SharePoint 2013
See also

Published: July 16, 2012

Summary: Explore these links to find out more about how to implement SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint 2013 is a collaboration environment that organizations of all sizes can use to increase the efficiency of business processes.

SharePoint 2013 sites provide secure environments that administrators can configure to provide personalized access to documents and other information. Search features enable users to find content efficiently regardless of the physical location of data.

Alert icon - exclamation point

Recently Published Content

See the following pages for new or updated content about SharePoint 2013:

  • Recently published content for SharePoint 2013

Building blocks

Documentation

The TechNet library contains articles that describe how to plan for, deploy, and use all the features of SharePoint 2013.

  • Recently published content for SharePoint 2013

  • Accessibility for SharePoint 2013

  • Downloadable content for SharePoint 2013

  • Technical diagrams for SharePoint 2013

  • Video demos and training for SharePoint 2013

  • Explore SharePoint 2013

  • Plan for SharePoint 2013

  • Develop for SharePoint 2013

  • Install and configure SharePoint 2013

  • Operations for SharePoint 2013

  • Use SharePoint 2013

  • Troubleshooting SharePoint 2013

  • Technical reference for SharePoint 2013

  • Solutions for the real world in SharePoint 2013

Related content:

  • SharePoint Online administration

  • Project Server 2013

  • Office 2013 Resource Kit

  • Office Web Apps (Installed on SharePoint 2013 Products)

  • Office 365 ProPlus

  • Duet Enterprise for Microsoft SharePoint and SAP

Legacy content:

  • Office 2010 Resource Kit

  • Office Web Apps (Installed on SharePoint 2010 Products)

  • Search Server 2010

  • FAST Search Server 2010 for SharePoint

  • Groove Server 2010

  • Project Server 2010

  • Duet Enterprise for Microsoft SharePoint and SAP

  • Microsoft Office SharePoint Server 2007

  • Microsoft Office SharePoint Portal Server 2003

House icon

TechNet TechCenter

Visit the following site to access videos, community sites, documentation, and more.

  • Microsoft SharePoint 2013

Getting started

Getting Started

TechNet documentation includes the following articles about the new features in SharePoint 2013:

  • Getting Started with SharePoint 2013 for IT Pros

Downloads

Downloads & Scripts

Access the following pages for both downloadable content and Windows PowerShell scripts:

  • Downloadable content for SharePoint 2013

  • Script Repository: Windows PowerShell for SharePoint 2013 Products

Chat icon

Blogs

Check out the latest posts from the SharePoint Products documentation teams.

  • To the SharePoint

  • Office 365 Technical Blog

People icon

Forums & Newsgroups

Got questions? Talk to your peers, MVPs, and the SharePoint product teams.

  • SharePoint 2013 for IT Professionals

Video (play button) icon

Videos

Watch subject matter experts and TechNet writers walk through tasks and dynamically explain SharePoint-related concepts.

  • Video demos and training for SharePoint 2013

Twitter

Stay Connected

Keep connected with the latest happenings with SharePoint 2013.

  • Follow us on Twitter

email

Provide Feedback

Provide feedback about the documentation for SharePoint 2013 depending on the TechNet view, as follows:

  • Lightweight View.Click Yes or No in the Did you find this helpful section at the bottom of the page. This delivers your feedback directly to the documentation team.

  • Classic View. Use the Click to Rate and Give Feedback link at the top of the article in the TechNet Library. This delivers your feedback directly to the documentation team.

  • Scriptfree View. Click the Feedback link at the top of the article in the TechNet Library. This enables you to provide feedback about the scriptfree view to a forum.

To suggest content or request more documentation (or report an error), please contact us at ITSPDOCS@microsoft.com.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support

See also

SharePoint Developer Center (MSDN)
SharePoint Server (Office)


Recently published content for SharePoint 2013

Updated: September 24, 2013

Summary: Find new and updated articles in the SharePoint 2013 TechNet library by release date.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Writers create new content and update published content regularly.

September 23, 2013 | September 16, 2013 | September 9, 2013 | September 2, 2013 | August 26, 2013 | August 19, 2013 | August 12, 2013 | August 5, 2013 | July 29, 2013 | July 22, 2013 | July 15, 2013 | July 8, 2013 | July 1, 2013 | June 24, 2013 | June 17, 2013 | June 10, 2013 | June 3, 2013 | May 27, 2013 | May 20, 2013 | May 13, 2013 | May 6, 2013 | April 29, 2013 | April 22, 2013 | April 15, 2013 | April 8, 2013 | April 1, 2013 | March 25, 2013 | March 18, 2013 | March 11, 2013 | March 5, 2013 | February 25, 2013 | February 18, 2013 | February 11, 2013 | February 4, 2013

Published the week of September 23, 2013

New

Blog: How to display values from custom managed properties in the hover panel in SharePoint Server 2013

Blog: How to add a custom action to the hover panel in SharePoint Server 2013

Updated article

Software boundaries and limits for SharePoint 2013 Updated the "SharePoint Apps limits" section with new guidance for Access app limits.

Published the week of September 16, 2013

New

Blogs:

  • How to create a new result type in SharePoint Server 2013

  • How to display values from custom managed properties in search results - option 1

  • How to display values from custom managed properties in search results - option 2

Published the week of September 9, 2013

New

Blogs: Understanding how search results are displayed in SharePoint Server 2013 and Understanding how item display templates and hit highlighting work in SharePoint Server 2013

Published the week of September 2, 2013

New article

Result types and display templates that are used to display search results in SharePoint Server 2013 Learn about the default result types and display templates that are used to display search results.

Blog post: New Storage and SQL Server capacity planning article for SharePoint Server 2013

Blog post: Updates to search ranking models in SharePoint Server 2013

Published the week of August 26, 2013

New article

Storage and SQL Server capacity planning and configuration (SharePoint Server 2013) Learn how to plan and configure the storage and database tier for SQL Server in SharePoint 2013.

Updated articles

Plan enterprise search architecture in SharePoint Server 2013 Corrected the illustration of the medium search farm and adjusted guidance on using physical or virtual servers.

Technical diagrams for SharePoint 2013, Hybrid for SharePoint Server 2013, Configure the hybrid environment infrastructure Added a link to the new model: Which hybrid topology should I use?

Published the week of August 19, 2013

Updated articles

Learn about upgrade for SharePoint 2013 Changed style of article to be more friendly and easy to read. Added graphics to anchor the sections.

Linguistic search features in SharePoint Server 2013 Corrected a linguistic feature name, from "people search" to "fuzzy name matching." Added more information about fuzzy name matching.

Rename the Search service application databases in SharePoint 2013 Updated procedures in the Move and rename the Search service application databases section.

Published the week of August 12, 2013

New blog post

New Test Lab Guide content for SharePoint 2013

Updated articles

Overview of search result ranking in SharePoint Server 2013 Updated to reflect changes to ranking models that were introduced in the SharePoint Server 2013 cumulative update package of August 2013.

Overview of the search schema in SharePoint Server 2013 Updated to reflect which search schema changes require content to be re-indexed.

Manage the search schema in SharePoint Server 2013 Updated to reflect which search schema changes require content to be re-indexed.

Published the week of August 5, 2013

Updated articles

Configure SAML-based claims authentication with AD FS in SharePoint 2013 Technical corrections and a new procedure to configure permissions based on email addresses.

Plan crawling and federation in SharePoint 2013, Configure and use the Exchange connector for SharePoint 2013 Deleted the statement of support for crawling Exchange 2013 public folders. Currently SharePoint 2013 only supports crawling Exchange 2007 public folders and Exchange 2010 public folders.

Learning roadmaps for SharePoint 2013 Added a link to the Learning Roadmaps overview video.

Published the week of July 29, 2013

New article

Plan for least-privileged administration in SharePoint 2013 Learn how to use least-privileged administration to configure and maintain a SharePoint 2013 farm and enhance security.

Published the week of July 22, 2013

New articles

Configure the crawler in case of SSL certificate warnings in SharePoint 2013 Specify whether a SharePoint 2013 crawler will crawl a site if there is a problem with the site's Secure Sockets Layer (SSL) certificate.

Plan enterprise search architecture in SharePoint Server 2013 Learn how to plan a small, medium or large enterprise search architecture.

Estimate performance and capacity requirements for divisional collaboration environments (SharePoint Server 2013) Use test results and recommendations to estimate performance and capacity requirements for a divisional collaboration environment for SharePoint Server 2013.

Blog: Changes to content deployment in SharePoint Server 2013

Updated articles

Overview of SkyDrive Pro in SharePoint Server 2013 Updated to include information about the stand-alone SkyDrive Pro Windows Sync client.

Change the default account for crawling in SharePoint 2013 Added instructions about how to change the user name of the default content access account.

Published the week of July 15, 2013

Updated article

Technical diagrams for SharePoint 2013 Added links to posters for "Authentication in SharePoint 2013" and "Social feature support in SharePoint Server 2013."

Published the week of July 8, 2013

New articles

Test Lab Guide: Configure a highly available SharePoint Server 2013 Search topology Learn how to configure search for high availability on a SharePoint 2013 farm.

Blog post: Integrating social media with public-facing websites in SharePoint 2013

Blog post: Integrating SharePoint, Exchange, and Lync for value-add solutions

Published the week of July 1, 2013

New articles

Plan for site maintenance and management in SharePoint 2013 Learn how to control SharePoint resource utilization through management of sites and site collections.

Integrate Yammer with on-premises SharePoint 2013 environments (white paper) Learn how to remove SharePoint 2013 social entry points in the user interface and install the Yammer app for SharePoint.

Blog: Stage 16: Add a Taxonomy Refinement Panel Web Part to a publishing site

Updated article

Host-named site collection architecture and deployment (SharePoint 2013) Updated with requirements for the root site collection.

Published the week of June 24, 2013

New blog posts

Stage 14: Configure refiners for faceted navigation

Stage 15: Add refiners for faceted navigation to a publishing site

Updated article

Move the Search service application databases in SharePoint 2013 Corrected the order of the first two procedures. You must pause the Search service application before you set the service application databases to read-only mode.

Published the week of June 17, 2013

New articles

Overview of site navigation in SharePoint 2013 Learn about the types of navigation controls that are available in SharePoint 2013.

Plan self-service site creation in SharePoint 2013 Learn the critical decisions that you need to make when preparing for Self Service Site creation and management.

Estimate performance and capacity requirements for social environments (SharePoint Server 2013) Learn how to determine the number and types of computers that you need for a capacity plan for a My Site and social computing portal based on SharePoint Server 2013.

Configure time-out values for crawler connections in SharePoint 2013 Change how long the SharePoint 2013 search crawler waits for a connection to a content repository or for a response to a connection attempt.

Updated articles

Plan crawling and federation in SharePoint 2013 Clarified the requirements for including file types and file content in the search index. The section covers both parsing by using built-in format handlers and parsing by using third-party format handlers.

Add or remove a file type from the search index in SharePoint Server 2013 Added steps for checking what file formats can be parsed, and for enabling or disabling parsing of a file format.

Default crawled file name extensions and parsed file types in SharePoint Server 2013 Clarified the requirements for parsing file formats.

New-SPEnterpriseSearchFileFormat Added information about when changes are effective.

Get-SPEnterpriseSearchFileFormat Added a description of the information the cmdlet returns.

Set-SPEnterpriseSearchFileFormatState Clarified that this cmdlet can be used only for file formats parsed using built-in format handlers.

Remove-SPEnterpriseSearchFileFormat Clarified that the cmdlet can only be used on formats parsed by a third-party format handler.

Published the week of June 10, 2013

New articles

Overview of My Sites in SharePoint Server 2013 Learn about the benefits and uses of My Sites in SharePoint Server 2013.

Plan for multilingual sites in SharePoint 2013 Learn how to plan for multilingual sites in SharePoint 2013 and SharePoint Online.

Plan for the multilingual user interface in SharePoint 2013 Learn about the multilingual user interface feature, how it works, and how to plan to use it in SharePoint 2013 and SharePoint Online.

Overview of themes in SharePoint 2013 Learn about the themes in SharePoint Server 2013 and how to use them to customize the look and feel of sites.

Benefits of Web Platform Consolidation (white paper) Using SharePoint Products as an example, this paper discusses the benefits of web platform consolidation for organizations of varying sizes.

Blog: NEW Test Lab Guide: Test Lab Guide: Configure eDiscovery for SharePoint Server 2013

Blog: Stage 13: Plan to use refiners for faceted navigation- Part II

Updated article

Upgrade-SPOSite Changed the "V2VUpgrade" parameter to "VersionUpgrade".

Published the week of June 3, 2013

New articles

Plan sites and site collections in SharePoint 2013 Learn the critical decisions that you need to make in your SharePoint 2013 site planning process.

Blog: Stage 11: Upload and apply display templates to the Content Search Web Part

Published the week of May 27, 2013

New articles

Business Intelligence Governance automation using Windows PowerShell Learn to automate requests for data access using Windows PowerShell, SharePoint lists, and workflows. Articles are:

  • Self-service data access using Windows PowerShell

  • Admin-approved data access using Windows PowerShell

  • Department-specific data access using Windows PowerShell

Understanding the Microsoft Cloud (white paper) Using SharePoint Products as an example, this paper discusses the kinds of cloud-based software and their benefits for organizations of varying sizes.

Blog: Stage 10: Configure the query in a Content Search Web Part on a catalog item page

Blog: Your friendly guide to host-named site collections

Published the week of May 20, 2013

New articles

Edit general settings on a web application in SharePoint 2013 Illustrates how to make changes to general settings for a SharePoint 2013 web application in Central Administration.

Understand and evaluate hosting options for SharePoint farms Learn about the options for hosting a SharePoint farm and the recommended criteria to evaluate and select a suitable option for your organization.

Plan for SkyDrive Pro in SharePoint Server 2013 Learn about performance, security, and other considerations for implementing SkyDrive Pro in SharePoint Server 2013.

Change the default account for crawling in SharePoint 2013 Change the password of the default content access account, which is the default account that the SharePoint 2013 Search service uses for crawling.

Branding issues that may occur when upgrading to SharePoint 2013 Learn how to address issues with branding, such as custom CSS, custom themes, and custom master pages, and custom page layouts in an upgraded site.

Blog: New permissions content for SharePoint 2013

Updated articles

Create a plan for current customizations during upgrade to SharePoint 2013 Added information about site templates.

Troubleshoot site collection upgrade issues in SharePoint 2013 Added items for branding issues in site collections.

Published the week of May 13, 2013

New articles

Host-named site collection architecture and deployment (SharePoint 2013) Learn how to plan and implement host-named site collections in SharePoint 2013 and how path-bases site collections might affect your environment.

Configure Exchange Autodiscover with a My Site Host URL in SharePoint Server 2013 Learn how to configure Exchange Autodiscover to find a user's SharePoint My Site URL.

Test Lab Guide: Configure eDiscovery for SharePoint Server 2013 Learn how to configure eDiscovery for SharePoint Server 2013 based on the Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm.

Test Lab Guide: Demonstrate permissions with SharePoint Server 2013 Learn how to configure and demonstrate SharePoint 2013 permissions based on the Test Lab Guide: Configure Intranet and Team Sites for SharePoint Server 2013.

Updated articles

Downloadable content for SharePoint 2013 Added new downloadable content: "Test Lab Guide: eBook for SharePoint Server 2013 Intranet and Team Sites."

Configure and use the Documentum connector in SharePoint Server 2013 Updated the supported DFS Productivity Layer version and improved the instructions to set up the Security Trimming Sync Service.

Manage continuous crawls in SharePoint Server 2013 Updated with a procedure that describes how to change the continuous crawl interval.

Plan crawling and federation in SharePoint 2013 Added a section describing the reasons to do a full crawl and added more information about content sources for line-of-business data.

Database types and descriptions (SharePoint 2013) Updated the "Managed Metadata Service service application database" section to show that the Managed Metadata Service application database stores the Taxonomy service application metadata.

Published the week of May 6, 2013

New articles

Language packs in SharePoint Server 2013 Learn about the language packs available for SharePoint 2013.

Profile schema reference in SharePoint 2013 Understand the XML schema for profiles for use in scripted monitoring configuration.

Customize search result types in SharePoint 2013 Create and configure custom search result types in SharePoint 2013 so that users can readily distinguish and preview different kinds of items in a list of search results.

Scripted monitoring configuration in SharePoint 2013 Read articles about scripted monitoring configuration for SharePoint 2013 to apply monitoring settings across an entire environment.

Overview of scripted monitoring configuration in SharePoint 2013 Learn how to use Windows PowerShell and XML to automate the configuration of monitoring settings.

Run scripted monitoring configuration in SharePoint 2013 Learn how to use Windows PowerShell scripts and Profile files to automatically back up, restore, or change monitoring settings in a SharePoint 2013 environment.

Permissions for SharePoint 2013 learning roadmap Use this learning roadmap to build expertise in permissions and permissions management in SharePoint 2013.

Test Lab Guide: Demonstrate profile synchronization for SharePoint Server 2013 Learn how to configure and demonstrate user profile synchronization based on "Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm."

Conformance statement AA-level for SharePoint Server 2013 Conformance statement AA-level for SharePoint Server 2013 in regards to Web Content Accessibility Guidelines 2.0 (http://www.w3.org/TR/WCAG20/).

Conformance statement A-level for SharePoint Server 2013 Conformance statement A-level for SharePoint Server 2013 in regards to Web Content Accessibility Guidelines 2.0 (http://www.w3.org/TR/WCAG20/).

Blog: Stage 9: Configure the query in a Content Search Web Part on a category page

Updated articles

Copy databases to the new farm for upgrade to SharePoint 2013 Added a note to make sure that the appropriate patch levels are applied to the SharePoint 2010 farm before you perform an upgrade to SharePoint 2013.

Configure trust for search between two SharePoint Server 2013 farms Corrected the file path of the metadata endpoint in two of the cmdlets in the Windows PowerShell code.

Published the week of April 29, 2013

New articles

Update Workflow in SharePoint Server 2013 Walks through the steps required to keep workflow up to date in SharePoint Server 2013.

Video series: Install and configure Workflow in SharePoint Server 2013 Videos that demonstrate the installation and configuration of workflow in SharePoint Server 2013.

Best practices for using fine-grained permissions in SharePoint Server 2013 Learn about best practices for fine-grained permissions and how to use them within your organization when you use SharePoint 2013.

Fine-grained permission reference for SharePoint Server 2013 Learn about the potential impact of fine-grained permissions on performance and the complexity of maintaining a SharePoint 2013 environment.

Troubleshoot common fine-grained permissions issues for SharePoint Server 2013 Learn about how to troubleshoot issues that include fine-grained permission in SharePoint 2013.

Database management for SharePoint 2013 learning roadmap Use this learning roadmap to build expertise about database management in SharePoint 2013.

Blog: Get your head in the cloud: Hybrid for SharePoint Server 2013/Office 365

Updated articles

Configure an environment for apps for SharePoint (SharePoint 2013) Added an additional step to perform if the App prefix is being changed.

Test Lab Guide: Configure intranet and team sites for SharePoint Server 2013 Added the test lab guide overview video.

Test Lab Guide: Demonstrate SAML-based Claims Authentication with SharePoint Server 2013 Added the test lab guide overview video.

Install and configure workflow for SharePoint Server 2013 Added information about the six-part video series that walks through the process of installing and configuring workflow in SharePoint Server 2013.

Published the week of April 22, 2013

New articles

Change administration-account passwords in SharePoint 2013 Learn about how to keep account passwords synchronized for sites and site content for SharePoint 2013.

Configure custom permissions in SharePoint 2013 Learn how to configure custom permissions in SharePoint 2013.

Security and permissions (SharePoint 2013) Learn about how to manage security, permissions, and accounts for SharePoint 2013.

Change passwords for SQL Server services (SharePoint Server 2013) Learn how to change passwords for the SQL Server services and SQL Server Agent service accounts by using SQL Server Configuration Manager.

Share workbooks by using Excel Services (SharePoint Server 2013) Excel Services enables you to share Excel content with other people using SharePoint Server. You can share an entire workbook, or choose to display only part of a workbook.

Blog: New SharePoint 2013 authentication process and Test Lab Guide overview videos

Blog: Refresh of SharePoint Server 2013 IT Pro training now available

Blog: Stage 8: Assign a category page and a catalog item page to a term

Updated articles

Supported high availability and disaster recovery options for SharePoint databases (SharePoint 2013) Added information about support for using SQL Server AlwaysOn asynchronous commit as a disaster recovery option for the Search service application databases.

Test Lab Guide: Configure intranet and team sites for SharePoint Server 2013 Updated for simplification and for a reduction of overlap with the Test Lab Guide: Demonstrate Social Features for SharePoint Server 2013.

Configure Forefront TMG for a hybrid environment Minor revisions to the general reverse proxy requirements.

Software boundaries and limits for SharePoint 2013 Updated the web application limits table with specific limits for both path-based and host-named site collections.

BI capabilities in Excel and Excel Services (SharePoint Server 2013) Removed sections about Office 365 and SkyDrive and put them in the article "Business intelligence capabilities in Excel and SharePoint Online".

Published the week of April 15, 2013

New articles

Performance and capacity test results and recommendations (SharePoint Server 2013) Learn about performance characteristics of features in SharePoint Server 2013.

Estimate capacity and performance for compliance and eDiscovery for SharePoint Server 2013 Learn about how compliance, eDiscovery, and large-scale document repositories can effect capacity and performance in SharePoint Server 2013.

Estimate capacity and performance for video content management in SharePoint Server 2013 Learn guidelines for how to plan video content types and video player pages using the Rich Media Web Part to provide better user experiences when you play videos in SharePoint Server 2013.

Overview of search result ranking in SharePoint Server 2013 Learn how SharePoint 2013 uses ranking models to calculate the relevance rank of search results and how you can influence the order of search results by using query rules, the search schema and ranking models.

Configure synchronization on all document libraries in SharePoint Server 2013 Learn how to add or remove synchronization from all document libraries in SharePoint Server 2013.

Blog post: Upload page layouts and create new pages in a publishing site

Published the week of April 8, 2013

New articles

Web applications management in SharePoint Server 2013 Summary: Learn how to create and manage web applications in a SharePoint Server 2013 farm.

How to upgrade an environment that uses content type syndication (SharePoint Server 2013) Upgrade the Managed Metadata service application and site collections that use content type syndication and share the service applications to the old farm.

Estimate capacity and performance for Managed Metadata Service (SharePoint Server 2013) Learn how to plan to deploy a Managed Metadata Service application for SharePoint Server 2013 by using tested capacity and performance data.

Estimate capacity and performance for Web Content Management (SharePoint Server 2013) Learn how to determine the number and types of computers that you need to publish content and manage web content in SharePoint Server 2013.

Configure the hybrid environment infrastructure Learn how to configure the basic infrastructure for SharePoint 2013 hybrid environments.

Configure the hybrid identity management infrastructure Learn how to configure the identity management infrastructure for SharePoint 2013 hybrid environments.

Configure hybrid search for SharePoint Server 2013 Configure search in a hybrid SharePoint environment so that users can get search results in SharePoint Server 2013 or in SharePoint Online from the SharePoint Server 2013 and SharePoint Online search indexes. Related new articles are: Display hybrid search results in SharePoint Online and Display hybrid search results in SharePoint Server 2013.

Configure Forefront TMG for a hybrid environment Learn about the general principles and requirements for reverse proxy devices in a SharePoint 2013 hybrid environment, and how to configure Forefront TMG as a reverse proxy device.

Configure hybrid Duet Enterprise Online for SharePoint Server 2013 Provides a roadmap to understanding and deploying Duet Enterprise Online.

Deploy a Business Connectivity Services hybrid solution in SharePoint 2013 How to configure the Business Connectivity Services (BCS) hybrid scenario to access on-premises data through SharePoint Online. This article is a roadmap that points to several other articles that describe the complete process.

Cache settings operations in SharePoint Server 2013 Learn about the available caches and the settings that can be configured for the BLOB cache, cache profiles and object cache settings.

Configure cache settings for a web application in SharePoint Server 2013 Learn how to configure the BLOB cache, page output cache profiles, and the object cache for a web application.

Configure object cache user accounts in SharePoint Server 2013 Learn how to configure the Portal Super User and Portal Super Reader accounts that are used by the object cache in SharePoint Server 2013.

Flush the BLOB cache in SharePoint Server 2013 Learn how to clear the contents of the BLOB cache for a web application.

Plan for caching and performance in SharePoint Server 2013 Learn about the BLOB cache, Bit Rate Throttling, and other SharePoint features that can improve browser performance.

(Blog post) Stage 6: Upload and apply a new master page to a publishing site Covers how to upload and apply an already finalized master page file and other design files.

Updated articles

Configure SQL Server 2012 AlwaysOn Availability Groups for SharePoint 2013 Removed information about configuring Named Pipes for SQL Server because it is not required. In addition, provided the correct information for configuring the database connection point when you are installing SharePoint Server.

Hardware and software requirements for SharePoint 2013 Added a statement of support for stretched farms for SharePoint 2013.

Best practices for upgrading to SharePoint 2013 Added a note to make sure that the appropriate patch levels are applied to the SharePoint 2010 farm before you perform an upgrade to SharePoint 2013.

Copy databases to the new farm for upgrade to SharePoint 2013 Added a note to make sure that the appropriate patch levels are applied to the SharePoint 2010 farm before you perform an upgrade to SharePoint 2013.

Configure Business Connectivity Services solutions for SharePoint 2013 Added a new section: "Deploy a Business Connectivity Services hybrid solution in SharePoint 2013."

Published the week of April 1, 2013

New articles

Estimate performance and capacity requirements for enterprise intranet collaboration environments (SharePoint Server 2013) Use test results and recommendations in this article to estimate performance and capacity requirements for an enterprise intranet collaboration solution for SharePoint Server 2013.

Plan automatic password change in SharePoint 2013 Learn about the automatic password changes and how to deploy them in SharePoint 2013.

Configure automatic password change in SharePoint 2013 Learn about how to configure the automatic password changes in SharePoint 2013.

Published the week of March 25, 2013

New articles

Overview of managed navigation in SharePoint Server 2013 Summary: Learn about managed navigation and navigation term sets for SharePoint Server publishing sites.

Plan navigation term sets in SharePoint Server 2013 Summary: Learn how to create the navigation term set to provide site navigation for SharePoint Server publishing sites.

Overview of security trimming, administrative policies, and privacy settings for social feeds in SharePoint Server 2013 Summary: Learn about how security trimming, administrative policies, and user privacy settings affect feeds in SharePoint Server 2013.

Overview of SkyDrive Pro in SharePoint Server 2013 Summary: Learn about SkyDrive Pro, its architecture, and the benefits of using SkyDrive Pro in SharePoint Server 2013.

New-SPWebApplicationAppDomain Creates or changes a AppDomain entry.

Get-SPWebApplicationAppDomain Returns all app domains for a specific web application.

Remove-SPWebApplicationAppDomain Deletes the AppDomain.

Updated article

Configure server-to-server authentication between SharePoint 2013 farms Added procedures for a server without a web application and using HTTP rather than HTTPS.

Published the week of March 18, 2013

New articles

Search-first migration from FAST Search Server for SharePoint 2010 to SharePoint Server 2013 Describes how to perform a search-first migration from Microsoft FAST Search Server 2010 for SharePoint to SharePoint Server 2013.

Blog post: How to install update packages on a SharePoint farm where search component and high availability search topologies are enabled Provides information on how to install the March Public Update (PU) for SharePoint Server 2013 and SharePoint Foundation 2013 where search components and high availability search topologies are enabled.

Blog post: Microsoft BI Solution Builder: Business Intelligence tools and capabilities are available The BI Solution Builder is quick and easy to use, and it can help you put your BI environment to work in short order.

Updated article

Plan service deployment in SharePoint 2013 Added the "Services on server for streamlined topologies" table.

Published the week of March 11, 2013

New articles

Understanding result sources for search in SharePoint Server 2013 Use a result source in SharePoint Server 2013 to specify a provider to get search results from, and optionally to narrow a search to a subset of those results.

Enable apps in AAM or host-header environments for SharePoint 2013 Learn how to enable app domains for alternate access mappings or host-header web application environments after installing the March 2013 Public Update.

User profiles for SharePoint Server 2013 learning roadmap Use this learning roadmap to gain expertise about user profiles and associated technologies in SharePoint Server 2013.

Configure and use the Documentum connector in SharePoint Server 2013 Describes how to install and configure the Microsoft SharePoint 2013 Indexing Connector for Documentum.

Overview of SQL Server in a SharePoint environment (SharePoint 2013) Learn about the SharePoint Server 2013 relationship with SQL Server 2008 R2 with Service Pack 1 (SP1) and SQL Server 2012 and how you can interact with the databases.

Updated articles

Use Windows PowerShell to update alerts in SharePoint 2013 Learn to use Invoke-AlertFixup to update the e-mail alerts associated with a URL.

Published the week of March 4, 2013

New articles

Create a high availability architecture and strategy for SharePoint 2013 Describes how to combine farm architecture and technology to create a highly available environment in a single SharePoint 2013 farm.

Blog: Stage 3: How to enable a list as a catalog New post in a series that describes how you can use SharePoint 2013 to set up a website that is based on product catalog data.

Updated articles

Software boundaries and limits for SharePoint 2013 Revised limits for maximum file size and security scopes.

Install and configure workflow for SharePoint Server 2013 Added information about least-privilege configuration.

Published the week of February 25, 2013

New articles

Refreshing Excel workbooks with embedded PowerPivot models from SharePoint Online (white paper) Download this white paper to learn how to perform scheduled data refresh of workbooks that contain PowerPivot models published to SharePoint Online.

Configure server-to-server authentication between publishing and consuming farms Learn how to configure server-to-server authentication when you share service applications across SharePoint 2013 publishing and consuming farms.

Blog posts: An introduction to cross-site publishing, Stage 1: Create site collections for cross-site publishing, Stage 2: Import list content into the Product Catalog Site Collection Posts in a series that describes how you can use SharePoint 2013 to set up a website that is based on product catalog data.

Updated articles

Configure an environment for apps for SharePoint (SharePoint 2013) Updated information about the account used to set up the Subscription Settings and the App Management service applications from the farm account to a managed account. The farm account is not recommended.

Getting started with SharePoint Server 2013 workflow Added a video overview of workflow in SharePoint Server 2013.

Published the week of February 18, 2013

New articles

Virtualize SharePoint 2013 learning roadmap Use this learning roadmap to build expertise about how to install and configure SharePoint 2013 in a Microsoft virtual environment.

Backup and restore best practices in SharePoint 2013 Learn how to implement best practices before you back up and restore a SharePoint 2013 farm.

View and explore data in a dashboard Watch this video to learn how to explore data in an Excel Services dashboard using a Windows 8 tablet.

Overview of Excel Services reports displayed in PerformancePoint Web Parts Learn about how to display Excel Services reports in Dashboard Designer.

Overview of PerformancePoint analytic charts and grids Learn about analytic charts and grids in Dashboard Designer.

Overview of PerformancePoint KPI Details reports Learn about PerformancePoint KPI Details reports.

Overview of PerformancePoint reports and scorecards Learn about reports and scorecards within PerformancePoint Services Dashboard Designer.

Overview of PerformancePoint scorecards Learn about PerformancePoint scorecards.

Overview of Reporting Services reports displayed in PerformancePoint Web Parts Learn about how to include Reporting Services reports in a PerformancePoint web part.

Overview of the PerformancePoint Decomposition Tree Learn about PerformancePoint decomposition trees.

Overview of Web Page reports in Dashboard Designer Learn about web page reports in Dashboard Designer.

How to build a social media-sharing site in SharePoint 2013 (white paper) Learn how to build a social media-sharing site in SharePoint 2013.

Fundamental site planning in SharePoint 2013 View links to resources about site planning concepts such as how to structure sites and how to plan site navigation in SharePoint 2013.

Overview of sites and site collections in SharePoint 2013 Learn about site collections, sites, and site templates in SharePoint 2013.

Blog post: How to set up a product-centric website in SharePoint 2013 First in a series of posts that describes how you can use SharePoint 2013 to set up a website that is based on product catalog data.

Blog post: Get the new Office Visio stencil with the cool icons

Updated articles

Manage Feed Cache and Last Modified Time Cache repopulation in SharePoint Server 2013 Added new section: "Feed Cache settings on the User Profile Service application."

Manage the Distributed Cache service in SharePoint Server 2013 Added an optional step to reconfigure the memory allocation of the Distributed Cache service, added a note about Inbound ICMP (ICMPv4) traffic, and added a new section: "Repair a cache host."

Plan for feeds and the Distributed Cache service in SharePoint Server 2013 Added two new sections: "Capacity planning for the Distributed Cache service" and "Firewall configuration considerations."

Published the week of February 11, 2013

New articles

Display template reference in SharePoint Server 2013 Learn about the different display templates that are available in SharePoint 2013.

Deploy software updates for SharePoint 2013 Learn how to prepare for, download, install, and then configure software updates and patches for SharePoint 2013.

Install a software update (SharePoint 2013) Learn to install a software update on servers in a SharePoint 2013 farm.

Prepare to deploy software updates for SharePoint 2013 Describes the required and recommended tasks to complete before you install software updates on servers in a SharePoint 2013 farm.

Software updates overview for SharePoint 2013 Learn how to deploy a software update to a SharePoint 2013 farm.

Updated articles

Upgrade a site collection to SharePoint 2013 Added conceptual video to illustrate steps in upgrade.

Configure result sources for search in SharePoint Server 2013 and Configure result sources for web content management in SharePoint Server 2013 Added a statement that the Exchange protocol provides results only from Exchange Server 2013 content, and only from a SharePoint 2013 eDiscovery Center.

Published the week of February 4, 2013

New articles

Monitoring scenarios in SharePoint 2013 Learn about monitoring scenarios in SharePoint 2013 and tools that help to maintain a reliable environment.

Monitor farms in SharePoint 2013 Learn what to monitor in a SharePoint farm, how to monitor SharePoint 2013 farms, and how to monitor multiple farms.

Monitor servers in SharePoint 2013 Learn how to monitor SharePoint servers, including database servers, application servers, and web servers, by using logs, SharePoint Health Analyzer rules, and System Center 2012 - Operations Manager.

Monitor sites and site collections in SharePoint 2013 Learn how to monitor SharePoint 2013 sites and site collections to maintain sites that run as expected.

Learning roadmaps for SharePoint 2013 Use these learning roadmaps to build expertise in SharePoint 2013 concepts.

Authentication in SharePoint 2013 learning roadmap Use this learning roadmap to build expertise in the authentication technologies in SharePoint 2013.

Windows PowerShell for SharePoint 2013 learning roadmap Use this learning roadmap to build expertise about Windows PowerShell for SharePoint 2013.

Learn about upgrade for SharePoint 2013 Use this learning roadmap to build expertise about upgrade for SharePoint 2013.

Upgrade overview videos for SharePoint 2013 View this series of short overview videos to understand how upgrade works for SharePoint 2013.

Global architectures for SharePoint Server 2013 Learn about supported architectures for SharePoint 2013 in WAN environments, strategies for optimizing performance over WAN connections, and recommendations for service applications.

Use EffectiveUserName in PerformancePoint Services (SharePoint Server 2013) Learn how to use the EffectiveUserName option when it connects to Analysis Services data from PerformancePoint Services Dashboard Designer.

Use EffectiveUserName with Excel Services (SharePoint Server 2013) Walks through a scenario that demonstrates how to use the Analysis Services EffectiveUserName property with Excel Services.

Understanding SharePoint 2013 Workflow Backup Learn about workflow backups in SharePoint Server 2013.

Deploy a Business Connectivity Services cloud-only solution in SharePoint 2013 Learn how to configure Business Connectivity Services in SharePoint Online to access Windows Azure SQL Database.

Updated article

Hardware and software requirements for SharePoint 2013 Updated the table in "Hardware requirements—web servers, application servers, and single server installations" with new requirements based on performance and capacity testing and recommendations. Added definitions for small, medium, and large deployments. Clarified the support statement for optional software.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support

Change History

Date | Description
September 24, 2013 | Two new blog posts and one updated article
September 17, 2013 | Three new blog posts
September 03, 2013 | Two new blog posts.
August 27, 2013 | New and updated articles for the week of August 26.
August 20, 2013 | Updated articles for the week of August 19.
August 13, 2013 | Updated articles for the week of August 12.
August 06, 2013 | Updated articles for the week of August 5.
July 23, 2013 | New and updated articles for the week of July 22.
July 16, 2013 | One updated article for the week of July 15.
July 09, 2013 | One new article and two blog posts for the week of July 8.
July 16, 2012 | Initial publication


Accessibility for SharePoint 2013
See also

Summary: SharePoint 2013 supports the accessibility features of common browsers to help IT Pros administer deployments and access sites.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 | SharePoint Server 2013 Enterprise

Administrators and other users who have administrative responsibilities typically use the SharePoint 2013 Central Administration web site and the SharePoint 2013 Management Shell to manage deployments. A mouse and keyboard are the typical devices that administrators use to interact with Central Administration.

Because SharePoint 2013 run as web sites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 support the accessibility features of supported browsers. For more information, see Plan browser support in SharePoint 2013.

Users who don't use a mouse can use a keyboard to navigate the user interface and complete actions. The ability to use the keyboard in this way is a result of support for keyboard interactions that a browser provides. For more information, see Accessibility features in SharePoint 2013 and Keyboard shortcuts.

Users who have devices that support touch can also use gestures to complete operations. For more information, see the "Touch Gestures" and "Touch Interactions" sections of the Touch article on MSDN Online and the Office Touch Guide on Office.com.

SharePoint 2013 Central Administration web site

Administrators browse to the SharePoint Central Administration website to complete many administrative operations on a single farm.

To browse to the SharePoint Central Administration website in Windows Server 2008 R2

  1. On the Start menu, click All Programs.

  2. Click Microsoft SharePoint 2013 Products.

  3. Click SharePoint 2013 Central Administration.

To browse to the SharePoint Central Administration website in Windows Server 2012

  1. On the Start screen, click SharePoint 2013 Central Administration.

    If SharePoint 2013 Central Administration is not on the Start screen, complete the following steps:

    1. Right-click Computer.

    2. Click All apps.

    3. Click SharePoint 2013 Central Administration.

    Note:

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012 (http://technet.microsoft.com/en-us/library/hh831491.aspx).

SharePoint 2013 Management Shell

Administrators can also use the SharePoint 2013 Management Shell to execute Windows PowerShell cmdlets to manage SharePoint deployments. For more information, see Use Windows PowerShell to administer SharePoint 2013.

To start the SharePoint 2013 Management Shell in Windows Server 2008 R2

  1. On the Start menu, click All Programs.

  2. Click Microsoft SharePoint 2013 Products.

  3. Click SharePoint 2013 Management Shell.

To start the SharePoint 2013 Management Shell in Windows Server 2012

  1. On the Start screen, click Microsoft SharePoint 2013 Products.

  2. Click SharePoint 2013 Management Shell.

    If SharePoint 2013 Management Shell is not on the Start screen, complete the following steps:

    1. Right-click Computer.

    2. Click All apps.

    3. Click SharePoint 2013 Management Shell.

    Note:

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012 (http://technet.microsoft.com/en-us/library/hh831491.aspx).

SharePoint Online Management Shell

Administrators can also use the SharePoint Online Management Shell to execute Windows PowerShell cmdlets to manage SharePoint Online deployments. For more information, see Set up the SharePoint Online Management Shell environment.

To start the SharePoint Online Management Shell in Windows Server 2008 R2

  1. On the Start menu, choose All Programs.

  2. Select SharePoint Online Management Shell.

To start the SharePoint Online Management Shell in Windows Server 2012

  1. On the Start screen, click SharePoint Online Management Shell.

    If SharePoint Online Management Shell is not on the Start screen, complete the following steps:

    1. Right-click Computer.

    2. Click All apps.

    3. Click SharePoint Online Management Shell.

Accessibility features in supported browsers

The following table includes links to resources that explain the accessibility features that typical browsers support.

Browser | Documentation
Internet Explorer | Accessibility in Internet Explorer 9 Language Support and Accessibility Features
Firefox | Firefox Help
Safari | Safari Accessibility
Chrome | Chrome Accessibility Technical Documentation

See also

Microsoft Accessibility Resource Center


Downloadable content for SharePoint 2013

Updated: May 14, 2013

Summary: You can download content in the SharePoint 2013 TechNet library for offline viewing.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Download the following content for information about how to plan for, install, and manage SharePoint 2013.

 | Content | Description
Downloads | Technical library in compiled Help format | View the entire technical library for SharePoint 2013 in a compiled Help (CHM) version.
Stack of books | Downloadable eBook: Deployment guide for SharePoint 2013 | Download or print content about how to deploy SharePoint 2013. Available in several file formats.
Stack of books | Downloadable eBook: Explore SharePoint 2013 | Download or print content about what's new in SharePoint 2013. Available in several file formats.
What's new icon (stem) | IT Professional Reviewer's Guide for SharePoint Server 2013 | Learn how new capabilities in SharePoint Server 2013 can help IT pros better manage cost, risk, and time.
Lab icon | Test lab guides for SharePoint Server 2013 | Create your own test lab environment to demonstrate SharePoint 2013 features and scenarios.
Stack of books | Test Lab Guide: eBook for SharePoint Server 2013 Intranet and Team Sites | Download this free ebook to learn how to create a test lab containing intranet and team sites in a SharePoint Server 2013 three-tier farm.
Architecture icon | Technical diagrams for SharePoint 2013 | See architecture choices at a glance in these large-format diagrams.
Checklist icon | Planning worksheets for SharePoint 2013 | Record planning decisions for later references with these spreadsheet templates.

Build and download your own book

You can build your own custom download of TechNet topics from across the network. Click Print Multiple Topics in the upper right corner of the screen to begin.

Screen shot of Print Multiple Topics command

If you don't see Print Multiple Topics, see the blog post Export your own TechNet book for information about the view settings to use.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support

Change History

Date | Description
May 14, 2013 | Added new downloadable content: "Test Lab Guide: eBook for SharePoint Server 2013 Intranet and Team Sites."
July 16, 2012 | Initial publication


Technical diagrams for SharePoint 2013

Updated: August 27, 2013

Summary: These diagrams provide visual representations of recommended solutions for SharePoint 2013 in the form of models, which are poster-size documents.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

These resources are available in Visio (.vsd) format (Visio 2010 or Visio 2013) and PDF format. For information about how to print documents, see Tips for printing posters.

You might need additional software to view these files. See the following table for more information.

File type | Software
.vsd | Visio 2010, Visio 2013, or the free Visio viewer If you use the Visio viewer, right-click the VSD link, click Save Target As, save the file to your computer, and then open the file from your computer.
.pdf | Any PDF viewer, such as Adobe Reader

Models

Models are 34-by-44-inch posters that detail a specific technical area. These models are intended to be used with corresponding articles on TechNet. These models are created by using Visio 2010. You can modify the Visio files to illustrate how you plan to incorporate SharePoint 2013 in your own environment.

Architecture

Authentication

Design samples

Upgrade

Search

Apps

Backup and recovery

Databases

Design a SharePoint site

Architecture

Title Description

Microsoft SharePoint 2013 Platform Options

Thumbnail of SharePoint 2013 Platform Options

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

For BDMs and architects, this model describes the platform options for SharePoint 2013 — SharePoint in Office 365, on-premises hybrid with Office 365, Windows Azure, and on-premises only deployments. It includes an overview of each architecture, recommendations, license requirements, and lists of architect and IT Pro tasks for each platform. Several SharePoint solutions on Windows Azure are highlighted.

Microsoft SharePoint Server 2013 architecture

Microsoft SharePoint Server 2013 architecture mode

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Provides an overview of architecture concepts for SharePoint Server 2013.

Streamlined Topologies for SharePoint 2013

Thumnail image for the streamlined topologies mode

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

This model describes a streamlined approach for building topologies. The distribution of components is intended to maximize system resources of server hardware. Streamlined architectures include Front-end servers, batch-processing servers, and database servers.

Use this model with the following resources:

  • Plan service deployment in SharePoint 2013

  • Services on Server Install Worksheet for Streamlined Topologies

Traditional Topologies for SharePoint 2013

Topology model for SharPoint 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

This model provides an overview of topology concepts. Example topologies are based on traditional approaches to building SharePoint architectures with Web servers, application servers, and database servers.

Use this model with the following resources:

  • Plan service deployment in SharePoint 2013

  • Services on Server Install Worksheet for Traditional Topologies

Enterprise-scale farms for SharePoint Server 2013

Enterprise-scale farms for SharePoint Server 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Illustrates an enterprise-scale farm and provides guidance for patching and updating farms of this size.

Services in SharePoint Server 2013

Services for SharePoint Server 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Describes and illustrates the services architecture, including common ways to deploy services in your overall solution design.

Plan and use the Distributed Cache service in SharePoint Server 2013

Model: Plan the Distributed Cache service

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Describes and illustrates the planning process, installation steps, and configuration tasks required to perform and implement the Distributed Cache service in a SharePoint 2013 farm. Use this model with the articles Plan for feeds and the Distributed Cache service in SharePoint Server 2013 and Manage the Distributed Cache service in SharePoint Server 2013.

Mobile architecture in SharePoint 2013

Model: Mobile Architecture in SharePoint 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Provides an end-to-end understanding of the SharePoint 2013 mobile ecosystem. Use this model with the articles in Plan for mobile devices in SharePoint 2013.

Multi-farm architectures with SharePoint Server 2013

Multi-farm architectures with SharePoint 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Provides an overview of concepts related to deploying more than one farm with SharePoint 2013 and illustrates supported architectures.

Global solutions for SharePoint 2013

Global Solutions for SharePoint 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Provides an overview of concepts related to deploying SharePoint 2013 in WAN environments. Summarizes WAN performance data and optimizations. Illustrates supported architectures for deploying Microsoft SharePoint 2010 Products geographically.

Business Connectivity Services Hybrid Flow in SharePoint 2013

BCS Hybrid Flow Model

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Illustrates the Business Connectivity Services (BCS) hybrid flow in SharePoint 2013.

Social feature support in SharePoint Server 2013

Click to visit the download page for the SharePoint 2013 On-Premises Social poster

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Discusses the different deployment architectures for SharePoint Server 2013 and the effect those deployment architectures have on the social features.

Which hybrid topology should I use? For SharePoint Server 2013 with Office 365

Thumbnail picture of Hybrid Topologies model

Visio version

PDF version

Helps you decide which hybrid topology is appropriate for your environment.

Authentication

Title | Description
Authentication in SharePoint 2013 Illustration of the three types of authentication in SharePoint 2013: user authentication, app authentication, and server-to-server authentication. Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version | Describes the three types of authentication in SharePoint 2013. Use this model with the articles in Plan authentication in SharePoint 2013. Watch the Authentication in SharePoint 2013 overview video Video (play button) icon

Design samples

Title Description

Corporate Portal with Host-named Sites for SharePoint Server 2013

Corporate portal host-named sites SharePoint 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Corporate Portal with Path-based Sites for SharePoint Server 2013

Corporate Portal Path-based Sites SharePoint 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Illustrates a typical corporate deployment, with the most common types of sites represented. The two samples differ in the type of site collections that are implemented — path-based site collections or host-named site collections.

Use these design samples with the following article: SharePoint 2013 design samples: Corporate portal and extranet sites

Extranet with Dedicated Zones for Authentication

Thumbnail of design sample

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Illustrates a logical architecture for an extranet site in which multiple zones are implemented for authenticating users based on the authentication type.

Use this design sample with the following article: SharePoint 2013 design samples: Corporate portal and extranet sites

Upgrade

Title | Description
SharePoint 2013 Upgrade Process Upgrade process model SharePoint 2013 Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version | Describes the steps in the process for a database-attach upgrade. Use this model with the article Overview of the upgrade process to SharePoint 2013 and the articles in Plan for upgrade to SharePoint 2013.
SharePoint 2013: How to Test Upgrade Testing model for SharePoint 2013 Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version | See a visual display of information about how to test the upgrade process. Use this model with the article Use a trial upgrade to SharePoint 2013 to find potential issues and the articles in Test and troubleshoot an upgrade to SharePoint 2013.

Search

Title | Description
SharePoint Server 2013 Search Search model for SharePoint 2013 Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version | This design sample shows the logical architecture and interaction of search components, and an example of a fault-tolerant server farm that provides enterprise search for a content corpus that contains approximately 40 million items.
Enterprise Search Architectures for SharePoint Server 2013 Enterprise search model for SharePoint 2013 Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version | This design sample illustrates small, medium, and large-size farm architectures for enterprise search. It contains search and farm topology examples, scaling guidance, and hardware requirements.
Internet Sites Search Architectures for SharePoint Server 2013 Internet sites search model for SharePoint 2013 Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version | This design sample provides guidance on the hardware requirements and performance considerations for Internet Sites search topologies. In addition, the model contains an example medium-sized Internet Sites farm.

Apps

Title | Description
SharePoint 2013: App Overview for IT Pro Model of overview of apps for SharePoint Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version | Model poster describing apps from an IT Pro perspective. Use this model with the articles in Install and manage apps for SharePoint 2013.

Backup and recovery

Title | Description
Back up and restore: SharePoint Server 2013 Backup and restore model for SharePoint 2013 Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version | A visual display of the backup and restore tools, scenarios and tasks available for SharePoint 2013 Preview. Use this model with the articles in Restore (SharePoint 2013) and the article Move all databases in SharePoint 2013.

Databases

Title | Description
Databases that support SharePoint 2013 Database model for SharePoint 2013 Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version | A visual display with details for all databases that support SharePoint 2013 and SQL Server.

Design a SharePoint site

Title | Description
Design and branding in SharePoint 2013 Design and branding in SharePoint 2013 - Model PDF version (light background) PDF version (dark background) | A visual display of the process that you use for designing and branding a publishing site in SharePoint 2013. Use this model with the articles in What's new with SharePoint 2013 site development and SharePoint page model overview in the MSDN Library.

Tips for printing posters

If you have a plotter, you can print these posters in their full size. If you don't have plotter, use the following steps to print on smaller paper.

Print posters on smaller paper

  1. Open the poster in Visio.

  2. On the File menu, click Page Setup.

  3. On the Print Setup tab, in the Printer paper section, select the size of paper you want to print on.

  4. On the Print Setup tab, in the Print zoom section, click Fit to, and then enter 1 sheet across by 1 sheet down.

  5. On the Page Size tab, click Size to fit drawing contents, and then click OK.

  6. On the File menu, click Print.

Change History

Date | Description
August 27, 2013 | Added a link to a new model: Which hybrid topology should I use?
July 16, 2013 | Added links to posters for "Authentication in SharePoint 2013" and "Social feature support in SharePoint Server 2013."
July 16, 2012 | Initial publication


Video demos and training for SharePoint 2013

Updated: May 21, 2013

Summary: Use videos to help you plan, install, configure, and manage SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Demos

Getting started

Video (play button) icon | Title | Description
 | SharePoint 2013 training for IT pros | Find IT pro-focused how-to training and walkthrough videos with this interactive course about SharePoint 2013 including changes and new features for search, social, plus deployment and performance/scalability.
 | Video: Social computing overview in SharePoint Server 2013 | View a video of enterprise social computing and collaboration in SharePoint 2013, featuring Bill Baer, SharePoint Senior Product Marketing Manager.

Conceptual videos

Conceptual videos are short videos that explain a process. They do not contain specific steps to perform in the user interface, but instead they use conceptual diagrams to explain an overall process.

Upgrade

Authentication

Test Lab Guides

Upgrade

Video (play button) icon Title Description

  • Overview of the upgrade process to SharePoint 2013

  • Create the SharePoint 2013 farm for a database attach upgrade

  • Copy databases to the new farm for upgrade to SharePoint 2013

  • Upgrade service applications to SharePoint 2013

  • Upgrade content databases to SharePoint 2013

  • Upgrade a site collection to SharePoint 2013

These videos provide a quick explanation of how to upgrade to SharePoint 2013.

Authentication

Video (play button) icon Title Description

  • Authentication overview for SharePoint 2013

Three videos step through the user authentication process for SharePoint 2013.

Test Lab Guides

Video (play button) icon Title Description

  • Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm

  • Test Lab Guide: Configure intranet and team sites for SharePoint Server 2013

  • Test Lab Guide: Demonstrate permissions with SharePoint Server 2013

  • Test Lab Guide: Demonstrate SAML-based Claims Authentication with SharePoint Server 2013

  • Test Lab Guide: Demonstrate forms-based claims authentication for SharePoint Server 2013

These videos step through the building of a test lab environment.

How to videos

How to videos are short videos that are included in operational topics. The videos help to avoid mistakes when attempting to complete potentially confusing operations.

Install and configure

Upgrade

Operate and maintain

Scenarios and solutions

Install and configure

Video (play button) icon | Title | Description
 | Configure the Secure Store Service in SharePoint 2013 | View a video about how to configure the Secure Store Service, and another about how target applications are used.

Operate and maintain

Video (play button) icon | Title | Description
 | Create a Visio Graphics Service service application in SharePoint Server 2013 | View a video about how to configure Visio Services.
 | Configure Excel Services in SharePoint Server 2013 | View a video about how to configure Excel Services.

Scenarios and solutions

Video (play button) icon | Title | Description
 | Configure AdventureWorks for Business Intelligence solutions | View a video about how to deploy the AdventureWorks sample data set for use with related articles on Business Intelligence.

Change History

Date | Description
May 21, 2013 | Added new Test Lab Guide link: "Test Lab Guide: Demonstrate permissions with SharePoint Server 2013."
April 30, 2013 | Added new Test Lab Guide links: "Test Lab Guide: Configure intranet and team sites with SharePoint Server 2013" and "Test Lab Guide: Demonstrate SAML-based claims authentication with SharePoint Server 2013."
April 23, 2013 | Added links to "Authentication overview for SharePoint 2013," "Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm," and "Test Lab Guide: Demonstrate forms-based claims authentication for SharePoint Server 2013."
July 16, 2012 | Initial publication


Explore SharePoint 2013

Summary: Use these articles to develop a business case for choosing SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Articles contain an overview of product features, product comparison information, system requirements, product evaluation kit, news and reviews, case studies, information on how to buy, virtual labs, and product roadmap.

The following downloadable resources, articles on TechNet, video recordings, and related resources provide evaluation information for SharePoint 2013.

Downloadable evaluation resources for SharePoint 2013

Download the following content for information about how to evaluate SharePoint 2013.

 | Content | Description
Downloads | IT Professional Reviewer's Guide for SharePoint Server 2013 Preview | Learn how new capabilities in SharePoint Server 2013 can help IT pros better manage cost, risk, and time.
Downloads | Download SharePoint Server 2013 Preview | See for yourself what SharePoint 2013 can do by downloading and installing this version.
Downloads | Download SharePoint Foundation 2013 Preview | See for yourself what SharePoint 2013 can do by downloading and installing this version.
Lab icon | Test lab guides | Get up and running quickly in a test environment by following these guides that take the guesswork out of a SharePoint 2013 deployment.
Building blocks | SharePoint 2013 training for IT pros | IT pro-focused how-to training and covers changes and new features for search, social, plus deployment and performance/scalability with downloadable presentations.

TechNet evaluation articles for SharePoint 2013

The following articles about how to evaluate SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

What's new icon (box) Content

What's new in authentication for SharePoint 2013

What's new for Business Connectivity Services in SharePoint 2013

What's new in eDiscovery in SharePoint Server 2013

What's new for mobile devices in SharePoint 2013

What's new in records management and compliance in SharePoint Server 2013

What's new in business intelligence in SharePoint Server 2013

What's new in social computing in SharePoint Server 2013

What's new in web content management for SharePoint 2013 publishing sites

What's new in workflow in SharePoint Server 2013

What's new in search in SharePoint Server 2013

Changes from SharePoint 2010 to SharePoint 2013

Overview of identity management in SharePoint 2013

Test lab guides for SharePoint Server 2013

Learning roadmaps for SharePoint 2013

SharePoint Products for the technical decision maker

Videos about how to evaluate SharePoint 2013

The following video recordings about how to evaluate SharePoint 2013 are available to view online or to download.

 | Content | Description
Video (play button) icon | SharePoint 2013 training for IT pros | Find IT pro-focused how-to training and walkthrough videos with this interactive course about SharePoint 2013 including changes and new features for search, social, plus deployment and performance/scalability.

Additional evaluation resources for SharePoint 2013

The following resources about how to evaluate SharePoint 2013 are available from other subject matter experts.

 | Content | Description
House icon | SharePoint 2013 Tech Center | Visit the TechCenter to access videos, community sites, documentation, and more.
Code icon | SharePoint developer center | Find resources for building solutions on SharePoint 2013, including how-to articles, code samples, and the SharePoint SDK.
Chat icon | To the SharePoint | Read draft content, learn about new content, and join the conversation at this IT pro content team blog.
 | Office 365 Technical Blog | Learn how to get the most out of SharePoint sites with this blog.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support


IT Professional Reviewer's Guide for SharePoint Server 2013
See also

Published: September 4, 2012

Summary: Learn how new capabilities in SharePoint Server 2013 can help IT pros better manage cost, risk, and time.

Applies to: SharePoint Server 2013

This guide describes how SharePoint Server 2013 builds on the investments of previous SharePoint releases to help you do the following:

  • Lower IT costs with a flexible and scalable collaboration platform.

  • Better manage risk by safeguarding your business with secure and reliable capabilities.

  • Increase productivity through cost-effective and efficient management.

Download this guide as a PDF document.

SharePoint Server 2013 Preview IT Professional Reviewer's Guide (http://go.microsoft.com/fwlink/p/?LinkId=263441)

See also

SharePoint 2013 for IT pros


What's new in authentication for SharePoint 2013
See also

Summary: SharePoint 2013 includes improvements in claims infrastructure and authentication features that enable new server-to-server and app authentication scenarios.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Authentication enhancements in SharePoint 2013 make the use of claims-based authentication easier and enable new scenarios and functionality for Exchange Server 2013, Lync Server 2013, and apps in the SharePoint Store or App Catalog. SharePoint 2013 introduces support for server-to-server authentication and app authentication by utilizing and extending the Open Authorization 2.0 (OAuth 2.0) web authorization protocol. OAuth is an industry standard protocol that provides temporary, redirection-based authorization. A user or a web application that acts on behalf of a user can request authorization to temporarily access specified network resources from a resource owner.

Support for OAuth in SharePoint 2013 allows users to grant apps in the SharePoint Store and App Catalog access to specified, protected user resources and data (including contact lists, documents, photographs, and videos) without requiring the app to obtain, store, or submit the user's credentials. OAuth allows app and services to act on behalf of users for limited access to SharePoint resources. For example, a user might approve permissions to an app to grant access to a specific folder of a document library. This enables an app, such as a third-party photo printing app, to access and copy the files in the specific folder upon user request, without having to use or verify the user's account credentials.

User authentication and authorization in SharePoint 2013

User authentication in SharePoint 2013 is the process that verifies the identity of a user who requests access to a SharePoint web application. An authentication provider issues the authenticated user a security token that encapsulates a set of claims-based assertions about the user and is used to verify a set of permissions that are assigned to the user. User authorization in SharePoint 2013 is the process that determines the users who can perform defined operations on a specified resource within a SharePoint web application. SharePoint 2013 supports user authentication based on the following methods:

  • Windows claims

  • Security Assertion Markup Language (SAML)-based claims

  • Forms-based authentication claims

These claims-based authentication methods are now the recommended authentication methods for SharePoint 2013.

The app authentication and server-to-server authentication features of SharePoint 2013 require claims-based authentication. Because of this, claims-based authentication is the default for new web applications in SharePoint 2013. When you create a web application in Central Administration, you can only specify authentication methods for claims-based authentication. Although Windows Classic mode authentication is still available in SharePoint 2013 and can be configured through Windows PowerShell, we recommend that you use claims-based authentication. Windows Classic mode authentication is deprecated in SharePoint 2013.

Improvements in claims infrastructure

SharePoint 2013 also includes the following improvements in claims authentication infrastructure:

  • Easier migration from classic mode to Windows-based claims mode with the new Convert-SPWebApplication Windows PowerShell cmdlet

    Migration can be run against each content database and each web application. This is in contrast to SharePoint 2010 Products, in which the migration was run against each web application. For more information, see Migrate from classic-mode to claims-based authentication in SharePoint 2013.

  • Login tokens are now cached in the new Distributed Cache Service

    SharePoint 2013 uses a new Distributed Cache Service to cache login tokens. In SharePoint 2010 Products, the login token is stored in the memory of each web front-end server. Each time a user accesses a specific web front-end server, it needs to authenticate. If you use network load balancers in front of your web front-ends, users need to authenticate for each web front-end server that is accessed behind the load balancer, causing possible multiple re-authentications. To avoid re-authentication and its delay, it is recommended to enable and configure load balancer affinity (also known as sticky sessions). By storing the login tokens in the Distributed Cache Service in SharePoint 2013, the configuration of affinity in your load balancing solution is no longer required. There are also scale-out benefits and less memory utilization in the web front-ends because of a dedicated cache service.

  • More logging makes the troubleshooting of authentication issues easier

    SharePoint 2013 has much more logging to help you troubleshoot authentication issues. Examples of enhanced logging support are the following:

    • Separate categorized-claims related logs for each authentication mode

    • Information about adding and removing FedAuth cookies from the Distributed Cache Service

    • Information about the reason why a FedAuth cookie could not be used, such as a cookie expiration or a failure to decrypt

    • Information about where authentication requests are redirected

    • Information about the failures of user migration in a specific site collection

Server-to-server authentication

SharePoint 2013 extends OAuth to implement a server-to-server authentication protocol that can be used by services such as SharePoint 2013 to authenticate other services such as Exchange Server 2013 or Lync Server 2013 or services that are compliant with the server-to-server authentication protocol.

SharePoint 2013 has a dedicated local server-to-server security token service (STS) that provides server-to-server security tokens that contain user identity claims to enable cross-server authenticated access. These user identity claims are used by the other service to lookup the user against its own identity provider. A trust established between the local STS (the SharePoint 2013 server-to-server STS) and other server-to-server compliant services (the Exchange Server 2013 or Lync Server 2013 server-to-server STS) is the key functionality that makes server-to-server possible. For on-premises deployments, you configure the JavaScript Object Notation (JSON) metadata endpoint of the other server-to-server compliant service to establish this trust relationship. For online services, an instance of the Windows Azure Access Control Service (ACS) acts as a trust broker to enable cross-server communications among the three types of servers.

The new server-to-server STS in SharePoint 2013 issues access tokens for server-to-server authentication. In SharePoint 2013 (and also in SharePoint 2010 Products), trusted identity providers that are compliant with the WS-Federation protocol are supported. However, the new server-to-server STS in SharePoint 2013 performs only the functionality that enables temporary access tokens to access other services such as Exchange Server 2013 and Lync Server 2013. The server-to-server STS is not used for user authentication and is not listed on the user sign-in page, the Authentication Provider UI in Central Administration, or in the People Picker in SharePoint 2013 Products.

App authentication

SharePoint 2013 uses OAuth 2.0 to authorize requests by apps in the SharePoint Store and App Catalog to access SharePoint resources on behalf of a user. The user grants permission to apps in the SharePoint Store and App Catalog to access SharePoint resources on the user's behalf when they are installed. For example, a user installs an app from the SharePoint Store. A SharePoint site contains an embedded HTML inline frame (IFRAME) that the app renders and that requires the app to access a user list. When a Web browser displays the site, the app then calls back to the server running SharePoint 2013 to access the list on behalf of the user. After the app obtains the data from the list, it displays the contents of the IFRAME.

The app authentication process in SharePoint 2013 uses OAuth to verify a claim that an app makes and assert that the app can act on behalf of an authenticated user. In SharePoint 2013, an instance of the Windows Azure ACS acts as the app identity provider. You can also use app authentication without ACS. The authorization process verifies that an authenticated app has permission to perform a defined operation or to access a specified resource.

See also

Explore SharePoint 2013
Plan authentication in SharePoint 2013
Configure authentication infrastructure in SharePoint 2013


What's new for Business Connectivity Services in SharePoint 2013
See also

Summary: Learn about the new features and capabilities of Business Connectivity Services (BCS) in SharePoint 2013, including OData, BDC models, and apps for SharePoint.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The SharePoint 2013 and the Office 2013 suites include Microsoft Business Connectivity Services. With Business Connectivity Services, you can use SharePoint 2013 and Office 2013 clients as an interface into data that doesn't live in SharePoint 2013 itself. It does this by making a connection to the data source, running a query, and returning the results. Business Connectivity Services returns the results to the user through an external list, or app for SharePoint, or Office 2013 where you can perform different operations against them, such as Create, Read, Update, Delete, and Query (CRUDQ). Business Connectivity Services can access external data sources through Open Data (OData), Windows Communication Foundation (WCF) endpoints, web services, cloud-based services, and .NET assemblies, or through custom connectors.

This article lists the new and enhanced capabilities of Business Connectivity Services in SharePoint 2013. If you are new to Business Connectivity Services, see Overview of Business Connectivity Services in SharePoint 2013. To learn more about changes and new features for developers that have been added to Business Connectivity Services (BCS) for SharePoint 2013, see What's new in Business Connectivity Services in SharePoint 2013 in the MSDN Library

In this article:

  • OData support

  • Automatic generation of BDC models for OData data sources

  • Event listener

  • Support for apps for SharePoint

  • External list enhancements

  • Business Connectivity Services in SharePoint Online enhancements

  • REST (CSOM) object model for Microsoft Business Connectivity Services for web and mobile app developers

  • Business Connectivity Services Client Runtime supports side-by-side Office 2010 and Office 2013 installations

  • OData Windows PowerShell cmdlets

  • Additional resources

OData support

SharePoint 2013 introduces support for OData Business Data Connectivity (BDC) connections. This is in addition to data connections for WCF, SQL Server, and .NET assemblies. The Open Data Protocol (OData) is a web protocol that is used to query and update data. OData applies web technologies such as HTTP, Atom Publishing Protocol (AtomPub), and JavaScript Object Notation (JSON) to provide access to information from a variety of applications, services, and stores. For more information about OData, see Introducing OData: Data Access for the Web, the cloud, mobile devices, and more in the MSDN Library. For years, SharePoint has been an OData provider, which means a SharePoint list can be consumed by using OData. In SharePoint 2013, you can now connect to an external data source by using OData. For examples of OData providers and for more information about OData support, see "Connecting to Open Data (OData) Data Sources" in What's new in Business Connectivity Services for developers in the MSDN Library. For more information on using OData in BCS in SharePoint 2013, see Using OData sources with Business Connectivity Services in SharePoint 2013 in the MSDN Library.

Business Connectivity Services supports Anonymous, Basic, Windows, and Custom authentication to OData services when it is used with the Secure Store Service. If you want to apply permissions at more discrete levels, use OData connections. OData connections provide an easier way to create BDC models that work for both SharePoint 2013 and Office 2013 client applications. In SharePoint 2013, you can connect external lists that are surfaced through OData to Office 2013 clients and you can work with the data when you are offline. When the Office 2013 client reconnects, it performs bidirectional synchronization with the OData source.

Automatic generation of BDC models for OData data sources

Before SharePoint 2013 or SharePoint Online can be used as an interface to external data, they must understand what kind of data source it is, how to talk to it, and what kind of authentication the external system expects. These items — and also which tables to read, which items from those tables are of interest, and which operations to perform on them — are all described to Business Connectivity Services in a BDC model. In SharePoint 2013, you must use Visual Studio 2010 to create BDC models for OData data sources. To make the BDC model creation process smoother, Visual Studio 2010 will be able to connect to the OData endpoint through Business Connectivity Services and read the OData source. Visual Studio 2010 will then automatically generate the BDC model based on the available metadata. The BDC model can then be either imported into the Business Data Catalog as a farm-scoped external content type, or be included in an app for SharePoint. Farm-scoped external content types can be used in external data lists, business data Web Parts, or business data in lists anywhere across the SharePoint farm.

The BDC model will not contain any filters because it is not possible to know what these would be beforehand. By default, Visual Studio 2010 will generate all the Business Connectivity Services operations for all the OData operations (Get, Put, Post, and Delete).

Event listener

SharePoint 2013 provides an event listener. The event listener includes an event subscriber on the SharePoint 2013 side. The subscriber receives notifications from the event publisher (on the external system side) on changes to the data and then initiates predefined actions when changes occur. This enables SharePoint users and custom code to receive notifications of events that occur in the external system. The users and custom code need to explicitly subscribe to events on entities for which they want to receive a notification. The external system can use any of the supported connections (OData, SQL, or WCF) for transactions with the external system. However, to support eventing, the external system must implement interfaces that allow users to subscribe to events and it must send the notifications back as ATOM feeds or JSON objects to the SharePoint 2013 endpoint.

Subscriptions enable event receivers on external lists

SharePoint 2013 supports a pull model for getting data from an external system and it introduces a subscription model. In this version, developers can create BDC models that subscribe to published events from an event publisher in the external system. The developers can target a particular entity in the external system, such as the Customer entity, and receive notifications about events that are published on that entity. This enables developers to write custom code for external lists that trigger SharePoint events when data is changed. SharePoint users can also subscribe to alerts on external lists that are associated with a BDC model in which a developer has defined a subscription. For example, you can create a custom event on an external list that sends an email message to an employee when a customer account is assigned to that employee in the external system. You can do this by subscribing to a particular event (or alert) on a particular view of an external list. Note that users can subscribe to an event the same way that they did in SharePoint Server 2010. For information about how to subscribe to an alert, see Create an alert or subscribe to an RSS Feed on Office.com. For more information, see "Receiving Events from External Systems" in What's new in Business Connectivity Services for developers in the MSDN Library.

Support for apps for SharePoint

SharePoint 2013 introduces apps for SharePoint. By using apps for SharePoint, you can add functionality to a SharePoint site by using the self-contained app for SharePoint. When installed, apps for SharePoint do not make any changes to the underlying code on the computer that is running SharePoint Server. Therefore, each app for SharePoint is isolated from the rest of the system. Because apps for SharePoint contain all the resources that they need to function, they are very safe to use and also can be uninstalled cleanly. This article focuses on Business Connectivity Services support for apps for SharePoint. Business Connectivity Services supports apps for SharePoint in two ways. First, BDC models can be scoped to apps for SharePoint. Second, connection information is defined and stored separately from the app-scoped BDC model in BDC connections.

About SharePoint app-scoped external content types and connections

In SharePoint 2013, developers of apps for SharePoint can package BDC models in an app for SharePoint. The Business Connectivity Services runtime then creates external content types that are scoped to the app for SharePoint. This limits use of the external content type to the app for SharePoint. Connection properties can be specified in two ways, either in the BDC model that is contained in the app for SharePoint or in a Business Connectivity Services connection settings object that is created and stored in the Secure Store. Otherwise, if you connect to a data source that requires authentication, the connection must be defined separately in the Business Connectivity Services layer by a developer. Also, an OData connection must be used to connect the app for SharePoint to the external data source. By defining the connections separately from the BDC models that are packaged within the app for SharePoint, administrators can more easily manage connections to external systems. A Business Connectivity Services connection settings object is a combination of the following:

  • A name for the connection.

  • The endpoint URL of the data source.

  • A declaration of the credential type and authentication method that will be used to authenticate with the endpoint URL of the data source. You must use a credential type and authentication method that is supported by the external data source. For example, you can declare that the connection will use the credentials of the user that is logged in or a different set. Certificate details can be included also.

When an administrator installs an app for SharePoint that needs to access a data feed through Business Connectivity Services, the app for SharePoint must use a BDC connection. During installation, the administrator must grant permission to the app for SharePoint to use the appropriate BDC connection. Note that external content types created from an app-scoped BDC model are scoped to only the app for SharePoint that contains the model. However, multiple apps for SharePoint — each of which contains an app-scoped BDC model — can all point to the same Business Connectivity Services connection settings object. In this way, connection settings can be reused across different apps for SharePoint. For more information about what's new for developers forapp-scoped external content types and how to create a connection, see "App-Scoped External Content Types" in What's new in Business Connectivity Services for developers in the MSDN Library. For a developer overview of apps for SharePoint, see App-scoped external content types in SharePoint 2013

External list enhancements

SharePoint 2013 includes enhancements to external lists that bring them to functional parity with other SharePoint lists.

Performance improvements in external lists

SharePoint 2013 introduces a number of improvements for external lists. These improvements reduce the load on the database servers in the SharePoint farm and increase the speed of list rendering. Performance is enhanced by having the external system do paging, filtering, and sorting of the external list data before it is sent to SharePoint.

Limiting records returned by the external system

When a limit filter is defined for a BDC model, users can specify the number of records in the list that they want displayed per page.

Data source filtering

Users can use a drop-down list on a column in an external list to filter queries. Developers can prepare Collaborative Application Markup Language (CAML) queries or calls to the SPList object model to filter a list. In SharePoint 2013, if a data source filter is defined in the BDC model, the filtering occurs on the external system before it is passed to SharePoint.

Sorting external lists

In SharePoint 2013, the user's request to sort an external list is sent to the external system. The external system sorts the data, and then sends it to the external list. To do this, the solution developer adds a sort filter to the BDC model for each column in the external list that the developer wants users to be able to sort. Sorting is applied on the entire dataset in the external system, instead of just the first set of data retrieved. The result is an accurately sorted list that is displayed to the user. For more information about paging, filtering, and sorting external lists, see "Enhanced Filtering, Sorting and paging for external lists" in What's new in Business Connectivity Services for developers in the MSDN Library.

Export external lists to Excel

In SharePoint 2013, you can export an external list to Excel 2010 or to Excel 2013. This works much like exporting SharePoint native lists to Excel in SharePoint Server 2010. However, there are some differences in how you control what gets exported and how you work with the exported data. By default, exporting external lists is enabled. However, an administrator can disable this.

When you export an external list to Excel, you basically get the list as it is displayed in the browser. You get only the data that is present in the selected view and the rows and columns in Excel will have the same sorting and filtering applied as the external list. The column names in the exported data will have the same language settings as the external list and the exported data is subject to any filters that are on the external system.

The process of exporting data creates a one-way (external list to Excel) link between the external list and the Excel version of the list. The Excel version can be refreshed at any time to reflect the current state of the source external list. This means that any changes users might have made to the Excel version are overwritten. Changes that are made in the Excel version are never pushed back up to the source external list.

Business Connectivity Services in SharePoint Online enhancements

All Office 365 for enterprises subscriptions include SharePoint Online. This version of SharePoint Online introduces Business Connectivity Services to the Office 365 users. By using this version, you will be able to bring external data into SharePoint Online from cloud-based data sources and from data sources that are behind your company's firewall in a hybrid scenario. Microsoft Business Connectivity Services can consume data sources that are exposed as WCF services, SQL Azure data services, OData endpoints, and web services.

REST (CSOM) object model for Microsoft Business Connectivity Services for web and mobile app developers

In SharePoint 2013, Business Connectivity Services exposes the Representational State Transfer (REST) APIs for web and mobile app developers to use. These APIs provide a standard interface to the developers.

Business Connectivity Services Client Runtime supports side-by-side Office 2010 and Office 2013 installations

Business Connectivity Services Client Runtime now supports side-by-side installation of Office 2010 and Office 2013 on the same client computer. For example, if Outlook 2010 and Lync 2013 are installed on the same client computer, by default both versions of Business Connectivity Services Client Runtime are also installed. This new feature enables Office 2010 and Office 2013 to continue to work without causing conflicts or failures when Microsoft Business Connectivity Services Client Runtime is used.

OData Windows PowerShell cmdlets

SharePoint 2013 includes the following six new Windows PowerShell cmdlets specifically for OData.

  • Get-SPODataConnectionSetting Reads a Business Connectivity Services connection of a BDC service application and returns the Business Connectivity Services connection object.

  • Get-SPODataConnectionSettingMetadata Returns Business Connectivity Services connection metadata properties.

  • New-SPODataConnectionSetting Creates a new Business Data Connectivity connection.

  • Remove-SPODataConnectionSetting Deletes the Business Connectivity Services connection object together with its metadata object.

  • Set-SPODataConnectionSetting Can be used to edit the properties of an existing Business Connectivity Services connection.

  • Set-SPODataConnectionSettingMetadata Can be used to edit metadata properties of an existing Business Connectivity Services connection.

Additional resources

For developer-focused information about what's new in Business Connectivity Services, see What's new in Business Connectivity Services for developers in the MSDN Library.

See also

Overview of Business Connectivity Services in SharePoint 2013


What's new in eDiscovery in SharePoint Server 2013
See also

Summary: Get a quick introduction to eDiscovery and in-place hold capabilities in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The eDiscovery functionality in SharePoint Server 2013 provides improved ways to help you protect your business. SharePoint Server 2013 includes the following:

  • A site collection from which you can perform eDiscovery queries across multiple SharePoint farms and Exchange servers and preserve the items that are discovered.

  • In-place preservation of Exchange mailboxes and SharePoint sites — including SharePoint list items and SharePoint pages — while still allowing users to work with site content.

  • Support for searching and exporting content from file shares.

  • The ability to export discovered content from Exchange Server 2013 and SharePoint Server 2013.

The following sections describe the new functionality:

  • SharePoint eDiscovery Center

  • SharePoint in-place holds

  • SharePoint eDiscovery export

  • Enterprise-wide eDiscovery

SharePoint eDiscovery Center

SharePoint Server 2013 introduces a new site for managing discovery cases and holds. The eDiscovery Center site template creates a portal through which you can access discovery cases to conduct searches, place content on hold, and export content. For each case, you create a new site that uses the eDiscovery Case site template. Each case is a collaboration site that includes a document library which you can use to store documents related to the management of the case. In addition, you can associate the following things with each case:

  • Sources: Exchange mailboxes, SharePoint sites, or file shares from which content can be discovered.

  • eDiscovery sets: Combinations of sources, filters, and whether to preserve content. eDiscovery sets are used to identify and preserve content.

  • Queries: The search criteria, such as author, date range, and free-text terms, and the scope of the search. Queries are used to identify content to export.

  • Exports: A list of all of the exports that were produced that relate to the case.

When there is a new need for discovery — for example, a legal case or an audit — a user who has appropriate permissions can create a new case, create eDiscovery sets to identify the specific material to be located, and then preserve the sites and mailboxes in which content was discovered. The user can then create queries to further refine the content that is relevant, preview the content, and export the content. When the case is closed, all of the holds associated with the case are released.

SharePoint in-place holds

In SharePoint Server 2013, content that is put on hold is preserved, but users can still change it. The state of the content at the time of preservation is recorded. If a user changes the content or even deletes it, the original, preserved version is still available. Regular users see the current version of the content; compliance officers who have permissions to use the eDiscovery features of SharePoint Server 2013 can access the original, preserved version.

In-place holds in SharePoint Server 2013 offer improvements to the hold functionality in earlier versions of SharePoint Server. Improvements include the following:

  • Documents, list items, pages, and Exchange Server 2013 mailboxes can be preserved.

  • Preservation is done at the level of a site. Preserving a site preserves the contents of the site.

  • Users can continue to work with content that is preserved. The content remains in the same location, and users can edit, delete, and add new content.

  • A user who has permissions to perform eDiscovery can access the original version of preserved content.

  • You do not have to preserve a whole site or mailbox. You can specify a query filter to define the scope of preservation, and preserve only the content that matches the query filter.

SharePoint eDiscovery export

In SharePoint Server 2013, you can export the results of an eDiscovery search for later import into a review tool. You can export all of the content that is associated with an eDiscovery case. This includes the following:

  • Documents: Documents are exported from file shares. Documents and their versions are exported from SharePoint Server 2013.

  • Lists: If a list item was included in the eDiscovery query results, the complete list is exported as a comma-separated values (.csv) file.

  • Pages: SharePoint pages, such as wiki pages or blogs, are exported as MIME HTML (.mht) files.

  • Exchange objects: Items in an Exchange Server 2013 mailbox, such as tasks, calendar entries, contacts, email messages, and attachments, are exported as a .pst file.

An XML manifest that complies with the Electronic Discovery Reference Model (EDRM) specification provides an overview of the exported information.

Enterprise-wide eDiscovery

In SharePoint Server 2013, you can centrally manage eDiscovery across multiple SharePoint farms, Exchange servers, and file shares. From one eDiscovery Center, you can do the following:

  • Create a case, define a query, and then search SharePoint Server 2013, Exchange Server 2013, and file shares throughout the enterprise for content that matches the query.

  • Export all of the content that was identified.

  • Preserve items in place in SharePoint Server 2013 or Exchange Server 2013.

  • Track statistics related to the case.

To implement eDiscovery across the enterprise, you configure SharePoint Server 2013 Search to crawl all file shares and websites that contain discoverable content, and configure the central Search service application to include results from Exchange Server 2013. Any content from SharePoint Server 2013, Exchange Server 2013, or a file share or website that is indexed by Search or by Exchange Server 2013 can be discovered from the eDiscovery Center.

See also

Overview of eDiscovery and in-place holds in SharePoint Server 2013
Plan for eDiscovery in SharePoint Server 2013


What's new for mobile devices in SharePoint 2013
See also

Summary: Learn about the new mobile features available in SharePoint 2013, including the mobile browser experience, device channels, and location.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint Server 2013 offers new, optimized viewing experiences across different mobile platforms. Additionally, several new features were added to help improve both worker productivity and usability on the device. This functionality includes the following:

  • Optimized mobile browser experience For smartphone mobile devices SharePoint Server 2013 provides a lightweight, contemporary view browsing experience for users to navigate and access document libraries, lists, wikis, and Web Parts.

  • Device channels You can render a single published SharePoint site in multiple designs to accommodate different device targets.

  • Push notifications A push notification service on a SharePoint site can be enabled to send device updates such as a tile or toast notification to a Windows Phone device.

  • Location SharePoint Server 2013 supports a new geolocation field type that can be used for mobile application development.

  • Business intelligence content Certain devices are now able to view business intelligence content such as PerformancePoint Web Parts, Excel Services reports, and SQL Reporting Services reports.

  • Office Web Apps You can view Word, Excel, and PowerPoint documents in mobile browsers with additional functionality in SharePoint Server 2013.

For an end to end look and understanding of the SharePoint Server 2013 mobile landscape, see the poster Mobile architecture in SharePoint 2013. Also, for more information on how to administer your mobile environment see Administer mobile devices in SharePoint 2013.

Optimized mobile browser experience

SharePoint Server 2013 offers improvements to the mobile browser experience with the introduction of a new contemporary view. Depending on the mobile browser, users have one of the following browsing options:

  • Contemporary view This view offers an optimized mobile browser experience to users and renders in HTML5. This view is available to Mobile Internet Explorer version 9.0 or later versions for Windows Phone 7.5, Safari version 4.0 or later versions for iPhone iOS 5.0, and the Android browser for Android 4.0 or later versions.

  • Classic view This view renders in HTML format, or similar markup languages (CHTML, WML, and so on), and provides backward compatibility for mobile browsers that cannot render in the new contemporary view. The classic experience in SharePoint 2013 is identical to the mobile browser experience of SharePoint Server 2010.

  • Full screen UI There is also the ability to have a full desktop view of a SharePoint site on a smartphone device.

The following figure shows the contemporary view for a smartphone browser.

Figure: Contemporary view on a smartphone browser

Note:

For the above figure the top row shows the contemporary view rendering on a Windows Phone, and the iPhone for the bottom row. The classic and contemporary views are only rendered for smartphone mobile browsers. For more information about which mobile browsers are supported in SharePoint Server 2013, see Mobile device browsers supported in SharePoint 2013.

Device channels

Browsing the web on a mobile device is now so common that it is essential that a SharePoint site should be optimized for readability and ease of use on smartphones and other mobile devices such as tablets.

Previous versions of SharePoint Server included a single default mobile view that was auto-generated based on the existing site, and that default mobile view was not easily customizable. Now, with mobile channels in SharePoint Server 2013, you can render a single publishing site in multiple ways by using different designs that target different devices. You create a single site and author the content in it a single time. Then, that site and content can be mapped to use different master pages, page layouts, and style sheets for a specific device or group of devices.

For more information on using device channels, and understanding the larger custom design and site branding experience for SharePoint 2013, see Plan device channels and Overview of Design Manager.

Push notifications

SharePoint Server 2013 supports applications on mobile devices (such as smartphones, tablets, and so on) that should receive notifications from a SharePoint site. Notifications can include events that occur in the site, such as when a user adds an item to a list or updates an item. For mobile devices to receive these notifications, device applications must register with a SharePoint site. Once the device is registered, you can write event handler code to interact with Microsoft Push Notification Service or notification services of other mobile device platforms. Notifications are sent from the server where the application is hosted to the registered mobile device application.

Location

SharePoint Server 2013 introduces a new geolocation field type that can be used in a list. For example, you can now make lists "location-aware" and display latitude and longitude coordinates through Bing Maps. An entry is typically seen as a pushpin on the map view. Although there are several ways to use this geolocation field, one key scenario is for mobile application development. Users can track or log location-specific data while they work remotely from the corporate office. Alternatively, the application can help them locate points of interest when it performs offsite functions.

Business intelligence content

SharePoint Server 2013 enables a user to view certain kinds of dashboard content. This includes PerformancePoint reports and scorecards, and Excel Services reports in iOS 5.0 Safari browsers on iPad devices.

Office Web Apps

In SharePoint Server 2010, Office Web Apps Server provides browser-based companions for Word, Excel, and PowerPoint. When Office Web Apps Server is installed on SharePoint Server 2010, Office Mobile Web Apps is also installed on the server. Office Mobile Web Apps enables users to open documents in the mobile web application by using a mobile browser. With SharePoint Server 2013, Office Web Apps Server is no longer a companion product installed on a computer that is running SharePoint Server. Instead, Office Web Apps Server is a new stand-alone server product that still provides mobile browser-based viewers for these applications. These viewers called Word Mobile Viewer, Excel Mobile Viewer, and PowerPoint Mobile Viewer are optimized to render documents for phones. When integrated with SharePoint Server 2013, a user can enjoy enhanced viewing experiences when interacting with documents on the phone.

See also

Overview of mobile devices and SharePoint Server 2013
Administer mobile devices in SharePoint 2013

Plan device channels
Mobile architecture in SharePoint 2013


What's new in records management and compliance in SharePoint Server 2013
See also

Summary: Learn about the new site-based retention feature in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The records management and compliance features in SharePoint Server 2013 provide improved ways to help you protect your business. The records archive and in-place record retention from earlier versions of SharePoint Server are still supported. SharePoint Server 2013 adds retention policies that are applied at the level of a site.

Site-based retention

Compliance features of SharePoint Server 2013 have been extended to sites. You can create and manage retention policies in SharePoint Server 2013, and the policies will apply to SharePoint sites and any Exchange Server 2013 team mailboxes that are associated with the sites.

Compliance officers create policies, which define the following:

  • The retention policy for the whole site and the team mailbox, if one is associated with the site.

  • What causes a project to be closed.

  • When a project should expire.

When a project begins, the project owner creates a SharePoint site and an Exchange Server 2013 team mailbox. The project owner selects the appropriate policy template and invites team members to join the project. As the team adds documents to the site, sends email messages, and creates other artifacts such as lists, these items automatically receive the correct retention policies. When the work is completed, the project owner closes the project, which removes the project's folders from the team members' user interface in Outlook 2013. After a certain time, as specified by the policy, the project expires, and the artifacts associated with the project are deleted.

See also

Overview of site policies in SharePoint 2013


What's new in business intelligence in SharePoint Server 2013

Summary: Microsoft provides comprehensive BI tools that integrate across Office applications and other Microsoft technologies. These tools enable analysis, reporting, dashboards, and visualizations.

Applies to: SharePoint Server 2013 Enterprise

Business intelligence (BI) in SharePoint 2013 provides comprehensive BI tools that integrate across Microsoft Office applications and other Microsoft technologies. These BI tools are: Excel 2013, Excel Services in SharePoint 2013, PerformancePoint Services in SharePoint Server 2013, Visio Services in SharePoint, SharePoint 2013, and Microsoft SQL Server.

Excel BI

Excel BI provides the capabilities to analyze and visually explore data of any size, and to integrate and show interactive solutions. In SharePoint Server 2013, Excel BI offers certain new features to support business intelligence applications.

These include the following:

  • In-Memory BI Engine (IMBI): The In Memory multidimensional data analysis engine (IMBI), also known as the Vertipaq engine, allows for almost instant analysis of millions of rows and is a fully integrated feature in the Excel client.

  • Power View Add-in for Excel: Power View ("Crescent") enables users to visualize and interact with modeled data by using highly interactive visualizations, animations and smart querying.. Users can present and share insights with others through rich storyboard presentation capabilities. PowerView is powered by the BI Semantic Model and the VertiPaq engine.

  • Decoupled PivotChart and PivotTable reports: Users can now create PivotChart reports without having to include a PivotTable report on the same page.

Excel Services

Excel Services enables people to view and interact with Excel workbooks that have been published to SharePoint sites. Users are able to explore data and conduct analysis in a browser window just as they would by using the Excel client. For more information about Excel Services in Microsoft SharePoint Server 2010, see Excel Services overview (SharePoint Server 2010) on Microsoft TechNet.In SharePoint Server 2013, Excel Services offers certain new features to support business intelligence applications. These include the following:

  • Data exploration improvements: People can more easily explore data and conduct analysis in Excel Services reports that use SQL Server Analysis Services data or PowerPivot data models. For example, users can point to a value in a PivotChart or PivotTable report and see suggested ways to view additional information. Users can also use commands such as Drill Down To to conduct analysis. Users can also apply the Drill Down command by using a single mouse click.

  • Field list and field well support: Excel Services enables people to easily view and change which items are displayed in rows, columns, values, and filters in PivotChart reports and PivotTable reports that have been published to Excel Services.

  • Calculated measures and members: Excel Services supports calculated measures and calculated members that are created in Excel.

  • Enhanced timeline controls: Excel Services supports timeline controls that render and behave as they do in the Excel client.

  • Application BI Servers: Administrators can specify SQL Server Analysis Services servers to support more advanced analytic capabilities in Excel Services.

  • Business Intelligence Center update: The Business Intelligence Center site template has been streamlined. It not only has a new look, it is easier to use.

PerformancePoint Services

PerformancePoint Services enables users to create interactive dashboards that display key performance indicators (KPIs) and data visualizations in the form of scorecards, reports, and filters. For more information about PerformancePoint Services in SharePoint Server 2010, see PerformancePoint Services overview (SharePoint Server 2010) on Microsoft TechNet.In SharePoint Server 2013, PerformancePoint Services offers certain new features to support business intelligence applications. These include the following:

  • Dashboard Migration: Users will be able to copy entire dashboards and dependencies, including the .aspx file, to other users, servers, or site collections. This feature also allows the ability to migrate single items to other environments and migrate content by using Windows PowerShell commands.

  • Filter Enhancements & Filter Search: The UI has been enhanced to allow users to easily view and manage filters including giving users the ability to search for items within filters without having to navigate through the tree.

  • BI Center Update: The new BI Center is cleaner, and easier to use with folders and libraries configured for easy use.

  • Support for Analysis Services Effective User: This new feature eliminates the need for Kerberos delegation when per-user authentication is used for Analysis Services data sources. By supporting Analysis Services Effective User feature, authorization checks will be based on the user specified by the EffectiveUserName property instead of using the currently authenticated user.

  • PerformancePoint Support on iPad: PerformancePoint dashboards can now be viewed and interacted with on iPad devices using the Safari web browser.

Visio Services

Visio Services is a service application that lets users share and view Microsoft Visio Drawing (*.vsdx) and Visio 2010 Web drawing (*.vdw) files. The service also enables data-connected Visio Drawing (*.vsdx) and Visio 2010 Web drawing (*.vdw) files.to be refreshed and updated from various data sources.

  • Maximum Cache Size: A new service parameter, it is located on the Central Admininstration Visio Graphics Service Application Global Settings page. The default value is 5120 MB.

  • Health Analyzer rules: New corresponding Health Analyzer rules have been added to reflect the new Maximum Cache Size parameter.

  • Updated Windows PowerShell cmdlets, Set-SPVisioPerformance: This cmdlet has been updated to include the new Maximum Cache Size parameter.

  • Commenting on drawings supported: Users can add meaningful comments to a Visio Drawing (*.vsdx) collaboratively on the web via Visio Services in full page rendering mode.


What's new in social computing in SharePoint Server 2013
See also

Summary: Learn about new features and functionality for social computing, such as My Sites, feeds, Community Sites, and Community Portals.

Applies to: SharePoint Server 2013

The social computing and collaboration features in SharePoint Server 2013 offer an improved administration and user experience, in addition to new functionality for enterprise users to share and collaborate with others in their organization.

The introduction of Community Sites offers a forum experience to categorize discussions around subject areas, and connect users who have knowledge or seek knowledge about subject areas. Improvements to My Sites offer a more intuitive workflow for users to develop their personal profiles, store content, and keep up-to-date with activities of interest.

Video: Social computing overview with Bill Baer

Video (play button) icon

In this article:

  • Communities

  • My Sites

Communities

In SharePoint Server 2010 and SharePoint Foundation 2010, you could add a Discussion list to sites to facilitate discussions among members of the site. SharePoint Server 2013 and SharePoint Foundation 2013 continue to provide this Discussion list, but also expand on the discussion concept by introducing two new site templates named Community Site and Community Portal.

Community Sites offer a forum experience to categorize and cultivate discussions with a broad group of people across organizations in a company. Community Sites promote open communication and information exchange by fostering discussions among users who share their expertise and use expertise of others who have knowledge in specific areas of interest.

With Community Sites, you organize discussions in categories. Visitors can view the discussions and become members if they want to contribute to those discussions. Moderators manage the community by setting rules, reviewing and addressing inappropriate posts, marking interesting content as featured discussions, and so on. Moderators can also assign gifted badges to specific members to visually indicate that the member is recognized as a specific kind of contributor in the Community Site, such as an expert or a moderator. Each Community Site contains information about member and content reputation, which members earn when they actively post in discussions, and when their content is liked, replied to, or marked as a best answer.

You can deploy Community Sites or use community features in the following ways:

  • By deploying a stand-alone community With a stand-alone community, you can create the Community Site at either a site collection or a site level. For example, you might create a community in a divisional portal if you want to facilitate discussions among members of the division and use the community categories to keep things organized.

  • By activating community features You can activate community features on any site, which provides the core Community Site pages, moderation, membership, and reputation functionality within the existing site without creating a separate Community Site. This option is useful when you already have a site, such as a team site, where you want to include community functionality, such as earning reputations, without having to direct users to a separate site.

Additionally, when you have multiple Community Sites that you want to display to users in your enterprise, you can deploy the Community Portal. The Community Portal is a search-driven page that surfaces SharePoint site collections and sites in the SharePoint farm that use the Community Site template. Users can visit the Community Portal to discover popular communities and to search for communities that they might want to join. The Community Portal relies on enterprise search for security trimming, and displays only Community Sites for which a user has at least read permissions.

For more information about communities, see Overview of communities in SharePoint Server 2013, Plan for communities in SharePoint Server 2013, and Create and configure communities in SharePoint Server 2013.

My Sites

In SharePoint Server 2010, My Sites provided a central place for users to store personal and shared documents, in addition to promoting their user information and expertise, tagging content, and communicating with others by using the Note Board. Through people search, users were able to connect with one another and benefit from expertise of others in their organization.

In SharePoint Server 2013, My Sites continue to provide the benefits from the previous release. However, the user interface is completely redesigned and modernized to give users an inviting and intuitive experience. A key change to the user interface includes a simplified and unified navigation experience for your own and others' My Sites. Additionally, My Sites contain the new Microblog and Newsfeeds features. These features allow users to engage in short, public conversations, and keep up-to-date on activities from content and people in which they are interested.

This section discusses improvements and new functionality to the following areas of My Sites:

  • My Site document libraries

  • Microblogging and feeds

  • Deployment and configuration

  • Central Administration changes

My Site document libraries

In SharePoint Server 2010, each My Site contained two document libraries: personal and shared. Items stored in the personal document library were restricted to the My Site owner, and items in the shared document library were shared with everyone.

In SharePoint Server 2013, My Sites include several improvements to saving, synchronization, sharing, and moving of content. These improvements make My Sites a more robust solution for users to store and work with files in the SharePoint environment.

Saving and synchronizing content

When deployed, a user's My Site document library is the default save location for files saved from Office 2013 client applications. A discovery service identifies the user's My Site URL and offers it as the default location in addition to other locations available for saving files. This promotes the workflow of storing files in the user's My Site document library where items can be managed, governed, shared, and moved. This helps reduce the amount of content that is stored in other systems, such as in email or on personal drives.

Note:

In test environments where users have more than one My Site, the discovery service is unable to determine the default My Site location to use for saving files.

Users have the option to synchronize their My Site document library content with a local drive to enable offline access to documents. This option encourages the use of the My Site document library for storage instead of the users' local drives because it offers flexibility for users to work with documents in both online and offline scenarios.

Sharing content

SharePoint Server 2013 introduces the concept of sharing for all document libraries. This concept is leveraged by the My Site document library to ease the process of collaborating with other users on content. Sharing is based on the same permissions infrastructure as SharePoint Server 2010, but simplifies and improves the user experience. By using this simplified experience, users can specify permissions for a specific document without having to understand the inheritance model.

By default, all content that is stored in a user's My Site document library is restricted to the user, and other users cannot see content unless it is shared with them. If the user wants others to collaborate on a piece of content in that library, the user can share the content with specific users or groups, and select the permission those users or groups have to the content.

Even though the sharing process is available to all document libraries in SharePoint Server 2013, My Sites include a sharing hint, which displays all the users and the permissions for a specific piece of content. This makes it easier for users to see at a glance what they are sharing and with whom.

Microblogging and feeds

In SharePoint Server 2013, the Newsfeed page in the My Site continues to provide an aggregated view of activities from content and people the user is following. However, the feed is improved with new microblogging functionality that enables users to do the following:

  • Participate in conversations by posting comments and replies.

  • Post pictures and links.

  • Use tags (starting with the # symbol) to define keywords that users can follow and search for.

  • Use mentions (starting with the @ symbol) to tag users in posts and replies.

  • Indicate agreement with comments and replies by clicking Like.

  • Follow people, documents, sites, and tags to customize their feed.

In SharePoint Server 2013, a new in-memory cache known as the Distributed Cache (which uses AppFabric for Windows Server) maintains the Newsfeed. AppFabric is installed and configured as part of the SharePoint Server 2013 prerequisites. For more information about SharePoint Server 2013 prerequisites, see Prepare for installation of SharePoint 2013.

This feeds infrastructure better supports the read and write operations generated by users' activities and participation in microblogging. The feeds API is extensible, which enables scenarios where activities can be added to the newsfeed or consumed by other applications programmatically. For example, you might develop a new application for users to check in to locations, such as a building, and broadcast their check-ins to their feed by using the feeds API.

In SharePoint Server 2013, each My Site requires a document library for microblogging and feeds. This document library contains a microblogging list that maintains all of a user's posts instead of maintaining them in the My Site Host site collection as in SharePoint Server 2010. This means that activities are persisted indefinitely and no longer limited to 14 days as in SharePoint Server 2010. The Newsfeed page displays the aggregated view of recent activities that are maintained in the cache, whereas the user's profile page displays all activities maintained in the user's microblogging list.

Deployment and configuration

The planning, deployment, and configuration steps for My Sites are much the same as in SharePoint Server 2010. For more information, see Plan for social computing and collaboration in SharePoint Server 2013 and Administer the User Profile service in SharePoint Server 2013.

This section describes the considerations for upgrading My Sites from SharePoint Server 2010, and new and updated settings for My Sites in SharePoint Server 2013.

Upgrade considerations

If you upgrade from SharePoint Server 2010 to SharePoint Server 2013, there are special considerations for My Sites. Make sure that you upgrade the My Site Host site collection before you allow users to upgrade their individual My Sites in SharePoint Server 2013. This ensures that the server software and database changes are complete so that users can start the upgrade of their individual My Sites successfully. Upgrade of a specific My Site occurs the first time that a user opens an individual My Site. An upgrade request is queued until the My Site upgrade is completed. While the upgrade request is in the queue, users can continue to use their My Sites though the sites will appear as they did in SharePoint Server 2010 until the upgrade is completed. Following upgrade, users see the new user interface the next time that they visit their My Site.

Central Administration changes

SharePoint Server 2013 includes several changes to the User Profile service application settings in Central Administration to support new My Sites functionality.

Configure permissions for personal and social features

The Manage User Permissions page contains new and updated settings for the User Profile service application. You can select one or more of the following permissions for users and groups that you want to grant permission to personal and social features:

  • Create Personal Site (required for personal storage, newsfeed, and followed content) This permission enables users to create personal sites to store their documents, newsfeed, and followed content.

  • Follow People and Edit Profile This permission enables users to follow people from their My Site and to edit their personal profile.

  • Use Tags and Notes This permission enables users to use the Tags and Notes feature from SharePoint Server 2010. The Tags and Notes feature is provided primarily for upgrade purposes so that users can continue to access the tags and notes they created in the previous version of SharePoint Server. However, you might also use this permission to enable users to leave notes on documents in SharePoint Server 2013.

Configure microblogging and following settings

Central Administration contains new settings for User Profile service application administrators to configure microblogging and following activities:

  • Enable microblogging e-mail notifications On the Setup My Sites page, under E-mail Notifications, select Enable newsfeed email notifications if you want users to receive email notifications that relate to their microblogging activities.

  • Manage Following page On the User Profile service application administration page, under My Site Settings, click Manage Following. From the Manage Following page, you can configure limits for the number of people, documents, and sites that users can follow from their My Site.

Configure policies for privacy and people

Central Administration contains new policy settings for the User Profile service application and My Sites. These settings appear on the Manage Policies page of the User Profile service application. There are two new sections that display privacy and people settings. You can select a specific policy to change whether the policy is enabled, the default privacy setting for users, and whether users can override the setting from their own profiles. In SharePoint Server 2013, the Default Privacy Setting for policies contains only two settings: Only Me and Everyone. The additional settings from SharePoint Server 2010 of My Manager, My Team, and My Colleagues are removed. Setting a policy to Only Me sets the default behavior for feed events to off, whereas setting it to Everyone turns it on. If you allow users to override the setting, they can choose whether to change the default behavior on their individual profiles.

The following are new settings under Privacy Settings:

  • Following a Document or Site on My Site

  • Tagging an Item on My Site

  • Workplace anniversary on My Site

  • Following a Tag on My Site

  • Updating "Ask Me About" on My Site

  • Rating an Item on My Site

  • Following a Person on My Site

  • Posting on a Note Board on My Site

  • Job Title Change on My Site

  • Posting a new blog post on My Site

  • Birthday Celebration on My Site

The following are updated settings under People Settings:

  • People on My Site

  • Auto-follow people from team

  • People Recommendations

Note:

These People Settings existed in SharePoint Server 2010 under the My Colleagues section, but they are renamed in SharePoint Server 2013 because the concept of colleagues is now changed to people. Additionally, the People on My Site setting now defines the default privacy setting for all people a user follows, instead of individual privacy settings. This means that when you set the privacy setting to Everyone, everyone who accesses a user's profile can see the people whom that user follows.

Note:

My Sites are private by default. There is a privacy setting named Make My Sites Public that an administrator can use to make all users' My Sites public by default. The Make My Sites Public setting is located in the User Profile service application under Setup My Sites. Even if an administrator configures any of these policy settings, these policy settings are overridden if the Make My Sites Public setting is selected.

See also

Overview of communities in SharePoint Server 2013
Plan for communities in SharePoint Server 2013
Create and configure communities in SharePoint Server 2013
Plan for My Sites in SharePoint Server 2013
Configure My Sites in SharePoint Server 2013
Overview of microblog features, feeds, and the Distributed Cache service in SharePoint Server 2013
Plan for feeds and the Distributed Cache service in SharePoint Server 2013


What's new in web content management for SharePoint 2013 publishing sites

Summary: Learn about web content management features for building Internet, intranet, and extranet SharePoint publishing sites.

Applies to: SharePoint Server 2013

SharePoint Server 2013 includes new and improved features for web content management that simplify how you design publishing sites and enhance the authoring and publishing processes of your organization. SharePoint Server 2013 also has new features that use the power of search to surface dynamic web content on publishing sites.

Content authoring improvements

Content authors have a better experience in SharePoint Server 2013. Content authors can now copy content from Word, paste it directly into a Rich Text Editor Web Part, Content Editor Web Part, or an HTML field control on a page, and have the resulting semantically correct HTML markup display in the styles that were defined by the site designer. Site owners and designers can now customize the global and current navigation menus by dragging and dropping menu items directly on the page.

SharePoint Server 2013 adds many new features for videos and using videos on pages. A new video content type is added, and the video upload process is improved for content authors. Thumbnail preview images are created automatically when a video is uploaded to an asset library, and content authors can choose a frame from the video and use that as the thumbnail preview image. For automatic thumbnail creation to work, the Desktop Experience feature must be installed on the front-end web server that hosts SharePoint Server 2013. For information about the Desktop Experience feature, see Desktop Experience Overview.

In SharePoint Server 2013, content authors can insert an iframe element into an HTML field on a page. This lets content authors embed dynamic content from other sites, such as videos or map directions. By default, certain trusted external domains are already approved for use in iframes. Site collection administrators can customize the field security settings by changing the default trusted external domains. They can also allow content authors to insert iframes for any external domain, or prevent them from inserting iframes on any page. To change the field security settings for a site collection, click HTML Field Security on the Site Settings page.

Finally, SharePoint Server 2013 supports image renditions. Image renditions let you display different sized versions of an image on different pages. When you create an image rendition, you specify the width and height for all images that use that image rendition. For example, if the site has a news article page layout that contains an image field, you can create an image rendition named Article_image to display the full-sized image in the article page. A second image rendition named Thumbnail_small can be used to display a smaller version of the image associated with a particular article when the image is displayed in a Web Part that lists all recent news articles on the site home page. To use image renditions, you first define the image rendition sizes. Next, you generate the default image preview by uploading an image, which you can adjust if it is necessary. Finally, you add the image to a page and specify which image rendition to use on that page.

By default, the image preview that is displayed for an image rendition is generated from the center of the image. You can adjust the image preview for individual images by selecting and resizing the portion of the image that you want to use as the image preview. For example, if a photo contains a person's face but the default image preview does not show the whole face, you can change the selected image area so that the whole face is displayed.

Image renditions let you have large source images on the site and also have places on the site where pages only use smaller versions. This reduces the size of the file that is downloaded to the client, which improves site performance. Image renditions also let you have multiple versions of the same image that are cropped differently without having to upload multiple images. This reduces the storage space that is required for images. Finally, image renditions are useful in mobile scenarios, where different versions of images can be displayed based on the device that is used.

Important:

Before you can use image renditions, you must enable the BLOB cache. For information about how to enable the BLOB cache, see "Configuring BLOB cache settings" in Configure cache settings for a Web application (SharePoint Server 2010).

To use image renditions, click Image Renditions on the Site Settings page. You define an image rendition by specifying a name, such as Thumbnail_small, and the width and height in pixels for that image rendition. You can create as many image renditions as you want for your site design. To use an image rendition for a specific image on a page, you add an image to a page as you typically would. When you add an image to a page, the Edit Image Properties page displays a list of image renditions that you can apply. The image is then displayed on the page using the dimensions specified in the selected image rendition.

You can also use image renditions on a page by specifying a value in the RenditionID property for an image field control on a page layout, or by using a URL that has the RenditionID parameter to point directly to the version of the image that you want to use. The rendition ID is displayed on the Image Renditions settings page for a site collection or site. After you create an image rendition, you can provide a list of available rendition IDs to content authors so they always know what value to use for the RenditionID in field controls or as a parameter in a URL. For example, if the image rendition named Thumbnail_small has RenditionID 2, you can give that information to content authors so that they always use RenditionID 2 anywhere they want to insert a small thumbnail of an image.

You can also use the following alternative methods to specify the RenditionID:

  • To specify the RenditionID property in the image field control, enter the numeric ID that corresponds to the rendition that you want to use when an image is inserted into that field control during page editing.

  • To specify the RenditionID parameter in the URL, add "?RenditionId=n" to the image URL, where n is the RenditionID. For example, the URL http://contoso.com/Images/myimage.jpg?RenditionId=2 will load the image rendition with ID 2 for the image file myimage.jpg.

Variations for multilingual sites

In SharePoint Server 2013, the variations feature is used exclusively for multilingual sites. The variations feature makes content available to specific audiences on different sites by copying content from a source variation site to one or more target variation sites, and tracking relationships between source and target content. Users who visit the site are redirected to the appropriate variation site based on the language setting of their web browser.

SharePoint Server 2013 now has an integrated translation service that lets content authors select content for export for human translation or specify content for machine translation. Translated content can also be used across multiple site collections by using cross-site publishing. For information about cross-site publishing, see Cross-site publishing later in this article.

By using SharePoint Server 2013, content authors can nominate lists on source variation sites to be propagated to target variation sites. List items such as documents, images, or announcements propagate independently from pages. For example, if you have a page that links to a document, and you change only the document, the document will be propagated to the target variation site without the user having to republish the page that references the document.

In SharePoint Server 2013, additional changes were made to the variations feature to improve performance, such as enabling bulk export of pages. Logging functionality is updated to improve the usefulness of error messages, and logs can now be exported to Excel.

Note:

In SharePoint Server 2010, you could use variations to make content available to audiences based on language, country and region, mobile device, or corporate branding needs. In SharePoint Server 2013, you use cross-site publishing to make content available to users in a single language, or if you want to brand the same content with different corporate branding requirements. If you want to make content available to users on multiple mobile devices, use mobile channels and device-specific targeting. For information about cross-site publishing, see Cross-site publishing later in this article. For information about how to design mobile channels, see What's new with branding sites in SharePoint Server 2013 (http://go.microsoft.com/fwlink/p/?LinkId=255056).

Cross-site publishing

Cross-site publishing lets you store and maintain content in one or more authoring site collections, and display this content in one or more publishing site collections. When you change the content in an authoring site collection, those changes are displayed on all site collections that are reusing this content.

Cross-site publishing uses search technology to retrieve content. On a site collection where the Cross-Site Collection Publishing feature is enabled, libraries and lists have to be enabled as catalogs before the content can be reused in other site collections. For more information, see Catalog-enabled libraries and lists. The content of the library or list catalogs must be crawled and added to the search index. The content can then be displayed in a publishing site collection by using one or more Content Search Web Parts. For more information, see Content Search Web Part.

The following illustration shows how content is stored in an authoring site collection, indexed by the search system, and then reused across three separate publishing site collections (1:n).

Cross-site publishing diagram

  1. Content is created in libraries and lists that are shared as catalogs in the authoring site collection.

  2. The search system crawls the content and builds the search index.

  3. A user views a page on a publishing site, which triggers queries from Content Search Web Parts.

  4. Results are returned from the search index, and shown in Content Search Web Parts on the page.

Catalog-enabled libraries and lists

SharePoint Server 2013 has added the ability to designate any library or list as a catalog. After the Cross-Site Collection Publishing feature is enabled for a site collection, you can designate any library or list within that site collection as a catalog so that content can be reused on publishing site collections.

You can use catalog-enabled libraries or lists for scenarios such as an article library, knowledge base library, or product catalog. For example, in an Internet business scenario where a company is selling electronic products such as TVs and radios, the company can use one or more lists that are enabled as catalogs to share product information such as brand, color, and size as it applies to each product. By using cross-site publishing, this information can then be displayed in one or more publishing site collections.

Another example is an intranet scenario, where all knowledge base articles created in an organization can be written and stored in one or more libraries that are enabled as catalogs in a content site collection. By using cross-site publishing, different combinations of these knowledge base articles can be displayed on one or more publishing site collections — for example, based on how relevant the articles are for the different departments in the organization.

SharePoint Server 2013 includes a new publishing site collection template, the Product Catalog Site Collection, designed to author, store and maintain data that is used in a catalog scenario. By default, the Cross-Site Collection Publishing feature is automatically enabled in the Product Catalog Site Collection. However, you must still configure the catalog settings to share content with other site collections, just as you would with any other library or list.

When you connect a library or list that is enabled as a catalog to a publishing site collection, a result source is automatically created for this library or list. A result source narrows the scope from which the search results can be retrieved. That is, the result source created for a library or list is limited to content within this library or list. For example, you can use the automatically generated result source to limit a query in a Content Search Web Part. You can also copy a result source or change it to specify an even narrower search result scope.

Managed navigation

Managed navigation lets you define and maintain the navigation on a site by using term sets. Managed navigation supplements the existing SharePoint navigation that is based on site structure. You create the managed navigation structure by adding terms to term sets in the Term Store Management tool. You can copy the navigation term set and translate it into the same languages that are used for variations labels. For more information about terms and term sets, see Overview of managed metadata in SharePoint Server 2013.

You can combine portions of term sets from different site collections to create the navigation of a website. This can be valuable in an Internet business scenario in which you have a catalog of products. This is because you can use one term set for the navigation within product pages, and another term set for the navigation within non-product pages. Together, these term sets form the navigation for the whole site. For example:

  • In an authoring site collection, you create a term set for the navigation of the product pages. A term within this term set typically represents a product category — for example, Audio, Cameras, or Computers.

  • In the publishing site collection, you create a term set for the navigation of the non-product catalog pages. A term within this term set usually represents pages — for example, Home, About, or Careers.

  • By using cross-site publishing to display content from the authoring site collection in the publishing site collection, you can combine the terms from the two site collections to create the complete website navigation — in this example, Home, Audio, Cameras, Computers, About, and Careers.

Category pages

Category pages are page layouts that are used for displaying structured content such as catalog data. You can use category pages when you want to aggregate content that meets certain criteria or parameters. For example, in an intranet scenario, all company events are maintained in a list that is shared as a catalog. You want the information about each event to appear in the same manner — for example, with a title in bold, followed by information about when and where the event occurs. To avoid having to create one page for each event, you can create some category pages that can be used to display all events in the same manner.

Category pages are closely tied to managed navigation. This is because you can associate a category page with a specific term within the term set that is used for managed navigation. For example, in the company events scenario that was described earlier, you can have a term set in which the different departments are used for managed navigation. You can use two separate category page templates to display the different events. Category page 1 can be used to display all events related to the Marketing department, and Category page 2 can be used to display all events related to the Human Resources department.

Friendly URLs

By using managed navigation and category pages, the URLs of category pages can be built from the terms that you have specified in the term set, such as Computers or Marketing. For individual catalog items, you can specify that the URL consists of additional properties from the library or list that is shared as a catalog. This lets you create more meaningful, user-friendly URLs, instead of having URLs that consist of strings that do not make sense to users. In SharePoint Server 2010, the URLs for publishing sites included the name of the Pages library — for example, http://www.contoso.com/Pages/Computers.aspx#/ID=453&Source=http%3A%2F1010101. In SharePoint Server 2013, you can create URLs that are more user-friendly — for example http://www.contoso.com/Computers/model101.

Content Search Web Part

SharePoint Server 2013 has added a new Content Search Web Part that displays content that was crawled and added to the search index. To display content in the Content Search Web Part, you specify a query in the Web Part. This query is automatically issued, and it returns results from the search index when users browse to a page that contains the Content Search Web Part. The Content Search Web Part is especially powerful when it is used in combination with managed navigation and category pages. For example, in an Internet business scenario where a product catalog is displayed, a term within the term set specified for managed navigation is associated with a specific category page, as described earlier in Category pages. You can specify that a query in a Content Search Web Part on a category page use the current navigation category as part of the query. For example, when users browse to a category, such as Computers, a query is issued from the Content Search Web Part to return all items from the search index that are specified as Computers. Similarly, when users browse to the category Audio, the same Content Search Web Part on the same category page will display items in the search index that are specified as Audio.

Refiners and faceted navigation

Refiners are based on managed properties from the search index. Managed properties represent the specifications of the items in the catalog-enabled library or list — for example, Author, Date, Color, or Product Category. In a catalog scenario, you can add a Refinement Panel Web Part to a category page so that users can narrow the content as they browse through different pages. For example, in an Internet business scenario in which a catalog of mobile telephones is displayed, the managed property Color is set as a refiner. When a user views all mobile telephones in the catalog, all available colors are displayed in the Refinement Panel Web Part. When a user clicks a specific color, such as Gray, only mobile telephones with the color Gray are displayed. Similarly, in the scenario in which company events are displayed, the managed property Date is set as a refiner. In the Refinement Panel Web Part, users can see for which dates events are scheduled. When they click a particular date, they refine the results so that only events scheduled to occur on that date appear.

By using faceted navigation, you can configure different refiners for different terms in a term set. For example, in an Internet business scenario in which a product catalog is displayed, you can set the managed property Screen size as refiner for the term Computer, and the managed property Megapixels as refiner for the term Cameras. The faceted navigation guides users to content that is relevant for each specific category, and makes it easier and faster to browse through catalog content.

Analytics and recommendations

The new Analytics Processing Component in SharePoint Server 2013 runs different analytics jobs to analyze content in the search index and user actions that were performed on a site to identify items that users perceive as more relevant than others.

The new functionality for displaying content recommendations based on usage patterns uses the information from the analyses. By including recommendations on a page, you can guide users to other content that may be relevant for them. For example, you can guide users to popular items in a category or let them know that users who viewed this item also viewed another item.

The search recommendations framework works in the following way:

  • User actions produce usage events. When users interact with a SharePoint Server 2013 website — for example, when they click a link, press a button, or view a document — their actions are stored as usage events.

  • Usage events are counted and analyzed. The recommendations algorithm in the Analytics Processing Component counts and analyzes the usage events.

  • Information is added to the index.

    After processing in the Analytics Processing Component, the information is added to the search index and the Reporting database.

You can use search recommendations to do the following:

  • Add Recommended Items and Popular Items Web Parts to a site. In SharePoint Server 2013, you can display recommendations on a site by adding one or more Recommended Items Web Parts. You can configure the Web Part to display recommendations for the document or item that a user is viewing. For example, these recommendations can be displayed under the heading Users who viewed this document also viewed.

    You can use the Popular Items Web Part to display the most popular items that satisfy a set of criteria. For example, these recommendations can be displayed under the heading Most popular items in this category.

  • Get insights through reports. Information about usage events is displayed in Excel reports. You can use the reports to view user statistics to understand the traffic pattern on a website.

  • Act on insights. Based on the information in the reports, you can make decisions about how to fine-tune the website.

  • Monitor changes. The reports are updated based on the changes that are made, and you can monitor the effect of the changes.

Branding

New features for publishing sites in SharePoint Server 2013 minimize the special SharePoint knowledge that is required to successfully design and brand a SharePoint site. To brand a SharePoint site, designers just create a site design as they typically would, by implementing HTML, CSS, and JavaScript. Designers can create these files by using their design tool of choice, whether that is Adobe Dreamweaver, Microsoft Expression Web, or some other HTML editor. You don't have to use SharePoint Designer or Visual Studio 2012 to brand a SharePoint site. For information about how to brand sites in SharePoint Server 2013, see What's new with SharePoint 2013 site development (http://go.microsoft.com/fwlink/p/?LinkId=255056).

Device-specific targeting

SharePoint Server 2013 supports targeting different devices such as smartphones, tablets, and set-top boxes. Designers can create channels that allow a single publishing site to be rendered in multiple ways by using different designs that target different devices. For information about how to design channels, see What's new with SharePoint 2013 site development (http://go.microsoft.com/fwlink/p/?LinkId=255056). For information about additional optimizations for mobile support in SharePoint Server 2013, see What's new for mobile devices in SharePoint 2013.


What's new in workflow in SharePoint Server 2013
See also

Summary: Learn about the new components and concepts in SharePoint Server 2013 workflow.

Applies to: SharePoint Server 2013

SharePoint Server 2013 brings a major advancement to workflow: enterprise features such as fully declarative authoring, REST and Service Bus messaging, elastic scalability, and managed service reliability.

SharePoint Server 2013 can use a new workflow service built on the Windows Workflow Foundation components of the .NET Framework 4.5. This new service is called Workflow Manager and it is designed to play a central role in the enterprise. Processes are central to any organization and workflow is the orchestrator of processes.

In this article:

  • Two SharePoint workflow platforms

  • SharePoint Designer enhancements

  • Workflow Manager capabilities

  • Windows PowerShell cmdlets that manage workflow

Two SharePoint workflow platforms

The SharePoint 2010 Workflow platform has been carried forward to SharePoint Server 2013. All of your workflows that were built by using SharePoint Server 2010 will continue to work in SharePoint Server 2013.

In SharePoint Server 2010 the workflow engine installed automatically with the product. This continues to be the case with the SharePoint 2010 Workflow platform in SharePoint Server 2013. If you simply install SharePoint Server 2013 and do not install and configure Workflow Manager then you will have a nearly identical experience with building workflows as you did in SharePoint Server 2010.

The SharePoint 2013 Workflow platform only becomes available to you, and your tools, after you download and install the new Workflow Manager service and configure it to communicate with your SharePoint Server 2013 farm. For a detailed guide on this process, see How to: Set up and configure SharePoint 2013 workflows.

The figure illustrates the concept.

Figure: Architectural changes in SharePoint Workflow

Architectural changes in workflow

SharePoint Designer enhancements

SharePoint Designer 2013 includes new functionality designed specifically for Workflow Manager. In SharePoint Designer 2013 this new platform is known as the SharePoint 2013 Workflow platform. These new features include:

  • A visual workflow development experience that uses a Visio 2013 add-in

  • A new action that enables no-code web service calls from within a workflow

  • New actions for creating a task and starting a task process

  • New coordination actions that let you start a workflow built on the SharePoint 2010 Workflow platform from a workflow built on the SharePoint 2013 Workflow platform

  • A new Dictionary type

  • New workflow building blocks such as Stage, Loop, and App Step

When you create a workflow in SharePoint Designer 2013, you have the option of choosing the platform on which you wish to build a workflow in the workflow creation dialog as shown in the figure.

Create a workflow using SharePoint Designer 2013.

Workflow Manager capabilities

Workflow Manager brings a new class of workflow to SharePoint Server 2013. Workflows built by using Workflow Manager can take advantage of several new capabilities. These include enterprise features such as:

  • High Density and Multi-Tenancy

  • Elastic Scale

  • Activity / Workflow Artifact Management

  • Tracking and Monitoring

  • Instance Management

  • Fully Declarative Authoring

  • REST and Service Bus Messaging

  • Managed Service Reliability

To learn more about Workflow Manager, see Workflow Manager on MSDN.

Windows PowerShell cmdlets that manage workflow

As a SharePoint Server 2013 workflow administrator you should be familiar with Windows PowerShell. After you have installed the Workflow Manager service you will need to configure it to communicate with your SharePoint Server 2013 farm. This pairing is accomplished by using Windows PowerShell cmdlets. Windows PowerShell is used exclusively when you manage and monitor Workflow Manager.

See also

Getting started with SharePoint Server 2013 workflow

Workflow development in SharePoint Designer 2013 and Visio 2013
Workflow Manager


What's new in search in SharePoint Server 2013

Published: September 25, 2012

Summary: Learn about new search capabilities in SharePoint Server 2013, including ways to configure and monitor the system and improve search results.

Applies to: SharePoint Server 2013

In this article:

  • Search user interface improvements

  • Relevance improvements

  • Changes in crawling

  • Discovering structure and entities in unstructured content

  • More flexible search schema

  • Search health reports

  • New search architecture

Search user interface improvements

Without having to open each search result, users can quickly identify useful results in ways such as the following:

  • Users can rest the pointer over a search result to preview the document content in the hover panel to the right of the result.

  • Users can quickly distinguish search results based on their type. For example, Microsoft Office documents display the application icon in front of the title of the search result. Newsfeed conversation results display the number of replies and the number of likes to the right. Site results list the top links that users often click on the site. People in results show the picture and the Lync availability status to the left.

  • By default, certain types of related results are displayed in groups called result blocks. A result block contains a small subset of results that are related in a particular way. For example, results that are PowerPoint documents appear in a result block when the word "presentation" is one of the search terms. Administrators and site owners can also create result blocks to group other results. Like individual search results, you can promote result blocks or rank them with other results.

Search helps users quickly return to important sites and documents by remembering what they have previously searched and clicked. The results of previously searched and clicked items are displayed as query suggestions at the top of the results page.

In addition to the default manner in which search results are differentiated, site collection administrators and site owners can create and use result types to customize how results are displayed for important documents. A result type is a rule that identifies a type of result and a way to display it.

Site collection administrators and site owners can use display templates to customize the appearance of search results by using an HTML editor, and they can customize the behavior of search results by using JavaScript. They can specify display templates that determine how result types appear.

Relevance improvements

A search result, suggestion, or recommendation is more relevant when it better satisfies the intent of the person who issues the query. SharePoint Server 2013 improves relevance in areas such as freshness of search results, linguistics, and document parsing. It also improves relevance in the following areas:

  • New ranking models

  • Analysis of content and user interaction

  • Query rules

  • Result sources

New ranking models

SharePoint Server 2013 provides new ranking models for people search, intranet sites, and Internet sites. A ranking model determines recall (which items are displayed in the search results) and rank (the order in which search results are displayed).

Analysis of content and user interaction

The search system determines the relevance of search results in part by how content is connected, how often an item appears in search results, and which search results people click. The search system also determines which items users most commonly click in SharePoint. The new analytics component in SharePoint Server 2013 tracks and analyzes this information and uses it to continuously improve relevance.

Based on analytics information, site collection administrators and site owners can customize the user experience by adding Web Parts to display recommendations and popular items, or to display deep links, which link directly to sub-sections of a main page that are frequently visited.

The search service also uses analytics to compute data for search usage reports. Administrators can get these reports in a timely manner, even on large deployments.

Query rules

Without any custom code, Search service administrators, site collection administrators, and site owners can help searches respond to the intent of users by creating query rules. In a query rule, you specify conditions and correlated actions. When a query meets the conditions in a query rule, the search system performs the specified actions to improve the relevance of the search results. For example, you might specify a condition that checks whether the query matches a term in a SharePoint term set, or another condition that checks whether the query is frequently performed on a particular search vertical in your search system, such as Videos.

A query rule can specify the following types of actions:

  • Add Promoted Results (formerly called Best Bets) that appear above ranked results. For example, for the query "sick leave," a query rule could specify a particular Promoted Result, such as a link to a site that has a statement of company policy regarding time off work. These items were previously referred to as Best Bets in SharePoint 2010.

  • Add one or more result blocks. For example, for a query that contains "Fabrikam sales report," a query rule might use a taxonomy dictionary to recognize Fabrikam as a customer, and then display a result block with pertinent results about Fabrikam from a customer relationship management (CRM) system.

  • Change ranked results, such as by modifying their relevance. For example, for a query that contains "download toolbox," a query rule could recognize the word "download" as an action term and boost results from a particular download site on your intranet.

Result sources

In SharePoint Server 2010, scopes and federated locations provided ways to limit searches to a certain set of content or subset of search results. In SharePoint Server 2013, result sources replace scopes and federated locations.

You create and use a result source to specify a location from which to get search results and to specify a protocol for getting those results. In SharePoint Server 2010, you specified a location and a protocol by creating a federated location. In SharePoint Server 2010, you could specify the protocol as local SharePoint index, FAST Search Server 2010 for SharePoint index, or OpenSearch. In SharePoint Server 2013, you can specify the Source Type as local SharePoint index, remote SharePoint index, OpenSearch, or Microsoft Exchange Server index. If you specify remote SharePoint index as the Source Type, you do not have to supply any custom code to handle authentication, unlike in SharePoint Server 2010.

In a result source, you can also restrict queries to a subset of content by using a query transform. For example, the pre-defined "Local Video Results" result source uses a query transform to return only video results from the local SharePoint index. In SharePoint Server 2010, you configured this kind of query restriction by using search scopes.

On a search results page, you can expose results for queries on a particular result source in several ways, such as in a result block or in a dedicated Web Part.

In SharePoint Server 2010, only a Search service application administrator was able to create and configure federated locations. In SharePoint Server 2013, site collection administrators, site owners, and site designers can also create and configure result sources to meet their specific requirements.

Changes in crawling

SharePoint Server 2013 includes many changes and improvements related to crawling content.

Continuous crawl

In SharePoint Server 2013, you can configure crawl schedules for SharePoint content sources so that crawls are performed continuously. Setting this option eliminates the need to schedule incremental crawls and automatically starts crawls as necessary to keep the search index fresh. Administrators should still configure full crawls as necessary. For more information, see Manage continuous crawls in SharePoint Server 2013.

Host distribution rules removed

In SharePoint Server 2010, host distribution rules are used to associate a host with a specific crawl database. Because of changes in the search system architecture, SharePoint Server 2013 does not use host distribution rules. Instead, Search service application administrators can determine whether the crawl database should be rebalanced by monitoring the Databases view in the crawl log.

Removing items from the search index

In SharePoint Server 2010, Search service application administrators could remove items from the search index by using Search Result Removal. In SharePoint Server 2013, you can remove items from the search index only by using the crawl logs.

Discovering structure and entities in unstructured content

You can configure the crawler to look for "entities" in unstructured content, such as in the body text or the title of a document. These entities can be words or phrases, such as product names. To specify which entities to look for in the content, you can create and deploy your own dictionaries. For companies, you can use the pre-populated company extraction dictionary that SharePoint Server 2013 provides.

You can store these entities in your search index as separate managed properties and use those properties later — for example, in search refiners.

To improve search relevance, the document parsing functionality in the content processing component analyzes both the structure and content of documents. Document parsers extract useful metadata and remove redundant information. For example, parsers extract headings and subheadings from Word documents, and titles, dates, and authors from slides in PowerPoint presentations. For HTML content, redundant generic information such as menus, headers, and footers are classified as such and removed from document summaries in the search results.

More flexible search schema

By defining crawled properties, managed properties, and the mappings between them, the search schema determines how the properties of crawled content are saved to the search index. Crawled properties and how these are mapped to managed properties define how to transform crawled content into managed properties. The search index stores the contents of the managed properties. The attributes of the managed properties determine the search index structure.

SharePoint Server 2013 introduces new attributes that you can apply to managed properties, such as sortable and refinable. The sortable attribute reduces the time that is required to return large search result sets by sorting results before they are returned. The refinable attribute enables you to create a refiner based on a particular managed property.

In SharePoint Server 2013, you can have multiple search schemas. The main search schema is defined at the Search service application level. Site collection administrators can create customized search schemas for different site collections.

For more information, see Manage the search schema in SharePoint Server 2013.

Search health reports

SharePoint Server 2013 provides many query health reports and crawl health reports. In SharePoint Server 2010 and FAST Search Server 2010 for SharePoint, similar reports were called Search Administration Reports. For more information, see View search diagnostics in SharePoint Server 2013.

New search architecture

SharePoint Server 2013 introduces a new search architecture that includes significant changes and additions to the search components and databases. For examples and more information, see the Search technical diagrams in Technical diagrams for SharePoint 2013.


Changes from SharePoint 2010 to SharePoint 2013
See also

Summary: Learn about the features and functionality that are deprecated in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes the features in SharePoint 2010 Products that have been deprecated or removed from SharePoint 2013. Deprecated features are included in SharePoint 2013 for compatibility with previous product versions. These features will be removed in the next major release of SharePoint Products.

Important:

The information in this article applies to both SharePoint Foundation 2013 and SharePoint Server 2013.

In this article:

  • Features deprecated in SharePoint 2013

  • SharePoint Foundation 2010 deprecated search features

  • SharePoint Server 2010 deprecated search features

  • FAST Search Server 2010 for SharePoint deprecated features

Features deprecated in SharePoint 2013

The following features and functionality have been deprecated or changed in SharePoint 2013.

Visual upgrade

Description: The visual upgrade feature in SharePoint Server 2010 is not available in SharePoint 2013. For the upgrade from Office SharePoint Server 2007 to SharePoint Server 2010, you could choose to use the visual upgrade feature to give site collection owners and site owners the opportunity to preserve the previous user interface temporarily while still upgrading the infrastructure and databases, site collections, and features to the latest version. This allowed site collection owners and site owners to update customizations to work in the new user interface. Once the database and site collection upgrade was complete, the user had the option to upgrade the user interface on a more granular level of the website (SPWeb object).

Reason for change: The visual upgrade feature is replaced with deferred site collection upgrade. The site collection upgrade process is not reversible. The deferred site collection upgrade is a more comprehensive upgrade process than visual upgrade.

Visual upgrade preserved only the old master pages, CSS files, and HTML files. Deferred site collection upgrade preserves much more, including SPFeature functionality. To achieve the deferred site collection upgrade, major changes in the architecture were required, including the removal of visual upgrade.

With deferred site collection upgrade, you can continue to use the UI from the previous version (SharePoint Server 2010) more seamlessly than is possible with visual upgrade. The master page, CSS, JScript, and SPFeatures will remain in SharePoint Server 2010 mode. One key difference is that the granularity of upgrading the user interface is per site collection (SPSite) instead of site (SPWeb). Users can still preview their site in the new SharePoint 2013 user interface before committing. However, this is accomplished by creating and upgrading a temporary copy of their site collection instead of a preview in the existing instance of the site collection. The reason for previewing a copy of the site collection is because of the complexity of what occurs during site collection upgrade. Once a site collection is upgraded, it cannot be rolled back. Therefore, performing a preview would not be possible except in a copy of the site collection.

Migration path: Site collection administrators who are using visual upgrade to continue to use SharePoint Server 2007 must move to the SharePoint Server 2010 user interface before upgrading to SharePoint 2013. After the content database is upgraded, users can use deferred site collection upgrade to continue to use the SharePoint Server 2010 experience for their site collections. Site collection administrators can be notified by their farm administrator when a site collection is ready for upgrade and the site collection administrators can then choose to either perform the upgrade of their site collection or optionally first preview the new functionality in a temporary copy of their site collection.

Any SharePoint user interface might have dependencies on visual upgrade. The main dependency was getting the user interface version and then outputting the correct user interface (new or legacy). The visual upgrade API feature is updated so that the user interface version is remapped to the new site collection compatibility level property. This returns the same information about which version the site uses as before. Therefore, dependent code does not need to change.

Document Workspace site template

Description: When you create a site in SharePoint 2013, the Document Workspace site template is not available.

Reason for change: The scenario of collaborating on a document is now provided by the Team Site site template. The Document Workspace site template was removed from SharePoint 2013 to simplify the list of templates that are available when a user creates a new site collection.

Migration path: Existing sites that were created by using the Document Workspace site template will continue to operate in SharePoint 2013. The Document Workspace site template will be removed completely from the next major release of SharePoint and sites that were created by using the Document Workspace site template will not be supported.

Personalization Site site template

Description: When you create a site in SharePoint 2013, the Personalization Site site template is not available.

Reason for change: The Personalization Site site template was not a widely used site template. The Personalization Site site template was removed from SharePoint 2013 to simplify the list of templates that are available when a user creates a new site collection.

Migration path: Existing sites that were created by using the Personalization Site site template will continue to operate in SharePoint 2013. The Personalization Site site template will be removed completely from the next major release of SharePoint and sites that were created by using the Personalization Site site template will not be supported.

Meeting Workspace site templates

Description: When you create a site in SharePoint 2013, all five of the Meeting Workspace site templates are not available. This includes the Basic Meeting Workspace, Blank Meeting Workspace, Decision Meeting Workspace, Social Meeting Workspace, and Multipage Meeting Workspace. In addition, the integration with Meeting Workspaces has been removed from Outlook 2013, and the commands to create a Meeting Workspace in Outlook 2013 have been removed from the Quick Access Toolbar and the Ribbon.

Reason for change: SharePoint 2013 and Office 2013 provide other features that support meetings and collaboration. For example, you can use Lync to conduct live meetings, OneNote to take notes during meetings, and a SharePoint team site or My Site to store shared meeting notes.

Migration path: Sites created using the Meeting Workspace site templates that are upgraded to the SharePoint 2013 user experience will no longer operate in SharePoint 2013. In the event continued use is necessary while a migration plan is determined, sites using the Meeting Workspace site template should be operated in SharePoint 2010 mode. Client integration features when operating in SharePoint 2010 mode require a 2010 version of the Microsoft Office client. The Meeting Workspace site templates will be removed completely from the next major release of SharePoint and sites that were created by using the Meeting Workspace site templates will not be supported.

Group Work site template and Group Work solution

Description: When you create a site in SharePoint 2013, the Group Work site template is not available. This Group Work site template provides a groupware solution that teams can use to create, organize, and share information. The Group Work site template includes the Group Calendar, Circulation, Phone-Call Memo, document library, and other basic lists. The Group Work site template and the Group Work solution are discontinued and not available in SharePoint 2013.

Reason for change: The Group Work site template was not a widely used site template. The Group Work site template was removed from SharePoint 2013 to simplify the list of templates that are available when a user creates a new site collection.

Migration path: Existing sites that were created by using the Group Work site template will continue to operate in SharePoint 2013. The Group Work site template will be removed completely from the next major release of SharePoint and sites that were created by using the Group Work site template will not be supported.

Visio Process Repository site template

Description: When you create a site in SharePoint 2013, the Visio Process Repository site template will continue to be available. However, the Visio Process Repository site template will be removed in the next major release of SharePoint.

Reason for change: The Visio Process Repository site template is not a widely used site template. The Visio Process Repository site template was removed from SharePoint 2013 to simplify the list of templates that are available when a user creates a new site collection.

Migration path: Not required. The Visio Process Repository site template is available in SharePoint 2013.

Unghosting and customizing CSS files

Description: The following methods are included in SharePoint 2013, but will be removed from the next major release of SharePoint:

  • Microsoft.SharePoint.SoapServer.Webs.CustomizeCss

  • Microsoft.SharePoint.SoapServer.Webs.RevertCss

The Webs.CustomizeCss method applies style sheet customization to a particular file.

The Webs.RevertCss method reverts style sheet customization of a file to the default style sheet.

These two methods are stored in Webs.asmx.cs and are defined in Webswsdl.asps.

Reason for change: The methods are outdated and are no longer needed.

Migration path: None.

Imaging Web service

Description: The Imaging Web service provides functionality for creating and managing picture libraries. The Imaging Web service will be removed from the next major release of SharePoint. The Imaging Web service is included and supported in SharePoint 2013.

Reason for change: The Imaging Web service is not widely used. The only client application for the Imaging Web service, Office Picture Manager, is no longer included with SharePoint 2013. The Imaging Web service is being removed to reduce security vulnerabilities and to simplify the number of ways to connect to SharePoint 2013.

Migration path: All the functionality of the Imaging Web service is available through the client-side object model (CSOM). The CSOM provides client-side applications with access to a subset of the SharePoint Foundation server object model, including core objects such as site collections, sites, lists, and list items. Also, Web Distributed Authoring and Versioning (WebDAV) provides clients with key functionality of the Imaging Web service (for example, upload, download, and rename).

Excel Services — Can't edit workbooks in the browser that have external data connections

Description: Workbooks with external data connections that use Windows authentication cannot be refreshed in the browser. Instead, you are prompted to open the workbook in the Excel client program. Workbooks that have database or Windows credentials stored either in the Secure Store Service or in the connection string can still be edited in the browser. This change applies only when Excel Web App in Office Web Apps Server is used to view workbooks, not when Excel Services in SharePoint Server 2013 is used.

Reason for change: This is a design limitation in SharePoint 2013.

Migration path: You can still refresh these workbooks in the Excel client program. Additionally, a service application administrator can configure that workbooks are viewed in SharePoint 2013 instead of Office Web Apps Server.

Web Analytics in SharePoint Server 2010

Description: Web Analytics in SharePoint Server 2010 has been discontinued and is not available in SharePoint 2013. Analytics processing for SharePoint 2013 is now a component of the Search service.

Reason for change: A new analytics system was required for SharePoint 2013 that included improvements in scalability and performance, and that had an infrastructure that encompasses SharePoint Online. The Analytics Processing Component in SharePoint 2013 runs analytics jobs to analyze content in the search index and user actions that are performed on SharePoint sites.

SharePoint 2013 still logs every click in SharePoint sites and still provides a count of hits for every document. User data is made anonymous early in the logging process and the Analytics Processing Component is scalable to the service.

This analytics data is used in SharePoint 2013 to provide new item-to-item recommendation features, to show view counts that are embedded in SharePoint 2013 and Search Server user interface, to provide a report of the top items in a site and list, and to influence the relevancy algorithm of search.

What happens to Web Analytics after upgrade: The Web Analytics Service is not upgraded to the Analytics Processing Component in SharePoint 2013. When you upgrade to SharePoint 2013, the databases that contain the data from Web Analytics in SharePoint Server 2010 are not removed. These databases are not used by or maintained by the Analytics Processing Component in SharePoint 2013. This means that documents on sites in SharePoint Server 2010 that are upgraded will show a hit count of 0.

When you upgrade to SharePoint 2013, do not attach and upgrade the databases that contain the data from Web Analytics in SharePoint Server 2010. We recommend that you turn off Web Analytics in the SharePoint Server 2010 environment before you copy the content databases that you want to upgrade to SharePoint 2013.

Reports from Web Analytics for the top items in a site are carried forward. Reports that show browser traffic, top users of a site, and referring URL are not carried forward and are not used by the Analytics Processing Component in SharePoint 2013.

Administrative reports for the quota usage of site collections in the farm are not available in SharePoint 2013.

SharePoint 2013 does not support the Web Analytics Web Part. After a farm is upgraded to SharePoint 2013, all instances of a Web Analytics Web Part will not function. The page that includes the Analytics Web Part will render and a message appears that informs the user that the Web Part is no longer supported.

Migration path: None. Data collection for Analytics Processing in SharePoint 2013 starts immediately for sites, including SharePoint Server 2010 sites.

Excel Services — Can't edit workbooks in the browser that have external data connections

Description: Workbooks with external data connections that use Windows authentication cannot be refreshed in the browser. Instead, you are prompted to open the workbook in the Excel client program. Workbooks that have database or Windows credentials stored either in the Secure Store Service or in the connection string can still be edited in the browser. This change applies only when Excel Web App in Office Web Apps Server is used to view workbooks, not when Excel Services in SharePoint Server 2013 is used.

Reason for change: This is a design limitation in SharePoint 2013.

Migration path: You can still refresh these workbooks in the Excel client program. Additionally, a service application administrator can configure that workbooks are viewed in SharePoint 2013 instead of Office Web Apps Server.

Organization Profiles

Description: The Organization Profiles feature is deprecated in SharePoint Server 2013. Organization Profiles contain detailed information about an organization such as teams, divisions, and other information that describes the organization's hierarchy.

Reason for change: SharePoint features related to identities continue to evolve around the core concepts of users and groups, and SharePoint will not be investing further in OrgID.

Migration path: Existing solutions based on Organization Profiles will continue to operate in SharePoint 2013. The Organization Profiles feature will be removed completely from the next major release of SharePoint, and solutions created by using Organization Profiles will not be supported.

SharePoint Foundation 2010 deprecated search features

The following functionality has changed in SharePoint Foundation search.

Search capabilities

Description: The search capabilities of SharePoint Foundation 2013 have changed, and are now based on the same search implementation as SharePoint Server. This provides many improvements, but also means that the search configuration is very different.

Reason for change: Alignment of basic capabilities between SharePoint Server and SharePoint Foundation.

Migration path: No migration of search settings is supported.

SharePoint Server 2010 deprecated search features

The following section provides details about the deprecated search features in SharePoint Server.

Modifying the search topology using a web-based interface

Description: SharePoint 2013 uses the web-based interface to show the current status of the topology. You change the topology by using Windows PowerShell. SharePoint Server 2010 also included a web-based option for changing the topology.

Reason for change: The core search architecture of SharePoint 2013 has a more complex and flexible topology that can be changed more efficiently by using Windows PowerShell.

Migration path: Use Windows PowerShell to modify the search topology.

Diacritic sensitivity element in the thesaurus

Description: In SharePoint Server 2010, thesaurus files contain a <diacritics_sensitive> element. This element determines whether diacritical marks such as accents should be ignored or applied by the search system when expanding a query with terms from the thesaurus. By default, the <diacritics_sensitive> element is set to zero to ignore diacritical marks.

In SharePoint 2013, the <diacritics_sensitive> element is not available. Instead, diacritical marks are always respected when matching query terms with terms in the thesaurus.

Diacritic variants are not automatically matched with query terms. Therefore, fewer query terms might be expanded by synonyms. For example, the thesaurus entry <munchen> is not matched with the query term <münchen>.

Reason for change: The feature has limited usage. The same behavior as in SharePoint Server 2010 can be achieved by adding diacritic variants in the thesaurus.

Migration path: Update the thesaurus dictionaries that are tagged as diacritic insensitive. To update thesaurus dictionaries, add diacritic variations of the relevant terms.

Replacement mode within the thesaurus

Description: The thesaurus replacement mode is deprecated in SharePoint 2013.

In SharePoint Server 2010, you can classify entries in the thesaurus as expansions that are added to the query in addition to the original term. Likewise, you can classify entries as replacements of the original term in a query.

In SharePoint 2013, thesaurus replacements are no longer supported. All entries in the thesaurus are expansions, and the original term is not removed from the query. The original query term is always evaluated when you search the index. You cannot remove synonyms or words from the index.

Reason for change: The feature has limited usage, and may also have unwanted side-effects for relevance.

Migration path: No equivalent feature.

Search Query web service

Description: The Search Query web service is deprecated in SharePoint 2013.

In SharePoint Server 2010, the Search Query web service exposes the SharePoint Enterprise Search capabilities to client applications. This enables you to access search results from client and web applications outside the context of a SharePoint site.

Reason for change: The Search Query web service is deprecated because the client object model (CSOM) and a new REST-based web service are available for developing Office-wide extensibility scenarios. The CSOM exposes the same functionality as the Search Query web service, and a larger set of functionality for stand-alone client applications.

Migration path: Change custom search solutions to use the CSOM or REST-based web service instead of using the Search Query web service.

Search RSS and search from Windows

Description: The search RSS feature is deprecated in SharePoint 2013. The functionality for performing enterprise searches from Windows 7 depends on search RSS and this element has also been deprecated in SharePoint 2013.

The RSS link no longer appears on the results page. This link is replaced by the Search Alerts link.

Before upgrading site collections to SharePoint 2013, you can continue to use RSS in the SharePoint 2010 version of the Search Center. However, after you upgrade the Search Center to SharePoint 2013, the RSS is no longer available. In SharePoint 2013, you can create custom RSS feeds that use the client object model (CSOM), which targets the needs of your particular application and the RSS readers.

Reason for change: Most RSS readers that are available do not support claims authentication. In SharePoint 2013, claims authentication is the default authentication model. By using claims authentication, RSS readers work while the authentication cookie is cached. However, after the cookie expires, RSS readers cannot refresh their authentication, and so they stop working.

Migration path: After migrating a site to SharePoint 2013, you can create search-based alerts to be notified of changes to search results. You can also create a custom RSS feed in SharePoint document libraries, by using the UX extensibility platform.

Custom word breaker dictionaries

Description: The format of the custom word breaker dictionaries has changed in SharePoint 2013. In SharePoint 2013, you can only create one language-independent dictionary. In SharePoint Server 2010, you can create language-specific custom dictionaries (one dictionary for each language) to edit the word breaker behavior of enterprise search. The word breaker behavior for East Asian (CJK) languages has not changed in SharePoint 2013.

In SharePoint 2013, custom word breaker dictionaries from earlier versions of SharePoint Server are not supported.

Reason for change: The search processing framework for SharePoint 2013 is new, and the way the word breakers operate has changed.

Migration path: You must combine existing custom dictionaries into one language-independent dictionary.

Configuration of stemming in the registry

Description: The configuration of stemming in the registry is no longer supported in SharePoint 2013. Modifying stemming entries in the registry has no effect during search. In SharePoint Server 2010, you can turn stemming on or off, or you can replace it with a third-party stemmer by changing the registry. In SharePoint 2013, you cannot use a third-party stemmer.

Reason for change: This feature has limited feature usage.

Migration path: There is no migration path available for custom stemmers. You can enable or disable stemming in the Search Result Web Part.

SharePoint Search SQL syntax

Description: In SharePoint Server 2010, you could construct complex search queries by using SQL syntax.

Search in SharePoint 2013 supports FAST Query Language (FQL) syntax and Keyword Query Language (KQL) syntax for custom search solutions. You cannot use SQL syntax in custom search solutions.

Custom search solutions that use SQL syntax with the Query object model and the Query web service that were created in earlier versions of SharePoint Serverdo not work when you upgrade them to SharePoint 2013. If you submit queries by using these applications, you will receive an error.

Reason for change: The core search architecture has changed in SharePoint 2013, and the SQL syntax is no longer supported.

Migration path: Change current search solutions to use either the KQL syntax or FQL syntax for queries.

Shallow search refiners

Description: SharePoint Server Search in Office 2010 supported shallow search refiners. FAST Search Server 2010 for SharePoint supports shallow refiners and deep refiners. InSharePoint 2013, only deep search refiners are supported.

We recommend that you use deep search refiners to refine searches. In SharePoint 2013, deep refiners are an improvement to the existing FAST Search Server 2010 for SharePoint functionality. For example, the resource usage for each refiner is improved in SharePoint 2013.

In SharePoint 2013, you can view refiners as you did in the earlier version of the product. However, the refiners are now computed differently. They are created based on index structures that are aggregated across the full result set.

Reason for change: The shallow search refiners are replaced with an improved implementation of deep search refiners.

Migration path: No specific migration steps are necessary.

FAST Search Server 2010 for SharePoint deprecated features

The following section provides details about the deprecated features in FAST Search Server 2010 for SharePoint.

FAST Search database connector

Description: The FAST Search database connector is not supported in SharePoint 2013.

Reason for change: The connector framework for SharePoint 2013 is combined with the BCS framework and the Business Data Catalog connectors.

Migration path: Replace the FAST Search database connector with the Business Data Catalog-based indexing connectors in the BCS framework.

FAST Search Lotus Notes connector

Description: The FAST Search Lotus Notes connector is not supported in SharePoint 2013.

The Lotus Notes indexing connector (BCS framework) provides similar functionality as the FAST Search Lotus Notes connector. The FAST Search Lotus Notes connector supports the Lotus Notes security model. This includes Lotus Notes roles, and lets you crawl Lotus Notes databases as attachments.

Reason for change: The connector framework for SharePoint 2013 is combined with the BCS framework and the Business Data Catalog connectors.

Migration path: Replace the FAST Search Lotus Notes connector with the Lotus Notes indexing connector, or with a third-party connector.

FAST Search web crawler

Description: The FAST Search web crawler is not supported in SharePoint 2013.

The SharePoint 2013 crawler provides similar functionality to the FAST Search web crawler.

Reason for change: The crawler capabilities are merged into one crawler implementation for consistency and ease of use.

Migration path: Use the standard SharePoint 2013 crawler. The following table explains the differences between the FAST Search web crawler and the SharePoint 2013 Preview crawler, and provides details about migration.

Feature FAST Search web crawler SharePoint 2013 crawler Migration path

Refeed documents

You can refeed documents that you have previously downloaded to the index without having to recrawl them.

You can perform a full recrawl with similar functionality, but with slightly decreased performance of feeds.

None.

Extract dynamically generated links and content from Java

You can extract dynamically generated links and content from JavaScript.

No longer supported.

None.

Language-focused crawls

You can extract dynamically generated links and content from JavaScript. You can perform crawls focused on language.

You can focus a crawl on a certain language, by only following links from and storing content for documents that match specific languages.

This feature is intended for large scale crawls that target specific languages but that do not limit the crawl to a top level domain.

No longer supported.

None.

Modify URIs

You can modify the URIs before crawling them.

Such a modification of the URI enables you to remove certain features of the URI, such as dynamic components, and to rename host names.

You can apply prefix-type URI rewriting with the "Server name remapping" feature in Search Admin. This allows you to perform the most relevant modifications of the URI.

None.

Find similar results

Description: The Find similar results feature is not available in SharePoint 2013. The Find similar results feature is supported in FAST Search Server 2010 for SharePoint to search for results that resemble results that you have already retrieved.

Reason for change: The Find similar results feature is available only within the query integration interfaces, and it does not consistently provide good results in many scenarios.

Migration path: There is no migration path available.

FAST Query Language (FQL) deprecated features

Description: The FQL features are aligned with the features of the SharePoint Keyword Query Language (KQL) syntax

The following table describes the FAST Query Language (FQL) features that are deprecated in SharePoint 2013.

FQL operator or feature Changed behavior in SharePoint 2013

ANY operator

This operator has the same effect as the OR operator.

RANK operator

This operator is accepted but does not affect result ranking.

XRANK operator

This operator has a new and more flexible syntax.

The old syntax is deprecated.

The boost parameter is mapped to the new cb parameter. The boostall parameter is ignored.

STRING operator

The N parameter is accepted but ignored.

The MINEXPANSION/MAXEXPANSION parameters are not supported.

The ANNOTATION_CLASS parameter is not supported.

For the MODE parameter, the following arguments are deprecated, and have the following behavior:

  • ANY: Equal to the OR mode.

  • NEAR/ONEAR: Equal to the AND mode.

  • SIMPLEALL/SIMPLEANY: The query string argument is evaluated according to the KQL query syntax.

Implicit typing of numeric data types

The FQL parser is not search schema-aware, and some implicit numeric data typing is no longer supported.

Reason for change: To simplify the query syntax, some redundant syntax features were removed from SharePoint 2013.

Migration path: The following table describes what to replace the deprecated FQL operators or features with.

Replace this FQL operator or feature | With
ANY operator | WORDS operator
RANK operator | XRANK operator
XRANK operator | New syntax
STRING operator | For proximity operations, use the NEAR/ONEAR operators. For mapping of end-user query text, use the KQL mode.
Numeric data types | Type numeric data explicitly. Use either the int/float/decimal operators, or consistently use decimal/float syntax (with decimals always included) in the query.

URL Query syntax

Description: In FAST Search Server 2010 for SharePoint, the URL-related managed properties (such as site, or path) are tokenized as a text string, and you can query any subpart of the URL. This includes STARTS-WITH, ENDS-WITH, PHRASE and proximity queries on URL properties. Special characters such as "/", "_" and "-"are handled as word delimiters.

In SharePoint 2013, the entire URL is tokenized as one word. This includes special characters such as "/", "_" and "-". You can query these managed properties by:

  • Searching for the full string for the site or path.

  • Searching for the leading part of the site or path.

  • Omitting the protocol part (http, https), and omitting the leading part of the domain address in the query expression, for the site managed property.

Reason for change: The implementation in SharePoint 2013 is aligned with SharePoint Server 2010 search. The FAST Search Server 2010 for SharePoint implementation has a very high query performance cost, especially when you search for the full URL or a leading subset of the URL.

Migration path: The following table provides details on how to change FAST Search Server 2010 for SharePoint query expressions to match the SharePoint 2013 URL query syntax.

To match Then

The complete URL string

Search for the exact string. Special characters in the URL must match. Do not use the PHRASE operator.

The leading part of the URL

Do not use the wildcard character.

Any part of the URL

  • Map the relevant crawled property to an additional managed property of type text.

  • Use this managed property as a property filter in your query.

Specific search scope filters

Description: In SharePoint 2013, search scopes are automatically converted to result sources.

In FAST Search Server 2010 for SharePoint, you can specify additional filtering conditions for search scopes, as described in the following table:

Filter(s) | Description
FQL scope | These filters may contain FQL syntax. In SharePoint 2013, you can use migrated FAST Search scope filters, but you cannot change them.
Alternative full-text index for the query | This filter provides a non-default full-text index for the full-text part of the queries. In SharePoint 2013, you can use migrated FAST Search scope filters that contain an alternative full-text index. However, you cannot change or convert these filters to result sources.

Reason for change: The search scope functionality was replaced by a more powerful functionality for result sources. For more information, see Configure result sources for search.

Migration path: You must convert FQL scope filters to corresponding result sources. You can use an alternative full-text index in the query syntax.

Anti-phrasing

Description: The search anti-phrasing feature in FAST Search Server 2010 for SharePoint is not supported in SharePoint 2013.

Anti-phrasing removes phrases that do not have to be indexed from queries, such as "who is", "what is", or "how do I". These anti-phrases are listed in a static dictionary that the user cannot edit.

In SharePoint 2013, such phrases are not removed from the query. Instead, all query terms are evaluated when you search the index.

Reason for change: The FAST Search Server 2010 for SharePoint feature has limited usage due to the limited number of customization options.

Migration path: None.

Offensive content filtering

Description: The filtering of offensive content in search is deprecated in SharePoint 2013.

In FAST Search Server 2010 for SharePoint, you can choose to filter offensive content. Offensive content filtering is not enabled by default.

In SharePoint 2013, you can no longer block documents that contain potentially offensive content from being indexed.

Reason for change: The feature has limited usage.

Migration path: None.

Substring search

Description: The substring search feature was removed in SharePoint 2013.

In FAST Search Server 2010 for SharePoint, substring search (N-gram indexing) can be used in addition to the statistical tokenizer in East Asian languages. Substring search can be useful for cases in which the normal tokenization is ambiguous, such as for product names and other concepts that are not part of the statistical tokenizer.

Reason for change: The feature has limited usage, and has very extensive hard disk requirements for the index.

Migration path: None.

Person names and location extractions

Description: In SharePoint 2013, you cannot extract person names and locations from documents by using predefined extractors.

In SharePoint 2013, you can create custom extractors to extract person names and locations. The difference between the predefined extractors in FAST Search Server2010 for SharePoint, and custom extractors in SharePoint 2013, is that custom extractors are only based on dictionary entries, whereas the predefined extractors also use extraction rules.

Reason for change: This feature has limited usage and usually requires extensive customization. In most cases, we recommend that you use customer-specific dictionaries.

Migration path: Use custom extractors for person names and locations.

Number of custom entity extractors

Description: In SharePoint 2013, the number of custom entity extractors that you can define is limited to 12.

In FAST Search Server 2010 for SharePoint Service Pack 1 (SP1), you can define an unlimited number of custom extractors. You can use custom entity extractors to populate refiners on the search result page.

There are 12 predefined custom entity extractors in SharePoint 2013:

  • Five whole-word case-insensitive extractors

  • Five word-part case-insensitive extractors

  • One whole-word case-sensitive extractor

  • One word-part case-sensitive extractor

Reason for change: By using a predefined set of custom entity extractors, the content processing architecture is more simple and easier to use.

Migration path: Use the predefined set of custom entity extractors.

Supported document formats

Description: SharePoint 2013 no longer supports rarely used and older document formats that are supported in FAST Search Server 2010 for SharePoint by enabling the Advanced Filter Pack. Both the ULS logs and the crawl log indicate the items that were not crawled.

In SharePoint 2013, the set of supported formats that are enabled by default is extended, and the quality of document parsing for these formats has improved.

Reason for change: The file formats for indexing are older formats and are no longer supported.

Migration path: You can work with partners to create IFilter-based versions of the file formats that can no longer be indexed.

Content processing extensibility

Description: The FAST Search Server 2010 for SharePoint content processing extensibility feature has changed in SharePoint 2013. Content processing prepares an item from a content source for indexing and searching. The FAST Search Server 2010 for SharePoint content processing extensibility feature uses a sandbox where your custom code runs. See http://msdn.microsoft.com/library/ff795801.aspx on MSDN, FAST Search, for more information.

SharePoint 2013 provides a new web service interface for content processing extensibility.

The new implementation of this feature has the following improvements:

  • The web service callout provides more flexibility about where the custom code runs than it does with the sandbox callout.

  • You can define triggers for the web service callout to optimize performance.

  • Content processing is performed on managed properties instead of on crawled properties. This makes it simpler to manage the items that are changed.

Reason for change: The content processing architecture of search has changed to improve performance and flexibility.

Migration path: To integrate with the new SharePoint content processing component, you must change the code. The custom content processing code must be packaged as a web service.

Custom XML item processing

Description: FAST Search Server 2010 for SharePoint includes a custom XML item processing feature as part of the content processing pipeline. Custom XML item processing is not supported in SharePoint 2013.

Reason for change: In SharePoint 2013, the content processing architecture has changed. Custom XML item processing was removed and we recommend that you implement a mapping functionality outside SharePoint.

Migration path: Custom XML item processing can be performed outside the content processing pipeline, for example by mapping XML content to a SharePoint list, or to a database table.

Adding a test item to the index

Description: DocPush is a test and diagnostic command-line tool that submits test documents to the FAST Search Server 2010 for SharePoint index. A similar command-line tool is not available in SharePoint 2013.

Reason for change: The administration and diagnostics of feeding and crawling has changed in SharePoint 2013.

Migration path: None. You can create test documents or test lists in SharePoint to test crawling and feeding. To remove items from the search index or to verify that there are any errors on an item, you can use the crawl log. See View search diagnostics in SharePoint Server 2013 for more information.

To remove items from the search results, use the Search Result Removal feature in Queries and Results. See Delete items from the search index or from search results in SharePoint Server 2013.

See also

Explore SharePoint 2013


Overview of identity management in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn how SharePoint 2013 supports authentication, authorization, and the storage, synchronization, and display of entities and their attributes.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Identity management in SharePoint 2013 is the combination of the following parts:

  • The set of identifiers for entities, their storage location, the creation of trust relationships among identity stores, and the display of identifier information.

    Users, computers, or services are examples of entities.

  • The methods, typically provided by a form of credential exchange that is protected with cryptography, that use identifiers to authenticate access to a resource.

  • The methods, typically specified by a set of permissions that are assigned to identifiers, that specify and enforce the authorization of access to a resource.

Elements of an identity management system

A typical identity management system consists of the following elements:

  • Entities

  • Stores for accounts and attributes

  • Authentication methods

  • Authorization methods

  • Storage, synchronization, and display of entity attributes

The following sections describe these elements and how SharePoint 2013 supports them.

Entities

Within an identity management system, an entity represents a physical or logical object that requires access to a resource. Entities on a network that uses Active Directory Domain Services (AD DS) include users, computers, and services. Each entity has an identity that can correspond to an account in a directory, such as AD DS. Accounts can consist of a set of attributes that describe the entity, such as name, group membership, email address, and so on.

For identity management in SharePoint 2013, entities are users, groups, services, computers, and apps.

Stores for accounts and attributes

A store that contains accounts and attributes provides a location for entity accounts and their attributes. Networks that use AD DS store accounts and attributes in AD DS. The store that contains accounts and attributes can do the following:

  • Validate account credentials during authentication.

  • Provide account attributes to the entity that requests authentication so that those attributes can be used for authorization.

SharePoint 2013 can use the forms-based or Security Assertion Markup Language (SAML) user authentication methods for AD DS or additional stores. SharePoint 2013 does not include a store for accounts and attributes.

Identity federation is the process that links multiple stores of accounts and attributes through trust relationships so that authentication and authorization for access to resources can occur seamlessly across those stores. Forefront Identity Manager 2010 R2 enables you to manage identity life cycle and role management across heterogeneous identity platforms.

Methods of authentication

An authentication method is a specific set of messages that computers send to each other to perform authentication. A message validates an identity of an entity. The result of the authentication process is a security token, which typically contains cryptographic proof that a store of accounts and attributes has validated the identity. The security token can also contain entity attributes, such as the list of security groups to which the entity belongs.

For AD DS, the authentication method is typically either NTLM or the Kerberos protocol. For example, when a user logs on to a domain-joined computer, it collects the security credentials from the user and uses the Kerberos protocol to validate those credentials with an AD DS domain controller. The user's computer receives a Kerberos ticket to use when the user accesses resources. The Kerberos ticket contains cryptographic proof that AD DS has validated the credentials and a list of groups to which the user belongs.

Claims-based identity and authentication

Although Kerberos and NTLM work well for AD DS-based networks, they do not extend easily to multiple stores of accounts and attributes from third-party vendors or to identity management systems in the cloud.

For claims-based identity, a user obtains a security token that a trusted security token service (STS) has digitally signed and that contains a set of claims. Each claim represents a specific item of data about the user such as his or her name, group memberships, and role on the network. Claims-based identity enables applications to rely on the security token for proof of authentication and the set of claims for authorization or other processing. Claims-based identity typically enables a user to perform an authentication to obtain the security token and submit that token to applications. The claims-aware application verifies the digital signature of the security token and uses the claims to implement authorization and other application-specific functions.

Claims-based identity and authentication in Windows is built on Windows Identity Foundation (WIF), which is a set of .NET Framework classes that is used to implement claims-based identity. Claims-based authentication relies on standards such as WS-Federation, WS-Trust, and protocols such as SAML.

A simplified claims-based identity implementation contains the following components:

  • A claims-aware client application An application that can obtain a security token from an STS and submit security tokens for authentication and authorization. An example of a claims-aware client application is a web browser, such as Internet Explorer.

  • An STS A server or service that creates security tokens for claims-aware client applications. The STS that is in SharePoint 2013 provides its own security tokens to requesting claims-aware client applications, and it can also use Active Directory Federation Services (AD FS) 2.0 as an external STS.

  • A relying party A computer or application that relies on an STS for tokens. The relying party redirects claims-aware client applications to the STS to obtain a suitable security token. SharePoint 2013 can act as a relying party to an external STS. An example is a SharePoint web application that is configured to use AD FS as its STS.

  • A claims-aware server application An application that requires a security token for authentication and authorization. An example is a SharePoint 2013 web application that uses claims-based authentication (the default).

SharePoint 2013 supports claims-based identity and authentication for the following entities:

  • Users The validation of a user's identity against a store of accounts and attributes that contains the user's credentials and can verify that the user submitted them correctly. User authentication occurs when a user attempts to access a SharePoint resource. For more information, see Plan for user authentication methods in SharePoint 2013.

  • Apps The validation of the identity a remote app for SharePoint and the authorization of the app and an associated user to request a secured SharePoint resource. App authentication occurs when an external component of a SharePoint Store app or an App Catalog app, such as a web server that is located on the intranet or the Internet, attempts to access a secured SharePoint resource. For more information, see Plan for app authentication in SharePoint 2013.

  • Servers The validation of a server's request for resources that is based on a trust between the STS of the server that runs SharePoint 2013 and the STS of another server that supports the OAuth server-to-server protocol. Based on this trust relationship, a requesting server can access secured resources on the server that is running SharePoint 2013 on behalf of a specified user account, subject to server and user permissions. For more information, see Plan for server-to-server authentication in SharePoint 2013.

Methods of authorization

After authentication succeeds, an application must determine whether the entity is authorized to access the requested resource. To perform this analysis, the application compares the identity information about the entity—such as the user name and the groups for which it is a member—in the security token (for claims-based identity) or Kerberos ticket to the list of default or configured permissions for the resource being accessed.

Permissions are settings that specify an entity (such as a user or group name) and what that entity is allowed or not allowed to do (such as read, edit, or delete files in a shared folder). To obtain access to the resources, the configured permissions must permit the type of access that the entity requests.

SharePoint 2013 provides permissions for users to access web applications and their resources, server permissions for server-to-server resource requests, and app permissions for app resource requests.

For more information about how to plan for permissions in SharePoint 2013, see Permissions planning for sites and content in SharePoint 2013 and Plan app permissions management in SharePoint 2013.

Methods to store, synchronize, and display entity attributes

To configure permissions, the identity management system must obtain the list of entities from a storage location and display them for you. If that storage location is not the original store of accounts and attributes, the entity information must be synchronized with that store and replicated to other computers.

In SharePoint 2013, the facility that displays entity information for permissions configuration is People Picker and the service that collects, synchronizes, and replicates local entity information is the User Profile application service.

For more information, see People Picker and claims providers overview (SharePoint 2013) and Overview of the User Profile service application in SharePoint Server 2013.

See also

Plan for user authentication methods in SharePoint 2013
Plan for app authentication in SharePoint 2013
Plan for server-to-server authentication in SharePoint 2013
Permissions planning for sites and content in SharePoint 2013
Plan app permissions management in SharePoint 2013
People Picker and claims providers overview (SharePoint 2013)
Overview of the User Profile service application in SharePoint Server 2013


Test lab guides for SharePoint Server 2013

Updated: June 18, 2013

Summary: Find the set of Test Lab Guides (TLGs) for SharePoint Server 2013 to gain valuable hands-on experience before planning and deployment.

Applies to: SharePoint Server 2013

The following articles on TechNet and related resources provide information about TLGs for SharePoint Server 2013.

TechNet articles about TLGs for SharePoint Server 2013

The following articles about the set of TLGs for SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Lab icon | Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm | Describes the steps to configure a three-tier farm (web front-end, application, and database tiers) by using SharePoint Server 2013.
 | Test Lab Guide: Configure intranet and team sites for SharePoint Server 2013 | Describes the steps to configure intranet and team sites in the SharePoint Server 2013 three-tier farm test lab.
 | Test Lab Guide: Demonstrate permissions with SharePoint Server 2013 | Learn how to configure and demonstrate SharePoint 2013 permissions based on the Test Lab Guide: Configure intranet and team sites for SharePoint Server 2013.
 | Test Lab Guide: Demonstrate profile synchronization for SharePoint Server 2013 | Describes the steps to configure and demonstrate profile synchronization against a single Active Directory Domain Services (AD DS) domain controller in the SharePoint Server 2013 three-tier farm test lab.
 | Test Lab Guide: Demonstrate Social Features for SharePoint Server 2013 | Describes the steps to configure and demonstrate the new social features in SharePoint Server 2013 (My Sites, Newsfeeds, Community Sites, and Team Site feeds) in the SharePoint Server 2013 three-tier farm test lab.
 | Test Lab Guide: Demonstrate SAML-based Claims Authentication with SharePoint Server 2013 | Describes the steps to configure and demonstrate Security Assertion Markup Language (SAML)-based claims by using Active Directory Federation Services (AD FS) 2.0 in the SharePoint Server 2013 three-tier farm test lab.
 | Test Lab Guide: Demonstrate forms-based claims authentication for SharePoint Server 2013 | Describes the steps to configure and demonstrate forms-based authentication in the SharePoint Server 2013 three-tier farm test lab.
 | Test Lab Guide: Configure eDiscovery for SharePoint Server 2013 | Describes the steps to configure eDiscovery for SharePoint Server 2013 and Exchange Server 2013 in the SharePoint Server 2013 three-tier farm test lab.
 | Test Lab Guide: Configure a highly available SharePoint Server 2013 Search topology | Provides step-by-step instructions to create a test lab that demonstrates how to configure a search topology that provides high availability
 | Business Intelligence test lab guides | A set of test lab guides that describe the steps to configure and demonstrate business intelligence features in the SharePoint Server 2013 three-tier farm test lab.

You can view the entire SharePoint 2013 TLG stack and link to each article or white paper in poster format.

You might need additional software to view these files. See the following table for more information.

File type | Software
.pptx | PowerPoint 2013, PowerPoint 2010, or the free PowerPoint viewer If you use the PowerPoint viewer, right-click the PowerPoint version link, click Save Target As, save the file to your computer, and then open the file from your computer.
.pdf | Any PDF viewer, such as Adobe Reader

SharePoint 2013 test lab guide stack

SharePoint Server 2013 test lab guide stack

Zoom into the poster in full detail with Zoom.it from Microsoft

PowerPoint version

PDF version

Additional resources about TLGs

The following resources about TLGs are available.

Content Description

TechNet logo

  • Test Lab Guides (http://microsoft.com/testlabguides)

  • SharePoint Server 2013 Test Lab

  • Installation and deployment for SharePoint 2013 IT pros Resource Center

  • Visit the central Test Lab Guides portal in the TechNet Wiki for a description of TLG content and links to all the published TLGs.

  • Visit this portal page in the TechNet Wiki for all of the TLG content for SharePoint Server 2013.

  • Visit the Resource Center to access videos, community sites, documentation, and more.

Blogs

  • Microsoft Test lab Guides

Visit this blog for the latest information about TLG content published across Microsoft.

Change History

Date | Description
June 18, 2013 | Updated to include new Test Lab Guides stack poster.
May 14, 2013 | Added links to "Test Lab Guide: Demonstrate Permissions with SharePoint Server 2013" and "Test Lab Guide: Configure eDiscovery for SharePoint Server 2013."
May 07, 2013 | Added link to the new Test Lab Guide: Demonstrate profile sychronization for SharePoint Server 2013.
July 16, 2012 | Initial publication


Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm
See also

Updated: July 30, 2013

Summary: Learn how to install and configure SharePoint Server 2013 on multiple servers with Microsoft SQL Server 2012 by using the computers in the Base Configuration test lab.

Applies to: SharePoint Server 2013

This document is the Test Lab Guide version of the procedures that are described in Install SharePoint 2013 across multiple servers for a three-tier farm.

This document contains instructions for the following:

  1. Configuring the Base Configuration test lab.

  2. Installing and configuring a new server named SQL1.

  3. Installing SQL Server 2012 on the SQL1 server.

  4. Installing SharePoint Server 2013 on the APP1 server.

  5. Installing and configuring a new server named WFE1.

  6. Installing SharePoint Server 2013 on WFE1.

  7. Demonstrating the facilities of the default Contoso team site on WFE1.

Watch the configure SharePoint Server 2013 in a three-tier farm test lab guide overview video

Video (play button) icon

For information about how to configure this test lab in Hyper-V, see Hosting the SharePoint Server 2013 Three-Tier Test Lab with Windows Server 2012 Hyper-V.

Download the test lab guide

Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm

See also

Install SharePoint 2013 across multiple servers for a three-tier farm

Test Lab Guides

Change History

Date | Description
July 30, 2013 | Added a link the to Hyper-V configuration article for this test lab.
April 16, 2013 | Added the test lab guide overview video.
July 16, 2012 | Initial publication


Test Lab Guide: Configure intranet and team sites for SharePoint Server 2013
See also

Updated: August 6, 2013

Summary: Learn how to configure intranet and team sites based on the Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm.

Applies to: SharePoint Server 2013

This document explains how to set up multiple web applications, site collections, subsites, and pages for intranet departments and teams.

This document contains instructions for the following:

  1. Setting up the SharePoint Server 2013 three-tier farm test lab.

  2. Configure the intranet and team sites on APP1.

  3. Verify the intranet and team sites.

Watch the configure intranet and team sites with SharePoint Server 2013 test lab guide overview video

Video (play button) icon

For eBook versions of this TLG (including DOCX, EPUB, MOBI, and PDF), see Test Lab Guide: eBook for SharePoint Server 2013 Intranet and Team Sites.

Download the test lab guide

Test Lab Guide: Configure Intranet and Team Sites with SharePoint Server 2013

See also

Test Lab Guides

Change History

Date | Description
August 06, 2013 | Added a link to the eBook versions of this Test Lab Guide.
April 30, 2013 | Added the test lab guide overview video.
April 23, 2013 | Updated for simplification and for a reduction of overlap with the Test Lab Guide: Demonstrate Social Features for SharePoint Server 2013.
July 16, 2012 | Initial publication


Test Lab Guide: Demonstrate permissions with SharePoint Server 2013
See also

Updated: May 21, 2013

Summary: Learn how to configure and demonstrate SharePoint 2013 permissions based on the Test Lab Guide: Configure intranet and team sites for SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

This document explains how to set up and demonstrate SharePoint permissions in the following scenarios:

  • Locking down a subsite so that only members of a specific department can access it

  • Creating a subsite that the vendors of an organization can access

  • Creating an archives subsite so that documents can be added, viewed, and changed, but not deleted

This document contains instructions for the following:

  1. Setting up the SharePoint Server 2013 intranet and team sites test lab.

  2. Preparing groups and accounts and initial permissions.

  3. Configuring a secured Human Resources subsite.

  4. Configuring a subsite for vendor use.

  5. Configuring an archives subsite.

Watch the demonstrate permissions with SharePoint Server 2013 test lab guide overview video

Video (play button) icon

Download the test lab guide

Test Lab Guide: Demonstrate Permissions with SharePoint Server 2013

See also

Test Lab Guides

Change History

Date | Description
May 21, 2013 | Added a link to the "Demonstrate Permissions" test lab guide overview video.
May 14, 2013 | Initial publication


Test Lab Guide: Demonstrate profile synchronization for SharePoint Server 2013
See also

Published: May 7, 2013

Summary: Learn how to configure and demonstrate user profile synchronization based on the Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm (http://technet.microsoft.com/en-us/library/jj219610.aspx).

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

This document explains how to set up the SharePoint Server synchronization tool to synchronize profiles between SharePoint Server 2013 and a single Active Directory Domain Services (AD DS) domain controller.

This document contains instructions for the following:

  1. Setting up the SharePoint Server 2013 three-tier farm test lab.

  2. Creating a My Site web application and site collection and configuring settings.

  3. Configuring the User Profile service application.

  4. Creating a synchronization connection on APP1 to a directory service on DC1.

  5. Demonstrating user profile synchronization.

Download the test lab guide

Test Lab Guide: Demonstrate profile synchronization for SharePoint Server 2013

See also

Test Lab Guides


Test Lab Guide: Demonstrate Social Features for SharePoint Server 2013
See also

Published: September 18, 2012

Summary: Learn how to configure and demonstrate the new social features of SharePoint Server 2013 based on the Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm.

Applies to: SharePoint Server 2013

This document is the Test Lab Guide version of the procedures that are described in Configure social computing features in SharePoint Server 2013.

This document contains instructions for the following:

  1. Setting up the SharePoint Server 2013 three-tier farm test lab.

  2. Creating a My Site site collection and configure settings.

  3. Configuring Following settings.

  4. Configuring Community Sites.

  5. Configuring site feeds.

  6. Demonstrating social features.

Download the test lab guide

Test Lab Guide: Demonstrate Social Features for SharePoint Server 2013

See also

Configure social computing features in SharePoint Server 2013

Test Lab Guides


Test Lab Guide: Demonstrate SAML-based Claims Authentication with SharePoint Server 2013
See also

Updated: August 6, 2013

Summary: Learn how to configure and demonstrate Security Assertion Markup Language (SAML)-based claims authentication with Active Directory Federation Services (AD FS) 2.0 and SharePoint Server 2013 based on the Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm.

Applies to: SharePoint Server 2013

This document is the Test Lab Guide version of the configuration described in Configure SAML-based claims authentication with AD FS in SharePoint 2013.

This document contains instructions for the following:

  1. Setting up the SharePoint Server 2013 three-tier farm test lab.

  2. Configuring AD FS 2.0.

  3. Configuring SAML-based claims authentication.

  4. Demonstrating SAML-based claims authentication.

Watch the SAML-based claims authentication with SharePoint Server 2013 test lab guide overview video

Video (play button) icon

Download the test lab guide

Test Lab Guide: Demonstrate SAML-based Claims Authentication with SharePoint Server 2013

See also

Configure SAML-based claims authentication with AD FS in SharePoint 2013

Test Lab Guides

Change History

Date | Description
August 06, 2013 | Incorporated technical updates.
April 30, 2013 | Added the test lab guide overview video.
July 16, 2012 | Initial publication


Test Lab Guide: Demonstrate forms-based claims authentication for SharePoint Server 2013
See also

Updated: April 16, 2013

Summary: Learn how to configure and demonstrate form-based authentication for SharePoint Server 2013 based on the Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm.

Applies to: SharePoint Server 2013

This document is the Test Lab Guide version of the configuration described in Configure forms-based authentication for a claims-based web application in SharePoint 2013.

This document contains instructions for the following:

  1. Setting up the SharePoint Server 2013 three-tier farm test lab.

  2. Configuring forms-based authentication.

  3. Demonstrating forms-based authentication.

Watch the demonstrate forms-based claims authentication for SharePoint Server 2013 test lab guide overview video

Video (play button) icon

Download the test lab guide

Test Lab Guide: Demonstrate Forms-based Authentication with SharePoint Server 2013

See also

Configure forms-based authentication for a claims-based web application in SharePoint 2013

Test Lab Guides

Change History

Date | Description
April 16, 2013 | Added the test lab guide overview video.
September 18, 2012 | Initial publication


Test Lab Guide: Configure eDiscovery for SharePoint Server 2013
See also

Published: May 14, 2013

Summary: Learn how to configure eDiscovery for SharePoint Server 2013 based on the Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm.

Applies to: SharePoint Server 2013 | Exchange Server 2013

This document explains how to set up eDiscovery between SharePoint Server 2013 and Exchange Server 2013.

This document contains instructions for the following:

  1. Setting up the SharePoint Server 2013 three-tier farm test lab.

  2. Installing Microsoft Office 2013 on CLIENT1.

  3. Setting up Exchange Server 2013 on EX1.

  4. Installing the Exchange Web Service API.

  5. Configuring a trust relationship between SharePoint 2013 and Exchange Server 2013.

  6. Configuring Exchange for SharePoint eDiscovery Center.

  7. Configuring Search to crawl all discoverable content.

  8. Creating an eDiscovery center.

  9. Adding User1 to the Discovery Management Role Group in Exchange 2013.

Download the test lab guide

Test Lab Guide: Configure eDiscovery for SharePoint Server 2013

See also

Test Lab Guides


Test Lab Guide: Configure a highly available SharePoint Server 2013 Search topology
See also

Published: July 9, 2013

Summary: Learn how to configure search for high availability by using the computers in the Configure SharePoint Server 2013 in a three-tier farm test lab.

Applies to: SharePoint Server 2013

This document is the Test Lab Guide version of the procedures that are described in Test Lab Guide: Configure a highly available SharePoint Server 2013 Search topology.

This document contains instructions for the following tasks:

  1. Configure the three-tier farm test lab.

  2. Install and configure new application servers named APP2, APP3, APP4, and APP5.

  3. Install SharePoint Server 2013 on the new application servers.

  4. Create and configure the Search service application.

  5. Change the default search topology.

  6. Create a Search Center site.

  7. Test the search on the default Contoso team site on WFE1.

Download the test lab guide

Test Lab Guide: Configure a Highly Available SharePoint Server 2013 Search Topology

See also

Install SharePoint 2013 across multiple servers for a three-tier farm

Test Lab Guides


Business Intelligence test lab guides
See also

Published: January 15, 2013

Summary: Learn how to configure and demonstrate the business intelligence solution for SharePoint Server 2013 based on the Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm.

Applies to: SharePoint Server 2013

To create your own working test lab for business intelligence in SharePoint Server 2013, use the topics described in Test Lab Guides for Business Intelligence. These topics are part of the Test Lab Guide content set for SharePoint Server 2013.

The set of test lab guides for business intelligence in SharePoint Server 2013 are as follows:

Lab icon

  • Test Lab Guide: Create a Business Intelligence Baseline Environment

  • Test Lab Guide: Configure Secure Store

  • Test Lab Guide: Configure Excel Services

  • Test Lab Guide: Configure the Excel Services unattended service account

  • Test Lab Guide: Configure Excel Services data refresh by using an embedded connection

  • Test Lab Guide: Configure Excel Services data refresh by using an external connection

  • Test Lab Guide: Configure Visio Services

  • Test Lab Guide: Configure the Visio Services unattended service account

  • Test Lab Guide: Configure Visio Services data refresh using an external connection

  • Test Lab Guide: Configure PerformancePoint Services

  • Test Lab Guide: Configure data access for PerformancePoint Services

See also

Test Lab Guides for Business Intelligence
Business intelligence scenarios and solutions


Learning roadmaps for SharePoint 2013

Updated: August 6, 2013

Summary: Build SharePoint 2013 expertise by stepping through a series of learning goals in these learning roadmaps.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A Learning Roadmap provides a methodical approach to help you build expertise as you achieve a series of learning goals. You start with prerequisites and then build on your knowledge and experience in levels:

  • Introductory (level 100)

  • Intermediate (level 200)

  • Advanced (level 300)

  • Expert (level 400)

Each section of a Learning Roadmap contains an ordered list of steps, which you should perform in the recommended order. Each step points to a resource (a Microsoft or third-party article, white paper, video, book chapter, blog post, and so on) and states a learning goal. After you meet the knowledge or experience requirements of a learning goal, move on to the next step.

Learning Roadmap Banner

Watch the Learning Roadmaps overview video

Video (play button) icon

The following learning roadmaps are available for SharePoint 2013.

Learning roadmaps for SharePoint 2013

The following learning roadmap articles for SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Learn - person with a book | Content | Description
 | Authentication in SharePoint 2013 learning roadmap | Use this learning roadmap to build expertise about authentication in SharePoint 2013.
 | Learn about upgrade for SharePoint 2013 | Use this learning roadmap to build expertise about how to upgrade to SharePoint 2013.
 | Virtualize SharePoint 2013 learning roadmap | Use this learning roadmap to build expertise about how to install and configure SharePoint 2013 in a Microsoft virtual environment.
 | Windows PowerShell for SharePoint 2013 learning roadmap | Use this learning roadmap to understand Windows PowerShell for SharePoint 2013.
 | User profiles for SharePoint Server 2013 learning roadmap | Use this learning roadmap to gain expertise about user profiles and associated technologies in SharePoint Server 2013.
 | Database management for SharePoint 2013 learning roadmap | Use this learning roadmap to build expertise about database management in SharePoint 2013.
 | Permissions for SharePoint 2013 learning roadmap | Use this learning roadmap to build expertise in permissions and permissions management in SharePoint 2013.

Additional resources about learning roadmaps

The following resources about learning roadmaps are available from other subject matter experts.

 | Content | Description
TechNet logo | Learning Roadmaps Portal | Learning roadmaps portal page in the TechNet Wiki.

Change History

Date | Description
August 06, 2013 | Added a link to the Learning Roadmaps overview video.
May 07, 2013 | Added link to Permissions for SharePoint 2013 learning roadmap.
April 30, 2013 | Added link to Database management for SharePoint 2013 learning roadmap.
March 12, 2013 | Added link to User profiles for SharePoint Sever 2013 learning roadmap.
February 19, 2013 | Added link to the Virtualize SharePoint 2013 learning roadmap.
February 5, 2013 | Initial publication


Authentication in SharePoint 2013 learning roadmap

Updated: April 16, 2013

Summary: Use this learning roadmap to build expertise in the authentication technologies in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

SharePoint 2013 makes it easy for people to work together. SharePoint 2013 enables you and your employees to set up web sites to share information with others, manage documents from start to finish, and publish reports to help everyone make informed decisions. Authentication in SharePoint 2013 defines how users, apps, and servers obtain authenticated access to protected SharePoint resources

If you are new to authentication in SharePoint 2013, this article can help you identify what you need to learn to develop expertise about authentication methods for SharePoint 2013. It includes prerequisite topics that explain fundamentals about the web infrastructure. Learn about prerequisite technologies first because SharePoint 2013 builds on them and assumes an understanding of the concepts. Afterwards, you can start to learn about authentication in SharePoint 2013 with the resources in the Level 100 (introductory), 200 (intermediate), and 300 (advanced) sections.

Learning Roadmap Banner

We recommend that you read the topics in the order listed.

  • Prerequisite information

  • Level 100

  • Level 200

  • Level 300

  • Ongoing learning

  • Additional Resources

Prerequisite information

This section contains links to many articles and books that contain background information that will help you fully understand the different authentication methods that SharePoint 2013 supports.

  • Step 1: Learn about the basic, digest, and anonymous methods of authentication for Internet Information Services (IIS).

    In some cases, you might want to use the basic, digest, and anonymous authentication methods for SharePoint web sites. For an explanation of these authentication methods, see IIS Authentication. For configuration steps, see Configuring Authentication in IIS 7.

    Your goal is to understand the use, role, and comparative advantages of the basic, digest, and anonymous methods of authentication for IIS and how to configure them for web sites that IIS hosts.

  • Step 2: Learn about the NTLM authentication method.

    When you use Windows claims or Windows classic user authentication methods, SharePoint 2013 can use the NTLM authentication method. See Microsoft NTLM and NTLM Authentication Scheme for HTTP.

    Your goal is to understand how NTLM works to authenticate user access to web sites.

  • Step 3: Learn about the Kerberos protocol and authentication method.

    When you use Windows claims or Windows classic user authentication methods, SharePoint 2013 can use the Kerberos protocol and authentication method. For the Kerberos protocol, What Is Kerberos Authentication? and How the Kerberos Version 5 Authentication Protocol Works. For the Kerberos protocol that is used for web authentication, see How Kerberos Works.

    Your goal is to understand how the Kerberos protocol works to authenticate user access to web sites.

  • Step 4: Learn about claims-based authentication.

    We recommend claims-based authentication for user authentication in SharePoint 2013. App authentication and server-to-server authentication required claims-based authentication. See the Claims-based Identity for Windows white paper, An Introduction to Claims, and Claims-Based Architectures.

    Your goal is to understand the following concepts:

    • The benefits of claims-based authentication

    • The components of a claims identity infrastructure: identity provider, security token service, account and attribute store, web-enabled client and server applications, federation provider

    • How claims-based authentication works to authenticate user access to web sites

  • Step 5: Learn about Open Authorization (OAuth).

    SharePoint 2013 uses OAuth for app authentication and server-to-server authentication. See About OAuth, OAuth 2.0 Tutorial, and "Section 1. Introduction" of RFC 6749.

    Your goal is to understand how OAuth provides an authorization mechanism to obtain access to protected resources.

  • Step 6: Learn how to create a public key infrastructure (PKI) with Active Directory Certificate Services (AD CS).

    Some authentication methods require installed digital certificates on servers that run SharePoint 2013. These certificates can be purchased from a third-party certification authority or you can deploy your own PKI. You can deploy your own PKI with AD CS. See Designing a Public Key Infrastructure.

    If you have to have AD CS for your PKI, your goal is to understand how to deploy an AD CS-based PKI and request specific types of certificates from an AD CS server.

  • Step 7: Learn how to configure HTTPS websites with Internet Information Services (IIS).

    Some authentication methods require HTTPS-based communication with servers that run SharePoint 2013 and that use IIS to host their web sites. See How to Set Up SSL on IIS 7.

    Your goal is to understand how to configure certificate bindings and enable HTTPS for web sites that run on IIS.

Level 100

The following documents contain introductory information about authentication in SharePoint 2013.

  • Step 1: Learn about the new features of authentication in SharePoint 2013.

    See What's new in authentication for SharePoint 2013 and SharePoint 2013 training for IT pros: Module 11.

    Your goal is to understand the new capabilities of authentication, such as app authentication, server-to-server authentication, and improvements to existing capabilities in SharePoint 2013.

  • Step 2: Understand the differences between user, app, and server-to-server authentication in SharePoint 2013.

    See Authentication overview for SharePoint 2013.

    Your goal is to understand how SharePoint 2013 uses user, app, and server-to-server authentication to provide user, app, and server resource access.

Level 200

The following content contains intermediate information about authentication in SharePoint 2013.

  • Step 1: Learn how to plan for and deploy user authentication in SharePoint 2013.

    See Plan for user authentication methods in SharePoint 2013, Configure forms-based authentication for a claims-based web application in SharePoint 2013, and Configure SAML-based claims authentication with AD FS in SharePoint 2013.

    View the following:

    Windows claims authentication in SharePoint 2013 video

    Video (play button) icon

    Forms-based claims authentication in SharePoint 2013 video

    Video (play button) icon

    SAML-based claims authentication in SharePoint 2013 video

    Video (play button) icon

  • Your goal is to understand the following concepts:

    • The various methods to authenticate users that SharePoint 2013 supports and how they work

    • How to plan for the use of an authentication method in web applications and zones

    • How to configure forms-based authentication and Security Assertion Markup Language (SAML)-based authentication by using AD FS 2.0

  • Step 2: Demonstrate forms-based authentication in a test lab.

    See Test Lab Guide: Demonstrate forms-based claims authentication for SharePoint Server 2013.

    View the following:

    Demonstrate forms-based claims authentication for SharePoint Server 2013 test lab guide overview video

    Video (play button) icon

    Your goal is to configure and demonstrate forms-based authentication by using the built-in Lightweight Directory Access Protocol (LDAP) membership provider in a test lab.

  • Step 3: Demonstrate SAML-based claims-based authentication in a test lab.

    View the following:

    Demonstrate SAML-based claims authentication for SharePoint Server 2013 test lab guide overview video

    Video (play button) icon

    See Test Lab Guide: Demonstrate SAML-based Claims Authentication with SharePoint Server 2013.

    Your goal is to configure and demonstrate SAML-based claims-based authentication with AD FS as the identity provider in a test lab.

  • Step 4: Learn how to plan for and deploy app authentication in SharePoint 2013..

    See Plan for app authentication in SharePoint 2013 and Configure app authentication in SharePoint Server 2013.

    Your goal is to understand the various types of apps, the design considerations for app authentication, and how to configure SharePoint 2013 to support app authentication.

  • Step 5: Learn how to plan for and deploy server-to-server authentication in SharePoint 2013.

    See Plan for server-to-server authentication in SharePoint 2013 and Configure server-to-server authentication in SharePoint 2013.

    Your goal is to understand following concepts:

    • The design considerations for server-to-server authentication

    • How to configure SharePoint 2013 to support server-to-server authentication for other SharePoint farms

    • How to configure SharePoint 2013 to support servers that are running Microsoft Exchange Server 2013

    • How to configure SharePoint 2013 to support servers that are running Microsoft Lync Server 2013

  • Step 6: Learn how to migrate a Windows classic web application to Windows claims.

    See Migrate from classic-mode to claims-based authentication in SharePoint 2013.

    Your goal is to understand the different ways in which you can convert a web application that uses Windows classic user authentication to use Windows claims-based authentication in SharePoint 2013.

  • Step 7: Learn how to perform basic troubleshooting for claims-based user authentication.

    See Claims authentication does not validate user (SharePoint 2013).

    Your goal is to understand the following concepts:

    • The tools that you use to collect claims authentication error and system state information

    • How to determine the specific claims method being used in a user authentication attempt

    • How to check configuration requirements

    • How to capture and analyze claims authentication network traffic

Level 300

The following content contains advanced information about authentication in SharePoint 2013.

  • Step 1: Learn how to create custom claims providers for SharePoint 2013.

    See Claims Walkthrough: Writing Claims Providers for SharePoint 2010.

    Note:

    Although this article is for SharePoint 2010, the content also applies to SharePoint 2013.

    Your goal is to understand how to augment claims and provide name resolution in a custom claims provider for SharePoint 2013.

  • Step 2: Understand claims-based user authentication processes in SharePoint 2013.

    See the " Overview of Advanced Claims-Based Authentication Scenarios " section in Claims Architecture and Scenarios for SharePoint 2010 Developers.

    Your goal is to understand the high-level architecture for claims-based user authentication in SharePoint and the detailed processes for Windows, forms-based, and SAML-based claims authentication.

  • Step 3: Understand the browser interaction for claims-based user authentication in SharePoint 2013.

    See Appendix B of A Guide to Claims-Based Identity and Access Control (Second Edition).

    Your goal is to understand the set of messages and their contents for various types of claims-based user authentication.

Ongoing learning

  • Share-n-dipity blog.

    See Share-n-dipity.

    Your goal is to keep up-to-date with Microsoft Principal Consultant Steve Peschka, a leading expert in SharePoint authentication issues.

Additional Resources

  • SharePoint 2013 Claims-based Authentication

  • SharePoint 2013 Portal

Feedback

Your feedback is valuable and welcome! Please rate this content by using the Did you find this helpful section at the bottom of the article, or send your comments and suggestions to SharePoint IT Documentation Feedback (itspdocs@microsoft.com). The author will review your comments and use them to help improve this documentation. Your e-mail address won't be saved or used for any other purposes.

Change History

Date | Description
April 16, 2013 | Added the new user authentication process and test lab guide overview videos.
February 5, 2013 | Initial publication


Learn about upgrade for SharePoint 2013

Updated: August 20, 2013

Summary: Use this learning roadmap to understand the process and build expertise about upgrade for SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The process for upgrading to SharePoint 2013 is complex and has a lot of steps. You have to know a lot about your existing environment, and about how the process works, before you upgrade. This article can help you get a baseline understanding of what upgrade means for SharePoint products. It contains links to other articles that explain concepts, illustrate the process, and help you avoid pitfalls when you are ready to plan and then start an upgrade.

Learning Roadmap Banner

This article is built like a college course curriculum: start with the prerequisites, then move through the Level 100 (introductory), 200 (intermediate), and 300 (advanced) sections.

We recommend that you read the articles in the order listed.

Prerequisites - What do I need to know first?

Get familiar with these concepts before you start learning about upgrade to SharePoint 2013.

Step 1: Learn about SharePoint logical architecture and topologies

Physical and logical architecture pieces

When you upgrade to SharePoint 2013 from SharePoint 2010, you first create a SharePoint 2013 environment. That environment has logical architecture pieces (such as web applications, service applications, and site collections) and physical architecture pieces (such as web servers and database servers).

These articles and posters explain the logical and physical architecture for SharePoint:

  • Plan logical architectures for SharePoint 2013

  • Topologies model

  • Services model

The Architecture design for SharePoint 2013 IT Pros Resource Center contains all of the above, plus more useful information about SharePoint 2013 architecture.

After reading these articles, you should understand what you want to have in place for SharePoint 2013. And it'll also help you understand what pieces of the logical and physical architecture are involved in each stage of upgrade.

Step 2: Learn about SharePoint databases

Content and service application databases

When you upgrade to SharePoint 2013, you perform what's called a database-attach upgrade. You back up the databases from the SharePoint 2010 environment, and then restore and upgrade the databases to SharePoint 2013. SharePoint has several database types. Only some of the databases can be upgraded. The Databases model explains what they all are, what kind of information they store, and how big they typically are. Look for information in the model about the content databases and the service application databases in the model. These are the ones you'll work with during upgrade.

Level 100 - Walk me through the process

In this section, you get familiar with the process of upgrade for SharePoint 2013.

Step 1: Learn about the overall process for an upgrade to SharePoint 2013

SharePoint 2013 Products Upgrade Process model

The Overview of the upgrade process to SharePoint 2013 article contains illustrations and a video that give you a high-level overview of the whole process. The Upgrade Process model has all of the steps on one big page that you can print.

Use this article and poster to understand the overall upgrade process and what happens in each phase of the process.

Step 2: Learn about upgrade for service applications

Service application databases

Many of the service applications can be upgraded from SharePoint 2010 to SharePoint 2013. Each service application is a little bit different though, so you need to understand what can be upgraded and what won't upgrade in the new environment. The Services upgrade overview for SharePoint Server 2013 article talks about these differences and what to expect.

After you read the article, you'll know which service applications can be upgraded and any considerations to think about for each of those service applications.

Step 3: Learn about best practices

Like

Some things can make upgrade easier, and some things can make it harder. Read Best practices for upgrading to SharePoint 2013 to find out what you should and shouldn't do if you want the best possible path.

Level 200 - How will upgrade work for my environment?

Now that you understand the overall process, you probably want to know, well, how will it work for me? And by the way, how long will it take? The only way to know is to test it out with your own data. These articles help you do that.

Step 1: Learn about how to test upgrade

SharePoint 2013 Products Upgrade Testing model

The article Use a trial upgrade to SharePoint 2013 to find potential issues tells you how to try out upgrade with a test copy of your data and look for potential issues. The How to Test Upgrade model has a summary of this article on one big page that you can print.

Test the upgrade process so that the actual upgrade goes smoothly and you do not have to recover from unexpected events. Testing upgrade is our number one recommendation. It's the only way to predict how things will go, and the only way to save yourself from a 5:00 PM Sunday crisis about whether or not your sites will be online again on Monday morning. The more testing you do, the better off you'll be.

Step 2: Learn about upgrade performance

Alarm icon

Every environment is different. That's why we don't have a simple formula for x amount of data = x amount of time. Test your environment, and use the information in Plan for performance during upgrade to SharePoint 2013 to figure out what your data is like and how long upgrade is likely to take. Is your hardware up to the task? Or is it going to be so slow you'll wonder if it'll ever get done? Find out before you're on a deadline. Don't forget to think about the performance after the upgrade. How much power will the SharePoint 2013 environment need?

Step 3: Learn about customizations and upgrade

List of common customizations

Customizations cause the most grief for people running upgrade. Be prepared with a plan. Use the article Create a plan for current customizations during upgrade to SharePoint 2013 to find out what you have in your environment, and how to approach upgrade for each type of common customization.

Level 300 - The detailed steps

You've had the overview, you know what to watch out for, now how do you really do it? Here's how.

Step 1: Learn about the specific steps in a database-attach upgrade

Upgrade steps that an administrator performs

The chapter Upgrade databases from SharePoint 2010 to SharePoint 2013 has all of the steps to perform to upgrade the environment. There's a checklist you can print out, and articles that cover each phase in the upgrade process.

Plus, there's an article about how to migrate users from classic authentication to claims authentication so you can use all the new features that rely on claims authentication.

Step 2: Learn about site collection upgrade

Upgrade steps that site collection owners perform

New in SharePoint 2013, you can upgrade your databases, then upgrade the site collections on their own schedule. The articles Plan for site collection upgrades in SharePoint 2013 and Upgrade site collections to SharePoint 2013 explain this process. And then you can decide whether you want to control the whole process yourself, or let your site collection owners help themselves.

Step 3: Learn how to troubleshoot upgrade

Alert icon

Even with the best preparation, sometimes things go wrong. Some of the most common problems are in the articles Troubleshoot database upgrade issues in SharePoint 2013 and Troubleshoot site collection upgrade issues in SharePoint 2013. Use these articles to understand how to approach and troubleshoot issues when something goes wrong.

Step 4: Experiment with SharePoint 2013 upgrade in a test lab

Lab icon

We have test lab guides that walk through creating a test lab of SharePoint 2010. Why not use them to create a test environment and try stuff out? It won't be an accurate representation of your environment, so you can't rely on it for performance testing or finding issues, but you can run upgrade over and over until you know the steps well.

Use the SharePoint Server 2010 Single Server or Three-Tier Farm test lab guides to create a test lab that mimics key aspects of your SharePoint Server 2010 environment. Then use part 4 of the Test Lab Guide: Configure SharePoint Server 2013 in a three-tier farm to create a 2013 server named APP2, add it to the existing 2010 farm, and then upgrade the SharePoint Server 2010 test lab content to SharePoint 2013 using the procedures in Upgrade to SharePoint 2013.

This way you can have hands-on experience with the upgrade process in a simple environment and work up to the real thing.

Where can I find more information?

Video (play button) icon | SharePoint 2013 training for IT pros: Module 13: Upgrading to SharePoint 2013 These videos have lots of detailed information about the upgrade steps.
House icon | Resource Center: Upgrade and migrate to SharePoint 2013 (IT pros) This is a great entry point for all of the upgrade content.
Stack of books | Upgrade guide: Upgrade to SharePoint 2013 This is the part of the library that has all of the upgrade content we have for SharePoint 2013.

Feedback

Your feedback is valuable and welcome! Please rate this content by using the Did you find this helpful section at the bottom of the article, or send your comments and suggestions to SharePoint IT Documentation Feedback (itspdocs@microsoft.com). The author will review your comments and use them to help improve this documentation. Your email address won't be saved or used for any other purposes.

Change History

Date | Description
August 20, 2013 | Changed style of article to be more friendly and easy to read. Added graphics to anchor sections.
March 19, 2013 | Added suggestion to use Test Lab Guides to experience a simplified upgrade process.
February 5, 2013 | Initial publication


Virtualize SharePoint 2013 learning roadmap

Published: February 19, 2013

Summary: Use this learning roadmap to build expertise about how to install and configure SharePoint 2013 in a Microsoft virtual environment.

Applies to: SharePoint Server 2013 | Windows Azure | Windows Server

SharePoint 2013 makes it easy for people to work together. SharePoint 2013 enables you and your employees to set up web sites to share information with others, manage documents from start to finish, and publish reports to help everyone make informed decisions. You can deploy SharePoint products on any virtualization solution certified by the Microsoft Server Virtualization Validation Program (SVVP). This learning roadmap provides information about how to virtualize SharePoint 2013 in a Hyper-V environment or on Windows Azure.

If you are new to virtualization in SharePoint 2013, this article can help you identify what you need to learn before you deploy a SharePoint farm in a virtual environment. It includes prerequisite articles that explain various Microsoft virtualization fundamentals. You must understand the prerequisite technologies first, because virtualization in SharePoint 2013 builds upon them and assumes an understanding of them. Afterwards, you can begin to learn about virtualization in SharePoint 2013 planning and deployment with the resources in the Level 100 (introductory), 200 (intermediate), and 300 (advanced) sections.

Learning Roadmap Banner

We recommend that you read the topics in the order listed.

  • Prerequisite information

  • Level 100

  • Level 200

  • Level 300

  • Where can I find more information?

Prerequisite information

This section contains links to various resources that provide background about the virtualization technologies that SharePoint 2013 supports.

  • Step 1: Learn about virtualization.

    Virtualization technologies have been used in the computer industry for several years. However, if you haven't had direct contact with these technologies, we recommend viewing the following videos. These videos present the basic concepts and benefits of virtualization.

    • Virtually Speaking: What is Virtualization?

    • What is Virtualization - An Introduction to Server Virtualization

    After you are familiar with the basic virtualization concepts, view the following Microsoft TechNet videos in the Virtualization Jump Start series.

    • Virtualization overview

    • Differentiating Microsoft and VMWare

    • Hyper-V Deployment Options & Architecture | Part 1

  • Step 2: Learn about virtualization support and licensing.

    See Virtualization support and licensing in SharePoint 2013 to see what virtualization technologies you can use for a SharePoint farm. If you plan to deploy SharePoint products in a hosted virtual environment that Microsoft provides as a service, see Support and licensing for Windows Azure in SharePoint 2013.

    Your goal is to understand the hypervisor-based virtualization technologies that SharePoint 2013 supports.

  • Step 3: Learn about Hyper-V and what is required for SharePoint 2013.

    See Getting to Know Hyper-V: A Walkthrough from Initial Setup to Common Scenarios and Hyper-V Overview. After you learn these Hyper-V fundamentals, see Hyper-V virtualization requirements for SharePoint 2013.

    Your goal is to understand the hardware and operating system requirements for the server hardware that will host the virtual machines in your SharePoint farm.

Level 100

The following resources contain introductory information about how to deploy SharePoint 2013 in a virtual environment.

  • Step 1: Learn about SharePoint logical architecture and topologies.

    When you deploy SharePoint 2013 in a virtual environment, you first create architecture for the environment. You must be familiar with the supported logical components of a SharePoint farm, such as web applications, service applications, and site collections. You must also be familiar with physical components, such as web servers and database servers so that you can determine the appropriate architecture for your SharePoint environment. See Plan logical architectures for SharePoint 2013, the Topologies for SharePoint Server 2013 model, the Services model, and the Architecture design for SharePoint 2013 IT Pros Resource Center.

    Your goal is to understand the pieces of the logical and physical architecture of SharePoint 2013, so that you understand what level of the architecture you need to work in to deploy SharePoint 2013 in a virtual environment.

  • Step 2: Learn about farm virtualization and supported architectures.

    After you design the topology to support the farm, you have to understand farm virtualization and the supported virtual architectures. See Overview of farm virtualization and architectures for SharePoint 2013.

    Your goal is to understand how a SharePoint 2013 logical and physical architecture maps to a virtual environment.

Level 200

The following resources contain intermediate information about how to deploy SharePoint 2013 in a virtual environment.

  • Step 1: Learn about planning for virtualization.

    See Create a virtualization plan for SharePoint 2013.

    Your goal is to understand all the infrastructure requirements and the main phases to deploy a SharePoint farm in a virtual environment.

  • Step 2: Learn about virtual infrastructure design and virtualization host server specifications.

    See Detailed design and system specification process for a virtual SharePoint 2013 farm.

    Your goal is to understand how to design a virtual infrastructure and develop system specifications for the Hyper-V environment.

  • Step 3: Learn about best practices to configure a Hyper-V environment for SharePoint 2013.

    See Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment.

    Your goal is to learn about the best practice configurations for the virtualization infrastructure and the virtual machines that are used in a SharePoint farm.

Level 300

The following resources contain advanced information about how to deploy SharePoint 2013 in a virtual environment.

  • Step 1: Learn about best practice configurations for setting up a Hyper-V environment for SharePoint 2013.

    See Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment.

    Your goal is to learn about the best practice configurations for the virtualization infrastructure and the virtual machines that are used in a SharePoint farm.

  • Step 2: Learn about Windows Azure as a virtualization option for SharePoint Server 2013.

    Deployment Considerations for SharePoint 2013 on Windows Azure Virtual Machines describes the things to consider if you intend to deploy a SharePoint farm on Windows Azure.

  • Step 3: Learn about deploying SharePoint on Windows Azure.

    SharePoint Deployment on Windows Azure Virtual Machines (http://www.microsoft.com/en-us/download/details.aspx?id=34598) explains how to deploy SharePoint Server 2010 on Windows Azure virtual machines.

Additional resources

  • Wiki: Virtualization Portal

  • Hyper-V Portal

  • Windows Azure: Microsoft's Cloud Platform

  • Server Virtualization Validation Program

Feedback

Your feedback is valuable and welcome! Please rate this content by using the Did you find this helpful section at the bottom of the article, or send your comments and suggestions to SharePoint IT Documentation Feedback (itspdocs@microsoft.com). The author will review your comments and use them to help improve this documentation. Your e-mail address won't be saved or used for any other purposes.


Windows PowerShell for SharePoint 2013 learning roadmap

Published: February 5, 2013

Summary: Use this learning roadmap to understand Windows PowerShell for SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

SharePoint 2013 makes it easy for people to work together. SharePoint 2013 enables you and your employees to set up web sites to share information with others, manage documents from start to finish, and publish reports to help everyone make informed decisions. Windows PowerShell in SharePoint 2013 lets an administrator automate tasks with SharePoint web applications, site collections, sites, lists, and more and provides a command-line alternative to configuring SharePoint 2013 through Central Administration.

If you are new to Windows PowerShell in SharePoint 2013, this article can help you identify what you need to learn to understand how to build expertise for Windows PowerShell in SharePoint 2013. It includes prerequisite articles that explain Windows PowerShell fundamentals. You have to understand the prerequisite technologies first. Windows PowerShell in SharePoint 2013 assumes that you understand basic concepts. Afterwards, you can start to learn about Windows PowerShell in SharePoint 2013 with the resources in the Level 100 (introductory), 200 (intermediate), and 300 (advanced) sections.

Learning Roadmap Banner

We recommend that you read the articles in the order listed.

  • Prerequisite information

  • Level 100

  • Level 200

  • Level 300

  • Additional Resources

Prerequisite information

This section contains links to articles and books that contain background information that will help you understand how Windows PowerShell in SharePoint 2013 works.

  • Step 1: Learn about the basics of Windows PowerShell.

    Before you start to use Windows PowerShell to automate tasks in SharePoint 2013, you have to understand the terms, concepts, and the use of objects to complete tasks. To understand why one would use Windows PowerShell and definition of terms, see Getting Started with Windows PowerShell

    Your goal is to understand the use, concept, terms, and role of Windows PowerShell.

  • Step 2: Learn the permission requirements for Windows PowerShell in SharePoint 2013.

    See Use Windows PowerShell to administer SharePoint 2013.

    Before you run a Windows PowerShell for SharePoint cmdlet, you have to understand the minimum required permissions. Membership in the Farm administrators group or being the Farm Administrator to the SharePoint farm is not sufficient permission to run SharePoint cmdlets. If you don't have required permissions, you might receive the following error message: "The local farm is not accessible."

    Your goal is to understand the permissions that are required to run a Windows PowerShell for SharePoint cmdlets.

Level 100

The following resources contain introductory information about Windows PowerShell in SharePoint 2013

  • Learn about the Get-Command cmdlet.

    See Get-Command

    One of the first cmdlets (pronounced, command-lets) that you want to learn to use is the Get-Command cmdlet. Think of this cmdlet as the command inventory. It displays all the cmdlets that are available in the current Windows PowerShell session. The construct of a cmdlet is Verb-Noun object. Verbs are action-oriented words, such as Add, Get, Set, Update, for example. Nouns describe what command to act on, such as SPSite or SPUser. Notice that all nouns for SharePoint 2013 begin with "SP."

    The following table shows examples of how verbs and nouns combine to create cmdlet names:

    Verb

    Noun

    Cmdlet

    Get

    SPSite

    Get-SPSite

    Add

    SPUser

    Add-SPUser

    To display a list of all availableWindows PowerShell cmdlets, you can use the Get-Command cmdlet. The result will display Windows PowerShell core cmdlets and SharePoint 2013 cmdlets. To only display a list of all SharePoint 2013 cmdlets, from the Windows PowerShell Command Prompt window, use the -Noun parameter together with "SP" and the wildcard character (*). The resulting syntax would be displayed as follows:

    Copy code
    Get-Command -noun SP*

    Conversely, you can use the -Verb parameter to display cmdlets that begin with a specific verb, for example, "Get", the syntax would look this this:

    Copy code
    Get-Command -Verb get

    Your goal is to display a list of all available Windows PowerShell cmdlets for SharePoint 2013, by noun or by verb.

  • Step 2: Learn about the Get-Help cmdlet..

    See Get-Help

    This cmdlet displays help information for any Windows PowerShell cmdlet. . It has three levels of display: Normal, Detailed, and Full.

    For example, if you want to display complete help for the Get-SPSite cmdlet, from the Windows PowerShell Command Prompt, type the following syntax:

    Copy code
    Get-Help Get-SPSite -Full

    To show examples only for the Get-SPSite cmdlet, type the following syntax:

    Copy code
    Get-Help Get-SPSite -Examples

    For an interactive tool and guide that helps you learn Windows PowerShell syntax, see Windows PowerShell Command Builder Tool

    Your goal is to understand how to obtain and use help for Windows PowerShell cmdlets for command syntax or for examples.

Level 200

The following resources contain intermediate information about Windows PowerShell in SharePoint 2013.

  • Step 1: Learn about the pipeline.

    See about_Pipelines

    Simply put, the concept of the pipeline passes one object of a command to another. The result of the first command is an input for the next command. For more information, see Piping and the Pipeline

    For example, you might want to display SharePoint services that are running on your computer. Use Get-Service cmdlet to display all available services. This result will serve as input for the second command, the Where-Object cmdlet, where you'll filter to show SharePoint services. The result is a sorted list of SharePoint services. From a Windows PowerShell Command Prompt, type the following syntax:

    Copy code
    Get-Service | Where-Object {$_.DisplayName -like "Sharep*"}

    The result should resemble the following:

    Status

    Name

    DisplayName

    Running

    OSearch15

    SharePoint Server Search 15

    Stopped

    SPAdminV4

    SharePoint Administration

    Running

    SPSearchHostController

    SharePoint Search Host Controller

    Running

    SPTimerV4

    SharePoint Timer Service

    Running

    SPTraceV4

    SharePoint Tracing Service

    Running

    SPUserCodeV4

    SharePoint User Code Host

    Stopped

    SPWriterV4

    SharePoint VSS Writer

    Your goal is to understand the concept of a pipeline, why you use it, and when to use it.

  • Step 2: Learn about parameter sets.

    See Parameter Sets Information

    Parameter sets provide multiple ways to use the same command. Parameter sets are mutually exclusive. You can't combine parameters from different parameter sets.

    For example, the Get-SPSite cmdlet has four different ways that it can be used. The multiple lines of syntax make it a parameter set. Each takes a different parameter set.

    Here is the syntax for the Get-SPSite cmdlet:

    Get-SPSite [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

    Get-SPSite [-Identity] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-Regex <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

    Get-SPSite -ContentDatabase <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-WhatIf [<SwitchParameter>]]

    Get-SPSite -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-WhatIf [<SwitchParameter>]]

    In this syntax, the parameter that makes each parameter set unique is bold. If you decide to use the WebApplication parameter, then you can only use the parameters from the first parameter set. You can't use the Regex parameter from the second parameter set. If you use parameters from different sets, you receive the following error message: "Parameter set cannot be resolved".

    Your goal is to understand and use parameter sets correctly.

  • Step 3: Learn about the Get-Member cmdlet

    See Get-Member

    To display a list of all the methods and properties that are associated with any cmdlet, use the Get-Member cmdlet.

    For example, you might want to know the web application, zone, and owner information for each site collections in your farm. The default output of the Get-SPSite cmdlet displays none of these properties. To complete this task, you could go to the SharePoint Central Administration website and see the web application, zone and owner information that is defined for each site collection. If you have hundreds or thousands of site collections, this could take some time. The Get-Member cmdlet displays all of the properties and methods of a cmdlet. So, using piping and the following simple lines of syntax is more efficient than using the SharePoint Central Administration website.

    First, determine whether web application, zone, and owner properties are available by typing this syntax:

    Copy code
    Get-SPSite | Get-Member

    You will see the owner, webapplication, and zone properties are available.

    Next use the Format-List cmdlet and pipe the properties that you want to display by typing the following syntax:

    Copy code
    Get-SPSite | Format-List owner, webapplication, zone

    Another way to use the Get-Member cmdlet is to use variables that store values. The variable will be used to display quota level information for each site collection in the SharePoint farm. For more information about variables, see about_Variables.

    We'll use a variable, $a, to store the results of every site collection in the farm, and then we'll use the properties that Get-Member cmdlet returns. This example displays quota-level information for each site collection.

    First, set a variable that will contain the result of each site collection.

    Copy code
    $a=Get-SPSite

    Next, use the variable and any property that the Get-Member cmdlet returned to perform an action. This example uses the Quota property to display the quota levels.

    Copy code
    $a.quota

    We could have easily used the Secondary Contact property to display the secondary contacts for each site collection in the farm or the Owner property to return the owner of each site collection. Hopefully you can see the power of the Get-Member cmdlet.

    Your goal is to understand how to display and use the properties and methods of a cmdlet by using the Get-Member, Format-List cmdlets, and variables.

  • Step 4: Learn about aliasing

    See about_Aliases.

    Sometimes you use cmdlet names that are long or repeatedly use the same cmdlet. In these cases, you might want to use aliasing. Simply put, an alias is another name that is assigned to a cmdlet, function, or script. If a cmdlet does not have an alias, you can use the Set-Alias cmdlet to create or change an alias for an existing cmdlet, script or function. To display a list of default aliases within Windows PowerShell, use the Get-Alias cmdlet.

    The Get-Alias cmdlet is a good start, but what if you want to find an alias that belongs to a specific cmdlet? You can use the Get-Alias cmdlet and the Where-Object cmdlet to filter a set of results to achieve this goal.

    This example returns a list of aliases with the Add noun. From a Windows PowerShell Command Prompt, type the following syntax:

    Copy code
    Get-Alias | Where-object {$_.Definition -like "add*"}

    CommandType Name Definition

    Alias

    ac

    Add-Content

    Alias

    asnp

    Add-PSSnapin

    If a certain SharePoint cmdlet does not have an alias, you can use the Set-Alias cmdlet to create an alias. The following example creates the "gsp" alias for the Get-SPSite cmdlet.

    Copy code
    Set-Alias gsp Get-SPSite

    Now when you type the following syntax from the Windows PowerShell command prompt, all of the site collections in your farm are displayed:

    Copy code
    gsp
    Important:

    By default, no aliases are defined for any SharePoint 2013 cmdlet. You must create an alias for each SharePoint cmdlet that you want to use. After you create a list of custom aliases, you must guarantee that they are saved. By default, custom aliases are stored in the current active Windows PowerShell session. After you close the session, all custom aliases are lost.

    To save custom aliases, use of the following options:

    1. Use the Export-Alias cmdlet to export the aliases to a file, and then use the Import-Alias cmdlet to import the file to your Windows PowerShell session.

    2. Add the Set-Alias cmdlet to your Windows PowerShell profile.

    For more information about how to save custom aliases to your Windows PowerShell session by using the Export-Alias, Import-Alias, or Set-Alias cmdlets, see the "Keeping Aliases Around" section in Windows PowerShell Aliases.

    Your goal is to understand when to use aliasing, how to create aliases, and how to save them across Windows PowerShell sessions.

Level 300

The following resources contain advanced information about Windows PowerShell in SharePoint 2013.

  • Step 1: Learn about scripting.

    See the "Scripts and execution policy" section of Use Windows PowerShell to administer SharePoint 2013.

    Levels 100 and 200 demonstrate how to run a single command, a series of commands, and a series of commands that are piped to complete a task. But what if you want to update a certain property for several thousand site collections in a SharePoint farm or you want to create 10,000 users? Although you could use the SharePoint Central Administration website to complete this task, it would take you days if not weeks. Windows PowerShell scripting enables you to complete these tasks in minutes or even seconds.

    Scripting is an automated way to complete a series of commands. A script is a text file that contains one or more Windows PowerShell commands. Windows PowerShell scripts have a .ps1 file name extension. Before you can run a script, you must understand the concept of execution policies. For more information, see about_Execution_Policies.

    No one, not even the original owner of the script, can run a script until the execution policy level is changed from Restricted to another level. The Restricted policy is the default policy for Windows PowerShell. However, the minimum required execution policy for SharePoint 2013 is RemoteSigned.

    To understand scripting concepts, see Running Windows PowerShell scripts.

    To view and download sample scripts for SharePoint 2010 and 2013, see Script Gallery

    Your goal is to understand the permission that is required to run scripts and how to execute a script file.

Additional Resources

  • Windows PowerShell for SharePoint 2013 Resource Center

  • Windows PowerShell for SharePoint 2013 reference

  • Getting to know Windows PowerShell

  • Scripting with Windows PowerShell

  • Cmdlet Parameter Sets

Feedback

Your feedback is valuable and welcome! Please rate this content by using the Did you find this helpful section at the bottom of the article, or send your comments and suggestions to SharePoint IT Documentation Feedback (itspdocs@microsoft.com). The author will review your comments and use them to help improve this documentation. Your e-mail address won't be saved or used for any other purposes.


User profiles for SharePoint Server 2013 learning roadmap

Published: March 12, 2013

Use this learning roadmap to gain expertise about user profiles and associated technologies in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Microsoft SharePoint Server 2013 makes it easy for people to work together. SharePoint 2013 enables you and your employees to set up web sites to share information with others, manage documents from start to finish, and publish reports to help everyone make informed decisions. A user profile is a collection of properties that describes a single user. A user profile also includes the policies and other settings that are associated with each property. SharePoint Server 2013 uses these user profiles in a variety of ways, for example, to organize information about the relationships among multiple users.

If you have not worked with user profiles yet, this article can help you learn how to build expertise with user profiles in SharePoint Server 2013. This article includes prerequisite articles that explain many fundamental concepts that you have to understand. After you understand the basics, you can start to learn about how to work with user profiles in SharePoint Server 2013 with the resources in the Level 100 (introductory) and 200 (intermediate) sections.

Learning Roadmap Banner

We recommend that you read the articles in the order listed.

  • Prerequisite information

  • Level 100

  • Level 200

  • Level 300

  • Additional Resources

Prerequisite information

This section contains links to resources that explain background information that you should understand before you work with user profiles in SharePoint Server 2013.

  • Step 1: Learn about SharePoint logical architecture and topologies

    You must be familiar with the logical components and physical components of a SharePoint environment so that you can use and manage user profiles in your SharePoint farm.

    • Logical components

      • Web applications

      • Service applications

      • Site collections

    • Physical components

      • Web servers

      • Application servers

      • Database servers

    See Plan logical architectures for SharePoint 2013, the Topologies model, the Services model, and the Architecture design for SharePoint 2013 IT Pros Resource Center.

    Your goal is to understand the pieces of the logical and physical architecture of SharePoint so that you understand what level of the architecture in which you have to work.

  • Step 2: Learn about SharePoint databases

    SharePoint Server 2013 has several database types. See the Databases model.

    Your goal is to understand the types and names of the databases that SharePoint Server 2013 uses so that you know how to find and manage the databases that contain user profiles.

  • Step 3: Learn about service applications in SharePoint Server

    See About service applications and services in SharePoint 2013 and Manage service applications in SharePoint 2013.

    Your goal is to learn about how deployed services are used and shared across sites in a SharePoint farm and how to manage those services.

  • Step 4: Learn about new social computing features in SharePoint Server 2013 social computing

    The social computing and collaboration features in SharePoint Server 2013 enable you to administer social computing features and enable enterprise users to share and collaborate. Features such as Community Sites, the Community Portal, My Sites, and the microblog and feeds experience all involve user profiles. See What's new in social computing in SharePoint Server 2013.

    Your goal is to understand how user profiles works with the new social computing features in SharePoint Server 2013.

  • Step 5: Learn about Managing Active Directory Domain Services (AD DS), including managing organizational units (OUs), groups and users, and working with domain controllers

    See Active Directory Domain Services Overview.

    Your goal is to understand, at a high-level, the AD DS server role in Windows Server and how administrators can use AD DS to organize elements of a network, such as users, computers, and other devices, into a hierarchical containment structure. The hierarchical containment structure includes the AD DS forest, domains in the forest, and organizational units (OUs) in each domain.

  • Step 6: Learn about Forefront Identity Manager (FIM)

    For an overview of FIM 2010 documentation and guidance for using it, see the Documentation Roadmap. The SharePoint synchronization service includes a version of FIM that it uses to synchronize user properties between the directory store and the User Profile service application. Your goal is to gain a general understanding of how FIM works so that you can configure FIM for synchronization.

Level 100

The following resources contain introductory information about user profiles in SharePoint Server.

  • Step 1: Learn about user profiles

    See Plan user profiles in SharePoint Server 2013.

    Your goals are to understand what makes up a user profile and the source of the properties in user profiles. You will also gain an understanding of the tools that are available for you to manage user profiles.

  • Step 2: Learn about the User Profile service application

    See Overview of the User Profile service application in SharePoint Server 2013.

    Your goal is to understand how to set up and manage the User Profile service application in SharePoint Server 2013.

Level 200

The following resources contain intermediate information about user profiles in SharePoint Server.

  • Step 1: Learn about profile synchronization

    See Overview of profile synchronization in SharePoint Server 2013 and Plan profile synchronization for SharePoint Server 2013.

    Your goal is to understand the various methods that synchronize profiles from your directory source to SharePoint Server 2013.

  • Step 2: Learn about performing profile synchronization

    See Synchronize user and group profiles in SharePoint Server 2013 and Configure profile synchronization by using SharePoint Active Directory Import in SharePoint Server 2013.

    Your goals are to understand the steps that synchronize profiles from your directory source to SharePoint Server 2013. This includes directly from AD DS to SharePoint Server 2013 by using the Active Directory import method or by using the SharePoint Server synchronization tool.

  • Step 3: Learn about maintaining synchronized profiles

    See Maintain user profile synchronization settings in SharePoint Server 2013.

    Your goal is to understand how to maintain profiles after you have synchronized them from the directory source to SharePoint Server 2013. This includes additional administrative tasks such as excluding users whose accounts are disabled, what to do when you need to change the profile schema, and more.

Level 300

The following resources contain advanced information about user profiles in SharePoint Server.

  • Step 1: Learn how to grant the appropriate permissions in AD DS that are used for profile synchronization

    See Grant Active Directory Domain Services permissions for profile synchronization in SharePoint Server 2013.

    Your goal is to be able to configure the permissions that are required to synchronize profile information.

Additional Resources

  • SharePoint 2013 training for IT pros - All presentations in Module 7: SharePoint 2013 social features

  • Resource Center: Identity management for SharePoint 2013 (IT pros)

  • Scenario: Personal sites (My Sites) in SharePoint Server 2013

Feedback

Your feedback is valuable and welcome! Please rate this content by using the Did you find this helpful? section at the bottom of the article, or send your comments and suggestions to SharePoint IT Documentation Feedback (itspdocs@microsoft.com). The author will review your comments and use them to help improve this documentation. Your e-mail address won't be saved or used for any other purposes.


Database management for SharePoint 2013 learning roadmap

Published: April 30, 2013

Summary: Use this learning roadmap to build expertise about database management in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint 2013 makes it easy for people to work together. SharePoint 2013 enables you and your employees to set up web sites to share information with others, manage documents from start to finish, and publish reports to help everyone make informed decisions. Database management in SharePoint 2013 depends on SQL Server. The capacity and feature requirements of your SharePoint environment determine the edition of SQL Server that you run and the size of the databases.

The following actions apply to management of SharePoint 2013 databases:

  • Create

  • Upgrade

  • Move and rename

  • Back up and restore

If you are new to database management, information in this article can help you learn about database management and the features that are available. Prerequisite articles explain the fundamentals of database management. You must understand the prerequisite information first. Subsequent articles assume that you understand the fundamentals. After you understand the basics, you can read articles in the Level 100, 200, and 300 sections.

Learning Roadmap Banner

We recommend that you read the articles in the order listed.

  • Prerequisite information

  • Level 100

  • Level 200

  • Level 300

  • Additional Resources

Prerequisite information

This section contains links to many articles and books that contain background information that will help you fully understand how database management works.

  • Step 1: Learn about the databases that support SharePoint 2013.

    SharePoint 2013 is an application that is built on the SQL Server database engine. Most SharePoint content and settings are stored in SQL Server in relational databases. The SharePoint 2013 system databases include the Configuration, Content, and Central Administration Content databases.

    SharePoint 2013 uses the following types of databases:

    • Configuration

    • Content

    • Service application

    See the Databases that support SharePoint 2013 model. For comprehensive details about all SharePoint 2013 databases, see Database types and descriptions (SharePoint 2013).

    Your goal is to understand the different types of databases that support SharePoint 2013 and their requirements. It is important to understand database sizes and locations, plus any requirements that the database has so you can optimize the performance in a SharePoint 2013 farm.

  • Step 2: Learn about SQL Server in a SharePoint 2013 environment.

    SQL Server is a required part of SharePoint 2013 because it stores all of the relational databases. SharePoint 2013 supports SQL Server 2008 R2 with Service Pack 1 (SP1) and SQL Server 2012. See Overview of SQL Server in a SharePoint environment (SharePoint 2013). For configuration steps, see Best practices for SQL Server in a SharePoint Server farm.

    Your goal is to understand how to interact with SharePoint 2013 databases that are stored in SQL Server. Also learn how to use SQL Server to plan and maintain databases in your SharePoint 2013 farm.

Level 100

The following articles contain introductory information about database management in SharePoint 2013.

  • Step 1: Learn about database management in the SharePoint 2013 upgrade process.

    See Overview of the upgrade process to SharePoint 2013.

    Your goal is to learn about the three SharePoint 2013 upgrade stages that involve databases. Stages two, three, and four include; copy databases to the new farm, upgrade the service applications, and then upgrade the content databases.

  • Step 2: Learn about backup and recovery in SharePoint 2013.

    See Overview of backup and recovery in SharePoint 2013.

    Your goal is to learn about the backup and restore processes that are available for SharePoint 2013. It is important to have a backup and recovery plan before you deploy SharePoint 2013 to protect your data. An effective backup and recovery strategy is a required process to make sure that your data is available. At any point in time, you may have to restore your SharePoint databases, sites, site collections, document libraries, and digital content. While this is considered disaster recovery, it is an absolute requirement as you manage the databases that contain the SharePoint 2013 data.

  • Step 3: Learn about how to use Remote BLOB Storage (RBS) in a SharePoint 2013 farm.

    See Overview of RBS in SharePoint 2013.

    Your goal is to learn how and when to use Remote BLOB Storage (RBS) in a SharePoint 2013 farm.

Level 200

The following articles contain intermediate information about database management as it relates to backup and restore solutions in SharePoint 2013.

  • Step 1: Learn about how to prepare to back up and restore a SharePoint 2013 farm.

    See Prepare to back up and restore farms in SharePoint 2013.

    Your goal is to learn about requirements and restrictions for backup and recovery in SharePoint 2013. Besides natural disasters and system failures, there are business reasons why you should back up your SharePoint 2013 farm.

  • Step 2: Learn about SharePoint 2013 backup solutions and how to restore them.

    See Backup solutions in SharePoint 2013 and Restore (SharePoint 2013).

    Your goal is to understand how to implement the backup solutions and then restore these in SharePoint 2013. The backup and restore solutions and procedures include SharePoint system databases, service applications, farms, farm configurations, web applications, site collections, and apps for SharePoint. Basically anything that you can back up in SharePoint 2013, you can also restore.

  • Step 3: Learn about best practices for backup and restore and for SQL Server in a SharePoint 2013 farm.

    See Backup and restore best practices in SharePoint 2013 and Best practices for SQL Server in a SharePoint Server farm.

    Your goal is to become familiar with Microsoft recommendations for backup and restore procedures. Also, learn the recommended processes to deploy SQL Server in a SharePoint 2013 farm. Both of these areas are important aspects to deploy and maintain SharePoint 2013.

Level 300

The following articles contain advanced information about database management in SharePoint.

  • Step 1: Learn about the database management procedures for how to move and rename service application databases in SharePoint 2013.

    See Move service application databases (SharePoint 2013) and Rename service application databases in SharePoint 2013.

    Your goal is learn how to move and rename service application databases in SharePoint 2013. Some service application databases share common steps. Others have specific tasks that you must complete in a specific order.

  • Step 2: Learn about complex areas of database management that involve adding, attaching, and detaching content databases. Also learn about how to move content databases and move SharePoint 2013 site collections between databases.

    See Add content databases in SharePoint 2013, Attach or detach content databases in SharePoint 2013, and Move content databases in SharePoint 2013. Also see Move site collections between databases in SharePoint 2013.

    Your goal is to understand the complex procedures that manage content databases and site collections as they relate to databases in a SharePoint 2013 farm.

  • Step 3: Learn about the complex process to move all SharePoint databases and how to implement RBS in a SharePoint 2013 farm.

    See Move all databases in SharePoint 2013 and Install and configure RBS in a SharePoint 2013 farm.

    Your goal is to understand and become efficient when you have to move all SharePoint databases and deploy RBS in a SharePoint 2013 farm.

Additional Resources

  • Supported high availability and disaster recovery options for SharePoint databases (SharePoint 2013)

  • SharePoint and Database Statistics: Why are they out-of-date and what to do about it.

Feedback

Your feedback is valuable and welcome! Please rate this content by using the Did you find this helpful section at the bottom of the article, or send your comments and suggestions to SharePoint IT Documentation Feedback (itspdocs@microsoft.com). The author will review your comments and use them to help improve this documentation. Your e-mail address won't be saved or used for any other purposes.


Permissions for SharePoint 2013 learning roadmap
See also

Updated: May 21, 2013

Summary: Use this learning roadmap to build expertise in permissions and permissions management in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint 2013 makes it easy for people to work together. SharePoint 2013 enables you and your employees to set up web sites to share information with others, manage documents from start to finish, and publish reports to help everyone make informed decisions. Permissions in SharePoint 2013 define how users and apps obtain authorized access to protected SharePoint resources.

If you are new to permissions for SharePoint 2013, this topic can help you identify what you need to learn to understand how to plan and implement permissions and permissions management to control authorized access to resources in a SharePoint 2013 environment. These resources include SharePoint site collections, SharePoint subsites, team sites, site and subsite content (such as documents, lists, and calendars), and apps for SharePoint. This article includes prerequisite information that explains SharePoint and Active Directory Domain Services (AD DS) fundamentals. You must understand the prerequisite topics first. Subsequent articles for permissions in SharePoint 2013 assume that you understand the fundamentals. After you understand the basics, you can read articles in the Level 100, 200, and 300 sections.

Learning Roadmap Banner

We recommend that you read the articles in the order listed.

  • Prerequisite information

  • Level 100

  • Level 200

  • Level 300

  • Additional Resources

Prerequisite information

This section contains links to many articles and books that contain background information that will help you fully understand how permissions in SharePoint 2013 works.

  • Step 1: Learn about site structure in SharePoint 2013.

    See Overview of sites and site collections in SharePoint 2013.

    Your goal is to understand the structure of sites in SharePoint 2013, such as web applications, site collections, and subsites.

  • Step 2: Learn about Active Directory Domain Services (AD DS) security groups.

    Your goal is to understand how to create and manage the membership of AD DS security groups, which you can use to configure SharePoint permissions.

  • Step 3: Learn about permissions in SharePoint 2013 identity management.

    See Overview of identity management in SharePoint 2013.

    Your goal is to understand the role of permissions in the authorization methods for identity management in SharePoint 2013.

Level 100

The following articles contain introductory information about permissions in SharePoint 2013.

  • Step 1: Learn the basic concepts of permissions in SharePoint 2013.

    See Overview of site permissions in SharePoint 2013.

    View the following:

    Understanding permissions in SharePoint video

    Video (play button) icon

    Your goal is to understand the basic ideas of SharePoint permissions, including permission levels, SharePoint groups, securable objects, fine-grained permissions, and permission inheritance.

  • Step 2: Learn how to plan site permissions in SharePoint 2013.

    See Plan site permissions in SharePoint 2013.

    Your goal is to understand the guidelines to plan permissions in a site, including when to use and break permission inheritance.

  • Step 3: Learn how to plan for managing app permissions in SharePoint 2013.

    See Plan app permissions management in SharePoint 2013.

    Your goal is to understand the details of app permission request scopes, app permission requests, and app authorization policies when you deploy apps for SharePoint.

  • Step 4: Learn about the levels of administration for managing access in a SharePoint 2013 environment.

    See Choose administrators and owners for the administration hierarchy in SharePoint 2013.

    Your goal is to understand the different groups and their level of administration at the server or farm, shared services, web application, and site levels.

  • Step 5: Learn about the permission levels and groups for managing access in a SharePoint 2013 environment.

    See Determine permission levels and groups in SharePoint 2013, Assign permission levels in SharePoint 2013, and Overview of the Contribute permission level in SharePoint 2013.

    Your goal is to understand the default SharePoint groups and permission levels, when you have to have a custom permission level or group, and how to use AD DS groups when you assign permissions

Level 200

The following articles contain intermediate information about permissions in SharePoint 2013.

  • Step 1: Learn about administrative and service accounts in SharePoint 2013.

    See Initial deployment administrative and service accounts in SharePoint 2013 and Plan for administrative and service accounts in SharePoint 2013.

    Your goal is to understand the requirements for the administrative and service accounts that you might have to deploy on servers that are running SharePoint 2013 or SQL Server in a SharePoint 2013 environment.

  • Step 2: Learn about account permissions in SharePoint 2013.

    See Account permissions and security settings in SharePoint 2013.

    Your goal is to understand the purpose and default settings for administrative accounts, service application accounts, database roles, and group permissions in a SharePoint 2013 environment.

  • Step 3: Learn about web application permissions management and permissions policy management for web applications and users.

    See Manage permissions for a web application in SharePoint 2013 and Manage permission policies for a web application in SharePoint 2013.

    Your goal is to understand how to manage user permission policies and permission policy levels for a web application in SharePoint 2013.

  • Step 4: Learn about how to manage passwords in SharePoint 2013.

    See Plan automatic password change in SharePoint 2013, Configure automatic password change in SharePoint 2013, and Change administration-account passwords in SharePoint 2013.

    Your goal is to understand how to plan and configure the initial deployment and automatic updating of passwords across multiple accounts, without having to perform multiple manual procedures, in a SharePoint 2013 environment.

  • Step 5: Learn about how to configure custom permissions in SharePoint 2013.

    See Configure custom permissions in SharePoint 2013.

    Your goal is to understand how to customize an existing permission level or create a new permission level to configure custom permissions.

  • Step 6: Demonstrate SharePoint permissions in a test lab.

    See Test Lab Guide: Demonstrate permissions with SharePoint Server 2013.

    View the following:

    Demonstrate permissions with SharePoint Server 2013 test lab guide overview video

    Video (play button) icon

    Your goal is to configure and demonstrate SharePoint permissions for three user scenarios involving site collections and subsites in a test lab.

Level 300

The following articles contain advanced information about permissions in SharePoint 2013.

  • Step 1: Learn about fine-grained permissions in SharePoint 2013.

    See Best practices for using fine-grained permissions in SharePoint Server 2013, Fine-grained permission reference for SharePoint Server 2013, and Troubleshoot common fine-grained permissions issues for SharePoint Server 2013.

    Your goal is to understand how to use, understand, and troubleshoot fine-grained permissions to enable a more precisely defined level of resource access in a SharePoint 2013 environment.

  • Step 2: Learn about the details of the default permission levels and user permissions in SharePoint 2013.

    See User permissions and permission levels in SharePoint 2013.

    Your goal is to understand the specific set of permissions for each default permission level and the role of each list, site, and personal user permission in SharePoint 2013.

Additional Resources

  • Authentication in SharePoint 2013 learning roadmap

Feedback

Your feedback is valuable and welcome! Please rate this content by using the Did you find this helpful section at the bottom of the article, or send your comments and suggestions to SharePoint IT Documentation Feedback (itspdocs@microsoft.com). The author will review your comments and use them to help improve this documentation. Your e-mail address won't be saved or used for any other purposes.

See also

Learning roadmaps for SharePoint 2013

Change History

Date | Description
May 21, 2013 | Added links to the new "Understanding Permissions" video and the "Demonstrate Permissions with SharePoint Server 2013 test lab guide" and overview video.
May 7, 2013 | Initial publication


SharePoint Products for the technical decision maker

Updated: June 18, 2013

Summary: This group of articles specifically for technical decision makers discusses SharePoint Products.

Applies to: SharePoint

In this section:

  • Understanding the Microsoft Cloud (white paper) Using SharePoint Products as an example, this paper discusses the kinds of cloud-based software and their benefits for organizations of varying sizes.

  • Benefits of Web Platform Consolidation (white paper) Using SharePoint Products as an example, this paper discusses the benefits of web platform consolidation for organizations of varying sizes.

Change History

Date | Description
June 18, 2013 | Added a new white paper that discusses the benefits of web platform consolidation. Using SharePoint Products as an example, the new white paper discusses the benefits of web platform consolidation for organizations of varying sizes.
May 28, 2013 | Initial publication


Understanding the Microsoft Cloud (white paper)
See also

Published: May 28, 2013

Summary: Using SharePoint Products as an example, this paper discusses the kinds of cloud-based software and their benefits for organizations of varying sizes.

Applies to: SharePoint Online | BPOS (Deskless Worker suite) | Windows Azure

Understanding the Microsoft Cloud (white paper)

Trying to understand what a company means by a 'cloud' offering can seem like trying to understand fog. The term 'cloud' has come to mean different things to different people. Much of the confusion can be chalked up to marketing teams embracing the momentum of the 'cloud' buzzword. In the end, the benefit of the 'cloud' is that you offload the burden of server infrastructure and maintenance, and you are left with a simple, straightforward cost structure.

The white paper can be downloaded from the Microsoft Download Center, here: Understanding the Microsoft Cloud (http://go.microsoft.com/fwlink/p/?LinkId=301966)

See also

Windows Azure
Office 365
Dynamics CRM


Benefits of Web Platform Consolidation (white paper)
See also

Published: June 11, 2013

Summary: Using SharePoint Products as an example, this paper discusses the benefits of web platform consolidation for organizations of varying sizes.

Applies to: SharePoint Server 2013

Benefits of Web Platform Consolidation (white paper)

It would be wonderful if an organization could just appear out of the dark ages (before the Internet) and adopt the latest technology. If such a scenario were to occur, the newly awakened organization could avail itself of the latest standards. The result would be a tightly integrated ecosystem of computer technology all working together in harmony. Unfortunately, such a scenario almost never happens. This white paper explores the benefits of consolidating disparate and incompatible web platforms into a single environment.

The white paper can be downloaded from the Microsoft Download Center, here: Benefits of Web Platform Consolidation (http://go.microsoft.com/fwlink/p/?LinkId=309029)

See also

Windows Azure
Office 365
SharePoint 2013 For IT Pros


Plan for SharePoint 2013

Summary: IT pros use planning and architecture content to develop conceptual, logical, and physical designs for configuring SharePoint 2013 features, servers, and topologies.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following content provides recommendations for system designs based on customer scenarios and includes information to help IT pros design a highly reliable, consistently available, and scalable system.

Downloadable resources about how to plan for SharePoint 2013

Download the following content for information about how to plan for SharePoint 2013.

 | Content | Description
Architecture icon | Technical diagrams for SharePoint 2013 | See architecture choices at a glance in these large-format diagrams.
Checklist icon | Planning worksheets for SharePoint 2013 | Record planning decisions for later references with these spreadsheet templates.
What's new icon (stem) | SharePoint Server IT Pro Reviewer's Guide | Read about how SharePoint Server 2013 builds on the investments of previous SharePoint releases to help you do the following: lower IT costs with a flexible and scalable collaboration platform; better manage risk by safeguarding your business with secure and reliable capabilities; increase productivity through cost-effective and efficient management.
Video (play button) icon | Video demos and training for SharePoint 2013 | Discover video presentations and training for SharePoint 2013.

TechNet articles about planning for SharePoint 2013

The following articles about how to plan for SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Planning for solutions | Planning for server farm architecture
Scenario icon | Building blocks
Plan user profiles and identities (SharePoint Server 2013) Find the set of overview and planning topics for user profiles and identities for SharePoint Server 2013. | System requirements for SharePoint 2013 Find information about hardware requirements, software requirements, browser support, and IP support for SharePoint 2013.
Plan for social computing and collaboration in SharePoint Server 2013 Learn how to plan for social computing and collaboration in SharePoint Server 2013. | Plan logical architectures for SharePoint 2013 Use the SharePoint design samples and architectural guidance to plan an architecture for a SharePoint 2013 deployment.
Plan document management in SharePoint 2013 Learn about the document management features of a solution based on SharePoint Server 2013. | Plan for on-premises or hosted virtualization in SharePoint 2013 Create a well-designed plan to install and configure SharePoint 2013 in a virtual environment.
Plan digital asset libraries in SharePoint Server 2013 Find links to articles and related resources that can help you plan digital asset libraries in SharePoint Server 2013. | Plan authentication in SharePoint 2013 Find resources about user authentication, server-to-server authentication, and app authentication to help you understand and plan for authentication in SharePoint 2013.
Plan records management in SharePoint Server 2013 Learn about records management in SharePoint Server 2013. | Permissions planning for sites and content in SharePoint 2013 Learn about how to plan permissions for sites and site content for SharePoint 2013.
Plan eDiscovery in SharePoint Server 2013 Find links to articles about eDiscovery in SharePoint Server 2013. | Overview of backup and recovery in SharePoint 2013 Understand backup and recovery scenarios, the backup architecture, and recovery processes before you plan to back up and restore SharePoint 2013.
Plan web content management in SharePoint Server 2013 Learn how to plan publishing sites by using SharePoint Server 2013 features. | Plan for backup and recovery in SharePoint 2013 Learn how to plan backup and recovery strategies for your SharePoint 2013 environment.
Plan search in SharePoint Server 2013 Create a well-designed plan to install and configure search in SharePoint 2013. | Plan for monitoring in SharePoint 2013 Learn about SharePoint monitoring tools and scenarios. Plan schedules and create a response plan to keep the SharePoint farm running.
Plan managed metadata in SharePoint Server 2013 Learn about managed metadata and taxonomy in SharePoint Server 2013. | Plan for high availability and disaster recovery for SharePoint 2013 Create a well-designed high availability plan and a disaster recovery plan that meets business goals and objectives.
Plan for business intelligence in SharePoint Server 2013 Learn about how SharePoint Server 2013 implements business intelligence to analyze data. | SQL Server and storage (SharePoint 2013) Learn how to plan for SQL Server 2008 R2 with Service Pack 1 (SP1) and SQL Server 2012 and storage configuration for SharePoint 2013.
Plan for Business Connectivity Services in SharePoint 2013 Learn to plan to use Microsoft Business Connectivity Services to access external data in SharePoint Server 2013. | Security planning for SharePoint 2013 farms Learn about how to plan SharePoint 2013 security for server farms.
Plan for Access Services in SharePoint Server 2013 Learn how to use Access Services in SharePoint Server 2013 to share solutions on the web. |
Plan email integration for a SharePoint farm in SharePoint 2013 Learn how to plan for email integration in SharePoint 2013. |
Plan for mobile devices in SharePoint 2013 Learn how to plan for your SharePoint Server 2013 mobile infrastructure. |
Fundamental site planning in SharePoint 2013 Learn about site collections, sites, and site templates in SharePoint 2013. |
Getting started with SharePoint Server 2013 workflow Read a high-level view of the SharePoint 2013 Workflow platform. |
Plan for administrative and service accounts in SharePoint 2013 Learn about the accounts to use to manage SharePoint 2013 deployment scenarios and services. |

Videos about planning for SharePoint 2013

The following video recordings about how to plan for SharePoint 2013 are available to view online or to download.

Video (play button) icon | Content | Description
 | SharePoint 2013 deployment planning and considerations for IT pros | Watch this training from SharePoint experts to learn what to consider when planning for deployment.
 | SharePoint Server 2013 hardware and software requirements | Get a video overview of the hardware and software required for SharePoint 2013

Additional resources about planning for SharePoint 2013

The following resources about how to plan for SharePoint 2013 are available from other subject matter experts.

Content Description

House icon

  • SharePoint TechCenter

  • Upgrade and migration resource center

Visit the TechCenter and resource centers to access videos, community sites, documentation, and more.

Code icon

  • SharePoint for developers

  • Build apps for SharePoint

Find developer resources for SharePoint 2013, including code samples, training, and SDKs.

Chat icon

  • SharePoint blog

  • SharePoint IT Pro Blog

  • Office 365 Technical Blog

Keep up with news from the teams that create and document SharePoint 2013.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support


System requirements for SharePoint 2013

Summary: Introduces articles that describe hardware, software, and other requirements for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Before you install SharePoint 2013, you must make sure that you have installed all required hardware and software. To effectively plan your deployment, you must understand the level of support that is provided for the web browsers that you will be using in your environment and how support for IP versions 4 and 6 is implemented in SharePoint 2013. You must also understand the URL and path length restrictions in SharePoint 2013.

The following articles on TechNet help you prepare for the installation of SharePoint 2013 by providing information about the prerequisites that you must have in order to run SharePoint 2013.

TechNet articles about SharePoint 2013 system requirements

The following articles about SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Hardware and software requirements for SharePoint 2013 | Describes the hardware and software requirements that you must meet to successfully install SharePoint 2013.
Building blocks | Software requirements for business intelligence in SharePoint Server 2013 | Lists the minimum software requirements to run Business Intelligence features in SharePoint Server 2013 including Power Pivot for SharePoint, SQL Server 2012 Reporting Services for SharePoint, Power View for SharePoint, Excel Services, PerformancePoint Services and Visio Services.
Checklist icon (not checked) | Plan browser support in SharePoint 2013 | Describes levels of support for web browsers to use with SharePoint 2013.
Building blocks | URL path length restrictions (SharePoint 2013 Preview) | Describes the specific URL path length and character restrictions in SharePoint 2013, Internet Explorer 7, and Internet Explorer 8 that you should be aware of when planning sites, navigation, and structure.
Building blocks | IP support in SharePoint 2013 | Describes SharePoint 2013 support for IP version 4 (IPv4) and IP version 6 (IPv6).
Checklist icon (not checked) | Software boundaries and limits for SharePoint 2013 | This article provides a starting point for planning the performance and capacity of your SharePoint Server 2013 farm, and includes performance and capacity testing results and guidelines for acceptable performance.
Building blocks | Capacity management and sizing overview for SharePoint Server 2013 | This article walks you through the concepts involved in capacity management and sizing SharePoint Server 2013 farms, and provides an overview of the planning process.

Additional resources about system requirements for SharePoint 2013

The following resources about SharePoint 2013 are available from other subject matter experts.

Content Description

TechNet logo

  • Installation and Deployment for SharePoint 2013 Resource Center

  • Capabilities and features in SharePoint 2013 Resource Center

Visit the Resource Centers to access videos, Community Sites, documentation, and more.


Hardware and software requirements for SharePoint 2013
See also

Updated: April 9, 2013

Summary: Lists the minimum hardware and software requirements to install and run SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Important:

If you contact Microsoft Customer Support Services about a production system that does not meet the minimum hardware specifications described in this document, support will be limited until the system is upgraded to the minimum requirements.

In this article:

  • Overview

  • Hardware and software requirements for other SharePoint 2013 capabilities

  • Hardware requirements—location of physical servers

  • Hardware requirements—web servers, application servers, and single server installations

  • Hardware requirements—database servers

  • Software requirements

  • Optional software

  • Links to applicable software

  • Prerequisite installer operations and command-line options

Important:

The information in this article applies to SharePoint Foundation 2013 and SharePoint Server 2013. For information about the features that each version supports, see the SharePoint 2013 Product Page.

Some of the hardware requirement values in this article are based on test results from SharePoint 2010 Products and still apply to SharePoint 2013. This article will be updated with appropriate values and republished when new data becomes available. Hardware requirement values obtained from SharePoint 2010 Products that are listed in this article do not apply to search in SharePoint 2013.

This article links to SharePoint 2010 Products guidance where that guidance is still valid. The SharePoint 2010 Products guidance is not applicable for search in SharePoint 2013 because the search architecture has changed significantly.

Overview

SharePoint 2013 provides for several installation scenarios. Currently, these installations include single server with built-in database installations, single-server farm installations, and multiple-server farm installations. This article describes the hardware and software requirements for SharePoint 2013 in each of these scenarios.

Hardware and software requirements for other SharePoint 2013 capabilities

If you plan to use capabilities that are offered through SharePoint 2013 or through other integration channels, such as SQL Server or Exchange Server, you also need to meet the hardware and software requirements that are specific to that capability. The following list provides links to hardware and software requirements for some SharePoint 2013 capabilities:

  • Hardware and software requirements (Project Server 2013)

  • For eDiscovery, each front-end web server must have the Exchange Web Services Managed API, version 1.2 installed. For more information, see the following articles:

    • Configure eDiscovery in SharePoint Server 2013

    • Configure Exchange for SharePoint eDiscovery Center

  • Software requirements for business intelligence in SharePoint Server 2013

  • Hardware requirements for search in SharePoint Server 2013:

    • Hardware requirements for search topologies for the enterprise

    • Hardware requirements for search topologies for Internet sites

  • Mobile device browsers supported in SharePoint 2013

Hardware requirements—location of physical servers

Some enterprises have data centers that are located in close proximity to one another and are connected by high-bandwidth fiber optic links. In this environment it is possible to configure the two data centers as a single farm. This distributed farm topology is called a stretched farm. Stretched farms for SharePoint 2013 are supported as of April 2013.

For a stretched farm architecture to work as a supported high-availability solution, the following prerequisites must be met:

  • There is a highly consistent intra-farm latency of <1ms one way, 99.9% of the time over a period of ten minutes. (Intra-farm latency is commonly defined as the latency between the front-end web servers and the database servers.)

  • The bandwidth speed must be at least 1 gigabit per second.

To provide fault tolerance in a stretched farm, use the standard best practice guidance to configure redundant service applications and databases. For more information, see Create a high availability architecture and strategy for SharePoint 2013.

Hardware requirements—web servers, application servers, and single server installations

The values in the following table are minimum values for installations on a single server with a built-in database and for web and application servers that are running SharePoint 2013 in a multiple server farm installation. For information about the deployment types that are used in this table, see the SharePoint 2013: Deployment model. You can download this model from the Install and deploy SharePoint 2013 (IT pros) resource center.

For all installation scenarios, you must have sufficient hard disk space for the base installation and sufficient space for diagnostics such as logging, debugging, creating memory dumps, and so on. For production use, you must also have additional free disk space for day-to-day operations. In addition, maintain two times as much free space as you have RAM for production environments. For more information, see Capacity management and sizing for SharePoint Server 2010.

Installation Scenario | Deployment type and scale | RAM | Processor | Hard disk space
Single server with a built-in database or single server that uses SQL Server | Development or evaluation installation of SharePoint Server 2013 or SharePoint Foundation 2013 with the minimum recommended services for development environments. For information, see Minimum recommended services for development environments. | 8 GB | 64-bit, 4 cores | 80 GB for system drive
Single server with a built-in database or single server that uses SQL Server | Development or evaluation installation of SharePoint Server 2013 or SharePoint Foundation 2013 running Visual Studio 2012 and the minimum recommended services for development environments. For information, see Minimum recommended services for development environments. | 10 GB | 64-bit, 4 cores | 80 GB for system drive
Single server with a built-in database or single server that uses SQL Server | Development or evaluation installation of SharePoint Server 2013 running all available services. | 24 GB | 64-bit, 4 cores | 80 GB for system drive
Web server or application server in a three-tier farm | Pilot, user acceptance test, or production deployment of SharePoint Server 2013 or SharePoint Foundation 2013. | 12 GB | 64-bit, 4 cores | 80 GB for system drive

Hardware requirements—database servers

The requirements in the following table apply to database servers in environments that have multiple servers in the farm.

Component Minimum requirement

Processor

  • 64-bit, 4 cores for small deployments (fewer than 1,000 users)

  • 64-bit, 8 cores for medium deployments (between 1,000 to 10,000 users)

RAM

  • 8 GB for small deployments (fewer than 1,000 users)

  • 16 GB for medium deployments (between 1,000 to 10,000 users)

For large deployments over 10,000 users, see the "Estimate memory requirements" section in Storage and SQL Server capacity planning and configuration (SharePoint Server 2010). This document does not apply to search in SharePoint 2013.

These values are larger than those recommended as the minimum values for SQL Server because of the distribution of data that is required for a SharePoint 2013 environment. For more information about SQL Server system requirements, see Hardware and Software Requirements for Installing SQL Server 2008 R2.

Hard disk

80 GB for system drive

Hard disk space depends on how much content that you have in your deployment. For information about how to estimate the amount of content and other databases for your deployment, see Storage and SQL Server capacity planning and configuration (SharePoint Server 2010).

Software requirements

The requirements in the following section apply to the following installations:

  • Single server with built-in database

  • Server farm with a single server in the farm

  • Server farm with multiple servers in the farm

Important:

SharePoint 2013 does not support single label domain names. For more information, see Information about configuring Windows for domains with single-label DNS names.

The Microsoft SharePoint Products Preparation Tool can assist you in the installation of the software prerequisites for SharePoint 2013. Ensure that you have an Internet connection, because some prerequisites are installed from the Internet. For more information about how to use the Microsoft SharePoint Products Preparation Tool, see Install SharePoint 2013 on a single server with SQL Server and Install SharePoint 2013 across multiple servers for a three-tier farm.

Minimum software requirements

This section provides minimum software requirements for each server in the farm.

Minimum requirements for a database server in a farm:

  • One of the following:

    • The 64-bit edition of Microsoft SQL Server 2012.

    • The 64-bit edition of SQL Server 2008 R2 Service Pack 1

  • The 64-bit edition of Windows Server 2008 R2 Service Pack 1 (SP1) Standard, Enterprise, or Datacenter or the 64-bit edition of Windows Server 2012 Standard or Datacenter

  • The SharePoint parsing process crashes in Windows Server 2008 R2 (KB 2554876)

  • FIX: IIS 7.5 configurations are not updated when you use the ServerManager class to commit configuration changes (KB 2708075)

  • Hotfix: ASP.NET (SharePoint) race condition in .NET 4.5 RTM:

    • Windows Server 2008 R2 SP1 (KB 2759112)

    • Windows Server 2012 (KB 2765317)

  • Microsoft .NET Framework version 4.5

Minimum requirements for a single server with built-in database:

  • The 64-bit edition of Windows Server 2008 R2 Service Pack 1 (SP1) Standard, Enterprise, or Datacenter or the 64-bit edition of Windows Server 2012 Standard or Datacenter

  • The SharePoint parsing process crashes in Windows Server 2008 R2 (KB 2554876)

  • FIX: IIS 7.5 configurations are not updated when you use the ServerManager class to commit configuration changes (KB 2708075)

  • Hotfix: ASP.NET (SharePoint) race condition in .NET 4.5 RTM:

    • Windows Server 2008 R2 SP1 (KB 2759112)

    • Windows Server 2012 (KB 2765317)

  • The Setup program installs the following prerequisite for a single server with built-in database:

    • Microsoft SQL Server 2008 R2 SP1 - Express Edition

  • The Microsoft SharePoint Products Preparation Tool installs the following prerequisites for a single server with built-in database:

    • Web Server (IIS) role

    • Application Server role

    • Microsoft .NET Framework version 4.5

    • SQL Server 2008 R2 SP1 Native Client

    • Microsoft WCF Data Services 5.0

    • Microsoft Information Protection and Control Client (MSIPC)

    • Microsoft Sync Framework Runtime v1.0 SP1 (x64)

    • Windows Management Framework 3.0 which includes Windows PowerShell 3.0

    • Windows Identity Foundation (WIF) 1.0 and Microsoft Identity Extensions (previously named WIF 1.1)

    • Windows Server AppFabric

    • Cumulative Update Package 1 for Microsoft AppFabric 1.1 for Windows Server (KB 2671763)

Minimum requirements for front-end web servers and application servers in a farm:

  • The 64-bit edition of Windows Server 2008 R2 Service Pack 1 (SP1) Standard, Enterprise, or Datacenter or the 64-bit edition of Windows Server 2012 Standard or Datacenter.

  • The SharePoint parsing process crashes in Windows Server 2008 R2 (KB 2554876)

  • FIX: IIS 7.5 configurations are not updated when you use the ServerManager class to commit configuration changes (KB 2708075)

  • Hotfix: ASP.NET (SharePoint) race condition in .NET 4.5 RTM:

    • Windows Server 2008 R2 SP1 (KB 2759112)

    • Windows Server 2012 (KB 2765317)

  • The Microsoft SharePoint Products Preparation Tool installs the following prerequisites for front-end web servers and application servers in a farm:

    • Web Server (IIS) role

    • Application Server role

    • Microsoft .NET Framework version 4.5

    • SQL Server 2008 R2 SP1 Native Client

    • Microsoft WCF Data Services 5.0

    • Microsoft Information Protection and Control Client (MSIPC)

    • Microsoft Sync Framework Runtime v1.0 SP1 (x64)

    • Windows Management Framework 3.0 which includes Windows PowerShell 3.0

    • Windows Identity Foundation (WIF) 1.0 and Microsoft Identity Extensions (previously named WIF 1.1)

    • Windows Server AppFabric

    • Cumulative Update Package 1 for Microsoft AppFabric 1.1 for Windows Server (KB 2671763)

Minimum requirements for client computers

  • A supported browser. For more information, see Plan browser support in SharePoint 2013. For information on browsers supported on mobile devices, see Mobile device browsers supported in SharePoint 2013.

Minimum recommended services for development environments

The following are the minimum SharePoint 2013 services and service applications that are recommended for development environments:

  • App Management service application

  • Central Administration web site

  • Claims to Windows Token service (C2WTS)

  • Distributed cache service

  • Microsoft SharePoint Foundation 2013 Site and Subscription Settings service

  • Secure Store Service

  • User Profile service application (SharePoint Server 2013 only)

Optional software

The optional software in this section is supported but is not required to install or use SharePoint 2013. This software might be required by capabilities such as business intelligence. For more information about system requirements for other capabilities, see Hardware and software requirements for other SharePoint 2013 capabilities.

Environment Optional software

Single server with built-in database, front-end web servers, and application servers in a farm

  • .NET Framework Data Provider for SQL Server (part of Microsoft .NET Framework)

  • .NET Framework Data Provider for OLE DB (part of Microsoft .NET Framework)

  • Workflow Manager

    You can install Workflow Manager on a dedicated computer.

  • Microsoft SQL Server 2008 R2 Reporting Services Add-in for Microsoft SharePoint Technologies

    This add-in is used by Access Services for SharePoint 2013.

  • Microsoft SQL Server 2012 Data-Tier Application (DAC) Framework 64-bit edition

  • Microsoft SQL Server 2012 Transact-SQL ScriptDom 64-bit edition

  • Microsoft System CLR Types for Microsoft SQL Server 2012 64-bit edition

  • Microsoft SQL Server 2012 with Service Pack 1 (SP1) LocalDB 64-bit edition

  • Microsoft Data Services for the .NET Framework 4 and Silverlight 4 (formerly ADO.NET Data Services)

  • Exchange Web Services Managed API, version 1.2

  • Microsoft SQL Server 2008 R2 Remote Blob Store which is part of the Microsoft SQL Server 2008 R2 Feature Pack

  • SQL Server 2008 R2 Analysis Services ADOMD.NET

  • KB 2472264

    If you are running a geo-distributed deployment and your servers are running Windows Server 2008 R2, then installing KB 2472264 can optimize network latency in a dedicated datacenter network. For more information, and to download the software, see You cannot customize some TCP configurations by using the netsh command in Windows Server 2008 R2.

Client computer

  • Windows 7

    For information about how to use Windows 7 with SharePoint 2013 in a development environment, see Setting Up the Development Environment for SharePoint 2010 on Windows Vista, Windows 7, and Windows Server 2008.

  • Silverlight 3

  • Office 2013

  • Microsoft Office 2010 with Service Pack 1

    With KB 2553248

  • Microsoft Office 2007 with Service Pack 2

    With KB 2583910

  • Microsoft Office for Mac 2011 with Service Pack 1

  • Microsoft Office 2008 for Mac version 12.2.9

    Support ends April 9, 2013.

Links to applicable software

To install Windows Server 2008 R2 SP1, Windows Server 2012, SQL Server, or SharePoint 2013, you can go to the web sites that are listed in this section. You can install most software prerequisites through the SharePoint 2013 Start page. The software prerequisites are also available from web sites that are listed in this section. You can enable the Web Server (IIS) role and the Application Server role in Server Manager.

In scenarios where installing prerequisites directly from the Internet is not possible you can download the prerequisites and then install them from a network share. For more information, see Install prerequisites for SharePoint 2013 from a network share.

  • Windows 7 and Windows Server 2008 R2 Service Pack 1 (SP1) (KB 976932)

  • Microsoft SharePoint Server 2013

  • Microsoft SharePoint Foundation 2013

  • Office 365 Enterprise

  • The SharePoint parsing process crashes in Windows Server 2008 R2 (KB 2554876)

  • FIX: IIS 7.5 configurations are not updated when you use the ServerManager class to commit configuration changes (KB 2708075)

  • Hotfix: ASP.NET (SharePoint) race condition in .NET 4.5 RTM:

    • Windows Server 2008 R2 SP1 (KB 2759112)

    • Windows Server 2012 and Windows 8 (KB 2765317)

  • Windows Server 2012, Datacenter Edition or Standard Edition

  • Microsoft SQL Server 2008 R2 Service Pack 1

  • Microsoft .NET Framework version 4.5

  • Microsoft SQL Server 2008 R2 SP1 - Express Edition

  • Workflow Manager

  • WCF Data Services 5.0 for OData

  • Microsoft Information Protection and Control Client (MSIPC)

  • Windows Management Framework 3.0 which includes Windows PowerShell 3.0

  • Microsoft Sync Framework Runtime v1.0 SP1 (x64)

  • Windows Identity Foundation 1.0 for Windows Server 2008 R2

  • Windows Identity Extensions for Windows Server 2008 R2

  • Microsoft SQL Server 2008 R2 Feature Pack which includes the Microsoft SQL Server 2008 R2 SP1 Native Client and the SQL Server Remote BLOB Store

  • Microsoft SQL Server 2008 R2 SP1 Feature pack which includes Microsoft SQL Server 2008 R2 ADOMD.NET

  • Microsoft Silverlight 3

  • Exchange Web Services Managed API, version 1.2

  • Microsoft SQL Server 2012 Native Client 64-bit edition - ENU\x64\sqlncli.MSI

  • Microsoft SQL Server 2012 Data-Tier Application (DAC) Framework 64-bit edition - ENU\x64\dacframework.msi

  • Microsoft SQL Server 2012 Transact-SQL ScriptDom 64-bit edition - SQLDOM.msi

  • Microsoft System CLR Types for Microsoft SQL Server 2012 64-bit edition - SQLSysClrTypes.msi

  • Microsoft SQL Server 2012 with Service Pack 1 (SP1) LocalDB 64-bit edition, which is also a component of SQL Server 2012 with Service Pack 1 (SP1) Express - ENU\x64\SqlLocalDB.msi

Prerequisite installer operations and command-line options

The SharePoint 2013 prerequisite installer (prerequisiteinstaller.exe) installs the following software, if it has not already been installed on the target server, in this order:

  1. Microsoft .NET Framework version 4.5

  2. Windows Management Framework 3.0

  3. Application Server Role, Web Server (IIS) Role

  4. Microsoft SQL Server 2008 R2 SP1 Native Client

  5. Windows Identity Foundation (KB974405)

  6. Microsoft Sync Framework Runtime v1.0 SP1 (x64)

  7. Windows Identity Extensions

  8. Microsoft Information Protection and Control Client

  9. Microsoft WCF Data Services 5.0

  10. Windows Server AppFabric

  11. Cumulative Update Package 1 for Microsoft AppFabric 1.1 for Windows Server (KB 2671763)

You can run prerequisiteinstaller.exe at a command prompt with the following options. When you run prerequisiteinstaller.exe at a command prompt, you may be asked to restart the server one or more times during the installation process. After rebooting, you should continue the prerequisite installation by running prerequisiteinstaller.exe with the /continue option.

  • /? Display command-line options

  • /continue This is used to tell the installer that it is continuing from a restart

  • /unattended No user interaction

The installer installs from the file that you specify in the command-line options described in the following list. In this list, <file> signifies the file from which you want to install. If you do not specify the <file> option, the installer downloads the file from the Internet and installs it. If the option does not apply to the current operating system, it is ignored.

  • /SQLNCli:<file> Install Microsoft SQL Server 2008 SP1 Native Client from <file>

  • /PowerShell:<file> Install Windows Management Framework 3.0 from <file>

  • /NETFX:<file> Install Microsoft .NET Framework version 4.5 from <file>

  • /IDFX:<file> Install Windows Identity Foundation (KB974405) from <file>

  • /IDFX11:<file> Install Windows Identity Foundation v1.1 from <file>

  • /Sync:<file> Install Microsoft Sync Framework Runtime SP1 v1.0 (x64) from <file>

  • /AppFabric:<file> Install Windows Server AppFabric from <file> (AppFabric must be installed with the options /i CacheClient,CachingService,CacheAdmin /gac)

  • /KB2671763:<file> Install Microsoft AppFabric 1.1 for Windows Server (AppFabric 1.1) from <file>

  • /MSIPCClient:<file> Install Microsoft Information Protection and Control Client from <file>

  • /WCFDataServices:<file> Install Microsoft WCF Data Services from <file>

Installation options

Certain prerequisites are installed by the prerequisite installer with specific options. Those prerequisites with specific installation options are listed below with the options that are used by the prerequisite installer.

  • Windows AppFabric

    /i CacheClient,CachingService,CacheAdmin /gac

  • Microsoft WCF Data Services

    /quiet

The prerequisite installer creates log files at %TEMP%\prerequisiteinstaller.<date>.<time>.log. You can check these log files for specific details about all changes the installer makes to the target computer.

See also

Installation and deployment for SharePoint 2013 IT Pros Resource Center

Change History

Date | Description
April 09, 2013 | Added a statement of support for stretched farms for SharePoint 2013.
July 16, 2012 | Initial publication


Plan browser support in SharePoint 2013
See also

Summary: Learn about how SharePoint 2013 supports Internet Explorer, Google Chrome, Mozilla Firefox, and Apple Safari.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

SharePoint 2013 supports several commonly used web browsers, such as Internet Explorer browser logo Internet Explorer, Google Chrome browser logo Google Chrome, Mozilla Firefox browser logo Mozilla Firefox, and Apple Safari browser logo Apple Safari. However, certain web browsers could cause some SharePoint 2013 functionality to be downgraded, limited, or available only through alternative steps.

As you plan your deployment of SharePoint 2013, we recommend that you review the browsers used in your organization to guarantee optimal performance with SharePoint 2013.

In this article:

  • Key planning phase of browser support

  • Browser support matrix

  • Browser details

  • ActiveX controls

  • Mobile browser support

Key planning phase of browser support

Browser support is an important part of your SharePoint 2013 implementation. Before you install SharePoint 2013, make sure that you know the browsers that SharePoint 2013 supports. The information in this article describes browser support in the following sections:

  • Browser support matrix

  • Browser details

Browser support matrix

The following table summarizes the support levels of typically used web browsers.

Browser | Supported | Not supported
Internet Explorer 10 | X |
Internet Explorer 9 | X |
Internet Explorer 8 | X |
Internet Explorer 7 |  | X
Internet Explorer 6 |  | X
Google Chrome (latest released version) | X |
Mozilla Firefox (latest released version) | X |
Apple Safari (latest released version) | X |

Browser details

Review the details of the web browser that you have or plan to use in your organization to make sure that the web browser works with SharePoint 2013 and according to your business needs.

Supported Internet Explorer versions

The product group makes every effort to validate that SharePoint functionality works correctly with released versions of Internet Explorer. Customers who want a more deeply validated browser interaction experience should strongly consider Internet Explorer.

Internet Explorer 10, Internet Explorer 9, Internet Explorer 8

Other supported browsers

  • Google Chrome (latest released version)

  • Mozilla Firefox (latest released version plus immediate previous version)

    For example, if the latest released version is 10, then version 9 would be supported.

  • Apple Safari (latest released version)

ActiveX controls

Some functionality in SharePoint 2013 requires ActiveX controls. This produces limitations on browsers which do not support ActiveX. Currently only 32-bit versions of Internet Explorer support this functionality. All other browsers have the following limitations.

Note:

Internet Explorer 10 does not support Active X controls when in immersive mode. The functionality for the controls listed below should only be expected to work in desktop mode.

Plugin name

DLL Filename

What it does

Supported browser version

Known limitations

Digital Signature

Dsigctrl.dll, dsigres.dll

Digital signing takes place in both the InfoPath client and on the InfoPath Forms Services server. Make sure that the following conditions exist:

  • Forms that are signed on the client can be verified on the server.

  • Forms that are signed on the server can be verified on the client.

Internet Explorer versions 8, 9 and 10

An inability to verify a form produces an error that states that the form cannot be signed.

NameCtrl

Name.dll

Enables a web page to display a contact card and presence status for people. Integrates through client-side APIs with Office 2013.

Supported in Internet Explorer versions 8, 9, and 10.

Firefox, Google Chrome are also supported by using a plug-in.

Internet Explorer version 10 immersive mode is not supported.

TaskLauncher

Nameext.dll

Used to export items in a task list to Project Server if Project 2010 is installed on the client computer.

All browsers

If software requirements are not met, an error message states that you need to install Project Server.

SpreadSheetLauncher

Owssupp.dll

Used to verify whether Excel is installed for Export to Excel feature.

Internet Explorer versions 8, 9, and 10

If Excel is not installed, an error message states that a list cannot be imported because a compatible spreadsheet application is not installed or is not compatible with the browser.

StssyncHandler

Owssupp.dll

Enables synchronization of lists of events and lists of contacts in SharePoint with a messaging application such as Outlook 2013.

Internet Explorer versions 8, 9, and 10

ExportDatabase

Owssupp.dll

Enables a user to use an application such as Access to create or open a database that contains SharePoint list data.

Internet Explorer versions 8, 9, and 10

To export a list, the client computer must have a SharePoint compatible application.

OpenDocuments

Owssupp.dll

Starts Office client applications so that a user can create a document or edit a document. Enables users to create documents that are based on a specified template, open documents as read-only, or open documents as read/write.

All except Internet Explorer version 10 in immersive mode.

If a compatible Office application or browser is not installed on a client, an error message states that the feature requires a SharePoint compatible application and web browser.

UploadCtl

Stsupld.dll

Enables drag-and-drop in SharePoint Server 2013 visual mode "upload multiple files" dialog box.

Internet Explorer versions 8 and 9.

CopyCtl

Stsupld.dll

Enables a user to copy a document on a SharePoint site to one or more locations on a server.

Internet Explorer versions 8, 9, and 10

In Firefox, Google Chrome, and immersive mode of Internet Explorer version 10, the copy progress dialog box is not displayed.

PPActiveX

PPSLAX.dll

Starts PowerPoint to open presentations from a slide library or publish individual slides to a slide library.

Internet Explorer versions 8, 9, and 10

Does not work on Click-to-Run installations of Office and version of Office that run on Windows for ARM.

BCSLauncher

BCSLaunch.dll

Starts the Visual Studio Tools for Office installer to install a Visual Studio Tools for Office package that has been generated on the server.

Internet Explorer versions 8, 9, and 10

Mobile browser support

To learn about the different mobile device browsers supported, see Mobile device browsers supported in SharePoint 2013

See also

Plan for SharePoint 2013


IP support in SharePoint 2013
See also

Summary: SharePoint 2013 supports Internet Protocol Version 4 (IPv4) and Internet Protocol Version 6 (IPv6).

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint 2013 supports the following environments:

  • IPv4-only

    In an IPv4-only environment, the network infrastructure supports address assignment, name registration and resolution, and routing for only IPv4-based network traffic. Note that even in an IPv4-only environment, the recommendation is that you leave IPv6 enabled on your Windows-based computers. If the network infrastructure does not support IPv6 traffic, SharePoint will use IPv4 traffic.

  • Mixed IPv4 and IPv6

    In a mixed IPv4 and IPv6 environment, the network infrastructure supports address assignment, name registration and resolution, and routing for both IPv4 and IPv6-based network traffic.

  • IPv6-only

    In an IPv6-only environment, the network infrastructure supports address assignment, name registration and resolution, and routing for only IPv6-based network traffic.

In a SharePoint environment, "mixed" can be defined as one of the following likely scenarios:

  • Both IPv4 and IPv6 protocols are running on hosts. This is also known as a dual-stack environment, in which both the IPv4 and IPv6 protocol stacks are enabled and being used.

  • Some of your client computers are using only IPv4, some of them are using only IPv6, and some of them are using both IPv4 and IPv6.

  • Your client computers are using only IPv4, but the server computers are using both IPv4 and IPv6.

By default, the IPv6 protocol and the IPv4 protocol are both installed and enabled in Windows 8, Windows Server 2012, Windows 7, Windows Server 2008 R2, Windows Vista, and Windows Server 2008. When both IPv4 and IPv6 are enabled, IPv6 is preferred over IPv4 when you are using names and Domain Name System (DNS) name query responses contain both types of addresses. Additionally, you can remove the IPv4 protocol so that the computer runs only IPv6.

To determine what versions are being used on your network, you can use the IPConfig.exe tool. If the display of the IPConfig command at a Command Prompt contains rows named "IPv6 Address" or "Temporary IPv6 Address," you have IPv6 in your environment. If all of the IPv6 addresses begin with "fe80" and correspond to rows named "Link-Local IPv6 Address," you do not have IPv6 in your environment. For additional information, see IPConfig.

The following list shows other important considerations about IPv6:

  • For any computer that is authenticated by using a domain controller and is only running IPv6 in a SharePoint 2013 environment, the domain controller must be running Windows Server 2012, Windows Server 2008, or Windows Server 2008 R2. Ensure that you use the correct service pack and any additional software prerequisites. For more information, see Hardware and software requirements for SharePoint 2013.

  • All versions of SQL Server supported for SharePoint 2013 also support IPv6. For more information about IPv6 support for SQL Server 2008, see Connecting Using IPv6 (http://go.microsoft.com/fwlink/p/?LinkId=183115).

  • When SharePoint 2013 uses the IPv6 protocol, all end-user URLs must be based on DNS names with AAAA records. For more information about AAAA records, see Adding a Resource Record to a Forward Lookup Zone.

  • Browsing to SharePoint URLs that use IPv6 literal addresses is not supported. An example of a literal address URL is http://[2001:db8:85a3:8d3:1319:8a2e:370:7344]. However, you can enter IPv6 literal addresses for certain farm administration tasks, such as entering the server name when you create or attach databases. For server names that use a literal address format, you must enclose the literal address within square brackets.

  • When specifying an outbound Simple Mail Transfer Protocol (SMTP) server, SharePoint does not support the configuration of IPv6 literal addresses. The recommendation is to specify a DNS name for the SMTP server, which can resolve to an IPv4 address, an IPv6 address, or both. If you do not have a DNS name for the SMTP server and must supply an IPv6 address, you can configure the corresponding ipv6-literal.net name for the address.

    To create an ipv6-literal.net name for an IPv6 address, convert the colons (:) in the address to dashes (-), then add the result to "ipv6-literal.net". For example, for the IPv6 address 2001:db8:28:3:f98a:5b31:67b7:67ef, the corresponding ipv6-literal.net name is 2001-db8-28-3-f98a-5b31-67b7-67ef.ipv6-literal.net.

  • Some SharePoint features or components integrate with cloud services—such as SharePoint Help, SharePoint Translation Service, and SharePoint apps that use the Windows Azure Access Control Service (ACS)—which might not yet be IPv6-capable. Therefore, make sure that that your SharePoint servers are IPv4-capable, which includes both IPv4-only and mixed IPv4 and IPv6 environments, until all of the SharePoint-dependent cloud services become IPv6-capable. For more information, see IPv6 Support in Microsoft Products and Services and IPv6 - Technology Overview.

For additional information about IPv6 in Microsoft products, see the IPv6 TechCenter.

See also

IPv6 Survival Guide in the TechNet Wiki


Software boundaries and limits for SharePoint 2013
See also

Updated: September 24, 2013

Summary: Learn about the tested performance and capacity limits of SharePoint Server 2013 and how limits relate to acceptable performance.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise | Project Server 2013 | SharePoint Foundation 2013

This article describes software boundaries and limits of SharePoint Server 2013. These include the following:

  • Boundaries: Static limits that cannot be exceeded by design

  • Thresholds: Configurable limits that can be exceeded to accommodate specific requirements

  • Supported limits: Configurable limits that have been set by default to a tested value

Important:

Some values in this article are based on test results from SharePoint 2010 Products and may not represent the final values for SharePoint Server 2013. This article will be updated with appropriate values as SharePoint Server 2013 test data becomes available.

For information about current hardware and software requirements, see Hardware and software requirements for SharePoint 2013.

Note:

The capacity planning information in this document provides guidelines for you to use in your planning. It is based on testing performed at Microsoft, on live properties. However, your results are likely to vary based on the equipment you use and the features and functionality that you implement for your sites.

In this article:

  • Overview of boundaries and limits

    • Boundaries, thresholds and supported limits

    • How limits are established

  • Limits and boundaries

    • Limits by hierarchy

      • Web application limits

      • Web server and application server limits

      • Content database limits

      • Site collection limits

      • List and library limits

      • Column limits

      • Page limits

    • Limits by feature

      • Search limits

      • User Profile Service limits

      • Content deployment limits

      • Blog limits

      • Business Connectivity Services limits

      • Workflow limits

      • Managed Metadata term store (database) limits

      • Visio Services limits

      • SharePoint Web Analytics service limits

      • PerformancePoint Services limits

      • Word Automation Services limits

      • Excel Services limits

      • Machine Translation Service limits

      • Office Web Application Service limits

      • Project Server limits

      • SharePoint Apps limits

      • Distributed cache service limits

      • Miscellaneous limits

Overview of boundaries and limits

This article contains information to help you understand the tested performance and capacity limits of SharePoint Server 2013, and offers guidelines for how limits relate to acceptable performance. Use the information in this article to determine whether your planned deployment falls within acceptable performance and capacity limits, and to appropriately configure limits in your environment.

The test results and guidelines provided in this article apply to a single SharePoint Server 2013 farm. Adding servers to the installation might not increase the capacity limits of the objects that are listed in the tables in the Limits and boundaries section later in this topic. On the other hand, adding server computers increases the throughput of a server farm, which might be necessary to achieve acceptable performance with many objects. In some cases, the requirements for high numbers of objects in a solution might require more servers in the farm.

Note that there are many factors that can affect performance in a given environment, and each of these factors can affect performance in different areas. Some of the test results and recommendations in this article might be related to features or user operations that do not exist in your environment, and therefore do not apply to your solution. Only thorough testing can give you exact data related to your own environment.

Boundaries, thresholds and supported limits

In SharePoint Server 2013, there are certain limits that are by design and cannot be exceeded, and other limits that are set to default values that may be changed by the farm administrator. There are also certain limits that are not represented by a configurable value, such as the number of site collections per web application.

  • Boundaries are absolute limits that cannot be exceeded by design. It is important to understand these limits to ensure that you do not make incorrect assumptions when you design your farm.

    An example of a boundary is the 2 GB document size limit; you cannot configure SharePoint Server 2013 to store documents that are larger than 2 GB. This is a built-in absolute value, and cannot be exceeded by design.

  • Thresholds are those that have a default value that cannot be exceeded unless the value is modified. Thresholds can, in certain circumstances, be exceeded to accommodate variances in your farm design, but it is important to understand that doing this may affect the performance of the farm in addition to the effective value of other limits.

    The default value of certain thresholds can only be exceeded up to an absolute maximum value. A good example is the document size limit. By default, the default document size threshold is set to 50MB, but can be changed to support the maximum boundary of 2GB.

  • Supported limits define the tested value for a given parameter. The default values for these limits were defined by testing, and represent the known limitations of the product. Exceeding supported limits may cause unexpected results, significant decrease in performance, or other harmful effects.

    Some supported limits are configurable parameters that are set by default to the recommended value, while other supported limits relate to parameters that are not represented by a configurable value.

An example of a supported limit is the number of site collections per farm. The supported limit is the largest number of site collections per web application that met performance benchmarks during testing.

It is important to be aware that many of the limit values that are provided in this document represent a point in a curve that describes an increasing resource load and concomitant decrease in performance as the value increases. Therefore, exceeding certain limits, such as the number of site collections per web application, may only result in a fractional decrease in farm performance. However, in most cases, operating at or near an established limit is not a best practice, as acceptable performance and reliability targets are best achieved when a farm's design provides for a reasonable balance of limits values.

Thresholds and supported limits guidelines are determined by performance. In other words, you can exceed the default values of the limits, but as you increase the limit value, farm performance and the effective value of other limits may be affected. Many limits in SharePoint Server 2013 can be changed, but it is important to understand how changing a given limit affects other parts of the farm.

How limits are established

In SharePoint Server 2013, thresholds and supported limits are established through testing and observation of farm behavior under increasing loads up to the point where farm services and operations reach their effective operational limits. Some farm services and components can support a higher load than others so that in some cases you must assign a limit value based on an average of several factors.

For example, observations of farm behavior under load when site collections are added indicate that certain features exhibit unacceptably high latency while other features are still operating within acceptable parameters. Therefore, the maximum value assigned to the number of site collections is not absolute, but is calculated based on an expected set of usage characteristics in which overall farm performance would be acceptable at the given limit under most circumstances.

Obviously, if some services are operating under parameters that are higher than those used for limits testing, the maximum effective limits of other services will be reduced. It is therefore important to execute rigorous capacity management and scale testing exercises for specific deployments in order to establish effective limits for that environment.

Note: We do not describe the hardware that was used to validate the limits in this document, because the limits were collected from multiple farms and environments.

The Pie Metaphor

In order to understand the relationship between hardware resources, load and performance, it's important to have a way to visualize the factors involved and how they affect each other.

Consider the capacity of a farm as a pie, the size of which represents the aggregate of factors such as servers, hardware resources such as CPUs and RAM, storage capacity, disk IOPs, network bandwidth and latency. The size of the pie is therefore related to the overall resources of the farm; adding resources (such as farm servers) increases the size of the pie.

This pie is divided into slices that represent load from a variety of sources: user requests, search queries, operations against installed features, timer jobs and operating system overhead. Each of these sections must share available farm resources. If the size of one slice increases, the size of others must decrease proportionally. Since load on a farm is not static (user requests, for example, might only be significant during certain hours of the day), the relative size of the slices is constantly in flux. However, each slice must maintain a required minimum size to operate normally, and since the functions represented by each slice are interdependent, increasing the size of one slice may place more load on other slices in addition to reducing the resources available for them to consume.

Using this metaphor, the goal of the farm's design is to make the pie large enough to accommodate the required size of each pie slice under peak load.

Now, consider a scenario where user requests increase by 100% over baseline. Let's say that about half of the requests are search queries, and the other half editing lists and documents. This increased load squeezes the other pie slices, but some farm features must also work harder to compensate. The Search service has to process more queries, most of which are handled by the cache, but some queries are passed on to the database servers, increasing their load as well. If load on the database servers becomes too great, disk queue lengths will increase, which in turn increases the latency of all other requests.

Limits and boundaries

This section lists the objects that can be a part of a solution and provides guidelines for acceptable performance for each kind of object. Acceptable performance means that the system as tested can support that number of objects, but that the number cannot be exceeded without some decrease in performance or a reduction in the value of related limits. Objects are listed both by scope and by feature. Limits data is provided, together with notes that describe the conditions under which the limit is obtained and links to additional information where available.

Use the guidelines in this article to review your overall solution plans. If your solution plans exceed the recommended guidelines for one or more objects, take one or more of the following actions:

  • Evaluate the solution to ensure that compensations are made in other areas.

  • Flag these areas for testing and monitoring as you build your deployment.

  • Redesign or partition the solution to ensure that you do not exceed capacity guidelines.

Limits by hierarchy

This section provides limits sorted by the logical hierarchy of a SharePoint Server 2013 farm.

Web application limits

The following table lists the recommended guidelines for web applications.

Limit Maximum value Limit type Notes

Web application

20 per farm

Supported

We recommended limiting the number of web applications as much as possible. Create additional host named site collections where possible instead of adding web applications.

Zone

5 per web application

Boundary

The number of zones defined for a farm is hard-coded to 5. Zones include Default, Intranet, Extranet, Internet, and custom.

Managed path for host-named site collections

20 per farm

Supported

Managed paths for host-named site collections apply at the farm level. Each managed path that is created can be applied in any Web application.

Managed path for path-based site collections

20 per web application

Supported

Managed paths are cached on the web server, and CPU resources are used to process incoming requests against the managed path list.

Managed paths for path-based site collections apply at the Web application level. You can create a different set of managed paths for each Web application. Exceeding 20 managed paths per web application adds more load to the web server for each request.

If you plan to exceed twenty managed paths in a given web application, we recommend that you test for acceptable system performance.

Solution cache size

300 MB per web application

Threshold

The solution cache allows the InfoPath Forms service to hold solutions in cache in order to speed up retrieval of the solutions. If the cache size is exceeded, solutions are retrieved from disk, which may slow down response times. You can configure the size of the solution cache by using the Windows PowerShell cmdlet Set-SPInfoPathFormsService. For more information, see Set-SPInfoPathFormsService.

Web server and application server limits

The following table lists the recommended guidelines for web servers on the farm.

Limit Maximum value Limit type Notes

Application pools

10 per web server

Threshold

The maximum number is determined by hardware capabilities.

This limit is dependent largely upon:

  • The amount of memory allocated to the web servers

  • The workload that the farm is serving, that is, the user base and the usage characteristics (a single highly active application pool can utilize 10 GB or more)

Content database limits

The following table lists the recommended guidelines for content databases.

Limit Maximum value Limit type Notes

Number of content databases

500 per farm

Supported

The maximum number of content databases per farm is 500. With 500 content databases per web application, end user operations such as opening the site or site collections are not affected. But administrative operations such as creating a new site collection will experience decrease in performance. We recommend that you use Windows PowerShell to manage the web application when a large number of content databases are present, because the management interface might become slow and difficult to navigate.

Content database size (general usage scenarios)

200 GB per content database

Supported

We strongly recommended limiting the size of content databases to 200 GB, except when the circumstances in the following rows in this table apply.

If you are using Remote BLOB Storage (RBS), the total volume of remote BLOB storage and metadata in the content database must not exceed this limit.

Content database size (all usage scenarios)

4 TB per content database

Supported

Content databases of up to 4 TB are supported when the following requirements are met:

  • Disk sub-system performance of 0.25 IOPs per GB. 2 IOPs per GB is recommended for optimal performance.

  • You must have developed plans for high availability, disaster recovery, future capacity, and performance testing.

You should also carefully consider the following factors:

  • Requirements for backup and restore may not be met by the native SharePoint Server 2013 backup for content databases larger than 200 GB. It is recommended to evaluate and test SharePoint Server 2013 backup and alternative backup solutions to determine the best solution for your specific environment.

  • It is strongly recommended to have proactive skilled administrator management of the SharePoint Server 2013 and SQL Server installations.

  • The complexity of customizations and configurations on SharePoint Server 2013 may necessitate refactoring (or splitting) of data into multiple content databases. Seek advice from a skilled professional architect and perform testing to determine the optimum content database size for your implementation. Examples of complexity may include custom code deployments, use of more than 20 columns in property promotion, or features listed as not to be used in the over 4 TB section below.

  • Refactoring of site collections allows for scale out of a SharePoint Server 2013 implementation across multiple content databases. This permits SharePoint Server 2013 implementations to scale indefinitely. This refactoring will be easier and faster when content databases are less than 200 GB.

  • It is suggested that for ease of backup and restore that individual site collections within a content database be limited to 100 GB. For more information, see Site collection limits.

Important:

Content databases of over 4 TB, except for use in document archive scenarios (described in the row below), are not recommended. Upgrading of site collections within these content databases is likely to be very difficult and time consuming.

It is strongly recommended that you scale out across multiple content databases, rather than exceed 4 TB of data in a single content database.

Content database size (document archive scenario)

No explicit content database limit

Supported

Content databases with no explicit size limit for use in document archive scenarios are supported when the following requirements are met:

  • You must meet all requirements from the "Content database size (all usage scenarios)" limit earlier in this table, and you should ensure that you have carefully considered all the factors discussed in the Notes field of that limit.

  • SharePoint Server 2013 sites must be based on Document Center or Records Center site templates.

  • Less than 5% of the content in the content database is accessed each month on average, and less than 1% of content is modified or written each month on average.

  • Do not use alerts, workflows, link fix-ups, or item level security on any SharePoint Server 2013 objects in the content database.

    Note:

    Document archive content databases can be configured to accept documents from Content Routing workflows.

For more information about large-scale document repositories, see Estimate Performance and Capacity Requirements for Large Scale Document Repositories (http://technet.microsoft.com/en-us/library/ff608068.aspx), and the Typical large-scale content management scenarios section of the article Enterprise content storage planning (SharePoint Server 2010).

Content database items

60 million items including documents and list items

Supported

The largest number of items per content database that has been tested on SharePoint Server 2013 is 60 million items, including documents and list items. If you plan to store more than 60 million items in SharePoint Server 2013, you must deploy multiple content databases.

Site collections per content database

10,000 maximum (2,500 non-Personal site collections and 7,500 Personal Sites, or 10,000 Personal Sites alone)

Supported

We strongly recommended limiting the number of site collections in a content database to 5,000. However, up to 10,000 site collections in a database are supported. Note that in a content database with up to 10,000 total site collections, a maximum of 2,500 of these can be non-Personal site collections. It is possible to support 10,000 Personal site collections if they are the only site collections within the content database.

These limits relate to speed of upgrade. The larger the number of site collections in a database, the slower the upgrade with respect to both database upgrade and site collection upgrades.

The limit on the number of site collections in a database is subordinate to the limit on the size of a content database that has more than one site collection. Therefore, as the number of site collections in a database increases, the average size of the site collections it contains must decrease.

Exceeding the 5,000 site collection limit puts you at risk of longer downtimes during upgrades. If you plan to exceed 5,000 site collections, we recommend that you have a clear upgrade strategy to address outage length and operations impact, and obtain additional hardware to speed up the software updates and upgrades that affect databases.

To set the warning and maximum levels for the number of sites in a content database, use the Windows PowerShell cmdlet Set-SPContentDatabase with the -WarningSiteCount parameter. For more information, see Set-SPContentDatabase.

Remote BLOB Storage (RBS) storage subsystem on Network Attached Storage (NAS)

Time to first byte of any response from the NAS cannot exceed 20 milliseconds

Boundary

When SharePoint Server 2013 is configured to use RBS, and the BLOBs reside on NAS storage, consider the following boundary.

From the time that SharePoint Server 2013 requests a BLOB, until it receives the first byte from the NAS, no more than 20 milliseconds can pass.

Site collection limits

The following table lists the recommended guidelines for site collections.

Limit Maximum value Limit type Notes

Site collections per farm

750,000 (500,000 Personal Sites and 250,000 other sites per farm)

Supported

The maximum recommended number of site collections per farm is 500,000 Personal Sites plus 250,000 for all other site templates. The Sites can all reside on one web application, or can be distributed across multiple web applications.

Note that this limit is affected by other factors that might reduce the effective number of site collections that can be supported by a given content database. Care must be exercised to avoid exceeding supported limits when a container object, such as a content database, contains a large number of other objects. For example, if a farm contains a smaller total number of content databases, each of which contains a large number of site collections, farm performance might be adversely affected long before the supported limit for the number of site collections is reached.

For example, Farm A contains a web application that has 200 content databases, a supported configuration. If each of these content databases contains 1,000 site collections, the total number of site collections in the web application will be 200,000, which falls within supported limits. However, if each content database contains 10,000 site collections, even though this number is supported for a content database, the total number of site collections in the farm will be 2,000,000, which exceeds the limit for the number of site collections per web application.

Memory usage on the web servers should be monitored, as memory usage is dependent on usage patterns and how many sites are being accessed in given timeframe. Similarly, the crawl targets might also exhibit memory pressure, and if so the application pool should be configured to recycle before available memory on any web server drops to less than 2 GB.

Web site

250,000 per site collection

Supported

The maximum recommended number of sites and subsites is 250,000 sites.

You can create a very large total number of web sites by nesting subsites. For example, in a shallow hierarchy with 100 sites, each with 1,000 subsites, you would have a total of 100,000 web sites. Or a deep hierarchy with 100 sites, each with 10 subsite levels would also contain a total of 100,000 web sites.

Note: Deleting or creating a site or subsite can significantly affect a site's availability. Access to the site and subsites will be limited while the site is being deleted. Attempting to create many subsites at the same time may also fail.

Site collection size

Maximum size of the content database

Supported

A site collection can be as large as the content database size limit for the applicable usage scenario. For more information about the different content database size limits for specific usage scenarios, see the Content database limits table in this article.

In general, we strongly recommend limiting the size of site collections to 100 GB for the following reasons:

  • Certain site collection actions, such as site collection backup/restore or the Windows PowerShell cmdlet Move-SPSite, cause large SQL Server operations which can affect performance or fail if other site collections are active in the same database. For more information, see Move-SPSite.

  • SharePoint site collection backup and restore is only supported for a maximum site collection size of 100 GB. For larger site collections, the complete content database must be backed up. If multiple site collections larger than 100 GB are contained in a single content database, backup and restore operations can take a long time and are at risk of failure.

Number of device channels per publishing site collection

10

Boundary

The maximum allowed number of device channels per publishing site collection is 10.

List and library limits

The following table lists the recommended guidelines for lists and libraries. For more information, see Designing large Lists and maximizing list performance (SharePoint Server 2010).

Limit Maximum value Limit type Notes

List row size

8,000 bytes per row

Boundary

Each list or library item can only occupy 8,000 bytes in total in the database. 256 bytes are reserved for built-in columns, which leaves 7,744 bytes for end-user columns. For details on how much space each kind of field consumes, see Column limits.

File size

2 GB

Boundary

The default maximum file size is 250 MB. This is a configurable limit that can be increased up to 2 GB (2,047 MB). However, a large volume of very large files can affect farm performance.

Documents

30,000,000 per library

Supported

You can create very large document libraries by nesting folders, or using standard views and site hierarchy. This value may vary depending on how documents and folders are organized, and by the type and size of documents stored.

Major versions

400,000

Supported

If you exceed this limit, basic file operations—such as file open or save, delete, and viewing the version history— may not succeed.

Minor versions

511

Boundary

The maximum number of minor file versions is 511. This limit cannot be exceeded.

Items

30,000,000 per list

Supported

You can create very large lists using standard views, site hierarchies, and metadata navigation. This value may vary depending on the number of columns in the list and the usage of the list.

Rows size limit

6 table rows internal to the database used for a list or library item

Supported

Specifies the maximum number of table rows internal to the database that can be used for a list or library item. To accommodate wide lists with many columns, each item may be wrapped over several internal table rows, up to six rows by default. This is configurable by farm administrators through the object model only. The object model method is SPWebApplication.MaxListItemRowStorage.

Bulk operations

100 items per bulk operation

Boundary

The user interface allows a maximum of 100 items to be selected for bulk operations.

List view lookup threshold

8 join operations per query

Threshold

Specifies the maximum number of joins allowed per query, such as those based on lookup, person/group, or workflow status columns. If the query uses more than eight joins, the operation is blocked. This does not apply to single item operations. When using the maximal view via the object model (by not specifying any view fields), SharePoint will return up to the first eight lookups.

List view threshold

5,000

Threshold

Specifies the maximum number of list or library items that a database operation, such as a query, can process at the same time outside the daily time window set by the administrator during which queries are unrestricted.

List view threshold for auditors and administrators

20,000

Threshold

Specifies the maximum number of list or library items that a database operation, such as a query, can process at the same time when they are performed by an auditor or administrator with appropriate permissions. This setting works with Allow Object Model Override.

Subsite

2,000 per site view

Threshold

The interface for enumerating subsites of a given web site does not perform well as the number of subsites surpasses 2,000. Similarly, the All Site Content page and the Tree View Control performance will decrease significantly as the number of subsites grows.

Coauthoring in Word and PowerPoint for .docx, .pptx and .ppsx files

10 concurrent editors per document

Threshold

Recommended maximum number of concurrent editors is 10. The boundary is 99.

If there are 99 co-authors who have a single document opened for concurrent editing, each successive user sees a "File in use" error, and can only open a read-only copy.

More than 10 co-editors will lead to a gradually degraded user experience with more conflicts, and users might have to go through more iterations to successfully upload their changes to the server.

Security scope

50,000 per list

Threshold

The maximum number of unique security scopes set for a list cannot exceed 50,000.

For most farms, we recommend that you consider lowering this limit to 5,000 unique scopes. For large lists, consider using a design that uses as few unique permissions as possible.

When the number of unique security scopes for a list exceeds the value of the list view threshold (set by default at 5,000 list items), additional SQL Server round trips take place when the list is viewed, which can adversely affect list view performance.

A scope is the security boundary for a securable object and any of its children that do not have a separate security boundary defined. A scope contains an Access Control List (ACL), but unlike NTFS ACLs, a scope can include security principals that are specific to SharePoint Server 2013. The members of an ACL for a scope can include Windows users, user accounts other than Windows users (such as forms-based accounts), Active Directory groups, or SharePoint groups.

Column limits

SharePoint Server 2013 data is stored in SQL Server tables. To allow for the maximum number of possible columns in a SharePoint list, SharePoint Server 2013 will create several rows in the database when data will not fit on a single row. This is called row wrapping.

Each time that a row is wrapped in SQL Server, an additional query load is put on the server when that item is queried because a SQL join must be included in the query. To prevent too much load, by default a maximum of six SQL Server rows are allowed for a SharePoint item. This limit leads to a particular limitation on the number of columns of each type that can be included in a SharePoint list. The following table describes the limits for each column type.

The row wrapping parameter can be increased beyond six, but this may result in too much load on the server. Performance testing is recommended before exceeding this limit.

Each column type has a size value listed in bytes. The sum of all columns in a SharePoint list cannot exceed 8,000 bytes. Depending on column usage, users can reach the 8,000 byte limitation before reaching the six-row row wrapping limitation.

Limit Maximum value Limit type Size per column Notes

Single line of text

276

Threshold

28 bytes

SQL Server row wrapping occurs after each 64 columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 384 Single line of text columns per SharePoint list (6 * 64 = 384). However, because the limit per SharePoint list item is 8,000 bytes, of which 256 bytes are reserved for built-in SharePoint columns, the actual limit is 276 Single line of text columns.

Multiple Lines of Text

192

Threshold

28 bytes

SQL Server row wrapping occurs after each 32 columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 192 Multiple lines of text columns per SharePoint list (6 * 32 = 192).

Choice

276

Threshold

28 bytes

SQL Server row wrapping occurs after each 64 columns in a SharePoint list. The default row wrapping value of 6 allows for a maximum of 384 Choice columns per SharePoint list (6 * 64 = 384); ); however because the limit per SharePoint list item is 8,000 bytes, of which 256 bytes are reserved for built-in SharePoint columns, the actual limit should be 276 Choice columns.

Number

72

Threshold

12 bytes

SQL Server row wrapping occurs after each 12 columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 72 Number columns per SharePoint list (6 * 12 = 72).

Currency

72

Threshold

12 bytes

SQL Server row wrapping occurs after each 12 columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 72 Currency columns per SharePoint list (6 * 12 = 72).

Date and Time

48

Threshold

12 bytes

SQL Server row wrapping occurs after each eight columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 48 Date and Time columns per SharePoint list (6 * 8 = 48).

Lookup

96

Threshold

4 bytes

SQL Server row wrapping occurs after each 16 columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 96 single value Lookup columns per SharePoint list (6 * 16 = 96).

Yes / No

96

Threshold

5 bytes

SQL Server row wrapping occurs after each 16 columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 96 Yes / No columns per SharePoint list (6 * 16 = 96).

Person or group

96

Threshold

4 bytes

SQL Server row wrapping occurs after each 16 columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 96 Person or Group columns per SharePoint list (6 * 16 = 96).

Hyperlink or picture

138

Threshold

56 bytes

SQL Server row wrapping occurs after each 32 columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 192 Hyperlink or Picture columns per SharePoint list (6 * 32 = 192) ); however because the limit per SharePoint list item is 8,000 bytes, of which 256 bytes are reserved for built-in SharePoint columns, the actual limit should be 138 Hyperlink or Picture columns.

Calculated

48

Threshold

28 bytes

SQL Server row wrapping occurs after each eight columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 48 Calculated columns per SharePoint list (6 * 8 = 48).

GUID

6

Threshold

20 bytes

SQL Server row wrapping occurs after each column in a SharePoint list. The default row wrapping value of six allows for a maximum of 6 GUID columns per SharePoint list (6 * 1 = 6).

Int

96

Threshold

4 bytes

SQL Server row wrapping occurs after each 16 columns in a SharePoint list. The default row wrapping value of six allows for a maximum of 96 Int columns per SharePoint list (6 * 16 = 96).

Managed metadata

94

Threshold

40 bytes for the first, 32 bytes for each subsequent

The first Managed Metadata field added to a list is allocated four columns:

  • A lookup field for the actual tag

  • A hidden text field for the string value

  • A lookup field for the catch all

  • A lookup field for spillover of the catch all

Each subsequent Managed Metadata field added to a list adds two more columns:

  • A lookup field for the actual tag

  • A hidden text field for the string value

The maximum number of columns of Managed Metadata is calculated as (14 + (16 * (n-1))) where n is the row mapping value (default of 6).

External Data columns have the concept of a primary column and secondary columns. When you add an external data column, you can select some secondary fields of the external content type that you want to be added to the list. For example, given an External Content Type "Customer" which has fields like "ID", "Name", "Country", and "Description", when you add an External Data column of type "Customer" to a list, you can add secondary fields to show the "ID", "Name" and "Description" of the Customer. Overall these are the columns that get added:

  • Primary column: A text field.

  • Hidden Id column: A multi-line text field.

  • Secondary columns: Each secondary column is a text/number/Boolean/multi-line text that is based on the data type of the secondary column as defined in the Business Data Catalog model. For example, ID might be mapped to a Number column; Name might be mapped to a Single line of text column; Description might be mapped to a Multiple lines of text column.

Page limits

The following table lists the recommended guidelines for pages.

Limit | Maximum value | Limit type | Notes
Web parts | 25 per wiki or Web Part page | Threshold | This figure is an estimate based on simple Web Parts. The complexity of the Web Parts dictates how many Web Parts can be used on a page before performance is affected.

Security limits

Limit Maximum value Limit type Notes

Number of SharePoint groups a user can belong to

5,000

Supported

This is not a hard limit but it is consistent with Active Directory guidelines. There are several things that affect this number:

  • The size of the user token

  • The groups cache: SharePoint Server 2013 has a table that caches the number of groups a user belongs to as soon as those groups are used in access control lists (ACLs).

  • The security check time: as the number of groups that a user is a member of increases, the time that is required for the access check increases also.

Users in a site collection

2 million per site collection

Supported

You can add millions of people to your web site by using Microsoft Windows security groups to manage security instead of using individual users.

This limit is based on manageability and ease of navigation in the user interface.

When you have many entries (security groups of users) in the site collection (more than one thousand), you should use Windows PowerShell to manage users instead of the UI. This will provide a better management experience.

Active Directory Principles/Users in a SharePoint group

5,000 per SharePoint group

Supported

SharePoint Server 2013 enables you to add users or Active Directory groups to a SharePoint group.

Having up to 5,000 users (or Active Directory groups or users) in a SharePoint group provides acceptable performance.

The activities most affected by this limit are as follows:

  • Fetching users to validate permissions. This operation takes incrementally longer with growth in number of users in a group.

  • Rendering the membership of the view. This operation will always require time.

SharePoint groups

10,000 per site collection

Supported

Above 10,000 groups, the time to execute operations is increased significantly. This is especially true of adding a user to an existing group, creating a new group, and rendering group views.

Security principal: size of the Security Scope

5,000 per Access Control List (ACL)

Supported

The size of the scope affects the data that is used for a security check calculation. This calculation occurs every time that the scope changes. There is no hard limit, but the bigger the scope, the longer the calculation takes.

Limits by feature

This section lists limits sorted by feature.

Search limits

The following table lists the recommended guidelines for Search.

Note:

Limits for Search have changed significantly as the feature has been updated. For more information, see Plan search in SharePoint Server 2013.

Limit Maximum value Limit type Notes

Alerts

100,000 per Search service application

Supported

This is the limit for a Search service application with a mix of end user queries (75%) and alert queries (25%). The limit for a Search service application with only alert queries is 400,000 alerts. These limits are based on a system with five queries per second (QPS).

Analytics processing components

6 per Search service application; 1 per server

Threshold

Analytics reporting database

4 per Search service application

Threshold

Add an analytics reporting database when the size of any of the deployed analytics databases reaches 250 GB. This way repartitioning is as balanced as possible.

Authoritative pages

1 top level and minimal second and third level pages per Search service application

Supported

Use as few second- and third-level pages as possible while still achieving the desired relevance.

The boundary is 200 authoritative pages per relevance level per Search service application. If you add additional pages, you may not achieve the desired relevance. Add the key site to the first relevance level. Add more key sites at either second or third relevance levels, one at a time. Evaluate relevance after each addition to ensure that you have achieved the desired relevance effect.

Concurrent crawls

20 per Search service application

Threshold

Content processing components

1 per server

Supported

The topology supports scaling out the number of Content processing components. Although a specific physical host or virtual machine does support multiple Content processing components, you achieve better usage of the CPU capacity by using one Content processing component. The reason is that a built-in mechanism maximizes CPU usage by adjusting the number of feeding sessions in accordance with available CPU cores. Multiple feeding sessions allow the Content processing component to process incoming documents in parallel. This mechanism assumes a single Content processing component per host.

If the number of physical cores on the host equals N, then the Content processing component will have N*K feeding sessions. K is a constant coefficient with the initial value 3. A 4-core server will have 12 feeding sessions, which means that the Content processing component can process 12 documents in parallel. You can change the value of K by setting the NumberOfCssFeedersPerCPUForRegularCrawl property of the Search Service Application. SharePoint 2013 limits the value of N upwards to 12, even if a server has more than 12 physical cores. Therefore a 16-core server will have N*K = 12 * 3 = 36 feeding sessions.

In the case that there still is idle CPU time, consider increasing the K coefficient instead of adding an extra Content processing component. If you increase the K coefficient, you must ensure that the host has sufficient available memory.

Content sources

50 per Search service application

Supported

Crawl components

2 per Search service application;1 per server

Supported

Crawl databases

5 per Search service application

Boundary

Crawl impact rule

No limit

Supported

Crawl log entries

100 million per Search service application

Supported

Crawl rules

No limit

Supported

Crawled properties

500,000 per Search service application

Supported

The contents and metadata of the items that you crawl are represented as crawled properties. You can map these crawled properties to managed properties. When the number of crawled properties exceeds this supported limit, indexing speed will be reduced.

Default eDiscovery query MaxRowLimit

10,000 rows

Supported

This is the default maximum row limit for eDiscovery queries. The Search service application property MaxRowLimit defines the maximum value of the eDiscovery query property RowLimit. RowLimit defines the number of rows each page contains in a result set.

Default query MaxRowLimit

500 rows

Supported

This is the default maximum row limit for queries. The Search service application property MaxRowLimit defines the maximum value of the query property RowLimit. RowLimit defines the number of rows each page contains in a result set.

Index components

60 per Search service application; 1 per server

Supported

To calculate the number of index components you have, multiply the number of index partitions with the number of index replicas.

Index partitions

20 per Search service application

Supported

An index partition holds a subset of the Search service application index. Increasing the number of index partitions results in each partition holding a smaller subset of the index, reducing the RAM and disk space that is needed on the servers hosting the index components.

Index replicas

3 per index partition

Supported

Each index partition can have a set of replica. If you increase the number of index replicas, this will have a positive effect on the query performance and it provides better fault tolerance. However, if you add too many replicas to your index partition, this can have a negative effect on indexing.

For Internet sites scenarios, which typically have a high query rate but low content volume (less than 4 million items per partition), the supported limit is 6 index replicas per partition.

Indexed items

100 million per Search service application

10 million per index partition

Supported

Each index partition contains a subset of the entire search index. If the number of indexed items is high in relation to the amount of memory the server has, this will affect the query response time negatively.

Indexed managed property size

512 KB per searchable/queryable managed property

Threshold

This is the default limit for the size of a searchable or queryable managed property. If you increase this limit, you will enable indexing of more data per managed property. Indexing more data per managed property uses more disk space and increases the overall load on the system. You can configure this limit by using Windows PowerShell cmdlets and the schema object model to set the MP.MaxCharactersInPropertyStoreIndex attribute.

Length of machine host name

15 characters

Threshold

NetBIOS limits the maximum machine host name length to this value.

Link database

2 per Search service application

Threshold

Each link database can contain up to 50 million items.

Managed properties

50,000 per Search service application

Supported

Search uses managed propertied in queries. Crawled properties are mapped to managed properties. When you exceed the supported limit for managed properties, this reduces indexing speed.

Managed property mappings

100 per managed property

Supported

Crawled properties can be mapped to managed properties. Exceeding this limit may decrease crawl speed and query performance.

Maximum allowed KeywordQuery text length

20 KB

Boundary

The Keyword Query Language is a language for building search queries. This is the boundary limit for the Search service application properties MaxKeywordQueryTextLength and DiscoveryMaxKeywordQueryTextLength. These properties define the maximum query text length for keyword queries and eDiscovery keyword queries.

Maximum allowed query MaxRowLimit

100,000 rows

Boundary

This is the boundary limit for the Search service application properties MaxRowLimit and DiscoveryMaxRowLimit. These properties define the maximum value of the query property RowLimit for queries and eDiscovery queries. RowLimit defines the number of rows each page contains in a result set.

Maximum eDiscovery KeywordQuery text length

16 KB

Supported

The Keyword Query Language is a language for building search queries. This is the supported default limit for the Search service application property DiscoveryMaxKeywordQueryTextLength. This property defines the maximum query text length of an eDiscovery keyword query.

Maximum KeywordQuery text length

4 KB

Supported

The Keyword Query Language is a language for building search queries. This is the supported default limit for the Search service application property MaxKeywordQueryTextLength. This property defines the maximum query text length of a keyword query.

Maximum size of documents pulled down by crawler

64 MB (3 MB for Excel documents)

Boundary

Metadata properties recognized

10,000 per crawled item

Supported

This is the number of metadata properties that can be determined and potentially mapped or used for queries when an item is crawled.

Navigable results from search

100,000 per query request per Search service application

Boundary

This is the limit for how many hits that a query requests. Increasing this limit will affect the query performance negatively.

Number of entries in a custom entity extraction dictionary

1 million

Supported

This is the tested limit.

Number of entries in a custom search dictionary

5,000 terms per tenant

Boundary

This limits the number of terms allowed for inclusions and exclusions dictionaries for query spelling correction and company extraction.

Number of entries in a thesaurus

1 million

Supported

This is the tested limit.

Query processing components

1 per server

Supported

SharePoint only supports one query processing component per physical machine or virtual machine.

Ranking models

1,000 per tenant

Boundary

Approaching this limit can have negative effect on the overall system performance.

Results removal

No limit

Threshold

Retrievable managed property size

16 KB per managed property

Threshold

This is the default maximum limit for the size of a retrievable managed property. Increasing this limit will enable indexing of more data per managed property. It will also enable retrieval of more data per managed property with the search results. Indexing and retrieving more data per managed property increases the overall load on the system and uses more disk space. You can configure this limit per managed property by using Windows PowerShell cmdlets and the schema object model to set the P.MaxCharactersInPropertyStoreForRetrievalattribute.

Search service applications

20 per farm

Supported

Multiple Search service applications can be deployed on the same farm, because you can assign search components and databases to separate servers. This limit is lower than the limit for the total number of service applications in a farm.

Sortable and refinable managed property size

16 KB per managed property

Boundary

This is the default maximum limit for the size of a sortable and refinable managed property. Increasing this limit will enable indexing of more data per managed property. This uses more disk space and increases the overall load on the system. You can configure this limit per managed property by using Windows PowerShell cmdlets and the schema object model to set the MP.MaxCharactersInPropertyStoreForRetrieval attribute.

Start addresses

100 per content source

Supported

Term size

300 characters

Boundary

SharePoint Search will split terms that are longer than this boundary into two or more terms where no term has more than 300 characters. For example, a 612-character term will be split into two 300-character terms and one 12-character term. SharePoint Search only considers the first 1000 characters of a term for splitting, it ignores any remaining characters.

Unique contexts used for ranking

15 unique contexts per rank model

Boundary

This is the maximum boundary for the number of unique contexts per rank model.

Unique terms in the index

2^31 (>2 billion terms)

Boundary

This is the maximum boundary for the number of unique terms that can exist in the index of a Search service application.

User defined full text indexes

10

Boundary

This is the maximum boundary for the number of full text indexes.

Values per managed property

100

Supported

A managed property can have multiple values of the same type. This is the supported number of values per managed multi-valued managed property per document. Exceeding this limit may have a negative effect on query performance, index disk size and/or memory usage.

User Profile Service limits

The following table lists the recommended guidelines for User Profile Service.

Limit | Maximum value | Limit type | Notes
User profiles | 2,000,000 per service application | Supported | A user profile service application can support up to 2 million user profiles with full social features functionality. This number represents the number of profiles that can be imported into the people profile store from a directory service, and also the number of profiles a user profile service application can support without leading to performance decreases in social features.
Social tags, notes and ratings | 500,000,000 per social database | Supported | Up to 500 million total social tags, notes and ratings are supported in a social database without significant decreases in performance. However, database maintenance operations such as backup and restore may show decreased performance at that point.

Content deployment limits

The following table lists the recommended guidelines for content deployment.

Limit Maximum value Limit type Notes

Content deployment jobs running on different paths

20

Supported

For concurrently running jobs on paths that are connected to site collections in the same source content database, there is an increased risk of deadlocks on the database. For jobs that must run concurrently, we recommend that you move the site collections into different source content databases.

Note:

Concurrent running jobs on the same path are not possible.

If you are using SQL Server snapshots for content deployment, each path creates a snapshot. This increases the I/O requirements for the source database.

For more information, see About deployment paths and jobs.

Blog limits

The following table lists the recommended guidelines for blogs.

Limit | Maximum value | Limit type | Notes
Blog posts | 5,000 per site | Supported | The maximum number of blog posts is 5,000 per site.
Comments | 1,000 per post | Supported | The maximum number of comments is 1,000 per post.

Business Connectivity Services limits

The following table lists the recommended guidelines for Business Connectivity Services.

Limit Maximum value Limit type Notes

ECT (in-memory)

5,000 per web server (per tenant)

Boundary

Total number of external content type (ECT) definitions loaded in memory at a given point in time on a web server.

External system connections

500 per web server

Boundary

Number of active/open external system connections at a given point in time. The default maximum value is 200; the boundary is 500. This limit is enforced at the web server scope, regardless of the kind of external system (for example, database, .NET assembly, and so on) The default maximum is used to restrict the number of connections. An application can specify a larger limit via execution context; the boundary enforces the maximum even for applications that do not respect the default.

Database items returned per request

2,000 per database connector

Threshold

Number of items per request the database connector can return.

The default maximum of 2,000 is used by the database connector to restrict the number of result that can be returned per page. The application can specify a larger limit via execution context; the Absolute Max enforces the maximum even for applications that do not respect the default. The boundary for this limit is 1,000,000.

Response latency

600 seconds

Threshold

Timeout used by the external data connector per request. The default value is 180 seconds, but applications can be configured to specify a larger value up to the maximum of 600 seconds.

Service response size

150,000,000 bytes

Threshold

The upper volume of data per request the external data connector can return. The default value is 3,000,000 bytes, but applications can be configured to specify a larger value up to the maximum of 150,000,000 bytes.

Filter Descriptor (in-store)

200 per ECT method

Boundary

The maximum number of Filter Descriptors per ECT method is 200.

ECT Identifier (in-store)

20 per ECT

Boundary

The maximum number of identifiers per ECT is 20.

Database Item

1,000,000 per request

Threshold

The default maximum number of items per request the database connector can return is 2,000, and the absolute maximum is 1,000,000.

The default max is used by the database connector to restrict the number of results that can be returned per page. The application can specify a larger limit via execution context; the absolute max enforces the allowed maximum even for applications that do not respect the default such as indexing.

Workflow limits

The following table lists the recommended guidelines for workflow.

Limit Maximum value Limit type Notes

Workflow postpone threshold

15

Threshold

15 is the maximum number of workflows allowed to be executing against a content database at the same time, excluding instances that are running in the timer service. When this threshold is reached, new requests to activate workflows will be queued to be run by the workflow timer service later. As non-timer execution is completed, new requests will count against this threshold. This is limit can be configured by using the Set-SPFarmConfig Windows PowerShell cmdlet. For more information, see Set-SPFarmConfig.

Note: This limit does not refer to the total number of workflow instances that can be in progress. Instead, it is the number of instances that are being processed. Increasing this limit increases the throughput of starting and completing workflow tasks but also increases load against the content database and system resources.

Workflow timer batch size

100

Threshold

The number of events that each run of the workflow timer job will collect and deliver to workflows. It is configurable by using Windows PowerShell. To allow for additional events, you can run additional instances of the SharePoint Foundation Workflow Timer Service.

Workflow associations

100 per list

Supported

Exceeding this limit will degrade browser performance due to the large volume of data that is loaded for more than 100 associations and their status columns.

List items or documents that can be bulk created or uploaded to start workflow instances

5,000 items

Supported

Testing has verified that all workflow activation events are processed for an on-item-creation workflow association when up to 5,000 items are created in a single bulk upload. Exceeding this limit could cause workflow initiation to time out.

Published workflow definitions per web site

1,000 per web site

Supported

The maximum supported number of published workflow definitions per web site is 1,000.

Total workflow associations per site

1,799 per site

Boundary

The Service Bus supports a maximum of 1,799 subscriptions per scope. This maximum value includes the sum of both published and unpublished associations.

Maximum workflow definition (xaml) size

5,120 KB

Boundary

Attempts to publish xaml files that exceed the size limit will fail.

Maximum depth of a workflow sub-step in xaml (workflow complexity)

121 levels

Boundary

There is a hard limit of 125 for node depth in xaml. The maximum value of 121 levels accounts for the default activities (stage, sequence, etc.) that SharePoint Designer inserts automatically.

Workflow instance activations per second per web server

6 per second

Threshold

Testing has confirmed that a SharePoint web server can activate a maximum of 6 workflow instances per second. This number is cumulative, and therefore scales with the number of web servers in the farm. For example, 2 web servers can activate 12 workflow instances per second, and 3 web servers can activate 18.

Rest calls from SharePoint workflow per second per web server

60 per second

Supported

Testing has confirmed that a SharePoint web server can effectively process up to 60 rest calls per second from SharePoint workflow. If this level of volume will be exceeded, we recommend that an additional load-balanced web server be added to the SharePoint farm.In testing, 120 rest calls per second against a single web server resulted in sustained 90-100% CPU utilization. Adding a second web server reduced CPU utilization to 30-40% on both servers. Adding a third web server enabled processing of 180 calls per second, with 30-40% CPU utilization on all three servers, and so on. The servers used for this test were Hyper-V virtual machines with 16 core processor and 24 GBs RAM each.

Workflow variable value size

256 KB

Boundary

The maximum amount of data that can be stored in a single workflow variable is 256 KB. Exceeding this limit will cause the workflow instance to terminate.

Maximum list size for workflow lookups to non-indexed fields

5,000 items per list view

Threshold

This limit is a result of the maximum view size limit. When this limit is exceeded, workflow lookups to non-indexed fields will fail for non-administrative users. At this threshold, an index must be created for the field, in order for workflows to be able to successfully perform lookups against the field.

Maximum list size for auto-start workflow associations

10 million items per list

Supported

Testing has confirmed that the performance of auto-start workflow associations is not affected when list size grows to 1 million items.Because response time doesn't change as list size scales, the effective limit is the same as the maximum number of items in a non-workflow list.

Managed Metadata term store (database) limits

The following table lists the recommended guidelines for managed metadata term stores.

Limit Maximum value Limit type Notes

Maximum number of levels of nested terms in a term store

7

Supported

Terms in a term set can be represented hierarchically. A term set can have up to seven levels of terms (a parent term, and six levels of nesting below it.)

Maximum number of term sets in a term store

1,000

Supported

You can have up to 1,000 term sets in a term store.

Maximum number of terms in a term set

30,000

Supported

30,000 is the maximum number of terms in a term set.

Note:

Additional labels for the same term, such as synonyms and translations, do not count as separate terms.

Total number of items in a term store

1,000,000

Supported

An item is either a term or a term set. The sum of the number of terms and term sets cannot exceed 1,000,000. Additional labels for the same term, such as synonyms and translations, do not count as separate terms.

Note:

You cannot have both the maximum number of term sets and the maximum number of terms simultaneously in a term store.

Number of Variation Labels

209 per term store

Supported

The maximum number of Variation Labels per term store is 209.

Visio Services limits

The following table lists the recommended guidelines for instances of Visio Services in SharePoint Server 2013.

Limit Maximum value Limit type Notes

File size of Visio web drawings

50 MB

Threshold

Visio Services has a configuration setting that enables the administrator to change the maximum size of web drawings that Visio processes.

Larger file sizes have the following side effects:

  • Increase in the memory footprint of Visio Services.

  • Increase in CPU usage.

  • Reduction in application server requests per second.

  • Increase overall latency.

  • Increase SharePoint farm network load

Visio web drawing recalculation time-out

120 seconds

Threshold

Visio Services has a configuration setting that enables the administrator to change the maximum time that it can spend recalculating a drawing after a data refresh.

A larger recalculation time-out leads to:

  • Reduction in CPU and memory availability.

  • Reduction in application requests per second.

  • Increase in average latency across all documents.

A smaller recalculation time-out leads to:

  • Reduction of the complexity of diagrams that can be displayed.

  • Increase in requests per second.

  • Decrease in average latency across all documents.

Visio Services minimum cache age (data connected diagrams)

Minimum cache age: 0 to 24hrs

Threshold

Minimum cache age applies to data connected diagrams. It determines the earliest point at which the current diagram can be removed from cache.

Setting Min Cache Age to a very low value will reduce throughput and increase latency, because invalidating the cache too often forces Visio to recalculate often and reduces CPU and memory availability.

Visio Services maximum cache age (non-data connected diagrams)

Maximum cache age: 0 to 24hrs

Threshold

Maximum cache age applies to non-data connected diagrams. This value determines how long to keep the current diagram in memory.

Increasing Max Cache Age decreases latency for commonly requested drawings.

However, setting Max Cache Age to a very high value increases latency and slows throughput for items that are not cached, because the items already in cache consume and reduce available memory.

SharePoint Web Analytics service limits

The SharePoint Web Analytics service has been deprecated in SharePoint Server 2013.

PerformancePoint Services limits

The following table lists the recommended guidelines for PerformancePoint Services in SharePoint Server 2013.

Limit | Maximum value | Limit type | Notes
Cells | 1,000,000 per query on Excel Services data source | Boundary | A PerformancePoint scorecard that calls an Excel Services data source is subject to a limit of no more than 1,000,000 cells per query.
Columns and rows | 15 columns by 60,000 rows | Threshold | The maximum number of columns and rows when rendering any PerformancePoint dashboard object that uses a Excel workbook as a data source. The number of rows could change based on the number of columns.
Query on a SharePoint list | 15 columns by 5,000 rows | Supported | The maximum number of columns and row when rendering any PerformancePoint dashboard object that uses a SharePoint list as a data source. The number of rows could change based on the number of columns.
Query on a SQL Server data source | 15 columns by 20,000 rows | Supported | The maximum number of columns and row when rendering any PerformancePoint dashboard object that uses a SQL Server table data source. The number of rows could change based on the number of columns.

Word Automation Services limits

The following table lists the recommended guidelines for Word Automation Services.

Limit Maximum value Limit type Notes

Input file Size

512 MB

Boundary

Maximum file size that can be processed by Word Automation Services.

Frequency with which to start conversions (minutes)

1 minute (recommended)

15 minutes (default)

59 minutes (boundary)

Threshold

This setting determines how often the Word Automation Services timer job executes. A lower number leads to the timer job running faster. Our testing shows that it is most useful to run this timer job once per minute.

Number of conversions to start per conversion process

For PDF/XPS output formats: 30 x MFor all other output formats: 72 x M Where M is the value of Frequency with which to start conversions (minutes)

Threshold

The number of conversions to start affects the throughput of Word Automation Services.

If these values are set higher than the recommended levels then some conversion items may start to fail intermittently and user permissions may expire. User permissions expire 24 hours from the time that a conversion job is started.

Conversion job size

100,000 conversion items

Supported

A conversion job includes one or more conversion items, each of which represents a single conversion to be performed on a single input file in SharePoint. When a conversion job is started (using the ConversionJob.Start method), the conversion job and all conversion items are transmitted over to an application server which then stores the job in the Word Automation Services database. A large number of conversion items will increase both the execution time of the Start method and the number of bytes transmitted to the application server.

Total active conversion processes

N-1, where N is the number of cores on each application server

Threshold

An active conversion process can consume a single processing core. Therefore, customers should not run more conversion processes than they have processing cores in their application servers. The conversion timer job and other SharePoint activities also require occasional use of a processing core.

We recommend that you always leave 1 core free for use by the conversion timer job and SharePoint.

Word Automation Services database size

2 million conversion items

Supported

Word Automation Services maintains a persistent queue of conversion items in its database. Each conversion request generates one or more records.

Word Automation Services does not delete records from the database automatically, so the database can grow indefinitely without maintenance. Administrators can manually remove conversion job history by using the Windows PowerShell cmdlet Remove-SPWordConversionServiceJobHistory. For more information, see Remove-SPWordConversionServiceJobHistory.

Excel Services limits

The following table lists the recommended guidelines for Excel Services in SharePoint Server 2013.

Limit | Maximum value | Limit type | Notes
Maximum workbook size | 10 MB | Supported | The maximum size of a workbook that can be opened in Excel Services is 10 megabytes.

Machine Translation Service limits

The following table lists the recommended guidelines for the Machine Translation Service.

Limit | Maximum value | Limit type | Notes
Input file size for binary files | 524,288 KB per file | Threshold | Files larger than the limit take too long to transfer and process, decreasing the throughput of the service.
Input file size for text files | 15,360 KB per file | Threshold | Files larger than the limit have too much text to translate, decreasing the throughput of the service.
Maximum character count for Microsoft Word Documents | 10,000,000 per document | Threshold | Documents with more characters than the limit have too much text to translate, decreasing the throughput of the service.
Total concurrent translation processes | 5 | Threshold | Using more processes than the limit does not increase throughput because there is a limit to how much text can be translated at a time. Using more processes increases the demands on the server resources.
Delay between translations | 59 minutes | Threshold | Starting translations at a larger interval than the limit causes the time taken to translate documents to grow too large and can cause the number of queued translations to grow too large.
Number of translations per translation process | 1,000 per process | Threshold | Starting more translations than the limit causes translations to fail due to timing out because they cannot be processed before the timeout period.
Maximum concurrent translation requests | 300 | Threshold | More than 300 concurrent translation requests could cause translations to time out because requests are queued for longer than the timeout period.
Files per translation job | 100,000 files | Supported | Submitting jobs with a number of files that exceeds the limit causes job submittal time and processing time to be too long.
Machine Translation Service database size | 1,000,000 files | Supported | Operations to maintain the queue of jobs become slow if the database grows beyond the maximum number of files in the database.

Office Web Application Service limits

The following table lists the recommended guidelines for Office Web Apps. Office client application limits also apply when an application is running as a web app.

Limit | Maximum value | Limit type | Notes
Cache size | 100 GB | Threshold | Space available to render documents, created as part of a content database. By default, the cache available to render documents is 100 GB. We do not recommend that you increase the available cache.
Renders | One per document per second per CPU core per application server (maximum eight cores) | Boundary | This is the measured average number of renders that can be performed of "typical" documents on the application server over a period of time.
OneNote concurrent merge operations | 8 per document | Threshold | OneNote merges combine changes from multiple users who are co-authoring a notebook. If too many concurrent merges are already in progress, a conflict page is generated instead, which forces the user to perform the merge manually.

Project Server limits

The following table lists the recommended guidelines for Project Server. For more information about how to plan for Project Server, see Planning and architecture for Project Server 2010.

Limit | Maximum value | Limit type | Notes
End of project time | Date: 12/31/2149 | Boundary | Project plans cannot extend past the date 12/31/2149.
Deliverables per project plan | 1,500 deliverables | Boundary | Project plans cannot contain more than 1,500 deliverables.
Number of fields in a view | 256 | Boundary | A user cannot have more than 256 fields added to a view that they have defined in Project Web App.
Number of clauses in a filter for a view | 50 | Boundary | A user cannot add a filter to a view that has more than 50 clauses in it.

SharePoint Apps limits

The following table lists the recommended guidelines for apps for SharePoint.

Limit Maximum value Limit type Notes

Maximum Access/SharePoint App Package size

100 Mb

Boundary

100 MB is the limit for an app package created in the Access client.

Note:

Access compresses the database when it creates the app package, so the app package may include more than 100 MB of data.

Maximum Access app database storage size in SQL Azure

1 Gb

Boundary

Each Access app created on SharePoint Online creates a database on SQL Azure. 1 GB is the limit for the database storage on SQL Azure. In an on-premise installation, the administrator controls the size of the associated SQL database.

Apps displayed in Manage Licenses page

2,000

Boundary

Up to 2,000 apps (purchased from the store) can be displayed on the Manage Licenses page. You can still manage the license of any app by going to the All Site Contents page of the site where the app is installed and clicking on Licenses, or by searching for the app using Marketplace Search.

Number of app licenses per tenant

1,000,000

Supported

The maximum supported number of licenses (purchase of apps from the store) for a single SharePoint deployment, either on-premises or SharePoint Online. Exceeding this limit might cause severe performance degradation.

Number of apps displayed in the Add an App page

240

Boundary

After this limit is reached, only the first 240 apps are displayed, and a message guiding you to search to find your app is displayed.

Number of managers per app license

30

Boundary

Only 30 people can manage a license. License managers can add or remove users or delete a license.

Number of app licenses assigned to a user viewable by that user

2,000

Boundary

When more than 2,000 licenses are assigned to a user, that user will no longer see any apps in the default Add an App view. Instead, a message guiding you to search the app catalog or the SharePoint Store will appear.

Number of apps in the corporate catalog viewable by a single user

500

Boundary

When more than 500 apps from the corporate catalog are available to a single user, that user will no longer see any apps in the default Add an App view. Instead, a message guiding you to search the app catalog or the SharePoint Store will appear.

Distributed cache service limits

The following table lists the recommended guidelines for the distributed cache service.

Limit | Maximum value | Limit type | Notes
Number of followable entities (users, documents, sites and hashtags) per cache host | 400,000 | Supported | The total number of entities that can be followed by a single user on a distributed cache host with 16GB RAM assigned to the distributed cache service is 400,000.
Number of cache hosts in a cluster | 16 | Boundary | The total number of cache hosts a single distributed cache cluster can support is 16.
Maximum amount of memory dedicated to a cache host | 16GB | Boundary | The total amount of memory that can be dedicated to the distributed cache service on any one cache host in a cluster is 16GB.

Miscellaneous limits

The following table lists limits and recommended guidelines for services and features not covered in other sections.

Limit | Maximum value | Limit type | Notes
Number of User agent substrings per device channel | 150 | Boundary | The maximum number of user agent substrings per mobile device channel is 150.
Number of SharePoint sources per EDiscovery case | 100 | Boundary | The maximum number of SharePoint sources that can be added to an EDiscovery case is 100.
Number of Exchange sources (mailboxes) per EDiscovery case | 1,500 | Boundary | The maximum number of Exchange sources (mailboxes) per EDiscovery case is 1,500.
Maximum size of EDiscovery Query | 16K characters or 500 keywords | Boundary | The size of an EDiscovery query is limited to 500 keywords or 16,000 characters, whichever is reached first.
Number of nodes in managed navigation term set | 2,000 | Supported | The maximum supported number of terms in a managed navigation term set is 2,000.

See also

Hardware and software requirements for SharePoint 2013
Plan for performance and capacity management in SharePoint Server 2013

Change History

Date | Description
September 24, 2013 | Updated the "SharePoint Apps limits" section with new guidance for Access app limits.
May 21, 2013 | Updated the boundaries and limits for search.
April 23, 2013 | Updated the web application limits table with specific limits for both path-based and host-named site collections.
March 05, 2013 | Revised limits for maximum file size and security scopes.
July 16, 2012 | Initial publication


Capacity management and sizing overview for SharePoint Server 2013
See also

Summary: Learn about how to use performance data to plan and manage the capacity of a SharePoint Server 2013 environment.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

This article provides an overview of how to effectively plan and manage the capacity of SharePoint Server 2013 environments. This article also describes how to maintain a good understanding of the capacity needs and capabilities of your deployment, by analysis of performance and volume data. It also reviews the major application impacts that affect capacity, including content characteristics and usage.

Important:

Some values in this article are based on test results and other information related to SharePoint 2010 Products and may not represent the final values for SharePoint Server 2013. This article will be updated with appropriate values, links to related content and other information and republished when data related to SharePoint Server 2013 becomes available.

Capacity management is an ongoing process, because no implementation remains static with regard to content and usage. You need to plan for growth and change, so that your SharePoint Server 2013-based environment can continue to deliver an effective business solution.

Capacity Planning is only one part of the capacity management cycle. It is the initial set of activities that brings the design architect to the point where there is an initial architecture that the architect believes will best serve the SharePoint Server 2013 deployment. The capacity management model includes additional steps to help you validate and tune the initial architecture, and provides a feedback loop for re-planning and optimizing the production environment until it can support design goals with optimal choices of hardware, topology, and configuration.

In this article:

  • Glossary

  • Who should read capacity management articles?

  • Four fundamentals of performance

  • Capacity management versus capacity planning

  • Oversizing versus undersizing

  • Software limits and boundaries

  • SharePoint Server 2013 deployment key differentiators

  • Reference architectures

Glossary

The following specialized terms are used in SharePoint Server 2013 capacity management documentation.

  • RPS Requests per second. The number of requests received by a farm or server in one second. This is a common measurement of server and farm load. The number of requests processed by a farm is greater than the number of page loads and end-user interactions. This is because each page contains several components, each of which creates one or more requests when the page is loaded. Some requests are lighter than other requests with regard to transaction costs. In our lab tests and case study documents, we remove 401 requests and responses (authentication handshakes) from the requests that were used to calculate RPS because they have insignificant impact on farm resources.

  • Peak hours The time or times during the day when load on the farm is at its maximum.

  • Peak load The average maximum daily load on the farm, measured in RPS.

  • Load spike Transient load peaks that fall outside usual peak hours. These can be caused by unplanned increases in user traffic, decreased farm throughput because of administrative operations, or combinations of such factors.

  • Scale up To scale up means to add resources such as processors or memory to a server.

  • Scale out To scale out means to add more servers to a farm.

Who should read capacity management articles?

Consider the following questions to determine whether you should read this content.

Evaluating SharePoint Server 2013

Important:

Some links in this section might refer to SharePoint Server 2010 and other previous product versions, and will be updated when SharePoint Server 2013 versions of this content become available.

I am an IT pro or business decision maker, and I am looking for a solution to specific business problems. SharePoint Server 2013 is an option for my deployment. Can it provide features and scalability that meet my specific requirements?

For information about how SharePoint Server 2013 scales to meet the demands of specific solutions and how to determine the hardware that will be required to support your requirements, see the following sections later in this article:

  • Hardware and software requirements for SharePoint 2013

For information about how to evaluate SharePoint Server 2013 for your specific business requirements, see the following articles:

  • Explore SharePoint 2013

  • Hardware and software requirements for SharePoint 2013

Upgrading from Office SharePoint Server 2010

I am currently using SharePoint Server 2010. What has changed in SharePoint Server 2013, and what do I have to consider if I upgrade? What effect will the upgrade have on my topology's performance and scale?

For information about more general upgrade considerations and guidance on how to plan and execute an upgrade from Office SharePoint Server 2007, see the following article:

  • Upgrade to SharePoint 2013

Tuning and optimizing a live SharePoint-based environment

I have deployed SharePoint Server 2013, and I want to make sure I have the appropriate hardware and topology in place. How do I validate my architecture and maintain it correctly?

For information about monitoring and performance counters for SharePoint Server 2013farms, see the following article:

  • Monitoring and maintaining SharePoint Server 2013

For information about how to use the health monitoring tools built into the Central Administration interface, see the following article:

  • Monitor health in SharePoint 2013

I have deployed SharePoint Server 2013, and I am experiencing performance issues. How do I troubleshoot and optimize my environment?

For information about monitoring and performance counters forSharePoint Server 2013 farms, see the following articles:

  • Monitoring and maintaining SharePoint Server 2013

  • Plan for monitoring in SharePoint 2013

For information about tools and techniques for optimizing SharePoint Server 2013 farms, see the following article:

  • Optimize performance for SharePoint Server 2013

For information about troubleshooting by using the health monitoring tools built into the Central Administration interface, see the following article:

  • Solving problems and troubleshooting in SharePoint 2013

For a list of capacity management articles that are available for specific SharePoint Server 2010 services and features (more articles will be added as they become available), see the following article:

  • Performance and capacity test results and recommendations (SharePoint Server 2013)

For information about database sizing and performance, see the following article:

  • Storage and SQL Server capacity planning and configuration (SharePoint Server 2013)

For information about Remote BLOB Storage (RBS), see the following article:

  • Plan for RBS in SharePoint 2013

Beginning to end

I want to know everything about SharePoint Server 2013 capacity management. Where do I start?

For information about the general concepts behind capacity management and links to additional documentation and resources, see the following article:

  • Plan for performance and capacity management in SharePoint Server 2013

  • Plan logical architectures for SharePoint 2013

For additional information about capacity management, see the following companion articles to this overview article:

  • Capacity planning for SharePoint Server 2013

  • Performance testing for SharePoint Server 2013

  • Monitoring and maintaining SharePoint Server 2013

  • Optimize performance for SharePoint Server 2013

You should now have a good understanding of the concepts. For information the limits and boundaries of SharePoint Server 2013, see the following article:

  • Software boundaries and limits for SharePoint 2013

When you are ready to identify a starting point topology for your SharePoint Server 2013-based environment, you can look through the library of available technical case studies to find the one that most closely matches your requirements. For a list of SharePoint Server 2010 case studies (SharePoint Server 2013 case studies will be published as they become available), see the following article:

  • Performance and capacity technical case studies (SharePoint Server 2010)

For information about health monitoring and troubleshooting by using the health monitoring tools built into the Central Administration interface, see the following articles:

  • Plan for monitoring in SharePoint 2013

  • Solving problems and troubleshooting in SharePoint 2013

For more information about how to virtualize SharePoint Server 2013-based servers, see the following article:

  • Plan for on-premises or hosted virtualization in SharePoint 2013

For more information about high availability and disaster recovery, see the following article:

  • Plan for high availability and disaster recovery for SharePoint 2013

Four fundamentals of performance

Capacity management focuses on the following four major aspects of sizing your solution:

  • Latency For the purposes of capacity management, latency is defined as the duration between the time that a user initiates an action, such as clicking a hyperlink, and the time until the last byte is transmitted to the client application or web browser.

  • Throughput Throughput is defined as the number of concurrent requests that a server or server farm can process.

  • Data scale Data scale is defined as the content size and data corpus that the system can host. The structure and distribution of the content databases has a significant effect on the time that is required for the system to process requests (latency) and the number of concurrent requests it can serve (throughput).

  • Reliability Reliability is a measurement of the ability of the system to meet the targets set for the latency and throughput over time.

The main goal of managing your environment's capacity is to establish and maintain a system that meets your organization's latency, throughput, data scale, and reliability targets.

Latency

Latency, also known as end-user perceived latency, is composed of three major components:

  • The time it takes the server to receive and process the request.

  • The time it takes the request and the server response to transfer over the network.

  • The time it takes the response to render on the client application.

Different organizations define different latency goals based on business requirements and user expectations. Some organizations can afford latency of several seconds, whereas other organizations require very fast transactions. Optimizing for very fast transactions is usually costlier, and usually requires more powerful clients and servers, more recent browser and client application versions, high-bandwidth network solutions, and possibly development investments and page tuning.

Some major factors that contribute to longer end-user perceived latencies, and examples of some common problems, are described in the following list. These factors are especially relevant in scenarios where the clients are geographically distant from the server farm, or are accessing the farm across a low-bandwidth network connection.

  • Features, services, or configuration parameters that are not optimized might delay the processing of requests and impact latency for both remote and local clients. For more information, see Throughput and Reliability later in this article.

  • Web pages that generate unnecessary requests to the server to download required data and resources. Optimization would include downloading the minimum number of resources to draw the page, reducing the sizes of images, storing the static resources in folders that enable anonymous access, clustering requests and enabling page interactivity while resources are downloaded asynchronously from the server. These optimizations are important for achieving an acceptable first time visit browse experience.

  • Excessive volume of data being transmitted over the network contributes to latency and throughput degradation. For example, images and other binary objects on a page should use a compressed format such as .png or .jpg instead of bitmaps when it is possible.

  • Web pages that are not optimized for second-access page loads. Page Load Time (PLT) improves for second-access page loads because some page resources are cached on the client, and the browser must only download dynamic non-cached content. Unacceptable second-access page load latencies are often caused by incorrect Binary Large Object (BLOB) cache configuration or local browser caching being disabled on client computers. Optimizations would include correct caching of resources on the client.

  • Web pages that have non-optimized custom JavaScript code. This might slow rendering of the page on the client. Optimization would delay JavaScript from being processed on the client until the rest of the page has loaded, and preferably calling scripts instead of adding JavaScript inline.

Throughput

Throughput is described by the number of requests that a server farm can process in a unit of time, and is also often used to measure the scale of operations that the system is expected to sustain based on the size of the organization and its usage characteristics. Every operation has a specific cost in server farm resources. Understanding the demand and deploying a farm architecture that can consistently satisfy demand requires estimating the expected load, and testing the architecture under load to validate that latency does not fall below target when concurrency is high and the system is under stress.

Some common examples of low throughput conditions include the following:

  • Inadequate hardware resources When the farm receives more requests than it can process concurrently, some requests are queued, which cumulatively delays the processing of each subsequent request until demand is reduced enough for the queue to be cleared. Some examples of optimizing a farm to sustain greater throughput include the following:

    • Ensure that the processors on farm servers are not over-utilized. For example, if CPU usage during peak hours or load spikes consistently exceeds 80 percent, add more servers or redistribute services to other farm servers.

    • Ensure that there is sufficient memory on application servers and web servers to contain the complete cache. This will help avoid calls to the database to serve requests for uncached content.

    • Ensure that database servers are free of bottlenecks. If total available disk IOPS are insufficient to support peak demand, add more disks or redistribute databases to underutilized disks. See the Removing Bottlenecks section of Monitoring and maintaining SharePoint Server 2013 for more information.

    • If adding resources to existing computers is insufficient to resolve throughput issues, add servers and redistribute affected features and services to the new servers.

  • Non-optimized custom web pages Adding custom code to frequently used pages in a production environment is a common cause of throughput issues. Adding custom code might generate additional round trips to the database servers or Web services to service data requests. Customization of infrequently used pages might not significantly impact throughput, but even well-optimized code can decrease farm throughput if it is requested thousands of times a day. SharePoint Server 2013 administrators can enable the Developer Dashboard to identify custom code that requires optimization. Some examples of optimizing custom code include the following:

    • Minimize the number of web service requests and SQL queries.

    • Fetch the minimum required data in each trip to the database server while limiting the number of necessary round trips.

    • Avoid adding custom code to frequently used pages.

    • Use indexes when you are retrieving a filtered amount of data.

  • Untrusted solutions Deploying custom code in bin folders can cause slow server performance. Every time that a page that contains untrusted code is requested, SharePoint Server 2013 must perform security checks before the page can be loaded. Unless there is a specific reason to deploy untrusted code, you should install custom assemblies in the GAC to avoid unnecessary security checking.

Data scale

Data scale is the volume of data the server or server farm can store while meeting latency and throughput targets. Generally, the greater the data volume on the farm, the greater the impact on overall throughput and user experience. The method that is used to distribute data across disks and database servers can also affect farm latency and throughput.

Database sizing, data architecture, and sufficient database server hardware are all very important to an optimal database solution. In an ideal deployment, content databases are sized according to limits guidance and are distributed across physical disks so that requests are not queued because of disk overutilization, and database servers can support peak loads and unexpected spikes without exceeding resource utilization thresholds.

Also, certain operations can lock certain tables during the operation. An example of this is large site deletion, which can cause the related tables in the content database where the site resides to be locked until the delete operation is complete.

Some examples of optimizing a farm for data and storage performance include the following:

  • Ensure that databases are properly distributed across the database servers, and that database server resources are sufficient to support the volume and distribution of data.

  • Separate database volumes into unique Logical Units (LUNs), consisting of unique physical disk spindles. Use multiple disks that have low seek time and appropriate RAID configurations to satisfy database server storage demands.

  • You can use Remote BLOB Storage (RBS) if your corpus contains many Binary Large Objects (BLOBs). RBS can provide the following benefits:

    • BLOB data can be stored on less expensive storage devices that are configured to handle simple storage.

    • The administration of the BLOB storage is controlled by a system that is designed specifically to work with BLOB data.

    • Database server resources are freed for database operations.

    These benefits are not free. Before you implement RBS with SharePoint Server 2013, you should evaluate whether these potential benefits override the costs and limitations of implementing and maintaining RBS.

For more information about how to plan data scale, see Storage and SQL Server capacity planning and configuration (SharePoint Server 2013).

Reliability

Reliability is the aggregate measurement of the server farm's capacity to meet established latency, throughput, and data capacity targets over time. A reliable farm is one for which uptime, responsiveness, failure rate, and frequency and amplitude of latency spikes are within established targets and operational requirements. A reliable farm can also consistently sustain latency and throughput targets during peak load and peak hours, or when system operations such as crawling or daily backups occur.

A major factor in sustaining reliability is the effect of common administrative operations on performance targets. During certain operations, such as rebuilding the database indexes, maintenance timer jobs, or deleting multiple sites that have large volume of content, the system might be unable to process user requests as quickly. In this case, both latency and throughput of end-user requests can be affected. The impact on the farm depends on the frequency and transaction cost of such less common operations, and whether they are run during normal operating hours.

Some examples of how to sustain a more reliable system include the following:

  • Schedule resource-intensive timer jobs and administrative tasks during off-peak hours.

  • Scale up hardware on existing farm servers, or scale out by adding web servers, application servers or additional database servers.

  • Distribute resource-intensive services and features to dedicated servers. You can also use a hardware load balancer to direct feature-specific traffic to a web server dedicated to specific features or services.

Capacity management versus capacity planning

Capacity management extends the concept of capacity planning to express a cyclical approach in which the capacity of a SharePoint Server 2013 deployment is continually monitored and optimized to accommodate changing conditions and requirements.

SharePoint Server 2013 offers increased flexibility and can be configured to sustain usage scenarios in a wide variety of different scale points. There is no single deployment architecture. Therefore, system designers and administrators must understand the requirements for their specific environments.

SharePoint Server 2013 capacity management model

Capacity Management Model

  • Step 1: Model Modeling is the process by which you decide the key solutions that you want your environment to support, and establish all important metrics and parameters. The output of the modeling exercise should be a list of all the key data that you must have to design your environment.

    • Understand your expected workload and dataset.

    • Set farm performance and reliability targets.

    • Analyze the SharePoint Server 2013IIS logs.

  • Step 2: Design Once you have collected the data from Step 1, you can design your farm. Outputs are detailed data architecture and physical and logical topologies.

    • Determine your starting point architecture.

    • Select your hardware.

  • Step 3: Pilot, Test, and Optimize If you have designed a new deployment, you must deploy a pilot environment for testing against your workload and expected usage characteristics. For an existing farm, testing is advised when major changes are being made to the infrastructure, but regular optimization based on monitoring results might be necessary to maintain performance targets. The output from this phase is analysis of test results against targets, and an optimized architecture able to sustain established performance and capacity targets.

    • Pilot Deploy a pilot environment.

    • Test Test against latency and throughput targets.

    • Optimize Gather test results and make any required changes to the farm resources and topology.

  • Step 4: Deploy This step describes implementing the farm, or deploying changes to an existing farm. Output for a new design is a completed deployment to live production, including all content and user migrations. Output for an existing farm is revised farm maps and updates to maintenance plans.

  • Step 5: Monitor and maintain This step describes how to set up monitoring, and how to predict and identify bottlenecks and perform regular maintenance and bottleneck mitigation activities.

Oversizing versus undersizing

Oversizing describes an approach to farm design in which targets are achieved without full utilization of hardware, and the resources in the SharePoint Server 2013 farm are significantly and consistently underutilized. In an oversized deployment, memory, CPU, and other indicators on the farm's resources show that it can well serve the demand with fewer resources. The downside of oversizing is increased hardware and maintenance expenditures and can impose greater power and space demands.

Undersizing describes an approach to farm design in which performance and capacity targets are not achievable because hardware resources in the SharePoint Server 2013 farm are over-utilized. Undersizing a farm is sometimes done to reduce hardware costs, but generally results in high latency leading to a poor user experience, low satisfaction, frequent escalations, high support costs, and unnecessary spending for troubleshooting and tuning the environment.

When you design your farm, make sure that your farm can meet established performance and capacity targets, both under regular peak load and unexpected spikes. Design, testing, and optimization will help you to make sure that that your farm has the correct hardware.

To maintain performance targets and accommodate growth, it is always more desirable to have more resources than you must have to meet your targets. The cost of overinvestment in hardware is usually far less than the cumulative expenses related to troubleshooting problems cause by undersizing.

You should always size a system to respond adequately during peak demand, which might be different for specific services at different times. To effectively estimate capacity requirements, you must identify the worst case demand period for all resources. There might be increased load on various features and services at certain times of the day, such as first thing in the morning or after lunch.

The farm must also be able to support unplanned peaks, such as when organization-wide announcements are made and an unusually high number of users access a site at the same time. During such periods of high demand, users will experience high latency or not get a response from the farm at all unless sufficient farm resources are available to satisfy the increased load on the farm.

Farm capacity should also be revisited when additional users will be provisioned in the enterprise. Situations such as a merger or acquisition characterized by new employees or members accessing the farm can have adverse effects on performance if not planned and estimated in advance.

Operational states: Green Zone and Red Zone

When we describe the load of a production system, we refer to two major operational states: the "Green Zone" state in which the system is operating under the normal, expected load range, and the "Red Zone" state, which is a state in which the farm experiences very high transient resource demand that can only be sustained for limited periods until failures and other performance and reliability issues occur.

Green Zone This is the state at which the server or farm is operating under normal load conditions, up to expected daily peak loads. A farm operating in this range should be able to sustain response times and latency within acceptable parameters.

Red Zone The operating range in which load is greater than normal peak load, but can still service requests for a limited period. This state is characterized by greater than normal latency and possible failures caused by saturation of system bottlenecks.

The ultimate goal of farm design is to deploy an environment that can consistently support Red Zone load without service failure and within acceptable latency and throughput targets.

Software limits and boundaries

In SharePoint Server 2013, there are certain limits that are by design and cannot be exceeded, and other limits that are set to default values that can be changed by the farm administrator. There are also certain limits that are not represented by a configurable value, such as the number of site collections per web application.

Boundaries are absolute limits that cannot be exceeded by design. It is important to understand these limits to ensure that you do not make incorrect assumptions when you design your farm.

An example of a boundary is the 2 GB document size limit. You cannot configure SharePoint Server 2013 to store documents that are larger than 2 GB. This is a built-in absolute value, and cannot be exceeded by design.

Thresholds are those that have a default value that cannot be exceeded unless the value is changed. Thresholds can, in certain circumstances, be exceeded to accommodate variances in your farm design. However, you must understand that doing this might affect the performance of the farm and the effective value of other limits.

The default value of certain thresholds can only be exceeded up to an absolute maximum value. A good example is the document size limit again. By default, the document size limit is set to 50 MB, but can be changed to a maximum value of 2 GB.

Supported limits define the tested value for a given parameter. The default values for these limits were defined by testing, and represent the known limitations of the product. Exceeding supported limits could cause unexpected results, significant performance degradation, or other detrimental effects.

Some supported limits are configurable parameters that are set by default to the recommended value, whereas other limits relate to parameters that are not represented by a configurable value.

An example of a supported limit is the number of site collections per web application. The supported limit is the largest number of site collections per web application that met performance benchmarks during testing.

It is important to be aware that many of the limit values that are provided in this document represent a point in a curve that describes an increasing resource load and concomitant performance degradation as the value increases. Therefore, exceeding certain limits, such as the number of site collections per web application, might only result in a fractional decrease in farm performance. However, in most cases, operating at or near an established limit is not a best practice, as acceptable performance and reliability targets are best achieved when a farm's design provides for a reasonable balance of limits values.

Thresholds and supported limits guidelines are determined by performance. In other words, you can exceed the default values of the limits, but as you increase the limit value, farm performance and the effective value of other limits might be affected. Many limits in SharePoint Server 2013 can be changed. However, you should understand how changing a given limit affects other parts of the farm.

If you contact Microsoft Customer Support Services about a production system that does not meet the published minimum hardware specifications as described in Hardware and software requirements for SharePoint 2013, support will be limited until the system is upgraded to the minimum requirements.

How limits are established

In SharePoint Server 2013, thresholds and supported limits are established through testing and observation of farm behavior under increasing loads up to the point where farm services and operations reach their effective operational limits. Some farm services and components can support a greater load than others. Therefore, in some cases, you must assign a limit value that is based on an average of several factors.

For example, observations of farm behavior under load when site collections are added indicate that certain features exhibit unacceptably high latency while other features are still operating within acceptable parameters. Therefore, the maximum value assigned to the number of site collections is not absolute, but is calculated based on an expected set of usage characteristics in which overall farm performance would be acceptable at the given limit under most circumstances.

If other services are operating under parameters that are greater than those used for limits testing, the maximum effective limits of other services will be reduced. Therefore, it is important to execute rigorous capacity management and scale testing exercises for specific deployments to establish effective limits for that environment.

For more information about boundaries and limits and how they affect the capacity management process, see Software boundaries and limits for SharePoint 2013.

SharePoint Server 2013 deployment key differentiators

Each SharePoint Server 2013 deployment has a key set of characteristics that will make it unique and different from other farms. These key differentiators can be described by these four major categories:

  • Specification Describes the farm's hardware, and the farm topology and configuration.

  • Workload Describes the demand on the farm, including the number of users and the usage characteristics.

  • Dataset Describes content sizes and distribution.

  • Health and performance Describes the farm's performance against latency and throughput targets.

Specifications

Hardware

Hardware is the computer's physical resources such as processors, memory, and hard disks. Hardware also includes physical network components such as NICs (Network Interface Cards), cables, switches, routers and hardware load balancers. Many performance and capacity issues can be resolved by making sure that the correct hardware is being used. Conversely, a single misapplication of a hardware resource, such as insufficient memory on a server, can affect performance across the entire farm.

Topology

Topology is the distribution and interrelationships of farm hardware and components. There are two kinds of topology:

  • Logical topology The map of software components such as services and features in a farm.

  • Physical topology The map of servers and physical resources.

Typically, the number of users and usage characteristics determine the physical topology of a farm, and business requirements such as the need to support specific features for expected load drives the logical topology.

Configuration

We use the term configuration to describe software settings and how parameters are set. Also, configuration refers to caching, RBS, how configurable limits are set, and any part of the software environment that can be set or modified to meet specific requirements.

Workload

Workload defines the key operational characteristics of the farm, including the user base, concurrency, features that are being used, and the user agents or client applications that are used to connect with the farm.

Different SharePoint Server 2013 features have different associated costs on the farm's resources. Popularity of more costly features can potentially significantly impact the performance and the health of the system. Understanding your expected demand and usage characteristics will enable you to correctly size your implementation, and reduce the risk of constantly running the system in an unhealthy condition.

User Base

The user base of a SharePoint Server 2013-based application is a combination of the total number of users and how they are geographically distributed. Also, within the total user base, there are subgroups of users who might use given features or services more heavily than other groups. Concurrency of users is defined as the total percentage of users actively using the system at a given time. Indicators that define the user base include the number of total unique users and number of concurrent users.

Usage Characteristics

A farm's performance can be affected not only by the number of users interacting with the system, but also by their usage characteristics. Two organizations that have the same number of users might have significantly different requirements based on how often users access farm resources, and whether resource-intensive features and services are enabled on the farm. Indicators that describe the usage characteristics include the frequency of unique operations, the overall operational mix (the ratio of read and write operations and administrative operations), and the usage patterns and load against new features that are enabled on the farm (such as My Sites, Search, Workflows, and Office Web Apps).

Dataset

The volume of content that is stored in the system and the characteristics of the architecture in which it is stored can have a significant effect on the overall health and performance of the system. Understanding the size, access frequency, and distribution of data will enable you to correctly size the storage in the system and prevent it from becoming the bottleneck that slows down user interactions with farm services and affects the end-user experience.

To correctly estimate and design the storage architecture of a SharePoint Server 2013-based solution, you need to know the volume of data that you will store on the system, and how many users are requesting data from different data sources. The volume of the content is an important element of sizing disk capacity, because it can influence the performance of other features, and can also potentially affect network latency and available bandwidth. Indicators that define the dataset include total size of content, total number of documents, total number of site collections, and average and maximum sizes of site collection.

Health and performance

SharePoint Server 2013 farm health is basically a simplified measurement or score that reflects the reliability, stability, and performance of the system. How well the farm performs against targets is basically dependent on the first three differentiators. The health and performance score can be tracked and described by a distillation of a set of indicators. For more information, see Monitoring and maintaining SharePoint Server 2013 and Plan for monitoring in SharePoint 2013. These indicators include the system's uptime, end-user perceived latency, page failure rates, and resource utilization indicators (CPU, RAM).

Any significant change in hardware, topology, configuration, workload, or dataset can significantly vary the reliability and responsiveness of the system. The health score can be used to track performance over time and to assess how changing operating conditions or system modifications affect farm reliability.

Reference architectures

SharePoint Server 2013 is a complex and powerful product, and there is no one-size-fits-all architecture solution. Each SharePoint Server 2013 deployment is unique, and is defined by its usage and data characteristics. Every organization needs to perform a thorough capacity management process and effectively take advantage of the flexibility that the SharePoint Server 2013 system offers to customize a correctly sized solution that best satisfies the organizational needs.

The concept of reference architectures is meant to describe and illustrate the different major categories of SharePoint Server 2013 deployments, and not to provide a recipe for architects to use to design their solutions. This section focuses on describing the vectors on which SharePoint Server 2013 deployments usually scale.

The architectures listed here are provided as a useful way to understand the general differentiators between these generic categories, and to distinguish them by general cost factors and scale of effort.

Single server deployment

The single server deployment architecture consists of one server that is running SharePoint Server 2013 and a supported version of SQL Server. This architecture might be appropriate for evaluation purposes, developers or for an isolated non-mission-critical departmental implementation with only a few users. However, we do not recommend its use for a production environment.

Single-server Deployment Model

Small farm deployment

A small farm deployment consists of a single database server or cluster and one or two SharePoint Server 2013-based computers. The major architecture characteristics include limited redundancy and failover, and a minimal set of SharePoint Server 2013 capabilities enabled.

A small farm is useful to serve only limited deployments, with a minimal set of service applications enabled, a relatively small user base, a relatively low usage load (a few requests per minute up to very few requests per second), and a relatively small volume of data (10 or more gigabytes).

Small Farm Deployment Model

Medium farm deployment

This architecture introduces the breakdown of the topology into three tiers: dedicated Web servers, dedicated application servers, and one or more database servers or clusters. Separating the front end server tier from the application server tier allows greater flexibility in service isolation and helps balancing the load across the system.

This is the most common architecture, and includes a wide spectrum of service topologies and farm sizes. A medium farm deployment is useful to serve environments that have the following:

  • Several service applications distributed across multiple servers. A typical set of features might include the Office Web Apps Service, User Profile Service, Managed Metadata Service, and Excel Calculation Service.

  • A user base of tens of thousands of users and a load of 10 to 50 requests per second.

  • A data store of one or two terabytes.

Capacity - Medium Farm Deployment Model

Large farm deployment

Large farm deployments introduce the breakdown of services and solutions across multiple farms, and additional scaling out the tiers on a single farm. Several SharePoint Server 2013 services can be deployed on a dedicated services farm that serves requests from multiple consuming farms. In these large architectures, there are typically Web servers, multiple application servers, depending on the usage characteristic of each of the local (non-shared) services, and multiple SQL Server-based servers or SQL Server clusters, depending on the content size and the application services databases that are enabled on the farm. Large farm architectures are expected to serve deployments that have the following:

  • Several service applications federated and consumed from dedicated services farm, typically the User Profile Service, Search, Managed Metadata service, and Web Analytics.

  • Most other service applications are enabled locally.

  • A user base in the range of hundreds of thousands of users.

  • A usage load in the range of hundreds of requests per second.

  • A dataset in the range of ten or more terabytes.

Capacity - Large Farm Deployment Model

See also

Capacity planning for SharePoint Server 2013
Performance testing for SharePoint Server 2013
Monitoring and maintaining SharePoint Server 2013
Plan for monitoring in SharePoint 2013
Software boundaries and limits for SharePoint 2013
Performance and capacity test results and recommendations (SharePoint Server 2013)
Hardware and software requirements for SharePoint 2013

Performance and capacity technical case studies (SharePoint Server 2010)
Resource Center: Capacity Management for SharePoint Server 2010


Planning worksheets for SharePoint 2013
See also

Summary: Use planning worksheets for SharePoint 2013 to help you gather and record data when you plan to deploy a SharePoint environment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

  • Planning worksheets by task

  • Planning worksheets by title

Download worksheets and use them to record information that you gather and decisions that you make as you plan your deployment of SharePoint 2013. Use these worksheets in conjunction with — not as a substitute for — Plan for SharePoint 2013.

Planning worksheets by task

For this task | Use this worksheet | To do this
Plan for backup and recovery in SharePoint 2013 | Backup planning workbook | Help you plan strategies for backup and recovery for a SharePoint 2013 environment.
Plan service deployment in SharePoint 2013 | Services on Server Install Worksheet for Streamlined Topologies —or— Services on Server Install Worksheet for Traditional Topologies | Plan for and indicate the services that will run on farm servers.
Plan for upgrade to SharePoint 2013 | Upgrade worksheet | Record information about your environment while you prepare for upgrade.
Plan for eDiscovery in SharePoint Server 2013 | eDiscovery planning worksheet | Record the decisions that you make as you plan to implement eDiscovery in your SharePoint environment, including decisions about eDiscovery Centers and permissions.
Plan incoming email for a SharePoint farm in SharePoint 2013 | Plan for incoming email worksheet | Plan for incoming email for your SharePoint farm.

Planning worksheets by title

Use this worksheet | For this task | To do this
Backup planning workbook | Plan for backup and recovery in SharePoint 2013 | Help you plan strategies for backup and recovery for a SharePoint 2013 environment.
Services on Server Install Worksheet for Streamlined Topologies —or— Services on Server Install Worksheet for Traditional Topologies | Plan service deployment in SharePoint 2013 | Plan for and indicate the services that will run on farm servers.
Upgrade worksheet | Plan for upgrade to SharePoint 2013 | Record information about your environment while you prepare for upgrade.
eDiscovery planning worksheet | Plan for eDiscovery in SharePoint Server 2013 | Record the decisions that you make as you plan to implement eDiscovery in your SharePoint environment, including decisions about eDiscovery Centers and permissions.
Plan incoming email worksheet | Plan incoming email for a SharePoint farm in SharePoint 2013 | Plan for incoming e-mail for your SharePoint farm.

See also

Capabilities and features in SharePoint 2013 Resource Center
Install and deploy SharePoint 2013 for IT Pros Resource Center
Upgrade and migrate to SharePoint 2013 for IT Pros Resource Center


Plan user profiles and identities (SharePoint Server 2013)

Summary: Find the set of overview and planning topics for user profiles and identities for SharePoint Server 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet and related resources provide information about user profiles and identities for SharePoint Server 2013.

TechNet articles about user profiles and identities in SharePoint Server 2013

The following articles about the set of user profiles and identities in SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of profile synchronization in SharePoint Server 2013 | Learn about profile synchronization, also known as "profile sync", in SharePoint Server 2013.
Checklist icon (not checked) | Plan profile synchronization for SharePoint Server 2013 | Plan how to implement profile synchronization in SharePoint Server 2013.
Building blocks | Overview of the User Profile service application in SharePoint Server 2013 | Learn about the User Profile service application and how SharePoint Server 2013 uses it to enable features such as social computing.
Checklist icon (not checked) | Plan user profiles in SharePoint Server 2013 | Plan user profiles for SharePoint Server 2013.
 | People Picker and claims providers overview (SharePoint 2013) | Get an overview of People Picker and links to topics about how to plan for People Picker in SharePoint 2013.


Overview of profile synchronization in SharePoint Server 2013
See also

Summary: Learn about profile synchronization, also known as "profile sync," in SharePoint Server 2013.

Applies to: SharePoint Server 2013

A user profile is a collection of properties that describes a SharePoint user. Features such as My Sites and People Search use user profiles to provide a rich, personalized experience for the users in your organization. You can create user profiles by importing data from directory services, such as Active Directory Domain Services (AD DS). You can augment user profiles by importing data from business systems, such as SAP or SQL Server. The process of importing profile data from external systems and writing data back to these systems is called profile synchronization.

When you synchronize user profiles, you can also synchronize groups. Synchronizing groups gives SharePoint Server 2013 information about which users are members of which group.

User profiles and groups are used by SharePoint 2013 through server-to-server authentication to access and request resources from one another on behalf of users. For more information about server-to-server authentication, see Server-to-server authentication and user profiles in SharePoint Server 2013.

This article provides required information about profile synchronization in SharePoint Server 2013.

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Synchronization components

  • Importing profiles from a directory service

  • Importing properties from a business system

  • Exporting properties to a directory service

  • Creating user profiles without synchronizing

  • Synchronizing groups

  • Types of synchronization

  • Supported directory services

Synchronization components

The following figure shows the components that are involved in synchronizing profiles in SharePoint Server 2013. Shaded boxes represent external systems. The SharePoint Server components are described in the paragraphs that follow the figure.

Profile synchronization components

Note:

Throughout this topic, the phrase "business system" is used to mean an external system that is not a directory service. SAP, Siebel, SQL Server, and custom applications are all examples of business systems.

Your solution must have a User Profile service application to use any of the social computing features in SharePoint Server 2013. When you create the User Profile service application, you can specify the synchronization server (also known as the profile synchronization instance), which is the computer that will be used to synchronize profile information. Creating the User Profile service application creates several databases, such as the profile database.

The User Profile Synchronization service is the core of the synchronization architecture in SharePoint Server 2013. When you start the User Profile Synchronization service on the synchronization server, SharePoint Server 2013 provisions a version of Microsoft Forefront Identity Manager (FIM) to participate in synchronization. A User Profile service application can only have one User Profile Synchronization service. A User Profile Synchronization service is associated with connections and mappings.

A connection is a way to access profile data in an external system. A User Profile Synchronization service can have multiple connections, and each external system requires its own connection. Connections can be divided into two types: connections to directory services, and connections to business systems.

When you create a connection to a directory service, you specify which containers in the directory service contain the information that you want to synchronize. You can also create a filter to exclude users and groups that you do not want to import. For example, you could synchronize with the Users container in AD DS, but filter out users whose accounts are disabled.

When you create a connection to a business system, you specify the external content type that represents the information from the business system.

Mappings define how SharePoint user profile properties relate to data in external systems. A mapping for a particular user profile property consists of three things:

  • The connection that identifies the external system.

  • The attribute from the external system to which the user profile property is related.

  • The direction of the mapping, which can be either "import" for a property that receives its value from the external attribute, or "export" for an external attribute whose value is provided by the SharePoint user profile property.

Importing profiles from a directory service

You can create new profiles and import profile properties by synchronizing with a directory service. When you synchronize with a directory service, SharePoint Server 2013 does the following:

  • Creates a user profile for each new user in the directory service containers that are being synchronized, and fills in the properties of each new profile with data from the directory service.

  • Deletes the profile of any user who was removed from the directory service.

  • For properties that are being imported, updates the property in the SharePoint user profile if the corresponding value in the directory service has changed.

If you synchronize with multiple directory services, each directory service must provide unique users. You cannot synchronize a single user profile with multiple directory services.

Note:

Active Directory resource and logon forests present the only case in which you can synchronize the same users from two directory services. The connection to the logon forest provides the users. The connection to the resource forest merely augments the properties of existing profiles, similarly to a connection to a business system.

Importing properties from a business system

You can populate the properties of existing user profiles from a business system. You cannot create new user profiles in this manner, and you cannot write data back to a business system.

To import data from a business system, you must first create an external content type to bring the data from the business system into SharePoint Server 2013. Then you can synchronize user profiles with the external content type. For more information about external content types, see Overview of Business Connectivity Services in SharePoint 2013.

There must be some information that is shared by the external content type and a user profile. SharePoint Server 2013 uses this shared information to match an instance of the external content type to the correct user profile during synchronization. When you define the external content type, you specify that the field to match against is the identifier for the external content type. You specify which user profile property to match against when you create a synchronization connection to a business system. For example, if the business system contains an employee's email address, birth date, and office location, you could specify the email address as the identifier of the external content type, and create a connection that matches against the WorkEmail profile property. For each user profile, SharePoint Server 2013 would synchronize information from the instance of the external content type whose email address matched the WorkEmail property of the user profile.

Exporting properties to a directory service

Once user profiles exist, you can let users modify the values of certain profile properties. You can configure these properties so that data that is changed in SharePoint Server 2013 will be written back to a directory service. Each property can be either imported or exported. You cannot both import and export the same property. You can only export data about a user to the directory service from which the user was imported. You cannot create new user accounts in the directory service by exporting user profile information.

Creating user profiles without synchronizing

You can create a custom solution that uses the SharePoint object model to create user profiles. If your solution does not use profile synchronization, you can remove the profile synchronization features from the SharePoint user interface by selecting the Enable External Identity Manager option on the Configure Synchronization Settings page of Central Administration.

Synchronizing groups

If you synchronize groups in addition to users, SharePoint Server 2013 imports information about the groups that exist in the directory service containers with which you are synchronizing, and also about which SharePoint Server 2013 users are members of these groups. Each time that you synchronize, SharePoint Server 2013 updates the group and membership information. Groups do not have profiles, and you cannot manipulate them by using SharePoint Server. You must manage groups and their membership in the directory service itself. Within SharePoint Server, groups are only used to create audiences and to display the memberships that a visitor has in common with the person whose My Site the person is visiting (see Plan for My Sites in SharePoint Server 2013).

Types of synchronization

You can perform two kinds of synchronization: full and incremental. Full synchronization can take a long time—for directories that contain hundreds of thousands of users, it could take several days. Incremental synchronization only synchronizes data that has changed in the external system or SharePoint Server 2013, and is more efficient. You must perform a full synchronization the first time that you synchronize. After that, you can use incremental synchronization unless one of the following conditions is true:

  • A mapped property has changed. For example, you mapped a new property, or added or changed a mapping associated with a property.

  • You changed the containers that a connection uses to synchronize with a directory service.

  • You changed or added a filter.

  • An external content type that you are synchronizing with has changed.

  • You added or deleted a connection.

You can configure a timer job to run an incremental synchronization on a set schedule, ranging from every few minutes through monthly. You can also start either a full synchronization or an incremental synchronization manually.

Supported directory services

With SharePoint Server 2013 you can create connections to the following directory services:

  • Active Directory Domain Services (AD DS) 2003 SP2 and AD DS 2008

  • Sun Java System Directory Server version 5.2

  • Novell eDirectory version 8.7.3

  • IBM Tivoli version 5.2

You can use any of these directory services to synchronize users. Synchronizing groups is only supported for AD DS.

All of these directory services support full synchronization. All except Novell eDirectory support incremental synchronization.

You can also import data directly from Active Directory Domain Services (AD DS). For more information about how to import directly from AD DS, see Configure profile synchronization by using SharePoint Active Directory Import in SharePoint Server 2013.

See also

Plan for social computing and collaboration in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013
Plan user profiles in SharePoint Server 2013
Plan for My Sites in SharePoint Server 2013
Configure profile synchronization by using SharePoint Active Directory Import in SharePoint Server 2013
Administer the User Profile service in SharePoint Server 2013
Overview of Business Connectivity Services in SharePoint 2013


Plan profile synchronization for SharePoint Server 2013
See also

Summary: Learn how to implement profile synchronization in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Profile synchronization (also known as "profile sync") allows you to create user profiles by importing information from other systems that are used in your organization. Before you read this article you should understand the concepts introduced in the article Overview of profile synchronization in SharePoint Server 2013. Profile synchronization is also used in server-to-server authentication which enables servers to access and request resources from one another server on behalf of users. For more information, see Server-to-server authentication and user profiles in SharePoint Server 2013.

This article describes:

  • How to get the information that you must have to configure profile synchronization.

  • Who you must work with to collect the necessary information.

  • The external content types that will have to be created, if any.

As you examine this article, you can complete Worksheets to record your decisions. When you have finished this article and completed the worksheets, you'll have the information that you need to configure profile synchronization by using Central Administration. You can either give the completed worksheets to the profile synchronization administrator, or you can use them to do the configuration yourself. If you need external content types to represent information from external business systems, you'll specify the requirements for these external content types. You can give the specifications to the developer who creates the external content types.

This article does not describe how to implement your plan. That information is covered in the article Synchronize user and group profiles in SharePoint Server 2013.

In this article:

  • Before you begin

  • About planning for profile synchronization

  • Plan synchronization connections

  • Identify property mappings

  • Synchronizing groups

  • Plan for the synchronization server

  • Plan the synchronization schedule

  • Plan account permissions

  • Next steps

  • Worksheets

Before you begin

Before you work through the planning tasks in this article, you should already:

  • Know which users that you want to have profiles in SharePoint Server.

  • Know what properties a user profile will have, and fill out the User Profile Properties Planning worksheet as explained in the article Plan user profiles in SharePoint Server 2013.

  • Understand general concepts about directory services.

About planning for profile synchronization

As the first step towards planning for profile synchronization, you'll identify synchronization connections, and collect information that you will need when you create the connection. If you will need any external content types, you'll document the requirements for those external content types, provide the requirements to a developer, and receive the details that you'll use to specify a synchronization connection to the business system.

Next, you'll determine how to map user profile properties to information in the external systems so that they can be synchronized.

Finally, you'll answer more straightforward questions such as whether you'll synchronize groups, which server that you'll use to run the synchronization service, and how often you'll synchronize profile information.

Plan synchronization connections

Each property in a user's profile can come from an external system. There are two types of external systems: directory services and business systems. Throughout this article, the phrase business system is used to mean an external system that is not a directory service. SAP, Siebel, SQL Server, and custom applications are all examples of business systems.

Note:

For a list of supported directory services, see the Supported directory services section in the "Profile synchronization overview" article.

In SharePoint Server, a synchronization connection is a way to obtain user profile information from an external system. To import profiles from one of the supported directory services, you create a synchronization connection to the directory service. To import additional profile properties from a business system, you create an external content type to bring the data from the business system into SharePoint Server, and then create a synchronization connection to the external content type. The following sections explain how to collect the information that you will need about each synchronization connection.

Connections to directory services

Each user who you want to have a profile in SharePoint Server must have an identity in a directory service. (If users are not represented in a directory service, you can't synchronize user profiles.) Identify which directory services contain information about these users. Unless you can access the directory service yourself, you should also identify an administrator of the directory service. You will need this person's help to collect some information that will be needed to create synchronization connections.

The Connection planning worksheet contains templates for the information that you need to collect for each type of connection. Each template is in a separate tab that is labeled with the name of the directory service provider to which it applies. Create a tab for each directory service that you identified. Copy the template for the type of directory service into the new tab. Then complete the information on each new tab according to the following table.

Row name in worksheet Applies to connection type Instructions

Synchronization connection name

All

Choose a name that will help you remember which directory service this is a connection to.

Connection type

All

The type of directory service that this is a connection to.

This information is already filled in on each tab.

Forest

AD DS

The name of the directory service forest.

Domain controller

AD DS

The name of the preferred domain controller. You only have to identify the domain controller if there are multiple domain controllers in the forest and you want to synchronize with a specific domain controller.

Authentication provider type

All

The type of authentication SharePoint Server should use to connect to the directory service. This is one of the following:

  • Windows authentication

  • Forms-based authentication

  • Claims-based authentication

The systems architect should be able to provide this information.

Authentication provider

All

If forms-based authentication or claims-based authentication will be used, fill in the name of the trusted provider. The systems architect should be able to provide this information. An authentication provider is not needed for Windows authentication.

Synchronization account

All

The account, including the domain, that will be used to connect to the directory service. It is likely that the directory service administrator will create an account to be used for synchronization.

Note:

The permissions that the synchronization account must have are described in the Plan account permissions section of this topic.

Synchronization account password

All

The password for the synchronization account.

Security

You must know the password for the synchronization account. We recommend that you do not record the password in the worksheet.

Connection port

All

The port that will be used to connect to the directory service.

Use SSL?

AD DS

Whether to use an SSL-secured connection to connect to the directory service. SSL is only supported for connections to AD DS.

Directory service server

Tivoli, Sun, eDirectory

The name of the directory service server.

Username attribute

Tivoli, Sun, eDirectory

The name of the attribute in the directory service that serves as the unique identifier for each profile. In most cases, the default user name attribute of "uid" is correct.

Containers

All

The names of the directory service containers, also known as organizational units (OU), that contain the profiles to synchronize.

Filter for users

All

See the detailed instructions in the section About exclusion filters.

Filter for groups

All

See the section Synchronizing groups.

About exclusion filters

SharePoint Server will synchronize all of the profiles from the containers that you identify unless you choose to exclude profiles by using a filter. For example, you might create a filter to exclude users whose accounts are disabled.

A filter consists of a set of clauses and the connector to use to join the clauses. Each clause has three parts:

  • Attribute: The directory service attribute to compare.

  • Value: The value to compare the attribute to.

  • Operator: The type of comparison. For more information about which operators are available for each Active Directory Domain Services (AD DS) data type, see Connection filter data types and operators in SharePoint Server 2013.

There are two ways to join the clauses of an exclusion filter:

  • All apply (AND): An account matches the filter if all of the clauses apply.

  • Any apply (OR): An account matches the filter if any clause applies.

You can't mix ANDs and ORs in a filter.

For example, assume that temporary employees in your organization are given Active Directory accounts that begin with "T-". You want to synchronize profiles for all permanent (non-temporary) users whose accounts are not disabled. You could create a filter that uses the clauses in the following table.

Attribute | Operator | Value
sAMAccountName | starts with | T-
userAccountControl | bit on equals | 2

The filter would join the clauses by using Any apply (OR).

Note:

In AD DS, userAccountControl is a bitmask that represents several useful aspects about the status of the user account. For a list of some of the more frequently-used filters that you can create by using the userAccountControl attribute, see How to use the UserAccountControl flags to manipulate user account properties.

You can't create a filter that is based on membership in a directory service group, such as a distribution list. For alternatives to importing users based on group membership, see http://go.microsoft.com/fwlink/p/?LinkId=220892.

Connections to business systems

To import properties from a business system, you will need an external content type that brings the property value from the external system into SharePoint Server 2013. This article does not cover how to create an external content type. That task is usually done by a developer. This article describes the data that you must collect and give to the developer, and tells you what to do with the information that you receive. For developer information, see External content types in SharePoint 2013.

You can use the External content type planning worksheet to specify the external content types to be created. Go through the User Profile Properties Planning worksheet that you completed when you read the article Plan user profiles in SharePoint Server 2013. In the External Content Type Planning worksheet, create one row for each user profile property that comes from a business system. Fill in the first three columns of each row according to the instructions in the following table.

Column in worksheet | Instructions
Business system | A name that you choose that identifies the business system that contains the property.
Item | The data in the business system that corresponds to the property. Be as specific as possible. For example, if the business system is a database, provide the name of the table and column, if known.
Possible identifiers | A list of the user profile properties that could uniquely identify a user.

After you have filled in the first three columns of each row, give the worksheet to the external content type developer. The developer should follow these steps, and then return the worksheet:

  • Create external content types to provide the external system data that is described in the worksheet.

  • Choose an appropriate identifier for each external content type.

  • If user profiles will have a one-to-one relationship with items of the external content type, create a specific finder method. An external content type that contains a user's birthdate is an example of a one-to-one relationship. Each user profile will match one item of the external content type.

  • If user profiles will have a one-to-many relationship with items of the external content type, create a finder method and a comparison filter. An external content type that contains the license plate of a vehicle the user owns is an example of a one-to-many relationship. A user might own multiple vehicles. Therefore, each user profile might match more than one item of the external content type.

  • Update the worksheet to describe the external content types that were created.

The Connection Planning worksheet (http://go.microsoft.com/fwlink/p/?LinkId=267109) contains a tab for a connection to a business system. When you receive the information back from the external content type developer, group all user profile properties that share the same external content type. Create a tab in the Connection Planning worksheet for each external content type, and copy the information from the Business systems tab to each new tab. On each tab that you created, complete the information according to the instructions in the following table.

Row in worksheet | Instructions
Synchronization connection name | Choose a name that will help you remember which business system this is a connection to.
Connection type | "Business data connectivity" This information is already filled in.
Business data connectivity entity | The name of the external content type.
One-to-one or one-to-many mapping | The number of items of the external content type that might match a given user profile. Enter "one-to-one" or "one-to-many" as appropriate.
Profile property to match against | The name of the user profile property that corresponds to the external content type's identifier.
Comparison filter | The name of the comparison filter. A filter is only required for one-to-many mappings.

Identify property mappings

To indicate that a user profile property comes from an external system, you map the property to a specific attribute of the external system. By default, certain user profile properties are mapped. For a list of the default mappings for each type of directory service, see Default user profile property mappings in SharePoint Server 2013. You can only map a profile property to an attribute whose data type is compatible with the data type of the property. For example, you can't map the SPS-HireDate user profile property to the homePhone Active Directory attribute because SPS-HireDate is a date and homePhone is a Unicode string. For a list of which user profile property data types are compatible with which AD DS data types, see User profile property data types in SharePoint Server 2013.

When you synchronize profile information, in addition to importing profile properties from external systems, you can also write data back to a directory service. You can't write data back to a business system. To indicate that SharePoint Server should export a user profile property, you map the property, and set the direction of the mapping to Export. Each property can only be mapped in one direction. You can't both import and export the same user profile property. The data that is exported overwrites any values that might already be present in the directory service. This is true for multivalued properties also—the exported value is not appended to the existing values, it overwrites them.

Examine the User Profile Properties Planning worksheet that you completed as you read the Plan user profiles in SharePoint Server 2013 topic. For each row (property) whose value will be imported from an external system, fill in the final three columns according to the instructions in the following table.

Row in worksheet Instructions

Direction

"Import", indicating that the property will be imported into SharePoint Server.

Synchronization connection

The name of the synchronization connection through which this property will be provided.

Attribute

The name of the external system element that will provide the value of the user profile property.

If the synchronization connection is to a directory service, this is the name of the directory service attribute.

If the synchronization connection is to a business system, this is the name of the column in the external content type.

Note:

You can't use a connection to a business system to map a binary property to a property that implements the Stream accessor method.

For each row (property) whose value will be exported to a directory service, fill in the final three columns according to the instructions in the following table.

Row in worksheet | Instructions
Direction | "Export", indicating that the property will be exported from SharePoint Server to a directory service.
Synchronization connection | The name of the synchronization connection through which this property will be exported. This can only be a connection to a directory service.
Attribute | The name of the directory service attribute whose value should be updated with the value of the user profile property.

Synchronizing groups

By default, SharePoint Server synchronizes groups, such as distribution lists, when it synchronizes user profiles. You can turn off this functionality from the Configure Synchronization Settings page of Central Administration. Synchronizing groups is only supported for AD DS.

If you synchronize groups in addition to users, SharePoint Server imports information about the groups and about which users are members of the groups. Synchronizing a group does not create a profile for the group, and causes no additional user profiles to be created. In SharePoint Server, groups are only used to create audiences and to display which memberships a visitor has in common with the person whose My Site the person is visiting.

If you decide to synchronize groups, SharePoint Server will import information about all of the groups that exist in the directory service containers that you are synchronizing unless you choose to exclude groups by using a filter. The filter for excluding groups differs from the filter for excluding users, although both follow the same format.

Return to the Connection Planning worksheet and fill in the Filter for groups cell.

Plan for the synchronization server

In addition to determining the synchronization connections and identifying the property mappings, you also have to plan for the more straightforward aspects of synchronizing profiles. The first of these is identifying the synchronization server.

You can only run one instance of the User Profile Synchronization service on a farm. The computer on which the User Profile Synchronization service runs is called the synchronization server. You specify the synchronization server when you create the User Profile service application. SharePoint Server provisions a version of Microsoft Forefront Identity Manager (FIM) on this computer to participate in synchronization.

When SharePoint Server synchronizes profiles, it makes heavy use of the network to communicate between the synchronization server and the domain controllers. Choosing a synchronization server that is physically close to the domain controllers will reduce the time that is required to synchronize.

Plan the synchronization schedule

The first time that you synchronize profile information between SharePoint Server and external systems, you must run a full synchronization. After that, you should configure the User Profile Incremental Synchronization timer job to perform an incremental synchronization on a recurring schedule. You can configure the timer job to run every few minutes, hourly, daily, weekly, or monthly. By using the hourly, daily, weekly, and monthly options, you specify when you want the timer job to start.

The more often the synchronization timer job runs, the fewer changes there will be to synchronize, and the quicker the job will finish. The default frequency is daily. We recommend that you schedule synchronization to start at a time when the network is lightly used.

For instructions about how to configure the User Profile Incremental Synchronization timer job, see Schedule profile synchronization in SharePoint Server 2013.

Plan account permissions

In the Connection Planning worksheet, you provided the name of a synchronization account for each directory service. These synchronization accounts must be granted specific permissions so that the synchronization service can obtain the information that it needs from the directory service. The following sections identify which permissions are needed for each type of directory service. Work with the administrator of the directory service to grant the accounts the appropriate permissions.

Active Directory Domain Services (AD DS)

The synchronization account for a connection to Active Directory Domain Services (AD DS) must have the following permissions:

  • It must have Replicate Directory Changes permission on the domain with which you'll synchronize. For more information, see the "Grant Replicate Directory Changes permission on a domain" section of Grant Active Directory Domain Services permissions for profile synchronization in SharePoint Server 2013.

    The Replicate Directory Changes permission allows an account to query for the changes in the directory. This permission does not allow an account to make any changes in the directory.

  • If the domain controller is running Windows Server 2003, the synchronization account must be a member of the Pre-Windows 2000 Compatible Access built-in group. For more information, see the "Add an account to the Pre-Windows 2000 Compatible Access group" section of Grant Active Directory Domain Services permissions for profile synchronization in SharePoint Server 2013.

  • If the NetBIOS name of the domain differs from the fully-qualified domain name, the synchronization account must have Replicate Directory Changes permission on the cn=configuration container. For example, if the NetBIOS domain name is contoso and the fully-qualified domain name is contoso-corp.com, you must grant Replicate Directory Changes permission on the cn=configuration container. For more information, see the Grant Replicate Directory Changes permission on the cn=configuration container section of the Grant Active Directory Domain Services permissions for profile synchronization in SharePoint Server 2013 procedural reference article.

  • If you'll export property values from SharePoint Server to AD DS, the synchronization account must have Create Child Objects (this object and all descendants) and Write All Properties (this object and all descendants) permissions on the organizational unit (OU) with which you are synchronizing. For more information, see the "Grant Create Child Objects and Write permission" section of Grant Active Directory Domain Services permissions for profile synchronization in SharePoint Server 2013.

Novell eDirectory version 8.7.3

The synchronization account for a connection to Novell eDirectory must have the following permissions:

  • Entry Rights: Browse rights for the specified tree.

  • All Attributes Rights: Read, Write, and Compare rights for the specified tree.

Sun Java System Directory Server version 5.2

The synchronization account for a connection to a Sun Java System Directory Server must have the following permissions:

  • Read, Write, Compare, and Search permissions to the RootDSE.

  • To perform incremental synchronization, the synchronization account must also have Read, Compare, and Search permissions to the change log (cn=changelog). If the change log does not exist, you must create it before synchronizing.

IBM Tivoli version 5.2

The synchronization account for a connection to IBM Tivoli must have the following permission:

  • The synchronization account must be a member of an administrative group.

The farm account

The User Profile Synchronization service runs under the farm account. The farm account requires specific permissions to configure profile synchronization. A person with administrator rights on the synchronization server can grant these permissions.

  • The account must be a member of the Administrators group on the synchronization server. You can remove this permission after you have configured the User Profile Synchronization service.

  • The account must be able to log on locally to the synchronization server.

    Note:

    The farm account differs from the farm administrator account. To determine the farm account, from Central Administration, click Configure service accounts, and then click Farm account.

If you'll synchronize user profiles with a business system by using an external content type, the farm account must also have permission to execute operations on the external content type. A farm administrator can use the procedure "Set permissions on an external content type" to give the farm account Execute permission on each external content type with which you'll synchronize.

Next steps

To implement your profile synchronization plan, follow the instructions in the article Synchronize user and group profiles in SharePoint Server 2013. After you have configured profile synchronization and synchronized profile information for the first time, implement the synchronization schedule by following the procedure that is described in the article Schedule profile synchronization in SharePoint Server 2013.

Worksheets

To download the connection planning worksheet, the external content type planning worksheet, and the user profile planning worksheets, go to User profile properties and profile synchronization planning worksheets for SharePoint Server 2010.

See also

Plan for social computing and collaboration in SharePoint Server 2013
Overview of profile synchronization in SharePoint Server 2013
Plan user profiles in SharePoint Server 2013
Synchronize user and group profiles in SharePoint Server 2013
Administer the User Profile service in SharePoint Server 2013
Overview of the User Profile service application in SharePoint Server 2013
Grant Active Directory Domain Services permissions for profile synchronization in SharePoint Server 2013


Overview of the User Profile service application in SharePoint Server 2013
See also

Summary: Learn about the User Profile service application and how SharePoint Server 2013 uses it to enable features such as social computing.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The User Profile service application stores information about users in a central location. Social computing features use this information to enable productive interactions so that users can collaborate efficiently. In order to provision My Sites, enable social computing features such as social tagging and newsfeeds, and create and distribute profiles across multiple sites and farms, you must enable the User Profile service application.

In this article:

  • Uses and benefits of the User Profile service application

  • Architecture

  • Related service applications

Uses and benefits of the User Profile service application

The User Profile service application in SharePoint Server 2013 provides a central location where service administrators configure and administer the following features:

  • User profiles - contain detailed information about people in an organization. A user profile organizes and displays all of the properties related to each user, together with social tags, documents, and other items related to that user.

  • Profile synchronization - provides a reliable way to synchronize groups and user profile information that is stored in the SharePoint Server 2013 profile database together with information that is stored in directory services across the enterprise.

  • Audiences - enables organizations to target content to users based on their job or task, as defined by their membership in a SharePoint Server group or distribution list, by the organizational reporting structure, or by the public properties in their user profiles.

  • My Site Host - a dedicated site for hosting My Sites. A My Site Host is needed in order to deploy the social features of SharePoint Server.

  • My Site - a personal site that gives users in your organization a central location to manage and store documents, links, and information about colleagues.

  • Social tags and notes - enables users to add social tags to documents, to other SharePoint Server items, and to other items, such as external web pages and blog posts. Users can also leave notes on profile pages of a My Site or any SharePoint Server page. Administrators can delete all tags for employees when they leave the company or remove a tag they do not want.

These features make it possible for users in an organization to share information and to stay informed about what happens within the organization. Social tags, for example, enable users to tag and track the information in which they are most interested. Users can be alerted when people with which they work author new blog posts or when there is a change in organizational metadata.

Like other service applications in SharePoint Server 2013, farm administrators can delegate the administration of all or part of the User Profile service application to one or more service application administrators. This enables the User Profile service application to be managed by the appropriate business group. One administrator can manage all areas of the User Profile service application or areas can be isolated and managed by different administrators who might not know about the other areas of the service application. For example, one administrator can manage My Sites while a different administrator manages social tags and notes. The User Profile service application can be restricted and made available only to certain departments or sets of sites based on business need, security restrictions, and budgets. For more information, see Delegate administration of User Profile service applications in SharePoint Server 2013 and Logical architecture components (SharePoint Server 2010).

Architecture

When you create a User Profile service application, SharePoint Server creates three databases for storing user profile information and associated data:

  • Profile database - used to store user profile information.

  • Synchronization database - used to store configuration and staging information for synchronizing profile data from external sources such as the Active Directory Domain Services (AD DS).

  • Social tagging database - used to store social tags and notes created by users. Each social tag and note is associated with a profile ID.

Each of these databases can be accessed by My Sites, Team Sites, and other SharePoint sites by using the User Profile service application. This provides a dynamic, personalized experience for the users in an organization.

Related service applications

The User Profile service application relies on other service applications to implement the full range of social computing features in SharePoint Server. These related service applications include the following:

  • Managed metadata service - makes it possible to use managed metadata and share content types across site collections and web applications. For more information, see Overview of managed metadata service applications in SharePoint Server 2013 and Overview of managed metadata in SharePoint Server 2013 Overview of managed metadata service applications in SharePoint Server 2013

  • Search Service application - needed to enable the People Search feature. For more information, see Plan people search (SharePoint Server 2010).

  • Business Connectivity Services - makes it possible to populate the properties of existing user profiles from a business system during profile synchronization. For more information, see Overview of profile synchronization in SharePoint Server 2013 and Overview of Business Connectivity Services in SharePoint 2013.

See also

Plan for social computing and collaboration in SharePoint Server 2013
Administer the User Profile service in SharePoint Server 2013

Resource Center: Architecture Design for SharePoint Server 2013 IT pros


Plan user profiles in SharePoint Server 2013
See also

Summary: Find resources about how to plan for user profiles for SharePoint Server 2013.

Applies to: SharePoint Server 2013

A user profile is a collection of properties that describes a single user, and also the policies and other settings associated with each property. The user who is described by a profile is represented by a unique identifier in the profile, and the remaining properties provide information about that user, such as the user's phone numbers, manager, office number, job title, and so on. The set of user profiles for a SharePoint Server 2013 farm are stored in the profiles database associated with a User Profile service application.

User profiles are also used in server-to-server authentication which allows for servers to access and request resources from one another on behalf of users. For more information, see Server-to-server authentication and user profiles in SharePoint Server 2013.

In this article:

  • Overview of user profiles

  • About user profile properties

  • About property policies

Note:

Profile synchronization is the process of synchronizing data from directory services and business systems with user profiles. Along with understanding the concepts and activities described in this article, you should read the related article Overview of profile synchronization in SharePoint Server 2013.

User profiles help identify connections between users in an enterprise, such as their common managers, workgroups, group membership, and common web sites. They can also contain important information about a user, such as the products the user works on, the user's interests or areas of expertise, and the user's place in the organization's structure. By exposing this information in features such as My Sites, user profiles provide the basis for enterprise social networking in SharePoint Server 2013. Some of the enterprise social networking features that user profiles support are as follows:

  • My Sites

  • Profile pages

  • People searching

  • Organizational charts

  • Expertise search

  • Social tagging

  • Audiences

Overview of user profiles

As shown in the following illustration, user profiles can be composed of properties that are imported from a directory service, imported from business systems, and supplied by users.

Composition of SharePoint Server user profiles

For example, a directory service could supply important information that is needed across the organization, such as users' account names, work telephone numbers, titles, and work e-mail addresses. Business systems could supply business-related information, such as the customer accounts or product lines managed by each team member. Users could supply supplemental information about themselves, such as their areas of expertise or hobbies.

User profiles are distinct from SharePoint 2013 user accounts and exist in their own data store. User accounts help provide security and permissions to objects in SharePoint 2013. User profiles are used to organize information about users and about the relationships among users. Updating a user's profile does not affect that user's user account.

New user profiles are created in the following ways:

  • If an authenticated user does not have a user profile, a new one is created by using properties taken from the appropriate directory service the first time that user accesses his or her My Site.

  • You can create one or more user profiles by using profile synchronization. For details, see Plan profile synchronization for SharePoint Server 2013.

  • A custom solution can be developed to create user profiles. For more information, see How to: Create User Profiles and Organization Profiles.

    Important:

    Organization profiles are deprecated in SharePoint Server 2013. All other information in the SharePoint Server 2010 article applies to SharePoint Server 2013.

About user profile properties

A user profile is composed of a set of user properties. Each user property provides an item of information related to a user. User property values can come from directory services, business systems, or user input. You can configure some properties so that they can be exported to a directory service. Many of the decisions that you make in planning user profiles are about which user properties to include and how their values are set.

A rich set of data types is available for user properties. For a list of the supported data types and their definitions, see PropertyDataType Fields.

User profiles include a set of default user profile properties. Many of these properties are included because they are used by SharePoint 2013 social networking or personalization features, and a subset of the properties are mapped automatically to their corresponding directory service attributes after you run profile synchronization. For a list of default user properties, see Default user profile properties in SharePoint Server 2013.

SharePoint Server 2013 includes a managed metadata feature. Managed metadata is a hierarchical collection of centrally managed terms that you can define and then use as attributes for items in SharePoint Server 2013. A set of managed terms is a term set. You can associate a term set with an editable user profile property. By doing this, you can govern the values associated with that property and make it easier for users to enter appropriate values for the property. For example, by associating a term set that defines the job titles in an enterprise, you can help promote consistent use of those titles in user profiles. For information about how to plan managed metadata, see Plan managed metadata in SharePoint Server 2013.

About property policies

As described above, user profiles are used in many SharePoint Server 2013 social networking features. You can set policies on each user property in a user profile to help govern how the information in that property can be used. You can specify:

  • Whether or not a property is included in user profiles

  • Whether or not a property is required

  • Whether or not users can change the default privacy setting of a property

  • Who can view the property, based on the user's role in the organization

The following table describes each policy setting option.

Policy setting option Description

Enabled or Disabled

You can configure a property to be available for use in features that incorporate it, or you can configure a property to be unavailable by configuring it as disabled.

Required

You can specify that a property must contain information.

Optional

You can specify that a property is not required to have a value. Each user can provide values for the property or leave the property empty.

Default privacy setting

This determines who can see information for a property, as follows:

  • Everyone: Every user who has viewer or higher permissions to a site can see the relevant information.

    Only properties that have a privacy setting of Everyone will be used by search.

  • My colleagues: Every user in the user's My Colleagues list can see the information for this user.

  • My team: Every colleague in the user's immediate team, a subset of the My Colleagues list, can see the information.

  • My manager: Only the user and the user's immediate manager can see the information.

  • Only Me: Only the user can see the information.

User Profile service administrators can always view the information in a user profile regardless of its default privacy setting.

Users Can Override

When this option is selected, users can change the property's default privacy setting. When this option is not selected, only administrators of the User Profile Service can change default privacy settings.

Replicable

The property's value will be replicated to user information lists in other sites when its value changes. For a property to be replicated, its default privacy setting must be set to Everyone and the User can override policy must not be selected.

Along with setting policies on each user profile property, you can set similar policies on some SharePoint 2013 features that provide profile-related information in lists, Web Parts, or web sites. The personalization feature settings that you can set policies on include the following:

  • The display of SharePoint site memberships

  • The display of distribution list memberships

  • The display of colleagues on My Sites

  • Auto-population of colleagues based on organizational hierarchy

  • The display of colleague recommendations

  • The display of links on My Sites

  • Other sites pinned to My Sites

For example, if the display of distribution list memberships is enabled with a privacy setting of "My Team," then only members of a user's team will be able to view which distribution lists that user belongs to.

The following considerations can help you determine which policies are appropriate for your organization:

  • Which properties should be required? By default, some properties are required and can be configured so that they cannot be overridden or changed by users. In most organizations, these properties are key ways to enable collaboration and develop relationships across the organization. SharePoint Server 2013 uses many of these properties to enable other features, such as colleagues and audiences. For more information, see Audience and content targeting planning (SharePoint Server 2010) and Default user profile properties in SharePoint Server 2013.

  • Which properties should be visible to everyone? By default, most properties are visible to everyone, but you can configure sensitive information to have limited visibility. For example, a company that has many employees in the field might decide that mobile phone information is important for everyone to see. Other organizations might choose to keep all non-work telephone numbers private.

  • Which properties policies can be changed by users? Some property policies have settings that can be changed by users. For example, some users might not want automatic population of colleague lists. Other users might want to change the default visibility setting for a property.

When planning the policy setting for a property or personalization feature, consider the factors shown in the following table.

Condition Disable the property Make the property optional Make the property required

The property is used by key user features.

X

The property is associated with key business data for applications in the Microsoft Business Connectivity Services.

X

The property is used when you create audiences.

X

User Profile service administrators expect consistent and meaningful values for the property.

X

The property will rarely be used.

X

The property will distract from more important properties.

Note:

You can change the display settings for properties to hide them.

X

You decide to provide default values for properties, but want users to be able to change or remove those values.

X

When you plan the default visibility settings for properties, consider the factors shown in the following table.

Condition | Action
You want to use the property in search so that users can be found by searches for the property. | Set the default access policy to Everyone. Only properties that have a privacy setting of Everyone will be used by search.
The property is useful across workgroups and other divisions in your organization and does not contain sensitive information. | Make the property visible to everyone.
The property is mostly useful for collaboration inside an immediate workgroup or with a specific group of individually selected colleagues. | Make the property visible only to colleagues.
The property is of a private or sensitive nature. | Make the property visible only to the immediate manager, or in some cases, only the individual user.

Planning user profiles

This section provides guidance to help in planning user profiles. It is recommended that your planning tasks are performed in the following order:

  1. Identify stakeholders

  2. Identify how the profile information will be used

  3. Identify directory services and business systems

  4. Determine which properties to include

  5. Determine property details

  6. Determine personalization settings policies

  7. Plan for capacity

Some sections below refer to the User Profile Properties Planning worksheet. Use this workbook to record your user profile properties configuration decisions and personalization feature settings. The workbook also has a place to record contact information for the profiles stakeholders in your enterprise and for members of the governing body that oversees profile properties decisions.

Identify stakeholders

User profiles are part of an enterprise's information architecture and must meet the needs of workgroups that depend on the profile information. Decisions about which properties to include in profiles should be based on input from stakeholders representing the workgroups that use My Sites and other social computing features.

Decisions about user profiles must strike a balance between meeting the social computing needs of the organization and its security, privacy, and regulatory responsibilities. Therefore, decisions about which information to expose in user profiles and which properties to include should be made with the participation of executive sponsors, legal advisors, and human resources team members. This helps ensure that profile information is used in compliance with enterprise policies and legal requirements. If your solution spans multiple locales, it is a recommended practice to include represents from the various locales in making these decisions.

Use the Stakeholders tab on the User Profile Properties Planning worksheet to record the contact information for the members of your profiles stakeholders.

Identify how profile information will be used

How you intend to use this information in your SharePoint Server 2013 solution is the key to planning user profile properties. Your functional specifications and architectural documents should provide this information and should help guide you in designing effective user profiles to meet your users' needs. Your development team's functional specification, architecture diagrams, and other artifacts will be key resources in determining requirements for user profile properties.

Identify directory services and business systems

User profiles contain data from directory services and business systems. Directory services can supply the members of your user community and provide data about those users. Additional user information can be imported from business systems such as external databases or Web services. The particular directory services and business systems you'll use depend on your enterprise's environment.

For more information about integrating user profiles with directory services and business systems, see Plan profile synchronization for SharePoint Server 2013. That article includes information about how to plan directory service and business system integration and includes a Connection Planning worksheet in which you should list the directory services and business systems required by your solution.

Determine which properties to include

Review the article Default user profile properties in SharePoint Server 2013. By default, the mapped properties support basic SharePoint Server 2013 social computing and personalization features.

Also, determine which additional custom properties to include based on your social computing solution goals, your solution's functional requirements, and the data available from directory services and business systems.

In the Property column of the User Profile Properties Planning worksheet, list each property that you want to include. Information about filling in the rest of the worksheet is provided in the following section.

Determine property details

Use the User Profile Properties Planning worksheet to record the set of properties to include in user profiles, as shown in the following table.

Property Information to provide

Source

Indicate the source for the property: a directory service, business system, or "user input" for a write-in field. For business systems, we recommend that you enter the particular business system, such as "HR system".

Type

Indicate the property's type. A list of the supported data types and their definitions is available at PropertyDataType Fields.

Description

Define the property and describe its intended use.

Enable

Indicate if this property should be enabled. Enabling a property makes it available for use in features such as My Sites. Disabled properties are only visible to administrators of the User Profile service.

Require

Indicate if the property is required to have a value.

Editable

Indicate if users can edit this property's value.

Term set

If this is an editable property, you can also supply the name of a term set that contains acceptable values for the property.

Default privacy setting

Indicate who can see information for the property: everyone, colleagues, team members, manager, or only the user.

Privacy setting override

Indicate if users can change the property's default privacy setting.

Display options

Indicate if this property's value may appear in the following places:

  • On My Profile pages

  • On the page on which users edit their profile information

  • On a user's newsfeed, when the property value changes

Replication

Indicate if the property can be configured to be replicated to user information lists on other sites when a user changes its value. This requires that the property's default privacy setting is Everyone and that users cannot override the property's default privacy setting.

Search-related attributes

There are two search-related attributes:

  • Alias to user name: Indicate if the property's value should be treated as an equivalent to the user's name for searching.

  • Index: Indicate if the value of this property should be indexed for searching.

For tips about how to design user profiles that are searchable, see Update your profile to help people find you.

Connection attributes

There are three connection-related attributes: Connection name, Direction, and Attribute name. For descriptions, see Plan profile synchronization for SharePoint Server 2013.

Determine personalization settings policies

Along with setting policies on each user profile property in the User Profile service application, you can set similar policies on SharePoint Server 2013 personalization features that provide profile-related information in lists, web parts, or web sites. You do this on the Manage Policies page of the User Profile service application.

Use the Personalization tab of the User Profile Properties Planning worksheet to record the set of policies related to personalization features. You can set policies to give users the capabilities show in the following table.

Feature | Information to provide
SharePoint site memberships | Enable this capability if users' SharePoint site memberships should be displayed in My Sites, lists, and web parts.
Distribution list memberships | Enable this capability if distribution list memberships should be displayed in My Sites, lists, and web parts.
Colleagues | Enable this capability if users' colleagues should be displayed in My Sites.
Auto-population of colleagues from organizations | Indicates if the user's colleagues list should be auto-populated based on organizational hierarchy.
Display colleagues recommendations | Indicates if the list of colleague recommendations (based on email usage and other factors) should be displayed in My Sites, lists, and web parts.
Display links on My Sites | Enable this capability if links to users' frequently visited web sites should be displayed in My Sites.
Display other sites pinned to My Sites | Indicates if the sites that users have pinned to their My Sites can be viewed by other users.

You can enable or disable personalization features, and you can configure privacy settings on them. In the User Profile Properties Planning worksheet, record your privacy policy preferences for each personalization feature, as shown in the following table.

Setting | Information to provide
Enable | Indicate if this personalization feature should be enabled. Enabling a capability makes it available for use in features such as My Sites.
Default privacy setting | Indicate who can see information that is provided by the feature: everyone, colleagues, team members, manager, or only the user.
Privacy setting override | Indicate if users can change the feature's default privacy setting.

Plan for capacity and performance with user profile properties

The number and types of properties in your user profiles can affect your system's performance during profile synchronization and other operations. It is beyond the scope of this article to provide guidance about how to plan for capacity and performance with user profile properties. Capacity Planning for Microsoft SharePoint 2010 My Sites and Social Computing features uses test data to describe the performance and capacity effect of a range of choices in configuring user profiles and other social computing features in SharePoint Server 2013. Read this white paper to help determine the best way to design your user profile properties to achieve your performance and capacity planning goals.

See also

Plan for social computing and collaboration in SharePoint Server 2013

User profile properties and profile synchronization planning worksheets
Configure a profile synchronization connection in SharePoint Server 2010 (video)
Configure a synchronization connection to a SQL Server database in SharePoint Server 2010 (video)
Understanding Forefront Identity Manager 2010


People Picker and claims providers overview (SharePoint 2013)
See also

Published: October 30, 2012

Summary: Get an overview of People Picker and links to topics about how to plan for People Picker in SharePoint 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

People Picker is a web control that is used to find and select users, groups, and claims to grant permission to items such as lists, libraries, or sites in SharePoint 2013. For web applications that use claims-based authentication, the People Picker control uses claims providers to list, resolve, search, and determine the "friendly" display of users, groups, and claims. A claims provider in SharePoint 2013 issues claims, which SharePoint 2013 then packages into security tokens for users. Although People Picker is used by site, list, and library owners to assign permissions to sites and content in SharePoint 2013, its behavior is heavily dependent on how authentication is configured for the whole web application. It is important to plan for People Picker and claims providers when you plan authentication methods for your SharePoint 2013 solution.

In this article:

  • People Picker architecture

  • About the People Picker control

  • People Picker and authentication

  • TechNet articles about People Picker and custom claims providers

People Picker architecture

The People Picker control is a central component of SharePoint 2013. The control is connected to a repository so that you can find and select users, groups, and claims to assign permissions in a site. The exact sources of those users, groups, and claims depend on the authentication method that is used by the web application that contains the site collection. For more information about authentication methods, see People Picker and authentication later in this article.

People Picker is configured at the zone level for a farm by using the Stsadm setproperty operation. By configuring the settings for the control, you can filter and restrict the results that are displayed when a user searches for a user, group, or claim. Those settings will apply to every site in a specific site collection. For more information about how to configure People Picker, see Configure People Picker in SharePoint 2013.

When a web application is configured to use claims-based authentication, People Picker uses claims providers to resolve and display users, groups, and claims in the user or group text box. The information that SharePoint displays depends on the claims provider that is used by the authentication method that was configured for the web application. For more information about claims providers, see Plan for custom claims providers for People Picker in SharePoint 2013.

About the People Picker control

When you type the first three characters of a user name, group name, or claim (such as an e-mail address) into the text box, People Picker automatically searches for results that match the first three typed characters. You can then select from a drop-down list, which displays up to thirty suggested names with titles. If you rest the mouse pointer on a suggestion, SharePoint 2013 displays the email address and claims provider. To resolve a name, select it from the drop-down, or use your arrow keys to select it, and then press ENTER. You can also type the complete name followed by a semicolon. If a unique name is found, SharePoint will resolve it. Otherwise, SharePoint 2013 shows suggestions or indicates that the name was not found. You can delete a resolved name in the text box by using the BACKSPACE key or by clicking the "x" next to the name.

When a web application is configured to use Windows authentication, you can limit the suggested results by using the Stsadm setproperty operation to change the settings for the People Picker control. For example, you can configure People Picker to return only users, groups, and claims that belong to a certain Active Directory domain or are members of a specific site collection. For more information about how to configure the People Picker control, see Configure People Picker in SharePoint 2013.

People Picker and authentication

People Picker relies on the authentication method that is used by the web application that contains the site collection from which it is queried to determine what results to display to a user. If the web application is configured to use claims-based authentication (recommended), you can specify whether to use Windows authentication, forms-based authentication, or Security Assertion Markup Language (SAML) token-based authentication. In claims mode, People Picker searches and resolves queries that are based on the claims provider that is specified for the authentication method that is used by the web application and zone. If the web application is configured to use Windows authentication in classic mode, SharePoint 2013 treats user accounts as Active Directory Domain Services (AD DS) accounts. The following sections describe People Picker behavior for both claims-based and classic mode authentication. For more information about zones and authentication, see Plan for user authentication methods in SharePoint 2013.

Claims-based authentication

When claims-based authentication is used, People Picker uses the claims provider that is specified for the authentication method that is used by the web application and zone to retrieve a list of users, groups, or claims that match the search item typed in the text box. For more information about claims mode authentication and zones, see Plan for user authentication methods in SharePoint 2013.

You can write a custom claims provider to control what information is displayed and what results are returned in response to a query from the People Picker control. When a custom claims provider is registered on the server, you can also configure it for use in a specific web application and zone. For more information about custom claims providers, see Plan for custom claims providers for People Picker in SharePoint 2013.

Note:

In the Central Administration website, People Picker will return users, groups, and claims from all claims providers used in all web applications in the farm, regardless of the web application or zone in which the claims providers are configured.

By default, when you use SAML token-based authentication, all queries entered in the text box are automatically displayed as if they were resolved, regardless of whether they are valid users or groups. If your SharePoint 2013 solution will use SAML token-based authentication, you should plan to create a custom claims provider that will implement custom search, name resolution, and list features. For more information about custom claims providers, see Plan for custom claims providers for People Picker in SharePoint 2013.

For information about how to create a web application that uses claims-mode authentication, see Create claims-based web applications in SharePoint 2013. For information about how to configure claims-based authentication for web applications, see Configure claims authentication.

Classic mode authentication

When classic mode authentication (also known as Windows classic authentication) is used, the People Picker control queries Active Directory to retrieve a list of users, groups, or claims that match the search item typed in the text box. You can configure People Picker to query AD DS by using Lightweight Directory Access Protocol (LDAP) queries, which enables you to apply custom Active Directory filters, limit the scope of search queries, and search across forests and domains.

For more information about classic mode authentication, see Plan for user authentication methods in SharePoint 2013. For information about how to create a web application that uses classic mode authentication, see Create web applications that use classic mode authentication in SharePoint 2013.

TechNet articles about People Picker and custom claims providers

The following articles about People Picker and custom claims providers are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Checklist icon (not checked) | Content | Description
 | Plan for People Picker in SharePoint 2013 | Describes the People Picker control and how it works, its relationship to authentication and claims providers, and includes planning considerations for People Picker.
 | Plan for custom claims providers for People Picker in SharePoint 2013 | Describes the use and benefits of claims providers, their architecture, special considerations for custom claims providers, and planning considerations for them.

See also

Plan authentication in SharePoint 2013
Configure People Picker in SharePoint 2013


Plan for People Picker in SharePoint 2013
See also

Published: October 30, 2012

Summary: Learn how to plan for the People Picker web control in SharePoint 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

You use the People Picker control to find and select people, groups, and claims when a site, list, or library owner assigns permissions in SharePoint 2013. This article describes how to plan for People Picker. For information about how to configure People Picker, see Configure People Picker in SharePoint 2013.

Before reading this article, you should understand the concepts described in the following articles:

  • Plan for user authentication methods in SharePoint 2013

  • People Picker and claims providers overview (SharePoint 2013)

  • The Role of Claims

  • SharePoint Claims-Based Identity

In this article:

  • People Picker and claims providers

  • Using People Picker with multiple forests or domains

  • Planning considerations for People Picker

People Picker and claims providers

A claims provider lists, resolves, searches, and determines the "friendly" display of users, groups, and claims in the People Picker when claims-based authentication is used. If your web application uses claims-based authentication, you must decide whether to use one of the default claims providers or create a custom claims provider that will meet the business needs of your organization.

For more information about how claims providers are related to the People Picker control, see Plan for custom claims providers for People Picker in SharePoint 2013.

Using People Picker with multiple forests or domains

By default, People Picker will only return users, groups, and claims from the domain on which SharePoint 2013 is installed. If you want People Picker to return query results from more than one forest or domain, you must either have a two-way trust between the forests or domains, or you must configure People Picker to use an encrypted account and password for a one-way trust between forests and domains. For more information about trusts, see Managing Trusts.

To configure People Picker for a one-way trust, see Configure People Picker in SharePoint 2013.

Planning considerations for People Picker

Planning for People Picker largely depends on what forests and domains that you want users to be able to query, and what users, groups, and claims you want to display in query results. As you plan for the forests and domains that you want users to query, consider the following questions:

  • Do users have to query across a forest or a domain?

  • What is the domain name system (DNS) name for each forest or domain that you want users to query?

  • Will your forest or domain have a one-way or two-way trust with other forests or domains?

  • If you are using a one-way trust, what credentials will be used to query the other farms or domains?

Planning for the users, groups, and claims you want to display in the query results in People Picker will help you determine how to configure People Picker to return and display results from claims providers. As you plan for the users, groups, and claims you want to display in query results, consider the following questions:

  • Are there certain Lightweight Directory Access Protocol (LDAP) filters that you want to apply to query results?

  • Do you want to restrict the query results to users, groups, or claims in a specific site collection?

  • Do you want to restrict the query results to users, groups, or claims in a certain Active Directory organizational unit (OU)?

See also

Plan for user authentication methods in SharePoint 2013
People Picker and claims providers overview (SharePoint 2013)
Plan for custom claims providers for People Picker in SharePoint 2013
Configure People Picker in SharePoint 2013


Plan for custom claims providers for People Picker in SharePoint 2013
See also

Published: October 30, 2012

Summary: Learn about how to plan for custom claims providers for the People Picker web control in SharePoint 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

You can use the claims providers that are included with SharePoint 2013, or you can create your own custom claims providers to connect to additional sources of claims and provide additional claims in the security token for a user. For example, if you have a customer relationship management (CRM) application that contains roles that are not found in the user repository in Active Directory Domain Services (AD DS), you can create a custom claims provider to connect to the CRM database and add CRM role data to a user's original security token. For more information about claims provider usage scenarios, see Claims Provider.

A claims provider in SharePoint 2013 is used to augment claims and to provide name resolution. In the claims augmentation role, a claims provider augments a user security token with additional claims during sign-in. For more information about claims augmentation, see Claims Provider. In the name resolution role, a claims provider lists, resolves, searches, and determines the "friendly" display of users, groups, and claims in the People Picker. Claims picking enables an application to surface claims in the People Picker, for example when you configure the security of a SharePoint site or SharePoint service. For more information about People Picker, see Plan for People Picker in SharePoint 2013.

By default, the information that is resolved in People Picker when a query is performed depends on the information supplied by the claims provider. You can't change what information is supplied and how it is displayed when you use an out-of-box claims provider. To do this, you must create a custom claims provider that will meet the needs of your solution for finding and selecting users, groups, and claims when a user assigns permissions to items such as a site, list, or library.

When you create a custom claims provider, you can control what information is displayed and what results are returned in response to a query from the People Picker control. By default, you configure the web application to use claims authentication, and then register the claims provider on the server.

Before reading this article, you should understand the concepts described in Plan for user authentication methods in SharePoint 2013 and The Role of Claims. For additional information about claims-based authentication, see SharePoint Claims-Based Identityand A Guide to Claims-based Identity and Access Control.

In this article:

  • Architecture

  • Example custom claims provider configuration

  • Using custom claims on more than one farm

  • Planning considerations for custom claims providers

Architecture

When a web application is configured to use claims-based authentication, SharePoint 2013 automatically uses two default claims providers:

  • The SPSystemClaimProvider class provides claims information related to the server farm where SharePoint 2013 is installed.

  • The SPAllUserClaimProvider class provides an All Users claim.

Depending on the authentication method selected for a zone of a web application, SharePoint 2013 also uses one or more of the default claims providers that are listed in Table 1.

Table 1. Authentication methods and default claims providers

Authentication method | Claims provider
Windows authentication | SPActiveDirectoryClaimProvider
Forms-based authentication | SPFormsClaimProvider
Security Assertion Markup Language (SAML) token-based authentication | SPTrustedClaimProvider

You can see a list of claims providers for a farm by using the Get-SPClaimProviderWindows PowerShell cmdlet.

Note:

When a web application is configured to use SAML token-based authentication, the SPTrustedClaimProvider class does not provide search functionality to the People Picker web control. Any text entered in the People Picker control will automatically be displayed as if it was resolved, regardless of whether it is a valid user, group, or claim. If your SharePoint 2013 solution will use SAML token-based authentication, you should plan to create a custom claims provider to implement custom search and name resolution.

Claims providers are registered on a server farm as features that are deployed to the farm. They are scoped at the farm level. Each claims provider object uses the SPClaimProviderDefinition class to include information about the claims provider, such as display name, description, assembly, and type. Two important properties of the SPClaimProviderDefinition class are IsEnabled and IsUsedByDefault. These properties determine whether a registered claims provider is enabled for use in the farm, and whether the claims provider is used by default in a particular zone. By default, all claims providers are enabled when they are deployed to a server farm. For information about the SPClaimProviderDefinition class, see SPClaimProviderDefinition.

For more information about zones and authentication, see Plan for user authentication methods in SharePoint 2013.

Example custom claims provider configuration

By default, when you register a custom claims provider on the farm, the IsEnabled and IsUsedByDefault properties are both set to True. Depending on the number of zones needed for your SharePoint 2013 solution, the authentication methods that are used by each zone, and the users for each zone, you may want to limit the zones in which your custom claims provider is displayed in People Picker.

Because claims providers are scoped at the farm level and enabled at the zone level, you must carefully plan the zones in which you want the custom claims provider to be displayed. In general, you should ensure that the IsUsedByDefault property is set to False, and then configure the SPIisSettings class for each zone in which you want to use the custom claims provider. To configure a custom claims provider for select zones, you can create a Windows PowerShell script that sets the claims provider for a zone by using the ClaimsProviders property, or you can create a custom application to allow you to enable a custom claims provider for select zones.

For example, consider a scenario in which there are two web applications:

  • The first web application, PartnerWeb, has two zones — one intranet that uses Windows claims-based authentication and one extranet that uses forms-based authentication — and is used for collaboration among employees and partners.

  • The second web application, PublishingWeb, has only one zone that uses forms-based authentication and is an Internet publishing site for employees, business partners, and customer partners.

Now, suppose that for the extranet zone on PartnerWeb, you want employees to be able to collaborate with business partners but not customer partners. To do this, you write a custom claims provider that determines whether the current user is a business partner or customer partner, based on the user's identity. In this example, users from fabrikam.com are business partners, but users from contoso.com are customer partners. When a user who is a business partner is authenticated in the PartnerWeb web application, a claim for a role called BusinessPartner is added to the claim token. When a customer partner is authenticated, a claim for a role called CustomerPartner is added to the claim token.

To make sure that customer partners are never added to the extranet collaboration site, you add a web application policy on the PartnerWeb web application for the extranet zone that explicitly denies access to any user who has a claim for a role called CustomerPartner. The custom claims provider would also have to implement search and type-in support for the web application policy to resolve the CustomerPartner role claim so that it can be added to the web application policy. Finally, to enable this functionality on the extranet zone, you configure the SPIisSettings class for that zone to use the custom claims provider. The following diagram shows the authentication methods and claims provider settings for each web application and zone.

Figure 1. Example of the authentication methods and claims provider settings for Web applications and zones

You can set the IsUsedByDefault property by configuring it in a feature receiver that you create for your custom claims provider.

You can also override the settings of the IsEnabled and IsUsedByDefault properties by using the Set-SPClaimProviderWindows PowerShell cmdlet.

Important:

Changing the IsEnabled property to False will disable the claims provider for the server farm. This can be useful if you have to troubleshoot issues that might be caused by a custom claims provider. In general, the IsEnabled property should be set to True.

Using custom claims on more than one farm

Claim values are a combination of the claim itself, the claims provider name, and the order in which the claims provider was installed on the server. Therefore, if you want to use a claim across multiple farms or environments, you must install the claims providers in the same order on each farm in which you want to use the claim. Use the following steps when you have installed a custom claims provider on a farm and you want to use the same claim on additional farms:

  1. Register the claims providers on the additional farms in the same order that they were registered on the first farm.

  2. Perform a backup of the first farm. For information about how to back up a farm, see Back up farms in SharePoint 2013.

  3. Use the back up from the first farm to restore the other farms. For information about how to restore a farm, see Restore farms in SharePoint 2013.

Planning considerations for custom claims providers

As you plan custom claims providers for use with People Picker in your SharePoint solution, consider the following questions:

  • What zones does your web application have, and what authentication methods are used in each zone?

  • Are there any custom claims that should be added to users to enable more advanced permissions or security scenarios?

  • Will you be using SAML authentication with a trusted identity provider?

  • What will be the source of the values for the users and roles that will be displayed in People Picker query results?

The SharePoint 2013 Content Publishing team wants to thank Steve Peschka for contributing to this article. Take a look at Steve Peschka's Share-n-dipity TechNet blog.

See also

People Picker and claims providers overview (SharePoint 2013)
Plan for user authentication methods in SharePoint 2013


Plan for social computing and collaboration in SharePoint Server 2013

Updated: June 11, 2013

Summary: Learn how to plan for social computing and collaboration in SharePoint 2013.

Applies to: SharePoint Server 2013

SharePoint Server 2013 implements features that make enterprise social computing and collaboration easier. Social networking tools such as My Sites and social content technologies such as blogs, wikis, and really simple syndication (RSS), are examples of social computing features. These features enable users to easily capture and share the knowledge and expertise that is needed to do their work. This sharing of information encourages collaboration, improves innovation, and targets relevant content to the people who have to see it. You can adapt content to each user while enabling administrators to set policies to protect privacy.

The social computing and collaboration features in SharePoint Server 2013 are built upon a database of properties that integrates information about people from many kinds of business applications and directory services.

Good understanding and planning of social computing and collaboration features is very important for creating effective SharePoint Server solutions.

TechNet articles about planning for social computing and collaboration

The following articles about planning for social computing and collaboration in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Video (play button) icon | Video: Overview of social computing in SharePoint Server 2013 | View a video of enterprise social computing and collaboration in SharePoint Server 2013, including My Sites, Community Sites, and microblogging.
Building blocks | Social computing terminology and concepts in SharePoint Server 2013 | Learn about the terminology and concepts related to social computing in SharePoint Server 2013.
Building blocks | Overview of My Sites in SharePoint Server 2013 | Learn about the benefits and uses of My Sites in SharePoint Server 2013.
Checklist icon (not checked) | Plan for My Sites in SharePoint Server 2013 | Learn how to plan My Sites architecture, related services, and other considerations when planning to deploy My Sites.
Building blocks | Overview of communities in SharePoint Server 2013 | Learn about concepts, benefits, and uses of Community Sites and Community Portals in SharePoint Server 2013.
Checklist icon (not checked) | Plan for communities in SharePoint Server 2013 | Learn how to plan for Community Sites and Community Portals in SharePoint Server 2013.
Building blocks | Overview of microblog features, feeds, and the Distributed Cache service in SharePoint Server 2013 | Learn about microblog features, newsfeed, and the Distributed Cache service in SharePoint Server 2013.
Checklist icon (not checked) | Plan for feeds and the Distributed Cache service in SharePoint Server 2013 | Learn how to plan to implement microblog features, the Newsfeed, and the Distributed Cache service in SharePoint Server 2013.
Building blocks | Overview of security trimming, administrative policies, and privacy settings for social feeds in SharePoint Server 2013 | Learn about how security trimming, administrative policies, and user privacy settings affect feeds in SharePoint Server 2013.
Building blocks | Overview of SkyDrive Pro in SharePoint Server 2013 | Learn about SkyDrive Pro, its architecture, and the benefits of using SkyDrive Pro in SharePoint Server 2013.
Checklist icon (not checked) | Plan for SkyDrive Pro in SharePoint Server 2013 | Learn about performance, security, and other considerations for implementing SkyDrive Pro in SharePoint Server 2013.

Additional resources about planning for social computing and collaboration

The following resources about planning for social computing and collaboration in SharePoint 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | What's New in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.

Change History

Date | Description
June 11, 2013 | Added new article: "Overview of My Sites in SharePoint Server 2013."
May 21, 2013 | Added new article: "Plan for SkyDrive Pro in SharePoint Server 2013."
March 26, 2013 | Added two new articles: "Overview of security trimming, administrative policies, and privacy settings for social feeds in SharePoint Server 2013" and "Overview of SkyDrive Pro in SharePoint Server 2013."
July 16, 2012 | Initial publication


Video: Overview of social computing in SharePoint Server 2013
See also

Summary: View a video of enterprise social computing and collaboration in SharePoint 2013, including My Sites, Community Sites, and microblogging.

Applies to: SharePoint Server 2013

In this video, Bill Baer, SharePoint Senior Product Marketing Manager, provides an overview of the benefits and value that social computing and collaboration bring to the enterprise. He also introduces the key improvements to the social and collaboration features in SharePoint Server 2013.

Video: Social computing overview with Bill Baer

Video (play button) icon

Summary

SharePoint Server provides features and functionality to support the following social computing and collaboration pillars in the enterprise:

  • Connecting people By connecting people, you reduce employee isolation and give employees a voice to collaborate with both peers and executives. Employees can connect with others who have common interests, and create networks of people who share common goals across an organization instead of within a particular workgroup.

  • Managing knowledge Social computing and collaboration features and functionality provide an approachable, less formal means of communication in the enterprise. For example, you can use blogs or wikis to capture more impromptu or casual information that doesn't belong in formal documents or other resources in the organization. It reduces clutter, and creates transparent communities of persisted information.

  • Collaborating and sharing information Technology now provides ways for people to interact in a traditional computing scenario in much the same way they interact with others in real life. Employees find and discover other people in ways that are familiar to them, such as informal communications, conversations, and contributions.

Even though the social computing journey started in SharePoint Server 2010, SharePoint Server 2013 represents a further commitment to social computing and collaboration by bringing familiar social experiences to the platform.

My Sites are improved to include new, modern experiences such as microblogging, which is the basis of the new feeds infrastructure that supports likes, hash tags, mentions, and the ability to follow content, people, and other sites. My Sites are the gateway to the information you're interested in and to the people that you want to interact with. The content that you store in your My Site is yours until you decide to share it, and with whom to share it.

Community Sites are new in SharePoint Server 2013. They provide a forum experience that enables people to discuss common interests. Community Sites provide features to organize discussions, moderate conversations, and promote participation of members through incentives such as reputation points, gifted badges, likes, and best replies. These features help people share and locate knowledge through persistent, searchable information.

SharePoint Server 2013 can be considered a social renaissance for the enterprise, bringing together information and people, the right way, at the right time, and in the right place.

Related resources

Resource | Description
What's new in social computing in SharePoint Server 2013 | Learn about the new features and functionality for social computing and collaboration in SharePoint Server 2013.
Plan for social computing and collaboration in SharePoint Server 2013 | Plan for implementing and using social computing and collaboration features and functionality in SharePoint Server 2013.
SharePoint Products Tech Center | Find details about related technologies, downloads, and additional resources.

See also

Video demos and training for SharePoint 2013

Other SharePoint Preview videos: Training for IT pros
IT pro videos for SharePoint Server 2010


Social computing terminology and concepts in SharePoint Server 2013
See also

Summary: Learn about the terminology and concepts related to social computing in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Use this article as a reference to understand the terms and concepts related to social computing in SharePoint Server 2013.

Social computing terms and concepts

Table: Common terms and definitions for social computing

Term Description

Post

A post is an initial message that is created by a user or generated by the system.

Reply

A reply is a response to a post.

Activity

An activity is either a post or a reply. Posts and replies are collectively known as activities.

Conversation

A conversation consists of a single post and any number of replies.

Likes

When members post or reply to threads, other members can like the original post or individual replies. Likes provide a method to collect public validation or support for a message.

With My Sites, likes are available in the newsfeed. A user can view previously liked items from the Likes view in the newsfeed.

With Community Sites, likes are available for posts and replies. Members can improve their reputation in the community by building up likes.

Additionally, you can enable ratings on any list or library in the SharePoint site, and choose to use either likes or star ratings. These likes and ratings appear in the newsfeed.

Table: Terms and definitions for Community Sites

Term Description

Category

A category is a unit of organization to define similar characteristics of discussions. For example, in a Community Site for products, there might be a separate category for each product that a company manufactures.

Discussions and threads

Categories contain discussions, which in turn contain threads. Discussions often focus on a question or a specific area of interest for member feedback. Members contribute to discussions by replying to the original post, which creates a thread within the discussion.

Membership

Users who visit a Community Site can join and become a member of the community. Members are maintained in a SharePoint list that contains additional information that is specific to the user within the Community Site.

Visitor

A visitor is a person who visits a community but is not yet a member.

Member

A member is a person who joins the community and has permission to participate.

Moderator

A moderator is a community member who has permission and access to tools to manage, or moderate, the community settings and members.

Moderation involves reviewing and addressing posts that are flagged as inappropriate, setting rules for discussions, specifying interesting content as featured discussions to promote them, and so on. Strong moderation is important to promote quality content, to help users find useful content, and to make sure that that boundaries are in place to make the community successful.

Reputation

Each member of the Community Site earns a reputation within the community. Users earn a reputation based on specific activities and feedback from other members, such as when the member's posts are liked frequently or rated as a best answer.

Reputation functionality is maintained at the site level, and is specific only to that Community Site; in other words, reputation does not span sites within a site collection. This is by design because a member might be considered more reputable in one community than another community. Moderators and site owners define and adjust reputation settings for the community as a whole.

Gifted badges

Moderators and site owners can give a user a gifted badge to designate the user as a special contributor of the community. Gifted badges replace earned reputation. For example, you might give a gifted badge to highlight users who are experts in an area.

Best reply

In a discussion, one reply can be designated as the best reply. Only the original poster or moderators can designate best replies. By building up best replies, members can improve their reputation in the community.

Table: Terms and definitions for Microblogging, Newsfeeds, and Distributed Cache

Term | Definition
User Activity | A user activity is a post or reply originating from a user, and not a system-generated post or reply.
Following | Following refers to a user-initiated action that indicates a user's interest in a specific document, person, site, or tag. When a user follows an item, new activities about that item appear in the user's newsfeed on the user's My Site.
Mentions | When members post or reply to threads, they can tag other users by mentioning them. A mention takes the form of an at symbol (@) and the user's name. The user profile service returns a list of names that match the member's input. When users are mentioned, the users receive an activity in their My Site newsfeed that alerts them to the mention.
Tags | When members post or reply to threads, they can tag words by using hash tags. A hash tag takes the form of a number symbol (#) and the corresponding words that the member wants to include in the tag. The managed metadata service returns a list of terms that match the member's input. When a post contains tags, the newsfeed displays an activity related to that tag, and any users who follow that tag see the activity in their newsfeed.
Notifications | A notification is a system-generated email that notifies a user of an activity occurring on a thread they contributed to, or notifying the user that someone has started following him or her, or notifying the user that someone has mentioned him or her.
Entity | An entity is a person, document, tag, or site. Entities can be followed.
Feed or Newsfeed | A feed is a generic term that is used to refer to a container of conversation and activities. Special purpose feeds exist, such as the Likes view or the Consolidated Feed, where these feeds show different views or filtered views of conversations and activities. For example, the Likes view shows all items liked by the user. The Activities view, shows all activities, such as following a person, posts or replies performed by the user.
Likes view | The Likes view is a feed of activities liked by the user
Activities view | The Activities view is a feed showing all posts, replies and likes made by the user
Mentions view | The Mentions view is a feed showing all messages where the user was mentioned.
Everyone view | The Everyone view is the feed with all activities from all users.
Site feed | The site feed is a feed scoped to a particular group of users. The site feed is a feature on a team site. Security trimming applies to site feeds.
Consolidated feed | The consolidated feed is a feed that contains threads from entities a user is following. By default, the consolidated feed displays 20 items and is ordered in reverse chronological order. This is the default view of the newsfeed shown on the user's My Site.
Distributed Cache | The Distributed Cache is a service that provides caching functionality which runs on an application server in SharePoint Server 2013. All microblog features in SharePoint Server 2013 depend on the Distributed Cache service.
Feed Cache | The feed cache is an in-memory data store that stores recent activities of entities and provides data to various feeds on-demand. The feeds cache requires the Distributed Cache service to be running.

See also

Overview of communities in SharePoint Server 2013
Plan for communities in SharePoint Server 2013
Overview of microblog features, feeds, and the Distributed Cache service in SharePoint Server 2013
Plan for feeds and the Distributed Cache service in SharePoint Server 2013


Overview of My Sites in SharePoint Server 2013
See also

Published: June 11, 2013

Summary: Learn about the benefits and uses of My Sites in SharePoint Server 2013.

Applies to: SharePoint Server 2013

This article provides an overview of My Sites end-user functionality and benefits for consideration by enterprise business decision makers or SharePoint administrators. It does not discuss the architecture of My Sites or information about planning and configuring My Sites.

If you are a SharePoint administrator who is responsible for configuring My Sites in your organization, use this article together with Plan for My Sites in SharePoint Server 2013 to understand and plan for My Sites. You can then use the Configure My Sites in SharePoint Server 2013 to configure My Sites and Plan user profiles in SharePoint Server 2013 to see how user profile setup can influence the information that is displayed in My Sites.

Uses and benefits of My Sites

In SharePoint Server 2013, a My Site is a personal site for individual users in an organization. Although an organization can customize My Sites, by default the top of every page displays tabs for:

  • Newsfeed

  • SkyDrive

  • Sites

The default links on the left navigation bar that are visible to the owner of the My Site are as follows:

  • Newsfeed

  • About me

  • Blog

  • Apps

  • Tasks

  • Recent

When a user views another user's profile, the links on the left navigation bar are similar, but also include a link to Documents and People. The Documents link lets other users view the My Site owner's public documents stored on the owner's SkyDrive Pro, and the People link displays the people whom the My Site owner is following.

My Sites give users rich social networking and collaboration features, which enable users to explore and share interests, projects, business relationships, content, and other data with people in the organization.

Because My Sites enable users to easily share information about themselves and their work, this sharing of information encourages collaboration, builds and promotes information about expertise, and targets relevant content to the people who want to see it. Once My Sites are deployed, a user can access his or her My Site by clicking his or her user name in the top-right corner of a SharePoint Server page and then clicking About me. A user can also click any photo or a name in a newsfeed to be directed to that user's My Site profile.

Newsfeed

Newsfeed is the user's social hub where he or she can see updates from the people, documents, sites, and tags that the user is following. Newsfeed is the default page that displays when a user accesses his or her My Site. This page displays the feed of recent activities related to a user's specified colleagues and interests. Users can customize their newsfeeds by adding or removing colleagues they are interested in, specifying interests, and configuring the kind of activities they want to follow, such as when a colleague tags a shared interest. For more information about newsfeeds and other social computing terminology, see Social computing terminology and concepts in SharePoint Server 2013.

When the system generates an activity related to a user's action, such as when the user follows a site or changes a document, the activity includes the URL of the related item and an activity is created with a link to the affected content. These activities are security trimmed, which means that users can only see activities with links to which they have permission. This differs from user-generated posts with URLs to site or content, which are not security trimmed. For more information, see Overview of security trimming, administrative policies, and privacy settings for social feeds in SharePoint Server 2013.

The Newsfeed page contains the information shown in the following table.

Heading | Description
Start a conversation | A text box in which the user can post to the newsfeed. The user can either choose to share with everyone, or with the members of a team site of which he or she is a member.
Following | Lists all the conversations, tags, groups, and documents that the user is following.
Everyone | Displays the recent conversations from everyone in the organization.
Mentions | Displays all the mentions other users have made of the user, tasks assigned to the user, and so on.
Activities | Displays all the activities by the user.
Likes | Displays all the items that the user has liked.
I'm following | Displays a number that indicates how many people, documents, sites, and tags the user is following. The user can click the numbers to get more details about any items that she or she is following.
Trending #tags | Lists the top five tags.

SkyDrive

The SkyDrive tab links to the user's SkyDrive Pro. SkyDrive Pro is the user's personal file storage and synchronization service for business use.

The user's SkyDrive Pro usually includes a private folder and a folder that is shared with everyone, or with specific people. For more information, see Overview of SkyDrive Pro in SharePoint Server 2013.

Sites

The Sites tab lists the sites that the user is following and suggested sites that the user might find interesting. The user can use this to easily keep track of the sites he or she is most interested in.

About me

The About me is the default page that displays when a user accesses another user's My Site. This page displays the user's profile page to other people in the organization. The About me is also the default page that displays when a user accesses another user's My Site by clicking the user's name or profile picture.

SharePoint Server 2013 provides user profile policies that specify how profile information is displayed and how it can be used. Although there are recommended default policies for features and properties exposed in user profiles and personal sites, you can configure custom policies to meet specific needs of the organization. For example, you can configure a property to be more or less visible by default, and allow a user to override default settings for properties that you want to give them control over. You configure these policies for the User Profile service in the SharePoint Central Administration website. For more information, see About property policies in Plan user profiles in SharePoint Server 2013.

The About me page includes a title that is typically "About <user's name>" and it displays the user's profile data, such as the user's picture, title, group and telephone number.

The About me page contains the information shown in the following table.

Heading | Description
Activities | Displays the user's recent activities on newsfeeds, who the user is following, colleagues the user has added, and so on. For more information, see Enable or disable personal and social features for users or groups in SharePoint Server 2013.
edit your profile | By clicking edit your profile link, a user can change or update their display photo and information, and privacy settings for their individual profile properties that you allow them to override in the profile policy. The privacy settings are assigned to one of the following two privacy groups: Only Me or Everyone. For example, a user might decide to display more information, such as a personal phone number.
In Common | When a user views another user's profile, he or she can see the lowest level manager that they share.
Org Chart | Displays an organization chart. The chart shows the user's position in the organization among management, peers, and direct reports. You can select other people from the chart to view their profiles.

Blog

Blog is a Web Part page that the My Site owner can use to publish a blog. By default, the Blog page displays a left navigation pane with links to the user's blog categories and archives that can be edited.

The user can also customize the Blog page by editing the page, by adding apps to the page, or by changing the look of the page.

Apps

Displays the lists, libraries, and other apps for the user.

Tasks

Displays tasks assigned to the user. This is only visible to the owner of the My Site page.

The tasks can be viewed based on importance, status (active), whether they are completed, recently added, or personal.

See also

Plan for My Sites in SharePoint Server 2013
Plan for social computing and collaboration in SharePoint Server 2013
Configure My Sites in SharePoint Server 2013


Plan for My Sites in SharePoint Server 2013
See also

Summary: Learn about the process and considerations for planning a My Sites deployment in SharePoint Server 2013.

Applies to: SharePoint Server 2013

In SharePoint Server 2013, a My Site is a personal site for a user in an organization. Although a My Site appears as a single site to a user, the My Sites architecture in SharePoint Server consists of a web application, a My Site host site collection, an individual site collection, and several SharePoint service applications and features. Except for the individual site collection, all other parts of this infrastructure are configured once and shared among all the users who are part of the My Sites deployment.

This article contains information about My Sites architecture, related services, and other considerations when planning to deploy My Sites.

Use this article to understand and plan for My Sites. If you plan to use the microblogging and newsfeed features, see Plan for feeds and the Distributed Cache service in SharePoint Server 2013. After you understand the planning concepts, use the procedures in Configure My Sites in SharePoint Server 2013 and Configure microblogging in SharePoint Server 2013 to set up My Sites and feeds in your environment.

In this article:

  • My Sites architecture

  • Related service applications

  • Planning for jobs and schedules

  • Planning for geographically distributed deployments

  • Planning for the multilingual user interface

  • Planning for storage requirements

  • Planning for file types

My Sites architecture

The My Sites architecture consists of a web application that hosts My Sites, a My Site host site collection, and individual site collections for users.

Each user's My Site uses two site collections: the farm's My Site host site collection and the user's individual site collection. Although you can use an existing web application to host these site collections, we recommend that you use a dedicated web application to improve performance and manageability.

When you create the My Site host site collection and users create their individual site collections, the data is maintained in one or more content databases that are associated with the web application that hosts My Sites. Like other web applications in SharePoint Server, you can add content databases to this web application if you must have multiple databases for storage. For more information, see Planning for storage requirements in Plan for My Sites in SharePoint Server 2013.

The My Site host site collection and the configuration that enables individual My Sites site collections to be created are required before users can create My Sites. For more information, see Configure My Sites in SharePoint Server 2013.

The My Site host site collection and individual site collections are described more fully in the following sections.

My Site host site collection

The My Site host site collection is a special site collection that displays the newsfeed and profile pages of all users' My Sites. The site collection's site template must be the My Site host site template, available from the Enterprise tab of the Create Site Collection page. The My Site host site template can be used only once per User Profile service application, which is discussed later in this article.

My Sites require that a site collection exist at the web application root (which is displayed as / in the user interface). Without this, you will receive a message that states that there is no site collection at the root when you try to enable self-service site creation for the web application. Because we recommend that you use a dedicated web application to host My Sites, you should use the root path for the My Site host collection unless you have a specific requirement to create the site collection deeper in the uniform resource locator (URL) path.

Although not recommended, if you create the My Site host deeper in the path, it must be under an explicit inclusion managed path. Additionally, you must create a separate site collection at the web application root, although this site collection can be empty and created without a template.

The URL for a My Site host site collection is shared by all users of the same User Profile service application. The URL for Newsfeed is http://hostname/default.aspx, and the URL for About Me is http://hostname/person.aspx, where hostname is the address of the site collection. For example, if you configure your My Site host site collection at http://contoso.com/my, users access their newsfeeds and profiles at http://contoso.com/my/default.aspx and http://contoso.com/my/person.aspx, respectively.

Although these URLs are the same for all users of a User Profile service application, the information displayed for each user is different. SharePoint Server determines the information to display based on the user's logon account. The information is targeted to that specific user and is provided by the SharePoint service applications referred to in this article.

When a visitor views another user's My Site, the visitor can see only the user's profile page. This URL is http://hostname/person.aspx?accountname=account, where hostname is the address of the site collection and account is the user name (and, if it is configured, the user's domain name). For example, http://contoso.com/my/person.aspx?accountname=sidney.

Individual site collections

A user's individual site collection hosts the document library of the user's individual My Site. An individual site collection is created the first time that a user accesses the My Site. This ability to create an individual site collection requires the following configuration in SharePoint Server:

  • The web application that hosts My Sites has a wildcard inclusion managed path, such as sites or personal. This is the path under which the individual site collections will be created when users access their My Sites for the first time.

  • The Setup My Sites settings for the User Profile service application are configured to use the URL of the My Site host site collection and the wildcard inclusion managed path for individual site collections.

  • The web application is enabled for self-service site creation. This functionality enables the individual site collections to be created under the specified wildcard inclusion managed path. The self-service site creation feature has special security considerations for cross-site scripting. This strengthens the recommendation to host My Sites in a dedicated web application to isolate any scripts running in a My Site from affecting other sites in your environment. For more information about cross-site scripting vulnerabilities with web applications enabled for self-service site creation, see More information about the Self-Service Site Creation feature in Office SharePoint Server 2010 on the Microsoft Support website.

  • Users must have Create Personal Site permissions to create a My Site. By default, this permission is enabled for all authenticated users. For more information, see Plan users and user permissions later in this article.

The URL to a user's document library section of a My Site is in the format of http://hostname/managed_path/account/documents, where hostname is the address of the My Site host site collection, managed_path is the managed path for the My Site host, and account is the account of the user logged on. For example, if you configure your My Site host site collection and managed path at http://contoso.com/my, users access their documents at http://contoso.com/my/account/documents.

With the account part of the URL, when you set up My Sites, you have three options to specify how to name an individual user's site collection, as shown in the following table.

Table: Naming options for an individual user's site collection

Option | Description
User name (do not resolve conflicts) | By using this option, the My Site name is the user name of the account. This is not a user's display name. For example, if a user's friendly name is Sidney Higa and the user's account is sidney, the site collection is named sidney. Only choose the first option if you are sure that all user names in your organization are unique. Otherwise users will encounter conflicts when they provision their My Sites. If a conflict occurs, the first user who creates a My Site with a user name is successful. However, the next user who tries to use the same user name cannot create a My Site.
User name (resolve conflicts by using domain_username) | By using this option, the first user who has a duplicate user name will have a My Site created by using the user name only, and a second user who has that same user name will have a My Site created by using both the domain name and user name. For example, the first user will have a My Site created under http://contoso.com/my/sidney/default.aspx while the second user will have a My Site created under http://contoso.com/my/CONTOSO_sidney/default.aspx. Choose this option when it is possible for a user name to exist multiple times in an organization, such as when you have multiple domains. Because a user name is guaranteed to be unique only within its own directory source, this option prevents two users who have the same user name but different domains from encountering issues when they create their My Sites.
Domain and user name (will not have conflicts) | By using this option, all My Site names are created by using both the domain name and user name. For example, http://contoso.com/my/CONTOSO_sidney/default.aspx. Choose this option when you want My Sites to be consistently named with the domain name and user name, regardless of whether conflicts with user names exist or not.

Related service applications

My Sites rely on several SharePoint service applications and their related databases. These related service applications are discussed in this section, although you should also refer to the linked articles to fully plan and implement them to support My Sites in your enterprise.

User Profile service application

The User Profile service application has three databases: profile database, a social database, and a synchronization database. The profile database stores information about users, such as a profile picture, the organization the users belong to, and so on. The social database stores pointers to social tags and notes created by the users when they use the Notes and Tags feature. The synchronization database stores connection information for profile import. SharePoint Server uses the information in the profile database to personalize the data displayed on the About Me page of a user's My Site. Additionally, the User Profile service application enables social computing features, such as tagging, mentions, and newsfeeds for My Sites, which affect the About Me and Newsfeed sections of a user's My Site.

The User Profile service application is required for My Sites. For more information, see Overview of the User Profile service application in SharePoint Server 2013.

Plan for profile synchronization

Although configuring the User Profile service application is required for My Sites, synchronizing profiles between SharePoint Server 2013 and directory services or business applications is optional but highly recommended. Profile synchronization provides rich functionality for My Sites by enabling the User Profile service application to collect information about users in an organization from directory services and business applications. As a result, consistent and timely information is always available on a user's My Site. Information about users can also be synchronized across the deployment among all site collections that use the same User Profile service application. User information can also be used by personalization features to increase the value of collaboration and relationships in an organization.

For more information, see Plan profile synchronization for SharePoint Server 2013.

Plan policies and privacy

SharePoint Server 2013 provides a default set of policies that you can configure to make the appropriate information available to meet the needs of an organization. You can also create and deploy custom policy features to meet specific needs. When planning for My Sites, you should define which information is needed for key business processes in an organization and which information might be unsuitable for sharing across an organization. Between these extremes is the information that should be shared only among some users. In the case of information that might be unsuitable for sharing across an organization, you must create policies to address these specific situations. For more information about policy planning, see About property policies in Plan user profiles in SharePoint Server 2013.

Additionally, My Site features might store or use personally identifiable information. When planning to deploy My Sites, make sure that you carefully plan how to control the behavior of these features — or turn off the features — to help protect the privacy of this information. These decisions are affected by several factors, such as corporate privacy practices, and regional or national/regional privacy laws.

Plan users and user permissions

For users to create My Sites, maintain their profiles, follow people and content, and use tags and notes, there are user permissions to configure in the User Profile service application. Determine which of the following permissions to grant to users or groups of users:

  1. Create Personal Site This permission enables users to create a personal site to store their documents, newsfeed, and followed content.

  2. Follow People and Edit Profile This permission enables users to follow people from their My Site and to edit their personal profile.

  3. Use Tags and Notes This permission enables users to use the Tags and Notes feature from SharePoint Server 2010. The Tags and Notes feature is provided primarily for upgrade purposes so that users can continue to access the tags and notes they created in the earlier version of SharePoint Server. However, you might also use this permission to enable users to leave notes on documents in SharePoint Server 2013.

By default, all authenticated users are granted all these permissions, but you can configure specific permissions depending on your needs. For example, you could allow only full-time employees to create My Sites, instead of all workers in your organization. As a best practice, simplify administration by granting permissions to security groups instead of specific users.

Use the following table to understand how the combination of permissions affects the user experience in My Sites.

Table: Combination of permissions in My Sites

Option combination | Personal site creation | Edit profile | Newsfeed | Document library | Document following | People following | Site following | Social Tags and Note Board
1, 2, 3 | Yes | Yes | Yes | Yes | Yes | Yes | Yes | Yes
1,2 | Yes | Yes | Yes | Yes | Yes | Yes | Yes | No
1 | Yes | No | Yes | Yes | Yes | No | Yes | Yes
1,3 | Yes | No | Yes | Yes | Yes | No | Yes | Yes
2 | No | Yes | No | No | No | Yes | No | No
2, 3 | No | Yes | No | No | No | Yes | No | Yes
3 | No | No | No | No | No | No | No | Yes

Managed metadata service application

The managed metadata service application enables web applications to store and access keywords from a managed metadata term database. For My Sites, this functionality is required for users to specify keywords as their areas of expertise in the Ask Me About section, to use hash tags in posts in newsfeeds, and for social tagging by using the Tags and Notes feature of a My Site.

A managed metadata service application is highly recommended for My Sites. It must be configured as the default keyword term store for the web application. For more information about managed metadata service applications, see Overview of managed metadata service applications in SharePoint Server 2013.

Search service application

Although not required for My Sites, the SharePoint Server Search service application is highly recommended to enable users to search from their My Sites for people in the organization based on names or areas of expertise. Additionally, when you add a hash tag to microblog posts, users are directed to search results for that tag when they click it. This search functionality is part of enterprise search planning and configuration.

Although this section describes people and expertise search for My Sites, for more information about enterprise search, see Plan search in SharePoint Server 2013.

People search

When a user searches for people, results contain links to the public profiles of users and links to contact them by email or messaging programs. When planning for My Sites, you might want to consider supplementing the default people search scope, and supplementing the Search Center tab with customized search scopes and tabs for more specific groups of users.

If the administrator of the User Profile service application differs from the administrator of the Search service application, the User Profile service application administrator should review the information architecture and site hierarchy to determine the key business concepts that might relate to specific groups of users for whom other users might search across sites. Then the User Profile service application administrator can work with the Search service application administrator to develop search scopes and people search tabs for those specific groups. User Profile service application administrators can also use their knowledge of the user profiles they manage to determine other useful groups of users, and to create additional specific search scopes and search tabs for those groups.

Site collection administrators can also create site-level search scopes for users who are members of their site collections.

People search planning also feeds back into user profile planning. Initial planning might reveal people or groups of users whom you want to make it easier to find. However, additional user profile properties might have to be created to allow for those users to be found easily. For more information about how to plan user profiles, see Plan user profiles in SharePoint Server 2013.

Expertise search

When planning My Sites, you should determine whether you want to enable users to locate colleagues within the organization based on the colleagues' expertise. People search and expertise tagging help users locate people inside an organization who have identified themselves as having significant experience with a particular subject. Users in your organization can add terms to their profile that describe areas in which they have experience. These terms are used by people search when a user searches for someone in the organization who has experience in a particular area.

If email analysis is enabled, users can also find people by using email analysis in Outlook 2013. Colleague suggestions are imported from Outlook if you are using Office Outlook 2007 email. If you are using Outlook 2013, SharePoint Server analyzes sent email messages and then makes colleague and keyword suggestions based on this analysis. Users can then see these suggestions when they edit their profiles.

Although you can enable email analysis for all users in Outlook or only for specific groups by using Group Policy, users can opt out of this feature. If email analysis is disabled for all users, individual users can still opt in.

Planning for jobs and schedules

The timer jobs in the following table are related to My Sites functionality.

Table: Timer jobs related to My Sites

Services Jobs

Microsoft SharePoint Foundation Web Application

My Site Cleanup Job

Microsoft SharePoint Foundation Timer

User Profile service application name - User Profile to SharePoint Full Synchronization

User Profile service application name - User Profile to SharePoint Quick Synchronization

User Profile Service

User Profile service application name - Feed Cache Repopulation

User Profile service application name - Activity Feed Job

Note:

This is a legacy timer job that is included if you continue to use the SharePoint Server 2010 activity feed following upgrade.

User Profile service application name - Activity Feed Cleanup Job

Note:

This is a legacy timer job that is included if you continue to use the SharePoint Server 2010 activity feed following upgrade.

User Profile service application name - My Site Suggestions Email Job

You can enable or disable these jobs, and configure their schedules to meet the needs of your organization. These jobs are located in the SharePoint Central Administration website, under Monitoring, in the Review job definitions section. In the View list, select Service and then, from the Service menu, select Change Service to select different services and view the related timer jobs.

Planning for geographically distributed deployments

When planning for My Sites, you must consider the location of the users in the organization and the number of farms or User Profile service applications that will host My Sites. If you have more than one farm or User Profile service application, you will likely have to configure trusted My Site host locations.

User Profile service deployment considerations for My Sites

My Sites depend on the User Profile service application. In SharePoint Server 2013, My Sites should be configured by using one User Profile service application. Server farm architectures using a single User Profile service application include the following:

  • A single server farm with a single User Profile service application.

  • An enterprise services farm sharing a single User Profile service application together with one or more consuming farms. The My Sites Host is located on one of the consuming farms. In SharePoint Server 2013, the consuming farm must be physically located in the same datacenter as the enterprise services farm when you share the User Profile service application. Consuming the User Profile service application from another farm over a WAN connection is not supported. This means that both the User Profile service application and the My Site Host must be located in the same datacenter. For more information, see Multi-farm architectures with SharePoint Server 2013

Trusted My Site host locations

The Trusted My Site Host Locations feature prevents a user from creating more than one My Site in an organization with multiple User Profile service applications.

For example, in a server farm deployment that spans geographic regions, you might have separate User Profile service applications for each region or regional server farms in the environment. By default, a user can create a different My Site in each User Profile service application or server farm, which could cause unwanted results from both an administration perspective and a user perspective. When you have multiple My Sites for an individual user in an organization, server resource needs increase. Additionally, users might not understand or want multiple My Sites.

To prevent individual users from creating multiple My Sites, configure trusted My Site host locations. When specified, users are redirected to the single My Site host location that is intended for their accounts regardless of where they are browsing when they attempt to create or access their My Sites. This feature ensures that each user can create only one My Site in an organization.

Configuring trusted My Site host locations is optional.

Planning for the multilingual user interface

When enabled, users can use the multilingual user interface feature for their My Sites. This feature is used to display the site's user interface in a secondary language that the user prefers instead of the default, primary language that was selected when the site was created. By default, when a new site is created, it is created in the default, primary language of the SharePoint Server 2013 installation on the server. A farm administrator must install language packs on the server before sites can be created in languages other than the default, primary language.

For My Sites, the multilingual user interface feature is controlled by the Language Options setting when you configure My Site settings. The languages that are available to users correspond to the language packs installed in the server farm. For more information about language packs, see Install or uninstall language packs for SharePoint 2013.

Planning for storage requirements

Because My Site users can edit their profiles, generate newsfeed activities, upload and download documents, and so on, plan carefully for the storage and capacity needs of your environment. Take into consideration the content databases for My Sites and the databases for the related services of My Sites.

Additionally, SharePoint Server includes a default Personal Site quota template, which has a storage limit of 100 MB and no user limit. This quota template is used for each user's individual site collection in the user's My Site. Because feed activity is now stored in lists in the user's My Site, and those lists are not archived, storage needs will continue to grow. Therefore, consider increasing the personal site quota to 500 MB or more depending on the activity that you expect in the feeds.

Configuring quota templates is optional, but recommended. For more information, see Create, edit, and delete quota templates in SharePoint 2013.

Planning for file types

Like other web applications in SharePoint Server, you can configure the file types that users can upload to or download from the web application that hosts My Sites. This is useful if you want to prevent users from uploading or downloading file types that can be large, such as media file types, or file types that can be run on the client computer, such as executable files.

By default, SharePoint Server blocks certain file types. However, you can configure My Sites to allow these file types, or add other file types to block depending on the needs in your organization. For more information about how to manage file types, see Manage blocked file types in SharePoint 2013.

See also

Configure My Sites in SharePoint Server 2013
Plan for social computing and collaboration in SharePoint Server 2013


Overview of communities in SharePoint Server 2013
See also

Summary: Learn about concepts, benefits, and uses of Community Sites and Community Portals in SharePoint 2013.

Applies to: SharePoint Server 2013

In SharePoint 2013, a Community Site is a new site template that provides a forum experience in the SharePoint environment. Use communities to categorize and cultivate discussions among a broad group of people across organizations in a company. Communities promote open communication and information exchange by enabling people to share their expertise and seek help from others who have knowledge in specific areas of interest. You can deploy a Community Portal to promote communities to users within your enterprise.

This article uses many terms related to communities and social computing. If you are unfamiliar with a term, see Social computing terminology and concepts in SharePoint Server 2013.

Note:

Community Sites are available in SharePoint Server 2013, but not in SharePoint Foundation 2013. However, discussion lists and Web Parts are still available in SharePoint Server and SharePoint Foundation if you want a light-weight discussion experience on your SharePoint sites.

In this article:

  • Uses and benefits of communities

  • Impacts of communities

Uses and benefits of communities

Communities use categories to organize discussions. Visitors can view the discussions and become members of the community if they want to contribute to those discussions. Moderators manage the community by setting rules, reviewing and addressing inappropriate posts, marking interesting content as featured discussions, and so on. Moderators can also assign gifted badges to specific members to visually indicate that the member is recognized as a specific kind of contributor in the community, such as an expert or a moderator. Each community contains information about member and content reputation, which members earn when they actively post in discussions, and when their content is liked, replied to, or marked as a best answer.

Although the purpose of discussions is similar between communities and email discussion lists, there are some benefits to communities including:

  • All users who have access to the community (whether through membership or visitor permissions) can view the information in discussions. By using email distribution lists, only members of that list benefit from discussions.

  • Communities are more permanent and contain the history of any posts and replies in discussions before a user has even joined the community. In contrast, when a user joins a distribution list, they receive email only from the point that they joined the list.

  • Communities help collect and organize intellectual property that is otherwise undiscoverable or difficult to find unless you are part of the distribution list. By using distribution lists, there is no method to categorize email messages and a search of the email messages only returns results within the member's own folders.

  • Communities encourage and reward members for participation by building reputation points for posting, replying, and receiving likes and best answers.

  • Communities have built-in moderation functionality that helps keep the community active and appropriate to enterprise needs.

Impacts of communities

Usage options

There are several ways to use Community Sites and features in SharePoint Server 2013:

  • By creating a stand-alone community at the site collection level or at the site level. For example, you might create a community in an organizational portal if you want to facilitate discussions among members of the organization and use the community categories to keep things organized.

  • By populating a community with email messages from a distribution list. This approach is one way only; email messages populate discussions in the community, but new posts and replies originating from the community do not appear in email.

  • By activating community features on existing sites. You can activate community features on any site, which provides the core Community Site pages, moderation, membership, and reputation functionality without creating a community itself. For example, you might activate features on an existing team site where you want to include community functionality but do not want to create and manage a separate site.

Community Portal template

The Community Portal template is an enterprise site template. It is a Web Part page that provides search-driven results to display any sites that use the Community Site template in the SharePoint farm. The Community Portal template provides a search Web Part to search for communities or other content, and a Popular Communities Web Part to display communities. The sort order in Popular Communities is determined by the number of posts, number of replies, and number of members. Posts are weighted higher than replies and members. Replies and members are weighted the same. This means that a community with a smaller number of very active users is considered more popular than a larger, less active community.

You can edit the Community Portal page to add other Web Parts and customize the page. When deployed in the same environment as My Sites, users can access the Community Portal from the Sites link on their My Sites. You can have only one Community Portal per SharePoint farm.

Community Site template

The Community Site template is a collaboration site template that is based on the Team Site template, and contains the same base features such as lists and libraries, a wiki-page editing experience, and so on. However, The Community Site template provides the additional features and functionality shown in the following table.

Table: Elements included in the Community Site template

Site template element type Included in the Community Site template

Pages

Home

Categories

Members

About

Administration settings

Lists

Discussions

Categories

Badges

Community Members

Web Parts

What's happening: Available for visitors and members to display how many members, discussions, and replies the community has.

Top contributors: Available for visitors and members to display the members who contribute most to the community.

My Membership: Available for members to display information about their membership in the community, such as the number of posts and replies.

Manage: Available for site owners and community moderators to manage discussions, categories, members, reputation settings, and community settings.

Community Sites inherit the features and functionality that is provided to other SharePoint sites, such as governance, records management, workflows, and so on. Once deployed, you can customize the default content in the template to adapt the user experience to the special interests of the community. For example, you can change the appearance by choosing a new site background picture, changing themes, customizing the page content, adding an image and description to a category, and more.

Requirements and dependencies

Communities rely on the following required and optional databases, services, and service applications in SharePoint Server 2013:

  • Content database Required to store the content from the site's lists and pages.

  • User Profile service, service application, and social and profile databases Optional but recommended to enable the use of profiles for members of the community, integration with My Sites and feeds, and mention functionality in discussions. When implemented in the same environment as My Sites, users can access the Community Portal from the Sites page on their My Sites. Additionally, when a member joins a community, starts a discussion, has a post liked or marked as a best reply, or increases their reputation level, a notification is posted to the feeds and displays for users who are following that user on their My Sites.

  • Managed Metadata service, service application, and database Optional but recommended to enable hash tags and integration with feeds in the SharePoint environment.

  • Search service, service application, and databases Optional but recommended to enable users to search communities and discussions, and to populate the Community Portal.

Permissions

Community Sites rely on the SharePoint permissions infrastructure to help secure the community contents and enable participation by granting appropriate permissions to users. Depending on how you deploy the community, you can configure the site to be open to visitors and allow membership without approval, or you can configure more specific permissions that limit who can read discussions, join the community, and even discover the community at all.

The SharePoint groups shown in the following table provide permission to users for Community Site visibility, participation, and moderation.

Table: Default SharePoint groups and permissions for Community Sites

SharePoint group | Permission level | Description
Members | Contribute | Members can view, add, update, and delete lists and documents. Exceptions: Members can only read the Categories and Members list items, and the site pages
Moderators | Moderate | Moderators can view, add, update, delete, and moderate list items and documents.
Owners | Full Control | Owners have full control of the site.
Visitors | Read | Visitors can view pages and list items, and download documents.

The default groups and permission levels should be sufficient for most communities, but as with other SharePoint sites, you can create additional groups and configure unique permission levels to suit the needs of your community.

When you create your site collection and select the Community Site template, you must specify a primary owner, and optionally a secondary owner. These users belong to the Owners group for the Community Site and have permission to add users to groups. As part of your governance plan, work with the owners to understand the groups and permission levels for the site.

For more information about how to plan for user permissions on Community Sites, see Plan for communities in SharePoint Server 2013.

Membership

Community membership is maintained in a list within the Community Site, which means that the membership and reputation of a member are specific to only that site. Depending on how you want users to join the community, you can either allow anyone to join without approval, or you can require users to request access to the community and provide an email address for a user or group who can approve the request. If you require access requests to join the community, you must have outgoing email enabled for the SharePoint farm so that the requests can be sent. For more information, see Plan for communities in SharePoint Server 2013 and Plan outgoing email for a SharePoint farm in SharePoint 2013.

See also

What's new in social computing in SharePoint Server 2013
Plan for communities in SharePoint Server 2013
Social computing terminology and concepts in SharePoint Server 2013


Plan for communities in SharePoint Server 2013
See also

Summary: Learn about planning for Community Sites and Community Portals in SharePoint Server 2013.

Applies to: SharePoint Server 2013

In SharePoint Server 2013, Community Sites provide a forum experience in the SharePoint environment. This experience enables community members to contribute information and to ask for help from other members. Community Portals provide a directory of Community Sites for users to search for and discover communities of interest.

Communities are groups of people who collaborate around common goals to share and access information. Community Sites provide a computing solution for users to collaborate around questions, problems, interests, suggestions, opinions, and so on. Through feedback, in the form of replies, members gain access to valuable information from which they can further narrow the most useful responses via the number of members who like a reply and which reply is marked as the best reply. These actions provide incentives for members of the community to participate and build a reputation within the community. Over time, users who have provided the most positive contributions to the community become top contributors and earn trust from other members.

Use this article to develop a plan for implementing communities in SharePoint Server 2013. Before you use this article to plan for communities, make sure that you understand the terms, concepts, and benefits in Social computing terminology and concepts in SharePoint Server 2013 and Overview of communities in SharePoint Server 2013.

In this article:

  • Introduction

  • Phase 1: Identify project stakeholders and responsibilities

  • Phase 2: Determine business needs and evaluate collaboration solutions

  • Phase 3: Plan the solution

  • Phase 4: Define site ownership and moderation roles

Introduction

Communities are part of the social computing offering in SharePoint Server 2013. They provide a means for fostering collaboration among large groups of employees in an enterprise. By using communities, employees have an outlet to collaborate outside traditional hierarchies while keeping valuable corporate and intellectual property within the company.

Community planning is most successful when business users sponsor the effort by aligning communities with corporate goals and working with the IT staff to develop and implement the strategy through technology. This is especially important for corporate initiatives instead of informal grassroots initiatives led by employees. If you are part of the IT staff interested in implementing a Community Portal and Community Sites, make sure that you have appropriate business leaders and users involved in defining the business needs early on so that the effort has a purpose suitable for a community solution.

This article is organized in ordered phases for planning Community Sites and portals. Although each phase is discussed independently, in practice some phases might overlap.

Phase 1: Identify project stakeholders and responsibilities

Identify stakeholders who will work together to identify business needs, develop requirements, evaluate possible solutions, determine a schedule, and approve plans for a collaboration initiative. Business leaders and users should lead collaboration initiatives with input from the IT staff on the available technology options. Make sure that you have a balance of people high enough in the organization to provide approval and funding for the project, in addition to people who are closest to the daily work to help identify the challenges and define the requirements that the solution should address. Without these key people involved, you might implement a solution that does not have the necessary budget and resources allocated, has poor user adoption because it does not meet user needs, and so on.

Phase 2: Determine business needs and evaluate collaboration solutions

Although communities offer a valuable collaboration experience, you should first identify your business needs and then evaluate the possible collaboration solutions in SharePoint Server 2013. Begin with organizational goals and use these to develop a plan for community deployment and phases at which to deploy them. If you are new to communities, start with a business need that is fairly low-risk and has a group of users who want to collaborate. Then add other communities in over time. Use this as guidance to define the number of communities needed and which should be open, closed, or private. Always make sure that you lead with the business need and verify that a community is the right solution for that need.

Evaluate the options available for collaboration and determine whether a Community Site is an appropriate solution for business needs. Consider the following information when you evaluate social computing options in SharePoint Server:

  • Communities Communities are well suited for mass collaboration initiatives, where a large group of users participate in sharing knowledge and learning from other people across organizational and hierarchical boundaries. They are a persistent form of knowledge collection and storage.

  • Team sites Team sites are well suited for distinct groups of users to collaborate and store information that is common to the team, such as documents and calendars. They are generally used within organizational hierarchies, and generally have more permanence than project sites.

  • Project sites Project sites are well suited for distinct groups of users who are working together on a specific project, although these users might span organizational hierarchies. They generally exist only for the life of a project, and might be discarded or archived when the project is completed.

  • My Sites My Sites are well suited for individual users to promote their profile information, save and share personal documents, build networks of people, follow content and sites of interest, keep up-to-date via relevant information in feeds, and participate in microblogging activities. Some parts of the My Site are more lasting than others, such as document storage and profiles, whereas other parts are briefer, such as items in feeds.

Phase 3: Plan the solution

Planning the solution architecture involves identifying answers for the following:

  • What type of community do you want?

  • What is the primary language for the community?

  • Where does the Community Site logically belong in the current or planned SharePoint environment?

  • What services and service applications do you have or need that support community features and functionality?

Usage options

Make sure that a Community Site is an appropriate solution for your business needs. In some cases, it might be easier for users to add a discussion list or activate the new community features on an existing site, such as a team site. However, when you want users to specifically use a site to discuss and share knowledge around communities of practice and interests, create a Community Site. Additionally, only sites that use the Community Site template display in the Community Portal if you deploy one.

Figure: Ways to use discussions and communities

Usage options for communities

Community types

Depending on the permissions that you or the site owner configure for the Community Site, you can make the site more or less discoverable to users in the enterprise, and determine how to handle membership approval. If you have a community with sensitive information or that you want to limit to specific users or groups, consider configuring permissions for a private community. Conversely, if you want the community to be discoverable and allow all users to contribute, consider configuring permissions for an open community. The following table describes how to achieve configuration of these different types of communities.

Table: Configure permissions for different types of communities

Type | Permission | Approval setting
Private community. Available to only specified members. | Share the site with only specific users or groups, and grant Member permissions to them so they can contribute. | Not applicable.
Closed community. Everyone can view the content of the site, but only members who have approved requests for membership can contribute. | Share the site with Everyone and grant Visitor permissions to them so that they can view the site and request access. | Enable access requests on the site.
Open community with explicit membership. Everyone can view the site and can automatically join to contribute to the site. | Share the site with Everyone and grant Visitor permissions so they can view the site and automatically join as members. | Enable auto-approval on the site.
Open community. Everyone can contribute to the community. | Share the site with Everyone and grant Member permissions so they can all contribute. | Not applicable.

Language

Community Sites are generally used with a single language because user-generated content, such as the text in discussions, is not translated. Users are not prevented from posting to discussions in other languages, although it is up to the members of the Community Site whether they can understand and respond to the discussion. However, as with other SharePoint sites, Community Sites can use the multilingual user interface to display the user interface elements in another language specified by users.

Logical architecture

Based on the identified business needs, determine where the community logically belongs in your SharePoint environment. For example, if the business need is to enable large-scale participation among employees across the company or a region, the community might logically belong with the company portal or another similar high-level area in the SharePoint environment. However, if the goal is to enable participation among a smaller group of employees, such as a division or business unit, the community might logically belong with a divisional portal or similar level in the SharePoint environment. Or you might have a farm specifically for content or collaboration sites where you decide all of your Community Sites belong.

In order for community activities to display in the My Sites newsfeed, the web application that contains the My Site Host and personal sites cannot run under a different account than the web application that hosts Community Sites. Community Sites need not be located in the same farm as My Sites and the User Profile Service, but the web applications that host each must be using the same account in order for newsfeed integration to work.

Community Sites have similar deployment considerations and topologies as team sites, although the read/write characteristics for the underlying content database might be more intensive than with team sites depending on how active the community is. When planning for capacity and performance, consider how many members there are, and how frequently members generate and interact with discussions in the Community Site.

The Community Portal is available only at the site-collection level. However, Community Sites are available at the site collection and site level. If you create Community Sites at the site level, you can choose to inherit permissions from the parent site or to use unique permissions. Generally, you should use unique permissions to manage communities to keep the membership of each community separate. However, you might choose to inherit permissions if you have a hierarchy of Community Sites that you want to have the same membership.

If possible, we recommend that you locate your enterprise Community Sites in the same site collection or at least in site collections that share the same purpose. This enables you to tune settings, and easily move, backup, and restore the underlying database as needed without affecting the other site collections and sites in your environment. For more information about site collections and sites, see Plan sites and site collections in SharePoint 2013.

Services and service applications

There are several SharePoint services and service applications that improve Community Site functionality in SharePoint Server 2013. Depending on your identified business needs, these might be required for your implementation even though they are not truly required for Community Sites. Review the information in the following table to determine whether you already have these services in your topology or have to plan and implement them.

Table: Related services and service applications for communities

Service Reason

User Profile service

Consider using the User Profile service to integrate communities with My Sites. The User Profile service and service application store information about users, such as profile pictures, organizational details, and activities. This is a required service for My Sites and it is one of the key services for the social computing experience in SharePoint Server 2013.

Community Sites benefit from feed integration and a Community Portal when you implement them with the User profile service and the My Site Host site template. When community members mention other members or use hash tags in their discussion posts and replies, SharePoint Server updates users' feeds with these activities. On users' My Sites, users who follow those mentioned people or hash tags see these activities in their feed. This can help users discover communities of interest, other people to follow, and information about things they are interested in. Additionally, members can click mentioned members to navigate to a member's profile on their My Site.

When implemented in the same environment as My Sites, users can access the Community Portal from the Sites page on their My Sites. Additionally, when a member joins a community, starts a discussion, has a post liked or marked as a best reply, or increases the reputation level, a notification is posted to the feeds and is displayed for users who are following that user on their My Sites.

Managed metadata

Consider using the Managed metadata service to enable hash tags in Community Sites. When members include hash tags in discussion posts and replies, they can select tags from the term store from the Managed metadata service. Additionally, when a term does not already exist in the term store, members can create new tags and add them to the term store. This helps to seed the Community Site with the corporate taxonomy for tagging and enable growth of the term store through member contributions.

Search service

SharePoint Search is an important part of the SharePoint user experience, including the experience with Community Sites and Community Portals. Search enables users to search within discussions and find information in a Community Site. It also populates the search-driven Community Portal page with sites that use the Community Site template. Search performs the security trimming for the results that display both in community searches and the communities that appear on the Community Portal.

The Community Portal is a page that users can browse and search to discover communities of interest. This portal provides integration between users' My Sites and Community Sites. The My Site contains a link to the Community Portal so that users can easily navigate to the portal.

Phase 4: Define site ownership and moderation roles

Determine which users to assign as site owners and moderators. Work with them to understand and configure permissions appropriately for the community based on business needs.

Moderators are a specific SharePoint group who play an important role in keeping the community active and healthy. They have permission to manage categories and discussions, actively edit posts or delete them, mark posts as featured items or best replies, monitor flagged content, and configure reputation settings. As a best practice, have the site owners and moderators configure reasonable reputation settings before members start to use the community, and refrain from changing them later unless needed. If you change reputation settings after members have joined and participate in the community, SharePoint Server does not recalculate the existing reputation of members, although reputation for existing members going forward will be calculated with the new settings. Any members who join after the reputation settings are changed will have their reputation calculated accurately based on the new settings.

Depending on the size of the community, you might want to designate specific members to be category owners. Although there is no specific permission for category owners, you can either decide to make category owners part of the Moderators group or have moderators set up alerts for specific users who are tasked with monitoring specific categories. If category owners are made moderators, they can set alerts for themselves to monitor items in their categories and respond appropriately.

Determine the rules of participation and consequences when rules are broken. Most communities are fairly self-governing, but the moderator role should have clear guidelines from the business about how to handle issues and guidance from the IT staff on how to implement those consequences in the technology itself.

Additionally, encourage site owners and moderators to use the manage discussion view to monitor the community by exporting the discussion list to Excel. This way, they can easily determine how many posts are unanswered, have replies, and so on. This data can help moderators and site owners to address issues in the community if it is necessary, and understand where they should intervene, such as encouraging participation and moving discussions to more appropriate categories. Just as with other SharePoint lists, moderators and site owners can edit or create a specific view of the discussion list to make sure that the data that they need for review is included during export.

See also

What's new in social computing in SharePoint Server 2013
Overview of communities in SharePoint Server 2013
Create and configure communities in SharePoint Server 2013


Overview of microblog features, feeds, and the Distributed Cache service in SharePoint Server 2013
See also

Summary: Learn about microblog features, newsfeed, and the Distributed Cache service in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Microblogs allow users to quickly broadcast information to a central location while enabling other users to create a public dialog by responding with comments. Important information and news can be shared quickly among peers while keeping conversations in context.

Note:

Before reading this article, you should understand the definitions and concepts in Social computing terminology and concepts in SharePoint Server 2013.

Microblog features are included in SharePoint Server 2013. On a microblog, users can post a message that they want to publicize and create a public dialog about. Users can include text, URLs, pictures, and videos. HTML tags are not accepted. The maximum length of a post is 512 characters. After a message is posted, it is immediately seen in the newsfeed. Other users can see this post and reply to the original message. The maximum number of replies that can be associated with a post is 100 replies.

Users can include tags in the body of the message to highlight interest in the thread to others following that tag. Users can also mention (@Mention) a particular user to get the attention of that user from the post or reply they are submitting. For example, if a particular user is a subject matter expert in a particular area, users might @Mention the user to get that user's attention and maybe a response to the current conversation. Users can like a post or reply in the newsfeed as a way of giving public validation that a post or reply was useful to them. By liking an item, a user can easily reference that item from the Likes newsfeed. Users can also follow people, sites, tags, or documents that they are interested in. When following an entity, updates and new information about that entity will be displayed in the user's newsfeed.

In this article:

  • Architecture of the microblog features, feeds, and the Distributed Cache

  • Benefits of using the microblog features, feeds, and the Distributed Cache

Architecture of the microblog features, feeds, and the Distributed Cache

The following diagram shows the architecture of the microblog features, feeds, and the Distributed Cache.

Note:

To access any microblog feature or the feeds, the user must have a user profile and a My Site in SharePoint Server 2013. Anonymous posting is not supported in any microblog feature in SharePoint Server 2013.

Figure: Architecture of microblog features, feeds, and the Distributed Cache

Architecture of microblog and dependencies

Activities are posts and replies that can be either user-generated or system-generated. There are several types of activities in SharePoint Server 2013. These include the following:

  • Microblog activities This includes posts, replies, likes, mentions, or tagging an item.

  • Following activities This includes when a user follows people, documents, sites, or tags.

  • User profile activities This includes birthday, job title change, anniversary, updates made to Ask Me About, creating a new blog post, or posting on a Community Site.

  • Document activities This includes when a document is edited or a document is shared.

In SharePoint Server 2013, the newsfeed (or just simply the feed) displays activity information to users. Users access the feeds from a user's My Site. In SharePoint Server 2013, a user's My Site has several feeds available from which to choose. These different feeds show different views of activity information by filtering or pivoting on activity metadata. The different feeds available to users from their My Sites include the following:

  • Newsfeed This is the default view when visiting a user's My Site. The Newsfeed contains recent activities from followed entities. The Newsfeed displays 20 items and is sorted in reverse chronological order. Items listed in the Newsfeed are activities from entities a user follows, and conversations from any site feeds the user follows. Site feeds are explained later in this article.

  • Everyone The Everyone feed shows the last 20 posts or replies across all users. The distinction between the Everyone feed and the Newsfeed is that the Newsfeed only shows activities from entities the user is following.

  • Activities The Activities feed shows all activities associated with a user, including system-generated activities. The Activities feed represents the most accurate view of a user's activities because it shows all activities and not just recent activities, which occurs with the Newsfeed. This feed is also seen when users browse to their profile or About Me page for a user.

  • Mentions The Mentions feed for a user displays all posts or replies where that user was mentioned.

  • Likes The Likes feed displays a list of posts or replies that the user has liked. This is not related to the I Like It feature from SharePoint Server 2010.

Note:

When a user stops following an entity, the entity is removed from the user's followed entities list. The user will no longer see activities from that entity in their Newsfeed.

Site feeds Activities are publicly accessible unless the activity refers to content that the user does not have access to. If feed functionality is required for a restricted group of users, a site feed should be used. Site feeds display posts and replies among the users of the group. Site feed posts and replies display in the Newsfeed of a user only if the user has access to the site feed. Site feeds do not display system-generated activities. By default, the site feed feature on a team site is enabled. When you assign permissions to a team site that hosts a site feed, consider the following:

  • Access to the site feed is restricted to the users specified in the permissions list.

  • Users can post or reply only if they have the appropriate permissions.

  • Security trimming is enforced. This means that no site feed activities will appear in the search results of a user who doesn't have access to the team site.

  • Site feed activities appear in a user's Newsfeed if the user has access to the team site.

As shown in the earlier figure, when an activity is generated in SharePoint Server 2013, the following occurs (the numbers in the list correspond to numbers in the figure):

  1. Some activities are saved to the content databases. If the activity is a user activity or site activity, the activity is saved to the My Sites content database. If the activity is a site feed activity, the activity is saved in the team sites content database. Tags and document activities are not saved to content databases.

  2. Activities are written to the Distributed Cache. The Distributed Cache is described later in this article.

  3. Updates appear in the feed. Users receive visual indicators to notify them of new updates. When a user refreshes the browser, updates are shown to the user.

Note:

There are no dedicated databases that directly support the microblog features and feeds. Microblog features and feeds use the My Sites and team sites content databases only. Activities written to the My Sites content databases are never deleted. This should be planned for when you plan a My Sites deployment.

Distributed Cache service The Distributed Cache service provides caching features in SharePoint Server 2013. The microblog features and feeds rely on the Distributed Cache to store data for very fast retrieval across all entities. The Distributed Cache service is built on Windows Server AppFabric, which implements the AppFabric Caching service. Windows Server AppFabric installs with the prerequisites for SharePoint Server 2013.

Any server in the farm running the Distributed Cache service is known as a cache host. A cache cluster is the group of all cache hosts in a SharePoint Server 2013 farm. A cache host joins a cache cluster when a new application server running the Distributed Cache service is added to the farm. When using a cache cluster, the Distributed Cache spans all application servers and creates one cache in the server farm. The total cache size is the sum of the memory allocated to the Distributed Cache service on each of the cache hosts.

The Distributed Cache service can run in dedicated or collocated mode. When running in dedicated mode, the Distributed Cache service is started and all other services are stopped on the server. In collocated mode, the Distributed Cache service is running along with other services on the server.

Note:

We recommend that in collocated mode, all non-essential services be shut down to reduce the competition for memory resources.

In SharePoint Server 2013, there are several caches that exist, all of which depend on the Distributed Cache service. The following table lists these caches.

Table: Different caches that depend on the Distributed Cache service

Name | Cache name | Description
Login Token Cache | DistributedLogonTokenCache | This cache stores the security token issued by a Secure Token Service for use by any web server in the server farm. Any web server that receives a request for resources can access the security token from the cache, authenticate the user, and provide access to the resources requested.
Feed Cache | DistributedActivityFeedCache | This cache stores activities and conversations for use by the feeds on a user's My Site.
Last Modified Time Cache | DistributedActivityFeedLMTCache | This cache stores time stamp information for all Feed Cache entities
OneNote Throttling | DistributedBouncerCache |
Access Cache | DistributedAccessCache |
Search Query Web Part | DistributedSearchCache |
Security Trimming Cache | DistributedSecurityTrimmingCache |
App Token Cache | DistributedServerToAppServerAccessTokenCache |
View State Cache | DistributedViewStateCache |
Default Cache | DistributedDefaultCache | This cache can be used by any feature.

The microblog features and feeds rely on the following two caches: the Last Modified Time Cache and the Feed Cache.

  • Feed Cache The Feed Cache stores recent activities and recent conversations for all entities

  • Last Modified Time Cache The Last Modified Time Cache is used to determine the last modified time for all items in the Feed Cache.

As shown in the earlier figure, when constructing feeds, such as the Newsfeed or the Everyone feed, the following occurs (the letters in the list correspond to the letters in the figure):

A. The feed queries the Last Modified Time Cache to retrieve time stamp information and metadata of recent activities.

B. This information is then used as input to query the Feed Cache to retrieve activity data.

C. The requested feed is then constructed by using the activity data retrieved from the Feed Cache.

For each entity, the Feed Cache assigns a portion of memory known as a cache bucket to store recent activity data for that entity. Entities include users, tags, sites, and documents. Cache buckets only store recent activities. Many cache buckets will be empty because not all entities will have recent activities. By default, recent activities are kept for seven days.

Important:

The Last Modified Time Cache only lives on one cache host in the cache cluster. Also, the Feed Cache stores recent information about all entities. It is important that proper capacity planning be conducted for the cache hosts. For more information, see Plan for feeds and the Distributed Cache service in SharePoint Server 2013.

System events, such as a power failure or unexpected restart of a server, affect the Distributed Cache service. Also, a planned activity, such as an administrator shutting down an application server that is running the Distributed Cache service to perform operational tasks, affects the Distributed Cache service. These actions reset and empty the Feed Cache and the Last Modified Time Cache. In this situation, repopulation of recent activities is required. Repopulation involves reloading saved data from the content databases into the Last Modified Time Cache. After the Last Modified Time Cache is reloaded, the next user to visit their My Site starts the repopulation of data in the Feed Cache. For more information, see Manage Feed Cache and Last Modified Time Cache repopulation in SharePoint Server 2013.

Benefits of using the microblog features, feeds, and the Distributed Cache

Some benefits of using microblog features, feeds, and the Distributed Cache include the following:

  • Allows users to stay in touch with individuals and specific groups of people over time and distance.

  • Allows users to stay informed about what's going in the organization.

  • The focus of the interactions is around people or teams, and not so much the topic being discussed.

  • It is difficult to keep track of activities related to documents, discussions, and lists in SharePoint without manually visiting the item regularly. Feeds collect and deliver information to users that they would otherwise have to spend time searching for.

  • The feed gives users a single place where they can stay up-to-date with all of the content and people they work with.

  • Allows quick conversations to take place.

See also

Plan for feeds and the Distributed Cache service in SharePoint Server 2013
Plan for My Sites in SharePoint Server 2013


Plan for feeds and the Distributed Cache service in SharePoint Server 2013

Updated: February 19, 2013

Summary: Learn how to plan to implement microblog features, the Newsfeed, and the Distributed Cache service in SharePoint Server 2013.

Applies to: SharePoint Server 2013

In SharePoint Server 2013, microblog functionality enables users to have short, public conversations about topics they are interested in. The Newsfeed and the Distributed Cache service support this microblog functionality in SharePoint Server 2013. Before you read this article, you should understand the concepts described in Overview of microblog features, feeds, and the Distributed Cache service in SharePoint Server 2013 and Social computing terminology and concepts in SharePoint Server 2013.

In this article:

  • Plan for the feeds

  • Plan for the Distributed Cache service

Plan for the feeds

Site feeds

Site feeds provide newsfeed functionality to a specific group of users. Site feeds are available on team sites. When planning to use site feeds on your team sites in SharePoint Server 2013, the team sites must consume the same User Profile Service application as My Sites. Team Sites and My Sites can be located on the same or different farms, but must use the same User Profile service application. If you have team sites on a different farm from the My Site Host, server-to-server authentication between the two farms is required. In SharePoint Server 2013, we recommend that the same service account be used for both the My Site host web application and the web application hosting the team sites. Additionally, the My Site host site collection must be a SharePoint Server 2013 My Site host, and the user must have a SharePoint Server 2013 My Site to use the site feed feature. Consider enabling Self Service Site Creation on the web application that contains the team sites so that users can easily create team sites from their My Site. In a SharePoint Server 2013 deployment where users only use About Me pages (the administrator has configured the rest of the My Site features to be unavailable), site feeds are still available to users.

When an administrator upgrades team sites from SharePoint Server 2010, they must activate site feeds on the upgraded team site by first enabling the Following Content feature on the team site, and then enabling the Site Feeds feature on the team site. Following entities and seeing posts from Site Feeds are then available to the user.

Note:

If users start following the site before the administrator enables the Site Feeds feature, the upgraded team site will not appear in the Share With menu. When the administrator enables the Site Feeds feature, the user must Stop Following the site, and Follow the site again. The site will now appear in the Share With menu.

My Sites planning

A user can include an image in microblog posts. When posts include an image, SharePoint Server 2013 uploads that image to a private folder on the user's My Site. This image is automatically reduced in file size and dimensions to optimize how much space is consumed by the image on the user's My Site. When assigning quotas for My Sites, an administrator should plan for this additional image storage requirement. If the user does not have available storage on their My Site and the user is attempting to post a message that has an image, an error is displayed to the user.

Notifications

Notifications are system-generated email messages that notify the user of an activity that occurs in a thread they contributed to, or that someone has started following them. Notifications require the configuration of outgoing email settings in SharePoint Server 2013 as a prerequisite. For more information, see Configure outgoing email for a SharePoint 2013 farm.

Upgrade

When upgrading from SharePoint Server 2010 to SharePoint Server 2013, the newsfeeds from SharePoint Server 2010 are upgraded as a legacy feature in SharePoint Server 2013. This means that the SharePoint Server 2010 newsfeed is being deprecated, but is still available from within SharePoint Server 2013. An administrator must perform special configuration steps to allow users access to the upgraded SharePoint Server 2010 newsfeed. Any data that is stored in the SharePoint Server 2010 newsfeed is available in SharePoint Server 2013. However, an administrator cannot migrate data from the SharePoint Server 2010 newsfeed to the SharePoint Server 2013 newsfeed because the feeds differ significantly.

Outlook Social Connector

The Outlook Social Connector displays feed information in Outlook alongside Outlook messages, meetings, and so on. The Outlook Social Connector increases system load on a SharePoint Server 2013 server farm. This is because the Outlook Social Connector frequently accesses My Sites features and pushes the information into Outlook. This affects the performance of the SharePoint Server 2013 farm and should be considered when designing the server farm.

Search and security trimming

The Everyone view and Following view contain public conversations (posts and replies), which all users can access. When public conversations are added to the search index in SharePoint Server 2013, users can search for and view search results that include these public conversations. Security trimming does not apply to public conversations because there are no permissions assigned to the conversation. If users require security trimming to be applied to specific conversations, use site feeds on team sites. On the team site, assign permissions to the group of users who can participate in the conversation. The search results are then security trimmed based on the assigned permissions.

Consider how you configure the incremental crawl schedule of the indexer because this affects how quickly conversations appear in the search results of users. If users actively use the microblog features to make posts and replies, they might expect to see conversations appear in the search results quicker. In this case, consider shorter intervals between updates.

Plan for the Distributed Cache service

When you plan to implement the Distributed Cache service, consider that the Distributed Cache service can be deployed in two modes: dedicated mode or collocated mode. In dedicated mode, all services other than the Distributed Cache service are stopped on the application server that runs the Distributed Cache service. In collocated mode, the Distributed Cache service runs together with other services on the application server. Dedicated mode is the recommended mode in which to deploy the Distributed Cache service.

Important:

If you are using custom applications in SharePoint Server 2013 which use the AppFabric client APIs, or are creating custom caches, you should create a separate AppFabric cache cluster to support your custom applications. Do not use the AppFabric cache cluster supporting your SharePoint Server 2013 farm. Run your separate AppFabric cache cluster for your custom applications on separate servers from the servers dedicated to your SharePoint Server 2013 farm.

Install the Windows Server AppFabric prerequisite

When the SharePoint Server 2013 prerequisite installer runs, it installs Windows Server AppFabric. This is the recommended approach for installing Windows Server AppFabric on a server that is running SharePoint Server 2013. If you already have Windows Server AppFabric installed on the server before you run the prerequisite installer, you must uninstall Windows Server AppFabric before you run the prerequisite installer. If an administrator decides to install Windows Server AppFabric manually, the administrator must install the CacheAdmin, CachingService, and CacheClient features, and use the /gac switch. For more information see Automated Installation (AppFabric 1.1 Caching) in the MSDN Library.

Capacity planning for the Distributed Cache service

This section of the document helps administrators plan the architecture and memory requirements for servers hosting the Distributed Cache service. The Distributed Cache service stores data in-memory only and does not have a dependency on databases in SharePoint Server 2013. Additionally, some services in SharePoint Server 2013 require significant memory resources which may affect the performance of the Distributed Cache service. The performance of the Distributed Cache service is significantly affected by both the choice of architecture and memory allocation for the Distributed Cache service.

The following table lists different memory and architecture recommendations for the Distributed Cache service, depending on the total number of users.

Deployment size | Small farm | Medium farm | Large farm
Total number of users | < 10,000 | < 100,000 | < 500,000
Recommended cache size for the Distributed Cache service | 1 GB | 2.5 GB | 12 GB
Total memory allocation for the Distributed Cache service (double the recommended cache size above) | 2 GB | 5 GB | 24 GB
Recommended architectural configuration | Dedicated server or co-located on a front-end server | Dedicated server | Dedicated server
Minimum cache hosts per farm | 1 | 1 | 1

Note:

In a SharePoint Server 2013 farm, there must be at least one cache host running the Distributed Cache service.

Memory allocation

Note:

You should understand the Distributed Cache concepts discussed in Overview of microblog features, feeds, and the Distributed Cache service in SharePoint Server 2013 before you read this section of the article.

The Distributed Cache service's memory allocation for the cache size is set to a default value of 10 percent of total physical memory when SharePoint Server 2013 installs. An administrator can change the memory allocation for the Distributed Cache service by using the Update-SPDistributedCacheSize cmdlet. The Distributed Cache service can be assigned a maximum of 16GB of memory per cache host in the cache cluster. We recommend that you reserve 2 GB of memory for other services that are running on the server, and assign the remaining memory to the Distributed Cache service. For more information, see Manage the Distributed Cache service in SharePoint Server 2013.

Important:

On a server that has more than 16 GB of total physical memory, allocate a maximum of 16 GB of memory to the Distributed Cache service. If you allocate more than 16 GB of memory to the Distributed Cache service, the server might unexpectedly stop responding for more than 10 seconds.

If you require more memory, you can configure the Distributed Cache service to run on several application servers. In this case, the cache spans all the servers that are running the Distributed Cache service, and acts as one cache that supports the entire farm. To add another application server, join the new application server to the server farm by using the SharePoint Configuration Wizard. You should decide whether the new application server should run in dedicated or collocated mode. You must ensure that the memory allocation assigned to the Distributed Cache service is the same on all servers that are running the Distributed Cache service. Cached data is stored on one server, not both servers. For more information, see Manage the Distributed Cache service in SharePoint Server 2013.

When the Distributed Cache service runs in collocated mode, the physical memory of the server should be increased and all non-essential services stopped. We do not recommend that any of the following services or applications run on the same server as the Distributed Cache service:

  • SQL Server 2008 or SQL Server 2012

  • Search service

  • Excel Services in SharePoint

  • Project Server services

When planning for developer workstations, the developer's workstation should have a minimum of 32 GB of total physical memory. On developer workstations, SharePoint Server 2013 is installed as a single server deployment. This means that the Distributed Cache service is deployed in collocated mode. In collocated mode, there will be competition for memory resources. To manage memory resource allocation, a developer can shut down any services that are not used, or they can periodically restart SQL Server.

Important:

The Distributed Cache service can run on either a physical or virtual server. When using virtualization, do not use Dynamic Memory to manage shared memory resources among other virtual machines and the Distributed Cache servers. The memory allocation for virtualized Distributed Cache servers must be fixed.

Distributed Cache service configuration sequence

Starting and stopping the Distributed Cache service in an unplanned manner results in the Distributed Cache service becoming unstable. When performing the initial configuration of a SharePoint Server 2013 farm, perform the following steps in the following order:

  • Run the Configuration Wizard to join all servers to the server farm. The Distributed Cache service is started on all web servers and application servers in the server farm.

  • Perform other farm configuration steps as necessary.

  • When ready to configure the Distributed Cache service, confirm that the Distributed Cache service is running on all servers in the server farm. Then proceed to stop the Distributed Cache service on any server that is not intended to be part of the cache cluster. Avoid stopping and restarting the Distributed Cache service on a server. If the Distributed Cache service was accidentally stopped on a server and a restart of the Distributed Cache service is now required, refer to the guidance in Manage the Distributed Cache service in SharePoint Server 2013.

Important:

If you stop the Distributed Cache service on all servers that are running the Distributed Cache service, do not restart the Distributed Cache service on only one server. Instead, restart the Distributed Cache service on all Distributed Cache servers at the same time. While the Distributed Cache service is restarting, initial performance is affected for a short time.

As an alternative to the previous method, an administrator can install SharePoint Server 2013 without registering the Distributed Cache service on servers not intended to be part of the cache cluster. This can be achieved by using the skipRegisterAsDistributedCachehost parameter with the New-SPConfigurationDatabase or the Connect-SPConfigurationDatabaseWindows PowerShell cmdlets, or when running psconfig.exe at the command line. This parameter is optional.

Firewall configuration considerations

The Distributed Cache service uses the following communication ports:

  • 22233

  • 22234

  • 22235

  • 22236

Note:

If you are using more than one cache host in your server farm, you must configure the first cache host running the Distributed Cache service to allow Inbound ICMP (ICMPv4) traffic through the firewall. For more information, see Create an Inbound ICMP Rule on Windows 7, Windows Vista, Windows Server 2008, or Windows Server 2008 R2. If an administrator removes the first cache host from the cluster which was configured to allow Inbound ICMP (ICMPv4) traffic through the firewall, you must configure the first server of the new cluster to allow Inbound ICMP (ICMPv4) traffic through the firewall.

Change History

Date | Description
February 19, 2013 | Added two new sections: "Capacity planning for the Distributed Cache service" and "Firewall configuration considerations."
July 16, 2012 | Initial publication


Overview of security trimming, administrative policies, and privacy settings for social feeds in SharePoint Server 2013
See also

Published: March 26, 2013

Summary: Learn about how security trimming, administrative policies, and user privacy settings affect feeds in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

In SharePoint Server 2013, users can interact with others and view information in social feeds, such as the newsfeed on their personal site (also known as a "My Site") or a site feed.

There are three factors that affect the information that users see when they load a feed:

Factors affecting displayed items in the newsfeed

  • Security trimming Search in SharePoint Server 2013 performs security trimming, which prevents users from seeing information that they do not have access to in the system. Security trimming is discussed further in this article.

  • Administrative policies SharePoint administrators can configure policies to customize the default values of user privacy settings and specify the settings that are available for users to configure. Administrators can configure these policies in the User Profile service application. For more information, see "Configure policies for privacy and people" in What's new in social computing in SharePoint Server 2013.

  • User privacy settings Users can configure their personal privacy settings based on the administrative policies set in the User Profile service application. These settings enable users to specify the information that they want to share with others. Users can configure these settings from their personal profile page. For more information, see Update your profile privacy settings on Office.com.

In this article:

  • How security trimming, administrative policies, and user privacy settings affect feeds

  • How cached items affect feeds

  • Security Trimming Cache settings on the User Profile Service application

How security trimming, administrative policies, and user privacy settings affect feeds

Security trimming is based on a user's access to a URL. When the system generates an activity related to a user's action, such as by following a site or by modifying a document, the activity includes the URL of the related item. Only system-generated activities are security trimmed; user-generated posts with URLs are not security trimmed. However, in either case SharePoint security ultimately determines whether a user has permission to access the item in a URL. This is no different from email, where someone can send a link to a document or site that recipients do not have access to.

SharePoint Server 2010 performed security trimming on user's activities, and used SharePoint search to determine a user's access to items that were posted in the Newsfeed, tagged with social tags, and rated. Whenever users accessed their SharePoint Server 2010 Newsfeed to view activities, the system would call search to return results about access and would display only items that the user had access to. For more information about security trimming in SharePoint Server 2010, see Privacy and security implications of social tagging (SharePoint Server 2010).

SharePoint Server 2013 continues to use search to perform security trimming. However, there is also a new cache, called the Security Trimming Cache, which now maintains information about user access to feed items based on search results. When users reload their feed, SharePoint Server uses cached results for a specified time. This reduces the number of requests made to search.

Note:

The Security Trimming Cache depends on the Distributed Cache service as a pre-requisite.

Each user has two lists in the user's My Site to organize feed items: the Microblog list and the Social list. The Microblog list is public, and it contains user-generated posts and reference posts to anything that the user comments on in another user's feed. The Social list is private, and it contains system-generated activities including followed items, documents, and sites. The security trimmer reads items in the Social list to determine which items a user has access to see so that those items can be displayed in the user's feed. even though search indexes both of these lists, it returns only the results that the requesting user has permission to see.

Administrative policies and user privacy settings also affect the items returned to a user's feed. However, instead of using security trimming to remove this information, posts are created only for information that either the administrator or user has selected to share. For example, if a policy or privacy setting specifies not to share a user's birthday, a post for that activity is never created in the first place. This differs from security trimming, where an activity exists in the user's Social list but displays only for users who have access to that information.

How cached items affect feeds

When users submit a request to load their feed, SharePoint Server calls search to perform security trimming on all URLs from posts in the user's private folder. However, to protect search from frequent, and often unnecessary requests for the same information, SharePoint Server caches the URLs a user can access in the Security Trimming Cache.

Cached results are affected by Time to Live (TTL) settings in the User Profile service application. These properties are available for configuration in PowerShell, and include the following:

  • SecTrimCacheMaxTTLMinutes This sets the long TTL for requests.

  • SecTrimCacheNonAuthoritativeAccessTTLMinutes This sets the medium TTL for requests.

  • SecTrimCacheThrottledTTLMinutes This sets the short TTL for requests.

The following diagram describes how search results are cached when users load their feed.

Figure: How search results are cached

Security trimming process with the cache

The first time that users submit a request to load their feed, SharePoint Server calls search for security trimming on any URLs to display in the feed. The security trimmer reviews the information in the user's private folder, and saves access results in the cache.

If the user is allowed access to a URL, search saves this in the cache by writing "Access," sets the Time to Live (TTL) to long, and then displays the item.

If search determines a user is denied access to a URL, search writes "Indeterminate Access" in the cache, sets the medium TTL, and does not display the content. There is a retry threshold that determines how many times a URL will be checked again to see whether a user has access. Once the retry threshold is reached, search writes "No Access" to the cache and sets the TTL to long. This process helps to make sure that users aren't prevented from seeing an item in their feed that they might actually have access to.

If the user's access is unable to be determined, such as if search is too busy to answer or results aren't yet indexed, search saves this by writing "Throttle" to the cache, sets the short TTL, and retries the call after the TTL duration expires. This continues until search can determine whether access is granted or denied to the URL.

Note:

If a user's permission to a URL changes from access granted to access denied within the long TTL cached period, the feed item will still appear in the user's feed. However, the user will be unable to open the URL because SharePoint security prevents users from accessing information that they do not have permission to. After the long TTL period expires, the security trimming process repeats and the cached item will be updated to access denied so the feed item no longer appears.

After the long TTL expires, the cached results are no longer considered valid, and the process starts again the next time that a user loads the feed.

Security Trimming Cache settings on the User Profile Service application

An administrator can use PowerShell to change some of the Security Trimming Cache properties on the User Profile service application. The following table lists the Security Trimming Cache properties that are available on the User Profile service application.

Table: Security Trimming Cache properties

Property | Description | Default value
SecTrimCacheMaxTTLMinutes | Long TTL. This is the maximum number of minutes to maintain an item in the cache. The default is 1440 minutes (24 hours). | 1440
SecTrimCacheNonAuthoritativeAccessTTLMinutes | Medium TTL. If access is unable to be determined, such as when search is too busy to respond, medium TTL is set and the call is retried after this period elapses until the retry threshold is reached. | 15
SecTrimCacheThrottledTTLMinutes | Short TTL. If access is denied to a URL, short TTL is set so that any changes to the URL permissions are caught if a user reloads the feed. | 5
SecTrimCacheMaxRetryCount | Retry count threshold. This is the maximum number of times that the cache can call search to ask about access before setting Access Denied and setting long TTL. | 5
SecTrimCacheMaxNumberOfDataItems | The maximum number of per-user items that can be cached. | 50
SecTrimCacheEnabled | Determines whether the cache is enabled or disabled. | True (1)
SecTrimMaxNumberOfSocialUrls | Determines the maximum number of URLs that can be security trimmed at one time. | 24

An administrator can use PowerShell cmdlets to update these parameters on the User Profile Service application. For example, to set the maximum cache TTL, use the following cmdlet to update the SecTrimCacheMaxTTLMinutes to 1440:

Copy code
$upa = Get-SPServiceApplication | where {$_.TypeName -Like "User Profile Service Application"}
$upa.SecTrimCacheMaxTTLMinutes = 1440
$upa.Update()

To update other cache settings, replace the SecTrimCacheMaxTTLMinutes parameter and value with the parameter that you want to change.

See also

Plan for social computing and collaboration in SharePoint Server 2013


Overview of SkyDrive Pro in SharePoint Server 2013
See also

Updated: July 23, 2013

Summary: Learn about SkyDrive Pro, its architecture, and the benefits of using SkyDrive Pro in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

This article helps administrators learn about SkyDrive Pro, the SkyDrive Pro architecture in SharePoint Server 2013, and the benefits of using SkyDrive Pro. Before you read this article, you should be familiar with My Sites. For more information, see My Sites in What's new in social computing in SharePoint Server 2013.

In this article:

  • Terminology and concepts for SkyDrive Pro

  • Architecture of SkyDrive Pro

  • Benefits of using SkyDrive Pro

Terminology and concepts for SkyDrive Pro

  • SkyDrive Pro A personal file storage and synchronization service for business use. Users store, access, and synchronize their files in SharePoint Online or SharePoint Server 2013 with their client workstation.

  • SkyDrive Pro document library A document library on the user's My Site in SharePoint Server 2013. Users access their SkyDrive Pro document library by clicking SkyDrive in SharePoint Server 2013.

  • SkyDrive A consumer-based file storage service available through your Microsoft account. For more information, see What is a Microsoft account?. SkyDrive has no relationship to SharePoint Server 2013. However, if you install Office 2013 and open Windows Explorer, you see a SkyDrive folder in the Favorites section. This folder synchronizes with the consumer-based file storage, not your SkyDrive Pro storage. Users may download the SkyDrive synchronization application to synchronize their SkyDrive (consumer-based file storage) with the SkyDrive folder in Windows Explorer, without installing Office 2013. For more information, see Download SkyDrive synchronization client.

  • Synchronization (also known as Sync) Process that involves copying, updating, and moving files between a client workstation and the server, or vice versa. In SkyDrive Pro, synchronization is performed by the SkyDrive Pro Windows Sync client, which is either installed with Office 2013, or is available as a stand-alone version, which may be used with earlier versions of Office (Office 2010, Office 2007, and so on).

The following table provides more information about SkyDrive Pro, the SkyDrive Pro document library, SkyDrive, and synchronization. Some of the information relates to later sections of this article.

Table: More about SkyDrive Pro, SkyDrive, and synchronization

SkyDrive Pro Synchronization (using the SkyDrive Pro Windows Sync client) SkyDrive Pro document library SkyDrive

How do I access it?

To use SkyDrive Pro Synchronization, the user must have:

  • SharePoint Server 2013 or SharePoint Online

  • Either Office 2013 or the stand-alone SkyDrive Pro Windows Sync client.

In SharePoint Server 2013, a user clicks the Sync button in a document library to start the synchronization of files between the document library and the client workstation. On the client workstation, when the SkyDrive Pro Windows Sync client runs, it is available from the notification area. The SkyDrive Pro Windows Sync client creates shortcuts in Windows Explorer in Favorites.

On a user's My Site in SharePoint Server 2013, or on a My Site in SharePoint Online

Go to the SkyDrive logon page.

Who uses this product?

Business users

Business users

Consumers or individuals

Is this a document library?

No, but the SkyDrive Pro Windows Sync client performs synchronization with document libraries.

Yes

Yes

Is this installed with Office 2013?

Yes, the SkyDrive Pro Windows Sync client is installed.

You may also download the stand-alone SkyDrive Pro Windows Sync client, which can be used with earlier versions of Office (Office 2010, Office 2007, and so on).

No, this is a document library on a user's My Site in SharePoint Server 2013.

Yes, the Microsoft SkyDrive client is installed, a shortcut named SkyDrive is created in Favorites in Windows Explorer, and an open and save location is created in the Backstage view in Office 2013.

Which folder used in Windows Explorer under Favorites?

SkyDrive Pro Windows Sync client synchronizes files in the following Windows folders:

  • SkyDrive @ Contoso, where Contoso is a SharePoint Online tenancy name

  • SkyDrive Pro

  • SharePoint

SkyDrive Pro folder

SkyDrive folder

Architecture of SkyDrive Pro

The SkyDrive Pro architecture includes several layers that span SharePoint Server 2013, Office 2013, and Windows Explorer. The following diagram shows the components that make up the SkyDrive Pro architecture.

Figure: SkyDrive Pro architecture

Diagram of the Sky Drive Pro architecture

SkyDrive Pro in SharePoint Server 2013 consists of two main components: Storage locations and the SkyDrive Pro Windows Sync client.

  • Storage locations Files are stored in storage locations. Storage locations include the following:

    • Document libraries. A user can choose to synchronize a document library with a client workstation. As shown in the diagram:

      • E is a user's SkyDrive Pro document library on the user's My Site. This is a special document library, and is discussed in the next section.

      • F is a document library on a team site.

    • Windows Folders. When a document library is synchronized with a client workstation, synchronized files are stored in specific Windows folders on the client workstation. As shown in the diagram:

      • A is a user's SkyDrive folder. When Office 2013 is installed, a SkyDrive folder is created in the Favorites section of Windows Explorer. Users can use this SkyDrive folder with their SkyDrive location on SkyDrive.

        Note:

        The SkyDrive folder is not associated with SharePoint Server 2013. SkyDrive Pro does not use the SkyDrive folder.

      • B is the SharePoint folder. Files in document libraries on team sites are synchronized with the SharePoint folder.

      • C is the SkyDrive @ Contoso folder. Files in document libraries on team sites in a SharePoint Online tenancy are synchronized with the SkyDrive @ Contoso folder.

        Note:

        Contoso is your SharePoint Online tenancy.

      • D is the SkyDrive Pro folder. Files in a user's SkyDrive Pro document library are synchronized with the SkyDrive Pro folder.

  • SkyDrive Pro Windows Sync client The SkyDrive Pro Windows Sync client synchronizes files between document libraries in SharePoint Server 2013 or SharePoint Online, and specific Windows folders on a client workstation.

    Note:

    The SkyDrive Pro Windows Sync client creates the specific Windows folders and shortcuts in Favorites in Windows Explorer when a user synchronizes a document library.

SkyDrive Pro document library

SharePoint Server 2013 creates the SkyDrive Pro document library in the personal site collection of a user's My Site when the user requests creation of the My Site. The SkyDrive Pro document library is a special document library built by using the standard document library template. Many of the features and processes applicable to a standard document library can be applied to the SkyDrive Pro document library.

Important:

Even though the SkyDrive Pro document library supports many of the features of a standard document library, a user should not customize the SkyDrive Pro document library because this might affect synchronization. For example, a user should not add or delete additional columns to the SkyDrive Pro document library. The default configuration of the SkyDrive Pro document library is optimized for synchronization.

SkyDrive Pro Windows Sync client

The SkyDrive Pro Windows Sync client enables users to take documents offline from document libraries in SharePoint Server 2013, and use them when they are disconnected from SharePoint Server 2013. Later, when the client workstation reconnects to SharePoint Server 2013, the files are synchronized. The SkyDrive Pro Windows Sync client synchronizes files with any document library in SharePoint Server 2013 including the SkyDrive Pro document library.

Note:

SkyDrive Pro Windows Sync client does not replace, or is not an updated version of, SharePoint Workspace 2010.

A user accesses the SkyDrive Pro Windows Sync client from the notification area in Windows. From the SkyDrive Pro Windows Sync client, a user can select Sync Now, Pause Syncing, Open your SkyDrive Pro folder, and so on. The SkyDrive Pro Windows Sync client establishes a synchronization relationship with the document library when the user clicks the Sync button in SharePoint Server 2013. When a synchronization relationship is set up, files and folders can be synchronized between the client workstation and the SharePoint Server. The SkyDrive Pro Windows Sync client creates shortcuts displayed in Windows Explorer to Windows folders (previously discussed in this article, and labeled B, C, or D in the earlier diagram) to store files from the synchronized document library. For more information about how to synchronize a document library, see Sync a library to your computer on Office.com.

Important:

The SkyDrive Pro Windows Sync client maintains a synchronization relationship between one SharePoint Server 2013 document library and one Windows folder that was created by the SkyDrive Pro Windows Sync client (B, C, or D in the earlier diagram). Files from an existing synchronization relationship cannot be synchronized with more than one document library or more than one Windows folder.

The SkyDrive Pro Windows Sync client automatically synchronizes with SharePoint Server 2013 every 10 minutes. When the SkyDrive Pro Windows Sync client makes the request to synchronize with SharePoint Server 2013, SharePoint Server 2013 might respond by indicating that it is experiencing high server resource utilization and cannot synchronize now. When this occurs, the SkyDrive Pro Windows Sync client cancels the current synchronization request, and resends a new synchronization request later.

Note:

The cancellation and retry is transparent to the user. No informational message or error message is shown to the user.

When synchronization occurs:

  • If the file type is a Word, Excel, or PowerPoint file, the SkyDrive Pro Windows Sync client performs a differential synchronization, which is a synchronization of only the changes that were made to the document between the last synchronization and the current synchronization.

  • For all other file types, the SkyDrive Pro Windows Sync client synchronizes the whole file, not just the changes that were made to the file from the last synchronization.

Backstage view

In Office 2013, the Backstage view provides file-level functionality in the Office applications. In Office 2013, a user can access the Backstage view by clicking File in the ribbon. In Office 2013, each client application can share information and actions via the Backstage view. Office applications (Word, Excel, PowerPoint, OneNote) use the Backstage view to access shared documents. The Office 2013 client applications use the Backstage view with SharePoint Server 2013 to open and save files to document libraries in SharePoint Server 2013. Once the SkyDrive Pro Windows Sync client synchronizes with a document library and the user opens or saves a file in the synchronized Windows folder, the document library is put into the Backstage view as an open and save location. Alternatively, if an administrator configures SharePoint Server 2013 to use Exchange Autodiscovery, the user's SkyDrive Pro document library will be listed as an open or save location.

Note:

The Backstage view is not, or does not use the synchronization features of, SkyDrive Pro.

Benefits of using SkyDrive Pro

Some benefits of using SkyDrive Pro include the following:

  • Users can take their documents offline with them and have them synchronize when they are online again.

  • Users' documents can be synchronized across all client devices and servers where the files are stored and synchronized.

  • Multiple users (online or offline) can work on documents at the same time, and the SkyDrive Pro Windows Sync client will synchronize the changes between the users. If there are conflicts, users are prompted to resolve the conflicts.

  • Users can share and collaborate on documents.

  • Users can work from many locations, either online or offline, and work from many devices.

See also

Configure social computing features in SharePoint Server 2013

Change History

Date | Description
July 23, 2013 | Updated to include information about the stand-alone SkyDrive Pro Windows Sync client.
March 26, 2013 | Initial publication


Plan for SkyDrive Pro in SharePoint Server 2013

Published: May 21, 2013

Summary: Learn about performance, security, and other considerations for implementing SkyDrive Pro in SharePoint Server 2013.

Applies to: SharePoint Server 2013

In SharePoint Server 2013, SkyDrive Pro functionality enables users to store and synchronize files between SharePoint Server 2013 and a client workstation. The SkyDrive Pro architecture includes storage locations (both document libraries in SharePoint Server 2013 and Windows folders on the client workstation), and the SkyDrive Pro Windows Sync client. This topic helps administrators plan their implementation of SkyDrive Pro by presenting what planning options are available, and important considerations when you are using or administering SkyDrive Pro. Before you read this topic, you should understand the concepts described in Overview of SkyDrive Pro in SharePoint Server 2013.

In this article:

  • Pre-requisites

  • SkyDrive Pro document library

  • SkyDrive Pro Windows Sync client

  • Security recommendations

  • Upgrading from SharePoint Server 2010 to SharePoint Server 2013

  • Important considerations to review before deploying and using SkyDrive Pro

Pre-requisites

The components that make up SkyDrive Pro (the SkyDrive Pro Windows Sync Client and document libraries in SharePoint Server 2013) have different pre-requisites. The following is a list of pre-requisites for SkyDrive Pro, organized by the different SkyDrive Pro components.

  • To support SkyDrive Pro document libraries in SharePoint Server 2013, you must have:

    • A SharePoint Server 2013My Site Host.

    • Configured the User Profile Service application.

    • The user must have an existing My Site with the personal site collection created.

  • To support synchronizing document libraries to a user's client workstation with the SkyDrive Pro Windows Sync client, you must have:

    • Either

      • Office 2013 Standard or Office 2013 Professional Plus, or the stand-alone SkyDrive Pro Windows Sync client.

      • An Office 365 subscription that includes the Office 2013 applications.

    • Client workstations running Windows 7 or Windows 8.

Depending on your usage scenarios, the following additional pre-requisites may apply to you:

  • To enable Office 2013 users to open documents from or save documents to their SkyDrive Pro document library on their My Site:

    • The user must have an existing My Site.

    • For Office 2013 to automatically locate the user's My Site, an administrator must configure SharePoint Server 2013 to use Exchange Autodiscover. For more information, see Configure Exchange Autodiscover with a My Site Host URL in SharePoint Server 2013.

  • To support system generated email notifications from SharePoint Server 2013 when a user shares a document with another user:

    • Configure outgoing email settings. For more information, see Configure outgoing email for a SharePoint 2013 farm.

SkyDrive Pro document library

The SkyDrive Pro document library is part of a user's My Site, which is created when the user's My Site is created. If a quota is set on the My Site site collection, the quota also applies to items in the SkyDrive Pro document library. By default, this is set to 100MB. If your company plans to use the SkyDrive Pro document library for users to store their files, an administrator should increase this default quota limit. If your organization uses SharePoint Online, a user's My Site quota is set to 7GB.

To make the user's SkyDrive Pro document library on their My Site appear in the Office client applications as an open or save location (so that the user can open files from, or save files to this location directly), you need to configure Exchange Autodiscover with the My Site URL. When Exchange Autodiscover is configured to use the My Site Host's URL, Office clients receive the My Site location for that user from Exchange Server 2013, and populates the Backstage in Office 2013 with a user's SkyDrive Pro document library as an open and save location. For more information, see Configure Exchange Autodiscover with a My Site Host URL in SharePoint Server 2013.

Note:

If the user does not open or save documents to their SkyDrive Pro document library frequently, the open and save location in the Backstage may be removed even if Exchange Autodiscover is configured.

If configuring Exchange Autodiscover is not an option in your deployment, users can individually add their SkyDrive Pro document library on their My Site as an open / save location by:

  1. Clicking Sync in SharePoint Server 2013.

  2. Entering the My Site Host URL when you are prompted by the SkyDrive Pro Windows Sync client. The SkyDrive Pro Windows Sync client will place a shortcut to the user's My Site in Windows Explorer under Favorites.

  3. In Office 2013, users can open or save a file to their SkyDrive Pro document library by going to the shortcut created in the previous step, and open or save a file to that location.

  4. After opening or saving a file, the Backstage will display the open and save locations to the user's My Site as part of the recent location feature in Office 2013.

SkyDrive Pro Windows Sync client

The SkyDrive Pro Windows Sync client installs either with Office 2013 Standard or Office 2013 Professional Plus, or you can download the stand-alone SkyDrive Pro Windows Sync client. To use the SkyDrive Pro Windows Sync client together with SharePoint Server 2013, you must have SharePoint Server 2013 Standard or Enterprise server licenses.

The SkyDrive Pro Windows Sync client synchronizes individual document libraries. If there are multiple document libraries in the site or in sub-sites, each document library must be synchronized individually. A user may start synchronization:

  • From SharePoint Server 2013 by clicking Sync in the document library you want synchronized.

  • From the SkyDrive Pro Windows Sync client. The user must supply a URL. A list of all document libraries available on that site will be displayed and the user must select one.

Warning:

When a user sets up their first synchronization between the SkyDrive Pro Windows Sync client and a document library in SharePoint Server 2013, the SkyDrive Pro Windows Sync client prompts the user to select a default synchronization folder in Windows Explorer on the client workstation. The SkyDrive Pro Windows Sync client stores synchronized files from SharePoint Server 2013 in this synchronization folder. After the user selects the default synchronization folder on the client workstation, if the user wants to change the default synchronization folder, all synchronizations must be stopped, and synchronizations initiated again at which point the user will be asked to select a new default synchronization folder. Additionally, the user must let the first synchronization of this synchronization folder complete without terminating the process (for example, by ending the process using Windows Task Manager).

If you change the URLs of your SharePoint Server, users will have to break their synchronization relationships with synchronization folders and set up new synchronization relationships with the document libraries. This is necessary because the synchronization of a document library depends on the URL of the document library. If URLs change on the server, the SkyDrive Pro Windows Sync client has no way of receiving the updated URL information. In this case, the user will have to stop synchronizing the document library, and set up the synchronization with that document library again.

Note:

Users will not lose data when stopping and setting up new synchronization relationships with a document library.

If storing files on a client workstation is against your corporate policy, an administrator may remove synchronization functionality from document libraries in SharePoint Server 2013. For more information, see Configure synchronization on all document libraries in SharePoint Server 2013.

Once a document library has synchronized with a client workstation, the files will continue to exist on that client workstation even if the My Site of the user is deleted and their Active Directory account is deleted. In this situation, even though the files will remain on the client workstation, the user cannot synchronize the files with SharePoint Server 2013 again.

The SkyDrive Pro Windows Sync client limits the total number of items that you may synchronize with a document library. The following limits are the synchronization limits of the SkyDrive Pro Windows Sync client:

  • You can synchronize up to a maximum of 20,000 items in your SkyDrive Pro document library, which includes folders and files.

  • You can sync up to a maximum of 5,000 items in other document libraries, which includes folders and files.

  • In any library, you can download files up to a maximum file size of 2 GB.

Note:

The above limits are not configurable.

If you are syncing OneNote files, you should create your OneNote notebook in SharePoint Server 2013 first, and then synchronize that with the client workstation, not vice versa. Also, if you have set up synchronization on a document library, you may only move your OneNote notebooks if you first break the synchronization on that document library.

SharePoint Server 2013 may respond to the SkyDrive Pro Windows Sync client indicating that it is experiencing high server resource utilization. The SkyDrive Pro Windows Sync client will retry synchronization after some time has elapsed. The default automatic synchronization time of the SkyDrive Pro Windows Sync client is 10 minutes. A user may also use the Sync Now feature on the SkyDrive Pro Windows Sync Client available in the notification area to start synchronization.

Security recommendations

Exchanges between the SkyDrive Pro Windows Sync client and SharePoint Server 2013 sites rely on a synchronization protocol and external mechanisms for security, such as those provided by virtual private networks or Secure Socket Layer (SSL) technology. SkyDrive Pro data is not encrypted over the network when the SkyDrive Pro Windows Sync client communicates with SharePoint Server 2013 unless the transport protocol uses https for server communication (which uses SSL or Transport Layer Security - TLS). Server administrators may configure SSL encryption for data sent over the network between the SkyDrive Pro Windows Sync client and the SharePoint servers. On-disk data may be encrypted by using the Windows BitLocker Drive Encryption. For more information see BitLocker Drive Encryption (http://go.microsoft.com/fwlink/p/?LinkId=163122).

Note:

SSL is recommended when users want to access SharePoint Server 2013 from outside a corporate domain. If you're using Active Directory, you can configure the Group Policy setting Sync Only On Domain Network which requires a Secure Socket Layer (SSL) connection for SkyDrive Pro clients that connect to SharePoint Server 2013 from outside the organization's intranet.

In addition, you can secure the SharePoint site from unauthorized access by setting site permissions appropriately. For more information, see Overview of site permissions in SharePoint 2013.

Note:

SkyDrive Pro does not use any non-standard communication ports for synchronization.

Upgrading from SharePoint Server 2010 to SharePoint Server 2013

SkyDrive Pro is not an upgrade from SharePoint Workspace 2010. You cannot migrate any data from SharePoint Workspace 2010 to SkyDrive Pro. SkyDrive Pro can co-exist with SharePoint Workspace 2010 on the same client computer.

In SharePoint Server 2010, each My Site included two document libraries:

  • Personal. Users stored documents in this document library that only the user had access to.

  • Shared. Users stored shared documents in this document library. Everyone in the organization had access to this document library.

In SharePoint Server 2013, a user has only one document library on their My Site. This document library is called the SkyDrive Pro document library. From within the SkyDrive Pro document library, users may share files and folders easily with other users.

When you perform an upgrade from SharePoint Server 2010 to SharePoint Server 2013:

  1. The Personal and Shared document libraries in SharePoint Server 2010 are combined into the SkyDrive Pro document library on the user's My Site in SharePoint Server 2013. Items from the Shared folder are stored in the Shared with Everyone folder in SharePoint Server 2013. Items from the Personal folder are stored at the root of the SkyDrive Pro document library and only shared with the owner of the My Site.

  2. Any other document libraries from a user's My Site in SharePoint Server 2010 are converted into subfolders at the root of the SkyDrive Pro document library. Permissions on these folders are automatically set to Private. A user is required to change the permissions on the folders if they want to share the folder with other users.

Important considerations to review before deploying and using SkyDrive Pro

Consider the following behaviors when planning to deploy and use SkyDrive Pro in your organization:

  • If you move a document to the SkyDrive Pro document library on a My Site, you will lose metadata and any version history associated with the file.

  • If you synchronize a document library that requires metadata to be filled in, the files will synchronize with SharePoint Server 2013, however, the document will remain checked out to you. To check-in the document, you have to fill in the required metadata either through SharePoint Server 2013 using the browser, or by opening the file with the Office 2013 client.

  • In the SkyDrive Pro document library, you can share documents with other users. In the Sharing dialog, you can select either the Can edit or Can view permission level. Do not add new permission levels to the SkyDrive Pro document library on the user's My Site.

  • An administrator may stop synchronization at a document library level or on the entire farm. While administrators can stop synchronization at the document library level, this is not easy to manage because administrators have to stop synchronization on each document library where synchronization is not allowed. For more information, see Configure synchronization on all document libraries in SharePoint Server 2013.


Plan document management in SharePoint 2013

Published: November 13, 2012

Summary: Use these TechNet articles and related resources to learn about document management planning in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint 2013 includes document management features that you can use to control the life cycle of documents in your organization — how they are created, reviewed, and published, and how they are ultimately disposed of or retained. The articles in this section will guide you in planning the document management features of your solution that is based on SharePoint 2013.

Note:

Certain features, such as document sets and information management policies, are not available in SharePoint Foundation 2013. The articles that discuss these features are intended for SharePoint Server 2013 audiences.

TechNet articles about document management planning

The following articles about document management planning are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of document management in SharePoint 2013 | Learn about the elements of a document management solution and the document management planning process in SharePoint 2013.
Building blocks | Identify users and analyze document usage in SharePoint 2013 | Learn how to collect information about document users to plan your SharePoint 2013 document management solution.
Checklist icon (not checked) | Plan document libraries in SharePoint 2013 | Learn how to plan document library use, access, and workflow in SharePoint 2013.
Checklist icon (not checked) | Plan content types and workflows in SharePoint 2013 | Learn how to integrate content types and workflows into your SharePoint 2013 document management solution.
Checklist icon (not checked) | Plan document sets in SharePoint Server 2013 | Learn about the Document Set feature in SharePoint Server 2013, how to administer Document Sets, and plan for Document Set content types.
Checklist icon (not checked) | Plan for information management policy in SharePoint Server 2013 | Learn how to use information management policies in SharePoint Server 2013.
Checklist icon (not checked) | Plan document versioning, content approval, and check-out controls in SharePoint 2013 | Learn how to use versioning, content approval, and check-out in SharePoint 2013 to control document versions throughout their life cycle.
Building blocks | Co-authoring administration in SharePoint 2013 | Contains links to TechNet articles that will help you learn how to configure co-authoring for SharePoint 2013.

Additional resources about document management planning

The following resources about document management planning are available from other subject matter experts.

 | Content | Description
TechNet logo | SharePoint 2013 for IT pros | Visit the Resource Center to access videos, community sites, documentation, and more.


Overview of document management in SharePoint 2013
See also

Published: November 13, 2012

Summary: Learn about the elements of a document management solution and the document management planning process in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article contains a high-level description of the various elements of a document management solution that is based on SharePoint 2013.

Document management controls the life cycle of documents in your organization — how they are created, reviewed, and published, and how they are ultimately disposed of or retained. Although the term "management" implies that information is controlled from the top of the organization, an effective document management system should reflect the culture of the organization that uses it. The tools that you use for document management should be flexible enough to enable you to tightly control a document's life cycle, if that fits your enterprise's culture and goals, but also to let you implement a more loosely structured system, if that better suits your enterprise.

The elements of a document management system

An effective document management solution specifies the following:

  • What kinds of documents and other content can be created in an organization.

  • What template to use for each kind of document.

  • What metadata to provide for each kind of document.

  • Where to store a document at each stage of its life cycle.

  • How to control access to a document at each stage of its life cycle.

  • How to move documents within the organization as team members contribute to the documents' creation, review, approval, publication, and disposition.

SharePoint Foundation 2013 includes features that implement all these aspects of document management. SharePoint Server 2013 includes the same features and also adds the following:

  • What policies to apply to documents so that document-related actions are audited, documents are retained or disposed of appropriately, and content that is important to the organization is protected.

  • How to handle documents as corporate records, which must be retained according to legal requirements and corporate guidelines.

To make sure that information workers can easily take advantage of these capabilities without having to depart from their day-to-day operations and familiar tools, applications in the Microsoft Office system — such as Outlook and Word — also include features that support each stage in a document's life cycle.

The planning process

The document management planning process consists of the following major steps:

  1. Identify document management roles Ensure that your plans incorporate the feedback of your organization's key stakeholders, you have the best team to implement the solution, and you know who will participate in document management processes.

  2. Analyze document usage After you identify who works on documents, determine the kinds of documents that they work on and how they use them. For more information, see Identify users and analyze document usage in SharePoint 2013.

  3. Plan the organization of documents You can organize documents in site collections, sites, and libraries. SharePoint 2013 offers a range of features to help organize and store documents, from specialized sites to loosely structured document libraries for quick document creation and collaboration. Within a library, you can additionally organize content into folders and subfolders. For more information, see Plan document libraries in SharePoint 2013.

  4. Plan how content moves between locations It might be necessary to move or copy a document from one site or library to another at different stages of its life cycle. For more information, see "Plan the flow of content" in Plan document libraries in SharePoint 2013.

  5. Plan content types Use content types to organize information about documents, such as metadata, document templates, and workflow processes. This is an important step to help you organize your documents and enforce consistency across your organization. For more information, see Plan content types and workflows in SharePoint 2013.

  6. Plan workflows When you plan workflows for your organization, you can control and track how documents move from one team member to another as each participant collaborates in a document's life cycle. SharePoint Server 2013 includes workflows for common team tasks such as reviewing and approving documents. SharePoint 2013 also supports creating and installing custom workflows. For more information, see Plan content types and workflows in SharePoint 2013.

  7. Plan content governance You can plan the appropriate degree of control that is based on content type or storage location. For example, you might require that documents in a particular library be checked out before they can be edited. For more information, see Plan document versioning, content approval, and check-out controls in SharePoint 2013.

  8. Plan policies For each content type, plan information management policies to make sure that documents are audited, retained, and otherwise handled according to your organization's institutional and legal requirements. SharePoint Server 2013 includes policies that implement auditing, document retention, and bar codes (to make sure that printed content can be correlated with corresponding electronic versions). For more information, see Plan for information management policy in SharePoint Server 2013.

    Note:

    Policies are not available in SharePoint Foundation 2013.

See also

Identify users and analyze document usage in SharePoint 2013
Plan document libraries in SharePoint 2013
Plan content types and workflows in SharePoint 2013
Plan document versioning, content approval, and check-out controls in SharePoint 2013
Plan for information management policy in SharePoint Server 2013


Identify users and analyze document usage in SharePoint 2013
See also

Published: November 13, 2012

Summary: Learn how to collect information about document users to plan your SharePoint 2013 document management solution.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The first step to plan your document management solution is to identify users and analyze how documents are used. This article contains guidance to identify users and analyze document usage for your solution that is based on SharePoint 2013.

Before reading this article, you should understand the document management planning process described in Overview of document management in SharePoint 2013.

In this article:

  • Identify users

  • Analyze document usage

  • Worksheets

Identify users

To identify the stakeholders and participants in your document management solution, you can use a survey to collect information. For example, your survey might contain the following questions:

  • Who in your organization creates documents?

  • What kinds of documents do they create?

  • What role does the user of the document have?

    • Who reviews documents?

    • Who edits documents?

    • Who uses documents?

    • Who approves the publication of documents?

    • Who designs websites used for hosting documents?

    • Who sets guidelines and policies for managing documents?

    • Who manages records in your organization?

    • Who deploys and maintains the servers on which documents are stored?

Identifying content stakeholders can help you make sure that your document management solution is comprehensive and that you design sites and document libraries that suit your enterprise's content needs and processes.

Analyze document usage

After you identify your content stakeholders, collect information from them that will help you analyze how documents are used in your organization. This is an important part of the planning process because the analysis helps you determine the following:

  • How document libraries should be structured.

  • Which site templates to use.

  • How many sites you will need.

  • Which physical server topology you must have to implement your solution.

  • Which information management policies to apply to the sites.

Note:

Information management policies are not available in SharePoint Foundation 2013.

The information to collect includes the following:

  • Document type, such as equity research note, employee performance review, internal memo, or product specification.

  • The purpose of each document type, such as "gives customers recommendations about equities together with supporting data."

  • The author of each document type (it is helpful to list the role of the author — such as "financial analyst or "product manager" — instead of individual names).

  • The users of each document type, such as "customers" or "team members."

  • The format of the document. If the document has to be converted from one format to another at any point in its life cycle, record that information.

  • Other roles that apply to the document's life cycle, such as "technical reviewer" or "copy editor."

  • Location of the document, such as "client computer," "web server," or "file server." Note that this question could have multiple answers, for example when a document is authored on a client computer and then published to a web server.

The following are examples of information that might be collected and recorded in the worksheet from two different organizations in an enterprise.

Table: Example with research information

Type Purpose Author User role Format Other roles Location

Equity research note

Gives premium customers of a financial service guidance on whether to buy or sell one or more stocks

Financial analyst

Customer

DOCX (for authoring); PDF (for publishing)

Reviewer (technical); reviewer (legal); approver; copy editor; site administrator

  • Authoring site

  • Testing site

Analysis The separate authoring and publishing formats require a format conversion. The large number of reviewers requires one or more workflows (business processes implemented on the server). The two sites (authoring and testing) require mechanisms for moving the content from one site to another.

Table: Example with employee information

Type Purpose Author User role Format Other roles Location

Employee performance review

Evaluates the performance of an employee — including self-evaluation and manager's evaluation

Information worker; manager

Managers; human resources specialists

.DOCX

Reviewer (human resources); reviewer (legal); approver (upper manager); records manager

  • Client computer

  • E-mail server (as attachment)

  • Corporate web server

  • Corporate records center

Analysis Two authors and multiple reviewers require one or more workflows. The document is handled by many people, then is located in a corporate web server (presumably highly secured) and is managed in place or moved to a records center. The sensitive nature of this content requires Information Rights Management (IRM) on the desktops and servers, in addition to corporate policies and best practices (such as auditing) that protect the employee's privacy and the enterprise's legal standing.

Note:

The Records Center is not available in SharePoint Foundation 2013.

Worksheets

Use the following worksheets to record the information discussed in this article:

  • Document management participants worksheet (http://go.microsoft.com/fwlink/p/?LinkId=165871)

  • Analyze document usage worksheet (http://go.microsoft.com/fwlink/p/?LinkId=165873)

See also

Plan document libraries in SharePoint 2013

SharePoint 2013 for IT pros


Plan document libraries in SharePoint 2013
See also

Published: November 13, 2012

Summary: Learn how to plan document library use, access, and workflow in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article describes how to plan document libraries in your SharePoint 2013 document management solution.

Document libraries are collections of files on SharePoint 2013 that you share with other site users. Most document management features are delivered through document libraries. As part of document management planning, you should determine the kind of document libraries that best fit your organization's needs. If you plan document libraries for multiple sites, you might have to plan the flow of content from one site to another. If you plan to use document libraries as storage locations, you can customize the Office Professional 2013Open dialog box and the Save dialog box to ensure that documents are stored in the preferred location.

Before reading this article, you should understand the document management process described in Overview of document management in SharePoint 2013.

Note:

The publishing feature, Document Center, Records Center, and Published Links web service are not available in SharePoint Foundation 2013. All other content in this topic applies to both SharePoint Server 2013 and SharePoint Foundation 2013 unless otherwise noted.

In this article:

  • Determine library type

  • Plan the flow of content

  • Promoting document libraries from Office client applications (SharePoint Server 2013 only.)

Determine library type

When you identify which document libraries best match your organization's needs, you might also determine that that you want multiple sites or site collections. For example, if you are authoring content for publication to external customers, you might need one site in which to author and review content and a separate site, perhaps in a separate SharePoint 2013 installation, in which to publish your content.

When you plan document libraries for multiple sites, you might also have to plan how content flows from one site to another — by manual processes, workflows, or custom solutions. For more information, see Plan the flow of content, later in this article.

The following table lists typical uses of document libraries.

Table: How document libraries are used

Library | Purpose
Library in a team site | Collaboration; easy sharing of content among peers; content control, such as versioning; SharePoint 2013 search.
Library in a portal area | Content that is intended for a wider audience in the organization; similar to a library in a team site, but typically implemented by using a stricter review and approval process.
Library in a Document Center site (SharePoint Server 2013 only.) | A large-scale library useful as an enterprise knowledge base or historical archive; includes features to help users navigate, search, and manage lots of documents in a deep hierarchy by using a set of specialized Web Parts.
Library in a Records Center (SharePoint Server 2013 only.) | Specialized records management; each library corresponds to a record type, such as contract, that the organization must retain for legal compliance purposes; libraries retain documents, metadata, and associated audits and are meant to be read-only.
Library in an Internet site (HTML) (SharePoint Server 2013 only.) | Content in web pages to incorporate into an Internet or intranet website; SharePoint Server 2013 supports editing web pages directly and manages the underlying document libraries for each page automatically.
Library in an Internet site (hybrid) (SharePoint Server 2013 only.) | Content available for downloading from a website; you can present content from document libraries on an Internet site.

The following example shows how to use the analysis that you completed in the Analyze document usage section in Identify users and analyze document usage in SharePoint 2013 to help you plan document library organization for your enterprise. In this example, Contoso Ltd. delivers content to clients based on market research. The content is created primarily by consultants who operate remotely. This is performed in a cycle in which the following steps occur:

  1. A partner evaluates engagement ideas and requests for proposals.

  2. After a contract is established, a project manager assembles a team of consultants and creates an engagement-specific working site in which the results of the research are recorded and the project is completed.

  3. When the project is finished, the deliverable documents are published to a secured Internet site, where customers have access to them.

  4. The team writes best practices documents and case studies based on the project.

  5. Knowledge managers collect, organize, and archive the best practices and other documents.

  6. Deliverables, contracts, and other documents are retained as corporate records.

  7. By using the content maintained by the knowledge managers, partners evaluate opportunities and create new proposals.

The following table shows a document usage analysis for this scenario.

Table: Document usage analysis

Documents | Purpose | Author | Users | Format
Engagement ideas and requests | Develop new customer engagements | Project leader | Sales manager; project leader | .docx
Proposals | Describe a proposed customer engagement | Project leader | Project managers; project team members; customers | .docx
Contracts | Commit to a consulting engagement | Lawyer | Project leader; project manager; sales manager; customers | .docx
Research results and project deliverable drafts | Generate documents related to the customer engagement | Project leader; project contributor; consultant | Editors; technical reviewers | .docx and other types
Deliverable documents | Generate final deliverables, probably converted from .docx format | Project leader | Customers | .pdf
Best practices and case study documents | Capture organizational knowledge | Project contributor; consultant; knowledge manager | All team members | Various types
Corporate records - (SharePoint Server 2013 only.) | Retain some content, such as contracts, as corporate records | All | Corporate records managers; corporate lawyers | All

This document usage analysis suggests the following requirements:

  • Project leaders need libraries in team sites for storing engagement ideas, engagement requests, and proposal drafts.

  • Lawyers need libraries in a portal or on a centralized document management site for storing contract templates and active contracts.

  • Project leaders and contributors need libraries in team sites for authoring research results, deliverables, and case studies.

  • Customers need libraries in an Internet site for viewing final deliverables. (SharePoint Server 2013 only.)

  • All members of the enterprise need access to a Document Center site for viewing best practices and case study documents. (SharePoint Server 2013 only.)

  • Corporate records managers and lawyers need access to an enterprise Records Center to maintain corporate records. (SharePoint Server 2013 only.)

The following figure shows how these libraries might be distributed. The sites are hosted in three site collections: an Internet site collection for customer access, an extranet site collection for remote authoring by team members, and an intranet site collection for secure maintenance of the records management site. (SharePoint Server 2013 only.)

Figure: How document libraries might be distributed

Distribution of libraries across sites

Plan the flow of content

Content in a document management solution is often dynamic, moving from one site to another as needed to meet users' needs. When you plan document libraries, therefore, you often plan the flow of content from one library or site to another. SharePoint 2013 includes the following ways to move content, either manually or dynamically:

  • You can create custom workflows that copy or move content from one site or library to another. A workflow guides a document through a business process and assigns tasks to participants when their role in the document's life cycle becomes active. A workflow can be designed to move a document from one site or library to another. For information about how to plan workflows, see Plan content types and workflows in SharePoint 2013.

  • Authors can copy a document to a library in any site in which they have authoring permissions. The relationship between the source and the destination document is maintained so that the copy can be refreshed as needed.

  • Web pages and whole websites can be staged and published from one site to another, either manually or automatically based on a schedule. (SharePoint Server 2013 only.)

  • Content can be sent to the records management site by using the SharePoint Server 2013 user interface, by using a workflow, or by using a custom solution that is based on the SharePoint Server 2013 object model. (SharePoint Server 2013 only.)

  • By using Web Folders or Network Places, an author can manually copy or move the content of a document library from one library or site to another.

Returning to the example, the following figure shows how to apply some of these content flow techniques. Note that the Staged Internet site has been added to the Authoring portal site. (SharePoint Server 2013 only.)

Figure: How to apply content flow techniques

How content flows from one library to another

  • By using publishing features, an author can publish web pages to the Internet site. (SharePoint Server 2013 only.)

  • By using the Copy command, an author can copy documents to the Document Center site.

  • By using a custom workflow, an author can copy documents to document libraries on the Internet site.

  • By using the Send To command, an author can send contracts to the enterprise records repository. (SharePoint Server 2013 only.)

Promoting document libraries from Office client applications

Important:

This section only applies to SharePoint Server 2013.

You can customize the Office Professional 2013Open dialog box and the Save dialog box to encourage organization members to use document libraries as storage locations. By adding sites to the My Places bar next to the Open dialog box and the Save dialog box, you can provide single-click access to the locations where users should store their documents. This makes it possible for team members to interact with the document libraries when they use Save from Office Professional 2013 client applications, instead of having to go directly to the server to upload their documents.

To promote using sites in the Open dialog box and the Save dialog box, you can publish them by using a web service. This service provides a list of sites targeted to specific users based on their roles or the sites that they are members of. An Office Professional 2013 client application can automatically discover this web service through the user's My Sites. Other server products can also implement this web service and provide the location of the service to the Office client application. After the web service is configured, Office Professional 2013 adds an entry to the My Places bar and populates it with the locations that are defined by the web service. For more information about the Published Links web service, see Published Links web service in the MSDN Library.

Or, administrators can set registry keys to add specific sites to the My Places bar in the Office Open dialog box and the Save dialog box. Registry keys are deployed by using Group Policy and an Active Directory directory service template that is provided in the Office 2013 Resource Kit.

You can limit the locations that organization members can save content to by using the Office Save dialog box. For example, you can restrict the ability to save files to desktops and force users to save content in a document library. In Office Professional 2013, you can control where users can browse to save their documents. This guides users to save in approved locations. Note that this does not guarantee that users will not save files to their local computers or other unapproved locations. There are many ways to move files onto a computer, and motivated people can work around most restrictions. However, by limiting access to these locations through the Office Save dialog box, you can significantly reduce the number of team members who use these unapproved locations.

To restrict the locations available in the Office Save dialog box, use Group Policy to set the appropriate registry keys to enable this setting and define the approved local, network, or server locations. When this setting is enabled, any location not defined in this manner — including standard links to the Desktop and My Network Places folders — will be removed from the My Places bar.

The list of approved locations can be limited to one or more Office applications. For example, an administrator can restrict save locations in Access while allowing other Office applications to save anywhere.

See also

Plan content types and workflows in SharePoint 2013
Plan for information management policy in SharePoint Server 2013

Getting started with SharePoint Server 2013 workflow


Plan content types and workflows in SharePoint 2013
See also

Published: November 13, 2012

Summary: Learn how to integrate content types and workflows into your SharePoint 2013 document management solution.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article describes content types and workflows and provides guidance about how to plan to integrate them into your SharePoint 2013 document management solution. A content type is a reusable collection of metadata (columns), workflow, behavior, and other settings for a category of items or documents in a SharePoint 2013 list or document library. Content types enable you to manage the settings for a category of information in a centralized, reusable way. A workflow lets you attach a business process to items in SharePoint 2013.

In this article:

  • Content type overview

  • Plan document content types

  • Plan list content types

  • Plan workflows

  • Worksheet

Before you use the Content type and workflow planning (http://go.microsoft.com/fwlink/p/?LinkID=165878) worksheet included with this article to plan your content types and workflows, ensure that you have read Identify users and analyze document usage in SharePoint 2013 and completed the "Analyze document usage" and the "Document participants" worksheets associated with that article.

Content type overview

A content type defines the attributes of a list item, a document, or a folder. Each content type can specify the following:

  • Properties to associate with items of its type.

  • Metadata to associate with items of its type.

  • Workflows that can be started from items of its type.

  • Information management policies to associate with items of its type.

  • Document templates (for document content types).

  • Custom features.

You can associate a content type with a list or library. When you do this, you are specifying that the list or library can contain items of that content type and that the New command in that list or library will let users create new items of that type.

Note:

You can also associate properties, workflows, policies, and templates directly with a list or library. However, doing this can limit these associations to the list or library and is not reusable across your solution. In SharePoint 2013, site-level workflows can be associated with multiple lists or libraries.

Document libraries and lists can contain multiple content types. For example, a library can contain both the documents and the graphics related to a project. When a list or library contains multiple content types, the following apply:

  • By default, the New command in that list or library lets users select from all available content types when they create a new item. Content type owners can configure the New command to display only certain content types.

  • The columns associated with all available content types are displayed.

You can define custom content types in a site's content type gallery. A custom content type must be derived, directly or indirectly, from a core content type such as Document or Item. After it is defined in a site, a custom content type is available in that site and in all sites below that site. To make a content type most widely available throughout a site collection, define it in the content type gallery of the top-level site. In SharePoint Server 2013, you can also create a custom content type inside a content type hub that is defined in a managed metadata service instance. When it is created in a content type hub, the content type will be available to other site collections that are part of web applications associated with that managed metadata service instance.

Note:

The Managed Metadata service and the content type hub are not available in SharePoint Foundation 2013.

For example, if your organization uses a particular contract template, in the content type gallery of the top-level site in a site collection, you can create a content type that defines the metadata for that contract, the contract's template, and workflows required to review and complete the contract. Then, any document library in your site collection to which you associate the Contract content type will include all these features and will enable authors to create new contracts based on the template.

In sites that are based on SharePoint 2013, each default list item or library item, such as Contact, Task, or Document, has a corresponding core content type in the site's content type gallery. When you plan content types, you can use these core content type definitions as starting points and base new content types on existing ones as needed.

Content types are organized into a hierarchy that lets one content type inherit its characteristics from another content type. This inheritance enables classes of documents to share characteristics across an organization, and it enables teams to customize these characteristics for particular sites or lists.

For example, all user-deliverable documents in an enterprise might require a set of metadata, such as account number, project number, and project manager. By creating a top-level Customer Deliverable content type from which all other customer-deliverable document types inherit, you make sure that required information, such as account numbers and project numbers, will be associated with all variants of customer-deliverable documents in your organization. Note that if the content type owner adds another required column to the top-level Customer Deliverable content type, the content type owner can propagate the changes to all content types that inherit from it, which will add the new column to all customer deliverable documents.

Properties integration with Office 2013

In the Microsoft Office system, when a user edits a document from a SharePoint 2013 document management server, a Document Information Panel is shown at the top of the document. The Document Information Panel displays an editable form of the document's properties on the server.

SharePoint 2013 makes it easy to customize the property form for a content type. When you configure a content type, you can start InfoPath 2013, which generates a default property form that is based on the properties of the content type. The default form includes the same controls, layout, and schema that InfoPath 2013 would use if no custom form were defined. You can then customize and deploy the form as you would any other InfoPath 2013 form. For example, you can add your company logo, fonts, and color scheme to a form; connect it to a custom data source; add conditional logic; and design form features that are available to users based on their roles.

Along with editing properties in the Document Information Panel, authors who use Word 2013 can insert properties that are defined on the server into their documents. For example, if the document properties include a project manager name, this name can be inserted into the title page, the footer, or anywhere else the name is used in the document. If a new project manager is assigned to a project, the Project Manager property can be updated on the document management server. This updated project manager name will be reflected in every instance of this property that was inserted into a document.

Using metadata with content types

Metadata is information about a document that is used to categorize and classify your content. Metadata is associated with a content type as a column. Metadata can provide contextual information about your document by associating it with an author, subject, audience, language, and so on. Unlike properties, metadata are stored as columns and can be indexed and searched on by the SharePoint Search engine.

Metadata added at the site collection level can be associated with content types. By using metadata with content types, all later content types can inherit some or all the metadata from the parent content type at the site collection level. Additional metadata can then be added at a lower level, such as a single document.

Column templates

Each item of metadata that is associated with a content type is a column, which is a location in a list to store information. Lists or libraries are often displayed graphically as columns of information. However, depending on the view associated with the list, the columns can appear in other forms, such as days in a calendar display. In forms associated with a list or library, columns are displayed as fields.

You can define columns for use in multiple content types. To do this, create them in a Column Templates gallery. There is a Column Templates gallery in each site in a site collection. As with content types, columns defined in the Column Templates gallery of a site are available in that site and in all sites below it.

Folder content types

Folder content types define the metadata that is associated with a folder in a list or library. When you apply a folder content type to a list or library, the New command in that list or library will include the folder content type, which makes it possible for users create folders of that type.

You can define views in a list or library that are available only in folders of a particular content type. This is useful when you want a folder to contain a particular kind of document and you want views in that folder to only display columns that are relevant to the document type that is contained in that folder.

By using the SharePoint products object model, you can customize the New command for a folder content type so that when a user creates a new folder of that type, the folder is prepopulated with multiple files and documents based on templates that are stored on the server. This is useful, for example, for implementing a compound document type that requires multiple files to contribute to a single deliverable document.

Document sets is a feature in SharePoint Server 2013 that lets you use Office 2013 to manage deliverables that span multiple documents. Document sets are special kinds of folders that are used to manage a single deliverable, or work product, which can include multiple documents in multiple locations. You create document sets by using extensible templates that are provided with SharePoint Server 2013. You can also customize Document Set templates to represent the work products that are relevant to your organization. Document sets also include version control, which lets you capture the status of the complete document set at various points in its life cycle. For more information about document sets, see Plan document sets in SharePoint Server 2013.

Plan document content types

The first stage in planning document content types is to review each document type that is listed in your Analyze document usage (http://go.microsoft.com/fwlink/p/?LinkId=165873) worksheet to determine whether an existing content type will work for that kind of document. Each document content type should inherit its settings directly from the core Document content type or from a content type that is descended from the Document content type. This ensures that the basic columns for your document types, such as Title and Created By, are present and that you can associate a template with the content type. If a core content type (such as Document) is sufficient, enter the content type name in the Content Type column of the "Analyze document usage" worksheet.

For information about changing the core content types, download the white paper "Guidance for editing pre-defined content types and site columns" (http://go.microsoft.com/fwlink/p/?LinkId=260922).

Plan list content types

The elements of a list content type include the columns of metadata that are associated with the content type and workflows that can run on items of that content type. Use a list content type to define a kind of list item that is unique to your solution. For example, in a customer call center solution, in which support professionals investigate and resolve customers' technical issues, a list content type could be used to standardize the data for each support incident and to track the incident by using a workflow.

Plan workflows

Workflows implement business processes on documents, web pages, forms, and list items in SharePoint 2013. They can be associated with libraries, lists, or content types.

In document management, use workflows to route documents from person to person so that they can each complete their document management tasks, such as reviewing documents, approving their publication, or managing their disposition. Also, use custom workflows to move documents from one site or library to another. For example, you can design a workflow to copy a document from one site to another when the document is scheduled to be archived.

SharePoint 2013 includes the Three-state workflow, which you can use to manage business processes that track the status of an item through three states or phases. SharePoint Server 2013 also includes the following workflows that address document management needs:

  • Collect Feedback Sends a document for review.

  • Approval Sends a document for approval, often as a prerequisite to publishing it.

  • Disposition Manages document expiration and disposition.

  • Collect Signatures Routes a document for signatures.

Associate a workflow with a content type when you want to make that workflow available when that content type is being used. For example, a purchase order content type could require approval by a manager before the transaction can be completed. To make sure that the Approval workflow is always available when a purchase order is initiated, create a Purchase Order content type and associate the Approval workflow with it. Then add the Purchase Order content type to any document libraries in which purchase orders will be stored.

To plan workflows for your document management solution, analyze each document content type that you plan to implement and identify the business processes that have to be available to run on content of that type. Then identify the workflows you will have to make available for that content.

The following is a sample table that analyzes workflows for a contract content type.

Table: Workflows for a contract content type

Contract process | Contract workflow
Review drafts. | Collect feedback
Get approval from the manager and legal counsel. | Approval
Resolve open issues. | Issue tracking
Get signatures. | Collect signatures

For more information, see Workflow in SharePoint 2013.

Worksheet

Use the following worksheet to record the information discussed in this article:

  • Content type and workflow planning worksheet (http://go.microsoft.com/fwlink/p/?LinkId=165878)

See also

Workflow in SharePoint 2013
Configure workflow in SharePoint Server 2013
SharePoint 2013 for IT pros


Plan document sets in SharePoint Server 2013
See also

Published: November 13, 2012

Summary: Learn about the Document Set feature in SharePoint Server 2013, how to administer Document Sets, and plan for Document Set content types.

Applies to: SharePoint Server 2013

This article describes Documents Sets and provides guidance on how you can integrate them with your SharePoint Server 2013 document management solution.

In this article:

  • About Document Sets

  • Administering Document Sets

  • Planning Document Set content types

  • Worksheets

About Document Sets

Document Sets are a feature in SharePoint Server 2013 that enables an organization to manage a single deliverable, or work product, which can include multiple documents or files. A Document Set is a special kind of folder that combines unique Document Set attributes, the attributes and behavior of folders and documents, and provides a user interface (UI), metadata, and object model elements to help manage all aspects of the work product.

For teams and users in many organizations, a set of documents, or a work product, is needed to better manage a project or deliverable. For example, a legal team might need to collect, create, and manage various documents, photos, and audio files that are related to a particular case. Or, a sales team might need to compile documents from various sources to create and manage a request for proposal (RFP) for a potential client. Documents Sets provide those teams and users with the ability to manage those sets of documents as a single collection, deliverable, or work product. Document Set owners can then create a custom Welcome Page that can display the items included and important information about the work product.

In SharePoint Server 2013, organizations that want to create and manage Document Sets consistently can configure a Document Set content type for each work product they typically create. A Document Set content type can then define approved content types, attributes, default items, columns, workflows, and policies. Additional customized Document Set content types can then be created from the parent content type, each inheriting properties and settings from the parent Document Set content type. After the content type is added to a library, users can then create a Document Set that inherits the attributes of the Document Set content type by using the New command. A Document Set content type provides additional settings that enable you to specify allowed content types, default content, shared columns, Welcome Page columns, and default Welcome Page view.

For more information about content types, see Plan content types and workflows in SharePoint 2013.

For more information about how to create and manage Document Sets in SharePoint Server 2013, see Create and configure a new document set content type in SharePoint Server 2013 Help.

Administering Document Sets

Document Sets in SharePoint Server 2013 share many of the same attributes and properties as folders. However there are some important considerations you should be aware of when planning a Document Set solution.

  • There is no limit on the number of documents that can exist in a Document Set. However, display load times may be limited by the list view threshold which by default is set at 5,000 items. Folders are allowed in document sets, but metadata navigation cannot be used in a Document Set. Therefore, it is important to consider the possibility of exceeding list view thresholds and navigation design concerns when you determine how many items should exist in a Document Set. In addition, when you use the Send to feature with a Document Set, the sum for all documents in a Document Set cannot be larger than 50MB. For a collection or work product with a very large number of items, a folder structure in a document library may be a better solution.

  • There is no limit on the number of Document Sets that can exist in a document library. However, the number of Document Sets that can appear in lists will be limited by the list view threshold.

  • When using shared metadata, if there are more than 10 items in a Document Set, metadata updates will be run by a timer job every 15 minutes.

  • When using Document Set routing, Document Sets that are sent to a content organizer will remain in the drop-off library and be moved to the appropriate location by the content organizer processing timer job, which by default runs daily.

To use Document Sets in a site collection, the Document Sets feature must be enabled.

To enable Document Sets feature for a site collection

  1. On the Site Settings page, under Site Collection Administration, click Site collection features.

  2. On the Features page, for Document Sets, click Activate.

After the Document Sets feature is enabled, you can create Document Set content types.

Planning Document Set content types

You can plan Document Set content types for your solution by using the Analyze document usage worksheet, which you can complete by using the article Identify users and analyze document usage in SharePoint 2013. You can then use the Content type worksheet (http://go.microsoft.com/fwlink/?LinkId=165878&clcid=0x409) to record your decisions about each new Document Set content type that you will use in your solution.

To plan Document Set content types by using the Content type worksheet

  1. Enter Document Set in the Content Type field of the Content type worksheet.

  2. Enter the site URL at which the new Document Set content type will be defined. Note that the content types are available in the site in which they are defined and in all sites below that site.

  3. Determine the parent content type Enter the parent Document Set content type in the Parent Content Type field of the Content type worksheet. This will be either a core Document Set content type or a custom Document Set content type that you have already planned.

  4. Determine Document Set settings Determine and then specify the following Document Set settings in the Content type worksheet:

    1. Determine allowed content types Specify the default content types that will be allowed in this Document Set content type.

    2. Determine default content If the Document Set content type that you are creating will be configured to automatically create default content when you create a new instance of a Document Set, you can add files to the Document Set manually. Only files of the allowed content types for the Document Set can be added.

    3. Determine shared columns Specify whether column values for the Document Set should be automatically synchronized to all documents that are contained in the set.

    4. Determine Welcome Page columns Specify which columns should be shown on the Welcome Page for each Document Set.

    5. Determine the Welcome Page view Specify the view to display the contents of the Document Set on the Welcome Page.

  5. Determine the columns and column order In the Plan Columns table of the Content type worksheet:

    1. Enter each column that is inherited from the parent content type. In the New? column, type No for each entry.

    2. For each additional column, enter the name of a predefined column or of a column that you will create. Enter the names of the additional columns, their types, and indicate whether they are new.

  6. In the Plan Template section of the worksheet, type None.

  7. Determine the workflows If there is an available workflow that is relevant to the Document Set content type, you can optionally associate it with the content type. The workflow can then be initiated on any list item of that content type. For a full discussion of workflow planning, see Plan workflows. After reviewing workflows and determining which workflows are available, enter each workflow to associate with the content type in the Plan Workflows table of the Content type worksheet. If the workflow is not inherited from the parent content type, enter that information in the New? column.

  8. Determine the policy A policy is a set of rules for a kind of content; policy features provide the details of each rule, such as whether items of the content type can be printed or which actions on the item should be audited. For more information about policy planning, see Plan for information management policy in SharePoint Server 2013. After reviewing policies and determining which policy features and policy templates are available, in the Plan a Policy section of the Content type worksheet, do the following:

    1. If the parent content type has policy settings, they will apply unchanged in the new content type. This ensures that policies, after they are set, are enforced in all relevant content types. If the current content type is inheriting its policy settings from its parent type, in the Plan a Policy section of the Content type worksheet, answer Yes to the question, "Is the policy defined in the parent content type?."

    2. If the current content type is inheriting a policy based on the parent content type, in the Record the Policy Name field of the Plan a Policy section, type the name of the policy template. Similarly, if the current content type does not inherit a policy and you want to apply a policy template, in the Record the Policy Name field of the Plan a Policy section, type the name of the policy template.

    3. If the current content type is inheriting one or more individual policy features from the parent content type, enter each policy feature in the Feature table in the Plan a Policy section of the worksheet. Conversely, if the current content type does not inherit a policy and you want to associate policy features with the current content type, enter those policy features in the Feature table. Note that you cannot associate both individual policy features and a policy by name to a content type.

Worksheets

Use the following worksheets to record the information that is discussed in this article:

  • Content type worksheet (http://go.microsoft.com/fwlink/?LinkId=165878&clcid=0x409)

  • Analyze document usage worksheet (http://go.microsoft.com/fwlink/?LinkID=165873&clcid=0x409)

See also

Identify users and analyze document usage in SharePoint 2013
Plan content types and workflows in SharePoint 2013


Plan for information management policy in SharePoint Server 2013
See also

Published: November 13, 2012

Summary: Learn how to use information management policies in SharePoint Server 2013.

Applies to: SharePoint Server 2013

An information management policy is a set of rules for a type of content. Each rule in a policy is a policy feature. For example, an information management policy feature could specify how long a type of content should be retained, or it could provide document auditing. Information management policies enable you to control who can access your organizational information, what they can do with it, and how long the information should be retained.

In this article:

  • Information management policies and policy features

  • Information management policy integration with Office system applications

  • Policy features available in SharePoint Server 2013

  • Plan document policies

Information management policies and policy features

Note:

In this article, the term policy refers to information management policy unless otherwise specified.

Policies can be implemented to help an organization comply with legally mandated requirements, such as the need to retain records. For example, a Human Resources policy, used in an organization to ensure that employee records are handled in compliance with legally recommended guidelines, could include the following policy features:

  • Auditing, to record the editing and viewing history of each employee-related document.

  • Retention, to ensure that work-in-progress content is not kept for an unnecessarily long time.

  • Print restrictions, to ensure that sensitive employee-related documents are printed only on secure printers. Note that this is an example of a custom policy feature that must be implemented by using the SharePoint Server 2013 object model or obtained from a third-party software vendor.

Policy features are implemented as programs that run on SharePoint Server 2013. They can be enabled and configured by a server administrator and, when they are enabled, they can be used by site administrators to define policies. SharePoint Server 2013 includes policy features to help you manage your content. By using the SharePoint Server 2013 object model, you can design and install custom policy features that meet unique enterprise needs.

When your organization uses the Microsoft Office system client applications together with SharePoint Server 2013, policies are enforced both on the server and in the client applications. This is done transparently; policy features that apply to a document are described in a policy statement that is associated with the document, and policy-aware applications prevent users from doing tasks that violate the document's policy.

To implement a policy, associate it with content types, libraries, or lists in sites.

You can associate a policy with a library, list, or content type in the following ways:

  • Associate policy features with a Site Collection policy and then associate that policy with a content type or with a list or library. The top-level site of a site collection includes a Site Collection Policies gallery where administrators of the top-level site can create new policies. After creating a Site Collection policy, you can export it so that administrators of other site collections can import it into their Site Collection Policies galleries. This lets you standardize policies across your organization.

    When a Site Collection policy is associated with a content type and that content type is associated with a list or library, the owner of the list or library cannot modify the Site Collection policy in the list or library. This ensures that policies that are assigned to a content type are enforced at each level of the site hierarchy.

  • Associate a set of policy features directly with a content type, and then add that content type to one or more lists or libraries. To ensure that a policy that is created by using this method will be used in the whole site collection, associate it with a content type in the Site Content Type gallery of the top-level site collection. Then every item of that content type in the site collection, and every item of a content type that inherits from the original content type, will have the policy. When you use this method of associating a policy with a content type, it is harder to reuse the policy in other site collections, because policies created by using this method cannot be exported.

    Note:

    To more tightly control which policies are being used in a site collection, site collection administrators can disable the ability to set policy features directly on a content type. When setting policy features on a content type is restricted, content type designers can only associate policies from the Site Collection Policies gallery with content types.

  • Associate a set of policy features directly with a list or library. You can only use this method if the list or library does not support multiple content types. This method of creating a policy is only useful for a narrowly defined policy that applies to a single list or library.

    Note:

    To more tightly control which policies are being used in a site collection, site collection administrators can disable the ability to set policy features directly on a library. When setting policy features on a library is restricted, content type designers can only associate policies from the Site Collection Policies gallery with libraries.

Information management policy integration with Office system applications

SharePoint Server 2013 information management policies are exposed in the Office system client applications. When you configure an information management policy on the server, you can write a policy statement that informs information workers about the policies that are enforced on documents. For example, the policy statement might indicate that a document will be deleted after a certain time or that it contains sensitive information that should not be communicated outside the company. The statement might even provide a contact name if the information worker needs more information about the policy.

Custom policy features can be integrated in the Office system client applications. However, you must implement policy-specific behaviors that you want to be available from the Office system client applications, and you must give users a way to install these behaviors on their client computers via mechanisms such as add-ins to make them available from the Office system client applications. For example, if you implement a custom policy feature that restricts the printers that can be used to print a content type, you must provide a custom add-in for Microsoft Office client applications to enforce the restriction from these applications.

Policy features available in SharePoint Server 2013

This section describes the policy features that are included in SharePoint Server 2013.

  • Retention The Retention policy feature lets you define retention stages, with an action that happens at the end of each stage. For example, you could define a two-stage retention policy on all documents in a specific library that deletes all previous versions of the document one year after the document is created, and declares the document to be a record five years after the document is created.

    The actions that can occur at the end of a stage include the following:

    • Moving the item to the Recycle Bin

    • Permanently deleting the item

    • Transferring the item to another location

    • Starting a workflow

    • Skipping to the next stage

    • Declaring the item to be a record

    • Deleting all previous drafts of the item

    • Deleting all previous versions of the item

  • Auditing The Auditing policy feature logs events and operations that are performed on documents and list items. You can configure Auditing to log events such as the following:

    • Editing a document or item

    • Viewing a document or item

    • Checking a document in or out

    • Changing the permissions for a document or item

    • Deleting a document or item

  • Labeling The Labeling policy feature specifies a label to associate with a type of document or list item. Labels are searchable text areas that SharePoint Server 2013 generates based on properties and formatting that you specify. For example, in a law firm, a document related to a legal matter could include a label that contains the clients' names, the case number, and the attorney assigned to the matter. Labels are especially useful in printed versions of documents as a way to display document properties in printed copy. Along with using labels for documents, you can associate a label with a list item and include that label in views of the list.

    Note:

    The label policy feature has been deprecated and should not be used in SharePoint Server 2013.

  • Barcode The Barcode policy feature enables you to track physical copies of a document by creating a unique identifier value for a document and inserting a bar code image of that value in the document. By default, bar codes are compliant with the common Code 39 standard (ANSI/AIM BC1-1995, Code 39), and you can plug in other bar code providers by using the policies object model.

Plan document policies

When you plan your solution's policies, first determine organization-wide policy needs, and then design Site Collection policies to meet those needs and distribute those policies for inclusion in the Site Collection Policy galleries of all relevant site collections. This might require planning custom policy features. Note that, if your policy requires custom policy features and resources, those features and resources must be installed and enabled on all server farms on which your solution is used.

A typical example of an organization-wide policy is one that is designed to promote best practices in auditing and retaining product specifications across the divisions of an organization. A single Site Collection policy is designed to be applied to all product specifications so that they are consistently audited and retained. After the Site Collection policy is designed and tested, it is exported and then imported to Site Collection Policy galleries of other site collections in which product specifications are stored. It is then associated with all product specification content types in the various site collections to impose the policy on all product specifications.

See also

Plan content types and workflows in SharePoint 2013

SharePoint 2013 for IT pros


Plan document versioning, content approval, and check-out controls in SharePoint 2013
See also

Published: November 13, 2012

Summary: Learn how to use versioning, content approval, and check-out in SharePoint 2013 to control document versions throughout their life cycle.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article describes how to plan to use versioning, content approval, and check-out in SharePoint 2013 to control document versions throughout their life cycle.

Before reading this article, you should understand the document management planning process described in Overview of document management in SharePoint 2013.

In this article:

  • About versioning, content approval, and check-outs

  • Plan versioning

  • Plan content approval

  • Plan check-out and check-in

About versioning, content approval, and check-outs

SharePoint 2013 includes the following features that can help you control documents in a document library:

  • Versioning is the method by which successive iterations of a document are numbered and saved.

  • Content approval is the method by which site members who have approver permissions control the publication of content.

  • Check-out and Check-in are the methods by which users can better control when a new version of a document is created and also comment on changes that they made when they check a document in.

You configure settings for the content governance features discussed in this article in document libraries. To share these settings across libraries in your solution, you can create document library templates that include your content governance settings. This makes sure that new libraries will reflect your content governance decisions.

Plan versioning

The default versioning control for a document library depends on the site collection template. However, you can configure versioning control for a document library depending on your particular requirements. Each document library can have a different versioning control that best suits the kind of documents in the library. SharePoint 2013 has three versioning options:

  • No versioning Specifies that no earlier versions of documents are saved. When versioning is not being used, earlier versions of documents are not retrievable, and document history is also not retained because comments that accompany each iteration of a document are not saved. Use this option on document libraries that contain unimportant content or content that will never change.

  • Create major versions Specifies that numbered versions of documents are retained by using a simple versioning scheme (such as 1, 2, 3). To control the effect on storage space, you can specify how many earlier versions to keep, counting back from the current version.

    In major versioning, every time that a new version of a document is saved, all users who have permissions to the document library will be able to view the content. Use this option when you do not want to differentiate between draft versions of documents and published versions. For example, in a document library that is used by a workgroup in an organization, major versioning is a good choice if everyone on the team must be able to view all iterations of each document.

  • Create major and minor (draft) versions Specifies that numbered versions of documents are retained by using a major and minor versioning scheme (such as 1.0, 1.1, 1.2, 2.0, 2.1). Versions ending in .0 are major versions and versions ending with non-zero extensions are minor versions. Previous major and minor versions of documents are saved together with current versions. To control the effect on storage space, you can specify how many previous major versions to keep, counting back from the current version. You can also specify how many major versions being kept should include their respective minor versions. For example, if you specify that minor versions should be kept for two major versions and the current major version is 4.0, then all minor versions starting at 3.1 will be kept.

    In major and minor versioning, any user who has read permissions can view major versions of documents. You can specify which users can also view minor versions. Typically, we recommend that you grant permissions to view and work with minor versions to the users who can edit items, and restrict users who have read permissions to viewing only major versions.

    Use major and minor versioning when you want to differentiate between published content that can be viewed by an audience and draft content that is not yet ready for publication. For example, on a human resources Web site that describes organizational benefits, use major and minor versioning to restrict employees' access to benefits descriptions while the descriptions are being revised.

Note:

Regardless of the versioning control that you choose, remember that each version of a document stores a complete copy of the document in SQL Server and consider what effect this might have on storage space.

Plan content approval

Use content approval to formalize and control making content available to an audience. For example, an enterprise that publishes content as one of its products or services might require a legal review and approval before publishing the content.

A document draft awaiting content approval is in the Pending status. When an approver reviews the document and approves the content, it becomes available for viewing by users who have read permissions. A document library owner can enable content approval for a document library and, optionally, can associate a workflow with the library to run the approval process.

The way that documents are submitted for approval varies depending on the versioning settings in the document library:

  • No versioning If versioning is not being used and changes to a document are saved, the document's status becomes Pending. SharePoint 2013 keeps the earlier version of the document so that users who have read permissions can still view it. After the pending changes are approved, the new version of the document is made available for viewing by users who have read permissions and the earlier version is not retained.

    If versioning is not being used and a new document is uploaded to the document library, it is added to the library in the Pending status and is not viewable by users who have read permissions until it is approved.

  • Create major versions If major versioning is being used and changes to a document are saved, the document's status becomes Pending and the previous major version of the document is made available for viewing by users who have read permissions. After changes to the document are approved, a new major version of the document is created and made available to users who have read permissions, and the previous major version is saved to the document's history list.

    If major versioning is being used and a new document is uploaded to the document library, it is added to the library in the Pending status and is not viewable by users who have read permissions until it is approved as version 1.

  • Create major and minor (draft) versions If major and minor versioning is being used and changes to a document are saved, the author has the choice of saving a new minor version of the document as a draft or creating a new major version, which changes the document's status to Pending. After the changes to the document are approved, a new major version of the document is created and made available to users who have read permissions. In major and minor versioning, both major and minor versions of documents are kept in a document's history list.

    If major and minor versioning is being used and a new document is uploaded to the document library, it can be added to the library either in the Draft status as version 0.1 or the author can immediately request approval. In this case, the document's status becomes Pending.

Plan check-out and check-in

You can require users to check out documents from a document library before they edit the documents. The benefits of requiring check-out and check-in include the following:

  • Better control of when document versions are created. When a document is checked out, the author can save the document without checking it in. Other users of the document library will be unable to see these changes, and a new version is not created. A new version (visible to other users) is only created when an author checks in a document. This gives the author more flexibility and control.

  • Better capture of metadata. When a document is checked in, the author can write comments that describe the changes that were made to the document. This creates an ongoing historical record of the changes that were made to the document.

If your solution requires users to check in and check out documents to edit them, you can use features in Office 2013 client applications that support these actions. Users can check out documents, undo check-outs, and check in documents from Office 2013 client applications.

When a document is checked out, it is locked for exclusive editing by the user. When the user saves edits to this file, the changes are uploaded and saved to the server. The changes are private to the user and not visible to others. When the user is ready to check in the document, the latest changes are made visible to others and published.

From Office 2013 client applications, users can also choose to leave checked-out documents on the server by changing content editing options.

Note:

You should not check out a document when you use the co-authoring functionality.

See also

Plan document management in SharePoint 2013


Co-authoring administration in SharePoint 2013
See also

Published: January 8, 2013

Summary: Find TechNet articles that will help you learn how to configure co-authoring for SharePoint 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

Co-authoring simplifies collaboration by enabling multiple users to work productively on the same document without intruding on one another's work or locking one another out. By default, co-authoring functionality is enabled in SharePoint 2013 and requires no additional steps. The articles that are listed here describe tasks that administrators can use if they want to configure co-authoring for their organizations or to disable it, either on the server side by using server properties, or on the client side by using Group Policy.

Office 2013 logo The following table lists and describes articles about co-authoring in SharePoint 2013.

Articles about co-authoring in SharePoint 2013

Article | Description
Overview of co-authoring in SharePoint 2013 | Provides information about co-authoring and the permissions and software versions that are required for co-authoring in SharePoint 2013 and SharePoint Online.
Configure versioning for co-authoring in SharePoint 2013 | Provides information about how to configure SharePoint document library versioning settings to support co-authoring.
Configure the co-authoring versioning period in SharePoint 2013 | Provides information about how to specify how often SharePoint 2013 stores a version of a document that is being edited.
Configure the maximum number of co-authoring authors in SharePoint 2013 | Provides information about how to limit the number of users who can co-author a Word document or PowerPoint presentation at the same time.
Disable co-authoring in SharePoint 2013 | Provides information about how to disable co-authoring functionality in SharePoint 2013 by using Group Policy or by using Windows PowerShell.

See also

Overview of co-authoring in SharePoint 2013


Overview of co-authoring in SharePoint 2013
See also

Published: January 15, 2013

Summary: Provides information about co-authoring and the permissions and software versions that are required for co-authoring in SharePoint 2013 and SharePoint Online.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013 | SharePoint Online

Audience: IT Professionals

Use the co-authoring feature in SharePoint Server 2013 or SharePoint Online to enable multiple users to work on a document, at any time, without interfering with each other's changes. Co-authoring removes barriers to server-based document collaboration and helps organizations to reduce the overhead associated with traditional document sharing through attachments. This functionality requires no additional server setup and is the default state for documents stored in SharePoint 2013 and SharePoint Online. Co-authoring functionality is managed by using the same tools and technologies that are already used to manage SharePoint, helping to minimize the impact on administrators.

As with Office 2010, Office 2013 provides co-authoring functionality for Word 2013, PowerPoint 2013 and OneNote 2013. Office 2013 introduces co-authoring functionality for Visio 2013. If you are using SharePoint Online or have SharePoint 2013 configured to use Office Web Apps Server, users can also co-author documents in Word, PowerPoint, Excel, and OneNote Web Apps.

Important:

This article is for IT Professionals. It applies to planning for co-authoring in an organization.

Are you looking for help with co-authoring? You may be looking for Document collaboration and co-authoring, which will help you understand and use the co-authoring and versioning features of SharePoint 2013.

In this article:

  • Co-authoring functionality in SharePoint 2013 and SharePoint Online

  • Understanding the end-user experience of co-authoring in SharePoint 2013 and SharePoint Online

  • Important planning considerations for co-authoring in SharePoint 2013 and SharePoint Online

  • Planning considerations for co-authoring in OneNote notebooks

  • Software version requirements for co-authoring in SharePoint 2013 and SharePoint Online

  • Co-Authoring in a mixed Office environment

  • Performance and scalability considerations for co-authoring in SharePoint 2013 and SharePoint Online

Co-authoring functionality in SharePoint 2013 and SharePoint Online

In traditional collaboration, documents are shared via email attachments. Tracking versions and edits from multiple authors is difficult and time-consuming for users. Email systems have to contend with storing multiple copies of the same document, not to mention increased network traffic as documents are sent repeatedly.

The use of SharePoint to store documents for collaboration has reduced these problems by providing consistent access to up-to-date versions of documents, the ability to track earlier versions, and centralized management. Storing a single document, instead of many attachments, also reduces network and storage overhead.

But this solution hasn't been perfect. When one author has a document open, other authors can't work on it. If someone forgets to close a document or check it in, other users may be locked out indefinitely, a situation that often requires a call to the IT department.

Co-authoring in SharePoint 2013 addresses these issues by making it possible for multiple users to work on a document, at any time, without interfering with each other's changes. This approach streamlines many common document-collaboration scenarios. For example:

  • Two or more authors work on different parts of a composite document. While one author works on his section of the document, another author can work on hers, without either interrupting the other's work.

  • Several authors work on a composite slide show. Each author can add slides to the presentation and edit them, instead of working in isolation and trying to merge several documents and make them consistent all at the same time.

  • A document is sent out to several experts and stakeholders, each of whom provides some edits or additions. No user's edits are lost, because they are all working on a central, server-stored document.

Understanding the end-user experience of co-authoring in SharePoint 2013 and SharePoint Online

Co-authoring is easy to use from the end user's point of view. When a user wants to work on a document in Word 2013, PowerPoint 2013, OneNote 2013, Visio 2013 or one of the Office Web Apps, he or she merely opens it from SharePoint 2013 or SharePoint Online, as usual. If another user already has the document open, both users can edit the document at the same time. One exception to this is that users can co-author in Excel Web App only if everyone uses the Excel Web App to access the workbook. If anyone uses Excel 2013 or Excel 2010 (the client application) to access the workbook, co-authoring in Excel Web App will be disabled for that workbook while it is open in the client application.

When a user saves a Word 2013, PowerPoint 2013, or Word Web App document, other current users are notified that there are new edits. Those users can refresh their views immediately to see the changes or continue their work and refresh later to see the latest edits. PowerPoint Web App, and Excel Web App auto-save so that users can view any changes automatically. The authors can see one another's work, and everyone knows who is working on the document. SharePoint 2013 and SharePoint Online versioning and tracking tools protect the document so that authors can roll back unwanted changes. When Lync is available, users can see the online status of fellow co-authors and start instant messaging conversations without leaving the document.

In OneNote 2013 and OneNote Web App, shared notebooks enable users to share notes seamlessly. When a user edits a page of the notebook, those edits are automatically synchronized with other users of that notebook so that everybody has a complete set of notes. Edits made by multiple users on the same page appear automatically, which enables near real-time collaboration. Versioning and other shared features in OneNote make it possible for users to roll back edits, show what edits are new, and determine who made a specific edit.

The Excel 2013 client application does not support co-authoring workbooks in SharePoint 2013 or SharePoint Online. But, the Excel client application uses the Shared Workbook feature to support non-real-time co-authoring workbooks that are stored locally or on network (UNC) paths. Co-authoring workbooks in SharePoint is supported by using the Excel Web App, which is included with Office Web Apps. Office Web Apps is available to users through SkyDrive and to business customers who have Office 365, or Office 2013 volume licensing, or Office Web Apps Server and SharePoint 2013. For more information, see Overview of Office Web Apps and how they work on-premises with SharePoint 2013.

Important planning considerations for co-authoring in SharePoint 2013 and SharePoint Online

There are several factors that administrators will want to consider when planning how to use co-authoring in their environment.

Co-authoring functionality in SharePoint is designed to be easy to set up and requires minimal effort to manage. But, there are several things to consider when you set up and manage co-authoring:

  • Permissions - For multiple users to be able to edit the same document, users need edit permissions for the document library where that document is stored. The simplest way to guarantee that this is to give all users access to the SharePoint site where documents are stored. In cases in which only a subset of users should have permission to co-author documents in a particular library, SharePoint permissions can be used to manage access. For more information, see Overview of site permissions in SharePoint 2013.

  • Versioning -SharePoint Server versioning keeps track of changes to documents while they are being edited, and even stores earlier versions for reference. By default, this feature is turned off in SharePoint 2013. SharePoint 2013 supports two kinds of versioning, major and minor. It is best that minor versioning remain off for document libraries that are used for co-authoring in OneNote, because it may interfere with the synchronization and versioning capabilities that are part of the product. This limitation only applies to minor versioning. Major versioning may be used with OneNote. For more information, see How does versioning work in a list or library?.

  • Number of versions - The number of document versions retained affects storage requirements on the server. This number can be tuned in the document library settings to limit the number of versions retained. OneNote notebooks that are frequently updated may result in many versions being stored on the server. To avoid using unnecessary disk space, we recommend that an administrator set the maximum number of versions retained to a reasonable number on document libraries used to store OneNote notebooks. For more information, see Enable and configure versioning for a list or library

  • Versioning period - The versioning period determines how often SharePoint products will create a version of a Word or PowerPoint document that is being co-authored. Setting this period to a low value will capture versions more often, for more detailed version tracking, but may require more server storage. The versioning period does not affect OneNote notebooks. This value can be altered by adjusting the coAuthoringVersionPeriod property on the server. For more information about adjusting this setting, see Configure the co-authoring versioning period in SharePoint 2013.

  • Check out - When a user checks out a document for editing, the document is locked for editing by that user. This prevents co-authoring. Do not enable the Require Check Out feature in document libraries in which co-authoring will be used. By default, Require Check Out is not enabled in SharePoint 2013. Users should not check out documents manually when co-authoring is being used. For more information, see Set up a library to require check-out of files.

Planning considerations for co-authoring in OneNote notebooks

Unlike Word and PowerPoint, OneNote stores version information within the file itself. For this reason, administrators should follow these recommended practices when storing OneNote notebooks in a SharePoint 2013 document library:

  • Do not enable minor versioning. By default, minor versioning is not enabled in SharePoint 2013.

  • If major versioning is enabled, set a reasonable maximum number of versions to store. By default, major versioning is not enabled in SharePoint 2013.

Software version requirements for co-authoring in SharePoint 2013 and SharePoint Online

For users to co-author documents by using Office, those documents must be stored in SharePoint 2013, SharePoint Online or SharePoint 2010. Office 2010 users have the same set of co-authoring features when they open documents from SharePoint 2013 or SharePoint Online as they do when they open documents from a SharePoint 2010 document library.

The following table summarizes the Office application versions that are needed for organizations to take advantage of the co-authoring functionality that are available with SharePoint.

Co-authoring support for Office on each version of SharePoint

Office version | SharePoint 2013 configured to use Office Web Apps Server | SharePoint Online | SharePoint 2010 with Office Web Apps enabled
Excel 2013 | No | No | No
Excel Web App | Yes | Yes | Yes
Excel 2010 | No | No | No
OneNote 2013* | Yes | Yes | Yes
OneNote Web App | Yes | Yes | Yes
OneNote 2010* | Yes | Yes | Yes
PowerPoint 2013* | Yes | Yes | Yes
PowerPoint Web App | Yes | Yes | Yes
PowerPoint 2010* | Yes | Yes | Yes
Word 2013* | Yes | Yes | Yes
Word Web App | Yes | Yes | Yes
Word 2010* | Yes | Yes | Yes
Visio 2013* | Yes | Yes | Yes
Visio Web App | No | No | No
Visio 2010 | No | No | No
Office 2007 client applications | No | No | No
Note:

  • Versions that are denoted by "*" support co-authoring functionality, even when Office Web Apps isn't configured or enabled in SharePoint.

  • The co-authoring functionality is available to Office 2013 users who have SkyDrive accounts, whether or not SharePoint 2013, SharePoint Online or SharePoint 2010 are installed. This article only covers use of co-authoring in SharePoint.

Co-Authoring in a mixed Office environment

Some organizations may want to use co-authoring in an environment in which users have different versions of Office.

Co-authoring in a mixed environment that includes PowerPoint and Word 2007

Users of earlier versions of PowerPoint and Word can share and edit documents that are stored in SharePoint 2013 or SharePoint Online exactly as they could in earlier versions of SharePoint. But they can't use co-authoring to work on them at the same time. To collaborate best in PowerPoint and Word, we recommend that all users work in Office 2013. Users of PowerPoint 2007 and Word 2007 won't experience any significant difference between their current experience and their user experience in SharePoint. For instance, if Office 2007 users open a document that is stored in SharePoint and is currently being edited by another user, they will see a message that the document is being used. They will be unable to edit it. If no other user is editing the document, Office 2007 users will be able to open it as usual. When an Office 2007 user opens a document, the document will be locked. While it is locked, Office 2013 users can't use co-authoring to edit the document. This behavior matches earlier versions of SharePoint.

Document co-authoring is supported between PowerPoint 2010 and PowerPoint 2013 users, and Word 2010 and Word 2013 users. But, PowerPoint 2013 and Word 2013 have some feature improvements that offer users a better co-authoring experience than in earlier versions. For more information, see Co-Authoring in What's new for IT professionals in Office 2013.

Co-authoring in mixed environment that includes OneNote 2007

OneNote 2013 and OneNote 2010 are backward compatible with the OneNote 2007 file format and they support co-authoring with OneNote 2007 users. In mixed environments, notebooks must be saved in the OneNote 2007 file format for OneNote 2007, OneNote 2010, and OneNote 2013 users to work on it together. But, by upgrading to the OneNote 2013 file format, users gain several key features, such as compatibility with the OneNote Web App. That allows users who don't have any version of OneNote installed to edit and co-author notebooks.

OneNote 2013 includes the ability to upgrade OneNote 2007 files to OneNote 2013 files at any time. This provides an easy upgrade path for organizations that are moving from a mixed environment to a unified environment on Office 2013. For more information, see Upgrading to Microsoft OneNote 2013 from a previous version.

Performance and scalability considerations for co-authoring in SharePoint 2013 and SharePoint Online

SharePoint 2013 and Office 2013 applications minimize the performance and scalability impact that is associated with co-authoring in your environment. Office clients do not send or download co-authoring information from the server until more than one author is editing. When a single user is editing a document, the performance impact resembles that of earlier versions of SharePoint.

Office clients are configured to reduce server impact by reducing the frequency of synchronization actions that are related to co-authoring when the server is under heavy load, or when a user is not actively editing the document. This helps reduce overall performance impact.

See also

Co-authoring administration in SharePoint 2013
Plan document versioning, content approval, and check-out controls in SharePoint 2013


Configure versioning for co-authoring in SharePoint 2013
See also

Published: January 8, 2013

Summary: Learn how to configure SharePoint document library versioning settings to support co-authoring.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

Audience: IT Professionals

Document library versioning is the method by which successive iterations of a document are numbered and saved. By default, versioning is disabled in SharePoint 2013 document libraries . We recommend that you enable this feature for document libraries in which users plan to co-author documents or presentations in Word 2010, Word 2013, Word Web App, PowerPoint 2010, PowerPoint 2013, or PowerPoint Web App.

In this article:

  • Before you begin

  • Configure versioning for co-authoring in SharePoint 2013

  • Configure Require Check Out in SharePoint 2013

Before you begin

Before you configure versioning for co-authoring, review Overview of co-authoring in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure versioning for co-authoring in SharePoint 2013

SharePoint versioning helps protect documents and prevent data loss by allowing authors to roll back to a previous document version when the current version contains unwanted changes.

Do not enable minor versioning in document libraries that contain OneNote notebooks. Minor versioning can result in synchronization errors that prevent edits from being saved.

When multiple authors work on the same document, edits are retained on the server as document versions. To limit server storage usage, you can limit the number of retained versions. If you enable major versioning in a document library that contains OneNote notebooks, we recommend that you specify the maximum number of versions so you can use disk space more efficiently.

To enable versioning

  1. Browse to the document library that you want to configure.

  2. In the toolbar, on the LIBRARY tab, in the Settings group, choose Library Settings.

  3. In General Settings, choose Versioning settings.

  4. In Document Version History, select Create major versions.

  5. To specify a version retention limit, select Keep the following number of major versions and in the text box, type the number of versions.

Configure Require Check Out in SharePoint 2013

When a document is checked out of a document library, the document is locked. This makes it unavailable for co-authoring. Therefore, the Require Check Out setting should not be enabled in document libraries that are used for co-authoring. By default, for SharePoint 2013 document libraries, this setting is not enabled.

To disable Require Check Out

  1. Browse to the document library that you want to configure.

  2. In the toolbar, on the LIBRARY tab, in the Settings group, choose Library Settings.

  3. In General Settings, choose Versioning settings.

  4. In Require Check Out, select No (default).

See also

Overview of co-authoring in SharePoint 2013
Configure the co-authoring versioning period in SharePoint 2013


Configure the co-authoring versioning period in SharePoint 2013
See also

Published: January 8, 2013

Summary: Learn how to specify how often SharePoint 2013 stores a version of a document that is being edited.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

Audience: IT Professionals

The CoauthoringVersionPeriod property specifies, in minutes, how often SharePoint stores a version of a document that is being edited. This article describes how to use Windows PowerShell to configure the CoauthoringVersionPeriod property. For more information about document library versioning, see Configure versioning for co-authoring in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure the co-authoring versioning period in SharePoint 2013

When versioning is turned on, SharePoint 2013 takes periodic snapshots of documents, saving them for later reference. This information can provide an edit trail that may be useful for seeing who changed a document, rolling back to an earlier version, or for compliance reasons.

You can configure the CoauthoringVersionPeriod property by using the Windows PowerShell. If the value is set to 0, SharePoint 2013 captures every change made by a new user in a different version of the document. If the value is set to a very large number, SharePoint 2013 creates one version for the whole editing session. This latter behavior matches the behavior of files that are not co-authored and files that were created in earlier versions of SharePoint Server or SharePoint Foundation.

To configure the co-authoring versioning period by using Windows PowerShell (save as script and run script)

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Paste the following code into a text editor, such as Notepad:

    Copy code
    $siteurl ="<ServerName>"
$mysite=new-object Microsoft.SharePoint.SPSite($siteurl)
$mysite.WebApplication.WebService.CoauthoringVersionPeriod = <Time>
$mysite.WebApplication.WebService.Update()

  3. Specify the following parameters:

    Parameters to configure the co-authoring versioning period

    Parameter Value

    ServerName

    Server name

    Time

    Number in minutes

  4. Save the file and add the .ps1 extension, such as SuggestedNameOfFile.ps1.

    Note:

    You can use a different file name, but you must save the file as an ANSI-encoded text file whose extension is .ps1.

  5. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, choose All Programs, choose Microsoft SharePoint 2013 Products, and then choose SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • Swipe in from the edge of the screen to show the charms and then choose Search to see all the applications that are installed on the computer.

      • Choose (right-click) SharePoint 2013 Management Shell to display the app bar.

      • In the app bar, choose Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  6. Change to the directory to which you saved the file.

  7. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ./SuggestedFileName.ps1

See also

Configure versioning for co-authoring in SharePoint 2013
Overview of co-authoring in SharePoint 2013


Configure the maximum number of co-authoring authors in SharePoint 2013
See also

Published: January 8, 2013

Summary: Learn how to limit the number of users who can co-author a Word document or PowerPoint presentation at the same time.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

Audience: IT Professionals

The CoauthoringMaxAuthors property lets you specify the maximum number of users who can co-author a Word document or PowerPoint presentation at the same time in SharePoint 2013. This article describes how to configure the CoauthoringMaxAuthors property by using Windows PowerShell.

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure the maximum number of co-authoring authors for SharePoint 2013

You can limit the number of users who can co-author a document at the same time by setting the CoauthoringMaxAuthors property. This property only applies to Word 2010, Word 2013, Word Web App, PowerPoint 2010, PowerPoint 2013 and PowerPoint Web App documents. There is no upper limit to the number of users who can co-author OneNote notebooks.

To configure the maximum number of co-authoring users for Word documents and PowerPoint presentations by using Windows PowerShell (save as script and run script)

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Paste the following code into a text editor, such as Notepad:

    Copy code
    $siteurl = "<ServerName>"
$mysite=new-object Microsoft.SharePoint.SPSite($siteurl)
$mysite.WebApplication.WebService.CoauthoringMaxAuthors = <MaxAuthors>
$mysite.WebApplication.WebService.Update()

  3. Replace:

    • <ServerName> with the name of the server.

    • <MaxAuthors> with the maximum number of authors to allow.

  4. Save the file and add the .ps1 extension, such as SuggestedNameOfFile.ps1.

    Note:

    You can use a different file name, but you must save the file as an ANSI-encoded text file whose extension is .ps1.

  5. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, choose All Programs, choose Microsoft SharePoint 2013 Products, and then choose SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • Swipe in from the edge of the screen to show the charms and then choose Search to see all the applications that are installed on the computer.

      • Choose (right-click) SharePoint 2013 Management Shell to display the app bar.

      • In the app bar, choose Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  6. Change to the directory to which you saved the file.

  7. At the Windows PowerShell command prompt, type the following command: ./SuggestedFileName.ps1

See also

Overview of co-authoring in SharePoint 2013


Disable co-authoring in SharePoint 2013
See also

Published: January 8, 2013

Summary: Learn how to disable co-authoring functionality in SharePoint 2013 by using Group Policy or by using Windows PowerShell.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

Audience: IT Professionals

Co-authoring in SharePoint 2013 makes it possible for multiple users to work on a document, at any time, without interfering with each other's changes. Although we have engineered co-authoring to be scalable and efficient, some organizations that have hardware limitations may want to turn off co-authoring to minimize any additional effects on server performance.

This article describes how to disable co-authoring functionality in SharePoint 2013 by using Group Policy or by using Windows PowerShell 3.0.

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Disable co-authoring in SharePoint 2013

There are three ways to disable co-authoring:

  • You can use Group Policy to disable co-authoring functionality on the client-side. For more information, see Group Policy overview for Office 2013.

  • You can use Windows PowerShell to set the DisableCoauthoring server property. This disables the co-authoring property for Word and PowerPoint documents on the server. This property applies to documents or presentations that are authored in Word 2010, Word 2013, Word Web App, PowerPoint 2010, PowerPoint 2013 and PowerPoint Web App.

  • You can enable the Require Check Out setting in a document library. This disables co-authoring in the document library. For more information, see Configure Require Check Out in SharePoint 2013.

Procedures in this task:

  • To disable co-authoring by using Group Policy

  • To disable co-authoring for Word documents and PowerPoint presentations at the web service level by using Windows PowerShell (save as script and run script)

  • To disable co-authoring for Word documents and PowerPoint presentations at the web application level by using Windows PowerShell (save as script and run script)

To disable co-authoring by using Group Policy

  1. Start Group Policy Management.

    • For Windows Server 2008 R2:

      • On the server, choose Start, choose Administrative Controls, and then choose Group Policy Management.

    • For Windows Server 2012:

      • Swipe in from the edge of the screen to show the charms and then choose Search to see all the applications that are installed on the computer.

      • Choose Group Policy Management.

      For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. In Group Policy Management, expand the Forest and Domain nodes for the domain where you want to set the policy, and then expand Group Policy Objects.

  3. Choose (right-click) the Group Policy Object where your co-authoring settings are configured, and then choose Edit.

  4. For Word 2013, expand User Configuration, Administrative Templates, Microsoft Word 2013, Collaboration Settings, Co-authoring, and then open (double-click) Prevent Co-authoring.

    For PowerPoint 2013, expand User Configuration, Administrative Templates, Microsoft PowerPoint 2013, Collaboration Settings, Co-authoring, and then choose Prevent Co-authoring.

  5. In the Prevent Co-authoring Properties dialog box, select Enabled, and then choose OK.

To disable co-authoring for Word documents and PowerPoint presentations at the web service level by using Windows PowerShell (save as script and run script)

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Paste the following code into a text editor, such as Notepad:

    Copy code
    $siteurl = "<servername>"
$mysite=new-object Microsoft.SharePoint.SPSite($siteurl)
$mysite.WebApplication.WebService.DisableCoauthoring = $true;
$mysite.WebApplication.WebService.Update();

  3. Specify the following parameter:

    Parameter Value

    servername

    Server name

  4. Save the file and add the .ps1 extension, such as SuggestedNameOfFile.ps1.

    Note:

    You can use a different file name, but you must save the file as an ANSI-encoded text file whose extension is .ps1.

  5. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, choose All Programs, choose Microsoft SharePoint 2013 Products, and then choose SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • Swipe in from the edge of the screen to show the charms and then choose Search to see all the applications that are installed on the computer.

      • Choose (right-click) SharePoint 2013 Management Shell to display the app bar.

      • In the app bar, choose Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  6. Change to the directory to which you saved the file.

  7. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ./SuggestedFileName.ps1

To disable co-authoring for Word documents and PowerPoint presentations at the web application level by using Windows PowerShell (save as script and run script)

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Paste the following code into a text editor, such as Notepad:

    Copy code
    $siteurl = "<servername>"
$mysite=new-object Microsoft.SharePoint.SPSite($siteurl)
$mysite.WebApplication.DisableCoauthoring = $true;
$mysite.WebApplication.Update();

  3. Specify the following parameter:

    Parameter Value

    servername

    Server name

  4. Save the file and add the .ps1 extension, such as SuggestedNameOfFile.ps1.

    Note:

    You can use a different file name, but you must save the file as an ANSI-encoded text file whose extension is .ps1.

  5. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, choose All Programs, choose Microsoft SharePoint 2013 Products, and then choose SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • Swipe in from the edge of the screen to show the charms and then choose Search to see all the applications that are installed on the computer.

      • Choose (right-click) SharePoint 2013 Management Shell to display the app bar.

      • In the app bar, choose Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  6. Change to the directory to which you saved the file.

  7. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ./SuggestedFileName.ps1

See also

Overview of co-authoring in SharePoint 2013
Co-authoring administration in SharePoint 2013


Digital asset library planning in SharePoint Server 2013

Published: December 18, 2012

Summary: Use these TechNet articles and related resources to plan for digital asset libraries in SharePoint Server 2013.

Applies to: SharePoint Server 2013

SharePoint Server 2013 provides an asset library, which lets you store and manage digital assets such as images, audio, video, and other reusable content fragments from many applications. Content types that are designed specifically for audio and video assets support the storage and playback of those assets in Web Parts and Web Part pages, and the HTML5 player is integrated with the user interface to enhance the media playback experience for users. Use the articles in this section to guide you in planning the management of digital assets in a solution that is based on SharePoint Server 2013.

TechNet articles about digital asset library planning

The following articles about digital asset library planning are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
SharePoint logo | Overview of managing digital assets in SharePoint Server 2013 | Describes managing digital assets, details the users of a digital asset library, outlines key functionality for managing digital assets in SharePoint Server 2013, and summarizes potential scenarios for managing digital assets.
 | Plan digital asset libraries in SharePoint Server 2013 | Covers the planning process for managing digital assets. This process includes steps for planning for asset libraries and describes tasks associated with planning various aspects of a digital asset solution, such as storage and performance, permissions and security, metadata and Search, Web Parts, views and filters, and client support.
 | Plan digital asset library topology and architecture in SharePoint Server 2013 | Discusses logical architecture and topology decisions that are related to deploying digital asset libraries.

Additional resources about digital asset library planning

The following resources about digital asset library planning are available from other subject matter experts.

Content Description

TechNet logo

  • Resource Center: Enterprise Content Management in SharePoint Server 2010

Visit the Resource Center to access videos, community sites, documentation, and more.


Overview of managing digital assets in SharePoint Server 2013
See also

Published: December 18, 2012

Summary: Learn about the asset library and how you can use it to store and share image, audio, or video files.

Applies to: SharePoint Server 2013

This article describes digital assets (also known as rich media) and defines key terms that are used in relation to managing digital assets in SharePoint Server 2013. It also explains aspects of managing digital assets by using the assets library in SharePoint Server 2013, describes the primary users of an asset library, and outlines common scenarios for using the asset library in SharePoint Server 2013.

For more information about how to plan a solution for managing digital assets, see Plan digital asset libraries in SharePoint Server 2013.

Increasing numbers of office workers create or reuse images and other rich media assets as part of their daily tasks. Often, however, no centralized repository exists at the departmental or enterprise level that is optimized for storing these assets. A centralized repository lets users easily discover and reuse rich media assets that others have already created. The asset library in SharePoint Server 2013 can save an organization time and other resources by providing a specialized repository for storing and managing digital assets. Users no longer have to look for assets in multiple locations over the network, or re-create assets from scratch. By using a centralized repository for managing digital assets, the organization also exerts tighter control over brand-sensitive content and can make sure that only approved assets for products are made available to the appropriate users.

In this article:

  • About managing digital assets

  • Users of an asset library

  • Managing digital assets in SharePoint Server 2013

  • Scenarios for using the asset library

About managing digital assets

A digital asset is an image, audio, or video file, or other reusable rich content fragment that an organization uses in applications across the enterprise. The asset library in SharePoint Server 2013 enables users to easily create, discover, and reuse existing digital assets within the organization.

In SharePoint Server 2013 you use an asset library to store and share digital assets with users. The asset library is a SharePoint Server 2013 library template that is customized to use content types designed specifically for storing and cataloging rich media assets.

An effective solution for managing digital assets specifies the following:

  • The metadata to provide for each kind of asset.

  • The amount of storage space that is required for the assets, and the performance issues to consider for serving the assets to users.

  • Where to store assets at each stage of the life cycle of an asset.

  • How to control access to an asset at each stage of its life cycle.

  • How to move assets within the organization as team members contribute to creation, review, approval, publication, and disposition of assets.

  • Which policies to apply to assets so that asset-related actions are audited, assets are retained or disposed of correctly, and assets that are important to the organization are protected.

  • How assets are treated as corporate records, which must be retained according to requirements and corporate guidelines.

For information about how to plan a digital asset solution by using SharePoint Server 2013, see Plan digital asset libraries in SharePoint Server 2013.

Users of an asset library

Users of an asset library in SharePoint Server 2013 generally fall into one of the following three categories:

  • Asset creators. This includes people who create individual assets, such as graphic artists, video producers, or marketing copywriters, and who submit assets to the asset library. For example, a graphic artist might create a product logo in multiple resolutions and sizes, and in both color and black and white, and then upload all versions of the logo to the asset library for use by other members of a product marketing team.

  • Asset managers. This includes people who manage the assets in the library. They are in charge of the end-to-end workflow from the time that an asset is first submitted, through publication, to the time when an asset expires. They are also in charge of managing and organizing assets in the library. For example, an asset manager might take multiple versions of a product logo and categorize them appropriately in the library, add important metadata such as keywords, and set a date after which the asset cannot be used.

  • Asset consumers. This includes people who have to find and use assets from the library to create other work products. For example, web designers can use a product logo from the asset library when they create marketing pages for product websites.

Depending on the scenario, there can be crossover between these users. For example, users who have permission to upload assets to the library may also have permission to categorize and manage the assets they submit to the archive. Asset creators can also be asset consumers if they look for and use assets that are added to other work products, which in turn are uploaded as separate assets. For example, a video producer might use a product logo while making a marketing video for a product, and then upload the video to the library as a separate asset.

Managing digital assets in SharePoint Server 2013

SharePoint Server 2013 provides a library template named Asset Library that is customized to use new image, audio, and video content types designed specifically for storing and cataloging rich media assets. These new content types use new column types such as Preview, Picture Size, Date Picture Taken, and Length (seconds) that contribute to the metadata for a particular asset. The asset library also has a preview mode that displays a thumbnail and some of this metadata when you rest the pointer over an asset. Enterprise keywords can be assigned to assets to make them more easily discovered by searching. Keywords can be assigned by an asset creator when a new asset is uploaded, or keywords can be added later by an asset manager. Users can rate assets, a capability that provides additional metadata for assets. The metadata can then be used when assets are displayed in a Web Part. For example, if you have a library of training videos that users have viewed and rated, you can use a Web Part to display the top-rated videos on a web page.

Asset creators and asset managers work directly in the asset library to upload, categorize, and manage assets. Asset consumers can browse the library to find assets for inserting into projects in other applications. Asset consumers can browse an asset library from Office applications and insert an asset into the open application, such as Word or PowerPoint.

You can display digital assets to users in SharePoint Server 2013 in the following ways:

  • Allow users to browse the asset library.

  • Insert a Web Part into a web page on a team site.

  • Use the video field control on a publishing page on a publishing site.

  • Use the Content Query Web Part.

The specific methods that you use to display assets to users of the asset library will vary depending on who the users are, how they have to use assets from the library, and which methods for displaying assets are most appropriate for a scenario.

In addition to the features that are part of the asset library, you can take advantage of SharePoint Server features such as workflows, routing, rules, and policies. These features help manage the assets as they come into the asset library, track the progress of assets, automate publication of assets on approval, and set the expiration for assets.

Scenarios for using the asset library

Users with Edit permissions can add an asset library to any SharePoint Server 2013 site collection or site. The following table describes possible scenarios in which you might use a digital asset library.

Scenario | Description
Corporate brand library | The asset library stores branded corporate assets such as logos, artwork, and other digital assets, and workflows and policies help manage the content. Creative teams can submit digital assets to the asset library where they are reviewed and published. Content stewards manage and edit the digital assets to make sure that they are correctly tagged and organized. Information workers and extranet partners who want corporate logos or brand assets use the library to find the content they require.
Divisional portal | The asset library is a repository for images and rich media files for a single portal site. In this scenario, any contributor or designer can upload logos and images to the library for other people to view and use. The content is typically managed by contributors, and there is minimal workflow or policy associated with adding and managing content. For example, the divisional portal library might have multiple contributors but only a few approvers. Authors and web designers of the site use content in the library by viewing, downloading, and inserting it into their work products, such as documents or presentations.
Team site | Similar to a divisional portal but smaller. The asset library is a repository for images and rich media for a single team site. In this scenario, any team member can upload assets to the library for other team members to view and use. The content is managed as necessary by contributors, and there is minimal workflow or policy. Team members use content in the library by viewing, downloading, and inserting it into their work products, such as documents or presentations.
Corporate archive | The asset library stores pictures, video, documents, and other assets that have historical value to the organization. Users can submit current and past items, which are collected, scanned, organized, and tagged by curators who manage the library so that other users can browse, search, and view archived content.
Divisional media sharing site | The asset library stores audio and video files. In this scenario, anyone can contribute to the library, and there is minimal or no management of items in the library. Ratings are enabled for the library, and are combined with social tagging of assets to drive the structure and presentation of assets within the library.

See also

Plan digital asset libraries in SharePoint Server 2013

Resource Center: Enterprise Content Management in SharePoint Server 2010


Plan digital asset libraries in SharePoint Server 2013
See also

Published: December 18, 2012

Summary: Learn how to plan storage and performance, permissions and security, metadata and search, Web Parts, views and filters, and client support.

Applies to: SharePoint Server 2013

The SharePoint Server 2013 asset library is a special kind of document library. It is a collection of media files — such as image, audio, and video files — that is shared with other site users.

For information about how to manage digital assets, see Overview of managing digital assets in SharePoint Server 2013.

In this article:

  • Asset library overview

  • Plan for asset libraries

  • Plan for permissions and security

  • Plan for storage and performance

  • Plan for metadata and Search

  • Plan for video thumbnails

  • Plan for Web Parts and web pages

  • Plan for client support

Asset library overview

Asset libraries are collections of media files on SharePoint Server 2013 that you share with other site users. As part of planning for managing digital assets, you must decide which kind of asset library best fits the needs of the organization. Because the asset library is a SharePoint Server library with specialized content types for digital assets, you use many of the same methods that you use to plan a document management solution.

You can use an asset library in the following two ways:

  • As a general document library for digital assets at the team level. The asset library stores images, audio, and video files for use by a team. A site owner might give everyone on the team permissions to upload, organize and manage assets, or you might restrict the task of organizing and managing assets to a small subset of people on the team.

    Note:

    SharePoint Server 2013 does not support live streaming of audio or video content.

  • As a centralized repository for digital assets for the organization. In this situation, you use content approval and workflow for all assets that are added to the library. People who have different roles might be responsible for separate stages of the approval process. For example, graphic designers and audio or video producers could upload assets to the library. But a content manager might be responsible for triaging incoming assets, assigning additional metadata to the assets, and approving them for publication.

For more information about scenarios in which you might use a digital asset library, see the Scenarios for using the asset library section in Overview of managing digital assets in SharePoint Server 2013.

Plan for asset libraries

Planning the asset libraries for a digital asset solution consists of the following major steps:

  1. Identify roles for managing digital assets

  2. Analyze asset usage

  3. Plan organization of asset libraries

  4. Plan content types

  5. Plan content governance for digital assets

  6. Plan workflows

  7. Plan policies

  8. Other uses for an asset library

Identify roles for managing digital assets

The first step in planning a digital asset library is to determine the participants and stakeholders for the solution. Find out who creates digital assets in the organization, what kinds of assets they create, who manages the assets, and who maintains the servers on which the assets are stored. For more information and for a worksheet to record the data that you collect, see Identify users and analyze document usage in SharePoint 2013.

Analyze asset usage

After you identify who works on assets, determine the kinds of assets they work on, and how they use the assets. This helps you determine how to structure the asset libraries, how many libraries are required, which content types to use for the assets, and which information management policies to apply to the asset libraries. Because the size of most digital assets is much larger than standard documents, you must also plan for storage capacity. For more information and for a worksheet to record the data that you collect, see Identify users and analyze document usage in SharePoint 2013.

Plan organization of asset libraries

As you plan the asset libraries, you decide where you should create them, how they must be used, how many are needed, and how to organize them. You use the same methods to plan asset libraries as you do to plan document libraries. This section describes the following steps for planning asset libraries:

  • Determine how many asset libraries are needed

  • Decide where you want to create each asset library

  • Choose a fixed or collaborative library

  • Decide how to organize the asset library

Determine how many asset libraries are needed. This determination, as in the earlier analysis and planning steps, also depends on how the asset library will be used. For example, if you have individual teams that must use asset libraries for collaboration, and who must use content governance such as versioning while they work on assets, you can create an asset library for each team site. You can then let the teams manage their own assets. If you want the asset library to serve as a large-scale centralized repository that is used by many teams, you might create a single asset library. Then, you can adjust the permissions to manage how people use, manage, and search the library. For more information, see Plan document libraries in SharePoint 2013.

Note:

If you enable the disk-based cache for a web application, every site collection within that web application will use the cache. If you do not have to have the disk-based cache for most the sites, consider putting in a separate web application only those site collections that contain an asset library that requires the disk-based cache.

Decide where you want to create each asset library. Where you create the asset library depends on how you plan to use it. For an asset library that will be used at the team level, you might create the asset library at the site level. For a centralized repository, you might create the asset library at the site collection level. If the asset library will be used with a web publishing site, put the library in the same site collection as the publishing site so that asset files that are used by publishing pages are available to the publishing site. Use your asset analysis to determine who creates and uses assets, and how those assets are used. This will help you decide where asset libraries are needed in the enterprise.

Choose a fixed or collaborative library. Depending on the scenario, the asset library will be either a fixed library or a collaborative environment. In a fixed library, completed assets are checked in and the library is read-only. In a collaborative environment, versioning is enabled for the library, and users who have appropriate permissions can both read and write to existing assets.

Decide how to organize the asset library. You can plan to store all assets in the root of the asset library, and use custom views to display assets to library users based on certain criteria. You can also use folders to hold assets based on criteria that you specify. For example, you might put video files in one folder and audio files in another. Or, you might create folders based on products and put all assets related to a particular product into the product folder. Refer to your asset analysis to determine the most common scenarios for how assets are used in your organization.

Plan content types

The content types included in an asset library are image, audio, and video. You can either use these content types or create custom content types that are derived from them, depending on the classification needs of your organization. For example, you might create two separate content types for posters and product logos, and derive the base characteristics for those new content types from the image content type. This arrangement lets you associate separate properties for the two new content types, specify different workflows, or set different information management policies based on the content types. For more information, see Plan content types and workflows in SharePoint 2013.

Plan content governance for digital assets

You plan the appropriate degree of control for each content type and storage location for digital assets. For example, if the asset library is a collaborative solution, you can use versioning to store successive iterations of assets in the library, and can require users to check assets in and out before working on assets. You can also specify an approval process by which assets must be approved before they can be made available to an audience. For more information, see Plan document versioning, content approval, and check-out controls in SharePoint 2013.

Plan workflows

You use workflows to perform management tasks on assets in the asset library in the same manner as you use workflows in a document library. Important considerations include the following:

  • Do assets have to be reviewed and approved before they can be used by asset consumers?

  • Who is responsible for managing the expiration of assets?

  • Are assets retained or deleted after expiration?

For more information, see Plan content types and workflows in SharePoint 2013.

Plan policies

For each content type that you want to use in the asset library, you must plan the information management policies that specify how assets are audited, retained, and labeled. For more information, see Plan for information management policy in SharePoint Server 2013.

Important:

SharePoint Server 2013 does not automatically apply Information Rights Management (IRM) protection to audio or video content that is stored in a SharePoint Server 2013 asset library. Additionally, when audio or video assets stored in SharePoint Server 2013 are viewed by a user, copies of those assets might be stored in the user's local browser cache. The SharePoint Server 2013 media player supports playing IRM-protected audio and video formats where the Digital Rights Management protection was applied by an external IRM provider that is supported by Silverlight 3 or later versions. For more information, see Digital Rights Management (DRM) (http://go.microsoft.com/fwlink/p/?LinkId=154933).

Other uses for an asset library

The following table lists additional uses for an asset library in SharePoint Server 2013.

Feature Description

Podcasts

Users can enter the URL for the library RSS feed into their podcast application to receive updates when new audio and video files are added to the asset library. For more information about how to upload audio and video files, see Set up an Asset Library to store image, audio, or video files.

Suggested Content Browser Locations

When you are using a publishing site, the URL for an asset library in a separate site can be added to the Suggested Content Browser Locations list for the publishing site. This lets content creators access the asset library when they insert assets into web pages within SharePoint Server 2013, or within Office 2013 applications, such as Word.

Content Organizer

When you are using an asset library as a centralized repository, consider using the Content Organizer site feature to automate the routing of assets that are uploaded to the library by users. When the Content Organizer site feature is activated, a new library named Drop Off Library is automatically created. This lets you create rules that specify how assets added to this library are routed to other libraries, such as the asset library. For example, you can specify that all audio assets are stored in one folder of the asset library, whereas all video assets are stored in another folder.

An advantage to using the Content Organizer is that certain metadata fields can be required to receive user input when new assets are added. This helps control how different types of assets are routed. In addition, this can automate some of the content management work and reduce the workload of administering the asset library and managing the assets it contains. For more information, see Configure the Content Organizer to route documents

Published links

Members of the Administrators group on the local computer can add links to SharePoint sites and lists from client applications in the Office 2013 suites such as Word, Excel, and PowerPoint. These links appear on the My SharePoint Sites tab of the Open, Save, and Save As dialog boxes when you open and save documents from these applications. Users can manually add links to their published link lists by browsing to a library and clicking Connect to Office. For more information, see Add or delete links to Office client applications (SharePoint Server 2010).

Plan for permissions and security

Planning for permissions and security in an asset library is the same as planning for permissions and security in a document library. For information about the available default groups, permission levels, and when to use custom groups or levels, see Determine permission levels and groups in SharePoint 2013.

Plan for storage and performance

Because an asset library is a specialized kind of document library, determining storage requirements for digital assets resembles determining storage requirements for documents. The primary difference is that asset libraries typically contain fewer assets than document libraries contain. But the assets in an asset library are larger than those in a document library. When you plan for storage, analyze the content to determine how many assets will be stored in the asset library, and the average size of those assets. For example, if you have 50,000 assets and the average file size is 10 megabytes (MB), you must have at least 500 gigabytes (GB) of storage on the database server. If you will be using the asset library to store video files, you must determine the average size of those files. By default, the maximum video file upload size is 250 MB. If you know that you have to support larger video files, you can increase the file upload size up to 2 GB for every web application by using Central Administration. If you will be using the disk-based binary large object (BLOB) cache, you must also make sure that the front-end web server has sufficient disk space in which to store the cached files.

Depending on the type of digital asset files that will be stored in the asset library, you should enable the disk-based BLOB cache and Bit Rate Throttling to provide better performance for users. It is usually a good idea to enable the disk-based BLOB cache. When the BLOB cache is enabled, it stores specified file types on the front-end web server to reduce the load put on the database server when those files are requested and served to users.

The video renditions feature lets users upload multiple renditions of a video. The video renditions can have different codecs and formats, or different bit rates. A user can choose the rendition to play. By default, the video with the lowest bit rate is chosen.

If you will be using the asset library to serve audio and video files to users, we recommend that you always enable the BLOB cache, and that you enable Bit Rate Throttling on the server. Bit Rate Throttling controls the rate at which audio and video files are downloaded to the client so that overall performance on the site is not affected. For more information about the disk-based cache, see Plan for caching and performance (SharePoint Server 2010). For information about how to enable and configure Bit Rate Throttling, see Bit Rate Throttling Readme (http://go.microsoft.com/fwlink/p/?LinkId=154962).

Plan for metadata and Search

The addition of metadata that helps describe the type and content of a digital asset greatly improves the discoverability of content in an asset library. When you plan an asset library, remember that rich media files are not automatically searchable because they do not contain text that a search engine can index. The metadata that is used to describe digital assets can include information such as the title, description, author, copyright, and enterprise keywords that provide additional details about the asset. Some metadata, such as the size and dimensions of an image, is entered automatically when the asset is uploaded to the asset library. Other metadata is added manually. For example, an asset creator might add a text description of an image when the asset is uploaded. Or, a library manager might add keywords and update approval status during triage of incoming assets or performance of administrative task.

SharePoint Server 2013 includes many improvements for video search. Users can use the Search Navigation Web Part to filter the search results to display only video results. The video search results page shows a thumbnail for each video. Users can click the thumbnail to go to the video player page or pause on the thumbnail to view additional information such as who uploaded the video, when it was uploaded, number of views, and so on. The video search results page also provides video-specific search refiners. Users can refine the search results by length of video, people in the video, and upload date.

Plan for video thumbnails

Thumbnail preview images are created automatically when a video is uploaded to an asset library. Content authors can also choose a frame from the video or upload a picture and use that as the thumbnail preview image. For automatic thumbnail creation to work, you must install the Desktop Experience feature on the front-end web server that hosts SharePoint Server 2013. For more information, see Desktop Experience Overview.

Plan for Web Parts and web pages

SharePoint Server 2013 has many Web Parts and field controls that take advantage of the content types in an asset library. Web Parts are added to web zones in Web Part pages by content owners. Field controls are added to publishing pages by site developers and designers. Examples of Web Parts and field controls that are used to display digital assets include the following:

  • Media Web Part and field control. Used to display embedded video in a web page.

  • Image Web Part and field control. Used to display images on a web page.

  • Content Query Web Part. Used to display items from all sites in a site collection, a selected site or subsite, or a specific list or library. The query can be configured to return a list of items based on list and content types, and can be filtered and targeted to a specific audience.

  • Content Search Web Part. Used to display content that was crawled and added to the search index. You can configure the Web Part and choose the video content type from the query builder.

When you design web pages for sites, consider which fields to expose to users in web pages and Web Parts to help users find the assets they need. You can customize the information that is displayed when a user rests the pointer on an asset in the asset library by editing the Thumbnail view in the Library Settings page. For more information about Web Parts and field controls, see Understanding Field Controls and Web Parts in SharePoint Server 2007 Publishing Sites.

Plan for client support

SharePoint Server 2013 supports HTML5 and Silverlight media players. The HTML5 media player is the default media player that is used to play all video files that are compatible with the HTML5 <video> element implementation for the current browser. SharePoint Server 2013 selects the player automatically, depending on the video format. If the video format cannot be played on the HTML 5 media player, the system uses the Silverlight media player.

To use the Silverlight media player, Silverlight 3, or later versions, must be installed on the client computers. For more information about Silverlight 3, see Silverlight Overview (http://go.microsoft.com/fwlink/p/?LinkId=154002).

For more information about the media formats that are supported by Silverlight media players, see Supported Media Formats, Protocols, and Log Fields.

See also

Overview of managing digital assets in SharePoint Server 2013

Resource Center: Enterprise Content Management in SharePoint Server 2010


Plan digital asset library topology and architecture in SharePoint Server 2013
See also

Published: December 18, 2012

Summary: Learn about logical architecture and topology decisions that are related to deploying digital asset libraries.

Applies to: SharePoint Server 2013

The SharePoint Server 2013 asset library, which is a kind of document library, is a collection of media files — such as image, audio, and video files — that are shared with other site users. Because the asset library is a SharePoint Server library with specialized content types for digital assets, the overall architecture and topology is minimally affected. The considerations that can potentially influence logical architecture and topology decisions include the following:

  • Where to locate digital asset libraries in the overall site structure.

  • What to do with content databases that store digital assets.

  • Whether to optimize a server farm with a binary large object (BLOB) cache or with Bit Rate Throttling.

  • Whether to scale out a server farm with dedicated databases or server hardware for digital assets.

In this article:

  • Logical architecture for managing digital assets

  • Components of a digital asset library topology

  • Typical digital asset library topology

  • Scaling topologies for digital asset libraries

Logical architecture for managing digital assets

The essential tool for managing digital assets in SharePoint Server 2013 is the asset library. Users with Edit permissions can add the asset library to any site. If you will be storing a large total volume of data, such as thousands to tens of thousands of files in an asset library, or audio or video files that in total require hundreds of gigabytes of storage space, you must carefully plan the location in which the asset library is created and the content databases in which assets will be stored.

For example, if you have a collaboration site in which multiple individual teams each have their own sites but have to use a shared media set, you might create an asset library at the top-level site to store the assets that will be used by the individual teams. In this scenario, the content database is shared by all sites within the site collection so that the quantity and size of the files that are stored in the asset library might be significantly smaller than in Example 2.

Example 1 illustrates a logical architecture for when an asset library is located at the root of a site collection and shares a content database that has other sites in the site collection.

Single site collection

Example 2 illustrates a large corporate training site that contains training videos used by internal employees. In this scenario, you might locate the asset library in the top-level site of a site collection that uses its own content database, and that has no other sites under it in the site hierarchy. By doing this, you can ensure that there is sufficient storage space for the files that will be uploaded to the asset library. This also lets you plan for future expansion, because the content database is already isolated and does not share content with any other sites in your solution.

Two separate site collections

The following table summarizes these two approaches. (Note that you can implement a combination of these two approaches.)

Area Single site collection Separate site collection

Description

A digital asset library is contained within the same site collection as other content. Multiple digital asset libraries can be created within the site structure.

A separate site collection is deployed to host a digital asset library.

Usage

Teams can add digital asset libraries to their team sites or use the library contained at the top-level site.

Teams add and use media files from the centrally managed digital asset library.

Note:

When using a publishing site, the URL for an asset library in a separate site can be added to the Suggested Content Browser Locations list for the publishing site. This will enable content creators to access the asset library when they insert assets into web pages within SharePoint Server 2013, or within Office 2013 suite applications, such as Word.

Management

Teams manage their own libraries. Media files are managed in the same manner as all other content in the site collection.

Because media files are located in a separate database, this content can be managed separately according to a different service level agreement.

Performance and capacity

A large total volume of media files can affect the overall performance of sites. If site collections approach or exceed database size limits, it is more difficult to scale out the overall server farm.

Because media files are located in a separate database, the database can be scaled out to dedicated hardware, if it is necessary, to reduce the performance effect this content has on the rest of the server farm.

When you plan to incorporate the management of digital assets into your solution, you should carefully consider the quantity and size of the files that will be stored and also how they will be used. This will help you design your site architecture when you determine where the asset library should be located.

Components of a digital asset library topology

Digital asset library topologies use the same elements as any standard SharePoint topology, such as web servers, application servers, and database servers. Components that are specific to managing digital assets are put in certain locations within the topology, but they do not change the overall structure of the topology. The following are components about which you must make configuration decisions for the digital asset library topology:

  • BLOB cache The disk-based BLOB cache controls the caching for binary large objects (BLOBs), such as frequently used image, audio, and video files, and other files that are used to display web pages, such as .css and .js files. The BLOB cache should always be enabled on every front-end web server in a server farm if your solution will include asset libraries.

  • Bit Rate Throttling Bit Rate Throttling is an Internet Information Services (IIS) 7.0 extension that meters the download speeds of media file types and data between a server and a client computer. Bit Rate Throttling can be enabled on every front-end web server in a server farm, and it should always be enabled if your solution will include audio or video files in asset libraries. For more information, see Bit Rate Throttling (http://go.microsoft.com/fwlink/p/?LinkId=155151).

  • Maximum file upload size The maximum file upload size is a web application setting that specifies the maximum size of a file that a user can upload to the server. You configure the maximum file upload size for every web application by using Central Administration to specify the size of files that will be uploaded to asset libraries. By default, the maximum video file upload size is 250 MB. You can increase the video file upload size to 2 GB.

  • Desktop Experience The Desktop Experience feature enables you to install many Windows 7 features on a server that is running Windows Server 2008. In SharePoint Server 2013, thumbnail preview images are created automatically when a video is uploaded to an asset library. For automatic thumbnail creation to work, the Desktop Experience feature must be installed on the front-end web server that hosts SharePoint Server 2013. For more information, see Desktop Experience Overview.

    Note:

    The Desktop Experience feature is enabled by default on Windows Server 2012.

For more information, see Plan for caching and performance (SharePoint Server 2010).

If your digital asset library solution will be used to store a very large amount of content, consider using Remote BLOB Storage (RBS) to move the storage of large binary data from SQL Server 2008 to an external storage solution. RBS is not a feature of SharePoint Server 2013 or Internet Information Services (IIS) 7.0. For more information, see Overview of RBS in SharePoint 2013.

Typical digital asset library topology

Digital asset libraries work well with any server farm topology that is supported by SharePoint Server 2013. The server farm can be a single server, a small server farm, or a large server farm.

When you decide to deploy BLOB cache or Bit Rate Throttling, you must deploy them to web servers in the following manner:

  • BLOB cache is enabled in IIS 7.0 and stored on every front-end web server.

  • If Bit Rate Throttling is used, you must install and configure it in IIS 7.0 on every front-end web server.

Additionally, the server that hosts the Central Administration website is used to configure the maximum file upload size for each web application.

Note:

Depending on the size of your server farm and the kind of solution that you are implementing, you might have additional servers that are designated for specific roles — for example, hosting query processing components and index partitions, or crawl components and content processing components for the search system.

The following illustration shows a typical three-tier server farm topology with components added for a digital asset library topology.

Basic farm topology for digital asset management

Callout | Element
1 | Front-end web servers, each with their own BLOB cache and Bit Rate Throttling enabled (if applicable).
2 | The application server that hosts the Central Administration website is used to configure the maximum file upload size for each web application.
3 | Database servers that contain one or more SharePoint content databases.

Scaling topologies for digital asset libraries

When planning and scaling a solution that includes digital asset libraries, the two main factors that you must consider are capacity planning and performance. Because video and audio files can be much larger than images or other kinds of files, you will potentially reach storage capacity more quickly. And depending on the number of users who must access these files at any time, the rate at which requests for the files are made to the server and then sent to the client browser can affect network performance.

For example, if you plan to use an asset library to store training videos, you must consider the average size of each video, and how many videos will be needed for your organization. You must also consider how many users will view the videos, and which videos are likely to be requested most frequently.

For each main component in a digital asset library topology, consider the following issues:

  • Database storage. Is there sufficient storage capacity on the database server for all the files that users will upload? It is important to understand the average size of the files and the number of files that you expect the users will upload to the server.

  • BLOB Cache storage. Is there sufficient storage capacity on the front-end web servers for the files that will be cached?

  • Remote BLOB storage (RBS). If you will have large volumes of content, consider using RBS to move storage of BLOBs out of the content database and into an external storage solution. For more information, see Overview of RBS in SharePoint 2013.

The logical architecture of your digital asset library plan will influence options for scaling out a server farm. If a digital asset library is contained in a dedicated site collection, you can easily move the database to a dedicated server, if it is necessary, to improve capacity and performance.

See also

Plan digital asset libraries in SharePoint Server 2013
Overview of managing digital assets in SharePoint Server 2013

Resource Center: Enterprise Content Management in SharePoint Server 2010


Plan records management in SharePoint Server 2013

Summary: Find links to articles about records management in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet and related resources provide information about records management in SharePoint Server 2013.

A record is a document or other electronic or physical entity in an organization that serves as evidence of an activity or transaction performed by the organization and that requires retention for some time period. Records management is the process by which an organization:

  • Determines what kinds of information should be considered records.

  • Determines how active documents that will become records should be handled while they are being used, and determines how they should be collected after they are declared to be records.

  • Determines in what manner and for how long each record type should be retained to meet legal, business, or regulatory requirements.

  • Researches and implements technological solutions and business processes to help ensure that the organization complies with its records management obligations in a cost-effective and non-intrusive way.

  • Performs records-related tasks such as disposing of expired records or locating and protecting records that are related to external events such as lawsuits.

The articles in this section describe records management in SharePoint Server 2013 and provide guidance for planning your records management solution.

TechNet articles about records management planning

The following articles about records management planning are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of records management in SharePoint Server 2013 | Learn about records management and the records management planning process in SharePoint Server 2013.
Checklist icon (not checked) | Create a file plan to manage records in SharePoint Server 2013 | Learn how to create a file plan to identify what information that you will keep as records.
Checklist icon (not checked) | Plan ways to convert active documents to records in SharePoint Server 2013 | Learn ways that users can turn active documents into records in the Records Center site in SharePoint Server 2013.
Arrow icon, crossing two directions | Use a SharePoint Server 2013 records archive or manage records in place | Decide which records management approach to choose in SharePoint Server 2013.


Overview of records management in SharePoint Server 2013
See also

Summary: Learn about records management and the records management planning process in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

A record is a document or other electronic or physical entity in an organization that serves as evidence of an activity or transaction performed by the organization and that requires retention for some time period. Records management is the process by which an organization:

  • Determines what kinds of information should be considered records.

  • Determines how active documents that will become records should be handled while they are being used, and determines how they should be collected after they are declared to be records.

  • Determines in what manner and for how long each record type should be retained to meet legal, business, or regulatory requirements.

  • Researches and implements technological solutions and business processes to help ensure that the organization complies with its records management obligations in a cost-effective and non-intrusive way.

  • Performs records-related tasks such as disposing of expired records or locating and protecting records that are related to external events such as lawsuits.

Determining which documents and other physical or electronic items in your organization are records is the responsibility of corporate compliance officers, records managers, and lawyers. By carefully categorizing all enterprise content in your organization, these people can help you ensure that documents are retained for the appropriate period of time. A well-designed records management system helps protect an organization legally, helps the organization demonstrate compliance with regulatory obligations, and increases organizational efficiency by promoting the disposition of out-of-date items that are not records.

Elements of a records management system

A records management system includes the following elements:

  • A content analysis that describes and categorizes content in the enterprise that can become records, that provides source locations, and that describes how the content will move to the records management application.

  • A file plan that indicates, for each kind of record in the enterprise, where they should be retained as records, the policies that apply to them, how long they must be retained, how they should be disposed of, and who is responsible for managing them.

  • A compliance requirements document that defines the rules that the organization's IT systems must follow to ensure compliance and the methods that are used to ensure the participation of enterprise team members.

  • A method for collecting records that are no longer active from all record sources, such as collaboration servers, file servers, and email systems.

  • A method for auditing records while they are active.

  • A method for capturing records' metadata and audit histories and for maintaining them.

  • A process for holding records (suspending their disposition) when events such as litigations occur.

  • A system for monitoring and reporting on the handling of records to ensure that employees are filing, accessing, and managing them according to defined policies and processes.

SharePoint Server 2013 includes features that can help organizations implement integrated records management systems and processes.

Overview of records management planning

This topic describes the planning steps that you should take to help make sure that that the records management system that you implement based on SharePoint Server 2013 will achieve your organization's records management goals. The following is a preview of the records management planning process:

  1. Identify records management roles Successful records management requires specialized roles, such as the following:

    • Records managers and compliance officers to categorize the records in the organization and to run the records management process.

    • IT personnel to implement the systems that efficiently support records management.

    • Content managers to find where organizational information is kept and to make sure that that their teams follow records management practices.

  2. Analyze organizational content Before creating a file plan, records managers and content managers survey document usage in the organization to determine which documents and other items can become records.

  3. Develop a file plan After you have analyzed your organizational content and determined retention schedules, fill in the rest of the file plan. File plans differ from organization to organization, but generally they describe the kinds of items the enterprise acknowledges to be records, indicate where they are stored, describe their retention periods, and provide other information, such as who is responsible for managing them and which broader category of records they belong to.

  4. Develop retention schedules For each record type, determine when it is no longer active (being used), how long it should be retained after that, and how it should ultimately be disposed of.

  5. Evaluate and improve document management practices Make sure that required policies are being applied in document repositories. For example, make sure that that content is being appropriately audited so that suitable audits are retained together with records.

  6. Design the records management solution Determine whether to create a records archive, to manage records in place, or to use a combination of the two approaches. Based on your file plan, design the record archive, or determine how to use existing sites to contain records. Define content types, libraries, policies, and, when it is required, metadata that determines the location to route a document to.

  7. Plan how content becomes records If you are using SharePoint Server 2013 for both active document management and records management, you can create custom workflows to move documents to a records archive. If you are using either SharePoint Server 2013 or an external document management system, you can plan and develop interfaces that move content from those systems to the records archive, or that declare a document to be a record but do not move the document. You also create a training plan to teach users how to create and work with records.

  8. Plan email integration Determine whether you will manage email records within SharePoint Server 2013, or whether you will manage email records within the email application itself.

  9. Plan compliance for social content If your organization uses social media such as blogs, wikis, or My Sites, determine how this content will become records.

  10. Plan compliance reporting and documentation To verify that your organization is performing its required records management practices, and to communicate these practices, you should document your records management plans and processes. If your enterprise becomes engaged in records-related litigation, you might have to produce these records management guidelines, implementation plans, and metrics on effectiveness.

See also

Create a file plan to manage records in SharePoint Server 2013
Plan ways to convert active documents to records in SharePoint Server 2013
Use a SharePoint Server 2013 records archive or manage records in place


Create a file plan to manage records in SharePoint Server 2013

Summary: Learn how to create a file plan to identify what information that you will keep as records.

Applies to: SharePoint Server 2013 Enterprise

The file plan is the primary records management planning document in SharePoint Server 2013. Although file plans can differ across organizations, they typically:

  • Describe the kinds of items the organization acknowledges to be records.

  • Describe what broader category of records the items belong to.

  • Indicate where records are stored.

  • Describe retention periods for records.

  • Delineate who is responsible for managing the various kinds of records.

This article describes the contents of a file plan and summarizes how to create a file plan for your organization. The article also directs you to a worksheet in which you can record the file plan.

In this article:

  • Identify kinds of records

  • Complete the file plan

  • Record categories worksheet

Identify kinds of records

Determining which active documents in your organization might be declarable as records requires the collaboration of records managers, lawyers, compliance officers, and content managers. Note that, even if your enterprise is not in a highly regulated industry, there are general laws that might obligate your enterprise to keep records. Along with general business laws, you must evaluate legal requirements that are specific to your enterprise.

It is beyond the scope of this article to provide more than general information about how to determine what is a record in your organization. Most likely, your enterprise is already doing some form of records management and has filled most of the records management roles that you need, and you might already have a taxonomy of records.

Generally, to determine what are records in your organization:

  1. Understand your enterprise's legal obligations and business needs.

  2. In a collaborative effort across the divisions of your organization, analyze how active documents are used.

  3. Develop a list of the kinds of documents that should become records. For example, you might determine that the following should be retained as records:

    • Contracts to rent corporate space.

    • Documents related to employees' benefits.

    • Documents related to product research and development.

  4. Categorize the records. Records in the same category often have the same retention periods and might require similar treatment in other ways.

Record the information that you collected. You can use the worksheet mentioned in the section Record categories worksheet for this purpose. Record the kind of record, the category that records of this kind belong to, and a brief description of the kind of record.

The following is a sample worksheet:

Kind of record | Record category | Description
Benefit plans, insurance plans, pension plans | Employee Benefit Descriptions | Descriptions of all employee benefit plans.
Payroll timesheets, supplementary payroll information | Payroll Records | Summaries of hours worked, overtime, and salary paid.
Vendor invoices | Invoices | Records of goods or services purchased from vendors.
Product surveys, questionnaires, training manuals, training videos | Training Materials | Provides internal or external training.
Shipping forms, shipping reports | Shipping Records | Documents the shipment of materials.
Press releases, newspaper articles | Press Releases | Public relations information about products and services.
Emergency contact sheets, medical plan enrollment forms, resumes, benefits status reports | Personnel Records | Records of individuals' employment histories and related personnel actions.

Complete the file plan

After you determine which documents should be retained as records and after you create a set of record categories, complete your file plan by providing additional information about each kind of record. Indicate the following:

  • How long each kind of record should be retained.

  • How records should be disposed of when the retention period expires.

  • Who is the primary records manager for records of this kind.

  • What kind of media are records of this kind stored in.

The following is a completed sample file plan:

Records | Description | Media | Record category | Retention | Disposition | Contact
401k plans | Description of employee benefit plan. | Web pages | Employee Benefit Plans | X years | None | Kathi Flood
Insurance plans | Description of employee insurance plan. | Print | Employee Benefit Plans | X years | None | Reshma Patel
Pension plans | Description of employee pension plan. | Print | Employee Benefit Plans | X years | None | Reshma Patel
Payroll timesheets | Summaries of hours worked, overtime, and salaries paid. | Electronic documents | Payroll Records | X years | Destroy | Reshma Patel
Supplementary payroll information | Summaries of sick time, vacation time, and other non-salary payroll items. | Electronic documents | Payroll Records | X years | Destroy | Reshma Patel
Vendor invoices | Records of goods or services purchased from vendors. | Print | Invoices | X years | Destroy | Eric Lang
Product surveys | Customer satisfaction survey. | Web pages | Survey Materials | X years | Archive | Molly Dempsey
Questionnaires | Questionnaire to determine customer demographics. | Print | Survey Materials | X years | Archive | Molly Dempsey
Training manuals | Hard-copy training content. | Print | Training Materials | X years | Destroy | Molly Dempsey
Training videos | Video training content. | Video | Training Materials | X years | Destroy | Molly Dempsey
Shipping forms | Configuration of materials shipments | Print | Shipping Materials | X years | Destroy | Eric Lang
Shipping reports | Documentation of the shipment of materials. | Electronic spreadsheets | Shipping Materials | X years | Destroy | Eric Lang
Press releases | Releases about products and services. | Electronic documents | Public Relations Information | X years | Archive | Molly Dempsey
Newspaper articles | News about products and services. | Print | Public Relations Information | X years | Archive | Molly Dempsey
Emergency contact sheets | Employee information. | Electronic documents | Personnel Records | X years | Destroy | Reshma Patel
Medical plan enrollment forms | Employees' sign-up forms for health plans. | Electronic documents | Personnel Records | X years | Destroy | Reshma Patel
Resumes | Resumes received. | Mixed | Personnel Records | X years | Destroy | Reshma Patel
Note:

The example earlier in this section is a sample. It is not a recommendation of any particular file plan settings. To reinforce that this is an example and not a recommendation of any records management policy, no retention periods are supplied.

Record categories worksheet

You can use the following Excel worksheet with this article to help plan your deployment:

  • Record categories worksheet http://go.microsoft.com/fwlink/p/?LinkID=179987&clcid=0x409


Plan ways to convert active documents to records in SharePoint Server 2013
See also

Summary: Learn ways that users can turn active documents into records in the Records Center site in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

After you develop a file plan and design your records management solution in SharePoint Server 2013, plan how active documents in your organization - electronic and hard copy - will become records. This article reviews techniques that you can use to declare active documents to be records and suggests one way to plan how items in your file plan will become records.

In this article:

  • Techniques for converting active documents to records in SharePoint Server 2013

  • Completing your plan

Techniques for converting active documents to records in SharePoint Server 2013

You can use the following techniques convert active documents to records:

  • Manually declaring a document to be a record.

  • Defining a policy that declares a document to be a record or sends a document to a Records Center site at a specified time.

  • Creating a workflow that sends a document to a Records Center site.

  • Using a custom solution that is based on the SharePoint object model.

Creating records manually

If in-place records management is enabled for a document library, users can explicitly declare a document in the library to be a record by editing the document's compliance details. When the site collection administrator enables in-place records management, the site collection administrator specifies who should be able to declare and undeclare records, and whether users should be able to edit or delete documents after they become records.

If a connection to a Records Center site was created, users can manually send documents to the Records Center site by using the Send to command. When a farm administrator configures a connection to the Records Center site, this command becomes available on all active documents. Depending on how the connection is configured, documents can be either copied to the Records Center site, moved to the Records Center site, or moved to the Records Center site with a link to the document maintained.

Although manually sending records to the Records Center site is not a practical large-scale solution, you can use it to supplement other methods of creating records.

Defining a policy

A retention policy specifies actions to take on documents at certain points in time. Policy actions occur automatically. Users do not have to start the action.

Two policy actions relate specifically to managing records: transferring a document to another location, and declaring a document to be a record. If a connection to a Records Center site exists, you can create a policy that sends documents to a Records Center site. The policy also specifies whether to copy the document to the Records Center site, move it, or move it and leave a link in the document library. If in-place records management is enabled for the site, you can create a policy that declares a document to be a record. You can also use the SharePoint object model to create a custom action.

A retention policy can have multiple stages. For example, you could create a retention policy that deletes all earlier versions of a document one year after the document was last changed, and transfers the document to a Records Center site five years after the document was last changed.

If in-place records management is enabled for a site, the site can contain both active documents and records. In this case, you can specify different retention policies for active documents and records. For example, you could create a policy that declares an active document to be a record two years after the document was created, and create a second policy that deletes a record seven years after it was declared to be a record.

Creating a workflow

When you use SharePoint Designer to create a workflow, you can add an action to send an item to a repository. By using this action, you can create workflows that send documents to a Records Center site. You can also include other actions in the workflow. For example, you could create a workflow that sends an email message to a document's author requesting approval, and then sends the document to a Records Center site. You could combine policies and workflows by creating a retention policy that runs the new workflow one year after a document is created.

You can also use the SharePoint object model to create a custom workflow that copies files to the Records Center site. A workflow that sends files to the Records Center site can be integrated into your document management system as part of a workflow that guides a document through its life cycle. For document types that have a predictable life cycle, such as expense reports, you could implement a workflow that guides the document through its various stages and, as a final step, sends a copy of the document to the Records Center site. The workflow could be triggered by creating a new document.

Using a custom solution

You can develop custom solutions that use objects in the Microsoft.Office.RecordsManagement.OfficialFileWSProxy namespace to send content from other data sources to the Records Center site. For more information about how to implement custom solutions using the SharePoint Server 2013 object model, see the SharePoint Server 2013Software Development Kit (http://go.microsoft.com/fwlink/p/?LinkId=259788).

Completing your plan

After you develop the file plan and review the methods for moving content into the Records Center site, complete your file plan by determining how to send each kind of record to the Records Center site. The things to consider include the following:

  • Is compliance enforced or voluntary?

  • Can you depend on the cooperation of users in your organization to comply with records management processes? In general, avoid manual processes. However, where they are needed, create suitable training and monitoring to make sure that team compliance.

  • Will content be stored on SharePoint Server 2013 document management servers?

  • Are you maintaining physical content? Managing active physical content, such as hard copy or CD-ROM, and sending it to a records vault for retention (together with tracking the record in a Records Center site) requires unique planning not described in this topic. For example, if no electronic version of a paper document exists, you might have to track the item by using a list that has associated policies and workflows.

The following table shows how some records in a sample file plan will move to a Records Center site:

Documents | Description | Media | Source location | Becomes a record...
Benefit plan | Description of employee benefit plan. | Web pages | SharePoint Server 2013 document library | Using a custom workflow associated with expiration policy
Insurance plan | Description of employee insurance plan. | Print | Physical document associated with list item in SharePoint Server 2013 | By sending it to a physical vault and creating a list item in the Records Center site to track (using a barcode)
Payroll timesheets | Summaries of hours worked, overtime, and salaries paid. | Electronic documents | Payroll records server not based on SharePoint Server 2013 | Using a custom program
Product development files | Specifications of products and associated documents. | Electronic documents | SharePoint Server 2013 document library | Using custom workflow associated with expiration policy and manually by using Send to command

See also

Create a file plan to manage records in SharePoint Server 2013


Use a SharePoint Server 2013 records archive or manage records in place

Summary: Decide which records management approach to choose in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

In SharePoint Server 2013 you can manage records in an archive, or you can manage records in the same document repository as active documents. By using the SharePoint Server 2013 in-place approach, when you declare that a document has become a record, the record remains in place, but SharePoint Server 2013 now manages it as a record. For example, a document might get a different retention policy when it is declared to be a record, or users might be unable to edit it.

A hybrid approach is also possible. For example, you could keep records in place with active documents for two years, and then move records to a records archive when a project is completed.

As you think about whether to manage records in a separate Records Center site or in the same collaboration site in which the documents were created, consider the following questions:

  • Is the governance of the collaboration site appropriate for managing records? Is your industry subject to regulatory requirements that mandate records be separated from active documents? Should the administrator of a collaboration site be trusted to manage a site that contains records? You might want to store records in a site that uses more restricted access than the collaboration site, or in a site that is backed up on a different schedule.

  • How long will the collaboration site be in use? If records will have to be kept for longer than the project is ongoing, selecting an in-place records management strategy means that you will have to maintain the collaboration site even after it is no longer used.

  • Will the project members need frequent access to the documents after the documents have become records? If you use an in-place approach, project members can access documents in the same manner regardless of whether the documents are active or are records.

  • Are records managers in your organization responsible for only records, or are they responsible for all information, regardless of whether it is active or a record? If records managers are responsible only for official records, having a separate Records Center site might be easier for them.

The following table describes differences between what you can do with records in a record center and with records that are managed in-place in a collaboration site. The differences are presented from the point of view of both records managers and employees collaborating on a project team.

Differences between a records archive and in-place records

Factor | Records archive | In-place records
Managing record retention | The content organizer automatically puts new records in the correct folder in the archive's file plan, based on metadata. | There may be different policies for records and active documents based on the current content type or location.
Restrict which users can view records | Yes. The archive specifies the permissions for the record. | No. Permissions do not change when a document becomes a record. However, you can restrict which users can edit and delete records.
Ease of locating records (for records managers) | Easier. All records are in one location. | Harder. Records are spread across multiple collaboration sites.
Maintain all document versions as records | The user must explicitly send each version of a document to the archive. | Automatic, assuming versioning is turned on.
Ease of locating information (for team collaborators) | Harder, although a link to the document can be added to the collaboration site when the document becomes a record. | Easier.
Clutter of collaboration site | Collaboration site contains only active documents. | Collaboration site contains active and inactive documents (records), although you can create views to display only records.
Ability to audit records | Yes. | Dependent on audit policy of the collaboration site.
Administrative security | A records manager can manage the records archive. | Collaboration site administrators have permission to manage records and active documents.

The following table describes differences between the two records management approaches that might affect how you manage IT resources.

Resource differences between a records archive and in-place records

Factor | Records archive | In-place records
Number of sites to manage | More sites. That is,, there is a separate archive in addition to collaboration sites. | Fewer sites.
Scalability | Relieves database size pressure on collaboration sites. | Maximum site collection size reached sooner.
Ease of administration | Separate site or farm for records. | No additional site provisioning work beyond what is already needed for the sites that have active documents.
Storage | Can store records on different storage medium. | Active documents and records stored together.


Plan eDiscovery in SharePoint Server 2013
See also

Summary: Find links to articles about eDiscovery in SharePoint Server 2013.

Applies to: SharePoint Server 2013

This section contains articles that will help you plan how to implement eDiscovery in SharePoint 2013.

TechNet articles about eDiscovery planning

The following articles about eDiscovery planning are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of eDiscovery and in-place holds in SharePoint Server 2013 | Learn about eDiscovery across SharePoint Server 2013 and Exchange Server 2013, the eDiscovery Center, eDiscovery cases, in-place holds, and exports.
Checklist icon (not checked) | Plan for eDiscovery in SharePoint Server 2013 | Prepare to implement eDiscovery across SharePoint Server 2013, Exchange Server 2013, and Lync 2013. Determine permissions to grant and how many eDiscovery Centers to create.

See also

What's new in eDiscovery in SharePoint Server 2013
Configure eDiscovery in SharePoint Server 2013


Overview of eDiscovery and in-place holds in SharePoint Server 2013
See also

Summary: Learn about eDiscovery across SharePoint Server 2013 and Exchange Server 2013, the eDiscovery Center, eDiscovery cases, in-place holds, and exports.

Applies to: SharePoint Server 2013

Electronic discovery, or eDiscovery, is the process of identifying and delivering electronic information that can be used as evidence. SharePoint Server 2013 introduces the eDiscovery Center, a new type of site collection that serves as a portal for managing eDiscovery cases. From this central location you can discover content in the SharePoint farm, in Exchange Server 2013, on file shares, and in other SharePoint farms. You can apply a hold to SharePoint and Exchange content that you discover. The hold ensures that a copy of the content is preserved, while still allowing users to work with their content. When you have identified the specific items that you will have to deliver, you can export them in an industry-standard format.

In this article:

  • Managing an eDiscovery case

  • How eDiscovery works in SharePoint products

  • In-place holds

  • Integration with Exchange

Managing an eDiscovery case

When you receive a new request for eDiscovery, you create an eDiscovery case in the eDiscovery Center. An eDiscovery case is a collaboration site that you can use to organize information related to the eDiscovery request. From within an eDiscovery case, you can search for content, apply a hold to content, export content, and view the status of holds and exports that are associated with the case.

The two primary components of an eDiscovery case are eDiscovery sets and queries. Use an eDiscovery set to find content and apply a hold. Use a query to find content and export it.

eDiscovery process flow

eDiscovery process flow

To find and preserve content, create an eDiscovery set. Each eDiscovery set contains the following:

  • Sources, which are locations to be searched. Exchange mailboxes, SharePoint sites, and file shares can all be sources.

  • A filter, which defines what you are searching for. A filter can include search terms, a date range, and an author's name.

  • An option to apply an in-place hold to the sources that contain content that matches the filter.

To find and export content, create a query. Each query contains the following:

  • Query filters, which define what you are searching for. Query filters resemble a filter in an eDiscovery set, and can include search terms, a date range, and an author's name. However, query filters in a query can also use stemming.

  • Sources to be searched. Exchange mailboxes, SharePoint sites, file shares, and eDiscovery sets can all be sources in a query.

When you run a query, you can see statistics about the items that were found, you can preview the results, and you can filter the results by message type (for Exchange results) or by file type (for SharePoint results). When you are finished, you can export the results of the query.

The content that you export by using a query is formatted according to the Electronic Data Reference Model (EDRM) specification so that it can be imported into a review tool. An export can include the following:

  • Documents: Documents are exported from file shares. Documents and their versions can be exported from SharePoint 2013.

  • Lists: If a list item is included in the query results, the whole list is exported as a comma-separated values (.csv) file.

  • Pages: SharePoint pages, such as wiki pages or blogs, are exported as MIME HTML (.mht) files.

  • Exchange objects: Items in an Exchange Server 2013 mailbox, such as tasks, calendar entries, contacts, email messages and attachments are exported as a.pst file. If Lync conversations are archived in Exchange, those can be discovered and exported, too.

  • Crawl log errors.

  • An XML manifest that provides an overview of the exported information.

How eDiscovery works in SharePoint products

The Search service application is a key component of the search system in SharePoint Server 2013. (For more information about service applications, see Services architecture planning (SharePoint Server 2010).) You can associate an eDiscovery Center with a Search service application. Any content that is indexed by the Search service application can be discovered from the eDiscovery Center. If you configure the Search service application to crawl file shares, you can use the eDiscovery Center to discover content on the file shares. If you configure the Search service application to crawl other websites - for example, a team site that was created by using Office SharePoint Server 2007 - you can use the eDiscovery Center to discover content on the websites. For SharePoint 2013 farms, you can also put the content on hold. If you add Exchange Server 2013 to the Search service application as a result source, you can discover content within Exchange mailboxes from the eDiscovery Center and put the mailboxes on hold. If you archive content from Lync in Exchange, you can also discover Lync content.

If your environment includes two isolated Search service applications - for example, SharePoint Online and SharePoint on-premises - you have to have two eDiscovery Centers to discover content across the farms. For more information about how many eDiscovery Centers you will need, see Plan eDiscovery in SharePoint Server 2013.

A separate eDiscovery Center for each isolated Search service application.

separate discovery center for each search service

As the Search system crawls content, it creates a search index. The search index stores data that is used to provide the results for search queries. The search index also stores information about the permissions that are required to access each piece of content. When a user performs a search, the search system uses the search index to identify the appropriate search results. Before displaying the results, the Search service application performs security trimming, by which the system compares the user's permissions to the permissions that are required to access content that search results link to, and then "trims" the results to show only those results that the user has permissions to view.

In-place holds

SharePoint Server 2013 introduces the concept of an in-place hold. When you apply an in-place hold to a site, content in the site remains in its original location. Users can still work with the content, but a copy of the content as it was at the time that you initiated the hold is preserved. In-place holds differ from the style of hold that you could use in SharePoint Server 2010. In SharePoint Server 2010, users could not change or delete content when it was on hold. By using in-place holds in SharePoint Server 2013, users do not even have to know that their content is on hold.

Important:

If SharePoint Server 2013 runs on a server that uses Alternate Access Mapping (AAM), host-named site collections, or SSL termination format, then users will not be able to edit web pages in a site that has an in-place hold applied. To allow users to edit pages in sites that are on hold, you will need to disable loopback checking as described under Method 2 in KB article 896861 (http://go.microsoft.com/fwlink/p/?LinkId=272340).

An in-place hold is applied at the level of a site. When a hold is placed on a SharePoint site, a preservation hold library is created, if one does not already exist. Most users cannot view the preservation hold library. It is only visible to site collection administrators. The search crawler also has special permissions to crawl content in the preservation hold library.

Note:

There is one case in which a user can view the preservation hold library. Users who are granted permissions at the web application level can view all content in all site collections within the web application. For more information about permissions and eDiscovery, see Plan for eDiscovery in SharePoint Server 2013.

If a user attempts to modify or delete content in a site that is on hold, SharePoint first checks whether the content has been modified since the hold was applied. If this is the first modification since the hold was applied, SharePoint copies the content to the preservation hold library, and then allows the user to modify or delete the original content. Note that any content in the site can be copied to the preservation hold library, even if the content does not match the filter of the eDiscovery set that initiated the hold.

The Information Management Retention timer job cleans up the preservation hold library. The timer job runs periodically and compares all content in the preservation hold library to the filters for the eDiscovery sets that put the site on hold. Unless content matches at least one of the filters, the timer job deletes the content from the preservation hold library.

Two important consequences of this process are as follows:

  • The version of content that is current at the time that the hold was applied is the only version that is preserved. If the content is changed multiple times, intermediate versions of the content are not preserved.

    Note:

    If an item is placed on hold multiple times, SharePoint preserves the version that is current at the time each hold is placed. For example, if version 27 of an item is the most recent when the site is placed on hold the first time, and version 51 is the most recent when the site is placed on hold the second time, versions 27 and 51 are preserved.

  • Storage space is used efficiently. Most content in a site does not change, and content that is not changed is not copied to the preservation hold library.

Integration with Exchange

You can manage the discovery process for Exchange Server 2013 from a SharePoint eDiscovery Center. You can do the following:

  • Add Exchange mailboxes as sources to either an eDiscovery set or a query.

  • Preview content that is discovered in an Exchange mailbox.

  • Apply a hold to an Exchange mailbox.

  • Export content that is discovered in an Exchange mailbox.

To discover content in Exchange mailboxes, you must first configure a trust relationship between SharePoint and Exchange. You must also grant specific Exchange permissions to the users of the eDiscovery Center. For more information about these tasks, see Configure eDiscovery in SharePoint Server 2013.

See also

Plan for eDiscovery in SharePoint Server 2013
Configure eDiscovery in SharePoint Server 2013


Plan for eDiscovery in SharePoint Server 2013
See also

Summary: Prepare to implement eDiscovery across SharePoint, Exchange, and Lync. Determine permissions to grant and how many eDiscovery Centers to create.

Applies to: SharePoint Server 2013

There are several factors to consider before you implement eDiscovery. First, determine how many eDiscovery Centers you need and where to put the eDiscovery Centers. Then identify the locations that contain content that can be discovered. Finally, consider the permissions that you have to grant to eDiscovery users. The decisions that you make when you plan for eDiscovery might affect other systems that your organization uses, such as Exchange Server 2013. Accordingly, you might have to coordinate with the people who manage those systems when you create and implement your plan.

As you create your plan, you can record the details on the Worksheet. To implement your plan, follow the instructions in the article Configure eDiscovery in SharePoint Server 2013. The decisions that you make during planning determine which tasks to do.

Before you read this article, you should understand the concepts that are presented in the article Overview of eDiscovery and in-place holds in SharePoint Server 2013.

Decide how many eDiscovery Centers

The following factors affect the number of eDiscovery Centers that you have to create:

  • How many Search service applications you have.

  • What content each Search service application crawls.

If you have only one Search service application, or if there is a single Search service application that crawls all of the sites that contain discoverable content, you can have a single eDiscovery Center. If different Search service applications crawl subsets of the discoverable content, you have to have multiple eDiscovery Centers. Associate eDiscovery Centers with Search service applications so that all discoverable content is crawled by a Search service application that is associated with an eDiscovery Center.

The following figure presents three examples of farm topologies and illustrates how many eDiscovery Centers are required for each example.

How many Search service applications you have influences how many eDiscovery Centers you have.

How many Discovery Centers are needed?

A Search service application in an on-premises SharePoint farm cannot crawl content in SharePoint Online. If you have discoverable content in SharePoint Online, you will also have to create an eDiscovery Center in SharePoint Online.

On the worksheet, record how many eDiscovery Centers you will have.

An eDiscovery Center must be in a web application that supports claims authentication. For each eDiscovery Center, record the farm that will contain the eDiscovery Center and the Search service application with which to associate the eDiscovery Center.

Identify discoverable content

After you have determined how many eDiscovery Centers you will have and where the eDiscovery Centers will be, identify the content that each Search service application will crawl.

To be discoverable, content on file shares, in SharePoint sites, or on other web sites must be crawled by a Search service application that is associated with an eDiscovery Center.

Note:

A file on a file share whose file name is longer than 259 characters cannot be discovered.

In the worksheet, list all the locations that contain content that must be discoverable. If you have more than one eDiscovery Center, indicate which Search service application will crawl each content source.

If you want to manage the discovery of Exchange Server 2013 content from a SharePoint Server 2013 eDiscovery Center, you must configure a Search service application to include Exchange Server 2013 as a result source. If you want to manage the discovery of Lync Server 2013 content from a SharePoint Server 2013 eDiscovery Center, you must configure Lync Server 2013 to archive content to Exchange Server 2013.

Note:

To manage discovery of Exchange content through SharePoint Server 2013, you must be using Exchange Server 2013. To manage discovery of Lync content through SharePoint, you must be using both Lync Server 2013 and Exchange Server 2013.

Determine how to manage permissions

People who perform eDiscovery must be able to view all content that is potentially discoverable. We recommend that you create a security group for eDiscovery users, and add the appropriate users to the security group. Then you can grant permissions to the security group, instead of to individual users. Choose a name for the security group, and record the name in the worksheet. Also record which users will be members of the security group.

Within SharePoint Server 2013, eDiscovery users must be able to view all content. This includes content that is in the preservation hold library. (For more information about the preservation hold library, see Overview of eDiscovery and in-place holds in SharePoint Server 2013.) There are two ways to achieve this:

  1. Grant eDiscovery users access to all content in a web application by using web application user policy.

  2. Add eDiscovery users as site collection administrators for every site collection that contains discoverable content.

We recommend that you grant permissions at the web application level, if that is possible in your environment.

Note:

Because SharePoint Online is a hosted service, administrators cannot access web applications directly. Therefore, in SharePoint Online you must explicitly add eDiscovery users as site collection administrators on each site collection that contains discoverable content.

Decide whether you will grant permissions by web application or by site collection. If you will grant permissions at the web application level, identify which web applications you will have to grant access to eDiscovery users. (It is likely that this will be all web applications.) If you will grant permissions at the site collection level, identify which site collections eDiscovery users will need access to. Record your decisions in the worksheet.

Generally, when you export content for eDiscovery, you will also want to export a list of things that could not be indexed. The search crawl log contains this information. Therefore, eDiscovery users also have to have access to the search crawl log.

Worksheet

As you create a plan to implement eDiscovery, you can record your decisions in a worksheet. Download the eDiscover planning worksheet (http://go.microsoft.com/fwlink/p/?LinkId=254840).

See also

Overview of eDiscovery and in-place holds in SharePoint Server 2013
Configure eDiscovery in SharePoint Server 2013


Plan web content management in SharePoint Server 2013

Updated: April 9, 2013

Summary: Use these TechNet articles and related resources to learn how to plan publishing sites by using SharePoint features.

Applies to: SharePoint Online | SharePoint Server 2013

The following articles on TechNet and related resources provide information about web content management planning.

TechNet articles about web content management planning

The following articles about web content management planning are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013 | Learn about SharePoint publishing, the kinds of SharePoint publishing sites, and the publishing methods available for SharePoint sites.
Checklist icon (not checked) | Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013 | Learn how to plan SharePoint publishing sites, multilingual support, and SharePoint cross-site publishing or author-in-place.
Checklist icon (not checked) | Plan for cross-site publishing in SharePoint Server 2013 | Learn how to use cross-site publishing to create SharePoint sites that display search-driven content on Internet, intranet, and extranet sites.
Building blocks | Overview of managed navigation in SharePoint Server 2013 | Learn about managed navigation and navigation term sets for SharePoint Server publishing sites.
Checklist icon (not checked) | Plan navigation term sets in SharePoint Server 2013 | Learn how to create the navigation term set to provide site navigation for SharePoint Server publishing sites.
Building blocks | Variations overview in SharePoint Server 2013 | Learn about variations and the benefits and scenarios for using variations to create multilingual sites in SharePoint Server 2013 or SharePoint Online.
Checklist icon (not checked) | Plan for variations in SharePoint Server 2013 | Learn how to plan for variations, specify the source variation site, plan the target variation sites, and decide how sites, lists, and pages will be created on target variation sites in SharePoint Server 2013 or SharePoint Online.
Checklist icon (not checked) | Plan for caching and performance in SharePoint Server 2013 | Learn about the BLOB cache, Bit Rate Throttling, and other SharePoint features that can improve browser performance.

Change History

Date | Description
April 09, 2013 | Added new article: "Plan for caching and performance in SharePoint Server 2013."
March 26, 2013 | Added two new articles: "Overview of managed navigation in SharePoint Server 2013" and "Plan navigation term sets in SharePoint Server 2013."
August 21, 2012 | Initial publication


Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013
See also

Published: August 21, 2012

Summary: Learn about SharePoint publishing, the kinds of SharePoint publishing sites, and the publishing methods available for SharePoint sites.

Applies to: SharePoint Server 2013 | SharePoint Online

You can use the publishing features inSharePoint 2013 to create branded Internet, intranet, and extranet sites. However, some publishing features are available only in SharePoint Server 2013.

This article describes what is meant by publishing in the context of web content management (WCM) in SharePoint Server 2013, and explains how to use publishing sites to benefit your organization. It includes a list of the major publishing components, introduces the types of publishing sites that are available, and explains the publishing methods that you can use for SharePoint Server 2013 publishing sites. For information about how to plan publishing sites, see Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013.

What is publishing in SharePoint Server 2013?

WCM in SharePoint Server 2013 consists of features and functionality that you use to configure, customize, optimize, and publish site collections, sites, and pages. When we talk about publishing sites in SharePoint Server 2013, we are referring to sites that use one or more of these features to author and deploy branded artifacts, content, and configuration files to Internet, intranet, and extranet sites.

Use and benefits of SharePoint publishing sites

You can use SharePoint Server 2013 publishing sites to create different types of branded sites, depending on your business needs and goals. The following list gives examples of how you can use SharePoint publishing sites:

  • Internet presence site Provide information to customers, partners, investors, and potential employees. For example, you might use an Internet presence site to provide news articles or reviews that are tagged with metadata to categorize articles so that users can search or browse for information.

  • Internet business site Promote products and services that your company offers to customers. For example, you might use an Internet business site to show a catalog of products such as TVs, stereos, MP3 players, and mobile devices.

  • Intranet sites Deploy a site that has a tightly managed navigation structure to provide authored content to intranet readers. For example, you might use a published intranet site to provide human resources information to employees.

  • Extranet sites Provide access to targeted content to remote employees, partners, and customers. For example, you might use an extranet site to provide access to a knowledge base that uses authored content tagged with metadata to categorize articles so that users can search or browse for specific information, such as troubleshooting articles, support issues, and service packs.

SharePoint Server 2013 publishing sites let you establish a branded, online identity for your company or organization. The benefits of using SharePoint publishing sites include the following:

  • Brand consistency by using custom design assets, such as master pages and page layouts, edited in HTML and automatically converted into SharePoint resources.

  • Tight control over site navigation.

  • Decentralized content creation, which enables globally contributed content.

  • Centralized publishing workflow and approval processes.

  • Dynamic, customized sites.

About SharePoint publishing features

Publishing in SharePoint Server 2013 consists of two separate features: the SharePoint Server Publishing Infrastructure feature, and the SharePoint Server Publishing feature. These features provide the core publishing functionality for SharePoint Server 2013. The following list describes the major functionality that is enabled by the publishing features:

  • Site templates By default, some site collection and site templates have the publishing feature enabled. You can enable publishing features for other kinds of site collections and sites.

  • Special groups and permission levels Special groups such as Approvers, Designers, and Hierarchy Managers are included, and permission levels such as Approve, Design, and Manage Hierarchy are added to the site collection to support tasks that compose the creation and publication of content.

  • Navigation The global navigation menu replaces the top link bar, and the managed navigation feature is enabled.

  • Master pages, page layouts, and display templates Master pages, page layouts, and display templates let you customize the overall behavior and appearance of your site. For more information, see SharePoint page model overview.

  • Design Manager and design packages The Design Manager is a new interface and central hub for managing all aspects of branding your SharePoint site. It enables a step-by-step approach for creating design assets in the web development tool of your choice that you can use to brand sites.

    After you finish designing your site, you can choose Export Package in the Design Manager to export a single .wsp file called a design package. When you export a design package, SharePoint Server 2013 automatically packages all of the contents that you have added or changed in the Master Page Gallery, Style Library, Theme Gallery, the Device Channels list, and Page content types into a design package. You can import the design package into another site, even if that site already has content. For more information, see What's new with SharePoint 2013 site development.

  • Device channels By using device channels, you can target different designs to different devices (such as Windows Phone) or groups of devices (such as all smartphones).

  • Site columns and content types Special site columns such as Page Content, Scheduling Start Date, and Scheduling End Date are added to the site collection, and content types such as Page Layout, Article Page, and Enterprise Wiki Page are added to support creating content.

  • Special Web Parts Special Web Parts such as Content and Structure Reports, Content Search, Content Query, and Taxonomy Refinement Panel are added to support the display of publishing-related data.

  • Pages library The Pages library is used to store all web pages that are created in the site.

  • Page editing menus The page editing ribbon lets users quickly and easily author and manage their content.

  • Approval workflow and scheduling An approval workflow lets authors route their content for review and approval before it is published. Scheduling functionality lets authors specify when a piece of content should go live on the site, and when it should expire.

  • Variations for multilingual sites The variations feature lets you create multilingual content and target it to specific audiences on different sites by copying content from a source variation site to each target variation site. You can then use machine translation to translate page content, or you can package content for human translation.

  • Caching The object cache reduces the amount of traffic between the web server and the SQL database by storing objects — such as lists and libraries, site settings, and page layouts — in memory on the front-end web server. The page output cache stores the rendered output of a page and uses cache profiles that specify how long items should be held in the cache. The binary large object (BLOB) cache is a disk-based cache for caching items such as frequently used images, audio and video files, and other files that are used to display web pages, such as .css and .js files.

About SharePoint publishing site collection templates

SharePoint Server 2013 has three site collection templates that you can use to create a publishing site based on your site needs and goals: Publishing Portal, Product Catalog, and Enterprise Wiki. The following table describes each template.

Publishing site collection templates

Template | Description
Publishing Portal | Use for an Internet site or a large intranet portal site. You can use distinctive branding to customize this site. Typically, this site has many more readers than contributors. By default, this site collection template enables content approval workflows for a more formal and controlled publishing process. It also lets you grant permissions to anonymous users to view only content pages. Anonymous users cannot view SharePoint Server 2013 administrative pages, such as the Site Settings page.
Enterprise Wiki | A site in which your organization can publish knowledge that it accumulates and wants to share across the enterprise. It provides an easy content editing experience in a single location for co-authoring content, for discussions, and for collaborating on projects.
Product Catalog | Use for managing library or list data that is shared as a catalog for cross-site collection publishing. Catalog data is published to an Internet-facing site by using Web Parts that use Search technology. The catalog can be configured to support catalog item variants and multilingual catalog item properties. The site includes administration pages for managing faceted navigation for catalog items.

In addition to using one of these established site collection templates, you can also turn on publishing for any non-publishing site by activating the SharePoint Server Publishing Infrastructure feature at the site collection level, and the SharePoint Server Publishing feature at the site level.

Understanding SharePoint publishing methods

SharePoint Server 2013 has two ways that you can make published content available to users: author-in-place and cross-site publishing. The following list summarizes these publishing methods.

  • Author-in-place You use a single site collection to author content and make it available to readers of your site. Content is branded by using master pages and page layouts on the same site, and approval and publishing workflows are used to submit pages for approval and then publish them for readers. This was the primary publishing method that was available in SharePoint Server 2010.

  • Cross-site collection publishing You use one or more site collections to author content, and one or more site collections to control the design of the site and the display of the content. The authoring site collection is used to hold the source content, and can contain catalogs of Pages libraries and lists that are indexed by the search system, and made available to the publishing site collection. The publishing site collection takes the data from the authoring site collection and shows it on web pages by using the Content Search Web Part and the Catalog-Item Reuse Web Part. These Web Parts use configured queries to get data from the search index and show it on the site. Content is branded on the publishing site by using master pages, page layouts, and display templates. These let a designer control how data appears in the Content Search Web Part and the Catalog-Item Reuse Web Part. For more information, see Overview of cross-site publishing in SharePoint Server 2013.

See also

Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013
Overview of cross-site publishing in SharePoint Server 2013
Plan for cross-site publishing in SharePoint Server 2013
Estimate capacity and performance for Web Content Management (SharePoint Server 2013)


Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013
See also

Published: August 21, 2012

Summary: Learn how to plan SharePoint publishing sites, multilingual support, and SharePoint cross-site publishing or author-in-place.

Applies to: SharePoint Server 2013 | SharePoint Online

You can use the publishing features in SharePoint 2013 to create branded Internet, intranet, and extranet sites. However, some publishing features are available only in SharePoint Server 2013.

There are several planning steps you have to do before you begin building publishing sites. First, decide what SharePoint architecture you want to have. Then determine the type of content that will be published. Next, decide whether you need multilingual support for your sites. Finally, decide which publishing method is best suited for your solution.

This article builds on the information in Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013.

Determine the SharePoint architecture

If you are planning to build a publishing site based on SharePoint Server 2013, you have probably already made some decisions about what kind of sites are needed, and how you want them distributed. For example, if you are building an Internet business site, you probably already know how many public-facing sites you require for each region or brand. If you are building an intranet site for your company, you have probably already determined how many internal sites you require for each division or group. It is not necessary to have a detailed plan of the physical architecture at this stage in the project. However, when you plan to set up a publishing site, it's important to consider if you have to plan for sites to be inside or outside a firewall, and if some sites will allow anonymous users. For more information about how to plan for sites, see Plan sites and site collections (SharePoint Server 2010).

Determine what type of content you will have on each site

What type of content do you plan to publish on the site? Is the site an intranet knowledge base that will have only Pages library content? Or is the site an Internet business site that will display lists of products and descriptions, together with Pages library content? If you plan to use cross-site publishing, how many catalogs do you have? Are any catalogs in external data sources? Will you import catalogs into the site, or will you create content directly in SharePoint Server? Knowing what type of content you have will help you determine what publishing method you will use later in this article.

Decide on multilingual support

Does your site require that content be provided in more than one language, or to more than one locale? Even if you currently plan to only create and publish content in a single language, you should carefully consider whether that business requirement might change in the future. If there is a chance you might eventually want to use variations on the site, you should plan for using variations now. By setting up your site structure now in preparation for using variations, you will save yourself and your organization time and resources in the future. If you have to change the site structure when you switch to using variations later, it is often more difficult and can affect the URLs that you planned for your sites. For more information about variations, see Variations overview (SharePoint Server 2010). For information about how to plan variations, see Plan for variations (SharePoint Server 2010).

Decide which publishing method to use

SharePoint Server 2013 has two ways that you can make published content available to users: author-in-place and cross-site publishing. Deciding which publishing method to use is an important step in planning publishing sites. The publishing method that you select will lead to additional planning steps, and some steps are unique to each method.

  • Author-in-place Uses a single site collection to author content and make it available to readers of your site. If you plan to publish only Pages library content, and you do not have to author on more than one site, or publish to more than one site, and you do not have a business need to author separately from your production environment, you should use author-in-place. If you must publish multilingual content, you can still use variations to make content available to sites in multiple languages or regions. Author-in-place is available in both SharePoint Server 2013 and SharePoint Online.

  • Cross-site publishing Uses one or more site collections to author content, and one or more site collections to control the design of the site and the display of the content. If you want to separate your authoring and publishing environments, you should use cross-site publishing. If you plan to publish only Pages library content, but you want to author in more than one site, or publish to more than one site, you should also use cross-site publishing. Cross-site publishing is available only in SharePoint Server 2013. For more information about cross-site publishing, see Overview of cross-site publishing in SharePoint Server 2013. For information about how to plan for cross-site publishing, see Plan for cross-site publishing in SharePoint Server 2013.

Consider cross-site publishing if you answer yes to any of the following questions:

  • Is it okay for the authoring site to look different from the publishing site?

  • Do you want to keep the authoring environment separate from the publishing environment?

  • Do you have multiple site collections represented, on either the authoring or publishing side — for example, n:1 or 1:n?

  • Do you want to have multiple sites for different brands?

  • If you plan to use variations or if you plan to translate content for multiple sites, do you want to have different URLs for different locale-specific variants of your site?

Although cross-site publishing is the recommended method to use for making content available to multiple sites, it might not be the right method for your publishing solution. You should not use cross-site publishing if you do not plan to use variations with unique URLs, or publish to multiple sites, and you want to author content on the same site collection in which it is published. Use author-in-place instead.

Use the following flowchart to help you determine which publishing method to use:

Publishing method decision flowchart

Publishing decision flowchart

Additional planning tasks

After you have determined the publishing method to use, there are additional planning tasks to perform. The following resources will help you make additional planning decisions about your publishing solution.

  • Plan information architecture for Web content management provides general recommendations for planning the information architecture for a Web content management solution.

  • Plan Web page authoring (SharePoint Server 2010) describes the steps that are involved in planning how Web pages are authored.

  • Plan content approval and scheduling contains general guidance about how to plan content approval and scheduling for use with SharePoint Server 2013 publishing sites.

  • Plan for caching and performance (SharePoint Server 2010) provides information about how and when to use the BLOB cache, and it lists key considerations for planning to use it. This article also describes performance considerations for when to use Bit Rate Throttling, and it describes the limitations of upload file size restrictions.

  • Plan for large Pages libraries (SharePoint Server 2010) describes the use of large Pages libraries in SharePoint Server 2013 publishing sites. Also, this article contains information to help you determine whether to use large Pages libraries with your publishing solution and information about how to plan for them.

  • Plan for variations (SharePoint Server 2010) provides information about important items that you should consider when you are using variations in publishing sites, and it describes the tasks that are involved in planning a solution that uses variations in SharePoint Server 2013.

See also

Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013
Overview of cross-site publishing in SharePoint Server 2013
Plan for cross-site publishing in SharePoint Server 2013
Estimate capacity and performance for Web Content Management (SharePoint Server 2013)


Plan for cross-site publishing in SharePoint Server 2013
See also

Published: August 21, 2012

Summary: Learn how to use cross-site publishing to create SharePoint sites that display search-driven content on Internet, intranet, and extranet sites.

Applies to: SharePoint Server 2013 Enterprise

Cross-Site Collection Publishing is a SharePoint Server 2013 feature that enables you to use one or more site collections to author content, and one or more site collections to control the design of the site and the display of the content. The functionality provided by this feature is referred to as cross-site publishing. You can use cross-site publishing to create branded Internet, intranet, and extranet publishing sites. Cross-site publishing is available only in SharePoint Server 2013.

There are many planning steps that you must follow to build a solution that uses cross-site publishing. The first articles in this section explain key concepts about cross-site publishing in SharePoint Server 2013, and describe how to plan the architecture to support it. Additional articles in this section divide the remaining planning steps into three tasks, which are based on the three major components of cross-site publishing: planning the authoring site collection, planning the publishing site collection, and planning for search.

In this section:

  • Overview of cross-site publishing in SharePoint Server 2013 describes cross-site publishing, its use and benefits, common cross-site publishing scenarios, and the major components for the authoring and publishing site collections and search. This article also lists limitations of cross-site publishing.

  • Plan the logical architecture for cross-site publishing in SharePoint Server 2013 describes the major components of a cross-site publishing architecture, and illustrates example architectures.

  • Plan authoring sites for cross-site publishing in SharePoint Server 2013 describes how to plan the authoring site structure, security, design and branding, tagging term sets, and catalog content.

  • Plan publishing sites for cross-site publishing in SharePoint Server 2013 describes how to plan the publishing site structure, security, design and branding, navigation term sets, catalog connections, and displaying catalog content.

  • Plan search for cross-site publishing sites in SharePoint Server 2013 describes how to plan for search-driven pages, including content sources and crawling, managed properties in the search index, refiners and faceted navigation, result sources and query rules, usage analytics and events, and recommendations.

See also

Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013
Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013
Configure cross-site publishing in SharePoint Server 2013
Estimate capacity and performance for Web Content Management (SharePoint Server 2013)


Overview of cross-site publishing in SharePoint Server 2013
See also

Published: August 21, 2012

Summary: Learn how you can use cross-site publishing and Search Web Parts to create adaptive SharePoint Internet, intranet, and extranet sites.

Applies to: SharePoint Server 2013 Enterprise

The Cross-Site Collection Publishing feature in SharePoint Server 2013 works in the following way: you use one or more authoring site collections to author and store content, and one or more publishing site collections to control the design of the site and to show the content. The functionality provided by this feature is referred to as cross-site publishing. The authoring site collection contains catalogs, such as Pages libraries and lists, which contain content that is tagged with metadata. These catalogs are indexed by the search system and made available to the publishing site collection. The publishing site collection issues queries for data that has been indexed and shows it on web pages by using Web Parts that use search technology (referred to in this article as Search Web Parts). You brand content on the publishing site by using master pages, page layouts, and display templates.

The following illustration shows how content is stored in an authoring site collection, indexed by the search system, and then reused across three separate publishing site collections (1 : n).

Cross-site publishing diagram

  1. Content is created in libraries and lists that are shared as catalogs in the authoring site collection.

  2. The search system crawls the content and builds the search index.

  3. A user views a page on a publishing site, which triggers queries from Search Web Parts.

  4. Results are returned from the search index, and shown in Search Web Parts on the page.

Cross-site publishing is available only in SharePoint Server 2013. If you are using SharePoint Online, you can use the author-in-place method to publish content.

This article describes the use and benefits of cross-site publishing, describes the authoring and publishing site collections, and describes how the search system crawls and indexes content and metadata. Finally, this article discusses important limitations of cross-site publishing. After you read this article, make sure that you read the next article, Plan the logical architecture for cross-site publishing in SharePoint Server 2013. For information about other publishing methods, and how to decide whether to use cross-site publishing, see Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013 and Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013.

In this article:

  • Use and benefits of SharePoint cross-site publishing

  • Authoring site collections for SharePoint cross-site publishing

  • Publishing site collections for SharePoint cross-site publishing

  • Search for SharePoint cross-site publishing

  • Limitations of SharePoint cross-site publishing

Use and benefits of SharePoint cross-site publishing

You can use cross-site publishing to reuse content in several different ways. You can use it to make content from a single authoring site collection available to a single publishing site collection (1:1), to make content from a single authoring site collection available to one or more publishing site collections (1: n), to make content from more than one authoring site collection available to a single publishing site collection (n: 1), or to make content from more than one authoring site collection available to more than one publishing site collection (n:n). How you use cross-site publishing is determined by the type of publishing solution that you want to create. The following table describes possible scenarios in which you might use cross-site publishing.

SharePoint cross-site publishing scenarios

Scenario | Description
Internet site | You can use cross-site publishing to create an Internet business site that contains a catalog that shows products to customers, based on metadata. Users view pages that are created dynamically based on navigation, and filter results based on additional refinements. The site may also show content such as a company contact page, shipping and handling rates, and job openings. Content is authored internally, and is made available to anonymous users outside the firewall.
Intranet site | You can use cross-site publishing to create an internal Human Resources (HR) website that uses a tightly managed navigation structure to show authored content. Content is authored by a small group of people, and consumed by a large group of people with the Read permission level.
Extranet site | You can use cross-site publishing to create a knowledge base that is available to internal and external users in an extranet site. Content authors tag pages with metadata to categorize articles so that users can search or browse for specific information, such as troubleshooting articles, support issues, and service packs.
Multilingual sites | You can use cross-site publishing together with the variations and translation features to create multiple sites that show translated content for specific languages or locales. For example, you can have English, French, and German content that is shown on sites that have .com, .fr, and .de addresses. Internet, intranet, and extranet sites can all be multilingual sites.

In SharePoint Server 2013, cross-site publishing provides the following benefits:

  • Provides a broad range of possible site architectures.

  • Separates content authoring from branding and rendering.

  • Allows content to be shared anonymously with users on the publishing site.

  • Can be used across site collections, web applications, and also across farms.

  • Allows for a mix of authored pages and list content.

Authoring site collections for SharePoint cross-site publishing

When you use cross-site publishing, you create and store content in a different site collection than the site collections where users view the content. The authoring site collection contains Pages libraries and lists, which have been shared as catalogs. This section explains the features that are involved when you set up the authoring site collection for the content that will be reused across publishing site collections.

Types of content

You can store different types of content in libraries and lists in the authoring site collection. By sharing these libraries and lists as catalogs, the data that they contain can be reused in one or more publishing site collections. By default, only HTML content is indexed and returned by the search system. Non-HTML content, such as Word documents and PDFs, is not stored in the index, and must be referenced directly. The following list describes the different types of content that you can use in an authoring site collection.

  • Pages library. You can use a Pages library to create any HTML content that you plan to reuse across site collections. By using a Pages library, you can take advantage of the Approval workflow and content scheduling features that are part of the SharePoint publishing feature set. For more information about the Approval workflow and content scheduling, see Plan content approval and scheduling.

    Note:

    You can have only one Pages library per site. However, you can have multiple sites within a site collection, and thereby put Pages library content into separate catalogs.

  • List. You can use one or more lists to store any type of data that is better stored in a list than in Pages library content. For information about when to use a Pages library and when to use a list, and how to plan Pages libraries and list content, see Plan for cross-site publishing in SharePoint Server 2013.

  • Asset library. You can use one or more Asset libraries to store binary large object files (BLOBs) such as pictures, audio, or video files, if those files contain the primary content that you want to show on the publishing site. Asset libraries that are used to contain BLOBs that are referenced by Pages or lists, such as PDFs or product images, represent a different type of content, and are handled differently for cross-site publishing. For more information about referencing images and other BLOBs in catalogs, see "Plan asset library content" in the "Plan catalog content for authoring sites" section in Plan authoring sites for cross-site publishing in SharePoint Server 2013.

  • Document library. You can use one or more standard SharePoint document libraries to store files such as Word and Excel documents. However, because these types of files are also considered BLOBs, you treat Document libraries in the same manner that you treat Asset libraries. For more information about referencing images and other BLOBs in catalogs, see "Plan asset library content" in the "Plan catalog content for authoring sites" section in Plan authoring sites for cross-site publishing in SharePoint Server 2013.

Tagging term sets

In authoring sites, you use term sets to tag content. When you tag content with one or more terms, the terms become part of the metadata that is associated with the content. When the search system adds content to the index, it also adds the associated metadata. That metadata is later used in the publishing site collections when content is shown on pages, and when used for managed navigation.

Catalog configuration

Before the content in the libraries and lists can be reused across publishing site collections, you have to share libraries and lists for use as catalogs. When you share a library or list as a catalog, you specify that you want to share it with other sites and site collections. You can also choose to enable anonymous access to the content in the catalog. You also select up to five fields that are used to uniquely identify items in the catalog. Finally, you specify a single managed metadata field that is used as a navigation term set in the publishing site collections. After a library or list is shared as a catalog, and the content has been crawled and indexed, you can connect to it from a publishing site collection. For more information about how to connect publishing site collections to catalogs, see "Plan catalog connections for publishing sites" in Plan publishing sites for cross-site publishing in SharePoint Server 2013.

Note:

Before you share a library or list as a catalog, you must add at least one piece of content, and you must tag it with a term from the tagging term set. In addition, when the managed metadata site column that is associated with the tagging term set is created, it must be a single value field.

Publishing site collections for SharePoint cross-site publishing

When you use cross-site publishing, search technology is used to determine what content is shown to users. This section describes the features that are involved when you build a publishing site that obtains data from libraries or lists that are shared as catalogs. It also describes how you can use search features to influence what, and in which order, content is shown to users.

Master pages and page layouts

Because content from one or more authoring site collections is shown on one or more publishing site collections, you have to configure the publishing site collections to support the branding needs of your solution. This includes designing the master pages, page layouts, and cascading style sheets that you use to show content. You can also configure image renditions that are used to control how images are shown on the site. For more information about how to design for SharePoint publishing sites, see SharePoint page model overview.

Navigation term sets

You use term sets to create the site navigation in publishing site collections. Term sets that were used for tagging content on the authoring site collection can be pinned to the navigation term set that is used by the publishing site collection. By configuring individual terms in the Term Store Management Tool, you can customize the navigation for the whole site. You can also add new terms, or use terms from other term sets, to additionally customize the site navigation. If you are creating multilingual sites, you can copy the navigation term set and translate it into the same languages that are used for variation labels.

Catalog connections

Before you can show content from an authoring site collection, you have to configure the catalog connections in the publishing site collection that will consume those catalogs. When you configure catalog connections, you specify which catalogs the publishing site collection will use to show content. When you configure a catalog connection, you specify information such as whether to integrate catalog content into the site, where to put the categories to use for navigation, the term set that was used for tagging, and how category item URLs should be constructed. For more information about how to connect publishing site collections to catalogs, see "Plan catalog connections for publishing sites" in Plan publishing sites for cross-site publishing in SharePoint Server 2013.

Category pages and catalog item pages

Category pages and catalog item pages are page layouts that you can use to show structured catalog content consistently across a site. By default, SharePoint Server 2013 can automatically create one category page layout and one catalog item page layout per catalog connection. Pages based on these layouts are created in the Pages library of a publishing site when you connect the site to a catalog. These pages have the following considerations:

  • They are not published for you.

  • You should edit the HTML of the page layouts. The category page layout and the catalog item page layout are meant to be used to get you started.

  • When you edit the HTML page layouts, they are synced back to the corresponding ASPX pages. If you prefer to edit the ASPX pages directly, you should first delete the HTML version.

By using category pages and catalog item pages, you do not have to create many individual pages for content that you want to show in the same manner across your site. Category pages and catalog item pages are often used in combination with managed navigation and Search Web Parts. You can associate a category page or catalog item page with a specific term within the term set that is used for managed navigation. For example, in an intranet scenario, all company events are maintained as items in a list that is shared as a catalog. In the list, each event is tagged with a term from a term set that defines the different departments within the company — for example, Marketing, or Human Resources. You want the information about the events to be shown in the same manner across your site — for example, an overview page showing all events for each department, and one page per individual event. To avoid having to create an overview page for each department, you can create one category page that you can use to show the overview of events for all departments in the same manner. You can also create a catalog item page that you can use for each event. Then you configure Search Web Parts on the category pages or catalog item pages to make sure that the content that is shown to users varies depending on the event information that is maintained in the list that you shared as a catalog.

By default, a page based on the category page layout is added to the Pages library with the name Category-<catalog name>. The page is applied to all levels, except the last (catalog item), within the catalog navigation structure. For example, in an Internet business scenario where you connect to a list of electronic products, the default category page is applied to all terms within the term set that is used for catalog navigation, such as Computers, Audio, Laptops, and MP3 players. The association between a category page and a term is shown in the Term Store Management Tool, on the TERM-DRIVEN PAGES tab. The category page layout has the following features:

  • The category page layout has four Web Part zones: Body, Left, Bottom Center, and Right.

  • A Content Search Web Part is added to the Body Web Part zone.

  • The query in the Content Search Web Part is pre-configured to use the result source that is automatically created during catalog connection. The result source limits search results to the current and sub-page navigation terms.

  • The item display template that is used is Picture on top, 3 lines on bottom (known as Item_Picture3Lines in the Master Page Gallery).

By default, a page based on the catalog item page is added to the Pages library with the name CatalogItem-<catalog name>. The page is applied to the last level (catalog item), within the catalog navigation structure — for example, to show the individual product Contoso Digital Camera M200. The association between a catalog item page and items within the catalog appears in the Term Store Management Tool, on the TERM-DRIVEN PAGES tab. The catalog item page layout has the following features:

  • The catalog item page has one Web Part zone, Body.

  • A Catalog-Item Reuse Web Part is added to the Body Web Part zone.

  • The query in the Catalog-Item Reuse Web Part is pre-configured to use the result source that was automatically created during catalog connection, and to limit search results based on an additional query filter.

  • In addition to the Catalog-Item Reuse Web Part in the Body Web Part zone, one server-side Catalog-Item Reuse Web Part is added to the catalog item page layout for each indexed field in the catalog. By default, all Catalog-Item Reuse Web Parts on a page use the same query as the first Catalog-Item Reuse Web Part. These fields render server-side in the page layout, and can only be changed by editing the catalog item page layout directly. Because these are server-side Web Parts, you should edit the HTML source page to specify the HTML that is rendered together with the catalog content.

For more information about category pages and catalog item pages, see "Plan category pages and item detail pages" in Plan publishing sites for cross-site publishing in SharePoint Server 2013.

Search Web Parts

Search Web Parts use search technology to show content that was crawled and added to the index. In Search Web Parts, queries are configured so that a subset of content from the search index is shown in a particular ranking order. When users browse to a page that contains a Search Web Part, the Web Part automatically issues the query. The result is then shown in the Web Part.

Search Web Parts are often used in combination with managed navigation and category pages and catalog item pages. For example, in an Internet business scenario where a product catalog is shown, a term within the term set specified for managed navigation is associated with a specific category page. A Content Search Web Part on a category page can have the current navigation category (term) as part of the query. When users browse to a category, such as Computers, the Web Part issues a query that returns and shows all items in the search index that are categorized as Computers. Similarly, when users browse to the category Audio, the same Web Part on the same category page will show items in the search index that are categorized as Audio.

To influence how the query is written, or to increase the relevance of search results, you can use result sources and query rules. For more information, see "Plan result sources and query rules" in Plan search for cross-site publishing sites in SharePoint Server 2013.

For more information about Search Web Parts, see "Plan to add Search Web Parts to pages" in Plan publishing sites for cross-site publishing in SharePoint Server 2013.

Search for SharePoint cross-site publishing

When you use cross-site publishing, you use search technology to retrieve and show content. The search index is the center of search. The queries that are specified in the different Search Web Parts on the publishing site are sent to the search index to retrieve relevant content and show it in the Web Part.

This section explains how content is added to and managed in the search index.

Understanding how content is added to and managed in the search index

To get content into the search index from catalogs, you must first create a content source and start a full crawl. After the content is crawled, you have to manage the content metadata in the search index.

Content sources and crawling

To build the search index, you must first start a full crawl of content that is specified in one or more content sources. A content source is a set of options that you can use to specify what type of content is crawled, what URLs to crawl, and how frequently the content should be crawled. Content sources are set up and maintained in Central Administration by a Search service application administrator. For more information, see "Plan content sources and crawling" in Plan search for cross-site publishing sites in SharePoint Server 2013.

Content metadata in the search index

When content is crawled, the metadata of the items that are crawled are represented as crawled properties. To include crawled properties in the search index, crawled properties are mapped to managed properties. This is because only managed properties are included in search results.

To avoid having to manually map crawled properties to managed properties for a catalog, SharePoint Server 2013 automatically creates managed properties for all site columns. In a catalog, managed properties are the specifications of the items in the library or list, such as Author, Date, Article Type, Color, or Product Category. For more information, see Automatically created managed properties in SharePoint Server 2013.

You can specify settings for managed properties to affect how content is shown in Search Web Parts and in search results. The settings are maintained in the search schema. For more information about managed property settings, see "Plan to manage managed properties in the search index" in Plan search for cross-site publishing sites in SharePoint Server 2013.

Result sources and query rules

Result sources are used in Search Web Parts to narrow the scope of search results that are shown in the Web Part. In SharePoint Server 2010, this kind of restricted query was called a search scope. One way to quickly understand the concept of a result source is to think of it as a reusable query. You can create result sources to specify a location from which search results can be retrieved — for example, the URL for a catalog, or to specify that search results can only be retrieved for a particular item type — for example, pictures.

A query rule is a set of conditions that cause the query to be changed in a specific way. An easy way to think of a query rule is to think, "if X happens, then do Y." Query rules are used to limit the type of content that can appear in search results, and to influence the order in which search results should appear. When you configure a query rule, you specify query conditions that cause the query rule to be triggered. For example, a query condition could specify that a query matches a specific term in a term set, or that a query matches a particular search term. Additionally, you specify the actions that should happen to the search results when the query rule is triggered. For example, an action could be to show a specific item at the top of the search results. Say you have an intranet site where all company events are maintained in a list that you have shared as a catalog, and you want to promote a first-aid seminar. To do this, you create a query rule that raises the first-aid seminar to the top of the search results when someone searches for "seminar" or "event."

You can configure query rules for one or more result sources, and you can specify the time period during which the query rule is triggered.

For more information about result sources and query rules, see "Plan result sources and query rules" in Plan search for cross-site publishing sites in SharePoint Server 2013.

Refiners and faceted navigation

You can add refiners to a page to help users quickly browse to specific content. Refiners are based on managed properties from the search index. To show refiners on a page, you must first enable the managed property that you want to use as a refiner, and then add a Refinement Panel Web Part to the page where you want the refiners to appear. For example, in an intranet scenario in which you have a catalog of knowledge base articles, you might add the managed property Author as a refiner. The Refinement Panel Web Part will list all authors of the knowledge base articles. When users click a specific author name, only knowledge base articles written by that author are listed.

SharePoint Server 2013 has faceted navigation to help users browse for content more easily by filtering on refiners that are tied to terms in a term set. By using faceted navigation, you can configure different refiners for different terms in a term set without having to create additional pages. For example, in an Internet business scenario in which a catalog of electronic products is shown, a term set might be used to categorize different products, such as computers or cameras. The same category page is used for both terms. After you enable the managed properties Screen size and Megapixels as refiners, you can configure faceted navigation so that Screen size is shown as a refiner for computers, and Megapixels is shown as a refiner for cameras. This means that you don't have to create additional pages to guide users to content that is relevant for a specific category.

For more information, see "Plan refiners and faceted navigation" in Plan search for cross-site publishing sites in SharePoint Server 2013.

Usage analytics and recommendations

Usage analytics in SharePoint Server 2013 automatically tracks how different items are viewed by users. Items can be documents, pages, or list items that are shown on a site. Every time that a user views an item, the system issues a usage event and adds the event to the total and recent view counts for that item.

You can use the usage analytics information to configure recommendations on your site. The recommendations that are shown are based on how users previously interacted with a site, tracked by the usage events. The recommendations feature can guide the users to other content that may be relevant for them, related to what they are viewing. For example, you can guide users to popular items in a category or let them know that users who viewed this item also viewed these other items. You add recommendations to a page by adding the Recommended Items Web Part or the Popular Items Web Part.

You can also view data about usage events in usage reports.

For more information, see Overview of analytics processing in SharePoint Server 2013.

For more information about recommendations, see "Plan usage analytics, usage events and recommendations" in Plan search for cross-site publishing sites in SharePoint Server 2013.

Limitations of SharePoint cross-site publishing

The following list contains information about the limitations of the cross-site publishing feature in SharePoint Server 2013.

  • Content is not shown in publishing site collections until it is indexed.

    Content stored in authoring site collections must be indexed before it will be made available to publishing site collections. The search system only indexes items that are major versions. This means that if you create Pages content and use the Approval workflow or content scheduling, the search system will not index Pages content that has not been approved for publishing, or that has not yet reached its scheduled publication date because it is not yet marked as a major version. In addition, the term associated with that content will not appear in the navigation on the publishing site. When the content is published, the term will be immediately available in the navigation on the publishing site. However, content does not appear in results on the publishing site until the content is crawled and indexed.

  • The term store does not support versioning.

    If you add terms to the term store too early in the process, you can expose navigation terms on the publishing site collection before any related content is ready. Changes to terms are immediate, and there is no history for term sets. Therefore, if you change a term, you cannot revert it back to a previous value.

  • There is no Approval workflow for lists.

    Only the Pages library has an Approval workflow. If you add an item to a list that is shared as a catalog, it will automatically get added to the search index the next time that the catalog is crawled. We recommend that you either use versioning, or do not add items to a list that is shared as a catalog until you are ready to tag content and have it appear on the publishing site collection.

  • Using variations for multilingual sites requires adjustments to the site architecture.

    How you use variations in your publishing solution will depend on whether you have Pages or list content, and whether you intend to show the content on one or more publishing site collections. Either case will require changes to the site architecture for your solution. For more information, see Plan for variations (SharePoint Server 2010).

See also

Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013
Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013
Plan for cross-site publishing in SharePoint Server 2013
Plan the logical architecture for cross-site publishing in SharePoint Server 2013
Plan authoring sites for cross-site publishing in SharePoint Server 2013
Plan publishing sites for cross-site publishing in SharePoint Server 2013
Plan search for cross-site publishing sites in SharePoint Server 2013
Configure cross-site publishing in SharePoint Server 2013
Estimate capacity and performance for Web Content Management (SharePoint Server 2013)


Plan the logical architecture for cross-site publishing in SharePoint Server 2013
See also

Published: August 21, 2012

Summary: Learn about components and typical architectures for SharePoint cross-site publishing sites.

Applies to: SharePoint Server 2013 Enterprise

Cross-site publishing is a publishing method in SharePoint Server 2013 in which you use one or more authoring site collections to author and store content, and one or more publishing site collections to control the design of the site and to show content. The authoring site collection can contain catalogs such as Pages libraries, and lists of items that are tagged with metadata. These catalogs are indexed by the search system and made available to the publishing site collection. The publishing site collection takes the data that has been indexed and shows it on web pages by using Web Parts that use search technology (referred to in this article as Search Web Parts). For more information, see Overview of cross-site publishing in SharePoint Server 2013.

This article describes the components of a cross-site publishing architecture and illustrates typical cross-site publishing architectures.

Components of a SharePoint cross-site publishing architecture

Most cross-site publishing architectures include two or more site collections, which separate the authoring environment from the publishing environment. The number of authoring and publishing site collections that you create depends on project requirements such as how many catalogs there will be and where they are located, and how many publishing sites will show the content. The number of application pools and web applications that you require depends on the type of site you want to create. For example, an intranet site might use the same application pool and web application for both authoring and publishing site collections. Conversely, an Internet site's authoring site collection would be inside the company firewall, and the publishing site collection might be in a separate application pool and web application that is configured to allow anonymous access for users. Because cross-site publishing works across web applications and server farms, you can create a cross-site publishing solution that fits your SharePoint Server 2013 topology. For more information, see Logical architecture components (SharePoint Server 2010).

Before you begin to plan the components that go into a cross-site publishing architecture, consider the following questions:

  • What types of publishing sites are you creating? Are they Internet, intranet, or extranet sites?

  • What kind of access will users have? Do you want to allow anonymous access, or authenticated users, or both?

  • Do you need to separate sensitive content for a limited audience from content that will be accessible to a larger audience?

The following sections describe the components about which you must make key decisions as you plan the logical architecture for a SharePoint solution that uses cross-site publishing.

Authoring site collections

Authoring site collections are where content is authored or stored. You can have one or more authoring site collections. A single site collection can have multiple libraries and lists. However, there can be only one Pages library per site. If you want to separate content into multiple Pages libraries, you must either create multiple site collections, or create multiple sites within a site collection. For more information, see "Plan site collections and site structure for SharePoint authoring sites" in Plan authoring sites for cross-site publishing in SharePoint Server 2013.

Library and list content in authoring site collections is tagged by using terms in a managed metadata site column. When the content is indexed by the search system, the column is included as metadata in the index, and is used to categorize content to appear in the publishing site collection.

You can create library and list content at the root of the site collection. However, if you think that you might eventually use variations in your site, we recommend that you create a site within the site collection, and create content there. If you later decide that you need to use variations, this will enable you to specify the site as the source variation site, and will simplify the creation of a variations hierarchy within the site collection.

As you plan authoring site collections for your cross-site publishing architecture, consider the following questions:

  • How many authoring site collections do you have to have?

  • Do any of the authoring site collections have to be in a separate web application?

  • Will you have separate groups of content authors that belong to separate security groups?

Publishing site collections

Publishing site collections are where content is shown. You can have one or more publishing site collections. However, you do not have to create a site within the site collection, as recommended for authoring site collections. Typically, publishing site collections have URLs that separate sites based on criteria such as location, locale, or brand. This is often helpful when search engine optimization is an important business need. For example, for an extranet site, you might have one publishing site collection named https://partnerweb.contoso.com for external partners, and another publishing site collection named https://customerweb.contoso.com for customers.

As you plan publishing site collections for your cross-site publishing architecture, consider the following questions:

  • How many publishing site collections do you have to have?

  • Do any of the publishing site collections have to be in a separate web application?

  • Do you want to use multiple web applications to improve search engine optimization?

  • Will you have separate groups of site users who will use different types of authentication?

Search

When you use cross-site publishing, you use search technology to retrieve and show content. The queries that are specified in the different Search Web Parts on the publishing site are sent to the search index to retrieve relevant content and show it in the Web Parts. Accordingly, the search crawler must have access to content on authoring site collections. For more information, see "Plan crawler authentication" in Plan crawling and federation in SharePoint 2013.

Content is shown on the publishing site collection based on search queries. The queries use terms from one or more term sets that were used to tag content on the authoring site. These terms are pinned to the navigation of the publishing site collection, where they are used to build the queries that get and show content from the search index. For more information, see "Plan term sets for tagging content on SharePoint authoring sites" in Plan authoring sites for cross-site publishing in SharePoint Server 2013, "Plan navigation term sets for SharePoint publishing sites" in Plan publishing sites for cross-site publishing in SharePoint Server 2013, and "Plan result sources and query rules" in Plan search for cross-site publishing sites in SharePoint Server 2013.

Asset libraries

Asset libraries contain binary large objects (BLOBs) such as pictures and video files that are used in content on the authoring site. These assets must be accessible by two separate groups of users: content authors on the authoring site, and readers on the publishing site. If the publishing site is an Internet site available to anonymous users, the asset library must be in a separate site collection from the authoring site, and must be in a web application that is configured to allow anonymous access. This could be in the same web application as the publishing site, or in a separate web application. In either case, designers or content authors must be able to upload files to the asset library, and the library should be added to the list of Suggested Content Browser Locations for the authoring site so that content authors can locate and use assets stored within the library.

As you plan asset libraries for your cross-site publishing architecture, consider the following questions:

  • Where will assets be located?

  • How will publishing site users be granted access to see assets that are referenced in content that is shown on the publishing site?

  • How will content authors on the authoring site locate assets and insert them into content?

Typical SharePoint cross-site publishing architectures

This section illustrates typical architectures for cross-site publishing. These architectures are examples of how you might structure your architecture for an intranet, extranet, and Internet site. However, there are many different ways in which you can arrange the architecture for your solution. For more information about how to plan the logical architecture for your solution, see Logical architecture components (SharePoint Server 2010).

Intranet site

The following figure shows a simple one-to-one (1:1) authoring-to-publishing site configuration for a published intranet site.

Published intranet sample architecture

Both site collections are located within a single web application that uses claims-based authentication. The authoring site collection (http://authoring) contains a single Pages library, and can also contain one or more lists or libraries that are not Pages libraries. All libraries and lists are shared as catalogs. The catalog content is shown in a single publishing site collection (http://contosoweb).

Because the authoring and publishing site collections are in the same web application, asset library files are stored in the authoring site collection, and site users on http://contosoweb have read access to those assets.

The search system indexes content from the authoring site. When a user views a page on the publishing site, queries from Search Web Parts on that page are sent to the search index. Results are returned from the search index and shown in the Search Web Parts on the page.

Extranet site

The following figure shows a one-to-many (1:n) authoring-to-publishing site configuration for a published extranet site.

Published extranet sample architecture

The authoring and publishing site collections are located in separate web applications. The Authored content web application uses Active Directory Domain Services (AD DS) for authentication of content authors, whereas the web application that contains the Published extranet sites uses forms-based authentication for designers, customers, and partners. The extranet sites are located in a single web application, but are in separate site collections to provide for greater isolation between customers and partners. The authoring site collection (http://authoring/) contains two sites, one for customer content (http://authoring/customer) and one for partner content (http://authoring/partner). Each site contains a single Pages library, and can also contain one or more lists. All libraries and lists are shared as catalogs. The Pages library and list content is shown in two separate publishing site collections, one named https://customerweb.contoso.com for customers, and one named https://partnerweb.contoso.com for partners. For more information about how to plan an extranet site architecture, see SharePoint 2013 design samples: Corporate portal and extranet sites.

Because the publishing site collections are outside the firewall, the asset library is located in a separate site collection in the same web application as the published extranet site collection so that users on the publishing sites have read access to those assets. Internal users such as designers and other content authors have the Contribute permission level to add, update, and delete items in the asset library. The asset library is added to the Suggested Content Browser Locations list for the authoring site collection so that content authors can use those assets in their content.

The search system indexes content from the authoring site. When a user views a page on one of the publishing sites, queries from Search Web Parts on that page are sent to the search index. Results are returned from the search index, and shown in the Search Web Parts on the page.

Internet site

The following figure shows a many-to-many (n:n) authoring-to-publishing site configuration for a published Internet site that includes a separate product catalog.

Published Internet sample architecture

The authoring and publishing site collections are located in separate web applications. The Authored content web application uses AD DS for authentication of content authors, whereas the Published Internet sites web application uses forms-based authentication for designers and is also configured to allow anonymous access for external users. The authoring site (http://authoring) contains a single Pages library. The product catalog site collection (http://products) contains a list of product data. All libraries and lists are shared as catalogs. The catalog content appears in two separate publishing site collections, one named http://www.contoso.com and one named http://www.fabrikam.com. Different content and products are shown on the publishing sites based on the associated brand.

Because the publishing site collections are outside the firewall, the asset library is located in a separate site collection in the same web application as the publishing site collections so that users on the publishing sites have read access to those assets. Internal users such as designers and other content authors have Contribute permission level to add, update, and delete items in the asset library. The asset library is added to the Suggested Content Browser Locations list for the authoring and product catalog site collections so that content authors can use those assets in their content.

The search system indexes content from the authoring site and the product catalog site collection. When a user views a page on one of the publishing sites, queries from Search Web Parts on that page are sent to the search index. Results are returned from the search index, and shown in the Search Web Parts on the page.

See also

Plan for cross-site publishing in SharePoint Server 2013
Overview of cross-site publishing in SharePoint Server 2013
Plan authoring sites for cross-site publishing in SharePoint Server 2013
Plan publishing sites for cross-site publishing in SharePoint Server 2013
Plan search for cross-site publishing sites in SharePoint Server 2013
Configure cross-site publishing in SharePoint Server 2013
Estimate capacity and performance for Web Content Management (SharePoint Server 2013)


Plan authoring sites for cross-site publishing in SharePoint Server 2013
See also

Published: August 21, 2012

Summary: Learn how to plan authoring site collections for a SharePoint cross-site publishing solution.

Applies to: SharePoint Server 2013 Enterprise

When you use cross-site publishing in SharePoint Server 2013, you use one or more authoring site collections for authoring and storing content, and one or more publishing site collections to control the design of the site and show content. This article describes how to plan authoring sites for your cross-site publishing solution.

In this article:

  • Plan site collections and site structure for SharePoint authoring sites

  • Plan security for SharePoint authoring sites

  • Plan design and branding for SharePoint authoring sites

  • Plan term sets for tagging content on SharePoint authoring sites

  • Plan catalog content for SharePoint authoring sites

This article builds on the information in Overview of cross-site publishing in SharePoint Server 2013. After you finish reading this article, make sure that you read the next article, Plan publishing sites for cross-site publishing in SharePoint Server 2013.

Plan site collections and site structure for SharePoint authoring sites

Authoring site collections must have the SharePoint Server 2013 Cross-Site Collection Publishing feature activated. We recommend that you use the Product Catalog Site Collection template to create authoring site collections because the Cross-Site Collection Publishing feature is activated by default when you use that template. If you use a site collection template that does not have the Cross-Site Collection Publishing feature activated, you must activate it. Additionally, if you use a site collection template, such as the Team Site template, that does not create a publishing site, and you want to use publishing features such as Approval workflows and scheduling, you must also activate those publishing features. For information about activating the Cross-Site Publishing feature, see "Activate the Cross-Site Collection Publishing feature" in Configure cross-site publishing in SharePoint Server 2013. For more information about how to use the publishing features on a site that is not a publishing site, see Publishing features overview (SharePoint Server 2010). For information about how to activate the publishing features, see Enable publishing features. For more information about how to design the logical architecture for a cross-site publishing solution, see Plan the logical architecture for cross-site publishing in SharePoint Server 2013.

Because cross-site publishing separates the authoring and publishing environments, the structure of an authoring site can differ from the structure of the publishing site. As you plan how to structure authoring sites, consider the questions in the following list.

  • Should you use a Pages library or a list for content?

    In SharePoint Server 2010, publishing sites used Pages libraries to store HTML content that was shown to users. By using cross-site publishing in SharePoint Server 2013, you can also use lists and other libraries to store the content that is reused on the publishing sites. When you plan for where you can store this content, consider what the content is and how you plan to use it. In general, if you plan to author HTML content, we recommend that you use a Pages library instead of a list. A Pages library has the following benefits over a list:

    • You can create a more WYSIWYG environment for authoring pages to give authors an idea of how their content will appear on the publishing site.

    • You can use variations and translation with a Pages library to create multilingual content.

    • You can use the Approval workflow to route Pages library content for review and approval. The search system will not index pages that are not approved for publishing because they are not marked as major versions until they are published.

    • You can use scheduling to specify when content will be available. The search system will not index pages that have not been scheduled for publishing. This is because pages are not marked as major versions until they are published.

  • How many Pages libraries do you have to have?

    The primary drawback to using a Pages library is that you can have only one Pages library per site. Depending on how much Pages content you plan to create, a single, large catalog can be difficult to consume on publishing sites because the queries that show content are more complex and time-consuming to configure. Accordingly, when you plan Pages content, consider how much content you will create and whether the content should be stored together. If you want to store Pages content in separate catalogs, you must create separate sites within the authoring site collection hierarchy, and then share the Pages library in each site as a catalog. You can then connect to these catalogs from one or more publishing sites.

    For example, in an intranet scenario in which you have a knowledge base site, you might want to keep troubleshooting articles separate from user manuals because they are authored by different groups of people. In the authoring site collection, you create one site to store troubleshooting articles in its Pages library, and another site to store user manuals in its Pages library. After you share both Pages libraries as catalogs, you can connect to them both from the same publishing site, and show the two types of content by using different Web Parts.

  • How many authoring site collections do you have to have?

    In addition to deciding how many sites you must have in a single authoring site collection, you should also consider whether you have to have additional authoring site collections. You might use more than one authoring site collection if the content authors are in separate groups that have different security requirements, or are in separate geographical locations. For example, in an extranet scenario, you might use one authoring site collection for internal content authors who belong to a specific group in Active Directory Domain Services (AD DS), and a separate authoring site collection for external content authors who connect to the site by using forms-based authentication. Catalogs can be shared across web applications and farms so that you do not have to restrict authoring sites to a single web application or farm. Decide how many authoring site collections you must have, and then plan which catalogs to include in each site.

  • Do you plan to use variations to create multilingual content?

    Do you have to provide content in more than one language? Even if you currently plan to only create and publish content in a single language, consider whether that business requirement might change in the future. If you might eventually want to use variations on the site, you should plan for using variations now. By setting up the site structure now to accommodate variations, you can save yourself and your organization time and resources in the future. If you have to change the site structure when you switch to using variations later, it is often more difficult and can affect the URLs that you planned for your sites. If you plan to use variations and cross-site publishing, each variation label has to be created as a separate site within the authoring site collection. You share the Pages library from each variation site as a catalog, and then you connect each publishing site collection to the catalog that matches its locale. For more information about variations, see Variations overview (SharePoint Server 2010). For more information about how to plan variation sites, see Plan variations (SharePoint Server 2010).

  • What kind of navigation do you have to have on the authoring site?

    Although you can use managed navigation on the authoring site so that the authoring site resembles the publishing site, this can confuse content authors. We recommend that you use structured navigation on the authoring site to make it easier for authors to create content. Consider the kind of content that will be created and stored on the authoring site. Will most content be HTML content that is stored in the Pages library? Or will you manually create or import list data? If you keep a simple structure for the authoring site and any lists and libraries, it makes it easier for content authors to create content.

Plan security for SharePoint authoring sites

You plan security for authoring sites in the same way that you do for most other sites in SharePoint Server 2013. Consider the following questions:

  • Who should have permissions to create the different kinds of content that is contained within the authoring site?

  • Who should have permissions to create Pages content?

  • Can the same group of people also create list content, or is a separate group responsible for that content?

  • If you plan to use the Approval workflow, who should be included in the Approvers group? For more information, see Plan content approval and scheduling (SharePoint Server 2010).

For information about security, see Permissions planning for sites and content in SharePoint 2013.

When you enable anonymous access for a catalog, security on the authoring site can be treated independently from how it is represented in search. When anonymous access is enabled, indexed content is searchable and viewable to anonymous users on the publishing site. However, if you change permissions to individual items in the catalog, those permissions are respected by the search system, and any items that are restricted to certain groups will not be available to anonymous users. This allows for greater flexibility when you plan to share content with anonymous users.

You must also plan to grant the crawler access to content on authoring site collections. The crawler uses a default content access account. If the default content access account does not have at least Read permission level to content, the content is not indexed and is not available to queries on publishing site collections. You can use the default content access account, or you can use crawl rules to specify a different content access account to use when crawling particular content. For more information, see "Plan crawler authentication" in Plan crawling and federation in SharePoint 2013.

Plan design and branding for SharePoint authoring sites

As was mentioned earlier in this article, the structure of the authoring sites can differ from the structure of publishing sites. Likewise, the appearance of those sites can also be very different. If you want content authors to have a WYSIWYG user experience on the authoring site, you can use similar master pages, page layouts, and cascading style sheets to design the authoring site. However, the actual publishing sites might have different designs because of branding or other requirements. Therefore, the authoring site will not provide a complete WYSIWYG experience.

Even if you do not plan to apply the same branding to the authoring site that you use on the publishing site, if you plan to use Pages library content, you still have to plan for the basic page layouts that authors will use. As you plan the design of the authoring site, consider the following questions:

  • What site columns must you have? Site columns can be added as page fields to page layouts to hold additional content, such as managed metadata.

  • What content types must you have? You can create custom content types that use the Article Page content type as the parent content type. You can add site columns to the custom content type, which will be included as page fields in any page layouts that you create by using the custom content type.

  • Can you use the default master page? You might use the default master page, or create a new master page to use on the authoring site.

  • What page layouts must you have? You can create custom page layouts that contain specific page fields. For example, in an intranet scenario in which you have a knowledge base, you might create separate page layouts for troubleshooting guides and user manuals.

For information about authoring web pages, see SharePoint page model overview, Plan Web pages (SharePoint Server 2010) and Plan Web page authoring (SharePoint Server 2010).

Plan term sets for tagging content on SharePoint authoring sites

You use term sets to tag catalog content such as pages or list items on the authoring site. By doing this, terms help categorize the content into a hierarchy. These same terms are later used on the publishing site to issue queries, show information about category and catalog item pages, create friendly URLs, and for managed navigation. When you plan the term sets and terms to use for tagging content, consider how you want the hierarchy structured. You can combine terms from more than one tagging term set into a single customized term set for navigation on the publishing site. You do not have to create a single, highly complex structure for the tagging term set on the authoring site. Also consider how you want the URLs to look on the publishing site, and plan to create terms that will help users find what they want. For example, if you have a level 1 term called Computers, and underneath that, a level 2 term called Laptops, and the catalog item name is CM61438, the friendly URL for the page that shows that model will be http://contoso.com/computers/laptops/CM61428. For more information, see Plan terms and term sets in SharePoint Server 2013.

For information about creating term sets for tagging content, see "Create and manage term sets for tagging content on authoring sites" in Configure cross-site publishing in SharePoint Server 2013.

Plan catalog content for SharePoint authoring sites

Catalogs contain the content that is reused across site collections. You can use HTML content in a Pages library, data in a list, or assets such as pictures and video in an asset library. For example, in an Internet business scenario, you might use a list to show a catalog of products, or in an intranet scenario, you might use a Pages library to show a catalog of knowledge base articles. In either example, you might also have assets that you want to associate with content, such as pictures of products or videos that explain troubleshooting steps. This section describes how to plan for different kinds of catalog content in an authoring site.

For information about how to enable a library or list as a catalog, see "Share a library or list as a catalog" in Configure cross-site publishing in SharePoint Server 2013.

Plan Pages libraries

After you decide whether to store content in one or more Pages libraries, and how to divide content between them, consider the following questions:

  • What term set will you associate with Pages library content?

    If you use a Pages library, you must plan to add at least one managed metadata site column to a Page Layout Content Type, and link the site column to a tagging term set. When a content author creates a new page that uses that content type, they will be able to select a term with which to tag the page. For example, in the intranet knowledge base scenario, you might have a tagging term set that is named Article Types that contains separate terms for Troubleshooting Guides and for User Manuals. You can create a site column called Article Type that is linked to the Article Types term set, and add it to the Article Page content type. When a content author creates a new page, they must choose a term from the list of available Article Types terms. When the Pages library is shared as a catalog, you have to select that managed metadata column as the one to use as a navigation term set on the publishing sites. For more information, see Plan term sets for tagging content on SharePoint authoring sites earlier in this article.

  • What other fields must you add to the Page Layout Content Type?

    In addition to planning the tagging field for navigation, you should consider any other fields that you want to add to a Page Layout Content Type. These can be other managed metadata fields that are linked to other term sets, or other kinds of fields, such as hyperlinks, numbers, and dates and times. By default, publishing page content types contain a Page Content field. This lets content authors insert HTML and images onto a page by using a rich text editor. You can create different page layouts that contain different fields, based on the content that is created. For example, in the intranet knowledge base scenario, you can use a page layout for Troubleshooting Articles that contains fields such as Applies To or Article Number, whereas you can use a page layout for User Manuals that contains fields such as Product Name or Model Number. As you plan Pages library content, decide what other site columns and content types are needed, what page layouts are needed, and which fields should go in which page layout. For more information, see SharePoint page model overview.

For more information, see Plan Web pages (SharePoint Server 2010), and Plan for large Pages libraries (SharePoint Server 2010).

Plan list content

When you plan to use lists to maintain catalog content, consider the following questions:

  • How many lists do you want to use?

    Depending on the structure of the data, consider using several lists for creating and maintaining catalog content. You should consider using several lists when the attributes that are used to represent catalog items vary greatly between the different categories of data. For example, attributes representing washing machines are very different from the attributes representing MP3 players. In this case, consider creating one list for washing machines, and another list for MP3 players.

  • Which site columns do you have to have to represent the catalog items?

    When you create and maintain catalog content in SharePoint lists, an item in the list represents a single catalog item — for example, a single product or a specific event. The different items have attributes to represent properties of the items, such as brand, color, and size for products, or date, time, and place for events. To add these attributes in the list, you have to create site columns that represent the different attributes, such as Brand, Color, Weight, Date, Time, and Place.

    When you plan the site columns that you want to represent the catalog content, consider both what you want to show, and how the different catalog items appear on the publishing site. You don't have to show all site columns from the list on a publishing site. However, you can use the information from all site columns to sort how catalog items must appear. For example, you can use the data in a site column named Amount in stock to sort catalog items so that the items with the greatest amount in stock appear in a prominent place.

    Important:

    We recommend that you create site columns and not list columns. Managed properties are automatically created for site columns, taxonomy columns, and indexed list columns. Also be aware that all automatically created managed properties are of the text data type. For more information, see Automatically created managed properties in SharePoint Server 2013.

  • What content types do you want for lists?

    If you have several lists, we recommend that you create a content type for each list, and then associate the appropriate site columns to this content type.

  • What term set do you want to use for each list that you will share as a catalog?

    As described in Plan term sets for tagging content on SharePoint authoring sites earlier in this article, you use term sets to categorize the catalog content into a hierarchy. To use tagging term sets for list content, you must have a site column that is a Managed Metadata data type, and is connected to the tagging term set.

  • Is the data that you will input into a list consistent?

    You should also plan a strategy to make sure that catalog list data is consistent. Catalog list data is often maintained by different people over a long time, and this can increase the inconsistency of the data. For example, let's say that you have a site column named Color, and you want to import the color information for individual items from an external system. The values in the external system vary in how the color is written (BLUE, Blue, blue). Before you import this data into a SharePoint list, make sure that the data is consistent. For this example, you make sure that all color names are represented as Blue.

    In addition to guaranteeing data consistency, you should also make sure that the managed metadata field that is used to tag catalog content is a required field. Missing data from this field may cause content to appear incorrectly on the publishing site.

For information about how to create list content for cross-site publishing, see "Create catalog content by using SharePoint lists" in Configure cross-site publishing in SharePoint Server 2013.

Plan to use the Product Catalog site collection

The Product Catalog Site Collection template is intended to be used to create sites in which to author, store and maintain any type of data that is used in a catalog scenario. The site collection template includes a Product Catalog list template that is optimized for maintaining catalog content in a list. By default, when you create a Product Catalog site collection, a Products list based on the Product Catalog list template is automatically created. The Products list is preconfigured with the Product with Image content type. The Product with Image content type has site columns associated with it, as described in the following table.

Site columns in the Product with Image content type

Site column name | Site column type
Title | Single line of text
Item Number | Single line of text
Group Number | Single line of text
Language Tag | Choice
Rollup Image | Publishing Image
Item Category | Managed Metadata

In addition, a term set named Product Hierarchy is created. This term set is associated with the Item Category site column.

For performance considerations, see Designing large lists and maximizing list performance (SharePoint Server 2010).

Plan asset library content

When you plan to use assets in content, remember what is and is not indexed. The search system indexes some fields, such as text and HTML fields, but does not index assets such as pictures, audio and video files, and files such as Word documents or PDFs. These files are considered binary large objects (BLOBs), and are stored in the BLOB cache, not in the search index. This means that they will not be shown on the publishing site in the same manner as other content. As you plan the asset library content for authoring sites, consider the questions in the following list.

  • Where should the asset library be located?

    To use assets in content, authoring site collections and publishing site collections must have access to the asset library. The location of the asset library depends on the kind of site that you want to create, and the solution architecture. If the users of the publishing site can have Read permission level on the authoring site collection, the asset library can be stored on the authoring site collection. However, if users on the publishing site cannot have Read permission level on the authoring site collection, the asset library must be created on a separate site collection with different permission levels. For example, in an Internet scenario in which users on the publishing site have only anonymous access, the asset library should be stored on a separate site collection, in a separate web application that is configured to allow anonymous access. However, in an intranet scenario in which users on the publishing site can have read access, the asset library can be stored in the authoring site collection. When the asset library is stored in a site collection separate from both the authoring and publishing sites, make sure that you add it to the list of Suggested Browser Content Locations for the authoring site so content authors can find and insert items from the asset library into their content. If you plan to use image renditions with the asset library, renditions must be enabled and configured on the site collection that hosts the images.

  • Does the asset library have to be shared as a catalog?

    If the assets to be stored in the asset library are tagged with terms from a tagging term set, and you want to be able to query assets based on those terms, you can share the asset library as a catalog. For example, if you have one or more publishing sites that you want to show pictures or videos based on certain categories, the libraries that contain those assets must be shared as catalogs. If you want to allow anonymous users on the publishing site, make sure the asset library is accessible to anonymous users.

  • Where will assets be cached?

    When you plan to use assets in content, also plan for where the asset files will be cached. In general, always enable the BLOB cache for publishing sites. The BLOB cache improves web site performance by retrieving BLOB files from the database and storing them in a directory on the front-end web server where they are served to users. This reduces the network traffic to and load on the database server. For more information, see Plan for caching and performance (SharePoint Server 2010).

  • How big are the asset files?

    If you plan to use very large files such as videos in content, you should plan to increase the maximum upload file size on the server where the asset library is located. This will allow you to upload files that are larger than the default setting permitted by SharePoint Server 2013. For more information about the BLOB cache, bit-rate throttling, and maximum upload file size, see Plan for caching and performance (SharePoint Server 2010).

For more information about how to plan for asset libraries, see Plan digital asset libraries (SharePoint Server 2010).

See also

Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013
Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013
Plan for cross-site publishing in SharePoint Server 2013
Overview of cross-site publishing in SharePoint Server 2013
Plan the logical architecture for cross-site publishing in SharePoint Server 2013
Plan publishing sites for cross-site publishing in SharePoint Server 2013
Plan search for cross-site publishing sites in SharePoint Server 2013
Configure cross-site publishing in SharePoint Server 2013
Estimate capacity and performance for Web Content Management (SharePoint Server 2013)


Plan publishing sites for cross-site publishing in SharePoint Server 2013
See also

Published: August 21, 2012

Summary: Learn how to plan publishing site collections for a SharePoint cross-site publishing solution.

Applies to: SharePoint Server 2013 Enterprise

When you use cross-site publishing in SharePoint Server 2013, you use one or more authoring site collections for authoring and storing content, and one or more publishing site collections to control the design of the site and show content. This article describes how to plan publishing sites for your cross-site publishing solution.

In this article:

  • Plan site collections and site structure for SharePoint publishing sites

  • Plan security for SharePoint publishing sites

  • Plan design and branding for SharePoint publishing sites

  • Plan catalog connections for SharePoint publishing sites

  • Plan navigation term sets for SharePoint publishing sites

  • Plan to show catalog content in SharePoint publishing sites

This article builds on the information in Overview of cross-site publishing in SharePoint Server 2013. After you finish reading this article, make sure that you read the next article, Plan search for cross-site publishing sites in SharePoint Server 2013.

Plan site collections and site structure for SharePoint publishing sites

Publishing site collections must have the SharePoint Server 2013 publishing features activated. We recommend that you use the Publishing Portal Site Collection template to create publishing site collections because the publishing features are activated by default when you use that site collection template. If you use a site collection template that is not for a publishing site collection, you must enable the SharePoint Server 2013 publishing features. For more information, see Publishing features overview (SharePoint Server 2010). For information about how to activate the publishing features, see Enable publishing features.

Because the publishing site collection reuses content and term sets from the authoring site to show content, publishing sites are much more lightweight than authoring sites. Therefore, the site structure for a publishing site is usually very different from the authoring site. The publishing site contains a master page, a limited number of page layouts, managed navigation, and a single Pages library that contains the catalog and catalog item pages used to show catalog content. The URLs for the site are created based on the terms in the tagging term set used on the authoring site. Therefore, you do not have to manually create a complex site structure for a publishing site.

Plan security for SharePoint publishing sites

Although you plan security for publishing sites in the same way that you do for any other SharePoint Server 2013 site, also consider the following:

  • Who are the designers, and what permission levels should they be granted? Because the publishing site is where master pages, page layouts, and CSS files are stored, designers must have read and write permissions to the site.

  • Is this an Internet site that allows for anonymous access? What web application should the publishing site collection be in to allow anonymous access for visitors? You must decide who should have Read permission levels for content shown on the publishing site.

  • If this is an Internet site, do you have to set up claims-based authentication for designers?

  • If this is an intranet or extranet site, what authentication method do you have to use? For more information about user authentication, see Plan for user authentication methods in SharePoint 2013.

When you enable anonymous access for a catalog, security on the authoring site can be treated independently from how it is represented in search. When anonymous access is enabled, indexed content is searchable and viewable to anonymous users on the publishing site. However, if you change permissions to individual items in the catalog, those permissions are respected by the search system, and any items that are restricted to certain groups will not be available to anonymous users. This allows for greater flexibility when you plan to share content with anonymous users.

For information about security, see Overview of site permissions in SharePoint 2013 and Plan site permissions in SharePoint 2013.

Plan design and branding for SharePoint publishing sites

In a cross-site publishing solution, the publishing sites contain the files and other resources that a designer creates and that are used to brand the site. The following list describes the major branding components that a designer must create.

  • Master pages Define the chrome and shared elements of a site.

  • Page layouts Templates for specific types of pages in a site.

  • Display templates Templates used within Content Search Web Parts that control which managed properties are shown in the search results, and how they appear.

In general, you plan the design of the publishing sites exactly as you do for any branded site. You should work with a designer to collect design requirements, decide the browsers and devices that you want to support, and then create a wireframe for the sites. To plan for specific SharePoint Server 2013 aspects of the publishing sites, consider the following:

  • How many publishing sites will you have?

  • How many visual designs will you have for the publishing sites?

  • How many master pages are needed?

  • What catalog content will be shown on each publishing site, and how should it look?

  • What devices will you support, and will you have to have separate device channels and master pages?

For more information, see SharePoint page model overview.

Plan catalog connections for SharePoint publishing sites

When you connect a publishing site to a catalog, SharePoint Server 2013 automatically creates a result source for the catalog. You can also do the following:

  • Integrate the tagging term set from the catalog into the navigation term set on the publishing site.

  • Create a category page layout and catalog item page layout for the catalog content.

  • Set up a catalog item friendly URL to the catalog item page.

If you choose to not integrate the catalog into your publishing site when you connect to a catalog, you must do each of those tasks manually.

For information about how to connect a publishing site to a catalog, see Connect a publishing site to a catalog in SharePoint Server 2013.

Plan navigation term sets for SharePoint publishing sites

When you connect a publishing site to a catalog, you have the option to pin the tagging terms from the authoring site to navigation of the publishing site. When you view the Site Navigation term set in the Term Store Management Tool, you'll be able to configure the navigation settings for each term. When you plan the navigation term sets for a publishing site, consider the following:

  • Will the navigation term titles be the same as the original tagging term titles? If the titles will be different, what should the new titles be?

  • Should the navigation term appear in the Global and Current Navigation Menus?

  • Should the navigation term use a friendly URL that points to a term-driven page, point to a different URL, or just be a text-only heading?

When you configure the navigation term set, you'll be able to change other settings such as target page settings, search engine optimization, and catalog item page settings. If you use a site collection template, such as the Team Site template, that does not create a publishing site collection, and then activate the publishing feature, you must also be sure to turn on managed navigation for the site collection.

Plan to show catalog content in SharePoint publishing sites

This section describes how to plan to show catalog content in publishing sites. The structure of the catalog data will be important when you plan the category pages and catalog item pages. How you want to show the content in the different levels within the catalog will determine which Web Parts you use on the category pages and catalog item pages.

Plan category pages and catalog item pages

When you set up a site that uses catalog content, SharePoint Server 2013 can automatically create a category page and a catalog item page for you when you connect to a catalog. This section describes what you should plan for if you choose to customize the default pages, or create these pages yourself. For more information about category pages and catalog item pages, see "Category pages and catalog item pages" in the "Publishing site collections for SharePoint cross-site publishing" section in Overview of cross-site publishing in SharePoint Server 2013.

Plan category pages

As you plan to customize default category pages, or create your own, consider the structure of the content, and determine what content you want to show at different points within this structure. Consider the following:

  • How many levels (categories) do you have in the term set that is used for catalog navigation?

    If you want to make a clear differentiation between the levels (categories) within the catalog, you could create one category page per level within the term set.

  • Will you customize the default category pages, or create your own?

    If you choose to create your own category pages, after you connect to a catalog and specify the custom category page to show content, you must open the page in edit mode and configure the queries for any Content Search Web Parts that you added to the page.

  • What content is important to show for users to easily browse within the catalog?

    When you think about what content to show, you should also think about which Web Parts you want to include on category pages. For example, if you use a Refinement Panel Web Part and faceted navigation, users can easily browse to content by filtering on properties from the catalog. You can also add a Popular Items Web Part to show items that are perceived to be relevant for the user. You should also consider if you want to use only Search Web Parts, or if you want to include other content Web Parts. For more information, see Plan to add Search Web Parts to pages later in this article.

  • Can you use the same design across all category pages?

    If you can't use the same design across all category pages, you'll have to create separate pages that have separate design. After you connect to a catalog and specify the category page to use to show content, you must open the page in edit mode and configure the queries for any Content Search Web Parts on the page.

  • How much work do you think is acceptable when maintaining these pages?

    The more category pages that you have, the more maintenance work that you'll have to do. Limit the number of category pages so that you reduce the number of places where you have to do change management.

For information about how to create and customize a category page layout, see How to: Customize page layouts for a catalog-based site in SharePoint 2013

Plan catalog item pages

As you plan to customize default catalog item pages, or create your own, consider the following:

  • Do you want to display items in a group?

    The automatically created catalog item page uses Catalog Item Reuse Web Parts when displaying content. By default, the Catalog Item Reuse Web Part is configured to use server-side rendering, and therefore, search engines such as Google and Bing can discover and log individual items in the catalog. Also, users who haven't enabled JavaScript, for example for accessibility reasons, will be able to view the content. The Catalog Item Reuse Web Part is configured to automatically record the default usage events used by Usage analytics.

    When you plan to display items on a catalog item page, consider if you want to display an item in a group or not. For example, in an Internet Business scenario where you have a website selling clothes, you may want to group all available sizes of a particular item on the catalog item page. Users who browse to the catalog item page, can then quickly view all available sizes for that item. For this group scenario, you can't use the automatically created catalog item page because it uses Catalog Item Reuse Web Parts. Catalog Item Reuse Web Parts can only retrieve one item at a time, and not a group of items. Therefore, if you want to display items in a group on your catalog item page, you have to create your own catalog item page, and use a Content Search Web Part to display the items.

    Note:

    Even though the Content Search Web Part by default uses client-side rendering and JavaScript to display search results, it will automatically implement XSLT-based server-side rendering to render content to search engines such as Google and Bing. However, users who haven't enabled JavaScript, for example for accessibility reasons, won't be able to view the content. To make sure that your content can be viewed independently of whether JavaScript is enabled, consider changing the Content Search Web Part to always use XSLT-based server-side rendering.

    Also be aware that usage events for Usage analytics are not automatically recorded in the Content Search Web Part, but you can configure the display template to record usage events. For more information, see Configure recommendations and usage event types in SharePoint Server 2013.

    For more information about the differences between the Catalog Item Reuse Web Part and the Content Search Web Part, see Search Web Parts and when to use the different Web Parts.

  • Can you use the same design across all catalog item pages?

    If you can't use the same design across all catalog item pages, you'll have to create separate pages that have separate designs. After you connect to a catalog and specify the catalog item page to use to show content, you must open the page in edit mode and configure the queries for any Content Search Web Parts on the page.

  • How much work do you think is acceptable when maintaining these pages?

    The more catalog item pages that you have, the more maintenance work you'll have to do. Limit the number of catalog item pages to reduce the number of places where you have to do change management.

For information about how to create and customize a catalog item page layout, see How to: Customize page layouts for a catalog-based site in SharePoint 2013

Plan to add Search Web Parts to pages

The Search Web Parts show content from the search index. The Search Web Parts have different predefined queries, such as what type of content to search for, and where to search for the content. When users browse to a page that contains a Search Web Part, the Web Part automatically issues the query defined in the Web Part, and the search results appear in the Web Part. As search system discovers new content, an updated list of items appears in the Web Part every time that the page is viewed.

You can add one or more Search Web Parts to the pages. When you add a Search Web Part, you can use the predefined query, or you can change the default query settings. You can also change how the results appear in the Web Part, for example, by specifying to sort items by price or by popularity. You can change the predefined query by editing the Web Part and changing its search criteria.

The Search Web Parts use display templates to control how the results appear in the Web Part. Display templates are HTML files that specify which managed properties from the search result to show, and also how these properties should be shown. For example, a display template could specify that the managed property PublishingImage shows a 100x100 pixel picture, and the managed property Title appears in bold to the left of the image.

For information about how to create and customize display templates, see SharePoint 2013 Design Manager display templates

Search Web Parts and when to use the different Web Parts

The following table describes Search Web Parts that are commonly used in web content management scenarios. For information about Search Web Parts commonly used in a productivity search scenario, see Manage the Search Center.

Search Web Parts

Category Web Part Description

Content Rollup

Content Query

Do not use for cross-site publishing. Use the Content Search Web Part or one of the Web Parts in the Search-Driven Content Web Part category.

Content Search

Use this Web Part to display catalog content on a category page. You can also use it to display items in a group on your catalog item page. In the Content Search Web Part (CSWP), you can select a result source to specify which content should be searched. You can also use Keyword Query Language to add more filters and search terms to the query.

By default, this Web Part uses client-side rendering, which means that you can use JavaScript in the display template to customize how search results should be displayed. To enable search engines such as Google and Bing to discover and log individual items in the catalog, the CSWP will automatically implement XSLT-based server-side rendering when rendering content to search engines.

Another benefit of using client-side rendering is that the server requires fewer resources because the rendering happens in the browser. For information about performance considerations when you add a CSWP to a page, see Estimate capacity and performance for Web Content Management (SharePoint Server 2013)

Note:

Because the Content Search Web Part uses JavaScript to display content, users who haven't enabled JavaScript, for example for accessibility reasons, won't be able to view the content. To make sure that that your content can be viewed independently of whether JavaScript is enabled, consider changing the Content Search Web Part to always use XSLT-based server-side rendering. Note that using XSLT-based server-side rendering often require more server resources and may reduce performance.

Search

Refinement Panel

This Web Part adds refiners to the page. You can use this Web Part to add stand-alone refiners and refiners for faceted navigation.

You must enable managed properties as refiners before any refiners will display in this Web Part. For more information, see Configure refiners and faceted navigation in SharePoint Server 2013.

Taxonomy Refinement Panel

This Web Part combines refinement with managed navigation, and can be used to add a powerful search-driven navigation experience to the catalog content. It can only be used in combination with managed navigation, and must be associated with another Search Web Part on the page, such as a Content Search Web Part. It enables you to filter search results in the associated Web Part by displaying refiners based on the current navigation term. The refiners shown in the Taxonomy Refinement Panel Web Part are child refiners of the current navigation term. When a user clicks a refiner, the search results in the associated Web Part are filtered accordingly. What makes this Web Part especially powerful is that it accounts for previous queries or refinements made by the user when displaying the refiners.

Important:

We don't recommend that you use the Taxonomy Refinement Panel Web Part on a page that has more than 200 navigation nodes under it. A large number of navigation nodes may cause slow server response times and decrease throughput. For more information, see Estimate capacity and performance for Web Content Management (SharePoint Server 2013)

Search-Driven Content

Articles

Shows items that are associated with the Article Page content type.

Catalog Item Reuse

Only use this Web Part on a catalog item page when you don't want to display your catalog items in a group. This Web Part uses server-side rendering so that search engines such as Bing or Google can discover and log individual items in the catalog. It's also configured to automatically record the default usage events used by Usage Analytics.

The configuration of this Web Part is somewhat different from the other Search Web Parts. Most configuration of this Web Part is performed in the HTML page layout file of the catalog item page. The Web Part can only display one managed property. Therefore, for each managed property that you want to display on your catalog item page, you must add one Catalog Item Reuse Web Part to the HTML page layout file. In addition, you must add one Catalog Item Reuse Web Part as a Web Part directly on the catalog item page. In that Web Part, you configure the query for the catalog item that should be retrieved. The Catalog Item Reuse Web Parts that were added in the HTML page layout file are configured to reuse the data that are retrieved by this query.

The Catalog Item Reuse Web Part doesn't use display templates to show content. Instead, formatting is based on the managed property type, for example Date or HTML.

For information about how to customize a catalog item page layout that uses Catalog Item Reuse Web Parts, see How to: Customize page layouts for a catalog-based site in SharePoint 2013

For information about performance considerations when you add a Catalog-Item Reuse Web Part to your page, see Estimate capacity and performance for Web Content Management (SharePoint Server 2013)

Items Matching a Tag

Shows items that are tagged with a term.

Pictures

Shows any items that are associated with the Picture or Image content type.

Popular Items

Use this Web Part to show the most popular items that satisfy a set of criteria. For example, you can add this Web Part to a Category page to show "Most popular items in category."

Recently Changed Items

Shows items that were recently changed. This can help users track the latest activity on a site or in a library.

Recommended Items

Use this Web Part to show content recommendations based on how users have previously interacted with the site. For example, you can add this Web Part to a catalog item page. If a user views a specific item, this Web Part will show other items that users have previously viewed, such as "Users who viewed this item also viewed these items."

By default, the query is restricted to recommended items for the current site. You can change this setting to recommended items based on a token from the URL, and also restrict the query to a specific URL or content type.

Videos

Displays any items that are associated with the Video content type. It will sort items by number of views.

Web Pages

Displays any items that are derived from the Page content type.

Wiki Pages

Displays any items that are associated with the Wiki Page content type.

For information about how to add and configure Search Web Parts, see Configure Search Web Parts in SharePoint Server 2013.

See also

Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013
Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013
Plan for cross-site publishing in SharePoint Server 2013
Overview of cross-site publishing in SharePoint Server 2013
Plan the logical architecture for cross-site publishing in SharePoint Server 2013
Plan authoring sites for cross-site publishing in SharePoint Server 2013
Plan search for cross-site publishing sites in SharePoint Server 2013
Configure cross-site publishing in SharePoint Server 2013
Estimate capacity and performance for Web Content Management (SharePoint Server 2013)


Plan search for cross-site publishing sites in SharePoint Server 2013
See also

Published: August 21, 2012

Summary: Learn how to plan for search-driven pages for SharePoint cross-site publishing sites.

Applies to: SharePoint Server 2013 Enterprise

Search-driven pages are pages that use search technology to dynamically show content. This article describes features that you will use when you set up search-driven pages, such as managed properties, refiners, result sources, and recommendations, and what you must consider when you set up and use these features.

In this article:

  • Plan content sources and crawling

  • Plan to manage managed properties in the search index

  • Plan refiners and faceted navigation

  • Plan result sources and query rules

  • Plan usage analytics, usage events and recommendations

This article builds on the information in Overview of cross-site publishing in SharePoint Server 2013.

Plan content sources and crawling

The default content source is Local SharePoint sites. You can use this content source to crawl all content within the web application. However, we recommend that you create separate content sources for libraries or lists that you share as catalogs. When you set up a content source for libraries or lists that are shared as catalogs, we recommend that you select Enable Continuous Crawl when specifying the crawl schedules. A continuous crawl starts at set intervals, which enables the search system to crawl the content and quickly add any changed content to the index. The default crawl interval for continuous crawl is 15 minutes, but you can set shorter or longer intervals. Enabling continuous crawl also means that a site administrator will not have to wait for the search service application administrator to manually start a crawl in order to update the search index with the latest changes from a catalog.

For information about how to set up a content source and manage continuous crawling, see "Configure search for cross-site publishing" in Configure cross-site publishing in SharePoint Server 2013.

Plan to manage managed properties in the search index

Managed properties can have many settings, or attributes. These settings, or attributes, are maintained in the search schema, and determine how the contents can be shown in Search Web Parts and search results. Site administrators can read the search schema, such as the mappings between crawled and managed properties on the site collection level. However, they can't edit the search schema. Administrators using Central Administration and site collection administrators can edit the search schema.

When editing the search schema, consider the following:

  • Which managed properties contain content that I want to search?

  • Which managed properties contain content that I don't want to be returned in search results?

  • Which managed properties do I want to use to sort search results?

  • Which managed properties do I want to enable as refiners?

For more information about the different managed properties settings, see "Managed property settings overview" in Overview of the search schema in SharePoint Server 2013.

Plan refiners and faceted navigation

When you plan to use refiners and faceted navigation, consider the questions in the following sections.

What type of refiners do you want to use?

There are two types of refiners: stand-alone and for faceted navigation. You can use just one type on the site, or a combination of both. The structure of the content and what kind of navigation you use on the site will determine the type of refiners that you should choose.

  • Stand-alone refiners are usually used in scenarios where you have unstructured content. Within this content, you can identify several managed properties that can be used as refiners across all content. However, you do not want the refiners to change depending on a term in a term set. For example, in an intranet scenario, you can add stand-alone refiners to a Search Center page. These stand-alone refiners are typically managed properties that apply to most items in the intranet, such as Author and Date.

  • Refiners for faceted navigation are used in scenarios where you have structured content, such as catalog content. This content is tied to a term set, and you want to have different refiners for different terms. For example, in an Internet business scenario where a product catalog of electronic products is shown, a term set is used to categorize the different products — for example, Computers or Cameras. After you enable the managed properties Screen Size and Megapixels as refiners, you can configure faceted navigation so that Screen Size appears as a refiner for Computers, and Megapixels appears as a refiner for Cameras. This means that you can guide users to content that is relevant for a specific category. This makes it easier and faster to browse through catalog content.

How do you identify a refiner?

When identifying which managed properties you want to specify as refiners, consider what kind of information users want to differentiate on and browse to.

When using refiners for faceted navigation, it is especially important that you identify refiners that represent information that users will find useful when they browse through a catalog. You configure refiners in Term Store Management. You can set refiners for a specific term set, you can configure refiners to apply to all terms in a term set, or you can set specific refiners for a specific term. Consider the following:

  • Which managed properties represent information that users want to quickly browse to for all my catalog items?

  • Which managed properties represent information that is unique for only a sub-set of my catalog items?

Note that adding many refiners to your page may increase the time to process a query. For more information, see Estimate capacity and performance for Web Content Management (SharePoint Server 2013)

How should you configure refiners in the Term Store Management Tool?

You configure refiners in the Term Store Management Tool by adding refiners to terms in a term set. When you configure refiners, consider the following:

  • Do you want all terms within your term set to have the same refiners, or do you have any term-specific refiners?

    By default, all terms in a term set are set to inherit the refiner configuration from the parent term. The configuration is passed down to all child terms. For any term, you can choose to break inheritance to add term-specific refiners to any child terms.

  • How should my refiners be sorted?

    You can specify how the refiner values should be sorted, and if the sort direction should be ascending or descending. The sorting options are as follows:

    • Count: sort by the number of items with a specific value

    • Name: sort by the name of the value

    • Number

  • Do I have any refiners where I want the values to be grouped in intervals?

    Refiners of data type Integer, Decimal, or Date and Time can often have many values. When this is the case, the values are automatically placed in intervals.

You can also choose to specify custom intervals.

For information about how to add refiners and configure faceted navigation, see Configure refiners and faceted navigation in SharePoint Server 2013

Plan result sources and query rules

Result sources narrow the scope of search results that are retrieved. SharePoint Server 2013 provides many pre-defined result sources. Many of the pre-defined result sources have a corresponding Web Part where the result source is specified as part of the query. For example, the result source Local Video Results is set as part of the query that is used in the Videos Web Part.

You manage result sources in Central Administration and in site collection administration. If you are familiar with Keyword Query Language (KQL), you can create custom result sources.

All available result sources appear in a list when you build the query in a Content Search Web Part. Users who configure this Web Part can easily narrow the scope of results that can be shown in the Web Part. For example, for an intranet site, a site collection administrator can create a result source named My PowerPoint Presentations, and configure it to narrow the scope of the search results to PowerPoint presentations created by the user who is logged on to the site. Any user can add a Content Search Web Part to their My Site and configure the Web Part by selecting the result source My PowerPoint Presentations. When users browse to their My Sites, the Web Part only shows PowerPoint presentations that they have created themselves.

Another example is an Internet site, where a list that is shared as a catalog is used to maintain product data in many languages. A site collection administrator can create a result source named US English products and configure it to narrow the scope of search results to products with the language tag en-us. A user who has the Contribute permission level can then add a Content Search Web Part, and configure it to show only products that have information in US English, by selecting the US English products result source.

In addition to the pre-defined result sources, SharePoint Server 2013 automatically creates a result source when you connect a catalog to a publishing site. The automatically created result source is added to the result sources in your publishing site. This result source limits search results to the URL of the catalog, which means that only content from that catalog will be shown when that result source is selected in a Web Part.

Note:

Before you create any result sources, start a full crawl of the catalog content, and connect a catalog to your publishing site.

For information about how to configure result sources, see Configure result sources for web content management in SharePoint Server 2013.

Query rules can be specified for one or more result sources. Result sources are used as part of the query in Web Parts that use search technology, and you can easily influence how search results are shown for all Search Web Parts on your site. By specifying a limited time period for when a query rule is triggered, you can control when certain items are promoted within your website, without having to worry about how to add or remove content at a particular time. Let's say that you are selling electronic products through a product catalog, and you want to promote pink cameras on Valentine's day in the United States. You can create a query rule for a result source that starts on February 14th, and ends on February 15th. The query rule is triggered if a query contains the term Cameras, and pink cameras appear first in the Search Web Part.

For information about how to create query rules, see Create query rules for web content management in SharePoint Server 2013.

Plan usage analytics, usage events and recommendations

The Usage Analytics feature in SharePoint Server 2013 automatically tracks how different items are being viewed by users. Items can be documents, sites, or list items that are shown on a site by using cross-site publishing. Every time that a user views an item, the system issues a usage event and adds this to the total and recent usage event counts for that item. The following usage events are preconfigured:

  • Views - number of views for a single item, page, or document.

  • Recommendations Displayed - number of times a single item, page or document was displayed as a recommendation.

  • Recommendation Clicks - number of times a single item, page or document was clicked when it was displayed as a recommendation.

You can use the data that is generated by usage events in the following ways:

  • Show recommendations or popular items on your site. By using recommendations, you can guide users to other content that may be relevant for them, based on how users previously interacted with the site. You can add recommendations to a page by adding one or more Web Parts. The Recommended Items and Popular Items Web Parts are especially designed to show recommendations. For more information about these Web Parts, see "Plan to add Search Web Parts to pages" in Plan publishing sites for cross-site publishing in SharePoint Server 2013.

  • Sort search results by the number of counts of a usage event. For example, show items that have the most view events at the top of search results.

  • View the usage event data in the Most Popular Items usage report. This report applies to all items in a library, and lists the most popular items for each usage event — for example, a list of the most viewed pages in a library.

  • View the usage event data in the Popularity Trends report. This report applies to a Site Collection, a Site or an individual item in a library or list. The report shows the daily and monthly counts for each usage event — for example, the total views of a page on a specific day.

The following illustration shows how usage events are sent from Web Parts, through components in the Search service application, and are then used in usage reports and to show recommendations and popular items in Web Parts.

Overview of data flow for usage analytics, usage events, and recommendations

For more information about the usage analytics framework, see Overview of analytics processing in SharePoint Server 2013.

Plan to add custom usage events

The preconfigured usage events may not be sufficient for your business needs. To track user activities that are important to your site or business, you can register up to twelve custom usage events by using Windows PowerShell. For example, if you want to be able to track how often a catalog item is viewed from a mobile phone, you can add a custom event that tracks this.

Plan to import existing usage events

When you set up a new site, there has not been any user traffic to generate usage events. Therefore, there will be no recommendations and popular items in the system. To be able to show recommendations and popular items from the beginning, you can import existing events from a previous SharePoint system, or import events from a third-party web analytics provider. To correctly import existing data, the data have to be formatted according to specific rules.

Whenever a usage event occurs, the event is logged to the item in the library that you shared as a catalog. The default method for logging and sending usage events through the system is to use the URL of the item in the library as ID. However, the usage event data that you import may use a different ID to log usage events, for example InternalNumber. You must change the way that usage events in the library that you shared as a catalog are logged to match how usage events for the imported events are logged. To change this, you must do the following:

  1. In the library that you shared as a catalog, add a column that represents the ID on which the imported usage events are logged, for example InternalNumber, and add corresponding InternalNumber values to this column for all items in the library.

  2. Map the crawled property of this column to the managed property UsageEventItemId.

  3. Change the Web Part used to show individual catalog items to use the managed property UsageEventItemId to log usage events.

Plan to influence how recommendations are calculated

The default recommendations algorithm calculates recommendations between individual catalog items. By default, the crawled property ows_q_TEXT_ProductCatalogItemNumber is mapped to the managed property UsageAnalyticsID, which specifies the property on which recommendations should be calculated. For example, if you show a catalog of electronic products on your site, and a user views AdventureWorks Laptop15.4W M1548 White, only this specific product will get a recommendation count.

Depending on how catalog data is structured and how you want to show the products, you might want to change how the recommendations algorithm calculates the recommendations. You can, for example, choose that all color variants of a product get a recommendation count when one color variant is viewed. Let's say that the products in the catalog have the data structure listed in the following table.

Product title | Item number | Group number
AdventureWorks Laptop15.4W M1548 White | 1010101 | 10101
AdventureWorks Laptop15.4W M1548 Black | 1010102 | 10101
AdventureWorks Laptop15.4W M1548 Yellow | 1010103 | 10101
AdventureWorks Laptop15.4W M1548 Red | 1010104 | 10101

You may not want to show every color variant in your catalog on a page, but only show one color variant, and then list the other color variants. However, you want all color variants to get a recommendation count when one of the variants is viewed. That is, you want recommendations to be calculated based on Group number and not Item number. To do this, you must map the crawled property Group number to the managed property UsageAnalyticsID. Recommendations will then be calculated between groups and not between individual items. This means that given a group, the system will return a set of recommended groups for a particular group.

Note:

When you map a property to the UsageAnalyticsID managed property, make sure that this property is part of the friendly URL for your item details page. This is because the Recommended Items Web Part uses a token from the URL to show the correct recommendations.

Rank usage event types by importance

You can influence how recommendations are calculated by changing the importance of usage event types by using Windows PowerShell. In the recommendations calculations, you can define that a usage event of one type should be considered more important than other usage events. For example, you have two usage events: views from a mobile phone and views from a site. If you want views from a mobile phone to be more important than views from a site in the recommendations algorithm, you can give the usage event views from a mobile a high weight (for example 10), and the usage event views from a site a low weight (for example 1).

See also

Plan for cross-site publishing in SharePoint Server 2013
Overview of cross-site publishing in SharePoint Server 2013
Plan the logical architecture for cross-site publishing in SharePoint Server 2013
Plan authoring sites for cross-site publishing in SharePoint Server 2013
Plan publishing sites for cross-site publishing in SharePoint Server 2013
Configure cross-site publishing in SharePoint Server 2013
Estimate capacity and performance for Web Content Management (SharePoint Server 2013)


Overview of managed navigation in SharePoint Server 2013
See also

Published: March 26, 2013

Summary: Learn about managed navigation and navigation term sets for SharePoint Server publishing sites.

Applies to: SharePoint Server 2013

The managed navigation feature in SharePoint Server 2013 enables you to build navigation for a publishing site that is derived from a SharePoint managed metadata taxonomy. In SharePoint Server 2010, by default, you could base navigation only on the structure of a site. To create site navigation based on any data structure, you had to create a custom navigation provider. By using managed navigation, you can design site navigation around important business concepts. Managed navigation also lets you create friendly URLs without changing the structure of your site. In SharePoint Server 2010, all publishing site URLs contained a reference to the Pages library and any folders within that library — for example, http://contoso.com/Pages/AboutUs.aspx. In SharePoint Server 2013, you can create URLs that are better for Search Engine Optimization (SEO), and easier for site visitors to read — for example, http://contoso.com/AboutUs. Managed navigation is not available in SharePoint Foundation 2013.

This article describes the key elements of the managed navigation feature, its uses and benefits, how it works, how terms can be used in other locations, limitations of the feature, and includes examples of how managed navigation can be used in a publishing site.

For information about how to create the navigation term set that is used for site navigation, see Plan navigation term sets in SharePoint Server 2013.

For capacity and performance considerations when using managed navigation, see Estimate capacity and performance for Web Content Management (SharePoint Server 2013)

In this article:

  • Elements of managed navigation in SharePoint Server 2013

  • How managed navigation works in SharePoint Server 2013

  • Use and benefits of managed navigation in SharePoint Server 2013

  • Examples of managed navigation in SharePoint Server 2013

  • Using terms in other term sets

  • Limitations of managed navigation in SharePoint Server 2013

Elements of managed navigation in SharePoint Server 2013

This section describes key concepts that are related to managed navigation.

Navigation term set

A term is a word or phrase that can be associated with an item inSharePoint Server. A term set is a collection of related terms. The term set that managed navigation uses to build site navigation is called a navigation term set. For more information, see Overview of managed metadata in SharePoint Server 2013 and Plan managed metadata in SharePoint Server 2013.

The navigation term set is the backbone of the managed navigation feature. By default, as you create new pages in your publishing site, new terms are automatically added to the navigation term set. For example, when you create a new page named Company History, a term named Company History is added to the navigation term set. You can choose to turn off automatic term creation on the Navigation Settings page. You can also manually add terms to the navigation term set by using the Term Store Management Tool. For more information, see Create and manage terms in a term set on Office.com.

Note:

If automatic term creation is enabled, a new term will only be created if you choose Add a page on the Settings menu. Adding a page by using the New Document button on the Files tab in the ribbon does not create a new term in the navigation term set.

Each term in a navigation term set has a friendly URL that loads a physical page in the context of that term. Terms in the navigation term set can be configured to do one of the following:

  • Point to the same page as other terms

  • Point to a unique page for each term

  • Point to a URL or appear only as text

If you use cross-site publishing, you must use a tagging term set on the authoring site to tag catalog items for reuse. You can combine terms from one or more tagging term sets in the authoring site to create a single customized navigation term set in the publishing site. For more information about cross-site publishing, see Plan for cross-site publishing in SharePoint Server 2013.

Target pages, category pages, and catalog-item pages

Target pages display page content, and are associated with terms and friendly URLs. You can change the default target pages that are used by the term and any child terms.

When you use cross-site publishing, target pages are also known as category pages. A category page is a special page that can be automatically created when you connect a publishing site to a catalog. You can also create category pages by hand. The category page contains a Content Search Web Part that uses a term from the navigation term set to query for and dynamically display catalog content associated with the current navigation term. This enables you to use the same page repeatedly to display different content, based on the associated navigation term selected by the page visitor. For example, let's say you use cross-site publishing to display electronic products from a catalog. The category page that is used to show a list of products that use the navigation term Cameras is the same page that is also used to display a list of products that use the navigation term Printers. For more information about Content Search Web Parts, see Plan publishing sites for cross-site publishing in SharePoint Server 2013.

A catalog-item page is also a special page that can be automatically created when you connect a publishing site to a catalog. Whereas a category page displays a set of items that match the current navigation term (for example, Laptops), the catalog-item page returns the details for a single item (for example, when a user chooses a specific model on the Laptops category page). The catalog-item page contains a Catalog-Item Reuse Web Part that uses the ID for a specific item that was returned in the results of a Content Search Web Part on a category page to show the details for the item. The ID is the set of primary key properties specified when the publishing site connects to the catalog. Catalog-item pages can be configured only when a site uses cross-site publishing and is connected to a catalog. For example, the URL http://contoso.com/cameras might contain a list of available camera models. If you click the link for the individual product Contoso Digital Camera M200, the catalog-item page displays specific information about that particular camera. Similar to the category page, the catalog-item page enables you to show different items without having to create a different page for each item in the catalog. You use the same page but it shows different content based on the selected item from a result set.

For more information about category pages and catalog-item pages, see "Publishing site collections for SharePoint cross-site publishing" in Overview of cross-site publishing in SharePoint Server 2013.

Friendly URLs

Friendly URLs are URLs that correspond to a term in the navigation term set, and that provide a shorter, more meaningful URL to a page. This makes the URL more useful to visitors to your site, and also improves search engine optimization (SEO) for your site. For example, the URL http://www.contoso.com/products/household/vacuum-cleaner is more meaningful to both users and search engines than the URL http://www.contoso.com/Products/Inventory/Pages/productViewer.aspx?productID=115&name=vacuum%20cleaner&CID=34q327234ef. By default, when you create a new page, a new navigation term is created, and a corresponding friendly URL is created for the page. You can use a single friendly URL to point to a single page. You can also have multiple friendly URLs that point to the same page, such as a category page. For example, if you use cross-site publishing to display content from a knowledge base, you can have separate friendly URLs for /kb/manuals, /kb/troubleshooting-guides, and /kb/product-specs that all point to the same category page, Category-KB-Articles.aspx. You do not have to use cross-site publishing to use multiple friendly URLs that point to the same page.

Global navigation and current navigation controls

The global navigation control (called Top Navigation in the Snippet Gallery) is the primary navigation control that is used to display the navigation for a site. The global navigation control appears at the top of the page in the default master page, and can show one or more levels of navigation, based on terms in the navigation term set. The current navigation control (called Vertical Navigation in the Snippet Gallery) is a secondary navigation control that appears on the left side of the page in the default master page. Current navigation can show one or more levels of navigation that represent the next level of the navigation term set hierarchy based on the term that is selected in the global navigation control. For information about the Snippet Gallery, see Add snippets to a master page or a page layout in SharePoint Server 2013 in the MSDN Library.

How managed navigation works in SharePoint Server 2013

Managed navigation works by associating a term from a navigation term set with a friendly URL and a page in the Pages library. By default, when a new page is created, a new term is created in the navigation term set, and a friendly URL is configured that points to the page. If you are using a standard publishing site that uses the author-in-place publishing model, this means that you'll probably have a 1:1 relationship between pages that are created in the site and terms in the navigation term set. Managing many terms and their corresponding pages can become difficult if your site has many pages. By using cross-site publishing to show content from one or more catalogs, you can use a few category and catalog-item pages to easily display lots of data with minimal configuration and page management. By using managed navigation, you can change the navigation term set and have those changes appear on your site without having to add new pages or change the physical structure of the site and its content.

Before you can use managed navigation, it must be configured in Navigation Settings on the site collection. By default, managed navigation is enabled for site collections that are created by using the Publishing Portal or the Enterprise Wiki site collection templates. On the other hand, the Product Catalog site collection template uses structural navigation because it is intended to be used as a source for catalogs that will be shared with a publishing site for cross-site publishing. When managed navigation is configured, two additional settings are also configured: new pages are automatically added to navigation, and friendly URLs are automatically created for new pages. If you turn off both settings, new pages will not be added to the navigation, and no new terms will be added to the Site Navigation term set.

Note:

To enable managed navigation for a non-publishing site, you must activate the SharePoint Server Publishing Infrastructure feature for the site collection, and activate the SharePoint Server Publishing feature for the site.

Use and benefits of managed navigation in SharePoint Server 2013

You should use managed navigation with any publishing site in which you want the structure of the site navigation to be separate from the structure of the site and its content. If you plan to use cross-site publishing, you can use a tightly managed taxonomy to create a complex navigation structure that would otherwise be difficult and time-consuming to manage if each navigation node represented a separate page. When you use cross-site publishing, managed navigation is enabled by default in the publishing site. You can also use managed navigation in a standard author-in-place publishing scenario. The following table describes possible scenarios in which you might want to use managed navigation.

Table: SharePoint managed navigation scenarios

Scenario | Description
Internet business site | You can use cross-site publishing to create an Internet business site that contains a catalog that shows products to customers based on metadata. Users view pages that are created dynamically based on navigation, and users can filter results by using additional refiners. For more information, see "Plan refiners and faceted navigation" in Plan search for cross-site publishing sites in SharePoint Server 2013.
Intranet site | You can use cross-site publishing to create an internal Human Resources (HR) website that uses a tightly managed navigation structure to show authored content.
Internet presence site | You can use author-in-place publishing to create an Internet Presence site where pages are automatically added to the managed navigation. Content authors can configure navigation properties directly from the pages they create.

Examples of managed navigation in SharePoint Server 2013

This section provides examples of how you can use term sets, tagging term sets, and target pages to define your site's navigation hierarchy.

Simple managed navigation

In the simplest form of managed navigation, every term in the navigation term set corresponds to a page in the site. Site navigation controls reflect the order and the hierarchy of terms in the navigation term set. To change the "structure" of your site — the way the structure appears as displayed in the navigation controls — you simply rearrange terms in the navigation term set.

For example, consider a structure that's common to many public websites. A global navigation menu is displayed horizontally across the top of the page. The global navigation menu has entries for the highest level of information that's contained on the site. In this example, the global navigation menu contains the following entries:

  • Products

  • Customer support

  • About us

The current navigation menu is displayed vertically on the left side of the page. It shows the next level in the navigation hierarchy, relative to whichever page the site visitor is currently viewing. If the visitor is viewing the About us page, then the current navigation menu displays the following entries:

  • Company history

  • Press releases

  • Contact us

You can easily implement this navigation hierarchy by using managed navigation. The navigation term set contains the following terms, arranged hierarchically:

  • Products

  • Customer support

  • About us

    • Company history

    • Press releases

    • Contact us

Figure: Navigation term set driving navigation controls

Navigation term set driving navigation controls

You configure each term in the navigation term set to correspond to a page to display. If you create the pages before you create the navigation term set, you can even have the terms created automatically and the correspondence between terms and pages set up automatically. You can also customize the appearance of the controls themselves — for example, how many levels of the navigation hierarchy to display. To change the structure of your website, you can reorder terms in the navigation term set, and the navigation controls will automatically display the new structure.

Attributes of the terms influence the appearance and behavior of items in the navigation controls. For example, you can change the title of the "Customer support" term to "Customer assistance," and the navigation controls will use the new wording, but still display the same page when the user selects Customer assistance. You can modify attributes of navigation terms to control how the term is displayed, whether the term should be included in the global navigation control and the current navigation control, what text is displayed when a site visitor hovers over the term in a navigation menu, and so on.

Catalogs and term-driven pages

Cross-site publishing is available only in SharePoint Server 2013 Enterprise. If your site uses cross-site publishing, then you can associate one or more tagging term sets with the publishing site. You specify which part of the tagging term set (on the authoring site) to add to the navigation term set (on the publishing site). For more information about cross-site publishing and tagging term sets, see Overview of cross-site publishing in SharePoint Server 2013.

You can add tagging terms either by pinning them or by reusing them. A pinned term is essentially a link. If you change the term in the tagging term set, the changes also apply to the pinned term in the navigation term set. You can pin only a term, or you can pin a term and all of its sub-terms. A reused term is essentially a copy. No association is maintained between the tagging term and the reused navigation term.

Returning to the example, assume that the publishing site uses cross-site publishing. There is an authoring site that has a tagging term set with the following hierarchy of terms:

  • Cameras

    • Digital

    • Film

  • Computers

    • Laptop

      • Gaming

      • High-performance

      • Ultra-light

    • Slate

    • Desktop

  • Printers

    • Inkjet

    • Laser

A list on the authoring site is used as a catalog of all available products. Items in the list are tagged with terms from the tagging term set.

If you pin the root of the tagging term set to the navigation term set, and modify the global navigation control to display two levels of navigation, then the global navigation menu will still display the following entries:

  • Products

  • Customer support

  • About us

Furthermore, the Products menu item in the global navigation menu will expand to show the following menu items:

  • Cameras

  • Computers

  • Printers

If a visitor to the site selects the Cameras entry on the global navigation menu, then the current navigation control displays the following entries:

  • Digital

  • Film

The navigation term set that represents this structure is the following:

  • Products

    • Cameras

      • Digital

      • Film

    • Computers

      • Laptop

        • Gaming

        • High-performance

        • Ultra-light

      • Slate

      • Desktop

    • Printers

      • Inkjet

      • Laser

  • Customer support

  • About us

    • Company history

    • Press releases

    • Contact us

Figure: Tagging term set driving navigation term set

Tagging term set driving navigation term set

When a visitor to the site navigates to a node under Products, a page is automatically generated that shows the following information:

  • If the term has sub-terms, the page displays sub-categories. For example, the page that corresponds to the term Cameras displays the categories for Digital and Film.

  • If the term has no sub-terms, the page displays items that are tagged with the term. For example, the page that corresponds to the term Digital displays items that are tagged with "Digital."

You define the page that is generated by setting attributes on the term in the navigation term set. You can specify values for the following attributes for each term:

  • A friendly URL The friendly URL is displayed in the browser's address bar when the user views the page. It is most likely a suffix that is appended to the parent term's friendly URL. For example, if the friendly URL for the Cameras term is "www.contoso.com/cameras," the friendly URL for the Film term could be "www.contoso.com/cameras/film."

  • A target page This is the page that loads when the friendly URL is accessed. A term can use the same target page as its parent term, or you can override the parent's target page and specify a different one. If you specify a new target page, you can also indicate that it should be used by all child terms of the current term (unless a child term overrides its parent's target page).

  • A catalog item page This is the page that is rendered when a site visitor views an item that is tagged with the term. For example, the target page for the Film term might display images and brief descriptions of all film cameras, whereas the catalog item page for the Film term would display an image of the specific camera that was selected, along with detailed product specifications. A term can use the same catalog item page as its parent term, or you can override the parent's catalog item page and specify a different one. If you specify a different catalog item page, you can also indicate that it should be used by all child terms of the current term (unless the child term overrides its parent's catalog item page).

Using terms in other term sets

When you use cross-site publishing, there are two ways to use terms from an authoring site collection as navigation terms in a publishing site collection: you can pin terms or reuse terms.

When you pin a term from a tagging term set in an authoring site collection into the site navigation of a publishing site collection, that term is shared with the navigation term set in the publishing site collection. Any changes that you make to the original term in the authoring site collection will be reflected anywhere that term is pinned. You can't change the general settings for a term in the publishing site collection where the term is pinned. You also can't add shared properties to the term from the publishing site collection. However, you can add local properties to the term. You can pin a single term, or you can pin a term with all its child terms.

When you reuse a term from a tagging term set in an authoring site collection into the site navigation of a publishing site, that term is copied to the navigation term set in the publishing site collection and no association with the original term is maintained. Any changes that you make to the original term in the authoring site collection are not made on any reused copies of the term. You can change the general settings for the reused term in the publishing site collection. You can also add both shared and local properties to the term from the publishing site collection. You can reuse a single term, or a term with all its child terms.

Limitations of managed navigation in SharePoint Server 2013

Because managed navigation uses term sets to build the site navigation, it has the same limitations as any other term set:

  • There is no version control on terms. If you make a change to a term, you can't later revert the change back to an earlier version of the term.

  • There is no publishing workflow on terms. As soon as you make a change to a term, it will appear in the navigation with the change. If you are using cross-site publishing, this also means that when a new term is added to the navigation term set, the term itself may be visible in the navigation on the publishing site before the associated content is indexed by search. You can choose to hide terms from the navigation until the content is published and indexed by search.

See also

Plan navigation term sets in SharePoint Server 2013
Overview of managed metadata in SharePoint Server 2013
Plan managed metadata in SharePoint Server 2013
Overview of cross-site publishing in SharePoint Server 2013
Plan authoring sites for cross-site publishing in SharePoint Server 2013
Plan publishing sites for cross-site publishing in SharePoint Server 2013
Estimate capacity and performance for Web Content Management (SharePoint Server 2013)


Plan navigation term sets in SharePoint Server 2013
See also

Published: March 26, 2013

Summary: Learn how to create the navigation term set to provide site navigation for SharePoint Server publishing sites.

Applies to: SharePoint Server 2013 | SharePoint Online

The managed navigation feature in SharePoint Server 2013 and SharePoint Online enables you to build navigation for a publishing site that is derived from a SharePoint managed metadata taxonomy. If your publishing site uses managed navigation, then a navigation term set is associated with the site. You can configure the global navigation control and the current navigation control to use the navigation term set to determine what to display. This article explains the information that you will need to provide for each node in the navigation hierarchy, explains how to record this information in a worksheet, and provides links to other articles that explain how to implement your plan.

Before you read this article you should already know whether or not you will be using cross-site publishing. For more information about cross-site publishing, see Overview of cross-site publishing in SharePoint Server 2013 and Plan for cross-site publishing in SharePoint Server 2013. If you will use cross-site publishing, you should also know the structure of the tagging term sets, and you should have an idea of which pages will be used to display which catalog items. You should also know the navigation hierarchy that you want to implement for your site.

Note:

The cross-site publishing feature is available only in SharePoint Server 2013 Enterprise.

For more information about managed navigation and term sets, see Overview of managed navigation in SharePoint Server 2013 and Overview of managed metadata in SharePoint Server 2013.

In this article:

  • Plan a navigation term set

  • Migrating to managed navigation

  • Navigation term set planning worksheet

Plan a navigation term set

Download the Navigation term set planning worksheet and use it to record the decisions you make about terms in the navigation term set for your site. You will use one row for each term in the navigation term set.

Note:

You will need one worksheet for each publishing site that uses managed navigation.

On the worksheet, in the Navigation term column, enter the navigation hierarchy for your site. In the Level in hierarchy column, indicate each term's level in the navigation hierarchy. Sample navigation term set represents the structure of the following navigation term set. An example is shown the table.

  • Products

    • Cameras

      • Digital

      • Film

    • Computers

      • Laptop

        • Gaming

        • High-performance

        • Ultra-light

      • Slate

      • Desktop

    • Printers

      • Inkjet

      • Laser

  • Customer service

  • About us

    • Company history

    • Press releases

    • Contact us

Table: Sample navigation term set

Navigation term | Level in hierarchy
Products | 1
Cameras | 2
Film | 3
Digital | 3
Computers | 2
Laptop | 3
Gaming | 4
High-performance | 4
Ultra-light | 4
Slate | 3
Desktop | 3
Printers | 2
Inkjet | 3
Laser | 3
Customer service | 1
About us | 1
Company history | 2
Press releases | 2
Contact us | 3

If the navigation term comes from a tagging term set, fill in the third and fourth columns. In the Term and term set pinned from column, enter the name of the term in the tagging term set and the name of the tagging term set itself. In the Pin or reuse? column, enter Pin if the term in the navigation term set is pinned from the tagging term set, or enter Reuse if the term is reused from the tagging term set. Leave both of these columns blank if the navigation term is not associated with a tagging term set.

Next, fill in information about how each node should behave in the navigation controls. For each term, enter the following information:

  • In the Navigation node title column, enter the words to display for this term in the navigation controls. This could be the same as the term, a version of the term with different capitalization, or a completely different word or phrase.

  • In the Hover text column, enter the text to display when the site visitor hovers over the node in a navigation control. Don't make the next level in the navigation hierarchy into hover text. The navigation controls themselves manage displaying the next level of the hierarchy. Instead, provide a more detailed description of this node that will help the user determine whether to navigate to the page.

  • In the Show in global navigation menu? column, enter Yes if this term should appear in the global navigation menu. Enter No if the term should not appear in the global navigation menu.

  • In the Show in current navigation menu? column, enter Yes if this term should appear in the current navigation menu when the site visitor navigates to the page corresponding to this term's parent term. Enter No if the term should not appear in the current navigation menu.

  • In the Navigation node type column, enter:

    • Header, if this term should display as a header in navigation controls, but should not link to any page.

    • URL, if the term should link to a specific page. If the navigation term is not associated with a tagging term, the navigation node type is likely to be URL.

    • Term-driven, if you want this term to use a target page and a catalog item page as described earlier in this article. Navigation terms that are associated with tagging terms are likely to use term-driven pages.

  • In the URL (for simple link) column, if the navigation node type is URL, enter the URL that the term should link to. Leave this column blank if the navigation node type is not URL.

Finally, fill in additional information if the term is associated with a term-driven page. Leave these columns blank if the term is not associated with a term-driven page. Enter the following information:

  • In the Friendly URL column, enter the friendly URL to be displayed when a site visitor navigates to the page that is associated with this term. If the parent of this term has a friendly URL, then this term's friendly URL must be the parent term's friendly URL with a suffix in the form "/something" appended.

  • In the Term target page column, enter Inherit from parent if the term should use its parent term's target page, or enter the name of the target page if this term has a different target page.

  • In the Child term target page column, enter the name of that target page if you want terms that are children of this term to use a specific target page. Otherwise, leave this column blank. Child terms can override this value.

  • In the Category image column, enter the name of the image if you want to associate an image with items of this type. Otherwise, leave this column blank.

  • In the Catalog item page column, enter Inherit from parent if the term should use its parent term's catalog item page, or enter the name of the catalog item page if this term has a different catalog item page.

  • In the Child catalog item page column, enter the name of that catalog item page if you want terms that are children of this term to use a specific catalog item page. Otherwise, leave this column blank. Child terms can override this value.

Migrating to managed navigation

SharePoint Server 2013 provides a shortcut to help you migrate sites that don't use managed navigation to become sites that do use managed navigation. If your site already has web pages organized into folders, you can associate each folder that contains pages with a term in the navigation term set. When a user views one of the pages, the term's node in the navigation hierarchy will appear as if it had been selected. Use the Associated Folder field on the Navigation tab in the Term Store Management Tool to associate a folder on the site with a navigation term.

Navigation term set planning worksheet

Download an Excel version of the Navigation term set planning worksheet.

See also

Overview of cross-site publishing in SharePoint Server 2013
Overview of managed navigation in SharePoint Server 2013


Variations overview in SharePoint Server 2013
See also

Published: January 8, 2013

Summary: Learn about variations and the benefits and scenarios for using variations to create multilingual sites in SharePoint Server 2013 or SharePoint Online.

Applies to: SharePoint Server 2013 | SharePoint Online

The variations feature in SharePoint Server 2013 and SharePoint Online makes content available to specific audiences on different sites by syncing content from a source variation site to each target variation site. When users visit the root site, they are redirected to the appropriate variation site, based on the language setting of their web browser. Content on a target variation site can be translated into other languages before it is published. Variations can be used only on sites that are created by using one of the Publishing site templates, or on sites for which the SharePoint Server Publishing Infrastructure feature was activated.

This article contains an overview of the variations feature. It describes the elements of the variations feature; provides an overview of site, list, and page creation for variation sites; lists some limitations of variations; and describes scenarios for using variations in SharePoint. This article does not describe the tasks that are involved in planning a solution that uses variations. For information about how to plan to use variations in your solution, see Plan for variations in SharePoint Server 2013. This article also does not describe how to create variation labels and hierarchies. For information about how to create a variation site, see Create a multi-language website.

In this article:

  • Use and benefits of variations

  • Scenarios for using variations

  • Elements of variations

  • Understanding variations

  • Understanding source variation and target variation site creation

  • Understanding site, list, and page creation

  • Limitations of variations

Use and benefits of variations

Many organizations have a global reach. However, even in domestic markets, organizations must reach a diverse user base that might speak many languages or that might have to have specific information that is based on regional differences. These types of organizations need websites that deliver customized content to suit different cultures, different markets, and different geographic regions. Producing and maintaining different versions of a site can be difficult and time-consuming. By using the variations feature as part of a SharePoint solution, site architects and site administrators can simplify the process of producing and maintaining these sites. The variations feature automates the creation, management, synchronization, and translation of sites, lists, and pages, which eliminates having to manually create a site and all associated lists and pages for each instance of a needed variation.

Scenarios for using variations

You can use variations to create sites, lists, and page content for specific languages. In this scenario, most of the content is authored in the language of the source variation site and synced to some or all of the target variation sites for translation into different languages. For example, the content might be authored in English and be synced to target variation sites for translation into German, French, and Spanish.

You can also use variations to create content for specific locales. For example, a company based in North America might have target variation sites for the following locales: English (United States), English (Canada), French (Canada), and Spanish (Mexico). Most of the content is authored in English (United States), and the variation feature syncs that content to the target variation sites. Content on the French (Canada) and Spanish (Mexico) site is translated into French and Spanish, whereas content for English (Canada) is edited to account for regional differences in United States and Canadian English. Other content that is unique to a specific locale is created on the target variation sites for which it is needed.

In SharePoint Server 2010, you could use variations to create sites for different mobile devices, or that used different branding. In SharePoint 2013, variations is used only for multilingual sites. To create sites for different mobile devices, use Device Channels. To create sites that use different branding, use cross-site publishing. For more information, see Plan for mobile devices in SharePoint 2013 and Plan for cross-site publishing in SharePoint Server 2013.

Elements of variations

The variations feature consists of the following elements:

  • Variation root site The variation root site provides the URL for all source and target variation sites and contains the landing page that redirects users to the correct variation site. This is not the same as the root site of a site collection, although you can specify the root site of a site collection to also be the root site of the variations hierarchy.

  • Variation labels A variation label is an identifier that names a new variation site. Variations of a site are defined by creating variation labels, one for each planned variation.

    Note:

    SharePoint Server 2013 supports up to 209 variation labels. SharePoint Online supports up to 50 variation labels.

  • Variation sites Variation sites are the sites that are created based on the defined variation labels. There are two types of variation sites:

    • Source variation site The source variation site is the site where shared content is authored and published, and it is the site from which the shared content is synced with target variation sites. There can be only one source variation site in a single site collection. After a source variation site is selected, it cannot be changed.

    • Target variation sites The target variation sites receive most of their content from the source variation site. New content can be created on a target variation site. However, that content is not synced with other sites and is unique to the site on which it was created.

  • Variations hierarchy The variations hierarchy is the complete set of sites in all variation labels.

  • Variation lists Variation lists are lists for which you specify target variation labels to receive list items.

  • Variation pages Variation pages are the publishing pages that are stored in the Pages library of the source variation site and the target variation sites.

    Important:

    We recommend that you do not add nonpublishing pages to the Pages library of a site that uses variations. If you do, the Variations Create Hierarchies Job Definition timer job might fail.

Understanding variations

The variations feature creates sites and syncs content and supported list items from a source variation site to one or more target variation sites. By default, the variations feature syncs publishing pages from the Pages library of the source variation site, and any lists that are configured to be synced to specific target variation sites.

By default, when users visit the root site, they are redirected to the appropriate variation site, based on the language setting of their web browser. For example, if a user's default browser language is French, SharePoint redirects that user to the French variation site. You can customize this behavior by replacing the default redirection page, VariationRoot.aspx, with a different page. This new page can implement logic that identifies the user's preferred language. For information about how to customize variation sites redirection, see How to: Customize the Variation Root Landing Logic.

Variation labels

A variation label is an identifier that names a variation site. You select one variation label as the source, which represents the source variation site. The remaining variation labels are the target labels, representing the target variation sites to which content is synced. You create variation sites from variation labels by using the Create Hierarchies command on the Variation Labels page.

Only one set of variation labels, the variation hierarchy, can be defined for a site collection. The corresponding variation sites can be created anywhere within the site collection hierarchy. The source variation site and the target variation sites are always created as subsites of the variation root site. Users who visit the variation root site are redirected to the appropriate variation site.

The following illustration provides an example of a variation site hierarchy, and shows how publishing content is synced to target variation sites.

Planning site variations

Three variation labels, "EN," "FR," and "DE," are created on the root site http://contoso.com. When the variations hierarchy is created, the corresponding variation sites, labeled "EN," "FR," and "DE," are created one level below the variation root site. Because site "http://contoso.com/EN" is specified as the source variation site, lists and pages that are authored and published on site "http://contoso.com/EN" are synced to the target variation sites, "http://contoso.com/FR" and "http://contoso.com/DE."

When you create a variation label, you select a locale for it to use. The locale setting assists with browser redirection and regional settings such as sort order and calendar. It does not affect the language of the user interface. If language packs were installed on the front-end web server, you can also select a language for the variation site. The language setting in SharePoint determines the language of the user interface on the variation site. If no language packs were installed, the option to select a language is not available, and the variation site uses the default language of the SharePoint installation on the server, regardless of the locale that is selected for the variation label. For example, if SharePoint was installed by using the English version, and no language packs were installed, when a new variation label is created for the Japanese locale, the user interface for the new variation target site is in English, not Japanese. If you want the user interface of a target variation site to be displayed using a specific language, you should install the language pack for each language before you create the variation sites. If a language pack is not available when a target variation site is created, the target variation site can still be created, and users can change the alternate language for a site by using the multilingual user interface. For information about the multilingual user interface, see Plan for multilingual sites in SharePoint 2013. For information about how to install language packs, see Install or uninstall language packs for SharePoint 2013.

When you create a variations hierarchy, a navigation term set is created for each variation label. By default, the term set for the source variation label is named Variations Navigation. The term set for a target variation label is named Variations Navigation (LabelName). For example, if you have a target label named en-ca, the term set for that label will be named Variations Navigation (en-ca). By default, when the variations feature creates a target page for the first time, a corresponding navigation term is also created on the target variation site. When you export a page for translation, its associated navigation term is also exported.

Variation settings

The Variations Settings page contains the following options:

  • Site, List, and Page Creation Behavior Determines whether sites, lists, and pages on the source variation site are created automatically on the target variation sites. By default, Create Everywhere is enabled. If you enable Create Selectively, the first time that you sync sites, lists, and pages from the source variation site to target variation sites, you must do so manually. Subsequent updates to items on the source variation site will be synced based on the target label sync preferences.

  • Recreate Deleted Target Page Determines whether a page should be re-created on a target variation site if the page was deleted from the target variation site, and the page on the source variation site was republished. By default, this option is enabled. If you disable this option, deleted pages are not re-created on target variation sites. For example, consider the case in which a content author creates a page on the source variation site that is not relevant to a target variation site. However, because Create Everywhere is enabled, the page is created automatically on the target variation site, and the target label content owner later deletes the unwanted target page. The next time that the content author updates the source page, the page will not be re-created on the target variation site.

  • Update Target Page Web Parts Determines whether changes that were made to Web Parts on pages on a source variation site are also made on pages on target variation sites. By default, this option is enabled.

  • Notification Sends an email message to the contact of the target label of a target variation site when a new page or site is created or to the contact person of the specified page when a page is updated with revisions from the source variation site. If the label does not have a contact, then the email message is sent to the contact of the welcome page of a target variation site. By default, this option is enabled.

For information about how to specify variations settings, see Create a multi-language website.

Variations timer jobs

The variations feature uses timer jobs to perform tasks such as creating and propagating sites and pages. A timer job runs inside OWSTIMER, a Windows service for SharePoint. Each timer job has its own default schedule for when the job runs. You can change the frequency with which each job runs on the Job Definitions page on the Central Administration website. The variations feature uses the following timer jobs:

  • Variations Create Hierarchies Job Definition Creates a complete variations hierarchy by creating all variation sites, lists, and pages from the source variation site, based on the variation labels. By default, this timer job runs hourly.

  • Variations Propagate List Items Job Definition Creates and updates list items on target variation sites after a list is configured to send items to specific target variation labels. By default, this timer job runs every 15 minutes.

  • Variations Propagate Page Job Definition Creates and updates pages on target variation sites after a page on the source variation site is approved or after it is manually submitted by a user. By default, this timer job runs every 15 minutes.

  • Variations Propagate Sites and Lists Job Definition Creates variation sites and lists when the Create Everywhere option is enabled. By default, this timer job runs every 30 minutes.

Note:

Timer jobs are not configurable in SharePoint Online.

For information about timer jobs, see View timer job status in SharePoint 2013.

Understanding source variation and target variation site creation

Source variation and target variation sites are always created one level below the variation root site. Each variation site is created by using the same site template that is used to create the variation root site. This means that by default, each variation site will use the same master page as the variation root site. However, each variation site can use separate master pages, page layouts, and CSS files. This is useful when you want to have separate layouts for different locales. For example, you can use a right-to-left layout for one language and a left-to-right layout for another language. For information, see Overview of the SharePoint 2013 page model.

When the variations hierarchy is first created, only sites that are based on the list of defined variation labels are created. If the variation root site has sites below it in a hierarchical site structure, and you want to include those sites in the hierarchical site structure of each variation site, you must manually create the hierarchical structure of those sites below the source variation site after you create the variation hierarchy. By default, the next time that the Variations Create Hierarchies Job Definition timer job runs, the sites are synced only to any new target variation sites that are created at that time. For information about how sites below the source variation site are created on existing target variation sites, see Understanding site, list, and page creation later in this article.

After the variations hierarchy is first created, when you add a new label to the variations hierarchy and then click Create Hierarchies on the Variation Labels page, a new target variation site is created for each new label. By default, if the source variation site has content in the Pages library, a list that is configured to send list items to specific target variation labels, or contains sites below it in the site hierarchy, those pages, lists, and sites are created on all new target variation sites only.

Understanding site, list, and page creation

By default, any sites that are created below the source variation site and any lists and pages that are published on the source variation site or on any sites below it in the site hierarchy are automatically synced to the target variation sites. If Create Selectively is enabled, you must manually create any sites, lists, and pages on the selected target variation sites.

This section describes the ways in which sites, lists, and pages are created on target variation sites.

Site creation

The first time that the Variations Create Hierarchies Job Definition timer job runs and creates the variations hierarchy from the list of variation labels, only the source variation and target variation sites are created. After the source variation site is created, you can create sites below it in the site hierarchy, and those sites are then created on the existing target variation sites the next time that the Variations Propagate Sites and Lists Job Definition timer job runs. If Create Selectively is enabled, use the Site Variation Settings page on any site that is below the source variation site to manually create a target variation of the current site on one or more target variation sites. The new site is created on the specified target variation site when the next Variations Propagate Sites and Lists Job Definition timer job runs. You can do this any time that Create Selectively is enabled.

Note:

When source variation and target variation sites are created, they are created by using the default site definition provided by the template selected when the source label was created. No custom site configurations or settings are synced to the new sites. If you want the source variation and target variation sites to have custom site configurations or settings, such as navigation customizations, you must make those changes on each site after you create the variations hierarchy.

List and page creation

List items are synced to variation target sites only when the list on the source variation site is configured to specify the target variation sites to which they should be synced. By default, when a list is configured to be synced to specific target variation sites, it is synced when the next Variations Propagate Sites and Lists Job Definition timer job runs. If a new item is added to a list that has already been synced to target variation sites, it is synced when the next Variations Propagate List Items Job Definition timer job runs. If a new target variation label is added after the variations hierarchy is created, the list will be created on the new target variation site. By default, content approval is enabled on target lists. When a new item is synced to a target list, it must be approved before it will appear in a Content Query Web Part on the target variation site.

Note:

Although you can specify individual pages that you want to sync to specific target labels, you cannot sync individual list items. You can only specify a complete list to sync to specific target labels.

If the Publishing Site template was selected when the source variation site was created, pages on the source variation site or on any site below it in the site hierarchy must be published before they are eligible to be synced to target variation sites. If the Publishing Site with Workflow template was selected, pages must be approved for publication by using the publishing workflow before they are eligible to be synced to target variation sites. By default, after a new page is published or approved for publication, if it uses workflows, it is synced to all target variation sites when the next Variations Propagate Page Job Definition timer job runs. If the page was published previously and is changed and republished on the source variation site, and the Automatically update target variation pages setting is selected for the target labels, the page is synced to all target variation sites when the next Variations Propagate Page Job Definition timer job runs.

Note:

On target variation sites, a page that is synced from the source variation site is always assigned a minor version number. If the page is new to the target site, it is assigned version 0.1. If the page already exists on the target variation site, the synced page is assigned the next available minor version number. For example, if a target variation site has version 2.1 of a page and a new variation of that page is synced to the target site, the page becomes version 2.2. Pages and additional resources, such as images that are approved for publishing on the source variation site, are synced to the target variation site together with their Approval status set to Draft, and they must be approved before they can be viewed by readers of the site.

If Create Selectively is enabled, a user must create the page for a specific variation label by using the Create new targets command in the Variations group on the Publish tab of the page on the source variation site. The new page is synced to one or more target variation sites when the next Variations Propagate Page Job Definition timer job runs. If the page was published previously and is changed and republished on the source variation site, it is synced only to the specified target variation site when the next Variations Propagate Page Job Definition timer job runs. For information about how to enable Create Selectively for variation pages, see Create a multi-language website.

By default, when a page that was synced from the source variation site is deleted from a target variation site, that page is re-created on the target variation site the next time that it is published on the source variation site and the next time that the Variations Propagate Page Job Definition timer job runs. If Recreate Deleted Target Page is disabled, deleted pages are not re-created on the target variation sites.

For information about how to create variation source pages and how to work with content on variation target pages, see Create a multi-language website.

Limitations of variations

The following list contains information about the limitations of the variations feature in SharePoint:

  • Variations feature is a single-tier hierarchy. The source and target variation sites exist at the same level within the site hierarchy, one level down from the variations root site. However, you can have only one source variation site per site collection. A site cannot be both a source and a target site. You can sync content from a source variation site to one or more target variation sites, but you cannot sync content from one target variation site to another target variation site. For example, if you have a source variation site in English (United States), and a target variation site in French (France), which has a French (Canada) site below it, the variations feature will only sync content from the English (United States) source variation site to the French (France) target variation site. The variations feature cannot also sync content from the French target variation site to the French (Canada) site below it.

    You can use variations together with cross-site publishing to reuse content from one variation site in the context of another variation site. For example, you could reuse content from the French (France) site on the French (Canada) site.

    For more information, see Plan the logical architecture for cross-site publishing in SharePoint Server 2013.

  • Content syncing is unidirectional. The variations feature syncs content from a source variation site to one or more target variation sites. You cannot use the variations feature to sync content from a target variation site back to a source variation site. Also, target variation sites cannot sync content to other target variation sites.

See also

Plan for variations in SharePoint Server 2013


Plan for variations in SharePoint Server 2013
See also

Published: January 8, 2013

Summary: Learn how to plan for variations, identify the source and target variation sites, and decide how content will be synced on target variation sites in SharePoint Server 2013 and SharePoint Online.

Applies to: SharePoint Server 2013 | SharePoint Online

The variations feature in SharePoint Server 2013 and SharePoint Online makes content available to specific audiences on different sites by syncing content from a source variation site to each target variation site. Content on a target variation site can be translated into other languages before it is published. Variations can be used only on sites that are created by using one of the Publishing site templates, or on a site for which the SharePoint Server Publishing Infrastructure feature was activated.

This article contains information about important items that you should consider when you use variations in a publishing site collection, and it describes the tasks that are involved in planning a solution that uses variations in SharePoint Server 2013. This article does not provide an overview of variations, describe how to use variations, or explain how to create variation labels and hierarchies. For more information about variations, see Variations overview in SharePoint Server 2013.

In this article:

  • About planning variations

  • Important items to consider when planning to use variations

  • Determine the variations needed

  • Specify the source variation site

  • Plan target variation sites

  • Decide how sites, lists, and pages will be created on target variation sites

  • Plan variations timer job scheduling

  • Variations planning worksheet

About planning variations

The planning process that is described in this article starts with describing important items that you should consider when you plan to use variations with a SharePoint solution. The remainder of the article describes the steps that are required to plan for using variations with SharePoint Server 2013. These steps include the following:

  • Determine the variations that are needed and select the variations root site.

  • Specify the source variation site and plan the target variation sites.

  • Decide how sites, lists, and pages will be created on the target source sites.

  • Plan how variations timer jobs will be scheduled.

You can record this information in the Variations planning worksheet.

Important items to consider when planning to use variations

Before you plan to use variations with a SharePoint solution, you should be aware of the interaction between variations and other SharePoint features. This section contains information about important items to consider when you plan to use variations with a SharePoint solution.

Content approval

Content approval is the method by which site members with approver permissions control the publication of content. In content approval, content is considered published when a new major version is approved, because major versions are viewable by users who have read permissions. Content approval in variation sites requires major and minor versioning in the Pages libraries on the source and target variation sites. For more information about content approval, see Plan content approval and scheduling.

Content approval has unique factors that you should consider when you are planning variations:

  • On the source variation site, when a page is submitted for approval, an e-mail message is generated and sent to the contact of the page by using the values stored in the following columns, in the following order:

    • Contact

    • Contact E-Mail Address

    • Modified By

    Note:

    Starting with the Contact field, each field is checked for contact information to which the notification can be sent. If the first field is empty, the next field is tried until contact information is found.

    After the page is approved for publication, it is enabled for syncing to the target variation sites. You can configure the variations settings so that content is either manually or automatically synced to the variation sites.

  • On target variation sites, a page that is synced from the source variation site is always assigned a minor version number. If the page is new to the target site, it is assigned version 0.1. If the page already exists on the target variation site, the synced page is assigned the next available minor version number. For example, if a target variation site has version 2.1 of a page and a new variation of that page is synced to the target site, the page becomes version 2.2.

  • If a page is published on the source variation site, when the page is synced to target variation sites, the Approval status is set to Draft. If Content Approval and Document Version History are enabled in the Pages library on target variation sites, the page must be approved on each target variation site before the page is available to readers.

Note:

Changes made to content that originates on the source variation site can supersede changes made to the content on the target variation site. For example, if the source variation site is in one language and the target variation site is in another, the following situation might occur: An editor changes a localized page on the target variation site, assigning it a new minor version, 1.1. Then, a writer on the source variation site makes different changes to the same page, which is synced to the target variation site as version 1.2. This supersedes the version 1.1 changes to the page. In this example, an editor for the target variation site would have to restore the previous version of the page from the Version History, accept the new version, or use the View Changes button to view differences between the current version and previous versions of the page, and manually merge the new and previous versions into a new version. For more information about versioning, see Plan document versioning, content approval, and check-out controls in SharePoint 2013.

Site navigation

If you use site variations, you must plan your site navigation experience carefully. In SharePoint Server 2013, site navigation links to the current site's peer sites are automatically generated and displayed in the Global Navigation and Current Navigation menus of a web page. In variation sites, where the current site's peers are variations of the same site, you might not want to give site users the ability to browse to other sites in this manner. You can use the Navigation Settings page to change the settings of the Global Navigation and Current Navigation menus so that peer sites are not displayed.

Note:

Changes to site navigation on the source variation site are not synced to the target variation sites. If you want the site navigation on target variation sites to match the site navigation on the source variation site, you must manually change the site navigation settings on the target variation sites.

For more information about site navigation, see Overview of site navigation in SharePoint 2013.

Content deployment

Content deployment copies content from a source site collection to a destination site collection.

We recommend that you disable any content deployment jobs that include the source variation site while Variations Create Hierarchies Job Definition runs. If content deployment runs while the Variations Create Hierarchies Job Definition timer job is also running, a target variation site that is only partially created may be synced to the target variation site on the destination server.

For more information about content deployment planning, see Plan content deployment (SharePoint Server 2010).

Cross-site publishing

Unlike the variations feature, which syncs content from a source variation site to a target variation site, the cross-site publishing feature uses the search index to only show content on other sites. You can share a list or library as a catalog, which is indexed by the search service, and then show the content in query results in Web Parts on other pages and in other site collections.

The variations feature is limited to syncing content within a single site collection. However, you can share lists and libraries as catalogs in variation sites. Then you can create any number of site collections to represent your variation labels, and display content in these site collections. This enables you to have different country code top-level domains for different variation labels. For example, you can have contoso.co.uk or contoso.mx.

Note:

Cross-site publishing is available only in SharePoint Server 2013.

For information about cross-site publishing, see Plan for cross-site publishing in SharePoint Server 2013.

Web Parts

A Web Part is one of the building blocks of pages based on SharePoint Server 2013. Most Web Parts are designed to display a specific type of data, such as text, HTML, or images. SharePoint Server 2013 includes a default set of Web Parts, and you can also develop or import custom Web Parts.

Web Parts are synced with pages of variation sites. If Update Target Page Web Parts is enabled, Web Parts are updated only on the target variation site if a page that contains that Web Part is synced to the target variation site. If the Web Part appears on multiple target pages on different target variation sites, all instances of the Web Part are updated when the page from the source variation site is synced to the target variation sites. For example, if a page contains a Media Web Part, and the Web Part is configured to point to video A that is stored on a site outside the variations hierarchy, when the page is published on the source variation site, the page is synced to all target variation sites. The pages on the target variation sites display video A in the Media Web Part. If the page on the source variation site is updated and the Media Web Part is changed to point to video B, the pages on the target variation sites continue to point to video A until the page on the source variation site is published and synced to the target variation sites. Also, if readers on the target variation sites do not have permission to view the video file that is stored outside the variations hierarchy, they cannot view the video. To prevent unintended Web Parts behavior such as this, you can configure the variations settings so that Web Part updates are not synced to target variation sites.

Multilingual sites

SharePoint Server 2013 has several features that enable you to support users in different regions or users who speak different languages. You can use these features to create websites in different languages and to enable users to view the user interface of a site in a language other than the one in which a site was created. If you plan to use variations with multilingual sites, there are additional steps that you must follow to enable multilingual support for the variation sites. For more information about how to plan multilingual sites, see Plan for multilingual sites in SharePoint 2013.

Determine the variations needed

Variations are used to create multilingual sites, and sites based on regional differences. Determine which variations are needed for your solution, and make a list of the sites that will belong to the variations hierarchy.

If you will be using variations for creating multilingual sites in SharePoint Server 2013, and if you want the site administration pages of the target variation sites to be displayed in another language, you must install the language pack for each language that corresponds to a variation site. For information about how to install language packs, see Install or uninstall language packs for SharePoint 2013. If you will be using variations for creating multilingual sites in SharePoint Online, all language packs are installed and available for use.

Specify the source variation site

The source variation site is the site where content to be shared by all sites is authored and published, and it is the site that is used to sync changes to the target variation sites. The first variation label that you create is automatically specified as the source variation site. There can be only one source variation site for a variations hierarchy. After a source variation site is specified, it cannot be changed.

Review the list of sites for your variations solution, and decide which site will be the source variation site. Record the source variation site for your solution in the top row of the Variations data sheet tab in the Variations planning worksheet. Enter the information for the following columns:

  • Site template language The name of the language pack to use as the default user interface language. For example, English. If you are not using the multilingual user interface on the target sites, leave this column empty.

  • Locale The locale that the label represents. For example, English (United States).

  • Variations home The location where the source and target variations will be created. The variation home site provides the URL for all variation sites and contains the landing page that redirects users to the correct variation site. The home site can be a site at any level in a site collection, including the top-level site. However, after you specify the home site, you cannot change it after you click Create Hierarchies, and you cannot use variations anywhere else in the site collection.

    To indicate a top-level website of the site collection, type a slash (/).

    Note:

    If the home site contains a site hierarchy, or list or Pages library content that you want to include in the source variation site, you must manually copy them to the source variation site after it is created.

  • Label name The name as it will appear in the URL.

  • Label description A description for the label.

  • Display name The name as it will appear in the site navigation.

  • Publishing site template The site template that is used to create the source variation site. Type Publishing Site with Workflow or Publishing Site.

  • Label contact One or more contacts for the variation site.

Plan target variation sites

Review the list of sites for your variations hierarchy, and record each target variation site in the Variations planning worksheet. For each site, enter the information for the following columns.

  • Site template language The name of the language pack to use as the default user interface language. For example, German. If you are not using the multilingual user interface on the target sites, leave this column empty.

  • Locale The locale that the label represents. For example, German (Germany).

  • Label name The name as it will appear in the URL.

  • Label description A description for the label.

  • Display name The name as it will appear in the site navigation.

  • Hierarchy creation The portion of the source hierarchy that will be synced to the target variation site. Type one of the following:

    • Publishing Sites, Lists with Variations, and All Pages

    • Publishing Sites Only

    • Root Site Only

  • Allow human translation Whether to allow human translation on the target label. Type Y or N.

  • Translator language The translator language to use on the target label if human translation is allowed.

  • Allow machine translation Whether to allow machine translation on the target label. Type Y or N.

    Note:

    If the Machine Translation Service is not enabled on the server, the machine translation option is not available.

  • Machine translator language The machine translation language to use on the target label if machine translation is allowed.

  • Label contact One or more contacts for the variation site.

Note:

SharePoint Server 2013 supports up to 209 variation labels. SharePoint Online supports up to 50 variation labels.

Plan custom master pages, layout pages or style sheets

You can decide to use custom master pages, page layouts, or style sheets for variation sites. For example, you might need different master pages and page layouts for sites where the language is read right-to-left. Master pages, page layouts, and style sheets are managed only in the top-level site of a site collection. Therefore, you must make all changes to these resources in one of the locations in the top-level site as shown in the following table.

Table: Resource locations for variations customization

Resource | Location
Master Page | Master Page Gallery
Layout Page | Master Page Gallery
XSL styles and cascading style sheets | Style Library

Target pages can have different page layouts independent of the source variation site. If the page layout on the source site changes, the page layout of the target page is not changed.

Plan custom content types

You must use the same content type (either the Page content type, or a content type based on the Page content type) for all pages that are stored in the Pages library of the source variation site. The easiest way to do this is to use a content type that is defined on the Site Content Type page in the top-level site of the site collection.

If you must have custom columns for one or more pages on the variation sites, add them to the content type that you are using in your Pages libraries. For example, you can add a column that indicates whether the page was localized. For more information about how to plan content types and columns, see Plan content types and workflows in SharePoint 2013.

Decide how sites, lists, and pages will be created on target variation sites

If the source variation site will have other sites below it in a site hierarchy, you must plan for how those sites will be created on the target variation sites. There are two ways in which sites can be created on target variation sites: automatically and manually. By default, any new sites that are added below the source variation site will be automatically created on all target variation sites. However, if you disable automatic site and page creation for variations, for each new site that you create below the source variation site, you must manually specify the target variation sites on which the site should be created. Although enabling new sites to be created automatically on the target variation sites has the advantage of reducing tasks for the site administrator, the advantage to manual site creation is that you can specify which sites should be created on which target variation sites. This can be useful if you want a site to be included only on some, but not all, target variation sites.

For list and page content, there are two decisions that you must make about how the content is propagated.

  1. From the source perspective, what happens when new content is published? You can choose to do one of the following:

    • Automatically create a copy of the content in all target variation sites. This is the Create Everywhere option, and it is enabled by default.

    • Manually create a copy of the content in selected target variation sites. Subsequent updates to that content will be available automatically for the specified target variation sites. This is the Create Selectively option.

  2. From the target perspective, what happens when new content is available? You can choose to do one of the following:

    • Automatically sync the change from the source variation site, and add it as a new draft version on the target variation site.

    • Notify the target label owner that a change is available. The label owner decides whether to manually sync the content.

By default, any new pages that are published in the Pages library of the source variation site will automatically be created on all target variation sites. However, if Create Selectively is enabled, for each new page that you create on the source variation site, you must manually specify the target variation site on which the page should be created. The Create Selectively option can be useful if you want certain pages to be included only on some, but not all, target variation sites.

Lists can be created automatically on target variation sites only if they are created on the source variation site before the variation hierarchy is created. If a list is created after the variations hierarchy is set up, a list must be created manually on the target variation sites by using the Settings button on the Variations tab on the ribbon for the list on the source variation site. However, new list items can be created automatically on a target variation site.

By default, the Create Everywhere option is enabled. You should carefully consider the potential increase in administrative tasks if you decide to enable the Create Selectively option. You can configure the settings for site, list, and page creation behavior on the Variations Settings page in Site Collection Administration. For information, see Create a multi-language website.

Plan variations timer job scheduling

The variations feature uses timer jobs to perform tasks such as creating and propagating sites and pages. A timer job runs inside OWSTIMER, a Windows service for SharePoint. Each timer job has its own default schedule for when the job runs. You can change the frequency with which each job runs on the Job Definitions page on the Central Administration website.

Note:

Timer jobs are not configurable in SharePoint Online.

The following table lists the variations timer jobs and the default schedule for each job.

Table: Variations timer jobs and default schedules

Job name | Default schedule
Variations Create Hierarchies Job Definition | Hourly
Variations Propagate List Items Job Definition | Every 15 minutes
Variations Propagate Page Job Definition | Every 15 minutes
Variations Propagate Sites and Lists Job Definition | Every 30 minutes

You can specify when each job will run by setting a recurring schedule in minutes, hourly, daily, weekly, or monthly intervals. If you select daily, weekly, or monthly, you can specify a window of time for when the job should run, and the server will randomly select a time within the specified range in which to start to run the job. This option is most appropriate for high-load jobs that run on multiple servers in a farm. Be aware that running this type of job on all servers in the farm at the same time might increase the server load and affect performance. To avoid this possibility, you can specify an exact starting time for a job.

You should carefully plan when the variations timer jobs should run on your servers, and set the recurring schedule accordingly. For example, to determine how often the Variations Propagate List Items Job Definition or the Variations Propagate Page Job Definition should run and sync list items or pages to target variation sites, consider how many list items or pages will be created on the source variation site, and how often those list items or pages will be updated.

If you plan to change the default schedule of the variations timer jobs, record the new schedule for each timer job on the Variations Timer Jobs tab in the Variations planning worksheet.

Variations planning worksheet

Download an Excel version of the Variations planning worksheet.

See also

Variations overview in SharePoint Server 2013


Plan for caching and performance in SharePoint Server 2013
See also

Published: April 9, 2013

Summary: Learn about the BLOB cache, Bit Rate Throttling, and other SharePoint features that can improve browser performance.

Applies to: SharePoint Server 2013

SharePoint Server 2013 provides a disk-based binary large object (BLOB) cache that reduces database load and increases browser performance for users. This article describes the BLOB cache, tells you how and when to use it, and lists key considerations for planning to use it. This article also contains information about when to use Bit Rate Throttling, an Internet Information Services (IIS) 7.0 extension that improves video performance for users when serving videos as part of managing digital assets in SharePoint Server 2013. Finally, this article also discusses the other types of caches that are available in SharePoint Server 2013, describes the limitations of upload file size restrictions, and lists considerations for adjusting the size limit for file transfers on the server.

For information about how to enable the BLOB cache, see Configure cache settings for a web application in SharePoint Server 2013. For information about managing digital assets, see Plan digital asset libraries in SharePoint Server 2013.

In this article:

  • Disk-based BLOB caching

    • BLOB cache overview

    • Decide whether to use the BLOB cache

    • Store the BLOB cache

    • Enable the BLOB cache

    • Specify the size of the BLOB cache

  • Output cache, object cache, and anonymous search results cache

  • Bit Rate Throttling

    • Bit Rate Throttling overview

    • Decide to use Bit Rate Throttling

    • Enable Bit Rate Throttling

  • Maximum upload file size

    • Maximum upload file size overview

    • Decide maximum upload file size

    • Configure the maximum upload file size

Disk-based BLOB caching

This section describes the disk-based BLOB cache, and provides important information about how to plan to use the cache with a SharePoint deployment. It tells how to decide when to use the BLOB cache, where to store it, how to enable it, and how to configure the size of the cache to get the best performance for users.

BLOB cache overview

The disk-based BLOB cache controls the caching for binary large objects (BLOBs), such as frequently used image, audio, and video files, and other files that are used to display web pages, such as .css and .js files. The BLOB cache is enabled on a front-end web server and improves performance by retrieving BLOB files from the database and storing them in a directory on the front-end web end server where they are served to users. This reduces the network traffic to and load on the database server.

The BLOB cache also provides features that support serving media files to users. One such feature is support for byte-range requests, which lets users select a later point in the video and immediately begin playback. Another feature is progressive caching, which starts serving the beginning of a large video file while the rest of the file is being cached. Video files are divided and retrieved in smaller sections to reduce the load between the front-end and back-end servers. An administrator can configure the size of the sections.

The BLOB cache is also a prerequisite for using the image renditions feature. Image renditions let you display different sized versions of an image on different pages in a publishing site, based on the same source image. When you create an image rendition, you specify the width and height for all images that use that image rendition. For more information, see How to: Manage image renditions in SharePoint 2013 in the MSDN Library.

Decide whether to use the BLOB cache

When enabled, the BLOB cache caches various image, audio, and video files, together with .css and .js files. An administrator can change the settings to add or remove file name extensions of file types to be cached. This functionality lets you either cache as many file types as possible, or to restrict the cache to certain kinds of files. For example, if you have an Internet-facing portal with read-only files such as .doc or .pdf files, you can specify that those files be cached so that they are displayed more quickly to users. If you have a collaboration site that contains files that are frequently updated, and also media assets, you can specify that the cache is to store only audio or video types by including only file name extensions for those files in the cache settings.

Before you enable the BLOB cache, carefully consider the scenario in which you plan to use it. If your site will be used for heavy collaboration, enabling the BLOB cache might temporarily affect the performance of your site while the files to be cached are first written to the disk. After the files have been stored in the cache, site performance will improve, so take this into consideration when you decide whether to enable the cache. Base your decision to enable BLOB caching on the following criteria:

  • For a publishing site for which most of the visitors are anonymous or where most of the files are static content, enable the BLOB cache for as many file types as possible.

  • For a publishing site that plans to use the image renditions feature, you must enable the BLOB cache.

  • For other sites that contain lots of media assets that are read-only, or where only a small percentage of the media assets are updated, enable the BLOB cache for media files only.

There is one BLOB cache per web application. If you plan to use the BLOB cache together with an asset library that you expect will be large, or together with a site that will receive lots of traffic, consider putting the site collection that contains the asset library into its own web application so that it receives its own BLOB cache. This will ensure that other assets are not using up space in the BLOB cache that you want allocated to items in the asset library. It will also ensure that sites which receive lots of traffic do not prevent other sites which receive less traffic from benefitting from the BLOB cache.

Store the BLOB cache

When you enable the BLOB cache, you must specify a location on the front-end web server where the files will be stored. By default, the cache will be created on the drive on which SharePoint is installed. Make sure that you put the BLOB cache on a drive that has sufficient disk space available in which to store the cache. Also, select a drive that will be used by as few processes as possible so that the BLOB cache process does not encounter conflicts when it tries to access the drive. If too many processes compete for disk access on the drive where the BLOB cache is located, BLOB cache performance and other processes will be adversely affected.

If you plan to use the BLOB cache in a scenario with heavy cache use, such as serving videos in a high traffic environment, and if you will use ULS logging, consider placing the BLOB cache on a separate physical drive from the ULS log — not on a separate partition. Storing the BLOB cache and the ULS log on the same drive can result in poor server performance. If you place the BLOB cache and the ULS log on the same physical drive, make sure that you closely monitor the disk queue length for any performance effect.

Each front-end web server has its own local copy of the BLOB cache that is built as requests for files are received. If you use load balancing with multiple front-end web servers, each server contains its own cache. When a file is requested by the first server, it is cached to that server only. If the next request for the same file comes from a second server, a second request is sent to the database server to retrieve the file to the cache on the second server.

Enable the BLOB cache

The BLOB cache is configured in the web.config file for each web application and, by default, is not enabled. You must specifically enable the BLOB cache to get the performance advantage it provides. For information about how to enable the BLOB cache, see Configure cache settings for a web application in SharePoint Server 2013.

Specify the size of the BLOB cache

When you decide how large to make the BLOB cache, you must consider the number and size of the files to determine the total size of the data to be stored in the cache. By default, the BLOB cache is set to 10 gigabytes (GB). Allow at least 20 percent more space on the drive than the size of the cache. For example, if you have 100 GB of content, set the size of the cache to 120 GB on a drive that has at least 150 GB of space. If the BLOB cache is too small, serving files to users slows, reducing the performance of your site.

If you plan to use the image renditions feature on your site, you should account for each rendition being a separate BLOB in the cache. For example, if you plan to have five renditions per image, then you must allocate significantly more than the general estimate of 20 percent more space on the drive.

Output cache, object cache, and anonymous search results cache

In addition to the BLOB cache, SharePoint Server 2013 provides the following types of caches that help improve the speed at which web pages load in the browser:

Note:

You must be using the Publishing feature on your site to use the output cache or the object cache.

  • Output cache: Stores the rendered output of a page. It also stores different versions of the cached page, based on the permissions of the users who are requesting the page.

    Cache profiles describe specific cache settings for each type of page output cache. Cache profile settings can be configured in the user interface at the site collection level by a site collection administrator, and also at the web application level by an administrator on the front-end web server. The page output cache must be enabled at the site collection level before page output cache profiles can be configured at either the site collection level or web application level. For more information, see Configure cache profile settings.

    Note:

    There is a known issue with the Content Search Web Part. The SendContentBeforeQuery setting in the Web Part does not work correctly on pages that use output caching. This issue is resolved in the SharePoint Server 2013 cumulative update for March 2013. For more information, see Microsoft Knowledge Base article 2767999: Description of the SharePoint Server 2013 update: March 12, 2013.

  • Object cache: Reduces the traffic between the web server and the SQL database by storing objects such as lists and libraries, site settings, and page layouts in memory on the front-end web server. As a result, the pages that require these items can be rendered quickly, increasing the speed with which pages are delivered to the client browser.

    The object cache settings can be configured at the site collection level in the user interface by a site collection administrator, and is on by default. The maximum cache size can be configured at the web application level on the front-end web server to place a restriction on the maximum amount of memory that the cache will use for all site collections. For more information, see Configure object cache settings.

  • Anonymous search results cache: Used primarily by publishing sites that allow access to anonymous users. The anonymous search results cache saves search results from anonymous users and reuses them for later queries that are the same as the original query. This improves performance on site pages that use the Content Search Web Part.

    Note:

    There is a known issue in which Content Search Web Part and the Catalog-Item Reuse Web Part do not use the anonymous search results cache on category pages. This issue is resolved in the SharePoint Server 2013 cumulative update for March 2013. For more information, see Microsoft Knowledge Base article 2767999: Description of the SharePoint Server 2013 update: March 12, 2013.

    If you have category pages that you created before the cumulative update was installed, you must re-create the category pages. Save the layouts and any customizations on the original category pages that you want to keep. Disconnect and then reconnect to the catalog, and then copy the customizations to the new category pages.

Bit Rate Throttling

This section contains information about Bit Rate Throttling, describes when you should use it with the SharePoint solution, and explains how to enable it.

Bit Rate Throttling overview

Bit Rate Throttling is an IIS 7.0 extension that meters the download speeds of media file types and data between a server and a client computer. The encoded bit rates of media file types such as Windows Media Video (WMV), MPEG-4 (MP4), and Adobe Flash Video, are automatically detected, and the rate at which those files are delivered to the client over HTTP are controlled according to the Bit Rate Throttling configuration. For more information, see Bit Rate Throttling.

Decide to use Bit Rate Throttling

If you will make long-playing video assets available to users in SharePoint Server 2013, enable Bit Rate Throttling in IIS. Without Bit Rate Throttling, IIS will serve video files by using as much bandwidth as it can, which will result in increased network performance. When you enable Bit Rate Throttling in IIS, it will serve video files that use only as much bandwidth as is needed to support progressive downloading and viewing of videos. When the BLOB cache is also enabled, Bit Rate Throttling uses extension rules for files cached to disk. Files that are served from the BLOB cache by using Bit Rate Throttling are sent to the client based on a percentage of the compressed size using the encoded bit rate. For example, if the videos in your organization are smaller than 10 MB, you may decide not to use Bit Rate Throttling because it will affect how fast users can download videos to their local computers. However, if you are serving video files, enable Bit Rate Throttling to control the speed at which files are downloaded to client computers.

Note:

Bit rate throttling will not work correctly if you do not first enable the BLOB cache and configure it to cache the files types that you want to throttle.

Enable Bit Rate Throttling

To enable Bit Rate Throttling in IIS 7.0, you must install IIS Media Services 2.0. For information about how to install IIS Media Services 2.0, see Bit Rate Throttling Readme. For information about how to configure Bit Rate Throttling, see Bit Rate Throttling Configuration Walkthrough.

Maximum upload file size

This section describes the upload file size limitation, tells how to decide what the maximum upload file size limit should be, and how to configure it.

Maximum upload file size overview

The maximum upload file size is a setting that is used by the SharePoint Server 2013 web application that specifies the maximum size of a file that a user can upload to the server. When a new web application is created, SharePoint Server 2013 sets the default maximum upload size to 50 MB. If a user tries to upload a file larger than the specified maximum upload size, the upload will fail.

Decide maximum upload file size

Every user that uploads a file to a library uses a connection to the server and increases the amount of data in the database. This impacts the load, response time and data capacity for a server. Depending on your scenario, this can negatively impact your server performance if the server is not configured to handle larger volumes of files. To determine what the upload file size limit should be for your server, consider the number of users for your site, and the size of the files they will upload. For example, if your users will primarily be uploading video files that are 500 MB, the upload file size limit should be large enough to easily accommodate the largest files users will upload. When planning to adjust the upload file size limit, keep in mind that this will also directly impact capacity planning for your server environment. For more information about planning for storage of large media files, see Plan digital asset libraries in SharePoint Server 2013. For more information about capacity planning, see Capacity management and sizing for SharePoint Server 2013.

Configure the maximum upload file size

To configure the upload file size in SharePoint Server 2013, a farm administrator must change the Maximum Upload Size value on the Web Application General Settings page in Central Administration.

Note:

If you increase the default maximum upload size for a web application, and you also plan to use content deployment to move content from site collections within that web application to another farm or site collection, you must also increase the default maximum upload size on the destination server, or the content deployment job will fail.

See also

Cache settings operations in SharePoint Server 2013
Monitor cache performance in SharePoint 2013


Case Study: Mavention and web content management in SharePoint Server 2013

Published: November 9, 2012

Summary: Learn how Mavention used new SharePoint Server 2013 web content management features when they built their new website.

Applies to: SharePoint Server 2013

This case study provides an overview of new SharePoint Server 2013 web content management features, and also how Mavention used these features when they upgraded their website from SharePoint Server 2010 to SharePoint Server 2013.

To view a Microsoft Word version of this case study, see Case Study: Mavention and Web Content Management in SharePoint 2013.

In this article:

  • About Mavention

  • Why Mavention migrated to SharePoint Server 2013

  • Overview of new SharePoint Server 2013 web content management (WCM) features

  • Planning phase

  • Site architecture

  • Farm architecture

  • About Mavention's authoring experience

  • How Mavention uses the new SharePoint Server 2013 WCM features

About Mavention

Mavention is a Dutch system integrator that specializes in developing websites, portals and intranets using the Microsoft SharePoint platform. The SharePoint solutions that Mavention delivers provide their clients with the ability to deliver high quality information at a lower operating cost.

For more information about Mavention, see http://www.mavention.com.

Why Mavention migrated to SharePoint Server 2013

Since January 2011, Mavention had been using SharePoint Server 2010 for their website. This website had the following drawbacks for Mavention:

  • It did not contain any user-specific behavior, such as the way to display different content to different target groups.

  • It was very difficult for users to read the content and browse the pages of their site via a mobile device.

  • It was available only in Dutch.

Mavention's decision to migrate to SharePoint Server 2013 was influenced by the following factors. They wanted to do the following:

  • Improve the communication with their different target groups.

  • Offer content customized for each target group.

  • Increase the time visitors spent on their site (decrease the bounce rate) by offering recommendations to other content that visitors might be interested in.

  • Have an English version of their website up and running.

  • Optimize their website for mobile devices.

  • Improve their website's SEO features.

  • Minimize the time they spent on content management tasks.

Overview of new SharePoint Server 2013 web content management (WCM) features

When migrating from SharePoint Server 2010 to SharePoint Server 2013, Mavention implemented the following new WCM features:

  • Cross-site publishing and catalogs

  • Category pages and catalog item pages

  • Managed navigation and tagging term sets

  • Content Search Web Part

  • Variations and translations

  • Image renditions

  • Device channels

  • Analytics processing and recommendations

  • User segmentation

  • Query rules

  • Continuous crawls

  • SEO capabilities

  • Search REST API

To read a general overview of these new SharePoint features, see the following table. To read about how Mavention implemented these new features, see How Mavention uses the new SharePoint Server 2013 WCM features later in this article.

Cross-site publishing and catalogs

Cross-site publishing is a publishing feature that enables you to reuse content across site collections. A catalog is a SharePoint library or list that has been shared as a catalog. You can use one or more site collections to author catalog content, and one or more site collections to display catalog content, and control how the catalog content should be displayed.

For more information, see Overview of cross-site publishing in SharePoint Server 2013.

Category pages and catalog item pages

Category pages and catalog item pages are page layouts that enable you to consistently show dynamically created catalog content across a site. These pages are often used in combination with managed navigation and Content Search Web Parts.

For more information, see Plan category pages and catalog item pages.

Managed navigation and tagging term sets

Managed navigation enables you to use term sets to define and maintain the navigation of your site. When using cross-site publishing, it is highly important to tag your content with terms from a term set. By tagging terms in your content, it is not the physical location in the authoring site that defines the hierarchy of your content, but instead the actual terms that you have used to tag content.

Content Search Web Part

The Content Search Web Part (CSWP) displays content that has been crawled and added to the search index. To display content in a Content Search Web Part, you specify a query in the Web Part. When users browse to a page that contains a Content Search Web Part, the query is automatically issued, and query results are displayed in the Web Part.

For more information about this and other Search Web Parts, see Plan to add Search Web Parts to pages.

Variations and translations

The variations feature copies content from a source site to one or more target sites. When you use machine translation, the content that you copy from the source site can automatically be translated into the language of the target site. If you don't want to use machine translation, you can export translation packages in an .XLIFF format, translate the content, and import the translation package back intoSharePoint Server 2013.

Image renditions

Image renditions are very useful in mobile scenarios. Based on the device that is being used, you can display different sizes and versions of images. This feature enables you to have differently cropped versions of the same image without having to upload multiple images. This reduces the size of the file that is downloaded to the client, and improves the performance of your website.

For more information about image renditions, see Manage image renditions in SharePoint 2013.

Device channels

By using device channels, you can render a publishing site in multiple ways by using designs that are customized for different mobile devices. You can map your content to device channels in a publishing site, and then map it again to different master pages, page layouts, and style sheets, based on the device channel that you are using.

For more information about device channels, see Plan device channels in SharePoint Server 2013

Analytics processing and recommendations

Analytics processing is a feature that automatically tracks how users interact with a page, such as page or document views. This information is used to generate recommendations. Recommendations can be used to guide users to content that may be relevant for them —for example, "Users who viewed this document also viewed these documents."

For more information, see Plan usage analytics, usage events and recommendations.

User segmentation

User segmentation enables you to present different content to different user groups. To use this feature, you have to specify criteria that define the different user groups, and have access to properties that contain these criteria.

Query rules

A query rule is a set of conditions that cause the query to be changed in a specific way. An easy way to understand a query rule is as follows: "if X happens, then do Y." Query rules are used to limit the type of content that appears in search results, and to influence the order in which search results should appear.

For more information, see Plan result sources and query rules.

Continuous crawls

Continuous crawls enable you to specify an automatic crawl of your content at a set interval. By using continuous crawls, your search results are kept fresh and up to date. As a result, a search administrator no longer has to monitor any content changes to the farm.

For more information, see Plan content sources and crawling.

SEO capabilities

Instead of having URLs that consist of strings that do not make any sense to users, you can now create meaningful, user-friendly URLs. For example, http://www.contoso.com/Computers/model101 is much easier to read and to understand than http://www.contoso.com/Pages/Computers.aspx#/ID=453&Source=http%3A%2F1010101.

To create meaningful URLs, you can use managed navigation with category pages and catalog item pages, and build your URLs from the terms that you specify in the term set.

Search REST API

The search REST API is a service that you can use to add search functionality to your website or to your mobile devices. This service uses a technology that supports REST web requests.

Planning phase

When Mavention started to plan for their new website, they did the following:

  • Defined who their website should target.

  • Focused on what to improve on their current website.

  • Identified how to resolve the problems they had faced in the past.

Define user groups

Mavention defined two user groups that their website should target: customers and potential employees. Mavention then defined the characteristics of each group, which would allow them to use new user segmentation capabilities to provide dynamically created content for each target group.

Determine a publishing method

Statistics showed that 60% of Mavention's visitors were from outside the Netherlands. Therefore, they wanted to provide an English version of their website. The variations feature in SharePoint Server 2010 offered support for building multilingual sites. However, the content had to be tied to a top-level domain. The drawback of this was that search engines couldn't show the differences in local search ranking. To ease the effort of maintaining multilingual sites, Mavention decided to manage their content in a centralized content management environment.

The new cross-site publishing feature in SharePoint Server 2013 supports all of these-mentioned requirements, so Mavention chose this solution for their new website.

Determine the web design

Mavention had been witnessing a sharp increase in visitors accessing their pages via mobile devices. They wanted their new website to support as many devices as possible with as little effort as possible. As a result, they chose to use responsive web design, where an HTML template adjusts itself to the characteristics of a particular device. The benefit of using an HTML template for all devices is that this method reduces the maintenance of a website, and content is more efficiently indexed by public search engines.

Determine the look and feel

Mavention analyzed which browser their mobile visitors were using when visiting their site. Then they defined screen sizes and screen resolutions to implement for their web pages. The user interface of Mavention's website was created by a design agency. Based on this design, Mavention started to build static HTML pages to see how the user interface blocks would scale with various screen resolutions.

Site architecture

The following figure shows Mavention's final site architecture:

Mavention's final SharePoint 2013 site architecture

Link to larger image

Authoring site

The authoring site collection is located on the left side of the diagram. The authoring site collection uses variations, and it is where Mavention creates and manages all of their content. Content is translated from Dutch in to English in the authoring site collection. The authoring site collection is not publicly available.

Publishing site

The publishing site collections are located on the right side of the diagram. The publishing site collection is where Mavention publishes content. The publishing site collections are publicly available.

Language versions
Each language has its own top-level site collection, so variations are not used on the publishing side. Mavention uses a top-level site collection for each language so that the sites are hosted on the top-level domain of the respective country/region code. This enables search engines to show differences in local search ranking.

Storing assets
Although Mavention's content is translated from Dutch into English, both the Dutch and the English sites reference the same source images. To avoid duplicating their assets, Mavention stored them in a separate site collection.

Given the fact that assets cannot be stored in the search index, and to avoid enabling anonymous access to the authoring part of their site, Mavention decided to store their assets on the publishing part of their site. By doing this, they secured the authoring part of their site, which in turn increased the overall security level of their site.

Farm architecture

The following figure shows Mavention's farm architecture.

Mavention's SharePoint 2013 farm architecture

Link to larger image

About servers

Mavention uses web servers, application servers, and database servers. The following table explains the roles of the servers and the hardware configuration that Mavention uses.

Server | Server role | Hardware CPU | Hardware RAM
Web servers that have two Hyper-V instances | Handles all incoming search requests. Hosts the Managed Metadata Service, the query processing components and the index components. | 4 cores | 8 GB
Application server that has one Hyper-V instance | Hosts the crawl component, the search administration component, the analytics processing component, and the content processing component. | 4 cores | 12 GB
Database server with two Hyper-V instances | Hosts all SharePoint databases. This includes the search databases. | 4 cores | 8 GB

Scaling out the search topology

Mavention's current farm architecture is within the limits for handling how much content that has to be indexed, and for maintaining a low query response time for all incoming query requests. Should Mavention experience a large increase in visitors that would increase the number of page views and queries per second, they could easily handle this by scaling out the search topology of their farm. To scale out the search topology, Mavention would have to add to their farm architecture another virtual web server that has a web front-end, a query processing component and an index component.

About Mavention's authoring experience

Mavention does not have a department in charge of authoring and maintaining content for their website. Therefore, one of their goals was to make sure that people had an easy and intuitive authoring experience, even employees who aren't working with their system regularly.

The following figure shows how the Mavention authoring site collection was set up.

Mavention's SharePoint 2013 authoring site collection

Link to larger image

Use of a Pages library

Mavention wanted a rich authoring experience customized for creating articles. Therefore, they decided to use a Pages library for creating and storing their content. By authoring content in a Pages library, they could use the default Rich Text Editor. Another important reason for deciding to use a Pages library was that it could be extended to implement a preview mode.

Mavention uses a Pages library on their source site for Dutch content, and another Pages library on their target site for English content. Now that Mavention is using cross-site publishing, they will be able to add lots of new content to their Pages library in the future without disrupting the navigation structure of their website.

Create metadata

Since cross-site publishing relies on how content is tagged, the structure of the authoring site has no effect on how content is presented on the publishing site. On the authoring site, Mavention created custom site columns and content types at the site collection level so that they could be used on the source site and on the target site. Mavention also created a page layout for each custom content type. The catalog tagging term set was created and translated into English at the site collection level.

Generate a preview mode by using a device channel

By using cross-site publishing and separating the authoring environment from the publishing environment, you gain lots of flexibility for how content is displayed on the publishing site. However, when authors add content to the authoring site, they are unable to see what that content looks like to visitors who will view it from the publishing site. To bridge this gap, Mavention decided to use the new device channel feature that generates a preview mode.

About the device channel
In SharePoint Server 2010, Mavention had a separate authoring and publishing architecture. However they had to write custom code to implement different master pages. In SharePoint Server 2013, it is now possible to implement different master pages by default. The device channel feature is intended to optimize content for different mobile devices by mapping content to different master pages, page layouts, and style sheets. The device channel can also be used to render different previews of the same page. Mavention created a new device channel called "Publishing," to which they associated the master page used on the publishing site. In addition they used a Mobile panel so that only content that should be displayed on the publishing site is displayed in the preview mode.

Examples of a page in several modes

The following screen shots show several views of the same blog article, all of which were taken from the Mavention website.

The blog article on the authoring site displayed in edit mode.

Blog article on the authoring site in edit mode.

Link to larger image

The blog article on the authoring site displayed in preview mode. Note that the tiles do not have any content in them as they are only displayed to give the author a preview of how the page will look in combination with other page elements.

The same blog article on the authoring site in preview mode.

Link to larger image

The blog article displayed on the publishing site.

The same blog article on the publishing site.

Link to larger image

How Mavention uses the new SharePoint Server 2013 WCM features

Cross-site publishing and catalogs

Mavention has two catalogs: one Pages library for their Dutch content, and one Pages library for their English content.

Category pages and catalog item pages

Mavention created five category page layouts and three catalog item page layouts for their website. Based on these, they created 10 category pages and five catalog item pages. Mavention created many pages because they wanted to have a section where they could insert editorial content. Although most of the content displayed on these pages is created dynamically by using Content Search Web Parts, they still have the flexibility to insert additional static content.

Managed navigation and term sets

SharePoint Server 2013 has a new Managed Metadata functionality that enables you to share local term sets with other site collections.

Mavention created a single term set on their authoring site by using terms that describe the different types of information that they have on their site, such as news, products or blogs.

Mavention used the Managed Metadata functionality to share the term set that they created on their authoring site with their publishing site collections, www.mavention.nl and www.mavention.com.

All of the catalog items in the authoring site are tagged with a term from the term set. This term set was translated into English. Therefore, a single term set is used to tag all catalog content. The main navigation of Mavention's website corresponds to the different types of information that they have on their site. So they could integrate the tagging term set from the authoring site into the term set that drives the navigation on the publishing site.

Content Search Web Parts

The default rendering of the Content Search Web Part occurs on the client side. This helps reduce the load on the servers, and build more dynamic experiences. When building public-facing websites, it is important to control how your website's content is indexed, and also to make sure that your website is equipped with reading and navigation tools for visually impaired visitors. Mavention decided to use server-side rendering to take this into account. Server-side rendering enables Mavention to have full control of their rendered HTML, and control of how their content is rendered.

Variations and translation

Mavention uses translation packages to translate their website content. They export the content from their source site (nl-nl), and send this file to a translation agency. Once the translation agency has translated their content into English, Mavention imports the file back into SharePoint, and the contents are applied to their target site (en-us).

To to make sure that the content on their bilingual website is consistent, Mavention creates a translation package every time that they update or publish new content on the Dutch language version of their website.

Image renditions

Mavention created two image renditions for their website: "tile" and "screenshot." When you create an image rendition, a rendition ID is generated. When you insert an image and choose an image rendition, SharePoint Server 2013 automatically uses the rendition ID to refer to the correct image rendition. This works well in an environment where you have a single site collection for all content. However, because Mavention uses cross-site publishing, where the assets are located on a different site collection than the content, they couldn't use the rendition ID to refer to their images. An alternative way to refer to image renditions is to use the width or the height of images. This is what Mavention did for their website.

Device channels

Although the device channels feature is meant to be used for optimizing content for different mobile devices, it can also be used to generate different page previews. Mavention created a device channel on their authoring site, which they used to create a preview of how their content would look on the publishing site.

Analytics processing and recommendations

By using a Recommended Items Web Part, two recommended articles are shown below every article on the Mavention website. The article recommendations are calculated by the Analytics Processing Component, which analyzes the content and the way users have interacted with it. Both the Analytics Processing Component and the recommendations feature are available by default in SharePoint Server 2013.

The default Recommended Items Web Part is not mapped to a property in the Pages library. Accordingly, to display recommendations, Mavention had to do some search schema management. By mapping the crawled property that they use for their Catalog Item URL Field to the managed property UsageAnalyticsID, Mavention were able to add the Recommended Items Web Part to their page and retrieve recommendations without any additional configurations.

The following screen shot shows how two recommended articles are displayed below the mail article.

Two recommendations shown for an article.

Link to larger image

User segmentation and query rules

Visitors to www.mavention.nl or www.mavention.com are anonymous. To apply user segmentation functionality to their website, Mavention had to do the following:

  • Build controls that could generate user properties.

  • Define a term set that could be used as user property input.

  • Extend the Content Search Web Part to use user properties.

  • Define query rules to trigger the display of user-specific content.

Controls used to generate user properties
Mavention built the following controls that they used on their master page and page layouts to generate user properties about the profile of a visitor:

  • Counted User Property Set if a particular action has been executed a given number of times. For example, if a user reads three blog posts, this user property is set.

  • Matched User Property Set if a specific condition is matched. Mavention compares the input data retrieved from the UrlReferer (whole URL), the host name of the referring site and the UserAgent string to a regular expression, or to terms within the User Segment Terms (see Term set used for user property input, in the next section) term set.

  • Search Query User Property Set if a user has reached the website from a search results page, for example www.bing.com or www.google.com. In this is the case, Mavention retrieves the query entered by the user in the search engine (q query string parameter from the referrer URL), and try to match that query against terms (parent and all children). If there is a match, the matching term is added to the user properties.

The following figure shows how the MaventionUserProperties are passed on the extended Content Search Web Part (CSWP).

MaventionUserProperties are passed on to the customized CSWP.

Link to larger image

Term set for user property input
The website from where visitors come to either www.mavention.nl or www.mavention.com might give an indication of the user's profile. Mavention wanted to use this as input to their user property. So they created a term set to which they added a term for the two types of sites their visitors could come from: "Business" and "Technical." Mavention then added more terms that were composed of the addresses of relevant websites to each of these terms. For example, if a visitor comes to Mavention's website from www.pinpoint.microsoft.com, the GUID of the term "Business" is passed on as a Matched User Property and used as input to generate the MaventionUserProperties.

The following screen shot shows the term set Mavention used to define websites for the two site types.

Term set used by Mavention when implementing user segmentation

Link to larger image

Extended Content Search Web Part
Mavention extended the default Content Search Web Part by adding user segmentation functionality as follows:

  • In the User Tracking Mode section, Mavention configured the Web Part to track visitors by using Sessions.

  • In the User Properties Variable Name section, Mavention configured the Web Part with the name of the session variable that contains the user properties of the visitor. This variable is called MaventionUserProperties.

    Customized CSWP used by Mavention to implement user segmentation.

    Customized CWSP used to implement user segmentation

    Link to larger image

Query rules used to trigger the display of user-specific content
Mavention defined three query rules that are based on the three defined target groups. Depending on the target group in which the visitor is categorized, different content is displayed. The following screen shots show how content is displayed on the homepage depending on the target group.

Mavention home page as shown to default users.

Mavention's homepage as shown to default users

Link to larger image

Mavention home page as shown to users that belong to the customers target group.

Mavention homepage as shown to users in the customers target group.

Link to larger image

Mavention home page as shown to users that belong to the potential employees target group.

Mavention's homepage as shown to users in the potential employees target group.

Link to larger image

Continuous crawls

When you use cross-site publishing, your content is made available to publishing sites by the SharePoint search index. Whenever a new entry is made on the authoring site, it must be crawled and added to the search index for it to be displayed on the publishing site. To ensure the freshness of their content, Mavention decided to use a continuous crawl schedule. This crawl schedule automatically adds any new content that was created since the previous crawl to the search index. This means that a search administrator does not have to start a crawl manually. By default, a new continuous crawl starts every 15 minutes. Mavention implemented a one-minute interval between each continuous crawl for their website.

SEO capabilities

When Mavention was using SharePoint Server 2010 for their website, they had to build custom solutions for search engine optimization (SEO) capabilities such as XML Sitemap, robots.txt, meta description, and the displaying of separate titles in the browser title bar. All of these features are available by default in SharePoint Server 2013.

Along with page titles and headings, URLs are one of the most important factors that determine page ranking in search results. To fully optimize SEO for their website, Mavention translated the URLs on which the content is published. By using cross-site publishing, managed navigation, and translation packages, the translation part is covered by SharePoint Server 2013 default functionalities.

For Mavention, the challenge was how to provide visitors with the means of switching between Dutch or English content while remaining on the same page.

Mavention built an HTTP handler that executes a search query for catalog item pages, that looks up the right term in the managed navigation of the target site collection for category pages. By implementing this, the exact location of the target page can be found, and maximum flexibility for content management and SEO of the website is ensured.

Search REST API

Mavention used the search REST API to display additional information based on page properties. Because Mavention use server-side rendering for their Content Search Web Parts, page properties are known only after the page is rendered. By passing page properties on to an AJAX request to the Search REST API, Mavention can display additional information.

The following screen shot shows how the two latest blog posts for a Mavention employee are displayed at the bottom of the page. The blog posts are displayed by using the Search REST API.

Blog posts are displayed using the Search REST API.

Link to larger image


Case Study: United Airlines and SharePoint Server 2013

Published: August 20, 2013

Summary: Learn how United Airlines used new SharePoint Server 2013 web content management and search features.

Applies to:

This case study gives an overview of new SharePoint Server 2013 Web Content Management (WCM) and search features, and also how United Airlines used these features to improve their Service Catalog

To view a Microsoft Word version of this case study, see Case Study: United Airlines and SharePoint Server 2013.

In this article

  • About United Airlines

  • About the Service Catalog

  • Planning to improve the Service Catalog

  • Features in SharePoint Server 2013

  • How United Airlines uses SharePoint Server 2013 WCM features

  • How United Airlines uses SharePoint Server 2013 search features

  • How United Airlines has integrated the back end system

  • Productivity gains from the improved Service Catalog

About United Airlines

United Airlines is one of the world's leading airlines, with more than 85,000 employees, serving 385 airports across the globe. In 2012, United Airlines was the busiest airline on the planet, operating over two million flights, and carrying 140 million passengers. United Airlines has been using SharePoint since 2001 for both internal and external Enterprise Content Management solutions. For example, 20% of their customer-facing content on www.united.com comes from SharePoint.

About the Service Catalog

United Airlines uses an internal Service Catalog that contains all of the IT-related products and services that their employees need. Using the Service Catalog, employees can do just about anything from ordering printers, laptops, or software, to issuing service desk tickets. In short; if an employee needs an IT-related item, they order it via the Service Catalog.

The Service Catalog logs approximately 400 to 500 requests per month.

Planning to improve the Service Catalog

United Airlines was keen to improve the maintenance and daily operations of their Service Catalog. The complexity of the Service Catalog system meant that only employees with developer skills were able to publish catalog items. Then there was the amount of time that it took to add an item to the Service Catalog, which could take up to two months.

The first step in the Service Catalog improvement process was to outline the goals they had to achieve to move forward, and to define which features the Service Catalog should have.

Goals for an improved Service Catalog
With a new and improved Service Catalog, United Airlines set the following five goals:

  1. Reduce operations and maintenance costs of the Service Catalog.

  2. Simplify the tasks of keeping the Service Catalog updated.

  3. Utilize existing companywide resources by integrating the Service Catalog with existing back-end systems.

  4. Improve the visitor's experience of the Service Catalog.

  5. Reduce the delivery time of items ordered through the Service Catalog.

Defining features for an improved Service Catalog
After researching how people interact with online stores, United Airlines decided to use an online store as a model for their new Service Catalog. Some of the key behavior that they discovered about online shoppers was that:

  • 38% of visitors browse to see what the site has to offer.

  • 35% of visitors look for a particular type of product but not for a specific product.

  • 27% of visitors look for a specific product.

By combining their goals with the research they'd done, United Airlines decided to implement the following:

  • Display engaging content, such as popular items.

  • Display user-specific content, such as popular items based on a visitor's user group.

  • Implement a user-friendly search experience that will make items easy to find by:

    • Integrating an easy to find search box.

    • Returning only highly relevant search results.

    • Enabling users to easily narrow down their search results by using relevant refiners.

    • Displaying query terms that a visitor has already searched for in a list below the search box as the visitor types a query.

    • Displaying query spelling corrections, "Did you mean?" if a user mistypes a query.

  • Display user-friendly URLs.

Features in SharePoint Server 2013

Many of the features that United Airlines had outlined as part of their Service Catalog improvement goals, are available by default in SharePoint Server. The following section contains an overview of these features.

Web Content Management features

Catalogs | A SharePoint library or list that you enable as a catalog. Catalog content can be reused across other site collections. See also Overview of cross-site publishing in SharePoint Server 2013.
Tagging term sets | A term set that you use to categorize (tag) the items in your catalog. By using term sets, the hierarchy of the content that you want to display is no longer bound to the physical location of the content. Instead, the hierarchy is determined by the tagging term set. See also Plan term sets for tagging content on SharePoint authoring sites.
Managed navigation | A navigation method that supplements the existing SharePoint navigation that is based on site structure. Managed navigation enables you to use term sets to define and maintain the navigation of your site. See also Overview of managed metadata in SharePoint Server 2013.
Friendly URLs | By using managed navigation, the URL to a page is no longer defined by the physical location of the page. Instead, it is defined by terms in your managed navigation term set. For example, instead of having an undecipherable URL, such as http://www.contoso.com/Pages/Computers.aspx#/ID=453&Source=http%3A%2F1010101, you can create a user-friendly one, such as http://www.contoso.com/Computers/model101.
Category pages and catalog item pages | Page layouts that enable you to consistently show dynamically created catalog content across a site. These pages are assigned to terms in a term set, and are often used with managed navigation and Search Web Parts. See also Plan category pages and catalog item pages.
Refiners for faceted navigation | Used in scenarios where you have structured content, such as catalog content. Refiners help users browse to content more easily, by filtering on refiners that are tied to terms in a term set. By using faceted navigation, you can configure different refiners for different terms in a term set without having to create additional pages. See also Plan refiners and faceted navigation.
Content Search Web Part (CSWP) | Displays content that has been crawled and added to the search index. To display content in a CSWP, you specify a query in the Web Part. When users browse to a page that contains a CSWP, the query is automatically issued, and query results are displayed in the Web Part. See also Plan to add Search Web Parts to pages.
Analytics processing | Automatically tracks how visitors interact with a site. For example, it can track which pages or documents visitors have viewed, and count the number of times this has happened. This information is used to generate information that can be displayed in the Popular Items Web Part. See also Plan usage analytics, usage events and recommendations.
Popular Items Web Part | Shows the most popular items for a particular set of criteria. For example, it can show content such as "Most popular items in category". See also Plan to add Search Web Parts to pages.
Display templates | Used in Search Web Parts to specify how search results should be displayed. By editing a display template, you can customize how you want your search results to be displayed. See also SharePoint 2013 Design Manager display templates.
User segmentation | Enables you to present different content to different user groups. See also User segmentation in SharePoint 2013.

Search features

Ranking | There are several ranking models that are optimized for specific use cases, which provide an effective ranking of search results. In most cases, you probably won't have to customize any of the ranking models.
Refiners | Properties that enable users to quickly narrow search results, and browse to specific content. See also Plan refiners and faceted navigation.
Result types | Specifies one or more conditions that are compared against a search result. If the conditions are met, a specific display template will be used to display the search results. See also About configuring result types.
Query suggestions | Also referred to as search suggestions. They're suggested phrases that users have already searched for. They appear in a list below the Search Box as a user types a query. See also Manage query suggestions in SharePoint Server 2013.
Query spelling correction | Also known as "Did you mean?" For example, if someone enters a query containing the word "amphitheatre" the query spelling correction will suggest "amphitheater." See also Manage query spelling correction in SharePoint Server 2013.
Query rules | A set of conditions that cause the query to be changed in a specific way. An easy way to understand a query rule is as follows: "if X happens, then do Y." They're used to limit the type of content that appears in search results, and to influence the order in which you want search results to appear. See also Transforming queries with query rules.

How United Airlines uses SharePoint Server 2013 WCM features

Catalog

The existing Service Catalog contained approximately 600 items, and was available in Excel format. By using a standard list feature, United Airlines extracted information from Excel, and imported it into a single list in SharePoint Server 2013. This list was then enabled as a SharePoint catalog.

Tagging term sets

Based on the structure used in the existing Service Catalog, United Airlines created one tagging term set. They manually associated, or tagged, each item in their catalog with the correct term from the tagging term set.

The following screenshot shows the tagging term set United Airlines created.

Tagging term set that United Airlines created

Managed navigation

United Airlines uses the tagging term set to drive managed navigation on the Service Catalog.

The following screenshot shows the navigation in the Service Catalog after a user has clicked "Hardware." Notice that the subcategories "Accessories," "Desktops," "Laptops," etc., match the hierarchical structure defined in the tagging term set.

Managed navigation on the Service Catalog

Friendly URLs

When visitors are browsing the Service Catalog, category pages and catalog item pages are used to display content. The URL to the actual category page or catalog item detail page, for example, <site>/pages/Category-Product-Hierarchy.aspx, does not make much sense to visitors. However, because managed navigation is used to drive site navigation, visitors won't see this URL when they browse the Service Catalog. What they will see, is a friendly URL that's composed of terms from the tagging term set.

The following screenshot shows the URL when navigating to the "Laptops" page. Notice that the friendly URL, <site>/hardware/laptops, matches the terms and hierarchical structure of the tagging term set, which has been set to drive managed navigation.

Friendly URL for Laptops page

Category pages, catalog item pages and Web Parts

As explained above, the category pages and catalog item pages can be assigned to multiple terms within the managed navigation term set. You can configure Web Parts on these pages so that the content is displayed differently depending on where in the site navigation the visitor is browsing.

For the Service Catalog, United Airlines created a main category page layout, and a subcategory page layout. Based on these page layouts, they then created three category pages and one item category page:

  1. A category page for all main categories except "Data Services."

  2. A category page for the main category "Data Services."

  3. A category page for individual items in the subcategories.

  4. An item category page.

Category page 1 - Displays content for all main categories except "Data Services"
This category page displays content for all top-level categories, for example "Employee Services," "Hardware," or "Knowledge Management."

This category page contains only one Web Part; a custom Web Part developed by United Airlines. The Web Part is used to show all subcategories below a top-level category. For example, when visitors click the main category, "Hardware," all subcategories such as "Accessories," "Desktops," "Laptops," etc., display. When visitors click the top-level category, "Employee Services," all subcategories such as "Employee-Account-Services" and "Facilities" display.

The following screenshot shows how this category page is used to display all subcategories below the top-level category, "Employee Services."

Category page 1 for Service Catalog

Category page 2 - Displays content for the main category "Data Services"
This category page displays content for the top-level category, "Data Services." It has three Web Parts:

  • Search Box Web Part: a default Web Part that displays query suggestions as the user is typing a query.

  • Content Editor Web Part: a default Web Part with hyperlinks to different services.

  • Popular Items Web Part: a default Web Part that displays popular items, such as popular laptops.

The following screenshot shows how this category page is used to display content for the top-level category, "Data Services."

Category page 2 for service catalog

Category page 3 - Displays individual items in the subcategories
This category page displays the individual items within a subcategory; for example, all items within the "Laptops" subcategory. This category page contains only one Content Search Web Part (CSWP).

The CSWP contains a query that is automatically issued when visitors browse to a page containing a CSWP. By using a value from the URL as a query variable, the query issued by the CSWP changes depending on where in the navigation hierarchy the visitor is browsing. For example, when a visitor clicks the category "Laptops," the CSWP queries for all items tagged with the term "Laptops." When a visitor clicks the category "Printers," the CSWP issues a query for all items tagged with the term "Printers."

The following screenshot shows how the category page is used to display individual items within the "Laptops" subcategory.

Category page 3 for service catalog

Item category page
This page is used to display the individual items in the Service Catalog. It has three Web Parts:

  • Content Search Web Part: a default Web Part that displays individual catalog items.

  • Shopping Cart Web Part: a custom Web Part that facilitates the ordering of individual catalog items.

  • Questioner Form Web Part: a custom Web Part where users can fill in additional information when ordering certain items.

The following screenshot shows how the catalog item detail page is used to display content for the category item "Elitebook 2560p."

Item category page for service catalog

All of the Web Parts on this page use search technology to display content.

Display templates

United Airlines created 5 display templates for the Service Catalog:

  • One for the custom Web Part on Category page 1.

  • One for the Search Box Web Part on Category page 2.

  • One for the Popular Items Web Part on Category page 3.

  • One for the Content Search Web Part on the Item category page.

  • One for the Search Results Web Part used on the search results page.

How United Airlines uses SharePoint Server 2013 search features

Refiners

United Airlines implemented 10 refiners. The following screenshot shows how the refiners are displayed on the "Monitors" page.

Refiners used on the Service Catalog

Query suggestions

The query suggestions are turned on by default in the Search Box Web Part, so United Airlines didn't have to do any additional configuration to implement this.

The following screenshot shows how two query suggestions are displayed as a visitor is typing a query.

Query suggestions are displayed as a visitor is typing a query

Query spelling correction

The query spelling correction is turned on by default in the Search Results Web Part, so United Airlines didn't have to do any additional configuration to implement this.

The following screenshot shows how a query spelling correction is displayed when a visitor has mistyped a query.

Query spelling correction is displayed when a visitor has mistyped a question

How United Airlines has integrated the back end system

Once visitors have found what they're looking for in the Service Catalog, they can begin the ordering process by going to the checkout page.

The following screenshot shows the checkout page.

The checkout page in the Service Catalog

The shopping cart is a SharePoint list, which is based on the context of the visitor. If a visitor logs out before completing the checkout, the items are stored in the visitor's shopping cart. United Airlines has implemented a system that empties the visitor's shopping cart, if they haven't checked out the items within 30 days.

The Service Catalog is also integrated with Active Directory. From Active Directory, information about the visitor, for example: "Approving manager," "Cost center," "Division Controller," and "office location" are prefilled and always up to date.

Productivity gains from the improved Service Catalog

United Airlines has experienced vast productivity gains since improving the Service Catalog; the most significant of all being the time it takes to add a new item to the catalog. This has gone down from several months to a few days, or in certain cases, to a couple of hours.

Maintenance time has also significantly dropped now that the system has been transformed into a standard SharePoint site.

Ordering an item from the Service Catalog is now a familiar experience that resembles any other online shopping experience for employees. The intuitive navigation makes browsing for items easy, as do the search features, when searching for a specific item of interest. The integration of Active Directory and the ERP system has also cut down on the approval and delivery time of the ordered item.

As employees increasingly start to use the improved Service Catalog, United Airlines will gather user data, and will continuously improve their visitors' experience.


Plan search in SharePoint Server 2013

Summary: Create a well-designed plan to install and configure search in SharePoint 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet provide information about the planning you need to do to deploy search in SharePoint 2013.

TechNet articles about planning search

The following articles about planning search in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of search in SharePoint Server 2013 | Learn about the different search components and databases and their role within the search topology.
Building blocks | Plan enterprise search architecture in SharePoint Server 2013 | Learn how to plan a small, medium or large enterprise search architecture.
Checklist icon (not checked) | Scale search for performance and availability in SharePoint Server 2013 | Determine hardware requirements and review considerations to scale out search topologies for performance and availability.
Checklist icon (not checked) | Best practices for organizing content for search in SharePoint Server 2013 | Learn how to organize SharePoint content and metadata to make the content easier to find.
Building blocks | Understanding result sources for search in SharePoint Server 2013 | Use a result source in SharePoint Server 2013 to specify a provider to get search results from, and optionally to narrow a search to a subset of those results.
Building blocks | Plan crawling and federation in SharePoint 2013 | Plan to crawl or federate results from different kinds of content and plan to apply the appropriate settings.
Building blocks | Overview of the search schema in SharePoint Server 2013 | Learn how the search schema is used to build up the search index. The search schema contains the mapping from crawled properties to managed properties and the settings on the managed properties.
Building blocks | Plan to transform queries and order results in SharePoint 2013 | Learn how to transform user queries to provide more relevant SharePoint search results and to improve the way search results are displayed.
Building blocks | Overview of search result ranking in SharePoint Server 2013 | Learn how SharePoint uses ranking models to calculate the relevance rank of search results and how you can influence the order of search results by using query rules, the search schema and ranking models.
Building blocks | Overview of analytics processing in SharePoint Server 2013 | Learn how the Analytics Processing Component analyzes content and user actions to improve search relevance.


Overview of search in SharePoint Server 2013
See also

Summary: Learn about SharePoint search architecture, SharePoint search components, SharePoint search databases, and the SharePoint search topology.

Applies to: SharePoint Server 2013

The search architecture contains search components and databases. How you structure the search architecture depends on where you intend to use search: for the enterprise or for Internet sites. When building the search architecture, you should take into account considerations such as high availability and fault tolerance, the volume of your content and the estimated amount of page views and queries per second.

For more information about search hardware requirements and scaling considerations: see Scale search for performance and availability in SharePoint Server 2013.

For more information about search topologies for different use cases: see the technical diagrams Enterprise search architectures for SharePoint Server 2013 and Internet sites search architectures for SharePoint Server 2013.

In this article:

  • Overview of search components and search databases

  • About the crawl component

  • About the content processing component

  • About the analytics processing component

  • About the index component

  • About the query processing component

  • About the search administration component

  • About the crawl database

  • About the link database

  • About the analytics reporting database

  • About the search administration database

Overview of search components and search databases

The following tables show an overview of all the available search components and search databases. For more information about how search components and databases interact, see the Search architectures for SharePoint Server 2013 technical diagram.

Search components

Search component name | Description
Crawl component | Crawls content sources to collect crawled properties and metadata from crawled items and sends this information to the content processing component.
Content processing component | Transforms the crawled items and sends them to the index component. This component also maps crawled properties to managed properties.
Analytics processing component | Carries out search analytics and usage analytics.
Index component | Receives the processed items from the content processing component and writes them to the search index. This component also handles incoming queries, retrieves information from the search index and sends back the result set to the query processing component.
Query processing component | Analyzes incoming queries. This helps optimize precision, recall and relevance. The queries are sent to the index component, which returns a set of search results for the query.
Search administration component | Runs the system processes for search, and adds and initializes new instances of search components.

Search databases

Search database name | Description
Crawl database | Stores tracking information and historical information about crawled items such as documents and URLs. It also stores information such as the last crawl time, the last crawl ID and the type of update (add, update, delete) during the last crawl.
Link database | Stores unprocessed information that is extracted by the content processing component and information about search clicks. The analytics processing component analyzes this information.
Analytics reporting database | Stores the results of usage analysis.
Search administration database | Stores search configuration data.

About the crawl component

The crawl component crawls the content sources. You can crawl lots of content sources, for example file shares, SharePoint content, line of business applications and many more. To retrieve information, the crawl component connects to the content sources by invoking the appropriate indexing connector or protocol handler. After retrieving the content, the crawl component passes crawled items to the content processing component.

For more information about crawling content sources, see Plan crawling and federation in SharePoint 2013.

About the content processing component

The content processing component processes crawled items and sends these items to the index component. The content processing component performs operations such as document parsing and property mapping. It also performs linguistics processing such as language detection and entity extraction. The component transforms crawled items into artifacts that are included in the search index. The content processing component also writes information about links and URLs to the link database.

For more information about content processing, see Plan crawling and federation in SharePoint 2013.

About the analytics processing component

The analytics processing component performs two types of analyses: search analytics and usage analytics. This component uses information from these analyses to improve search relevance, create search reports, and generate recommendations and deep links.

  • Search analytics is about extracting information, such as links, the number of times an item is clicked, anchor text, data related to people, and metadata, from the link database. This information is important to relevance.

  • Usage analytics is about analyzing usage log information received from the front-end via the event store. Usage analytics generates usage and statistics reports.

The results from the analyses are added to the items in the search index. In addition, results from usage analytics are stored in the analytics reporting database.

For more information, see Overview of analytics processing in SharePoint Server 2013.

About the index component

You can divide the search index into discrete portions, called index partitions. The search index is the aggregation of all index partitions. Each index partition holds one or more index replicas that contain the same information. To achieve fault tolerance and redundancy, create additional index replicas for each index partition and distribute the index replicas over multiple servers.

The index component is the logical representation of an index replica. In the search topology, you have to provision one index component for each index replica.

The index component:

  • Receives processed items from the content processing component and writes those items to an index file. Index files are stored on a disk in the server that hosts the index component.

  • Receives queries from the query processing component and returns result sets.

For more information about the search schema and the search index, see Overview of the search schema in SharePoint Server 2013.

About the query processing component

The query component analyzes and processes queries and results. It performs linguistics processing such as word breaking and stemming. When the query processing component receives a query from the search front-end, it analyzes and processes the query to optimize precision, recall and relevance. The processed query is submitted to the index component. The index component returns a result set based on the processed query to the query processing component, which in turn processes that result set, before returning it to the search front-end.

For more information, see Plan to transform queries and order results in SharePoint 2013.

About the search administration component

The search administration component runs the system processes for search. This component performs provisioning, which is to add and initialize instances of the other search components.

About the crawl database

The crawl database stores tracking information and historical information about crawled items. For example, it stores information about the last crawl time, the last crawl ID and the type of update during the last crawl.

About the link database

The link database stores information extracted by the content processing component. In addition, it stores information about search clicks; the number of times people click on a search result from the search result page. This information is stored unprocessed, to be analyzed by the analytics processing component.

About the analytics reporting database

The analytics reporting database stores the results of usage analytics. In addition, it stores statistics information from the analyses. SharePoint uses this information to create Excel reports that show different statistics.

About the search administration database

The search administration database stores search configuration data, such as the topology, crawl rules, query rules, and the mappings between crawled and managed properties. It also stores the access control list (ACL) for the crawl component. There can be only one search administration database per search service application.

See also

Manage the search topology in SharePoint Server 2013


Plan enterprise search architecture in SharePoint Server 2013

Updated: August 27, 2013

Summary: Learn how to plan a small, medium or large enterprise search architecture.

Applies to: SharePoint Server 2013

Before you set up your enterprise search architecture, there are quite a few things that require careful planning. Step by step, we'll help you to plan a small, a medium, or a large-size enterprise search architecture.

Are you familiar with the components of the search system in SharePoint 2013, and how they interact? By reading Overview of search in SharePoint Server 2013 and Search architectures for SharePoint Server 2013 before you get going, you'll become familiar with search architecture, search components, search databases, and the search topology. When planning a search architecture, here are some suggestions about what to consider:

  • Step 1: How much content do I have?

  • Step 2: How much content for what size search architecture?

  • Step 3: Which hardware requirements should I be aware of?

    • Choose to run the servers physically or virtually

    • Choose hardware resources for the host servers

    • Plan storage performance

    • Choose how your search architecture supports high availability

  • Step 4: How to check that my search architecture performs well?

    • Test the storage I/O subsystem

    • Test the search performance

Step 1: How much content do I have?

The volume of content that you have in your search index affects what resources you need to host the farm. Work out approximately the number of items that you plan on making searchable. Here are some examples of items: documents, web pages, SharePoint list entries, and images. Remember that each entry in a SharePoint list counts as one item.

When you have established a figure, multiply it by what you think the expected growth of that content will be over the next 12 months.

For example, if you're starting out with 12,000 indexed items, and you expect the volume of that content to triple over the next 12 months. You should plan for 36,000 searchable items.

Step 2: How much content for what size search architecture?

It's not always easy to assess how big or small to make your search architecture. The size of your search architecture depends on the volume of your content, the crawl rate, the query throughput, and the level of high availability that you require. There are sample search architectures that were tested by Microsoft, that we advise using as a basis to plan your own farm. The sample search architecture that you choose depends on how much content has to be searchable:

Volume of content | Sample search architecture
0-10 million items | Small search farm
10-40 million items | Medium search farm
40-100 million items | Large search farm

Although these sample search architectures use virtual machines, you can use both physical servers and virtual machines according to the strategy of the overall SharePoint 2013 solution of your search architecture.

Small search farm

If you have up to 10 million items, the small search farm will probably be the most suitable farm for you. Microsoft tested this search architecture, and measured that it can crawl 50 documents per second, and serve 10 queries per second. With a crawl rate of 50 documents per second, it takes search 55 hours to crawl 10 million items in the first full crawl.

Diagram of the servers and search components in the small enterprise search architecture sample

Medium search farm

If you have between 10 and 40 million items, the medium search farm will probably be the most suitable farm for you. Microsoft tested this search architecture, and measured that it can crawl 100 documents per second, and serve 10 queries per second. With a crawl rate of 100 documents per second, it takes search 110 hours to crawl 40 million items in the first full crawl.

Diagram of the servers and search components in the medium enterprise search architecture sample

Large search farm

If you have between 40 and 100 million items, the large search farm will probably be the most suitable farm for you. Microsoft tested this search architecture, and measured that it can crawl 200 documents per second, and serve 10 queries per second. With a crawl rate of 200 documents per second, it takes search 140 hours to crawl 100 million items in the first full crawl.

Diagram of the servers and search components in the large enterprise search architecture sample

Step 3: Which hardware requirements should I be aware of?

Now that you've determined the volume of your content and chosen a sample search architecture, the next step is to plan the hardware you'll need, as described in this section:

  • Choose to run the servers physically or virtually

  • Choose hardware resources for the host servers

    • General storage

    • Minimum hardware resources for the small search farm

    • Minimum hardware resources for the medium search farm

    • Minimum hardware resources for the large search farm

  • Plan storage performance

    • Choose storage

      • Search component IOPS requirements

      • Search database IOPS requirements

  • Choose how your search architecture supports high availability

Choose to run the servers physically or virtually

If you're using one of the small, medium or large-size architectures that we've tested for you, then you'll be running your search architecture on virtual machines. It's also possible to run your search architecture on physical servers. In the sample farm architectures, just move the search components from the virtual machines to the host and take away the virtual machines. Note also that although a virtual environment is easier to manage, its performance level can sometimes be slightly lower than that of a physical environment. A physical server can host more search components on the same server than a virtual server.

Choose hardware resources for the host servers

Each search component and search database requires a minimum amount of hardware resources from the host server to perform well. The more hardware resources you have, the better the performance of your search architecture will be.

For example, when hosting virtual machines on Windows Server 2008 R2 Service Pack 1 (SP1), you can't use more than four CPU cores per virtual machine. With Windows Server 2012, it's a good idea to use eight CPU cores.

The following tables show the minimum amount of storage, memory, and processor capacity that the search components and databases in the small, medium, and large-size search farms require.

General storage

Make sure that each host server has enough disk space for the base installation of the Windows Server operating system and for the SharePoint 2013 program files. The host server also needs free hard disk space for diagnostics such as logging, debugging, and creating memory dumps, for daily operations, and for the page file. Normally, 80 GB of disk space is enough for the Windows Server operating system and for the SharePoint 2013 program files.

Minimum hardware resources for the small search farm

The listed minimum storage that the analytics reporting database requires can vary. This is because the requested amount of storage depends on how the search environment uses analytics, and how often. It's a good idea to adjust the amount of storage for the analytics reporting database once you've deployed a pilot search architecture.

Also, determine how much storage the search databases require for SQL log space. If the database server doesn't back up the databases often, the SQL log space uses lots of storage. For more information about how to plan SQL databases, see Storage and SQL Server capacity planning and configuration (SharePoint Server 2013).

Host server | Application or database server | Storage | RAM | Processor1
A, B | Application server with query processing and index components. | 500 GB | 16 GB | 1.8 GHz 4x CPU cores
A, B | Application server with crawl, search administration, analytics and content processing components. | 200 GB | 8 GB | 1.8 GHz 4x CPU cores
C, D | Database server with all search databases. | 100 GB | 16 GB | 1.8 GHz 4x CPU cores

1The number of CPU cores is specified here, not the number of CPU threads.

Minimum hardware resources for the medium search farm

The listed minimum storage that the analytics reporting database requires can vary. This is because the requested amount of storage depends on how the search environment uses analytics, and how often. It's a good idea to adjust the amount of storage for the analytics reporting database once you've deployed a pilot search architecture.

Also, determine how much storage the search databases require for SQL log space. If the database server doesn't back up the databases often, the SQL log space uses lots of storage. For more information about how to plan SQL databases, see Storage and SQL Server capacity planning and configuration (SharePoint Server 2013).

Host server | Application or database server | Storage | RAM | Processor1
A, B, C, D | Application server with query processing and index components. | 500 GB | 16 GB | 1.8 GHz 4x CPU cores
E, F | Application server with analytics and content processing components. | 300 GB | 8 GB | 1.8 GHz 4x CPU cores
 | Application server with crawl, search administration, and content processing components. | 100 GB | 8 GB | 1.8 GHz 4x CPU cores
G, H | Database server with all search databases. | 400 GB | 16 GB | 1.8 GHz 4x CPU cores

1The number of CPU cores is specified here, not the number of CPU threads.

Minimum hardware resources for the large search farm

The listed minimum storage that the analytics reporting database requires can vary. This is because the requested amount of storage depends on how the search environment uses analytics, and how often. It's a good idea to adjust the amount of storage for the analytics reporting database once you've deployed a pilot search architecture.

Also, determine how much storage the search databases require for SQL log space. If the database server doesn't back up the databases often, the SQL log space uses lots of storage. For more information about how to plan SQL databases, see Storage and SQL Server capacity planning and configuration (SharePoint Server 2013).

Host server | Application or database server | Storage | RAM | Processor1
A, B, C, D, E, G, H | Application server with query processing and index components. | 500 GB | 16 GB | 1.8 GHz 4x CPU cores
K | Application servers with analytics and content processing components | 200 GB | 8 GB | 1.8 GHz 4x CPU cores
 | Application servers with crawl and search administration components | 100 GB | 8 GB | 1.8 GHz 4x CPU cores
M | Application servers with analytics and content processing components | 200 GB | 8 GB | 1.8 GHz 4x CPU cores
O | Database server with search admin, analytics, and crawl databases | 500 GB | 16 GB | 1.8 GHz 4x CPU cores
P | Database server with all redundant copies of Host O databases | 500 GB | 16 GB | 1.8 GHz 4x CPU cores
Q | Database server with link and crawl databases. | 500 GB | 16 GB | 1.8 GHz 4x CPU cores
R | Database server with all redundant copies of Host Q databases | 500 GB | 16 GB | 1.8 GHz 4x CPU cores

1The number of CPU cores is specified here, not the number of CPU threads.

Plan storage performance

The speed of the storage affects the search performance. Make sure that the storage you have is fast enough to handle the traffic from the search components and databases. Disk speed is measured in I/O operations per second (IOPS).

The way you decide to distribute data from the search components and from the operating system across your storage, has an impact on search performance. It's a good idea to:

  • Distribute the base installation of the Windows Server operating system, the SharePoint 2013 program files, and diagnostics across three separate storage volumes or partitions with normal performance.

  • Store the search component data on a separate storage volume or partition with high performance.

Choose storage

For an overview of storage architectures and disk types, see Storage and SQL Server capacity planning and configuration (SharePoint Server 2013). The servers that host the index, analytics processing, and the search administration components, or search databases, require storage that can maintain low latency, while providing sufficient I/O operations per second (IOPS). The following tables show how many IOPS each of these search components and databases require.

If you deploy shared storage like SAN/NAS, the peak disk load of one search component typically coincides with the peak disk load of another search component. To get the number of IOPS search requires from the shared storage, you need to add up the IOPS requirement of each of these components.

Search component IOPS requirements

Component name Component details IOPS requirements Use of separate storage volume/partition

Index component

Uses storage when merging the index and when handling and responding to queries.

  • 300 IOPS for 64 KB random reads.

  • 100 IOPS for 256 KB random writes.

  • 200 MB/s for sequential reads.

  • 200 MB/s for sequential writes.

Yes

Analytics component

Analyzes data locally, in bulk processing.

No

Yes

Crawl component

Stores downloaded content locally, before it sends it to a content processing component. Storage is limited by network bandwidth.

No

Yes

Search database IOPS requirements

Database name | IOPS requirements | Typical load on I/O subsystem.
Crawl database | Medium to high IOPS | 10 IOPS per 1 document per second (DPS) crawl rate.
Link database | Medium IOPS | 10 IOPS per 1 million items in the search index.
Search administration database | Low IOPS | Not applicable.
Analytics reporting database | Medium IOPS | Not applicable.

Choose how your search architecture supports high availability

If you aren't familiar with high availability strategies, here's an article that will get you started: Create a high availability architecture and strategy for SharePoint 2013. Your search architecture supports high availability when you host redundant search components and databases on separate fault domains. All of the sample search architectures host redundant search components on independent servers.

For each redundant host server in your search architecture, you should plan to install:

  1. Redundant networking

  2. Redundant power supplies with independent wiring or an uninterruptable power supply (UPS).

Step 4: How to check that my search architecture performs well?

Before you deploy your search architecture to a production environment, you'll need to check that it performs well. Here's a checklist of what to do:

  1. Test that the index components use a storage I/O subsystem that has enough IOPS. See Test the storage I/O subsystem.

  2. Deploy the search architecture to a pilot environment. Make sure that the pilot environment is representative of the production environment.

  3. Test the search performance of the pilot environment. See Test the search performance

For an overview of testing in general in SharePoint 2013, see Performance testing for SharePoint Server 2013.

Test the storage I/O subsystem

To test the storage I/O subsystem, run the most important disk operations and measure the IOPS. You can use the SQLIO tool to run these tests. See SQLIO Disk Subsystem Benchmark Tool.

Set up the test environment

You don't need to set up the whole search architecture, or install SharePoint 2013. It's enough to set up a test environment that produces a realistic workload for the storage I/O subsystem.

Let's consider the case for local storage. For example, if host A in the medium search farm uses a local disk, you need to install the two virtual machines and run the disk operation tests on both virtual machines at the same time.

You need a different set-up for shared storage. If for example the workload from all the index components in the medium search farm plus other unrelated workloads share the same storage, you need to:

  1. Install the eight virtual machines in host A, B, C, and D, and set up the sources of the unrelated workloads.

  2. Make sure that the unrelated workload is applied to the shared storage at the same time as you run simultaneous disk operation tests on all the virtual machines in host A, B, D, and D.

Create a test file

  1. Create a 1 GB test file by using the command sqlio.exe -t32 -s1 -b256 1g. This command creates a file named "1g".

  2. Save the test file on the storage device that you want to test. For example: on the hard disk of Host A in the medium farm.

  3. Concatenate the test file to a sufficiently large test file. For example: 256 GB, with the command copy 1g+1g+1g+…+1g testfile.

  4. Restart the server. This will ensure that caching does not skew the test results.

Run tests

It's a good idea to measure:

  • The performance of medium sized random accesses (see test number one and two below).

  • Read and write throughput for large transfers (see test number three and four below).

The table below shows the SQLIO commands that you should use to run each test. All the commands assume that the "testfile" exists in the current directory. Each test runs for 300 seconds.

Test number | Scope | Command
1 | 64 KB read [IOPS] | sqlio.exe -kR -t4 -o25 -b64 -frandom -s300 testfile
2 | 256 KB write [IOPS] | sqlio.exe -kW -t4 -o25 -b256 -frandom -s300 testfile
3 | 100 MB read [MB/s] | sqlio.exe -kR -t1 -o1 -b100000 -frandom -s300 testfile
4 | 100 MB write [MB/s] | sqlio.exe -kW -t1 -o1 -b100000 -frandom -s300 testfile

Example results for local disk storage

The sample results in the table below show a deployment where at least 50 percent of the disk subsystem capacity was in use before adding the test file.

The disk controller and the spindles of the disk strongly influence these results.

If you test on empty disks, you'll get elevated results because the test file will be in the most optimal tracks across all spindles (short stroking). This can increase performance by up to two or three times. You'll get unrealistically high results if you test a hard disk that optimizes away accesses on uninitialized storage space, or storage containing all zeros, for example dynamic VHD/VHDX files. In this case, use a very large test file that contains real data, rather than generating a synthetic test file using SQLIO commands.

Disk layout | Test 1 | Test 2 | Test 3 | Test 4
Recommended minimum IOPS during ordinary operations | 300 | 100 | 200 | 200
4x 1 TB 7200 RPM NLSAS in RAID5 on Dell H710 RAID controller (64kB stripe size, 64kB block size) | 1181 | 206 | 284 | 296
8x 1TB 7200 RPM NLSAS in RAID5 on Dell H710 RAID controller (64kB stripe size, 64kB block size) | 2082 | 337 | 610 | 645
16x 1TB 7200 RPM NLSAS in RAID5 on Dell H710 RAID controller (64kB stripe size, 64kB block size) | 3763 | 595 | 1173 | 1181
16x 1TB 7200 RPM NLSAS in RAID50 (2x8) on Dell H710 RAID controller (64kB stripe size, 64kB block size) | 3613 | 545 | 1139 | 1164
16x 1TB 7200 RPM NLSAS in RAID10 on Dell H710 RAID controller (256kB stripe size, 64kB block size) | 4030 | 1146 | 970 | 775
4x SmartStorage Optimus 800GB SSDs in RAID5 on Dell H710 RAID controller (64kB stripe size, 64kB block size) | 32385 | 3781 | 1714 | 1319
4x SmartStorage Optimus 800GB SSDs in RAID0 on Dell H710 RAID controller (256kB stripe size, 64kB block size) | 31747 | 7149 | 1643 | 1798

Test the search performance

Here's a checklist of what to do to test your search architecture:

  1. Choose content to run tests on

  2. Choose terms and phrases to test query performance

  3. Measure search performance

Choose content to run tests on

Choose content that represents your production content well. If you choose content that's only there for test purposes, make sure you've got different types of items, not just one item that you've duplicated many times. The reason for this is that the query processor will spend time detecting duplicated items, which will affect search performance, and your results won't be representative of a production environment.

Set up one or more content sources to crawl the content. Verify that you have the required user account and network access.

Choose terms and phrases to test query performance

The number of results you get for a query is called the recall.

To test query performance, you'll first need to create a set of terms and phrases to use as queries. Make sure that the set contains terms and phrases that have low recall and high recall, and that the terms and phrases are relevant to your environment.

Examples

  • If you search for a product number in a product catalog, it's likely that there's only one number for one product. Therefore, you'll get your search results fast. This is low recall.

  • If you search for a common term like "presentation" on a company intranet, it's likely that you'll get many results, and it may take longer to get them. This is high recall.

  • If, for example, your content is related to human resources, use search terms that relate to this area.

Measure search performance

SharePoint 2013 collects search performance measurements in the Crawl Health Reports and Query Health Reports. You can find these reports in Central Administration, under Search Administration.

It's a good idea to measure search performance first with a synthetic load, and then with a small set of live users, and live content. When you use live users and live content, you can observe how the search architecture is performing. If your content increases faster than you intended, it might be worth considering using the next size search architecture. Or, if your users are using more analytics than anticipated, then we suggest that you increase the amount of storage space of the analytics database.

Change History

Date | Description
August 27, 2013 | Corrected the illustration of the medium search farm and adjusted guidance on using physical or virtual servers.
July 23, 2013 | Initial publication


Scale search for performance and availability in SharePoint Server 2013
See also

Summary: Determine hardware requirements and review considerations to scale out SharePoint search topologies for performance and availability.

Applies to: SharePoint Server 2013

This article lists the minimum hardware requirements for virtual machines and physical servers for search topologies for the enterprise and for Internet sites.

This article also provides basic guidance on the scaling of search topologies to improve performance and availability.

In this article:

  • Hardware requirements for search topologies for the enterprise

  • Hardware requirements for search topologies for Internet sites

  • Scaling and redundancy considerations for enterprise topologies

  • Performance considerations for a medium Internet sites topology

Introduction

This article lists the minimum requirements and gives guidance about how and when to scale out search topologies for the enterprise and for Internet sites.

For examples of topologies, see the technical diagrams Enterprise search architectures for SharePoint Server 2013 and Internet sites search architectures for SharePoint Server 2013.

For an overview and a description of search components and the overall search architecture, see Overview of search in SharePoint Server 2013 and the technical diagram Search architectures for SharePoint Server 2013.

Hardware requirements for search topologies for the enterprise

The following tables show the hardware requirements for servers that host enterprise search topologies. The hardware requirements apply to:

  • Application servers that contain search components.

  • Database servers that contain search databases.

The requirements apply to each of the servers in the small, medium and large enterprise search topology example.

You can deploy search topologies for the enterprise on physical hardware or on virtual machines.

Each server must have sufficient disk space for the base installation of the Windows Server operating system and sufficient disk space for diagnostics such as logging, debugging, creating memory dumps, and so on. For production use, the server also needs additional free disk space for day-to-day operations and for the page file. Follow the guidance on free disk space and page file size corresponding to your Windows Server installation.

Application servers hosting search components

Search component | Hard disk | RAM | Processor
Index component | 80 GB regardless of the number of search components hosted on the server. 500 GB additional disk space, preferably a separate disk volume/partition. | 16 GB if the server hosts only an index component. 16 GB if the server hosts an index component and a query processing component. | All components: 64-bit, 4 cores minimum, 8 cores recommended. When hosting virtual machines on Windows Server, maximum 4 cores are possible.
Analytics processing component | 80 GB regardless of the number of search components hosted on the server. 300 GB additional disk space, preferably a separate disk volume/partition. This disk space is necessary for local processing of analytics data before it is written to the analytics reporting database. | 8 GB if the server hosts only one of these search components. 16 GB if the server hosts two or more of these search components. This does not apply if the server hosts an index component.
Crawl component | 80 GB regardless of the number of search components hosted on the server.
Content processing component
Query processing component
Search administration component

Database servers hosting search databases

Component | Minimum requirements
Processor | 64-bit, 4 cores for small topologies. 64-bit, 8 cores for medium topologies.
RAM | 8 GB for small topologies. 16 GB for medium topologies.
Hard disk | 80 GB for system drive. Hard disk space depends on the amount of content.

Hardware requirements for search topologies for Internet sites

The following tables show the hardware requirements for servers that host a medium search topology for Internet sites. The hardware requirements apply to:

  • Application servers and Web servers that contain search components.

  • Database servers that contain search databases.

The minimum listed RAM requirements for a server that hosts a search component is the total required amount of RAM for that server. For example, if you are hosting a content processing component, a search administration component and a crawl component on one server, the total amount of minimum required RAM for that server is 24 GB.

Each server must have sufficient disk space for the base installation of the Windows Server operating system and sufficient disk space for diagnostics such as logging, debugging, creating memory dumps, and so on. For production use, the server also needs additional free disk space for day-to-day operations and for the page file. Follow the guidance on free disk space and page file size corresponding to your Windows Server installation.

Note:

The medium search topology example is optimized for physical hardware, but you can deploy it on virtual machines as well.

Application servers and Web servers hosting search components

Search component on the physical server | RAM | Hard disk | Processor
Index component | 48 GB for each server in the farm that hosts an index component, a query processing component and the Web front end. | 500 GB additional disk space, preferably a separate disk volume/partition. | All components: 64-bit, 4 cores minimum, 8 cores recommended.
Analytics processing component | 24 GB for each server in the farm that hosts an analytics processing component, a crawl component, a content processing component and/or a search administration component. | 300 GB additional disk space, preferably a separate disk volume/partition.
Crawl component Content processing component | See the requirements listed for the analytics processing component. | 80 GB for system drive.
Query processing component | See the requirements listed for the index component.
Search administration component | See the requirements listed for the analytics processing component.

Database servers hosting search databases

Component | Minimum requirements
Processor | 64-bit, 4 cores for small topologies. 64-bit, 8 cores for medium topologies.
RAM | 8 GB for small topologies. 16 GB for medium topologies.
Hard disk | 80 GB for system drive. Hard disk space depends on the amount of content.

Scaling and redundancy considerations for enterprise topologies

The volume of items in your corpus affects farm sizing and how you decide to scale out.

Volume of items

Number of items | Action
Any number | For redundancy and failover, you must provision two of each of the search components on different servers that are in different failure domains in your farm. Search database redundancy must be set up in the SQL Server configuration.
Up to 10 million items | All search roles can co-exist on one non-redundant server or on two servers.
From 40 million items and upward | Add one crawl database per 20 million items. Add one index partition per 10 million items. Add up to two query processing components.
From 80 million items and upward | Add one crawl database per 20 million items. Add one index partition per 10 million items. Add up to four query processing components. Add one link database per 60 million items. Add one analytics reporting database for each 500 thousand unique items viewed each day or every 10-20 million total items.

Performance considerations for a medium Internet sites topology

A medium Internet sites (FIS) topology is optimized for a corpus size of 3,400,000 items, processing approximately 100-200 documents per second, depending on language, and a usage pattern of 85 page views per second, which corresponds to 100 queries per second.

Performance considerations

What to consider | Why this is important
Cache | The query and its results are cached with Windows Server AppFabric, in key-value pairs: the query being the key and the results being the value. For each query, there is an approximate 50% cache ratio. This means that if you have a usage pattern of 200 queries per second, about 100 queries are sent to the search index and the other 100 queries are cached. The results from the cache have lower query latency than those that you retrieve from the search index. For example, results for front-page queries that are often run are likely to be cached.
Continuous crawl | We recommend that you enable continuous crawl with an interval of one minute, instead of the default interval of 15 minutes. You can only enable continuous crawl on SharePoint content sources.
Anonymous access | With anonymous access, users do not have to use credentials to log on to a SharePoint Internet site. Anonymous queries are cached, so they are cheaper because of lower query latency. You must enable anonymous access in two locations: on the web front-end and on the site.
Query latency | Query latency is influenced by caching, anonymous access and by other factors such as the number and complexity of query rules that are applied and triggered. Also, consider the disks on which the search index is stored; a disk that has multiple spindles can improve the access speed of the disk and reduce query latency.

See also

Manage the search topology in SharePoint Server 2013
Change the default search topology in SharePoint Server 2013
Manage search components in SharePoint Server 2013
Manage the index component in SharePoint Server 2013


Best practices for organizing content for search in SharePoint Server 2013

Published: October 16, 2012

Summary: Learn how to organize SharePoint content and metadata to make the content easier to find.

Applies to: SharePoint Server 2013

These best practices for organizing SharePoint content and applying useful metadata will help make sure that the right content is included in the search index and that the right content is returned in search results.

In this article:

  • Keep your most important content in SharePoint

  • Organize content in hierarchies and use natural language

  • Encourage users to enter rich and consistent metadata for their sites and content

  • Managing multilingual content

  • Specify authoritative pages

Keep your most important content in SharePoint

If possible, keep your most important content in SharePoint, and crawl and index as much premium content as possible. If you cannot crawl and index the content, consider federating results from other sources into your local search results.

Try to organize content with similar value and importance into nearby site structures. The search system will automatically infer the relative importance, but you can also influence the importance of sites directly by defining authoritative pages. For more information, see the section Specify authoritative pages.

It is important to know what content to crawl and include in the search index, but it is also important to know what content not to crawl. For example, you do not want to crawl and index backup file shares. You should also establish routines for archiving obsolete content, deleting low-quality content and encourage users to add expiration dates to announcements.

Organize content in hierarchies and use natural language

By organizing SharePoint content in natural hierarchies, you not only make it is easier for users to understand where they can find and file their content, but you also make it easier for the search system to rank the content and return search results that better match the user's intent.

Flat structure | Structure with hierarchy
http://Europe http://Asia | http://sales http://sales/Europe http://sales/Asia

URLs and other metadata of files, such as file names, are analyzed linguistically by the search system. If you use natural language for URLs and for metadata, the search system can more easily understand what information is in the site or file and give it an appropriate ranking in the results. It is much easier for the search system (and users) to understand a URL and file name like http://sales/Europe/presentations/phones.ppt than it is to make sense of http://slseur/p_phones.ppt.

Encourage users to enter rich and consistent metadata for their sites and content

Metadata is data that provides additional information about one or more aspects of sites and content, such as who created the content or site, when was it created, and what the purpose of the content or the site is. Consistent and rich metadata increases the quality of the content itself, and it also enables the search system to more easily discover relationships between content, and to provide more targeted and relevant search results.

These are some examples of important metadata that you should encourage users to provide:

  • Title of a document

  • Description of a site

  • The author(s) of a document

  • The date the content was created

For some document types, such as PowerPoint and Word, the search system extracts additional metadata such as headings and subheadings from inside the content, and uses this information to return the right search results and to provide rich document summaries and previews.

To provide the right search results for people, it is also important that My Sites and user profile data is entered so that this information can be used as metadata by the search system.

Managing multilingual content

The search system detects the language of most content automatically. These recommendations help prevent that the search system detects the wrong language:

  • If possible, keep content in different languages on different sites. If the search system cannot detect the language of a particular content item, it assumes that it is in the language of the site where it is stored.

  • Avoid mixing languages in content and that content's metadata. Use the same language in the metadata as the language that is used in the content itself.

  • Avoid mixing languages in a single piece of metadata. This is mostly applicable to URLs.

Specify authoritative pages

You can use the Authoritative Pages feature in the Search service application to specify SharePoint sites that contain the most relevant information. Search results from authoritative pages are ranked higher in the search results.

You can specify three degrees of authority, and you can also specify non-authoritative sites. When you identify a site as an authority, sites that are connected to the authoritative page via hyperlinks are also boosted in the results, based on their proximity to the authoritative page. A most-authoritative page contains or links to the most relevant information. URLs designated as non-authoritative are ranked lower than other sites.

We recommend that you only specify a small number (four-five) of authoritative pages. If you specify lots of authoritative pages, it is difficult to predict the effects on the ranking of search results.

For more information, see Configure authoritative pages in SharePoint 2013.


Understanding result sources for search in SharePoint Server 2013
See also

Published: March 12, 2013

Summary: Use a result source in SharePoint Server 2013 to specify a provider to get search results from, and optionally to narrow a search to a subset of those results.

Applies to: SharePoint Server 2013

This article provides a brief overview of result sources in SharePoint Server 2013. In this article:

  • What is a result source?

  • Available result sources

  • Result source protocols and URLs

  • Who can create result sources?

  • Specifying a result source to use for a query

  • Narrowing search results by using a query transform

What is a result source?

When a user issues a query, the search system associates the query with a result source to provide search results. The result source is a definition that specifies each of the following:

  • A search provider or source URL to get search results from — for example, the search index of the local SharePoint Search service

  • A protocol to use to get search results — for example, the OpenSearch protocol

  • A query transform, which can narrow results from the given search provider or URL to a specified subset — for example, a subset that has a particular content type

A result source can also specify other settings, such as an authentication method to use when requesting results from a provider.

An example of a pre-configured result source is "Local Video Results". This result source specifies the local SharePoint search index as the provider and "Local SharePoint" as the protocol, and it has a query transform that specifies that it will return only files that have file extensions that correspond to videos, such as MP4. The "Local Video Results" result source is used by the Videos search experience, or search vertical, on the default enterprise Search Center results page.

The following screen shot shows the four search experiences that are available on a default enterprise Search Center results page. The user can choose one of these search experiences before submitting a query from the search box.

enterprise Search Center default search experiences

The following table shows the result sources that are used by the four search experiences that are available on a default enterprise Search Center results page. Each search experience uses a different result source.

Search experiences and corresponding result sources

This search experience | Uses this preconfigured result source
Everything | Local SharePoint Results
People | Local People Results
Conversations | Conversations
Videos | Local Video Results

Available result sources

SharePoint Server 2013 provides 16 pre-configured result sources, which are available in all sites and site collections in web applications that consume a Search service application. The pre-configured result sources are shown in the following table. You can view details about result sources from the Manage Result Sources page.

Pre-configured result sources

This result source | Specifies these items in the local SharePoint index
Conversations | Discussions in microblogs, newsfeed posts, and community sites
Documents | Microsoft Office documents and PDF documents
Items matching a content type | Items that match a content type that the incoming query specifies
Items matching a tag | Documents or list items that match a managed metadata term that the incoming query specifies
Items related to current user | Documents or list items that are related to the user in a way that the query template specifies
Local People Results | People items from the profile database of the User Profile service application
Local Reports and Data Results | Excel, Office Data Connection (ODC), or Report Definition Language (RDL) items, or items in a report library
Local SharePoint Results | All items from the local SharePoint search index except People items
Local Video Results | Videos
Pages | SharePoint web pages
Pictures | Photos and images
Popular | Documents and list items sorted by view count
Recently changed items | Documents and list items sorted by Modified date
Recommendations | Documents and list items that you recommend for the incoming query
Wiki | SharePoint wiki pages

From the Manage Result Sources page, you can create other result sources in either of the following two ways:

  • You can click New Result Source. For more information, see Configure result sources for search in SharePoint Server 2013.

  • You can point to the arrow next to an existing result source, click Copy, and then modify the copy as necessary and save it with a new name.

Result source protocols and URLs

A result source specifies one of four protocols to use to get search results, as shown in the following table.

Result source protocols

A result source that specifies this protocol | Gets search results from this search provider
Local SharePoint | The search index of the local Search service
Remote SharePoint | The search index of a Search service hosted in another farm
OpenSearch 1.0/1.1 | An external search provider (such as a remote search engine or feed) that uses the OpenSearch protocol to provide search results
Exchange | Exchange Web Services

A result source that uses a protocol other than "Local SharePoint" must also specify a URL from which to get search results, as shown in the following table.

Result source URLs

A result source that uses this protocol | Must specify this URL
Remote SharePoint | The address of the root site collection of the remote SharePoint farm
OpenSearch 1.0/1.1 | The URL of the RSS feed of a search provider that uses the OpenSearch protocol
Exchange | An Exchange Web Services URL

Who can create result sources?

Result sources can be created at the Search service application level, site collection level, or site level. This enables Search service application administrators, site collection administrators, and site owners to create and use result sources to meet their specific requirements for providing search results to users. When you create a result source at the Search service application level, for example, the result source is available to any query rule that is created at the same level, and also to any query rule that is created for a site collection or site that is in a web application that consumes that Search service application. For information about levels and permissions for result sources, see Create a result source in Configure result sources for search in SharePoint Server 2013.

Specifying a result source to use for a query

A query is initially associated with a result source according to the search experience in which the user performs the query. For example, if a user clicks People below a search box (see the screen shot earlier in this article) to specify the People search experience, the query uses the "Local People Results" result source.

A Search Box Web Part is always associated with a particular Search Results Web Part. When a user types a query in a search box, the Search Box Web Part sends the query to the associated Search Results Web Part. That Search Results Web Part specifies the result source for the query; by default, this result source is "Local SharePoint Results". You can set a different result source as the default. You can also edit any Search Results Web Part to specify a different result source for it to use. For example, you might add a new search experience called "Reports", and create a search results page for displaying search results for that search experience. You could then edit the default Search Results Web Part that is on the new Reports results page to specify an appropriate result source for that search experience. An example of such a result source would be a SharePoint site that contains content types that correspond to reports. For more information, see the following resources:

  • Set a result source as default in Configure result sources for search in SharePoint Server 2013

  • Configure properties of the Search Results Web Part in SharePoint Server 2013

You can configure the search system so that a query becomes associated with an additional or a different result source under certain conditions. One way to do this is to create a query rule that displays search results from another result source if a query is more frequently performed in that result source than in the one that the user performed it on. For example, let's say that a user queries on "keynote speech" in the Conversations search experience but the query is more popular in the Videos search experience. In that case, you could configure an action that also displays results from the Videos result source in a separate result block. For more information, see the following resources:

  • Transforming queries with query rules in Plan to transform queries and order results in SharePoint 2013

  • Manage query rules in SharePoint Server 2013

When you create a query rule, on the Manage Query Rules page you specify a result source to which the rule will apply. Then on the Add/Edit Query Rule page, in the Context section, you can add or remove result sources to which the rule will apply. When a query is submitted to any result source other than those that you set as applicable, the rule cannot fire. For example, if you create a query rule that you want to fire only for people searches, you would specify "Local People Results" as the result source to which the rule applies.

Narrowing search results by using a query transform

You can configure the search system so that it interprets the intent of user queries and then modifies queries accordingly to provide more targeted search results. One way to do this is to use the Query Transform section that is part of the definition of each result source. For example, to provide a Videos search experience, in the result source you could configure a query transform to specify a SharePoint site from which to get search results for video queries.

You can also modify queries in the Web Part that issues a query, and in query rules. A user query is transformed first by any modifications that were configured in the Web Part, then by any query rules that fire, and finally by the query transform in the result source for the query. The query rules and result sources can take the modified query as input and modify the query again. However, the modifications made to a query by a result source cannot be modified further, because the query transform in a result source modifies the query last. For more information, see Plan to transform queries and order results in SharePoint 2013.

Each pre-configured result source uses a query transform and thus provides an example of how you can use a query transform to narrow search results. On the Manage Result Sources page, you can click each result source to see how it uses a query transform. For example, you can click the pre-configured "Local People Results" result source to see that it uses the following query transform to provide people-related results from the profile database:

{?{searchTerms} ContentClass=urn:content-class:SPSPeople}

For more information, see Building search queries in SharePoint 2013 (http://msdn.microsoft.com/library/jj163973.aspx).

See also

Transforming queries in result sources
About result sources and federated search

Query variables in SharePoint Server 2013
Default connectors in SharePoint Server 2013


Plan crawling and federation in SharePoint 2013
See also

Updated: August 6, 2013

Summary: Plan to crawl or federate results from different kinds of content and plan to apply the appropriate settings.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Before end-users can use search functionality in SharePoint 2013, you must crawl or federate the content that you want to make available for users to search. Effective search depends on well-planned content sources, connectors, file types, crawl rules, authentication, and federation.

In this article:

  • About crawling and content processing

  • Plan content sources

    • Plan to crawl different kinds of content

    • Crawl content on different schedules

    • Reasons to do a full crawl

    • Limit or increase the quantity of content that is crawled

    • Plan connectors

    • Plan crawl rules to optimize crawls

    • Plan crawler authentication

  • Plan content processing

    • Include or exclude file types

    • Plan to use (custom) entity extractors

  • About result sources and federated search

Introduction

You have the option to crawl content and build up a search index to run queries (search requests) against. You can also run queries against an external provider, such as Bing, which contains publicly available content on the Internet. You can display the search results from an external provider (for example Bing) alongside the results from the index that you've built up (for example of local intranet content). This process of getting search results from both a search index containing content that you have crawled and an external provider is called federation. Whether you choose to crawl or to federate, or both, depends on various factors.

About crawling and content processing

The SharePoint 2013 crawler can crawl various hosts and databases that contain content or data using different APIs such as web protocols. Content sources that you define in the Search service application tell the crawler which host should be crawled, how it should be crawled and when. The crawler connects the search system with the content repositories.

In the search architecture, the crawler (represented by the crawl component in the search topology) crawls specified content sources and then feeds the crawled items (their contents and also their metadata) to the content processing component. The content processing component then processes these crawled items (URLs, documents, etcetera) by reading, parsing and further processing the crawled properties within files or within the content itself. The content processing component reports the properties of the item (new crawled properties) to the Search Administration database.

You can map crawled properties to managed properties and configure property settings by editing the search schema. The content processing component reads this search schema and uses it to carry out the mapping. Only managed properties are included in the search index. Managed properties can be used to create refiners, for example. For more information, see Overview of the search schema in SharePoint Server 2013.

Plan content sources

A content source is a SharePoint search specific term that represents a group of crawl setting. When you set up a content source, you configure which hosts you want to crawl. You also indicate the type of content that will be crawled, for example HTTP, Lotus Notes or SharePoint content, and configure other crawl parameters such as the crawl schedule, how deep and when to crawl.

The default content source is Local SharePoint sites. You can use this content source to specify how to crawl all content in a web application that is associated with a particular Search service application.

If you have only one type of host (for example all content on the hosts is of the type SharePoint sites or file shares), you should consider defining only one content source. However, if you have multiple, different types of content or unique requirements per host, you should consider defining multiple content sources.

Plan additional content sources when you have to do the following:

  • Crawl different types of content — for example, SharePoint sites, file shares, and business data.

  • Crawl some content on different schedules than other content.

  • Limit or increase the quantity of content that is crawled.

  • Set different priorities for crawling different sites.

  • Keep some types of content fresher than others.

Although you can create an unlimited number of content sources in each Search service application, each content source can contain up to 100 start addresses. To keep administration as easy as possible, we recommend that you limit the number of content sources that you create.

Plan to crawl different kinds of content

You can only crawl one kind of content per content source. That is, you can create a content source that contains start addresses for SharePoint sites and another content source that contains start addresses for file shares. However, you cannot create a single content source that contains start addresses to both SharePoint sites and file shares, for example. The following table lists the kinds of content sources that you can configure.

Use this kind of content source For this content

SharePoint sites

SharePoint sites from the same farm or different SharePoint Server 2013 or SharePoint Foundation 2013 farms.

SharePoint sites from the same farm or different SharePoint Server 2010, SharePoint Foundation 2010, or Microsoft Search Server 2010 farms.

SharePoint sites from the same farm or different Office SharePoint Server 2007, Windows SharePoint Services 3.0, or Search Server 2008 farms.

Web sites

Other web content in your organization that is not located in SharePoint sites.

Content on web sites on the Internet.

File shares

Content on file shares in your organization.

Exchange public folders

Exchange 2007 and Exchange 2010 public folders.

Lotus Notes

E-mail messages stored in Lotus Notes databases.

Note:

Unlike all other kinds of content sources, the Lotus Notes content source option does not appear in the user interface until you have installed and configured the appropriate prerequisite software. For more information, see Configure and use the Lotus Notes connector for SharePoint Server 2013.

Documentum

Content from the EMC Documentum system.

Note:

You can't crawl EMC Documentum content before you have installed and configured the appropriate prerequisite software and the Microsoft SharePoint 2013 Indexing Connector for Documentum. For more information, see Configure and use the Documentum connector in SharePoint Server 2013.

Line of business data

Business data that is stored in line-of-business applications.

Custom repository

Content sources that can only be crawled after a custom connector is installed and registered.

Content sources for line of business data

Business data content sources require that the applications hosting the data are specified in an Application Model in a Business Data Connectivity service application. You can create one content source to crawl all applications that are registered in the Business Data Connectivity service, or you can create separate content sources to crawl individual applications. For more information, see Search connector framework in SharePoint 2013 (MSDN).

Often, the people who plan for integration of business data into site collections are not the same people involved in the overall content planning process. Therefore, include business application administrators in content planning teams so that they can advise you how to integrate the business application data into content and effectively present it in the site collections.

Crawl content on different schedules

Consider defining content sources with varying schedules based on the following factors:

  • To accommodate down times and periods of peak usage.

  • To more frequently crawl content that is more frequently updated.

  • To crawl content that is located on slower servers separately from content that is located on faster servers.

  • To continuously crawl a SharePoint content source because of high freshness demands.

Reasons to do a full crawl

Reasons for a Search service application administrator to do a full crawl for one or more content sources include the following:

  • A Search service application has just been created and the preconfigured content source Local SharePoint sites have not been crawled yet.

  • Some other content source is new and has not been crawled yet.

  • A software update or service pack was installed on servers in the farm. See the instructions for the software update or service pack for more information.

  • A Search service application administrator, site collection administrator or tenant administrator added a new managed property or changed an existing managed property. A full crawl is required for the new or changed managed property to take effect.

  • You want to detect security changes that were made to local groups on a file share after the last full crawl of the file share.

  • You want to resolve consecutive incremental crawl failures. If an incremental crawl fails a large number of consecutive times at any level in a repository, the system removes the affected content from the search index.

  • Crawl rules have been added, deleted, or modified.

  • You want to repair a corrupted search index.

  • The credentials for the user account that is assigned to the default content access account have changed. A full crawl is required only if the permissions of this user account have changed.

The system does a full crawl even when an incremental crawl or continuous crawl is scheduled under the following circumstances:

  • A search administrator stopped the previous crawl.

  • A content database was restored, or a farm administrator has detached and reattached a content database.

  • A full crawl of the content source has never been done from this Search service application.

  • The crawl database does not contain entries for the addresses that are being crawled. Without entries in the crawl database for the items being crawled, incremental crawls cannot occur.

Limit or increase the quantity of content that is crawled

The options available in the properties for each content source vary depending on the content source type that you select. You can use crawl setting options to limit or increase the quantity of content that is crawled. For each content source, you can specify how extensively to crawl the start addresses. Most content source types allow you to specify how many levels deep in the hierarchy from each start address to crawl. Note that this behavior is applied to all start addresses in a particular content source. If you have to crawl some sites at deeper levels, you can create additional content sources that include those sites. The following table describes best practices when you configure crawl setting options.

For this kind of content source If this pertains Use this crawl setting option

SharePoint sites

You want to include the content that is on the site itself and you do not want to include the content that is on subsites, or you want to crawl the content that is on subsites on a different schedule.

Crawl only the SharePoint site of each start address.

SharePoint sites

You want to include the content on the site itself.

-or-

You want to crawl all content under the start address on the same schedule.

Crawl everything under the host name of each start address.

Web sites

Content available on linked sites is unlikely to be relevant.

Crawl only within the server of each start address.

Web sites

Relevant content is located on only the first page.

Crawl only the first page of each start address.

Web sites

You want to limit how deep to crawl the links on the start addresses.

Custom — Specify the number of pages deep and number of server hops to crawl.

Note:

For a highly connected site, we recommend that you start with a small number, because specifying more than three pages deep or more than three server hops can crawl all the Internet.

File shares

Exchange public folders

Content available in the subfolders is unlikely to be relevant.

Crawl only the folder of each start address.

File shares

Exchange public folders

Content in the subfolders is likely to be relevant.

Crawl the folder and subfolders of each start address.

Business data

All applications that are registered in the Business Data Catalog metadata store contain relevant content.

Crawl the whole Business Data Catalog metadata store.

Business data

Not all applications that are registered in the BDC metadata store contain relevant content.

-or-

You want to crawl some applications on a different schedule.

Crawl selected applications.

Plan connectors

All content that is crawled requires you to use a connector (known as a protocol handler in earlier versions) to acquire and index that content. SharePoint 2013 provides connectors for the most popular protocols. However, if you want to crawl content that requires a connector that is not provided by default, you should consider installing a third-party or build a custom connector before you can crawl that content. For a list of connectors that are installed by default, see Default connectors in SharePoint Server 2013.

Other considerations when planning content sources

In addition to considering crawl schedules, your decision about whether to group start addresses in a single content source or create additional content sources depends largely upon administration considerations. To make administration easier, organize content sources in such a way that updating content sources, crawl rules, and crawl schedules is convenient for administrators.

Warning:

Changing a content source requires a full crawl.

  • You can't crawl the same start addresses by using multiple content sources in the same Search service application. For example, if you use a particular content source to crawl a site collection and all its subsites, you cannot use a different content source to crawl one of those subsites separately on a different schedule.

  • Administrators often make changes that update a particular content source. Since changing a content source requires a full crawl of the content repository that is specified in that content source, consider creating separate content sources to make sure that a full crawl does not take a very long time.

Plan crawl rules to optimize crawls

Crawl rules apply to all content sources in the Search service application. You can apply crawl rules to a particular URL or set of URLs to do the following things:

  • Avoid crawling irrelevant content by excluding one or more URLs. This also helps reduce the use of server resources and network traffic.

  • Crawl links on the URL without crawling the URL itself. This option is useful for sites that have links of relevant content when the page that contains the links does not contain relevant information.

  • Enable complex URLs to be crawled. This option directs the system to crawl URLs that contain a query parameter specified with a question mark. Depending upon the site, these URLs might not include relevant content. Because complex URLs can often redirect to irrelevant sites, it is a good idea to enable this option on only sites where you know that the content available from complex URLs is relevant.

  • Enable content on SharePoint sites to be crawled as HTTP pages. This option enables the system to crawl SharePoint sites that are behind a firewall or in scenarios in which the site being crawled restricts access to the Web service that is used by the crawler.

  • Specify whether to use the default content access account, a different content access account, or a client certificate for crawling the specified URL.

Because crawling content consumes resources and bandwidth, it is better to include a smaller amount of content that you know is relevant than a larger amount of content that might be irrelevant. After the initial deployment, you can review the query and crawl logs and adjust content sources and crawl rules to be more relevant and include more content.

Plan crawler authentication

When the crawler accesses the start addresses that are listed in content sources, the crawler must be authenticated by, and granted access to, the servers that host that content. By default, the system uses the default content access account. Or, you can use crawl rules to specify a different content access account to use when crawling particular content. Whether you use the default content access account or a different content access account specified by a crawl rule, the content access account that you use must have at least read permissions on all content that is crawled. If the content access account does not have read permissions, the content is not crawled, is not indexed, and therefore is not available to queries.

We recommend that the account that you specify as the default content access account has access to most of your crawled content. Only use other content access accounts when security considerations require separate content access accounts.

For each content source that you plan, determine the start addresses that cannot be accessed by the default content access account, and then plan to add crawl rules for those start addresses.

Important:

Ensure that the domain account that is used for the default content access account or any other content access account is not the same domain account that is used by an application pool associated with any Web application that you crawl. Doing so can cause unpublished content in SharePoint sites and minor versions of files (that is, history) in SharePoint sites to be crawled and indexed.

Another important consideration is that the crawler must use the same authentication protocol as the host server. By default, the crawler authenticates by using NTLM. You can configure the crawler to use a different authentication protocol, if it is necessary.

If you are using claims-based authentication, make sure that Windows authentication is enabled on any Web applications to be crawled.

Plan content processing

Include or exclude file types

Content from any file typecan be included in the search index. But for your content to be indexed, it first has to be crawled by the crawl component and then parsed by the content processing component. The crawl component can only crawl a file if its name extension is included in the list of file name extensions on the Manage File Types page. The content processing component can only parse the contents of a crawled file:

  • When it has a format handler that can parse the file format.

  • When it is enabled to parse files that have the file format and file name extension.

If the content processing component is unable to parse a file, the search index will only include file properties, such as the file name.

By default, SharePoint 2013 satisfies these requirements for many types of files and it can crawl and parse these file types without your having to install additional format handlers. For an overview of the file types, see Default crawled file name extensions and parsed file types in SharePoint Server 2013.

Note:

You can extend the initial collection of file formats that SharePoint 2013 can parse by adding third-party filter-based format handlers, known as iFilters. You cannot override a built-in format handler by installing a third-party iFilter.

When you plan to include content in the search index from content sources that have file types that are not on the Manage File Types page, review the following:

  • To crawl the file type, add the file type to the Manage File Types page.

  • To parse the file type:

    • If SharePoint 2013 does not have a format handler for the format, install a third-party filter-based format handler for the file format on each server that hosts a content processing component in the Search service application.

    • Enable parsing of the file format and file name extension on each server that hosts a content processing component in the Search service application

For more information, see Add or remove a file type from the search index in SharePoint Server 2013

Plan to use (custom) entity extractors

You can configure the search system to look for "entities" in unstructured content, such as in the body text or the title of a document. These entities can be words or phrases, such as product names. To specify which entities to look for, you can create and deploy your own dictionaries.

The extracted entities are stored in the search index as separate managed properties, which are automatically configured to be searchable, queryable, retrievable, sortable and refinable. You can use those properties in search refiners, for example, to help users filter their search results.

For companies, you can use the pre-populated company extraction dictionary that SharePoint 2013 provides.

In addition, you can deploy several types of custom entity extractors in the form of custom entity extraction dictionaries. You deploy these dictionaries using Windows PowerShell. The entries in these dictionaries (single or multiple words) will be matched on words or parts of words in the content in a case-sensitive or case-insensitive way. For more information, see Create and deploy custom entity extractors in SharePoint Server 2013.

Custom entity extractor / dictionary | Description
Word Extraction | Case-insensitive, maximum 5 dictionaries. For example, the entry "anchor" would match "anchor" and "Anchor", but not "anchorage".
Word Part Extraction | Case-insensitive, maximum 5 dictionaries. For example, the entry "anchor" would match "anchor", "Anchor" and within "anchorage".
Word Exact Extraction | Case-sensitive, maximum 1 dictionary. For example, the entry "anchor" would match "anchor", but not "Anchor" or "Anchorage".
Word Part Exact Extraction | Case-sensitive, maximum 1 dictionary. For example, the entry "anchor" would match "anchor" and within "anchorage", but not "Anchor".

About result sources and federated search

In SharePoint 2013, you use result sources to specify which providers to get search results from, which protocol to use to get those results and which authentication method to use to connect to the result source. You can also use query rules on a result source to narrow down a search to a subset of results from that particular result source. For more information, see Understanding result sources for search in SharePoint Server 2013.

Federated search is the concurrent querying of local and external search providers and displaying the results on a single results page for end-users. When you add a result source that specifies an external provider such as a remote search engine or feed, end-users can search for and retrieve content that has not been crawled by servers in the local farm.

See also

Understanding result sources for search in SharePoint Server 2013
Default connectors in SharePoint Server 2013
Default crawled file name extensions and parsed file types in SharePoint Server 2013

Search connector framework in SharePoint 2013

Change History

Date | Description
August 06, 2013 | Deleted the statement of support for crawling Exchange 2013 public folders. Currently SharePoint 2013 only supports crawling Exchange 2007 public folders and Exchange 2010 public folders.
June 18, 2013 | Clarified the requirements for including file types and file content in the search index. The section covers both parsing by using built-in format handlers and parsing by using third-party format handlers.
May 14, 2013 | Added a section describing the reasons to do a full crawl and added more information about content sources for line of business data.
July 16, 2012 | Initial publication


Overview of the search schema in SharePoint Server 2013
See also

Updated: August 13, 2013

Summary: Learn how the search schema is used to build up the search index. The search schema contains the mapping from crawled properties to managed properties and the settings on the managed properties.

Applies to: SharePoint Server 2013

The search index is the center of search. What is in your search index determines what people will find when they look for information by entering search queries or by interacting with internet or intranet pages.

This article describes how content is collected in and retrieved from the search index by using the search schema. The search schema contains crawled properties, crawled property categories, the crawled to managed property mapping and the managed property settings. Managed property settings define what you can search for and how, for example if you can refine or query on a property.

In this article:

  • Crawling and crawled properties

  • Managed properties and property mapping

  • The search schema

  • The search index

  • Managed property settings overview

Crawling and crawled properties

To build up the search index, you must first crawl content. You can crawl various content sources, for example SharePoint content, file shares or user profiles. The contents and metadata of the items that you crawl are represented as crawled properties.

Each item that has been crawled and passed on to the content processing component has crawled properties associated with it. Examples of properties are Author, Title, and Creation Date. Any new crawled properties will be discovered automatically.

Crawled properties are grouped into categories that are based on the IFilter or protocol handler of the item. Example categories are Office (crawled properties from Word documents, Excel worksheets, and so on), Business Data (crawled properties from for example databases), and Web (crawled properties from web sites).

For more information about crawling, see Plan crawling and federation in SharePoint 2013.

Managed properties and property mapping

To include the contents and metadata of crawled properties in the search index, you must map crawled properties to managed properties. Only managed properties are written to the search index.

Managed properties can have many settings. The settings on the managed property determine how the contents can be shown in search results and how people can search for it.

You can map multiple crawled properties to a single managed property. For example, you can map both the "Writer" and "Author" crawled properties to the "Author" managed property. Or, you can map a single crawled property to multiple managed properties.

Also, the order in which crawled properties are mapped to a managed property can determine the content of a managed property. For example, a managed property can have multiple crawled properties mapped to it and can be set to includes all values from all crawled properties mapped to it. But, if you give the crawled property containing the SharePoint title priority over another title in the mapping, it will show the SharePoint title in the search results.

A set of default mappings between crawled and managed properties has been defined, see Overview of crawled and managed properties in SharePoint Server 2013.

Some crawled property types automatically generate a new managed property and a mapping between the crawled and managed property. For example, all site columns from SharePoint libraries have this automatic generation and mapping. When you create a site column in a list, and you crawl that list, a crawled property, a managed property, and a mapping between the crawled and managed property is automatically created for the site column.

You can change the default mapping or any other mapping from crawled to managed properties, create new mappings, or create new managed properties. When you create a new managed property, or when you change certain settings on existing managed properties, a full crawl must complete before the managed property and its value is included in the search index. If the new or changed property is in a SharePoint library or list, you can reindex that individual library or list without starting a full crawl of the entire SharePoint content source. This has the same effect as a full crawl.

See the table Managed property settings overview later in this article for more information.

The search schema

The search schema is stored in the Search Administration database. The search schema contains:

  • The mapping between crawled properties and managed properties. This can be a mapping from one crawled property to one managed property, from one to many, many to one or even a many to many mapping.

  • How the managed properties should be written to the search index. For example, to which full-text index the values of the managed properties should be written and to which weight group (context).

  • The settings for the different managed properties. For example, if you can search on, query on, or refine search results by particular managed properties.

  • Crawled property categories that group properties according to their IFilter or protocol handler. If you edit a crawled property category, your changes apply to all of the crawled properties within the category. This can influence performance and how items are saved in the search index.

Search schema updates are propagated through the search system every minute.

Multiple search schemas

You can create multiple search schemas. The main search schema is defined in the Search service application and can be edited in the Central Administration. Site collection administrators and tenant administrators can change the search schema for a particular site collection or tenant. For example, a site collection administrator can customize what is included in the search index by changing the search schema for that site collection and, by doing this, customize the search experience for that site collection. Site owners can view the search schema, but not change it.

Note:

You can't view or change the site collection search schema in Central Administration. To view or make changes in the search schema for a site collection, you have to use Site Collection Administration.

The search index

The search index consists of a set of files in folders on a server. The content processing component processes crawled items, uses the search schema to map crawled properties to managed properties, and translates the managed properties into a format that is written to the search index. In addition to various full-text indexes, there are separate indexes of the managed properties that are marked as retrievable and those that are marked as queryable. There is also a separate index for attribute vectors, and there are numeric indexes.

Index update groups

Whenever an item changes, it must be re-indexed after it has been crawled again. To reduce the re-indexing load, SharePoint 2013 introduces several separate index update groups.

  • Default Contains he majority of managed properties. This index update group contains all managed properties that do not belong to the Security, Link, Usage or People index update groups.

  • Security Contains the document Access Control List (ACL) managed property

  • Link Contains the managed properties related to link structure

  • Usage Contains the managed properties related to usage data

  • People Contains the managed properties related to people search

Each update group is stored in a different folder in the search index.

Full-text index

A full-text index contains all the text from the searchable managed properties that are stored in that full-text index. Each full-text index is divided into weight groups, also referred to as contexts. The different contexts relate to the relative importance of a managed property, which is one of the ranking features that are used to calculate the total relevance rank of a search result. The number, or ID, of a context is not important; the ranking model determines its relative importance by assigning a contribution weight to a particular context. A higher contribution weight results in a higher ranking score. For more information, see the section Influence the ranking of search results by using the search schema in the article Overview of search result ranking in SharePoint Server 2013.

There are two pre-defined full-text indexes other than the default full-text index: the SharePoint Terms full-text index (SpTermsIdx) and the People index (PeopleIdx).

Most managed properties are already mapped to a suitable context and full-text index by default. We do not recommend changing the context of any of the existing searchable managed properties.

Managed property settings overview

Settings on the managed properties determine how content is saved in the search index and if and how people can search for and retrieve it.

The search schema can be edited in Central Administration, Site Collection Administration and Tenant Administration. Site administrators can view the search schema, but they can't edit the search schema. The following table describes the different settings and whether they are available for editing on different administrator levels.

Managed property setting What it does Example Available in Full crawl or reindex SharePoint list/library required after changing setting

Searchable

Enables querying against the content of the managed property. The content of this managed property is included in the full-text index.

If the property is "author", a simple query for "Smith" returns items that contain the word "Smith" and items whose author property contains "Smith".

Central Administration / Site Collection Administration / Tenant Administration

Yes

Advanced Searchable Settings

Enables viewing and changing the full-text index that the managed property is written to. It also allows you to change the context of the managed property for the relevance rank calculation. We do not recommend changing the context of any of the existing managed properties. For more information, see the section Influence the ranking of search results by using the search schema in the article Overview of search result ranking in SharePoint Server 2013.

Central Administration / Site Collection Administration / Tenant Administration

Yes

Queryable

Enables querying against the specific managed property. The managed property name must be included in the query, either specified in the query itself or included in the query programmatically.

If the managed property is "author", the query must contain "author:Smith".

Central Administration / Site Collection Administration / Tenant Administration

From disabled to enabled.

Retrievable

Enables the content of this managed property to be returned in search results. Enable this setting for managed properties that are relevant to present in search results.

Central Administration /Site Collection Administration /Tenant Administration

From disabled to enabled.

Allow multiple values

Allows multiple values of the same type in this managed property.

If this is the "author" managed property, and a document has multiple authors, each author name will be stored as a separate value in the managed property.

Central Administration

Yes

Refinable

Yes - active: Enables using the property as a refiner for search results in the front end. You must manually configure the refiner in the web part.

Yes - latent: Enables switching refinable to active later, without having to do a full re-crawl when you switch.

Both options require a full crawl to take effect.

Important:

If you select Yes - active or Yes - latent, you must also make the managed property Queryable.

If the "author" managed property is set to Refinable, you can set up Author as a refiner in your search front-end later.

Central Administration

From disabled to enabled (if not already set to Sortable)

Sortable

Yes - active: Enables sorting the result set based on the property before the result set is returned.

Yes - latent: Enables switching sorting to active later without having to do a full re-crawl when you switch.

Both options require a full crawl to take effect.

Use for large result sets that cannot be sorted and retrieved at the same time.

Central Administration

From disabled to enabled (if not already set to Refinable)

Alias

Defines an alias for a managed property if you want to use the alias instead of the managed property name in queries and in search results. Use the original managed property and not the alias to map to a crawled property.

Use an alias if you don't want to or don't have permission to create a new managed property.

Central Administration / Site Collection Administration / Tenant Administration

No

Token normalization

Enables returning results independent of letter casing and diacritics used in the query.

The query "curacao" will also match "Curaçao", "curacao" and "Curacao".

Central Administration / Site Collection Administration / Tenant Administration

Yes

Complete matching

Queries will only be matched against the exact content of the property.

If you have a managed property "ID" that contains the string "1-23-456#7", complete matching only returns results on the query ID:"1-23-456#7", and not on ID:"1-23" or ID:"1 23 456 7".

Central Administration / Site Collection Administration / Tenant Administration

Yes

Mappings to crawled properties

The list shows all the crawled properties that are mapped to this managed property. A managed property can get its content from one or more crawled properties.

You can either include content from all crawled properties or include content from the first crawled property that is not empty, based on a specified order.

Central Administration / Site Collection Administration / Tenant Administration

Yes

Company name extraction

Enables the system to extract company name entities from the managed property when crawling new or updated items. The extracted entities can later be used to set up refiners.

There is one pre-populated dictionary for company name extraction. The system saves the original managed property content unchanged in the index, and, in addition, copies the extracted entities to the managed property "companies". The "companies" managed property is configured to be searchable, queryable, retrievable, sortable and refinable.

You can edit the company name dictionary in the Term Store.

For more information, see Manage company name extraction in SharePoint Server 2013.

Central Administration / Site Collection Administration / Tenant Administration

Yes

Custom entity extraction

Enables one or more custom entity extractors to be associated with this managed property. This enables the system to extract entities from the managed property when crawling new or updated items. The extracted entities can later be used to set up refiners.

For more information, see Create and deploy custom entity extractors in SharePoint Server 2013.

Central Administration / Site Collection Administration

Yes

See also

Manage the search schema in SharePoint Server 2013
Overview of crawled and managed properties in SharePoint Server 2013
Plan crawling and federation in SharePoint 2013

Change History

Date | Description
August 13, 2013 | Updated to reflect which search schema changes require content to be reindexed.
July 16, 2012 | Initial publication


Plan to transform queries and order results in SharePoint 2013
See also

Summary: Learn how you can transform queries to provide more targeted SharePoint search results and how you can influence the way search results are ordered and displayed.

Applies to: SharePoint Server 2013

You can add query transforms to a Web Part, add query rules that transform queries when certain conditions are met, and you can transform all queries directed to a result source to create a specialized search experience.

SharePoint 2013 contains a number of predesigned search experiences, or search verticals, such as "Videos", "People" and "Conversations". These all contain predefined query transforms to optimize the search experience. You can also design your own search experiences that include your own query transforms, for instance for "Music" or "Pictures".

In this article:

  • Understanding query transforms and query variables

  • Using the Query Builder to write and test query transforms

  • Transforming queries for a Web Part

  • Transforming queries with query rules

  • Transforming queries in result sources

  • Changing the way results are shown by using result types

  • How the search system processes a query

Understanding query transforms and query variables

You can configure a query transform to replace certain properties of a query, such as the result source that the query will use to get search results from, or the sort order that it will use when it displays search results.

A query transform can contain query variables. Query variables are placeholders for values, and when a query is actually run, the query variables are replaced with specific values.

The following table shows some examples of query variables.

A query transform replaces this query variable: | With this:
{User.Name} | The name of the user who typed the query.
{Site.URL} | The site where the user typed the query.
{Today} | Today's date.
{SearchBoxQuery} | The query that the user typed.
{searchTerms} | The query that the user typed, as changed by the most recent transform.

See Query variables in SharePoint Server 2013 for an overview of all the available query variables.

When a query transform replaces the incoming query, it uses a query template. A query template is a query that includes query variables, for example "{searchTerms} contenttype:picture".

If you, for example, want to create a Pictures search vertical that only returns pictures in the search results, you could configure a query transform that uses the query template "{searchTerms} contenttype:picture" to add "contenttype:picture" to all queries. If a user then types the query "moon" in the Pictures vertical, the transform replaces the query variable "{searchTerms}" with "moon" and changes the query to "moon contenttype:picture".

You can configure query transforms in three places:

  • In a Web Part

  • In a query rule

  • In the result source

A user query is transformed first by the Web Part, then by any query rules that apply, and finally by the result source. When you configure a transform in a result source, you know that the transform changes will not be discarded or overridden, because the result source transforms the query last.

Using the Query Builder to write and test query transforms

The Query Builder helps you write and test query transforms. To build queries you use Keyword Query Language (KQL), and you can also add query variables. You can test the query from within the Query Builder by setting temporary test values for the query variables, run the query and preview the search results.

For more information about building search queries and for KQL syntax examples, see Building search queries in SharePoint 2013 (MSDN). For an overview of all the available query variables, see Query variables in SharePoint Server 2013.

Transforming queries for a Web Part

You can transform queries in search Web Parts, such as the Content Search Web Part and the Search Results Web Part. Query transforms on a Web Part can be overridden by a query rule or by a query transform on the result source.

Query transforms in a Web Part are most often used to specify the result source that the queries should be sent to. For example, if you want to create a search experience that is customized for searching for pictures only, you would first create a result source with a query transform that returns only pictures. Then, you would create a Web Part that has a query transform that changes any query run in that Web Part to use your new Pictures result source instead of the default one.

Another common use of query transforms in Web Parts is to make changes that are specific to one Web Part. For example, after creating the Pictures result source, you could add a Web Part with a query transform that uses the Pictures result source and in addition restrict the search results to only show recently modified pictures.

Transforming queries with query rules

You use query rules to try to capture the real intent behind a user query, and to return results that better match that intent. For each query rule you can specify under which conditions the rule should be applied, and also which actions the rule should trigger when it is applied. Most often you create query rules that apply to one site, but you can also create query rules that apply to a site collection or to all site collections in a Search service application.

The first step in creating a query rule is to specify the context of the rule. The minimum requirement is that you specify which result source the query must target for the query rule to be applied. To create a rule that only applies to people search, for example, you would specify that the context is the result source Local People Results. Optionally, you can include a user segment or topic category in the context of a query rule.

The next step is to specify the conditions that will cause the rule to be applied. If you want the query rule to apply to all queries, you can remove all conditions.

The following table shows the available query rule conditions.

Query rule condition | Description | Example
Query matches keyword exactly | Apply the query rule when the query exactly matches a word or phrase that you specify. | You specify "picture; pic" as the keywords. The query rule will apply when users type the query "picture" or "pic" in a search box. The rule will not apply if a user types "pictures" or "sunny picture".
Query contains action term | Apply the query rule when the query contains a term in the form of a single word or phrase that indicates that the user is trying to do something. The term must be at the beginning or end of the query and might be a verb, a command, or a filter. | If a query contains the phrase "download", the user is probably not looking for items that contain the word "download", but is probably trying to download something.
Query matches dictionary exactly | Apply the query rule when the query exactly matches a dictionary entry. This entry can be a term in the term store, or an entry in the people names dictionary. |
Query more common in source | Apply the query rule if the user's query is more commonly performed against a different result source than the current one. This condition uses an analysis of queries that users entered in the various result sources. | You can create a query rule that checks if a query is more commonly performed in a Video vertical. It will make video results more prominent if it is.
Result type commonly clicked | Apply the query rule if the query often ends in users clicking results of a particular result type. When you create a new result type, you can indicate that these clicks should be recorded to be used in query rules. | If this is a query where people often click the result type "pictures", it may be appropriate to provide picture-related results in a result block.
Advanced query text match | Apply the query rule if the query matches a regular expression. It also allows you to use variations of the keyword, dictionary and action term conditions explained earlier, but with more advanced control. | To match all phone numbers that are in the format nnn-nnn-nnnn, you specify the regular expression "\(?(\d{3})\)?-?(\d{3})-(\d{4})".

The final step is to specify which actions the query rule should trigger when it is applied. Optionally, you can specify the start and end date for a query rule to be active.

The following table shows the available query rule actions.

Query rule action Description Example

Add promoted results

Show promoted results (known as Best Bets in earlier versions of SharePoint) above ranked results. Promoted results are best used when an item is not indexed or if it has a poor document summary. In other cases, consider changing the ranking of the results.

For the query "sick leave", you can for instance add a link to a Human Resources site above all ranked results.

Add result blocks

Add a block of results that contains a small subset of results that are related to a query in a specific way. You can promote a result block, or you can rank it with other search results.

The query transform specified for the result block transforms a copy of the original query.

You can also specify which display template should be used to display the result block.

For a query that contains "Contoso sales report", a query rule could use a taxonomy dictionary to recognize "Contoso" as a customer, and then display a result block with results about "Contoso" from your customer relationship management (CRM) system.

Change ranked results by changing the query

Add a query transform that changes the original query. For example, the transform can promote or demote certain results.

Changing the ranking of search results, such as boosting appropriate results by their site or URL, is a common alternative to adding promoted results. Changing ranked results by changing the query has the advantage that the results are security trimmed and refinable. Also, the search results will disappear if the document is no longer available. You can change the sorting order of the search results dynamically, based on several variables such as file extension or specific keywords. You can either promote or demote results, and you can specify how much the results should be promoted or demoted.

For more information, see the section Influence the ranking of search results with query rules in Overview of search result ranking in SharePoint Server 2013.

For a query that contains "download toolbox", a query rule could recognize the word "download" as an action term and boost search results that point to a particular download site on your intranet.

Transforming queries in result sources

For each result source, you can specify that all search results from that result source should be transformed in a specific way. For example, the pre-configured "Local Video Results" result source uses a query transform to return only video results from the local SharePoint index.

SharePoint 2013 provides a number of preconfigured result sources with predefined query transforms out-of-the-box. You can also create new result sources and apply different query transforms on them. You can create more than one result source per search provider, and you can set different query transforms on each result source.

A user query is transformed first by the Web Part, then by any query rules that apply, and finally by the result source. When you configure a transform in a result source, you know that the transform changes will not be discarded or overridden, because the result source transforms the query last. You can re-use a result source query transform in Web Parts or result blocks, and you can create query rules or result types that are only applied to results from certain result sources.

Changing the way results are shown by using result types

With result types, you can conditionally change how search results are displayed. To customize the appearance of a group of related results, you can create a display template in HTML and associate the display template with a result type. You can create rules to specify when to show the display template, and you can prioritize these rules.

How the search system processes a query

When someone enters a query or clicks on an element that triggers a query, the search system sends the query to the query processing component. This component processes the query and then sends it to the appropriate search providers to retrieve results. A search provider can be a local search index or a remote source. After the results are collected from the search providers, the query processing component performs additional processing and then returns the results so that they can be displayed.

The search system processes a query by doing the following:

  1. Applying any Web Part transforms.

  2. Applying any query rules. A query rule action can either transform the original query or it can trigger a parallel query that is transformed for a result block.

  3. Applying any query transforms on result sources.

  4. Parsing the query and creating a query syntax tree for internal use.

  5. Processing the query linguistically by performing word breaking, stemming, spelling correction, and synonym expansion.

  6. Appending user-access information to the query. This specifies the user who is performing the query and the permissions that the user has.

  7. Sending the query to the search index or another search provider.

  8. Collecting and merging search results from all search providers and sending them back to the query processing component.

  9. Evaluating the search results against result types. If a result matches a particular result type, the result is displayed by using the display template that you have specified for the result type.

  10. Applying additional security trimming, if appropriate.

See also

Manage query rules in SharePoint Server 2013
Configure result sources for search in SharePoint Server 2013
Manage the Search Center


Overview of search result ranking in SharePoint Server 2013
See also

Updated: August 13, 2013

Summary: Learn how SharePoint 2013 uses ranking models to calculate the relevance rank of search results and how you can influence the order of search results by using query rules, the search schema and ranking models.

Applies to: SharePoint Server 2013

The search engine calculates the relevance rank, that is to say, the order in which the search results for a query appear. The ranking model is at the core of this calculation. In most cases, you can influence relevance by using the available SharePoint 2013 ranking models in combination with query rules without having to consider customizing any ranking models.

In this article:

  • What is a ranking model?

  • How does a search result get a rank?

  • How can I influence the rank of a search result?

  • Influence the ranking of search results with query rules

  • Influence the ranking of search results by using the search schema

  • Influence the ranking of search results by using a custom ranking model

What is a ranking model?

There are several ranking models in SharePoint 2013 that are optimized for specific cases. These ranking models provide an effective ranking of results without any further customization. A ranking model contains a collection of ranking features to calculate the rank score of a particular item, for example a document, in the search results. The type of content that is ranked determines the set of ranking features that the ranking model uses and the relative importance of these different ranking features.

For the default search verticals Everything, Videos, Conversations and People, the search system uses the most appropriate ranking model automatically. If you create your own search vertical, you can configure which ranking model to use for that vertical.

SharePoint 2013 provides the following types of ranking models:

  • General purpose ranking models.

    General purpose ranking models compute the relevance rank for most types of search results.

  • People search ranking models.

    People search ranking models compute the relevance rank for search results that are related to people. They calculate, among other things, how relevant search results are based on social distance and expertise.

  • Special purpose ranking models.

    Special purpose ranking models compute the relevance rank for search results related to various specific ranking scenarios. For example, there is a ranking model to calculate the ranking score for recommendations and there are ranking models to calculate relevance ranks for cross-site publishing sites that have an associated product catalog.

The following table lists the available ranking models in SharePoint 2013.

Ranking model type Ranking model name Description

General purpose

Default Search Model

Default ranking model for the Search service application. This ranking model ranks most search results, such as the search results for queries on the result source "Local SharePoint Results". This model is used for the search verticals Everything, Videos and Conversations.

General purpose

Search Ranking Model with Two Linear Stages

Important:

This ranking model is only available after you have installed the SharePoint Server 2013 cumulative update package published on August 13, 2013.

This ranking model is a copy of the Default Search Model with the exception that stage two is a linear stage instead of a neural net stage. We recommend that you use a copy of this model as the base model if you want to create a custom ranking model.

General purpose

O15 MainResultsDefaultRankingModel

Important:

This ranking model is only available after you have installed the SharePoint Server 2013 cumulative update package published on August 13, 2013.

Ranking model that was used as the default ranking model for the Search service application before the SharePoint Server 2013 cumulative update of August 2013. The cumulative update introduces some improvements to the Default Search Model. This ranking model was added for backward compatibility.

General purpose

O14 Default Search Model

Ranking model that was used as the default ranking model for the Search service application in SharePoint Server 2010 and Search Server 2010. This ranking model was added for backward compatibility.

General purpose

Search Model With Boosted Minspan

Ranking model that puts a higher weight on proximity features than the Default Search Model. Proximity features in the ranking model look at each of the query terms and determine how close to one another these query terms occur in the items. Proximity is only considered in the managed properties Body and Title.

General purpose

Search Model Without Minspan

Default Search Model without proximity features.

People search

People Search application ranking model

Default ranking model for people search. This ranking model ranks search results for people. People search is based on user profile information from My Sites that are kept in the User Profile service application.

People search

People Search expertise ranking model

Ranking model for people search that puts a higher weight on expertise. Expertise is calculated based on how few levels the person is from the top position within an organization.

People search

People Search expertise social distance ranking model

Ranking model for people search based on expertise with a higher weight on social distance. Social distance is the relationship, as defined by their position in the organization, between the user who typed the query and the people who are listed in the search results.

People search

People Search name ranking model

Ranking model for people name search.

People search

People Search name social distance ranking model

Ranking model for people name search that puts a higher weight on social distance.

People search

People Search social distance model

Ranking model for people search that puts a higher weight on social distance.

Special purpose

Catalog ranking model

Ranking model for internet facing websites. This ranking model ranks search results for websites that use cross-site publishing and that have a product catalog associated with the SharePoint site collection.

Special purpose

Popularity ranking model

Ranking model for popularity based search. This ranking model ranks SharePoint content based on the number of times an item that is stored in SharePoint has been accessed.

Special purpose

Recommender ranking model

Ranking model to rank recommendations. Recommendations are based on item-to-item relationships collected from an analysis of how users have interacted with items on a site or with search results.

Special purpose

Site suggestion ranking model

Ranking model for social suggestions. Items that other users have clicked will get a higher ranking.

How does a search result get a rank?

A ranking model computes the relevance rank of a search result. A search result gets a rank through a process called rank evaluation. The rank evaluation results in a ranking score. Items with the highest score get the highest position in search results. Search results are sorted in descending order based on their ranking score.

For example, the default search model uses two stages for rank evaluation. During stage one, the ranking model applies fairly inexpensive ranking features to get a gross ranking of the results. During stage two, the ranking model applies additional and more expensive rank features to the items with the highest rank. By default, the search results page shows the ten documents that have the highest ranking score after these two stages of rank evaluation.

Each ranking model has several ranking features. The relative weight of these ranking features in the overall ranking calculation varies per ranking model. Ranking features can be query dependent or query independent. To calculate the final ranking score of a search result, all the calculations of all the ranking features in the ranking model are combined.

Ranking models use information from the search index, as explained in the following table.

Information about a search index item | Description
Content | These are the words contained in the items. For items that are text based, such as documents, this is typically most of the text. For other types of items, such as videos, there is little or no content.
Metadata | The metadata associated with items such as title, author, URL and creation date. Metadata is automatically extracted from most types of items.
Web graph data | This is information such as authority (from authoritative pages settings) and anchor text (from the hyperlinks associated with the item, and items linking to the item).
File type | Some file types can be considered more important for ranking than others. For example, Word and PowerPoint results are typically more important than Excel results.
Interaction | Information about the number of times a search result is clicked, and which queries led to a result being clicked.

How can I influence the rank of a search result?

You can influence the ranking of search results in the following ways:

  • Query rules: define which actions to take when a query matches a condition.

    • Promote particular results to the top of the search results.

    • Add a result block to promote particular results.

    • Change the rank by changing the query.

      • Change the sorting of the ranked results based on managed properties.

      • Dynamically promote or demote particular results.

      • Change the ranking model when someone runs a certain query.

    See the section Influence the ranking of search results with query rules for more information.

  • Search schema: configure the context of a managed property.

    • Change the context of a managed property in Advanced Searchable Settings.

    See the section Influence the ranking of search results by using the search schema for more information.

  • Create and use a custom ranking model.

    • Customize a copy of an existing ranking model, deploy it and use this custom model to rank search results.

    See the section Influence the ranking of search results by using a custom ranking model for more information.

In most cases, using the available ranking models in SharePoint 2013 in combination with query rules should provide sufficient ways to influence ranking.

Influence the ranking of search results with query rules

If you are not satisfied with the search result ranking for specific queries, we recommend that you try to influence the ranking for those queries with query rules. In most cases, configuring query rules will help you reach your goals, and you won't have to consider changing the context of a managed property or creating a custom ranking model.

For each query rule, you can influence the way you sort, rank and display search results. Each query rule consists of a query rule condition and a query rule action. Whenever a query matches a query rule condition, the query rule action that you specify in the query rule triggers.

You can specify the following query rule actions for a query rule:

  • Add promoted results on top of the ranked search results.

    When you add a promoted result, which was called Best Bets in earlier versions of SharePoint, you show this result above the ranked results. For example, for the query "sick leave", you can add a link to a Human Resources site above all ranked results.

  • Add a result block.

    A result block displays search results as a group. You can configure the query rule to define for which queries you want to show the results in a result block. In the same manner as you can promote a specific result, you can promote a result block when a specified query condition applies.

  • Change the rank by changing the query.

    • Sort by managed property.

      You can change the sorting order of the search results by specifying by which managed property the search results should be sorted, and if this should be done in ascending or descending order. You can add more than one sort level. If you sort by one or more managed properties, you do not use a ranking model to rank the search results.

    • Dynamic ordering: promote or demote search results.

      You can dynamically change the ranking of search results. You can specify when you want to change the ranking of the search results for a query, and by how much, when a certain condition applies. The following table shows the conditions that you can set.

      Change ranking when: Description

      Result contains keyword

      Matches if the result contains the keywords anywhere in its contents, including meta-data.

      Title contains keyword

      Matches if the result title contains the specified keywords or phrases.

      Title matches keyword

      Matches if the result title exactly matches the specified keywords or phrases.

      URL starts with

      Matches if the result URL starts with the specified URL.

      URL exactly matches

      Matches if the result URL exactly matches the specified URL.

      Content type is

      Matches if the result is of the content type that you specify.

      File extension matches

      Matches if the result has the specified file extension.

      Result has the tag

      Matches if the result has the specified taxonomy tag as part of its meta-data.

      Manual condition

      Add any restriction using standard query syntax.

    • Change the ranking model.

      You can change which ranking model is used when a query rule fires.

For more information, see Plan to transform queries and order results in SharePoint 2013 and Manage query rules in SharePoint Server 2013.

Influence the ranking of search results by using the search schema

You can influence the ranking of search results by changing the context of a searchable managed property in a full-text index. However, most managed properties are already mapped to a suitable context and full-text index by default. We do not recommend changing the context of any of the existing searchable managed properties. However, if you create a new managed property and you want this property to be considered by the ranking models, you have to map it to a full-text index context.

SharePoint 2013 has several full-text indexes. Each full-text index has several managed properties that are stored in that full-text index. In this section, we only discuss the default full-text index and only a few of the default full-text index contexts in combination with the default search ranking model.

A full-text index contains all the text from the searchable managed properties that are stored in that full-text index. Each full-text index is divided into weight groups, also referred to as contexts. The different contexts relate to the relative importance of a managed property, which is one of the ranking features that are used to calculate the total relevance rank. The number, or ID, of a context is not important; the ranking model determines its relative importance by assigning a contribution weight to a particular context. A higher contribution weight results in a higher ranking score.

By default, new managed properties are mapped to context 0, which means that they are returned in the search results but are not considered by any of the ranking models. If you want a new managed property to be considered by the default search ranking model, you should map it to the default full-text index and to one of the contexts shown in the table below. There are more contexts in the default full-text index, but you should only use the contexts mentioned in the following table. Each ranking model considers the contexts differently; the table only shows how the Default Search Model considers contexts in the default full-text index.

Context | Example of a managed property in this context | Relative contribution weight to ranking (Default Search Model and default full-text index)
0 | - | Used only for recall, not for ranking.
1 | Title | 0.3610
2 | Filename | 0.1512
5 | Author | 0.1581
7 | Body | 0.0194

For example, you create a new managed property of the type string that contains about ten words or less. You consider this new managed property to be about as important as the existing managed property Title. In that case, you should map the new managed property to context 1.

Another example. You create a managed property of the type string that contains lots of words, for example a description of something. You should map this new managed property to context 7 because it is similar to the managed property Body, both in length as well as in importance.

Important:

Map managed properties with similar importance and size (in words) to the same context.

After changing the context of a managed property, it is important to monitor the search results, as the change may not have the expected or desired consequences. It will take some time before the changes appear in the search results, because the content has to be re-indexed before changes to the search schema are picked up. If you have already crawled one or more content sources that include content that contains the managed property that you changed the context of, you have to do a full re-crawl of those content sources before you can see any changes in the ranking.

You can change the context of a searchable managed property in the Advanced Searchable Settings, using the search schema feature in the Search service application. See Overview of the search schema in SharePoint Server 2013 and Manage the search schema in SharePoint Server 2013 for more information.

Influence the ranking of search results by using a custom ranking model

The most advanced way to change the ranking of search results is to create a custom ranking model. In most cases, the ranking models that SharePoint 2013 supplies provide good ranking, and you can influence this ranking with query rules as discussed in Influence the ranking of search results with query rules

Examples of when you may want to create and use a custom ranking model:

  • You have created a search experience in which query performance is extremely important and you want to make the ranking model calculations faster.

  • You have built a custom app and want to create a ranking model that is specific to that app.

  • You have added a special managed property for a special search experience and want to include this managed property in the ranking calculations.

Warning:

If you create a custom ranking model, this influences all the queries using that ranking model. You should test the effect of the custom ranking model on many queries.

You can read more about how to create, deploy and use a custom ranking model in the article Customizing ranking models to improve relevance in SharePoint 2013 on MSDN.

Note:

If you want to create a custom ranking model for the default search results, we recommend that you install the SharePoint Server 2013 cumulative update package published on August 13, 2013. This cumulative update includes two new ranking models, one of which is Search Ranking Model with Two Linear Stages. If you use a copy of the Search Ranking Model with Two Linear Stages as the base model for your custom ranking model, it will be easier to re-tune and customize your ranking model.

See also

Plan to transform queries and order results in SharePoint 2013
Overview of the search schema in SharePoint Server 2013

Change History

Date | Description
August 13, 2013 | Updated to reflect changes to ranking models that were introduced in the SharePoint Server 2013 cumulative update package of August 2013.
April 16, 2013 | Initial publication


Overview of analytics processing in SharePoint Server 2013

Summary: Learn how the Analytics Processing Component analyzes content and user actions to improve search relevance.

Applies to: SharePoint Server 2013

To help identify and surface the content that users consider to be the most useful and relevant, the Analytics Processing Component in SharePoint Server 2013 analyzes both the content itself, and also the way that users interact with it. The results from the analysis are added to the items in the search index so that search relevance improves automatically over time. Also, the results are used in reports that help search administrators see which manual steps they can take to improve the search system.

In this article:

  • The analytics architecture

  • The different types of analyses

  • The usage events used by Usage analytics

  • Reports based on analytics processing

The analytics architecture

The analytics architecture consists of these main parts:

  • The Analytics Processing Component runs the analytics jobs. For more information, see The different types of analyses.

  • The Analytics reporting database stores statistical information, such as usage event counts, from the different analyses. SharePoint Server uses the information in this database to create Excel reports for the search administrators. For more information, see Usage analytics and Reports based on analytics processing.

  • The Link database stores information about searches and crawled documents. The data in this database is processed in different sub-analyses. For more information, see Search analytics.

The different types of analyses

The Analytics Processing Component runs two main types of analyses: Search analytics and Usage analytics. Search analytics analyzes content in the search index, and usage analytics analyzes the user actions.

  • Search analytics analyzes content that is being crawled and added to the search index.

  • Usage analytics analyzes user actions, or usage events, such as clicks or viewed items, on the SharePoint site.

Search analytics

Search analytics is a set of analyses that extracts information such as links and anchor text from content as it is being crawled and processed and stored in the search index. The extracted information is stored in the Link database together with information about clicks on search results. The information in the Link database is further processed in several sub-analyses.

Information that results from the search analyses is used to enrich items in the search index with information to help improve relevance and recall, and is stored in the Reporting database and included in reports.

Analyses in search analytics

Analysis Description

Anchor text processing

Anchor text processing analyzes how items in the content corpus are interlinked. It also includes the anchor texts associated with the links in the analysis. The Analytics Processing Component uses the results of the analysis to add rank points to the items in the search index.

Click Distance

The Click Distance analysis calculates the number of clicks between an authoritative page and the items in the search index. An authoritative page can be a top level site, for example http://www.contoso.com, or other pages that are viewed as important. You can define Authorative pages in Central Administration.

The Analytics Processing Component uses the results of the analysis to add rank points to the items in the search index.

Search Clicks

The Search Clicks analysis uses information about which items users click in search results to boost or demote items in the search index. The analysis calculates a new ranking of items compared to the base relevance.

The clicks data is stored in the Link database.

Social Tags

The Social Tags analysis analyses social tags, which are words or phrases that users can apply to content to categorize information in ways that are meaningful to them.

In SharePoint Server 2013, social tags are not used for refinement, ranking, or recall by default. However, you can create custom search experiences that use social tags and the information from this analysis.

Social Distance

The Social Distance analysis calculates the relationship between users who use the Follow person feature. The analysis calculates first and second level Followings: first level Followings first, and then Followings of Following.

The information is used to sort People Search results by social distance.

Search Reports

The Search Reports analysis aggregates data and stores the data in the Analytics reporting database where it's used to generate these search reports:

  • Number of queries

  • Top queries

  • Abandoned queries

  • No result queries

  • Query rule usage

The report information is saved in the Search service application, and not with the items in the search index. If you delete the Search service application, the report information is also deleted.

Deep Links

The Deep Links analysis uses information about what people actually click in the search results to calculate what the most important sub-pages on a site are. These pages are displayed in the search results as important shortcuts for the site, and users can access the relevant sub-pages directly from the search results.

Usage analytics

Usage analytics is a set of analyses that receive information about user actions, or usage events, such as clicks or viewed items, on the SharePoint site. Usage analytics combines this information with information about crawled content from the Search analyses, and processes the information. Information about recommendations and usage events is added to the search index. Statistics on the different usage events is added to the search index and sent to the Analytics reporting database.

A default set of usage events is defined out of the box. The default events are always registered and analyzed by SharePoint. You can also configure custom event types. For more information about the default usage events, see The usage events used by Usage analytics.

Analyses in usage analytics

Analysis Description

Usage counts

The Usage counts analysis analyzes events, such as viewed or clicked items. The analysis calculates how many times an item is opened overall, not just from the search result page, but also, for example, when a document is opened from Word or clicked in a SharePoint library.

The analysis calculates both recent events and all time events, for all defined event types. By default, recent events is set to the last 14 days, but you can set it between 1 and 14 days (on-premises). The statistics data is aggregated on site level, on site collection level, and on tenant level (SPO).

The usage events are stored temporarily on the web front end and are pushed to the Search Service Application every 15 minutes. Usage events are kept on disk for up to 14 days before they are deleted. Every day, the previous full day of Usage counts data is analyzed.

Usage counts are added to the items in the search index to improve search relevancy. The information is also stored in the Analytics reporting database, and can be used to display popular items on a site.

Recommendations

The Recommendations analysis creates recommendations between items based on how users have interacted with the items on a site. The analysis uses the same event file as Usage counts, but looks for patterns in the usage. The analysis calculates an item-to-item relationship graph and adds the information to the items in the search index.

The information can be used to display recommendations on a site, for example "People who viewed this also viewed".

The data is stored in the Analytics reporting database for recovery purposes. Reports related to recommendations are based on the Usage counts analysis.

Activity ranking

The Activity ranking analysis uses the activity tracking of usage events (the event rate) to influence search relevancy. Items that have high usage activity (clicks or views) typically get a higher activity rank score than less popular items.

The analysis looks for trends in item activity. If you only count the number of events, older items will typically "win" in relevancy, because the older documents have had more time to collect activity. The activity tracking helps newer documents that have high usage activity get a higher rank.

The usage events used by Usage analytics

SharePoint Server 2013 includes the following default usage events:

  • Views

  • Recommendations displayed

  • Recommendations clicked

In addition to the default events, you can add up to twelve custom events. For example, you can add a custom event that tracks how often an item is accessed from a mobile platform.

All usage events are counted per item, site collection, and tenant (SPO).

Reports based on analytics processing

The Analytics Processing Component generates data that is used to create the following usage reports:

  • Popularity Trends An Excel report that shows the daily and monthly count per usage event for a site collection, site, or specific item in a SharePoint library or list.

    Note:

    Unique Users shows the number of unique users per day, while Unique Users per month shows SUM(UU/Day) for the month.

  • Most Popular Items Shows ranking per usage event for all items in a library or list, for example the most viewed items in the library or list. The ranking can be sorted by Recent or Ever.

Privacy protection of the data collected by the Analytics Processing Component

Parts of the data that the Analytics Processing Component collects are related to personally identifiable information. SharePoint Server 2013 has different features to protect the privacy of this information.

For each usage event, the Analytics Processing Component logs the following information:

  • The URL of the item where the usage event occurred.

  • The SiteID, the WebID, and the TenantID where the usage event occurred.

  • The time and the date when the usage event occurred.

  • The obfuscated user ID of the person who caused the usage event to occur.

This data is stored in the Search service application before it is processed by the Analytics Processing Component. The data is automatically removed after 30 days. The following list shows the results of the data processing:

  • The total number of usage events.

  • The total number of unique usage events.

  • Item-to-item recommendations.

  • Relevance features.

These results are stored in the analytics reporting database, and in the search index. No user information is stored as a result of the data processing. The obfuscated user ID is only used when calculating the unique usage event counts, and calculating item-to-item recommendations.

You can view the results in two usage reports. For more information, see View usage reports in SharePoint Server 2013.

Usage cookies for sites that have anonymous users

By default, usage cookies are not enabled for a SharePoint web application. To generate unique user counts and item-to-item recommendations for sites that have anonymous users, SharePoint Server 2013enables you to use usage cookies for a SharePoint web application. When you enable usage cookies, this generates a unique GUID that is used as a user ID when data is being processed. The GUID is available for the lifetime of the cookie, and it is used as a user ID when data is being processed. The lifetime of the cookie is 14 days.

Important:

Local legal restrictions might apply when you enable cookies on sites that have anonymous users.

To enable usage cookies for a SharePoint web application, see Edit general settings on a web application in SharePoint 2013.


Plan managed metadata in SharePoint Server 2013

Summary: Find links to articles about managed metadata and taxonomy in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet and related resources provide information about managed metadata planning in SharePoint Server 2013.

Managed metadata is a hierarchical collection of centrally managed terms that you can define and then use as attributes for items in SharePoint Server 2013. The first articles in this section explain key concepts about managed metadata in SharePoint Server 2013. Additional articles in the section provide guidance about how to identify managed metadata for your solution, and how to determine the managed metadata services and connections that you will have to have to implement your solution.

TechNet articles about managed metadata planning

The following articles about managed metadata are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of managed metadata in SharePoint Server 2013 | Learn about managed metadata including terms, term sets, and enterprise keywords.
Building blocks | Overview of managed metadata service applications in SharePoint Server 2013 | Learn about the SharePoint managed metadata service application, managed metadata connections, and the permissions that are required to access managed metadata.
Checklist icon (not checked) | Plan terms and term sets in SharePoint Server 2013 | Learn how to plan a SharePoint managed metadata taxonomy, how to determine and organize term sets, and how to define terms.
Checklist icon (not checked) | Plan to share term sets and content types in SharePoint Server 2013 | Figure out how many SharePoint managed metadata services and connections to the services you must have to meet your business requirements.


Overview of managed metadata in SharePoint Server 2013
See also

Summary: Learn about SharePoint managed metadata including terms, term sets, and enterprise keywords.

Applies to: SharePoint Server 2013

Managed metadata is a hierarchical collection of centrally managed terms that you can define, and then use as attributes for items in SharePoint Server 2013.

This article introduces the core concepts about managed metadata, and then describes the way that you use managed metadata. An example is used throughout this article to explain the concepts. The final section presents several benefits of incorporating managed metadata into your SharePoint Server 2013 solution.

Understanding SharePoint managed metadata

This section defines several key concepts related to managed metadata.

Terms and term sets

A term is a word or a phrase that can be associated with an item in SharePoint Server 2013. A term set is a collection of related terms. You can specify that a column must contain a term from a specific term set. Managed metadata is a way to refer to the fact that terms and term sets can be created and managed independently from the columns themselves.

Local term sets are created within the context of a site collection. For example, if you add a column to a list in a document library, and create a new term set to bind the column to, the new term set is local to the site collection that contains the document library.

Global term sets are created outside the context of a site collection. For example, the term store administrator could create a term set group that is named "Human Resources" and designate a person to manage the term set group. The group manager would create term sets that relate to Human Resources, such as job titles and pay grades in the Human Resources term set group.

Users can see only global term sets and term sets that are local to the user's site collection.

For example, imagine that you are organizing a conference. Each conference session is assigned a room, and the large sessions are also assigned an overflow room, in which attendees who do not fit into the primary room can watch the session broadcast on large screens. You decide to track all of the sessions and their associated details in a SharePoint list.

To keep track of the sessions and their conference rooms, you would:

  1. Create a term set that is named "Conference rooms" to represent all of the available rooms.

  2. Add a term to the term set for each conference room.

  3. Create a content type called "Session."

  4. Add two new columns to the content type: "Room" and "Overflow room."

  5. Specify that the value of each of these columns must come from the "Conference rooms" term set.

  6. Create a list of sessions.

In this example, when you add a session to the list, you provide values for the Room and Overflow room. If you later reserve an additional room at the conference center, you would add a new term to the Conference rooms term set, and it would become a valid value for the two columns.

Managed terms, enterprise keywords, and the term store

Terms can be divided into two types:

  • Managed terms, which are usually pre-defined, can only be created by users who have the appropriate permissions, and are often organized into a hierarchy.

  • Enterprise keywords, which are merely words or phrases that were added to SharePoint items. All enterprise keywords are part of a single, non-hierarchical term set that is named the keyword set.

Managed terms and enterprise keywords are used differently. For more information, see the "Using terms" section later in this topic.

Note:

The word "managed" is often omitted when it refers to managed terms when the meaning is clear from the context.

Both managed terms and enterprise keywords are stored in a database known as a term store.

Working with SharePoint managed metadata

The following sections describe how terms are created and used. The conference room example is used throughout these sections to explain the concepts.

Creating terms

SharePoint Server 2013 includes the Term Store Management Tool, which you use to create and manage term sets. If you have the appropriate permissions, you can use the Term Store Management Tool to perform the following actions:

  • Create or delete a term set.

  • Add, change, or delete terms.

  • Arrange managed terms in a term set into a hierarchy.

  • Define synonyms.

  • Import terms.

  • Make enterprise keywords into managed terms by moving them into a term set.

Example:

To organize the conference sessions, you start by using the Term Store Management Tool to define a term set to represent all of the conference rooms. Then you use the same tool to add a term to the term set for each room. You start to define the following term set and terms:

  • Conference rooms (term set)

    • La Nouvelle Ballroom

    • Room 256

    • Room 270

    • Mardi Gras Ballroom

    • Room 287

    • Room 391

    • Room 348b

    • Hall C

    • Hall D

    • Room 348a

    • Auditorium C

    • Auditorium D

    • Auditorium E

    • Room 354

    • Room 355

    • Room 293

The term set is becoming unwieldy. You will have to scroll through too long a list when you select a conference room. You decide to reorganize the term set based on which wing of the conference center the rooms are located in. The new term set and terms now have this structure:

  • Conference rooms (term set)

    • Auditoriums

      • Auditorium C

      • Auditorium D

      • Auditorium E

    • Halls

      • Hall A

      • Hall B

      • Hall C

      • Hall D

    • Ballrooms

      • La Nouvelle Ballroom

      • Mardi Gras Ballroom

    • Second floor

      • Room 256

      • Room 270

      • Room 287

      • Room 293

    • Third floor

      • Room 348a

      • Room 348b

      • Room 354

      • Room 355

      • Room 391

Because the terms "Auditoriums," "Halls," "Second floor," and "Third floor" are used only for grouping other terms and do not represent actual rooms in which sessions can be held, you do not make these terms available for users to select.

Using terms

A column is a location in a list in which to store information about a SharePoint item. When you define a column, you provide a name for the column, specify the column's type, and provide additional information that depends on the column type.

SharePoint Server 2013 includes a column type called managed metadata. When you create a managed metadata column, you specify the term set from which the column's value must come. When you want users to provide information for list items (including documents), and the valid values for the information are contained in a term set, use a managed metadata column. Create a new content type or change an existing content type, and add the managed metadata column to the content type.

Example:

You create a new content type named "Session" to represent each session. Because conference sessions will have an associated room and overflow room, you add columns for each of these attributes. You add a column named "Room," choose Managed Metadata for the column's type, select the term set "Conference rooms" to provide values for the "Rooms" column, and indicate that the column can only contain a single value. Then you create an additional column named "Overflow room," and map it to the same term set. Because not all sessions have an overflow room, you do not require that the column contain information. Because there may be multiple overflow rooms, you allow multiple values.

The definitions of the two columns are summarized in the following table:

Column name | Term set | Require a value? | Allow multiple values?
Room | Conference rooms | Yes | No
Overflow room | Conference rooms | No | Yes

Finally, you create a list of sessions.

Entering terms

When a user creates or uploads a new SharePoint item of a type that has columns that require a value, the user must provide a value. If the column is a managed metadata column, the managed metadata control is displayed, and the user interacts with this control to enter the value.

The managed metadata control allows the user either to type a value or to select a value by hierarchically moving through the term set that is associated with the column. If the user starts to type a value, the control displays all terms in the associated term set that begin with the characters the user has typed. The name of the term set and the term's position in the hierarchy are indicated together with the term itself.

If the column's definition allows for multiple values, the user can select more than one term. If both the term set and the column's definition allow new terms to be added, the user can also create a new term and insert it at the appropriate place in the term set's hierarchy.

Example:

A conference administrator adds a new session. SharePoint Server displays a form that contains a field for each column that is associated with the Session content type. When the administrator creates the keynote session, in the Room field, the administrator displays the hierarchy of terms within the Conference rooms term set, and then selects La Nouvelle Ballroom.

The administrator cannot remember which auditorium is being used for the overflow from the keynote session, but knows that it is the middle one. The administrator types aud, and the following terms are displayed as options:

  • Auditorium C [Conference rooms: Auditoriums]

  • Auditorium D [Conference rooms: Auditoriums]

  • Auditorium E [Conference rooms: Auditoriums]

The administrator selects Auditorium D.

Entering enterprise keywords

SharePoint Server 2013 includes a predefined column named Enterprise Keywords. You can add this column to content types. When a user adds a value to the Enterprise Keywords column, the enterprise keyword control is displayed, and the user interacts with the control to enter the value. The enterprise keyword control behaves in a similar manner to the managed metadata control, except that the enterprise keyword control allows users to select enterprise keywords in addition to managed terms.

When the user starts to type a value, the control displays the terms that begin with the characters the user has typed from the keyword set and other global term sets. The term set in which the term exists, and the term's position in the hierarchy are also displayed. There is usually an option for entering a new enterprise keyword also. If the user enters a new enterprise keyword, the enterprise keyword is added to the keyword set.

By default, the Enterprise Keywords column allows for multiple values.

Example:

A conference administrator adds a new session to represent the welcome party for all attendees. The welcome party is being held at Mardi Gras World, which is an external venue. Because Mardi Gras World is not a member of the Conference rooms term set, the administrator cannot select it as the value of the Room field. However, the administrator does want to include the location so that other administrators find this session when they search for the phrase "Mardi Gras World." The administrator notices that the Session content type includes the Enterprise Keywords column, and decides to add the venue as an enterprise keyword.

The administrator starts to type the name of the venue into the enterprise keyword field. When the administrator has typed Mar, the following options are displayed:

  • Mardi Gras Ballroom [Conference rooms: Ballrooms]

  • Create new

The administrator selects Create New, and creates the enterprise keyword Mardi Gras World, which is now added to both the Enterprise Keywords column of the list item and the keyword set.

Benefits of using managed metadata

This section describes several of the benefits of using managed metadata.

More consistent use of terminology

Managed metadata makes it easier to use terms and enterprise keywords more consistently. You can pre-define terms, and allow only authorized users to add new terms. You can also prevent users from adding their own enterprise keywords to items, and require them to use existing enterprise keywords. Managed metadata also provides greater accuracy by presenting only a list of correct terms from which users can select values. Because enterprise keywords are also a type of managed metadata, even the enterprise keywords that users apply to items can be more consistent.

Because metadata is used more consistently, you can have more confidence that it is correct. When you use metadata to automate business processes—for example, putting documents in different files in the record center based on the value of their department attribute - you can be confident that the metadata was created by authorized users, and that the value of the department attribute is always one of the valid values.

Better search results

A simple search can provide more relevant results if items have consistent attributes.

As users apply managed terms and enterprise keywords to items, they are guided to terms that have already been used. In some cases, users might not even be able to enter a new value. Because users are focused on a specific set of terms, those terms - and not synonyms - are more likely to be applied to items. Searching for a managed term or an enterprise keyword is therefore likely to retrieve more relevant results.

Dynamic

In earlier versions of SharePoint Server, to restrict the value of an attribute to being one of a set of values, you would have created a column whose type is "choice," and then provided a list of valid values. When you needed to add a new value to set of choices, you would have to change every column that used the same set of values.

By using managed metadata, you can separate the set of valid values from the columns whose value must be one of the set of valid values. When you have to add a new value, you add a term to the term set, and all columns that map to that term set would use the updated set of choices.

Using terms can help you keep SharePoint items in sync with the business as the business changes. For example, assume that your company's new product had a code name early in its development, and was given an official name shortly before the product launched. You included a term for the code name in the "product" term set, and users were identifying all documents related to the product by using the term. When the product name changed, you could edit the term and change its name to the product's official name. The term is still applied to the same items, but its name is now updated.

See also

Plan terms and term sets in SharePoint Server 2013


Overview of managed metadata service applications in SharePoint Server 2013
See also

Summary: Learn about the SharePoint managed metadata service application, managed metadata connections, and permissions to access managed metadata.

Applies to: SharePoint Server 2013

The managed metadata service application makes it possible to use managed metadata and share content types across site collections and web applications.

A managed metadata service publishes a term store and, optionally, content types; a managed metadata connection consumes these. This article describes the managed metadata service and connections, and provides an example scenario for using them. Before reading this article, you should understand the concepts described in the article Overview of managed metadata in SharePoint Server 2013. To learn more about how to design your managed metadata service application topology, after you read this article, see Plan to share term sets and content types in SharePoint Server 2013.

SharePoint managed metadata services

When you enable managed metadata in your SharePoint Server 2013 application, a managed metadata service and connection are created automatically. The service identifies the database to be used as the term store, and the connection provides access to the service. When you create new managed terms, or when users add enterprise keywords, these terms are stored in the database that is specified in the managed metadata service. When you publish a managed metadata service, a URL to the service is created. Before an administrator can create a connection to the service from another web application, the administrator must know the URL of the service.

In addition to sharing managed metadata, you can also use the managed metadata service to share content types. By creating a new managed metadata service and specifying a site collection as the content type hub, you can share all content types in the site collection's content type gallery. The content type information that is shared includes columns, workflow associations, and policies.

Note:

The workflows themselves must already exist in the destination site collection. Only the association between a content type and a workflow is shared.

You can create multiple managed metadata services, and share multiple term stores and content types from multiple site collections. However, each managed metadata service must specify a different term store. When you specify a nonexistent database for the term store, a new database is created.

SharePoint managed metadata connections

To use managed metadata, a web application must have a connection to a managed metadata service. A web application can have connections to multiple services, and the services can be local to the web application or remote. When you create a managed metadata service, a connection to the service is created automatically in the same web application as the service.

After you create a connection to a managed metadata service, you can configure the following four options:

  • Default keyword location: Whether to store new enterprise keywords in the keyword set in the term store associated with this managed metadata service.

  • Default term set location: Whether to store the term sets that are created when you create new managed metadata site columns in this managed metadata service's term store.

  • Use content types: Whether to make the content types that are associated with this managed metadata service (if any) available to users of sites in this web application. This option is available only if the service has a hub defined to share content types.

  • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type: Whether to update existing instances of the changed content types in sub-sites and libraries.

If no connection is specified as the default keyword location, users cannot create new enterprise keywords. If no connection is specified as the default term set location, users can only specify an existing term set when they create a site column whose data type is managed metadata.

Important:

Within a web application, do not make more than one connection the default keyword location. Within a web application, do not define more than one connection as the default term set location.

Permissions for accessing a SharePoint managed metadata service

Three things are required to create a connection to a managed metadata service:

  • You must know the URL of the service.

  • If this will be a cross-farm connection, the farm on which the service runs and the farm on which the connection runs must have a trust relationship.

  • The service must have granted permission to the application pool account of the web application in which the connection is created.

When you create a connection from a web application to a service, the connection runs with the credentials of the web application's application pool account. Users of sites in the web application can perform different actions depending on the permission that the service grants to the application pool account. There are three levels of permission: read, restricted, and full.

The following table indicates which actions are enabled, depending on the permissions that the service grants.

Action | Read | Restricted | Full
View terms and term sets | Yes | Yes | Yes
Add existing terms and existing enterprise keywords to documents and list items | Yes | Yes | Yes
Bind columns to existing term sets | Yes | Yes | Yes
View and use content types from the content type hub (if the service provides a hub) | Yes | Yes | Yes
Add new terms to open term sets | No | Yes | Yes
Create new enterprise keywords (if the connection is configured to enable this) | No | Yes | Yes
Create local term sets (if the connection is configured to enable this) | No | Yes | Yes
Add and modify content types in the content type hub (if the service provides a hub) | No | No | Yes
Manage terms and term sets (if the user is authorized to do this) | No | No | Yes
Important:

By default, all application pool accounts that are local to the farm on which the service runs have full access to the managed metadata service. To grant an application pool account lesser permission - that is, read-only or restricted access - you must first remove or reduce the permissions of the Local farm group.

Example scenario

This example shows how a company configures its managed metadata services and connections. The company has already made the following decisions, which affect the design of the managed metadata services infrastructure:

  • There is a corporate taxonomy that is strictly controlled and is used by everyone.

  • All keywords will be stored centrally, to encourage people to reuse the same keywords.

  • Every document that is created must include values for a core set of properties. The document content type was updated to include columns for these additional properties.

  • My Sites will be located in one web application, and site collections for various team sites will be located in another web application.

The legal department also has a requirement that affects how the managed metadata services are configured. The legal department plans to represent confidential information by using term sets. These term sets must be available to users of all of the legal department's site collections, but users of other site collections may not view or use these term sets.

Design

The following figure shows how the company designs its managed metadata services infrastructure. The design is described in detail in the paragraphs that follow the figure.

Managed metadata services and connections example

The corporate managed metadata service is the primary managed metadata service for all SharePoint Server 2013 sites in the company. The corporate taxonomy is represented by global term sets in the term store that is associated with the corporate managed metadata service. The content type hub that is associated with the corporate managed metadata service makes shared content types available to users of all site collections.

Every web application has a connection to the corporate managed metadata service. The connections from the My Site web application, the team sites web application, and the legal sites web application, numbered 2, 3, and 4 in the figure, all have restricted access to the corporate managed metadata service. Restricted access lets users of the sites in these web applications use the shared content types and global term sets, add new enterprise keywords, and create local term sets, but it prohibits them from changing global term sets.

The administrative web application hosts the site collection from which authorized users manage the corporate taxonomy and the shared content types. The site collection's content type gallery contains the shared content types, such as the updated document content type that reflects the additional required properties. This content type gallery is the content type hub of the corporate managed metadata service. The connection from the administrative web application, numbered 1 in the figure, has full access to the corporate managed metadata service.

The term store that is associated with the legal department's managed metadata service contains term sets that represent confidential information that the legal department uses. Only the legal sites web application has a connection to legal's managed metadata service so that users of the site collections in the legal sites web application can manage their term sets.

Permissions

The following table summarizes the permission that each managed metadata service grants to the accounts that the connections use to access the service. Note that local farm is explicitly given reduced permission. If you do not remove or reduce the permissions for local farm, other local accounts will connect to the services by using the permissions that are specified for local farm.

Account | Corporate managed metadata service | Legal's managed metadata service
Local farm | Read permission | No permission
Administrative web application's application pool account | Full permission | No permission
My Site web application's application pool account | Restricted permission | No permission
Team sites web application's application pool account | Restricted permission | No permission
Legal sites web application's application pool account | Restricted permission | Full permission

Connection parameters

All connections to the corporate managed metadata service specify that the corporate managed metadata service is the default location to store keywords. Because the connection from the legal sites web application to the corporate managed metadata service is the default keyword location, its connection to legal's managed metadata service is not the default keyword location.

The connections from the administrative web application, the My Site web application, and the team sites web application to the corporate managed metadata service specify that the corporate managed metadata service is the place to store column-specific term sets. The connection from the legal web application to the corporate managed metadata service specifies not to store column-specific term sets. The connection from the legal web application to the legal managed metadata service specifies that it is the default location for column-specific term sets.

Note:

Either managed metadata service would be an acceptable location for column-specific term sets from the legal sites web application. Because column-specific term sets are local to the site collection from which they are created, users of other site collections cannot see them.

Security

Metadata publishing should not be enabled for any library that contains documents that might have metadata that other users should not see. By default, metadata publishing is disabled. For more information about metadata publishing, see Configure Enterprise Metadata and Keyword Settings for a list or library.

All connections to the corporate managed metadata service specify that they will use content types and that they will push down content type changes. Because legal's managed metadata service has no content type hub, the connection to legal's managed metadata service does not specify to use content types or to push-down content type changes.

The following table summarizes the connection settings for each connection to a managed metadata service. The connection numbers refer to the lines in the previous figure.

Connection | Managed metadata service | Web application | Default keyword location | Column-specific term set location | Use content types | Push-down content types
1 | Corporate managed metadata service | Administrative web application | Yes | Yes | Yes | Yes
2 | Corporate managed metadata service | My Site web application | Yes | Yes | Yes | Yes
3 | Corporate managed metadata service | Team sites web application | Yes | Yes | Yes | Yes
4 | Corporate managed metadata service | Legal sites web application | Yes | No | Yes | Yes
5 | Legal's managed metadata service | Legal sites web application | No | Yes | N/A | N/A

See also

Overview of managed metadata in SharePoint Server 2013
Plan to share term sets and content types in SharePoint Server 2013


Plan terms and term sets in SharePoint Server 2013
See also

Summary: Learn how to plan a SharePoint managed metadata taxonomy, how to determine and organize term sets, and how to define terms.

Applies to: SharePoint Server 2013

Managed metadata is a hierarchical collection of centrally managed terms that you can define, and then use as attributes for items in SharePoint Server 2013. Before reading this article, you should understand the concepts described in the article Overview of managed metadata in SharePoint Server 2013.

Managed metadata and the way that you structure it can affect many parts of a SharePoint solution, such as the following:

  • Valid values for columns, and the way users enter these values.

  • The enterprise keywords that users can apply to SharePoint items.

  • The way that search results can be refined.

  • How documents are routed.

  • The workflows that are applied to SharePoint items.

  • The ways that users can sort and filter SharePoint items.

  • If you are using social tagging, the tags that users can apply to items that are not SharePoint items.

Plan: now or later

SharePoint Server 2013 enables you to use managed metadata even if you do not define all the terms and term sets first. You can start without any term sets and merely let users add enterprise keywords to items. As the set of enterprise keywords grows, you will probably want to organize it in some way to make finding and disambiguating keywords easier. At this point, you can create term sets and move some keywords into term sets. You might also want to clean up the terms in the new term set by deleting misspelled words, or indicating that some words are synonyms of other words.

Even if you decide to use the less formal approach of starting with enterprise keywords and creating term sets later, you should understand how to plan and organize managed metadata.

About planning managed metadata

Planning and organizing managed metadata involves the following steps:

  1. Identify term sets.

  2. Identify the owner of each term set.

  3. Determine term set groups.

  4. Define term sets.

The first three tasks are often performed by a group, a solution architect, or a taxonomist. The fourth task, defining term sets, can be distributed to the owners of the term sets.

The Managed metadata planning worksheets section contains links that you can use to download worksheets in which you can record your terms and term sets.

Note:

If you rearrange several columns in the detailed term set planning worksheet, you can also use the worksheet to import a term set into SharePoint Server 2013.

This article contains guidance about how to determine the managed metadata that your organization will use. This article does not cover how to divide the metadata among term stores or where you should deploy the service applications that host the term stores. For information about how to plan your managed metadata services, such as planning where you should store enterprise keywords, see Plan to share term sets and content types in SharePoint Server 2013.

Identify term sets

As you design your solution, you will discover attributes (metadata) that should be associated with certain items in SharePoint Server. You might also implement some of your organization's governance policies by using metadata. This section provides guidelines for identifying metadata, and explains which metadata should be managed metadata. Each item of managed metadata will be represented by a term set.

First, examine your solution for information that can be represented by metadata. The following table provides suggestions about where you are likely to locate metadata.

Potential metadata | Example
Custom columns associated with documents and lists | The confidentiality of a document: public, proprietary, confidential, trade secret, and so on
In cases in which the system or a user might take different actions based on a characteristic of an item, the characteristic itself is probably metadata. | If a request that was submitted by a specific individual is automatically approved, "submitted by" could be metadata.
Common things that users will want to sort or filter items on | If users are likely to filter items by the milestone that the item is associated with, "milestone" could be metadata.
Words or phrases that users are likely to "tag" items with | The subject of an image, such as "company logo" or "product XYZ icon"
"Choice" or "Lookup" columns in an existing SharePoint Server site |

Not all metadata is managed metadata, that is, a term set. The following table provides suggestions about when the metadata that you identified is likely to be managed metadata. If it is not clear whether to create a term set for an item of metadata, it is probably best not to create a term set. Instead, monitor the keywords that users add to items, and create a term set if several keywords were created that would belong in the term set.

If the potential metadata… | … is it likely to be managed metadata?
Is something for which a user will select a valid value | Yes
Represents information that is likely to be used multiple times | Yes
Has valid values that can be organized hierarchically | Yes
Includes synonyms or abbreviations that should be aggregated | Yes
Can be applied in one language, but might be viewed in other languages | Yes
Is represented by a built-in column (such as "last modified date") | No
Has an infinite number of valid values | No
Has different valid values in each location that it is used (such as different values for the "version" attribute depending on which product team's site the item appears in) | No (or, if it is represented by managed metadata, it can be planned and managed at the site level.)
Has only "yes" and "no" as valid values | No

Record the term sets in the term sets planning worksheet, and add a brief description of each term set.

Identify term set owners

For each term set, you will have to determine an owner. The owner can then define the terms in the term set.

If the term set will be used across the organization, or if the terms in the term set will be strictly controlled, it is likely that there is already a group that manages the information. This group will probably manage the term set. If the information is not strictly controlled, you might have to nominate a person to own the term set and to periodically clean up the terms.

Record the owner of each term set in the term sets planning worksheet.

Determine term set groups

A term set group is a security boundary. Only a user who is designated a contributor to the group can manage the term sets in the group and create new term sets. However, all users can usually see all term sets. (For information about how to restrict certain users from seeing a term set, see Plan to share term sets and content types in SharePoint Server 2013.)

Organize the term sets into groups based on which users should be able to manage the term sets. If you identified one person as the owner of 25 term sets, perhaps those 25 term sets belong in a single group. If various people own a single term set each, but those people are all in the same department, this might also be a good reason to put the term sets in a single group. It is common to create groups based on the organization structure and let each organization designate a manager for the term set group. The term set group manager can then add people to the contributor role, and these people can manage the term sets that they own.

If there are term sets that some users should be unable to view, assign these term sets to separate groups. For example, if five of the term sets may only be viewed by members of the legal department, make a new term set group and include only these five term sets in the group. You will eventually create different managed metadata service instances for the public and private groups, as described in the article Plan to share term sets and content types in SharePoint Server 2013.

Define term sets

At this point, you have identified an owner for each term set. The owners can follow the rest of this process to define their term sets.

To define a term set, you must answer the following questions:

  • What are the terms in the term set?

  • How should the terms be organized?

  • Who should be permitted to add terms to the term set?

Use the guidance in the following sections to define and organize the terms, and to determine whether the term set is open or closed. Record the term sets and descriptions in the detailed term set planning worksheet.

Identify the terms

Identify the terms in the term set. If you want to allow the multiple terms to represent the same concept (for example, "XYZ version 2" and "XYZ v2" might be alternate names for the same product), include both terms. Identify one term as the primary term, and indicate that the second term is a synonym of the first term.

Organize the terms

The primary organizing principle for a term set should be ease of navigation. End users will often interact with a term set by selecting one of the terms in the term set. Therefore, you should organize the term set to make it easy for users to find the correct term without too much scrolling. This suggests a hierarchical structure.

Note:

Because you can specify a custom sort order for a term set (for example, "Wednesday" should be presented before "Thursday," even though that is not alphabetical order), you do not have to be concerned about the order in which you list the terms.

You can nest terms to a maximum of seven levels deep. Because you can declare a term to be "unavailable for tagging" (that is, a term that the user cannot select), you have flexibility in how you organize the hierarchy, as illustrated in the examples that are provided in the worksheets.

The following suggestions might help you decide how to structure a term set.

  • In a well-understood domain, there is likely to be a standard organization. For example, the terms in a term set that represented sales offices might be organized using a geographic hierarchy. The first level terms could be thought of as continents. The second level terms would then be countries. The third level terms would be provinces within each country. The fourth level terms would be the cities in which the offices were located. Because the term set represents sales offices, only the fourth level of terms would be available for tagging.

  • Are there already well known ways that information is organized in your organization? For example, does the folder structure on a file share represent the way that most people would organize information? Is the navigation structure of your intranet portal useful for finding information? You can refer to these examples of how information is currently structured as you organize your term set.

    Note:

    Think carefully before you use your organization's internal structure to organize a term set. If your company reorganized next week, would you also have to reorganize the term set? Is the benefit worth the effort?

  • If the terms in the term set are merely a list that has no clear method of organization, consider organizing them alphabetically. Make the letters of the alphabet the first-level terms, and make the terms themselves the second-level terms. If the term set is too large for that structure, you could create a second level of alphabetical organization (for example, "AA - AF", "AG - AI", "AJ - AR", and "AS - AZ"), and include the terms themselves at the third level. The terms in the levels that are merely for alphabetizing would be marked as unavailable for tagging.

Identify who can add terms

Anyone can add a new term to an open term set. Only people who were identified as contributors to a term set group can add terms to a closed term set in the group. For example, a term set that represents cost centers would probably be closed. A term set that represents contributors to a charity might be open.

Record the details of each term set in a separate copy of the detailed term set planning worksheet.

Managed metadata planning worksheets

Download an Excel version of the Term sets planning worksheet (http://go.microsoft.com/fwlink/p/?LinkId=163486&clcid=0x409).

Download an Excel version of the Detailed term set planning worksheet (http://go.microsoft.com/fwlink/p/?LinkId=163487&clcid=0x409).

See also

Overview of managed metadata in SharePoint Server 2013
Plan to share term sets and content types in SharePoint Server 2013


Plan to share term sets and content types in SharePoint Server 2013
See also

Summary: Figure out how many SharePoint managed metadata services and connections to the services you must have to meet your business requirements.

Applies to: SharePoint Server 2013

A managed metadata service publishes a term store and, optionally, content types; a managed metadata connection consumes them. To share term sets among site collections, you create a managed metadata service, and then create connections to the service from each web application that contains a site collection. To share content types among site collections, you make one content type gallery the "hub" of a managed metadata service, create connections to the service from each web application that contains a site collection, and specify that site collections should use the content types in the service.

This article contains procedures for identifying the managed metadata services and connections that your solution requires. The planning process that is described in this article is only a recommendation. There are other ways to structure your managed metadata services and connections.

Before reading this article, you should understand the concepts described in Overview of managed metadata service applications in SharePoint Server 2013 and Services architecture planning (SharePoint Server 2010).

In this article:

  • About planning managed metadata services and connections

  • Identify SharePoint managed metadata services

  • Identify SharePoint managed metadata connections

  • Determine service account permissions for SharePoint managed metadata

  • Managed metadata services planning worksheet

About planning managed metadata services and connections

Before you plan your managed metadata services and connections, you should already have identified the site collections in your solution and determined which site collections will be contained in which web applications.

The planning process that is described in this article starts with the simplest configuration - a single managed metadata service - and then directs you to add more services in certain situations. Then you determine the connections to each managed metadata service, and determine the connection parameters. If you have to have more than one managed metadata service, keep track of the services that you identify, and also a description of what each service's term store will be used for and which site collection the service's content type hub, if any, will come from. Also keep track of the connections that you identify, and the values of their connection parameters. You can record this information in the worksheets that are referenced at the end of this article.

Your organization's governance policies can affect how you design your managed metadata services and connections. For example, if there is a formal process for managing terms and term sets, this affects how you set connection parameters. If every document that is created must have a certain set of attributes, you will probably want to have a content type hub in at least one service. Familiarize yourself with your organization's governance plan before you determine the managed metadata services and connections. For more information about how to create a governance plan, see Governance overview (SharePoint Server 2010).

Identify SharePoint managed metadata services

If you intend to use terms and term sets, or if you intend to share content types across more than one site collection, your solution must use a managed metadata service. Assume for now that you will store all term sets and all enterprise keywords in a single term store. The first managed metadata service, which is named the "primary" managed metadata service in this article, contains this term store. If your solution includes shared content types, assume that a single content type gallery will contain all shared content types. This content type gallery, if it exists, is the hub of the primary managed metadata service. In many cases, the primary managed metadata service is the only managed metadata service that you will need.

A local term set is a term set that is created within the context of a site collection. For example, if you add a column to a list in a document library, and create a new term set to bind the column to, the new term set is local to the site collection that contains the document library.

A global term set is a term set that is created outside the context of a site collection. For example, the term store administrator could create a term set group that is named "Human Resources" and designate a person to manage the term set group. The group manager would create term sets that relate to Human Resources, such as job titles and pay grades in the Human Resources term set group. The keyword set, which contains enterprise keywords, is a global term set.

Users can see only global term sets and term sets that are local to the user's site collection.

A content type hub is associated with the content type gallery of a site collection. If you have to share content types from the content type galleries of multiple site collections, add a managed metadata service for each required content type hub.

Identify SharePoint managed metadata connections

Add a connection from the primary managed metadata service to every web application that contains a site collection. Use the following guidelines to determine the values of the connection's parameters.

  • Default keyword location:

    • NO, if users of sites in the web application might create an enterprise keyword that should be kept private.

    • Otherwise, YES.

  • Default column-specific term set location:

    • NO if administrators of sites in the web application should be unable to make new term sets.

    • Otherwise, YES.

  • Use content types: YES, assuming that the primary managed metadata service has a content type hub and you have no reason not to use the content types.

  • Push down content types: YES, assuming that the primary managed metadata service has a content type hub, and you have no reason not to push them down.

Any remaining managed metadata services will be used only for their content type hubs. Create a connection from every remaining managed metadata service to each web application that contains a site collection that uses the content types. Use the following guidelines to determine the values of the connection's parameters:

  • Default keyword location: NO.

  • Default column-specific term set location: NO.

  • Use content types: YES.

  • Push down content types: YES, assuming you have no reason not to push them down.

For each web application, review the values of the parameters of all connections to a managed metadata service. Check for the following conditions:

  • If no connection is specified as the default keyword location, users of sites in the web application will be unable to create new enterprise keywords. If this is not what you want, set the value of the default keyword location to YES in the connection to the managed metadata service whose term store should contain the new enterprise keywords.

  • If no connection is specified as the default column-specific term set location, administrators of sites in the web application will be unable to create new term sets when they create a managed metadata column. If this is not what you want, set the value of the default column-specific term set location to YES in the connection to the managed metadata service whose term store should contain the new term sets.

  • Ensure that there is a maximum of one default keyword location per web application. The managed metadata service does not support more than one default keyword location per web application.

  • Ensure that there is a maximum of one default column-specific term set location per web application. The managed metadata service does not support more than one default column-specific term set location per web application.

Determine service account permissions for SharePoint managed metadata

When you create a connection from a web application to a service, the connection runs with the credentials of web application's application pool account. Users of sites in the web application can perform different actions depending on the permission that the service grants to the application pool account. There are three levels of permission: read, restricted, and full.

The following table indicates which actions are enabled, depending on the permissions that the service grants.

Action | Read | Restricted | Full
View terms and term sets | Yes | Yes | Yes
Add existing terms and existing enterprise keywords to documents and list items | Yes | Yes | Yes
Bind columns to existing term sets | Yes | Yes | Yes
View and use content types from the content type hub (if the service provides a hub)View terms and term sets | Yes | Yes | Yes
Add new terms to open term sets |  | Yes | Yes
Create new enterprise keywords (if the connection is configured to enable this) |  | Yes | Yes
Create local term sets (if the connection is configured to enable this) |  | Yes | Yes
Add and modify content types in the content type hub (if the service provides a hub) |  |  | Yes
Manage terms and term sets (if the user is authorized to do this) |  |  | Yes

By default, all application pool accounts that are local to the farm on which the service runs have full access to the term store.

Use the following procedure to determine the permissions that each service will grant to each connection. Complete the planning steps one time for each managed metadata service.

  1. Determine the level of permission that you want to grant automatically to all connections from inside the local farm. Record the permission level in the Local Farm permissions column of the services page of the worksheet.

  2. If any connections from inside the local farm must have greater permissions than you granted to the Local Farm group, record the permission level in the permissions column of the connections tab of the worksheet.

  3. If web applications on remote farms will connect to the service, record the permission level of each remote connection in the permissions column of the connections tab of the worksheet.

Managed metadata services planning worksheet

Download an Excel version of the Managed metadata services planning worksheet (http://go.microsoft.com/fwlink/p/?LinkId=164578).

See also

Overview of managed metadata service applications in SharePoint Server 2013
Overview of managed metadata in SharePoint Server 2013

Governance overview (SharePoint Server 2010)
Services architecture planning (SharePoint Server 2010)


Plan for business intelligence in SharePoint Server 2013

Summary: Learn about specific software requirements for BI applications and what you can do with Excel Services in SharePoint Server 2013 and Visio Services in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Business intelligence applications and tools enable you to organize your vision of organizational goals, processes, and performance requirements in a useful manner, and to present that data as meaningful information.

TechNet articles about business intelligence planning

The following articles about planning for business intelligence in SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Software requirements for business intelligence in SharePoint Server 2013 | Learn about the minimum software requirements to run Business Intelligence features in SharePoint Server 2013.
Building blocks | Overview of Excel Services in SharePoint Server 2013 | Excel 2013 is designed to help you analyze business data and increase business intelligence. Excel Services in SharePoint Server 2013 is a SharePoint Server shared service that you can use to publish Excel 2013 workbooks on SharePoint Server.
Building blocks | PerformancePoint Services in SharePoint Server 2013 overview | Learn about PerformancePoint Services in SharePoint Server 2013.
Checklist icon (not checked) | Plan for Visio Services in SharePoint Server 2013 | This section describes planning considerations for Visio Services in SharePoint Server 2013.
Building blocks | Overview of PerformancePoint strategy maps in SharePoint Server 2013 | Learn about strategy maps in Dashboard Designer.


Software requirements for business intelligence in SharePoint Server 2013
See also

Summary: Learn about the minimum software requirements to run business intelligence features in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The business intelligence tools for SharePoint Server 2013 include Power View for SharePoint, SQL Server 2012 Reporting Services for SharePoint, Power Pivot for SharePoint, Excel Services, PerformancePoint Services, and Visio Services.

Software requirements for Power Pivot for SharePoint 2013

The requirements for Power Pivot for SharePoint 2013 are as follows:

  • SQL Server 2012 SP1: To be able to use the new Excel 2013 features such as advanced data models on SharePoint Server 2013, an instance of SQL Server 2012 SP1 CTP3 Analysis Services must be installed in SharePoint deployment mode.

  • Excel Services must be configured on the farm and at least one Analysis Services server in SharePoint mode must be registered in the Excel Services configuration. Excel Services in SharePoint Server 2013 can use multiple Analysis Services servers, but they must all be SQL 2012 SP1 CTP 3.

  • Secure Store must be configured on the farm if you want to configure scheduled data refresh of PowerPivot workbooks.

Important:

For SharePoint Server 2013, Power Pivot for SharePoint 2013 must be installed from either SQL Server 2012 SP1 CTP3 setup or the SQL Server 2012 SP1 CTP3 Feature Pack web page.

Software requirements for Reporting Services on SharePoint Server 2013

The requirements to run Power View, start Report Builder from SharePoint and view Reporting Services reports on SharePoint Server 2013 are as follows:

  • SQL Server 2012 SP1: To be able to start Report Builder from SharePoint Server 2013 and for viewing Reporting Services reports from SharePoint Server 2013, an instance of SQL Server 2012 SP1 CTP3 Reporting Services must be installed in SharePoint deployment mode.

  • To view Power View sheets in Excel 2013 workbooks on SharePoint Server 2013, Excel Services must be configured on the farm and at least one Analysis Services server in SharePoint mode must be registered in the Excel Services configuration. Excel Services in SharePoint Server 2013 can use multiple Analysis Services servers, but they must all be SQL 2012 SP1 CTP 3.

Note:

The Report Viewer component is no longer needed. The SQL Server 2012 SP1 CTP3 Reporting Services in SharePoint deployment mode includes all of the web-front-end components required.

Software requirements for Excel Services in SharePoint Server 2013

The requirements for Excel Services for SharePoint Server 2013 are as follows:

  • If you plan to use Excel Services with advanced data models, at least one Analysis Server in SharePoint mode must be registered in the Excel Services configuration. Excel Services can use multiple Analysis Services servers, but they must all be SQL 2012 SP1 CTP 3.

  • The Secure Store Service must be configured in the farm if you want to store encrypted credentials for data refresh scenarios, or if you want to use the Excel Services unattended service account. For more information, see Plan the Secure Store Service in SharePoint Server 2013.

  • Kerberos constrained delegation must be configured if you want to delegate user credentials to an external data source for data refresh scenarios.

Note:

For Analysis Services data, the EffectiveUserName option is an alternative method of accessing data. When it is enabled, all connections to Analysis Services data for individual users will be made by using the EffectiveUserName connection string property instead of Windows delegation. For more information, see Use Analysis Services EffectiveUserName in SharePoint Server 2013.

For information about planning for Excel Services, see Overview of Excel Services in SharePoint Server 2013. For information about configuring Excel Services, see Configure Excel Services in SharePoint Server 2013.

Software requirements for PerformancePoint Services in SharePoint Server 2013

The requirements for PerformancePoint Services in SharePoint Server 2013 are as follows:

  • ADOMD.net V11

  • Secure Store must be configured in the farm if you want to store encrypted credentials for data refresh scenarios, or if you want to use the PerformancePoint Services unattended service account. For more information, see Plan the Secure Store Service in SharePoint Server 2013.

  • Kerberos constrained delegation must be configured if you want to delegate user credentials to an external data source for data refresh scenarios.

Note:

For Analysis Services data, the EffectiveUserName option is an alternative method of accessing data. When enabled, all connections to Analysis Services data for individual users will be made using the EffectiveUserName connection string property instead of Windows delegation.

Note:

ADOMD.net V11 is not installed as part of the SharePoint Server 2013 prerequisite installer tool. However, if you are installing the SQL Server 2012 Reporting Services SQL Server 2012 Reporting Services in SharePoint Server 2013 mode on your application server, this file is included.

For information about how to plan for PerformancePoint Services, see PerformancePoint Services in SharePoint Server 2013 overview. For information about how to configure PerformancePoint Services, see Configure PerformancePoint Services (SharePoint Server 2013).

Software requirements for Visio Services in SharePoint Server 2013

The requirements for Visio Services in SharePoint Server 2013 are as follows:

  • Secure Store must be configured in the farm if you want to store encrypted credentials for data refresh scenarios, or if you want to use the Visio Services unattended service account. For more information, see Plan the Secure Store Service in SharePoint Server 2013.

  • Kerberos constrained delegation must be configured if you want to delegate user credentials to an external data source for data refresh scenarios.

For information about how to plan for Visio Services, see Overview of Visio Services in SharePoint Server 2013. For information about how to configure Visio Services, see Create a Visio Graphics Service service application in SharePoint Server 2013.

See also

SQL 2012 SP1 Installation
SQL 2012 SP1 CTP Release Notes


Overview of Excel Services in SharePoint Server 2013
See also

Summary: Excel Services is a business intelligence tool that allows you to share data-connected workbooks across an organization.

Applies to: SharePoint Server 2013

Excel Services in SharePoint Server 2013 is a shared service that you can use to publish Excel 2013 workbooks on SharePoint Server. The published workbooks can be managed and secured according to your organizational needs and shared among SharePoint Server 2013 users, who can render the workbooks in a browser. Excel Services was introduced in Office SharePoint Server 2007 and is available only in the Enterprise edition of SharePoint Server 2013.

Excel Services is used primarily for business intelligence scenarios. Excel workbooks can be connected to external data sources, reports created, and then the workbook can be published to a SharePoint document library. When a user opens the workbook from the the document library, it is rendered in the browser by using Excel Services. The external data connection is maintained and the data is refreshed if necessary. This allows broad sharing of reports throughout an organization.

Excel Services consists of Excel Calculation Services, the Excel Web Access Web Part, and Excel Web Services for programmatic access. It supports sharing, securing, managing, and using Excel 2013 workbooks in a browser by providing the following:

  • Global settings for managing workbooks, which include settings for security, load balancing, session management, memory utilization, workbook caches, and external data connections.

  • Trusted file locations (which allow you to define which document libraries are trusted by Excel Services) together with session management, workbook size, calculation behavior, and external data settings of workbooks stored in those locations.

  • An extensive list of trusted data providers for connecting to your data, plus the ability to add your own trusted data provider.

  • Trusted data connection libraries, which allow you to define which data connection libraries in your farm are trusted by Excel Services.

  • The ability to add your own user-defined function assemblies.

While users can interact with Excel workbooks in a browser through Excel Services, the workbooks cannot be edited in the browser by using Excel Services. Programmatic options are available.

Looking at several specific scenarios can help you understand how best to take advantage of Excel Services:

  • Sharing workbooks Users can save Excel 2013 workbooks to a SharePoint Server document library to give other users browser-based access to the server-calculated version of the workbook. When the workbook is accessed, Excel Services loads the workbook, refreshes the external data if it is necessary, calculates it if it is necessary, and sends the resulting output view back through the browser. A user can interact with Excel-based data by sorting, filtering, expanding, or collapsing PivotTables, and by passing in parameters. This provides the ability to perform analysis on published workbooks. A user does not have to have Excel 2013 installed to view the workbook. Users will always view the latest version of a workbook, and they can interact with it in a browser. Security permissions can be set to limit what access is provided to which user.

  • Building business intelligence (BI) dashboards Browser-based dashboards can be created by using Excel and Excel Services together with the Excel Web Access Web Part. PerformancePoint Services can also use Excel Services workbooks as a data source.

  • Reuse of logic encapsulated in Excel workbooks in custom applications Besides a browser-based interface with the server, Excel Services provides a Web-service-based interface so that a published workbook can be accessed programmatically by any application that uses Web services. The Web service applications can change values, calculate the workbook, and retrieve some or all of the updated workbook by using that interface according to what security permissions are set for the published workbook.

  • Report Building One of the most useful features of Excel Services is report building. By publishing data-connected workbooks to a SharePoint document library and making them available through Excel Services, you can make reports that you have created in Excel available to others in your organization. Instead of multiple users having separate copies of the workbooks on their computers, the workbooks can be created and changed by a trusted author in a central location that is trusted by Excel Services. The correct version of the worksheet is easier to find, share, and use from Excel, SharePoint Server, and other applications.

Farms using Office Web Apps Server

If your SharePoint Server farm has been integrated with Office Web Apps Server and Excel Web App, the features available in Excel Services will depend on how Excel Web App has been configured.

Excel Web App runs in one of two modes:

  • SharePoint view mode In this mode, Excel Services is used to view workbooks in the browser.

  • Office Web Apps Server view mode In this mode, Excel Web App is used to view workbooks in the browser.

The following table lists the business intelligence features available in Excel Services in each mode.

BI features in Excel Services, by mode

 | SharePoint Server only | SharePoint Server with Excel Web App (SharePoint view mode) | SharePoint Server with Excel Web App (Office Web Apps Server view mode)
Excel Web Access Web Part | × | × |
Refresh OData connections | × | × |
View and interact with Power View reports | × | × |
View and interact with Power Pivot data models | × | × |
Refresh Power Pivot data models | × | × |
Refresh data by using the Excel Services unattended service account | × | × |
Refresh data by using Secure Store and Windows credentials | × | × | ×
Refresh data by using Effective User Name connections | × | × |
Kerberos delegation | × | × |

See also

Administer Excel Services in SharePoint Server 2013
BI capabilities in Excel and Excel Services (SharePoint Server 2013)


BI capabilities in Excel and Excel Services (SharePoint Server 2013)
See also

Updated: April 23, 2013

Summary: Excel 2013 offers a wide range of business intelligence capabilities. Learn which capabilities are supported in Excel Services (on premises).

Applies to: SharePoint Server 2013

Excel 2013 offers certain business intelligence capabilities that make it easier than ever to explore and analyze data. Many of these features are supported by Excel Services. Read this article to learn about which capabilities in Excel 2013 are supported in SharePoint Server 2013 and Office Web Apps Server.

Important:

The information in this article applies to on-premises deployments of SharePoint Server 2013. If you're looking for information about business intelligence in Office 365, see Business intelligence capabilities in Excel and SharePoint Online.

In this article:

  • Business intelligence capabilities in Excel 2013

  • Business intelligence capabilities supported in Excel Services in SharePoint Server

  • Business intelligence capabilities supported in Office Web Apps Server 2013 and SharePoint Server 2013

Business intelligence capabilities in Excel 2013

Using Excel 2013, you can create powerful reports, scorecards, and dashboards. You can bring data into Excel, sort, and organize data, and use it to create reports and scorecards. You can also use powerful analytic capabilities in Excel to visualize and explore data. The following table describes business intelligence features in Excel.

Table: Overview of business intelligence capabilities in Excel 2013

Task area Capability Description

Get data

Native data

Native data is data that was imported into Excel and lives in Excel without maintaining an external data connection. This is useful for working with static data, working with data that is updated manually, and creating workbooks that are published in locations where external data connections are not supported.

Get data

External data

External data is data that resides on another computer and is accessed in Excel through one or more external data connections. Excel 2013 can connect to many kinds of data sources.

Work with data

Data Models

A Data Model is a dataset that consists of multiple tables. You can use Data Models to bring together data from different databases and create relationships between tables of data. You can use a Data Model as a source for reports, scorecards, and dashboards. For more information, see PowerPivot: Powerful data analysis and data modeling in Excel.

Work with data

Flash Fill

Flash Fill is functionality that enables you to quickly and easily format data that is displayed in a table in Excel. For example, suppose that you have imported data into Excel and you have a column that lists dates and times, and you only want to use dates. You can insert a new column, type the date that corresponds to the first item in the format that you want to use, and then use Flash Fill to automatically do this for all the rows in your table.

Create reports

Quick Analysis

Quick Analysis is functionality that enables you to select a range of data and see recommended ways to visualize that information. When you use Quick Analysis, you can see what your chart or table will resemble before actually selecting which chart type to use.

Create reports

Reports

Reports can include tables, line charts, bar charts, scatter plots, radar charts, and many other kinds of charts. You can use Excel to create powerful, interactive PivotChart reports and PivotTable reports to display relevant information by using lots of data sources.

Create reports

Scorecards

Scorecards are a special kind of report designed to show whether performance is on- or off-target for one or more metrics at a glance. Scorecards typically contain one or more key performance indicators (KPIs) that compare actual values to target values and use a graphical indicator, such as colors or symbols, to show performance at a glance.

In Excel, you can use KPIs that were defined in an external database or use Power Pivot to create your own KPIs.

Create reports

Power View

Power View is an add-in for Excel that you can use to create highly interactive views. Power View enables you to quickly and easily create reports, scorecards, and dashboards. You can configure connections between items in a view so that values in one report can be used as parameters for other reports in the view. For more information about Power View, see Power View: Explore, visualize, and present your data.

Create or edit reports

Field List and Field Well

When you create a PivotChart or PivotTable report, you use the Fields section to specify what information to display in the reports. The Fields section contains the Field List and Field Well.

  • The Field List lists items such as dimensions and members from the data source that you are using for the PivotChart or PivotTable report. You can also use the Field List to determine whether you are using native data or external data.

  • The Field Well shows which items from the Field List are displayed in the report. You can change what information is displayed in a PivotChart or PivotTable report by selecting (or clearing) different items and measures.

Apply filters

Timeline control

The Timeline control is a special kind of time filter that you can use in Excel. To add a timeline control to a worksheet, at least one report on the worksheet must use data that contains a calendar date/time hierarchy. You can use the timeline control to select a single time period or a range of time, and any reports that are connected to the timeline are automatically updated to show information for that time period.

Apply filters

Slicers

Slicers are a kind of filter that you can use to select one or more items to use as a filter for reports and scorecards in a worksheet. For example, suppose that you want to see sales information for different colors of items, such as shirts that your company carries. You can create a slicer that lists shirt colors, connect it to a sales report, and then use the slicer to view sales information for the colors that are selected in the slicer.

Explore and analyze data

Quick Explore

Quick Explore is functionality that enables you to click a value in a PivotChart or PivotTable report that uses SQL Server Analysis Services data or Power Pivot data, and then see additional information about that value displayed as a chart type. You can also use Quick Explore to drill up (or down) to view higher (or lower) levels of detail in a PivotChart or PivotTable report.

Use advanced analytic capabilities

Calculated Members and Calculated Measures

Calculated Members and Calculated Measures are items that you can define by using Multidimensional Expressions (MDX) queries in Excel 2013. You can create calculated members and calculated measures for PivotChart or PivotTable reports that use multidimensional data that is stored in Analysis Services.

Important:

Calculated Members and Calculated Measures are not the same things as Calculated Fields. You can only create Calculated Members and Calculated Measures when you have created a PivotTable report or a PivotChart report that uses data that is stored in Analysis Services. To create calculated members or calculated measures, you should be familiar with the database that you are using and be proficient in writing MDX queries.

Use advanced analytic capabilities

Calculated Fields

Calculated Fields enable you to change a Data Model that was created by using Power Pivot. When you create Calculated Fields, custom columns are added to the Data Model. You can then use those columns in reports that you create using that Data Model.

Note:

To create calculated fields, you should be familiar with the database that you are using and be proficient in writing Data Analysis Expressions (DAX). For more information about DAX, see Data Analysis Expressions (DAX) Overview.

Business intelligence capabilities supported in Excel Services in SharePoint Server

After you have created reports, scorecards, and dashboards using Excel, you can publish those items to SharePoint Server to make them available to people in your organization. The following table summarizes which business intelligence features are supported by Excel Services (on premises).

Table: Overview of business intelligence capabilities in Excel Services

Item | Supported in Excel Services in the on-premises version of SharePoint Server?
External data connections | Most external data connections are supported in Excel Services. Excel Services supports SQL Server Analysis Services (SSAS), SQL Server databases, and OLE DB and ODBC data sources. For more information, see Data authentication for Excel Services in SharePoint Server 2013.
Data Models | Data Models are supported in Excel Services as long as an instance of SQL Server Analysis Services is specified for Excel Services. For more information, see Plan Excel Services Data Model settings in SharePoint Server 2013.
Flash Fill | Flash Fill is not supported when you view a workbook in a browser window. You can edit a workbook in Excel to use Flash Fill.
Quick Analysis | Quick Analysis is not supported when you view a workbook in a browser window. You can edit a workbook in Excel to use Quick Analysis.
Reports and scorecards | Reports, scorecards, and dashboards that were created by using Excel are supported in Excel Services. You can view, sort, filter, and interact with PivotTable reports and PivotChart reports in a browser window much such as you would by using the Excel client. This includes views that were created by using Power View.
Field List and Field Well (for PivotChart and PivotTable reports) | The ability to open and use the Field List and Field Well in a browser window is supported in Excel Services.
Timeline control | The ability to use an existing timeline control is supported in Excel Services. However, to add a timeline control to a workbook, you must use the Excel client.
Slicers | The ability to use existing slicers is supported in Excel Services. However, to add slicers to a workbook, you must use the Excel client.
Quick Explore | The ability to use Quick Explore is supported in Excel Services. You can use Quick Explore to drill up and down to view higher or lower levels of information. However, you can't create new views using Quick Explore in a browser window.
Calculated Members and Calculated Measures | The ability to use existing calculated members and calculated measures is supported in Excel Services. However, to create calculated members and calculated measures, you must use the Excel client.
Calculated Fields | The ability to use existing calculated fields is supported in Excel Services. However, to create calculated fields, you must use Power Pivot for Excel.
Business Intelligence Center | A Business Intelligence Center site template is available in SharePoint Server. This enables you to create a site that serves as a central location to store business intelligence content, such as reports, scorecards, and dashboards. For more information, see Configure a Business Intelligence Center in SharePoint Server 2013.
Excel Web Access Web Part | An Excel Web Access Web Part is available in SharePoint Server. This enables you to display all or part of an Excel workbook that was published to SharePoint Server. For more information about how to use the Excel Web Access Web Part, see Display Excel content in an Excel Web Access Web Part.

Business intelligence capabilities supported in Office Web Apps Server 2013 and SharePoint Server 2013

Office Web Apps Server is the online companion to Office Word, Excel, PowerPoint, and OneNote applications. Office Web Apps Server gives users a browser-based viewing and editing experience by providing a representation of an Office document in the browser. Organizations that have SharePoint Server 2013 might also be using Office Web Apps Server, and that has certain implications for which business intelligence capabilities are supported in a browser window.

Important:

If your organization is using Office Web Apps Server together with SharePoint Server 2013, then your organization can use either Office Web Apps Server or SharePoint Server to display workbooks. This decision affects which business intelligence capabilities are supported in a browser window.

To enable people to interact with workbooks that contain a Data Model or Power View views in a browser window, configure Excel Services in SharePoint Server to display workbooks. This requires a SharePoint administrator to run the New-SPWOPISupressionSetting cmdlet on the server where SharePoint Server in installed. For more information, see New-SPWOPISuppressionSetting.

The following table summarizes the business intelligence features that are supported by Office Web Apps Server and by SharePoint Server.

Table: Overview of business intelligence capabilities in Office Web Apps Server and SharePoint Server

Excel Capability What's supported when Office Web Apps Server is used to display workbooks What's supported when SharePoint Server 2013 is used to display workbooks

External data connections and authentication methods

Office Web Apps Server supports some, but not all, kinds of secure external data connections. Data connections that use Secure Store Service or an unattended service account are supported as long as SharePoint Server 2013 is configured to use these methods.

SharePoint Server 2013 supports most kinds of external data connections. These include SQL Server Analysis Services (SSAS), SQL Server databases, and OLE DB and ODBC data sources.

For more information about authentication methods, see Data authentication for Excel Services in SharePoint Server 2013.

Data Models

Office Web Apps Server enables you to view workbooks that contain Data Models that use native data. However, you can't explore data in items such as PivotTable reports, PivotChart reports, and timeline controls that use a Data Model as the data source.

SharePoint Server 2013 enables you to view, interact with, and refresh workbooks that contain Data Models using native or external data. This includes the ability to explore data in PivotChart reports and PivotTable reports and to use timeline controls in a browser window.

Flash Fill

Office Web Apps Server does not support using Flash Fill when you edit a workbook in a browser window. However, you can open the workbook in Excel to use Flash Fill.

SharePoint Server 2013 does not support Flash Fill when you view a workbook in a browser window. However, you can open the workbook in Excel to use Flash Fill.

Quick Analysis

Office Web Apps Server does not support using Quick Analysis when you edit a workbook in a browser window. However, you can use open the workbook in Excel to use Quick Analysis.

SharePoint Server 2013 does not support Quick Analysis when you view a workbook in a browser window.

Reports and scorecards

Office Web Apps Server enables you to view, sort, and filter reports, scorecards, and dashboards that were created by using Excel. However, Office Web Apps Server does not support views that were created by using Power View.

SharePoint Server 2013 enables you to view, sort, and filter reports, scorecards, and dashboards that were created by using Excel. This includes views that were created by using Power View.

Field List and Field Well (for PivotChart and PivotTable reports)

Office Web Apps Server enables you to open and use the Field List and Field Well in a browser window.

SharePoint Server 2013 enables you to open and use the Field List and Field Well in a browser window.

Timeline control

Office Web Apps Server enables you to use an existing timeline control. To add a timeline control to a workbook you must use the Excel client.

SharePoint Server 2013 enables you to use an existing timeline control. To add a timeline control to a workbook you must use the Excel client.

Slicers

Office Web Apps Server enables you to use slicers.

SharePoint Server 2013 enables you to use slicers.

Quick Explore

Office Web Apps Server enables you to use Quick Explore.

SharePoint Server 2013 enables you to use Quick Explore.

Calculated Members and Calculated Measures

Office Web Apps Server supports workbooks that contain calculated members and calculated measures. However, to create calculated members and calculated measures, you must use the Excel client.

SharePoint Server 2013 enables you to use existing calculated members and calculated measures. However, to create calculated members and calculated measures, you must use the Excel client.

Calculated Fields

Office Web Apps Server does not support calculated fields.

SharePoint Server 2013 enables you to use existing calculated fields. However, to create calculated fields, you must use Power Pivot for Excel.

Business Intelligence Center

You can use the Business Intelligence Center site template to create a central location to store business intelligence content, such as reports, scorecards, and dashboards. For more information, see Configure a Business Intelligence Center in SharePoint Server 2013.

You can use the Business Intelligence Center site template to create a central location to store business intelligence content, such as reports, scorecards, and dashboards. For more information, see Configure a Business Intelligence Center in SharePoint Server 2013.

Excel Web Access Web Part

The Excel Web Access Web Part that is available in SharePoint Server enables you to display all or part of an Excel workbook that was published to a SharePoint library in a Web Part on a SharePoint page. Even if Office Web Apps Server is used to display workbooks in a browser window, the Excel Web Access Web Part uses Excel Services in SharePoint Server to display content in that Web Part.

For more information about how to use the Excel Web Access Web Part, see Display Excel content in an Excel Web Access Web Part.

The Excel Web Access Web Part that is available in SharePoint Server enables you to display all or part of an Excel workbook that was published to a SharePoint library in a Web Part on a SharePoint page.

For more information about how to use the Excel Web Access Web Part, see Display Excel content in an Excel Web Access Web Part.

To learn more about Office Web Apps Server, see Overview of Office Web Apps Server .

See also

What's new in business intelligence in SharePoint Server 2013
Overview of Excel Services in SharePoint Server 2013

Office Web Apps
Business intelligence capabilities in Excel and SharePoint Online

Change History

Date | Description
April 23, 2013 | Removed sections about Office 365 and SkyDrive and put them in the article "Business intelligence capabilities in Excel and SharePoint Online"
July 16, 2012 | Initial publication


Data authentication for Excel Services in SharePoint Server 2013

Summary Learn how Excel Services supports connections with SQL Server Analysis Services (SSAS), SQL Server databases, and OLE DB and ODBC data sources.

Applies to: SharePoint Server 2013

Retrieving data from a data source requires a user to be authenticated by the data source and then authorized to access the data that is contained therein. In the case of a workbook, Excel Services authenticates to the data source on behalf of the user who is viewing it in order to refresh the data to which the workbook is connected.

Which authentication method Excel Services can use to retrieve data depends on the type of the underlying data source, as outlined in the following table. For data sources that support more than one authentication method, data connections must specify which one to use.

Data sources and authentication methods for Excel Services

Data source Authentication method

Analysis Services

  • Windows authentication (integrated security)

    • using Constrained Kerberos Delegation

    • using Secure Store

    • using the Unattended Service Account

  • using the EffectiveUserName connection string property

SQL Server

One of:

  • Windows authentication (integrated security)

    • using Constrained Kerberos Delegation

    • using Secure Store

    • using the Unattended Service Account

  • SQL Server Authentication

Custom data providers

Varies per data source, typically a user-name and password pair stored in the connection string.

Custom data providers can also be used.

The following data sources are supported in Excel but not in Excel Services:

  • Access databases

  • Web content

  • XML data

  • Windows Azure Marketplace

  • Text files

Connecting to external data with Excel Services

Excel Services can connect to various external data sources, including SQL Server, Analysis Services, and custom OLE DB/ODBC data providers. To connect to the data source, Excel Services uses a specific data provider for each data source.

As a security measure, Excel Services must explicitly trust data providers before they can be used. Trusted data providers can be configured as part of the Excel Services service application settings in the SharePoint Central Administration website.

Connecting to a SQL Server data source can be done by using either:

  • Windows authentication

  • SQL Server Authentication

Connecting to an Analysis Services data source is done by using Windows authentication.

Other data sources use a connection string usually consisting of a user name and password.

Data connections for Excel Services workbooks

Excel Services workbooks use one of two kinds of connections:

  • Embedded connections

  • Linked connections

Embedded connections are stored as part of the Excel Services workbook. Linked connections are stored externally to a workbook in Office Data Connection (ODC) files. To use a linked connection, a workbook must reference an .odc file that is also stored in the same farm as the workbook, in a trusted data connection library. Each data connection consists of:

  • A connection string

  • A query string

  • An authentication method

  • Optionally, some metadata required to retrieve external data

Each kind of connection has its advantages and drawbacks discussed here. Choose the one that best suits your scenario.

Comparison of data connections for Excel Services

Connection type Embedded connections ODC files

Advantages

  • All connection information is stored in the workbook.

  • Embedded connections require little administrative overhead to support.

  • Embedded connections are easy to create.

  • Linked connections can be centrally stored, managed, audited, shared and access to them controlled by using a data connection library.

  • Workbook authors can use existing connections without having to create queries and connection strings.

  • If the data connection details for a data source change, an administrator only need update one ODC file. With that change, all workbooks that refer to the ODC file will use the updated connection information when the next refresh occurs. (An example of this scenario is when the database server is moved or the database name is changed.)

Drawbacks

  • If the data connection details for a data source change, all workbooks with embedded connections to that data source will have to be republished with updated connection information.

  • Embedded data connections are more difficult to audit by SharePoint administrators.

  • Linked connections may require the help of a SharePoint administrator to share, manage and secure.

  • Linked connections are saved in clear text and may contain database passwords. Extra care must be taken to help secure these files.

Choose a linked data connection, by using an ODC file, for scenarios in which you must have a data connection to an enterprise-scale data source such as SQL Server or Analysis Services. Linked data connections are most useful in scenarios in which they will be shared across many users and in which administrator control of the connection is important.

Note:

ODC files must first be created in Excel and exported to SharePoint Server before it can be used with Excel Services.

Choose an embedded connection for scenarios where you need a data connection that will not be widely used.

ODC files must be stored in a trusted data connection library. Centralizing data connections in such a document library has several advantages:

  • Administrators can restrict write access to a data connection library to trusted data connection authors to ensure that only well tested and secure data connections are used by workbook authors.

  • Administrators have a single location to manage data connections for a large group of users.

  • Administrators can easily approve, audit, revert and manage data connection files by using document library versioning and workflow features.

  • Data connection libraries can be reused across other Office applications such as Visio, Visio Services, InfoPath 2013, InfoPath Forms Services, and Word.

  • Workbook authors only have a single location to find workbook data connections, reducing confusion and user training.

For information about how to create data connection libraries, see How to: Create and Use a Data Connection Library (http://go.microsoft.com/fwlink/p/?LinkID=188117). For information about how to create ODC files, see Create, edit, and manage connections to external data (http://go.microsoft.com/fwlink/p/?LinkID=196894).

Windows authentication

Windows authentication requires that Excel Services present to the data source a set of Windows credentials. This kind of credential is common on Windows networks and is the same credential used to log on to computers on a Windows domain or to connect to a computer that is running Exchange Server. Windows credentials are considered the most secure and manageable means of controlling access to SQL Server databases. However, one obstacle to using Windows authentication with Excel Services is the Windows double hop security measure, wherein a user's credentials cannot be passed across more than one computer in a Windows network. Given that Excel Services is a multi-tiered system, special authentication methods are required for Excel Services to retrieve data on behalf of the end-user.

Diagram of credentials being passed to server

The authentication method to choose depends on various factors as outlined in the following table. Choose the one that best suits your scenario.

Comparison of authentication methods

Authentication method

Kerberos delegation

Secure Store

Unattended Service Account

Effective User Name

Description

Using constrained Kerberos delegation, the workbook viewer's Windows credentials are sent to the data source directly.

Using the Secure Store Service, the viewer's Windows credentials are mapped to another set of credentials specified in a Secure Store target application.

Using the Secure Store Service, all viewers are mapped to a unique set of credentials called the Unattended Service Account that is stored in a specific Secure Store target application specified in Excel Services Global Settings.

Using the EffectiveUserName Global Setting, the user's domain user name is passed to Analysis Services data sources.

Data connection credentials

The Windows credentials of the workbook viewer.

The credentials specified in the Secure Store target application.

The credentials of the Unattended Service Account.

The credentials of the Excel Services process identity.

Advantages

  • The Kerberos protocol is an industry standard in credentials management.

  • Kerberos ties into the existing Active Directory infrastructure.

  • Kerberos delegation permits auditing of individual accesses to a data source.

  • Given that the workbook viewer's identity is known, workbook creators can embed personalized database queries into workbooks.

  • The Secure Store Service is part of SharePoint Server and is easier to configure than Kerberos.

  • Mappings are flexible: a user can be mapped either 1-to-1 or many-to-1.

  • Non-Windows credentials can be used to connect to data sources that do not accept Windows credentials. (Requires the Unattended Service Account to be configured also.)

  • Mappings created for Excel Services can be re-used by other business intelligence applications such as Visio Services.

  • The Unattended Service Account is easy to deploy and setup.

  • The Unattended Service Account does not require much administrative overhead.

  • Per-user data security without the need to configure Kerberos delegation.

  • Minimal configuration and administrative overhead.

Drawbacks

  • Additional administrative effort required to configure SharePoint Server and Excel Services.

  • Establishing and managing mapping tables requires some administrative overhead.

  • Secure Store permits limited auditing. In the many-to-1 scenario, individual incoming users are mapped into the same credentials through a target application, effectively blending them into one user.

  • Given that everyone is mapped to the same credentials, an administrator cannot distinguish who accessed a data source.

  • Only works with Analysis Services data sources.

For the authentication operation to succeed …

  • Kerberos delegation must be set up on the SharePoint Server.

  • The Secure Store Service must be provisioned and configured on the farm. It must also contain appropriate mapping information for a particular incoming user. Additionally the mapping information may need to be updated periodically to reflect password changes on the mapped account.

  • The Secure Store Service must be provisioned and configured on the farm. It must also contain the credentials for the Unattended Service Account. Additionally the mapping information may need to be updated periodically to reflect password changes on the mapped account.

  • Excel Services Global Settings must be configured to use the Unattended Service Account.

  • The EffectiveUserName option must be enabled in Excel Services Global Settings.

  • The user must be a member of the appropriate Analysis Services role.

Kerberos delegation

Choose Kerberos delegation for secure and fast authentication to enterprise-scale relational data sources that support Windows authentication. For information about configuring Kerberos delegation, see:

  • Configuring Kerberos Authentication for Microsoft SharePoint 2010 Products (http://go.microsoft.com/fwlink/p/?LinkId=196600)

  • Plan for Kerberos authentication in SharePoint 2013

Secure Store

Choose Secure Store for authentication to enterprise-scale relational data sources that may or may not support Windows Authentication. Secure Store is also useful in scenarios in which you want to control user credential mappings.

For information about using Secure Store with Excel Services, see Use Excel Services with Secure Store Service in SharePoint Server 2013.

Unattended service account

For ease of configuration Excel Services provides a special configuration where an administrator can create a unique mapping where all users are mapped into to a single set of credentials.

This account, known as the unattended service account, must be a low-privilege Windows domain account. Excel Services impersonates this account when it connects to a data source on behalf of a workbook viewer.

It is a best practice to give this account as few network permissions as possible, typically only access to log into the network and access to the data source you want to have users connect to. For best security, be sure that the unattended service account does not have access to the SharePoint Configuration and Content databases.

The unattended service account is used by Excel Services in these scenarios:

  • When an ODC file specifies the use of the Unattended Service

  • When an embedded data connection specifies the Unattended Service Account

  • When using SQL credentials that are stored in a Secure Store target application

Note:

The unattended service account can be a local computer account of type Windows. If the unattended service account is configured as a local computer account, ensure that the configuration is identical on every application server running Excel Services. For manageability reasons, the best practice is to use a domain account

Choose the unattended service account when you are connecting to small ad-hoc deployments in which security is less important or for which speed of deployment is essential.

For information about using the unattended service account with Excel Services, see Configure Excel Services data refresh by using the unattended service account in SharePoint Server 2013.

SQL Server Authentication

SQL Server Authentication requires that Excel Services present a SQL Server user name and password to a SQL Server data source to authenticate. Excel Services passes the connection string to the data source. The connection string must contain the user name and password.

If the user name and password are stored in a Secure Store target application (recommended for best security), then Excel Services will impersonate the unattended service account and when the connection is made, the SQL credentials are set as properties of the connection.

Authentication against OLEDB/ODBC data sources

Authentication to third party data sources typically requires that Excel Services present a user name and password to a data source.

If the user name and password are stored in the workbook or in the ODC file, then Excel Services impersonates a Windows identity dependent on which option has been selected for Excel Services authentication settings, either in the workbook or in the ODC file.

If the user name and password are stored in a Secure Store target application (recommended for best security), then Excel Services impersonates the unattended service account and when the connection is made, the SQL credentials are set as properties of the connection.

Data refresh

Excel Services supports refreshing workbooks connected to one or more of the following data sources:

  • SQL Server

  • SQL Server Analysis Services (SSAS)

Note:

If the data source that you plan to connect to is not in the list above, you can add support for it by creating a Custom Data Provider. This technology enables you to wrap your existing data sources into one that Excel Services can consume.

External data refresh is the result of the following set of steps through Excel Services.

  1. Creating a workbook: A workbook author uploads a data-connected workbook to SharePoint Server 2013.

  2. Triggering Refresh: The workbook viewer triggers refresh on a data-connected workbook.

  3. Data Connections: Excel Services retrieves data connection information for each external data source in the workbook.

  4. Trusted Data Providers: Excel Services checks to see if there is a trusted data provider it can use to retrieve data.

  5. Authentication: Excel Services authenticates into the data source and retrieves the requested data on behalf of the workbook viewer.

  6. Workbook Refresh: Excel Services updates the workbook based on the data source data and returns it to the viewer.

Refresh can be triggered in one of following ways from within the browser:

  • The end-user opens the workbook (if the workbook is configured to refresh on open).

  • The end-user clicks on the refresh button on an already open workbook.

If there are no previously cached versions of this workbook, any of these actions will trigger a refresh and update the workbook.


Data sources supported in Excel Services (SharePoint Server 2013)
See also

Published: October 30, 2012

Summary: Learn about different kinds of data sources that you can use in Excel and Excel Services.

Applies to: SharePoint Server 2013 Enterprise

You can bring data into Excel using lots of data sources and connections. Many, but not all, of the data connections that you can use in Excel are supported in Excel Services. In addition, if your organization is using Office Web Apps Server, some data sources that you can use in Excel are not supported in Excel Web App.

At a high level, the following table summarizes the Excel data sources that are supported in Excel Services (as part of SharePoint Server) and Excel Web App (as part of Office Web Apps Server).

Table: Summary of Excel data sources that are supported in Excel Services and Excel Web App

Excel data source | Supported in Excel Services? | Supported in Excel Web App?
SQL Server tables | Yes | Yes, if the environment is configured to use Secure Store Service or an unattended service account.
SQL Server Analysis Services cubes | Yes | Yes, if the environment is configured to use Secure Store Service or an unattended service account.
OLE DB or ODBC data source | Yes, as long as the connection string contains a user name and password for the connection. | Yes, as long as the connection string contains a user name and password for the connection.
Data model that was created by using Excel | Yes, provided Excel Services is configured to use an instance of SQL Server Analysis Services for data models. | No
Windows Azure Marketplace data | No | No
OData data | No | No
XML data | No | No
Access data | No | No
Data from a text file | No | No

The following sections contain more detailed information about how to work with data in Excel and Excel Services.

In this article

  • Working with external data in Excel

  • External data connections that are supported in Excel Services in SharePoint Server

  • External data connections that are supported in a SharePoint environment that includes Office Web Apps Server

  • Working with data models in Excel Services

  • Working with native data in Excel Services

Working with external data in Excel

In Excel 2013, you can connect to lots of data sources. These include the following:

  • SQL Server tables

  • SQL Server Analysis Services cubes

  • Windows Azure Marketplace data

  • OData data

  • XML data

  • Access data

  • Text file data

To bring data into Excel, you can use existing connections, or you can create your own connections. Existing connections can be stored on your computer or in a central location, such as a SharePoint site.

Ideally, you'll have access to a set of existing data connections in a site, such as a Business Intelligence Center site, that you can use to work with data in Excel. This is especially helpful if you plan to publish a workbook to a documents library in a Business Intelligence Center site. Typically, a SharePoint administrator configures such locations as trusted locations in Excel Services. This makes it possible for you and others to refresh data in your workbooks to view the most current information.

To use an existing data connection in Excel

  1. In Excel, on the Data tab, choose Existing Connections.

  2. Choose Browse for More to open the Select a Data Source dialog box.

  3. Specify the location of the data source that you want to use, select the data source, and then choose Open.

  4. On the Import Data page, choose how you want to view the data, and then choose OK.

    The options that are available depend on the particular data source that you are using. For example, you might choose to create a data table, a PivotChart report, a PivotTable report, or a Power View sheet.

If you do not have an existing connection or you want to create a new connection, you can easily do this in Excel. You'll typically have to know the name of the location (such as a server or a website) where the data is stored and what authentication method that you should use to connect to the data. For example, to create a connection to a table that is stored in SQL Server, you must know the name of the server, the database, and table that you want to use, and what credentials are used to connect to the data.

To create and use a new data connection in Excel

  1. In Excel, on the Data tab, in the Get External Data group, choose one of the following options:

    • Choose From Access to use data that is stored in an Access database.

    • Choose From Web to use data from an internal or external website.

    • Choose From Text to use data that is stored in a text file.

    • Choose From Other Sources to use data that is available in SQL Server, SQL Server Analysis Services, Windows Azure Marketplace, OData, an XML file, or data that is available through a custom provider.

    The Data Connection Wizard opens.

  2. Specify the information that is required for each step of the Data Connection Wizard, and then click Finish.

  3. On the Import Data page, choose how you want to view the data, and then choose OK.

    The options that are available depend on the particular data source that you are using. For example, you might choose to create a data table, a PivotChart report, a PivotTable report, a Power View sheet, or just the data connection.

For more detailed information about how to create data connections, see Share data connections by using Excel and Excel Services (SharePoint Server 2013).

After you have created an Excel workbook that uses external data and views, such as PivotChart reports, PivotTable reports, or Power View views, you can share that workbook with others by using a site such as a SharePoint site. Depending on your environment, the external data connections that are used in your workbook might not be supported. Whether an external data connection is supported determines whether data refresh is available for the workbook and whether the workbook is viewable in a browser window.

External data connections that are supported in Excel Services in SharePoint Server

Most, but not all, of the data connections that you can use in Excel are supported in Excel Services. These include connections to the following data sources:

  • SQL Server tables

  • SQL Server Analysis Services cubes

  • OLE DB and ODBC data sources

When a data connection is supported, it means that people can refresh data in Excel Services that use that data connection, as long as Excel Services is configured correctly.

Data sources that you can connect to in Excel that are not supported in Excel Services include the Access databases, website content, XML files, Windows Azure Marketplace data, and text files. If you plan to use these kinds of data sources in workbooks that you'll publish to SharePoint Server, consider importing data into Excel and using the data as native data. For more information, see Working with native data in Excel Services.

External data connections that are supported in a SharePoint environment that includes Office Web Apps Server

Office Web Apps Server is the online companion to Office Word, Excel, PowerPoint, and OneNote applications. If your organization is using SharePoint Server 2013 together with Office Web Apps Server, then your organization is using either Excel Services or Excel Web App (part of Office Web Apps Server) to display workbooks in a browser window. This decision affects which data sources are supported for workbooks rendered in a browser window.

Excel Web App supports some, but not all, kinds of secure external data connections. Data connections to Microsoft Access databases, website content, XML files, Windows Azure Marketplace data, and text files are not supported in Excel Web App. If you plan to use these kinds of data sources in workbooks that you'll share using Excel Web App, consider importing data into Excel and using the data as native data.

Working with data models in Excel Services

A data model is a dataset that consists of multiple tables. Data models are useful for bringing together data from different databases to create a single database that can serve as a data source for views, such as PivotChart reports, PivotTable reports, and Power View views. Data models can be created by using external data or native data. For more information about data models, see PowerPivot: Powerful data analysis and data modeling in Excel.

To view or use a workbook that contains a data model in Excel Services, Excel Services must be configured to support data models. For more information, Manage Excel Services data model settings (SharePoint Server 2013). Currently, Office Web Apps Server does not support data models.

Working with native data in Excel Services

Native data is data that is imported into Excel and does not keep connections to external databases. Native data is also known as worksheet data or sheet data, and it is either static data or data that is updated manually. Working with native data in Excel workbooks offers certain advantages:

  • You can publish workbooks that use data from sources that are not supported in Excel Services or Excel Web App.

  • You and others can view and interact with workbooks that use native data in a browser window, whether the workbook is rendered by either Office Web Apps Server or SharePoint Server 2013. Note that data models are not supported in Office Web Apps Server, but PivotChart reports and PivotTable reports that use native data are supported.

  • If a workbook does not consume more than 10 MB of disk space, you can share or view the workbook on Office 365. This makes it possible to share information "in the cloud."

See also

Share data connections by using Excel and Excel Services (SharePoint Server 2013)
Data authentication for Excel Services in SharePoint Server 2013
BI capabilities in Excel and Excel Services (SharePoint Server 2013)


Plan Excel Services Global Settings in SharePoint Server 2013

Summary: Learn how to choose authorization (impersonation or process account) and encryption (IPsec or SSL) options for Excel Services.

Applies to: SharePoint Server 2013

When you deploy Excel Services in SharePoint Server 2013, you need to plan for the following Global Settings:

  • File access method for Excel Services

  • Connection encryption for Excel Services

For information about configuring these settings, see Manage Excel Services global settings (SharePoint Server 2013).

File access method for Excel Services

In Excel Services Global Settings, there are two options for file access method: Impersonation or Process account.

The Impersonation option enables a thread to run in a security context other than the context of the process that owns the thread. Select Impersonation to require Excel Services to authorize users when they try to access workbooks that are stored in UNC and HTTP locations. Selecting this option does not affect workbooks that are stored in SharePoint Server 2013 databases. In most server farm deployments in which front-end web servers and Excel Services application servers run on different computers, impersonation requires constrained Kerberos delegation.

The Process Account option specifies that the user account is not impersonated, and the process account is used when Excel Services opens workbooks from UNC shares or HTTP Web sites.

Connection encryption for Excel Services

You can use Internet Protocol Security (IPsec) or Secure Sockets Layer (SSL) to encrypt data transmission among Excel Services application servers, data sources, client computers, and front-end web servers. By default, connection encryption is not required. If you choose to require connection encryption, the Excel Services application server will only enable data transmission between client computers and front-end web servers over SSL connections.

If you decide to require encrypted data transmission, you will have to manually configure IPsec or SSL. You can require encrypted connections between client computers and front-end web servers while enabling connections that are not encrypted between front-end web servers and Excel Services application servers.


Plan Trusted File Locations in SharePoint Server 2013
See also

Summary: Plan Excel Services trusted file location parameters, including session, workbook, calculation, memory, and external data settings.

Applies to: SharePoint Server 2013

This article describes trusted file locations for Excel Services in SharePoint Server 2013.

In this article:

  • Introduction to Trusted File Locations for Excel Services

  • Workbook location settings for Excel Services

  • Session management settings for Excel Services

  • Workbook and image size settings for Excel Services

  • Calculation behavior settings for Excel Services

  • External Data settings for Excel Services

  • User-defined functions settings for Excel Services

Introduction to Trusted File Locations for Excel Services

Excel Services automatically creates a default trusted file location (http://) which trusts the whole SharePoint Server farm. This default trusted location enables any file to be loaded from the SharePoint Server farm or stand-alone deployment by using Excel Services. Trusting the whole SharePoint farm by default enables easier setup for administrators. Administrators can define new trusted file locations to expand workbook capabilities and tighten security.

Excel Services administrators can add new trusted file locations as needed. Trusted file locations are either SharePoint sites, UNC paths, or HTTP Web sites from which a server that is running Excel Services is permitted to access workbooks.

To make sure that only trusted users have access to workbooks stored in trusted locations, it is important to enforce ACLs on all trusted file locations.

There are three core scenarios to deploy Excel Services: enterprise, small department, and custom.

In an enterprise deployment, consider the following guidelines:

  • Do not configure support for user-defined functions.

  • Do not enable workbooks to use embedded data connections to directly access external data sources.

  • Limit the use of data connection libraries for external data source access from workbooks.

  • Restrict the size of workbooks that can be opened in Excel Services.

  • Selectively trust specific file locations and do not enable Trust Children for trusted sites and directories.

In a small department deployment, consider the following guidelines:

  • Enable trust for all file locations that are used by department members to store workbooks.

  • Enable Trust Children for all trusted sites and directories.

  • Selectively restrict access to specific file locations if problems occur.

In a custom deployment, consider the following guidelines:

  • Enable Excel Services to open large workbooks.

  • Configure long session time-out settings.

  • Configure large data caches.

  • Create a single trusted location for this deployment.

  • Do not enable Trust Children for this trusted location.

Workbook location settings for Excel Services

In the Location section of the Excel Services Add Trusted File Location page, you can configure the address, the location type, and whether child libraries of trusted file locations are also trusted. By selecting Trust children you can simplify manageability. However, you can also create a potential security issue by enabling subsites and subdirectories of trusted locations to be automatically trusted as soon as they are created. Only choose Children trusted if you are certain that any child directories or libraries will contain workbooks that you want Excel Services to trust.

Session management settings for Excel Services

In the Session Management section, you can configure settings to help conserve resource availability and improve Excel Services performance and security. Performance can decrease when many users have multiple Excel Services sessions open at the same time. You can control resource consumption and limit the duration of open Excel Services sessions by configuring two time-out settings for open sessions.

The Session Timeout setting determines the time that an Excel Services session can remain open and inactive after each user interaction. The Short Session Timeout setting determines how long an Excel Services session can remain open and inactive after the initial session request. The New Workbook Session Timeout setting determines how long an Excel Services session for a new workbook can remain open and inactive before it is shut down. You can also control the number of seconds allowed for any single session request by configuring a Maximum Request Duration value. Similarly, you can configure the Maximum Chart Render Duration. By limiting how long sessions remain open, you can help reduce the risk of denial-of-service attacks.

We recommend that you start with the default values and adjust them as needed if you encounter performance issues.

Workbook and image size settings for Excel Services

In the Workbook Properties section, you can configure a maximum size of any workbook, chart or image that is permitted to be opened in an Excel Services session. Performance and resource availability can be compromised when users open extremely large workbooks. Unless you control the allowable size of workbooks running in open Excel Services sessions, you risk users exceeding your resource capacity and causing the server to fail.

Calculation behavior settings for Excel Services

In the Calculation Behavior section, you determine calculation modes in Excel Calculation Services for workbooks from this location. The Volatile Function Cache Lifetime setting specifies how long a computed value for a volatile function is cached for automatic recalculations. The Workbook Calculation Mode setting specifies options for how and when workbook calculations are performed.

External Data settings for Excel Services

In the External Data section, you can determine whether workbooks stored in trusted file locations and opened in Excel Services sessions can access an external data source. You can designate whether Allow External Data is set to None, Trusted data connection libraries only, or Trusted data connection libraries and embedded. If you select either Trusted data connection libraries only or Trusted data connection libraries and embedded, the workbooks stored in the trusted file locations can access external data sources.

External data connections can be accessed only when they are embedded in or linked from a workbook. Excel Services checks the list of trusted file locations before it opens a workbook. If you select None, Excel Services will block any attempt to access an external data source. If you manage data connections for many workbook authors, consider specifying Trusted data connection libraries only. This ensures that all data connections in all of the workbooks generated by authenticated workbook authors have to use a trusted data connection library to access any external data sources.

If you manage data connections for only a few workbook authors, consider specifying Trusted data connection libraries and embedded. This enables workbook authors to embed direct connections to external data sources in their workbooks, but still have access to trusted data connection libraries.

In the Warn on Refresh area of the External Data section, you can specify whether a warning is displayed before a workbook updates from an external data source. By selecting Refresh warning enabled, you ensure that external data is not automatically refreshed without user interaction.

In the Display Granular External Data Errors option, if you enable the Granular External Data Errors setting it provides descriptive error messages to display that provide helpful information for troubleshooting and fixing connection problems.

In the Stop When Refresh on Open Fails area, you can specify if Excel Services stops opening a workbook if the workbook contains a Refresh on Open data connection that fails. By selecting Stopping open enabled, you ensure that cached values are not displayed if an update operation fails when the workbook is opened by any user having View Only permissions to the workbook. This is useful when a report may contain per-user data and you don't want a user to see another user's cached data. When Refresh on Open is successful, cached values are purged. By clearing the Stopping open enabled check box, you risk displaying cached values if Refresh on Open fails.

In the External Data Cache Lifetime area of the External Data section, you can specify the maximum time that cached values can be used before they expire, and the maximum number of external data queries that can execute at the same time in a single session.

You can also specify the maximum number of queries that you want to allow for a given session, as well as whether to enable allow external data using REST.

User-defined functions settings for Excel Services

If your deployment scenarios include workbooks that contain user-defined functions to extend the capabilities of Excel Calculation Services, you must configure Excel Services to support user-defined functions.

To configure this support, you must enable user-defined functions on trusted file locations that contain workbooks that require access to user-defined functions. In addition, you must register user-defined function assemblies on the Excel Services user-defined function assembly list. See Manage Excel Services user defined function assemblies (SharePoint Server 2013) for more information about how to enable user-defined functions.

See also

Plan Trusted Data Connection Libraries in SharePoint Server 2013


Plan Trusted Data Connection Libraries in SharePoint Server 2013
See also

Summary: Use Excel Services trusted data connection libraries to manage and secure data connections for Excel Services.

Applies to: SharePoint Server 2013

Excel Services in SharePoint Server 2013 provides the ability to connect to external data sources and refresh the data in data-connected Excel workbooks when it renders them in a browser. Data connections can be loaded by using information from the workbook file, but using a data connection library provides an additional layer for data connections so that they can be managed separately from workbooks.

Trusted data connection libraries are SharePoint Server 2013 data connection libraries that contain data connection files that Excel Services will trust to use to connect to databases. These files contain everything that Excel Services and Excel client have to have to connect to an external data source.

Data connection libraries enable broad reuse and sharing of data connections. By using trusted data connection libraries with Excel Services, you can create, deploy, and manage the data connections that your users use. By managing connections in this way, you can ensure that connections are configured correctly and maintained properly and that your users are all using a consistent group of connection files that have been created and approved by authorized users and administrators.

Excel Services does not use data connection files that are not stored in a trusted data connection library. However, data connection information can be embedded directly in a workbook that is trying to make a connection.

You can create different trusted data connection libraries for different purposes or projects, and you can customize the settings and permissions to the libraries accordingly.

For workbooks that use the same data connection file, changing the data connection file is all that is required to change connection information; changing the individual workbooks is not necessary.

Initially, there are no Excel Services trusted data connection libraries. To store data connection files, you must create at least one trusted data connection library.

For information about creating trusted data connection libraries, see Manage Excel Services trusted data connection libraries (SharePoint Server 2013).

See also

Plan Trusted File Locations in SharePoint Server 2013


Plan Excel Services Data Model settings in SharePoint Server 2013

Summary: Specify an instance of Analysis Services to be used with interactive data models in Excel Services.

Applies to: SharePoint Server 2013

In Excel Services in SharePoint Server 2013, you can specify one or more instances of SQL Server 2012 SP1 Analysis Services (SSAS) for use in processing Data Models created in Excel 2013. In this configuration, SQL Server 2012 Analysis Services provides a backend service for Excel Services to load, query, and refresh Excel 2013 Data Models so that users can interact with these types of workbooks in the browser. SQL Server 2012 Analysis Services must be installed in SQL Server PowerPivot for SharePoint mode.

In Excel Services in SharePoint Server 2013, Data Models are created automatically when you choose multiple tables in the same import operation in Excel. If you build workbooks that store imported data in multiple tables, you will need an instance of SQL Server 2012 SP1 Analysis Services (SSAS) specified in Excel Services if you want to interact with that data in SharePoint Server 2013.

Analysis Services must be on the same network and domain as your SharePoint Server farm. You install and manage it by using SQL Server installation media and tools. After you install Analysis Services, the only additional configuration is to configure Excel Services Application Settings to point to the Analysis Services server instance.

You can specify multiple instances of Analysis Services in Excel Services settings. When you do this, data models are streamed to these instances in a round-robin fashion for load balancing. If you notice that resource usage on your instance of Analysis Services is excessive or working with data models in the browser has slowed, consider adding an additional instance of Analysis Services for greater capacity.

The Analysis Services instance is specified as part of Excel Services Application Settings. For information on configuring SQL Server 2012 SP1 Analysis Services (SSAS) for Excel Services, see Manage Excel Services data model settings (SharePoint Server 2013).


PerformancePoint Services in SharePoint Server 2013 overview

Summary: Learn about PerformancePoint Services in SharePoint Server 2013.

Applies to: SharePoint Server 2013

PerformancePoint Services in SharePoint Server 2013 is a performance management service that you can use to monitor and analyze your business. By providing flexible, easy-to-use tools for building dashboards, scorecards, and key performance indicators (KPIs), PerformancePoint Services can help individuals across an organization make informed business decisions that align with companywide objectives and strategy.

PerformancePoint Services

PerformancePoint Services lets you create rich dashboards, aggregating content from multiple sources and displaying it in a web browser in an understandable and collaborative environment. The rich interactivity of the dashboards lets you to analyze the latest information and work with the data quickly and easily to identify key opportunities and trends. PerformancePoint Services and its authoring tool Dashboard Designer let you display key performance indicators (KPIs) and data visualizations in the form of scorecards, analytic reports, and filters. You can integrate with SQL Server Reporting Services (SSRS)and Excel Services in addition to create scorecards that bring together data from multiple data sources to track and monitor key drivers of your business.

New features and improvements

In SharePoint Server 2013, PerformancePoint Services offers certain new features to support business intelligence applications. These include the following:

  • Dashboard Migration: Users will be able to copy complete dashboards and dependencies. This includes the .aspx file, to other users, servers, or site collections. This feature also allows the ability to migrate single items to other environments and migrate content by using Windows PowerShell commands.

  • Filter Enhancements & Filter Search: The UI is improved to allow users to easily view and manage filters including letting users search for items within filters without having to navigate through the tree.

  • BI Center Update: The new BI Center is cleaner, and easier to use with folders and libraries configured for easy use.

  • Support for Analysis Services Effective User: This new feature eliminates the need for Kerberos delegation when per-user authentication is used for Analysis Services data sources. By supporting Analysis Services Effective User feature, authorization checks will be based on the user specified by the EffectiveUserName property instead of using the currently authenticated user.

  • PerformancePoint Support on iPad: PerformancePoint dashboards can now be viewed and interacted with on iPad devices that are using the Safari web browser.


Overview of PerformancePoint reports and scorecards
See also

Published: February 19, 2013

Summary: Learn about reports and scorecards within PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

You can use PerformancePoint Dashboard Designer to create reports and scorecards for your dashboards. As you create each report or scorecard, you begin by selecting the appropriate template within Dashboard Designer.

In this article:

  • Report templates

  • Scorecard templates

Report templates

PerformancePoint reports can vary greatly in appearance and functionality. Some reports are created by using Dashboard Designer,but others are often external, existing reports that you can display in a PerformancePoint dashboard by creating a PerformancePoint Web Part. Finally, for some reports, you must have at least one scorecard created to successfully create and display information in those reports.

Template Description

Analytic Chart

An analytic chart is an interactive line, bar, or pie chart that you create and configure by using Dashboard Designer. Analytic charts use data that is stored in SQL Server Analysis.

For more information, see Create analytic charts or grids by using Dashboard Designer (SharePoint Server 2013).

Analytic Grid

An analytic grid is an interactive table that you create and configure by using Dashboard Designer. Analytic grids use data that is stored in SQL Server Analysis.

For more information, see and Create analytic charts or grids by using Dashboard Designer (SharePoint Server 2013).

Excel Services

An Excel Services report is an Excel workbook that was published to SharePoint Server 2013 by using Excel Services.

In Dashboard Designer, you do not actually create an Excel Services report. Instead, create a PerformancePoint Web Part to display all or part of an Excel workbook.

For more information, see Create Excel Services reports by using Dashboard Designer (SharePoint Server 2013).

KPI Details

A KPI Details report is a report that serves as a companion to a scorecard to provide additional information about scorecard key performance indicator (KPI) values and properties.

A KPI Details report does not contain or display information by itself. The KPI Details report derives all its information directly from the scorecard to which it is connected. Dashboard users click a value in a scorecard, and the KPI Details report updates to display additional information about that particular scorecard value without cluttering up the scorecard.

For more information, see Overview of PerformancePoint KPI Details reports and Create a KPI Details report by using Dashboard Designer (SharePoint Server 2013).

Reporting Services

A Reporting Services report is a view that was published to SQL ServerReporting Services Report Server.

In Dashboard Designer, you do not actually create a Reporting Services report. Instead, you create a PerformancePoint Web Part to display an existing Reporting Services report.

For more information, see nd Create a Reporting Services report by using Dashboard Designer.

Strategy Map

A strategy map is a report that serves as a companion to a scorecard to show relationships between objectives, goals, and KPIs at a glance. Strategy maps are based on the Balanced Scorecard framework.

A strategy map uses a scorecard as its data source and a Visio diagram as its display structure.

For more information, see Create strategy maps by using Dashboard Designer (SharePoint Server 2013).

Web Page

A Web Page report is a fully functional internal or external Web site that you can display alongside other reports in your dashboard.

In Dashboard Designer, you do not actually create a Web Page. Instead, you create a PerformancePoint Web Part to display an existing website.

For more information, see Create a Web Page report by using Dashboard Designer.

Decomposition Tree

A Decomposition Tree is an interactive view that dashboard users open from a scorecard or a report that uses SQL Server Analysis Services data. However, as a dashboard author, you do not create the Decomposition Tree by using PerformancePoint Dashboard Designer. In addition, you cannot display a Decomposition Tree as a top-level report view that is always displayed in a dashboard alongside other reports.

For more information, see Overview of the PerformancePoint Decomposition Tree.

Scorecard templates

A scorecard is a special kind of report that provides a high-level snapshot of performance for a group or an organization. A scorecard provides a visual representation of performance that can give you a summary of progress at a glance.

When you create a PerformancePoint scorecard, you can use a wizard to guide you through the process. When you use a wizard, you begin by selecting a template. The template that you select corresponds to the kind of data source that you plan to use for at least one key performance indicator (KPI) in your scorecard.

Important:

To use the different scorecard templates that are available, ensure that Dashboard Designer is configured to use a scorecard wizard. To learn more, see Turn on or off the scorecard wizard in Dashboard Designer.

Template Description

Analysis Services

The Analysis Services scorecard template enables you to create a scorecard that uses an Analysis Services data source for at least one KPI in the scorecard.

Depending on how an Analysis Services scorecard is configured, dashboard users can perform certain tasks that are not necessarily available with other scorecard templates:

  • Use Show Details to view transaction-level details for a particular scorecard value.

  • Open a Decomposition Tree to decompose, or analyze, a group to see its individual members and how they can be ranked according to a selected measure. For more information, see Learn about the Decomposition Tree (http://go.microsoft.com/fwlink/p/?LinkId=204883).

  • View higher or lower levels of data in the scorecard.

  • View dynamic dimension hierarchies in the scorecard.

When you use the Analysis Services scorecard template, you can create KPIs that are based on measures in the data cube, or you can select existing KPIs that you or other dashboard authors have created. However, you can also copy KPIs that are defined in the data cube into the scorecard. This ability to copy KPIs is unique to the Analysis Services scorecard template.

For more information, see Create an Analysis Services scorecard by using Dashboard Designer (SharePoint Server 2013).

Blank Scorecard

The Blank Scorecard template enables you to create an empty scorecard that has no KPIs or other information. You would typically create a blank scorecard when you and other dashboard authors have already created KPIs.

For more information, see Create blank scorecards by using Dashboard Designer (SharePoint Server 2013).

Fixed Values Scorecard

The Fixed Values Scorecard template enables you to create a scorecard that does not use a separate data source. When you use this template, you specify the values for the scorecard while you use the wizard.

For more information, see Create Fixed Values scorecards by using Dashboard Designer (SharePoint Server 2013).

Tabular templates. They include the following:

  • Excel Services

  • Excel Workbook

  • SharePoint List

  • SQL Server Table

The four tabular templates (Excel Services, Excel Workbook, SharePoint List, and SQL Server Table) enable you to create a scorecard that uses a tabular data source for at least one KPI in the scorecard. Similar to the Analysis Services scorecard template, when you use a tabular data scorecard template, you can create KPIs that are based on measures in the data source, or you can select existing KPIs that you or other dashboard authors have created.

For more information, see Create tabular data scorecards by using Dashboard Designer.

See also

Create reports by using Dashboard Designer (SharePoint Server 2013)


Overview of PerformancePoint strategy maps in SharePoint Server 2013

Published: August 15, 2012

Summary: Learn about strategy maps in Dashboard Designer.

Applies to: SharePoint Server 2010 Enterprise

A strategy map is a report view that can show relationships between objectives, goals, and key performance indicators (KPIs).

In a PerformancePoint dashboard, a strategy map alongside its scorecard might resemble the following image:

PerformancePoint strategy map

In the image, the color of each shape in the diagram is determined by the indicator that is connected to it. For example, the scorecard shows that Asia is on target overall, off target for the Sales Amount measure, and on target for the Sales Quantity measure. Thus, we see the shape that represents Asia colored in green, the shape for Sales Amounts colored in yellow, and Sales Quantity colored in green.

You are not limited to simple diagrams such as the one shown. You can use any Visio diagram. However, if you want the shape colors to update automatically, the kinds of shapes that you use matter. To configure the strategy map so that the shape colors correspond to scorecard values, use a Visio diagram that does not consist of complex shapes. Examples of complex shapes include shapes that consist of groups or sets of other shapes.

Strategy maps and the Balanced Scorecard

Strategy maps have their roots in the Balanced Scorecard framework, which defines organizational performance by using four perspectives:

  • Financial This perspective typically includes metrics such as revenue, cost, and profit.

  • Customer This perspective, which is also known as the customer satisfaction perspective, typically includes metrics such as customer counts, market share, and number of complaints.

  • Internal process This perspective, which is also known as the operations perspective, typically includes metrics such as time to market for new products, service error rates, and quality control measures.

  • Learning and growth This perspective, which is also known as the human resources perspective, typically includes metrics such as employee turnover rates, the number of new employees, and hiring data.

A Balanced Scorecard in PerformancePoint Services is typically a dashboard page that consists of the following:

  • A scorecard that displays performance metrics across the organization using the four perspectives described earlier in this section. The scorecard contains four groups of KPIs that correspond to those perspectives. For example, one set of KPIs includes financial metrics, another set includes customer metrics, and so on.

  • A strategy map that includes four groups of shapes (one group of shapes for each perspective) that are connected to the scorecard KPIs.

A Balanced Scorecard might resemble the following image:

Example of a Balanced Scorecard

Although many organizations find the Balanced Scorecard framework useful, you do not have to follow it when you create your strategy map. You can create your strategy map using any combination of KPIs and objectives in a PerformancePoint scorecard. For example, you can use a strategy map to show performance metrics across different geographical regions. Or, you can diagram a process in your organization and show how well each contributor to the process is performing.


Overview of PerformancePoint analytic charts and grids
See also

Published: February 19, 2013

Summary: Learn about analytic charts and grids in Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

You can create analytic reports for your dashboards by using PerformancePoint Dashboard Designer. Analytic reports are dynamic, visual representations of data that can be displayed as interactive line charts, bar charts, pie charts, and tables (which are called grids).

PerformancePoint analytic reports remain connected to the data, which means that their content is always up to date. To learn how to create an analytic report, see Create analytic charts or grids by using Dashboard Designer (SharePoint Server 2013).

Interactive functionality in analytic charts and grids

You would typically include one or more analytic reports in your dashboard\. Depending on how you set up your analytic charts or grids, dashboard users can use those reports to::

  • Open a Decomposition Tree to see how a specific value can be broken down into its contributing members and discover trends across individual members.

    Important:

    You must have Microsoft Silverlight 2 or Silverlight 3 installed on your computer in order to use the Decomposition Tree. If you do not have Silverlight 2 or Silverlight 3 installed, you will not see Decomposition Tree listed on the right-click menu.

  • Apply value filters to display the top (or bottom) members in a group, or values that are in a given range.

  • Use Additional Actions, which are defined in the Analysis Services cube.

  • Sort values or chart legend items in ascending or descending order.

  • Drill down or up to see lower or higher levels of detail.

  • Filter out empty items, isolate an item, or remove an item from the report view.

  • Pivot the report, or configure the view type and format.

  • Show or hide information, such as measures or background information.

  • Work with multiple pages of data. (This is useful when a query returns a large set of results.)

  • Export information to PowerPoint or Excel.

Tip:

The activities described in the list are largely dependent on the way that data cubes are configured in SQL Server Analysis Services. For example, if no actions are defined in the data cubes, then the Additional Actions option is not available for your analytic chart.

Data sources for analytic charts and grids

Analytic reports pull information from data that is arranged into cubes in SQL Server 2005 Analysis Services or SQL Server 2008 Analysis Services. These cubes consist of dimensions, members, and named sets, as described here:

Item | Description
Dimension | A structured, hierarchical way to organize data. For example, a Products dimension might have a hierarchy such as Products > Product Categories > Product Names, and a Date dimension might have Year > Week > Day.
Measure | A cube member that associates a numeric value with one or more dimension members. For example, some measures might include Sales Amounts, Gross Profit, and Gross Profit Margin.
Named set | A collection of one or more dimension members that is defined in the database. For example, Core Products is a common named set that contains a subset of the members that are included in the Products dimension.

See also

Create analytic charts or grids by using Dashboard Designer (SharePoint Server 2013)


Overview of Excel Services reports displayed in PerformancePoint Web Parts
See also

Published: February 19, 2013

Summary: Learn about how to display Excel Services reports in Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

By using PerformancePoint Dashboard Designer, you can include Excel Services reports in your PerformancePoint dashboards. Excel Services reports are Excel workbooks that have been published to SharePoint Server. You can display a single item in the workbook, or the whole workbook in your PerformancePoint dashboard.

When you use Dashboard Designer to include Excel Services reports in your dashboard, you do not actually create the reports. Instead, you create PerformancePoint Web Parts that are designed to display Excel Services reports and receive dashboard filters.

Use Excel Services reports for purposes such as the following:

  • To display view types that you cannot create by using Dashboard Designer. Examples include PivotChart reports, PivotTable reports, and tables that contain conditional formatting or other custom formatting that is not available in analytic grids.

  • To save time by displaying existing reports, instead of creating (or recreating) new Excel workbooks.

  • To include interactive reports in your dashboards that users can either view in a web browser or open in Excel.

  • To create reports that use data source types not available in Dashboard Designer.

These are only some examples of how an Excel Services report can be useful. An Excel Services report displays all or part of an Excel workbook that was published to SharePoint Server 2013 by using Excel Services. You can include Excel Services reports in your dashboard, either as a single item on the page or as an item alongside other dashboard items. In addition, you can connect dashboard filters to Excel Services reports, together with other kinds of PerformancePoint reports and scorecards.

Interactive functionality in Excel Services reports

You would typically include one or more Excel Services reports in your dashboard to enable dashboard users to easily view and explore data. Depending on how you set up your reports, dashboard users can perform these kinds of tasks:

  • Browse through pages in Excel workbooks without opening Excel

  • Apply (or change) internal filters for charts and tables that were created in Excel

  • Sort rows or columns in charts or tables

  • Use the Refresh button in the browser window to restore the Excel Services report to its default view

Data sources for Excel Services reports

Excel Services reports can use various data sources, such as those in the following list:

  • A SQL Server database

  • A SQL Server Analysis Services data cube

  • A Access database

  • An online analytical processing (OLAP) database

  • A relational database

  • An Excel workbook

  • A text file

  • An external data connection file that is defined as a trusted data provider. Examples might include those in the following list:

    • SQL Server OLE DB, ODBC, or OLAP

    • OLE DB and ODBC for Oracle

    • OLE DB and ODBC for IBM DB2

Data connections are defined in the Excel workbooks and are retained when the workbooks are published to SharePoint Server.

See also

Connect filters to reports or scorecards by using Dashboard Designer (SharePoint Server 2013)

Create an Excel Services data connection by using PerformancePoint Services


Overview of PerformancePoint KPI Details reports
See also

Published: February 19, 2013

Summary: Learn about PerformancePoint KPI Details reports.

Applies to: SharePoint Server 2013 Enterprise

By using PerformancePoint Dashboard Designer, you can include KPI Details reports in your dashboards. A KPI Details report is a view type that provides additional information about scorecard values and properties. As dashboard users click cells in a scorecard, the KPI Details report updates to display particular information about that value. For example, when dashboard users click a value in the Target column, the KPI Details report displays details such as how performance is calculated, what banding settings are used, and what kind of indicator is used.

To display information, a KPI Details report must be connected to a scorecard in the dashboard. This means that a KPI Details report is not used in a dashboard without its accompanying scorecard on the same dashboard page. However, you can create and configure a KPI Details report one time, and then reuse it in multiple dashboards, connected to multiple scorecards.

See also

Create a KPI Details report by using Dashboard Designer (SharePoint Server 2013)
Create scorecards by using Dashboard Designer
Assemble dashboard pages and link items together by using Dashboard Designer
Add a KPI Details report to a dashboard by using Dashboard Designer (SharePoint Server 2013)


Overview of Reporting Services reports displayed in PerformancePoint Web Parts
See also

Published: February 19, 2013

Summary: Learn about how to include Reporting Services reports in a PerformancePoint web part.

Applies to: SharePoint Server 2013 Enterprise

SQL Server Reporting Services reports are reports that are published to Reporting Services. Reporting Services reports can resemble tables or charts, and they can include their own filters, which are also known as parameters. For more information, see Overview (Reporting Services) (http://go.microsoft.com/?linkid=9758846).

Reporting Services reports are typically highly interactive. Depending on how the reports are configured, dashboard users can explore data by clicking, sorting, and scrolling through pages. In addition, users can perform the following kinds of tasks:

  • Preview, adjust, and print one or more pages in the report.

  • Apply one or more parameters without having to rerun a query to the database. Parameters are built-in filters that are specific to the report.

  • Export data as image files, Adobe PDF files, Web files, or other formats that Microsoft applications recognize.

When you use Dashboard Designer to include Reporting Services reports in your dashboard, you do not actually create the reports. Instead, you create PerformancePoint Web Parts to display Reporting Services reports and receive dashboard filters. For more information, see Create a Reporting Services report by using Dashboard Designer.

See also

Overview of PerformancePoint reports and scorecards


Overview of Web Page reports in Dashboard Designer
See also

Published: February 19, 2013

Summary: Learn about web page reports in Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

In PerformancePoint Dashboard Designer, a Web Page report is a report type that you can use to display a Web site in a dashboard. You would typically use Web Page reports for purposes such as the following:

  • To add textual details about other reports on the dashboard page. For example, you might use a Web Page report to help users understand the key performance indicators (KPIs) that are in a scorecard and what actions they should take when a KPI is off target.

  • To add a Web site, such as a financial news page that displays alerts, stock market activity, and news bulletins to a dashboard targeted at sales, marketing, or finance professionals.

  • To display a report, such as a Visio Graphics Service report, an Access Services report, or a Project Server report that you cannot create by using Dashboard Designer.

  • To add a blog or a forum that displays discussion threads and user comments on a new product in a dashboard page.

A Web Page report displays an internal or external site in a Web Part that you can then include in your dashboard, either as a single item on the page or as an item alongside other dashboard items.

Limitations of Web Page reports

The site that you display in a Web Page report is live and fully functional, exactly as it is in a typical Web browser. However, Web Page reports do not typically have filtering and exporting capabilities that are available in other PerformancePoint report types.

  • Dashboard filters In general, you cannot connect a dashboard filter to a Web Page report. However, depending on the site that is displayed in the Web Page report, you might be able to add a parameter to the Web site address (URL) that is specified for the report.

  • Exporting information Dashboard users cannot export a Web Page report to PowerPoint or Excel by using the Web Part menu for a Web Page report. To capture the information displayed in a Web Page report, dashboard users can print the report by using the Print toolbar commands for the Web browser.

See also

Create a Web Page report


Overview of the PerformancePoint Decomposition Tree
See also

Published: February 19, 2013

Summary: Learn about PerformancePoint decomposition trees.

Applies to: SharePoint Server 2013 Enterprise

The PerformancePoint Decomposition Tree, is an analytics tool that dashboard users can use to perform root-cause analysis. Dashboard users can view how individual members in a group contribute to the whole.

In a Decomposition Tree, members are ranked from greatest to least, or from least to greatest. The Decomposition Tree enables users to decompose, or analyze, a group to see its individual members and how they can be ranked according to a selected measure, such as by sales amounts.

Tip:

The Decomposition Tree is useful for understanding why a particular value in a report or a scorecard is what it is. However, dashboard users cannot export a Decomposition Tree to Excel or PowerPoint like they can with some other kinds of reports, such as scorecards or analytic charts or grids. In addition, dashboard users cannot save their analysis that they did by using the Decomposition Tree.

In this article:

  • How do I create or open a Decomposition Tree?

  • How do I use a Decomposition Tree?

How do I create or open a Decomposition Tree?

As a dashboard author, you do not create the Decomposition Tree by using PerformancePoint Dashboard Designer. In addition, you cannot display a Decomposition Tree as a top-level report view that is always displayed in a dashboard alongside other reports. Instead, dashboard users open the Decomposition Tree from a report in a dashboard that is deployed to SharePoint Server 2013.

Note:

To open and use the Decomposition Tree, dashboard users must have Silverlight 3 or Silverlight 4 installed on their computer. Also be aware that depending on how a scorecard or an analytic view is configured, dashboard users might be unable to open the Decomposition Tree. For example, if a dashboard user right-clicks a report or scorecard value that uses a calculated member or a background item, the Decomposition Tree option might not be available.

To open the Decomposition Tree

  1. In a PerformancePoint dashboard that is published to SharePoint Server 2013, select a report view that uses SQL Server Analysis Services data. Examples include analytic charts and grids, and some kinds of scorecards.

  2. In the report view, right-click a value, and then select Decomposition Tree. The value can be a cell in a scorecard or a grid, or it can be an amount in a chart.

    The Decomposition Tree opens in a browser window.

How do I use a Decomposition Tree?

Dashboard users would typically use a Decomposition Tree to see how a single value in a report or a scorecard can be broken down into its contributing members. The Decomposition Tree automatically sorts results and applies an inline Pareto chart to the data. Therefore, dashboard users can quickly see the highest contributors to a particular report value. Dashboard users can also see trends across individual members that contribute to an overall value.

When dashboard users begin to use the Decomposition Tree, they typically start with one bar, which is a decomposition node, located on the left side of the screen. Use the following procedure to conduct root-cause analysis.

To conduct root-cause analysis by using a Decomposition Tree

  1. In a PerformancePoint dashboard that is published to SharePoint Server 2013, select a report view that uses SQL Server Analysis Services data. Examples include analytic charts and grids, and some kinds of scorecards.

  2. In the report view, right-click a value, and then select Decomposition Tree. The value can be a cell in a scorecard or a grid, or it can be an amount in a chart.

    The Decomposition Tree opens in a browser window.

  3. Click a decomposition node. A list of dimensions and hierarchies is displayed.

  4. Select the dimension and hierarchy that you want to use. The view automatically updates to display the next level of detail for the item that you selected.

  5. Repeat Steps 3 and 4 to show additional levels of detail in the view.

  6. To view member properties for a dimension member, browse to a single dimension member. Click its node to open a dialog box that contains additional options, and then click Show Properties.

See also

Overview of PerformancePoint reports and scorecards


Overview of PerformancePoint scorecards
See also

Published: February 19, 2013

Summary: Learn about PerformancePoint scorecards.

Applies to: SharePoint Server 2013 Enterprise

A scorecard is a special kind of report that provides a high-level snapshot of performance for a group or an organization. Scorecards display a collection of key performance indicators (KPIs) and the performance targets for those KPIs to show progress toward achieving specific goals. The KPIs in a scorecard represent specific, measurable elements of performance, such "Sales" for a particular group, or "Number of customer complaints per day." A scorecard provides a visual representation of performance that can give you a summary of progress at a glance.

Characteristics of PerformancePoint scorecards

A scorecard that was created by using PerformancePoint Dashboard Designer is known as a PerformancePoint scorecard. Some features that you might see in a PerformancePoint scorecard are described in the following list:

  • Trend indicators, such as arrows, that show whether performance has improved, remained the same, or decreased from a previous time period.

  • Complex KPIs that measure performance by comparing multiple values or by using calculated metrics. For example, suppose that sales performance is determined not only by comparing gross sales amounts to quota, but also by factoring in gross profit margin and weighted sales metrics. You can have KPIs that show all the measures of sales performance and then calculate an overall performance measurement.

  • Time Intelligence to show performance for dynamic time periods or as of a particular date. For example, you might have a column labeled Last Six Months in your scorecard that is automatically updated.

  • Expandable and collapsible rows or columns that you can use to see lower or higher levels of detail in the scorecard. For example, suppose that you have an item named All Products on rows in your scorecard. Depending on how the scorecard is configured, you can click Products and see the next level of detail. The scorecard updates and displays additional rows, one for each item in the Products group.

  • KPIs that are used as filters for other reports, such as analytic charts or grids in a dashboard. For example, suppose that you have a scorecard that is connected to an analytic chart. When you click a KPI, the analytic chart automatically updates to display information that is relevant to that KPI. When you click another KPI, the report updates again to display information for that KPI, and so on.

  • The ability to open a Decomposition Tree to analyze how individual members contribute to a value. Depending on how the scorecard is configured and if it uses SQL Server Analysis Services data, you can right-click a value, and then click Decomposition Tree.

Interactive functionality in scorecards

You would typically include one or more scorecards in your dashboard to enable dashboard users to easily view whether performance is on or off target at a glance. Depending on how you set up your scorecards, dashboard users can use those scorecards to perform the following tasks:

  • Expand or collapse rows in the scorecard.

    Drill up (or down) to view higher (or lower levels) of detail.

  • Apply value filters to display the top (or bottom) members in a group, or values that are in a given range.

  • Export information to PowerPoint or Excel.

  • Click a value in a scorecard that is linked to a KPI Details report to view additional information about KPI values and properties.

    Note:

    This option applies to dashboards that contain a scorecard that is connected to a KPI Details report on the same page.

  • Click a KPI that is linked to another report, such as an analytic chart or grid, to display additional information about that KPI value.

Data sources for scorecards

PerformancePoint scorecards can use data that is stored in any of the following data sources:

  • SQL Server Analysis Services

  • A SharePoint list

  • An Excel Services file

  • A table in a SQL Server database

  • A list of values that is created by the scorecard author

See also

Create scorecards by using Dashboard Designer
Assemble dashboard pages and link items together by using Dashboard Designer


Plan for Visio Services in SharePoint Server 2013
See also

Summary: This section discusses planning considerations for Visio Services in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about <subject>.

TechNet articles about Visio Services

The following articles about Visio Services are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
SharePoint logo | Overview of Visio Services in SharePoint Server 2013 | Visio Services in SharePoint Server 2013 is a service application that allows users to collaborate on and view Visio diagrams. The service also enables data-connected Visio 2013 diagrams to be refreshed and updated from a variety of data sources.
 | Plan Visio Services deployment in SharePoint Server 2013 | Planning your Visio Services deployment before rollout can help give you the best system performance and user satisfaction, and also help you avoid unexpectedly overtaxing system resources in your SharePoint Server 2013 farm and related systems.
 | Plan Visio Services security in SharePoint Server 2013 | Visio Services enables you to render published Visio diagrams. These drawings can be connected to external data, and drawing elements can be updated based on that data. Security is an important consideration when enabling these scenarios.
 | Data authentication for Visio Services in SharePoint Server 2013 | This article covers connecting Visio Services diagrams to data hosted on SharePoint Server 2013 plus data hosted externally. Connection types and authentication methods are also covered.

Videos about Visio Services

The following video recording about Visio Services is available to view online or to download.

 | Content | Description
Videos | Data authentication for Visio Services in SharePoint Server 2013 | This demonstration shows the steps for configuring Visio Services with Secure Store.

See also

Visio Graphics Service administration in SharePoint Server 2013


Overview of Visio Services in SharePoint Server 2013

Summary: Visio Services lets users share and view Visio diagrams. It also enables data-connected Visio diagrams to be refreshed and updated from various data sources.

Applies to: SharePoint Server 2013

Visio Services runs as a SharePoint Server 2013 service application.

Use and benefits of Visio Services

Visio diagrams can be rendered by Visio Services and viewed in a Web browser. This lets users view Visio documents without having Visio or the Visio Viewer installed on the local computer. This also allows diagrams to be viewed on mobile devices.

Basic exploration and navigation of these rendered diagrams are supported within the Visio Web Access Web Part. Page designers can configure the user interface and functionality of the Web Part.

Visio Services can also refresh the data and recalculate the visuals of a Visio diagram hosted on a SharePoint site. This enables published diagrams to refresh connections to various data sources and to update affected data graphics and text fields.

Visio diagrams can be published to SharePoint Server 2013 by using Visio Professional 2013 and Visio Premium 2013.

Data sources supported by Visio Services

Connections to the data sources listed here may be refreshed by using Visio Services. The original data connection must be configured using Visio 2010 Professional, Visio 2010 Premium, or Visio Professional 2013. Refresh of data through any other mechanism into a Visio diagram is not supported.

  • SQL Server 7.0

  • SQL Server 2000

  • SQL Server 2005 (32- & 64-bit)

  • SQL Server 2008 (32- & 64-bit)

  • SQL Server 2008 R2 (32- & 64-bit)

  • SQL Server 2012 (32- & 64-bit)

  • Sheet information that is stored in Excel workbooks (.xlsx files) published from Office Excel 2007, Excel 2010, or Excel 2013 hosted on the same SharePoint Server 2013 farm

  • SharePoint Server lists that are hosted on the same farm

  • External lists exposed in SharePoint Server through Microsoft Business Connectivity Services.

  • OLE DB or ODBC

  • Custom Data Providers implemented as .NET Framework assemblies

Compatible diagrams

Visio Services in SharePoint Server 2013 can render diagrams created in Visio 2010 or Visio 2013.

Visio diagrams created in Visio 2010 must be created using Visio 2010 Professional or Visio 2010 Premium and must be published to a SharePoint site as a Visio Web drawing (*.vdw) file. Standard Visio 2010 diagrams (.vsd files) are not rendered by Visio Services and require Visio 2010 to be viewed.

Visio diagrams created in Visio 2013 must be created by using Visio Professional 2013. The new standard diagram format in Visio Professional 2013 (*.vsdx files) can be rendered by Visio Services, along with the Web drawing (.vdw) format. We recommend that you use the new .vsdx format unless you require compatibility with previous versions of Visio.

Configuring Visio Services

Before you configure Visio Services in SharePoint Server 2013, be sure to review Plan Visio Services deployment in SharePoint Server 2013, Plan Visio Services security in SharePoint Server 2013, and Data authentication for Visio Services in SharePoint Server 2013. These articles contain important information about planning your Visio Services infrastructure.

To get started deploying Visio Services, see Create a Visio Graphics Service service application in SharePoint Server 2013.


Plan Visio Services deployment in SharePoint Server 2013

Summary: Best practices for deploying Visio Services include performance planning, using a pilot program, monitoring your deployment, and backing up your data.

Applies to: SharePoint Server 2013

As an integrated part of SharePoint Server 2013, Visio Services in SharePoint Server 2013 is very easy to deploy. Planning your Visio Services deployment before rollout can help give you the best system performance and user satisfaction, and it can help you better manage system resources in your SharePoint Server farm and related systems.

Visio Services performance

Visio Services is implemented by using the Visio Graphics Service, which runs on one or more application servers in the farm. Like all such services, this service consumes resources such as processing capacity and memory on each server where the service is running.

System performance of application servers that are running the Visio Graphics Service may be affected by various factors such as the following:

  • The size of the diagrams being rendered

  • The number of diagrams connected to a data source

  • The performance of the data sources to which diagrams are connected

  • The frequency of data refresh for data-connected diagrams

  • Peak loads of users who are accessing diagrams

  • Peak loads on external data sources accessed by diagrams

  • Complexity of diagrams

  • Visio Services cache settings

The diagram size limit and refresh parameters can be adjusted by the administrator. Being able to adjust these parameters can help you adjust the performance of the server. If changing these parameters does not provide the desired performance, you may have to add processing capacity or memory.

When planning system resources for Visio Services, the most important factor is peak load. For example, if users will make heaviest use of the Visio Services functionality early Monday morning, plan your server capacity for that peak load. Peak load times can vary widely depending on how Visio Services is used within your organization. It is important to estimate peak loads as best as possible to avoid overtaxing system resources.

If your SharePoint Server 2013 farm has multiple application servers, each potentially running multiple services, you must decide which application server or servers that you want to run the Visio Graphics Service on. When determining this, look at the other SharePoint Server 2013 services that are running on each application server. When do the peak loads for each other service occur? Try to select an application server where the peak loads of other services occur at different times than those of Visio Services.

Besides peak load considerations, also consider the overall load of other services that are running on the same server. Some SharePoint Server services, such as Search, might benefit from their own application servers that are not shared by other loads such as Visio Services. Others, such as Access Services, might be ideal companion loads for Visio Services depending on usage patterns.

In addition to SharePoint Server 2013 performance considerations, you should also examine the performance impact of Visio Services on your other systems. For example, if you have a data-connected diagram that is querying data from an Oracle database, what is the effect of your Visio Services peak load on that Oracle database? Large numbers of users querying any data source at the same time could put a strain on the resources of that data source.

The following best practices can be used to optimize the performance of Visio Services:

  • Monitor the performance of the application servers in the farm and add CPU and memory if they are needed to handle peak loads.

  • Start the Visio Graphics Service on more than one application server in the farm to gain additional performance.

  • Run the Visio Graphics Service on an application server where other services experience peak load at a different time of day than the Visio Graphics Service.

  • Limit the maximum diagram size.

  • Increase the minimum cache age for diagrams. This increases the interval in which a user sees cached data for a particular diagram.

Visio Graphics Service Application

SharePoint Server 2013 implements Visio Services through the Visio Graphics Service Application. It is within the Visio Graphics Service Application that you configure the various Visio Services settings, such as trusted data providers and drawing cache settings.

For many deployments, a single Visio Graphics Service Application is sufficient. However, SharePoint Server 2013 lets you create multiple service applications of each type if you want (for example, if you need to use different data sources that require different global settings or a different unattended service account within Visio Services).

Use a pilot deployment

To help determine capacity requirements for Visio Services, consider rolling Visio Services out to a limited pilot group that is representative of typical users. Giving a fairly small number of people access to Visio Services functionality lets you monitor server resource usage and effect on related systems, such as external data sources, without overtaxing system resources.

Once you have compiled performance data for the pilot group, you can extrapolate system requirements for Visio Services when you deploy it across your whole organization. The pilot data will also help you determine peak load requirements and times when peak loads are likely to occur.

By monitoring other affected systems—such as data sources used by data-connected diagrams—you can also determine the likely effect of Visio Services on other systems in your organization.

Monitor system resources consumed by Visio Services

We highly recommend that you monitor system resources consumed by Visio Services—alongside the other services in your SharePoint Server 2013 farm. It is typical for resource usage to increase over time as additional users are brought online and existing users make more use of Visio Services and other SharePoint Server technologies.

The SharePoint Server 2013 services architecture enables easy addition of application servers to the farm. As user demands increase, you can continue to add servers to the farm, and offload services—including Visio Services—to these new servers. Or, instead of offloading Visio Services to a new server, you can run the Visio Services service on multiple application servers at the same time to provide additional capacity and redundancy.

By monitoring resource usage, you can predict when additional capacity is likely to be needed and include the needed hardware in your organization's regular budgetary procedures. This also helps avoid system downtime or slow response caused by unexpectedly high server loads.

Backup and recovery of data

Visio Services settings and Visio documents stored in SharePoint Server 2013 libraries can be backed up by the farm administrator when doing a standard farm backup. However, be aware that when working with Visio documents that are connected to data sources that are outside the farm, the data to which the Visio documents are connected is not backed up as part of a standard farm backup. In this case, the administrator of the system where the data resides should perform a separate backup procedure.

Requirements for authors of diagrams

Visio Services lets you display Visio diagrams in a Web Part without the need to have Visio installed on the client computer. However, Visio Services does not allow for creating or editing Visio diagrams. As part of your deployment plan for Visio Services, you should also plan for the needs of diagram authors within your organization. Each diagram author who has to use Visio Services must have a copy of Visio Professional 2013, Visio 2010 Professional, or Visio 2010 Premium. Users of Visio Professional 2013 can create diagrams using the new vsdx file format. Users of Visio 2010 must use the Web drawing (*.vdw) file format in order to be compatible with Visio Services.


Plan Visio Services security in SharePoint Server 2013
See also

Summary: Security is an important consideration for determining who can gain access to data-connected diagrams rendered in Visio Services.

Applies to: SharePoint Server 2013

In addition to the security requirements to deploy SharePoint Server 2013, you should also review security considerations for a deployment that includes Visio Services in SharePoint Server 2013. Visio Services enables you to render Visio diagrams. These diagrams can be connected to external data, and diagram elements can be updated based on that data. Security is an important component for enabling these data-rendering scenarios. Visio Services gives you a significant level of fine-grained control for the processing and displaying of Visio diagrams and what data sources they can connect to.

Store diagrams in SharePoint document libraries

Visio diagrams must be stored in SharePoint document libraries to be opened by Visio Services. SharePoint Server 2013 maintains an access control list (ACL) for the files that are contained in the document library. By setting the library rules correctly you can limit access to a particular diagram. For information about how to work with document library permissions, see Plan site permissions in SharePoint 2013.

Visio diagrams that are connected to data

The Visio Graphics Service can connect to data sources. These include SharePoint lists (including external lists), Excel workbooks hosted on the farm, databases such as SQL Server, and custom data sources. You can control access to specific data sources by explicitly defining the data providers that are trusted and configuring them in the list of trusted data providers.

Note:

Visio Services accesses external data sources by using a delegated Windows identity. Consequently, external data sources must reside within the same domain as the SharePoint Server 2013 farm or Visio Services must be configured to use the Secure Store Service. If Secure Store is not used and external data sources do not reside within the same domain, authentication to the external data sources will fail. For more information, see Planning considerations for services that access external data sources in "Services Architecture Planning."

When Visio Services loads a data connected diagram, the service checks the connection information that is stored in the diagram to determine whether the specified data provider is a trusted data provider. If the provider is specified on the Visio Services trusted data provider list, a connection is tried; otherwise, the connection request is ignored.

Visio Services has an extensive list of preconfigured trusted data providers. For more information, see Configure Visio Graphics Service trusted data providers in SharePoint Server 2013.

Once an administrator has configured Visio Services to enable connections to a particular data source, there are additional security configurations that must be made, depending on the kind of the data source. The following data sources are supported by Visio Services:

  • Excel workbooks stored on SharePoint Server with Excel Services enabled

  • SharePoint lists, including external lists enabled through Microsoft Business Connectivity Services

  • Databases such as SQL Server databases

  • Custom Data Providers

Visio diagrams that are connected to SharePoint lists

Visio diagrams can be connected to SharePoint lists on the same farm that the diagram is hosted on. The user viewing the diagram must have access to both the diagram and the SharePoint list that the diagram is connected to. These permissions and credentials are managed by SharePoint Server 2013.

Visio diagrams can also be connected to external lists by using Microsoft Business Connectivity Services. External lists exposed through a Microsoft Business Connectivity Services External Content Type can be connected to a Visio diagram in Visio and the data can be refreshed through Visio Services. In order for a user to access data in an External List, the user must have permissions to access the External Content Type and permissions to access the external data source.

Visio diagrams that are connected to Excel Services

Visio diagrams can be connected to Excel workbooks hosted on the same farm as the diagram with Excel Services running and configured correctly. To view the diagram, the user must have access to both the diagram and the Excel workbook that the diagram is connected to. These permissions and credentials are managed by SharePoint Server 2013.

Note:

Excel workbooks can be connected to external data sources. For more information, see Data authentication for Excel Services in SharePoint Server 2013.

Visio diagrams that are connected to SQL Server databases

When a Visio diagram is connected to a SQL Server database, Visio Services uses additional security configuration options to establish a connection between the Visio Graphics Service and the database.

The authentication methods supported by Visio Services are as follows:

  • Integrated Windows authentication In this security model the Visio Graphics Service uses the diagram viewer's identity to authenticate with the database. Integrated Windows authentication with constrained Kerberos delegation is more helpful for increasing security than the other authentication methods shown in this list. This configuration requires constrained Kerberos delegation to be enabled between the application server that is running the Visio Graphics Service and the database server. The database itself might require additional configuration to enable Kerberos-based authentication.

  • Secure Store Service In this security model the Visio Graphics Service uses the Secure Store Service to map the user's credentials to a different credential that has access to the database. Secure Store supports individual and group mappings for both Integrated Windows authentication and other forms of authentication such as SQL Server Authentication. This gives administrators more flexibility in defining one-to-one, many-to-one, or many-to-many relationships. For more information, see Use Visio Services with Secure Store Service in SharePoint 2013.

  • Unattended Service Account For ease of configuration the Visio Graphics Service provides a special configuration where an administrator can create a unique mapping associating all users to a single account by using a Secure Store target application. This mapped account, known as the unattended service account, must be a low-privilege Windows domain account that is given access to databases. The Visio Graphics Service impersonates this account when it connects to the database if no other authentication method is specified. Note that this approach does not enable personalized queries against a database and does not provide auditing of database calls. This authentication method is the default authentication method that is used when you connect to SQL Server databases: if no ODC file is used in the Visio diagram that specifies a different authentication method, then Visio Services uses the credentials specified by the unattended account to connect to the SQL Server database. For information about how to use Visio Services with the unattended service account, see Use Visio Services with Secure Store Service in SharePoint 2013.

In a larger server farm it is likely that Visio diagrams will use a mix of the authentication methods described here. It is important to be aware of the following things:

  • Visio Services supports usage of both Secure Store and the unattended service account in the same farm. In diagrams that are connected to SQL Server data but do not use ODC files, the unattended account is required and always used.

  • If Integrated Windows authentication is selected, and authentication to the data source fails, Visio Services will not attempt to render the diagram using the unattended service account.

  • Integrated Windows authentication can be used together with Secure Store by configuring diagrams to use a Secure Store target application for those diagrams that require specific credentials.

See also

Secure Store for Business Intelligence service applications (SharePoint Server 2013)
Data authentication for Visio Services in SharePoint Server 2013


Data authentication for Visio Services in SharePoint Server 2013

Summary: Visio Services supports connections with Excel workbooks, SharePoint lists, SQL Server databases, and OLE DB and ODBC data sources.

Applies to: SharePoint Server 2013

Data sources are categorized as internal or external as follows:

  • Internal: Data hosted within the SharePoint farm, such as an Excel workbook or a SharePoint list.

  • External: SQL Server data, or an OLE DB or ODBC data source.

Retrieving data from a data source requires a user to be authenticated by the data source and then authorized to access the data that it contains. In the case of a diagram, Visio Services authenticates to the data source on behalf of the user who is viewing it in order to refresh the data to which the diagram is connected.

Figure: The process by which Visio Services retrieves data from a data source

Retrieving data from a data source

Which authentication method Visio Services can use to retrieve data depends on the type of the underlying data source, as outlined in the following table. For data sources that support more than one authentication method, the data connection must specify which one to use.

Data source Authentication method

SharePoint lists

SharePoint user permissions

Excel workbooks

SharePoint user permissions

SQL Server

One of:

  • Windows authentication (integrated security)

    • using Constrained Kerberos Delegation

    • using Secure Store

    • using the Unattended Service Account

  • SQL Server Authentication

OLE DB/ODBC

Varies per data source, typically a user-name and password pair stored in the connection string.

Custom data providers can also be used.

The following data sources are supported in Visio but not in Visio Services:

  • Access databases

  • Excel workbooks not hosted on SharePoint Server

  • OLAP

Connect to data hosted on SharePoint Server

Visio Services supports data-connected diagrams that are connected to data hosted within the SharePoint farm, including the following:

  • Excel workbooks residing in a document library

  • Data in SharePoint lists

Connect to Excel workbooks

Visio Services uses the diagram viewer's SharePoint Server credentials to connect to an .xlsx Excel workbook. For the authentication operation to succeed, the following conditions must be met:

  • Excel Services must be provisioned correctly and configured on the SharePoint farm.

  • The workbook must be hosted on the same farm as the diagram.

  • The diagram viewer must have at least "read" permissions to the Excel workbook.

No other configuration steps are required to enable this kind of data connection.

Note:

As part of connecting to an Excel workbook, Visio Services requests that Excel Services refresh the workbook if it contains connections to external data. In this case, the diagram viewer's identity is passed on to Excel Services so that Excel Services can authenticate to underlying data sources to refresh the workbook.

Connect to SharePoint lists

Visio Services uses the diagram viewer's SharePoint Server credentials to connect to a SharePoint list. For the authentication operation to succeed the following conditions must be met:

  • In order for a user to access data in an External List, the user must have permissions to access the External Content Type and permissions to access the external data source.

  • The diagram viewer must have at least "read" permissions to the SharePoint list.

No other configuration steps are required to enable this kind of data connection.

Connect to external data

Visio Services can connect to various external data sources, including SQL Server, OLE DB/ODBC, and custom data providers. To connect to the data source, Visio Services uses a specific data provider for each data source.

As a security measure, Visio Services must explicitly trust data providers before they can be used. For more information about trusted data providers, see Configure Visio Graphics Service trusted data providers in SharePoint Server 2013.

Connecting to a SQL Server data source can be done by using either:

  • Windows authentication

  • SQL Server Authentication

Other data sources use a connection string usually consisting of a user name and password.

Data connections

Visio diagrams use one of two kinds of connections:

  • Embedded connections

  • Linked connections

Embedded connections are stored as part of the Visio diagram. Linked connections are stored externally to a diagram in Office Data Connection (ODC) files. To use a linked connection, a diagram must reference an .odc file that is also stored in the same farm as the diagram. Each data connection consists of:

  • A connection string

  • A query string

  • An authentication method

  • Optionally, some metadata required to retrieve external data

Each kind of connection has its advantages and drawbacks discussed here; choose the one that best suits your scenario.

Connection type Embedded connections ODC files

Data sources supported

  • SQL Server

  • OLE DB/ODBC

  • Excel workbooks

  • SharePoint lists

  • Custom Data Providers

  • SQL Server (supports all authentication methods)

  • OLE DB/ODBC

Advantages

  • All connection information is stored in the diagram.

  • Embedded connections require little administrative overhead to support.

  • Embedded connections are easy to create.

  • Linked connections can be centrally stored, managed, audited, shared and access to them controlled by using a data connection library.

  • Diagram authors can use existing connections without having to create queries and connection strings.

  • If the data connection details for a data source change, an administrator only need update one ODC file. Thanks to that change, all diagrams that refer to the ODC file will use the updated connection information when the next refresh occurs. (An example of this scenario is when the database server is moved or the database name is changed.)

Drawbacks

  • If the data connection details for a data source change, all diagrams with embedded connections to that data source will have to be republished with updated connection information.

  • Embedded data connections are more difficult to audit by SharePoint administrators.

  • Linked connections may require the help of a SharePoint administrator to share, manage and secure.

  • Linked connections are saved in clear text and may contain database passwords. Extra care must be taken to help secure these files.

Choose a linked data connection, by using an ODC file, for scenarios in which you must have a data connection to an enterprise-scale relational data source such as SQL Server. Linked data connections are most useful in scenarios in which they will be shared across many users and in which administrator control of the connection is important.

Note:

If you are using Visio 2010, ODC files must first be created in Excel and exported to SharePoint Server before it can be used with Visio Services.

Choose an embedded connection for scenarios in which you have to have a quick data connection to a small or file-based data source that will only be used by some users.

ODC files can be stored in a data connection library, a special kind of SharePoint document library. Centralizing data connections in such a document library has several advantages:

  • Administrators can restrict write access to a data connection library to trusted data connection authors to make sure that only well tested and secure data connections are used by diagram authors.

  • Administrators have a single location to manage data connections for a large group of users.

  • Administrators can easily approve, audit, revert and manage data connection files by using document library versioning and workflow features.

  • Data connection libraries can be reused across other Office applications such as Excel, Excel Services, InfoPath 2013, InfoPath Forms Services, and Word.

  • End-users only have a single location to find diagram data, reducing confusion and user training.

Windows authentication

Windows authentication requires that Visio Services present to SQL Server a set of Windows credentials. This kind of credential is common on Windows networks and is the same credential used to log on to computers on a Windows domain or to connect to a computer that is running Exchange Server. Windows credentials are considered a more secure and manageable means of controlling access to SQL Server databases. However, one obstacle to using Windows authentication with Visio Services is the Windows double-hop security measure, wherein a user's credentials cannot be passed across more than one computer in a Windows network. Given that Visio Services is a multi-tiered system, special authentication methods are required for Visio Services to retrieve data on behalf of the end-user.

Figure: The double-hop security measure prevents the passing of credentials across more than one computer in a Windows-based network

The authentication method to choose depends on various factors as outlined in the following table. Choose the one that best suits your scenario.

Authentication method Kerberos delegation Secure Store Unattended Service Account

Description

Using constrained Kerberos delegation, the diagram viewer's Windows credentials are sent to the data source directly.

Using Secure Store, the viewer's Windows credentials are mapped to another set of credentials specified in a Secure Store target application.

Using Secure Store, all viewers are mapped to a unique set of credentials called the Unattended Service Account that is stored in a specific Secure Store target application specified in Visio Services Global Settings.

Data connection credentials

The Windows credentials of the diagram viewer.

The credentials specified in the Secure Store target application.

The credentials of the Unattended Service Account.

Advantages

  • The Kerberos protocol is an industry standard in credentials management.

  • Kerberos ties into the existing Active Directory infrastructure.

  • Kerberos delegation enables auditing of individual accesses to a data source.

  • Given that the diagram viewer's identity is known, diagram creators can embed personalized database queries into diagrams.

  • Secure Store is part of SharePoint Server and is easier to configure than Kerberos authentication.

  • Mappings are flexible: a user can be mapped either 1-to-1 or many-to-1.

  • Non-Windows credentials can be used to connect to data sources that do not accept Windows credentials.

  • Mappings created for Visio can be re-used by other business intelligence applications such as Excel Services.

  • The Unattended Service Account is the easiest authentication method to deploy and setup.

  • The Unattended Service Account does not require much administrative overhead.

Drawbacks

  • Additional administrative effort required to configure for SharePoint Server and Visio Services.

  • Establishing and managing mapping tables requires some administrative overhead.

  • Secure Store allows limited auditing. In the many-to-1 scenario, individual incoming users are mapped into the same credentials through a target application, effectively blending them into one user.

  • Given that everyone is mapped to the same credentials, an administrator cannot distinguish who accessed a data source.

For the authentication operation to succeed …

  • Kerberos delegation must be set up on a SharePoint farm.

  • Secure Store must be provisioned and configured on the Farm. It must also contain appropriate mapping information for a particular incoming user. Additionally the mapping information may need to be updated periodically to reflect password changes on the mapped account.

  • Secure Store must be provisioned and configured on the Farm. It must also contain the credentials for the Unattended Service Account. Additionally the mapping information may need to be updated periodically to reflect password changes on the mapped account.

  • Visio Services Global Settings must be configured to use the Unattended Service Account.

Kerberos delegation

Choose Kerberos delegation for secure and fast authentication to enterprise-scale relational data sources that support Windows authentication.

Secure Store

Choose Secure Store for authentication to enterprise-scale relational data sources that may support Windows Authentication. Secure Store is also useful in scenarios in which you want to control user credential mappings.

For information about how to use Secure Store with Visio Services, see Use Visio Services with Secure Store Service in SharePoint 2013.

Unattended Service Account

For ease of configuration the Visio Graphics Service provides a special configuration where an administrator can create a unique mapping where all users are mapped to a single set of credentials.

This account, known as the Unattended Service Account, must be a low-privilege Windows domain account. Visio Services impersonates this account when it connects to a data source on behalf of a diagram viewer.

It is a best practice to give this account as few network permissions as possible, typically only to log on to the network and to access the data source that you want users to connect to. For better security, be sure that the Unattended Service Account does not have access to the SharePoint Configuration and Content databases.

The Unattended Service Account is used by Visio Services in the following circumstances:

  • When an ODC file specifies the use of the Unattended Service Account for either Windows or SQL Server Authentication

  • When no ODC is used, and Kerberos authentication fails

Note:

The unattended account can be a local computer account of type Windows. If the unattended service account is configured as a local computer account, make sure that the configuration is identical on every application server that is running Visio Services. For manageability reasons, the best practice is to use a domain account

Choose the Unattended Service Account when you connect to small ad-hoc deployments in which security is less important or for which speed of deployment is very important.

For information about how to use the Unattended Service Account with Visio Services, see Secure Store for Business Intelligence service applications (SharePoint Server 2013).

SQL Server Authentication

SQL Server Authentication requires that Visio Services present a SQL Server user name and password to a SQL Server data source to authenticate. Visio Services extracts this user name and password from the data connection's connection string and passes it to the data source.

To reduce security risks, Visio Services impersonates the Unattended Service Account when it connects to such a data source.

Authentication against OLE DB/ODBC data sources

Authentication to third-party data sources typically requires that Visio Services present a user name and password to a data source. Like SQL Server Authentication, Visio Services extracts this user name and password from the data connection's connection string and passes them to the data source.

To reduce security risks, Visio Services impersonates the Unattended Service Account when it connects to such a data source.

Data refresh

Visio Services supports refreshing diagrams connected to one or more of the following data sources:

  • SQL Server

  • SharePoint lists

  • Excel workbooks hosted in SharePoint Server

  • Oracle 9i, 9iR2, 10g, 10gR2, 11g, 11gR2, and DB2 9.2

Note:

If the data source that you plan to connect to is not in the list above, you can add support for it by creating a Visio Custom Data Provider. This technology enables you to wrap your existing data sources into one that Visio Services can consume.

External data refresh is the result of the following set of steps through Visio Services.

Figure: Process for external data refresh

Exernal data refresh

  1. Creating a diagram: A diagram author uploads a data-connected diagram to SharePoint Server 2013.

  2. Triggering Refresh: The diagram viewer triggers refresh on a data-connected diagram.

  3. Data Connections: Visio Services retrieves data connection information for each external data source in the diagram.

  4. Trusted Data Providers: Visio Services checks whether there is a trusted data provider it can use to retrieve data.

  5. Authentication: Visio Services authenticates into the data source and retrieves the requested data on behalf of the diagram viewer.

  6. Diagram Refresh: Visio Services updates the diagram based on the data source data and returns it to the viewer.

Refresh can be triggered in one of following ways from the browser:

  • The end-user opens the diagram.

  • The end-user clicks on the refresh button on an already open diagram.

  • The end-user loads a page that contains the Visio Web Access Web Part which was configured to refresh automatically by a site designer.

    Note:

    A SharePoint site designer must place the Visio Web Access Web Part on a page and configure it to refresh periodically.

Refresh can also be triggered in third-party solutions by calling through JavaScript the Vwa.VwaControl.refreshDiagram Method of the Visio Web Access Web Part's Mash-up API.

If there are no previously cached versions of this diagram, any of these actions will trigger a refresh and update the diagram. For information about how to configure cache settings for Visio Services, see Configure Visio Graphics Service global settings in SharePoint Server 2013.


Plan for Business Connectivity Services in SharePoint 2013
See also

Summary: Use these TechNet articles to plan Business Connectivity Services in SharePoint Server 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Microsoft Business Connectivity Services is a set of services and features that provide a way to connect SharePoint Server 2013 solutions to sources of external data and to define external content types that are based on that external data. Planning for Microsoft Business Connectivity Services should include thinking about the kinds of solutions your organization requires, and planning for security and administration of those solutions.

TechNet articles about planning for Business Connectivity Services

The following articles about Business Connectivity Services are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of Business Connectivity Services in SharePoint 2013 | Describes Business Connectivity Services and how it can bring external data into SharePoint Server 2013 and Office through the cloud, hybrid, and on-premises configurations.
Building blocks | Overview of Business Connectivity Services security tasks in SharePoint 2013 | Describes Business Connectivity Services security in SharePoint Server 2013 for IT professionals, site and SharePoint Online administrators, and developers.
Checklist icon (not checked) | Plan a Business Connectivity Services solution in SharePoint 2013 | Describes how to create a plan for a Business Connectivity Services solution in SharePoint Server 2013 and SharePoint Online.

Additional resources about planning for Business Connectivity Services

The following resources about the new features and capabilities in SharePoint 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | What's New in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.

See also

Microsoft Business Connectivity Services (BCS) in SharePoint 2010


Overview of Business Connectivity Services in SharePoint 2013
See also

Updated: June 11, 2013

Summary: Understand SharePoint Business Connectivity Services (BCS) and how SharePoint Business Connectivity Services brings external data into SharePoint and Office through the cloud and on-premises configurations.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article introduces you to Microsoft Business Connectivity Services. After you read this article you'll understand:

  • What Business Connectivity Services is.

  • The business problems that Business Connectivity Services solves for and when to use it.

  • How Business Connectivity Services works.

  • What the three basic Business Connectivity Services solutions are and what they look like.

This article is your starting place for using Business Connectivity Services to create data integration solutions in SharePoint 2013 and Office 2013. You have to understand the concepts in this article before you can move on to planning, developing, and installing Business Connectivity Services data integration solutions. The examples in this article are used throughout the remainder of the Business Connectivity Services documentation.

In this article:

  • What is Business Connectivity Services?

  • How does Business Connectivity Services work?

  • What does a Business Connectivity Services solution look like?

What is Business Connectivity Services?

Business Connectivity Services is a centralized infrastructure in SharePoint 2013 and Office 2013 that supports integrated data solutions. With Business Connectivity Services, you can use SharePoint 2013 and Office 2013 clients as interfaces into data that doesn't live in SharePoint 2013 itself. For example, this external data may be in a database and it is accessed by using the out-of-the-box Business Connectivity Services connector for that database. Business Connectivity Services can also connect to data that is available through a web service, or data that is published as an OData source or many other types of external data. Business Connectivity Services does this through out-of-the box or custom connectors. The connectors, as the name implies, are the communication bridge between SharePoint 2013 and the external system that hosts the external data. For an overview of using OData in BCS from a developers perspective, see Using OData sources with Business Connectivity Services in SharePoint 2013 in the MSDN Library

SharePoint 2013 has several ways to present the external data. Probably the most common way is to present the data in an external list. External lists look and feel like regular SharePoint lists, except that they can only display external data. If you want to integrate external data alongside other data in a list or library, you would use an external data column. An external data column is a column type that you can create and add to a SharePoint list just as you would add a Person or Group or Date and Time column, except that it is displays external data. For more information about external data and external lists from an information worker perspective, see Introduction to External Data and Differences between native and external lists on Office.com. SharePoint 2013 includes Business Data Web Parts for presenting and interacting with external data and apps for SharePoint, which can also use external data. For information about apps for SharePoint, see Overview of apps for SharePoint 2013. For an overview of BCS from a developers perspective, see Business Connectivity Services in SharePoint 2013 in the MSDN Library.

Once the external data is available, you can then perform different operations on the data such as Create, Read, Update, Delete, and Query (CRUDQ). Depending on the operations that are enabled, the changes made to the data in SharePoint 2013 or Office 2013 can be automatically synchronized back to the external data source. You can search the external data by using SharePoint Search.

Which business problems does Business Connectivity Services solve?

Every company deals with data that is located in different places, is accessed in different ways, and is used for different purposes. Some of this data might live in SharePoint 2013 and some of it might not. Companies might have complete control over some of that data in file shares and databases and SharePoint 2013, as in the case of their sensitive employee records and content about product research. It is just as likely that they will use other data that they do not have control over, data that is provided by a third party, such as customer information or stock quotes. Companies then have to develop business processes that use the important data from each of those sources to accomplish their business goals.

Frequently, companies create custom applications that take data from these different data sources — both structured and unstructured — and make them available to their employees through custom interfaces that bring the structured and unstructured data together. This is usually done by in-house developers and it incurs some level of overhead to develop and maintain. Business Connectivity Services gives companies a way to easily integrate external data into SharePoint 2013 solutions and Office 2013 clients. Depending on the type of solution, you can manipulate the data and update it in the external system. You can also take it and work with it offline. Users can then work with SharePoint 2013 data and external data in the familiar SharePoint 2013 and Office 2013 tools.

Examples of Business Connectivity Services solutions

You can use Business Connectivity Services to build many types of data integration solutions. Here are some examples.

  • Help desk Enterprise help desks that provide internal technical support can use Business Connectivity Services. For example, the support tickets and the knowledge base that the help desk technicians use are stored in two separate databases, both of which are not in SharePoint 2013. By using Business Connectivity Services, the company can retrieve data from both sources, filter and sort it, and then present it for interaction in an external list in SharePoint 2013. What's more, with the correctly configured permissions, the help desk technicians can manipulate the data, while users with support questions only have permissions to search for their open support tickets to check the status. Technicians and information workers can also access the data through various Office 2013 clients. Open support tickets are routed through predefined steps by workflows. Help desk managers can view current support ticket data by technician in reports and dashboards. Typical reports indicate the number of support issues assigned to each support specialist, the most critical issues currently, and the number of support incidents that are handled by each support specialist during a given time period.

  • Artist tracker A talent agency integrates its database of artists into its internal website. The complete list of artists, their contact information, and schedules can be taken offline in SharePoint Workspace or in Outlook. Recording contracts can be generated and filled from the website, or Outlook, and a workflow guides each contract through its various stages. New artists can be added from the website or from Outlook. By using this solution, agents always have the information that they need and they can perform many key tasks by using familiar Office interfaces.

  • Sales dashboard A sales dashboard application helps sales associates in an organization quickly find the information that they need and enter new data. Sales orders and customer information are managed in an external application, such as Salesforce.com, and integrated into the solution by using Business Connectivity Services. Depending on their roles, team members can view sales analytics information, individual team members' sales performance data, sales leads, and a customer's contact information and orders. Sales professionals can view their daily calendars, view tasks assigned to them by their managers, collaborate with team members, and read industry news from a web browser, or from Outlook. By using Word 2013, managers can author monthly status reports that include data from the external systems.

For information on how to get started with BCS from a developers perspective, see Get started with Business Connectivity Services in SharePoint 2013

What distinguishes Business Connectivity Services from similar solutions?

Business Connectivity Services is just one way to integrate external data into SharePoint 2013 and Office 2013 client-based business data solutions. There are custom Java script-based solutions, custom data connections, and custom-coded Web Parts. In addition, apps for Office are also available. apps for Office can access external data directly or use the Business Connectivity Services APIs and the centralized Business Connectivity Services infrastructure. While each of these has its purpose, Business Connectivity Services offers several advantages for enterprise-scale data integration.

Centralized infrastructure Business Connectivity Services is a centralized infrastructure that supports integrated data solutions. By itself, the infrastructure is unaware of any external system or external data. Business Connectivity Services and the Office 2013 clients need to be told where the external data is, how to connect to it, and what can be done with it. This data about the external system and external data is wrapped up in a definition called an external content type. External content types make Business Connectivity Services aware of external systems. External content types are centrally stored and secured and can be shared by many Business Connectivity Services solutions. External content types allow you to deeply integrate external data into SharePoint 2013 and Office 2013 solutions. The Business Connectivity Services infrastructure is very similar in server and client environments. Because of this, the developer can create an external content type and with minimal administrative intervention and that external content type can be used in both client and server solutions. For more information about external content types from a Developers perspective, see External content types in SharePoint 2013 in the MSDN Library.

Managed authentication Another advantage of the centralized infrastructure in Business Connectivity Services is that it handles the security transactions with the external system. When the developer creates the external content type, information about which authentication protocol and credentials to use is included. Business Connectivity Services passes this configuration information to the appropriate connector and the connection is made. This means that users don't have to provide any additional credentials when they want to work with the external data. Business Connectivity Services can use credentials stored in the Secure Store Service. These stored credentials have access to the external data and they are mapped to users' individual credentials or a security group that the users are members of. This enables a single sign-on experience for the users. On the client-side, users must know the credentials that the external system requires and provide the credentials the first time that they access the external data. The credentials are then securely stored on the Windows client.

Search external content Because the Business Connectivity Services infrastructure is built into SharePoint 2013, it takes advantage of common SharePoint 2013 features such as Search. The external data is defined as a content source that SharePoint 2013 crawls and indexes. The search results from external data are security trimmed — meaning the user only sees what they have permissions to see — just as all other search results in SharePoint 2013 are. Expert users, other users, and developers can interact with external data by using the lists, Web Parts, and column features that they are already familiar with.

How does Business Connectivity Services work?

Business Connectivity Services has server-side components and client-side components. Business Connectivity Services solutions can include one or the other or both in a single solution. These two component stacks work completely independently of one another. However, they are structured very similarly. They both use the same configuration data. For the server-side, the configuration data is stored in an external content type. External content types are stored in the Business Data Connectivity (BDC) Metadata Store database. For the client-side, the configuration data is stored in a BDC model on the client in the BDC client-side cache. The BDC model is just a version of the external content type that is exported to an XML file. The XML file is imported into the Office client. The server component stack and the client component stack can access the same external content sources. The two stacks are distinguished by the user interfaces, where and how the data that define the external connection and external system are stored, and where the services run.

Server-side solutions

In Business Connectivity Services server-side solutions, users interact only with external data in a browser on a SharePoint site. This can be on any type of SharePoint site that supports external lists, external data columns, external Web Parts, or apps for SharePoint. SharePoint Enterprise Search of external data is supported in the browser as well.

For Business Connectivity Services to connect to an external data source and interact with the data there, that external system must be defined in a way that Business Connectivity Services understands in an external content type. An external content type contains the name of the external system and what kind of data source it is, what type of authentication to use for connections, where it can connect to, which operations can be performed, and, optionally, any filters and sorting instructions to be used so that only the desired data is returned and that the data is in the correct order.

Figure: Business Connectivity Services server-side components

The layers of the BCS server side architecture

  1. A user opens a SharePoint web page that contains external data to interact with it. At a minimum, if the user has permissions to access the data, the user will be able to read it. In addition, depending on how the supported operations are defined in the external content type and the level of permissions that the user has to the external content type, the user might be able to create new records, update existing records, and delete existing records. If the user is in an Enterprise Search website, and the user has the necessary permissions, the user can run queries against the records. This data can be in an external list, external data columns, external Web Parts, or apps for SharePoint.

  2. A request for the external data is created and passed to the BDC Server-Side Runtime service. The BDC Server-Side Runtime does a variety of jobs. It is the working component of Business Connectivity Services and handles most of the actual activities involved with taking requests for external data, making connections and interacting with the external data, and returning data to the user.

  3. The BDC Server-Side Runtime accesses the BDC Metadata Store and retrieves the external content type. The BDC Metadata Store is a database stored in SQL Server. It only contains information about the connections. No external data is stored in the BDC Metadata Store or anywhere else in SharePoint 2013.

  4. The BDC Server-Side Runtime reads the external content type to see how to connect to the external data source. The BDC Server-Side Runtime retrieves credentials from the Secure Store if it is necessary. For more information about the Secure Store, see Plan the Secure Store Service (SharePoint Server 2010) in the SharePoint Server 2010 Library.

  5. The BDC Server-Side Runtime passes the request to the connector that can communicate with the external system.

  6. The connector establishes communication with the external system, retrieves the data, and performs any write actions that might be pending. The external data is filtered and sorted before it is returned back through the chain to the user.

Client-side solutions

In the client-side version of Business Connectivity Services solutions, the Office 2013 applications interact with external data. A client-side solution can run independently of SharePoint. Not all of the Office 2013 applications interact with external data and some of them only do so in a read-only manner. The following table provides details on which operations are supported, how the applications can access the data, and how the connection is made.

Table: Applications and operations supported in Business Connectivity Services

Application | Supported operations | Access external data online or offline | ClickOnce or import BDC model
Word | Read only | Online | Import BDC model
Access | CRUDQ | Online | Import BDC model
Visio | Read only | Online and offline | Import BDC model
InfoPath | CRUDQ | Online and offline | Import BDC model
Excel | CRUDQ | Online | Import BDC model
Outlook | CRUDQ | Online and offline | Click Once installation

Before you can work with external data in an Office 2013 client you must have the prerequisite software listed here Prerequisite software that is needed to work with external data on Office.com

In the client-side solutions, there is some work that must be done before users can access external data through the Office client applications.

  • First, when the developer creates the external content type, it must be configured to support Office clients.

  • If the solution uses Access, the external content type must be exported as a BDC file and then imported into Access.

  • If the solution uses Word, InfoPath, or Excel, the application will install Microsoft SQL Server Compact 4.0 and Microsoft .NET Framework 4, and then connect to the external data the first time that the application is used.

  • If the solution uses Visio, you will use the Link Data To Shapes feature in Visio to browse to an external list and connect to it.

The following diagram shows the client-side architecture of Business Connectivity Services. You can assume that either the BDC model file was imported into the indicated applications or connections have been made to Outlook.

Figure: Business Connectivity Services client-side architecture

The components of the BCS Client side architecture

  1. A user attempts to access external data through one of the Office applications and the application generates a request for the data.

  2. The request is passed to the BDC Client Runtime. The BDC Client Runtime performs the same functions as the BDC Server-Side Runtime.

  3. The BDC Client Runtime queries the BDC model, which is stored in the BDC client-side cache, for the details about how to connect to the external source, which credentials to use, and what the external data source is. The BDC client-side cache is an instance of Microsoft SQL Server Compact 4.0, which is installed the first time that a client-side Business Connectivity Services solution is used.

  4. If the user's credentials don't have access to the external data source, the user is prompted to enter a set of credentials that do. Those credentials are then stored in the Windows Credential Manager for later use.

  5. Once the connection information is retrieved, the BDC Client-Side Runtime passes the request to the appropriate connector, which establishes communication with the data source and performs the requested and permitted operations. As with the server-side solution, the authentication is handled by the Business Connectivity Services client.

  6. The data is then filtered and sorted by the external system and returned through the communication chain to the Office application.

What does a Business Connectivity Services solution look like?

At the most fundamental level, every Business Connectivity Services configuration is driven by the location of the Business Connectivity Services infrastructure and the location of the external system that hosts the external data. There are only two ways that the Business Connectivity Services infrastructure and the external system can relate to one another. The Business Connectivity Services infrastructure and the external system can be on your corporate network (all-on-premises), or both the Business Connectivity Services infrastructure and the external system are in the cloud (cloud only).

On-premises solution

The first solution is one where the SharePoint 2013 farm and the external system are both behind a company's firewall and live in company-controlled data centers and users will have to be on the company's network to access it. This first type is an all-on-premises solution. The following diagram shows an example of an all-on-premises configuration. In this example, users interact with external data through an external list and through Outlook. The external data source is a SQL Server database that contains customer contact information.

Figure: Diagram of an all-on-premises solution

A structured on premises BCS solution. Showing the

  1. A user goes to an external list on a SharePoint site. The external list creates a request for data by using the user's Windows credentials.

  2. The request is sent to the BDC runtime in the SharePoint farm.

  3. The BDC runtime accesses the external content type for the list (in the BDC Metadata Store) to see how to access the external system and which operations can be performed. By using either the user's credentials or the credentials from the Secure Store (as defined in the external content type), the BDC runtime passes the request to a connector that can handle the request, in this case the SQL connector.

  4. The SQL connector accesses the external data source and retrieves the data, and applies any formatting and filtering as specified in the external content type. The data is passed back through the request chain to the list where the user can interact with it.

  5. The user wants to take this data on a portable computer in Outlook so that the user can use the Connect to Outlook feature on the external list to take the data offline.

  6. The Click Once installation runs and installs the required BDC model on the client. This lets the BDC Client-Side Runtime access the external data directly.

  7. Outlook then connects to the external data by using the configuration in the BDC model and synchronizes it into an Outlook SharePoint external list, formatted as a contacts list.

  8. The user can then interact with the contact data, and any changes that the user makes can be written back to the external data source either by an on-demand synch or by waiting six hours for the automated synchronization.

Cloud-only solution

Business Connectivity Services in a SharePoint Online tenancy can access data from various cloud services. For example, SharePoint Online can access data from a third-party stock quotes service or from the Windows Azure Marketplace Data Market by using the Business Connectivity Services web service connector. Because this type of solution doesn't include any customer-maintained SharePoint 2013 farms and hardware and consists of only cloud-based services, it is called a cloud-only solution.

Figure: Diagram of a cloud-only solution

The sequence of data flow for BCS All In The Cloud

  1. The user logs on to SharePoint Online and opens an external list that the user has rights to.

  2. The Business Data Connectivity service runtime queries the external content type for the list in the Business Data Connectivity services metadata store to learn how to access the external system, which operations can be performed, and which credentials to use. The external content type tells the BDC runtime to retrieve the necessary credentials from the Secure Store.

  3. The Business Data Connectivity service runtime passes the request (SOAP over HTTP) to the endpoint of the SQL Azure Windows Communication Foundation (WCF) service.

  4. The SQL Azure service returns the data in a SOAP envelope.

  5. The SharePoint Online site displays the external list in the user's browser. The user can then perform all the configured operations on the data source for which the user has permissions.

For an overview of the procedures to deploying this solution, see Deploy a cloud-only Business Connectivity Services solution in SharePoint 2013. For the procedures to deploy this solution, see Make an External List from a SQL Azure table with Business Connectivity Services and Secure Store on Office.com

Hybrid solution

The BCS hybrid solution makes use of SharePoint Online and SharePoint 2013 on-premises. It integrates data from an on-premises OData service endpoint into a SharePoint Online tenancy. The solution looks as shown in the following video and diagram. For more information about SharePoint hybrid configurations and how data and authentication flow in the SharePoint BCS hybrid solution, see Hybrid for SharePoint Server 2013.

Video: Watch a demonstration of the BCS hybrid solution overview.

Video (play button) icon

Figure: Business Connectivity Services hybrid solution

Shows the sequence of actions for BCS hybrid

  1. An information worker logs on to the SharePoint Online tenancy using the user's federated account and opens an app for SharePoint or external list that needs data from an on-premises OData data source. OData is an open protocol that is used to query and update data. For more information about OData, see Introducing OData: Data Access for the Web, the cloud, mobile devices and more in the MSDN Library.

  2. The external list creates a request for the data and sends it to Business Connectivity Services. Business Connectivity Services looks at the connection settings object to see how to connect to the data source and which credentials to use.

  3. Business Connectivity Services retrieves two sets of credentials.

    1. Business Connectivity Services retrieves the Secure Channel certificate from the Secure Store in SharePoint Online. This is used for SharePoint Online authentication to the reverse proxy.

    2. Business Connectivity Services retrieves an OAuth token from the Windows Azure AD Service. This is used for user authentication to the SharePoint 2013 on-premises farm. You get access to the Windows Azure AD service with your SharePoint Online subscription. It is a security token service that manages security tokens for users of SharePoint Online. For more information about the Access Control Service, see Access Control Service 2.0 in the MSDN Library. For more information about OAuth, see OAuth 2.0 on the web.

  4. Business Connectivity Services sends an HTTPS request to the published endpoint for the data source. The request includes the client certificate from the Secure Store and the OAuth token, as well as a request for the data. The reverse proxy authenticates the request by using the client certificate and forwards it to the on-premises SharePoint 2013 farm. For more information about publishing SharePoint to the Internet, see SharePoint publishing solution guide in the Forefront Technical Library.

  5. The on-premises farm retrieves the user's cloud identity from the OAuth token (for example, user123@contoso.com), and through the Client Side Object Model (CSOM) code, maps it to their on-premises identity (for example, Contoso\user123). The on-premises credentials are mapped to credentials that have access to the external data via a Secure Store target application.

  6. The on-premises Business Connectivity Services forwards the request to the OData Service endpoint. The OData Service authenticates the request (via IIS) and returns the data, which is passed back through the chain to the external list for the user to work with.

See also

What's New in SharePoint 2013 Resource Center
Resource Center: Business Connectivity Services in SharePoint Server 2010
Deploy a cloud-only Business Connectivity Services solution in SharePoint 2013
Make an External List from a SQL Azure table with Business Connectivity Services and Secure Store

Change History

Date | Description
June 11, 2013 | Added new video: "BCS hybrid solution overview."
July 16, 2012 | Initial publication


Overview of Business Connectivity Services security tasks in SharePoint 2013
See also

Published: October 16, 2012

Summary: Understand Business Connectivity Services (BCS) security in SharePoint 2013 for IT professionals, site and SharePoint Online administrators, and developers.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Providing security for the data that your customers work with through Microsoft Business Connectivity Services (BCS) is a critical part of every BCS solution. Unlike regular SharePoint data, which is stored in a SharePoint content database, the data that BCS solutions make visible live outside of SharePoint in external systems. BCS provides the channel that SharePoint uses to get to the external data. In addition to working within the usual SharePoint products security controls such as site access permissions, and list permissions, BCS solutions have to deal with additional communication and security layers. For example, the external system might use a different authentication mechanism or provider, and require different credentials than the ones your users use to access SharePoint products with. Because there are more security layers in a BCS solution, there are more security configuration tasks involved.

Important:

Prerequisites Before reading this article, you should read Overview of Business Connectivity Services in SharePoint 2013 and Plan a Business Connectivity Services solution in SharePoint 2013.

The Business Connectivity Services security tasks fall to three different roles: the IT professional; the SharePoint Online administrator, site collection administrator, or site owner; and the developer. The following examples describe what each role is responsible for.

  • IT professionals have the responsibility of managing the security on the Metadata Store and its contents. They also handle account and group administration and credential mapping in the Secure Store Service.

  • SharePoint Online administrators, site collection administrators, and site owners are responsible for understanding the kind of security the external system uses and how to configure no-code, or declarative, external content types to communicate with it. They are also responsible for planning and applying security to external lists and business data Web Parts.

  • BCS solution developers are responsible for understanding the kind of security that the external system uses and how to configure the BDC model to communicate with it, and security around development and deployment of apps for Office and SharePoint.

In this article:

  • Business Connectivity Services security for IT professionals

  • Business Connectivity Services security for SharePoint Online administrators, site collection administrators, and site owners

  • Business Connectivity Services security tasks for developers

Business Connectivity Services security for IT professionals

Delegation of administration to the Business Data Connectivity service

The first task that the farm administrator should perform after creating an instance of the Business Data Connectivity service is to delegate administration of the service to a different account, preferably one without farm administrator rights. This best practice follows the principle of least-privilege. The delegated account will be granted the necessary permissions to open the SharePoint Central Administration website and access to the Business Data Connectivity service service application. This should be the primary account that is used to administer the service. The only permission that can be granted or revoked is Full Control.

Managing permission on the Metadata Store and its contents

The Metadata Store holds the external content type, the external system, and the BDC model definitions that the Business Data Connectivity service application uses. One of the main jobs of the BCS Services administrator is to manage security of the Metadata Store and all the items it contains. Items in the Metadata Store get their permissions in two ways. First you can directly apply the permissions to the Metadata Store, BDC models, external systems, or external content types. The second way is by inheriting them from a higher level item. Both methods are shown in the following figure.

Figure: Metadata Store permissions

Diagram of metadata store permissions

  • Inheritance Inheritance happens in two ways. First when any item is added to the Metadata Store, it inherits the permissions configuration of the Metadata Store itself. Second, the Metadata Store, external system, and external content type items can forcibly overwrite the permissions of items that are below them in the hierarchy. This happens when you select the Propagate permissions to all… and click OK when you are setting permissions on the parent item.

  • Direct Application If the permissions that an item has inherited from its parent when the item was added to the Metadata Store or when they were forcibly overwritten, do not meet your needs, you can manually adjust them on the items themselves.

You can directly apply four permissions:

  • Edit This allows the user or group to edit the item

  • Execute This allows the user or group to execute the operations (create, read, update, delete, query) of external content types in the Metadata Store. All users of a BCS solution must have execute permission on the associate external content type.

  • Selectable in Clients This allows the user or group to use the External Content Type for External Lists, and apps for SharePoint by making them available in the external item picker

  • Set Permissions This allows the user or group to set permissions on the item. Every item must have at least one user or group that has the Set Permissions permission.

Recommendations for managing Metadata Store permissions

  1. Pick one account, probably your Business Connectivity Services administrator account or your SharePoint Online administrator account and grant it Set Permissions at the Metadata Store level. This will satisfy the requirement that every item has one user or group that has Set Permissions with a securely managed administrative account. If you don't explicitly set an account, the farm account is used by default. Do not select the Propagate permissions to all option. You don't have to select the Propagate permissions to all option because every item will inherit this configuration when it is added to the Metadata Store. This also prevents unnecessary accounts from gaining access to any external systems, BDC models, or external content types that they shouldn't have.

  2. Use the direct application method, configure the permissions on the individual items, again not selecting the Propagate permissions to all option. This will allow you to maintain unique permissions configuration on each object.

  3. Periodically, as part of your maintenance and operational plans, review the permissions configuration starting from the Metadata Store level and moving down the hierarchy to ensure that each item has the correct permissions configuration. If the permissions configuration has drifted from what it should be you should manually reconfigure them.

  4. You should only use the Propagate all permissions option when you must completely reset all the permissions on the parent item and all its children. Note that this is a destructive process and all custom permissions on child items are lost. This action can break BCS solutions for users or groups that lose their permissions.

Mapping accounts and groups in Secure Store Service

In most cases, your users' accounts won't be able to directly access the external data for a BCS solution. This is true when the external system doesn't use Active Directory Domain Services (AD DS) to secure the external data; as it is secured in different way. For example, your external data might be in SQL Server but the database is secured using SQL Server security. This problem is solved in BCS solutions by using the Secure Store Service to map your Active Directory Domain Services (AD DS) accounts or groups to external system credentials. To ensure that only the intended people can access the external data, you have to plan out the credential mapping between the two systems. The Secure Store service stores the mappings in a target application. Before you create the target application, you must know who requires access to the external data with the AD DS credentials and the credentials for the external system. You can also choose an administrator for the target application. There are two ways to configure your mappings:

  • Group mapping In group mapping target application, you add AD DS user accounts and security groups to the target app and then map them to a single set of credentials from the external system. This is the easiest way to manage access to the BCS solution.

  • Individual mapping In an individual mapping target application you can only map a single AD DS user account to a single set of credentials from the external system. Basically, this is a 1:1 mapping. You would generally do this if you have very few accounts to manage or if you want to track access and activity on the external system.

For more information about how to plan for the Secure Store Service see, Plan the Secure Store Service in SharePoint Server 2013. For more information about how to configure the Secure Store Service and how to create target applications see, Configure the Secure Store Service In SharePoint 2013.

Managing permissions on the BDC Service application

By default, every Web Application in your farm is granted access to the BDC Service application through the server farm account. If you want to restrict access to only certain web applications, you can change this by removing the server farm account and then adding the Application Pool Identity account of desired the web applications. By doing this you control which web applications have access to the BDC Service application. For more information, see Set Permissions to a published service application (SharePoint Server).

If you are publishing the BCS Service Application to other farms, you have to add the Farm IDs of the consuming farms. For more information, see Share service applications across farms (SharePoint Server 2010).

Business Connectivity Services security for SharePoint Online administrators, site collection administrators, and site owners

SharePoint Online administrators and site collection administrators and site owners have to manage the security for site collections and sites, as well as external lists on those sites. If you are in this role and you will be creating external content types by using SharePoint Designer 2013, you have to understand the different authentication modes the Business Connectivity Services supports, including using a target application in Secure Store. The following table provides information about security tasks for administrators.

Table: Security tasks for administrators

Security task Article Description

Set authentication mode and credentials in a no-code external content type

  1. Business Connectivity Services authentication overview

  2. Introduction to external data

  3. Configure the Secure Store Service In SharePoint 2013

  1. Learn what the supported authentication modes are for BCS.

  2. An Office.com introduction to external data.

  3. Configure storage of authorization credentials in Secure Store Service on a SharePoint Server 2013 farm. A video demonstration is included.

Manage external list permissions

  1. Introduction: Control user access with permissions

  2. What is uniquely secured content?

  3. Edit permissions for a list, library or individual item

  1. An Office.com article on understanding and managing user permissions in SharePoint products including SharePoint Online.

  2. Uniquely secured content is any content that does not use the same permissions settings as the site collection that contains the content. Instead, the content has its own unique permissions settings. When you are working with permissions on your site, you might see a message about uniquely secured content on the permissions page.

  3. This topic explains how to assign unique permissions for an individual site, list, library, folder, list item, or document.

Manage SharePoint Online BCS

  1. Business Connectivity Services security for IT professionals

  1. A description of security related administrative tasks for BCS.

Manage the Officeclient Trust Center

  1. View my options in settings in the Trust Center

  1. The Trust Center is where you can find security and privacy settings for Microsoft Office programs. With the consistent appearance of the ribbon in Office programs, steps to find the Trust Center are the same for each program.

Business Connectivity Services security tasks for developers

Out of all the roles that are involved in Business Connectivity Services solution security tasks, the developer has to have the deepest understanding of the BCS security architecture and how to use it to create a secure BCS solution. The following table presents summaries of the level security tasks that the developer performs and links to detailed information in the MSDN Library.

Table: Security tasks for developers

Developer security task Article Summary

Configure authentication modes for external content types

  1. Using OData sources with Business Connectivity Services in SharePoint 2013

  2. How to: Create an external content type from an OData source in SharePoint 2013

  3. External content types in SharePoint 2013

  4. How to: Create external content types for SQL Server in SharePoint 2013 Preview

  1. Learn how to get started creating external content types based on OData sources and using that data in SharePoint 2013 Preview or Office 2013 components.

  2. Learn how to use Visual Studio 2012 to discover a published OData source and create a reusable external content type for use in Microsoft Business Connectivity Services (BCS) in SharePoint 2013 Preview.

  3. Learn what you can do with external content types and what you must have to start creating them in SharePoint 2013 Preview.

  4. Learn how to create an external content type for SQL Server in SharePoint 2013 Preview. Creating an external content type is a pivotal task when you are working with external data. An external content type contains important information about connections, access, methods of operation, columns, filters, and other metadata that is used to retrieve the data from the external data source.

Manage OAuth, exchange of tokens and building web requests

  1. Authentication, authorization, and security in SharePoint 2013

  1. Learn about authentication and authorization in SharePoint products, claims-based identity and authentication, and, forms-based authentication.

Manage development environment security

  1. Start: Set up the development environment for SharePoint 2013

  1. Learn the steps to set up a SharePoint 2013 Preview development environment by installing SharePoint 2013 Preview and Visual Studio 2012.

Manage security for apps for Office and SharePoint

  1. Deploying and installing apps for SharePoint: methods and options

  1. Learn about the methods for publishing, installing, and uninstalling an app for SharePoint.

Manage security on events and alerts from external systems

  1. External events and alerts in SharePoint 2013

  1. Learn the concepts behind creating event receivers in SharePoint 2013 Preview that can be attached to external lists and execute when the external data that the list represents is updated.

See also

Overview of Business Connectivity Services in SharePoint 2013

Business Connectivity Services Security Overview
Plan a Business Connectivity Services solution in SharePoint 2013


Plan a Business Connectivity Services solution in SharePoint 2013
See also

Summary: Create a plan for your Business Connectivity Services (BCS) solution in SharePoint 2013 and SharePoint Online.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Before you read this document, make sure that you have read What's new for Business Connectivity Services in SharePoint 2013 and Overview of Business Connectivity Services in SharePoint 2013.

For an overview, what's new, and how to get started with BCS for developers, see Business Connectivity Services in SharePoint 2013, What's New in Business Connectivity Services in SharePoint 2013, and Get started with Business Connectivity Services in SharePoint 2013 in the MSDN Library.

Unlike other SharePoint 2013 features and solutions, Microsoft Business Connectivity Services solutions have no predefined form. You don't know what they will look like or, precisely, what they will do before you understand the business needs that drive the solution. You don't know how users will interact with them, or how they need to be secured. By definition, every Business Connectivity Services solution is a custom-built solution. You will have to use SharePoint Designer 2013 or Visual Studio 2012 during your solution development to define the external data source. There are no out-of-the-box Business Connectivity Services configurations or templates that you can use. The only thing that you can say about a Business Connectivity Services solution before it is designed and implemented is that you know it will serve to integrate external data deeply into SharePoint 2013 and Office 2013.

Before you can begin to develop a design for your Business Connectivity Services solution, you must understand the business needs that are driving the solution and the environment in which the solution must operate. This article takes you through five questions that you must have answers to before you can design your Business Connectivity Services solution. Be sure to collect all this information and communicate it to all the key stakeholders to review and approve. When you do this, you will ensure that everyone involved has the same understanding of the needs of the project and how the solution will work.

In this article:

  • Where is the data?

  • How is the data surfaced?

  • How is the data secured?

  • How will the data be consumed?

  • How will you assign permissions to the solution?

Where is the data?

Your first step in planning your Business Connectivity Services solution is to understand where the external data that you want is. You need to understand this from three perspectives.

Network perspective

You need to understand where the external data source is in relation to the network that Business Connectivity Services and your users will be on. To help you figure this out, draw a diagram of the three components on your network and see where they lie. For example, you can see whether they are all on your internal network and inside your firewall. Or, you could see that the Business Connectivity Services infrastructure and the external data source are separated by a firewall or boundary network and that they are on completely separate networks. Here are some basic rules that you can use to guide your design:

  • If the external data source, the Business Connectivity Services infrastructure, and the consumers of the solution are all on your corporate-controlled network, then you will be implementing an all-on-premises solution. For more information about how to deploy an all-on-premises solution, see Configure Business Connectivity Services solutions for SharePoint 2013.

  • If the Business Connectivity Services infrastructure and the users are on your corporate-controlled network (internally or by VPN), you will be deploying an all-on-premises solution, even if the external data source is outside of your network, such as on the Internet. In this scenario, Business Connectivity Services will need to communicate with the external data source through your corporate firewall and you need to plan for that traffic.

  • If you will use Business Connectivity Services in SharePoint Online and the external data source is in the cloud, then you will be implementing a cloud-only solution.

  • Look at where the users will be accessing the Business Connectivity Services solution from. Be sure to consider if the data communications between the client and the Business Connectivity Services solution need to be encrypted and whether the underlying network infrastructure can support the added load. Also, make sure that the browsers and Office clients support the functionality that the solution provides. For more information about browser support for SharePoint products, see Plan browser support in SharePoint 2013.

For more information about how the location of the external data affects the design of your Business Connectivity Services solution, see Business Connectivity Services in SharePoint 2013 in the MSDN library.

For more information on how a Business Connectivity Services solution may impact your network and SharePoint products farms, see Performance and capacity management (SharePoint Server 2013).

External system perspective

The external data is hosted by an external system. For example, the data might be in a SQL Server database, in which case SQL Server is the external system. The connector that the external content type uses to connect to the data is sometimes determined by what the external system is. For example, there are out-of-the-box connectors for SQL Server 2008 with SP1 and Cumulative Update 2. If you are connecting to Exchange Server 2013, you will use a .NET connector. In other cases, it is more important how the external data is made available. For more information, see How is the data surfaced? later in this article.

Administrative perspective

You will need to know who has daily administrative responsibility over the external data source. This is the group that you will need to work with to help set up connectivity to the external data. They will be able to tell you how the data is made available for external consumption, how it is secured, and so on. You might need them to create credentials in the external system for you to use. Be prepared to answer their questions on the impact of your Business Connectivity Services solution on their data and their external system.

How is the data surfaced?

Business Connectivity Services solutions can connect to an external data source through OData, SQL Server, Windows Communication Foundation (WCF) service, and .NET Assemblies. You need to know (and you can find this out from the external system administrators) how the data is surfaced for external consumption. How the external data is surfaced determines what development tools you will use to create the external content type. The following table shows you which tools to use based on the external data source.

Table: Tools used to create the external content type

Data source type | Tool to use to create the external content type
Windows Communication Foundation | SharePoint Designer 2013
SQL Server | SharePoint Designer 2013
SQL Azure | Start with SharePoint Designer 2013 against a local SQL Server, then you need to manually modify the connection settings to work with SQL Azure
All OData sources (this includes any SQL Server data source that is surfaced via OData) | Visual Studio 2012

For more information about how to set up the development environment for Business Connectivity Services, see How to setup a development environment for BCS in the MSDN Library.

How is the data secured?

Business Connectivity Services handles all authentications for communications between itself and the external system. Basically, Business Connectivity Services presents the external system with information that allows the external system to authenticate (determine whether you are who you say you are) the request and then authorize access to data in the external system. Business Connectivity Services supports many types of authentication. For more information about the types of security that Business Connectivity Services supports, see Business Connectivity Services security overview (SharePoint Server 2010). For more information on the security related tasks for Business Connectivity Services, see Overview of Business Connectivity Services security tasks in SharePoint 2013.

For your Business Connectivity Services solution design, you have to know what authentication mechanism the external system requires. This way, you will know how to configure Business Connectivity Services so that it presents the authentication information in the manner that the external system requires. Business Connectivity Services supports three authentication models:

  • Credentials-based authentication In credentials-based authentication models, credentials are passed from Business Connectivity Services to the external system. Credentials are a combination of a user name and some form of password. Business Connectivity Services has a number of ways of doing this, including passing the credentials of the user who is logged on, passing the credentials of the service that is making the request, or mapping the credentials of the user who is logged on to a different set of credentials that the external system recognizes. For more information, see Business Connectivity Services security overview (SharePoint Server 2010).

  • Claims-based authentication In some authentication scenarios, the external system will not accept credentials directly from Business Connectivity Services. However, the external system will accept them from a third-party authentication service that it trusts. The third-party authentication service (a security token provider) accepts a grouping of information (known as assertions) about the requestor. The whole grouping is known as a claim, and a claim can contain more information about the requestor than just the user name and password. For example, a claim can contain metadata about the requestor, such as the requestor's email address or the security groups to which the requestor belongs. The third-party authentication service performs the authentication of the requestor based on the assertions in the claim and creates a security token for the requestor to use. The requestor (Business Connectivity Services) then presents the security token to the external system, and the external system looks to see what data the requestor has been authorized to access.

  • Custom authentication If the external system that you are working with does not support credentials-based or claims-based authentication, then you will have to develop, test, and implement a custom solution that takes the credentials that Business Connectivity Services can produce and translates them into a format that the external system will accept. You can implement a custom authentication solution for OData data sources that are secured either by OAuth or a custom ASP.NET HTTP module and are on premises.

How will the data be consumed?

As part of your requirement gathering, you need to find out from your business stakeholders what they need the solution to do and how they need users to interact with it. They might need the users to interact with the data in SharePoint Server, via external lists, and external Web Parts and in Office 2013 clients. Or, they might need the solution to surface data through an apps for Office and SharePoint application in SharePoint Online or an on-premises SharePoint installation. For more information about apps for Office and SharePoint, see Overview of apps for SharePoint 2013. Or, the solution might require some other combination of browser, client, and application access to the external data.

How users access the data affects how you will scope the external content type that Business Connectivity Services uses to access the external data. If your Business Connectivity Services solution requires an apps for Office and SharePoint application, then the external content type must be scoped to that application. For more information about apps for Office and SharePoint, see Install and manage apps for SharePoint 2013. If your Business Connectivity Services solution will not use apps for Office and SharePoint to access external data, then the external content type must be scoped to the Business Data Connectivity service application. For more information about Business Data Connectivity service application-scoped external content types and how to create them, see SharePoint 2013: Create external list based on app-scoped external content types.

Business Connectivity Services-scoped external content types are stored centrally in the BDC Metadata Store. For an on-premises SharePoint 2013 installation, external content types are stored in the BDC Metadata Store and a farm administrator manages security on them. You can share these external content types with multiple Business Connectivity Services web applications. For SharePoint Online, external content types are stored in your tenancy and you can use them in all the site collections in your tenancy.

The apps for Office and SharePoint-scoped external content types are stored as an XML file in the app for Office and SharePoint application itself. They cannot be used by any other apps for Office and SharePoint applications whether they are in an on-premises installation or in a SharePoint Online tenancy.

Connection settings objects contain connection information, such as a service address for the service that surfaces the external data, the type of authentication to use, the Internet-facing URL, and the names of any required certificates. Connection settings objects are separate objects from an external content type. When a Business Connectivity Services solution needs to connect to an external system, it uses the information in a connection settings object. You would typically choose to define the connection information separately from the external content type when the external content type developer doesn't know, or doesn't have access to, the necessary connection information when the external content type is developed. Connection settings objects can be used only with OData data sources. Both app-scoped external content types and service-scoped external content types can use connection settings objects. Connection settings objects are managed in the SharePoint Central Administration website for an on-premises SharePoint installation and in the Tenant Administration tool for SharePoint Online. All Business Connectivity Services solutions must be granted permissions to use a connection settings object. Connection settings objects can be used by multiple Business Connectivity Services solutions. For more information in connection settings objects, see Business Connectivity Services in SharePoint 2013 in the MSDN Library.

If your apps for Office and SharePoint will be accessing an OData source, then you can automatically create the app-scoped external content types by using Visual Studio 2012. Visual Studio 2012 has a tool built into it so that you can create external content types by pointing Visual Studio 2012 at the OData service URL. App-scoped external content types can be used by any external data lists. App-scoped external content types can also be used by any custom code, such as .NET code that uses CSOM or JavaScript code that uses JS CSOM. For information in how to set up the developer environment for BCS, see How to setup a development environment for BCS in the MSDN library.

How will you assign permissions to the solution?

In every Business Connectivity Services solution, you must plan who will have which permissions on which objects. This is how you both restrict and grant access to the solution to the appropriate users in the appropriate way. You will have to work with the external system administrator and the SharePoint farm administrators, site collection administrators, site administrators, and SharePoint Online tenant administrators to configure permissions. At the most fundamental level however, here is what you must consider during your planning.

There are three fundamental roles that are involved with every Business Connectivity Services solution:

  • Administrative roles These roles are responsible for managing permissions on the external system, creating and managing the Business Data Connectivity service application, importing Business Data Connectivity (BDC) models into the BDC Metadata Store, and managing permissions on the BDC Metadata Store and all the objects in it. If apps for SharePoint are using Business Connectivity Services, then the SharePoint farm administrators will also be involved with publishing the application and creating and managing connection objects. Generally, these duties are performed by people who are SharePoint farm administrators, people who are administrators of the external system, and anyone who has delegated administrative rights.

  • Developer or designer roles These roles are responsible for creating the external content types, the BDC models, and the apps for SharePoint that use Business Connectivity Services. They are the ones who are primarily responsible for understanding all the business needs for the solution.

  • User roles People in these roles consume and manipulate the external data in the Business Connectivity Services solution. There can be multiple user roles in your solution, each with different levels of permissions. For example, in a support-ticketing system scenario that uses Business Connectivity Services to integrate external information into the solution, the Tier I Help Desk technicians might be granted only the ability to read and start workflows on a ticket, while Tier II and Tier III technicians have the ability to update tickets.

There are also four main aspects to every Business Connectivity Services solution for which you will manage permissions:

  • External system Every external system will have a method for performing authentication and authorization. (For more information, see How is the data secured? earlier in this article.) You need to work with the external system administrator to identify how to grant access to the solution users according to the principle of least privileges. In general, you will map a group of users from the Business Connectivity Services side to a single account on the external system side and use the single external system account to restrict access. Another way is to do a 1:1 mapping between individual accounts on each system. In either case, unless the external system can directly accept the credentials with which the user authenticates to SharePoint, you will need to use the Secure Store Service. For more information about the Secure Store, see Plan the Secure Store Service in SharePoint Server 2013 and Configure the Secure Store Service in SharePoint 2013. For more in-depth information about the authentication models that Business Connectivity Services supports, see Business Connectivity Services security overview (SharePoint 2010). For more information about how to configure SharePoint for OAuth, see Learn about the OAuth authentication and authorization workflow for cloud-hosted apps in SharePoint 2013 in the MSDN Library.

  • Business Connectivity Services central infrastructure Business Connectivity Services is a shared service application and you configure it and manage permission on it in Central Administration. To create a shared service application, you must have farm administrator rights. You can also delegate administration to the Business Data Connectivity service application as needed after you create it. In Central Administration, you also manage the assignment of permissions to the BDC Metadata Store. Permissions assigned to the BDC Metadata Store can be propagated to objects in the BDC Metadata Store. In the BDC Metadata Store, you manage BDC models, external systems, and external content types. You must assign execute permissions on an external content type to all users who will be using the Business Connectivity Services solution. The following tables provide a detailed mapping of abilities, permissions, and objects.

    The BDC Metadata Store This SQL Server database that stores the model definitions, external content types, and external system definitions.

    Table: Mapping permissions on the BDC Metadata Store

    To allow a user or group to… Give them the following permissions… On…

    Set permissions on any object contained in the BDC Metadata Store via propagation

    SetPermissions

    The BDC Metadata Store

    The model A model is a XML file that contains sets of descriptions of one or more external content types, the related external systems, and information that is specific to the environment, such as authentication properties.

    Table: Mapping permissions on the model

    To allow a user or group to… Give them the following permissions… On…

    Create new models

    Edit

    The BDC Metadata Store

    Edit a model

    Edit

    The model

    Set permissions on a model

    SetPermissions

    The model

    Import a model

    Edit

    The BDC Metadata Store

    Export a model

    Edit

    The model and all external systems in the model

    The external system in the BDC Metadata Store An external system is the metadata definition of a supported source of data that can be modeled, such as a database, web service, or .NET connectivity assembly.

    Table: Mapping permissions on the external system in the BDC Metadata Store

    To allow a user or group to… Give them the following permissions… On…

    Create new external systems

    Edit

    The BDC Metadata Store

    Edit an external system

    Edit

    The external system object

    Use the external system in SharePoint Designer

    Edit

    The external system object

    Set permissions on the external system

    SetPermissions

    The external system object

    External content type An external content type is a reusable collection of metadata that defines a set of data from one or more external systems, the operations available on that data, and connectivity information related to that data.

    Table: Mapping permissions on the external content type

    To allow a user or group to … Give them the following permissions … On …

    Create new external content types

    Edit

    The external system

    Execute operations on an external content type

    Execute

    The external content type (method instances of the operation)

    Create lists of the external content type

    Selectable in clients

    The external content type

    Set permissions on the external content type

    SetPermissions

    The external content type

    The method A Business Data Connectivity method is an XML definition of how Business Connectivity Services can interact with an external data source.

    Table: Mapping permissions on the method

    To allow a user or group to … Give them the following permissions … On …

    Edit a method

    Edit

    The method

    Set permissions on a method

    SetPermissions

    The method

    The method instance A method instance describes, for a particular method, how to use a method by using a specific set of default values.

    Table: Mapping permissions on the method instance

    To allow a user or group to… Give them the following permissions… On…

    Edit a method instance

    Edit

    The method instance

    Execute a method instance

    Execute

    The method instance

    Set permissions on a method instance

    SetPermissions

    The method instance

  • The development environment When you are developing a Business Connectivity Services solution, including the external content type, and any apps for SharePoint and connection settings objects, it is a best practice to use a development environment that is separate from your production environment. In the development environment, you can grant higher levels of permissions to the developers than you would usually do in your production environment. If your Business Connectivity Services solution includes connecting to an OData source, then your development environment must include Visual Studio 2012 or other XML editor. For guidance on how to configure your development environment, see How to setup a development environment for BCS in the MSDN Library.

  • The user environment All external data will be accessed through external lists, external data columns, Business Data Web Parts, apps for SharePoint, or Office. For apps for SharePoint, you can choose to let the app for Office and SharePoint enforce permissions. In this case, if the users can access the app for Office and SharePoint, then they can access all the external data that is surfaced in the app for Office and SharePoint. You will have to work with site administrators, site collection administrators, and tenant administrators to plan and implement permissions to the external data in your solution. For more information about how to manage permissions on SharePoint products, see Permissions Management on Office.com.

See also

What's new for Business Connectivity Services in SharePoint 2013
Overview of Business Connectivity Services in SharePoint 2013


Plan for Access Services in SharePoint Server 2013
See also

Summary: Use these TechNet articles to plan Access Services in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Access Services in SharePoint Server 2013 are service applications that allow users do the following:

  • Create and customize Access apps for SharePoint, which are a new type of database that you build in Access Services, and then use and share with others as an app for SharePoint in a web browser.

  • Maintain and update Access web databases that were previously created in SharePoint Server 2010 for backward compatibility.

TechNet articles about planning for Access Services

The following articles about Access Services are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of Access Services in SharePoint Server 2013 | Describes how Access Services in SharePoint Server 2013 enables you to share two types of Access 2013 solutions on the web.

Additional resources about planning for Access Services

The following resources about the new features and capabilities in Access Services are available from other subject matter experts.

 | Content | Description
TechNet logo | What's New in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.
Office 2013 logo | What's new in Access 2013 | Read about Access web apps, a new type of database that you build in Access, then use and share with others as a SharePoint app in a web browser.
MSDN | Welcome to the Access 2013 developer reference | See conceptual overviews, programming tasks, samples, and reference documentation to guide you in developing solutions based on Access 2013.

See also

Administer Access Services in SharePoint Server 2013


Overview of Access Services in SharePoint Server 2013
See also

Published: October 16, 2012

Summary: Learn how to use Access Services in SharePoint Server 2013 to share solutions on the web.

Applies to: SharePoint Server 2013

Access Services in SharePoint Server 2013 are service applications that enable you to share two types of Access 2013 solutions on the web.

Access apps are new in SharePoint Server 2013

Access apps for SharePoint are a new type of database that you build in Access 2013, then use and share with others as an app for SharePoint in a web browser. To build an Access app, you select the type of data that you want to track (contacts, tasks, projects, and so on). Access creates the database structure as well as various views that let you add and edit data. Navigation and basic commands are built-in, so you can start to use the app right away. Once the Access app is running, it's a straightforward task to customize and enhance the Access app over time.

Access web databases are supported for backward compatibility

By default, you cannot create a web database by using Access 2013. However, you can still view and edit a web database that was previously created by using Access 2010 and SharePoint Server 2010, and you can republish it to SharePoint Server 2013.

There is no way to automatically convert a web database to an Access app. If you want to manually convert a web database to an Access app to take advantage of new functionality and features, you can do the following:

  • Import the data from the web database into a new Access app.

  • Re-create the user interface and business logic.

See also

What's new in Access 2013
Welcome to the Access 2013 developer reference


Plan email integration for a SharePoint farm in SharePoint 2013

Summary: Learn how to plan for e-mail integration in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

To enable communication in SharePoint 2013 is a critical component for creating web applications in which group members can interact with each other and keep up with changes to information through the use of alerts. The site collection features that are dependent on communications being properly set up include the following:

  • Alerts that notify group members when things have changed.

  • Administrative messages related to requests for site access and other site administration issues.

  • Discussion groups.

To make the most effective use of the communications features, planning should include understanding the software requirements and maintenance considerations.

TechNet articles about email integration planning

The following articles about e-mail integration planning are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Checklist icon (not checked) | Plan incoming email for a SharePoint farm in SharePoint 2013 | Provides information on how to set up email for discussion groups.
Checklist icon (not checked) | Plan outgoing email for a SharePoint farm in SharePoint 2013 | Provides information about how to use alerts and administrative messages.

Additional resources about email integration planning

The following resources about email integration planning in SharePoint Server 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | What's New in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.


Plan incoming email for a SharePoint farm in SharePoint 2013
See also

Summary: Learn how to configure incoming e-mail to enable SharePoint sites to receive and store e-mail messages and attachments.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The incoming e-mail feature of SharePoint 2013 enables SharePoint sites to receive and store e-mail messages and attachments in lists and libraries. This article helps server and farm administrators understand the choices they need to make before they deploy the incoming e-mail feature for their organization.

In this article:

  • About incoming e-mail

  • Key decisions for planning incoming e-mail

  • Configuration options and settings modes

About incoming e-mail

The incoming e-mail feature enables teams to store the e-mail that they send to other team members without opening the SharePoint site and uploading the content that was sent in e-mail. This is possible because most types of lists and libraries can be assigned a unique e-mail address.

Before configuring incoming e-mail, you must perform the following tasks:

  • If you are using the basic scenario, each SharePoint front-end web server must be running the Simple Mail Transfer Protocol (SMTP) service and the SharePoint Foundation web application service.

  • If you are using the advanced scenario, you can use one or more servers in the server farm to run the SMTP service and to have a valid SMTP server address. Alternatively, you must know the name of a server outside the farm that is running the SMTP service and the location of the e-mail drop folder.

For more information about installing the SMTP service, see Configure incoming email for a SharePoint 2013 farm.

Key decisions for planning incoming e-mail

As you plan to implement incoming e-mail, you must decide whether to use a basic or and advanced scenario, as described below.

Using a basic scenario

You can enable a basic incoming e-mail scenario by installing the Simple Mail Transfer Protocol (SMTP) service on the server running SharePoint 2013 and enabling incoming e-mail by using the automatic settings mode with all default settings. In this scenario, e-mail is delivered directly to your SMTP server and SharePoint 2013 periodically checks for e-mail in the default e-mail drop folder that is automatically configured by the SMTP service.

Selecting the automatic settings mode and accepting all the default settings is the easiest way to enable incoming e-mail because all configuration settings are made for you and, therefore, little expertise is required. For most organizations, this configuration is all that is needed.

You enable a basic incoming e-mail scenario in the following steps:

  1. The server administrator uses the Add Features Wizard to install the SMTP Server feature on the server from which you want to receive incoming e-mail. This installs and starts the SMTP service on that server.

  2. The farm administrator enables incoming e-mail by using the automatic settings mode and accepting all the default values.

  3. The site collection administrator enables the incoming e-mail feature on the libraries and lists in which they want to store incoming e-mail and assigns each library and list a unique e-mail address in the form address@SMTPserveraddress, for example, sharedfiles@SMTPserver.contoso.com.

When users send e-mail to the address of a list or library, SharePoint 2013 detects that new e-mail has been delivered and sends it to the appropriate list or library based on the e-mail address.

Note:

You can also use the automatic settings option in an advanced scenario and select whether to use the Microsoft SharePoint Directory Management service, a safe e-mail server, and an incoming e-mail server display address. These options are all discussed in the Using an advanced scenario later in this article.

If this basic scenario meets your needs, you can skip the remainder of this article. For more information, see Configure incoming email for a SharePoint 2013 farm.

Using an advanced scenario

For more advanced administrators, additional choices are available, some of which require more expertise to deploy than choosing the basic scenario with all default options. This section describes the following configuration options:

  • SharePoint Directory Management service

  • Incoming e-mail server display address

  • Safe e-mail server

  • E-mail drop folder

If you use the advanced scenario to configure incoming e-mail, you will need to perform additional procedures. For more information, see Configure incoming email for a SharePoint 2013 farm.

SharePoint Directory Management service

The SharePoint Directory Management service connects SharePoint sites to your organization's user directory to provide enhanced e-mail features. The benefit of using this service is that it enables users to create and manage e-mail distribution groups from SharePoint sites. This service also creates contacts in your organization's user directory so people can find e-mail-enabled SharePoint lists in their address books. However, using SharePoint Directory Management service requires more management because it is communicating with Active Directory Domain Services (AD DS).

Note:

It is recommended that you use Exchange Server together with SharePoint Directory Management service. If you do not, you must customize your own directory management service.

You can configure the SharePoint Directory Management service by using either the automatic or the advanced settings mode. You can choose to enable the SharePoint Directory Management service in your SharePoint server farm, or you can use the SharePoint Directory Management service of another farm. One advantage of using the service running on another farm is that Active Directory permissions are managed in a centralized place (that is, on the other farm).

To enable this service on a server or server farm runningSharePoint 2013, the SharePoint Central Administration application pool account used by SharePoint 2013 must have write access to the container that you specify in Active Directory. This requires an Active Directory administrator to set up the organizational unit (OU) and the permissions on the OU. The advantage of using the SharePoint Directory Management service on a remote farm is that you do not need the help of an Active Directory administrator to create and configure the OU if the OU already exists.

Note:

There are a number of procedures that you need to perform if you plan to use SharePoint Directory Management service. For more information, see Configure incoming email for a SharePoint 2013 farm.

A typical directory management scenario proceeds in the following steps:

  1. A site collection administrator creates a new SharePoint group.

  2. The administrator chooses to create a distribution list to associate with that SharePoint group and assigns an e-mail address to that distribution list.

  3. Over time, the administrator adds users to and removes users from this SharePoint group. As users are added to and removed from the group, the SharePoint Directory Management service automatically adds and removes them from the distribution list, which is stored in the Active Directory directory service. Because distribution lists are associated with a particular SharePoint group, this distribution list is available to all members of that SharePoint group.

  4. By default, e-mail addresses are automatically generated for discussion boards and calendars on team sites and then added to the team distribution list. The e-mail addresses for these two lists will be in the following form, by default: GroupAddress.discussions and GroupAddress.calendar.

  5. By including e-mail addresses for discussion boards and calendars in the distribution list, all e-mail and meeting invitations sent to this distribution list will be archived in the team site.

For more information about SharePoint Directory Management Service, see Inside SharePoint: SharePoint Directory Integration.

SharePoint Directory Management service configuration options

When you configure the SharePoint Directory Management service to create distribution groups and contacts in Active Directory, you must provide the following information:

  • Name of the Active Directory container in which new distribution groups and contacts will be created. This must be provided in the following format:

    OU=ContainerName, DC=DomainName, DC=TopLevelDomainName

    Example

    OU=SharePointContacts,DC=Contoso,DC=com

  • Name of the SMTP server to use for incoming e-mail (or accept the default SMTP server if one exists). This must be provided in the following format:

    Server.subdomain.domain.top-level_domain

    For example, SharePointServer.support.contoso.com

  • Whether to accept messages from only authenticated users.

  • Whether to allow users to create distribution groups from SharePoint sites. If you choose yes for this option, you can also choose whether users can do any combination of the following actions:

    • Create a new distribution group.

    • Change a distribution group's e-mail address.

    • Change a distribution group's title and description.

    • Delete a distribution group.

When configuring the SharePoint Directory Management service to create distribution groups and contacts using a remote SharePoint Directory Management service, you must provide the following information:

  • The URL of the remote directory management service, for example, http://server:adminport/_vti_bin/SharePointE-mailWS.asmx.

  • The name of the SMTP server to use for incoming e-mail.

  • Whether to accept messages from only authenticated users.

  • Whether to allow users to create distribution groups from SharePoint sites.

Incoming e-mail server display address

Administrators can specify the e-mail server address that will be displayed in web pages when users create an incoming e-mail address for a site, list, or group. This setting is often used in conjunction with the SharePoint Directory Management service to provide a more friendly e-mail server address for users to type, for example, mylist@example.com.

Safe e-mail server

You can configure SharePoint 2013 to accept e-mail from any e-mail server or only e-mail that has been routed through a safe-e-mail server application.

You can derive the following benefits by routing e-mail through a safe e-mail server:

  • User authentication The SMTP service cannot authenticate users who send e-mail to your site, but Exchange Server can. The server administrator can use the SharePoint Central Administration website to specify that the system accept e-mail from authenticated users only if the e-mail is sent through Exchange Server.

  • Spam filtering Exchange Server provides spam filtering to eliminate unsolicited commercial e-mail before it is forwarded to its destination — in this case, the server running SharePoint 2013. Another technique that can reduce spam is to allow members of the team site to archive e-mail only in lists on which you have granted write permissions to members.

  • Virus protection Exchange Server provides virus protection for e-mail routed through it.

Note:

Because this option is only available in automatic mode, you cannot specify one or more safe e-mail servers and also specify an e-mail drop folder.

E-mail drop folder

If the SMTP service is running on another server than on the SharePoint server, you must specify the location from which SharePoint 2013 retrieves incoming e-mail. You specify the e-mail drop folder so that SharePoint 2013 knows from where to retrieve incoming e-mail. However, if you specify a specific e-mail drop folder, SharePoint 2013 cannot detect configuration changes on the remote e-mail server that is delivering the e-mail to your drop folder. This means that if an administrator configures the e-mail server to no longer deliver e-mail to this folder, SharePoint 2013 cannot detect that the configuration has changed, and therefore will not be able to retrieve the files from the new location.

Note:

When incoming e-mail is set to advanced mode, you must ensure that you have the proper permissions on the e-mail drop folder. For more information, see Configure incoming email for a SharePoint 2013 farm.

Note:

Because this option is only available in advanced mode, you cannot specify an e-mail drop folder and also specify one or more safe e-mail servers.

Configuration options and settings modes

As a farm administrator, you have two settings modes from which to choose when enabling incoming e-mail: automatic and advanced. As described in the "Using a basic scenario" section, you can choose the automatic settings mode with default settings. However, the automatic settings mode has additional options that you can choose.

The following table describes the configuration options and whether they are configured on the Configure Incoming E-Mail Settings page in the SharePoint Central Administration website by using the automatic settings mode or the advanced settings mode.

Configuration option | Automatic settings mode | Advanced settings mode
Enable Incoming E-mail | Yes | Yes
SharePoint Directory management service | Yes | Yes
Incoming e-mail server display address | Yes | Yes
E-mail drop folder | No | Yes

The advanced and automatic settings modes are similar in that they both enable farm administrators to configure the SharePoint Directory Management service and the e-mail server address to display in web pages. These settings modes differ in that the automatic settings mode replaces the ability to choose what e-mail servers to accept e-mail from with the ability to specify the folder to which e-mail is dropped. SharePoint 2013 uses this e-mail drop folder to detect new e-mail messages.

Note:

The e-mail drop folder setting is not available in automatic mode, because that mode automatically sets the e-mail drop folder to the folder that is specified by the SMTP service.

Plan incoming e-mail worksheet

Download a Word version of the Plan incoming e-mail worksheet. Use this worksheet to plan incoming e-mail in order to enable SharePoint sites to receive and store e-mail messages and attachments in lists and libraries.

See also

Configure incoming email for a SharePoint 2013 farm
Plan outgoing email for a SharePoint farm in SharePoint 2013
Configure outgoing email for a SharePoint 2013 farm


Plan outgoing email for a SharePoint farm in SharePoint 2013
See also

Summary: Learn how to configure outgoing e-mail to relay e-mail alerts and notifications in your SharePoint 2013 farm or web application.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Outgoing e-mail is the foundation on which site administrators can implement several e-mail notification features. These features help end users track changes and updates to individual site collections and allow site administrators to deliver status messages.

In this article:

  • About outgoing e-mail

  • Key planning phases of outgoing e-mail

About outgoing e-mail

Properly configuring outgoing e-mail is a requirement for implementing e-mail alerts and notifications. The outgoing e-mail feature uses an outbound Simple Mail Transfer Protocol (SMTP) service to relay e-mail alerts and notifications. These e-mail features include the following:

  • Alerts

    In a large and growing site collection, users need an efficient way to keep up with updates to lists, libraries, and discussions. Setting up alerts provides an effective means to stay on top of changes. For example, if many users work on the same document, the owner of the document can set up alerts to be notified whenever there are changes to this document. Users can specify which areas of the site collection or which documents they want to track and decide how often they want to receive alerts.

    Note:

    Users must have at least View permissions to set up alerts.

  • Administrative messages

    Site administrators might want to receive notices when users request access to a site or when site owners have exceeded their specified storage space. Setting up outgoing e-mail enables site administrators to receive automatic notifications for site administration issues.

Outgoing e-mail support can be enabled at both the server farm level (available in the System Settings section of the Central Administration website) and at the web application level (available in the Application Management section of the Central Administration website). Therefore, you can specify different settings for a specific web application. Outgoing e-mail settings at the web application level override those set up at the server farm level.

Key planning phases of outgoing e-mail

Before you configure outgoing e-mail, you must have an SMTP service to relay e-mail alerts and notifications.

The outgoing e-mail settings include several components that must be considered when planning for this feature:

  • An SMTP service to relay e-mail alerts and notifications. You will need the DNS name or IP address of the SMTP mail server to use.

  • An address to use in the header of an alert message that identifies the sender of the message.

  • A Reply-to address that is displayed in the To field of a message when a user replies to an alert or notification.

  • A character set to use in the body of alert messages.

Outbound SMTP server

The SMTP service is a component of Internet Information Services (IIS); however, it is not enabled by default with IIS. It can be enabled by using Programs and Features in Control Panel.

After determining which SMTP server to use, the SMTP server must be configured to allow anonymous access and to allow e-mail messages to be relayed. Additionally, the SMTP server must have Internet access if you want the ability to send messages to external e-mail addresses.

For more information about installing, configuring, and managing the SMTP service, see Help for Internet Information Services (IIS) Manager.

Note:

Only a member of the Farm Administrators group can configure an SMTP server. The user must also be a member of the local Administrators group on the server.

From and Reply-to addresses

When configuring outgoing e-mail, you can configure the following two addresses:

  • From address

    Alerts and notifications are sent from an administrative account on the server farm. This account is probably not the one you want to be displayed in the From field of an e-mail message. The address that you use does not need to correspond to an actual e-mail account; it can be a simple friendly address that is recognizable to an end user. For example, "Site administrator" might be an appropriate From address.

  • Reply-to address

    This is the address that will be displayed in the To field of a message if a user replies to an alert or notification. The Reply-to address should also be a monitored account to ensure that end users receive prompt feedback for issues they might have. For example, a help desk alias might be an appropriate Reply-to address.

Character set

When you configure outgoing e-mail, you will need to specify the character set to use in the body of e-mail messages. A character set is a mapping of characters to their identifying code values. The default character set for outgoing e-mail is Unicode UTF-8, which allows most combination of characters (including bidirectional text) to co-exist in a single document. In most cases, the default setting of UTF-8 works well, although East Asian languages are best rendered with their own character set.

Be aware that if you select a specific language code, the text is less likely to appear correctly in mail readers configured for other languages.

See also

Configure outgoing email for a SharePoint 2013 farm


Plan for mobile devices in SharePoint 2013
See also

Summary: Learn how to plan for your SharePoint Server 2013 mobile infrastructure.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

SharePoint Server 2013 provides the mobile architecture necessary to connect users to business-critical data and other types of information across multiple device platforms. IT professionals can create and manage compelling mobile SharePoint experiences throughout their organization by using an on-premises server-based deployment, or by using SharePoint Online services. The following articles offer planning guidance and best practices for how to deploy and use mobile devices with SharePoint Server 2013.

TechNet articles about planning for mobile devices

The following articles about planning for mobile devices in SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of mobile devices and SharePoint Server 2013 | SharePoint Server 2013 offers new, optimized viewing experiences across different mobile platforms. Additionally, several new features were added to help improve both worker productivity and usability on the device.
Checklist icon (not checked) | Plan for mobile views in SharePoint Server 2013 | This article will help you plan for using mobile browser experiences in SharePoint Server 2013 by identifying device and site requirements for a particular view, and providing inventory for your mobile device base.
Building blocks | Mobile device browsers supported in SharePoint 2013 | SharePoint Server 2013 provides support for multiple devices. However, not all browsing experiences and functionality are available to all devices. This article provides the list of supported browsers available for use with SharePoint Server 2013.
Building blocks | Mobile security and authentication in SharePoint 2013 | Plan a secure mobile infrastructure in SharePoint Server 2013, and learn about multiple authentication methods and authentication modes available between your devices and network.

Additional resources about planning for mobile devices

The following resources about planning for mobile devices in SharePoint Server 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | What's New in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.

See also

What's new for mobile devices in SharePoint 2013


Overview of mobile devices and SharePoint Server 2013
See also

Summary: Learn about the SharePoint mobility features, services, and browsing experiences with a deployment of SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint Server 2013 offers new, optimized viewing experiences across different mobile platforms. Additionally, there are several features that are available to help improve both worker productivity and usability on the device. This article is intended for IT professionals to help understand the SharePoint Server 2013 mobile features that are available to your organization.

In this article:

  • Mobile browser experience

  • Device channels

  • Office Web Apps

  • Location

  • Push notifications

  • Business intelligence content

  • Subscribe to mobile alerts

Important:

For more information about supported mobile browsers with SharePoint Server 2013, see Mobile device browsers supported in SharePoint 2013.

For an end-to-end look and understanding of the SharePoint Server 2013 mobile landscape, see the poster Mobile architecture in SharePoint 2013. Also, for more information about how to administer your mobile environment, see Administer mobile devices in SharePoint 2013.

Mobile browser experience

SharePoint Server 2013 offers improvements to the mobile browser experience with the introduction of a new contemporary view. Depending on the mobile browser, users have one of the following browsing options:

  • Contemporary view This view offers an optimized mobile browser experience to users and renders in HTML5. This view is available to Mobile Internet Explorer version 9.0 or later versions for Windows Phone 7.5, Safari version 4.0 or later versions for iPhone iOS 5.0, and the Android browser for Android 4.0 or later versions.

  • Classic view This view renders in HTML format, or similar markup languages (CHTML, WML, and so on), and provides backward compatibility for mobile browsers that cannot render in the new contemporary view. The classic experience in SharePoint Server 2013 is identical to the mobile browser experience of SharePoint Server 2010.

  • Full-screen UI There is also the ability to have a full desktop view of a SharePoint site on a smartphone device.

The following figure shows the contemporary view for a smartphone browser.

Figure: Contemporary view on a smartphone browser

Note:

For the above figure the top row shows the contemporary view rendering on a Windows Phone, and the iPhone for the bottom row. The classic and contemporary views are only rendered for smartphone mobile browsers. For more information about which mobile browsers are supported in SharePoint Server 2013, see Mobile device browsers supported in SharePoint 2013.

The contemporary view of a SharePoint site offers users some of the following enhanced features:

  • Menu button The menu button is located on the right side of the title area of the contemporary view. It presents a user with several commands. This includes the following:

    • Site contents allows the user to view all of the site content on the SharePoint site including lists and document libraries.

    • Sign Out allows the user to log off from SharePoint. SharePoint information is now unavailable to the mobile device.

    • Close closes the Command button menu and returns to the SharePoint site.

  • Switch to PC View This changes the display from mobile browser view to a full desktop view of a site. This command is available in both contemporary and classic views in SharePoint Server 2013. You can switch back to the mobile browser view in Site Settings. Under the Site Information section, click the URL under the Mobile Site URL heading.

  • Navigation window This is accessed by tapping the left side of the title area of the contemporary view. The navigation window presents a single menu with breadcrumbs, top navigation, and quick launch navigation from the full desktop view of the site. Also included is a link to All Site Content.

  • Tap-to-open links All hyperlinks are replaced with the new tap-to-open link feature. This feature displays text or icons on a wide strip that is easier for a user to tap.

  • Pagination Lists with more than 20 items are automatically paginated.

  • New and edit functionality You can create new list items and edit them in the contemporary view. For example, you can create a new task in a task list on your mobile device by tapping New. Alternatively, you could also edit the task in the list by tapping Edit.

For more information about mobile views and planning a mobile browser-based experience, see Plan for mobile views in SharePoint Server 2013.

Mobile browser redirection

To access a site by using the optimized mobile browser experience, a new feature named Mobile Browser View must be activated on the site. When activated and a mobile browser is accessing the site, this feature checks the mobile browser to determine whether it can handle HTML5. If the mobile browser supports HTML5, the contemporary view is rendered. Otherwise, the classic view is rendered.

By default, this feature is activated when any of the following site templates are used:

  • Team Site

  • Blank Site

  • Document Workspace

  • Document Center

  • Project Site

You must explicitly activate the feature on sites created with other templates. You can activate or deactivate the Mobile Browser View feature at the site level.

Mobile views and the browser definition file

A mobile view is a version of the SharePoint site that was optimized for mobile devices. The browser definition file lists the mobile browsers and devices that are supported by SharePoint Server 2013 and is used to redirect mobile browsers to the mobile views. You can modify the browser definition file to change the redirect behavior of a mobile browser, or to add or delete entries from the list of supported mobile devices.

The browser definition file lists the mobile browsers and devices that can access mobile views in SharePoint Server 2013. When a user browses a SharePoint site from a mobile device, the mobile browser submits to the site an HTTP GET request that includes a user agent string. If the mobile browser and device model in the user agent string are listed in the browser definition file and the isMobileDevice setting for the mobile browser is set to true, SharePoint Server 2013 redirects the mobile browser to the mobile view of the site. Otherwise, a standard view of the site is shown in the mobile browser. You can modify the file to change the redirect behavior of a mobile browser.

The browser definition file lists the mobile browsers and devices that are supported by SharePoint Server 2013. The file can be updated when product updates to SharePoint Server 2013 are released. You can also modify the file to add a mobile browser or device to the list. For more information about how to modify the browser definition file, see Configure the browser definition file in SharePoint 2013. Also, for more information about mobile views and planning a mobile browser-based experience, see Plan for mobile views in SharePoint Server 2013.

Device channels

Browsing the web on a mobile device is now so common that a SharePoint site must be optimized for readability and ease of use on smartphones and other mobile devices such as tablets. Previous versions of SharePoint Server included a single default mobile view that was auto-generated based on the existing site, and that default mobile view was not easily customizable. Now, with device channels in SharePoint Server 2013, you can render a single publishing site in multiple ways by using different designs that target different devices based on their user agent string. You create a single site and author the content in it a single time. Then, that site and content can be mapped to use different master pages and style sheets for a specific device or group of devices. Also, you can easily show different content to different device channels using same page and page layout.

For more information on using device channels, and understanding the larger custom design and site branding experience for SharePoint 2013, see Plan device channels and Overview of Design Manager.

Office Web Apps

In SharePoint Server 2010, Office Web Apps Server provides browser-based companions for Word, Excel, and PowerPoint. When Office Web Apps Server is installed on SharePoint Server 2010, Office Mobile Web Apps is also installed on the server. Office Mobile Web Apps enables users to open documents in the mobile web application by using a mobile browser. With SharePoint Server 2013, Office Web Apps Server is no longer a companion product installed on a computer that is running SharePoint Server. Instead, Office Web Apps Server is a new stand-alone server product that still provides mobile browser-based viewers for these applications. These viewers called Word Mobile Viewer, Excel Mobile Viewer, and PowerPoint Mobile Viewer are optimized to render documents for phones. When integrated with SharePoint Server 2013, a user can enjoy enhanced viewing experiences when interacting with documents on the phone.

Together, SharePoint Server 2013 and Office Web Apps Server offer a better user experience when interacting with documents on a mobile device. For example, when both products are used together, a user opens a server-based version of the document in the mobile browser. Without Office Web Apps Server, the user would first have to download the file and then open it in Office Mobile or in an Office document viewer.

Location

SharePoint Server 2013 introduces a new geolocation field type that can be used in a list. For example, you can now make lists "location-aware" and display latitude and longitude coordinates through Bing Maps. An entry is typically seen as a pushpin on the map view. Although there are several ways to use this geolocation field, one key scenario is for mobile application development. Users can track or log location-specific data while they work remotely from the corporate office. Alternatively, the application can help them locate points of interest when they perform offsite functions. To display map views in the list, you must use the Bing Maps service. For information about the procedures and Windows PowerShell for SharePoint Server 2013 cmdlets necessary to display map views, see Use the location field type in mobile applications for SharePoint 2013.

Note:

The geolocation field is not available when you create a list through the user interface (UI). Therefore, you cannot make a custom list and add it as a column through traditional UI methods. Instead, this field must be inserted programmatically. For more information about how to render and work with this data type programmatically, see Integrating location and map functionality in SharePoint 2013.

Push notifications

SharePoint Server 2013 supports applications on mobile devices that should receive notifications from a SharePoint site. Notifications can include events that occur in the site, such as when a user adds an item to a list or updates an item. For mobile devices to receive such notifications, device applications must register with a SharePoint site. Once registered, you can write event handler code to interact with Microsoft Push Notification Service or notification services of other mobile device platforms. Notifications are sent from the server where the application is hosted to the registered mobile device application.

When the push notification feature is activated, a subscription store is created at the website level to store information from devices that have registered with the SharePoint site to receive notifications. This subscription store is created as a hidden list that cannot be viewed directly by a user or an administrator. There is a limit of 2,000 device registrations for push notifications in SharePoint Server 2013. Once this limit is reached, no further registrations can be performed unless entries are cleared from the subscription store. To perform this procedure on your SharePoint site, see Clear push notification registrations from the subscription store in SharePoint 2013.

Business intelligence content

SharePoint Server 2013 enables a user to view certain kinds of dashboard content. This includes PerformancePoint reports and scorecards, and Excel Services reports in iOS 5.0 Safari browsers on iPad devices. For more information about how to use this feature, see Viewing reports and scorecards on Apple iPad devices in the SharePoint Server 2010 Library.

Subscribe to mobile alerts

You can configure and manage a mobile account in SharePoint Server 2013 to enable users to subscribe to alerts that are sent by using Short Message Service (SMS). The alerts are sent to the mobile device when changes are made to a SharePoint list or item. Because a SharePoint site is usually located on an intranet, access to the SharePoint site can be difficult when users are away from the office. For example, when they are traveling or attending a business dinner. The mobile alert feature enables users to react quickly when they receive an SMS alert that an item in a SharePoint list has changed. For more information about how to subscribe to mobile alerts in SharePoint, see Configure mobile accounts in SharePoint 2013.

See also

Mobile device browsers supported in SharePoint 2013
Administer mobile devices in SharePoint 2013
Configure mobile accounts in SharePoint 2013

Plan device channels
Mobile architecture in SharePoint 2013


Plan for mobile views in SharePoint Server 2013
See also

Published: September 11, 2012

Summary: Learn how to plan for using a mobile browser experience in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In SharePoint Server 2013, there are new, optimized mobile browser experiences available for viewing a SharePoint site. For example, you have the flexibility to use a modern out-of-the-box solution, such as the HTML5-based contemporary view, or you can design a mobile view based on your organization's unique usability requirements. There are four browser-based experiences that are available in SharePoint Server 2013. Your ability to choose these experiences depends on several factors, including which devices you have and the type of site that you are trying to enable for mobile views. This article will help you plan for using mobile browser experiences in SharePoint Server 2013 by identifying device and site requirements for a particular view, and providing inventory for your mobile device base. Upon completion, you will understand the mobile views that are available to you, and you will be provided with next steps and guidance if these views are unacceptable.

Before proceeding, we recommend that you read Overview of mobile devices and SharePoint Server 2013. It provides additional details on understanding mobile views, including the browser redirection process and the compat.browser file that is associated with mobile view redirection. For information about which mobile browsers are supported in SharePoint Server 2013, see Mobile device browsers supported in SharePoint 2013.

In this article:

  • Mobile browser experiences

  • Device inventory and site planning for mobile devices

  • Choose a mobile browser experience

  • Next steps

Mobile browser experiences

This section will help you understand which mobile views are available in SharePoint Server 2013, and identify which views are available to you based on device and site requirements. In summary, there are three distinct mobile browser experiences that are available by default, and a feature known as device channels that will allow you create a customized mobile browser view for a SharePoint publishing site. The following table describes these views and the device channels feature.

Table: Mobile browser views and device channel feature

Mobile view Device rendering Description

Contemporary view

Contemporary View

  • For smartphone devices only. Activated by default on select site templates (Team Site, Blank Site, Document Workspace, Document Center, and Project Site).

  • It is available by default in SharePoint Server 2013.

  • The contemporary mobile browser view renders in HTML5. This view is available to Mobile Internet Explorer version 9.0 or later versions for Windows Phone 7.5, Safari version 4.0 or later versions for iPhone iOS 5.0, and the Android browser for Android 4.0 or later versions.

  • The contemporary view has a modern UI that is optimized for touch.

  • It provides an intuitive navigation experience that allows you to move to different pages and parts of site with ease.

  • Supports full screen UI view.

Important:

The contemporary view is intended for smartphone devices. However, certain slates might also receive this view if they use similar user agent strings as smartphones. For more information about user agent strings and configuring mobile view redirection, see Configure the browser definition file in SharePoint 2013. For more information about the new contemporary view functionality, see Overview of mobile devices and SharePoint Server 2013.

Classic view

Classic View

  • For smartphone devices only. This view renders in HTML format, or similar markup languages (CHTML, WML, and so on), and provides backward compatibility for mobile browsers that cannot render in the new contemporary view.

  • It is offered by default in SharePoint Server 2013.

  • Lightweight mobile view for interacting with lists and libraries on your SharePoint site.

  • Hyperlink navigation model.

Full screen UI

Full Screen

  • For smartphone and slate devices.

  • This view resembles the desktop SharePoint rendering experience.

  • Same navigation experience as the desktop experience.

  • The contemporary view has a menu option to switch to the full screen UI view.

Device channels (custom)

Not applicable - depends on design

  • For smartphone and slate devices. Can only be used with a publishing site.

  • With device channels, you can render a single publishing site in multiple ways by using different designs that target different devices based on their user agent string.

  • The site and content can be mapped to use different master pages and style sheets for a specific device or group of devices.

  • You can easily show different content to different device channels by using same page and page layout.

Device inventory and site planning for mobile devices

The first important planning step is to inventory which mobile devices will be connecting to the SharePoint Server 2013 site. Next, you will have to determine which sites will offer mobile views for SharePoint Server 2013.

Device inventory

Some key preliminary questions should be Which devices do I have, and are they supported for SharePoint Server 2013? It is important to inventory all devices including brand and operating system information. Also, some of the views are unavailable to certain phones and slates as stated in the previous table. For example, if you do not have an HTML5-enabled browser on a device, the contemporary view will not be shown. Or, the device might not be supported in SharePoint Server 2013. To help with this stage of planning, you can do the following:

  • Perform a full device inventory by brand and operating system version in your network, or on the mobile devices that will be connecting to the SharePoint Server 2013 site.

  • Refer to the previous browser experiences table to understand which views are available for both smartphones and slates. To see which device browsers are supported by brand and operating system in SharePoint Server 2013, see Mobile device browsers supported in SharePoint 2013.

To help with this process, a worksheet is available to help catalog your inventory by brand and operating system version. Also, it provides columns for identifying whether the device browser is supported or not in SharePoint Server 2013. It is important to capture device inventory and support information because it will help you expose restrictions in choosing a mobile view discussed in later sections of this article. To download this worksheet, see Mobile Device Inventory and Site Planning Worksheet in the Microsoft Download Center.

Site planning for mobile devices

The browser-based mobile views in SharePoint Server 2013 can be used on a number of different SharePoint site templates. The following table shows where mobile views can be applied.

Table: Browser-based mobile views on SharePoint site templates

Mobile view | Team Site | Blank Site | Document Workspace | Document Center | Project Site | Publishing Site
Contemporary view | Yes | Yes | Yes | Yes | Yes | n/a
Full screen UI | Yes | Yes | Yes | Yes | Yes | Yes
Device channels | Not applicable | Not applicable | Not applicable | Not applicable | Not applicable | Yes
Classic view | Yes | Yes | Yes | Yes | Yes | Not applicable
Note:

The full screen UI view is actually available for all SharePoint site templates and not for just the select templates that are listed in this table.

An important question to answer is Which sites do you plan to have mobile views on for SharePoint Server 2013? Although choosing a mobile view is discussed in the next section, it is important to identify which sites will require a mobile rendering in your organization. The same worksheet discussed in the previous section will allow you to record this information. To download this worksheet, see Mobile Device Inventory and Site Planning Worksheet in the Microsoft Download Center.

Choose a mobile browser experience

After you perform a full device inventory and understand the different mobile view restrictions at the device and site levels, you must choose which mobile browser view best fits your organizational needs.

  • Which view should I choose?

    This will depend primarily on factors such as what are your mobile usability requirements, what is the level of interaction a user needs with a mobile SharePoint solution, and are there any device or site restrictions. Will an out-of-the-box experience like the contemporary view be sufficient for general interaction, or do you need a more customizable solution that caters to specific business requirements like device channels? It is very important to clearly understand the needs of your mobile SharePoint user base to help with the selection process.

    The following table provides some prime considerations when you evaluate positive or negative user impact with a specific view. It is not a competitive analysis between the different view options because some choices might not be available for you based on device or site template requirements. An example is that device channels can only be used on a publishing site and not on other site templates like the other views. However, it is intended to provide insight and discussion into the advantages and disadvantages each view provides and the usability impact. For example, will the UI be lightweight and not potentially cumbersome to end users, or how will users navigate between mobile pages.

  • Table: Considerations for choosing a browser view

    Mobile view Lightweight UI experience? Optimized for touch? Navigation method Desktop/ full UI rendering? Customizable?

    Contemporary view (smartphone)

    Yes

    Yes

    Navigation window

    No

    No

    Full screen UI (smartphone and slate)

    No

    No

    Same experience as desktop

    Yes

    No

    Device channels (smartphone and slate-publishing site only)

    Defined by view design

    Yes - based on custom design

    Defined by view design

    Yes

    Yes

    Classic view (smartphone)

    Yes

    No

    Hyperlink driven

    No

    No

    Important:

    Although the classic view is presented as an option in the previous table, it is considered to be a legacy mobile browser view for SharePoint Server 2013. If your device browser is supported, and renders in HTML5, the contemporary view will be seen instead of the classic view. We recommend that you evaluate the other browser views, if possible, for your mobile environment.

    It is again important to recognize the key advantages and potential disadvantages of these mobile views for your specific organization. For example, users might prefer to view a SharePoint site in its entirety on a smartphone because the look, feel, and navigation experience is similar to the desktop and is familiar. Or, a full-screen rendering is not preferable on a smartphone because of the reduced screen size and multiple touch gesture movements that are required to perform an operation. We highly recommend that you extensively test the mobile views available to you with users before deployment into a production environment.

  • Is there a customizable solution available so I can create my own unique SharePoint mobile view?

    Yes, you can create a custom view by using device channels in SharePoint Server 2013. Device channels make it easy to render certain site content, style your content, and even change images while maintaining the same URL across a pool of different devices. For example, compared to the desktop version of your SharePoint site, the mobile view can be formatted with a smaller width, have better navigation with wider touch targets, and show less information in general.

    Important:

    Device channels can only be used with publishing sites and not with other sites templates.

Next steps

After reading this article, you should understand which mobile views are available to you based on device and site restrictions. Ultimately, you might have questions about what to do next, especially if a particular mobile view is not available. The following list provides options to deploy the ideal mobile view for your organization, and further clarification on certain mobile view experiences.

  • My devices do not support HTML5, and I want to use the contemporary view experience. In this case, the option is to purchase devices that do support the contemporary view and are capable of rendering the experience. To see which device browsers are supported by brand and operating system in SharePoint Server 2013, see Mobile device browsers supported in SharePoint 2013.

  • After evaluating my user base I find that users do not want to use a mobile view of our SharePoint sites. Due to familiarity with the full UI experience, they would rather use that option on smartphones. There are several ways to disable mobile views in SharePoint Server 2013, including turning off the feature Mobile Browser View at the site level. Alternatively, you can modify the browser definition file in Internet Information Services (IIS) to change mobile redirect behavior. This file lists the mobile browsers and devices that can access mobile views in SharePoint Server 2013. When a user browses a SharePoint site by using a mobile device, the mobile browser submits to the site an HTTP GET request that includes a user agent string. If the mobile browser and device model in the user agent string are listed in the browser definition file and the isMobileDevice setting for the mobile browser is set to true, SharePoint Server 2013 redirects the mobile browser to the mobile view of the site. Otherwise, a standard view of the site is shown in the mobile browser. For more information, see Configure the browser definition file in SharePoint 2013.

  • I want to create a customized mobile view on a non-publishing site. Device channels can only be used in a publishing site. However, you can enable the publishing feature on your non-publishing sites.

See also

Overview of mobile devices and SharePoint Server 2013
Mobile device browsers supported in SharePoint 2013


Mobile device browsers supported in SharePoint 2013
See also

Summary: Learn about the different mobile device browsers supported in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

SharePoint Server 2013 provides browser support for multiple mobile devices. This article provides the list of supported device browsers for SharePoint Server 2013 and Office Web Apps.

Mobile browser compatibility matrix

The following table provides browser support information for SharePoint Server 2013 and Office Web Apps based on the manufacturer operating system version.

Table: Mobile browser compatibility matrix

Mobile device operating system Operating system version Browser Smartphone device Slate or tablet device

Windows Phone

Windows Phone 7.5 or later versions

Internet Explorer Mobile

Supported

Not applicable

Windows

Windows 7 or later versions

Internet Explorer

Not applicable

Supported

iOS

5.0 or later versions

Note:

Video play experience requires iOS version 6.0 or later.

Safari

Supported

Supported

Important:

Office Web Apps full functionality is supported on iPad versions 2 and 3 using iOS 6.0 or later versions. Limited viewing and editing functionality is also supported on iPad versions 1, 2, 3 using iOS version 5.1.

Android

4.0 or later versions

Note:

Video play experience requires Android version 4.1 or later.

Android Browser

Supported

Supported

See also

Overview of mobile devices and SharePoint Server 2013


Mobile security and authentication in SharePoint 2013
See also

Summary: Learn how to help secure a SharePoint mobile infrastructure, and learn about the different authentication types supported in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article provides security guidance and recommendations to help ensure that access to SharePoint Server 2013 and specific data in SharePoint is not compromised on a mobile device. This article also details the supported authentication types for select devices in SharePoint Server 2013.

In this article:

  • Security for mobile devices

  • Authentication for mobile devices

Security for mobile devices

This section provides security recommendations for using devices that are external to your corporate network. A lost or stolen device could be devastating to an organization on many levels. Therefore, necessary measures must be put in place if one were to be compromised.

General security considerations include the following:

  • Mobile devices can contain sensitive data or documents. Because mobile devices can be lost or stolen, we recommend that you set policies around mobile devices to help protect sensitive data and documents. This can include securing the mobile device by using a PIN or lock, and ensuring that you can remotely wipe the data on the mobile device. Available programs and features vary by mobile device. For more information about a possible method to implement these policies in your organization, see Exchange ActiveSync later in this article.

  • You can educate users about how they can help protect their user credentials. This can include signing out of sites when they have finished, not enabling any option that keeps them signed in or remembers their password, and frequently deleting cookies in the mobile browser. This can help prevent others from using their user credentials to log on to a SharePoint site if their mobile device is lost or stolen.

  • We recommend that you enable SSL to help secure communication between mobile browsers and the computer that is running SharePoint Server 2013. For more information about how to use a reverse proxy server, such as Forefront Unified Access Gateway (UAG), to help secure communication, see Forefront Unified Access Gateway (UAG) in the Forefront Technical Library.

Exchange ActiveSync

Microsoft Exchange ActiveSync is a communications protocol that enables mobile access, over the air, to e-mail messages, scheduling data, contacts, and tasks. Exchange ActiveSync is available on Windows Phone and third-party phones and slates that are enabled for Exchange ActiveSync such as the Apple iPhone. One of the benefits of implementing Exchange ActiveSync in your organization is device-side security, and administration through policy enforcement. If SharePoint Server 2013 is deployed in an extranet topology, mobile devices access the computer that is running SharePoint Server 2013 via a public-facing URL. If the mobile device were to become lost or stolen, it is necessary to ensure that SharePoint data is not compromised. For example, by using Exchange ActiveSync you can wipe data contents from the device remotely, such as SharePoint configurations, or enforce a complex password at the lock screen to help prevent unauthorized access.

The following table lists a selection of Exchange ActiveSync features and policies that you can apply to some devices.

Table: Exchange ActiveSync policies for mobile devices

Exchange ActiveSync policy Description

Remote wipe (this is a feature and not an Exchange ActiveSync policy)

If a mobile phone is lost, stolen, or otherwise compromised, you can issue a remote wipe command from the Exchange Server computer or from any web browser by using Outlook Web App. This command restores the device to factory defaults.

Important:

After a remote device wipe has occurred, data recovery is very difficult. However, no data removal process leaves a device as free from residual data as when it is new. Recovery of data from a device may still be possible using sophisticated tools.

Enforce password on device (DevicePasswordEnabled)

This setting enables the mobile phone password.

Minimum password length (MinDevicePasswordLength)

This option specifies the length of the password for the mobile phone. The default length is 4 characters, but as many as 18 can be included.

Require alphanumeric password (AlphanumericDevicePasswordRequired)

This setting requires that a password contains numeric and non-numeric characters.

Allow simple password (AllowSimpleDevicePassword)

This setting enables or disables the ability to use a simple password such as 1234.

Maximum inactivity time lock (MaxInactivityTimeDeviceLock)

This option determines how long the mobile phone must be inactive before the user is prompted for a password to unlock the mobile phone.

Important:

The selection of Exchange ActiveSync policies that can be used might differ on a device-by-device basis. For more information about which policies are supported on a specific device platform, such as Windows Phone and Apple iPhone, see Understanding Exchange ActiveSync Mailbox Policies.

Finding a lost device

When a device is lost or stolen it may be useful to find the location of that device, and be able to wipe all data contents if it is necessary. There are various third-party services and solutions that can provide this functionality. An example is the Windows Phone Find My Phone service that can make it easier to recover your mobile device by locating it, or prevent someone from using it without your consent.

The functionality this service can provide includes the following:

  • Map your mobile device location.

  • Make your mobile device ring.

  • Lock your mobile device and show a message.

  • Wipe your mobile device data.

Note:

To learn more about the Find My Phone service for Windows Phone, see Find a lost phone.

Authentication for mobile devices

SharePoint Server 2013 supports multiple authentication methods and authentication modes. Not all mobile browsers and devices work with all the available authentication methods. When you plan for mobile device access, you must do the following:

  • Determine the mobile devices that you must support. Then, learn the authentication methods that are supported by the mobile devices. This information varies by manufacturer.

  • Determine the sites that you want to make available to your mobile device users.

  • Determine whether you want to make SharePoint sites available for mobile devices when the devices are used outside the corporate firewall. If you do, the method that you use to enable external access can also affect mobile device authentication.

The following tables detail the authentication types supported for browsers and the Office Hub Windows Phone experience in SharePoint Server 2013.

Table: Mobile authentication support for SharePoint browsers

SharePoint infrastructure | Authentication mode | Authentication provider | Windows Phone 7.5 or later versions (Internet Explorer Mobile) | iOS 5.0 or later versions (iPad, iPhone using Safari)
SharePoint on-premises | NTLM | Active Directory | Supported | Supported
SharePoint on-premises | Basic authentication | Active Directory | Supported | Supported
SharePoint on-premises | SAML | WS-Federation 1.1 compatible Identity Provider | Supported | Supported
SharePoint Online | Forms-based authentication | Org-ID | Supported | Supported

Table: Mobile authentication support matrix for Office Hub

SharePoint infrastructure | Authentication mode | Authentication provider | Windows Phone 7.5 or later versions
SharePoint on-premises | NTLM | Active Directory | Supported
SharePoint on-premises | Basic authentication | Active Directory | Not supported
SharePoint on-premises | SAML | WS-Federation 1.1 compatible Identity Provider | Not supported
SharePoint Online | Forms-based authentication | Org-ID | Supported

Note:

In order for mobile devices to communicate with SharePoint servers, Internet Protocol Security (IPSec) must be disabled on the servers. The reason this must be done is that mobile devices are not domain-joined.

See also

Overview of mobile devices and SharePoint Server 2013


Fundamental site planning in SharePoint 2013
See also

Updated: June 18, 2013

Summary: View links to resources about site planning concepts such as how to structure sites and how to plan site navigation in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about fundamental site planning.

TechNet articles about fundamental site planning

The following articles about fundamental site planning are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of sites and site collections in SharePoint 2013 | Learn about sites, site collections, and site templates in SharePoint 2013.
Checklist icon (not checked) | Plan sites and site collections in SharePoint 2013 | Learn the critical decisions that you need to make in your SharePoint 2013 site planning process.
Checklist icon (not checked) | Plan self-service site creation in SharePoint 2013 | Learn the critical decisions that you need to make when you prepare for self-service site creation and management.
Building blocks | Overview of site policies in SharePoint 2013 | Learn about SharePoint site closure and deletion policies and how they apply to SharePoint governance and self-service site creation.
Building blocks | Overview of site navigation in SharePoint 2013 | Learn about the types of navigation controls that are available in SharePoint 2013.
Checklist icon (not checked) | Plan for multilingual sites in SharePoint 2013 | Learn how to plan for multilingual sites in SharePoint 2013 and SharePoint Online.
Checklist icon (not checked) | Plan for the multilingual user interface in SharePoint 2013 | Learn about the multilingual user interface feature, how it works, and how to plan to use it in SharePoint 2013 and SharePoint Online.
Building blocks | Overview of themes in SharePoint 2013 | Learn about the themes in SharePoint 2013 and how to use them to customize the look and feel of sites.

Additional resources about fundamental site planning

The following resources about fundamental site planning are available from other subject matter experts.

Content Description

TechNet logo

  • Resource Center: Enterprise Content Management in SharePoint Server 2010

Visit the TechCenter to access videos, community sites, documentation, and more.

See also

Plan for SharePoint 2013

Change History

Date | Description
June 18, 2013 | Added two new articles: "Plan self-service site creation in SharePoint 2013" and "Overview of site navigation in SharePoint 2013."
June 11, 2013 | Added new articles: "Overview of themes in SharePoint 2013," "Plan for multilingual sites in SharePoint 2013," and "Plan for the multilingual user interface in SharePoint 2013."
June 04, 2013 | Added new article: "Plan sites and site collections in SharePoint 2013."
February 19, 2013 | Initial publication


Overview of sites and site collections in SharePoint 2013
See also

Published: February 19, 2013

Summary: Learn about site collections, sites, and site templates in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A site collection is made up of one top-level site and all sites below it. As shown in the following figure, it is the top level of organization in a SharePoint 2013 web application. The number of site collections you can have in a single web application depends on the capacity of your server infrastructure. For more information about SharePoint 2013 boundaries, see Software boundaries and limits for SharePoint 2013. For more information about SharePoint 2013 capacity planning, see Capacity management and sizing overview for SharePoint Server 2013.

Figure: Structure of a site collection in SharePoint 2013

Diagram of a site collection

From an architecture standpoint, all the content of a site collection must be stored in a single content database. You cannot have a site collection's content spread out across multiple content databases. Content databases scale with your infrastructure capacity so site collections can share a content database. A site collection can exist in only one content database, but one content database can host the content for multiple site collections. Similarly, any given SharePoint 2013 site can only exist in one site collection, but a site collection can host a multitude of sites. A site cannot exist outside of a site collection.

In this article:

  • Overview of SharePoint site collections

  • Overview of SharePoint sites

Overview of SharePoint site collections

You create a site collection to host sites that are going to have something in common. For example, the sites might be in a common administrative boundary or share common branding. The site collection might be created to house all the sites and content for a business unit. Or, a single site collection might have become too large to manage, and it must be split into smaller ones. Lastly, some site collections are created exclusively to host specific SharePoint 2013 functionality, such as Enterprise Search Center or to host My Sites. Site collections are a way of organizing sites for a common purpose.

SharePoint 2013 supports two types of site collections: host-named site collections and path-based site collections. In a path-based site collection, all the subsites in the site collection will share a root or parent URL (DNS name). For example, Team A could have a site collection at http://contoso.com/sites/teamA, and Team B would have a site collection at http://contoso/sites/teamB. All sites in either site collection would have the http://contoso.com/sites/teamA or /teamB root. The only way to have a different URL root is to create a different web application.

To better align with SharePoint Online best practices, you should use host-named site collections. Host-named site collections allow you to assign custom names to each site collection that you create in a web application. For example, you can have two site collections in the same web application addressed like this: http://TeamA.contoso.com and http://TeamB.contoso.com. This is much more scalable and has been heavily tested in SharePoint Online. For more information about planning host-named site collections, see Host-named site collection architecture and deployment (SharePoint 2013).

Because site collections and sites exist in a parent-child relationship, there are aspects of control and functionality that can be configured at the site collection level and used at the site level. This provides many benefits as follows:

  • For site designers, a site collection's galleries and libraries (such as the Master Page Gallery or the Site Collection Images library) provide a means for creating a unified, branded user experience across all sites in the site collection.

  • For site collection administrators, a site collection provides a unified mechanism and scope for administration. For example, security, policies, and features can be managed for a whole site collection; Site Collection Web Analytics Reports, audit log reports, and other data can help administrators track site collection security and performance.

  • For farm administrators, site collections can be moved between content databases. By doing this, farm administrators can manage the size of their content databases.

  • For site authors, shared site columns, content types, Web Parts, authoring resources, workflows, and other site collection features provide a consistent authoring environment.

  • For site users, a site collection's unified navigation, branding, and search tools provide a unified website experience.

Every site collection starts out as a single, top-level site. Because it is a site, its structure and functionality is based on a site template. SharePoint 2013 provides many site templates for your use. You can also create and use your own as needed. SharePoint 2013 includes the ability to present sites in the style of SharePoint 2010 Products or the style of SharePoint 2013. The following table describes the 2013 experience version site templates that are available in SharePoint 2013.

Table: 2013 experience version site templates in SharePoint 2013

Type Name Description Availability

Collaboration

Team Site

A place to work together with a group of people.

Site collection and site, Server and Foundation

Blog

A site for a person or team to post ideas, observations, and expertise that site visitors can comment on.

Site collection and site, Server and Foundation

Develop Site

A site for developers to build, test, and publish apps for Office.

Site collection only, Server and Foundation

Project Site

A site for managing and collaborating on a project. This site template brings all status, communication, and artifacts relevant to the project into one place.

Site collection and site, Server only

Community Site

A place where community members discuss topics of common interest. Members can browse and discover relevant content by exploring categories, sorting discussions, by popularity or by viewing only posts that have a best reply. Members gain reputation points by participating in the community, such as starting discussions and replying to them, liking posts, and specifying best replies.

Site collection and site, Server only

Enterprise

Document Center

A site to centrally manage documents in your enterprise.

Site collection and site, Server only

eDiscovery Center

A site to manage the preservation, search, and export of content for legal matters and investigations.

Site collection only, Server only

Records Center

This template creates a site designed for records management. Records managers can configure the routing table to direct incoming files to specific locations. The site also lets you manage whether records can be deleted or modified after they are added to the repository.

Site collection and site, Server only

Business Intelligence Center

A site for presenting Business Intelligence content.

Site collection and site, Server only

Enterprise Search Center

A site focused on delivering an enterprise-wide search experience.

Note:

Search Centers should be separate site collections because they search for information across a company portal or division. If you create a Search Center as a subsite, you might have to create some workarounds for a full customization. For more information, see Customizing the Search Center in the MSDN Library.

Site collection and site, Server only

My Site Host

A site used for hosting personal sites (My Sites) and the public People Profile page.

Site collection only, Server only

Community Portal

A site for discovering communities.

Site collection only, Server only

Basic Search Center

A site focused on delivering a basic search experience. It includes a welcome page with a search box that connects users to a search results page and an advanced search page. This Search Center will not appear in navigation.

Note:

Search Centers should be separate site collections because they search for information across a company portal or division. If you create a Search Center as a subsite, you might have to create some workarounds for a full customization. For more information, see Customizing the Search Center in the MSDN Library.

Site collection and site, Server and Foundation

Visio Process Repository

A site for viewing, sharing, and storing Visio process diagrams. It includes a versioned document library and templates for Basic Flowcharts, Cross-functional Flowcharts, and BPMN diagrams.

Note:

The Visio Process Repository site template will be removed in the next version of SharePoint Server.

Site collection and site, Server only

Publishing

Publishing Portal

A starter hierarchy for an Internet-facing site or a large intranet portal. This site can be customized easily with distinctive branding. Typically, this site has many more readers than contributors and it is used to publish web pages with approval workflows.

Site collection only, Server only

Enterprise Wiki

A site for publishing knowledge that you capture and want to share across the enterprise.

Site collection and site, Server only

Product Catalog

A site for managing product catalog data that can be published to an Internet-facing site through search.

Site collection only, Server only

Publishing site

A blank site for expanding your website and quickly publishing web pages. Contributors can work on draft versions of pages and publish them to make them visible to readers. The site includes document and image libraries for storing web publishing assets.

Site only, Server only

Publishing Site with workflow

A site for publishing web pages on a schedule by using approval workflows. It includes document and image libraries for storing web publishing assets. By default, only sites with this template can be created under this site.

Site only, Server only

Custom

<Select template later…>

Create an empty site and pick a template for the site at a later time.

Site collection only, Server and Foundation

The following table describes the 2010 experience version site templates that are available in SharePoint 2013.

Table: 2010 experience version site templates in SharePoint 2013

Type | Name | Description | Availability
Collaboration | Team Site | Same functionality as the 2013 Team site. | Site collection and site, Server and Foundation
 | Blank Site | A blank site for you to customize based on your requirements. | Site collection and site, Server and Foundation
 | Document Workspace | A site for colleagues to work together on a document. It provides a document library for storing the primary document and supporting files. | Site collection and site, Server and Foundation
 | Blog | Same functionality as the 2013 Blog site. | Site collection and site, Server and Foundation
 | Group Work Site | This template provides a groupware solution that enables teams to create, organize, and share information. It includes a Group Calendar, Circulation, Phone-Call Memo, a document library, and other basic lists. | Site collection and site, Server and Foundation
 | Visio Process Repository | Same functionality as the 2013 Visio Process Repository. | Site collection and site, Server only
Meetings | Basic Meeting Workspace | A site to plan, organize, and capture the results of a meeting. It provides lists for managing the agenda, meeting attendees, and documents. | Site collection and site, Server and Foundation
 | Blank Meeting Workspace | A blank meeting site for you to customize based on your requirements. | Site collection and site, Server and Foundation
 | Decision Meeting Workspace | A site for meetings that track status or make decisions. It provides lists for creating tasks, storing documents, and recording decisions. | Site collection and site, Server and Foundation
 | Social Meeting Workspace | A site to plan social occasions. It provides lists for tracking attendees, providing directions, and storing pictures of the event. | Site collection and site, Server and Foundation
 | Multipage Meeting Workspace | A site to plan, organize, and capture the results of a meeting. It provides lists for managing the agenda and meeting attendees in addition to two blank pages for you to customize based on your requirements. | Site collection and site, Server and Foundation
Enterprise | Document Center | A site to centrally manage documents in your enterprise. | Site collection and site, Server only
 | Records Center | This template creates a site designed for records management. Records managers can configure the routing table to direct incoming files to specific locations. | Site collection and site, Server only
 | Business Intelligence Center | Same functionality as the 2013 Business Intelligence site. | Site collection only, Server only
 | Enterprise Search Center | A site for delivering the search experience. It includes a search box with scopes for general searches and for people searches. You can add and customize tabs to focus on other search scopes or result types. | Site collection and site, Server only
 | My Site Host | Same functionality as the 2013 My Site Host site. | Site collection only, Server only
 | Basic Search Center | A site for delivering the search experience. The site includes pages for search results and advanced searches. | Site collection and site, Server and Foundation
 | FAST Search Center | A site for delivering the FAST search experience. | Site collection and site, Server only
Publishing | Publishing Portal | Same functionality as the 2013 Publishing Portal site. | Site collection only, Server only
 | Enterprise Wiki | Same functionality as the 2013 Enterprise Wiki site. | Site collection only, Server only
 | Publishing Site with Workflow | Same functionality as the 2013 Publishing Site with Workflow site. | 2010 site only, Server only
Custom | <Select template later…> | Same functionality as the 2013 <Select template later…> option. | Site collection only, Server and Foundation
Web Databases | Assets Web Database | Create an assets database to keep track of assets, including asset details and owners. | 2010 site only
 | Charitable Contributions Web Database | Create a database to track information about fundraising campaigns including donations made by contributors, campaign-related events, and pending tasks. | 2010 site only
 | Contacts Web Database | Create a contacts database to manage information about people that your team works with, such as customer and partner. | 2010 site only
 | Issues Web Database | Create an issues database to manage a set of issues or problems. You can assign, prioritize, and follow the progress of issues from start to finish. | 2010 site only
 | Projects Web Database | Create a project tracking database to track multiple projects and assign tasks to different people. | 2010 site only
Note:

The Web Databases site templates that are available through the 2010 experience sites in SharePoint 2013 are no longer available in the 2013 experience sites in SharePoint 2013. In SharePoint 2013, you create an Access database by creating a new app, instead of creating a site. For more information, see Overview of apps for SharePoint 2013.

Important:

Some SharePoint 2010 Products site templates, such as the Document Workspace Site templates, were deprecated and are not available as an option in SharePoint 2013. Existing sites that were created by using these deprecated site templates and then upgraded will continue to operate in SharePoint 2013. The deprecated site templates will be removed completely from the next version of SharePoint. For more information, and to see a complete list of deprecated site templates, see Changes from SharePoint 2010 to SharePoint 2013.

Examples of solutions that benefit from being implemented as site collections are as follows:

  • Team collaboration site A site collection to support authoring and collaboration tasks. Often, this kind of site includes collaborative content that is not published but only used internally. For example, a team collaboration site collection might contain a site for each team in your organization to use to plan projects, coordinate tasks, record meeting notes, and store team documents.

  • Published Internet site A site collection for publishing content to anonymous Internet readers. A small number of authors create and publish content for many readers. For example, you might use a published Internet site to provide information about company products or services to customers. You can implement publishing sites in a single site collection, where authoring and publishing tasks are performed on the same site. You can also implement publishing sites as two or more site collections that separate the stages of authoring and publishing. Content is created on one or more authoring site collections, and is displayed on one or more publishing site collections by using the Cross-Site Collection Publishing feature in SharePoint Server 2013. For information about how to decide which publishing method to use, see Plan for Internet, intranet, and extranet publishing sites in SharePoint Server 2013. For information about cross-site publishing, see Plan for cross-site publishing in SharePoint Server 2013. Publishing sites are not available in SharePoint Foundation 2013. Cross-site publishing is only available in SharePoint Server 2013.

Overview of SharePoint sites

You create sites in your site collection to partition your content so that you can have finer control of the appearance and the permission to the content. You can also have different features available on the various sites in your site collection. You can use a site template with its default configuration, or you can change the site's default settings through site administration, and then save the site as a new template.

Note:

You cannot save a SharePoint publishing site collection or site as a template. If you activate the SharePoint Server Publishing Infrastructure feature on a nonpublishing site collection, the Save site as template link is removed from the Site Actions section on the Site Settings page.

You can configure the following items for a site:

  • Templates Sites in a site collection can each use different templates.

  • Language If language packs were installed on the web server, you can select a specific language to use together with the site template when you create a new site. The user interface that appears on the site is displayed in the language that was selected when the site was created. Content and other items created by users are displayed in the language in which they are created. For more information, see Plan for multilingual sites in SharePoint 2013 and Install or uninstall language packs for SharePoint 2013.

  • Security You can define unique user groups and permissions for each site. For more information, see SharePoint 2010 Governance Planning (white paper). For information about how to share securely, see Sharing - simplified on the Microsoft SharePoint Team Blog.

  • Navigation You can fine-tune your site's navigation experience by configuring unique navigation links in each part of your site's hierarchy. Site navigation often reflects the relationships among the sites in a site collection. Therefore, planning navigation and planning sites structures are closely related activities. For more information, see Overview of site navigation in SharePoint 2013.

    In SharePoint Server 2013 publishing sites, you can use managed navigation to create a site navigation that is derived from a tightly managed taxonomy. For more information, see Overview of managed navigation in SharePoint Server 2013.

  • Web pages Each site can have a unique welcome page and other pages.

  • Site layouts Each site can have a unique layout or master pages.

  • Themes You can change colors and fonts on a site. For more information, see Plan for using themes (SharePoint Server 2010).

  • Regional settings Each site can have custom regional settings, such as locale, time zone, sort order, time format, and calendar type.

  • Search Each site can have custom search settings. For example, you can specify that a particular site never appears in search results.

  • Content types Each site can have unique content types and site columns.

  • Workflows You can make each site have unique workflows.

  • Apps You can install apps for SharePoint to deliver specific information or functionality to a SharePoint site. An app for SharePoint is a small, easy-to-use, stand-alone application that solves a specific end-user or business need. For more information, see Overview of apps for SharePoint 2013.

See also

Plan sites and site collections in SharePoint 2013
Overview of site navigation in SharePoint 2013

Resource Center: Enterprise Content Management in SharePoint Server 2010


Plan sites and site collections in SharePoint 2013
See also

Published: June 4, 2013

Summary: Learn the critical decisions that you need to make in your SharePoint 2013 site planning process.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Every SharePoint 2013 site belongs to only one site collection and a site collection is made up of one top-level site and all sites below it. As shown in the following figure, a site collection is the top level of organization in a SharePoint 2013 web application. The number of site collections you can have in a single web application depends on the capacity of your server infrastructure. For more information about SharePoint 2013 boundaries, see Software boundaries and limits for SharePoint 2013. For more information about SharePoint 2013 capacity planning, see Capacity management and sizing for SharePoint Server 2013. For an overview of SharePoint 2013 site collections, see Overview of sites and site collections in SharePoint 2013.

Figure: Structure of a site collection in SharePoint 2013

Diagram of a site collection

Important:

The information in this article applies to SharePoint Foundation 2013 and SharePoint Server 2013. However, the article discusses certain types of sites such as My Sites, publishing, and records center and document center sites that are not available in SharePoint Foundation 2013.

In this article:

  • Sites and site collections planning principles

  • Methods of site and site collection organization

  • Inventory your farm

Sites and site collections planning principles

In general, use these rules to plan your sites and site collections:

  • Use one web application per farm to support all your site collections and sites.

  • Keep your internally facing (intranet) SharePoint 2013 solution in a separate SharePoint 2013 farm from your externally facing (Internet) solution.

  • Use host-named site collections instead of path-named site collections and place them in the default zone. For more information about how to design host-named site collections, see Host-named site collection architecture and deployment (SharePoint 2013).

  • Use path-named collections when you need to use alternate access mappings (AAMs).

Note:

For more information about how to plan site collections, see Overview of sites and site collections in SharePoint 2013.

Methods of site and site collection organization

There are many ways your sites can be organized. Having a plan in place to help govern your site deployments will help you avoid random, unorganized site growth, enable better management of your SharePoint infrastructure, and provide a better user experience.

Understand business needs

The first step in planning your site structure is to inventory the business problems and needs that you are using SharePoint 2013 to address. Then map your business needs to the site type best suited to meet them. This mapping will tell you the types of sites you will need. At the highest level, you will need sites that fall under the Collaboration category, the Enterprise category, the Publishing category, or the Custom category. For more information about the types of sites and how they are categorized, see Overview of sites and site collections in SharePoint 2013.

Models for site collections

After you determine which types of sites your solution requires, the next step is to plan how these sites are implemented across site collections. A site collection is a hierarchical set of sites that can be managed together. Sites in a site collection have common features, such as:

  • Shared permissions

  • Galleries for templates

  • Content types

  • Web Parts

  • Often share a common navigation scheme

The main goal of site collection planning is to put a structure in place that your organization can grow in without creating unnecessary management overhead. Here is a generic model for an intranet SharePoint 2013 farm that will meet many needs.

Figure: Model of an intranet SharePoint 2013 farm

A suggested model for site collections

Internal Collaboration and Publishing You can create a site collection to host your internal team sites. These can be broken down into two major categories. One branch can be organized around your company's internal hierarchy, with divisional portals hosting subsites for the individual long standing teams to use to store their content, collaborate, and publish their work out to the rest of the organization. Another peer branch can be for ad hoc or v-teams or project teams. These teams have members from across the long standing teams and need to have a collaboration and publishing space for a limited period of time.

Internal Enterprise Applications You can create a site collection to host sites and resources that everyone in your company will use. For example, your company intranet, enterprise search, My Sites, and records repositories. It is best practice to keep document center sites and records center sites in separate site collections.

Internet Presence It is best practice to place your company Internet presence in a separate SharePoint 2013 farm. Site collections of this type host resources that are available to anonymous users on the Internet. For example, you might use an Internet presence site to provide news articles or reviews that are tagged with metadata to categorize articles so that users can search or browse for information. For more information about how to design SharePoint 2013 for an Internet presence, see Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013 and Plan the logical architecture for cross-site publishing in SharePoint Server 2013.

All sites in a site collection are stored together in the same SQL database. This can potentially affect site and server performance, depending on how your site collections and sites are structured, and depending on the purpose of the sites. Be aware of the following limits when you plan how to allocate your content across one or more site collections:

  • Keep extremely active sites in separate site collections. For example, a knowledge base site on the Internet that allows anonymous browsing could generate lots of database activity. If other sites use the same database, their performance could be affected. By putting the knowledge base site in a separate site collection with its own database, you can free up resources for other sites that no longer have to compete with it for database resources.

  • Because all content in a site collection is stored in the same content database, the performance of database operations — such as backing up and restoring content — will depend on the amount of content across the site collection, the size of the database, the speed of the servers hosting the database, and other factors. Depending on the amount of content and the configuration of the database, you might have to divide a site collection into multiple site collections to meet service-level agreements for backing up and restoring, throughput, or other requirements. It is beyond the scope of this article to provide prescriptive guidance about how to manage the size and performance of databases.

  • Creating too many sites below a top-level site in a site collection might affect performance and usability. The maximum recommended number of sites and subsites in a site collection is 250,000 sites.

Once you have your site collection plan in place, you can move on to planning the organization of the sites in those site collections.

Plan sites by organizational hierarchy

Plan the basic sites that you need based on the scale and structure of your organization. Some sites for larger divisions or projects can also aggregate information that is found on all the smaller subsites that are devoted to smaller long standing teams or v-teams that are responsible for time limited projects.

Use the following guidelines when you plan sites that are based on your organizational structure:

Divisional or team sites Plan to create one site per team under a divisional rollup site. In large organizations, there might be several levels of sites, with each site focusing on the content that is created and managed at its level of the organization.

You can design a site for members of your organization to collaborate on content related to your business or organizational goals. These can be self-contained or they can work with other sites as part of a publishing process. Often, these sites will have a mixture of collaborative content that is used internally and content that is intended for publication to an audience.

Rollup sites A rollup site surfaces content that is stored on other subsites. It makes it possible for users across divisions to find information, and experts. It often contains sites that are related to the overall organizational information architecture and that are usually mapped to the structure of the divisional or project sites.

Plan application sites

An application site organizes team processes and provides mechanisms for running them. Application sites often include digital dashboards and other features to view and change data that is related to the site's purpose. The information that is presented in an application site usually comes from diverse sources, such as databases or other SharePoint sites.

For example, the human resources organization could design an application site to provide employees with:

  • Access to general information, such as employee handbooks and career opportunities.

  • Ways to do common tasks, such as submitting timecards and expense reports.

  • Dashboards to view personalized information, such as an employee's salary and benefits history.

As another example, the internal technical support group in an organization could design a Help Desk application site to provide technical support to members of the organization. Features of the application site could include the following:

  • Access to a knowledge base of past support incidents and best-practices documentation.

  • Ways to do common tasks, such as starting a support incident or reviewing the status of an ongoing incident.

  • Integration with communications features that support online meetings and discussions.

  • Personalized views of data. For example, support managers could view dashboards that provide views of their team members' productivity and customer satisfaction ratings. Support engineers could view their current unresolved incidents.

Plan publishing sites

By using a publishing site, authors can create and modify content in the form of web pages and documents, and they can use an approval process to make the content available to users who have the appropriate levels of viewing permissions. The publishing process involves creating content and then submitting it for approval. After content is approved, it is made available, or published, to the website for readers. This publishing occurs according to either a default schedule or a customized schedule, based on the needs of the project. Publishing sites can be used as intranet, extranet, or Internet sites, depending on the audience.

For example, you might use a publishing site for an Internet site that publishes press releases. The public relations team creates press releases, uses the publishing workflow to approve new content, and specifies when it should be made available to consumers. As another example, you might use a publishing site for a corporate intranet site, where company news is made available to employees. Page authors can specify the target audience for their content, which makes the content viewable by only the members of the designated groups.

You can use one of two ways to make published content available to users: author-in-place, or cross-site publishing. With the author-in-place method, you use a single site collection to author content and make it available to readers of your site. With the cross-site publishing method, you use one or more site collections to author content, and one or more site collections to control the design of the site and the display of the content. For more information, see Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013.

Plan other sites

You can plan to make it possible for site users to create additional sites. For example, you can plan to give a My Site to each team member who uses a site. A My Site is a team site that is based on SharePoint Server 2013 and has public and private views. You can also make it possible for team members to create other sites, such as Document Workspace sites, when they collaborate on documents and other projects. Similarly, you can give users of an Internet site access to collaboration sites as part of a web-based service. For example, you can give them permissions to create Meeting Workspace sites and participate in online meetings as part of their experience of using your site.

For information about the kinds of sites that you can create, see Overview of sites and site collections in SharePoint 2013.

Inventory your farm

To help you in your site and site collection planning, the Windows PowerShell command-line will inventory your entire SharePoint 2013 farm and get the properties of each site collection and site. It saves the results in a comma separated file (CSV). Use this inventory to identify what your site collection and site hierarchy are in each web application, and then plan where you want to add new sites.

To inventory a SharePoint farm by using Windows PowerShell

  1. Verify that you have the following memberships:

    • Securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • In the Farm Administrators group

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Open the SharePoint 2013 Management Shell.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPWebApplication -IncludeCentralAdministration | Get-SPSite -Limit All | Get-SPWeb -Limit All | Select-Object URL, Title, Description, ParentWeb, AssociatedOwnerGroup, SiteAdministrators, WebTemplate, UIVersion, QuickLaunchEnabled, TreeViewEnabled, Language, Locale, Author, HasUniquePerm | Sort URL | export-csv <file location and name.csv>

    Where:

    • URL is the address of the site.

    • Title is name of the site as configured in site settings and displayed on the title bar of the site.

    • Description is the value in the description field in the sites properties.

    • ParentWeb is the site immediately above the inventoried site in the hierarchy.

    • AssociatedOwnerGroup is the group that owns the site.

    • Site Administrations are the current users who are listed as the sites primary and secondary site administrators.

    • Web Template is the type of site template that the site was created from.

    • UIVersion is the SharePoint 2013 version of the site. This can be either 2013 or 2010.

    • QuickLaunchEnabled indicates if the site has the Quick Launch enabled in the vertical navigation.

    • TreeViewEnabled indicates if the site has the tree view enabled for the Quick Launch.

    • Language is the language the site was created in.

    • Locale is the locale of the site.

    • Author is who created the site.

    • HasUniquePerm indicates if the site inherits permissions from its parent site or implements unique permissions.

For more information, see Windows PowerShell for SharePoint 2013 reference.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Overview of SharePoint site collections

Software boundaries and limits for SharePoint 2013
Capacity management and sizing overview for SharePoint Server 2013
Overview of sites and site collections in SharePoint 2013
Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013
Host-named site collection architecture and deployment (SharePoint 2013)


Plan self-service site creation in SharePoint 2013
See also

Published: June 18, 2013

Summary: Learn the critical decisions that you need to make when preparing for Self Service Site creation and management.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Organizations have two ways to create site collections in their web applications. One way is to restrict site collection creation to Farm Administrators. The Farm Administrators create site collections either through the SharePoint Central Administration website or through SharePoint 2013 Management Shell. This provides tight control. Organizations can also enable Self Service Site Creation, which allows users with the necessary rights to create site collections under predefined paths. This article helps you understand self-service site creation.

Note:

The information in this article applies to SharePoint Foundation 2013 and SharePoint Server 2013. However, in SharePoint Foundation 2013, My Sites and the policies feature are not available and Self-Service Site Creation is disabled by default.

In this article:

  • Determine who can create sites and a method for site creation

  • Plan for Self-Service Site Creation

  • Plan for custom site creation processes

Determine who can create sites and a method for site creation

By default, new site collections can only be created by using Central Administration or SharePoint 2013 Management Shell, which means that they can only be created by members of the Farm Administrators group. This behavior might suit your organization if you want your environment to be tightly controlled and managed, with only a few people allowed to add top-level sites. However, the default top-level site creation method might not suit your organization if you have any of the following requirements:

  • You want users to be able to easily create informal, perhaps even disposable, top-level sites, such as for short-term projects.

  • You want to create an informal space for team, group, or community interaction.

  • You are hosting top-level sites (either internally or externally) and want the process for requesting and receiving a top-level site to be as quick and low cost as possible.

There are several ways to allow users to create their own sites, while still maintaining some control over your environment. Consider which of the following methods will work best for your organization.

  • Self-Service Site Creation Self-Service Site Creation enables users to create site collections under the /sites path (or other path you specify) within a particular web application. This method is best used when you want to allow groups or communities to create sites. This method also works well if you are hosting sites and want to allow users to create sites without waiting for a complicated process. The create a site user interface can be customized or replaced with a custom form that includes all of the information you might need to integrate with a billing system or to track custom metadata about the site at creation time. This method does not work well when large numbers of users need access to multiple sites. Because Self-Service Site Creation creates site collections, which have separate permissions, users need to be added uniquely to different site collections. If you use subsites instead, the users can be inherited from the parent site in the site collection.

    Self-Service Site Creation can also be configured to create sites instead of site collections. When enabled, users can create a new site quickly and easily from their personal site. Clicking the new site link from the Sites page creates a new site. The site is created by using the Team Site template and will have separate permissions. The site creator can add additional users to the new site.

  • Subsites of existing sites Limit users to creating subsites of existing sites, instead of new site collections and top-level sites. Any user who has the Full Control or Manage Hierarchy permission level on an existing site can create a subsite. This method is the most limited, because you still control how many site collections there are. Because the sites are always subsites of other sites, they can be either easy to organize (if there are just a few) or very difficult to organize and browse (for example, if everyone in your organization wants a subsite and they create them at different levels in the site collection's hierarchy, the site collection can soon become very difficult to navigate).

    Note:

    If you do not want users to have this capability, you can remove the Create Subsites right from the Full Control and Manage Hierarchy permission levels, either at the site collection or web application level.

  • My Sites Allow users to create personal sites (also known as My Sites). Personal sites are site collections stored under the /personal path of the web application. Personal sites are created for individual users, so they are not the appropriate method to use if you are trying to create sites for groups or communities. Self-Service Site Creation is used to create My sites For more information on My Sites, see Configure My Sites in SharePoint Server 2013

    Note:

    My Sites are not available in SharePoint Foundation 2013.

Note:

Keep in mind that none of these methods can control how much space each site takes up in your content databases. To control site sizes, you should use quotas and set a size limit for site collections. You cannot set individual size limits for subsites. For more on quotas see Plan quota management in SharePoint 2013.

Plan for Self-Service Site Creation

Self-Service Site Creation allows users to create and manage their own top-level websites automatically. When you turn on Self-Service Site Creation for a web application, users can create their own top-level websites under a specific path (by default, the /sites path). Self-Service Site Creation can be configured to create sites, instead of site collections, automatically. When turned on, this capability advertises itself with a new site link added to the Sites page of users' personal sites.

Note:

Self-service site creation only creates path based site collections. You cannot create host-named site collections with self-service site collections.

Note:

In SharePoint Foundation 2013, Self-Service Site Creation is disabled by default. When you enable Self-Service Site Creation, users can use the site creation page (http://<server>/_layouts/15/scsignup.aspx) to create a new site or site collection.

Note:

If you want to use a path other than /sites for Self-Service Site Creation, you must add the path as a wildcard inclusion.

When configured to create site collections, users must have Use Self-Service Site Creation permission on the host site collection. When configured to create sites, users must have Create Subsites permission on the parent site.

This capability can obviously affect the security for your web server. You enable Self-Service Site Creation for a single web application at a time. If you want to use it on all web applications in your server farm, you must enable it for every web application individually.

If you enable Self-Service Site Creation, you should consider the following:

  • Generally, you should require a secondary site contact. Administrative alerts, such as those for when quotas are exceeded, or checking for unused websites, go to the primary and secondary administrators. Having more than one contact reduces administrator involvement with these sites because the secondary contact can perform required tasks even if the primary contact is not available.

  • Define a storage quota and set it as the default quota for the web application.

    Note:

    You can also configure Self-Service Site Creation to apply a quota template to any site collections that are created.

  • Consider requiring a retention policy. When users create a site or site collection, they must select a policy to apply. For more information on site policies see, Overview of site policies in SharePoint 2013

  • Review the number of sites allowed per content database. Combined with quotas, this will help you limit the size of the databases in your system.

  • Enable unused website notifications, so that sites that are forgotten or no longer of value can be identified.

Because Self-Service Site Creation creates new top-level websites on an existing web application, any new sites automatically conform to the web application's default quota settings, unused website notification settings, and other administrative policies.

You can configure Self-Service Site Creation in a variety of ways to meet your needs. For example, if you have a web application dedicated to My Sites, you can enable Self-Service Site Creation but select to hide the new site link so that no one can use it to create new sites or site collections. You can also create a custom form that users utilize to create a site or site collection.

Plan for custom site creation processes

You can, of course, create your own process for site creation by using a custom form to request a site that integrates with a back-end billing system to charge a customer's credit card or a corporate cost center. If you have a complicated system or process that you want to include as part of site creation, you should create a custom application to call the site creation interface and perform any other tasks that you require. However, if you simply want to add a few custom fields to the site creation page (for example, to track which department in your company is requesting a particular site), you should consider using Self-Service Site Creation and customize the sign-up page to include the information that you need. You can customize the scsignup.aspx page in the site definition to include the metadata that you need without having to develop an entire application.

For more information about how to build custom applications or edit pages in a site definition, see SharePoint Developer Portal in the MSDN Library.

See also

Fundamental site planning in SharePoint 2013


Overview of site policies in SharePoint 2013
See also

Summary: Learn about SharePoint site closure and deletion policies and how they apply to SharePoint governance and self-service site creation.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Even with good governance, SharePoint sites can proliferate and grow out of control. Sites are created as they are needed, but sites are rarely deleted. If sites persist when they are no longer needed, they require storage space and they might be unwanted for compliance reasons.

You can use site policies to help control site proliferation. A site policy defines the life-cycle of a site by specifying when the site will be closed and when it will be deleted. When you close or delete a site, any sub-sites are also closed or deleted. If an Exchange mailbox is associated with a site, the mailbox is deleted from Exchange Server 2013 when the site is deleted.

Site closure is a new concept in SharePoint 2013. When you close a site, you specify that the site is no longer used so that the site can eventually be deleted according to a schedule. A closed site does not appear in other places where sites are aggregated — for example, Outlook, Outlook Web App, or Project Server 2013 — but users can still modify a closed site and its content by using the URL to reach the site.

SharePoint site policy options

A site policy specifies the conditions under which to close or delete a site automatically. There are the following four options:

  • Do not close or delete the site automatically. If a policy that has this option is applied to a site, the site owner must delete the site manually.

  • Delete the site automatically. If a policy that has this option is applied to a site, the site owner may close the site manually, but the site will be deleted automatically. A policy that deletes the site automatically specifies a rule for when to delete the site, and has the following options:

    • What action triggers the site to be deleted, and how long to wait after the trigger occurs before deleting the site. The trigger can be either site creation or site closure. For example, you can create a policy that deletes a site three months after the site is closed, or a policy that deletes a site one year after the site is created.

    • Whether to have SharePoint 2013 send a notification email message to the site owner a specified amount of time before the site is scheduled to be deleted.

    • Whether to allow site owners to postpone deletion of the site.

  • Close the site automatically and delete the site automatically. This option gives the same choices for how to delete the site automatically, and also requires you to specify how long after its creation time the site will be closed.

    Note:

    A site owner can re-open a closed site by going to the Site Closure and Deletion page from the Site Settings menu.

  • Run a workflow to close the site, and delete the site automatically. This option gives the same choices for how to delete the site automatically, and also requires you to specify a workflow to run. When the workflow finishes running, SharePoint 2013 closes the site. You specify the name of the workflow, how long after the site is created to run the workflow, and whether to rerun the workflow periodically until the site is closed.

A site policy can also specify that if it is applied to the root site in a site collection, when the root site is closed, the root site and all sub-sites become read-only.

Defining SharePoint site policies

You define site policies from the root site of a site collection by going to the Site Policies page from the Site Collection Administration menu. The policies are then available in every site in the site collection. Site owners can apply a policy to a site by going to the Site Closure and Deletion page from the Site Settings menu. Site owners can also close a site by using the Site Closure and Deletion page.

Note:

To delete a site manually, a site owner must select Delete this site on the Site Settings menu. The Site Closure and Deletion page shows when a site will be deleted automatically. However, it does not provide an option for the site owner to delete the site manually.

If the site collection in which you define site policies is a content type hub, then you can publish policies and share them across site collections. For more information about publishing content types — and site policies — across site collections, see Plan to share term sets and content types in SharePoint Server 2013.

Using SharePoint site policies with self-service site creation

Site policies are especially valuable when you use them together with self-service site creation. When a farm administrator enables self-service site creation on a web application, the farm administrator can specify that users must classify each newly created site by selecting a policy to apply to the site. The farm administrator can specify that site classification is required, optional, or hidden from the user. By using site policies together with self-service site creation, you can let users create their own sites, but also make sure that that the sites will be deleted after a certain time.

See also

Turn on or turn off self-service site creation (SharePoint 2013)


Overview of site navigation in SharePoint 2013
See also

Published: June 18, 2013

Summary: Learn about the types of navigation controls that are available in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Site navigation are the sets of controls and links in your site collections, sites and pages that help orient users to where they are and that help them easily get to other relevant locations. For example, you can configure site navigation to help users get to other sites in the site collection or you can configure it so that the top navigation and the vertical navigation controls are dynamically generated based on context of what the user is looking at. A well planned site navigation strategy make SharePoint 2013 sites easier to use.

SharePoint Server 2013 has many new features that use search technology to provide site owners with ways to display content dynamically on web pages. For more information about search-driven sites, see Plan for cross-site publishing in SharePoint Server 2013.

In this article:

  • Navigation controls overview

  • Common Navigation Controls

  • Navigation Web Parts

Navigation controls overview

Navigation controls can be displayed on master pages, page layouts, and — by using Web Part zones — directly in a page's content.

By default, SharePoint 2013 bases its navigation model on the hierarchical structure of the site collection. By using the navigation features, you can link any site to any other in the hierarchy and to pages in those sites. Additionally, you can create links to arbitrary locations, such as to an external website.

Diagram of a site collection

Managed Navigation - When you use managed navigation, you create a term set that represents the navigation hierarchy, and navigation controls display data from the term set. You can change the navigation hierarchy by changing the term set. For more information, see Overview of managed navigation in SharePoint Server 2013. Managed navigation is disabled by default in all site templates except the Publishing Portal site collection template.

Note:

Metadata navigation, managed navigation, navigation Web Parts, and navigation controls on page layouts are not available in SharePoint Foundation 2013.

Navigation links are subject to security trimming. This means that if a site user does not have permissions to the destination SharePoint 2013 site or page of the link, then that link is not displayed. Pages, sites, and links that are manually added to navigation can be configured to be available only to members of a particular audience. Users who are not members of that audience cannot see links to sites and pages that are targeted to that audience.

Common Navigation Controls

A master page defines the outer frame of the web pages in a site. Master pages contain the elements that you want all pages in your site to share, such as branding information; common commands, such as Search; and navigation elements that you want to be available throughout the site. A master page often includes the top navigation control (where links are presented on drop-down menus) and the vertical navigation control.

You can apply your own custom styles to these navigation controls by using Design Manager and an HTML editor of your choice. For more information about Design Manager, see Overview of Design Manager in SharePoint 2013.

Top Link Bar

The Top link bar control displays links to the sites that are one level below the current site in a site hierarchy. It is common for the top link bar to appear at the top of each page in a site. By default, all sites that are one level below the current site are added to the top navigation, and each site has its own unique top navigation. Site owners can customize the top navigation for a specific site.

screenshot of top link bar

Site owners can choose to inherit the top navigation from the parent site. This approach allows users to switch from one site to another from anywhere within the site collection, by allowing the top navigation to stay the same in all the sites in the site collection. For example, an Internet site that is used to market an organization's products could have a site for each line of its products. By displaying each product's site in the top navigation of each site, site designers can make it possible for users to easily switch from one site to another without having to return to the site home page.

Other top navigation configuration features include the following:

  • Linking to the web pages of all the top-level sites in SharePoint Server 2013 only

  • Linking to specified external sites

  • Linking to specified sites or pages that are anywhere in the site.

  • Organizing links under headings in SharePoint Server 2013 only.

  • Manually sorting the items on the top link bar

  • Restricting the maximum number of items to show at the global navigation level in SharePoint Server 2013 only

All top link bar features, such as linking to external sites, can be defined uniquely for each site. If you are on a top level site, you can add, move or rearrange the links by clicking EDIT LINKS

By using Design Manager you can additionally customize the appearance and functionality of the top link bar in SharePoint Server 2013 only.

Quick Launch

Quick launch typically highlights the important content in the current site, such as lists and libraries. It is common for it to appear on the left of each page in a site.

screen shot of the quick launch bar

Quick launch configuration features include the following:

  • Linking to sites that are on the same level of the site hierarchy as the current site in SharePoint Server 2013 only

  • Linking to specific external sites or to pages in the current site

  • Organizing links under headings.

  • Manually sorting the items in Quick Launch

  • Restricting the maximum number of items to show at the navigation level in SharePoint Server 2013 only

If you want to add, remove, or rearrange the links, click EDIT LINKS in the vertical navigation. You can also add, remove, rearrange links or create new headings in Site Settings for the site. To enable or disable Quick Launch, click the gear icon in the upper-right corner and then click Site Settings. In the Look and Feel area, click Tree view, and then select the Enable Quick Launch check box.

Just as you customize top navigation, you can also customize the appearance and functionality of vertical navigation by using Design Manager in SharePoint Server 2013 only.

Tree view

Tree view appears on the left side of the page. If you have enabled Quick launch and Tree view, Tree view will appear below Quick launch. Tree view displays site content, such as lists, libraries, and sites that are in the current site, in a hierarchical structure.

screen shot of tree view

By default, tree view navigation is turned off. To enable tree view, click the gear icon in the upper-right corner and then click Site Settings. In the Look and Feel area, click Tree view, and then select the Enable Tree View check box.

Metadata navigation

Metadata navigation displays metadata about library and list content in the tree view navigation, and lets users filter library or list content based on specified fields. Site administrators can configure metadata navigation by using the Metadata Navigation Settings page for a list or library to configure the navigation hierarchies and key filters that are available to users. Metadata navigation is displayed only when a user views the list or library for which metadata navigation was configured.

Managed navigation

Managed navigation enables you to define and maintain the navigation on your site by using term sets. This method supplements the existing SharePoint navigation based on site structure. You create the managed navigation structure by adding terms to the navigation term set in the Term Store Management tool. You can copy the navigation term set and translate it into the same languages that are used for variations labels. For more information, see Overview of managed navigation in SharePoint Server 2013.

Navigation Web Parts

A Web Part is a control that authors can insert into a Web Part zone on a page and configure. The Summary Links, Table of Contents, Content Query, and Content Search controls each have Web Part counterparts that page authors can insert into Web Part zones on pages. The Web Parts have the same configuration features and the same functionality as their related controls. However, they can be configured when they are inserted them on the page instead of when the site designer inserts them on the layout of the page. To make navigation Web Parts available for page authors to insert on a page, you can include one or more Web Part zones on a page layout, or you can include a Rich Text Editor control on a page, which will allow users to add Web Parts directly to the Rich Text Editor Web Part.

The following navigation Web Parts are available only for non-Publishing sites:

  • Content Rollup - Categories Displays categories from the Site Directory

  • Content Rollup - Site Aggregator Displays sites of your choice.

  • Content Rollup - Sites in Category Displays sites from the Site Directory in a specific category.

  • Social Collaboration - Tag Cloud displays the most popular subjects being tagged inside your organization.

If you make it possible for authors to insert navigation Web Parts on pages, you reduce the control that you have over your site's navigation because authors can then control part of the navigation experience of site users. This might be appropriate in a loosely controlled environment, such as a collaboration site in an organization, where individual authors must be able to point users to content that is related to the author's work. It is less appropriate in a more tightly controlled environment, such as an Internet presence site, in which the navigation experience is planned and implemented in a consistent, controlled way by the designers and planners of the site.

Note:

If you want to include Web Part zones on page layouts but prevent authors from inserting navigation Web Parts into these zones, you can change the permissions that are required to use navigation Web Parts in the Web Parts gallery of your site to make those Web Parts unavailable to authors based on their permission level.

See also

Overview of managed navigation in SharePoint Server 2013

Overview of Design Manager in SharePoint 2013


Plan for multilingual sites in SharePoint 2013
See also

Published: June 11, 2013

Summary: Learn how to plan for multilingual sites in SharePoint 2013 and SharePoint Online.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013 | SharePoint Online

SharePoint 2013 and SharePoint Online have features that enable you to support users in different regions or users who speak different languages. You can use these features to create websites in different languages, or to enable users to view sites in their preferred language.

This article describes how to plan for multilingual sites in SharePoint 2013. For information about how to create multilingual sites, see Choose the languages you want to make available for a site's user interface and Create a multi-language website on Office.com.

In this article:

  • About SharePoint multilingual sites

  • Determine language and locale requirements

  • Determine language pack requirements

  • Decide whether to use site variations

Important:

The concepts in this article apply to SharePoint Server 2013, SharePoint Online, and SharePoint Foundation 2013, except for the section Decide whether to use site variations, which applies only to SharePoint Server 2013 and SharePoint Online.

About SharePoint multilingual sites

The SharePoint 2013 multilingual sites feature enables you to work in more than one language, to provide content to users in more than one language, or both. By using the multilingual sites feature, you can do the following:

  • Create, manage, and read content in different languages.

  • Navigate a site in a preferred language.

  • Collaborate with people in different regions, in different languages, in the same application.

  • Manage personal sites by using a preferred language.

  • Search and browse content across a company by using a preferred language.

There are three ways that you can provide multilingual sites for users:

  1. You can create sites in languages different from the one that was used to install SharePoint.

    This option creates a site in which the site user interface appears in the language that was selected when the site was created. For example, if the English version of SharePoint was installed, but Japanese is selected when the site is created, the site user interface will appear in Japanese. This option only affects the site administration pages and user interface, and does not affect content created on the site. For more information, see Install or uninstall language packs for SharePoint 2013.

  2. You can use the multilingual user interface to enable users to view the site user interface in their preferred language.

    This option creates a site in one language, but can show the site user interface in another language, based on the preferred language of the user. For example, if the site was created in English, but the user's preferred language is Spanish, and the Spanish language pack was installed and enabled for the site, the site user interface for that user will appear in Spanish. This option only affects the site administration pages and user interface, and does not affect content created on the site. For information about the multilingual user interface, see Plan for the multilingual user interface in SharePoint 2013.

  3. You can use the variations feature to make publishing content available in different languages on different sites.

    This option creates a source variation site that is used to author content in one language, and then syncs that content to one or more target variation sites where it can be translated and consumed in other languages. For example, you can author and publish content in English for http://contoso.com/en, and use variations to sync content to http://contoso.com/fr, where you can translate it to French and publish it. Unlike the first two options, the variations feature does not affect site administration pages or the user interface; it affects only content. You can create the variation sites in different languages, and you can enable the multilingual user interface for users who create content for the variation sites. For information about variations, see Variations overview in SharePoint Server 2013.

    Note:

    The variations feature is available only in SharePoint Server 2013 and SharePoint Online.

Note:

Only options 1 and 2 require that language packs be installed. But if you want to create variation sites in other languages, or enable the multilingual user interface on variation sites, you must also install language packs for option 3. If you are using SharePoint Online, all language packs are already installed. For information about language packs, see Install or uninstall language packs for SharePoint 2013.

For information about how to decide whether to use multilingual user interface features, the variations feature, or both, see Introduction to multilingual features on Office.com.

If your organization supports users in different regions or users who speak different languages, you must determine what your multilingual requirements are and plan for multilingual site deployment when you plan your overall site structure and navigation. To determine your multilingual requirements, you must do the following:

  • Determine the languages and locales that you must support.

  • Determine the language pack requirements for sites and users.

  • Decide whether you want to use the variations feature.

Note:

Although Office SharePoint Server 2007 and Windows SharePoint Services 3.0 supported internationalized domain names (IDNs), SharePoint 2013 does not. If you currently use IDNs with Office SharePoint Server 2007 or Windows SharePoint Services 3.0 and you plan to upgrade or migrate to SharePoint 2013, you must stop using IDNs, delete any IDN settings, and set up a non-IDN environment before you upgrade or migrate to SharePoint 2013.

Determine language and locale requirements

You might have to create sites in multiple languages for any of the following reasons:

  • You want to provide content to users in different regions or countries, and you want to provide content to each region or country in its specific language.

  • You want to provide content to customers whose business spans many geographic areas.

  • You are required by government regulation or organizational policy to provide content in more than one language.

Consult all potential site owners to determine your language requirements. Record the list of sites and the default language for each site in a spreadsheet. Be sure to list all languages that you might have to support in the future. It is easier to install language support during initial deployment instead of waiting to install language support when your servers are running in a full production environment. After a site is created for a specific language, the default language of the site cannot be changed. But a user who is logged on to the site can use the multilingual user interface to view the site in the user's preferred language.

Note:

If users change their preferred language, some site elements, such as column names, might still appear in the default site language.

Do not assume that you have to create a site collection or site in multiple languages only because a document library contains documents in multiple languages. A document library can contain documents in multiple languages without requiring you to create site collections or sites in multiple languages. For example, the document library for an English site collection can contain documents that were written in French, Spanish, and Japanese. For publishing sites, content can be created in any language. You do not have to create a site collection or site in a specific language to show pages that contain content in other languages.

When you plan multilingual sites, you should also consider which locales are necessary to support your sites. Locale is a regional setting that specifies the way numbers, dates, and times are shown on a site. But locale does not change the language in which the site is viewed. For example, selecting the Thai locale changes the default sort order of list items, and uses the Buddhist calendar instead of the default calendar. But it does not change the site user interface language to Thai. Locale is a setting that is configured independently of the language specified when a site is created. In your spreadsheet, record any locales that you want to use with specific languages. The site locale can be changed, but only until any of the lists on the site are indexed.

Determine language pack requirements

SharePoint language packs enable you to create site collections and sites in multiple languages without requiring separate installations of SharePoint 2013. A farm administrator must install language packs on all front-end web servers in the SharePoint farm before sites can be created in languages other than the default language. For more information, see Install or uninstall language packs for SharePoint 2013. When you create a site collection or a site and select a language, the user interface text that appears on the site collection or site is shown in the selected language. For example, when you create a site in French, the toolbars, navigation bars, lists, and column headings for that site appear in French. Likewise, if you create a site in Arabic, the site administration pages and user interface, such as toolbars, navigation bars, lists, and column headings for that site, appear in Arabic, and the default left-to-right orientation of the site changes to a right-to-left orientation to correctly show Arabic text.

If your site will have users who can't work in the default language that you plan to use for the site, you should install language packs that will enable users to work in their preferred language by using the multilingual user interface. If you do not provide support for additional languages, users might find it difficult to use site features in their non-native language. Language packs provide language-specific translation of user interface elements such as the following:

  • Site administration pages

  • Ribbon elements

  • List and site column headers

  • Site settings interface

  • Templates for new lists, document libraries, and sites

  • Managed metadata term sets and terms

    Note:

    Managed metadata is not available in SharePoint Foundation 2013.

For more information about what is supported by the multilingual user interface, see Plan for the multilingual user interface in SharePoint 2013.

Note:

Language packs provide translation only of the user interface. They do not translate content that is created and shown in content pages or Web Parts. You can use the Machine Translation service to enable users to automatically translate documents. For more information, see Create and configure Machine Translation services in SharePoint Server 2013.

The list of available languages that you can use to create a site collection or site, and which you can enable for the multilingual user interface, is generated by the language packs that are installed on the front-end web servers of the server farm. By default, site collections and sites are created in the language in which SharePoint 2013 was installed. For example, if you install the Spanish version of SharePoint 2013, the default language for site collections and sites is Spanish. If you must create site collections or sites in a language other than the default SharePoint 2013 language, you must first install the language pack for that other language on the front-end web servers before you can select another language in which to create a site. For example, if you are running the French version of SharePoint 2013 and you want to create sites in French, English, and Spanish, you must install the English and Spanish language packs on the front-end web servers before you can create the English and Spanish sites.

Note:

Every time that a language pack is installed, you must rerun the SharePoint Products Configuration Wizard, which stops and restarts Internet Information Services, the SharePoint Administration Service, and the SharePoint Timer Service. To minimize interruption of service to your users, you should plan to install all language packs before your sites go live.

Based on the language requirements of your site collections or sites, determine the language packs that must be installed on every front-end web server. In your spreadsheet, for each site, record the list of language packs that you want to make available as alternative languages. For information about which language packs are available, see Language packs in SharePoint Server 2013.

The following table lists when language packs are or are not required:

Table: When language packs are required

To do the following | Are language packs required?
Create sites in different languages. | Yes
Enable the multilingual user interface on sites. | Yes
Use the variations feature to create multilingual content. | No
Create variation sites in different languages. | Yes
Enable the multilingual user interface on variation sites. | Yes

Even though you specify a language for a site, some user interface elements such as error messages, notifications, or dialog boxes might not appear in the language that you choose. This is because SharePoint 2013 relies on several supporting technologies — such as the .NET Framework, Microsoft Windows Workflow Foundation, ASP.NET, and SQL Server — and some of these supporting technologies are localized into a limited number of languages. If a user interface element is generated by one of the supporting technologies, and if the supporting technology is not localized into the language that the site administrator specified for the site, the user interface element appears in English.

In addition, some text might originate from the original installation language, which can create a mixed-language experience. This type of mixed-language experience is typically seen only by content creators, site collection administrators, or site owners, and is not seen by site users.

Note:

Error logs that SharePoint 2013 stores on the server are always in English.

For information about how to install language packs, see Install or uninstall language packs for SharePoint 2013.

Decide whether to use site variations

The SharePoint Server 2013 variations feature enables site owners to make the same content available to specific audiences across different sites by maintaining customizable copies of the content from the source variation site in each target variation site. For a multilingual site, you might want to use the primary language of your organization as the source variation site. You can create the target variation sites in the same language as the source variation site, or in the language the target variation site is intended to support. If you plan to create the target variation sites in other languages, verify that the corresponding language packs are installed. For more information about variations, see Variations overview in SharePoint Server 2013.

When you plan for multilingual sites, consider whether you have to create content that will be shared across sites, but must be changed to meet regional requirements or translated to meet language requirements. If you think there is a possibility that you might have to set up variations sites, you should plan for them beforehand. It is very difficult to integrate variations sites into a site collection after the site structure is implemented. The following factors can affect your ability to easily move to using variations sites later in the life of your site:

  • Custom code Code that contains references to the location of the root variations site.

  • Site customizations Site navigation, Master Pages, and other customizations.

  • Search Search scopes must be created for each variation label, and the site properties of each variations site must be changed.

If you plan to translate content on your variations sites, you must decide whether to use human translation or machine translation. If you plan to use machine translation, make sure that the language to which you want to translate content is available for the Machine Translation service.

For more information about how to plan for variations, see Plan for variations in SharePoint Server 2013.

Note:

The variations feature is not available in SharePoint Foundation 2013.

See also

Plan for the multilingual user interface in SharePoint 2013
Variations overview in SharePoint Server 2013
Plan for variations in SharePoint Server 2013

Multilingual term sets (SharePoint Server 2010)


Plan for the multilingual user interface in SharePoint 2013
See also

Published: June 11, 2013

Summary: Learn about the multilingual user interface feature, how it works, and how to plan to use it in SharePoint 2013 and SharePoint Online.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013 | SharePoint Online

The multilingual user interface (MUI) feature enables users to display the user interface of a SharePoint 2013 or SharePoint Online site in the language they prefer, instead of the default language that was selected when the site was created. This article describes the use and benefits of the MUI feature, explains how the feature works, and lists the other features and functionality that are supported by the feature. It also describes how to add and edit application content, and how to export and import content for translation. It explains how to use the MUI feature with managed metadata, and describes the limitations of the feature. Finally, this article describes how to plan for using the MUI feature in a SharePoint 2013 site solution.

For information about how to plan for multilingual sites, see Plan for multilingual sites in SharePoint 2013.

In this article:

  • How the multilingual user interface works

  • Use and benefits of the multilingual user interface feature

  • What is supported by the multilingual user interface

  • Managing application content

  • Using the multilingual user interface with managed metadata

  • Limitations of the multilingual user interface

  • Plan to use the multilingual user interface

How the multilingual user interface works

By default, when a new site is created, it is created in the default language of the SharePoint 2013 installation on the server. A farm administrator must install language packs on all front-end web servers in the SharePoint farm before sites can be created in languages other than the default language. For more information, see Install or uninstall language packs for SharePoint 2013.

Note:

If you use SharePoint Online, all language packs are installed and available for use.

After language packs are installed on the server, the Language settings link is added to the Site Settings page. Site collection administrators and site owners use the Language Settings page to specify which alternate languages the site will support. After the site collection administrator or site owner has enabled alternate languages for a site, the next time that a user logs on to the site, SharePoint 2013 uses one of the following rules to determine the language in which to display content to the user:

  1. If the User Profile service application is started on the SharePoint Server 2013 farm, the language preferences stored in the user profile are used. For information about how to add a list of languages to user profile settings in SharePoint Server 2013, see Add, edit, or delete custom properties in SharePoint Server 2013 user profiles. For information about how to add a list of languages to user profile settings in SharePoint Online Administration Center, see Add and edit user profile properties on Office.com.

  2. If no language preference is defined in the user profile, or if the server uses SharePoint Foundation 2013, the language preferences stored in the user's language settings for the site collection are used.

  3. If no language preference is defined in the user's site collection language settings, the language preferences stored in the user's web browser are used.

  4. If no language preference is defined in the user's web browser, the default site language is used.

The MUI feature only displays site's user interface elements in a user's preferred language. It does not translate content or display content such as documents or list items in an alternate language. To translate webpage content, you use the variations feature in SharePoint Server 2013 or SharePoint Online.

SharePoint 2013 provides three methods that you can use to change certain application content, such as list or library titles and descriptions: by using the user interface, by exporting and importing translations for a site, and by using the SPUserResource class in the Microsoft.SharePoint namespace. Not all user interface elements can be changed directly in the user interface. For example, user actions and commands can be changed only by using the SPUserResource class. For more information, see SPUserResource class in the MSDN Library.

For information about how to install language packs, see Install or uninstall language packs for SharePoint 2013. For information about how to let individual users change the language that is used to display their site's user interface, see Choose the languages that you want to make available for a site's user interface on Office.com.

Use and benefits of the multilingual user interface feature

The MUI feature enables users to collaborate in a single site by using another language that they prefer, regardless of which language was selected when the site was created. For example, the default language for a site could be English, and a user whose preferred language is French will view the site in French, whereas a user whose preferred language is Spanish will view the site in Spanish.

When you create a site and language packs are installed on all the front-end web servers, you can specify the default site language. The site will use that language to display the site's user interface, such as site navigation and administrative pages. If you want to enable site users to view the site's user interface in a preferred language, you can use the Language Settings page to specify alternate languages that you want to make available to users. When a user logs on to the site, the users preferred language is used to display the site's user interface. All sites within that domain name are displayed in the user's preferred language. This does not change the default site language. Other users who view the site see the site's user interface displayed either in the default site language or in their preferred language. The site's user interface is changed only for those users who have specified a preferred language in which to view the site.

By using the MUI feature, team members can work on documents and projects in a shared language while they view the site and perform tasks in their preferred language. In addition to team collaboration, the MUI feature enables farm and site collection administrators and site owners to perform administrative tasks in their preferred language. For example, farm administrators can view the administrative links and instructions on the SharePoint Central Administration website in their preferred language.

The MUI feature also enables users to change new and existing application content — such as list or library titles and descriptions — and it enables users to have those changes be reflected in the user interface for users of other languages. For example, a team member who uses English as the preferred language creates a new document library named "Team Reports." Another team member, who has the preferred language set to German, logs on to the site and changes the library title to "Mannschaftsberichte." The next time that users who have their preferred language set to German logs on to the site, the name of the document library is displayed as "Mannschaftsberichte." But users who have their preferred language set to English still see the document library name displayed as "Team Reports."

What is supported by the multilingual user interface

When a user views a site in a preferred language, certain elements of the user interface are displayed in the preferred language. Generally speaking, most user interface elements can be displayed in the preferred language, but user-created content cannot be. The following list includes examples of items that are supported by the MUI feature:

  • Settings pages, such as those in the _layouts and the _admin virtual directories.

  • SharePoint Help.

  • Application content, such as menus, controls, site actions, site title and description, list or library titles and descriptions, top link bar links, Quick Launch links, local breadcrumbs, site and list content types, and site and list columns.

  • Developer content, such as features and solutions.

  • List views.

  • Web Part titles, descriptions, custom properties, and import error messages.

  • The Blog site template was not supported in SharePoint Server 2010, but is now supported.

Not all user interface elements are displayed in the preferred language. The following list includes examples of items that are not supported by the MUI feature:

  • Global breadcrumbs.

  • User-created content, such as list item data, documents and web pages in libraries, custom permission levels, and groups.

For more detailed information about the user interface elements that are not supported by the MUI feature, see Limitations of the multilingual user interface, later in this article.

Managing application content

Application content includes content such as menus, controls, site actions, site title and description, list or library titles and descriptions, top link bar links, Quick Launch links, local breadcrumbs, site and list content types, and site and list columns. The MUI feature enables users to add or edit application content either in the default site language or in one or more alternate languages. You can also choose to export and import application content for bulk translation.

Adding and editing application content

When users add or edit application content, the following rules apply:

  • When users view a site in the default site language, any new application content that they create is displayed in the default site language, even when the site is viewed in another language.

    For example, if the default site language is English, when a user views the site in English and creates a new document library named "Team Documents," the library title is still displayed as "Team Documents" when the user views the site in French.

  • When users view a site in another language, any new application content that they create is displayed in that language, even when the site is viewed in the default site language, or in any other language.

    For example, if the default site language is English, and a user views the site in German and adds a document library named "Mannschaftsdokumente," the library title is displayed as "Mannschaftsdokumente" even when the site is viewed in English. To translate application content, such as a document library title into the default site language or into an alternate language, users must first change the language preference either in their user profile, or in their web browser settings, to display the site in the language they want to use, and then change the user interface string. The exception to this behavior is if the Overwrite Translations option is enabled. For more information, see Overwriting translated application content.

When a site is displayed in a user's preferred language, any changes that are made to existing application content strings are changed for that language only. The strings that are associated with specific application content in the default site language and any alternate languages remain unchanged. To translate application content strings, such as a document library title into the default site language or into any alternate languages, the user must change the language preferences in the browser or user profile to display the site in the default or switch language, and then make the change to the user interface strings.

Overwriting translated application content

The Language Settings page contains an Overwrite Translations option that affects how changes to existing application content are made to other languages for the site. If the Overwrite Translations option is enabled, any changes that are made to the user interface in the default site language will overwrite any changes that were made to those same user interface elements in switch languages.

By default, when a user views a site in the default site language, any changes that are made to existing application content are changed for the default site language only. The strings that are associated with specific application content in the alternate languages remain unchanged. If the Overwrite Translations option is enabled, the strings that are associated with that application content for every language are replaced with the new default site language string. For example, if the default site language is English and a user changes the title of the "Shared Documents" library to "Team Documents," by default, the title is changed only for the default site language. If the Overwrite Translations option is enabled, the title is changed to "Team Documents" for every alternate language, and it must be retranslated.

Exporting and importing translated application content

The MUI feature lets you export and import application content for bulk translation. Instead of translating application content one item at a time, you can export the strings for any new or changed application content in the default site language or in one of the alternate languages. To export content, you use the Export Translations link on the Site Settings page. When you export application content for an alternate language, you can choose to export all content or only content that has not been translated.

When the application content is exported, it is saved as a .resx file, which can be opened by using a text editor or any third-party tool that can open resource files. For more information, see Resources in .Resx File Format in the MSDN Library. After the resource strings are translated, you use the Import Translations link on the Site Settings page to import the .resx file.

Using the multilingual user interface with managed metadata

You can create multilingual managed metadata for use with a SharePoint Server 2013 solution. By using the Term Store Management Tool, you can create a term set and associate multiple labels, one for each language that you want to support, with each term in the set. When a user views the site in the user's preferred language, the terms are displayed by using the labels that correspond to the preferred language. For more information about how to use multilingual managed metadata with a site, see Multilingual term sets (SharePoint Server 2010).

Note:

Managed metadata is not available in SharePoint Foundation 2013.

Limitations of the multilingual user interface

As mentioned previously, some user interface elements are not MUI-enabled — that is, they are not supported by the MUI feature. This section describes additional limitations that apply when you use the MUI feature with shared components and site templates.

Shared components

Shared components, such as lists and permissions, appear across all site templates. Their functionality is centrally defined, and their behavior is consistent regardless of the site template in which they appear.

Lists

List views are MUI-enabled, but list items are not because they are user-created content. List items will continue to display the values that were entered when they were created, regardless of the user's preferred language.

Permissions

The following properties that are associated with permissions are not MUI-enabled. They are always displayed in the default site language or the language in which they were created:

  • Permission group names These include default permission group names and any custom permission groups that were created by a user.

  • Custom permission level names and descriptions These include any custom permission levels that were created or changed by a user.

  • User information User information such as About Me, Title, and Department.

Search site templates

Many of the Search site limitations are not actually related to MUI features, but are architectural designs that affect the user interface. The following limitations are a mix of MUI and architectural limitations for Search sites:

  • Search Search indexes content in the default language of the SharePoint Server installation. Even if content is provided in alternate languages, that content is only searchable by using the default site language. For example, if your preferred language is German, and the default site language is English, a search for "Freigegebene Dokumente" returns no results. A search for "Shared Documents" does return results.

  • Search Web Part properties Title, description, and custom properties are MUI-enabled. But if the default search prompt for the search box is customized, its customized value will be displayed for all languages.

  • Refinement Panel Web Part The Refinement Panel Web Part is not MUI-enabled. Term store labels that are displayed in the Refinement Panel Web Part are always displayed from the search index, which only stores items in the default site language. For example, if your preferred language is Italian, and the default site language is English, and you have a document that uses term store labels that contain values for both languages, the Refinement Panel Web Part will display only the English label.

    Note:

    This does not apply to the Taxonomy Refinement Panel Web Part, which displays the same language labels as the ones used in managed navigation.

Plan to use the multilingual user interface

Planning to use the MUI feature with a SharePoint 2013 site involves the following tasks:

  • Determine site language requirements.

  • Plan to install service packs.

  • Plan to translate application content.

Determine site language requirements

Before you can use the MUI feature in SharePoint 2013 sites, the farm administrator must install language packs on all front-end web servers so that they are available for use on sites. Decide which language packs are needed, and when they will be installed on the server. Site collection administrators or site owners must configure the language settings for individual sites to make specific languages available to site users. You must decide which languages are needed for each site, and plan to have the site collection administrators or site owners enable specific languages for the sites that they manage. For information about how to plan multilingual sites, see Plan for multilingual sites in SharePoint 2013. For information about how to install language packs, see Install or uninstall language packs for SharePoint 2013.

Note:

If you use SharePoint Online, all language packs are installed and available for use.

Plan to install service packs

If language packs are updated as part of a service pack release for SharePoint 2013, you must update the language packs on the servers when the service pack is installed. You should plan to coordinate with the farm administrator to monitor the release of service packs and any associated language packs so that you know about updated language packs that must be installed for users.

Note:

If you use SharePoint Online, all service packs and language packs are installed and available for use.

Plan to translate application content

If you plan to enable the MUI feature on your site to provide users a way to collaborate while they use their preferred language, you must decide whether the default MUI feature is sufficient, or whether application content must also be translated. If you have application content that must be translated, you should consider the following questions:

  • How will new and existing application content be translated? Will individual team members translate application content directly in the user interface as it is needed, or will you export resource files in the languages that are needed for the site, and have them all translated at the same time? If users create new application content in an alternate language, you must plan for who will translate that content into the default site language and for each alternate language. If you plan to create complex pages, such as new menu pages, or develop custom solutions, such as features that create lists, you must plan to use the object model to provide translations in alternate languages.

  • Who will translate the application content? Will resource files be translated by someone within your organization, or will you have a third-party translate them for you?

  • How will updates to the application content be handled? Will changes to the user interface be translated as changes are made, or will changes be made on a periodic schedule? This might depend on the size and scale of the sites and the content that is included.

  • How should translation overwrites be handled? Do you want changes in the default site language to overwrite string values in alternate languages? If so, then you must enable the Overwrite Translations option on the Language Settings page.

  • What column names must be changed? What column names must be translated, and for which languages? Will the column names be at the list level or at the site level?

See also

Plan for multilingual sites in SharePoint 2013
Language packs in SharePoint Server 2013
Variations overview in SharePoint Server 2013
Plan for variations in SharePoint Server 2013


Overview of themes in SharePoint 2013
See also

Published: June 11, 2013

Summary: Learn about the themes in SharePoint Server 2013 and how to use them to customize the look and feel of sites.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Themes give you a quick and easy way to change the look and feel of any site in SharePoint 2013. They are predesigned collections of web page elements, such as fonts, color schemes, layout, and background pictures that come with SharePoint 2013. In SharePoint 2013, you can apply a theme to a site, and then preview it before committing the change. You can change the theme of a site any number of times. For more information about themes, see Themes overview for SharePoint 2013 in the MSDN Library.

Use of themes is one way to change the look and feel of a site. Themes are part of the larger, updated branding and design capabilities in SharePoint 2013. For an overview of all the branding and design capabilities in SharePoint 2013, see SharePoint 2013 Branding and design capabilities in the MSDN Library.

This article includes an overview of themes and how they work. This article does not describe how to create custom themes, called composed looks, or how to upload and manage themes in a theme gallery. It also does not discuss how to plan for the overall branding of sites by using master pages or cascading style sheets. For more information, see Develop the site design in SharePoint 2013 in the MSDN Library.

In this article:

  • About themes

  • Ways to use themes

About themes

Themes enable lightweight branding of a SharePoint 2013 site by allowing a site owner or a user who has designer rights to make changes to the color palette, site layout, font scheme, and background of a site. Themes are applied and customized directly in the user interface, and do not require knowledge of cascading style sheets or master pages.

By default, a theme is only applied to the site for which it is selected. It is not inherited by any subsites unless you are working with a publishing site., Or, if the publishing feature was enabled for a site, you can choose to either inherit the theme from the parent site or specify a theme that will be used by the site. For more information about how to use themes in branding publishing sites, see Choose a theme for your publishing site on Office.com. When working publishing sites and you want more control over your customizations than themes can provide, use Design Manager. For more information about Design Manager, see Overview of Design Manager in SharePoint 2013 in the MSDN Library.

Note:

Themes in SharePoint 2013 have been redesigned to simplify the process of customizing sites by changing the site layout, color palette, font scheme, and background image. The themes user interface has been redesigned and there is a set of new file formats related to themes. Themes created in SharePoint 2010 Products cannot be used on SharePoint 2013 sites. However, they can still be used on site collections that have not been upgraded and are running in 2010 mode. For more information about upgrading, see Plan for site collection upgrades in SharePoint 2013 and Create a plan for current customizations during upgrade to SharePoint 2013.

Components of the themes experience

The following section provides an overview of the terminology and user interface components that comprise the themes experience in SharePoint 2013.

The following list describes the themes terminology used in this article:

  • Design A design, or composed look, is the color palette, font scheme, background image, and master page that determine the look and feel of a site. When used to discuss the overall look of a site, design and theme can be used interchangeably.

  • Image The background image used for the site. You can change this in any of the preconfigured themes.

  • Color palette A color palette, or color scheme, is the combination of colors that are used in a site. You can select from a number of predefined color combinations.

  • Site layout A master page defines how all the elements are structured on the page. There are two site layouts available for each of the preconfigured themes.

  • Font scheme Defines the fonts used in a site. You can select from a list of available fonts.

Theme gallery

You can access thumbnails of themes and apply them to a site through the Change the look gallery available in site settings.

The theme gallery can be accessed in the following ways:

  • Click Settings, and then click Change the look, or

  • On the Site Settings page, under Web Designer Galleries, click Themes, or

  • On the home page, click the What's your style? tile.

Master page gallery

The master page gallery lists the master page files, and their corresponding preview files (.preview), that are used by the themes user interface. The preview files are used to render the thumbnail images in the design gallery. If a master page does not have a corresponding preview file, it cannot be used in the design gallery.

To access the master page gallery, on the Site Settings page, under Web Designer Galleries, click Master pages. For information about how to create master pages, see How to: Create a master page preview file in SharePoint 2013 in the MSDN Library.

Composed looks list

The composed looks list shows the designs that are available to the design gallery. A design includes the design name, master page URL, color palette URL, image URL (optional), font scheme URL (optional), and display order number.

To access the composed looks list, on the Site Settings page, under Web Designer Galleries, click Composed looks.

Ways to use themes

There are three ways to use themes on a site:

  • Use a preinstalled theme.

  • Modify a preinstalled theme.

  • Upload a custom theme (composed look) to the gallery.

Use a preinstalled theme

SharePoint 2013 comes with preinstalled themes, including the default SharePoint theme. When a new site is created, it will use the default SharePoint theme.

Modify a preinstalled theme

When a preinstalled theme is modified, a new theme called Current is created automatically after the theme changes have been applied. There can only be one Current theme for a site. SharePoint 2013 does not provide a way to save themes within the user interface. If you modify a preinstalled theme, apply the changes (thereby creating a new theme called Current), and then modify a second preinstalled theme. The second preinstalled theme becomes the Current theme when the settings are applied.

To save a modified theme, create a new list item in the composed looks list that contains the same master page, color palette, font scheme, and background image URLs of the modified theme (the modified theme is called Current in the composed looks list).

Upload your own Composed Looks files to the theme gallery

You can create custom themes by creating additional color palettes and font schemes and uploading them to the theme gallery. The new color palettes and font schemes are then available to you when you choose to modify a design in the design gallery. Similarly, if you want to have additional site layouts to choose from, you can upload additional master pages, and corresponding preview files, to the master page gallery.

You can create new designs by creating new list items in the composed looks list. Create a new list item and specify the master page, color palette, font scheme, and background image for the new design. For more information about how to create and deploy custom themes, see How to: Deploy a custom theme in SharePoint 2012 in the MSDN Library.

See also

Plan for site collection upgrades in SharePoint 2013
Create a plan for current customizations during upgrade to SharePoint 2013

Themes overview for SharePoint 2013
SharePoint 2013 Branding and design capabilities
Develop the site design in SharePoint 2013
Choose a theme for your publishing site
Overview of Design Manager in SharePoint 2013
How to: Create a master page preview file in SharePoint 2013
How to: Deploy a custom theme in SharePoint 2012


Plan for site maintenance and management in SharePoint 2013
See also

Published: July 2, 2013

Summary: Learn how to control SharePoint resource utilization through management of sites and site collections.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Every site and site collection in your SharePoint 2013 farm uses system resources, such as storage, processing, and network. If sites are unused or abandoned they use resources but don't deliver any business value, and so they are a waste. Out-of-control sites use system resources beyond what your original plan may have allocated to them. In both cases, access to system resources is being denied and performance will suffer, overhead increases, and manageability decreases. To help you avoid these issues, you need to plan for managing your sites and site collections. This article tells you about the tools you can use to manage sites and site collections.

In this article:

  • Quotas

  • Usage reports

  • Site and site collection deletion

Quotas

The first step in controlling the amount of resources that your sites and site collections use is to establish and apply quota templates. Quotas let you control how much data a site collection can hold and then lock the site to further content when site storage reaches a maximum size. With quotas you can also control the amount of resources, such as processor and memory, that a site or site collection can use. Quotas let you set storage limit values and warning limit values as well as resource utilization limits which applications cannot exceed. Once you configure and apply quotas, you mitigate issues posed by 'out-of-control' site collections. For more information on working with quotas and how to configure them, see Create, edit, and delete quota templates in SharePoint 2013.

When you perform your database and server capacity planning, determine what size limits (if any) you want to enforce. The following list describes how to take the best advantage of quotas:

  • Create different quota templates for different site types. For example, you might want different quotas for different divisions, or for different customer types, or for different paths (perhaps sites under the /sites path only get 100 MB per site collection, whereas sites under the /VIP path can take up to 300 MB per site collection). Whenever you create a site collection from Central Administration, you can specify on which quota template it is based. Note that sites created by using Self-Service Site Management use the default quota for the web application.

  • Give enough room for reasonable growth in sites. Depending on what each site is used for, storage space needs can vary dramatically. Sites are designed to grow over time as they are used. A quota limit of 50 MB is unlikely to be enough storage space to start with for most sites, and is unlikely to be anywhere near enough for a site that has a long life.

  • Allow for reasonable notice between the warning e-mail message and locking the site for exceeding its quota. For example, do not set the warning limit to 80 MB and the site storage limit to 85 MB. If users are in the middle of uploading several large files, they will not be happy if they are blocked from completing that task with very little notice.

  • Archive obsolete content or sites. However, if you are going to archive or delete obsolete content or sites, be sure that users understand that plan and that you perform these actions only at predictable times. For example, publish a schedule of when you are going to archive content or delete unused sites.

  • Periodically review site permissions. For example, review the permissions quarterly to remove permissions for any users who have left the group or project.

  • Create a plan for regular backups of site content. Determine or discover how often backups will be made, and the process for restoring content when necessary. For more information about planning for backup and restore, see Plan for backup and recovery in SharePoint 2013.

Usage reports

Quotas prevent site collections as a whole from overrunning the limits you set, but within a site collection, some sites and pages will be used more than others. In order to balance your system resources you need to be aware of highly used pages and sites and of underused or abandoned sites. The highly used sites may need more resources and underused or abandoned ones should be archived or deleted. One part of your site maintenance plan should be a plan for how to manage the size and number of site collections in your environment. This is most important if you are allowing Self-Service Site Management. Most organizations want to be able to predict and control how much growth they can expect from sites because of the impact that they can have on database resources. For example, if a particular content database contains 100 sites, and one of those sites is taking up more than 50 percent of the space, then that site collection might need to be moved to a different content database. This will ensure that you preserve some room for additional growth, while maintaining the ability to back up and restore the databases

In SharePoint 2013 usage reports allow you to track activity on pages through number of hits and number of unique users for a site or site collection on a daily and monthly basis. Before you can view the reports, a farm administrator must configure usage and data collection. For more information on configuring collection of usage and health information, see Configure usage and health data collection in SharePoint 2013. For more information on viewing and using usage reports, see View usage reports in SharePoint Server 2013.

Site and site collection deletion

You need to plan how you will handle sites that become inactive after a project has ended, or sites that users created just to test out some ideas, and then abandoned. Site use confirmation and deletion can help you keep your environment cleaner, by helping you identify when sites are no longer needed. This feature works by automatically sending an e-mail message to site owners to see if they consider their site active. If the owner does not respond to the e-mail message (after a specified number of messages over a specified length of time), the site can be deleted. For more information on managing unused site collections, see Manage unused site collections in SharePoint 2013.

To plan for site use confirmation and deletion, decide the following:

  • How long you want to wait before checking to see if a site is inactive. The default length of time for team or project sites is 90 days after site creation. Usually a site that was created, was actively used, and is now ready to be deleted or archived, took at least six months and probably a few years to complete that life cycle. Reminders every six months are valuable for those situations.

  • How often you want to send an e-mail message to site owners to see if their sites are inactive. After the first e-mail message, if the site administrator does not respond, you can continue with additional notices at daily, weekly, or monthly intervals.

  • If you want to automatically delete unused sites. If the site administrator does not respond to multiple e-mail messages, do you want to go ahead and delete the site automatically? We recommend that you make a backup first. You can do so by making sure that regular backups are performed. You can use the SharePoint 2013 Developer content in the MSDN Library to customize this functionality so that it automatically makes a backup of the site before deletion, but this is not default behavior.

  • If you are going to automatically delete unused sites, how many e-mail messages will you send to site owners before you do so? By default, four weekly notices are sent before site deletion, but you can increase or decrease this number to suit your needs.

See also

Manage unused site collections in SharePoint 2013
Create, edit, and delete quota templates in SharePoint 2013
Configure usage and health data collection in SharePoint 2013
Delete a site collection in SharePoint 2013
Restore a deleted site collection in SharePoint 2013
Create a site collection in SharePoint 2013


Getting started with SharePoint Server 2013 workflow
See also

Updated: February 26, 2013

Summary: Learn about the two workflow platforms available in SharePoint Server 2013 and the tools for working with them.

Applies to: SharePoint Server 2013

SharePoint Server 2013 brings several changes to workflow. This guide gets you started with the SharePoint 2013 Workflow platform.

In this article:

  • A high-level view of the SharePoint 2013 Workflow platform

  • The process to install and configure the SharePoint 2013 Workflow platform

  • Workflow development tools

Watch an overview video of Workflow in SharePoint Server 2013

Video (play button) icon
Tip:

Workflow in SharePoint Server 2013 has many different aspects. Visit the Workflow Resource Center to read about all things related to SharePoint Server 2013 workflow. Be sure to bookmark the resource center site as content is regularly added and updated.

A high-level view of the SharePoint 2013 Workflow platform

The SharePoint 2013 Workflow platform uses the new Workflow Manager service. Workflow Manager is built on top of Windows Workflow Foundation. Windows Workflow Foundation is part of the .NET Framework 4.5.

The figure below illustrates the SharePoint 2013 Workflow platform technology stack.

Figure: SharePoint 2013 Workflow platform diagram

SharePoint 2013 Workflow platform diagram

Workflow Manager is a powerful new workflow service that can be used by many different applications. SharePoint Server 2013 uses Workflow Manager for its workflow engine.

Note:

Workflow Manager is a separate download and must be configured to communicate with the SharePoint Server 2013 farm.

In addition to the SharePoint 2013 Workflow platform, the SharePoint 2010 Workflow platform that came with SharePoint Server 2010 is still available in SharePoint Server 2013. The SharePoint 2010 Workflow platform installs with SharePoint Server 2013 just as it did with SharePoint Server 2010. The end result is that there are two platforms to choose from when you build a workflow in SharePoint Server 2013. To learn about the development experience when choosing a workflow platform in SharePoint Designer 2013, see Creating a workflow by using SharePoint Designer 2013 and the SharePoint 2013 Workflow platform.

Figure: Diagram of workflow platforms in SharePoint Server

Diagram of workflow platforms in SharePoint Server

To learn more about the new features of workflow in SharePoint Server 2013, see What's new in workflow in SharePoint Server 2013.

The process to install and configure the SharePoint 2013 Workflow platform

At a high level, there are only three steps required to get the SharePoint 2013 Workflow platform installed and configured. Of course, this is a simplification, because each of these steps includes its own due diligence and set of best practices. Nevertheless, it is a straightforward process to getting up and running and exploring the technology in a test environment should be straightforward.

For example, you could:

  1. Install and configure SharePoint Server 2013 by using the "stand-alone" installation that also installs SQL Server.

  2. Install and configure Workflow Manager on the same virtual machine by using the SQL Server instance that was installed in step 1.

  3. Configure the SharePoint Server 2013 farm to use Workflow Manager.

For detailed instructions on getting SharePoint Server 2013 and Workflow Manager installed and configured, see Configure workflow in SharePoint Server 2013.

Note:

We recommend that you follow best practices when you install SharePoint Server 2013 and Workflow Manager. For example, using a single account and a single server to install SharePoint Server, SQL Server, and Workflow Manager is fine for basic testing and product familiarization, but it should not be taken as a best practice. For anything other than an initial test environment, you should follow best practices.

Workflow development tools

There are several tools that come together to provide a rich workflow development experience. These include the following:

  • SharePoint Designer 2013

  • Visual Studio 2012

  • Visio 2013

  • InfoPath 2013

  • A supported web browser such as Internet Explorer, Firefox, or Chrome

SharePoint Designer 2013

The primary development tool for a SharePoint Server 2013 workflow is called SharePoint Designer 2013. SharePoint Designer 2013 provides a rich set of features specifically designed for workflow development against both the SharePoint 2010 Workflow platform and the SharePoint 2013 Workflow platform. You work with SharePoint Designer 2013 by opening it on your local computer and then connecting it to a SharePoint Server 2013 site.

Tip:

SharePoint Designer 2013 can connect to any SharePoint Server 2013 site as long as you have permissions to that site and can access it over a network. For example, you might have SharePoint Designer 2013 installed on a computer in your home office and SharePoint Server 2013 might be installed on a server at your corporate data center. As long as you can connect to your site, you can use SharePoint Designer 2013 to develop workflows for it.

Visual Studio 2012

Visual Studio 2012 is used in many types of Microsoft development. You can use Visual Studio 2012 to develop workflows similar to SharePoint Designer 2013. However it can also be used to develop custom actions and tasks such as a workflow action that interacts with a custom application.

SharePoint Server 2013 ships with a rich assortment of actions and tasks. If you need a very specific action, you can use Visual Studio 2012 to develop it. The custom action can then be used in SharePoint Designer 2013 by a workflow developer.

To learn more about building workflows by using Visual Studio 2012, see Develop SharePoint 2013 workflows using Visual Studio.

Visio 2013

Visio 2013 is an Office application that is used to build diagrams by using shapes and connectors. You can use Visio 2013 to build workflows based on the SharePoint 2013 Workflow platform. You can import workflows from Visio 2013 into SharePoint Designer 2013, and vice versa.

To learn more about building workflows by using the Visual Designer in SharePoint Designer 2013, see Getting familiar with Visual Designer for workflow in SharePoint Designer 2013.

InfoPath 2013

InfoPath 2013 is a tool designed for form development. Using InfoPath 2013 you can customize the forms that a workflow uses as users interact with it.

Web browser

A web browser, such as Internet Explorer, Firefox, or Chrome, is what you use to interact with SharePoint Server 2013 sites. For example, you can create lists and libraries, associate a workflow with a list and library, add items to a list or library, start a workflow on an item, and check the status of a workflow.

See also

What's new in workflow in SharePoint Server 2013

Workflow in SharePoint 2013
Workflow development in SharePoint Designer 2013 and Visio 2013
Workflow Manager

Change History

Date | Description
February 26, 2013 | Updated article to include a video overview of workflow in SharePoint Server 2013.
July 16, 2012 | Initial publication


Plan logical architectures for SharePoint 2013

Updated: May 14, 2013

Summary: Learn how to visualize the architecture of a SharePoint 2013 deployment by using the logical architecture articles and other resources in this section.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about logical architecture planning.

TechNet articles about logical architecture planning

The following articles about logical architecture planning are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | SharePoint 2013 design samples: Corporate portal and extranet sites | Use the design samples to see a generic corporate deployment of SharePoint 2013.
Checklist icon (not checked) | Plan service deployment in SharePoint 2013 | Lists the services on the Services on Server page in the SharePoint Central Administration website and provides deployment guidance for these services. Many of these services are associated with service applications.
 | Plan logical architectures for SharePoint 2013 | Learn how to plan and implement host-named site collections in SharePoint 2013 and how path-bases site collections might affect your environment.

Additional resources about logical architecture planning

The following resources about logical architecture planning are available from other subject matter experts.

Content Description

TechNet logo

  • Resource Center: Architecture design for SharePoint 2013 IT pros

Visit the TechCenter to access videos, community sites, documentation, and more.

Change History

Date | Description
May 14, 2013 | Added a link to "Plan logical architectures for SharePoint 2013."
July 16, 2012 | Initial publication


Plan service deployment in SharePoint 2013
See also

Updated: March 19, 2013

Summary: Learn about the services on the Services on Server page in the SharePoint Central Administration website and deployment guidance for these services. Many of these services are associated with service applications.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

In this article:

  • About Services on Server

  • Services on server for streamlined topologies

  • Services on Server for traditional topologies

About Services on Server

The Services on Server page in Central Administration lists services that are started or stopped on specific servers in the farm. Some of these services are associated with service applications. After deploying service applications to the farm, go to the Services on Server page and make sure that the associated services are started on the appropriate servers. Some of these services are not associated with service applications.

Note:

Note: Search components are deployed by using Windows PowerShell instead of the Services on Server page.

After planning the farm topology, use this article to make sure that the appropriate services on server are started for each server in the farm. This may not be necessary for small farms in which all of the service applications and services are run on one server or two redundant servers.

This article lists recommended configuration of services and service applications for two different architecture approaches:

  • Streamlined topologies — The distribution of services and other components in a farm is intended to maximize system resources of server hardware. Streamlined architectures include front-end servers, batch-processing servers, and database servers. You can use the Services on Server Install Worksheet for Streamlined Topologies to track decisions about which services are started on each server.

  • Traditional topologies — Topologies are based on traditional approaches to building architectures with Web servers, application servers, and database servers. You can use the Services on Server Install Worksheet for Traditional Topologies to track decisions about which services are started on each server.

For more information about these topology approaches, see the following models:

  • Streamlined Topologies for SharePoint Server 2013

  • Traditional Topologies for SharePoint Server 2013

Services on server for streamlined topologies

Table: Service applications and Services on Server for streamlined topologies

Service application | Services on server | Server recommendation | Additional information
Access Services | Access Services | Front-end server | Enables users of the Access 2013 client to create new Access service applications. View, edit, and interact with Access Services databases in a browser.
Access Services 2010 | Access Database Service 2010 | Front-end server | Allows continued maintenance of SharePoint 2010 Access service applications by using Access 2010 clients and Access 2013 clients. Does not allow users to create new applications.
App Management Service | App Management Service | Front-end server |
Business Data Connectivity | Business Data Connectivity service | Front-end server |
Excel Services | Excel Calculation Services | Front-end server or specialized server |
Machine Translation Service | Machine Translation Service | Batch-processing server | The Machine Translation Service uses SharePoint OAuth for file management. The Machine Translation Service Application's app pool account needs permissions to the User Profile Application to function correctly. The Machine Translation Service connects to the Microsoft Translator online service. Microsoft Translator may collect some data to improve the quality of translations.
Managed Metadata Service | Managed Metadata Web Service | Front-end server |
Microsoft SharePoint Foundation Subscription Settings Service | Microsoft SharePoint Foundation Subscription Settings Service | Front-end server | You must use Windows PowerShell to deploy this service. Start this service if you have deployed service applications in multi-tenant mode or if the farm includes sites that use site subscriptions. This service stores settings and configuration data for tenants in a multi-tenant environment. After you start this service, web applications consume the service automatically.
PerformancePoint | PerformancePoint Service | Batch-processing server or specialized server |
PowerPoint Conversion | PowerPoint Conversion Service | Batch-processing server | This service converts PowerPoint presentations to other formats. It typically runs on one or more application servers. It starts one or more worker processes to perform conversions. When actively converting, a worker process may use up a complete processor core. Memory usage depends on the size and content of files being converted. You can use Windows PowerShell cmdlets to control the number of worker processes that are used. Several other configuration options are also available through Windows PowerShell cmdlets.
Search | Lotus Notes Connector | Batch-processing server or specialized servers for search | Refer to TechNet documentation to learn how to configure Lotus Notes Connector which crawls data on a Lotus Domino server.
Search | Search Host Controller Service | Servers that run search components | This service manages the search topology components. The service is automatically started on all servers that run search topology components.
Search | Search Query and Site Settings Service | Servers that run the query processing component | This service load balances queries within the search topology. It also detects farm-level changes to the search service and puts these in the Search Admin database. The service is automatically started on all servers that run the query processing component.
Search | SharePoint Server Search | Servers that run search components | This service crawls content for the search index. This service is automatically started on all servers that run search topology components. The service cannot be stopped or started from the Services on Server page.
Secure Store Service | Secure Store Service | Front-end server |
Usage and Health Data Collection |  |  | This service application has no associated service on server.
User Profile | User Profile Service | Front-end server |
User Profile | User Profile Synchronization Service | Batch-processing server |
Visio Graphics Service | Visio Graphics Service | Front-end server |
Word Automation Service | Word Automation Services | Batch-processing server | Performs automated bulk document conversions. When actively converting, this service will fully use one CPU for each worker process (configured in Central Administration). If the service is started on multiple servers, a job will be shared across all the servers.
Work Management | Work Management Service | Batch-processing server |
 | Central Administration | Front-end server | This service runs the Central Administration site. It can be put on a batch-processing server if security policies of an organization mandate this.
 | Claims to Windows Token Service | Servers that run Excel Calculation Services and PerformancePoint as well as any other service applications that rely on this service to delegate a SharePoint user identity to an external data source |
 | Distributed Cache | Front-end server OR Distributed Cache and Request Management tier (not both) | By default this service is started on all web servers and application servers in a farm.
 | Document Conversions Launcher Service | Batch-processing servers | Schedules and starts the document conversions on a server.
 | Document Conversions Load Balancer Service | Batch-processing servers | Balances document conversion requests from across the server farm. Each web application can have only one load balancer registered with it at a time.
 | Microsoft SharePoint Foundation Incoming E-Mail | Front-end servers | Typically, this service runs on a web server. If you have to isolate this service, you can start it on an application server.
 | Microsoft SharePoint Foundation Sandboxed Code Service | Front-end servers | Start this service on computers that run sandboxed code in the farm. This can include front-end servers and batch-processing servers. This service runs code that is deployed as part of a sandboxed solution in a remote, rights-restricted process and measures the server resources that are used during execution against a site collection-scoped, daily quota.
 | Microsoft SharePoint Foundation Web Application | Front-end servers, batch-processing servers, plus the Distributed Cache and Request Management servers if these servers are implemented | This service provides web server functionality. It is started by default on web servers. Custom features scoped to web applications may not display in Central Administration as intended if this service is not started on the server running Central Administration and if the feature cannot be deployed globally.
 | Microsoft SharePoint Foundation Workflow Timer Service | Batch-processing server | This service is automatically configured to run on all web servers in a farm.
 | Request Management | Distributed Cache and Request Management tier | In integrated mode, Request Management runs on all web servers in a farm. In dedicated mode servers in a separate Request Management farm are between the hardware load balancer and one or more SharePoint farms.

Services on Server for traditional topologies

Table: Service applications and Services on Server for traditional topologies

Service Application | Services on Server | Server Recommendation | More information
Access Services 2010 | Access Database Service 2010 | Application Server | Allows continued maintenance of SharePoint 2010 Access service applications by using Access 2010 clients and Access 2013 clients. Does not allow users to create new applications.
Access Services | Access Services | Application Server | Allows creation of new Access service applications by using the Access 2013 client. View, edit, and interact with Access Services databases in a browser.
App Management Service | App Management Service | Application Server |
Business Data Connectivity | Business Data Connectivity service | Application Server |
Excel Calculation Services | Excel Calculation Services | Application Server |
Machine Translation Service | Machine Translation Service | Application Server | The Machine Translation Service uses SharePoint OAuth for file management. The Machine Translation Service Application's app pool account needs permissions to the User Profile Application to function correctly. The Machine Translation Service connects to the Microsoft Translator online service. Microsoft Translator may collect some data to improve the quality of translations.
Managed Metadata Service | Managed Metadata Web Service | Application Server |
Microsoft SharePoint Foundation Subscription Settings Service | Microsoft SharePoint Foundation Subscription Settings Service | Web server or application server | This service application is deployed only by using Windows PowerShell. In hosting environments, this service is typically started on one or more application servers. Start this service if you have deployed service applications in multi-tenant mode or if the farm includes sites that use site subscriptions. This service stores settings and configuration data for tenants in a multi-tenant environment. After it is started, web applications consume this service automatically.
PerformancePoint | PerformancePoint Service | Application server |
PowerPoint Conversion | PowerPoint Conversion Service | Application Server | This service converts PowerPoint presentations to other formats. It typically runs on one or more application servers. It starts one or more worker processes to perform conversions. When actively converting, a worker process may use up a whole processor core. Memory usage depends on the size and content of files being converted. The number of worker processes that are used can be controlled through Windows PowerShell cmdlets. Several other configuration options are also available through Windows PowerShell cmdlets.
Search | Lotus Notes Connector | Application Server | Refer to TechNet documentation to learn how to configure Lotus Notes Connector which crawls data on a Lotus Domino server.
Search | Search Host Controller Service | Automatically configured to run on the appropriate application servers | This service manages the search topology components. The service is automatically started on all servers that run search topology components.
Search | Search Query and Site Settings Service | Automatically configured to run on the appropriate application servers | This service load balances queries within the search topology. It also detects farm-level changes to the search service and puts these in the Search Admin database. The service is automatically started on all servers that run the query processing component.
Search | SharePoint Server Search | Automatically configured to run on the appropriate application servers | This service crawls content for the search index. This service is automatically started on all servers that run search topology components. The service cannot be stopped or started from the Services on Server page.
Secure Store Service | Secure Store Service | Application server |
Usage and Health Data Collection | NA | NA | This service application has no associated service on server.
User Profile | User Profile Service | Application server |
User Profile | User Profile Synchronization Service | Application Server |
Visio Graphics Service | Visio Graphics Service | Application server |
Word Automation Service | Word Automation Services | Application server | Performs automated bulk document conversions. When actively converting, this service will fully use one CPU for each worker process (configured in Central Administration). If the service is started on multiple servers, a job will be shared across all the servers.
Work Management | Work Management Service | Application Server |
 | Central Administration | Application Server | This service runs the SharePoint Central Administration website.
 | Claims to Windows Token Service | Web and application servers | This service is automatically configured to run on applicable servers.
 | Distributed Cache | Web and application servers | By default this service is started on all web servers and application servers in a farm.
 | Document Conversions Launcher Service | Application Server | Schedules and starts the document conversions on a server.
 | Document Conversions Load Balancer Service | Application Server | Balances document conversion requests from across the server farm. Each web application can have only one load balancer registered with it at a time.
 | Microsoft SharePoint Foundation Incoming E-Mail | Web server or application server | Typically, this service runs on a web server. If you need to isolate this service, you can start it on an application server.
 | Microsoft SharePoint Foundation Sandboxed Code Service | Web server or application server | Start this service on computers in the farm that run sandboxed code. This can include web servers and application servers. This service runs code that is deployed as part of a sandboxed solution in a remote, rights-restricted process and measures the server resources that are used during execution against a site collection-scoped, daily quota.
 | Microsoft SharePoint Foundation Web Application | Web server | Ensure that this service is started on all web servers in a farm. Stop this service on application servers. This service provides web server functionality. It is started by default on web servers. Custom features scoped to web applications may not display in Central Administration as intended if this service is not started on the server that runs Central Administration and if the feature cannot be deployed globally.
 | Microsoft SharePoint Foundation Workflow Timer Service | Web server | This service is automatically configured to run on all web servers in a farm.
 | Request Management | Web server or dedicated servers | In integrated mode, Request Management runs on all web servers in a farm. In dedicated mode servers in a separate Request Management farm are between the hardware load balancer and one or more SharePoint farms.

See also

Plan for SharePoint 2013

Change History

Date | Description
March 19, 2013 | Added the "Services on server for streamlined topologies" table.
July 16, 2012 | Initial publication


SharePoint 2013 design samples: Corporate portal and extranet sites

Summary: Describes logical architecture design choices for the most common SharePoint 2013 design samples.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article discusses several design samples that can be used as starting-point architectures for SharePoint sites. The design samples described in this article illustrate standard architectures for the most common types of SharePoint sites that are deployed within a company or organization.

In this article:

  • About the design samples

  • Sites included in the design samplesSites included in the design samples

  • Overall design goals

  • Server farms

  • Users, zones, and authentication

  • Services

  • Administration sites

  • Application pools

  • Web applications

  • Site collections

  • Content databases

  • Zones and URLs

  • Zone policies

Important:

The information in this article applies to SharePoint Foundation 2013 and SharePoint Server 2013. However, the article discusses certain features, such as My Sites and enterprise search, that are not available in SharePoint Foundation 2013.

About the design samples

The following design samples are described in this article:

  • Corporate Portal with Path-based Sites

  • Corporate Portal with Host-named Sites

  • Extranet with Dedicated Zones for Authentication

The design samples illustrate sites for a fictitious company named Fabrikam, Inc. The design samples apply nearly all of the logical architecture components and illustrate how these are incorporated into the overall design. This article describes the design goals for the samples and explains how the logical architecture components illustrated in the samples achieved these goals.

Corporate Portal design sample — two versions

Host-named site collections in SharePoint 2013 provide URL management and scalability of sites within a single web application. The two versions of the Corporate Portal design sample show implementations that are based on the use of the traditional path-based site collections or host-named site collections. Both of these design samples utilize claims-based authentication with a single zone. These samples are discussed in greater detail later in this article.

Extranet with Dedicated Zones for Authentication

The Extranet with Dedicated Zones for Authentication design sample includes only the partner web site. It provides an alternate configuration for partner collaboration in which dedicated zones are used for each authentication method. Each design sample uses claims mode authentication for web applications. The difference between the Corporate Portal design samples and the Extranet Design sample is how the zones are configured. The Extranet with Dedicated Zones for Authentication design sample uses multiple zones, and one method of authentication is configured for each zone. The Corporate Portal design samples use one zone, and multiple authentication methods are configured for different classes of users.

The Extranet with Dedicated Zones for Authentication design sample also introduces a new recommendation for remote employee access — Direct Access with Windows Server 2012. An alternative to this recommendation is to create a virtual private network (VPN). You can also use forms-based authentication on the firewall or gateway product to collect and forward credentials, if desired.

New host-named site collection features

SharePoint 2013 introduces new functionality for host-named site collections (also referred to as host-header site collections). Whereas previous versions of the Corporate Portal design sample made use of path-based site collections, going forward host-named site collections are recommended unless requirements indicate that the traditional path-based sites with alternate access mapping (AAM) are necessary (described later in this article). This is reflected in the design samples in the following ways:

  • Corporate Portal with Path-based Site Collections — This sample illustrates path-based site collections in the traditional way with sites organized into dedicated Web applications and a single top-level site collection per Web application. Use this approach if you want the additional security provided by multiple web apps with separate app pools.

  • Corporate Portal with Host-named Site Collections — This sample illustrates the use of host-named site collections with all sites deployed in a single Web application on the farm. This method is highly scalable and provides more flexibility in managing URLs.

  • Extranet with Dedicated Zones for Authentication — This sample illustrates many top-level project sites with vanity URLs by using host-named sites for each project site (instead of organizing project sites underneath a top-level site collection). One advantage of using host-named site collections in this manner is creating additional isolation between domain URLs, which might be desired in a partner collaboration solution. However, the tradeoff of this approach is the additional costs of managing a greater number of host names, including managing SSL certificates. Also, if SAML authentication is used, additional configuration is required (see "Using SAML authentication with host-named sites" later in this article).

Another design option is retaining a multi-web application design while at the same time implementing host-named site collections. While this option maintains the benefits of using dedicated web applications, it may not be practical because it requires extra configuration work with DNS and IP address binding management within the SharePoint Web applications on each Web server to map requests to the correct Web application when using host-named site collections. However, administrators who are familiar with scripting deployment may choose to manage the configuration of host-named site collections across multiple Web applications by adding the configuration to the scripts. In general, if multiple Web applications are required, the recommendation is to use path-based site collections with AAM instead.

These design options are contrasted later in this article.

Claims-based authentication for SharePoint 2013

The way that authentication works in for SharePoint 2013 might influence design decisions that are related to implementing choices represented by these design samples. Here are some examples:

  • In SharePoint 2013, claims-based authentication is the default mode and the only option available through Central Administration. Classic-mode authentication can be implemented by using Windows PowerShell.

  • In SharePoint 2013, you don't have to configure server affinity on the load balancer to use SAML claims authentication. SharePoint 2013 fully supports non-affinity load balancing.

In SharePoint 2013 the search crawl account requires access to content through the Default zone by using Integrated Windows authentication (NTLM or Kerberos). Because claims authentication allows multiple types of authentication in one zone, this requirement should not affect other authentication requirements.

Summary of design sample features

The following table summarizes the three design samples that are discussed in this article.

Table: Summary of design samples

Design Sample Includes Key design elements

Corporate Portal with Path-based Sites

Most common types of sites deployed within an organization.

  • Path-based site collections

  • Claims-based authentication

  • Multiple authentication providers and authentication types implemented in a single zone

Corporate Portal with Host-names sites

Most common types of sites deployed within an organization.

  • Host-named site collections

  • Claims-based authentication

  • Multiple authentication providers and authentication types implemented in a single zone

Extranet with Dedicated Zones for Authentication

Only the partner web site. Provides an alternate configuration for partner collaboration.

  • Host-named site collections

  • Claims-based authentication

  • Different zone for each authentication method

Sites included in the design samples

This section describes the top-level sites that are included in the design samples.

Intranet sites

The corporate portal includes the following sites for intranet use:

  • Published intranet content (such as HRweb)

  • Collaborative team sites

  • My Sites

Together, these are the content and collaboration sites that employees use on a day-to-day basis. Individually, each of these applications represents a distinct type of content. Each type of content has the following properties:

  • Emphasizes different features of SharePoint 2013.

  • Hosts data with different data characteristics.

  • Is subject to a different usage profile.

  • Requires a different permissions management strategy.

Consequently, design choices for each of these applications are intended to optimize the performance and security for each application.

The design of service applications brings these three applications together to provide the following features:

  • Enterprise-wide search

  • Shared profile data and enterprise metadata

The following illustration, from the Corporate Portal with Path-based Site Collections design sample, shows the three types of sites that make up the corporate intranet.

Types of sites that make up the corporate intranet

Partner web application

The partner web application hosts externally-available sites for secure collaboration with partner companies and individual partners. This application is intended for employees to easily create sites for secure collaboration. Partners cannot access other types of content that the server farm hosts. The design for zones and service applications addresses this goal. Additionally, individual site owners manage permissions for their sites and invite only necessary participants to collaborate.

In the extranet design sample, this is the only type of represented site.

Overall design goals

The design samples provide practical implementations of SharePoint 2013 features within several common types of sites. The design implementations for each of the individual applications are discussed in this article. Following are the key design goals for the design samples:

  • Create a framework for designing an environment that can grow.

    Design decisions for individual types of sites do not prevent the addition of other types of sites. For example, an initial deployment might include only collaborative team sites or only the three types of sites that compose an intranet (team sites, My Sites, and published intranet content). If you use a similar logical architecture design, you can add sites to the solution without affecting the design of the initial solution. In other words, the design does not incorporate design choices that limit the use of the environment.

  • Provide access for several groups of users without compromising the security of the content within the different types of sites.

    Users from different network zones (both internal and external) who use different authentication providers can participate in collaboration. Also, users can only access the content they are intended to access. If you follow a similar logical architecture design, you can provide access to users who are in multiple locations and have different objectives. For example, your initial design might be intended only for internal employee access. However, if you use a similar design, you can also enable access to remote employees, partner employees, partner companies, and customers.

  • Ensure that the design can be used in an extranet environment.

    Make deliberate design choices to make sure that the solution can be securely deployed in a perimeter network.

The rest of this article discusses each of the logical components that appear in the design sample (from top to bottom) and discusses the design choices that are applied to the design sample. The purpose of this approach is to demonstrate the different ways in which logical architecture components can be configured based on the application.

Server farms

This section describes the topologies of the server farms that are illustrated in the design sample and discusses scaling beyond a single farm.

Topology of the server farms

Each server farm in the design sample is composed of six servers with the following fault-tolerant topology:

  • Two front-end web servers

  • Two application servers

  • Two database servers with SQL Server installed and configured to support SQL Server clustering, mirroring, or AlwaysOn. AlwaysOn requires SQL Server 2012.

The design sample illustrates the logical architecture of SharePoint 2013 by showing that the following:

  • All sites are mirrored across front-end web servers.

  • The Central Administration site is installed on an application server to protect it from direct user access.

In reality, the number of server computers and the topology of the server farm are important to the logical architecture only to increase capacity and improve performance. You can design the logical architecture independent of the server farm topology. The process of planning performance and capacity helps you plan the size the server farm to meet performance and capacity goals.

Scale beyond two farms

Your business might require more than one farm. Sites that are candidates for a dedicated farm include the following:

  • My Sites

    Many organizations with large numbers of employees or students choose to host My Sites on a dedicated server farm.

  • Partner sites

    Security and isolation requirements might warrant a dedicated farm for partner collaboration. This physically isolates internal-only content from content that is developed in collaboration with external partners. The extranet design sample illustrates this configuration.

Users, zones, and authentication

Claims is the default mode of authentication in SharePoint 2013 and each design sample incorporates claims-based authentication. You can use Windows PowerShellto implement classic-mode authentication; however, some features of SharePoint 2013 are not available in classic mode. For more information about design samples that incorporate classic-mode authentication, see Design sample: Corporate deployment (SharePoint Server 2010)

The following table lists the differences in the two approaches that are represented by the Corporate Portal Design sample and the Extranet Design sample.

Table: Contrasting approaches for zone configurations in the design samples

Corporate Portal with Host-named sites and Corporate Portal with Path-based sites Extranet with Dedicated Zones for Authentication

Mode of authentication

Claims

Claims

Zone configuration

One zone with multiple authentication methods configured for different classes of users.

Multiple zones with one method of authentication configured for each zone.

URLs

All classes of users use the same URL for each site. Employees use the same URL regardless of whether they are inside the corporate network or working remotely.

Each class of user uses a different URL to access a site. Employees use a different URL depending on whether they are inside the corporate network or working remotely.

Internal requests

Requests that initiate inside the corporate network are routed out of the network and then back in through the gateway or proxy server. These requests are secured by using the Secure Sockets Layer (SSL) protocol.

Alternatively, split DNS can be used to route the requests directly to the internal interface for the servers.

Requests that initiate inside the corporate network remain internal to the network.

User experience

All users are prompted to choose the type of account they are using to log in.

The authentication method is predetermined. Users are not required to select the account type by using a logon page.

The following sections specifically discuss how authentication is incorporated by using the two different approaches.

Extranet with dedicated zones design sample

The extranet design sample illustrates three different classes of users, and each is assigned to a different zone. Within each web application, you can create up to five zones by using one of the available zone names: Default, Intranet, Internet, Custom, or Extranet. The search crawl account requires access to the Default zone by using Integrated Windows authentication (NTLM or the Kerberos protocol), which is accounted for in the design sample. The following table shows how zones are set up in the extranet design sample.

Table: Zones, users, and authentication type prescribed by the extranet design sample

Zone Users Authentication

Intranet

Internal and remote employees

Search crawl account

NTLM or Kerberos protocol

Remote employees who use Direct Access or VPN to connect.

Default

Individual partners

Options:

  • LDAP directory using forms-based authentication

  • Externally-facing Active Directory Domain Services (AD DS) forest with a one-way trust to the internal forest and Integrated Windows authentication

  • Trusted identity provider with SAML authentication

Extranet

Partner companies

Trusted partner identity provider with SAML authentication

Corporate Portal design samples

Claims-based authentication allows multiple types of authentication in the same zone. The two versions of the Corporate Portal design sample use the Default zone for all authentication types.

The following table shows the zones, users, and authentication types that are prescribed by the design samples.

Table: Zones, users, and authentication for the corporate portal design samples

Zone | Users | Provider and authentication type
Default | Internal and remote employees | Active Directory Domain Services (AD DS) or LDAP store with forms-based authentication or SAML authentication.
Default | Individual partners | Trusted identity provider with SAML authentication, or SQL Server database with forms-based authentication
Default | Partner companies | Trusted partner identity provider with SAML authentication
Default | Search crawl account | AD DS with Windows NTLM authentication

In the design sample, the Published Intranet Content site, Team Sites, and My Sites are only accessible to employees, whether they are inside or outside the network. The design sample implements only one URL (using SSL) for each of these sites that can be used both internally and externally. AD DS accounts are used. If needed, forms-based authentication or SAML can use LDAP, which requires additional configuration.

In the design sample, the partner web application represents an extranet site that partner employees and partner companies can access. Claims-based authentication in this scenario requires you to configure trust with one or more external identity providers. You can use either one of the following approaches:

  • You can configure the SharePoint farm to trust an external identity provider, such as the provider that resides in a partner company (to authenticate directly against the partner directory).

  • You can configure the identity provider inside the corporate environment to trust an external identity provider. Administrators in the two organizations must establish this relationship explicitly. In this scenario, the SharePoint farm trusts the identity provider from within its own corporate environment. When the identity provider sends a token, the farm uses the token signing certificate that was specified when the trust was established to confirm the validity of the token. We recommend this approach.

Forms-based authentication is an alternative to a claims-based environment to authenticate partners. You use a separate store, such as a database, to manage these accounts.

Zones

When you design zones, several key decisions are critical to the success of the deployment. These decisions include design and configuration decisions for the following zones:

  • The Default zone

  • Zones for external access

The following sections describe the decisions that are incorporated in the design sample.

Configuration requirements of the default zone

The zone that involves the greatest consideration is the Default zone. SharePoint 2013 places the following requirements on how you configure the Default zone:

  • When a user request cannot be associated with a zone, the authentication and policies of the Default zone are applied. Consequently, the Default zone must be the most secure zone.

  • Administrative e-mail messages include links from the Default zone. These include messages to owners of sites that are approaching quota limits. Consequently, users who receive these kinds of messages and alerts must be able to access links through the Default zone. This is especially important for site owners.

In SharePoint 2013 host-named site collections can be access from any zone.

Configuring zones for an extranet environment

In an extranet environment, the design of zones is critical for the following two reasons:

  • Several different networks can initiate user requests. In the design samples, users initiate requests from the internal network, the Internet, and partner companies.

  • Users consume content across multiple web applications. In the design sample, the intranet is composed of three web applications. Additionally, internal and remote employees can potentially contribute to and administer content in the partner web application.

If an extranet environment includes more than one zone, ensure that you follow these design principles:

  • Configure zones across multiple web applications to mirror each other. The configuration of authentication and the intended users should be the same. However, policies that are associated with zones can differ across web applications. For example, make sure that you use the Intranet zone for the same employees across all web applications. In other words, do not configure the Intranet zone for internal employees in one web application and remote employees in another.

  • If you use path-based site collections, configure alternate access mappings appropriately and accurately for each zone and each resource. Alternate access mappings are automatically created when you create a zone. However, you can configure SharePoint 2013 to crawl content in external resources, such as a file share. You must create links to these external resources manually for each zone by using alternate access mappings.

  • If you use host-named site collections, make sure that you use Windows PowerShell to map URLs to the appropriate zones

If zones across Web applications do not mirror each other and links to external resources are not appropriate, the following risks can occur:

  • Server names, Domain Name System (DNS) names, and IP addresses can potentially be exposed outside the internal network.

  • Users might be unable to access Web sites and other resources.

Using SAML authentication with host-named sites

If a design includes the use of SAML authentication with host-named sites, each vanity URL requires the following:

  • A new realm on the SPTrustedIdentityTokenIssuer

  • A corresponding relying party in the Identity Provider.

Services

The service architectures vary depending on the design sample. The Corporate Portal with Host-named Sites design sample includes the simplest architecture for services. This is because it uses one web application, which can accommodate only one service application group (also known as proxy group).

The Corporate Portal with Path-based Sites example uses partitioned services for the Partner sites to isolate data between projects. This design sample incorporates two service groups, one for the intranet sites and one for the partner collaboration sites. Separate instances of Managed Metadata and Search are deployed for the Partner sites and these services are partitioned. Partitioned services require the Subscription Settings Service which can only be deployed by using Windows PowerShell.

Service architecture for the Corporate Portal with Path-based Sites

Deploying partitioned services adds complexity to the architecture and makes it difficult to migrate sites to Office 365 at a later time. A simpler option for the Partner sites is to deploy dedicated but unpartitioned instances of the Managed Metadata service and Search service if these are required to be separate. Many organizations rely on the security trimming feature of Search, rather than deploying dedicated instances of the Search service.

The Extranet design sample includes only one proxy group but it also uses partitioned services for both the Managed Metadata and Search service applications.

The primary design decision for deploying service applications is how broadly to spread the organization taxonomy. To simplify the services architecture, share Managed Metadata, User Profile, and Search across all web apps and rely on security trimming to manage access to content. In the Corporate Portal with Path-based Sites design sample, one instance of the Managed Metadata service is shared across all sites. However, all users can access to the corporate taxonomy with this configuration. Solution architects must decide whether to implement multiple instances of the Managed Metadata service. They'll also need to decide how broadly to share the User Profile data.

Within the Corporate Portal with Path-based Site Collections sample, partner web is configured to use dedicated Search and Managed Metadata service applications by using a custom service group. Other service applications are added to the custom group and these are shared with the default group. The design sample does not include the User Profile service application to prevent partner users from browsing people data in the organization.

In the simplified architecture of the Corporate Portal with Host-named Site Collections (one service group), partners can access the entire corporate taxonomy and can browse people data in the organization. However, search limits results to sites and content that partners can access.

If your partner sites require content isolation between projects, deploying dedicated service applications is a good choice, as illustrated in this article. This increases the complexity of the services architecture but ensures that partners cannot access metadata that is associated with the Intranet content or even other projects within the partner web site. The Extranet design sample also uses partitioned services.

Administration sites

In the design sample, an application server hosts the SharePoint Central Administration website for each server farm. This protects the site from direct user contact. If a performance bottleneck or security compromise affects the availability of the front-end web servers, the SharePoint Central Administration website remains available.

The design sample and this article do not mention the load-balanced URLs for administration sites. Recommendations include the following:

  • If administrative URLs use port numbers, use non-standard ports. URLs include port numbers by default. While customer-facing URLs typically do not include port numbers, using port numbers for administration sites can increase security by limiting access to these sites to non-standard ports.

  • Create separate DNS entries for administration sites.

In addition to these recommendations, you can optionally load-balance the SharePoint Central Administration website across multiple application servers to achieve redundancy.

Application pools

Separate Internet Information Services (IIS) application pools are typically implemented to achieve process isolation between content. Application pools provide a way for multiple sites to run on the same server computer but still have their own worker processes and identity. This helps to prevent an attacker who injects code on one site from affecting other servers or sites on other sites.

If a single application pool and web application is used together with host-named site collections, isolation is provided between domain URLs but only at the scripting level.

If you choose to implement more than one application pool, consider a dedicated application pool for each of the following scenarios:

  • To separate authenticated content from anonymous content. If the same farm hosts the company Internet site, place this site in a dedicated web application and application pool.

  • To isolate sites that store passwords for and interact with backend data systems (although the Secure Store Service can be used for this purpose instead).

The Corporate Portal with host-named sites design sample and the Extranet with Dedicated Zones for Authentication design sample both implement a single application pool and web application for all content. Separate application pools are required for service applications and the SharePoint Central Administration website.

The Corporate Portal with Path-based Sites design sample implements process isolation between content by using separate application pools in the following ways:

  • The administration site is hosted in a dedicated application pool. This is a requirement of SharePoint 2013.

  • All service applications are deployed to a single application pool. Unless there is a compelling reason to deploy service applications to different application pools, this is the recommended configuration. One application pool for all service applications optimizes performance and reduces the number of application pools to manage.

  • Intranet content is divided into two different application pools. One application pool hosts collaborative content (My Sites and team sites). A separate application pool hosts the published intranet content. This configuration provides process isolation for the published intranet content in which business data connections are more likely to be used.

  • A dedicated application pool hosts the partner web application.

Web applications

A web application is an IIS web site that SharePoint 2013 creates and uses. Each Web application is represented by a different Web site in IIS.

If you choose to implement more than one web application, consider the following use cases:

  • Separate anonymous content from authenticated content.

    If the same farm hosts the company Internet site, place this site in a dedicated web application and application pool.

  • Isolate users

    In the design sample, a dedicated web application and application pool hosts the partner web site to make sure that partners do not have access to the intranet content.

  • Enforce permissions

    A dedicated web application provides the opportunity to implement policies on the zones within the web application to enforce permissions. For example, you can create policies for the company Internet site to explicitly deny write access to one or more groups of users. Policies are enforced regardless of permissions that are configured on individual sites or documents in the web application.

  • Optimize performance

    Applications achieve better performance if you place them in web applications with other applications of similar data characteristics. For example, the data characteristics of My Sites include a large number of sites that are small in size. In contrast, team sites typically encompass a smaller number of very large sites. By placing these two different types of sites in separate web applications, the resulting databases are composed of data with similar characteristics, which optimizes database performance. In the design sample, My Sites and team sites do not have unique data isolation requirements—they share the same application pool. Nonetheless, My Sites and team sites are placed in separate web applications to optimize performance.

  • Optimize manageability

    Because creating separate Web applications results in separate sites and databases, you can implement different site limits (recycle bin, expiration, and size) and negotiate different service-level agreements. For example, you might allow more time to restore My Site content if this is not the most critical type of content within your organization. This enables you to restore more critical content before you restore My Site content. In the design sample, My Sites are in a separate web application to enable administrators to more aggressively manage growth compared to other applications.

If you implement host-named site collections with a single web application, each top-level site is a separate domain which enables you to achieve some of these goals, such as optimizing manageability by implementing different site limits.

Site collections

The recommended configuration for deploying sites is using host-named site collections with all sites located within a single web application. This configuration is recommended to deploy sites because it is the same architecture that the Office 365 environment uses. Consequently this is the most heavily tested configuration. New features, including the App model and Request Management, are optimized for this configuration, and it is the most reliable configuration going forward.

Although we recommend host-named site collections for most architectures, you should use the traditional path-based site collections and alternate access mapping if any of the following conditions apply:

  • You need to use the Self Service Site Creation feature that is part of the default installation of SharePoint 2013.

    This does not apply to custom self-service site creation solutions.

  • A web application requires unique wild card inclusions or explicit inclusions.

    You create inclusions for host-named site collections at the farm level, and they are available for all host-named sites. All host-named site collections in a farm share the same inclusions but do not need to use them. In contrast, inclusions that you create for path-based site collections apply only to a single web application.

  • SSL termination is required but your SSL termination device cannot be configured to produce the necessary custom HTTP header.

    You can still use SSL bridging with host-named site collections with these devices if SSL termination is not a requirement.

  • You plan to use different application pools for the additional security that these provide or you need to use multiple proxy groups.

For more information about host-named site collections, including a comparison with path-based site collections, see Host-named site collection architecture and deployment (SharePoint 2013).

Design goals for site collections

Site collections bridge logical architecture and information architecture. The design goals for site collections are to fulfill requirements for URL design and to create logical divisions of content. For each site collection, managed paths incorporate a second tier of top-level site collections. For more information about URL requirements and using managed paths, see Zones and URLs later in this article. Beyond the second tier of site collections, each site is a subsite.

The following diagram illustrates the site hierarchy of Team Sites.

Site hierarchy for team sites

For both path-based site collections and host-named collections, the information architecture revolves around the second tier of site collections. The following section describes how design samples incorporate choices based on the nature of the sites.

Published intranet content

The assumption for the published intranet content web application is that multiple divisions within the company will host published content. In the design sample, a separate site collection hosts each division's content. This provides the following advantages:

  • Each division can manage content and administer permissions independently.

  • Each division can store its content in a dedicated database.

The disadvantages of multiple site collections include the following:

  • You cannot share master pages, page layouts, templates, Web Parts, and navigation be across site collections.

  • Coordination of customizations and navigation across site collections requires more effort.

Depending on the information architecture and design of the intranet sites together, the published content can appear to the user as a seamless experience. Alternatively, each site collection can appear to be a separate web site.

My Sites

My Sites have distinct characteristics and the deployment recommendations for My Sites are straightforward. In the design samples, the My Sites site collection incorporates a top-level site with the URL of http://my. The first top-level site collection that is created uses the My Site Host template. A managed path is incorporated (by using wildcard inclusion), which allows an indefinite number of user-created sites. All sites below the managed path are independent site collections that use the Personal Site template. The user name is appended to the URL in the form http://my personal/username. The following illustration illustrates My Sites.

Site hierarchy for My Sites

Team sites

You can use either of the following two approaches to design site collections in a Team Site application:

  • Allow teams to create site collections through self-service site creation. The advantage of this approach is that teams can easily create a site, as needed, without assistance from an administrator. Disadvantages to this approach include the following:

    • You lose the opportunity to implement a thoughtful taxonomy.

    • You cannot share templates and navigation across projects or teams that might otherwise share a site collection.

  • Create a finite number of site collections for your organization based on the way your organization operates. In this approach, a SharePoint administrator creates site collections. After a site collection is created, teams can create sites within the site collection. This approach provides the opportunity to implement a thoughtful taxonomy that provides structure to the way team sites are managed and grow. There is also more opportunity to share templates and navigation between projects and teams that share a site collection. However, this approach also includes some disadvantages.

The design samples incorporate the second approach, which results in a similar site collection hierarchy for team sites and published intranet content. The challenge for information architects is to create a second tier of site collections that makes sense for the organization. The following table suggests different types of organizations.

Table: Suggested site collection taxonomies

Type of organization Suggested site collection taxonomies

Product development

  • Create a site collection for each product under development. Allow contributing teams to create sites within the site collection.

  • For each long-term development project, create a site collection for each large team that contributes to the product. For example, create one site collection for each of the following teams: designers, engineers, and content developers.

Research

  • Create a site collection for each long-term research project.

  • Create a site collection for each category of research projects.

Higher education institution

  • Create a site collection for each academic department.

State legislative office

  • Create a site collection for each political party. Government officials who share party affiliation can share templates and navigation.

  • Create a site collection for each committee. Or, create one site collection for all committees.

Corporate law office

  • Create a site collection for each corporate client.

Manufacturing

  • Create a site collection for each line of products.

Partner web application

Partner web is intended to be used for collaboration with external partners on projects that have finite scopes or finite durations. By design, sites in the partner web application are not intended to be related. The requirements for the partner web application include ensuring that:

  • Project owners can easily create sites for partner collaboration.

  • Partners and other contributors can access only the project they work on.

  • Site owners manage permissions.

  • Search results from within one project do not expose content from other projects.

  • Administrators can easily identify sites that are no longer used and delete these sites.

To satisfy these requirements, the design sample incorporates a site collection for each project. Both Corporate Portal design samples utilize a managed path to create a second tier of site collections below a root site collection. Alternatively, the Extranet design sample makes each partner site a top-level site collection by using host-named site collections. Either way, individual site collections provide the appropriate level of isolation between projects.

If you plan to use the Self Service Site Creation feature that is part of the default installation of SharePoint 2013 (as opposed to a custom solution developed for your organization), then use path-based site collections. Host-named site collections do not yet work with this feature.

Content databases

You can use the following two approaches to incorporate content databases into the design (the design sample incorporates both approaches):

  • Establish target sizes for content databases with appropriate size-warning thresholds. Create a new database when a database reaches size-warning thresholds. With this approach, site collections are automatically added to the available database or databases, based on size targets alone. This is the most commonly used approach.

  • Associate site collections to specific content databases. This approach enables you to place one or more site collections in a dedicated database that administrators can manage independently from the rest.

If you choose to associate site collections to specific content databases, you can use the following methods to accomplish this:

  • Use Windows PowerShell to create a site collection in a specific database.

  • Dedicate a database to a single site collection by applying the following database capacity settings:

    • Number of sites before a warning event is generated = 1

    • Maximum number of sites that can be created in this database = 1

  • Add a group of site collections to a dedicated database by completing the following steps:

    1. Within the web application, create the database and set the database status to Ready.

    2. Set the status of all other databases to Offline. While content databases are offline, new site collections cannot be created. However, existing site collections in offline databases are still accessible for both read and write operations.

    3. Create the site collections. They are automatically added to the database.

    4. Set the status of all other databases back to Ready.

Published intranet content

For published intranet content, the corporate portal design samples incorporate a single database for ease of management. Add databases based on target size goals, if needed.

My Sites

For My Sites, the corporate portal design samples achieve scale efficiency by managing databases to the maximum target size. The following settings are configured to achieve this goal:

  • Limit site storage to a maximum of: This setting, which you configure on the Quota Templates page in Central Administration, limits the size of a personal site.

  • Second stage Recycle Bin: This setting, which you configure on the Web Application General Settings page, determines the amount of additional space that is allocated to the second-stage recycle bin.

  • Maximum number of sites that can be created in this database: This setting is configured when you create a database. Calculate the total allowable size of sites by using the numbers you specify for the previous two values. Then, based on the size goal for each database, determine how many sites will fit in the database.

The design samples provide the following example size settings based on a target database size of 175 gigabytes (GB) and a target My Site size of 1 GB:

  • Site size limits per site = 1 GB

  • Target size of database = 175 GB

  • Reserved for second-stage recycle bin = 15%

  • Maximum number of sites = 180

  • Site level warning = 150

When the site-level warning is reached, create a new database. After you create the new database, new My Sites are added to the content database that has the fewest site collections.

Team sites

For team sites, again, the corporate portal design samples achieve scale efficiency by managing databases to the maximum target size. Team sites for most organizations are expected to be much larger than My Sites. The design sample provides database settings based on a 30-GB limit for site collections. Choose a limit that is appropriate for team sites in your organization.

Another approach for organizations whose teams have large storage needs is to dedicate a single database to each top-level team site collection.

Partner web

Similar to My Sites, partner web achieves scale efficiency by managing databases to the maximum target size.

The design samples provide the following example size settings:

  • Target size of database = 200 GB

  • Storage quota per site = 5 GB

  • Maximum number of sites = 40

  • Authoring site collection hosted in dedicated database

Zones and URLs

The design samples illustrate how to coordinate URLs across multiple sites within a corporate deployment. The following goals influence design decisions for URLs:

  • URL conventions do not limit the zones through users can access content.

  • The standard HTTP and HTTPS ports (80 and 443) can be used across all applications in the design sample.

  • Port numbers are not included in URLs. In practice, port numbers are typically not used in production environments.

Designing load-balanced URLs

When you create a web application, you must choose a load-balanced URL to assign to the application. The URL that you choose applies to the Default zone. Additionally, you must create a load-balanced URL for each additional zone that you create within a web application. The load-balanced URL includes the protocol, scheme, hostname, and port, if used. The load-balanced URL must be unique across all web applications and zones. Consequently, each web application and each zone within each web application requires a unique URL across the design sample.

Intranet

Each of the three site collections that make up the intranet requires a unique URL. In Corporate Portal design samples, the target audience for the intranet content is internal employees and remote employees. Employees use the same URLs for each of these sites regardless of whether they are on site or remote. This approach adds a layer of security to the SharePoint design (all traffic is SSL). However, this approach requires you to choose an alternative for additional configuration:

  • Route internal traffic through the firewall or gateway product along with remote traffic.

  • Set up a split DNS environment to resolve internal requests within the internal network.

Partner web site

In the design samples, internal employees, remote employees, and partner employees access the partner web site. In the Corporate Portal design samples, all users enter the same URL regardless of the authentication method. In the Extranet design sample, each different type of user enters a different URL. Although both individual partners and partner companies use SSL (HTTPS) to access the partner web site externally, each group requires a different URL to apply the benefits of separate zones—that is, different authentication methods and different zone policies.

Because the Extranet design sample uses Direct Access or VPN for remote employee access, both remote employees and internal employees use the same URLs. If access for remote employees is configured through a reverse proxy device, remote employees would require a separate URL using SSL, requiring an additional zone. Finally, the Extranet design sample incorporates host-named site collections instead of a single top-level site collection. Consequently, each project site has a different URL.

The following table shows example URLs that internal employees, remote employees, and partners use to access the partner web site, as shown in the Extranet design sample.

Table: Example URLs from the Extranet design sample

Zone | Example URL
Internal and remote employees | http://project1
Individual partners | https://project2.fabrikam.com
Partner companies | https://TrustedPartnerProject1.fabrikam.com

Using explicit and wildcard inclusions for URL paths

Managed paths enable you to specify the paths in the URL namespace of a web application that are used for site collections. You can specify that one site collection or more than one site collection exists at a distinct path below the root site. Without managed paths, all sites below the root site collection are part of the root site collection.

You can create the following two types of managed paths:

  • Explicit inclusion: A site collection with the explicit URL that you assign. An explicit inclusion is applied to only one site collection. You can create many explicit inclusions below a root site collection. . An example URL for a site collection created by using this method is http://intranet/hr. There is a performance impact for every explicit path added so the recommendation is to limit the number of site collections created with an explicit inclusion to about 20.

  • Wildcard inclusion: A path that is added to the URL. This path indicates that all sites that are specified directly after the path name are unique site collections. This option is typically used for site collections that support self-site creation, such as My Sites. An example URL for a site collection that is created by using this method is http://my/personal/user1.

When managed paths for host-named site collections are implemented, these managed paths are created at the farm level and paths apply across all web applications, if multiple web applications are included in the solution. When managed paths for path-based sites are implemented, these managed paths apply only to the Web application in which they were created.

The design sample incorporates the use of both types of managed paths (explicit inclusions and wildcard inclusions, as described in the following sections.

Explicit inclusions: Published intranet content

In the design samples, the published intranet site collection incorporates explicit inclusions for each subsite, for example, HR, Facilities, and Purchasing. Each of these site collections can be associated with a different content database, if needed. Unless host-named site collections are used, the use of explicit inclusions in this example assumes that no other types of sites are created in the web application, including wildcard inclusions.

The use of explicit inclusions results in the URLs:

  • https://intranet.fabrikam.com

  • https://intranet.fabrikam.com/hr

  • https://intranet.fabrikam.com/facilities

  • https://intranet.fabrikam.com/purchasing

In this example, the root site collection, http://intranet.fabrikam.com, represents the default home page for the intranet. This site is intended to host content for users.

Wildcard inclusions: Team Sites, My Sites, and Partner Web

Team Sites, My Sites, and the partner web application incorporate the use of a wildcard inclusion. Wildcard inclusions are ideal for applications that allow users to create their own site collections and for web applications that include many site collections. A wildcard inclusion indicates that the next item after the wildcard is a root site of a site collection.

Team sites

Within the Team Sites application, wildcard inclusion is used for each team site collection. Good governance practices recommend that you keep the number of top-level team sites within a manageable number. Also, the taxonomy for team sites should be logical for the way your business operates.

The use of wildcard inclusions results in the URLs:

  • https://teams.fabrikam.com/sites/Team1

  • https://teams.fabrikam.com/sites/Team2

  • https://teams.fabrikam.com/sites/Team3

In this example, the root site collection, https://teams.fabrikam.com, does not necessarily host content for users.

My Sites

My Sites offer self-service site creation. When a user who browses the intranet first clicks My Site, a My Site is automatically created for the user. In the design sample, My Sites include a wildcard inclusion named /personal (http://my/personal). The My Site feature automatically appends the user name to the URL.

This results in URLs of the format:

  • https://my.fabrikam.com/personal/User1

  • https://my.fabrikam.com/personal/User2

  • https://my.fabrikam.com/personal/User3

Partner web

If path-based site collections are used, you can implement the self-service site creation feature to allow employees to create secure sites for collaboration with external partners. If host-named site collections are used, you can implement a custom self-service site creation feature or administrators can create partner project sites by request.

In Corporate Portal design samples, the partner web application includes a wildcard inclusion named /sites (http://partnerweb/sites). This results in URLs of the following format:

  • https://partnerweb.fabrikam.com/sites/Project1

  • https://partnerweb.fabrikam.com/sites/Project2

  • https://partnerweb.fabrikam.com/sites/Project3

Coordinating URLs with AAM and DNS

If path-based site collections are implemented, configure alternate access mappings (AAM) for each site URL in the farm. This makes sure that web requests are mapped to the correct site, especially in environments that use load balancing or reverse proxy technologies.

Single-name URLs, such as http://teams, can be configured for intranet access. A client computer resolves these URLs by appending the DNS suffix of the client computer, such as fabrikam.com, and then issuing a DNS lookup for the name with the suffix. For example, when a client computer in the fabrikam.com domain requests http://teams, the computer sends a request to DNS for http://teams.fabrikam.com.

DNS must be configured to use an A record, or AAAA for IPv6, for each fully qualified domain name (FQDN). The record points to the load-balanced IP address for the web servers that host a site. In a typical production deployment, servers are configured to use statically assigned IP addresses, in addition to statically assigned A or AAAA records in DNS.

After a client browser receives the load-balanced IP address, the client browser connects to a front-end web server in the farm, and then sends an HTTP request that has the original single-name URL, http://teams. IIS and SharePoint 2013 recognize this as a request for the Intranet zone, based on the settings that are configured in alternate access mappings. If a user instead requests https://teams.fabrikam.com, the process is similar, but IIS and SharePoint 2013 receive this FQDN instead, and therefore recognize this request for the Default zone.

In environments that have multiple domains, enter CNAME records for DNS in the domains that the sites do not reside in. For example, if the Fabrikam network environment includes a second domain named europe.fabrikam.com, CNAME records are entered for these sites in the Europe domain. For the Team Sites intranet site (http://teams), a CNAME record named teams is added to the europe.fabrikam.com domain that points to teams.fabrikam.com. Then, when a client computer's DNS suffix is appended to DNS lookup requests, a request for http://teams from the Europe domain will issue a DNS lookup of teams.europe.fabrikam.com, and will be directed by the CNAME record to teams.fabrikam.com.

Note:

There is a known issue with some clients that use Kerberos authentication and resolving CNAME records. For more information, see Kerberos configuration known issues (SharePoint Server 2010).

Zone policies

You can configure policies for one or more zones to enforce permissions for all content within a web application. In claims mode, a policy can be defined only for a specific zone (not for the web application in general). A policy enforces permissions on all content that users access through a zone. Policy permissions override all other security settings that are configured for sites and content. You can configure policy based on users or user groups, but not SharePoint groups. If you add or change a zone policy, search must crawl sites again to apply the new permissions.

The design samples do not use policies because either multiple types of authentication are enabled on a single zone or all sites are contained within on web application (or both).


Host-named site collection architecture and deployment (SharePoint 2013)
See also

Updated: July 2, 2013

Summary: Plan and implement host-named site collections in SharePoint 2013 and learn how path-based site collections might affect your environment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Host-named site collections are the preferred method to deploy sites in SharePoint 2013. Because the Office 365 environment uses host-named site collections, new features are optimized for these site collections and they are expected to be more reliable. Learn how to plan for and implement host-named site collections, design URLs, and manage URLs.

In this article:

  • Architecture and design for host-named site collections

    • Recommended architecture for host-named site collections

    • Host-named site collections versus path-based site collections

    • Design and manage URLs for host-named site collections

    • When to use path-based site collections

    • Use host headers and host-named site collections

    • Mix host-named site collections and path-based site collections in the same web application

  • Deployment and configuration for host-named site collections

    • Create a web application for host-named site collections

    • Create a root site collection

    • Create host-named site collections

    • Use managed paths with host-named site collections

    • Map URLs to host-named site collections

    • Configure SSL certificates for host-named site collections

    • Use host-named site collections with off-box SSL termination

    • Enable apps in environments with multiple zones

  • Migrate path-based site collections to host-named site collections

    • Determine host-named site collections in existing web applications

    • Convert path-based site collections to host-named site collections

  • Use multiple web applications with host-named site collections

    • Create multiple web applications with host-named site collections

    • Create multiple web applications for host-named site collections

    • Add virtual IP addresses in IIS

Architecture and design for host-named site collections

Host-named site collections enable you to assign a unique DNS name to site collections. For example, you can address them as http://TeamA.contoso.com and http://TeamB.contoso.com. This enables you to deploy many sites with unique DNS names in the same web application. It also enables hosters to scale an environment to many customers. If you do not use host-named site collections, your SharePoint web application will contain many path-based site collections that share the same host name (DNS name). For example, Team A has a site collection at http://contoso.com/sites/teamA, and Team B has a site collection at http://contoso.com/sites/teamB.

We recommend host-named site collections unless requirements dictate that path-based sites with alternate access mapping are necessary (described later in this article). This article describes how to implement host-named site collections in a recommended configuration with SharePoint 2013. Information about advanced configurations is included at the end of this article: Use multiple web applications with host-named site collections.

Recommended architecture for host-named site collections

The recommended configuration for deploying sites is using host-named site collections with all sites located within a single web application, as illustrated in the following diagram.

Recommended configuration for host-named site collections

Diagram that shows recommended configuration for host-named site collections

This recommended configuration in the diagram includes the following elements:

  • One application pool for site collections.

  • One web application for site collections that is hosted inside the one application pool.

  • A root site collection (http://SP1).

  • Multiple host-named site collections to host content with example sites:

    • Published intranet content (http://intranet.contoso.com) with subsites for HR, Facilities, and Purchasing.

    • Team sites (http://teams.contoso.com) with subsites for Team 1, Team 2, and Team 3.

    • My Sites with site URLs in the following format: http://my.consoso.com/personal/<site_name>.

The number of sites within the web application and the URLs for sites are not important for this example.

When creating a Web application for host-named site collections, the URL of the Web application and the root site collection will be http://< servername>/.

URLs of the Web app and root site collection.

This architecture is recommended to deploy sites because it is the same architecture that the Office 365 environment uses. Consequently this is the most heavily tested configuration. New features, including the App model and Request Management, are optimized for this configuration, and it is the most reliable configuration going forward.

The recommended configuration does not include the following elements:

  • Enabling apps in environments with multiple zones.

  • Mixing host-named site collections and path-based site collections (except the root site collection).

  • Multiple web applications with host-named site collections.

Host-named site collections versus path-based site collections

When you use host-named site collections, each site collection in a web application is assigned a unique DNS name. When you deploy many host-named site collections to a single web application, you increase scalability of the farm because resources are not used to support multiple application pools and web applications.

SharePoint 2013 supports both host-named and path-based site collections. The following table details the differences between the two options and provides more information about host-named site collections.

Table: Comparison of host-named site collections and path-based site collections

 | Host-named site collections | Path-based site collections
Creating sites | You can use Windows PowerShell to create host-named site collections. You cannot use Central Administration to create host-named site collections. | You can use Central Administration or Windows PowerShell to create path-based site collections.
URLs | Each host-named site collection in a web application is assigned a unique DNS name. You can use zones to assign up to five URLs to host-named sites, including vanity URLs. | All path-based site collections in a web application share the same host name (DNS name) as the web application. You can extend a web application to implement up to five zones and create different host names for each zone. However, the host name for a zone applies to all site collections within the web application.
Root site collection and search | A root site collection is required to crawl content in a web application. A root site collection can be a site collection that users cannot access. | Typically, a single path-based site collection serves as the root site collection within a web application. You can use managed paths to create additional site collections within the web application.
URL mapping | Use Windows PowerShell commands to manage URLs (Set-SPSiteURL, Remove-SPSiteURL, Get-SPSiteURL). | Use Alternate Access Mappings to manage URLs.
Self-service site creation | You need to use a custom solution for self-service site creation with host-named site collections. The Self Service Site Creation feature that is part of the default installation of SharePoint 2013 does not work with host-named site collections. | When you use the Self Service Site Creation feature that is part of the default installation of SharePoint 2013, you create path-based sites.
Managed paths | Managed paths for host-named site collections apply at the farm level and are available for all web applications. You have to use Windows PowerShell to create managed paths for host-named site collections. | Managed paths for path-based sites apply at the web application level. You can use Central Administration or Windows PowerShell to create managed paths for path-based site collections.

Design and manage URLs for host-named site collections

Windows PowerShell cmdlets manage URL mappings for host-named site collections and enable you to map URLs to a single site collection:

  • Set-SPSiteUrl — Add or change a URL mapping for a site.

  • Remove-SPSiteUrl — Remove a URL mapping from a site.

  • Get-SPSiteUrl — See all URLs and associated zones for a site collection.

These cmdlets provide URL mapping functionality for host-named site collections that is similar to alternate access mapping.

Zones and host-named site collections

Host-named site collections are available through any zone. Host-named site collections are not limited to the default zone. If needed, you can implement multiple zones and use zones and host-named site collections to configure different authentication settings or policies.

You can assign up to five URLs to a single site collection by assigning one URL per zone. Even if you follow the recommended architecture by implementing only one zone, you can still assign up to five URLs to host-named site collections. This is because if a zone is not implemented by extending the web application, SharePoint 2013 uses the default zone.

For example, the following URLs could provide access to the same Internet site:

  • www.Contoso.com

  • www.Contoso.uk

  • www.Contoso.ca

  • www.Contoso.au

  • www.Contoso.ie

The search crawl account requires access to content through the Default zone by using Integrated Windows authentication (NTLM or Kerberos). Because claims authentication allows multiple types of authentication in one zone, this requirement should not affect other authentication requirements.

Managed paths and host-named site collections

URLs that are configured for the same site collection may have different schemes and domains, but they must have the same managed paths, namely everything after the '/' that follows the domain must be the same. For example, http://www.Contoso.com/sites/Site1 and http://www.Fabrikam.com/sites/Site1 can both point to the same site collection but http://www.Contoso.com/sites/Site1 and http://www.bar.com/sites/Project1 cannot.

The cmdlets that manage URLs only operate on the root site collection for a host name, for example http://www.Contoso.com. These cmdlets do not operate on a managed path site collection that is underneath the root, such as http://www.Contoso.com/sites/Project1. Sites below the root of a host-named site collection will inherit the URL settings of that root host-named site collection.

Off-box termination of SSL with host-named site collections

Off-box termination of SSL occurs when a proxy server terminates an SSL request and uses HTTP to forward the request to a web server. To achieve off-box SSL termination with host-named site collections, the device that terminates the SSL connection, such as a reverse proxy server, must be capable of generating a custom HTTP header: Front-End-Https: On. For more information, see Use host-named site collections with off-box SSL termination, later in this article.

The protocol used for a host-named site collection depends on the value of the Url parameter that you specified when you used the Set-SPSiteURL cmdlet to map the URL to a particular zone: http or https. Ensure that the IIS bindings for the web application, SSL certificates, reverse proxy configuration, and any other configuration necessary is complete.

When to use path-based site collections

Although we recommend host-named site collections for most architectures, you should use the traditional path-based site collections and alternate access mapping if any of the following conditions apply:

  • You need to use the Self Service Site Creation feature that is part of the default installation of SharePoint 2013.

    This does not apply to custom self-service site creation solutions.

  • SSL termination is required but your SSL termination device cannot be configured to produce the necessary custom HTTP header.

    You can still use SSL bridging with host-named site collections with these devices if SSL termination is not a requirement.

  • You plan to use different application pools for the additional security that these provide or you need to use multiple proxy groups.

    In these cases, you can use host-named site collections. However, the additional configuration that is required to map URLs for host-named site collections across multiple web applications greatly outweigh the benefits of using host-named site collections. For more information, see Use multiple web applications with host-named site collections. For more information about creating path-based site collections, see Create a site collection in SharePoint 2013.

Use host headers and host-named site collections

Host headers allows the web server to host multiple web sites on the same IP Address and Port combination. If the incoming HTTP request includes a host header name, and a matching host header is configured in IIS, IIS will respond with the content from the appropriate web site.

Host headers are configured at the Web Application (IIS website) level, they are one of the website bindings properties.

It is important to understand the distinction between Host headers in IIS and Host Named Site Collections. Host headers at the IIS website level are only intended for path-based site collections.

When using Host named site collections, SharePoint is responsible for resolving the correct site for the address based upon the incoming request passed through IIS. In most cases, applying a host header binding at the IIS website level makes it impossible to access host-named site collections through the IIS website. This is because IIS will not respond to requests for host names that differ from the host header binding.

Important:

If an existing web application has a host header binding set, IIS will not return pages from the host-named site collection until you remove the binding from IIS. For more information, see Update a Web application URL and IIS bindings (Office SharePoint Server 2007).

Mix host-named site collections and path-based site collections in the same web application

You can use host-named and path based site collections in the same web application. To ensure that both types of site collections are accessible to users, do not put host header bindings on the IIS website of your web application, including IIS websites for zones that are extended from the web application. If an existing web application has a host header binding set, IIS will not return pages from the host-named site collection until you remove the binding from IIS.

My Sites

When you use both types of site collections with My Sites, consider implementing your own provisioning process to create My Sites as host-named sites instead of path based sites.

Deployment and configuration for host-named site collections

Create a web application for host-named site collections

If you do not intend to configure two or more IIS websites that share the same port number on the same server, create a web application in the Default zone. Do not apply a host header binding at the IIS website level.

To create a web application for host-named site collections

  1. Verify that you have the following memberships:

    • The securityadmin fixed server role on the SQL Server instance.

    • The db_owner fixed database role on all databases that are to be updated.

    • The Administrators group on the server on which you are running the Windows PowerShell cmdlet.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt (that is, PS C:\>), type the following syntax:

    Copy code
    New-SPWebApplication -Name 'Contoso Sites' -port 80 -ApplicationPool ContosoAppPool -ApplicationPoolAccount (Get-SPManagedAccount 'Contoso\JDoe') -AuthenticationProvider (New-SPAuthenticationProvider -UseWindowsIntegratedAuthentication)

Create a root site collection

A root site collection is a requirement for any Web application. It is also necessary for crawling content. This site collection must have the same URL as the Web application. Currently, SharePoint prevents the creation of a host-named site collection with the same URL as a Web application. Therefore, the root site collection is created as a path-based site collection.

A web application with a root site.

The following example creates an empty site collection that is the root site collection:

Copy code
New-SPSite 'http://<servername>' -Name 'Portal' -Description 'Portal on root' -OwnerAlias 'contoso\administrator' -language 1033 -Template 'STS#0'

Only the root site collection of the web application appears in the content source. Even though all other host-named site collections in the web application do not appear in the content source, by default search automatically crawls the other host-named site collections.

Create host-named site collections

You must use Windows PowerShell to create a host-named site collection. You cannot use the SharePoint 2013 Central Administration web application to create a host-named site collection, but you can use Central Administration to manage the site collection after you have created it.

You can create a host-named site collection by using the Windows PowerShell New-SPSite cmdlet with the -HostHeaderWebApplication parameter, as shown in the following example:

To create host-named site collections

  1. Verify that you have the following memberships:

    • The securityadmin fixed server role on the SQL Server instance.

    • The db_owner fixed database role on all databases that are to be updated.

    • The Administrators group on the server on which you are running the Windows PowerShell cmdlet.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. On the Start menu, click All Programs.

  4. Click Microsoft SharePoint 2013 Products.

  5. Click SharePoint 2013 Management Shell.

  6. At the Windows PowerShell command prompt (that is, PS C:\>), type the following syntax:

    Copy code
    New-SPSite 'http://portal.contoso.com' -HostHeaderWebApplication 'http://<servername>' -Name 'Portal' -Description 'Customer root' -OwnerAlias 'contoso\administrator' -language 1033 -Template 'STS#0'

This creates a host-named site collection that has the URL, http://portal.contoso.com, in the SharePoint 2013 web application that has the URL ,http://webapp.contoso.com.

Use managed paths with host-named site collections

You can implement managed paths with host-named site collections. Hosters can provide multiple site collections to the same customer with each site collection sharing the customer's unique host name but differentiated by the URL path after the host name. Managed paths for host-named site collections are limited to 20 per farm. For more information, see Web application limits.

Managed paths for host-named site collections behave differently from managed paths for path-based site collections. Managed paths for host-named site collections are available to all host-named site collections within the farm regardless of the web application that the host-named site collection is in. In contrast, managed paths for path-based site collections only apply to sites within the same web application. Managed paths for path-based site collections do not apply to path-based site collections in other web applications. Managed paths for one type of site collection do not apply to the other type of site collection.

To create a managed path, you must first create a site collection with the desired base URL. For example, to create http://teams.contoso.com/finance you must first create the site collection for http://teams.contoso.com.

To create a managed path for use with host-named site collections, use the Windows PowerShell New-SPManagedPath cmdlet with the -HostHeader parameter, as shown in the following example:

Copy code
New-SPManagedPath 'departments' -HostHeader

You can also use the -explicit parameter to create explicit managed paths.

The following example shows a host-named site collection created at a managed path:

Copy code
New-SPSite 'http://portal.contoso.com/departments/marketing' -HostHeaderWebApplication 'http://<servername>' -Name 'Marketing' -Description 'Portal Marketing' -OwnerAlias 'contoso\administrator' -language 1033 -Template 'STS#0'

To remove an existing managed path, use the Windows PowerShell Remove -SPManagedPath cmdlet, as shown in the following example:

Copy code
Remove-SPManagedPath 'departments' -HostHeader

You can use Windows PowerShell to remove a managed path even if a site collection exists. If you remove a managed path, the site collection can no longer be accessed. To access the existing site collection, use Windows PowerShell to recreate the managed path.

Map URLs to host-named site collections

When you create a new hostname site collection, the default alternate access mappings will still exist but cannot be used. Use Windows PowerShell commands to manage URL mappings for host-named site collections.

Add a mapping to an existing site:

Copy code
Set-SPSiteUrl (Get-SPSite 'http://teams.contoso.com') -Url 'http://teamsites.contoso.com' -Zone Intranet

Each URL mapping is applied to a single zone. Use one of the following zone names when you map URLs:

  • Default

  • Intranet

  • Internet

  • Custom

  • Extranet

If you do not specify the -Zone parameter and the URL mapping entry is new, the default zone is used.

Remove a mapping for a site:

Copy code
Remove-SPSiteUrl 'http://teamsites.contoso.com'

Display all URL mappings for a site:

Copy code
Get-SPSiteUrl -Identity (Get-SPSite 'http://teams.contoso.com')

Configure SSL certificates for host-named site collections

You can configure a single web application that uses SSL and then create multiple host-named site collections within that web application. To browse to a site over SSL, you have to install and assign a server certificate to the IIS website. Each host-named site collection in a web application will share the single server certificate that you assigned to the IIS website.

You need to acquire a wildcard certificate or subject alternate name (SAN) certificate and then use a host-named site collection URL format that matches that certificate. For example, if you acquire a *.contoso.com wildcard certificate, you must generate host-named site collection URLs such as https://site1.contoso.com, https://site2.contoso.com, and so on, to enable these sites to pass browser SSL validation. However, if you require unique second-level domain names for sites, you must create multiple web applications rather than multiple host-named site collections.

To configure SSL for host-named site collections, enable SSL when you create the web application. This will create an IIS website with an SSL binding instead of an HTTP binding. After you create the web application, open IIS Manager and assign a certificate to that SSL binding. You can then create site collections in that web application.

If you are implementing multiple zones with host-named site collections, ensure that the configuration of certificates and bindings (SSL or HTTP) is appropriate for each zone and corresponding IIS site.

Use host-named site collections with off-box SSL termination

You can use host-named site collections with off-box SSL termination. There are several requirements to use SSL termination with host-named site collections:

  • At least one IIS site should have a binding on port 80 (or whatever port the terminator forwards the request to). Microsoft recommends that you use the IIS site of a web application (or the IIS site of a zone for a web application) with HTTP/80.

  • The SSL terminator or reverse proxy must preserve the original HTTP host header from the client.

  • If the client SSL request is sent to the default SSL port (443), then the SSL terminator or reverse proxy must forward the decrypted HTTP request to the front-end web server on the default HTTP port (80). If the client SSL request is sent to a non-default SSL port, then the SSL terminator or reverse proxy must forward the decrypted HTTP request to the front-end web server on the same non-default port.

  • The device that terminates the SSL connection, such as a reverse proxy server, must be capable of generating a custom HTTP header: Front-End-Https: On. This is the same custom header that Outlook Web Access (OWA) uses: Front-End-Https: On/Off. More information about this custom header is included later in this section.

To use host-named site collections with off-box SSL termination, configure your web application as you normally would for SSL termination and ensure that it meets the requirements described above. In this scenario, SharePoint 2013 will use HTTPS instead HTTP to render links of its host-named site collections in that web application.

Reverse proxy servers can publish SharePoint 2013 host-named site collections and perform off-box SSL termination. In this scenario, the reverse proxy server changes the connection type between the end user and the SharePoint web front-end server from SSL/TLS to HTTP or vice versa. Reverse proxy servers in this scenario must insert an additional HTTP header in the user's request when it forwards the request to the SharePoint web front-end server. This additional HTTP header indicates to SharePoint 2013the type of connection the end user initiated so that SharePoint 2013 renders URLs appropriately in its response. The HTTP header name is "Front-End-Https" and its acceptable values are as follows.

Table: Front-End-Https header values

Value | Description
On | The reverse proxy server received the end user's request over an encrypted (SSL or TLS) HTTPS connection. For example, Front-End-Https: On.
Off | The reverse proxy server received the end user's request over an unencrypted HTTP connection.

The values are not case-sensitive. For example, on, ON, On, and oN are acceptable.

This custom header works only with host-named site collections. It does not work with path-based site collections.

Enable apps in environments with multiple zones

The March 2013 Public Update enables you to configure an app domain for each web application zone and use alternate access mapping and host-header web application configuration. Before the release of this update, you could only host one app domain and it had to be in the Default zone. You could not use the app domain on alternate access mappings or host-header web application configurations.

To resolve this issue, apply the SharePoint 2013 Cumulative Update Server Hotfix Package: March 12, 2013, see Updates for SharePoint 2013.

Migrate path-based site collections to host-named site collections

Determine host-named site collections in existing web applications

When you migrate from SharePoint 2010 to SharePoint 2013, we recommend that you determine how SharePoint 2010 sites were created. If sites were created as path-based sites, consider migrating these sites to host-named site collections. If host-named and path-based sites were implemented together, identify the sites that were created as path-based sites and consider migrating these sites to host-named site collections. To accomplish this, look for the 'HostHeaderIsSiteName' flag.

The following example determines if a site within a given web application is created as host-named or path based:

Copy code
$webApp = Get-SPWebapplication 'http://portal.contoso.com'

foreach($spSite in $webApp.Sites)
{
if ($spSite.HostHeaderIsSiteName)
{ Write-Host $spSite.Url 'is host-named' }
else
{ Write-Host $spSite.Url 'is path based' }
}

Convert path-based site collections to host-named site collections

You can convert path-based site collections to host-named site collections and host-named site collections to path-based site collections. You have to use the Windows PowerShell backup and restore cmdlets to convert site collections. You cannot use the the SharePoint Central Administration website or Windows PowerShell cmdlets that attach and detach, or mount and dismount content databases to convert site collections.

The following example converts a standard site collection to a host-named site collection:

Copy code
Backup-SPSite -Identity 'http://portalOld.contoso.com' -Path 'c:\Backup\portalContoso.bak' -Force -UseSQLSnapShot
Restore-SPSite -Identity 'http://portal.contoso.com' -Path 'c:\Backup\portalContoso.bak' -DatabaseName 'portal_content' -Force -HostHeaderWebApplication 'http://<servername>' -Confirm:$false

Use multiple web applications with host-named site collections

If you use more than one web application, you add more operational overhead and complexity to the system. We recommend that you use one web application for site collections. However, the following reasons might influence you to implement site collections across multiple web applications:

  • An organization's security policies require separate web applications or application pools.

  • Web applications need to be configured differently.

  • An organization requires the use of multiple proxy groups.

It is more complex to implement host-named site collections with multiple web applications in a farm because you must complete more configuration steps. For example, URLs with host-named sites might be spread across multiple web applications that share the same port in a single farm. This scenario requires more configuration steps to ensure that requests are mapped to the correct web applications. You have to manually configure the mappings on each web server in the farm by configuring a separate IP address to represent each web application. You also have to create and manage host-header bindings to assign unique IP addresses for each site. Scripts can manage and replicate this configuration across servers; however, this adds complexity to the solution. Each unique URL also requires a mapping in DNS. Generally speaking, if multiple web applications are a requirement, we recommend path-based site collections with alternate access mapping.

The following two tables contrast three different design choices to implement site collections. These tables are intended to help you understand the consequences of each approach and how configuration varies depending on the architecture.

Table: Results of different design choices to provision site collections

 | Host-named site collections with all sites in a farm consolidated in one web application | Path-based site collections with alternate access mapping and multiple web applications | Host-named site collections with multiple web applications in a farm
Site collection provisioning | Use Windows PowerShell or a custom site collection provisioning solution to provision sites. | Use Central Administration or Windows PowerShell to deploy sites. | Use Windows PowerShell or a custom site collection provisioning solution to provision sites.
URL management | You can map all site collections in DNS to point to a single IP address which represents the web application. | If you implemented more than one zone, you configure alternate access mapping for each site URL. Each zone also requires a mapping in DNS. | Additional configuration is required to ensure that requests for sites that share the same port are mapped to the correct web application. Each unique host name also requires a mapping in DNS. This configuration is manual and you must complete it on each web server in a farm for each site.
Additional URLs | You can assign up to five URLs to a host-named site collection, one per zone. It is not necessary to extend the web application to multiple zones. If a zone is not implemented the default zone is used. | The number of URLs for a site collection is limited to five because this is the number of zones that is allowed. | You can assign up to five URLs to a host-named site collection, one per zone. It is not necessary to extend the web application to multiple zones. If a zone is not implemented the default zone is used.
Service applications | All sites in the farm use a single service application group. | You can implement custom service application groups for different web applications. | You can implement custom service application groups for different web applications.
Zones | You do not have to implement multiple zones to implement different URLs for the same site collection. If a zone is not implemented the default zone is used. | Zones are necessary to implement different URLs for the same site collection. | You do not have to implement multiple zones to implement different URLs for the same site collection. If a zone is not implemented the default zone is used.
Authentication | With one web application, authentication options are limited to five zones. However, you can implement many authentication methods on one zone. | You can implement different authentication and zone designs for each web application. | You can implement different authentication and zone designs for each web application.
Authentication | Provides client scripting isolation between domain URLs. | You can isolate web applications into dedicated application pools, if desired, to achieve process isolation. Provides isolation between domain URLs. | You can isolate web applications into dedicated application pools, if desired, to achieve process isolation. Provides isolation between domain URLs.
Policy | You can use zones to assign different policies to host-named sites. | You can use policies at the web application level to enforce permissions, regardless of permissions that are configured on individual sites or documents. Additionally, you can implement different policies for different zones. | You can implement different policies for different web applications to enforce permissions, regardless of permissions that are configured on individual sites or documents. Additionally, you can implement different policies for different zones.

Scalability numbers that might also affect design decisions include the recommended maximums for site collections, content databases, and managed paths.

The following table summarizes the configuration that is necessary to manage URLs based on each of the three design options presented in this article.

Table: Configuration required for different site collection designs

Host-named site collections with all sites in a farm consolidated into one web application Path-based site collections with alternate access mapping and multiple web applications Host-named site collections with multiple web applications in a farm

Within SharePoint Server

  • Create the web application.

  • Create a root-site collection that is not accessible to users (for example, https://HNSC01.fabrikam.com).

  • Create the host-named site collections with the host header (for example, https://intranet.fabrikam.com).

  • Optionally add more URLs for each site collection and configure zones by using Set-SPSiteUrl. (In corporate portal design samples there's no need because there's only one zone.)

  • Create the web application with the host header (for example, https://intranet.fabrikam.com).

  • Optionally configure alternate access mapping. In the design sample there's no need because there's only one zone).

  • Create the root path-based site collection.

  • Create the web application.

  • Create a root-site collection that is not accessible to users (for example, https://HNSC01.fabrikam.com).

  • Create the host-named site collections with the host header (for example, https://intranet.fabrikam.com).

  • Optionally add more URLs for each site collection and configure zones by using Set-SPSiteUrl. (In corporate portal design samples there's no need because there's only one zone.)

Within IIS

Associate an SSL certificate (wildcard certificate or SAN certificate) for all host-named site (domain) in the web application.

Associate an SSL certificate in IIS for each zone (each zone is a separate web application in IIS).

Associate an SSL certificate (wildcard certificate or SAN certificate) for a host-named site (domain) in the web applications.

On each web server in the farm and for each web application that shares a port:

  • Configure a separate IP address to represent each web application.

  • Edit the IIS web site binding manually to remove the host header binding that was created when the web application was created and replace this with an IP address binding.

If you use multiple web applications on different IP addresses, you might need to complete additional configuration for the NIC, DNS, and the load balancer for each server.

Create multiple web applications with host-named site collections

To run multiple web applications on the same server and port in combination with host-named site collections, you have to assign different IP addresses to the web applications. This type of architecture requires that you add IP addresses to the web servers and configure the network router to point host names to the IP address of its web application.

Note:

You can create a web application that does not have a host header. If you create a web application that does not have a host header, you cannot create multiple web applications with host-named site collections on the same web server.

The process that creates multiple web applications for a host-named site collections includes the following tasks:

  • Create the multiple web applications.

  • Add a new virtual IP address in IIS on each web server in the farm.

Create multiple web applications for host-named site collections

The following example creates a web application:

Copy code
New-SPWebApplication -Name 'webapp' -hostHeader 'webapp.contoso.com' -port 80 -ApplicationPool ContosoAppPool -ApplicationPoolAccount (Get-SPManagedAccount 'Contoso\JDoe') -AuthenticationProvider (New-SPAuthenticationProvider -UseWindowsIntegratedAuthentication)

Repeat this task for each web application.

Add virtual IP addresses in IIS

The IP bindings must be applied on all servers that will host the web application. Set the sleep command to 60 seconds to make sure that the IP bindings are set to all servers in the farm before the existing host header on the web application is removed. Remote scripting can be used for this job.

Use the following commands to add unique IP bindings to each of the web applications that you created and then remove the host header binding from these web applications.

Copy code
Import-Module WebAdministration
# add empty binding to webapp on IP 192.168.10.20
New-WebBinding -Name 'webapp' -IPAddress '192.168.10.20' -HostHeader ''
Sleep 60
# remove existing binding webapp.contoso.com from existing web application
Get-WebBinding -Name 'webapp' -HostHeader 'webapp.contoso.com' | Remove-WebBinding

See also

Get-SPSiteUrl
Set-SPSiteUrl
Remove-SPSiteUrl

Plan logical architectures for SharePoint 2013

Change History

Date | Description
July 02, 2013 | Updated with requirements for the root site collection.
May 14, 2013 | Initial publication


Global deployment of multiple farms (SharePoint 2013)

Published: February 5, 2013

Summary: Discover links to articles that explain issues about global deployments of SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about <subject>.

Downloadable resources about global deployments of SharePoint 2013

Download the following content for information about global deployments of SharePoint 2013.

 | Content | Description
Tutorial - student and teacher | SharePoint 2013 WAN testing with Visual Studio 2012 walkthrough | This PowerPoint presentation is a walkthrough that shows how to build a web test and load test for WAN testing that uses Visual Studio 2013.

TechNet articles about global deployments of SharePoint 2013

The following articles about global deployments of SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Global architectures for SharePoint Server 2013 | Learn about supported architectures for SharePoint 2013 in WAN environments, strategies for optimizing performance over WAN connections, and recommendations for service applications.
 | Testing WAN connections for SharePoint 2013 architectures | Learn about WAN performance improvements, test results, and WAN test tools and scenarios.
 | SharePoint Server 2013 WAN case studies: United Airlines, Teck, and Fabrikam | Learn how three global companies designed their SharePoint architectures to meet their requirements.

Additional resources about global deployments of SharePoint 2013

The following resources about <subject> are available from other subject matter experts.

 | Content | Description
TechNet logo | Resource Center: Architecture design for SharePoint 2013 IT pros | Visit the TechCenter to access videos, community sites, documentation, and more.


Global architectures for SharePoint Server 2013

Updated: April 2, 2013

Summary: Learn about supported architectures for SharePoint 2013 in WAN environments, strategies for optimizing performance over WAN connections, and recommendations for service applications.

Applies to: SharePoint Server 2013

SharePoint Server 2013 is optimized to perform well over wide-area network (WAN) connections. For most customers, a centralized environment is the recommended architecture for serving a world-wide user base. Customers who have sites that are not well connected might benefit from deploying one or more regional farms. This article describes supported architectures, strategies to optimize SharePoint Server 2013 for WAN connections, and recommendations for service applications.

In this article:

  • Key concepts

  • Evaluate your WAN connections

  • Optimize a central farm or central datacenter deployment

  • Client tools for WAN environments

  • Design a central site with multiple farms

  • Share service applications across farms connected by WAN links

Key concepts

This article uses the following terms:

  • Central site—The location that hosts most of the company data and employee computers. A centralized SharePoint Server 2013 environment can consist of a single farm or multiple farms located in the same datacenter.

  • Regional site—A location that hosts a subset of corporate data and employee computers that are connected by using a combination of local-area network (LAN) and WAN links.

  • Distributed environment—An environment in which employees and company data are dispersed across the globe.

  • In-country farm — A farm that is deployed inside a political boundary to satisfy government regulations.

Evaluate your WAN connections

The most important factor that drives architectures for WAN environments is the performance of SharePoint Server 2013 across the WAN connections. Before you consider architecture options for your WAN environment, first evaluate the performance that users will experience for the most common actions they will perform. This can be done by using systematic benchmark testing across multiple WAN connections, or with simple user testing against a test environment. You can also create an evaluation site in Office 365 and test the user experience from multiple locations.

WAN performance for SharePoint Server 2013 is improved compared to SharePoint 2010 Products. If your organization currently deploys more than one farm geographically by using an earlier version of the product, you might be able to succeed with either a single, central-farm environment or with fewer farms. Do not assume that your organization will require the same number of farms as you deployed with an earlier version.

For more information about how to evaluate your WAN connections, see Testing WAN connections for SharePoint 2013 architectures.

Optimize a central farm or central datacenter deployment

The first and best option to serve a world-wide user base is to deploy SharePoint Server 2013 to a central environment.

Central environment model

Due to the performance improvements in SharePoint Server 2013 global customers who are well connected with WAN connections can expect to succeed with a centralized deployment of SharePoint Server 2013. For enterprise-scale customers, this might include more than one farm that is deployed to a single datacenter. Most customers can deploy a single farm to meet the needs of an organization (for example, United Airlines). Organizations can also use Office 365 as a central environment to serve a world-wide user base.

For examples of global organizations that succeed with a centralized environment, see SharePoint Server 2013 WAN case studies: United Airlines, Teck, and Fabrikam.

If you deploy SharePoint Server 2013 on premises, several strategies can help optimize a centralized environment across WAN connections.

Optimize web pages for faster downloads

The default pages in SharePoint Server 2013 are optimized for performance. If you customize pages or add many images or other types of content, make sure that you optimize these pages so they perform well over WAN connections. For more information, see Optimizing Web pages for WAN connections.

Windows Server features

Several features in Windows Server can improve performance for users who connect to a central environment through a regional site or branch office.

  • BranchCache-- BranchCache, a feature of the Windows 7, Windows Server 2008 R2, and Windows Server 2012 operating systems, caches content from file and web servers on a WAN on computers at a local branch office. In a geographically distributed SharePoint Server 2013 environment, BranchCache can optimize WAN performance by caching large files that users download from SharePoint Server 2013. For more information, see Optimize performance for SharePoint Server 2013.

  • Quality of Service (QoS)— Windows 2000 introduced QoS features that Windows Server 2012 has enhanced. QoS enables you to meet the service requirements of a workload or an application by measuring network bandwidth, detecting changing network conditions (such as congestion or availability of bandwidth), and prioritizing - or throttling - network traffic. For example, you can use QoS to prioritize traffic for latency-sensitive applications and to control the effect of latency-insensitive traffic (such as bulk data transfers). You can use QoS to prioritize requests for applications that are critical for users. In addition, you can deprioritize applications or processes that adversely affect performance, such as backup processes or large downloads. For more information about QoS features in Windows Server 2012, see Quality of Service (QoS) Overview.

WAN accelerators

WAN accelerators benefit intranet deployments. Some global companies position WAN accelerators across the highest latency connections to improve performance at these sites to an acceptable range. These solutions typically optimize traffic at several levels.

  • WAN acceleration solutions compress network-level packets and optimize the underlying protocol to reduce the raw traffic.

  • WAN accelerators optimize content by comparing content blocks against a history of recently sent blocks, which enables only differences to be sent instead of all the content.

  • Application-aware devices optimize the application-level protocol which reduces the application chatter.

Different solutions use different combinations of optimization techniques and algorithms.

WAN accelerators work in pairs. One device is in the data center next to the servers that are running SharePoint Server 2013, and another device is in the branch office or on a client device outside an office. Vendors claim 90% or more reduction in response time for second and successive requests over high-latency networks.

Many WAN accelerator devices are available. Each device optimizes WAN traffic in different ways. Because SharePoint Server 2013 also optimizes and compresses data, it is important to test the performance of SharePoint Server 2013 both with and without WAN acceleration devices. In some cases, the compression of multiple technologies (SharePoint Server 2013, IIS, and a WAN accelerator) might adversely affect performance compared to the benefit achieved.

Optimize the network

Many customers can make a centralized environment work by working with bandwidth providers to optimize the network connections between users and a central site. Also, some telecommunications companies provide more efficient routing patterns, especially in emerging markets. Compared to the complexity of managing SharePoint farms and content at multiple locations, it might be more practical to optimize the WAN connections instead.

Client tools for WAN environments

Several client tools can greatly improve the user experience over WAN connections without deploying multiple farms across the globe. You can also use these tools in environments that have multiple farms that are deployed geographically.

Office Web Apps Server

Office Web Apps Server is an Office server product that delivers browser-based versions of Word, PowerPoint, Excel, and OneNote. Office Web Apps Server greatly improves performance in WAN environments because users don't upload or download files. A single Office Web Apps Server farm can support users who access Office files through SharePoint 2013, Lync Server 2013, and Exchange Server 2013. Office Web Apps Server works well in environments that have high-latency connections, or low bandwidth connections, or both. It might not work well in environments that have intermittent connections.

A Office Web Apps Server farm is typically located in the same datacenter as the SharePoint 2013 farm, although this is not a requirement. Locating a Office Web Apps Server farm in a remote datacenter where SharePoint sites are not located will not improve performance. For more information, see Office Web Apps Server overview.

Sky Drive Pro

SkyDrive Pro lets users sync their My Site library or other SharePoint libraries on team sites to their computers. They can then work with files in these libraries directly in Windows Explorer. Users can access these files even when they are offline. Updates to files sync with SharePoint when a user is online.

SkyDrive Pro works well in environments that have intermittent connections or in environments that have high latency or low bandwidth connections. It is not intended to be used by many users who are editing the same file offline at the same time. For more information see Sync your SkyDrive or other SharePoint libraries to your computer with SkyDrive Pro.

SharePoint Workspace 2010

You can use SharePoint Workspace 2010 with SharePoint Server 2013. However, you might have to apply a hotfix for all features to work as expected. SharePoint Workspace 2010 enables users to sync documents, lists, libraries, sites, and site hierarchies. For more information, see the following resources:

  • Description of the SharePoint Workspace 2010 Update: August 2, 2012

  • SharePoint Workspace 2010 overview

Design a central site with multiple farms

Some enterprises might choose to deploy more than one farm at a central site to meet scale and capacity requirements. However, if the architecture includes more than one content farm, social features may be limited. To optimize a multi-farm environment the following design principles apply:

  • The User Profile Service application must reside in the same datacenter as the content that it supports.

  • One My Site farm is recommended. Social features are limited across multiple My Site farms. For example, users will see social activities in their My Site newsfeed from that farm alone. Multiple My Site farms also require multiple User Profile service applications which increase complexity.

  • For social features to work across content farms, you must create a My Site Host on each content farm in the datacenter. In this design, the My Site Host on the designated My Site farm, where the User Profile Service application exists, is the primary My Site Host. The other My Site Hosts support site feeds on team sites that are located in the content farms.

  • SharePoint Server 2013 supports stretched farm architectures in which servers are located in different datacenters. For a stretched farm to work, there must be less than 1 millisecond latency between the computer that is running SQL Server and the front-end web servers in one direction, and at least 1 gigabit per second bandwidth.

  • Search farms can reside in a different datacenter. The Search service application works well over WAN connections. If you have to spread farms across datacenters, a dedicated search farm does not have to be located in the same datacenter as other types of SharePoint farms.

The following illustration represents a multi-farm architecture designed for a global manufacturing company that is fictionally named Fabrikam and has more than 300,000 users.

Multi-farm architecture for a global manufacturing company

For more information about this diagram and company, see SharePoint Server 2013 WAN case studies: United Airlines, Teck, and Fabrikam.

Share service applications across farms connected by WAN links

You can share some service applications across farms. Most of these can be shared across farms separated by WAN links. The following table summarizes the support for sharing service applications across WAN links. The Search service application requires greater consideration and recommendation for this service are provided after the table.

Cross-farm services support for WAN environments

Service application | Supported over WAN connections? | Notes
Search | Yes | Content can be crawled over WAN connections. Or, you can configure search to retrieve results from remote result sources (indexes at remote farms).
Managed Metadata | Yes | User entry fields that the Managed Metadata service application provides might not be available if a WAN connection is not online (such as an intermittent satellite link).
Business Data Connectivity | Yes | After the data model is cached on the web server of the remote farm (the farm that consumes the Business Data Connectivity service from a central farm), the remote farm connects directly to the data source over the WAN to query the data (instead of reconnecting to the farm that is hosting the Business Data Connectivity service). Therefore, the remote farm requires permission to access the data source. Also, performance between the remote farm and the data source depends on the performance of the WAN connection.
User Profile | Not supported | Using the User Profile service application across WAN links is not supported. This service requires direct database access.
Secure Store Service | Yes | Although the Secure Store Service works across WAN links, we do not recommend this use because it might adversely affect the performance of other services over a WAN link.
Machine Translation Service | Yes |

For information about how these services are configured for Teck, see SharePoint Server 2013 WAN case studies: United Airlines, Teck, and Fabrikam.

Search

You can share the Search service application across WAN connections. However, if a WAN connection is robust enough to support crawling content over the WAN, the connection is likely robust enough to support user actions over the WAN to a central farm. Instead of sharing the Search service application over WAN connections, we recommend that you take advantage of WAN performance improvements by eliminating the regional farm and having users use a central farm environment instead.

The following WAN conditions may be reasons for creating regional farms:

  • Highest latency connections

  • Intermittent connections

  • Unreliable connections caused by network congestion

  • Inefficient routing patterns

  • Packet loss

We do not recommend sharing the Search service application across these types of WAN connections. Instead, we recommend that you configure Search on the regional farm and use Remote SharePoint result sources to bring together search results from the regional farm(s) and the central farm.

In-country farms represent a different challenge. If the purpose of an in-country farm is to prevent documents and files from residing in locations outside a political boundary, we do not recommend crawling content over the WAN. A search index contains at least fragments of the crawled content. Furthermore, a temporary copy of each document is downloaded to the search farm for processing. Therefore, a central farm that crawls an in-country farm includes a copy of the data in that in-country farm. If this is against company policy, we recommend that you use Remote SharePoint result sources instead. With this configuration, search results can include content from an in-country farm and content continues to reside only on the local farm, unless a user downloads a copy to their local computer.

The one scenario in which crawling content over WAN connections is allowed is with a hybrid deployment in which an on-premises SharePoint Server 2013 farm is used to crawl content in an Office 365 Dedicated farm (O365-D) and provide search services to that farm. With the Office 365 Dedicated subscription plan each customer environment is placed on a dedicated server farm. Crawling the Office 365 dedicated farm provides a single relevancy-ranked set of results for the two environments. The dedicated Office 365 environment differs from the multi-tenant Office 365 environment. For hybrid environments that include the Office 365 multi-tenant environment, crawling the multi-tenant environment is not possible and the recommendation is to provide centralized search by using remote result sources.

Despite the recommendations, sharing the Search service application over WAN connections is supported and can be implemented in the following ways:

  • A regional farm can consume the Search service application from a central farm and use it to crawl content locally. You have to set up a cross-farm service sharing relationship and complete additional configuration. In this case, the search components on the central farm crawl content on the regional farm. Communication that is necessary to crawl content occurs over the WAN connection. This configuration is not recommended. Instead, deploy and configure the Search service application directly on the regional farm.

  • A Search service application at a central farm can crawl content at a regional farm. This configuration does not require you to set up cross-farm service sharing. Instead, crawl rules are added at the central farm to crawl content at a remote farm. However, this configuration crawls content over the WAN connection, which is not ideal.

The following table summarizes the differences between crawling over the WAN and using remote result sources to include content in search results.

Options for including global content in search results

Crawl over the WAN Configure a result source for remote farms

Description

Content at regional sites is crawled from the central site over the WAN.

Search is configured to return results from one or more remote farms (result source), in addition to the local farm.

In this scenario, remote farms are crawled locally. You configure search at the central farm to include results from the remote indexes.

You can also configure the remote farms to include results from the central farm and other regional farms. This allows users to search from the local farm.

User experience

Users are presented with a single list of results.

Results are presented in in a single list. However, the results are grouped in blocks by result source. You can configure the number of results within each group.

Advantages

Search results are contained in a single search-ranked list.

Search is managed centrally.

WAN crawling is not used.

Search results are potentially fresher, based on the crawl schedule.

If you also configure remote farms to include result sources for other farms, enterprise-wide search is available from remote farms in addition to the central farm.

Disadvantages

Crawling over the WAN takes time and uses bandwidth.

Search results might not be as fresh as if the content were crawled locally.

Enterprise-wide search is available only from the central farm.

Users see multiple groupings of results.

Search results are not ranked across the organization.

Search must be managed at multiple locations.

Change History

Date | Description
April 02, 2013 | Added support for stretched farm architectures.
February 5, 2013 | Initial publication


Testing WAN connections for SharePoint 2013 architectures
See also

Published: February 5, 2013

Summary: Learn about WAN performance improvements, test results, and WAN test tools and scenarios.

Applies to: SharePoint Server 2013

SharePoint 2013 is optimized to perform well over WAN connections. This article describes performance improvements and methods for testing WAN connections to help you determine if you need to deploy more than one farm geographically. It also includes example test results from companies that participated in the prerelease program.

In this article:

  • Key concepts

  • WAN performance improvements

  • WAN product-team test results

  • Simple WAN unit testing

  • WAN test tools and scenarios for systematic testing

Key concepts

  • Bandwidth — The data transfer capacity, or speed of transmission, of a digital communications system as measured in bits-per-second (bps).

  • Latency — The time that is required for a request to travel from one point on a network to another point.

  • Network congestion - The condition of a network when the current load approaches or exceeds the available resources and bandwidth that are designed to handle that load at a particular location in the network. Packet loss and delays are associated with congestion.

WAN performance improvements

SharePoint 2013 responds to incoming requests 50% faster the previous version. It utilizes available bandwidth between the server and the client almost 40% more efficiently than the previous version. These performance gains were quantified in Microsoft's environment with the busiest SharePoint farms in the world.

A Microsoft Office 365 environment demands higher levels of performance over WAN connections because many customers are geographically distributed. As a result, Office 365 was extensively tested under WAN conditions. Testing scenarios included latencies up to 300 milliseconds, which is much higher than latencies between the North America and Asia.

To achieve up to 40% improvement in the use of available bandwidth (compared to the previous version), optimizations were targeted to various layers of the network stack:

  • IIS compression and image compression are more effective on the server side.

  • Servers respond to http and https requests much faster.

  • Low-level TCP/IP optimizations result in better use of the communication ports that are open between the client and the server. The ports ramp up quicker and are used more efficiently.

Users benefit not only from the performance gains but also from additional features that improve the experience:

  • Active download management and script on demand — these optimizations prioritize resources and JavaScript to download the content that is most meaningful to users first.

  • Smooth page transitions with animations provide a rich, interactive browser experience.

  • Minimal download strategy — As users browse SharePoint content, only changes to a page are downloaded and sent to the client.

WAN product-team test results

The following diagrams detail the effect of WAN performance optimizations on one of the most popular pages in SharePoint — Teamsite. The diagrams show network traces of Teamsite for both SharePoint 2010 and SharePoint 2013 with the following network conditions:

  • Approximately 300 ms latency roundtrip

  • 1 mpbs bandwidth connection between the server and clients

These conditions represent higher latencies and lower bandwidths than are typical for global WAN connections. However, some customers who have extremely remote sites find themselves within this range (for example, mining, oil and gas, and global construction companies). 1 mpbs bandwidth connection is lower than a typical mobile phone connection.

The following diagram demonstrates that SharePoint 2013 makes better use of available communication ports.

Comparison of port usage between SharePoint 2010 and SharePoint 2013

In the two network traces, the horizontal rows represent the ports that are open. The colored blocks represent content that is traveling over the wire, such as the images, JavaScript, and HTML. In the SharePoint 2010 network trace, the white spaces between the colored blocks represent idle time in which the client or server is waiting for something to happen before completing the next action. In the SharePoint 2013 network trace, the network pipe is filled almost 100%. Communication between the client and server is ongoing until the transaction is complete. There is very little or no idle time between actions. These improvements are provided by the optimizations described earlier in this article (minimal download strategy, active download management, and script on demand).

The following diagram calls attention to the improvement in bandwidth utilization. The blue graphs in both network traces represent the bandwidth utilization. The use of available bandwidth is more efficient in SharePoint 2013.

Comparison of bandwidth utilization between SharePoint 2010 and SharePoint 2013 and illustration of improved efficiency of SharePoint 2013.

This following diagram of the network traces shows that the content that users interact with on the page (the document library, prompts, navigational elements, etc.) are downloaded a full second faster in SharePoint 2013 compared to SharePoint 2010. Users can interact with the site much sooner.

Comparison of content download speed between SharePoint 2010 and SharePoint 2013

Compared to SharePoint 2010, WAN optimizations in SharePoint 2013 achieve the following improvements for this network scenario:

  • Downloads 65% fewer bytes for images because of better use of image compression.

  • Downloads 20% more bytes for the JavaScript which provides quicker and improved functionality in the browser.

  • Downloads 15% fewer bytes total.

Simple WAN unit testing

The simplest method to test performance over WAN connections is to have a user at a remote location connect to a SharePoint site and perform several user actions. For example, you can host an online meeting, talk the user through the actions, and count the number of seconds for actions to be completed. Or, you can connect to a computer remotely and perform the tasks.

For example, during the early adoption phase of SharePoint 2013, Microsoft worked with Teck to evaluate WAN performance between the mining company's two datacenters in Santiago, Chile, and Calgary, Canada. Mahmood Jaffer, IT Specialist and SharePoint Architect, created a remote connection from his Canadian office to the datacenter in Santiago, Chile. From a computer in Santiago, he connected to a server running in the Calgary datacenter and uploaded several files. He also connected to a server running SharePoint 2010 in Calgary and uploaded files that have the same characteristics. The following table records the results.

Teck unit test — File upload from Santiago to Calgary (140ms latency) with Riverbed device

File size and type | SharePoint 2010 | SharePoint 2013
1 mg pdf | 5 seconds | <1 second
10 mg .zip | 25 seconds | 12 seconds

An important consideration for this user test is the use of a WAN accelerator device between the two locations. Teck uses a Riverbed device to accelerate traffic. WAN accelerators look for patterns within packets of data and potentially only send packets that are unique, replacing duplicate packets with content that is cached on the other end. For Teck to obtain accurate results, it was important to use files that have different content for each test, instead of just renaming files.

To repeat this unit test, the Microsoft SharePoint writing team had colleagues in the Beijing office connect to SharePoint sites in the Redmond office. In this scenario, two writers repeated the test multiple times throughout the day and produced a range of results. Files with different content were used each time to avoid potential caching issues, although a WAN accelerator device is not used between the two locations. The following table records the results.

Microsoft writing team unit test — File upload from Beijing to Redmond (144ms latency)

File size and type | SharePoint 2010 | SharePoint 2013
1 mg pdf | 8-9 seconds | 7-8 seconds
10 mg .zip | 53-140 seconds | 49-63 seconds

Several observations result from a comparison of these two sets of results:

  • Testing multiple times throughout a day or week will produce a range of results.

  • The range of results for SharePoint 2013 is narrower than the range of results for SharePoint 2010. The result is in a more predictable experience with .

  • Network environment characteristics can affect results more than latency. Both tests were conducted over WAN connections with similar latencies. However, the results are slower for the WAN connection from Beijing to Redmond. Network environment characteristics include routing patterns, network congestion, packet loss, and other factors. Some global regions and international telecommunications companies are less optimized for WAN traffic.

  • Simple unit testing can provide meaningful data. In these two cases, the real-world experience is unlikely to be duplicated by plugging numbers for bandwidth and latency into a WAN simulation device.

Here are recommendations if you conduct your own simple unit testing:

  • Use different files that have different content to avoid optimization of WAN accelerator devices on second upload.

  • Test multiples times throughout a day or week to capture results for different network loads.

  • Be aware that a file upload in SharePoint 2013 might be slower than in SharePoint 2010 due to the new Efficient File I/O features. Efficient File I/O is a storage method in which a file is split into pieces that are stored and updated separately, and streamed together when a user requests the file. As a result, the performance of the first upload might be slower. Subsequent downloads and uploads of the file will be faster as only the pieces that change are updated. However, you might see slower performance for SharePoint 2013 when you test the versions side-by-side in or near the same location as the servers. The results of the two unit tests described in this article demonstrate that the WAN optimizations in SharePoint 2013 more than offset the performance overhead of the Efficient File I/O feature for high latency connections.

WAN test tools and scenarios for systematic testing

Before you begin any type of systematic load testing across a WAN environment make, sure that you understand the nature of your network. You should have data about bandwidth, latency, network congestion, packet loss and types of devices between users and the SharePoint front-end web server. This data is not always easy to obtain. However tools, such as System Center Operations Manager, can make it easier.

After you understand the network environment, you'll know whether you must address items before you test over the WAN. For initial testing, minimize network congestion and packet loss. Also remove or disable network optimization devices. This will leave you with bandwidth and latency as the two primary factors that will impact your end-users from a network perspective.

Test tools

After you address WAN constraints, you can start to use a combination of tools to testing WAN efficiency. Prescriptive tools, such as Visual Studio 2012 Update 1, provide repeatable unit and load testing capabilities. Non-prescriptive tools, such as Microsoft Network Monitor (Netmon) with Visual Round Trip Analyzer, provide end-user oriented monitoring. Both types of tools can be useful because they each provide a different approach to WAN testing and data collection. The combined results can provide a complete view of the impact of WAN connections on user performance.

The following chart lists the strengths of both tools.

Visual Studio 2012 Update 1 Network Monitor with Visual Round Trip Analyzer

  • Repeatable unit and load test capabilities

  • Data capture across servers and load test agents

  • Plug-ins to test SharePoint loads

  • Export to Excel with Pivot capability

  • Real and simulated bandwidth and latency capability

  • End-user oriented monitoring (true end-user experience capture)

  • Network packet and port analysis

  • Low barrier to entry (free and easy setup)

  • Real bandwidth, latency, congestion, packet loss and optimization is reflected

Test scenarios

Create test scenarios that reflect the types of actions users will perform as part of their jobs. Common scenarios include the following:

  • Browse a team site

  • Fill out a form

  • Upload a document

  • Download a document

  • View a document in Office Web Apps Server

  • Edit a document in Office Web Apps Server

  • Add a newsfeed post

  • Add a social tag

The goal is to have a well-rounded set of unit tests which capture actions that end-users perform in a SharePoint environment and expose any potential latency-sensitive transactions.

Finally, make sure that you conduct rounds of tests at various times throughout the day to capture differences in network utilization patterns. For example, 09:00 on Monday morning may have a very different network and performance pattern compared to 23:00 on Friday. Also, be aware of events in other geographical regions, such as a natural disaster that results in region-wide power outages, that might impact WAN routing or performance. A comprehensive set of tests spread across different time intervals will provide insight and set expectations about what your end-users will experience when they use SharePoint 2013 across the WAN.

Example WAN test using Visual Studio 2013

For an example test case, see SharePoint 2013 SharePoint 2013 WAN testing with Visual Studio 2012 walkthrough. This 3 megabyte Visio slide deck shows how to build a web test and load test for WAN testing that uses Visual Studio 2013.

Example test results

Fabrikam is a fictional company that represents a large, world-wide manufacturing company that participated in the SharePoint 2013 prerelease program. Fabrikam used Visual Studio to script a load test made up of many unit tests and then ran the load test from multiple geographic locations.

In this first set of results, two users in the Fabrikam Shanghai, China, office ran the load test against the servers running SharePoint 2013 in the Texas, USA datacenter. Latency is around 190 ms. The upload, download, and Office Web Apps Server tests were conducted with a 1 mb file.

Fabrikam — WAN performance across the feature set for Shanghai to Texas

Fabrikam test results for performance from Shanghai to Texas. 5 seconds to download a file, 6 seconds to upload a file, less than 2 seconds to render a document in Office Web Apps, less than 2 seconds for most social tasks.

The test results show that performance is good, especially for the social tasks.

The next set of results shows performance for the same load test across a larger set of geographic locations where Fabrikam employees work. The SharePoint servers are located in Texas, USA.

Fabrikam— Results across the feature set for different locations

Fabrikam test results for WAN connections initiating in Australia, Germany, India, Singapore, South Africa, and the UK. 2-6 seconds for file download. 3-8 seconds for file upload. less than 2 seconds for most social tasks.

Even though there are varying degrees of latency, performance is good for users across the globe. The Fabrikam test results provide an example of systematic WAN testing that uses a load test made up of many SharePoint tasks that are important to the company.

Fabrikam is an example of a world-wide company that succeeds with a central datacenter model, instead of deploying SharePoint 2013 to multiple regions across the world. If you plans include a move from a central datacenter model to multiple SharePoint sites in different geographical regions, make sure that you conduct WAN testing to see whether it is really necessary.

See also

Global architectures for SharePoint Server 2013


SharePoint Server 2013 WAN case studies: United Airlines, Teck, and Fabrikam
See also

Summary: Learn how three global companies designed their SharePoint architectures to meet their requirements.

Applies to: SharePoint Server 2013

In this article:

  • United Airlines—Central deployment, single datacenter

  • Fabrikam—Central deployment, multiple datacenter

  • Teck—geographically dispersed deployment

Attributions

United Airlines, Fabrikam, and Teck worked with Microsoft in the prerelease program for SharePoint Server 2013. The IT teams for these companies were led by the following individuals.

Photo of Denise Wilson, United Airlines

Denise Wilson — Senior Manager of Enterprise Collaboration Services, United Airlines

Mahmood Jaffer, IT Specialist

Mahmood Jaffer — IT Specialist and SharePoint Architect for Teck, Softlanding (www.softlanding.ca)

Fabrikam is a fictionally named company representing a large world-wide manufacturing company. While the Fabrikam IT team remains anonymous for this case study, the team was very active in providing valuable feedback to Microsoft.

Faizan Khan, Microsoft

Microsoft Senior Consultant, Faizan Khan, worked with these companies to evaluate WAN performance and recommend appropriate architectures using SharePoint 2013.

"Getting a chance to work on the latest version of SharePoint with three global customers with unique scenarios was rewarding. I enjoyed tackling the previous SharePoint 2007 and 2010 paradigms related to architecture and WAN connected users head on with all of the new SharePoint 2013 capabilities. It was great to see how SharePoint 2013's higher scalability and optimizations for connectivity over the WAN allowed each customer to reduce their server footprint while providing an excellent social collaboration experience for their own customers. When you start planning your SharePoint 2013 architecture I highly recommend taking a look at the new opportunities to consolidate your infrastructure as these customers have done." -Faizan Khan

United Airlines—Central deployment, single datacenter

United Airlines is one of the world's leading airlines serving 379 global airports on six continents with over 85,000 employees. United Airlines participated in the SharePoint Server 2013 Rapid Deployment Program and the Windows 8 and Windows Server 2012 Technology Adoption Programs.

Denise Wilson, Senior Manager of Enterprise Collaboration Services team at United Airlines, worked with Microsoft on several projects with SharePoint Server 2013. Wilson worked with Microsoft Consulting Services to architect the new SharePoint Server 2013 environment and to provide feedback about the airline's experience using SharePoint Server 2013 in its WAN environment. Wilson also worked closely with the SharePoint product team to develop and pilot a new procurement tool that is based on taxonomy and new search features in SharePoint Server 2013.

United Airlines' employees rely on SharePoint sites to complete job-related tasks at every company site, including the 379 global airports. The route map for the airline shows the geographic environment. The whole environment is served by a centralized SharePoint farm.

United Airlines global route map shows many international locations where employees work.

The environment includes high latency connections and other challenges that relate to performance. Wilson's team addressed these challenges in many ways. The following table summarizes some performance optimizations that made a positive difference for the company. The third column of the table includes additional options that other organizations with similar challenges can consider.

Challenges | United optimizations | Additional options that other organizations can consider
High utilization, low-bandwidth connections at international locations | Quality of service (QoS), browser compression (Internet Explorer) | WAN accelerators
Performance at airport kiosks Prioritizing customer kiosk performance over back office performance of SharePoint traffic | QoS, browser compression, local caching | SQL Server Master Data Services (MDS), network interface card optimization
Intranet SharePoint performance | Browser compression, Internet Information Services (IIS) File Compression (static and dynamic), binary large object (BLOB) Caching, Output Caching, Object Caching | Branch Cache
SQL Server performance optimization | Memory tuning, reducing databases, reorganizing indexes, and rebalancing the virtual log files | Do not enable auto-create statistics Set max degree of parallelism (MAXDOP) to 1

The last row of the table, SQL Server performance optimization, highlights the importance of paying attention to the overall health and performance of a SharePoint farm. While these are not WAN-specific optimizations, the United Airlines team reported noticeably faster SharePoint performance across the environment after optimizing compression and caching.

United Airlines operates its SharePoint environment in a Chicago-based datacenter. The disaster recovery environment is hosted in its Houston datacenter. Currently the company uses log-shipping between farms. Failover between farms is scripted and can be achieved in about 15 minutes. The following diagram shows the disaster recovery environment.

United Airlines disaster recovery diagram. Log-shipping between farms from Chicago to Houston.

"There are a number of options for supporting high availability and failover," states Khan. "This example, log shipping between farms across the WAN, is fairly standard. United Airlines has tiered their services and databases. Some databases have a high or medium SLA and are log-shipped. Others, such as content databases, have a lower SLA and are backed up and then restored. While log-shipping is a common way to build a failover solution, database mirroring can also be used, as well as high availability groups with SQL Server 2012."

The overall performance in SharePoint Server 2013 is optimized for building and operating larger farms. Even with the high number of users, large volume of content, and extensive use of the feature set, the Microsoft Consulting team and the SharePoint product team feel comfortable recommending a single, large farm for United Airlines.

The farm featured in the Enterprise-scale model resembles the farm designed by Khan for United Airlines. This model provides guidance for patching and updating farms of this size.

Enterprise-scale farms for SharePoint Server 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

Fabrikam—Central deployment, multiple datacenter

Fabrikam is a fictional company that represents a large world-wide manufacturing company that participated in the SharePoint Server 2013 prerelease program. Fabrikam has several-hundred-thousand employees and many content farms that were migrated from the previous version.

A priority for Fabrikam is offering My Sites to all employees. With the large number of employees, much consideration went into the architecture for My Sites. Fabrikam weighed the benefits and risks of deploying one My Site farm versus multiple My Site farms. The following table summarizes the advantages and disadvantages for both architectures.

 | Architecture 1 — One large My Site farm and multiple content farms | Architecture 2 — Two or three My Site farms and multiple content farms
Description | All employees are served by one My Site farm. The My Site farm and the content farms are located in the same datacenter and consume the User Profile service from a dedicated services farm which is also located in the same datacenter. | Two or more My Site farms are deployed and employees are spread across the My Site farms. Each My Site farm consumes a dedicated User Profile service application. The My Site farms and the User Profile service applications can be spread across datacenters if the User Profile service application that is associated with a My Site farm is located in the same datacenter. Content farms can be spread across datacenters. However, each content farm must consume a User Profile service application that is located in the same datacenter.
Advantages | Single User Profile service to manage. Single My Site farm to manage. Less complexity. With a single User Profile service application, all social features are expected to work as expected across farms. | My Site farms are smaller. The environment can be distributed across multiple datacenters. Users can be assigned to My Site farms based on location, which provides greater opportunities for maintenance windows.
Disadvantages | Concern about outgrowing a single My Site farm. With a world-wide user base, scheduling maintenance windows is more challenging. | More farms to maintain. With multiple User Profile service applications, social features across farms are limited.

An advantage of the performance improvements in SharePoint Server 2013 is the ability to combine content and users into a smaller number of large farms. These improvements helped Fabrikam to feel comfortable with a single My Site farm (Architecture 1 in the previous table). This architecture avoids the complexity of managing multiple User Profile service applications. However, with a single User Profile service application, all of Fabrikam's content farms must be located in the same datacenter. The following diagram shows Fabrikam's environment.

Multi-farm architecture for a global manufacturing company

In the diagram, a separate datacenter hosts Fabrikam's search farm and a dedicated search team manages the farm.

Khan explains the design challenge: "Because the social capabilities of SharePoint Server 2013 are extremely important to Fabrikam, we engaged in a number of detailed conversations on the best approach to implementing a My Sites farm. Should we implement one large farm or fewer smaller farms? There are pros and cons with either choice including manageability, availability, and functionality. There are also concerns with scalability both on the application and storage layers. With new guidance from the SharePoint product group, we decided the best approach is to implement a single farm. This approach results in the best social experience while remaining within the scalability guidelines of SharePoint Server 2013. Due to the large user base, Fabrikam highlights the ability of SharePoint Server 2013 to scale while minimizing the number of farms required."

For more information about how to design architectures that have multiple farms and multiple datacenters, see the following model: Multi-farm architectures with SharePoint Server 2013.

Multi-farm architectures with SharePoint 2013

Zoom into the model in full detail with Zoom.it from Microsoft

Visio version

PDF version

A goal of working with Fabrikam in the prerelease program was to understand how SharePoint Server 2013 performs over a variety of WAN connections. Fabrikam used Visual Studio to script a load test that is made up of many unit tests and then ran the load test from multiple geographic locations. For more information about how to create a similar test, see SharePoint 2013 WAN testing with Visual Studio 2012 walkthrough.

In this first set of results, two users in the Fabrikam Shanghai, China, office ran the load test against the SharePoint sites in the Texas, USA, datacenter. Latency is about 190 milliseconds roundtrip. The upload, download, and Outlook Web Access (OWA) tests were conducted with a 1 mb file.

Fabrikam — WAN performance across the feature set for Shanghai to Texas

Fabrikam test results for performance from Shanghai to Texas. 5 seconds to download a file, 6 seconds to upload a file, less than 2 seconds to render a document in Office Web Apps, less than 2 seconds for most social tasks.

The test results show that performance is good, especially for the social tasks.

The next set of results shows performance for the same load test across a larger set of geographic locations where Fabrikam employees work. The servers running SharePoint Server 2013 are located in Texas, USA.

Fabrikam— Results across the feature set for different locations

Fabrikam test results for WAN connections initiating in Australia, Germany, India, Singapore, South Africa, and the UK. 2-6 seconds for file download. 3-8 seconds for file upload. less than 2 seconds for most social tasks.

Even though there are varying degrees of latency, performance is good for users across the globe. The Fabrikam test results provide an example of systematic WAN testing by using a load test that is comprised of a variety of SharePoint tasks that are important to the company.

Fabrikam is an example of a world-wide company that is succeeding with a central datacenter model, instead of deploying SharePoint Server 2013 to multiple regions across the world. If you are considering a move from a central datacenter model to multiple SharePoint sites in different geographical regions, make sure that you conduct WAN testing to see whether it is really necessary.

Teck—geographically dispersed deployment

Teck is a mining company with many remote sites throughout the world. Many sites are connected to the Teck WAN by high latency and intermittent satellite connections. Mahmood Jaffer, IT Specialist and SharePoint Architect with Microsoft Partner Softlanding, worked with Teck to design and support their global SharePoint architecture.

The description of the Teck architecture includes several illustrations that might be difficult to read within this article. These illustrations are also available in SharePoint 2013 WAN architecture diagrams.

Teck uses two datacenters in Calgary, Canada, and Santiago, Chile. The following map shows the two datacenters plus the 10 remote sites.

Map of Teck Resources Sharepoint architecture. The environment includes 2 central farms in Calgary and Santiago plus 10 regional farms.

Even though some remote sites are located on the same continent as a datacenter, these sites rely on low bandwidth connections or satellite connections that are intermittent. For sites shown on the map, WAN performance prevents or discourages users from uploading content to a SharePoint site at one of the two datacenters, or a site located at a nearby site.

Teck weighed the costs and benefits of deploying many regional SharePoint farms compared to not using SharePoint sites. For the mining company, the benefit of using SharePoint Server 2013 features to manage content outweighs the administrative costs of deploying many farms to support the distributed environment. In particular, the company relies on the following capabilities:

  • Managed metadata—a standard tagging scheme that is applied to content so that assets can be discovered and managed appropriately over time.

  • Enterprise-wide search—the ability to discover content assets that meet specific criteria, which metadata defines, and to know the mining sites that these assets are associated with.

Integrating the environment to support these features requires coordinating service applications at all farms. The User Profile Service and My Sites are deployed to each farm.

Map of User Profile and My Site configuration. Each farm includes both the User Profile service and My Sites. This illustration also shows profile replication between the two central sites--Calgary and Santiago.

With this highly distributed environment, Teck is considering using Yammer for social features.

Search is an important component of the enterprise content management strategy of Teck. The company searches for assets that meet specific criteria. The company also requires the ability to easily determine the mining sites that assets are associated with. Currently much of the historic data that belongs to Teck resides on file shares. It will take some time for the company to move the content to a SharePoint environment. Some assets might remain on file shares indefinitely.

At the remote sites, search is deployed to each local farm and crawl rules are set up to also crawl local file shares. The following diagram shows the configuration that is replicated for all remote sites.

At each regional farm, search indexes local SharePoint content as well as content on local file shares.

Enterprise-wide search is provided at the company's two datacenters in Calgary and Santiago. Teck considered using a combination of federated search and remote result sources to display results. Federated search was considered for sites with intermittent satellite connections. By configuring federated search to show results in a separate Web Part Teck would have a visual indication of whether the remote site is connected or disconnected at the time of the search. However, Teck decided to use remote result sources for all sites to ensure that all results are security trimmed.

The following diagram shows how enterprise-wide search is architected to include results from all remote sites.

Enterprise-wide search architecture. Half the regional farms are included in search results by using federated search. The other half are included by using remote result sources.

The relationship of the two datacenters to each other is not included in the illustration. Each datacenter uses remote result sources to include the other datacenter in search results.

Finally, the Managed Metadata service application is integrated by deploying it to the central farm in Calgary and then sharing this service application to all other farms in the environment. The Managed Metadata service application is one of the few service applications that can be shared across farms that are separated by WAN links.

Map of Managed Metadata service deployment. The service is shared from the Calgary datacenter to all other global farms.

One issue that Teck reports with this configuration, however, is that the Managed Metadata fields and tagging are not available to remote farms when a satellite connection is disconnected.

Khan summarizes the design challenges for Teck: "Because Teck supports the collaboration needs of occasionally connected offices or offices with extreme latency due to the use of satellite links, we needed to build an architecture that was flexible while minimizing the complexity as much as possible. The WAN improvements helped Teck consolidate some of the remote farms, but not all. The result is two central sites that act as the hub for a number of smaller farms. This provides a cohesive enterprise-wide search experience while supporting the goal of providing remote office users with access to SharePoint sites even when disconnected from the 'hub'."

See also

Global architectures for SharePoint Server 2013
Testing WAN connections for SharePoint 2013 architectures


Plan for performance and capacity management in SharePoint Server 2013

Published: October 23, 2012

Summary: Performance and capacity planning is the process of mapping your solution design for SharePoint Server 2013 to a farm size and set of hardware that supports your business goals.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The following articles on TechNet and related resources provide information about performance and capacity management.

Relevant performance and capacity planning articles for Project Server 2013 are available in the Project Server document library at Plan for performance and capacity (Project Server 2013).

TechNet articles about performance and capacity management

The following articles about performance and capacity management are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Relevant performance and capacity planning articles for Project Server 2013 are available in the Project Server document library at Plan for performance and capacity (Project Server 2013).

Building blocks Content | Content | Description
 | Capacity management and sizing for SharePoint Server 2013 | Learn about the concepts and planning considerations for managing the capacity of a SharePoint Server 2013 environment.
 | Software boundaries and limits for SharePoint 2013 | Learn about the tested performance and capacity limits of SharePoint Server 2013 and how limits relate to acceptable performance.
 | Performance and capacity test results and recommendations (SharePoint Server 2013) | Read articles that use test results and recommendations to estimate performance and capacity requirements for SharePoint Server 2013.

Additional resources about performance and capacity management

The following resources about performance and capacity management are available from other subject matter experts.

Content Description

TechNet logo

  • Capabilities and features in SharePoint 2013 Resource Center

  • Architecture design for SharePoint 2013 IT pros

Visit the TechCenter to access videos, community sites, documentation, and more.


Capacity management and sizing for SharePoint Server 2013

Published: October 23, 2012

Summary: Learn about the concepts and planning considerations for managing the capacity of a SharePoint Server 2013 environment.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The articles in this section help you to make the following decisions regarding the appropriate capacity for your SharePoint Server 2013 environment:

  • Understand the concepts behind effective capacity management.

  • Define performance and capacity targets for your environment.

  • Select the appropriate data architecture.

  • Choose hardware to support the number of users and the features you intend to deploy.

  • Test, validate, and adjust your environment to achieve your performance and capacity targets.

  • Monitor and adjust your environment to match demand.

In this section:

  • Capacity management and sizing overview for SharePoint Server 2013

  • Capacity planning for SharePoint Server 2013

  • Performance testing for SharePoint Server 2013

  • Monitoring and maintaining SharePoint Server 2013

  • Optimize performance for SharePoint Server 2013


Capacity planning for SharePoint Server 2013
See also

Published: October 23, 2012

Summary: Learn how to plan and manage capacity and performance for SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

This article describes how to plan the capacity of a SharePoint Server 2013 farm. When you have a good appreciation and understanding of capacity planning and management, you can apply your knowledge to system sizing. Sizing is the term used to describe the selection and configuration of appropriate data architecture, logical and physical topology, and hardware for a solution platform. There is a range of capacity management and usage considerations that affect how you should determine the most appropriate hardware and configuration options.

Before you read this article, you should read Capacity management and sizing overview for SharePoint Server 2013.

Important:

Some information and values in this article are based on test results and other information related to SharePoint 2010 Products and may not represent the final values for SharePoint Server 2013. This article will be updated with appropriate values, links to related content and other information and republished when data related to SharePoint Server 2013 becomes available.

In this article, we describe the steps you should take to undertake effective capacity management for your environment. Each step requires certain information for successful execution, and has a set of deliverables that you will use in the subsequent step. For each step, these requirements and deliverables are outlined in tables.

In this article:

  • Step 1: Model

  • Step 2: Design

  • Step 3: Pilot, Test and Optimize

  • Step 4: Deploy

  • Step 5: Monitor and Maintain

Step 1: Model

Modeling your SharePoint Server 2013-based environment begins with analyzing your existing solutions and estimating the expected demand and targets for the deployment you are planning to set up. You start by gathering information about your user base, data requirements, latency and throughput targets, and document the SharePoint Server features you want to deploy. Use this section to understand what data you should collect, how to collect it, and how it can be used in subsequent steps.

Understand your expected workload and dataset

Proper sizing of a SharePoint Server 2013 implementation requires that you study and understand the demand characteristics that your solution is expected to handle. Understanding the demand requires that you be able to describe both the workload characteristics such as number of users and the most frequently used operations, and dataset characteristics such as content size and content distribution.

This section can help you understand some specific metrics and parameters you should collect and mechanisms by which they can be collected.

Workload

Workload describes the demand that the system will need to sustain, the user base and usage characteristics. The following table provides some key metrics that are helpful in determining your workload. You can use this table to record these metrics as you collect them.

Workload Characteristics | Value
Average daily RPS |
Average RPS at peak time |
Total number of unique users per day |
Average daily concurrent users |
Peak concurrent users at peak time |
Total number of requests per day |
Expected workload distribution | No. of Requests per day | %
Web Browser - Search Crawl |  |
Web Browser - General Collaboration Interaction |  |
Web Browser - Social Interaction |  |
Web Browser - General Interaction |  |
Web Browser - Office Web Apps |  |
Office Clients |  |
OneNote Client |  |
SharePoint Workspace |  |
Outlook RSS Sync |  |
Outlook Social Connector |  |
Other interactions(Custom Applications/Web services) |  |

  • Concurrent users - It is most common to measure the concurrency of operations executed on the server farm as the number of distinct users generating requests in a given time frame. The key metrics are the daily average and the concurrent users at peak load.

  • Requests per second (RPS) - RPS is a commonly used indicator used to describe the demand on the server farm expressed in the number of requests processed by the farm per second, but with no differentiation between the type or size of requests. Every organization's user base generates system load at a rate that is dependent on the organization's unique usage characteristics. See the Glossary section in Capacity management and sizing overview for SharePoint Server 2013 for more information on this term.

  • Total daily requests - Total daily requests is a good indicator of the overall load the system will need to handle. It is most common to measure all requests except authentication handshake requests (HTTP status 401) over a 24 hour period.

  • Total daily users - Total users is another key indicator of the overall load the system will need to handle. This measurement is the actual number of unique users in a 24 hour period, not the total number of employees in the organization.

    Note:

    The number of total daily users can indicate the growth potential of the load on the farm. For example, if the number of potential users is 100k employees, 15k daily users indicates that the load may significantly grow over time as user adoption increases.

  • Workload Distribution - Understanding the distribution of the requests based on the clients applications that are interacting with the farm can help predict the expected trend and load changes after migrating to SharePoint Server 2013. As users transition to more recent client versions such as Office 2013, and start using the new capabilities new load patterns, RPS and total requests are expected to grow. For each client we can describe the number of distinct users using it in a time frame of a day, and the amount of total requests that the client or feature generates on the server.

    For example, the chart below shows a snapshot of a live internal Microsoft environment serving a typical social solution. In this example, you can see that the majority of the load is generated by the search crawler and typical end user web browsing. You can also observe that there is significant load introduced by the Outlook Social Connector feature (6.2 percent of the requests).

    Typical daily load distribution of requests
    Note:

    The data in this chart was collected from a SharePoint Server 2010 environment, and will be updated with current data as it becomes available.

Estimating your production workload

In estimating the required throughput your farm needs to be able to sustain, begin with estimating the mix of transactions that will be used in your farm. Focus on analyzing the most frequently used transactions the system will serve, understanding how frequently they will be used and by how many users. That will help you validate later whether the farm can sustain such load in pre-production testing.

The following diagram describes the relationship of the workload and load on the system:

Capacity - Workload Diagram

To estimate your expected workload, collect the following information:

  • Identify user interactions such as typical web page browses, file downloads and uploads, Office Web Application views and edits in the browser, co-authoring interactions, SharePoint Workspace site syncs, Outlook Social Connections, RSS sync (in Outlook or other viewers), PowerPoint Broadcasts, OneNote shared notebooks, Excel Service shared workbooks, Access Service shared applications and others. See the Services and Features section of the article Capacity management and sizing overview for SharePoint Server 2013 for more information. Focus on the identifying the interactions that may be unique to your deployment, and recognize the expected impact of such load, examples can be significant use of InfoPath Forms, Excel Service Calculations and similar dedicated solutions.

  • Identify system operations such as Search incremental crawls, daily backups, profile sync timer jobs, web analytics processing, logging timer jobs and others.

  • Estimate the total number of users per day that are expected to utilize each capability, derive the estimated concurrent users and high level Requests per second, there are some assumptions you will be making such as present concurrency and the factor of RPS per concurrent users that is different across capabilities, you should use the workload table earlier in this section for your estimates. It is important to focus on peak hours, rather than average throughput. Planning for peak activity, you are able to proper size your SharePoint Server 2013-based solution.

If you have an existing Office SharePoint Server 2007 solution, you can mine the IIS log files or look to other Web monitoring tools you have to better understand some of the expected behaviors from the existing solution or see the instructions in the section below for more details. If you are not migrating from an existing solution, you should fill out the table using rough estimates. In later steps you will need to validate your assumptions and tune the system.

Analyzing your SharePoint Server 2013 IIS Logs

To discover key metrics about an existing SharePoint Server 2013 deployment, such as how many users are active, how heavily they are using the system, what kind of requests are coming in, and from what kind of clients they originate, it is necessary to extract data from ULS and IIS logs. One of the easiest ways to acquire this data is to use Log Parser, a powerful tool available free for download from Microsoft. Log Parser can read and write to a number of textual and binary formats, including all the IIS formats.

For detailed information about how to analyze SharePoint Server 2013 usage using Log Parser, read Analyzing Microsoft SharePoint Products and Technologies Usage (http://www.microsoft.com/downloads/details.aspx?familyid=f159af68-c3a3-413c-a3f7-2e0be6d5532e&displaylang=en&tm).

You can download Log Parser 2.2 at http://www.microsoft.com/downloads/details.aspx?FamilyID=890CD06B-ABF8-4C25-91B2-F8D975CF8C07&displaylang=en.

Dataset

Dataset describes the volume of content stored in the system and how it can be distributed in the data store. The following table provides some key metrics that are helpful in determining your dataset. You can use this table to record these metrics as you collect them.

Object | Value
DB size (in GB) |
Number of Content DBs |
Number of site collections |
Number of web apps |
Number of sites |
Search index size (# of items) |
Number of docs |
Number of lists |
Average size of sites |
Largest site size |
Number of user profiles |

  • Content size - Understanding the size of the content that you expect to store in the SharePoint Server 2013 system is important for planning and architecting the system storage, and also for properly sizing the Search solution that will crawl and index this content. The content size is described in total disk space. If you are migrating content from an existing deployment you might find it simple to identify the total size that you will move; while planning you should leave room for growth over time based on the predicted trend.

  • Total number of documents - Other than the data corpus size, it is important to track the overall number of items. The system reacts differently if 100 GB of data is composed of 50 files of 2 GB each versus 100,000 files of 1 KB each. In large deployments, the less stress there is on a single item, document or area of documents, the better performance will be. Widely distributed content like multiple smaller files across many sites and site collection is easier to serve then a single large document library with very large files.

  • Maximum site collection size - It is important to identify what is the biggest unit of content that you will store in SharePoint Server 2013; usually it is an organizational need that prevents you from splitting that unit of content. Average size of all site collections and the estimated total number of site collections are additional indicators that will help you identify your preferred data architecture.

  • Service applications data characteristics - In addition to analysing the storage needs for the content store, you should analyse and estimate the sizes of other SharePoint Server 2013 stores, including:

  • Total size of the Search index

  • The profile database total size based on the number of user in the profile store

  • The social database total size based on the expected number of tags, colleagues and activities

  • The metadata store size

  • The size of the usage database

  • The size of the Web Analytics data base

Setting Farm Performance and Reliability Targets

One of the deliverables of Step 1: Model is a good understanding of the performance and reliability targets that best fit the needs of your organization. A properly designed SharePoint Server solution should be able to achieve "four nines" (99.99%) of uptime with sub-second server responsiveness.

The indicators used to describe the performance and reliability of the farm can include:

  • Server availability - Usually described by the percent of overall uptime of the system. You should track any unexpected downtime and compare the overall availability to the organizational target you set. The targets are commonly described by a number of nines (i.e. 99%, 99.9%, 99.99%)

  • Server responsiveness - The time it takes the farm to serve requests is a good indicator to track the health of the farm. This indicator is usually named server side latency, and it is common to use the average or median (the 50th percentile) latency of the daily requests being served. The targets are commonly described in sub seconds or seconds. Note that if your organization has a target to serve pages from SharePoint Server 2013 in less than two seconds, then the server side goal needs to be sub seconds to leave time for the page to reach the client over the network and time to render in the browser. Also in general longer server response times are an indication of an unhealthy farm, as this usually as an impact on throughput and rarely can RPS keep up if you spend more than a second on the server on most requests

  • Server spikiness - Another good server side latency indicator worth tracking is the behaviour of the slowest 5% of all requests. Slower requests are usually the requests that hit the system when it is under higher load or even more commonly, requests that are impacted by less frequent activity that occur while users interact with the system; a healthy system is one that has the slowest requests under control as well. The target here is similar to Server Responsiveness, but to achieve sub-second response on server spikiness, you will need to build the system with a lot of spare resources to handle the spikes in load.

  • System resource utilization - Other common indicators used to track the health of the system are a collection of system counters that indicate the health of each server in the farm topology. The most frequently used indicators to track are % CPU utilization and Available Memory; however, there are several additional counters that can help identify a non-healthy system; more details can be found in Step 5: Monitor and Maintain.

Step 2: Design

Now that you have finished collecting some facts or estimates on the solution you need to deliver, you are ready to start the next step of designing a proposed architecture that you predict will be able to sustain the expected demand.

By the end of this step you should have a design for your physical topology and a layout for your logical topology, so you should be able to go ahead with any necessary purchase orders.

The hardware specifications and the number of machines you layout are tightly related, to handle a specific load there are several solutions you can choose to deploy. It is common to either use a small set of strong machines (scale up) or a larger set of smaller machines (scale out); each solution has its advantages and disadvantages when it comes to capacity, redundancy, power, cost, space, and other considerations.

We recommend that you begin this step by determining your architecture and topology. Define how you plan to layout the different farms and the different services in each farm, and then pick the hardware specifications for each of the individual servers in your design. You can also execute this process by identifying the hardware specifications you are expected to deploy (many organizations are constrained to a certain company standard) and then define your architecture and topology.

Use the following table to record your design parameters. The data included is sample data, and should not be used to size your farm. It is intended to demonstrate how to use this table for your own data.

Role | Type (Standard or virtual) | # of machines | Procs | RAM | IOPS need | Disk size OS+Log | Data drive
Web servers | Virtual | 4 | 4 cores | 8 | N/A | 400 GB | N/A
Content database server | Standard | 1 cluster | 4 quad-core 2.33 (GHz) | 48 | 2k | 400 GB | 20 disks of 300GB @ 15K RPM
Application servers | Virtual | 4 | 4 cores | 16 | N/A | 400 GB | N/A
Search Crawl Target Web server | Virtual | 1 | 4 cores | 8 | N/A | 400 GB | N/A
Search Query server | Standard | 2 | 2 quad-core 2.33 (GHz) | 32 | N/A | 400 GB | 500 GB
Search Crawler server | Standard | 2 | 2 quad-core 2.33 (GHz) | 16 | 400 | 400 GB | N/A
Search Crawl database server | Standard | 1 cluster | 4 quad-core 2.33 (GHz) | 48 | 4k (tuned for read) | 100 GB | 16 disks of 150GB @ 15K RPM
Search Property Store database + Administration database server | Standard | 1 cluster | 4 quad-core 2.33 (GHz) | 48 | 2k (tuned for write) | 100 GB | 16 disks of 150GB @ 15K RPM

Determine your starting point architecture

This section describes how to select a starting point architecture.

When you deploy SharePoint Server 2013, you can choose from a range of topologies to implement your solution; you may deploy a single server or scale out many servers to a SharePoint Server farm with clustered or mirrored database servers and discreet application servers for various services. Later you will select the hardware configurations based on the requirements of each of the roles, based on your capacity, availability, and redundancy needs.

Start by reviewing the different reference architectures and figure out your farm structure, decide if you should split your solution across multiple farms, or federate some services, such as search, on a dedicated farm. See the Reference Architectures section in Capacity management and sizing overview for SharePoint Server 2013 for more information.

SharePoint Server 2010 Technical Case Studies

Capacity management guidance for SharePoint Server 2013 includes a number of technical case studies of existing production environments that present a detailed description of existing SharePoint Server-based production environments. Technical case studies specific to SharePoint Server 2013 will be published as they become available; the existing SharePoint Server 2010 case studies can serve as a reference on how to design a SharePoint Server-based environment for specific purposes.

You can use these case studies as a reference while designing the architecture of your SharePoint Server solutions especially if you find the description of these deployment specific key differentiators similar to the demands and targets of the solution you are architecting.

These documents describe the following information for each documented case study:

  • Specifications, such as hardware, farm topology and configuration;

  • Workload including the user base, and the usage characteristics;

  • Dataset, including contents sizes, content characteristics and content distribution

  • Health and performance including a set of recorded indicators describing the farm's reliability and performance characteristics

For more information, download relevant documents from the Performance and capacity technical case studies (SharePoint Server 2010) page.

Select your hardware

Selecting the right specifications for the machines in your farm is a crucial step to ensure proper reliability and performance of your deployment, one key concept to keep in mind is that you should plan for peak load and peak hours; in other words, when your farm is operating under average load conditions, there should be enough resources available to handle the greatest expected demand while still hitting latency and throughput targets.

The core capacity and performance hardware features of servers reflect four main categories: processing power, disk performance, network capacity, and memory capabilities of a system.

Another thing to consider is using virtualized machines. A SharePoint Server farm can be deployed using virtual machines. Although virtualization has not been found to add any performance benefits, it does provide manageability benefits. Virtualizing SQL Server-based computers is generally not recommended, but there may be certain benefits to virtualizing the Web server and application server tiers. For more information, see Virtualization planning (http://technet.microsoft.com/en-us/library/71c203cd-7534-47b0-9122-657d72ff0080(Office.14).aspx).

For more information about hardware requirements, see Hardware and software requirements for SharePoint 2013.

Hardware Selection Guidelines

Choosing Processors

SharePoint Server 2013 is available only for 64-bit processors. In general, more processors will enable you to serve greater demand.

In SharePoint Server 2013, individual web servers will scale up as you add more cores. The more cores the server has the more load it can sustain, all else being equal. In large SharePoint Server deployments, we recommend that you allocate either multiple 4-core web servers (which can be virtualized), or fewer stronger (8-/16-/24-cores) web servers.

Application servers' processor capacity requirements differ depending on the role of the server and the services it is running. Some SharePoint Server features demand greater processing power than others. For example, the SharePoint Search Service is highly dependent on the processing power of the application server. For more information about the resource requirements of SharePoint Server features and services, see the Services and features section of the article Capacity management and sizing overview for SharePoint Server 2013.

The processor capacity requirements for SQL Server also depend on the service databases that a SQL Server-based computer is hosting.

Choosing Memory

Your servers will require varying amounts of memory, depending on server function and role. For example, servers that run Search crawl components will process data more quickly if they have a large amount of memory because documents are read into memory for processing. Web servers that take advantage of many of the caching features of SharePoint Server 2013 may require more memory as well.

In general, web server memory requirements are highly dependent on the number of application pools enabled in the farm and the number of concurrent requests being served. In most production SharePoint Server deployments, we recommend that you allocate at least 8 GB RAM on each web server, with 16 GB recommended for servers that have greater traffic or deployments with multiple application pools set up for isolation.

Application servers' memory requirements differ also; some SharePoint Server features have greater memory requirements on the application tier than others. In most production SharePoint Server deployments we recommend that you allocate at least 8 GB RAM on each application server; 16 GB, 32 GB and 64 GB application servers are common when many application services are enabled on the same server, or when services that are highly dependent on memory, such as the Excel Calculation Service and SharePoint Server Search Service, are enabled.

The memory requirements of database servers are tightly dependent on the database sizes. For more information about choosing memory for your SQL Server-based computers, see Storage and SQL Server capacity planning and configuration (SharePoint Server 2013).

Choosing Networks

In addition to the benefit offered to users if clients have fast data access through the network, a distributed farm must have fast access for inter-server communication. This is especially true when you distribute services across multiple servers or federate some services to other farms. There is significant traffic in a farm across the web server tier, the application server tier, and the database server tier, and network can easily become a bottleneck under certain conditions like dealing with very large files or very high loads.

Web servers and application servers should be configured to use at least two network interface cards (NICs): one NIC to handle end-user traffic and the other to handle the inter-server communication. Network latency between servers can have a significant effect on performance. Therefore, it is important to maintain less than 1 millisecond of network latency between the web server and the SQL Server-based computers hosting the content databases. The SQL Server-based computers that host each service application database should be as close as possible to the consuming application server also. The network between farm servers should have at least 1 Gbps of bandwidth.

Choosing Disks and Storage

Disk management is not simply a function of providing sufficient space for your data. You must assess the on-going demand and growth, and make sure that that the storage architecture is not slowing the system down. You should always make sure that that you have at least 30 percent additional capacity on each disk, above your highest data requirement estimate, to leave room for future growth. Additionally, in most production environments, disk speed (IOps) is crucial to providing sufficient throughput to satisfy the servers' storage demands. You must estimate the amount of traffic (IOps) the major databases will require in your deployment and allocate enough disks to satisfy that traffic.

For more information about how to choose disks for database servers, see Storage and SQL Server capacity planning and configuration (SharePoint Server 2013).

The web and application servers have storage requirements also. In most production environments, we recommend that you allocate at least 200 GB disk space for OS and temp and 150 GB of disk space for logs.

Step 3: Pilot, Test and Optimize

The testing and optimization stage is an extremely important component of effective capacity management. You should test new architectures before you deploy them to production and you should conduct acceptance testing together with following monitoring best practices in order to ensure the architectures you design achieve the performance and capacity targets. This allows you to identify and optimize potential bottlenecks before they affect users in a live deployment. If you are upgrading from an Office SharePoint Server 2007 environment and plan to make architectural changes, or are estimating user load of the new SharePoint Server features, then testing particularly important to make sure that your new SharePoint Server-based environment will meet performance and capacity targets.

Once you have tested your environment, you can analyze the test results to determine what changes must be made in order to achieve the performance and capacity targets you established in Step 1: Model.

These are the recommended sub steps that you should follow for pre-production:

  • Create the test environment that mimics the initial architecture you designed in Step 2: Design.

  • Populate the storage with the dataset or part of the dataset that you've identified in Step 1: Model.

  • Stress the system with synthetic load that represents the workload you've identified in Step 1: Model.

  • Run tests, analyze results, and optimize your architecture.

  • Deploy your optimized architecture in your data center, and roll out a pilot with a smaller set of users.

  • Analyze the pilot results, identify potential bottlenecks, and optimize the architecture. Retest if it is required.

  • Deploy to the production environment.

Test

Testing is a critial factor in establishing the ability of your system design to support your workload and usage characteristics. See Performance testing for SharePoint Server 2013 for detailed information about how to test your SharePoint Server 2013 deployment.

  • Create a test plan

  • Create the test environment

  • Create Tests and Tools

Deploy the pilot environment

Before you deploy SharePoint Server 2013 to a production environment, it is important that you first deploy a pilot environment and thoroughly test the farm to make sure that that it can meet capacity and performance targets for your expected peak load. We recommend that the pilot environment is first tested with synthetic load especially for large deployments, and then stressed by a small set of live users and live content. The benefit of analyzing a pilot environment by using a small set of live users is the opportunity to validate some assumptions you made about the usage characteristics and the content growth before you go fully into production.

Optimize

If you cannot meet your capacity and performance targets by scaling your farm hardware or making changes to the topology, you may have to consider revising your solution. For example, if your initial requirements were for a single farm for collaboration, Search and Social, you may have to federate some services such as search to a dedicated services farm, or split the workload across more farms. One alternative is to deploy a dedicated farm for social and another for team collaboration.

Step 4: Deploy

Once you have executed your final round of tests and confirmed that the architecture you have selected can achieve the performance and capacity targets you established in Step 1: Model, you can deploy your SharePoint Server 2013-based environment to production.

The appropriate rollout strategy will vary depending on the environment and situation. While SharePoint Server deployment generally is outside the scope of this document, there are certain suggested activities that may come out of the capacity planning exercise. Here are some examples:

  • Deploying a new SharePoint Server farm: The capacity planning exercise should have guided and confirmed plans for a design and deployment of SharePoint Server 2013. In this case, the rollout will be the first broad deployment of SharePoint Server 2013. It will require moving or rebuilding the servers and services that were used during the capacity planning exercises into production. This is the most straight-forward scenario because there are not any upgrades or modifications needed to an existing farm.

  • Upgrading an Office SharePoint Server 2007 farm to SharePoint Server 2013: The capacity planning exercise should have validated the design for a farm that can meet existing demands and scale up to meet increased demand and usage of a SharePoint Server 2013 farm. Part of the capacity planning exercise should have included test migrations to validate how long the upgrade process will take, whether any custom code must be modified or replaced, whether any third-party tools have to be updated, and so on At the conclusion of capacity planning you should have a validated design, and understanding of how much time that it will take to upgrade, and a plan for how best to work through the upgrade process - for example, an in-place upgrade, or migrating content databases into a new farm. If you're doing an in-place upgrade then during capacity planning you may have found that additional or upgraded hardware will be needed, and considerations for downtime. Part of the output from the planning exercise should be a list of the hardware changes that are needed and a detailed plan to deploy the hardware changes to the farm first. Once the hardware platform that was validated during capacity planning is in place, you can move forward with the process of upgrading to SharePoint Server 2013.

  • Improving the performance of an existing SharePoint Server 2013 farm: The capacity planning exercise should have helped you to identify the bottlenecks in your current implementation, plan ways to reduce or eliminate those bottlenecks, and validate an improved implementation that meets your business requirements for SharePoint Server services. There are different ways in which performance issues could have been resolved, from something as easy as reallocating services across existing hardware, upgrading existing hardware, or adding additional hardware and adding additional services to it. The different approaches should be tested and validated during the capacity planning exercise, and then a deployment plan designed depending on the results of that testing.

Step 5: Monitor and Maintain

To maintain system performance, you must monitor your server to identify potential bottlenecks. Before you can monitor effectively, you must understand the key indicators that will tell you if a specific part of your farm requires attention, and know how to interpret these indicators. If you find that your farm is operating outside the targets you have defined, you can adjust your farm by adding or removing hardware resources, changing your topology, or changing how data is stored.

See Monitoring and maintaining SharePoint Server 2013 for a list of the settings that you can change to monitor your environment in its early stages, which will help you determine whether any changes are needed. Keep in mind that increasing your monitoring capabilities will affect how much disk space that your usage database will require. Once the environment is stable and this detailed monitoring is no longer required, you may want to reverse the settings below to their default settings.

For more information about health monitoring and troubleshooting using the health monitoring tools built into the SharePoint Server Central Administration interface, read the following:

Monitor health in SharePoint 2013

Solving problems and troubleshooting (http://technet.microsoft.com/en-us/library/ee748639(office.14).aspx)

See also

Capacity management and sizing overview for SharePoint Server 2013
Performance testing for SharePoint Server 2013
Monitoring and maintaining SharePoint Server 2013
Software boundaries and limits for SharePoint 2013
Monitor health in SharePoint 2013
Performance and capacity test results and recommendations (SharePoint Server 2013)

Performance and capacity technical case studies (SharePoint Server 2010)


Performance testing for SharePoint Server 2013
See also

Published: October 23, 2012

Summary: Learn about how to plan and execute performance testing of a SharePoint Server 2013 environment.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

This article describes how to test the performance of SharePoint Server 2013. The testing and optimization stage is a critical component of effective capacity management. You should test new architectures before you deploy them to production and you should conduct acceptance testing in conjunction with following monitoring best practices in order to ensure the architectures you design achieve the performance and capacity targets. This allows you to identify and optimize potential bottlenecks before they impact users in a live deployment. If you are upgrading from an Office SharePoint Server 2007 environment and plan to make architectural changes, or are estimating user load of the new SharePoint Server 2013 features, then testing particularly important to make sure your new SharePoint Server 2013-based environment will meet performance and capacity targets.

Once you have tested your environment, you can analyze the test results to determine what changes need to be made in order to achieve the performance and capacity targets you established in Step 1: Model of Capacity planning for SharePoint Server 2013.

These are the recommended sub steps you should follow for pre-production:

  • Create the test environment that mimics the initial architecture you designed in Step 2: Design.

  • Populate the storage with the dataset or part of the dataset that you've identified in Step 1: Model.

  • Stress the system with synthetic load that represents the workload you've identified in Step 1: Model.

  • Run tests, analyze results, and optimize your architecture.

  • Deploy your optimized architecture in your data center, and roll out a pilot with a smaller set of users.

  • Analyze the pilot results, identify potential bottlenecks, and optimize the architecture. Retest if needed.

  • Deploy to the production environment.

Before you read this article, you should read Capacity management and sizing overview for SharePoint Server 2013.

In this article:

  • Create a Test Plan

  • Create the Test Environment

  • Create Tests and Tools

Create a Test Plan

Verify that your plan includes:

  • Hardware that is designed to operate at expected production performance targets. Always measure the performance of test systems conservatively.

  • If you have custom code or custom component, it is important that you test the performance of those components in isolation first to validate their performance and stability. After they are stable, you should test the system with those components installed and compare performance to the farm without them installed. Custom components are often a major culprit of performance and reliability problems in production systems.

  • Know the goal of your testing. Understand ahead of time what your testing objectives are. Is it to validate the performance of some new custom components that were developed for the farm? Is it to see how long it will take to crawl and index a set of content? Is it to determine how many requests per second your farm can support? There can be many different objectives during a test, and the first step in developing a good test plan is deciding what your objectives are.

  • Understand how to measure for your testing goal. If you are interested in measuring the throughput capacity of your farm for example, you will want to measure the RPS and page latency. If you are measuring for search performance then you will want to measure crawl time and document indexing rates. If your testing objective is well understood, that will help you clearly define what key performance indicators you need to validate in order to complete your tests.

Create the Test Environment

Once your test objectives have been decided, your measurements have been defined, and you have determined what the capacity requirements are for your farm (from steps 1 and 2 of this process), the next objective will be to design and create the test environment. The effort to create a test environment is often underestimated. It should duplicate the production environment as closely as possible. Some of the features and functionality you should consider when designing your test environment include:

  • Authentication: Decide whether the farm will use Active Directory Domain Services (AD DS), forms-based authentication (and if so with what directory), claims-based authentication, etc. Regardless of which directory you are using, how many users do you need in your test environment and how are you going to create them? How many groups or roles are you going to need and how will you create and populate them? You also need to ensure that you have enough resources allocated to your authentication services that they don't become a bottleneck during testing.

  • DNS: Know what the namespaces are that you will need during your testing. Identify which servers will be responding to those requests and make sure you've included a plan that has what IP addresses will be used by which servers, and what DNS entries you will need to create.

  • Load balancing: Assuming you are using more than one server (which you normally would or you likely wouldn't have enough load to warrant load testing), you will need some kind of load balancer solution. That could be a hardware load balancing device, or you could use software load balancing like Windows NLB. Figure out what you will use and write down all of the configuration information you will need to get it set up quickly and efficiently. Another thing to remember is that load test agents typically try and resolve the address to a URL only once every 30 minutes. That means that you should not use a local hosts file or round robin DNS for load balancing because the test agents will likely end up going to the same server for every single request, instead of balancing around all available servers.

  • Test servers: When you plan your test environment, you not only need to plan for the servers for the SharePoint Server 2013 farm, you also need to plan for the machines needed to execute the tests. Typically that will include 3 servers at a minimum; more may be necessary. If you are using Visual Studio Team System (Team Test Load Agent) to do the testing, one machine will be used as the load test controller. There are generally 2 or more machines that are used as load test agents. The agents are the machines that take the instructions from the test controller about what to test and issue the requests to the SharePoint Server 2013 farm. The test results themselves are stored on a SQL Server-based computer. You should not use the same SQL Server-based computer that is used for the SharePoint Server 2013 farm, because writing the test data will skew the available SQL Server resources for the SharePoint Server 2013 farm. You also need to monitor your test servers when running your tests, the same way as you would monitor the servers in the SharePoint Server 2013 farm, or domain controllers, etc. to make sure that the test results are representative of the farm you're setting up. Sometimes the load agents or controller can become the bottleneck themselves. If that happens then the throughput you see in your test is typically not the maximum the farm can support.

  • SQL Server: In your test environment, follow the guidance in the sections "Configure SQL Server" and "Validate and monitor storage and SQL Server performance" in the article Storage and SQL Server capacity planning and configuration (SharePoint Server 2013).

  • Dataset validation: As you decide what content you are going to run tests against, remember that in the best case scenario you will use data from an existing production system. For example, you can back up your content databases from a production farm and restore them into your test environment, then attach the databases to bring the content into the farm. Anytime you run tests against made up or sample data, you run the risk of having your results skewed because of differences in your content corpus.

If you do have to create sample data, there are a few considerations to keep in mind as you build out that content:

  • All pages should be published; nothing should be checked out

  • Navigation should be realistic; don't build beyond what you would reasonably expect to use in production.

  • You should have an idea of the customizations the production site will be using. For example, master pages, style sheets, JavaScript, etc. should all be implemented in the test environment as closely as possible to the production environment.

  • Determine how many SharePoint groups and/or permission levels you are going to need, and how you are going to associate users with them.

  • Figure out whether you'll need to do profile imports, and how long that will take.

  • Determine whether you'll need Audiences, and how you'll create and populate them.

  • Determine whether you need additional search content sources, and what you will need to create them. If you won't need to create them, determine whether you'll have network access to be able to crawl them.

  • Determine whether you have enough sample data - documents, lists, list items, etc. If not, create a plan for how you will create this content.

  • Have a plan for enough unique content to adequately test search. A common mistake is to upload the same document - maybe hundreds or even thousands of times - to different document libraries with different names. That can impact search performance because the query processor will spend an ordinate amount of time doing duplicate detection that it wouldn't otherwise have to in a production environment with real content.

Create Tests and Tools

After the test environment is functional, it is time to create and fine-tune the tests that will be used to measure the performance capacity of the farm. This section will at times make references specifically to Visual Studio Team System (Team Test Load Agent), but many of the concepts are applicable irrespective of which load test tool you use. For more information about Visual Studio Team System, see Visual Studio Team System at MSDN (http://msdn.microsoft.com/en-us/library/fda2bad5.aspx" ).

You can also use the SharePoint Load Test Kit (LTK) in conjunction with VSTS for load testing of SharePoint 2010 farms. The Load Test Kit generates a Visual Studio Team System 2008 load test based on Windows SharePoint Services 3.0 and Microsoft Office SharePoint Server 2007 IIS logs. The VSTS load test can be used to generate synthetic load against SharePoint Foundation 2010 or SharePoint Server 2010 as part of a capacity planning exercise or a pre-upgrade stress test.

The Load Test Kit is included in the Microsoft SharePoint 2010 Administration Toolkit v1.0, available from the Microsoft Download Center (http://www.microsoft.com/downloads/details.aspx?FamilyId=718447d8-0814-427a-81c3-c9c3d84c456e&displaylang=en).

A key criterion to the success of the tests is to be able to effectively simulate a realistic workload by generating requests across a wide range of the test site data, just as users would access a wide range of content in a production SharePoint Server 2013 farm. In order to do that, you will typically need to construct your tests such that they are data driven. Rather than creating hundreds of individual tests that are hard-coded to access a specific page, you should use just a few tests that use data sources containing the URLs for those items to dynamically access that set of pages.

In Visual Studio Team System (Team Test Load Agent), a data source can come in a variety of formats, but a CSV file format is often easiest to manage and transport between development and test environments. Keep in mind that creating CSV files with that content might require the creation of custom tools to enumerate the SharePoint Server 2013-based environment and record the various URLs being used.

You may need to use tools for tasks like:

  • Creating users and groups in Active Directory or other authentication store if you're using forms based authentication

  • Enumerating URLs for sites, lists and libraries, list items, documents, etc. and putting them into CSV files for load tests

  • Uploading sample documents across a range of document libraries and sites

  • Creating site collections, webs, lists, libraries, folders and list items

  • Creating My Sites

  • Creating CSV files with usernames and passwords for test users; these are the user accounts that the load tests will execute as. There should be multiple files so that, for example, some contain only administrator users, some contain other users with elevated privileges (like author / contributor, hierarchy manager, etc.), and others are only readers, etc.

  • Creating a list of sample search keywords and phrases

  • Populating SharePoint groups and permission levels with users and Active Directory groups (or roles if you are using forms based authentication)

When creating the web tests, there are other best practices that you should observe and implement. They include:

  • Record simple web tests as a starting point. Those tests will have hard-coded values in them for parameters like URL, ID's, etc. Replace those hard-coded values with links from your CSV files. Data binding those values in Visual Studio Team System (Team Test Load Agent) is extremely easy.

  • Always have validation rules for your test. For example, when requesting a page, if an error occurs you will often get the error.aspx page in response. From a web test perspective it appears as just another positive response, because you get an HTTP status code of 200 (successful) in the load test results. Obviously an error has occurred though so that should be tracked differently. Creating one or more validation rules allows you to trap when certain text is sent as a response so that the validation fails and the request is marked as a failure. For example, in Visual Studio Team System (Team Test Load Agent) a simple validation rule might be a ResponseUrl validation - it records a failure if the page that is rendered after redirects is not the same response page that was recorded in the test. You could also add a FindText rule that will record a failure if it finds the word "access denied", for example, in the response.

  • Use multiple users in different roles for tests. Certain behaviors such as output caching work differently depending on the rights of the current user. For example, a site collection administrator or an authenticated user with approval or authoring rights will not get cached results because we always want them to see the most current version of content. Anonymous users, however, will get the cached content. You need to make sure that your test users are in a mix of these roles that approximately matches the mix of users in the production environment. For example, in production there are probably only two or three site collection administrators, so you should not create tests where 10% of the page requests are made by user accounts that are site collection administrators over the test content.

  • Parsing dependent requests is an attribute of a Visual Studio Team System (Team Test Load Agent) that determines whether the test agent should attempt to retrieve just the page, or the page and all associated requests that are part of the page, such as images, style sheets, scripts, etc. When load testing, we usually ignore these items for a few reasons:

    • After a user hits a site the first time these items are often cached by the local browser

    • These items don't typically come from SQL Server in a SharePoint Server 2013-based environment. With BLOB caching turned on, they are instead served by the Web servers so they don't generate SQL Server load.

If you regularly have a high percentage of first time users to your site, or you have disabled browser caching, or for some reason you don't intend to use the blob cache, then it may make sense to enable parsing dependent requests in your tests. However this is really the exception and not the rule of thumb for most implementations. Be aware that if you do turn this on it can significantly inflate the RPS numbers reported by the test controller. These requests are served so quickly it may mislead you into thinking that there is more capacity available in the farm than there actually is.

  • Remember to model client application activity as well. Client applications, such as Microsoft Word, PowerPoint, Excel and Outlook generate requests to SharePoint Server 2013 farms as well. They add load to the environment by sending the server requests such as retrieving RSS feeds, acquiring social information, requesting details on site and list structure, synchronizing data, etc. These types of requests should be included and modeled if you have those clients in your implementation.

  • In most cases a web test should only contain a single request. It's easier to fine-tune and troubleshoot your testing harness and individual requests if the test only contains a single request. Web tests will typically need to contain multiple requests if the operation it is simulating is composed of multiple requests. For example, to test this set of actions you will need a test with multiple step: checking out a document, editing it, checking it in and publishing it. It also requires reserving state between the steps - for example, the same user account should be used to check it out, make the edits, and check it back in. Those multi-step operations that require state to be carried forward between each step are best served by multiple requests in a single web test.

  • Test each web test individually. Make sure that each test is able to complete successfully before running it in a larger load test. Confirm that all of the names for web applications resolve, and that the user accounts used in the test have sufficient rights to execute the test.

Web tests comprise the requests for individual pages, uploading documents, view list items, etc. All of these are pulled together in load tests. A load test is where you plug in all of the different web tests that are going to be executed. Each web test can be given a percentage of time that it will execute - for example, if you find that 10% of requests in a production farm are search queries, then in the load test you would configure a query web test to run 10% of the time. In Visual Studio Team System (Team Test Load Agent), load tests are also how you configure things like the browser mix, network mix, load patterns, and run settings.

There are some additional best practices that should be observed and implemented for load tests:

  • Use a reasonable read/write ratio in your tests. Overloading the number of writes in a test can significantly impact the overall throughput of a test. Even on collaboration farms, the read/write ratios tend to have many more reads than writes.

  • Consider the impact of other resource intensive operations and decide whether they should be occurring during the load test. For example, operations like backup and restore are not generally done during a load test. A full search crawl may not be usually run during a load test, whereas an incremental crawl may be normal. You need to consider how those tasks will be scheduled in production - will they be running at peak load times? If not, then they should probably be excluded during load testing, when you are trying to determine the maximum steady state load you can support for peak traffic.

  • Don't use think times. Think times are a feature of Visual Studio Team System (Team Test Load Agent) that allow you to simulate the time that users pause between clicks on a page. For example a typical user might load a page, spend three minutes reading it, then click a link on the page to visit another site. Trying to model this in a test environment is nearly impossible to do correctly, and effectively doesn't add value to the test results. It's difficult to model because most organizations don't have a way to monitor different users and the time they spend between clicks on different types of SharePoint sites (like publishing versus search versus collaboration, etc.). It also doesn't really add value because even though a user may pause between page requests, the SharePoint Server 2013-based servers do not. They just get a steady stream of requests that may have peaks and valleys over time, but they are not waiting idly as each user pauses between clicking links on a page.

  • Understand the difference between users and requests. Visual Studio Team System (Team Test Load Agent) has load pattern where it asks you to enter the number of users to simulate. This doesn't have anything to do with application users, it's really just how many threads are going to be used on the load test agents to generate requests. A common mistake is thinking that if the deployment will have 5,000 users for example, then 5,000 is the number that should be used in Visual Studio Team System (Team Test Load Agent) - it is not! That's one of the many reasons why when estimating capacity planning requirements, the usage requirements should be based on number of requests per second and not number of users. In a Visual Studio Team System (Team Test Load Agent) load test, you will find that you can often generate hundreds of requests per second using only 50 to 75 load test "users".

  • Use a constant load pattern for the most reliable and reproducible test results. In Visual Studio Team System (Team Test Load Agent) you have the option of basing load on a constant number of users (threads, as explained in the previous point), a stepped up load pattern of users, or a goal based usage test. A stepped load pattern is when you start with a lower number of users and then "step up" adding additional users every few minutes. A goal based usage test is when you establish a threshold for a certain diagnostic counter, like CPU utilization, and test attempts to drive the load to keep that counter between a minimum and maximum threshold that you define for it. However, if you are just trying to determine the maximum throughput your SharePoint Server 2013 farm can sustain during peak load, it is more effective and accurate to just pick a constant load pattern. That allows you to more easily identify how much load the system can take before starting to regularly exceed the thresholds that should be maintained in a healthy farm.

Each time you run a load test remember that it is changing data in the database. Whether that's uploading documents, editing list items, or just recording activity in the usage database, there will be data that is written to SQL Server. To ensure a consistent and legitimate set of test results from each load test, you should have a backup available before you run the first load test. After each load test is complete the backup should be used to restore the content back to the way it was before the test was started.

See also

Capacity management and sizing overview for SharePoint Server 2013
Capacity planning for SharePoint Server 2013
Monitoring and maintaining SharePoint Server 2013
Monitor health in SharePoint 2013
Software boundaries and limits for SharePoint 2013


Monitoring and maintaining SharePoint Server 2013
See also

Published: October 23, 2012

Summary: Learn about how to monitor and maintain SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

This article discusses monitoring and performance counters for SharePoint Server 2013 farms. To maintain SharePoint Server 2013 system performance, you must monitor your server to identify potential bottlenecks. Before you can monitor effectively, you must understand the key indicators that will tell you if a specific part of your farm requires attention, and know how to interpret these indicators. If you find that your farm is operating outside the targets you have defined, you can adjust your farm by adding or removing hardware resources, changing your topology, or changing how data is stored.

The information in this section is intended to help administrators manually configure performance counters and other settings. For more information about health monitoring and troubleshooting using the health monitoring tools built into the SharePoint Central Administration website interface, read the following articles:

  • Plan for monitoring in SharePoint 2013

  • Monitor health in SharePoint 2013

  • Solving problems and troubleshooting in SharePoint 2013

Before you read this article, you should read Capacity management and sizing overview for SharePoint Server 2013.

In this article:

  • Configuring monitoring

  • Removing bottlenecks

Configuring monitoring

Below is a list of the settings that you can change to monitor your environment in its early stages, which will help you determine whether any changes are needed. Increasing your monitoring capabilities will affect how much disk space that your usage database will require. Once the environment is stable and this detailed monitoring is no longer required, you may want to reverse the settings below to their default settings.

Setting | Value | Notes
Event Log Flooding Protection | Disabled | The default value is Enabled. It can be disabled to collect as much monitoring data as possible. For normal operations, it should be enabled.
Timer Job Schedule |  |
Microsoft SharePoint Foundation Usage Data Import | 5 minutes | The default value is 30 minutes. Lowering this setting imports the data into the usage database more frequently, and is especially useful when troubleshooting. For normal operations, it should be 30 minutes.
Diagnostic Providers |  |
Enable all diagnostic providers | Enabled | The default value is Disabled except for the "Search Health Monitoring - Trace Events" provider. These providers collect health data for various features and components. For normal operations, you may want to revert to the default.
Set "job-diagnostics-performance-counter-wfe-provider" and "job-diagnostics-performance-counter-sql-provider" Schedule Intervals | 1 minute | The default value is 5 minutes. Lowering this setting can poll data more frequently, and is especially useful when troubleshooting. For normal operations, it should be 5 minutes.
Miscellaneous |  |
Enable stack tracing for content requests | Enabled | The default value is Disabled. Enabling this setting allows diagnosis of content requests failures using the process stack trace. For normal operations, it should be disabled.
Enable the Developer Dashboard | Enabled | The default value is Disabled. Enabling this setting allows diagnosis of slow pages, or other problems by using the Developer Dashboard. For normal operations, and as soon as troubleshooting is no longer necessary, it should be disabled.
Usage Data Collection |  |
Content Import Usage Content Export Usage Page Requests Feature Use Search Query Use Site Inventory Usage Timer Jobs Rating Usage | Enabled | Enabling the logging of this set of counters allows you to collect more usage data across the environment and to better understand the traffic patterns in the environment.

Performance counters

If you are using the usage database, then you can add the performance counters that assist you in monitoring and evaluating your farm's performance to the usage database, in such a way that they are logged automatically at a specific interval (by default, 30 minutes). Given that, you can query the usage database to retrieve these counters and graph the results over time. Here's an how to use the Add-SPDiagnosticsPerformanceCounter PowerShell cmdlet to add the % Processor Time counter to the usage database. This only has to be run on one of the web servers:

Copy code
Add-SPDiagnosticsPerformanceCounter -Category "Processor" -Counter "% Processor Time" -Instance "_Total" -WebFrontEnd

There are several generic performance counters that you should monitor for any server system. The following table outlines these performance counters.

Performance Counter | Description
Processor | You should monitor processor performance to ensure that all processor usage does not remain consistently high (over 80 percent) as this indicates that the system would not be able to handle any sudden surges of activity. And that in the common state, you will not see a domino effect if one component failure will bring the remaining components to a malfunctioning state. For example, if you have three web servers, you should make sure that the average CPU across all servers is under 60% so that if one fails, there is still room for the other two to absorb the additional load.
Network Interface | Monitor the rate at which data is sent and received via the network interface card. This should remain below 50 percent of network capacity.
Disks and Cache | There are several logical disk options that you should monitor regularly. The available disk space is important in any capacity study, but you should also review the time that the disk is idle. Dependent on the types of applications or services that you are running on your servers, you may review disk read and write times. Extended queuing for write or read function will affect performance. The cache has a major effect on read and write operations. You must monitor for increased cache failures.
Memory and Paging File | Monitor how much physical memory is available for allocation. Insufficient memory will lead to excessive use of the page file and an increase in the number of page faults per second.

System counters

The following table provides information on system objects and counters that you could add to the set of counters monitored in the usage database using the SPDiagnosticPerformanceCounter on a web server.

Objects and Counters Description

Processor

% Processor Time

This shows processor usage over time. If this is consistently too high, you may find performance is adversely affected. Remember to count "Total" in multiprocessor systems. You can measure the utilization on each processor also, to ensure balanced performance between cores.

Disk

- Avg. Disk Queue Length

This shows the average number of both read and write requests that were queued for the selected disk during the sample interval. A bigger disk queue length may not be a problem as long as disk reads/writes are not suffering and the system is working in a steady state without expanding queuing.

Avg. Disk Read Queue Length

The average number of read requests that are queued.

Avg. Disk Write Queue Length

The average number of write requests that are queued.

Disk Reads/sec

The number of reads to disk per second.

Disk Writes/sec

The number of writes to disk per second.

Memory

- Available Mbytes

This shows how much physical memory is available for allocation. Insufficient memory leads to excessive use of the page file and an increase in the number of page faults per second.

- Cache Faults/sec

This counter shows the rate at which faults occur when a page is sought in the file system cache and is not found. This may be a soft fault, when the page is found in memory, or a hard fault, when the page is on disk.

The effective use of the cache for read and write operations can have a significant effect on server performance. You must monitor for increased cache failures, indicated by a reduction in the Async Fast Reads/sec or Read Aheads/sec.

- Pages/sec

This counter shows the rate at which pages are read from or written to disk to resolve hard page faults. If this increases, it indicates system-wide performance problems.

Paging File

- % Used and % Used Peak

The server paging file, also known as the swap file, holds "virtual" memory addresses on disk. Page faults occur when a process has to stop and wait while required "virtual" resources are retrieved from disk into memory. These will be more frequent if the physical memory is insufficient.

NIC

- Total Bytes/sec

This is the rate at which data is sent and received via the network interface card. You may have to investigate further if this rate is over 40-50 percent network capacity. To fine-tune your investigation, monitor Bytes received/sec and Bytes Sent/sec.

Process

- Working Set

This counter indicates the current size (in bytes) of the working set for a given process. This memory is reserved for the process, even if it is not being used.

- % Processor Time

This counter indicates the percentage of processor time that is used by a given process.

Thread Count (_Total)

The current number of threads.

ASP.NET

Requests Total

The total number of requests since the service was started.

Requests Queued

SharePoint Foundation 2013 provides the building blocks for HTML pages that are rendered in the user browser over HTTP. This counter shows the number of requests waiting to be processed.

Request Wait Time

The number of milliseconds that the most recent request waited in the queue for processing. As the number of wait events increases, users will experience decreased page-rendering performance.

Requests Rejected

The total number of requests not executed because of insufficient server resources to process them. This counter represents the number of requests that return a 503 HTTP status code, which indicates that the server is too busy.

Requests Executing (_Total)

The number of requests currently executing.

Requests/Sec (_Total)

The number of requests executed per second. This represents the current throughput of the application. Under constant load, this number should remain in a certain range, barring other server work (such as garbage collection, cache cleanup thread, external server tools, and so on).

.NET CLR Memory

# Gen 0 Collections

Displays the number of times the generation 0 objects (that is, the youngest, most recently allocated objects) are reclaimed by garbage collection since the application started. This number is useful as a ratio of #Gen 0: #Gen 1: #Gen 2 to make sure that the number of Gen 2 collections does not greatly exceed Gen 0 collections, optimally by a factor of 2.

# Gen 1 Collections

Displays the number of times the generation 1 objects are reclaimed by garbage collection since the application started.

# Gen 2 Collections

Displays the number of times the generation 2 objects are reclaimed by garbage collection since the application started. The counter is incremented at the end of a generation 2 garbage collection (also known as a full garbage collection).

% Time in GC

Displays the percentage of elapsed time that was spent performing a garbage collection since the last garbage collection cycle. This counter usually indicates the work done by the garbage collector to collect and compact memory on behalf of the application. This counter is updated only at the end of every garbage collection. This counter is not an average. Its value reflects the last observed value. This counter should be under 5% in normal operation.

SQL Server counters

The following table provides information on SQL Server objects and counters.

Objects and Counters | Description
General Statistics | This object provides counters to monitor general server-wide activity, such as the number of current connections and the number of users connecting and disconnecting per second from computers that are running an instance of SQL Server.
User Connections | This counter shows the number of user connections on your instance of SQL Server. If you see this number increase by 500 percent from your baseline, you may see a performance reduction.
Databases | This object provides counters to monitor bulk copy operations, backup and restore throughput, and transaction log activities. Monitor transactions and the transaction log to determine how much user activity is occurring in the database and how full the transaction log is becoming. The amount of user activity can determine the performance of the database and affect log size, locking, and replication. Monitoring low-level log activity to gauge user activity and resource usage can help you identify performance bottlenecks.
Transactions/sec | This counter shows the number of transactions on a given database or on the whole SQL Server instance per second. This number is to help you create a baseline and to help you troubleshoot issues.
Locks | This object provides information about SQL Server locks on individual resource types.
Number of Deadlocks/sec | This counter shows the number of deadlocks on the SQL Server per second. This should typically be 0.
Average Wait Time (ms) | This counter shows the average amount of wait time for each lock request that resulted in a wait.
Lock Wait Time (ms) | This counter shows the total wait time for locks in the last second.
Lock Waits/sec | This counter shows the number of locks per second that could not be satisfied immediately and had to wait for resources.
Latches | This object provides counters to monitor internal SQL Server resource locks called latches. Monitoring the latches to determine user activity and resource usage can help you identify performance bottlenecks.
Average Latch Wait Time (ms) | This counter shows the average latch wait time for latch requests that had to wait.
Latch Waits/sec | This counter shows the number of latch requests per second that could not be granted immediately.
SQL Statistics | This object provides counters to monitor compilation and the type of requests sent to an instance of SQL Server. Monitoring the number of query compilations and recompilations and the number of batches received by an instance of SQL Server gives you an indication of how quickly SQL Server is processing user queries and how effectively the query optimizer is processing the queries.
SQL Compilations/sec | This counter indicates the number of times the compile code path is entered per second.
SQL Re-Compilations/sec | This counter indicates the number of times statement recompiles are triggered per second.
Plan Cache | This object provides counters to monitor how SQL Server uses memory to store objects such as stored procedures, impromptu and prepared Transact-SQL statements, and triggers.
Cache Hit Ratio | This counter indicates the ratio between cache hits and lookups for plans.
Buffer Cache | This object provides counters to monitor how SQL Server uses memory to store data pages, internal data structures, and the procedure cache and counters to monitor the physical I/O as SQL Server reads and writes database pages.
Buffer Cache Hit Ratio | This counter shows the percentage of pages found in the buffer cache without having to read from disk. The ratio is the total number of cache hits divided by the total number of cache lookups since an instance of SQL Server was started.

Removing bottlenecks

System bottlenecks represent a point of contention where there are insufficient resources to service user transaction requests. These may be physical hardware, operating environment, or application-based. Often, the reason for the bottleneck will be inefficient custom code or third-party solutions, and a review of those could yield better results than adding hardware. Another common cause of bottlenecks is a misconfiguration of the farm, or an inefficient solution implementation that structures data in a way that requires more resources than necessary. For a system administrator, you should manage bottlenecks by constantly monitoring performance. When you identify a performance issue, you must assess the best resolution for removing the bottleneck. The performance counters and other performance monitoring applications, such as System Center 2012 - Operations Manager (SCOM), are the key tools in tracking and analyzing problems, so that you can develop a solution.

Physical bottleneck resolution

Physical bottlenecks are based on processor, disk, memory, and network contention: too many requests are contending for too few physical resources. The objects and counters described in the Monitoring Performance topic indicate where the performance problem is located, for example, hardware processor or ASP.NET. Bottleneck resolution requires that you identify the issue and then make a change or changes that mitigate the performance problem.

Problems seldom happen instantaneously; there is usually a gradual performance degradation that you can track if you monitor regularly, using your performance monitor tool or a more sophisticated system, such as SCOM. For both of these options, to varying degrees, you can embed solutions within an alert, in the form of advisory text or scripted commands.

You may have to resolve bottleneck issues by making changes to hardware or system configurations, once you have determined that they are not caused by a misconfiguration, inefficient custom code or third party solutions, or inefficient solution implementation. The following tables identify problem threshold and possible resolution options. Some of the options suggest hardware upgrades or modifications.

Objects and Counters Problem Resolution Options

Processor

Processor - % Processor Time

Over 75-85%

Upgrade processor

Increase number of processors

Add additional server(s)

Disk

Avg. Disk Queue Length

Gradually increasing, system not in a steady state and queue is backing up

Increase number or speed of disks

Change array configuration to stripe

Move some data to an alternative server

% Idle Time

Less than 90%

Increase number of disks

Move data to an alternative disk or server

% Free Space

Less than 30%

Increase number of disks

Move data to an alternative disk or server

Memory

Available Mbytes

Less than 2GB on a Web server.

Add memory.

Note:

SQL Server available memory will be low, by design, and does not always indicate a problem.

Cache Faults/sec

Greater than 1

Add memory

Increase cache speed or size if possible

Move data to an alternative disk or server

Pages/sec

Greater than 10

Add memory

Paging File

% Used and % Used Peak

The server paging file, sometimes called the swap file, holds "virtual" memory addresses on disk. Page faults occur when a process has to stop and wait while required "virtual" resources are retrieved from disk into memory. These will be more frequent if the physical memory is inadequate.

Add memory

NIC

Total Bytes/sec

Over 40-50% of network capacity. This is the rate at which data is sent and received via the network interface card.

Investigate further by monitoring Bytes received/sec and Bytes Sent/sec.

Reassess network interface card speed

Check number, size, and usage of memory buffers

Process

Working Set

Greater than 80% of total memory

Add memory

% Processor Time

Over 75-85%.

Increase number of processors

Redistribute workload to additional servers

ASP.NET

Application Pool Recycles

Several per day, causing intermittent slowness.

Make sure that you have not implemented settings that automatically recycle the application pool unnecessarily throughout the day.

Requests Queued

Hundreds or thousands of requests queued.

Implement additional Web servers

The default maximum for this counter is 5,000, and you can change this setting in the Machine.config file

Request Wait Time

As the number of wait events increases, users will experience degraded page rendering performance.

Implement additional Web servers

Requests Rejected

Greater than 0

Implement additional Web servers

See also

Capacity management and sizing overview for SharePoint Server 2013
Performance testing for SharePoint Server 2013
Capacity planning for SharePoint Server 2013
Monitor health in SharePoint 2013


Optimize performance for SharePoint Server 2013
See also

Updated: June 4, 2013

Learn about the techniques and tools available for optimizing SharePoint Server 2013 performance.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

This article provides information about techniques and tools for optimizing SharePoint Server 2013 performance.

Optimizing performance

There are many technologies and techniques available to optimize SharePoint Server 2013 performance. In a given environment, some or all of these techniques may apply.

Using BranchCache to optimize WAN performance

BranchCache is a feature of the Windows 7, Windows 8, Windows Server 2008 R2 and Windows Server 2012 operating systems that caches content from file and web servers on a wide area network (WAN) on computers at a local branch office. In a geographically distributed SharePoint Server 2013 environment, BranchCache can optimize WAN performance by caching large files that users download from SharePoint Server 2013.

After you install and configure BranchCache, a computer on the branch office network caches files that branch office users download from SharePoint Server 2013. BranchCache also stores file version metadata when the following Office 2013 applications access files:

  • SkyDrive Pro

  • OneNote

  • Word

  • Excel

  • Visio

  • PowerPoint

Every time a branch office user requests a cached file from SharePoint Server 2013, BranchCache checks to see if a more recent file exists on the server. If not, BranchCache will serve the cached version of the file.

For more information about BranchCache, see the following resources:

  • BranchCache Resource Center on TechNet

  • BranchCache Overview for Windows 8 and Windows Server 2012

  • BranchCache Overview for Windows 7 and Windows Server 2008 R2

  • BranchCache Deployment Guide for Windows 8 and Windows Server 2012

  • BranchCache Deployment Guide for Windows 7 and Windows Server 2008 R2

Configuring BranchCache for use with SharePoint Server 2013

This section describes how to install and configure BranchCache for use with SharePoint Server 2013.

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • You must be logged in as a farm administrator to enable BranchCache for SharePoint Server 2013.

    • You must be logged in as a domain administrator or local computer administrator to install and enable BranchCache on a Windows 7 or Windows Server computer.

  2. Deploy BranchCache on each web server in your SharePoint Server 2013 farm by following the instructions in the following topics:

    • For Windows Server 2012, see Install Content Servers that Use the BranchCache Feature.

    • For Windows Server 2008 R2, see Install content servers that use the BranchCache feature.

  3. Deploy BranchCache in your branch office network environment by following the instructions in the following topics:

    • For Windows 8 and Windows Server 2012, see the BranchCache Deployment Guide.

    • For Windows 7 and Windows Server 2008 R2, see the BranchCache Deployment Guide

  4. If you have deployed BranchCache in Distributed mode, and the AuthNoEncap policy is enabled in your environment, you must install the update described in Performance issue when you enable the AuthNoEncap policy to handle large payloads in a network environment in Windows 7 or in Windows Server 2008 R2 on all Windows 7 client computers.

After you have installed and configured BranchCache in the operating system of each web server in your SharePoint Server 2013 farm and each computer in your branch office, content in SharePoint Server 2013 will be cached automatically, and no further configuration is required.

See also

Plan for SharePoint 2013
Plan for performance and capacity management in SharePoint Server 2013

Change History

Date | Description
June 04, 2013 | Revised for updated guidance and references.
October 23, 2012 | Initial publication


Performance and capacity test results and recommendations (SharePoint Server 2013)
See also

Updated: July 23, 2013

Summary: Learn about performance characteristics of features in SharePoint Server 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

The following articles describe the tested performance and capacity characteristics and effect of specific scenarios and feature sets in SharePoint Server 2013. These articles include information about the characteristics of the scenario or feature and how it was tested by Microsoft, including:

  • Test farm characteristics, including:

    • Specifications for hardware, topology, and configuration

    • The workload and dataset used to generate test loads

  • Test results and analysis that demonstrate throughput, latency and hardware demand under load at specific scale points, and discuss important trends and considerations

  • Recommendations for how to optimize performance characteristics, scale your environment, and manage bottlenecks

  • Troubleshooting performance and scalability when specific conditions are observed

You can use the information in these articles to understand the performance and capacity characteristics of a specific scenario or feature under both normal and peak loads, and how performance trends for a scenario or feature change when farm servers are scaled out or hardware resources are added to existing servers. The articles can also help you estimate an appropriate starting point for your planned architecture, and to determine what factors are important to consider when you are planning for the resources your farm will have to maintain acceptable levels of performance under peak load.

It is important to realize that the test results that appear in these articles were produced in test labs that use workloads, datasets and architectures that are designed to emulate a production environment under highly controlled conditions. While great care is exercised in designing these tests, the performance characteristics of a test lab are never equivalent to the behavior of a production environment. These test results are not intended to represent the performance and capacity characteristics of a production farm, but instead to demonstrate observed trends in throughput, latency and hardware demand, and to provide an analysis of the observed data that can help you make capacity planning and management decisions in your own farm.

Before reading these articles, make sure that you understand the key concepts behind capacity management in SharePoint Server 2013. For more information, see Capacity management and sizing for SharePoint Server 2013.

The following table describes the available articles. This list will be updated as new articles become available.

Subject Description

Enterprise intranet collaboration scenario

This scenario-specific article describes guidance on performance and capacity planning for an enterprise intranet collaboration solution.

This article contains performance test results, analysis and recommendations based on testing of a SharePoint Server 2013 environment that was scaled out using virtual web servers that run on Hyper-V hosts. The article also includes comparison testing of SharePoint Server 2013 and SharePoint Server 2010 on both physical and virtual web servers.

View the article at Estimate performance and capacity requirements for enterprise intranet collaboration environments (SharePoint Server 2013).

Web Content Management

This article contains capacity and performance data to help plan the number of computers to use and the types of computers that are required to publish content and manage web content in SharePoint Server 2013.

View the article at Estimate capacity and performance for Web Content Management (SharePoint Server 2013).

Managed Metadata Service

This article discusses information and recommendations related to sizing and performance optimization of the Managed Metadata Service in SharePoint Server 2013. It also gives best practices for how to configure this service application and how to structure the service application databases for optimal performance.

View the article at Estimate capacity and performance for Managed Metadata Service (SharePoint Server 2013).

Video content

This article explains how to plan video content types and video player pages using the Rich Media Web Part to provide better user experiences when you play videos in SharePoint Server 2013.

View the article at Estimate capacity and performance for video content management in SharePoint Server 2013.

Compliance and eDiscovery

This article explains how compliance, eDiscovery, and large-scale document repositories can affect capacity and performance in SharePoint Server 2013.

View the article at Estimate capacity and performance for compliance and eDiscovery for SharePoint Server 2013.

Social content

This article explains how to determine the number and types of computers that you need for a capacity plan for a My Site and social computing portal based on SharePoint Server 2013.

View the article at Estimate performance and capacity requirements for social environments (SharePoint Server 2013).

Divisional collaboration

This article explains how to use test results and recommendations to estimate performance and capacity requirements for a divisional collaboration environment for SharePoint Server 2013.

View the article at Estimate performance and capacity requirements for divisional collaboration environments (SharePoint Server 2013).

See also

Capacity management and sizing for SharePoint Server 2013
Software boundaries and limits for SharePoint 2013

Change History

Date | Description
July 23, 2013 | Added link to Estimate performance and capacity requirements for divisional collaboration environments (SharePoint Server 2013).
June 11, 2013 | Added link to Estimate performance and capacity requirements for social environments (SharePoint Server 2013).
April 16, 2013 | Initial publication


Estimate performance and capacity requirements for enterprise intranet collaboration environments (SharePoint Server 2013)
See also

Published: April 2, 2013

Summary: Use test results and recommendations in this article to estimate performance and capacity requirements for an enterprise intranet collaboration solution for SharePoint Server 2013.

Applies to: SharePoint Server 2013

This article contains guidance on performance and capacity planning for an enterprise intranet collaboration solution that is based on SharePoint Server 2013. It includes the following:

  • Lab environment specifications, such as hardware, farm topology and configuration

  • The test farm workload and dataset that was used to generate test load

  • Test results and analysis that demonstrate and explain trends in throughput, latency and hardware demand under load at specific scale points.

Use the information in this article to understand the characteristics of the scenario under both normal and peak loads, and how performance trends change when farm servers are scaled out. This article can also help you estimate an appropriate starting point for your planned architecture, and the factors that are important to consider when you plan for the resources your farm will need to maintain acceptable levels of performance under peak load.

In this article:

  • Introduction to this environment

  • Glossary

  • Overview

  • Specifications

  • Results and analysis

Introduction to this environment

This article provides guidance about how to scale out servers in a SharePoint Server 2013 enterprise intranet collaboration solution. Capacity planning informs decisions about hardware to purchase and system configurations that optimize your solution.

Individual SharePoint Server 2013 farms are unique, and each farm has different requirements that depend on hardware, user behavior, the configuration of installed features, and many other factors. Therefore, supplement this guidance with additional testing on your own hardware in your own environment. If your planned design and workload resembles the environment described in this article, you can use this article to draw conclusions about how to scale your environment.

Test results that appear in this article were produced in a test lab, using a workload, dataset, and architecture emulate a production environment under highly controlled conditions. While great care was exercised in designing these tests, the performance characteristics of a test lab are never the same as the behavior of a production environment. These test results do not represent the performance and capacity characteristics of a production farm. Instead, the test results demonstrate observed trends in throughput, latency, and hardware demand, and provide analysis of the observed data that can help you make decisions about how to plan capacity and manage your own farm.

This article includes the following:

  • Specifications, which include hardware, topology, and configuration

  • The workload, which includes an analysis of the demand on the farm, the number of users, and usage characteristics

  • The dataset, such as database sizes and content types

  • Test results and analysis for scaling out web servers

  • Comparison between SharePoint Server 2010 and SharePoint Server 2013 throughput, latency, and web server performance on both physical servers and virtual machines

Before you read this article, read the following articles to make sure that you understand the key concepts behind capacity management in SharePoint Server 2013.

  • Capacity management and sizing for SharePoint Server 2013

  • Software boundaries and limits for SharePoint 2013

These articles provide the following information:

  • The recommended approach to capacity management

  • How to make effective use of the information in this article

  • Definitions of terms that are used throughout this article

Glossary

Here are some specialized terms that you will encounter in this article.

  • RPS: Requests per second, or the number of requests a that a farm or server receives in one second. This is a common measurement of server and farm load.

    Note that requests differ from page loads. A page contains several components, each of which creates one or more requests when a browser loads the page. Therefore, one page load creates several requests. Typically, authentication checks and events that use insignificant resources are not counted in RPS measurements.

  • Green Zone: Green Zone represents a defined set of load characteristics under normal operation conditions, up to expected daily peak loads. A farm that operates in this range should be able to sustain response times and latency that are within acceptable parameters.

    This is the state at which the server can maintain the following set of criteria:

    • The server-side latency for at least 75% of the requests is less than 1 second.

    • All farm servers maintain an average CPU utilization of less than 60%.

      Note:

      Because this lab environment did not have an active search crawl running, the database server was kept at approximately 50% CPU utilization or lower to reserve 10% for the search crawl load. This assumes SQL Server Resource Governor is used in production to limit Search crawl load to 10% CPU.

    • Failure rate is less than 0.01%.

  • Red Zone (Max): Red Zone represents a defined set of load characteristics under peak operation conditions. At Red Zone, the farm experiences very high transient resource demands that it can sustain only for limited periods before failures and other performance and reliability issues occur.

    This is the state at which the server can maintain the following set of criteria for a limited duration:

    • HTTP request throttling feature is enabled, but no 503 errors (Server Busy) are returned.

    • Failure rate is less than 0. 1%.

    • The server-side latency is less than 3 seconds for at least 75% of the requests.

    • All farm servers (excluding database servers) maintain an average CPU utilization of less than approximately 90%.

    • Database server average CPU utilization is less than approximately 50%, which allows for ample overhead to be reserved for the Search crawl load.

  • AxBxC (Graph notation): This is the number of web servers, application servers, and database servers respectively in a farm. For example, 10x1x1 means that this environment has 10 web servers, 1 application server, and 1 database server.

  • MDF and LDF: SQL Server physical files. For more information, see Files and Filegroups Architecture.

Overview

This section provides an overview of our scaling approach and test methodology.

Scaling approach

This section describes the approach that we took to scale this lab environment. This approach will enable you to find the best configuration for your workload:

  1. We scaled out the web servers until four web servers were in use. Each server runs the Distributed Cache Service.

  2. We added a dedicated server that runs the Distributed Cache Service.

  3. We disabled the Distributed Cache Service on the web servers.

  4. We scaled out additional web servers to the maximum for the scope of testing.

  5. We conducted additional testing to compare the performance characteristics of SharePoint Server 2013 and SharePoint Server 2010.

Methodology and test notes

Because this article provides results from a test lab environment, we could control certain factors to show specific aspects of performance for this workload. In addition, certain elements of the production environment, which are in the following list, were left out of the lab environment to simplify the overhead of testing.

Note:

We recommend that you include these elements in production environments.

  • Between test runs, we modified only one variable at a time to make it easy to compare results between test runs.

  • The database servers were not part of a cluster because redundancy was not necessary for the purposes of these tests.

  • Search crawl was not running during the tests. Of course, it might be running in a production environment. To take this into account, we lowered the SQL Server CPU utilization in our definitions of 'Green Zone' and 'Red Zone' to accommodate the resources that a running search crawl would normally consume during testing.

Specifications

This section provides details about the hardware, software, topology, and configuration of the lab environment.

Hardware

The following sections describe the hardware that was used in this lab environment.

Important:

Note that all web servers and application servers in the test lab were virtualized by using Hyper-V hosts. Database servers were not virtualized. The physical host hardware and virtual machine virtual hardware are detailed separately below.

Hyper-V Hosts

A total of six identically configured Hyper-V hosts were used for testing. Each host runs one to two virtual machines.

Host Hardware | Value
Processor(s) | 2 quad-core 2.49 GHz processors
RAM | 32 GB
Operating System | Windows Server 2008 R2 SP1
Number of network adapters | 2
Network adapter speed | 1 Gigabit

Virtual web servers and application servers

The farm has from one to 10 virtual web servers. An additional dedicated virtual server runs the Distributed Cache Service.

Note:

In a production environment, dedicated servers that run the Distributed Cache Service would typically be deployed in a highly available configuration. For test purposes, we used a single dedicated server for Distributed Cache because high availability was not a critical factor.

VM Hardware | WFE1-10 and DC1
Processors | 4 virtual processors
RAM | 12 GB
Operating system | Windows Server 2008 R2 SP1
Size of the SharePoint drive | 100 GB
Number of network adapters | 2
Network adapter speed | 10 Gigabit (inter-host traffic limited to host NIC speed)
Authentication | Windows NTLM
Load balancer type | F5 Big IP
Services running locally | WFE 1-10: Basic Federated Services. This includes the following: SharePoint Timer Service, Trace Service, Word Automation Services, Excel Services and Microsoft SharePoint Foundation Sandboxed Code Service. DC1: Distributed Cache Service.

Database Servers

One physical database server runs the default SQL Server instance that has the SharePoint databases. The logging database is not tracked in this article.

Note:

If you enable usage reporting, we recommend that you store the logging database on a separate Logical Unit Number (LUN). Large deployments and some medium deployments might require a dedicated logging database server to accommodate the processor demand of a high log volume.

In this lab environment, logging was constrained, and the logging database was stored in a separate instance of SQL Server.

Database Server - Default Instance | SPSQL
Processors | 4 quad-core 2.4 GHz processors
RAM | 32 GB
Operating system | Windows Server 2008 R2 SP1
Storage and geometry | Direct Attached Storage (DAS) 1 x System volume (RAID0, 1 spindle, 300GB) 2 x Content Data volumes (RAID0, 4 spindles, 450GB each) 2 x Content Log volumes (RAID0, 2 spindles, 450GB each) 1 x Temp Data volume (RAID0, 2 spindles, 300GB each) 1 x Temp Log volume (RAID0, 2 spindles, 300GB each)
Number of network adapters | 1
Network adapter speed | 1 Gigabit
Authentication | Windows NTLM
Software version | SQL Server 2008 R2

Topology

The following diagram shows the topology in this lab environment.

This graph shows the lab topology for performance and capacity testing of the enterprise intranet collaboration scenario.

Configuration

To allow for optimal test performance and clear relationships between test parameters and results, the following significant configuration changes were made in this lab environment.

Setting Value Notes

Site collection

179

The site collections in the test environment use default settings and Windows claims authentication.

Blob caching

On

The default is Off. If you enable Blob caching, you improve server efficiency by reducing calls to the database server for static page resources that may be frequently requested.

Max degree of parallelism (MAXDOP)

1

This parameter is set on the SQL Server instance or instances that contain SharePoint Server 2013 content databases. The default value is 0, which enables SQL Server to determine the maximum degree of parallelism. SharePoint Server 2013 requires MAXDOP to be set to 1 for SQL Server instances that contain SharePoint Server 2013 databases.

For more information about how to configure the MAXDOP setting for SQL Server 2008 R2, see max degree of parallelism Option.

For more information about how to configure the MAXDOP setting for SQL Server 2012, see Configure the max degree of parallelism Server Configuration Option.

Workload

This section explains the lab tests that are run against SharePoint Server 2013. The details of the tests are typical of an enterprise collaboration environment.

This graphic displays the breakdown of the performance test workload into operation categories.

Dataset

The dataset for the lab environment in this article, which represents a typical enterprise collaboration environment, contains various site collections, sites, lists, libraries, file types and sizes.

Dataset Characteristics | Value
Database size (combined) | 174 GB
MDF size | 154 GB
LDF size | 20 GB
BLOB size | 152 GB
Number of content databases | 2
Number of site collections | 179
Number of web applications | 1
Number of sites | 1,471

Results and analysis

The following results are ordered based on the scaling approach that is described in the Overview section of this article.

Web server scale out

This section describes the test results that were obtained when we scaled out the number of web servers in this lab environment.

Test methodology

  • Add web servers that use the same hardware specifications, and run the test again without changes to the farm or test parameters.

  • Measure RPS, latency, and resource utilization on each server in the test farm.

Analysis

In our testing, we found the following:

  • The environment scaled to ten web servers per database server. The increase in throughput was fairly linear.

  • Even up to the maximum tested scale of ten web servers, the addition of more database servers did not increase throughput. The bottleneck was generally confined to web server resources.

  • The average latency at green zone was almost constant throughout the whole test. The number of web servers and throughput did not affect green zone latency. Red Zone latency data shows an expected trend line. Latency is very high at a single web server. A curve between 2 and 10 web servers remains comfortably within Red Zone criteria.

    Note:

    Latency may be mildly affected when you move the Distributed Cache service from a farm's web servers to a server that is dedicated to the Distributed Cache. This may occur because Distributed Cache traffic, which was previously internal to each web server, begins traversing the network. Test scale-out performance in your own environment to determine whether this tradeoff is significant. Note that latency in our test environment increased mildly when the Distributed Cache service was migrated to a dedicated server. Latency decreased with each added web server as the nominal added latency was offset by the decreased processing and memory load on the web servers.

    For more information about Distributed Cache capacity planning, see Plan for feeds and the Distributed Cache service in SharePoint Server 2013.

  • When performance testing was conducted for SharePoint Server 2010, the database server became a bottleneck at maximum throughput using four web servers. Because of improvements in caching and database usage characteristics in SharePoint Server 2013, the average load on the database server layer is significantly lower than it was in SharePoint Server 2010, and it was not necessary to scale out the database servers during testing.

    For more information about SharePoint Server 2010 test results for this scenario, see Enterprise intranet collaboration environment lab study (SharePoint Server 2010)

  • Performance gains when you add virtual web servers depend partly on host hardware resources and on the resource usage of other virtual computers that are running on the same host. Capacity planning for virtual servers requires additional planning and management strategies specific to virtualization.

    For more information on Hyper-V performance and capacity planning, see Hyper-V virtualization requirements for SharePoint 2013 and Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment.

Note:

The conclusions described in this section are specific to the hardware that comprises the environment. The environment might have achieved the same throughput by using more but less powerful Hyper-V host servers, or fewer but more powerful Hyper-V host servers. An increase of hardware resources on the database server would not materially affect the results.

Results, graphs and charts

In the following graphs, the x axis shows the change in the number of web servers in the farm. The scale starts with one virtual web server and one physical database server (1x1). The maximum is ten virtual web servers, one dedicated virtual Distributed Cache server (added at four web servers) and one physical database server (10x1x1).

Note:

The graphs in this section represent the average values for each data point over the duration of the test. All graphs include the RPS baseline for both Green and Red zones to show the relationship between RPS and factors such as latency, server resource utilization, and SQL Server disk usage.

1. RPS

The following graph shows how scaling out affects the RPS baseline.

This graph shows the RPS baseline for both Green and Red zones.

2. Latency

The following graph shows how scaling out affects latency. Note that Green Zone latency remains mostly flat, while Red Zone latency shows moderate variations that are well within acceptable limits.

This graph shows the relationship between RPS and latency.

3. Web server processor and memory utilization

The following graph shows how scaling out affects average processor and memory utilization on the web servers. Note that Green Zone processor utilization remains fairly constant as RPS increases, while average memory utilization increases slightly.

The Red Zone processor utilization trend is downward, which reflects the fact that the average demand of the web server's processor at maximum load is gradually reduced as the number of servers is increased.

This graph shows the relationship between RPS and utilization of web server processor and memory.

4. SQL Server I/O operations per second (IOPs) and processor utilization

The following graphs show how average disk IOPs (both total and reads/writes) and processor utilization values change as the number of web servers is scaled out. The following performance counters were used to measure IOPs values:

  • PhysicalDisk: Disk Reads / sec

  • PhysicalDisk: Disk Writes / sec

The values of each counter over the duration of the test are averaged, and then added together to produce total IOPs.

Note:

Data for SQL Server memory utilization was not available and is not in this graph.

Important:

These IOPs test results are not representative of a production environment because our dataset was much smaller than that of a production farm. It was therefore possible for a larger percentage of the data to be cached at the web servers than would be possible in a production environment. The IOPs results in this section are therefore calculated averages that are based on available test data and are expected to be generally lower than IOPs in a production environment. Thorough testing of your own farm in a pilot environment may produce different results.

Note that in the graphs in this section, both IOPs and database server processor utilization show a drop at both 9 and 10 front-end web servers, while RPS continues to increase. This variation is also reflected in web server processor utilization as shown in the previous graph.

This shows that the scale of the farm has reached a point at which maximum pressure on the farm server resources has been achieved using the baseline load and dataset. A lower average utilization of server resources is required to support the load on the farm.

It is possible to extrapolate the following from this trend:

  • Had the test load been increased at the ninth web server scale point, greater RPS could have been achieved while maintaining a flat curve in server resource utilization.

  • Had the number of web servers been scaled out further while maintaining the same test load, RPS would have continued to increase while pressure on server resources would have continued a downward trend.

  1. SQL Server Total IOPs

    The following graph shows how scaling out affects total IOPs.

    This graph shows the relationship between RPS and SQL Server total IOPs.

  2. SQL Server IOPs broken down into read and write operations

    The following graph shows how scaling out affects IOPs, broken down into reads per second and writes per second.

    This graph shows the relationship between RPS and SQL Server IOPs, broken down into read and write operations.

  3. SQL Server processor utilization

    The following graph shows how scaling out affects SQL Server processor utilization.

    This graph shows the relationship between RPS and SQL Server processor utilization.

Comparing SharePoint Server 2013 and SharePoint Server 2010

This section provides information about how performance for this workload varied between SharePoint Server 2013 and SharePoint Server 2010.

Workload

To compare SharePoint Server 2013 with SharePoint Server 2010, we used a different test mix from the one outlined in the Specifications section. This was necessary because some SharePoint Server 2013 features (such as the Distributed Cache Service) and operations were not available in SharePoint Server 2010.

Test methodology

To test performance in the two environments, we used the following methodology:

  1. We created a SharePoint Server 2010 environment.

  2. We tested the SharePoint Server 2010 environment by using the workload outlined earlier in this section.

  3. We upgraded the content databases to SharePoint Server 2013 without changing the clients consuming the environment.

This upgraded environment was then tested again on the upgraded servers that host SharePoint Server 2013 by using the same test mix, which includes only SharePoint Server 2010 operations.

  • We tested two environments for comparison. One environment used physical server hardware, and the other environment used virtual machines to run the web servers on a Hyper-V host. In both cases, the database server ran on a physical server.

  • We did not modify the dataset after the content database upgrade for the SharePoint Server 2013 tests.

  • The test mix for SharePoint Server 2010 excluded new SharePoint Server 2013-specific operations, and resembled the enterprise intranet collaboration solution that was tested and described earlier in this article.

The goal of the testing was to apply similar loads against both SharePoint Server 2013 and SharePoint Server 2010 farms by using the same workload and dataset, and then show the differences in throughput, latency and server resource consumption. Test methodologies and goals differed between physical and virtual web server tests:

  • The goal of physical server testing was to compare how SharePoint Server 2013 and SharePoint Server 2010 farms performed when scaled out under load. The web servers in this test were scaled out from two to five web servers.

  • The goal of virtual server testing was to compare how SharePoint Server 2013 and SharePoint Server 2010 farms with four web servers performed at both Green and Red Zone user loads. No web server scale-out tests were conducted.

Analysis

  • In general, SharePoint Server 2013 performed better than SharePoint Server 2010 when scaled out to five web servers, but SharePoint Server 2010 results were better at two web servers. Testing against the upgraded SharePoint Server 2013 server farm did not involve post-upgrade optimizations or take advantage of SharePoint Server 2013 performance improvements such as the Distributed Cache Service or Request Manager. SharePoint Server 2013 test results, therefore, are significantly different from results in a real-world environment.

  • The relationship between data trends in the graphs in this section show how the SharePoint Server 2013 resource management model prioritizes the use of processor resources over disk IOPs.

  • At Green Zone, SharePoint Server 2013 outperforms SharePoint Server 2010 at five web servers, with more than 10% improvement in RPS and slightly lower latency. However, at two web servers, SharePoint Server 2013 produces lower RPS and a slight improvement in latency over SharePoint Server 2010.

  • At Red Zone, SharePoint Server 2013 achieves approximately 12% greater throughput compared to SharePoint Server 2010 at five web servers. At two web servers, the throughput of SharePoint Server 2010 was approximately 30% greater. SharePoint Server 2013 showed a moderate improvement in latency over SharePoint Server 2010 at five web servers.

  • In virtual web server testing, both SharePoint Server 2013 and SharePoint Server 2010 results are similar at Green Zone. SharePoint Server 2013 shows significant improvement over SharePoint Server 2010 in both throughput and latency at Red Zone.

Results, graphs and charts

The tests that produced the results in the graphs in this section were run against both physical and virtual web servers as indicated. In all tests, a single physical database server running SQL Server 2008 R2 with SP1 was used.

  1. RPS and latency

    The following graph shows the difference in throughput and latency between SharePoint Server 2013 and SharePoint Server 2010 with both two and five physical web servers at Green Zone. SharePoint Server 2010 has higher RPS at two web servers and higher latency. At five web servers, SharePoint Server 2013 shows both increased RPS and lower latency.

    This graph compares Green Zone RPS and latency between SharePoint Server 2013 and SharePoint Server 2010.

    The following graph shows the difference in web server processor utilization with both two and five physical web servers at Red Zone. SharePoint Server 2013 outperforms SharePoint Server 2010 in both RPS and latency at 5 web servers, but not at two web servers.

    This graph compares Red Zone RPS and latency between SharePoint Server 2013 and SharePoint Server 2010.

  2. RPS and server resource utilization

    The following graph shows the difference in web and database server processor utilization with two and five physical web servers at Green Zone load. Note that SharePoint Server 2013 achieves greater throughput at five web servers by more effectively taking advantage of available server resources.

    This graph compares Green Zone web server processor utilization between SharePoint Server 2013 and SharePoint Server 2010.

    The following graph shows the difference in web and database server processor utilization with two and five physical web servers at Red Zone load. Again, SharePoint Server 2013 achieves greater throughput at five web servers, but not at two web servers.

    This graph compares Red Zone web server processor utilization between SharePoint Server 2013 and SharePoint Server 2010.

  3. RPS and IOPs

    The following graph shows the difference in IOPs with two and five physical web servers at Green Zone. Note that at Green Zone, SharePoint Server 2013 IOPs increases between two and five web servers, while SharePoint Server 2010 IOPs decreases. At the same time, the rate of increase in SharePoint Server 2013 RPS is significantly greater than in SharePoint Server 2010. This difference in trends shows how SharePoint Server 2013 manages server resources differently in a larger farm to achieve greater throughput.

    This graph compares Green Zone IOPs between SharePoint Server 2013 and SharePoint Server 2010.

    The following graph shows the difference in IOPs with two and five physical web servers at Red Zone load. When these results are contrasted with the Red Zone graph in the earlier RPS and server resource utilization section, you can observe that the SharePoint Server 2013 resource management model prioritizes the use of processor resources over SQL Server disk IOPs.

    This graph compares Red Zone IOPs between SharePoint Server 2013 and SharePoint Server 2010.

  4. Virtual web server RPS, latency and IOPs

    Virtual server comparison testing was conducted against 4 virtual web servers and one physical database server.

    The following graph shows the difference in throughput and latency with four virtual web servers. At Green Zone load, both SharePoint Server 2013 and SharePoint Server 2010 results are similar, while SharePoint Server 2013 shows significant improvement over SharePoint Server 2010 in both throughput and latency at Red Zone.

    This graph compares virtual server RPS and latency between SharePoint Server 2013 and SharePoint Server 2010.

    The following graph shows the difference in database IOPs with four virtual web servers. SharePoint Server 2013 shows a significant improvement in database IOPs performance at both Green and Red Zone loads.

    This graph compares virtual server IOPs between SharePoint Server 2013 and SharePoint Server 2010.

See also

Plan for performance and capacity management in SharePoint Server 2013
Performance and capacity test results and recommendations (SharePoint Server 2013)


Estimate capacity and performance for Web Content Management (SharePoint Server 2013)
See also

Published: April 9, 2013

Summary: Learn how to determine the number and types of computers that you need to publish content and manage web content in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Enterprises often use SharePoint Server 2013 to publish content that anonymous users access on an Internet site or that authenticated users access on an intranet site. This article contains capacity and performance data to help plan the number of computers to use and the types of computers that are required to publish content and manage web content in SharePoint Server 2013.

In this article:

  • Introduction

  • Prerequisite information

  • Cross-site publishing using managed navigation

  • Author-in-place publishing

SharePoint publishing includes different types of publishing sites and associated methods that are available for each site. The publishing features of SharePoint Server 2013are intended to help create branded Internet, intranet, and extranet sites. For more information about SharePoint Server 2013 publishing, see Overview of publishing to Internet, intranet, and extranet sites in SharePoint Server 2013.

Introduction

This article discusses the following scenarios:

  • Internet presence site

    Provides information to customers, partners, investors, and potential employees. This type of site lets anonymous Internet users find information about a corporation. Typically, these sites are branded and the company tightly controls the content.

  • Internet business site

    Promotes products and services that a company offers to customers. These sites can show a catalog of products that the company offers.

  • Intranet site

    A company publishes this site internally inside an organization. These sites share information for authenticated users and companies either tightly manage the site to restrict access or open to all jnternal users.

  • Extranet site

    Provides access to targeted content to remote employees, partners, and customers. These sites can provide access to knowledge bases that use authored content tagged with metadata to categorize articles. Users can search or browse for specific information such as troubleshooting and support articles.

Cross-Site Collection Publishing and the Content Search Web Part enable content reuse across site collections in these scenarios. These features and functionality affect how you plan for capacity. For more information, see Overview of cross-site publishing in SharePoint Server 2013.

Note:

Cross-Site Collection Publishing is known as cross-site publishing in this article.

Managed navigation in SharePoint Server 2013 provides taxonomy-driven navigation for a publishing site. For more information, see Overview of managed navigation in SharePoint Server 2013.

The capacity and performance data in this article contain two parts. The first part is the new cross-site publishing method and managed navigation. The second part uses the author-in-place model.

Note:

The scenarios that are addressed in this article can be achieved by both cross-site publishing and author-in-place sites. The cross-site publishing and managed navigation features do not depend on one another and can be used independently.

The following two key metrics are addressed in the models that are used in this article:

  • Throughput

    The number of page views per second that the site can sustain

  • Server Response Time

    The time that is required for the server to process a request, affecting the time it takes for a user to view the page. The server response times that we provide in this document are the 95th and 50th percentile values. These values mean that 95 percent and 50 percent of requests are faster than the value that is provided, respectively. We measure these values by using the "Duration" recorded in the SharePoint Usage database for a given request.

  • Content freshness

    The time that is required for an updated item to be reflected in search results is a good metric to consider when you work with cross-site publishing scenarios.

The scenarios in this article use the following two states:

  • Green Zone

    The servers are under 60 percent utilization. This should be the target for most of the time that the servers are running.

  • Red Zone

    The servers are close to full utilization. This can be considered a state where the SharePoint site is under more load than usual. In the Red Zone, the server response time values start to increase as the server tries to meet the demand of incoming requests.

Prerequisite information

Before you read this article, make sure that you understand the key concepts behind SharePoint Server 2013 capacity management. The following articles help you learn about the recommended approach to capacity management and provide context to help you understand how to make effective use of the information in this article.

Note that some other new features that affect publishing scenarios functionally do not appear in this article. These scenarios include device channels, SEO optimization, display templates and query rules. Additionally, the functionality and configuration of a cross-site publishing site is not described in detail in this article. For more information, see Plan for cross-site publishing in SharePoint Server 2013 and Configure web content management solutions in SharePoint Server 2013.

For more information about capacity and performance to help understand the data in this article, see Plan for performance and capacity management in SharePoint Server 2013.

Cross-site publishing using managed navigation

This section provides our test data for two areas: cross-site publishing with anonymous users and author-in-place publishing.

Cross-site publishing with Anonymous users

Test results in this section are based on a basic cross-site publishing site model to provide capacity planning guidance. When you plan a SharePoint deployment for anonymous users to access a web site, use this guidance and adjust your deployment specifications accordingly.

The test case in our tests uses the cross-site publishing feature. This scenario provides content in multiple site collections that are marked as catalogs, and then crawled by the SharePoint Search Service application. Web Parts that use search technology, for example the Content Search Web Part, and the Catalog-Item Reuse Web Part, display content on pages in another site. For more information, see Overview of cross-site publishing in SharePoint Server 2013.

We used the following characteristics in the model site, which we built to test cross-site publishing:

  • Publishing web site that has approximately 5 million pages or items.

  • The items are associated with about 1,000 categories.

  • The content is located in other site collections in one or more catalogs.

  • The web site uses managed navigation that is linked to the categories that the items are associated with.

  • For the baseline deployment topology described later in this list, the web site receives up to 80 page views per second on average. Peak periods reach up to 100 page views per second. To scale this throughput number up, add computes to the topology. To scale this throughput number down, remove computers from the topology.

  • The Search crawler runs with continuous crawls for a 1-minute interval with five updates per second to the catalog.

  • The web site has the following page and traffic patterns:

    • Home page that has three Content Search Web Parts and a Refinement Panel Web Part (receives 15 percent of the traffic).

    • Category pages that have three Content Search Web Parts, one Taxonomy Refinement Panel Web Part, and one Refinement Panel Web Part receive 45 percent of the traffic.

    • Catalog Item pages that have Catalog-Item Reuse Web Part and two Content Search Web Parts receive 40 percent of the traffic.

  • Each Content Search and Catalog-Item Reuse Web Part issues a synchronous query.

  • The catalog item pages do not use the Anonymous Search Results Cache because they receive a small amount of traffic.

  • The farm has the binary large object (BLOB) cache turned on for the computers that are run as the front-end web servers.

The server topology that we used to test this scenario is in the following diagram:

Figure 1: Test lab server topology

Diagram of the test server topology, 2 computers host SQL and SharePoint Servers; 1 computer hosts Search crawler and content processing (CPC) role; 3 computers host Search index with query processing as front-end web servers.

  • one computer that hosts SQL Server with all of the databases that SharePoint uses

  • one computer that hosts SharePoint service applications, distributed cache service, search analytics processing, and search administration roles

  • one computer that hosts the search crawler and content processing (CPC) roles

  • three computers that host search index nodes with query processing and serve as front-end web servers

Note:

The computers in this test are physical computers that run Windows Server 2008 R2. Refer to the Search capacity planning and Capacity planning for SharePoint Server 2013 for recommendations about how to use virtual machines and Windows Server 2012.

Important:

The configuration for our test lab topology is optimized for search-driven publishing scenarios. This configuration is different from collaboration types of SharePoint deployments. For example, our configuration uses the front-end web servers as search index servers to get the best performance.

In our test lab topology we learned that the computer that hosts the application server was underutilized. As a result, we put the Distributed Cache Service on this application server instead of on a dedicated server. You may decide to host the Distributed Cache Service on a dedicated server in your environment. For best performance we do not recommend that you host the Distributed Cache Service on a front-end web server that has the search index server role.

Test lab reports

We used the topology in figure 1 for our test lab with physical computers and a Visual Studio Team System (VSTS) load test. For more information, see Visual Studio Team System. Technical specifications for the test computers are in the following tables.

Note:

We did not use browser caching or dependent requests, such as images or JavaScript files in our VSTS tests. Depending on how you customize your publishing site, the amount of dependent requests that occur can vary considerably.

The pages that we used in our tests made almost 50 page load time 1 (PLT1) request types (empty browser cache) and about 3 requests for PLT2 request types (subsequent requests with results from the browser cache). Usually, SharePoint BLOB Cache serves requests for these items and will not alter our performance numbers significantly.

Server Components | Servers running SharePoint Server
Processors | Intel Xeon CPUs @2.27GHz (2 processors, 8 cores total, 16 threads total)
RAM | 24 GB
Operating system | Windows Server 2008 R2 Enterprise SP1, 64-bit
Size of the SharePoint drive | 200 GB on internal disk
Storage used for Search Index | 78 GB on an external disk array (2 x Dell PERC H700 SCSI)
Number of network adapters | 2
Network adapter speed | 1 gigabit
Authentication | None ─ Anonymous
Software version | SharePoint Server 2013

Server Components | Database servers
Processors | Intel Xeon CPUs L5520 @2.27GHz (2 processors, 8 cores total, 16 threads total
RAM | 24 GB
Operating system | Windows Server 2008 R2 Enterprise SP1, 64-bit
Disk Array | 2 x Dell H700 SCSI
Number of network adapters | 2
Network adapter speed | 1 gigabit
Authentication | NTLM
Software version | Microsoft SQL Server 2008 R2 SP1

Results from a 10 minute run are as follows:

Test Features | Green Zone | Red Zone
Number of VSTS users (simulating concurrent users): | 60 | 100
Server Response Time 50th percentile*: | 219 ms. | 302 ms.
Server Response Time 95th percentile*: | 412 ms. | 635 ms.
Page views per second: | 78 | 98

This is a cross-site publishing scenario that displays content from the search index. It may be interesting to examine the number of queries that the servers that host search queries serve, and the number of queries that the Anonymous Results Cache serves. In this model, the Anonymous Results Cache serves about 60 percent of the queries. The Anonymous Results Cache is discussed later in this article.

Test Features | Green Zone | Red Zone
Total queries per second: | 235 | 294
Queries served from Anonymous Results Cache: | 145 | 182
Queries served from Search: | 90 | 112

The values for the average CPU and peak memory usage for these computers while the tests were running are as follows:

Test Features | Green Zone | Red Zone
Average CPU (Search index nodes per front-end web server) | 59% | 80%
Average CPU (application server including Distributed Cache) | 8% | 9%
Average CPU (Search CPC nodes) | 5% | 5%
Average CPU (SQL Server) | Not measured | Not measured
Peak Memory usage (Search index nodes per front-end web server) | 7.5 GB | 7.5 GB
Peak memory usage (application server including Distributed Cache) | 10.1 GB | 10 GB
Peak memory usage (Search CPC nodes) | 6.5 GB | 6.5 GB

Note that the memory usage may differ somewhat because various timer jobs run on the server during normal usage. We found that the index/front-end web server nodes were using as much as 12 GB of memory after a two week test run with a sustained load.

How Search Web Parts display content on cross-site publishing pages

If a publishing page contains a Search Web Part, such as the Content Search Web Part, the browser starts to process the page before the search query is complete. This improves the perceived latency of the page. After the search query finishes, the complete results of the query are sent to the browser, and the connection to the browser is closed. Users might think that the search results are loaded asynchronously. However, the queries are still issued from the server while the page is being requested.

Note that there is a separate asynchronous mode for the Content Search Web Part, where the queries are issued from the browser after a page is loaded.

Effect of load changes on your cross-site publishing site

We varied the number of VSTS users (similar to the number of concurrent users who access the site) who were used in the load test. The following graph shows that the server response time increases as load increases, and there is some incremental increase in number of pages served per second. We recommend that the server response times are kept under 750 ms. to make sure that users have a responsive experience with the SharePoint deployment.

Figure 2: Chart showing throughput and server response times with different loads

Excel graph showing the server response time increases when loads are increased with some incremental increase of number of pages served per second.

Scaling out your cross-site publishing site

If the SharePoint deployment is expected to receive more or less traffic compared to the baseline case described earlier, you may want to change the number of computers that are running with the Index and front-end web server role on the farm to accommodate that traffic. The following graph shows the results for scaling out the same cross-site publishing site that has different load patterns and varying number of computers that are used as front-end web servers with Index nodes, starting with a single computer in the front-end web server role with Index nodes, and going up to six computers:

Figure 3: Scaling out your deployment

Excel graph showing results of scaling out a cross-site publishing site with different load patterns and varying number of computers used as front-end web servers with Index nodes and starting with a single computer and ending with 6 computers.

In each of the configurations, we adjusted the load to have server response times at similar values compared to the baseline in the previous section.

Note that as number of computers increased, the complexity of the topology starts to overtake the gains. Each additional computer has less throughput compared to computers that are already in the environment. These numbers are provided to show the pattern for scaling out. Actual performance will change depending on how the SharePoint deployment is built.

Guidelines to plan your site

The majority of our performance testing used the deployment that was described in the earlier sections. The guidelines in the following list are meant to help you make correct capacity planning decisions when your deployments differ from the ones we used in our test lab.

  • More items in the search index generally mean higher latency. Each index partition can contain up to 10 million items. Typical websites rarely have more than 10 million items to show. So they only need one partition as in the topology we described earlier. You can use more index partitions to either host more than 10 million items or to have more, smaller, and faster index partitions. If you plan to use multiple index partitions, refer to Scale search for performance and availability in SharePoint Server 2013 to correctly size your search topology.

  • Each control or Web Part that you add to a page (or page layout) will add some overhead to the server response time for the page.

  • Avoid using more than five synchronous Content Search Web Parts or Catalog-Item Reuse Web Parts on a page. While processing a request for a page, SharePoint Server 2013 executes as many as five queries in parallel and returns the results. If more than five queries are on a page, SharePoint Server 2013 executes the first five queries before it starts to execute the next set of five queries. If pages require more than five Content Search Web Parts or Catalog-Item Reuse Web Parts, you might run the additional Content Search Web Parts in asynchronous mode or use query rules and result blocks.

  • Content Search Web Parts and Catalog-Item Reuse Web Parts have an asynchronous mode. The query that is associated with the Web Part is executed after the browser loads the page. Use this mode for slow queries so that the rest of the page appears faster for users. Otherwise, we recommend that you use synchronous queries for best page load times.

  • A Refinement Panel Web Part that has many refiners increases the time to process a query. You can change the number of refiners to show for a managed property. For more information, see Configure refiners and faceted navigation in SharePoint Server 2013

  • If you use the Taxonomy Refinement Panel Web Part when you have a deep hierarchy of navigation nodes, the time to process a query increases. We do not recommend the use of the Taxonomy Refinement Panel Web Part on a page that has more than 200 navigation nodes under it. The large number of navigation nodes may cause slow server response times and decrease throughput.

  • If you must design a SharePoint deployment for high availability, you must add the following:

    • An additional computer that runs with the service applications in distributed cache roles in case the existing computer is not available

    • Additional computers to sustain the load if one or more of the front-end web server computers with Index nodes are not available

    • An additional computer in the CPC roles to make sure updates are still reflected in your site when the computer that has the CPC role is not available

    • A SQL Server topology that continues to serve database queries if one of the database servers is not available

Search crawl speed and content freshness

In our testing, we also conducted tests for the process that updates the catalog content that was being published. We then observed the amount of time that elapsed before an updated item appeared in the publishing site. In our experiments, we made five updates per second to the catalog and set the continuous crawls on the catalog to a one minute interval. We observed that the average time for the changes to appear in the publishing site were about two minutes. The minimum time was just under a minute and the maximum time was three minutes. We did not see a significant change from these numbers when we increased the number of computers that were running with the CPC role.

For the full crawl of the catalog, however, an increase in the number of computers that are running with the CPC role increased the number of items processed per second. The following graph shows the relationship of items processed per second and the number of computers in the farm with the CPC role. Note that this test data was obtained from a SharePoint deployment other than the one used in the baseline tests. The findings should apply to the SharePoint deployments because the addition of more CPC nodes results in improved full crawl times.

Figure 4: Effect of content processing (CPC) computers on a full crawl

Excel graph shows relationship of items processed per second and the number of computers in the content processing role (CPC). Increasing the number of computers with CPC role increases number of items processed per second and improves full crawl times.

Therefore, if you require faster full crawls for your catalogs, you can increase the number of computers that use the CPC role in your deployment.

Load on Managed Metadata Service application

Our testing shows that publishing scenarios that involve sites that use managed navigation do not have significant memory or CPU requirements on the Managed Metadata service application. For a deployment such as the one we have described earlier, the Managed Metadata service application can be run on a computer that is running other SharePoint service applications. The Managed Navigation feature makes one connection to the service application when it receives the first request for a site. Subsequent requests use values that front-end web servers cache. Therefore there is no load on the Managed Metadata service application while front-end web servers fulfill requests.

Anonymous Search Results Cache

The Anonymous Search Results Cache stores results of a query, refinement data for the query, and additional result tables that are returned from the SharePoint Distributed Cache Service. Each cache entry depends on the parameters of a query, such as the sort order of the results, the requested refiners, and any dynamic reordering rules. The cache affects all queries that a web application handles including queries from Search Web Parts and the queries from CSOM clients. For more information, see Overview of search in SharePoint Server 2013 and Scale search for performance and availability in SharePoint Server 2013.

This cache is not used for queries that are authenticated because of security concerns.

We recommend that you configure the Distributed Cache Service to run only on the computer that runs the SharePoint service applications for best results. The Distributed Cache Service should not run on the computers that are in the front-end web server roles.

By default, the Anonymous Search Results Cache refreshes items every 15 minutes. You can use Windows PowerShell to configure the cache duration on the web application where the cache is configured:

Copy code
$webapp.Properties["SearchResultsCacheTTL"] = <number of seconds to keep in cache>
$webapp.Update()

If you want search results to be fresher than the default value, you lower the value. Note that this increases the number of queries that the Search service will need to serve.

We recommend that you always use the cache on publishing pages that receive heavy traffic. Some examples for these types of pages are the site home page and category pages that use Search Web Parts. We do not recommend caching for catalog item pages. Because an individual catalog item page would be accessed much less frequently than a home page, and it may not be worthwhile to store the item in cache.

When we turned off the Anonymous Search Results Cache in our test environment that has the same load patterns, server response times increased significantly and throughput in number of page views per second declined. Here's a graph that shows this relationship:

Figure 5: Effect of Anonymous Search Results Cache

Excel graph shows that turning off Anonymous Search Results Cache in front-end web servers increases server response times and reduces throughput in terms of number of page views per second.

By default, Content Search Web Parts are configured to use the Anonymous Search Results Cache. Catalog-Item Reuse Web Parts, which are used on catalog item pages, are not configured to use it due to the sparse access patterns these pages generally exhibit.

To configure the caching behavior for an individual Web Part to use (or not use) the Anonymous Search Results Cache, set the value of the sub-property "TryCache" in the DataProviderJSON property of the Web Part. If the value is "true", the query uses the cache. If the value is "false", the query does not use the cache for Anonymous search queries.

Effect of output cache

Output caching is an effective way to reduce the load on SharePoint Server 2013 in publishing scenarios. For more details about how Output Cache works in this article, see Output Caching and Cache Profiles.

A SharePoint deployment may benefit from Output Caching to reduce the load on SharePoint content databases and the search service application. Here are some example situations:

  • You are receiving lots of traffic on some of your pages.

  • You are receiving lots of traffic on SharePoint content databases,

  • Computers that serve search queries are running with high CPU utilization.

We recommend that you use Output Caching for very popular pages on your site, such as the site's home page or top level category pages and certain item pages that receive large amounts of traffic.

Important:

There is a known issue in SharePoint Server 2013 when pages that have Output Caching enabled also contain Content Search Web Parts. To avoid this issue in your deployment, install SharePoint Server 2013 update: March 12, 2013.

The following graph shows some results from our test environment where we use Output Caching on the homepage and category pages that receive 60 percent of the site traffic.

Figure 6: Effect of output caching for home page and category pages

Excel grpah showing the effects of turning off Output Caching for home pages and category pages in both the Green and Red Zones of our test environment.

Note:

Content Search Web Parts have a setting to run in asynchronous mode. Output Caching does not apply to the load from asynchronous Content Search Web Parts.

Usage analytics processing

To have information about usage analytics ready to use, SharePoint Server 2013 processes information that's in the usage database. In our topology Analytics Processing occurs on the node that contains the Search Admin node, Distributed Cache service and other service applications. For more information, see Overview of analytics processing in SharePoint Server 2013

We took some analytics processing time measurements by using the cross-site publishing site that we used in our earlier tests. We measured the time that SharePoint Server 2013 takes to process a large amount of click events on the pages in the site. While these results are from a cross-site publishing site, they also apply to sites that use the author-in-place publishing method.

For our tests around usage analytics processing, we generated the following mock events, every day for a week:

  • 27.5 million click events spread across 3 million list items and 400,000 users.

    Zipf distribution was used so that some items and users have many events, but others have less.

This generated a total of 7.5 million events per day, simulating different users generating different traffic patterns for the site.

We triggered the analysis runs seven times to simulate one week of traffic. We ran the Usage Analytics job every day for the data that we accumulated over six days. Then we measured the time, the seventh day took. The seventh day will be the day that takes longest to process as the complete week's items are processed and the relationship graph is updated. The runtime and disk usage for Day 8 will resemble Day 1.

The analytics processing did not have a significant impact on the computer that it ran on, and we continued to successfully serve queries and keep content fresh on the search-driven site.

The results are summarized in the following table:

Test Schedule | Update Relationship Graph | Runtime (hours) | Total Peak Disk Usage | Usage Analytics Peak Disk Usage
Day 1 | No | 02:35 |  | 2.65 GB
Day 2 | No | 02:43 |  |
Day 3 | No | 03:23 |  |
Day 4 | No | 04:39 |  |
Day 5 | No | 06:08 |  |
Day 6 | No | 07:35 |  |
Day 7 | Yes | 08:29 | 82.4 GB | 4 GB

The following graph displays the runtimes for the different days:

Figure 7: Runtime hours per day

Excel bar chart showing the 7 different test days and the amount of time that we tested each day. Day 1 we tested for 2 hours and 35 minutes, and ended on day 7 with 8 hours and 29 minutes of testing.

Cross-site publishing with authenticated users

SharePoint publishing is used commonly on intranet sites. By using SharePoint Server 2013, these sites can also be powered by cross-site publishing. The following sections show some important distinctions to consider when you plan for a cross-site publishing site that uses authenticated users. Other than the exceptions mentioned in the following sections, the rules that apply to anonymously accessed sites still apply to sites that authenticated users access.

Lack of Anonymous Search Results Cache

As mentioned in the Anonymous Search Results Cache section earlier, this cache only takes effect for users who are accessing the SharePoint site anonymously. Compared to anonymously accessed sites that use the Anonymous Search Results Cache, the throughput capacity of sites that are accessed by authenticated users will be significantly lower. Typically intranet sites rarely receive loads as high as the ones mentioned in the previous section (up to 100 page views / second). However, this is an important distinction to consider.

Use of the output cache can ease the lack of Anonymous Search Results Cache to a degree for these scenarios. Cross-site publishing sites that expect multiple page views per second should consider enabling output cache for their sites.

Important:

Content Search Web Parts have a setting that, if it is enabled, causes them to run in asynchronous mode. The output cache does not apply to the load from asynchronous Content Search Web Parts.

Larger Search index

Depending on the size of the enterprise that deploys SharePoint Server 2013, intranet deployments for SharePoint Server 2013 will typically index larger numbers of documents. This means that the required Search topology to index those documents will be different compared to the topology described in the previous section. Refer to Plan search in SharePoint Server 2013 to size your SharePoint deployment appropriately.

Author-in-place publishing

This section provides guidance and results that use SharePoint Server 2013, but it does not detail the different features that affect capacity planning. For details in this area, see Plan web content management in SharePoint Server 2013.

Author-in-place publishing with anonymous users

For our tests we worked with a website that has the following characteristics:

  • Website with up to 20,000 article pages divided into 20 folders of 1,000 pages each across 50 sites in a single site collection.

  • The site uses structured navigation.

  • The site generally receives a minimum of 50 to 100 page views per second.

  • Traffic patterns hit the following mix of pages:

    • 20 pages that contain a single Content Query Web Part that issues content database queries of varying scopes (20 percent of the traffic)

    • 30 pages that include multiple Content Query Web Parts that issue content database queries of varying scopes (30 percent of the traffic)

    • 1,600 articles with 40k of text and two images (receives 50 percent of the traffic)

The recommended server topology is in the following diagram:

Figure 8: Author-in-place publishing test topology

Visio diagram of the test server topology for the author-in-place tests. This test topology includes 1 computer hosting SQL Server and 1 computer hosting SharePoint service applications and running as a front-end web server.

  • 1 computer hosting SQL Server

  • 1 computer hosting SharePoint service applications as the front-end web server

Test lab results

We used the topology shown in the previous diagram in our test lab by using physical computers and a Visual Studio Team System load test.

The following table shows the technical specifications that we used in the computers that we tested:

Server Components | SharePoint Servers
Processors | Intel Xeon CPUs @2.33GHz (2 processors, 8 cores total, 8 threads total)
RAM | 24 GB
Operating system | Windows Server 2008 R2 Enterprise, 64-bit
Number of network adapters | 2
Network adapter speed | 1 Gbps
Authentication | None ─ Anonymous
Load balancer type | Windows software load balancer
Software version | SharePoint Server 2013

Server Components | Database server
Processors | Intel Xeon CPUs MP7130M @2.79GHz (2 processors, 8 cores total, 16 threads total
RAM | 16 GB
Operating system | Windows Server 2008 R2 Enterprise, 64-bit
Disk array | 2 x Dell PERC 5/E
Number of network adapters | 1
Network adapter speed | 1 gigabit or Gbps
Authentication | NTLM
Software version | Microsoft SQL Server 2008 R2 SP1

The following table shows our results for a 10-minute run:

Test Features | Green Zone | Red Zone
Number of VSTS users: | 5 | 15
Server Response Time 50th percentile: | 69 ms. | 112 ms.
Server Response Time 95th percentile: | 92 ms. | 221 ms.
Page views per second: | 57 | 93
Average CPU (application server and front-end web server) | 55 | 97
Average CPU (SQL Server) | 7 | 9
Peak memory usage (application server and front-end web server) | 8.9 GB | 8.9 GB

Effect of output cache

Output caching is an effective way to reduce the load on SharePoint Server in publishing scenarios. For more information, see Plan for caching and performance in SharePoint Server 2013.

The following table shows our results for a 10-minute run with output cache enabled and a 90 percent hit ratio:

Test Features | Green Zone | Red Zone
Number of VSTS users: | 5 | 15
Server Response Time 50th percentile: | 2 ms. | 2 ms.
Server Response Time 95th percentile: | 74 ms. | 88 ms.
Page views per second: | 190 | 418
Average CPU (application server and front-end web server) | 58 | 85
Average CPU (SQL Server) | 5 | 7
Peak memory usage (application server and front-end web server) | 9.2 GB | 9.4 GB

The test results show that using output caching can significantly increase the throughput of a SharePoint publishing site and reduce server response times. For requests served from the output cache, the response times are almost instant.

The following graph shows a summary of our testing results:

Figure 9: Effect of output caching with 90% cache hit ratio

Excel bar chart shows effect of using output caching in Green and Red Zones. Output caching reduces server response time and increases SharePoint publishing site throughput, when not used the throughput is reduced and server response times increase.

Effect of managed navigation

In SharePoint Server 2013, publishing sites can also use managed navigation. For details on how to set this up, see Overview of managed navigation in SharePoint Server 2013.

We ran the same set of tests for our test site using managed navigation as we used for the structured navigation tests. Our tests show that there is no significant difference in performance when sites use managed navigation or structured navigation.

Test Features | Green Zone | Red Zone
Number of VSTS users: | 5 | 15
Server Response Time 50th percentile: | 70 ms. | 111 ms.
Server Response Time 95th percentile: | 95 ms. | 215 ms.
Page views per second: | 56 | 94
Average CPU (application server and front-end web server) | 54 | 97
Average CPU (SQL Server) | 7 | 9
Peak memory usage (application server and front-end web server) | 8 GB | 8 GB

The following graph shows the different types of navigation for the same site:

Figure 10: Managed Navigation versus Structured Navigation

Excel bar chart show effects of using managed navigation versus structured navigation in both Green and Red Zones. Comparisons show using managed or sturctured navigation are the same.

Effect of adding computers (scaling out)

If you find that you need more throughput from a SharePoint deployment, scaling out (increasing the number of computers that host SharePoint Server) is an option to consider. The following graph shows how throughput increases as we add more computers to the farm:

Figure 11: Effect on throughput by adding front-end web servers

Excel chart shows the effect of adding front-end web servers and increasing the load on these servers in both the red and green zones. Starting with one front-end web server and ending with 3, throughput increases at almost the same time in milliseconds.

In our tests we increased the load on the server running SharePoint Server for each computer that was added so that the server response times were approximately the same (around 11 milliseconds for the green zone, around 250 milliseconds for the red zone).

Author-in-place publishing sites with authenticated users

The SharePoint publishing feature is used commonly in the intranet where users who access a site are authenticated. This section shows our tests that used authenticated users and the effects.

The following table shows the test results of author-in-place publishing sites that authenticated users accessed by using claims-based authentication with NTLM. Note that these tests use identical hardware as the tests in the previous section.

Test Features | Green Zone | Red Zone
Number of VSTS users: | 5 | 15
Server Response Time 50th percentile: | 76 ms. | 107 ms.
Server Response Time 95th percentile: | 103 ms. | 194 ms.
Page views per second: | 54 | 100
Average CPU (application server and front-end web server) | 50 | 97
Average CPU (SQL Server) | 6 | 9
Peak Memory Usage (application server and front-end web server) | 9.5 GB | 9.5 GB

The numbers show that there is no significant difference between anonymous versus authenticated requests according to the server response times and throughput.

The following graph shows the different types of requests for the same site:

Figure 12: Anonymous requests versus authenticated requests

Excel chart shows proportional performance of using anonymous requests versus authenticated requests in both the green and red zones.

Effect of Output Cache in authenticated scenarios

Authenticated requests to the server require a roundtrip to the content database to make sure that the account that is accessing the content has permissions to view the content. This means that the output caching performance characteristics of authenticated sites are different compared to anonymous sites.

The following table shows the results we received for a 10 minute run with output cache enabled and a 90 percent cache hit ratio:

Test Features | Green Zone | Red Zone
Number of VSTS users: | 6 | 18
Server Response Time 50th percentile: | 17 ms. | 29 ms.
Server Response Time 95th percentile: | 87 ms. | 118 ms.
Page views per second: | 114 | 236
Average CPU (application server and front-end web server) | 50 | 97
Average CPU (SQL Server) | 7 | 10
Peak Memory Usage (application server and front-end web server) | 9.9 GB | 10 GB

The following graph shows the summary of these results:

Figure 13: Effect of authenticated output caching

Excel bar chart shows the effect of using authenticated output caching in both the green and red zones. The roundtrip time in milliseconds increases when using authenticated requests compared to anonymous requests.

See also

Plan web content management in SharePoint Server 2013
Configure web content management solutions in SharePoint Server 2013
Administer web content management in SharePoint Server 2013
Configure cache settings for a web application in SharePoint Server 2013
Plan for caching and performance in SharePoint Server 2013


Estimate capacity and performance for Managed Metadata Service (SharePoint Server 2013)
See also

Published: April 9, 2013

Summary: Learn how to plan to deploy a Managed Metadata Service application for SharePoint Server 2013 by using tested capacity and performance data.

Applies to: SharePoint Server 2013

This article contains information and recommendations that are related to sizing and performance optimization of the Managed Metadata Service in SharePoint Server 2013. We also provide some best practices about how to configure the service and structure the service application databases for maximum performance. Use this information to determine whether your planned deployment fits in the capacity and performance limits that our tests provide.

The following new features in SharePoint Server 2013 directly affect the Managed Metadata Service and are important for capacity planning. The load from these features is included in our test dataset and test scenarios.

  • Hashtags in feeds (in My Sites or Team Sites)

  • Sites using managed navigation

  • New CSOM endpoints that clients can call

For a typical SharePoint Server deployment with similar characteristics as our test dataset, we recommend that the Managed Metadata Service application run on the computers that assume the front-end web server role. The database for the Managed Metadata Service application can be placed on a SQL Server instance that hosts other SharePoint service application databases.

For deployments that contain significantly more items than compared to the dataset we provide in our tests, we'll attempt to provide guidance through the results of tests where we change one of the variables and keep the other components of our test dataset constant. Users with larger deployments should consider these results and size their SharePoint Server farms accordingly.

In this article:

  • Introduction

  • Test dataset

  • Test scenarios

  • Test topology

  • Test results

For general information about capacity management and how to plan for SharePoint Server 2013, see Capacity management and sizing for SharePoint Server 2013.

Introduction

We recommend that in a typical SharePoint Server deployment with similar characteristics as our test dataset, that the Managed Metadata Service application be enabled only on computers that run as a front-end web server. The database for the Managed Metadata Service application can be put on a SQL Server instance that hosts other SharePoint service application databases.

Note that for deployments that contain significantly more items than are in the dataset that we provide in our tests, we provide separate recommendations. In our tests we attempt to provide guidance using the test results where we change one of the variables and keep the other components constant. Users with larger deployments should consider these results and size their SharePoint farms accordingly.

Test dataset

To provide capacity planning guidance, we created a test dataset that includes the features in SharePoint Server 2010 and new features in SharePoint Server 2013 and ran tests on a SharePoint deployment. The following table shows the test dataset that we used:

Variable | Number of items
Term set groups | 500
Term sets | 1,000 (2 per group)
Managed terms (does not include enterprise keywords) | 20,000 (20 per term set)
Enterprise keywords | 80,000
Hashtags | 200,000
Total terms (includes managed terms, enterprise keywords, and hashtags) | 300,000
Labels | 300,000 (1 per item)
Term label length | 30 characters per label

Test scenarios

We used the tests in the following table for this dataset:

Test | Description | Percentage in test
GetSuggestions | A single call to the web service and a single character prefix string. The string will be chosen to match 20% of the terms in the term store, similar to how metadata column suggestions work in the SharePoint user interface. | 10%
GetMatches | Web service for a string that matches 1% of the terms in the term store. | 5%
ValidateTerms | Web service call to validate a single term. | 5%
CreateTaxonomyItem | Web service call to a call to create a keyword with a random name. | 5%
GetChildTermsInTermSetWithPaging | Web service call to multiple term sets. Similar to the call made by SharePoint Server 2013 to retrieve terms sets used by the managed navigation feature, the results of which are then cached in the front-end web server. | 5%
GetTermSets | Web service call to get term sets. | 5%
GetTermsByLabel | Web service call with a list of term GUIDs. Similar to the call made by SharePoint Server 2013 when a My Site home page is loaded. | 10%
HT GetSuggestions | Web service call to get suggestions for hashtags with a single character. Similar to the call made by SharePoint UI when you work with hashtags in the feeds. | 10%
HT NewHashTag | 2 web service calls. One to get terms, then another to create the term. | 5%
HT GetTermsByLabel | Web service call to get existing terms. Used when a hashtag is used in a feed post. | 15%
HT AddAssociation | Web service call to add an association to an existing hashtag term. | 5%
CSOM GetTerms | Test to GetTerms a list of terms GUIDs. Has 2 individual CSOM calls. | 10%
CSOM SetProperty | Test to SetProperty for a single term. Has 4 individual CSOM calls. | 5%
CSOM CreateTerm | Test to add a term to the term store. Has 4 individual CSOM calls. | 5%

In our tests we put more weight on operations that are expected to be used more frequently.

Test topology

We ran the tests in our lab environment that has the topology shown in the following diagram:

Figure 1: Test lab server topology

Visio diagram showing the test server topology that included a single computer hosting SQL Server and a single computer hosting SharePoint server running as either an application server or front-end web server.

We started our tests with one computer that is running the Managed Metadata Service application and serving as the front-end web server. Later, we added another computer that has the same configuration.

Test results

We used the dataset and the scenarios that were described in earlier sections to test the total number of Managed Metadata Service application operations that executed for a given configuration.

We ran our tests with the different load profiles in the following list:

  • Green Zone

    Servers are under 60% utilization. This should be the target for most of the time when the servers are running.

  • Red Zone

    Servers are close to full utilization. This can be considered a state where the SharePoint site is under more load than usual. In the Red Zone, server response time values start increasing as the server tries to meet the demand of incoming requests.

The following table shows the results of our measurements with a single computer:

 | Green Zone | Red Zone
Server Response Time 50th percentile for read operations: | 32 ms. | 44 ms.
Server Response Time 95th percentile for read operations: | 1090 ms. | 1335 ms.
Server Response Time 50th percentile for write operations: | 1837 ms. | 2038 ms.
Server Response Time 95th percentile for write operations: | 2283 ms. | 3515 ms.
Tests completed per second: | 9 | 15
Average CPU (application server or front-end web server) | 56% | 92%
Average CPU (SQL Server) | 7% | 12%
Peak memory usage (application Server or front-end web server) | 6 GB | 6.2 GB

We then added a second application server or front-end web server virtual machines (VMs) to the deployment with the same configuration. The following table shows the results for a two VM farm with approximately two times (2x) the load as our earlier tests:

 | Green Zone | Red Zone
Server Response Time 50th percentile for read operations: | 44 ms. | 110 ms.
Server Response Time 95th percentile for read operations: | 1161 ms. | 1679 ms.
Server Response Time 50th percentile for write operations: | 1828 ms. | 2253 ms.
Server Response Time 95th percentile for write operations: | 3321 ms. | 4648 ms.
Tests completed per second: | 15 | 28
Average CPU (application server or front-end web server) | 49% | 88%
Average CPU (SQL Server) | 14% | 28%
Peak memory usage (application server or front-end web server) | 6.1 GB | 6.3 GB

The following graph shows the data in the previous two tables:

Figure 2: Managed Metadata Service application performance

Excel bar chart shows Managed Metadata Service application performance data from the previous tables. First performance data shows a single application server or front-end web server and then shows two with twice the load, for both green and red zones.

Effect of friendly URLs on Search crawls for friendly URLs

SharePoint Server 2013 includes the Managed Navigation feature and two timer jobs that are triggered to make sure that the search crawl receives the latest versions of pages that use friendly URLs. Our tests found that running these timer jobs that communicated with the Managed Metadata Service application did not have a significant effect on read and write operations that target the same application.

Effect of CSOM calls

Some tests increased the CSOM calls made in our test procedure compared to the baseline case. We increased these from 20 percent of tests to 66 percent. The test results show that the number of executed tests declined from 28 to 22 per second. The server response times are comparable to the baseline. The reduction in the number of executed tests is because of the increased overhead of multiple calls to the front-end web server for each action for the CSOM calls compared to fewer calls involved in the web service calls.

Effect of having more hashtag operations

In another test case, we increased the percentage of the hashtag operations from 35 percent in our baseline to 71 percent in our tests. The results show that the number of executed tests declined from 28 to 19. The server response times are also about 30 percent greater than the baseline. The reduction in the number of executed tests is attributed to the fairly high number of terms in the hashtags term set and the much increased percentage of write operations in the changed procedure.

See also

Overview of managed metadata in SharePoint Server 2013
Overview of managed metadata service applications in SharePoint Server 2013
Plan terms and term sets in SharePoint Server 2013


Estimate capacity and performance for video content management in SharePoint Server 2013
See also

Published: April 16, 2013

Summary: Learn guidelines for how to plan video content types and video player pages using the Rich Media Web Part to provide better user experiences when you play videos in SharePoint Server 2013.

Applies to: SharePoint Server 2013

SharePoint Server 2013 supports the video content type and the video player page, where you can use the Rich Media Web Part to play videos. This article contains test data to help you optimize the video playing experience for users in a SharePoint Server 2013 environment.

In this article:

  • Introduction

  • Video storage locations

  • Size the BLOB cache to ensure smooth video streaming experiences

  • Dataset and test scenarios

    • Test lab results

    • Effect of IIS Bit Rate Throttling

    • Using videos that are stored external to SharePoint Server 2013

Videos are known as digital assets or rich media in SharePoint Server 2013. SharePoint Server 2013 provides an asset library to store videos so that users can visit a central location to view them. For more information, see Overview of managing digital assets in SharePoint Server 2013.

Introduction

We tested two scenarios in our video capacity and performance testing. The first scenario stores videos in a location that is not part of the SharePoint deployment. The second scenario stores videos in a SharePoint asset library. We look at the performance characteristics for both scenarios.

Video storage locations

Videos in SharePoint Server 2013 use a new content type named Video, much like a document set. When you create a video, SharePoint Server 2013 uses one of the following methods to store it:

  • Store the video content as a Binary Large Object (BLOB) in the content database

  • Store a reference to a URL for the video

  • Store an embedded code that contains the reference to an external video and player

The following advantages and disadvantages can help you decide where to store videos:

  • If you store videos in a SharePoint asset library, we recommend that you turn on BLOB cache for the computers that run as the front-end web server role. The BLOB cache size must be appropriate to ensure a smooth streaming experience for users.

    Note:

    This option increases the size of the content database as more videos are added.

  • If users are in the same geographical region, and the total sizes of the videos are large (such as HD videos), or you have many videos, consider hosting the videos on a web or file server instead of the content database to reduce your SQL Server storage costs.

  • If users are geographically distributed over long distances, you can store the videos in a content delivery network so that users who are farthest from the SharePoint farm do not have to stream videos over a high latency network connection.

When you store videos outside a SharePoint deployment, ensure that the videos are correctly secured so that unauthorized users cannot access them.

If you find that you can't upload files larger than a certain size, you can change this on the Web Application Settings page of the SharePoint Central Administration website. Note that you can also change the Web Page Security Validation to use a larger time-out value if users upload videos that take more than 30 minutes to upload. This is also done on the Web Application Settings page in Central Administration.

Size the BLOB cache to ensure smooth video streaming experiences

When you store videos in SharePoint Server 2013, the size of the BLOB cache can help you optimize the streaming experience for users. We recommend that you size the BLOB cache to a certain percentage of the total size of unique videos viewed in a week. For example, consider an environment where the total size of unique videos viewed in seven days is 100 GB. For this environment you can size your BLOB cache to be 80 GB, which is 80 percent of the total size of the unique videos. This ensures that the most frequently viewed videos are always kept in the BLOB cache where there is no additional load on the content database to retrieve these videos multiple times. This also ensures an optimal user streaming experience. The ideal size will differ based on the video viewing patterns in the SharePoint deployment.

To optimize performance, do not place the BLOB cache on the same drive as the system drive.

Note that bigger BLOB cache sizes enable SharePoint Server 2013 to store more videos. So if you have the available disk space on the front-end web servers and know that you'll store many videos, increase the BLOB cache size. Note that if the BLOB cache size is set lower than a certain threshold that users can experience choppy video streaming.

Dataset and test scenarios

The following table describes the video library that we used for our tests:

Variable | Value
Number of videos | 350
Size of videos | 1 MB - 1 GB each, total size of 14 GB

We used this set of videos in different tests:

  1. Uploaded the videos to SharePoint Server 2013 and turned on the BLOB cache.

  2. Uploaded the videos to a Windows Server 2008 R2.

We ran our tests in the following farm topology:

Figure 1: Video content management test topology

Visio diagram of the Video content management test server topology. The test server topology consists of a single computer hosting SQL Server and a single computer hosting SharePoint Server service applications running as a front-end web server.

The following list shows the computers that we used:

  • One computer that is hosting SQL Server

  • One computer that is hosting SharePoint service applications and runs as the front-end web server

Test lab results

To produce the test lab results, we created a load test where we navigated to different pages. We accessed either the video player page or the publishing page that uses the Rich Media control. We then requested the video file that the page referenced by using varying numbers of Visual Studio Team System (VSTS) users. Applying this load to our SharePoint deployment, we manually navigated to a video player page and a publishing page that uses the video control to make sure that the video streaming experience was acceptable. We define an acceptable experience as follows:

  1. Video starts to play within 2 seconds of going to the page

  2. Video seeking experience works as expected

Note that all of the computers in our tests are on a network that used 1 Gbps network connections. We found that in many of the tests, we managed to reach a point where the network was the bottleneck instead of the computers that served the content.

The tests started with a 50 user load and then increased the number of concurrent users until the experience is no longer acceptable. On a single computer that is running SharePoint Server 2013 and servicing only videos, we found that we had an acceptable experience until we increased the load to 400 concurrent users. After we passed that point, we began to see that the page took longer to load and the video seek experience became slower.

The following graph shows this:

Figure 2: Acceptable video streaming experience

Excel line chart showing the video streaming experience. Using one SharePoint Server, starting at one user, and then adding up to 400 before video streaming slowed; between 400 - 450 users the video streaming experience fell below acceptable.

To see how this experience scales, we gradually added more computers to our SharePoint deployment and continued to increase the load. The following graph shows the results.

Figure 3: Acceptable video streaming with more test computers and users

Excel line chart showing video streaming experience with additional users and front-end web servers. At 2 servers the video streaming slowed at 600 users, and at 650 was unacceptable. At 3 servers, streaming slowed at 1050 users, at 1100 was unacceptable.

Effect of IIS Bit Rate Throttling

We used Internet Information Services (IIS) Bit Rate Throttling on our test servers. This extension to IIS allows the bandwidth to be used more effectively while you are streaming videos. For more information about Bit Rate Throttling, see Bit Rate Throttling.

Note that there is no significant difference according to the number of concurrent users supported when we used IIS Bit Rate Throttling versus when we did not use it. However, the video viewing experience feels smoother when it is turned on.

Using videos that are stored external to SharePoint Server 2013

When you store videos outside a SharePoint Server 2013 environment, the load shifts from SharePoint Server 2013 to the external location. SharePoint Server 2013 only loads the video player page or the publishing page that uses the Rich Media control. The streaming is performed by the external location's source.

In our lab environment, we set up an IIS server to host and stream the videos. We updated our dataset to refer to the external URL for videos in our SharePoint video library. We ran the same test again and found that we could stream up to 650 videos concurrently and still have an acceptable experience. We did not test for more concurrent users.

Note that videos that are stored outside a SharePoint environment do not receive the same authentication benefit as videos in a SharePoint library. Take this into consideration when you design your topology and decide how to store your videos.

See also

Digital asset library planning in SharePoint Server 2013
Manage Web Parts in SharePoint 2013


Estimate capacity and performance for compliance and eDiscovery for SharePoint Server 2013
See also

Published: April 16, 2013

Summary: Learn about how compliance, eDiscovery, and large-scale document repositories can effect capacity and performance in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Compliance feature sets, such as in-place holds and querying and exporting data under preservation, effect the processing and storage requirements in SharePoint Server 2013 when used.

In this article:

  • Storage requirements for in-place holds

  • Effect of eDiscovery queries and export on other Search queries

  • Effect of Export

Storage requirements for in-place holds

An in-place hold preserves edited and deleted content to make the original version available for legal actions. In-place holds apply to a complete site. For example, if the root site of a site collection is put on hold, the complete site collection is also on hold. An in-place hold applies to documents, pages, and lists. After a site is put on hold, all items that are edited for the first time or deleted, are put in the Preservation Hold Library for the SharePoint site. This location is where the content was originally located on the site. The size of the site increases at a rate that correlates with how much of the content existed when the hold was enabled and is changed when new content is added. In practice, most content on legal hold is not new. The effect on storage for in-place holds is expected to be low because users are not actively changing content. For more information, see Overview of eDiscovery and in-place holds in SharePoint Server 2013.

Effect of eDiscovery queries and export on other Search queries

SharePoint Server 2013 has a site collection type called Case Manager that allows you to execute eDiscovery queries across your organization's SharePoint content and Exchange Server 2013 mailboxes. eDiscovery queries are usually complex and wide in scope. These queries require more processing time on the Search system and potentially affect the search response time that other users experience.

The following guidelines can help you understand how these queries affect Search experiences for other users:

  • As you add more sources to an eDiscovery query, you increase the number of executed queries.

  • As you add more terms to an eDiscovery query, you increase the effect of your eDiscovery queries.

  • As you add more operators (such as AND, OR, NEAR) to an eDiscovery query, you increase the effect of your eDiscovery queries.

In our lab tests, we used an eDiscovery query of 350 terms that ran against 10 sources. The query returned a total of 150,000 items. We then exported those items. To perform this test, we executed five simulated loads on the Search service system, which represented other types of search queries that are expected to run on the system.

Our tests show that eDiscovery queries can increase query latencies that users observe by as much as 100 percent. If you run close to capacity for your user search queries, you might consider running eDiscovery queries and exports during non-peak hours to have a smaller effect on user search queries.

Effect of Export

After you run eDiscovery queries, a common operation is to export the data. During the export action, content that the eDiscovery query returned is downloaded one file at a time. We ran a set of tests where we downloaded files and updated SharePoint items. Export did not add a significant load on the SharePoint deployment. We ran the export action in our tests while the farm served about 100 requests per second. Out of the 100 requests only about five requests per second were made by the export action.

Note that the effect of export on Exchange Server 2013 may be different. Exchange Server 2013 queries are variable, particularly eDiscovery queries that are often long and complex.

Large-scale document repositories with SharePoint Server 2013

Aside from the compliance and eDiscovery features, the SharePoint Server 2013 large scale document repositories feature has not changed significantly from SharePoint Server 2010. In this section we refer to Scale test report for very large scale document repositories (SharePoint Server 2010), and point out differences for scenarios that involve SharePoint Server 2013 document repositories. The following sections summarize the main differences.

Guidance for putting interactive service applications on front-end web servers

Guidance for SharePoint Server 2010 advised you to put service applications on a separate tier. In SharePoint Server 2013 we recommend that you put the interactive service applications on computers that run as front-end web servers. For more information, see Capacity planning for SharePoint Server 2013.

Search in SharePoint Server 2013

The SharePoint Server 2013 Search Service application merges the SharePoint Server 2010 Search and FAST Search Server 2010 for SharePoint into a unified search platform with additional functionality. For more information, see Scale search for performance and availability in SharePoint Server 2013 and Overview of search in SharePoint Server 2013.

Efficient File I/O and SQL Server improvements

Efficient File I/O in SharePoint Server 2013 is a storage method in which a file is split into pieces that are stored and updated separately, and streamed together when a user requests the file. This results in more efficient file updates as only the updated pieces are written to SQL Server. Efficient File I/O is very effective when you use it with large files. Small files can see a small increase in the disk storage that is required. A direct result of using Efficient File I/O is that the throughput to update documents is improved.

Other improvements use SQL Server 2008 R2 with SP1 features and throughput to find documents for link fix-up and alert handling.

Column limits

Column limits are updated in SharePoint Server 2013. For more information, see Software boundaries and limits for SharePoint 2013.

See also

Estimate capacity and performance for compliance and eDiscovery for SharePoint Server 2013
Plan for eDiscovery in SharePoint Server 2013
Configure eDiscovery in SharePoint Server 2013


Estimate performance and capacity requirements for social environments (SharePoint Server 2013)
See also

Published: June 18, 2013

Summary: Learn how to determine the number and types of computers that you need for a capacity plan for a My Site and social computing portal based on SharePoint Server 2013.

Applies to: SharePoint Server 2013

To create a performance and capacity plan for an enterprise intranet My Site and social computing portal solution, this article contains information about the following areas:

  • Lab environment specifications, such as hardware, farm topology, and farm configuration

  • The test farm workload and dataset that was used to generate test load

  • Test results and analysis that demonstrate and explain trends in throughput, latency, and hardware demand under load at specific scale points.

Use the information in this article to understand the following concepts:

  • Characteristics of the scenario under both normal and peak loads

  • How performance trends change when farm servers are scaled out

  • How to estimate an appropriate starting point for your planned architecture

  • Important factors to consider when you plan for the resources your farm will need to maintain acceptable levels of performance under peak load

In this article:

  • Introduction to this environment

  • Glossary

  • Overview

  • Specifications

  • Results and analysis

Introduction to this environment

Enterprises often use SharePoint Server 2013 to publish My Site and social computing portals that authenticated users access on an intranet site. This article contains capacity and performance data to help plan the number of computers to use and the types of computers that are required to publish My Site and social computing portals in SharePoint Server 2013.

Additional guidance explains how to scale out servers in a SharePoint Server 2013 enterprise My Site and social computing portal solution. Capacity planning informs decisions about hardware to purchase and system configurations that optimize your solution.

Because individual SharePoint Server 2013 farms are unique, each farm has different requirements that depend on hardware, user behavior, the configuration of installed features, and many other factors. Therefore, supplement this guidance with additional testing on your own hardware in your own environment. If your planned design and workload resembles the environment described in this article, you can use this article to draw conclusions about how to scale your environment.

Test results in this article were produced in a test lab, using a workload, dataset, and architecture to simulate a production environment under highly controlled conditions. While great care was exercised in designing these tests, the performance characteristics of a test lab are never the same as the behavior of a production environment. These test results do not represent the performance and capacity characteristics of a production farm. Instead, the test results demonstrate observed trends in throughput, latency, and hardware demand. Use the analysis of the observed data to help you plan capacity and manage your own farm.

This article includes the following:

  • Specifications, which include hardware, topology, and configuration

  • The workload, which includes an analysis of the demand on the farm, the number of users, and usage characteristics

  • The dataset, such as database sizes and content types

  • Test results and analysis to scale out web servers

Before you read this article, read the following articles to make sure that you understand the key concepts behind capacity management in SharePoint Server 2013.

  • Capacity management and sizing for SharePoint Server 2013

  • Software boundaries and limits for SharePoint 2013

These articles provide the following information:

  • The recommended approach to capacity management

  • How to make effective use of the information in this article

Glossary

The following list contains definitions for key terms found in this article:

  • RPS: Requests per second. RPS is the number of requests that a farm or server receives in one second. This is a common measurement of server and farm load.

    Important:

    Note that requests differ from page loads. Each page contains several components, each of which creates one or more requests when a browser loads a page. Therefore, one page load creates several requests. Authentication checks and events that use insignificant resources typically are not counted in RPS measurements.

  • Green Zone: Green Zone represents a defined set of load characteristics under normal operating conditions, up to expected daily peak loads. A farm that operates in this range should be able to sustain response times and latency that are within acceptable parameters.

    This is the state at which the server can maintain the following set of criteria:

    • The server-side latency for at least 75 percent of the requests is less than 0.5 seconds.

    • All servers maintain an average CPU utilization of less than 50 percent.

    • Failure rate is less than 0.1 percent.

  • Red Zone (Max): Red Zone represents a defined set of load characteristics under peak operation conditions. At Red Zone, the farm experiences very high transient resource demands that it can sustain only for limited periods before failures and other performance and reliability issues occur.

    This is the state at which the server can maintain the following set of criteria for a limited duration:

    • Server-side latency for at least 75 percent of the requests is less than 1 second.

    • Average database server CPU utilization is less than 80 percent.

    • Failure rate is less than 0.1 percent.

Overview

This section summarizes our scaling approach, the relationship between this lab environment and a similar case study environment, and our test methodology.

Scaling approach

We recommend that you scale the computers in your environment in the specific order we followed for scaling our test lab environment. This approach will enable you to find the best configuration for your workload.

We divided the performance test cycles into three workload categories. The primary parameter that determined the category boundary was number of user profiles, which was set at 10K, 100K and 500K user profile tests. Another parameter was the number of active users, who were carrying out actions related to the social set of features. With both the number of users with a profile and number of active users, we ran tests to simulate usage of the application that would be similar to actual deployments. The following table depicts the initial data set and the number of active users.

Initial Data Set

Entity | % of users with this feature | Small (10K users) | Medium (100K users) | Large (500K users)
Number of user profiles for users | 100% | 10K | 100K | 500K
Number of provisioned My Sites | 100% | 10K | 100K | 500K
Number of user profiles that have user photos | 50% | 5K | 50K | 250K
Number of user profiles that have posts | 10% | 1K | 10K | 50K
Number of teams |  | 1,860 | 18,600 | 93K
Number of active users per day | 10% | 1K | 10K | 50K
Number of active users per hour | 5% | 500 | 5K | 25K

Testing focused on the following key scenarios:

  • News Feed page access and other actions

  • Profile page

  • Site feed page access and other actions

  • Outlook Social Connector Activity Feed Sync

  • Sky Drive Pro page access

  • Sky Drive Pro client usage

To simulate a realistic deployment scenario, all tests were run on a database that already had data. The dataset was a model of a tree organization with an average of 4-6 users per team, and 3-4 levels deep. To generate these numbers, we analyzed traffic from an internal social site. The following table describes the set of parameters that we used to build the initial data set.

Data model for initial database

Data entity description | Number
Average number of users in on team | 5
Average number of levels per organization | 4
Number of teams per 1,000 users | 186
Average number of colleagues a user follows | 50
Number of User Profile properties | 93

The following table describes the set of parameters in terms of actions that would result in the data population:

Usage characteristics

Parameter | Number or percentage
Percentage of users with 1-3 posts | 10%
Average number of posts per user | 2
Average number of replies per post | 2
Percentage of posts that are Liked | 15%
Percentage of posts with links | 5%
Percentage of posts with tags | 12%
Percentage of posts with user mentions | 8%
Percentage of posts with image attached | 5%

To create each of our scale tests, we applied the following action mix to the preceding data set and the number of active users:

User READ Actions

User action | % of user taking this action | Scenario | Feature or URL
Navigate to My Site home page | 12% | Newsfeed | Newsfeed page (http://my/default.aspx)
Navigate to the user's public profile page | 8% | Profile | Profile page (http://my/person.aspx?accountname=<alias>)
Navigate to the user's private profile page | 4% | Profile | Profile page (http://my/person.aspx)
Automatic syncing of activity feed | 32% | Outlook Social Connector | none
Navigate to the People I'm following page | 3% | Follow People List | http://my/MyPeople.aspx
Navigate to the default document library | 6% | SkyDrive Pro | https://msft-my.spoppe.com/personal/<user>/Documents
Navigate to followed documents page | 3% | SkyDrive Pro | https://msft-my.spoppe.com/personal/<user>/Social/FollowedContent.aspx
Navigate to followed documents page | 3% | SkyDrive Pro | https://msft-my.spoppe.com/personal/<user>/Social/FollowedContent.aspx
Navigate to the site feed page | 8% | Site Feed | Site Feed page (https://<domain>/teams/<site>/newsfeed.aspx_
View all replies on a thread | 1% | Newsfeed | Newsfeed page (http://my/default.aspx)
View Everyone feed | 3% | Newsfeed | Newsfeed page (http://my/default.aspx)
View more posts on the newsfeed | 2% | Newsfeed | Newsfeed page (http://my/default.aspx)
View the @mentions page | 1% | Newsfeed | Newsfeed page (http://my/default.aspx)
View newsfeed (Mobile) | 1% | Mobile | Mobile Representational State Transfer (REST) Call
View categorized newsfeed | 3% | Mobile | Mobile REST Call

User WRITE Actions

User action | Percentage | Scenario | Feature or URL
Create root post in the feed | 0.5% | Newsfeed | Newsfeed page (http://my/default.aspx)
Like a post in the feed | 0.3% | Newsfeed | Newsfeed page (http://my/default.aspx)
Reply to a post in the feed | 0.7% | Newsfeed | Newsfeed page (http://my/default.aspx)
Create post in the feed with @mention | 0.1% | Newsfeed | Newsfeed page (http://my/default.aspx)
Create root post in the site feed | 0.5% | Site Feed | Site feed page (https://<domain>/teams/<site>/newsfeed.aspx)
Create post in the site feed with @mention | 0.5% | Site Feed | Site feed page (https://<domain>/teams/<site>/newsfeed.aspx)
Reply to a post in the site feed | 0.15% | Site Feed | Site feed page (https://<domain>/teams/<site>/newsfeed.aspx)
Create post in the site feed with a tag | 0.05% | Site Feed | Site feed page (https://<domain>/teams/<site>/newsfeed.aspx)

SkyDrive Pro client actions

User action | Percentage | Scenario | Feature or URL
SkyDrive Pro initial sync | 0.2% | SkyDrive Pro | Initial Sync
SkyDrive Pro incremental sync - download a file | 0.88% | SkyDrive Pro | Incremental Sync
SkyDrive Pro incremental sync - no changes | 8.1% | SkyDrive Pro | Incremental Sync

Test Methodology

We started with a minimum SharePoint Server 2013 farm configuration for social features. We applied a characteristic social load to the test farm and increased the load until we observed levels of normal and maximum server capacity. We analyzed bottlenecks at each of these load levels and added machines of the overloaded role to scale out the farm configuration. This addition alleviated the bottlenecks in each case and provided a view of scalability characteristics of the server for a particular dataset. We repeated this scale-out process for three deployment sizes to provide representative summaries of a SharePoint Server 2013 farm's scalability characteristics and guidelines for capacity planning.

Specifications

This section provides detailed information about the hardware, software, topology, and configuration of the lab environment.

Important:

Al web servers and application servers in the test lab were virtualized by using Hyper-V hosts. Database servers were not virtualized. The physical host hardware and virtual machine virtual hardware are detailed separately in the following sections.

Hardware

The following table lists hardware specifications for the computers that were used in this test. Front-end web servers that were added to the server farm during multiple iterations of the test also complied with these specifications.

Hyper-V Hosts

The farm includes a total of three identically configured Hyper-V hosts, and each host runs one to four virtual machines.

Host hardware | Value
Processor(s) | 2 Quad-core 2.27 GHz processors
RAM | 64 GB
Operating System | Windows Server 2008 R2 SP1
Number of network adapters | 2
Network adapter speed | 1 Gigabit

Virtual web servers and application servers

The farm has from one to eight virtual web servers. An additional dedicated virtual server runs the Distributed Cache Service.

Note:

In a production environment, dedicated servers that run the Distributed Cache Service are typically deployed in a highly available configuration. For test purposes, we used a single dedicated server for Distributed Cache because high availability was not a critical factor.

VM hardware | Web servers
Processors | 4 virtual processors
RAM | 12 GB
Operating system | Windows Server 2008 R2 SP1
Size of the SharePoint drive | 100 GB
Number of network adapters | 2
Network adapter speed | 1 Gigabit
Authentication | Windows NTLM
Load balancer type | F5 Big IP
Services running locally | Microsoft SharePoint Foundation Web Application, Microsoft SharePoint Foundation Incoming E-Mail, Microsoft SharePoint Foundation Workflow Timer Service, Managed Metadata Web Service, User Profile Service

VM hardware | Cache
Processors | 4 virtual processors
RAM | 12 GB
Operating system | Windows Server 2008 R2 SP1
Size of the SharePoint drive | 100 GB
Number of network adapters | 2
Network adapter speed | 1 Gigabit
Authentication | Windows NTLM
Services running locally | Distributed Cache, Microsoft SharePoint Foundation Workflow Timer Service

VM hardware | Search query component
Processors | 4 virtual processors
RAM | 12 GB
Operating system | Windows Server 2008 R2 SP1
Number of network adapters | 2
Network adapter speed | 1 Gigabit
Authentication | Windows NTLM
Services running locally | Microsoft SharePoint Foundation Web Application, Microsoft SharePoint Foundation Incoming E-Mail, Microsoft SharePoint Foundation Workflow Timer Service, Search Query and Site Settings Service, SharePoint Server Search

VM Hardware | Search index component
Processors | 4 virtual processors
RAM | 12 GB
Operating system | Windows Server 2008 R2 SP1
Number of network adapters | 2
Network adapter speed | 1 Gigabit
Authentication | Windows NTLM
Services running locally | Microsoft SharePoint Foundation Web Application, Microsoft SharePoint Foundation Incoming E-Mail, Microsoft SharePoint Foundation Workflow Timer Service, SharePoint Server Search

Database servers

One physical database server runs the default SQL Server instance that has the SharePoint databases. This article does not track the logging database.

Note:

If you enable usage reporting, we recommend that you store the logging database on a separate Logical Unit Number (LUN). Large deployments and some medium deployments might require a dedicated logging database server to accommodate the demand on the processor that a high volume of logging events generates.

In this lab environment, logging was constrained, and the logging database was stored in a separate instance of SQL Server.

Database Server - Default Instance

Processors | 2 Quad-core 3.3 GHz processors
RAM | 32 GB
Operating system | Windows Server 2008 R2 SP1
Storage and geometry | Direct Attached Storage (DAS) Internal array with 6 x 300 GB 15krpm disk External array with 15 x 450 GB 15krpm disk 50 x content data (external RAID10, 2x3 spindles 300 GB each) 50 x content logs (internal RAID10, 2x2 spindle 300 GB each) 1 x temp data (internal RAID10, 2x2 spindles 300 GB each) 1 x temp log (internal RAID10, 2x2 spindles 300 GB each)
Number of network adapters | 1
Network adapter speed | 1 Gigabit
Authentication | Windows NTLM
Software version | SQL Server 2008 R2

Topology

The following table shows the topology for this lab environment:

Lab environment topology

Role | Small deployment (10k users) | Medium deployment (100K users) | Large deployment (500K users)
Web server | 2-4 | 4-8 | 8
Cache | 1 | 1-2 | 3
SQL Server | 1 | 1-2 | 2

Test Process

Important:

  • The tests only model normal business-hour usage on a typical social computing portal. We did not consider the cyclical changes in user-generated traffic that day/night cycles produce. We tested Timer jobs such as Profile Synchronization and People Search Crawl, which require significant resources, independently with the same test workload to determine their effect.

  • The tests focus on social operations, such as newsfeeds, social tagging, and reading people profiles. The test mix includes a small amount of typical collaboration traffic to better simulate a production environment. We expect these results will help to design a separate portal that is dedicated to My Sites and social features.

  • The test mix does not include traffic from the Search Content Crawl.

We conducted tests against small, medium, and large deployments for the social features. To configure server hardware, we started at minimum configurations for the smallest size and populated the test database with the dataset as described in the Scaling approach section.

We used Visual Studio Team System (VSTS) to simulate a workload and apply a characteristic social load, driving a small load against the server at first. We uniformly increased this load slowly and recorded performance metrics on all server roles until we observed maximum RPS. This was recognizable as the state where an increase of the applied load on the farm resulted in no increase in delivered RPS output because of server bottleneck constraints.

From these recorded metrics, we defined green zone and red zone states, which represent the normal and fully loaded states of the VM server at a given computer configuration. We then applied a steady load at both green zone and red zone levels to analyze steady-state performance metrics at these loads. This provided a server health and performance representation of the VM server under these key load conditions for each topology configuration.

After we understood the green and red load characteristics and the scaling curve for each topology, we identified the scaling bottleneck that limited RPS. In the case of social workload, this was typically web server CPU for small datasets. For larger datasets, we also observed memory pressure on the Distributed Cache nodes. We added virtual servers of the overloaded role to the configuration to remove the bottlenecks in each case and continue the scale-out process. We then repeated the analysis of performance trends and their conformity to green and red zone definitions at each configuration size until we achieved requirements for a specific deployment size.

After we understood each deployment size, we reconfigured the test farm to the smallest configuration of the next larger size, populated the dataset as described in the Scaling approach section, and repeated the analysis/scale-out process cycle, and measured scale-out characteristics of each dataset size.

Results and analysis

This section shows the measured results for the three deployment sizes. Specifically, it shows how scaling out the server farm by adding web servers affects green and red zone RPS, latency, and average CPU usage.

The following trends were consistent across all three deployment sizes:

  • Both red and green zone RPS increases linearly with the number of virtual web servers.

  • The primary bottleneck across all tested configurations was the web server CPU.

  • At red zone, latency increases slightly as we add web servers and increase load. This is caused by added pressure on SQL Server and the Distributed Cache service (which is running on all web servers in the test farm).

  • Additionally, average CPU usage on SQL Server and Distributed Cache computers increases as the number of web servers increases. This is caused by additional caching load on the on SQL Server and the Distributed Cache service.

  • Green zone latency remains fairly flat as the number of web servers increases. This is because the web servers are not overburdened at green zone load levels.

Small Scale Results

The following graph shows how increasing the number of web servers affects RPS for both green and red zones.

Screenshot showing how increasing the number of front-end web servers affects RPS for both Green and RED zones in the 10k user scenario.

The following graph shows how increasing the number of web servers affects latency for both green and red zone load levels.

Screenshot showing how increasing the number of front-end web servers affects latency for both Green and RED zones in the 10k user scenario.

The following graph shows how increasing the number of web servers affects average CPU usage for both green and red zone load levels.

Screenshot showing how increasing the number of front-end web servers affects CPU usage for both Green and RED zones in the 10k user scenario.

Medium Scale Results

The following graph shows how increasing the number of web servers affects RPS for both green and red zones.

Screenshot showing how increasing the number of front-end-web servers affects RPS for both Green and RED zones in the 100k user scenario.

The following graph shows how increasing the number of web servers affects latency for both green and red zone load levels.

Screenshot showing how increasing the number of front-end web servers affects latency for both Green and RED zones in the 100k user scenario.

The following graph shows how increasing the number of web servers affects average CPU usage for both green and red zone load levels.

Screenshot showing how increasing the number of front-end web servers affects CPU usage for both Green and RED zones in the 100k user scenario.

Large Scale Results

The following graph shows how increasing the number of web servers affects RPS for both green and red zones.

Screenshot showing how increasing the number of front-end web servers affects RPS for both Green and RED zones in the 500k user scenario.

The following graph shows how increasing the number of web servers affects latency for both green and red zone load levels.

Screenshot showing how increasing the number of front-end web servers affects latency for both Green and RED zones in the 500k user scenario.

The following graph shows how increasing the number of web servers affects average CPU usage for both green and red zone load levels.

Screenshot showing how increasing the number of front-end web servers affects CPU usage for both Green and RED zones in the 500k user scenario.

As the number of web servers increases, the following events occur:

  • Average CPU usage increases for SQL Server and Distributed Cache nodes because of added burden on these shared resources.

  • Average web server CPU usage at red zone slightly decreases because of bottleneck shifting slightly to SQL Server and Distributed Cache computers.

  • Average web server CPU usage at green zone remains constant because servers are kept at recommended load levels.

Recommendations

A successful SharePoint Server 2013 social deployment as measured by performance depends on the following factors:

  • The number of active users who you want to support

  • The expected transaction mix of read and write operations

  • How the load is distributed across the farm servers

The expected number of active users is one key factor to determine the number of servers that you should plan to have in the topology. The number of active users also determines the makeup of hosting of the various services that are required to be enabled for the social scenario across the servers.

Though our testing used a typical dataset and applied the load complexity that you might expect in a real-world customer deployment, every deployment is unique. Your capacity planning effort should consider expected usage characteristics, feature configuration, and hardware resource availability. Some factors that can have an affect or change the capacity numbers in a significant way are as follows:

  • A pattern of increased email usage might increase the load that the Outlook Social Connector generates.

  • A significant increase in the percentage of write actions (for example, an increase in tagging or @mention) in the transaction mix might increase the load on the database server.

  • You can add or remove web servers to balance CPU load between web servers, SQL Server, and Distributed Cache nodes.

Carefully follow standard SharePoint Server 2013 configuration guidance for optimal performance. Considerations that matter specifically for social transactions are as follows:

  • Separate physical disks for Profile DB - Because of the heavy disk usage that social transactions can have on Profile DB, we recommend that you keep Profile DB on its own set of physical disks on the server that runs SQL Server.

  • Memory requirements for User Profile service application - The User Profile service application is located on front-end web servers and relies heavily on its in-memory cache. Make sure that front-end web servers have enough RAM to cache many requests for data. Minimum recommended RAM is 12 GB per front-end web server.

  • Memory requirements for Distributed Cache servers- Social features, microblogging in particular, depend heavily on sufficient and robust Distributed Cache storage. Low memory situations on these computers can degrade the capacity of the SharePoint farm while this cache is being repopulated. Therefore we recommend that you configure servers that host the Distributed Cache to use at least 12 GB of RAM, and scaled out as needed based on total number of users in the deployment.

The SharePoint Server 2013 social deployment makes it mandatory to provision a personal site for every user who wants to use social features. Plan the growth of the creation of personal site collections at the level of the content database . For more information about how to scale personal site collections, see Software boundaries and limits for SharePoint 2013.

See also

Plan for performance and capacity management in SharePoint Server 2013
Software boundaries and limits for SharePoint 2013


Estimate performance and capacity requirements for divisional collaboration environments (SharePoint Server 2013)
See also

Published: July 23, 2013

Summary: Use test results and recommendations to estimate performance and capacity requirements for a divisional collaboration environment for SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

This article describes guidance about performance and capacity planning for a divisional collaboration solution that is based on SharePoint Server 2013. The following information is included in this article:

  • Test lab environment specifications, such as hardware, farm topology, and configuration

  • The test farm workload and dataset that generated the test load

  • Test results and analysis that demonstrate and explain trends in throughput, latency, and hardware demand under load at specific scale points.

Use the information in this article to understand the characteristics of the scenario under both normal and peak loads, and how performance trends change when farm servers are scaled out. This article can also help you estimate an appropriate starting point for your planned architecture, and understand things to consider when you develop a plan to maintain acceptable levels of performance under peak load.

In this article:

  • Introduction

  • Glossary

  • Overview

  • Specifications

  • Results and analysis

Introduction

This article outlines how to scale out servers in a SharePoint Server 2013 divisional collaboration solution. A divisional collaboration solution is a SharePoint Server 2013 deployment that has fewer computers involved in the collaborative activities than an enterprise collaboration solution. This article assumes that a division is an organization inside an enterprise that has 1,000 to 10,000 employees.

Diverse scenarios will have different requirements. Therefore, supplement this guidance with additional testing on your own hardware and in your own environment. If your planned design and workload resembles the environment described in this article, you can draw conclusions about the performance to expect when you scale your environment up and out.

Important:

Test results in this article were produced in a test lab that used a workload, dataset, and architecture to simulate a production environment under highly controlled conditions. While we carefully designed these tests, the performance characteristics of a test lab are never the same as the behavior of a production environment. These test results do not represent the performance and capacity characteristics of a production farm. Instead, the test results demonstrate observed trends in throughput, latency, and hardware demand. Use the analysis of the observed data to help you plan capacity and manage your own farm.

As you read this article, you'll learn about the following:

  • Specifications, which include hardware, topology, and configuration

  • The workload, which includes an analysis of the demand on the farm, the number of users, and usage characteristics

  • The dataset, such as database sizes and content types

  • Test results and analysis to scale out web servers

Before you read this article, read the following articles to make sure that you understand the key concepts behind capacity management in SharePoint Server 2013.

  • Capacity management and sizing for SharePoint Server 2013

  • Software boundaries and limits for SharePoint 2013

  • Estimate performance and capacity requirements for enterprise intranet collaboration environments (SharePoint Server 2013)

Glossary

The following list contains definitions for key terms found in this article.

  • RPS: Requests per second. RPS is the number of requests that a farm or server receives in one second. This is a common measurement of server and farm load.

    Note:

    Requests differ from page loads. A page contains several components, each of which creates one or more requests when a browser loads the page. A single page load creates several requests. Normally, authentication checks and events that use insignificant resources are not counted in RPS measurements.

  • Green Zone: Green Zone represents a defined set of load characteristics under normal operating conditions, up to expected daily peak loads. A farm that operates in this range should be able to sustain response times and latency that are within acceptable parameters.

    This is the state at which the server can maintain the following set of criteria:

    • The server-side latency for at least 75% of the requests is less than 1 second.

    • All farm servers maintain an average CPU utilization of less than 60%.

      Note:

      Our lab environment did not run an active search crawl. So we kept the database server close to 50% CPU utilization or lower to reserve 10% for the search crawl load. This assumes SQL Server Resource Governor is used in production to limit Search crawl load to 10% CPU.

    • Failure rate is less than 0.01%.

  • Red Zone (Max): Red Zone represents a defined set of load characteristics under peak operating conditions. At Red Zone, the farm experiences very high transient resource demands that it can sustain only for limited periods before failures and other performance and reliability issues occur.

    This is the state at which the server can maintain the following set of criteria for a limited duration:

    • HTTP request throttling feature is enabled, but no 503 errors (Server Busy) are returned.

    • Failure rate is less than 0. 1%.

    • The server-side latency is less than 3 seconds for at least 75% of the requests.

    • All farm servers (excluding database servers) maintain an average CPU utilization of less than approximately 90%.

    • Database server average CPU utilization is less than approximately 50%, which allows for ample overhead to be reserved for the Search crawl load.

  • AxBxC (Graph notation): The number of web servers, application servers, and database servers respectively in a farm. For example, 10x1x1 means that this environment has 10 web servers, 1 application server, and 1 database server.

  • MDF and LDF: SQL Server physical files. For more information, see Files and Filegroups Architecture.

Overview

This section provides an overview of our scaling approach and test methodology.

Scaling approach

This section describes the approach that we took to scale our lab environment. This approach will enable you to find the best configuration for your workload:

  • We scaled out the web servers until four web servers were being used. Each server runs the Distributed Cache Service.

  • We added a dedicated server that runs the Distributed Cache Service.

  • We disabled the Distributed Cache Service on the web servers.

  • We scaled out additional web servers to the maximum for the scope of testing.

Methodology and test notes

Because this article contains results from a test lab environment, we could control certain factors to show specific aspects of performance for this workload. In addition, certain elements of the production environment, which are in the following list, were left out of the lab environment to simplify the overhead of testing.

Note:

We recommend that you include these elements in production environments.

  • Between test runs, we modified only one variable at a time to make it easy to compare results between test runs.

  • The database servers were not part of a cluster because redundancy was not necessary for the purposes of these tests.

  • Search crawl was not running during the tests. Of course, it might be running in a production environment. To take this into account, we lowered the SQL Server CPU utilization in our definitions of 'Green Zone' and 'Red Zone' to accommodate the resources that a search crawl would usually consume during testing.

Specifications

This section provides details about the hardware, software, topology, and configuration of our test lab environment.

Hardware

The following sections describe the hardware that we used in our test lab environment.

Important:

We used Hyper-V hosts to virtualize all web servers and application servers in our test lab. Database servers were not virtualized. The physical host hardware and virtual machine virtual hardware are described separately in this section.

Hyper-V Hosts

We used six identically configured Hyper-V hosts for our tests. Each host runs one to two virtual machines.

Host Hardware | Value
Processors | 2 Quad-core 2.49 GHz processors
RAM | 32 GB
Operating System | Windows Server 2008 R2 SP1
Number of network adapters | 2
Network adapter speed | 1 Gigabit

Virtual web servers and application servers

Our test farm uses eight virtual web servers. We also use a dedicated virtual server that runs the Distributed Cache Service.

Note:

Production environments typically deploy dedicated servers that run the Distributed Cache Service in a highly available configuration. In our test lab environment we use a single dedicated server for Distributed Cache because high availability is not an important factor.

VM Hardware | WFE1-8 and DC1
Processors | 4 virtual processors
RAM | 12 GB
Operating system | Windows Server 2008 R2 SP1
Size of the SharePoint drive | 100 GB
Number of network adapters | 2
Network adapter speed | 10 Gigabit (inter-host traffic limited to host network adapter speed)
Authentication | Windows NTLM
Load balancer type | F5 Big IP
Services running locally | WFE 1-8: Basic Federated Services. This includes the following: SharePoint Timer Service, Trace Service, Word Automation Services, Excel Services, and Microsoft SharePoint Foundation Sandboxed Code Service. DC1: Distributed Cache Service.

Database servers

In our tests we use one physical database server and ran the default SQL Server instance that stores the SharePoint databases. We do not track the logging database in this article.

Note:

If you enable usage reporting, we recommend that you store the logging database on a separate Logical Unit Number (LUN). Large deployments and some medium deployments might require a dedicated logging database server to accommodate the demand on the processor that a high volume of logging events generates.

In our lab environment we constrained the logging and stored the logging database in a separate SQL Server instance.

Database Server - Default Instance | SQL Server
Processors | 4 Quad-core 2.4 GHz processors
RAM | 32 GB
Operating system | Windows Server 2008 R2 SP1
Storage and geometry | Direct Attached Storage (DAS) 1 x system volume (RAID0, 1 spindle, 300 GB) 2 x content data volumes (RAID0, 4 spindles, 450 GB each) 2 x content log volumes (RAID0, 2 spindles, 450 GB each) 1 x temp data volume (RAID0, 2 spindles, 300 GB each) 1 x temp log volume (RAID0, 2 spindles, 300 GB each)
Number of network adapters | 1
Network adapter speed | 1 Gigabit
Authentication | Windows NTLM
Software version | SQL Server 2008 R2

Topology

The following diagram shows the topology in our test lab environment.

Test lab topology has 4 Hyper-V VMs that each host 2 web servers and 1 more VM as a domain controller. Physical DB server runs SQL Server 2008 R2 SP1 (1 system volume, 2 content data volumes, 2 content log volumes, 1 temp data volume, 1 temp log volume)

Configuration

The following table shows the significant configuration changes that we made to the database server in our lab environment. These configuration changes allow for optimal test performance and clear relationships between test parameters and results. Note that the MAXDOP setting is required for SharePoint Server 2013. The other setting changes only apply to our test lab environment and may not affect your production environment.

Setting Value Notes

Site collection

179 (total in environment)

The site collections in our test environment use default settings and Windows claims authentication.

BLOB caching

On

The default is Off. If you enable BLOB caching, you improve server efficiency by reducing calls to the database server for static page resources that browsers may request frequently.

Max degree of parallelism (MAXDOP)

1

This parameter is set on the SQL Server instance or instances that contain SharePoint Server 2013 content databases. The default value is 0, which enables SQL Server to determine the maximum degree of parallelism. SharePoint Server 2013 requires MAXDOP to be set to 1 for SQL Server instances that contain SharePoint Server 2013 databases.

For more information about how to configure the MAXDOP setting for SQL Server 2008 R2, see max degree of parallelism Option.

For information about how to configure the MAXDOP setting for SQL Server 2012, see Configure the max degree of parallelism Server Configuration Option.

Workload

This section explains the lab tests that we ran against SharePoint Server 2013. The test details are typical of a divisional collaboration environment.

Lab tests run for divisional collaboration against SharePoint Server 2013. Test details show requests made to server for nine scenarios.

Dataset

The dataset that we used for our test lab environment represents a typical divisional collaboration environment. This dataset contains various site collections, sites, lists, libraries, file types, and file sizes.

Dataset Characteristics | Value
Database size (combined) | 174 GB
MDF size | 154 GB
LDF size | 20 GB
BLOB size | 152 GB
Number of content databases | 2
Number of site collections | 179
Number of web applications | 1
Number of sites | 1,471

Results and analysis

The following results are ordered based on the scaling approach that is described in the Overview section.

Web server scale out

The following sections describe the test results which we obtained when we scaled out the number of web servers in our test lab environment.

Test methodology

  • Add web server that use the same hardware specifications, and run the test again without changes to the farm or test parameters.

  • Measure the RPS, latency, and resource utilization on each server in the test farm.

Analysis

In our tests we found the following:

  • The environment scaled to ten web servers per database server. The increase in throughput was relatively linear.

  • Even up to the maximum tested scale of ten web servers, the addition of more database servers did not increase throughput. The bottleneck was generally confined to web server resources.

  • The average latency at Green Zone was almost constant throughout the whole test. The number of web servers and throughput did not affect Green Zone latency. Red Zone latency data shows an expected trend line. Latency is very high at a single web server. A curve between 2 and 8 web servers remains comfortably within Red Zone criteria.

    Note:

    Latency may be slightly affected when you move the Distributed Cache service from a farm's web servers to a server that is dedicated to the Distributed Cache. This may occur because Distributed Cache traffic, which was previously internal to each web server, begins to cross the network. Test scale-out performance in your own environment to determine whether this tradeoff is significant. Note that latency in our test environment increased slightly when the Distributed Cache service was migrated to a dedicated server. Latency decreased with each added web server as the nominal added latency was offset by the decreased processing and memory load on the web servers.

    For more information about Distributed Cache capacity planning, see Plan for feeds and the Distributed Cache service in SharePoint Server 2013.

  • Because of improvements in caching and database usage characteristics in SharePoint Server 2013, the average load on the database server layer is low. We found that during our tests it was not necessary to scale out the database servers.

  • Performance gains when you add virtual web servers depend partly on host hardware resources and on the resource usage of other virtual computers that are running on the same host. Virtual servers require additional planning and management strategies that are specific to virtualization.

    For more information about Hyper-V performance and capacity planning, see Hyper-V virtualization requirements for SharePoint 2013 and Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment.

Note:

Conclusions in this section are specific to the hardware that makes up the environment. The environment might have achieved the same throughput if the environment used more but less powerful Hyper-V host servers, or fewer but more powerful Hyper-V host servers. An increase of hardware resources on the database server wouldn't greatly affect the results.

Results, graphs and charts

The x axis of the following graphs show the change in the number of web servers in the farm. The scale starts with one virtual web server and one physical database server (1x1). The maximum is eight virtual web servers, one dedicated virtual Distributed Cache server (added at four web servers) and one physical database server (8x1x1).

Note:

The graphs in this section represent the average values for each data point over the duration of the test. All graphs include the RPS baseline for both Green and Red zones to show the relationship between RPS and factors such as latency, server resource utilization, and SQL Server disk usage.

1. RPS

The following graph shows how scaling out affects the RPS baseline.

Illustration of a graph shows requests per second increase as front-end web servers and domain controllers are scaled out.

2. Latency

The following graph shows how scaling out affects latency. Note that Green Zone latency remains almost flat, but Red Zone latency shows increases that are within acceptable limits.

Scaling out front-end web servers and domain controllers affects latency. Green Zone remains flat, while RedZone shows variations.

3. Web server processor and memory utilization

The following graph shows how scaling out affects average processor and memory utilization on the web servers. Note that Green Zone processor utilization and average memory utilization remains relatively constant as RPS increases.

The trend of processor utilization in the Red Zone is down. This downward trend reflects the fact that the average demand of the web server's processor at maximum load gradually declines as the number of servers increases.

Graph shows how scaling out front-end web servers affect processor and memory use. Green Zone remains constant as requests per second and memory use increase. Red Zone shows a decrease as demand on the web server processor reduces when servers are added.

4. SQL Server I/O operations per second (IOPs) and processor utilization

The following graphs show how average disk IOPs (both total and reads/writes) and the values of processor utilization change as the number of web servers is scaled out. We use the following performance counters to measure IOPs values:

  • PhysicalDisk: Disk Reads / sec

  • PhysicalDisk: Disk Writes / sec

The values of each counter over the duration of the test are averaged and then added together to produce total IOPs.

Note:

Because the data for SQL Server memory utilization wasn't available at the time of our tests, this data is not included in this graph.

Important:

These results for IOPs tests are not representative of a production environment because our dataset was much smaller than that of a production farm. This made it possible for a larger percentage of the data to be cached at the web servers than would be possible in a production environment. Because we cached a larger percentage of the data at the web server, the IOPs results in this section are calculated averages that are based on available test data. We expect that our IOPs results are generally lower than IOPs in a production environment. Thorough testing of your own farm in a pilot environment may produce different results.

Note that in the graphs in this section, both IOPs and database server processor utilization show a drop at six front-end web servers, while RPS continues to increase. This variation is also reflected in web server processor utilization as shown in the previous graph.

This shows that the scale of the farm has reached a point at which maximum pressure on the farm server resources was achieved by using the baseline load and dataset. A lower average utilization of server resources is required to support the load on the farm.

It is possible to conclude the following from this trend:

  • Had we increased the test load at the sixth web server scale point, greater RPS could have been achieved while maintaining a flat curve in the utilization of server resources.

  • Had we scaled out the number of web servers further while maintaining the same test load, RPS would have continued to increase while pressure on server resources would have continued a downward trend.

  1. SQL Server Total IOPs

    The following graph shows how scaling out affects total IOPs.

    Graph shows SQL server total IOPs for Green and Red Zones. Both zones increase up to 4 front-end web servers then level and gradually decrease at 8 web servers.

  2. SQL Server IOPs broken down into read and write operations

    The following graph shows how scaling out affects IOPs for reads per second and writes per second.

    Graph shows how scaling out front-end web servers aftects IOPs as per reads and writes per second. Reads and writes per second trend upward to 4 front-end web servers then reads per second gradually decrease while writes per second continue to increase.

  3. SQL Server processor utilization

    The following graph shows how scaling out affects SQL Server processor utilization.

    Illustration of a graph shows the SQL processor and reads per second trend upward as more web servers are added.

See also

Plan for performance and capacity management in SharePoint Server 2013
Performance and capacity test results and recommendations (SharePoint Server 2013)
Estimate performance and capacity requirements for enterprise intranet collaboration environments (SharePoint Server 2013)


Plan for on-premises or hosted virtualization in SharePoint 2013
See also

Summary: Create a well-designed plan to install and configure SharePoint 2013 in a virtual environment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about the planning you have to do before deploying SharePoint 2013 in a virtual environment.

TechNet articles about planning for virtualization

The following articles about planning for virtualization are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Understand and evaluate hosting options for SharePoint farms | This article describes the options available for deploying and running a SharePoint farm and includes information about evaluation criteria.
Building blocks | Virtualization support and licensing in SharePoint 2013 | This article provides support and licensing information about virtualization host computers used for on-premise virtualization.
Building blocks | Support and licensing for Windows Azure in SharePoint 2013 | This article provides support and licensing information about hosted virtualization solutions.
Building blocks | Microsoft Windows Server 2012 with Hyper-V and SharePoint 2013 | This ESG Lab report documents the results of independent, hands-on testing of the performance, scalability, and efficiency of Microsoft's Windows Server 2012 with improved Hyper-V virtualization. ESG Lab tested with a tier-1 virtualized SharePoint 2013 application workload to confirm that Hyper-V can be used to increase scalability and maintain high levels of enterprise-class performance.
Building blocks | Hyper-V virtualization requirements for SharePoint 2013 | This article describes the mandatory computer processor architecture and software requirements for using hardware-based virtualization technologies.
Checklist icon (not checked) | Create a virtualization plan for SharePoint 2013 | This article describes the scope and major elements of a virtualization plan, and identifies the key decision points for the plan.
Building blocks | Overview of farm virtualization and architectures for SharePoint 2013 | This article discusses the key considerations for determining a virtual architecture and provides examples of typical virtual architectures.
Building blocks | Detailed design and system specification process for a virtual SharePoint 2013 farm | This article describes a process to create a detailed architecture design and system specifications for SharePoint 2013 farm that meets performance goals, will scale, and is highly available.

See also

Resource Center: Virtualization for SharePoint Server 2010


Understand and evaluate hosting options for SharePoint farms
See also

Published: May 21, 2013

Summary: Learn about the options for hosting a SharePoint farm and the recommended criteria to evaluate and select a suitable option for your organization.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | Office 365 Enterprise | Windows Server 2008 SP 2 | Windows Azure | Windows Server 2012

As you determine how to host a SharePoint farm, the choices that you make can affect the functionality of the farm. For example, the hosting option that you choose might impact support for SharePoint features, scalability, licensing, and cost. The following information helps you choose an option that is appropriate for your organization's immediate and long range SharePoint strategy.

In this article:

  • SharePoint hosting options

  • Cloud computing

  • SharePoint farm solutions

  • SharePoint Online

  • On-premises SharePoint 2013 solutions

  • Choose a hosting option

  • Use a decision tree to analyze hosting options

  • Conclusion

SharePoint hosting options

You can use several hosting environments to deploy and operate a SharePoint farm. These options range from the traditional farm deployment that runs on physical computers that you maintain to third-party hosted environments and cloud-based services. Each hosting environment enables you to deliver core SharePoint farm features and services. However, differences might cause you to prefer a specific environment.

Cloud computing

Cloud computing is an option to host a SharePoint farm. You could use a public or private cloud. You should understand the concept of cloud computing as you entertain hosting options. A heavily virtualized IT environment is not necessarily a cloud platform.

The NIST-SP 500-291, NIST Cloud Computing Standards Roadmap publication from the National Institute of Standards and Technology (NIST) defines cloud computing:

"The NIST Definition of Cloud Computing identified cloud computing as a model for enabling ubiquitous, convenient, on-demand network access to a shared pool of configurable computing resources (for example, networks, servers, storage, applications, and services) that can be rapidly provisioned and released with minimal management effort or service provider interaction."

The essential characteristics of cloud computing can be summarized as follows:

  • There is on-demand, self-service for users.

  • There is broad network access.

  • There is a shared resource pool for users.

  • There is an ability to elastically scale resources in response to user demand.

  • There is the ability to measure the services, such as network bandwidth and storage that is used by users.

The NIST-SP 500-291, NIST Cloud Computing Standards Roadmap publication also identifies service models and deployment models for the cloud.

The service models are as follows:

  • Cloud Software as a Service (SaaS)

  • Cloud Platform as a Service (PaaS)

  • Cloud Infrastructure as a Service (IaaS)

The deployment models for cloud services are as follows:

  • Private cloud

  • Community cloud

  • Public cloud

  • Hybrid cloud

For more information, see The NIST Definition of Cloud Computing (SP 800-145).

SharePoint farm solutions

Microsoft offers and licenses two categories of SharePoint farm solutions. The solution in the cloud is SharePoint Online, and the on-premises solution is SharePoint 2013.

  • SharePoint Online is a product that Microsoft provides as Software as a Service (SaaS). Users subscribe to the SharePoint service and Microsoft hosts these SharePoint solutions in its data centers.

  • SharePoint 2013 follows the traditional software licensing and installation model. Customers install and configure an on-premises solution on servers that the customer owns and maintains, or on servers that another organization's data center hosts.

The SharePoint hybrid scenario, also described in this article, is not a farm solution in the same sense as the SharePoint Online or SharePoint 2013. That is to say, Microsoft does not offer and license a SharePoint hybrid environment as a solution. The SharePoint hybrid environment is actually a combination of the on-line and on-premises SharePoint solutions.

Compare SharePoint Options contains a summary of the SharePoint features in each solution, licensing information, and subscription information.

SharePoint Online

There are two subscription plans available for SharePoint Online.

  • SharePoint Online stand-alone plan

  • SharePoint Online Office 365 plan

SharePoint Online stand-alone plan

SharePoint Online is a Software as a Service (SaaS) offering that is available as a stand-alone service.

The following resources provide information about SharePoint Online features, subscriptions, and service level agreements.

  • SharePoint feature availability across stand-alone plans identifies the features that are available in both plans.

  • SharePoint Online provides detailed information about subscription options, platform features and service continuity. For more information, see Service Continuity.

  • The Microsoft Online Services Level Agreement (SLA) applies to the SharePoint Online platform. For more information, see Service Level Agreement for Microsoft Online Services.

SharePoint Online Office 365 plan

All Office 365 plans include the SharePoint Online service, but some plans do not support all SharePoint features. SharePoint feature availability across Office 365 plans identifies the SharePoint Online features that are available in Office 365 and the SharePoint 2013 features that are available in each plan.

The following resources provide information about Office 365 features, subscriptions, and service level agreements.

  • Office 365 Platform provides detailed information about subscription options, platform features and service continuity. For more information, see Service Continuity.

  • The Microsoft Online Services Level Agreement (SLA) applies to the SharePoint Online platform. For more information, see Service Level Agreement for Microsoft Online Services.

On-premises SharePoint 2013 solutions

Customers install and configure SharePoint 2013 on-premises solutions on servers that the customer owns and maintains, or on a hosted infrastructure that another organization provides.

SharePoint 2013 is available and licensed as one of the following on-premises solutions:

  • SharePoint Foundation 2013

  • SharePoint Server 2013 Standard CAL

  • SharePoint Server 2013 Enterprise CAL

The scope of available SharePoint features varies among the previous solutions. SharePoint feature availability across on-premises solutions identifies whether a feature is available in a solution.

You can deploy SharePoint 2013 solutions on physical and virtual infrastructures, which include the following environments:

  • On-premises, physical or virtual

  • Private cloud (in-house)

  • Private cloud (hosted)

  • Public cloud

On-premises infrastructure

SharePoint 2013 is deployed and hosted on the infrastructure and platform that a customer's data center provides and maintains. Although the infrastructure can be completely physical, many data centers use a combination of physical hardware and virtualization technologies to host a SharePoint farm.

Note:

You can deploy a SharePoint 2013 farm on Windows Server 2008 Hyper-V technology or other server virtualization technologies that are certified by the Windows Server Virtualization Validation Program (SVVP).

In-house private cloud infrastructure

SharePoint 2013 is deployed and hosted in a private cloud that a customer's data center provides and maintains. A private cloud combines resources, such as servers, storage, and networking, in a data center that you manage. The infrastructure that you create enables you to abstract resources into units so that you can provide applications and resources efficiently. Customers of a private cloud can request services, and you can scale the resources as the demand of the infrastructure changes.

The software that is the foundation for a Microsoft private cloud is Windows Server 2012 and System Center 2012. For more information, see Microsoft Private Cloud and Private Cloud Fast Track.

Hosted private cloud infrastructure

In this scenario the SharePoint 2013 farm is deployed and operated on a private cloud that a service provider's data center hosts. While this solution delivers the same benefits as private and public cloud computing, it eliminates the infrastructure, operations, and maintenance costs. Like the private cloud scenario, Windows Server 2012 and System Center 2012 are foundation products. For more about cloud service providers, see Service Providers.

Note:

Windows Azure Services for Windows Server provides a user experience that resembles what users have when they work with virtual machines and websites on the Windows Azure platform. The Service Management Portal and Service Management API makes this front end for a private cloud possible. Windows Azure Services for Windows is available to service providers and customers who want to implement and management a Windows private cloud. For more information, see Service Management Portal and Service Management API. Download the Service Management Portal and Service Management API Express bits to install the Admin and Tenant portals and the Service Management API on one computer.

Public cloud infrastructure

Public cloud offerings, such as Windows Azure, provide the infrastructure and platform services to host a SharePoint 2013 farm. The key difference between public and private clouds is that public clouds typically use a multi-tenant model, which means the host resources are shared among subscribers and not dedicated to a single customer. For more information, see the following articles:

  • Windows Azure

  • Windows Azure Support

  • SharePoint Deployment on Windows Azure Virtual Machines

SharePoint hybrid solution

An organization can create a hybrid SharePoint environment that consists of a SharePoint Server 2013 on-premises farm and a subscription to a SharePoint Online service. There are several reasons why an organization may choose this approach. SharePoint customers identify the following reasons as the most common for adopting a hybrid solution:

  • The size of an organization does not make it practical to implement cloud computing exclusively, at least not in the short term. The geographical distribution of an organization also affects the level of adoption for cloud computing.

  • Regulatory compliance and governance requirements determine where an organization's content must be stored. This prevents an organization from storing content in the cloud that is hosted in a remote location.

  • Relationships with business partners and vendors may require on-premise farms to maintain these relationships.

  • The nature of the business requires a higher service level than a cloud service can provide.

  • The organization must protect its current investment in IT and maximize the return on investment.

  • Strategic planning and budgeting cycles affect cloud adoption, especially if a large scale migration is required.

  • The hybrid scenario provides a transitional environment from an on-premises deployment to the cloud.

  • A hybrid environment enables you to use preferred features from SharePoint 2013 on-premises and SharePoint Online.

To learn more the hybrid scenario, see Hybrid for SharePoint Server 2013.

Choose a hosting option

Choosing a suitable SharePoint farm hosting option to meet your organization's business goals and objectives is a complex process. Although common elements apply to any organization that is evaluating hosting options, no generic, all-encompassing formula applies to every organization. There are several reasons for this, such as the following:

  • Organizations have unique characteristics and requirements. Organizations in the same line of business differ because of size, geopolitical factors, and so on.

  • The level of technical maturity and scope determines what is or can be handled in-house.

To evaluate these options, you have to define relevant criteria that you can apply to all the options. After you establish these criteria, you have to determine their relative importance and develop a way to evaluate each option. This process may seem to be fairly simple, which is true when you are dealing with quantifiable criteria such as farm uptime (number of nine's) and cost per seat for a subscription. However, there are always intangibles to consider, such as improved productivity and processes.

Identify evaluation criteria

The financial aspect, which includes cost, cost savings and return on investment (ROI) is usually the first criterion in any discussion about hosting technologies. Cost benefits, which are explained later in this section, should not be the only consideration when you select a hosting option.

You should consider many other intangible and difficult to quantify factors when you evaluate hosting options. The following examples apply, in varying degrees, to most organizations and can be used to generate quantifiable evaluation criteria.

  • The role and importance of SharePoint in supporting the current and future business strategy.

  • How the various hosting options fit in the current and future IT strategy.

  • General business, technology and operations requirements.

  • How to measure the actual benefits against the projected benefits.

  • The projected effect that a specific option will have on business processes and staff.

The following table categorizes the items that organizations typically use to identify evaluation criteria. Although there are variations and differences in levels of detail, these categories apply to most IT environments.

Category Item Description

Physical data center

  • Servers and peripherals

  • Network infrastructure including switches and routers

  • Racks and cabling

  • Uninterruptible power supply (UPS)

  • Benches

The physical hardware that consists of the infrastructure to host applications.

Facilities power and environment

  • Power lines and junction boxes

  • Telecommunications lines

  • Air conditioning and fire suppression

  • Facilities maintenance

Facilities requirements to support the data center hardware. There is also a cost associated with maintaining facilities.

Software and applications

  • Licenses

  • Maintenance agreements

Product licensing may include product support. Understand your licenses. Also consider licensing, maintenance, and support for third-party applications.

Hardware, software, and application maintenance

  • New hardware, upgrades, replacement, and recycling.

  • Software updates, patches, and upgrades for SharePoint farm and applications.

New or upgraded hardware that is required to scale out or scale up. Hardware replacement is an alternative to repairs or maintenance of obsolete equipment.

Updates, patches, and upgrades include the operating system, SharePoint software, prerequisite software, and in some cases, application software.

Support and personnel

  • Server infrastructure management and operations.

  • Network infrastructure (LAN and WAN) management and operations.

  • SharePoint farm management and operations.

Support processes, tools, and staff to manage, operate, and maintain the servers. This includes monitoring (performance, capacity and alerts), reporting, troubleshooting, and problem resolution or problem repair.

Support processes, tools, and staff to manage, operate, and maintain the networks. This includes monitoring (performance, capacity and alerts), reporting, troubleshooting, and problem resolution or problem repair.

Support processes, tools, and staff to manage, operate, and maintain the SharePoint farm. This includes monitoring (performance, capacity and alerts), reporting, troubleshooting, and problem resolution or problem repair.

Compliance and governance

  • Data storage location and retention.

  • Off-site backup storage.

  • Security and auditing.

Processes, tools, and staff to make sure that regulatory compliance and governance requirements are monitored, audited, and maintained.

Backup processes and storage requirements for the infrastructure and the SharePoint farm.

Security and auditing requirements for the infrastructure and the farm.

Business continuity and high availability

  • Service levels and Service Level Agreements (SLA).

    • Number of 9s

    • Recovery time objective (RTO)

    • Recovery point objective (RPO)

  • Redundancy to support high availability.

  • Disaster recovery plan

  • Disaster recovery farm

SLA requirements (number of 9s, RTO, and RPO), including ownership and associated costs and penalties.

Redundancy requirements and strategy for the infrastructure and the farm.

Create, maintain, and test a disaster recovery plan.

A recovery strategy and options to recover the farm at another location.

Conversion and migration

  • Content

  • Customizations and applications

  • Accounts

  • Farm settings

For existing SharePoint environments: content migration requirements, and if supported, conversion or migration of customizations and applications. Migration of user accounts and farm settings.

For a new SharePoint farm: possible content conversion and migration to a SharePoint environment, migration or addition of user accounts to farm.

Suitability

  • Solutions

  • Workloads

  • Capacity, performance, and access

  • Scalability

  • Integration

The SharePoint solution on the host can meet the following requirements.

  • Supports the desired features and meets functional requirements.

  • Supports specific workloads identified for the farm.

  • Is able to provide the capacity and meet user performance expectations. Additionally the farm meets access requirements (for example, remote access, support for mobile devices, and business working hours).

  • The farm can scale up or scale out appropriately in response to changes in volume or growth.

  • The farm environment can be integrated with existing products and solutions.

In addition to providing a way to evaluate hosting options, your criteria also give you a way to determine the potential business value that they can provide.

Identify business value

Available processes and tools enable you to calculate total cost of ownership (TCO) and return on investment (ROI) for investments in computer technology. Typically, TCO and ROI are tangible and easy to calculate when you are dealing with the hardware, software, and other aspects of IT in an organization. However, the service-based cloud computing model introduces intangible benefits that make it difficult to measure ROI.

Note:

The traditional ROI model works well for IT purchases that you treat as a capital expense. Initial costs, such as asset purchases, are combined with recurring costs, such as maintenance, to produce qualitative metrics to justify expenditures. These metrics include costs savings, productivity gains, time savings, and others.

Business and IT experts frequently identify the following benefits or business value that cloud computing provides.

  • Rate of adoption

    An organization can set up and use cloud services almost immediately You don't have to obtain, install, and configure an infrastructure to support a SharePoint farm.

  • Flexibility and speed of change

    Reduced cost enables an organization to adapt quickly to changing market trends and remain competitive.

  • Reduced TCO

    Cloud computing reduces in-house technical skill requirements, maintenance costs, and implementation costs.

  • Rapid resource adjustment

    The cloud platform supports dynamic and rapid adjustment of resources in response to an organization's needs. For example, you can scale in response to growth or reduction.

  • IT cost control

    The cloud enables an organization to effectively manage IT costs by reducing the risk of over or under provisioning IT technology and services.

  • Process improvement

    An organization can focus on how to improve processes in response to market changes instead of how to manage solutions and applications.

The following articles help you understand how to measure cloud ROI and business value.

  • 8 Ways to Measure Cloud ROI, written by Mark Skilton for CIO magazine in 2010 is still applicable and recommended reading.

  • Published in Forbes Magazine, Is ROI the Right Measure of Cloud Success? was written by Daryl Plummer, a managing vice president and Gartner Fellow. Gartner has a site dedicated to Cloud Computing Research

TCO and ROI resources

Many resources and tools help you model and analyze investments in information technology. The following organizations are well-known and experienced in this area.

  • Alinean; ROI and TCO tools (http://www.alinean.com )

  • Glomark - Governan; Enterprise Value Creation (EVC™ ) (http://www.glomark-governan.com )

  • McKinsey; Valuation: Measuring and Managing the Value of Companies (http://www.mckinsey.com )

  • IDC; The Hidden Costs of Information Work (http://www.idc.com)

  • Forrester; Total Economic Impact (TEI) (http://www.forrester.com/TEI )

  • Gartner; Guidance Framework for Creating a Defensible Business Case (http://www.gartner.com )

  • Cranfield School of Management; Managing the Realization of Business Benefits From IT Investments (http://www.som.cranfield.ac.uk/)

Use a decision tree to analyze hosting options

Decision tree analysis is a common method to evaluate the value of different decisions. This method provides a visual and analytical decision support tool that calculates the expected values of alternatives. This technique allows for the assignment of values to various decision paths. The result is a final "expected value" of any one path. The "expected values" typically highlight one decision as more favorable than another.

The following example shows how a company used a very simple decision tree to analyze the hosting options for a SharePoint farm. Realistically, every organization will have different criteria for selecting an option but this example can be adapted to meet the requirements of different scenarios.

In this example Contoso is a Widget manufacturer with a global user base. Although Contoso's leadership supports deploying a SharePoint farm, the organization has not chosen a hosting option. The company has the following options to evaluate: on-premises on physical servers in the organization's Windows Server 2003, Datacenter Edition or on a cloud platform. Another decision is the type of cloud: private (SharePoint 2013 deployed on-premises running on Hyper-V host servers) or public (SharePoint Online)?

Contoso identified the following criteria as the most important to support its business:

  • The level of SharePoint farm uptime availability for its global user base.

  • A lower total cost of ownership (TCO) in relation to the current physical IT environment.

  • The ability to customize SharePoint functionality when the farm is hosted in a specific environment.

Assign weights to criteria

Before the Contoso team created the decision tree, it assigned a weight to each of the criteria to identify relative importance. The weight might be based on a number scale and percentage system. Regardless of the approach, the idea is to have a way to quantify the criteria. For example, how important is availability compared with TCO and customizability? Using 1 as the total for all the options, the team assigned the weights that are in the following table.

Criteria | Weight
Availability | .45
TCO Reduction | .30
Customizability | .25

Create a tree with decision paths for the options

After the Contoso team assigned weights to criteria, it created the decision tree in the following illustration. Standard symbols are used to represent decision points (squares) and criteria evaluation point (circles.) When you refer to the illustration, note the following:

  • The first decision point is at the root of the tree, where the choices are an on-premises option or a public (off-premises) option.

  • Following the on-premises branch, the next decision point is between the virtualized, private cloud option and physical servers. Each of these options uses the criteria evaluation points that the Contoso team established.

  • Following the public branch, the next decision point is between the hosted private cloud option and the public cloud. Each of these options uses the criteria evaluation points that the Contoso team established.

Hosting options decision tree with weighted critera for each path.

Score the options in each decision path

The Contoso team then reviewed all of the criteria in each path and assigned scores to the criteria. The scale is 1-10; 10 is the best score. The following illustration shows the scores that the team assigned to all the criteria for each option.

Hosting options decision tree with weighted criteria and scores for the criteria.

Calculate total expected value for each path

The final step in the decision tree analysis was to calculate the total expected value for each path. The Contoso team used the following steps to calculate these values for each option.

  • Multiply the weight by the score to obtain a result for each criterion.

  • Add the results for each criterion in a path to get a total for the path.

The following illustration shows the final results of the Contoso decision tree analysis.

Hosting options decision tree with final scores calculated for each option.

Based on the results of their analysis the Contoso team decided that the Public cloud option, with a score of 7.75, was the best choice to host its SharePoint farm.

The following table gives a summary of the decision tree analysis.

Location Option Criteria Weight x score Result Total score

On-premises

Virtual, private cloud

  • TCO reduction

  • Availability

  • Customizability

  • .30 x 4

  • .45 x 7

  • .25 x 10

  • 2.50

  • 3.15

  • 2.50

6.85

On-premises

Physical servers

  • TCO reduction

  • Availability

  • Customizability

  • .30 x 1

  • .45 x 7

  • .25 x 10

  • 0.30

  • 3.15

  • 2.50

5.95

Off-premises

Hosted private cloud

  • TCO reduction

  • Availability

  • Customizability

  • .30 x 5

  • .45 x 9

  • .25 x 8

  • 1.50

  • 4.05

  • 2.00

7.55

Off-premises

Public cloud

  • TCO reduction

  • Availability

  • Customizability

  • .30 x 9

  • .45 x 9

  • .25 x 4

  • 2.70

  • 4.05

  • 1.00

7.75

Conclusion

Many resources and tools can help you to analyze data, create models, and produce metrics. However, the value of these results depends on the quality of the data that you provide. Your evaluation criteria and weights must be relevant and sufficient to accurately reflect the business requirements of the SharePoint farm. Finally, when you evaluate the business value of a hosting option, consider the intangible benefits in addition to the financial aspects. A balanced approach makes sure that you consider all aspects of investment, which in turn, contributes to selection of the optimal solution to host the SharePoint farm.

See also

SharePoint Online
SharePoint 2013 Overview
Windows Azure
Microsoft Private Cloud


Virtualization support and licensing in SharePoint 2013
See also

Summary: Microsoft licenses and supports several virtualization technologies for deployment of SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article provides information about support and licensing for using several virtualization technologies to deploy SharePoint 2013 in a virtual environment.

Support

SharePoint 2013 supports virtualization that includes any required products, such as SQL Server, when you deploy the products in a Windows Server 2008 Hyper-V technology or Hyper-V Server 2008 environment or any virtualization solution that the Server Virtualization Validation Program (SVVP) validates. For more information, see the Server Virtualization Program FAQ.

Note:

The SVVP only validates virtualization products and all versions of Windows Server running on server hardware that is certified for Windows Server 2008 R2.

SharePoint 2013 is not supported on virtualization environments that are not explicitly referenced under the Server Virtualization Validation Program.

Licensing

You must ensure that your virtualization solution meets all the licensing requirements. The Microsoft Volume Licensing page provides information about licensing for virtual environments. We recommend that you use the Windows Server 2008 R2 Virtualization Calculator to estimate the number and cost of Microsoft server licenses for your virtualization scenario.

SharePoint 2013

Every element of a SharePoint products farm that is installed on a virtual machine must comply with the licensing requirements for SharePoint 2013 and related and supporting technologies.

For information about licensing other Microsoft Server products in a virtual environment, get a copy of the Microsoft Volume Licensing Brief: Licensing Microsoft Server Products in Virtual Environments.

See also

What's New in SharePoint 2013 Resource Center
Installation and deployment for SharePoint 2013 IT pros Resource Center


Support and licensing for Windows Azure in SharePoint 2013
See also

Summary: Microsoft licenses and supports the Windows Azure technology for deployment of SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Before you deploy SharePoint 2013 on the Windows Azure platform, you should understand the support and licensing information.

Support

You can install SharePoint 2013 and related products, such as SQL Server, on the Windows Azure platform.

Important:

We do not support FAST Search Server 2010 for SharePoint products deployments on Windows Azure.

Licensing

You must ensure that your Windows Azure virtualization solution meets all the licensing requirements.

SharePoint 2013

Every element of a SharePoint 2013farm that is installed on Windows Azure virtual machines must comply with the licensing requirements for SharePoint 2013 and related and supporting technologies.

Windows Azure and other Microsoft Server Products

For more information about Windows Azure licensing and costs, go to the Windows Azure site.

For information about licensing other Microsoft Server products in a virtual environment, see LICENSING MICROSOFT SERVER PRODUCTS IN VIRTUAL ENVIRONMENTS (http://go.microsoft.com/fwlink/p/?LinkId=212535).

See also

What's New in SharePoint 2013 Resource Center
Installation and deployment for SharePoint 2013 IT pros Resource Center


Hyper-V virtualization requirements for SharePoint 2013
See also

Summary: Windows Server 2008 Hyper-V technology has specific processor requirements and is only supported by specific versions of Microsoft Windows Server products.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article provides hardware and software requirements for hardware-based virtualization. Ensure that your plans for a SharePoint 2013 environment comply with supported products. Although Windows Server 2008 Hyper-V technology is the focal point of this article, the basic hardware requirements for hardware-based virtualization also apply to third-party virtualization technologies that Microsoft certifies. For more information, see Plan for on-premises or hosted virtualization in SharePoint 2013.

Hardware

The requirements for hardware-based virtualization are as follows:

  • Hardware-assisted virtualization, which is available in processors that include a virtualization option—specifically processors with Intel Virtualization Technology (Intel VT) or AMD Virtualization (AMD-V) technology. Although today's processors support hardware-assisted virtualization this is not always the case for older chipsets. Your hardware manufacturer can provide this information.

  • Hardware-enforced Data Execution Prevention (DEP) is available and enabled.

Software

One of the following Microsoft products is required for Hyper-V:

  • Windows Server 2008 (all editions of Windows Server 2008, except for Windows Server 2008 for Itanium-Based Systems, Windows Web Server 2008, and Windows Server 2008 Foundation)

  • Hyper-V Server 2008

  • Windows Server 2008 R2 (all editions of Windows Server 2008 R2, except for Windows Server 2008 R2 for Itanium-Based Systems, Windows Web Server 2008 R2, and Windows Server 2008 R2 Foundation)

  • Hyper-V Server R2

We recommend Windows Server 2008 R2 for virtualization servers because of the many improvements that Hyper-V introduces, such as:

  • Live migration to move a running virtual machine from one cluster node to another

  • Significant gains in performance and scalability

  • Enhanced processor support

  • Enhanced virtual machine storage

  • Enhanced networking support

For more information, see What's New in Hyper-V in Windows Server 2008 R2.

Note:

Windows Server 2008 R2 Service Pack 1 is supported for SharePoint 2013 but we recommend that you read Windows Server 2008 R2 Service Pack 1 before you install this service pack.

See also

Virtualization support and licensing in SharePoint 2013

What's New in SharePoint 2013 Resource Center
Installation and deployment for SharePoint 2013 IT pros Resource Center


Overview of farm virtualization and architectures for SharePoint 2013
See also

Summary: Determine a high level architectural configuration for a virtual SharePoint 2013 farm that is based on your business requirements and available options.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article discusses the key design considerations and options for a virtual architecture that can support your SharePoint 2013 farm. This article includes examples of architectures for small, medium, and large farms.

Introduction

Regardless of the reasons for virtualizing SharePoint 2013 or the stage of adopting virtualization, the design of a virtual SharePoint 2013 architecture has to support your long term and immediate business and IT goals and accommodate future changes.

Architects who plan a virtual environment often apply the requirements for a SharePoint solution that was deployed in a physical environment to the virtual environment. This includes elements such as farm topology, capacity and performance requirements, and business continuity. You can use the number of database servers, front end web servers, and application servers — including specific application server roles — to determine the number of virtual machines and virtualization host server computers that a virtualized farm requires.

Note:

A virtual environment requires additional virtual servers to achieve the same overall performance as physical servers that serve the same roles. This is a reality of virtualization. Because of hypervisor overhead, a virtual machine that is configured the same as a physical computer (for example, same number of processors, same amount of memory, and same hard disk configuration) cannot match the performance of a physical computer.

This article does not include prescriptive guidance for server size and performance, availability, or growth. It describes the key considerations and general guidance to help you plan a preliminary, high-level architecture that you can use to develop a detailed architecture design. Prescriptive guidance and topology analysis is in Detailed design and system specification process for a virtual SharePoint 2013 farm.

Identify system requirements

Before you design a virtual architecture and the supporting infrastructure, you have to identify system requirements. In many instances, you can use an existing or planned SharePoint solution, and the physical infrastructure that supports the solution.

Whether SharePoint Server or SharePoint Foundation is already deployed can affect the process of determining requirements and making design decisions. The current state of virtualization technology in an organization is another factor.

SharePoint products

If you have an existing SharePoint farm, you can use historical benchmark data and usage profiles as a starting point to determine virtual machine configurations for the different server roles in the farm. For example, concurrent connections, types of requests, and peaks in demand are useful types of data. After you have the virtual machine requirements, you then determine the number and capacity of the host servers that you require to support the virtual farm servers.

If you are upgrading an existing farm, remember that you have to have new benchmark data to validate your assumptions. This is a requirement because customers typically clean up and architect their SharePoint solutions again as part of the upgrade, which we recommend. Another reason to collect new data is that you might add functionality to the farm. SharePoint 2013 also provides new features and redesigned features, such as Search.

For new deployments, you have to base your starting requirements on the SharePoint 2013 planning, design, and sizing documents that are available in the Microsoft TechNet Library. After that you have to test, resize, and retest until you feel comfortable with your farm design.

Virtualization

If virtualization is a mature technology in your organization then you have the experience and resources to develop fairly accurate picture of the physical infrastructure requirements for the farm. This includes host sizing, virtual machine distribution across the hosts to meet expected performance demands, and high availability.

If your organization is just starting to adopt virtualization for applications such as SharePoint 2013, then you probably have a shortage of resources and expertise to implement a virtual farm. You would have to plan and complete several pre-production phases to collect benchmark data and tune configurations until they are ready for a pilot project.

It is important to remember that at this point your requirements and proposed design are preliminary. You will have to adjust the design as you develop a detailed design to deploy a farm in a proof-of-concept (optional), pre-production (pilot), and production environment.

Identify farm server roles to virtualize

Identifying the server roles that you want to virtualize is related to the broader virtualization goals and objectives of your organization. Clearly, if the goal is implement an architecture where all the SharePoint farm servers are virtual, then the pros and cons of server selection is not an issue. In a homogeneous environment, the criteria for the design of the architecture are based on operational requirements such as performance and capacity and the host infrastructure that is needed to support the farm.

Although server virtualization is fully supported for all the server roles of SharePoint 2013, the server role alone is not the determining factor in deciding whether to virtualize some farm servers or all of the farm servers. Several factors will affect your virtualization strategy and architecture: IT constraints, host server capacity, and operations.

  • IT constraints

    Many organizations do not support or allow IT departments to virtualize database servers. This policy is typical in organizations that have dedicated database teams that tightly manage and maintain SQL Server. In these controlled deployments, the database team has to create all databases. Virtualizing SQL Server is not an option.

  • Host server capacity

    The availability of host hardware than can adequately support the requirements of all the roles is something else to consider. For example, the CPU and memory requirements of a virtual database server are greater than a web server or application server. The issue of host hardware capabilities happens when you re-purposing existing hardware as part of a virtualization strategy.

  • Operations

    Managing and maintaining a virtual farm environment is complex and requires specific skills and tools. You have to manage the farm on the virtual level and the physical host level. If you deploy SharePoint 2013 in a partly virtualized environment, you have to deal with the virtual machines and their hosts. Additionally you have to maintain the physical computers that are used for specific roles. The result is that you must have three sets of skills, tools, and procedures to support the farm. Full virtualization reduces the support requirements and simplifies support for the operations team.

If there aren't any constraints about virtualizing specific server roles, and you don't know whether to virtualize some or all of the servers, the next step is to review all of the server roles and decide which ones to virtualize.

Virtualizing web servers and application servers

The front end web server and application server roles are usually the first choices for virtualization.

The web server role is usually the first choice for virtualization because the workload demand on these servers is usually much lower than on other servers in a farm. As a result you can configure the virtual machine for this role to use fewer processors, less memory and fewer (and smaller) hard disks. The smaller resource footprint means that you can deploy more front end web servers on a single host than a highly specialized and resource-intensive system such as a database server, and in some cases, an application server. For organizations that are just starting to move to virtualization, virtual machines for the Web server role are easier to plan for than the other roles, have the lowest virtualization host requirements, and are perceived as having the lowest risk in a production environment

Application servers are also good initial candidates for virtualization. Depending on the degree of specialization, which is reflected by services they provide, they do not always have low resource requirements. A good example is an application server that hosts the search crawl component.

Virtualizing SQL Server

IT professionals vigorously debate whether to virtualize SQL Server. Until recently the conventional wisdom was to avoid virtualizing the database server. As is the case for other farm servers, hypervisor imposes a performance cost. You have to define your performance goals and collect benchmark data before you decide whether to virtualize SQL Server. Even with SQL Server optimizations for virtualization and performance improvements in the Windows Server 2008 R2 Hyper-V role, a virtual database server will not outperform a physical server that uses the same configuration. However, if you scale up the virtual database server configuration, you can achieve the same overall throughput at a slightly increased CPU usage cost.

We recommend that your database virtualization decision also accounts for virtual processor requirements in relation to the number of host server cores, high availability, and options for optimizing storage. In the final analysis, the benefits of deploying SQL Server on a virtual machine can often outweigh the performance cost.

For more information, see Running SQL Server 2008 in a Hyper-V Environment - Best Practices and Performance Recommendations.

Virtualizing other servers in the IT infrastructure

SharePoint 2013 solutions usually rely on other servers in the IT environment. This section provides general guidance about how to factor these dependencies into your virtual architecture.

Active Directory Domain Services (AD DS)

We recommend that you host the root domain controller for an Active Directory Domain Services (AD DS) environment on a physical server outside the virtual environment. If needed, you can deploy additional domain controllers as virtual servers.

For more information about how to deploy AD DS in a virtual environment, see the following resources:

  • Blog by Sander Berkouwer: Active Directory in Hyper-V environments, Part 2

  • Planning Considerations for Virtualized Domain Controllers

Microsoft gateway products

Gateway products for SharePoint 2013 include the following:

  • Forefront Unified Access Gateway 2010 (UAG) delivers comprehensive, secure remote access to corporate resources for employees, partners, and vendors on both managed and unmanaged PCs and mobile devices.

  • Forefront Threat Management Gateway 2010 (TMG) is a secure web gateway that provides comprehensive protection against web-based threats by integrating multiple layers of protections into a unified solution.

For high availability, we recommend that you position these products outside the SharePoint 2013 virtual environment. For more information about how to set up virtual environments for these gateway products, refer to the product documentation.

Additional design considerations

After you've collected information and created a draft design, you still may have concerns about performance if specific SharePoint 2013 server roles are virtualized. If performance is still a major factor in completing your architecture, then consider testing specific roles that are candidates for virtualization. You can use the test results to decide how many virtual servers to deploy for a specific role, or even whether to deploy a specific role in the virtual environment. For example, if your farm crawls a high volume of content, the results of your tests may indicate that you should leave the crawl role on a physical server or install the role several virtual machines.

One way to conduct your tests is to deploy a specific role on a virtual machine and on a physical computer. The tests that you use are very important because they have to adequately measure the role. For example, tests that measure the number of requests and types of content that is served are meaningful for a front end web server but not for an application server that is dedicated to crawling content. After you finish your tests compare the benchmark data for the performance counters that are meaningful as a performance measure. These counters are typically one or more of the following: memory consumption, CPU utilization and Input/Output Operations Per Second (IOPS). For some scenarios network throughput is also an important performance indicator. The following illustration provides an example of how to test specific server roles by using a limited number of servers.

How to test specific server roles

Rotate roles for side-by-side testing

In this illustration, specific roles are deployed to the virtual environment. A physical test server is set up to test each role, one at a time so that you can collect side-by-side benchmark data. Be sure to account for the differences between the physical and virtual environments that might affect test results, such as different hardware specifications.

If you have an existing farm, you can add a virtual host and swap in virtual machines that have equivalent roles to see how the virtual performance for each role is affected. You can also see how different combinations of roles affect the overall performance of the farm. The following example shows this idea.

How to swap roles in the physical and virtual environments

Swap roles in and out of the virtual environment

Example virtual architectures for small to medium size farms

To start to use a virtual farm to replace a physical farm, use two to four physical host servers. For each host, available memory, CPU, disk, and network resources dictate the number of servers that you can be deploy.

The following two illustrations provide example deployments in which the web server and application server roles are deployed to a virtual environment.

Web server and application server roles in a proof-of-concept virtual environment

Use fewer virtual machines for proof of concept

In the previous example, you should be aware of the following:

  • The minimum resources for CPUs and RAM are starting points for the farm. Because only two cores are reserved for each virtual image, this example is only appropriate for proof-of-concept or development environments in which performance is not an issue. Reserve enough spare resources to reallocate based on performance monitoring.

  • SQL Server is deployed to physical servers, instead of to virtual servers.

  • Web servers and application servers are redundant across the two host servers.

  • Three web servers are deployed to the virtual environment for high availability.

  • The AD DS domain controllers are deployed to physical servers.

For pilot testing and production environments, four cores are the minimum recommended starting point for virtual machines. The following virtual environment uses fewer virtual machines to achieve this objective.

Web server and application server roles in a pilot testing virtual environment

Use fewer virtual machines for a pilot environment

This example represents a starting-point environment. You might have to add resources, depending on the usage pattern of the farm.

Example virtual architectures for medium to large size farms

You can allocate more resources to virtual images if you use larger host servers. The following illustration provides an example implementation that uses more CPUs and RAM.

Web server and application server roles with increased RAM and more CPUs in a virtual environment

Using more CPUs and RAM

If the benefits of virtualizing SQL Server outweigh the performance tradeoffs, you can deploy SQL Server as a guest also, as shown in the following illustration.

SQL Server deployed in a virtual environment

Deplyoying SQL Server as a guest

In the previous example, you should be aware of the following:

  • Only one instance of SQL Server is deployed to each host. In small and medium size virtual environments, we recommend that you do not deploy more than one SQL Server guest per host.

  • Both host servers include more memory to accommodate the number of virtual servers, including SQL Server.

If a particular server role consumes so many resources that it adversely affects the overall performance of the virtual environment, consider dedicating a physical server to this role. Depending on the usage patterns of an organization, these roles might include crawl servers, the server that imports profiles, Excel Services application, or other services that are used heavily. The following illustration provides an example.

Use a physical server for a role to improve performance

Dedicate a physical server to a role

In this example:

  • SQL Server is deployed to physical servers. Remove SQL Server from the virtual environment before you remove application server roles.

  • The crawl role is deployed to a physical server. In some environments, a different role might be a candidate to deploy to a physical server, depending on usage.

See also

Resource Center: Architecture Design for SharePoint Server 2013


Create a virtualization plan for SharePoint 2013
See also

Summary: Learn about what to plan before you install, configure, and test SharePoint 2013 in a Windows Server 2008 environment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A virtualization plan includes critical elements, key planning tasks, and decision points. Your plan's scope and level of detail determines the success of a SharePoint 2013 deployment in a test, pre-production, or production virtual environment.

In this article:

  • Introduction

  • Obtain reference material and tools

  • Evaluate in-house resources and infrastructure

  • Create a project team

  • Identify virtual farm requirements

  • Determine virtualization scope and architecture

  • Identify virtual infrastructure requirements

  • Identify virtualization management and maintenance requirements

  • Create a deployment plan

  • Review and adjust the plan

Introduction

In the real world, phases do not always depend on preceding phases. You can do many planning tasks concurrently. The major phases in this planning document are organized sequentially to show the logical flow of information gathering, decision-making, and plan creation. These phases and suggested sequence are not absolute; you can, and should, change the sequence and tasks to suit the needs of your organization. The goal is that the final plan contains all the information that you need to deploy SharePoint 2013 in a virtual environment.

Article scope

Although this article focuses on Windows Server 2008 Hyper-V technology, you can apply our planning concepts, guidance and tasks to any virtualization solution that the Server Virtualization Validation Program (SVVP) validates. For more information, see the Server Virtualization Program FAQ

The following subjects are mentioned in this article, but detailed information about each subject area is provided in separate articles.

  • Business continuity

  • Security

  • Performance and capacity

  • Maintenance and operations

Obtain reference material and tools

Reference material and tools that are relevant to the technologies that you plan to deploy are valuable as you plan. They reduce the possibility of missed steps, and templates or tools reduce errors and add to consistency. We recommend that you obtain copies of the following:

  • Microsoft Assessment and Planning Toolkit

    Note:

    This guide is updated to include Windows Server 2008 R2.

  • Infrastructure Planning and Design Guides for Virtualization

    The collection of Infrastructure Planning and Design Guides includes guides for Windows Server 2008, SQL Server 2008, SQL Server 2008 R2 and System Center (2008).

    Note:

    Announcements about updated or new guides are published at this location.

  • Microsoft Deployment Toolkit (MDT) 2012

  • Hyper-V Planning and Deployment Guide

  • Planning documentation for SharePoint 2013

We recommend that you review the entire list of Solution Accelerators at Solution Accelerator Downloads to see if there are additional Solution Accelerators that you can use for your virtual farm.

Evaluate in-house resources and infrastructure

A critical first step when you create your plan is to inventory, document, and assess the availability of in-house resources and the technical infrastructure. The availability of adequate resources and infrastructure are determining factors when you plan how to budget, schedule, implement, maintain, and use SharePoint 2013 in a virtual environment.

If you do not have detailed specifications for the farm servers and virtualization server hosts, you can still derive a preliminary definition for system requirements. As you move forward in the planning process, you will refine the farm requirements and assess the available in-house resources and infrastructure again.

The minimum base requirements for a virtual farm are as follows:

  • Windows Server 2008 R2

  • Hyper-V

  • SharePoint 2013

  • SQL Server 2008 R2 or SQL Server 2012

  • A suitable hardware, storage, and network infrastructure to support the farm.

You have to verify the base technologies that are available to determine what you can reuse or what you have to buy for the virtualization project. In either case, you have to identify all the infrastructure deployment requirements and a schedule to have everything in place in time to deploy the farm. For the existing technologies, you have to evaluate the breadth and depth of in-house knowledge and experience that you can use to support the virtualization project. The presence or absence of these elements affects several aspects of your virtualization project, which include but is not limited to the following:

  • Implementation costs exclusive of hardware, software and licensing.

  • Human resource requirements.

  • Training requirements (schedule and cost) for users and the IT group.

  • Hardware sizing and costs, which you derive from existing or new benchmark data.

  • Pre-production phases and benchmark requirements.

  • The time will take to put the farm into full production.

After you finish your assessment you can then decide whether you can use in-house resources to handle all aspects of your virtual farm implementation. If external resources such as vendors or partners are required, identify the project tasks that you have to outsource.

You should also consider outsourcing other tasks to free up in-house resources who can focus on implementation. In the process, you can add to the in-house skillset and the organization's knowledge base. The use of outside resources changes the total project, and there may be other significant changes, such as changes to the schedule. If you decide that outsourcing is the best alternative for certain tasks, you have to incorporate the schedules of the external teams in the plan.

When you inventory and evaluate the infrastructure, you must also include existing IT policies, procedures, standards and best practices. A well-scoped infrastructure assessment highlights additional technical requirements such as hardware, software, and licenses, and also determines capabilities and limitations in the context of virtualization. A well-known example is virtualizing database servers, which is not permitted in many organizations, especially those that have a team that is dedicated to database support.

Create a project team

A project team is made up of suitable personnel who have the experience or skills that are required for different phases of the project. For example, technical members of the team collect and analyze benchmark data. However, non-technical team members who understand workflows between business units are very important for different aspects of user acceptance testing. In addition, team members aren't necessarily engaged in all the project phases. For example, a member of the legal team may only be engaged in establishing governance requirements for the farm. Representatives from different business units would only be involved in user acceptance testing for the SharePoint features that affect their teams.

A project team typically has the following members:

  • IT staff from the necessary product support areas (for example, database and networking) define initial benchmark criteria for the project. During the deployment phases they collect and analyze data, and validate/refine the benchmarks.

    Note:

    User acceptance testing. As is the case with farm testing in a physical environment, users from each business unit that is affected by or will use the farm participate in user acceptance testing. The fact that the platform is virtualized should be transparent to the users.

  • Assuming that there is some degree of customization, members of the development team validate functionality and behavior and debug farm elements as the project moves through each deployment phase.

    Note:

    It might be necessary to revalidate custom code that is now running on virtualized farm servers versus a solution that was designed to run, or was already running on physical servers.

You have to clearly lay out expectations, identify responsibilities, and obtain commitments before the project starts to guarantee that you have sufficient team and specific time commitments. Finally you must work with all the team members to establish acceptance criteria which will be used to determine when the farm can be put into production.

Identify virtual farm requirements

We recommend that you approach design of a virtual farm in the same way that you design a physical farm. Most issues and requirements to deploy on physical servers apply equally to virtual machines. Any decisions that you make, such as minimum processor or memory requirements, have a direct effect on the number of servers in the farm topology and corresponding virtualization host requirements. The host computers must have sufficient resources to support the virtual machines that you identify for the farm.

The following list shows some typical farm requirements that apply to physical and virtual farms.

  • Identify the required roles (for example, queries) for a specific SharePoint solution.

  • Decide how to distribute the SharePoint roles on farm servers.

  • Determine how many servers are needed for the farm.

  • Decide how each server needs to be configured.

The starting point to determine farm server specifications are the minimum hardware and software requirements for SharePoint 2013. For more information about these requirements (such as specific updates that you must install), see Hardware and software requirements for SharePoint 2013.

The next steps are to refine farm server specifications by using benchmark data from an existing SharePoint farm or from benchmark tests that are based on published performance and limits guidance.

Important:

If you use benchmark data from an existing farm, you still have to run benchmark tests.

Important:

Given the same configuration (number of processors, amount of memory, and hard disk size) the results of previous benchmark tests consistently show that a virtual machine has lower overall performance (for example, average response time, requests per second, and lower IOPS) than a physical computer. You must take these results into account when you design a virtual farm topology.

Determine virtualization scope and architecture

As you begin to design your architecture you have to decide whether to virtualize all the farm servers or have a mix of virtual machines and physical computers.

If your strategy is to implement a heterogeneous SharePoint virtualization environment, then you have to identify servers that are the best candidates for virtualization. From a technical and Microsoft support perspective, all servers that run SharePoint 2013 can be virtualized. The decision to virtualize a particular farm server should be based on specific requirements and considerations, such as the following:

  • Corporate compliance policies (for example, legal and technical) might not support virtualization, or virtualization host server and storage location.

  • Estimated performance and capacity requirements.

  • Security requirements.

  • Support and maintenance requirements

For more information about virtualization scope and architectures, see Overview of farm virtualization and architectures for SharePoint 2013.

After you create a topology design for a physical farm, you have a starting point that you can use to design a virtual architecture. Ideally, this architecture is as close as possible to the final virtualization solution that you intend to put into production. Realistically, the architecture is likely to change as you move through the deployment phase of the system life-cycle. For more information, see Detailed design and system specification process for a virtual SharePoint 2013 farm.

Note:

As you develop benchmarks during the pilot and pre-production phases of deployment, you may decide that some server roles are not the best candidates for virtualization. If the scope of your virtualization is a homogeneous environment then you have to scale up or scale out to improve performance.

Identify virtual infrastructure requirements

Determine the minimum virtualization server host requirements (amount of memory, number of sockets (physical processors) and cores, number and size of local hard disks, number of network adapters).

Important:

The number of physical processors determines licensing cost for Windows Server virtualization. For more information, see Virtualization support and licensing in SharePoint 2013.

You should also consider and plan for the following:

  • Scalability

    Determine if you can add more CPUs, more memory, more hard disks, and more network adapters to the host computer.

    Important:

    The manufacturer, computer model, and hardware architecture might limit growth capability or even worse, may prevent an increase in capacity. You must know the limits of a potential host server before you try to reuse a server or purchase a new one.

  • Reserve capacity

    Determine whether the host has sufficient reserve capacity to scale up the existing virtual machines, or to scale out by adding virtual machines. This is very important if you plan to use Hyper-V failover clustering, quick migration, or live migration.

Important:

You must make sure that your strategy for responding to seasonal or random load increases on the virtual machines includes the host servers.

Identify virtualization management and maintenance requirements

Virtualization adds to the complexity of the IT environment and may add new challenges that your IT group must overcome to effectively manage the farm and its infrastructure. Frontline support is different, as is operations support and ongoing maintenance.

The virtual farm presents two additional levels of support requirements: the virtual machines and the virtualization host servers. Although the requirements of each level are similar to a farm that is deployed on physical servers, these requirements are not identical. There are enough unique elements to warrant an evaluation of the existing support infrastructure.

IT groups in most organizations have obtained or developed software tools and utilities for monitoring and managing their physical computing environment.

  • Third party tools and utilities - Most third-party software is customizable to a degree and IT groups customize tools to meet the changing automation requirements.

  • In house-tools and utilities - This software may only be a collection of batch files and scripts that have evolved in response to the changing environment but they do provide a degree of automation that does the job.

The challenge for the IT group is to determine whether any current tools can meet the demands of a virtual environment, and at what cost. Third-party tools may have reached the limits of customization or may not have caught up to virtualization requirements. Similarly, the in-house tool collection may not be more customizable, or the cost and time requirements may not be justifiable. Your analysis will determine whether you have to invest in new tools to manage the virtual farm.

If you decide to make an investment in tools to manage the new environment, we recommend Microsoft System Center 2012 it provides a robust set of tools that are well integrated with Hyper-V as well as SharePoint products. The System Center toolset includes the following programs that have broader capabilities in addition to managing your virtual environment.

  • Virtual Machine Manager (VMM) is a management solution for the virtualized datacenter. It enables you to configure and manage your virtualization host, networking, and storage resources to create and deploy virtual machines and services to private clouds.

  • System Center 2012 - Operations Manager provides infrastructure monitoring that is flexible and cost-effective. It helps ensure the predictable performance and availability of important applications, and it offers comprehensive monitoring for your datacenter and cloud, both private and public.

    Note:

    Operations Manager also provides a System Center Management Pack for SharePoint Server 2013 and a System Center Management Pack for SharePoint Foundation 2013.

  • Microsoft System Center 2012 Configuration Manager helps you deliver user experiences across a wide range of devices, while also making sure that you meet corporate control and compliance requirements.

  • System Center 2012 - Data Protection Manager (DPM) enables disk-based and tape-based data protection and recovery for servers such as SQL Server, Exchange Server, SharePoint 2013, virtual servers, and file servers. DPM also supports Windows desktops and portable computers. DPM can also centrally manage system state and Bare Metal Recovery (BMR).

  • Orchestrator is a workflow management solution for the data center. Orchestrator lets you automate the creation, monitoring, and deployment of resources in your environment.

Note:

Consider obtaining the Virtual Machine Servicing Tool from the Microsoft Download Center. This Solution Accelerator provides automated tools and guidance that IT professionals can use to update offline virtual machines, templates, and virtual hard disks efficiently and without exposing them to security risks.

Create a deployment plan

At this point in the planning process, you must create an implementation plan that describes the phases that move the virtual farm to production. The scope and details of your implementation plan is the same as if you were deploying a SharePoint products farm on physical servers.

Use the following table, which describes the phases for putting a physical farm into production as a guide to implement your virtual farm.

Implementation phases

Name Steps Output Characteristics

Proof of Concept (PoC)

Used to determine whether the solution will meet business needs and to determine the appropriate infrastructure.

  • Deploy farm

  • Deploy solution

  • Collect benchmark data

  • Evaluate proof of concept

  • Refine goals and infrastructure requirements

  • Updated solution plan

  • Updated topology

  • Updated resource requirements

PoCs are often created for evaluating a product or solution. A PoC can be hosted in a development environment or on a small production computer. Sometime s the PoC moves through several phases in continuous development.

Pilot (small scale test)

Use to test a solution on a small scale

Pilots are used to test solution readiness (no real data, just functional testing.) A pilot can also be used to test for production characteristics by using real data and performing actual work, which we recommend.

  • Deploy pilot farm

  • Deploy pilot solution

  • Collect benchmark data

  • Evaluate pilot

  • Refine goals and infrastructure requirements

  • Determine operations requirements

  • Updated solution plan

  • Updated topology and resource requirements

  • An operations plan

A limited set of users has access to the environment to test the functionality and performance of the solution and infrastructure.

User Acceptance Test (UAT)

The purpose is to provide a pre-production environment that is used for testing solutions against a subset or complete copy of production data.

This test is also used for validating backups or the operations procedures.

  • Deploy UAT farm

  • Deploy UAT solution

  • Implement operations plan

  • Evaluate solution

  • Evaluate operations plan

  • Test capacity and performance

Updated operations plan

The topology should be as similar to the production environment as possible.

Testers make sure that that all solution elements function as expected in a network and security conditions match those of the production environment.

Production

This is the live environment that that users interact with to do their jobs.

  • Deploy production farm

  • Deploy production solution

  • Implement operations plan

  • Deploy additional environments such as authoring and staging farms, and services farms

Deployed production farm

It is business-critical and all the appropriate service level agreements (SLAs) are in place.

For each of the previous phases you have to determine the answers to the following questions:

  • Who must be involved in the tests during each phase?

  • What must be tested?

  • What benchmark data is getting collected?

  • What are the criteria for moving to the next phase?

  • Who is responsible for signing off on the successful completion of the phase?

The duration of each phase should be determined by meeting predefined acceptance criteria in addition to any date-driven release goals. However, a time goal does provide a useful measure of the actual duration of a phase and validates time-based estimates. You can use the results for future deployments or upgrades.

Review and adjust the plan

Review and revise your plan before and during the implementation of the virtual farm in a production capacity. Keep the plan up to date -- it provides valuable information for a project post-mortem and can be used to plan future projects.

See also

Overview of farm virtualization and architectures for SharePoint 2013
Detailed design and system specification process for a virtual SharePoint 2013 farm

Installation and Deployment for SharePoint 2013
What's New in SharePoint 2013


Detailed design and system specification process for a virtual SharePoint 2013 farm
See also

Summary: Implement a process to create a detailed topology design and system requirements specification for the SharePoint 2013 farm and Hyper-V host computers.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article contains an example that you can use to create a detailed architecture and system requirements for a virtualized SharePoint 2013 farm. This architecture consists of the virtual machines used for farm server roles, any physical computers that might be used as farm servers, and the virtualization host computers. Your detailed design is a reflection of the duality of a virtual environment and must accommodate the constraints and demands of the virtual machines, virtualization host computers, networking, and storage.

Your detailed design must meet all business and technical criteria (and expectations) for the new SharePoint farm in a production environment. A good design also considers operations support, ongoing maintenance activities, and future upgrades.

In this article:

  • Introduction and scope

  • Determine availability, security, performance, and capacity requirements

  • Choose a design strategy and identify the key tasks

  • Create an architecture model and system specifications for a farm deployed on physical servers

  • Create an architecture model and system specifications for a farm deployed in virtual environment

  • Review the architecture model and system specifications for the virtual farm

  • Update the architecture model and system specifications

  • Test the architecture design and system specifications in a live environment

Introduction and scope

This article follows accepted best practices to step through the process required to create a detailed farm topology, virtualization architecture, and a system requirements specification for the virtual machines and Windows Server 2008 Hyper-V technology computers. We recommend that you use the approach described in the Identify virtual farm requirements section of Create a virtualization plan for SharePoint 2013 — treat the topology and servers the same way that you would approach designing a farm deployed on a physical platform. Because SharePoint 2013 requirements are technology agnostic, there's no requirement to address virtualization elements until you have enough information to extend the topology and system specifications to the underlying virtual layer. We also recommend that you use an iterative process for creating and refining your design, which starts by identifying mandatory and important requirements, such as availability and performance. This is a frequently used and proven technique for getting the information that is needed to refine and complete a design.

As part of design process, you also have to establish evaluation criteria to determine whether the farm topology and system specifications are acceptable for the first pre-production deployment stage, which is usually a proof-of-concept (POC) or pilot environment.

Note:

With regards to performance, this article does not provide detailed information about how to create and run benchmark tests. Guidance for analyzing and interpreting benchmark data is also out of scope.

After you identify your requirements, continue the design and specification process using the following sequence of steps as a guide.

  1. Use the SharePoint 2013 solution and architecture guidance to create a topology that is best suited for the solution that you want to deploy.

  2. Use the draft topology design to identify the number of farm servers that are needed, and document the minimum configuration requirements for each server according to their role. Remember, this a starting point, not the final farm design and configuration specification.

  3. Extend your farm topology to include the virtualization infrastructure. Once again, use published guidance to determine the optimal distribution of farm server roles across virtualization host computers. As part of this step, estimate the resources that each host computer needs in order to support the virtual machines that you plan to deploy on the host.

    Note:

    The capabilities and limits of the virtualization host computers must be reflected in the architecture.

  4. Continue to refine the topology until you have a design that is suitable to deploy a test farm in a pre-production environment. At the same time that you are refining the topology you can adjust system specifications if you get additional information about configuration requirements for the farm virtual machines or host computers. Unless you have benchmark data from a previous deployment, system specifications are an estimate and any meaningful adjustments will come from your benchmark tests.

Article scope

The process and guidance in this article focuses on how to install and configure SharePoint products using a Windows Server 2008 Hyper-V technology solution. However, you can apply our strategy to any virtualization solution that the Server Virtualization Validation Program (SVVP) validates. For more information, see the Server Virtualization Program FAQ

This article does not provide detailed information about how to install and configure a virtualization host computer or the virtual machines that are required for a SharePoint products farm. For more information, see Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment.

Note:

For this release of the SharePoint 2013, the virtualization changes and features in Windows Server 2012 are not supported.

The following subjects are covered to varying degrees in this article, but detailed information about each subject area is provided in separate articles.

  • Business continuity - High availability and disaster recovery for a virtual environment

  • Security - Best practices for securing Hyper-V virtualization host computers

  • Performance and capacity

  • Maintenance and operations

Determine availability, security, performance, and capacity requirements

The starting point in creating a detailed design is to establish, review, and prioritize the functional, technical and operational requirements for SharePoint 2013 and the supporting virtualization infrastructure. You must establish priorities because there will be competing priorities from your stakeholders. There will be significant gaps between the requirements, expectations actually, between different organizational units. For example, users have always expected fast response time whereas the IT security group requires a design that reduces the risk of a system breach.

As you work through the process to identify and prioritize requirements, you must also develop scoring criteria in order to determine when the design is suitable for a farm that you can deploy in a pre-production environment.

There are many approaches and tools that you can use for prioritizing your requirements, and there is no best way or right way for any given scenario. For example, one popular approach to the problem is to categorize requirements as mandatory, very important and so on. Another approach is to use a weighting system or ranking scale to establish priorities. Regardless of the method, choose an approach that enables you to establish credible priorities and apply it consistently as you identify and refine your requirements.

We recommend that you group your requirements into major categories and then subdivide each category in order to provide more details about specific requirements. For example, security is very broad category— detailed information about necessary user permission levels or who should be able to access to farm features or components is very important for understanding, designing and implementing a secure system.

Note:

The benefits of compartmentalizing requirements are that you are able focus better on relevant details and it helps reduce the possibility of missing something. However, categories are not isolated. There are always overlaps or dependencies. You must take a holistic design approach that recognizes and incorporates these overlaps and key dependencies.

In this article we use four major categories for grouping design requirements. These categories, in order of priority are as follows:

  • High availability

  • Security

  • Performance

  • Capacity

Note:

We recognize the interdependence of performance and capacity but decided to separate these two categories for the convenience of readers.

High availability

The first step in designing for high availability is to determine the level of SharePoint availability that your organization must have in order to support the business. Typically, an organization's high availability requirement is defined by the type of business, the degree of globalization, customers, and partners. From an internal perspective, you must document the level of availability needed for the organization as whole in addition to individual business units.

Note:

High availability (HA) and disaster recovery (DR) are subsets of a broader Business Continuity Management (BCM) strategy and process. This article focuses on the immediate design elements that are required to put a farm into production. Disaster recovery requirements are very important and are should not be ignored during the architecture design process. We decided to treat disaster recovery as a separate, post deployment activity in order provide more focus and details about DR requirements, best practices, and options.

The next steps are to assess all the farm components to determine their potential effect on availability, review the options for providing highly available components, and then decide which option is the best for your architecture.

Note:

Cost is always a factor for organizations. However,, you must weigh these costs against the potential effect of reduced availability on your business.

We recommend that, as a minimum, you evaluate the following farm components from a high availability perspective:

  • SharePoint databases

  • application servers

  • front-end web servers

  • SharePoint services and features such as Search

  • virtual machines used for the farm

  • distribution of farm server roles across virtualization host computers

  • virtualization host computers

  • infrastructure elements such as routers and power load balancers

Security and authentication

Virtualization introduces another layer of security that must be addressed. The virtualization host computer provides a single access point to the virtual machines it hosts, which widens the attack surface. In addition, virtual networking presents additional challenges for securing the farm network.

Your organization already has policies, procedures, and tools in place to manage security and authentication for the IT systems and infrastructure. You should secure your virtualization server by using the same measures that you would take to safeguard any server that is running Windows Server 2008 or Windows Server 2008 R2. You must also implement additional measures to help secure the virtual machines, configuration files, and data. For more information about how to help secure Windows Server 2008 workloads, see the Windows Server 2008 Security Guide).

Performance

SharePoint 2013 provides new, re-designed, and expanded features and therefore,, farm server performance characteristics and resource requirements differ from the requirements for SharePoint 2010 Products. An in-depth understanding of the changes that are introduced in SharePoint 2013 is necessary for understanding each farm server's resource requirements. Understanding the effect of these changes is especially important in a scenario where you intend to base farm server system specifications on historical data: either usage profiles or performance data. For more information about performance, see Plan for performance and capacity management in SharePoint Server 2013.

Usage data

Historical usage data makes it easier to derive test parameters that you can use for baseline tests. However, when you evaluate this data do so in the context of the new SharePoint 2013 features. Determine how these features might affect user behavior patterns. For example:

  • A typical result of improvements to an existing feature is that more people will use the feature more often and for longer periods.

  • New or extended features have the same effect as improved features, and in some cases, notably when highly requested features weren't available; the increase in SharePoint usage is very significant.

  • A significant increase in the size of the user base, the result of a merger or acquisition for example, will also affect the usage profile.

Changes in use patterns such as the number of concurrent connections or average connection time can have a significant effect on overall system requirements.

Performance data

Performance data provides a measure of how well a server handles the SharePoint workload according to its role in addition to the computer resources (such as CPU usage or memory) used while the system is performing its tasks. (You can also use overall throughput for a group of farm servers as another performance measure.) In order to achieve optimal performance there must enough computer resources that are available to handle the workload. The system requirements specification, excluding software prerequisites, has to identify the configuration for each server in order to handle the load that you expect for the server role. The final configuration is the result of iterative tests (benchmarks) that collect performance data when pre-determined tasks are performed under different loads. Your project team testers compare the benchmark data to the baseline in order to see the effect of load and tasks affect performance. If historical data is available it is easier to create the baseline for performance tests.

Important:

Make sure that the performance characteristics of all the re-designed or updated features tested thoroughly and that their effect on overall system performance is understood. Some of these features may not significantly or visibly increase performance demands. However,, the load imposed by a feature may be shifted to different farm server role. Any assumptions you have for a particular role must be validated by conducting new benchmark tests.

If the SharePoint farm is the first deployment in your organization you do not have the option of using historical data as a reference point for establishing a performance baseline. You have to create the baseline using the guidelines and limits provided for SharePoint 2013. Regardless of how you establish your baseline you must run different benchmark tests designed to collect specific data in order to refine your architecture design and system requirements specifications.

Important:

Performance testing and analysis for each server role must be combined to create a performance profile for overall farm performance, which makes it easier to identify performance bottlenecks in the farm.

Capacity

After you determine the capacity requirements of a SharePoint 2013 farm the next step is sizing the farm, its servers and the virtualization infrastructure. The two key areas that farm architects focus on are content storage and farm performance. For more information about capacity, see Capacity management and sizing for SharePoint Server 2013.

SharePoint 2013 is noted for its capability to handle a diverse cross section of content types, ranging from simple text files to large media files. This capability includes, and is not limited to, content creation and editing, sharing for collaboration, short and long term storage, and archiving. From a sizing perspective, your design should be sufficient to handle near term requirements—as the content database grows you can scale up the farm to accommodate this growth.

A farm's ability to consistently meet or exceed the required level of performance is the second important aspect of capacity. Performance capacity is typically defined and evaluated as the kind of load that is put on farm servers compared to a pre-defined set of thresholds. Thresholds are configurable limits that are used to define acceptable loads and also for loads that will put the farm into an unhealthy state when a limit is exceeded. For more information, see Software boundaries and limits for SharePoint 2013.

Note:

Performance capacity typically includes content delivery measurements also, such as page load time.

The performance capacity of the farm is determined by the size of the farm, based on the solution(s) it supports, and the characteristics of many farm components. Some examples of these components include the following: the farm servers themselves, network bandwidth and latency, page design, and custom code, to name some.

As is the case with performance, whether this farm is the first SharePoint 2013 deployment for your organization or one already exists shapes your strategy for capacity planning.

Choose a design strategy and identify the key tasks

A well-defined architecture for a virtual farm, starting from hardware layer up, consists of the virtualization host computers, the network infrastructure, the storage system, and the virtual machines that are part of the SharePoint 2013 environment. (A heterogeneous architecture design includes the physical farm servers.) Use the design illustration that we provide as a guide to set up your own process and criteria for creating a detailed architecture and system specifications. Tailor your approach to reflect your organization's requirements and also for the requirements of the SharePoint products solution that you plan to deploy in a virtual environment.

Our design strategy uses modeling and iteration to arrive at a virtual farm architecture and system specifications that is ready for live testing.

Modeling is a very useful visualization tool that enables you to see all the components of a SharePoint products farm deployment for your solution. If the model includes system specifications it also enables you to do a check to verify that all the required specifications are identified and documented. Because the model is a small document, it is easy to circulate to stake holders, and easy for the stakeholders to review and provide feedback on.

It's your choice when it comes to how much detail that you use in a model. The model that we use to show the design process consists of the farm servers, the SharePoint products components that are installed and configured on each server, and the system specifications for each server. We decided not to include SharePoint products processing workflows or the network infrastructure in order to keep the model as simple as possible and still be useful.

The iterative design process is a well-known and proven approach for application and systems design. Iterative design provides several benefits, such as the following:

  • It enables you to identify missing or incorrect information.

  • It makes it easier to identify questionable design elements or system specifications that require more investigation.

The following list of tasks describes the key steps to create, configure and deploy a virtual farm and the supporting infrastructure:

  1. Create an architecture model and system specifications for a farm deployed on physical servers

  2. Use the physical architecture and system specifications as a template to create the preliminary virtual farm architecture and the required supporting physical platform.

    Tip:

    Collect detailed technical reference material (for example, technical white papers, and KB articles) for SharePoint 2013, SQL Server and Hyper-V. Use this information to create a technical knowledge base that you can use as a design tool. This knowledge base is very useful during pre-production testing when the test team has to determine the best way to resolve a performance issue and identify the best solution.

  3. Add the virtualization host computers and their system specifications to the model.

  4. Start the iterative design process. Analyze the architecture model to verify that the model identifies all the elements that are required for the farm solution. Conduct a reasonableness test against each farm server's the system specifications. Identify and obtain missing or incomplete information so you can use it for adjusting the farm design or specifications.

  5. Refine the architecture based on the result of your analysis and by incorporating new or updated information.

  6. Start another iterative loop: review, revise, review. Continue to evaluate and refine the architecture and specifications until you feel confident that all aspects of the virtual farm meet your criteria to deploy and test the farm in a pre-production environment such as proof-of-concept (POC) or a limited pilot.

  7. Deploy the farm.

Create an architecture model and system specifications for a farm deployed on physical servers

Create a model of the physical architecture either by using historical data if it available, or by using the requirements and guidance that is provided for SharePoint 2013. If you use historical data we recommend that you supplement this data with any new information about requirements and updated guidance to that your design covers all the new or updated features.

Important:

As a best practice, invest the same time and apply the same rigor that you would use to install and configure SharePoint products on physical servers. This investment pays off when you translate the physical design and system specifications to a virtual environment. It also eliminates unnecessary topology changes and sizing changes to the virtual machines and virtualization host computers.

After you are confident that this model is sound and adequately addresses the requirements for the new farm, you can map the physical view to a virtual environment.

Our example farm

In order to show the process of creating and refining a farm design and system specifications we use a small-medium farm that is configured to use Search. For the sake of clarity we did not include any of the other service applications that you need to consider for your own design.

The following figure shows our example farm deployed on physical computers. This is our starting point for the process of developing a virtual farm architecture and system specifications that are suitable to deploy as a proof-of -concept or pilot farm.

Figure 1. A small-medium size farm deployed on physical computers

Architecture for farm on physical servers
Note:

The numbered labels (1X - 6X) in Figure 1 identify farm components or server configurations that have to be investigated.

Create an architecture model and system specifications for a farm deployed in virtual environment

Use the physical farm topology design and system specifications as a guide for modeling the virtual environment, which includes the Hyper-V host computers.

Note:

Ensure that the capabilities and potential limitations of the virtualization host computers are fully understood and are part of your design plan.

Use the following sequence of tasks as a guide for developing your virtual model:

  1. Conduct a final review of the physical model and system specifications to verify that you are basing the virtual model on sound design and sizing.

    Before you transfer specifications from the physical model note any configurations that stand out so you can check the SharePoint 2013 requirements in order to verify configurations or missing information. Using our example, note the following:

    1. Each of the front-end web servers (FE-1, FE-2) is configured to use 24 GB of RAM. At first read, this memory configuration seems high, especially when you compare them to the application servers that host search components.

    2. Two of the application servers (SA-1 and SA-2) are dedicated to hosting search components. The RAM configuration seems reasonable. However, the hard disk capacity for the index might not be sufficient.

    3. The third application server (AP-1) hosts the remaining search components in addition to the other application roles for the farm. There is no provision for high availability.

    4. The AP-1 application server has sufficient memory. However, the hard disk capacity might be insufficient.

    5. The database servers (SQ-1 and SQ-2) lack information about hard disk requirements and the memory configuration seems to be too low.

    6. A requirement for highly available databases is noted, but specific information about the high availability solution is not provided.

  2. Identify the number of virtual machines that are needed and map the role of each virtual machine to the corresponding server in the physical model.

  3. Use the physical server specifications to document the configuration for each virtual machine (number of processors, amount of memory, and disk space). While you're transferring specifications from the physical model note any configurations that stand out so you can check the SharePoint 2013 requirements in order to verify questionable configurations.

    Note:

    Remember to verify SQL Server requirements while you are checking the specifications for the servers in the SharePoint 2013 farm.

  4. Determine the distribution of virtual machines on the host computers. Consider the following factors when you are determining how to distribute the virtual machines across the host computers: farm availability requirements, best practice role distribution for optimal performance, the minimum number of host computers, and host capacity (if known.)

  5. Examine the distribution of farm services across the virtualization host computers to see whether any of these services are at risk if a host computer fails.

  6. Use the virtual machine capacity requirements to determine the minimum host computer system specifications (number of cores, memory, local hard disks or network storage).

    Note:

    Use best practice configurations for the virtual machines and virtualization host computers. For more information, see Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment .

  7. Identify general networking requirements, storage requirements, and power requirements considering these design goals: availability, performance, and capacity.

    As we indicated in the "Choose a design strategy and identify the key tasks" section, we are keeping the model as simple as possible. Therefore networking and storage requirements are not addressed or covered at any level of detail.

  8. Review the architecture and system specifications and identify the uncommitted resources on each of the Hyper-V host computers. Additional host computer capacity determines the extent to which you can scale up virtual machines on a host computer, or if you can scale out the farm by adding a virtual machine to a host computer.

After you finish the first version of the virtual architecture model and system specifications, we recommend that you start the iterative process to refine the architecture and system specifications. The goal is to validate design requirements and any assumptions used to create the design. This process also enables you to review the functional requirements (for the solution and the farm) to verify that there are no changes that have to be considered before refining the model. Finally, if there is new benchmark data or updated product specifications, you can incorporate this information in a revised model.

Review the architecture model and system specifications for the virtual farm

During the process of analyzing the SharePoint 2013 farm architecture and system specifications it's important to remember that the farm topology and server configurations will change before, and to a degree, after you deploy the farm in the production environment. The extent and degree of change will vary according to the solution, but realize the fact that there will be changes and this should be part of your design review strategy.

The following illustration shows the first draft of our virtual architecture using the topology and system specifications created for the physical farm. The same numbers of farm servers are implemented as virtual machines and are assigned the same roles as the physical servers. The virtual machines are distributed on two Hyper-V host servers. A minimum of two Hyper-V hosts is required in order to be consistent with the high availability design used in the physical model.

Important:

The system specifications for the virtual machines and Hyper-V host computers shown in the following diagram are only for illustration, they are not prescriptive.

The virtual machines are configured according to the minimum requirements for each server role, as stated in the Hardware and software requirements for SharePoint 2013 article.

Figure 2. Virtual farm topology with two Hyper-V host computers

Initial architecture for virtualized farm
Note:

The numbered labels (1X - 5X) in Figure 2 identify farm components or server configurations that have to be investigated.

Our approach to the design review in this article consists of three phases (or categories), which provides a basic framework for the design. Use the following steps as a guide for developing your own design review process.

  1. Conduct a design review of the virtual farm architecture and supporting physical platform.

  2. Analyze the system specifications for the virtual machines and virtualization host computers.

  3. Review the architecture and system specifications as a single entity.

    Note:

    Subdivide major review steps or categories as much as is necessary to get the level of detail that you must have to refine the architecture or system specifications.

Virtual and physical architecture design assessment

The virtual architecture implements the availability strategy for specific farm server roles as the physical model. The front-end web server redundancy is retained in addition to the high availability requirement for the databases. Availability is also maintained for the two application servers (SA-1, SA-2) that host search query and search index components.

Note:

While the virtual architecture maintains the availability design of the physical architecture, it does not improve availability, which should be part of a virtualization strategy.

The decision to use two host computers and distribute farm server roles across these hosts achieves two things. First, it makes sure that most of the farm servers are not vulnerable to a single point of failure. Second, by distributing roles, it also distributes the workload which contributes to better overall farm performance.

Design flaws

The following aspects of the design must be addressed:

  • The level of redundancy for the front-end servers is suitable for pre-production environments but should be re-evaluated before putting the farm in production. The loss of one front-end web server reduces the farm's ability to serve content by 50%. There is no high availability option for the virtualization host computers. If HOST-2 failed the farm might continue to function. However, this is not the case if HOST-1 failed.

  • There is no high availability provided for all the application servers. The Search Administration component and Search analytics component on AP-1 are vulnerable because both instances are running on the same Hyper-V host.

  • There is no high availability option for the virtualization host computers. If Host-2-fails the farm will continue to function without a loss of services. However, if Host-1 fails, key services such as crawling the content or analytics processing will not be available.

Virtual machine system specification analysis

The virtual machine system specifications are based on the server configurations in the physical model. After reviewing these specifications there are two configurations that don't pass our reasonableness test. More information is required for the following servers:

  • The front-end web servers. After rechecking the SharePoint 2013 requirements we reduced the memory configuration to 8 GB, which is the recommended minimum for a system that serves content. Another aspect of the web server configuration is the number of virtual processors—we need to verify that these servers require four virtual processors.

  • The database servers. The memory specification seems low for these servers. However, the model doesn't provide any information about the expected volume or types of database transactions.

  • Storage is another area that warrants more investigation. For the database servers the only stated required if for the system disk. There is no information about capacity requirements for the other database hard disks.

Hyper-V host computer system specification analysis

The following table (System specifications for the Hyper-V host computers (Host-1 and Host-2) shows an analysis of the virtualization host computers' performance capacity using memory, processor configuration and scalability as criteria.

System specifications for the Hyper-V host computers (Host-1 and Host-2)

Specifications Analysis

Memory

Host-1: 96 GB RAM

The total memory requirement is 68 GB (allowing 4 GB for overhead and 64 GB for the virtual machines), which leaves 28 GB of RAM available for scaling up virtual machines or scaling out the farm.

Note:

The memory overhead allowance for a Hyper-V virtualization host computer is typically estimated at 2 GB. However,, for a virtualized SharePoint products environment we recommend that you use 4 GB as overhead when calculating memory requirements.

Host-2: 96 GB RAM

The total memory requirement is 48 GB (allowing 4 GB for overhead and 44 GB for the virtual machines), which leaves 48 GB of RAM available for scaling up virtual machines or scaling out the farm.

Processors

The virtual to logical CPU ratio is 2:1 on Host-1 and 1.5:1 on Host-2. These ratios are within acceptable limits.

Note:

In a virtualized SharePoint products environment, virtual machine memory allocation has a significantly greater effect on performance than an oversubscribed CPU on the virtualization host computer.

Scalability

Both host computers have sufficient resources to scale up virtual machines or scale out by adding virtual machines.

Note:

Hyper-V host computer CPU architecture

Oversubscribing the CPU on the Hyper-V hosts is not a concern. However, it would be useful to know whether the virtualization host CPU architecture supports hyper-threading technology (HT) because this feature does improve performance.

Our review highlights the requirement to obtain more information before we can update the architecture and system specifications. The next step is to obtain information about the following aspects of the farm:

  • Database capacity requirements

    The size of the farm database, the content database in particular, is a determining factor for estimating the number of databases files to use and their distribution on the storage system. Other valuable pieces of information include the following: the types of data that will be stored (documents, media), the pre-dominant database activities (e.g., read, update, etc.), governance, and expected growth requirements.

  • Local and shared storage requirements

    More information is needed to address the storage generally. At this point we don't know whether all the storage is local or if the intent is to use local and shared network storage. The front-end web servers and the search application (SA-1, SA-2) servers seem to have enough storage for SharePoint products binaries and the Index, but storage requirements for the search components and all the other services on the other application server (AP-1) has to be verified.

    We also have to understand the overall storage strategy in order to determine storage requirements for the virtualization host computers (Host-1, Host-2). Based on the model it seems that only local storage is used, which will affect hard disk layout and virtual machine placement.

  • Virtual hard disk configurations

    Virtual hard disk configurations directly affect host computer storage requirements and configurations. For example, if a host is using local storage, a directly attached physical disk (also known as a pass-through disk) configuration reserves all the hard disk for the virtual machine. Virtual machine hard disk configurations also affect backup and restore options such as SAN snapshots and can affect virtualization host computer high availability configuration.

    s

  • High availability

    We need more information in order to address the lack of high availability for the application servers. High availability is identified as a requirement for the database servers but we need specific details about the solution that will be used (for example, clustering vs. mirroring) because this will affect the architecture and most likely the database system specifications.

Additional changes to the model

The scope of and extent of changes to the architecture and system specifications is determined by the results of the initial design review and analysis of the system specifications.

Your implementation plan can also play a role in the process because it can be used to determine what changes to implement, and also the priority of each change. The following scenarios may not require any changes, especially if there are no significant and quantifiable benefits. For example:

  • The preliminary architecture is suitable for early testing in the proof-of-concept or pilot deployment stages.

  • The virtualization host computers are only for testing and the plan is to replace them for the user acceptance testing. This eliminates the requirement to address scalability or availability issues.

  • The farm is intended to be used for testing or evaluation and it will be decommissioned when these activities are finished.

Tip:

Consider archiving the virtual machines so you can re-create the farm for future test activities.

Update the architecture model and system specifications

After following up on the recommendations and requests for information that were a result of the design and system specification review we can update the model and system specifications.

The following illustration shows a revised model that incorporates the recommended changes in addition to missing information and details. The following illustration shows a revised architecture that is better suited for a production farm.

Figure 3. The revised architecture for the virtual farm

Revised architecture for virtualized farm

Virtual and physical architecture design assessment

The revised virtual and physical architecture implements several changes in response to the concerns that were raised during the previous review. In the revised architecture, we decided to scale out the virtualization host platform instead of scaling up the two hosts in the first model.

Note:

The decision to scale out or scale up the virtualization host computers is determined by your organization's hardware strategy, which is based on factors such as IT standards, business objectives and budget. Both approaches to providing more capacity are valid and there are positive and negative aspects for each scalability choice.

The new architecture is also designed to meet the following objectives:

  • Provide high availability for all the farm servers and increase the level of availability.

  • Improve scalability by enabling scale up or scale up for the farm and its components.

  • Provide more flexibility for moving virtual machines between the Hyper-V hosts in order to re-balance workload if it is necessary and to enable live migration if there is diminished virtual host computer capability because of capacity or a hardware failure.

The following changes meet our objectives:

  • The number of front-end web servers is increased to four for better load balancing and to provide a more availability for that particular farm role.

  • The number of virtualization host computers is increased to four. In addition, the capacity for each of these computers is increased by using the following configurations:

    • CPU: 16 cores plus hyper-threading

    • Memory: 96 GB

  • High availability for the database server is implemented by using SQL Server 2012 AlwaysOn Availability Groups.

    With two more host computers there is enough capacity to dedicate one Hyper-V host (Host-3) to the primary replica (PR) for the AG-1 availability group. The secondary replica (SR) is installed on Host-2, which is also dedicated to running SQL Server 2012. This strategy increases the capacity and performance of the farm database servers. However, the result is under-used virtualization host computers. After increasing the memory on the database virtual machine to 32 GB, there is still 60 GB of unallocated memory. The virtual processor to logical processor ratio is only 1:4, leaving both virtualization host computers significantly undersubscribed.

    We decided to use a database configuration that made better use of the Hyper-V hosts, improved database performance by balancing workload better, and provided more availability. This configuration uses two availability groups (AG-1 and AG-2). The primary replica for AG-2 shares Host-2 with the secondary replica for AG-1 and the secondary replica for AG-2 shares Host-3 with the primary replica for AG-1.

    Another aspect of the revised architecture and system specifications is the decision to use pass-through disks for the database virtual machines. This configuration follows the best practice guidance for configuring hard disks for a virtual machine that is running SQL Server. The recommended Hyper-V disk configuration for database servers is the pass-through disk. Although pass-through disks offer only slightly better performance than fixed size disks, pass-through disks are a better option for large disks and applications that are disk I/O intensive, a well-known characteristic of SharePoint products databases. In addition, pass-through disks eliminate disk contention because other virtual hard disks cannot access the physical disk.

  • Scaling out the virtualization hosts provides more flexibility for virtual machine workload balancing.

  • Using four virtualization host computers provides a good foundation for implementing failover clustering in addition to quick migration and live migration for the virtual machines. For more information, see Understanding Hyper-V and Virtual Machines in the Context of a Cluster (http://technet.microsoft.com/en-us/library/dd759249).

Virtualization host computer system specification analysis

The following table (Revised system specifications for virtualization host computers (Host-1, Host-2, Host-3, Host-4) shows an analysis of the virtualization host computers' performance capacity using memory, processor configuration and scalability as criteria.

Revised system specifications for virtualization host computers (Host-1, Host-2, Host-3, Host-4)

Specifications Analysis

Memory

After allowing 4 GB of RAM on each virtualization host computer, the unallocated memory on the Hyper-V host computers is as follows:

  • Host-1: 36 GB

  • Host-2: 28 GB

  • Host-3: 28 GB

  • Host-4: 36 GB

The unallocated memory on all the host computers leaves sufficient capacity for scaling or for live migration.

Processors

As a result of the revised architecture the virtual to logical processor ratios are as follows:

  • Host-1: The virtual to logical ratio is 1:1.

  • Host-2: The virtual to logical ratio is 1:2.

  • Host-3: The virtual to logical ratio is 1:2.

  • Host-4: The virtual to logical ratio is 1:1.

These ratios are within acceptable limits.

Scalability

The revised architecture supports scalability across the farm and for all the farm components.

The changes to the architecture design and system specifications are an improvement over the first model. However, an additional iteration would be necessary in order to:

  • Provide more detailed specifications for the storage strategy (local or shared network) for the database server virtual machines. In order to do this, more information about the volume and type of content that the farm is expected to store is required.

  • Refine the specifications for the front-end web servers. This requires obtaining information about expected use, such as the number of concurrent connections or the average length of connection time.

There are not a mandatory or optimal number of review and revision iterations; continue the cycle until you reach a stage where additional revisions don't significantly improve the design or system specifications. This is the point where you must test the farm in a live environment.

Test the architecture design and system specifications in a live environment

Regardless of your diligence, the reality is that all the architecture and system specifications are theoretical until you deploy the farm in a pre-production test environment and run a series of benchmarks. The number of benchmarks that are needed depend on your hardware strategy. If this strategy is based on over specified requirements then benchmark requirements are reduced.

Tip:

Weigh the cost and time that is required to conduct extensive benchmarks against the cost of hardware that provides more than the required capacity and performance capability. Depending on your situation, the hardware investment might be a better option.

Benchmarks provide the data that you must have in order to evaluate and then implement good cross-platform changes. The first set of benchmark data enables you to identify the scope, nature and extent of the changes that are required. Typically the first changes that deployment teams consider are as follows (not listed in order of priority):

  • Change the farm topology architecture in order to distribute workloads.

  • Scale up the virtual machines or scale out the farm by adding virtual machines.

  • Scale up the Hyper-V host computers or scale out the hardware platform by adding more host computers.

The deployment team has to determine the priority, potential gain, and effect of these changes. The available data may not be sufficient to make these determinations and therefore, additional benchmarks might be required and you might have to change the benchmarks in order to get the data that that you want.

Note:

We recommend that you test the monitoring and reporting strategy (and tools) that you intend to use for the production environment. Testing against pre-production farms enables you have fully operation monitoring and reporting in place when the farm goes into production.

In conclusion, your architecture and system specifications will continue to evolve as you move the pre-production stages and into production. As a best practice we recommend that you continue to run benchmarks until the farm is stabilized in the production environment.

See also

Overview of farm virtualization and architectures for SharePoint 2013
Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment

Installation and Deployment for SharePoint 2013
What's New in SharePoint 2013


Plan authentication in SharePoint 2013
See also

Summary: Find resources about user authentication, server-to-server authentication, and app authentication to help you understand and plan for authentication in SharePoint 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

The following articles on TechNet and related resources provide information about authentication planning in SharePoint 2013.

TechNet articles about authentication planning in SharePoint 2013

The following articles about authentication planning in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Authentication overview for SharePoint 2013 | Learn about how user, app, and server-to-server authentication works in SharePoint 2013.
Checklist icon (not checked) | Plan for user authentication methods in SharePoint 2013 | Plan how to use various user authentication methods in SharePoint 2013 to help create a secure experience for users of web applications.
Checklist icon (not checked) | Plan for app authentication in SharePoint 2013 | Plan for authentication of SharePoint 2013 SharePoint Store and App Catalog apps.
Checklist icon (not checked) | Plan for server-to-server authentication in SharePoint 2013 | Plan for server-to-server authentication for SharePoint 2013 and other servers that support the server-to-server protocol.
Checklist icon (not checked) | Plan the Secure Store Service in SharePoint Server 2013 | Plan for Secure Store Service and service application requirements, and for target applications and credential mappings.
Checklist icon (not checked) | Plan for Kerberos authentication in SharePoint 2013 | Plan for Kerberos authentication in SharePoint 2013 for Windows and claims-based authentication.
Checklist icon (not checked) | Server-to-server authentication and user profiles in SharePoint Server 2013 | Plan user profiles for server-to-server authentication in SharePoint Server 2013.

Additional resources about authentication in SharePoint 2013

The following resources about authentication in SharePoint 2013 are available from other subject matter experts.

Content Description

Blogs

  • Share-n-dipity (http://blogs.technet.com/b/speschka/)

Microsoft Principal Consultant Steve Peschka is a leading expert in SharePoint authentication issues.

See also

Configure authentication infrastructure in SharePoint 2013
Plan user profiles and identities (SharePoint Server 2013)


Authentication overview for SharePoint 2013
See also

Updated: April 16, 2013

Summary: Learn about how user, app, and server-to-server authentication works in SharePoint 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

SharePoint 2013 requires authentication for the following types of interactions:

  • Users who access on-premises SharePoint resources

  • Apps that access on-premises SharePoint resources

  • On-premises servers that access on-premises SharePoint resources, or vice versa

In this article:

  • User authentication in SharePoint 2013

  • App authentication in SharePoint 2013

  • Server-to-server authentication in SharePoint 2013

User authentication in SharePoint 2013

User authentication is the validation of a user's identity against an authentication provider, which is a directory or database that contains the user's credentials and can verify that the user submitted them correctly. User authentication occurs when a user attempts to access a SharePoint resource.

SharePoint 2013 supports two authentication types for user authentication:

  • Claims-based authentication

  • Windows classic mode authentication

The result of a claims-based authentication is a claims-based security token, which the SharePoint Security Token Service (STS) generates. The result of a Windows classic mode authentication is a Windows security token. We recommend that you use claims-based authentication for user authentication.

SharePoint 2013 supports Windows, forms-based, and Security Assertion Markup Language (SAML)-based claims authentication. For information about how these three authentication methods work, see the following videos.

Windows claims authentication in SharePoint 2013 video

Video (play button) icon

Forms-based claims authentication in SharePoint 2013 video

Video (play button) icon

SAML-based claims authentication in SharePoint 2013 video

Video (play button) icon

For more information, see Plan for user authentication methods in SharePoint 2013.

App authentication in SharePoint 2013

App authentication is the validation of a remote SharePoint app's identity and the authorization of the app and an associated user of a secured SharePoint resource request. App authentication occurs when an external component of a SharePoint Store app or an App Catalog app, such as a web server that is located on the intranet or the Internet, attempts to access a secured SharePoint resource.

For example, suppose that a user opens a SharePoint page that contains an IFRAME of a SharePoint app, and that IFRAME needs an external component, such as a server on the intranet or the Internet, to access a secured SharePoint resource in order to render the page. The external component of the SharePoint app must be authenticated and authorized so that SharePoint provides the requested information and the app can render the page for the user.

Note that if the SharePoint app does not require a SharePoint secured resource to render the page for the user, app authentication is not needed. For example, a SharePoint app that provides weather forecast information and only has to access a weather information server on the Internet does not have to use app authentication. This type of application can be done with SharePoint 2010 Products.

App authentication is a combination of two processes:

  • Authentication

    Verifying that the application has registered correctly with a commonly trusted identity broker

  • Authorization

    Verifying that the application and the associated user for the request has the appropriate permissions to perform its operation, such as accessing a folder or list or executing a query

To perform app authentication, the application obtains an access token either from the Windows Azure Access Control Service (ACS) or by self-signing an access token using a certificate that SharePoint 2013 trusts. The access token asserts a request for access to a specific SharePoint resource and contains information that identifies the app and the associated user, instead of the validation of the user's credentials. The access token is not a logon token.

For SharePoint Store apps, an example of the authentication process is as follows:

  1. A user opens a SharePoint web page that contains an IFRAME that has to be rendered by a SharePoint Store app, which is hosted on the Internet and uses ACS as its trust broker. To render the IFRAME for the user, the SharePoint Store app must access a SharePoint resource.

  2. The SharePoint STS requests and receives a context token from ACS.

  3. SharePoint sends the requested web page together with the context token to the user's web browser.

  4. The user's web browser sends a request for the IFRAME's content and the context token to the SharePoint Store app server on the Internet.

  5. The SharePoint Store app server requests and receives an access token from ACS.

  6. The SharePoint Store app server sends the SharePoint resource request and the access token to the SharePoint server.

  7. The SharePoint server authorizes the access, checking both the app's permissions, which were specified when the app was installed, and the associated user's permissions.

  8. If permitted, SharePoint sends the requested data to the SharePoint Store app server on the Internet.

  9. The SharePoint Store app server on the Internet sends the IFRAME results to the web browser, which renders the IFRAME portion of the page for the user.

Notice how the SharePoint Store app has accessed SharePoint server resources without having to obtain the user's credentials. The access was authenticated through ACS, which is trusted by the server running SharePoint 2013, and authorized through the set of app and user permissions.

For SharePoint App Catalog apps, an example of the authentication process is as follows:

  1. A user opens a SharePoint web page that contains an IFRAME that has to be rendered by an App Catalog app that is hosted on the intranet and uses a self-signed certificate for its access tokens. To render the IFRAME for the user, the App Catalog app must access a SharePoint resource.

  2. SharePoint sends the requested page along with the IFRAME to the user's web browser.

  3. The user's web browser sends a request for the IFRAME's content to the App Catalog app server on the intranet.

  4. The App Catalog app server authenticates the user and generates an access token, signed with its self-signed certificate.

  5. The App Catalog app server sends the SharePoint resource request and the access token to the SharePoint server.

  6. The SharePoint server authorizes the access, checking both the app's permissions, which were specified when the app was installed, and the associated user's permissions.

  7. If permitted, the SharePoint server sends the requested data to the App Catalog app server on the intranet.

  8. The App Catalog app server sends the IFRAME results to the web browser, which renders the IFRAME portion of the page for the user.

Note:

App Catalog apps can use either ACS or a self-signed certificate for their access tokens.

For more information, see Plan for app authentication in SharePoint 2013.

Server-to-server authentication in SharePoint 2013

Server-to-server authentication is the validation of a server's request for resources that is based on a trust relationship established between the STS of the server that runs SharePoint 2013 and the STS of another server that supports the OAuth server-to-server protocol, such as on-premises running SharePoint 2013, Exchange Server 2013, Lync Server 2013, or Azure Workflow Service, and SharePoint 2013 running in Office 365. Based on this trust relationship, a requesting server can access secured resources on the SharePoint server on behalf of a specified user account, subject to server and user permissions.

For example, a server running Exchange Server 2013 can request resources of a server running SharePoint 2013 for a specific user account. This contrasts with app authentication, in which the app does not have access to user account credential information. The user can be currently signed in to the server making the resource request or not, depending on the service and the request.

When a server running SharePoint 2013 attempts to access a resource on a server or a server attempts to access a resource on a server running SharePoint 2013, the incoming access request must be authenticated so that the server accepts the incoming access request and subsequent data. Server-to-server authentication verifies that the server running SharePoint 2013 and the user whom it is representing are trusted.

The token that is used for a server-to-server authentication is a server-to-server token, not a logon token. The server-to-server token contains information about the server that requests access and the user account on whose behalf the server is acting.

For on-premises servers, an example basic process is as follows:

  1. A user opens a SharePoint web page that requires information from another server (for example, display the list of tasks from both SharePoint 2013 and Exchange Server 2013).

  2. SharePoint 2013 generates a server-to-server token.

  3. SharePoint 2013 sends the server-to-server token to the other server.

  4. The other server validates the SharePoint server-to-server token.

  5. The other server sends a message to SharePoint 2013 to indicate that the sent server-to-server token was valid.

  6. The service on the server running SharePoint 2013 accesses the data on the server.

  7. The service on the server running SharePoint 2013 renders the page for the user.

When both servers are running in Office 365, an example process is as follows:

  1. A user opens a SharePoint web page that requires information from another server (for example, display the list of tasks from both SharePoint Online and Exchange Online).

  2. SharePoint Online requests and receives a server-to-server token from ACS.

  3. SharePoint Online sends the server-to-server token to the Office 365 server.

  4. The Office 365 server verifies the user identity in the server-to-server token with ACS.

  5. The Office 365 server sends a message to SharePoint Online to indicate that the sent server-to-server token was valid.

  6. The service on SharePoint Online accesses the data on the Office 365 server.

  7. The service on SharePoint Online renders the page for the user.

For more information, see Plan for server-to-server authentication in SharePoint 2013.

See also

What's new in authentication for SharePoint 2013

Change History

Date | Description
April 16, 2013 | Added the new user authentication process videos.
July 16, 2012 | Initial publication


Plan for user authentication methods in SharePoint 2013

Updated: April 16, 2013

Summary: Plan how to use various user authentication methods to create a secure experience for users of web applications.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes the user authentication types and methods that are supported by SharePoint 2013 and how to determine which ones to use for web applications and zones.

In this article:

  • Introduction

  • Claims-based authentication

  • Supported authentication types and methods

  • Plan for Windows authentication

  • Plan for forms-based authentication

  • Plan for SAML token-based authentication

  • Planning zones for web applications

Introduction

User authentication is the validation of a user's identity against an authentication provider, which is a directory or database that contains the user's credentials and can confirm the user submitted them correctly. An example of an authentication provider is Active Directory Domain Services (AD DS). Other terms for authentication provider are user directory and attribute store.

An authentication method is a specific exchange of account credentials and other information that assert a user's identity. The result of the authentication method is proof, typically in the form of a token that contains claims, that an authentication provider has authenticated a user.

An authentication type is a specific way of validating credentials against one or more authentication providers, sometimes using an industry standard protocol. An authentication type can use multiple authentication methods.

After a user's identity is validated, the authorization process determines which sites, content, and other features the user can access.

Your planning for user authentication types and methods should determine the following:

  • The user authentication types and methods for each web application and zone

  • The authentication infrastructure needed to support the determined authentication types and methods

  • How to migrate your current web applications and zones that use classic mode authentication to use claims-based authentication

Claims-based authentication

User identity in AD DS is based on a user account. For successful authentication, the user provides the account name and proof of knowledge of the password. To determine access to resources, applications might have to query AD DS for account attributes and other information, such as group membership or role on the network. While this works well for Windows environments, it does not scale out to third-party authentication providers and multi-vendor environments that support Internet, partner, or cloud-based computing models.

With claims-based identities, a user obtains a digitally signed security token from a commonly trusted identity provider. The token contains a set of claims. Each claim represents a specific item of data about a user such as his or her name, group memberships, and role on the network. Claims-based authentication is user authentication that uses claims-based identity technologies and infrastructure. Applications that support claims-based authentication obtain a security token from a user, rather than credentials, and use the information within the claims to determine access to resources. No separate query to a directory service such as AD DS is needed.

Claims-based authentication in Windows is built on Windows Identity Foundation (WIF), which is a set of .NET Framework classes that is used to implement claims-based identity. Claims-based authentication relies on standards such as WS-Federation, WS-Trust, and protocols such as the Security Assertion Markup Language (SAML).

For more information about claims-based authentication, see the following resources:

  • Claims-based Identity for Windows (white paper)

  • Windows Identity Foundation home page

Due to the widespread use of claim-based authentication for user authentication, server-to-server authentication, and app authentication, we recommend claims-based authentication for all web applications and zones of a SharePoint 2013 farm. For more information, see Plan for server-to-server authentication in SharePoint 2013 and Plan for app authentication in SharePoint 2013. When you use claims-based authentication, all supported authentication methods are available for your web applications and you can take advantage of new features and scenarios in SharePoint 2013 that use server-to-server authentication and app authentication.

For claims-based authentication, SharePoint 2013 automatically changes all user accounts to claims identities. This results in a security token (also known as a claims token) for each user. The claims token contains the claims pertaining to the user. Windows accounts are converted into Windows claims. Forms-based membership users are transformed into forms-based authentication claims. SharePoint 2013 can use claims that are included in SAML-based tokens. Additionally, SharePoint developers and administrators can augment user tokens with additional claims. For example, Windows user accounts and forms-based accounts can be augmented with additional claims that are used by SharePoint 2013.

You do not have to be a claims architect to use claims-based authentication in SharePoint 2013. However, implementing SAML token-based authentication requires coordination with administrators of your claims-based environment, as described in Plan for SAML token-based authentication.

Classic mode authentication in SharePoint 2013

In SharePoint 2013, when you create a web application in Central Administration, you can only specify authentication types and methods for claims-based authentication. In previous versions of SharePoint, you could also configure classic mode authentication for web applications in Central Administration. Classic mode authentication uses Windows authentication and SharePoint 2013 treats the user accounts as AD DS accounts.

To configure a web application to use classic mode authentication, you must use the New-SPWebApplication Windows PowerShellcmdlet to create it. SharePoint 2010 Products web applications that are configured for classic mode authentication retain their authentication settings when you upgrade to SharePoint 2013. However, we recommend that you migrate your web applications to claims-based authentication before upgrading to SharePoint 2013.

A SharePoint 2013 farm can include a mix of web applications that use both modes. Some services do not differentiate between user accounts that are traditional Windows accounts and Windows claims accounts.

For more information about migrating before upgrading, see Migrate from classic-mode to claims-based authentication.

For more information about migrating after upgrading, see Migrate from classic-mode to claims-based authentication in SharePoint 2013.

For information about how to create web applications that use classic mode authentication in SharePoint 2013, see Create web applications that use classic mode authentication in SharePoint 2013. Note that you cannot migrate a web application that uses claims-based authentication to use classic mode authentication.

Important:

Office Web Apps can be used only by SharePoint 2013 web applications that use claims-based authentication. Office Web Apps rendering and editing will not work on SharePoint 2013 web applications that use classic mode authentication. If you migrate SharePoint 2010 web applications that use classic mode authentication to SharePoint 2013, you must migrate them to claims-based authentication to allow them to work with Office Web Apps. For more information, see Use Office Web Apps with SharePoint 2013.

Supported authentication types and methods

SharePoint 2013 supports a variety of authentication methods and authentication providers for the following authentication types:

  • Windows authentication

  • Forms-based authentication

  • SAML token-based authentication

Windows authentication

The Windows authentication type takes advantage of your existing Windows authentication provider (AD DS) and the authentication protocols that a Windows domain environment uses to validate the credentials of connecting clients. Windows authentication methods, which are used by both claims-based authentication and classic mode, include the following:

  • NTLM

  • Kerberos

  • Digest

  • Basic

For more information, see Plan for Windows authentication in this article.

Watch the Windows claims authentication in SharePoint 2013 video

Video (play button) icon

Although not a Windows authentication type, SharePoint 2013 also supports anonymous authentication. Users can access SharePoint content without validating their credentials. Anonymous authentication is disabled by default. You typically use anonymous authentication when you use SharePoint 2013 to publish content that does not require security and is available for all users, such as a public Internet website.

Note that in addition to enabling anonymous authentication, you must also configure anonymous access (permissions) on sites and site resources.

Forms-based authentication

Forms-based authentication is a claims-based identity management system that is based on ASP.NET membership and role provider authentication. Forms-based authentication can be used against credentials that are stored in an authentication provider, such as the following:

  • AD DS

  • A database such as a SQL Server database

  • An Lightweight Directory Access Protocol (LDAP) data store such as Novell eDirectory, Novell Directory Services (NDS), or Sun ONE

Forms-based authentication validates users based on credentials that users type in a logon form (typically a web page). Unauthenticated requests are redirected to a logon page, where a user must provide valid credentials and submit the form. The system issues a cookie for authenticated requests that contains a key for reestablishing the identity for subsequent requests.

Watch the forms-based claims authentication in SharePoint 2013 video

Video (play button) icon
Note:

With forms-based authentication, the user account credentials are sent as plaintext. Therefore, you should not use forms-based authentication unless you are also using Secure Sockets Layer (SSL) to encrypt the website traffic.

For more information, see Plan for forms-based authentication.

SAML token-based authentication

SAML token-based authentication in SharePoint 2013 uses the SAML 1.1 protocol and the WS-Federation Passive Requestor Profile (WS-F PRP). It requires coordination with administrators of a claims-based environment, whether it is your own internal environment or a partner environment. If you use Active Directory Federation Services (AD FS) 2.0, you have a SAML token-based authentication environment.

A SAML token-based authentication environment includes an identity provider security token service (IP-STS). The IP-STS issues SAML tokens on behalf of users whose accounts are included in the associated authentication provider. Tokens can include any number of claims about a user, such as a user name and the groups to which the user belongs. An AD FS 2.0 server is an example of an IP-STS.

SharePoint 2013 takes advantage of claims that are included in tokens that an IP-STS issues to authorized users. In claims environments, an application that accepts SAML tokens is known as a relying party STS (RP-STS). A relying party application receives the SAML token and uses the claims inside to decide whether to grant the client access to the requested resource. In SharePoint 2013, each web application that is configured to use a SAML provider is added to the IP-STS server as a separate RP-STS entry. A SharePoint farm can represent multiple RP-STS entries in the IP-STS.

Watch the SAML-based claims authentication in SharePoint 2013 video

Video (play button) icon

The set of authentication providers for SAML token-based authentication depends on the IP-STS in your claims environment. If you use AD FS 2.0, authentication providers (known as attribute stores for AD FS 2.0) can include the following:

  • Windows Server 2003 Active Directory and AD DS in Windows Server 2008

  • All editions of SQL Server 2005 and SQL Server 2008

  • Custom attribute stores

For more information, see Plan for SAML token-based authentication.

Choosing authentication types for LDAP environments

Forms-based authentication or SAML token-based authentication can use LDAP environments. You should use the authentication type that matches your current LDAP environment. If you do not already have an LDAP environment, we recommend that you use forms-based authentication because it is less complex. However, if your authentication environment already supports WS-Federation 1.1 and SAML 1.1, then we recommend SAML. SharePoint Server 2013 has a built-in LDAP provider. For SharePoint Foundation 2013, you might have to deploy a third-party LDAP provider.

Plan for Windows authentication

The process of planning and implementing Windows authentication methods is similar for both claims-based and classic mode authentication. Claims-based authentication for a web application does not increase the complexity of implementing Windows authentication methods. This section summarizes the planning for the Windows authentication methods.

NTLM and the Kerberos protocol

Both NTLM and the Kerberos protocol are Integrated Windows authentication methods, which let users seamlessly authenticate without prompts for credentials. For example:

  • Users who access SharePoint sites from Internet Explorer use the credentials under which the Internet Explorer process is running to authenticate. By default, these credentials are the credentials that the user used to log on to the computer.

  • Services or applications that use Integrated Windows authentication methods to access SharePoint resources attempt to use the credentials of the running thread, which by default is the identity of the process, to authenticate.

NTLM is the simplest form of Windows authentication to implement and typically requires no additional configuration of authentication infrastructure. Simply select this option when you create or configure the web application.

The Kerberos protocol supports ticketing authentication. Use of the Kerberos protocol requires additional configuration of the environment. To enable Kerberos authentication, the client and server computers must have a trusted connection to the domain Key Distribution Center (KDC). Configuring the Kerberos protocol involves setting up service principal names (SPNs) in AD DS before you install SharePoint 2013.

The reasons why you should consider Kerberos authentication are as follows:

  • The Kerberos protocol is the strongest Integrated Windows authentication protocol, and supports advanced security features including Advanced Encryption Standard (AES) encryption and mutual authentication of clients and servers.

  • The Kerberos protocol allows for delegation of client credentials.

  • Of the available secure authentication methods, Kerberos requires the least amount of network traffic to AD DS domain controllers. Kerberos can reduce page latency in certain scenarios, or increase the number of pages that a front-end web server can serve in certain scenarios. Kerberos can also reduce the load on domain controllers.

  • The Kerberos protocol is an open protocol that many platforms and vendors support.

The reasons why Kerberos authentication might not be appropriate are as follows:

  • Kerberos authentication requires more configuration of infrastructure and environment than other authentication methods to function correctly. In many cases, domain administrator permission is required to configure the Kerberos protocol. Kerberos authentication can be difficult to set up and manage. Misconfiguring Kerberos can prevent successful authentication to your sites.

  • Kerberos authentication requires client computer connectivity to a KDC and to an AD DS domain controller. In a Windows deployment, the KDC is an AD DS domain controller. While this is a common network configuration on an organization intranet, Internet-facing deployments are typically not configured in this manner.

The following steps summarize configuring Kerberos authentication:

  1. Configure Kerberos authentication for SQL Server communications by creating SPNs in AD DS for the SQL Server service account.

  2. Create SPNs for web applications that will use Kerberos authentication.

  3. Install the SharePoint 2013 farm.

  4. Configure specific services within the farm to use specific accounts.

  5. Create the web applications that will use Kerberos authentication.

For more information about how to plan for the Kerberos protocol, see Plan for Kerberos authentication in SharePoint 2013.

Digest and Basic

With the Digest authentication method, the user account credentials are sent as an MD5 message digest to the Internet Information Services (IIS) service on the web server that hosts the web application or zone. With the Basic authentication method, the user account credentials are sent as plaintext. Therefore, you should not use the Basic authentication method unless you are also using SSL to encrypt the website traffic.

You might have to use these older authentication methods if your environment uses web browsers or services that only support Digest or Basic authentication to websites.

Unlike the NTLM, Kerberos, and Anonymous authentication methods, you configure Digest and Basic authentication methods from the properties of the web site that corresponds to the web application or zone in the Internet Information Services (IIS) snap-in.

If you are using claims-based authentication, see the following:

  • Configure digest authentication for a claims-based web application in SharePoint 2013

  • Configure basic authentication for a claims-based web application in SharePoint 2013

If you are using classic mode authentication, see the following:

  • Configure Digest authentication for a classic-mode web application

  • Configure Basic authentication for a classic-mode web application

Plan for forms-based authentication

To use forms-based authentication to authenticate users against an identity management system that is not based on Windows or that is external, you must register the membership provider and role manager in the Web.config file. SharePoint 2013 uses the standard ASP.NET role manager interface to collect group information about the current user. Each ASP.NET role is treated as a domain group by the authorization process in SharePoint 2013. You register role managers in the Web.config file exactly as you register membership providers for authentication.

If you want to manage membership users or roles from the Central Administration website, you must register the membership provider and the role manager in the Web.config file for the Central Administration website. You must also register the membership provider and the role manager in the Web.config file for the web application that hosts the content.

For detailed steps to configure forms-based authentication, see Configure forms-based authentication for a claims-based web application in SharePoint 2013

Plan for SAML token-based authentication

The architecture for implementing SAML token-based providers includes the following components:

  • SharePoint Security Token Service This service creates the SAML tokens that the farm uses. The service is automatically created and started on all servers in a server farm. The service is used for inter-farm communication because all inter-farm communication uses claims-based authentication. This service is also used for authentication methods that are implemented for web applications that use claims-based authentication. This includes Windows authentication, forms-based authentication, and SAML token-based authentication.

  • Token-signing certificate (ImportTrustCertificate) This is the certificate that you export from an IP-STS and then copy to one server in the farm and add it to the farm's Trusted Root Authority list. Once you use this certificate to create an SPTrustedIdentityTokenIssuer, you cannot use it to create another one. To use the certificate to create a different SPTrustedIdentityTokenIssuer, you must delete the existing one first. Before you delete an existing one, you must disassociate it from all web applications that may be using it.

  • Identity claim The identity claim is the claim from a SAML token that is the unique identifier of the user. Only the owner of the IP-STS knows which value in the token will always be unique for each user. The identity claim is created as a regular claims mapping during the mapping of all desired claims. The claim that serves as the identity claim is declared when the SPTrustedIdentityTokenIssuer is created.

  • Other claims These claims consist of additional claims from a SAML ticket that describe users. These can include user roles, user groups, or other kinds of claims such as age. All claims mappings are created as objects that are replicated across the servers in a SharePoint 2013 farm.

  • Realm In the SharePoint claims architecture, the URI or URL that is associated with a SharePoint web application that is configured to use a SAML token-based provider represents a realm. When you create a SAML-based authentication provider on the farm, you specify the realms, or web application URLs, that you want the IP-STS to recognize, one at a time. The first realm is specified when you create the SPTrustedIdentityTokenIssuer. You can add more realms after you create the SPTrustedIdentityTokenIssuer. Realms are specified by using syntax similar to the following: $realm = "urn:sharepoint:mysites". After you add the realm to the SPTrustedIdentityTokenIssuer, you must create an RP-STS trust with the realm identifier on the IP-STS server. This process involves specifying the URL for the web application.

  • SPTrustedIdentityTokenIssuer This is the object that is created on the SharePoint farm that includes the values necessary to communicate with and receive tokens from the IP-STS. When you create the SPTrustedIdentityTokenIssuer, you specify which token-signing certificate to use, the first realm, the claim that represents the identity claim, and any additional claims. You can only associate a token-signing certificate from an STS with one SPTrustedIdentityTokenIssuer. However, after you create the SPTrustedIdentityTokenIssuer, you can add more realms for additional web applications. After you add a realm to the SPTrustedIdentityTokenIssuer, you must also add it to the IP-STS as a relying party. The SPTrustedIdentityTokenIssuer object is replicated across servers in the SharePoint 2013 farm.

  • Relying party security token service (RP-STS) In SharePoint 2013, each web application that is configured to use a SAML provider is added to the IP-STS server as an RP-STS entry. A SharePoint 2013 farm can include multiple RP-STS entries.

  • Identity provider security token service (IP-STS) This is the secure token service in the claims environment that issues SAML tokens on behalf of users who are included in the associated user directory.

The following diagram shows the SharePoint 2013 SAML token claims architecture.

SAML token claims architecture

SharePoint claims authentication components

The SPTrustedIdentityTokenIssuer object is created with several parameters, which include the following:

  • A single identity claim.

  • A single SignInURL parameter.

    The SignInURL parameter specifies the URL to redirect a user request to in order to authenticate to the IP-STS.

  • A single Wreply parameter.

    Some IP-STS servers require the Wreply parameter, which is set to either true or false. False is the default. Use the Wreply parameter only if it is required by the IP-STS.

  • Multiple realms.

  • Multiple claims mappings.

To implement SAML token-based authentication with SharePoint 2013, use the following steps which require planning in advance:

  1. Export the token-signing certificate from the IP-STS. Copy the certificate to a server in the SharePoint 2013 farm.

  2. Define the claim that will be used as the unique identifier of the user. This is known as the identity claim. The user principal name (UPN) or user e-mail name is frequently used as the user identifier. Coordinate with the administrator of the IP-STS to determine the correct identifier because only the owner of the IP-STS knows the value in the token that will always be unique per user. Identifying the unique identifier for the user is part of the claims-mapping process. You use Windows PowerShell to create claims mappings.

  3. Define additional claims mappings. Define the additional claims from the incoming token that the SharePoint 2013 farm will use. User roles are an example of a claim that can be used to assign permissions to resources in the SharePoint 2013 farm. All claims from an incoming token that do not have a mapping will be discarded.

  4. Use Windows PowerShell to create a new authentication provider to import the token-signing certificate. This process creates the SPTrustedIdentityTokenIssuer. During this process, you specify the identity claim and additional claims that you have mapped. You must also create and specify a realm that is associated with the first SharePoint web applications that you are configuring for SAML token-based authentication. After you create the SPTrustedIdentityTokenIssuer, you can create and add more realms for additional SharePoint web applications. This is how you configure multiple web applications to use the same SPTrustedIdentityTokenIssuer.

  5. For each realm that you add to the SPTrustedIdentityTokenIssuer, you must create an RP-STS entry on the IP-STS. You can do this before the SharePoint web application exists. Regardless, you must plan the URL before you create the web applications.

  6. For an existing or new SharePoint web application, configure it to use the newly created authentication provider. The authentication provider is displayed as a trusted identity provider in Central Administration when you create a web application.

You can configure multiple SAML token-based authentication providers. However, you can only use a token-signing certificate once in a farm. All configured providers are displayed as options in Central Administration. Claims from different trusted STS environments will not conflict.

If you implement SAML token-based authentication with a partner company and your own environment includes an IP-STS, we recommend that you and the administrator of your internal claims environment establish a one-way trust relationship from your internal IP-STS to the partner STS. This approach does not require you to add an authentication provider to your SharePoint 2013 farm. It also enables your claims administrators to manage the whole claims environment.

Important:

You no longer have to set network load balancing to single affinity when you are using claims-based authentication in SharePoint 2013.

Note:

When a web application is configured to use SAML token-based authentication, the SPTrustedClaimProvider class does not provide search functionality to the People Picker control. Any text entered in the People Picker control will automatically be displayed as if it resolves, regardless of whether it is a valid user, group, or claim. If your SharePoint 2013 solution uses SAML token-based authentication, plan to create a custom claims provider that implements custom search and name resolution.

For more information, see Plan for custom claims providers for People Picker in SharePoint 2013.

For detailed steps to configure SAML token-based authentication using AD FS, see Configure SAML-based claims authentication with AD FS in SharePoint 2013.

For additional information about SAML token-based authentication, see the following resources:

  • TechNet blog article: Planning Considerations for Claims Based Authentication in SharePoint 2010

  • TechNet blog article: Creating both an Identity and Role Claim for a SharePoint 2010 Claims Auth Application

  • TechNet blog article: How to Create Multiple Claims Auth web Apps in a Single SharePoint 2010 Farm

Planning zones for web applications

Zones represent different logical paths to gain access to the same sites in a web application. Each web application can include as many as five zones. When you create a web application, Central Administration creates the zone named default. To create additional zones, extend the web application and select one of the remaining zone names: intranet, extranet, Internet, or custom.

Your plan for zones will depend on the following:

  • Claims-based authentication (recommended) — You can implement multiple authentication providers on a single zone. You can also use multiple zones.

  • Classic mode (discouraged) — You can implement only one type of authentication per zone. However, classic mode only supports Windows authentication methods. Consequently, you can use multiple zones only to implement multiple Windows authentication methods, or to implement the same Windows authentication method against different AD DS stores.

Implementing more than one type of authentication on a single zone

If you use claims-based authentication and implement more than one authentication method, we recommend that you implement multiple authentication methods on the default zone. The result is the same URL for all users.

When you implement multiple authentication methods on the same zone, the following restrictions apply:

  • You can implement only one instance of forms-based authentication on a zone.

  • Central Administration allows you to use both an Integrated Windows method and Basic at the same time. Otherwise, you cannot implement more than one type of Windows authentication on a zone.

If multiple SAML token-based authentication providers are configured for a farm, all appear as options when you create a web application or a new zone. You can configure multiple SAML providers on the same zone.

The following diagram shows multiple types of authentication implemented on the default zone for a partner collaboration site.

Multiple types of authentication implemented on the default zone

Multiple types of authentication on a zone

In the diagram, users from different directory stores use the same URL to access the partner web site. The dashed box that surrounds partner companies shows the relationship between the user directory and the authentication type that is configured in the default zone. For more information about this design example, see SharePoint 2013 design samples: Corporate portal and extranet sites.

Planning to crawl content

The crawl component requires NTLM to access content. At least one zone must be configured to use NTLM authentication. If NTLM authentication is not configured on the default zone, the crawl component can use a different zone that is configured to use NTLM authentication.

Implement more than one zone

If you plan to implement more than one zone for web applications, use the following guidelines:

  • Use the default zone to implement your most secure authentication settings. If a request cannot be associated with a specific zone, the authentication settings and other security policies of the default zone are applied. The default zone is the zone that is created when you create a web application. Typically, the most secure authentication settings are designed for end-user access. Consequently, end-users are likely to access the default zone.

  • Use the minimum number of zones that are required to provide access to users. Each zone is associated with a new IIS site and domain for accessing the web application. Only add new access points when they are required.

  • Ensure that at least one zone is configured to use NTLM authentication for the crawl component. Do not create a dedicated zone for the index component unless it is necessary.

The following diagram shows multiple zones that are implemented to accommodate different authentication types for a partner collaboration site.

One zone per authentication type

One zone for each authentication type

In the diagram, the default zone is used for remote employees. Each zone has a different URL associated with it. Employees use a different zone depending on whether they are working in the office or are working remotely.

Change History

Date | Description
April 16, 2013 | Added the new user authentication process videos.
July 16, 2012 | Initial publication


Plan for app authentication in SharePoint 2013
See also

Summary: Learn how to plan for app authentication in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

App authentication is the validation of an external app for SharePoint's identity and the authorization of both the app and an associated user when the app requests access to a secured SharePoint resource. App authentication occurs when an external component of a SharePoint Store app or an App Catalog app, such as a web server that is located on the intranet or the Internet, attempts to access a secured SharePoint resource. For example, an app for SharePoint that includes a component that runs in Windows Azure is an external app. App authentication enables a new set of functionality and scenarios that can be achieved by allowing apps to include data from SharePoint resources in the results that the app processes and displays for users.

To provide the requested resources from an app for SharePoint, the server that runs SharePoint 2013 must do the following:

  • Verify that the requesting app is trusted.

    To authenticate the requesting app, you must configure the server that runs SharePoint 2013 to trust the app that is sending it requests. This is a one-way trust relationship.

  • Verify that the type of access that the app is requesting is authorized.

    To authorize the access, SharePoint 2013 relies on the set of app permissions, which was specified in the app manifest file when it was installed, and the permissions that are associated with the user on whose behalf the app is acting. SharePoint 2013 also relies on the permissions that were granted to the SPAppPrincipal when the trust was established by using the Set-SPAppPrincipalPermission Windows PowerShell cmdlet.

Note that app authentication in SharePoint 2013 is separate from user authentication and is not used as a sign-in authentication protocol by SharePoint users. App authentication uses the Open Authorization (OAuth) 2.0 protocol and does not add to the set of user authentication or sign-on protocols, such as WS-Federation. There are no new user authentication protocols in SharePoint 2013. App authentication and OAuth do not appear in the list of identity providers.

In this article:

  • Introduction

  • Identify the set of trust relationships

  • Choose user authentication methods for on-premises apps

  • Provide incoming access from external applications hosted on the Internet

  • Address User Profile application service considerations

Introduction

Planning for app authentication consists of the following tasks:

  • Identify the set of trust relationships that you have to configure on a farm that runs SharePoint 2013 that correspond to the external apps that will be making requests for SharePoint resources.

  • Provide incoming access from external applications that the Internet hosts.

Important:

The web applications that include app authentication endpoints (for incoming requests by apps for SharePoint) must be configured to use Secure Sockets Layer (SSL). You can configure OAuth in SharePoint 2013 so that it does not require SSL. However, we recommend this only for evaluation, for ease of configuration or to create an app development environment.

Note:

You only have to plan for app authentication on a SharePoint farm if you are using one or more external apps for SharePoint that require its resources.

Identify the set of trust relationships

You must configure the SharePoint farm to trust the access tokens that correspond to resource requests that the following types of external apps send:

  • Autohosted apps run as a web role in Windows Azure and use the Windows Azure Access Control Service (ACS) to obtain the access token.

    For autohosted apps, you must configure the SharePoint farm to trust the ACS instance of the autohosted app.

  • Provider-hosted apps run on their own servers on the Internet or your intranet, are registered with Windows Azure, and use ACS to obtain the access token.

    For provider-hosted apps, you must configure the SharePoint farm to trust the ACS instance of the provider-hosted app.

    For more information about autohosted and provider-hosted apps, see Overview of apps for SharePoint 2013.

  • High-trust apps run on stand-alone servers on your intranet and use a signing certificate to digitally sign the access tokens that the app generates.

    High-trust apps use the server-to-server protocol to request resources on behalf of a user. For high-trust apps, configure the SharePoint farm with the JavaScript Object Notation (JSON) metadata endpoint of the server that hosts the app. Or, you can manually configure the trust. For more information, see Configure app authentication in SharePoint Server 2013

    For more information about high-trust apps, see How to: Create high-trust apps for SharePoint 2013 using the server-to-server protocol.

Choose user authentication methods for on-premises apps

An on-premises app is either a provider-hosted app that is hosted on an on-premises server or a SharePoint hosted app. Table 1 lists the different authentication user methods of SharePoint 2013 and whether that method can be used for SharePoint 2013 on-premises apps.

Table 1. User authentication methods and support by on-premises apps

Authentication method Supported by on-premises apps

NTLM

Yes

Kerberos

Yes, but only when it is configured to use NTLM as a fallback authentication method. Kerberos-only is not supported.

Basic

Yes

Anonymous

Yes

Forms-based authentication using the default ASP.NET provider

Yes

Forms-based authentication using Lightweight Directory Access Protocol (LDAP)

Yes

Security Assertion Markup Language (SAML) authentication

Yes, if the identity provider supports wildcard return uniform resource locator (URL) registration and honors the wreply parameter. For more information, see WS-Federation: Passive Requestor Profile.

To configure SharePoint 2013 to use the wreply parameter, use the following commands at a Windows PowerShell command prompt:

Copy code
$p = Get-SPTrustedTokenIssuer
$p.UseWReplyParameter = $true
$p.Update()
Note:

Active Directory Federation Services (AD FS) 2.0 version does not support wildcard for return URL registration.

For more information about user authentication methods in SharePoint 2013, see Plan for user authentication methods in SharePoint 2013.

Provide incoming access from external applications hosted on the Internet

If external autohosted or provider-hosted apps are located on the Internet, you have to configure a reverse web proxy to perform app authentication and request resources from intranet SharePoint farms. A configured reverse web proxy at the edge of your network has to allow incoming HTTP over SSL (HTTPS) connections from the apps to your SharePoint farms. You typically identify the HTTPS-based URLs that the external applications will access and configure the reverse proxy to publish those URLs and provide the appropriate security.

Address User Profile application service considerations

High-trust apps generate their own access tokens, which include an assertion of the identity of the user on whose behalf they are acting. The server that runs SharePoint 2013 and services the incoming resource request must be able to resolve the request to a specific SharePoint user, a process known as rehydrating the user's identity. Note that this differs from app authentication for autohosted or provider-hosted apps, in which the user is identified, but not asserted.

To rehydrate a user's identity, a server that runs SharePoint 2013 takes the claims from the incoming access token and resolves it to a specific SharePoint user. By default, SharePoint 2013 uses the built-in User Profile service application as the identity resolver.

The key user attributes for user identity rehydration are as follows:

  • The Windows Security Identifier (SID)

  • The Active Directory Domain Services (AD DS) user principal name (UPN)

  • The Simple Mail Transfer Protocol (SMTP) address

  • The Session Initiation Protocol (SIP) address

Therefore, the app must include at least one of these user attributes and that attribute must be current in user profiles. We recommend a periodic synchronization from identity stores to the User Profile service application.

Furthermore, SharePoint 2013 expects only one entry in the User Profile service application for a given lookup query that is based on one or more of these four attributes. Otherwise, it returns an error condition that multiple user profiles were found. Therefore, you should delete obsolete user profiles in the User Profile service application periodically to avoid multiple user profiles.

If a user profile exists for a user and the relevant group memberships are not synchronized, access may be denied when the user is supposed to be granted access for a given resource. Therefore, make sure that group memberships are synchronized with the User Profile service application.

See also

What's new in authentication for SharePoint 2013
Authentication overview for SharePoint 2013


Plan for server-to-server authentication in SharePoint 2013
See also

Summary: Learn how to plan for server-to-server authentication in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Server-to-server authentication allows for servers that are capable of server-to-server authentication to access and request resources from one another on behalf of users. Servers that are capable of server-to-server authentication run SharePoint 2013, Exchange Server 2013, Lync Server 2013, Azure Workflow Service, or other software that supports the Microsoft server-to-server protocol. Server-to-server authentication enables a new set of functionality and scenarios, such as What's new in eDiscovery in SharePoint Server 2013, that can be achieved through cross-server resource sharing and access.

To provide the requested resources from another server that can perform server-to-server authentication, the server that runs SharePoint 2013 must do the following:

  • Verify that the requesting server is trusted. To authenticate the requesting server, you must configure the server that runs SharePoint 2013 to trust the server that is sending it requests. This is a one-way trust relationship.

  • Verify that the type of access that the server is requesting is authorized. To authorize the access, you must configure the server that runs SharePoint 2013 for the appropriate set of permissions for the requested resources.

Note that the server-to-server authentication protocol in SharePoint 2013 is separate from user authentication and is not used as a sign-in authentication protocol by SharePoint users. The server-to-server authentication protocol, which uses the Open Authorization (OAuth) 2.0 protocol, does not add to the set of user sign-on protocols, such as WS-Federation. There are no new user authentication protocols in SharePoint 2013. The server-to-server authentication protocol does not appear in the list of identity providers.

In this article:

  • Introduction

  • Identify the set of trust relationships

For information about how to plan for the User Profile application service for server-to-server authentication, see Server-to-server authentication and user profiles in SharePoint Server 2013.

Introduction

Planning for server-to-server authentication consists of the following tasks:

  • Identify the set of trust relationships that you have to configure on a server that runs SharePoint 2013.

  • Address User Profile application service considerations. For more information, see Server-to-server authentication and user profiles in SharePoint Server 2013.

Important:

The web applications that include server-to-server authentication endpoints (for incoming server-to-server requests) or that make outgoing server-to-server requests to other servers must be configured to use Secure Sockets Layer (SSL).

Note:

You only have to plan for server-to-server authentication on a server that runs SharePoint 2013 if you are configuring one or more server-to-server scenarios that require its use.

Identify the set of trust relationships

From the perspective of a server that runs SharePoint 2013, a trust relationship with another server that can perform server-to-server authentication consists of the following:

  • The server that runs SharePoint 2013 trusts requests from a server that can perform server-to-server authentication (incoming to the server that runs SharePoint 2013).

    This requires configuration on the server that runs SharePoint 2013 so that it trusts the requesting server.

  • The server that can perform server-to-server authentication trusts requests from a server that runs SharePoint 2013 (outgoing from the server that runs SharePoint 2013).

    This requires configuration on the server that can perform server-to-server authentication so that it trusts the requesting server that runs SharePoint 2013.

For each farm that runs SharePoint 2013, make a list of servers that are capable server-to-server authentication and that will be receiving incoming requests based on the server-to-server scenarios that involve the farm. There are two cases of server-to-server authentication relationships to examine.

Case 1: Farms are on-premises

If the farm that can perform server-to-server authentication is on-premises, you must configure the farm that runs SharePoint 2013. Use the New-SPTrustedSecurityTokenIssuer Windows PowerShell cmdlet to add a JavaScript Object Notation (JSON) metadata endpoint of the server that can perform server-to-server authentication to the server that runs SharePoint 2013. If the server that can perform server-to-server authentication is another server that runs SharePoint 2013, the JSON metadata endpoint is in the format: https://<HostName>/_layouts/15/metadata/json/1.

Case 2: Farms are part of an Office 365 tenancy

If the farm that runs SharePoint 2013 and the other server that can perform server-to-server authentication are both part of an Office 365 tenancy, no additional configuration for server-to-server authentication is needed.

After you determine the set of servers that require server-to-server authentication, see Configure server-to-server authentication in SharePoint 2013 to configure the server-to-server trust relationships.

See also

What's new in authentication for SharePoint 2013
Authentication overview for SharePoint 2013
Configure server-to-server authentication in SharePoint 2013
Server-to-server authentication and user profiles in SharePoint Server 2013


Plan the Secure Store Service in SharePoint Server 2013
See also

Summary: Plan to store authorization credentials in an encrypted database by using Secure Store Service in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The Secure Store Service is a claims-aware authorization service that includes an encrypted database for storing credentials.

In this article:

  • About the Secure Store Service

  • Secure store service preparation

  • Target applications

  • Secure store credential mappings

  • Secure store service and claims authentication

About the Secure Store Service

The Secure Store Service is an authorization service that runs on an application server. The Secure Store Service provides a database that is used to store credentials. These credentials usually consist of a user identity and password, but can also contain other fields that you define. For example, SharePoint Server 2013 can use the Secure Store database to store and retrieve credentials for access to external data sources. The Secure Store Service provides support for storing multiple sets of credentials for multiple back-end systems.

Usage scenarios for Secure Store include the following:

  • Excel Services can use Secure Store to provide access to external data sources in published workbooks. This can be used as a substitute to passing a user's credentials to the data source, a process which often requires configuring Kerberos delegation. Excel Services requires Secure Store if you want to configure an unattended service account for data authentication.

  • Visio Services can use Secure Store to provide access to external data sources in published data-connected diagrams. This can be used as a substitute to passing a user's credentials to the data source, a process which often requires configuring Kerberos delegation. Visio Services requires Secure Store if you want to configure an unattended service account for data authentication.

  • PerformancePoint Services can use Secure Store to provide access to external data sources. PerformancePoint Services requires Secure Store if you want to configure an unattended service account for data authentication.

  • Power Pivot requires Secure Store for scheduled refresh of PowerPivot workbooks.

  • Microsoft Business Connectivity Services can use Secure Store to map the user's credentials to a set of credentials for an external system. You can either map each user's credentials to a unique account on the external system or you can map a set of authenticated users to a single group account. Business Connectivity Services can also use Secure Store to store certificates for accessing an on-premises data source from SharePoint Online.

  • SharePoint runtime can use Secure Store to store credentials necessary to communicate with Azure services, if any of the user apps require SharePoint runtime to provision and use Azure Services.

Secure store service preparation

When you prepare to deploy the Secure Store Service, be aware of the following important guidelines:

  • Before you generate a new encryption key, back up the Secure Store database. You should also back up the Secure Store database after it is initially created, and again each time credentials are reencrypted. When a new key is generated, the credentials can be re-encrypted with the new key. If the key refresh fails, or the passphrase is forgotten, the credentials will not be useable.

  • Back up the encryption key after initially setting up Secure Store, and back up the key again each time it is regenerated.

  • Do not store the backup media for the encryption key in the same location as the backup media for the secure store database. If a user obtains a copy of both the database and the key, the credentials stored in the database could be compromised.

Because Secure Store is used to store sensitive information, for better security we recommend that you consider the following guidelines:

  • Run the Secure Store Service in a separate application pool that is not used for any other service.

  • Run the Secure Store Service on a separate application server that is not used for any other service.

  • Create the Secure Store database on a separate application server running SQL Server. Do not use the same SQL Server installation that contains content databases.

Target applications

A target application is a collection of information that maps a user or users to a set of encrypted credentials stored in the Secure Store database. Target applications contain the following information that you define:

  • Whether this is an individual or group mapping.

  • What fields to store in the Secure Store database. (The default is Windows User Name and Windows Password, but additional field types can be selected, depending on the application.)

  • Users with permissions to administer the target application.

  • The individual or group to whom you are mapping the credentials.

Each target application has a unique application ID that you define that is used to reference the target application from external applications such as Excel Services or SharePoint Designer.

Secure store credential mappings

The Secure Store Service supports individual mappings and group mappings. In a group mapping, every user who is a member of a specific domain group is mapped to the same set of credentials. In an individual mapping, each individual user is mapped to a unique set of credentials. Individual mappings are useful if you need logging information about individual user access to shared resources. For group mappings, a security layer maps credentials for multiple domain users against a single set of credentials that are stored in the secure store database. Group mappings are easier to maintain than individual mappings, and can provide improved performance.

Secure store service and claims authentication

The Secure Store Service is a claims-aware service. It can accept security tokens and decrypt them to get the application ID, and then perform a lookup. When a SharePoint Server 2013 Security Token Service (STS) issues a security token in response to an authentication request, the Secure Store Service decrypts the token and reads the application ID value. The Secure Store Service uses the application ID to retrieve credentials from the secure store database. The credentials are then used to authorize access to resources.

See also

Configure the Secure Store Service in SharePoint 2013
Data authentication for Excel Services in SharePoint Server 2013
Data authentication for Visio Services in SharePoint Server 2013


Plan for Kerberos authentication in SharePoint 2013
See also

Summary: Learn how to plan for Kerberos authentication in SharePoint 2013 for Windows and claims-based authentication.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The Kerberos protocol supports an authentication method that uses tickets that a trusted source provides. Kerberos tickets indicate that the network credentials of a user who is associated with a client computer were authenticated. The Kerberos protocol defines how users interact with a network service to gain access to network resources. The Kerberos Key Distribution Center (KDC) issues a ticket-granting-ticket (TGT) to a client computer on behalf of a user. In Windows, the client computer is a member of an Active Directory Domain Services (AD DS) domain and the TGT is proof that the domain controller authenticated the user credentials.

Before establishing a network connection to a network service, the client computer presents its TGT to the KDC and requests a service ticket. Based on the previously issued TGT, which confirms that the client computer was authenticated, the KDC issues a service ticket to the client computer. The client computer then submits the service ticket to the network service. The service ticket must also contain an acceptable Service Principal Name (SPN) that identifies the service. To enable Kerberos authentication, the client and server computers must already have a trusted connection to the KDC. The client and server computers must also be able to access AD DS.

In this article:

  • Kerberos authentication and SharePoint 2013

  • Kerberos authentication and claims-based authentication

Kerberos authentication and SharePoint 2013

The reasons why you should consider Kerberos authentication are as follows:

  • The Kerberos protocol is the strongest Integrated Windows authentication protocol, and supports advanced security features including Advanced Encryption Standard (AES) encryption and mutual authentication of clients and servers.

  • The Kerberos protocol allows for delegation of client credentials.

  • Of the available secure authentication methods, Kerberos requires the least amount of network traffic to AD DS domain controllers. Kerberos can reduce page latency in certain scenarios, or increase the number of pages that a front-end web server can serve in certain scenarios. Kerberos can also reduce the load on domain controllers.

  • The Kerberos protocol is an open protocol that is supported by many platforms and vendors.

The reasons why Kerberos authentication might not be appropriate are as follows:

  • In contrast to other authentication methods, Kerberos authentication requires additional infrastructure and environment configuration to function correctly. In many cases, domain administrator permission is required to configure Kerberos authentication which can be difficult to set up and manage. Misconfiguring Kerberos can prevent successful authentication to your sites.

  • Kerberos authentication requires client computer connectivity to a KDC and to an AD DS domain controller. In a Windows and SharePoint deployment, the KDC is an AD DS domain controller. While this is a common network configuration on an organization intranet, Internet-facing deployments are typically not configured in this manner.

Kerberos delegation

Kerberos authentication supports the delegation of client identity. This means that a service can impersonate an authenticated client's identity. Impersonation enables a service to pass the authenticated identity to other network services on behalf of the client. Claims-based authentication can also be used to delegate client credentials, but requires the back-end application to be claims-aware.

Used with SharePoint 2013, Kerberos delegation enables a front-end service to authenticate a client and then use the client's identity to authenticate to a back-end system. The back-end system then performs its own authentication. When a client uses Kerberos authentication to authenticate with a front-end service, Kerberos delegation can be used to pass a client's identity to a back-end system. The Kerberos protocol supports two types of delegation:

  • Basic Kerberos delegation (unconstrained)

  • Kerberos constrained delegation

Basic Kerberos delegation and Kerberos constrained delegation

Basic Kerberos delegation can cross domain boundaries within the same forest but cannot cross a forest boundary. Kerberos constrained delegation cannot cross domain or forest boundaries, except when you are using domain controllers that run Windows Server 2012. For more information, see What's New in Kerberos Authentication.

Depending on the service applications that are part of a SharePoint 2013 deployment, implementing Kerberos authentications with SharePoint 2013 can require Kerberos constrained delegation.

Important:

To deploy Kerberos authentication with any of the following service applications, SharePoint Server 2013 and all external data sources must reside in the same Windows domain:

  • Excel Services

  • PerformancePoint Services

  • InfoPath Forms Services

  • Visio Services

These service applications are not available in SharePoint Foundation 2013.

To deploy Kerberos authentication with any of the following service applications or products, SharePoint Server 2013 can use either basic Kerberos delegation or Kerberos constrained delegation:

  • Business Data Connectivity service (this service application is not available in SharePoint Foundation 2013)

  • Access Services (this service application is not available in SharePoint Foundation 2013)

  • SQL Server Reporting Services (SSRS) (a separate product)

  • Project Server 2013 (a separate product)

Services that are enabled for Kerberos authentication can delegate identity multiple times. As an identity travels from service to service, the delegation method can change from basic Kerberos to Kerberos constrained. However, the reverse is not possible. The delegation method cannot change from Kerberos constrained to basic Kerberos. Therefore, it is important to anticipate and plan for whether a back-end service will require basic Kerberos delegation. This can affect the planning and design of domain boundaries.

A Kerberos-enabled service can use protocol transition to convert a non-Kerberos identity to a Kerberos identity that can be delegated to other Kerberos enabled services. This capability can be used, for example, to delegate a non-Kerberos identity from a front-end service to a Kerberos identity on a back-end service.

Important:

Protocol transition requires Kerberos constrained delegation. Therefore, protocol transitioned identities cannot cross domain boundaries.

Claims-based authentication can be used as an alternative to Kerberos delegation. Claims-based authentication enables a client's authentication claim to be passed between different services if the services meet all of the following criteria:

  • There must be a trust relationship between the services.

  • The services must be claims-aware.

For more information about Kerberos authentication, see the following resources:

  • Kerberos Survival Guide (http://social.technet.microsoft.com/wiki/contents/articles/4209.kerberos-survival-guide.aspx)

  • How the Kerberos Version 5 Authentication Protocol Works

  • Microsoft Kerberos

  • Kerberos Explained

Kerberos authentication and claims-based authentication

SharePoint 2013 supports claims-based authentication. Claims-based authentication is built on the Windows Identity Foundation (WIF), which is a set of the .NET Framework classes that are used to implement claims-based identity. Claims-based authentication relies on standards such as WS-Federation and WS-Trust. For more information about claims-based authentication, see the following resources:

  • Claims-based Identity for Windows (white paper) (http://go.microsoft.com/fwlink/p/?LinkId=198942)

  • Windows Identity Foundation home page

  • An Introduction to Claims

  • SharePoint Claims-Based Identity

  • Plan for user authentication methods in SharePoint 2013

When you create a SharePoint 2013 web application by using Central Administration, you must select one or more claims-based authentication types. When you create a SharePoint 2013 web application by using the New-SPWebApplication Windows PowerShell cmdlet, you can specify either claims authentication and claims authentication types or classic mode authentication. Claims authentication is recommended for all SharePoint 2013 web applications. By using claims authentication, all supported authentication types are available for your web applications and you can take advantage of server-to-server authentication and app authentication. For more information, see What's new in authentication for SharePoint 2013.

Important:

The following service applications in SharePoint Server 2013 require the translation of claims-based credentials to Windows credentials. This process of translation uses the Claims to Windows Token Service (C2WTS):

  • Excel Services

  • PerformancePoint Services

  • InfoPath Forms Services

  • Visio Services

These service applications are not available in SharePoint Foundation 2013.

The service applications that require the C2WTS must use Kerberos constrained delegation because C2WTS requires protocol transition, which is only supported by Kerberos constrained delegation. For the service applications in the previous list, the C2WTS translates claims within the farm to Windows credentials for outgoing authentication. It is important to understand that these service applications can use the C2WTS only if the incoming authentication method is either Windows claims or Windows classic mode. Service applications that are accessed through web applications and that use Security Assertion Markup Language (SAML) claims or forms-based authentication claims do not use the C2WTS. Therefore, they cannot translate claims to Windows credentials.

Kerberos authentication and the new SharePoint app model

If you are using Windows claims mode for user authentication and the web application is configured to use only Kerberos authentication without falling back to NTLM as the authentication protocol, then app authentication does not work. For more information, see Plan for app authentication in SharePoint 2013.

See also

Plan for user authentication methods in SharePoint 2013


Server-to-server authentication and user profiles in SharePoint Server 2013
See also

Published: October 16, 2012

Summary: Learn how to plan user profiles for server-to-server authentication in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Server-to-server authentication allows for servers that are capable of server-to-server authentication to access and request resources from one another on behalf of users. Therefore, the server that runs SharePoint Server 2013 and that services the incoming resource request must be able to complete two tasks:

  • Resolve the request to a specific SharePoint user

  • Determine the set of role claims that are associated with the user, a process known as rehydrating the user's identity

To rehydrate a user's identity, a server that can perform server-to-server authentication requests access to SharePoint resources. SharePoint Server 2013 takes the claims from the incoming security token and resolves it to a specific SharePoint user. By default, SharePoint Server 2013 uses the built-in User Profile service application to resolve the identity.

The key user attributes for locating the corresponding user profile are as follows:

  • The Windows Security Identifier (SID)

  • The Active Directory Domain Services (AD DS) user principal name (UPN)

  • The Simple Mail Transfer Protocol (SMTP) address

  • The Session Initiation Protocol (SIP) address

Therefore, at least one of these user attributes must be current in user profiles. We recommend a periodic synchronization from identity stores to the User Profile service application. For more information, see Plan profile synchronization for SharePoint Server 2013.

Furthermore, SharePoint Server 2013 expects only one matching entry in the User Profile service application for a given lookup query that is based on these four attributes. Otherwise, it returns an error condition that multiple user profiles were found. Therefore, you should delete obsolete user profiles in the User Profile service application periodically to avoid multiple user profiles that share these four attributes.

If a user profile and the relevant group memberships for the user are not synchronized, SharePoint Server 2013 may incorrectly deny access to a given resource. Therefore, make sure that group memberships are synchronized with the User Profile service application. For Windows claims, the User Profile service application imports the four key user attributes previously described and group memberships.

For forms-based and Security Assertion Markup Language (SAML)-based claims authentication, you must do one of the following:

  • Create a synchronization connection to a data source that the User Profile service application supports and associate the connection with a specific forms-based or SAML authentication provider. Additionally, you have to map attributes from the user store to the four user attributes previously described, or as many of them as you can obtain from the data source.

  • Create and deploy a custom component to perform the synchronization manually. This is the most likely option for users who do not use Windows. Note that the forms-based or SAML authentication provider is invoked when the user's identity is rehydrated to get their role claims.

User rehydration for requesting servers

If the requesting server is running Exchange Server 2013 or Lync Server 2013, which use standard Windows authentication methods, the incoming security token sent by the requesting server contains the UPN of the user and may contain other attributes such as SMTP, SIP, and the SID of the user's identity. SharePoint Server 2013, the receiving server, uses this information to locate the user profile.

For a requesting server that is running SharePoint Server 2013, the receiving server rehydrates the user through the following claims-based authentication methods:

  • For Windows claims authentication, SharePoint Server 2013 uses AD DS attributes to find the user profile for the user (for example, the UPN or SID values) and their role claims (group membership).

  • For forms-based authentication, SharePoint Server 2013 uses the Account attribute to locate the user's profile and then invokes the role provider and all additional custom claims providers to obtain the corresponding set of role claims. For example, SharePoint Server 2013 uses attributes in AD DS, in a database such as a SQL Server database, or in an Lightweight Directory Access Protocol (LDAP) data store to find the user profile that represents the user (for example, the UPN or SID values). Your component to synchronize your forms-based provider should at a minimum populate user profiles with the user's account name. You can also create a custom claim provider to import additional claims as attributes into user profiles.

  • For SAML-based claims authentication, SharePoint Server 2013 uses the AccountName attribute to locate the user's profile and then invokes the SAML provider and all additional custom claims providers to obtain the corresponding set of role claims. The user identity claim should be mapped to the Account attribute in user profiles through the corresponding SAML claims provider, which should be configured to populate your user profiles. Similarly, a UPN claim should be mapped to the UPN attribute and the SMTP claim should be mapped to the SMTP attribute. To duplicate the set of claims that the user would usually obtain from their identity provider, you must add those claims, including the role claims, through claims augmentation. A custom claim provider must import those claims as attributes into user profiles.

See also

Plan for server-to-server authentication in SharePoint 2013
Authentication overview for SharePoint 2013


Permissions planning for sites and content in SharePoint 2013

Updated: April 30, 2013

Summary: Learn about how to plan permissions for sites and site content for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Some sites in an enterprise probably contain content that should not be available to all users. For example, proprietary technical information should be accessible only on a need-to-know basis. An intranet portal for employee benefits should be available only to full-time employees, whereas the home page of an Internet Web site is accessible by anonymous clients.

Permissions control access to sites and site content. You can manage permissions by using SharePoint groups, which control membership. Fine-grained permissions also help to secure content at the item and document level.

TechNet articles about how to plan security for sites and content

The following articles about how to plan security for sites and content are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of site permissions in SharePoint 2013 | Learn about the concepts behind SharePoint 2013 access control at the site collection, site, subsite, and site content (list or library, folder, item or document) levels.
Checklist icon (not checked) | Plan site permissions in SharePoint 2013 | Helps you understand how permissions are assigned and helps you choose the appropriate permissions to use in your site collection or subsite.
Checklist icon (not checked) | Determine permission levels and groups in SharePoint 2013 | Reviews the available permission levels and groups, and helps you determine whether you need additional permission levels or groups.
Checklist icon (not checked) | Assign permission levels in SharePoint 2013 | Helps you determine which Microsoft Windows security groups and user accounts to use to grant access to sites, decide whether to use the Authenticated Users group, and decide whether to allow anonymous access.
Checklist icon (not checked) | Choose administrators and owners for the administration hierarchy in SharePoint 2013 | Defines the levels of administration from the server level to the subsite level and helps you choose administrators for each level.
Building blocks | Best practices for using fine-grained permissions in SharePoint Server 2013 | Learn about best practices for fine-grained permissions and how to use them within your organization when you use SharePoint 2013.
Building blocks | Overview of the Contribute permission level in SharePoint 2013 | Provides information about the Contribute permission level and the tasks that you can complete if you have these permissions.

Change History

Date | Description
April 30, 2013 | Added link to Best practices for using fine-grained permissions in SharePoint Server 2013.
July 16, 2012 | Initial publication


Overview of site permissions in SharePoint 2013
See also

Summary: Learn about the concepts behind SharePoint 2013 access control at the site collection, site, subsite, and site content (list or library, folder, item or document) levels.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article helps you understand the concepts behind access control at the site collection, site, subsite, and site content (list or library, folder, item or document) levels.

Introduction

You can control access to site and site content by assigning permissions to users or groups for a specific site or site content at the following levels in a site collection:

  • Site

  • Library or list

  • Folder

  • Document or item

Before developing your plan for site and content access, you should consider the following questions:

  • To what granularity do you want to control permissions for the site or site content? For example, you might want to control access at the site level, or you might need more restrictive security settings for a specific list, folder, or item.

  • How do you want to categorize and manage the users by using SharePoint groups? Groups have no permission until they are assigned a permission level for a specific site or for specific site content. When you assign permission levels to SharePoint groups at the site collection level, by default, all sites and site content inherit those permission levels.

For more information about how to use groups to help manage permissions, see Assign permission levels in SharePoint 2013.

About site permissions

You should understand the following concepts before designing your permissions plan.

  • Permissions Permissions grant a user the ability to perform specific actions. For example, the View Items permission allows a user to view items in a list or folder, but not to add or remove items. Permissions can be granted to individual users at site or site content levels.

    For information about available permissions, see User permissions and permission levels in SharePoint 2013.

  • Fine-grained permissions Fine-grained permissions are unique permissions on securable objects that are at a lower level in a site hierarchy, such as permissions on a list or library, folder, or item or document. Fine-grained permissions allow for greater granularity and customization of user permissions in a site collection.

  • Permission level Permission levels are collections of permissions that allow users to perform a set of related tasks. For example, the Read permission level includes the View Items, Open Items, View Pages, and View Versions permissions (and others), all of which are needed to view pages, documents, and items in a SharePoint site. Permissions can be included in more than one permission level.

    Permission levels are defined at the site collection level and can be customized by any user or group whose permission level includes the Manage Permissions permission. For more information about how to customize permission levels, see Configure custom permissions in SharePoint 2013.

    The default permission levels are Limited Access, Read, Contribute, Design, and Full Control. For information about default permission levels and the permissions included in each level, see User permissions and permission levels in SharePoint 2013.

  • SharePoint group A SharePoint group is a group of users who are defined at site collection level for easy administration of permissions. Each SharePoint group is assigned a default permission level. For example, the default SharePoint groups are Owners, Visitors, and Members, with Full Control, Read, and Contribute as their default permission levels respectively. Anyone with Full Control permission can create custom groups.

  • User A user can be a person with a user account from any authentication provider supported by the Web application. We recommend that you assign permissions to groups instead of users, although you can directly grant individual users permissions to a site or specific content. Because it is inefficient to maintain individual user accounts, you should assign permissions on a per-user basis only as an exception.

  • Securable object A securable object is a site, list, library, folder, document, or item for which permissions levels can be assigned to users or groups. By default, all lists and libraries in a site inherit permissions from the site. You can use list-level, folder-level, and item-level permissions to additional control which users can view or interact with site content. You must first break the permission inheritance before you change or assign permissions for that securable object. You can resume inheriting permissions from the parent list or site at any time.

You can assign a user or group permissions for a specific securable object. Individual users or groups can have different permissions for different securable objects. The following diagram shows the relationships among permissions, users and groups, and securable objects.

Relationships among permissions, users and groups, and securable objects

Specific permission levels

About permission inheritance

Permissions on securable objects in a site are inherited from the parent object by default. You can break inheritance and use fine-grained permissions — unique permissions on the list or library, folder, or item or document level — to gain more control of the actions users can take on your site.

Stopping inheriting permissions copies the groups, users, and permission levels from the parent object to the child object, and then breaks the inheritance. When permission inheritance is broken, all permissions are explicit and any changes to parent object do not affect the child object. If you restore inherited permissions, the child object will inherit its users, groups, and permission levels from the parent again, and you will lose any users, groups, or permission levels that were unique to the child object.

For ease of administration, use permission inheritance wherever possible.

Tip:

If you choose to break inheritance and use fine-grained permissions, you should use groups to avoid having to track individual users. Because people move in and out of teams and change responsibilities frequently, tracking those changes and updating the permissions for uniquely secured objects would be time-consuming and error-prone.

See also

What's New in SharePoint 2013 Resource Center


Plan site permissions in SharePoint 2013

Summary: Learn about how to plan site permissions for SharePoint 2013 to provide secure access to sites and content.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article helps you plan access control at the site collection, site, subsite, and site content (list or library, folder, item or document) levels.

This article does not address planning the security of your entire server or server farm. For more information about planning other aspects of security, such as authentication methods and authentication modes, see Plan authentication in SharePoint 2013.

In this article:

  • Plan for site permissions

  • Plan for permission inheritance

Plan for site permissions

When you create permissions, you must balance the ease of administration and performance against the requirement to control access to individual items. If you use fine-grained permissions extensively, you will spend more time managing the permissions, and users may experience slower performance when they try to access site content.

Use the following guidelines to plan site permissions:

  1. Follow the principle of least-privileged: Users should have only the permission levels or individual permissions they must have to perform their assigned tasks.

  2. Use standard groups (such as Members, Visitors, and Owners) and control permissions at the site level.

    • Make most users members of the Members or Visitors groups. By default, users in the Members group can contribute to the site by adding or removing items or documents, but cannot change the structure, site settings, or appearance of the site. The Visitors group has read-only access to the site, which means that they can see pages and items, and open items and documents, but cannot add or remove pages, items, or documents.

    • Limit the number of people in the Owners group. Only those users that you trust to change the structure, settings, or appearance of the site should be in the Owners group.

  3. Use permission levels instead of assign individual permissions.

Note:

  1. You can create additional SharePoint groups and permission levels if that you must have more control over the actions that the users can take. For example, if you do not want the Read permission level on a specific subsite to include the Create Alerts permission, break the inheritance and customize the Read permission level for that subsite.

  2. SharePoint Foundation 2013 and SharePoint Server 2013 use Check Permissions to determine a user or group's permissions on all resources in a site collection. You can now find both the user's directly assigned permissions and the permissions assigned to any groups of which the user is a member by checking permissions for a specific site or site content.

Plan for permission inheritance

It is much easier to manage permissions when there is a clear hierarchy of permissions and inherited permissions. It becomes more difficult when some lists in a site have fine-grained permissions applied, and when some sites have subsites with unique permissions and others with inherited permissions. As much as possible, arrange sites and subsites, and lists and libraries so they can share most permissions. Separate sensitive data into their own lists, libraries, or subsites.

For example, it's much easier to manage a site that has permission inheritance as described in the following table.

Securable object | Description | Unique or inherited permissions
SiteA | Group home page | Unique
SiteA/SubsiteA | Sensitive group | Unique
SiteA/SubsiteA/ListA | Sensitive data | Unique
SiteA/SubsiteA/LibraryA | Sensitive documents | Unique
SiteA/SubsiteB | Group shared project information | Inherited
SiteA/SubsiteB/ListB | Non-sensitive data | Inherited
SiteA/SubsiteB/LibraryB | Non-sensitive documents | Inherited

However, it is not as easy to manage a site that has permission inheritance as shown in the following table.

Securable object | Description | Unique or inherited permissions
SiteA | Group home page | Unique
SiteA/SubsiteA | Sensitive group | Unique
SiteA/SubsiteA/ListA | Non-sensitive data | Unique, but same permissions as SiteA
SiteA/SubsiteA/LibraryA | Non-sensitive documents, but with one or two sensitive documents | Inherited, with unique permissions at the document level
SiteA/SubsiteB | Group shared project information | Inherited
SiteA/SubsiteB/ListB | Non-sensitive data, but with one or two sensitive items | Inherited, with unique permissions at the item level
SiteA/SubsiteB/LibraryB | Non-sensitive documents, but with a special folder that contain sensitive documents | Inherited, with unique permissions at the folder and document level


Choose administrators and owners for the administration hierarchy in SharePoint 2013

Summary: Learn about the levels at which you can delegate administration of the SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes the administrator roles that correspond to the SharePoint Server 2013 server and site hierarchy. Many people can be involved in managing SharePoint Server 2013. Administration of SharePoint Server occurs at the following levels:

  • Server or SharePoint farm

  • Shared services

  • Web application

  • Sites

  • Document library or list

  • Individual items

Levels of administration

Most levels of the server and site hierarchy have a corresponding administration group. The administration groups that have administrative permissions at different levels are described in the following list:

  • Server or farm level

    • Farm Administrators group Members of the Farm Administrators group have Full Control permissions to and responsibility for all servers in the server farm. Members can perform all administrative tasks in Central Administration for the server or server farm. They can assign administrators to manage service applications, which are instances of shared services. This group does not have access to individual sites or their content.

    • Windows Administrators group Members of the Windows Administrators group on the local server can perform all farm administrator actions. Administrators on the local server can perform additional tasks, such as installing new products or applications, deploying Web Parts and new features to the global assembly cache, creating new Web applications and new Internet Information Services (IIS) Web sites, and starting services. Like farm administrators, members of this group on the local server have no access to site content, by default.

      Note:

      Farm administrators and members of the local Administrators group can take ownership of specific site collections if it is necessary. For example, if a site administrator leaves the organization and a new administrator must be added, the farm administrator or a member of the local Administrators group can take ownership of the site collection to make the change. To take ownership, they can add themselves as the site collection administrator on the Application Management page.

  • Shared services level

    • Service application administrators These administrators are designated by the farm administrator. They can configure settings for a specific service application in a farm. However, these administrators cannot create service applications, access any other service applications in the farm, or perform any farm-level operations, such as topology changes. For example, the service application administrator for a Search service application in a farm can configure settings for that Search service application only.

    • Feature administrators A feature administrator is associated with a specific feature or features of a service application. These administrators can manage a subset of service application settings, but not the entire service application. For example, a Feature administrator might manage the Audiences feature of the User Profile service application.

  • Web application level

    • The Web application level does not have a unique administrator group, but farm administrators have control over the Web applications within their scope. Members of the Farm Administrators group and members of the Administrators group on the local server can define a policy to grant individual users permissions at the Web application level.

  • Site level

    • Site collection administrators These administrators have the Full Control permission level on all Web sites in a site collection. They have Full Control access to all site content in that site collection, even if they do not have explicit permissions on that site. They can audit all site content and receive any administrative message. A primary and a secondary site collection administrator can be specified during the creation of a site collection.

    • Site owners By default, members of the Owners group for a site have the Full Control permission level on that site. They can perform administrative tasks on the site, and on any list or library within that site. They receive e-mail notifications for events, such as the pending automatic deletion of inactive sites and requests for site access.


Determine permission levels and groups in SharePoint 2013

Summary: Learn how to define the correct SharePoint 2013 permission levels at the site collection level.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A SharePoint group is a set of users that can be managed together. A permission level is a set of permissions that can be assigned to a specific group for a specific securable object. SharePoint groups and permission levels are defined at the site collection level and are inherited from the parent object by default. This article describes default groups and permission levels and helps you decide whether to use them as they are, customize them, or create different groups and permission levels.

In this article:

  • Review available default groups

  • Review available permission levels

  • Determine whether you need custom permission levels or groups

The most important decision about your site and content security in SharePoint 2013 is how to group your users and which permission levels to assign.

Review available default groups

SharePoint groups enable you to manage sets of users instead of individual users. These groups can contain many individual users, or they can include the contents of any corporate identity system, including Active Directory Domain Services (AD DS), LDAPv3-based directories, application-specific databases and new user-centric identity models, such as Windows Live ID. SharePoint groups do not confer specific rights to the site; they are a way to designate a set of users. You can organize yours users into any number of groups, depending on the size and complexity of your organization or Web site. SharePoint groups cannot be nested.

The following table displays default groups that are created for team sites in SharePoint 2013. Each default group is assigned a default permission level.

Group name | Default permission level | Description
Visitors | Read | Use this group to grant people Read permissions to the SharePoint site.
Members | Edit | Use this group to grant people Edit permissions to the SharePoint site.
Owners | Full Control | Use this group to grant people Full Control permissions to the SharePoint site.
Viewers | View Only | Use this group to grant people View Only permissions to the SharePoint site.

If you use a site template other than the team site template, you will see a different list of default SharePoint groups. For example, the following table shows the additional groups provided by a publishing site template.

Group name Default permission level Description

Restricted Readers

Restricted Read to the site, plus Limited Access to specific lists

Members of this group can view pages and documents, but cannot view historical versions or review user rights information.

Style Resource Readers

Read to the Master Page Gallery and Restricted Read to the Style Library.

Members of this group are given Read permission to the Master Page Gallery and Restricted Read permission to the Style Library. By default, all authenticated users are a member of this group.

Note:

Do not remove all authenticated users from this group. Because Master Page Gallery and Style Library are shared across all sites in the site collection and must be accessible to all users of all sites. If you remove all authenticated users from the group, anyone with this permission level on a subsite will not be able to render the site. SharePoint will not automatically add or remove users of subsites to or from this group as needed.

Designers

Design, Limited Access

Members of this group can to view, add, update, delete, approve, and customize the layout of site pages by using the browser or SharePoint Designer 2013.

Approvers

Approve, plus Limited Access

Members of this group can edit and approve pages, list items, and documents.

Hierarchy Managers

Manage Hierarchy, plus Limited Access

Members of this group can create sites, lists, list items, and documents.

Tip:

The Limited Access permission level is used to give groups access to a specific list, library, folder, document, or item, without giving them access to the entire site. Do not remove this permission level from the groups listed above. If this permission level is removed, the groups might not be able to navigate through the site to get the specific items with which they need to interact.

Make most users members of the Visitors or Members groups. By default, users in the Members group can contribute to the site by adding or removing items or documents, but cannot change the structure, site settings, or appearance of the site. The Visitors group has read-only access to the site, which means that they can see pages and items, and open items and documents, but cannot add or remove pages, items, or documents.

If the default groups do not map to the exact user groups in your organization, you can create custom groups.

Besides the above SharePoint groups, there are also administrator groups for higher-level administration tasks. They are Windows administrators, SharePoint farm administrators, and site collection administrators.

For more information, see Choose administrators and owners for the administration hierarchy in SharePoint 2013.

Review available permission levels

The ability to view, change, or manage a site is determined by the permission level that you assign to a user or group. This permission level controls all permissions for the site and the child objects that inherit the site's permissions. Without the appropriate permission levels, the users might be unable to perform their tasks, or they could perform tasks that you did not want them to perform.

By default, the following permission levels are available:

  • View Only Includes permissions that enable users to view pages, list items, and documents.

  • Limited Access Includes permissions that enable users to view specific lists, document libraries, list items, folders, or documents, without giving access to all the elements of a site. You cannot edit this permission level directly.

    Note:

    If this permission level is removed, group members might be unable to navigate the site to access items, even if they have the appropriate permissions for an item within the site.

  • Read Includes permissions that enable users to view items on the site pages.

  • Edit Includes permissions that enable users to add, edit and delete lists; can view, add, update and delete list items and documents.

  • Contribute Includes permissions that enable users to add or change items on the site pages or in lists and document libraries.

  • Design Includes permissions that enable users to view, add, update, delete, approve, and customize the layout of site pages by using the browser or SharePoint Designer 2013.

  • Full Control Includes all permissions.

For more information about permissions that are included in the default permission levels, see User permissions and permission levels in SharePoint 2013.

The following additional permission levels are provided with the publishing template by default:

  • Approve Includes permissions to edit and approve pages, list items, and documents.

  • Manage Hierarchy Includes permissions to sites and edit pages, list items, and documents.

  • Restricted Read Includes permissions to view pages and documents, but not historical versions or permissions information.

Determine whether you need custom permission levels or groups

The default groups and permission levels provide a general framework for permissions, covering many organization types and roles within those organizations. However, they might not map exactly to how the users are organized or to the many different tasks that the users perform on your sites. If the default groups and permission levels do not suit your organization, you can create custom groups, change the permissions included in specific permission levels, or create custom permission levels.

Do you need custom groups?

The decision to create custom groups is fairly straightforward and has little effect on your site's security. You should create custom groups instead of using the default groups if either of the following situations applies:

  • You have more (or fewer) user roles within your organization than are obvious in the default groups. For example, if in addition to Approvers, Designers, and Hierarchy Managers, you have a set of people who are tasked with publishing content to the site, you might want to create a Publishers group.

  • There are well-known names for unique roles within your organization that perform very different tasks in the sites. For example, if you are creating a public site to sell your organization's products, you might want to create a Customers group that replaces Visitors or Viewers.

  • You want to preserve a one-to-one relationship between Windows security groups and the SharePoint groups. For example, if your organization has a security group that is named Web Site Managers, you might want to use that name as a group name for easy identification when you manage the site.

  • You prefer other group names.

Do you need custom permission levels?

The decision to customize permission levels is less straightforward than the decision to customize SharePoint groups. If you customize the permissions assigned to a permission level, you must keep track of that change, verify that it works for all groups and sites affected by the change, and make sure that that the change does not adversely affect your security or your server capacity or performance.

For example, if you customize the Contribute permission level to include the Create Subsites permission that is typically part of the Full Control permission level, members of the Contributors group can create and own subsites, and can potentially invite malicious users to their subsites or post unapproved content. If you customize the Read permission level to include the View Usage Data permission that is typically part of the Full Control permission level, all members of the Visitors group can see usage data, which could cause performance issues.

You should customize the default permission levels if either of the following situations applies:

  • A default permission level includes all permissions except one that the users must have to do their jobs, and you want to add that permission.

  • A default permission level includes a permission that the users do not have to have.

    Note:

    Do not customize the default permission levels if your organization has security or other concerns about a specific permission that is part of the permission level. If you want to make that permission unavailable for all users assigned to the permission level or levels that include that permission, turn off the permission for all Web applications in your server farm, instead of change all of the permission levels To manage permissions for a web application, see Manage permissions for a web application in SharePoint 2013.

If you must make several changes to a permission level, create a custom permission level that includes all of the permissions that you need.

You might want to create additional permission levels if either of the following conditions is true:

  • You want to exclude several permissions from a specific permission level.

  • You want to define a unique set of permissions for a new permission level.

To create a permission level, you can create a permission level and then select the permissions that you want to include.

Note:

Some permissions depend on other permissions. If you clear a permission that another permission depends on, the other permission is also cleared.


Assign permission levels in SharePoint 2013
See also

Summary: Learn how to assign permission levels to SharePoint 2013 groups.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can manage users of SharePoint sites more efficiently if you assign permission levels to groups instead of to individual users. A SharePoint group is a set of individual users and can also include Active Directory Domain Services (AD DS) groups.

In this article:

  • Decide whether to add security groups

  • Determine which security groups to use for granting access to sites

  • Decide whether to allow access for all authenticated users

  • Decide whether to allow access for anonymous users

Introduction

In AD DS, the following groups are commonly used to organize users:

  • Distribution group A group that is used only for e-mail distribution and that is not security-enabled. Distribution groups cannot be listed in discretionary access control lists (DACLs), which are used to define permissions on resources and objects.

  • Security group A group that can be listed in DACLs. A security group can also be used as an e-mail entity.

You can use security groups to control permissions for your site by adding security groups to SharePoint groups and granting permissions to the SharePoint groups. You cannot add distribution groups to SharePoint groups, but you can expand a distribution group and add the individual members to a SharePoint group. If you use this method, you must manually keep the SharePoint group synchronized with the distribution group. If you use security groups, you do not need to manage the individual users in the SharePoint application. Because you included the security group instead of the individual members of the group, AD DS manages the users for you.

Note:

For ease of security management, we do not recommend the following items when you manage AD DS groups.

  • Assign permission levels directly to AD DS groups.

  • Adding security groups that contain nested security groups, contacts, or distribution lists.

Decide whether to add security groups

Adding security groups to SharePoint groups provides centralized management of groups and security. The security group is the only place where you manage individual users. Once you add the security group to a SharePoint group, you do not have to manage security group members in that SharePoint group. If a user is removed from the security group, the user will be automatically removed from the SharePoint group.

However, security groups in SharePoint sites do not provide full visibility of what is occurring. For example, when a security group is added to a SharePoint group for a specific site, the site will not appear in the users' My Sites. The User Information List will not show individual users until they have contributed to the site. In addition, security groups that have deep nested structure might break SharePoint sites.

Considering the previous advantages and disadvantages, here are the recommendations:

  • For intranet sites that are broadly accessed by your users, use security groups because you do not care about the individual users who accessed the intranet site home page.

  • For collaboration sites that are accessed by a small group of users, add users directly to SharePoint groups. In this case, there is more of a need to know who is a member so the group members know each other's e-mail addresses and how to contact one another.

Determine which security groups to use for granting access to sites

Each organization sets up its security groups differently. For easier permission management, security groups should be:

  • Large and stable enough that you are not continually adding additional security groups to your SharePoint sites.

  • Small enough that you can assign appropriate permissions.

For example, a security group that is named "all users in building 2" is probably not small enough to assign permissions, unless all users in building 2 have the same job function, such as accounts receivable clerks. This is rarely the case. Therefore, you should look for a smaller, more specific set of users, such as "Accounts Receivable".

Decide whether to allow access for all authenticated users

If you want all users within your domain to be able to view content on your site, consider granting access to all authenticated users (the Domain Users Windows security group). This special group allows all members of your domain to access a website (at the permission level that you choose), without your having to enable anonymous access.

Decide whether to allow access for anonymous users

You can enable anonymous access to allow users to view pages anonymously. Most Internet web sites allow anonymous viewing of a site, but might ask for authentication when someone wants to edit the site or buy an item on a shopping site. Anonymous access is disabled by default and must be granted at the web application level at the time that the web application is created.

If anonymous access is allowed for the web application, site administrators can decide whether to grant anonymous access to a site or any of the content on that site.

Anonymous access relies on the anonymous user account on the web server. This account is created and maintained by Internet Information Services (IIS), not by your SharePoint site. By default in IIS, the anonymous user account is IUSR. When you enable anonymous access, you are in effect granting that account access to the SharePoint site. Allowing access to a site, or to lists and libraries, grants the View Items permission to the anonymous user account. Even with the View Items permission, however, there are restrictions to what anonymous users can do. Anonymous users cannot:

  • Open sites for editing in Office SharePoint Designer.

  • View sites in My Network Places.

  • Upload or edit documents in document libraries, such as wiki libraries.

    Important:

    To improve security for sites, lists, or libraries, do not enable anonymous access. Anonymous access allows users to contribute to lists, discussions, and surveys, which will possibly use up server disk space and other resources. Anonymous access also allows anonymous users to discover site information, including user e-mail addresses and any content posted to lists, and libraries, and discussions.

Permission policies provide a centralized way to configure and manage a set of permissions that applies to only a subset of users or groups in a web application. You can manage permission policy for anonymous users by enabling or disabling anonymous access for a web application. If you enable anonymous access for a web application, site administrators can then grant or deny anonymous access at the site collection, site, or item level. If anonymous access is disabled for a web application, no sites within that web application can be accessed by anonymous users.

  • None No policy. This is the default option. No additional permission restrictions or additions are applied to site anonymous users.

  • Deny Write Anonymous users cannot write content, even if the site administrator specifically attempts to grant the anonymous user account that permission.

  • Deny All Anonymous users cannot have any access, even if site administrators specifically attempt to grant the anonymous user account access to their sites. For more information about permission policies, see Manage permission policies for a web application in SharePoint 2013.

See also

Permissions planning for sites and content in SharePoint 2013
Manage permission policies for a web application in SharePoint 2013


Best practices for using fine-grained permissions in SharePoint Server 2013

Published: April 30, 2013

Summary: Learn about best practices for fine-grained permissions and how to use them within your organization when you use SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Fine-grained permissions can influence security on a SharePoint farm. Potential performance issues can occur when you use fine-grained permissions. The following information helps you address issues when an environment is experiencing issues that incorrect use or scale of fine-grained permissions might have caused.

You can avoid fine-grained permissions by doing the following:

  • Break permission inheritance as infrequently as possible.

  • Use groups based on folder membership to assign permissions.

    We do not recommend SharePoint groups to assign permissions to sites. When a SharePoint group is used to assign permissions, a full crawl of the index occurs. Instead, we recommend Active Directory Domain Services (AD DS) groups.

  • Assign permissions at the highest possible level. As part of this strategy, consider the following techniques:

    • Put documents that require fine-grained permissions in document libraries that are defined to support each group of permissions Keep the document libraries in a separate site collection or site. For additional information about hierarchical changes, see Issue 2: Use fine-grained permissions by hierarchical structure changes.

    • Use different document publish levels to control access. Before a document is published, the advanced permissions and versioning settings can be set for users who can only approve items in the document library.

    • For non-document libraries (lists), use the ReadSecurity and WriteSecurity permission levels. When a list is created, the owners can set the Item-level permissions to either Read access or Create and Edit access.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Fine-grained permission reference for SharePoint Server 2013

  • Troubleshoot common fine-grained permissions issues for SharePoint Server 2013

Best practices to avoid common limit issues of fine-grained permissions

If your business requirement must use fine-grained permissions, consider the following recommended best practices:

  • Ensure that you do not have too many items at the same level of hierarchy in the document libraries, because the time that is required to process items in the views increases.

  • Use event handlers to control edit permission. You can have an event handler that registers an event using the SPEventReceiverType.ItemUpdating and SPEventReceiverType.ItemUpdated methods, and then use code to control whether the update should be allowed. This is very powerful, because you can make security decisions based on any metadata of a list or item, without affecting the view-rendering performance. For additional information about event handlers, see Resolution of fine-grained permissions issues.

  • Use the AddToCurrentScopeOnly method to assign Limited Access membership in a SharePoint group. The key element in this principle is to redesign the architecture so that scope membership does not cause Access Control List (ACL) recalculation at the parent document library and web. For additional information about scope changes, Issue 3: Use fine-grained permissions by scope structure changes (2010 only).

When working with fine-grained permissions, it is easy to unintentionally encounter limits that prevent permissions from resolving. This section describes some of these limits and best practices on how to set them to allow permissions to resolve correctly.

Too many scopes in a list

There is a built-in limit of 50,000 scopes per list or document library. After 50,000 scopes are reached addition of new scopes in a given list or document library is prohibited.

Best practices:

  • Only set unique scopes on parent objects such as folders.

  • Do not create a system with many uniquely-permissioned objects below an object that has many scopes.

  • If your business requires more than 50,000 uniquely permissioned items in a list or document library, then you must move some items to a different list or document library.

Change the built-in scope limit

Change the built-in scope limit by using a Windows PowerShell script.

To change the built-in scope limit by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not displayed on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $webapp = Get-SPWebApplication http://<serverName>
$webapp.MaxUniquePermScopesPerList
$webapp.MaxUniquePermScopesPerList = <Number of scope limit>

    Where:

    • Where <serverName> is the name of the application server in the SharePoint farm.

    • Where <Number of scope limit> is the maximum number of unique permissions scopes that you want to allow per SharePoint list. Often, the effective limit is much smaller than 50,000 if many scopes exist at the same hierarchical level. This is because display checks for items below that hierarchical level must be checked against all scopes above them. This limitation can cause the effective number of scopes allowed in a particular query to be reduced to 1,000 to 2,000.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Too many members in a permission scope

As described earlier, a binary ACL is calculated when the membership of the associated permission scope changes. This includes when a new limited access member is added. As the scope membership number increases, the time that is required to recalculate the binary ACL increases.

The problem can be made worse as the addition of users at a child object's unique scope will cause its parent scopes to be updated with the new Limited Access members, even if this ultimately results in no change to the parent scope membership. When this occurs, the binary ACL for the parent scopes must also be recalculated, at the expense of more processing time, even if it ultimately results in the same ACL.

Best practice:

Rely on group membership instead of individual user membership in permission scopes. For example, if a single group can be used instead of 1,000 individual users, the scope will be 999 membership entries smaller for the permission scope and any of its parent scopes. Also, the single group will be updated with Limited Access rights instead of updating each user who has Limited Access rights. This also helps increase the speed of Limited Access rights push and ACL recalculation on the parent scope objects.

Important:

Using a SharePoint group will cause a full crawl of the index. If possible, use a domain group.

Very deep scope hierarchy

As indicated earlier, the hierarchical depth of permission scopes can affect the work that is required to add Limited Access users to parent scopes. The larger the number of unique scopes above an item, up to and including the uniquely permissioned web, the larger the number of additions that must occur. If a scope hierarchy is very deep, a scope membership change can take a very long time to occur, as each membership change in the deepest scope item will have to iteratively update parent scopes with a membership addition for the explicitly added user or group that has Limited Access rights. Additionally this will increase the number of binary ACLs that have to be recalculated, with an according performance effect.

Best practice:

Reduce the numbers of uniquely permissioned parent objects. This reduces the number of scopes that have to be updated with Limited Access members when any child object's scope changes.


Overview of the Contribute permission level in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn about the Contribute permission level in SharePoint 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Foundation 2013

You should be aware that the Contribute permission level, which enabled certain web file and Web Part functionality in SharePoint 2007 products and technologies requires a different permission level in SharePoint 2010 Products and in SharePoint 2013.

In this article:

  • About updating web files

  • About editing Web Parts

About updating web files

Web files enable you to implement various customization options for a web page. Web files can contain scripts (for example, JavaScript) that can call web services and interoperate with data on a site. Web files are stored as a modifiable list, based on their file name extensions.

A member of the Farm Administrators group can use Windows PowerShell cmdlets to configure web files that have the following file name extensions:

  • .ascx

  • .aspx

  • .asmx

  • .master

  • .jar

  • .swf

  • .xap

  • .xsf

  • .xsn

SharePoint 2007 products and technologies enabled users who have the Contribute permission level to perform various tasks that now require the Add and Customize Pages permission. The tasks that require the Add and Customize Pages permission in SharePoint 2010 Products and in SharePoint 2013 include the following:

  • Update the content of a web file

  • Move a web file

  • Upload a web file

  • Rename a web file

  • Publish, migrate, import and export a web file

Users with the default Contribute permission level in SharePoint 2013 can perform the following tasks:

  • Check in, check out, or revert a web file

  • Revert a version from version history for a web file

  • Delete a web file

  • Recycle a deleted web file

About editing Web Parts

SharePoint 2007 products and technologies enabled users who have the Contribute permission level to add or edit Web Parts that developers have marked as unsafe for editing. To add or edit Web Parts that developers have marked as unsafe for editing, SharePoint 2010 Products users and SharePoint 2013 users must have the Add and Customize Pages permission.

By default, the following Web Parts are marked as safe for editing and can be added or edited by users who have the default Contribute permission level:

  • Basic Chart Web Part

  • Image Web Part

  • Page Viewer Web Part

  • Picture Slideshow Web Part

  • Relevant Documents Web Part

  • Site Users Web Part

  • Title Bar Web Part

  • User Tasks Web Part

See also

User permissions and permission levels in SharePoint 2013


Overview of backup and recovery in SharePoint 2013
See also

Summary: Understand backup and recovery scenarios, the backup architecture, and recovery processes before you plan to back up and restore SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The SharePoint 2013 backup architecture and recovery processes include farm backup and recovery, granular backup and recovery, and recovery from an unattached content database. You can complete backup and recovery operations by using the SharePoint Central Administration website or Windows PowerShell cmdlets. Note that some built-in backup and recovery tools may not meet all the requirements of your organization.

SharePoint backup and recovery scenarios

Backing up and recovering data supports many business scenarios, including the following:

  • Recovering unintentionally deleted content that is not protected by the recycle bin or versioning.

  • Moving data between installations as part of a hardware or software upgrade.

  • Recovering from an unexpected failure.

Backup architecture in SharePoint 2013

SharePoint 2013 provides two backup systems: farm and granular.

Farm backup architecture in SharePoint 2013

The farm backup architecture in SharePoint 2013 starts a SQL Server backup of content and service application databases, writes configuration content to files, and also backs up the Search index files and synchronizes them with the Search database backups.

The following illustration shows the farm backup system.

SharePoint backup system for a farm

Backup architecture (SharePoint Foundation)

The architecture supports both full and differential backups. Full backups create a new backup of the complete system. Differential backups create a backup of all changes that are stored in databases since the last full backup.

The farm backup system is organized hierarchically. The components in a farm that you can select for backup include the following:

  • Farm The farm is the highest-level object. You can select from the following options when you perform a farm backup:

    • Content and configuration data (default)

      The whole server farm is backed up. This includes settings from the configuration database.

    • Configuration-only

      Configuration database settings are backed up so that you can apply configurations across farms. For more information, see Configuration-only backup use and benefits later in this article.

  • Web application Within a web application, you can select one or more of the content databases to back up.

    A web application backup includes the following:

    • Application pool name and application pool account

    • Authentication settings

    • General web application settings such as alerts and managed paths

    • Internet Information Services (IIS) binding information, such as the protocol type, host header and port number

    • Changes to the Web.config file that were made through the object model or Central Administration

      Note:

      Changes to the Web.config file that were made to support claims-based applications that use forms-based authentication are not included in backups, because those changes are made manually. For more information, see Considerations for using farm backups later in this article.

    • Sandboxed solutions

    For recommendations about how to protect these settings, see Plan for backup and recovery in SharePoint 2013.

  • Services and service applications (not shared) An example of a service that is not shared is the State Service. Service and service application backups contain the settings for a service or service application and any databases associated with it.

    Important:

    Backups of service applications do not include the related proxy. To back up both the service application and the service application proxy, you must either back up the farm or perform two consecutive backups. You select the service application in one backup, and you select the associated service application proxy in the second backup.

    Many service application databases cannot be backed up individually from SharePoint 2013. To back up service application databases only, you must use SQL Server backup.

  • Proxies for service applications that are not shared

  • Shared Services Shared services require both a service application and a service application proxy to run. Select the Shared Services node to back up all of the service applications and the related service application proxies on the farm.

    Note:

    The backup hierarchy enables you to select individual service applications and service application proxies to back up. However, when you select one or all service applications, or one or all proxies, the related objects are not backed up by default.

Note:

Some settings in the SharePoint 2013 environment are not included in a farm backup. They include the following settings that are stored on web servers:

  • Application pool account passwords

  • HTTP compression settings

  • Time-out settings

  • Custom Internet Server Application Programming Interface (ISAPI) filters

  • Computer domain membership

  • Internet Protocol security (IPsec) settings

  • Network Load Balancing settings

  • Secure Sockets Layer (SSL) certificates

  • Dedicated IP address settings

Search service application backup process

Back up and recovery of the Search service application is a special case because of the complexity of interactions between the components of the application.

When you start a backup of the Search service application, SharePoint 2013 starts a SQL Server backup of the Search administration database, crawl databases, and property databases. The process also backs up the index partition files in parallel.

Consider how the backup and recovery processes for the Search service application affect your service-level agreement. For example, consider how pausing all crawls might affect the freshness of search results.

The backup process is as follows:

  1. Master merges are paused to preserve the master index.

  2. A full database backup starts.

  3. The master index is backed up.

  4. Crawls are paused.

    The pause in crawling is much shorter than during a backup of SharePoint 2010 Products and Office SharePoint Server 2007 search, and does not last the full duration of the backup process.

  5. All shadow indexes are backed up.

  6. An incremental database backup starts.

  7. Crawls are resumed.

  8. Master merges are resumed.

Configuration-only backup use and benefits

A configuration-only backup extracts and backs up the configuration settings from a configuration database. You can use built-in tools to back up the configuration of any configuration database, whether it is currently attached to a farm or not. For detailed information about how to back up a configuration, see Back up farm configurations in SharePoint 2013.

You can be restore a configuration backup to the same or another server farm. When you restore a configuration, you overwrite settings in the farm if values for those settings are in the configuration backup. Settings in the farm that are not in the configuration backup are not changed. For detailed information about how to restore a farm configuration, see Restore farm configurations in SharePoint 2013.

Note:

Web application and service application settings are not included in a configuration backup. You can use Windows PowerShell cmdlets to document and copy settings for service applications. For more information, see Document farm configuration settings in SharePoint 2013 and Copy configuration settings between farms in SharePoint 2013.

Situations in which you might want to restore a configuration from one farm to another farm include the following:

  • Replicating a standardized farm configuration to be used throughout an environment.

  • Moving configurations from a development or test environment to a production environment.

  • Moving configurations from a stand-alone installation to a farm environment.

  • Configuring a farm to serve as part of a standby environment.

SharePoint 2013 stores the following kinds of settings in the configuration-only backup:

  • Antivirus

  • Information rights management (IRM)

  • Outbound email settings (only restored when you perform an overwrite).

  • Customizations deployed as trusted solutions

  • Diagnostic logging

Considerations for using farm backups

Consider the following before you use farm backups:

  • There is no built-in scheduling system for backups. To schedule a backup, we recommend that you use Windows PowerShell to create a backup script, and then use Windows Task Scheduler to run the backup script regularly.

  • We do not recommend that you use IIS metabase backup to protect IIS settings. Instead, document all IIS configurations for each web server by using a tool that provides the configuration monitoring you want, such as Microsoft System Center 2012 Configuration Manager.

  • SharePoint 2013 backup and recovery can be run together with SQL Server Enterprise features such as backup compression and transparent data encryption.

    If you are running SQL Server Enterprise, we recommend that you use backup compression. For more information about backup compression, see Backup Compression (SQL Server).

    If you decide to run databases with transparent data encryption, you must manually back up the key and restore the key. SharePoint 2013 backup and restore will not remind you about the key. For more information about transparent data encryption, see Understanding Transparent Data Encryption (TDE).

  • If a content database is set to use the SQL FILESTREAM remote BLOB storage (RBS) provider, the RBS provider must be installed both on the database server that is being backed up and on the database server to which you recover the backup.

  • SharePoint 2013 backup does not protect:

    • Changes to the Web.config file on web servers that are not made through Central Administration or the object model.

    • Customizations to a site that are not deployed as part of a trusted or sandboxed solution.

  • If you share service applications across farms, be aware that trust certificates that have been exchanged are not included in farm backups. You must back up the certificate store separately or keep the certificates in a separate location. When you restore a farm that shares a service application, you must import and redeploy the certificates and then establish any inter-farm trusts again.

    For more information, see Exchange trust certificates between farms in SharePoint 2013.

  • When you restore a farm or Web application that is configured to use any kind of claims-based authentication, duplicate or additional providers may appear to be enabled. If duplicates appear, you must manually save each web application zone to remove them.

  • Additional steps are required when you restore a farm that contains a web application that is configured to use forms-based authentication. You must register the membership and role providers again in the Web.config file, and then deploy the providers again. You must perform these steps whether you are restoring at the web application level or at the farm level.

    For more information, see Back up web applications in SharePoint 2013, and Plan for user authentication methods in SharePoint 2013.

Granular backup and export architecture

The granular backup and export architecture uses Transact-SQL queries and export calls. Granular backup and export is a more read-intensive and processing-intensive operation than farm backup.

From the granular backup system, you can back up a site collection or export a site or list.

Note:

Workflows are not included in exports of sites or lists.

If you are running SQL Server Enterprise, the granular backup system can optionally use SQL Server database snapshots to make sure that data remains consistent while the backup or export is in progress. After you create a snapshot, SharePoint 2013 uses it to create the backup or export package, and then deletes the snapshot. Database snapshots are linked to the source database. When the source database is offline, the snapshot is unavailable. For more information about database snapshots, see Database Snapshots (http://go.microsoft.com/fwlink/p/?LinkId=166158).

Benefits of backing up a site collection by using a snapshot include the following:

  • The snapshot makes sure that the data that is being read remains consistent while the operation is being performed.

  • Users can continue to interact with the site collection while it is being backed up from the database snapshot. This includes adding, editing, and deleting content. However, the changes that users make to the live site will not be included in the site collection backup because the backup is based on the database snapshot.

However, database snapshots can adversely affect performance.

You can use granular backup and export for content that is stored in a database that is configured to use the SQL FILESTREAM RBS provider.

Note:

If the RBS provider that you use does not support snapshots, you cannot use snapshots for content deployment or backup. For example, the SQL FILESTREAM provider does not support snapshots.

Note:

We do not recommend that you use SharePoint 2013 site collection backup for site collections larger than 85 GB.

The following illustration shows the granular backup and export system.

Site collection backup

Granular backup/export process

Recovery processes in SharePoint 2013

SharePoint 2013 supports the following primary, built-in recovery options:

  • Restore from a farm backup that was created by using built-in tools.

  • Restore from the backup of a component taken by using the farm backup system.

  • Restore from a site collection backup.

  • Connect to a content database by using the unattached content database feature, back up or export data from it, and then restore or import the data.

Restoring from a farm backup

Items that can be recovered from a farm backup include the following:

  • Farm

    • Content and configuration data (default)

      The whole server farm is restored.

      This includes settings from the configuration database, and trusted solution packages.

    • Configuration-only

      Only the configuration data is restored. This overwrites any settings in the farm that have values that are set within the configuration-only backup.

  • Web applications

    Restores web applications.

  • Service applications

    Restores service applications. Service application recovery can be complex because SharePoint 2013 cannot fully reconfigure service application proxies during the restore process. Although service application proxies are restored, they are not put in proxy groups. Therefore, service application proxies are not associated with any web applications. For more information about how to restore a Search service application, see Search service application recovery process. For specific information about how to restore specific service applications, see Restore service applications in SharePoint 2013.

  • Content databases

    When content databases are restored, the sandboxed solutions associated with the related site collections are also restored.

Restoring as new versus restoring as overwrite

By default, SharePoint 2013 recovery restores all objects as new instances of the object, instead of overwriting existing instances with the same name.

When you restore a farm or object as new, the following objects will not work without adjustments, because all GUIDs for objects are assigned new values:

  • Farm.

    When you restore a farm as new, you must do the following:

    • Recreate alternate access mapping settings. SharePoint 2013 recovery only restores the Default zone of the web application.

    • Reconfigure settings for any Microsoft Business Connectivity Services and Managed Metadata service application external sources.

    • Associate service application proxies with proxy groups again because service application proxies are not assigned to proxy groups when restored. All web applications will be associated with the default proxy group. You must associate web applications with other proxy groups if you want to do that.

  • Web application

    • If the name and URL of a web application that you provide match the name and URL an existing web application in the farm, SharePoint 2013 recovery combines them.

    • If you do not want to combine web applications, you must rename the web application when you restore it as new.

    • When you restore a web application as new in the same environment but do not combine web applications, many other parameters and objects must also be changed. For example, you may have to provide different database file paths and different database names.

  • Service applications and service application proxies

    • If you recover a service application and also recover the related service application proxy, you must associate the service application proxy with a proxy group.

    • If you recover a service application and do not also recover the related service application proxy, you must recreate the service application proxy.

    Note:

    You cannot restore a service application as new in the same farm. You can restore a service application as new in another farm.

When you restore an object and overwrite the existing object, no changes are necessary.

Search service application recovery process

The recovery process for the Search service application varies depending on whether you are restoring as new or restoring as overwrite. When you restore as overwrite, no additional steps are necessary.

The restore as new process is as follows:

  1. Restore the service application as new, and specify the new farm topology information as you restore.

  2. Restore the service application proxy as new. If you did not restore the service application proxy, you must create a new service application proxy and associate it with the Search service application.

  3. Associate the service application proxy with the appropriate proxy group and associate the proxy group (if it is not the default proxy group) with the appropriate Web application.

  4. For least-privilege deployments, start the Search service and the Search admin query Web service with the appropriate account.

For more information about how to recover the Search service application, see Restore Search service applications in SharePoint 2013.

Restoring from a site collection backup

Only site collections can be recovered from a site collection backup.

Recovering from an unattached content database

An unattached content database is a database that is attached to an instance of SQL Server but is not associated with a web application. SharePoint 2013 can connect to and back up from an unattached database. For example, SharePoint 2013 can connect to read-only content databases that were restored from any supported backup technology and SQL Server database snapshots of content databases.

Recovery is the following two-stage process:

  1. Back up or export the object from the unattached content database.

  2. Restore or import the output of the prior step to SharePoint 2013.

The following items can be backed up or exported from an unattached database by using granular backup and export, and then restored:

  • Site collection

    Back up by using site collection backup, and then recover by using a site collection restore.

  • Site

    Export, and then import.

  • Lists and libraries

    Export, and then import.

You can use import to recover content that you backed up from a database that is configured to use the SQL FILESTREAM RBS provider. SharePoint 2013 uses the currently defined storage provider for that content database to store recovered content. If the content database is not set to use RBS, the data will be stored in the content database; if the content database is set to use RBS, the data will be stored in RBS.

See also

Plan for backup and recovery in SharePoint 2013
Backup and restore SharePoint 2013

What's New in SharePoint 2013 Products Resource Center
Data Protection and Recovery


Plan for backup and recovery in SharePoint 2013
See also

Summary: Learn how to plan backup and recovery strategies for your SharePoint 2013 environment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Typically, you want to have a backup and recovery plan available before you deploy your SharePoint 2013 environment. Your backup and recovery plan must change as your SharePoint 2013 changes to protect your data.

The stages involved in planning for backup and recovery include determining backup and recovery strategies for a SharePoint Server environment and deciding which tools to use. The stages do not have to be done in the order listed, and the process may be iterative.

When you plan backup and recovery for disaster recovery, consider common events, failures, and errors; local emergencies; and regional emergencies. The sections in this article describe the stages that you must address in your backup and recovery plan. Each stage is a step toward the final goal of a good backup to use to recover your SharePoint 2013 farm. You can customize the stages to meet your needs. Note that your overall backup and recovery plan is dynamic and must reflect your SharePoint 2013 environment.

For more information about SharePoint 2013 backup and recovery, see Overview of backup and recovery in SharePoint 2013.

Define business requirements for SharePoint farms and services

To define business requirements, determine the following for each farm and service in the environment:

  • Recovery point objective (RPO) is the objective for the maximum time period between the last available backup and any potential failure point. It is determined by how much data that the business can afford to lose if a failure were to occur.

  • Recovery time objective (RTO) is the objective for the maximum time that a data recovery process will take. It is determined by the time that the business can afford for the site or service to be unavailable.

  • Recovery level objective (RLO) is the objective that defines the granularity with which you must be able to recover data — whether you must be able to recover the whole farm, Web application, site collection, site, list or library, or item.

Shorter RPO and RTO, and finer granularity of RLO, all typically cost more.

A worksheet to help you plan your strategies for backup and recovery for your SharePoint 2013 environment can be downloaded from SharePoint 2013 Products Preview backup and recovery planning workbook.

Choose what to protect and recover in your SharePoint environment

Your business requirements will help you determine which components of the environment that you must protect, and the granularity with which you must be able to recover them.

The following table lists components of a SharePoint environment that you might decide to protect, and the tools that can be used to back up and recover each component.

SharePoint components for backup and recovery

Component | SharePoint backup | SQL Server 2008 with Service Pack 1 (SP1) and Cumulative Update 2 | SQL Server 2012 | System Center 2012 - Data Protection Manager (DPM) | File system backup
Farm | Yes |  |  | Yes6 |
Service applications | Yes |  |  |  |
Web application | Yes |  |  |  |
Content databases | Yes | Yes | Yes | Yes |
Site collection | Yes1, 2 | Yes1, 2 | Yes1, 2 | Yes1, 2 |
Site | Yes2 | Yes2 | Yes2 | Yes |
Document library or list | Yes2 | Yes2 | Yes2 | Yes |
List item or document |  |  |  | Yes |
Content stored in remote BLOB stores | Yes3 | Yes3 | Yes3 | Yes3 |
Customizations deployed as solution packages | Yes7 | Yes7 | Yes7 | Yes6, 7 |
Changes to Web.config made by using Central Administration or an API | Yes | Yes | Yes | Yes4 |
SharePoint configuration settings | Yes2, 8 | Yes2, 8 | Yes2, 8 | Yes2, 9 |
Customizations not deployed as solution packages |  |  |  | Yes, files can be recovered if protected as files.4, 5 | Yes
Changes to Web.config not made by using Central Administration or an API |  |  |  | Yes4 | Yes
IIS configurations not set through SharePoint 2013 |  |  |  | Yes5 | Yes
SQL Server Reporting Services databases |  | Yes | Yes | Yes |

1Farm-level and database-level backup and restore can be used for site collection recovery if a single site collection is stored in a database.

2Farm-level and database-level backups can be used with SharePoint 2013 unattached database recovery to restore site collections, sites, lists, and configurations.

3Content stored in remote BLOB stores cannot be restored by using System Center 2012 - Data Protection Manager (DPM).

4Changes to Web.config can be backed up by using file system backup from DPM.

5 IIS configurations can be recovered by using a bare-metal backup from DPM.

6 DPM can recover this item by using a combination of a bare-metal backup and SharePoint 2013 backup. It cannot be backed up and recovered as an object.

7Fully-trusted solution packages are stored in the configuration database, and sandboxed solutions are stored in content databases. They can be recovered as part of farm or content database recovery.

8Configuration settings can be recovered from farm-level backups. For more information, see Restore farms in SharePoint 2013.

9The Central Administration content database and the configuration database for a SharePoint 2013 farm can be recovered but only as part of a full-farm recovery to the same farm, with the same computers.

Note:

You can register SharePoint 2013 with Windows Server Backup by using the stsadm.exe -o -registerwsswriter operation to configure the Volume Shadow Copy Service (VSS) writer for SharePoint 2013. Windows Server Backup then includes SharePoint 2013 in server-wide backups. When you restore from a Windows Server backup, you can select SharePoint Foundation (regardless of which version of SharePoint 2013 is installed), and all components reported by the VSS writer for SharePoint 2013 on that server at the time of the backup will be restored.

Windows Server Backup is recommended only for use with for single-server deployments.

Choose what to recover from within SharePoint content databases

From within a content database, you can recover site collections, sites, lists and libraries.

Backup and recovery tools provide different levels of recovery for content in a content database. Recovering an object from within a content database is always more complex than recovering the whole content database.

Protecting customizations

Customizations to SharePoint sites can include the following:

  • Master pages, page layouts and cascading style sheets. These objects are stored in the content database for a web application.

  • Web Parts, site or list definitions, custom columns, new content types, custom fields, custom actions, coded workflows, or workflow activities and conditions.

  • Third-party solutions and their associated binary files and registry keys, such as IFilters.

  • Changes to standard XML files.

  • Custom site definitions (Webtemp.xml).

  • Changes to the Web.config file.

How customizations are deployed, and how changes are made to the Web.config file, have a significant effect on which tools can be used to back up and recover customizations. To provide the greatest opportunity for recovery, we recommend that you use solution packages to deploy customizations and use Central Administration or the SharePoint APIs and object model to configure the Web.config file.

Protecting workflows

Workflows are a special case of customizations that you can back up and recover. Make sure that your backup and recovery plan addresses any of the following scenarios that apply to your environment:

  • Declarative workflows, such as those that you created in SharePoint Designer 2013, are stored in the content database for the site collection to which they are deployed. Backing up the content database protects these workflows.

  • Custom declarative workflow actions have components in the following three locations:

    1. The Visual Studio assemblies for the Activities are stored in the global assembly catalog (GAC).

    2. The XML definition files (.ACTIONS files) are stored in the 15\TEMPLATE\{LCID}\Workflow directory.

    3. An XML entry to mark the activity as an authorized type is stored in the Web.config file for the Web applications in which it is used.

    If your farm workflows use custom actions, you should use a file backup system to protect these files and XML entries. Similar to SharePoint 2013 features such as Web Parts and event receivers, these files should be reapplied to the farm as needed after recovery.

  • Workflows that depend on custom code, such as those that are created by using Visual Studio, are stored in two locations. The Visual Studio assemblies for the workflow are stored in the global assembly catalog (GAC), and the XML definition files are stored in the Features directory. This is the same as other kinds of SharePoint 2013 features such as Web Parts and event receivers. If the workflow was installed as part of a solution package, backing up the content database protects these workflows.

  • If you create a custom workflow that interacts with a site collection other than the one where the workflow is deployed, you must back up both site collections to protect the workflow. This includes workflows that write to a history list or other custom list in another site collection. Performing a farm backup is sufficient to back up all site collections in the farm and all workflows that are associated with them.

  • Workflows that are not yet deployed must be backed up and restored separately like any other data file. When you are developing a new workflow but have not yet deployed it to the SharePoint 2013 farm, make sure that you back up the folder where you store your workflow project files by using Windows Server Backup or another file system backup application.

Protecting service applications

Service applications in a SharePoint 2013 environment can be made up of both service settings and one or more databases, or only service settings. You cannot restore a complete service application by restoring the database only. However, you can restore the databases for a service application and then provision the service application. For more information, see Restore service applications in SharePoint 2013.

Protecting SQL Server Reporting Services databases

SharePoint 2013 backup and recovery does not include SQL Server Reporting Services databases. You must use SQL Server tools for SharePoint Server and SQL Server 2008 R2 Express tools for SharePoint Foundation. For more information, see Backup and Restore Operations for a Reporting Services Installation.

Choose SharePoint backup and recovery tools

To select the correct tools for backup and recovery, you must determine whether you can meet the continuity requirements that you have set for your business within your budget for time and resources.

Key things to consider when you select tools include the following:

  • Speed of backup: Can the tool perform within the maintenance window for your databases? You should test any backup system to make sure that it meets your needs on your hardware.

  • Completeness of recovery.

  • Granularity of objects that can be recovered.

  • Backup type supported (full, differential, or incremental).

  • Complexity of managing the tool.

The following table compares the kind of backup and size of farm that can be backed up in a six-hour window for backup and recovery tools available from Microsoft.

SharePoint farm backup comparison

Tool | Backup type | Size of backup completed in six hours1
SharePoint farm backup and recovery | Full, differential | 600 GB
SQL Server | Full, differential | 600 GB
System Center Data Protection Manager | Incremental | Terabytes

1Backup size was determined by backing up a system that totals the specified size on the test hardware listed in the following section.

Note:

The SharePoint Server and SQL Server backups were performed with backup compression turned on. The SharePoint Foundation and SQL Server 2008 R2 Express backups were also performed with backup compression turned on.

Test hardware

The following table lists the hardware that was used in the tests that determined the size of backup that could be completed in a six-hour window.

Table 3. Hardware used in backup size tests

Component | Description
Processor | 64-bit dual processor, 3 GHz
RAM | 8 GB
Disk | 2 terabyte NTFS file system-formatted partition
Network | 100 megabits per second (Mbps) or faster connection between client computers and server
Network share | Network share with 1.25 terabytes free space

Note:

The upper size limit for performing SharePoint 2013 site collection backups is 100 GB.

For detailed information about the backup and recovery systems that can be used with SharePoint 2013, see the following resources:

  • Overview of backup and recovery in SharePoint 2013

  • Backing Up and Restoring Databases in SQL Server

  • Data Protection Manager 2010 Overview

Determine SharePoint backup and recovery strategies

Based on your business requirements, recovery needs, and the tools that you have selected, determine and document the backup and recovery strategies for your environment.

It is common for IT departments that support SharePoint 2013 environments to decide to use more than one tool to protect the environment, as they determine the strategies that they will use.

For example, in an environment that has databases that are managed by DBAs, the strategies in the following list might be employed:

  • All databases are backed up by SQL Server for SharePoint Server and SQL Server 2008 R2 Express for SharePoint Foundation. The backup interval that is set is based on the following:

    • The importance of the content or service.

    • The effect on performance that the backup has on the environment.

  • Small, quickly changing, very high-business-affect content databases are additionally protected by SQL Server and SQL Server 2008 R2 Express database snapshots that are stored on a separate physical disk. Only one snapshot is stored per database, and snapshots are discarded regularly so that the effect on performance is minimized. The snapshot interval that is set for each database is based on the following:

    • The importance of the content or service.

    • The standard rate of change for the database.

    • The effect on performance that the snapshot has on the environment.

    • The amount of space that is required to store the snapshot.

    Recovering from a snapshot is faster than standard recovery because a snapshot, and its underlying database, can be treated by SharePoint 2013 as an unattached database. However, creating snapshots can decrease the performance of the underlying database. We recommend that the effect that snapshots have on the performance of the system be tested before they are implemented, and that snapshots be discarded regularly to reduce the space that is required.

    Note:

    If you are using Remote Blob Storage (RBS), and the RBS provider that you are using does not support snapshots, you cannot use snapshots for backup. For example, the FILESTREAM provider does not support snapshots.

  • SharePoint 2013 backup is used to protect service applications. The backup interval is based on the following:

    • The importance of the service.

    • The standard rate of change for the database.

    • The effect on performance that the backup has on the database.

  • All restore operations are performed through SharePoint 2013. The choice of which restore system to use is determined by the kind of backup that is available and the object being restored.

Other tools should be part of your business continuity strategy. Consider how you will use recycle bins and versioning in site collections throughout the environment.

Plan for performance when designing your SharePoint backup and recovery strategy

As you plan your backup and recovery strategy, consider the following recommendations to help you decrease the effect of backup and recovery on system performance.

By design, most backup jobs consume as many I/O resources as they can to finish the job in the available time for maintenance. Therefore, you might see disk queuing and you might see that all I/O requests come back more slowly than usual. This is typical and should not be considered a problem.

Follow recommendations for configuring SQL Server and storage

Follow the general recommendations for configuring SQL Server and storage for a SharePoint Server environment and for configuring SQL Server 2008 R2 Express and storage for a SharePoint Foundation environment.

Minimize latency between SQL Server and the backup location

In general, use a local disk instead of a network drive for backups. If you are backing up multiple servers, you may want to have a directly connected computer that both servers can write to. Network drives that have 1 millisecond or less latency between them and the computers that are running either SQL Server or SQL Server 2008 R2 Express will perform well. If your farm has multiple servers in it (including the computer that is running SQL Server or SQL Server 2008 R2 Express), you must use UNC network paths for the SharePoint farm backup location.

Avoid processing conflicts

Do not run backup jobs during times in which users must have access to the system.

To avoid I/O bottlenecks, perform the main backup to a separate disk, and only then copy to tape.

Consider staggering backups so that not all databases are backed up at the same time.

SharePoint Server backups use SQL Server backups and SharePoint Foundation backups use SQL Server 2008 R2 Express. When using compression with your backups, be careful not to overwhelm SQL Server or SQL Server 2008 R2 Express. For example, some third-party backup tools compress data during backup, which can disrupt SQL Server performance. There are tools available to throttle the compression processes and control the effect on SQL Server.

Follow SQL Server backup and restore optimization recommendations

If you are running SQL Server 2008 Enterprise, we recommend that you use backup compression. For more information, see Backup Compression (SQL Server).

If you are using SQL Server or SQL Server 2008 R2 Express backups, use a combination of full, differential, and transaction log backups for the full recovery model to minimize recovery time. Differential database backups are usually faster to create than full database backups, and they reduce the amount of transaction log required to recover the database.

If you are using the full recovery model in SQL Server 2008, we recommend that you use the truncate option during backup to avoid maintenance issues.

For detailed recommendations about how to optimize SQL Server backup and restore performance, see Optimizing Backup and Restore Performance in SQL Server.

Ensure sufficient write performance on the backup drive

Carefully consider whether to use redundant array of independent disks (RAID) on your disk backup device. For example, RAID 5 has low write performance, approximately the same speed as for a single disk. (This is because RAID 5 maintains parity information.) Using RAID 10 for a backup device may provide faster backups. For more information about how to use RAID with backups, see Configure RAID for maximum SQL Server I/O throughput.

See also

Overview of backup and recovery in SharePoint 2013

Data Protection and Recovery


Plan for monitoring in SharePoint 2013
See also

Summary: Learn about SharePoint monitoring tools and scenarios. Plan schedules and create a response plan to keep the SharePoint farm running.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

To make sure that SharePoint 2013 is running smoothly, IT professionals must monitor farms, servers, applications, services, and performance closely. You should do preventive maintenance regularly to prevent problems from happening, and create a plan that will minimize damage when a problem occurs.

Microsoft provides many tools that help you to monitor the overall health status of the SharePoint 2013 environment. If anything goes wrong, you can find abundant resources and use the monitoring tools to analyze logs, identify the cause, and then take appropriate actions to resolve the problems.

You also need to plan how many people you want to monitor the SharePoint 2013 environment, and develop a response plan to cover actions that you should take when a problem occurs.

In this article:

  • Overview of monitoring tools

  • Identify monitoring scenarios

  • Determine daily, weekly, and monthly monitoring items

  • Plan monitoring personnel

  • Create a response plan

Overview of monitoring tools

There are many tools for you to monitor SharePoint 2013 and troubleshoot problems. Different tools cover different aspects of the environment, although there may be overlapped areas. Consider which tools can maximize your monitoring benefits. The following monitoring tools are available:

  • SharePoint Health Analyzer

    On the Central Administration home page, click Monitoring, Health Analyzer. You can use this built-in feature to analyze and resolve problems in the following areas: security, performance, configuration, and availability. Health Analyzer rules are predefined and run at scheduled intervals, such as hourly, daily, weekly, and monthly. If an error is detected, the corresponding rule is triggered. Each rule has a brief explanation about why the error occurs and provides you with a link to a detailed article that contains step-by-step guidance to resolve the problem. When you take actions by following the guidance, you can re-run the rule to verify resolution. If the error does not appear in the list, the problem is resolved.

  • Timer Jobs

    On the Central Administration home page, click Monitoring, Timer Jobs. SharePoint 2013 uses configurable timer jobs to collect health data and then writes the data to the logging folder and to the Logging database. The data is then used in reports to display the health status of the farm servers.

    You can reschedule a timer job, enable or disable it, and run it on demand. Daily, weekly, and monthly schedules also include a window of execution. The timer service will select a random time within this interval to start running the timer job on each applicable server. This feature is appropriate for high-load jobs that run on multiple servers on the farm.

    Note:

    Running timer jobs at the same time on all servers on the farm can affect system performance. You must schedule them carefully to avoid overlap with other timer jobs.

  • Reporting

    On the Central Administration home page, click Monitoring, Reporting. This feature lets you configure diagnostic logging and data collection, and view administrative and health reports. Because some configurations will use up drive space and adversely affect system performance you must carefully plan what configurations to set.

  • Windows PowerShell

    Windows PowerShell is a powerful tool for monitoring SharePoint 2013. You can run commands to obtain the exact logs that you want to view. For more information, see View diagnostic logs in SharePoint 2013.

  • System Center 2012 - Operations Manager with System Center Management Pack for SharePoint Server 2013

    System Center 2012 - Operations Manager is a powerful monitoring platform that lets you monitor services, devices, and operations for many computers in a single console. By using Operations Manager, you can view status, health, performance information, and alerts generated for availability, performance, configuration and security situations. For more information, see Operations Manager (http://go.microsoft.com/fwlink/p/?LinkID=226376).

    To use Operations Manager to monitor SharePoint products, you must install System Center Management Pack for SharePoint Server 2013. You can use this tool to monitor events, collect SharePoint component-specific performance counters in one central location, and raise alerts for operator intervention as necessary. Download and install System Center Monitoring Pack for SharePoint Server or System Center Monitoring Pack for SharePoint Foundation.

  • Event Viewer

    Event Viewer is a Microsoft Management Console (MMC) snap-in. It lets you browse and manage event logs. It is a very handy tool for troubleshooting problems. You can filter for specific events across multiple logs, and reuse useful event filters as custom views. For more information, see Event Viewer (http://go.microsoft.com/fwlink/p/?LinkId=253618).

  • SharePoint Developer Dashboard

    This tool provides diagnostic information that can help a developer or system administrator analyze performance of SharePoint Web pages. This utility can help if a page is loading slowly, a Web Part is not performing, or if a database query on the page is not performing. The SharePoint Developer Dashboard is disabled by default. You can enable it by using Windows PowerShell. For more information, see SharePoint Developer Dashboard (http://go.microsoft.com/fwlink/p/?LinkID=199580).

  • Windows Management Instrumentation (WMI)

    WMI provides many classes for you to monitor the SharePoint 2013 environment. For each manageable resource, there is a corresponding WMI class. For more information, see WMI Overview (http://go.microsoft.com/fwlink/p/?LinkId=188652).

  • SQL Server Reporting Services (SSRS)

    SQL Server Reporting Services provides a full range of ready-to-use tools and services to help you create, deploy, and manage reports for your organization. It also has programming features that let you extend and customize reporting functionality. By using SQL Server Reporting Services, you can create interactive, tabular, graphical, or free-form reports from relational, multidimensional, or XML-based data sources. You can publish reports, schedule report processing, or access reports on-demand. You can use SQL Server Reporting Services to create reports based on predefined models, and to interactively explore data within the model. You can select from a variety of viewing formats, export reports to other applications, and subscribe to published reports. The reports that you create can be viewed over a Web-based connection or as part of a Windows application or SharePoint site. For more information, see SQL Server Reporting Services (http://go.microsoft.com/fwlink/p/?LinkId=253387).

SharePoint Health Analyzer, Timer Jobs, Reporting, and Windows PowerShell are built-in features, whereas Operations Manager, System Center Management Pack for SharePoint Server 2013, and SQL Server Reporting Services are independent tools. SharePoint Developer Dashboard and WMI are built-in tools and intended for developers or system administrators. These tools are complementary and apply to different scenarios.

The following table shows a summary of these tools. You must balance the pros and cons of the monitoring tools when you determine which tools to use under certain scenarios.

Summary of monitoring tools

Tool Optional or built-in Skill level required Pros Cons Resources

SharePoint Health Analyzer

Built-in

Basic

  • Gives step-by-step instructions for resolving a problem.

  • Customizable. You can disable some rules if you don't need them.

  • Does not cover all possible problems.

  • A rule is triggered only after a problem has already happened.

Configure SharePoint Health Analyzer rules in SharePoint 2013

View and resolve SharePoint Health Analyzer alerts in SharePoint 2013

How to: Create a Health Rule (http://go.microsoft.com/fwlink/p/?LinkId=247474).

SharePoint Health Analyzer rules reference (SharePoint 2013)

Timer jobs

Built-in

Advanced: You have to consider the implications of enabling or disabling a timer job and changing schedules.

  • Wide range of monitoring items.

  • Easy to reschedule.

  • Customizable. You can create new timer jobs to meet your specific requirements.

Can affect system performance and conflict with one another.

Configure SharePoint Health Analyzer timer jobs in SharePoint 2013

Timer job reference (SharePoint 2013)

Create a custom timer job (http://go.microsoft.com/fwlink/p/?LinkId=253616)

Reporting

Built-in

Viewing skill level: Basic

Flexible. Lets you configure the severity of events to log, enable event log flood protection, and configure trace logs.

  • Only shows administrative and health statistics, without any suggested solutions.

  • You have to interpret the logging data.

  • Can affect performance and disk usage.

View reports and logs in SharePoint 2013

Windows PowerShell

Built-in

Advanced: you have to know what to look for, and you have to run Windows PowerShell commands.

Filters data, displays it in various ways, and outputs data to a grid with which you can filter, sort, group, and export the data to Excel 2013.

You have to know which Windows PowerShell commands to run.

View diagnostic logs in SharePoint 2013

Scripting with Windows PowerShell (http://go.microsoft.com/fwlink/p/?LinkId=206775)

System Center 2012 - Operations Manager
with System Center Management Pack for SharePoint Server 2013

Optional but recommended

Advanced: you need to know what to look for and how to interpret data.

The tool can detect, diagnose, and alert you about software and hardware incidents, and refer you to TechNet knowledge articles. It helps you to do more monitoring with fewer people by monitoring many key scenarios.

Requires additional servers to deploy.

Operations Manager (http://go.microsoft.com/fwlink/p/?LinkID=226376)

Microsoft SharePoint 2010 Products Management Pack for System Center Operations Manager 2007 (http://go.microsoft.com/fwlink/p/?LinkID=203252)

Event Viewer

Built-in

Basic

You can view events from multiple event logs, save useful event filters as custom views that can be reused, schedule a task to run in response to an event, and create and manage event subscriptions.

Does not suggest resolutions.

Event Viewer (http://go.microsoft.com/fwlink/p/?LinkId=253618)

SharePoint Developer Dashboard

Built-in

Advanced: you have to know what to look for and how to interpret data.

Easy to analyze performance of SharePoint pages.

Limited to monitoring performance of SharePoint pages.

SharePoint Developer Dashboard (http://go.microsoft.com/fwlink/p/?LinkID=199580)

Windows Management Instrumentation (WMI)

Built-in

Advanced: you have to know what to look for and how to write WMI scripts for the managed objects.

Can monitor, track, and control system events that are related to software applications, hardware components, and networks.

  • You have to identify which managed objects to monitor.

  • You have to write WMI scripts.

SharePoint 2010 SDK (http://go.microsoft.com/fwlink/p/?LinkId=166675)

WMI Overview (http://go.microsoft.com/fwlink/p/?LinkId=188652)

FAST Search: WMI classes (http://go.microsoft.com/fwlink/p/?LinkId=203240)

SQL Server Reporting Services

Optional but recommended.

Advanced: you have to design and manage reports.

Comprehensive platform to create and manage reports.

Advanced skills required to create and develop solutions.
You have to know PerformancePoint Dashboard Designer and Visual Studio.

SQL Server Reporting Services (http://go.microsoft.com/fwlink/p/?LinkId=253387)

For a SharePoint farm with no more than 10 servers, we recommend that you at least install the following independent tools:

  • System Center 2012 - Operations Manager with System Center Management Pack for SharePoint Server 2013

    Monitors the health status of SharePoint products.

  • SQL Server Reporting Services

    Deploy it if you use the Reporting Services to view Report Definition Language (RDL) files, and design reports by Visual Studio and PerformancePoint Dashboard Designer.

Identify monitoring scenarios

Identify the scenarios that you want to monitor —for example, health, workflows, search, SQL Server, virtual environments, and performance. The following table shows some key scenarios and the monitoring tools that you can use to monitor those scenarios.

Scenarios and monitoring tools

Tool\Scenario | Health | Search | Databases | Performance | Workflows | Virtual environments | Business Data Connectivity | Business Intelligence | Access Services | Farms | Servers | Service applications | Web applications
SharePoint Health Analyzer | √ | √ | √ | √ | X | X | √ | √ | √ | √ | √ | √ | X
Timer jobs | √ | √ | √ | √ | √ | X | X | √ | X | X | X | √ | √
Reporting | √ | √ | √ | √ | √ | X | √ | √ | √ | √ | √ | √ | X
Windows PowerShell | √ | √ | √ | √ | √ | X | √ | √ | √ | √ | √ | √ | √
System Center 2012 - Operations Manager with System Center Management Pack for SharePoint Server 2013 | √ | √ | √ | √ | X | √ | √ | √ | √ | √ | √ | √ | X
Event Viewer | √ | √ | √ | √ | √ | X | √ | √ | √ | √ | √ | √ | √
SharePoint Developer Dashboard | X | X | X | √* | X | X | X | X | X | X | X | X | X
Windows Management Instrumentation (WMI) | √ | √ | √ | √ | X | √** | X | √ | X | X | √ | X | X
SQL Server Reporting Services | √ | √ | √ | √ | √ | X | √ | √ | √ | √ | √ | √ | √

Note:

*: SharePoint Developer Dashboard only monitors performance of web pages.

**: The WMI interfaces can manage the Hyper-V services.

Determine daily, weekly, and monthly monitoring items

You can decide which items to monitor daily, weekly and monthly based on the "Daily Tasks" section (on page 43), the "Weekly Tasks" section (on page 51), the "Monthly Tasks" section (on page 52), and the "Impromptu Tasks" section (on page 53) in the SharePoint Server 2010 Operations Framework and Checklists (white paper). You can download the following versions of the white paper:

  • SharePoint Server 2010: Operations Framework and Checklists (Microsoft Word version)

  • SharePoint Server 2010: Operations Framework and Checklists (PDF version)

  • SharePoint Server 2010: Operations Framework and Checklists (XPS version)

Plan monitoring personnel

You have to estimate how many people you will require to monitor the SharePoint 2013 environment. Depending on the size of the SharePoint environment, you might assign dedicated people to monitor the SharePoint environment. For very large enterprise farms, you usually might require one or two people who are dedicated to each farm.

When planning for monitoring personnel, consider the following:

  • Small farm (Small user base, or line of business (LOB) applications)

  • Medium farm (Enterprise, Service Applications, etc.)

  • Large enterprise farm (Large Enterprise, Many Service Applications, Self-Provisioning, etc.)

  • High availability requirements (Service level agreements, SLAs)

  • High performance requirements (Page render times)

  • User base size (how many unique users)

  • Concurrent users (how many users actively hitting the portal at once)

  • Requests per second (also during peak hours)

  • Operational maturity

  • Management tools

The following table shows approximately how many people of different skill levels are required to monitor the SharePoint environment depending on the number of servers. Note that this table only provides a very rough estimate.

Monitoring personnel required

Number of servers | Personnel required | Skill level required
1~4 | 1 | Basic
4~10 | 1~2 | Advanced
10~40 | 3~4 | Basic and Advanced
40~100 | 5+ | Basic and Advanced
100+ | 10+ | Basic and Advanced

Create a response plan

As a best practice, create a response plan to prepare for potential problems and to specify what actions to take when a problem occurs.

The response plan should exclude SharePoint Health Analyzer rules that provide workable solutions already. For a problem that has no immediate solutions, you must investigate the logs by using monitoring tools such as the Event Viewer to find a solution.

The following table shows some factors that you should consider when you develop a response plan.

Suggested items in a response plan

Item | Description
Alert/Event/Problem | The verbatim message, the verbatim event, or description of the problem.
Affected services/applications | Services or applications that will be affected by the problem.
Symptom | Symptom of the problem.
Severity | Severity of the problem. Problems with high severity must have high priority.
Problem must be resolved in (minutes or hours) | Acceptable lapse time of service.
Possible causes | Possible causes of the problem.
Resolutions | Resolutions of the problem.
Contacts | People who should be contacted when this problem occurs.
Escalation | People or teams that should be contacted if the resolutions did not successfully resolve the problem.
Related resources | Any resources that may help resolve the problem, such as articles on the TechNet.
Note | Any issues that you want to highlight.

See also

Monitor health in SharePoint 2013
Overview of monitoring in SharePoint 2013
Monitor health in SharePoint 2013
Monitor apps for SharePoint for SharePoint Server 2013
View search diagnostics in SharePoint Server 2013
Storage and SQL Server capacity planning and configuration (SharePoint Server 2013)
Monitoring and maintaining SharePoint Server 2013
Monitor cache performance in SharePoint 2013

Monitor SharePoint Server by using Visio Services and System Center Operations Manager
Performance Monitoring Getting Started Guide
Monitor workflows (SharePoint 2013 Preview).
Monitor SharePoint Server by using Visio Services and System Center Operations Manager
Monitor and manage a virtual environment (SharePoint 2013 Preview)
Network Monitor
Monitoring Server Planning and Architecture Guide for PerformancePoint Server 2007
Monitoring and Diagnostic logging in Business Connectivity Services overview (SharePoint 2013 Preview)


Plan for high availability and disaster recovery for SharePoint 2013
See also

Updated: March 5, 2013

Summary: Create a well-designed high availability plan and a disaster recovery plan that meets business goals and objectives.

Applies to: SharePoint | Search Server 2013 | SharePoint Foundation 2013 | SharePoint Server 2013 | SharePoint Server 2013 Standard

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about how to plan for, select, and install the best high availability and disaster recovery solutions to ensure of business continuity.

TechNet articles about planning for high availability and disaster recovery

The following articles about high availability and disaster recovery are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | High availability and disaster recovery concepts in SharePoint 2013 | This article introduces high availability and disaster recovery terminology and key concepts. Industry standard benchmarks for assessing HA and DR are also included in the article.
 | Supported high availability and disaster recovery options for SharePoint databases (SharePoint 2013) | This article provides information about the supported technologies that can be used as a high availability or disaster recovery option for SharePoint databases.
 | Choose a disaster recovery strategy for SharePoint 2013 | This article describes the disaster recovery options that are available to implement a disaster recovery strategy for a SharePoint farm.
 | Create a high availability architecture and strategy for SharePoint 2013 | This article provides information about using farm architecture and technology to make your farm highly available.
 | Overview of backup and recovery in SharePoint 2013 | This article describes the backup architecture for SharePoint 2013 and the recovery processes that are available to recover for common business scenarios.
 | Plan for backup and recovery in SharePoint 2013 | This article describes how to plan and implement a backup and recovery strategy for your SharePoint farm.

See also

SharePoint 2013 for IT pros resource center

Change History

Date | Description
March 05, 2013 | Added link to Create a high availability architecture and strategy for SharePoint 2013.
October 16, 2012 | Initial publication


High availability and disaster recovery concepts in SharePoint 2013
See also

Published: October 16, 2012

Summary: Understand high availability and disaster recovery concepts in SharePoint 2013 so you can choose the best strategy for your farm.

Applies to: SharePoint | Search Server 2013 | SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

High availability and disaster recovery is the highest priority when you create a plan and system specifications for a SharePoint 2013 farm. Other aspects of the plan, such as high performance and capacity, are negated if farm servers are not highly available or a farm cannot be recovered.

To design and implement an effective strategy that maintains efficient and uninterrupted operations, you should understand the basic concepts of high availability and disaster recovery. These concepts are also important to evaluate and pick the best technical solutions for your SharePoint environment.

In this article:

  • Introduction to business continuity management

  • Describing high availability

  • Quantifying downtime

Note:

"Describing high availability" and "Quantifying downtime" are excerpts from the Microsoft SQL Server AlwaysOn Solutions Guide for High Availability and Disaster Recovery.

Introduction to business continuity management

Business continuity management is a management process or program that defines, assesses, and helps manage the risks to the continued running of an organization. The following table summarizes the inputs and outputs of business continuity management.

Business continuity management focuses on creating and maintaining a business continuity plan, which is a roadmap for continuing operations when normal business operations are interrupted by adverse conditions. These conditions can be natural, man-made, or a combination of both. A continuity plan is derived from the following analyses and inputs:

  • A business impact analysis

  • A threat and risk analysis

  • A definition of the impact scenarios

  • A set of documented recovery requirements

The result is a solution design or identified options, an implementation plan, a testing and organization acceptance plan, and a maintenance plan or schedule.

A good and brief example of business continuity management is Reducing Operational Risk through Business Continuity Management, which provides a snapshot of the business continuity program at Microsoft. This article and companion video identifies the program's goals and highlights the factors that contribute to its success.

Obviously Information Technology (IT) is a significant aspect of business continuity planning for many organizations. However, business continuity is more encompassing - it includes all the operations that are needed to make sure that an organization can continue to do business during and immediately after a major disruptive event. A business continuity plan includes, but is not limited to, the following elements:

  • policies, processes and procedures

  • possible options and decision-making responsibility

  • human resources and facilities

  • information technology

Although high availability and disaster recovery are often equated to business continuity management; they are in fact, subsets of business continuity management.

Describing high availability

For a given software application or service, high availability is ultimately measured in terms of the end user's experience and expectations. The tangible and perceived business impact of downtime may be expressed in terms of information loss, property damage, decreased productivity, opportunity costs, contractual damages, or the loss of goodwill.

The principal goal of a high availability solution is to minimize or mitigate the impact of downtime. A sound strategy for this optimally balances business processes and Service Level Agreements (SLAs) with technical capabilities and infrastructure costs.

A platform is considered highly available per the agreement and expectations of customers and stakeholders. The availability of a system can be expressed as this calculation:

Actual uptime/Expected uptime X 100%

The resulting value is often expressed by industry in terms of the number of 9's that the solution provides; meant to convey an annual number of minutes of possible uptime, or conversely, minutes of downtime.

Number of 9's | Availability Percentage | Total Annual Downtime
2 | 99% | 3 days, 15 hours
3 | 99.9% | 8 hours, 45 minutes
4 | 99.99% | 52 minutes, 34 seconds
5 | 99.999% | 5 minutes, 15 seconds

Planned versus unplanned downtime

System outages are either anticipated or planned for, or they are the result of an unplanned failure. Downtime need not be considered negatively if it is appropriately managed. There are two key types of foreseeable downtime:

  • Planned maintenance. A time window is preannounced and coordinated for planned maintenance tasks such as software patching, hardware upgrades, password updates, offline re-indexing, data loading, or the rehearsal of disaster recovery procedures. Deliberate, well-managed operational procedures should minimize downtime and prevent any data loss. Planned maintenance activities can be seen as investments needed to prevent or mitigate other potentially more severe unplanned outage scenarios.

  • Unplanned outage. System-level, infrastructure, or process failures may occur that are unplanned or uncontrollable, or that are foreseeable, but considered either too unlikely to occur, or are considered to have an acceptable impact. A robust high availability solution detects these types of failures, automatically recovers from the outage, and then reestablishes fault tolerance.

When establishing SLAs for high availability, you should calculate separate key performance indicators (KPIs) for planned maintenance activities and unplanned downtime. This approach allows you to contrast your investment in planned maintenance activities against the benefit of avoiding unplanned downtime.

Degraded availability

High availability should not be considered as an all-or-nothing proposition. As an alternative to a complete outage, it is often acceptable to the end user for a system to be partially available, or to have limited functionality or degraded performance. These varying degrees of availability include:

  • Read-only and deferred operations. During a maintenance window, or during a phased disaster recovery, data retrieval is still possible, but new workflows and background processing may be temporarily halted or queued.

  • Data latency and application responsiveness. Due to a heavy workload, a processing backlog, or a partial platform failure, limited hardware resources may be over-committed or under-sized. User experience may suffer, but work may still get done in a less productive manner.

  • Partial, transient, or impending failures. Robustness in the application logic or hardware stack that retries or self-corrects upon encountering an error. These types of issues may appear to the end user as data latency or poor application responsiveness.

  • Partial end-to-end failure. Planned or unplanned outages may occur gracefully within vertical layers of the solution stack (infrastructure, platform, and application), or horizontally between different functional components. Users may experience partial success or degradation, depending upon the features or components that are affected.

The acceptability of these suboptimal scenarios should be considered as part of a spectrum of degraded availability leading up to a complete outage, and as intermediate steps in a phased disaster recovery.

Quantifying downtime

When downtime does occur, either planned, or unplanned, the primary business goal is to bring the system back online and minimize data loss. Every minute of downtime has direct and indirect costs. With unplanned downtime, you must balance the time and effort needed to determine why the outage occurred, what the current system state is, and what steps are needed to recover from the outage.

At a predetermined point in any outage, you should make or seek the business decision to stop investigating the outage or performing maintenance tasks, recover from the outage by bringing the system back online, and if needed, reestablish fault tolerance.

Recovery objectives

Data redundancy is a key component of a high availability database solution. Transactional activity on your primary SQL Server instance is synchronously or asynchronously applied to one or more secondary instances. When an outage occurs, transactions that were in flight may be rolled back, or they may be lost on the secondary instances due to delays in data propagation.

You can both measure the impact, and set recovery goals in terms how long it takes to get back in business, and how much time latency there is in the last transaction recovered:

  • Recovery Time Objective (RTO). This is the duration of the outage. The initial goal is to get the system back online in at least a read-only capacity to facilitate investigation of the failure. However, the primary goal is to restore full service to the point that new transactions can take place.

  • Recovery Point Objective (RPO). This is often referred to as a measure of acceptable data loss. It is the time gap or latency between the last committed data transaction before the failure and the most recent data recovered after the failure. The actual data loss can vary depending upon the workload on the system at the time of the failure, the type of failure, and the type of high availability solution used.

    Note:

    A related objective is Recovery level objective (RLO). This objective defines the granularity with which you must be able to recover data — whether you must be able to recover the whole farm, Web application, site collection, site, list or library, or item. For more information, see Plan for backup and recovery in SharePoint 2013.

You should use RTO and RPO values as goals that indicate business tolerance for downtime and acceptable data loss, and as metrics for monitoring availability health.

Justifying ROI or opportunity cost

The business costs of downtime may be either financial or in the form of customer goodwill. These costs may accrue with time, or they may be incurred at a certain point in the outage window. In addition to projecting the cost of incurring an outage with a given recovery time and data recovery point, you can also calculate the business process and infrastructure investments needed to attain your RTO and RPO goals or to avoid the outage all together. These investment themes should include:

  • Avoiding downtime. Outage recovery costs are avoided all together if an outage doesn't occur in the first place. Investments include the cost of fault-tolerant and redundant hardware or infrastructure, distributing workloads across isolated points of failure, and planned downtime for preventive maintenance.

  • Automating recovery. If a system failure occurs, you can greatly mitigate the impact of downtime on the customer experience through automatic and transparent recovery.

  • Resource utilization. Secondary or standby infrastructure can sit idle, awaiting an outage. It also can be leveraged for read-only workloads, or to improve overall system performance by distributing workloads across all available hardware.

For given RTO and RPO goals, the needed availability and recovery investments, combined with the projected costs of downtime, can be expressed and justified as a function of time. During an actual outage, this allows you to make cost-based decisions based on the elapsed downtime.

Monitoring availability health

From an operational point of view, during an actual outage, you should not attempt to consider all relevant variables and calculate ROI or opportunity costs in real time. Instead, you should monitor data latency on your standby instances as a proxy for expected RPO.

In the event of an outage, you should also limit the initial time spent investigating the root cause during the outage, and instead focus on validating the health of your recovery environment, and then rely upon detailed system logs and secondary copies of data for subsequent forensic analysis.

Planning for disaster recovery

While high availability efforts entail what you do to prevent an outage, disaster recovery efforts address what is done to re-establish high availability after the outage.

As much as possible, disaster recovery procedures and responsibilities should be formulated before an actual outage occurs. Based upon active monitoring and alerts, the decision to initiate an automated or manual failover and recovery plan should be tied to pre-established RTO and RPO thresholds. The scope of a sound disaster recovery plan should include:

  • Granularity of failure and recovery. Depending upon the location and type of failure, you can take corrective action at different levels; that is, data center, infrastructure, platform, application, or workload.

  • Investigative source material.Baseline and recent monitoring history, system alerts, event logs, and diagnostic queries should all be readily accessible by appropriate parties.

  • Coordination of dependencies. Within the application stack, and across stakeholders, what are the system and business dependencies?

  • Decision tree. A predetermined, repeatable, validated decision tree that includes role responsibilities, fault triage, failover criteria in terms of RPO and RTO goals, and prescribed recovery steps.

  • Validation. After taking steps to recover from the outage, what must be done to verify that the system has returned to normal operations?

  • Documentation. Capture all of the above items in a set of documentation, with sufficient detail and clarity so that a third party team can execute the recovery plan with minimal assistance. This type of documentation is commonly referred as a 'run book' or a 'cook book'.

  • Recovery rehearsals. Regularly exercise the disaster recovery plan to establish baseline expectations for RTO goals, and consider regular rotation of hosting the primary production site on the primary and each of the disaster recovery sites.

See also

Choose a disaster recovery strategy for SharePoint 2013


Choose a disaster recovery strategy for SharePoint 2013
See also

Published: October 11, 2012

Summary: Understand the disaster recovery options and supported technologies for recovering a SharePoint 2013 farm if there is a disaster.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2010

We define disaster recovery as the ability to recover from a situation in which the primary data center that hosts a SharePoint 2013 farm is unable to continue to operate. Regardless of the nature of event and its cause, the data center outage is significant enough to set into motion the actions defined in your organization's disaster recovery plan. This means putting a fully operational farm into production using computer resources that are located in a data center that is not affected by the event.

In this article:

  • Introduction

  • Standby data center recovery options

  • System requirements for recovery

SharePoint 2013 and SQL Server 2008 R2 with Service Pack 1 (SP1) or SQL Server 2012 provide configuration and content recovery options that can meet the Recovery Time Objective (RTO) and Recovery Point Objective (RPO) that are required for your business if there is a disaster. For more information about these and other disaster recovery concepts, see High availability and disaster recovery concepts in SharePoint 2013.

Introduction

An effective disaster recovery strategy for a SharePoint 2013 farm must be sufficient to meet your organization's business requirements, which are typically expressed by using two measures: Recovery Time Objective (RTO) and Recovery Point Objective (RPO). RTO and RPO requirements are derived by determining the downtime cost to the organization if a disaster happens.

Important:

As a best practice we recommend that you clearly identify and quantify your organization's RTO and RPO before you develop a recovery strategy and implement a technical solution. Focus on what is required, not how to do it.

Downtime costs vary significantly between and within industries, especially due to the different effects of downtime. Business size is the most obvious factor. However, it is not the only one. Setting a measure means establishing the nature and implications of the failure. Reduced to the simplest level, a failure of a critical application could lead to the following types of losses:

  • Loss of the application service. The effect of downtime varies with the application and the business.

  • Loss of data. The potential loss of data due to a system outage can have significant legal and financial impact.

Most organizations will incur a downtime cost from both of the previous types of loss but the nature of the business will determine which type of loss has the biggest effect. The following article, written by Chris Preimesberger at eWEEK, highlights the financial effect of data center downtime. Unplanned IT Downtime Can Cost $5K Per Minute: Report.

In most scenarios, SharePoint products is one of several applications that must be recovered in the event of a data center shutdown that qualifies as a disaster. For this reason we have not included information about disaster recovery planning but focus on options for making sure that you can recover your SharePoint 2013 farm at another location.

Regardless of the type and scale of a disaster, recovery involves the use of a standby data center that you can recover the farm to.

Standby data center recovery options

Standby data centers are required for scenarios where local redundant systems and backups cannot recover from the outage at the primary data center. The time and immediate effort to get a replacement farm up and running in a different location is often known as a hot, warm, or cold standby. Our definitions for these farm recovery data centers are as follows:

  • Cold standby. A secondary data center that can provide availability within hours or days.

  • Warm standby. A secondary data center that can provide availability within minutes or hours.

  • Hot standby. A secondary data center that can provide availability within seconds or minutes

Each of these standby data centers has specific characteristics and requirements, and also an associated cost to operate and maintain.

  • Cold standby disaster recovery strategy: A business ships backups to support bare metal recovery to local and regional offsite storage regularly, and has contracts in place for emergency server rentals in another region.

    Pros:

    • Often the cheapest option to maintain, operationally.

    • Often an expensive option to recover, because it requires that physical servers be configured correctly after a disaster has occurred.

    Cons: The slowest option to recover.

  • Warm standby disaster recovery strategy: A business ships backups or virtual machine images to local and regional disaster recovery farms.

    Pros: Often fairly inexpensive to recover, because a virtual server farm can require little configuration upon recovery.

    Cons: Can be very expensive and time-consuming to maintain.

  • Hot standby disaster recovery strategy: A business runs multiple data centers, but serves content and services through only one data center.

    Pros: Often fairly fast to recover.

    Cons: Can be very expensive to configure and maintain.

Important:

No matter which of the previous disaster recovery solutions that you decide to implement, there is likely going to be some data loss.

Cold standby recovery

In a cold standby disaster recovery scenario, you recover by setting up a new farm in a new location, (preferably by using a scripted deployment), and restoring backups. Or, you can recover by restoring the farm using a backup solution such as System Center 2012 - Data Protection Manager (DPM). System Center Data Protection Manager protects your data at the computer operating system level and lets you restore each server individually. This article does not contain detailed instructions for how to create and recover in cold standby scenarios. For more information, see:

  • Overview of backup and recovery in SharePoint 2013

  • Plan for backup and recovery in SharePoint 2013

Warm standby recovery

In a warm standby disaster recovery scenario, you create a warm standby environment by creating a duplicate farm at the alternate data center and ensure that it is updated regularly by using full and incremental backups of the primary farm.

Virtual warm standby environments

Virtualization provides a workable and cost effective option for a warm standby recovery solution. You can use Hyper-V as an in-house solution or Windows Azure as a hosted solution to provide necessary infrastructure for recovery.

You can create virtual images of the production servers and ship these images to the standby data center. By using the virtual standby solution, you have to make sure that the virtual images are created often enough to provide the level of farm configuration and content freshness that you must have for recovering the farm. At the secondary location, you must have an environment available in which you can easily configure and connect the images to re-create your farm environment.

Hot standby recovery

In a hot standby disaster recovery scenario, you set up a failover farm in the standby data center so that it can assume production operations almost immediately after the primary farm goes offline. An environment that has a separate failover farm has the following characteristics:

  • A separate configuration database and the SharePoint Central Administration website content database must be maintained on the failover farm.

  • All customizations must be deployed on both farms.

    Tip:

    There is consistency between the two farms and reduce the possibility of error we recommend that you use scripted deployment to create the primary and failover farm by using the same configuration settings and customizations.

  • Operating system, SQL Server and SharePoint products software updates must be applied to both farms, to maintain a consistent configuration across both farms.

  • You can copy SharePoint products content databases to the failover farm by using asynchronous mirroring, asynchronous commit on an availability group replica, or log-shipping.

    Note:

    SQL Server mirroring can only be used to copy databases to a single mirror server, but you can log-ship to multiple secondary servers.

  • Service applications vary in whether they can be log-shipped to a farm. For more information, see Service application redundancy later in this article.

The hot standby farm topology can be repeated across more than one data center, as long as you configure SQL Server log shipping to one or more additional data centers.

Important:

Available network bandwidth and latency are major considerations when you are using a failover approach for disaster recovery.

We recommend that you consult with your SAN vendor to determine whether you can use SAN replication or another supported mechanism to provide the hot standby level of availability across data centers.

Service application redundancy

To provide availability across data centers for service applications, we recommend that for the services that can be run cross-farm, you run a separate services farm that can be accessed from both the primary and the secondary data centers.

For services that cannot be run cross-farm, and to provide availability for the services farm itself, the strategy for providing redundancy across data centers for a service application varies. The strategy employed depends on whether:

  • There is business value in running the service application in the disaster recovery farm when it is not being used.

  • The databases associated with the service application can be log-shipped, asynchronously mirrored, or replicated using asynchronous commit.

  • The service application can run against read-only databases.

Review the Supported high availability and disaster recovery options for SharePoint databases (SharePoint 2013) article before designing a disaster recovery solution that uses a warm or hot standby data center.

System requirements for recovery

In an ideal scenario, the failover components and systems match the primary components and systems in all ways: platform, hardware, and number of servers. At a minimum, the failover environment must be able to handle the traffic that you expect during a failover. Keep in mind that only a subset of users may have to be served by the failover site. The systems must match in at least the following:

  • Operating system version and all updates

  • SQL Server versions and all updates

  • SharePoint 2013 versions and all updates

In addition to the previous requirements, farm recovery time will also be affected by availability of facilities and infrastructure components. Make sure that the following requirements are met:

  • Power, cooling, network, directory, and SMTP are fully redundant

  • Choose a switching mechanism; whether DNS or hardware load balancing, that meets your needs.

See also

High availability and disaster recovery concepts in SharePoint 2013


Supported high availability and disaster recovery options for SharePoint databases (SharePoint 2013)
See also

Updated: April 23, 2013

Summary: Learn about supported high availability and disaster recovery options for each SharePoint 2013 system and service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes the supported high availability and disaster recovery options for SharePoint 2013 databases. For detailed information about these databases, such as size and supported backup and recovery tools, see Database types and descriptions (SharePoint 2013). You can also view or download a model (Databases that support SharePoint 2013) of these databases on the Technical diagrams for SharePoint 2013 page.

In this article:

  • Introduction

  • SharePoint 2013 system databases

  • SharePoint 2013 service application databases

  • SharePoint 2013 service applications

  • SQL Server System databases

  • SQL Server Reporting Services databases

Introduction

The scope of this article is the supported high availability and disaster recovery solutions for each SharePoint 2013 system and service application database. These solutions address the database level, instead of the database instance or database server level and include the following: database mirroring, database availability groups, and log shipping.

When you evaluate a high availability or a disaster recovery option for SharePoint, you must understand that not all of the options are supported by each SharePoint database. This is because of design requirements and feature characteristics.

This article identifies the supported option for each of the SharePoint databases, which are grouped by SKU and then by feature.

SharePoint 2013 system databases

The Configuration, the SharePoint Central Administration website Content, and Content databases are the databases that are automatically installed when you deploy any SharePoint 2013 edition.

The following tables provide the supported high availability and disaster recovery options for the SharePoint system databases.

Configuration database

Category Description

Default database name when it is installed with the SharePoint Products Configuration Wizard

SharePoint_Config

Purpose

The configuration database contains data about the following:

  • SharePoint databases

  • Internet Information Services (IIS) web sites

  • web applications

  • Trusted solutions

  • Web Part packages

  • Site templates

The configuration database also contains specific data for SharePoint 2013 farm settings, such as default quota settings and blocked file types.

Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability

Yes

Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability

Yes

Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery

No

Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery

No

Central Administration content database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | SharePoint_Admin_Content
Purpose | This database stores all configuration data for the Central Administration site collection. If SQL Server 2012 Power Pivot for SharePoint 2013 is installed the Central Administration content database also stores the Excel worksheets and Power Pivot data files that are used in the Power Pivot Management Dashboard.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | No

Content database

Category Description

Default database name when it is installed with the SharePoint Products Configuration Wizard

WSS_Content

Purpose

Content databases store all content for a site collection. This includes site documents or files in document libraries, list data, Web Part properties, audit logs, and some apps for SharePoint data if the apps are installed, in addition to user names and rights.

Content databases also store user data for Power Pivot for SharePoint, if you installed it in your SharePoint 2013 environment.

Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability

Yes

Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability

Yes

Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery

Yes

Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery

Yes

SharePoint 2013 service application databases

These databases are created to support features that are used in both SharePoint Foundation 2013 and SharePoint Server 2013 farms.

The following sections describe the supported high availability and disaster recovery options for SharePoint Foundation 2013 and SharePoint Server 2013 service application databases.

App Management service application

The following table provides the supported high availability and disaster recovery options for the App Management database.

App Management database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | AppManagement
Purpose | Stores app licenses and permissions that are downloaded from the SharePoint Store or App Catalog.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

SharePoint Search service databases

The SharePoint Search service application uses the following databases:

  • Search Administration

  • Analytics Reporting

  • Crawl

  • Link

The following tables provide the supported high availability and disaster recovery options for the Search databases.

Search Administration database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | Search_Service_Application_DB_<GUID>
Purpose | Stores the Search application configuration and access control list (ACL) for the crawl component.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | No
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | No

Analytics Reporting database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | Search_Service_Application_AnalyticsReportingStoreDB_<GUID>
Purpose | Stores the results for usage analysis reports and extracts information from the Link database when it is needed.
Supports SQL Server 2008 R2and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | No

Crawl database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | Search_Service_Application_CrawlStoreDB_<GUID>
Purpose | Stores the state of the crawled data and the crawl history.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | No
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | No

Link database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | Search_Service_Application_LinkStoreDB_<GUID>
Purpose | Stores the information that is extracted by the content processing component and click through information.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | No
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | No

Secure Store database

The following table provides the supported high availability and disaster recovery options for the Secure Store database.

Secure Store database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | Secure_Store_Service_DB_<GUID>
Purpose | Stores and maps credentials, such as account names and passwords.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Usage and Health Data Collection database

The following table provides the supported high availability and disaster recovery options for the Usage and Health Data Collection database.

Usage and Health Data Collection database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | SharePoint_Logging
Purpose | Stores health monitoring and usage data temporarily, and can be used for reporting and diagnostics.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes, but not recommended
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes, but not recommended
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes, but not recommended
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Subscription Settings service application

The following table provides the supported high availability and disaster recovery options for the Subscription Settings service application database.

Subscription Settings database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | SettingsServiceDB
Purpose | The Microsoft SharePoint Foundation Subscription Settings service application database stores features and settings for hosted customers.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

SharePoint 2013 service applications

These service applications support the features that are available in either the Standard or Enterprise edition of SharePoint Server 2013.

The following sections describe the supported high availability and disaster recovery options for SharePoint Server 2013 service application databases.

User Profile Service databases

The User Profile Service application uses the following databases:

  • Profile: The Profile database stores and manages users and associated information. It also stores information about a user's social network in addition to memberships in distribution lists and sites.

  • Synchronization: The Synchronization database stores configuration and staging data for use when profile data is being synchronized with directory services such as Active Directory.

  • Social Tagging: The Social Tagging database stores social tags and notes created by users, alongside their respective URLs.

The following tables describe the supported high availability and disaster recovery options for the User Profile service application databases.

Profile database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | User Profile Service Application_ProfileDB_<GUID>
Purpose | Stores and manages users and their associated information. It also stores information about a user's social network in addition to memberships in distribution lists and sites.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Synchronization database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | User Profile Service Application_SyncDB_<GUID>
Purpose | Stores configuration and staging data for use when profile data is synchronized with directory services such as Active Directory.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | No
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Social Tagging database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | User Profile Service Application_SocialDB_<GUID>
Purpose | Stores social tags and notes created by users, alongside their respective URLs.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Word Automation Services database

The following table describes the supported high availability and disaster recovery options for the Word Automation Services database.

Word Automation Services database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | WordAutomationServices_<GUID>
Purpose | Stores information about pending and completed document conversions.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | No
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Managed Metadata Service database

The following table describes the supported high availability and disaster recovery options for the Managed Metadata Service database.

Managed Metadata Service database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | Managed Metadata Service Application_Metadata_<GUID>
Purpose | Stores managed metadata and syndicated content types.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Taxonomy database

The following table describes the supported high availability and disaster recovery options for the Taxonomy database.

Taxonomy database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | Managed Metadata Service_<GUID>
Purpose | Stores a hierarchical structure for items that are used to tag content and build site collections.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Translation Services database

The following table describes the supported high availability and disaster recovery options for the Translation Services database.

Translation Services database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | SharePoint Translation Services_<GUID>
Purpose | Stores information about pending and completed batch document translations with enabled file extensions.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Business Data Connectivity service database

The following table describes the supported high availability and disaster recovery options for the Business Data Connectivity database.

Business Data Connectivity service database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | Bdc_Service_DB_<GUID>
Purpose | Stores external content types and related objects.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

Project Server database

The following table describes the supported high availability and disaster recovery options for the Project Server database.

Note:

Project Server creates a separate database for each instance of Project Web App

Project Server database

Category Description

Default database name when it is installed with the SharePoint Products Configuration Wizard

ProjectWebApp

Purpose

Each Project Web App database contains the following data:

  • All Project and Portfolio Management (PPM) data

  • Time tracking and Timesheet data

  • Aggregated SharePoint project site data

Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability

Yes

Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability

Yes

Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery

Yes

Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery

To be determined. Currently not supported because testing is not finished.

Power Pivot Service database

The following table describes the supported high availability and disaster recovery options for the PowerPivot Service database.

Power Pivot Service database

Category | Description
Default database name when it is installed with SQL Server 2012 Power Pivot for Excel 2013 | DefaultPowerPivotServiceApplicationDB_<GUID>
Purpose | Stores data refresh schedules, and Power Pivot usage data that is copied from the central usage data collection database.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Not tested
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Not tested
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Not tested
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | Not tested

PerformancePoint Services database

The following table describes the supported high availability and disaster recovery options for the PerformancePoint Services database.

PerformancePoint Services database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | PerformancePoint Service _<GUID>
Purpose | Stores temporary objects and saved user comments and settings.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | Yes
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | To be determined. Currently not supported because testing is not finished.

State Service database

The following table describes the supported high availability and disaster recovery options for the State Service database.

State Service database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | SessionStateService_<GUID>
Purpose | Stores temporary state information for InfoPath Forms Services, Exchange Server, the chart Web Part, and Visio Services.
Supports SQL Server 2008 R2 and SQL Server 2012 synchronous mirroring in a farm for availability | Yes
Supports SQL Server AlwaysOn Availability Group with synchronous-commit for availability | Yes
Supports SQL Server 2008 R2 asynchronous mirroring or log-shipping to another farm for disaster recovery | No
Supports SQL Server AlwaysOn Availability Group with asynchronous-commit for disaster recovery | No

SQL Server System databases

SharePoint Server 2013 is built on SQL Server and uses the following SQL Server system databases: master, msdb, tempdb, and model. SQL Server provides a complete set of administrative tools that let users fully administer their system and manage all users and objects in a database. For more information about the SQL Server system databases, see System Databases.

Only user databases can be mirrored, placed in a SQL Server AlwaysOn availability group or log shipped. You cannot use these approaches to provide high availability or disaster recovery for the system databases.

SQL Server Reporting Services databases

The following SQL Server Reporting Services (SSRS) databases can be used as part of a SharePoint 2013 deployment:

  • Report Server Catalog (ReportingService_<GUID>) - Stores all report metadata including report definitions, report history and snapshots, and scheduling information.

    Note:

    When Report Server Catalog is used, report documents are stored in SharePoint content databases.

  • ReportServerTempDB (ReportingService_<GUID>_TempDB) - Stores all the temporary snapshots while reports are running.

  • Report Server Alerting (ReportingService_<GUID>_Alerting) - Stores all Data Alerts and runtime information.

A Reporting Services report server is a stateless server that stores application data, content, properties, and session information in two SQL Server relational databases. The best way to ensure the availability of Reporting Services functionality is to do the following:

  • Use the high availability features of the SQL Server Database Engine to maximize the uptime of the report server databases. If you configure a Database Engine instance to run in a failover cluster, you can select that instance when you create a report server database.

  • Use SQL Server AlwaysOn Availability Groups with the Reporting Services databases and for data sources where applicable.

  • Configure multiple report servers to run in a scale-out deployment, where all the servers share a single report server database. Deploying multiple report server instances on different servers can help increase the level of uninterrupted service.

See also

High Availability: Interoperability and Coexistence
AlwaysOn Availability Groups (SQL Server): Interoperability and Coexistence with Other Database Engine Features

Change History

Date | Description
April 23, 2013 | Added information about support for using SQL Server AlwaysOn asynchronous commit as a disaster recovery option for the Search service application databases.
November 27, 2012 | Initial publication


Create a high availability architecture and strategy for SharePoint 2013
See also

Updated: April 2, 2013

Summary: Learn how to combine farm architecture and technology to create a highly available environment in a single SharePoint 2013 farm.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

A high-availability strategy is an important requirement for a production SharePoint 2013 environment. An end-to-end strategy includes operational processes, platform governance, architecture, and technical solutions. This article focuses on the architectural and technical aspects of high availability. The guidance explains specific SharePoint design elements and the technical options that will determine your strategy for high availability.

Note:

High availability and disaster recovery are not the same things. Although there is overlap in planning and solutions, they are subsets of business continuity. The purpose of high availability is to provide resiliency within the primary data center and planned downtime. The purpose of disaster recovery is to enable an organization to resume computer operations in a secondary data center when a disaster at the primary data center makes the infrastructure unusable. For information about disaster recovery for SharePoint 2013, see Choose a disaster recovery strategy for SharePoint 2013.

In this article:

  • Introduction

  • High availability - definition and scope

  • Measuring availability

  • High availability costs

  • Create a farm architecture that supports high availability

  • Use fault tolerance in your high availability solution

  • Configure two data centers as a single farm ("stretched" farm) to provide high availability

  • Incorporate backup and restore operations in a high availability strategy

High availability is generally used to describe the ability of a system to continue operating and provide resources to its users when a failure occurs in one or more of the following categories in a fault domain: hardware, software, or application. The level of availability is expressed as a measure of the percentage of time that a system is continuously operational to support business functions. The required level of availability varies among organizations. Although this requirement may also vary among business units, a service level agreement is for the organization as a whole. From the perspective of users, a farm is available when users can access the farm and use the features and services that they must have to do their work.

A highly available SharePoint farm has the following goals and characteristics:

  • The farm design reduces potential points of failure. Because it is improbable that you can eliminate all failure points, the overall strategy must address how to respond to a failure event.

  • Failover events are seamless and have minimal effect on user activities.

  • The farm continues to operate at reduced capacity instead of failing completely.

  • The farm is resilient. Incidents that affect service occur infrequently, and timely and effective action is taken when they do occur.

Introduction

Before you can create a realistic and economical high-availability architecture and strategy for your SharePoint environment, you have to define and quantify your availability goals. These goals reflect the extent to which your organization depends on SharePoint 2013 and how a loss of service might affect the organization's operations. The effect of the loss of service depends on the nature of the loss (full or partial) and the duration of the loss.

Lost revenue is usually identified as a leading result of reduced service or a complete loss of service, especially for companies that conduct business online. However, other less visible consequences are equally damaging to an organization. For example, an organization can experience loss of confidence by partners, suppliers or customers, diminished respect of the corporate brand, and legal issues.

A successful high-availability strategy must reflect the specific needs of your organization. Additionally, it must provide an optimal balance between business requirements, IT service level agreements (SLAs), and the availability of technical solutions, IT support capabilities, and infrastructure costs.

After you identify availability requirements for your organization, you can begin to create a high-availability design and a strategy to reduce the risk of downtime and reduced operations. IT professionals who design and deploy highly available systems use the following guiding principles to meet their goals:

  • Eliminate single points of failure for each fault domain and the entire system at every possible layer (the operating system, software and the SharePoint application).

    Note:

    A fault domain provides the scope and boundary of a physical point of failure. The March 2011 Issue of IEEE Computer Magazine gives this definition: "A fault domain is a set of hardware components - computers, switches, and more - that share a single point of failure."

    For more information about fault domains and upgrade domains, see Window Azure Fault Domain and Upgrade Domain Explained for IT Pros.

  • Implement very rapid fault detection, isolation, and resolution.

Note:

An SLA is a negotiated agreement between IT service providers (an internal IT group or external vendor) and user representatives. An SLA is used to identify and quantify the required services and the support that the service provider will provide. SLAs are clear, specific, and precise to avoid misunderstandings about expectations of providers and users. Clarity and preciseness are important because SLAs typically specify significant financial penalties where third-party service providers are engaged.

High availability - definition and scope

High availability and fault tolerance are not the same things. A definition of high availability is important because fault tolerance is frequently used synonymously to describe how high availability is implemented.

High availability solutions are broad in scope and provide a set of system-wide, shared resources that are integrated to provide predefined required services. The solution uses different combinations of industry-standard hardware and software to minimize downtime and restore services when the system or part of the system fails.

A fault-tolerant solution is hardware-centric and uses specialized hardware to detect faults and instantly switch to a redundant hardware component. This component can be a processor, memory board, power supply, I/O subsystem, or storage subsystem. The switch to a redundant component provides a high level of service.

A cost-benefits analysis of fault-tolerant solutions and high availability solutions enables organizations to create an effective strategy to meet the availability goals for their SharePoint farm. Typically there are cost tradeoffs between the two solutions. For more information, see Evaluating High-Availability (HA) vs. Fault Tolerant (FT) Solutions.

Measuring availability

Availability is measured in relation to being operational 100% of the time, or never down. The common measure of availability in the IT world is expressed as a number of 9s, ranging from one nine (90%) to five nine (99.999%), the ideal. The number of nines measure is the percentage of time that a given system is running, functioning, and available to users.

Note:

Uptime is frequently used synonymously with availability. However, this is misleading because a computer system can be running but not able to provide the services and functionality that users need.

The availability percentage is calculated using the formula x = (n - y) * 100/n.

  • x is the percentage

  • n is the total number of minutes in a given calendar month (30 days)

  • y is the total number of minutes that a system or service is unavailable

As you can see in the following table, which correlates availability percentage with calendar time equivalents, five 9s of availability is difficult to achieve. This level of availability is also expensive, complex, and in some cases involves risk. For more perspective on five 9s, read Vijay Gill's post, How many Nines? and Sean Hull's post, The myth of five nines - Why high availability is overrated.

Note:

Three 9s of availability is the norm for most businesses that operate SharePoint farms in their datacenter. This level of availability is also typical for a SharePoint farm that is deployed in a hosted environment or in the cloud.

Correlation of % availability to calendar downtime

Acceptable availability percentage | Downtime per day | Downtime per month | Downtime per year
90 (one nine) | 144.00 minutes | 72 hours | 36.5days
99 (two nines) | 14.40 minutes | 7 hours | 3.65 days
99.9 (three nines) | 86.40 seconds | 43 minutes | 8.77 hours
99.99 (four nines) | 8.64 seconds | 4 minutes | 52.60 minutes
99.999 (five nines) | 0.86 seconds | 26 seconds | 5.26 minutes

Although out of scope for this article, several of the following aspects of an SLA should be reflected in a high-availability design.

Availability definition and scope

You can't build an environment for availability or negotiate an SLA until you define availability. It has to be a measure of the ability of users to complete the normal tasks that their job requires and use the functions and services that provides. SharePoint workloads that an organization uses determine this definition and the scope of availability. Workload requirements vary among customers and are based on the specific needs of each organization, the functions that the farm provides, and the profile of the users of the farm.

Exclusions to availability calculations

Exclusions to availability are as important to the design of availability as they are to an SLA. Every system requires routine maintenance. Planned downtime or reduced levels of service are not part of availability calculations. Typical exclusions are scheduled maintenance hours and planned downtime for activities such as quarantining a virus or responding to a security threat.

Downtime metrics

The previous "Correlation of % availability to calendar downtime" table identifies downtime for each 9 of availability. The following measures are used to calculate availability:

  • Mean time between failures (MTBF) - The expected time between two consecutive failures for a repairable system.

  • Mean time to failure (MTTF) - The expected time to failure for a system that cannot be repaired.

  • Mean time to repair or replace (MTTR) - The expected time to repair or replace a failed component.

The following formula calculates availability: Availability = MTTF / (MTTF + MTTR). You can use this formula to calculate total availability and improve it by using more reliable hardware and software components to increase MTTF and decrease MTTR.

The relationship of performance to availability

Performance is not isolated from availability. Service providers and consumers define quantifiable performance benchmarks for service levels when a system is running under normal conditions. However, reduced availability occurs when an extraordinary event significantly affects performance to make the system basically unusable—by definition, the farm is not available. Here are typical examples of extraordinary events:

  • Denial of service attacks on public-facing web servers

  • Poorly formed queries that use up database server resources or database transactions that lock tables

  • Wide-area network (WAN) failures or high network latency caused by events in other locations

As more organizations move to geographically distributed SharePoint farms or hosted environments, network latency is extremely important for availability planning.

High availability costs

A process that implements high availability is one of the more expensive investments for a SharePoint farm. As the level of availability and the number systems that you want to make highly available increases, complexity and cost of an availability solution also increases. The following costs are typically part of an investment in high availability:

  • Additional infrastructure components such as network adapters, switches, and power for redundancy.

  • Additional hardware, software, or software licenses to support various farm roles that provide workload redundancy across the farm architecture.

  • Spare hardware to replace failed equipment.

    Although it's common to prepare spare computers in varying states of readiness to use for routine maintenance or to replace a failed server, your investment is in hardware that sits idle.

    Note:

    Advances in virtualization technology enable organizations to use virtual computers as hot, warm, or cold spares. Virtual computers may be suitable to provide the same functionality. Virtualization can provide flexibility and cost efficiency. However, you must verify that a virtual machine has the capacity to handle the load of the physical computer that it will replace.

  • Increased maintenance and support costs that are proportional to the level of availability and the solutions that are used to meet availability requirements.

  • Anticipated changes to the farm, such as scaling out. When you scale out a farm, the availability solution has to be able to reflect all the changes to the farm topology. Costs will probably increase.

  • A robust detection and alerting system that provides rapid fault detection. This system can use existing fault detection tools and can include health monitoring and alerting tools such as System Center Operations Manager.

  • Integration or customization costs required to implement high availability for the farm itself or to meet broader data center requirements.

Evaluate the cost of better availability in the context of your core business needs. In many cases every organizational unit does not require the same level of availability. Consider varying levels of availability for different sites, different services, or different farms.

Referring back to the "Correlation of % availability to calendar downtime" table, five 9s of availability means that over the course of a year the system is only down for 5.26 minutes! Although you can achieve this level of availability, the cost is prohibitive for many organizations. A key decision is to determine the point where an investment in an additional nine of availability does not provide a cost benefit in relation to the effect of a failure.

Create a farm architecture that supports high availability

The following illustration shows how you can distribute and configure different parts of a SharePoint environment to increase availability across a farm. This example also shows how redundancy can address fault domains.

Note:

Our example is not comprehensive. For example it does not show all the fault domains and fault-tolerant hardware.

Examples of redundancy in a farm topology to address points of failure

A farm example that shows how redundant roles and services are used to address single points of failure.

Referring to the topology in the previous illustration, note the following:

  • The farm servers in this example can be physical computers or virtual machines that are deployed on Hyper-V host servers. The principle of identifying and responding to points of failure applies to both types of environment.

  • Four servers (W1-W4) are dedicated to serving content and this redundancy increases availability if a failure occurs in one or more servers. This level of redundancy also enables the farm to continue operations when software updates are applied.

  • Four application servers (A1-A4) increase availability for farm services and specific application components such as search. Search roles and components are redundant. For more information about search availability, see Scale search for performance and availability in SharePoint Server 2013

  • The farm database servers are redundant and database high availability can be achieved by using database mirroring or clustering.

  • In a virtual environment the virtual machines are put on separate Hyper-V host servers to eliminate a single point of failure. This approach to virtual machine placement follows best practice guidelines for availability and performance.

  • The primary database server (labeled 1) and Rack 2 (labeled 2), that contains two of the virtualization host computers, are identified as fault domains to show how your farm and infrastructure can be viewed as a collection of fault domains. This shows how you can do an in-depth analysis of your environment to develop an overall strategy and cost benefit analysis.

Other farm roles and services

Our example does not include all the roles, services, and service applications that might be running in a specific SharePoint farm. You cannot use a generic approach to high availability for everything in a SharePoint farm. Some important exclusions to using a standard approach to high availability are as follows:

  • Distributed Cache requires special considerations during failover. For more information, see Plan for the Distributed Cache service and Manage the Distributed Cache service in SharePoint Server 2013.

  • Workflow introduces improved capabilities, new requirements, and a new architecture for the workflow execution host. For more information, see Configuring a Highly Available Workflow in Workflow Manager 1.0.

  • Although service applications can run on multiple computers, which we recommend, some have unique installation and configuration requirements for high availability. The User Profile application is a well-known example.

Use fault tolerance in your high availability solution

After you design an architecture that supports highly available roles and workloads, you can use fault-tolerant components to increase availability. Fault tolerant solutions are available across the infrastructure, which includes the databases.

A fault-tolerant infrastructure

Fault tolerance is readily available for almost every hardware component in the infrastructure of a SharePoint farm. As part of your high availability design, determine the parts of the infrastructure that should be fault-tolerant from an operational and cost perspective. Just because you can make every part of the infrastructure fault-tolerant doesn't mean that you should.

Fault tolerant database servers and databases

Because the SharePoint platform and its application workloads depend on the availability and reliability of all the SharePoint databases, highly available databases are an extremely important aspect of your high availability strategy. You can use the following features as fault-tolerant solutions for database servers and databases:

  • SQL Server failover clustering (AlwaysOn Failover Cluster Instances (FCI) in SQL Server 2012)

  • SQL Server high-availability database mirroring

  • AlwaysOn Availability Groups

Important:

SQL Server 2012 AlwaysOn is available only in SQL Server Enterprise.

About AlwaysOn Failover Cluster Instances and AlwaysOn Availability Groups

A failover cluster requires shared disk storage between two computers. In a two node configuration, the computers are configured as active/passive which provides a fully redundant instance of the primary node. The passive node is only brought online when the primary node fails. The shared disk is only presented to one computer at a time. This configuration typically requires the most additional hardware. In SQL Server 2012, this type of cluster configuration is an AlwaysOn Failover Cluster Instance, and it is a specific way to install SQL Server. Because of the configuration requirements, you cannot take a standard SQL Server installation and easily change it to a Failover Cluster Instance.

An AlwaysOn Availability Group is a different technology in SQL Server 2012 (think of it as a descendant of Database Mirroring) that uses some features exposed by Windows Clustering. However, it does not require shared disk storage, and the computers in an availability group do not have to have a specialized configuration of SQL Server installed on them. After a database server is added to a Windows Cluster, it is fairly easy to enable AlwaysOn Availability Groups and then configure the availability group that you want.

In summary, any server that runs SQL Server 2012 Enterprise Edition can use AlwaysOn Availability Groups by joining a cluster and configuring the availability group. AlwaysOn failover clusters require special hardware and configuration steps to set up Failover Cluster Instances. Each of these technologies has its use for specific environments, and both are complimentary competitors. For more information about these features, see Microsoft SQL Server AlwaysOn Solutions Guide for High Availability and Disaster Recovery.

Important:

Because each SQL Server high availability option has its own features, strengths, and weaknesses, one option is not necessarily better than another. For example, in a given scenario that uses AlwaysOn Availability Groups, minimizing data lose might be better than any performance gain that AlwaysOn Failover Cluster Instances achieves. You must choose a high-availability solution that is based on your business requirements and IT infrastructure requirements.

A determining factor in selecting a SQL Server option to use is the SharePoint databases. You must understand the characteristics of the SharePoint 2013 databases. Each database may have specific requirements or constraints that will determine the SQL Server fault-tolerant solution that is appropriate and fully supported in your production environment. We recommend that you review the following articles:

  • Database types and descriptions (SharePoint 2013)

  • Supported high availability and disaster recovery options for SharePoint databases (SharePoint 2013)

SQL Server failover clustering

Failover clustering provides availability support for an instance of SQL Server on SQL Server 2008 R2 with Service Pack 1 (SP1) or SQL Server 2012.

Note:

SQL Server Failover Clustering is renamed to AlwaysOn Failover Cluster Instances (FCI) in SQL Server 2012. For simplicity, the term failover clustering applies to either SQL Server Failover Clustering in SQL Server 2008 R2 with Service Pack 1 (SP1) or AlwaysOn FCI in SQL Server 2012.

A failover cluster is a combination of one or more nodes or servers, and two or more shared disks. Although an instance of a failover cluster appears as a single computer, the instance provides failover from one node to another if the current node becomes unavailable. SharePoint 2013 can run on any combination of active and passive nodes in a cluster that SQL Server supports.

SharePoint 2013 references the cluster as a whole. Therefore, failover is automatic and seamless from the perspective of SharePoint 2013.

Note:

When either a planned or unplanned failover happens, connections are dropped and must be established again when transitioning from one cluster node to another cluster node.

For detailed information about SQL Server failover clustering, see the following articles:

  • AlwaysOn Failover Cluster Instances (SQL Server)

  • Getting Started with SQL Server 2008 Failover Clustering

SQL Server AlwaysOn Availability Groups and SQL Server Database Mirroring

The key benefit of SQL Server AlwaysOn Availability Groups and SQL Server Database Mirroring is that both provide complete or almost complete data redundancy depending on how you configure them for transaction processing. In addition to minimizing data loss, automatic failover minimizes downtime for production databases.

Important:

Although SQL Server 2012 supports database mirroring, this feature is deprecated. We recommend that you avoid using this feature in new development work. Plan to change applications that currently use this feature. Use AlwaysOn Availability Groups instead.

AlwaysOn Availability Groups

The SQL Server AlwaysOn Availability Groups feature is both a high-availability and disaster-recovery solution that provides an enterprise-level alternative to database mirroring. AlwaysOn Availability Groups supports a failover environment for one or more user databases contained in a user-defined collection. This collection, an availability group, consists of the following components:

  • Replicas, which are a discrete set of user databases called availability databases that are handled as a single unit. An availability group supports one primary replica and up to four secondary replicas.

  • A specific instance of SQL Server to host each replica and to maintain a local copy of each database that belongs to the availability group.

When an availability group fails over to a target instance or target server, all databases in the group also fail over. Because SQL Server 2012 can host multiple availability groups on a single server, you can configure AlwaysOn to fail over to SQL Server instances on different servers. This reduces the need for idle, high-performance standby servers to handle the full load of the primary server, which is one of the many benefits of availability groups.

Note:

Database issues, such as a database becoming suspect due to a loss of a data file, deletion of a database, or corruption of a transaction log do not cause a failover.

For more information about the benefits of AlwaysOn Availability Groups and an overview of AlwaysOn Availability Groups terminology, see AlwaysOn Availability Groups (SQL Server).

Database mirroring

Database mirroring provides database redundancy by keeping a mirrored copy of databases on the primary database server. Mirroring is implemented on a per-database basis and only works with databases that use the full recovery model.

Note:

There are two mirroring operating modes. One of them, high-safety mode, supports synchronous operation. In high-safety mode, when a session starts, the mirror server synchronizes the mirror database and the principal database as quickly as possible. As soon as the databases are synchronized, a transaction is written to the log on the secondary server and then replayed. (Control returns to the principal server as soon as the transaction is hardened.) The other mirroring mode is high-performance, which uses asynchronous operation to reduce transaction latency, at the cost of increased data loss.

For high-availability mirroring in a SharePoint farm, you must use high-safety mode with automatic failover. High-safety database mirroring requires three server instances: a principal, a mirror, and a witness. The witness server enables SQL Server to automatically fail over from the principal server to the mirror server. Failover from the principal database to the mirror database typically takes several seconds.

For general information about database mirroring, see Database Mirroring.

Important:

Databases that are configured to use the SQL Server FILESTREAM remote BLOB store provider cannot be mirrored.

Comparison of database availability and recovery strategies for a single farm

The choice of a SQL Server technology for high availability and disaster recovery should be based on your organization's business goals for Recovery Point Objective (RPO) and Recovery Time Objective (RTO). Although RPO and RTO are typically associated with disaster recovery, some failure events are outside the scope of a disaster but require recovery from local backup media in the primary datacenter.

Important:

Depending on the specific database, the various SharePoint 2013 databases only support specific SQL Server high availability options. For more information, see Supported high availability and disaster recovery options for SharePoint databases (SharePoint 2013).

The following table provides a general comparison of the RPO and RTO results that available SQL Server solutions achieve.

Note:

Times in the following table are for comparing database options. In practice, all times depend on the workload, data volume, and failover procedures.

RPO and RTO comparison based on database technology

SQL Server solution Potential data loss (RPO) Potential recovery time (RTO) Automatic failover Readable secondaries
Important:

SharePoint 2013does not support this configuration.

AlwaysOn Availability Group (synchronous-commit)

Zero

Seconds

Yes

0 - 2

AlwaysOn Availability Group (asynchronous-commit)

Seconds

Minutes

No

0 - 4

AlwaysOn Failover Cluster Instance

Does not apply

An FCI itself does not provide data protection. The amount of data loss depends on the storage system implementation.

Seconds to minutes

Yes

Does not apply

Database mirroring - High-safety (synchronous mode + witness server)

Zero

Seconds

Yes

Does not apply

Database mirroring - High-performance (asynchronous mode)

Seconds

Minutes

No

Does not apply

Backup, copy, restore

Hours or zero if the tail of the log can be accessed after the failure.

Hours to days

No

Not during a restore

Comparison of SQL Server Cluster, AlwaysOn Availability Group and Database mirror

SQL Server failover cluster SQL Server 2012 AlwaysOn Availability Group SQL Server high-availability mirror

Time to fail over

Cluster member takes over almost immediately after failure. A lag occurs while the cluster node spins up.

Replica takes over almost immediately after failure. A lag occurs while the secondary replica spins up.

Mirror takes over as soon as the redo queue is processed.

Transactional consistency

Yes

Yes

Yes

Transactional concurrency

Yes

Yes

Yes

Time to recovery

Shorter time to recover than an availability group.

Longer time to recover than a failover cluster, but faster recovery time than a mirrored solution.

Slightly longer time to recover than cluster or availability group.

Steps required for failover

Database nodes automatically detect a failure.

SharePoint 2013 references the cluster so that failover is seamless and automatic.

The Availability Group listener automatically detects a failure and failover is seamless and automatic.

The database automatically detects failure.

SharePoint 2013 is aware of the mirror location, if it was configured correctly so that failover is automatic.

Protection against failed storage

The failover cluster itself does not provide data protection. The amount of data loss depends on the storage system implementation. For example, a SAN environment has redundant components such as multiple file paths, RAID, and hot spares.

Protects against failed storage because the primary replica writes to the local disks on the secondary replicas.

Protects against failed storage because both the principal and mirror database servers write to local disks.

Storage types supported

Requires shared storage which is more expensive than dedicated storage.

Can use less expensive directly attached storage solutions.

Can use less expensive directly attached storage.

Location requirements

Members of the cluster must be on the same subnet.

Note:

This is not the case with SQL Server 2012.

Replicas can be on different subnets as long as latency does not cause performance issues.

Principal, mirror, and witness servers must be on the same LAN (up to 1 millisecond latency round-trip).

Recovery model

SQL Server full recovery model recommended. You can use the SQL Server simple recovery model. However, the only available recovery point if the cluster is lost will be the last full backup.

Requires SQL Server 2012 full recovery model.

Requires SQL Server full recovery model.

Performance overhead

Some decrease in performance may occur while a failover is occurring. The server will be unavailable during failover and connections are dropped and then established again on the new active node.

AlwaysOn Availability Groups introduce transactional latency because of synchronous commit on the secondary replicas. The amount of latency depends on the number of secondary replicas that have to be synchronized.

Memory and processor overhead is greater than clustering, but less than mirroring.

High-availability mirroring introduces transactional latency because it is synchronous. It also requires additional memory and processor overhead.

Operations overhead

Set up and maintained at the server level.

The operational overhead is greater than clustering and mirroring. AlwaysOn requires overhead at the level of the SQL Server database server in addition to the Windows Server level.

Note:

Server-level objects such as logons and agent jobs must be maintained manually.

If you add content databases, you have to add them to an availability group and then synchronize the primary replica to the secondary replicas.

A SharePoint farm environment requires multiple configuration steps to make sure that the SharePoint 2013 connection string is correctly associated with the availability group listener name.

The operations overhead is more than clustering. Must be set up and maintained for all databases. Reconfiguring after failover is manual.

Note:

Server-level objects such as logons and agent jobs must be maintained manually.

If you add content databases, you have to add them to the principal and then synchronize the principal to the mirror.

Configure two data centers as a single farm ("stretched" farm) to provide high availability

Some enterprises have data centers that are located in close proximity to one another, connected by high-bandwidth fiber optic links. When this environment is available it is possible to configure the two data centers as a single farm. This distributed farm topology is called a "stretched" farm.

For stretched farm architecture to work as a supported high availability solution the follow prerequisites must be met:

  • There is a highly consistent intra-farm latency of <1ms (one way), 99.9% of the time over a period of ten minutes. (Intra-farm latency is commonly defined as the latency between the front-end web servers and the database servers.)

  • The bandwidth speed must be at least 1 gigabit per second.

To provide fault tolerance in a stretched farm, use the standard best practice guidance to configure redundant service applications and databases.

The following illustration shows a stretched farm.

Stretched farm

A stretched farm topology that uses two data centers to provide high availability.

Incorporate backup and restore operations in a high availability strategy

Your high availability strategy must include the appropriate backup and restore operations to make sure that the SharePoint farm is resilient. When an incident, such as a media failure or user error occurs, you must be able to restore the affected part of the farm environment or farm data in a timely manner. An effective backup and restore solution should enable you to meet the Recovery Time Objectives (RTO) and Recovery Point Objectives (RPO) that you define.

For more information, see Backup and restore SharePoint 2013.

See also

High availability and disaster recovery concepts in SharePoint 2013
Choose a disaster recovery strategy for SharePoint 2013

Change History

Date | Description
April 02, 2013 | Added a stretched farm topology as a supported high availability option.
March 5, 2013 | Initial publication


SQL Server and storage (SharePoint 2013)

Updated: August 27, 2013

Summary: Learn how to plan for SQL Server 2008 R2 with Service Pack 1 (SP1) and SQL Server 2012 and storage configuration for SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The following articles on TechNet provide information about SQL Server and storage configuration for SharePoint 2013.

TechNet articles about SQL Server and storage configuration for SharePoint 2013

The following articles about SQL Server storage configuration for SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Overview of SQL Server in a SharePoint environment (SharePoint 2013) | Describes the relationship between SharePoint 2013 and supported versions of SQL Server and how you can interact with the databases.
 | Overview of RBS in SharePoint 2013 | Describes how SharePoint 2013 works with remote BLOB storage (RBS).
 | Plan for RBS in SharePoint 2013 | Describes the factors to consider when moving to a remote BLOB storage solution.
 | Storage and SQL Server capacity planning and configuration (SharePoint Server 2013) | Describes a process for planning storage and SQL Server capacity for a SharePoint Server 2013 deployment.

Change History

Date | Description
August 27, 2013 | Added a link to the Storage and SQL Server capacity planning and configuration article for SharePoint Server 2013.
March 19, 2013 | Initial publication


Overview of SQL Server in a SharePoint environment (SharePoint 2013)
See also

Published: March 12, 2013

Summary: Learn about the SharePoint Server 2013 relationship with SQL Server 2008 R2 with Service Pack 1 (SP1) and SQL Server 2012 and how you can interact with the databases.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

SharePoint 2013 supports several versions of SQL Server. Depending on the installed version, you can use specific features of SQL Server, such as reporting and business intelligence (BI).

Note:

SharePoint Foundation 2013 does not support BI features, which require SharePoint Server 2013.

The minimum requirements for a database server in SharePoint 2013 are SQL Server 2008 R2 with Service Pack 1 (SP1) or SQL Server 2012, 64-bit versions. Note that to use the business intelligence (BI) tools in SharePoint Server 2013 you must install SQL Server 2012 with Service Pack 1 (SP1), 64-bit version. For more information, see Hardware and software requirements for SharePoint 2013 and Software requirements for business intelligence in SharePoint Server 2013.

In this article:

  • SharePoint 2013 and the SQL Server database engine

  • Working with the SQL Server databases that support SharePoint Server 2013

  • SQL Server 2008 R2 SP1

    • SQL Server Reporting Services in SharePoint Integrated Mode

  • SQL Server 2012

    • High Availability Solutions

    • SQL Server 2012 Reporting Services (SSRS) SharePoint mode

    • Business intelligence features

    • Power Pivot for SharePoint 2013

SharePoint 2013 and the SQL Server database engine

The SharePoint 2013 application is built on the SQL Server database engine. Most content and settings in SQL Server 2008 R2 with Service Pack 1 (SP1) and SQL Server 2012 are stored in relational databases. The following table shows the databases that SharePoint 2013 uses.

Database type Description

Configuration

The Configuration database and Central Administration content database are called configuration databases. They contain data about farm settings such as the databases that are used, Internet Information Services (IIS) web sites or web applications, solutions, Web Part packages, site templates, default quota, and blocked file types. A farm can only have one set of configuration databases.

Content

Content databases store all site content:

  • Site documents, such as files in document libraries

  • List data

  • Web Part properties

  • Data for apps for SharePoint

  • User names and permissions

Each web application can contain many content databases. Each site collection can be associated with only one content database, although a content database can be associated with many site collections.

Service application

Databases for service applications store the data that service applications use.

For a full list of all of the databases that support SharePoint 2013, see Database types and descriptions (SharePoint 2013). For a graphical representation of the databases that support SharePoint 2013, see Databases that support SharePoint 20113.

Working with the SQL Server databases that support SharePoint Server 2013

The databases that support SharePoint Server 2013 are either created automatically with the SharePoint Products Configuration Wizard or by database administrators when they manually configure SharePoint Server.

Microsoft does not support directly querying or modifying the databases that support SharePoint Server 2013. In SharePoint Server 2013 the Usage and Health Data Collection database does support schema modifications.

The SQL Server databases that support SharePoint Server 2013 are subject to sizing limitations and to configuration recommendations that are not standard for SQL Server.

SQL Server 2008 R2 with Service Pack 1 (SP1)

SQL Server 2008 R2 introduced Power Pivot for SharePoint and Power Pivot for Excel 2010 for SharePoint business intelligence capability through integration with SharePoint Server 2010. Both SQL Server Analysis Services and SQL Server Reporting Services can run in the same SharePoint Server 2013 farm. SQL Server 2008 R2 with Service Pack 1 (SP1) introduced various new features and fixed many SQL Server 2008 R2 issues. For more information, see "1.0 What's New in Service Pack 1" in Microsoft SQL Server 2008 R2 SP1 Release Notes.

SQL Server Reporting Services in SharePoint Integrated Mode

SQL Server 2008 R2 Reporting Services supports two types of SharePoint integration. Full integration relies on the SharePoint integrated mode. Partial integration relies on two Web Parts, Report Explorer and Report Viewer, which you must install on a SharePoint site and point to a remote report server instance. For more information, see Overview of Reporting Services and SharePoint Technology Integration and Planning for SharePoint Integration.

Note:

Reporting Services supports SharePoint integrated mode using SharePoint Server 2013 only.

When you setup Reporting Services with SharePoint Server 2013 you create a report server. The report server is the central component of Reporting Services. This component contains two processing engines and a set of unique extensions that handle authentication, data processing, rendering, and delivery operations. When you configure a report server to run with SharePoint Server 2013 in integrated mode you must install the SQL Server 2008 R2 Reporting Services add-in on a SharePoint front-end web server. The following levels of integration are provided when you run a report server in integrated mode with SharePoint Server 2013.

  • Shared storage

  • Shared security

  • Same site access for all business documents such as reports, report models, and shared data sources

When Reporting Services runs in SharePoint integrated mode, both the SharePoint content and report server databases store content and metadata. The following table shows the report server data that each database stores.

Name of database Report server data

SharePoint content

Primary storage for the following data:

  • Published reports

  • Report models

  • Shared data sources

  • Resources

  • Properties

  • Permissions

SharePoint configuration

All report server configuration settings that you make in Central Administration including:

  • Report server URL

  • Report server Reporting Services account information

  • Information about the authentication provider that is used on the server

  • Site-level settings that limit or enable report history and logging

Report server

Internal copies of report content and metadata, which are also stored in the SharePoint content database, and the following report data:

  • Schedules

  • Subscriptions

  • Snapshots for report history or report execution

Report server Temp

Temporary data, including the following:

  • Session data

  • Temporary snapshots created for subscription processing, interactive reporting, or report caching as a performance improvement

Reporting Services data alerts are available to inform recipients of changes in report data.

For more information, see Storing and Synchronizing Report Server Content With SharePoint Databases

SQL Server 2012

SQL Server 2012 with SP1 provide business intelligence solutions for SharePoint Server 2013. The new SharePoint mode of SQL Server 2012 provides features for SQL Server Analysis Services and SQL Server Reporting Services. In addition, the SharePoint mode provides SQL Server BI features in SharePoint Server 2013.

Note:

SharePoint Foundation 2013 does not support SQL Server BI features.

High Availability Solutions

We recommend AlwaysOn Availability Groups for high availability in SQL Server 2012 Reporting Services. Other high availability solutions are AlwaysOn Failover Cluster Instances, database mirroring, and log shipping. Both AlwaysOn Availability Groups and Failover Cluster Instances solutions require and use Windows Server Failover Clustering (WSFC).

Note:

We recommend that you use AlwaysOn Availability Groups instead of database mirroring for your high availability solution with SQL Server 2012 and SharePoint Server 2013. For more information, see Overview of SQL Server High-Availability Solutions.

For more information, see AlwaysOn Availability Groups (SQL Server), and Prerequisites, Restrictions, and Recommendations for AlwaysOn Availability Groups (SQL Server).

SQL Server 2012 Reporting Services (SSRS) SharePoint mode

SharePoint mode in SQL Server 2012 Reporting Services is a SharePoint 2013 shared service that you configure in either the SharePoint Central Administration website or by using Reporting Services SharePoint mode Windows PowerShell cmdlets. For more information, see PowerShell cmdlets (Reporting Services SharePoint Mode). SharePoint mode supports SharePoint 2013 backup and restore for SQL Server Reporting Services service application and Unified Logging Service (ULS) trace logs. SharePoint mode also supports claims-based authentication. For more information, see the "SharePoint Mode" section of What's New (Reporting Services). For more information about the SharePoint Windows PowerShell cmdlets for ULS, see Logging and events cmdlets in SharePoint 2013.

SharePoint mode requires that a report server component of Reporting Services must run within a SharePoint Server farm. This means that a SharePoint application server must exist with the Reporting Services shared service installed and at least one Reporting Services service application.

For more information, see Reporting Services Report Server (SSRS) and Reporting Service Report Server (SharePoint Mode).

Business intelligence features

Note:

SharePoint Foundation 2013 does not support BI features, which require SharePoint Server 2013.

When you install SQL Server 2012 Analysis Services (SSAS) and SQL Server 2012 Reporting Services (SSRS) in a SharePoint Server 2013 farm the following business intelligence features are enabled:

  • SQL Server 2012 Power Pivot for SharePoint 2013

  • Power View for SharePoint 2013

  • Reporting Services interactive report designer that runs on Power Pivot or Analysis Services tabular data models

The xVelocity in-memory analytics engine in SQL Server 2012 supports both self-service BI and corporate BI. For more information, see xVelocity in SQL Server 2012.

For more information, see Plan for business intelligence in SharePoint Server 2013, Guidance for Using SQL Server BI Features in a SharePoint Farm, and Install SQL Server BI Features with SharePoint 2013 (SQL Server 2012 SP1).

Power Pivot for SharePoint 2013

SQL Server 2012 with SP1 is required to deploy Power Pivot for SharePoint 2013. Power Pivot for SharePoint 2013 is a SharePoint Server service application that becomes available when Analysis Services runs in SharePoint mode. This provides a server that hosts Power Pivot data in a SharePoint farm. SQL Server 2012 Analysis Services provides three modes for analysis, Multidimensional, Tabular, and Power Pivot for SharePoint. Note that each server mode is independent of the others, and each supports a type of analytical database that only runs in that modality. For more information, see Analysis Services. The server that hosts Power Pivot for SharePoint 2013 can be outside a SharePoint 2013 farm.

To configure Power Pivot for SharePoint you can use the SharePoint Central Administration website, the Power Pivot for SharePoint 2013 Configuration tool, or Windows PowerShell cmdlets. The following table lists each method and describes the process:

Power Pivot for SharePoint Configuration method | Description
SharePoint 2013 Central Administration | Provides all available options to configure the Power Pivot for SharePoint service application.
Power Pivot for SharePoint 2013 Configuration Tool | Evaluates an existing installation and determines what needs to be configured in the SharePoint farm and Power Pivot for SharePoint and then configures everything required.
Windows PowerShell cmdlets | Provides cmdlets that you can use to build Windows PowerShell script files (.ps1) and automate the configuration process for Power Pivot for SharePoint.

The Power Pivot for SharePoint 2013 add-in enables PowerPivot Gallery, Schedule Data Refresh, and the PowerPivot Management Dashboard in Central Administration. For more information, see PowerPivot for SharePoint (SSAS) and Software requirements for Power Pivot for SharePoint 2013.

See also

Supported Combinations of SharePoint and Reporting Services Components
What's New (Analysis Services)
Features Supported by the Editions of SQL Server 2012
Deprecated Database Engine Features in SQL Server 2012


Overview of RBS in SharePoint 2013
See also

Summary: Learn about how to use Remote BLOB Storage (RBS) in a SharePoint 2013 farm.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article describes how to use SharePoint 2013 together with Remote BLOB Storage (RBS) and SQL Server to optimize database storage resources.

Before you implement RBS, we highly recommend that you evaluate its potential costs and benefits. For more information and recommendations about how to use RBS in a SharePoint 2013 installation, see Plan for RBS in SharePoint 2013.

Note:

Unless otherwise specified, the information in this article is specific to RBS using the FILESTREAM provider. For guidance specific to another provider, contact the provider manufacturer.

In this article:

  • Introduction to RBS

  • RBS providers

  • Using RBS together with SharePoint 2013

Introduction to RBS

In SharePoint 2013, a binary large object (BLOB) is a large block of data stored in a database that is known by its size and location instead of by its structure — for example a Office document or a video file. By default, these BLOBs, also known as unstructured data, are stored directly in the SharePoint content database together with the associated metadata, or structured data. Because these BLOBs can be very large, it might be better to store BLOBs outside the content database. BLOBs are immutable. Therefore,, a new copy of the BLOB must be stored for each version of that BLOB. Because of this, as a database's usage increases, the total size of its BLOB data can expand quickly and grow larger than the total size of the document metadata and other structured data that is stored in the database. BLOB data can consume lots of space and uses server resources that are optimized for database access patterns. Therefore, it can be helpful to move BLOB data out of the SQL Server database, and onto commodity or content addressable storage. To do this, you can use RBS.

RBS is a SQL Server library API set that is incorporated as an add-on feature pack for SQL Server 2008 R2, SQL Server 2008 or SQL Server 2008 R2 Express. The RBS feature enables applications, such as SharePoint 2013, to store BLOBs in a location outside the content databases. Storing the BLOBs externally can reduce how much SQL Server database storage space is required. The metadata for each BLOB is stored in the SQL Server database and the BLOB is stored in the RBS store.

SharePoint 2013 uses the RBS feature to store BLOBs outside the content database. SQL Server and SharePoint 2013 jointly manage the data integrity between the database records and contents of the RBS external store on a per-database basis.

RBS is composed of the following components:

  • RBS client library

    An RBS client library consists of a managed library that coordinates the BLOB storage with SharePoint 2013, SQL Server, and RBS provider components.

  • Remote BLOB Storage provider

    An RBS provider consists of a managed library and, optionally, a set of native libraries that communicate with the BLOB store.

    An example of an RBS provider is the SQL FILESTREAM provider. The SQL FILESTREAM provider is a feature of SQL Server 2008 that enables storage of and efficient access to BLOB data by using a combination of SQL Server 2008 and the NTFS file system. For more information about FILESTREAM, see FILESTREAM Overview (http://go.microsoft.com/fwlink/p/?LinkID=166020&clcid=0x409) and FILESTREAM Storage in SQL Server 2008 (http://go.microsoft.com/fwlink/p/?LinkID=165746&clcid=0x409).

  • BLOB store

    A BLOB store is an entity that is used to store BLOB data. This can be a content-addressable storage (CAS) solution, a file server that supports Server Message Block (SMB), or a SQL Server database.

RBS providers

RBS uses a provider to connect to any dedicated BLOB store that uses the RBS APIs. SharePoint 2013 supports a BLOB storage implementation that accesses BLOB data by using the RBS APIs through such a provider. There are two kinds of RBS providers, local and remote.

The location in which an RBS provider stores the BLOB data depends on the provider that you use. In the case of the FILESTREAM provider, the data is not stored in the .mdf file. Instead, it is stored in another folder that is associated with the database.

Local RBS provider

A local provider stores the BLOBS outside the database but on the same server that is running SQL Server. You can conserve resources by using the local RBS FILESTREAM provider to put the extracted BLOB data on a different (that is, less resource-intensive) local disk. Because the BLOBs are stored in the same Filegroup as the metadata, SharePoint Server 2010 features, such as backup and restore in Central Administration, can be used.

The RBS FILESTREAM provider is available through the SQL Server Remote BLOB Store installation package from the Feature Pack for SQL Server 2008 R2. The RBS FILESTREAM provider uses the SQL Server FILESTREAM feature to store BLOBs in an additional resource that is attached to the same database and stored locally on the server. The FILESTREAM feature manages BLOBs in an SQL database by using the underlying NTFS file system.

Important:

The local FILESTREAM provider is supported only when it is used on local hard disk drives or an attached Internet Small Computer System Interface (iSCSI) device. You cannot use the local RBS FILESTREAM provider on remote storage devices such as network attached storage (NAS).

Remote RBS provider

A remote RBS provider stores the BLOBs on a separate server. This is typically on a separate volume on the same network as the database server.

Because the BLOBs are not stored in the same Filegroup with the metadata, some SharePoint 2013 features — for example, backup and restore in Central Administration — cannot be used with remote RBS providers. The metadata and the BLOBs must be managed separately. For more information about what features can be used with the provider, contact the provider manufacturer.

Using RBS together with SharePoint 2013

SharePoint 2013 supports the FILESTREAM provider that is included in the SQL Server Remote BLOB Store installation package from the Feature Pack for SQL Server Remote BLOB Store installation package from the Feature Pack for SQL Server 2008 R2. This version of RBS is available at Microsoft® SQL Server® 2008 R2 Feature Pack (http://go.microsoft.com/fwlink/p/?LinkID=177388). Be aware that this is the only version of RBS that is supported by SharePoint 2013. Earlier versions are not supported. Third-party RBS providers can also be used with the RBS APIs to create a BLOB storage solution that is compatible with SharePoint 2013.

In SharePoint 2013, site collection backup and restore and site import or export will download the file contents and upload them back to the server regardless of which RBS provider is being used. This process is known as a deep copy. However, the FILESTREAM provider is the only provider that is currently supported for SharePoint 2013 farm database backup and restore operations.

To use RBS, you must install an RBS provider on each server where SharePoint 2013 is installed and on each database server in the topology. The provider includes a set of DLLs that implement methods for the RBS APIs and perform the actual operation of externalizing the BLOBs.

To run RBS on a remote server, you must be running SQL Server 2008 R2 Enterprise on the server that is running SQL Server where the metadata is stored in the database.

If you plan to store BLOB data in an RBS store that differs from your SharePoint 2013 content databases, you must run SQL Server 2008 with SP1 and Cumulative Update 2. This is true for all RBS providers.

The FILESTREAM provider that is recommended for upgrading from stand-alone installations of Windows SharePoint Services 3.0 that have content databases that are over 4 gigabytes (GB) to SharePoint 2013 associates data locally with the current content database, and does not require SQL Server Enterprise.

Important:

Although RBS can be used to store BLOB data externally, accessing or changing those BLOBs is not supported using any tool or product other than SharePoint 2013. All access must occur by using SharePoint 2013 only.

See also

FILESTREAM Overview
FILESTREAM Storage in SQL Server 2008
Remote BLOB Store Provider Library Implementation Specification


Plan for RBS in SharePoint 2013

Published: October 16, 2012

Summary: Decide whether to use Remote BLOB Storage (RBS) in a SharePoint 2013 environment.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article provides information to help you decide whether to use Remote BLOB Storage (RBS) in a SharePoint 2013 environment, and if you use RBS, to understand the benefits and costs of using RBS in your environment.

Important:

RBS does not increase the storage limits of content databases. All limitations still apply to RBS-enabled content databases. RBS is intended to lower storage costs by allowing you to store large read-intensive BLOBs on less expensive drives.

In SharePoint 2013, a binary large object (BLOB) is a file, such as a Office 2013 document or a video file. By default, these BLOBs, also named unstructured data, are stored inline in the SharePoint content database together with the metadata, or structured data. Because BLOBs can be very large, it can be helpful to move BLOB data out of the SQL Server database, and onto commodity or content addressable storage. To do this, you can use RBS.

Note:

Unless otherwise specified, the information in this article is specific to RBS using the FILESTREAM provider. For guidance specific to another provider, contact the provider manufacturer.

For more information about RBS including information about RBS providers, we highly recommend that you see Overview of RBS in SharePoint 2013.

In this article:

  • Limitations of RBS

  • Most optimal use of RBS

  • Least optimal use of RBS

  • Implications of using RBS in different site scenarios

  • Benefits and costs of using RBS

  • Benefits and costs of using RBS with the FILESTREAM provider

  • Implications of using RBS over the IT life cycle

  • Evaluate provider options

Limitations of RBS

Each RBS provider will have different capabilities and limitations. The FILESTREAM provider has the following limitations:

  • RBS has specific content database size limitations for specific scenarios. For more information about these limitations, see the "Content database limits" section in Content database limits.

  • Encryption is not supported on BLOBs, even if Transparent Data Encryption is enabled.

  • RBS does not support using data compression.

  • Support for database mirroring and log shipping is altered. For more information, see Evaluate provider options later in this article.

To determine the capabilities and limitations of third-party providers, contact the provider manufacturer.

Most optimal use of RBS

Because RBS is a solution created for a specific set of conditions, there is an optimal use of RBS in which the benefits outweigh the costs. The optimal environment for using RBS is an environment where the following is true:

  • You want to store fewer large BLOBs (256 KB or larger) for read-intensive or read-only access.

  • The resources on the computer that is running SQL Server might become a performance bottleneck.

  • The expense of high-cost drive space is greater than the expense of increased IT operations complexity that might be introduced by using RBS.

Least optimal use of RBS

RBS is not a good solution for all environments. The costs will outweigh the benefits in some circumstances. The least optimal environment for using RBS would be an environment where the following is true:

  • You want to store many small BLOBs (256 KB or less) for write-intensive access.

  • The resources on the computer that is running SQL Server are not a performance bottleneck.

  • The expense of increased IT operations complexity that might be introduced by using RBS is greater than high-cost drive space.

Under these conditions, even a content database less than 200 GB will produce a noticeable performance bottleneck as the small BLOBs are frequently accessed for writing. This occurs because the database contains the metadata for the BLOBs. As the metadata is changed, new rows are added to the table in the database. This can cause the table to quickly grow very large. Large tables can decrease performance.

Although the presence of many small BLOBs can decrease performance, the cost of storage is usually the most important consideration when you evaluate RBS. The predicted decrease in performance is usually an acceptable trade-off for the cost savings in storage hardware.

Implications of using RBS in different site scenarios

You should evaluate the implications of using RBS in different site scenarios. Because RBS was created to resolve specific problems, RBS might not perform equally well in all scenarios. The scenarios in the following sections are examples.

Team sites

If you are considering using RBS with team sites or other highly-collaborative sites, and the sites typically contain documents smaller than 256 KB, you will not see significant gains by using RBS. Moreover, by using versioning, you can cause the content database to grow very quickly if documents are being revised frequently.

Important:

The use of RBS-enabled content databases larger than 4TB with collaboration sites is not supported. You cannot upload any document larger than 2GB to an RBS-enabled content database. For more information about RBS limits, see the "Content databases" section is Software boundaries and limits for SharePoint 2013.

Record centers

RBS works well for record centers and other archive sites. Because these sites are mostly read-only and do not use versioning, you can store lots of data in the RBS store.

Benefits and costs of using RBS

This section discusses the benefits and costs of using RBS. These benefits and costs usually apply regardless of which provider you use. For more detailed information about how to use the FILESTREAM RBS provider, see Benefits and costs of using RBS with the FILESTREAM provider later in this article. For more detailed information about how to use third-party RBS providers, contact the provider manufacturer.

Benefits

RBS was designed to move the storage of BLOBs from databases on database servers to directories on commodity storage solutions. Therefore, under the specific environments that RBS was intended to be used in, you can experience performance or cost benefits. By using lower-priced storage instead of more expensive storage on a databases server, you can save on costs. RBS saves storage resources when there are fewer large BLOBs. When there are many smaller files, there is no benefit.

Costs

RBS will increase operational costs because the IT staff must perform additional tasks when they back up or restore the content. Large RBS stores can slow down tasks such as backup or restore, updating the environment, upgrading to a newer version of SharePoint 2013, or migrating the SharePoint sites to another environment. These costs should be considered when you evaluate whether to use RBS.

Benefits and costs of using RBS with the FILESTREAM provider

This section discusses the benefits and costs of using the FILESTREAM provider. These benefits and costs might not be relevant for another provider. For information about how to use third-party RBS providers, contact the provider manufacturer.

Benefits

Microsoft currently supports only the FILESTREAM RBS provider with SharePoint 2013. When you use this provider, the backup and restore features in SharePoint 2013 also back up and restore the BLOBs and the structured data in the content database without requiring you to do additional work. The FILESTREAM provider also supports Internet Small Computer System Interface (iSCSI) connected storage devices.

Costs

Using the FILESTREAM provider might increase operational costs because the IT staff must perform additional tasks. Large RBS stores can slow down tasks such as backup or restore, updating the environment, upgrading to a newer version of SharePoint 2013, or migrating the SharePoint sites to another environment. These costs should be considered when you evaluate whether to use RBS.

Implications of using RBS over the IT life cycle

You should evaluate the implications of using RBS for the whole life cycle of the environment. What might be a good idea for normal operations, such as having large BLOB stores, might present challenges during backup and restore or during an upgrade. By evaluating the effects of using RBS and BLOB store size on the whole life cycle, you can avoid potential problems later.

For example, using a remote RBS provider will require increased IT operations complexity and some cost increases. This is because the content database and the BLOB store must be backed up in synchronization to maintain references consistency.

Another example is that in some cases upgrade operations will enumerate and possibly change each BLOB regardless of where the BLOBs are stored.

Setup

Using RBS can add some complexity to set up because you must install and configure the RBS provider on all Web servers in the farm. For more information about how to set up RBS, see Install and configure RBS in a SharePoint 2013 farm.

Normal operations

You should consider the average file size and the kind of file access during normal operations. Although using RBS with files larger than 1 MB can improve I/O and processor performance, using RBS with files smaller than 256 KB might decrease overall performance. Storing the BLOBs inline in the content database is more efficient with smaller files. For more information about performance of RBS, see Managing Unstructured Data with SQL Server 2008 (http://go.microsoft.com/fwlink/p/?LinkId=223909).

You should also consider how BLOB content will be used. If users will most frequently read the content but not revise it, RBS can provide performance gains. However, if users will frequently revise the content, using RBS will decrease performance. This is because extensive versioning will cause significant growth in both the metadata in the content database and the size of the BLOB store.

You should weigh any storage cost benefits against potential operational cost increases.

Monitoring and optimization

Using RBS also adds some operations overhead because there are several performance counters that are added to monitor RBS. Several options are available to tune RBS performance. For more information, see Maintain RBS in SharePoint Server 2013.

Database maintenance

You can achieve better efficiency and speed in database index defragmentation and statistics operations when you use RBS. Also regular consistency checks, such as DBCC checks, are also significantly faster when you use RBS.

However, regular database maintenance will become more complex because you must configure and use the RBS Maintainer to maintain link-level consistency between the metadata and the BLOB store and to perform cleanup of orphaned BLOBs. For more information, see Maintain RBS in SharePoint Server 2013.

Backup and restore

If you use the local FILESTREAM provider with RBS, you can use built-in SharePoint tools to back up and restore. These operations back up and restore both the metadata and the BLOB store. If you use the remote RBS provider, you must carefully coordinate the backup and restore processes. This is because the backup and restore processes involve both the metadata and the BLOB store. You should take this into account when planning the RBS configuration. Not all RBS providers support backup and restore of BLOB data. You must check with the manufacturer of the provider to confirm support.

You cannot use Microsoft System Center Data Protection Manager to back up and restore content that is stored in the RBS stores.

Upgrade and update

Under some circumstances, an upgrade, or even applying software updates, can enumerate and iterate through each object to include BLOB data regardless of where that data is stored. Therefore, upgrade operations will be similar in duration whether inline or remote BLOBs are used.

Evaluate provider options

RBS requires a provider that connects the RBS APIs and SQL Server. SQL Server 2008 Express and Microsoft SQL Server 2008 R2 Express include the FILESTREAM provider.

Important:

RBS can be run on the local computer that is running SQL Server 2008 R2, SQL Server 2008 or SQL Server 2008 R2 Express. To run RBS on a remote server, you must be running SQL Server 2008 R2 Enterprise. SharePoint 2013 requires you to use the version of RBS that is included with the SQL Server Remote BLOB Store installation package from the Feature Pack for SQL Server 2008 R2. Earlier versions of RBS will not work with SharePoint 2013. In addition, RBS is not supported in SQL Server 2005.

BLOBs can be kept on commodity storage such as direct-attached storage (DAS) or network attached storage (NAS), as supported by the provider. The FILESTREAM provider is supported by SharePoint 2013 when it is used on local hard disk drives or iSCSI drives only. You cannot use RBS with FILESTREAM on remote storage devices, such as NAS.

The following table summarizes FILESTREAM benefits and limitations.

Operational requirement | With the FILESTREAM provider | Without the FILESTREAM provider
SQL Server integrated backup and recovery of the BLOB Store | Yes | Maybe 1
Scripted migration to BLOBs | Yes | Yes
Supports mirroring | No | No
Log shipping | Yes | Yes, with provider implementation
Database snapshots | No2 | No2
Geo replication | Yes | No
Encryption | NTFS only | No
Local drives supported | Yes | Yes, with provider implementation
Network Attached Storage (NAS) | Only supported by SharePoint 2013 with iSCSI and if TTFB is less than 20ms. | Yes, with provider implementation
Direct Attached Storage (DAS) | Not supported by SharePoint 2013 | Yes, with provider implementation
iSCSI Drives supported | Yes | Yes, with provider implementation

1Only if the RBS provider that you are using does it.

2If the RBS provider that you are using does not support snapshots, you cannot use snapshots for content deployment or backup. The FILESTREAM provider does not support snapshots.

If the FILESTREAM provider is not practical for the environment, you can purchase a supported third-party provider. In this case, you should use the following criteria when you evaluate a provider:

  • Backup and restore capability

  • Tested disaster recovery

  • Deployment and data migration

  • Performance impact

  • Long-term administrative costs

Important:

We do not recommend that you develop a provider unless you are an independent software vendor (ISV) that has significant development experience in designing storage solutions.


Storage and SQL Server capacity planning and configuration (SharePoint Server 2013)
See also

Published: August 27, 2013

Summary: Learn how to plan and configure the storage and database tier for SQL Server in SharePoint 2013.

Applies to: SharePoint Server 2013

The capacity planning information that we provide contains guidelines to help you plan and configure the storage and SQL Server database tier in a SharePoint Server 2013 environment. This information is based on testing performed at Microsoft on live properties. However, your results may vary based on the equipment you use and the features and functionality that you implement for your sites.

Note:

Performance and capacity tests in this article use SQL Server 2008 R2 with Service Pack 1 (SP1) and SharePoint Server 2013. The test results are the same as in SharePoint Server 2010, except for the Search service test data. The test data for the Search service in SharePoint Server 2013 has changed and is shown in the appropriate sections in this article.

Although tests were not run on SQL Server 2012, you can use these test results as a guide to help you plan for and configure the storage and SQL Server database tier in a SharePoint Server 2013 environment. For training about how to configure and tune SQL Server 2012, see SQL Server 2012 for SharePoint Server 2013.

Because SharePoint Server often runs in environments in which databases are managed by separate SQL Server database administrators, this document is intended for joint use by SharePoint Server farm implementers and SQL Server database administrators. It assumes significant understanding of both SharePoint Server and SQL Server.

This article assumes that you are familiar with the concepts that are presented in Capacity management and sizing for SharePoint Server 2013.

Design and configuration process for SharePoint 2013 storage and database tier

We recommend that you break the storage and database tier design process into the following steps. Each section provides detailed information about each design step, including storage requirements and best practices:

  1. Gather storage and SQL Server space and I/O requirements

  2. Choose SQL Server version and edition

  3. Design storage architecture based on capacity and I/O requirements

  4. Estimate memory requirements

  5. Understand network topology requirements

  6. Configure SQL Server

  7. Validate and monitor storage and SQL Server performance

  8. SQL Server 2012 for SharePoint Server 2013

Gather storage and SQL Server space and I/O requirements

Several SharePoint Server 2013 architectural factors influence storage design. The key factors are: the amount of content, enabled features, deployed service applications, number of farms, and availability requirements.

Before you start to plan storage, you should understand the databases that SharePoint Server 2013 can use.

In this section:

  • Databases used by SharePoint 2013

  • Understand SQL Server and IOPS

  • Estimate core storage and IOPS needs

  • Estimate service application storage needs and IOPS

  • Determine availability needs

Databases used by SharePoint 2013

The databases that are installed with SharePoint 2013 depend on the features that are being used in the environment. All SharePoint 2013 environments rely on the SQL Server system databases. This section provides a summary of the databases installed with SharePoint 2013. For detailed database information, see Database types and descriptions (SharePoint 2013) and Databases that support SharePoint 2013.

Note:

Some SharePoint 2013, SQL Server Database Engine, and SQL Server Reporting Services (SSRS) databases have specific location recommendations or requirements. For information about these database locations, see Database types and descriptions (SharePoint 2013).

Product version and edition Databases

SharePoint Foundation 2013

Configuration

Central Administration content

Content (one or more)

App Management Service

Business Data Connectivity

Search service application:

  • Search administration

  • Analytics Reporting (one or more)

  • Crawl (one or more)

  • Link (one or more)

Secure Store Service

Subscription Settings Service Application (if it is enabled through Windows PowerShell)

Usage and Health Data Collection Service

Word Conversion Service

SharePoint Server 2013

Machine Translation Services

Managed Metadata Service

PerformancePoint Services

PowerPivot Service (Power Pivot for SharePoint 2013)

Project Server Service

State Service

User Profile Service application:

  • Profile

  • Synchronization

  • Social tagging

Word Automation services

If you are integrating further with SQL Server, your environment may also include additional databases, as in the following scenarios:

  • SQL Server 2012 Power Pivot for SharePoint 2013 can be used in a SharePoint Server 2013 environment that includes SQL Server 2008 R2 Enterprise Edition and SQL ServerAnalysis Services. If in use, you must also plan to support the Power Pivot application database, and the additional load on the system. For more information, see Plan a PowerPivot deployment in a SharePoint farm and the SQL Server PRO article Understanding PowerPivot and Power View in Microsoft Excel 2013.

  • The SQL Server 2008 R2 Reporting Services (SSRS) plug-in can be used with any SharePoint 2013 environment. If you are using the plug-in, plan to support the two SQL Server 2008 R2 Reporting Services databases and the additional load that is required for SQL Server 2008 R2 Reporting Services.

Understand SQL Server and IOPS

On any server that hosts a SQL Server instance, it is very important that the server achieve the fastest response possible from the I/O subsystem.

More and faster disks or arrays provide sufficient I/O operations per second (IOPS) while maintaining low latency and queuing on all disks.

You cannot add other types of resources, such as CPU or memory, to compensate for slow response from the I/O subsystem. However, it can influence and cause issues throughout the farm. Plan for minimal latency before deployment, and monitor your existing systems.

Before you deploy a new farm, we recommend that you benchmark the I/O subsystem by using the SQLIO disk subsystem benchmark tool. Note that this tool works on all Windows Server versions with all versions of SQL Server. For more information, see SQLIO Disk Subsystem Benchmark Tool.

Stress testing also provides valuable information for SQL Server. For information about how to use the SQLIOSim utility and SQLIO for stress testing, see the TechNet video Stress testing using SQLIOSIM and SQLIO and How to use the SQLIOSim utility to simulate SQL Server activity on a disk subsystem.

For detailed information about how to analyze IOPS requirements from a SQL Server perspective, see Analyzing I/O Characteristics and Sizing Storage Systems for SQL Server Database Applications.

Estimate core storage and IOPS needs

Configuration and content storage and IOPS are the base layer that you must plan for in every SharePoint Server 2013 deployment.

Configuration storage and IOPS

Storage requirements for the Configuration database and the Central Administration content database are not large. We recommend that you allocate 2 GB for the Configuration database and 1 GB for the Central Administration content database. Over time, the Configuration database may grow beyond 1 GB. It does not grow quickly — it grows by approximately 40 MB for each 50,000 site collections.

Transaction logs for the Configuration database can be large. Therefore, we recommend that you change the recovery model for the database from full to simple.

Note:

If you want to use SQL Server database mirroring to provide availability for the Configuration database, you must use the full recovery model.

IOPS requirements for the Configuration database and Central Administration content database are minimal.

Content storage and IOPS

Estimating the storage and IOPS required for content databases is not a precise activity. In testing and explaining the following information, we intend to help you derive estimates to use to determine the initial size of your deployment. However, when your environment is running, we expect that you'll revisit your capacity needs based on the data from your live environment.

For more information about our overall capacity planning methodology, see Capacity management and sizing for SharePoint Server 2013.

Formula to estimate content database storage

The following process describes how to approximately estimate the storage required for content databases, without considering log files:

  1. Use the following formula to estimate the size of your content databases:

    Database size = ((D × V) × S) + (10 KB × (L + (V × D)))

    Note:

    The value, 10 KB, in the formula is a constant that approximately estimates the amount of metadata required by SharePoint Server 2013. If your system requires significant use of metadata, you may want to increase this constant.

  2. Calculate the expected number of documents. This value is known as D in the formula.

    How you calculate the number of documents will be determined by the features that you are using. For example, for My Sites or collaboration sites, we recommend that you calculate the expected number of documents per user and multiply by the number of users. For records management or content publishing sites, you may calculate the number of documents that are managed and generated by a process.

    If you are migrating from a current system, it may be easier to extrapolate your current growth rate and usage. If you are creating a new system, review your existing file shares or other repositories and estimate based on that usage rate.

  3. Estimate the average size of the documents that you'll be storing. This value is known as S in the formula. It may be worthwhile to estimate averages for different types or groups of sites. The average file size for My Sites, media repositories, and different department portals can vary significantly.

  4. Estimate the number of list items in the environment. This value is known as L in the formula.

    List items are more difficult to estimate than documents. We generally use an estimate of three times the number of documents (D), but this will vary based on how you expect to use your sites.

  5. Determine the approximate number of versions. Estimate the average number of versions any document in a library will have. This value will usually be much lower than the maximum allowed number of versions. This value is known as V in the formula.

    The value of V must be above zero.

As an example, use this formula and the characteristics in the following table to estimate the required storage space for data files in a content database for a collaboration environment. The result is that you need approximately 105 GB.

Input | Value
Number of documents (D) | 200,000 Calculated by assuming 10,000 users times 20 documents
Average size of documents (S) | 250 KB
List items (L) | 600,000
Number of non-current versions (V) | 2 Assuming that the maximum versions allowed is 10

Database size = (((200,000 x 2)) × 250) + ((10 KB × (600,000 + (200,000 x 2))) = 110,000,000 KB or 105 GB

Note:

Efficient File I/O in SharePoint Server 2013 is a storage method in which a file is split into pieces that are stored and updated separately. These pieces are streamed together when a user requests the file. This increases the I/O performance but it normally does not increase the file size. However, small files can see a small increase in the disk storage that is required.

Features that influence the size of content databases

The following SharePoint Server 2013 features can significantly affect the size of content databases:

  • Recycle bins Until a document is fully deleted from both the first stage and second stage recycle bin, it occupies space in a content database. Calculate how many documents are deleted each month to determine the effect of recycle bins on the size of content databases. For more information, see Configure Recycle Bin settings in SharePoint Server 2013.

  • Auditing Audit data can quickly compound and use large amounts of space in a content database, especially if view auditing is turned on. Rather than letting audit data grow without constraint, we recommend that you enable auditing only on the events that are important to meet regulatory needs or internal controls. Use the following guidelines to estimate the space that you must reserve for auditing data:

    • Estimate the number of new auditing entries for a site, and multiply this number by 2 KB (entries generally are limited to 4 KB, with an average size of about 1 KB).

    • Based on the space that you want to allocate, determine the number of days of audit logs you want to keep.

Note:

Using Office Web Apps with SharePoint Server 2013 no longer affects the size of the content database. If you plan to deploy Office Web Apps in your SharePoint Server 2013 farm, you must install Office Web Apps Server. For more information, see Use Office Web Apps with SharePoint 2013

Estimate content database IOPS requirements

IOPS requirements for content databases vary significantly based on how your environment is being used, available disk space, and the number of servers that you have. In general, we recommend that you compare the predicted workload in your environment to one of the solutions that we tested. For more information, see Performance and capacity test results and recommendations (SharePoint Server 2013).

In tests, we found that the content databases tend to range from 0.05 IOPS/GB to around 0.2 IOPS/GB. We also found that a best practice is to increase the top-end to 0.5 IOPS/GB. This is more than necessary and can be much more than you'll need in your environment. Note that if you use mirroring, this results in much more IO than the primary content databases. Simply be aware that the mirrored content databases are never lightweight.

Estimate service application storage needs and IOPS

After you estimate content storage and IOPS needs, you must determine the storage and IOPS required by the service applications that are being used in your environment.

SharePoint Server 2013 service application storage and IOPS requirements

To estimate the storage requirements for the service applications in the system, you must first be aware of the service applications and how you'll use them. Service applications that are available in SharePoint Server 2013 and that have databases are listed in the following tables. The storage and IOPs data for all of the service applications in SharePoint Server 2013 remains the same as in SharePoint Server 2010 except for the Search service application and User Profile service application.

Search service application storage and IOPS requirements

Database | Scaling | Disk IOPS | Disk size | 10M items | 100M items
Crawl | One DB per 20M items SQL IOPS: 10 per 1 DPS | Medium/High | Medium | 15GB 2GB log | 110GB 50GB log
Link | One DB per 60M items SQL IOPS: 10 per 1M items | Medium | Medium | 10GB 0.1GB log | 80GB 5GB log
Analytics Reporting | Split when reaching 100-300GB | Medium | Medium | Usage dependent | Usage dependent
Search Administration | One DB | Low | Low | 0.4GB 1GB log | 1GB data 2GB log

Service application storage requirements and IOPS recommendations

Service application Size estimation recommendation

User Profile

The User Profile service application is associated with three databases: Profile, Synchronization, and Social Tagging.

Note:

The testing for the User Profile database storage requirements and IOPS recommendations is not yet complete. Check back for additional information.

For User Profile database information, see Database types and descriptions (SharePoint 2013).

Managed Metadata Service

The Managed Metadata service application has one database. The size of the database is affected by the number of content types and keywords used in the system. Many environments will include multiple instances of the Managed Metadata service application.

Secure Store Service

The size of the Secure Store service application database is determined by the number of credentials in the store and the number of entries in the audit table. We recommend that you allocate 5 MB for each 1,000 credentials for it. It has minimal IOPS.

State Service

The State service application has one database. We recommend that you allocate 1 GB for it. It has minimal IOPS.

Word Automation Services

The Word Automation service application has one database. We recommend that you allocate 1 GB for it. It has minimal IOPS.

PerformancePoint Services

The PerformancePoint service application has one database. We recommend that you allocate 1 GB for it. It has minimal IOPS.

Business Data Connectivity service

The Business Data Connectivity service application has one database. This database is small and significant growth is unlikely. It has minimal IOPS.

App Management

The App Management service application has one database. This database is small and significant growth is unlikely. It has minimal IOPS.

Word Automation Services

The Word Automation Services service application has one database. This database is small and significant growth is unlikely. It has minimal IOPS.

PerformancePoint Services

The PerformancePoint Services has one database. This database is small and significant growth is unlikely. It has minimal IOPS.

Power Pivot

The Power Pivot Service application has one database. This database is small and has no significant I/O impact. We recommend that you use the same IOPS as the SharePoint content database. Note that content databases have significantly higher I/O requirements than the Power Pivot service application database.

Determine availability needs

Availability is how much a SharePoint Server 2013 environment is perceived by users to be available. An available system is a system that is resilient — that is, incidents that affect service occur infrequently, and timely and effective action is taken when they do occur.

Availability requirements can significantly increase your storage needs. For detailed information, see Create a high availability architecture and strategy for SharePoint 2013. Also, see the SQL Server 2012 white paper AlwaysOn Architecture Guide: Building a High Availability and Disaster Recovery Solutions by Using AlwaysOn Availability Groups

Choose SQL Server version and edition

We recommend that you consider running your environment on the Enterprise Edition of SQL Server 2008 R2 with SP1 or SQL Server 2012 to take advantage of the additional performance, availability, security, and management capabilities that these versions provide. For more information about the benefits of SQL Server 2008 R2 with SP1 or SQL Server 2012 Enterprise Edition, see Features Supported by the Editions of SQL Server 2012 and Features Supported by the Editions of SQL Server 2008 R2.

In particular, you should consider your need for the following features:

  • Backup compression Backup compression can speed up any SharePoint backup, and is available in SQL Server 2008 R2 with Service Pack 1 (SP1) or SQL Server 2012 Enterprise Edition or Standard edition. By setting the compression option in your backup script, or by configuring the server that is running SQL Server to compress by default, you can significantly reduce the size of your database backups and shipped logs. For more information, see Backup Compression (SQL Server) for SQL Server 2008 R2 with SP1 and Backup Compression (SQL Server) for SQL Server 2012.

    Note:

    SQL Server data compression is not supported for SharePoint 2013, except for the Search service application databases.

  • Transparent data encryption If your security requirements include the need for transparent data encryption, you must use SQL Server Enterprise Edition.

  • Content deployment If you plan to use the content deployment feature, consider SQL Server Enterprise Edition so that the system can take advantage of database snapshots.

    Note:

    If you are using a Remote BLOB storage provider that does not support database snapshots, you can't use snapshots for content deployment or backup.

  • Remote BLOB storage If you want to take advantage of remote BLOB storage to a database or location outside the files associated with each content database, you must use SQL Server 2008 R2 with SP1 or SQL Server 2012 Enterprise Edition.

  • Resource governor Resource Governor is a technology introduced in SQL Server 2008 to enable you to manage SQL Server workloads and resources by specifying limits on resource consumption by incoming requests. Resource Governor enables you to differentiate workloads and allocate CPU and memory as they are requested, based on the limits that you specify. It is available only in SQL Server 2008 R2 with SP1 Enterprise edition. For more information about how to use Resource Governor, see Managing SQL Server Workloads with Resource Governor for SQL Server 2008 R2 with SP1 or Managing SQL Server Workloads with Resource Governor for SQL Server 2012.

    We recommend that you use Resource Governor with SharePoint Server 2013 to:

    • Limit the amount of SQL Server resources that the web servers targeted by the search crawl component consume. As a best practice, we recommend limiting the crawl component to 10 percent CPU when the system is under load.

    • Monitor how many resources are consumed by each database in the system — for example, you can use Resource Governor to help you determine the best placement of databases among computers that are running SQL Server.

  • Power Pivot for SharePoint 2013 Enables users to share and collaborate on user-generated data models and analysis in Excel and in the browser while automatically refreshing those analyses. It is part of SQL Server 2008 R2 Analysis Services (SSAS) and SQL Server 2012 SP1 Analysis Services (SSAS) Enterprise Edition.

Design storage architecture based on capacity and I/O requirements

The storage architecture and disk types that you select for your environment can affect system performance.

In this section:

  • Choose a storage architecture

  • Choose disk types

  • Choose RAID types

Choose a storage architecture

SharePoint Server 2013 supports Direct Attached Storage (DAS), Storage Area Network (SAN), and Network Attached Storage (NAS) storage architectures, although NAS is only supported for use with content databases that are configured to use remote BLOB storage. Your choice depends on factors within your business solution and your existing infrastructure.

Any storage architecture must support your availability needs and perform adequately in IOPS and latency. To be supported, the system must consistently return the first byte of data within 20 milliseconds (ms).

Direct Attached Storage (DAS)

DAS is a digital storage system that is directly attached to a server or workstation, without a storage network in between. DAS physical disk types include Serial Attached SCSI (SAS) and Serial Attached ATA (SATA).

In general, we recommend that you choose a DAS architecture when a shared storage platform can't guarantee a response time of 20 ms and sufficient capacity for average and peak IOPS.

Storage Area Network (SAN)

SAN is an architecture to attach remote computer storage devices (such as disk arrays and tape libraries) to servers in such a way that the devices appear as locally attached to the operating system (for example, block storage).

In general, we recommend that you choose a SAN when the benefits of shared storage are important to your organization.

The benefits of shared storage include the following:

  • Easier to reallocate disk storage between servers.

  • Can serve multiple servers.

  • No limitations on the number of disks that can be accessed.

Network Attached Storage (NAS)

A NAS unit is a self-contained computer that is connected to a network. Its sole purpose is to supply file-based data storage services to other devices on the network. The operating system and other software on the NAS unit provide the functionality of data storage, file systems, and access to files, and the management of these functionalities (for example, file storage).

Note:

NAS is only supported for use with content databases that are configured to use remote BLOB storage (RBS). Any network storage architecture must respond to a ping within 1 ms and must return the first byte of data within 20 ms. This restriction does not apply to the local SQL Server FILESTREAM provider, because it only stores data locally on the same server.

Some confusion exists about if you use the Internet Small Computer System Interface (iSCSI) and assume that it is a NAS protocol. If you access this iSCSI storage through the Common Internet File System (CFIS), it is a NAS protocol. This means that you can't use this storage with content databases if they aren't configured to use RBS. If however, you access this iSCSI storage through a locally attached hard disk, it is considered a SAN architecture. This means that you can use it with NAS.

Choose disk types

The disk types that you use in the system can affect reliability and performance. All else being equal, larger drives increase mean seek time. SharePoint Server 2013 supports the following types of drives:

  • Small Computer System Interface (SCSI)

  • Serial Advanced Technology Attachment (SATA)

  • Serial-attached SCSI (SAS)

  • Fibre Channel (FC)

  • Integrated Device Electronics (IDE)

  • Solid State Drive (SSD) or Flash Disk

    For information about using solid state drives for storage in SQL Server, see the SQL Server PRO article Using Solid State Disks in SQL Server Storage Solutions.

Choose RAID types

RAID (Redundant Array of Independent Disks) is often used to both improve the performance characteristics of individual disks (by striping data across several disks) and to provide protection from individual disk failures.

All RAID types are supported for SharePoint Server 2013. However, we recommend that you use RAID 10 or a vendor-specific RAID solution that has equivalent performance.

When you configure a RAID array, make sure that you align the file system to the offset that is supplied by the vendor.

For more information about provisioning RAID for SQL Server 2008 R2 with SP1 and SQL Server 2012, see RAID.

Estimate memory requirements

The memory that is required for SharePoint Server 2013 is directly related to the size of the content databases that you are hosting on a server that is running SQL Server.

As you add service applications and features, your requirements are likely to increase. The following table gives guidelines for how much memory we recommend.

Note:

Our definitions of small and medium deployments are those that are described in the Reference architectures section of the article Capacity management and sizing overview for SharePoint Server 2013.

Combined size of content databases | RAM recommended for computer running SQL Server
Minimum for small production deployments | 8 GB
Minimum for medium production deployments | 16 GB
Recommendation for up to 2 terabytes | 32 GB
Recommendation for the range of 2 terabytes to 5 terabytes | 64 GB
Recommendation for more than 5 terabytes | Additional RAM over 64 GB can improve SQL Server caching speed

Note:

These values are higher than those recommended as the minimum values for SQL Server because of the distribution of data required for a SharePoint Server 2013 environment. For more information about SQL Server system requirements, see Hardware and Software Requirements for Installing SQL Server 2012.

For information about SQL Server capacity limits and specifications see Compute Capacity Limits by Edition of SQL Server and Maximum Capacity Specifications for SQL Server.

Other factors that may influence the memory that is required include the following:

  • The use of SQL Server mirroring.

  • The frequent use of files larger than 15 megabytes (MB).

Understand network topology requirements

Plan the network connections within and between farms. We recommend that you use a network that has low latency.

The following list provides some best practices and recommendations:

  • All servers in the farm should have LAN bandwidth and latency to the server that is running SQL Server. Latency should be no greater than 1 millisecond.

  • We do not recommend a wide area network (WAN) topology in which a server that is running SQL Server is deployed remotely from other components of the farm over a network that has latency greater than 1 ms., because this topology has not been tested.

  • Plan for an adequate WAN network if you plan to use SQL Server the AlwaysOn implementation suite, mirroring, log shipping, or Failover Clustering to keep a remote site up-to-date.

  • We recommend that web servers and application servers have two network adapters: one network adapter to handle user traffic and the other to handle communication with the servers that are running SQL Server.

    Note:

    If you use iSCSI, make sure each network adapter is dedicated to either network communication or iSCI, not both.

For information about recommended SharePoint 2013 topologies, see the following technical diagrams:

  • Streamlined Topologies for SharePoint 2013

  • Traditional Topologies for SharePoint 2013

Configure SQL Server

The following sections describe how to plan to configure SQL Server for SharePoint Server 2013.

In this section:

  • Estimate how many servers are required

  • Configure storage and memory

  • Set SQL Server options

  • Configure databases

Estimate how many servers are required

In general, SharePoint Server 2013 is designed to take advantage of SQL Server scale out. For example, SharePoint Server 2013 may perform better with many medium-size servers that are running SQL Server than with only several large servers.

Always put SQL Server on a dedicated server that is not running any other farm roles or hosting databases for any other application. The only exception to this recommendation is if you deploy the system on a stand-alone server for a development or a non-performance oriented test environment.

The following is general guidance for when to deploy an additional server that will run a SQL Server instance:

  • Add an additional database server when you have more than four web servers that are running at capacity.

  • Add an additional database server when your current server has reached its effective resource limits of RAM, CPU, disk IO throughput, disk capacity, or network throughput.

For more information, see Compute Capacity Limits by Edition of SQL Server and Maximum Capacity Specifications for SQL Server.

To promote secure credential storage when you are running the Secure Store service application, we recommend that the Secure Store database be hosted on a separate database instance where access is limited to one administrator.

Configure storage and memory

On the server that is running SQL Server 2008 R2 with SP1 or SQL Server 2012, we recommend that the L2 cache per CPU have a minimum of 2 MB to improve memory.

Follow vendor storage configuration recommendations

For optimal performance when you configure a physical storage array, adhere to the hardware configuration recommendations supplied by the storage vendor instead of relying on the default values of the operating system.

If you do not have guidance from your vendor, we recommend that you use the DiskPart.exe disk configuration utility to configure storage for SQL Server 2008. For more information, see Predeployment I/O Best Practices.

We recommend using the Windows PowerShell storage cmdlets that are available for Windows Server 2012. For more information, see Storage Cmdlets in Windows PowerShell.

Provide as many resources as possible

Ensure that the SQL Server I/O channels to the disks are not shared by other applications, such as the paging file and Internet Information Services (IIS) logs.

Provide as much bus bandwidth as possible. Greater bus bandwidth helps improve reliability and performance. Consider that the disk is not the only user of bus bandwidth — for example, you must also account for network access.

Set SQL Server options

The following SQL Server settings and options should be configured before you deploy SharePoint Server.

  • Do not enable auto-create statistics on a server that hosts SQL Server and supports SharePoint Server. SharePoint Server configures the required settings upon provisioning and upgrade. Auto-create statistics can significantly change the execution plan of a query from one instance of SQL Server to another instance of SQL Server. Therefore, to provide consistent support for all customers, SharePoint Server provides coded hints for queries as needed to provide the best performance across all scenarios.

  • To ensure optimal performance, we strongly recommend that you set max degree of parallelism (MAXDOP) to 1 SQL Server instances that host SharePoint Server 2013 databases. For more information about how to set max degree of parallelism, see max degree of parallelism Option for SQL Server 2008 R2 with SP1, or Configure the max degree of parallelism Server Configuration Option for SQL Server 2012.

Configure databases

The following guidance describes best practices to plan for as you configure each database in your environment.

Separate and prioritize your data among disks

Ideally, you should place the tempdb database, content databases, Usage database, search databases, and SQL Server 2008 R2 with SP1 and SQL Server 2012 transaction logs on separate physical hard disks.

The following list provides some best practices and recommendations for prioritizing data:

  • When you prioritize data among faster disks, use the following ranking:

    1. Tempdb data files and transaction logs

    2. Database transaction log files

    3. Search databases, except for the Search administration database

    4. Database data files

    In a heavily read-oriented portal site, prioritize data over logs.

  • Testing and customer data show that SharePoint Server 2013 farm performance can be significantly impeded by insufficient disk I/O for tempdb. To avoid this issue, allocate dedicated disks for tempdb. If a high workload is projected or monitored — that is, the average read action or the average write action requires more than 20 ms — you might have to ease the bottleneck by either separating the files across disks or by replacing the disks with faster disks.

  • For best performance, place the tempdb on a RAID 10 array. The number of tempdb data files should equal the number of core CPUs, and the tempdb data files should be set at an equal size. Count dual core processors as two CPUs for this purpose. Count each processor that supports hyper-threading as a single CPU. For more information, see Optimizing tempdb Performance.

  • Separate database data and transaction log files across different disks. If files must share disks because the files are too small to warrant a whole disk or stripe, or you have a shortage of disk space, put files that have different usage patterns on the same disk to minimize concurrent access requests.

  • Consult your storage hardware vendor for information about how to configure all logs and the search databases for write optimization for your particular storage solution.

Use multiple data files for content databases

Follow these recommendations for best performance:

  • Only create files in the primary filegroup for the database.

  • Distribute the files across separate disks.

  • The number of data files should be less than or equal to the number of core CPUs. Count dual core processors as two CPUs for this purpose. Count each processor that supports hyper-threading as a single CPU.

  • Create data files of equal size.

Important:

Although you can use the backup and recovery tools that are built in to SharePoint Server 2013 to back up and recover multiple data files, if you overwrite in the same location, the tools can't restore multiple data files to a different location. For this reason, we strongly recommend that when you use multiple data files for a content database, you use SQL Server backup and recovery tools. For more information about how to back up and recover SharePoint Server 2013, see Plan for backup and recovery in SharePoint 2013.

For more information about how to create and manage filegroups, see Physical Database Files and Filegroups.

Limit content database size to improve manageability

Plan for database sizing that will improve manageability, performance, and ease of upgrade for your environment.

To help ensure system performance, we recommended that you limit the size of content databases to 200 GB, except when specific usage scenarios and conditions support larger sizes. For more information about content database size limits, see the Content database limits section in Software boundaries and limits for SharePoint 2013.

We generally recommend that a site collection should not exceed 100 GB unless it is the only site collection in the database so that you can use the SharePoint Server 2013 granular backup tools to move a site collection to another database if you need to.

Proactively manage the growth of data and log files

We recommend that you proactively manage the growth of data and log files by considering the following recommendations:

  • As much as possible, pre-grow all data and log files to their expected final size.

  • We recommend that you enable autogrowth for safety reasons. Do not rely on the default autogrowth settings. Consider the following guidelines when you configure autogrowth:

    • When you plan content databases that exceed the recommended size (200 GB), set the database autogrowth value to a fixed number of megabytes instead of to a percentage. This will reduce the frequency with which SQL Server increases the size of a file. Increasing file size is a blocking action that involves filling the new space with empty pages.

    • If the calculated size of the content database is not expected to reach the recommended maximum size of 200 GB within the next year, set it to the maximum size the database is predicted to reach in a year — with 20 percent additional margin for error — by using the ALTER DATABASE MAXSIZE property. Periodically review this setting to make sure that it is still an appropriate value, depending on past growth rates.

  • Maintain a level of at least 25 percent available space across disks to allow for growth and peak usage patterns. If you are managing growth by adding disks to a RAID array or allocating more storage, monitor disk size closely to avoid running out of space.

Validate and monitor storage and SQL Server performance

Test that your performance and backup solution on your hardware enables you to meet your service level agreements (SLAs). In particular, test the I/O subsystem of the computer that is running SQL Server to make sure that performance is satisfactory.

Test the backup solution that you are using to make sure that it can back up the system within the available maintenance window. If the backup solution can't meet the SLAs your business requires, consider using an incremental backup solution such as System Center 2012 - Data Protection Manager (DPM) with Service Pack 1 (SP1).

It is important to track the following resource components of a server that is running SQL Server: CPU, memory, cache/hit ratio, and I/O subsystem. When one or more of the components seems slow or overburdened, analyze the appropriate strategy based on the current and projected workload. For more information, see Monitoring and Tuning for Performance for SQL Server 2008 R2 with SP1 and Monitor and Tune for Performance for SQL Server 2012.

The following section lists the performance counters that we recommend that you use to monitor the performance of the SQL Server databases that are running in your SharePoint Server 2013 environment. Also listed are approximate healthy values for each counter.

For details about how to monitor performance and use performance counters, see Windows Performance Monitor and Monitoring Performance.

SQL Server counters to monitor

Monitor the following SQL Server counters to ensure the health of your servers:

  • General statistics This object provides counters to monitor general server-wide activity, such as the number of current connections and the number of users connecting and disconnecting per second from computers that are running an instance of SQL Server. Consider monitoring the following counter:

    • User connections This counter shows the number of user connections on your computer that is running SQL Server. If you see this number increase by 500 percent from your baseline, you may see a performance reduction.

  • Databases This object provides counters to monitor bulk copy operations, backup and restore throughput, and transaction log activities. Monitor transactions and the transaction log to determine how much user activity is occurring in the database and how full the transaction log is becoming. The amount of user activity can determine the performance of the database and affect log size, locking, and replication. Monitoring low-level log activity to gauge user activity and resource usage can help you identify performance bottlenecks. Consider monitoring the following counter:

    • Transactions/sec This counter shows the number of transactions on a given database or on the entire server per second. This number is more for your baseline and to help you troubleshoot issues.

  • Locks This object provides information about SQL Server locks on individual resource types. Consider monitoring the following counters:

    • Average Wait Time (ms) This counter shows the average amount of wait time for each lock request that resulted in a wait.

    • Lock Wait Time (ms) This counter shows the wait time for locks in the last second.

    • Lock waits/sec This counter shows the number of locks per second that couldn't be satisfied immediately and had to wait for resources.

    • Number of deadlocks/sec This counter shows the number of deadlocks on the computer that is running SQL Server per second. This should not increase above 0.

  • Latches This object provides counters to monitor internal SQL Server resource locks called latches. Monitoring the latches to determine user activity and resource usage can help you identify performance bottlenecks. Consider monitoring the following counters:

    • Average Latch Wait Time (ms) This counter shows the average latch wait time for latch requests that had to wait.

    • Latch Waits/sec This counter shows the number of latch requests that couldn't be granted immediately.

  • SQL Statistics This object provides counters to monitor compilation and the type of requests sent to an instance of SQL Server. Monitoring the number of query compilations and recompilations and the number of batches received by an instance of SQL Server gives you an indication of how quickly SQL Server is processing user queries and how effectively the query optimizer is processing the queries. Consider monitoring the following counters:

    • SQL Compilations/sec This counter indicates the number of times the compile code path is entered per second.

    • SQL Re-Compilations/sec This counter indicates the number statement recompiles per second.

  • Buffer Manager This object provides counters to monitor how SQL Server uses memory to store data pages, internal data structures, and the procedure cache, and also counters to monitor the physical I/O as SQL Server reads and writes database pages. Consider monitoring the following counter:

    • Buffer Cache Hit Ratio

    • This counter shows the percentage of pages that were found in the buffer cache without having to read from disk. The ratio is the total number of cache hits divided by the total number of cache lookups over the last few thousand page accesses. Because reading from the cache is much less expensive than reading from disk, you want this ratio to be high. Generally, you can increase the buffer cache hit ratio by increasing the memory available to SQL Server.

  • Plan Cache This object provides counters to monitor how SQL Server uses memory to store objects such as stored procedures, unprepared and prepared Transact-SQL statements, and triggers. Consider monitoring the following counter:

    • Cache Hit Ratio

    • This counter indicates the ratio between cache hits and lookups for plans.

Physical server counters to monitor

Monitor the following counters to ensure the health of your computers that are running SQL Server:

  • Processor: % Processor Time: _Total This counter shows the percentage of time that the processor is executing application or operating system processes other than Idle. On the computer that is running SQL Server, this counter should be kept between 50 percent and 75 percent. In case of constant overloading, investigate whether there is abnormal process activity or if the server needs additional CPUs.

  • System: Processor Queue Length This counter shows the number of threads in the processor queue. Monitor this counter to make sure that it remains less than two times the number of core CPUs.

  • Memory: Available Mbytes This counter shows the physical memory, in megabytes, available to processes running on the computer. Monitor this counter to make sure that you maintain a level of at least 20 percent of the total available physical RAM.

  • Memory: Pages/sec This counter shows the rate at which pages are read from or written to disk to resolve hard page faults. Monitor this counter to make sure that it remains under 100.

For more information and memory troubleshooting methods, see Monitoring Memory Usage for SQL Server 2008 R2 with SP1 and Monitoring Memory Usage for SQL Server 2012.

Disk counters to monitor

Monitor the following counters to ensure the health of disks. Note that the following values represent values measured over time — not values that occur during a sudden spike and not values that are based on a single measurement.

  • Physical Disk: % Disk Time: DataDrive This counter shows the percentage of elapsed time that the selected disk drive is busy servicing read or write requests-it is a general indicator of how busy the disk is. If the PhysicalDisk: % Disk Time counter is high (more than 90 percent), check the PhysicalDisk: Current Disk Queue Length counter to see how many system requests are waiting for disk access. The number of waiting I/O requests should be sustained at no more than 1.5 to 2 times the number of spindles that make up the physical disk.

  • Logical Disk: Disk Transfers/sec This counter shows the rate at which read and write operations are performed on the disk. Use this counter to monitor growth trends and forecast appropriately.

  • Logical Disk: Disk Read Bytes/sec and Logical Disk: Disk Write Bytes/sec These counters show the rate at which bytes are transferred from the disk during read or write operations.

  • Logical Disk: Avg. Disk Bytes/Read This counter shows the average number of bytes transferred from the disk during read operations. This value can reflect disk latency — larger read operations can result in slightly increased latency.

  • Logical Disk: Avg. Disk Bytes/Write This counter shows the average number of bytes transferred to the disk during write operations. This value can reflect disk latency — larger write operations can result in slightly increased latency.

  • Logical Disk: Current Disk Queue Length This counter shows the number of requests outstanding on the disk at the time that the performance data is collected. For this counter, lower values are better. Values greater than 2 per disk may indicate a bottleneck and should be investigated. This means that a value of up to 8 may be acceptable for a logical unit (LUN) made up of 4 disks. Bottlenecks can create a backlog that can spread beyond the current server that is accessing the disk and result in long wait times for users. Possible solutions to a bottleneck are to add more disks to the RAID array, replace existing disks with faster disks, or move some data to other disks.

  • Logical Disk: Avg. Disk Queue Length This counter shows the average number of both read and write requests that were queued for the selected disk during the sample interval. The rule is that there should be two or fewer outstanding read and write requests per spindle. But this can be difficult to measure because of storage virtualization and differences in RAID levels between configurations. Look for larger than average disk queue lengths in combination with larger than average disk latencies. This combination can indicate that the storage array cache is being overused or that spindle sharing with other applications is affecting performance.

  • Logical Disk: Avg. Disk sec/Read and Logical Disk: Avg. Disk sec/Write These counters show the average time, in seconds, of a read or write operation to the disk. Monitor these counters to make sure that they remain below 85 percent of the disk capacity. Disk access time increases exponentially if read or write operations are more than 85 percent of disk capacity. To determine the specific capacity for your hardware, refer to the vendor documentation or use the SQLIO Disk Subsystem Benchmark Tool to calculate it. For more information, see SQLIO Disk Subsystem Benchmark Tool.

    • Logical Disk: Avg. Disk sec/Read This counter shows the average time, in seconds, of a read operation from the disk. On a well-tuned system, ideal values are from 1 through 5 ms for logs (ideally 1 ms on a cached array), and from 4 through 20 ms for data (ideally less than 10 ms). Higher latencies can occur during peak times. However, if high values occur regularly, you should investigate the cause.

    • Logical Disk: Avg. Disk sec/Write This counter shows the average time, in seconds, of a write operation to the disk. On a well-tuned system, ideal values are from 1 through 5 ms for logs (ideally 1 ms on a cached array), and from 4 through 20 ms for data (ideally less than 10 ms). Higher latencies can occur during peak times. However, if high values occur regularly, you should investigate the cause.

    When you are using RAID configurations with the Logical Disk: Avg. Disk Bytes/Read or Logical Disk: Avg. Disk Bytes/Write counters, use the formulas listed in the following table to determine the rate of input and output on the disk.

    RAID level Formula

    RAID 0

    I/Os per disk = (reads + writes) / number of disks

    RAID 1

    I/Os per disk = [reads + (2 × writes)] / 2

    RAID 5

    I/Os per disk = [reads + (4 × writes)] / number of disks

    RAID 10

    I/Os per disk = [reads + (2 × writes)] / number of disks

    For example, if you have a RAID 1 system that has two physical disks, and your counters are at the values that are shown in the following table.

    Counter Value

    Avg. Disk sec/Read

    80

    Logical Disk: Avg. Disk sec/Write

    70

    Avg. Disk Queue Length

    5

    The I/O value per disk can be calculated as follows: (80 + (2 × 70))/2 = 110

    The disk queue length can be calculated as follows: 5/2 = 2.5

    In this situation, you have a borderline I/O bottleneck.

Other monitoring tools

You can also monitor disk latency and analyze trends by using the sys.dm_io_virtual_file_stats dynamic management view in SQL Server 2008. For more information, see sys.dm_io_virtual_file_stats (Transact-SQL) for SQL Server 2008 R2 with SP1 or sys.dm_io_virtual_file_stats (Transact-SQL)for SQL Server 2012.

SQL Server 2012 for SharePoint Server 2013

Thanks to Bill Baer, Microsoft Senior Product Marketing Manager and Brian Alderman, CEO and Founder of MicroTechPoint for providing a series of online SQL Server 2012 training modules. Special thanks to Channel 9 Microsoft for hosting these online training modules. The following training modules provide details about SQL Server 2012 database settings to help you learn how to improve SharePoint Server 2013 performance, availability, and security.

  • Tuning SQL Server 2012 for SharePoint 2013: (01) Key SQL Server and SharePoint Server Integration

  • Tuning SQL Server 2012 for SharePoint 2013: (02) Best Practices for SQL Server Database Settings

  • Tuning SQL Server 2012 for SharePoint 2013: (03) Server Settings for SQL Server

  • Tuning SQL Server 2012 for SharePoint 2013: (04) SQL Server and SharePoint Availability

See also

Overview of SQL Server in a SharePoint environment (SharePoint 2013)
Optimize performance for SharePoint Server 2013
Best practices for SQL Server in a SharePoint Server farm
Plan for performance and capacity management in SharePoint Server 2013
Capacity management and sizing for SharePoint Server 2013
Capacity planning for SharePoint Server 2013

SharePoint for IT pros


Security planning for SharePoint 2013 farms

Updated: July 30, 2013

Summary: These articles and resources provide information about how to plan SharePoint 2013 security for server farms.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about how to plan for security for server farms.

TechNet articles about how to plan for security for server farms

The following articles about how to plan for security for server farms are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Plan for least-privileged administration in SharePoint 2013 | Learn about how to use least-privileged administration to configure and maintain a SharePoint 2013 farm and enhance security.
 | Plan security hardening for SharePoint 2013 | Learn about security hardening for SharePoint Web server, application server, and database server roles, including specific hardening requirements for ports, protocols, and services.
 | Plan for administrative and service accounts in SharePoint 2013 | Learn about the accounts to use to manage SharePoint Server 2013 deployment scenarios and services.
 | Plan automatic password change in SharePoint 2013 | Learn about the automatic password changes and how to deploy them in SharePoint 2013.

Additional resources about how to plan for security for server farms

The following resources about how to plan for security for server farms are available from other subject matter experts.

 | Content | Description
TechNet logo | SharePoint 2013 for IT pros Tech Center | Visit the TechCenter to access videos, community sites, documentation, and more.
Blogs | SharePoint blog To the SharePoint (for IT pros) Office 365 Technical Blog | Keep up with news from the teams that create and document SharePoint 2013.

Change History

Date | Description
July 30, 2013 | Added link to Plan for least-privileged administration in SharePoint 2013.
October 16, 2012 | Initial publication


Plan for least-privileged administration in SharePoint 2013
See also

Published: July 30, 2013

Summary: Learn about how to use least-privileged administration to configure and maintain a SharePoint 2013 farm and enhance security.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The concept of least-privileged administration is to assign users the minimum permissions that are required for users to complete authorized tasks. The goal of least-privileged administration is to configure and help maintain secure control of an environment. The result is that each account under which a service runs is granted access to only the resources that are absolutely necessary.

We recommend that you deploy SharePoint 2013 with least-privileged administration even though implementing least-privileged administration can result in increased operational costs because additional resources might be required to maintain this level of administration. Moreover, the ability to troubleshoot security problems can also be made more complex.

In this article:

  • Introduction

  • Least-privileged environment for accounts and services

Introduction

Organizations implement least-privileged administration to achieve better security than would be typically recommended. Only a small percentage of organizations require this heightened level of security because of the resource costs of maintaining least-privileged administration. Some deployments that might require this heightened level of security include governmental agencies, security organizations, and organizations in the financial services industry. The implementation of a least-privileged environment should not be confused with best practices. In a least-privileged environment, administrators implement best practices together with additional heightened levels of security.

Least-privileged environment for accounts and services

To plan for least-privileged administration, you must consider several accounts, roles, and services. Some apply to SQL Server and some apply to SharePoint 2013. As administrators lock down additional accounts and services, daily operational costs are likely to increase.

SQL Server roles

In a SharePoint 2013 environment, several accounts may be granted the following two SQL Server server-level roles. In a least-privileged SharePoint 2013 environment, we recommend that you only grant these privileges to the account under which the Microsoft SharePoint Foundation Workflow Timer Service runs. Typically, the timer service runs under the server farm account. For day-to-day operations, we recommend that you remove the following two SQL Server server-level roles from all other accounts that are used for SharePoint administration:

  • Dbcreator - Members of the dbcreator fixed server role can create, alter, drop, and restore any database.

  • Securityadmin - Members of the securityadmin fixed server role manage logins and their properties. They can GRANT, DENY, and REVOKE server-level permissions. They can also GRANT, DENY, and REVOKE database-level permissions if they have access to a database. Additionally, they can reset passwords for SQL Server logins.

    Security

    The ability to grant access to the database engine and to configure user permissions allows the securityadmin to assign most server permissions. You should treat the securityadmin role as equal to the sysadmin role.

For additional information about SQL Server server-level roles, see Server Level Roles.

If you remove one or more of these SQL Server roles, you might receive "Unexpected" error messages in the Central Administration web site. In addition, you may receive the following message in the Unified Logging Service (ULS) log file:

System.Data.SqlClient.SqlException… <operation type> permission denied in database <database>. Table <table>

Along with an error message that may be displayed, you may be unable to perform any of the following tasks:

  • Restore a backup of a farm because you can't write to a database

  • Provision a service instance or web application

  • Configure managed accounts

  • Change managed accounts for web applications

  • Perform any action on any database, managed account, or service that requires the Central Administration web site

In certain situations, database administrators (DBAs) may want to operate independently from SharePoint 2013 administrators and create and manage all the databases. This is typical in IT environments where security requirements and company policies require a separation of administrator roles. The farm administrator provides SharePoint 2013 database requirements to the DBA, who then creates the necessary databases and sets up the logins that are required for the farm.

By default, the DBA has complete access to the SQL Server instance but requires additional permissions to access SharePoint 2013. DBAs typically use Windows PowerShell 3.0 when they add, create, move, or rename SharePoint databases, so they must be a member of the following accounts:

  • Securityadmin fixed server role on the SQL Server instance.

  • Db_owner fixed database role on all databases in the SharePoint farm.

  • Administrators group on the computer on which they run the Windows PowerShell cmdlets.

Additionally, the DBA may have to be a member of the SharePoint_Shell_Access role to access the SharePoint content database. In some conditions, the DBA may want to add the Setup user account to the db_owner role.

SharePoint 2013 roles and services

In general, you should remove the ability to create new databases from SharePoint 2013 service accounts. Other than the account under which the timer service runs (typically the farm account), no SharePoint 2013 service account should have the sysadmin role on the SQL Server instance and no SharePoint 2013 service account should be a local Administrator on the server that runs SQL Server.

For more information about SharePoint 2013 accounts, see Account permissions and security settings in SharePoint 2013.

The following list provides information about locking down other SharePoint 2013 roles and services:

  • SharePoint_Shell_Access role

    When you remove this SQL Server role, you remove the ability to write entries to the configuration and content database and the ability to perform any tasks by using Windows PowerShell. For additional information about this role, see Add-SPShellAdmin.

  • SharePoint Timer service (SPTimerV4)

    We recommend that you do not limit the default permissions granted to the account under which this service runs and that you never disable this account. Instead, use a secure user account, for which the password is not widely known, and leave the service running. By default, this service is installed when you install SharePoint 2013 and maintains configuration cache information. If you set the service type to disabled you may experience the following behavior:

    • Timer jobs won't run

    • Health analyzer rules won't run

    • Maintenance and farm configuration will be out of date

  • SharePoint Administration service (SPAdminV4)

    This service performs automated changes that require local administrator permission on the server. When the service is not running, you must manually process server-level administrative changes. We recommend that you do not limit the default permissions granted to the account under which this service runs and that you never disable this account. Instead, use a secure user account, for which the password is not widely known, and leave the service running. If you set the service type to disabled, you may experience the following behavior:

    • Administrative timer jobs won't run

    • Web configuration files won't be updated

    • Security and local groups won't be updated

    • Registry values and keys won't be written

    • Services may be unable to be started or restarted

    • Provisioning of services may be unable to be completed

  • SPUserCodeV4 Service

    This service lets a site collection administrator upload sandboxed solutions to the Solutions gallery. If you are not using sandboxed solutions, you can disable this service.

  • Claims To Windows Token service (C2WTS)

    By default, this service is disabled. The C2WTS service may be required for a deployment with Excel Services, PerformancePoint Servers, or SharePoint shared services that must translate between SharePoint security tokens and Windows-based identities. For example, you use this service when you configure Kerberos-constrained delegation for accessing external data sources. For more information about C2WTS, see Plan for Kerberos authentication in SharePoint 2013.

The following features may experience additional symptoms under certain circumstances:

  • Backup and restore

    The ability to perform a restore from a backup may fail if you have removed database permissions.

  • Upgrade

    The upgrade process starts correctly, but then fails if you do not have suitable permissions to databases. If your organization is already in a least-privileged environment, the workaround is to move to a best practices environment to complete the upgrade, and then move back to a least-privileged environment.

  • Update

    The ability to apply a software update to a farm will succeed for the schema of the configuration database, but fail on the content database and services.

Additional things to consider for a least-privileged environment

In addition to the previous considerations, you might have to consider more operations. The following list is incomplete. Selectively use the items at your own discretion:

  • Setup user account - This account is used to set up each server in a farm. The account must be a member of the Administrators group on each server in the SharePoint 2013 farm. For additional information about this account, see Initial deployment administrative and service accounts in SharePoint 2013.

  • Synchronization account - For SharePoint 2013 Server, this account is used to connect to the directory service. We recommend that you do not limit the default permissions granted to the account under which this service runs and that you never disable this account. Instead, use a secure user account, for which the password is not widely known, and leave the service running. This account also requires Replicate Directory Changes permission on AD DS which enables the account to read AD DS objects and to discover AD DS objects that were changed in the domain. The Grant Replicate Directory Changes permission does not enable an account to create, change or delete AD DS objects. For additional information, see User profile properties and profile synchronization planning worksheets.

  • My Site host application pool account - This is the account under which the My Site application pool runs. To configure this account, you must be a member of the Farm Administrators group. You can limit privileges to this account.

  • Built-in user group - Removing the built-in user security group or changing the permissions may have unanticipated consequences. We recommend that you do not limit privileges to any built-in accounts or groups.

  • Group permissions - By default the WSS_ADMIN_WPG SharePoint group has read and write access to local resources. The following WSS_ADMIN_WPG file system locations, %WINDIR%\System32\drivers\etc\Hosts and %WINDIR%\Tasks are needed for SharePoint 2013 to work correctly. If other services or applications are running on a server, you might consider how they access the Tasks or Hosts folder locations. For additional information about account settings for SharePoint 2013, see Account permissions and security settings in SharePoint 2013.

  • Change permission of a service - A change of a permission of a service may have unanticipated consequences. For example, if the following registry key, HKLM\System\CurrentControlSet\Services\PerfProc\Performance\Disable Performance Counters, has the value of 0, the User Code Host service would be disabled which would cause sandboxed solutions to stop working.

See also

Least Privilege Configuration for Workflow Manager with SharePoint 2013


Plan security hardening for SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn about security hardening for SharePoint web server, application server, and database server roles, including specific hardening requirements for ports, protocols, and services.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In this article:

  • Secure server snapshots

  • Specific port, protocol, and service guidance

Secure server snapshots

In a server farm environment, individual servers play specific roles. Security hardening recommendations for these servers depend on the role each server plays. This article contains secure snapshots for two categories of server roles:

  • Web server and application server roles

  • Database server role

The snapshots are divided into common configuration categories. The characteristics defined for each category represent the optimal hardened state for SharePoint 2013. This article does not include hardening guidance for other software in the environment.

In addition to hardening servers for specific roles, it is important to protect the SharePoint farm by placing a firewall between the farm servers and outside requests. The guidance in this article can be used to configure a firewall.

Web server and application server roles

This section identifies hardening characteristics for Web servers and application servers. Some of the guidance applies to specific service applications; in these cases, the corresponding characteristics need to be applied only on the servers that are running the services associated with the specified service applications.

Category Characteristic

Services listed in the Services MMC snap-in

Enable the following services:

  • ASP.NET State service (if you are using InfoPath Forms Services or Project Server 2013)

  • View State service (if you are using InfoPath Forms Services)

  • World Wide Web Publishing Service

Ensure that these services are not disabled:

  • AppFabric Caching Service

  • Claims to Windows Token Service

  • SharePoint Administration

  • SharePoint Timer Service

  • SharePoint Tracing Service

  • SharePoint VSS Writer

Ensure that these services are not disabled on the servers that host the corresponding roles:

  • SharePoint User Code Host

  • SharePoint Search Host Controller

  • SharePoint Server Search 15

  • The following services are required by the User Profile service application on the server that imports profiles from the directory store:

    • Forefront Identity Manager service

    • Forefront Identity Manager Synchronization service

Ports and protocols

  • TCP 80, TCP 443 (SSL)

  • Custom ports for search crawling, if configured (such as for crawling a file share or a website on a non-default port)

  • Ports used by the search index component — TCP 16500-16519 (intra-farm only)

  • Ports required for the AppFabric Caching Service — TCP 22233-22236

  • Ports required for Windows Communication Foundation communication — TCP 808

  • Ports required for communication between Web servers and service applications (the default is HTTP):

    • HTTP binding: TCP 32843

    • HTTPS binding: TCP 32844

    • net.tcp binding: TCP 32845 (only if a third party has implemented this option for a service application)

  • Ports required for synchronizing profiles between SharePoint 2013 and Active Directory Domain Services (AD DS) on the server that runs the Forefront Identity Management agent:

    • TCP 5725

    • TCP&UDP 389 (LDAP service)

    • TCP&UDP 88 (Kerberos)

    • TCP&UDP 53 (DNS)

    • UDP 464 (Kerberos Change Password)

    For information about how to synchronize profiles with other directory stores, see User Profile service hardening requirements, later in this article.

  • Default ports for SQL Server communication — TCP 1433, UDP 1434. If these ports are blocked on the SQL Server computer (recommended) and databases are installed on a named instance, configure a SQL Server client alias for connecting to the named instance.

  • Microsoft SharePoint Foundation User Code Service (for sandbox solutions) — TCP 32846. This port must be open for outbound connections on all Web servers. This port must be open for inbound connections on Web servers or application servers where this service is turned on.

  • Ensure that ports remain open for Web applications that are accessible to users.

  • Block external access to the port that is used for the Central Administration site.

  • SMTP for e-mail integration — TCP 25

Registry

No additional guidance

Auditing and logging

If log files are relocated, ensure that the log file locations are updated to match. Update directory access control lists (ACLs) also.

Web.config

Follow these recommendations for each Web.config file that is created after you run Setup:

  • Do not allow compilation or scripting of database pages via the PageParserPaths elements.

  • Ensure <SafeMode> CallStack="false" and AllowPageLevelTrace="false".

  • Ensure that the Web Part limits around maximum controls per zone are set low.

  • Ensure that the SafeControls list is set to the minimum set of controls needed for your sites.

  • Ensure that your Workflow SafeTypes list is set to the minimum level of SafeTypes needed.

  • Ensure that customErrors is turned on (<customErrors mode="On"/>).

  • Consider your Web proxy settings as needed (<system.net>/<defaultProxy>).

  • Set the Upload.aspx limit to the highest size you reasonably expect users to upload (the maximum is 2 GB). Performance can be affected by uploads that exceed 100 MB.

Database server role

The primary recommendation for SharePoint 2013 is to secure inter-farm communication by blocking the default ports used for SQL Server communication and establishing custom ports for this communication instead. For more information about how to configure ports for SQL Server communication, see Blocking the standard SQL Server ports, later in this article.

Category Characteristic

Ports

  • Block UDP 1434.

  • Consider blocking TCP 1433.

This article does not describe how to secure SQL Server. For more information about how to secure SQL Server, see Securing SQL Server (http://go.microsoft.com/fwlink/p/?LinkId=186828).

Specific port, protocol, and service guidance

The rest of this article describes in greater detail the specific hardening requirements for SharePoint 2013.

In this section:

  • Blocking the standard SQL Server ports

  • Service application communication

  • User Profile service hardening requirements

  • Connections to external servers

  • Service requirements for e-mail integration

  • Service requirements for session state

  • SharePoint 2013 Products services

  • Web.config file

Blocking the standard SQL Server ports

The specific ports used to connect to SQL Server are affected by whether databases are installed on a default instance of SQL Server or a named instance of SQL Server. The default instance of SQL Server listens for client requests on TCP 1433. A named instance of SQL Server listens on a randomly assigned port number. Additionally, the port number for a named instance can be reassigned if the instance is restarted (depending on whether the previously assigned port number is available).

By default, client computers that connect to SQL Server first connect by using TCP 1433. If this communication is unsuccessful, the client computers query the SQL Server Resolution Service that is listening on UDP 1434 to determine the port on which the database instance is listening.

The default port-communication behavior of SQL Server introduces several issues that affect server hardening. First, the ports used by SQL Server are well-publicized ports and the SQL Server Resolution Service has been the target of buffer overrun attacks and denial-of-service attacks, including the "Slammer" worm virus. Even if SQL Server is updated to mitigate security issues in the SQL Server Resolution Service, the well-publicized ports remain a target. Second, if databases are installed on a named instance of SQL Server, the corresponding communication port is randomly assigned and can change. This behavior can potentially prevent server-to-server communication in a hardened environment. The ability to control which TCP ports are open or blocked is essential to securing your environment.

Consequently, the recommendation for a server farm is to assign static port numbers to named instances of SQL Server and to block UDP 1434 to prevent potential attackers from accessing the SQL Server Resolution Service. Additionally, consider reassigning the port used by the default instance and blocking TCP 1433.

There are several methods you can use to block ports. You can block these ports by using a firewall. However, unless you can be sure that there are no other routes into the network segment and that there are no malicious users that have access to the network segment, the recommendation is to block these ports directly on the server that hosts SQL Server. This can be accomplished by using Windows Firewall in Control Panel.

Configuring SQL Server database instances to listen on a nonstandard port

SQL Server provides the ability to reassign the ports that are used by the default instance and any named instances. In SQL Server, you reassign ports by using SQL Server Configuration Manager.

Configuring SQL Server client aliases

In a server farm, all front-end Web servers and application servers are SQL Server client computers. If you block UDP 1434 on the SQL Server computer, or you change the default port for the default instance, you must configure a SQL Server client alias on all servers that connect to the SQL Server computer. In this scenario, the SQL Server client alias specifies the TCP port that the named instance is listening on.

To connect to an instance of SQL Server, you install SQL Server client components on the target computer and then configure the SQL Server client alias by using SQL Server Configuration Manager. To install SQL Server client components, run Setup and select only the following client components to install:

  • Connectivity Components

  • Management Tools (includes SQL Server Configuration Manager)

For specific hardening steps for blocking the standard SQL Server ports, see Configure SQL Server security for SharePoint 2013 environments.

Service application communication

By default, communication between Web servers and service applications within a farm takes place by using HTTP with a binding to TCP 32843. When you publish a service application, you can select either HTTP or HTTPS with the following bindings:

  • HTTP binding: TCP 32843

  • HTTPS binding: TCP 32844

Additionally, third parties that develop service applications can implement a third choice:

  • net.tcp binding: TCP 32845

You can change the protocol and port binding for each service application. On the Service Applications page in Central Administration, select the service application, and then click Publish.

The HTTP/HTTPS/net.tcp bindings can also be viewed and changed using the Get-SPServiceHostConfig and Set-SPServiceHostConfig PowerShell cmdlets.

Communication between service applications and SQL Server takes place over the standard SQL Server ports or the ports that you configure for SQL Server communication.

User Profile service hardening requirements

The User Profile service application uses the Forefront Identity Management agent to synchronize profiles between SharePoint 2013 and Active Directory or a Lightweight Directory Access Protocol (LDAP) directory service. The Forefront Identity Management agent is installed on all servers in a SharePoint farm, but is only required on the server that is set up to synchronize with the directory store.

The Forefront Identity Management agent includes the following two services that must remain enabled on the server that is set up to crawl Active Directory or another directory store:

  • Forefront Identity Manager service

  • Forefront Identity Manager Synchronization service

Additionally, TCP 5725 must be open on the server that runs the Forefront Identity Management agent and is set up to crawl a directory store.

In Active Directory environments, the following ports must remain open for communication between the SharePoint 2013 server that synchronizes with the directory store and the server that is running Active Directory:

  • TCP&UDP 389 (LDAP service)

  • TCP&UDP 88 (Kerberos)

  • TCP&UDP 53 (DNS)

  • UDP 464 (Kerberos Change Password)

For more information about hardening requirements for the Forefront Identity Management agent, including port requirements for other directory types, see Management Agent Communication Ports, Rights, and Permissions (http://go.microsoft.com/fwlink/p/?LinkId=186832).

Connections to external servers

Several features of SharePoint Server 2013 can be configured to access data that resides on server computers outside of the server farm. If you configure access to data that is located on external server computers, ensure that you enable communication between the appropriate computers. In most cases, the ports, protocols, and services that are used depend on the external resource. For example:

  • Connections to file shares use the File and Printer Sharing service.

  • Connections to external SQL Server databases use the default or customized ports for SQL Server communication.

  • Connections to Oracle databases typically use OLE DB.

  • Connections to Web services use both HTTP and HTTPS.

The following table lists features that can be configured to access data that resides on server computers outside the server farm.

Feature Description

Content crawling

You can configure crawl rules to crawl data that resides on external resources, including Web sites, file shares, Exchange public folders, and business data applications. When crawling external data sources, the crawl role communicates directly with these external resources.

For more information, see Manage crawling in SharePoint 2013.

Business Data Connectivity connections

Web servers and application servers communicate directly with computers that are configured for Business Data Connectivity connections.

For more information, see Plan for Business Connectivity Services in SharePoint 2013.

Receiving Microsoft Office Excel workbooks

If workbooks opened in Excel Services Application connect to any external data sources (for example, Analysis Services and SQL Server), appropriate TCP ports need to be opened for connecting to these external data sources. For more information, see Overview of Excel Services in SharePoint Server 2013.

If Universal Naming Convention (UNC) paths are configured as trusted locations in Excel Services Application, the Excel Calculation Services application role uses the protocols and ports used by the File and Printer Sharing service to receive Office Excel workbooks over a UNC path.

Workbooks that are stored in content databases or that are uploaded or downloaded from sites by users are not affected by this communication.

Service requirements for e-mail integration

E-mail integration requires the use of two services:

  • SMTP service

  • Microsoft SharePoint Directory Management service

SMTP service

E-mail integration requires the use of the Simple Mail Transfer Protocol (SMTP) service on at least one of the front-end Web servers in the server farm. The SMTP service is required for incoming e-mail. For outgoing e-mail, you can either use the SMTP service or route outgoing email through a dedicated e-mail server in your organization, such as a Microsoft Exchange Server computer.

Microsoft SharePoint Directory Management service

SharePoint 2013 includes an internal service, the Microsoft SharePoint Directory Management Service, for creating e-mail distribution groups. When you configure e-mail integration, you have the option to enable the Directory Management Service feature, which lets users create distribution lists. When users create a SharePoint group and they select the option to create a distribution list, the Microsoft SharePoint Directory Management Service creates the corresponding Active Directory distribution list in the Active Directory environment.

In security-hardened environments, the recommendation is to restrict access to the Microsoft SharePoint Directory Management Service by securing the file associated with this service, which is SharePointEmailws.asmx. For example, you might allow access to this file by the server farm account only.

Additionally, this service requires permissions in the Active Directory environment to create Active Directory distribution list objects. The recommendation is to set up a separate organizational unit (OU) in Active Directory for SharePoint 2013 objects. Only this OU should allow write access to the account that is used by the Microsoft SharePoint Directory Management Service.

Service requirements for session state

Both Project Server 2013 and InfoPath Forms Services maintain session state. If you are deploying these features or products within your server farm, do not disable the ASP.NET State service. Additionally, if you are deploying InfoPath Forms Services, do not disable the View State service.

SharePoint 2013 Products services

Do not disable services that are installed by SharePoint 2013 (listed in the snapshot previously).

If your environment disallows services that run as a local system, you can consider disabling the SharePoint Administration service only if you are aware of the consequences and can work around them. This service is a Win32 service that runs as a local system.

This service is used by the SharePoint Timer service to perform actions that require administrative permissions on the server, such as creating Internet Information Services (IIS) Web sites, deploying code, and stopping and starting services. If you disable this service, you cannot complete deployment-related tasks from the Central Administration site. You must use Windows PowerShell to run the Start-SPAdminJob cmdlet (or use the Stsadm.exe command-line tool to run the execadmsvcjobs operation) to complete multiple-server deployments for SharePoint 2013 and to run other deployment-related tasks.

Web.config file

The .NET Framework, and ASP.NET in particular, use XML-formatted configuration files to configure applications. The .NET Framework relies on configuration files to define configuration options. The configuration files are text-based XML files. Multiple configuration files can, and typically do, exist on a single system.

System-wide configuration settings for the .NET Framework are defined in the Machine.config file. The Machine.config file is located in the %SystemRoot%\Microsoft.NET\Framework\%VersionNumber%\CONFIG\ folder. The default settings that are contained in the Machine.config file can be modified to affect the behavior of applications that use the .NET Framework on the whole system.

You can change the ASP.NET configuration settings for a single application if you create a Web.config file in the root folder of the application. When you do this, the settings in the Web.config file override the settings in the Machine.config file.

When you extend a Web application by using Central Administration, SharePoint 2013 automatically creates a Web.config file for the Web application.

The Web server and application server snapshot presented earlier in this article lists recommendations for configuring Web.config files. These recommendations are intended to be applied to each Web.config file that is created, including the Web.config file for the Central Administration site.

For more information about ASP.NET configuration files and editing a Web.config file, see ASP.NET Configuration (http://go.microsoft.com/fwlink/p/?LinkID=73257).

See also

Security planning for SharePoint 2013 farms


Plan for administrative and service accounts in SharePoint 2013
See also

Published: September 4, 2012

Summary: Learn about the accounts to use to manage SharePoint Server 2013 deployment scenarios and services.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

To install SharePoint 2013, you have to have appropriate administrative and service accounts on servers running SharePoint 2013 and SQL Server. After installation, you need to have appropriate administrative and service accounts to modify and maintain the environment. The accounts that you require to complete these groups of tasks are not necessarily the same. This article describes the accounts that you require after installation for a single server environment and a server farm environment.

In this article:

  • About administrative and service accounts

  • Single server standard requirements

  • Server farm requirements

Use this article along with Initial deployment administrative and service accounts in SharePoint 2013.

The initial deployment administrative and service accounts article describes the specific account and permissions that you need to grant prior to running Setup.

This article does not describe the account requirements for using Secure Store service in SharePoint Server 2013. For more information, see Plan the Secure Store Service in SharePoint Server 2013.

This article does not describe security roles and permissions required to administer in SharePoint 2013.

About administrative and service accounts

This section lists and describes the accounts that you must plan for to manage servers running SQL Server or SharePoint 2013. The accounts are grouped according to scope.

After you complete installation and configuration of accounts, ensure that you do not use the Local System account to perform administration tasks or to browse sites.

Server farm-level accounts

The following table describes the accounts that are used to configure SQL Server database software and to install SharePoint 2013.

Account Purpose

SQL Server service account

SQL Server prompts for this account during SQL Server Setup. This account is used as the service account for the following SQL Server services:

  • MSSQLSERVER

  • SQLSERVERAGENT

If you are not using the default instance, these services will be shown as:

  • MSSQL<InstanceName>

  • SQLAgent<InstanceName>

Setup user account

The user account that is used to run:

If you run Windows PowerShell cmdlets that affect a database, this account must be a member of the db_owner fixed database role for the database.

  • Setup on each server computer

  • SharePoint Products Configuration Wizard

  • The Psconfig command-line tool

  • The Stsadm command-line tool

Server farm account

This account is also referred to as the database access account.

This account has the following properties:

  • It's the application pool identity for the SharePoint Central Administration website.

  • It's the process account for the Windows SharePoint Services Timer service.

Service application accounts

The following table describes the accounts that are used to set up and configure a service application. Plan one set of an application pool and proxy group for each service application that you plan to implement.

For more information about service application endpoints, see Using Service Endpoints.

Account Service Purpose Requirements

Service Application Endpoint

Service name | In SharePoint Server | In SharePoint Foundation
Access Services | X |
Business Data Connectivity service | X | X
Secure Store Service | X |
Usage and Health Data Collection Service | X |
User Profile Service | X |
Visio Graphics Service | X |
Word Automation services | X |

This account is used as the identity for the service application endpoint application pool. Unless there are specific isolation requirements, the application pool can be used to host multiple service application endpoints.

Service Application Endpoint

Service name | In SharePoint Server | In SharePoint Foundation
Excel Services | X |
Managed Metadata Service | X |
PerformancePoint Service | X |
Search Service | X |

This account is used as the identity for the service endpoint application pool. Unless there are specific isolation requirements, the application pool can be used to host multiple service application endpoints.

Must be a domain user account.

Service Application Endpoint

Service name | In SharePoint Server | In SharePoint Foundation
Security Token Service | X |
Application Discovery and Load Balancer Service | X | X

This account is used as the identity for the service application endpoint application pool. This account must be the Farm Service Account and the SharePoint Products Configuration Wizard automatically creates the application pool.

Unattended Service

Service name | In SharePoint Server | In SharePoint Foundation
Excel Services | X |

Used with workbooks to refresh data. It is required when workbook connections specify "None" for authentication, or when any credentials that are notWindows credentials are used to refresh data.

Must be a domain user account.

Unattended Service

Service name | In SharePoint Server | In SharePoint Foundation
PerformancePoint Service | X |

Used for authenticating with data sources.

Must be a domain user account.

Unattended Service

Service name | In SharePoint Server | In SharePoint Foundation
Visio Graphics Service | X |

Used with documents to refresh data. It is required when connecting to data sources that are external to SharePoint Server 2013, such as SQL Server.

Default Content Access

Service name | In SharePoint Server | In SharePoint Foundation
SharePoint Server Search | X |

The default account for crawling content. A Search service application administrator can create crawl rules to specify other accounts to crawl specific content.

Must have Read Access to the content being crawled.

Full Read permissions must be granted explicitly to content that is outside the local farm.

Full Read permissions are automatically configured for content databases in the local farm.

Search Service

Service name | In SharePoint Server | In SharePoint Foundation
SharePoint Server Search | X |

The Windows service account for the SharePoint Server Search service. This setting affects all Search service applications in the farm.

Must be a domain user account.

User Profile Synchronization Service

Service name | In SharePoint Server | In SharePoint Foundation
User Profile Synchronization Service | X |

This is the Windows service account for the User Profile Synchronization Service.

Requires Log on Locally permission on the computer running the instance of the User Profile Synchronization Service.

Synchronization Connection

Service name | In SharePoint Server | In SharePoint Foundation
User Profile Service | X |

This is the account used to perform synchronization with the remote directory service. There can be one account per synchronization connection.

Replicating Directory Changes permissions on the domains being synchronized.

Replicating Directory Changes permissions on the configuration partition of the domains being synchronized if the NetBIOS and fully qualified domain name (FQDN) names do not match.

App Management Service

Service name | In SharePoint Server | In SharePoint Foundation
App management | X | X

This account permits you to install SharePoint apps from the SharePoint Store or the App Catalog.

PowerPoint Conversion Service

Service name | In SharePoint Server | In SharePoint Foundation
PowerPoint conversion service | X |

This account converts Microsoft PowerPoint presentations into various formats.

Machine Translation service

Service name | In SharePoint Server | In SharePoint Foundation
Machine Translation service | X |

This account performs automated machine translation.

Access Services 2013

Service name | In SharePoint Server | In SharePoint Foundation
Access Services in SharePoint Server 2013 | X |

This account views, edits, and interacts with Access 2013 databases in a browser.

Work Management

Service name | In SharePoint Server | In SharePoint Foundation
Work management | X |

This account provides task aggregation across work management systems, including SharePoint products, Microsoft Exchange Server, and Microsoft Project Server.

Additional application pool identity accounts

If you create additional application pools to host sites, plan for additional application pool identity accounts. The following table describes the application pool identity account. Plan one application pool account for each application pool that you plan to implement.

Account | Purpose
Application pool identity | The user account that the worker processes that service the application pool use as their process identity. This account is used to access content databases that are associated with the web applications that reside in the application pool.

Single server standard requirements

If you are deploying to a single server computer, account requirements are greatly reduced. In an evaluation environment, you can use a single account for all of the account purposes. In a production environment, ensure that the accounts that you create have the appropriate permissions for their purposes.

For a list of account permissions for single server environments, see Initial deployment administrative and service accounts in SharePoint 2013.

Server farm requirements

If you are deploying to more than one server computer, use the server farm standard requirements to ensure that accounts have the appropriate permissions to perform their processes across multiple computers. The server farm standard requirements detail the minimum configuration that is necessary to operate in a server farm environment.

For a list of standard requirements for server farm environments, see the requirements listed in the Technical reference: Account requirements by scenario section of this article.

For some accounts, additional permissions or access to databases are configured when you run Setup. These are noted in the accounts planning tool. An important configuration for database administrators to be aware of is the addition of the WSS_Content_Application_Pools database role. Setup adds this role to the following databases:

  • SharePoint_Config database (configuration database)

  • SharePoint_AdminContent database

Members of the WSS_Content_Application_Pools database role are granted the Execute permission to a subset of the stored procedures for the database. Additionally, members of this role are granted the Select permission to the Versions table (dbo.Versions) in the SharePoint_AdminContent database.

For other databases, the accounts planning tool indicates that access to read from these databases is automatically configured. In some cases, limited access to write to a database is also automatically configured. To provide this access, permissions to stored procedures are configured.

Technical reference: Account requirements by scenario

This section lists account requirements by scenario:

  • Single server standard requirements

  • Server farm standard requirements

Single server standard requirements

Server farm-level accounts

Account | Requirements
SQL Server service | Local System account (default)
Setup user | Member of the Administrators group on the local computer
Server farm | Network Service (default) No manual configuration is necessary.

Service application accounts

Important:

Accounts in this table apply only to SharePoint Server.

Account | Requirements
SharePoint Server Search Service | By default, this account runs as the Local System account. If you want to crawl remote content by changing the default content access account or by using crawl rules, change this to a domain user account. If you do not change this account to a domain user account, you cannot change the default content access account to a domain user account or add crawl rules to crawl this content. This restriction is designed to prevent elevation of privilege for any other process running as the Local System account.
Default Content Access | No manual configuration is necessary if this account is only crawling local farm content. If you want to crawl remote content by using crawl rules, change this to a domain user account, and apply the requirements listed for a server farm.
Content Access | Same requirement as the default content access account.
Profile import Default Access | Same requirements as server farm.
Excel Services Unattended Service | Must be a domain user account.

Additional application pool identity accounts

Account | Requirements
Application pool identity | No manual configuration is necessary. The Network Service account is used for the default web site that is created during Setup and configuration.

Server farm standard requirements

Server farm-level accounts

Important:

The accounts in this table apply only to SharePoint Server

Account Requirements

SQL Server service account

Use either a Local System account or a domain user account.

If a domain user account is used, this account uses Kerberos authentication by default, which requires additional configuration in your network environment. If SQL Server uses a service principal name (SPN) that is not valid (that is, that does not exist in the Active Directory Domain Services (AD DS)service environment), Kerberos authentication fails, and then NTLM is used. If SQL Server uses an SPN that is valid but is not assigned to the appropriate container in AD DS, authentication fails. Authentication will always try to use the first SPN that it finds, so ensure that there are no SPNs assigned to inappropriate containers in AD DS.

If you plan to back up to or restore from an external resource, permissions to the external resource must be granted to the appropriate account. If you use a domain user account for the SQL Server service account, grant permissions to that domain user account. However, if you use the Network Service or the Local System account, grant the machine account ((<domain_name>\<SQL_hostname>) permissions to the external resource.

Setup user account

  • Domain user account.

  • Member of the Administrators group on each server on which Setup is run.

  • SQL Server login on the computer running SQL Server.

  • Member of the Server admin SQL Server security role.

If you run Stsadm commands that affect a database, this account must be a member of the db_owner fixed database role for the database.

Server farm account

  • Domain user account.

Additional permissions are automatically granted for this account on web servers and application servers that are joined to a server farm.

This account is automatically added as a SQL Server login on the computer running SQL Server and added to the following SQL Server security roles:

  • dbcreator fixed server role

  • securityadmin fixed server role

  • db_owner fixed database role for all databases in the server farm

Note:

If you configure the Secure Store Service, the server farm account will not automatically be given db_owner access to the Secure Store Service database.

Service application service accounts

Important:

The accounts in this table apply only to SharePoint Server

Account Requirements

SharePoint Server Search service account

  • Must be a domain user account.

  • Must not be a member of the Farm Administrators group.

The following are automatically configured:

  • Access to read from the configuration database, administration content database, the search administration database, crawl databases.

  • Full Control access to the index partitions on the query servers.

Default content access account

  • Must be a domain user account.

  • Must not be a member of the Farm Administrators group.

  • Read access to external or secure content sources that you want to crawl by using this account.

  • For sites that are not a part of the server farm, this account must explicitly be granted Full Read permissions on the web applications that host the sites.

The following are automatically configured:

  • Full Read permissions are automatically granted to content databases hosted by the server farm.

Content access account

  • Read access to external or secure content sources that this account is configured to access.

  • For web sites that are not a part of the server farm, this account must explicitly be granted Full Read permissions on the web applications that host the sites.

Profile import default access account

  • Read access to the directory service.

  • The account must have the Replicate Changes permission in AD DS.

  • Manage User Profiles personalization services permission.

  • View permissions on entities used in Business Data Catalog import connections.

Excel Services unattended service account

Must be a domain user account.

Additional application pool identity accounts

Account Requirements

Application pool identity

No manual configuration is necessary.

The following are automatically configured:

  • Membership in the SP_DATA_ACCESS role for content databases and search databases associated with the web application.

  • Membership in specific application pool roles for the configuration and the SharePoint_AdminContent databases.

  • Additional permissions for this account to front-end web servers and application servers are automatically granted.

See also

Plan for SharePoint 2013

Install and deploy SharePoint 2013 (IT pros) Resource Center


Plan automatic password change in SharePoint 2013
See also

Published: April 2, 2013

Summary: Learn about the automatic password changes and how to deploy them in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

To simplify password management, the automatic password change feature enables you to update and deploy passwords without having to perform manual password update tasks across multiple accounts, services, and web applications. You can configure the automatic password change feature to determine whether a password is about to expire and reset the password using a long, cryptographically-strong random string. To implement the automatic password change feature, you have to configure managed accounts.

In this article:

  • Configure managed accounts

  • Reset passwords automatically on a schedule

  • Detect password expiration

  • Reset the account password immediately

  • Synchronize SharePoint Foundation account passwords with Active Directory Domain Services

  • Reset all passwords immediately

  • Credential change process

  • Service impact when you change passwords

Configure managed accounts

SharePoint 2013 supports how to create managed accounts to improve security and guarantee application isolation. By using managed accounts, you can configure the automatic password change feature to deploy passwords across all services in the farm. You can configure SharePoint web applications and services, running on application servers in a SharePoint farm, to use different domain accounts. You can create multiple accounts in Active Directory Domain Services (AD DS), and then register each of these accounts in SharePoint 2013. You can map managed accounts to various services and web applications in the farm.

Reset passwords automatically on a schedule

Prior to the implementation of the automatic password change feature, updating passwords required resetting each account password in AD DS and then manually updating account passwords on all of the services that are running on all the computers in the farm. To do this, you had to run the Stsadm command-line tool or use the SharePoint Central Administration web application. By using the automatic password change feature, you can now register managed accounts and enable SharePoint 2013 to control account passwords. Users have to be notified about planned password changes and related service interruptions. However, the accounts that are used by a SharePoint farm, web applications, and various services can be automatically reset and deployed within the farm as necessary, based on individually configured password reset schedules.

Detect password expiration

IT departments typically impose a policy requiring that all domain account passwords be reset regularly, for example, every 60 days. SharePoint 2013 can be configured to detect imminent password expiration, and send an e-mail notification to a designated administrator. Even without requiring administrator intervention, SharePoint 2013 can be configured to generate and reset passwords automatically. The automatic password reset schedule is also configurable to guarantee that the impact of possible service interruptions during a password reset will be minimal.

Reset the account password immediately

You can always override any automatic password reset schedule and force an immediate service account password reset by using a specific password value. In this scenario, the password for the service account can also be changed in AD DS by SharePoint 2013. The new password is then immediately propagated to other servers in the farm.

Synchronize SharePoint Foundation account passwords with Active Directory Domain Services

If AD DS and SharePoint 2013 account passwords are not synchronized, services in the SharePoint farm won't start. If an Active Directory administrator changes an Active Directory account password without coordinating the password change with a SharePoint administrator, there is a risk of service interruptions. In this scenario, a SharePoint administrator can immediately reset the password from the Account Management page using the password value that was changed in AD DS. The password is updated and immediately propagated to the other servers in the SharePoint farm.

Reset all passwords immediately

If an administrator suddenly leaves your organization, or if the service account passwords need to be immediately reset for any other reason, you can quickly create a Windows PowerShell script that calls the password change cmdlets. You can use the script to generate new random passwords and deploy the new passwords immediately.

Credential change process

When SharePoint 2013 changes the credentials for a managed account, the credential change process will occur on one server in the farm. Each server in the farm will be notified that the credentials are about to change and servers can perform critical pre-change actions, if they are necessary. If the account password has not yet been changed, then SharePoint 2013 will attempt to change the password using either a manually entered password, or a long, cryptographically-strong random string. The complexity settings will be queried from the appropriate policy (network or local), and the generated password will be equivalent to the detected settings. SharePoint 2013 will attempt to commit a password change. If it is unable to commit the password change, it will retry by using a new sequence, for a specified number of times. If the account password update process succeeds, it will proceed to the next dependent service, where it will again attempt to commit a password change. If it does not ultimately succeed, each dependent service will be notified that they can resume normal activity. Either success in committing a password change or failure to commit will result in the generation of an automated password change status notification that will be sent by e-mail to farm administrators.

Service impact when you change passwords

When an administrator performs a password change for the servers in the SharePoint search topology, there is an implied query downtime when the services are restarted. The query downtime is typically in the range of 3-5 minutes.

See also

Configure automatic password change in SharePoint 2013


Develop for SharePoint 2013

Summary: Find resources for developers who create applications to extend SharePoint 2013 functionality.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

TechNet articles for SharePoint 2013 developers

The following articles help SharePoint developers create applications for SharePoint 2013. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Code icon | Business Connectivity Services code samples for SharePoint 2013 | Find links to scenario code samples for Microsoft Business Connectivity Services in SharePoint 2013.

Additional resources for SharePoint 2013 developers

 | Content | Description
House icon | SharePoint TechCenter | Visit the TechCenter and resource centers to access videos, community sites, documentation, and more.
House icon | SharePoint Server Developer Portal | Find information about how to develop solutions for SharePoint 2013.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support


Business Connectivity Services code samples for SharePoint 2013
See also

Summary: Find links to scenario code samples for Business Connectivity Services (BCS) in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article contains links to scenario code samples for Microsoft Business Connectivity Services in SharePoint 2013.

Code sample name and description | Link to code sample
SharePoint 2013: Create external list based on app-scoped external content types Learn how to use an external list inside an app for Office and SharePoint to connect to the OData service and manipulate the data. | SharePoint 2013: Create external list based on app-scoped external content types
SharePoint 2013: Create multiple external lists with associations Learn how to add a second external list to an app for Office and SharePoint and link navigation between two external lists. | SharePoint 2013: Create multiple external lists with associations
SharePoint 2013: Accessing external lists with REST Learn how to use the Representational State Transfer (REST) object model on an external list deployed within an app for Office and SharePoint. | SharePoint 2013: Accessing external lists with REST
SharePoint 2013: Accessing complex external content types with client object model Learn how to perform operations on an app for Office and SharePoint-scoped external content type by using the new client-side object model for Business Connectivity Services. You will learn to work with both simple and complex entities defined against an OData source. | SharePoint 2013: Accessing complex external content types with client object model
SharePoint 2013: Creating an OData source with BCS notifications Learn how to create an Internet-addressable Windows Communication Foundation service that uses the OData to send notifications to SharePoint 2013 when the underlying data changes. These notifications are used to trigger events that are attached to external lists. | SharePoint 2013: Creating an OData source with BCS notifications
SharePoint 2013: Create an app for Office and SharePoint to access a public OData source Learn how to create an app for Office and SharePoint-scoped external content type and access that data by using the Representational State Transfer (REST) API. | SharePoint 2013: Create an app for Office and SharePoint to access a public OData source
SharePoint 2013: Create a remote event receiver for external data Learn how to create a remote event receiver that performs actions based on changes in external data. | SharePoint 2013: Create a remote event receiver for external data

See also

Plan for Business Connectivity Services in SharePoint 2013
Configure Business Connectivity Services solutions for SharePoint 2013


Install and configure SharePoint 2013
See also

Summary: Deployment articles for SharePoint 2013 help you install and configure SharePoint 2013 and upgrade from earlier versions.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Articles include information about how to prepare for installation, step-by-step installation instructions, post-installation configuration steps, and upgrade information.

Before you install SharePoint 2013, review the information in Plan for SharePoint 2013.

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about how to install and configure SharePoint 2013.

Downloadable resources about SharePoint 2013 installation and configuration

Download the following content for information about how to install and configure SharePoint 2013.

 | Content | Description
Architecture icon | Technical diagrams for SharePoint 2013 | See architecture choices at a glance in these large-format diagrams.
Downloads | Downloadable eBook: Deployment guide for SharePoint 2013 | Download or print content about how to deploy SharePoint Server 2013. Available in several file formats.
Video (play button) icon | SharePoint 2013 training for IT pros | IT pro-focused how-to training and covers changes and new features for search, social, plus deployment and performance/scalability with downloadable presentations.
Lab icon | Test lab guides | Get up and running quickly in a test environment by following these guides that take the guesswork out of a SharePoint 2013 deployment.

TechNet articles about SharePoint 2013 installation and configuration

The following articles about how to install and configure SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Overview of SharePoint 2013 installation and configuration | Learn about how to install and configure SharePoint 2013 in a farm.
Building blocks | Prepare for installation of SharePoint 2013 | Learn about permissions, accounts, security settings, and what you have to do to prepare your environment for SharePoint 2013.
123 steps | Install SharePoint 2013 | Introduces articles that describe how to install SharePoint 2013 in various topologies, in both physical and virtual environments.
Settings icon | Configure SharePoint 2013 | Introduces articles that describe how to configure settings (such as services, authentication, and specific features) after you install SharePoint 2013.
123 steps | Create a web application in SharePoint 2013 | Learn how to create SharePoint 2013 web applications to isolate content for specific types of users within your site collections.
123 steps | Create a site collection in SharePoint 2013 | Learn how to create a SharePoint 2013 site collection in an existing web application.
Building blocks | Install and manage solutions for SharePoint 2013 | Learn how to install solutions or components that were customized by developer or web designers to a SharePoint 2013 environment.
Building blocks | Install and manage apps for SharePoint 2013 | Learn about apps for SharePoint, the SharePoint Store, and the App Catalog and find steps for how to install, manage, and monitor apps.
Building blocks | Upgrade to SharePoint 2013 | Learn how to plan, prepare for, troubleshoot, and perform an upgrade to SharePoint 2013.

Videos about SharePoint 2013 installation and configuration

The following video recordings about how to install and configure SharePoint 2013 are available to view online or to download.

 | Content | Description
Video (play button) icon | SharePoint 2013 training for IT pros | Find IT pro-focused how-to training and walkthrough videos with this interactive course about SharePoint 2013 including changes and new features for search, social, plus deployment and performance/scalability.

Additional resources about SharePoint 2013 installation and configuration

The following resources about how to install and configure SharePoint 2013 are available from other subject matter experts.

 | Content | Description
House icon | SharePoint 2013 Tech Center | Visit the TechCenter to access videos, community sites, documentation, and more.
Code icon | SharePoint developer center | Find resources for building solutions on SharePoint 2013. This includes how-to articles, code samples, and the SharePoint SDK.
Chat icon | To the SharePoint Office 365 Technical Blog | Read draft content, learn about new content, and join the conversation at this IT pro content team blog. Learn how to get the most out of SharePoint sites by reading this blog.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support

See also

Installation and Deployment for SharePoint 2013 Resource Center


Overview of SharePoint 2013 installation and configuration

Summary: Learn about how to install and configure SharePoint Server 2013 or SharePoint Foundation 2013 in a farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Although SharePoint products farms vary in complexity and size, a combination of careful planning and a phased deployment that includes ongoing testing and evaluation significantly reduces the risk of unexpected outcomes. This article provides an overview for all types of SharePoint 2013 farm deployment.

For a visual representation of the information in this article, see the SharePoint 2013 Products Deployment model in the Technical diagrams for SharePoint 2013 topic. Related technical diagrams include "Topologies for SharePoint 2013 and Services inSharePoint Server 2013".

In this article:

  • Concepts

  • Physical architecture

  • Installation and configuration

  • Deployment stages

Concepts

The logical result of SharePoint 2013's flexibility and richness can be a high degree of complexity around installing and configuring SharePoint 2013 correctly. A fundamental understanding of the following key structural elements in a SharePoint 2013 environment is required in order to correctly deploy and support SharePoint 2013:

  • Server farm: The top-level element of a logical architecture design for SharePoint 2013.

  • Web application: An IIS Web site that is created and used by SharePoint 2013.

  • Content database: Provides storage Web application content. You can separate content into multiple content databases at the site collection level.

  • Site collection: A set of Web sites that have the same owner and share administration settings.

  • Site: One or more related Web pages and other items (such as lists, libraries, and documents) that are hosted inside a site collection.

For more information about these and other architectural components, see Plan logical architectures for SharePoint 2013.

In addition to understanding the elements of a SharePoint 2013 environment and how they have to be configured for your solution, you must consider the following additional factors: physical architecture, installation and configuration, and the various stages of deployment.

Physical architecture

The physical architecture, which consists of one or more servers and the network infrastructure, enables you to implement the logical architecture for a SharePoint 2013 solution. The physical architecture is typically described in two ways: by its size and by its topology. Size, which can be measured in several ways, such as the number of users or the number of documents, is used to categorize a farm as small, medium, or large. Topology uses the idea of tiers or server groups to define a logical arrangement of farm servers.

Size

Size uses the number of users and number of content items as a fundamental measure to indicate whether a server farm is small, medium, and large, as follows:

  • A small server farm typically consists of at least two Web servers and a database server. One of the Web servers hosts the Central Administration site and the other handles additional farm-related tasks, such as serving content to users.

    The small farm can be scaled out to three tiers using a dedicated application server in response to the number of users, the number of content items, and the number of services that are required.

  • A medium server farm typically consists of two or more Web servers, two application servers, and more than one database servers. We recommend that you start with the preceding configuration and then scale out to accommodate the workload placed on the servers.

    In scenarios where services are known to use a disproportionate amount of resources, you can scale out the application tier. Performance data will indicate which services you should consider off-loading to a dedicated server.

  • A large server farm can be the logical result of scaling out a medium farm to meet capacity and performance requirements or by design before a SharePoint 2013 solution is implemented. A three-tier topology environment typically uses dedicated servers on all the tiers. Additionally, these servers are often grouped according to their role in the farm. For example, all client-related services can be grouped onto one or two servers and then scaled out by adding servers to this group as needed in response to user demand for these services.

    Note:

    The recommendation for scaling out a farm is to group services or databases with similar performance characteristics onto dedicated servers and then scale out the servers as a group. In large environments, the specific groups that evolve for a farm depend on the specific demands for each service in a farm.

For specific numbers related to small, medium, and large farms, see Plan for performance and capacity management in SharePoint Server 2013.

Topology

Topology uses tiers as a model for logically arranging farm servers according to the components that they host or their roles in a server farm. A SharePoint 2013 farm is deployed on one, two, or three tiers, as follows:

  • In a single-tier deployment, SharePoint 2013 and the database server are installed on one computer.

  • In a two-tier deployment, SharePoint 2013 components and the database are installed on separate servers. This kind of deployment maps to what is called a small farm. The front-end Web servers are on the first tier and the database server is located on the second tier. In the computer industry, the first tier is known as the Web tier. The database server is known as the database tier or database back-end.

  • In a three-tier deployment, the front-end Web servers are on the first tier, the application servers are on the second tier, which is known as the application tier, and the database server is located on the third tier. A three-tier deployment is used for medium and large farms.

Installation and configuration

After you finish planning your solution you can create a SharePoint 2013 farm to host the solution. The first step is to install SharePoint 2013 and create the farm that is required for the solution. The process of preparing your environment consists of the following phases:

  1. Prepare the servers

  2. Create the farm

  3. Configure settings, services, solutions, and sites

Note:

The farm that you create and deploy will undergo significant changes in size, topology, and complexity as you move through the different deployment stages illustrated in the SharePoint 2013 Products Deployment model. This is typical and the expected result of a phased deployment. This is why we recommend that you follow all of the stages described in the "Deployment stages" section of this article.

Prepare the servers

In this phase, you get your servers ready to host the product. This includes the supporting servers and the servers that will have SharePoint 2013 installed. The following servers must be configured to support and host a farm:

  • Database server: The required version of SQL Server, including service packs and cumulative updates must be installed on the database server. The installation must include any additional features, such as SQL Analysis Services, and the appropriate SharePoint 2013 logins have to be added and configured. The database server must be hardened and, if it is required, databases must be created by the DBA. For more information, see:

    • Hardware and software requirements for SharePoint 2013

    • Configure SQL Server security for SharePoint 2013 environments

  • Application servers and front-end Web servers: The farm servers that will have SharePoint 2013 installed must be prepared as follows: verify that they meet the hardware requirements, have the operating system hardened, have the required networking and security protocols configured, have the SharePoint 2013 software prerequisites installed and hardened, and have the required authentication configured. For more information, see:

    • System requirements for SharePoint 2013

    • "Installing software prerequisites" in Hardware and software requirements for SharePoint 2013

    • Plan security hardening for SharePoint 2013

    • Plan authentication in SharePoint 2013

  • Domain controller: The required farm accounts have to be configured for the domain and directory synchronization must be configured.

    Important:

    SharePoint 2013 does not support installation on to a domain controller in a production environment. A single label domain (SLD) names or single label forests is also not supported. Because the use of SLD names is not a recommended practice, SharePoint 2013 is not tested in this scenario. Therefore, there may be incompatibility issues when SharePoint 2013 are implemented in a single label domain environment. For more information, see Information about configuring Windows for domains with single-label DNS names and the DNS Namespace Planning Solution Center.

    For information about required accounts, see:

    • Initial deployment administrative and service accounts in SharePoint 2013

    • About Directory Synchronization (http://go.microsoft.com/fwlink/p/?LinkId=193169)

Create the farm

In this phase, you install the product and configure each server to support its role in the farm. You also create the configuration database and the SharePoint Central Administration Web site. The following servers are required for a SharePoint 2013 farm:

  • Database server: Unless you plan to use DBA-created databases, the configuration database, content database, and other required databases are created when you run the SharePoint Products Configuration Wizard.

  • Application server: After you prepare the application server, install any additional components that are required to support functions such as Information Rights Management (IRM) and decision support. Install SharePoint 2013 on the server that will host SharePoint Central Administration Web site and then run the SharePoint Products Configuration Wizard to create and configure the farm.

  • Front-end Web server: Install SharePoint 2013 on each Web server, install language packs, and then run the SharePoint Products Configuration Wizard to add the Web servers to the farm.

    Note:

    After you add and configure all the front-end Web servers, you can add any additional application servers that are part of your topology design to the farm.

For more information about supported deployment scenarios, see Install SharePoint 2013.

Configure settings, services, solutions, and sites

In this phase, you prepare the farm to host your site content by completing the following tasks:

  • Configure services. For more information, see Configure services and service applications in SharePoint 2013

  • Configure global settings. For more information, see Configure SharePoint 2013

  • Create and populate the sites. For more information, see Set up Web applications and sites (SharePoint 2013)

Note:

Farm configuration steps are not isolated to a specific tier in the server infrastructure.

Deployment stages

By deploying a SharePoint 2013 solution in stages, you gain the benefits that are provided by a systematic approach, such as collecting performance and usage data that you can use to evaluate your solution. Additional benefits include verifying your capacity management assumptions and identifying issues before the farm is put into production.

We recommend that you deploy your farm in the following stages:

  • Planning

  • Development

  • Proof of concept

  • Pilot

  • User acceptance test

  • Production

Planning

Before you can deploy a farm, you must plan the solution that you want to deploy and determine the infrastructure requirements, such as server resources and farm topology. When you finish the planning stage, you should have documented the following:

  • An infrastructure design to support your solution

  • A detailed description of how you will implement the farm and the solution

  • A plan for testing and validating the solution

  • A site and solution architecture

  • An understanding of the monitoring and sustained engineering requirements to support the solution

  • A record of how the solution will be governed

  • An understanding of how the solution will be messaged to the user to drive adoption of the solution

We recommend that you use the planning resources and articles described in Plan for SharePoint 2013.

Important:

Resource and time issues may pressure you to be less rigorous during the planning stage. We recommend that you try to be as diligent as possible because missed or lightly touched planning elements can resurface as significant issues after you are in production. These issues can create much additional work, consume unbudgeted resources, and potentially take away from the success of your SharePoint 2013.

After the planning stage, you move through the following deployment stages, updating and revising your plans, configurations, and topologies as you test.

Development

During the development stage you will deploy SharePoint 2013 on a single server or on multiple servers to develop, test, evaluate, and refine the solution that you intend to implement. This environment is scaled according to your needs during solution development and can be retained as a scaled down environment for future development and testing. This is not a stable environment and there are no service-level agreements.

Proof of concept

During the proof of concept stage, the objective is two-fold: to understand SharePoint 2013 and to evaluate SharePoint 2013 in the context of how it can address your business needs. The first level of product evaluation can be done by installing all of the product components on a single server. You do a more extensive product evaluation by a proof-of-concept deployment.

A proof-of-concept deployment on a single server or on a small farm enables you to expand the scope of your evaluation. In this deployment, non-IT staff is added to the evaluation team, which provides a broader view of how SharePoint 2013 features might be actually be used in the organization. The benefit of a proof-of-concept deployment is that you can collect data that can be used to refine your original plan. This data—such as page views, user behavior patterns, and server resource consumption—also enables you to start to build a benchmark for sizing your farm. A proof of concept is also good when you evaluate service applications and determining what feature sets that you will offer your end users.

It is important during the proof-of-concept stage that you understand the unique characteristics and functionality of these features because this understanding will help you define your overall topology. Be aware that a proof-of-concept deployment requires additional resources and extends the time required to put SharePoint 2013 into production.

Tip:

Virtualization provides a good platform for evaluating SharePoint 2013 because a virtual environment provides flexibility, rapid deployment capability, and the ability to roll back virtual machines to previous states.

Pilot

A pilot is used to test your solution on a small scale. There are two approaches to using a pilot deployment. In the first approach, the focus is on functional testing without using real data. By using the second approach you test for production characteristics by using real data and have your pilot users test different kinds of tasks. We recommend the second approach because of the broader scope and real-world data that you can collect and use to refine your solution design.

A pilot deployment provides many benefits. It enables you to collect data that you can use to validate the following aspects of your farm design:

  • Infrastructure design

  • Capacity management assumptions

  • Site and solution architecture

  • Solution usage assumptions

The pilot stage also enables you to determine additional data that should be collected to increase the breadth and depth of your benchmarks. This is important if you want to assess the potential effect of additional features or services that you want to add to the farm before the user acceptance test.

At the conclusion of the pilot deployment, you can use the data that you collect to adjust the various components of the solution and its supporting infrastructure.

User acceptance test (UAT)

A user acceptance test deployment—also known as a pre-production environment—is used by organizations as a transitional step from the pilot deployment to a production deployment. An organization's business processes determine the scope, scale, and duration of user accept testing.

The topology of the pre-production environment should be the same as, or very similar to the planned production topology. During user acceptance testing, the SharePoint 2013 solution is tested against a subset or a complete copy of production data. This deployment stage provides a final opportunity for performance tuning and validating operational procedures such as backups and restores.

Production

The final stage is rolling your farm into a production environment. At this stage, you will have incorporated the necessary solution and infrastructure adjustments that were identified during the user acceptance test stage.

Putting the farm into production requires you to complete the following tasks:

  • Deploy the farm.

  • Deploy the solution.

  • Implement the operations plan.

  • If required, deploy additional environments such as authoring and staging farms, and services farms.


Prepare for installation of SharePoint 2013

Summary: Learn about permissions, accounts, security settings, and what you have to do to prepare your environment for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about how to prepare for SharePoint 2013 installation and initial configuration.

TechNet articles about how to prepare for SharePoint 2013 installation and initial configuration

The following articles about how to prepare for SharePoint 2013 installation and initial configuration are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Initial deployment administrative and service accounts in SharePoint 2013 | Provides information about the administrative and service accounts that are required for an initial SharePoint 2013 installation.
 | Account permissions and security settings in SharePoint 2013 | Describes SharePoint 2013 administrative and services account permissions. This article discusses the following areas: Microsoft SQL Server, the file system, file shares, and registry entries.
 | Configure SQL Server security for SharePoint 2013 environments | Learn how to harden SQL Server for SharePoint 2013 environments by using SQL Server tools and Windows Firewall.
 | Install prerequisites for SharePoint 2013 from a network share | Describes how to install SharePoint 2013 prerequisites from an offline shared network location using the prerequisite installer (PrerequisiteInstaller.exe) tool.

Additional resources about SharePoint 2013 installation and initial configuration

The following resources about SharePoint 2013 installation and initial configuration are available from other subject matter experts.

Content Description

TechNet logo

  • Installation and Deployment for SharePoint 2013 Resource Center

  • Capabilities and features in SharePoint 2013 Resource Center

Visit the Resource Center to access videos, Community Sites, documentation, and more.


Initial deployment administrative and service accounts in SharePoint 2013
See also

Summary: Learn about the administrative and service accounts that are required to initially install SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

This article provides information about the administrative and service accounts that are required for an initial SharePoint 2013 deployment. Additional accounts and permissions are required to fully implement all aspects of a production farm.

Note:

For a complete list of permissions, see Account permissions and security settings in SharePoint 2013.

Required accounts

To deploy SharePoint 2013 on a server farm, you must provide credentials for several different accounts.

The following table describes the accounts that are used to install and configure SharePoint 2013.

Account Purpose Requirements

SQL Server service account

The SQL Server service account is used to run SQL Server. It is the service account for the following SQL Server services:

  • MSSQLSERVER

  • SQLSERVERAGENT

If you do not use the default SQL Server instance, in the Windows Services console, these services will be shown as the following:

  • MSSQL<InstanceName>

  • SQLAgent<InstanceName>

Use either a Local System account or a domain user account.

If you plan to back up to or restore from an external resource, permissions to the external resource must be granted to the appropriate account. If you use a domain user account for the SQL Server service account, grant permissions to that domain user account. However, if you use the Network Service or the Local System account, grant permissions to the external resource to the machine account (<domain_name>\<SQL_hostname>).

The instance name is arbitrary and was created when SQL Server was installed.

Setup user account

The Setup user account is used to run the following:

  • Setup

  • SharePoint Products Configuration Wizard

  • Domain user account.

  • Member of the Administrators group on each server on which Setup is run.

  • SQL Server login on the computer that runs SQL Server.

  • Member of the following SQL Server roles:

    • securityadmin fixed server role

    • dbcreator fixed server role

If you run Windows PowerShell cmdlets that affect a database, this account must be a member of the db_owner fixed database role for the database.

Server farm account or database access account

The server farm account is used to perform the following tasks:

  • Configure and manage the server farm.

  • Act as the application pool identity for the SharePoint Central Administration Web site.

  • Run the Microsoft SharePoint Foundation Workflow Timer Service.

  • Domain user account.

Additional permissions are automatically granted for the server farm account on Web servers and application servers that are joined to a server farm.

The server farm account is automatically added as a SQL Server login on the computer that runs SQL Server. The account is added to the following SQL Server security roles:

  • dbcreator fixed server role

  • securityadmin fixed server role

  • db_owner fixed database role for all SharePoint databases in the server farm

Note:

We recommend that you install SharePoint 2013 by using least-privilege administration.

See also

Account permissions and security settings in SharePoint 2013

Installation and Deployment for SharePoint 2013 Resource Center


Account permissions and security settings in SharePoint 2013
See also

Published: September 4, 2012

Summary: Learn about the permissions and security settings to use with a deployment of SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes SharePoint administrative and services account permissions for the following areas: Microsoft SQL Server, the file system, file shares, and registry entries.

In this article:

  • About account permissions and security settings

  • SharePoint administrative accounts

  • SharePoint service application accounts

  • SharePoint database roles

  • Group permissions

About account permissions and security settings

The SharePoint Configuration Wizard (Psconfig) and the Farm Creation Wizard, both of which are run during a Complete installation, configure many of the SharePoint baseline account permissions and security settings.

SharePoint administrative accounts

One of the following SharePoint components automatically configures most of the SharePoint administrative account permissions during the setup process:

  • The SharePoint Configuration Wizard (Psconfig).

  • The Farm Creation Wizard.

  • The SharePoint Central Administration web site.

  • Windows PowerShell.

Setup user administrator account

This account is used to set up each server in your farm by running the SharePoint Configuration Wizard, the initial Farm Creation Wizard, and Windows PowerShell. For the examples in this article, the setup user administrator account is used for farm administration, and you can use Central Administration to manage it. Some configuration options, for example, configuration of the SharePoint 2013 Search query server, require local administration permissions. The setup user administrator account requires the following permissions:

  • It must have domain user account permissions.

  • It must be a member of the local administrators group on each server in the SharePoint farm, excluding the server running SQL Server and the Simple Mail Transfer Protocol (SMTP) server.

  • This account must have access to the SharePoint databases.

  • If you use any Windows PowerShell operations that affect a database, the setup user administrator account must be a member of the db_owner role.

  • This account must be assigned to the securityadmin and dbcreatorSQL Server security roles during setup and configuration.

Note:

The securityadmin and dbcreatorSQL Server security roles might be required for this account during a complete version-to-version upgrade because new databases might have to be created and secured for services.

After you run the configuration wizards, machine-level permissions for the setup user administrator account include:

  • Membership in the WSS_ADMIN_WPG Windows security group.

  • Membership in the IIS_WPG role.

After you run the configuration wizards, database permissions include:

  • db_owner on the SharePoint server farm configuration database.

  • db_owner on the SharePoint Central Administration content database.

Warning:

If the setup user administrator account cannot a log on to the computer running SQL Server, the configuration wizards will not run correctly. If the account that you use to run the configuration wizards does not have the appropriate special SQL Server role membership or access as db_owner on the databases, the configuration wizards will not run correctly.

SharePoint farm service account

The server farm account, which is also referred to as the database access account, is used as the application pool identity for Central Administration and as the process account for the SharePoint Foundation 2013 Timer service. The server farm account requires the following permissions:

  • It must have domain user account permissions.

Additional permissions are automatically granted to the server farm account on web servers and application servers that are joined to a server farm.

After you run the SharePoint Configuration Wizard, machine-level permissions include:

  • Membership in the WSS_ADMIN_WPG Windows security group for the SharePoint Foundation 2013 Timer service.

  • Membership in WSS_RESTRICTED_WPG for the Central Administration and Timer service application pools.

  • Membership in WSS_WPG for the Central Administration application pool.

After you run the configuration wizards, SQL Server and database permissions include:

  • Dbcreator fixed server role.

  • Securityadmin fixed server role.

  • db_owner for all SharePoint databases.

  • Membership in the WSS_CONTENT_APPLICATION_POOLS role for the SharePoint server farm configuration database.

  • Membership in the WSS_CONTENT_APPLICATION_POOLS role for the SharePoint_Admin content database.

SharePoint service application accounts

This section describes the service application accounts that are set up by default during installation.

Application pool account

The application pool account is used for application pool identity. The application pool account requires the following permission configuration settings:

The following machine-level permission is configured automatically: The application pool account is a member of WSS_WPG.

The following SQL Server and database permissions for this account are configured automatically:

  • The application pool accounts for Web applications are assigned to the SP_DATA_ACCESS role for the content databases.

  • This account is assigned to the WSS_CONTENT_APPLICATION_POOLS role associated with the farm configuration database.

  • This account is assigned to the WSS_CONTENT_APPLICATION_POOLS role associated with the SharePoint_Admin content database.

Default content access account

Important:

Information in this section applies to SharePoint Server 2013 only.

The default content access account is used within a specific service application to crawl content, unless a different authentication method is specified by a crawl rule for a URL or URL pattern. This account requires the following permission configuration settings:

  • The default content access account must be a domain user account that has read access to external or secure content sources that you want to crawl by using this account.

  • For SharePoint Server sites that are not part of the server farm, you have to explicitly grant this account full read permissions to the web applications that host the sites.

  • This account must not be a member of the Farm Administrators group.

Content access accounts

Important:

Information in this section applies to SharePoint Server 2013 only.

Content access accounts are configured to access content by using the Search administration crawl rules feature. This type of account is optional and you can configure it when you create a new crawl rule. For example, external content (such as a file share) might require this separate content access account. This account requires the following permission configuration settings:

  • The content access account must have read access to external or secure content sources that this account is configured to access.

  • For SharePoint Server sites that are not part of the server farm, you have to explicitly grant this account full read permissions to the web applications that host the sites.

Excel Services unattended service account

Important:

Information in this section applies to SharePoint Server 2013 only.

Excel Services uses the Excel Services unattended service account to connect to external data sources that require a user name and password that are based on operating systems other than Windows for authentication. If this account is not configured, Excel Services will not attempt to connect to these types of data sources. Although account credentials are used to connect to data sources of operating systems other than Windows, if the account is not a member of the domain, Excel Services cannot access them. This account must be a domain user account.

My Sites application pool account

Important:

Information in this section applies to SharePoint Server 2013 only.

The My Sites application pool account must be a domain user account. This account must not be a member of the Farm Administrators group.

The following machine-level permission is configured automatically: This account is a member of WSS_WPG.

The following SQL Server and database permissions are configured automatically:

  • This account is assigned to the WSS_CONTENT_APPLICATION_POOLS role that is associated with the farm configuration database.

  • This account is assigned to the WSS_CONTENT_APPLICATION_POOLS role that is associated with the SharePoint_Admin content database.

  • The application pool accounts for web applications are assigned to the SP_DATA_ACCESS role for the content databases

Other application pool accounts

The other application pool account must be a domain user account. This account must not be a member of the Administrators group on any computer in the server farm.

The following machine-level permission is configured automatically: This account is a member of WSS_WPG.

The following SQL Server and database permissions are configured automatically:

  • This account is assigned to the SP_DATA_ACCESS role for the content databases.

  • This account is assigned to the SP_DATA_ACCESS role for search database that is associated with the web application.

  • This account must have read and write access to the associated service application database.

  • This account is assigned to the WSS_CONTENT_APPLICATION_POOLS role that is associated with the farm configuration database.

  • This account is assigned to the WSS_CONTENT_APPLICATION_POOLS role that is associated with the SharePoint_Admin content database.

SharePoint database roles

This section describes the database roles that installation sets up by default or that you can configure optionally.

WSS_CONTENT_APPLICATION_POOLS database role

The WSS_CONTENT_APPLICATION_POOLS database role applies to the application pool account for each web application that is registered in a SharePoint farm. This enables web applications to query and update the site map and have read-only access to other items in the configuration database. Setup assigns the WSS_CONTENT_APPLICATION_POOLS role to the following databases:

  • The SharePoint_Config database (the configuration database).

  • The SharePoint_AdminContent database.

Members of the WSS_CONTENT_APPLICATION_POOLS role have the execute permission for a subset of the stored procedures for the database. In addition, members of this role have the select permission to the Versions table (dbo.Versions) in the SharePoint_AdminContent database. For other databases, the accounts planning tool indicates that access to read these databases is automatically configured. In some cases, limited access to write to a database is also automatically configured. To provide this access, permissions for stored procedures are configured.

WSS_SHELL_ACCESS database role

The secure WSS_SHELL_ACCESS database role on the configuration database replaces the need to add an administration account as a db_owner on the configuration database. By default, the setup account is assigned to the WSS_SHELL_ACCESS database role. You can use a Windows PowerShell command to grant or remove memberships to this role. Setup assigns the WSS_SHELL_ACCESS role to the following databases:

  • The SharePoint_Config database (the configuration database).

  • One or more of the SharePoint Content databases. This is configurable by using the Windows PowerShell command that manages membership and the object that is assigned to this role.

Members of the WSS_SHELL_ACCESS role have the execute permission for all stored procedures for the database. In addition, members of this role have the read and write permissions on all of the database tables.

SP_READ_ONLY database role

The SP_READ_ONLY role should be used for setting the database to read only mode instead of using sp_dboption. This role as its name suggests should be used when only read access is required for data such as usage and telemetry data.

Note:

The sp_dboption stored procedure is not available in SQL Server 2012. For more information about sp_dboption see sp_dboption.

The SP_READ_ONLY SQL role will have the following permissions:

  • Grant SELECT on all SharePoint stored procedures and functions

  • Grant SELECT on all SharePoint tables

  • Grant EXECUTE on user-defined type where schema is dbo

SP_DATA_ACCESS database role

The SP_DATA_ACCESS role is the default role for database access and should be used for all object model level access to databases. Add the application pool account to this role during upgrade or new deployments.

Note:

The SP_DATA_ACCESS role replaces the db_owner role in SharePoint 2013.

The SP_DATA_ACCESS role will have the following permissions:

  • Grant EXECUTE or SELECT on all SharePoint stored procedures and functions

  • Grant SELECT on all SharePoint tables

  • Grant EXECUTE on User-defined type where schema is dbo

  • Grant INSERT on AllUserDataJunctions table

  • Grant UPDATE on Sites view

  • Grant UPDATE on UserData view

  • Grant UPDATE on AllUserData table

  • Grant INSERT and DELETE on NameValuePair tables

  • Grant create table permission

Group permissions

This section describes permissions of groups that the SharePoint 2013 setup and configuration tools create.

WSS_ADMIN_WPG

WSS_ADMIN_WPG has read and write access to local resources. The application pool accounts for the Central Administration and Timer services are in WSS_ADMIN_WPG. The following table shows the WSS_ADMIN_WPG registry entry permissions.

Key name |  | Permissions | Inherit |  | Description
HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\VSS |  | Full control | Not Applicable |  | Not Applicable
HKEY_LOCAL_MACHINE\Software\Microsoft\Office\15.0\Registration\{90150000-110D-0000-1000-0000000FF1CE} |  | Read, write | Not Applicable |  | Not Applicable
HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Office Server |  | Read | No |  | This key is the root of the SharePoint 2013 registry settings tree. If this key is altered, SharePoint 2013 functionality will fail.
HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Office Server\15.0 |  | Full control | No |  | This key is the root of the SharePoint 2013 registry settings.
HKEY_LOCAL_MACHINE\Software\Microsoft\Office Server\15.0\LoadBalancerSettings | Read, write |  |  | No | This key contains settings for the document conversion service. Altering this key will break document conversion functionality.
HKEY_LOCAL_MACHINE\Software\Microsoft\Office Server\15.0\LauncherSettings | Read, write |  |  | No | This key contains settings for the document conversion service. Altering this key will break document conversion functionality.
HKEY_LOCAL_MACHINE\Software\Microsoft\Office Server\15.0\Search | Full control |  |  | Not Applicable | Not Applicable
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\Search | Full control |  |  | Not Applicable | Not Applicable
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\Secure | Full control |  |  | No | This key contains the connection string and the ID of the configuration database to which the machine is joined. If this key is altered, the SharePoint 2013 installation on the machine will not function.
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\WSS |  | Full control | Yes |  | This key contains settings used during setup. If this key is altered, diagnostic logging may fail and setup or post-setup configuration may fail.

The following table shows the WSS_ADMIN_WPG file system permissions.

File system path |  | Permissions | Inherit |  | Description
%AllUsersProfile%\ Microsoft\SharePoint |  | Full control | No |  | This directory contains the file-system-backed cache of the farm configuration. Processes might fail to start and the administrative actions might fail if this directory is altered or deleted.
C:\Inetpub\wwwroot\wss |  | Full control | No |  | This directory (or the corresponding directory under the Inetpub root on the server) is used as the default location for IIS Web sites. SharePoint sites will be unavailable and administrative actions might fail if this directory is altered or deleted, unless custom IIS Web site paths are provided for all IIS Web sites extended with SharePoint 2013.
%ProgramFiles%\Microsoft Office Servers\15.0 |  | Full control | No |  | This directory is the installation location for SharePoint 2013 binaries and data. The directory can be changed during installation. All SharePoint 2013 functionality will fail if this directory is removed, altered, or removed after installation. Membership in the WSS_ADMIN_WPG Windows security group is required for some SharePoint 2013 services to be able to store data on disk.
%ProgramFiles%\Microsoft Office Servers\15.0\WebServices |  | Read, write | No |  | This directory is the root directory where back-end Web services are hosted, for example, Excel and Search. The SharePoint 2013 features that depend on these services will fail if this directory is removed or altered.
%ProgramFiles%\Microsoft Office Servers\15.0\Data |  | Full control | No |  | This directory is the root location where local data is stored, including search indexes. Search functionality will fail if this directory is removed or altered. WSS_ADMIN_WPG Windows security group permissions are required to enable search to save and secure data in this folder.
%ProgramFiles%\Microsoft Office Servers\15.0\Logs |  | Full control | Yes |  | This directory is the location where the run-time diagnostic logging is generated. Logging functionality will not function properly if this directory is removed or altered.
%ProgramFiles%\Microsoft Office Servers\15.0\Data\Office Server | Full control |  |  | Yes | Same as the parent folder.
%windir%\System32\drivers\etc\HOSTS | Read, write |  |  | Not Applicable | Not Applicable
%windir%\Tasks | Full control |  |  | Not Applicable | Not Applicable
%COMMONPROGRAMFILES%Microsoft Shared\Web Server Extensions\15 | Modify |  |  | Yes | This directory is the installation directory for core SharePoint 2013 files. If the access control list (ACL) is modified, feature activation, solution deployment, and other features will not function correctly.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\ADMISAPI | Full control |  |  | Yes | This directory contains the SOAP services for Central Administration. If this directory is altered, remote site creation and other methods exposed in the service will not function correctly.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\CONFIG |  | Full control | Yes |  | This directory contains files used to extend IIS Web sites with SharePoint 2013. If this directory or its contents are altered, web application provisioning will not function correctly.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS |  | Full control | No |  | This directory contains setup and runtime tracing logs. If the directory is altered, diagnostic logging will not function correctly.
%windir%\temp |  | Full control | Yes |  | This directory is used by platform components on which SharePoint 2013 depends. If the access control list is modified, Web Part rendering and other deserialization operations might fail.
%windir%\System32\logfiles\SharePoint |  | Full control | No |  | This directory is used by SharePoint Server usage logging. If this directory is modified, usage logging will not function correctly. This registry key applies only to SharePoint Server.
%systemdrive\program files\Microsoft Office Servers\15 folder on Index servers |  | Full control | Not Applicable |  | This permission is granted for a %systemdrive\program files\Microsoft Office Servers\15 folder on Index servers.

WSS_WPG

WSS_WPG has read access to local resources. All application pool and services accounts are in WSS_WPG. The following table shows WSS_WPG registry entry permissions.

Key name | Permissions | Inherit | Description
HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Office Server\15.0 | Read | No | This key is the root of the SharePoint 2013 registry settings.
HKEY_LOCAL_MACHINE\Software\Microsoft\Office Server\15.0\Diagnostics | Read, write | No | This key contains settings for the SharePoint 2013 diagnostic logging. Altering this key will break the logging functionality.
HKEY_LOCAL_MACHINE\Software\Microsoft\Office Server\15.0\LoadBalancerSettings | Read, write | No | This key contains settings for the document conversion service. Altering this key will break document conversion functionality.
HKEY_LOCAL_MACHINE\Software\Microsoft\Office Server\15.0\LauncherSettings | Read, write | No | This key contains settings for the document conversion service. Altering this key will break document conversion functionality.
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\Secure | Read | No | This key contains the connection string and the ID of the configuration database to which the machine is joined. If this key is altered, the SharePoint 2013 installation on the machine will not function.
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\WSS | Read | Yes | This key contains settings that are used during setup. If this key is altered, diagnostic logging may fail and setup or post-setup configuration may fail.

The following table shows the WSS_WPG file system permissions.

File system path |  | Permissions | Inherit |  | Description
%AllUsersProfile%\ Microsoft\SharePoint |  | Read | No |  | This directory contains the file-system-backed cache of the farm configuration. Processes might fail to start and the administrative actions might fail if this directory is altered or deleted.
C:\Inetpub\wwwroot\wss |  | Read, execute | No |  | This directory (or the corresponding directory under the Inetpub root on the server) is used as the default location for IIS Web sites. SharePoint sites will be unavailable and administrative actions might fail if this directory is altered or deleted, unless custom IIS Web site paths are provided for all IIS Web sites extended with SharePoint 2013.
%ProgramFiles%\Microsoft Office Servers\15.0 |  | Read, execute | No |  | This directory is the installation location for the SharePoint 2013 binaries and data. It can be changed during installation. All SharePoint 2013 functionality will fail if this directory is removed, altered, or moved after installation. WSS_WPG read and execute permissions are required to enable IIS sites to load SharePoint 2013 binaries.
%ProgramFiles%\Microsoft Office Servers\15.0\WebServices |  | Read | No |  | This directory is the root directory where back-end Web services are hosted, for example, Excel and Search. The SharePoint 2013 features that depend on these services will fail if this directory is removed or altered.
%ProgramFiles%\Microsoft Office Servers\15.0\Logs |  | Read, write | Yes |  | This directory is the location where the runtime diagnostic logging is generated. Logging functionality will not function properly if this directory is removed or altered.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\ADMISAPI |  | Read | Yes |  | This directory contains the SOAP services for Central Administration. If this directory is altered, remote site creation and other methods exposed in the service will not function correctly.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\CONFIG | Read |  |  | Yes | This directory contains files used to extend IIS Web sites with SharePoint 2013. If this directory or its contents are altered, web application provisioning will not function correctly.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS | Modify |  |  | No | This directory contains setup and runtime tracing logs. If the directory is altered, diagnostic logging will not function correctly.
%windir%\temp | Read |  |  | Yes | This directory is used by platform components on which SharePoint 2013 depends. If the access control list is modified, Web Part rendering, and other deserialization operations may fail.
%windir%\System32\logfiles\SharePoint | Read |  |  | No | This directory is used by SharePoint Server usage logging. If this directory is modified, usage logging will not function correctly. The registry key applies only to SharePoint Server.
%systemdrive\program files\Microsoft Office Servers\15 | Read, execute |  |  | Not Applicable | The permission is granted for %systemdrive\program files\Microsoft Office Servers\15 folder on Index servers.

Local service

The following table shows the local service registry entry permission:

Key name | Permissions | Inherit | Description
HKEY_LOCAL_MACHINE\Software\Microsoft\Office Server\15.0\LoadBalancerSettings | Read | No | This key contains settings for the document conversion service. Altering this key will break document conversion functionality.

The following table shows the local service file system permission:

File system path | Permissions | Inherit | Description
%ProgramFiles%\Microsoft Office Servers\15.0\Bin | Read, execute | No | This directory is the installed location of the SharePoint 2013 binaries. All the SharePoint 2013 functionality will fail if this directory is removed or altered.

Local system

The following table shows the local system registry entry permissions:

Key name | Permissions | Inherit | Description
HKEY_LOCAL_MACHINE\Software\Microsoft\Office Server\15.0\LauncherSettings | Read | No | This key contains settings for the document conversion service. Altering this key will break document conversion functionality. This registry key applies only to SharePoint Server.
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\Secure | Full control | No | This key contains the connection string and the ID of the configuration database to which the machine is joined. If this key is altered, the SharePoint 2013 installation on the machine will not function.
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\Secure\FarmAdmin | Full control | No | This key contains the encryption key that is used to store secrets in the configuration database. If this key is altered, service provisioning and other features will fail.
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\WSS | Full control | Yes | This key contains settings that are used during setup. If this key is altered, diagnostic logging may fail and setup or post-setup configuration may fail.

The following table shows the local file system permissions:

File system path |  | Permissions | Inherit |  | Description
%AllUsersProfile%\ Microsoft\SharePoint |  | Full control | No |  | This directory contains the file-system-backed cache of the farm configuration. Processes might fail to start and administrative actions might fail if this directory is altered or deleted.
C:\Inetpub\wwwroot\wss |  | Full control | No |  | This directory (or the corresponding directory under the Inetpub root on the server) is used as the default location for IIS Web sites. SharePoint sites will be unavailable and administrative actions might fail if this directory is altered or deleted, unless custom IIS Web site paths are provided for all IIS Web sites extended with SharePoint 2013.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\ADMISAPI |  | Full control | Yes |  | This directory contains the SOAP services for Central Administration. If this directory is altered, remote site creation and other methods exposed in the service will not function correctly.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\CONFIG |  | Full control | Yes |  | If this directory or its contents are altered, Web Application provisioning will not function correctly.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS |  | Full control | No |  | This directory contains setup and run-time tracing logs. If the directory is altered, diagnostic logging will not function correctly.
%windir%\temp |  | Full control | Yes |  | This directory is used by platform components on which SharePoint 2013 depends. If the access control list is modified, Web Part rendering, and other deserialization operations might fail.
%windir%\System32\logfiles\SharePoint | Full control |  |  | No | This directory is used by SharePoint Server for usage logging. If this directory is modified, usage logging will not function correctly. This registry key applies only to SharePoint Server.

Network service

The following table shows the network service registry entry permission:

Key name | Permissions | Inherit | Description
HKEY_LOCAL_MACHINE\Software\Microsoft\Office Server\15.0\Search\Setup | Read | Not Applicable | Not Applicable

Administrators

The following table shows the administrators registry entry permissions:

Key name | Permissions | Inherit | Description
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\Secure | Full control | No | This key contains the connection string and the ID of the configuration database to which the machine is joined. If this key is altered, the SharePoint 2013 installation on the machine will not function.
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\Secure\FarmAdmin | Full control | No | This key contains the encryption key that is used to store secrets in the configuration database. If this key is altered, service provisioning and other features will fail.
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\WSS | Full control | Yes | This key contains settings that are used during setup. If this key is altered, diagnostic logging may fail and setup or post-setup configuration may fail.

The following table shows the administrators file system permissions:

File system path |  | Permissions | Inherit |  | Description
%AllUsersProfile%\ Microsoft\SharePoint |  | Full control | No |  | This directory contains the file-system-backed cache of the farm configuration. Processes might fail to start and administrative actions might fail if this directory is altered or deleted.
C:\Inetpub\wwwroot\wss |  | Full Control | No |  | This directory (or the corresponding directory under the Inetpub root on the server) is used as the default location for IIS Web sites. SharePoint sites will be unavailable and administrative actions might fail if this directory is altered or deleted, unless custom IIS web site paths are provided for all IIS web sites that are extended with SharePoint 2013.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\ADMISAPI |  | Full control | Yes |  | This directory contains the SOAP services for Central Administration. If this directory is altered, remote site creation and other methods exposed in the service will not function correctly.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\CONFIG |  | Full control | Yes |  | If this directory or its contents are altered, web application provisioning will not function correctly.
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS |  | Full control | No |  | This directory contains setup and runtime tracing logs. If the directory is altered, diagnostic logging will not function correctly.
%windir%\temp |  | Full control | Yes |  | This directory is used by platform components on which SharePoint 2013 depends. If the ACL is modified, Web Part rendering, and other deserialization operations might fail.
%windir%\System32\logfiles\SharePoint | Full control |  |  | No | This directory is used by SharePoint Server for usage logging. If this directory is modified, usage logging will not function correctly. This registry key applies only to SharePoint Server.

WSS_RESTRICTED_WPG

WSS_RESTRICTED_WPG can read the encrypted farm administration credential registry entry. WSS_RESTRICTED_WPG is only used for encryption and decryption of passwords that are stored in the configuration database. The following table shows the WSS_RESTRICTED_WPG registry entry permission:

Key name | Permissions | Inherit | Description
HKEY_LOCAL_MACHINE\Software\Microsoft\Shared Tools\Web Server Extensions\15.0\Secure\FarmAdmin | Full control | No | This key contains the encryption key that is used to store secrets in the configuration database. If this key is altered, service provisioning and other features will fail.

Users group

The following table shows the users group file system permissions:

File system path | Permissions | Inherit | Description
%ProgramFiles%\Microsoft Office Servers\15.0 | Read, execute | No | This directory is the installation location for SharePoint 2013 binaries and data. It can be changed during installation. All SharePoint 2013 functionality will fail if this directory is removed, altered, or moved after installation.
%ProgramFiles%\Microsoft Office Servers\15.0\WebServices\Root | Read, execute | No | This directory is the root directory where back-end root Web services are hosted. The only service initially installed on this directory is a search global administration service. Some search administration functionality that uses the server-specific Central Administration Settings page will not work if this directory is removed or altered.
%ProgramFiles%\Microsoft Office Servers\15.0\Logs | Read, write | Yes | This directory is the location where the run-time diagnostic logging is generated. Logging will not function properly if this directory is removed or altered.
%ProgramFiles%\Microsoft Office Servers\15.0\Bin | Read, execute | No | This directory is the installed location of SharePoint 2013 binaries. All of the SharePoint 2013 functionality will fail if this directory is removed or altered.

All SharePoint 2013 service accounts

The following table shows the all SharePoint 2013 service accounts file system permission:

File system path | Permissions | Inherit | Description
%COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS | Modify | No | This directory contains setup and runtime tracing logs. If this directory is altered, diagnostic logging will not function correctly. All SharePoint 2013 service accounts must have write permission to this directory.

See also

Install and configure SharePoint 2013


Configure SQL Server security for SharePoint 2013 environments
See also

Summary: Learn how to improve the security of SQL Server for SharePoint 2013 environments.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

When you install SQL Server, the default settings help to provide a safe database. In addition, you can use SQL Server tools and Windows Firewall to add additional security to SQL Server for SharePoint 2013 environments.

In this article:

  • Before you begin

  • Configuring a SQL Server instance to listen on a non-default port

    • To configure a SQL Server instance to listen on a non-default port

  • Blocking default SQL Server listening ports

  • Configuring Windows Firewall to open manually assigned ports

    • To configure Windows Firewall to open manually assigned ports

  • Configuring SQL Server client aliases

    • To configure a SQL Server client alias

Before you begin

Before you begin this operation, review the following tasks about how to secure your server farm:

  • Block UDP port 1434.

  • Configure named instances of SQL Server to listen on a nonstandard port (other than TCP port 1433 or UDP port 1434).

  • For additional security, block TCP port 1433 and reassign the port that is used by the default instance to a different port.

  • Configure SQL Server client aliases on all front-end web servers and application servers in the server farm. After you block TCP port 1433 or UDP port 1434, SQL Server client aliases are necessary on all computers that communicate with the computer that is running SQL Server.

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configuring a SQL Server instance to listen on a non-default port

SQL Server provides the ability to reassign the ports that are used by the default instance and any named instances. In SQL Server 2008 R2, and SQL Server 2012, you reassign the TCP port by using SQL Server Configuration Manager. When you change the default ports, you make the environment more secure against hackers who know default assignments and use them to exploit your SharePoint environment.

To configure a SQL Server instance to listen on a non-default port

  1. Verify that the user account that is performing this procedure is a member of either the sysadmin or the serveradmin fixed server role.

  2. On the computer that is running SQL Server, open SQL Server Configuration Manager.

  3. In the navigation pane, expand SQL Server Network Configuration.

  4. Click the corresponding entry for the instance that you are configuring.

    The default instance is listed as Protocols for MSSQLSERVER. Named instances will appear as Protocols for named_instance.

  5. In the main window in the Protocol Name column, right-click TCP/IP, and then click Properties.

  6. Click the IP Addresses tab.

    For every IP address that is assigned to the computer that is running SQL Server, there is a corresponding entry on this tab. By default, SQL Server listens on all IP addresses that are assigned to the computer.

  7. To globally change the port that the default instance is listening on, follow these steps:

    • For each IP address except IPAll, clear all values for both TCP dynamic ports and TCP Port.

    • For IPAll, clear the value for TCP dynamic ports. In the TCP Port field, enter the port that you want the instance of SQL Server to listen on. For example, enter 40000.

  8. To globally change the port that a named instance is listening on, follow these steps:

    • For each IP address including IPAll, clear all values for TCP dynamic ports. A value of 0 for this field indicates that SQL Server uses a dynamic TCP port for the IP address. A blank entry for this value means that SQL Server will not use a dynamic TCP port for the IP address.

    • For each IP address except IPAll, clear all values for TCP Port.

    • For IPAll, clear the value for TCP dynamic ports. In the TCP Port field, enter the port that you want the instance of SQL Server to listen on. For example, enter 40000.

  9. Click OK.

    A message indicates that that the change will not take effect until the SQL Server service is restarted. Click OK.

  10. Close SQL Server Configuration Manager.

  11. Restart the SQL Server service and confirm that the computer that is running SQL Server is listening on the port that you selected.

    You can confirm this by looking in the Event Viewer log after you restart the SQL Server service. Look for an information event similar to the following event:

    Event Type:Information

    Event Source:MSSQL$MSSQLSERVER

    Event Category:(2)

    Event ID:26022

    Date:3/6/2008

    Time:1:46:11 PM

    User:N/A

    Computer:computer_name

    Description:

    Server is listening on [ 'any' <ipv4>50000]

  12. Verification: Optionally, include steps that users should perform to verify that the operation was successful.

Blocking default SQL Server listening ports

Windows Firewall with Advanced Security uses Inbound Rules and Outbound Rules to help secure incoming and outgoing network traffic. Because Windows Firewall blocks all incoming unsolicited network traffic by default, you do not have to explicitly block the default SQL Server listening ports. For more information, see Windows Firewall with Advanced Security and Configuring the Windows Firewall to Allow SQL Server Access.

Configuring Windows Firewall to open manually assigned ports

To access a SQL Server instance through a firewall, you must configure the firewall on the computer that is running SQL Server to allow access. Any ports that you manually assign must be open in Windows Firewall.

To configure Windows Firewall to open manually assigned ports

  1. Verify that the user account that is performing this procedure is a member of either the sysadmin or the serveradmin fixed server role.

  2. In Control Panel, open System and Security.

  3. Click Windows Firewall, and then click Advanced Settings to open the Windows Firewall with Advanced Security dialog box.

  4. In the navigation pane, click Inbound Rules to display the available options in the Actions pane.

  5. Click New Rule to open the New Inbound Rule Wizard.

  6. Use the wizard to complete the steps that are required to allow access to the port that you defined in Configuring a SQL Server instance to listen on a non-default port.

    Note:

    You can configure the Internet Protocol security (IPsec) to help secure communication to and from your computer that is running SQL Server by configuring the Windows firewall. You do this by selecting Connection Security Rules in the navigation pane of the Windows Firewall with Advanced Security dialog box.

Configuring SQL Server client aliases

If you block UDP port 1434 or TCP port 1433 on the computer that is running SQL Server, you must create a SQL Server client alias on all other computers in the server farm. You can use SQL Server client components to create a SQL Server client alias for computers that connect to SQL Server.

To configure a SQL Server client alias

  1. Verify that the user account that is performing this procedure is a member of either the sysadmin or the serveradmin fixed server role.

  2. Run Setup for SQL Server on the target computer, and install the following client components:

    • Connectivity Components

    • Management Tools

  3. Open SQL Server Configuration Manager.

  4. In the navigation pane, click SQL Native Client Configuration.

  5. In the main window under Items, right-click Aliases, and select New Alias.

  6. In the Alias - New dialog box, in the Alias Name field, enter a name for the alias. For example, enter SharePoint_alias.

  7. In the Port No field, enter the port number for the database instance. For example, enter 40000. Make sure that the protocol is set to TCP/IP.

  8. In the Server field, enter the name of the computer that is running SQL Server.

  9. Click Apply, and then click OK.

  10. Verification: You can test the SQL Server client alias by using SQL Server Management Studio, which is available when you install SQL Server client components.

  11. Open SQL ServerManagement Studio.

  12. When you are prompted to enter a server name, enter the name of the alias that you created, and then click Connect. If the connection is successful, SQL ServerManagement Studio is populated with objects that correspond to the remote database.

  13. To check connectivity to additional database instances from SQL ServerManagement Studio, click Connect, and then click Database Engine.

See also

How to: Configure a Windows Firewall for Database Engine Access
How to: Configure a Server to Listen on a Specific TCP Port (SQL Server Configuration Manager)


Install prerequisites for SharePoint 2013 from a network share
See also

Summary: Learn how to how to install SharePoint 2013 prerequisites from an offline shared network location by using the prerequisite installer (PrerequisiteInstaller.exe) tool.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Installing prerequisites from an offline location is typically required when the servers on which you want to install SharePoint 2013 are isolated from the Internet. Even if this is not the case, installing prerequisites from an offline central location enables you to make sure of farm server consistency by installing a well-known and controlled set of images.

Note:

The Microsoft SharePoint Products Preparation Tool is a user interface built on PrerequisiteInstaller.exe. The Microsoft SharePoint Products Preparation Tool accepts no user input.

In this article:

  • Installer switches and arguments

  • Download and combine the SharePoint 2013 prerequisites on a file share

  • Install the SharePoint 2013 prerequisites at the command prompt

  • Install the SharePoint 2013 prerequisites by using an arguments file

  • Known issues

Important:

The steps in this article apply to SharePoint Foundation 2013 and SharePoint Server 2013.

Installer switches and arguments

By using PrerequisiteInstaller.exe with switches and arguments, you control the versions of the required software that are installed and the location from which they are installed.

PrequisiteInstaller.exe accepts single or multiple switch and argument pairs. A switch identifies the prerequisite and the argument specifies the action and the location of the prerequisite.

A switch and argument pair uses the following format:

/switch: <path>

Where:

  • /switch is a valid switch to identify a prerequisite. For example, /SQLNCli: is the switch for the Microsoft SQL Server 2008 R2 SP1 Native Client.

  • <path> is expressed as the path of a local file or the path of a file share, for example, "C:\foldername\sqlncli.msi" or "\\<servername>\<sharename>\sqlncli.msi".

Each switch and its argument are separated by a colon and a space. The argument is enclosed in quotation marks.

The switch and argument pairs can be passed to PrerequisiteInstaller.exe at the command prompt or read from an arguments text file.

Download and combine the SharePoint 2013 prerequisites on a file share

The process for downloading and combining prerequisites consists of the steps that were described in the following procedures.

To identify prerequisites

  1. Refer to Hardware and software requirements for SharePoint 2013, which lists all the required and optional software for SharePoint 2013. Additionally, this document provides the download location for each prerequisite that is available for download on the Internet.

  2. From the command prompt, navigate to the root of the SharePoint 2013 installation media or folder location.

  3. At the command prompt, type the following command and then press ENTER:

    PrerequisiteInstaller.exe /?

    This displays a list of the command-line options and switches and their corresponding arguments for installing a prerequisite from the command-line.

    Tip:

    To copy the contents of the active About window to the Clipboard, press CTRL+C.

  4. Verify that you have an accurate list of the required software. Compare the output from the prerequisite installer to the list of prerequisites in step 1.

  5. Download the prerequisites to a computer that has Internet access.

Next, follow these steps to create a central location that you can use for installing SharePoint 2013 prerequisites on all the farm servers.

To combine prerequisites

  1. Create a shared folder on a computer that can be accessed by the servers on which the prerequisites will be installed.

  2. Copy the files that you downloaded from the Internet to the shared folder.

After you finish creating an available network location for the prerequisites, use the procedure in the following section to install SharePoint 2013 prerequisites on a server.

Install the SharePoint 2013 prerequisites at the command prompt

You can install one or more of the prerequisites from the command line using the following procedure.

To install from the command line

  1. From the Start menu, open the Command Prompt window using the Run as administrator option.

  2. Navigate to the SharePoint 2013 source directory.

  3. Type the prerequisite program switch and corresponding argument for the program that you want to install, and then press ENTER, for example:

    PrerequisiteInstaller.exe /SQLNCli: "\\o15-sf-admin\SP_prereqs\sqlncli.msi"

    Note:

    To install more than one prerequisite, type each switch and argument pair. Be sure to separate each pair by a space, for example:

    PrerequisiteInstaller.exe /IDFX: "\\<path>\Windows6.1-KB974405-x64.msu" /sqlncli: "\\<path>\sqlncli.msi" /Sync: "\\<path>\Synchronization.msi"

Install the SharePoint 2013 prerequisites by using an arguments file

You can install the prerequisites from the file share using an arguments file that consists of switches and corresponding path statements to the programs that have to be installed.

When you run PrerequisiteInstaller.exe with an arguments file, the following happens:

  1. PrerequisiteInstaller.exe reads the argument file to verify that each switch is valid and that the program identified in the path statement exists.

    Note:

    If you specify an argument, PrerequisiteInstaller.exe ignores the arguments file and only processes the command-line argument.

  2. PrerequisiteInstaller.exe scans the local system to determine whether any of the prerequisites are already installed.

  3. PrerequisiteInstaller.exe installs the programs in the argument file and returns one of the following exit codes:

    • 0 - Success

    • 1 - Another instance of this application is already running

    • 2 - Invalid command line parameter

    • 1001 - A pending restart blocks installation

    • 3010 - A restart is needed

  4. If a prerequisite requires a restart, a 3010 code is generated and you are prompted to click Finish to restart the system. The behavior of the installer after a 3010 code is different depending on which of the following conditions are true on the computer:

    • If the component that requires a restart is already installed on the system, the 3010 code is generated and the remaining prerequisites are installed. After the last prerequisite is installed you are prompted to restart the system.

    • If the component that requires a restart is installed on the system by PrerequisiteInstaller.exe, the installer generates the 3010 code, and the installation of the remaining prerequisites is skipped. You are prompted to restart the system.

      After the system restarts, PrerequisiteInstaller.exe starts to run again because the startup file that is created before the restart contains a /continue flag.

    Multiple components may require a restart. So PrerequisiteInstaller.exe may have to be restarted several times. After a restart, PrerequisiteInstaller.exe ignores the arguments file and attempts to download and install the remaining prerequisites from the Internet. For more information, see Known issues.

Use the following procedure to create an arguments file.

To create an arguments file

  1. Using a text editor, create a new text document named PrerequisiteInstaller.Arguments.txt. Save this file to the same location as PrerequisiteInstaller.exe. This file will contain the switches and arguments that are used when you run the Microsoft SharePoint Products Preparation Tool.

  2. Using a text editor, edit PrerequisiteInstaller.Arguments.txt and provide file paths to the installation source for each prerequisite switch by using the following syntax:

    /switch: <path>

    Where /switch is a valid switch and <path> is a path of the installation source.

    The following example shows a complete arguments file that uses a file share as a common installation point. Do not include carriage returns in your file.

    Copy code
    /PowerShell:"<path>\WINDOWS6.1-KB2506143-x64.msu" /NETFX:"<path>\dotNetFx45_Full_x86_x64.exe" /IDFX:"<path>\Windows6.1-KB974405-x64.msu" /sqlncli: "<path>\sqlncli.msi" /Sync: "<path>\Synchronization.msi" /AppFabric:"<path>\setup.exe" /IDFX11:"<path>\Microsoft Identity Extensions.msi" /MSIPCClient:"<path>\msipc.msi" /WCFDataServices:"<path>\WcfDataServices.exe" /KB2671763:"<path>\AppFabric1.1-RTM-KB2671763-x64-ENU.exe"

  3. After you finish editing PrerequisiteInstaller.Arguments.txt, save your edits, and verify that this file is in the same directory as PrerequisiteInstaller.exe.

Use the following procedure to install the prerequisites.

To install the prerequisites using an arguments file

  1. Run PrerequisiteInstaller.exe at the command prompt to install the prerequisites.

    Caution:

    If you are prompted to click Finish to restart the system, do not do so. Instead, click Cancel. For more information, see Known issues you continue with the next step.

  2. Restart the system manually.

  3. At the command prompt type the following command and then press Enter:

    PrerequisiteInstaller.exe

Known issues

There are two known issues that affect the use of an arguments file:

  • Using line breaks in the arguments file

    If you create an arguments file and use line breaks to put each switch and argument on a separate line, the prerequisite installer fails. The workaround is to enter all the switch and argument pairs on a single line.

  • After a computer restart, the arguments file is not used

    After a restart, PrerequisiteInstaller.exe executes the startup command file, which contains a /continue flag. The /continue flag forces the installer to ignore the arguments file.

    You must prevent a restart by deleting the startup task in this command file by using one of the following options:

    Option 1

    1. Run PrerequisiteInstaller.exe by double-clicking it. The program will display the first screen with the list of prerequisites.

    2. Click Cancel. PrerequisiteInstaller.exe deletes the startup task.

    Option 2

    1. From the Start menu, choose Run and then type regedit to open the registry.

    2. Open the key HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders.

    3. Check the value for "Common Startup". This shows the directory where the startup tasks are listed.

    4. Close the registry editor without making any changes.

    5. Navigate to the startup directory, which is usually <systemdir>\ProgramData\Microsoft\Windows\Start Menu\Programs\Startup.

    6. Delete the startup task by deleting "SharePointServerPreparationToolStartup_0FF1CE14-0000-0000-0000-000000000000.cmd".

See also

Capabilities and features in SharePoint 2013 Resource Center
Installation and Deployment for SharePoint 2013 Resource Center


Install SharePoint 2013
See also

Summary: Introduces articles that describe how to install SharePoint 2013 in various topologies, on both physical and virtual environments.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Testing and implementing SharePoint 2013 solutions at different stages of the deployment life cycle requires deployments in various topologies.

The following articles on TechNet provide information about how to deploy SharePoint 2013 on one or more servers to create different topologies that you can use for testing and implementing SharePoint 2013 solutions at different stages of the deployment life cycle.

TechNet articles about how to install and configure SharePoint 2013

The following articles about how to install and configure SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Install SharePoint 2013 on a single server with SQL Server | Describes how to install SharePoint 2013 on a single server. This deployment uses SQL Server and can easily be scaled out to create two- and three-tier farm topologies.
Install SharePoint 2013 on a single server with a built-in database | Explains how to install SharePoint 2013 on a single server. This deployment uses SQL Server Express and is typically used for evaluating SharePoint 2013.
Install SharePoint 2013 across multiple servers for a three-tier farm | Describes how to install SharePoint 2013 on multiple servers. This deployment uses SQL Server and the resulting three-tier topology provides the foundation for implementing any solution.
Install and configure a virtual environment for SharePoint 2013 | This article describes how to use Windows PowerShell to install SharePoint 2013 in a Hyper-V environment.
Install or uninstall language packs for SharePoint 2013 | Describes language packs and how to download, install, and uninstall them.
Add web or application servers to farms in SharePoint 2013 | Explains how to add a web or application server to a farm. The procedures in this article apply to a SharePoint 2013 farm that consists of at least two tiers. They should not be used for converting a single server deployment to a multiple server farm.
Add a database server to an existing farm in SharePoint 2013 | Provides information about how to add a new database server to an existing SharePoint 2013 farm.
Remove a server from a farm in SharePoint 2013 | Describes how to remove a web server, application server, or a database server from a SharePoint 2013 farm.
Uninstall SharePoint 2013 | Describes how to remove SharePoint 2013 from a computer.
Install and configure a virtual environment for SharePoint 2013 | Learn about permissions, accounts, security settings, and what you have to do to prepare your Windows Server 2008 Hyper-V environment for SharePoint 2013.

Additional resources about how to install and configure SharePoint 2013

The following resources about how to install and configure SharePoint 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | Installation and Deployment for SharePoint 2013 Resource Center | Visit the Resource Center to access videos, Community Sites, documentation, and more.

See also

Capabilities and features in SharePoint 2013 Resource Center
Installation and Deployment for SharePoint 2013 Resource Center


Install SharePoint 2013 on a single server with a built-in database
See also

Summary: Learn how to install SharePoint 2013 with a built-in database on a single server.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can quickly publish a SharePoint site by deploying SharePoint 2013 on a single server that has a built-in database. This configuration is useful if you want to evaluate SharePoint 2013 features and capabilities, such as collaboration, document management, and search. This configuration is also useful if you are deploying only a few websites and you want to minimize administrative overhead.

This article contains required information and procedures to install and configure SharePoint 2013 with a built-in database on a single server.

In this article:

  • Overview

  • Before you begin

  • Install SharePoint 2013

  • Post-installation steps

Important:

The steps in this article apply to SharePoint Foundation 2013 and SharePoint Server 2013. The procedures in this topic install Microsoft SQL Server 2008 R2 SP1 Express Edition. However, User Profile synchronization does not work with the Express Edition. If you intend to use User Profile synchronization with SharePoint Server 2013, you must choose a different installation scenario.

Overview

When you deploy SharePoint 2013 on a single server that has a built-in database by using the default settings, Setup installs Microsoft SQL Server 2008 R2 SP1 Express Edition and the SharePoint product. The SharePoint Products Configuration Wizard creates the configuration database and content database for the SharePoint sites. Additionally, the SharePoint Products Configuration Wizard installs the SharePoint Central Administration website and creates your first SharePoint site collection.

Note:

This article does not describe how to install SharePoint 2013 in a farm environment, or how to upgrade from previous releases of SharePoint 2013. For more information about how to install SharePoint 2013 on a single-server farm, see Install SharePoint 2013 on a single server with SQL Server. For more information about how to install SharePoint 2013 on a multiple server farm, see Install SharePoint 2013 across multiple servers for a three-tier farm. For more information about upgrade, see Upgrade to SharePoint 2013.

Note:

The Distributed Cache service gives you a complete social computing experience. For more information about the Distributed Cache service, see Overview of microblog features, feeds, and the Distributed Cache service in SharePoint Server 2013, Manage the Distributed Cache service in SharePoint Server 2013, Plan for feeds and the Distributed Cache service in SharePoint Server 2013, and What's new in authentication for SharePoint 2013

Consider the following restrictions of this method of installation:

  • You cannot use this method on a domain controller or in a workgroup environment.

  • This method is not supported for production on a domain controller.

  • If your computer is in a workgroup, you cannot install AppFabric for Windows Server.

  • A Microsoft SQL Server 2008 R2 SP1 Express Edition database cannot be larger than 10 GB.

  • You cannot use user profile synchronization in this type of installation. If you want to use user profile synchronization, you must use a server farm installation of SharePoint 2013. For more information, see Install SharePoint 2013 on a single server with SQL Server or Install SharePoint 2013 across multiple servers for a three-tier farm, and Synchronize user and group profiles in SharePoint Server 2013.

Before you begin

Before you begin installation, make sure that you have met all hardware and software requirements. For more information, see Hardware and software requirements for SharePoint 2013. To make sure that you perform a clean installation of SharePoint 2013, you must first remove any earlier version of SharePoint 2013 and any pre-release prerequisites if installed.

Install SharePoint 2013

To install and configure SharePoint 2013, follow these steps:

  1. Run the Microsoft SharePoint Products Preparation Tool.

  2. Run Setup, which installs Microsoft SQL Server 2008 R2 SP1 Express Edition and the SharePoint product.

  3. Run the SharePoint Products Configuration Wizard, which installs and configures the configuration database, the content database, and installs the SharePoint Central Administration website. This wizard also creates your first SharePoint site collection.

  4. Configure browser settings.

  5. Perform post-installation steps.

Important:

To complete the following procedures, you must be a member of the Administrators group on the computer on which you are installing SharePoint 2013.

Run the Microsoft SharePoint Products Preparation Tool

Because the prerequisite installer downloads components from the Microsoft Download Center, you must have Internet access on the computer on which you are running the installer. Use the following procedure to install software prerequisites for SharePoint 2013.

To run the Microsoft SharePoint Products Preparation Tool

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. In the folder where you downloaded the SharePoint 2013 software, locate and then run prerequisiteinstaller.exe.

  3. On the Welcome to the Microsoft SharePoint Products Preparation Tool page, click Next.

  4. On the License Terms for software products page, review the terms, select the I accept the terms of the License Agreement(s) check box, and then click Next.

  5. On the Installation Complete page, click Finish.

  6. After you complete the Microsoft SharePoint Products Preparation Tool, you must also install the following:

    • KB 2554876

    • KB 2708075

    • KB 2759112

    • KB 2765317

Run Setup

The following procedure installs Microsoft SQL Server 2008 R2 SP1 Express Edition and the SharePoint product. At the end of Setup, you can choose to start the SharePoint Products Configuration Wizard, which is described later in this section.

To run Setup

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. On the SharePoint Server 2013 or SharePoint Foundation 2013 Start page, click Install SharePoint Server or Install SharePoint Foundation.

  3. On the Enter Your Product Key page, enter your product key, and then click Continue.

  4. On the Read the Microsoft Software License Terms page, review the terms, select the I accept the terms of this agreement check box, and then click Continue.

  5. On the Server Type tab, click Standalone.

  6. When Setup finishes, a dialog box prompts you to complete the configuration of your server. Ensure that the Run the SharePoint Products Configuration Wizard now check box is selected.

  7. Click Close to start the configuration wizard.

    Note:

    If Setup fails, check log files in the Temp folder of the user account that you used to run Setup. Ensure that you are logged in using the same user account, and then type %temp% in the location bar in Windows Explorer. If the path in Windows Explorer resolves to a location that ends in a "1" or "2", you will have to navigate up one level to view the log files. The log file name is SharePoint Server Setup (<time stamp>).

Run the SharePoint Products Configuration Wizard

Use the following procedure to install and configure the configuration database and the content database, and install the SharePoint Central Administration website.

To run the SharePoint Products Configuration Wizard

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. If you have closed the SharePoint Products Configuration Wizard, you can access it by clicking Start, point to All Programs, click SharePoint 2013 Products, and then click SharePoint 2013 Products Configuration Wizard. If the User Account Control dialog box appears, click Continue.

  3. On the Welcome to SharePoint Products page, click Next.

  4. In the dialog box that notifies you that some services might have to be restarted during configuration, click Yes.

  5. On the Configuration Successful page, click Finish.

    Note:

    If the SharePoint Products Configuration Wizard fails, check the PSCDiagnostics log files, which are located on the drive on which SharePoint 2013 is installed, in the %COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS folder.

  6. On the Template Selection page, select one of the following options, and then click OK:

    • In the Template Selection section, click a predefined template.

    • In the Solutions Gallery section, click Solutions Gallery, and customize your own site template.

  7. On the Set Up Groups for this Site page, specify who should have access to your site, and then either create a new group or use an existing group for these users by doing one of the following:

    • To create a new group, click Create a new group, and then type the name of the group and the members that you want to be part of this group.

    • To use an existing group, click Use an existing group, and then select the user group in the Item list.

  8. Click OK.

Note:

If you are prompted for your user name and password, you might have to add the SharePoint Central Administration website to the list of trusted sites and configure user authentication settings in Internet Explorer. You might also want to disable the Internet Explorer Enhanced Security settings. If you see a proxy server error message, you might have to configure proxy server settings so that local addresses bypass the proxy server. For more information about how to configure browser and proxy settings, see Configure browser settings.

Configure browser settings

After you run the SharePoint Products Configuration Wizard, you should confirm that SharePoint 2013 works correctly by configuring additional settings in Internet Explorer.

If you are not using Internet Explorer, you might have to configure additional settings for your browser. For information about supported browsers, see Plan browser support in SharePoint 2013.

To confirm that you have configured browser settings correctly, log on to the server by using an account that has local administrative credentials. Next, connect to the SharePoint Central Administration website. If you are prompted for your user name and password when you connect, perform the following procedures:

  • Add the SharePoint Central Administration website to the list of trusted sites

  • Disable Internet Explorer Enhanced Security settings

If you receive a proxy server error message, perform the following procedure:

  • Configure proxy server settings to bypass the proxy server for local addresses

To add the SharePoint Central Administration website to the list of trusted sites

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account is a member of the Administrators group on the computer on which you are performing the procedure.

  2. In Internet Explorer, on the Tools menu, click Internet Options.

  3. On the Security tab, in the Select a zone to view or change security settings area, click Trusted Sites, and then click Sites.

  4. Clear the Require server verification (https:) for all sites in this zone check box.

  5. In the Add this web site to the zone box, type the URL to your site, and then click Add.

  6. Click Close to close the Trusted Sites dialog box.

  7. Click OK to close the Internet Options dialog box.

To disable Internet Explorer Enhanced Security settings

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account is a member of the Administrators group on the computer on which you are performing the procedure.

  2. Click Start, point to All Programs, point to Administrative Tools, and then click Server Manager.

  3. In Server Manager, select the root of Server Manager.

  4. In the Security Information section, click Configure IE ESC.

    The Internet Explorer Enhanced Security Configuration dialog box appears.

  5. In the Administrators section, click Off to disable the Internet Explorer Enhanced Security settings, and then click OK.

To configure proxy server settings to bypass the proxy server for local addresses

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account is a member of the Administrators group on the computer on which you are performing the procedure.

  2. In Internet Explorer, on the Tools menu, click Internet Options.

  3. On the Connections tab, in the Local Area Network (LAN) settings area, click LAN Settings.

  4. In the Automatic configuration area, clear the Automatically detect settings check box.

  5. In the Proxy Server area, select the Use a proxy server for your LAN check box.

  6. Type the address of the proxy server in the Address box.

  7. Type the port number of the proxy server in the Port box.

  8. Select the Bypass proxy server for local addresses check box.

  9. Click OK to close the Local Area Network (LAN) Settings dialog box.

  10. Click OK to close the Internet Options dialog box.

Post-installation steps

After you install SharePoint 2013, your browser window opens to the SharePoint Central Administration website of your new SharePoint site. Although you can start to add content to the site or customize the site, we recommend that you first perform the following administrative tasks:

  • Configure usage and health data collection You can configure usage and health data collection in your server farm. The system writes usage and health data to the logging folder and to the logging database. For more information, see Configure usage and health data collection in SharePoint 2013.

  • Configure diagnostic logging You can configure diagnostic logging that might be required after initial deployment or upgrade. The default settings are sufficient for most situations, but depending on the business needs and life cycle of the farm, you might want to change these settings. For more information, see Configure diagnostic logging in SharePoint 2013.

  • Configure incoming e-mail You can configure incoming e-mail so that SharePoint sites accept and archive incoming e-mail. You can also configure incoming e-mail so that SharePoint sites can archive e-mail discussions as they occur, save e-mailed documents, and show e-mailed meetings on site calendars. In addition, you can configure the SharePoint Directory Management Service to provide support for e-mail distribution list creation and administration. For more information, see Configure incoming email for a SharePoint 2013 farm.

  • Configure outgoing e-mail You can configure outgoing e-mail so that your Simple Mail Transfer Protocol (SMTP) server sends e-mail alerts to site users and notifications to site administrators. You can configure both the "From" e-mail address and the "Reply" e-mail address that appear in outgoing alerts. For more information, see Configure outgoing email for a SharePoint 2013 farm.

  • Configure search settings You can configure search settings to crawl the content in SharePoint 2013.

See also

Installation and Deployment for SharePoint 2013 Resource Center
What's New in SharePoint 2013 Resource Center


Install SharePoint 2013 on a single server with SQL Server
See also

Summary: Learn how to install SharePoint 2013 on a single server.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A single server installation consists of one server that runs both SQL Server and SharePoint 2013. You can install and configure SharePoint 2013 on a single server if you are hosting only a few sites for a limited number of users or if you want to create a trial or development environment. This configuration is also useful if you want to configure a farm to meet your needs first, and then add servers to the farm at a later stage.

In this article:

  • Overview

  • Before you install SharePoint 2013 on a single server

  • Install SharePoint 2013 on a single server

  • Post-installation steps

Important:

The steps in this article apply to SharePoint Foundation 2013 and SharePoint Server 2013.

Overview

When you install SharePoint 2013 on a single server, you can configure SharePoint 2013 to meet your specific needs. After you have completed setup and the SharePoint Products Configuration Wizard, you will have installed binaries, configured security permissions, configured registry settings, configured the configuration database, configured the content database, and installed the SharePoint Central Administration web site. Next, you can choose to run the Farm Configuration Wizard to configure the farm, select the services that you want to use in the farm, and create the first site collection, or you can manually perform the farm configuration at your own pace.

Before you install SharePoint 2013 on a single server

Before you begin to install and configure SharePoint 2013, do the following:

  • Ensure that you are familiar with the operating-system guidelines described in Performance Tuning Guidelines for Windows Server 2008 and Performance Tuning Guidelines for Windows Server 2008 R2.

  • Ensure that you have met all hardware and software requirements. You must have a 64-bit version of Windows Server 2008 R2 SP1. For server farms, you must also have a 64-bit version of SQL Server 2008 R2 SP1. For more information about these requirements, such as specific updates that you must install, see Hardware and software requirements for SharePoint 2013.

  • Ensure that you perform a clean installation of SharePoint 2013.

  • Ensure that you are prepared to set up the required accounts by using appropriate permissions. For detailed information, see Initial deployment administrative and service accounts in SharePoint 2013.

  • Ensure the Max degree of parallelism is set to 1. For additional information about max degree of parallelism see, Configure the max degree of parallism Server Configuration option and Degree of Parallelism

Note:

The Distributed Cache service gives you a complete social computing experience. For more information about the Distributed Cache service, see Overview of microblog features, feeds, and the Distributed Cache service in SharePoint Server 2013, Manage the Distributed Cache service in SharePoint Server 2013, Plan for feeds and the Distributed Cache service in SharePoint Server 2013, and What's new in authentication for SharePoint 2013

Security

As a security best practice, we recommend that you install SharePoint 2013 by using least-privilege administration.

Install SharePoint 2013 on a single server

To install and configure SharePoint 2013 on a single server, you will follow these steps:

  1. Run the Microsoft SharePoint Products Preparation Tool, which installs all prerequisites to use SharePoint 2013.

  2. Run Setup, which installs binaries, configures security permissions, and edits registry settings for SharePoint 2013.

  3. Run SharePoint Products Configuration Wizard, which installs and configures the configuration database, installs and configures the content database, and installs the SharePoint Central Administration web site.

  4. Configure browser settings.

  5. Run the Farm Configuration Wizard, which configures the farm, creates the first site collection, and selects the services that you want to use in the farm.

  6. Perform post-installation steps.

Important:

To complete the following procedures, the account that you use must be a member of the Administrators group on the computer on which you are installing SharePoint 2013. For information about user accounts, see Initial deployment administrative and service accounts in SharePoint 2013.

Run the Microsoft SharePoint Products Preparation Tool

Because the prerequisite installer downloads components from the Microsoft Download Center, you must have Internet access on the computer on which you are running the installer. Use the following procedure to install software prerequisites for SharePoint 2013.

To run the Microsoft SharePoint Products Preparation Tool

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. In the folder where you downloaded the SharePoint 2013 software, locate and then run prerequisiteinstaller.exe.

  3. On the Welcome to the Microsoft SharePoint Products Preparation Tool page, click Next.

  4. On the License Terms for software products page, review the terms, select the I accept the terms of the License Agreement(s) check box, and then click Next.

  5. On the Installation Complete page, click Finish.

  6. After you complete the Microsoft SharePoint Products Preparation Tool, you must also install the following:

    • KB 2554876

    • KB 2708075

    • KB 2759112

    • KB 2765317

Run Setup

The following procedure installs binaries, configures security permissions, and edits registry settings for SharePoint 2013. At the end of Setup, you can choose to start the SharePoint Products Configuration Wizard, which is described later in this section.

To run Setup

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. On the SharePoint Server 2013 Start page, click Install SharePoint Server.

  3. On the Enter Your Product Key page, enter your product key, and then click Continue.

  4. On the Read the Microsoft Software License Terms page, review the terms, select the I accept the terms of this agreement check box, and then click Continue.

  5. On the Server Type tab, click Complete.

    The stand-alone option is used to install a single server that has a built-in database.

  6. Optional: To install SharePoint 2013 at a custom location, click the File Location tab, and then either type the location or click Browse to find the location.

  7. Click Install Now.

  8. When Setup finishes, a dialog box prompts you to complete the configuration of your server. Ensure that the Run the SharePoint Products and Technologies Configuration Wizard now check box is selected.

  9. Click Close to start the configuration wizard.

Note:

If Setup fails, check log files in the Temp folder of the user account you used to run Setup. Ensure that you are logged in using the same user account and then type %temp% in the location bar in Windows Explorer. If the path in Windows Explorer resolves to a location that ends in a "1" or "2", you have to navigate up one level to view the log files. The log file name is SharePoint Server Setup (<time stamp>).

Run the SharePoint Products Configuration Wizard

Use the following procedure to install and configure the configuration database and the content database, and to install the SharePoint Central Administration website.

To run the SharePoint Products Configuration Wizard

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. If you have closed the SharePoint Products Configuration Wizard, you can access it by clicking Start, point to All Programs, click SharePoint 2013 Products, and then click SharePoint 2013 Products Configuration Wizard. If the User Account Control dialog box appears, click Continue.

  3. On the Welcome to SharePoint Products page, click Next.

  4. In the dialog box that notifies you that some services might have to be restarted during configuration, click Yes.

  5. On the Connect to a server farm page, click Create a new server farm, and then click Next.

  6. On the Specify Configuration Database Settings page, do the following:

    1. In the Database server box, type the name of the computer that is running SQL Server.

    2. In the Database name box, type a name for your configuration database or use the default database name. The default name is SharePoint_Config.

    3. In the Username box, type the user name of the server farm account. Ensure that you type the user name in the format DOMAIN\user name.

      Security

      The server farm account is used to create and access your configuration database. It also acts as the application pool identity account for the SharePoint Central Administration application pool, and it is the account under which the Microsoft SharePoint Foundation Workflow Timer service runs. The SharePoint Products Configuration Wizard adds this account to the SQL Server Login accounts, the SQL Serverdbcreator server role, and the SQL Serversecurityadmin server role. The user account that you specify as the service account has to be a domain user account. However, it does not have to be a member of any specific security group on your front-end web servers or your database servers. We recommend that you follow the principle of least-privilege and specify a user account that is not a member of the Administrators group on your front-end web servers or your database servers.

    4. In the Password box, type the user password.

  7. Click Next.

  8. On the Specify Farm Security Settings page, type a passphrase, and then click Next.

    Although a passphrase resembles a password, it is usually longer to improve security. It is used to encrypt credentials of accounts that are registered in SharePoint 2013. For example, the SharePoint 2013 system account that you provide when you run the SharePoint Products Configuration Wizard. Ensure that you remember the passphrase, because you must use it every time that you add a server to the farm.

    Ensure that the passphrase meets the following criteria:

    • Contains at least eight characters

    • Contains at least three of the following four character groups:

      • English uppercase characters (from A through Z)

      • English lowercase characters (from a through z)

      • Numerals (from 0 through 9)

      • Nonalphabetic characters (such as !, $, #, %)

  9. On the Configure SharePoint Central Administration Web Application page, do the following:

    1. Either select the Specify port number check box and type the port number that you want the SharePoint Central Administration web application to use, or leave the Specify port number check box cleared if you want to use the default port number.

    2. Click either NTLM or Negotiate (Kerberos).

  10. Click Next.

  11. After you complete the SharePoint Products Configuration Wizard page, review your configuration settings to verify that they are correct, and then click Next.

    Note:

    The Advanced Settings option is not available in SharePoint 2013.

  12. On the Configuration Successful page, click Finish. When the wizard closes, setup opens the web browser and connects to Central Administration.

    If the SharePoint Products Configuration Wizard fails, check the PSCDiagnostics log files, which are located on the drive on which SharePoint 2013 is installed, in the %COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS folder.

    If you are prompted for your user name and password, you might have to add the SharePoint Central Administration web site to the list of trusted sites and configure user authentication settings in Internet Explorer. You might also want to disable the Internet Explorer Enhanced Security settings. If you see a proxy server error message, you might have to configure proxy server settings so that local addresses bypass the proxy server. Instructions for configuring proxy server settings are provided in the following section. For more information about how to configure browser and proxy settings, see Configure browser settings.

Configure browser settings

After you run the SharePoint Products Configuration Wizard, you should confirm that SharePoint 2013 works correctly by configuring additional settings in Internet Explorer.

If you are not using Internet Explorer, you might have to configure additional settings for your browser. For information about supported browsers, see Plan browser support in SharePoint 2013.

To confirm that you have configured browser settings correctly, log on to the server by using an account that has local administrative credentials. Next, connect to the SharePoint Central Administration web site. If you are prompted for your user name and password when you connect, perform the following procedures:

  • Add the SharePoint Central Administration website to the list of trusted sites

  • Disable Internet Explorer Enhanced Security settings

If you receive a proxy server error message, perform the following procedure:

  • Configure proxy server settings to bypass the proxy server for local addresses

To add the SharePoint Central Administration website to the list of trusted sites

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account is a member of the Administrators group on the computer on which you are performing the procedure.

  2. In Internet Explorer, on the Tools menu, click Internet Options.

  3. On the Security tab, in the Select a zone to view or change security settings area, click Trusted Sites, and then click Sites.

  4. Clear the Require server verification (https:) for all sites in this zone check box.

  5. In the Add this web site to the zone box, type the URL to your site, and then click Add.

  6. Click Close to close the Trusted Sites dialog box.

  7. Click OK to close the Internet Options dialog box.

To disable Internet Explorer Enhanced Security settings

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account is a member of the Administrators group on the computer on which you are performing the procedure.

  2. Click Start, point to All Programs, point to Administrative Tools, and then click Server Manager.

  3. In Server Manager, select the root of Server Manager.

  4. In the Security Information section, click Configure IE ESC.

    The Internet Explorer Enhanced Security Configuration dialog box appears.

  5. In the Administrators section, click Off to disable the Internet Explorer Enhanced Security settings, and then click OK.

To configure proxy server settings to bypass the proxy server for local addresses

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account is a member of the Administrators group on the computer on which you are performing the procedure.

  2. In Internet Explorer, on the Tools menu, click Internet Options.

  3. On the Connections tab, in the Local Area Network (LAN) settings area, click LAN Settings.

  4. In the Automatic configuration area, clear the Automatically detect settings check box.

  5. In the Proxy Server area, select the Use a proxy server for your LAN check box.

  6. Type the address of the proxy server in the Address box.

  7. Type the port number of the proxy server in the Port box.

  8. Select the Bypass proxy server for local addresses check box.

  9. Click OK to close the Local Area Network (LAN) Settings dialog box.

  10. Click OK to close the Internet Options dialog box.

Run the Farm Configuration Wizard

You have now completed setup and the initial configuration of SharePoint 2013. You have created the SharePoint Central Administration web site. You can now create your farm and sites, and you can select services by using the Farm Configuration Wizard.

To run the Farm Configuration Wizard

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. On the SharePoint Central Administration home page, on the Quick Launch, click Configuration Wizards, and then click Launch the Farm Configuration Wizard.

  3. On the Help Make SharePoint Better page, click one of the following options, and then click OK:

    • Yes, I am willing to participate (Recommended.)

    • No, I don't want to participate.

  4. On the Configure your SharePoint farm page, next to Yes, walk me through the configuration of my farm using this wizard, click Start the Wizard.

  5. On the Configure your SharePoint farm page, in the Service Account section, click the service account option that you want to use to configure your services.

    Security

    For security reasons, we recommend that you use a different account from the farm administrator account to configure services in the farm.

    If you decide to use an existing managed account — that is, an account of which SharePoint 2013 is aware — make sure that you click that option before you continue.

  6. In the Services section, review the services that you want to use in the farm, and then click Next.

    Note:

    For more information, see Configure services and service applications in SharePoint 2013. If you are using Office Web Apps, see Office Web Apps (SharePoint 2013).

  7. On the Create Site Collection page, do the following:

    1. In the Title and Description section, in the Title box, type the name of your new site.

    2. Optional: In the Description box, type a description of what the site contains.

    3. In the Web Site Address section, select a URL path for the site.

    4. In the Template Selection section, in the Select a template list, select the template that you want to use for the top-level site in the site collection.

      Note:

      To view a template or a description of a template, click any template in the Select a template list.

  8. Click OK.

  9. On the Configure your SharePoint farm page, review the summary of the farm configuration, and then click Finish.

Post-installation steps

After you install and configure SharePoint 2013, your browser window opens to the Central Administration web site of your new SharePoint site. Although you can start adding content to the site or customizing the site, we recommend that you first perform the following administrative tasks.

  • Configure usage and health data collection You can configure usage and health data collection in your server farm. The system writes usage and health data to the logging folder and to the logging database. For more information, see Configure usage and health data collection in SharePoint 2013.

  • Configure diagnostic logging You can configure diagnostic logging that might be required after initial installation or upgrade. The default settings are sufficient for most situations. Depending upon the business needs and life-cycle of the farm, you might want to change these settings. For more information, see Configure diagnostic logging in SharePoint 2013.

  • Configure incoming e-mail You can configure incoming e-mail so that SharePoint sites accept and archive incoming e-mail. You can also configure incoming e-mail so that SharePoint sites can archive e-mail discussions as they occur, save e-mailed documents, and show e-mailed meetings on site calendars. In addition, you can configure the SharePoint Directory Management Service to provide support for e-mail distribution list creation and administration. For more information, see Configure incoming email for a SharePoint 2013 farm.

  • Configure outgoing email You can configure outgoing email so that your Simple Mail Transfer Protocol (SMTP) server sends email alerts to site users and notifications to site administrators. You can configure both the "From" email address and the "Reply" email address that appear in outgoing alerts. For more information, see Configure outgoing email for a SharePoint 2013 farm.

  • Configure Search settings You can configure Search settings to crawl the content in SharePoint 2013.

See also

Capabilities and features in SharePoint 2013 Resource Center
Installation and Deployment for SharePoint 2013 Resource Center


Install SharePoint 2013 across multiple servers for a three-tier farm
See also

Summary: Learn how to install SharePoint 2013 to create a server farm that includes web servers, an application server, and a database server.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A three-tier farm configuration consists of two front-end web servers, an application server, and a database server. The deployment sequence and configurations that are described in this article are based on recommended best practices. While the farm configuration is not complex, it provides a fundamental infrastructure to implement a SharePoint 2013 solution on similar — or more complex farms.

In this article:

  • Overview

  • Prepare the farm servers

  • Install SharePoint 2013 on the farm servers

  • Create and configure the farm

  • Add web servers to the farm

  • Post-installation steps

Overview

The basic steps in this deployment are as follows:

  • Ensure that you are familiar with the concept of a three-tier topology.

  • Ensure that you have done all the planning and preparatory work, such as verifying hardware and software requirements.

  • Install the required software updates on all servers that will be part of the farm.

  • Install the SharePoint 2013 prerequisites on servers in the application and web tiers.

  • Install SharePoint 2013 on the application server and the web servers.

  • Create and configure the SharePoint farm.

  • Provision services.

  • Complete post-deployment tasks as required.

Topology overview

This topology is typically used for the medium and large farms described in Overview of SharePoint 2013 installation and configuration. In terms of performance, capacity, and scalability, a three-tier topology is recommended over a two-tier topology. A three-tier topology provides the most efficient physical and logical layout to support scaling out or scaling up, and it provides better distribution of services across the member servers of the farm. The following illustration shows the three-tier deployment that is described in this article.

Three-tier farm configuration

SharePoint Server 2010:three tier topology

In the previous illustration, note the following:

  • You can add web servers to the web tier. These servers can be configured as conventional web servers to handle user requests, or they can be configured to host dedicated query components or other service components.

  • You can add farm servers to the application tier and configure them as dedicated servers that will host the SharePoint Central Administration website or other services on the farm that require dedicated resources or isolation from the web tier — for example, crawl components, query components, and profile pages.

  • You can add database servers to the database tier to implement a stand-alone instance, database mirroring, or a failover cluster. To configure the farm for high availability, database mirroring or a failover cluster is required on the database tier.

Before you install SharePoint 2013 on multiple servers for a three-tier farm

Before you begin to install and configure SharePoint 2013, do the following:

  • Ensure that you are familiar with the operating-system guidelines described in Performance Tuning Guidelines for Windows Server 2008 and Performance Tuning Guidelines for Windows Server 2008 R2.

  • Ensure that you have met all hardware and software requirements. You must have a 64-bit version of Windows Server 2008 R2 SP1. For server farms, you must also have a supported 64-bit version of SQL Server. For more information about these requirements, such as specific updates that you must install, see Hardware and software requirements for SharePoint 2013.

  • Ensure that you perform a clean installation of SharePoint 2013.

  • Ensure that you are prepared to set up the required accounts by using appropriate permissions. For detailed information, see Initial deployment administrative and service accounts in SharePoint 2013.

Note:

If your computer is in a Workgroup, you cannot install AppFabric for Windows Server.

Note:

The Distributed Cache service gives you a complete social computing experience. For more information about the Distributed Cache service, see Overview of microblog features, feeds, and the Distributed Cache service in SharePoint Server 2013, Manage the Distributed Cache service in SharePoint Server 2013, Plan for feeds and the Distributed Cache service in SharePoint Server 2013, and What's new in authentication for SharePoint 2013

Using the Microsoft SharePoint Products Preparation Tool

The Microsoft SharePoint Products Preparation Tool checks for the presence of prerequisites, and installs and configures all required programs. The Microsoft SharePoint Products Preparation Tool requires an Internet connection to download and configure SharePoint 2013 prerequisites. The Microsoft SharePoint Products Preparation Tool runs when you start to install SharePoint 2013.

Database server

Ensure that SQL Server is updated to the required level and the TCP/IP protocol is enabled for the network configuration.

Organizations whose database administrators operate independently from SharePoint administrators will have to make sure that the correct version of SQL Server is available and updated to the required level. In addition, you will have to request a DBA-created database that is configured for your farm.

Ensure the Max degree of parallelism is set to 1. For additional information about max degree of parallelism see, Configure the max degree of parallism Server Configuration option and Degree of Parallelism.

Public updates and hotfix packages

Ensure that public updates and the required hotfix packages are installed for the operating system, SQL Server, and SharePoint 2013. We recommend that all servers be updated to the same software version before you apply the public updates.

Prepare the farm servers

Before you install SharePoint 2013 , you must check for and install all the prerequisites on the application server and the web servers by using the Microsoft SharePoint Products Preparation Tool.

Tip:

If you decide to install prerequisites manually, you can still run the Microsoft SharePoint Products Preparation Tool to verify which prerequisites are required on each server.

Use the following procedure to install prerequisites on each server in the farm.

To run the Microsoft SharePoint Products Preparation Tool

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. In the folder where you downloaded the SharePoint 2013 software, locate and then run prerequisiteinstaller.exe.

  3. On the Welcome to the Microsoft SharePoint Products Preparation Tool page, click Next.

    Note:

    The preparation tool may have to restart the local server to complete the installation of some prerequisites. The installer will continue to run after the server is restarted without manual intervention. However, you will have to log on to the server again.

  4. On the License Terms for software products page, review the terms, select the I accept the terms of the License Agreement(s) check box, and then click Next.

  5. On the Installation Complete page, click Finish.

  6. After you complete the Microsoft SharePoint Products Preparation Tool, you must also install the following:

    • KB 2554876

    • KB 2708075

    • KB 2759112

    • KB 2765317

Install SharePoint 2013 on the farm servers

After the prerequisites are installed, follow these steps to install SharePoint 2013 on each farm server.

The following procedure installs binaries, configures security permissions, and edits registry settings for SharePoint 2013. At the end of Setup, you can choose to start the SharePoint Products Configuration Wizard, which is described later in this article.

To run Setup

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. On the SharePoint 2013 Start page, click Install SharePoint Server.

  3. On the Enter Your Product Key page, enter your product key, and then click Continue.

  4. On the Read the Microsoft Software License Terms page, review the terms, select the I accept the terms of this agreement check box, and then click Continue.

  5. On the Choose the installation you want page, click Server Farm.

  6. On the Server Type tab, click Complete.

  7. On the File Location tab, accept the default location or change the installation path, and then click Install Now.

    Note:

    As a best practice, we recommend that you install SharePoint 2013 on a non-system drive.

  8. When the Setup program is finished, a dialog box prompts you to complete the configuration of your server. Clear the Run the SharePoint Products and Technologies Configuration Wizard now check box.

    Note:

    For consistency of approach, we recommend that you do not run the configuration wizard until you have installed SharePoint 2013 all application and front-end web servers that will participate in the server farm.

  9. Click Close to finish Setup.

Create and configure the farm

To create and configure the farm, you run the SharePoint Products Configuration Wizard. This wizard automates several configuration tasks, such as creating the configuration database, installing services, and creating the Central Administration website. We recommend that you run the SharePoint Products Configuration Wizard on the server that will host the SharePoint Central Administration website before you run the wizard on the other servers in the farm.

To run the SharePoint Products Configuration Wizard and configure the farm

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. On the server that will host Central Administration (the application server), click Start, point to All Programs, and then click SharePoint 2013 Products, and then click SharePoint 2013 Products Configuration Wizard. If the User Account Control dialog box appears, click Continue.

  3. On the Welcome to SharePoint Products page, click Next.

  4. In the dialog box that notifies you that some services might have to be restarted during configuration, click Yes.

  5. On the Connect to a server farm page, click Create a new server farm, and then click Next.

  6. On the Specify Configuration Database Settings page, do the following:

    1. In the Database server box, type the name of the computer that is running SQL Server.

    2. In the Database name box, type a name for your configuration database, or use the default database name. The default name is SharePoint_Config.

    3. In the Username box, type the user name of the server farm account in DOMAIN\user name format.

      Important:

      The server farm account is used to create and access your configuration database. It also acts as the application pool identity account for the SharePoint Central Administration application pool, and it is the account under which the SharePoint Timer service runs. The SharePoint Products Configuration Wizard adds this account to the SQL Server Login accounts, the SQL Serverdbcreator server role, and the SQL Serversecurityadmin server role. The user account that you specify as the service account has to be a domain user account. However, it does not have to be a member of any specific security group on your web servers or your database servers. We recommend that you follow the principle of least-privilege, and specify a user account that is not a member of the Administrators group on your front-end web servers or your database servers.

    4. In the Password box, type the user password.

  7. Click Next.

  8. On the Specify Farm Security Settings page, type a passphrase, and then click Next.

    Although a passphrase resembles a password, it is usually longer to improve security. It is used to encrypt credentials of accounts that are registered in SharePoint 2013. For example, the SharePoint 2013 system account that you provide when you run the SharePoint Products Configuration Wizard. Ensure that you remember the passphrase, because you must use it every time that you add a server to the farm.

    Ensure that the passphrase meets the following criteria:

    • Contains at least eight characters

    • Contains at least three of the following four character groups:

      • English uppercase characters (from A through Z)

      • English lowercase characters (from a through z)

      • Numerals (from 0 through 9)

      • Nonalphabetic characters (such as !, $, #, %)

  9. On the Configure SharePoint Central Administration Web Application page, do the following:

    1. Either select the Specify port number check box and type the port number that you want the SharePoint Central Administration web application to use, or leave the Specify port number check box cleared if you want to use the default port number.

      Note:

      If you want to access the SharePoint Central Administration website from a remote computer, make sure that you allow access to the port number that you configure in this step. You do this by configuring the inbound rule for SharePoint Central Administration v4 in Windows Firewall with Advanced Security.

    2. Click either NTLM or Negotiate (Kerberos).

  10. Click Next.

  11. On the Completing the SharePoint Products Configuration Wizard page, click Next.

  12. On the Configuration Successful page, click Finish.

    Note:

    If the SharePoint Products Configuration Wizard fails, check the log files on the drive on which SharePoint 2013 is installed, which are located in the %COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS folder.

  13. The Central Administration website will open in a new browser window.

    On the Help Make SharePoint Better page, click one of the following options and then click OK.

    1. Yes, I am willing to participate (Recommended).

    2. No, I don't wish to participate.

  14. On the Initial Farm Configuration Wizard page, you have the option to use a wizard to configure services or you can decide to configure services manually. For the purpose of this article, we use the manual option. Click Cancel.

    The choice that you make here is a matter of personal preference. The Farm Configuration Wizard will configure some services automatically when you run it. However, if you configure services manually, you have greater flexibility in designing your logical architecture.

    For information about how to use the wizard to configure services, see Configure services and service applications in SharePoint 2013. If you are using Microsoft Office Web Apps, see Office Web Apps overview (Installed on SharePoint 2013).

    Important:

    If you are using a DBA-created database, you cannot use the Farm Configuration Wizard, you must use SharePoint Products Configuration Wizard.

Add web servers to the farm

After you create the farm on the application server, you can add the servers for the web tier by following the same process described earlier in this topic for installing SharePoint 2013 on the server that hosts Central Administration. The only difference is that during setup, you are prompted to join an existing farm. Follow the wizard steps to join the farm.

For additional information about how to add servers to a farm, see Add web or application servers to farms in SharePoint 2013. This article also provides detailed information for the steps in the following procedure.

Post-installation steps

After you install and configure SharePoint 2013, your browser window opens to the Central Administration web site of your new SharePoint site. Although you can start adding content to the site or customizing the site, we recommend that you first perform the following administrative tasks.

  • Configure usage and health data collection You can configure usage and health data collection in your server farm. The system writes usage and health data to the logging folder and to the logging database. For more information, see Configure usage and health data collection in SharePoint 2013.

  • Configure diagnostic logging You can configure diagnostic logging that might be required after initial installation or upgrade. The default settings are sufficient for most situations. Depending upon the business needs and life-cycle of the farm, you might want to change these settings. For more information, see Configure diagnostic logging in SharePoint 2013.

  • Configure incoming e-mail You can configure incoming e-mail so that SharePoint sites accept and archive incoming e-mail. You can also configure incoming e-mail so that SharePoint sites can archive e-mail discussions as they occur, save e-mailed documents, and show e-mailed meetings on site calendars. In addition, you can configure the SharePoint Directory Management Service to provide support for e-mail distribution list creation and administration. For more information, see Configure incoming email for a SharePoint 2013 farm.

  • Configure outgoing email You can configure outgoing email so that your Simple Mail Transfer Protocol (SMTP) server sends email alerts to site users and notifications to site administrators. You can configure both the "From" email address and the "Reply" email address that appear in outgoing alerts. For more information, see Configure outgoing email for a SharePoint 2013 farm.

  • Configure Search settings You can configure Search settings to crawl the content in SharePoint 2013.

See also

Capabilities and features in SharePoint 2013 Resource Center
Installation and deployment for SharePoint 2013 IT Pros Resource Center


Install or uninstall language packs for SharePoint 2013
See also

Summary: Learn how to download, install, and uninstall language packs for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Language packs enable site owners and site collection administrators to create SharePoint sites and site collections in multiple languages without requiring separate installations of SharePoint 2013. You install language packs, which contain language-specific site templates, on web and application servers. When an administrator creates a site or a site collection that is based on a language-specific site template, the text that appears on the site or the site collection is displayed in the site template's language. Language packs are typically used in multinational deployments where a single server farm supports users in different locations, or when sites and web pages must be duplicated in one or more languages.

If users are accessing Project Server 2013 in the SharePoint farm and have to view their project data in another language, they will also have to install a corresponding Project Server 2013 language pack. For more information about Project Server 2013 language packs, see Deploy language packs in Project Server 2013

Word breakers and stemmers enable you to search efficiently and effectively across content on SharePoint sites and site collections in multiple languages without requiring separate installations of SharePoint 2013. Word breakers and stemmers are automatically installed on web and application servers by Setup.

Important:

If you are uninstalling SharePoint 2013, you must uninstall all language packs before you uninstall SharePoint 2013.

In this article:

  • About language IDs and language packs

  • Downloading language packs

  • Installing language packs on the web and application servers

  • Uninstalling language packs

About language IDs and language packs

Site owners or site collection administrators who create sites or site collections can select a language for each site or site collection.

The language that they select has a language identifier (ID). The language ID determines the language that is used to display and interpret text that is on the site or site collection. For example, when a site owner creates a site in French, the site's toolbars, navigation bars, lists, and column headings appear in French. Similarly, if a site owner creates a site in Arabic, the site's toolbars, navigation bars, lists, and column headings appear in Arabic. In addition, the default left-to-right orientation of the site changes to a right-to-left orientation to correctly display Arabic text.

The language packs that are installed on the web and application servers determine the list of available languages that you can use to create a site or site collection. By default, sites and site collections are created in the language in which SharePoint 2013 was installed. For example, if you install the Spanish version of SharePoint 2013, the default language for sites, site collections, and web pages is Spanish. If someone has to create sites, site collections, or web pages in a language other than the default SharePoint 2013 language, you must install the language pack for that language on the web and application servers. For example, if you are running the French version of SharePoint 2013, and a site owner wants to create sites in French, English, and Spanish, you must install the English and Spanish language packs on the web and application servers.

By default, when a site owner creates a new web page in a site, the site displays text in the language that is specified by the language ID.

Language packs are not bundled into multilingual installation packages. You must install a specific language pack for each language that you want to support. Also, language packs must be installed on each web and application server to make sure that that each web and application server can display content in the specified language.

Important:

You cannot change an existing site, site collection, or web page from one language to another by applying different language-specific site templates. After you use a language-specific site template for a site or a site collection, the site or site collection always displays content in the language of the original site template.

Only a limited set of language packs are available for SharePoint 2013.

Although a site owner specifies a language ID for a site, some user interface elements such as error messages, notifications, and dialog boxes do not display in the language that was specified. This is because SharePoint 2013 relies on several supporting technologies — for example, the Microsoft .NET Framework, Microsoft Windows Workflow Foundation, Microsoft ASP.NET, and SQL Server — some of which are localized into only a limited number of languages. If a user interface element is generated by any of the supporting technologies that are not localized into the language that the site owner specified for the site, the user interface element appears in English. For example, if a site owner creates a site in Hebrew, and the .NET Framework component displays a notification message, the notification message will not display in Hebrew because the .NET Framework is not localized into Hebrew. This situation can occur when sites are created in any language except the following: Chinese, French, German, Italian, Japanese, Korean, and Spanish.

Each language pack that you install creates a folder at %COMMONPROGRAMFILES%\Microsoft Shared\Web server extensions\15\LAYOUTS\Locale_ID that contains language-specific data. In each locale_ID folder, you must have only one HTML error file that contains the error information that is used when a file cannot be found. Anytime a file cannot be found for any site in that language, this file will be used. You can specify the file to use by setting the FileNotFoundPage for each web application.

In some cases, some text might originate from the original installation language, which can create a mixed-language experience. This kind of mixed-language experience is typically seen only by content creators or site owners and is not seen by site users.

Downloading language packs

Follow these steps for each language that you want to support. If you decide to download more than one language, please be aware that a unique file that has a common name is downloaded for each language. Therefore, make sure that you download each language pack to a separate folder on the hard disk so that you do not overwrite a language pack of a different language.

Important:

By default, the Windows PowerShell Help files are installed in English (en-us). To view these files in the same language as the operating system, install the language pack for the same language in which the operating system was installed.

You can download language packs from the same location where you downloaded SharePoint 2013.

Installing language packs on the web and application servers

After you install the necessary language files on the web and application servers, you can install the language packs. Language packs are available as individual downloads (one download for each supported language). If you have a server farm environment and you are installing language packs to support multiple languages, you must install the language packs on each web and application server.

Important:

The language pack is installed in its native language. The procedure that follows is for the English language pack.

To install a language pack

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. In the folder where you downloaded the language pack, run setup.exe.

  3. On the Read the Microsoft Software License Terms page, review the terms, select the I accept the terms of this agreement check box, and then click Continue.

  4. The Setup wizard runs and installs the language pack.

  5. Rerun the SharePoint Products Configuration Wizard by using the default settings. If you do not run the SharePoint Products Configuration Wizard after you install a language pack, the language pack will not be installed correctly.

    The SharePoint Products Configuration Wizard runs in the language of the base installation of SharePoint 2013, not in the language of the language pack that you just installed.

To rerun the SharePoint 2013 Configuration Wizard

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. Click Start, point to All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Products Configuration Wizard.

  3. On the Welcome to SharePoint Products page, click Next.

  4. Click Yes in the dialog box that alerts you that some services might have to be restarted during configuration.

  5. On the Modify Server Farm Settings page, click Do not disconnect from this server farm, and then click Next.

  6. If the Modify SharePoint Central Administration Web Administration Settings page appears, do not change any of the default settings, and then click Next.

  7. After you complete the Completing the SharePoint Products and Technologies Configuration Wizard, click Next.

  8. On the Configuration Successful page, click Finish.

  9. After you install a new language pack and rerun the Rerun the SharePoint 2013 Configuration Wizard, you must deactivate and then reactivate any language-specific features before you use the new language pack.

When you install language packs, the language-specific site templates are installed in the %COMMONPROGRAMFILES%\Microsoft Shared\Web server extensions\15\TEMPLATE\LanguageID directory, where LanguageID is the Language ID number for the language that you are installing. For example, the United States English language pack installs to the %COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\TEMPLATE\1033 directory. After you install a language pack, site owners and site collection administrators can create sites and site collections based on the language-specific site templates by specifying a language when they are creating a new SharePoint site or site collection.

Uninstalling language packs

If you no longer have to support a language for which you have installed a language pack, you can remove the language pack by using the Control Panel. Removing a language pack removes the language-specific site templates from the computer. All sites that were created that have those language-specific site templates will no longer work (the URL will produce a HTTP 500 - Internal server error page). Reinstalling the language pack will make the site functional again.

You cannot remove the language pack for the version of SharePoint 2013 that you have installed on the server. For example, if you are running the Japanese version of SharePoint 2013, you cannot uninstall the Japanese language support for SharePoint 2013.

See also

Capabilities and features in SharePoint 2013 Resource Center
Installation and Deployment for SharePoint 2013 Resource Center


Add web or application servers to farms in SharePoint 2013

Summary: Learn how to add a server to an existing SharePoint 2013 farm so the server can later be configured for use as a front-end web server or as an application server.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The procedures in this article apply to a SharePoint 2013 farm that consists of at least two tiers. This article does not describe how to convert a single-server deployment to a multiple-server farm.

In this article:

  • Before you add a web or application server to a SharePoint farm

  • Install prerequisite software

  • Install the SharePoint software

  • Add the new SharePoint server to the farm

  • Configure the new server

Before you add a web or application server to a SharePoint farm

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products

  • Keyboard shortcuts

  • Touch

Determine server role

To add a new server to the farm, you must know its intended role to plan for additional or specialized configurations and assess the potential effect of adding the server to a production environment.

Note:

A typical three-tier farm includes front-end web servers, an application server that also hosts Central Administration, and a database server. The scope of this article is the front-end web server and application server roles.

After you determine the role of the server in your farm topology, you must identify the services and features that must be configured for the server to meet this role. This information will determine how SharePoint 2013 is configured to provision the server for its role in either the web tier or the application tier. For more information, see Manage service applications in SharePoint 2013.

The following illustration shows a SharePoint 2013 farm with two front-end web servers (Web-1 and Web-2) that serve content. The only application server (App-1) hosts Central Administration and the search components for the farm.

Options for adding a server to a farm

SharePoint Server 2010 farm:Add a server

The following sections provide information about the general characteristics of the front-end web server and application server roles.

Front-end web server role

The fundamental role of a front-end web server is to host web pages, web services, and the Web Parts that are required to process requests from users. The web server directs these requests to the application server, which returns the results to the front-end web server.

Application server role

By default, the server that hosts Central Administration in a three-tier farm is an application server. You can add application servers to host services that can be deployed to a single server and used by all the servers in a farm.

Services with similar usage and performance characteristics can be logically grouped on a server, and if it is necessary, hosted on multiple servers if a scale out is required to respond to performance or capacity requirements. For example, client-related farm services such as Word Services and Word Viewer can be combined into a service group and hosted on a dedicated server. In addition, some services, such as the Managed Metadata service, can be configured as service application that can be used by other farms.

In the farm illustration, there are two options to add an application server.

  • In option A an additional server is configured to host an additional instance of all search components. This will provide fault-tolerance for the search service.

  • In option B an additional server is configured to host a second index partition. This will enable indexing of more than 10 million documents.

In a three-tier farm that is running enterprise search, dedicated application servers are typically configured to host individual search components. For more information, see Manage the search topology in SharePoint Server 2013.

Note:

Distributing search is not an option for SharePoint 2013, where only a single search instance is permitted for each content database.

Additional tasks

Before you start to install prerequisite software, you have to complete the following:

  • Verify that the new server meets the hardware and software requirements described in Hardware and software requirements for SharePoint 2013.

  • Verify that you have the minimum level of permissions that are required to install and configure SharePoint 2013 on a new server. You must be a member of the Farm Administrators SharePoint group and the Administrators group on the local server to complete the procedures in this article. For more information, see Initial deployment administrative and service accounts in SharePoint 2013.

  • Verify that you know the name of the database server on the farm to which you are connecting, and the name of the configuration database if you are adding the server by using Windows PowerShell commands.

  • If you intend to use Windows PowerShell commands to add the server, verify that you meet the following minimum memberships: SharePoint 2013 is installed.

  • Securityadmin fixed server role on the SQL Server instance.

  • db_owner fixed database role on all databases that are to be updated.

  • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

  • An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  • Document the location of the SharePoint 2013 binary and log files on the existing farm servers. We recommend that the location of these files on the new server map to the locations used on the other servers in the farm. For more information, see Configure diagnostic logging in SharePoint 2013.

    Important:

    If you change the location of the trace log to a non-system drive, change the location on all the servers in the farm. Existing or new servers cannot log data if the location does not exist. In addition, you will be unable to add new servers unless the path that you specify exists on the new server. You cannot use a network share for logging purposes.

Install prerequisite software

Before you can install SharePoint 2013 and add a server to the farm, you must check for and install all the prerequisite software on the new server. You do this by using the Microsoft SharePoint Products Preparation Tool, which requires an Internet connection to download and configure SharePoint 2013 prerequisites. If you do not have an Internet connection for the farm servers, you can still use the tool to determine the software that is required. You will have to obtain installable images for the required software. For download locations, see Links to applicable software in "Hardware and software requirements (SharePoint 2013)."

Tip:

After you obtain a copy of the required software, we recommend that you create an installation point that you can use to store the images. You can use this installation point to install future software updates.

For detailed instructions about how to install the prerequisites, see Prepare the farm servers in the article, Install SharePoint 2013 across multiple servers for a three-tier farm.

Install the SharePoint software

After you install the prerequisites, follow these steps to install SharePoint 2013 on the new server. For detailed instructions about how to install SharePoint 2013, see Install SharePoint 2013 on a single server with SQL Server.

To install SharePoint 2013

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. From the product media or a file share that contains the SharePoint 2013 Products installation files, run Setup.exe.

  3. On the Start page, click the link to install SharePoint 2013.

  4. Review and accept the Microsoft License Terms.

  5. On the Server Type tab, select Complete.

    Note:

    You can choose to install only the components that are required for a front-end web server. However, if you perform a complete installation, you have more flexibility to re-purpose the server role in the farm in the future.

  6. Accept the default file location where SharePoint 2013 will be installed or change the installation path in order to suit your requirements.

    Tip:

    As a best practice, we recommend that you install SharePoint 2013 on a drive that does not contain the operating system.

  7. When Setup finishes, a dialog box prompts you to run the SharePoint Products Configuration Wizard. You can start the wizard immediately or from the Windows command prompt later.

Add the new SharePoint server to the farm

You add the new server to the farm by using one of the following procedures:

  • To add a new SharePoint 2013 server to the farm by using the SharePoint Products Configuration Wizard

  • To add a new SharePoint 2013 server to the farm by using Windows PowerShell

To add a new SharePoint 2013 server to the farm by using the SharePoint Products Configuration Wizard

  1. Verify that the user account that is performing this procedure is the Setup user account. For information about the Setup user account, see Initial deployment administrative and service accounts in SharePoint 2013.

  2. Start the SharePoint 2013 Products Configuration Wizard.

    • For Windows Server 2008 R2:

      • On the new server, click Start, point to All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Products Configuration Wizard.

    • For Windows Server 2012:

      • On the new server, on the Start screen, click SharePoint 2013 Products Configuration Wizard.

        If SharePoint 2013 Products Configuration Wizard is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Products Configuration Wizard.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the Welcome to SharePoint Products page, click Next.

  4. On the Connect to a server farm page, click Connect to an existing server farm.

  5. Click Next.

  6. On the Specify Configuration Database settings page, type the name of the instance of SQL Server in the Database server box, and then click Retrieve Database Names.

  7. Select the name of the configuration database in the Database name list, and then click Next.

  8. On the Specify Farm Security Settings page, type the name of the farm passphrase in the Passphrase box, and then click Next.

  9. On the Completing the SharePoint Products Configuration Wizard page, click Next.

  10. On the server that hosts Central Administration, click Manage servers in this farm to verify that the new server is part of the farm.

    Note:

    You can also verify a successful server addition or troubleshoot a failed addition by examining the log files. These files are located on the drive on which SharePoint 2013 is installed, in the %COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS folder. For more information, see Monitor health in SharePoint 2013.

  11. On the Servers in Farm page, click the name of the new server. Use the list of available services on the Services on Server page to start the services that you want to run on the new server.

  12. Configure SharePoint 2013 so that the new server can accommodate the role for which it was intended. For more information, see Configure the new server.

To add a new SharePoint 2013 server to the farm by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:Right-click

      • Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command to connect the server to a configuration database:

    Copy code
    Connect-SPConfigurationDatabase -DatabaseServer "<$DatabaseServer>" -DatabaseName "<$RunSettings.ConfigurationDatabaseName>" -Passphrase "<$Passphrase>"

    Where:

    • <$DatabaseServer> is the name of the server that hosts the configuration database

    • <$RunSettings.ConfigurationDatabaseName> is the name of the configuration database

    • <$Passphrase> is the passphrase for the farm

  4. At the Windows PowerShell command prompt, type the following command to install the Help File Collections:

    Copy code
    Install-SPHelpCollection -All

  5. At the Windows PowerShell command prompt, type the following command to install the Security Resource for SharePoint 2013:

    Copy code
    Initialize-SPResourceSecurity

  6. At the Windows PowerShell command prompt, type the following command to install the basic services:

    Copy code
    Install-SPService

  7. At the Windows PowerShell command prompt, type the following command to install all the features:

    Copy code
    Install-SPFeature -AllExistingFeatures

  8. At the Windows PowerShell command prompt, type the following command to install application content:

    Copy code
    Install-SPApplicationContent

  9. At the Windows PowerShell command prompt, type the following command to get a list of servers in the farm.

    Copy code
    Get-SPFarm | select Servers
    Note:

    You can also verify a successful server addition or troubleshoot a failed addition by examining the log files. These files are located on the drive on which SharePoint 2013 is installed, in the %COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS folder. For more information, see Monitor health in SharePoint 2013.

  10. Configure SharePoint 2013 so that the new server can accommodate the role for which it was intended. For more information, see Configure the new server.

Configure the new server

The new server has no real functionality in the farm until you configure the services that are required to support the role that you planned for the new server. For more information, see Configure services and service applications in SharePoint 2013.


Add a database server to an existing farm in SharePoint 2013
See also

Published: December 11, 2012

Summary: Learn how to add a new database server to an existing SharePoint farm.

Applies to: SharePoint

You can add more database servers at any time to respond to business or operations requirements. Because a database server contains the farm content, which can consist of diverse types of data and can have a fast growing document collection, the size of the farm databases can grow quickly. Storage capacity is often the key reason to add more database servers. Other reasons can include adding new features, improving performance and high availability.

In this article:

  • Before you begin

  • Prepare the new database server

    • To provision the database server

  • Configure and use the new database server

    • To create a new web application

    • To move a site collection by using Windows PowerShell

Before you begin

Normally, all that is required to add a database server to an existing SharePoint farm is to set up and configure a new database server and join it to the farm by referencing the new server when you add a feature or move database content to the new server. SharePoint 2013 automatically allocates and assigns new database resources as necessary when they are required.

Note:

In the case of high availability, this is typically implemented as part of the initial farm topology design and deployment and is not included in this article. For more information about high availability for SQL Server 2008 R2 and SQL Server 2012, see High Availability Solution Overview and High Availability Solutions (SQL Server).

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

The procedures in this article are intended to show how to configure a new database server for a specific task in SharePoint 2013.

Prepare the new database server

Before you can use the new database server, you must prepare it so that it can be used in a SharePoint 2013 farm. Use the following steps as guidance to provision the new server.

Important:

IT policy may require a database administrator (DBA) to complete some or all steps in these procedures.

To provision the database server

  1. Verify that the user account that is performing this procedure is a member of the SQL Server database dbcreator fixed server role, the Farm Administrators SharePoint group, and Administrators group on the server.

  2. Review Hardware and software requirements for SharePoint 2013

  3. Install the operating system, and make sure that the following conditions are satisfied:

    • The disk configuration is the same as the existing server.

    • The operating system is updated to the same service pack or hotfix level as the existing server.

  4. Install the same version of SQL Server that is installed on the existing farm database server.

    For information about how to install and configure SQL Server 2008 R2 with Service Pack 1 (SP1) or SQL Server 2012 before you add them to an existing server farm, see SQL Server Installation (SQL Server 2008 R2) or Quick-Start Installation of SQL Server 2012.

  5. Configure SQL Server, and confirm the following:

    • The database collation is LATIN1_General_CI_AS_KS_WS.

    • A logon account is created for the SharePoint 2013 Setup user account. This account will be the database owner for the new database.

  6. Install the same SQL Server service packs and hotfixes that are installed on the existing database server.

Configure and use the new database server

Use the following procedures as a guide to configure a new database server to host specific SharePoint databases. This includes the following:

  • Create a new web application.

  • Move a site collection to the new server.

You can use either the SharePoint Central Administration website or Windows PowerShell to create a new web application. You must use Windows PowerShell to move a site collection.

To create a new web application

  1. Verify that the user account that is performing this procedure is a member of the SQL Server database dbcreator fixed server role and the Farm Administrators SharePoint group.

  2. Use the Application Management page in the SharePoint Central Administration website to create a new web site.

  3. Configure either classic mode authentication (Windows authentication) or claims-based authentication.

  4. Configure IIS to use either the existing web site or create a new web site and configure the following settings:

    • Specify the port number that you want to use to access the web application.

    • Provide the URL you want to use to access the web application (optional).

    • Provide the path of the site directory on the server where the web site is hosted.

  5. Configure authentication and encryption for your web by using the following options.

    • Negotiate (Kerberos) or NTLM authentication

    • Anonymous access to the web site

    • Secure Sockets Layer (SSL)

  6. Provide a URL for the domain name for all sites that users will access in this web application.

  7. Use the existing application pool or create a new one.

  8. Configure security for the application pool (predefined or configurable).

  9. Identify the database server, database name, and authentication method for your new web application.

For detailed instruction, see Create a web application in SharePoint 2013.

To move a site collection by using Windows PowerShell

  1. The SharePoint 2013 content database stores all site content for a farm, this includes the site collection. Content databases can store more than one site collection. Whether you move a site collection between database servers or between databases the procedure is the same. If the site collection grows too large then it can be moved to a new content database using the same procedure.

  2. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  3. Verify that the following conditions are true:

    • The destination content database exists.

    • The source content database and destination content database reside on the same instance of SQL Server.

    • The source content database and destination content database are attached to the same web application.

  4. Determine the size of the source site collection and verify that the destination hard disk has at least three times more free space than is required for the site collection.

    Use the Get-SPSiteAdministration cmdlet to determine the size of a site collection. For more information, see Get-SPSiteAdministration

  5. Use the Move-SPSite cmdlet to move a site collection from the source content database to the new content database. For more information, see Move-SPSite.

    For detailed instructions, see Move site collections between databases in SharePoint 2013.

See also

Deploy Windows Server 2008 R2
Install and Deploy Windows Server 2012
SQL Server Installation (SQL Server 2008 R2)
Install SQL Server 2012


Remove a server from a farm in SharePoint 2013
See also

Summary: Learn how to remove a web server, application server, or database server from a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

There are three types of servers in a server farm running SharePoint 2013: web servers, application servers, and database servers. The method that you use to remove a server from a SharePoint farm varies depending on the type of server that you are removing from the farm.

In this article:

  • Removing a web server or application server from a SharePoint farm

  • Removing a database server from a SharePoint farm

  • Remove a database server, web server, or application server from a SharePoint farm by using Central Administration

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support in SharePoint 2013

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Removing a web server or application server from a SharePoint farm

For information about uninstallation procedures that SharePoint 2013 supports, see Uninstall SharePoint 2013.

Removing a server that contains a search topology component can affect future search activities. The extent of that effect depends on the farm search topology. We recommend that you remove or relocate any search topology components from a server before removing the server from the farm.

If you remove a server that hosts a crawl component, no index files are lost. However, you might reduce or remove the capacity to crawl content.

You can lose index files in the following situations:

  • The farm has only one query component, and you remove the server that hosts the query component.

  • You have configured the index to be partitioned and you delete the last query component in one of the partitions. In this case, you will lose a portion of the index.

In either of these cases, a full crawl will have to be performed to re-create the index files.

You can deploy specific techniques to build fault tolerance into the search topology. If these techniques are followed, the deliberate or unplanned removal of a server from the topology can be absorbed without losing data and without affecting the ability to crawl or serve queries. (However, performance can still be affected.) For more information, see Technical diagrams for SharePoint 2013.

Make sure that the server that you want to remove is not running any important site components. If important services or components (such as a custom Web Part) are running on the server and are not available on another server in the farm, removing the server can damage sites in the farm. For example, if the server that you want to remove is the only application server in the farm that is running the Business Data Connectivity service, removing the server can make any sites that rely on that service stop working correctly.

Remove a web server or an application server from a farm by using Control Panel

You can remove a web server or an application server from the server farm by uninstalling SharePoint 2013 from the server through Control Panel. When you uninstall SharePoint 2013 by using Control Panel, you remove the program files and other information from the server.

To remove a web server or an application server from a farm by using Control Panel

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Administrators group on the server.

  2. Stop the services that are running on the server. For information about how to determine which services are running on a specific server and stopping services, see Start or stop a service (SharePoint 2013).

  3. On the server that you want to remove from the farm, click Start, click Control Panel, and then double-click Programs and Features.

  4. In the list of currently installed programs, click SharePoint 2013, and then click Uninstall.

  5. Click Continue at the confirmation prompt to uninstall the program.

Removing a database server from a SharePoint farm

To remove a database server from a farm without uninstalling SharePoint and therefore deleting the data that was stored in the database, you must first move any databases that are hosted by that server to another database server in the farm and then use Central Administration to remove the database server from the farm.

You cannot remove a database server if it is the only database server available in the farm, or if it is the database server that hosts the configuration database.

Caution:

If you uninstall SharePoint 2013 from the server that is running Central Administration, you will be unable to administer the server farm until you configure another server in the farm to host the Central Administration site.

Remove a database server, web server, or application server from a SharePoint farm by using Central Administration

If a web server or application server is no longer available, or if uninstalling SharePoint 2013 from Control Panel is not possible, you can remove the web server or application server from the farm by using the SharePoint Central Administration website. Removing a server from the farm by using Central Administration does not uninstall SharePoint 2013 from the server, nor does it make any sites on that server inaccessible. We recommend that you use the process described in Remove a web server or an application server from a farm by using Control Panel to uninstall SharePoint 2013 instead of using Central Administration to remove the server.

Removing the server from the farm by using Central Administration does not delete this information from the server. Use the Central Administration procedure for removing database servers only, or for removing a web server or an application server from the farm when the server is no longer available to uninstall through Control Panel.

You can follow these steps to remove a web server, application server, or database server from the farm. However, we recommend that you remove web servers and application servers from a farm by using Control Panel, instead of by using Central Administration. For information, see Remove a web server or an application server from a farm by using Control Panel.

Before you remove a database server from a farm, make sure that you have moved any databases stored on that server to a different database server in your farm.

To remove a database server, web server, or application server from a SharePoint farm by using Central Administration

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Farm Administrators SharePoint group.

    • The user account that performs this procedure is a member of the Administrators group on the server.

  2. Stop the services that are running on the server. For information about how to determine which services are running on a specific server and stopping services, see Start or stop a service (SharePoint 2013).

  3. On the SharePoint Central Administration website, in the System Settings section, click Manage servers in this farm.

  4. On the Servers in Farm page, locate the row that contains the name of the server that you want to remove, and then click Remove Server.

  5. In the warning that appears, click OK to remove the server or click Cancel to stop the operation.

    The page updates, and the server that you removed no longer appears in the list of servers.

See also

Install SharePoint 2013

Install and deploy SharePoint 2013 (IT pros) Resource Center


Uninstall SharePoint 2013
See also

Summary: SharePoint Server 2013 and SharePoint Foundation 2013 support a limited set of methods to uninstall.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 .

You remove SharePoint 2013 by uninstalling it from Control Panel. When you uninstall SharePoint 2013, most files and subfolders in the installation folders are removed. However, some files are not removed. Also,

  • Web.config files, index files, log files, and customizations that you might have are not automatically removed when you uninstall SharePoint 2013.

  • SQL Server databases are detached but are not removed from the database server.

  • If you uninstall a single server that has a built-in database, SQL Server Express is not removed.

  • When you uninstall SharePoint 2013, all user data remains in the database files.

Before you begin

Before you begin this operation, confirm that you have uninstalled all language packs that are on the server.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Uninstall SharePoint 2013

Use this procedure to uninstall SharePoint 2013.

To uninstall SharePoint 2013

  1. Verify that you are a member of the Farm Administrators group or a member of the Administrators group on the local computer.

  2. On the computer that runs SharePoint 2013, log on as a local or domain administrator.

  3. Start Control Panel.

    • For Windows Server 2008 R2:

      • Click Start, and then click Control Panel.

    • For Windows Server 2012:

      • On the Start screen, click Control Panel.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  4. In the Programs area, click Uninstall a program.

  5. In the Uninstall or change a program dialog box, click Microsoft SharePoint Server 2013.

  6. Click Change.

  7. On the Change your installation of Microsoft SharePoint Server 2013 page, click Remove, and then click Continue.

    A confirmation message appears.

  8. Click Yes to remove SharePoint 2013.

    A warning message appears.

  9. Click OK to continue.

    A confirmation message appears.

  10. Click OK.

    You might be prompted to restart the server.

Note:

If you did not remove the language template packs before you uninstalled and then reinstalled SharePoint 2013, you must run Repair from the SharePoint Products Configuration Wizard for each language template pack on the server. After the repair operation is complete, you must restart the server. Finally, complete the language template pack configuration by running the SharePoint Products Configuration Wizard.

See also

Add web or application servers to farms in SharePoint 2013
Remove a server from a farm in SharePoint 2013
Hardware and software requirements for SharePoint 2013
Install SharePoint 2013 on a single server with a built-in database
Install SharePoint 2013 on a single server with SQL Server
Install SharePoint 2013 across multiple servers for a three-tier farm

Installation and Deployment for SharePoint 2013 Resource Center


Install and configure a virtual environment for SharePoint 2013

Summary: Learn about permissions, accounts, security settings, and what you have to do to prepare your Windows Server 2008 Hyper-V environment for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, and related resources provide information about how to prepare Hyper-V to support a SharePoint 2013 virtual farm.

Articles about SharePoint 2013 virtualization with Hyper-V

TechNet articles about SharePoint 2013 virtualization with Hyper-V

The following articles about virtualization in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Provides
Building blocks | Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment | Provides best practice guidance to install and configure virtual machines for a SharePoint 2013 farm and the Hyper-V virtualization host computer.

Resources about Hyper-V installation and initial configuration

The following resources about Hyper-V are available from other subject matter experts.

 | Content | Description
TechNet logo | Getting Business Done With Virtualization | Visit the TechCenter to access videos, community sites, documentation, and more.
Stack of books | Virtualization: Prepare to Virtualize | This TechNet Magazine article provides an overview of the preparation required to shift applications to a virtual environment.

Resources about about SharePoint 2013 farms hosted on Windows Azure

The following articles about how to deploy SharePoint 2013 on Windows Azure virtual machines are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Content Description

Content on MSDN

  • SharePoint 2013 on Windows Azure Infrastructure

  • Installing SharePoint 2013 on Windows Azure Infrastructure Services

  • Provides guidance to install and configure a SharePoint 2013 farm in a Windows Azure environment.

  • This tutorial provides step by step instructions to create an Azure environment and then deploy a SharePoint farm on Azure virtual machines.


Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment
See also

Summary: Follow best practice recommendations to configure the SharePoint 2013 virtual machines and the Windows Server 2008 Hyper-V infrastructure.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

After you create a detailed architecture design and system specifications, you are ready to install and configure the virtual environment for the SharePoint 2013 farm. To achieve the performance and capacity goals that you identify in your detailed design and system specifications, you must have a correctly configured virtual environment. One or more badly configured virtual machines or virtualization hosts can significantly reduce performance.

This article discusses Windows Server 2008 Hyper-V technology configuration options and their potential impact on the performance of the virtualization host computer, the virtual machines, and the SharePoint 2013 farm in general. Key decision points and best practice configurations provide guidance when you set up the virtual environment.

Important:

A wide range of features and installation options are available to set up and configure a Hyper-V environment. Measurements focus on testing and guidance on the features and configurations that provide quantifiable benefits and consider the known performance characteristics of server roles in a SharePoint products farm.

In this article:

  • Introduction and scope

  • Review the general best practice guidance for virtualization

  • Configure the Hyper-V host computer

  • Install and configure virtual networking

  • Create and configure the virtual machines

  • Configure the memory for the virtual machines

  • Configure the processors for the virtual machines

  • Configure the controllers and hard disks for the virtual machines

  • Configure services and general settings

Introduction and scope

We recommend that you use a bottom up approach to configure the Hyper-V environment for the SharePoint 2013 farm. Start with the Hyper-V host computer configuration and then work up to the virtual layer to configure the virtual network components and the virtual machines.

Before you install and configure the Hyper-V environment, we recommend that you review the following articles:

  • Hardware Considerations for Hyper-V in Windows Server 2008

  • Requirements and Limits for Virtual Machines and Hyper-V in Windows Server 2008 R2

  • Hyper-V Getting Started Guide

Article scope

Several aspects about how to configure a virtual environment that are not discussed in detail are documented in separate articles. Detailed information about the following subjects is out of scope for this article:

  • Business Continuity Management (high availability and disaster recovery) for a virtual environment

  • Securing a virtual environment (options and best practices)

Review the general best practice guidance for virtualization

When you install and configure virtualization for a SharePoint 2013 farm, every configuration choice that you make and implement has an effect on all other parts of the virtual environment. Your primary goal is to create intended consequences and positive effects. To achieve this goal you have to understand the interaction between the virtual and the physical, the inherent constraints. You also have to follow best practice guidance when you set up the virtual farm.

The first thing that you have to do before you install and configure your virtual environment is to make sure that you install the latest version of the Hyper-V Best Practices Analyzer (BPA). You can get this update from Update for Best Practices Analyzer for HYPER-V for Windows Server 2008 R2 x64 Edition (KB977238).

You can use Hyper-V Best Practices Analyzer to scan a server that is running the Hyper-V role and help identify configurations that do not comply with the best practices of Microsoft for this role. BPA scans the configuration of the physical computer, the virtual machines, and other resources, such as virtual networking and virtual storage. No configuration changes are made by running the scan.

The scan results display the following information:

  • A list of issues that you can sort by severity

  • Recommended fixes for issues

  • Links to instructions

The best practices in the following table explain several aspects of virtualization and are not necessarily specific to any virtualization technology.

Note:

Hyper-V partition terminology

Hyper-V provides three types of partitions: the root partition, the parent partition, and the child partition. Each partition has its resources (memory and processor) and policies for device use. The root partition is the original partition and it starts the hypervisor. The parent partition calls the hypervisor to request the creation of new child partitions—the virtual machines.

Best practice guidance for virtualization

Best practice Description

Leave adequate memory for the Hyper-V partitions.

Calculate the total memory requirements for all the virtual machines on the host and ensure that there is enough available memory to meet Hyper-V partition requirements.

Important:

For SharePoint products virtual machines, we recommend 4 GB of RAM or more for host computer operations.

Do not use the parent partition for services other than Hyper-V.

Do not run additional roles or services on the parent partition. Run them on the virtual machines instead because the parent is differentiated for scheduling.

Do not store host computer system files on drives that are used for Hyper-V storage.

To reduce disk contention, do not store system files (for example, Pagefile.sys) on hard disks that are dedicated to storing virtual machine data.

Use a minimum of two physical network adapters.

For better network management and performance, dedicate one adapter to virtual machine network traffic and use the other adapter for virtualization host network traffic.

Do not oversubscribe the CPU on the virtualization host computer.

Review the supported ratio of virtual processors per logical processor and avoid oversubscribing the host computer CPU. The optimum virtual processor:logical processor ratio is 1:1. For more information, see Configure the processors for the virtual machines.

Do not cross Non-uniform memory access (NUMA) boundaries.

Hyper-V spans NUMA nodes to assign physical memory to a virtual machine; however, this does reduce performance on the virtual machine. For more information, see Configure the memory for the virtual machines

Do not use snapshots in a production environment.

Do not use snapshots for the virtual machines in a SharePoint products production environment. When you create a snapshot, Hyper-V creates a new secondary drive for the virtual machine. Write operations occur on the new drive and read operations occur on both drives, which has the same net affect as a differencing disk. Every snapshot that you add reduces disk performance further.

Configure the Hyper-V host computer

When you configure the Hyper-V host computer, we recommend that you consider the following configuration options and best practices:

  • Close the operating system management windows.

    Hyper-V Manager and Virtual Machine Connection sessions consume resources. For example, Hyper-V manager causes Windows Management Instrumentation (WMI) activity in the parent partition. When you close the Virtual Machine Connection Manager, video emulation is disabled, which eliminate this source of resource consumption.

  • Avoid running programs such as anti-virus software on the parent partition.

    Run them on the child partition if they are required.

  • Use hardware that supports Second Level Address Translation (SLAT).

    SLAT is hardware that is optimized for virtualization improves virtual machine performance, and reduces processing load on the Windows hypervisor. For more information, see Hyper-V: List of SLAT-Capable CPUs for Hosts.

  • If your hardware supports Hyper-Threading, enable it.

    Hyper-Threading splits the CPU pipeline in two and makes a single core look like two cores.

Install and configure virtual networking

Hyper-V provides the level of networking robustness and configuration options that you expect to see in a physical networking environment. There are, of course, some limitations because you are dealing with virtual devices.

We recommend that you refer to the following documentation to prepare to install and configure virtual networking.

  • Understanding Networking with Hyper-V

  • How does basic networking work in Hyper-V?

  • Hyper-V: What are the uses for different types of virtual networks?

  • Understanding Hyper-V VLANs

  • Hyper-V VLANs Part II

  • Configuring Virtual Networks

Hyper-V virtual networks

You can create and configure a Hyper-V virtual network before you install and configure virtual machines. In addition, you can create more than one virtual network on a Hyper-V host computer.

Note:

You cannot create more than one virtual network on a Hyper-V host computer if the computer is running a Server Core installation of Windows Server 2008 or Windows Server 2008 R2.

Hyper-V provides three types of virtual networks that you can configure for virtual machines. The following table provides a summary of these virtual networks and their characteristics.

Virtual network types

Type Description

External

Provides a communication link between virtual machines and a physical network by creating an association to a physical network adapter on the host computer. Dedicate one physical adapter to this type of network.

For security purposes you can isolate traffic between virtual machines and other computers on the physical network by clearing the Allow management operating system to share this network adapter setting. However, you will be unable to connect to the management operating system remotely.

Internal

Provides a communications link between the host computer and the virtual machines. This provides a degree of isolation from external network traffic and is typically used in a test environment where you want to connect to the virtual machines by using the management operating system.

Private

Provides a communications link between the virtual machines. They are completely isolated from the host computer and this type of virtual network is often used to set isolated test domains.

Important:

In a scenario where two internal (or private) virtual networks are created in Hyper-V and two virtual machines are created on a separate IP subnet, these virtual machines cannot communicate with one another. Because the virtual switch operates at layer 2 of the ISO/OSI Network Model, you have to have a router to achieve routing at a higher level.

After you create your virtual network, you can specify the range of media access control (MAC) addresses that are automatically assigned to the virtual network adapters. Hyper-V enables you to provide static MAC addresses to a virtual adapter to avoid collisions on the network.

Tip:

John Howard's blog post, Hyper-V: MAC Address allocation and apparent network issues MAC collisions can cause provides a very good explanation about MAC Address allocation and associated network issues.

Windows Server 2008 R2 adds the option to configure MAC address spoofing (Enable Spoofing Of MAC Addresses) in the virtual network adapter settings. For more information, see Configure MAC Address Spoofing for Virtual Network Adapters.

Virtual local area networks (VLANs)

From a performance perspective, the ability to create virtual local area networks (VLANs) can provide significant throughput gains. Because virtual machines on the same VLAN can communicate through the virtual switch, network traffic is faster because it does not have to use the physical network adapter. Another benefit of a VLAN configuration is the fact that, because it is software-based, a virtual machine can easily be moved between hosts and still keeps its network configuration.

When you enable virtual LAN identification for the management operating system, you can assign a VLAN identifier (ID), which is an integer that uniquely identifies a node that belongs to a particular VLAN. If you use virtual LAN feature and a VLAN ID, note the following:

  • The physical adapters must support VLAN tagging and this feature has to be enabled.

  • Set the VLAN ID on either the virtual switch or on the virtual machine's network adapter instead of the physical adapter.

  • You can assign only one VLAN ID on the virtual switch.

Network adapters and virtual network switches

Hyper-V provides two kinds of virtual network adapters that you can configure for a virtual machine: a network adapter and a legacy network adapter.

  • A network adapter, also known as a synthetic adapter, is the preferred option for most virtual machine configurations. The driver for this adapter is included with the integration services that are installed with the Windows Server 2008 R2 guest operating system.

  • A legacy adapter emulates an Intel 21140-based PCI Fast Ethernet Adapter, which results in a lower data transfer than the network adapter. A legacy network adapter also supports network-based installations because it can boot to the Pre-Boot Execution Environment (PXE).

Unless you have to use a legacy adapter until you can install the virtual machine driver or have to do a network boot, we recommend that you configure a virtual machine with a network adapter. If you do have to use a legacy adapter for a network installation, you can always add a network adapter later, and then delete the legacy adapter.

NIC teaming is the process of grouping several physical NICs into one logical NIC, which can be used for network fault tolerance and transmit load balance. The process of grouping NICs is called teaming. Teaming has two purposes:

  • Fault tolerance. Teaming more than one physical NIC to a logical NIC maximizes high availability. Even if one NIC fails, the network connection does not stop and continues to operate on other NICs.

  • Load balancing. Balancing the network traffic load on a server can enhance the functionality of the server and the network. Load balancing within network interconnect controller (NIC) teams enables distributing traffic among the members of a NIC team so that traffic is routed among all available paths.

Note:

Windows Server 2008 Service Pack 2 (SP2) and Windows Server 2008 R2 have no restrictions that are associated with NIC Teaming and the Failover Clustering feature. In Windows Server 2008, the Microsoft Failover Cluster Virtual Adapter is compatible with NIC Teaming and enables it to be used on any network interface in a Failover Cluster.

Windows Server 2008 R2 adds important new capabilities that you should use in your Hyper-V environment if your servers and network hardware support them. We recommend that you investigate the following networking options:

  • Large Send Offload (LSO) and Checksum Offload (CSO). The virtual networks in Hyper-V support LSO and CSO. In addition, if your physical network adapters support these capabilities, the virtual traffic is offloaded to the physical network as necessary. Most network adapters support LSO and CSO.

  • Jumbo frames. With Windows Server 2008 R2, jumbo frame improvements converge to support up to 6 times the payload per packet. This increases overall throughput and reduces CPU utilization for large file transfers. Physical networks and virtual networks support jumbo frames. This includes switches and adapters.

    Note:

    For physical networks, all intervening network hardware such as switches must have jumbo frame support enabled also.

  • TCP chimney. This lets virtual NICs in child partitions to offload TCP connections to physical adapters that support it, which reduces CPU utilization and other overhead.

  • Virtual machine queue (VMQ). VMQ improves network throughput by distributing network traffic for multiple VMs across multiple processors. This process reduces processor utilization by offloading packet classification to the hardware and avoiding both network data copy and route lookup on transmit paths. VMQ is compatible with most other task offloads and can coexist with large send offload and jumbo frames.

Create and configure the virtual machines

Although Hyper-V supports several guest operating systems, SharePoint 2013 requires the 64-bit edition of Windows Server 2008 R2 Service Pack 1 (SP1) Standard, Enterprise, or Data Center. For more information about supported guest operating systems, see About Virtual Machines and Guest Operating Systems

Hyper-V provides many configuration options and you can change a configuration, the amount of memory for example, after the virtual machine is running as a SharePoint products farm server. With the exception of adding a virtual hard disk drive for a SCSI controller, you have to shut down a virtual machine before you can change its configuration.

Configure each virtual machine according to the requirements in Detailed design and system specification process for a virtual SharePoint 2013 farm. Configure the following for each virtual machine:

  • The BIOS setting to set the boot sequence (legacy network adapter, CD, IDE, or floppy disk)

  • The amount of memory

  • The number of virtual processors

  • The type and number of controllers

  • The type and number of hard disks

  • The type and number of network adapters

In addition to the previous configurations, you also have the option to configure a DVD drive, COM ports, and a virtual floppy disk.

From a SharePoint products perspective, the primary configuration considerations are the memory, processor, and hard disks.

Configure the memory for the virtual machines

Configure memory on a virtual machine as you typically do for an application that runs on a physical server. The memory allocation must be sufficient to reasonably handle the load at ordinary and peak times. For SharePoint virtual machines, insufficient memory is the main cause of performance issues.

Before you install and configure the virtual machines on a Hyper-V host computer, calculate how much memory is available for the virtual machines. The root partition must have sufficient memory to provide services such as I/O virtualization and management to support the child partitions. For SharePoint products, we recommend that you allow a minimum of 4 GB of RAM for overhead on a Hyper-V virtualization host computer.

After you factor in the 4 GB RAM reserve for the virtualization host, configure the virtual machines to use the remaining memory.

Dynamic memory

Windows Server 2008 R2 SP1 has the option of configuring dynamic memory (with a minimum value and maximum value) for virtual machines.

We do not support this option for virtual machines that run in a SharePoint 2013 environment. The reason is that this implementation of dynamic memory does not work with every SharePoint feature. For example, Distributed Cache and Search do not resize their caches when the allocated memory for a virtual machine is dynamically changed. This can cause performance degradation, especially when assigned memory is reduced.

Non-uniform memory access (NUMA)

A very import aspect of virtual machine memory configuration is Non-uniform memory access (NUMA). NUMA is a memory design that speeds up memory access by partitioning physical memory so each processor in a multi-CPU has its own memory. For example, in a system with 8 cores and 32 GB of RAM, each core or node has 4 GB of physical memory. If a virtual machine is configured to use 8 GB of RAM, the system has to use memory in another node. Because crossing the NUMA boundary can reduce virtual performance by as much as 8%, it is a best practice to configure a virtual machine to use resources from a single NUMA node. For more information about NUMA, refer to the following articles:

  • Understanding Non-uniform Memory Access

  • Determining NUMA node boundaries for modern CPUs

  • NUMA Node Balancing

Configure the processors for the virtual machines

You can configure multiple virtual processors for a virtual machine, up to a limit of four processors. You cannot configure more processors per virtual machine than there are logical (cores) processors on the virtualization host. For example, given a dual core physical server, the limit is two virtual processors for a virtual machine. Although Hyper-V supports up to eight virtual processors per core or per thread, a configuration that exceeds this ratio (8:1) is known as being oversubscribed. For any virtual machine that you use in a SharePoint 2013 farm, we recommend a ratio of 1:1. Oversubscribing the CPU on the virtualization host can decrease performance, depending on how much the CPU is oversubscribed. For more information, see Hyper-V VM Density, VP:LP Ratio, Cores and Threads

Configure the controllers and hard disks for the virtual machines

You can use two controller options and several hard disk configurations for a virtual machine. Before you configure storage for your virtual machines, read the following posts written by Jose Barreto, who is a member of the File Server Team at Microsoft.

  • Storage options for Windows Server 2008 Hyper-V

  • More on Storage Options for Windows Server 2008 Hyper-V

You can select either Integrated Device Electronics or SCSI devices on virtual machines, as follows:

  • IDE devices: Hyper-V uses emulated devices with IDE controllers. You can have up to two IDE controllers with two disks on each controller. The startup disk (also known as the boot disk) must be attached to one of the IDE devices. The startup disk can be either a virtual hard disk or a physical disk. Although a virtual machine must use an IDE device as the startup disk to start the guest operating system, you have many options to choose from when you select the physical device that will provide the storage for the IDE device.

  • SCSI devices: Each virtual machine supports up to 256 SCSI disks (four SCSI controllers with each controller supporting up to 64 disks). SCSI controllers use a type of device that was developed specifically for use with virtual machines and use the virtual machine bus to communicate. The virtual machine bus must be available when the guest operating system is started. Therefore, virtual hard disks that are attached to SCSI controllers cannot be used as startup disks.

    Note:

    Physical SCSI devices typically provide better I/O performance than physical IDE devices. However, this is not the case for virtualized SCSI and IDE devices in Hyper-V. Support for hot swappable hard disk drives, which the Hyper-V implementation of SCSI supports, is a better reason for selecting SCSI drives than performance gains.

The version of Hyper-V released with Windows Server 2008 R2 provides significant improvements in virtual hard disk performance. For more information, see Virtual Hard Disk Performance: Windows Server 2008 / Windows Server 2008 R2 / Windows 7. For a summary of virtual machine drive options, see the "How to choose your Hyper-V and VHD Storage Container Format" section of " Virtual Hard Disk Performance: Windows Server 2008 / Windows Server 2008 R2 / Windows 7".

Hyper-V supports many storage options. For more information about the storage options, see Planning for Disks and Storage.

You can use the following types of physical storage with a server that runs Hyper-V:

  • Direct-attached storage: You can use Serial Advanced Technology Attachment (SATA), external Serial Advanced Technology Attachment (eSATA), Parallel Advanced Technology Attachment (PATA), Serial Attached SCSI (SAS), SCSI, USB, and Firewire.

  • Storage area networks (SANs): You can use Internet SCSI (iSCSI), Fibre Channel, and SAS technologies.

For more information, see Configuring Pass-through Disks in Hyper-V.

There is no generic storage solution for every virtual environment. Selecting the optimal virtual machine drive option for your SharePoint 2013 servers requires research and extensive testing to implement the best storage solution for your virtual environment. When you pick a storage solution you must consider access performance, storage needs, and how much memory is used for the advanced caching of virtual hard disk images.

Configure services and general settings

In a Hyper-V environment, you can specify the configuration of virtual networking and the configuration for each virtual machine. Additionally, you can configure how each virtual machine interacts with the Hyper-V host computer, and also the stop and restart behavior if the running state of the virtual machine is interrupted.

Integration services

Hyper-V includes a software package for supported guest operating systems that improves integration between the physical computer and the virtual machine. This package is known as integration services. You should verify that the management operating system (which runs the Hyper-V role) and virtual machines are running the same version of integration services. For more information, see Version Compatibility for Integration Services.

For each virtual machine you can configure the following integration items between the virtual machine and the virtualization host computer:

  • Operating system shutdown

  • Time synchronization

  • Data exchange

  • Heartbeat

  • Backup (volume snapshot)

Important:

Disable the time synchronization for each SharePoint virtual machine. SharePoint 2013 implements timer jobs extensively and the latency during time synchronization will cause unpredictable results in the SharePoint environment.

Automatic stop and start

For each virtual machine you can configure automatic stop and start behavior if a physical computer shuts down.

The options for stop are as follows:

  • Save the virtual machine state.

    The current state of the virtual machine is saved. When the virtual machine is started, Hyper-V attempts to restore the virtual machine to the state it was in.

  • Turn off the virtual machine.

    This is the equivalent of pulling the power plug on a server.

  • Shut down the guest (virtual machine) operating system.

    This is the equivalent of shutting down a computer by using the Windows Shut down option.

For a SharePoint products virtual machine, do not configure the virtual machine to save state. Virtual machines that start from saved state will be out of synchronization with the other servers in the farm. We recommend that you configure the virtual machine to use a shutdown because it minimizes that chances that the virtual machine can be corrupted. When a shutdown happens, all timer jobs that are running can finish, and there will be no synchronization issues when the virtual machine restarts.

The opposite of an automatic stop is an automatic start. Hyper-V provides the following startup options when the physical server restarts:

  • Do nothing.

    You have to start the virtual machine manually regardless of its state when the physical server shut down.

  • Automatically start if the virtual machine was running when the service stopped.

  • Always start this virtual machine automatically.

    Hyper-V starts the virtual machine regardless of its state when the physical server shut down.

We recommend that you select either of the first two options. Both options are acceptable. However, the decision is ultimately up to the IT team that manages and maintains the virtual environment.

In addition to the previous start options, you can configure a startup time delay for a virtual machine. We recommend that you do this to reduce resource contention on a virtualization host. However, if your start option is to do nothing, this is not an issue.

See also

Overview of farm virtualization and architectures for SharePoint 2013
Use best practice configurations for the SharePoint 2013 virtual machines and Hyper-V environment

Installation and Deployment for SharePoint 2013 Resource Center
Capabilities and features in SharePoint 2013 Resource Center


Configure SharePoint 2013

Summary: Lists articles that describe how to configure settings (such as services, authentication, and specific features) after you install SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

After you install SharePoint 2013, you must configure several additional settings to enable key features in your farm. The articles in this section provide steps for configuring these settings.

TechNet articles about how to configure settings for the server farm

The following articles about how to configure settings for the server farm are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Settings icon | Configure authentication infrastructure in SharePoint 2013 | These articles describe how to configure the infrastructure for user, server-to-server, and app authentication.
Settings icon | Configure availability and recovery solutions for SharePoint 2013 | Learn about the options for providing high availability and disaster recovery solutions for SharePoint 2013.
Settings icon | Configure email integration for a SharePoint 2013 farm | These articles describe how to configure incoming and outgoing e-mail in the server farm.
Settings icon | Configure licensing in SharePoint Server 2013 | Learn about new licensing functionality and how to configure licensing in SharePoint Server 2013.
Settings icon | Configure mobile accounts in SharePoint 2013 | Learn how to subscribe to SMS alerts for your mobile device in SharePoint Server 2013.
Settings icon | Configure Request Manager in SharePoint Server 2013 | Learn how Request Manager can route and throttle incoming requests to help improve performance and availability.
Settings icon | Configure services and service applications in SharePoint 2013 | These articles describe how to configure services and service applications.
Settings icon | Configure usage and health data collection in SharePoint 2013 | Learn how to configure usage and health data collection.
Scenario icon | Configure Business Connectivity Services solutions for SharePoint 2013 | Find links to procedures to help you install and configure Business Connectivity Services for SharePoint 2013 on-premises and other scenarios.
Scenario icon | Configure eDiscovery in SharePoint Server 2013 | Learn the steps to set up and configure eDiscovery in SharePoint Server 2013 and Exchange Server 2013.
Scenario icon | Configure Exchange task synchronization in SharePoint Server 2013 | Configure Exchange Server 2013 and SharePoint Server 2013 for task synchronization by using the SharePoint Server 2013 Task Synchronization feature.
Scenario icon | Configure site mailboxes in SharePoint Server 2013 | Configure Exchange Server 2013 and SharePoint Server 2013 for team email by using the SharePoint Server 2013 Site Mailboxes feature.
Scenario icon | Configure social computing features in SharePoint Server 2013 | These articles describe how to configure social computing features. This includes My Sites, Community Sites, and microblogging in SharePoint Server 2013.
Scenario icon | Configure web content management solutions in SharePoint Server 2013 | Learn how to configure SharePoint web content management solutions that use cross-site collection publishing in SharePoint Server 2013.
Scenario icon | Configure workflow in SharePoint Server 2013 | Learn how to install and configure Workflow Manager in SharePoint Server 2013.

Additional resources about how to configure settings for the server farm

The following resources about how to configure settings for the server farm are available from other subject matter experts.

 | Content | Description
TechNet logo | Installation and Deployment for SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.


Service application and service management (SharePoint 2013)
See also

Published: November 6, 2012

Summary: Learn about service application infrastructure and how service applications and services can be managed by farm administrators in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In this section

  • About service applications and services in SharePoint 2013

    Provides an introduction to the logical infrastructure of service applications and services.

  • Share service applications across farms in SharePoint 2013

    Describes the process and cautions that are involved in sharing service applications across farms in SharePoint 2013.

  • Start or stop a service (SharePoint 2013)

    Describes how services can be started, stopped, and configured.

  • Manage service applications in SharePoint 2013

    Describes how to manage, create, configure, and share service applications.

  • Configure automatic password change in SharePoint 2013

    Learn about how to configure the automatic password changes in SharePoint 2013.

See also

Web applications management in SharePoint Server 2013
Technical diagrams for SharePoint 2013


Configure authentication infrastructure in SharePoint 2013
See also

Summary: Find resources to help you configure the infrastructure for user, server-to-server, and app authentication in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet and related resources provide information about how to configure authentication infrastructure.

TechNet articles about how to configure authentication infrastructure

The following articles about how to configure authentication infrastructure in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Configure forms-based authentication for a claims-based web application in SharePoint 2013 | Describes the steps to configure forms-based authentication using a Lightweight Directory Access Protocol (LDAP) membership provider.
 | Configure SAML-based claims authentication with AD FS in SharePoint 2013 | Describes the steps to configure Security Assertion Markup Language (SAML)-based claims authentication using Active Directory Federation Services (AD FS) 2.0.
 | Configure server-to-server authentication in SharePoint 2013 | These articles describe the steps to configure server-to-server authentication.
 | Configure app authentication in SharePoint Server 2013 | Describes the steps to configure app authentication for SharePoint Server 2013.
 | Configure client certificate authentication for SharePoint 2013 | Describes how to configure user authentication with client certificates.

See also

What's new in authentication for SharePoint 2013
Plan authentication in SharePoint 2013
Create a web application in SharePoint 2013


Configure forms-based authentication for a claims-based web application in SharePoint 2013
See also

Summary: Learn how to configure forms-based authentication with an LDAP provider for a new SharePoint 2013 web application.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article provides guidance for configuring forms-based authentication for a SharePoint 2013 web application that uses a Lightweight Directory Access Protocol (LDAP) membership provider. Forms-based authentication is an identity management system that is based on ASP.NET membership and role provider authentication. Forms-based authentication in SharePoint 2013 is a claims-based authentication method. For more information about the use of forms-based authentication, see the "Implementing forms-based authentication" section of Plan for user authentication methods in SharePoint 2013.

Important:

The steps in this article apply to SharePoint Server 2013.

For a version of these procedures that are configured in a standardized test lab, see Test Lab Guide: Demonstrate forms-based claims authentication for SharePoint Server 2013.

Before you begin

Before you begin this operation, you should be familiar with the concepts in Plan for user authentication methods in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Process overview

This configuration has the following phases that must be performed in consecutive order:

  • Phase 1: Create a new web application that uses forms-based authentication with Central Administration

  • Phase 2: Configure the Web.Config files for an LDAP membership provider

Within each phase, the set of procedures must also be performed in consecutive order.

For an alternative to creating the new web application by using Central Administration, see Create a new web application that uses forms-based authentication with Windows PowerShell.

If you are using iFrame-based Windows Azure autohosted apps within the web application, see Configure a forms-based authentication web application for Windows Azure autohosted apps.

Phase 1: Create a new web application that uses forms-based authentication with Central Administration

Perform the steps in the following procedure to create a web application that uses forms-based authentication with Central Administration.

To create a new web application that uses forms-based authentication with Central Administration

  1. Verify that the user account that is performing this procedure is a site collection administrator.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, in the Application Management section, click Manage web applications.

  4. In the Contribute group of the ribbon, click New.

  5. In the Claims Authentication Types section of the Create New Web Application dialog box, select Enable Forms Based Authentication (FBA).

  6. Type a membership provider name in ASP.NET Membership provider name and a role manager name in ASP.NET Role manager name.

    In the example Web.Config files depicted in this article, the membership provider is membership and the role manager is rolemanager.

  7. Configure the other settings for this new web application as needed, and then click OK to create it.

  8. When prompted with the Application Created dialog box, click OK.

Phase 2: Configure the Web.Config files for an LDAP membership provider

After you successfully create the new web application, modify the following Web.Config files in every web front-end server in the farm:

  • To configure the Central Administration Web.Config file

  • To configure the Security Token Service Web.Config file

  • To configure the new web application Web.Config file

Configure the Central Administration Web.Config file

The following procedure configures the Central Administration web site to recognize and use the new forms-based membership provider and role manager.

To configure the Central Administration Web.Config file

  1. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.

  2. In the console tree, open the server name, and then Sites.

  3. Right-click the SharePoint Central Administration v4 site, and then click Explore.

  4. In the folder window, double-click the Web.Config file.

  5. In the <Configuration> section, find the <system.web> section and add the following example entry:

    Copy code
    <membership defaultProvider="AspNetSqlMembershipProvider">
      <providers>
        <add name="membership"
             type="Microsoft.Office.Server.Security.LdapMembershipProvider, Microsoft.Office.Server, Version=15.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c"
             server="yourserver.com"
             port="389"
             useSSL="false"
             userDNAttribute="distinguishedName"
             userNameAttribute="sAMAccountName"
             userContainer="OU=UserAccounts,DC=internal,DC=yourcompany,DC=distinguishedName (of your userContainer)"
             userObjectClass="person"
             userFilter="(ObjectClass=person)"
             scope="Subtree"
             otherRequiredUserAttributes="sn,givenname,cn" />
      </providers>
    </membership>
    <roleManager enabled="true" defaultProvider="AspNetWindowsTokenRoleProvider" >
      <providers>
        <add name="roleManager"
             type="Microsoft.Office.Server.Security.LdapRoleProvider, Microsoft.Office.Server, Version=15.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c"
             server="yourserver.com"
             port="389"
             useSSL="false"
             groupContainer="DC=internal,DC=yourcompany,DC=distinguishedName (of your groupContainer)"
             groupNameAttribute="cn"
             groupNameAlternateSearchAttribute="samAccountName"
             groupMemberAttribute="member"
             userNameAttribute="sAMAccountName"
             dnAttribute="distinguishedName"
             groupFilter="((ObjectClass=group)"
             userFilter="((ObjectClass=person)"
             scope="Subtree" />
      </providers>
 </roleManager>

    In the preceding entry, substitute the following:

    • The name of your membership provider in <add name="membership".

    • The fully qualified domain name (FQDN) of your domain controller (your LDAP server) in server="yourserver.com".

    • The distinguished name of your user container in userContainer="OU=UserAccounts,DC=internal,DC=yourcompany,DC=distinguishedName (of your userContainer)".

    • The name of your role manager in <add name="roleManager".

    • The distinguished name of your group container in groupContainer="DC=internal,DC=yourcompany,DC=distinguishedName (of your groupContainer)".

    After you add this entry, save and close the Web.Config file.

Configure the Security Token Service Web.Config file

The following procedure configures the Security Token Service to recognize and use the new forms-based membership provider and role manager.

To configure the Security Token Service Web.Config file

  1. In the console tree of Internet Information Services (IIS) Manager, open the SharePoint Web Services site.

  2. In the console tree, right-click SecurityTokenServiceApplication, and then click Explore.

  3. In the folder window, double-click the Web.Config file.

  4. In the <Configuration> section, create a new <system.web> section and add the following example entry:

    Copy code
    <membership>
      <providers>
        <add name="membership"
             type="Microsoft.Office.Server.Security.LdapMembershipProvider, Microsoft.Office.Server, Version=15.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c"
             server="yourserver.com"
             port="389"
             useSSL="false"
             userDNAttribute="distinguishedName"
             userNameAttribute="sAMAccountName"
             userContainer="OU=UserAccounts,DC=internal,DC=yourcompany,DC=com"
             userObjectClass="person"
             userFilter="(&amp;(ObjectClass=person))"
             scope="Subtree"
             otherRequiredUserAttributes="sn,givenname,cn" />
      </providers>
    </membership>
    <roleManager enabled="true" >
      <providers>
        <add name="rolemanager"
             type="Microsoft.Office.Server.Security.LdapRoleProvider, Microsoft.Office.Server, Version=15.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c"
             server="yourserver.com"
             port="389"
             useSSL="false"
             groupContainer="DC=internal,DC=yourcompany,DC=com"
             groupNameAttribute="cn"
             groupNameAlternateSearchAttribute="samAccountName"
             groupMemberAttribute="member"
             userNameAttribute="sAMAccountName"
             dnAttribute="distinguishedName"
             groupFilter="(&amp;(ObjectClass=group))"
             userFilter="(&amp;(ObjectClass=person))"
             scope="Subtree" />
      </providers>
    </roleManager>

    In the preceding entry, substitute the following:

    • The name of your membership provider in <add name="membership".

    • The FQDN of your domain controller (your LDAP server) in server="yourserver.com".

    • The distinguished name of your user container in userContainer="OU=UserAccounts,DC=internal,DC=yourcompany,DC=com".

    • The name of your role manager in <add name="roleManager".

    • The distinguished name of your group container in groupContainer="DC=internal,DC=yourcompany,DC=com".

    After you add this entry, save and close the Web.Config file.

Configure the new web application Web.Config file

The following procedure configures the new web application to recognize and use the new forms-based membership provider and role manager.

To configure the new web application Web.Config file

  1. In the console tree of Internet Information Services (IIS) Manager, right-click the site that corresponds to the name of the web applications that you just created, and then click Explore.

  2. In the folder window, double-click the Web.Config file.

  3. In the <Configuration> section, find the <system.web> section.

  4. Find the <membership defaultProvider="i"> section and add the following example entry to the <Providers> section:

    Copy code
    <add name="membership"
             type="Microsoft.Office.Server.Security.LdapMembershipProvider, Microsoft.Office.Server, Version=15.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c"
             server="yourserver.com"
             port="389"
             useSSL="false"
             userDNAttribute="distinguishedName"
             userNameAttribute="sAMAccountName"
             userContainer="OU=UserAccounts,DC=internal,DC=yourcompany,DC=com"
             userObjectClass="person"
             userFilter="(&amp;(ObjectClass=person))"
             scope="Subtree"
             otherRequiredUserAttributes="sn,givenname,cn" />

    In the preceding entry, substitute the following:

    • The name of your membership provider in <add name="membership".

    • The FQDN of your domain controller (your LDAP server) in server="yourserver.com".

    • The distinguished name of your user container in userContainer="OU=UserAccounts,DC=internal,DC=yourcompany,DC=com".

  5. Find the <roleManager defaultProvider="c" enabled="true" cacheRolesInCookie="false"> section and add the following example entry to the <Providers> section:

    Copy code
    <add name="roleManager"
             type="Microsoft.Office.Server.Security.LdapRoleProvider, Microsoft.Office.Server, Version=15.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c"
             server="yourserver.com"
             port="389"
             useSSL="false"
             groupContainer="DC=internal,DC=yourcompany,DC=com"
             groupNameAttribute="cn"
             groupNameAlternateSearchAttribute="samAccountName"
             groupMemberAttribute="member"
             userNameAttribute="sAMAccountName"
             dnAttribute="distinguishedName"
             groupFilter="(&amp;(ObjectClass=group))"
             userFilter="(&amp;(ObjectClass=person))"
             scope="Subtree" />

    In the preceding entry, substitute the following:

    • The name of your role manager in <add name="roleManager".

    • The FQDN of your domain controller (your LDAP server) in server="yourserver.com".

    • The distinguished name of your group container in groupContainer="DC=internal,DC=yourcompany,DC=com".

    After you add the preceding entry, save and close the Web.Config file.

    Warning:

    Do not overwrite any existing entries in this Web.Config file.

Create a new web application that uses forms-based authentication with Windows PowerShell

Perform the following procedure to create a web application that uses forms-based authentication with Windows PowerShell.

To create a new web application that uses forms-based authentication with Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. From the Windows PowerShell command prompt, type the following:

    Copy code
    $ap = New-SPAuthenticationProvider -Name <Name> -ASPNETMembershipProvider <Membership Provider Name> -ASPNETRoleProviderName <Role Manager Name>
$wa = New-SPWebApplication -Name <Name> -ApplicationPool <ApplicationPool> -ApplicationPoolAccount <ApplicationPoolAccount> -Url <URL> -Port <Port> -AuthenticationProvider $ap

    Example

    Copy code
    $ap = New-SPAuthenticationProvider -Name "ClaimsForms" -ASPNETMembershipProvider "membership" -ASPNETRoleProviderName "rolemanager"
$wa = New-SPWebApplication -Name "FBA Web App" -ApplicationPool "Claims App Pool" -ApplicationPoolAccount "internal\appool" -Url http://contoso.com -Port 1234 -AuthenticationProvider $ap
    Note:

    The value of the ApplicationPoolAccount parameter must be a managed account on the farm.

  4. After you successfully create the new web application, modify the following Web.Config files:

    • To configure the Central Administration Web.Config file

    • To configure the Security Token Service Web.Config file

    • To configure the new web application Web.Config file

  5. After you change the Web.Config files, create a SPClaimsPrincipal and a site collection, as shown in the following example:

    Copy code
    $cp = New-SPClaimsPrincipal -Identity "membership:SiteOwner" -IdentityType FormsUser
$sp = New-SPSite http://servername:port -OwnerAlias $cp.Encode() -Template "STS#0"

    For more information, see New-SPClaimsPrincipal.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Configure a forms-based authentication web application for Windows Azure autohosted apps

To support iFrame-based Windows Azure autohosted apps from a SharePoint 2013 web application that is configured for forms-based authentication, you must complete the following procedure. For more information about apps for SharePoint, see Overview of apps for SharePoint 2013.

To configure a forms-based authentication web application to support Windows Azure autohosted apps

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. From the Windows PowerShell command prompt, type the following:

    Copy code
    $svc = [Microsoft.SharePoint.Administration.SPWebService]::ContentService
$svc.MembershipUserKeyType=[Microsoft.SharePoint.Administration.SPMembershipUserKeyType]::ProviderUserKey
$svc.Update()

See also

Plan for user authentication methods in SharePoint 2013
Test Lab Guide: Demonstrate forms-based claims authentication for SharePoint Server 2013


Configure SAML-based claims authentication with AD FS in SharePoint 2013
See also

Updated: August 6, 2013

Summary: Learn how to configure Security Assertion Markup Language (SAML)-based claims authentication using Active Directory Federation Services version 2.0 (AD FS).

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The procedures in this article describe how to configure AD FS to act as an Identity Provider Security Token Service (IP-STS) for a SharePoint 2013 web application. In this configuration, AD FS issues SAML-based security tokens consisting of claims so that client computers can access web applications that use claims-based authentication. You can use an alternative identity provider than AD FS, but it must support the WS-Federation standard.

For information about why you would use SAML-based authentication, see Plan for user authentication methods in SharePoint 2013.

You can use AD FS with the Windows Server 2012, Windows Server 2008, or Windows Server 2008 R2 operating systems to build a federated identity management solution that extends distributed identification, authentication, and authorization services to web-based applications across organization and platform boundaries. By deploying AD FS, you can extend your organization's existing identity management capabilities to the Internet.

For a version of these procedures that are configured in a standardized test lab, see Test Lab Guide: Demonstrate SAML-based Claims Authentication with SharePoint Server 2013.

Before you begin

Before you begin this operation, you should be familiar with the concepts in the following article:

  • Plan for user authentication methods in SharePoint 2013

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Process overview

This configuration has the following phases that must be performed in consecutive order:

  • Phase 1: Install and configure an AD FS server

  • Phase 2: Configure AD FS with the web application as a relying party

  • Phase 3: Configure SharePoint 2013 to trust AD FS as an identity provider

  • Phase 4: Configure web applications to use claims-based authentication and AD FS as the trusted identity provider

Within each phase, the set of procedures must also be performed in consecutive order.

Phase 1: Install and configure an AD FS server

You must install and configure a server that runs AD FS 2.0. For more information, see the AD FS 2.0 Deployment Guide (http://go.microsoft.com/fwlink/p/?LinkId=191723).

Phase 2: Configure AD FS with the web application as a relying party

This phase has the following procedures:

  1. Configure AD FS for a relying party

  2. Configure the claim rule

  3. Export the token signing certificate

Configure AD FS for a relying party

Use the procedure in this section to configure a relying party. The relying party defines how the AD FS recognizes the relying party application and issues claims to it.

To configure AD FS for a relying party

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer. For additional information about accounts and group memberships, see Local and Domain Default Groups

  2. On the AD FS server, open the Active Directory Federation Services (AD FS) 2.0 Management console.

  3. In the navigation pane, expand Trust Relationships, and then double-click the Relying Party Trusts folder.

  4. In the right pane, click Add Relying Party Trust.

    This opens the Active Directory Federation Services (AD FS) 2.0 configuration wizard.

  5. On the Welcome to the Add Relying Party Trust Wizard page, click Start.

  6. Select Enter data about the relying party manually, and then click next.

  7. Type a relying party name and then click Next.

  8. Make sure Active Directory Federation Services (AD FS) 2.0 Profile is selected, and then click Next.

  9. Do not use an encryption certificate. Click Next.

  10. Click to select the Enable support for the WS-Federation Passive protocol check box.

  11. In the WS-Federation Passive protocol URL field, type the name of the web application URL, and append /_trust/ (for example, https:// app1.contoso.com/_trust/). Click Next.

    Note:

    The name of the URL has to use Secure Sockets Layer (SSL).

  12. Type the name of the relying party trust identifier (for example, urn:sharepoint:contoso), and then click Add. Click Next. Note that this will be the realm value when you configure a new SPTrustedIdentityTokenIssuer in Phase 3.

  13. Select Permit all users to access this relying party. Click Next.

  14. On the Ready to Add Trust page, there is no action required, click Next.

  15. On the Finish page, click Close. This opens the Rules Editor Management console. Use this console and the next procedure to configure the mapping of claims from your chosen directory source to SharePoint 2013.

Configure the claim rule

Use the procedure in this step to send values of a Lightweight Directory Access Protocol (LDAP) attribute as claims and specify how the attributes will map to the outgoing claim type.

To configure a claim rule

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer. For additional information about accounts and group memberships, see Local and Domain Default Groups

  2. On the Issuance Transform Rules tab, click Add Rule.

  3. On the Select Rule Template page, select Send LDAP Attributes as Claims. Click Next.

  4. On the Configure Rule page, type the name of the claim rule in the Claim rule name field.

  5. From the Attribute Store drop-down list, select Active Directory.

  6. In the Mapping of LDAP attributes to outgoing claim types section, under LDAP Attribute, select E-Mail-Addresses.

  7. Under Outgoing Claim Type, select E-Mail Address.

  8. Under LDAP Attribute, select User-Principal-Name.

  9. Under Outgoing Claim Type, select UPN.

  10. Click Finish, and then click OK.

Export the token signing certificate

Use the procedure in this section to export the token signing certificate of the AD FS server with which you want to establish a trust relationship, and then copy the certificate to a location that SharePoint 2013 can access.

To export a token signing certificate

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer. For additional information about accounts and group memberships, see Local and Domain Default Groups

  2. On the AD FS server, open the Active Directory Federation Services (AD FS) 2.0 Management console.

  3. In the navigation pane, expand Service, and then click the Certificates folder.

  4. Under Token signing, click the primary token certificate as indicated in the Primary column.

  5. In the right pane, click View Certificate link. This displays the properties of the certificate.

  6. Click the Details tab.

  7. Click Copy to File. This starts the Certificate Export Wizard.

  8. On the Welcome to the Certificate Export Wizard page, click Next.

  9. On the Export Private Key page, click No, do not export the private key, and then click Next.

  10. On the Export File Format page, select DER encoded binary X.509 (.CER), and then click Next.

  11. On the File to Export page, type the name and location of the file that you want to export, and then click Next. For example, enter C:\ADFS.cer.

  12. On the Completing the Certificate Export Wizard page, click Finish.

Phase 3: Configure SharePoint 2013 to trust AD FS as an identity provider

This phase has the following procedures:

  1. Exporting multiple parent certificates

  2. Import a token signing certificate by using Windows PowerShell

  3. Define a unique identifier for claims mapping by using Windows PowerShell

  4. Create a new authentication provider

Exporting multiple parent certificates

To complete the configuration of the AD FS server, copy the .CER file to the computer that is running AD FS.

The token signing certificate may have one or more parent certificates in its chain. If it does, every certificate in that chain has to be added to the SharePoint 2013 list of trusted root authorities.

To determine whether one or more parent certificates exist, follow these steps.

Note:

These steps should be repeated until all certificates are exported up to the root authority certificate.

To export multiple parent certificates

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer. For additional information about accounts and group memberships, see Local and Domain Default Groups

  2. Open the Active Directory Federation Services (AD FS) 2.0 Management console.

  3. In the navigation pane, expand Service, and then click the Certificates folder.

  4. Under Token signing, click the primary token certificate as indicated in the Primary column.

  5. In the right pane, click View Certificate link. This displays the properties of the certificate.

  6. Click the Certification tab. This displays any other certificate(s) in the chain.

  7. Click the Details tab.

  8. Click Copy to File. This starts the Certificate Export Wizard.

  9. On the Welcome to the Certificate Export Wizard page, click Next.

  10. On the Export Private Key page, click No, do not export the private key, and then click Next.

  11. On the Export File Format page, select DER encoded binary X.509 (.CER), and then click Next.

  12. On the File to Export page, type the name and location of the file that you want to export, and then click Next. For example, enter C:\adfsParent.cer.

  13. On the Completing the Certificate Export Wizard page, click Finish.

Import a token signing certificate by using Windows PowerShell

Use this section to import the token signing certificates to the trusted root authority list that resides on the SharePoint Server. This step must be repeated for every token signing certificate in the chain until the root certification authority is reached.

To import a token signing certificate by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. From the Windows PowerShell command prompt, import the parent certificate of the token signing certificate (that is, the root authority certificate), as shown in the following syntax:

    Copy code
    $root = New-Object System.Security.Cryptography.X509Certificates.X509Certificate2("<PathToParentCert>")
    Copy code
    New-SPTrustedRootAuthority -Name "Token Signing Cert Parent" -Certificate $root

  4. From the Windows PowerShell command prompt, import the token signing certificate that was copied from the AD FS server, as shown in the following syntax:

    Copy code
    $cert = New-Object System.Security.Cryptography.X509Certificates.X509Certificate2("<PathToSigningCert>")
    Copy code
    New-SPTrustedRootAuthority -Name "Token Signing Cert" -Certificate $cert

For additional information about the New-SPTrustedRootAuthority cmdlet, see New-SPTrustedRootAuthority

Define a unique identifier for claims mapping by using Windows PowerShell

Use the procedure in this section to define a unique identifier for claims mapping. Typically, this information is in the form of an e-mail address and the administrator of the trusted STS will have to provide this information because only the owner of the STS knows which claim type will be always unique for each user.

To define a unique identifier for claims mapping by using Windows PowerShell

  1. From the Windows PowerShell command prompt, create the email address claim mapping, as shown in the following syntax:

    Copy code
    $emailClaimMap = New-SPClaimTypeMapping -IncomingClaimType "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress" -IncomingClaimTypeDisplayName "EmailAddress" -SameAsIncoming

  2. From the Windows PowerShell command prompt, create the UPN claim mapping as shown in the following syntax:

    Copy code
    $upnClaimMap = New-SPClaimTypeMapping -IncomingClaimType "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/upn" -IncomingClaimTypeDisplayName "UPN" -SameAsIncoming

  3. From the Windows PowerShell command prompt, create the role claim mapping as shown in the following syntax:

    Copy code
    $roleClaimMap = New-SPClaimTypeMapping -IncomingClaimType "http://schemas.microsoft.com/ws/2008/06/identity/claims/role" -IncomingClaimTypeDisplayName "Role" -SameAsIncoming

    This claim mapping is used for server-to-server authentication scenarios. For more information, see Plan for server-to-server authentication in SharePoint 2013.

  4. From the Windows PowerShell command prompt, create the Primary SID claim mapping as shown in the following syntax:

    Copy code
    $sidClaimMap = New-SPClaimTypeMapping -IncomingClaimType "http://schemas.microsoft.com/ws/2008/06/identity/claims/primarysid" -IncomingClaimTypeDisplayName "SID" -SameAsIncoming

    This claim mapping is used for server-to-server authentication scenarios.

For additional information about the New-SPClaimTypeMapping cmdlet, see New-SPClaimTypeMapping

Create a new authentication provider

Use the procedure in this section to create a new SPTrustedIdentityTokenIssuer.

To create a new authentication provider by using Windows PowerShell

  1. From the Windows PowerShell command prompt, create a new authentication provider, as shown in the following syntax.

    Note:

    The $realm variable is the name of the relying party trust identifier configured in AD FS, and the $cert variable is the one that was used from the Import a token signing certificate by using Windows PowerShell section. The SignInUrl parameter is to the AD FS server.

    Copy code
    $realm = "urn:sharepoint:<WebAppName>"
    Copy code
    $signInURL = "https://<YourADFSServerName>/adfs/ls"
    Copy code
    $ap = New-SPTrustedIdentityTokenIssuer -Name <ProviderName> -Description <ProviderDescription> -realm $realm -ImportTrustCertificate $cert -ClaimsMappings $emailClaimMap,$upnClaimMap,$roleClaimMap,$sidClaimMap -SignInUrl $signInURL -IdentifierClaim $emailClaimmap.InputClaimType

    Include $roleClaimMap and $sidClaimMap in the list of ClaimsMappings for server-to-server authentication scenarios.

For additional information about the New-SPTrustedIdentityTokenIssuer cmdlet, see New-SPTrustedIdentityTokenIssuer

Phase 4: Configure web applications to use claims-based authentication and AD FS as the trusted identity provider

This phase has the following procedures:

  1. Associate an existing web application with the AD FS identity provider

  2. Create a new web application with the AD FS identity provider

  3. Enable token replay protection

Associate an existing web application with the AD FS identity provider

To configure an existing web application to use SAML sign-in, the trusted identity provider in the claims authentication type section must be changed.

To configure an existing web application to use the AD FS identity provider

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, on the home page, click Application Management.

  3. On the Application Management page, in the Web Applications section, click Manage web applications.

  4. Click the appropriate web application.

  5. From the ribbon, click Authentication Providers.

  6. Under Zone, click the name of the zone. For example, Default.

  7. On the Edit Authentication page in the Claims Authentication Types section, select Trusted Identity provider, and then click the name of your SAML provider (<ProviderName> from the New-SPTrustedIdentityTokenIssuer command). Click OK.

  8. Next, you must enable SSL for this web application. You can do this by adding an alternate access mapping for the "https://" version of the web application's URL and then configuring the web site in the Internet Information Services (IIS) Manager console for an https binding. For more information about how to set up SSL for IIS, see How to Setup SSL on IIS 7.0.

Create a new web application with the AD FS identity provider

When creating a new web application to use SAML sign-in, you must configure claims authentication for the AD FS trusted identity provider. See Create claims-based web applications in SharePoint 2013 and do the following:

  • In the Security Configuration section of the New Web Application dialog box, for Use Secure Sockets Layer (SSL), select Yes.

    For information about how to set up SSL for IIS, see How to Setup SSL on IIS 7.0.

  • In the Claims Authentication Types section of the New Web Application dialog box, select Trusted Identity provider, and then click the name of your SAML provider (<ProviderName> from the New-SPTrustedIdentityTokenIssuer command).

Configure permissions to access the web application

To allow users to authenticate by using an email addresses as their SAML-based identity, as specified in the New-SPTrustedIdentityTokenIssuer command with the -IdentifierClaim $emailClaimmap.InputClaimType parameter, you must add their email addresses with appropriate permissions to the web application.

Use the following procedure to configure a web application for permissions based on email addresses.

To configure a web application for permissions based on email addresses

  1. In Central Administration, on the home page, click Application Management.

  2. On the Application Management page, in the Web Applications section, click Manage web applications.

  3. Click the appropriate web application, and then click User Policy.

  4. In Policy for Web Application, click Add Users.

  5. In the Add Users dialog box, click the appropriate zone in Zones, and then click Next.

  6. In the Add Users dialog box, click the Browse icon in the lower-right of the Users box.

  7. In the Select People and Groups dialog box, type the email address of a user account in Find, and then click the Search icon.

  8. In the search results, click EmailAddress under the name of your AD FS identity provider, click the email address of the user under Display Name, click Add, and then click OK.

  9. In Permissions, click the appropriate level of permissions.

  10. Repeat steps 6 through 9 for additional email addresses of users with the same level of permissions.

  11. Click Finish, and then click OK.

Enable token replay protection

To provide additional security for SharePoint 2013 web applications that use SAML-based claims authentication, you can use the Windows Identity Foundation (WIF) token replay detection feature. Token replay protection can prevent an attacker from trying to intercept and use a user's security token. For more information, see Replay Detection.

Use the procedure in this section to enable replay detection on a SharePoint web application that is configured for SAML claims authentication.

To enable replay protection

  1. On the server running SharePoint 2013, open the Internet Information Services (IIS) Manager snap-in.

  2. In the console tree of Internet Information Services (IIS) Manager, right-click the site that corresponds to the name of the web application, and then click Explore.

  3. In the folder window, double-click the Web.Config file.

  4. In the <Configuration> section, find the <microsoft.identityModel> section.

  5. Add the following as a new section to the <microsoft.identityModel> section:

    Copy code
    <service>
    <tokenReplayDetection enabled="true" capacity="<NumberOfTokensToBeCached>" expirationPeriod="<TokenCacheExpiration>">
</service>

    in which:

    • <NumberOfTokensToBeCached> is the number of tokens to store in the token replay detection cache.

    • <TokenCacheExpiration> is the time after which a token in the replay detection cache is removed, in <hours>:<minutes>:<seconds> format.

  6. Save your changes to the Web.Config file.

If the farm running SharePoint 2013 is behind a load balancer, enabling token replay detection requires session affinity in your load balancer even though SharePoint 2013 web applications do not require it. To avoid the session affinity requirement, use the information in ACS Security Guidelines.

See also

Authentication overview for SharePoint 2013
Plan for user authentication methods in SharePoint 2013
Test Lab Guide: Demonstrate SAML-based Claims Authentication with SharePoint Server 2013
Plan for server-to-server authentication in SharePoint 2013

Change History

Date | Description
August 06, 2013 | Technical corrections and a new procedure to configure permissions based on email addresses.
July 16, 2012 | Initial publication


Configure server-to-server authentication in SharePoint 2013
See also

Summary: Find resources to help you configure server-to-server authentication for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet and related resources provide information about how to configure server-to-server authentication.

TechNet articles about how to configure server-to-server authentication

The following articles about how to configure server-to-server authentication in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Configure server-to-server authentication between SharePoint 2013 farms | Describes the steps to configure server-to-server authentication between two SharePoint 2013 farms.
 | Configure server-to-server authentication between SharePoint 2013 and Exchange Server 2013 | Describes the steps to configure server-to-server authentication between SharePoint 2013 and Exchange Server 2013.
 | Configure server-to-server authentication between SharePoint 2013 and Lync Server 2013 | Describes the steps to configure server-to-server authentication between SharePoint 2013 and Lync Server 2013.

See also

Authentication overview for SharePoint 2013
Plan for server-to-server authentication in SharePoint 2013


Configure server-to-server authentication between SharePoint 2013 farms
See also

Updated: March 26, 2013

Summary: Learn how to configure server-to-server authentication between SharePoint 2013 farms.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

The configuration details in this article describe how to configure server-to-server authentication between SharePoint 2013 farms. For background information about server-to-server authentication, see Plan for server-to-server authentication in SharePoint 2013.

Important:

Web applications that include server-to-server authentication endpoints for incoming server-to-server requests, or that make outgoing server-to-server requests should be configured to use Secure Sockets Layer (SSL). For information about how to create a web application to use SSL, see Create claims-based web applications in SharePoint 2013. For information about configuring HTTP support for server-to-server requests, see Configure an STS for HTTP.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Configure a SharePoint 2013 trust relationship with another farm

To service incoming server-to-server requests from another SharePoint 2013 farm, you must configure the SharePoint 2013 farm to trust the sending farm. Use the Windows PowerShell New-SPTrustedSecurityTokenIssuer cmdlet in SharePoint 2013 to configure the trust relationship by specifying the JavaScript Object Notation (JSON) metadata endpoint of the sending farm.

To configure a SharePoint 2013 trust relationship with another farm

  1. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • Securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. In the SharePoint 2013 environment on the farm that is receiving server-to-server requests, start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SPTrustedSecurityTokenIssuer -MetadataEndpoint "https://<HostName>/_layouts/15/metadata/json/1" -Name "<FriendlyName>"

    Where:

    • <HostName> is the name and port of any SSL-enabled web application of the farm that will be sending server-to-server requests.

    • <FriendlyName> is a friendly name for the sending SharePoint 2013 farm.

  4. Repeat step 3 for all SharePoint 2013 farms that will be sending server-to-server requests.

    Note:

    For more information, see New-SPTrustedSecurityTokenIssuer.

Configure a SharePoint 2013 trust relationship with a farm that has no web applications

If you have a services-only farm or other type of farm that has no web applications, follow these steps to configure a trust relationship with that farm.

To configure a trust relationship with a farm that has no web applications

  1. On a server of the farm that has no web applications, export the SharePoint Security Token Service certificate in the Computer Certificate store to a .CER file (without the private key).

  2. Copy the .CER file to a location that can be accessed from the SharePoint farm that trusts the farm with no web applications.

  3. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • Securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  4. In the SharePoint 2013 environment of the farm that has no web applications, start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSecurityTokenServiceConfig

  6. In the display of the Get-SPSecurityTokenServiceConfig command, note the string in the NameIdentifier field after the "@" symbol. This is the NameID of the STS of this SharePoint farm.

  7. On a server of the SharePoint farm that trusts the farm that has no web applications, start the SharePoint 2013 Management Shell.

  8. To add the SharePoint STS of the SharePoint farm that has no web applications as a trusted security token issuer, use the following Windows PowerShell command:

    Copy code
    New-SPTrustedSecurityTokenIssuer -name <hostname> -Certificate "<CERLocation>" -RegisteredIssuerName "00000003-0000-0ff1-ce00-000000000000@<NameID>" -Description "<FriendlyName>" -IsTrustBroker:$false

    Where:

    • <HostName>is the name of the farm that has no web applications.

    • <CERLocation> is the location of the exported .CER file from step 2.

    • <NameID> is the NameID string for the STS of the farm that has no web applications from step 6.

    • <FriendlyName> is a friendly name for the farm that has no web applications

Configure an STS for HTTP

The recommended best practice for server-to-server authentication is to use SSL and an https-based URL to send and receive requests. If you cannot host your web applications over SSL, the following procedure describes how to configure the STS of a SharePoint farm to use HTTP.

To configure the STS to use HTTP

  1. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • Securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. In the SharePoint 2013 environment on one of the servers in the farm, start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $c = Get-SPSecurityTokenServiceConfig
$c.AllowMetadataOverHttp = $true
$c.AllowOAuthOverHttp= $true
$c.Update()

Configure a synchronized STS name identifier

The recommended best practice for server-to-server authentication is that each server-to-server application that establishes trust with a SharePoint farm must use a different certificate. In a cross-farm SharePoint topology, if you have to use the same certificate across the farms, you have to also set the name identifier of the SharePoint Security Token Service (STS) to be the same across those farms. The following procedure describes how to synchronize the STS name identifier across two SharePoint farms.

To synchronize the STS name identifier across SharePoint farms

  1. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • Securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. In the SharePoint 2013 environment on one of the farms, start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSecurityTokenServiceConfig

  4. In the display of the Get-SPSecurityTokenServiceConfig command, note the value of the NameIdentifier field, which starts with "00000003-0000-0ff1-ce00-000000000000@". This is the name identifier of the SharePoint STS.

  5. To set the name identifier of the SharePoint STS in the other SharePoint farm, use the following Windows PowerShell commands on a server in that farm:

    Copy code
    $config = Get-SPSecurityTokenServiceConfig
$config.NameIdentifier=<CommonNameIdentifier>
$config.Update();

    Where <CommonNameIdentifier> is the value of the NameIdentifier field from step 4.

See also

New-SPTrustedSecurityTokenIssuer

Authentication overview for SharePoint 2013
Configure server-to-server authentication in SharePoint 2013
Plan for server-to-server authentication in SharePoint 2013

An Introduction to JavaScript Object Notation (JSON) in JavaScript and .NET

Change History

Date | Description
March 26, 2013 | Added procedures for a server without a web application and using HTTP rather than HTTPS.
September 4, 2012 | Initial publication


Configure server-to-server authentication between SharePoint 2013 and Exchange Server 2013
See also

Published: September 4, 2012

Summary: Learn how to configure server-to-server authentication between SharePoint 2013 and Exchange Server 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Server-to-server authentication enables you to share resources that live on various servers in a SharePoint farm and access services, such as Exchange Server 2013 and Lync Server 2013, which are distributed among servers. Server-to-server authentication in SharePoint 2013 also supports resource sharing and access with additional services that are compliant with the server-to-server authentication protocol.

The configuration details in this article are about how to configure server-to-server authentication between SharePoint 2013 and Exchange Server 2013.

Important:

Web applications that include server-to-server authentication endpoints for incoming server-to-server requests, or that make outgoing server-to-server requests must be configured to use Secure Sockets Layer (SSL). For information about how to create a web application to use SSL, see Create claims-based web applications in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Process overview

This configuration has the following steps:

  • Configure the SharePoint 2013 server to trust the Exchange Server 2013 server

  • Configure permissions on the SharePoint 2013 server

  • Configure the Exchange Server 2013 server to trust the SharePoint 2013 server

Important:

Complete the procedures in the order in which they are presented in this article.

To configure the SharePoint 2013 server to trust the Exchange Server 2013 server

  1. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    New-SPTrustedSecurityTokenIssuer -MetadataEndpoint "https://<HostName>/autodiscover/metadata/json/1" -Name "<FriendlyName>"

    Where:

    • <HostName> is the name or address of the Exchange Server 2013 server.

    • <FriendlyName> is a friendly name for the Exchange Server 2013 server.

To configure permissions on the SharePoint 2013 server

  • At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $exchange=Get-SPTrustedSecurityTokenIssuer
$app=Get-SPAppPrincipal -Site http://<HostName> -NameIdentifier $exchange.NameId
$site=Get-SPSite http://<HostName>
Set-SPAppPrincipalPermission -AppPrincipal $app -Site $site.RootWeb -Scope sitesubscription -Right fullcontrol -EnableAppOnlyPolicy

    Where:

    • <HostName> is the name or address of the SharePoint 2013 server.

    Note:

    For more information, see Get-SPTrustedSecurityTokenIssuer, Get-SPAppPrincipal, and Set-SPAppPrincipalPermission.

To configure the Exchange Server 2013 server to trust the SharePoint 2013 server

  1. Start the Exchange Management Shell.

    • For Windows Server 2008 R2:

      • In the Exchange Server 2013 environment, on the Start menu, click All Programs, click Microsoft Exchange Server 2013, and then click Exchange Management Shell.

    • For Windows Server 2012:

      • In the Exchange Server 2013 environment, on the Start screen, click Exchange Management Shell.

        If Exchange Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click Exchange Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    cd c:\'Program Files'\Microsoft\'Exchange Server'\V15\Scripts
.\Configure-EnterprisePartnerApplication.ps1 -AuthMetadataUrl https://<HostName>/_layouts/15/metadata/json/1 -ApplicationType SharePoint

    Where:

    • <HostName> is the name and port of any SSL-enabled web application of the SharePoint farm.

See also

Configure server-to-server authentication in SharePoint 2013
Plan for server-to-server authentication in SharePoint 2013

Configure Exchange for SharePoint eDiscovery Center


Configure server-to-server authentication between SharePoint 2013 and Lync Server 2013
See also

Published: October 2, 2012

Summary: Learn how to configure server-to-server authentication between SharePoint 2013 and Lync Server 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Server-to-server authentication enables you to share resources that live on various servers in a SharePoint farm and access services, such as Lync Server 2013 and Exchange Server 2013, which are distributed among servers. Server-to-server authentication in SharePoint 2013 also supports resource sharing and access to additional services that are compliant with the server-to-server authentication protocol. For more information about the SharePoint server-to-server authentication protocol, see OAuth 2.0 Authentication Protocol: SharePoint Profile (http://msdn.microsoft.com/en-us/library/hh631177(office.12).aspx).

The configuration details in this article explain how to configure server-to-server authentication between SharePoint 2013 and Lync Server 2013.

Important:

Web applications that include server-to-server authentication endpoints for incoming server-to-server requests, or that make outgoing server-to-server requests must be configured to use Secure Sockets Layer (SSL). For information about how to create a web application to use SSL, see Create claims-based web applications in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Process overview

This configuration has the following steps:

  • Configure the server that runs SharePoint 2013 to trust the server that runs Lync Server 2013

  • Configure the server that runs Lync Server 2013 to trust the server that runs SharePoint 2013

To configure the SharePoint 2013 server to trust the Lync Server 2013 server

  1. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen, right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    New-SPTrustedSecurityTokenIssuer -MetadataEndpoint "https://<HostName>/metadata/json/1" -IsTrustBroker -Name "<FriendlyName>"

    Where:

    • <HostName> is name or address of the server that runs Lync Server 2013.

    • <FriendlyName> is a friendly name for the server that runs Lync Server 2013.

To configure the Lync Server 2013 server to trust the SharePoint 2013 server

  1. If you have not already done this, assign a server-to-server authentication certificate to Lync Server 2013. Follow the instructions in Assigning a Server-to-Server Authentication Certificate to Microsoft Lync Server 2013.

  2. Configure the server that runs Lync Server 2013 for a new SharePoint partner application that corresponds to the SharePoint farm. For the instructions in Configuring an On-Premises Partner Application for Microsoft Lync Server 2013, change the metadata URL string in the embedded script from:

    • http://atl-sharepoint-001.litwareinc.com/jsonmetadata.ashx

    to:

    • https://<NameAndPort>/_layouts/15/metadata/json/1

    Where:

    • <NameAndPort> is the host name or address and port of any SSL-enabled web application of the SharePoint farm.

See also

Configure server-to-server authentication in SharePoint 2013
Plan for server-to-server authentication in SharePoint 2013


Configure app authentication in SharePoint Server 2013
See also

Published: September 4, 2012

Summary: Learn how to configure app authentication in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

When you use an app for SharePoint, an external component of the app might want to access SharePoint resources. For example, a web server that is located on the intranet or the Internet might try to access a SharePoint resource. When this occurs, SharePoint has to confirm the following:

  • The authentication of the identity of the app and the user on whose behalf the app is acting.

  • The authorization of the access for both the app and the user whose behalf the app is acting.

App authentication is the combination of these two confirmations.

This topic describes how to configure a SharePoint Server 2013 farm for app authentication by configuring a trust, by registering the app with the Application Management service, and by configuring app permissions.

Important:

SharePoint web applications that include app authentication endpoints for incoming requests must be configured to use Secure Sockets Layer (SSL). For information about how to configure SSL for a new web application, see Create claims-based web applications in SharePoint 2013.

Note:

This topic does not apply to SharePoint Foundation 2013.

Process overview

This configuration has the following steps that must be performed in consecutive order:

  1. Configure the SharePoint Server 2013 app authentication trust.

  2. Register the app with the Application Management service.

  3. Configure app permissions.

For information about apps for SharePoint, see Overview of apps for SharePoint 2013.

Note:

Because SharePoint Server 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint Server 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Step 1. Configure the SharePoint Server 2013 app authentication trust

There are two ways to configure an app authentication trust with SharePoint Server 2013:

  • If you have an Office 365 subscription and the app is also using Windows Azure Active Directory (AD) for authentication, you configure the SharePoint farm to trust the Windows Azure AD instance that corresponds to your Office 365 subscription. You do not have to have a Office 365 subscription. You can obtain a Windows Azure AD account separately. For more information, see Windows Azure Active Directory. Windows Azure AD then acts as a common authentication broker between the on-premises SharePoint farm and the app and as the online security token service (STS). Windows Azure AD generates the context tokens when the app requests access to a SharePoint resource.

    In this case, configure SharePoint Server 2013 to trust Windows Azure AD.

  • If you do not have an Office 365 subscription or if the app does not use Windows Azure AD for authentication, you must configure a server-to-server trust relationship between the SharePoint farm and the app, known as a high-trust app. A high-trust app generates its own context tokens when it requests access to a SharePoint resource. This must be done for each high-trust app that a SharePoint farm must trust. For example, if multiple apps are running on one server and if they all use different token signing certificates, you must create a separate trust with each one.

    In this case, configure SharePoint Server 2013 to trust the app.

Configure SharePoint Server 2013 to trust Windows Azure AD

Use the following procedure to configure SharePoint Server 2013 to trust Windows Azure AD.

To configure a SharePoint Server 2013 trust relationship with Windows Azure AD

  1. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint Server 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $New-SPTrustedSecurityTokenIssuer -MetadataEndpoint "<Metadata endpoint URL of Windows Azure AD>" -IsTrustBroker -Name "Azure AD"

    Where:

    • <Metadata endpoint URL of Windows Azure AD> is https://accounts.accesscontrol.windows.net/<Windows Azure AD domain name or realm ID>/metadata/json/1.

  4. Keep the Windows PowerShell command prompt open for the Step 2. Register the app with the Application Management service.

Configure SharePoint Server 2013 to trust the app

Use the following procedure to configure SharePoint Server 2013 to trust the app.

To configure a SharePoint Server 2013 trust relationship with a high-trust app

  1. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint Server 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. In Central Administration on the SharePoint Server 2013 server in the farm, on the Quick Launch, click System Settings, and then click Manage services on server.

  3. In the list of services on the server, make sure that that User Profile Service is started.

  4. In Central Administration, on the Quick Launch, click Application Management, and then click Manage service applications.

  5. In the list of service applications, make sure that that the App Management Service and User Profile Service Application are started.

  6. Obtain a .CER version of the signing certificate of the high-trust app and store it in a location that can be accessed during the rest of this procedure.

  7. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint Server 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  8. Click Start menu, click All Programs, click SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

  9. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $appId = "<AppID>"
    Copy code
    $spweb = Get-SPWeb "<AppURL>"
    Copy code
    $realm = Get-SPAuthenticationRealm -ServiceContext $spweb.Site
    Copy code
    $certificate = New-Object System.Security.Cryptography.X509Certificates.X509Certificate2("<CERFilePath>")
    Copy code
    $fullAppIdentifier = $appId + '@' + $realm
    Copy code
    New-SPTrustedSecurityTokenIssuer -Name "<FriendlyName>" -Certificate $certificate -RegisteredIssuerName $fullAppIdentifier

    Where:

    • <AppID> is the client ID assigned to the high-trust app when it was created.

      Important:

      All of the letters in the AppID must be in lowercase.

    • <AppURL> is the URL to the high-trust app's location on the app server.

    • <CERFilePath> is the path of the .CER version of the signing certificate of the high-trust app.

    • <FriendlyName> is a friendly name that identifies the app.

  10. Keep the Windows PowerShell command prompt open for the next procedure.

Step 2. Register the app with the Application Management service

Use the following procedure to register the app with the Application Management service.

To register the app as a SharePoint app principal

  1. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $appPrincipal = Register-SPAppPrincipal -NameIdentifier $fullAppIdentifier -Site $spweb -DisplayName "<DisplayName>"

    Where:

    • <DisplayName> is the name of the app as displayed in Central Administration.

  2. Keep the Windows PowerShell command prompt open for the next procedure.

Step 3. Configure app permissions

Use the following Windows PowerShell command to add or change individual app permissions. Repeat this procedure for as many times as needed to configure the permissions of the app.

To configure app permissions

  • At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-AppPrincipalPermission -appPrincipal $appPrincipal -site $web -right <Level> -scope <Scope>

    Where:

    • <Level> is Read, Write, Manage, or FullControl.

    • <Scope> is Farm, Site collection, SharePoint Online, Web, Documents, List, or Library.

    For more information, see Set-SPAppPrincipalPermission

For more information, see Plan app permissions management in SharePoint 2013.

See also

Plan for app authentication in SharePoint 2013
Plan app permissions management in SharePoint 2013

Build apps for SharePoint


Configure client certificate authentication for SharePoint 2013
See also

Published: September 25, 2012

Summary: Learn how to configure SharePoint 2013 to support user authentication using a client certificate.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Client certificate authentication enables web-based clients to establish their identity to a server by using a digital certificate, which provides additional security for user authentication. SharePoint 2013 does not provide built-in support for client certificate authentication, but client certificate authentication is available through Security Assertion Markup Language (SAML)-based claims authentication. You can use Active Directory Federation Services (AD FS) 2.0 as your security token service (STS) for SAML claims or any third-party identity management system that supports standard security protocols such as WS-Trust, WS-Federation, and SAML 1.1.

Note:

For more information about SharePoint 2013 protocol requirements, see SharePoint Front-End Protocols.

Claims-based authentication in SharePoint 2013 allows you to use different STSs. If you configure AD FS as your STS, SharePoint 2013 can support any identity provider or authentication method that AD FS supports, which includes client certificate authentication.

Note:

For more information about AD FS, see Active Directory Federation Services Overview.

In the following figure, SharePoint 2013 is configured as a relying partner for an AD FS-based STS.

SharePoint Server 2010 with ADFS 2.0

AD FS can authenticate user accounts for several different types of authentication methods, such as forms-based authentication, Active Directory Domain Services (AD DS), client certificates, and smart cards. When you configure SharePoint 2013 as a relying partner of AD FS, SharePoint 2013 trusts the accounts that AD FS validates and the authentication methods that AD FS uses to validate those accounts. This is how SharePoint 2013 supports client certificate authentication.

Configure client certificate authentication

The following topics explain how to configure SharePoint 2013 with client certificate authentication or smart card authentication when you use AD FS as your STS:

  1. Configure AD FS to support claims-based authentication.

    For more information, see AD FS 2.0 - How to change the local authentication type (http://go.microsoft.com/fwlink/p/?LinkId=212513).

  2. Configure SharePoint 2013 to support SAML-based claims authentication using AD FS.

    For more information, see Configure SAML-based claims authentication with AD FS in SharePoint 2013.

  3. Create a web application that uses SAML-based claims authentication.

    For more information, see Create claims-based web applications in SharePoint 2013.

Note:

These steps will be similar for a third-party STS.

See also

Configure SAML-based claims authentication with AD FS in SharePoint 2013

Planning and Architecture: AD FS 2.0
AD FS 2.0 Deployment Guide
Using Active Directory Federation Services 2.0 in Identity Solutions


Configure availability and recovery solutions for SharePoint 2013

Published: October 16, 2012

Summary: Learn about the options for providing high availability and disaster recovery solutions for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about installing and configuring high availability and disaster recovery solutions for a SharePoint 2013 farm.

The articles in this section assume that you are familiar with the concepts and terms presented in High availability and disaster recovery concepts in SharePoint 2013 and Plan for high availability and disaster recovery for SharePoint 2013.

TechNet articles about installing and configuring high availability and disaster recovery solutions

The following articles about high availability and disaster recovery solutions are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Configure SQL Server 2012 AlwaysOn Availability Groups for SharePoint 2013 | Describes how to install and configure a SQL Server 2012 AlwaysOn Availability Group for a SharePoint farm.


Configure SQL Server 2012 AlwaysOn Availability Groups for SharePoint 2013
See also

Updated: April 9, 2013

Summary: Learn how to create and configure a SQL Server 2012 AlwaysOn Availability Group for a SharePoint 2013 farm.

Applies to: SharePoint Server 2013 | SharePoint Server 2013 Enterprise

This article provides the required information and detailed procedures to create and configure a SQL Server 2012 AlwaysOn Availability Group for a SharePoint 2013 farm.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013. With both of these products these steps are to deploy a new SharePoint farm and do not cover upgrading from SQL Server 2008 R2 to SQL Server 2012.

In this article:

  • Process overview

  • Before you begin

  • Detailed steps to configure an AlwaysOn Availability Group for SharePoint

  • Use failover tests to validate the AlwaysOn installation

  • Monitor the AlwaysOn environment

Process overview

We recommend the following installation sequence and key configuration steps to deploy a SharePoint farm that uses an AlwaysOn availability group:

  • Select or create a Windows Server failover cluster.

  • Install SQL Server 2012 on each cluster node.

  • Create and configure an availability group.

  • Install and configure SharePoint 2013.

  • Add the SharePoint databases to the availability group.

  • Test failover for the availability group.

Before you begin

A SQL Server 2012 AlwaysOn Availability Group is not just a combination of database mirroring and database clustering. It is a completely new high availability and disaster recovery feature that co-exists with existing high availability and disaster recover options such as mirroring and log shipping.

Before you begin deployment, review the following information about SQL Server AlwaysOn, the technologies that support AlwaysOn, and SharePoint 2013:

  • Knowledge and skill requirements

  • AlwaysOn Availability Group concepts

  • Hardware and software requirements

  • Permissions

Knowledge and skill requirements

To implement SQL Server AlwaysOn Availability Groups as a high availability and disaster recovery solution, several technologies interact and have to be installed and configured correctly. We recommend that the team responsible for setting up an AlwaysOn environment for SharePoint products has a working knowledge of, and hands-on skills with the following technologies:

  • Windows Server Failover Clustering (WSFC) services

  • SQL Server 2012

  • SharePoint 2013

SQL Server AlwaysOn Availability Group concepts

A SQL Server Availability Group enables you to specify a set of databases that you want to fail over together as a single entity. When an availability group fails over to a target instance or target server, all the databases in the group fail over also. Because SQL Server 2012 can host multiple availability groups on a single server, you can configure AlwaysOn to fail over to SQL Server instances on different servers. This reduces the need to have idle high performance standby servers to handle the full load of the primary server, which is one of the many benefits of using availability groups.

An availability group consists of the following components:

  • Replicas, which are a discrete set of user databases called availability databases that fail over together as a single unit. Every availability group supports one primary replica and up to four secondary replicas.

  • A specific instance of SQL Server to host each replica and to maintain a local copy of each database that belongs to the availability group.

Replicas and failover

The primary replica makes the availability databases available for read-write connections from clients and sends transaction log records for each primary database to every secondary replica. Each secondary replica applies transaction log records to its secondary databases.

All replicas can run under asynchronous-commit mode, or up to three of them can run under synchronous-commit mode. For more information about synchronous and asynchronous commit mode, see Availability Modes (AlwaysOn Availability Groups).

Note:

Database issues, such as a database becoming suspect due to a loss of a data file, deletion of a database, or corruption of a transaction log do not cause failovers.

Read the following articles to learn required and important concepts about SQL Server AlwaysOn technology:

  • For details about the benefits of AlwaysOn Availability Groups and an overview of AlwaysOn Availability Groups terminology, see AlwaysOn Availability Groups (SQL Server).

  • For detailed information about prerequisites, see Prerequisites, Restrictions, and Recommendations for AlwaysOn Availability Groups (SQL Server). This article contains the following information:

    • Windows Server system requirements and recommendations

    • SQL Server instance prerequisites and restrictions

      Important:

      You can install SQL Server 2012 on Windows Server core to improve security and reduce maintenance, but you cannot install SharePoint 2013 on Windows Server core. For more information, see Server Core for Windows Server 2008 R2 [Server Core for Windows Server 2008 R2. For information about server core and Windows Server 2012, see Windows Server Installation Options.

    • Prerequisites and restrictions for using a SQL Server Failover Cluster Instance (FCI) to host an availability replica

  • Availability group prerequisites and restrictions

  • Availability database prerequisites and restrictions

Windows Server Failover Clustering

To create and use SQL Server 2012 AlwaysOn Availability Groups, you have to install SQL Server 2012 on a Windows Server Failover Clustering (WSFC) cluster. For more information, see Windows Server Failover Clustering (WSFC) with SQL Server.

Although configuring a WSFC cluster is out of the scope for this article, you should be aware of the following requirements before you install and configure a cluster:

  • All the cluster nodes must be in the same Active Directory Domain Services (AD DS) domain.

  • Each availability replica in an availability group must reside on a different node of the same Windows Server Failover Clustering (WSFC) cluster.

  • The cluster creator must have the following accounts and permissions:

    • Have a domain account in the domain where the cluster will exist.

    • Have local administrator permissions on each cluster node.

    • Have Create Computer objects and Read All Properties permissions in AD DS. For more information, see Failover Cluster Step-by-Step Guide: Configuring Accounts in Active Directory or Active Directory Domain Services for Windows Server 2012.

A very important aspect of configuring failover clustering and AlwaysOn is determining the quorum votes that are needed for the cluster nodes.

Failover clustering is based on a voting algorithm where more than one half of the voters, or quorum, must be online and able to communicate with each other. Because a given cluster has a specific number of nodes and a specific quorum configuration, the cluster service is able to determine what constitutes a quorum. The cluster service will stop on all the nodes if the number of voters drops below the required majority.

For more information, see WSFC Quorum Modes and Voting Configuration (SQL Server) and Configure Cluster Quorum NodeWeight Settings.

SharePoint Foundation 2013 and SharePoint Server 2013

Some SharePoint 2013 databases do not support SQL Server AlwaysOn Availability Groups. We recommend that you review the Supported high availability and disaster recovery options for SharePoint databases (SharePoint 2013) before you configure an AlwaysOn environment. You should also review the Hardware and software requirements for SharePoint 2013 article.

Detailed steps to configure an AlwaysOn Availability Group for SharePoint

The following illustration shows a SharePoint 2013 farm (SPHA_farm) that uses an availability group named SP_AG1. We'll use SPHA_farm as reference example in our steps to configure AlwaysOn.

A SharePoint 2013 farm that uses an AlwaysOn Availability Group

Prepare the Windows Server cluster environment

Obtain access to or create a three node Windows Server Failover Clustering (WSFC) cluster that you can use to install SQL Server 2012 on each cluster node. The following reference material provides guidance and detailed steps to configure a Windows Server failover cluster:

  • Failover Clusters in Windows Server 2008 R2.

    This page provides links to Getting Started, Deployment, Operations, and Troubleshooting articles for Windows Server 2008 R2.

  • Failover Clustering Overview.

    This page provides links to Getting Started, Deployment, Operations, and Troubleshooting articles for Windows Server 2012.

Prepare the SQL Server environment

Before you can create an Availability Group for SharePoint Foundation 2013 or SharePoint Server 2013, you must prepare the SQL Server 2012 environment. To prepare the environment, complete the following tasks:

  • Install the SQL Server prerequisites.

  • Install SQL Server.

  • Enable AlwaysOn.

When you prepare the database server environment you must consider SharePoint 2013 database requirements. Refer to the following articles before you install SQL Server:

  • Hardware requirements—database servers

  • Install SharePoint 2013

  • Configure SQL Server security for SharePoint 2013 environments

  • Supportability regarding SQL collation for SharePoint Databases and TempDB. (This guidance in this article also applies to SharePoint 2013.)

Install SQL Server 2012

To install SQL Server 2012

  1. Install SQL Server 2012 prerequisites on each cluster node.

    For more information, see Prerequisites, Restrictions, and Recommendations for AlwaysOn Availability Groups (SQL Server).

  2. Install SQL Server on each cluster node.

    For more information, see Installation for SQL Server 2012.

Enable AlwaysOn

You must enable AlwaysOn for each of the database servers in the cluster.

Note:

You can enable AlwaysOn by using SQL Server Management Studio, Transact-SQL, or Windows PowerShell 3.0.

To enable AlwaysOn

  1. Make sure that your logon account has the required permissions to create an availability group. The account must have membership in the db_owner fixed database role and either CREATE AVAILABILITY GROUP server permission, CONTROL AVAILABILITY GROUP permission, ALTER ANY AVAILABILITY GROUP permission, or CONTROL SERVER permission.

  2. Log on to the server that will host the primary replica and start SQL Server Management Studio.

  3. In Object Explorer, select SQL Server Services, right-click SQL Server (<instance name>), where <instance name> is the name of a local server instance for which you want to enable AlwaysOn Availability Groups, and then click Properties.

  4. Select the AlwaysOn High Availability tab.

  5. Select the Enable AlwaysOn Availability Groups check box, and then click OK.

  6. Although the change is saved you must manually restart the SQL Server service (MSSQLSERVER) to commit the change. The manual restart enables you to choose a restart time that is best for your business requirements.

  7. Repeat the previous steps to enable AlwaysOn for SQL Server on the other cluster nodes.

For more information, see Enable and Disable AlwaysOn Availability Groups (SQL Server) (http://go.microsoft.com/fwlink/p/?LinkId=267140).

Create and configure the availability group

Depending on the SQL Server 2012 environment where you plan to create the Availability Group, you might have to create a temporary database to before you create the Availability Group.

The process that creates an availability group requires you to provide a name for the availability group and then select an eligible user database on the connected server instance as an availability database.

Note:

To be eligible to be added to an availability group, a database must be a user database. System databases cannot belong to an availability group. For more information, see the "Availability Database Prerequisites and Restrictions" section of Prerequisites, Restrictions, and Recommendations for AlwaysOn Availability Groups (SQL Server) and see Creation and Configuration of Availability Groups (SQL Server).

If there no user databases are on the instance of the connected server, which is the case in our example, you need to create one.

Use the following procedure to create a temporary user database that will be a temporary primary replica for the group.

To create a temporary user database

  1. Make sure that your logon account has the correct permissions for this task. You require one of the following permissions in the master database to create the new database:

    • CREATE DATABASE

    • CREATE ANY DATABASE

    • ALTER ANY DATABASE

  2. Log on to the server that will host the primary replica, which is SP-SRV1 in our example.

  3. Start Management Studio.

  4. In Object Explorer, right-click Databases and then click New Database.

  5. In the New Database dialog box, type the Database name:, which is "TemporaryUserDB" for this example.

    Because this is a temporary database that you delete after you create the availability group, you can use the default settings. Click OK.

    Because the New Availability Group Wizard will not create an availability group unless the user database was backed up, you have to back up the temporary database.

  6. In Object Explorer expand Databases and right-click the temporary database that you just created. Pick Tasks and then choose Back Up.

  7. In the Back Up Database dialog box, click OK to accept all the default settings and create the back up.

About replicas and data synchronization

About replicas

Every availability replica is assigned an initial role—either the primary role or the secondary role, which the availability databases of that replica inherit. The role of a given replica determines whether it hosts read-write databases or read-only databases, the type of failover and whether it uses synchronous commit or asynchronous commit.

The following table shows the information that you have to provide for each replica, either when you first create the availability group, or when you add secondary replicas.

Replica configuration requirements

Replica information Description

Server Instance

Displays the name of the instance of the server that will host the availability replica.

Initial Role

Indicates the role that the new replica will first perform: Primary or Secondary.

Automatic Failover (Up to 2)

Indicates the type of failover that the replica uses: automatic or manual.

Synchronous Commit (Up to 3)

Indicates the type of commit that is used for the replica.

Readable Secondary

Indicates whether a secondary replica can be read.

The configuration options are unavailable for read access, read-only, and read-only intent. For more information, see Readable Secondary Replicas (AlwaysOn Availability Groups).

Important:

Readable secondary replicas are currently not supported for SharePoint 2013 runtime usage.

Note:

When you add replicas to a group, you will also provide the endpoint for each replica and configure backup preferences. For more information, see Specify the Endpoint URL When Adding or Modifying an Availability Replica (SQL Server) and Backup on Secondary Replicas (AlwaysOn Availability Groups).

Data synchronization

As part of the availability group creation process, you have to make an exact copy of the data on the primary replica and install the copy on the secondary replica. This is the initial data synchronization for the Availability Group. For more information, see Select Initial Data Synchronization Page (AlwaysOn Availability Group Wizards).

A network share must exist and must be accessed by all the nodes in the AlwaysOn configuration to do the initial data synchronization between all the cluster nodes that host a replica. For more information, see Network Shares Extension and File Services.

The following restrictions exist when you use the New Availability Group wizard to start data synchronization:

  • If the file paths on the secondary replica location differ from the file paths on the primary location, you have to start data synchronization manually.

  • If any secondary database exists on a secondary replica, you have to manually delete the secondary databases before you start data synchronization in the New Availability Group. However, if you want to use existing secondary databases, exit the New Availability Group wizard and start data synchronization manually.

  • To use the availability group wizard to synchronize data, you have to have a backup share that all the replicas can write to. You can specify the share by browsing to it or by entering its fully qualified universal naming convention (UNC) path name, \\Systemname\ShareName\Path\, in the Specify a shared network location accessible by all replicas box.

For each database in the availability group, the Start Data Synchronization page shows the progress of the following operations:

  • Creating a full database backup of the primary database on the network share.

  • Creating a full database backup of the primary database on the network share.

  • Restoring these backups to the secondary replica location.

    These restore operations both use RESTORE WITH NORECOVERY option and leave the new secondary database in the RESTORING state.

  • Joining the secondary database to the availability group.

    This step puts the secondary database in the ONLINE state and starts data synchronization for this database.

Login replication

SharePoint logins that are created by using the same approach as in previous releases of SQL Server are not replicated in an availability group. This occurs because login information is stored in the MasterDB database, which is not replicated. Although the farm accounts are created when replicas are synchronized, login information is not available after a failover.

If you have already created an availability group and synchronized the primary and secondary replicas, the workaround is to manually copy the logins from the primary replica to the secondary replicas.

SQL Server 2012 introduces the concept of Users with Passwords for Contained Databases. The database itself stores all the database metadata and user information, and a user who is defined in this database does not have to have a corresponding login. The information in this database is replicated by the availability group and is available after a failover. For more information, see Contained Databases.

Important:

If you create a new SharePoint login to use for an existing availability group, make sure to add the login to the contained database so it is replicated to each server that is hosting a SQL Server instance for the availability group. For example, if you create another application pool for a Web App and give it a new identity (an application pool account that you have not used), then you need to add that account as a login.

Create and configure the availability group

Use the following procedure to create an availability group on the primary replica, which is SP-SRV1 in our example.

Create the availability group

  1. Make sure that your logon account has the required permissions to create an availability group. This requires membership in the db_owner fixed database role and either CREATE AVAILABILITY GROUP server permission, CONTROL AVAILABILITY GROUP permission, ALTER ANY AVAILABILITY GROUP permission, or CONTROL SERVER permission.

  2. Log on to the server that will host the primary replica and start SQL Server Management Studio.

  3. To start the New Availability Group Wizard, right-click AlwaysOn High Availability and then click New Availability Group Wizard.

  4. Click Next to advance to the Specify Name page. Enter SP-AG1 as the name of the new availability group in the Availability group name: box.

    This name must be: a valid SQL Server identifier, unique on the Windows Server Failover Clustering cluster and unique on the domain.

  5. On the Select Databases page, all user databases that are eligible to become the primary database for the new availability group are listed on the User databases on this instance of SQL Server grid. Select TemporaryUserDB, and then click Next.

  6. On the Specify Replicas page, use the following tabs to configure the replicas for SP-AG1: Replicas, Endpoints, and Backup Preferences.

  7. An availability group listener is a virtual network name that provides client connectivity to the database a given availability group. Availability group listeners direct incoming connections to the primary replica or to a read-only secondary replica. The listener provides fast application failover after an availability group fails over. For more information, see Availability Group Listeners, Client Connectivity, and Application Failover (SQL Server).

    On the Listener tab, configure an availability group listener for our example, use the name AGListener.

    Important:

    Intermittent, unusually high latency might occur when you use availability groups that have replicas that are deployed on multiple subnets.

    As a best practice, connections to SharePoint availability groups in a multi-subnet environment should configure specifyMultiSubnetFailover=True to avoid issues caused by high network latency. For more information, see Supporting Availability Group Multi-Subnet Failovers.

    You cannot directly specify MultiSubnetFailover=True because a SharePoint client cannot directly modify a connection string. You must use Windows PowerShell to set this value on the MultiSubnetFailover database property. The following example shows how to do this.

    C# Copy code
    $dbs = Get-SPDatabase | ?{$_.MultiSubnetFailover -ne $true}
     foreach ($db in $dbs)
     {
          $db.MultiSubnetFailover = $true
           $db.Update()
     }

  8. Select the desired configuration for each instance in the Selected instances grid, and then click Next.

  9. Click Finish to create the availability group.

  10. The Select Initial Data Synchronization page lets you select a synchronization preference and specify the shared network location that all replicas can access. For our environment accept the default, Full, which performs full database and log backups. Click Next.

  11. The Validation page of the wizard displays the results of six checks before it lets you continue with availability group creation. If all checks pass, click Next to continue. If any tests fail, you cannot continue until you correct the error and then click Re-run Validation to run the validation tests again. When all the tests pass, click Next to continue.

  12. On the Summary page, verify the configuration of the replica that you are adding and then click Finish to save it. To change the configuration, click Previous to return to previous wizard pages.

Install and configure SharePoint 2013

At this point in the process, you can install SharePoint 2013 and create the farm. Use the following procedure as a guide to install and configure SharePoint 2013.

Note:

For detailed installation and configuration instructions, see Prepare for installation of SharePoint 2013 and Install SharePoint 2013.

To install SharePoint 2013

  1. Copy the SharePoint 2013 program files to a local disk on the computer where you plan to install SharePoint products or to a network file share.

  2. Run the Microsoft SharePoint Products Preparation Tool to install all the prerequisites to set up and use SharePoint 2013.

  3. Run Setup to install binaries, configure security permissions, and edit registry settings for SharePoint 2013.

  4. Run the SharePoint Products Configuration Wizard to install and configure the configuration database, install and configure the content database, and install the SharePoint Central Administration website.

  5. On the Specify Configuration Database Settings page, in the Database server box, type AGListener as the name of the computer that is running SQL Server.

    Important:

    To provide automatic failover, you must specify the name of the availability group listener as the name of the database for SharePoint 2013.

Add SharePoint databases to the availability group

To finalize setup of AlwaysOn for a SharePoint 2013 farm, add the SharePoint databases to the availability group and synchronize secondary replicas to the primary replica.

Important:

Only add the databases that are supported for use with a SQL Server AlwaysOn Availability Group. For more information, see Supported high availability and disaster recovery options for SharePoint databases (SharePoint 2013)

On the server that hosts the primary replica, you have to run the Add Databases to Availability Group wizard to add all the SharePoint databases to the availability group. The following procedure is the same as the procedure that we described to create the availability group.

To add SharePoint databases to the availability group

  1. Log on to the server that will host the primary replica and start SQL Server Management Studio.

    The account that that you use must be a member of the Local Administrators group for each server where you install SharePoint 2013

    In addition, the account must have at least one of the following permissions:

    • ALTER AVAILABILITY GROUP permission on the availability group

    • CONTROL AVAILABILITY GROUP permission

    • ALTER ANY AVAILABILITY GROUP permission

    • CONTROL SERVER permission

    To join a database to availability group requires membership in the db_owner fixed database role.

  2. In Object Explorer, browse to, and if it is necessary expand the Availability Groups.

  3. Right-click the example group, SP-AG1, and then click Add Database.

  4. On the Select Databases page, all user databases that are eligible to become the primary database for the new availability group are listed on the User databases on this instance of SQL Server grid. Use the checkboxes to select all the databases that you want to add to the group, and then click Next.

  5. The Select Initial Data Synchronization page lets you select a synchronization preference and specify the shared network location that all replicas can access. For our environment we'll accept the default, Full, which performs full database and log backups. Click Next.

  6. The Validation page of the wizard displays the results of six checks before it lets you continue with availability group creation. If any tests fail, you cannot continue until you correct the error and then click Re-run Validation to run the validation tests again. When all the tests pass, click Next to continue.

  7. On the Summary page, verify the configuration of the replica that you are adding, and then click Finish to keep it. To change the configuration, click Previous to return to previous wizard pages.

Important:

Databases that you add to a SharePoint farm are not automatically added to the availability group. You must add them by using the steps described in this article or by using scripts to automate the procedure.

Use failover tests to validate the AlwaysOn installation

After you synchronize the SharePoint data with the secondary replicas, the final step is to test failover.

You must run extensive failover tests to make sure that the behavior of the AlwaysOn environment is as expected and that you completely understand the configuration requirements and procedures related to SQL Server 2012Availability Groups. These tests include and are not limited to the following:

  • Verify that all the farm services and features are completely functional.

  • Verify that SharePoint 2013 data is preserved and not corrupted.

Test availability group failover by using either the planned manual failover described in Perform a Planned Manual Failover of an Availability Group (SQL Server) or the forced manual failover described in Perform a Forced Manual Failover of an Availability Group (SQL Server).

You can perform either of the previous failovers by using the Failover Wizard in SQL Server Management Studio, Transact-SQL, or Windows PowerShell in SQL Server 2012.

Note:

In an Active-Active failover cluster scenario where there are multiple SharePoint instances can fail over to each other you must ensure that each server has enough capacity to handle the local workload and the workload from the failed server.

Monitor the AlwaysOn environment

You have to monitor an AlwaysOn environment for performance, health, and capacity.

Performance

New performance objects, SQLServer:Database Replica and SQLServer:Availability Replica, are available to monitor an AlwaysOn environment.

Health and capacity

For general health monitoring you can use the Availability Groups Dashboard to obtain the health of the availability groups in the system. We recommend that you refer to the following posts on the official SQL Server AlwaysOn team blog to fully understand AlwaysOn health monitoring.

  • The AlwaysOn Health Model Part 1 -- Health Model Architecture

  • The AlwaysOn Health Model Part 2 -- Extending the Health Model

You can also use Transact-SQL to monitor availability groups by using the set of catalog and dynamic management views that are provided for AlwaysOn Availability Groups. For more information, see Monitor Availability Groups (Transact-SQL).

See also

Install and configure SharePoint 2013

Change History

Date | Description
April 09, 2013 | Removed information about configuring Named Pipes for SQL Server because it is not required. In addition, provided the correct information for configuring the database connection point when installing SharePoint.
October 16, 2012 | Initial publication


Configure email integration for a SharePoint 2013 farm

Summary: Use these TechNet articles to learn how to configure incoming and outgoing email for a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet provide information about email integration. After you install SharePoint 2013, you can configure incoming and outgoing email. These optional settings are useful if you want to work with email in the server farm.

TechNet articles about email integration

The following articles about email integration are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Configure incoming email for a SharePoint 2013 farm | This article describes how to configure incoming email so that SharePoint 2013 sites accept and archive incoming email. It also describes how to configure incoming email so that SharePoint sites can archive email discussions as they happen, save attachments, and show meetings that were sent and received by email on site calendars. In addition, this article describes how to configure the SharePoint Directory Management Service to provide support for email distribution list creation and management.
 | Configure outgoing email for a SharePoint 2013 farm | This article describes how to configure outgoing email so that your Simple Mail Transfer Protocol (SMTP) server sends email alerts to site users and notifications to site administrators.


Configure incoming email for a SharePoint 2013 farm
See also

Summary: Learn how to install and configure the SMTP service, prepare your environment, and configure incoming email for a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to configure incoming email for SharePoint 2013. This article also describes how to install and configure the SMTP service that you must use to enable incoming email.

When incoming email is enabled, SharePoint sites can receive and store email messages and attachments in lists and libraries. This article describes two scenarios, one basic and one advanced. The basic scenario applies to a single-server farm environment and is recommended if you want to use default settings. The advanced scenario applies to a single-server farm or a multiple-server farm and contains several advanced options from which to choose. For more information, see Plan incoming email for a SharePoint farm in SharePoint 2013.

In this article:

  • Before you begin

  • Install and configure the SMTP service

  • Configure incoming email in a basic scenario

  • Configure incoming email in an advanced scenario

  • Prepare your environment for incoming email in an advanced scenario

  • Are attachments missing from email messages that are sent to a SharePoint document library?

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Your system is running SharePoint 2013.

  • You have read Plan incoming email for a SharePoint farm in SharePoint 2013.

  • For the basic scenario, each SharePoint front-end web server must be running the Simple Mail Transfer Protocol (SMTP) service and the SharePoint Foundation Web Application service.

  • For the advanced scenario, you can use one or more servers in the server farm to run the SMTP service and to have a valid SMTP server address. Alternatively, you must know the name of a server outside the farm that is running the SMTP service and the location of the email drop folder.

If you have not installed and configured the SMTP service and do not choose to use an email drop folder, you must complete the steps in Install and configure the SMTP service before you configure incoming email.

Install and configure the SMTP service

Incoming email for SharePoint 2013 uses the SMTP service. You can use the SMTP service in one of two ways. You can install the SMTP service on one or more servers in the farm, or administrators can provide an email drop folder for email that is forwarded from the service on another server. For more information about the email drop folder option, see Plan incoming email for a SharePoint farm in SharePoint 2013.

Install the SMTP service

If you are not using a drop folder for email, the SMTP service must be installed on every front-end web server in the farm that you want to configure for incoming email. To install the SMTP service, use the Add Features Wizard in Server Manager. After you complete the procedure, the SMTP service is installed on the front-end web server.

To install the SMTP service

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the front-end web server.

  2. Click Start, point to Administrative Tools, and then click Server Manager.

  3. In Server Manager, click Features.

  4. In Features Summary, click Add Features to open the Add Features Wizard.

  5. On the Select Features page, select SMTP Server.

  6. In the Add Features Wizard dialog box, click Add Required Roll Services, and then click Next.

  7. On the Confirm Installation Selections page, click Install.

  8. On the Installation Results page, ensure that the installation finished successfully, and then click Close.

Install IIS 6.0 Management tools

To manage the SMTP service on Windows Server 2008 and Windows Server 2008 R2, you must use Internet Information Services (IIS) 6.0 Manager.

To install IIS 6.0 Manager

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Administrators group on the front-end web server.

  2. Click Start, point to Administrative Tools, and then click Server Manager.

  3. In Server Manager, click Roles.

  4. In Application Server section, click Add Role Services.

  5. On the Select Role Services page, select Management Tools and IIS 6 Management compatibility, and then click Install.

Configure the SMTP service

After you install the SMTP service, you configure it to accept email from the mail server for the domain. You can decide to accept relayed email from all servers except those that you specifically exclude. Alternatively, you can block email from all servers except those that you specifically include. You can include servers individually, in groups by subnet, or in groups by domain.

After you configure the service, set it to start automatically.

To configure the SMTP service

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the front-end web server.

  2. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS) 6.0 Manager.

  3. In IIS Manager, expand the server name that contains the SMTP server that you want to configure.

  4. Right-click the SMTP virtual server that you want to configure, and then click Start.

  5. Right-click the SMTP virtual server that you want to configure, and then click Properties.

  6. On the Access tab, in the Access control area, click Authentication.

  7. In the Authentication dialog box, verify that Anonymous access is selected.

  8. Click OK.

  9. On the Access tab, in the Relay restrictions area, click Relay.

  10. To enable relaying from any server, click All except the list below.

  11. To accept relaying from one or more specific servers, follow these steps:

    1. Click Only the list below.

    2. Click Add, and then add servers one at a time by IP address, or in groups by using a subnet or domain.

    3. Click OK to close the Computer dialog box.

  12. Click OK to close the Relay Restrictions dialog box.

  13. Click OK to close the Properties dialog box.

To set the SMTP service to start automatically

  1. Click Start, point to Administrative Tools, and then click Services.

  2. In Services, right-click Simple Mail Transfer Protocol (SMTP), and then select Properties.

  3. In the Simple Mail Transfer Protocol (SMTP) Properties dialog box, on the General tab, in the Startup type list, select Automatic.

  4. Click OK.

Configure incoming email in a basic scenario

You can use the following procedure to configure incoming email in a basic scenario by selecting the Automatic settings mode and using the default settings. After you complete the procedure, users can send email to lists and libraries.

To configure incoming email in a basic scenario

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that is running the SharePoint Central Administration website.

  2. In Central Administration, click System Settings.

  3. On the System Settings page, in the E-Mail and Text Messages (SMS) section, click Configure incoming e-mail settings.

  4. If you want to enable sites on this server to receive email, on the Configure Incoming E-Mail Settings page, in the Enable Incoming E-Mail section, click Yes.

  5. Select the Automatic settings mode.

  6. In the Incoming E-Mail Server Display Address section, in the E-mail server display address box, type a display name for the email server, for example, mail.fabrikam.com.

  7. Use the default settings for all other sections, and then click OK.

After you configure incoming email, users who have Manage Lists permissions can configure email-enabled lists and document libraries.

Configure incoming email in an advanced scenario

You can use the following procedure to configure incoming email in an advanced scenario by selecting the Advanced settings mode and additional options that you want to use for your incoming email environment. After you complete the procedure, users can send email to lists and libraries.

You can also use the Automatic settings mode in an advanced scenario. In the Automatic settings mode, you can select to receive email that has been routed through a safe-email server application. In the Advanced settings mode, you can instead specify a drop folder. For more information, see Plan incoming email for a SharePoint farm in SharePoint 2013.

Several of these steps mention prerequisite procedures that are documented in Prepare your environment for incoming email in an advanced scenario later in this article.

To configure incoming email in an advanced scenario

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that is running the SharePoint Central Administration website.

  2. In Central Administration, click System Settings.

  3. On the System Settings page, in the E-Mail and Text Messages (SMS) section, click Configure incoming e-mail settings.

  4. If you want to enable sites on this server to receive email, on the Configure Incoming E-mail Settings page, in the Enable Incoming E-Mail section, click Yes.

  5. Select the Advanced settings mode.

    You can specify a drop folder instead of using an SMTP server.

    Note:

    You can also select the Automatic settings mode and select whether to use Directory Management Service and whether to accept email from all email servers or from several specified email servers. For more information, see Plan incoming email for a SharePoint farm in SharePoint 2013.

  6. If you want to connect to Directory Management Service, in the Directory Management Service section, click Yes.

    If you select this option, you must first configure Active Directory Domain Services (AD DS). If you use Exchange Server, you must also configure the DNS Manager and add an SMTP connector. For more information, see Configure AD DS to be used with Directory Management Service, Configure DNS Manager, and Add an SMTP connector in Microsoft Exchange Server 2010 later in this article.

    1. In the Active Directory container where new distribution groups and contacts will be created box, type the name of the container in the format OU=ContainerName, DC=domain, DC=com, where ContainerName is the name of the OU in AD DS, domain is the second-level domain, and com is the top-level domain.

      The application pool identity account for Central Administration must be delegated the Create, delete, and manage user accounts task for the container. Access is configured in the properties for the OU in AD DS.

    2. In the SMTP mail server for incoming mail box, type the name of the SMTP mail server. The server name must match the FQDN in the A resource record entry for the mail server in DNS Manager.

    3. To accept messages only from authenticated users, click Yes for Accept messages from authenticated users only. Otherwise, click No.

    4. To enable users to create distribution groups from SharePoint sites, click Yes for Allow creation of distribution groups from SharePoint sites. Otherwise, click No.

    5. Under Distribution group request approval settings, select the actions that will require approval. Actions include the following:

      • Create new distribution group

      • Change distribution group e-mail address

      • Change distribution group title and description

      • Delete distribution group

  7. If you want to use a remote Directory Management Service, select Use remote and complete the remainder of this step. Otherwise, click No and proceed to step 8.

    If you select this option and you are using Exchange Server, you must configure the DNS Manager and add an SMTP connector. For more information, see Configure DNS Manager and Add an SMTP connector in Microsoft Exchange Server 2010 later in this article. The AD DS has most likely already been configured, so you do not need to do this.

    1. In the Directory Management Service URL box, type the URL of the Directory Management Service that you want to use. The URL is typically in the following format: http://server:adminport/_vti_bin/SharePointEmailWS.asmx.

    2. In the SMTP mail server for incoming mail box, type the name of the SMTP mail server. The server name must match the FQDN in the A resource record entry for the mail server in DNS Manager on the domain server.

    3. To accept messages from authenticated users only, click Yes for Accept messages from authenticated users only. Otherwise, click No.

    4. To allow creation of distribution groups from SharePoint sites, click Yes for Allow creation of distribution groups from SharePoint sites. Otherwise, click No.

  8. In the Incoming E-Mail Server Display Address section, in the E-mail server display address box, type a display name for the email server (for example, mail.fabrikam.com). You typically use this option together with the Directory Management Service.

    Tip:

    You can specify the email server address that is displayed when users create an incoming email address for a list or group. Use this setting together with Directory Management Service to provide an email server address that is easy to remember.

  9. In the E-Mail Drop Folder section, in the E-mail drop folder box, type the name of the folder from which the Windows SharePoint Services Timer service retrieves incoming email from the SMTP service. This option is available only if you selected Advanced settings mode. If you select this option, ensure that you configure the necessary permissions to the email drop folder. For more information, see Configure permissions to the email drop folder later in this article.

    It is useful to have a dedicated email drop folder if the default email drop folder is full or almost full.

    Ensure that the logon account for the SharePoint Timer service has Modify permissions on the email drop folder. For more information, see To configure email drop folder permissions for the logon account for the SharePoint Timer service later in this article.

  10. In the Safe E-Mail Servers section, select whether you want to accept email from all email servers or from specific email servers.

    This option is available only if you selected Automatic settings mode.

  11. Click OK.

After you configure incoming email, site administrators can configure email-enabled lists and document libraries.

If you selected Directory Management Service, contact addresses that are created for document libraries appear automatically in Active Directory Users and Computers. The addresses are displayed in the OU of AD DS for SharePoint 2013 and must be managed by the administrator of AD DS. The AD DS administrator can add more email addresses for each contact. For more information about AD DS, see Using Active Directory Service in the TechNet Library.

Alternatively, you can configure the computer running Exchange Server by adding a new Exchange Server Global recipient policy. The policy automatically adds external addresses that use the second-level domain name and not the subdomain or host name for SharePoint 2013. For more information about how to manage Exchange Server, see Recipient Configuration Node in the Exchange Server Technical Library.

Prepare your environment for incoming email in an advanced scenario

Before you configure incoming email in an advanced scenario, you need to perform additional procedures depending on how you want your incoming email environment to work.

If you want to use Directory Management Service, you must first configure AD DS, and if you use Exchange Server, you must also configure the DNS Manager and add an SMTP connector.

If you want to use a specific email drop folder, ensure that you configure the necessary permissions to the email drop folder.

In this section:

  • Configure AD DS to be used with Directory Management Service

  • Configure DNS Manager

  • Add an SMTP connector in Microsoft Exchange Server 2010

  • Configure permissions to the email drop folder

Configure AD DS to be used with Directory Management Service

If you plan to use Directory Management Service, you should first create an organizational unit (OU) and make the necessary configurations in AD DS.

To use Directory Management Service on a SharePoint farm, you must configure the application pool identity account for the SharePoint Central Administration website to have the Create, delete, and manage user accounts user right to the container that you specify in AD DS. The preferred way to do this is by assigning the right to the application pool identity account for the SharePoint Central Administration website. An AD DS administrator must set up the OU and assign the Create, delete, and manage user accounts right to the container. The advantage of using Directory Management Service on a remote server farm is that you do not have to assign rights to the OU for multiple farm service accounts.

The following procedures are performed on a domain controller that runs Windows Server 2008 with DNS Manager. In some deployments, these applications might run on multiple servers in the same domain.

To create an OU in AD DS

  1. Verify that the user account that is performing this procedure is a member of the Domain Administrators group or a delegated authority for domain administration on the domain controller that is running DNS Manager.

  2. Click Start, point to Administrative Tools, and then click Active Directory Users and Computers.

  3. In Active Directory Users and Computers, right-click the folder for the second-level domain that contains your server farm, point to New, and then click Organizational Unit.

  4. Type the name of the OU, and then click OK.

    After you create the OU, you must delegate the Create, delete, and manage user accounts right to the container of the OU to manage the user accounts.

To delegate the right to the application pool identity account for Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Domain Administrators group or the Enterprise Administrators group in AD DS, or a delegated authority for domain administration.

  2. In Active Directory Users and Computers, find the OU that you created.

  3. Right-click the OU, and then click Delegate control.

  4. On the Welcome page of the Delegation of Control Wizard, click Next.

  5. On the Users and Groups page, click Add, and then type the name of the application pool identity account that the Central Administration uses.

  6. In the Select Users, Computers, and Groups dialog box, click OK.

  7. On the Users or Groups page of the Delegation of Control Wizard, click Next.

  8. On the Tasks to Delegate page of the Delegation of Control Wizard, select the Create, delete, and manage user accounts check box, and then click Next.

  9. On the last page of the Delegation of Control Wizard, click Finish to exit the wizard.

To create and delete child objects, you must also delegate Create all Child Objects and Delete all Child Objects control of the OU to the application pool identity account for Central Administration. After you complete this procedure, the application pool identity account for Central Administration has Create all Child Objects and Delete all Child Objects control on the OU, and you can enable incoming email.

To delegate Create all Child Objects and Delete all Child Objects control of the OU to the application pool identity account for Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Domain Administrators group or the Enterprise Administrators group in AD DS, or a delegated authority for domain administration.

  2. Right-click the OU, and then click Delegate control.

  3. In the Delegation of Control Wizard, click Next.

  4. Click Add, and then type the name of the application pool identity account for Central Administration.

  5. Click OK.

  6. Click Next.

  7. On the Tasks to Delegate page of the Delegation of Control Wizard, select Create a custom task to delegate, and then click Next.

  8. Click This folder, existing objects in this folder, and creation of new objects in this folder, and then click Next.

  9. In the Permissions section, select Create all Child Objects and Delete all Child Objects.

  10. Click Next.

  11. On the last page of the Delegation of Control Wizard, click Finish to exit the wizard.

Delegating Create all Child Objects and Delete all Child Objects control of the OU to the application pool identity account for Central Administration enables administrators to enable email for a list. After these controls have been delegated, administrators cannot disable email for the list or document library because the Central Administration account tries to delete the contact from the whole OU instead of from the list.

To avoid this problem, you must add Delete Subtree permissions for the application pool identity account for Central Administration. Use the following procedure to add these permissions. After this procedure is complete, you can disable incoming email for a list.

To add Delete Subtree permissions for the application pool identity account for Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Domain Administrators group or the Enterprise Administrators group in AD DS, or a delegated authority for domain administration.

  2. In Active Directory Users and Computers, click the View menu, and then click Advanced Features.

  3. Right-click the OU, and then click Properties.

  4. In the Properties dialog box, click the Security tab, and then click Advanced.

  5. In the Permission Entries area, double-click the application pool identity account for Central Administration.

    If the application pool identity account is listed more than once, select the first one.

  6. In the Permissions area, select Allow, for Delete Subtree.

  7. Click OK to close the Permissions dialog box.

  8. Click OK to close the Properties dialog box.

  9. Click OK to close Active Directory Users and Computers.

After you add these permissions, you must restart Internet Information Services (IIS) for the farm.

For more information, see Active Directory Users, Computers, and Groups in the TechNet Library.

Configure DNS Manager

If you are using Exchange Server and are routing email internally in your organization, you must create a host (A) resource record in DNS Manager to associate DNS domain names of computers (or hosts) to their IP addresses. Your organization might already have a configured DNS Manager and an A resource record. If not, then use the following procedure.

To create an A resource record for a subdomain

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer.

  2. In DNS Manager, select the forward lookup zone for the domain that contains the subdomain for SharePoint 2013.

  3. Right-click the zone, and then click New Host (A or AAAA).

  4. In the New Host dialog box, in the Name text box, type the host or subdomain name for SharePoint 2013.

  5. In the Fully qualified domain name (FQDN) text box, type the FQDN for the server that is running SharePoint 2013. This is typically in the format subdomain.domain.com.

  6. Ensure that the domains that are listed under the SMTP server in IIS match the FQDN of the server that receives email. If they do not match, you must create a local domain. For instructions, see To create a local domain later in this article.

  7. In the IP address text box, type the IP address to which you want the FQDN to resolve.

  8. Click Add Host.

  9. In the message that confirms the creation of the host record, click OK.

  10. In the New Host dialog box, click Done.

    The A resource record now appears in DNS Manager.

If you use the E-mail server display address option and if the email address to which you are sending email messages is not the same as your server name, you must create a local domain.

To create a local domain

  1. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS) 6.0 Manager.

  2. In IIS Manager, expand the SMTP server.

  3. Right-click Domains, and on the Action menu, point to New, and then click Domain.

  4. In the New SMTP Domain Wizard dialog box, select Alias, and then click Next.

  5. In the Domain Name area, in the Name box, type the address of the mail that is to be received by this domain.

    This address must be the same as the one that you specified in step 4 in To create an A resource record for a subdomain, and in step 6b in To configure incoming email in an advanced scenario.

  6. Click Finish.

  7. In the message that confirms the creation of the host record, click OK.

  8. Restart the SMTP server so that all email messages that are still in the Queue folder move to the Drop folder. The messages are then sent by the Windows SharePoint Services Timer service to their destination list or library.

Note:

If you are routing email from outside your organization to an SMTP server, you must use an MX record. For more information, see Add a mail exchanger (MX) resource record to a zone in the Windows Server Technical Library.

Add an SMTP connector in Microsoft Exchange Server 2010

An SMTP connector gives you more control over the message flow in your organization. Other reasons to use an SMTP connector are to set delivery restrictions or to specify a specific address space. If you use Exchange Server to route incoming email to SharePoint lists and libraries, you must have an SMTP connector so that all mail that is sent to the SharePoint domain uses the servers that are running the SMTP service.

Use the following procedure to add an SMTP connector in Exchange Server. After you complete the procedure, the SMTP connector ensures that incoming email messages are sent to the correct list and library in the farm.

To add an SMTP connector in Exchange Server

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that is running Exchange Server.

  2. In Exchange Management Console, expand the Organization Configuration group, right-click Hub Transport, point to New Send Connector.

    The New Send Connector wizard appears.

  3. On the Introduction page, do the following and then click Next:

    1. In the Name box, type a name for the SMTP connector.

    2. In the Select the intended use for this Send connector box, select the Custom usage type for the connector.

  4. On the Address Space page, click Add, and then click SMTP Address Space.

  5. In the SMTP Address Space dialog box, do the following:

    1. In the Address box, type an email domain for the connector.

    2. In the Cost box, assign an appropriate cost. By default, the cost is 1.

  6. Click OK to return to the Address Space page, and then click Next.

  7. On the Network settings page, select Use domain name system (DNS) "MX" records to route mail automatically, and then click Next.

  8. On the Source Server page, click Next.

    The Source server page only appears on Hub Transport servers. By default, the Hub Transport server that you are currently working on is listed as a source server.

  9. On the New Connector page, review your options and then click New to create the new send connector.

  10. On the Completion page, ensure that the send connector was created, and then click Finish.

    In the Hub Transport pane, you can see that the send connector has been enabled automatically.

For more information, see Create an SMTP Send Connector in the Exchange Server Technical Library.

Configure permissions to the email drop folder

You can specify a particular email drop folder, which enables SharePoint 2013 to retrieve incoming email from a network share on another server. You can use this option if you do not want to use an SMTP service. However, the drawback of using this option is that SharePoint 2013 cannot detect configuration changes on the remote email server that is delivering email to the drop folder. The result is that SharePoint 2013 cannot retrieve email if the location of the email messages has changed. However, this feature is useful if the default email drop folder is full or almost full.

If you specified an email drop folder, you must ensure that the application pool identity accounts for Central Administration and for the web application have the required permissions to the email drop folder.

Configure email drop folder permissions for the application pool identity account for a web application

If your deployment uses different application pool identity accounts for Central Administration and for one or more web applications, each application pool identity account must have permissions to the email drop folder. If the application pool identity account for the web application does not have the required permissions, email will not be delivered to document libraries on that web application.

In most cases, when you configure incoming email and select an email drop folder, permissions are added for the following worker process groups:

  • WSS_Admin_WPG, which includes the application pool identity account for Central Administration and the logon account for the SharePoint Timer service, and has Full Control permissions.

  • WSS_WPG, which includes the application pool accounts for web applications, and has Read & Execute, List Folder Contents, and Read permissions.

In some cases, these groups might not be configured automatically for the email drop folder. For example, if Central Administration is running as the Network Service account, the groups or accounts that are needed for incoming email will not be added when the email drop folder is created. Check to determine whether these groups have been added automatically to the email drop folder. If the groups have not been added automatically, you can add them or add the specific accounts that are required.

To configure email drop folder permissions for the application pool identity account for a web application

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that contains the email drop folder.

  2. In Windows Explorer, right-click the drop folder, click Properties, and then click the Security tab.

  3. On the Security tab, under the Group or user names box, click Edit.

  4. In the Permissions for Windows Explorer dialog box, click Add.

  5. In the Select Users, Computers, or Groups dialog box, in the Enter the object names to select box, type the name of the worker process group or application pool identity account for the web application, and then click OK.

    This account is listed on the Identity tab of the Properties dialog box for the application pool in IIS.

  6. In the Permissions for User or Group box, next to Modify, select Allow.

  7. Click OK.

Configure email drop folder permissions for the logon account for the SharePoint Timer service

Ensure that the logon account for the Windows SharePoint Services Timer service has Modify permissions on the email drop folder. If the logon account for the service does not have Modify permissions, email-enabled document libraries will receive duplicate email messages.

To configure email drop folder permissions for the logon account for the SharePoint Timer service

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that contains the email drop folder.

  2. In Windows Explorer, right-click the drop folder, click Properties, and then click the Security tab.

  3. On the Security tab, under the Group or user names box, click Edit.

  4. In the Permissions for Windows Explorer dialog box, click Add.

  5. In the Select Users, Computers, or Groups dialog box, in the Enter the object names to select box, type the name of the logon account for the SharePoint Timer service, and then click OK.

    This account is listed on the Log On tab of the Properties dialog box for the service in the Services snap-in.

  6. In the Permissions for User or Group box, next to Modify, select Allow.

  7. Click OK.

Are attachments missing from email messages that are sent to a SharePoint document library?

If attachments are missing from email messages that are sent to a SharePoint document library, it might be because you associated the document library with an email address. When you do this, Directory Management Service may not add the following two attributes to the user associated with the email address:

  • internet Encoding = 1310720

  • mAPIRecipient = false

You must use Active Directory Service Interfaces (ADSI) to manually add these two missing attributes.

On servers that are running Windows Server 2008 or Windows Server 2008 R2, ADSI Edit is installed when you configure a server as a domain controller by installing the AD DS role. You can also install Windows Server 2008 Remote Server Administration Tools (RSAT) on domain member servers or stand-alone servers. For more information, see Installing or Removing the Remote Server Administration Tools Pack in the Windows Server Technical Library.

To add attributes by using ADSI Edit

  1. Click Start, and then click Run.

  2. In the Run dialog box, type Adsiedit.msc, and then click OK.

  3. In the ADSI Edit window, expand ADSI Edit, expand Domain [DomainName], expand DC=DomainName, DC=com, and then expand CN=Users.

  4. Right-click the user name to which you want to add the missing attributes, and then click Properties.

  5. In the Properties dialog box, double-click Internet Encoding on the Attribute Editor tab.

  6. In the Integer Attribute Editor dialog box, type 1310720 in the Value box, and then click OK.

  7. In the Properties dialog box, double-click mAPIRecipient on the Attribute Editor tab.

  8. In the Boolean Attribute Editor dialog box, click False, and then click OK two times.

See also

Plan incoming email for a SharePoint farm in SharePoint 2013

Resource Center: Installation and Deployment for SharePoint Server 2010


Configure outgoing email for a SharePoint 2013 farm
See also

Summary: Learn how to install and configure the SMTP service and configure outgoing email for a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to configure outgoing email for a farm or for a specific web application for SharePoint 2013. This article also describes how to install and configure the SMTP service that you must use to enable outgoing email.

After you have installed SharePoint 2013 and completed the initial configuration of your server farm, you can configure outgoing email. Doing so enables users to create alerts to track such site items as lists, libraries, and documents. In addition, site administrators can receive administrative messages about site administrator issues, such as the information that site owners have exceeded their specified storage space. For more information, see Plan outgoing email for a SharePoint farm in SharePoint 2013.

To configure outgoing email for a specific web application, first configure the default outgoing email for all web applications in the farm. If you configure the outgoing email for a specific web application, that configuration will override the default configuration for all web applications in the farm.

Important:

You cannot configure outgoing email by using Windows PowerShell.

In this article:

  • Before you begin

  • To install the SMTP service

  • To install IIS 6.0 Management tools

  • To configure the SMTP service

  • To set the SMTP service to start automatically

  • To configure outgoing email for a farm by using Central Administration

  • To configure outgoing email for a specific web application by using Central Administration

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Your computer is running SharePoint 2013.

  • One or more servers in the server farm are running the Simple Mail Transfer Protocol (SMTP) service and have a valid SMTP server address. Alternatively, you must know the name of a server outside the farm that is running the SMTP service.

If you have not installed and configured the SMTP service, before you configure outgoing email you must complete the steps in:

  • Install and configure the SMTP service

Install and configure the SMTP service

Before you can enable outgoing email, you must determine which SMTP server to use. This SMTP server must be configured to allow anonymous SMTP email submissions. The SMTP server can be a server in the farm or outside the farm.

Note:

If your organization does not allow anonymous SMTP email messages to be sent by using Exchange Server, you can use a local SMTP server in the SharePoint farm that accepts anonymous email messages. The local SMTP server automatically authenticates the messages and then forwards them to the computer that's running Exchange Server.

Install the SMTP service

To install the SMTP service, use the Add Features Wizard in Server Manager. The wizard creates a default SMTP configuration. You can customize this default SMTP configuration to meet the requirements of your organization.

If you already have the SMTP service installed on a server, skip to Configure the SMTP service later in this article.

To install the SMTP service

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the front-end web server.

  2. Click Start, point to Administrative Tools, and then click Server Manager.

  3. In Server Manager, click Features.

  4. In Features Summary, click Add Features to open the Add Features Wizard.

  5. On the Select Features page, select SMTP Server.

  6. In the Add Features Wizard dialog box, click Add Required Roll Services, and then click Next.

  7. On the Confirm Installation Selections page, click Install.

  8. On the Installation Results page, ensure that the installation is complete, and then click Close.

Configure the SMTP service

After you install the SMTP service, you configure it to send email messages from servers in the farm.

You can decide to send relayed email messages to all servers except those that you specifically exclude. Alternatively, you can block messages to all servers except those that you specifically include. You can include servers individually or in groups by subnet or domain.

If you enable anonymous access and relayed email messages, you increase the possibility that the SMTP server will be used to relay unsolicited commercial email messages (spam). It is important to limit this possibility by carefully configuring mail servers to help protect against spam. One way that you can do this is by limiting relayed email messages to a list of specific servers or to a domain, and by preventing relayed email messages from all other servers.

Note:

To manage the SMTP service on Windows Server 2008, you must use Internet Information Services (IIS) 6.0 Manager. Ensure that you install IIS 6.0 Management tools in Server Manager.

To install IIS 6.0 Management tools

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the front-end web server.

  2. Click Start, point to Administrative Tools, and then click Server Manager.

  3. In Server Manager, click Roles.

  4. In the Application Server section, click Add Role Services.

  5. On the Select Role Services page, select Management Tools and IIS 6 Management compatibility, and then click Install.

To configure the SMTP service

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the front-end web server.

  2. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS) 6.0 Manager.

  3. In IIS Manager, expand the server name that contains the SMTP server that you want to configure.

  4. Right-click the SMTP virtual server that you want to configure, and then click Start.

  5. Right-click the SMTP virtual server that you want to configure, and then click Properties.

  6. On the Access tab, in the Access control area, click Authentication.

  7. In the Authentication dialog box, verify that Anonymous access is selected.

  8. Click OK.

  9. On the Access tab, in the Relay restrictions area, click Relay.

  10. To enable relayed email messages to any server, click All except the list below.

  11. To accept relayed email messages from one or more specific servers, follow these steps:

    1. Click Only the list below.

    2. Click Add, and then add servers one at a time by IP address, or in groups by using a subnet or domain.

    3. Click OK to close the Computer dialog box.

  12. Click OK to close the Relay Restrictions dialog box.

  13. Click OK to close the Properties dialog box.

Ensure that the SMTP service is running and set to start automatically. To do this, use the following procedure.

To set the SMTP service to start automatically

  1. Click Start, point to Administrative Tools, and then click Services.

  2. In Services, right-click Simple Mail Transfer Protocol (SMTP), and then select Properties.

  3. In the Simple Mail Transfer Protocol (SMTP) Properties dialog box, on the General tab, in the Startup type list, select Automatic.

  4. Click OK.

Configure outgoing email for a farm

You can configure outgoing email for a farm by using the SharePoint Central Administration website. Use the following procedures to configure outgoing email. After you complete the procedures, users can track changes and updates to individual site collections. In addition, site administrators can, for example, receive notices when users request access to a site.

To configure outgoing email for a farm by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group on the server that is running the SharePoint Central Administration website.

  2. In Central Administration, click System Settings.

  3. On the System Settings page, in the E-Mail and Text Messages (SMS) section, click Configure outgoing e-mail settings.

  4. On the Outgoing E-Mail Settings page, in the Mail Settings section, type the SMTP server name for outgoing email (for example, mail.example.com) in the Outbound SMTP server box.

  5. In the From address box, type the email address as you want it to be displayed to email recipients.

  6. In the Reply-to address box, type the email address to which you want email recipients to reply.

  7. In the Character set list, select the character set that is appropriate for your language.

  8. Click OK.

Configure outgoing email for a specific web application

You can configure outgoing email for a specific web application by using the Central Administration website. Use the following procedures to configure outgoing email.

Note:

To configure outgoing email for a specific web application, first configure the default outgoing email for all web applications in the farm. If you configure the outgoing email for a specific web application, that configuration will override the default configuration for all web applications in the farm.

To configure outgoing email for a specific web application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group on the server that is running the SharePoint Central Administration website.

  2. In Central Administration, in the Application Management section, click Manage web applications.

  3. On the Web Applications Management page, select a web application, and then in the General Settings group on the ribbon, click Outgoing E-mail.

  4. On the Web Application Outgoing E-Mail Settings page, in the Mail Settings section, type the name of the SMTP server for outgoing email (for example, mail.fabrikam.com) in the Outbound SMTP server box.

  5. In the From address box, type the email address (for example, the site administrator alias) as you want it to be displayed to email recipients.

  6. In the Reply-to address box, type the email address (for example, a help desk alias) to which you want email recipients to reply.

  7. In the Character set list, click the character set that is appropriate for your language.

  8. Click OK.

See also

Plan outgoing email for a SharePoint farm in SharePoint 2013

Configure alert settings for a Web application (SharePoint Server 2010)
Resource Center: Installation and Deployment for SharePoint Server 2010


Configure services and service applications in SharePoint 2013

Summary: Introduces articles that describe how to configure services for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

In SharePoint 2013, you can configure individual services independently, and you can implement only the services that your organization needs.

Deployed services are named service applications. A service application provides a resource that you can share across sites in a farm or sometimes across multiple farms, and users can access them through a hosting web application. Service applications are associated to web applications by service application connections.

For more information about service applications and services, see Technical diagrams for SharePoint 2013. If you plan to use Office Web Apps, you must install and configure them to work with SharePoint 2013. For more information, see Office Web Apps overview (Used with SharePoint 2013 Preview Products).

The following articles on TechNet and related resources provide information about how to configure services for SharePoint 2013.

TechNet articles about how to configure services for SharePoint 2013

The following articles about how to configure services for SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Settings icon Content | Description
Configure Excel Services in SharePoint Server 2013 | Deploy Excel Services to a SharePoint Server 2013 farm by creating an Excel Services service application by using Central Administration.
Configure a Business Intelligence Center in SharePoint Server 2013 | Create a Business Intelligence Center in SharePoint Server 2013 by using the Business Intelligence Center enterprise template and creating a new site collection.
Create and configure Machine Translation services in SharePoint Server 2013 | The Machine Translation Service in SharePoint 2013 lets users automatically translate documents. This topic describes how to create a Machine Translation Service Application and configure the Machine Translation Service by using Central Administration, or Windows PowerShell.
Configure PerformancePoint Services (SharePoint Server 2013) | Configure PerformancePoint Services in SharePoint Server 2013 before you make it available to users
Create and configure a Search service application in SharePoint Server 2013 | This article describes how to create and configure a SharePoint Search service application so that you can crawl content and provide search results to users.
Manage the search topology in SharePoint Server 2013 | Learn how to retrieve, clone, add, move, remove and activate search components in the search topology using Windows PowerShell. Use these procedures to scale out or scale down the search topology of the Search service application
Create a Search Center site in SharePoint Server 2013 | This article describes how to create a SharePoint Search Center site and grant site access to users.
Deploy people search in SharePoint Server 2013 | Learn how to set up SharePoint people search so that users can find people in the organization and the documents that they have authored.
Configure result sources for search in SharePoint Server 2013 | Learn how to create and manage result sources for SharePoint Search service applications, and for SharePoint sites and site collections.
Customize search result types in SharePoint 2013 | Create and configure custom search result types in SharePoint 2013 so that users can readily distinguish and preview different kinds of items in a list of search results.
Configure the Secure Store Service in SharePoint 2013 | This article describes the SharePoint 2013Secure Store Service operations that solution designers can use to create target applications that map user and group credentials to the credentials of external data sources.
Administer the User Profile service in SharePoint Server 2013 | Learn how to configure and administer the User Profile service and User Profile Synchronization service.
Visio Graphics Service administration in SharePoint Server 2013 | Learn how to create, configure, list, or delete Visio Services service applications by using Central Administration or Windows PowerShell.
Share service applications across farms in SharePoint 2013 | Describes the process and cautions that are involved in sharing service applications across farms.

Additional resources about how to configure services for SharePoint 2013

The following resources about how to configure services for SharePoint 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | Installation and Deployment for SharePoint 2013 Resource Center | Visit the Resource Center to access videos, Community Sites, documentation, and more.


Configure the Secure Store Service in SharePoint 2013

Summary: Configure storage of authorization credentials in Secure Store Service on a SharePoint Server 2013 farm. A video demonstration is included.

Applies to: SharePoint Server 2013 Enterprise

This article describes how to configure the Secure Store Service on a SharePoint Server 2013 farm. Secure Store has important planning considerations associated with it. Be sure to read Plan the Secure Store Service in SharePoint Server 2013 before you begin the procedures in this article.

In this article:

  • Video demonstration (configuration)

  • Configure Secure Store

  • Work with encryption keys

  • Store credentials in Secure Store

  • Create a target application

  • Set credentials for a target application

  • Enable the audit log

  • Video demonstration (target applications)

Video demonstration (configuration)

This video shows the steps involved in setting up a Secure Store Service service application service application in SharePoint Server 2013, as described in this article.

Video: Configure the Secure Store Service in SharePoint 2013

Video (play button) icon

Configure Secure Store

To configure Secure Store, you perform the following steps:

  1. Register a managed account in SharePoint Server 2013 to run the Secure Store application pool.

  2. Start the Secure Store Service on an application server in the farm.

  3. Create a Secure Store Service service application.

To run the application pool, you must have a standard domain account. No specific permissions are required for this account. Once the account has been created in Active Directory, follow these steps to register it with SharePoint Server 2013.

To register a managed account

  1. On the SharePoint Central Administration Web site home page, in the left navigation, click Security.

  2. On the Security page, in the General Security section, click Configure managed accounts.

  3. On the Managed Accounts page, click Register Managed Account.

  4. In the User name box, type the name of the account.

  5. In the Password box, type the password for the account.

  6. If you want SharePoint Server 2013 to handle changing the password for the account, select the Enable automatic password change box and specify the password change parameters that you want to use.

  7. Click OK.

Once you have configured the registered account, you must start the Secure Store Service on an application server in the farm. Because Secure Store deals with sensitive information, we recommend that you use a separate application server just for the Secure Store Service for better security.

To start the Secure Store Service

  1. On the Central Administration home page, in the System Settings section, click Manage services on server.

  2. Above the Service list, click the Server drop-down list, and then click Change Server.

  3. Select the application server where you want to run the Secure Store Service.

  4. In the Service list, click Start next to Secure Store Service.

Once the service is started, you must create a Secure Store Service service application. Use the following procedure to create the service application.

To create a Secure Store Service service application

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click New, and then click Secure Store Service.

  3. In the Service Application Name box, type a name for the service application (for example, Secure Store Service).

  4. In the Database Server box, type the instance of SQL Server where you want to create the Secure Store database.

    Note:

    Because the Secure Store database contains sensitive information, we recommend that you deploy the Secure Store database to a different instance of SQL Server from the rest of SharePoint Server 2013.

  5. Select the Create new application pool option and type a name for the application pool in the text box.

  6. Select the Configurable option, and, from the drop-down list, select the account for which you created the managed account earlier.

  7. Click OK.

The Secure Store Service has now been configured. The next step is to generate an encryption key for encrypting the Secure Store database.

Work with encryption keys

Before using the Secure Store Service, you must generate an encryption key. The key is used to encrypt and decrypt the credentials that are stored in the Secure Store Service database.

Generate an encryption key

The first time that you access the Secure Store service application, your only option is to generate a new encryption key. Once the key has been generated, the rest of the Secure Store functionality becomes available.

To generate a new encryption key

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store service application.

  3. In the Key Management group, click Generate New Key.

  4. On the Generate New Key page, type a pass phrase string in the Pass Phrase box, and type the same string in the Confirm Pass Phrase box. This pass phrase is used to encrypt the Secure Store database.

    Important:

    A pass phrase string must be at least eight characters and must have at least three of the following four elements:

    • Uppercase characters

    • Lowercase characters

    • Numerals

    • Any of the following special characters

      "! " # $ % & ' ( ) * + , - . / : ; < = > ? @ [ \ ] ^ _ ` { | } ~

    Important:

    The pass phrase that you enter is not stored. Make sure that you write this down and store it in a safe place. You must have it to refresh the key, such as when you add a new application server to the server farm.

  5. Click OK.

For security precautions or as part of regular maintenance you may decide to generate a new encryption key and force the Secure Store Service to be re-encrypted based on the new key. You can use this same procedure to do this.

Caution:

You should back up the database of the Secure Store Service application before generating a new key.

Refresh the encryption key

Refreshing the encryption key propagates the key to all the application servers in the farm. You may be required to refresh the encryption key if any of the following things are true:

  • You add a new application server to the server farm.

  • You restore a previously backed up Secure Store Service database and have since changed the encryption key.

  • You receive an "Unable to get master key" error message.

  • You have upgraded your farm from SharePoint Server 2010.

To refresh the encryption key

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store service application.

  3. In the Key Management group, click Refresh Key.

  4. In the Pass Phrase box, type the pass phrase that you first used to generate the encryption key.

    This phrase is either the pass phrase that you used when you initialized the Secure Store Service service application or one that you used when you created a new key by using the Generate a New Key command.

  5. Click OK.

Store credentials in Secure Store

Storing credentials in Secure Store is accomplished by using a Secure Store target application. A target application maps the credentials of a user, group, or claim to a set of encrypted credentials stored in the Secure Store database. After a target application is created, you can associate it with an external content type or application model, or use it with a business intelligence service application such as Excel Services or Visio Services to provide access to an external data source. When a SharePoint Server 2013 service application calls the target application, Secure Store confirms that the user making the request is an authorized user of the target application and then retrieves the encrypted credentials. The credentials are then used on the user's behalf by the SharePoint Server 2013 service application.

To create a target application, you must do the following:

  1. Create the target application itself, specifying the type of credentials that you want to store in the Secure Store database, the administrators for the target application, and the credential owners.

  2. Specify the credentials that you want to store.

Create a target application

Target applications are configured on the Secure Store Service Application page in Central Administration. Use the following procedure to create a target application.

To create a target application

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store service application.

  3. In the Manage Target Applications group, click New.

  4. In the Target Application ID box, type a text string.

    This is the unique string that you will use externally to identify this target application.

  5. In the Display Name box, type a text string that will be used to display the identifier of the target application in the user interface.

  6. In the Contact Email box, type the e-mail address of the primary contact for this target application.

    This can be any legitimate e-mail address and does not have to be the identity of an administrator of the Secure Store Service application.

  7. When you create a target application of type Individual (see below), you can implement a custom Web page that lets users add individual credentials for the destination data source. This requires custom code to pass the credentials to the target application. If you did this, type the full URL of this page in the Target Application Page URL field. There are three options:

    • Use default page: Any Web sites that use the target application to access external data will have an individual sign-up page that was added automatically. The URL of this page will be http:/<samplesite>/_layouts/SecureStoreSetCredentials.aspx?TargetAppId=<TargetApplicationID>, where <TargetApplicationID> is the string typed in the Target Application ID box. By publicizing the location of this page, you can enable users to add their credentials for the external data source.

    • Use custom page: You provide a custom Web page that lets users provide individual credentials. Type the URL of the custom page in this field.

    • None: There is no sign-up page. Individual credentials are added only by a Secure Store Service administrator who is using the Secure Store Service application.

  8. In the Target Application Type drop-down list, choose the target application type: Group, for group credentials, or Individual, if each user is to be mapped to a unique set of credentials on the external data source.

    Note:

    There are two primary types for creating a target application:

    • Group, for mapping all the members of one or more groups to a single set of credentials on the external data source.

    • Individual, for mapping each user to a unique set of credentials on the external data source.

  9. Click Next.

  10. Use the Specify the credential fields for your Secure Store Target Application page to configure the various fields which may be required to provide credentials to the external data source. By default, two fields are listed: Windows User Name and Windows Password.

    To add an additional field for supplying credentials to the external data source, on the Specify the credential fields for your Secure Store Target Application page, click Add Field.

    By default, the type of the new field is Generic. The following field types are available:

    Field Description

    Generic

    Values that do not fit in any of the other categories.

    User Name

    A user account that identifies the user.

    Password

    A secret word or phrase.

    PIN

    A personal identification number.

    Key

    A parameter that determines the functional output of a cryptographic algorithm or cipher.

    Windows User Name

    A Windows user account that identifies the user.

    Windows Password

    A secret word or phrase for a Windows account.

    Certificate

    A certificate.

    Certificate Password

    The password for the certificate.

    • To change the type of a new or existing field, click the arrow that appears next to the type of the field, and then select the new type of field.

      Note:

      Every field that you add will be required to have data when you set the credentials for this target application.

    • You can change the name that a user sees when interacting with a field. In the Field Name column of the Specify the credential fields for your Secure Store Target Application page, change a field name by selecting the current text and typing new text.

    • When a field is masked, each character that a user types is not displayed but is replaced with a mask character such as the asterisk "*". To mask a field, click the check box for that field in the Masked column of the page.

    • To delete a field, click the delete icon for that field in the Delete column of the page.

    When you have finished editing the credential fields, click Next.

  11. In the Specify the membership settings page, in the Target Application Administrators Field, list all users who have access to manage the target application settings.

  12. If the target application type is group, in the Members field, list the user groups to map to a set of credentials for this target application.

  13. Click OK to complete configuring the target application.

Set credentials for a target application

After creating a target application, an administrator of that target application can set credentials for it. These credentials are used by the calling application to provide access to an external data source. If the target application is of type Individual, you can also enable users to supply their own credentials.

To set credentials for a target application

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store service application.

  3. In the target application list, point at the target application for which you want to set credentials, click the arrow that appears, and then, in the menu, click Set credentials.

    If the target application is of type Group, type the credentials for the external data source. Depending on the information that is required by the external data source, the fields for setting credentials will vary.

    If the target application is of type Individual, type the user name of the individual who will be mapped to this set of credentials on the external data source, and type the credentials for the external data source. Depending on the information that is required by the external data source, the fields for setting credentials will vary.

  4. Click OK.

Once you have set the credentials for the target application, it is ready to be used by a SharePoint Server 2013 service such as Business Connectivity Services or Excel Services.

Enable the audit log

Audit entries for the Secure Store service are stored in the Secure Store Service database. By default, the audit log file is disabled.

An audit log entry stores information about a Secure Store Service action, such as when it was performed, whether it succeeded, why it failed if it didn't succeed, the Secure Store Service user who performed it, and optionally the Secure Store Service user on whose behalf it was performed. Therefore, a valid reason to enable an audit log file is to troubleshoot an authentication issue.

To enable the audit log by using Central Administration

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. Select the Secure Store service application. (That is, select the service application, but do not click the link to go to the Secure Store Service application settings page.)

  3. On the ribbon, click Properties.

  4. From the Enable Audit section, click to select the Audit log enabled box.

  5. To change the number of days that entries will be purged from the audit log file, specify a number in days in the Days Until Purge field. The default value is 30 days.

  6. Click OK.

Video demonstration (target applications)

This video shows the steps necessary to configure a Secure Store service application.

Note:

This video uses SharePoint Server 2010. Target applications function in the same way in SharePoint Server 2013.

Video: How target applications are used in Secure Store

Video (play button) icon


Create and configure a Search service application in SharePoint Server 2013
See also

Summary: Learn how to create and configure a SharePoint Search service application so that you can crawl content and provide search results to users.

Applies to: SharePoint Server 2013

Before you begin

If you used the Farm Configuration Wizard after you installed SharePoint Server 2013, a Search service application might have been created at that time. To verify whether a Search service application exists, you can click Manage service applications in the Application Management section on the Central Administration home page. For the remainder of this article, it is assumed that a Search service application does not exist yet, and that therefore you must create one.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

How to create and configure a SharePoint Search service application

When you deploy and configure a Search service application, you perform the following main tasks:

  1. Create accounts — Certain domain user accounts are required specifically for a Search service application.

  2. Create a Search service application — A Search service application provides enterprise search features and functionality.

  3. Configure the Search service application — Basic configuration of a Search service application includes configuring a default content access account, an email contact, and content sources.

  4. Configure the Search service application topology — You can deploy search components on different servers in the farm. You can also specify which instance of SQL Server is used to host the search-related databases.

Step 1: Create accounts that are required for a SharePoint Search service application

The following table lists the accounts that are required when a Search service application is created.

Account Description Notes

Search service

Windows user credentials for the SharePoint Server Search service, which is a Windows service

This setting applies to all Search service applications in the farm. You can change this account at any time by clicking Configure service accounts in the Security section on the Central Administration home page.

  • Search Admin Web Service application pool

  • Search Query and Site Settings Web Service application pool

Windows user credentials

For each of these accounts, you can use the same credentials that you specified for the Search service. Or, you can assign different credentials to each account according to the principle of least-privilege administration.

Default content access

Windows user credentials for the Search service application to use to access content when crawling

We recommend that you specify a separate account for the default content access account according to the principle of least-privilege administration.

The accounts that you use for the Search service, the Search Admin Web Service application pool, and the Search Query and Site Settings Web Service application pool must be registered as managed accounts in SharePoint Server 2013 so that they are available when you create the Search service application. Use the following procedure to register each of these accounts as a managed account.

To register a managed account

  1. On the Central Administration home page, in the Quick Launch, click Security.

  2. On the Security page, in the General Security section, click Configure managed accounts.

  3. On the Managed Accounts page, click Register Managed Account.

  4. On the Register Managed Account page, in the Account Registration section, type the user name and password that you want to use as credentials for the service account.

  5. If you want SharePoint Server 2013 to manage password changes for this account, select the Enable automatic password change check box and configure the parameters for automatic password change.

  6. Click OK.

Step 2: Create a SharePoint Search service application

Each Search service application has a separate content index. You can create multiple Search service applications if you want to have different content indexes for different sets of content. For example, if you want to segregate sensitive content (such as employee benefits information) into a separate content index, you can create a separate Search service application to correspond to that set of content.

Note:

Each Search service application has its own search topology. If you create more than one Search service application in a farm, we recommend that you allocate dedicated servers for the search topology of each Search service application. Deploying several Search service applications to the same servers will significantly increase the resource requirements (CPU and memory) on those servers.

Use the following procedure to create a Search service application.

To create a Search service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group for the farm for which you want to create the service application.

  2. On the Central Administration home page, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, on the ribbon, click New, and then click Search Service Application.

  4. On the Create New Search Service Application page, do the following:

    1. Accept the default value for Service Application name, or type a new name for the Search service application.

    2. In the Search Service Account list, select the managed account that you registered in the previous procedure to run the Search service.

    3. In the Application Pool for Search Admin Web Service section, do the following:

      1. Select the Create new application pool option, and then specify a name for the application pool in the Application pool name text box.

      2. In the Select a security account for this application pool section, select the Configurable option, and then from the list select the account that you registered to run the application pool for the Search Admin Web Service.

    4. In the Application Pool for Search Query and Site Settings Web Service section, do the following:

      1. Choose the Create new application pool option, and then specify a name for the application pool in the Application pool name text box.

      2. In the Select a security account for this application pool section, select the Configurable option, and then from the list select the account that you registered to run the application pool for the Search Query and Site Settings Web Service.

  5. Click OK.

Step 3: Configure the SharePoint Search service application

You configure a Search service application on the Search Administration page for that service application. Use the following procedure to go to the Search Administration page for a particular Search service application.

To go to the Search Administration page

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application that you want to configure.

  2. On the home page of the Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application that you want to configure.

On the Search Administration page, configure the settings as described in the following sections:

  • Specify the default content access account

  • Specify the contact email address

  • Create content sources

Specify the default content access account

When you create a Search service application, the account that you specify for the Search service is automatically configured as the default content access account. The crawler uses this account to crawl content that does not have an associated crawl rule that specifies a different account. For the default content access account, we recommend that you specify a domain user account that has read access to as much of the content that you want to crawl as possible. You can change the default content access account at any time.

If you have to crawl certain content by using a different account, you can create a crawl rule and specify a different account for crawling. For information about how to create a crawl rule, see Manage crawl rules in SharePoint Server 2013.

Use the following procedure to specify the default content access account.

To specify the default content access account

  1. On the Search Administration page, in the System Status section, click the link in the Default content access account row.

  2. In the Default Content Access Account dialog box, in the Account box, type the account that you created for content access in the form domain\user name.

  3. Type the password for this account in the Password and Confirm Password boxes.

  4. Click OK.

Specify the contact email address

The Search service writes the contact email address to the logs of crawled servers. The default contact email address, someone@example.com, is a placeholder. We recommend that you change this to an account that an external administrator can contact when a crawl might be contributing to a problem such as a decrease in performance on a server that the search system is crawling.

Use the following procedure to specify the contact email address.

To specify the contact email address

  1. On the Search Administration page, in the System Status section, click the link for the Contact e-mail address.

  2. In the Search E-mail Setting dialog box, in the E-mail Address box, type the email address that you want to appear in the logs of servers that are crawled by the search system.

  3. Click OK.

Create content sources in a SharePoint Search service application

Crawling requires at least one content source. A content source is a set of options that you use to specify the type of content to crawl, the starting URLs to crawl, and when and how deep to crawl. When a Search service application is created, a content source named "Local SharePoint sites" is automatically created and configured for crawling all SharePoint sites in the local server farm. You can create content sources to specify other content to crawl and how the system will crawl that content. For more information, see Add, edit, or delete a content source in SharePoint Server 2013. However, you do not have to create other content sources if you do not want to crawl content other than the SharePoint sites in the local farm.

If you choose the Standalone installation option when you install SharePoint Server 2013, a full crawl of all SharePoint sites in the farm is automatically performed after installation and an incremental crawl is scheduled to occur every 20 minutes after that. If you choose the Server Farm installation option when you install SharePoint Server 2013, no crawls are automatically scheduled or performed.

Step 4: Configure the SharePoint Search service application topology

When you create a Search service application, the SharePoint Server Search service is started on the application server that is hosting the Central Administration website, and search components are deployed to that server. If you have more than one application server in your farm, you can deploy additional search components on other application servers, depending on your requirements. You can deploy multiple instances of certain components. For more information, see Manage the search topology in SharePoint Server 2013.

See also

Create a Search Center site in SharePoint Server 2013


Create a Search Center site in SharePoint Server 2013
See also

Summary: Learn how to create a SharePoint Search Center site and grant site access to users.

Applies to: SharePoint Server 2013

Note:

The article does not apply to SharePoint Online, because in that environment a Search Center site is automatically available at <host_name>/search/.

A Search Center site, or Search Center, provides an interface for users to submit search queries and view search results. A Search Center site is the top-level site of a site collection that a farm administrator creates by using the Enterprise Search Center template or the Basic Search Center template.

Before you begin

Depending on the kind of installation that you performed and the site collection template that you selected at that time, the farm might already have a Search Center site. To check this, browse to the top-level site for the site collection that you created during installation. In either case, you can create a Search Center site and grant users access to it by using the procedures in this article. After you create the Search Center site, the site collection administrator or site owner might want to add features and functionality so that the site provides a richer interface than the search box that appears by default on each SharePoint site.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

To create a SharePoint Search Center site

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the home page of the Central Administration website, in the Application Management section, click Create site collections.

  3. On the Create Site Collection page, do the following:

    1. In the Web Application section, select a web application to contain the new site collection. To use a web application other than the one that is displayed, click the web application that is displayed, and then click Change Web Application.

    2. In the Title and Description section, in the Title box, type the name for the new Search Center site. Optionally, type a description in the Description box.

    3. In the Web Site Address section, for the part of the URL immediately after the web application address, select /sites/, or select a managed path that was previously defined, and then type the final part of the URL.

      Note the address of the new Search Center for future reference.

    4. In the Template Selection section, do the following:

      1. In the Select the experience version drop-down list, select 2013 to create a Search Center site that provides the SharePoint Server 2013 user experience, or select 2010 to create a Search Center site that provides the SharePoint 2010 Products user experience.

      2. In the Select a template subsection, click the Enterprise tab, and then do one of the following:

        • If you are using SharePoint Foundation 2013, select the Basic Search Center template.

        • Otherwise, if you are using SharePoint Server 2013, select the Enterprise Search Center template.

    5. In the Primary Site Collection Administrator section, in the User name box, type the user name of the primary site collection administrator for this site collection in the form domain\user name.

    6. (Optional) In the Secondary Site Collection Administrator section, type the user name of a secondary site collection administrator in the form domain\user name.

    7. In the Quota Template section, select No Quota.

      A Search Center site is not intended to be a data repository. Therefore, you do not have to select a quota template.

    8. Click OK.

  4. On the Top-Level Site Successfully Created page, click the link to the Search Center site that you created.

After you create the Search Center site, you must grant site access to users so that they can perform search queries and view search results. Use the following procedure to grant site access to users.

To grant access to the SharePoint Search Center

  1. Verify that the user account that is performing this procedure is a member of the Owners group on the Search Center site.

  2. In a web browser, go to the Search Center site.

  3. Open the Site menu by clicking the gear icon in the upper-right portion of the page, and then click Site Permissions.

  4. In the Shared with dialog box, click Invite people.

  5. In the Share <SearchCenterName> dialog box, in the Enter users separated with semicolons text box, type the names of the Windows user groups and Windows users to whom you want to grant permissions for submitting queries and viewing search results in the Search Center.

    For example, to grant access to the Search Center to all Windows users, type NT Authority\authenticated users.

  6. Click Show options.

  7. Clear the Send an email invitation check box.

  8. In the Select a group or permission level drop-down list, select <SearchCenterName> Visitors [Read].

  9. Click Share.

See also

Create and configure a Search service application in SharePoint Server 2013
Manage the Search Center


Deploy people search in SharePoint Server 2013
See also

Published: October 16, 2012

Summary: Learn how to set up SharePoint people search so that users can find people in the organization and the documents that they have authored.

Applies to: SharePoint Server 2013

In this article:

  • Before you begin

  • People search prerequisites

  • Set up people search

  • Add data for people search

  • Crawl the profile store

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

People search prerequisites

People search has the following prerequisites:

  • A Search service application must be running in the farm. For more information, see Create and configure a Search service application in SharePoint Server 2013. The farm must also have a Search Center that uses the Enterprise Search Center template. For more information, see Create a Search Center site in SharePoint Server 2013.

  • A Managed Metadata service application must be running in the farm. For more information, see Overview of managed metadata service applications in SharePoint Server 2013.

  • User profile synchronization must be configured in the farm. If this has not been done yet, at a minimum you must complete the following procedures that are described in Synchronize user and group profiles in SharePoint Server 2013:

    • Phase 0: Configure the farm

    • Phase 1: Start the User Profile synchronization service

For more information, see Overview of profile synchronization in SharePoint Server 2013 and Plan profile synchronization for SharePoint Server 2013.

The following sections describe how to deploy and provide data for people search.

Set up people search

To set up people search, you must configure My Sites settings and configure crawling.

Configure My Sites settings

You configure My Sites for a User Profile service application to specify the My Site Host location and other settings. For more information, see Plan for My Sites in SharePoint Server 2013 and Configure My Site settings for the User Profile service application.

After you configure My Sites settings, the next step is to configure crawling.

Configure crawling

When you configure My Sites, the default content access account for search is automatically given Retrieve People Data for Search Crawlers permissions in the User Profile service application. If you want to use a different content access account to crawl the profile store, you must make sure that the account has permissions to crawl the profile store. Use the following procedure to grant access to the profile store for a different account.

To grant access to an account to crawl the profile store

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, in the Application Management section, click Manage service applications.

  4. On the Manage Service Applications page, click the row that contains the User Profile service application, and then in the ribbon, click Administrators.

  5. In the Administrators for User Profile Service Application dialog box, in the To add an account box, type a user account in the form domain\user name.

  6. Click Add.

  7. In the Permissions list, select the Retrieve People Data for Search Crawlers check box.

  8. Click OK.

After you give the account access to crawl the profile store, you must create a crawl rule to specify that you want to use that account when you crawl the profile store. Use the following procedure to create a crawl rule for this purpose.

To create a crawl rule to authenticate to the User Profile service application

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application for which you want to create a crawl rule.

  4. On the Search Administration page, in the Quick Launch, in the Crawling section, click Crawl Rules.

  5. On the Manage Crawl Rules page, click New Crawl Rule.

  6. In the Path section, in the Path box, type the start address for the User Profile service application in the form sps3://<hostname>, where <hostname> is the URL for the Web application where you deployed the My Sites site collection.

  7. Click Use regular expression syntax for matching this rule if you want to use regular expression syntax in the path.

  8. In the Crawl Configuration section, select Include all items in this path.

  9. In the Specify Authentication section, select Specify a different content access account.

  10. In the Account box that appears, type the user account to which you gave access to the profile store in the form domain\user name.

  11. Type the password for the account that you specified in the Password and Confirm Password boxes.

  12. Clear the Do not allow Basic Authentication check box only if you want to allow the user account credentials to be sent as plaintext.

    Note:

    You should not clear the Do not allow Basic Authentication check box unless you are using SSL to encrypt the website traffic. For more information, see Plan for user authentication methods in SharePoint 2013.

  13. Click OK.

For more information, see Manage crawl rules in SharePoint Server 2013.

When you configure My Sites, the starting URL to crawl the profile store (sps3://<hostname>) is automatically added to the default content source. We recommend that you remove the URL of the profile store from the default content source and then create a separate content source to crawl only the profile store. This allows you to crawl the profile store on a different schedule from other crawls.

Use the following procedure to remove the URL of the profile store from the default content source.

To remove the profile store URL from the default content source

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click Search Service Application.

  4. On the Search Administration page, in the Quick Launch, in the Crawling section, click Content Sources.

  5. On the Manage Content Sources page, click the link to the default content source (Local SharePoint sites).

  6. In the Start Addresses section, remove the URL for the profile store (sps3://<hostname>, where <hostname> is the URL for the web application where you deployed the My Sites site collection).

  7. Click OK.

    Use the following procedure to create a content source that specifies how to crawl the profile store.

To create a content source that specifies how to crawl the profile store

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click Search Service Application.

  4. On the Search Administration page, in the Quick Launch, in the Crawling section, click Content Sources.

  5. On the Manage Content Sources page, click New Content Source.

  6. On the Add Content Source page, in the Name section, type a name for this content source.

  7. In the Content Source Type section, ensure that SharePoint Sites is selected.

  8. In the Start Addresses section, type the start address in the form sps3://<hostname>, where <hostname> is the URL for the web application where you deployed the My Sites site collection.

  9. In the Crawl Settings section, leave the default value of Crawl everything under the host name for each start address.

  10. In the Crawl Schedules section, do the following:

    • Select Enable Continuous Crawls or Enable Incremental Crawls.

      A continuous crawl automatically provides maximum freshness for the content source without an incremental crawl schedule. For more information, see Manage continuous crawls in SharePoint Server 2013.

      If you select Enable Incremental Crawls, create an incremental crawl schedule.

    • Optionally create a schedule for full crawls.

  11. If you selected Enable Incremental Crawls, in the Content Source Priority section, select the priority for this content source.

    Note:

    The Content Source Priority section does not appear when you specify the content source type as SharePoint Sites and you select Enable Continuous Crawls.

  12. Click OK.

Add data for people search

To get the best results from people search, you should add as much information as you can by adding user profiles to the profile store and adding information to My Sites.

Add user profiles to the profile store

Before you can obtain meaningful people search results, you must add user profiles to the User Profile service application. You can do this in the following ways:

  • Import user profiles from the directory service. For more information, see the following articles:

    • Plan profile synchronization for SharePoint Server 2013

    • Synchronize user and group profiles in SharePoint Server 2013

    • Configure profile synchronization by using SharePoint Active Directory Import in SharePoint Server 2013

    • Configure profile synchronization using a Lightweight Directory Interchange Format (LDIF) file in SharePoint 2013

  • Add user profiles manually.

  • Synchronize with an external data source by using the Business Data Connectivity service. For more information, see Phase 3: Configure connections and import data from business systems in the article Synchronize user and group profiles in SharePoint Server 2013.

Important:

For a test environment, we recommend that you do not synchronize the profile store to a directory service or other external data source that is in a production environment. Instead, create a copy of the directory service and synchronize the copy with the profile store.

Use the following procedure to view the user profiles in the User Profile service application.

To view a list of user profiles in the User Profile service application

  1. Verify that the user account that is performing this procedure is an administrator for the User Profile service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the User Profile service application.

  4. On the Manage Profile Service page, in the People section, click Manage User Profiles.

  5. On the Manage User Profiles page, in the Find profiles box, type the name of the domain of which the users are members.

    Do not type the fully qualified domain name. For example, if users are members of the Contoso.com domain, type Contoso in the Find profiles box.

  6. Click Find.

Add information to My Sites

My Sites keep information in the User Profile service application databases. The User Profile service application stores much of the information that appears in results for people search. People search results become more useful as users add more information to their My Sites.

The first time that a user accesses their My Site, also known as their personal site, a My Site is created for them and a profile is automatically added to the User Profile service application.

To add information to a user's My Site, log on as a user for whom a user profile was created in the User Profile service application, and then go to that user's My Site. In the user's My Site, you can provide information about the user's expertise and interests. To see how the information that you added affects the people search results that appear, perform a crawl of the profile store, and then search on the user's name.

Crawl the profile store

You are now ready to crawl the profile store. For information about how to start the crawl, see Start, pause, resume, or stop a crawl in SharePoint Server 2013.

Note:

We recommend that you crawl the profile store and wait about two hours after the crawl finishes before you start the first crawl of the default content source (that is, local SharePoint sites). After the crawl of the profile store finishes, the search system generates a list to standardize people's names. This is so that when a person's name has different forms in search results, the results are displayed in a single group corresponding to one name. For example, all documents authored by Anne Weiler or A. Weiler or alias AnneW can be displayed in the search results in a result block that is labeled "Documents by Anne Weiler". Similarly, all documents authored by any of those identities can be displayed under the heading "Anne Weiler" in the refinement panel if "Author" is one of the categories there.

For information about how to view the status of a crawl, see Start, pause, resume, or stop a crawl.

See also

Create and configure a Search service application in SharePoint Server 2013
Create a Search Center site in SharePoint Server 2013
Manage crawling in SharePoint 2013
Administer the User Profile service in SharePoint Server 2013
Overview of profile synchronization in SharePoint Server 2013
Manage user profile synchronization in SharePoint Server 2013
Plan for My Sites in SharePoint Server 2013


Configure trust for search between two SharePoint Server 2013 farms
See also

Updated: May 7, 2013

Summary: Configure a SharePoint Server 2013 content farm that receives search queries to trust the SharePoint Server 2013 farm that sends the queries.

Applies to: SharePoint Server 2013

To configure an on-premises SharePoint Server 2013 content farm to return results from its search index to a separate on-premises SharePoint Server 2013 farm, you must perform the following two main procedures:

  1. In the farm that will receive the search queries, configure trust of the farm that will send the queries by doing the following:

    • Configure a server-to-server trust relationship by using the Open Authorization 2.0 (OAuth 2.0) web authorization protocol.

    • Enable the farm that receives the queries to return search results from all of its web applications that host content.

  2. In the farm that will send the search queries, create a result source that does each of the following:

    • Specifies Remote SharePoint as the protocol.

    • Specifies the address of any root site collection in the SharePoint farm that will receive the search queries.

    For more information, see Configure result sources for search in SharePoint Server 2013.

    Note:

    After you create the result source, you expose the search results that it provides by using it in a Web Part or a query-rule action. In this way, users of the farm that is sending search queries can see results from the farm that is receiving the queries. For more information, see Understanding result sources for search in SharePoint Server 2013.

This article describes how to perform the first procedure in the list above: how to configure the farm that receives search queries to trust the farm that sends the queries.

For brevity in this article, the following terms are used:

SendingFarm | An on-premises SharePoint Server 2013 farm that has a search service that sends search queries to ReceivingFarm.
ReceivingFarm | An on-premises SharePoint Server 2013 content farm that has a search index that receives search queries from SendingFarm. In this article, it is assumed that ReceivingFarm has at least one web application that hosts content.

In order for SendingFarm to be able to get search results from the search index in ReceivingFarm, the farms must have the following characteristics:

  • Each farm is a SharePoint Server 2013 on-premises deployment.

  • User profiles in the two farms are synchronized. For more information, see Server-to-server authentication and user profiles in SharePoint Server 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

To configure ReceivingFarm to trust SendingFarm

  1. Verify that the account that performs this procedure is a member of the following groups:

    • Farm Administrators group in ReceivingFarm.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

      An administrator of that server can use the Add-SPShellAdmin cmdlet to grant someone permission to use SharePoint 2013 cmdlets. When you run the Add-SPShellAdmin cmdlet, you must have membership in the securityadmin fixed server role on the SQL Server instances, and you must have membership in the db_owner fixed database role on all databases that are to be updated. For more information, see Add-SPShellAdmin. Contact your system administrator or SQL Server administrator to request these memberships if you do not have them.

  2. On a server in ReceivingFarm, start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start page, click SharePoint 2013 Management Shell.

      • If SharePoint 2013 Management Shell is not on the Start page, right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

      For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On a server in ReceivingFarm, run the following commands at a Windows PowerShell command prompt. The commands use the OAuth 2.0 web authorization protocol to configure a server-to-server trust, so that ReceivingFarm will trust SendingFarm.

    Copy code
    # Create a trusted security token issuer
$i = New-SPTrustedSecurityTokenIssuer -Name "SendingFarm" -IsTrustBroker:$false -MetadataEndpoint "https://<SendingFarm_web_application>/_layouts/15/metadata/json/1"
# Configure trust of the token-signing certificate'
# by adding the trust used to sign oAuth tokens'
# to the list of trusted root authorities'
# in ReceivingFarm
New-SPTrustedRootAuthority -Name "SendingFarm" -MetadataEndPoint https://<SendingFarm_web_application>/_layouts/15/metadata/json/1/rootcertificate

    Where:

    https://<SendingFarm_web_application> is any SSL-enabled web application in SendingFarm

    Important:

    Web applications that include server-to-server authentication endpoints for incoming server-to-server requests, or that make outgoing server-to-server requests, should be configured to use Secure Sockets Layer (SSL). For information about how to configure a web application to use SSL, see Create claims-based web applications in SharePoint 2013. For information about how to configure HTTP support for server-to-server requests, see Configure an STS for HTTP in Configure server-to-server authentication in SharePoint 2013.

  4. On a server in ReceivingFarm, at a Windows PowerShell command prompt, run the following command:

    Copy code
    # Use $realm to store the string'
# that comes after the "@" character'
# in the value of $i.NameId
$realm = $i.NameId.Split("@")

  5. On a server in ReceivingFarm, at a Windows PowerShell command prompt, run the following commands to enable all web applications in ReceivingFarm to return search results to SendingFarm:

    Copy code
    $s1 = Get-SPSite -Identity https://<ReceivingFarm_web_application>
$sc1 = Get-SPServiceContext -Site $s1
# Set up an authentication realm for'
# a web application that hosts content in ReceivingFarm
Set-SPAuthenticationRealm -ServiceContext $sc1 -Realm $realm[1]
# Get a reference to the application principal'
# for that web application in Farm B
$p = Get-SPAppPrincipal -Site https://<ReceivingFarm_web_application> -NameIdentifier $i.NameId
# Grant rights to the application principal'
# that SendingFarm will use'
# when it sends queries to ReceivingFarm
Set-SPAppPrincipalPermission -Site https://<ReceivingFarm_web_application> -AppPrincipal $p -Scope SiteCollection -Right FullControl

    Where:

    https://<ReceivingFarm_web_application> is an SSL-enabled web application in ReceivingFarm.

  6. Repeat the previous step (step 5) for each web application in ReceivingFarm that hosts content that you want to search.

See also

Authentication overview for SharePoint 2013
Plan for server-to-server authentication in SharePoint 2013
Configure server-to-server authentication in SharePoint 2013
Plan for server-to-server authentication in SharePoint 2013

Setting Up an oAuth Trust Between Farms in SharePoint 2013
Getting a Full Result Set from a Remote SharePoint Index in SharePoint 2013
An Introduction to JavaScript Object Notation (JSON) in JavaScript and .NET

Change History

Date | Description
May 07, 2013 | Corrected the file path of the metadata endpoint in two of the cmdlets in the Windows PowerShell code.
April 23, 2013 | Initial publication


Configure result sources for search in SharePoint Server 2013
See also

Updated: April 30, 2013

Summary: Learn how to create and manage result sources for SharePoint Search service applications, and for SharePoint sites and site collections.

Applies to: SharePoint Server 2013

Result sources limit searches to certain content or to a subset of search results. SharePoint Server 2013 provides 16 pre-defined result sources. The pre-configured default result source is Local SharePoint Results. You can specify a different result source as the default. For more information, see Understanding result sources.

In this article:

  • Before you begin

  • Create a result source

  • Set a result source as default

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Create a result source

You can create a result source for a Search service application, a site collection, or a site. The following table shows the permissions that are required to create a result source at each level, and where the result source can be used.

Levels and permissions for result sources

When you create a result source at this level | You must have this permission | The result source can be used in
Search service application | Search service application administrator | All site collections in web applications that consume the Search service application
Site collection | Site collection administrator | All sites in the site collection
Site | Site owner | The site

To create a result source

  1. Depending on the level at which you want to create the result source, do one of the following:

    • To create a result source for a Search service application:

      1. Verify that the user account that performs this procedure is an administrator on the Search service application.

      2. In Central Administration, in the Application Management section, click Manage service application.

      3. Click the Search service application for which you want to create a result source.

      4. On the Search Administration page for the Search service application, on the Quick Launch, in the Queries and Results section, click Result Sources.

    • To create a result source for a site collection:

      1. Verify that the user account that performs this procedure is an administrator for the site collection.

      2. On the Settings menu for the site collection, click Site Settings.

      3. On the Site Settings page, in the Site Collection Administration section, click Search Result Sources.

    • To create a result source for a site:

      1. Verify that the user account that performs this procedure is a member of the Owners group for the site.

      2. On the Settings menu for the site, click Site Settings.

      3. On the Site Settings page, in the Search section, click Result Sources.

  2. On the Manage Result Sources page, click New Result Source.

  3. On the Add Result Source page, in the General Information section, do the following:

    1. In the Name box, type a name for the result source.

    2. In the Description box, type a description of the result source.

  4. In the Protocol section, select one of the following protocols for retrieving search results:

    • Local SharePoint, the default protocol, provides results from the search index for this Search service application.

    • Remote SharePoint provides results from the index of a search service in another farm.

      Important:

      To use the Remote SharePoint protocol to get search results in one SharePoint Server 2013 on-premises farm from the index of another SharePoint Server 2013 on-premises farm, you must configure the farm that receives the queries to trust the farm that sends the queries. For information about how to do this, see Configure trust for search between two SharePoint Server 2013 farms.

    • OpenSearch provides results from a search engine that uses the OpenSearch 1.0/1.1 protocol.

    • Exchange provides results from Exchange Server 2013 through a SharePoint 2013 eDiscovery Center. Click Use AutoDiscover to have the search system find an Exchange Server 2013 endpoint automatically, or type the URL of the Exchange web service to retrieve results from — for example, https://contoso.com/ews/exchange.asmx.

      Note:

      • The Exchange protocol only enables you to discover Exchange Server 2013 content, and only from a SharePoint 2013 eDiscovery Center. For more information, see Configure communication between SharePoint Server 2013 and Exchange Server 2013 in Configure eDiscovery in SharePoint Server 2013.

      • The Exchange Web Services Managed API must be installed on the computer on which the search service is running. For more information, see Optional software in Hardware and software requirements for SharePoint 2013.

  5. In the Type section, select SharePoint Search Results to search the whole index, or People Search Results to enable query processing that is specific to people search.

  6. In the Query Transform field, do one of the following:

    • Leave the default query transform (searchTerms) as is. In this case, the query will be unchanged since the previous transform.

    • Type a different query transform in the text box.

    • Use the Query Builder to configure a query transform by doing the following:

      1. Click Launch Query Builder.

      2. In the Build Your Query dialog box, optionally build the query by specifying filters, sorting, and testing on the tabs as shown in the following tables.

      • On the BASICS tab

        Keyword filter

        You can use keyword filters to add pre-defined query variables to the query transform. You can select pre-defined query variables from the drop-down list, and then add them to the query by clicking Add keyword filter.

        For an overview of query variables, see Query variables in SharePoint Server 2013.

        Property filter

        You can use property filters to query the content of managed properties that are set to queryable in the search schema.

        You can select managed properties from the Property filter drop-down list. Click Add property filter to add the filter to the query.

      • On the SORTING tab

        Sort results

        In the Sort by menu, you can select a managed property from the list of managed properties that are set as sortable in the search schema, and then select Descending or Ascending. To sort by relevance, that is, to use a ranking model, select Rank. You can click Add sort level to specify a property for a secondary level of sorting for search results.

        Ranking Model

        If you selected Rank from the Sort by list, you can select the ranking model to use for sorting.

        Dynamic ordering

        You can click Add dynamic ordering rule to specify additional ranking by adding rules that change the order of results within the result block when certain conditions are satisfied.

      • On the TEST tab

        Query text

        You can view the final query text, which is based on the original query template, the applicable query rules, and the variable values.

        Click Show more to display the options in the following rows of this table.

        Query template

        You can view the query as it is defined in the BASICS tab or in the text box in the Query transform section on the Add Result Source page.

        Query template variables

        You can test the query template by specifying values for the query variables.

  7. On the Add Result Source page, in the Credentials Information section, select the authentication type that you want for users to connect to the result source.

Set a result source as default

You can set any result source as the default result source. Specifying a result source as default can make it easier to edit the query in Search Web Parts. For example, when you add a Content Search Web Part to a page, the Web Part automatically uses the default result source. For more information, see Configure Search Web Parts in SharePoint Server 2013.

To set a result source as default

  1. Perform the appropriate procedures in the following list depending on the level at which the result source was configured.

    • If the result source was created at the Search service application level, do the following:

      1. Verify that the user account that performs this procedure is an administrator for the Search service application.

      2. In Central Administration, in the Application Management section, click Manage service applications.

      3. Click the Search service application for which you want to set the result source as default.

      4. On the Search Administration page, in the Queries and Results section, click Result Sources.

    • If the result source is at the site collection level, do the following:

      1. Verify that the user account that performs this procedure is an administrator for the site collection administrator.

      2. On the Settings menu for the site collection, click Site Settings.

      3. On the Site Settings page, in the Site Collection Administration section, click Search Result Sources.

    • If the result source is at the site level, do the following:

      1. Verify that the user account that performs this procedure is a member of the Owners group for the site.

      2. On the Settings menu for the site, click Site Settings.

      3. On the Site Settings page, in the Search section, click Result Sources.

  2. On the Manage Result Sources page, point to the result source that you want to set as default, click the arrow that appears, and then click Set as Default.

See also

Query variables in SharePoint Server 2013

Change History

Date | Description
April 30, 2013 | Added a cross-reference to instructions on how to use the Remote SharePoint protocol to get search results in one on-premises SharePoint Server 2013 farm from the index of another SharePoint Server 2013 farm.
February 12, 2013 | Added a statement that the Exchange protocol provides results only from Exchange Server 2013 content, and only from a SharePoint 2013 eDiscovery Center. Also added a link to a related SharePoint 2013 eDiscovery article on TechNet.
October 16, 2012 | Initial publication


Customize search result types in SharePoint 2013
See also

Published: May 7, 2013

Create and configure custom search result types in SharePoint 2013 so that users can readily distinguish and preview different kinds of items in a list of search results.

Applies to: SharePoint Server 2013 | SharePoint Online

A search result type is a rule that causes distinct kinds of search results to be displayed in different ways. It consists of the following:

  • One or more characteristics or conditions to compare each search result against, such as the result source or content type of the search result

  • A display template to use for search results that meet the conditions. The display template controls the way in which all results that meet the conditions appear and behave on a search results page.

The search system has preconfigured result types that it uses by default. You can view them on the Manage Result Types page. For example, a preconfigured result type named Person specifies that if a search result comes from the result source Local People Results, then use the People Item display template to display the result. The People Item display template shows certain user-profile information in the search result and provides links in the hover panel for documents that the person has authored.

As a site collection administrator or site owner, you can use the default result types as starting points for creating custom result types. For example, the pre-configured Microsoft Excel result type specifies the condition that the file extension of the search result is XLS or XLSX. You could copy this result type and customize it so that it also includes the condition that the value of the ContentType managed property is Sales Report. That way, users will readily be able to identify certain Excel search results as sales reports.

You could also customize the default Excel Item display template for this purpose. A display template specifies how to display managed properties of a search result, such as item title, file extension, path, and summary. This helps users to distinguish results easily. The display template also controls how a document or site will appear in the preview pane (also called the hover panel) to the right of the search result. This helps users to know whether a search result will be useful to them before they click the result to open it. For example, the Excel Item display template can display relevant charts, worksheets, and tables from an Excel document in the hover panel and enable users to go directly to those sections in the document. For more information about display templates for search result types, see:

  • How to: Create a display template in SharePoint Server 2013

  • Display template reference in SharePoint Server 2013

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Create and configure a custom search result type

  1. Go to the Manage Result Types page by doing one of the following:

    • If you want to create a result type for a site collection:

      1. Ensure that you are an administrator for the site collection.

      2. In the site collection, go to Settings > Site settings, and then in the Site Collection Administration section, click Search Result Types.

    • If you want to create a result type for a site:

      1. Ensure that you are a site owner for the site.

      2. On the site, go to Settings > Site settings, and then in the Search section, click Result Types.

  2. To create a result type, do one of the following on the Manage Result Types page:

    • Click New Result Type.

    • In the list of existing result types, click the name of a result type, such as Person, and then click Copy so that you can modify the copy to create a new result type.

      Tip:

      When you create a result type, we recommend that you use the copy method, so that the settings in an existing result type can help guide you through the configuration process.

  3. On the Add Result Type page, in the General Information section, in the Give it a name text box, type a name for the new result type.

  4. On the Add Result Type page, in the Conditions section, do the following:

    1. In the Which source should results match? drop-down list, select a result source such as All Sources or Documents.

      For any given search result, this condition will be met if the search result is from the result source that you selected from this drop-down list.

    2. (Optional) In the What types of content should match? drop-down list, do the following:

      1. Select a type of content, such as Microsoft Word.

        Note:

        If you do not select a type of content, all results from the result source that you specified (in the Which source should results match? section) will match this result type.

      2. As many times as appropriate, click Add Value and select another type of content.

  5. (Optional) On the Add Result Type page, expand the Show more conditions section, and then do the following:

    1. In the Which custom properties should match? section, the items in the Select a property drop-down list are retrievable managed properties. Select a property that you want the search system to perform a match on, such as Author.

    2. In the second drop-down list, specify the operator, such as Equals any of.

    3. In the text box, specify the value against which the search system should search for a match.

      Separate multiple values with semicolons. Alternatively, as many times as appropriate, click Add Value and type another value in the new text box that appears.

      For example, if you select the Author property and you select the operator Equals any of, then if you specify multiple values such as Kara and Silas, the condition will be "author equals Kara or Silas".

    4. To add another property to match, click Add Property.

  6. On the Add Result Type page, in the Actions section, do the following:

    1. In the What should these results look like? drop-down list, click a display template such as Office Document Item or PDF Item.

      Display templates for search results are in the Search folder in the master page gallery for the site collection. The Display template URL box automatically displays the URL of the display template that corresponds to the display template that you selected.

    2. Select the Optimize for frequent use check box if you expect this result type to appear frequently in search results.

See also

Display template reference in SharePoint Server 2013

How to: Create a display template in SharePoint Server 2013


Create and configure Machine Translation services in SharePoint Server 2013
See also

Summary: Learn how to create a new SharePoint Machine Translation service application and how to configure the Machine Translation Service.

Applies to: SharePoint Server 2013

The Machine Translation Service in SharePoint Server 2013 lets users automatically translate documents. You can create a Machine Translation service application and configure the Machine Translation Service by using Central Administration, or Windows PowerShell. Configuring the Machine Translation Service consists of the following steps:

  1. Create a Machine Translation service application.

  2. Configure the Machine Translation Service.

Before you begin

Before you perform these operations, review the following information about prerequisites:

  • The App Management service application must be started in Central Administration. For more information, see Configure an environment for apps for SharePoint (SharePoint 2013).

  • You must configure server-to-server authentication and app authentication. For more information, see Configure server-to-server authentication in SharePoint 2013 and Configure app authentication in SharePoint Server 2013.

  • There must be a User Profile service application proxy in the default proxy group for the farm, and the User Profile service application must be started and configured by using Central Administration or by using Windows PowerShell. For more information, see Create, edit, or delete User Profile service applications in SharePoint Server 2013.

  • The server from which machine translations will be run must be able to connect to the Internet.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Create a SharePoint Machine Translation service application

You can create a new Machine Translation Service application by using either Central Administration or Windows PowerShell.

To create a Machine Translation service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group and the Administrators group on the computer that is running Central Administration.

  2. On the Central Administration home page, in the Application Management section, click Manage service applications.

  3. On the ribbon, click New, and then click Machine Translation Service.

  4. In the Create New Machine Translation Service Application pane, in the Name section, type a name for the service application.

  5. In the Application Pool section, do one of the following:

    • Click Use existing application pool, and then select the application pool that you want to use from the drop-down list.

    • Click Create a new application pool, type the name of the new application pool, and then under Select a security account for this application pool do one of the following:

      • Click Predefined to use a predefined security account, and then select the security account from the drop-down list.

      • Click Configurable to specify a new security account to be used for an existing application pool. You can create a new account by clicking the Register new managed account link.

    Important:

    The account that is used by the application pool must also have Full Control permissions to the User Profile service application. If you create a new application pool and a new account, make sure that you add the account to the list of accounts that can use the User Profile Service Application, and grant Full Control permissions to the account. For more information, see Restrict or enable access to a service application (SharePoint 2013).

  6. In the Partitioned Mode section, select Run in partitioned mode only if you will be providing hosting services for other sites, and the sites using it have site subscriptions.

  7. In the Add to Default Proxy List section, select Add this service application's proxy to the farm's default proxy list. If you have multiple Web applications, and want them to use different sets of services, clear this check box.

  8. In the Database section, specify the database server, database name, and authentication method for the new service application as described in the following table. The database is used to hold the work items for the Machine Translation service.

    Database section properties

    Item Action

    Database Server

    Type the name of the database server and SQL Server 2012 instance that you want to use in the format ServerName\Instance. You can also use the default entry.

    Database Name

    Type the name of the database.

    Important:

    The database name must be a unique name.

    Database Authentication

    Select the authentication that you want to use by doing one of the following:

    • If you want to use Windows authentication, leave this option selected. We recommend this option because Windows authentication automatically encrypts the password when it connects to SQL Server.

    • If you want to use SQL authentication, click SQL authentication. In the Account box, type the name of the account that you want the service application to use to authenticate to the SQL Server database, and then type the password in the Password box.

    Note:

    In SQL authentication, an unencrypted password is sent to SQL Server. We recommend that you use SQL authentication only if you force protocol encryption to SQL Server or encrypt network traffic by using IPsec.

  9. Click OK.

  10. Start the Machine Translation Service. For more information, see "Starting or stopping a service" in Start or stop a service (SharePoint 2013).

To create a Machine Translation service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SPTranslationServiceApplication -Name "<ServiceApplicationName>" -DatabaseName "<DatabaseName>" -DatabaseServer "<DatabaseServer>" -ApplicationPool "<ApplicationPoolName>" -Default

    Where:

    • <ServiceApplicationName> is name of the new Machine Translation Service application.

    • <DatabaseName> is the name of the database that will host the Machine Translation Service logs. To create a new database, provide a new name.

      Important:

      The database name must be a unique name.

    • <DatabaseServer> is the name of the database server that will hold the work items for the Machine Translation Service.

    • <ApplicationPoolName> is the name of an existing application pool in which the new Machine Translation Service should run.

      Important:

      The account that is used by the application pool must also have Full Control permissions to the User Profile service application. If you create a new application pool and a new account, make sure that you add the account to the list of accounts that can use the User Profile service application, and grant it Full Control permissions. For more information, see Restrict or enable access to a service application (SharePoint 2013).

    Example

    Copy code
    New-SPTranslationServiceApplication -Name "Machine Translation Service Application" -DatabaseName "MachineTranslationDB" -DatabaseServer "ContosoDBServer" -ApplicationPool "ContosoAppPool" -Default

  6. Start the Machine Translation Service. For more information, see "Starting or stopping a service" in Start or stop a service (SharePoint 2013).

For more information, see New-SPTranslationServiceApplication.

Configure the Machine Translation Service

You can configure the Machine Translation Service by using either Central Administration or Windows PowerShell.

Caution:

Changing the default settings for the Machine Translation Service can potentially affect server performance. For example, increasing item size limits can result in the translation job taking longer to run, and increasing the number of processes will consume more resources on the server. Be sure to carefully consider any possible server effects before you change these settings.

To configure the Machine Translation Service by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group in SharePoint Server 2013.

  2. On the Central Administration home page, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the link that corresponds to the name of the Machine Translation service application.

  4. On the Machine Translation Service page, in the Enabled File Extensions section, clear the check box for any file name extensions that you want to disable. By default, all file name extensions are enabled.

  5. In the Item Size Limits section, do the following:

    • In the Maximum file size for binary files in KB. Microsoft Word documents are binary files box, type the maximum file size (100-524288), in KB, for binary files. The default is 51200. Files that exceed this limit will not be translated.

    • In the Maximum file size for text files in KB. Plain-text, HTML, and XLIFF documents are text files box, type the maximum file size (100-15360), in KB, for text files. The default is 5120. Files that exceed this limit will not be translated.

    • In the Maximum character count for Microsoft Word documents box, type the maximum character count (10000-10000000) for Word documents. The default is 500000.

  6. In the Online Translation Connection section, do one of the following:

    • Click Use default internet settings. This is the default.

    • Click Use the proxy specified, and type a web proxy server and port number.

    Note:

    If you change this setting, you must stop and restart the Machine Translation Service after you configure it.

  7. In the Translation Processes section, type the number of translation processes (1-5). The default is 1.

    Note:

    If you change this setting, you must stop and restart the Machine Translation Service after you configure it.

  8. In the Translation Throughput section, do the following:

    • In the Frequency with which to start translations (minutes) box, type the frequency with which groups of translations are started, in minutes (1-59). The default is 15.

    • In the Number of translations to start (per translation process) box, type the number of translations (1-1000) per process. This number represents the number of translations started per process every time translations are started. The default is 200.

  9. In the Maximum Translation Attempts section, type the maximum number of times (1-10) a translation is tried before its status is set to Failed. The default is 2.

  10. In the Maximum Synchronous Translation Requests section, type the maximum number of synchronous translation requests (0-300). The default is 10.

    Note:

    You can also set this value to 0 so that no synchronous jobs are accepted.

  11. In the Translation Quota section, do the following:

    • In the Maximum number of items which can be queued in a 24-hour period section, do one of the following:

      • Click No limit. This is the default.

      • Click Limit per 24 hours, and then type the maximum number of items (100-1000000) that can be queued in a 24-hour period.

    • In the Maximum number of items which can be queued in a 24-hour period per site subscription section, do one of the following:

      • Click No limit. This is the default.

      • Click Limit per 24 hours, and then type the maximum number of items (100-1000000) that can be queued in a 24-hour period per site subscription.

      Note:

      This setting applies only if you will be providing hosting services for other sites, and the sites using it have site subscriptions.

  12. In the Completed Job Expiration Time section, do one of the following:

    • Click Days, and then type the number of days (1-1000) completed jobs are kept in the job history log. The default is 7.

    • Click No expiration.

  13. In the Recycled Threshold section, type the number of documents (1-1000) to be converted before the conversion process is restarted. The default is 100.

    Note:

    If you change this setting, you must stop and restart the Machine Translation Service after you configure it.

  14. In the Office 97-2003 Document Scanning section, specify whether to disable security scanning for Office 97-2003 documents. Only enable this setting if you trust the documents that will be converted. The default is No.

  15. Click OK.

  16. If you changed any settings that require you to restart the Machine Translation Service, restart the service now. For more information, see "Starting or stopping a service" in Start or stop a service (SharePoint 2013).

To configure the Machine Translation Service by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPTranslationServiceApplication -Identity "<ServiceApplicationName>" -EnableAllFileExtensions -UseDefaultlnternetSettings -TimerJobFrequency <TimerJobFrequency> -MaximumTranslationAttempts <MaximumTranslationAttempts> -JobExpirationDays <JobExpirationDays> -MaximumSyncTranslationRequests <MaximumSyncTranslationRequests> -RecycleProcessThreshold <RecycleProcessThreshold> -DisableBinaryFileScan <DisableBinaryFileScan>

    Where:

    • <ServiceApplicationName> is name of the Machine Translation service application.

    • <TimerJobFrequency> is the frequency, in minutes (1-59), with which groups of translations are started.

    • <MaximumTranslationAttempts> is the maximum number of times (1-10) a translation is tried before its status is set to Failed.

    • <JobExpirationDays> is the number of days (1-1000) completed jobs are kept in the job history log.

    • <MaximumSyncTranslationRequests> is the maximum number of synchronous translation requests (0-300).

    • <RecycleProcessThreshold> is the number of documents (1-1000) to be converted before the conversion process is restarted.

    • <DisableBinaryFileScan> is either 0 (false) or 1 (true).

    Example

    Copy code
    Set-SPTranslationServiceApplication -Identity "Machine Translation Service Application" -EnableAllFileExtensions -UseDefaultlnternetSettings -TimerJobFrequency 30 -MaximumTranslationAttempts 3 -JobExpirationDays 14 -MaximumSyncTranslationRequests 20 -RecycleProcessThreshold 300 -DisableBinaryFileScan 1
    Note:

    Changes to any of the following parameters will require that you restart the Machine Translation Service: KeepAliveTimeout, MaximumTranslationTime, TotalActiveProcesses, RecycleProcessThreshold, WebProxyAddress, MachineTranslationAddress, UseDefaultInternetSettings.

  6. If you changed any settings that require you to restart the Machine Translation Service, restart the service now. For more information, see "Starting or stopping a service" in Start or stop a service (SharePoint 2013).

For more information, see Set-SPTranslationServiceApplication.

The Microsoft Translator Hub is an extension of Microsoft Translator, and allows you to build automatic language translation systems that integrate with your website. After you build a custom system, the Test System page on the Projects tab in the Microsoft Translator Hub displays a category ID. You can configure the Machine Translation Service to use the custom translation system by passing the category ID in the MachineTranslationCategory parameter. For more information about the Microsoft Translator Hub, see http://hub.microsofttranslator.com.

Additional steps

If the account that is used by the application pool that was assigned to the Machine Translation service application differs from the one used by the User Profile service application, you must add it to the list of accounts that can use the User Profile service application, and grant it Full Control permissions. For more information, see Restrict or enable access to a service application (SharePoint 2013).

See also

Configure an environment for apps for SharePoint (SharePoint 2013)
Configure server-to-server authentication in SharePoint 2013
Configure app authentication in SharePoint Server 2013


Configure Request Manager in SharePoint Server 2013

Published: October 2, 2012

Summary: Learn how Request Manager in SharePoint Server 2013 can route and throttle incoming requests to help improve performance and availability.

Applies to: SharePoint Server 2013

Request Manager is functionality in SharePoint Server 2013 that enables administrators to manage incoming requests and determine how SharePoint Server 2013 routes these requests.

In this article:

  • Overview

  • Scenarios

  • Setup and Deployment

  • Configuration

  • Request Routing

  • Monitoring and maintenance

Overview

Request Manager uses configured rules to perform the following tasks when it encounters requests:

  • Deny potentially harmful requests from entering a SharePoint farm.

  • Route good requests to an available server.

  • Manually optimize performance.

Information that administrators or an automated process provide to Request Manager determine the effectiveness of routed requests.

To learn about how to use performance data to plan and manage the capacity of a SharePoint Server 2013 environment, see Capacity management and sizing overview for SharePoint Server 2013

Scenarios

The following table describes possible scenarios and resolutions that Request Manager can address.

Area | Scenario | Resolution
Reliability and performance | Routing new requests to web front end with low performance can increase latency and cause timeouts. | Request Manager can route to front-end web servers that have better performance, keeping low performance front-end web servers available.
 | Requests from users and bots have equal priority. | Prioritize requests by throttling requests from bots to instead serve requests from end-users).
Manageability, accountability, and capacity planning | SharePoint Server fails or generally responds slowly, but it's difficult to identify the cause of a failure or slowdown. | Request Manager can send all requests of a specific type, for example, Search, User Profiles, or Office Web Apps, to specific computers. When a computer is failing or slow, Request Manager can locate the problem.
 | All front-end web servers must be able to handle the requests because they could be sent to any front-end web server. | Request Manager can send multiple or single requests to front-end web servers that are designated to handle them.
Scaling limits | Hardware scaling limited by load balancer | Request Manager can perform application routing and scale out as needed so that a load balancer can quickly balance loads at the network level.

Setup and Deployment

Request Manager's task is to decide two things: a SharePoint farm will accept a request, and if the answer is "yes", to which front-end web server SharePoint Server will send it. The three major functional components of Request Manager are Request Routing, Request Throttling and Prioritizing, and Request Load Balancing. These components determine how to handle requests. Request Manager manages all requests on a per-web-application basis. Because Request Manager is part of the SharePoint Server 2013 Internet Information Services (IIS) module, it only affects requests that IIS hosts.

When a new request is received, Request Manager is the first code that runs in a SharePoint farm. Although Request Manager is installed during setup of SharePoint Server on a front-end web server, the Request Management service is not enabled. You can use the Start-SPServiceInstance and Stop-SPServiceInstance cmdlets to start and stop the Request Management service instance respectively or the Manage services on server page on the the SharePoint Central Administration website. You can use the RoutingEnabled or ThrottlingEnabled parameters of the Set-SPRequestManagementSettings Windows PowerShell cmdlet to change properties of Request Manager.

Note:

There is no user interface to configure properties of Request Manager. The Windows PowerShell cmdlet is the only way to perform this task.

Request Manager has two supported deployment modes: Dedicated and Integrated.

Dedicated mode

Figure 1 shows a dedicated mode deployment.

Figure 1: Dedicated mode

Dedicated Mode Deployment

A set of front-end web servers is dedicated to managing requests exclusively. The front-end web servers that are dedicated to Request Manager are in their own farm that is located between the hardware load balancers (HLBs) and the SharePoint farm. The HLBs send all requests to the Request Manager front-end web servers. Request Manager that runs on these front-end web servers decides to which SharePoint front-end web servers it will send the requests and then routes the requests. Depending on the routing and throttling rules, Request Manager might ignore some requests without sending them to another server. The SharePoint front-end web servers do their normal tasks in processing requests and then send responses back through the front-end web servers that run Request Manager and to the clients.

Note that all farms are set up as SharePoint farms. All front-end web servers in Figure 1 are SharePoint front-end web servers, each of which can do the same work as any other. The difference between the farms is that the Request Manager front-end web servers have Request Manager enabled.

Dedicated mode is good for larger-scale deployments when physical computers are readily available. The ability to create a separate farm for Request manager provides two benefits: Request Manager and SharePoint processes do not compete for resources and you can scale out one without having to also scale out the other. This allows you to have more control over the performance of each role.

  • Request Manager and SharePoint processes do not compete for resources.

  • You can scale out each farm separately, which provides more control over the performance of each farm.

Integrated mode

Figure 2 shows an integrated mode deployment.

Figure 2: Integrated mode

Integrated Mode Deployment

In an integrated mode deployment, all SharePoint front-end web servers run Request Manager. Hardware load balancers send requests to all front-end web servers. When a front-end web server receives a request, Request Manager decides how to handle it: .

  • Allow it to be processed locally.

  • Route it to a different front-end web server.

  • Deny the request.

Integrated mode is good for small-scale deployments when many physical computers are not readily available. This mode lets Request Manager and the rest of SharePoint Server to run on all computers. This mode is common for on-premises deployments.

Configuration

Request Manager has two configurable parts: General settings and Decision information. General settings are parameters that make Request Manager ready to use, such as enabling or disabling Request Routing and Request Throttling and Prioritizing. Decision information is all of the information that is used during the routing and throttling processes, such as routing and throttling rules.

Note:

You configure Request Manager on a farm and functionality occurs at a web application level.

General settings

By default, request routing and request throttling and prioritizing are enabled. You use the Set-SPRequestManagementSettings cmdlet to change the properties of request routing, request throttling and prioritizing, and select a routing weight scheme.

The table describes the configuration situation and Windows PowerShell syntax to use.

Windows PowerShell examples to enable routing and throttling

Situation Windows PowerShell syntax

Enable routing and throttling for all web applications

Copy code
Get-SPWebApplication | Set-SPRequestManagementSettings -RoutingEnabled $true -ThrottlingEnabled $true

Enable routing with static weighting for all web applications

Copy code
Get-SPWebApplication | Get-SPRequestManagementSettings | Set-SPRequestManagementSettings -RoutingEnabled $true -ThrottlingEnabled $false -RoutingWeightScheme Static

In some situations, multiple front-end web servers will be suitable destinations for a particular request. In this case, by default, SharePoint Server selects one server randomly and uniformly.

One routing weight scheme is static-weighted routing. In this scheme, static weights are associated with front-end web servers so that Request Manager always favors a higher static weight during the selection process. This scheme is useful to give added weight to more powerful front-end web servers and produce less strain on less powerful ones. Each front-end web server will have a static weight associated with it. The values of the weights are any integer value, where 1 is the default. A value less than 1 represents lower weight, and greater than 1 represents higher weight.

Another weighting scheme is health-weighted. In health-weighted routing, front-end web servers that have health scores closer to zero will be favored, and fewer requests will be sent to front-end web servers that have a higher health score values. The health weights run from 0 to 10, where 0 is the healthiest and therefore will get the most requests. By default, all front-end web servers are set to healthy, and therefore, will have equal weights. SharePoint's health score based monitoring system assigns weight to server and send a health score value as a header in the response to a request. Request Manager uses same health score and stores it in local memory.

Decision information

Decision information applies to routing targets, routing rules, and throttling rules.

Routing targets

Request routing determines the routing targets that are available when a routing pool is selected for a request. The scope of routing targets is currently for front-end web servers only, but Request Manager's design does not exclude routing to application servers, too. A list of front-end web servers in a farm is automatically maintained by using the configuration database. An administrator who wants to change that list, typically in dedicated mode, has to use the appropriate routing cmdlets to get, add, set, and remove routing targets.

The following table describes the various routing target tasks and the associated Windows PowerShell syntax to use.

Windows PowerShell examples routing target tasks

Task Windows PowerShell syntax

Return a list of routing targets for all available web applications.

Copy code
Get-SPWebApplication | Get-SPRequestManagementSettings | Get-SPRoutingMachineInfo -Availability Available

Add a new routing target for a specified web application.

Note:

IIS log files will contain all HTTP requests. For additional information about IIS logging, see IIS Logging

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Add-SPRoutingMachineInfo -RequestManagementSettings $rm -Name <MachineName> -Availability Available

Where

  • <URL of web application> is the URL of the web application to which you're adding a new routing target.

  • <MachineName>is the name of the server that hosts the web application.

Edit an existing routing target's availability and static weight for a specified web application

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
$m=Get-SPRoutingMachineInfo -RequestManagementSettings $rm -Name <MachineName>
Copy code
Set-SPRoutingMachineInfo -Identity $m -Availability Unavailable

Where

  • <URL of web application> is the URL of the web application for which you're editing an existing routing target's availability and static weight.

Remove a routing target from a specified web application

Note:

You cannot remove front-end web servers that are in the farm. Instead, you can use the Availability parameter of the Set-SPRoutingMachineInfo cmdlet to make them unavailable.

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
$m=Get-SPRoutingMachineInfo -RequestManagementSettings $rm -Name <MachineName>
Copy code
Remove-SPRoutingMachineInfo -Identity $M

Where

  • <URL of web application> is the URL of the web application from which you're removing a routing target.

Routing and throttling rules

Request routing and request throttling and prioritizing are decision algorithms that use rules to prescribe many actions. The rules determine how Request Manager handles requests.

Rules are separated into two categories, routing rules and throttling rules, which are used in request routing and request throttling and prioritizing, respectively. Routing rules match criteria and route to a machine pool. Throttling rules match criteria and throttle based on known health score of a computer.

Request Routing

Request processing is all operations that occur sequentially from the time that Request Manager receives a new request to the time that Request Manager sends a response to the client.

Request processing is divided into the components:

  • request routing

  • incoming request handler

  • request throttling and prioritizing

  • request load balancing

Incoming request handler

The role of the incoming request handler is to determine whether Request Manager should process a request. If request throttling and prioritizing is disabled and the Request Manager queue is empty, Request Manager directs the request to SharePoint Server that is running on the current front-end web server. If request throttling and prioritizing is enabled, request throttling and prioritizing determines whether the request should be allowed or denied on the current front-end web server.

The processes steps of the incoming request handler are as follows:

  1. Request is determined if it should be throttled or routed

  2. For routed requests, load balance algorithm is run

  3. Request routed to load balancer endpoint

Request routing and Request throttling and prioritizing only run if it is enabled and is routed once per farm. Request load balancer only runs if a request has been determined as routable. The outgoing request handler only runs if the request has to be sent to a different front-end web server. The role of the outgoing request handler is to send the request to the selected front-end web server, wait for a response, and send the response back to the source.

Request routing

The role of request routing is to select a front-end web server to route a request. By using no routing rules that are defined, the routing scheme is as easy as randomly selecting an available front-end web server.

The algorithm of request routing is defined by two parts: request-rule matching and front-end web server selection.

Request rule matching

Every rule has one or more match criteria, which consist of three things: match property, match type, and match value.

The following table describes the different types of match properties and match types:

Match property | Match type
Hostname | RegEx
URL | Equals
Port number | Starts with
MIME Type | Ends with

For example, an administrator would use the following match criteria to match http://contoso requests: Match Property=URL; Match value= http://contoso; Match type=RegEx

Front-end web server selection

The front-end web server selection uses all routing rules, whether they match or do not match a given request. Rules that match have machine pools, a request sends load balanced to any machine in any matching rule's machine pool. If a request does not match any request, it sends load balanced to any available routing target.

Request routing and prioritizing

For routing requests that use the health-based monitoring system, the role of request routing and prioritizing is to reduce the routing pool to computers that have a good health score to process requests. If request routing is enabled, the routing pool is whichever front-end web server is selected. If request routing is disabled, the routing pool only contains the current front-end web server.

Request routing and prioritizing can be divided into two parts: request-rule matching and front-end web server filtering. Request-rule matching happens exactly like in request routing. Front-end web server filtering uses the health threshold parameter from the throttling rules in combination with front-end web server health data to determine whether the front-end web servers in the selected routing pool can process the given request.

The front-end web server filtering process follows these steps:

  1. The routing pool is either the current front-end web server or one or more front-end web servers that request routing selects.

  2. All matching rules are checked to find the smallest health threshold value.

  3. Remove front-end web servers in the routing pool that have health scores greater than or equal to the smallest health threshold value.

For example, request routing is disabled and the current front-end web server has a health score of 7 and a rule "Block OneNote" without a health threshold (that is, health threshold = 0) is created.

The routing pool is the current front-end web server that has a health threshold equal to zero (0). So, the smallest threshold that the front-end web server can serve is zero. Because the current front-end web server has health score of 7, Request Manager denies and removes the request.

Request load balancing

The role of request load balancing is to select a single target to which to send the request. Request load balancing uses the routing weight schemes to select the target. All routing targets begin with a weight of 1. If static weighting is enabled, request load balancing uses the static weights set of each routing target to adjust the weights and the value can be valid integer number. If health weighting is enabled, request load balancing uses health information to add weight to healthier targets and remove weight from less healthy targets.

Monitoring and maintenance

Monitoring and logging are keys to managing requests from Request Manager.

  • The rules that matched.

  • The rules that did not match.

  • The final decision of the request.

    Decisions might include useful information such as the following.

    • Was the request denied?

    • Which front-end web server was selected and from which routing pool>

    • Did the request succeed or fail and why?

    • How long did each part, routing, throttling, and waiting for front-end web server to respond, take?

An administrator can use this information to adjust the routing and throttling rule sets to optimize the system and correct problems. To help you monitor and evaluate your farm's performance, you can create a performance monitor log file and add the following SharePoint Foundation Request Manager Performance counters:

Counter name | Description
Connections Current | The total number of connections that are currently open by Request Manager.
Connections Reused / Sec | The number of connections per second that are reused when the same client connection makes another request without closing the connection.
Routed Requests / Sec | The number of routed requests per second. The instance determines the application pool and server for which this counter tracks.
Throttled Requests / Sec | The number of throttled requests per second.
Failed Requests / Sec | The number of failed requests per second.
Average Processing Time | The time to process the request that is, the time to evaluate all the rules and determine a routing target.
Last Ping Latency | The last ping latency (that is, Request Manager's PING feature) and the instance determine which application pool and machine target.
Connection Endpoints Current | The total number of endpoints that are connected for all active connections.
Routed Requests Current | The number of unfinished routed requests. The instance determines which application pool and machine target.

Along with creating a performance monitor log file, the verbose logging level can be enabled by using the following Windows PowerShell syntax:

Copy code
Set-SPLogLevel "Request Management" -TraceSeverity Verbose


Configure Business Connectivity Services solutions for SharePoint 2013
See also

Updated: April 9, 2013

Summary: Find links to procedures to help you install and configure SharePoint 2013 Business Connectivity Services (BCS) for the on-premises, cloud-only, and hybrid solutions, and other scenarios.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article is your starting place for the procedures to install common Microsoft Business Connectivity Services scenarios for SharePoint 2013. The Business Connectivity Services solution that you deploy will most likely look different from the solutions presented here, but you can model your installation on these examples. Also, you can select the individual procedures from here to build your own procedural documents for your Business Connectivity Services solution scenario.

About Business Connectivity Services installation scenarios

Every Business Connectivity Services solution is unique because each business has unique data integration problems that it solves with Business Connectivity Services. The solutions can range from something simple and straightforward that a power user or IT professional (who has the appropriate permissions) can perform by themselves, to complex solutions that require developer, IT professional, and end-user solution development involvement. This guide presents the configuration procedures in common scenarios.

  • On-premises deployment All the Business Connectivity Services components are under your organizations control behind your firewall.

  • Cloud-only deployment All the Business Connectivity Services components are in SharePoint Online.

  • Hybrid deployment SharePoint Online uses Business Connectivity Services to connect to data that lives in the cloud.

Prerequisites

Before you begin with any Business Connectivity Services scenario configuration, make sure that you have read Overview of Business Connectivity Services in SharePoint 2013 and completed the steps in Plan a Business Connectivity Services solution in SharePoint 2013.

On-premises deployment

The procedures in Deploy a Business Connectivity Services on-premises solution in SharePoint 2013 show you how to deploy a solution that involves the following:

  • A Business Connectivity Services infrastructure that is on your corporate network.

  • Information workers who access the Business Connectivity Services solution are on your corporate network.

  • External content that is surfaced in SharePoint as an external list.

  • External content that is synchronized into Outlook for offline use.

  • Accessing external data that is in SQL Server database on your corporate network.

  • SharePoint Designer 2013 to create the external content type for the SQL Server data source.

  • The Secure Store Service to manage mapping of user credentials to group credentials for accessing the external systems.

Cloud-only deployment

The procedures in Deploy a Business Connectivity Services cloud-only solution in SharePoint 2013 show you how to deploy a solution that involves a Business Connectivity Services infrastructure that is in SharePoint Online.

Hybrid deployment

The procedures in Deploy a Business Connectivity Services hybrid solution in SharePoint 2013 shows you how to publish on-premises data to an external list or app for SharePoint in SharePoint Online.

See also

Plan for Business Connectivity Services in SharePoint 2013

Change History

Date | Description
April 09, 2013 | Added new section: "Deploy a Business Connectivity Services hybrid solution in SharePoint 2013."
July 16, 2012 | Initial publication


Deploy a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Summary: How to install Business Connectivity Services (BCS) to access an on-premises SQL Server external data source, surface external data in SharePoint lists, and take external data offline in Outlook.

Applies to: SharePoint Server 2013

The following scenario shows you how to create a no-code business solution in Microsoft Business Connectivity Services (BCS) by using the SQL Server AdventureWorks sample database. You learn how to:

  • Configure the accounts, and groups that you need to securely access the external data source.

  • Configure the permission on the external data source, the external content type and the external lists.

  • Create and configure an external content type.

  • Create an external list that makes the external data available to users.

  • Connect the external list to Outlook to make the external data available when the user is offline.

This article includes the overview, roadmap, and any conceptual information that is needed.

In this article:

  • Before you begin

  • What these procedures help you deploy

  • How to use these procedures and a roadmap of the procedures

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

What these procedures help you deploy

Business Connectivity Services is a centralized infrastructure in SharePoint 2013 and Office 2013 that enables you to integrate data that is not in SharePoint products and Office 2013 into SharePoint products and Office 2013. BCS implementations take many different forms, including the on-premises form. These procedures show you how to install and configure BCS to integrate data from an on-premises SQL data source into a SharePoint products external list and into Outlook. For the purposes of building out this scenario, we use the AdventureWorks sample SQL database. The solution looks as shown in the following diagram.

Figure: On-premises BCS solution

A structured on premises BCS solution. Showing the

  1. A user goes to an external list on a SharePoint site. The external list creates a request for data by using the user's Windows credentials.

  2. The request is sent to the BDC runtime in the SharePoint farm.

  3. The BDC runtime accesses the external content type for the list (in the BDC Metadata Store) to see how to access the external system and which operations can be performed. By using either the user's credentials or the credentials from the Secure Store (as defined in the external content type), the BDC runtime passes the request to a connector that can handle the request, in this case the SQL connector.

  4. The SQL connector accesses the external data source and retrieves the data, and applies any formatting and filtering as specified in the external content type. The data is passed back through the request chain to the list where the user can interact with it.

  5. The user wants to take this data on a portable computer in Outlook so the user can use the Connect to Outlook feature on the external list to take the data offline.

  6. The Click Once installation runs and installs the required BDC model on the client. This lets the BDC Client-Side Runtime access the external data directly.

  7. Outlook then connects to the external data by using the configuration in the BDC model and synchronizes it into an Outlook SharePoint external list, formatted as a contacts list.

  8. The user can then interact with the contact data, and any changes that the user makes can be written back to the external data source either by an on-demand synch or by waiting six hours for the automated synchronization.

How to use these procedures and a roadmap of the procedures

The steps to completely deploy this scenario are presented in smaller procedures. Some of the procedures are on TechNet, some are on Office.com, and some are on MSDN. Each procedure is numbered indicating its position in the overall sequence. At the beginning and end of each procedure, links direct you to the preceding and following steps. The following list contains links to all of the procedures, in proper order, for your reference. You must follow them in sequence to build out the scenario. You can also use these procedures individually to build out your own unique scenarios. When you are assembling individual procedures to build out your own scenarios, be sure to test the entire set of procedures, in order, in a lab setting before you attempt them in production.

  1. Prerequisites for deploying a Business Connectivity Services on-premises solution in SharePoint 2013

  2. Create database logins for a Business Connectivity Services on-premises solution in SharePoint 2013

  3. Start the Business Data Connectivity service for a Business Connectivity Services on-premises solution in SharePoint 2013

  4. Create the Business Data Connectivity service application in SharePoint 2013

  5. Set permissions on the BCS Metadata Store for a Business Connectivity Services on-premises solution in SharePoint 2013

  6. Configure the Secure Store Service for a Business Connectivity Services on-premises solution in SharePoint 2013

  7. Create an external content type for a Business Connectivity Services on-premises solution in SharePoint 2013

  8. Configure permission on an external content type for a Business Connectivity Services on-premises solution in SharePoint 2013

  9. Create an external list for a Business Connectivity Services on-premises solution in SharePoint 2013

  10. Manage user permissions on an external list for a Business Connectivity Services on-premises solution in SharePoint 2013

  11. Connect an external list to Outlook for a Business Connectivity Services on-premises solution in SharePoint 2013

  12. Verify offline access and synchronization of external data in Outlook for a Business Connectivity Services on-premises solution in SharePoint 2013

See also

Configure Business Connectivity Services solutions for SharePoint 2013


Prerequisites for deploying a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: How to prepare your environment to install Business Connectivity Services (BCS) in an on-premises configuration in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Before you start your installation of the on-premises Microsoft Business Connectivity Services (BCS) scenario, you must have these software and infrastructure requirements in place.

Important:

This is Step 1 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013.

On-premises scenario prerequisites

  • A fully functional SharePoint 2013 server farm with a Web Application and site collection

  • A fully functioning instance of SQL Server 2008 with Service Pack 1 (SP1) and Cumulative Update 2 or SQL Server 2008 R2

  • SharePoint Designer 2013

  • Outlook 2013 client

  • You have an account that has permissions to administer the Business Data Connectivity Service Application

  • You have an account that has permissions to administer the Secure Store Service service application

  • Download the AdventureWorks sample database from Codeplex downloads for SQL Server. This database must be installed and functioning on your SQL Server

  • Create an Active Directory directory Service (AD DS) security group and add the users who will be using this BCS solution, for example create a group that is named AdventureWorksBCSUsers

The AdventureWorks sample database is developed and published by Microsoft. The AdventureWorks sample database is prepopulated with a large quantity of fictitious data from a fictitious company, AdventureWorks Cycles. We are using the AdventureWorks sample database here so we have a concrete example for illustrating the installation and configuration of the on-premises BCS scenario.

Tip:

If you have problems attaching the database file by using the Attach command, in the Attach databases dialog box, and remove the reference to the log file in the bottom pane before you click OK.

Preparing the environment

How to download and install the AdventureWorks sample database

  1. From a browser, go to AdventureWorks sample database and download the AdventureWorks2008R2_Data.mdf file.

  2. Install the Adventure Works2008R2 sample database by following the procedures in the "Readme for AdventureWorks 2008 R2 Sample Database" section of the SQL Server Samples Readme (en-US) page.

Important:

Link to Step 2 Create database logins for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013


Create database logins for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: How to prepare the SQL Server logins for Business Connectivity Services (BCS) on-premises scenario deployment in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Microsoft Business Connectivity Services (BCS) requires an account that it can use to access the external data source. The account must have the necessary permissions on the external data source to perform all the operations that your BCS solution might require. For ease of configuration and ongoing management, you can map a group of SharePoint products users to a single shared account on the external data source.

In this procedure, you create a SQL Server login and then assign that login to a user account on the AdventureWorks sample database. You will use Secure Store Service services to map a group of SharePoint 2013 users to the single shared account in a later procedure.

Important:

This is Step 2 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • Link to Step 1 Prerequisites for deploying a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Create a SQL Server login

  1. Start SQL Server Management Studio.

  2. In the Object Explorer, expand the <database server name>, expand Security, and then expand Logins.

  3. Right-click Logins, and then click New Login

  4. In the Login Name box, enter SharePointGroupAccount.

  5. Select SQL Server authentication, and then enter and confirm a password.

  6. In the Default database box, select AdventureWorks2008R2, and then click OK.

Create a SQL Server user on the AdventureWorks database

  1. In the Object Explorer, expand Databases, expand AdventureWorks2008R2, expand Security, and then expand Users.

  2. Right-click Users, and then click New User.

  3. Under the Login Name, with the User name box pre-selected, in the first box, enter AdventureWorksUser

  4. In the second box, click Browse, in the Select Login dialog box, click Browse, select the SQL Server account, SharePointGroupAccount, and then click OK twice.

  5. Under Database Role membership, select db_owner.

  6. Click OK.

  7. Close SQL Server Management Studio.

Important:

Link to Step 3 Start the Business Data Connectivity service for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013


Start the Business Data Connectivity service for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: How to start the Business Data Connectivity service for a SharePoint 2013 server farm.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The Business Data Connectivity Service must be running for you to create any BCS based business solution. Use this procedure to start or stop the Business Data Connectivity Service

Important:

This is Step 3 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • Link to Step 2 Create database logins for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Start the Business Data Connectivity service

  1. Open the SharePoint Central Administration website for the server farm that contains your BCS solution.

  2. On the Quick Launch, click System Settings.

  3. On the System Settings page, under Servers, click Manage services on server.

  4. Check the value in the Server field. If the server name shown there is not the server that you want running the Business Data Connectivity Service on, click on the down arrow, click Change Server and select the correct server.

  5. If necessary, next to Business Data Connectivity Service, under the Action column, click Start.

Note:

If you need to stop the Business Data Connectivity Service after starting it, next to Business Data Connectivity Service in the Action column click Stop.

Important:

Link to Step 4 Create the Business Data Connectivity service application in SharePoint 2013 of the Business Connectivity Services On-Premises deployment procedures

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013


Create the Business Data Connectivity service application in SharePoint 2013
See also

Published: October 16, 2012

Summary: How to create the Business Data Connectivity service application for SharePoint 2013 for a Business Connectivity Services on-premises configuration.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Microsoft Business Connectivity Services is a SharePoint 2013 service application. You must create it if it was not created during your farms initial configuration.

Important:

This is Step 4 in the Business Connectivity Services on-premises scenario deployment procedures.

  • Link to Step 3 Start the Business Data Connectivity service for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Create a new Business Data Connectivity Services service application

  1. Open the SharePoint Central Administration website for your farm with a Farm administrator account. This must be the farm in which you started the Business Data Connectivity Service in the Start the Business Data Connectivity service for a Business Connectivity Services on-premises solution in SharePoint 2013 procedure.

  2. On the Quick start, click, Application Management.

  3. On the Application Management page under Service Applications, click Manage service applications.

  4. If an instance of the Business Data Connectivity Service Application that you will use for this solution is already there, you can skip the rest of this procedure. If not, follow the rest of this procedure to create one.

  5. On the SERVICE APPLICATIONS tab, click New and click Business Data Connectivity Service.

  6. Configure the setting in the Create New Business Data Connectivity Service Application configuration page as follows:

    1. In the Service Application Name box enter the name you want the service to appear as on the Manage Service Applications page. This BCS service application can be used by multiple BCS solutions.

    2. In the Database area, leave the prepopulated values for Database Server, Database Name, and Database authentication, which is Windows authentication (recommended) unless you have specific design needs to change them.

    3. If you have SQL Server database mirroring configured and you want to include the Business Data Connectivity Service database in mirroring, provide the name of the failover database server in the Failover Database Server box.

    4. If you have not already created a new application pool for your service applications, enter a name for a new application pool in the Application pool name box, for example, "SharePointServiceApps". You can use this application pool for all your service applications. For more information on planning, creating and configuring service applications, see Manage service applications in SharePoint 2013.

    5. Select the account that you configured in the Prerequisites for deploying a Business Connectivity Services on-premises solution in SharePoint 2013 procedure as the SharePoint products application services account in the Configurable drop down.

  7. Click OK to create the new Business Data Connectivity Service Application and click OK again.

  8. Select the row that the Business Data Connectivity Service Application is in, not the proxy row.

  9. Click Administrators in the Operations area and add any accounts that you want to be able to administer the Business Data Connectivity service application granting them full control. When these individuals open Central Administration they will only be able to administer the Business Data Connectivity service application.

Important:

Link to Step 5 Set permissions on the BCS Metadata Store for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013
Manage service applications in SharePoint 2013


Set permissions on the BCS Metadata Store for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: How to configure permissions on the Business Connectivity Services (BCS) Metadata Store for SharePoint 2013 for an on-premises configuration.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The BCS Metadata Store holds external content types, external systems and BDC model definitions for the BCS Service Application. In this procedure you configure administrative permissions on the Metadata Store and everything that it will contain.

Important:

This is Step 5 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • Link to Step 4 Create the Business Data Connectivity service application in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Set permissions on the Business Connectivity Services Metadata Store

  1. Open the SharePoint Central Administration website with either a Farm administrator account or an account that has been delegated permissions to administer the Business Data Connectivity Service Applications.

  2. On the Quick Launch, click Application Management.

  3. On the Application Management page, under Service Applications, click Manage service applications.

  4. In the list of services, select the row of the Business Data Connectivity Service Application that you created in Create the Business Data Connectivity service application in SharePoint 2013 and then click Manage and then Set Metadata Store Permissions.

  5. Enter the Farm Administrator account and any other delegate administrators if you have them and then click Add.

  6. For each account or group that you added that is an administrator of the Business Data Connectivity Service Application, select the Edit, Execute, Selectable In Clients, and Set Permissions checkboxes.

  7. Select the Propagate permissions to all BDC Models, External Systems and External Content Types in the BDC Metadata Store. Doing so will overwrite existing permissions checkbox. For more information on setting permissions on the BDC Metadata Store, see Overview of Business Connectivity Services security tasks in SharePoint 2013.

  8. Click OK.

Note:

Edit is a highly privileged permission that is required to create or modify external content types in the Business Data Connectivity metadata store. Execute permission is required to query the external content type.

Important:

Link to Step 6 Configure the Secure Store Service for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013
Overview of Business Connectivity Services security tasks in SharePoint 2013


Configure the Secure Store Service for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: Link to a configuration of the Secure Store Services for a Business Connectivity Services (BCS) on-premises solution in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The Secure Store Service stores the credentials that Microsoft Business Connectivity Services uses to access the AdventureWorks external data source and performs credential mapping between your users accounts and the credentials used to access the external data source.

Important:

This is Step 6 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • Link to Step 5 Set permissions on the BCS Metadata Store for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Parameters for configuring the Secure Store Service for a Microsoft Business Connectivity Services on-premises configuration

In this procedure you perform all the steps in Configure the Secure Store Services in SharePoint 2013 Preview article. You must perform the steps in the Configure the Secure Store Services in SharePoint 2013 article with these parameters from start to finish.

Configure Secure Store Service for on-premises Business Connectivity Services

  1. Perform all the steps in Configure the Secure Store Services in SharePoint 2013 Preview with the following parameters.

  2. Open the SharePoint Central Administration website for the server farm that your Secure Store Service is in with an account that has Farm Administrator permissions.

  3. In the Configure the Secure Store Services in SharePoint 2013 Preview article, perform all procedures in the Configure Secure Store section with these parameters

    1. For the Register Managed Account, User name type in the name of the service account that you created in the Prerequisites for deploying a Business Connectivity Services on-premises solution in SharePoint 2013 procedure.

    2. Do not select the Enable automatic password change box.

  4. Perform the "To start the Secure Store Service" procedure

  5. Perform the "To create a Secure Store Service application" procedures using these parameters

    1. In the Service Application Name box enter the name you want the service to appear as on the Manage Service Applications page.

    2. In the Database area, leave the prepopulated values for Database Server, Database Name, and Database authentication, which is Windows authentication (recommended) unless you have specific design needs to change them.

    3. If you have SQL Server database mirroring configured and you want to include the Secure Store Service in mirroring, provide the name of the failover database server in the Failover Database Server box.

    4. For the Configurable dropdown, select the account that you registered as a managed account earlier in this procedure.

  6. Perform the steps in the Work with encryption keys section with these parameters:

    1. Don't perform the procedures in the "Refresh the encryption key" sub-section

  7. Read the Store credentials in Secure Store section and perform the Create a target application procedure using these parameters.

    1. In the Target Application ID box type in a string for the target application; this is not the display name. For example type in AWTargetAppID.

    2. In the Display Name box, enter the display name you want, for example Adventure Works Target Application ID.

    3. In the Target Application Type dropdown, select Group (which indicates the mapping of many credentials to one credential). In this case, the Target Application Page URL is not needed and automatically selects to None.

    4. On the Create New Secure Store Target Application page, under Field Name, change Windows User Name to SQL User Name, and Windows Password to SQL Password.

    5. Under Field Type change Windows User Name to User Name and change Windows Password to Password.

    6. In the Target Application Administrators add the accounts that you want to be administrators of the Target Application. Note that the Farm Administrator has access by default.

    7. In the Members box, add the names of the users whom you want to allow access to the external data source. For this example use the AdventureWorksBCSUsers security group you created in Prerequisites for deploying a Business Connectivity Services on-premises solution in SharePoint 2013.

  8. Perform the steps in the Set credentials for a target application procedure using these parameters:

    1. In the SQL User Name box, type AdventureWorksUser which is the name SQL Server account you created in Create database logins for a Business Connectivity Services on-premises solution in SharePoint 2013.

    2. In the SQL Password, and Confirm SQL Password boxes type the password for that account, which is actually the password for the SharePointGroupAccount account that you created in Create database logins for a Business Connectivity Services on-premises solution in SharePoint 2013.

Important:

Link to Step 7 Create an external content type for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Configure the Secure Store Services in SharePoint 2013 Preview


Create an external content type for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: How to create and configure an external content type for the Business Connectivity Services (BCS) on-premises scenario deployment in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

These procedures walk you through building an external content type for Business Connectivity Services using SharePoint Designer 2013 without writing any code. You will learn how to discover a SQL Server database, connect to the database table, and then return the required data. You will create an external content type named Customers that is based on the Customer view in the AdventureWorks sample database. This article uses the procedures in How to: Create external content types for SQL Server in SharePoint 2013 Preview. You must open that article and perform the steps there using the parameters given in the matching sections of this article.

Note:

The sections in this article match the sections in the How to: Create external content types for SQL Server in Sharepoint 2013.

Important:

This is Step 7 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • Link to Step 6 Configure the Secure Store Service for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Create and configure an external content type with SharePoint Designer 2013

Define general information

  1. Open How to: Create external content types for SQL Server in SharePoint 2013 Preview

  2. Create a new external content type named AWcustomers with a display name of AdventureWorks Customers.

Define general and Office behaviors

  1. Set the Office Item Type to Contact. The Office Item Type determines the Outlook behavior you want to attach to the external content type. In this case, this AWCustomer external content type behaves like a native Contact Item in Outlook.

  2. In the Offline Sync for External List checkbox, make sure Enabled is selected, which is the default.

Note:

If you disable this option, then the SharePoint Connect to Outlook ribbon command is not available for an external list.

Create a connection to the external data

  1. Add a connection using SQL Server as the External Data Source Type.

  2. In the Set the Database Server box, enter <The name of the database server> and in the Set the Database Name box, enter AdventureWorks2008R2. Optionally, in the Name box, enter AdventureWorks Sample Database.

  3. Select Connect with Impersonated Custom Identity.

  4. In the Secure Store Application ID box, enter AWTargetAppID.

Warning:

If you are prompted to enter a user name and password for AWTargetAppID it may be because when you created the SharePointGroupAccount SQL login, you did not uncheck the User must change password at next login option. To fix this, you must change the password via SQL query ALTER LOGIN <LoginName> WITH PASSWORD = '<originalpassword>'

Select a table, view, or routine and Define Operation

  1. In the AdventureWorks Sample Database select the vIndividualCustomer view and right click Create All Operations.

Note:

Create All Operations is a convenient way to define all basic methods of operations (Create, Read, Read List, Update, and Delete).

Tip:

Always read carefully the messages in the Errors and Warnings pane. They provide useful information to confirm your actions or troubleshoot any issues.

Add columns

  1. In the Parameters Configuration dialog box, by default all columns are selected. To remove unnecessary columns, clear the checkboxes next to the following columns: Suffix and Demographics.

  2. For the BusinessEntityID select the Map to Identifier value.

    Note:

    Uncheck the Required box to prevent it from being updated but select the Read Only checkbox, which is needed to retrieve items so you can update other fields.

Map Outlook fields and set up the external item picker control

  1. For the FirstName, LastName, EmailAddress, and PhoneNumber fields, do the following:

  2. Click and highlight the field.

  3. Under properties, in the Office property dropdown, select the appropriate matching field: FirstName to First Name (FirstName), LastName to Last Name (LastName), and PhoneNumber to Primary Telephone Phone Number (PrimaryTelephonePhoneNumber), EmailAddress to EmailAddress1 (Email1Address).

    Note:

    Unmapped fields, depending on the number, are displayed as extended properties. For two to five fields they are listed as Adjoining meaning that they are appended to the form region at the bottom of an Outlook form's default page. For six or more fields they are listed as Separate and are added as a new page to an Outlook.

  4. For the following fields, BusinessEntityID, FirstName, LastName, and EmailAddress click and highlight the field, and then under Properties, click Show in Picker.

Define filters

  1. Create a Comparison filter named ByRegion, use CountryRegionName for the value.

  2. Under Properties, next to Default Value, enter Canada.

  3. Create Limit filter named AWLimit, use BusinessEntityID for the Filter Field

  4. Set the default value to 200

Tip:

Click the Errors and Warnings pane and make sure there are no more errors or warnings.

Set the Title field for an external list and complete the external content type

  1. Set BusinessEntityID as the Title and save the external content type.

Important:

Link to Step 8 Configure permission on an external content type for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

How to: Create external content types for SQL Server in SharePoint 2013 Preview


Configure permission on an external content type for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: Configure permission on an external content type for a Business Connectivity Services (BCS) on-premises scenario deployment in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

To configure user access and permissions to the external content type:

Important:

This is Step 8 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • Link to Step 7 Create an external content type for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Set up permissions to the external content type

  1. Open the Central Administration page for your site.

  2. On the Quick Launch, click Application Management.

  3. On the Application Management page, under Service Applications, click Manage service applications.

  4. In the list of services, click your Business Data Connectivity (BDC) Service.

  5. Click AWCustomers.

  6. On the ribbon, click Set Object Permissions.

  7. Enter the user accounts to which you want to grant permissions, and then click Add. For this example, you would add the security group that was created in Prerequisites for deploying a Business Connectivity Services on-premises solution in SharePoint 2013 AdventureWorksBCSUsers.

  8. Select the user accounts that you just added, and then select Execute check boxe.

  9. Select the Propagate permissions to all BDC Models, External Systems and External Content Types in the BDC Metadata Store check box to overwrite existing permissions.

  10. Click OK.

The external content type is now available for use in SharePoint and Office products to the appropriate users.

Important:

Link to Step 9 Create an external list for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013


Create an external list for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: Create an external list, set its permissions and configure a view for a Business Connectivity Services (BCS) on-premises scenario deployment in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

An external list is a key building block for SharePoint solutions based on external data. You can read and write external data with the familiar experience of using a SharePoint list. An external list looks and behaves a lot like a native list, but there are some differences in behavior. For example, you can create views and use calculated values with formulas, but not attach files or track versions. For this exercise, you create the external list in the browser because that is a common approach. This article uses the procedures in Create an external list on Office.com. You must open that article and perform the steps there using the parameters given in the matching sections of this article.

Important:

This is Step 9 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • Link to Step 8 Configure permission on an external content type for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Create an external list

  1. Open Create an external list

  2. Create an external list named AdventureWorksCustomers using the AWCustomers external content type.

Create a view of an external list

  1. Create a view for the external list AdventureWorksCustomers. For this example use ByRegionData Source Filter.

  2. Make it the default view, and select your own Sort, Filter, and Limit values.

Important:

Link to Step 10 Manage user permissions on an external list for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Create an external list


Manage user permissions on an external list for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: How to configure permissions on external lists for a Business Connectivity Services (BCS) on-premises scenario deployment in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Once you or an appropriate user has created the external list, it's important to make sure that you set appropriate permissions for other users. If the subsite that contains the external list inherits permissions from its parent site, then you may inadvertently give permission to inappropriate users. In this example, permissions are given to the AdventureWorksBCSUsers group.

Important:

This is Step 10 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • Link to Step 9 Create an external list for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Manage user permissions to the external list

  1. On the List tab, in the Settings group, click List Settings.

  2. Under Permissions and Management, click Permissions for this list...

  3. Apply permissions to the list as you have planned them.

The following table summarizes the default external list permissions for SharePoint user groups:

Name | Permission levels
Excel Services Viewers | View Only
<Site Name> Members | Edit
<Site Name> Owners | Full Control
<Site Name> Visitors | Read

Important:

Link to Step 11 Connect an external list to Outlook for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013


Connect an external list to Outlook for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: Create a connection between an external list and Outlook in a Business Connectivity Services (BCS) on-premises scenario deployment in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The external list contains customer data mapped to Outlook contacts for which you enabled Offline Sync for External List, so you can connect the list with Outlook 2013. Once connected, you can view, edit, and print the data using the familiar Outlook user interface. This article mirrors the procedures in Connect an external list to Outlook on Office.com. Refer to that article for more information on connecting an external list to Outlook.

Important:

This is Step 11 in the Business Connectivity Services On-Premises scenario deployment procedures.

  • Link to Step 10 Manage user permissions on an external list for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013.

Synchronize the external list with Outlook

  1. Open the SharePoint 2013 site that contains the external list. In the ribbon, on the List tab, in the Connect & Export group, click Connect to Outlook.

  2. In the Microsoft Office Customization Installer dialog box, click Install.The installation should take a minute or two.

  3. Once the installation is complete, click Close.

Important:

Link to Step 12 Verify offline access and synchronization of external data in Outlook for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Connect an external list to Outlook


Verify offline access and synchronization of external data in Outlook for a Business Connectivity Services on-premises solution in SharePoint 2013
See also

Published: October 16, 2012

Summary: How to work offline with external data in Outlook for a Business Data Connectivity (BCS) on-premises scenario deployment in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Important:

This is Step 12 in the On-Premises scenario deployment procedures. This is the last step in the installation procedures for this scenario

  • Link to Step 11 Connect an external list to Outlook for a Business Connectivity Services on-premises solution in SharePoint 2013 Create an external list for a Business Connectivity Services on-premises solution in SharePoint 2013 of the Business Connectivity Services On-Premises scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services on-premises solution in SharePoint 2013

Update customer data offline and refresh it online

  1. To take Outlook 2013 offline, click Send/Receive, and in the Preferences group, click Work Offline.

  2. Make a change or two to one of the AdventureWorks customers.

  3. To bring Outlook 2013 back online, click Send/Receive, and in the Preferences group, click Work Online.

  4. To synchronize the data, on the navigation pane, right-click the <Team Site Name> AWCustomers external list and then click Sync now

See also

Deploy a Business Connectivity Services on-premises solution in SharePoint 2013


Deploy a Business Connectivity Services cloud-only solution in SharePoint 2013
See also

Published: February 5, 2013

Summary: How to configure Business Connectivity Services (BCS) in SharePoint Online to access Windows Azure SQL Database.

Applies to: SharePoint Server 2013

The following scenario shows how to create a Microsoft Business Connectivity Services solution in SharePoint Online to access Windows Azure SQL Database. You will learn how to:

  • Configure the Business Connectivity Services in SharePoint Online.

  • Configure a Secure Store Service target application to map credentials between SharePoint Online and SQL Database.

  • Create an external content type by using SharePoint Designer 2010.

  • Create an external list in SharePoint Online.

  • Grant permissions to manage the external content type.

In this article:

  • Before you begin

  • What these procedures help you deploy

  • How to use these procedures

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

What these procedures help you deploy

Business Connectivity Services is a shared service in SharePoint Online. In SharePoint Online you can make external data visible through external lists or through apps for SharePoint. In this example, we use external lists. The solution looks as shown in the following diagram.

Figure: Cloud-only BCS solution

The sequence of data flow for BCS All In The Cloud

  1. The user logs on to SharePoint Online and opens an external list that the user has rights to.

  2. The Business Data Connectivity service runtime queries the external content type for the list in the Business Data Connectivity service metadata store to learn how to access the external system, which operations can be performed, and which credentials to use. The external content type tells the Business Data Connectivity service runtime to retrieve the necessary credentials from the Secure Store.

  3. The Business Data Connectivity service runtime passes the request (SOAP over HTTP) to the endpoint of the SQL Azure Windows Communication Foundation (WCF) service.

  4. The SQL Azure service returns the data in a SOAP envelope.

  5. The SharePoint Online site displays the external list in the user's browser. The user can then perform all the configured operations on the data source for which the user has permissions.

How to use these procedures

The steps to completely deploy this scenario are presented on Office.com at Make an External List from a SQL Azure table with Business Connectivity Services and Secure Store.

See also

Configure Business Connectivity Services solutions for SharePoint 2013


Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
See also

Published: April 9, 2013

Summary: How to configure the Business Connectivity Services (BCS) hybrid scenario to access on-premises data through SharePoint Online.

Applies to: SharePoint Server 2013 | SharePoint Online

Note:

This documentation is preliminary and subject to change.

The Microsoft Business Connectivity Services (BCS) hybrid deployment scenario allows you to securely publish on-premises data to an external list or app for SharePoint in SharePoint Online. From there users can view and edit the data, depending on the permissions that they have.

The BCS hybrid scenario requires successful deployment of the two-way SharePoint hybrid configuration. For more information about how to configure hybrid for SharePoint Server 2013, see Configure the hybrid environment infrastructure, Configure the hybrid identity management infrastructure, and Supported features and authentication topologies.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

Warning:

If you don't have a successful implementation of the base SharePoint hybrid scenario, you cannot proceed with the BCS hybrid implementation. You must complete the procedures at Configure the hybrid environment infrastructure and Configure the hybrid identity management infrastructure.

In this scenario you will learn how to:

  • Configure your on-premises environment so that you can securely publish confidential business data to your SharePoint Online tenancy.

  • Create and configure an OData service endpoint and an external content type with Visual Studio 2012.

  • Prepare your SharePoint Online tenancy to host an app for SharePoint or an external list which makes the external data accessible to your extranet users.

  • Create a connection settings object that tells Business Connectivity Services in SharePoint Online how to connect to the on-premises OData service endpoint.

  • Deploy an app for SharePoint or external list to your SharePoint Online tenancy.

  • Validate and troubleshoot the BCS hybrid scenario.

In this article:

  • Before you begin

  • What these procedures help you deploy

  • How to use these procedures

  • Roadmap of the procedures

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

What these procedures help you deploy

Business Connectivity Services (BCS) is a centralized infrastructure in SharePoint Server 2013, Office 2013, and SharePoint Online that enables you to integrate data that is not in SharePoint products and Office 2013 into SharePoint products. BCS implementations take many different forms, including this hybrid form that makes use of SharePoint Online and SharePoint 2013 on-premises. These procedures show you how to install and configure BCS to integrate data from an on-premises OData service endpoint into a SharePoint Online tenancy. For this scenario, we use the AdventureWorks sample SQL database and created an OData service head for the database. The solution looks as shown in the following diagram. For more information about SharePoint hybrid configurations and how data and authentication flow in the SharePoint BCS hybrid solution, see Hybrid for SharePoint Server 2013.

Figure: Hybrid BCS solution

Shows the sequence of actions for BCS hybrid

  1. An information worker logs on to the SharePoint Online tenancy by using the information worker's federated account and opens an app for SharePoint or external list that needs data from an on-premises OData data source. OData is an open protocol that is used to query and update data. For more information about OData, see Introducing OData: Data Access for the Web, the cloud, mobile devices and more in the MSDN Library.

  2. The external list creates a request for the data and sends it to Business Connectivity Services. Business Connectivity Services looks at the connection settings object to see how to connect to the data source and which credentials to use.

  3. Business Connectivity Services retrieves two sets of credentials.

    1. Business Connectivity Services retrieves the Secure Channel certificate from the Secure Store in SharePoint Online. This is used for SharePoint Online authentication to the reverse proxy.

    2. Business Connectivity Services retrieves an OAuth token from the Windows Azure AD Service. This is used for user authentication to the SharePoint 2013 on-premises farm. You get access to the Windows Azure AD service with your SharePoint Online subscription. It is a security token service that manages security tokens for users of SharePoint Online. For more information about the Access Control Service, see Access Control Service 2.0 in the MSDN Library. For more information about OAuth, see OAuth 2.0 on the web.

  4. Business Connectivity Services sends an HTTPS request to the published endpoint for the data source. The request includes the client certificate from the Secure Store and the OAuth token, as well as a request for the data. The reverse proxy authenticates the request by using the client certificate and forwards it to the on-premises SharePoint 2013 farm. For more information about publishing SharePoint to the Internet, see SharePoint publishing solution guide in the Forefront Technical Library.

  5. The on-premises farm retrieves the user's cloud identity from the OAuth token (for example, user123@contoso.com), and through the Client Side Object Model (CSOM) code, maps it to their on-premises identity (for example, Contoso\user123). The on-premises credentials are mapped to credentials that have access to the external data via a Secure Store target application.

  6. The on-premises Business Connectivity Services forwards the request to the OData Service endpoint. The OData Service authenticates the request (via IIS) and returns the data, which is passed back through the chain to the external list for the user to work with.

Video: Watch a demonstration of the BCS hybrid scenario.

Video (play button) icon

How to use these procedures

The steps to completely deploy this scenario are presented in smaller procedures. Some of the procedures are on TechNet, some are on Office.com, and some are on MSDN. Each procedure is numbered indicating its position in the overall sequence. At the beginning and end of each procedure, links direct you to the previous and following steps. The following list contains links to all of the procedures, in proper order, for your reference. Be aware that this list includes the steps to deploy an external list and an app for SharePoint. You can deploy one or the other or both depending on your needs. You should skip the steps for whichever configuration you don't want to deploy. You must follow them in sequence to build out the scenario. You can also use these procedures individually for your own unique scenarios. When you assemble individual procedures to build out your own scenarios, be sure to test the entire set of procedures, in order, in a lab setting before you try them in production.

If you only want to deploy the BCS hybrid scenario by using an external list, perform all the procedures in this order.

  • Start with Prepare the on-premises environment for the Business Connectivity Services hybrid scenario and go through

  • Create an external list for the Business Connectivity Services hybrid scenario, and then skip to

  • Validate the Business Connectivity Services hybrid scenario.

If you only want to deploy the BCS hybrid scenario by using an app for SharePoint, perform all the procedures in this order.

  • Start with Prepare the on-premises environment for the Business Connectivity Services hybrid scenario and go through

  • Create an external list for the Business Connectivity Services hybrid scenario, and then skip to

  • Deploy the Business Connectivity Services hybrid scenario as an app for SharePoint, and then perform all the procedures through

  • Validate the Business Connectivity Services hybrid scenario.

If you want to use both external lists and an app for SharePoint, perform all of the steps in order and do not skip any steps.

Roadmap of the procedures

Step number | Link to procedure | Description of procedure | Where the procedure is performed
1 | Prepare the on-premises environment for the Business Connectivity Services hybrid scenario | Prepare the on-premises account that you use to access the OData service endpoint (ODataAccount) and the Windows group (ODataGroup) that you use to control access to the OData service endpoint. | In your on-premises Active Directory domain.
2 | Create an on-premises Secure Store Service target application for the Business Connectivity Services hybrid scenario | Associate the security group (ODataGroup) to the account (Account) that you created in step 1 via a Secure Store Service target app. | In your on-premises Secure Store.
3 | Create and configure an OData service endpoint for the Business Connectivity Services hybrid scenario | Create the OData service endpoint, assign permissions and verify that the OData service endpoint is publishing the external data. | You create the OData endpoint with Visual Studio 2012 in your on-premises environment and you browse to it from inside your company intranet.
4 | Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario | Identify or create the SharePoint Online site where users will interact with the external data and create an App Catalog if necessary. | You will prepare a site in your SharePoint Online tenancy for the app for SharePoint or external list.
5 | Configure permissions on the SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario | Prepare the Business Data Connectivity (BDC) Metadata store for manually imported BDCM models. | You set permissions on the BDC metadata store in your SharePoint Online tenancy.
6 | Validate external access to reverse proxy published URL for the Business Connectivity Services hybrid scenario | Browse to the externally published address and log on as a federated user. | You browse to the externally published site through the Internet from a client computer that is outside your company intranet.
7 | Create and configure the connection settings object for the Business Connectivity Services hybrid scenario | Create a connection settings object that BCS in your SharePoint Online tenancy will use to connect to the on-premises OData service endpoint. | You create the connection settings object in your SharePoint Online tenancy.
8 | Create and configure the external content type for the Business Connectivity Services hybrid scenario | Use Visual Studio 2012 to create and configure the external content type for the OData service endpoint. | You create the external content type with Visual Studio 2012 from inside your company intranet.
9.0 | Deploy the Business Connectivity Services hybrid scenario as an external list | If you are creating an external list for the on-premises data, then follow steps 9.1, 9.2 and 9.3. |
9.1 | Extract an external content type to a BDCM file for the Business Connectivity Services hybrid Scenario | Manually extract the BDCM model to a file and prepare to import it into your SharePoint Online tenancy. | In Visual Studio 2012 in your on-premises environment.
9.2 | Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario | Import the BDCM into the BDC metadata store of your SharePoint Online tenancy. | In the metadata store of your SharePoint Online tenancy.
9.3 | Create an external list for the Business Connectivity Services hybrid scenario | Create an external list and associate it with the external content type that you imported in step 9.2. After you finish this step go to Validate the Business Connectivity Services hybrid scenario. | You create this list in the SharePoint Online site that you prepared in step 4.
10.0 | Deploy the Business Connectivity Services hybrid scenario as an app for SharePoint | If you are deploying an app for SharePoint for users to access the external data, follow steps 10.0 and 10.1. |
10.1 | Deploy an app for SharePoint to SharePoint Online by using Visual Studio for the Business Connectivity Services hybrid scenario | Deploy the app for SharePoint to the App Catalog. After you finish this step, go to Validate the Business Connectivity Services hybrid scenario. | You use Visual Studio 2012 from your on-premises environment to automatically deploy the app for SharePoint.
11 | Validate the Business Connectivity Services hybrid scenario | Validate read and write access to the on-premises data through your external list or app for SharePoint, and test security. | From the external list or app for SharePoint in the site you prepared in Step 4.

See also

Configure the hybrid environment infrastructure
Configure the hybrid identity management infrastructure

Hybrid for SharePoint Server 2013


Prepare the on-premises environment for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: Learn how to prepare the on-premises account and security group to control access to an OData endpoint for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

This example of the Microsoft Business Connectivity Services (BCS) hybrid scenario shows you how to use standard Windows domain security to control access to the on-premises OData service endpoint. You configure one domain account with which to access the OData service endpoint, and one global security group for your federated user accounts. Then, you map the group to the account by using a Secure Store Service target application.

Important:

This is Step 1 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to the previous article Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

To prepare on-premises security for the BCS hybrid scenario

  1. Identify all the user accounts in your on-premises domain that need to use the BCS hybrid solution and make sure that they are federated accounts. You will add these accounts to a domain global security group later in this procedure.

  2. In your on-premises domain, create a service account that will access the OData service endpoint. These procedures use an account named ODataAccount. For more information about how to create a domain-based account, see Create a New User Account in the Windows Server TechNet Library.

  3. In your on-premises domain, create a global security group. These procedures use a group named ODataGroup. For more information about how to create a global security group, see Create a New Group in the Windows Server TechNet Library.

  4. Add the accounts that you identified in step 1 to the ODataGroup. For more information about how to add users to a global security group, see Add a Member to a Group in the Windows Server TechNet Library.

Important:

Link to Step 2 Create an on-premises Secure Store Service target application for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
Create an on-premises Secure Store Service target application for the Business Connectivity Services hybrid scenario


Create an on-premises Secure Store Service target application for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: Learn how to create and configure the on-premises Secure Store Service target application for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

The Secure Store Service provides a database that is used to store credentials. These credentials usually consist of a user identity and password, but can also contain other fields that you define. For example, SharePoint Server 2013 can use the Secure Store database to store and retrieve credentials for access to external data sources. The Secure Store provides support for storing multiple sets of credentials for multiple back-end systems. For more information about the Secure Store, see Plan the Secure Store Service in SharePoint Server 2013.

In the Prepare the on-premises environment for the Business Connectivity Services hybrid scenario procedure, you added all the users that will use your BCS hybrid solution to the ODataGroup and created the ODataAccount. Later in this scenario, you will configure security on the OData service endpoint so that only the ODataAccount has access to it, aside from administrative accounts. In this procedure, you link the ODataGroup to the ODataAccount by using a Secure Store target application ID. This way, users can only access the OData service endpoint through only one account, the ODataAccount. Users get access to that account only by virtue of their membership in the ODataGroup, which you control administratively.

Important:

This is Step 2 in the Business Connectivity Services Hybrid scenario deployment procedures.

  • Link to Step 1 Prepare the on-premises environment for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

Create and configure a Secure Store target application

In this procedure, you create and configure the on-premises Secure Store target application named ODataApp for the BCS hybrid scenario. The name ODataApp is used for demonstration purposes. You can use any name of your choice. This procedure assumes that the Secure Store Service service application is already configured on your on-premises farm. If you haven't configured the Secure Store Service service application, you must complete the procedures in Configure the Secure Store Service in SharePoint 2013 before you continue.

To create and configure a Secure Store target application

  1. Open the SharePoint Central Administration website for your on-premises server farm by using a user account that is a member of the Farm Administrators group. In the Manage service applications section, click Secure Store Service.

  2. In Configure the Secure Store Service in SharePoint 2013, read Store credentials in Secure Store, and then perform the Create a target application procedure by using these parameters:

    1. In the Target Application ID box, type a string for the target application. This is not the display name; for example, ODataApp.

    2. In the Display Name box, type the display name you want; for example, ODataApp.

    3. In the Contact E-mail box, type a contact email address.

    4. In the Target Application Type drop-down list, select Group. This indicates the mapping of many user credentials or a security group to one credential. In this case, the Target Application Page URL is not needed and automatically selects None.

    5. On the Create New Secure Store Target Application page, for both Field Name and Field Type, accept the default values of Windows User Name and Windows Password.

    6. In the Target Application Administrators field, add the Farm Administrators account and an account that has farm administrator rights. In the Members field, add the domain security group you are using to control access to the BCS hybrid scenario solution; for example, ODataGroup.

  3. In Configure the Secure Store Service in SharePoint 2013, perform the Set credentials for a target application procedure by using these parameters:

    1. In the Windows User Name box, type the account name for the account that will have access to the OData service endpoint in domain\username format that you configured in Prepare the on-premises environment for the Business Connectivity Services hybrid scenario; for example, Adventureworks\ODataAccount.

    2. In the Windows Password and Confirm Windows Password fields, type the password for the account.

    Tip:

    If you need to change the password in the future, and you open this target application ID to edit it, the current account and password is not displayed.

Important:

Link to Step 3 Create and configure an OData service endpoint for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Prepare the on-premises environment for the Business Connectivity Services hybrid scenario
Create and configure an OData service endpoint for the Business Connectivity Services hybrid scenario

Configure the Secure Store Service in SharePoint 2013
Plan the Secure Store Service in SharePoint 2013


Create and configure an OData service endpoint for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: Learn how to configure an OData service endpoint for a SQL database for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

The Business Connectivity Services (BCS) hybrid scenario supports connecting only to an OData source. If your external data already has an OData service endpoint, then you can skip the creating an OData service endpoint portions of this procedure. You will still need to configure permissions on the service endpoint for the ODataAccount. For the purposes of these procedures, we use the Adventureworks sample SQL Server database (AdventureWorks 2012 LT sample database script and the AdventureWorks 2012 LT sample data) as the data source and create an OData service endpoint to make the data available to the BCS hybrid solution. You use Visual Studio 2012 to create and configure the OData service.

Important:

This is Step 3 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 2 Create an on-premises Secure Store Service target application for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

To create and configure the OData service endpoint

  1. Perform the procedures in How to: Create an OData data service that sends notifications to BCS in SharePoint 2013 in the MSDN Library. You will need the on-premises account that was configured in Prepare the on-premises environment for the Business Connectivity Services hybrid scenario to secure the service endpoint in Internet Information Services (IIS) 7.0. For example, these procedures use an account named ODataAccount.

  2. When you finish creating the OData service endpoint, go to Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario.

Important:

Link to Step 4 Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Create an on-premises Secure Store Service target application for the Business Connectivity Services hybrid scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013

AdventureWorks 2012 LT sample database script
AdventureWorks 2012 LT sample data


Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: Prepare the SharePoint Online site and App Catalog for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

The BCS hybrid scenario securely publishes sensitive on-premises data to select users of a SharePoint Online tenancy. You can present the data either through a SharePoint Online external list or through an app for SharePoint. In either case, you must identify or create a site in your tenancy through which the data will be offered. If you choose to use an app for SharePoint, you must also have a SharePoint OnlineApp Catalog configured.

Important:

This is Step 4 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 3 Create and configure an OData service endpoint for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

To prepare the SharePoint Online site and App Catalog

  1. Identify or create a site in your SharePoint Online tenancy for your external list or app for SharePoint. Ensure that all the federated users who will be using the BCS hybrid solution are added to the Members group for access to the site. For more information about how to create a site in SharePoint Online, see Create a Site on Office.com. For more information about how to plan sites and manage users, see Plan site and manage users also on Office.com.

  2. Before you can deploy an app for SharePoint to a site in your SharePoint Online tenancy, you must enable the App Catalog. For more information about how to enable and configure the App Catalog in SharePoint Online, see Use the App Catalog to make custom business apps available for your SharePoint Online environment on Office.com.

    Note:

    This scenario shows you how to directly deploy your app for SharePoint into the site you have prepared. It is also possible to deploy your app for SharePoint into the App Catalog.

Important:

Link to Step 5 Configure permissions on the SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Create and configure an OData service endpoint for the Business Connectivity Services hybrid scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
Configure permissions on the SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario

Create a Site
Plan site and manage users


Configure permissions on the SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: How to configure permission on the SharePoint Online Business Data Connectivity service (BDC) Metadata Store for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

The Business Data Connectivity service (BDC) Metadata Store holds external content types, external systems, and BDC model definitions for the BDC Service Application. In this procedure, you configure administrative permissions on the Metadata Store and everything that it will contain. Later in this scenario, if you are using the manual import of the external content type method, you will be using the BDC Metadata Store. This external content type will be available across your entire tenancy. If you will only be using the automated deployment of an app for SharePoint, then you will not use the BDC Metadata Store, and the external content type is scoped to the app only.

Important:

This is Step 5 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 4 Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

To set permissions on the BDC Metadata Store in SharePoint Online

  1. Open the SharePoint Online Administration Center by using an administrative account.

  2. On the Quick Launch, click BCS, then click Manage BDC Models and External Content Types.

  3. Click Set Metadata Store Permissions, and add All Authenticated Users with at least Execute permissions. This will allow all users who authenticate to your SharePoint Online tenancy to use the external content types stored in the Metadata Store.

  4. Select the Propagate permissions to all BCS Models, External Systems and External Content Types in the BDC Metadata Store. Doing so will overwrite existing permissions check box. For more information about how to set permissions on the BDC Metadata Store, see Overview of Business Connectivity Services security tasks in SharePoint 2013.

  5. Click OK.

Important:

Link to Step 6 Validate external access to reverse proxy published URL for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
Overview of Business Connectivity Services security tasks in SharePoint 2013
Validate external access to reverse proxy published URL for the Business Connectivity Services hybrid scenario


Validate external access to reverse proxy published URL for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: How to confirm access to the external URL of the on-premises SharePoint 2013 farm for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

At this point in deploying the Business Connectivity Services (BCS) hybrid scenario, you should confirm that you can access your on-premises SharePoint 2013 farm that has been configured to receive hybrid calls from SharePoint Online. This site was already configured in the Configure the hybrid environment infrastructure procedures. Its URL is the one you published through your reverse proxy.

Important:

This is Step 6 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 5 Configure permissions on the SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

Prerequisites

Before you begin this procedure, make sure you have the following:

  • The external URL, for example, if your on-premises farm web application was configured with an alternate access mapping of "hybridexternal.sharepoint.com" and you published out "https://hybridexternal.sharepoint.com" through the reverse proxy, you will use "https://hybridexternal.sharepoint.com" for this procedure. For more information, see Extend the primary web application and configure alternate access mappings.

  • A computer to browse from that is in the extranet. For example, use a computer that is not on your corporate network and is not a member of your corporate domain.

  • The Secure Channel certificate that is stored in the SharePoint OnlineSecure Store Service target application. This target application was configured in the Configure the hybrid environment infrastructure procedures. In the example it was named SecureChannelTargetApp. You will need the password for the certificate as well. For more information, see Create and install certificates.

  • The credentials of a federated account.

To confirm access to external URL

  1. Copy the certificate to your extranet computer, and then click the certificate. You will be prompted for the certificate password. This adds the certificate to your personal certificate store.

  2. Open a web browser and browse to the externally published URL of your on-premises farm. You should be prompted for credentials. If not, check your browser settings and make sure that your logged on credentials are not being automatically passed.

  3. Provide the credentials of the federated user. This log on must succeed and you should see the published site. If this does not work, contact the administrators who set up your hybrid infrastructure. Do not proceed any further with the BCS hybrid scenario until this issue is resolved.

Important:

Link to Step 7 Create and configure the connection settings object for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Configure permissions on the SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
Create and configure the connection settings object for the Business Connectivity Services hybrid scenario


Create and configure the connection settings object for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: How to configure a connection settings object in SharePoint Online for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

Your external list or app for SharePoint will send requests for external data to Microsoft Business Connectivity Services (BCS) in SharePoint Online just as it would in a SharePoint 2013 Server implementation. And just as in a SharePoint 2013 Server implementation, BCS will broker all communication with the external system and the external data source. However, unlike a SharePoint 2013 Server implementation, BCS in SharePoint Online needs additional information to establish the connection to the external system and the OData source. This configuration information is provided in a SharePoint Onlineconnection settings object.

Important:

This is Step 7 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 6 Validate external access to reverse proxy published URL for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

Prerequisites

Before you begin this procedure, make sure you have the following:

  • The URL or published service endpoint of the on-premises OData service that you configured in Create and configure an OData service endpoint for the Business Connectivity Services hybrid scenario.

  • The Secure Store Service target application ID that you configured in Create an on-premises Secure Store Service target application for the Business Connectivity Services hybrid scenario. This is the one that stores the mapping between ODataGroup and ODataAccount. For example the ODataApp.

  • The Internet-facing URL that Office 365 uses to connect to the service address and that was published by the reverse proxy. This is the address that you used to browse to the external service in Validate external access to reverse proxy published URL for the Business Connectivity Services hybrid scenario with the addition of /_vti_bin/client.svc.

  • The Secure Store target application ID for the Secure Channel certificate in the Secure Store the Office 365 users use to connect to the Internet-facing URL. This is the target application ID you configured in Configure SharePoint Online, for example SecureChannelTargetApp.

To configure the connection settings object for the BCS hybrid scenario

  1. Open the SharePoint Online Administration Center by using an administrator account, and on the Quick Launch, click bcs.

  2. Click Manage connections to on-premises services.

  3. Click Add.

  4. Give the connection settings object a name.

    Important:

    Keep track of this name; you will use it when you create the external content type in Create and configure the external content type for the Business Connectivity Services hybrid scenario.

  5. In the Service Address box, type the URL of the OData service endpoint that you created in Create and configure an OData service endpoint for the Business Connectivity Services hybrid scenario.

  6. For this scenario, select the Use credentials stored in Sharepoint on-premises as the authentication option, and then type the name of target application ID that holds the group to account mapping. In this scenario, it is ODataApp that you created in Create an on-premises Secure Store Service target application for the Business Connectivity Services hybrid scenario.

  7. In the Authentication Mode drop-down list, select Impersonate Window's Identity.

  8. In the Internet-facing URL box, type the external URL with the /_vti_bin/client.svc extension. For example https://hybridexternal.sharepoint.com/_vti_bin/client.svc.

  9. In the Secure Store Target Application ID box, type the ID of the target application that holds the Secure Channel certificate. For example SecureChannelTargetApp.

  10. Click Create.

Important:

Link to Step 8 Create and configure the external content type for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Configure the hybrid environment infrastructure
Configure the hybrid identity management infrastructure
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
Create an on-premises Secure Store Service target application for the Business Connectivity Services hybrid scenario
Create and configure an OData service endpoint for the Business Connectivity Services hybrid scenario
Validate external access to reverse proxy published URL for the Business Connectivity Services hybrid scenario
Create and configure the external content type for the Business Connectivity Services hybrid scenario


Create and configure the external content type for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: How to create an external content type for an OData source by using Visual Studio 2012 to support the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

In every Business Connectivity Services (BCS) solution, the external content type defines the external data to SharePoint 2013. It includes descriptions of how the data is structured, how it is secured, the specific portions of the external data that you want to interact with, and the permitted operations. When an external list or app for SharePoint or business data Web Part makes a request for external data, the Business Data Connectivity service refers to the external content type for the list or app or Web Part to understand how to communicate with the external data source.

In the BCS hybrid scenario, only OData sources are supported and the preferred way to make an external content type for an OData source is to use Visual Studio 2012. Visual Studio 2012 simplifies the external content type creation process by directly connecting to the OData source, reading it, and building the external content type XML for you. Once created, you have to make some minor changes to the XML, such as inserting which connection settings object to use and removing some of the boilerplate code, before you can deploy it to your SharePoint Online tenancy for use in the BCS hybrid scenario.

Important:

This is Step 8 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 7 Create and configure the connection settings object for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

Prerequisites

Before you begin this procedure, make sure you have the following:

  • Visual Studio 2012 installed on a computer that on your corporate network.

  • The OData service endpoint URL

  • Microsoft Office Tools for Visual Studio 2012

To create an external content type for the BCS hybrid scenario

  1. Complete the steps in How to: Create an external content type from an OData source in SharePoint 2013 in the MSDN Library. When you are done creating the external content type, you will need to decide how it will be deployed, either by using Visual Studio 2012 F5 deployment, or by extracting the external content type from a .app package and importing it manually by using SharePoint Online Administration Center. Return to Deploy the Business Connectivity Services hybrid scenario as an external list if you are going to manually import the external content type into the SharePoint Online BCS Metadata Store, or return to Deploy the Business Connectivity Services hybrid scenario as an app for SharePoint if you are going to use Visual Studio 2012 automation to deploy an app for SharePoint to your site in SharePoint Online.

    • If you are deploying manually, first follow the steps in How to: Convert an App-Scoped External Content Type to Tenant-Scoped in the MSDN Library to extract the BDC model file. Once you have the model file, return to Deploy the Business Connectivity Services hybrid scenario as an external list to manually import it into the SharePoint Online BCS Metadata Store.

    • If you are using Visual Studio 2012 to deploy the app for SharePoint, return to Deploy the Business Connectivity Services hybrid scenario as an app for SharePoint.

Important:

Link to Step 9.0 Deploy the Business Connectivity Services hybrid scenario as an external list of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Create and configure the connection settings object for the Business Connectivity Services hybrid scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
Deploy the Business Connectivity Services hybrid scenario as an external list
Deploy the Business Connectivity Services hybrid scenario as an app for SharePoint

How to: Create and external content type from an OData source in SharePoint 2013


Deploy the Business Connectivity Services hybrid scenario as an external list
See also

Published: April 9, 2013

Summary: Find links to procedures to help you manually extract a Business Data Connectivity model, import the model into SharePoint Online, and manually create an external list to surface the on-premises data.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

On-premises data can be integrated in to your SharePoint Online tenancy either through an external list or an app for SharePoint. The procedures in this section show you how to integrate the external data by using an external list. After you complete these procedures, you can go to Validate the Business Connectivity Services hybrid scenario.

Important:

This is Step 9.0 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 8 Create and configure the external content type for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

Procedures in this section

Link to procedure | Description of procedure | Where the procedure is performed
Extract an external content type to a BDCM file for the Business Connectivity Services hybrid Scenario | Manually extract the BDCM model to a file and prepare to import it into your SharePoint Online tenancy. | In your on-premises environment, by using Visual Studio 2012.
Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario | Import the BDCM model into the BDC Metadata Store of your SharePoint Online tenancy. | In the Metadata Store of your tenancy, by using SharePoint Online.
Create an external list for the Business Connectivity Services hybrid scenario | Create an external list and associate it with the external content type that you imported in Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario. After you finish this step, go to Validate the Business Connectivity Services hybrid scenario. |

Important:

Link to Step 9.1 Extract an external content type to a BDCM file for the Business Connectivity Services hybrid Scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Create and configure the external content type for the Business Connectivity Services hybrid scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
Extract an external content type to a BDCM file for the Business Connectivity Services hybrid Scenario


Extract an external content type to a BDCM file for the Business Connectivity Services hybrid Scenario
See also

Published: April 9, 2013

Summary: Link to how to manually extract an external content type to a BDCM file for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

The external content type that you configured in Create and configure the external content type for the Business Connectivity Services hybrid scenario must be manually extracted and saved as a file with a .bcdm extension. This is done by using Visual Studio 2012. The procedure for doing this is How to: Convert an App-Scoped External Content Type to Tenant-Scoped in the MSDN Library. After you complete the steps in How to: Convert an App-Scoped External Content Type to Tenant-Scoped procedure, return to Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario.

Important:

This is Step 9.1 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 9.0 Deploy the Business Connectivity Services hybrid scenario as an external list of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

To extract an external content type to a BDCM model

  1. Follow the steps in How to: Convert an App-Scoped External Content Type to Tenant-Scoped.

Important:

Link to Step 9.2 Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Deploy the Business Connectivity Services hybrid scenario as an external list
Create and configure the external content type for the Business Connectivity Services hybrid scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013

How to: Convert an App-Scoped External Content Type to Tenant-Scoped


Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: How to import an external content type as a BDCM file into a SharePoint Online Business Data Connectivity service (BDC) Metadata Store.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

When you import a BDCM model into the BDC metadata service, you are creating an external content type. This external content type is available for tenant-wide use.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

Important:

This is Step 9.2 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 9.1 Extract an external content type to a BDCM file for the Business Connectivity Services hybrid Scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

Import a BDCM file into the SharePoint Online BDC Metadata Store

Before you begin this procedure, make sure you have the following:

  • The .bdcm file that you extracted in Extract an external content type to a BDCM file for the Business Connectivity Services hybrid Scenario.

  • An account with administrative rights to your SharePoint Online tenancy and administrative rights to the BDC Metadata Store.

Important:

When you import the BDC Model file into SharePoint Online, you must be logged in to the SharePoint Online administrator site as a federated account (an account imported to Office 365 from On-Premise using Directory Sync). This federated account should also be given Global Administrator rights in Office 365. When importing the BDC Model to configure Hybrid BCS, certain calls are made to On-premise SharePoint Server 2013 that will require you use a federated user account. Be aware the account must also have a populated user profile in your On-Premise SharePoint Server 2013 farm.

This procedure requires that all previous procedures in this scenario have been completed successfully, that the core hybrid infrastructure is working correctly, and that bidirectional communication between SharePoint Online and your on-premises SharePoint 2013 farm for hybrid is working.

To import a BDCM file into the SharePoint Online BDC Metadata Store

  1. Log on to your SharePoint Online tenancy by using an administrative account, and then open the SharePoint Online Administration Center.

  2. In the Quick Launch, click bcs.

  3. Under business connectivity services, click Manage BDC Models and External Content Types.

  4. On the Edit tab, click Import.

  5. Click Browse, and then browse to the .bdcm file that you exported in Extract an external content type to a BDCM file for the Business Connectivity Services hybrid Scenario.

  6. Leave the default selections for File Type and Advanced Settings, and then click Import. During the import, BCS validates the XML in the model, queries the connection settings object, and connects to the on-premises OData source.

Important:

Link to Step 9.3 Create an external list for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Extract an external content type to a BDCM file for the Business Connectivity Services hybrid Scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
Create an external list for the Business Connectivity Services hybrid scenario


Create an external list for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: How to create an external list in SharePoint Online for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

Important:

This is Step 9.3 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 9.2 Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

To create an external list for the BCS hybrid scenario

  1. Open the site that you prepared in Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario by using an account that has site owner permissions and is a federated account.

  2. On the Quick Launch, click Site Contents, and then click add an app.

  3. Click External List, and then provide a name for the list.

  4. Click the Select External Content Type link next to the External Content Type box.

  5. Select the external content type that you created in Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario, click OK, and then click Create.

  6. Open the external list and confirm that your external data is displayed.

Important:

Link to Step 11 Validate the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario
Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario
Import the BDCM file into SharePoint Online BDC Metadata Store for the Business Connectivity Services hybrid scenario


Deploy the Business Connectivity Services hybrid scenario as an app for SharePoint
See also

Published: April 9, 2013

Summary: Find links to procedures to help you use Visual Studio 2012 automation to deploy your app for SharePoint for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

On-premises data can be integrated in to your SharePoint Online tenancy through either an app for SharePoint or an external list. The procedure in this section shows you how to integrate the external data by using an app for SharePoint. After you complete this procedure, you can go to Validate the Business Connectivity Services hybrid scenario.

Important:

This is Step 10.0 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to the previous step, Step 8 Create and configure the external content type for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

Procedures in this section

Link to procedure | Description of procedure | Where the procedure is performed
Deploy an app for SharePoint to SharePoint Online by using Visual Studio for the Business Connectivity Services hybrid scenario | Deploy the app for SharePoint to SharePoint Online. After you finish this step, go to Validate the Business Connectivity Services hybrid scenario. | You use Visual Studio 2012 from your on-premises environment to automatically deploy the app for SharePoint.

Important:

Link to Step 10.1 Deploy an app for SharePoint to SharePoint Online by using Visual Studio for the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Validate the Business Connectivity Services hybrid scenario
Deploy an app for SharePoint to SharePoint Online by using Visual Studio for the Business Connectivity Services hybrid scenario


Deploy an app for SharePoint to SharePoint Online by using Visual Studio for the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: How to deploy your app for SharePoint to your SharePoint Online site by using Visual Studio for the Business Connectivity Services (BCS) hybrid scenario.

Applies to: SharePoint Server 2013 | SharePoint Online

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

Visual Studio 2012 includes automation that you can use to deploy apps for SharePoint directly to SharePoint. This procedure contains links to the latest procedures in the MSDN Library. After you have completed that procedure, return to Validate the Business Connectivity Services hybrid scenario.

Important:

This is Step 10.1 in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 10.0 Deploy the Business Connectivity Services hybrid scenario as an app for SharePoint of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

To deploy an app for SharePoint by using Visual Studio

  1. Follow Deploying apps for SharePoint 2013 using Business Connectivity Services Hybrid Connections.

Important:

Link to Step 11 Validate the Business Connectivity Services hybrid scenario of the Business Connectivity Services hybrid scenario deployment procedures.

See also

Deploy the Business Connectivity Services hybrid scenario as an app for SharePoint
Validate the Business Connectivity Services hybrid scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013


Validate the Business Connectivity Services hybrid scenario
See also

Published: April 9, 2013

Summary: How to validate the Business Connectivity Services (BCS) hybrid solution is working.

Applies to: SharePoint Server 2013

Note:

This documentation is preliminary and subject to change.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

Now that you have created an external list or deployed an app for SharePoint in SharePoint Online, you need to test the security you put in place. Every account that will be accessing and manipulating the external data must have three properties:

  • It must have user or greater permissions to the SharePoint Online site and the external list or app for SharePoint.

  • It must be a federated account.

  • It must be a member of the on-premises global security group that you are using to control access to the OData service endpoint. For example, it must be a member of ODataGroup.

In this procedure, you will open the SharePoint Online site and the external list or app for SharePoint with four different accounts.

Important:

This is Step 11, the last step in the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 9.3 Create an external list for the Business Connectivity Services hybrid scenario if you did the manual import of the BDCM and manually created an external list of the Business Connectivity Services hybrid scenario deployment procedures.

  • Link to Step 10.1 Deploy an app for SharePoint to SharePoint Online by using Visual Studio for the Business Connectivity Services hybrid scenario if you did the automated deployment of an app for SharePoint by using Visual Studio 2012 of the Business Connectivity Services hybrid scenario deployment procedures.

  • For a list of all the procedures in order, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

To validate security on the BCS hybrid

  1. Identify or create one account for each of the account types listed in the following table.

    Account Expected outcome Troubleshooting step

    Account A

    • Has site/list/app permissions.

    • Is federated.

    • Is a member of the on-premises global security group (ODataGroup).

    External data displayed and editable.

    If the external data does not display or you cannot edit it, check the site permissions, your federation setup, and the membership of your on-premises global security group; for example, the ODataGroup.

    Account B

    • Does not have site/list/app permissions.

    • Is federated.

    • Is a member of the on-premises global security group (ODataGroup).

    External data does not display.

    If the external data does display and you can edit it, check the site/list/app permissions.

    Account C

    • Has site/list/app permissions.

    • Is not federated (is an Office 365 account only).

    • Cannot be added to the on-premises global security group (ODataGroup).

    External data does not display.

    If the external data does display and you can edit it, check your federation setup and membership of your on-premises global security group (Odata Group).

    Account D

    • Has site/list/app permissions.

    • Is federated.

    • Is not a member of your on-premises global security group (ODataGroup).

    External data does not display.

    If the external data does display and you can edit it, check the membership of your on-premises global security group (ODataGroup) and the permissions that you set on the OData service endpoint that you configure in Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario

  2. Open (by using In-Private browsing if possible) the SharePoint Online site that contains the external list or app for SharePoint by using each of the accounts in turn. Be sure to completely log out and close your browser in between tests.

  3. If you don't see the expected outcome, refer to the troubleshooting step in the previous table, fix the issue, and repeat all four tests until you achieve the expected outcome.

See also

Create an external list for the Business Connectivity Services hybrid scenario
Deploy an app for SharePoint to SharePoint Online by using Visual Studio for the Business Connectivity Services hybrid scenario
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013
Prepare the SharePoint Online environment for the Business Connectivity Services hybrid scenario


Configure eDiscovery in SharePoint Server 2013

Summary: Learn the steps to set up and configure eDiscovery in SharePoint Server 2013 and Exchange Server 2013.

Applies to: SharePoint Server 2013

This article identifies the steps that are required to configure eDiscovery in SharePoint Server 2013. When you complete the steps that are listed in this article, users will be able to create and work with eDiscovery cases.

Before you configure eDiscovery, you should understand the concepts that are presented in the article Overview of eDiscovery and in-place holds in SharePoint Server 2013, and you should have completed the planning process that is described in the article Plan for eDiscovery in SharePoint Server 2013.

The tasks that you must perform to configure eDiscovery are the following:

  • Configure communication between SharePoint Server 2013 and Exchange Server 2013.

  • Configure Search to crawl all discoverable content.

  • Grant permissions.

  • Create an eDiscovery Center.

Configure communication between SharePoint Server 2013 and Exchange Server 2013

If you will use a SharePoint eDiscovery Center to discover content in Exchange Server, you must configure SharePoint Server 2013 and Exchange Server to interact.

Important:

To discover content in Exchange Server from a SharePoint eDiscovery Center, you must be running Exchange Server 2013.

Perform the following steps:

  1. Ensure that the Exchange Web Service managed API is installed on every front-end server that is running SharePoint Server 2013. For more information about the Exchange Web Service managed API, see Hardware and software requirements for SharePoint 2013.

  2. Configure a trust relationship between SharePoint Server 2013 and Exchange Server. For information about how to configure the trust relationship, see Configure server-to-server authentication in SharePoint 2013.

  3. If you want content from Lync Server 2013 to be discoverable, configure Lync Server 2013 to archive to Exchange Server 2013. For information about how to configure Lync Server 2013 archiving, see Microsoft Lync Server 2013 Archiving Deployment Guide.

  4. Perform the eDiscovery configuration steps for Exchange. For information about how to configure Exchange Server 2013 for eDiscovery, see Configure Exchange for SharePoint eDiscovery Center.

Configure Search to crawl all discoverable content

Content is only discoverable if it is crawled and indexed by the Search service application that is associated with the web application that the eDiscovery Center is in. You should have identified this Search service application when you planned for eDiscovery. To configure the Search service application to crawl the appropriate content, follow these steps:

  1. If content in Exchange Server 2013 must be discoverable, add Exchange Server 2013 as a result source. For information about how to configure a result source, see Configure result sources for search in SharePoint Server 2013.

  2. Ensure that all websites that contain discoverable content are being crawled. For information about how to configure a location to be crawled, see Add, edit, or delete a content source (SharePoint Server 2010).

  3. Ensure that all file shares that contain discoverable content are being crawled. For information about how to configure a location to be crawled, see Add, edit, or delete a content source (SharePoint Server 2010).

Grant permissions

The article Plan for eDiscovery in SharePoint Server 2013 recommends that you create a security group to contain all users of the eDiscovery Center. After you create the security group, grant the security group permissions to access all discoverable content.

Note:

The article Plan for eDiscovery in SharePoint Server 2013 explains the different ways of granting permissions to discoverable content. You should have chosen to grant permissions at the web application level or at the site collection level.

  1. If you will grant permissions at the web application level, create a user policy that gives the security group full read permissions for each web application that contains discoverable content. For information about how to create a policy for a web application, see Manage permission policies for a web application in SharePoint 2013.

    Note:

    When you change permissions at the web application level, Search re-crawls all of the content in the web application.

  2. If you will grant permissions at the site collection level, make the security group a site collection administrator for each site collection that contains discoverable content. For information about how to add a site collection administrator, see Add or change a site collection administrator.

    Important:

    A site collection administrator must add the security group as an additional site collection administrator by using the Site Settings menu. You cannot use Central Administration to make a security group a site collection administrator

  3. Ensure that the security group has permissions to access all file shares and other websites that contain discoverable content.

  4. If you will use a SharePoint eDiscovery Center to discover content in Exchange Server, grant the security group permissions to access Exchange Server mailboxes. For information about how to grant permissions in Exchange, see Configure Exchange for SharePoint eDiscovery Center.

  5. Grant the security group permissions to view the crawl log. For information about how to grant permissions to access the crawl log, see Set-SPEnterpriseSearchCrawlLogReadPermission.

Create an eDiscovery center

An eDiscovery Center is a site collection from which users can create and manage eDiscovery cases. To create an eDiscovery Center, follow the procedure in the article Create a site collection in SharePoint 2013, and choose the eDiscovery Center site collection type from the Enterprise tab. Be aware that an eDiscovery Center must be in a web application that supports claims authentication.


Configure site mailboxes in SharePoint Server 2013

Published: July 31, 2012

Summary: Configure Exchange Server 2013 and SharePoint Server 2013 for team email by using the SharePoint Server 2013 Site Mailboxes feature.

Applies to: Exchange Server 2013 | SharePoint Server 2013

This article describes how to configure Site Mailboxes in SharePoint Server 2013 and Exchange Server 2013. The Site Mailboxes feature provides SharePoint Server 2013 users with team email on a SharePoint site. Site Mailboxes also provides links to SharePoint document libraries in Outlook 2013, enabling users to share files and email messages with other members of a team that are working on a joint project.

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • Site Mailboxes requires Exchange Server 2013.

  • Any previous version of Exchange Web Services (EWS) will need to be uninstalled from the SharePoint servers.

    Note:

    You may need to determine if a previous version of EWS is installed. If so, please run the Check-SiteMailboxConfig script referenced below. Your version should be 15.0.516.25 or above.

  • Site Mailboxes feature requires that user profile synchronization be configured in the farm. For information about configuring user profile synchronization, see Plan user profiles and identities (SharePoint Server 2013), and Manage user profile synchronization in SharePoint Server 2013.

  • Site Mailboxes feature requires that the app management service application be configured in the farm. For information about configuring the app management service application, see New-SPAppManagementServiceApplication.

  • Secure Sockets Layer (SSL) configured for the Default Zone is a requirement for web applications that are deployed in scenarios that support server-to-server authentication and app authentication. This is such a scenario. As a prerequisite for configuring Site Mailboxes, the computer that is running SharePoint Server must have SSL configured. For more information, see Create claims-based web applications in SharePoint 2013 and follow the steps for creating an SSL site collection and server certificate.

    Note:

    You may need to import the Exchange Server SSL certificate from Exchange 2013 to SharePoint 2013, and from SharePoint 2013 to Exchange 2013. This is only necessary if the certificate is not trusted for the API endpoints (such as a Self-SSL Certificate in a lab environment).

    To import an untrusted SSL certificate to a new server:

    • Open Internet Explorer and navigate to Outlook Web App (if the deployment is on SharePoint Server) or the SSL SharePoint site (if the deployment is on Exchange Server): https://<ExServerName>/owa or https://<SP_FQDN>.

    • Accept to trust the certificate by clicking Continue to website.

    • Click Certificate Error info in Internet Explorer next to the Address bar, and then click View Certificates.

    • Select Install Certificate and then select Place all certificates in the following store.

    • Select the checkbox to show physical stores.

    • Install the certificate to Trusted Root Certification Authorities > Local Computer.

  • In order to perform these procedures, you must be a member of the SharePoint and Exchange Server administrator groups and have an operational Exchange Server with end-user mailboxes.

  • A SharePoint backup solution will not incorporate Exchange site mailboxes. An Exchange administrator will need to ensure timely backups of site mailboxes are taking place.

  • Users who access files in a SharePoint document library from a Site Mailbox must have the document library configured as a trusted site in their browser or a warning will appear that asks the user if she or he wants to trust the file.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure SharePoint for Site Mailboxes in SharePoint Server 2013

The first step in configuring Site Mailboxes is to install the Exchange Server Web Services API on each web front-end (WFE) server in the SharePoint Server 2013 farm.

Install Exchange Web Services API on SharePoint Server

  1. Download EWSManagedAPI.msi from the Microsoft Download Center (http://www.microsoft.com/en-us/download/details.aspx?id=35371) and save it to a folder on each WFE server.

  2. Open a command window as administrator and navigate to the folder where you saved EWSManagedAPI.msi.

  3. Run the following command:

    Copy code
    msiexec /i EwsManagedApi.msi addlocal="ExchangeWebServicesApi_Feature,ExchangeWebServicesApi_Gac"

  4. Reset IIS from the command line by typing IISReset.

Establish OAuth Trust and Service Permissions on SharePoint Server 2013

The next step is to copy the following two scripts. The first should be saved as Set-SiteMailboxConfig.ps1 and the second should be saved as Check-SiteMailboxConfig.ps1.

Set-SiteMailboxConfig.ps1:

Copy code
# .SYNOPSIS
#
# Set-SiteMailboxConfig helps configure Site Mailboxes for a SharePoint farm
#
# .DESCRIPTION
#
# Establishes trust with an Exchange Server, sets Site Mailbox settings and enables Site Mailboxes for a farm.
#
# .PARAMETER ExchangeSiteMailboxDomain
#
# The FQDN of the Exchange Organization where Site Mailboxes will be created
#
# .PARAMETER ExchangeAutodiscoverDomain
#
# [Optional] The FQDN of an Exchange Autodiscover Virtual Directory
#
# .PARAMETER WebApplicationUrl
#
# [Optional] The URL of a specific web application to configure. If not specified all Web Applications will be configured
#
# .PARAMETER Force
#
# [Optional] Indicate that the script should ignore any configuration issues and enable Site Mailboxes anyway
#

Param
(
   [Parameter(Mandatory=$true)]
   [ValidateNotNullOrEmpty()]
   [string]$ExchangeSiteMailboxDomain,
   [Parameter(Mandatory=$false)]
   [ValidateNotNullOrEmpty()]
   [string]$ExchangeAutodiscoverDomain,
   [Parameter(Mandatory=$false)]
   [ValidateNotNullOrEmpty()]
   [string]$WebApplicationUrl,
   [Parameter(Mandatory=$false)]
   [switch]$Force
)

$script:currentDirectory = Split-Path $MyInvocation.MyCommand.Path

if($WebApplicationUrl -ne $NULL -and $WebApplicationUrl -ne "")
{
    $webapps = Get-SPWebApplication $WebApplicationUrl
}
else
{
    $webapps = Get-SPWebApplication
}

if($webapps -eq $NULL)
{
    if($WebApplicationUrl -ne $NULL)
    {
        Write-Warning "No Web Application Found at $($WebApplicationUrl). Please create a web application and re-run Set-SiteMailboxConfig"
    }
    else
    {
        Write-Warning "No Web Applications Found. Please create a web application and re-run Set-SiteMailboxConfig"
    }

    return
}

$rootWeb = $NULL

foreach($webapp in $webapps)
{
    if($rootWeb -eq $NULL)
    {
        $rootWeb = Get-SPWeb $webApp.Url -EA SilentlyContinue
    }
}

if($rootWeb -eq $NULL)
{
    Write-Warning "Unable to find a root site collection. Please create a root site collection on a web application and re-run Set-SiteMailboxConfig"
    return
}

$exchangeServer = $ExchangeAutodiscoverDomain

if($exchangeServer -eq $NULL -or $exchangeServer -eq "")
{
    $exchangeServer = "autodiscover.$($ExchangeSiteMailboxDomain)"
}

Write-Host "Establishing Trust with Exchange Server: $($exchangeServer)"

$metadataEndpoint = "https://$($exchangeServer)/autodiscover/metadata/json/1"

$exchange = Get-SPTrustedSecurityTokenIssuer | Where-Object { $_.MetadataEndpoint -eq $metadataEndpoint }

if($exchange -eq $NULL)
{
    $exchange = New-SPTrustedSecurityTokenIssuer -Name $exchangeServer -MetadataEndPoint $metadataEndpoint
}

if($exchange -eq $NULL)
{
    Write-Warning "Unable to establish trust with Exchange Server $($exchangeServer). Ensure that $($metadataEndpoint) is accessible."

    if($ExchangeAutodiscoverDomain -eq $NULL -or $ExchangeAutodiscoverDomain -eq "")
    {
        Write-Warning "If $($metadataEndpoint) does not exist you may specify an alternate FQDN using ExchangeAutodiscoverDomain."
    }
    return
}

Write-Host "Granting Permissions to Exchange Server: $($exchangeServer)"
$appPrincipal = Get-SPAppPrincipal -Site $rootWeb.Url -NameIdentifier $exchange.NameId
Set-SPAppPrincipalPermission -AppPrincipal $appPrincipal -Site $rootWeb -Scope SiteSubscription -Right FullControl -EnableAppOnlyPolicy

Write-Host
Write-Host

Write-Host "Verifying Site Mailbox Configuration"
$warnings = & $script:currentDirectory\Check-SiteMailboxConfig.ps1 -ReturnWarningState

if($warnings -and -not $Force)
{
    Write-Warning "Pre-requisites not satisfied. Stopping Set-SiteMailboxConfig. Use -Force to override"
    return
}
elseif($warnings)
{
    Write-Warning "Pre-requisites not satisfied. -Force used to override"
}

foreach($webapp in $webapps)
{
    Write-Host "Configuring Web Application: $($webapp.Url)"
    Write-Host "Setting Exchange Site Mailbox Domain to $($ExchangeSiteMailboxDomain)"
    $webapp.Properties["ExchangeTeamMailboxDomain"] = $ExchangeSiteMailboxDomain

    if($ExchangeAutodiscoverDomain -ne $NULL -and $ExchangeAutodiscoverDomain -ne "")
    {
        Write-Host "Setting Exchange Autodiscover Domain to $($ExchangeAutodiscoverDomain)"
        $webapp.Properties["ExchangeAutodiscoverDomain"] = $ExchangeAutodiscoverDomain;
    }

    $webapp.Update()
}

$feature = Get-SPFeature CollaborationMailboxFarm -Farm -ErrorAction Ignore

if($feature -eq $NULL)
{
    Write-Host "Enabling Site Mailboxes for Farm"
    Enable-SPFeature CollaborationMailboxFarm
}
else
{
    Write-Host "Site Mailboxes already enabled for Farm"
}

Check-SiteMailboxConfig.ps1:

Copy code
Param
(
   [Parameter(Mandatory=$false)]
   [ValidateNotNullOrEmpty()]
   [switch]$ReturnWarningState
)

Add-PSSnapin Microsoft.SharePoint.Powershell

$anyWarnings = $false

Write-Host "Step 1: Checking for Exchange Web Services"

try
{
    $assm = [System.Reflection.Assembly]::Load("Microsoft.Exchange.WebServices, Version=15.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35")
    if($assm.GlobalAssemblyCache)
    {
        Write-Host -Foreground Green "Found Exchange Web Services in Global Assembly Cache"
        Write-Host "Exchange Web Services Version: $([System.Diagnostics.FileVersionInfo]::GetVersionInfo($assm.Location).FileVersion)"
    }
    else
    {
        Write-Warning "Unable to find Exchange Web Services in Global Assembly Cache"
        $anyWarnings = $true
    }
}
catch
{
    Write-Warning "Unable to find Exchange Web Services in Global Assembly Cache"
    $anyWarnings = $true
}

Write-Host
Write-Host

Write-Host "Step 2: Checking for https web application"

$webapps = Get-SPWebApplication -EA SilentlyContinue

$rootWeb = $NULL

if($webapps -ne $NULL)
{
    $sslWebAppExists = $false
    foreach($webapp in $webapps)
    {
        if($rootWeb -eq $NULL)
        {
            $rootWeb = Get-SPWeb $webApp.Url -EA SilentlyContinue
        }

        if(-not $webapp.Url.StartsWith("https://"))
        {
            Write-Warning "Web Application at $($webapp.Url) does not use HTTPS. Site Mailboxes will not work on this Web Application."
        }
        else
        {
            $sslWebAppExists = $true
            Write-Host -Foreground Green "Found Web Application at $($webapp.Url) that uses HTTPS"
        }
    }

    if(-not $sslWebAppExists)
    {
        Write-Warning "At least one Web Application must be configured for HTTPS in the default zone."
        $anyWarnings = $true
    }
}
else
{
    Write-Warning "No Web Applications Found. Please create a web application and re-run Check-SiteMailboxConfig"
    $anyWarnings = $true
    if($ReturnWarningState)
    {
        return $anyWarnings
    }
    return;
}

if($rootWeb -eq $NULL)
{
    Write-Warning "Unable to find any Sites. Please create a root site collection on a web application and re-run Check-SiteMailboxConfig"
    $anyWarnings = $true
    if($ReturnWarningState)
    {
        return $anyWarnings
    }
    return;
}

# Get App Permissions Management Objects
$appPrincipalManager = [Microsoft.SharePoint.SPAppPrincipalManager]::GetManager($rootWeb)
$appPrincipalPermissionsManager = New-Object -TypeName Microsoft.SharePoint.SPAppPrincipalPermissionsManager -ArgumentList $rootWeb

Write-Host
Write-Host
Write-Host "Step 3: Checking for trusted Exchange Servers"

$trustedIssuers = Get-SPTrustedSecurityTokenIssuer
$trustedIssuerHosts = @()

if($trustedIssuers -ne $NULL)
{
    $foundTrustedIssuer = $false
    foreach($trustedIssuer in $trustedIssuers)
    {
        if($trustedIssuer.RegisteredIssuerName.StartsWith("00000002-0000-0ff1-ce00-000000000000@"))
        {
            if($trustedIssuer.IsSelfIssuer)
            {
                $foundTrustedIssuer = $true

                $uri = New-Object -TypeName System.Uri -ArgumentList $trustedIssuer.MetadataEndPoint

                Write-Host -Foreground Green "Found trusted Exchange Server at $($uri.Host)"
                $appPrincipalName = [Microsoft.SharePoint.SPAppPrincipalName]::CreateFromNameIdentifier($trustedIssuer.RegisteredIssuerName)
                $appPrincipal = $appPrincipalManager.LookupAppPrincipal([Microsoft.SharePoint.SPAppPrincipalIdentityProvider]::External, $appPrincipalName);

                if($appPrincipal -ne $NULL)
                {
                    $isValidAppPrincipal = $true;

                    if($appPrincipalPermissionsManager.GetAppPrincipalSiteSubscriptionContentPermission($appPrincipal) -eq [Microsoft.SharePoint.SPAppPrincipalPermissionKind]::FullControl)
                    {
                        Write-Host -Foreground Green "Exchange Server at $($uri.Host) has Full Control permissions"

                    }
                    else
                    {
                        Write-Warning "Exchange Server at $($uri.Host) does not have Full Control permissions"
                        $isValidAppPrincipal = $false;
                        $anyWarnings = $true
                    }

                    if($appPrincipalPermissionsManager.IsAppOnlyPolicyAllowed($appPrincipal))
                    {
                        Write-Host -Foreground Green "Exchange Server at $($uri.Host) has App Only Permissions"
                    }
                    else
                    {
                        Write-Warning "Exchange Server at $($uri.Host) does not have App Only Permissions"
                        $isValidAppPrincipal = $false;
                        $anyWarnings = $true
                    }

                    if($isValidAppPrincipal)
                    {
                        $trustedIssuerHosts += $uri.Host
                    }

                }
                else
                {
                    Write-Warning "Unable to get App Principal for $($uri.Host). Unable to check permissions for this Exchange Server"
                    $anyWarnings = $true
                }
            }
            else
            {
                Write-Warning "Found trusted Exchange Server at $($uri.Host) but it is not a Self Issuer"
                $anyWarnings = $true
            }
        }
    }

    if(-not $foundTrustedIssuer)
    {
        Write-Warning "Unable to find any trusted Exchange Servers"
        $anyWarnings = $true
    }
}
else
{
    Write-Warning "Unable to find any trusted Exchange Servers"
    $anyWarnings = $true
}

Write-Host
Write-Host
Write-Host "Step 4: Report current Site Mailbox Configuration"

if($webapps -ne $NULL)
{
    foreach($webapp in $webapps)
    {
        Write-Host
        Write-Host "Web Application Site Mailbox Configuration: $($webapp.Url)"
        Write-Host "Exchange Site Mailbox Domain: $($webapp.Properties["ExchangeTeamMailboxDomain"])"

        if($webapp.Properties["ExchangeAutodiscoverDomain"] -ne $NULL)
        {
            Write-Host "Exchange Autodiscover Domain: $($webapp.Properties["ExchangeAutodiscoverDomain"])"
        }
    }
}

Write-Host
Write-Host "Trusted Exchange Services: $([String]::Join(", ", $trustedIssuerHosts))"

$feature = Get-SPFeature CollaborationMailboxFarm -Farm -ErrorAction Ignore

if($feature -eq $NULL)
{
    Write-Host -ForegroundColor Red "Site Mailboxes are NOT enabled for Farm"
}
else
{
    Write-Host -ForegroundColor Green "Site Mailboxes are enabled for Farm"
}

if($ReturnWarningState)
{
    return $anyWarnings
}

Save the two .ps1 files to the same folder on a SharePoint 2013 WFE server, as one script calls the other during execution. In a Windows PowerShell window (right-click the PowerShell icon and choose Run As Administrator to open), navigate to the folder containing the .ps1 files and run the Set-SiteMailboxConfig.ps1 script. This allows users to do the following:

  • Retrieve and install the Exchange metadata, giving the Exchange service principal full control permissions to the SharePoint site subscription

  • Enable the site mailbox feature in the SharePoint environment

  • (optional) Set the Exchange site mailbox target domain, if DNS for the domain has not been configured for AutoDiscover

The Check-SiteMailboxConfig.ps1 is called as part of the Set-SiteMailboxConfig script, and it confirms that the configuration has been successful (it can also be run separately).

The format should be as follows:

.\Set-SiteMailboxConfig.ps1 -ExchangeSiteMailboxDomain <Domain> -ExchangeAutodiscoverDomain [Exchange Server] -WebApplicationUrl [URL]

Where <Domain> equals the FQDN of the domain your Exchange Server is in, and <Exchange Server> is the Exchange Server that you intend to connect to. This is a required parameter.

Optional parameters are [Exchange Server], which is the Exchange Server you intend to connect to (this is needed ifAutodiscover is not enabled or properly configured) and [URL], which would be a specific URL that you may be configuring (typically used in an environment with SSL and non-SSL web applications).

Example:
.\Set-SiteMailboxConfig.ps1 -ExchangeSiteMailboxDomain tailspintoys.com -ExchangeAutodiscoverDomain exchange1.tailspintoys.com -WebApplicationUrl https://tailspintoys.com

If you encounter an error while running the script, refer to the "Troubleshooting" section later in this article for guidance.

Configure Exchange Server 2013 for Site Mailboxes

The final step is to establish OAuth trust, and service permissions, on the Exchange server.

Establish OAuth Trust and Service Permission on Exchange

  1. On your instance of Exchange Server open the Exchange Management PowerShell window as Administrator and change to the "C:\Program Files\Microsoft\Exchange Server\V15\Scripts" directory.

  2. Run the following command:

    Copy code
    .\Configure-EnterprisePartnerApplication.ps1 -ApplicationType Sharepoint -AuthMetadataUrl https://<SP_FQDN>/_layouts/15/metadata/json/1

    Where <SP_FQDN> is the URL to the SharePoint SSL root site collection that you want to configure.

Troubleshooting

Please review the following table if you encounter issues.

Table of error codes for reference when you run a configuration checklist script

Error Code | Error | Notes
0 | NoError | Review Prerequisites.
1 | ExchangeClientNotAvailable | EWS client was not found on the SharePoint WFE. Run the Check script and ensure the entries are properly in the GAC; you may need to reinstall the EWS client.
2 | UnsupportedVersion | EWS client version is incompatible with SharePoint. Run the Check script to ensure the version meets minimum requirements. Alternatively, the Exchange server may be 2010 or earlier.
3 | InvalidUser | The TeamMailboxDomain parameter is not a valid FQDN or SMTP address.
4 | UnauthorizedUser | The script received a 401 from the Exchange Server, review the Exchange setup steps.
5 | ServerBusy | Exchange timed out during AutoDiscovery. It should be intermittent, please retry, but if it is persistent, follow-up with the Exchange Administrator.
6 | URLNotAvailable | AutoDiscovery failed to return a URL for ECP/OWA, which means typically that the EWS client version is incompatible with SharePoint. It may also mean Site Mailboxes are not enabled on Exchange, which would require follow-up with the Exchange Administrator.
7 | OAuthNotSupported | Unsuccessful in generating an OAuth token on behalf of SharePoint. This is typically caused by claims-based authentication being disabled on the SharePoint web application.
8 | OAuthException | An error occurred during the OAuth handshake between SharePoint and Exchange. This is typically caused by server to server configuration issues, such as a realm value mismatch on either side, certificate issues for Exchange or SharePoint, etc. Review certificates and attempt to establish or reestablish trust.
9 | InvalidAutodiscoverDomain | The AutoDiscover domain property is not set to a valid FQDN.
10 | UnknownError | An unknown error condition has occurred. Run the Check script and confirm that a valid, trusted instance of SharePoint is available, review prerequisites, confirm AutoDiscover has been set-up properly with the Exchange Administrator.
101 | OAuthNotSupportedOverHttp | If this error is thrown, your web application's default zone is not set to SSL, and AllowOauthoverHttp is also set to false. Run the Check script to ensure that any web application you intend to host site mailboxes are set with SSL in the default zone, as outlined in the prerequisites.
102 | AssociatedOwnersGroupNull | One or both of the default Owners and Members groups for the site have been deleted. Each of these two default groups are required to exist on any site where users install site mailboxes. A site administrator should be able to direct a site owner to recreated these required groups.
103 | ExchangeTeamMailboxDomainNotSet | The ExchangeTeamMailboxDomain property has not been set.
104 | ExchangeAppPrincipalNotFound | No Exchange app principals were found to be trusted. Typically, this means the New-SPTrustedSecureTokenService step was missed. Run the Check script and ensure that the app principal URL(s) outputted are the correct one(s).
105 | ExchangeAppPrincipalMissingPermissions | The Exchange app principal being connected to doesn't have the right permissions on the SharePoint farm. Run the Check script and ensure that the Exchange app principal has the required permissions on the farm.


Configure Exchange task synchronization in SharePoint Server 2013
See also

Published: August 21, 2012

Summary: Configure Exchange Server 2013 and SharePoint Server 2013 for task synchronization by using the SharePoint Server 2013 Task Synchronization feature.

Applies to: SharePoint Server 2013 Enterprise SharePoint Server 2013, Exchange 2013

This article describes how to configure Task Synchronization in SharePoint Server 2013 and Exchange Server 2013. Task Synchronization allows users to synchronize SharePoint Server 2013 and Project Server tasks with Exchange Server and have them appear in Outlook 2013.

Note:

You may be looking for information on Exchange Server OOF integration with Project Server 2013. If so, refer to article Exchange Server calendar OOF integration with Project Server 2013.

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • Task Synchronization requires that user profile synchronization be configured in the farm. For information about configuring user profile synchronization, see Plan user profiles and identities (SharePoint Server 2013), and Manage user profile synchronization in SharePoint Server 2013.

  • Task Synchronization requires that the work management service application be configured in the farm. For information about creating the work management service application, see New-SPWorkManagementServiceApplication

  • Task Synchronization requires Exchange Server 2013.

  • Secure Sockets Layer (SSL) is a requirement for web applications that are deployed in scenarios that support server-to-server authentication and app authentication. This is such a scenario. As a prerequisite for configuring Task Synchronization, the computer that is running SharePoint Server must have SSL configured. For more information, see Create claims-based web applications in SharePoint 2013 and follow the steps for creating an SSL site collection and server certificate.

    Note:

    You may need to import the SSL certificate from the SharePoint Server 2013 web application. This is only necessary if the certificate is not trusted for the API endpoints (such as a Self-SSL Certificate in a lab environment).

    To import the untrusted SSL certificate from SharePoint Server 2013:

    • Open Internet Explorer on the Exchange server and navigate to the SSL SharePoint site https://<SP_FQDN>, where <SP_FQDN> is the URL to the SSL site.

    • Accept to trust the certificate by clicking Continue to website.

    • Click Certificate Error info in Internet Explorer next to the Address bar, and then click View Certificates.

    • Select Install Certificate and then select Place all certificates in the following store.

    • Select the checkbox to show physical stores.

    • Install the certificate to Trusted Root Certification Authorities > Local Computer.

  • In order to perform these procedures, you must be a member of the SharePoint and Exchange Server administrator groups and have an operational Exchange Server with end-user mailboxes.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure SharePoint for Task Synchronization in SharePoint Server 2013

The first step in configuring Task Synchronization is to install the Exchange Server Web Services API on each web front-end server in the SharePoint Server 2013 farm.

Install Exchange Web Services API on SharePoint Server

  1. Download EWSManagedAPI.msi from the Microsoft Download Center (http://www.microsoft.com/en-us/download/details.aspx?id=35371) and save it to a folder on the application server.

  2. Open a command window as administrator and navigate to the folder where you saved EWSManagedAPI.msi.

  3. Run the following command:

    Copy code
    msiexec /i EwsManagedApi.msi addlocal="ExchangeWebServicesApi_Feature,ExchangeWebServicesApi_Gac"

  4. Reset IIS from the command line by typing IISReset.

Configure Exchange Server 2013 for Task Synchronization

The next step is to establish OAuth trust and service permission on Exchange Server.

Establish OAuth Trust and Service Permission on Exchange

  1. On the Exchange server, open Windows PowerShell and change to the "C:\Program Files\Microsoft\Exchange Server\V15\Scripts" directory.

  2. Run the following script:

    Copy code
    .\Configure-EnterprisePartnerApplication.ps1 -ApplicationType Sharepoint -AuthMetadataUrl https://<SP_FQDN>/_layouts/15/metadata/json/1

    Where <SP_FQDN> is the URL to the root site collection.

See also

My Tasks Aggregation in SharePoint Server and Exchange Task Integration


Configure social computing features in SharePoint Server 2013

Updated: May 14, 2013

Summary: Learn how to configure social computing features in SharePoint 2013, including My Sites, Community Sites, and microblogging.

Applies to: SharePoint Server 2013

SharePoint Server 2013 implements features that make enterprise social computing and collaboration easier. Social networking tools, such as My Sites, and social content technologies, such as microblogs, are examples of social computing features. These features enable users to easily capture and share the knowledge and expertise that is needed to do their work. This sharing of information encourages collaboration, improves innovation, and targets relevant content to the people who have to see it. You can adapt content to each user while enabling administrators to set policies to protect privacy.

TechNet articles about configuring social computing features

The following articles about how to configure social computing features in SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Configure Exchange Autodiscover with a My Site Host URL in SharePoint Server 2013 | Learn how to configure Exchange Autodiscover to find a user's SharePoint My Site URL.
Building blocks | Configure microblogging in SharePoint Server 2013 | Learn how to configure microblogging in SharePoint Server 2013.
Building blocks | Configure My Sites in SharePoint Server 2013 | Learn how to set up My Sites in SharePoint Server 2013.
Building blocks | Configure synchronization on all document libraries in SharePoint Server 2013 | Learn how to add and remove synchronization from all document libraries in SharePoint Server 2013.
Building blocks | Create and configure communities in SharePoint Server 2013 | Learn how to set up Community Sites in SharePoint Server 2013.
Building blocks | Enable or disable personal and social features for users or groups in SharePoint Server 2013 | Learn how to configure user permissions for personal and social features in SharePoint Server 2013.
Building blocks | Remove recommendation Web Parts from My Sites in SharePoint Server 2013 | Learn how to remove the Suggested sites to follow and Suggested documents to follow Web Parts in SharePoint Server 2013.

Additional resources about configuring social computing features

The following resources about how to configure social computing features in SharePoint Server 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | What's New in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.
Downloads | Integrate Yammer with on-premises SharePoint 2013 environments (white paper) | Learn how to remove SharePoint 2013 social entry points in the user interface and install the Yammer app for SharePoint.

Change History

Date | Description
May 14, 2013 | Added new article: "Configure Exchange Autodiscover with a My Site Host URL in SharePoint Server 2013."
April 16, 2013 | Added new article: "Configure synchronization on all document libraries in SharePoint Server 2013."
July 16, 2012 | Initial publication


Configure Exchange Autodiscover with a My Site Host URL in SharePoint Server 2013
See also

Published: May 14, 2013

Summary: Learn how to configure Exchange Autodiscover to find a user's SharePoint My Site URL.

Applies to: SharePoint Server 2013

In SharePoint Server 2013, a My Site gives users rich social networking and collaboration features that enable content sharing, discussions, and other features for users to do their jobs. The Exchange Server 2013 Autodiscover service configures profile settings on mail clients and mobile devices based on a supplied user name and password. The Autodiscover service can also be configured to allow for a simpler, seamless configuration experience to a My Site for Office 2013 client integration. For example, Office 2013 client and mobile phone apps can use Exchange Autodiscover to find a user's My Site based on the My Site Host URL stored in Active Directory Domain Services (AD DS). Instead of identifying and entering the My Site Host URL, a user's email address and password are the only requirements to configure and provision client functionality for:

  • SkyDrive Pro — Open and save a document to your SkyDrive Pro location.

  • Access a Newsfeed on a device.

  • Office Hub — Set up the application on your Windows Phone.

This article provides the steps necessary to update AD DS with your My Site Host URL in SharePoint Server 2013. It also details the steps necessary to retrieve or remove the current My Site Host URL if you need to see the current value or replace it respectively.

Important:

Before you proceed to the next section, you must already have your SharePoint Server 2013 and Exchange Server 2013 environments installed and configured. Additionally, you need to set up and configure My Sites in SharePoint Server 2013. For more information about how to implement My Sites and retrieve your My Site Host URL, see Configure My Sites in SharePoint Server 2013.

Configure Exchange Autodiscover with a My Site Host URL

To update AD DS with the My Site Host URL, you must run a script on an Exchange Server computer by using the Exchange Management Shell. This procedure helps you create the Windows PowerShell script, and then run the script to update AD DS with the specified URL value. This procedure also provides the optional steps to verify and remove a My Site Host URL entry if needed. For more information about how to run scripts, see Scripting with the Exchange Management Shell in the Exchange Server 2013 Technical Library.

To configure Exchange Autodiscover with a My Site Host URL

  1. On an Exchange Server 2013 computer, copy the contents of the following script into Notepad. Save this file to any location and use a .ps1 extension to designate it as a Windows PowerShell script. Finally, rename the file SetMySiteHostURLInAD.ps1.

    Copy code
    function PrintUsage
{
@"

NAME:
SetMySiteHostURLInAD.ps1

SYNOPSIS:
The purpose of this script is to set My Site Host URL in Active Directory.
This URL will be returned through Exchange Autodiscover.

MySiteHostURL - URL of My Site Host to set in Active Directory.
Or use -get to get My Site Host URL from Active Directory.
Or use -remove to remove My Site Host URL from Active Directory.

SYNTAX:
SetMySiteHostURLInAD.ps1 "MySiteHostURL" | -get | -remove

EXAMPLES:
SetMySiteHostURLInAD.ps1 "http://my"
SetMySiteHostURLInAD.ps1 -get
SetMySiteHostURLInAD.ps1 -remove

"@
}

function GetConfigurationNamingContextPath
{
    return GetEntryProperty "LDAP://RootDSE" "configurationNamingContext"
}

function GetExchangePath
{
    param([string]$configurationNamingContextPath)

    return "LDAP://CN=Microsoft Exchange,CN=Services," + $configurationNamingContextPath
}

function GetOrganizationContainerPath
{
    param([string]$exchangePath)

    [string]$organizationContainerPath = ""

    ([ADSI] $exchangePath).Children | foreach {
      if (!$organizationContainerPath -and $_.SchemaClassName -eq "msExchOrganizationContainer") {
         $organizationContainerPath = $_.Path
            }
    }

    return $organizationContainerPath
}

function GetEntryProperty
{
    param([string]$entryPath, [string]$propertyName)

    $entry = [ADSI] $entryPath

    [string]$value = ""

    trap {
         continue
    }

    $value = $entry.Get($propertyName)

    return $value
}

function SetEntryProperty
{
    param([string]$entryPath, [string]$propertyName, [string]$propertyValue)

    $entry = [ADSI] $entryPath

    if (!$propertyValue)
    {
        $entry.PutEx(1, $propertyName, $null)
    }
    else
    {
        $entry.Put($propertyName, $propertyValue)
    }

    trap {
        Write-Host "`nError setting property" -ForegroundColor Red
        continue
    }

    $entry.SetInfo()
}

function AddOrReplaceOrRemoveMySiteHostURL
{
    param([string]$old, [string]$url)

    [string]$separator = ";"
    [string]$label = "SPMySiteHostURL" + $separator

    if (!$old)
      {
         if (!$url)
            {
              return ""
            }
         else
            {
              return $label + $url
            }
      }

    [int]$labelPosition = $old.IndexOf($label)
    if ($labelPosition -eq -1)
      {
         if (!$url)
            {
              return $old
            }
         else
            {
              if ($old[$old.Length - 1] -eq $separator)
              {
              return $old + $label + $url
              }
              else
              {
        return $old + $separator + $label + $url
              }
            }
        }

    [int]$valuePosition = $labelPosition + $label.Length

    [int]$nextLabelPosition = $old.IndexOf($separator, $valuePosition)
     if ($nextLabelPosition -eq -1)
       {
         if (!$url)
         {
              if ($labelPosition -eq 0)
              {
                 return ""
              }
              else
              {
                 return $old.Substring(0, $labelPosition - 1)
              }
          }
         else
         {
              return $old.Substring(0, $valuePosition) + $url
         }
      }

     if (!$url)
       {
          return $old.Substring(0, $labelPosition) + $old.Substring($nextLabelPosition + 1)
       }
      else
       {
          return $old.Substring(0, $valuePosition) + $url + $old.Substring($nextLabelPosition)
       }
}

if ($args.Count -ne 1)
{
    Write-Host "`nError: Required argument missing or too many arguments" -ForegroundColor Red
    PrintUsage
    exit
}

if ($args[0] -eq "-?" -or $args[0] -eq "-h" -or $args[0] -eq "-help")
{
    PrintUsage
    exit
}

[string]$url = ""
if ($args[0] -ne "-r" -and $args[0] -ne "-remove")
{
    $url = $args[0]
}

Write-Host "`nSetting My Site Host URL in Active Directory..."

[string]$configurationNamingContextPath = GetConfigurationNamingContextPath
Write-Host "`nConfiguration Naming Context path: $configurationNamingContextPath"

[string]$exchangePath = GetExchangePath $configurationNamingContextPath
Write-Host "`nExchange path: $exchangePath"

[string]$organizationContainerPath = GetOrganizationContainerPath $exchangePath
Write-Host "`nOrganization Container path: $organizationContainerPath"

[string]$propertyName = "msExchServiceEndPointURL"
Write-Host "`nProperty name: $propertyName"

[string]$old = GetEntryProperty $organizationContainerPath $propertyName
Write-Host "`nOld value: $old"

if (!$url)
{
    Write-Host "`nRemoving value"
}
elseif ($url -eq "-g" -or $url -eq "-get")
{
    Write-Host ""
    exit
}
else
{
    Write-Host "`nAdding or replacing value: $url"
}

[string]$new = AddOrReplaceOrRemoveMySiteHostURL $old $url
Write-Host "`nNew value: $new"

SetEntryProperty $organizationContainerPath $propertyName $new
Write-Host ""

  2. On the Start menu, click All Programs.

  3. Click Microsoft Exchange Server 2013.

  4. Click Exchange Management Shell.

  5. In the Exchange Management Shell, navigate to the directory where you have saved the script and run the script with your specified My Site Host URL. For example, if you have a host URL of http://server/sites/contoso, the syntax might look like the following in the Exchange Management Shell:

    Copy code
    [PS] C:\>  c:\SetMySiteHostURLInAD.ps1      http://server/sites/contoso

  6. Press ENTER to run the script and update AD DS with the My Site Host URL.

  7. To verify that the correct URL was updated, run the following command:

    Copy code
    [PS] C:\>  c:\SetMySiteHostURLInAD.ps1      -get
    Note:

    Optionally, you can remove a My Site Host URL by entering the command [PS] C:\> c:\SetMySiteHostURLInAD.ps1 -remove.

Once you have configured the My Site Host URL, you can also verify the value in SharePoint 2013 Central Administration. From Application Management, go to Manage service applications, to User Profile Service Application (or other chosen name for User Profile Service Application), to My Site Settings, and finally to Setup My Sites. On the My Site Settings page, you will see that the My Site Host URL in Active Directory field is populated with your entry.

My Site Host URL in Active Directory
Note:

The My Site Host URL in Active Directory field cannot be populated through Central Administration, and My Site Host URL value must be supplied by using the previous detailed process.

See also

Configure My Sites in SharePoint Server 2013


Configure microblogging in SharePoint Server 2013
See also

Summary: Use these TechNet articles to learn how to configure microblogging in SharePoint 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet provide information about microblogging in SharePoint 2013. Before you configure microblogging, make sure that you have completed the steps in Configure My Sites in SharePoint Server 2013.

TechNet articles about microblogging

The following articles about microblogging are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Configure Following settings in SharePoint Server 2013 | Learn how to configure Following settings for My Sites in SharePoint 2013.
Building blocks | Manage Feed Cache and Last Modified Time Cache repopulation in SharePoint Server 2013 | Learn how to manage repopulation of the Feed Cache and Last Modified Time Cache in SharePoint 2013.
Building blocks | Manage the Distributed Cache service in SharePoint Server 2013 | Learn how to configure and manage the Distributed Cache service in SharePoint 2013.

See also

Configure social computing features in SharePoint Server 2013


Configure Following settings in SharePoint Server 2013

Summary: Learn how to configure Following settings for My Sites in SharePoint Server 2013.

Applies to: SharePoint Server 2013

In SharePoint Server 2013, following is a user-initiated action that indicates the user's interest in a specific document, person, site, or tag. When users follow an item, new activities about that item appear in the users' newsfeeds on their My Sites. Users view all their followed items from their My Sites.

Configure Following settings for My Sites

Use this procedure to configure Following settings for My Sites.

Note:

Using lower limits can slightly improve performance. Also, by using lower limits, users will follow higher priority documents, people, or sites.

To configure Following settings for My Sites

  1. Verify that you have the following administrative credentials:

    • To configure Following settings for the User Profile service application, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website or a service application administrator for the User Profile service application.

  2. In Central Administration, in the Application Management section, in the Service Applications group, click Manage service applications.

  3. In the list of service applications, select the User Profile service application.

  4. In the Operations group, click Manage.

  5. On the Manage Profile Service page, in the My Sites Settings section, click Manage Following.

  6. In the Maximum number of followed people box, type the maximum number of people that a user can follow from the user's My Site.

  7. In the Maximum number of followed documents box, type the maximum number of documents that a user can follow from the user's My Site.

  8. In the Maximum number of followed sites box, type the maximum number of sites that a user can follow from the user's My Site.

  9. Click OK.


Manage Feed Cache and Last Modified Time Cache repopulation in SharePoint Server 2013
See also

Updated: February 19, 2013

Summary: Learn how to manage repopulation of the Feed Cache and Last Modified Time Cache in SharePoint Server 2013.

Applies to: SharePoint Server 2013

SharePoint Server 2013 feeds require the Feed Cache and Last Modified Time Cache. The Feed Cache maintains recent conversations and activities of entities. The Last Modified Time Cache maintains the last modified time for all items in the Feed Cache. The Distributed Cache service manages both the Feed Cache and the Last Modified Time Cache.

System events, such as a server shutting down unexpectedly physical events such as electrical power spikes can affect the Distributed Cache service. Additionally, an administrator who performs maintenance and operational tasks can take an application server that runs the Distributed Cache service offline. This results in the resetting and emptying of the Feed Cache and the Last Modified Time Cache. In this situation, repopulation of the recent conversations and activities of entities occurs. Repopulation occurs in two stages:

  1. Load last modified time information for recent conversations and activities.

  2. Load recent conversations and activities.

Note:

In the case of planned maintenance and operations, an administrator can preserve cache data by using the graceful shutdown procedure. For more information, see Perform a graceful shutdown of the Distributed Cache service in Manage the Distributed Cache service in SharePoint Server 2013.

To manage the repopulation process, SharePoint Server 2013 includes the Feed Cache Repopulation Job timer job. When the Feed Cache Repopulation Job timer job runs, it first checks whether the Feed Cache and Last Modified Time Cache are empty. If they are empty, it starts repopulating the last modified time information for recent conversations and activities in the Last Modified Time Cache. After the timer job finishes the Last Modified Time Cache repopulation, the Feed Cache is populated with recent conversations and activities the next time any user accesses a feed in SharePoint Server 2013.

In this article:

  • Feed Cache settings on the User Profile Service application

  • Repopulate the Last Modified Time Cache by using timer jobs in Central Administration

  • Feed Cache settings on the User Profile Service application

Feed Cache settings on the User Profile Service application

An administrator might configure properties on the User Profile Service application that changes the default behavior of the Feed Cache in SharePoint Server 2013. For example, the maximum number of posts per entity that can be stored in the Feed Cache is set to a default value of 500. When this maximum value is reached, the Feed Cache will delete 200 posts to allow the entity to continue posting. Updating these properties might take 5 to 10 minutes to take effect because this is the time it takes to propagate. Other content following limits can take 5 to 10 minutes if you have more than one server.

The following table lists parameters to set for the Feed Cache on a User Profile Service application.

Table: Feed Cache parameters for a User Profile Service application

Feed Cache settings on the User Profile Service application | Description | Default value
FeedCacheTTLHours | The default Time To Live of entries in feed cache in hours. For example, setting this property to 168 (hours) will store entries in the Feed Cache for 7 days. | 168
FeedCacheLastModifiedTimeTtlDeltaHours | Additional time added to keep FeedCacheTTLHours for LMT entries. LMT items are kept for 14 days. 7 days for FeedCacheTTLHours plus 7 days for FeedCacheLastModifiedTimeTtlDeltaHours. | 168
FeedCacheObjectCountLimit | The maximum number of posts for a given entity that can exist in feed cache. | 500
FeedCacheRoomForGrowth | The amount of posts to delete when the number of posts for a given entity reaches FeedCacheObjectCountLimit. | 200

Use the following cmdlet with these parameters to make changes to the Feed Cache settings on the User Profile Service application:

For example, to set the FeedCacheTTLHours parameter, run the following cmdlet:

Copy code
$upa = Get-SPServiceApplication | where {$_.TypeName -Like "User Profile Service Application"}
$upa.FeedCacheTTLHours = 96
$upa.Update()

Where 96 represents the number of hours entities will stay in the Feed Cache.

The following cmdlets are available to force repopulation of the Feed Cache and the Last Modified Time Cache:

  • Update-SPRepopulateMicroblogLMTCache. This cmdlet must be run first.

  • Update-SPRepopulateMicroblogFeedCache.

Repopulate the Last Modified Time Cache by using timer jobs in Central Administration

The User Profile Service Application - Feed Cache Repopulation Job repopulates the Last Modified Time Cache if the Distributed Cache service resets and becomes empty. Also, after you configure My Sites, users will not see posts appearing in their consolidated newsfeed if the User Profile Service Application - Feed Cache Repopulation Job timer job is not configured to run. By default, the User Profile Service Application - Feed Cache Repopulation Job timer job is configured to run every 5 minutes.

Use this procedure to configure the User Profile Service Application - Feed Cache Repopulation Job timer job to monitor the Feed Cache and Last Modified Time Cache for repopulation.

Important:

Do not change the default settings of this timer job if you plan to use social features in SharePoint Server 2013. Do not disable this timer job. If this timer job is disabled and a repopulation is required, it will re-enable itself and run.

To configure the User Profile Service Application - Feed Cache Repopulation Job

  1. Verify that you have the following administrative credentials:

    • To configure timer jobs, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website.

  2. In Central Administration, on the Monitoring page, click Review job definitions.

  3. On the Job Definitions page, in the View list, select All.

  4. Use the arrows at the bottom of the page to locate the feed cache repopulation job for the User Profile service application on your server farm. The job name is in the format User_Profile_service_name - Feed Cache Repopulation Job, where User_Profile_service_name is the name that you specified for the User Profile service application.

  5. On the Edit Timer Job page, in the Recurring Schedule section, select the interval that you want the job to run. Available intervals are Minutes, Hourly, Daily, Weekly, and Monthly. Selecting a shorter interval, such as Minutes or Hourly, ensures that checks for an empty cache is performed more frequently. Selecting a longer interval, such as Daily, Weekly, or Monthly, reduces the number of times the job runs. However, it also means that performing cache repopulation checks are done fewer times. We recommend that this timer job runs on shorter intervals.

  6. Click Enable.

  7. Optionally, click Run Now to run the job immediately without waiting for the next scheduled interval.

Repopulate the Feed Cache and Last Modified Time Cache by using Windows PowerShell cmdlets

You can use Windows PowerShell cmdlets to perform the repopulation of the Feed Cache and the Last Modified Time Cache. To perform repopulation, we recommend that you configure the User Profile Service Application - Feed Cache Repopulation Job timer job as described above. This is because the timer job first checks to see whether the cache is empty and then repopulates the cache as necessary, whereas the Windows PowerShell cmdlets force a repopulation of the cache. However, in some instances, using the Windows PowerShell cmdlets is the only way to repopulate the cache. These instances include the following:

  • After attaching a new content database and the cache is not repopulating.

  • After restoring a content database.

The following cmdlets are available to force repopulation of the Feed Cache and the Last Modified Time Cache:

  • Update-SPRepopulateMicroblogLMTCache. This cmdlet must be run first.

  • Update-SPRepopulateMicroblogFeedCache.

See also

Configure microblogging in SharePoint Server 2013

Change History

Date | Description
February 19, 2013 | Added new section: "Feed Cache settings on the User Profile Service application."
July 16, 2012 | Initial publication


Manage the Distributed Cache service in SharePoint Server 2013
See also

Updated: February 19, 2013

Summary: Learn how to configure and manage the Distributed Cache service in SharePoint Server 2013.

Applies to: SharePoint Server 2013

To perform management and operational tasks on the Distributed Cache service in SharePoint Server 2013, an administrator must perform specific, ordered procedures. This article describes how to conduct several management and operational tasks on the Distributed Cache service.

Important:

The Distributed Cache service can end up in a nonfunctioning or unrecoverable state if you do not follow the procedures that are listed in this article. In extreme scenarios, you might have to rebuild the server farm. The Distributed Cache depends on Windows Server AppFabric as a prerequisite. Do not administer the AppFabric Caching Service from the Services window in Administrative Tools in Control Panel. Do not use the applications in the folder named AppFabric for Windows Server on the Start menu.

To learn more about planning, installing, and configuring the Distributed Cache service in a SharePoint Server 2013 farm, see the model Planning and using the Distributed Cache service.

Model: Plan the Distributed Cache service

In this article:

  • Start and stop the Distributed Cache service

  • Change the memory allocation of the Distributed Cache service

  • Add or remove a server in a Distributed Cache cluster

  • Perform a graceful shutdown of the Distributed Cache service

  • Change the service account

  • Repair a cache host

Start and stop the Distributed Cache service

An administrator that performs maintenance and operational tasks might need to start and stop the Distributed Cache service. Some of these tasks include the following:

  • Changing the default configuration of the server farm at installation time. The Distributed Cache service is started on all SharePoint servers at installation time. An administrator might want to stop the Distributed Cache service on some servers in the farm.

  • Updating the server and there is only one Distributed Cache server in the SharePoint Server 2013 farm.

Stopping the cache results in partial data loss. The Feed Cache depends on the Distributed Cache service. Tags and document activities are saved only to the Feed Cache. Tags and document activities are not persisted to content databases. When the Distributed Cache service is stopped, tags and document activities are lost. When the Distributed Cache service is started, repopulation occurs when the feed cache repopulation timer job runs. For more information, see Manage Feed Cache and Last Modified Time Cache repopulation in SharePoint Server 2013. One way to maintain the tags and document activities is to use the method described in Perform a graceful shutdown of the Distributed Cache service later in this article. When the graceful shutdown of the Distributed Cache service method is used, all cache data is moved from one server to another server before the Distributed Cache service is stopped.

Note:

If your cache hosts are part of a cache cluster, do not start or stop the Distributed Cache service as described here. Instead, see Add or remove a server in a Distributed Cache cluster later in this article.

To start and stop the Distributed Cache service by using Central Administration

  1. In Central Administration, click Application Management.

  2. In Service Applications, click Manage Services on Server.

  3. On the Services on Server page, locate the Distributed Cache service.

  4. If the Distributed Cache service is started and you want to stop the service, under Action, click Stop. If the Distributed Cache service is stopped and you want to start the service, under Action, click Start.

To start the Distributed Cache service by using Windows PowerShell

At the Windows PowerShell command prompt, run the following command:

Copy code
$instanceName ="SPDistributedCacheService Name=AppFabricCachingService"
$serviceInstance = Get-SPServiceInstance | ? {($_.service.tostring()) -eq $instanceName -and ($_.server.name) -eq $env:computername}
$serviceInstance.Provision()

To stop the Distributed Cache service by using Windows PowerShell

At the Windows PowerShell command prompt, run the following command:

Copy code
$instanceName ="SPDistributedCacheService Name=AppFabricCachingService"
$serviceInstance = Get-SPServiceInstance | ? {($_.service.tostring()) -eq $instanceName -and ($_.server.name) -eq $env:computername}
$serviceInstance.Unprovision()

Change the memory allocation of the Distributed Cache service

When SharePoint Server 2013 is installed, it assigns the Distributed Cache service 10 percent of the total physical memory on the server. The Distributed Cache service uses half of that memory allocation for data storage (also known as cache size), and the other half of that memory allocation is used for memory management overhead. When the cached data grows, the Distributed Cache service uses the entire 10 percent of the allocated memory.

You should increase the memory allocation of the Distributed Cache service in these scenarios:

  • When you add physical memory to the server. The Distributed Cache service does not automatically recalculate the 10% memory allocation, so when you increase the total physical memory on the server, you have to manually increase the Distributed Cache service's memory allocation.

  • When your server farm has a dedicated Distributed Cache server. Use the following method to calculate how much memory can be assigned to the Distributed Cache service:

    1. Determine the total physical memory on the server. For this example, we will use 16 GB as the total physical memory available on the server.

    2. Reserve 2 GB of memory for other processes and services that are running on the cache host. For example, 16 GB - 2 GB = 14 GB. This remaining memory is allocated to the Distributed Cache service.

    3. Take half of the remaining memory, and convert it to MB. For example, 14 GB/2 = 7 GB or 7000 MB. This is the cache size of the Distributed Cache service.

    4. Use the following procedure to update the memory allocation accordingly.

Change the memory allocation of the Distributed Cache

Use this procedure to reconfigure the memory allocation of the cache size of the Distributed Cache service.

  1. (Optional) To check the existing memory allocation for the Distributed Cache service on a server, run the following command at the Windows PowerShell command prompt:

    Copy code
    Use-CacheCluster
Get-AFCacheHostConfiguration -ComputerName ComputerName -CachePort "22233"

    Where:

    • ComputerName is the computer name of the server that you are running the PowerShell cmdlet on.

  2. Stop the Distributed Cache service on all cache hosts. To stop the Distributed Cache service, go to Services on Server in Central Administration, and Stop the Distributed Cache service on all cache hosts in the farm.

  3. To reconfigure the cache size of the Distributed Cache service, run the following command one time only on any cache host at the Windows PowerShell command prompt:

    Copy code
    Update-SPDistributedCacheSize -CacheSizeInMB CacheSize

    Where:

    • CacheSize is the cache size's memory allocation assignment in MB. In the previous example, the cache size was calculated at 7000 MB for a server with 16 GB of total memory.

  4. Restart the Distributed Cache service on all cache hosts. To restart the Distributed Cache service, go to Services on Server in Central Administration, and Start the Distributed Cache service on all cache hosts in the farm.

Add or remove a server in a Distributed Cache cluster

An administrator can add or remove a server to a cache cluster, or might want to remove a server from the cache cluster, perform some operational or maintenance tasks on the server, and then rejoin or add the server to the cache cluster. When removing the server, the Distributed Cache service is stopped, then unregistered from the server. Unregistering the Distributed Cache service means that an administrator will not see the Distributed Cache service listed on the Services on Server page in Central Administration. Similarly, when a server is added, the Distributed Cache service is registered and then is started on the server. Registering the Distributed Cache service means that an administrator will see the Distributed Cache service listed on the Services on Server page in Central Administration.

Use the following procedures to add and remove a server from a cache cluster. These Windows PowerShell cmdlets are run on the server being added or removed.

Note:

Before performing the following procedures, ensure the firewall allows Inbound ICMP (ICMPv4) traffic through it. For more information, see Firewall configuration considerations.

Add a server to the cache cluster and starting the Distributed Cache service by using a Windows PowerShell

At the Windows PowerShell command prompt, run the following command:

Copy code
Add-SPDistributedCacheServiceInstance

Remove a server from the cache cluster by using a Windows PowerShell

At the Windows PowerShell command prompt, run the following command:

Copy code
Remove-SPDistributedCacheServiceInstance
Important:

This procedure will stop the cache service and nonpersisted cached data will be lost. If you want to keep the cached data, use the graceful shutdown procedure that is described in the next section, and then run the Remove-SPDistributedCacheServiceInstance cmdlet. The Remove-SPDistributedCacheServiceInstance cmdlet involves stopping and disabling the underlying AppFabric Caching service. Do not restart the AppFabric Caching service other than by running the Add-SPDistributedCacheServiceInstance cmdlet.

Perform a graceful shutdown of the Distributed Cache service

In a SharePoint Server 2013 farm, a cache cluster exists when one or more cache hosts run the Distributed Cache service. In a SharePoint Server 2013 farm, one cache exists, and the cache spans the cache cluster. An administrator can take a cache host out of the cluster to perform operational or maintenance tasks on the server, such as applying updates to the server. To prevent data loss associated with the removal of the cache host from the cache cluster, an administrator must first run the graceful shutdown procedure before removing the cache host from the cache cluster. The graceful shutdown procedure is run on the cache host being removed from the cache cluster. This cache host stores a portion of the cached data. The graceful shutdown procedure transfers all cached data from the cache host on which the graceful shutdown procedure is being run on to another cache host in the farm. The transfer process takes 15 minutes or more to run depending on how many items exist in the cache. When the transfer process is complete, removing the cache host by using the Remove-SPDistributedCacheServiceInstance cmdlet does not result in any data loss.

To perform a graceful shutdown of the Distributed Cache by using Windows PowerShell

At the Windows PowerShell command prompt, run the following command:

Copy code
Stop-SPDistributedCacheServiceInstance -Graceful
Remove-SPDistributedCacheServiceInstance
Note:

To rejoin or add the server to the cache cluster, run the Add-SPDistributedCacheServiceInstance cmdlet.

Change the service account

When the server farm is first configured, the server farm account is set as the service account of the AppFabric Caching service. The Distributed Cache service depends on the AppFabric Caching service. To change the service account of the AppFabric Caching service to a managed account:

  1. Create a managed account. For more information, see Configure automatic password change (SharePoint Server 2010).

  2. Set the Managed account as the service account on the AppFabric Caching service. At the Windows PowerShell command prompt, run the following command:

    Copy code
    $farm = Get-SPFarm
$cacheService = $farm.Services | where {$_.Name -eq "AppFabricCachingService"}
$accnt = Get-SPManagedAccount -Identity domain_name\user_name
$cacheService.ProcessIdentity.CurrentIdentityType = "SpecificUser"
$cacheService.ProcessIdentity.ManagedAccount = $accnt
$cacheService.ProcessIdentity.Update()
$cacheService.ProcessIdentity.Deploy()

    Where Domain_name\user_name is the domain name and user name of the managed account.

Repair a cache host

During installation, configuration, or maintenance activities, the Distributed Cache service might enter a non-functioning state. Evidence of a malfunctioning Distributed Cache service will appear in Health Rules in Central Administration, or when users use features in SharePoint Server 2013 that rely on the Distributed Cache. For example, the Newsfeed on a user's My Site will start reporting errors. Also, administrators might receive the error message "cacheHostInfo is null " when they run Windows PowerShell cmdlets to manage the Distributed Cache service.

Use the following procedure to restore a non-functioning Distributed Cache host.

  1. At the Windows PowerShell command prompt, run the Get-SPServiceInstance cmdlet to list all services on all servers in the server farm. Make note of the GUID in the ID property of the Distributed Cache service on the server that you are repairing. The Get-SPServiceInstance cmdlet lists all services on all servers in the server farm. Ensure that you note the correct GUID from the server that you are repairing.

  2. At the Windows PowerShell command prompt, run the following command:

    Copy code
    $s = Get-SPServiceInstance GUID
$s.delete()

    Where GUID is the GUID of the Distributed Cache service noted in step 1.

  3. At the Windows PowerShell command prompt, run Add-SPDistributedCacheServiceInstance to reinstall and start the Distributed Cache service on the cache host that you are repairing.

See also

Plan for feeds and the Distributed Cache service in SharePoint Server 2013

Change History

Date | Description
February 19, 2013 | Added an optional step to reconfigure the memory allocation of the Distributed Cache service, added a note about Inbound ICMP (ICMPv4) traffic, and added a new section: "Repair a cache host."
July 16, 2012 | Initial publication


Configure My Sites in SharePoint Server 2013
See also

Summary: Learn how to set up and configure My Sites in SharePoint Server 2013 Preview.

Applies to: SharePoint Server 2013

This article describes how to set up My Sites in SharePoint Server 2013. Like other tasks in SharePoint Server, there are multiple ways to complete a task. This article provides ordered tasks with prerequisites and procedures to help you set up My Sites in your enterprise.

Before you set up My Sites, ensure that you understand the concepts and terminology in My Sites overview (SharePoint Server 2010) and Plan for My Sites in SharePoint Server 2013.

We recommend that you perform all of the procedures in the order listed for best results, although not all of them are required.

In this article:

  • Prerequisites

  • Create a My Site host site collection

  • Add a wildcard inclusion managed path to the web application

  • Connect the web application to service applications

  • Enable self-service site creation for the web application

  • Configure My Site settings for the User Profile service application

  • Enable the User Profile Service Application - Activity Feed Job

  • Next steps

Prerequisites

Because My Sites have dependencies on other service applications and features in SharePoint Server 2013, ensure that you meet the prerequisites in this section before you perform the procedures in this task.

Note:

My Sites are hosted by a web application and rely on a User Profile service application. Both are described in this section. My Sites also requires a managed metadata service application. We recommend that you also have a Search service application to use with My Sites, but this is not required. Without the Search service application, some My Sites functionality is affected. For more information, see Related service applications in Plan for My Sites in SharePoint Server 2013.

Web application

Although you can use an existing web application, for optimal performance and security, we recommend that you create the My Site host site collection in a dedicated web application. For more information, see Create a Web application (SharePoint Server 2010).

Important:

If a My Site host site collection was created during initial deployment and configuration, we recommend that you do not use it because it was created in the default web application. Delete this site collection, and create a new web application that is dedicated to hosting My Sites. Then create a new My Site host site collection in the dedicated web application.

User Profile service application and profile synchronization

Ensure you have a User Profile service application that you want to use for My Sites. If you do not, follow the steps in Create, edit, or delete User Profile service applications in SharePoint Server 2013 to create one.

Important:

Although the Create New User Profile service application dialog box requests information in the My Site Host URL and Personal Site Location sections, for this task, remove any default values and leave those fields blank when you create the User Profile service application. Additionally, you can select any of the options in Site Naming Format. These settings will be configured separately later in this task.

Optionally, configure profile synchronization if you want to synchronize user and group profile information that is stored in the SharePoint Server 2013 profile database with profile information that is stored in a directory service or business system. For more information, see Plan profile synchronization for SharePoint Server 2013.

Create a My Site host site collection

The My Site host site collection is a site collection that uses the Enterprise site template named My Site Host. This site collection must be created in the web application that you want to host My Sites. Generally, this site collection can be created at the root path of the web application, although it can be created as an explicit inclusion managed path deeper in the URL as long as there is a site collection created at the web application root. For more information about how to select the path for the My Site host collection, see My Sites architecture in Plan for My Sites in SharePoint Server 2013.

To create a My Site host site collection

  1. Verify that you have the following administrative credentials:

    • To create a My Site host site collection, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website or a service application administrator for the services related to My Sites. If you are a service application administrator, you must also have permission to create site collections in the web application that you dedicate to host My Sites.

  2. In Central Administration, click Application Management, and then click Create site collections.

  3. On the Create Site Collection page, in the Web Application section, ensure that the selected web application is the web application that you want to host My Sites. If it is not, expand the list, and then click Change Web Application. In the Select Web Application dialog box, select a different web application.

  4. In the Title and Description section, type a title and description for the site collection.

  5. In the Web Site Address section, select the URL where you want this site collection created. Generally, you should use the default path (which is displayed as / in the user interface), which is the root of the web application. For more information about this path, see My Sites architecture in Plan for My Sites in SharePoint Server 2013.

  6. In the Template Selection section, in the Select experience version list, select 2013. Then, on the Enterprise tab, click My Site Host.

  7. In the Primary Site Collection Administrator section, and optionally in the Secondary Site Collection Administrator section, type an account in the format domain\username to specify an administrator for the site collection.

  8. Optionally, in the Quota Template section, select a quota template for the My Site host site collection. This quota template does not affect the individual site collections that users create for their My Sites. For more information, see Planning for storage requirements in Plan for My Sites in SharePoint Server 2013.

  9. Click OK. Copy this site collection URL for later reference.

Add a wildcard inclusion managed path to the web application

The wildcard inclusion managed path is the path under which separate site collections are created for a user's My Site. Creation of the site collection occurs the first time that a user views the user's My Site. This functionality is available only when self-service site creation is also enabled. Enabling self-service site creation is discussed later in this article. For more information about managed paths, see Define managed paths (SharePoint Server 2010).

To add a wildcard inclusion managed path to the web application

  1. Verify that you have the following administrative credentials:

    • To add managed paths, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website.

  2. In Central Administration, click Application Management, and then click Manage Web applications.

  3. On the Web Applications Management page, select the web application that you created to host My Sites.

  4. On the Web Applications tab, in the Manage group, click Managed Paths.

  5. In the Define Managed Paths dialog box, in the Add a New Path section, in the Path box, type the path that you want to append to the URL namespace, and then select Wildcard inclusion. For example, if your web application URL is http://mysites.contoso.com/ and you want users' individual site collections created under a path named "personal", type personal in the Path box. Separate My Sites site collections will be created for each user under http://mysites.contoso.com/personal/.

  6. Click Add Path, and then click OK.

  7. Copy this managed path for later reference.

Connect the web application to service applications

The web application that hosts My Sites must be connected to service applications in SharePoint Server 2013. The User Profile service application is required for My Sites. The managed metadata service application and Search service application are highly recommended. For more information, see My Sites architecture in Plan for My Sites in SharePoint Server 2013.

Additionally, if you have other SharePoint sites from which you want users to be able to access their My Site and About Me links from the upper-right corner menu, connect the web applications of those sites to the User Profile service application.

To connect the web application to service applications

  1. Verify that you have the following administrative credentials:

    • To connect a web application to a service application, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website.

  2. In Central Administration, in the Application Management section, click Manage Web applications.

  3. On the Web Applications Management page, select the web application that you created to host My Sites.

  4. On the Web Applications tab, in the Manage group, click Service Connections.

  5. In the Configure Service Application Associations dialog box, in the Edit the following group of connections list, select default if the default group contains the service applications that you want to connect to the web application.

    • If you choose [Custom], select any service applications to which you want to connect the web application, including the User Profile service application, the managed metadata service application, and the Search service application.

  6. Click OK.

Enable self-service site creation for the web application

Self-service site creation enables the automatic creation of a separate site collection for users when they first view their My Site.

To enable self-service site creation for the web application

  1. Verify that you have the following administrative credentials:

    • To enable self-service site creation, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website.

  2. In Central Administration, in the Application Management section, click Manage Web applications.

  3. On the Web Applications page, select the web application that you created to host My Sites.

  4. On the Web Applications tab, in the Security group, click Self-Service Site Creation.

  5. In the Self-Service Site Creation Management dialog box, in Site Collections, select On. Optionally, in Quota template to apply, select a quota template.

  6. In Start a Site, choose one of the following options:

    1. Prompt users to create a team site under so users can create team sites from their My Site to use site feeds.

    2. Be hidden from users if you do not want users to create team sites from their My Sites to use site feeds.

  7. Click OK to finish.

Perform these additional steps to configure permissions for users to create team sites from their My Sites to use site feeds.

  1. In the Policy group, click Permission Policy.

  2. On Manage Permission Policy Levels dialog box, click Add Permission Policy Level.

  3. Type a name for the permission policy.

  4. Under Permissions, in Site Permissions, select the Grant option for Create Subsites - Create subsites such as team sites, Meeting Workspace sites, and Document Workspace sites.

  5. Click Save.

  6. In the Policy group, click User Policy.

  7. On Policy for Web Application dialog box, click Add Users.

  8. On Add Users, in Zones select (All Zones), then click Next.

  9. In Choose Users, enter the user names of the users that you want to create team sites from their My Site to use site feeds. If all users can create team sites from their My Site to use site feeds, click the Browse icon. In Select People and Groups, click All Users, then click Everyone. Click Add, and then click OK.

  10. In the Choose Permissions section, select the name of the Permission Policy created previously.

  11. Click Finish, and then click OK.

Configure My Site settings for the User Profile service application

After you have a My Site host site collection and wildcard inclusion managed path configured for My Sites, you can update the My Sites settings in the User Profile service application. Most of these settings are configured during initial deployment and only change infrequently during maintenance operations afterward.

To configure My Site settings for the User Profile service application

  1. Verify that you have the following administrative credentials:

    • To configure My Site settings for the User Profile service application, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website or a service application administrator for the User Profile service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the User Profile service application that you connected to the web application hosting My Sites earlier in this task.

  4. On the Manage Profile Service page, in the My Site Settings section, click Setup My Sites.

  5. On the My Sites Settings page, in the Preferred Search Center section, specify settings for the search center to direct users to when they search for people or documents from their About Me profile page. If you do not have a search center set up yet, you can skip this step and complete it later. For more information, see Search service application in Plan for My Sites in SharePoint Server 2013.

  6. In the My Site Host section, type the URL of the My Site host site collection that you created earlier in this task.

  7. The My Site Host URL in Active Directory section uses Exchange Autodiscover to allow client and mobile phone applications to find a user's SharePoint Server 2013 My Site. For more information, see Configure Exchange Autodiscover with a My Site Host URL in SharePoint Server 2013

  8. In the Personal Site Location section, type the wildcard inclusion managed path you configured earlier in this task. By default, personal is prepopulated in the box. However, if you chose a different path for your wildcard inclusion managed path, replace personal with your path.

  9. In the Site Naming Format section, select a naming format for the My Sites site collections that will be created when users view their My Sites for the first time. For more information about these formats, see My Sites architecture in Plan for My Sites in SharePoint Server 2013.

  10. In the Language Options section, specify whether users can select a preferred language for their My Site. The available languages correspond to the language packs installed in the farm. All servers in a farm must have the same language packs. For more information about multilingual sites, see Plan for multilingual sites (SharePoint Server 2010). For more information about language packs, see About language IDs and language packs in Install or uninstall language packs for SharePoint 2013.

  11. In the Read Permission Level section, specify the users or groups that can view other users' My Sites when they are created. By default, this includes all authenticated users. However, you can select a more specific group or users depending on the needs of your deployment.

  12. In the Security Trimming Options section, specify how system generated posts are checked for permissions before they are displayed in feeds and on the Tags and Notes page.

  13. In the Newsfeed section, enable system generated posts to the feed on My Sites by selecting Enable activities in My Site newsfeeds. This option is selected by default. This is important in hosted environments where tenants can share the same User Profile service but have different requirements on whether they can enable newsfeeds for their users.

    When upgrading from a SharePoint Server 2010 server farm that uses the newsfeed and tags and notes, you enable these legacy features on your SharePoint Server 2013 server farm by selecting Enable SharePoint 2010 activity migration.

  14. In the E-mail Notifications section, specify an email address to use as the sender email address for My Site email notifications. This account does not have to be a real monitored email address. If you want to receive notifications for newsfeed activities, such as replies to your posts or when someone follows you, select Enable newsfeed email notifications.

    Important:

    You must add the IP address of the farm's outbound SMTP server to the safe list in Exchange Server 2013 to prevent My Site email notifications from being sent to the Junk folder. For more information about safe lists in Exchange Server 2013, see Understanding Connection Filtering in the Exchange Server Technical Library.

  15. In the My Site Cleanup section, specify a new owner of a My Site if the existing My Site user is removed from the profile database. For example, if a user leaves the company and is no longer in the profile database, the user's My Site will be deleted together with any content. However, before it is deleted, a new owner can recover any important content. Select Enable access delegation for the My Site cleanup job to first attempt to assign ownership of the My Site to the user's manager. If no manager is found, the My Site is assigned to the user specified in Secondary Owner. The new owner has two weeks to retrieve content from the My Site before it is deleted.

  16. In the Privacy Settings section, select Make My Sites Public to make all users' My Sites public. This option is not selected by default.

    Note:

    When a user's My Site is public, the user's list of followers, the user's list of people they are following, and all activities (including new follow notifications, social tagging and rating of content, birthdays, job title changes, workplace anniversary, updating Ask Me About, posting on a note board, and new blog posts) will be public. Any policies set within People and Privacy on the Manage Policies page is overridden.

  17. Click OK.

For more information about additional timer jobs for My Sites, see Planning for jobs and schedules in Plan for My Sites in SharePoint Server 2013.

Enable the User Profile Service Application - Activity Feed Job

The User Profile Service Application - Activity Feed Job creates system generated posts in the feeds for the following events:

  • Following a tag

  • Tagging an item

  • Birthday celebration

  • Job title change

  • Workplace anniversary

  • Updates to Ask Me About

  • Posting on a note board

After you configure My Sites, enable the User Profile Service Application - Activity Feed Job so that users receive system generated posts in the Newsfeed on their My Sites.

There are other timer jobs related to My Sites that you might want to review and change default settings for. For more information about jobs related to My Sites functionality, see Planning for jobs and schedules in Plan for My Sites in SharePoint Server 2013.

To enable the User Profile Service Application - Activity Feed Job

  1. Verify that you have the following administrative credentials:

    • To configure timer jobs, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website.

  2. In Central Administration, click Monitoring, and then click Review job definitions.

  3. On the Job Definitions page, in the View list, select Service. The Service list appears.

    • If the Service list does not display User Profile Service, in Service, click No selection, then click Change Service. On the Select Service page, use the arrows in the upper-right corner to locate User Profile Service, and then click it. The Job Definitions page updates with the User Profile service jobs.

  4. Click the activity feed job for the User Profile service application that you created in Prerequisites earlier in this article. The job name is in the format User_Profile_service_name - Activity Feed Job, where User_Profile_service_name is the name that you specified for your User Profile service application.

  5. On the Edit Timer Job page, in the Recurring Schedule section, select the interval that you want the job to run. Available intervals are Minutes, Hourly, Daily, Weekly, and Monthly. Selecting a shorter interval, such as Minutes or Hourly, ensures that activities appear on users' My Site newsfeeds more frequently. However, it increases load on the system depending on how many activities are available. Selecting a longer interval, such as Daily, Weekly, or Monthly, reduces the number of times the job runs and processes feeds. However, it also means that users receive less frequent updates to activities in their newsfeeds.

  6. Click Enable.

  7. Optionally, click Run Now to run the job immediately without waiting for the next scheduled interval.

Next steps

After you configure My Sites by using the procedures in this article, consider whether you require the following optional procedures:

  • Configure trusted My Site host locations

  • Configure links to Office client applications

  • Add personalization site links on My Sites

  • Start related services

  • Configure microblogging

Configure trusted My Site host locations

Trusted My Site Host Locations is an optional feature that prevents a user from creating more than one My Site in an organization with multiple User Profile service applications. For more information, see Add or delete a trusted My Site host location (SharePoint Server 2010).

Configure links to Office client applications

Users' My Sites are convenient locations for users to save files that they work on in Office client applications, such as Word, Excel, and PowerPoint. After you configure an environment for My Sites, you can add a link to the Favorite Links section that users see when they save documents in the Save As dialog box in Office client applications. Users can then select their My Site and save files to the Documents library available on their My Site. For more information, see Add or delete links to Office client applications (SharePoint Server 2010).

Add personalization site links on My Sites

If your organization wants to provide important information to users, it can do so by adding personalization site links to a user's My Site. For more information, see Add or delete personalization site links on My Sites.

Start related services

If the related services for My Sites have not been started yet, start them so that My Sites functionality is available in your environment. For more information, see Manage services on the server (SharePoint Server 2010).

Configure microblogging

Setting up My Sites is the first step in configuring microblog features in SharePoint Server 2013. For more information about how to configure microblogging features in SharePoint Server 2013, see Configure microblogging in SharePoint Server 2013.

See also

Plan for My Sites in SharePoint Server 2013
Plan user profiles in SharePoint Server 2013
Overview of the User Profile service application in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013
Synchronize user and group profiles in SharePoint Server 2013

Manage My Sites settings (SharePoint Server 2010)
Configure personal and social features for My Sites (SharePoint 2013 Preview)
Resource Center: Social Computing in SharePoint Server 2013


Configure synchronization on all document libraries in SharePoint Server 2013
See also

Published: April 16, 2013

Summary: Learn how to add or remove synchronization from all document libraries in SharePoint Server 2013.

Applies to: SharePoint Server 2013

In SharePoint Server 2013, if a client workstation has Office 2013 installed, users can synchronize files that are stored in document libraries with their client workstations, and vice versa. The SkyDrive Pro Windows Sync client performs the synchronization of files between document libraries and the client workstation. When the SkyDrive Pro Windows Sync client synchronizes files to a client workstation, users take their files offline from SharePoint Server, work on them while offline, and then synchronize them with their document library when they reconnect to SharePoint Server 2013. Depending on your IT policy, users may not be allowed to take files offline from SharePoint Server and you must prohibit file synchronization. The following procedures explain how a farm administrator can add or remove synchronization on all document libraries on all sites in SharePoint Server 2013.

Important:

The following PowerShell cmdlets either add or remove synchronization from all document libraries in SharePoint Server 2013. Site collection administrators can manually change the Offline Client Availability setting under Site Settings after these PowerShell cmdlets are run. Select and educate site collection administrators appropriately because a site collection administrator who changes the Offline Client Availability setting may violate your corporate IT policy.

Remove synchronization

Use the following procedure to remove synchronization on all document libraries on all sites in SharePoint Server 2013. Running the following PowerShell cmdlet sets the Offline Client Availability setting to No on all sites in SharePoint Server 2013, and removes the Sync button from the ribbon.

To remove synchronization from all document libraries

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, run the following command:

    Copy code
    Get-SPSite -limit all | get-SPWeb -limit all | Foreach { $_.Title = $_.Title; $_.ExcludeFromOfflineClient=1; $_.Update() }

Add synchronization

Use the following procedure to add synchronization to all document libraries on all sites in SharePoint Server 2013. By default, synchronization is enabled on all document libraries. Running the following PowerShell cmdlet sets the Offline Client Availability to Yes on all sites in SharePoint Server 2013, and adds the Sync button on the ribbon.

To add synchronization to all document libraries

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, run the following command:

    Copy code
    Get-SPSite -limit all | get-SPWeb -limit all | Foreach { $_.Title = $_.Title; $_.ExcludeFromOfflineClient=0; $_.Update() }

See also

Overview of SkyDrive Pro in SharePoint Server 2013


Create and configure communities in SharePoint Server 2013
See also

Summary: Learn how to create Community Sites and Community Portals in SharePoint Server 2013.

Applies to: SharePoint Server 2013

You can create Community Sites and Community Portals in SharePoint Server 2013. Community Sites provide a discussion forum experience in the SharePoint environment. The Community Portal provides a directory of Community Sites for users to browse and search for communities of interest. Before you create Community Sites and Community Portals, understand the concepts and planning process in Overview of communities in SharePoint Server 2013 and Plan for communities in SharePoint Server 2013.

Important:

The steps in this article apply to SharePoint Server 2013.

In this article:

  • Before you begin

  • Create a Community Site

  • Create a Community Portal

  • Additional steps

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Verify that you have met the requirements in Phase 3: Plan the solution in Plan for communities in SharePoint Server 2013.

Create a Community Site

Use the following procedure to create a Community Site at the site collection level in SharePoint Server 2013.

To create a Community Site

  1. Verify that you have the following administrative credentials:

    • To create a site collection by using the Community Site template, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website or a service application administrator. If you are a service application administrator, you must also have permission to create site collections in the web application in which you create the Community Site.

  2. In Central Administration, click Application Management, and then click Create site collections.

  3. On the Create Site Collection page, in the Web Application section, ensure that the selected web application is the web application in which you want to create the Community Site. If it is not, expand the list, and then click Change Web Application. In the Select Web Application dialog box, select a different web application.

  4. In the Title and Description section, type a title and description for the site collection.

  5. In the Web Site Address section, select the URL where you want this site collection created.

  6. In the Template Selection section, in the Select experience version list, select 2013. Then, on the Collaboration tab, click Community Site.

  7. In the Primary Site Collection Administrator section, and optionally in the Secondary Site Collection Administrator section, type an account in the format domain\username to specify an administrator for the site collection.

  8. Optionally, in the Quota Template section, select a quota template.

  9. Click OK.

  10. Verification: After the site collection is created successfully, click the link to open the Community Site.

Create a Community Portal

Use the following procedure to create a Community Portal in SharePoint Server 2013. Community Portals can be created at only the site collection level.

To create a Community Portal

  1. Verify that you have the following administrative credentials:

    • To create a site collection by using the Community Portal template, you must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website or a service application administrator. If you are a service application administrator, you must also have permission to create site collections in the web application in which you create the Community Portal.

  2. In Central Administration, click Application Management, and then click Create site collections.

  3. On the Create Site Collection page, in the Web Application section, ensure that the selected web application is the web application in which you want to create the Community Portal. If it is not, expand the list, and then click Change Web Application. In the Select Web Application dialog box, select a different web application.

  4. In the Title and Description section, type a title and description for the site collection.

  5. In the Web Site Address section, select the URL where you want this site collection created.

  6. In the Template Selection section, in the Select experience version list, select 2013. Then, on the Enterprise tab, click Community Portal.

  7. In the Primary Site Collection Administrator section, and optionally in the Secondary Site Collection Administrator section, type an account in the format domain\username to specify an administrator for the site collection.

  8. Optionally, in the Quota Template section, select a quota template.

  9. Click OK.

  10. Verification: After the site collection is created successfully, click the link to open the Community Portal.

Additional steps

After you have created a Community Site or a Community Portal, consider the following additional steps to complete the configuration:

  • Create additional Community Sites as needed. You might create them at the site collection level, as in this procedure, or create them at the site level depending on what you determined during the planning phase.

  • Configure permissions for your Community Sites to make them private, closed, or open. For more information, see Community types in Plan for communities in SharePoint Server 2013.

  • Customize the Community Site. In particular, update the icon, title, and description of the site so that the Community Portal displays distinct information for each Community Site.

  • Run a search crawl so that it indexes the new site or sites, and populates the Community Portal with Community Sites. No communities appear on the portal until you run a crawl. Configure the incremental crawl schedule so that the Community Portal continues to display any new Community Sites, and so that members can search within communities and the portal.

See also

Overview of communities in SharePoint Server 2013
Plan for communities in SharePoint Server 2013


Enable or disable personal and social features for users or groups in SharePoint Server 2013
See also

Summary: Learn how to configure user permissions for personal and social features in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Farm Administrators or service administrators of a User Profile service application control who can create My Sites, and use personal and social features. For example, you might want a subset of users in an organization to be able to create My Sites, so you enable the Create Personal Site permission for those users. For more information, see Overview of the User Profile service application in SharePoint Server 2013.

Important:

Before you decide which permission to grant users or groups of users, first review the permission descriptions and how the combination of these permissions affects the My Site user experience. For more information, see Plan users and user permissions in Plan for My Sites in SharePoint Server 2013.

Before you perform this procedure, confirm the following:

  • A User Profile service application is running in the farm. For more information, see Create, edit, or delete User Profile service applications in SharePoint Server 2013.

Enable users or groups to use personal and social features

Use this procedure to configure the user permissions for personal and social features.

To enable users or groups to use personal and social features

  1. Verify that you have the following administrative credentials:

    • To use the SharePoint Central Administration website to enable users or groups to use personal and social features, you must be a member of the Farm Administrators group, or you must have been delegated permission to administer the User Profile service application that is running in the farm. For more information, see Delegate administration of User Profile service applications in SharePoint Server 2013.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. In the list of service applications, click User Profile Service Application.

  4. On the Manage Profile Service: User Profile Service Application page, in the People group, click Manage User Permissions.

  5. On the Permissions for User Profile Service Application page, type or select a user or group account, and then click Add.

  6. In the Permissions for box, check the feature or features that you want the user or group to be able to use, and then click OK.

See also

Plan for My Sites in SharePoint Server 2013


Remove recommendation Web Parts from My Sites in SharePoint Server 2013
See also

Published: January 15, 2013

Summary: Learn how to remove the Suggested sites to follow and Suggested documents to follow Web Parts in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

In SharePoint Server 2013, My Sites include Web Parts to display recommended sites and documents for users to follow. These Web Parts are called Suggested sites to follow and Suggested documents to follow. The information in these Web Parts originates from the search index. If you have not configured indexing on your farm, the Web Parts will not display anything. The recommendations for Suggested sites to follow and Suggested documents to follow are influenced by:

  • People, sites, and documents you already follow.

  • A site that is followed by many people.

  • The values of the Ask Me About and Followed #Tags properties on the user profile.

  • Any documents that you recently modified.

  • Sites followed by people that you follow.

Note:

If users do not update their user profile settings, documents viewed recently by three or more people are recommended to the user.

Depending on your company's policies and procedures, you may not want recommendations made to users about which sites and documents they should follow. An administrator cannot turn off the recommendations feature on the My Site. Instead, an administrator must remove the Suggested sites to follow and Suggested documents to follow Web Parts from the My Site.

Note:

All recommendations made in the Suggested sites to follow and Suggested documents to follow Web Parts are security trimmed.

Remove the Suggested sites to follow Web Part from a user's My Site

Use the following procedure to remove the Suggested sites to follow Web Part from a user's My Site.

To remove the Suggested sites to follow Web Part from a user's My Site:

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, enter the following command:

    Copy code
    Add-PsSnapin Microsoft.SharePoint.PowerShell
[System.Reflection.Assembly]::LoadWithPartialName("Microsoft.SharePoint.WebPartPages")
[System.Reflection.Assembly]::LoadWithPartialName("Microsoft.SharePoint.Publishing")

$useraccount = "useraccount"
$url = "http://" + [System.Net.Dns]::GetHostName() + "/my/personal/" + $useraccount
$site = get-spsite $url
$web = $site.RootWeb
$pageUrl= "Social/Sites.aspx"
$webPartManager =  $web.GetLimitedWebPartManager($pageUrl, [System.Web.UI.WebControls.WebParts.PersonalizationScope]::Shared);
$webPart = $webPartManager.WebParts | where-object { $_.WebBrowsableObject.GetType().Name -eq "ProjectSearchBrowseWebpart" }

if($webPart -ne $null)
{
    $webPartManager.DeleteWebPart($webPart)
}
$web.Update();

    Where:

    • $useraccount is set to the user's Active Directory account name for the user whose My Site the Web Part is being removed from.

Remove the Suggested documents to follow Web Part from a user's My Site

Use the following procedure to remove the Suggested documents to follow Web Part from a user's My Site.

To remove the Suggested documents to follow Web Part from a user's My Site:

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, enter the following command:

    Copy code
    Add-PsSnapin Microsoft.SharePoint.PowerShell
[System.Reflection.Assembly]::LoadWithPartialName("Microsoft.SharePoint.WebPartPages")
[System.Reflection.Assembly]::LoadWithPartialName("Microsoft.SharePoint.Publishing")

$useraccount = "useraccount"
$url = "http://" + [System.Net.Dns]::GetHostName() + "/my/personal/" + $useraccount
$site = get-spsite $url
$web = $site.RootWeb
$pageUrl= "Social/FollowedContent.aspx"
$webPartManager =  $web.GetLimitedWebPartManager($pageUrl, [System.Web.UI.WebControls.WebParts.PersonalizationScope]::Shared);
$webPart = $webPartManager.WebParts | where-object { $_.WebBrowsableObject.GetType().Name -eq "ProjectSearchBrowseWebpart" }

if($webPart -ne $null)
{
    $webPartManager.DeleteWebPart($webPart)
}
$web.Update();

    Where:

    • $useraccount is set to the user's Active Directory account name for the user whose My Site the Web Part is being removed from.

See also

Configure My Sites in SharePoint Server 2013


Integrate Yammer with on-premises SharePoint 2013 environments (white paper)

Published: July 2, 2013

Summary: Learn how to replace the social features in SharePoint Server 2013 with equivalent Yammer features in a SharePoint Server 2013 on-premises deployment.

Applies to: SharePoint Server 2013

This white paper helps you to use Yammer features in a SharePoint Server 2013 on-premises deployment. The new Yammerapp for SharePoint lets customers to embed their Yammer feeds into SharePoint Server 2013 sites making them more social and engaging. This white paper provides steps to replace the SharePoint Server 2013 social features with equivalent Yammer features by:

  • Removing the SharePoint Server social web parts from My Sites and Team Sites.

  • Hiding user interface controls that provide social functionality.

  • Discussing how to get, install and configure the Yammerapp for SharePoint to embed Yammer feeds (home feed, group feed, comment feed) into SharePoint sites.

Download the white paper by using the following link: Integrate Yammer with on-premises SharePoint 2013 environments.

See the following article if the Yammer App for SharePoint is not displaying as expected: SharePoint Server 2013 known issues.


Configure web content management solutions in SharePoint Server 2013

Published: September 4, 2012

Summary: Learn how to install and configure SharePoint web content management solutions that use cross-site collection publishing.

Applies to: SharePoint Server 2013

The articles that are listed in the following table describe how to set up cross-site publishing features in a SharePoint Server 2013 environment.

Building blocks Content Description

Configure cross-site publishing in SharePoint Server 2013

Learn how to create site collections for cross-site publishing, activate the Cross-Site Collection Publishing feature, create and manage term sets for tagging content on authoring sites, create catalog content by using SharePoint lists, share a library or list as a catalog, and configure search settings for cross-site publishing.

Connect a publishing site to a catalog in SharePoint Server 2013

Learn how to connect a publishing site to a library or list that is shared as a catalog.

Assign a category page and a catalog item page to a term in SharePoint Server 2013

Learn how to assign a category page and a catalog item page to a term in term store management.

Configure Search Web Parts in SharePoint Server 2013

Learn how to configure the following Web Parts that use search technology in a publishing environment:

  • Content Search Web Part

  • Refinement Panel Web Part

  • Taxonomy Refinement Panel Web Part

  • Recommended Items Web Part

Configure refiners and faceted navigation in SharePoint Server 2013

Learn how to map a crawled property to a refinable managed property, enable a managed property as a refiner, and configure faceted navigation.

Configure result sources for web content management in SharePoint Server 2013

Learn how to create and manage result sources for SharePoint Search service applications, and for SharePoint sites and site collections.

Create query rules for web content management in SharePoint Server 2013

Learn how to improve search results by creating and managing query rules for SharePoint Search service applications, and for SharePoint sites and site collections.

Configure recommendations and usage event types in SharePoint Server 2013

Learn how to create custom usage event types, how to add code to record usage events, and how to influence how recommendations are shown on a page.


Configure cross-site publishing in SharePoint Server 2013
See also

Published: September 4, 2012

Summary: Learn to create and tag catalog content in authoring sites and configure search settings for cross-site publishing in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Before you configure cross-site publishing, make sure that you understand the concepts and terminology in Plan for cross-site publishing in SharePoint Server 2013.

In this article:

  • Before you begin

  • Create site collections for cross-site publishing

  • Activate the Cross-Site Collection Publishing feature

  • Create and manage term sets for tagging content on authoring sites

  • Create catalog content by using SharePoint lists

  • Share a library or list as a catalog

  • Make a term set available to other site collections

  • Configure search for cross-site publishing

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Create site collections for cross-site publishing

In a cross-site collection publishing scenario where content is reused across site collections, you must have at least two site collections, one for authoring content and one for publishing content. Before you create the site collections, review the following information:

  • "Plan site collections and site structure for SharePoint authoring sites" in Plan authoring sites for cross-site publishing in SharePoint Server 2013.

  • "Plan site collections and site structure for SharePoint publishing sites" in Plan publishing sites for cross-site publishing in SharePoint Server 2013.

For information about how to create a site collection by using either Central Administration or Windows PowerShell, see Create a site collection in SharePoint 2013.

Activate the Cross-Site Collection Publishing feature

Before you can use cross-site collection publishing to reuse content across site collections, you have to activate the Cross-Site Collection Publishing feature on the authoring site collection.

Note:

If you used the Product Catalog Site Collection template to create the authoring site collection, you do not have to do this operation. By default, the Cross-Site Collection publishing feature is active when you create a site collection by using the Product Catalog Site Collection template.

To activate the Cross-Site Collection Publishing feature

  1. Verify that the user account that performs this procedure is a site collection administrator on the authoring site collection.

  2. On the top-level site of the authoring site collection, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Collection Administration section, click Site collection features.

  4. On the Site Collection Features page, next to Cross-Site Collection Publishing, click Activate.

Note:

Deactivating the Cross-Site Publishing feature on an authoring site will not remove the contents of a connected catalog from a publishing site. By deactivating this feature, you will no longer be able to modify existing catalog settings, or connect other publishing sites to catalogs within the site collection. To remove contents of a connected catalog from a publishing site, you have to disconnect the publishing site from the catalog. For more information, see Disconnect a publishing site from a catalog.

Create content for authoring sites

Before you create content for authoring sites, review "Plan term sets for tagging content on authoring sites" and "Plan catalog content for authoring sites" in Plan authoring sites for cross-site publishing in SharePoint Server 2013.

Create and manage term sets for tagging content on authoring sites

You create and manage term sets by using the Term Store Management Tool. For information about how to create and manage term sets, see the following articles:

  • Set up a new term set

  • Create and manage terms in a term set

After you have created a term set, you have to make it available for tagging content. If you used the Product Catalog Site Collection template to create the authoring site collection, and you have created a term set in this site collection, you do not have to do this operation. By default, new term sets created in the Product Catalog site collection are available for tagging content.

To make a term set available for tagging content

  1. Verify that the user account that performs this procedure is a member of the Owners SharePoint group on the authoring site that contains the catalog.

  2. On the authoring site, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Administration section, click Term store management.

  4. In the TAXONOMY TERM STORE section, click the term set that you want to make available for tagging.

  5. Click the INTEDED USE tab, and then select Available for Tagging.

  6. Click Save.

Create catalog content by using SharePoint lists

When you create catalog content by using SharePoint lists, we recommend that you create site columns for the lists in which you want to maintain your catalog content. This is because managed properties are automatically created for site columns, and you can use these managed properties when defining queries for you catalog content on a publishing site. If you have several lists, we recommend that you create a site content type for each list, and then associate the appropriate site columns to this site content type. If you want to use managed navigation to display catalog content on a publishing site, you also have to create at least one term set as described in Create and manage term sets for tagging content on authoring sites. The tagging term set must be tied to a site column that is a Managed Metadata data type.

For information about how to create site content types and site columns, see the following articles:

  • Create or customize a content type

  • Create a site column

  • Create a managed metadata column

If you have large amounts of data in external business systems — for example, an ERP system — consider importing this data into one or more SharePoint lists. SharePoint Server 2013 does not have a solution for importing list content. However, you can develop custom import tools — for example, by using Windows PowerShell. For a set of example Windows PowerShell scripts that you can use to import list content for cross-site publishing, see Import list content to Products list for SharePoint 2013 Preview. The example scripts import content only to a site collection that was created by using the Product Catalog Site Collection template.

Share a library or list as a catalog

Before you share a library or list as a catalog, verify that the Cross-Site Collection Publishing feature is activated for the site collection. If you used the Product Catalog Site Collection template to create the site collection, the Cross-Site Collection Publishing feature is already active. For all other types of site collections, you must activate the Cross-Site Collection Publishing feature before you can continue with the following steps. For more information, see Activate the Cross-Site Collection Publishing feature earlier in this article.

By default, anonymous access is enabled when you share a library or list as a catalog. If you have connected a publishing site to the catalog, and you don't want anonymous users to be able to view and search content that was added to the search index from this catalog, you should disable anonymous access.

Important:

In addition to enabling anonymous access for a catalog, you must enable anonymous access for the web application and publishing site so that anonymous users can search and view the content. For more information, see Create claims-based web applications in SharePoint 2013.

To share a library or list as a catalog

  1. Verify that the user account that performs this procedure is a member of the Owners group on the site that contains the library or list that you want to share.

  2. Browse to the library or list that you want to share, and then do one of the following:

    • To share a library, click the LIBRARY tab, and then, on the ribbon, in the Settings group, click Library Settings.

    • To share a list, click the LIST tab, and then, on the ribbon, in the Settings group, click List Settings.

  3. On the Settings page, in the General Settings section, click Catalog Settings.

  4. On the Catalog Settings page, in the Catalog Sharing section, select the Enable this library as a catalog check box.

  5. In the Anonymous Access section, if you want don't want anonymous users to view and search this content, click Disable anonymous access.

  6. In the Catalog Item URL Fields section, in the Available fields box, select up to five fields that uniquely identify an item in the library or list, and then click Add.

    After you connect a publishing site to this catalog, the fields that you specified as catalog item URL fields appear as part of the friendly URL. (See the example that follows this procedure.)

  7. In the Navigation Hierarchy section, select the column that is associated with the term set that you want to use as a navigation term set for catalog pages. After you connect a publishing site to this library or list to show catalog content, the value of the column that you selected appears as part of the friendly URL (see the example that follows this procedure).

    Note:

    You only have to make a selection in this section if you want to use managed navigation to display catalog content on a publishing site.

  8. Click OK.

    Note:

    After you share a library or list as a catalog, the content source that contains the catalog must be crawled. You don't have to start a full crawl. This is because an incremental crawl or a continuous crawl also adds the content to the search index. For more information, see Start, pause, resume, or stop a crawl in SharePoint Server 2013.

In this example, let's say that you have a list that contains data for different electronic products. The following items were specified when the list was shared as catalog:

  • Electronic products

    • Audio

      • Car audio

      • MP3

    • Computers

      • Laptops

      • Desktops

Each item in the shared list is associated with a value from this term set in the Item Category Managed Metadata site column. For more information about Managed Metadata columns, see Create a Managed Metadata column.

The following table describes how site columns and their corresponding values in the previous list are combined to create friendly URLs for catalog content when you connect a publishing site collection to this list.

Product title | Item Category | Item Number | Friendly URL to an item when the catalog is connected to a publishing site
Proseware 50W Car Radio | Car audio | 1010101 | <site>/audio/car-audio/1010101
Contoso 4GB Portable MP3 Player M450 | MP3 | 4020102 | <site>/audio/mp3/4020102
AdventureWorks Laptop8.9 E0890 | Laptops | 7030906 | <site>/computers/laptops/7030906
WWI Desktop PC2.33 X2330 | Desktops | 7030906 | <site>/computers/desktops/3030802

Make a term set available to other site collections

After you create a term set on the authoring site collection, you have to make it available to publishing site collections. You can make a term set available to all site collections or to specific site collections.

To make a term set available to all site collections

  1. Verify that the user account that performs this procedure is a member of the Owners SharePoint group on the authoring site that contains the catalog.

  2. On the authoring site, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Administration section, click Term store management. If the user that performs this procedure is already a member of the Term Store Administrators group, you can skip to step 7.

  4. In the Term Store Management Tool, verify that Managed Metadata Service is selected.

  5. In the Term Store Administrator section, type one or more user names.

  6. Click Save.

  7. Right-click Managed Metadata Service, and then select New Group.

  8. Type the name of the global term set that you want to create, and then press Enter.

  9. Refresh the page.

  10. Right-click the term set that you want to make available to all site collections, and then click Move Term Set.

  11. In the Term Set Move dialog box, click the global term set that you want to move the term set to, and then click OK.

  12. Refresh the page.

To make a term set available to specific site collections

  1. Verify that the user account that performs this procedure is a member of the Owners SharePoint group on the authoring site that contains the catalog.

  2. On the authoring site, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Administration section, click Term store management.

  4. In the Term Store Management Tool, click the group that contains all term sets within the site collection.

  5. In the Site Collection Access section, type the URLs of the site collections to which you want to make the term set available — for example, http://<site>/sites/products.

  6. Click Save.

Configure search for cross-site publishing

Because cross-site publishing depends on search, you have to create a content source and manage crawling for SharePoint cross-site publishing sites.

A content source specifies what, when, and how content should be crawled. When a Search service application is created, a content source named Local SharePoint sites is created and is automatically configured to crawl all SharePoint sites in the local server farm. You can create additional content sources to specify other content to crawl and define how SharePoint should crawl that content. You do not have to create a separate content source for catalog content in order to make content available to other site collections. However, it is easier to maintain crawl schedules when you have separate content sources for the different content that you want users to view and search.

The ability to enable continuous crawls is a new crawl schedule option in SharePoint 2013. When you enable continuous crawls, any changes that are made to content within the specified content source is picked up automatically by the crawler and added to the search index. A continuous crawl starts at set intervals. The default interval is 15 minutes, but you can set continuous crawls to occur at shorter intervals by using Windows PowerShell.

For information about how to create a new content source and manage crawling in Central Administration, see the following articles:

  • Add, edit, or delete a content source in SharePoint Server 2013

  • Start, pause, resume, or stop a crawl in SharePoint Server 2013

  • Manage continuous crawls in SharePoint Server 2013

Reindex catalog content

Some actions — for example, doing search schema management to enable refiners — require a full reindex of the content source that contains the catalog for the changes to be added to the search index. A site collection administrator can independently of the Search service application administrator indicate that a catalog should be fully reindexed during the next scheduled crawl of the catalog.

To reindex catalog content

  1. Verify that the user account that performs this procedure is a member of the Site collection administrators group on the site that contains the catalog.

  2. Browse to the catalog, and then do one of the following:

    • If you want to perform a full crawl of a catalog in a library, click the LIBRARY tab, and then, on the ribbon, in the Settings group, click Library Settings.

    • If you want to perform a full crawl of a catalog in a list, click the LIST tab, and then, on the ribbon, in the Settings group, click List Settings.

  3. On the Settings page, in the General Settings section, click Advanced settings.

  4. On the Advanced Settings page, in the Reindex List section, click Reindex List, and then click Reindex List to confirm that you want the catalog to be reindexed during the next scheduled crawl.

  5. Click OK.

    Note:

    The full reindex of the catalog will be performed during the next scheduled crawl.

See also

Automatically created managed properties in SharePoint Server 2013

http://blogs.technet.com/b/tothesharepoint/archive/2013/02/14/how-to-set-up-a-product-centric-web-site-in-sharepoint-2013.aspx


Connect a publishing site to a catalog in SharePoint Server 2013
See also

Published: October 2, 2012

Summary: Learn how to connect a publishing site collection to a library or list that is shared as a catalog.

Applies to: SharePoint Server 2013

To show content from a library or list that is shared as a catalog, you must connect the publishing site collection to the catalog. When you connect a publishing site collection to a catalog, the following occurs:

  • The catalog content is integrated into the publishing site collection.

  • The term set used by the catalog is integrated into the term set of the publishing site collection.

  • A category page and an item details page are created for the catalog pages.

  • Friendly URL is created for the item details page.

  • A result source is created for the catalog.

In this article:

  • Before you begin

  • Connect a publishing site to a catalog

  • Disconnect a publishing site from a catalog

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you connect the publishing site collection to a catalog, review the information in Plan category pages and catalog item pages. Also verify the following:

  • The publishing site that you connect to a catalog uses managed navigation. By default, site collections that are created by using the Publishing Portal Site Collection template use managed navigation.

  • The library or list was shared as a catalog, as described in Share a library or list as a catalog.

  • A full crawl of the content source that contains the catalog was performed, as described in Configure search for cross-site publishing.

  • The term set that is used by the catalog is available to the publishing site collection, as described in Make a term set available to other site collections.

Connect a publishing site to a catalog

To connect a publishing site to a catalog

  1. Verify that the user account that completes this procedure is a member of the Owners SharePoint group on the publishing site collection.

  2. On the publishing site collection, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Administration section, click Manage catalog connections.

  4. On the Manage catalog connections page, click Connect to a catalog. A list of available catalogs appears. Note that only catalogs that have been crawled will appear.

  5. On the line that contains the catalog that you want to connect to, click Connect. You can also search for a specific catalog by typing the catalog name in the search field.

  6. On the Catalog Source Settings page, in the Connection Integration section, do one of the following:

    • To make catalog content available to the publishing site and integrate the catalog tagging term set into the publishing site navigation term set, select Integrate the catalog into my site. When you select this option, use the following steps to specify at which level the term sets should be integrated, specify the URL for the catalog item details page, and select category pages and catalog item pages.

    • To make the catalog content available to the publishing site, select Connect, but do not integrate the catalog. You should select this option if you want to use content from the library to create individual catalog item pages.

    Either option creates a result source for the catalog.

  7. In the Navigation Hierarchy section, specify the term from which the catalog tagging term set should be integrated into the publishing site navigation term set. The catalog navigation column that you previously configured in Share a library or list as a catalog appears by default. The fields in this section are optional. Therefore, if you don't change the fields in this section, the catalog tagging term set will be integrated from the root term. If you want to integrate the catalog tagging term set from a different term, do the following:

    • Next to the Root term of hierarchy box, click Browse for a valid choice.

    • In the Select: Add Terms dialog box, click the term that corresponds to the level from which you want to integrate the catalog tagging term set, click Select, and then click OK.

    • To integrate the root term that is the parent of the selected term in the publishing site navigation term set, select the Include root term in site navigation check box.

    Note:

    All items in the catalog must be tagged with a term from the specified catalog tagging term set. If this is not done, site navigation will not work as intended for all items.

  8. In the Navigation Position section, specify the term in the publishing site navigation term set where the catalog tagging term set should be integrated. Do one of the following:

    • To integrate the catalog tagging term set to the root term of the publishing site navigation term set, click Add to navigation root.

    • To integrate the catalog tagging term set to a term below the root term of the publishing site navigation term set, click Select an alternate location in site navigation, and then do the following:

      • Click Browse for a valid choice to display the publishing site navigation term set.

      • In the Select: Add Terms dialog box, click the term that corresponds to the level from which you want to integrate the catalog tagging term set, click Select, and then click OK.

  9. If you want changes to the catalog tagging term set to be updated on the publishing site, in the Navigation Pinning section, select the Pin terms to site navigation check box. By default, this option is selected. If you clear this check box, changes made to the catalog tagging term set are not reflected on the publishing site navigation.

  10. In the Catalog Item URL Behavior section, specify what you want the URL of the catalog item to do by selecting one of the following options:

    • To point the URL of the catalog item to an item details page, select Make URLs relative to this site. When you select this option, you have to specify a catalog item URL format as described in the next step. This also means that the content that you can display on the item details page has to come from the search index.

    • To have the catalog item URL point to the item in the source catalog, select Make URLs point to source catalog. When you select this option, you do not have to specify a catalog item URL format. Note that when you select this option, anonymous users are not able to access and view the item in the source catalog.

  11. In the Catalog Item URL Format section, select which properties the URL of the item details page should contain by doing one of the following:

    • To use the field that you specified as Primary Key the when you shared the library or list as a catalog as described in Share a library or list as a catalog, select Use the default URL format provided by the catalog source. By default, this option is already selected.

      Note:

      All items in the catalog must have values for the specified field. Site navigation will not work as intended for items with missing values.

    • To manually define a format for the URL, select Manually define a URL format, and then type in a URL. You should select this option only if you have created an item details page and the items in your catalog are not tagged with a term from a catalog tagging term set. Type the URL in the following format: /<Folder of item details page>/<Name of item details page>.aspx? <Managed property name>=[Managed property value] — for example, /Pages/itemdetails.aspx?TitleProperty=[Title].

    • To construct a custom URL based on catalog properties, select Construct a URL format from catalog properties, and then do the following:

      • In the Available Fields list, select up to five fields, and then click Add.

        Important:

        Fields of site column type Number will not create a valid URL. All items in the catalog must have values for the specified fields. Site navigation will not work as intended for items with missing values.

  12. In the Category Page section, do one of the following:

    • To have SharePoint Server 2013 automatically create a new Category page for your catalog content, click Create a new page, and then select a master page. The page will be added to the Pages library with the name Category-<catalog tagging term set name>. The page will not be published automatically.

    • To use a Category page that was already created, select Use an existing page, and then specify the location of the page.

  13. In the Item Page section, do one of the following:

    • To have SharePoint Server 2013 automatically create a new Item page for your catalog content, click Create a new page, and then select a master page. The page will be added to the Pages library with the name CatalogItem-<catalog tagging term set name>. The page will not be published automatically.

    • To use an already created Item page, select Use an existing page, and specify the location of this page.

  14. Click OK.

Disconnect a publishing site from a catalog

If you want to remove the content of a connected catalog from a publishing site, you have to disconnect the publishing site from the catalog.

Important:

If you have integrated a catalog tagging term set into the publishing site navigation term set, the tagging terms will not be removed from the navigation when you disconnect from the catalog. To remove the tagging terms from the navigation, you have to delete the terms in Term Store Management. For more information, see Create and manage terms in a term set

Also, if you had SharePoint Server 2013 automatically create a category page and an item details page for the catalog pages, these will not be deleted from the Pages library when you disconnect from the catalog.

To disconnect a publishing site from a catalog

  1. Verify that the user account that completes this procedure is a member of the Owners SharePoint group on the publishing site collection.

  2. On the Site Settings page, in the Site Administration section, click Manage catalog connections.

  3. On the Manage catalog connections page, a list of connected catalogs appears.

  4. On the line that contains the catalog that you want to disconnect, click Disconnect, and then Disconnect to verify that you want to disconnect the catalog.

See also

Blog post: Connect your publishing site to a catalog


Assign a category page and a catalog item page to a term in SharePoint Server 2013
See also

Published: December 18, 2012

Summary: Learn how to assign a category page and a catalog item page to a term in term store management.

Applies to: SharePoint Server 2013

Category pages and catalog item pages are page layouts that you can use to show structured content consistently across a site. They are often used when displaying catalog content on a site that uses managed navigation. This saves you from having to create many individual pages for content that you want to show in the same manner across your site. You can assign a category page or a catalog item page to all terms in a term set, or to specific terms in a term set. For more information, see "Catalog pages and catalog item pages" in Overview of cross-site publishing in SharePoint Server 2013.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you assign a category page and a catalog item page in term store management, verify the following:

  • The publishing site is using managed navigation. By default, site collections that are created by using the Publishing Portal Site Collection template use managed navigation.

  • You have created a navigation term set in term store management as described in Create and manage terms in a term set.

  • You have created a category page and a catalog item page.

Important:

If you have connected a publishing site to a catalog and selected to integrate the catalog into the publishing site as described in Connect a publishing site to a catalog in SharePoint Server 2013, the category page and catalog item page configurations that you specified are displayed in term store management.

Assign a category page and a catalog item page to a term

By default, when you assign a category page to a term, the page that you specify will also be assigned to the children of the term unless you specify a different page to be used on all the children of a term.

Note:

You should only assign catalog item pages to a term if the term set is used as a tagging term set for catalog content.

To assign a category page and a catalog item page to a term

  1. Verify that the user account that performs this procedure is a member of the Owners SharePoint group on the site.

  2. On the site, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Administration section, click Term store management.

  4. On the Term Store Management Tool page, in the TAXONOMY TERM STORE section, click the term to which you want to assign a category page and a catalog item page.

  5. Click the tab TERM-DRIVEN PAGES.

  6. To assign a category page to a term, in the Target Page Settings section, select the check box Change target page for this term, and then type the URL of the category page that you want to assign to the term. Or you can click the Browse button, and then go to the category page that you want to assign to the term.

  7. To assign a category page to the children of a term, select the check box Change target page for the children of this term, and then type the URL of the category page that you want to assign to the children of the term. Or, you can click the Browse button, and then go to the category page that you want to assign to the children of the term.

  8. To assign a catalog item page for catalog items that are tagged with the current term, select Change Catalog Item Page for this category, and then type the URL of the catalog item page that you want to assign to catalog items that are tagged with the term. Or you can click the Browse button, and then go to the catalog item page that you want to assign to catalog items that are tagged with the term.

  9. To assign a catalog item page for catalog items that are tagged with a child of the current term, select Change Catalog Item Page, and then type the URL of the catalog item page that you want to assign to catalog items that are tagged with children of the term. Or you can click the Browse button, and then go to the catalog item page that you want to assign to catalog items tagged with children of the term.

See also

Blog post: Assign a category page and a catalog item page to a term


Configure Search Web Parts in SharePoint Server 2013
See also

Published: October 2, 2012

Summary: Learn how to configure the different Web Parts that use search technology in a publishing environment.

Applies to: SharePoint Server 2013

Web Parts that use search technology to show content in a publishing environment (referred to in this article as Search Web Parts) show content that was crawled and added to the search index, as described in "Understanding how content is added to and managed in the search index" in Overview of cross-site publishing in SharePoint Server 2013. These Web Parts have queries defined in them, and when users browse to a page that contains a Web Part that uses search technology, the Web Part issues the query automatically. The query result is then displayed in the Web Part. You can modify the query in the search Web Part to fit your content needs.

In this article:

  • Before you begin

  • Add a Content Search Web Part to a page

  • Configure the query for a Content Search Web Part

  • Configure the display templates for the Content Search Web Part

  • Add a Refinement Web Part to a page

  • Configure the Refinement Web Part

  • Display refiner counts in a Refinement Web Part

  • Change the refiner display name

  • Configure the display templates for the Refinement Web Part

  • Add a Taxonomy Refinement Panel Web Part to a page

  • Configure the Taxonomy Refinement Panel Web Part

  • Add a Recommended Items Web Part to a page

  • Configure the Recommended Items Web Part

  • Configure the display templates for the Recommended Items Web Part

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

There are many Search Web Parts available in SharePoint Server 2013. These Web Parts have predefined queries, such as what type of content to search for, where to search for content, and how to show content. For information about different Search Web Parts, see "Plan to add search Web Parts to pages" in Plan publishing sites for cross-site publishing in SharePoint Server 2013. Many of the Search Web Parts use result sources and have query rules that are applied to them. Result sources narrow the scope of search results that are retrieved. A query rule is a set of conditions that will cause the query to be changed in a specific way. For more information about result sources and query rules, see Plan result sources and query rules.

To customize how search results appear in Search Web Parts — for example, to show an image followed by a title in bold to the right of the image — you modify display templates. The two types of display templates that are most relevant to Search Web Parts are control display templates and item display templates.

Add a Content Search Web Part to a page

To add a Content Search Web Part to a page

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page where you want to add the Web Part.

  3. Click the Settings menu, and then click Edit page.

  4. In the Web Part Zone where you want to add the Web Part, click Add a Web Part.

  5. In the Categories list, click Content Rollup.

  6. In the Parts list, click Content Search, and then click Add.

Configure the query for a Content Search Web Part

You can use the Content Search Web Part in Quick Mode and create a query by selecting options from a list of existing result sources, or you can switch to Advanced Mode to create your own custom query by using Keyword Query Language (KQL). Use the Advanced Mode only if you know KQL and the functionality that is enabled for the managed properties.

To configure the query for a Content Search Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page that contains the Content Search Web Part that you want to configure.

  3. Click the Settings menu, and then click Edit Page.

  4. In the Web Part, click the Content Search Web Part Menu arrow, and then click Edit Web Part.

  5. In the Web Part tool pane, in the Properties section, in the Search Criteria section, click Change query.

  6. On the BASICS tab, do one of the following:

    • To define your query by using Quick Mode, select options as described in the following table:

      Quick Mode (default)

      Select a query

      Select a result source to specify which content should be searched. If you have shared a document library or list as catalog, the catalog result source will be displayed in this drop-down list. By default, this is set to Recently changed items (System).

      Restrict results by app

      Select an option from the list to restrict results to a specific site, library, list, or URL. By default, this is set to Current site.

      Restrict by tag

      You can limit results to content that is tagged with a term from a term set.

      Select one of the following options:

      Don't restrict by any tag

      Search results will not be limited based on tags (default).

      Restrict by navigation term of current page

      Search results will be limited to content that is tagged with the term of the current page. The current tag is displayed as the last part of the friendly URL. This option is only meaningful for sites that use managed navigation.

      Restrict by current and child navigation

      Search results will be limited to content that is tagged with the term of the current page (displayed as the last part of the friendly URL), and content that is tagged with sub-terms of the current page. This option is only meaningful for sites that use managed navigation.

      Note:

      In a cross-site publishing scenario, this selection will only work when the result source selected in the Select a query section is the catalog result source that is created when a publishing site is connected to a catalog.

      Restrict on this tag

      Search results will be limited to content that is tagged with the tag that you type inside the box.

    • To create your own query by using Keyword Query Language (KQL), click Switch to Advanced Mode. For information about KQL, see Keyword Query Language (KQL) syntax reference. When you configure the query in Advanced Mode, you can also use query variables. Query variables are placeholders for values that change dynamically depending on the context of the page when the page that contains the Content Search Web Part is being displayed. The correct information is inserted dynamically from the context the query is sent to the index. Examples of query variables are {User.Name}, which represents the name of the user who is viewing the page, or {searchBoxQuery}, which represents the query that a user typed in a search box. Select options as described in the following table:

      Advanced Mode

      Select a query

      Select a result source to specify which content should be searched.

      Default result source is Local SharePoint Results (System).

      Keyword filter

      You can use keyword filters to add query variables to your query. See Query variables in SharePoint Server 2013 for a list of available query variables.

      You can select pre-defined query variables from the drop-down list, and then add them to the query by clicking Add keyword filter.

      Property filter

      You can use property filters to query the content of managed properties that are set to queryable in the search schema.

      You can select managed properties from the Property filter drop-down list. Click Add property filter to add the filter to the query.

      Query text

      Type your query by using Keyword Query Language (KQL), or use the Keyword filter and Property filter lists to build the query.

      The keyword query can consist of free-text keywords, property filters, or operators. Use braces to enclose query variables. The query variables will be replaced with an actual value when the query is run.

      Keyword queries have a maximum length of 2,048 characters.

  7. The REFINERS tab lists the managed properties that are enabled as refiners in the search schema. You can specify that the search results returned in the Content Search Web Part should be limited to one or more values from the refiners. Click a refiner in the list, and then click Apply to add it to the query.

    Click Show more if you want to define grouping of results. Under Group results, you can specify that the results should be grouped based on one or more managed properties. This is useful when you are displaying several variants for a given item, and want to group them under a single result.

  8. On the SORTING tab, you can specify how search results should be sorted.

    This tab is available only if you use Advanced Mode. If you use Quick Mode, you can define sorting options in the result source.

    In the Sort by drop-down list, select a managed property from the list of managed properties that are set as sortable in the search schema, and then select Descending or Ascending. For example, to sort by relevance (that is, to use a ranking model) select Rank.

    To add more sorting levels, click Add sort level.

    If you selected Rank from the Sort by list, you can select which ranking model to use for sorting in the Ranking Model list.

    Under Dynamic ordering, you can specify additional ranking by adding rules that will change the order of results when certain conditions apply. Click Add dynamic ordering rule, and then specify conditional rules.

  9. On the SETTINGS tab, specify the settings that are listed in the following table.

    Query Rules

    Select whether to use Query Rules or not.

    URL Rewriting

    Select if the URL rewrite to the item details page should continue to be relative for each catalog item as defined when you set up the catalog connection. If you select Don't rewrite URLs, the URLs for catalog items are pointed directly to the library item of the connected catalog.

    Loading Behavior

    Select when the search results returned by the Content Search Web Part appear on the web page. The default option is Sync option: Issue query from the server. By using this loading behavior, queries are issued from the server, and the search results are included in the page response that is sent back from SharePoint. If you select Async option: Issue query from the browser, the queries will be issued from the end-users browser after the complete page is received. This option may be considered for secondary content on a page — for example Recommendations or Popular Items.

    Priority

    Select the level that best describes the relative importance of content that is displayed by this Web Part in relation to other Search Web Parts. If SharePoint Server 2013 is running under heavy load, the queries will be run according to their priority.

  10. On the TEST tab, you can preview the query that is sent by the Content Search Web Part.

    Query text

    Shows the final query that will be run by the Content Search Web Part. It is based on the original query template where dynamic variables are substituted with current values. Other changes to the query may have to be made as part of query rules.

    Click Show more to display additional information.

    Query template

    Shows the content of the query template that is applied to the query.

    Refined by

    Shows the refiners applied to the query as defined on the REFINERS tab.

    Grouped by

    Shows the managed property on which search results should be grouped as defined on the REFINERS tab.

    Applied query rules

    Shows which query rules are applied to the query.

    The Query template variables section shows the query variables that will be applied to the query, and the values of the variables that apply to the current page. You can type other values to test the effect they will have on the query. Click the Test Query button to preview the search results.

    You can also test how the query works for different user segment terms. Click Add user segment term to add terms to be added to the query. Click the Test query button to preview the search results.

    Query text

    Shows the final query that will be run by the Content Search Web Part. It is based on the original query template where dynamic variables are substituted with current values. Other changes to the query may have to be made as part of query rules.

Configure the display templates for the Content Search Web Part

When you connect a publishing site to a catalog, the default control display template for the Content Search Web Part on your category page is List with Paging (named Control_ListWithPaging in the Master Page Gallery).

The default item display template for the Content Search Web Part is Picture on top, 3 lines on bottom (named Item_Picture3Lines in the Master Page Gallery). If you want to use other display templates on your category page, you can change them by changing the settings for the Content Search Web Part.

For information on how to customize and create your own display templates, see SharePoint 2013 Design Manager display templates

Add a Refinement Web Part to a page

You can add refiners to a page to narrow the items that are shown in a Content Search Web Part, and help users quickly browse to specific content. Refiners are based on managed properties from the search index. To display refiners on a page, you must first enable the managed property that you want to use as a refiner, and then add a Refinement Web Part to the page where you want the refiners to appear. You can configure the Refinement Web Part for two types of refiners: Stand-alone refiners and Refiners for faceted navigation. For more information about the different refiner types, see Plan refiners and faceted navigation in Plan search for cross-site publishing sites in SharePoint Server 2013.

Before you begin this procedure, verify the following:

  • The managed properties that you want to use as refiners are enabled as refinable managed properties as described in "Map a crawled property to a refinable managed property in SharePoint site collection administration" or "Enable automatically created managed properties as refiners in SharePoint Central Administration " in Configure refiners and faceted navigation in SharePoint Server 2013.

  • You have done a full crawl of the content source that contains the managed properties that are enabled as refiners, or indicated that your catalog should be fully reindexed during the next scheduled crawl of the catalog as described in "Configure search for cross-site publishing" in Configure cross-site publishing in SharePoint Server 2013.

  • If you are using refiners for faceted navigation, you have configured the refiners as described in "Add refiners to a term set" in Configure refiners and faceted navigation in SharePoint Server 2013.

To add a Refinement Web Part to a page

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page where you want to add the Web Part.

  3. Click the Settings menu, and then click Edit Page.

  4. In the Web Part Zone where you want to add the Web Part, click Add a Web Part.

  5. In the Categories list, select Search.

  6. In the Parts list, select Refinement, and then click Add.

Configure the Refinement Web Part

To configure the Refinement Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page that contains the Refinement Web Part that you want to configure.

  3. Click the Settings menu, and then click Edit Page.

  4. In the Web Part, click the Refinement Web Part Menu arrow, and then click Edit Web Part.

  5. You can configure the Web Part for stand-alone refiners or for refiners for faceted navigation by using the following procedures,

    • To configure the Web Part for stand-alone refiners:

    1. In the Web Part tool pane, in the Properties for Search Refinement section, verify that the Choose Refiners in this Web Part is selected.

    2. Click Choose Refiners…

    3. On the Refinement configuration page, from the Available refiners section, use the buttons to select which refiners should be added to the term set, and also in which order that they should be displayed. If you have specified an alias for a refinable managed property, this alias is displayed in the Configuration for section.

    4. In the Configuration for section, set the configuration for how every refiner appears.

      Note:

      If you have a single language site, you can change the refiner display name in the Display name section. For multilingual sites, you have to change the refiner display language as described in Change the refiner display name.

    • To configure the Web Part for refiners for faceted navigation:

    1. In the Web Part tool pane, in the Properties for Search Refinement section, select the option Use the refinement configuration defined in the Managed Navigation term set.

Change the refiner display name

When you add a Refinement Web Part, the name of the managed property that is enabled as a refiner will be used as display name for the refiner. In many cases, the managed property name is not user-friendly — for example, RefinableString00 or ColorOWSTEXT. You can change the display name of the refiner by changing a java script file in the master page gallery.

To change the refiner display name

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. On the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Web Designer Galleries section, click Master pages and page layouts.

  4. On the Master Page Gallery page, click Display Templates.

  5. On the Display Templates page, click Language Files.

  6. On the Language Files page, click the folder that contains the language that you want to change the refiner display name for.

  7. Open the CustomStrings.js file.

  8. Add one line to the file for each managed property that is enabled as a refiner for which you want to change the display name byusing the following syntax:

    "rf_RefinementTitle_ManagedPropertyName": "Sample Refinement Title for ManagedPropertyName"

    For example, you can add the following line to change the display name for the managed property RefinableInt00 to Price:

    "rf_RefinementTitle_RefinableInt00": "Price".

Display refiner counts in a Refinement Web Part

When you add a Refinement Web Part to a page, by default, the Web Part will not show refiner counts — that is, the number of items for each refiner value. For example, if you have enabled the managed property Color as a refiner, the refiner values will only show colors such as Red, Green, and Blue. You can add refiner counts by changing a value in an HTML file so that the refiner values are shown as Red (10), Green (12), and Blue (8).

To add refiner counts to the Refinement Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. On the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Web Designer Galleries section, click Master pages and page layouts.

  4. On the Master Page Gallery page, click Display Templates.

  5. On the Display Templates page, click Filters.

  6. Open the Filter_Default.html file.

  7. Change the value for ShowCounts to true.

Configure the display templates for the Refinement Web Part

The display templates for the Refinement Web Part can be found in the Master Page Gallery.

To view display templates for the Refinement Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. On the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Web Designer Galleries section, click Master pages and page layouts.

  4. On the Master Page Gallery page, click Display Templates.

  5. On the Display Templates page, click Filters.

For information on how to customize and create your own display templates, see SharePoint 2013 Design Manager display templates.

Add a Taxonomy Refinement Panel Web Part to a page

Before you begin this procedure, verify the following:

  • The managed properties that you want to use as refiners are refiner-enabled as described in "Map a crawled property to a refinable managed property in SharePoint site collection administration" or "Enable automatically created managed properties as refiners in SharePoint Central Administration " in Configure refiners and faceted navigation in SharePoint Server 2013.

  • You have done a full crawl of the content source that contains the managed properties that are enabled as refiners as described in "Configure search for cross-site publishing" in Configure cross-site publishing in SharePoint Server 2013.

  • If you are using refiners for faceted navigation, you have configured the refiners as described in Configure refiners and faceted navigation in SharePoint Server 2013.

To add a Taxonomy Refinement Panel Web Part to a page

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page where you want to add the Web Part.

  3. Click the Settings menu, and then click Edit Page.

  4. In the Web Part Zone where you want to add the Web Part, click Add a Web Part.

  5. In the Categories list, select Search.

  6. In the Parts, select Taxonomy Refinement Panel, and then click Add.

Configure the Taxonomy Refinement Panel Web Part

To configure the Taxonomy Refinement Panel Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page where you have the Taxonomy Refinement Panel Web Part that you want to configure.

  3. On the Settings menu, click Edit Page.

  4. In the Web Part, click the Taxonomy Refinement Panel Web Part Menu arrow, and then click Edit Web Part.

  5. In the Web Part tool pane, in the Properties section, in the Query section, on the Refinement Target menu, select the Web Part you want to associate with the Taxonomy Refinement Panel Web Part.

  6. In the Web Part tool pane, in the Properties section, in the Query section, on the Refiner menu, select the managed property that you have specified for Managed Navigation.

Add a Recommended Items Web Part to a page

You can use the Recommended Items Web Part to show content recommendations based how users have previously interacted with the site. For example, you can add this Web Part to a Catalog Item page. If a user views a specific item, this Web Part will display other items that users have previously viewed, such as "Users who viewed this item also viewed these items." For more information about recommendations, see Plan usage analytics, usage events and recommendations in Plan search for cross-site publishing sites in SharePoint Server 2013.

To add a Recommended Items Web Part to a page

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page where you want to add the Web Part.

  3. Click the Settings menu, and then click Edit Page.

  4. In the Web Part Zone where you want to add the Web Part, click Add a Web Part.

  5. In the Categories list, click Search-Driven Content.

  6. In the Parts list, click Recommended Items, and then click Add.

Configure the Recommended Items Web Part

To configure the query for a Recommended Items Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page where you have the Recommended Items Web Part that you want to configure.

  3. On the Settings menu, click Edit Page.

  4. In the Web Part, click the Recommended Items Web Part Menu arrow, and then click Edit Web Part.

  5. In the Web Part tool pane, in the Properties section, in the Search Criteria section, click Change query.

  6. On the BASICS tab, define your query by selecting options described in the following table.

    Get recommended items for

    From the drop-down list, select from which value recommendations should be displayed. In a catalog scenario, this will often be A token from a URL. If you select this option, you will also have to select which URL token you want to obtain recommendations for.

    For example, let's say that you want to obtain recommendations for items in your catalog. You have a catalog item page where you display your catalog items, and the item number is part of your friendly URL — for example, www.contoso/audio/mp3/4010101. (4010101 represents the item number.) When you want to obtain recommendations for a token from the URL, you should select {URLToken.1} (4010101) from the second drop-down list.

    Restrict results by app

    Use this drop-down list to specify a scope for the search results.

    Restrict results by content type

    Use this drop-down list to limit the search results to a specific content type.

    If there are too few recommended items

    If you don't have much usage data — for example, if your site is fairly new, or if the items do not have recommendations to display — this Web Part will not display any search results. In order for the Web Part to display recommendations even though not enough user data has cumulated, you can select the option to Select a query to fill in with additional results.

  7. The REFINERS tab lists the managed properties that are set as refiner-enabled in the search schema. You can specify that the search results returned in the Recommended Items Search Web Part should be limited to one or more values from the refiners. Click a refiner in the list, and then click Apply to add it to the query.

    Click Show more if you want to define grouping of results. Under Group results, you can specify that the results should be grouped based on one or more managed properties.

  8. On the SETTINGS tab, specify the following:

    Query Rules

    Select whether to use Query Rules or not.

    URL Rewriting

    Select if the URL rewrite to the item details page should continue to be relative for each catalog item as defined when you set up the catalog connection. If you select Don't rewrite URLs, the URLs for your catalog items are pointed directly to the library item of the connected catalog.

    Loading Behavior

    Select when the search results returned by the Recommended Items Web Part should be displayed on the web page. The default option is Display the page and web party simultaneously. By using this loading behavior, queries are issued from the server, and the search results are included in the page response that is sent back from SharePoint. If you select Display the page and web part independently, the queries will be issued from the end-users browser after the complete page is received. This option may be considered for secondary content on a page — for example, Recommendations or Popular Items

    Priority

    Select the level that best describes the relative importance of content that is displayed by this Web Part in relation to other Search Web Parts. If SharePoint Server 2013 is running under heavy load, the queries will be run according to their priority.

  9. On the TEST tab, you can preview the query that is sent by the Recommended Items Web Part.

    Query text

    Shows the content of the query template that is applied to the query.

    Click Show more to display additional information.

    Refined by

    Shows the refiners applied to the query as defined in the REFINERS tab.

    Grouped by

    Shows the managed property on which search results should be grouped as defined in the REFINERS tab.

    Applied query rules

    Shows which query rules are applied to the query.

    In the Query template variables section, the selections that you made on the BASIC tab are displayed. In addition, you can type additional values for testing as outlined in the following table. Click the Test query button to preview the search results.

    {RecsURL}*

    Shows the token you selected when specifying for which value recommendations should be displayed.

    {Scope}*

    Shows the scope that you selected for the search results.

    {ContentTypeID}*

    Shows the content type that you selected for the search results.

    You can also test how the query works for different user segment terms. Click Add user segment term for testing to add terms to be added to the query. Click the Test query button to preview the search results.

    Query text

    Shows the final query that will be run by the Recommended Items Web Part. It is based on the original query template where dynamic variables are substituted with current values. Other changes to the query may have be made as part of query rules.

Configure the display templates for the Recommended Items Web Part

The default control display template for the Recommended Items Search Web Part is List (known as Control_List in the Master Page Gallery).

The default item display template for the Recommended Items Web Part is Recommended Items: Picture on top, 3 lines (known as Item_RecommendationsClickLogging in the Master Page Gallery). When a user clicks a link that is displayed in the Recommended Items Web Part, the default display template logs a Recommendations Clicked usage event.

For information on how to customize and create your own display templates, see SharePoint 2013 Design Manager display templates

See also

Query variables in SharePoint Server 2013

Blog series: How to set up a product-centric website in SharePoint Server 2013


Configure refiners and faceted navigation in SharePoint Server 2013
See also

Published: October 2, 2012

Summary: Learn how to map a crawled property to a refinable managed property, enable a managed property as a refiner, and configure refiners for faceted navigation.

Applies to: SharePoint Server 2013

You can add refiners to a page to help users quickly browse to specific content. Refiners are based on managed properties from the search index. To use managed properties as refiners, the managed properties must be enabled as refiners, or crawled properties must be mapped to managed properties that are enabled as refiners.

Faceted navigation is the process of browsing for content by filtering on refiners that are tied to category pages. Faceted navigation lets you specify different refiners for category pages, even when the underlying page displaying the categories is the same. For information about category pages, see "Category pages and catalog item pages" in Overview of cross-site publishing in SharePoint Server 2013.

Important:

You can apply faceted navigation only to publishing sites that use managed navigation.

In this article:

  • Before you begin

  • Map a crawled property to a refinable managed property in SharePoint site collection administration

  • Enable automatically created managed properties as refiners in SharePoint Central Administration

  • Enable a term set for faceted navigation

  • Add refiners to a term set

  • Set intervals for refiner values

  • Add JavaScript to a page to display refiners in the correct format

  • Reference tables

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Review the information in "Plan refiners and faceted navigation" in Plan search for cross-site publishing sites in SharePoint Server 2013.

About configuring refiners for different data types

When a catalog is crawled, SharePoint Server 2013 automatically creates managed properties for all site columns that contain values. These automatically created managed properties use the Text data type. To make sure that refiners that use the Number, Currency, Integer, and Date and Time data types are displayed in the correct format, you can do one of the following:

  1. Use the procedure that is described in Map a crawled property to a refinable managed property in SharePoint site collection administration. This procedure can be performed by site collection administrators. We recommend that you use this procedure for all data types.

  2. Create a managed property, add the type code to the property name, and then enable it as a refiner. This procedure can only be performed by an administrator of the Search service application. For more information, see To create a managed property, add type code to the name, and enable a managed property as a refiner.

  3. Add JavaScript to the page where the refiners are displayed. For more information, see Add JavaScript to a page to display refiners in the correct format .

Map a crawled property to a refinable managed property in SharePoint site collection administration

Site collection administrators can configure refiners because the search schema has many managed properties that are enabled as refiners by default. These managed properties are listed in the following table. Before site collection administrators can use these managed properties as refiners on their web pages, they must map the appropriate crawled property to the managed property that is enabled as a refiner. To make it easier to work with these properties when doing additional refiner configuration in Term Store Management, you can specify a user-friendly alias name for the managed property.

For an overview of managed properties that are enabled as refiners by default, see Managed properties that are enabled as refiners by default.

Note:

This procedure is performed on the authoring site collection.

To map a crawled property to a refinable managed property

  1. Verify that the user account that performs this procedure is a site collection administrator on the authoring site collection.

  2. On the authoring site collection, on the Settings menu, click Site settings.

  3. On the Site Settings page, in the Site Collection Administration section, click Search Schema.

  4. On the Managed Properties page, in the Managed property filter box, type the name of a refinable managed property — for example, RefinableString00 — and then click the arrow.

  5. In the Property Name column, click the refinable managed property that you want to edit.

  6. To specify an alias of the refinable managed property to use when you configure refiners for faceted navigation, on the Edit Managed Property page, type a user-friendly name in the Alias box.

    Important:

    For properties that use the data type Managed Metadata, the alias must consist of the type code, owstaxId, followed by the property name. For example, for a property named Color that uses the Managed Metadata data type, the alias for the refinable managed property must be owstaxIdColor.

  7. In the Mappings to crawled properties section, click Add a Mapping.

  8. In the Crawled property selection dialog box, find the crawled property that you want to map to the refinable managed property in the list, or search for it by typing the name of the crawled property in the box, and then clicking Find.

    Important:

    When you search for a crawled property, you may find two crawled properties that represent the same content. For example, a site column of type Text named Color will during crawl discover two crawled properties: ows_Color and ows_q_TEXT_Color. Crawled properties that begin with either ows_r<four letter code>, ows_q<four letter code>, or ows_taxId are automatically created crawled properties. When you select a crawled property to map to a refinable managed property, make sure that you don't map the automatically created crawled property. Instead, always map the crawled property that begins with ows_.

    For more information about automatically created crawled properties, see Automatically created managed properties in SharePoint Server 2013.

  9. Click OK.

  10. On the Edit Managed Property page, click OK.

Note:

To configure refiners in Web Parts or in Term Store Management, you must start a full crawl of the content source that contains the refinable managed properties. For more information, see Configure search for cross-site publishing.

Enable automatically created managed properties as refiners in SharePoint Central Administration

All automatically created managed properties use the Text data type. To make sure that that the refiners are displayed in the correct format, you should only enable an automatically created managed property as a refiner if it is based on a site column that uses the data type Text, Managed Metadata, or Person or Group. For other data types, you must create a managed property, add the type code to the property name, and enable the managed property as a refiner.

For more information about automatically created managed properties, see Automatically created managed properties in SharePoint Server 2013.

To enable an automatically created managed property as a refiner

  1. Verify that the user account that performs this procedure is an administrator of the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application in which you want to enable the managed property as a refiner.

  4. On the Search Administration page, in the Quick Launch, under Queries and Results, click Search Schema.

  5. On the Managed Properties page, in the Managed property filter box, type the name of the managed property that you want to enable as refiner, and then click the arrow.

  6. In the Property Name column, click the managed property that you want to edit.

  7. On the Edit Managed Property page, in the Refinable section, select either Yes - active or Yes - latent. If you select Yes - latent, you can switch the refiner to active later without having to do a full crawl.

  8. Click OK.

Note:

To configure refiners in Web Parts or in Term Store Management, you must complete a full crawl of the content source that contains the refinable managed properties. For more information, see Configure search for cross-site publishing.

To create a managed property, add type code to the name, and enable a managed property as a refiner

  1. Verify that the user account that performs this procedure is an administrator of the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application in which you want to create a managed property.

  4. On the Search Administration page, in the Quick Launch, under Queries and Results, click Search Schema.

  5. On the Managed Properties page, click New Managed Property.

  6. On the New Managed Property page, in the Property name box, in the Name and description section, type the name of the new managed property, followed by the appropriate type code. For an overview of type codes, see Type codes.

  7. In the Type section, select the appropriate data type.

  8. In the Main characteristics section, set the following selections:

    • Queryable

    • Refinable: Yes - active or Yes - latent

    You can also specify additional settings in this section.

  9. In the Mappings to crawled properties section, click Add a mapping.

  10. In the Crawled property selection dialog box, find the crawled property that you want to map to the managed property in the list, or search for it by typing the name of the crawled property in the box, and then clicking Find.

    Important:

    When you search for a crawled property, you may find two crawled properties that represent the same content. For example, a site column of type Date and Time named Created will during crawl discover two crawled properties: ows_Created and ows_q_DATE_Created. Crawled properties that begin with either ows_r<four letter code>,ows_q<four letter code> or ows_taxId are automatically created crawled properties. When you select a crawled property to map to a managed property, make sure that you don't map the automatically created crawled property. Instead, always map the crawled property that begins with ows_.

  11. Click OK.

Note:

To configure refiners in Web Parts or in Term Store Management, you must complete a full crawl of the content source that contains the refinable managed properties. For more information, see Configure search for cross-site publishing.

Configure refiners for faceted navigation

Before you start the procedures in this section, verify the following:

  • On the authoring site, a library or list is shared as a catalog, as described in Share a library or list as a catalog.

  • The required managed properties are enabled as refiners, as described in Map a crawled property to a refinable managed property in SharePoint site collection administration and Enable automatically created managed properties as refiners in SharePoint Central Administration.

  • A full crawl was completed for the content source that contains the refinable managed properties, as described in Configure search for cross-site publishing.

Enable a term set for faceted navigation

To configure refiners for faceted navigation, you must first enable the relevant term set for faceted navigation. This procedure is performed on the authoring site collection.

To enable a term set for faceted navigation

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the authoring site collection.

  2. On the authoring site collection, on the Settings menu, click Site settings.

  3. On the Site Settings page, in the Site Administration section, click Term store management.

  4. In the TAXONOMY TERM STORE section, click to select the term set that you want to enable for faceted navigation.

  5. Click the INTENDED USE tab, and then select Use this Term Set for Faceted Navigation.

  6. Click Save.

Add refiners to a term set

When configuring refiners for faceted navigation, you can add refiners to all terms in a term set or to specific terms in a term set. This procedure is performed on the authoring site collection.

To add refiners to all terms in a term set

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the authoring site collection.

  2. On the authoring site collection, on the Settings menu, click Site settings.

  3. On the Site Settings page, in the Site Administration section, click Term store management.

  4. In the TAXONOMY TERM STORE section, click the term set that you have enabled for faceted navigation.

  5. Click the FACETED NAVIGATION tab, and then click Customize refiners.

  6. On the Refinement Configuration page, in the Available refiners section, use the buttons to select which refiners should be added to the term set, and also to specify the order in which you want the refiners to appear. If you have specified an alias for a refinable managed property, this alias is displayed in the Configuration section.

  7. In the Configuration for section, specify how you want each refiner to appear.

  8. Click OK to close the Refinement Configuration page, and then click Save.

To add refiners to specific terms in a term set

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the authoring site collection.

  2. On the authoring site collection, on the Settings menu, click Site settings.

  3. On the Site Settings page, in the Site Administration section, click Term store management.

  4. In the TAXONOMY TERM STORE section, click the term set that you have enabled for faceted navigation, and then click the term to which you want to add term-specific refiners.

  5. Click the FACETED NAVIGATION tab, and then click Stop inheriting.

  6. Click FACETED NAVIGATION tab, and then click Customize refiners.

  7. On the Refinement Configuration page, in the Available refiners section, use the buttons to select which refiners should be added to the term set, and also to specify the order in which you want the refiners to appear. If you have specified an alias for a refinable managed property, this alias is displayed in the Configuration section.

  8. In the Configuration for section, specify how you want each refiner to appear.

  9. Click OK to close the Refinement Configuration page, and then click Save.

Set intervals for refiner values

For refiners that contain numeric values, you can present the numeric values within different intervals. For example, if you want end-users to be able to refine based on price, it would be useful to specify different price ranges instead of showing all available prices as separate refiners. This procedure is performed in the authoring site collection.

To set ranges for refiner values

  1. Add refiners to a term set as described in Add refiners to a term set earlier in this article.

  2. On the Refinement Configuration page, in the Selected refiners section, click the refiner that you want to set ranges for.

  3. In the Configuration for section, for Intervals, select Custom, and then type the ranges in the Thresholds box.

  4. Click OK to close the Refinement Configuration page, and then click Save.

Additional steps

To show refiners on a page, you must add a Refinement Panel Web Part to the page where you want the refiners to appear. For more information, see Configure Search Web Parts in SharePoint Server 2013.

Add JavaScript to a page to display refiners in the correct format

To make sure that refiners that use the Number, Currency, Integer, and Date and Time data types are displayed in the correct format, you can add JavaScript to the page where the refiners are displayed. You can add the JavaScript by adding a Content Editor Web Part, which you then hide from being displayed on the page.

Note that there are two methods depending on whether you are using the default display template, Filter_Default, or another display template in your Refinement Web Part.

To add JavaScript to a page to display refiners in the correct format when you are using the default display template

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page where the refiners are displayed.

  3. Click the Settings menu, and then click Edit page.

  4. In a Web Part Zone, click Add a Web Part.

  5. In the Categories list, click Media and Content.

  6. In the Parts list, click Content Editor, and then click Add.

  7. In the Web Part, click Click here to add new content, and type one of the following two code strings:

    Copy code
    # To ensure correct refiner formatting by using type code:
Srch.ValueInfo.overrideRenderingForProperty( "<ManagedPropertyName>", "Property<TypeCode>" );

# To ensure correct refiner formatting by using a managed properties that is enabled as a refiner by default:
Srch.ValueInfo.overrideRenderingForProperty("<ManagedPropertyName>", "<DefaultRefinableManagedProperty>");

    Where:

    • <ManagedPropertyName> is the name of the managed property that is enabled as a refiner, for example CreatedOWSDATE.

    • <TypeCode> is a seven letter code indicating the data type, for example OWSDATE. For an overview of type codes, see Type codes.

    • <DefaultRefinableManagedProperty> is the name of a managed property that is enabled as a refiner by default, for example RefinableDate00. For an overview of managed properties that are enabled as refiners by default, see Managed properties that are enabled as refiners by default.

  8. In the Web Part, click the Content Editor Web Part Menu arrow, and then click Edit Web Part.

  9. In the Web Part tool pane, expand the Layout section, and then select the check box Hidden.

  10. Click OK.

To add JavaScript to a page to display refiners in the correct format when you are not using the default display template

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the publishing site collection.

  2. Browse to the page where the refiners are displayed.

  3. Click the Settings menu, and then click Edit page.

  4. In a Web Part Zone, click Add a Web Part.

  5. In the Categories list, click Media and Content.

  6. In the Parts list, click Content Editor, and then click Add.

  7. In the Web Part, click Click here to add new content, and then type the following code strings:

    Copy code
    # To ensure correct refiner formatting by using type code:
Srch.ValueInfo.overrideRefinementTemplateForProperty("<ManagedPropertyName>", "Property<TypeCode>", "~sitecollection/<PathToDisplayTemplate>" );

# To ensure correct refiner formatting by using a managed properties that is enabled as a refiner by default:
Srch.ValueInfo.overrideRefinementTemplateForProperty("<ManagedPropertyName>", "<DefaultRefinableManagedProperty>", "~sitecollection/<PathToDisplayTemplate>" );

    Where:

    • <ManagedPropertyName> is the name of the managed property that is enabled as a refiner, for example CreatedOWSDATE.

    • <TypeCode> is a seven letter code indicating the data type, for example OWSDATE. For an overview of type codes, see Type codes.

    • <DefaultRefinableManagedProperty> is the name of a managed property that is enabled as a refiner by default, for example RefinableDate00. For an overview of managed properties that are enabled as refiners by default, see Managed properties that are enabled as refiners by default.

    • <PathToDisplayTemplate> is the path of the display template that you are using in the Refinement Web Part, for example catalogs\masterpage\Display Templates\Filters\MyDisplayTemplate.js.

  8. In the Web Part, click the Content Editor Web Part Menu arrow, and then click Edit Web Part.

  9. In the Web Part tool pane, expand the Layout section, and then select the check box Hidden.

  10. Click OK.

Reference tables

Managed properties that are enabled as refiners by default

Managed property name | Data type for mapping.
RefinableDate00 - RefinableDate19 | Values contain dates.
RefinableDecimal00 - RefinableDecimal09 | Values contain numbers with maximum three decimals.
RefinableDouble00 - RefinableDouble09 | Values contain numbers with more than three decimals.
RefinableInt00 - RefinableInt49 | Values are whole numbers.
RefinableString00 - RefinableString99 | Values are strings. This includes values that use the data type Text, Person or Group, Managed Metadata, Choice and Yes/No

Type codes

Site column type | Type code | Example of managed property name with type code
Number | OWSNMBR | ManagedPropertyNameOWSNMBR
Currency | OWSCURR | ManagedPropertyNameOWSCURR
Date and Time | OWSDATE | ManagedPropertyNameOWSDATE
Integer* | OWSINTG | ManagedPropertyNameOWSINTG

*Column creation not available through user interface.

See also

Configure search for cross-site publishing

Automatically created managed properties in SharePoint Server 2013
Configure Search Web Parts in SharePoint Server 2013


Configure result sources for web content management in SharePoint Server 2013
See also

Updated: February 12, 2013

Summary: Learn how to create and manage result sources for SharePoint Search service applications, and for SharePoint sites and site collections.

Applies to: SharePoint Server 2013

Result sources limit searches to certain content or to a subset of search results. SharePoint Server 2013 provides 16 pre-defined result sources. The pre-configured default result source is Local SharePoint Results. You can specify a different result source as the default. In addition to the pre-configured result sources, SharePoint Server 2013 automatically creates a result source when you connect a publishing site to a catalog, and adds it to the result sources in the publishing site. This result source limits search results to the URL of the catalog. For more information about result sources, see "Plan result sources and query rules" in Plan search for cross-site publishing sites in SharePoint Server 2013.

In this article:

  • Before you begin

  • Create a result source

  • Set a result source as default

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

We recommend that you set up the publishing site, integrate a catalog, and configure category and catalog item pages before you begin to create result sources. This is because you can then more easily test and verify how the different result sources apply to the different Search Web Parts that you have on the site.

Create a result source

You can create a result source for a Search service application, a site collection, or a site. The following table shows the permissions that are required to create a result source at each level, and where the result source can be used.

Levels and permissions for result sources

When you create a result source at this level | You must have this permission | The result source can be used in
Search service application | Search service application administrator | All site collections in web applications that consume the Search service application
Site collection | Site collection administrator | All sites in the site collection
Site | Site owner | The site

To create a result source

  1. Depending on the level at which you want to create the result source, do one of the following:

    • To create a result source for a Search service application:

      1. Verify that the user account that performs this procedure is an administrator on the Search service application.

      2. In Central Administration, in the Application Management section, click Manage service application.

      3. Click the Search service application for which you want to create a result source.

      4. On the Search Administration page for the Search service application, on the Quick Launch, in the Queries and Results section, click Result Sources.

    • To create a result source for a site collection:

      1. Verify that the user account that performs this procedure is a site collection administrator on the publishing site collection.

      2. On the publishing site collection, on the Settings menu, click Site Settings.

      3. On the Site Settings page, in the Site Collection Administration section, click Search Result Sources.

    • To create a result source for a site:

      1. Verify that the user account that performs this procedure is a member of the Owners group on the publishing site.

      2. On the publishing site, on the Settings menu, click Site Settings.

      3. On the Site Settings page, in the Search section, click Result Sources.

  2. On the Manage Result Sources page, click New Result Source.

  3. On the Add Result Source page, in the General Information section, do the following:

    1. In the Name box, type a name for the result source.

    2. In the Description box, type a description of the result source.

  4. In the Protocol section, select one of the following protocols for retrieving search results:

    • Local SharePoint, the default protocol, provides results from the search index for this Search service application.

    • Remote SharePoint provides results from the index of a search service in another farm.

      Important:

      To use the Remote SharePoint protocol to get search results in one SharePoint Server 2013 on-premises farm from the index of another SharePoint Server 2013 on-premises farm, you must configure the farm that receives the queries to trust the farm that sends the queries. For information about how to do this, see Configure trust for search between two SharePoint Server 2013 farms.

    • OpenSearch provides results from a search engine that uses the OpenSearch 1.0/1.1 protocol.

    • Exchange provides results from Microsoft Exchange Server 2013 through a SharePoint 2013 eDiscovery Center. Click Use AutoDiscover to have the search system find an Exchange Server 2013 endpoint automatically, or type the URL of the Exchange web service to retrieve results from — for example, https://contoso.com/ews/exchange.asmx.

      Note:

      • The Exchange protocol only enables you to discover Exchange Server 2013 content, and only from a SharePoint 2013 eDiscovery Center. For more information, see Configure communication between SharePoint Server 2013 and Exchange Server 2013 in Configure eDiscovery in SharePoint Server 2013.

      • The Exchange Web Services Managed API must be installed on the computer on which the search service is running. For more information, see Optional software in Hardware and software requirements for SharePoint 2013.

  5. In the Type section, select SharePoint Search Results to search the whole index, or People Search Results to enable query processing that is specific to people search.

  6. In the Query Transform field, do one of the following:

    • Leave the default query transform (searchTerms) as is. In this case, the query will be unchanged since the previous transform.

    • Type a different query transform in the text box.

    • Use the Query Builder to configure a query transform by doing the following:

      1. Click Launch Query Builder.

      2. In the Build Your Query dialog box, optionally build the query by specifying filters, sorting, and testing on the tabs as shown in the following tables.

      • On the BASICS tab

        Keyword filter

        You can use keyword filters to add pre-defined query variables to the query transform. You can select pre-defined query variables from the drop-down list, and then add them to the query by clicking Add keyword filter.

        For an overview of query variables, see Query variables in SharePoint Server 2013.

        Property filter

        You can use property filters to query the content of managed properties that are set to queryable in the search schema.

        You can select managed properties from the Property filter drop-down list. Click Add property filter to add the filter to the query.

      • On the SORTING tab

        Sort results

        In the Sort by menu, you can select a managed property from the list of managed properties that are set as sortable in the search schema, and then select Descending or Ascending. To sort by relevance, that is, to use a ranking model, select Rank. You can click Add sort level to specify a property for a secondary level of sorting for search results.

        Ranking Model

        If you selected Rank from the Sort by list, you can select the ranking model to use for sorting.

        Dynamic ordering

        You can click Add dynamic ordering rule to specify additional ranking by adding rules that change the order of results within the result block when certain conditions are satisfied.

      • On the TEST tab

        Query text

        You can view the final query text, which is based on the original query template, the applicable query rules, and the variable values.

        Click Show more to display the options in the following rows of this table.

        Query template

        You can view the query as it is defined in the BASICS tab or in the text box in the Query transform section on the Add Result Source page.

        Query template variables

        You can test the query template by specifying values for the query variables.

  7. On the Add Result Source page, in the Credentials Information section, select the authentication type that you want for users to connect to the result source.

Set a result source as default

You can set any result source as the default result source. Specifying a result source as default can make it easier to edit the query in Search Web Parts. For example, when you add a Content Search Web Part to a page, the Web Part automatically uses the default result source. For more information, see Configure Search Web Parts in SharePoint Server 2013.

To set a result source as default

  1. Perform the appropriate procedures in the following list depending on the level at which the result source was configured.

    • If the result source was created at the Search service application level, do the following:

      1. Verify that the user account that performs this procedure is an administrator for the Search service application.

      2. In Central Administration, in the Application Management section, click Manage service applications.

      3. Click the Search service application for which you want to set the result source as default.

      4. On the Search Administration page, in the Queries and Results section, click Result Sources.

    • If the result source is at the site collection level, do the following:

      1. Verify that the user account that performs this procedure is a site collection administrator on the publishing site collection.

      2. On the publishing site collection, on the Settings menu, click Site Settings.

      3. On the Site Settings page, in the Site Collection Administration section, click Search Result Sources.

    • If the result source is at the site level, do the following:

      1. Verify that the user account that performs this procedure is a member of the Owners group on the publishing site.

      2. On the publishing site, on the Settings menu, click Site Settings.

      3. On the Site Settings page, in the Search section, click Result Sources.

  2. On the Manage Result Sources page, point to the result source that you want to set as default, click the arrow that appears, and then click Set as Default.

See also

Query variables in SharePoint Server 2013
Configure Search Web Parts in SharePoint Server 2013

Change History

Date | Description
February 12, 2013 | Added a statement that the Exchange protocol provides results only from Exchange Server 2013 content, and only from a SharePoint 2013 eDiscovery Center. Also added a link to a related SharePoint 2013 eDiscovery article on TechNet.
October 16, 2012 | Initial publication


Create query rules for web content management in SharePoint Server 2013
See also

Published: December 11, 2012

Summary: Learn how to improve search results by creating and managing query rules.

Applies to: SharePoint Server 2013

Without using any custom code, Search service application administrators, site collection administrators, and site owners can help searches respond to the intent of users by creating query rules. In a query rule, you specify conditions and correlated actions. When a query meets the conditions in a query rule, the search system performs the actions specified in the rule to improve the relevance of the search results, such as by narrowing results or changing the order in which results are displayed. For example, a query rule condition could be that a term in a query matches a particular term in a SharePoint term set, or that a query is frequently performed on a particular result source in a search system, such as videos. When the query rule condition is satisfied, a correlated action could be to show a specific item at the top of the search results. Say you have an intranet site where all company events are maintained in a library that you have shared as a catalog, and you want to promote a first-aid seminar. To do this, you create a query rule that boosts the first-aid seminar to the top of the search results when someone searches for "seminar" or "event."

You can configure query rules for one or more result sources, and you can specify the time period during which the query rule is active.

For more information about query rules, see Plan result sources and query rules in Plan search for cross-site publishing sites in SharePoint Server 2013.

In this article:

  • Before you begin

  • Creating query rules at different levels in a SharePoint farm

  • Create a query rule

  • Create and display a result block

  • Change ranked search results

  • Make a query rule inactive

  • Display promoted results in a Content Search Web Part

  • Rank query rules

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

We recommend that you set up your site, integrate a catalog, and set up your category pages and catalog item pages before you begin to create query rules. This is because you can then more easily test and verify how the different query rules apply to the different Search Web Parts you have on your site.

Creating query rules at different levels in a SharePoint farm

You can create a query rule for a Search service application, a site collection, or a site. The following table shows the permissions that are required to create a query rule in each case, and where the query rule can be used.

Levels and permissions for query rules

When you create a query rule at this level | You must have this permission | The query rule can be used in
Search service application | Search service application administrator | All site collections in web applications that consume the Search service application
Site collection | Site collection administrator | All sites in the site collection
Site | Site owner | The site

To add or edit a query rule, you must go to the Manage query rules page. Depending on the level at which you are creating the query rule, use one of the following procedures to go to the Manage query rules page.

To go to the Manage query rules page for a Search service application

  1. Verify that the user account that performs this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application to which you want to add query rules.

  4. On the Search Administration page for the Search service application, in the Quick Launch, in the Queries and Results section, click Query Rules.

To go to the Manage query rules page for a publishing site collection

  1. Verify that the user account that performs this procedure is a site collection administrator for the publishing site collection.

  2. On the publishing site collection, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Collection Administration section, click Search Query Rules.

To go to the Manage query rules page for a site

  1. Verify that the user account that performs this procedure is a member of the Owners group for the site.

  2. On the Settings menu for the site, click Site Settings.

  3. On the Site Settings page, in the Site Administration section, click Query Rules.

Create a query rule

To create a query rule

  1. On the Manage Query Rules page, in the Select a Result Source menu, select a result source for the new query rule.

  2. Click New Query Rule.

  3. On the Add Query Rule page, in the General Information section, in the Rule name field, type the name for the query rule.

  4. Click to expand the Context section.

  5. In the Context section, select one of the following:

    • To apply the query rule to all result sources, select All sources.

    • To apply the query rule to one or more specific result sources, select One of these sources. By default, the result source that you specified in step 1 is selected. To add a result source for the query rule, do the following:

      Click Add Source. In the Add Source dialog box, select a result source, and then click Save.

  6. To restrict the query rule to categories —for example, that a query rule should fire only when a term from your managed navigation term set is included in the query — click Show more conditions, and then specify the following:

    • To restrict the query rule to a category, click Add category. In the Import from Taxonomy dialog box, select a term that when you include it in a query will cause the query rule to fire, and then click Save.

    • To restrict the query rule to a user segment, do the following:

      1. Click Add User Segment.

      2. In the Add User Segment dialog box, in the Title field, type the title for this rule.

      3. In the Import from taxonomy dialog box, select a term that represents a user segment that will cause the query rule to fire when it appears in a query.

      4. Click Save

  7. In the Query Conditions section, select one of the conditions listed in the following table.

    Note:

    When you create query rules for catalog pages that have Web Parts that use search technology (described in this article as Search Web Parts), and you want the query that is configured in the Web Parts to act as the query condition, click Remove Condition, and then go to step 8. You should also do this if you want a query rule to fire every time that a user types anything in a search box.

    Query condition Description Configuration Example

    Query Matches Keyword Exactly

    Select this option if you want the query rule to fire when a query exactly matches a word or phrase that you specify.

    In the Query exactly matches one of these phrases text box, type one or more phrases separated by semicolons.

    You type "picture; pic" in the Query contains one of these phrases box. The query rule will fire when a user types "picture" or "pic" in a search box. The rule will not fire if a user types "pictures" or "sunny picture."

    Query Contains Action Term

    Select this option if you want the query rule to fire when a query contains a term that indicates something that the user wants to do. The term must be at the beginning or end of the query.

    Specify the action term that will cause the query rule to fire by doing one of the following:

    • Select Action term is one of these phrases, and type one or more phrases.

    • Select Action term is an entry in this dictionary, and then click Import from taxonomy. In the Import from taxonomy dialog box, select a term from a term set, and then click Save.

    You type the word "download" in the Action term is one of these phrases text box. When a user types "download Contoso Electronics datasheet" in a search box, the user is probably not searching for a document that contains the words "download," "Contoso," "Electronics," and "datasheet." Instead, the user is probably trying to download a Contoso Electronics datasheet. When a user types "download Contoso Electronics datasheet" in a search box, the query rule fires, and only the words "Contoso," "Electronics," and "datasheet" are passed to the search index.

    Query Matches Dictionary Exactly

    Select this option if you want the query rule to fire when the query exactly matches a dictionary entry.

    From the Query contains an entry in this dictionary menu, select a dictionary. To specify a different dictionary, click Import from taxonomy, and then from the Import from taxonomy dialog box, select a term from a term set, and then click Save.

    In an Internet business scenario, you have a term set named Brands that contains all brand names within your catalog. The query rule will fire when a user types a name that matches a term from the Brands term set.

    Query More Common in Source

    Select this option if you want the query rule to fire if the query was frequently issued by users on a different result source that you specify.

    In the Query is more likely to be used in this source menu, select a result source.

    In the Query is more likely to be used in this source menu, you select Local Video Results. The query rule will fire if a user types the word "training" in a search box and that word was frequently typed in a search box in the Videos vertical.

    Result Type Commonly Clicked

    Select this option if you want the query rule to fire if other users frequently clicked a particular result type after they typed the same query.

    In the Commonly clicked results match result type menu, select a result type.

    In an Internet business scenario, you have a catalog of electronic products. Each product has a PDF datasheet. So when users query for a specific product, the search results will return two result types: one that links to the page that has the product details, and one that links to the PDF datasheet. You can create a query rule that will fire if the system over time recognizes that users frequently click the search result for the PDF datasheet. When you know the type of content the user is looking for, you can specify an action for this query rule.

    Advanced Query Text Match

    Select this option if you want to use a regular expression, a phrase, or a dictionary entry that will cause the query rule to fire.

    To match all phone numbers that are in a certain format, you specify a regular expression in the Query matches this regular expression box.

    To match all phone numbers that are in the format nnn-nnn-nnnn, you specify the regular expression "\(?(\d{3})\)?-?(\d{3})-(\d{4})".

    To add conditions, click Add Alternate Conditions.

    Note:

    The rule will fire when any condition is true.

  8. In the Actions section, specify the action to take when the query rule fires. Specify one of the following:

    • To promote individual results so that they appear towards the top of search results, click Add Promoted Result (in SharePoint 2010 Products this was called Best Bets). In the Add Promoted Result dialog box, in the Title field, type the name that you want to give this promoted result. In the URL field, type the URL of the result that should be promoted. Render the URL as a banner instead of as a hyperlink. Click Save.

      You can add several individual promoted results. When there is more than one promoted result, you can specify the relative ranking.

    • To promote a group of search results, click Add Result Block. For more information, see Create and display a result block later in this article.

    • To change ranked search results, click Change ranked results by changing the query. For more information, see Change ranked search results later in this article.

  9. To make the query rule active during a particular time period, click Publishing, and then specify the period.

Create and display a result block

A result block is several search results that are displayed as a group. In the same manner as you can promote a specific result, you can promote a result block when a specified query condition applies. For example, you can create a result block named Yellow items for all catalog items that have the color yellow. In an Internet business scenario where you have a catalog of electronic products and you want to promote yellow mp3 players, you can create a query rule that fires for all items that are tagged with the term mp3 players, where the action is to display the result block Yellow items.

Result blocks are automatically displayed in the Search Results Web Part. To display results from a result block in a Content Search Web Part, you have to configure it to display the result block.

When you configure the query condition for a result block, you can use query variables. Query variables are placeholders for values that you don't know when you specify the query. However, when the query is run, this information is known and can be used when the system sends the query to the index. Examples are {User.Name}, which represents the display name of the user who typed the query, or {searchBoxQuery}, which represents the query that a user typed in a search box. When you use Query Builder to configure the query, a list of query variables is shown. (See step 3 in the following procedure.)

To create a result block

  1. In step 8 of the previous procedure, on the Add Query Rule page, in the Actions section, click Add Result Block.

  2. In the Block Title section, in the Title field, type a name for the result block.

  3. In the Query section, to specify the query, click Launch Query Builder. In Query Builder, specify the following:

    • On the BASIC tab, select options from the following lists to define the query for the result block:

      Select a query

      Select a result source to specify which content should be searched.

      Keyword filter

      You can use keyword filters to add query variables to your query. See Query variables in SharePoint Server 2013 for a list of available query variables.

      You can select pre-defined query variables from the drop-down list, and then add them to the query by clicking Add keyword filter.

      Property filter

      You can use property filters to query the content of managed properties that are set to queryable in the search schema.

      You can select managed properties from the Property filter drop-down list. Click Add property filter to add the filter to the query.

    • On the SORTING tab, you can specify how search results within your result block should be sorted. In the Sort by drop-down list:

      • To sort by managed properties that are set as sortable in the search schema, select a managed property from the list, and then select Descending or Ascending. To add more sorting levels, click Add sort level.

      • To sort by relevance rank, select Rank, and then do the following:

        • In the Ranking Model list, select which ranking model to use for sorting search results (this selection is optional).

        • In the Dynamic ordering section, to specify additional ranking by adding rules that will change the order of search results when certain conditions apply, click Add dynamic ordering rule, and then specify conditional rules.

    • On the TEST tab, you can preview the query that is sent.

      Query text

      Shows the final query that will be run by the Content Search Web Part. It is based on the original query template where dynamic variables are substituted with current values. Other changes to the query may have to be made as part of query rules.

      Click Show more to display additional information.

      Query template

      Shows the content of the query template that is applied to the query.

      Query template variables

      Shows the query variables that will be applied to the query, and the values of the variables that apply to the current page. You can type other values to test the effect they will have on the query. Click the Test Query button to preview the search results.

  4. In the Query section, in the Configure Query box, in the Search this Source drop-down list, select the result source to which this result block should be applied.

  5. In the Query section, in the Items drop-down list, select how many results to show in the result block.

  6. Click to expand the Settings section.

    The result block will only display the number of search results that you specified in the previous step. However, you can add a SHOW MORE link at the bottom of the result block that will show all search results for the result block. To add a SHOW MORE link, select "More" link goes to the following URL, and then type a URL. You can use query variables in this URL — for example, http://www.<site>/search/results.aspx?k={subjectTerms}.

  7. In the Routing section, in the field under Label for routing to a Content Search Web Part, type a label for routing the result block to a Content Search Web Part, or select an existing label. You will use this label in the following procedure, To configure a Content Search Web Part to display a result block.

  8. Click OK.

To configure a Content Search Web Part to display a result block

  1. Add a Content Search Web Part to a page as described in "Add a Content Search Web Part to a page" in Configure Search Web Parts in SharePoint Server 2013.

  2. In the Web Part, click the Content Search Web Part Menu arrow, and then click Edit Web Part.

  3. In the Web Part tool pane, in the Properties section, expand the Settings section.

  4. In the Settings section, from the Result Table list, select the label of the result block that you want to display. The label is what you specified in step 7 in the previous procedure, To create a result block.

  5. To use the query results that are returned from another Web Part on the page as input when displaying the result block, from the Query results provided by list, select a Web Part.

Note:

When displaying a result block in a Content Search Web Part, paging of search results is not supported through the Control Display Template.

Display promoted results in a Content Search Web Part

To display promoted results in a Content Search Web Part

  1. Add a Content Search Web Part to a page as described in "Add a Content Search Web Part to a page" in Configure Search Web Parts in SharePoint Server 2013.

  2. In the Web Part, click the Content Search Web Part Menu arrow, and then click Edit Web Part.

  3. In the Web Part tool pane, in the Properties section, expand the Settings section.

  4. In the Settings section, in the Result Table list, select SpecialTermResults.

Change ranked search results

The ranking model calculates a ranking order of search results. You can change this ranking by promoting or demoting items within the search results. For example, for a query that contains "download toolbox," you can create a query rule that recognizes the word "download" as an action term, and change the ranked search results to promote a URL of a particular download site on your intranet. You can also change the sorting order of the search results dynamically, based on several variables such as file name extension or specific keywords. Changing ranked search results by changing the query has the advantage that the results are security trimmed and refinable. Moreover, the search results will not appear if the document is no longer available.

To change ranked search results by changing the query

  1. From step 8 of the procedure Create a query rule, on the Add Query Rule page, in the Actions section, click Change ranked results by changing the query.

  2. In the Build Your Query dialog box, specify the following:

    • On the BASIC tab, select options from the following lists to change ranked search results:

      Select a query

      Select a result source to specify which content should be searched.

      Keyword filter

      You can use keyword filters to add query variables to your query. See Query variables in SharePoint Server 2013 for a list of available query variables.

      You can select pre-defined query variables from the drop-down list, and then add them to the query by clicking Add keyword filter.

      Property filter

      You can use property filters to query the content of managed properties that are set to queryable in the search schema.

      You can select managed properties from the Property filter drop-down list. Click Add property filter to add the filter to the query.

    • On the SORTING tab, you can specify how search results should be sorted by doing the following:

      • In the Sort by drop-down list:

        • To sort by managed properties that are set as sortable in the search schema, select a managed property from the list, and then select Descending or Ascending. To add more sorting levels, click Add sort level.

        • To sort by relevance rank, select Rank, and then do the following:

          • In the Ranking Model list, select which ranking model to use for sorting search results (this selection is optional).

          • In the Dynamic ordering section, to specify additional ranking by adding rules that will change the order of search results when certain conditions apply, click Add dynamic ordering rule, and then specify conditional rules.

    • On the TEST tab, you can preview the query.

      Query text

      Shows the final query that will be run by the Content Search Web Part. It is based on the original query template where dynamic variables are substituted with current values. Other changes to the query may have to be made as part of query rules.

      Click Show more to display additional information.

      Query template

      Shows the content of the query template that is applied to the query.

      Query template variables

      Shows the query variables that will be applied to the query, and the values of the variables that apply to the current page. You can type other values to test the effect they will have on the query. Click the Test Query button to preview the search results.

Make a query rule inactive

Query rules that are created at the Search service application level are inherited by site collections and sites that are in web applications that consume the Search service application. Similarly, query rules that are created at the site collection level are inherited by sites in the site collection. If you don't want a query rule to apply to a site that inherits it, you can set the query rule as inactive for the site.

To make a query rule inactive on a site

  1. Verify that the user account that performs this procedure is a member of the Owners group on the publishing site.

  2. On the publishing site collection, on the Settings menu, click Site Settings.

  3. In the site collection, in the Settings menu, click Site Settings.

  4. On the Site Settings page, in the Search section, click Query Rules.

  5. On the Manage Query Rules page, on the Select a Result Source menu, select the result source that contains the query rule that you want to make inactive.

  6. In the Name column, point to the query rule that you want to make inactive, click the arrow that appears, and then click Make Inactive.

Rank query rules

When multiple query rules are active for a Search service application, a site collection, or a site, more than one rule can fire for a query that is performed at that level. By default, the rules do not fire in a prescribed order. You can control the order in which the rules fire by adding the query rules that you create to query groups. To do this, you select rules to add to a group, and then you specify the order in which the rules in the group will fire if they are triggered. You can also prevent query rules that rank lowest in a group from firing even if they are triggered.

To rank query rules for a site collection

  1. Verify that the user account that performs this procedure is a site collection administrator for the publishing site collection.

  2. On the publishing site collection, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Collection Administration section, click Search Query Rules.

  4. On the Manage Query Rules page, on the Select a Result Source menu, select the result source that contains the query rules that you want to group.

  5. For each query rule that you created that you want to add to a group, point to the rule and select the check box.

    Note:

    Query rules that you created for this site collection are listed in the Defined for this site collection section.

  6. Click Order Selected Rules.

  7. In the Order Selected Rules dialog box, do either of the following, and then click OK:

    • Select Move rules to new group with this name, and then type a name for the group.

    • Select Move rules to existing group and select a group in the drop-down list.

  8. On the Manage Query Rules page, do the following:

    1. To change the order in which a rule in a group will fire if it is triggered, change the numeric order of the rule.

    2. To prevent query rules that are ranked lowest in the group from firing, in the row for the group's query rule that should fire last, in the Actions column, in the Continue/Stop drop-down list, select Stop.

See also

Plan to transform queries and order results in SharePoint 2013
Query variables in SharePoint Server 2013


Configure recommendations and usage event types in SharePoint Server 2013
See also

Published: October 16, 2012

Applies to: SharePoint Server 2013

Usage events enable you to track how users interact with items on your site. Items can be documents, sites, or catalog items. When a user interacts with an item on your site, SharePoint Server 2013 generates a usage event for this action. For example, if you want to monitor how often a catalog item is viewed from a mobile phone, you can track this activity.

This article describes how to create custom usage event types, and how to add code to record custom usage events so that they can be processed by the analytics processing component.

You can use the data that is generated by usage events to show recommendations or popular items on your site. This article also explains how to influence how recommendations are shown by changing the level of importance for a specific usage event type. For more information, see "Plan usage analytics, usage events and recommendations" in Plan search for cross-site publishing sites in SharePoint Server 2013.

You can view the statistics for all usage event types in Popularity Trends and Most Popular Items reports. For more information, see View usage reports in SharePoint Server 2013.

In this article:

  • Before you begin

  • Create a custom usage event type

  • Record a custom usage event

  • Record a default usage event

  • Change the level of importance of a usage event type

  • Change the Recent time period for a usage event type

  • Enable and disable the logging of usage events of anonymous users

  • Get SiteId GUID and WebId GUID for a site

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Create a custom usage event type

There are three default usage event types in SharePoint 2013. You can create up to twelve custom usage event types by using Windows PowerShell.

To create a custom usage event type

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To get a site at the root site collection level:
$Site = Get-SPSite "http://localhost"

# To get a site below the root site collection level:
$Site = Get-SPSite "http://localhost/sites/<SiteName>"

# To create a custom usage event type:
$SSP = Get-SPEnterpriseSearchServiceApplicationProxy
$EventGuid = [Guid]::NewGuid()
$EventName = "<EventTypeName>"
$tenantConfig = $SSP.GetAnalyticsTenantConfiguration([Guid]::Empty)
$newEventType = $tenantConfig.RegisterEventType($EventGuid, $EventName, "")
$tenantConfig.Update($SSP)

    Where:

    • <SiteName> is the name of the site for which you want to create a custom usage event.

    • <EventTypeName> is the name of the new custom usage event type that you want to create — for example, BuyEventType.

    This procedure creates a random GUID for the usage event type. Use this GUID when you add code to record the custom usage event, as described in Record a custom usage event.

    Important:

    It can take up to three hours for a custom usage event type to become available in the system. However, to speed up the process, you can alternatively restart the SharePoint Timer Service.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Record a custom usage event

After you have created a custom usage event type, as described in Create a custom usage event type, you have to add code to the place where the event occurs — for example, when a page loads, or when a user clicks a link or a button. This data is then sent to the analytics processing component, where it is recorded and processed.

If you are using cross-site publishing, where you show catalog content on a publishing site, you must record the usage event on the URL of the indexed item, and override some site settings. For example, if you have a catalog in an authoring site that you have published on a publishing site, when a user interacts with a catalog item on the publishing site, this usage event must be recorded on the item in the authoring site. Furthermore, the code that you add to record the usage event must override the SiteId and the WebId of the publishing site, and be replaced with the SiteId and the WebId of the authoring site.

To add code to record a custom usage event

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To view GUIDs for all usage event types:
$SSP = Get-SPEnterpriseSearchServiceApplicationProxy
$SSP.GetAnalyticsEventTypeDefinitions([Guid]::Empty, 3) | ft

  4. In an HTML editor, open the file where the custom usage event should be logged — for example, a display template for a Content Search Web Part, and add the following code:

    Copy code
    window.Log<CustomUsageEventType>ToEventStore = function(url)
{
    ExecuteOrDelayUntilScriptLoaded(function()
    {
        var spClientContext = SP.ClientContext.get_current();
        var eventGuid = new SP.Guid("<GUID>");
        SP.Analytics.AnalyticsUsageEntry.logAnalyticsAppEvent(spClientContext, eventGuid, url);
        spClientContext.executeQueryAsync(null, Function.createDelegate(this, function(sender, e){ alert("Failed to log event for item: " + document.URL + " due to: " + e.get_message()) }));
    }, "SP.js");
}

    • <CustomUsageEventType> is the name of the custom event — for example, BuyEventType.

    • <GUID> is the numeric ID of the usage event type — for example, 4e605543-63cf-4b5f-aab6-99a10b8fb257.

  5. In an HTML editor, open the file that refers to the custom usage event, and add the following code:

    Copy code
    # The example below shows how a custom usage event type is referred to when a button is clicked:
<button onclick="Log<CustomUsageEventType>ToEventStore('<URL>')"></button>

    Where:

    • <CustomUsageEventType> is the name of the custom event type.

    • <URL> is the full URL of the item to which the usage event should be logged — for example, http://contoso.com/faq.

To add code to record a custom usage event and override site settings

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To view GUIDs for all usage event types:
$SSP = Get-SPEnterpriseSearchServiceApplicationProxy
$SSP.GetAnalyticsEventTypeDefinitions([Guid]::Empty, 3) | ft

  4. In an HTML editor, open the file where the custom usage event should be logged — for example, a display template for a Content Search Web Part. The following example shows how to override the current SiteId, WebId and UserId.

    Copy code
    window.Log<CustomUsageEventType>ToEventStore = function(url, siteIdGuid, webIdGuid, spUser)
{
    ExecuteOrDelayUntilScriptLoaded(function()
    {
      var spClientContext = SP.ClientContext.get_current();
      var eventGuid = new SP.Guid("<GUID>");
SP.Analytics.AnalyticsUsageEntry.logAnalyticsAppEvent2(spClientContext, eventGuid, url, webIdGuid, siteIdGuid, spUser);
      spClientContext.executeQueryAsync(null, Function.createDelegate(this, function(sender, e){ alert("Failed to log event for item: " + document.URL + " due to: " + e.get_message()) }));
    }, "SP.js");
}

    Where:

    • <CustomUsageEventType> is the name of the custom event type — for example, BuyEventType.

    • <GUID> is the numeric ID of the usage event type — for example, 4e605543-63cf-4b5f-aab6-99a10b8fb257.

  5. In an HTML editor, open the file that refers to the custom usage event type, and add the following code:

    Copy code
    # The example below shows how a custom usage event type is referred to when the "Buy!" button is clicked:
<button onclick="Log<CustomUsageEventType>ToEventStore('<URL>', new SP.Guid('{<SiteId GUID>}'), new SP.Guid('{<WebId GUID>}'), '<UserName>')">Buy!</button>

    Where:

    • <CustomUsageEventType> is the name of the custom event type — for example, BuyEventType.

    • <URL> is the URL found in the managed property OriginalPath.

    • <SiteId GUID> is the SiteId GUID of the authoring site. For information about how to get the SiteId GUID, see Get SiteId GUID and WebId GUID for a site.

    • <WebId GUID> is the WebId GUID of the authoring site. For information about how to get the WebId GUID, see Get SiteId GUID and WebId GUID for a site.

    • <UserName> can be a cookie ID that is used to identify users on a site that has anonymous users.

Record a default usage event

If you want to add code that refers to a default usage event type — for example, views, you have to add code to the place where the event occurs.

If you are using cross-site publishing, which shows catalog content on a publishing site, you must record the usage event on the URL of the indexed item, and override some site settings. For example, if you have a catalog in an authoring site that you have published on a publishing site, when a user interacts with a catalog item on the publishing site, this usage event must be recorded on the item in the authoring site. Furthermore, the code that you add to record the usage event must override the SiteId and WebId of the publishing site, and be replaced with the SiteId and WebId of the authoring site.

To add code to record a default usage event

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To view EventTypeId for all usage event types:
$SSP = Get-SPEnterpriseSearchServiceApplicationProxy
$SSP.GetAnalyticsEventTypeDefinitions([Guid]::Empty, 3) | ft

  4. In an HTML editor, open the file where the custom usage event should be logged — for example, a display template for a Content Search Web Part, and add the following code:

    Copy code
    window.Log<DefaultUsageEventType>ToEventStore = function(url)
{
    ExecuteOrDelayUntilScriptLoaded(function()
    {
        var spClientContext = SP.ClientContext.get_current();
        SP.Analytics.AnalyticsUsageEntry.logAnalyticsEvent(spClientContext, <EventTypeId>, url);
        spClientContext.executeQueryAsync(null, Function.createDelegate(this, function(sender, e){ alert("Failed to log event for item: " + document.URL + " due to: " + e.get_message()) }));
    }, "SP.js");
}

    Where:

    • <DefaultUsageEventType> is the name of the default usage event type — for example, Views.

    • <EventTypeId> is the numeric ID of the usage event type — for example, 1.

  5. In an HTML editor, open the file that refers to the default usage event, and add the following code:

    Copy code
    # The example below shows how a default usage event type is referred to on a page load:
<body onload="Log<DefaultUsageEventType>ToEventStore('<URL>')">

    Where:

    • <DefaultUsageEventType> is the name of the default usage event type — for example, Views.

    • <URL> is the full URL of the item to which the usage event should be logged, — for example, http://contoso.com/careers

  6. Save the file.

To add code to record a default usage event and override site settings

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To view EventTypeId for all usage event types:
$SSP = Get-SPEnterpriseSearchServiceApplicationProxy
$SSP.GetAnalyticsEventTypeDefinitions([Guid]::Empty, 3) | ft

  4. In an HTML editor, open the file where the custom usage event should be logged — for example, a display template for a Content Search Web Part. The example below shows how to override the current SiteId, the WebId and the UserId.

    Copy code
    window.Log<DefaultUsageEventType>ToEventStore = function(url, siteIdGuid, webIdGuid, spUser)
{
    ExecuteOrDelayUntilScriptLoaded(function()
    {
      var spClientContext = SP.ClientContext.get_current();
      SP.Analytics.AnalyticsUsageEntry.logAnalyticsEvent(spClientContext, <EventTypeId>, url, webIdGuid, siteIdGuid, spUser);
spClientContext.executeQueryAsync(null, Function.createDelegate(this, function(sender, e){ alert("Failed to log event for item: " + document.URL + " due to: " + e.get_message()) }));
    }, "SP.js");
}

    Where:

    • <DefaultUsageEventType> is the name of the default event type — for example, Views.

    • <EventTypeId> is the numeric ID of the usage event type — for example, 1.

  5. In an HTML editor, open the file that refers to the default usage event type, and add the following code:

    Copy code
    # The example below shows how a default usage event type is referred to on a page load:
<body onload="Log<DefaultUsageEventType>ToEventStore('<URL>', new SP.Guid('{<SiteId GUID>}'), new SP.Guid('{<WebId GUID>}'), '<UserName>')">

    Where:

    • <DefaultUsageEventType> is the name of the default event type — for example, Views.

    • <URL> is the URL in the managed property OriginalPath.

    • <SiteId GUID> is the SiteId GUID of the authoring site. For information on how to get the SiteId GUID, see Get SiteId GUID and WebId GUID for a site.

    • <WebId GUID> is the WebId GUID of the authoring site. For information on how to get the WebId GUID, see Get SiteId GUID and WebId GUID for a site.

    • <UserName> can be a cookie ID that is used to identify users on a site that has anonymous users, for example.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Change the level of importance of a usage event type

The usage event type property, RecommendationWeight, is a numeric value that shows the level of importance of a usage event type compared to other usage event types that are used in the recommendations calculation. The default Views usage event type has a preconfigured RecommendationWeight value of 1. The other default usage event types, Recommendations displayed, and Recommendations clicked, and all custom usage event types, have a RecommendationWeight value of 0. To increase the importance of a usage event type in the recommendations calculation, change the value of the RecommendationWeight parameter. The highest level of importance available is 10.

To change the level of importance of a usage event type

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To view EventTypeId for all usage event types:
$SSP = Get-SPEnterpriseSearchServiceApplicationProxy
$SSP.GetAnalyticsEventTypeDefinitions([Guid]::Empty, 3) | ft

# To get a usage event type:
$tenantConfig = $SSP.GetAnalyticsTenantConfiguration([Guid]::Empty)
$event = $tenantConfig.EventTypeDefinitions | where-object { $_.EventTypeId -eq <EventTypeId> }

# To change the importance level of a usage event type:
$event.RecommendationWeight = <RecommendationWeightNumber>
$tenantConfig.Update($SSP)

# To verify the changed importance level for the usage event type:
$tenantConfig = $SSP.GetAnalyticsTenantConfiguration([Guid]::Empty)
$event = $tenantConfig.EventTypeDefinitions | where-object { $_.EventTypeId -eq <EventTypeId> }
$event

    Where:

    • <EventTypeId> is the numeric ID of the usage event type for which you want to change the weight — for example, 256.

    • <RecommendationWeightNumber> is the level of importance that you want to apply to the user event type — for example, 4.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Change the Recent time period for a usage event type

The usage event type property RecentPopularityTimeframe is a numeric value that defines the Recent time period in the Most Popular Items report. The Most Popular Items report shows the most popular items per usage event type for all items in a library or list — for example, the most viewed items in a library or list. The report can be sorted by the time periods Recent or Ever. By default, the Recent time period is set to the last 14 days for each usage event. You can change this to a time period between one and 14 days.

To change the Recent time period for a usage event type

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To view EventTypeId for all usage event types:
$SSP = Get-SPEnterpriseSearchServiceApplicationProxy
$SSP.GetAnalyticsEventTypeDefinitions([Guid]::Empty, 3) | ft

# To get a usage event type:
$tenantConfig = $SSP.GetAnalyticsTenantConfiguration([Guid]::Empty)
$event = $tenantConfig.EventTypeDefinitions | where-object { $_.EventTypeId -eq <EventTypeId> }

# To change the Recent time span for a usage event type:
$event.RecentPopularityTimeFrame = <TimeFrame>
$tenantConfig.Update($SSP)

# To verify the changed Recent time frame for the usage event type:
$tenantConfig = $SSP.GetAnalyticsTenantConfiguration([Guid]::Empty)
$event = $tenantConfig.EventTypeDefinitions | where-object { $_.EventTypeId -eq <EventTypeId> }
$event

    Where:

    • <EventTypeId> is the numeric ID of the usage event type for which you want to change the Recent time frame — for example, 256.

    • <TimeFrame> is the new Recent time frame that you want to apply to the user event type — for example, 7.

    Note:

    The system updates any changes to the Recent time period only after the Usage Analytics Timer Job has run.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Enable and disable the logging of usage events of anonymous users

Users that are browsing the contents of a site without being connected to an account are known as anonymous users. Only the Views event type is enabled for the logging of anonymous users. By default, the logging of custom usage events is disabled for anonymous users.

To enable the logging of usage events of anonymous users

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To view EventTypeId for all usage event types:
$SSP = Get-SPEnterpriseSearchServiceApplicationProxy
$SSP.GetAnalyticsEventTypeDefinitions([Guid]::Empty, 3) | ft

# To get a usage event type:
$tenantConfig = $SSP.GetAnalyticsTenantConfiguration([Guid]::Empty)
$event = $tenantConfig.EventTypeDefinitions | where-object { $_.EventTypeId -eq <EventTypeId> }

# To enable the logging of anonymous users:
$event.Options = [Microsoft.Office.Server.Search.Analytics.EventOptions]::AllowAnonymousWrite
$tenantConfig.Update($SSP)

# To verify that the logging of anonymous users has been enabled, i.e. that the Options property is set to AllowAnonymousWrite:
$tenantConfig = $SSP.GetAnalyticsTenantConfiguration([Guid]::Empty)
$event = $tenantConfig.EventTypeDefinitions | where-object { $_.EventTypeId -eq <EventTypeId> }
$event

    Where:

    • <EventTypeId> is the numeric ID of the usage event type that you want to enable for the logging of anonymous users — for example, 256.

To disable the logging of usage events of anonymous users

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To view EventTypeId for all usage event types:
$SSP = Get-SPEnterpriseSearchServiceApplicationProxy
$SSP.GetAnalyticsEventTypeDefinitions([Guid]::Empty, 3) | ft

# To get a usage event type:
$tenantConfig = $SSP.GetAnalyticsTenantConfiguration([Guid]::Empty)
$event = $tenantConfig.EventTypeDefinitions | where-object { $_.EventTypeId -eq <EventTypeId> }

# To disable the logging of anonymous users:
$event.Options = [Microsoft.Office.Server.Search.Analytics.EventOptions]::None
$tenantConfig.Update($SSP)

# To verify that logging of anonymous users has been disabled, i.e. that the Options property is set to None:
$tenantConfig = $SSP.GetAnalyticsTenantConfiguration([Guid]::Empty)

    Where:

    • <EventTypeId> is the numeric ID of the usage event type that you want to disable for the logging of anonymous users — for example, 256.

    Note:

    For the default usage event type Views, you cannot disable the logging of anonymous users.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Get SiteId GUID and WebId GUID for a site

You can use the following PowerShell commands to get the SiteId GUID and the WebId GUID for a site.

To get SiteId GUID and WebId GUID for a site

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    # To get the SiteId GUID and the WebId GUID for a root site collection:
$site = Get-SPSite "<RootSiteURL>"
$web = $site.RootWeb
$site.id
$web.id

# To get the WebId GUID for a site below the root site collection:
$site = Get-SPSite "<RootSiteURL>"
$web = $site.OpenWeb("<SubSiteLocation>")
$web.id

    Where:

    • <RootSiteURL> is the URL of the root site that you want to get the SiteId GUID and the WebId GUID of — for example, http://contoso.com/sites/catalog.

    • <SubSiteLocation> is the remainder of the URL path to the subsite after the root site URL. For example, if your root site URL is http://contoso.com/sites/catalog, and your subsite URL is http://contoso.com/sites/catalog/products, type products for this placeholder.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

View usage reports in SharePoint Server 2013


Configure workflow in SharePoint Server 2013

Published: September 11, 2012

Summary: Learn how to install and configure the SharePoint 2013 Workflow platform in SharePoint Server 2013. This section includes step-by-step procedures and videos.

Applies to: SharePoint Server 2013

This section describes how to configure workflow in SharePoint Server 2013.

In this section:

  • Install and configure workflow for SharePoint Server 2013 This article describes how to install and configure the SharePoint 2013 Workflow platform to work with SharePoint Server.

  • Install Workflow Manager certificates in SharePoint Server 2013 Secure Sockets Layer (SSL) certificates are used to provide encrypted communication between SharePoint Server 2013 and Workflow Manager. This article describes how to install the SSL certificates.

  • Update Workflow in SharePoint Server 2013 This article describes the process for updating Workflow Manager and SharePoint Server with Cumulative Updates.

  • Video series: Install and configure Workflow in SharePoint Server 2013 This article contains a six-part series that walks through the process of installing and configuring the SharePoint 2013 Workflow Platform by using Secure Sockets Layer (SSL).


Install and configure workflow for SharePoint Server 2013
See also

Updated: April 30, 2013

Summary: Learn how to install and configure workflow in SharePoint Server 2013.

Applies to: SharePoint Server 2013

This article contains the information and procedures required to configure workflow in SharePoint Server 2013.

In this article:

  • Overview

  • Before you begin

  • Install and configure SharePoint Server 2013

  • Install and configure Workflow Manager

  • Configure Workflow Manager to work with the SharePoint Server 2013 farm

  • Validate the installation

  • Troubleshooting

  • Related topics

Important:

The steps in this article apply to SharePoint Server 2013. The SharePoint 2013 Workflow platform is not supported in SharePoint Foundation 2013.

Note:

You can watch a video series that walks through the process of installing and configuring the SharePoint Server 2013 Workflow platform. To view the videos, see Video series: Install and configure Workflow in SharePoint Server 2013

Overview

A new option exists when you build a workflow for SharePoint Server 2013. This option is called Platform Type. The figure shows the Platform Type option when you are creating a new workflow by using SharePoint Designer 2013.

Figure: SharePoint 2013 includes three workflow platform options.

Three workflow platforms in SharePoint 2013.

The only platform available when you first install SharePoint Server 2013 is the SharePoint 2010 Workflow platform. The SharePoint 2013 Workflow platform and the Project Server platform require additional steps. The three workflow platforms are outlined in the following table.

Workflow Platform types available in SharePoint Server 2013

Platform Type Platform Framework Requirements

SharePoint 2010 Workflow

Windows Workflow Foundation 3

Installs automatically with SharePoint 2013 Products.

SharePoint 2013 Workflow

Windows Workflow Foundation 4

Requires SharePoint Server 2013 and Workflow Manager.

Note:

Workflow Manager must be downloaded and installed separately from SharePoint Server 2013. It does not install automatically when you install SharePoint Server 2013.

SharePoint 2013 Workflow - Project Server

Windows Workflow Foundation 4

Requires SharePoint Server 2013, Workflow Manager, and Project Server 2013.

To learn more about workflow development with SharePoint Designer 2013 and other aspects of workflow, see the Workflow in SharePoint 2013 Resource Center.

Before you begin

Before you begin installation, make sure that you have met all hardware and software requirements for both SharePoint Server 2013 and Workflow Manager. For more information, see Hardware and software requirements for SharePoint 2013 and Planning your Workflow Manager Deployment.

Important:

The steps in this article apply to SharePoint Server 2013. The SharePoint 2013 Workflow platform is not supported in SharePoint Foundation 2013.

Install and configure SharePoint Server 2013

You must install and configure SharePoint Server 2013. To do so, see Install and deploy SharePoint 2013.

Note:

The SharePoint 2010 Workflow platform installs automatically when you install SharePoint Server 2013. The SharePoint 2013 Workflow platform requires Workflow Manager and must be installed separately and then configured to work with your SharePoint Server 2013 farm.

Install and configure Workflow Manager

You must install and configure Workflow Manager. To do so, see Installing and Configuring Workflow.

Configure Workflow Manager to work with the SharePoint Server 2013 farm

You must consider the following two key factors before configuring Workflow Manager to work with SharePoint Server 2013.

  • Is Workflow Manager installed on a server that is part of the SharePoint farm?

  • Will communication between Workflow Manager and SharePoint Server 2013 use HTTP or HTTPS?

These factors translate into four scenarios. Each scenario configures a SharePoint Server 2013 farm to communicate and function with the Workflow Manager farm. Follow the scenario that matches your circumstance.

1: Workflow Manager is installed on a server that is part of the SharePoint 2013 farm. Communication takes place by using HTTP. | 2: Workflow Manager is installed on a server that is part of the SharePoint 2013 farm. Communication takes place by using HTTPS.
3: Workflow Manager is installed on a server that is NOT part of the SharePoint 2013 farm. Communication takes place by using HTTP. | 4: Workflow Manager is installed on a server that is NOT part of the SharePoint 2013 farm. Communication takes place by using HTTPS.

Note:

For security reasons, we recommend HTTPS for a production environment.

Tip:

For information about least-privilege configuration, see Least Privilege Configuration for Workflow Manager with SharePoint Server 2013.

To configure Workflow Manager on a server that is part of the SharePoint 2013 farm and on which communication takes place by using HTTP

  1. Log on to the computer in the SharePoint Server 2013 farm where Workflow Manager was installed.

  2. Open the SharePoint Management Shell as an administrator. This is accomplished by right-clicking the SharePoint 2013 Management Shell and choosing Run as administrator.

  3. Run the Register-SPWorkflowService cmdlet.

    Example:

    Copy code
    Register-SPWorkflowService -SPSite "http://myserver/mysitecollection" -WorkflowHostUri "http://workflow.example.com:12291" -AllowOAuthHttp

  4. Log on to each server in the SharePoint Server 2013 farm.

    Each server in the SharePoint Server 2013 farm must have the Workflow Manager Client installed.

    Note:

    When you install Workflow Manager on a server it automatically installs the Workflow Manager Client on that server. You will still need to install the Workflow Manager Client on any additional servers. For example, if you have a farm that contains five servers and you install Workflow Manager on one of those servers you will still need to install the Workflow Manager Client on the four additional servers.

  5. Install the Workflow Manager Client on each server in the SharePoint farm.

    Download and install the Workflow Manager Client here: http://go.microsoft.com/fwlink/p/?LinkID=268376

To configure Workflow Manager on a server that is part of the SharePoint 2013 farm and on which communication takes place by using HTTPS

  1. Determine if you need to install Workflow Manager certificates in SharePoint.

    Under some circumstances, you have to obtain and install Workflow Manager certificates. If your installation requires that you obtain and install these certificates, you must complete that step before continuing. To learn whether you need to install certificates, and for instructions, see Install Workflow Manager certificates in SharePoint Server 2013.

  2. Log into the computer in the SharePoint Server 2013 farm where Workflow Manager was installed.

  3. Open the SharePoint Management Shell as an administrator. This is accomplished by right-clicking the SharePoint 2013 Management Shell and choosing Run as administrator.

  4. Run the Register-SPWorkflowService cmdlet.

    Example:

    Copy code
    Register-SPWorkflowService -SPSite "https://myserver/mysitecollection" -WorkflowHostUri "https://workflow.example.com:12290"

  5. Log on to each server in the SharePoint Server 2013 farm.

    Each server in the SharePoint Server 2013 farm must have the Workflow Manager Client installed.

    Note:

    When you install Workflow Manager on a server it automatically installs the Workflow Manager Client on that server. You will still have to install the Workflow Manager Client on any additional servers. For example, if you have a farm that contains five servers and you install Workflow Manager on one of those servers you will still need to install the Workflow Manager Client on the four additional servers.

  6. Install the Workflow Manager Client on each server in the SharePoint farm.

    Download and install the Workflow Manager Client here: http://go.microsoft.com/fwlink/p/?LinkID=268376

To configure Workflow Manager on a server that is NOT part of the SharePoint 2013 farm and on which communication takes place by using HTTP

  1. Log on to each server in the SharePoint Server 2013 farm.

  2. Install the Workflow Manager Client on each server in the SharePoint farm.

    Before you can run the workflow pairing cmdlet, you must install Workflow Manager Client on each of the servers in the SharePoint farm.

    Download and install the Workflow Manager Client here: http://go.microsoft.com/fwlink/p/?LinkID=268376

  3. Open the SharePoint Management Shell as an administrator. This is accomplished by right-clicking the SharePoint 2013 Management Shell command and choosing Run as administrator.

  4. Run the Register-SPWorkflowService cmdlet. The cmdlet should be run only once and can be run from any of the servers in the SharePoint farm.

    Example:

    Copy code
    Register-SPWorkflowService -SPSite "http://myserver/mysitecollection" -WorkflowHostUri "http://workflow.example.com:12291" -AllowOAuthHttp
    Important:

    You must install the Workflow Manager Client on each server in the SharePoint farm before you run the pairing cmdlet.

To configure Workflow Manager on a server that is NOT part of the SharePoint 2013 farm and on which communication takes place by using HTTPS

  1. Determine whether you need to install Workflow Manager certificates in SharePoint 2013.

    Under some circumstances, you have to obtain and install Workflow Manager certificates. If your installation requires that you obtain and install these certificates, you must complete that step before continuing. To learn whether you need to install certificates, and for instructions, see Install Workflow Manager certificates in SharePoint Server 2013.

  2. Log on to each server in the SharePoint Server 2013 farm.

  3. Install the Workflow Manager Client on each server in the SharePoint farm.

    Before you can run the workflow pairing cmdlet, you must install Workflow Manager Client on each of the servers in the SharePoint farm.

    Download and install the Workflow Manager Client here: http://go.microsoft.com/fwlink/p/?LinkID=268376

  4. Open the SharePoint Management Shell as an administrator. This is accomplished by right-clicking the SharePoint 2013 Management Shell command and choosing Run as administrator.

  5. Run the Register-SPWorkflowService cmdlet.

    Example:

    Copy code
    Register-SPWorkflowService -SPSite "https://myserver/mysitecollection" -WorkflowHostUri "https://workflow.example.com:12290"
    Important:

    You must install the Workflow Manager Client on each server in the SharePoint farm before you run the pairing cmdlet.

Validate the installation

Use these steps to validate that you have successfully installed and configured the required components.

To validate the installation

  1. Add a user to your SharePoint site, and grant the user Site Designer permissions.

  2. Install SharePoint Designer 2013 and create a workflow based on the SharePoint 2013 Workflow platform. For more information, see Creating a workflow by using SharePoint Designer 2013 and the SharePoint 2013 Workflow platform.

  3. Run this workflow from the SharePoint user interface.

Troubleshooting

For security reasons, the Setup account cannot be used to create a workflow based on the SharePoint 2013 Workflow platform. If you try to create a workflow based on the SharePoint 2013 Workflow platform by using SharePoint Designer 2013, you receive a warning that the list of workflow actions do not exist, and the workflow is not created.

The user who deploys and runs a workflow must be added to the User Profile service. Check the User Profile service application page in Central Administration to confirm that the user you are using to validate workflow installation is in the User Profile service.

You can determine which ports SharePoint Server 2013 and Workflow Manager are using for both HTTP and HTTPS by using IIS Manager as shown in the figure.

Figure: Use IIS Manager to view the ports used by Workflow Manager

View ports in IIS Manager.

Workflow Manager communicates by using TCP/IP or Named Pipes. Make sure that the appropriate communication protocol is enabled on the SQL Server instance that hosts the Workflow Manager databases.

The SQL Browser Service must be running on the SQL Server instance that hosts the Workflow Manager databases.

The System Account cannot be used to develop a workflow.

To troubleshoot Workflow Manager, see Troubleshooting Workflow Management and Execution.

To troubleshoot SharePoint Server 2013, see Troubleshooting SharePoint 2013.

See also

Installation and Deployment for SharePoint 2013 Resource Center
What's New in SharePoint 2013 Resource Center
Workflow Resource Center

Change History

Date | Description
April 30, 2013 | Added information about the six-part video series that walks through the process of installing and configuring workflow in SharePoint Server 2013.
March 12, 2013 | Added information to reflect that the Workflow Manager Client should be installed on every server in the SharePoint Server 2013 farm. This is to accomodate the fact that it is common to move SharePoint servers between roles and if a server that does not have the Workflow Manager Client installed takes on the role of a Web Front End (WFE) then workflow will break.
March 05, 2013 | Information added about least privilege configuration.
September 11, 2012 | Initial publication


Install Workflow Manager certificates in SharePoint Server 2013
See also

Published: September 11, 2012

Summary: Learn how to configure SSL certificates for encrypted communication between Workflow Manager and SharePoint Server 2013.

Applies to: SharePoint Server 2013

Secure Socket Layer (SSL) is an encrypted communication protocol which uses encryption certificates. Workflow Manager and SharePoint Server 2013 can communicate in a secure manor using SSL. This article describes the steps required to setup and configure SSL certificates.

Configuration steps

The following sections provide instructions for configuring SSL communication with Workflow Manager and SharePoint Server 2013.

Enable SSL

Enable Secure Sockets Layer (SSL) in IIS Manager. For guidance on completing the configuration, see the following:

  • Configuring SSL in IIS Manager

  • How to Set Up SSL on IIS 7

Install Workflow Manager certificates in SharePoint

Under some circumstances, you must obtain and install Workflow Manager "issuer" certificates on SharePoint Server 2013. Here are the circumstances where you must install Workflow Manager certificates:

  1. If SSL is enabled either on SharePoint Server 2013 (which is not the default) or on Workflow Manager (which is the default), AND

  2. If SharePoint Server 2013 and Workflow Manager do not share a Certificate Authority, AND

  3. If Workflow Manager is configured to generate self-signed certificates (which is the default).

Note:

Product trial, workflow development, and troubleshooting are easier if SSL is not enabled. However, communication between SharePoint Server 2013 and Workflow Manager is not encrypted if SSL is not enabled. For this reason, SSL should be enabled for production configurations.

To obtain and export certificates from the Workflow Manager server

  1. On a computer that has Workflow Manager installed, choose IIS Manager, Sites. Right-click Workflow Management Site, and then choose Edit Bindings.

  2. Choose the https port, and then choose Edit. Choose the View button in the SSL Certificate section.

  3. To export the issuer certificate, do the following:

    1. In the Certificate window, choose the Certification path tab.

    2. Select root certification path and choose View.

    3. On the Details tab, choose Export Certificate, and take the default options in the export wizard.

    4. Give the exported certificate file a friendly name.

To install certificates on SharePoint Server 2013

  1. Copy the issuer certificate to your SharePoint Server 2013 computer.

  2. Add the certificates to the Windows Certificate store.

  3. For each certificate, do the following:

    1. Double-click the file to open and view the certificate.

    2. On the certificate, choose the Install Certificate button to start the installation wizard.

    3. In the wizard, choose Place all certificates in the following store, and then choose Trusted Root Certification Authorities.

  4. Add the certificates to SharePoint Server by going to the SharePoint Management shell and running the New-SPTrustedRootAuthority cmdlet. Do this for each certificate file.

See also

Installation and Deployment for SharePoint 2013 (Resource Center)
What's New in SharePoint 2013 (Resource Center)


Video series: Install and configure Workflow in SharePoint Server 2013
See also

Published: April 30, 2013

Summary: Videos that demonstrate the installation and configuration of workflow in SharePoint Server 2013.

Applies to: SharePoint Server 2013

This six-part video series walks through the installation and configuration of the SharePoint 2013 Workflow Platform where communication between the SharePoint farm and the Workflow farm is using Secure Sockets Layer (SSL).

In this article:

  • Episode 1: Installation overview

  • Episode 2: Pre-install steps

  • Episode 3: Install and configure Workflow Manager

  • Episode 4: Install and configure Workflow Manager Client

  • Episode 5: Configure the SharePoint farm with the workflow farm

  • Episode 6: Test workflow

Episode 1: Installation overview

This video provides an overview of the installation and configuration process for Workflow in SharePoint Server 2013. (time: 1:15)

This video provides an overview of the installation and configuration process for Workflow in SharePoint Server 2013.

Video (play button) icon

Episode 2: Pre-install steps

This video provides a walkthrough of the pre-install steps that must be completed before installing and configuring Workflow in SharePoint Server 2013. (time: 5:12)

This video provides a walkthrough of the pre-install steps that must be completed before installing and configuring Workflow in SharePoint Server 2013.

Video (play button) icon

Episode 3: Install and configure Workflow Manager

This video provides a walkthrough of the installation and configuration of Workflow Manager. (time: 10:15)

This video provides a walkthrough of the installation and configuration of Workflow Manager.

Video (play button) icon

Episode 4: Install and configure Workflow Manager Client

This video provides a walkthrough of the installation of the Workflow Manager Client in the SharePoint farm. (time: 3:40)

This video provides a walkthrough of the installation of the Workflow Manager Client in the SharePoint farm.

Video (play button) icon

Episode 5: Configure the SharePoint farm with the workflow farm

This video provides a walkthrough on how to pair the SharePoint farm with the Workflow farm in order to enable the SharePoint 2013 Workflow Platform. (time: 3:00)

This video provides a walkthrough on how to pair the SharePoint farm with the Workflow farm in order to enable the SharePoint 2013 Workflow Platform.

Video (play button) icon

Episode 6: Test workflow

This video provides a walkthrough of testing the SharePoint 2013 Workflow Platform by using SharePoint Designer 2013 once it has been installed. (time: 7:43)

This video provides a walkthrough of testing the SharePoint 2013 Workflow Platform using SharePoint Designer 2013 once it has been installed.

Video (play button) icon

See also

Getting started with SharePoint Server 2013 workflow

Workflow in SharePoint Server 2013 Resource Center
Workflow development in SharePoint Designer 2013 and Visio 2013
Workflow Manager


Create a web application in SharePoint 2013

Summary: SharePoint 2013 web applications isolate content for specific types of users within your site collections.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The following downloadable resources, articles on TechNet, and related resources provide information about how to create web applications.

Introduction

A SharePoint 2013 web application is composed of an Internet Information Services (IIS) web site that acts as a logical unit for the site collections that you create. Before you can create a site collection, you must first create a Web application. Each web application is represented by a different IIS web site with a unique or shared application pool. You can assign each web application a unique domain name. This helps prevent cross-site scripting attacks. When you create a new web application, you also create a new content database and define the authentication method used to connect to the database. In addition, you define an authentication method to be used by the IIS Web site in SharePoint 2013.

TechNet articles about how to create web applications

The following articles about how to create web applications are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Create web applications that use classic mode authentication in SharePoint 2013 | Explains how to create a web application that uses classic mode (Windows-classic) authentication in SharePoint 2013.
 | Create claims-based web applications in SharePoint 2013 | Illustrates how to create SharePoint 2013 web applications that use claims-based authentication or classic-mode authentication.
 | Configure basic authentication for a claims-based web application in SharePoint 2013 | Explains how to configure basic authentication for a web application that uses claims-based authentication in SharePoint 2013.
 | Configure digest authentication for a claims-based web application in SharePoint 2013 | Explains how to configure digest authentication for a web application that uses claims-based authentication in SharePoint 2013.
 | Edit general settings on a web application in SharePoint 2013 | Illustrates how to change general settings for a SharePoint 2013 web application in Central Administration.


Create web applications that use classic mode authentication in SharePoint 2013
See also

Summary: Learn how to create a web application that uses classic mode (Windows-classic) authentication in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

In SharePoint 2013, claims-based authentication is the default and preferred method of user authentication and is required to take advantage of server-to-server authentication and app authentication. In Central Administration, you can only configure claims-based authentication when you manage web applications. You can also use Windows PowerShell cmdlets. The use of classic mode authentication, also known as Windows classic authentication, is discouraged in SharePoint 2013 and you can only create or configure web applications for classic mode authentication with Windows PowerShell cmdlets.

Important:

Office Web Apps can be used only by SharePoint 2013 web applications that use claims-based authentication. Office Web Apps rendering and editing will not work on SharePoint 2013 web applications that use classic mode authentication. If you migrate SharePoint 2010 web applications that use classic mode authentication to SharePoint 2013, you must migrate them to claims-based authentication to allow them to work with Office Web Apps. For more information, see Use Office Web Apps with SharePoint 2013.

To use Windows claims-based authentication instead (recommended), see Create claims-based web applications in SharePoint 2013. To convert a web application that uses classic mode to use claims-based authentication, see Migrate from classic-mode to claims-based authentication in SharePoint 2013.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

Before you begin

Before you perform this procedure, confirm the following:

  • Your system is running SharePoint 2013.

  • You have determined the design of your logical architecture.

    For more information, see Logical architecture components.

  • You have planned authentication for your web application.

    For more information, see Plan for user authentication methods in SharePoint 2013.

  • If you use Secure Sockets Layer (SSL), you must associate the SSL certificate with the web application's IIS website after the IIS website is created. For more information about how to set up SSL, see How to Setup SSL on IIS 7.0. SSL is required by default for web applications that are used in server-to-server authentication and app authentication scenarios.

  • You understand host-named site collections.

    For more information, see Host-named site collection architecture and deployment (SharePoint 2013).

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Create a web application that uses classic mode authentication with Windows PowerShell

Perform the following procedure to use Windows PowerShell to create a web application that uses classic mode authentication.

To create a web application that uses classic mode authentication with Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SPWebApplication -Name <Name> -ApplicationPool <ApplicationPool> -AuthenticationMethod <WindowsAuthType> -ApplicationPoolAccount <ApplicationPoolAccount> -Port <Port> -URL <URL>

    Where:

    • <Name> is the name of the new web application.

    • <ApplicationPool> is the name of the application pool.

    • < WindowsAuthType > is either "NTLM" or "Kerberos". Kerberos is recommended.

    • <ApplicationPoolAccount> is the user account that this application pool will run as.

    • <Port> is the port on which the web application will be created in IIS.

    • <URL> is the public URL for the web application.

    • Example

      Copy code
      New-SPWebApplication -Name "Contoso Internet Site" -ApplicationPool "ContosoAppPool" -AuthenticationMethod "Kerberos" -ApplicationPoolAccount (Get-SPManagedAccount "CONTOSO\jdoe") -Port 80 -URL "https://www.contoso.com"

For more information, see New-SPWebApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

After this procedure is complete, you can create one or more site collections for this web application. For more information, see Create a site collection in SharePoint 2013.

After you successfully create the web application, when you open the Central Administration page, you see a health rule warning that indicates that one or more web applications is enabled with classic authentication mode. This is a reflection of our recommendation to use claims-based authentication instead of classic mode authentication.

See also

Plan for user authentication methods in SharePoint 2013
Create claims-based web applications in SharePoint 2013

Extend a Web application)
Configure Web Server Security (IIS 7)


Create claims-based web applications in SharePoint 2013
See also

Summary: Illustrates how to create SharePoint 2013 web applications that use claims-based authentication or classic-mode authentication.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Claims-based authentication is a requirement to enable the advanced functionality of SharePoint 2013. This article explains how to use either Central Administration or Windows PowerShell to create a SharePoint 2013 web application that uses claims-based authentication. Claims-based authentication is a requirement for web applications that are deployed in scenarios that support server-to-server authentication and app authentication. However, this article also provides guidance for using Windows PowerShell to create classic-mode web applications if you have a specific scenario that cannot support claims-based authentication. Be aware that classic-mode authentication is deprecated in this release, and it will not be available in the next version. For more information, see Plan for server-to-server authentication in SharePoint 2013

Important:

Secure Sockets Layer (SSL) is a requirement for web applications that are deployed in scenarios that support server-to-server authentication and app authentication.

You can create a web application by using the SharePoint Central Administration website or Windows PowerShell. You typically use Windows PowerShell to create a web application. If you want to automate the task of creating a web application, which is common in enterprises, use Windows PowerShell. After you complete the procedure, you can create one or several site collections.

In this article:

  • Create a claims-based web application by using Central Administration

  • Create a claims-based web application by using Windows PowerShell

  • Create a classic-mode web application by using Windows PowerShell

Note:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products

  • Keyboard shortcuts

  • Touch

Create a claims-based web application by using Central Administration

Use the procedure described in this section to create a new claims-based SharePoint 2013 web application using the Central Administration.

To create a claims-based web application by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To create a web application, you must be a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the Central Administration Home page, click Application Management.

  4. On the Application Management page, in the Web Applications section, click Manage web applications.

  5. In the Contribute group of the ribbon, click New.

  6. On the Create New Web Application page, in the IIS Web Site section, you can configure the settings for your new web application by selecting one of the following two options:

    • Click Use an existing IIS web site, and then select the web site on which to install your new web application.

    • Click Create a new IIS web site, and then type the name of the web site in the Name box.

    • In the Port box, type the port number you want to use to access the web application. If you are using an existing web site, this field contains the current port number.

      Note:

      The default port number for HTTP access is 80, and the default port number for HTTPS access is 443.

    • Optional: In the IIS Web Site section, in the Host Header box, type the host name (for example, www.contoso.com) that you want to use to access the web application.

      Note:

      You do not need to populate this field unless you want to configure two or more IIS web sites that share the same port number on the same server, and DNS has been configured to route requests to the same server.

    • In the Path box, type the path to the IIS web site home directory on the server. If you are creating a new web site, this field contains a suggested path. If you are using an existing web site, this field contains the current path of that web site.

  7. In the Security Configuration section, choose whether or not to Allow Anonymous access and whether or not to Use Secure Sockets Layer (SSL).

    Important:

    Secure Sockets Layer (SSL) is a requirement for web applications that are deployed in scenarios that support server-to-server authentication and app authentication. In general, we strongly recommend using SSL for web applications.

    • In the Security Configuration section, click Yes or No for the Allow Anonymous options. If you choose to Yes, visitors can use the computer-specific anonymous access account (that is, IIS_IUSRS) to access the web site.

      Note:

      If you want users to be able to access any site content anonymously, you must enable anonymous access for the entire web application zone before you enable anonymous access at the SharePoint site level. Later, site owners can configure anonymous access for their sites. If you do not enable anonymous access at the web application level, site owners cannot enable anonymous access at the site level.

    • In the Security Configuration section, click Yes or No for the Use Secure Sockets Layer (SSL) options. If you choose Yes, you must request and install an SSL certificate to configure SSL. For more information about how to set up SSL, see How to Setup SSL on IIS 7.0.

  8. In the Claims Authentication Types section, select the authentication method that you want to use for the web application.

    • To enable Windows authentication, select Enable Windows Authentication and, in the drop-down menu, select NTLM or Negotiate (Kerberos). We recommend using Negotiate (Kerberos).

      If you do not want to use Integrated Windows authentication, clear Integrated Windows authentication.

      Note:

      If you do not select Windows Authentication for at least one zone of this web application, crawling for this web application will be disabled.

    • If you want users' credentials to be sent over a network in a nonencrypted form, select Basic authentication (credentials are sent in clear text).

      Note:

      You can select basic authentication or integrated Windows authentication, or both. If you select both, SharePoint 2013 offers both authentication types to the client web browser. The client web browser then determines which type of authentication to use. If you only select Basic authentication, ensure that SSL is enabled. Otherwise, a malicious user can intercept credentials.

    • To enable forms-based authentication, select Enable Forms Based Authentication (FBA), and then enter the ASP.NET Membership provider name and the ASP.NET Role manager name.

      Note:

      If you select this option, ensure that SSL is enabled. Otherwise, a malicious user can intercept credentials.

    • If you have set up Trusted Identity Provider authentication by using Windows PowerShell, the Trusted Identity provider check box is selected.

  9. In the Sign In Page URL section, choose one of the following options to sign into SharePoint 2013:

    • Select Default Sign In Page URL to redirect users to a default sign-in web site for claims-based authentication.

    • Select Custom Sign In page URL and then type the sign-in URL to redirect users to a customized sign-in web site for claims-based authentication.

  10. In the Public URL section, type the URL for the domain name for all sites that users will access in this web application. This URL will be used as the base URL in links that are shown on pages within the web application. The default URL is the current server name and port, and it is automatically updated to reflect the current SSL, host header, and port number settings on the page. If you deploy SharePoint 2013 behind a load balancer or proxy server, then this URL may need to be different than the SSL, host header, and port settings on this page.

    The Zone value is automatically set to Default for a new web application. You can change the zone when you extend a web application.

  11. In the Application Pool section, do one of the following:

    • Click Use existing application pool, and then select the application pool that you want to use from the drop-down menu.

    • Click Create a new application pool, and then type the name of the new application pool, or keep the default name.

    • Click Predefined to use a predefined security account for this application pool, and then select the security account from the drop-down menu.

    • Click Configurable to specify a new security account to be used for an existing application pool.

      Note:

      To create a new account, click the Register new managed account link.

  12. In the Database Name and Authentication section, choose the database server, database name, and authentication method for your new web application, as described in the following table.

    Item Action

    Database Server

    Type the name of the database server and SQL Server instance you want to use in the format <SERVERNAME\instance>. You can also use the default entry.

    Database Name

    Type the name of the database, or use the default entry.

    Database Authentication

    Select the database authentication to use by doing one of the following:

    • To use Windows authentication, leave this option selected. We recommend this option because Windows authentication automatically encrypts the password when it connects to SQL Server.

    • To use SQL authentication, click SQL authentication. In the Account box, type the name of the account that you want the web application to use to authenticate to the SQL Server database, and then type the password in the Password box.

      Note:

      SQL authentication sends the SQL authentication password to SQL Server in an unencrypted format. We recommend that you only use SQL authentication if you force protocol encryption to SQL Server to encrypt your network traffic by using IPsec.

  13. If you use database mirroring, in the Failover Server section, in the Failover Database Server box, type the name of a specific failover database server that you want to associate with a content database

  14. In the Service Application Connections section, select the service application connections that will be available to the web application. In the drop-down menu, click default or [custom]. You use the [custom] option to choose the service application connections that you want to use for the web application.

  15. In the Customer Experience Improvement Program section, click Yes or No.

  16. Click OK to create the new web application.

Create a claims-based web application by using Windows PowerShell

Use the procedure in this section to create a new claims-based SharePoint 2013 web application using Windows PowerShell.

To create a claims-based web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. To create a claims-based authentication provider, from the Windows PowerShell command prompt, type the following:

    Copy code
    $ap = New-SPAuthenticationProvider

  3. To create a claims-based web application, from the Windows PowerShell command prompt, type the following:

    Copy code
    New-SPWebApplication -Name <Name>
-ApplicationPool <ApplicationPool>
-ApplicationPoolAccount <ApplicationPoolAccount>
-URL <URL> -Port <Port> -AuthenticationProvider $ap

    Where:

    • <Name> is the name of the new web application that uses claims-based authentication.

    • <ApplicationPool> is the name of the application pool.

    • <ApplicationPoolAccount> is the user account that this application pool will run as.

    • <URL> is the public URL for this web application.

    • <Port> is the port on which the web application will be created in IIS.

    Note:

    For more information, see New-SPWebApplication.

    The following example creates an https claims-based web application, using the current user credentials and the current machine name:

    Copy code
    $ap = New-SPAuthenticationProvider
New-SPWebApplication -Name "Contoso Internet Site" -URL "https://www.contoso.com"  -Port 80
-ApplicationPool "ContosoAppPool"
-ApplicationPoolAccount (Get-SPManagedAccount "DOMAIN\jdoe")
-AuthenticationProvider $ap -SecureSocketsLayer
    Note:

    After you have created the web site, you must configure SSL in IIS for this newly created web site. For more information about how to set up SSL, see How to Setup SSL on IIS 7.0.

Create a classic-mode web application by using Windows PowerShell

Use the procedure in this section to create a new classic-mode SharePoint 2013 web application using Windows PowerShell.

To create a classic-mode web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies.

  2. From the Windows PowerShell command prompt, type the following:

    Copy code
    New-SPWebApplication -Name <Name>
-ApplicationPool <ApplicationPool>
-AuthenticationMethod <WindowsAuthType>
-ApplicationPoolAccount <ApplicationPoolAccount>
-Port <Port> -URL <URL>

    Where:

    • <Name> is the name of the new web application that uses classic-mode authentication.

    • <ApplicationPool> is the name of the application pool.

    • <WindowsAuthType> is either "NTLM" or "Kerberos". Kerberos is recommended.

    • <ApplicationPoolAccount> is the user account that this application pool will run as.

    • <Port> is the port on which the web application will be created in IIS.

    • <URL> is the public URL for the web application.

    Note:

    For more information, see New-SPWebApplication.

    Note:

    After you successfully create the web application, when you open the Central Administration page, you see a health rule warning that indicates that one or more web applications is enabled with classic authentication mode. This is a reflection of our recommendation to use claims-based authentication instead of classic mode authentication.

See also

Create web applications that use classic mode authentication in SharePoint 2013
Extend claims-based web applications in SharePoint 2013

Install and deploy SharePoint 2013 for IT Pros Resource Center


Configure basic authentication for a claims-based web application in SharePoint 2013
See also

Published: September 25, 2012

Summary: Learn how to configure basic authentication for a web application that uses claims-based authentication in SharePoint 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013 | SharePoint Server 2013 Standard

You can configure basic authentication for one or more zones in a SharePoint 2013 claims-based web application. A web application is an Internet Information Services (IIS) web site that SharePoint 2013 creates and uses. Zones represent different logical paths for gaining access to the network services that are available within the same web application. Within each web application, you can create up to five zones. A different web site in IIS represents each zone. Use zones to enforce different access and policy conditions for large groups of users. To configure basic authentication for one or more zones in a SharePoint 2013 web application, use IIS Manager console, instead of SharePoint Central Administration.

Before you begin

Before you perform this procedure, confirm the following:

  • Your system is running SharePoint 2013.

  • Basic authentication requires previously assigned Windows account credentials for user access.

  • You understand basic authentication for web traffic.

    Basic authentication enables a web browser to provide credentials when the browser makes a request during an HTTP transaction. Because user credentials are not encrypted for network transmission but are sent over the network in plaintext, we do not recommend that you use basic authentication over an unsecured HTTP connection. To use basic authentication, you should enable Secure Sockets Layer (SSL) encryption for the web site; otherwise, the credentials can be intercepted by a malicious user.

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Configure IIS to enable basic authentication

Use the IIS Manager console to configure IIS to enable basic authentication for one or more of the following zones for a claims-based web application:

  • Default

  • Intranet

  • Extranet

The Default zone is the zone that is first created when a web application is created. The other zones are created by extending a web application. For more information, see Extend claims-based web applications in SharePoint 2013.

To configure IIS to enable basic authentication

  1. Verify that you a member of the Administrators group on the server on which you are configuring IIS.

  2. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS) Manager to start IIS Manager console.

  3. Expand Sites in the console tree, and then click the IIS web site that corresponds to the web application zone on which you want to configure basic authentication.

  4. In Features View, in IIS, double-click Authentication.

  5. In Features View, in Authentication, right-click Basic Authentication, and then click Enable.

  6. Right-click Basic Authentication, and then click Edit.

  7. In the Edit Basic Authentication Settings dialog box, in the Default domain text box, type the appropriate default domain.

    The default domain is the name of a domain against which you want users to be authenticated when they do not provide a domain name.

  8. In the Realm text box, type the appropriate realm, and then click OK.

    The realm is a DNS domain name or an IP address that will use the credentials that are authenticated against your internal Windows domain. Configuring a realm name for basic authentication is optional.

The web site is now configured to use basic authentication.

You can also configure basic authentication when you create a web application in SharePoint Central Administration by selecting Basic authentication (password is sent in clear text) in the Claims Authentication Types section of the Create New Web Application dialog box. For more information, see Create claims-based web applications in SharePoint 2013.

Security

In the Claims Authentication Types section of the Create New Web Application dialog box, you can select Integrated Windows authentication, Basic authentication (password is sent in clear text), or both. If you select both, SharePoint 2013 will offer both authentication types to the client web browser. The client web browser then determines the type of authentication to use. If you only select Basic authentication (password is sent in clear text), make sure that you enable SSL for this web application.

See also

Plan for user authentication methods in SharePoint 2013
Extend claims-based web applications in SharePoint 2013
Configure digest authentication for a claims-based web application in SharePoint 2013


Configure digest authentication for a claims-based web application in SharePoint 2013
See also

Published: September 25, 2012

Summary: Learn how to configure digest authentication for a web application that uses claims-based authentication in SharePoint 2013.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

You can configure digest authentication for one or more zones in a SharePoint 2013 claims-based web application. A web application is an Internet Information Services (IIS) web site that SharePoint 2013 creates and uses. Zones represent different logical paths for gaining access to the same web application. Within each web application, you can create up to five zones. A different web site in IIS represents each zone. Use zones to enforce different access and policy conditions for large groups of users. To configure digest authentication for one or more zones in a SharePoint 2013 web application, use IIS Manager console, instead of SharePoint Central Administration.

Unlike basic authentication, digest authentication encrypts user credentials to increase security. User credentials are sent as an MD5 message digest in which the original user name and password cannot be determined. Digest authentication uses a challenge/response protocol that requires the authentication requestor to present valid credentials in response to a challenge from the server. To authenticate against the server, the client has to supply an MD5 message digest in a response that contains a shared secret password string. The MD5 Message-Digest Algorithm is described in RFC 1321. For access to RFC 1321, see The Internet Engineering Task Force (http://go.microsoft.com/fwlink/p/?LinkId=159913).

Before you begin

Before you perform this procedure, confirm the following:

  • Your system is running SharePoint 2013.

  • The user and IIS server must be members of, or trusted by, the same domain.

  • Users must have a valid Windows user account stored in Active Directory Domain Services (AD DS) on the domain controller.

  • The domain must use a Windows Server 2008 or Windows Server 2008 R2 domain controller.

  • You understand digest authentication for web traffic.

    For more information, see What is Digest Authentication? (http://go.microsoft.com/fwlink/p/?LinkId=209085).

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Configure IIS to enable digest authentication

Use IIS Manager console to configure IIS to enable digest authentication for one or more of the following zones for a claims-based web application:

  • Default

  • Intranet

  • Extranet

The Default zone is the zone that is first created when a web application is created. The other zones are created by extending a web application. For more information, see Extend claims-based web applications in SharePoint 2013.

To configure IIS to enable digest authentication

  1. Verify that you are a member of the Administrators group on the server on which you are configuring IIS.

  2. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS) Manager to start IIS Manager console.

  3. Expand Sites in the console tree, and then click the IIS web site that corresponds to the web application zone on which you want to configure digest authentication.

  4. In Features View, in IIS, double-click Authentication.

  5. In Features View, in Authentication, right-click Digest Authentication, and then click Enable.

  6. Right-click Digest Authentication, and then click Edit.

  7. In the Edit Digest Authentication Settings dialog box, in the Realm text box, type the appropriate realm, and then click OK.

    The realm is a DNS domain name or an IP address that will use the credentials that have been authenticated against your internal Windows domain. You must configure a realm name for digest authentication.

The web site is now configured to use digest authentication.

See also

Plan for user authentication methods in SharePoint 2013
Extend claims-based web applications in SharePoint 2013
Configure basic authentication for a claims-based web application in SharePoint 2013


Edit general settings on a web application in SharePoint 2013
See also

Published: May 21, 2013

Summary: Illustrates how to make changes to general settings for a SharePoint 2013 web application in Central Administration.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Note:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products

  • Keyboard shortcuts

  • Touch

Edit a web application by using Central Administration

Use the procedure described in this section to edit a SharePoint 2013 web application using the Central Administration.

To edit a web application by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To edit a web application, you must be a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the Central Administration home page, click Application Management.

  4. On the Application Management page, in the Web Applications section, click Manage web applications.

  5. Click on the web application that you want to edit.

  6. In the ribbon, from the WEB APPLICATIONS tab, click General Settings, and do the following:

    • To change the default time zone for sites that are created on the web application, in the Default Time Zone section, from the Select time zone drop-down list, select a time zone.

    • To change the user settings provider for sites that are created on the web application, in the User Settings Provider section, from the Select User Settings Provider drop-down list, select a user settings provider.

    • To change the default quota template for site collections created on the web application, in the Default Quota Template section, from the Select quota template drop-down list, select a quota template.

    • To disable person name actions and online presence information from being shown on sites on the web application, in the Person Name Actions and Presence Settings section, from Enable additional actions and Online Status for members, select No.

    • To disable alerts for sites in on the web application, in the Alerts section, from Alerts on this server are, select No. If you don't want to disable alerts completely, but want to limit the number of alerts a user can create, change the settings for Maximum number of alerts that a user can create accordingly.

    • To disable RSS feeds for sites on the web application, in the RSS Settings section, from Enable RSS feeds, select No.

    • To disable the MetaWeblog API for the web application, in the Blog API Settings section, from Enable Blog API, select No.

      The Metablog API allows SharePoint blog entries to be written, modified, or removed through web services. If Accept user name and password from the API is Yes, then the credentials to manage the blog post are sent in clear text, unless SSL to the web app is configured. If Accept user name and password from the API is set to No, SharePoint authorization for the web app is used.

    • To change the browser file handling so that the browser automatically executes web content, in the Browser File Handling section, select Permissive.

    • To disable security validation for sites on the web application, in the Web Page Security Validation section, from Security validation is, select Off. To change the expiration time for a security validation, change the settings for Security validation expires accordingly.

    • To disable the ability to send users their user name and password by e-mail, in the Send User Name and Password in E-Mail section, from Send user name and password, select No.

    • To deny pages in the _Layouts folder to reference site master pages for sites on the web application, in the Master Page Settings for Application _Layouts Page, from Application _Layout pages reference site master pages, select No.

    • To turn off recycle bins on sites in the web application, in the Recycle Bin section, from Recycle Bin Status, select Off. Alternatively, you can change when items in recycle bins should be deleted by changing the settings for Delete items in the Recycle Bin and Second stage Recycle Bin.

    • To change the maximum allowed size of content uploads to a site in the web application, in the Maximum Upload Size section, change the number in Maximum upload size accordingly.

    • To disable the collection of web site analytics for sites in the web application, in the Customer Experience Improvement Program section, from Enable Customer Experience Improvement Program, select No.

    • To enable usage cookies to be used for anonymous users on sites in the web application, in the Usage Cookie section, from Usage Cookie Status, select On.

      Important:

      Local legal restrictions might apply when you enable usage cookies on sites that have anonymous users.

  7. To save you changes to this web application, click OK.

See also

Create claims-based web applications in SharePoint 2013
Create web applications that use classic mode authentication in SharePoint 2013
Extend claims-based web applications in SharePoint 2013


Install and manage solutions for SharePoint 2013

Published: October 16, 2012

Summary: Learn how to install solutions or components that were customized by developer or web designers to a SharePoint 2013 environment.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The process to install custom site elements and solution packages in SharePoint 2010 Products and SharePoint 2013 has not changed significantly. Detailed content about how to install custom elements is available in the SharePoint Server 2010 technical library in the following section Deploy customizations - overview (SharePoint Server 2010). To install solution packages, you can use a new parameter, CompatibilityLevel, to install the solution to the latest version directories, or to use only the current version tracked in the cab file. For more information, see Install-SPSolution.

To add functionality to SharePoint sites in SharePoint 2013, you can use apps for SharePoint. For more information about apps for SharePoint, see Install and manage apps for SharePoint 2013.

TechNet articles about how to install and manage solutions

The following articles about how to install and manage solutions are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Deploy customizations - overview (SharePoint Server 2010) | Overview article and detailed content about how to install custom elements for SharePoint Server 2010. Applies to both SharePoint 2010 Products and SharePoint 2013.
 | Sandboxed solutions administration (SharePoint Server 2010) | Content about how to manage sandboxed solutions for SharePoint Server 2010. Applies to both SharePoint 2010 Products and SharePoint 2013.
 | Features and solutions cmdlets in SharePoint 2013 | List Windows PowerShell cmdlets that help you manage features and solutions in a SharePoint 2013 farm.

Additional resources about how to install and manage solutions

The following resources about how to install and manage solutions are available from other subject matter experts.

 | Content | Description
House icon | SharePoint 2013 Tech Center | Visit the TechCenter to access videos, community sites, documentation, and more.
Code icon | SharePoint developer center | Find resources for building solutions on SharePoint 2013. This includes how-to articles, code samples, and the SharePoint SDK.
Chat icon | To the SharePoint Office 365 Technical Blog | Read draft content, learn about new content, and join the conversation at this IT pro content team blog. Learn how to get the most out of SharePoint sites by reading this blog.


Install and manage apps for SharePoint 2013

Summary: The following resources provide information about apps for SharePoint, the SharePoint Store, and the App Catalog and how to install, manage, and monitor apps.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Downloadable resources about apps for SharePoint

Download the following content for information about apps for SharePoint.

 | Content | Description
Architecture icon | SharePoint 2013: App Overview for IT Pro model | Model poster describing apps from an IT Pro perspective.

TechNet articles about apps for SharePoint

The following articles about apps are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Overview of apps for SharePoint 2013 | Read an overview of apps for SharePoint from an IT Pro perspective.
Plan for apps for SharePoint 2013 | Understand what you need to plan for before you support apps for SharePoint.
Plan for app authentication in SharePoint 2013 | Learn how to plan for app authentication in SharePoint 2013.
Plan app permissions management in SharePoint 2013 | App permissions management enforces security and provides the additional functionality that apps enable on SharePoint 2013 sites.
Configure an environment for apps for SharePoint (SharePoint 2013) | Follow these steps to configure your environment to support apps for SharePoint.
Configure app authentication in SharePoint Server 2013 | Learn how to configure app authentication in SharePoint 2013.
Manage the App Catalog in SharePoint 2013 | Follow these steps to configure and manage the App Catalog and configure SharePoint Store rules.
Add apps for SharePoint to a SharePoint 2013 site | Learn how to install an app for SharePoint from the App Catalog or SharePoint Store.
Remove app for SharePoint instances from a SharePoint 2013 site | Learn how to remove an app for SharePoint from a site collection.
Monitor apps for SharePoint for SharePoint Server 2013 | Follow these steps to specify which apps for SharePoint to monitor, and then monitor the apps.
Monitor and manage app licenses in SharePoint Server 2013 | Learn how SharePoint farm administrators assign, monitor, and manage the app for SharePoint licenses in SharePoint Server 2013.
Back up apps for SharePoint in SharePoint 2013 | Learn how to back up apps for SharePoint either as part of a normal farm backup or individually.
Restore apps for SharePoint in SharePoint 2013 | Learn how to restore apps for SharePoint in SharePoint 2013.
Enable apps in AAM or host-header environments for SharePoint 2013 | Learn how to enable app domains for alternate access mappings or host-header web application environments after installing the March 2013 Public Update.

Additional resources about apps for SharePoint

The following resources about apps for SharePointare available from other subject matter experts.

Content Description

TechNet logo

Installation and Deployment for SharePoint 2013 Resource Center

Visit the Resource Center to access videos, community sites, documentation, and more.

Content on MSDN

  • Apps for SharePoint overview

  • Critical aspects of the app for SharePoint 2013 architecture and development landscape

  • Build apps for SharePoint

  • SharePoint developer center

Articles about apps for SharePoint in the SharePoint Server 2013 Software Development Kit


Overview of apps for SharePoint 2013
See also

Summary: The apps for SharePoint are a powerful, easy way to add functionality to a SharePoint site. Understand how they work, how they are integrated with SharePoint sites, and how they are isolated from your site content.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The apps for SharePoint provide a new method to deliver specific information or functionality to a SharePoint site. An app for SharePoint is a small, easy-to-use, stand-alone app that solves a specific end-user or business need. Site owners can discover and download apps for SharePoint from a public SharePoint Store or from their organization's internal App Catalog and install them on their SharePoint sites. These apps for SharePoint integrate the best of the web with SharePoint 2013. They do not replace SharePoint features and solution packages, which customize or enhance SharePoint sites. Unlike features and solutions, which farm or site collection administrators have to install, apps for SharePoint are stand-alone applications that owners of sites can add to their SharePoint sites. The apps for SharePoint have a simple lifecycle - they can be installed, upgraded, and uninstalled by site owners.

The following are examples of apps for SharePoint that site owners could add to their sites:

  • An app that provides event planning tools.

  • An app that provides a shopping cart experience for a site.

  • An app that sends a note of recognition for good work (kudos) to someone in the organization.

Microsoft will host and control a public SharePoint Store, where developers will be able to publish and sell their custom apps for SharePoint. End users and IT professionals will be able to obtain these custom apps for personal or corporate use. This SharePoint Store will handle the end-to-end acquisition experience from discovery to purchase, upgrades, and updates.

Company-developed and approved apps can also be deployed to an organization's internal App Catalog hosted on SharePoint 2013 or SharePoint Online. This controls the visibility of apps within organizations.

Important:

This article applies to both SharePoint Foundation 2013 and SharePoint Server 2013.

Where are apps for SharePoint hosted?

There are several options for hosting apps for SharePoint.

  • Provider-hosted

  • Hosted in the cloud (Windows Azure autohosted)

  • Hosted in a SharePoint environment

  • Several combinations of these options.

Depending on the hosting option, the app can contain different elements and take advantage of different components.

Illustration of hosting options for apps for SharePoint

Options for hosting SharePoint apps

No matter the hosting option for the app, if you want users to be able to install and use apps for SharePoint in your environment, you will have to configure your environment to support them.

For more information about hosting options, see the SharePoint 2013 developer documentation.

How are apps for SharePoint and SharePoint sites related?

Site owners can add apps for SharePoint to their sites. If an app contains SharePoint components, those components are stored in a subweb of the site that is automatically created when you install the app. Apps have their own, isolated URLs, which are separate from the URL for the site that contains the app. If the app is a Provider-hosted or Windows Azure autohosted app, the app components are stored in those locations. For example, in the following diagram, App1 contains custom business logic and is stored on an external server - it is an Windows Azure autohosted app and does not store content in a subweb of the site. App2 is a SharePoint hosted app with only SharePoint components. App2's content is stored in a subweb of the site on which it is installed.

Illustration of relationship between apps for SharePoint and SharePoint sites

Apps are isolated from SharePoint sites

What is the URL for an app for SharePoint?

By default, apps are deployed to their own web site in a special, isolated domain name, instead of in the same domain name as your farm. Processes run under that domain name and do not affect the SharePoint sites. This difference in domain names provides a layer of isolation for the apps. The use of a different domain name from the SharePoint sites prevents cross-site scripting between the apps and sites and unauthorized access to users' data.

Each installation of an app has a unique URL in your environment. You determine the template for that URL (by specifying a domain name and an app prefix), and then app URLs are automatically generated based on that template. Paths for the apps are based on the URL for the site where they are installed. When you install an app to a site, a subweb of that site is created to host the app content. The subweb for the app is hierarchically below the site collection, but has an isolated unique host header instead of being under the site's URL. The following diagram shows the relationship between the site's URL and the app's URL:

Illustration of URL for an app for SharePoint

App URLs are isolated from SharePoint site URLs

In this diagram, the Main SharePoint Site is the site on which the user installed the app. The App1 SharePoint Site is a subweb of the Main site that contains the app and its components. The URL for the App1 SharePoint site is based on that of the Main SharePoint site. However, it is in a different domain, has a prefix-apphash at the beginning, and has an app name at the end for the subweb name. The prefix-apphash part of the URL is designed to support multi-tenant environments. In a multi-tenant environment, each tenant has its name that is combined with the apphash to provide a unique domain name for the app. If you are not in a multi-tenant environment, you can use the same app prefix for all URLs.

Use and benefits of apps for SharePoint

The apps for SharePoint allow users to add quick functionality to their site without your intervention. Unlike templates, features, and solutions, which an IT administrator must deploy, site owners can add apps for SharePoint to their sites or remove them. Because apps for SharePoint are limited in scope to a subweb and have an isolated URL, they do not interact with the rest of your farm or open your environment to cross-site scripting risks.

Your organization can develop its own apps for SharePoint. You can make apps for SharePoint available from the SharePoint Store, and you can make these apps available in the App Catalog so that users know which apps for SharePoint are approved for use in your environment. Users can easily update apps for SharePoint with new versions when they become available.

Impacts of apps for SharePoint

Supporting apps for SharePoint in your environment does require a configuration change to your environment. There are two main considerations:

  • Requirements for supporting apps for SharePoint You must be running the Subscription Settings and App Management service applications to use apps for SharePoint. You must create the DNS domain to contain the URLs for apps for SharePoint in your environment.

  • Plan for capacity Each app for SharePoint that is installed creates a subweb under the site on which it is installed with its own URL. This means that environments that contain many apps for SharePoint will have many additional subwebs. Be sure to consider this when planning for capacity for your farm.

For more information about these and other considerations, see Plan for apps for SharePoint 2013 and Configure an environment for apps for SharePoint (SharePoint 2013).

See also

Install and manage apps for SharePoint 2013
Plan for apps for SharePoint 2013
Configure an environment for apps for SharePoint (SharePoint 2013)


Plan for apps for SharePoint 2013
See also

Updated: February 26, 2013

Summary: Determine your organization's policy about how to use and develop governance for apps for SharePoint 2013. Plan the App Catalog, app URLs, and how to monitor and license apps.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The apps for SharePoint provide a new method to deliver specific information or functionality to a SharePoint site. An app for SharePoint is a small, easy-to-use, stand-alone productivity app that solves a specific end-user need. Before you allow site owners to install apps in a SharePoint environment, you must plan how you want to support them. You have to determine your organization's policy around apps for SharePoint, plan your configuration settings, and determine how to manage and monitor the apps. This article discusses key decisions and helps you understand the choices to make as you plan to support apps for SharePoint.

For more conceptual information about apps for SharePoint, see Overview of apps for SharePoint 2013.

Note:

One of the feature updates of the March 2013 Public Update for SharePoint 2013 enables you to use multiple app domains in SharePoint 2013 environments with alternate access mapping or host-header web application configurations. For more information, see Enable apps in AAM or host-header environments for SharePoint 2013.

Governance: determine the app for SharePoint policy for your organization

The first decision about apps for SharePoint is the extent to which you want to use them in your organization and the policy for using them. The following questions can help you frame your discussion about your policy:

  • Do you want site owners to be able to install and use apps for SharePoint?

    • If so, keep reading and shaping your policy.

    • If not, then you can use settings in the SharePoint Store to control whether site owners can purchase apps from the SharePoint Store. You cannot block site owners from viewing the SharePoint Store. However, you can prevent them from purchasing or downloading apps for SharePoint. If you choose to prevent site owners from installing apps for SharePoint from the SharePoint Store, you should create a policy statement and advise site owners that you have chosen not to support apps for SharePoint. Otherwise, the only message to site owners will be an error when they try to install an app for SharePoint.

  • Do you want to restrict or control the apps for SharePoint that site owners can install and use?

    If so, you can do one or both of the following:

    • Set up an App Catalog to provide a set of apps for SharePoint that site owners can install and use.

    • Use the App Request feature to control the purchasing and licensing of apps for SharePoint.

  • In which environments do you want apps for SharePoint to be available? For example, intranet, extranet, or Internet environments?

    You should decide which environments are appropriate for using apps for SharePoint and configure the settings for apps for SharePoint only in those farms or for those web applications.

  • Do you want to control who can purchase apps for SharePoint?

    No explicit setting prevents a site owner from purchasing an app for SharePoint. However, you can create a request process that requires site owners to submit a request that your organization reviews to make sure that appropriate persons make purchases.

  • Do you want to control who can install apps for SharePoint?

    At the minimum, a user must have the Manage Web site and Create Subsites permissions to install an app for SharePoint. By default, these permissions are available only to users who have the Full Control permission level or who are in the Site Owners group.

  • Do you want to provide specific apps for SharePoint in your environment?

    Add apps for SharePoint for your own organization to the App Catalog.

  • How many and which apps for SharePoint do you want to monitor?

    You must explicitly select the apps for SharePoint to monitor for a farm.

    Note:

    The ability to monitor apps for SharePoint is not available for SharePoint Foundation 2013.

The following illustration summarizes these governance choices.

Governance choices for apps for SharePoint

Governance choices for apps for SharePoint

These choices change whether site owners in your environment can purchase and install or add apps from the SharePoint Store or the App Catalog. The following illustration shows the results of these choices for site owners.

Flowchart with decisions about purchasing apps

Flow of decisions about purchasing apps

Plan app configuration settings

Before you use apps for SharePoint in your environment, you have to configure your environment to support them. If you don't configure your environment, site owners who try to install and use apps for SharePoint receive error messages. For all apps for SharePoint, you must set up a Domain Name Services (DNS) domain name to provide a host name for the installed apps. By using a separate domain name, apps for SharePoint are separated from SharePoint sites to prevent unauthorized access to user data and to reduce the possibility of cross-site scripting attacks. The use of separate URLs for apps for SharePoint and SharePoint sites is called app isolation. You also need a DNS record so that the domain name can get correctly resolved. You can create one of two of the following types of DNS records for app for SharePoint URLs:

  • A wildcard Canonical Name (CNAME) record that points to the host domain assigned to the SharePoint farm.

  • A wildcard A record that points to the IP address for the SharePoint farm.

Choose the type of record to use to point from the app domain to the SharePoint farm domain.

The following illustration shows the types of records that you can use to point from the app domain to the SharePoint farm domain.

Illustration of a type of record that points from the app domain to a SharePoint farm domain

DNS domain names for SharePoint Apps

In addition to setting up the DNS domain to support apps in your environment, you also have to configure the following:

  • SSL Certificates

    If you are using SSL to help secure traffic, you must create a wildcard certificate to use for all app URLs. Wildcard certificates cost about the same as five individual certificates. So, you can quickly justify the cost of a wildcard if you expect to use more than five instances of apps for SharePoint in your environment.

    Important:

    Each instance of an app for SharePoint that is installed has its own URL. Therefore, if you only have one app for SharePoint in your environment, but the app is installed on six different sites, then you will have six different app URLs.

  • The Subscription Settings and App Management service applications

    These services support apps in your environment by storing the data needed to run apps in the farm. The Subscription Settings service and the App Management Service store app licenses, app principals, app users, app registrations, and so on.

  • The app URLs to use

    Each app has a unique URL in your environment. You determine the template for that URL, and then app URLs are automatically generated by using the prefix and domain that you specify. For example, prefix-Apphash.ContosoApps.com/sites/web1/appname.

The Configure an environment for apps for SharePoint (SharePoint 2013) article describes how to configure these settings.

Determine the domain name to use

Each app for SharePoint has a unique URL, which is made up of the app domain plus a prefix and an Apphash. The format is as follows: prefix-Apphash.domain.com. The Apphash is an arbitrarily-assigned unique identifier for each app for SharePoint. These URLs are generated automatically depending on the settings that you specify. You do not have to create or manage these URLs separately; instead you configure a wildcard entry in DNS to provide the URLs for all apps.

Note:

The examples in this section use an Internet-style domain name for clarity. This does not imply that you must expose your apps to the Internet. Note that for actual hosting environments you must still organize a DNS routing strategy within your intranet and optionally configure your firewall.

When you choose the domain name and prefixes to use for your environment, consider the following:

  • Use a unique domain name, not a subdomain

    For security reasons, the domain name that you choose should not be a subdomain of the root domain name that hosts other applications. This is because other applications that run under that host name might contain sensitive information that is stored in cookies that might not be protected. Code can set or read cookies across different domains that are under the same domain. A malicious developer could use code in an app for SharePoint to set or read information in a cookie on the root domain from the app for SharePoint subdomain. If a malicious app accessed that cookie information, then you could have an information leak. Internet Explorer honors the settings that SharePoint sites use to protect against this issue. However, you should still use a domain for apps that is separate from your other domains. For example, if the SharePoint sites are at Contoso.com, do not use Apps.Contoso.com. Instead use a unique name such as Contoso-Apps.com. This is not to say that you should never use a subdomain if you have business reasons to do this. However, consider all potential security risks.

  • The app domain should be in the Internet or Restricted sites security zone in Internet Explorer

    For security reasons, we recommend that you configure the app domain to be in either the Internet or Restricted sites security zone in Internet Explorer options, and not in the Intranet zone or Trusted sites zone. Internet Explorer security settings for the Intranet zone or Trusted sites zone do not provide a sufficient level of isolation of apps from user data in SharePoint sites.

  • For single tenant environments, use the same prefix for all apps

    If your environment is only used for your own organization and does not host SharePoint sites for other organizations, you configure a prefix that all app for SharePoint URLs in your environment use. For example, you can set the prefix to a word like default so that each app for SharePoint has a URL such as default-Apphash.Contoso-Apps.com.

  • For multi-tenancy environments, use unique prefixes for each tenant's apps

    If your environment has multiple tenants (in other words, you host SharePoint sites for multiple clients), you must be able to identify the URLs that each tenant or client in your environment uses. So, you set the URL prefix to indicate the client's name or the client's site's name. For example, suppose that A. Datum Corporation hosts SharePoint sites for Fabrikam and Fourth Coffee under the adatum.com hosting domain (for example, Fabrikam.Adatum.com and FourthCoffee.Adatum.com). You should set the prefix for your hosted sites so that they are created as Fabrikam-Apphash.AdatamApps.com and FourthCoffee-Apphash.AdatamApps.com.

    Important:

    If you are in a multi-tenancy environment, you must use the Set-SPAppDomain cmdlet in Windows PowerShell to configure the URL and prefix. For more information, see Configure the app URLs to use.

  • Keep prefixes short and simple

    Prefixes must be less than 48 characters and cannot contain special characters or dashes.

  • All URLs will be in the default zone

    If you are using alternate access mapping on a web application, you cannot use apps for SharePoint. Apps for SharePoint cannot use multiple zones in alternate access mapping. By default, all apps for SharePoint are available only in the default zone. Consider using host header site collections instead of alternate access mapping; apps for SharePoint are fully supported for host header site collections.

Recommended logical architecture

As a best practice, we recommend that you use a single web application that uses host-named site collections (host headers) instead of multiple web applications that use path-named site collections in your environment. When you use multiple web applications and path-named site collections you might have to complete additional configuration steps to guarantee that requests for apps for SharePoint are routed to the correct web application. For more information about host-named site collections and logical architecture, see SharePoint 2013 design samples: Corporate portal and extranet sites.

Plan App Catalog

If you decide to provide approved apps for SharePoint for site owners to install, you can configure the App Catalog to contain those apps for SharePoint. The App Catalog is a special site that contains the apps for SharePoint that site owners can install.

The following illustration shows the difference between the App Catalog and the SharePoint Store, and how the on premises IT professional can control which apps a site owner can install.

Contrasts the SharePoint Store and the App Catalog.

Contrasts the SharePoint Store and the App Catalog

You can have multiple App Catalogs in your farm, one for each web application in your farm. To configure the App Catalog for a web application, you just have to supply the names of the site collection administrators who you want to use for the App Catalog site. After you create the App Catalog, the site collection administrators can upload apps for SharePoint to it.

To plan App Catalog settings, determine the following:

  • Which web applications will need an App Catalog.

    This goes together with your decisions about your policy for supporting apps for SharePoint in the SharePoint environment. If you have different types of sites (intranet, extranet, Internet) on different web applications in your farm, you can determine whether you want an App Catalog for each of those web applications.

  • Who to add as the site collection administrators for the App Catalog.

    The App Catalog is a site inside a web application that can only be accessed from a link in Central Administration or directly by using the URL.

Plan to monitor apps

Important:

  • This section applies only to SharePoint Server 2013.

  • App monitoring is not available in SharePoint Foundation 2013.

  • App monitoring is not supported for SharePoint Server 2013 on-premise, multi-tenancy environments.

SharePoint 2013 Farm administrators can monitor apps for SharePoint to track the usage data and results, and any errors that occur. The Farm administrator must add apps to the Monitor Apps page in SharePoint on-premises in order for the apps to appear in the list. The maximum number of apps that can be monitored on the Monitor Apps page is limited to 100.

The Monitor Apps page requires the following search analytics and usage file import timer jobs to be active:

  • ECM analytics timer job name: Usage Analytics timer job for Search Service

  • Usage DB timer job name: Microsoft SharePoint Foundation Usage Data Import

Plan for app licenses

SharePoint 2013 does not enforce app licenses. Developers who build apps must add code that retrieves license information and then addresses users. SharePoint 2013 provides the storage and together with SharePoint Store web services the app license renewal. SharePoint Store handles payments for the licenses, issues the correct licenses, and provides the process to verify license integrity. Note that licensing only works for apps that are distributed through the SharePoint Store. Apps that you purchase from another source and apps that you develop internally must implement their own licensing mechanisms. SharePoint 2013 supports the following app licenses formats:

License Type | Duration | User Limit
Free | Perpetual | Unlimited
Trial | 30, 60, 120 Days, or Unlimited | Number per user or Unlimited
Paid per user | Perpetual | Number per user
Paid unlimited users (site license) | Perpetual | Unlimited

See also

Install and manage apps for SharePoint 2013
Overview of apps for SharePoint 2013
Configure an environment for apps for SharePoint (SharePoint 2013)
Enable apps in AAM or host-header environments for SharePoint 2013

Change History

Date | Description
February 26, 2013 | Added the word "governance" to the Summary to enhance search results.
July 16, 2012 | Initial publication


Plan app permissions management in SharePoint 2013
See also

Summary: App permissions management enforces security and enables the additional functionality that apps provide on SharePoint 2013 sites.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The purpose of app permissions management is to manage the ability of apps to access and use internal SharePoint 2013 resources and perform tasks on behalf of users. For app authentication, SharePoint 2013 relies on a trusted token service named the Windows Azure Access Control Service (ACS) to issue time- and scope-limited access tokens for apps. In SharePoint 2013, the ACS acts as the app identity provider. The app authentication process verifies a claim that an app makes and asserts that the app can act on behalf of an authenticated SharePoint 2013 user. The authorization process verifies that an authenticated app has permission to access a specified resource and perform a defined function. You can configure SharePoint 2013 to process app permissions and enable anyone who enters an anonymous web site, for example, to view and fill out a form that requests additional information about a product or service. You can also allow a SharePoint 2013 site owner, or a user with elevated permissions, to purchase and install an app that a defined set of internal SharePoint 2013 users can access. For example, a site owner can purchase and install an expense report app for a workgroup, and the members of the workgroup can use the app to access data in SharePoint 2013 document libraries and generate expense reports. For more information about apps, see Overview of apps for SharePoint 2013.

In this article:

  • App permission request scopes

  • App permission requests

  • App authorization policies

To plan the management of SharePoint 2013 app permissions, you have to determine the specific SharePoint 2013 resources that the app will need to access, and where those resources reside. You also have to determine the minimum permission level that will be required to enable the app to function correctly. In addition, you have to determine the appropriate app authorization policy to ensure that the app functions correctly and complies with specified authorization requirements.

Introduction

SharePoint 2013 apps provide a wide variety of powerful tools and enhanced functionality that can increase the usefulness of your SharePoint 2013 deployment. When you decide to support the implementation of SharePoint 2013 apps within your deployment, you need to determine who will be installing the apps and who will be using them. You also need to determine the appropriate scope and permission levels for each app, based on how the app is intended to be used.

This article explains how to decide which scope, permission level, and authorization policy to use for the various types of SharePoint 2013 apps you plan to deploy, depending on how the app is going to be used and who is going to use the app. This article does not explain how to create or configure SharePoint 2013 apps.

App permission request scopes

SharePoint 2013 apps use app permission request scopes and permission requests to specify the level at which the app is intended to run, and the permission level that is assigned to the app. The app permission request scope indicates the location within the SharePoint 2013 hierarchy where a permission request will apply. SharePoint 2013 supports the following permission request scopes:

  • SPSite Defines the app permission request scope as a SharePoint 2013 site collection.

  • SPWeb Defines the app permission request scope as a SharePoint 2013 web site.

  • SPList Defines the app permission request scope as a SharePoint 2013 list.

  • Tenancy Defines the app permission request scope as a SharePoint 2013 tenancy.

If an app is granted permission to one scope, the permission also applies to the children of that scope. For example, if an app is granted permission to a web site by using the SPWeb scope, the app is also granted permission to each list (SPList scope) that is contained within the SPWeb scope and all list items within each list. Because permission requests are made without information about the topology of the site collection where the app is installed, the scope is expressed as a type rather than as the URL of a specific instance. These scope types are expressed as URIs. Content database related permissions are organized under this URI: http://sharepoint/content. The following table provides an URI example for each app permission request scope.

Scope | URI
SPSite | http://sharepoint/content/sitecollection/
SPWeb | http://sharepoint/content/sitecollection/web
SPList | http://sharepoint/content/sitecollection/web/list
Tenancy | http://<sharepointserver>/<content>/<tenant>/

App permission requests

App permission requests are collections of permissions that enable apps to perform specific tasks. SharePoint 2013 includes four app permission request levels.

The following table lists the four app permission requests that you can assign to a SharePoint 2013 app.

Permission request Description Permissions included

Read-Only

Enables apps to view pages, list items, and download documents.

  • View Items

  • Open Items

  • View Versions

  • Create Alerts

  • Use Self-Service Site Creation

  • View Pages

Write

Enables apps to view, add, update, and delete items in existing lists and document libraries.

  • Read-Only permissions, plus:

  • Add Items

  • Edit Items

  • Delete Items

  • Delete Versions

  • Browse Directories

  • Edit Personal User Information

  • Manage Personal Views

  • Add/Remove Personal Web Parts

  • Update Personal Web Parts

Manage

Enables apps to view, add, update, delete, approve, and customize items or pages within a web site.

  • Write permissions, plus:

  • Manage Lists

  • Add and Customize Pages

  • Apply Themes and Borders

  • Apply Style Sheets

Full Control

Enables apps to have full control within the specified scope.

  • All permissions

There are important security implications when you assign a permission request level to a SharePoint 2013 app. The permission request level must be adequate to allow the app to function correctly and complete every aspect of the task it is designed to perform. However, it is also important to make sure that the assigned permission request level does not exceed the minimum requirements to complete the task. For example, the Read-Only app permission request level is adequate for a SharePoint 2013 app that is gathering and rendering data in response to a query. However, the Write app permission request level will be required for a SharePoint 2013 app that is intended to add new data or update existing data in a SharePoint 2013 library.

App authorization policies

In addition to determining the app permission request scope and the app permission request level for each app you deploy, you must also determine which app authorization policy is appropriate. SharePoint 2013 provides the following app authorization policies:

  • User and app policy When you assign the user and app policy to a SharePoint 2013 app, the content database authorization checks succeed only if both the current user and the app have sufficient permissions to perform the actions that the app is designed to perform. The user and app policy is required when a SharePoint 2013 site has an embedded IFRAME that links to a SharePoint Store app, and the app calls back to SharePoint 2013 to access SharePoint 2013 resources on behalf of the user. For example, this is a requirement when a SharePoint Store app that does not run within SharePoint 2013 needs to act on behalf of a user to access the user's resources.

  • App-only policy When you assign the app-only policy to a SharePoint 2013 app, the content database authorization checks succeed if the app has sufficient permissions to perform the actions that the app is designed to perform, whether or not the current user (if there is a current user) has the same permissions. The app-only policy is required when the app is not acting on behalf of a user.

  • User-only policy When you assign the user-only policy, the content database authorization checks succeed if the user has sufficient permissions to perform the action that the app is designed to perform. The user-only policy is required when a user is accessing their own resources.

See also

App Management Service cmdlets in SharePoint 2013


Configure an environment for apps for SharePoint (SharePoint 2013)
See also

Updated: April 30, 2013

Summary: Configure domain names, service applications, and URLs for apps for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

To enable users to install and use apps for SharePoint in their sites, you must configure your environment to support them. This article describes how to configure your environment to support apps. Use the Plan for apps for SharePoint 2013 article to review options and determine the values to use for configuration settings in this article.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

One of the feature updates of the March 2013 Public Update for SharePoint 2013 enables you to use multiple app domains in SharePoint 2013 environments with alternate access mapping or host-header web application configurations. For more information, see Enable apps in AAM or host-header environments for SharePoint 2013.

The following illustration summarizes the steps to take to configure an environment for apps for SharePoint.

Overview of how to configure an environment for apps for SharePoint

Process for configuring the environment for apps

These configuration steps result in example app URLs such as the following:

  • http://Apps-12345678ABCDEF.ContosoApps.com/sites/SiteName/App1Name/Pages/Home.aspx

  • https://Apps-3456789BCDEFG.ContosoApps.com/sites/SiteName/WebName/App2Name/Default.aspx

This article contains instructions for completing these steps.

Before you begin

  • You must purchase a domain name from a domain name provider for your apps, for example, ContosoApps.com.

  • You must be a member of the Farm Administrators group to perform the steps in this article. For some steps, you must also be a local administrator on the domain controller.

  • Confirm that the SharePoint Administration (spadmin) and SharePoint Timer (sptimer) services are running.

    To verify this, click Start, point to Administrative Tools, and then click Services. In the Services list, verify that the SharePoint Administration and SharePoint Timer services are running.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure the domain names in DNS (all hosting options)

You must configure a new name in Domain Name Services (DNS) to host the apps. To help improve security, the domain name should not be a subdomain of the domain that hosts the SharePoint sites. For example, if the SharePoint sites are at Contoso.com, consider ContosoApps.com instead of App.Contoso.com as the domain name. For more information, see Plan for apps for SharePoint 2013. When an app is provisioned, it provisions a unique DNS domain name (for example, Apps-12345678ABCDEF.ContosoApps.com, where 12345678ABCDEF is a unique identifier for the app). You need a wildcard Canonical Name (CNAME) entry for your DNS domain to support these unique names.

Depending on your configuration (for example, if you are using WINS forward lookup), you might have to create a new forward lookup zone first, or you can start with a wildcard CNAME entry in the same zone as the SharePoint site domain. In the following procedures, you create a forward lookup zone, and then create a wildcard alias record for the DNS domain name that allows for individual apps to create unique domain names within your app domain. In these procedures, we use DNS Manager for Windows Server 2008 R2. For more information about DNS server in Windows Server 2008 R2, see DNS Server. If you have a different type of DNS server, follow the procedures in the documentation for that server type.

To create a forward lookup zone for the app domain name

  1. Verify that the user account that performs this procedure is a local administrator on the domain controller.

  2. Click Start, point to Administrative Tools, and then click DNS.

  3. In DNS Manager, right-click Forward Lookup Zones, and then click New Zone….

  4. In the New Zone Wizard, click Next.

  5. In the Zone Type page, accept the default of Primary zone, and then click Next.

  6. In the Active Directory Zone Replication Scope page, select the appropriate replication method for your environment (the default is To all DNS servers in this domain), and then click Next.

  7. In the Zone Name page, in the Zone name box type the name for your new app domain name (for example, ContosoApps.com), and then click Next.

    The New Zone Wizard shows the new domain name for apps.

    Create a domain name for apps for SharePoint

  8. On the Dynamic Update page, select the appropriate type of dynamic updates for your environment (the default is Do not allow dynamic updates), and then click Next.

  9. On the Completing the New Zone Wizard page, review the settings, and then click Finish.

For more information about how to create a forward lookup zone, see Add a Forward Lookup Zone.

You have now created a forward lookup zone (and a domain name) to use for apps in your environment.

To create a wildcard Alias (CNAME) record for the new domain name

  1. Verify that the user account that performs this procedure is a local administrator on the domain controller.

  2. In DNS Manager, under Forward Lookup Zones, right-click the new app domain name, and then click New Alias (CNAME).

  3. In the New Resource Record dialog box, in the Alias name (uses parent domain if left blank) box, type *.

    The Fully qualified domain name (FQDN) box displays *. followed by the domain name that you created for apps. For example, *.ContosoApps.com or *.Contoso-Apps.com.

  4. Next to the Fully qualified domain name (FQDN) for target host box, type the FQDN of the server that hosts the SharePoint sites.

    For example, SharePoint.Contoso.com.

    Or:

    1. Next to the Fully qualified domain name (FQDN) for target host box, click Browse and navigate to the Forward Lookup Zone for the domain that hosts the SharePoint sites.

      For example, Contoso.com.

    2. And then navigate to the record that points to the server that hosts the SharePoint site.

      For example, SharePoint.

    New Resource Record dialog box shows the wildcard alias for the app domain and the FQDN of the server that hosts the SharePoint sites.

    Create a CNAME alias for the app domain

  5. Click OK.

For more information about how to create a wildcard alias record in DNS Manager, see Add an Alias (CNAME) Resource Record to a Zone.

You can verify the new domain name and alias by pinging them.

To verify the new domain name

  1. Verify that the user account that is performing this procedure is a local administrator on the domain controller.

  2. Click Start, and then click Command Prompt.

  3. At the command prompt, type ping followed by a subdomain of the domain that you created, and then press ENTER.

    For example, ping Apps-12345678ABCDEF.contosoapps.com

    If the ping command returns the correct IP address, then your wildcard for the domain name was configured successfully.

Create a new wildcard SSL certificate

If you are using Secure Sockets Layer (SSL) for the SharePoint sites in your environment, or if you use any apps that use data external to the SharePoint sites, you should use SSL for your apps. To use SSL, you create an SSL certificate for your app domain (for example, ContosoApps.com).

The domain should be added in the form of a wildcard (for example, *.ContosoApps.com). You need a wildcard certificate instead of individual certificates because each installed app has its own subdomain.

Configure the Subscription Settings and App Management service applications

Apps rely on the App Management and Microsoft SharePoint Foundation Subscription Settings service applications. These service applications use the multi-tenancy features to provide app permissions and create the subdomains for apps. Therefore, even if you are not hosting multiple tenants, you must still establish a name for the default tenant for your environment (any SharePoint site that is not associated with a tenant will be in the default tenant).

Note:

You can use the SharePoint Central Administration website to set the default tenant name (also know as the app prefix) for non-hosting environments. You must use Windows PowerShell to configure tenant names for hosting environments. You perform the steps to set the app prefix in the next section, Configure the app URLs to use.

To configure these services, you first start the services in Central Administration. After the services are started, you use Windows PowerShell to create the Subscription Settings service application, and then use either Windows PowerShell or Central Administration to create the App Management service application.

To start the Subscription Settings and App Management services in Central Administration

  1. Verify that you are a member of the farm administrators group in Central Administration.

  2. In SharePoint 2013 Central Administration, click System Settings.

  3. On the System Settings page, under Servers, click Manage services on server.

  4. On the Services on Server page, next to App Management Service, click Start.

  5. On the Services on Server page, next to Microsoft SharePoint Foundation Subscription Settings Service, click Start.

  6. Verify that the App Management and Microsoft SharePoint Foundation Subscription Settings services are running. The following illustration shows the Services on Server page where you can verify that the App Management and Subscription Settings services are running.

    Services on Server showing the App Management and Subscription Settings services running.

    Verify the services are running

To configure the Subscription Settings service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. First you must establish the application pool, run as account, and database settings for the services. Use a managed account for the SPManagedAccount (which will be used for the application pool runas account).

    At the Windows PowerShell command prompt, type the following commands, and press ENTER after each one to create the application pool:

    Copy code
    $account = Get-SPManagedAccount "<AccountName>"
# Gets the name of the managed account and sets it to the variable $account for later use.

    Where:

    • <AccountName> is the name of the managed account in the SharePoint farm.

    Copy code
    $appPoolSubSvc = New-SPServiceApplicationPool -Name SettingsServiceAppPool -Account $account
# Creates an application pool for the Subscription Settings service application.
# Uses a managed account as the security account for the application pool.
# Stores the application pool as a variable for later use.

  6. At the Windows PowerShell command prompt, type the following commands, and press ENTER after each one to create the new service application and proxy:

    Copy code
    $appSubSvc = New-SPSubscriptionSettingsServiceApplication -ApplicationPool $appPoolSubSvc -Name SettingsServiceApp -DatabaseName <SettingsServiceDB>
# Creates the Subscription Settings service application, using the variable to associate it with the application pool that was created earlier.
# Stores the new service application as a variable for later use.

    Where:

    • <SettingsServiceDB> is the name of the Subscription Settings service database.

    Copy code
    $proxySubSvc = New-SPSubscriptionSettingsServiceApplicationProxy -ServiceApplication $appSubSvc
# Creates a proxy for the Subscription Settings service application.

For more information, see Get-SPManagedAccount, New-SPServiceApplicationPool, New-SPSubscriptionSettingsServiceApplication, New-SPSubscriptionSettingsServiceApplicationProxy.

You can use either Windows PowerShell or Central Administration to create and configure the App Management service application. The following procedures provide the steps for each method.

To configure the App Management service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. First you must establish the application pool, run as account, and database settings for the services. Use a managed account for the SPManagedAccount (which will be used for the application pool runas account).

    At the Windows PowerShell command prompt, type the following commands, and press ENTER after each one to create the application pool:

    Copy code
    $account = Get-SPManagedAccount "<AccountName>"
# Gets the name of the managed account and sets it to the variable $account for later use.

    Where:

    • <AccountName> is the name of the managed account in the SharePoint farm.

    Copy code
    $appPoolAppSvc = New-SPServiceApplicationPool -Name AppServiceAppPool -Account $account
# Creates an application pool for the Application Management service application.
# Uses a managed account as the security account for the application pool.
# Stores the application pool as a variable for later use.

  6. At the Windows PowerShell command prompt, type the following commands, and press ENTER after each one to create the new service application and proxy:

    Copy code
    $appAppSvc = New-SPAppManagementServiceApplication -ApplicationPool $appPoolAppSvc -Name AppServiceApp -DatabaseName <AppServiceDB>
# Creates the Application Management service application, using the variable to associate it with the application pool that was created earlier.
# Stores the new service application as a variable for later use.

    Where:

    • <AppServiceDB> is the name of the App Management service database.

    Copy code
    $proxyAppSvc = New-SPAppManagementServiceApplicationProxy -ServiceApplication $appAppSvc
# Creates a proxy for the Application Management service application.

For more information, see Get-SPManagedAccount, New-SPServiceApplicationPool, New-SPAppManagementServiceApplication and New-SPAppManagementServiceApplicationProxy.

To create the App Management service application in Central Administration

  1. In SharePoint 2013 Central Administration, on the Application Management page, click Manage service applications.

  2. On the ribbon, click New, and then click App Management Service.

  3. In the New App Management Service Application page, in the Service Application Name box, type the name for the service application.

  4. In the Database section, in the Database Server box, type the instance of SQL Server where you want to store the database, or use the default server.

  5. In the Database Name box, type a database name, or use the default name.

    The database name must be unique.

  6. Under Database authentication, select the authentication that you want to use by doing one of the following:

    • If you want to use Windows authentication, leave this option selected. We recommend this option because Windows authentication automatically encrypts the password when it connects to SQL Server.

    • If you want to use SQL authentication, click SQL authentication. In the Account box, type the name of the account that you want the service application to use to authenticate to the SQL Server database, and then type the password in the Password box.

      Note:

      In SQL authentication, an unencrypted password is sent to SQL Server. We recommend that you use SQL authentication only if you force protocol encryption to SQL Server or encrypt network traffic by using IPsec.

  7. In the Failover Database Server section, if you want to use a failover database server, specify the server name.

  8. In the Application Pool section, do one of the following:

    • Click Use existing application pool, and then select the application pool that you want to use from the drop-down list.

    • Click Create a new application pool, type the name of the new application pool, and then under Select a security account for this application pool do one of the following:

      • Click Predefined to use a predefined security account, and then select the security account from the drop-down list.

      • Click Configurable to specify a new security account to be used for an existing application pool. You can create a new account by clicking the Register new managed account link.

  9. In the Create App Management Service Application Proxy section, leave the Create App Management Service Application Proxy and add it to the default proxy group check box selected.

  10. Click OK.

    The following illustration shows the App Management service application and proxy that were created.

    Manage Service Applications page showing the App Management service application and proxy.

    The App Management service application and proxy

    Now you must start the service on the server.

  11. In SharePoint 2013 Central Administration, click System Settings.

  12. On the System Settings page, under Servers, click Manage services on server.

  13. On the Services on Server page, next to App Management Service, click Start.

Configure the app URLs to use

In this section, you create the app domain prefix and the tenant name to use for apps in your environment. The app URL points to your app domain and a prefix that determines how each app is named. If you host multiple tenants in your environment, you must use Windows PowerShell to configure the app URLs.

Use the following procedure to configure app URLs for non-hosting (single tenant) environments by using Central Administration.

To configure app URLs

  1. In Central Administration, click Apps.

  2. On the Apps page, click Configure App URLs.

  3. In the App domain box, type the isolated domain that you created for hosting apps.

    For example, ContosoApps.com or Contoso-Apps.com.

  4. In the App prefix box, type a name to use for the URL prefix for apps.

    For example, you could use "apps" as the prefix so that you would see a URL for each app such as "apps-12345678ABCDEF.ContosoApps.com". The following illustration shows the Configure App URLs page after you have filled in the App domain and prefix.

    The Configure App URLs page in Central Administration shows the App domain and App prefix.

    Configure the app domain and prefix

  5. Click OK.

  6. If you will install apps and you have changed the App prefix (also known as the site subscription name), you must perform additional steps that involve restarting the World Wide Web Publishing Service (WWW Service) that hosts the apps.

    Important:

    Restarting the WWW Service will also restart the IIS Admin Service and the Windows Process Activation Service. This will also shut down all Web sites and applications that depend on these services and they may lose existing state and will be unavailable until the services successfully restart. You should plan to perform these steps during a planned maintenance time.

    To complete the App prefix rename tasks, perform these steps:

    1. Stop the SharePoint Timer service.

    2. Restart the World Wide Web Publishing Service that hosts the apps.

    3. Start the SharePoint Timer service.

Use the following procedure to configure app URLs for multi-tenant hosting environments.

To configure app URLs by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following commands and press ENTER after each one:

    Copy code
    Set-SPAppDomain <appDomain>

    Copy code
    Set-SPAppSiteSubscriptionName -Name "app" -Confirm:$false

    Where:

    • <appDomain> is the domain name that you created.

  6. If you will install apps and you have changed the App prefix (also known as the site subscription name), you must perform additional steps that involve restarting the World Wide Web Publishing Service (WWW Service) that hosts the apps.

    Important:

    Restarting the WWW Service will also restart the IIS Admin Service and the Windows Process Activation Service. This will also shut down all Web sites and applications that depend on these services and they may lose existing state and will be unavailable until the services successfully restart. You should plan to perform these steps during a planned maintenance time.

    To complete the App prefix rename tasks, perform these steps:

    1. Stop the SharePoint Timer service.

    2. Restart the World Wide Web Publishing Service that hosts the apps.

    3. Start the SharePoint Timer service.

For more information, see Set-SPAppSiteSubscriptionName and Set-SPAppDomain.

Configure the Internet-facing endpoints feature (Optional)

The SharePoint Store contains apps for SharePoint intended for use with sites that require Internet-facing endpoints. By default, these apps are not available (greyed out and cannot be purchased) because they are incompatible with most sites. However, if your farm is configured to allow internet-facing end points, you can turn on the Internet-facing endpoints feature to show these apps in the SharePoint Store. You turn this feature on in Central Administration.

To configure Internet-facing endpoints for apps

  1. In Central Administration, click Application Management.

  2. On the Application Management page, click Manage Web applications.

  3. On the Manage Web Applications page, select the web application that you want to change.

  4. On the ribbon, click Manage Features.

  5. In the feature list, next to Apps that require accessible internet facing endpoints, click Activate.

  6. Click OK.

See also

Plan for apps for SharePoint 2013
Install and manage apps for SharePoint 2013
Plan app permissions management in SharePoint 2013
Plan for app authentication in SharePoint 2013
Configure app authentication in SharePoint Server 2013
Enable apps in AAM or host-header environments for SharePoint 2013

Change History

Date | Description
April 30, 2013 | Added an additional step to perform if the App prefix is being changed.
February 26, 2013 | Changed the account used to set up the Subscription Settings and the App Management service applications from the farm account to a managed account. The farm account is not recommended.
July 16, 2012 | Initial publication


Manage the App Catalog in SharePoint 2013
See also

Summary: You can configure and manage an App Catalog for SharePoint environments to control access to available apps.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can store apps for SharePoint and Office apps for your organization's internal use in an App Catalog site. This article contains an overview of the App Catalog site and shows how to configure the App Catalog for a web application.

In this article:

  • Before you begin

  • Configure the App Catalog site for a web application

  • Configure app requests and SharePoint Store settings

  • Add apps to the App Catalog

  • Remove apps from the App Catalog

Before you begin

Before you begin:

  • Before you configure and use the App Catalog, a member of the Farm Administrators group must configure the environment to support apps for SharePoint. For more information, see Configure an environment for apps for SharePoint (SharePoint 2013).

  • You must be a member of the Farm Administrators group to perform the steps in this article.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure the App Catalog site for a web application

The App Catalog site is a special site collection on a web application. Because each web application can have an App Catalog site, a farm can have more than one App Catalog site.

When you create an App Catalog site, you get two libraries for apps:

  • Apps for SharePoint

  • Apps for Office

Because an App Catalog is scoped to a web application, all apps that you want to make available for a web application have to be in the App Catalog site collection for that web application. You create the App Catalog site collection from SharePoint Central Administration.

To create an App Catalog site collection for a web application

  1. Verify that the user account that is performing this procedure is a member of the Farm administrators group.

  2. In Central Administration, on the Apps page, in the App Management section, click Manage App Catalog.

    If no App Catalog exists for the farm, the Web Application page opens, so you can select a web application.

  3. On the Web Application page, select the web application for which you want to create a catalog.

  4. In the App Catalog Site section, select Create a new app catalog site, and then click OK.

  5. On the Create App Catalog page, in the Title box, type a title for the App Catalog site.

  6. In the Description box, type the description for the site.

  7. In the URL box, fill in the URL to use for the site.

  8. In the Primary Site Collection Administrator section, in the User Name box, type the user who will manage the catalog.

    Only one user name can be entered. Security groups are not allowed.

  9. In the End Users section, in the Users/Groups box, type the names of the users or groups that you want to be able to browse the catalog.

    Added users or groups have read access to the App Catalog site. You can add multiple user names and security groups. Users must be added as End Users to be able to browse the App Catalog from their site collections.

  10. In the Select a quota template list box, select the quota template to use for the site.

  11. Click OK.

To use an existing App Catalog site collection for a different web application

  1. Verify that the user account that is performing this procedure is a member of the Farm administrators group.

  2. In Central Administration, on the Apps page, in the App Management section, click Manage App Catalog.

  3. On the Manage App Catalog page, next to Web Application, click the down arrow and click Change Web Application.

  4. In the Select Web Application box, select the web application for which you want to create a catalog.

  5. In the App Catalog section, select Enter a URL for an existing app catalog site.

  6. In the URL box, type the URL to the App Catalog site, and then click OK.

To view an App Catalog site collection from Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm administrators group and has Read permission to the App Catalog site.

  2. In Central Administration, on the Apps page, in the App Management section, click Manage App Catalog.

  3. On the Manage App Catalog page, verify that the web application that is selected is the web application you want to manage.

    If you want to switch to a different web application, click the down arrow next to the Web application URL to change to a different web application.

  4. Under Site URL click the link to open the App Catalog for that web application.

Configure app requests and SharePoint Store settings

Farm administrators can determine whether users can purchase apps from the SharePoint Store. This setting is at the web application scope. If users cannot purchase apps, they can still browse the SharePoint Store, and request an app. Farm administrators and the App Catalog site owner can view and respond to app requests.

To configure SharePoint Store settings

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. In Central Administration, on the Apps page, in the SharePoint and Office Store section, click Configure Store Settings.

  3. On the SharePoint Store Settings page, verify that the selected web application is the web application that you want to configure.

    If you want to switch to a different web application, click the down arrow next to the web application URL to change to a different web application.

  4. To allow or prevent purchases, select an option for Should end users be able to get apps from the SharePoint Store?

    • Select Yes to allow users to purchase apps.

    • Select No to prevent purchases but allow users to request apps.

  5. To allow or prevent apps for Office from the Office Store to be started when a user opens a document in the browser, select an option for Should apps for Office from the store be able to start when documents are opened in the browser?

    • Select Yes to allow apps for Office from the Office Store to start.

    • Select No to prevent apps for Office from the Office Store from starting.

  6. Click OK.

When users request an app for SharePoint from the SharePoint Store, users can request a specific number of licenses and provide a justification for the purchase of the app for SharePoint. Submitted requests are added to the App Requests list in the App Catalog of the web application that contains a user's site collection. The app request includes the following fields:

  • Requested by The user name of the person requesting the app for SharePoint.

  • Title The title of the app for SharePoint.

  • Seats and Site License The number of licenses the user requested for that app for SharePoint.

  • Justification The reason why the app for SharePoint would be useful for the organization.

  • Status By default, the status is set to New for new requests. The person who reviews the request can change the status to Pending, Approved, Declined, Withdrawn, Closed as Approved, or Closed as Declined.

  • View App Details A link to the app details page in the SharePoint Store.

  • Approver Comments The person who reviews the request can add comments for the requestor.

To view and manage app requests from the SharePoint Store Settings page

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group and is a member of the site Owners or Designers group for the App Catalog.

  2. In Central Administration, on the Apps page, in the SharePoint and Office Store section, click Configure Store Settings.

  3. On the SharePoint Store Settings page, verify that the selected web application is the web application that you want to configure.

    If you want to switch to a different web application, click the down arrow next to the web application URL to change to a different web application.

  4. In the App Requests section, click Click here to view app requests.

    The App Requests list in the App Catalog site opens.

  5. Select a request in the list, and then click the Edit button.

  6. Review the details of the request.

    Note:

    At this time, the View app details link in the request details opens the SharePoint Store home page, instead of the details page for the app. Search for the app in the SharePoint Store to find more information about the app.

  7. Change the Status to the appropriate value - Approved if you want to user to be able to purchase the app, or Declined if you do not want to allow the purchase.

  8. Add comments in the Approver Comments box, and then click Save.

    To view a request, requestors can go to the Add an App page in their site collection, and then click Your Requests.

To view and manage app requests from the App Catalog site

  1. Verify that the user account that is performing this procedure is a member of the site Owners or Designers group for the App Catalog.

  2. On the App Catalog site, click the App Requests list.

  3. Select a request in the list, and then click the Edit button.

  4. Review the details of the request.

    Note:

    At this time, the View app details link in the request details opens the SharePoint Store home page, instead of the details page for the app. Search for the app in the SharePoint Store to find more information about the app.

  5. Change the Status to the appropriate value - Approved if you want to user to be able to purchase the app, or Declined if you do not want to allow the app to be purchased.

  6. Add any comments in the Approver Comments box, and then click Save.

    To view a request, requestors can go to the Add an App page in their site collection, and then click Your Requests.

Add apps to the App Catalog

After you have configured the App Catalog, you can add apps that users can then install to their SharePoint sites or use in their Office documents.

To add an app to the App Catalog

  1. Verify that the user account that is performing this procedure is a member of the site Owners or Designers group for the App Catalog.

  2. On the App Catalog site, click the Apps for SharePoint list.

    On the Apps for SharePoint page, click new item.

  3. In the Choose a file box, click Browse, and then locate the folder that contains the app that you want to upload.

    Tip:

    You can also click Upload files using Windows Explorer instead to drag and drop an app for SharePoint into the App Catalog.

  4. Select the app, and then click Open.

  5. Click OK to upload the app.

  6. In the Item details box, verify the Name, Title, Short Description, Icon URL, and other settings for the app.

    Be sure that the Enabled check box is selected so that users can see the app in their sites.

    You can select the Featured check box to list the app in the Featured content view of the App Catalog.

  7. Click Save.

You can also categorize apps in the App Catalog. To add categories, edit the Category field for the App Catalog list and add the category names you want to use.

You can preview how the app will appear to users.

Remove apps from the App Catalog

If you no longer want to offer a particular app to your users, you can remove it from the App Catalog. Removal does not uninstall or remove the app from sites to which it has been added. It merely removes the app from the App Catalog, and users cannot add the app to other sites.

To remove an app from the App Catalog

  1. Verify that the user account that is performing this procedure is a member of the site Owners or Designers group for the App Catalog.

  2. On the App Catalog site, click the Apps for SharePoint list.

  3. On the Apps for SharePoint page, select the app that you want to remove.

  4. In the ribbon, on the Files tab, click Delete Document to remove the app.

  5. In the dialog box, click OK to confirm that you want to send the item to the site Recycle Bin.

    The app is removed.

See also

Install and manage apps for SharePoint 2013
Overview of apps for SharePoint 2013
Plan for apps for SharePoint 2013


Add apps for SharePoint to a SharePoint 2013 site
See also

Summary: Site owners can add apps for SharePoint to SharePoint sites so that they and other users of the site can use the app.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Site owners can add apps for SharePoint from the SharePoint Store or an App Catalog to their sites. Adding an app installs an instance of that app to the site. In addition, several lists, libraries, and other SharePoint components, which are also called apps in SharePoint 2013, are available to add to a site.

Before you begin

Before you begin this operation, review the following information about prerequisites and permissions:

  • Before a user can add an app for SharePoint, a member of the Farm Administrators group must configure the environment to support apps for SharePoint. For more information, see Configure an environment for apps for SharePoint (SharePoint 2013).

  • A user must have the Manage Web site and Create Subsites permissions to add an app for SharePoint. By default, these permissions are available only to users who have the Full Control permission level or who are in the site Owners group.

  • When a user adds an app for SharePoint, the app requests permissions that it needs to function (for example, access to Search, or to create a list). Users who do not have those permissions are informed that they do not have sufficient permissions and the app cannot be added. The user can contact a site or farm administrator to see if the administrator can add the app.

  • A user logged in to a site as the system account cannot install an app. The system account cannot import app licenses because that could result in performance problems.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Add apps for SharePoint to SharePoint sites

Site owners can add apps for SharePoint from the following sources to their sites:

  • from the list of apps already available for a site (default apps, such as standard lists and libraries, and apps that have been purchased already).

  • from the App Catalog.

  • from the SharePoint Store.

The following procedures provide steps for adding apps from these sources.

To add an app from the list of available apps in a site

  1. Verify that the user account that is performing this procedure is a member of the site Owners group.

  2. On the home page, under Get started with your site, click Add lists, libraries, and other apps.

    If the Get started with your site control does not appear on the home page, click the Settings icon, and click View Site Contents, and then on the Site Contents page, click Add an App.

  3. In the Your Apps list, click the app you want to add.

  4. Follow the instructions to Trust the app (if it is a custom component) or Name the app (if it is a SharePoint component).

    The app for SharePoint is added and appears in the Apps section of your Site Contents list.

To add an app from an App Catalog

  1. Verify that the user account that is performing this procedure is a member of the site Owners group.

  2. On the home page, under Get started with your site, click Add lists, libraries, and other apps.

    If the Get started with your site control does not appear on the home page, click the Settings icon, and click View Site Contents, and then on the Site Contents page, click Add an App.

  3. Click From Name.

    Where Name is the name of your organization's App Catalog. For example, "From Contoso".

    Tip:

    Apps marked as Featured in the App Catalog will also appear in the main list of Apps.

  4. Click the app you want to add.

  5. In the Grant Permission to an App dialog box, if you trust the app, click Allow Access.

    The app for SharePoint is added and appears in Apps section of your Site Contents list.

To add an app from the SharePoint Store

  1. Verify that the user account that is performing this procedure is a member of the site Owners group.

  2. On the home page, under Get started with your site, click Add lists, libraries, and other apps.

    If the Get started with your site control does not appear on the home page, click the Settings icon, and click View Site Contents, and then on the Site Contents page, click Add an App.

  3. Click SharePoint Store.

  4. Browse the SharePoint Store to find an app that you want.

  5. Click the app you want to add.

  6. Click Details, and then click Buy It.

  7. Follow the steps to log in and purchase the app, if required.

  8. In the Grant Permission to an App dialog box, if you trust the app, click Allow Access.

    The app for SharePoint is added and appears in the Apps section of your Site Contents list.

You can also install an app by using Windows PowerShell. First, you import the app package from the file system, and then install it to the site collection. The following procedure contains a script to perform these steps.

To install an app by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Site Owners group on the site collection to which you want to install the app.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command to import the app and then press ENTER:

    Copy code
    $spapp = Import-SPAppPackage -Path Path to app -Site URL -Source Source
# Imports the app and sets a variable that you can use to identify the app when you install it in the next step.

    Where:

    • Path to app is the path to the app you want to import on the file system.

    • URL is URL for the site collection to which you want to import the app.

    • Source is one of the following: Marketplace, CorporateCatalog, DeveloperSite, ObjectModel, RemoteObjectModel, or InvalidSource.

  4. At the question Are you sure you want to perform this action?, type Y to import the app.

    The app is imported and information about the app, including the Asset ID, version string, and Product ID is displayed.

  5. At the Windows PowerShell command prompt, type the following command to add the app to a site and then press ENTER:

    Copy code
    Install-SPApp -Web URL -Identity $spapp
# Installs the app to the subweb you specify.
# Uses the $spapp variable you set previously to identify that app you want to install.

    Where:

    • URL is URL for the site or subweb to which you want to install the app.

For more information, see Import-SPAppPackage and Install-SPApp.

See also

Install and manage apps for SharePoint 2013
Overview of apps for SharePoint 2013


Remove app for SharePoint instances from a SharePoint 2013 site
See also

Summary: When administrators remove apps for SharePoint from SharePoint sites, the apps are uninstalled and functionality is no longer available to users.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

In this article:

  • Before you begin

  • Remove an app from a SharePoint site

  • Locate and remove app instances in all locations

Before you begin

Before you begin this task, review the following information about permissions:

  • A user must have the Manage Web site permission to remove an app for SharePoint. By default, this permission is only available to users with the Full Control permission level or who are in the site Owners group.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Remove an app from a SharePoint site

Site owners can remove apps for SharePoint from their sites. Several circumstances might influence farm administrators and site owners to remove apps from their sites. For example, an app for SharePoint may no longer be needed or could become too much of a distraction to employees. The following procedures provide steps for removing (or uninstalling) an app.

Note:

When you remove an app, the data for that app will no longer be available.

To remove an app from a SharePoint site

  1. Verify that the user account that is performing this procedure is a member of the Site owners group.

  2. On the site, on the Settings menu, click View Site Contents.

  3. In the Apps section, point to the app that you want to remove, click …, and then click Remove.

  4. Click OK to confirm that you want to remove the app.

Before you use the following procedure, be sure to get the title for the app that you want to remove.

To remove an app by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Site Owners group on the site collection to which you want to install the app.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012 .

  3. At the Windows PowerShell command prompt, type the following commands, and press ENTER after each one:

    Copy code
    $instances = Get-SPAppInstance -Web <URL>
# Gets all apps installed to the subsite you specify.

    Copy code
    $instance = $instances | where {$_.Title -eq '<app_title>'}
# Sets the $instance variable to the app with the title you supply.

    Copy code
    Uninstall-SPAppInstance -Identity $instance
# Uninstalls the app from the subsite.

    Where:

    • <URL> is the path site collection or subsite that contains the app.

    • <app_title> is the title of the app you want to remove.

  4. At the question Are you sure you want to perform this action?, type Y to uninstall the app.

For more information, see Get-SPAppInstance, Uninstall-SPAppInstance.

Locate and remove app instances in all locations

An app for SharePoint in the App Catalog is available for users to install. Consequently, users can install apps for SharePoint on many sites. An administrator who wants to remove a specific app might find it difficult to locate all instances of an app.

This section provides two Windows PowerShell scripts that farm administrators and site owners can use to find all locations for a specific app and then uninstall all instances from every location. Use the first script to locate all instances of a specific app in a SharePoint environment. Then use the second script to uninstall all instances of the app from the SharePoint environment.

Note:

When you remove an app, the data for that app will no longer be available.

To locate specific apps by using Windows PowerShell (save as script and run script)

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Open the Get all App instances for a specific App on a specific web application script sample on the TechNet Gallery.

  3. Copy the code from the sample to a text editor and save the file as "Get-AppInstances.ps1"

  4. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  5. Change to the directory where you saved the file.

  6. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ./ Get-AppInstances.ps1 -productId <ProductId> -webAppUrl <webAppUrl>

    Where:

    • <ProductId> is the GUID ID of the App

    • and <webAppUrl> is the full URL of the web application.

To uninstall specific apps from all locations by using Windows PowerShell (save as script and run script)

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Open the Remove all App instances for a specific App on a specific web application script sample on the TechNet Gallery.

  3. Copy the code from the sample to a text editor and save the file as "Remove-App.ps1"

  4. Save the file as Remove-App.ps1.

  5. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  6. Change to the directory where you saved the file.

  7. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ./ Remove-App.ps1 -productId <ProductId> -webAppUrl <webAppUrl>

    Where:

    • <ProductId> is the GUID ID of the App

    • <webAppUrl> is the full URL of the web application.

For more information, see Get-SPSite.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Install and manage apps for SharePoint 2013
Overview of apps for SharePoint 2013
Add apps for SharePoint to a SharePoint 2013 site
Use Windows PowerShell to administer SharePoint 2013


Monitor apps for SharePoint for SharePoint Server 2013
See also

Summary: Learn how administrators and site owners can monitor the health and usage details for apps for SharePoint in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use the SharePoint Central Administration website to add and remove apps for SharePoint and check details and errors.

Important:

  • The steps in this article apply to SharePoint Server 2013 only.

  • App monitoring is not available in SharePoint Foundation 2013.

  • App monitoring is not supported for SharePoint Server 2013 on-premise, multi-tenancy environments.

In this article:

  • Before you begin

  • Selecting apps to monitor in Central Administration

    • To add an app to the monitor apps list

    • To remove an app from the monitor apps list

  • Monitoring app details in Central Administration

    • To view the app usage details in Monitored Apps

    • To view the app error details in Monitored Apps

  • Monitoring app details in a SharePoint site

    • To view the app usage details in a SharePoint site

Before you begin

Before you can monitor apps, a member of the Farm Administrators group must configure the environment to support apps for SharePoint. For more information, see Configure an environment for apps for SharePoint (SharePoint 2013).

You must be a member of the Farm Administrators group or the site Owners group to perform the steps in this article.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Selecting apps to monitor in Central Administration

The Monitored Apps page displays the apps for SharePoint that a Farm Administrator monitors. Each app for SharePoint that is listed on this page includes details to help an administrator monitor performance. For example, each app for SharePoint provides the following properties: Name, Status, Source, Licenses in Use, Licenses Purchased, Install Locations, and Runtime Errors. A Farm Administrator chooses to add, remove, and monitor apps for SharePoint.

Important:

The Monitor Apps page requires the following search analytics and usage file import timer jobs to be active:

  • ECM analytics timer job name: Usage Analytics timer job for Search Service

  • Usage DB timer job name: Microsoft SharePoint Foundation Usage Data Import

To add an app to the monitor apps list

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, click General Application Settings.

  3. On the General Application Settings page, in the Apps section, click Monitor Apps.

  4. On the Monitored Apps page, in the Action group of the ribbon, click Add App.

    Note:

    If the App Catalog is not already created, or if the App Management Service application and app domain settings are not configured correctly the Add App dialog may create an error.

  5. Select the checkbox for the app that you want to monitor, or type a name in the Search for app name box, and then click the Search icon.

  6. On the search results page, select the app that you want to monitor.

    Note:

    Apps that you add to the Monitored Apps list previously are not displayed in the search results.

  7. Click Add App.

    The app now appears in the list of monitored apps.

To remove an app from the monitor apps list

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Monitored Apps page, select the checkbox next to the app that you want to remove.

  3. In the Manage group of the ribbon, click Remove App.

Monitoring app details in Central Administration

This section explains how farm administrators can monitor and understand the apps for SharePoint details. There are multiple ways that an administrator can view the error and usage details for apps for SharePoint. By selecting an app in the Monitored Apps page, an administrator can use the ribbon to access the error or usage details for that app. An administrator can also click an app in the list on the Monitored Apps page to open the app details page and access the same error or usage details.

The app usage and app error details data that is in the app monitoring pages can be delayed for up to 29 hours. The app details depend on when the ECM analytics timer job is scheduled to run. When the timer job runs, it collects events for the previous day. For example, if the timer job is scheduled to run at 5 A.M., then the most recent events that are collected are from 11:59 P.M. the previous day. An event that occurs at 12:01 A.M. will not appear in the app details pages until up to 29 hours later.

Note that if you view the app error details page for a specific instance of an app, the number of errors for the app is synchronized with the error messages in the list. This occurs because the number of errors appears in the app error details page instead of the events that are processed by the ECM analytics timer job.

Note:

Be aware that in the Monitored Apps page, the error dialog box can show more errors than are counted. The errors are counted every 24 hours, but the error messages are processed more often. As a result, the error dialog box can show error messages that are generated in the current day before the count is updated at the end of the day.

To view the app usage details in Monitored Apps

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Monitored Apps page, click the app that you want to view.

    A new page opens and displays detailed information about the app, such as the following: licensing, errors, installations, and usage.

    Note:

    The administrator can also select an app in the monitored apps list and in the App Details group of the ribbon, click View Details.

  3. In the Usage section, click Days, Months, or Years to change the chart to those time frames.

To view the app error details in Monitored Apps

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Monitored Apps page, click the number in the Runtime Errors column for the app you want to view.

    Note:

    The administrator can also select an app in the monitored apps list and in the App Details group of the ribbon, click View Errors.

  3. The App Monitoring Details dialog appears with information about each error for that app. You can use the Correlation ID to find the errors in the error log.

  4. Click the URL in the Location column to view more error details for this app.

  5. On the App Monitoring Details page, click the number next to Runtime Errors.

  6. The App Monitoring Details dialog appears and includes a list of all Runtime Errors for this app, the time each error occurred, and the Correlation ID.

    Note:

    The app error list can help you determine if you want to remove the app because there are too many errors or if the app is working as it should.

Monitoring app details in a SharePoint site

This section explains how site owners can monitor and understand the usage of apps for SharePoint. A site owner can view the error and usage details for apps for SharePoint by selecting an app in the Site Contents page and then clicking Monitor in the app dialog box.

Note:

Be aware that in the app details page, the error dialog box can show more errors than are counted. The errors are counted every 24 hours, but the error messages are processed more often. As a result, the error dialog box can show error messages that are generated in the current day before the count is updated at the end of the day.

To view the app usage details in a SharePoint site

  1. Verify that the user account that is performing this procedure is a member of the site Owners group.

  2. On the Site Contents page, in the quick launch pane, click Apps.

    A new page opens and displays all of the apps that are installed on this site.

  3. On the Apps page click the icon next to the app you want to monitor and then click Details in the callout.

    The App Details page appears for the selected app and the site owner can see the details for licenses, errors Installs and usage.

  4. In the Errors section, click the number next to Install Errors, Runtime Errors, or Upgrade Errors to see the error details.

    For example, click the number next to Runtime Errors and the Runtime Errors dialog appears. This includes a list of all Runtime Errors for this app, the time each error occurred, and the Correlation ID.

    This app error list can help you determine if you want to remove the app because there are too many errors or if the app is working as it should.

    Note:

    The app errors that appear in this list have occurred within the previous four days.

  5. In the Usage section, click Days, Months, or Years to change the chart to those time frames.

    The chart displays two bars for each time period that represents the number of times the app has been launched and the number of specific users that use this app each day.

    Note:

    If the app uses connections to external data sources through Business Connectivity Services, a graph that shows the number of calls made to the external data sources is also shown. Dates that appear in the Usage and BCS Calls graphs are in Coordinated Universal Time (UTC).

See also

Plan for apps for SharePoint 2013


Monitor and manage app licenses in SharePoint Server 2013
See also

Summary: Learn how SharePoint farm administrators assign, monitor, and manage the app for SharePoint licenses in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use the SharePoint Central Administration website to monitor and manage licenses for the apps for SharePoint. Licenses for apps for SharePoint are digital sets of verifiable information that state the user rights for a app for SharePoint. All apps that are distributed through the SharePoint Store are the only apps that have built-in licenses that SharePoint Server 2013 recognizes.

Members of the Farm Administrators group manage licenses for apps and can also assign license managers for others to manage app for SharePoint licenses.

Important:

The steps in this article apply to SharePoint Server 2013 only.

Before you begin

Before you can monitor and manage app licenses you must configure your environment to support apps for SharePoint. You must be a member of the Farm Administrators group to perform these steps. For more information, see Configure an environment for apps for SharePoint (SharePoint 2013).

Important:

We support only one App Management Service Application per farm. This helps ensure that the app license feature functions correctly.

Before you begin this operation, review the following information about what SharePoint Server 2013 does and does not provide for apps for SharePoint licensing:

  • SharePoint Server 2013 provides:

    • Storefront to obtain apps

    • Storage and renewal of app for SharePoint licenses

    • User Interface (UI) to assign users to specific app for SharePoint licenses

    • APIs for developers to query for license information

  • SharePoint Server 2013 does not enforce app for SharePoint licenses.

  • Developers must add code in their apps for SharePoint to retrieve license information and react accordingly.

  • All app for SharePoint licenses are bound to a specific SharePoint Server 2013 deployment but can be transferred to a different SharePoint Server 2013 deployment three times.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Monitoring and managing app licenses

A farm administrator or a license manager can check the licenses for all apps for SharePoint on the App Licenses page. It is important to track the number of licenses that are available for each app for SharePoint so that users do not exceed this number. An administrator can assign additional users to a app for SharePoint license, purchase additional licenses for an app, and also add managers to a license. For more information about how to monitor apps for SharePoint see, Monitor apps for SharePoint for SharePoint Server 2013.

To view app license details

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group or a license manager.

  2. In Central Administration, click Apps.

  3. On the Apps page, in the Store section, click Manage App Licenses.

  4. On the Manage App Licenses page, click an app for SharePoint in the list to view the license details.

    The Manage App License page shows detailed licensing information. This includes the name of the app, the developer, and current license details.

  5. In the top section, click the drop-down arrow in the dialog box to see purchase details for the selected app for SharePoint.

    The app details include the following information:

    • Number of licenses available for users

    • License type

    • App purchaser name

  6. At the end of the dialog box, a farm administrator can view the app details.

    • Click View in Store to see the app details.

      • In the People with a License (number of licenses available)section, the number of available licenses and a list of the people who currently have licenses for this App are shown.

      • In the License Managers section, all app managers are listed.

To add users to the app license

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Manage App Licenses page, click an app for SharePoint for which you want to add users.

  3. In the People with a License section, click assign people.

  4. In the dialog box that appears below, enter the user name that you want to add and then, click Add User.

    The user name is added to the list at the bottom of this section and the number of available licenses for this app is refreshed for the selected app for SharePoint.

To purchase more app licenses

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Manage App Licenses page, click an app for SharePoint for which you want to purchase more licenses.

  3. In the People with a License section, click buy more licenses.

  4. The SharePoint Store opens with the specific app showing the details with links to purchase additional licenses. Choose the number of Apps you want to purchase and then click OK.

To remove app licenses

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Manage App Licenses page, click an app for SharePoint for which you want to remove licenses.

  3. In the top section, under the app for SharePoint name, at the end of the dialog box, click Remove this License.

  4. Verification: Optionally, include steps that users should perform to verify that the operation was successful.

To recover app licenses

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Manage App Licenses page, click an app for SharePoint for which you want to recover licenses.

  3. In the top section, under the app name, at the end of the dialog box, click Recover License.

    The app for SharePoint details show any changes the administrator has made.

To add a license manager

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Manage App License page, in the License Managers section, click add manager.

    Below the License Managers section, the new App manager appears in the list.

See also

Overview of apps for SharePoint 2013


Enable apps in AAM or host-header environments for SharePoint 2013
See also

Published: March 12, 2013

Learn how to enable app domains for alternate access mappings or host-header web application environments after installing the March 2013 Public Update.

Applies to: Microsoft SharePoint technologies | SharePoint Foundation 2013 | SharePoint Server 2013

One of the feature updates of the March 2013 Public Update for SharePoint 2013 enables you to use multiple app domains in SharePoint 2013 environments with alternate access mapping or host-header web application configurations. Before the Public Update, you could only host one app domain and it had to be in the Default zone. You could not use the app domain on alternate access mappings or host-header web application configurations. The Public Update enables you to configure an app domain for each web application zone and use alternate access mapping and host-header web application configuration. For more information about apps for SharePoint 2013, see, Overview of apps for SharePoint 2013.

Although the Public Update automatically installs the necessary pieces, the feature is not enabled by default. To use the new feature, you must prepare the environment, enable the feature, and configure the app domains and zones.

Important:

To enable and use this feature, you have to use a reverse proxy to allow traffic for the app domains. The Public Update does not install or configure the reverse proxy. You must set up the reverse proxy. For more information about how to set up a reverse proxy for SharePoint 2013, refer to the proxy hardware manufacturer's documentation.

Note:

You can only enable and configure this feature by using Windows PowerShell.

The March 2013 Public Update for SharePoint 2013 installs the following new Windows PowerShell cmdlets:

  • New-SPWebApplicationAppDomain

  • Get-SPWebApplicationAppDomain

  • Remove-SPWebApplicationAppDomain

To complete the process, follow the procedures consecutively.

In this article:

  • Prepare the environment

  • Configure app domains

  • Enable the feature

  • Enable the SharePoint Health Analyzer rule

  • Special conditions and limitations

Prepare the environment

You must configure the farm-level app domain. For more information, see Configure an environment for apps for SharePoint (SharePoint 2013).

Configure app domains

To use the enabled feature, you have to configure the app domains, create DNS entries with specific routing rules, and then enable the feature. Use the following procedures to create the DNS entries and routing rules, and to add, remove, or alter app domains. You only have to run the configuration one time for each app domain in each zone on every web application. To enable the feature, see Enable the feature later in this article.

Note:

Apps domains can be shared across web applications if the zone, application pool identity, and authentication schemes match. For example suppose that webappA is configured to use the Default zone and webappB is also configured to use the Default zone. In addition, both web applications use the same application pool identity, and both web applications use NTLM. In this scenario, the web applications can share a single app domain.

Important:

Ensure that the domains follow the same guideline for the wildcard DNS entry and SSL cert as the farm app domain. For more information see, Configure an environment for apps for SharePoint (SharePoint 2013).

You must also create DNS entries for each app domain, including a routing rule. For more information about how to do this, see Configure an environment for apps for SharePoint (SharePoint 2013).

Because the SharePoint 2013 backup and restore process does not restore the alternate access mapping or host-header web application configuration, we recommend that you use a script to perform the configuration. If necessary, you can restore settings by running the script again.

In this section:

  • To configure app domains by using Windows PowerShell

  • To remove app domains by using Windows PowerShell

  • To alter app domains settings by using Windows PowerShell

To configure app domains by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SPWebApplicationAppDomain -AppDomain <AppDomain> -WebApplication <WebApplicationID> -Zone <Zone> -Port <Port> -SecureSocketsLayer

    Where:

    • <AppDomain> is the URI of the app domain.

      This parameter is required.

    • <WebApplicationID> is the GUID, URI, or name of the web application for which the app domain is being configured.

      This parameter is required.

    • <Zone> is the security zone to which the app domain will be assigned. Possible values are "Default", "Intranet", "Internet", "Custom", or "Extranet". If no value is specified "Default" will be applied.

      This parameter is optional.

    • <Port> is the IIS port number to which the app domain will be assigned. If no value is specified, the same port that is used by the web application for the zone will be applied.

      This parameter is optional.

    • -SecureSocketsLayer is a parameter to specify that the app domain will use Secured Sockets Layer (SSL) security. If no value is specified, no SSL security will be used.

      This parameter is optional.

To remove app domains by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Remove-SPWebApplicationAppDomain -WebApplication <WebApplicationID> -Zone <Zone>

    Where:

    • <WebApplicationID> is the GUID, URI, or name of the web application for which the app domains will be removed.

      This parameter is required.

    • <Zone> is the security zone from which the app domain will be removed. Possible values are "Default", "Intranet", "Internet", "Custom", or "Extranet". If no value is specified, all of the app domains for the web application will be removed.

      This parameter is optional.

To alter app domains settings by using Windows PowerShell

  1. To alter the settings for an app domain, such as after the authentication scheme of the zone is changed, you must use the Remove -SPWebApplicationAppDomain cmdlet to remove the app domain and then use the New -SPWebApplicationAppDomain cmdlet to re-create it. For more information about how to use these cmdlets, see the sections earlier in this article.

Enable the feature

To use the feature, you must first configure the app domains and then enable the feature. Use the following procedures to enable or disable the feature.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

To enable feature by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Important:

    Executing these commands will briefly interrupt Internet Information Services (IIS) 7.0.

    Copy code
    $contentService = [Microsoft.SharePoint.Administration.SPWebService]::ContentService
    Copy code
    $contentService.SupportMultipleAppDomains = $true
    Copy code
    $contentService.Update()
    Copy code
    Iisreset

    To disable the feature, at the Windows PowerShell command prompt, type the following command:

    Important:

    Executing these commands will briefly interrupt IIS 7.0.

    Copy code
    $contentService = [Microsoft.SharePoint.Administration.SPWebService]::ContentService
    Copy code
    $contentService.SupportMultipleAppDomains = $false
    Copy code
    $contentService.Update()
    Copy code
    Iisreset

Enable the SharePoint Health Analyzer rule

A SharePoint Health Analyzer (SPHA) rule is also installed with the feature but it is not enabled by default. This rule helps you detect any configuration problems that might occur with app domains. Use the procedure below to enable this SPHA rule.

To enable the SharePoint Health Analyzer rule by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPHealthAnalysisRule WebApplicationAppDomainsConfigurationTest | Enable-SPHealthAnalysisRule

For more information, see Get-SPHealthAnalysisRule or Enable-SPHealthAnalysisRule.

Special conditions and limitations

The feature in the Public Update has some special conditions and limitations. Review this list before you create app domains to ensure that the app domains are created correctly. The list might also help you troubleshoot problems when you create app domains:

  • You cannot add an app domain to a zone that does not exist. Ensure that the zone exists, or create it, before you add app domains to the zone.

  • To share an app domain across two web applications, the web applications must share the same application pool identity and both have to be configured to use the same zone and authentication scheme.

  • You cannot use IIS ports that are already being used when you configure app domains.

  • If the app domain is configured to use secure sockets layer (SSL) you must configure the app domain to use a wildcard certificate and bind the SSL to a different port from the web application SSL port.

  • You cannot use both the -Identity and -WebApplication parameters at the same time with the Get-SPWebApplicationAppDomain Windows PowerShell cmdlet. You can use either parameter by itself but not both together.

  • If the app domain is associated with multiple web applications, the Get-SPWebApplicationAppDomain Windows PowerShell cmdlet returns an ambiguous error when you use the -Identity parameter. The error message is: Get-SPWebApplicationAppDomain : Cannot find an SPAppDomain object with AppDomain: <Domain>.

  • You must enable the feature before you can use an app domain that you create. If you use the New-SPWebApplicationAppDomain Windows PowerShell cmdlet to create an app domain before you enable the feature, the cmdlet will create the app domain. You must enable the feature before you can use the app domain. To simplify the process, ensure that you enable the feature before you create app domains. You can use the Get-SPWebApplicationAppDomain Windows PowerShell cmdlet to confirm successful creation of app domains

See also

Configure an environment for apps for SharePoint (SharePoint 2013)
Overview of apps for SharePoint 2013


Upgrade to SharePoint 2013

Summary: Learn how to plan, prepare, and perform an upgrade to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about performing an upgrade to SharePoint 2013.

Downloadable resources about upgrade

Download the following content for information about upgrade.

 | Content | Description
Architecture icon | SharePoint 2013 - Upgrade Process model | Describes the steps in the process for a database-attach upgrade.
Architecture icon | SharePoint 2013 - Test Your Upgrade Process model | See a visual display of information about how to test the upgrade process.
Downloads | SharePoint 2013 Upgrade Worksheet | Use this worksheet to record information about your environment while you test upgrade.

TechNet articles about upgrade

The following articles about upgrade are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Get started with upgrades to SharePoint 2013 | Find resources to help you understand how to upgrade databases and site collections from SharePoint 2010 Products to SharePoint 2013.
Plan for upgrade to SharePoint 2013 | Find resources about how to plan to upgrade from SharePoint 2010 Products to SharePoint 2013.
Test and troubleshoot an upgrade to SharePoint 2013 | Find resources about how to test and troubleshoot an upgrade from SharePoint 2010 Products to SharePoint 2013.
Upgrade databases from SharePoint 2010 to SharePoint 2013 | Find resources to help you perform the steps to upgrade databases from SharePoint 2010 Products to SharePoint 2013.
Upgrade site collections to SharePoint 2013 | Find out how to upgrade a site collection to SharePoint 2013.
Advanced upgrade scenarios for SharePoint 2013 | Learn how to upgrade to SharePoint 2013 in advanced scenarios, such as from Office SharePoint Server 2007 or Windows SharePoint Services 3.0, from FAST Search Server, or when using content type syndication.

Additional resources about upgrade

The following resources about upgrade are available from other subject matter experts.

 | Content | Description
TechNet logo | Upgrade and Migration Resource Center for SharePoint 2013 Products | Visit the Resource Center to find additional information about upgrades to SharePoint 2013.
TechNet logo | Capabilities and features in SharePoint 2013 Resource Center | Visit the Resource Center to learn about what's new in SharePoint 2013.


Get started with upgrades to SharePoint 2013
See also

Summary: Find resources to help you understand how to upgrade databases and site collections from SharePoint 2010 Products to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The first step in any upgrade process is to learn about the process itself so that you can plan and prepare appropriately. These articles help you understand how the process of upgrading from SharePoint 2010 Products to SharePoint 2013 works. These articles also include overviews of how to upgrade service applications.

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about understanding upgrade for SharePoint 2013.

Downloadable resources about upgrade to SharePoint 2013

Download the following content for information about upgrade.

 | Content | Description
Architecture icon | SharePoint 2013 Products Preview - Upgrade Process model | Describes the steps in the process for a database attach upgrade

TechNet articles about understanding upgrade

The following articles about understanding upgrade are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
What's new icon (box) | What's new in SharePoint 2013 upgrade | Find out about new requirements, approaches, and features that are available for upgrading to SharePoint 2013.
Building blocks | Overview of the upgrade process to SharePoint 2013 | Get a visual overview of the steps involved in performing an upgrade.
 | Upgrade overview videos for SharePoint 2013 | View this series of short overview videos to understand how upgrade works for SharePoint 2013.
Building blocks | Services upgrade overview for SharePoint Server 2013 | SharePoint 2010 Products included several service applications, some of which have databases that can be upgraded when you upgrade to SharePoint 2013. Find out which service application databases can be upgraded and what steps that you must take before, during, and after upgrade for your service applications.
Building blocks | Upgrade farms that share services (parent and child farms) to SharePoint 2013 | In SharePoint Server 2010, it was possible to configure parent farms and child farms to share services. In such an environment, the parent farm hosts one or more service applications from which one or more child farms consume services. Learn how to approach upgrading these environments to SharePoint Server 2013.
Building blocks | Best practices for upgrading to SharePoint 2013 | Get off to the right start - review these best practices for testing and performing an upgrade to SharePoint 2013.
Building blocks | Review supported editions and products for upgrading to SharePoint 2013 | Understand the requirements for upgrade. And if you are planning to change SKUs or products during upgrade, understand which upgrade paths are supported.

Additional resources about upgrade to SharePoint 2013

The following resources about upgrade to SharePoint 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | Upgrade and migration for SharePoint 2013 IT Pros Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.

See also

Upgrade to SharePoint 2013
Plan for upgrade to SharePoint 2013


What's new in SharePoint 2013 upgrade
See also

Summary: SharePoint 2013 includes new upgrade features, such as upgrade for service applications, a site health checker, and upgrade for site collections.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint 2013 does not support in-place upgrade for an existing environment. You must use the database-attach upgrade method to upgrade your databases to a new environment that is based on SharePoint 2013. Also, to provide more flexibility to farm administrators and site administrators, the upgrade process has changed to separate upgrade of the software and databases from upgrade of the sites.

In-place upgrade of the farm is not supported

An upgrade to SharePoint Server 2010 or SharePoint Foundation 2010 provides an option to install the new version over the earlier version on the same hardware. This is called an in-place upgrade. During this process, the complete installation, that includes databases and sites, is upgraded in a fixed order. Although this is a simple method, in-place upgrade presents problems in performance and control for a farm administrator. There was no way to control the order in which content is upgraded, and a failure in a particular site collection could stop the whole process.

The database-attach upgrade method offers more flexibility, more control, and a better success rate. To use a database attach upgrade, you complete the following tasks:

  1. Create and configure a new farm that is separate from the old farm

  2. Copy the content and services databases to the new farm

  3. Upgrade the data and sites

You can upgrade the content databases in any order and upgrade several databases at the same time to speed up the overall process.

For more information, see Overview of the upgrade process to SharePoint 2013.

Database-attach upgrade is available for some service application databases

For the SharePoint 2013, you can use the database attach upgrade method to upgrade the following service application databases:

  • Business Data Connectivity

    This service application is available for both SharePoint Server 2013 and SharePoint Foundation 2013.

  • Managed Metadata

    This service application is available only for SharePoint Server 2013.

  • PerformancePoint

    This service application is available only for SharePoint Server 2013.

  • Secure Store

    This service application is available only for SharePoint Server 2013.

  • User Profile (Profile, Social, and Sync databases)

    This service application is available only for SharePoint Server 2013.

  • Search administration

    This service application is available only for SharePoint Server 2013.

For more information, see Services upgrade overview for SharePoint Server 2013.

Deferred site collection upgrade

In SharePoint 2010 Products, farm administrators use either the in-place upgrade process to upgrade sites immediately, or the command line to upgrade all sites at the same time or individually. In SharePoint 2013, farm administrators can now allow site collection owners to upgrade their sites to the new user interface on their own timeline. The commands for upgrading a site collection are on the Site Settings page in the Site Collection Administration section. There are also Windows PowerShell cmdlets to upgrade site collections to the new user interface. For more information, see Plan for site collection upgrades in SharePoint 2013, Upgrade a site collection to SharePoint 2013and Manage site collection upgrades to SharePoint 2013.

Site collection health checker

Site collection owners or administrators can use a site collection health checker to detect any potential issues with their site collections and address them before they upgrade sites to the new version. The checker is available after upgrade also to detect any health issues on an ongoing basis. Note that some issues can be repaired automatically, but others require manual steps to repair. During a site collection upgrade, if the checker finds issues that can be repaired automatically, they are repaired at that time. For more information, see Run site collection health checks in SharePoint 2013.

Upgrade evaluation site collections

In SharePoint 2013, the upgrade of the software and data was separated from the upgrade of the site. This means that the sites can truly remain running in SharePoint 2010 mode until a site owner or administrator explicitly upgrades the site to the new user interface. Site collection owners can request an evaluation site, which is a separate copy of the site, to review the new interface and functionality. After they have reviewed the site and made necessary changes in their original site, they can then upgrade their sites to the new version. Evaluation sites are set to automatically expire and be deleted. For more information, see Plan for upgrade evaluation sites, Create an upgrade evaluation site (Optional), and Manage site collection upgrades to SharePoint 2013.

Notifications for life-cycle events

An email message and a status bar notification in a site collection notifies site collection owners when an upgrade is available. Site collection owners can create an evaluation site from email and control the expiration and deletion of that site by using email also. A status bar notification in the site collection also informs all users if a site is in read-only mode. For more information, see Plan settings for upgrade notifications, self-service upgrade, and site collection creation and Manage site collection upgrades to SharePoint 2013.

Throttles for site collection upgrade

To make sure that site collection upgrades do not cause an outage on your farm, there are throttles built in at the web application, database, and content level. This means that even if 100 site collection owners decide to upgrade their site collections at the same time, only some are run at the same time, and the rest are put into a queue to run later. For more information, see Plan site collection upgrade throttling and queues and Manage site collection upgrades to SharePoint 2013.

True "SharePoint 2010" instead of visual upgrade

Visual upgrade in SharePoint 2010 Products lets site owners and administrators see what their site would be like in the new user interface. However, it is not a true preview because the site itself has already been upgraded to the new functionality. Consequently, some Web Parts or other elements do not display correctly.

SharePoint 2013 can host sites in both SharePoint 2010 and SharePoint 2013 modes. The installation contains both SharePoint 2010 and SharePoint 2013 versions of the following types of elements:

  • Features, site templates, site definitions, and Web Parts

    The directories on the file system are duplicated in both the 14 and 15 paths, for example:

    • Web Server Extensions/14/TEMPLATE/Features

    • Web Server Extensions/15/TEMPLATE/Features

  • IIS support directories:

    • _Layouts, _Layouts/15

    • _ControlTemplates, _ControlTemplates/15

  • Solution deployment, which lets legacy solutions work in 2010 mode

    Note that existing SharePoint 2010 Products solutions can be deployed to SharePoint 2013 and continue to function for 2010 sites, usually without requiring any changes.

Because of these directories, you can continue hosting unupgraded sites in an upgraded environment until all site collections are ready to upgrade. For more information, see About site collection modes.

Log files now in ULS format

The format of the upgrade, upgrade error, and site upgrade log files now comply with the Unified Logging System (ULS) conventions for easier review. For more information, see Verify database upgrades in SharePoint 2013.

See also

Capabilities and features in SharePoint 2013 Resource Center
Upgrade and Migration Resource Center for SharePoint 2013 Products


Overview of the upgrade process to SharePoint 2013
See also

Summary: Learn about the process of upgrading databases, service applications, My Sites, and site collections to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

To upgrade from SharePoint 2010 Products to SharePoint 2013, you use the database-attach method to upgrade. In the database-attach method, you first create and configure a SharePoint 2013 farm. Then you copy the content and service application databases from the SharePoint 2010 Products farm, and then attach and upgrade the databases. This upgrades the data to the new version. Site owners can then upgrade individual site collections.

Figure: The sequence of upgrade stages

Stages in upgrade process for SharePoint 2013

This article helps you understand the upgrade sequence so that you can plan an upgrade project. To get detailed steps for an upgrade, see Upgrade databases from SharePoint 2010 to SharePoint 2013 and Upgrade site collections to SharePoint 2013.

Important:

This article applies to both SharePoint Foundation 2013 and SharePoint Server 2013, except for information about how to upgrade My Sites and specific service applications that are only in SharePoint Server 2013.

Watch the SharePoint 2013 Upgrade: Overview video

Video (play button) icon

Create the SharePoint 2013 farm

The first stage in the upgrade process creates the new SharePoint 2013 farm:

  1. A server farm administrator installs SharePoint 2013 to a new farm. The administrator configures farm settings and tests the environment.

  2. A server farm administrator sets the SharePoint 2010 Products farm to read-only so that users can continue to access the old farm while upgrade is in progress on the new farm.

    Figure: Create new farm, set old farm to read-only

    Create new farm, set old farm to read-only

Copy the SharePoint 2010 Products databases

The second stage in the upgrade process copies the databases to the new environment. You use SQL Server Management Studio for these tasks.

  1. With the farm and databases in read-only mode, a server farm administrator backs up the content and service application databases from the SQL Server instance on the SharePoint 2010 Products farm.

  2. The server farm administrator restores a copy of the databases to the SQL Server instance on the SharePoint 2013 farm and sets the databases to read-write on the new farm.

    Figure: Use SQL Server tools to copy databases

    Use SQL Server tools to copy databases

Upgrade SharePoint 2010 Products databases and service applications

The third stage in the upgrade process upgrades the databases and service applications.

  1. A server farm administrator configures the service applications for the new farm. The following service applications have databases that you can upgrade during this process:

    • SharePoint Server 2010 and SharePoint Foundation 2010

      • Business Data Connectivity service application

    • SharePoint Server 2010 only

      • Managed Metadata service application

      • PerformancePoint Services service application

      • Search service application

      • Secure Store Service application

      • User Profile service application

  2. A server farm administrator creates a web application on the SharePoint 2013 farm for each web application on the SharePoint 2010 Products farm.

    Figure: Create web applications for upgrade

    Create Web applications for upgrade

  3. A server farm administrator installs all server-side customizations.

    Figure: Copy customizations to the new farm

    Copy customizations to new farm

  4. A server farm administrator then attaches the content databases to the new farm and upgrades the content databases for those web applications.

    Figure: Upgrade the databases by using Windows PowerShell

    Upgrade the databases with Windows PowerShell

  5. A server farm administrator confirms that the upgrade is successful.

Upgrade SharePoint 2010 Products site collections

The final stage in the upgrade process is to upgrade the site collections. In SharePoint 2013, site owners are in charge of upgrading their sites. The upgrade process for My Sites is slightly different from for other types of site collections.

Upgrade My Sites

Important:

This section applies to SharePoint Server 2013 only.

A server farm administrator upgrades the My Site host and then individual users can upgrade their My Sites or the farm administrator can upgrade them by using Windows PowerShell. The following illustration shows four stages for the My Site host and My Sites during the upgrade process.

Figure: Stages in upgrading My Sites

Stages in upgrading My Sites

  1. The My Site host has not been upgraded. My Sites cannot be upgraded yet.

  2. A server farm administrator has upgraded the My Site host. No My Sites have been upgraded.

  3. Some users have upgraded their My Sites.

  4. All My Sites have been upgraded.

Note:

A server farm administrator can choose to force an upgrade of My Sites without waiting for users to upgrade them. For details and steps, read Upgrade site collections to SharePoint 2013.

Upgrade other SharePoint 2010 Products site collections

Owners of all other site collections can start to upgrade their sites as soon as they see a notification on their site's home page that the new version is available. The following illustration shows four stages for a site collection during the upgrade process.

Stages in upgrading site collections

Stages in upgrading site collections

  1. The site owner runs the site collection health checks to determine readiness for upgrade. The site owner addresses issues before they continue with the next step.

  2. Optionally, the site owner requests an upgrade evaluation site collection. A timer job runs to create the site collection and the site owner receives an email message when the evaluation site collection is ready. The site owner previews the new user interface. After several days or weeks, the evaluation site collection expires and is deleted by a timer job.

    A server farm administrator can determine the length of time before expiration.

  3. When the site owner is ready, the site owner starts the upgrade process. The site collection health checks are run again automatically. The site owner must address issues before upgrading. If health checks return no issues, the upgrade starts.

  4. When upgrade is complete, the site owner sees the Upgrade Status page that contains the status and a link to the upgrade logs. The site owner reviews the site to make sure that everything works correctly.

Note:

A server farm administrator can also force specific site collections to be upgraded without waiting for the site owners to upgrade them. For details and steps, read Upgrade site collections to SharePoint 2013.

See also

Upgrade databases from SharePoint 2010 to SharePoint 2013
Upgrade site collections to SharePoint 2013
Upgrade to SharePoint 2013
Get started with upgrades to SharePoint 2013
Plan for upgrade to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Upgrade overview videos for SharePoint 2013
See also

Published: February 5, 2013

Summary: View this series of short overview videos to understand how upgrade works for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following six videos (each video is less than five minutes) can help you understand how to upgrade to SharePoint 2013.

Overview: SharePoint 2013 upgrade process

This video provides a brief overview of the upgrade process for SharePoint 2013 (video 1 of 6).

Watch the SharePoint 2013 Upgrade: Overview video

Video (play button) icon

Related resources

Resource | Description
Overview of the upgrade process to SharePoint 2013 | Learn about how to upgrade databases, service applications, My Sites, and site collections to SharePoint 2013.

Phase 1: Create the SharePoint 2013 farm

This video provides a quick explanation of how to create a farm for use in an upgrade to SharePoint 2013 (video 2 of 6).

Watch the SharePoint 2013 Upgrade: Phase 1 video

Video (play button) icon

Related resources

Resource | Description
Create the SharePoint 2013 farm for a database attach upgrade | Create and configure a SharePoint 2013 farm so that you can upgrade databases from SharePoint 2010 Products.

Phase 2: Copy the databases to the new farm

This video provides a quick explanation of how to copy SharePoint 2010 databases to a SharePoint 2013 farm for upgrade (video 3 of 6).

Watch the SharePoint 2013 Upgrade: Phase 2 video

Video (play button) icon

Related resources

Resource | Description
Copy databases to the new farm for upgrade to SharePoint 2013 | Copy SharePoint 2010 Products content and service databases to a SharePoint 2013 farm so that you can upgrade the data to SharePoint 2013.

Phase 3: Upgrade the service applications

This video provides a quick explanation of how to upgrade service applications to SharePoint 2013 (video 4 of 6).

Watch the SharePoint 2013 Upgrade: Phase 3 video

Video (play button) icon

Related resources

Resource | Description
Upgrade service applications to SharePoint 2013 | Upgrade service applications (Business Connectivity Services, Managed Metadata, Secure Store, User Profiles, Search) to SharePoint 2013.

Phase 4: Upgrade content databases

This video provides a quick explanation of how to upgrade content databases to SharePoint 2013 (video 5 of 6).

Watch the SharePoint 2013 Upgrade: Phase 4 video

Video (play button) icon

Related resources

Resource | Description
Upgrade content databases to SharePoint 2013 | Learn how to upgrade content databases from SharePoint 2010 Products to SharePoint 2013.
Migrate from classic-mode to claims-based authentication in SharePoint 2013 | Convert SharePoint 2010 Products or SharePoint 2013 classic-mode web applications to claims-based authentication or create new claims-based web applications in SharePoint 2013.

Phase 5: Upgrade site collections

This video provides a quick explanation of how to upgrade site collections to SharePoint 2013 (video 6 of 6).

Watch the SharePoint 2013 Upgrade: Phase 5 video

Video (play button) icon

Related resources

Resource | Description
Upgrade a site collection to SharePoint 2013 | Learn how site collection administrators can preview a copy of their sites in SharePoint 2013 mode, and then upgrade their sites.

See also

Video demos and training for SharePoint 2013
Upgrade to SharePoint 2013
Checklist for database-attach upgrade (SharePoint 2013)

Upgrade and Migration Resource Center for SharePoint 2013 Products


Services upgrade overview for SharePoint Server 2013
See also

Summary: Create a plan to upgrade data for service applications when you upgrade from SharePoint Server 2010 to SharePoint Server 2013.

Applies to: SharePoint Server 2013

The upgrade process for SharePoint Server 2013 uses the database attach upgrade method. When you move your databases to a new farm and upgrade the content, you must create your services infrastructure in the new farm, and configure the services appropriately for your new farm and new version. The following service applications have databases that can be upgraded when you upgrade from SharePoint Server 2010 to SharePoint Server 2013:

  • Business Data Connectivity service application

  • Managed Metadata service application

  • PerformancePoint Services service application

  • Search service application

  • Secure Store Service application

  • User Profile service application

Attaching and upgrading these databases configures these service applications. Settings for other services will have to be reconfigured when you upgrade.

Important:

The content in this article about the Business Data Connectivity service application applies to both SharePoint Foundation 2013 and SharePoint Server 2013. Other services are available only in SharePoint Server 2013.

Database attach upgrade with services

You must create the service applications on your new farm before you upgrade your content databases. The steps included in the installation guide above describe how to use the Farm Configuration Wizard to enable all service applications. Some service applications can be upgraded by using a service application database upgrade. If you want to upgrade these service applications by upgrading the service application databases, you should not use the Farm Configuration Wizard to configure these service applications when you set up your new farm.

The following service applications can be upgraded by performing a services database upgrade:

  • Business Data Connectivity service

    The Business Data Connectivity service uses a database to store information about external data. This database must be upgraded as part of a services database attach upgrade. This service application is also available in SharePoint Foundation 2013.

  • Managed Metadata service

    The Managed Metadata service uses a database to store metadata information. This database must be upgraded as part of a services database attach upgrade. You must attach and upgrade the database for this service and for the User Profile service before you can upgrade any My Sites.

  • PerformancePoint services

    PerformancePoint Services use a database to store information. This database must be upgraded as part of a services database attach upgrade.

  • Search

    In SharePoint Server 2010, the Search service application Administration database contains settings for the Search service application such as content sources, crawl rules, start addresses, server name mapping, and federated locations. You can upgrade a Search service application Administration database from SharePoint Server 2010 to SharePoint Server 2013 by using a database attach approach.

    You cannot use the database attach approach to upgrade any other search databases, such as crawl databases or property databases. (These databases are re-created when you perform a full crawl in the new farm.) Also, the upgrade process does not preserve or upgrade logical components of the SharePoint Server 2010 farm topology. After you perform the upgrade, you must manually re-create a topology as appropriate for the requirements of the organization.

  • Secure Store service

    The Secure Store Service uses a database to store information. This database must be upgraded as part of a services database attach upgrade. You have to upgrade the data for this service application so that any connections from Excel Services Application and Business Connectivity Services can work with existing passwords.

  • User Profile service

    The User Profile service uses databases to store profile, social, and sync information. These databases must be upgraded as part of a services database attach upgrade. You have to attach and upgrade the databases for this service and for the Managed Metadata service before you can upgrade any My Sites.

    Note:

    My Sites are not available in SharePoint Foundation 2010 or SharePoint Foundation 2013.

Specifically, the following service application databases can be upgraded:

Service application | Default database name
Business Data Connectivity | BDC_Service_DB_ID
Managed Metadata | Managed Metadata Service_ID
PerformancePoint | PerformancePoint Service Application_ID
Search Administration | Search_Service_Application_DB_ID
Secure Store | Secure_Store_Service_DB_ID
User Profile: Profile and Social databases | User Profile Service Application_ProfileDB_ID User Profile Service Application_SocialDB_ID User Profile Service Application_SyncDB_ID

The steps to upgrade these service application databases are included in Upgrade content databases to SharePoint 2013.

Considerations for specific services

The following services in SharePoint Server 2013 also require additional steps to enable and configure when you upgrade:

  • Excel Services

    You can enable this service by using the Farm Configuration Wizard, but you must make sure that you re-create all trusted data connections. For more information, see Manage Excel Services trusted data providers (SharePoint Server 2013).

  • InfoPath Forms Service

    This service is not part of the Farm Configuration Wizard. If you want to use this service, you can use the Configure InfoPath Forms Services link on the General Application Settings page in SharePoint Central Administration to configure it. If you want to continue using form templates from your previous environment, you can export any administrator-deployed form templates (.xsn files) and data connection files (.udcx files) from your SharePoint Server 2010 environment, and then import them to your new SharePoint Server 2013 environment by using the Export-SPInfoPathAdministrationFiles Windows PowerShell cmdlet. If the URL of the new server differs from the URL of the previous server, you can run the Update-SPInfoPathAdminFileUrl Windows PowerShell cmdlet to update links that are used in the upgraded form templates. For more information, see Configure InfoPath Forms Services (SharePoint Server 2010).

  • Office Web Apps

    If you installed Office Web Apps with SharePoint 2010 Products, Office Web Apps will not be available after you upgrade to SharePoint 2013 Products. You must deploy Office Web Apps Server and then connect SharePoint 2013 Products it to after the content databases are upgraded. You do not have to wait until the site collections are upgraded because Office Web Apps Server supports both the 2010 and 2013 site collection modes in SharePoint 2013 Products. For more information, see Office Web Apps.

See also

Overview of the upgrade process to SharePoint 2013
Upgrade content databases to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Upgrade farms that share services (parent and child farms) to SharePoint 2013
See also

Summary: Understand how to upgrade environments that include services farms to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Some services in SharePoint 2010 Products can be shared across multiple farms. A services farm hosts services such as Business Data Connectivity service, Search, and User Profiles that other farms consume. When you upgrade to SharePoint 2013, you first upgrade the services farm, and then upgrade the farms that consume those services. This article describes how to upgrade farms that share services.

Before you begin, make sure that you have reviewed the overall upgrade process described in Overview of the upgrade process to SharePoint 2013.

Note:

This article applies to both SharePoint Server 2013 and SharePoint Foundation 2013. However, only the Business Data Connectivity service is available in SharePoint Foundation 2013. The other services are available only in SharePoint Server 2013.

Process for upgrading farms that share services

To upgrade farms that share services, you follow these steps:

1. Starting status: services farm and content farm running SharePoint 2010 Products

In your SharePoint 2010 Products environment, you have one or more content farms that use services from a services farm. The services farm provides cross-farm services and Enterprise Search indexes the content on the content farm.

Pre-upgrade state: 2010 content and services farms

Pre-upgrade state: 2010 content and services farms

2. Create the SharePoint 2013 services farm

Create a new farm to host the service applications, and install and configure SharePoint 2013.

Create 2013 Services farm

Create 2013 Services farm

3. Upgrade the Search service application and optionally index the content in the SharePoint 2010 Products content farm

Upgrade the Search service application administration database and run a search crawl against the SharePoint 2010 Products content farm to create the index.

Upgrade the Search service application

Upgrade search data and index content farm

4. Upgrade the other service applications.

Upgrade the databases for the other service applications.

Upgrade other service applications

Upgrade other service applications

5. Switch the services connection to SharePoint 2013 services farm

Change the SharePoint 2010 Products content farm to consume services from the SharePoint 2013 services farm and retire the SharePoint 2010 Products services farm.

Switch connection to 2013 services farm

Switch connection; retire 2010 service farm

6. Create SharePoint 2013 content farm

Create a new farm to host content, and install and configure SharePoint 2013.

Create 2013 content farm

Create 2013 content farm

7. Upgrade and index the 2013 content farm

Upgrade the data in the SharePoint 2013 content farm. Configure it to consume services from the SharePoint 2013 services farm. Index the SharePoint 2013 content farm.

Upgrade and index the 2013 content farm

Upgrade and indext 2013 content farm

8. Retire the SharePoint 2010 Products content farm

Now that the SharePoint 2013 content farm uses services from a SharePoint 2013 services farm, you can retire the SharePoint 2010 Products content farm.

Retire 2010 content farm

Retire 2010 content farm

If more than one content farm uses services from the SharePoint 2010 Products services farm, repeat steps 5 through 7 for the remaining content farms until all farms are upgraded and are using services from SharePoint 2013. Except for the order of steps in this process, the process to create and upgrade each farm follows the database-attach upgrade steps outlined in Upgrade content databases to SharePoint 2013. This process does not explain how to upgrade site collections. For more information about how to upgrade sites, see Upgrade site collections to SharePoint 2013.

See also

Upgrade content databases to SharePoint 2013
Overview of the upgrade process to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Best practices for upgrading to SharePoint 2013
See also

Updated: April 9, 2013

Summary: Understand how to get the most out of testing upgrade and how to guarantee a smooth upgrade to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

To increase your chances of a successful and faster upgrade to SharePoint 2013, follow these best practices to test and complete an upgrade.

Best practices for testing upgrade

To understand your environment before you upgrade it, and to plan for the time that an upgrade will require, you should try one or more trial upgrades. The goal of testing upgrade is to find and fix issues and develop confidence in the outcome before the real upgrade. To develop an accurate trial of the upgrade process from SharePoint 2010 Products to SharePoint 2013, follow these best practices:

  1. Know what is in your environment. Do a full survey first.

    Document the hardware and software in your environment, where server-side customizations are installed and used, and the settings that you need. This helps you plan the trial environment and also helps you recover if upgrade fails. A worksheet is available to record information about your environment. Download the worksheet at SharePoint 2013 Products Preview Upgrade Worksheet.

  2. Make your test environment as similar as possible to your real environment.

    If possible, use the same kind of hardware and use the same settings, the same URLs, and so on to configure it. Minimize the differences between your test environment and your real environment. As you introduce more differences, you are likely to spend time resolving unrelated issues to make sure that they will not occur during the actual upgrade.

  3. Use real data.

    Use copies of your actual databases to run the tests. When you use real data, you can identify trouble areas and also determine upgrade performance. You can also measure how long different upgrade sequences and actions take on different kinds of data. If you cannot test all the data, test a representative subset of the data. Make sure that you find issues with the different kinds and sizes of sites, lists, libraries, and customizations that are present in your environment. If you cannot test all data because of storage concerns, try going over the data in several passes, removing the old trial copies before going on to the next batch.

  4. Run multiple tests.

    A single test can tell you whether you will encounter big problems. Multiple tests will help you find all the issues that you might face and help you estimate a more accurate timeline for the process. By running multiple tests, you can determine the following:

    • The upgrade approaches that will work best for your environment

    • The downtime mitigation techniques that you should plan to use

    • How the process or performance may change after you address the issues that you uncovered in your first tests

    Your final test pass can help you validate whether you have addressed the errors and are ready to upgrade your production environment.

  5. Do not ignore errors or warnings.

    Even though a warning is not an error, a warning could lead to problems in the upgrade process. Resolve errors, but also investigate warnings to make sure that you know the results that a warning might produce.

  6. Test the upgraded environment, not just the upgrade process.

    Check your service applications and run a search crawl and review the log files.

For more information about how to test upgrade, see Use a trial upgrade to SharePoint 2013 to find potential issues and the SharePoint 2013 Products Preview - Test Your Upgrade Process model.

Best practices for upgrading to SharePoint 2013

To guarantee a smooth upgrade from SharePoint 2010 Products to SharePoint 2013, follow these best practices:

  1. Ensure that the environment is fully functioning before you begin to upgrade.

    An upgrade does not solve problems that already exist in your environment. Therefore, make sure that the environment is fully functioning before you start to upgrade. For example, if you are not using web applications, unextend them before you upgrade. If you want to delete a web application in Internet Information Services (IIS), unextend the web application before you delete it. Otherwise, SharePoint 2013 will try to upgrade the web application even though it does not exist, and the upgrade will fail. If you find and solve problems beforehand, you are more likely to meet the estimated upgrade schedule.

  2. Perform a trial upgrade on a test farm first.

    Copy your databases to a test environment and perform a trial upgrade. Examine the results to determine the following:

    • Whether the service application data was upgraded as expected

    • The appearance of upgraded sites

    • The time to allow for post-upgrade troubleshooting

    • The time to allow for the upgrade process

    Try a full search indexing crawl. For more information, see Use a trial upgrade to SharePoint 2013 to find potential issues.

  3. Plan for capacity.

    Ensure that you have enough disk, processor, and memory capacity to handle upgrade requirements. For more information about system requirements, see System requirements for SharePoint 2013. For more information about how to plan the disk space that is required for upgrade, see Plan for performance during upgrade to SharePoint 2013 and Plan for performance and capacity management in SharePoint Server 2013

  4. Clean up before you upgrade

    Issues in your environment can affect the success of upgrade, and unnecessary or very large amounts of data can affect upgrade performance for both databases and site collections. If you don't need something in your environment, consider removing it before upgrade. If there are issues detected, try to resolve them before you start to upgrade. For more information, see Clean up an environment before an upgrade to SharePoint 2013.

  5. Back up your databases.

    Perform a full backup of your databases before you upgrade. That way, you can try upgrade again if it fails.

  6. Optimize your environment before upgrade.

    Be sure to optimize your SharePoint 2010 Products environment to meet any limits or restrictions, either from your business or governance needs or from the SharePoint 2013 boundaries and limits before upgrade. This will help reduce errors during the upgrade process and prevent broken lists or sites after upgrade. For more information about limits in the product, see Software boundaries and limits for SharePoint 2013. For more information about large lists and how to address the lower limit on site collections, see Clean up an environment before an upgrade to SharePoint 2013.

  7. (Optional) Set the original databases to read-only if you want to keep your original environment available while you upgrade.

    If you expect a long outage period while you upgrade, you can set the databases in the original environment to read-only. Users can continue to access the data but cannot change it. For more information, see Upgrade content databases to SharePoint 2013.

  8. After upgrade, review the Upgrade Status page and upgrade logs to determine whether you must address issues. Then review the upgraded sites.

    The Upgrade Status page reports on the upgrade progress, and the upgrade logs list any errors or warnings that occurred during the upgrade process. Verify all the sites and test them before you consider the upgrade finished. For more information, see Verify database upgrades in SharePoint 2013 and Review site collections upgraded to SharePoint 2013.

  9. Defer upgrade for site collections until you can get updated customizations to support 2013 mode.

    If you wait until the customizations are available, you can complete the initial upgrade of database and services without significantly affecting use of the existing sites in 2010 mode.

  10. Make sure that the appropriate service pack or update is applied to your 2010 environment. If you are using remote blog storage (RBS) in your environment, you must be running Service Pack 1 for SharePoint 2010 Products in your environment before you start the upgrade process.

See also

Upgrade to SharePoint 2013
Get started with upgrades to SharePoint 2013
Plan for upgrade to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center

Change History

Date | Description
April 09, 2013 | Added a note to make sure that the appropriate patch levels are applied to the SharePoint 2010 farm before you perform an upgrade to SharePoint 2013.
July 16, 2012 | Initial publication


Review supported editions and products for upgrading to SharePoint 2013

Summary: Understand the editions or versions of SharePoint 2010 Products that you can upgrade to specific editions or versions of SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

When you plan an upgrade process, make sure that you verify that the intended upgrade path is supported. This article describes the editions and products that are supported and unsupported to upgrade to SharePoint 2013.

Important:

Upgrade from a pre-release version of SharePoint 2013 to the release version of SharePoint 2013 is not supported.

Pre-release versions are intended for testing only and should not be used in production environments. Upgrading from one pre-release version to another is also not supported.

Supported topologies

For SharePoint 2013, the only upgrade method is the database-attach upgrade method. Because this method upgrades the databases instead of installing in place over an existing environment, you can attach the databases from a stand-alone installation to server farm (Complete) installation if you want to expand your environment.

Figure: Upgrade to either stand-alone or server farm (Complete) topologies

Upgrade to either stand-alone or farm

Before you create your new SharePoint 2013 environment and attach and upgrade the databases, determine the type and size of the environment that you need.

Physical topology guidance

The SQL Server topology — in addition to network, physical storage, and caching considerations — can significantly affect system performance. To learn more about how to map your solution design to the farm size and hardware that will support your business goals, see Plan for performance and capacity management in SharePoint Server 2013. For more information about requirements, see System requirements for SharePoint 2013.

Supported editions for upgrade

The following table lists the editions available for SharePoint Server 2010 and the supported and unsupported ending editions when you upgrade to SharePoint Server 2013.

Starting edition | Supported ending edition | Unsupported ending edition
SharePoint Server 2010, Standard edition | SharePoint Server 2013, Standard edition | SharePoint Server 2013, Enterprise edition You can convert to Enterprise edition after upgrade.
SharePoint Server 2010, Enterprise Edition | SharePoint Server 2013, Enterprise edition | SharePoint Server 2013, Standard edition.
SharePoint Server 2010, Trial edition | SharePoint Server 2013, Trial edition | SharePoint Server 2013, full product You can convert to the full product after upgrade.

Supported cross-product upgrades

The following table lists which Microsoft server products can be upgraded to SharePoint Foundation 2013 or SharePoint Server 2013.

Starting product | Supported ending products | Unsupported ending product
SharePoint Foundation 2010 | SharePoint Foundation 2013 SharePoint Server 2013 |
SharePoint Foundation 2013 | SharePoint Server 2013 |
SharePoint Server 2010 | SharePoint Server 2013 | SharePoint Foundation 2013
SharePoint Server 2013 | SharePoint Server 2013 | SharePoint Foundation 2013
Search Server 2010 | SharePoint Server 2013 | SharePoint Foundation 2013
Project Server 2010 with SharePoint Server 2010, Enterprise Edition | Project Server 2013 with SharePoint Server 2013, Enterprise Edition |


Plan for upgrade to SharePoint 2013
See also

Summary: Find resources about how to plan to upgrade from SharePoint 2010 Products to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

In order to have a successful upgrade to SharePoint 2013, you must plan for the upgrade. This section contains articles that help you plan and prepare for upgrading from SharePoint 2010 Products to SharePoint 2013.

To understand how the upgrade process works, see the articles in Get started with upgrades to SharePoint 2013.

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about how to plan for upgrade.

TechNet articles about how to plan for upgrade

The following articles about how to plan for upgrade are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Determine strategy for upgrade to SharePoint 2013 | Understand how to minimize downtime and plan for special cases during an upgrade to SharePoint 2013.
Create a plan for current customizations during upgrade to SharePoint 2013 | Learn how to identify and evaluate the customizations in your environment, and determine whether you will upgrade them, and how.
Plan for site collection upgrades in SharePoint 2013 | Plan to upgrade site collections to SharePoint 2013. Plan for upgrade evaluation sites, notifications, and throttling.
Plan for performance during upgrade to SharePoint 2013 | Understand upgrade performance and how to plan for the space and time that is required to upgrade to SharePoint 2013.
Create a communication plan for the upgrade to SharePoint 2013 | Create a plan to coordinate and communicate with the upgrade team, site owners and users, and stakeholders.
Clean up an environment before an upgrade to SharePoint 2013 | Make sure that your environment is in a healthy state, and delete unnecessary items before you upgrade to SharePoint 2013.

Additional resources about how to plan for upgrade to SharePoint 2013

The following resources about how to plan for upgrade to SharePoint 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | Upgrade and Migration in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.

See also

Get started with upgrades to SharePoint 2013
Upgrade to SharePoint 2013
Upgrade databases from SharePoint 2010 to SharePoint 2013
Upgrade site collections to SharePoint 2013


Determine strategy for upgrade to SharePoint 2013
See also

Summary: Understand how to minimize downtime and plan for special cases during an upgrade to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

When you upgrade your environment to SharePoint 2013, you want to limit how much downtime that users experience. You might also have a special case that you must address during upgrade. This article describes how to minimize downtime and work with these special cases.

In addition to the information in this article, make sure that you read Review supported editions and products for upgrading to SharePoint 2013 to understand exactly which upgrade situations are valid and lead to successful upgrades.

How to minimize downtime during upgrade

The following table lists the techniques that you can use during upgrade to reduce the time that users cannot access their content or to potentially increase upgrade performance.

  • Read-only databases You can use read-only databases to continue to provide read-only access to content during the upgrade process. For this approach, you set the databases to read-only on the original farm while the upgrade is in progress on another farm. This method reduces perceived downtime for users. Also, if you encounter a problem with upgrade, you can restore the read-only farm to read-write and restore access to users while you rework your plans before you try upgrade again.

  • Parallel database upgrades You can attach and upgrade multiple databases at a time to speed up the upgrade process overall. The maximum number of parallel upgrades depends on your hardware. This results in faster overall upgrade times for your environment. However, you must monitor the progress and your servers to make sure that the performance is acceptable, and for large databases, parallel upgrades can be slower than single upgrades.

    For more information about upgrade performance, see Plan for performance during upgrade to SharePoint 2013 and Use a trial upgrade to SharePoint 2013 to find potential issues.

The instructions for using these techniques are included in Upgrade content databases to SharePoint 2013.

Special cases

You might have other requirements or additional goals that you want to achieve when you perform an upgrade. The following table lists special cases and describes how to approach upgrade for each case.

Case Upgrade approach

Upgrading an environment that uses forms-based authentication?

Additional steps are required to upgrade when you are using forms-based authentication. For more information, see Configure forms-based authentication for a claims-based web application in SharePoint 2013.

Upgrading very large databases?

In general, very large databases — especially databases that have a large number or large size of document versions inside them — take longer to upgrade than smaller databases. However, the complexity of the data determines how long it takes to upgrade, not the size of the database itself. If the upgrade process times out, it is usually because of connection issues. For more information about how long upgrade might take for your environment, see Plan for performance during upgrade to SharePoint 2013.

Upgrading from the server products in the Office 2007 release?

Use a database attach upgrade method to upgrade to SharePoint 2010 Products, and then upgrade to SharePoint 2013.

Upgrading from SharePoint Foundation 2010 to SharePoint Server 2013?

Attach and upgrade the content databases from SharePoint Foundation 2010 to SharePoint Server 2013.

Changing languages?

You have two choices, depending on whether a single site or your whole environment is changing languages:

  • To change the multiple user interface (MUI) language for a specific site, upgrade in the same language, and then install the new language pack and change to that language.

    Caution:

    You must have the appropriate language packs installed to upgrade any sites based on a localized site definition. If you do not have the new language pack, the sites will not be available. Wait for the new language packs to be released before you try to upgrade those sites.

  • To change the installation language for your environment, set up your new environment in the new language, and then attach and upgrade your databases in the new language.

See also

Plan for performance during upgrade to SharePoint 2013
Review supported editions and products for upgrading to SharePoint 2013
Use a trial upgrade to SharePoint 2013 to find potential issues
Overview of the upgrade process to SharePoint 2013


Create a plan for current customizations during upgrade to SharePoint 2013
See also

Updated: May 21, 2013

Summary: Identify all customizations in your environment and determine what to change or remove as you upgrade to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

If you have extensively customized your sites based on SharePoint 2010 Products, you must determine how you want to handle your customizations when you upgrade to SharePoint 2013. Your approach will vary based on the extent of the customizations, the kind of customization, the complexity of your site, and your goals for upgrading. Before you upgrade, you must identify and then evaluate the customizations in your environment and determine whether you will upgrade them, and how.

Identify customizations in your environment

As part of an upgrade testing process, you should create an inventory of the server-side customizations in your environment (solutions, features, Web Parts, event handlers, master pages, page layouts, CSS files, and so on). For more information about how to identify customizations, see Use a trial upgrade to SharePoint 2013 to find potential issues.

You can use the Upgrade Planning worksheet to list specific customizations and then record the results of your evaluation in the next section.

Evaluate the customizations

After you have identified the customizations, think about the potential upgrade effect of each one. The following table describes types of customizations and the kind of effect they can have during upgrade.

Category of customization | Types of customizations | Potential effect on upgrade
Visually-affecting | Master pages Themes Web Pages Web Parts Custom JavaScript Custom CSS files | Should not affect database upgrade. For site upgrades: likely to work well in 2010 mode, but need changes to work in 2013 mode. Test carefully in both modes.
Data structure affecting | Content types List types Web templates Site definitions | Can affect database upgrade if content or list type names conflict with new content or list types in the product, or if templates or definitions are missing.
Non-visually affecting | Web services Windows services HTTP handler HTTP module | Might not be compatible with SharePoint 2013. Test carefully to determine effect. Be prepared to remove or replace.

Now that you know what customizations that you have, and what type that they are, you can decide what to do about them. The following questions can help you evaluate the customizations:

  • Is the customization still valuable?

    • Does it serve a useful business need?

    • Is it widely deployed and used?

    • Does it do something that you cannot do with standard features in the product?

  • Is the customization well-designed?

    • Is it built on supported, predefined site definitions?

    • Does it follow best practices for customizations?

    • Is it a supported kind of customization, or does it introduce risk into your environment?

As you evaluate every customization, you can also think about your overall approach for customizations. You can choose from among these options:

  • Keep the customizations, don't upgrade the sites You can continue to run the site in 2010 mode in the upgraded environment. Although you can use this approach to keep the same functionality, you will be unable to take advantage of the features and capabilities that are available in the new version. Use this approach only temporarily - eventually you must address the issue (such as before an upgrade to the next version of the product).

  • Replace or redo the customizations If you want to use new functionality, plan to redesign your sites, or are significantly changing the information architecture, the upgrade is your opportunity to start over with new features, a new look, or a new organization. When you replace or redo customizations, you can take advantage of the new capabilities, change your design slightly if you want, or move to a more manageable design.

  • Discard the customizations Replace the customizations by using default functionality. You can reset pages to the default site definitions and remove any Web Parts or features that you no longer want to support. In fact, the site collection health-checker checks for unghosted pages and can reset the pages to the default versions. If you decide to discard any customizations, you must fix any issues that result from removing the customizations in the sites that used them. You can use your customizations inventory to determine which sites require this kind of attention before or after upgrade.

Considerations for specific customizations

In addition to your overall decision about how to treat customizations in your environment during upgrade, you must examine specific types of customizations to determine whether you must perform any additional actions to make them work in the upgraded environment.

The following table lists some common customizations and a recommendation for addressing that kind of customization.

Customization type Recommendation

Site definition

Migrate sites to a supported, predefined site definition, then apply custom features by using solution deployment.

You can also continue to use a custom site definition. You do not have to create a new site definition that is based on SharePoint 2013.

However, if you must perform custom upgrade actions for the definition, you might have to create an upgrade definition file for that site definition. For more information, see Upgrade Definition Files on MSDN.

Custom site templates

If you have custom site templates (a site template that has been customized and saved as a WSP template) that you want to continue to use after you upgrade to SharePoint 2013, you must plan to recreate them in 2013 mode before you upgrade your site collection. You have to create them again because custom site templates apply to specific versions and don't always look or work the same way in subsequent versions. Furthermore, if you used a template to make various 2010 sites, they could all require manual adjustments to ensure that they work and render properly in SharePoint 2013.

"Fabulous 40" application templates

Microsoft is not creating new versions of these templates. Environments that contain sites based on these templates can be upgraded as long as the templates are installed. But there might be issues when you try to upgrade the site collections. Make sure that you test each site before you upgrade the production environment. For more information, see Troubleshoot database upgrade issues in SharePoint 2013.

Feature

Evaluate, then redesign or redeploy if it is necessary.

Workflows and server controls

Depends on the solution. Contact the vendor to discover whether there is an updated solution. If a workflow is compatible with the new version, redeploy.

Event handler

Most event handlers will continue to work without changes. However, if the code for the event handler makes calls to APIs which were deprecated, you will have to rewrite it, and then redeploy it as a feature.

Managed paths (inclusions/exclusions)

Re-create inclusions to make sure that you can access all site collections under those paths.

Exclusions were not used in SharePoint 2010 Products. If you had any remaining from an earlier version, they do not have to be re-created.

Themes

Re-create your themes following the SharePoint 2013 theming guidance, or select a new theme available in SharePoint 2013.

For more information, see Branding issues that may occur when upgrading to SharePoint 2013.

Master pages and CSS files

Rework to accommodate the new user experience. For more information, see Branding issues that may occur when upgrading to SharePoint 2013.

JavaScript

Test to determine whether any actions are required. In some cases, you might have to adjust the scripts to work with the new page model. Verify that it works in both 2010 and 2013 modes.

Search provider or security trimmer

Test to determine whether any actions are required.

Web Parts

Test to determine whether any actions are required. You might have to adjust the Web Parts to work with strict XHMTL mode.

Test to verify that there have not been changes to any object models or Web services that you call from the Web Part.

If a Web Part is located on a page but not in a Web Part Zone (so that it is, basically, HTML code embedded directly in a page), it will not work if you reset the page to the default template. There is a site collection health rule that will identify files in this status inside a site collection. There is a link from that rule to the page where they can reset to template.

Services

Test to determine whether any actions are required. Redesign or adjust code, as needed.

Authentication providers

Test to determine whether any actions are required. Redeploy the provider with the same provider name (exactly. This includes the letter case) on a test farm and make sure that it works correctly.

Custom search solutions that use SQL syntax

Rework to use FQL syntax and KQL syntax.

Custom search solutions in SharePoint Server 2013 do not support SQL syntax. Search in SharePoint Server 2013 supports FQL syntax and KQL syntax for custom search solutions. You cannot use SQL syntax in custom search solutions using any technologies. This includes the query server object model, the client object model, and the Search REST service. Custom search solutions that use SQL syntax with the index server object model and the Query web service that were created in SharePoint Server 2010 will not work when you upgrade them to SharePoint Server 2013. Queries submitted via these applications will return an error. For more information about how to use FQL syntax and KQL syntax, see Keyword Query Language (KQL) syntax reference and FAST Query Language (FQL) syntax reference.

While you are reviewing customizations in your environment, you should also make sure that the environment is not using any features or elements that are deprecated. For example, Web Analytics from SharePoint 2010 Products are not available in SharePoint 2013 and you should turn them off before upgrading. Also, SQL Server Search queries are not available in SharePoint 2013. For more information, see Changes from SharePoint 2010 to SharePoint 2013.

Some methods of deploying customizations might require additional steps in SharePoint 2013. The following table lists issues that you might encounter for specific methods of deploying customizations.

Deployment method Recommendation

Customizations deployed as MSI files

Contact the vendor for updated files. Most likely, you will have to get a replacement file compatible with SharePoint 2013.

Manually deployed features, files, or changes

You can re-deploy them to the equivalent directory in SharePoint 2013. However, consider packaging them into a deployable solution package for easier administration.

Sandboxed solutions

No special steps. Sandboxed solutions are upgraded with the content databases.

Solution packages

Deploy to SharePoint 2013 again. Make sure that you deploy it to the appropriate directory (/14 or /15), depending on the version.

Note that you can no longer add partial trust solution packages to the \bin directory. Any files deployed to the \bin directory must be full trust. Be sure to test any such solutions to make sure that deploying them in full trust does not introduce security vulnerabilities. Also, update any deployment scripts to make sure that they specify the correct trust level.

For more information, see Install-SPSolution.

Administrator-deployed form templates

You must extract them from SharePoint Server 2010 and redeploy them to SharePoint Server 2013. For more information, see Services upgrade overview for SharePoint Server 2013.

The following kinds of customizations are not supported. If you have any of these customizations in your environment, you must replace them by using a supported kind of customization before you can upgrade. Otherwise, you might experience upgrade issues that cannot be fixed:

  • Predefined files, features, or site definitions that were changed.

    Warning:

    Some predefined file types — such as document icons or actions — can be carried forward in a supportable way, although this does not occur automatically. Do not copy over the old version files as that can cause other issues, instead, make the same changes to the new version file Modifications to other predefined files, such as server-side ASPX pages, will be lost during upgrade if you reset to the site template or if you don't make the same changes in the new version files. Depending on the files that were changed and the extent of these changes, the upgrade experience can vary significantly.

  • SharePoint databases that were changed, either by directly changing data or changing the schema. This includes adding or removing triggers, tables, views, or indexes.

If you have any of these kinds of customizations, remove them and replace them with supported customizations before you attempt to upgrade. This is a best practice for helping to make sure that not only your current upgrade will work, but any future upgrades will go more smoothly. Changing predefined files and databases will remain unsupported.

Ensure that future customizations follow best practices

Ensure that your environment performs well and follows best practices. Deploy only those customizations that follow the best practices as described on the following page on MSDN: Developer Best Practices Resource Center.

See also

Best practices for upgrading to SharePoint 2013
Use a trial upgrade to SharePoint 2013 to find potential issues

Upgrade and Migration in SharePoint 2013 Resource Center

Change History

Date | Description
May 21, 2013 | Added information about site templates.
July 16, 2012 | Initial publication


Plan for site collection upgrades in SharePoint 2013
See also

Summary: Explains how plan to upgrade site collections to SharePoint 2013 and how to plan for upgrade evaluation sites, notifications, and throttling in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

When you upgrade from SharePoint 2010 Products to SharePoint 2013, site collections are not upgraded when you upgrade the content databases to a new version. The upgrade process is split to allow site collection administrators to decide when to upgrade their site collections. For a visual overview of the upgrade process, see Overview of the upgrade process to SharePoint 2013.

Server farm administrators can control settings for upgrading site collections, such as settings for upgrade evaluation site collections, notifications, and upgrade throttling. This article helps you plan the settings to use to controlling the upgrade of a site collection.

Determine the site collections that farm administrators should upgrade

By default, site collection administrators are in charge of when they upgrade their site collections, and they perform the upgrade themselves. However, under certain circumstances a farm administrator should probably perform the upgrade. For example, for sites that meet the following characteristics, the upgrade team at the farm level should perform tests before upgrade, and potentially upgrade the site collection:

  • Extremely important sites

    If a site is very important to your business, farm administrators should carefully test it before they upgrade it, and then upgrade it themselves to make sure that the site collection is available for users as quickly as possible.

  • Very large sites

    By default, if a site collection administrator starts to upgrade a site that is larger than 10 MB or with more than 10 subsites, the site is added to the upgrade queue, instead of being upgraded immediately. For very large site collections (larger than 10 GB), we recommend that you have a farm administrator upgrade the site collections instead of allowing the site collection administrators to start the upgrade. This way, the farm administrators can test these sites and then monitor the progress of the upgrade.

  • Highly-customized sites

    Carefully test sites that are based on custom site definitions or that have many other customizations before you upgrade them. If there are issues with server-side customizations, then farm administrators should address them, test again, and then perform the upgrade so that they can troubleshoot any issues that occur. If there are issues with the design of a site, a designer and site collection administrator can address them.

Farm administrators can upgrade sites by using Windows PowerShell. For more information, see Upgrade a site collection to SharePoint 2013.

Plan settings for upgrade notifications, self-service upgrade, and site collection creation

When a site collection is available to upgrade, a status bar on a site indicates that site collection administrators can upgrade it. They can choose to upgrade the site collection then, or be reminded later.

Farm administrators can determine whether to allow site collection administrators to upgrade their sites at all. You can set a property to prevent the site collection administrators from starting to upgrade, which also turns off the notification in the status bar. Then you can perform the upgrades yourself by using Windows PowerShell. If you choose to upgrade some sites centrally, you should have a plan to decide when each site will be upgraded and who will verify the site after upgrade.

Although administrators can upgrade all site collections immediately, we do not recommend this, for the following reasons:

  • You would risk that some sites would have unforeseen issues that you'd have to address. This could create or prolong an outage.

  • A high volume of issues could arrive at your helpdesk or troubleshooting process when users start to work with upgraded sites at the same time.

You can control settings for site collection upgrade and site creation. You can determine the following:

  • Whether the site collection administrator can upgrade the site collection.

  • Which mode (2010 or 2013, or both) can be used when a user creates a site collection.

    For example, you might want users to keep creating 2010 mode sites for a while, until most of site collections are upgraded, or you might want to force new sites to be created in 2013 mode so that you don't have to upgrade them later.

Properties that control site collection upgrade and site creation

Property Description

SPSite.AllowSelfServiceUpgrade

Determines whether an upgrade notification can be set for a site collection.

Default is true - notifications are set automatically.

If set to false, the upgrade notification will not appear on the status bar.

SPWebApplication.CompatibilityRange

Determines in which modes a site collection can be created. For example, 2010 mode (14) or 2013 mode (15). The following ranges are available:

  • OldVersions Use this range to enable users to create only 2010 mode sites.

  • NewVersion Use this range to enable users to create only 2013 mode sites.

  • AllVersions Use this range to enable users to create either 2010 or 2013 mode sites.

You can use these ranges or set your range by using the New-Object command to set the Microsoft.Shareoint.SPCompatibilityRange property.

For more information about how to set these properties, see Manage site collection upgrades to SharePoint 2013.

You can also control settings upgrade notifications. You can determine the following:

  • Whether to add a link to more information from the Upgrading now status bar.

  • How many days to wait before reminding a site collection administrator about upgrade if they choose Remind me later on the status bar.

    If a user clicks Remind me later, the current date is added to the number that is set for the UpgradeReminderDelay and the notification is hidden until that new date occurs. For example, if the setting is 30, then the notification will appear 30 days from the current date.

The following properties control site collection upgrade notifications:

Properties that control upgrade notifications

Property Description

SPWebApplication.UpgradeMaintenanceLink

Adds another link to the upgrading now status message so that users can follow it, and find more information.

Default is empty.

SPWebApplication.UpgradeReminderDelay

Sets the number of days to suspend the upgrade notification in the status bar after a user clicks Remind me later.

Default is 30 days.

If set to 0, then the upgrade notification is not removed from the status bar and the notification cannot be set to Remind me later.

For more information about how to set these properties, see Manage site collection upgrades to SharePoint 2013.

Plan for upgrade evaluation sites

Site collection administrators can request a preview of their site collection. This preview site is called an upgrade evaluation site collection. An upgrade evaluation site collection enables site collection administrators to see their site's content in a new, separate copy of the site that is running on the SharePoint 2013. Unlike visual upgrade in SharePoint Server 2010, the upgrade evaluation site collection is a complete copy of the site collection. It is separate from the original and has its own URL. Actions that the site collection administrators perform in the upgrade evaluation site collection do not affect the original site. Both the original site and the upgrade evaluation site are available for search, and timer jobs that run for all site collections also run on the upgrade evaluation sites.

When a site collection administrator requests an evaluation site collection, the request is added to a timer job (known as "Create Upgrade Evaluation Site Collections") which runs one time per day. This timer job creates a full copy of the site collection at a unique URL. Upgrade evaluation site collections are set to expire automatically and be deleted. The default time for expiration is 30 days, which can be configured by setting a value for the web application or by changing a value on the evaluation site collection itself.

Farm administrators can choose to prevent users from creating upgrade evaluation sites by setting the SPSite.AllowSelfServiceUpgradeEvaluation property for a site collection.

Timer jobs create and delete upgrade evaluation sites. The following timer jobs are used:

Timer jobs for upgrade evaluation site collections

Job name | Description | When run
Create Upgrade Evaluation Site Collections (job-create-upgrade-eval-sites) | Creates upgrade evaluation sites. | Runs daily, between 1:00 and 1:30 AM
Delete Upgrade Evaluation Site (job-delete-upgrade-eval-sites) | Deletes expired upgrade evaluation sites and sends notifications for sites near their expiration date. | Runs daily, between 1:00 and 1:30 AM
Upgrade site collections (job-upgrade-sites) | Upgrades site collections in the queue for a content database. | Runs every 1 minute

You can decide when and how often these timer jobs run, and you can also run them manually.

How the upgrade evaluation site collections are created

The Create Upgrade Evaluation Site Collections job timer collects the list of site collections that were queued for evaluation sites, and then copies the sites to new URLs and Site IDs. It also adds the sites to the upgrade queue so that they will be picked up by the Upgrade Site Collections timer job later. To create the copy of the site:

  1. If you have an Enterprise version of SQL Server, the Create Upgrade Evaluation Site Collections job timer takes a snapshot of the database and reads the data from the snapshot to a destination database (with the source database being the default target). This doesn't affect the read-only status of the source site throughout the whole process.

  2. For other versions of SQL Server that do not have snapshot capabilities, the Create Upgrade Evaluation Site Collections job timer backs up a site collection and restores it to a new URL. This makes the source site read-only for the whole duration of the process.

The Upgrade Site Collections job collects the list of site collections that were queued for upgrade and then upgrades the queued sites from oldest to newest. The recently added evaluation site is then upgraded (or at least upgrade is tried).

Plan site collection upgrade throttling and queues

To make sure that site collection upgrades do not cause an outage on your farm, there are throttles built in at the web application, database, and content level. This means that even if 100 site collection administrators decide to upgrade their site collections at the same time, only some are run at the same time, and the rest are put into a queue to run later.

Site collection upgrades are throttled:

Throttle levels for site collection upgrade

Level | Maximum number of site collections that can be upgraded at a time | Property that controls the throttle setting
Web application | Default is 5 per web application instance. Additional requests are queued. | SPWebApplication.SiteUpgradeThrottleSettings AppPoolConcurrentUpgradeSessionLimit
Content database | Default is 10 per content database. Additional requests are queued. | SPContentDatabase.ConcurrentSiteUpgradeSessionLimit
Content of a site collection (size and number of subwebs) | Default is that a site that is more than 10 MB, or has more than 10 subwebs, cannot be upgraded in a self-service manner by the site collection administrator, but must be upgraded by the farm administrator. | SPWebApplication.SiteUpgradeThrottleSettings UsageStorageLimit and SubwebCountLimit

The following illustration shows the relationship between the web application and content database upgrade throttle limits.

Upgrade throttles and the site upgrade queue for web applications and content databases

Web application and content database upgrade limit

In this illustration, the content database contains fifteen sites, and all sites were requested to start upgrade.

  1. Because of the web application throttle limit, only five sites can start to upgrade for web application 1 - instance 1 on Web server 1.

  2. An additional five sites start to upgrade on web application 1 - instance 2 on Web server 2.

  3. Because of the content database throttle, five sites are sent to the upgrade queue to wait their turn.

You can use the default throttling settings, or you can specify your own values for how many site collections can be upgraded at the same time. Farm administrators can also override throttle settings when they upgrade a site by using Windows PowerShell. Exercise caution when you change these values and make sure that you verify the settings that you want to use in a test environment before you implement them in production. If you increase throttling too much, you could create performance problems in your environment. For example, too many parallel upgrades could affect site rendering. For information about how to change these settings, see Manage site collection upgrades to SharePoint 2013.

About site collection modes

In order to make it possible to upgrade site collections separately from upgrading content databases, SharePoint 2013 introduces the concept of site collection "modes" (also known as compatibility levels). Site collections are in 2010 mode in the new environment until they are specifically upgraded to 2013 mode. You can create new site collections in either mode. Although farm administrators can configure this setting, the default setting is to create sites in 2010 mode). When a site collection is in 2010 mode, the user interface resembles the SharePoint 2010 Products interface, and only features that were available in SharePoint 2010 Products are enabled. In 2013 mode, the interface and features are updated to SharePoint 2013.

You have to make sure that the solution packages, features, and other custom components are available for both site modes. For more information, see Create a plan for current customizations during upgrade to SharePoint 2013.

Train site collection administrators

It is important to train users about how to upgrade their site collections and how to review their sites in an upgrade evaluation site collection. Educated users are prepared and know what to expect, which will minimize helpdesk support and frustrations.

Inform users about changes and new features. Also, let them know about possible issues that they can expect. For instance, they might have issues with customizations, such as pages that do not display correctly. For information about general upgrade issues, see Review site collections upgraded to SharePoint 2013 and Troubleshoot site collection upgrade issues in SharePoint 2013.

Explain to site collection administrators that their upgrade evaluation sites are copies, and any changes they make there will not persist in their upgraded sites. There is also a notification bar in the preview site that indicates that it is a copy.

By default, site collection administrators control upgrade for their sites. They can use upgrade evaluation site collections to preview the new user interface and features. This gives them time to make sure that everything works correctly, and they can address any issues in their original site before upgrading it. When site collection administrators are ready, they can upgrade their sites.

We recommend that you have a plan and set a time limit for how long to allow site collection administrators to postpone upgrade of their sites. For example, each site collection administrator may be given 90 days to work with his or her site collection administrators to evaluate and then upgrade their sites. This time limit makes sure that users are given a reasonable time to become familiar with the new user interface and to resolve any issues in their sites. Ensure that you communicate the time limit to the users, and that they know that you can force through an upgrade of all sites. Also, you can use a Windows PowerShell command to check the compatibility level for sites in a content database so that you can see how many sites are in 2010 mode and how many are in 2013 mode. For more information, see Manage site collection upgrades to SharePoint 2013.

It is important to tell site collection administrators that as long as sites use the 2010 mode, new features will not be available. However, as soon as sites are upgraded to the new version, application features automatically appear.

See also

Manage site collection upgrades to SharePoint 2013
Overview of the upgrade process to SharePoint 2013
Upgrade site collections to SharePoint 2013
Run site collection health checks in SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Plan for performance during upgrade to SharePoint 2013
See also

Summary: Understand upgrade performance and how to plan for the space and time that is required to upgrade to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

An important part of planning an upgrade from SharePoint 2010 Products to SharePoint 2013 is determining how long the upgrade process will take and how much storage space will be required. Every environment is unique and includes different hardware capabilities and different database and site characteristics. The space and the length of time required to run an upgrade will vary greatly depending on your environment. The best way to estimate these factors is to perform one or more trial upgrades, and then review the space and time that it took. For more information about how to perform a trial upgrade, see Use a trial upgrade to SharePoint 2013 to find potential issues.

About upgrade performance for SharePoint 2013

One of the main reasons that database upgrade and site collection upgrade are now separate actions for SharePoint 2013 is to give you more control over upgrade performance.

  • How upgrade works for SharePoint 2010 Products

    During an upgrade to SharePoint 2010 Products, when the database was upgraded, all of the site collections in that database were also upgraded. That meant that for certain steps, such as activating features or updating the Quick Launch control, the upgrade process needed to perform the step repeatedly for each site collection in a database before the database upgrade was completed.

    Upgrade process for SharePoint 2010 Products

    Upgrade process for SharePoint 2010 Products

  • How upgrade works for SharePoint 2013

    When you upgrade to SharePoint 2013, the database upgrade no longer starts these site-specific steps. Therefore, the database upgrade stage is much faster. Some tests have found that a database can be upgraded to SharePoint 2013 in two-thirds of the time that it took to upgrade the same data to SharePoint 2010 Products. These site-specific steps must still be performed. However, they are performed only when the site collection is upgraded, and then only for that site. Because each site collection is upgraded independently, you can manage the performance effect of those upgrades on your environment.

    Upgrade process for SharePoint 2013 Products

    Upgrade process for SharePoint 2013 Products

For SharePoint 2013, you can control the performance effect of site collection upgrades by controlling how many sites can be upgraded at a time. There is a site collection upgrade queue that maintains a list of site collections currently requested to be upgraded. And there are throttles on the content database and web application levels to control how many site collection upgrades can occur at a time. For more information about these controls, see Plan for site collection upgrades in SharePoint 2013 and Manage site collection upgrades to SharePoint 2013.

In addition to planning for performance during upgrade, you must also plan for the performance of your production environment after upgrade. Test your planned environment to make sure that you can support your environment by using the hardware that you have planned.

Estimate the space that you must have for the upgrade

As the databases are upgraded, they expand temporarily. Also, many transactions occur while the upgrade process runs. Therefore, you must make sure that the log files have room to expand to accommodate the changes that are occurring. Therefore, you have to plan for growth in both the databases and the log files.

Database growth

Because of the changes in table structures in the new version, the databases grow temporarily while the data is reorganized. This space can be recovered after upgrade, but you should make sure that there is room for the databases to grow up to 50 percent larger than their current sizes during upgrade (be aware that after upgrade, you can reduce the database again to recover much of this space).

You should also make sure that there is room on your database servers for your databases to grow over time with typical use. To check how large your databases currently are, use Enterprise Manager in SQL Server.

Transaction log growth

In addition to database space, you must also have room for the transaction log files for the databases. These log files must grow quickly to accommodate the number of changes occurring in the databases

In very large environments, there is a possibility that the default growth rate for the transaction log files (10 percent) is not enough to keep up with the upgrade process. This can cause a time-out. Again, a trial upgrade is the best way to determine whether the transaction log files can keep up with the upgrade process. If your environment is very large, or if the process timed out during a trial upgrade, consider expanding the SQL Server transaction log files beforehand to make sure that you have room for the number of transactions that must be processed. For more information about how to expand the SQL Server transaction logs, see Expanding a Database (SQL Server 2008 R2).

Estimate how long the upgrade will take

With your disk space estimates in hand, and some testing done, you can now calculate a rough estimate of how long the actual upgrade process will take. Upgrade times vary widely among environments. The performance for an upgrade depends greatly on the hardware being used, the complexity of the sites, and the particular characteristics of your implementation. For example, if you have many large document libraries, these may take longer to upgrade than a simpler site.

Factors that influence performance for upgrade are described in the following list.

  • Environment factors The following factors can affect the performance for both database and site collection upgrade:

    • Simultaneous upgrades

    • SQL Server disk input/output per second

    • SQL Server database to disk layout

    • SQL Server temporary database optimizations

    • SQL Server CPU and memory characteristics

    • Web server CPU and memory characteristics

    • Network bandwidth and latency

  • Database factors The following factors can affect the performance of database upgrade. The number of:

    • Site collections

    • Subwebs

    • Lists

    • Rowspan within lists

    • Document versions (number and size)

    • Documents

    • Links

    Plus the overall database size itself.

  • Site collection factors The following factors can affect the performance of site collection upgrade. The number of:

    • Subwebs

    • Lists

    • Activated upgrading features

    • Document versions (number and size)

    • Documents

    • Links

How your data is structured can affect how long it takes to upgrade it. For example, 10,000 lists with 10 items each will have a longer upgrade time than 10 lists with 10,000 items. The actions required to upgrade the list infrastructure must be performed for each list, regardless of the number of items. Therefore, more lists equals more actions. The same goes for most of the items under database factors or site collection factors.

The structure of your hardware can also have a big effect on performance. Generally, the database server performance is more important than web server performance, but underpowered hardware or connectivity issues at either tier can significantly affect upgrade performance. Web servers have a significant part to play in database upgrade performance, mainly by issuing the commands to make data and structural changes in the databases. The database servers have to process those changes and work with a large set of data for every command. Web server performance becomes a bigger issue during site collection upgrade, when the upgrade process iterates several actions for each site collection (which might occur for multiple site collections at a time). Site collection upgrade also affects the database server as each action must occur in SQL Server.

The best way to estimate overall time is to do a trial upgrade of the data, and then review the upgrade log files. The log files contain the duration for an upgrade — look for Total Elapsed Time at the bottom of the upgrade log file. Use this time to estimate the duration for your full set of content. You can also use the log files to check your progress during the upgrade process. The upgrade.log file is located at %COMMONPROGRAMFILES%\Microsoft Shared\web server extensions\15\LOGS.

To determine durations from the logs, examine:

  • The times spent in each upgrade sequence per log.

  • The times spent per upgrade action instance per log.

  • The minimum, maximum, and average times.

Make sure that you separate out the database upgrade times from time that is spent upgrading site collections for accurate planning. Perform multiple trial upgrades to guarantee more accurate data. Then collate the data from multiple tests to determine likely performance per sequence, action, and database. You can use the Get-SPUpgradeActions cmdlet in Windows PowerShell to see how many actions occur for the farm. For more information, see Get-SPUpgradeActions.

The estimate you arrive at based on your trial upgrade is for the actual upgrade process for the data. It does not include all of the steps that you have to perform before and after this step, which can take more time than the upgrade of the data itself. When estimating how long the upgrade will take, in addition to the time that is required for data to be processed, you must also estimate how long the activities during the upgrade phases will take.

Consider the following factors:

  • Creating custom elements Upgrading Web Parts or re-doing custom templates to take advantage of new features will take some time. The process of creating custom elements should begin early, during the evaluation phase of your project.

  • Backing up the databases You must perform a full backup — not a differential backup — of your databases for a database-attach upgrade. For large environments, this step can take significant time. In particular, if you are backing up to a network location, network latency issues can slow this process down.

  • Creating service applications and configuring services Creating service applications and configuring services does not take long. However, if you must contact a database administrator to create the databases for you before you create service applications, you might need a day or two of lead time.

  • Running a search crawl on all content For large sites, this step can take more than 24 hours. Unless you run a crawl, searches cannot return results because the index is not upgraded.

  • Verifying the environment after upgrade For large environments, it can take a while to verify the environment and check the site collections to make sure that they are in a good state before you allow users access to them. For more information, see Verify database upgrades in SharePoint 2013.

For site collection upgrade, consider the following factors:

  • Verifying sites and making changes Allow enough time for users to validate their sites after the upgrade. This may take several days. For more information, see Review site collections upgraded to SharePoint 2013.

Additional factors in your environment can also contribute to longer upgrade times. They include the following:

  • Very large document libraries A document library with more than 250,000 documents all in the root of the document library (instead of in folders) will take a long time to upgrade, and the upgrade might not be successful. Following the guidelines for using folders to break up large document libraries can help you manage the library size. For example, if you rearrange the same document library so that the 250,000 documents are divided into 125 folders, it should upgrade more easily.

  • Very large databases Databases larger than 100 GB can take a long time to upgrade.

    If you have content databases that are larger than 100 GB and include mixed site types (such as My Sites and team sites together with published sites), we recommend that you divide them up into smaller databases that contain a consistent type of data before you run the upgrade.

    Note:

    My Sites are available only with SharePoint Server, not SharePoint Foundation.

    You can use the Move-SPSiteWindows PowerShell cmdlet to move sites between databases. For more information, see Move-SPSite.

    Be sure that you are following the capacity planning guidelines from the previous and new versions before you attempt the upgrade. If you have exceeded the guidelines for best performance, the upgrade process might take longer, or it might fail (for example, the process might time out repeatedly on the same large document library). If your deployment does not meet the recommended capacity guidelines, consider whether you have to do some work to meet those guidelines before you try the upgrade. Again, a trial upgrade can help you with that decision.

  • Wide lists (lists with many columns)

    Wide lists are lists with more columns than fit in a single rowspan in the content database. These lists can take longer to process during upgrade, or might not upgrade. For more information, see Clean up an environment before an upgrade to SharePoint 2013.

  • Sites with many subwebs

    Site collections that contain hundreds or thousands of subwebs will take much longer to process during site collection upgrade. For example, a site collection with thousands of subwebs might take many hours instead of many minutes, or longer, to upgrade.

  • Communications requirements

    You have to notify the users and your team of the upgrade schedule, and give them time to do their tasks. For more information, see Create a communication plan for the upgrade to SharePoint 2013.

  • Managing system center alerts and alarms

    You have to monitor system performance during upgrade, but you will not have to monitor specific features. Pause any unnecessary alarms and alerts from Microsoft Systems Center Operations Manager or Microsoft Operations Manager, and then turn them on again after upgrade.

  • Turning SQL Server mirroring and log shipping (or AlwaysOn Availability Groups) on/off

    You should turn off mirroring and log shipping before you upgrade, and then turn them on again after you are sure that your environment is running correctly after the upgrade. We recommend that you do not run mirroring or log shipping during upgrade, because this creates additional load on the servers that are running SQL Server and also wastes resources mirroring or shipping temporary data.

    This also applies to AlwaysOn Availability Groups in SQL Server 2012.

Test the upgrade process to discover how long it may take, then create a schedule for the upgrade operations and test that to determine your timeline. You should include the time that that is required to do the pre-upgrade and post-upgrade steps in your operations timeline: If it takes 5 hours to back up your databases, you must include that time in your timeline. Also include buffer time in case you have to restore or recover — you should determine both your planned outage (realistic case) and your emergency outage (worst case) timelines.

Environment performance after upgrade

After you complete an upgrade, the environment will likely experience some lag in performance as it works through the changes. Make sure that you confirm the actual performance against your expected performance after upgrade to make sure that your new farm is performing within acceptable bounds. Check SQL Server responsiveness: is the disk queue length too long? Are CPU and memory usage too high? Also look for web and application server responsiveness: is the number of requests per second (RPS) acceptable? What about page load time (initial and secondary page requests). Review your overall environment performance and make adjustments as needed.

See also

Use a trial upgrade to SharePoint 2013 to find potential issues
Overview of the upgrade process to SharePoint 2013
Best practices for upgrading to SharePoint 2013
Plan for upgrade to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Create a communication plan for the upgrade to SharePoint 2013
See also

Summary: Communicate timelines, requirements, and how to obtain help with site owners and users during upgrade to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

It is important that you communicate with users during the upgrade process from SharePoint 2010 Products to SharePoint 2013. Site users have to know what to expect when they visit their sites again after you have upgraded the environment. Site owners have to know how they can help prepare for upgrade and what they have to do to upgrade their site collections in SharePoint 2013 and My Sites in SharePoint Server 2013. Both site users and site owners have to know when the upgrade will occur. As part of the planning process, determine the following:

  • Who are the members of the upgrade team, what other stakeholders are involved, and who will be affected by the upgrade?

  • What information must the upgrade team have, and when?

  • What information must site users and other stakeholders have, and when?

This article describes how to create a communication plan so that the upgrade team, stakeholders, and users know what to expect before, during, and after the upgrade.

Who is a member of the upgrade team?

For small deployments in which sites were not customized extensively, the upgrade team might consist of only one person. For larger deployments, on the other hand, several people with different roles can be required, as described in the following list:

  • Server administrators Server administrators perform most of the upgrade tasks. There must be at least one server administrator on the upgrade team because running the Setup wizard requires someone who is a member of the Administrators group on each front-end web server.

    Note:

    Farm administrators might not be local administrators for the server.

  • Database administrators If you have a separate database administration team, you must coordinate with them to schedule the upgrade and perform the upgrade.

  • Server security teams You must coordinate with your security teams, such as the Active Directory Domain Services (AD DS) team, to verify accounts and permissions or to take advantage of the new policy settings that you can apply for SharePoint 2013.

  • Network teams You must coordinate with the network teams, especially if you must switch DNS to point to your new farm, or add the new servers to the network infrastructure.

  • Client deployment team Communicate with client deployment teams to coordinate deployments of new client and server applications. Client deployment might have to occur before you upgrade, or it might be an option for users after their sites are upgraded.

  • Services administrators You must communicate with the administrators for service applications, such as the Business Data Connectivity service, to make sure that they are ready for the upgrade and they can review or reconfigure the appropriate settings in the new version.

  • IT or application Helpdesk leadership and personnel If you have a helpdesk for your company, make sure that they know about the timing for the upgrade and are prepared for questions after upgrade. Helpdesk should be a key stakeholder for planning and testing so that they can be understand the potential changes from an upgrade and the effect that it will have on users.

  • Site collection owners You must notify site collection owners when the upgrade process is about to occur. Warn them about any issues that you find when you run the pre-upgrade checker or when you upgrade their sites. You must also communicate with site collection owners about their role in upgrade. Site collection owners can upgrade their own sites in SharePoint 2013. Site collection owners can run health checks and review upgrade evaluation sites before they upgrade their sites.

  • Site designers and developers and third-party solution providers If you have custom templates, Web Parts, Web services, or other custom elements that are associated with your sites, you must work with the associated site designers and developers or third-party solution providers. Because custom elements can fail or perform differently in an upgraded environment, you have to make sure that designers or developers can create new versions of these custom elements or verify that these elements were upgraded correctly. Because their work can have a big influence on the upgrade schedule, work with these stakeholders early in the process. For more information about potential issues with custom elements, see Use a trial upgrade to SharePoint 2013 to find potential issues.

  • Site users Although you do not have to include site users in making decisions about the upgrade process, you must tell site users when it will occur and what they should expect.

  • Sponsors and other stakeholders Other people in your organization might be involved in the upgrade planning process. Make sure that you include them in your communication plan appropriately.

    Note:

    An upgrade team can include one or more members in each role, depending on your organization.

When and what to communicate to the upgrade team

In general, the server administrators and service application administrators set the timeline for upgrade, and site owners are notified only when the process is about to begin. However, because team members have their own tasks to perform at particular points in the overall upgrade process, it is very important that you have a solid plan to communicate the progress of the upgrade to all team members so that everyone knows when it is time to perform their particular tasks.

The whole upgrade team must work together to determine the dates and times to perform the upgrade. We recommend that you choose an upgrade window to occur when site usage is lowest. For small single-server deployments, upgrade may be completed in less than a day. Larger deployments can take more time, up to a weekend. There is no way to determine the precise length of time that will be required to upgrade any particular site collection. Because of this, it is very important to communicate with other team members involved in the upgrade process in addition to users. The day or days that you choose for upgrading should be far enough in the future that the upgrade team has enough time to complete all of the preliminary steps. When you plan the timeline, make sure that you schedule time to validate the upgraded sites and time to implement any changes or do any work to re-brand sites.

It is important to communicate with site owners, designers, and developers at the following points during the upgrade process:

  • Before the trial upgrade so that they know the general timeline and their roles in the process.

  • After you perform a trial upgrade to find issues. For example, issues such as customized site templates or custom Web Parts should be reported to the appropriate site owner, designer, or developer before you schedule the upgrade, to give them time to investigate the issues and take preliminary steps. Or a developer might decide that it would be prudent to rebuild a Web Part before the upgrade occurs. And site owners might want to note any customizations that were done to their sites, such as site templates and changes to core Active Server Page Extension (ASPX) files.

  • After the environment is upgraded so that they can review the sites and make any changes that are needed.

  • When you are ready for them to upgrade their site collections.

When and what to communicate to site users

It is equally important to communicate with the users of the sites to tell them about the following issues:

  • When the environment will be upgraded In particular, you must also inform them if their sites will be unavailable during the upgrade.

  • When their sites will upgraded Site collection owners should communicate to their site users about the timeline for upgrading the site collection. If you, as a server farm administrator, are upgrading a site, you should communicate when that will occur.

  • How the upgrade might affect them and what they should know about the new environment For example, the site will look different and function slightly differently in the new user interface. You can also point them to available content, such as What's New articles or training materials, to learn about the new version. For more information about feature changes, see What's new in SharePoint Server 15 Beta.

  • How to obtain help If they find an issue with their site after upgrade, how can they obtain help in addressing it?

You can use the new system status bar in the site collections to notify users of these items. For more information about how to set notifications for the status bar, see Plan settings for upgrade notifications, self-service upgrade, and site collection creation in the article Plan for site collection upgrades in SharePoint 2013.

See also

Get started with upgrades to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Clean up an environment before an upgrade to SharePoint 2013
See also

Summary: Make sure that your environment is in a healthy state, and delete unnecessary items before you upgrade to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Before you start to upgrade from SharePoint 2010 Products to SharePoint 2013, you should make sure that your environment is functioning in a healthy state and that you clean up any content that you do not have to upgrade. You can also take the time to remove or rearrange content so that you will have the structure that you want after you perform the upgrade.

Items to clean up

Many of these items can be removed or repaired by using Stsadm command-line tool or Windows PowerShell cmdlets.

Important:

To use the Stsadm command-line tool, you must be a member of the Administrators group on the local computer.

To use Windows PowerShell cmdlets in the SharePoint 2013 Management Shell, you must have the following memberships:

  • securityadmin fixed server role on the SQL Server instance.

  • db_owner fixed database role on all databases that are to be updated.

  • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

Delete unused or underused site collections and subwebs

You do not want to upgrade content that you do not have to keep. If it was unused for a long time and is not needed in the future, back it up, and then delete it to free storage and administrative resources, improve upgrade performance, and reduce upgrade risk. Be sure to communicate with site owners or organizational contacts regarding the site status — you want to make sure that the site is not needed before you delete it (for example, you do not want to delete sites that are required for compliance, such as emergency procedures, even though they may not be frequently updated).

For more information about how to delete site collections and subwebs, see the following articles:

  • Remove-SPSite

  • Remove-SPWeb

Check large lists (lists with lots of data)

By default, large list query throttling is turned on in SharePoint 2010 Products. This behavior has not changed in SharePoint 2013. If a list is very large, and users use a view or perform a query that exceeds the limit or throttling threshold, the view or query will not be permitted. If you are upgrading content from the server products in the Office 2007 release, check any large lists and have the site owner or list owner address the issue. For example, they can create indexed columns with filtered views, organize items into folders, set an item limit on the page for a large view, or use an external list. For more information about large list throttling and how to address issues with large lists, see Manage lists and libraries with many items on Office Online.

Delete excess columns from wide lists (lists with too many columns) or remove wide lists

Wide lists are lists with more columns than fit in a single rowspan in the content database. During upgrade, the underlying storage in the database is changed to a sparse table structure, and a very wide list can cause upgrade to fail. Use the Test-SPContentDatabase command in Windows PowerShell to look for wide lists in the content databases and then remove excess columns, or remove the wide list before you upgrade.

For more information about maximum column sizes in a list, see Column limits.

Consider moving site collections into separate databases

If you have 5,000 or more site collections in a database, consider breaking them out into multiple databases. In SharePoint 2010 Products, there was a default warning at 9,000 site collections and a hard limit at 15,000 site collections. In SharePoint 2013, these values change to 2,000 site collections for the warning and 5,000 site collections for the limit. To avoid errors during upgrade or broken sites after upgrade, we recommend that you move some site collections into separate databases. If you have multiple content databases, you can also speed up an upgrade process by upgrading multiple databases in parallel.

For more information about site collection limits, see Content database limits. For more information about how to move site collections to a new database, see Move site collections between databases in SharePoint 2013.

Remove extraneous document versions

Large numbers of document versions can slow down an upgrade significantly. If you do not have to keep multiple versions, you can have users delete them manually or use the object model to find and remove them. For more information about how to programmatically remove extraneous versions, see Versions Web Service on MSDN.

Remove unused templates, features, and Web Parts

First, verify that no sites are using the template, feature, or Web Part. You can use the Stsadm -o EnumAllWebs operation with the -includefeatures and -includewebparts parameters to identify these customizations in your environment. This operation identifies Web Parts, features, event handlers, and setup files that are being used in your environment. The EnumAllWebs command also specifies which files are used by which sites. Changes were made to the EnumAllWebs command in the February 2011 Cumulative update to make it return both site collection and web-level features. For more information, and to get the cumulative update, see Description of the SharePoint Foundation 2010 cumulative update package (SharePoint Foundation server-package): March 3, 2011.

You can remove a feature during site collection upgrade. Simple features can also be removed by deprecating them in the template. You can use feature upgrade to remove more complex features. For more information, see Upgrading Features and Feature Upgrade Overview on MSDN.

For more information about how to identify customizations in your environment, see Use a trial upgrade to SharePoint 2013 to find potential issues. If customizations are not being used, delete them. For more information about how to manage these kinds of customizations, see Features and Templates and Solutions and Web Part Packages on MSDN.

Remove PowerPoint Broadcast sites

These sites and site templates are not available in SharePoint 2013 because the Office Web Apps Server are now installed separately from the SharePoint 2013 environment. Sites based on these templates will not work in SharePoint 2013. Remove these types of sites before you upgrade.

You can use the Get-SPSiteWindows PowerShell command together with the following options to find these sites:

Copy code
Get-SPSite | Where-Object{$_.RootWeb.Template -eq "PowerPointBroadcast#0"}

This will return all sites that use that template.

You can also use the Get-SPSite and Remove-SPSiteWindows PowerShell commands together with the following options to remove these sites:

Copy code
Get-SPSite | Where-Object{$_.RootWeb.Template -eq "PowerPointBroadcast#0"} | Remove-SPSite

Be sure to back up these sites before you remove them. For more information, see Get-SPSite and Remove-SPSite.

Remove FAST Search Center sites

You cannot upgrade FAST Search Center sites to the 2013 experience. Existing FAST Search Center sites can continue to work in 2010 mode after upgrade. If you want the new functionality, you must create new Enterprise Search Center sites in 2013 mode.

Finish Visual Upgrades in SharePoint 2010 Products

During an upgrade from the server products in the Office 2007 release to SharePoint 2010 Products, you could allow site owners to use Visual Upgrade to keep sites in the old experience on the upgraded environment. When you upgrade to SharePoint 2013, all sites that are still in the old experience in SharePoint 2010 Products are automatically upgraded to the 2010 experience. If you want the opportunity to address any issues and review the sites before they are switched to the new experience, upgrade them to the new experience in your SharePoint 2010 Products environment and review them before you upgrade them to SharePoint 2013. We recommend that you finish visual upgrades before you upgrade to SharePoint 2013. Finishing visual upgrades before you upgrade provides the following benefits:

  • You can address issues while you still have the server products in the Office 2007 release components available.

  • You can have users be involved in reviewing and fixing issues in their sites.

  • You can roll back to the old experience temporarily if it is necessary. You cannot roll back when you are in the SharePoint 2013 experience.

  • You avoid adding potential errors to the upgrade process. The fewer operations occurring during upgrade, the better. Trying to troubleshoot errors is more difficult when you have more processes involved. And users might think that upgrade has caused an issue when it's really the experience changing to the new version. If you have an issue with how the site interface is displaying, how will you know whether it is an old issue from the site that was forced through visual upgrade, a problem with the 2010 mode in SharePoint 2013, or a problem with a new CSS file?

To check for sites in the old experience, on the SharePoint 2010 Products environment, you can use the Get-SPSite Windows PowerShell command.

To check for and upgrade sites still in the old experience in the SharePoint 2010 Products environment by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2010 Products.

  4. Click SharePoint 2010 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command to return all site collections that are in or have subwebs in the old experience:

    Copy code
    Get-SPSite | ForEach-Object{$_.GetVisualReport()}

  6. At the Windows PowerShell command prompt, type the following command to upgrade those sites to the new experience:

    Copy code
    Get-SPSite | ForEach-Object{$_.VisualUpgradeWebs()}

For more information, see Get-SPSite and Manage visual upgrade (SharePoint Server 2010).

Repair data issues

Make sure that you repair all issues in your databases or site content before you upgrade. In particular, check the following items:

  • Check databases for corrupted data

    Clean up your databases to remove any orphaned sites or other corrupted data, such as a corrupted list. Consider defragmenting if you have removed sites or subsites from the database. For more information, see:

    • Databaserepair: Stsadm operation

    • Forcedeletelist: Stsadm operation

  • Check databases for duplicate or orphaned site collections

    Make sure that site collections exist in only one content database. Occasionally, site collections can leave behind duplicate or orphaned references in old content databases if they are moved to new databases, or if a copy of a database was attached to the farm, or if there was an error when a site collection was provisioned. If a site collection is referenced in more than one content database or there is more than one instance of the site collection in a content database, it can cause issues when you upgrade by using the database attach upgrade method. If you upgrade a duplicate version of the site collection first, the site map in your configuration database might end up pointing to that version of the site instead of the current version.

    Before you upgrade, use the Enumallwebs operation in stsadm command-line tool to discover which sites are in which content databases and compare the results. Also, examine each site collection in the results and check whether it is listed as missing in the site map. Being listed as missing indicates that it is an orphaned site. For more information, see Enumallwebs: Stsadm operation. If you find duplicate or orphaned sites, you can use the Remove-SPSite cmdlet in Windows PowerShell to remove the duplicate or orphaned sites from the database.

    For more information, see Remove-SPSite.

  • Check variations

    In publishing environments, check for any variations that must be fixed. For more information, see Variationsfixuptool: Stsadm operation.

How to make structural changes

To make structural changes to your environment, such as moving site collections or changing how your databases are allocated, you can use the following methods:

  • Move-SPSite Use this to move site collections between databases. If a database is very large or contains lots of site collections, you can move sites to address this to make upgrade more efficient. Also, you can move all collaboration sites into one database and all My Sites into another to make the upgrade administration easier for those different sets of sites. You can also use this operation to divide large databases if they contain multiple site collections. This can also help increase upgrade efficiency.

    For more information, see Move-SPSite.

  • Export-SPWeb and Import-SPWeb Use this method to move subwebs or site collections inside a farm or between farms. For more information, see Export-SPWeb and Import-SPWeb.

See also

Use a trial upgrade to SharePoint 2013 to find potential issues
Best practices for upgrading to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Test and troubleshoot an upgrade to SharePoint 2013
See also

Updated: May 21, 2013

Summary: Find resources about how to test and troubleshoot an upgrade from SharePoint 2010 Products to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Before you upgrade from SharePoint 2010 Products to SharePoint 2013, you should take time to test an upgrade process and understand the issues that you might face in an actual upgrade. After you perform a test upgrade, or after you upgrade your actual databases, you might find issues that have to be addressed. After you address issues, you can restart the upgrade to try again.

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about how to test and troubleshoot upgrade.

Downloadable resources about how to test and troubleshoot upgrade

Download the following content for information about how to test and troubleshoot upgrade.

 | Content | Description
Architecture icon | SharePoint 2013 Products Preview - Test Your Upgrade Process model | See a visual display of information about how to test the upgrade process.
Architecture icon | SharePoint 2013 Products Preview Upgrade Worksheet | Use this worksheet to record information about your environment while you test upgrade.

TechNet articles about how to test and troubleshoot upgrade

The following articles about how to test and troubleshoot upgrade are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Use a trial upgrade to SharePoint 2013 to find potential issues | Find out how to plan for success by testing upgrade by using your actual data in either a physical or virtual environment.
Troubleshoot database upgrade issues in SharePoint 2013 | Follow these recommendations to troubleshoot any issues that occur during database-attach upgrade. You can also look up common issues and discover how to address them.
Troubleshoot site collection upgrade issues in SharePoint 2013 | Follow these recommendations to troubleshoot any issues that occur during a site collection upgrade. You can also look up common issues and discover how to address them.
Branding issues that may occur when upgrading to SharePoint 2013 | Learn how to address issues with branding in an upgraded site, such as custom CSS, custom themes, and custom master pages and page layouts.
Restart a database-attach upgrade or a site collection upgrade to SharePoint 2013 | If you encounter errors during upgrade, you can address them by using the troubleshooting article, and then use this article to restart or resume upgrade.

Additional resources about how to test and troubleshoot upgrade

The following resources about how to test and troubleshoot upgrade are available from other subject matter experts.

 | Content | Description
TechNet logo | Upgrade and Migration Resource Center for SharePoint 2013 Products | Visit the Resource Center to find additional information about upgrades to SharePoint 2013.

See also

Best practices for upgrading to SharePoint 2013
Clean up an environment before an upgrade to SharePoint 2013
Plan for performance during upgrade to SharePoint 2013

Change History

Date | Description
May 21, 2013 | Added a link to "Branding issues that may occur when upgrading to SharePoint 2013".
July 16, 2012 | Initial publication


Use a trial upgrade to SharePoint 2013 to find potential issues
See also

Summary: Prepare for upgrade to SharePoint 2013 by testing the upgrade process on copies of real data.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Before you start an upgrade from SharePoint 2010 Products to SharePoint 2013, you should test the upgrade process to make sure that you know exactly what you have to do to have a successful upgrade. A trial upgrade to test the process can reveal the following issues:

  • Whether an upgrade plan will work or if you must make adjustments.

  • The customizations that are in your environment so that you can plan to deal with them during upgrade.

  • Whether you should upgrade your hardware to make an upgrade run more efficiently and more quickly.

  • The timing for upgrade, or how long upgrade will take for your environment.

  • What you must plan for, operationally — for example, resources to have available.

In addition, you can use the trial upgrade to become familiar with the upgrade tools and the process itself so that you know what to expect when you perform the actual process. Through testing, you can discover the following issues:

  • What does the upgrade user interface look like? How do you know when you have finished one phase and are moving through another?

  • Where are the log files, and how do you read them? What information do they provide?

  • Whether you must adjust any scripts or commands that are used during the upgrade process, especially if you are relying on any scripts that were used in upgrading to SharePoint 2010 Products.

  • Whether you have the right plan to address any outages.

This article describes basic steps for testing upgrade, and it gives recommendations for reviewing the results and adjusting an upgrade plan based on what you learn during the tests.

In addition, the following resources can be helpful when you test the upgrade process:

  • SharePoint 2013 Upgrade Worksheet

    Download the SharePoint 2013 Products Preview Upgrade Worksheet and use it to record information about your environment while you test upgrade.

  • SharePoint 2013 - Test Your Upgrade Process model

    Download the SharePoint 2013 Products Preview - Test Your Upgrade Process model poster to see a visual display of information about how to test the upgrade process.

  • See best practices for testing the upgrade process in Best practices for upgrading to SharePoint 2013.

Set up a test environment

You can use either virtual or physical hardware to test the upgrade process. Every environment is unique. Therefore, there are no general guidelines for how long upgrade will take or how difficult a particular customization will be to upgrade. The best way to gauge how upgrade will go is to perform a series of trial upgrades.

Here are some things to consider when you create your test environment:

  • Make your test farm as similar as possible to your real farm — for example, hardware, software, and available space.

  • Use the same URLs in your test farm as in your real farm. Otherwise, you will waste time diagnosing issues that relate to the URLs that will not occur in the real upgrade. You can do this by using the same URLs and testing only from computers that have host file changes.

  • Use the different computer names for your web and application servers.

    This will prevent Active Directory Domain Services (AD DS) conflicts.

  • Use separate servers that run SQL Server for your test farm

    If you are using the same servers that run SQL Server for your test and production farm, you can affect the performance of your production farm while you run your tests. We recommend that you use different SQL Server computers (not just instances) for your production and test farms.

  • Use the same database names in your test environment.

    That way, you can validate any scripts that you use to manage your environment. Again, make sure that you use separate servers that are running SQL Server or you risk affecting your production environment.

  • Be sure that you transfer all the settings and customizations to the test environment. The section Identify and install customizations provides information about collecting this information.

Make sure that actions that you take in the test environment do not affect the live environment. Be cautious with the following:

  • External data connections

    Even though you are working with a copy of the environment, the link to the data source is real. Changes that you make to the data in the test environment affect the production environment.

  • Running commands against a live database still in production

    Make sure that you use copies of your databases for testing, not a live version in your production environment. For example, if you run Test-SPContentDatabase against a live database, instead of a copy, you might affect performance on your production environment.

Using a virtual test environment

When you test by using a virtualized environment, you do not have to have lots of hardware. You can replicate your environment by using just two servers that are running Hyper-V. One server has images for the front-end web servers and application servers, and the other server has images for the database servers.

However, virtual environments might not have the same performance metrics as physical environments. If your production environment is physical, you must consider this difference when you calculate the time that is required to upgrade your production environment. Generally, you can get better performance estimates if you use a physical server for SQL Server. Make sure that it has similar performance specifications to your server that runs SQL Server in your production environment.

Distribution of servers in a virtual test environment

Virtual test farm for upgrade

Using a physical test environment

When you test by using a physical environment, you must replicate your proposed production server farm environment as closely as possible. If you simplify the number of front-end web servers, application servers, or database servers too much, you will not have an accurate estimate of how long the upgrade process will take. You may not account for complications that arise from interactions between servers in the same role (such as SQL Server transactions). If you have multiple servers in a role in your proposed production farm, use at least two servers for that role in the test farm to test for such issues.

Distribution of servers in a physical test environment

Physical farm for testing upgrade

Identify and install customizations

To have an accurate test process, you must find all the customizations in your current environment and copy them to the test environment. For more information about the types of customizations that you have to identify, see Create a plan for current customizations during upgrade to SharePoint 2013.

  • Use the Stsadm -o enumallwebs operation on all content databases in your SharePoint 2010 Products environment to identify specific customizations in subsites. This operation lists an ID for each site collection and subsite in your environment and the templates that the site relies on. For more information, see Enumallwebs: Stsadm operation.

  • Use a tool such as WinDiff (a tool that is provided with most Microsoft operating systems) to compare your production environment servers with your test farm servers. You can use this tool to see which files exist on your servers and the differences between them.

  • Check the web.config files for any changes, and look in the SafeControls element to find any custom controls.

  • Use the SharePoint Diagnostics Tool (SPDiag) to find deployed solutions. For more information, see SharePoint Diagnostics Tool (SPDiag).

  • Create a list of all customizations that you find. Identify the source of the customizations, if it is possible. For example, are there third-party add-ins or templates that were customized in-house? After you identify the source, you can then check for updated or upgraded versions of the customizations. Download the SharePoint 2013 Products Preview Upgrade Worksheet and record information about your environment, based on your research on your customizations.

Tip:

Whom do you contact about customizations that you did not create?

  • Contact Microsoft if you have problems with a template that you downloaded from the Microsoft website.

  • Contact your third-party solution vendor if you have problems with a template or component that they supplied you for the earlier version. An upgraded version may be available.

After you identify all the customizations, copy them to the appropriate servers in your test farm. Ensure that the following customizations are deployed:

  • Solutions - by default legacy solutions are deployed to the /14 directories. Use the CompatibilityLevel parameter when you install the solutions to deploy them to the /15 directories. For more information, see Install-SPSolution.

  • Custom Master Pages

  • Custom JavaScript

  • Custom CSS files (including those for themes)

  • Custom workflow actions (must be included in actions file)

  • Confirm large list query throttling settings to make sure that large lists are displayed as expected.

When you test customizations, use the following guidance:

  • Check for visual changes.

  • Check for behavioral changes.

  • Test in both 2010 and 2013 mode site collections.

  • Look for any language or resource loading issues.

    This is an issue that can occur when customizations exist in 2010 mode and new customizations replace them in 2013 mode. Because there is only one global directory for language resources, there can be an issue loading the correct file. Make sure that replacement 2013 customizations include the 2010 resources so that the customizations can continue to work correctly in both modes.

  • Validate that upgrade did not affect customizations. Ensure that customizations do not block site collection upgrade.

You can use the Test-SPContentDatabase Windows PowerShell cmdlet before you attach a database to SharePoint 2013 to determine whether any customizations are missing from the environment. Run this command for each database after you restore the databases to your database server but before you run the upgrade. Note that this cmdlet runs silently — it will not return any output unless there is an issue found.

Copy real data to the test environment and upgrade databases

You cannot achieve your testing goals unless you use your actual data. Use the Microsoft SQL Server backup and restore tools to create a copy of your content and services databases.

There is no better way to tell what may occur during upgrade than to perform the test on a copy of all the data. However, this might not always be a realistic option for initial testing. You can test in phases by testing one database at a time (if the databases are large) so that you can make sure that you test whatever is unique about that dataset. Or, you can assemble a subset of data from representative sites in your environment. If you want to first test by using a subset of your data, be sure that the subset has the following characteristics:

  • The data subset contains sites that are typical of the sites that you support in your environment.

  • The size and complexity of the data subset closely resembles the actual size and complexity of your environment.

Important:

Testing a subset of your data does not produce a valid benchmark for how long it will take to process the whole volume of data for your environment.

After you copy the data, take a first pass through the upgrade process to see what happens. This is just the preliminary round. Follow the steps in Upgrade content databases to SharePoint 2013 to try the database attach upgrade process.

When you test the upgrade process, make sure that you test services that are shared across farms. Consider all states, such as the following:

  • A SharePoint Server 2010 farm connected to a SharePoint Server 2013 services farm.

  • A SharePoint Server 2013 farm connected to a SharePoint Server 2013 services farm.

  • Different version farms for different services.

Use the test environment to find any security, configuration, compatibility, and performance issues for service applications.

Review results after you upgrade databases

After your test upgrade has finished, you can review the results and revisit your plans. Look at the log files, look at the upgraded sites, and review your customizations. How did upgrade work for your environment? What did you discover? What do you have to rethink about the upgrade plan?

Review the log files

Review the upgrade log file and the upgrade error log file (generated when you run the upgrade). The upgrade log file (.log) and the upgrade error log file (.err) are located at %COMMONPROGRAMFILES%\Microsoft Shared\Web server extensions\15\LOGS. The log files are named in the following format: Upgrade-YYYYMMDD-HHMMSS-SSS.log, where YYYYMMDD is the date and HHMMSS-SSS is the time (hours in 24-hour clock format, minutes, seconds, and milliseconds).

The format of the log files complies with the Unified Logging System (ULS) conventions. To review the log files to find and troubleshoot issues, start at the top of the files. Errors or warnings may be repeated if they occur for several site collections in the environment, or if they block the upgrade process completely. For example, if you cannot connect to the configuration database, the upgrade process will try (and fail) several times and these tries will be listed in the log file.

Review sites in 2010 mode

Verify that the site collections that were not upgraded work as expected in 2010 mode. Sites should look and behave as they did in SharePoint 2010 Products. Some changes are expected. For example, Office Web Apps and the web analytics features have changed in SharePoint Server 2013 and sites that used these features will be affected. For information about specific things to look for, see Review site collections upgraded to SharePoint 2013.

Run upgrade again, if it is necessary

If you have to, you can restart the upgrade process for a database by using the Upgrade-SPContentDatabase Windows PowerShell cmdlet. For more information about this cmdlet, see Upgrade-SPContentDatabase. For more information, see Restart a database-attach upgrade or a site collection upgrade to SharePoint 2013.

Upgrade site collections and My Sites

After you have tested and validated upgrade for the content and services databases, you can test the upgrade process for site collections. Follow the steps in Upgrade site collections to SharePoint 2013 to test the site collection upgrade process. If you have My Sites in your environment, see Overview of the upgrade process to SharePoint 2013 for more information about the process of upgrading them.

Note:

Content about My Sites applies only to SharePoint Server 2013.

Review results after you upgrade site collections

Review upgraded sites visually to identify any issues that have to be addressed before you run the upgrade process on your production environment. For more information about specific things to look for, see Review site collections upgraded to SharePoint 2013.

Review the site collection upgrade log files to check for any issues, starting from the top down. Check the summary section near the end of the log file to see a count of issues and the actual upgrade status (if there is no status, that means that the upgrade process failed and site upgrade must be retried). The site collection log files are stored both in the site collection itself (in the _catalogs/Upgrade document library), and on the file system. The file system log file has more information if you want details about issues. The file system version of the site upgrade log file is located at %COMMONPROGRAMFILES%\Microsoft Shared\Web server extensions\15\LOGS. The log files are named in the following format: SiteUpgrade-YYYYMMDD-HHMMSS-SSS.log, where YYYYMMDD is the date and HHMMSS-SSS is the time (hours in 24-hour clock format, minutes, seconds, and milliseconds).

Adjust your plans and test again

Repeat the testing process until you are sure that you have found all the issues that you may face and that you know how to deal with them. Your goal is to know what your plan is if it is 4:00 P.M. on Sunday, you have to be back online Monday morning, and it is not going well. Is there a point of no return? Test your fallback plan and make sure that it works before you begin your real upgrade.

See also

Best practices for upgrading to SharePoint 2013
Plan for performance during upgrade to SharePoint 2013
Upgrade databases from SharePoint 2010 to SharePoint 2013
Upgrade site collections to SharePoint 2013
Test and troubleshoot an upgrade to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Troubleshoot database upgrade issues in SharePoint 2013
See also

Summary: Learn how to address problems that may occur after you upgrade a database to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Even after you test the upgrade process to identify potential issues, you might experience unexpected issues during an upgrade from SharePoint 2010 Products to SharePoint 2013. If you experience issues after upgrade, the sooner you detect and fix them, the better the end-user experience will be.

This article includes a list of common issues and describes general principles to help you identify and address upgrade issues. After you identify and address the issues, you can resume upgrade. For more information about how to resume upgrade, see Restart a database-attach upgrade or a site collection upgrade to SharePoint 2013.

General principles to identify issues

Check the upgrade status to see where upgrade stopped (if it did stop), and check log files to find errors or warnings. Next, address the issues that you find before you resume the upgrade.

First, check upgrade status and log files

Upgrade status indicators and log files indicate what went wrong during the upgrade process. We recommend that you carefully review all the errors that were logged in the upgrade log files. Warnings might not always indicate an issue, but you should review them all to determine whether any of them are likely to cause even more issues.

  1. Review the Upgrade Status page in the SharePoint Central Administration website.

    For more information about how to check upgrade status, see Verify database upgrades in SharePoint 2013.

  2. Review the following log files:

    • The upgrade error log file and the upgrade log file (which contains more detailed information than the upgrade error log file).

    • ULS or trace log files.

      These files are stored in the %COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\LOGS folder and are named Servername_YYYYMMDD-MMSS.log.

    • The application event log file.

      This file can be viewed by using the Event Viewer.

    For more information about the upgrade log files, see Verify database upgrades in SharePoint 2013. For more information about the trace log file, see Trace Logs on MSDN.

Then, address issues in order

Some issues have more effect than others. For example, a missing server-side file can cause many seemingly unrelated errors at the site level.

Address issues in the following order:

  1. Missing server-side files or customizations, such as features or Web Parts.

    Be sure to install all server-side customizations, such as features, Web Parts, and so on. Be sure to install customizations to the correct location in your new farm. For example, additional style sheets that you must have for SharePoint 2010 Products should be installed in the /14 path, not the new /15 path so that site collections that you have not upgraded can use them. Also, make sure that that you transfer all unique settings from the Web.config files for each web application to the new servers.

  2. Configuration issues in the server farm, web application, or service applications, such as managed paths or service applications that are not started.

  3. Additional issues that you discover on a site-by-site basis, starting with high-profile or very important sites.

As you identify and fix the top-level issues, you can try to run upgrade again to see whether any issues that occurred later in the upgrade process have also been fixed.

Common issues

Check to see whether any of the following issues cause an upgrade error or warning.

Q: I want to upgrade from a pre-release version of SharePoint 2013

  • A: Upgrade from a pre-release version of SharePoint 2013 to the release version of SharePoint 2013 is not supported.

    Pre-release versions are intended for testing only and should not be used in production environments. Upgrading from one pre-release version to another is also not supported.

Q: The log says I have missing templates, features, or other server-side customizations

  • A: Identify all server-side customizations and install them before you upgrade

One common error during upgrade is missing server-side files — either files that were installed with SharePoint 2010 Products or customized files. When you prepared for upgrade, you should have created an inventory of the server-side customizations (such as site definitions, templates, features, Web Parts, assemblies) that your sites required. Check this inventory to make sure that all the files that are needed for your customizations are installed in your new environment.

You can use the test-spcontentdatabaseWindows PowerShell cmdlet before you upgrade the database to identify missing files. You can also use the enumallwebs operation in Stsadm.exe to identify server-side customizations that are being used.

In the upgrade log files, you may see errors such as the following:

  • ERROR Found Reference Count web(s) using missing web template Site Template Identifier (lcid: Site Template Language Code) in ContentDatabase Content Database Name.

  • ERROR Found a missing feature Id = [Feature Identifier]

  • WARNING File [Relative File Path] is referenced [Reference Count] times in the database, but is not installed on the current farm.

  • WARNING WebPart class [Web Part Identifier] is referenced [Reference Count] times in the database, but is not installed on the current farm.

  • WARNING Assembly [Assembly Path] is referenced in the database, but is not installed on the current farm.

  • WARNING Feature could not be upgraded. Exception: Feature definition id 'Feature Identifier' could not be found.

If you can obtain a missing server-side file or dependency, install it, and then run upgrade again for the affected sites. If the file or dependency (such as a Web Part) was deprecated, you have to investigate whether you want to rebuild the site, page, or Web Part to use a different template, feature, or Web Part. If you can redo the customization by using dependencies that were not deprecated, you can run upgrade again for the affected sites. If you cannot remove the dependency, you cannot upgrade the site.

After you install the missing file or dependency, use the test-SPContentDatabase Windows PowerShell cmdlet on a test server to determine whether any other files for that database are missing. If you only run upgrade again, the error might not appear in the log files, even though it might still be occurring.

Q: The log file says that something is not right with my farm, web application, or service application configuration settings

  • A: Verify your farm and web application settings.

  • A: Create and start missing service applications

  • A: Verify that managed paths (included paths) are configured correctly for each web application.

In the upgrade log files, you may see errors such as the following:

  • ERROR Template Template Id: SPSite Id=Site Id could not be accessed due to exception. Skipping SPWeb Id=Web Id for template upgrade. Exception: System.IO.FileNotFoundException: The site with the id Site Id could not be found.

    This error indicates that a managed path is missing. Add the managed path for the site collection into the web application and restart upgrade for the content database that contains this site collection.

Q: I see errors and warnings during upgrade about connectivity or corruption

  • A: Verify your power connections and connection to the network and to SQL Server. Loss of connectivity to data sources can cause errors. If your servers cannot connect to the databases, they cannot be upgraded.

  • A: Clean up orphaned sites, lists, and other database corruptions before you try upgrade again. For more information about how to clean up data issues, see Clean up an environment before an upgrade to SharePoint 2013.

    In the upgrade log files, you may see errors such as the following:

    • WARNING The orphaned sites could cause upgrade failures.

    • ERROR Database [Content Database Name] contains a site (Id = [Site Collection Identifier], Url = [Site Collection URL]) that is not found in the site map.

    Fix any orphaned items or database corruptions, and then run upgrade again.

Q: I ran out of disk space

  • A: Free some space, or increase the size of the transaction log file before you resume upgrade. If you run out of space (for example, for transaction log files on your database servers), upgrade cannot continue.

    For more information, see Managing the Size of the Transaction Log File.

Q: I see an error about authentication

  • A: Make sure that the web application is using the right authentication method.

A mismatch in authentication methods can cause problems when you upgrade. The following resources can help if you have a mismatch between authentication methods:

  • Classic-to-claims authentication

    Make sure that the web applications that you created in SharePoint 2013 use the same authentication method that was used in SharePoint 2010 Products. Claims-based authentication is the default authentication method for web applications in SharePoint 2013. If the web application was using classic mode, you can either update it to claims before you upgrade the database, or create the web application in classic mode and then migrate it to claims. For more information about how to change to claims authentication in SharePoint 2010 Products, see Migrate from classic-mode to claims-based authentication in SharePoint 2013. For more information about how to create a web application that uses classic mode, and then migrating to claims, see Create web applications that use classic mode authentication in SharePoint 2013 and Migrate from classic-mode to claims-based authentication in SharePoint 2013

  • Forms-based authentication

    Additional steps are necessary if you are upgrading an environment that uses forms-based authentication. Follow the steps in Configure forms-based authentication for a claims-based web application in SharePoint 2013 to upgrade forms-based authentication providers.

Q: SQL Server says I don't have permissions

  • A: If you receive an error about an unknown account, or if a database is not upgraded, check the permissions for the database. In particular, between instances of SQL Server, make sure that you verify that security is configured correctly. Check that the login accounts that you use have the appropriate fixed roles and permissions on the databases, and that they will still be valid if you upgrade across domains.

  • A: Make sure the account that you use to attach the databases is a member of the db_owner fixed database role for the databases that you want to upgrade.

Q: A database will not upgrade

  • A: Verify that the database is not set to read-only. You cannot upgrade a database that is set to read-only. Make sure that you set the databases to read-write before you attach and upgrade the databases.

Q: I changed a database name during restore, but I cannot find the files that have that name

  • A: When you rename a database at restore time, you must also rename the database and log file names in the file system (the MDF and LDF files) so that they match.

Q: I cannot back up the Search service application Administration database

  • A: Before you can back up the Search service application Administration database, you must stop the Search service on your SharePoint Server 2010 farm. To stop the Search service, on the original farm, on the Start menu, click Administrative Tools, and then click Services. Right-click SharePoint Server Search 14, and then click Stop. Be sure to start the service again after you back up the database.

Q: Trusted connections are not working for Excel Services after upgrade

  • A: You must manually create all trusted data connections for Excel Services after upgrade.

Q: My workflows are no longer associated correctly

  • A: Verify that the Workflow Auto Cleanup timer job is turned off. If you had disabled the Workflow Auto Cleanup timer job in your SharePoint 2010 Products environment, make sure that you disable this timer job in the new environment also. If this timer job is enabled in the new environment and disabled in the SharePoint 2010 Products environment, you might lose workflow associations when you upgrade.

Q: I migrated users from classic authentication to claims-based authentication after upgrade. But some users have information that is out of date

  • A: For issues with user profiles, make sure that that the User Profile to SharePoint Full Synchronization job was run.

    If you started the User Profile to SharePoint Full Synchronization job (either automatically or manually) before the migration process was complete, some users might not be migrated. You can run the following cmdlet in Windows PowerShell after the migration is complete to clear the sync data, and then you can run the User Profile to SharePoint Full Synchronization job again to include the additional users.

    Copy code
    $database = Get-SPContentDatabase "DatabaseName"
[Microsoft.Office.Server.UserProfiles.WSSProfileSynch]::ClearSyncDataForContentDatabase($database)

    Where DatabaseName is the name of the content database for the site collection associated with the out-of-date user profile.

  • A: Verify that the user exists in the Active Directory domain.

    If the user does not exist, you can designate the user as deleted in the UserInfo table. If the user does exist, you can run the migration again. For more information, see Migrate from classic-mode to claims-based authentication in SharePoint 2013.

See also

Use a trial upgrade to SharePoint 2013 to find potential issues
Verify database upgrades in SharePoint 2013
Review site collections upgraded to SharePoint 2013
Restart a database-attach upgrade or a site collection upgrade to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Troubleshoot site collection upgrade issues in SharePoint 2013
See also

Updated: May 21, 2013

Summary: Learn how to address problems that may occur after you upgrade a site to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

When you upgrade a site collection to SharePoint 2013, errors can occasionally occur. This article helps you understand those errors and address them.

For more information about how to review UI issues in sites, see Review site collections upgraded to SharePoint 2013.

Check upgrade status and log files

Upgrade status indicators and log files should give you an indication of what went wrong during the upgrade process. We recommend that you carefully review all the errors in the upgrade log files. Warnings might not always indicate an issue, but you should review them all to determine whether any of them are likely to cause even more issues.

  1. Review the upgrade status page for your site collection.

    On the Site Settings page for the site collection, in the Site Collection Administration section, click Site collection upgrade. On the Site Collection Upgrade page, click Review Site Collection Upgrade Status.

  2. If pages don't render, check the Site Settings page. If the Site Settings page works and the upgrade has succeeded, there might be issues with the master page or home page. If the Site Settings page doesn't work, check the site collection upgrade log file for information about the problem.

  3. Review the site collection upgrade log files. You can review the site collection upgrade logs from the following locations:

    • For site collection administrators: There are also log files for site collection upgrade stored inside the site collection itself, in the Maintenance Logs catalog at (http://<SiteName>/_catalogs/MaintenanceLogs/YYYYMMDD-HHMMSS-SSS.txt , where YYYYMMDD is the date and HHMMSS-SSS is the time (hours in 24-hour clock format, minutes, seconds, and milliseconds).

    • For farm administrators: The site collection upgrade log file and the upgrade error log file are located at %COMMONPROGRAMFILES%\Microsoft Shared\Web server extensions\15\LOGS. The logs are named in the following format: SiteUpgrade-YYYYMMDD-HHMMSS-SSS.log, where YYYYMMDD is the date and HHMMSS-SSS is the time (hours in 24-hour clock format, minutes, seconds, and milliseconds). These file system logs have more information if you want details about issues.

Common issues

Check to see whether any of the following issues are causing an upgrade error, a warning, or a problem in your site.

Q: I don't see a UI control on the page that used to be there

  • A: Reset the page to the default version (that is, reghost it).

Making changes to the site UI can cause problems in site upgrades. If a page was customized to place a UI control in a non-standard location, you can reset the page to the default version to recover the control.

To reset the page, you can use the Reset to site definition link under Site Actions on the Site Settings page or use the Reset to Template command in SharePoint Designer.

Q: The view on a large list is not working any longer

  • A: Create indexed columns, folders, or new views for large lists. You might have to add the indexed column to your existing views.

If a list is very large, and users use a view or perform a query that exceeds the limit or throttling threshold, the view or query will not be permitted. You can create indexed columns with filtered views, organize items into folders, set an item limit on the page for a large view, or use an external list. For more information about large list throttling and how to address issues with large lists, see Manage lists and libraries with many items on Office Online.

Q: I see an error about a duplicate content type name

  • A: Rename content types or fields that conflict with default names.

Occasionally, custom elements (such as a content type) may have a name that conflicts with a name in the new version.

In the upgrade log files, you may see an error such as the following:

  • Failed to activate site collection features on site Site Url. Exception: A duplicate content type name "name" was found.

This error indicates that a third-party content type was added to the specified site in SharePoint Server 2010. During upgrade to SharePoint Server 2013 its name conflicted with the default content type by the same name. Rename the third-party content type in the specified site to a different name and run upgrade again. For more information, see Create or customize a content type on Office Online.

Note:

Either renaming or removing a content type can cause any customizations dependent on that content type to stop working.

Q: My site looks ugly, doesn't behave as expected, or I see script errors

  • A: Either edit the page or reset the page to the default version, or remove or replace the custom files.

    A problem with custom or inline JavaScript or CSS files can cause these issues. For more information, see Branding issues that may occur when upgrading to SharePoint 2013.

Q: Custom content in my site disappeared or doesn't work

  • A: Change the master page, or change the content so that it doesn't require specific zones.

    The master page might have different zone layouts and the content might no longer reference it correctly. As a last resort, you can also reset the page to the default version. However, if you reset the page, you might lose zone specific content. For more information, see Branding issues that may occur when upgrading to SharePoint 2013.

Q: I receive an error that says a control or page cannot render

  • A: Do one of the following:

    • If a Web Part was added that is not installed, contact the farm administrator to have it installed. If is a Web Part that is no longer available or not supported, then use the Web Part maintenance view to remove the Web Part from the page (remove, do not just close the Web Part).

    • If a page was directly edited, either edit it again to remove the control or Web Part or reset the page to the default version.

    A Web Part or other control might have been added to the page that is not installed or is no longer supported. Either a Web Part was added to a zone or the page was directly edited to add a control or Web Part reference directly inline (possibly on a master page).

    A SharePoint feature may need to be activated. For more information, see Enable or disable site collection features and Open and use the Web Part Maintenance Page on Office Online.

Q: I receive an error that I cannot create a subsite based on a site template because the site template uses the 2010 experience version and my site collection is in the 2013 experience version

  • A: Recreate the site template in the 2013 experience.

    To recreate the site template, create a new subsite based on the 2013 experience, customize it again to match the template that you had, and then save the customized subsite as a template (on the Site Settings page, click Save site as template).

Q: I receive an error when I try to upgrade a FAST Search Center site to the 2013 experience

  • A: Recreate the site by using the Enterprise Search Center template.

    FAST Search Center sites cannot be upgraded to the 2013 experience. Existing FAST Search Center sites can continue to work in 2010 mode after upgrade. If you want the new functionality, you must create new Enterprise Search Center sites in 2013 mode.

Q: My custom branding doesn't look right or there are issues in my upgraded site

A: Create an evaluation site collection, and then re-create the master page in the SharePoint 2013 site.

To support the new faster, more fluid UI in SharePoint 2013, changes have been made to the default master pages and CSS files. For this reason, you cannot apply a master page created in SharePoint 2010 to a site in SharePoint 2013. However, when you upgrade your SharePoint 2010 site to SharePoint 2013, the master page is reset to use the default master page in SharePoint 2013. Therefore, after upgrade, your site will not appear with its custom branding.

To resolve this, you should first create an evaluation site collection, and then re-create the master page in the SharePoint 2013 site. For more information, see Branding issues that may occur when upgrading to SharePoint 2013.

Q: My upgraded site does not render at all; instead, I see an "unexpected error" with a correlation ID

A: Your custom branding may use a custom master page that contains a custom content placeholder.

If your custom master page contains a custom content placeholder, and if custom page layouts also contain this custom content placeholder, then an error may prevent the home page of your site from rendering at all after upgrade. Instead, after upgrade, you may see the error message "An unexpected error has occurred." For more information, see Branding issues that may occur when upgrading to SharePoint 2013.

See also

Review site collections upgraded to SharePoint 2013
Upgrade a site collection to SharePoint 2013
Troubleshoot database upgrade issues in SharePoint 2013
Use a trial upgrade to SharePoint 2013 to find potential issues

Upgrade and Migration in SharePoint 2013 Resource Center

Change History

Date | Description
May 21, 2013 | Added items for branding issues in site collections.
July 16, 2012 | Initial publication


Branding issues that may occur when upgrading to SharePoint 2013
See also

Published: May 21, 2013

Summary: Learn how to address issues with branding, such as custom CSS, custom themes, and custom master pages, and custom page layouts in an upgraded site.

Applies to:

SharePoint 2013 introduces a new user interface that is lightweight, fast, and fluid. This UI is built by using new CSS styles, themes, and master pages. To get this new experience, you must upgrade to the new UI. But the significant changes that were made to support the new UI may break the upgrade story for some scenarios where you use custom branding.

In SharePoint 2010 Products, you may have branded your site in one of several different ways:

  • Applying a custom style sheet to your site that overrides the SharePoint default styles.

  • Applying a custom theme (THMX file) to your site.

  • Copying and changing a master page that is included with SharePoint 2013.

  • Creating a completely new custom master page in a publishing site, where the custom master page uses custom styles and is referenced by custom page layouts.

When you upgrade your site collection to SharePoint 2013, these types of customizations will not work as is because the default CSS styles, themes, and master pages have changed. Instead, you must create your custom branding again. This requires you to use the new styles, themes, or master pages available in SharePoint 2013, and then apply the newly re-created design to the upgraded site collection.

Changes to the default SharePoint styles, themes, and master pages were necessary to create a faster and more fluid user interface, and to make subsequent upgrades more predictable.

For this reason, if your site collection contains custom branding, we recommend that, before you upgrade, you first create an evaluation site collection where you can test and re-create your custom branding in a SharePoint 2013 environment. For more information about an evaluation site collection, see Create an upgrade evaluation site (Optional).

The following sections list branding issues that may occur when you upgrade to SharePoint 2013.

Custom CSS

The most common way to apply custom branding to a SharePoint 2010 Products site is to create a CSS file that contains styles that override the default SharePoint styles.

To make the new UI faster and more fluid, SharePoint 2013 introduced fundamental changes in how CSS is implemented:

  • CSS file sizes are reduced.

  • Nesting of CSS selectors is limited.

  • CSS inheritance is used whenever possible.

  • Classes are defined in only one place.

  • Related classes are grouped in the CSS file.

  • Inline styles and the !mportant declaration are not used because they cannot be overridden.

  • Styles use a consistent structure and naming convention.

In SharePoint 2013, styles use a consistent structure and naming convention.

NAMING PART | MS- | <FEATURE>- | <NAME>
Explanation | Indicates this is a Microsoft class. | The name of the feature with which this item is associated, or "core" if it's used as part of the core UI. | A descriptive name of the item, such as title, link, and so on

Because of these changes in how SharePoint 2013 implements CSS, when you upgrade, custom CSS styles will not be applied to your site. To resolve this, you should first create an evaluation site collection and then use that site as the environment where you can identify the new SharePoint 2013 styles that you have to override. Create a CSS file for these styles, and then apply that CSS to your upgraded site.

Custom theme

In SharePoint 2010 Products, you can use an Office program such as PowerPoint 2010 to create a THMX file. Then you can upload that theme file to SharePoint 2010 Products and apply the theme to your site.

In SharePoint 2013, the theming engine was improved so that theming is faster and more flexible, and so that themes can be more easily upgraded moving forward. The theming model uses comment-style markup in the CSS and then replaces parts of the CSS based on parameters such as fonts and color schemes that users select. Themes in SharePoint 2013 are defined by XML files:

  • SPColor.xml defines the color palette, in which slots now have semantic names so that it's more clear what UI elements will be affected when you change a color value. Also, themes now support setting opacity.

  • SPFont.xml defines the font scheme and supports multiple languages, web-safe fonts, and web fonts.

But there is no support to upgrade a THMX file from SharePoint 2010 Products to SharePoint 2013. If you applied a custom theme to the SharePoint 2010 Products site, when you upgrade to SharePoint 2013, the theme files remain in place. But the theme is no longer applied to the site, and the site reverts to the default theme.

To resolve this, you should first create an evaluation site collection and then use the new theming features in SharePoint 2013 to create the theme again. For more information about the new themes, see the following articles on MSDN:

  • Themes overview in SharePoint 2013

  • How to: Deploy a custom theme in SharePoint 2013

  • Color palettes and fonts in SharePoint 2013

  • How to: Create a master page preview file in SharePoint 2013

Important:

Moving forward, if you want to use custom branding, and if you want that branding to work after future upgrades, we recommend that you use themes to implement your design. Themes will have upgrade support when future updates are available. If themes don't work for your scenario or you must have more extensive branding, we recommend that you use a publishing site together with Design Manager. But understand that if you invest in building custom master pages and page layouts, you may have to rework or update your design files during and after each SharePoint upgrade.

Copy and change a master page that ships with SharePoint 2013

In SharePoint 2010 Products, a common way to make minor customizations to the UI is to copy and change a master page that ships with SharePoint 2010 Products. For example, you might change the master page to remove or hide capabilities from users.

When you upgrade a SharePoint 2010 Products site to SharePoint 2013, the master page is reset to use the default master page in SharePoint 2013. Therefore, after upgrade, your site will display its custom branding. The custom master page that was created in SharePoint 2010 Products still lives in the site, but you should not apply the old master page to the new site because the new site will not display as expected.

To support the new UI in SharePoint 2013, changes were made to the default master pages. For this reason, you cannot apply a master page that was created in SharePoint 2010 Products to a site in SharePoint 2013.

To resolve this, you should first create an evaluation site collection, and then create the master page again in the SharePoint 2013 site. After you verify that the new master page works as expected, move the master page to the new site collection and apply it to the site. If the sites are publishing sites, you can use Design Manager to export and then import the master page as part of a design package. Otherwise, you can move the master page as part of a sandboxed solution or by uploading the file to the master page gallery.

Important:

SharePoint Foundation 2013 does not support publishing sites. You'll need SharePoint Server 2013 to use publishing sites.

Custom master page in a publishing site

If you want a fully branded site such as a corporate communications intranet site, you use a publishing site that has a fully custom master page and custom page layouts that are attached to the custom master page.

When you upgrade a SharePoint 2010 Products site to SharePoint 2013, the master page is reset to use the default master page in SharePoint 2013. Therefore, after upgrade, your site will not display its custom branding. The custom master page and page layouts created in SharePoint 2010 Products still live in the site, but you should not apply the old master page to the new site because the new site will not display as expected.

To resolve this issue, you should first create an evaluation site collection that is a publishing site, and then create the master page again in the SharePoint 2013 site. After you verify that the new master page works as expected, complete the following steps:

  1. Export the master page as part of a design package.

  2. Import the design package into the new site collection,

  3. Apply the new master page to the site.

Custom content placeholders on a custom master page

Important:

If your custom master page contains a custom content placeholder, and if custom page layouts also contain this custom content placeholder, an error may prevent the home page of your site from rendering at all after upgrade. Instead, after upgrade, you may see the error message: "An unexpected error has occurred."

To determine whether you have this issue, you can create an evaluation site collection that is also a publishing site, and then set the master page to the master page that ships with SharePoint 2013. If the site still displays, you don't have this issue. If the site doesn't display and you get an "unexpected error" with a correlation ID, you likely have this issue.

To resolve this issue, do the following:

  1. Create an evaluation site collection that is a publishing site collection.

  2. Create a SharePoint 2013 master page.

  3. Add the custom content placeholder to the 2013 master page.

  4. Apply the new master page to the site.

  5. Create a page layout that does not contain the custom content placeholder.

    The page layout will be associated with the new master page that was applied to the site.

  6. Change all the pages that use the old page layout to use the new page layout.

    You can manually edit each page individually in the browser and use the option on the Ribbon, or you can use the client-side object model for SharePoint to update pages programmatically.

  7. Delete the old page layout that contains the custom content placeholder.

We recommend that you do not add custom content placeholders to your custom master page or page layouts.

See also

Troubleshoot site collection upgrade issues in SharePoint 2013
Review site collections upgraded to SharePoint 2013
Upgrade a site collection to SharePoint 2013
Run site collection health checks in SharePoint 2013

Overview of Design Manager in SharePoint 2013


Restart a database-attach upgrade or a site collection upgrade to SharePoint 2013
See also

Summary: Learn how to restart a database-attach upgrade or a site collection upgrade to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

In some cases, you might have to restart upgrade to finish a database-attach upgrade from SharePoint 2010 Products to SharePoint 2013. For example: if a template or language pack is missing from the environment, or if you lose the connection to SQL Server, you will have to resolve the issue and then restart upgrade. You might also need to retry or restart a site collection upgrade if it was unable to complete.

Note:

One frequent cause of failures during upgrade is that the environment is missing customized features, solutions, or other elements. Be sure that any custom elements that you must have are installed on your front-end web servers before you start the upgrade process. You can use the test-spcontentdatabaseWindows PowerShell cmdlet to identify any custom elements that your sites might be using. For more information, see Identify and install customizations in the article "Use a trial upgrade to find potential issues."

Restart upgrade for a database by using Windows PowerShell

If the upgrade ran into issues during the database-attach upgrade, you can restart the upgrade process for the database after you have addressed the issue by using a Windows PowerShell cmdlet.

To restart upgrade for a database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt (PS C:\>), type the following command:

    Copy code
    upgrade-spcontentdatabase <Name>

    Where:

    • Name is the database name that you want to upgrade.

      You can also use the -id parameter and provide the database GUID instead of a database name. You can run the following cmdlet to find the GUID for a content database:

      Copy code
      Get-SPContentDatabase -Identity <content_database_name>

    For more information, see Upgrade-SPContentDatabase and Get-SPContentDatabase.

Restart upgrade for a site collection

If upgrade ran into issues during a site collection upgrade, you can restart the upgrade process for the site collection after you have addressed the issue. You can use either the Site Settings page or a Windows PowerShell cmdlet to restart upgrade for a site collection.

To restart upgrade for a site collection

  1. Verify that the user account that performs this procedure is a site collection administrator.

  2. On the Site Settings page for the site collection, in the Site Collection Administration section, click Site collection upgrade.

  3. On the Site Collection Upgrade page, click Upgrade this Site Collection.

    This option starts to upgrade your site collection. A box opens to verify that you want to start the process.

  4. Click I'm ready to start the actual upgrade.

    Note:

    The site collection health checks are run automatically in repair mode before the upgrade starts. The results from the health checks are included in the upgrade log for the site collection. If there is an error, you must address it before you can continue to upgrade.

    The upgrade starts, and the Upgrade status page for the site collection is displayed. This page automatically updates while the upgrade is in progress and displays information about the process, such as the following:

    • Errors or warnings

    • When the upgrade started

    • Where you can find the upgrade log file

    After the upgrade is complete, the Upgrade status page is displayed in the new user interface with the message, Upgrade Completed Successfully.

  5. Click Let's see the new site to go to the home page.

Farm administrators can restart upgrade by using Windows PowerShell.

To restart upgrade for a site collection by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Upgrade-SPSite <http://site> -VersionUpgrade [-Unthrottled]

    Where:

    • <http://site> is the URL for the site collection.

    • Add the option -Unthrottled option to skip the site collection upgrade queue and start the upgrade immediately.

For more information, see Upgrade-SPSite.

See also

Upgrade to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Upgrade databases from SharePoint 2010 to SharePoint 2013
See also

Summary: Find resources to help you perform the steps to upgrade databases from SharePoint 2010 Products to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

After you learn about the upgrade process, plan for your upgrade, and test your upgrade process by following the steps in the articles in Test and troubleshoot an upgrade to SharePoint 2013, you are ready to perform a database-attach upgrade to SharePoint 2013. Follow the steps in this section for both a trial upgrade and your actual upgrade for your production farm.

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about upgrading databases to SharePoint 2013.

Downloadable resources about upgrading databases

Download the following content for information about upgrading databases.

 | Content | Description
Architecture icon | SharePoint 2013 Products Preview - Upgrade Process model | Describes the steps in the process for a database-attach upgrade

TechNet articles about upgrading databases

The following articles about how to upgrade databases are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Checklist icon | Checklist for database-attach upgrade (SharePoint 2013) | Use this checklist to make sure that you follow all necessary steps as you prepare for upgrade, perform the upgrade, and perform post-upgrade steps.
123 steps | Create the SharePoint 2013 farm for a database attach upgrade | Create and configure a SharePoint 2013 farm so that you can upgrade databases from SharePoint 2010 Products.
123 steps | Copy databases to the new farm for upgrade to SharePoint 2013 | Copy SharePoint 2010 Products content and service databases to a SharePoint 2013 farm so that you can upgrade the data to SharePoint 2013.
123 steps | Upgrade service applications to SharePoint 2013 | Upgrade service applications (Business Connectivity Services, Managed Metadata, Secure Store, User Profiles, Search) to SharePoint 2013.
123 steps | Upgrade content databases to SharePoint 2013 | Learn how to upgrade content databases from SharePoint 2010 Products to SharePoint 2013.
Building blocks | Verify database upgrades in SharePoint 2013 | Verify that the upgrade for your databases has succeeded and that you are ready to begin to upgrade sites.
Building blocks | Migrate from classic-mode to claims-based authentication in SharePoint 2013 | Convert SharePoint 2010 Products or SharePoint 2013classic-mode web applications to claims-based authentication or create new claims-based web applications in SharePoint 2013.

Additional resources about upgrade

The following resources about upgrade to SharePoint 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | Upgrade and Migration Resource Center for SharePoint 2013 Products | Visit the Resource Center to find additional information about upgrades to SharePoint 2013.
TechNet logo | What's New in SharePoint 2013 Products Resource Center | Visit the Resource Center to learn about what's new in SharePoint 2013.

See also

Test and troubleshoot an upgrade to SharePoint 2013
Plan for upgrade to SharePoint 2013
Overview of the upgrade process to SharePoint 2013


Checklist for database-attach upgrade (SharePoint 2013)
See also

Summary: Use this checklist as you upgrade from SharePoint 2010 Products to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This checklist helps you confirm that you follow all the steps that you must follow as you prepare for upgrade, perform the upgrade, and perform post-upgrade steps. This checklist applies only to upgrade of the content and service application databases. It does not apply to upgrade of My Sites or other site collections. For more information, see Upgrade site collections to SharePoint 2013.

In this article:

  • Prepare for upgrade

  • Complete the database attach upgrade

  • Complete post-upgrade steps

Some steps include notes about how long that step might take. These rough estimates only give you a relative idea of the duration of the step. To discover how much time each step will take for your environment, we recommend that you perform trial upgrades in a test environment. For more information, see Use a trial upgrade to SharePoint 2013 to find potential issues and Plan for performance during upgrade to SharePoint 2013.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013, except for the steps about how to upgrade the service applications, which apply mostly to SharePoint Server 2013 (the Business Data Connectivity service application applies to both).

Prepare for upgrade

Follow these steps in order before you start an upgrade to SharePoint 2013:

Pre-upgrade steps

Step Notes

[ ]

Create an inventory of server-side customizations in the environment

Create an inventory of the server-side customizations in your environment (solutions, features, Web Parts, event handlers, master pages, page layouts, CSS files, and so on). Record all customizations needed for your environment in the upgrade worksheet.

Detailed steps: Identify and install customizations in the "Use a trial upgrade to find potential issues" article.

Complete this step for the whole environment. Check each web server to make sure that you don't miss any customizations. Keep the inventory up to date as you prepare for the upgrade.

[ ]

Clean up your environment

Before you begin to upgrade, make sure that your environment is functioning in a healthy state and that you clean up any content that you do not have to upgrade. Clean up any orphaned sites or data, address any large lists and large ACLs, remove extraneous document versions, and remove any unused templates, features and Web Parts.

Detailed steps: Clean up an environment before an upgrade to SharePoint 2013.

Complete this step one time for the whole environment.

This process might take days or weeks to finish.

[ ]

Test the upgrade process

Try out upgrade in a test environment to find any issues and determine how long your actual upgrade might take.

Detailed steps: Use a trial upgrade to SharePoint 2013 to find potential issues

Perform this step multiple times, until you are prepared to perform the actual upgrade.

Complete the database attach upgrade

Follow these steps in order while you upgrade the content and service application databases for your environment.

Prepare the new environment

Step Notes

[ ]

Install and configure SharePoint 2013 and any language packs

Install the prerequisite software, and then install and configure SharePoint 2013.

Complete these steps on each server in your farm.

This step might take one hour or more, depending on the number of servers are in your environment.

[ ]

Configure service applications

Enable and configure the services that you need in your new environment.

Do not configure the following service applications - you will configure them while you upgrade their databases later in the process:

  • Business Data Connectivity service

  • Managed Metadata service

  • PerformancePoint services

  • Search

  • Secure Store service

  • User Profile service

Complete this step one time for the whole environment.

[ ]

Configure general farm settings

Reapply any general farm settings that you must have from your previous farm — such as blocked file types, e-mail setting, and quota settings — and add users or groups to the Farm Administrators group. Configure new settings such as usage and health data collection, diagnostic logging, and mobile accounts.

Important:

If you had disabled the Workflow Auto Cleanup timer job in your SharePoint 2013 environment, make sure that you disable this timer job in your new environment also. If this timer job is enabled in the new environment and disabled in the previous version environment, you might lose workflow associations when you upgrade. For more information about this timer job, see Disable preservation of workflow history (SharePoint Server 2010).

Complete this step one time for the whole environment.

Detailed steps for this phase: Create the SharePoint 2013 farm for a database attach upgrade.

Back up and restore databases

Step Notes

[ ]

Record the passphrase for the Secure Store service application

The Secure Store service application uses a passphrase to encrypt information. You must record this passphrase so that you can use it in the new environment.

Complete this step one time for each Secure Store service application in the environment.

[ ]

Set the previous version databases to be read-only

If you want your original environment to remain available to users in a read-only state, set the databases to read-only before you back them up.

Complete this step for each content database in your environment.

Depending on your organization, you might need a database administrator to complete this step.

[ ]

Back up databases

Back up all the content databases and the following service application databases before you begin the database attach upgrade process:

  • Business Data Connectivity

  • Managed Metadata

  • PerformancePoint

  • Search Administration

  • Secure Store

  • User Profile: Profile, Social, and Sync databases

Complete this step for each content database and supported service application database in your environment.

This step can take an hour, several hours, or longer, depending on your dataset and your environment.

Depending on your organization, you might need a database administrator to complete this step.

[ ]

Export the encryption key for the User Profile service application

The User Profile Service service application requires an encryption key that is stored separately from the database and is needed if you want to upgrade the User Profile Sync database.

Complete this step one time for each User Profile service application in the environment.

[ ]

Restore a backup copy of the databases

Restore the databases from the backup.

Complete this step for each content database and supported service application database in your environment.

This step can take an hour or longer, depending on your dataset and your environment.

Depending on your organization, you might need a database administrator to complete this step.

[ ]

Set the restored databases to be read-write

Before you can attach and upgrade the databases that you copied to the new environment, you must set them to read-write.

Complete this step for each content database and supported service application database in your environment.

Depending on your organization, you might need a database administrator to complete this step.

Detailed steps for this phase: Copy databases to the new farm for upgrade to SharePoint 2013

Upgrade service application databases

Step Notes

[ ]

Start the service application instances

Start the following service instances from Central Administration:

  • Business Data Connectivity service

  • Managed Metadata service

  • PerformancePoint services

  • Secure Store service

  • User Profile service

Start the instance of the Search service application by using Windows PowerShell.

Complete this step one time for the whole environment.

[ ]

Upgrade the Secure Store service application

Use Windows PowerShell to create the new service application and upgrade the database, create a proxy and add it to the default proxy group, and then restore the passphrase from the previous environment.

Complete this step one time for each Secure Store service application in the previous environment.

[ ]

Upgrade the Business Data Connectivity service application

Use Windows PowerShell to create the new service application and upgrade the database. You do not have to create a proxy for the Business Data Connectivity service application.

Note:

The Business Data Connectivity service application is available in both SharePoint Foundation 2013 and SharePoint Server 2013.

Complete this step one time for each Business Data Connectivity service service application in the previous environment.

[ ]

Upgrade the Managed Metadata service application

Use Windows PowerShell to create the new service application and upgrade the database, and then create a proxy and add it to the default proxy group. You must upgrade the Managed Metadata service application before you can upgrade the User Profile service application.

Complete this step one time for each Managed Metadata service application in the previous environment.

[ ]

Upgrade the User Profile service application

Use Windows PowerShell to create the new service application and upgrade the database, and then create a proxy and add it to the default proxy group. After you have created the User Profile service application, you must import the Microsoft Identity Integration Server Key (MIIS) encryption key. Finally, you can start the User Profile Synchronization service.

Complete this step one time for each User Profile service application in the previous environment.

[ ]

Upgrade the PerformancePoint Services service application

Use Windows PowerShell to create the new service application and upgrade the database, and then create a proxy and add it to the default proxy group.

Complete this step one time for each PerformancePoint Services service application in the previous environment.

[ ]

Upgrade the Search service application

Use Windows PowerShell to create the new service application and upgrade the database, and then create a proxy and add it to the default proxy group.

Note:

This step applies to only SharePoint Server 2013. Although SharePoint Foundation 2013 includes search functionality, it is not the same Search service application that is in SharePoint Server 2013 and it cannot be upgraded.

Complete this step one time for each Search service application in the previous environment.

[ ]

Verify that all of the new proxies are in the default proxy group

Use the Get-SPServiceApplicationProxyGroup cmdlet to verify that all of the service application proxies are in the default proxy group.

Complete this step one time for the whole environment.

Detailed steps for this phase: Upgrade service applications to SharePoint 2013.

Create web applications

Step |  | Notes
[ ] | Create and configure web applications Create a web application for each web application that existed in the old environment. | Complete this step one time for the whole environment.
[ ] | Reapply server-side customizations Manually transfer all server-side customizations to your new farm. Refer to the inventory that you created in the upgrade worksheet to make sure that you install all components that your sites depend on to work correctly. When you install solutions, make sure that you add it to the appropriate path (/14 or /15). If you want a solution to be available to both paths, install it two times, and the second time use the CompatibilityLevel parameter when you install it, and it will be installed to the /15 path. | Make sure that you reapply customizations to all web servers in the farm.
[ ] | Verify custom components Use the Test-SPContentDatabase Windows PowerShell cmdlet to verify that you have all the custom components that you need for that database. | Complete this step for each content database in your environment. Running the cmdlet takes only a few minutes, but addressing issues might take longer.

Detailed steps for this phase: Upgrade content databases to SharePoint 2013.

Attach and upgrade content databases

Step Notes

[ ]

Attach a content database to a web application

Attach the content database that contains the root site collection first. For My Sites, attach the content database that contains the My Site host before attaching databases that contain the My Sites.

You must perform this action from the command line. Use the Mount-SPContentDatabaseWindows PowerShell cmdlet.

Complete this step for one content database in your environment.

This step might take several minutes or several hours, depending on your dataset and hardware on the web servers, database servers, and storage subsystem.

[ ]

Verify upgrade for the first database

Verify that upgrade succeeded for the first database, and review the site to see whether there are any issues.

Detailed steps: Verify database upgrades in SharePoint 2013.

Complete this step for the content database that you just attached.

[ ]

Attach remaining databases

Attach and upgrade the remaining content databases in your environment. You must complete this action from the command line.

Complete this step for each of the remaining content databases in your environment.

This step might take several minutes or several hours, depending on your dataset, whether you are upgrading multiple databases in parallel, and the hardware on the web servers, database servers, and storage subsystem.

[ ]

Monitor upgrade progress

Use the Upgrade Status page in the SharePoint Central Administration website to monitor progress as your databases are upgraded.

Detailed steps: Verify database upgrades in SharePoint 2013.

Complete this step for each content database that you upgrade.

This step might take several minutes, an hour, several hours, or days, depending on your content.

[ ]

Verify upgrade for the remaining database

Verify that upgrade succeeded for the remaining databases.

Detailed steps: Verify database upgrades in SharePoint 2013.

Complete this step for each of the remaining content databases in your environment.

This step might take several minutes, an hour, several hours, or days, depending on your content.

Detailed steps for this phase: Upgrade content databases to SharePoint 2013.

Complete post-upgrade steps

Follow these steps in order after you perform a database-attach upgrade.

Post upgrade steps for database attach upgrade

Step |  | Notes
[ ] | Verify that site collections are working as expecting in 2010 mode Review the site collections and make sure that they work in 2010 mode before you begin to upgrade any site collections. You can use a similar review list as the one provided for upgraded sites in Checklists for reviewing upgraded sites | Complete this step one time for your whole environment.
[ ] | Migrate user accounts to claims authentication, if it is necessary By default, new web applications in SharePoint 2013 use claims authentication. If you were using classic authentication in the previous environment, you must migrate the users to claims authentication. For more information, see Migrate from classic-mode to claims-based authentication in SharePoint 2013. | Complete this step one time for every web application that has changed authentication methods.
[ ] | Update links that are used in any upgraded InfoPath form templates For a database-attach upgrade, you exported and imported all InfoPath form templates in your environment when you created the new environment. After upgrade, you can now update the links that are used in those upgraded form templates to point to the correct URLs by using a Windows PowerShell cmdlet. For more information, see Configure InfoPath Forms Services (SharePoint Server 2010). | Complete this step one time for your whole environment.
[ ] | Configure your Search topology The architecture for the Search service has changed for SharePoint Server 2013. Plan and configure your Search topology to suit your environment and the new architecture. For more information, see Scale search for performance and availability in SharePoint Server 2013 and Manage the search topology in SharePoint Server 2013. | Complete this step one time for your whole environment.
[ ] | Start a full crawl After all content is upgraded and all settings are configured, you can start a full search crawl of your content. For more information, see Start, pause, resume, or stop a crawl in SharePoint Server 2013. | Complete this step one time for your whole environment. A full crawl can take several hours or days to complete, depending on how much content is in your environment.
[ ] | Back up your farm Back up your farm so that you have a current backup of your upgraded environment before you start to upgrade site collections. For more information, see Back up farms in SharePoint 2013. | Complete this step one time for your whole environment.

See also

Create the SharePoint 2013 farm for a database attach upgrade
Copy databases to the new farm for upgrade to SharePoint 2013
Upgrade service applications to SharePoint 2013
Upgrade content databases to SharePoint 2013
Overview of the upgrade process to SharePoint 2013
Upgrade site collections to SharePoint 2013
Troubleshoot database upgrade issues in SharePoint 2013


Create the SharePoint 2013 farm for a database attach upgrade
See also

Updated: February 5, 2013

Summary: Create and configure a SharePoint 2013 farm so that you can upgrade databases from SharePoint 2010 Products.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

When you upgrade from SharePoint 2010 Products to SharePoint 2013, you must use a database attach upgrade, which means that you upgrade only the content for your environment and not the configuration settings. Before you can upgrade the content, you must configure a new server or server farm by using SharePoint 2013. This article lists the items that you have to configure when you create that new environment.

Phase 1 of the upgrade process: Create SharePoint 2013 farm

Phase 1 of the upgrade process: Create SharePoint 2013 farm

123 steps

This is the first phase in the process to upgrade SharePoint 2010 Products data and sites to SharePoint 2013. The process includes the following phases that must be completed in order:

  1. Create the SharePoint 2013 farm for a database attach upgrade (this phase)

  2. Copy databases to the new farm for upgrade to SharePoint 2013

  3. Upgrade service applications to SharePoint 2013

  4. Upgrade content databases to SharePoint 2013

  5. Upgrade site collections to SharePoint 2013

For an overview of the whole process, see Overview of the upgrade process to SharePoint 2013 and the Upgrade Process model Download the upgrade process model| Use Zoom.it to view the upgrade process model.

Important:

Although this article applies to both SharePoint Foundation 2013 and SharePoint Server 2013, the following sections apply only to SharePoint Server 2013:

  • The section explains how to export the encryption key for the User Profile service application.

  • The section explains how to configure service applications, except for the Business Data Connectivity service application which applies to SharePoint Foundation 2013 and SharePoint Server 2013.

Watch the SharePoint 2013 Upgrade: Phase 1 video

Video (play button) icon

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you create the SharePoint 2013 farm, review the following information and take any recommended actions.

  • Make sure that the hardware and software that you are using meets the requirements in Hardware and software requirements for SharePoint 2013.

  • Make sure that you have appropriately planned your logical and physical architecture to support the features and functionality that you want in the SharePoint 2013 farm. For more information, see the Architecture design for SharePoint 2013 IT pros Resource Center.

  • Make sure that you have planned for sufficient performance and capacity for the SharePoint 2013 farm. For more information, see Plan for performance and capacity management in SharePoint Server 2013.

  • Ensure that you are prepared to set up the required accounts by using appropriate permissions. For detailed information, see Initial deployment administrative and service accounts in SharePoint 2013.

Collect information and settings

Before you start to upgrade, you must collect information and settings about your existing environment. You have to know what is in your SharePoint 2010 Products environment before you can start to build your SharePoint 2013 environment. Gather information such as the following:

  • Alternate access mappings

  • Authentication providers and authentication modes that are being used

  • Quota templates

  • Managed paths

  • Self-service site management settings

  • Incoming and outgoing e-mail settings

  • Customizations

You can use the Upgrade Planning worksheet to record information and settings about your SharePoint 2010 Products environment.

You also have to turn off or remove services or components in the SharePoint 2010 Products environment that could cause errors in the upgrade process. The following services or components should be removed or stopped before you back up your databases:

  • Web Analytics The architecture for the Web Analytics service application is different in SharePoint 2010 Products. The presence of SharePoint Server 2010 Web Analytics information in your content databases could cause an error during upgrade. Stop the Web Analytics service application before you back up the content databases. Features and web parts from Web Analytics in SharePoint Server 2010 will not exist in SharePoint Server 2013, even for a site collection in 2010 mode. Remove any Web Analytics web parts or features from SharePoint Server 2010site collections before upgrade.

    For more information about this change to Web Analytics, see Changes from SharePoint 2010 to SharePoint 2013.

  • PowerPoint Broadcast Sites The Office Web Apps have changed into a separate server product, Office Web Apps Server, which can serve multiple SharePoint farms for viewing and editing documents. Because of this change, PowerPoint Broadcast sites cannot be upgraded to SharePoint Server 2013. For more information about how to install and use Office Web Apps Server with SharePoint 2013, see Deploy Office Web Apps (Installed on SharePoint 2010 Products).

Record the passphrase for the Secure Store service application

The Secure Store service application uses a passphrase to encrypt information. You have to know what this passphrase is so that you can use it in the new environment. Otherwise, you will not have access to the information in the Secure Store. If you do not know the passphrase, you can refresh the key, and then back up the Secure Store database. For more information, see Working with encryption keys.

Export the encryption key for the User Profile service application

The User Profile Service service application requires an encryption key that is stored separately from the database and is needed if you want to upgrade the User Profile Sync database. You must export the Microsoft Identity Integration Server Key (MIIS) encryption key from your SharePoint Server 2010 environment. You will import this exported key to the SharePoint Server 2013 environment after you upgrade the User Profile service application databases. By default, the key is located on the server that is running SharePoint Server 2010 and that is hosting the Microsoft Forefront Identity Manager services in the following directory: <root directory drive>\Program Files\Microsoft Office Servers\14.0\Synchronization Service\Bin.

Important:

This section applies only to SharePoint Server 2013, not SharePoint Foundation 2013.

To export the encryption key for the User Profile service application

  1. Verify that you have the following memberships:

    • Administrators group on the server on which you are running the command.

  2. Open the Command Prompt window, and then change to the following folder:

    %Program Files%\Microsoft Office Servers\14.0\Synchronization Service\Bin\

  3. To export the key, type the following at the command prompt, and then press ENTER:

    Copy code
    miiskmu.exe

  4. In the Microsoft Identity Integration Server Key Management Utility wizard, verify that Export key set is selected, and then click Next.

  5. In the Account Name box, type the account name for the farm administrator.

  6. In the Password box, type the password for the farm administrator.

  7. In the Domain box, type the domain that contains the farm administrator account, and then click Next.

  8. In the Specify export file name and location box, type or click browse to select the path and file name to use for the exported key, and then click Next.

    The key is exported as a file that has a .BIN file name extension.

  9. Verify the information, and then click Finish.

    A message appears indicating that the key was successfully exported.

  10. Click Close to close the Microsoft Identity Integration Server Key Management Utility.

For more information, see Back up a User Profile Service application (SharePoint Server 2010).

Install SharePoint 2013 in a new environment

Before you can upgrade your databases, you must use SharePoint 2013 to configure a new server or server farm. The first step in creating your new environment is to install SharePoint Server 2013 or SharePoint Foundation 2013 and configure your new server or server farm. You must do the following:

  1. Run the Microsoft SharePoint Products Preparation Tool to install all required software.

  2. Run Setup to install the product.

  3. Install all language packs that you want in your environment.

    Note:

    For more information about how to install available language packs, see Install or uninstall language packs for SharePoint 2013.

  4. Run the SharePoint Products Configuration Wizard to configure your server or servers.

    Important:

    Some service applications can be upgraded by using a service application database upgrade. If you want to upgrade these service applications by upgrading the service application databases, do not use the Farm Configuration Wizard to configure these service applications when you set up your new farm.

For step-by-step instructions for these tasks, see Install SharePoint 2013.

Configure service applications

You must create the service applications on your new farm before you upgrade your content databases. There are some service applications that can be upgraded from SharePoint 2010 Products to SharePoint 2013. The steps in Install SharePoint 2013 describe how to use the Farm Configuration Wizard to enable all service applications. However, you should not use the Farm Configuration Wizard to enable the service applications that you want to upgrade.

The following service applications can be upgraded by performing a services database upgrade:

  • Business Data Connectivity service

  • Managed Metadata service

  • PerformancePoint services

  • Search

  • Secure Store service

  • User Profile service

For an overview of how to upgrade these service applications, see Services upgrade overview for SharePoint Server 2013. The steps that you must follow to upgrade these service application databases are included in the Upgrade service application databases section.

The following services in SharePoint Server 2013 also require additional steps to enable and configure when you upgrade:

  • Excel Services

    You can use the Farm Configuration Wizard to enable this service, but you must make sure that you create all trusted data connections again. For more information, see Configure Excel Services in SharePoint Server 2013.

  • InfoPath Forms Service

    This service is not part of the Farm Configuration Wizard. To use this service, use the Configure InfoPath Forms Services link on the General Application Settings page in Central Administration to configure it. To continue to use form templates from your previous environment, export all administrator-deployed form templates (.xsn files) and data connection files (.udcx files) from your SharePoint Server 2010 environment, and then import them to your new SharePoint Server 2013 environment. For more information, see Configure InfoPath Forms Services (SharePoint Server 2010)

  • Office Web Apps

    Office Web Apps Server is a new stand-alone server product that delivers Office Web Apps functionality on your private network. You install and managed it separately from SharePoint Server 2013. It cannot be installed on the same server or virtual machine instance as SharePoint 2013. For more information, see Deploy Office Web Apps Server 2013.

Configure farm settings

The next step in creating the new environment is to apply general farm settings. You must manually reapply configuration settings from your SharePoint 2010 Products farm, such as the following:

  • Incoming and outgoing e-mail settings

    For more information, see Configure incoming email for a SharePoint 2013 farm and Configure outgoing email for a SharePoint 2013 farm.

  • All farm-level security and permission settings, such as adding user or group accounts to the Farm Administrators group

  • Blocked file types

    For more information, see Manage blocked file types in SharePoint 2013.

And you must configure all new farm-level settings that you want to use, such as the following:

  • Usage and health data collection

    For more information, see Configure usage and health data collection in SharePoint 2013.

  • Diagnostic logging

    For more information, see Configure diagnostic logging in SharePoint 2013.

  • Settings and schedules for timer jobs

Important:

If you had disabled the Workflow Auto Cleanup timer job in your SharePoint 2010 Products environment, make sure that you disable this timer job in your new environment also. If this timer job is enabled in the new environment and disabled in the SharePoint 2010 Products environment, you might lose workflow associations when you upgrade. For more information about this timer job, see Disable preservation of workflow history (SharePoint Server 2010).

In a standard installation, the next step would be to create web applications. However, for upgrade, you create web applications later in the process, after you upgrade the service application databases. For more information, see Create web applications.

123 steps

This is the first phase in the process to upgrade SharePoint 2010 Products data and sites to SharePoint 2013.

  • Next phase: Copy databases to the new farm for upgrade to SharePoint 2013

For an overview of the whole process, see Overview of the upgrade process to SharePoint 2013.

See also

Copy databases to the new farm for upgrade to SharePoint 2013
Upgrade service applications to SharePoint 2013
Upgrade content databases to SharePoint 2013
Checklist for database-attach upgrade (SharePoint 2013)
Services upgrade overview for SharePoint Server 2013
Upgrade farms that share services (parent and child farms) to SharePoint 2013
Troubleshoot database upgrade issues in SharePoint 2013

Upgrade and Migration Resource Center for SharePoint 2013 Products

Change History

Date | Description
February 05, 2013 | Added conceptual video to illustrate steps in upgrade.
November 27, 2012 | Initial publication


Copy databases to the new farm for upgrade to SharePoint 2013
See also

Updated: April 9, 2013

Summary: Copy SharePoint 2010 Products content and service databases to a SharePoint 2013 farm so that you can upgrade the data to SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

When you upgrade from SharePoint 2010 Products to SharePoint 2013, you must use a database attach upgrade, which means that you upgrade only the content for your environment and not the configuration settings. After you have configured a new SharePoint 2013 environment, you can copy the content and service application databases from the SharePoint 2010 Products environment to the SharePoint 2013 environment. You use a backup and restore process to copy the database, and you can also choose to set the databases to read-only in the SharePoint 2010 Products environment so that users can continue to access their information, but not change it. This article contains the steps that you take to copy the databases.

Phase 2 of the upgrade process: Copy databases to the new farm

Phase 2 of the upgrade process: Copy databases to the new farm

123 steps

This is the second phase in the process to upgrade SharePoint 2010 Products data and sites to SharePoint 2013. The process includes the following phases that must be completed in order:

  1. Create the SharePoint 2013 farm for a database attach upgrade

  2. Copy databases to the new farm for upgrade to SharePoint 2013 (this phase)

  3. Upgrade service applications to SharePoint 2013

  4. Upgrade content databases to SharePoint 2013

  5. Upgrade site collections to SharePoint 2013

For an overview of the whole process, see Overview of the upgrade process to SharePoint 2013 and the Upgrade Process model Download the upgrade process model| Use Zoom.it to view the upgrade process model.

Important:

Although this article applies to both SharePoint Foundation 2013 and SharePoint Server 2013, the sections about how to back up and restore service application databases apply only to SharePoint Server 2013. (The exception is the section about the Business Data Connectivity service application which applies to SharePoint Foundation 2013 and SharePoint Server 2013).

Watch the SharePoint 2013 Upgrade: Phase 2 video

Video (play button) icon

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you copy the databases, review the following information and take any recommended actions.

  • Make sure that the account that you use to copy the databases has access to SQL Server Management Studio on both the SharePoint 2010 Products and SharePoint 2013 environments and has access to a network location that can be accessed from both environments to store the copies of the databases.

  • Make sure that the account that you use to set the databases to read-only and read-write is a member of the db_owner fixed database role for the content databases that you want to upgrade.

  • Before you back up the databases, check for and repair all database consistency errors.

    For more information, see Database maintenance for SharePoint Server 2010.

  • Make sure that the appropriate service pack or update is applied to your 2010 environment. If you are using remote blog storage (RBS) in your environment, you must be running Service Pack 1 for SharePoint 2010 Products in your environment before you start the upgrade process.

Set the earlier version databases to be read-only

To maintain user access to your original environment, set the SharePoint 2010 Products databases to read-only before you back up the databases. Even if you don't want to maintain access over the long term, set the databases to read-only to make sure that you capture all the data in the backup so that you restore and upgrade the current state of the environment without allowing additional changes to be made. If the databases are set to read-only, users can continue to view content. However, they will be unable to add or change content.

Important:

Perform this step in the SharePoint 2010 Products environment.

To set a database to read-only by using SQL Server tools

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role for the databases.

  2. In SQL Server Management Studio, in Object Explorer, connect to an instance of the Database Engine, expand the server, and then expand Databases.

  3. Find the database that you want to configure to be read-only, right-click the database, and then click Properties.

  4. In the Database Properties dialog box, in the Select a page section, click Options.

  5. In the details pane, under Other options, in the State section, next to Database Read-Only, click the arrow, and then select True.

You can use Transact-SQL to configure the READ_ONLY database availability option. For more information about how to use the SET clause of the ALTER DATABASE statement, see Setting Database Options.

Back up the SharePoint 2010 Products databases by using SQL Server tools

You back up the databases in SQL Server Management Studio. A backup copy of the database guarantees that you have the data in a safe state if you must enable the original farm again and is required for a database-attach upgrade. Repeat the procedure for the following databases in the SharePoint 2010 Products server farm:

  • All content databases (default database name: WSS_Content_ID

  • The following service application databases:

    Service application Default database name

    Business Data Connectivity

    BDC_Service_DB_ID

    Managed Metadata

    Managed Metadata Service_ID

    PerformancePoint

    PerformancePoint Service Application_ID

    Search Administration

    Search_Service_Application_DB_ID

    Secure Store

    Secure_Store_Service_DB_ID

    User Profile: Profile, Social, and Sync databases

    User Profile Service Application_ProfileDB_ID

    User Profile Service Application_SocialDB_ID

    User Profile Service Application_SyncDB_ID

    The Business Data Connectivity service application is available in both SharePoint Foundation 2010 and SharePoint Server 2010. The other service applications are available only in SharePoint Server 2010. Although SharePoint Foundation 2010 includes search functionality, it is not the same Search service application that is in SharePoint Server 2010 and it cannot be upgraded.

You do not have to back up the configuration or admin content databases, because you recreated these databases when you set up the SharePoint 2013 server farm. Upgrading the configuration or admin content databases and the Central Administration site collection is not supported.

After you complete this procedure, you will have created backups of the read-only content databases.

Important:

Perform this step in the SharePoint 2010 Products environment.

To back up a database by using SQL Server tools

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role for the databases.

  2. In Management Studio, in Object Explorer, connect to an instance of the Database Engine, expand the server, and then expand Databases.

  3. Right-click the database that you want to back up, point to Tasks, and then click Back Up.

    The Back Up Database dialog box appears.

  4. In the Source area, in the Database box, verify the database name.

  5. In the Backup type box, select Full.

  6. Under Backup component, select Database.

  7. In the Backup set area, in the Name box, either accept the backup set name that is suggested or type a different name for the backup set.

  8. In the Destination area, specify the type of backup destination by selecting Disk or Tape, and then specify a destination. To create a different destination, click Add.

  9. Click OK to start the backup process.

Repeat the previous procedure to back up all the content and appropriate service application databases that SharePoint 2010 Products uses in your environment.

Important:

Before you can back up the Search service application Administration database, you must stop the Search service on your SharePoint Server 2010 farm. To stop the Search service, on the original farm, on the Start menu, click Administrative Tools, and then click Services. Right-click SharePoint Server Search 14, and then click Stop. Be sure to start the service again after you back up the database.

Copy the backup files to the SharePoint 2013 environment

Copy the backup files that you created in the previous procedure from the SharePoint 2010 Products environment to the SharePoint 2013 environment.

Restore a backup copy of the database

After you configure the new SharePoint 2013 server farm, you can restore the backup copies of the databases to SQL Server. Start with one database, and then verify that the restoration has worked before you restore the other databases.

Important:

Be sure to keep a copy of your original backups in reserve, just in case upgrade fails and you have to troubleshoot and try again.

Perform this step in the SharePoint 2013 environment.

To restore a backup copy of a database by using SQL Server tools

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role for the databases.

  2. After you connect to the appropriate instance of the SQL Server 2008 Database Engine, in Object Explorer, expand the server name.

  3. Right-click Databases, and then click Restore Database.

    The Restore Database dialog box appears.

  4. In the Restore Database dialog box, on the General page, type the name of the database to be restored in the To database list.

    Tip:

    When you type the name for the restored database, you do not have to use the original name. If you want to change the database name from a name with a long GUID to a shorter, friendlier name, this is an opportunity to make that change. Be sure to also change the database and log file names in the file system (the MDF and LDF files) so that they match.

  5. In the To a point in time text box, keep the default (Most recent possible).

  6. To specify the source and location of the backup sets to restore, click From device, and then use the ellipsis (...) to select the backup file.

  7. In the Specify Backup dialog box, in the Backup media box, be sure that File is selected.

  8. In the Backup location area, click Add.

  9. In the Locate Backup File dialog box, select the file that you want to restore, click OK, and then, in the Specify Backup dialog box, click OK.

  10. In the Restore Database dialog box, under Select the backup sets to restore grid, select the Restore check box next to the most recent full backup.

  11. In the Restore Database dialog box, on the Options page, under Restore options, select the Overwrite the existing database check box.

  12. Click OK to start the restore process.

Set the databases to read-write

You cannot upgrade a database that is set to read-only. You must set the databases back to read-write on your SharePoint 2013 farm before you attach and upgrade them.

Important:

Perform this step in the SharePoint 2013 environment.

To set a database to read-write by using SQL Server tools

  1. In SQL Server Management Studio, in Object Explorer, connect to an instance of the Database Engine, expand the server, and then expand Databases.

  2. Select the database that you want to configure to be read-write, right-click the database, and then click Properties.

  3. In the Database Properties dialog box, in the Select a page section, click Options.

  4. In the details pane, under Other options, in the State section, next to Database Read-Only, click the arrow, and then select False.

123 steps

This is the second phase in the process to upgrade SharePoint 2010 Products data and sites to SharePoint 2013.

  • Next phase: Upgrade service applications to SharePoint 2013

For an overview of the whole process, see Overview of the upgrade process to SharePoint 2013.

See also

Create the SharePoint 2013 farm for a database attach upgrade
Upgrade service applications to SharePoint 2013
Upgrade content databases to SharePoint 2013
Checklist for database-attach upgrade (SharePoint 2013)
Services upgrade overview for SharePoint Server 2013
Upgrade farms that share services (parent and child farms) to SharePoint 2013
Troubleshoot database upgrade issues in SharePoint 2013

Upgrade and Migration Resource Center for SharePoint 2013 Products

Change History

Date | Description
April 09, 2013 | Added a note to make sure that the appropriate patch levels are applied to the SharePoint 2010 farm before you perform an upgrade to SharePoint 2013.
February 05, 2013 | Added conceptual video to illustrate steps in upgrade.
November 27, 2012 | Initial publication


Upgrade service applications to SharePoint 2013
See also

Updated: February 5, 2013

Summary: Upgrade service applications (Business Connectivity Services, Managed Metadata, Secure Store, User Profiles, Search) to SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

When you upgrade from SharePoint 2010 Products to SharePoint 2013, you must use a database attach upgrade, which means that you upgrade only the content for your environment and not the configuration settings. After you have configured the SharePoint 2013 environment, and copied the content and service application databases, you can upgrade the service applications to SharePoint 2013. This article contains the steps that you take to upgrade the service applications.

Phase 3 of the upgrade process: Upgrade service applications

Phase 3 of the upgrade process: Upgrade service applications

123 steps

This is the third phase in the process to upgrade SharePoint 2010 Products data and sites to SharePoint 2013. The process includes the following phases that must be completed in order:

  1. Create the SharePoint 2013 farm for a database attach upgrade

  2. Copy databases to the new farm for upgrade to SharePoint 2013

  3. Upgrade service applications to SharePoint 2013 (this phase)

  4. Upgrade content databases to SharePoint 2013

  5. Upgrade site collections to SharePoint 2013

For an overview of the whole process, see Overview of the upgrade process to SharePoint 2013 and the Upgrade Process model Download the upgrade process model| Use Zoom.it to view the upgrade process model.

Important:

Although this article applies to both SharePoint Foundation 2013 and SharePoint Server 2013, the sections about how to upgrade service applications apply only to SharePoint Server 2013. (The exception is the section about how to upgrade the Business Data Connectivity service application which applies to SharePoint Foundation 2013 and SharePoint Server 2013).

Watch the SharePoint 2013 Upgrade: Phase 3 video

Video (play button) icon

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you create the SharePoint 2013 farm, review the following information and take any recommended actions.

  • Make sure that you have configured a SharePoint 2013 farm, recorded the Secure Store passphrase, and backed up the User Profile Synchronization encryption key. For more information, see Create the SharePoint 2013 farm for a database attach upgrade.

  • Make sure that the account that you use to perform the steps in this article is a member of the Farm administrators group in Central Administration.

  • Decide which service application pool to use for the upgraded service applications. The procedures below use the default application pool for service applications which is "SharePoint Web Services Default". You can view a list of available service application pools by using the Get-SPServiceApplicationPool cmdlet in Windows PowerShell. Or you can create a service application pool by using the New-SPServiceApplicationPool cmdlet. For more information, see Get-SPServiceApplicationPool and New-SPServiceApplicationPool.

Tip:

Throughout this article, variables (such as $applicationPool, $sss, $upa, and so on) are used in the Windows PowerShell cmdlets to save time and effort. You do not have to use these variables if you would prefer not to. However, if you do not use these variables, you must use IDs for the service applications and service application proxies when you specify the identity parameters. Each procedure has information about the variables used, or the alternate cmdlets to use to look up any IDs that are required.

Also, many procedures in this article include a step to set the $applicationPool variable. If you are performing all of these procedures in the same session of Windows PowerShell, and you want to use the same application pool for all service applications, you do not have to repeat this step in each procedure. Instead, you can set this variable once at the beginning and use it throughout the procedures in this article.

About upgrading the service application databases

To upgrade a service application database, you create a new service application and provide the name of the existing database to use for the new service application. As the service application is created, the database is upgraded. This process has several steps.

  1. Start the service instances

    The first step is to start service instances for the five service applications that you can upgrade: the Business Data Connectivity service, Managed Metadata Web Service, PerformancePoint Services service, Secure Store service, User Profile service, and Search service. Most of these service instances can be started from Central Administration. However the SharePoint Server Search service instance must be started by using Windows PowerShell.

  2. Create the service applications and upgrade the databases

    After you have started the service instances, the next step is to create the service applications and upgrade the databases. You must use Windows PowerShell to restore the service application databases.

  3. Create proxies for the service applications

    After you have upgraded the service application databases, you create the proxies for the service applications and add them to the default proxy group. You must create proxies for the following service applications:

    • Managed Metadata service application

    • Search service application

    • Secure Store service application

    • PerformancePoint Services service application

    • User Profile service application

    The Business Data Connectivity service application automatically creates a proxy and assigns it to the default proxy group when you create the service application.

  4. Verify that the proxies are in the default group

The following sections provide procedures to complete these steps.

Note:

The Business Data Connectivity service application is available for upgrade both from SharePoint Foundation 2010 to SharePoint Foundation 2013 and SharePoint Server 2010 to SharePoint Server 2013. The other service applications are available for upgrade only from SharePoint Server 2010 to SharePoint Server 2013. Although SharePoint Foundation 2013 includes search functionality, it is not the same Search service application that is in SharePoint Server 2013 and it cannot be upgraded.

Start the service instances

The following procedures start the service instances.

To start service application instances from Central Administration

  1. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. In SharePoint 2013 Central Administration, on the Application Management page, in the Service Applications section, click Manage Services on Server.

  3. Next to the Business Data Connectivity service, click Start.

  4. Next to the Managed Metadata Web Service, click Start.

  5. Next to the PerformancePoint Services service, click Start.

  6. Next to the Secure Store Service, click Start.

  7. Next to the User Profile Service, click Start.

The Search service instance must be started by using Windows PowerShell because you cannot start it from Central Administration unless a Search Service application already exists.

To start the Search service instance by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To start the Search service instance, at the Windows PowerShell command prompt, type the following commands and press ENTER after each one:

    Copy code
    $SearchInst = Get-SPEnterpriseSearchServiceInstance
# Stores the identity for the Search service instance on this server as a variable
Start-SPServiceInstance $SearchInst
# Starts the service instance

For more information, see Get-SPEnterpriseSearchServiceInstance and Start-SPServiceInstance.

Upgrade the Secure Store service application

To upgrade the Secure Store service application, you create the new service application and upgrade the database, create a proxy and add it to the default proxy group, and then restore the passphrase from the previous environment.

To upgrade the Secure Store service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To store the application pool that you want to use as a variable for this service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $applicationPool = Get-SPServiceApplicationPool -Identity 'SharePoint Web Services default'

    Where:

    • SharePoint Web Services default is the name of the service application pool that will contain the new service applications. This is the default service application pool. You can specify a different service application pool.

    This cmdlet sets the service application pool as a variable that you can use again in the cmdlets that follow. If you have multiple application pools and have to use a different application pool for a particular service application, repeat this step in the procedure to create each service application to use the appropriate application pool.

  4. To upgrade the Secure Store service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $sss = New-SPSecureStoreServiceApplication -Name 'Secure Store' -ApplicationPool $applicationPool -DatabaseName 'SecureStore_Upgrade_DB' -AuditingEnabled

    Where:

    • SecureStore is the name that you want to give the new Secure Store service application.

    • $applicationpool is the variable that you set earlier to identify the service application pool to use.

      Tip:

      If you do not use the variable $applicationPool, then you must specify the name of an existing service application pool in the format 'Application Pool Name'. To view a list of service application pools, you can run the Get-SPServiceApplicationPool cmdlet.

    • SecureStore_Upgrade_DB is the name of the service application database that you want to upgrade.

    This command sets a variable, $sss, that you use when you create the proxy later.

    For more information, see New-SPSecureStoreApplication.

  5. Type the following command to create a proxy for the Secure Store service application:

    Copy code
    $sssp = New-SPSecureStoreServiceApplicationProxy -Name ProxyName -ServiceApplication $sss -DefaultProxyGroup

    Where:

    • ProxyName is the proxy name that you want to use.

    • $sss is the variable that you set earlier to identify the new Secure Store service application.

      Tip:

      If you do not use the variable $sss, then you must use an ID to identify the Secure Store service application instead of a name. To find the ID, you can run the Get-SPServiceApplication cmdlet to return a list of all service application IDs.

    • DefaultProxyGroup adds the Secure Store service application proxy to the default proxy group for the local farm.

    This command sets a variable, $sssp, for the service application proxy that you use when you restore the passphrase.

    For more information, see New-SPSecureStoreServiceApplicationProxy.

    After you create the Secure Store service application and the proxy, you have to refresh the encryption key. For information about how to refresh the encryption key, see Refresh the encryption key.

  6. Type the following command to restore the passphrase for the Secure Store service application:

    Copy code
    Update-SPSecureStoreApplicationServerKey -Passphrase <Passphrase> -ServiceApplicationProxy $sssp

    Where:

    • <Passphrase> is the Passphrase for the Secure Store service application from your previous environment.

    • $sssp is a variable that you set earlier to identify the new Secure Store service application proxy.

      Tip:

      If you do not use the variable $sssp, then you must use an ID to identify the Secure Store service application proxy instead of a name. To find the ID, you can run the Get-SPServiceApplicationProxy cmdlet to return a list of all service application proxy IDs.

    For more information, see Update-SPSecureStoreApplicationServerKey.

Upgrade the Business Data Connectivity service application

To upgrade the Business Data Connectivity service application, you create the new service application and upgrade the database. You do not have to create a proxy for the Business Data Connectivity service application. The Business Data Connectivity service application automatically creates a proxy and assigns it to the default proxy group when you create the service application.

Note:

The Business Data Connectivity service application is available in both SharePoint Foundation 2013 and SharePoint Server 2013.

To upgrade the Business Data Connectivity service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To store the application pool that you want to use as a variable for this service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $applicationPool = Get-SPServiceApplicationPool -Identity 'SharePoint Web Services default'

    Where:

    • SharePoint Web Services default is the name of the service application pool that will contain the new service applications.

    This cmdlet sets the service application pool as a variable that you can use again in the cmdlets that follow. If you have multiple application pools and have to use a different application pool for a particular service application, repeat this step in the procedure to create each service application to use the appropriate application pool.

  4. To upgrade the Business Data Connectivity service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SPBusinessDataCatalogServiceApplication -Name 'BDC Service' -ApplicationPool $applicationPool -DatabaseName 'BDC_Service_DB'

    Where:

    • BDC Service is the name that you want to give the new Business Data Connectivity service application.

    • $applicationpool is the variable that you set earlier to identify the service application pool to use.

      Tip:

      If you do not use the variable $applicationPool, then you must specify the name of an existing service application pool in the format 'Application Pool Name'. To view a list of service application pools, you can run the Get-SPServiceApplicationPool cmdlet.

    • BDC_Service_DB is name of the service application database that you want to upgrade.

    For more information, see New-SPBusinessDataCatalogServiceApplication.

Upgrade the Managed Metadata service application

To upgrade the Managed Metadata service application, you create the new service application and upgrade the database, and then create a proxy and add it to the default proxy group. You must upgrade the Managed Metadata service application before you can upgrade the User Profile service application.

To upgrade the Managed Metadata service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To store the application pool that you want to use as a variable for this service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $applicationPool = Get-SPServiceApplicationPool -Identity 'SharePoint Web Services default'

    Where:

    • SharePoint Web Services default is the name of the service application pool that will contain the new service applications.

    This cmdlet sets the service application pool as a variable that you can use again in the cmdlets that follow. If you have multiple application pools and have to use a different application pool for a particular service application, repeat this step in the procedure to create each service application to use the appropriate application pool.

  4. To upgrade the Managed Metadata service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $mms = New-SPMetadataServiceApplication -Name 'Managed Metadata Service Application' -ApplicationPool $applicationPool -DatabaseName 'Managed Metadata Service_DB'

    Where:

    • Managed Metadata Service Application is the name that you want to give the new Managed Metadata service application.

    • $applicationpool is the variable that you set earlier to identify the service application pool to use.

      Tip:

      If you do not use the variable $applicationPool, then you must specify the name of an existing service application pool in the format 'Application Pool Name'. To view a list of service application pools, you can run the Get-SPServiceApplicationPool cmdlet.

    • Managed Metadata Service_DB is name of the service application database that you want to upgrade.

    This command sets a variable, $mms, that you use when you create the proxy later.

    For more information, see New-SPMetadataServiceApplication.

  5. At the Windows PowerShell command prompt, type the following command to create a proxy for the Managed Metadata service application:

    Copy code
    New-SPMetadataServiceApplicationProxy -Name ProxyName -ServiceApplication $mms -DefaultProxyGroup

    Where:

    • ProxyName is the proxy name that you want to use.

    • $mms is the variable that you set earlier to identify the new Managed Metadata service application.

      Tip:

      If you do not use the variable $mms, then you must use an ID to identify the Managed Metadata service application proxy instead of a name. To find the ID, you can run the Get-SPServiceApplication cmdlet to return a list of all service application IDs.

    • DefaultProxyGroup adds the Managed Metadata service application proxy to the default proxy group for the local farm.

    For more information, see New-SPMetadataServiceApplicationProxy.

Upgrade the User Profile service application

To upgrade the User Profile service application, you create the new service application and upgrade the database, and then create a proxy and add it to the default proxy group and then start the User Profile Synchronization service. After you have created the User Profile Service service application, you must import the Microsoft Identity Integration Server Key (MIIS) encryption key.

Note:

You must upgrade the Managed Metadata service application before you can upgrade the User Profile service application.

To upgrade the User Profile service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To store the application pool that you want to use as a variable for this service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $applicationPool = Get-SPServiceApplicationPool -Identity 'SharePoint Web Services default'

    Where:

    • SharePoint Web Services default is the name of the service application pool that will contain the new service applications.

    This cmdlet sets the service application pool as a variable that you can use again in the cmdlets that follow. If you have multiple application pools and have to use a different application pool for a particular service application, repeat this step in the procedure to create each service application to use the appropriate application pool.

  4. To upgrade the User Profile service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $upa = New-SPProfileServiceApplication -Name 'User Profile Service Application' -ApplicationPool $applicationPool -ProfileDBName 'User Profile Service Application_ProfileDB' -SocialDBName 'User Profile Service Application_SocialDB'
-ProfileSyncDBName 'User Profile Service Application_SyncDB'

    Where:

    • User Profile Service Application is the name that you want to give the new User Profile service application.

    • $applicationpool is the variable that you set earlier to identify the service application pool to use.

      Tip:

      If you do not use the variable $applicationPool, then you must specify the name of an existing service application pool in the format 'Application Pool Name'. To view a list of service application pools, you can run the Get-SPServiceApplicationPool cmdlet.

    • User Profile Service Application_ProfileDB is name of the User Profile service application Profile database that you want to upgrade.

    • User Profile Service Application_SocialDB is name of the User Profile service application Social database that you want to upgrade.

    • User Profile Service Application_SyncDB is name of the User Profile service application Sync database that you want to upgrade.

    Note:

    The SocialDBName and ProfileSyncDBName parameters are optional. Use these parameters if you have Social and Sync databases that you want to upgrade. If you do not specify these parameters, new Social and Sync databases are created for you.

    This command sets a variable, $upa, that you use when you create the proxy later.

    For more information, see New-SPProfileServiceApplication.

  5. Type the following command to create a proxy for the User Profile service application:

    Copy code
    New-SPProfileServiceApplicationProxy -Name ProxyName -ServiceApplication $upa -DefaultProxyGroup

    Where:

    • ProxyName is the proxy name that you want to use.

    • $upa is the variable that you set earlier to identify the new User Profile service application.

      Tip:

      If you do not use the variable $upa, then you must use an ID to identify the User Profile service application instead of a name. To find the ID, you can run the Get-SPServiceApplication cmdlet to return a list of all service application IDs.

    • DefaultProxyGroup adds the User Profile service application proxy to the default proxy group for the local farm.

    For more information, see New-SPProfileServiceApplicationProxy.

After you have created the User Profile Service service application, you can start the User Profile Synchronization service.

Start the User Profile Synchronization service

  1. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. In Central Administration, on the System Settings page, under Servers click Manage services on Server.

  3. Next to the User Profile Synchronization Service, click Start.

  4. In the Select the User Profile Application section, select the User Profile service application that you upgraded.

  5. In the Service Account Name and Password section, type the account name and password to use for the User Profile Synchronization service.

After you have started the User Profile Synchronization service, you must import the Microsoft Identity Integration Server Key (MIIS) encryption key. Import this key to the following directory: <root directory drive>\Program Files\Microsoft Office Servers\15.0\Synchronization Service\Bin.

To import the encryption key for User Profile service application

  1. Verify that you have the following memberships:

    • Administrators group on the server on which you are running the command.

  2. Open the Command Prompt window, and then change to the following folder:

    %Program Files%\Microsoft Office Servers\15.0\Synchronization Service\Bin\

  3. To import the key, type the following at the command prompt, and then press ENTER:

    Copy code
    miiskmu.exe /i Path {0E19E162-827E-4077-82D4-E6ABD531636E}

    Where:

    • Path is the path and file name for the key that you want to import.

      You might also have to enter a user name and password. These are the credentials for the farm administrator.

    Important:

    Use the GUID as specified. This GUID is fixed.

For more information, see Install a software update (SharePoint Server 2010).

Upgrade the PerformancePoint Services service application

To upgrade the PerformancePoint Services service application, you create the new service application and upgrade the database, and then create a proxy and add it to the default proxy group.

To upgrade the PerformancePoint Services service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To store the application pool that you want to use as a variable for this service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $applicationPool = Get-SPServiceApplicationPool -Identity 'SharePoint Web Services default'

    Where:

    • SharePoint Web Services default is the name of the service application pool that will contain the new service applications.

    This cmdlet sets the service application pool as a variable that you can use again in the cmdlets that follow. If you have multiple application pools and have to use a different application pool for a particular service application, repeat this step in the procedure to create each service application to use the appropriate application pool.

  4. To upgrade the PerformancePoint Services service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $pps = New-SPPerformancePointServiceApplication -Name 'PerformancePoint Service' -ApplicationPool $applicationPool -DatabaseName 'PerformancePoint Service Application_DB'

    Where:

    • PerformancePoint Service is the name that you want to give the new PerformancePoint Services service application.

    • $applicationpool is the variable that you set earlier to identify the service application pool to use.

      Tip:

      If you do not use the variable $applicationPool, then you must specify the name of an existing service application pool in the format 'Application Pool Name'. To view a list of service application pools, you can run the Get-SPServiceApplicationPool cmdlet.

    • PerformancePoint Service Application_DB is name of the PerformancePoint Services service application database that you want to upgrade.

    This command sets a variable, $pps, that you use when you create the proxy later.

    For more information, see New-SPProfileServiceApplication.

  5. Type the following command to create a proxy for the PerformancePoint Services service application:

    Copy code
    New-SPPerformancePointServiceApplicationProxy -Name ProxyName -ServiceApplication $pps -Default

    Where:

    • ProxyName is the proxy name that you want to use.

    • $pps is the variable that you set earlier to identify the new PerformancePoint Services service application.

      Tip:

      If you do not use the variable $pps, then you must use an ID to identify the PerformancePoint Services service application instead of a name. To find the ID, you can run the Get-SPServiceApplication cmdlet to return a list of all service application IDs.

    • Default adds the PerformancePoint Services service application proxy to the default proxy group for the local farm.

    For more information, see New-SPPerformancePointServiceApplicationProxy.

Upgrade the Search service application

To upgrade the Search service application, you create the new service application and upgrade the database, and then create a proxy and add it to the default proxy group.

Note:

This section applies to only SharePoint Server 2013. Although SharePoint Foundation 2013 includes search functionality, it is not the same Search service application that is in SharePoint Server 2013 and it cannot be upgraded.

To upgrade the Search service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To store the application pool that you want to use as a variable for this service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $applicationPool = Get-SPServiceApplicationPool -Identity 'SharePoint Web Services default'

    Where:

    • SharePoint Web Services default is the name of the service application pool that will contain the new service applications.

    This cmdlet sets the service application pool as a variable that you can use again in the cmdlets that follow. If you have multiple application pools and have to use a different application pool for a particular service application, repeat this step in the procedure to create each service application to use the appropriate application pool.

  4. To upgrade the Search service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $searchInst = Get-SPEnterpriseSearchServiceInstance -local
# Gets the Search service instance and sets a variable to use in the next command

Restore-SPEnterpriseSearchServiceApplication -Name '<SearchServiceApplicationName>' -applicationpool $applicationPool -databasename '<SearchServiceApplicationDBName>' -databaseserver <ServerName> -AdminSearchServiceInstance $searchInst

    Where:

    • SearchServiceApplicationName is the name of the Search service application.

    • $applicationpool is the variable that you set earlier to identify the service application pool to use.

      Tip:

      If you do not use the variable $applicationPool, then you must specify the name of an existing service application pool in the format 'Application Pool Name'. To view a list of service application pools, you can run the Get-SPServiceApplicationPool cmdlet.

    • SearchServiceApplicationDBName is the name of the Search service application Administration database that you want to upgrade.

    • $searchInst is the variable that you set to identify the new Search Service application instance.

    Note:

    A Search service application upgrade might fail because of an issue that occurs during upgrade, such as network or SQL Server latency. If an error message appears during the Search service application upgrade, do the following:

    1. Delete the Search Administration database that you were trying to upgrade.

    2. Using the backup copy that you made of the Search Administration database, repeat the following procedures in this article for the Search service application only:

      1. Restore a backup copy of the database

      2. Set the databases to read-write

    3. Upgrade the Search service application by typing the command again at the Windows PowerShell command prompt.

    For more information, see Restore-SPEnterpriseSearchServiceApplication.

    You must follow several steps to create the Search service application proxy and add it to the default proxy group. You must complete separate actions to find the ID for the Search service application, create the new proxy, get the proxy ID, and then add the proxy to the default proxy group.

  5. Type the following command to get the ID for the Search service application and store it as a variable:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication

    For more information, see Get-SPEnterpriseSearchServiceApplication.

  6. Type the following command to create a proxy for the Search service application:

    Copy code
    New-SPEnterpriseSearchServiceApplicationProxy -Name ProxyName -SearchApplication $ssa

    Where:

    • ProxyName is the proxy name that you want to use.

    • $ssa is the variable that you set earlier to identify the new Search service application.

      Tip:

      If you do not use the variable $ssa, then you must use an ID to identify the Search service application instead of a name. To find the ID, you can run the Get-SPServiceApplication cmdlet to return a list of all service application IDs.

    For more information, see New-SPEnterpriseSearchServiceApplicationProxy.

  7. Type the following command to get the Search service application proxy ID for the proxy you just created and set it as the variable $ssap:

    Copy code
    $ssap = Get-SPEnterpriseSearchServiceApplicationProxy

    For more information, see Get-SPEnterpriseSearchServiceApplicationProxy.

  8. Type the following command to add the Search service application proxy to the default proxy group:

    Copy code
    Add-SPServiceApplicationProxyGroupMember -member $ssap -identity " "

    Where:

    • $ssap is the variable that you set earlier to identify the ID for the proxy you just created for the Search service application.

      Tip:

      If you do not use the variable $ssap, then you must use an ID to identify the Search service application proxy instead of a name. To find the ID, you can run the Get-SPServiceApplicationProxy cmdlet to return a list of all service application proxy IDs.

    • You use an empty identity parameter (" ") to add it to the default group.

    For more information, see Add-SPServiceApplicationProxyGroupMember.

Verify that all of the new proxies are in the default proxy group

Use the following procedure to verify that the steps to create the proxies and add them to the default proxy group worked.

To verify that all of the new proxies are in the default proxy group by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $pg = Get-SPServiceApplicationProxyGroup -Identity " "
$pg.Proxies

    Where:

    • $pg is a variable you set to represent the default proxy group.

    • You use an empty identity parameter (" ") to specify the default proxy group.

    This returns a list of all proxies in the default proxy group, their display names, type names, and IDs.

For more information, see Get-SPServiceApplicationProxyGroup.

Now that the service applications are upgraded, you can start the process to upgrade the content databases. The first step in that process is to create the web applications that are needed for each content database.

123 steps

This is the third phase in the process to upgrade SharePoint 2010 Products data and sites to SharePoint 2013.

  • Next phase: Upgrade content databases to SharePoint 2013

For an overview of the whole process, see Overview of the upgrade process to SharePoint 2013.

See also

Create the SharePoint 2013 farm for a database attach upgrade
Copy databases to the new farm for upgrade to SharePoint 2013
Upgrade content databases to SharePoint 2013
Checklist for database-attach upgrade (SharePoint 2013)
Services upgrade overview for SharePoint Server 2013
Upgrade farms that share services (parent and child farms) to SharePoint 2013
Troubleshoot database upgrade issues in SharePoint 2013

Upgrade and Migration Resource Center for SharePoint 2013 Products

Change History

Date | Description
February 05, 2013 | Added conceptual video to illustrate steps in upgrade. Changed order of steps to turn on Profile Sync after upgrade.
November 27, 2012 | Initial publication


Upgrade content databases to SharePoint 2013
See also

Summary: Learn how to upgrade content databases from SharePoint 2010 Products to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

When you upgrade from SharePoint 2010 Products to SharePoint 2013, you must use a database attach upgrade, which means that you upgrade only the content for your environment and not the configuration settings. After you have configured the SharePoint 2013 environment, copied the content and service application databases, and upgraded the service applications, you can attach and upgrade the content databases to SharePoint 2013. This article explains the steps you take to attach and upgrade the content databases to SharePoint 2013.

This article does not provide steps for how to upgrade a site collection. The process to upgrade site collections is separate from the process for upgrading the databases. For steps to upgrade a site collection, see Upgrade site collections to SharePoint 2013.

Phase 4 of the upgrade process: Upgrade content databases

Phase 4 of the upgrade process: Upgrade content databases

123 steps

This is the fourth phase in the process to upgrade SharePoint 2010 Products data and sites to SharePoint 2013. The process includes the following phases that must be completed in order:

  1. Create the SharePoint 2013 farm for a database attach upgrade

  2. Copy databases to the new farm for upgrade to SharePoint 2013

  3. Upgrade service applications to SharePoint 2013

  4. Upgrade content databases to SharePoint 2013 (this phase)

  5. Upgrade site collections to SharePoint 2013

For an overview of the whole process, see Overview of the upgrade process to SharePoint 2013 and the Upgrade Process model Download the upgrade process model| Use Zoom.it to view the upgrade process model.

Important:

This article applies to both SharePoint Foundation 2013 and SharePoint Server 2013.

Watch the SharePoint 2013 Upgrade: Phase 4 video

Video (play button) icon

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you attach and upgrade the content databases, review the following information and take any recommended actions.

  • Make sure that the account that you use to attach the databases is a member of the db_owner fixed database role for the content databases that you want to upgrade.

  • Make sure that the account that you use to create web applications is a member of the Farm administrators group in Central Administration.

Create web applications

Create a web application for each web application that existed in the SharePoint 2010 Products environment. For each web application, do the following:

  • Use the same URL (including name, port, and host header) and configure alternate-access mapping settings.

    If you use a different URL, Office applications might not be redirected correctly to the new URLs and all bookmarks to the old URLs will not work.

  • Use the same authentication method.

    For example, if you use Windows Classic authentication in your old environment, and you want to continue to use it, then you must create a web application that uses Windows Classic authentication. Because claims-based authentication is now the default option for SharePoint 2013, you must use Windows PowerShell to create a web application that uses Windows Classic authentication. For more information, see Create web applications that use classic mode authentication in SharePoint 2013 and Create claims-based web applications in SharePoint 2013.

    Alternatively, you can migrate to claims authentication. For more information, see Migrate from classic-mode to claims-based authentication in SharePoint 2013.

  • Recreate included paths.

  • Recreate quota templates.

  • Configure email settings for the web application.

    For more information, see Configure email integration for a SharePoint 2013 farm.

  • Enable self-service site creation for any web application that used it in the previous environment. Recreate any self-service site creation settings.

  • Create the managed path for the My Sites (/personal) on the web application that hosts My Sites. My Sites are available in SharePoint Server only.

  • Recreate any web application policies or other web application settings that you had configured in the previous environment.

Reapply customizations

One frequent cause of failures during upgrade is that the new environment does not have customized features, solutions, or other elements. Make sure that all custom elements from the SharePoint 2010 Products environment are installed on your front-end web servers before you upgrade any content databases.

In this step, you manually transfer all customizations to your new farm. Make sure to install any components that your sites depend on to work correctly, such as the following:

  • Custom site definitions

  • Custom style sheets, such as cascading style sheets, and images

  • Custom Web Parts

  • Custom Web services

  • Custom features and solutions

  • Custom assemblies

  • Web.config changes (such as security)

    Ensure that you transfer all unique settings from the Web.config files for each web application to the new servers.

  • Administrator-approved form templates (.xsn files) and data connection files (.udcx files) for InfoPath. InfoPath is available in SharePoint Server 2010 only.

  • Any other components or files on which your sites depend.

SharePoint 2013 can host sites in both SharePoint 2010 Products and SharePoint 2013 modes. The installation for SharePoint 2013 contains both SharePoint 2010 Products and SharePoint 2013 versions of many elements. The directories on the file system are duplicated in both the 14 and 15 paths, for example:

  • Web Server Extensions/14/TEMPLATE/Features

  • Web Server Extensions/15/TEMPLATE/Features

There are also two versions of the IIS support directories: _Layouts, _Layouts/15 and _ControlTemplates, _ControlTemplates/15.

Be sure to install customizations to the correct location in your new farm. For example, additional style sheets for SharePoint 2010 Products should be installed in the /14 path, not the new /15 path so that site collections that you haven't upgraded can use them. If you want a solution to be available to both paths, install it two times, and the second time use the CompatibilityLevel parameter when you install it, and it will be installed to the /15 path. For more information, see Install-SPSolution.

For more information about how to update customizations for use in SharePoint 2013, see Redeploying Customizations and Solutions in SharePoint Foundation 2010 and SharePoint Server 2010. For more information about how to deploy customizations to your environment, see Install and manage solutions for SharePoint 2013.

Verify custom components

To make sure that you have identified all custom components for your environment, use the Stsadm -o enumallwebs operation in the SharePoint 2010 Products environment and use the includefeatures and includewebparts parameters. This operation can report the templates, features, Web Parts, and other custom elements that are used for each site. For more information about how to use the enumallwebs operation, see Enumallwebs: Stsadm operation (Office SharePoint Server) and Clean up an environment before an upgrade to SharePoint 2013.

You can also use the Get-SPWeb Windows PowerShell cmdlet in your SharePoint 2010 Products environment to see template that are associated with each site and then verify that the template is installed in your SharePoint 2013 environment. For more information about this operation, see Get-SPWeb.

Before you attach the content databases to the web applications, use the Test-SPContentDatabase Windows PowerShell cmdlet to verify that you have all the custom components that you must have for that database.

To verify custom components are available by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Test-SPContentDatabase -Name DatabaseName -WebApplication URL

    Where:

    • DatabaseName is the name of the database that you want to test.

    • URL is the URL for the web application that will host the sites.

For more information, see Test-SPContentDatabase.

Attach a content database to a web application and upgrade the database

When you attach a content database, you upgrade the database and add the site collections in that database to the web application that you specify. However, for SharePoint 2013, the process does not upgrade the site collections.

When you attach a content database, for a web application that spans multiple content databases, make sure that you attach the content database that contains the root site collection first. When you attach a content database, include the root site for the web application in the first content database that you attach. In other words, before you continue, examine the root of the web application in the SharePoint 2010 Products server farm to determine the first site collection. After you attach the database that contains the root site, attach the other content databases for the web application in any order. You do not have to create any site collections to store the content before you attach the database. This process attaches the content databases and the site collections inside that database. Make sure that you do not add new site collections until you have restored all the content databases.

Tip:

Each site collection in a content database has a GUID that is registered in the configuration database and associated with the site collection. Therefore, you cannot add the same site collection two times to the farm, even in separate web applications. Although you can successfully attach the database in this situation, you will be unable to browse to the site collection.

If you must have a copy of a site collection in the same farm, first attach the database that contains the site collection to a separate farm, and then use the Backup-SPSite and Restore-SPSite Windows PowerShell cmdlets to copy the site collection to the other farm. The backup and restore process creates a new GUID for the site collection. For more information about these cmdlets, see Backup-SPSite and Restore-SPSite.

For My Sites, attach the content database that contains the My Site host before attaching databases that contain the My Sites.

By default, when you created the web applications in the new SharePoint 2013 environment, a content database was created for each web application. You can ignore these default databases until after you have attached your SharePoint 2010 Products databases, and then you can delete the default databases.

Important:

If you are moving the content databases across domains or forests or to another environment that has different service accounts, make sure that the permissions for the service accounts are still correct before you attach the databases.

You must use the Mount-SPContentDatabase cmdlet to attach a content database to a web application. Using the SharePoint Central Administration pages to attach a content database is not supported for upgrading.

Ensure that the account that you use to attach the databases is a member of the db_owner fixed database role for the content databases that you want to upgrade.

Note:

One frequent cause of failures during upgrade is that the environment is missing customized features, solutions, or other elements. Be sure that all custom elements from the SharePoint 2010 Products environment are installed on your front-end web servers in the SharePoint 2013 environment before you start the upgrade process. Use the test-spcontentdatabase Windows PowerShell cmdlet to identify custom elements that your sites might be missing.

To attach a content database to a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command and then press ENTER:

    Copy code
    Mount-SPContentDatabase -Name DatabaseName -DatabaseServer ServerName -WebApplication URL

    Where:

    • DatabaseName is the name of the database that you want to upgrade.

    • ServerName is server on which the database is stored.

    • URL is the URL for the web application that will host the sites.

For more information, see Mount-SPContentDatabase.

Tip:

To upgrade from SharePoint Foundation 2010 to SharePoint Server 2013, attach the SharePoint Foundation 2010 content databases directly to the SharePoint Server 2013 environment. Just follow the same steps in this article, but use the SharePoint Foundation 2010 databases and a SharePoint Server 2013 farm. The upgrade process will upgrade the version and the product at the same time.

Verification: Verify upgrade for the first database

After you attach a database, you can use the Upgrade Status page in Central Administration to check the status of upgrade on your databases. After the upgrade process is complete, you can review the upgrade log file to see whether upgrade produced issues. You can use a Windows PowerShell cmdlet to check the upgrade status for all the content databases. For more information about verifying and troubleshooting upgrade, see Verify database upgrades in SharePoint 2013 and Troubleshoot database upgrade issues in SharePoint 2013.

To view the Upgrade Status page

  • Verify that the user account that is performing this procedure is a member of the db_owner fixed database role for the databases.

  • In Central Administration, click Upgrade and Migration, and then click Check upgrade status.

To view the upgrade log file

  • The upgrade error log file and the upgrade log file are located at %COMMONPROGRAMFILES%\Microsoft Shared\web server extensions\15\LOGS. The upgrade log file contains more detailed information than the upgrade error log. Be sure to check the summary at the bottom of the log files for information about the overall status and a count of the warnings and errors in the file.

    The logs are text files named in the following format:

    • Upgrade-YYYYMMDD-HHMMSS-SSS-error.log

    • Upgrade-YYYYMMDD-HHMMSS-SSS.log

    Where

    • YYYYMMDD is the date

    • HHMMSS-SSS is the time (hours in 24-hour clock format, minutes, seconds, and milliseconds)

    An example for an upgrade error log is Upgrade-20120105-132126-374-error.log, and an example for an upgrade log is Upgrade-20120105-132126-374.log.

    Note:

    The format of the upgrade log for SharePoint 2013 is based on the same structure as ULS.

    The upgrade log file includes the name of the content database being upgraded.

To view upgrade status for all databases by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPContentDatabase | ft Name, NeedsUpgradeIncludeChildren

This cmdlet returns a table-style list of databases in your farm and indicates whether the database needs an upgrade to SharePoint 2013.

Back to top

Attach the remaining databases

After you restore the first content database and verify success, you can continue to restore and upgrade other databases. You can perform parallel database attach upgrades to upgrade more than one database at a time. Use separate Command Prompt windows to run multiple upgrades. It is recommended that you separate the start time for each new database upgrade session by several minutes to prevent issues with temporary locks set for the web application during attachment. Otherwise you might receive an error on the upgrade session. The wait time to clear temporary locks varies depending on the number of site collections, or the speed of the database server hardware.

Verification: Verify upgrade for additional databases

After you upgrade all additional databases, view the Upgrade Status page to monitor progress and verify that the upgrade process is complete. Review the log file to identify any other issues.

Next steps

After you upgrade the databases, you might want to perform additional steps to make sure that your farm is ready for use. For example:

  • Verify that site collections are working as expecting in 2010 mode.

    Visually review site collections. You can use a similar review list as the one provided for upgraded sites in Checklists for reviewing upgraded sites.

  • Migrate user accounts to claims authentication, if it is necessary.

    By default, new web applications in SharePoint 2013 use claims authentication. If you were using classic authentication in the previous environment, you must migrate the users to claims authentication. For more information, see Migrate from classic-mode to claims-based authentication in SharePoint 2013.

  • Update links that are used in any upgraded InfoPath form templates.

    For a database-attach upgrade, you exported and imported all InfoPath form templates in your environment when you created the new environment. After upgrade, you can now update the links that are used in those upgraded form templates to point to the correct URLs by using a Windows PowerShell cmdlet.

    For more information, see Configure InfoPath Forms Services (SharePoint Server 2010).

    InfoPath is available in SharePoint Server only.

  • Configure your Search topology

    The architecture for the Search service has changed for SharePoint Server 2013. Plan and configure your Search topology to suit your environment and the new architecture. For more information, see Scale search for performance and availability in SharePoint Server 2013 and Manage the search topology in SharePoint Server 2013.

  • Perform a full crawl

    For more information, see Start, pause, resume, or stop a crawl in SharePoint Server 2013.

  • Back up your farm

    For more information, see Back up farms in SharePoint 2013.

    Although SharePoint Foundation 2013 includes search functionality, it is not the same Search service application that is in SharePoint Server 2013. These steps apply only to SharePoint Server 2013.

After your farm is ready, you can enable access to users, and then start to upgrade site collections. For information about how to upgrade site collections, see Upgrade site collections to SharePoint 2013.

123 steps

This is the fourth phase in the process to upgrade SharePoint 2010 Products data and sites to SharePoint 2013.

  • Next phase: Upgrade site collections to SharePoint 2013

For an overview of the whole process, see Overview of the upgrade process to SharePoint 2013.

See also

Create the SharePoint 2013 farm for a database attach upgrade
Copy databases to the new farm for upgrade to SharePoint 2013
Upgrade service applications to SharePoint 2013
Checklist for database-attach upgrade (SharePoint 2013)
Upgrade site collections to SharePoint 2013
Overview of the upgrade process to SharePoint 2013
Services upgrade overview for SharePoint Server 2013
Upgrade farms that share services (parent and child farms) to SharePoint 2013
Troubleshoot database upgrade issues in SharePoint 2013

Upgrade and Migration Resource Center for SharePoint 2013 Products
What's New in SharePoint 2013 Products Resource Center


Verify database upgrades in SharePoint 2013
See also

Summary: Learn how to verify when a database-attach upgrade to SharePoint 2013 has finished, and identify any problems that may have occurred.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

After you upgrade databases to SharePoint 2013, you must verify that the content was successfully upgraded to the new version. You can verify the status of the database-attach upgrade (is it still in progress, or has it been completed successfully or with errors or failures?) to see whether issues remain for you to address. When you follow these steps as part of a trial upgrade, you can use them to identify customizations that have to be reworked before you attempt to upgrade your production environment. When you upgrade your production environment, it is even more important that you know whether the upgrade has completed and what issues remain to be addressed.

In some cases, you might have to restart upgrade to finish upgrading your databases. For more information about how to restart upgrade, see Restart a database-attach upgrade or a site collection upgrade to SharePoint 2013. For information about how to restart a site collection upgrade, see Manage site collection upgrades to SharePoint 2013.

Verify upgrade status for databases

You can use the following methods to verify upgrade:

  • Use the Upgrade Status page in Central Administration

    This page lists all farm, service, or content database upgrades and their statuses. This includes a count of errors or warnings.

  • Review the log files to look for errors or warnings

    If upgrade was not successfully completed, you can view the log files to find the issues, address them, and then restart the upgrade process.

Review the log files for database attach upgrade

To verify that upgrade has succeeded, you can review the following log and error files:

  • The upgrade log file and the upgrade error log file.

    Review the upgrade log file and the upgrade error log file (generated when you run the upgrade). The upgrade log file and the upgrade error log file are located at %COMMONPROGRAMFILES%\Microsoft Shared\Web server extensions\15\LOGS. The logs are named in the following format: Upgrade-YYYYMMDD-HHMMSS-SSS.log, where YYYYMMDD is the date and HHMMSS-SSS is the time (hours in 24-hour clock format, minutes, seconds, and milliseconds). The upgrade error log file combines all errors and warnings in a shorter file and is named Upgrade-YYYYMMDD-HHMMSS-SSS-error.log.

    The format of the log files complies with the Unified Logging System (ULS) conventions. To review the log files to find and troubleshoot issues, start at the top of the files. Errors or warnings may be repeated if they occur for several site collections in the environment, or if they block the upgrade process completely. For example, if you cannot connect to the configuration database, the upgrade process will try (and fail) several times and these tries will be listed in the log file.

If you find blocking issues in the log file, you can resolve the issues and then restart upgrade to continue with the process.

Check upgrade status for databases

The Upgrade Status page lists the upgrade sessions and gives details about the status of each session — whether it succeeded or failed, and how many errors or warnings occurred for each server. The Upgrade Status page also includes information about the log and error files for the upgrade process and suggests remedies for issues that might have occurred.

To view upgrade status in SharePoint Central Administration

  1. Verify that you have the following administrative credentials:

    • To use SharePoint Central Administration, you must be a member of the Farm Administrators group.

  2. On the Central Administration home page, in the Upgrade and Migration section, click Check upgrade status.

Validate the upgraded environment

After you determine whether upgrade was completed successfully, validate your environment. Review the following items:

  • Service applications

    • Are they configured correctly?

    • Are the service application proxies configured the way that you want?

    • Do you have to create new connections between farms?

  • Site collections

    • Are sites that were not upgraded working as expected in 2010 mode?

    • Are all features associated with the sites working?

  • Search

    • Run a crawl, and review the log files.

    • Run search queries, and verify that the queries work as expected and provide appropriate results. Twenty-four hours later, view the query reports and look for issues.

    • Search for people and profiles.

    • Check any Search customizations to make sure that they work as expected.

See also

Restart a database-attach upgrade or a site collection upgrade to SharePoint 2013
Troubleshoot database upgrade issues in SharePoint 2013
Upgrade a site collection to SharePoint 2013
Review site collections upgraded to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Migrate from classic-mode to claims-based authentication in SharePoint 2013
See also

Summary: Convert SharePoint 2010 Products or SharePoint 2013 classic-mode web applications to claims-based authentication or create new claims-based web applications in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Claims-based authentication is an essential component to enable the advanced functionality of SharePoint 2013. To move classic-mode web applications from SharePoint 2010 Products to SharePoint 2013, you can convert them to claims-based web applications within SharePoint 2010 Products, and then migrate them to SharePoint 2013. The procedures in this article illustrate various supported scenarios.

The Windows PowerShellConvert-SPWebApplication cmdlet in SharePoint 2013 converts classic-mode web applications to claims-based web applications.

Warning:

After you convert a web application to claims-based authentication, you cannot revert it to classic-mode authentication.

Convert SharePoint 2010 Products classic-mode web applications to claims-based authentication in SharePoint 2010 Products and then upgrade to SharePoint 2013

In SharePoint 2010 Products, complete the following procedure to convert an existing web application to claims-based authentication. After you convert the web application to claims-based authentication, complete the additional step to migrate the web application to SharePoint 2013. To complete this procedure, you need the following information:

  • The URL of the web application that you are converting: http://yourWebAppUrl

  • A user account to set as a site administrator: yourDomain\yourUser

To convert a SharePoint 2010 Products web application to claims-based authentication

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies (http://go.microsoft.com/fwlink/p/?LinkId=193050).

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. From the Windows PowerShell command prompt, type the following to set the specified user account as an administrator for the site:

    Copy code
    $WebAppName = "http://<yourWebAppUrl>"
$wa = get-SPWebApplication $WebAppName
$wa.UseClaimsAuthentication = $true
$wa.Update()

    Where:

    • <yourWebAppUrl> is the URL of the web application.

  3. From the Windows PowerShell command prompt, type the following to configure the policy to enable the user to have full access:

    Copy code
    $account = "yourDomain\yourUser"
$account = (New-SPClaimsPrincipal -identity $account -identitytype 1).ToEncodedString()
$wa = get-SPWebApplication $WebAppName
$zp = $wa.ZonePolicies("Default")
$p = $zp.Add($account,"PSPolicy")
$fc=$wa.PolicyRoles.GetSpecialRole("FullControl")
$p.PolicyRoleBindings.Add($fc)
$wa.Update()

    For more information, see Get-SPWebApplication.

  4. From the Windows PowerShell command prompt, type the following to perform user migration:

    Copy code
    $wa.MigrateUsers($true)

  5. After user migration completes, type the following from the Windows PowerShell command prompt to perform provisioning:

    Copy code
    $wa.ProvisionGlobally()

    For more information, see New-SPClaimsPrincipal.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

After you complete the previous procedures, you might experience one or more of the following issues:

  • Users who submit valid credentials when accessing the migrated web application might be notified that they do not have permissions. If this occurs, the portalsuperuseraccount property and the portalsuperreaderaccount property of the web application were probably configured prior to migration. If this is the case, update the portalsuperuseraccount property and the portalsuperreaderaccount property to use the new claims-based account name. After migration, you can find the new claims-based account name in the web application policy for the migrated web application.

  • If existing alerts are not invoked after migration, you might have to delete and recreate the alerts.

  • If Search crawl does not function on the web application after migration, make sure that the Search crawl account lists the new converted account name. If the new converted account name is not listed, you must manually create a new policy for the crawl account.

To migrate a claims-based SharePoint 2010 Products web application to SharePoint 2013

  1. In SharePoint 2013, create a claims-based web application. For more information, see Create claims-based web applications in SharePoint 2013.

  2. Attach the two existing SharePoint 2010 Products content databases to the newly created SharePoint 2013 claims-based web application. For more information, see Attach or detach content databases in SharePoint 2013.

    Note:

    When you attach the SharePoint 2010 Products content databases to the SharePoint 2013 claims-based web application, the databases will be upgraded to the SharePoint 2013 database format. You have to verify that the content databases work correctly after you attach them.

Convert SharePoint 2010 Products classic-mode web applications to SharePoint 2013 claims-based web applications

In SharePoint 2013, complete the following procedure to convert an existing SharePoint 2010 Products classic-mode web application to a SharePoint 2013 web application that uses claims-based authentication.

To convert a SharePoint 2010 Products classic-mode web application to a SharePoint 2013 claims-based authentication

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies (http://go.microsoft.com/fwlink/p/?LinkId=193050).

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. In the SharePoint 2013 environment, on the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. Change to the directory where you saved the file.

  6. At the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SPWebApplication -name "ClassicAuthApp" -Port 100 -ApplicationPool
"ClassicAuthAppPool" -ApplicationPoolAccount (Get-SPManagedAccount
"<domainname>\<user>")

    Where:

    • <domainname>\<user> is the domain to which the server belongs and the name of the user account.

  7. Attach the two existing SharePoint 2010 Products content databases to the new SharePoint 2013 classic-mode web application. For more information, see Attach or detach content databases in SharePoint 2013.

    Note:

    When you attach the SharePoint 2010 Products content databases to the SharePoint 2013 classic-mode web application, the databases are upgraded to the SharePoint 2013 database format. You have to verify that the content databases work correctly after you have attached them.

  8. From the Windows PowerShell command prompt, type the following:

    Copy code
    Convert-SPWebApplication -Identity <yourWebAppUrl> -To Claims
-RetainPermissions [ -Force]

    Where:

    • <yourWebAppUrl> is the URL of the web application.

    Note:

    Convert-SPWebApplication converts the web application to claims-based authentication. You have to verify that the users can access the web application after you have converted it.

  9. If necessary, attach a third SharePoint 2010 Products content database to the new SharePoint 2013 classic-mode web application, and verify that the content database working correctly after you have attached it.

  10. From the Windows PowerShell command prompt, type the following:

    Copy code
    Convert-SPWebApplication -Identity yourWebAppUrl -To Claims
-RetainPermissions [ -Force]

Verify that users can access the web application after you have converted it to claims-based authentication.

For more information, see New-SPWebApplication, Get-SPManagedAccount, and Convert-SPWebApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Convert SharePoint 2013 classic-mode web applications to claims-based web applications

In SharePoint 2013, complete the following procedures to first create a classic-mode Web application, and then convert it to claims-based authentication.

To create a classic-mode Web application in SharePoint 2013

  • Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies (http://go.microsoft.com/fwlink/p/?LinkId=193050).

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  • From the Windows PowerShell command prompt, type the following:

    Copy code
    New-SPWebApplication -Name <Name>
-ApplicationPool <ApplicationPool>
-AuthenticationMethod <WindowsAuthType>
-ApplicationPoolAccount <ApplicationPoolAccount>
-Port <Port> -URL <URL>

    Where:

    • <Name> is the name of the new web application that uses classic-mode authentication.

    • <ApplicationPool> is the name of the application pool.

    • <WindowsAuthType> is either "NTLM" or "Kerberos". Kerberos is recommended.

    • <ApplicationPoolAccount> is the user account that this application pool will run as.

    • <Port> is the port on which the web application will be created in IIS.

    • <URL> is the public URL for the web application.

    Note:

    For more information, see New-SPWebApplication.

    Note:

    After you successfully create the web application, when you open the Central Administration page, you see a health rule warning that indicates that one or more web applications is enabled with classic authentication mode. This is a reflection of our recommendation to use claims-based authentication instead of classic mode authentication.

To convert a SharePoint 2013 classic-mode web application to claims-based authentication

  • From the Windows PowerShell command prompt, type the following:

    Copy code
    Convert-SPWebApplication -Identity "http:// <servername>:port" -To Claims
-RetainPermissions [-Force]

    Where:

    • <servername> is the name of the server.

Verify that users can access the web application after you have converted it to claims-based authentication.

For more information, see New-SPWebApplication, Get-SPManagedAccount, and Convert-SPWebApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Migrate SharePoint 2010 Products classic-mode web applications to SharePoint 2013 classic-mode web applications

In SharePoint 2013, complete the following procedure to create a classic-mode web application, and then migrate an existing SharePoint 2010 Products classic-mode Web application to SharePoint 2013.

To migrate a SharePoint 2010 Products classic-mode web application to SharePoint 2013

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies (http://go.microsoft.com/fwlink/p/?LinkId=193050).

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. From the Windows PowerShell command prompt, type the following:

    Copy code
    New-SPWebApplication -name "ClassicAuthApp" -Port 100 -ApplicationPool
"ClassicAuthAppPool" -ApplicationPoolAccount (Get-SPManagedAccount
"<domainname>\<user>")

    Where:

    • <domainname>\<user> is the domain to which the server belongs and the name of the user account.

  3. Attach the two existing SharePoint 2010 Products content databases to the new SharePoint 2013 classic-mode web application. Verify that the content databases work correctly after you have attached them. For more information, see Attach or detach content databases in SharePoint 2013.

Note:

After migration has successfully completed, you might find a user who has not been migrated listed in the ULS log. Determine if the user still exists in your Active Directory domain, and then:

  • If the user does not exist in your Active Directory domain, assign someone else as the site owner and designate the user as deleted in the UserInfo table. To designate a user as deleted, change the tp_deleted value in the UserInfo table for that user to 1.

  • If the user does exist in your Active Directory domain, run the migration procedure again.

For more information, see New-SPWebApplication and Get-SPManagedAccount.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Create claims-based web applications in SharePoint 2013
Create web applications that use classic mode authentication in SharePoint 2013


Upgrade site collections to SharePoint 2013
See also

Summary: Find out how to upgrade a site collection to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about upgrading site collections to SharePoint 2013.

Downloadable resources how to upgrade site collections

Download the following content for information about how to upgrade site collections.

 | Content | Description
Architecture icon | SharePoint 2013 Products Preview - Upgrade Process model | Describes the steps in the process for a database-attach upgrade.

TechNet articles about how to upgrade site collections

The following articles about how to upgrade site collections are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Run site collection health checks in SharePoint 2013 | Run the site collection health checks to verify your site is running well. Check each site before you upgrade to SharePoint 2013.
Upgrade a site collection to SharePoint 2013 | Site collection administrators can preview a copy of their sites in SharePoint 2013 mode, and then upgrade their sites.
Review site collections upgraded to SharePoint 2013 | Review site collections after you have upgraded them to SharePoint 2013.
Manage site collection upgrades to SharePoint 2013 | Farm administrators manage the upgrade queue and throttling settings and upgrade site collections to SharePoint 2013.

Additional resources about how to upgrade to SharePoint 2013

The following resources about upgrade to SharePoint 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | Upgrade and Migration Resource Center for SharePoint 2013 Products | Visit the Resource Center to find additional information about upgrades to SharePoint 2013.
TechNet logo | What's New in SharePoint 2013 Products Resource Center | Visit the Resource Center to learn about what's new in SharePoint 2013.

See also

Upgrade to SharePoint 2013


Run site collection health checks in SharePoint 2013
See also

Summary: Run the site collection health checks on each site to find issues before you upgrade to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint 2013 includes a set of rules that you can run against a site collection to verify that it is working as expected. These rules are part of the site collection health checks. You can run the health checks from the Site Settings page or by using Windows PowerShell.

If you are upgrading a site collection to SharePoint 2013, the first step in the process is to run the health checks.

Upgrade step 1: Run site collection health checks

Stage 1 - run the site collection health checks

For a visual overview of the entire upgrade process, see Overview of the upgrade process to SharePoint 2013.

You run the health checks manually to prepare for an upgrade. In addition, the health checks are run automatically in repair mode when you start to upgrade a site collection. You can also run the health checks at any time to verify that a site is working as expected. The site collection pre-upgrade health checks examine a site collection and list potential upgrade issues, such as missing or unsupported elements. For example, the results itemize customized files so that you can identify the custom file and reset it to the default template in the site definition, if you want. After you run the checks, a report lists potential issues. The report also has information about how to address the issues.

The site collection health checker includes the following rules:

Site collection health check rules

Rule name | Description | Rule ID
Conflicting Content Types | This rule checks for conflicts between existing content types and content types that are created when you upgrade the site to SharePoint 2013. A conflict occurs when both content types have the same name. | befe203b-a8c0-48c2-b5f0-27c10f9e1622
Customized Files | This rule checks for any files that were customized (or unghosted) in the site collection or subsites. When run in repair mode, it can reset the page to the default (reghost the file). | cd839b0d-9707-4950-8fac-f306cb920f6c
Missing Galleries | This rule checks for all default galleries and reports if any are missing from the site collection or subsites. | ee967197-ccbe-4c00-88e4-e6fab81145e1
Missing Parent Content Types | This rule checks for missing parent content types. If a missing parent content type is found, you can either delete the orphaned content type or associate the orphaned content type with a different parent content type.ge | a9a6769f-7289-4b9f-ae7f-5db4b997d284
Missing Site Templates | This rule checks to make sure that the template the site is based on is available and reports if any elements are missing. | 5258ccf5-e7d6-4df7-b8ae-12fcc0513ebd
Unsupported Language Pack References | This rule checks to make sure that the language packs that are used by the site collection exist and are referenced correctly by the site collection. | 99c946f7-5751-417c-89d3-b9c8bb2d1f66
Unsupported MUI References | This rule checks to make sure that the multi-user interface elements that are used by the site collection exist and are referenced correctly by the site collection. | 6da06aab-c539-4e0d-b111-b1da4408859a

Before you begin

This is the first step in upgrading a site collection. Before you upgrade a site collection, you must have already configured the environment that uses SharePoint 2013 and upgraded the databases. For more information about these steps, see Upgrade content databases to SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Run the site collection pre-upgrade health checks by using Site Settings

Site collection owners can run the site collection health checks from the Site Settings page in their site collections.

To run the pre-upgrade checks for a site collection

  1. Verify that the user account that performs this procedure is a site collection administrator.

  2. On the Site Settings page for the site collection, in the Site Collection Administration section, click Site collection health checks.

  3. On the Run site collection health checks page, click Start checks.

    A report lists all checked issues and issues that you should resolve.

  4. Resolve all issues, and then click Try it again to verify that you fixed them.

Run the site collection pre-upgrade health checks by using Windows PowerShell

Farm administrators can use the following Windows PowerShell cmdlets to run the site collection health checks and to repair issues: Test-SPSite Repair-SPSite.

To run the site collection health checks in test mode by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Either a site collection administrator or be granted full read (for test mode) for the web application by policy. For more information about permission policies for web applications, see Manage permission policies for a web application in SharePoint 2013.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Test-SPSite -Identity <SiteURL> [-Rule <RuleID>]

    Where:

    • <SiteURL> is URL for the site collection you want to check.

    • <RuleID> is ID for a specific rule that you want to run.

To run the site collection health checks in repair mode by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Either a site collection administrator or be granted full control (for repair mode) for the web application by policy. For more information about permission policies for web applications, see Manage permission policies for a web application in SharePoint 2013.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Repair-SPSite -Identity <SiteURL> [-Rule <RuleID>]

    Where:

    • <SiteURL> is URL for the site collection you want to repair.

    • <RuleID> is ID for a specific rule that you want to run.

Additional steps

If you are performing an upgrade to SharePoint 2013, you can start the site collection upgrade after you have addressed all issues from the health checks. You can create an upgrade evaluation site to try the new user interface for your site, or you can upgrade your site collection directly. To learn about how to create evaluation site collections or upgrade a site collection, see Upgrade a site collection to SharePoint 2013.

See also

Plan for upgrade to SharePoint 2013
Overview of the upgrade process to SharePoint 2013
Upgrade a site collection to SharePoint 2013
Upgrade to SharePoint 2013


Upgrade a site collection to SharePoint 2013
See also

Summary: Learn how site collection administrators can preview a copy of their sites in SharePoint 2013 mode, and then upgrade their sites.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

After a server farm administrator has upgraded the databases, site collection administrators can upgrade individual site collections. When site collection administrators first browse to their sites after the database has been upgraded, a notification bar at the top of the site indicates that their sites can be upgraded. The choices are to Start now or Remind me later. Start now begins the site collection upgrade process.

To upgrade a site collection, site collection administrators complete the following steps:

  1. Run the site collection health checks to verify the site is ready to upgrade. For more information, see Run site collection health checks in SharePoint 2013.

  2. Create an upgrade evaluation site to preview the differences between versions. (Optional)

  3. Upgrade the site collection.

  4. Verify that upgrade was successful and the site works as expected. For more information, see Review site collections upgraded to SharePoint 2013.

This article discusses the second and third steps, and includes procedures for performing these tasks from Site Settings. For information about using Windows PowerShell cmdlets to upgrade sites from the command line, see Manage site collection upgrades to SharePoint 2013.

Upgrade step 2: Request evaluation site collection and Step 3: Upgrade the site

Stage 2 and 3 - evaluation site and upgrading

For a visual overview of the upgrade process, including site collection upgrade, see Overview of the upgrade process to SharePoint 2013. For more information about how farm administrators can control site collection upgrades, see Manage site collection upgrades to SharePoint 2013. For more conceptual information about site upgrade, including how to plan for upgrade, see Plan for site collection upgrades in SharePoint 2013.

Watch the SharePoint 2013 Upgrade: Phase 5 video

Video (play button) icon
Important:

If you upgrade from SharePoint Server 2010 to SharePoint Server 2013, there are special considerations for My Sites. (My Sites are not available in SharePoint Foundation 2013.) Make sure that you upgrade the My Site Host site collection before you allow users to access their individual My Sites in SharePoint Server 2013. This makes sure that the server software and database changes are complete so that users can upgrade their individual My Sites successfully.

A user can upgrade his or her My Site by following the steps to upgrade a site collection later in this article, or a farm administrator can upgrade My Sites by using Windows PowerShell.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Create an upgrade evaluation site (Optional)

As a site collection administrator, you can request a preview of your site collection; this is called an upgrade evaluation site collection. An upgrade evaluation site collection enables you to see your site's content in a new, separate copy of the site that is running on the SharePoint 2013. Unlike visual upgrade in SharePoint Server 2010, the upgrade evaluation site collection is a complete copy of the site collection, separate from the original. Actions that you take in the upgrade evaluation do not affect the original site.

When you request an evaluation site collection, the request is added to a Timer job (named "Create Upgrade Evaluation Site Collections") which runs once a day. You will receive an e-mail message when the upgrade evaluation site is available. This might take up to 24 hours. The message includes a link to the evaluation site. Upgrade evaluation site collections are set to automatically expire (after 30 days by default). If yours expires before you have finished evaluating the changes, you can request another upgrade evaluation site collection.

To request an upgrade evaluation site collection

  1. Verify that the user account that performs this procedure is a site collection administrator.

  2. On the Site Settings page for the site collection, in the Site Collection Administration section, click Site collection upgrade.

  3. On the Step up to SharePoint 2013 page, click Try a demo upgrade.

    This option starts the process of generating an upgrade evaluation site collection.

  4. In the Create Upgrade Evaluation Site Collection box, click Create Upgrade Evaluation Site Collection.

    A box opens and informs you that a demo site request was received.

  5. Click Close to close the box.

    You will receive an e-mail message when the upgrade evaluation is available. The e-mail message will contain a link to the site collection. Review the site and confirm that your site collection will look and behave as expected in the new user interface.

After you have reviewed the upgrade evaluation and made any necessary changes in your original site based on your evaluation, you can upgrade your site collection.

Farm administrators can use Windows PowerShell to request an upgrade evaluation site collection. For more information, see Manage site collection upgrades to SharePoint 2013.

Upgrade a site collection

After you run the pre-upgrade checks and optionally review an upgrade evaluation site collection, you can upgrade your site collection to SharePoint 2013.

Important:

  • You cannot upgrade FAST Search Center sites to the 2013 experience. Existing FAST Search Center sites can continue to work in 2010 mode after upgrade. If you want the new functionality, you must create new enterprise Search Center sites in 2013 mode.

  • To enable users to preview Word or PowerPoint search results in a SharePoint 2013 Search Center, do each of the following:

    • Before you upgrade content site collections, upgrade the SharePoint Server 2010 enterprise Search Center site collection to 2013 mode.

    • Ensure that SharePoint 2013 is configured to use Office Web Apps. For more information, see Deploy Office Web Apps Server and Configure SharePoint 2013 to use Office Web Apps.

To upgrade a site collection

  1. Verify that the user account that performs this procedure is a site collection administrator.

  2. On the Site Settings page for the site collection, in the Site Collection Administration section, click Site collection upgrade.

  3. On the Site Collection Upgrade page, click Upgrade this Site Collection.

    This option starts the process of upgrading your site collection. A box opens to verify that you want to start the process.

  4. Click I'm ready to start the actual upgrade.

    Note:

    The site collection health checks are run automatically in repair mode before the upgrade starts. The results from the health checks are included in the upgrade log for the site collection. If there is an error, you must address it before you can continue to upgrade.

    The upgrade starts, and the Upgrade status page for the site collection is displayed. This page automatically updates while the upgrade is in progress and displays information about the process, such as the following:

    • Errors or warnings

    • When the upgrade started

    • Where you can find the upgrade log file

    After the upgrade is complete, the Upgrade status page is displayed in the new user interface with the message, Upgrade Completed Successfully.

  5. Click Let's see the new site to go to the home page.

Farm administrators can use Windows PowerShell to upgrade a site collection. For more information, see Manage site collection upgrades to SharePoint 2013.

Verification

To verify that upgrade has succeeded, check the Upgrade status page for the site collection.

View upgrade status in Site Settings

Site collection administrators can view the Upgrade Status page in Site Settings to verify that upgrade has succeeded for a site collection.

To view upgrade status in Site Settings

  1. Verify that the user account that performs this procedure is a site collection administrator.

  2. On the Site Settings page for the site collection, in the Site Collection Administration section, click Site collection upgrade.

  3. On the Site Collection Upgrade page, click Review Site Collection Upgrade Status.

    The Upgrade Status page for the site collection is displayed.

Farm administrators can use Windows PowerShell to view site collection upgrade status. For more information, see Manage site collection upgrades to SharePoint 2013.

Additional steps

Next, review your upgraded site collection to be sure that everything is working as expected. For more information see Review site collections upgraded to SharePoint 2013.

See also

Manage site collection upgrades to SharePoint 2013
Plan for site collection upgrades in SharePoint 2013
Overview of the upgrade process to SharePoint 2013
Run site collection health checks in SharePoint 2013
Review site collections upgraded to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Review site collections upgraded to SharePoint 2013
See also

Summary: Learn what to look for when you review site collections after you upgrade to SharePoint 2013 and find tips to address issues.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Use these steps in your test environment to identify any issues before you upgrade your production environment. And review your upgraded sites to fix any issues after you have upgraded a site collection.

When you perform tests before upgrading your environment:

  • Begin by validating high-impact or high-profile sites, and then move on to lower-priority sites. As part of the planning process, you should have identified which sites are high-impact and high-profile and require immediate attention, and which can wait a bit longer.

  • To verify basic functionality, create a new site collection by using a representative set of lists, libraries, Web Parts, and so on. Review the new site to make sure that the common, basic elements of your sites are working.

  • If pages do not render, you can check the Site Settings page by going directly to the URL (http:// siteurl/_layouts/settings.aspx). If the Site Settings page works and the upgrade has succeeded, there might be issues with the master page or home page. If the Site Settings page does not work, go to the site collection upgrade log file to see whether you can get more information about the problem.

You can review the site collection upgrade logs from the following locations:

  • For site collection administrators: There are also log files for site collection upgrade stored inside the site collection itself, in the Maintenance Logs catalog at (http://<SiteName>/_catalogs/MaintenanceLogs/YYYYMMDD-HHMMSS-SSS.txt , where YYYYMMDD is the date and HHMMSS-SSS is the time (hours in 24-hour clock format, minutes, seconds, and milliseconds).

  • For farm administrators: The site collection upgrade log file and the upgrade error log file are located at %COMMONPROGRAMFILES%\Microsoft Shared\Web server extensions\15\LOGS. The logs are named in the following format: SiteUpgrade-YYYYMMDD-HHMMSS-SSS.log, where YYYYMMDD is the date and HHMMSS-SSS is the time (hours in 24-hour clock format, minutes, seconds, and milliseconds). These file system logs have more information if you want details about issues.

Use the following checklists to review your upgraded sites and look for issues for either trial upgrades or upgrades in a production environment.

Checklists for reviewing upgraded sites

Web Parts

The following table lists issues with Web Parts that can occur after upgrade and how to address them.

Tip:

To test your Web Parts quickly, you can build a new Web Part page that contains all the custom Web Parts before you test an upgrade, and then review the page for any missing or broken Web Parts after the trial upgrade.

What to check What to do if there is a problem

Do all the Web Parts from your original site appear in your upgraded site?

If a Web Part zone exists in a customized (unghosted) page, but not in the site definition, the Web Parts from that Web Part zone may have been moved into the bottom zone on the page during the upgrade.

Either in Edit Mode for the page in the browser or in SharePoint Designer 2013, look for missing Web Parts in the bottom zone or other zones, or check whether the Web Parts were closed. For more information about how to work with Web Parts and Web Part zones in SharePoint Designer 2013, see the SharePoint Designer Help system.

Are there any broken Web Parts pages and are the Web Parts displayed correctly (in the correct zone, location, and size)?

Either in Edit Mode for the page in the browser or in SharePoint Designer 2013, drag the Web Part into the correct zone or modify the Web Part properties to correct any sizing or positioning problems.

Are there any extra or missing Web Parts?

Open the page either in Edit Mode for the page in the browser or in SharePoint Designer 2013. If you see additional Web Parts on your page, look for closed or inactive Web Parts on the original version of the page. Were the closed or inactive Web Parts opened by the upgrade process? If so, you can modify the Web Part properties to close these Web Parts.

If Web Parts are missing, look for errors in SharePoint Designer 2013 such as "Error Rendering Control" or "Missing Assembly." These errors indicate that the Web Part was not installed or was configured incorrectly for the new environment and must be reinstalled or reconfigured.

Do the Web Parts work correctly?

Open the page either in Edit Mode for the page in the browser or in SharePoint Designer 2013, and look for errors that indicate that a component or service is missing. Make sure that any components or services that the Web Parts rely on exist in the upgraded site. Particularly for the database attach upgrade approach, you must make sure that you have installed all the components or services that you must have for your Web Parts, and that you have configured them correctly (for example, you have configured the Web.config Safe Controls list).

Update and redeploy any Web Parts that exist but no longer function correctly.

Are any Web Parts pages still checked out?

If you check out a page to make changes, make sure that you check in the page again.

Are your Excel Web Access Web Parts working correctly? Did you create your connections again correctly? Are external data sources still working?

Verify all connections and external data sources.

Tip:

If you have problems with a Web Part, append ?contents=1 to the end of the URL syntax (http:// siteurl/default.aspx?contents=1), and then press ENTER. This opens the Web Part Maintenance page where you can remove and repair the broken Web Part.

Large lists

By default, large list query throttling is turned on in SharePoint 2013. If a list is very large, and users use a view or perform a query that exceeds the limit or throttling threshold, the view or query will not be permitted. Check any large lists in your environment and have the site administrator or list owner address the issue. For example, they can create indexed columns with filtered views, organize items into folders, set an item limit on the page for a large view, or use an external list. For more information about large list throttling and how to address issues with large lists, see Manage lists and libraries with many items on Office Online.

Styles and appearance

The following table lists common issues with the style and appearance of your web site after upgrade and how to address them.

Tip:

Most of the issues in this section can be resolved by correcting the links to an item.

What to check | What to do if there is a problem
Are all the images on your pages displayed correctly? | Verify or fix the links to the images.
Are the appropriate cascading style sheet colors and styles used in the appropriate locations? | Verify or fix the links to the cascading style sheet file. Verify the link on the master page.
Theme choices are different in SharePoint 2013 - which theme do you want to use? | Your site's home page, or other pages on your site, may look different after the site is upgraded. You may have to re-create or revise a theme and reapply it.
Do you have any JavaScript controls that are not working? | Verify or fix the links to the controls.
Are your pages displayed correctly in the browser? | Verify that any HTML on the page is in strict XHTML mode.
Are any script errors displayed on any pages? | Verify the scripts and links, and verify that any HTML is in strict XHTML mode.

Customized (unghosted) pages

Customized (also known as unghosted) pages are pages that were edited and are now unique versions of the pages for the site, instead of the default template pages. The following table lists issues with customized pages that can occur after upgrade and how to address them.

What to check What to do if there is a problem

Are your customizations still in place?

Determine whether you have only one issue or a larger problem with the whole page.

If you added a brand-new page to your original site (for example, if you replaced Default.aspx with a different file instead of changing the existing Default.aspx file), the new page has no association with the site definition. Therefore, it might not resemble the other pages on the upgraded site — nor can it be reset to resemble them. If you want your customized page to have the same appearance and behavior as the other pages on your site, consider creating a brand-new page that is based on the site definition and then transferring your customizations to that new page.

Can you still access the editing controls on the pages?

If you customized the editing controls (for example, the Site Actions link or the Edit Page link in SharePoint 2010 Products), check whether they still appear. If they don't appear, you can replace them with the editing controls of the new version by resetting the page to the default version.

Use the Reset to Template command in SharePoint Designer to reset the page to the default version (also known as reghosting). After you have restored the default page, you can then reapply your customizations in the browser by applying a different master page, or by reapplying the customizations in SharePoint Designer.

Are your customizations still appropriate in the new environment, or do you want to update to the new functionality and look?

If you want the new functionality and features, you must reset any customized pages to use the template. Resetting the page basically discards the customizations and attaches your page to the appropriate master page. Any customizations that you want can then be transferred to the master page instead of being stored in individual pages.

Use the Reset to Template command in SharePoint Designer to reset the page to the default version (that is, reghost it). After you have restored the default page, you can then reapply your customizations in the browser by applying a different master page, or by reapplying the customizations in SharePoint Designer.

Are any pages still checked out?

If you check out a page to make changes, make sure that you check in the page again.

See also

Upgrade a site collection to SharePoint 2013
Troubleshoot site collection upgrade issues in SharePoint 2013
Restart a database-attach upgrade or a site collection upgrade to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Manage site collection upgrades to SharePoint 2013
See also

Summary: Learn how farm administrators can manage the upgrade queue and throttling settings and upgrade site collections to SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Even though site collection administrators can now upgrade their own sites to SharePoint 2013, server farm administrators can still control when and whether a site collection is upgraded by managing the upgrade queue. You can also view and manage the upgrade throttling settings for a web application or content database to manage your farm's performance for site collection upgrades.

Before you begin to upgrade site collections to SharePoint 2013

Farm administrators can control settings for site collection upgrade, such as notifications, throttling, and the upgrade queue, and can upgrade site collections by using Windows PowerShell. Before you change these settings or upgrade a site collection, you should understand the settings and the implications for making changes. For more information about the settings for site collection upgrade, see Plan for site collection upgrades in SharePoint 2013. For information about how to upgrade a site collection from the Site Settings page, see Upgrade a site collection to SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Control upgrade notifications and self-service upgrade

When a site collection is available to upgrade, site collection administrators see a status bar on their sites indicating that they can upgrade them. They can choose to upgrade the site collection then or be reminded later. You can control settings for these notifications and control whether site collection administrators can upgrade their site collections. For more information about these properties, see Plan settings for upgrade notifications, self-service upgrade, and site collection creation.

To view the upgrade notification and self-service upgrade settings by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following commands to view the upgrade notification settings for a web application:

    Copy code
    $wa=Get-SPWebApplication <URL>
$wa.UpgradeReminderDelay
$wa.UpgradeMaintenanceLink

    Where:

    • <URL> is URL for the web application that you want to check.

    This command returns the Upgrade reminder delay setting for the specified web application.

  6. At the Windows PowerShell command prompt, type the following command to view the self-service upgrade setting for a site collection:

    Copy code
    $site=Get-SPSite <URL>
$site.AllowSelfServiceUpgrade=<Value>

    Where:

    • <URL> is URL for the site collection that you want to affect.

    • <Value> is either 'true' to allow site collection administrators to upgrade the site, or 'false' to not show them the notification and not allow them to upgrade.

For more information, see Get-SPWebApplication and Get-SPSite.

To change the upgrade notification and self-service upgrade settings for a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command to change the upgrade notification settings for a web application:

    Copy code
    $wa=Get-SPWebApplication <URL>
$wa.UpgradeReminderDelay=<Value>
$wa.UpgradeMaintenanceLink='<LinkURL>'

    Where:

    • <URL> is URL for the web application that you want to affect.

    • <Value> is the numeric value that you want to set for the delay (for example, 10 for 10 days).

    • <LinkURL> is a link where the user can find more information.

  6. At the Windows PowerShell command prompt, type the following command to change the self-service upgrade setting for a site collection:

    Copy code
    $site=Get-SPSite <URL>
$site.AllowSelfServiceUpgrade=<Value>

    Where:

    • <URL> is URL for the site collection that you want to affect.

    • <Value> is either 'true' to allow site collection administrators to upgrade the site, or 'false' to not show them the notification and not allow them to upgrade.

For more information, see Get-SPWebApplication and Get-SPSite.

Control the compatibility range for site creation modes

You can control which mode (2010 or 2013, or both) can be used when a user creates a site collection. The CompatibilityRange property on a web application controls the site modes available for a web application. You can view or change the settings for CompatibilityRange by using Windows PowerShell.

To view the compatibility range for site creation modes for a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following commands to view the compatibility range settings for a web application:

    Copy code
    $wa=Get-SPWebApplication <URL>
# Stores the web application at that URL as a variable
$wa.CompatibilityRange
# Returns the CompatibilityRange for the specified web application

    Where:

    • <URL> is URL for the web application that you want to check.

    This command returns the compatibility range for the specified web application. For example:

    Copy code
    MaxCompatibilityLevel   MinCompatibilityLevel  DefaultCompatibilityLevel   Singular
---------------------   ---------------------  -------------------------   --------
                15                    14                           15         False

  6. At the Windows PowerShell command prompt, type the following commands to view the maximum, minimum, and default settings for a specific range:

    Copy code
    [Microsoft.SharePoint.SPCompatibilityRange]::<RangeName>

    Where:

    • RangeName is one of the following values: OldVersions, NewVersion, AllVersions.

    This command returns the compatibility range for the specified value. For example, for NewVersion:

    Copy code
    MaxCompatibilityLevel   MinCompatibilityLevel  DefaultCompatibilityLevel   Singular
---------------------   ---------------------  -------------------------   --------
               15                     15                           15         True

For more information, see Get-SPWebApplication.

To change compatibility range for site creation modes for a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command to change the compatibility range settings to a specific range:

    Copy code
    $wa=Get-SPWebApplication <URL>
# Stores the web application at that URL as a variable
$wa.CompatibilityRange = [Microsoft.SharePoint.SPCompatibilityRange]::<RangeName>
# Specifies which range to use
$wa.Update()
# Updates the CompatibilityRange setting to use only the range you specified
$wa.CompatibilityRange
# Returns the new CompatibilityRange for the web application

    Where:

    • <URL> is URL for the web application that you want to change.

    • RangeName is one of the following values: OldVersions, NewVersion, AllVersions.

  6. At the Windows PowerShell command prompt, type the following command to change the values for the CompatibilityRange manually:

    Copy code
    $wa=Get-SPWebApplication <URL>
# Stores the web application at that URL as a variable
$range = New-Object Microsoft.SharePoint.SPCompatibilityRange(<Integer>,<Integer>)
# Creates a new compatibility range from <Integer> to <Integer>
$wa.CompatibilityRange = $range
# Specifies which range to use
$wa.Update()
#Updates the CompatibilityRange setting to use only the range you specified with $range
$wa.CompatibilityRange
# Returns the new CompatibilityRange for the web application

    Where:

    • <URL> is URL for the web application that you want to change.

    • Integer is a number to use as the minimum or maximum value. For example, (14,15) would set the MinCompatibilityLevel to 14 (2010) and the MaxCompatibilityLevel to 15 (2013). The DefaultCompatibilityLevel is automatically set to the lower of the MaxCompatibilityLevel and the current major version (for example, 15).

    This command sets and then returns the range that you specified. For example:

    Copy code
    MaxCompatibilityLevel   MinCompatibilityLevel   DefaultCompatibilityLevel   Singular
---------------------   ---------------------   -------------------------   --------
                15                     14                           15         False

For more information, see Get-SPWebApplication.

Control the queue for upgrades of sites to SharePoint 2013

Every site that is set to upgrade is added to the queue, even if it is processed immediately. A site is removed from the queue after it is upgraded, or if it has encountered an error that must be addressed by a site collection or server administrator. If an unexpected failure occurs during the process (such as a power outage or service interruption), the site remains in the queue and the timer service will try the upgrade again automatically. Server farm administrators can manage the queue to remove a site from the queue, add a site to the queue, or upgrade a site manually.

Server farm administrators can manage the queue to do the following:

  • Determine site collections that are in the upgrade queue.

    Each web application has its own upgrade queue. You can show the sites that are in the queue for a specific content database associated with that web application.

  • See all sites that are currently being upgraded.

    You can view the queue and filter it to show only the sites that are currently being upgraded for a specific content database.

  • Add a site collection to the upgrade queue.

    If you want to upgrade a site collection, you can add it to the queue.

  • Remove a site collection from the upgrade queue.

    You can remove a site collection from the upgrade queue. Stop the timer job, remove the site from the queue, and then restart the timer job to resume upgrade for the remaining sites in the queue. You cannot remove a site collection from the queue if it is currently being upgraded.

The following procedure contains steps to view and manage the site collection upgrade queue.

To manage the upgrade queue by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. To view all site collections in the queue for a content database, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSiteUpgradeSessionInfo -ContentDatabase <DatabaseName> -ShowInProgress -ShowCompleted -ShowFailed |ft

    Where:

    • <DatabaseName> is name of the database that you want to check. You can also use the GUID for the database instead of the name.

    For more information, see Get-SPSiteUpgradeSessionInfo.

  6. To see all sites that are currently being upgraded, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSiteUpgradeSessionInfo -ContentDatabase <DatabaseName> -ShowInProgress

    Where:

    • <DatabaseName> is name of the database that you want to check. You can also use the GUID for the database instead of the name.

    For more information, see Get-SPSiteUpgradeSessionInfo.

  7. To see whether a particular site is in the queue, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSiteUpgradeSessionInfo -Site <http://site>

    Where:

    • <http://site> is URL for the site collection you want to add to the upgrade queue.

    For more information, see Get-SPSiteUpgradeSessionInfo.

  8. To add a site collection to the upgrade queue, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Upgrade-SPSite <http://site> -VersionUpgrade -QueueOnly

    Where:

    • <http://site> is URL for the site collection you want to add to the upgrade queue.

    For more information, see Upgrade-SPSite.

  9. To remove a site collection from the upgrade queue, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Remove-SPSiteUpgradeSessionInfo -Identity <URL>

    Where:

    • <URL> is URL for the site collection you want to add to the upgrade queue.

    For more information, see Remove-SPSiteUpgradeSessionInfo.

Control site throttle settings for upgrade to SharePoint 2013

You can view and change the upgrade throttle settings for a content database and web application by viewing and setting the SPContentDatabase.ConcurrentSiteUpgradeSessionLimit and SPWebApplication.SiteUpgradeThrottleSettings properties. For descriptions of the properties that control throttle levels and the default values, see Plan for site collection upgrades in SharePoint 2013.

For more information about web application properties, see SPWebApplication Properties. For more information about content database properties, see SPContentDatabase Properties.

The following procedure provides steps to view upgrade throttling settings for a web application.

To view the upgrade throttle settings for a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $wa = Get-SPWebApplication <URL>
$wa.SiteUpgradeThrottleSettings

    Where:

    • <URL> is URL for the web application that you want to check.

    This command returns the set of throttling settings for the specified web application. For example:

    Copy code
    AppPoolConcurrentUpgradeSessionLimit : 5
UsageStorageLimit                    : 10
SubwebCountLimit                     : 10
Name                                 :
TypeName                             : Microsoft.SharePoint.Administration.SPSiteUpgradeThrottleSettings
DisplayName                          :
Id                                   : ca76dda0-7050-4c6b-a126-05917da39f8a
Status                               : Online
Parent                               : SPWebApplication Name=SharePoint - 80
Version                              : 8222
Properties                           : {}
Farm                                 : SPFarm Name=SharePoint_ConfigUpgradedPersistedProperties          : {}

For more information, see Get-SPWebApplication.

You can change the upgrade throttle settings for a web application. The following procedure provides steps to change the upgrade throttling settings for a web application.

To change the upgrade throttle settings for a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $wa=Get-SPWebApplication <URL>
$wa.SiteUpgradeThrottleSettings.AppPoolConcurrentUpgradeSessionLimit=<Value>
$wa.SiteUpgradeThrottleSettings.UsageStorageLimit=<Value>
$wa.SiteUpgradeThrottleSettings.SubwebCountLimit=<Value>

    Where:

    • <URL> is URL for the web applications that you want to affect.

    • Value is the numeric value that you want to set for that limit (for example, 8).

    This command changes the throttling settings for a web application to the value that you supply.

For more information, see Set-SPWebApplication.

The following procedure provides steps to view upgrade throttling settings for a content database.

To view the throttle settings for a content database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $db = Get-SPContentDatabase <DatabaseName>
# Stores the database name as a variable to use in the next command
    Copy code
    $db.ConcurrentSiteUpgradeSessionLimit
# Returns the value for the limit for that database

    Where:

    • <DatabaseName> is name of the database that you want to check. You can also use the GUID for the database instead of the name.

    This command returns the set of throttling settings for the specified content database.

For more information, see Get-SPContentDatabase.

You can change the upgrade throttle settings for a content database. The following procedure provides steps to change the upgrade throttling settings for a content database.

To change the throttle settings for a content database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $db = Set-SPContentDatabase <DatabaseName>
# Stores the database name as a variable to use in the next command
    Copy code
    $db.ConcurrentSiteUpgradeSessionLimit=<value>
# Changes the limit to the value you specify.

    Where:

    • <DatabaseName> is name of the database that you want to affect. You can also use the GUID for the database instead of the name.

    • <value> is a numeric value to set the property to, such as 9.

    This command changes the throttling settings for the specified content database to the value that you supply.

For more information, see Set-SPContentDatabase.

Create upgrade evaluation site collections by using Windows PowerShell

Site collection administrators can request a preview of their site collection. This preview site is called an upgrade evaluation site collection. Farm administrators can request an upgrade evaluation site collection by using Windows PowerShell.

To request an upgrade evaluation site collection by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Either a site collection administrator or be granted full control (for repair mode) for the web application by policy. For more information about permission policies for web applications, see Manage permission policies for a web application in SharePoint 2013.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Request-SPUpgradeEvaluationSiteCollection -identity URL to site

    Where:

    • URL to site is the URL to a site collection in 2010 mode.

For more information, see Request-SPUpgradeEvaluationSite.

Upgrade site collections by using Windows PowerShell

You can upgrade a single site collection or all site collections in a specific database by using Windows PowerShell.

To upgrade a single site collection in a database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Upgrade-SPSite <http://site> -VersionUpgrade [-Unthrottled]

    Where:

    • <http://site> is the URL for the site collection.

    • Add the option -Unthrottled option to skip the site collection upgrade queue and start the upgrade immediately.

This cmdlet upgrades the specific site collection to 2013 mode. For more information, see Upgrade-SPSite.

To upgrade all site collections in a database, use Windows PowerShell. However, because sites can continue to run in 2010 mode in the SharePoint 2013 environment, this is not a necessary procedure for most environments. If you do choose to upgrade all site collections immediately, site collection owners do not have an opportunity to use an upgrade evaluation site to preview the new user interface or change their original site before upgrading. We do not recommend that you upgrade all site collections immediately as part of your initial upgrade. However, you might want to upgrade all site collections after some time has passed and all customizations were verified in 2013 mode.

To upgrade all site collections in a database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSite -ContentDatabase <DBName> -Limit All | Upgrade-SPSite -VersionUpgrade -QueueOnly

    Where:

    • <DBName> is the name of the content database for which you want to upgrade all site collections.

    The -QueueOnly parameter adds the site collections to the upgrade queue. This allows the timer job to perform parallel upgrades when it is possible and can save time. The sites are upgraded in the order in which they are added to the queue.

This cmdlet upgrades all site collections in the specific content database to 2013 mode.

View upgrade status by using Windows PowerShell

You can view upgrade status for all databases, for a single site collection, or for all site collections.

To view upgrade status for a single site collection by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSiteUpgradeSessionInfo -Site <http://site>

    Where:

    • <http://site> is the URL of the site collection.

    This cmdlet returns the upgrade status for the specified site collection together with information about the upgrade session and a link to the log files for more information. For more information, see Get-SPSiteUpgradeSessionInfo.

  6. Or, you can use the following command to view the information about a specific site collection upgrade:

    Copy code
    $sc = Get-SPSite <http://site>
# Sets a variable for the site collection
$sc.CompatibilityLevel
# Returns the compatibility level for the site collection (either 14 or 15 for 2010 or 2013 mode)
$sc.UpgradeInfo
# Returns the upgrade information for the site collection

    Where:

    • <http://site> is the URL of the site collection.

    This command returns the compatibility level and upgrade information (such as a pointer to the log file) for the specified site collection. If the compatibility level is "15," then it has been upgraded to 2013 mode. For more information, see Get-SPSite.

To view upgrade status for a single database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSiteUpgradeSessionInfo -ContentDatabase <DatabaseName> -ShowInProgress -ShowCompleted -ShowFailed

    Where:

    • <DatabaseName> is the name of the database that you want to check.

    This cmdlet returns any site collections that have an upgrade in progress, completed, or failed and lists their status, plus a link to the log files for more information. You can use only one parameter to find only in progress, completed, or failed upgrades. For more information, see Get-SPSiteUpgradeSessionInfo.

To view upgrade status for all site collections by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSite -Limit All

This cmdlet returns the URL for all site collections in the environment and the compatibility level (14 or 15) for each site collection.

See also

Plan for site collection upgrades in SharePoint 2013
Upgrade a site collection to SharePoint 2013
Overview of the upgrade process to SharePoint 2013
Run site collection health checks in SharePoint 2013
Upgrade site collections to SharePoint 2013
Review site collections upgraded to SharePoint 2013

Upgrade and Migration in SharePoint 2013 Resource Center


Advanced upgrade scenarios for SharePoint 2013

Updated: April 2, 2013

Summary: Learn how to upgrade to SharePoint 2013 in advanced scenarios, such as from Office SharePoint Server 2007 or Windows SharePoint Services 3.0, from FAST Search Server, or when using content type syndication.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about how to upgrade to SharePoint 2013 in advanced scenarios.

TechNet articles about how to upgrade in advanced scenarios

The following articles about how to upgrade in advanced scenarios are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Upgrade from Office SharePoint Server 2007 or Windows SharePoint Services 3.0 to SharePoint Server 2013 or SharePoint Foundation 2013 | Learn how to use the database-attach method to upgrade from Windows SharePoint Services 3.0 or Office SharePoint Server 2007 to SharePoint 2013.
Search-first migration from FAST Search Server for SharePoint 2010 to SharePoint Server 2013 | Learn how to perform a search-first migration from Microsoft FAST Search Server 2010 for SharePoint to Microsoft SharePoint Server 2013.
How to upgrade an environment that uses content type syndication (SharePoint Server 2013) | Upgrade the Managed Metadata service application and site collections that use content type syndication and share the service applications to the old farm.

For descriptions of additional cross-product upgrade paths that are allowed, see the following articles:

  • Review supported editions and products for upgrading to SharePoint 2013

  • Determine strategy for upgrade to SharePoint 2013

Additional resources about upgrade

The following resources about upgrade are available from other subject matter experts.

 | Content | Description
TechNet logo | Upgrade and Migration Resource Center for SharePoint 2013 Products | Visit the Resource Center to find additional information about upgrades to SharePoint 2013.

Change History

Date | Description
April 02, 2013 | Added link to How to upgrade an environment that uses content type syndication (SharePoint Server 2013).
January 22, 2013 | Initial publication


Upgrade from Office SharePoint Server 2007 or Windows SharePoint Services 3.0 to SharePoint Server 2013 or SharePoint Foundation 2013
See also

Published: January 22, 2013

Summary: Learn how to use the database-attach method to upgrade from Windows SharePoint Services 3.0 or Office SharePoint Server 2007 to SharePoint 2013.

Applies to: SharePoint Server 2007 | Windows SharePoint Services 3.0 | SharePoint Server 2013 | SharePoint Foundation 2013

You cannot upgrade directly from the server products in the Office 2007 release to SharePoint 2013. The changes between versions are too great, and the hardware requirements differ so much between versions that a direct upgrade is not possible or supported. However, you can perform a series of database-attach upgrades to first upgrade your content to SharePoint 2010 Products and then to SharePoint 2013. This article describes how to perform these sequential database-attach upgrades.

Note:

During this whole process, your old environment should be offline or in read-only mode to prevent users from making changes in the old environment while you upgrade. After you finish and validate the upgrade, you can grant access to users in the SharePoint 2013 environment.

Process overview

Because this upgrade approach combines two upgrade processes that are already documented in the TechNet library, this article describes how the steps from each process fit together into the overall process. It does not provide details for every step, because those steps are available in the following articles:

  • Perform a database attach upgrade to SharePoint Server 2010 and Checklist for database attach upgrade (SharePoint Server 2010)

  • Upgrade databases from SharePoint 2010 to SharePoint 2013 and Checklist for database-attach upgrade (SharePoint 2013)

These combinations of articles and this roadmap give you the information to perform the sequential database-attach upgrades.

Important:

Make sure that you test this whole process in a test environment before you upgrade your actual live content. For more information about how to test an upgrade processes, see the following content:

  • For SharePoint 2010 Products see the Use a trial upgrade to find potential issues (SharePoint Server 2010) article and the Test your upgrade process model on TechNet.

  • For SharePoint 2013 see the Use a trial upgrade to SharePoint 2013 to find potential issues article and the Test your upgrade process model on TechNet.

Upgrade sequence

To upgrade your content across the two versions, follow these steps.

  1. Prepare to upgrade

    1. Prepare your original farm. Be sure that you have installed the latest software updates for Windows SharePoint Services 3.0 or Office SharePoint Server 2007. You must have Service Pack 2 at a minimum before you run the pre-upgrade checker and make an inventory of all the customizations on the Upgrade worksheet for SharePoint Server 2010.

      For a list of available updates for Windows SharePoint Services 3.0 and Office SharePoint Server 2007, see Updates for SharePoint Products and Technologies.

    2. Set up a small, temporary farm that is running SharePoint Foundation 2010 or SharePoint Server 2010 depending on whether you're upgrading from Windows SharePoint Services 3.0 or Office SharePoint Server 2007. Ensure that the latest service packs and updates are installed on this temporary farm. For information about requirements, Review required hardware and software.

      For a list of updates available for SharePoint Foundation 2010 and SharePoint Server 2010, see Updates for SharePoint 2010 Products.

    3. Set up your full SharePoint Foundation 2013 or SharePoint Server 2013 farm, and verify that it is configured and running correctly.

  2. First upgrade: Upgrade the content to SharePoint 2010 Products

    1. Use SQL Server to make a backup of the content databases on the Windows SharePoint Services 3.0 or Office SharePoint Server 2007 farm, restore the backups to the SharePoint Foundation 2010 or SharePoint Server 2010 farm, and then take the old farm offline.

    2. Attach the copies of the content databases to the SharePoint Foundation 2010 or SharePoint Server 2010 farm and upgrade them (optionally, you can upgrade them in parallel).

    3. Verify that the content was upgraded and that the SharePoint Foundation 2010 or SharePoint Server 2010 farm is working correctly.

  3. Second upgrade: Upgrade the content to SharePoint 2013

    1. Use SQL Server to make a backup of the content databases on the SharePoint Foundation 2010 or SharePoint Server 2010 farm, and then restore them to the SharePoint Foundation 2013 or SharePoint Server 2013 farm.

    2. Attach the copies of the content databases to the SharePoint Foundation 2013 or SharePoint Server 2013 farm and upgrade them (optionally, you can upgrade them in parallel).

    3. Verify that the content was upgraded and that the SharePoint Foundation 2013 or SharePoint Server 2013 farm is working correctly.

    4. Upgrade the site collections.

  4. Start serving requests on the SharePoint 2013 farm

The following diagrams illustrate this process:

  • The process to upgrade to SharePoint 2010 Products:

    Upgrade from the server products in the Office 2007 release to SharePoint 2010 Products.

    Upgrade from 2007 to a temporary 2010 farm

  • The process to upgrade to SharePoint 2013:

    Upgrade from SharePoint 2010 Products to SharePoint 2013.

    Upgrade from temporary 2010 farm to 2013

Before you begin

Before you begin an upgrade, review the following information about permissions, hardware requirements, and software requirements. Follow the specified steps to install or configure prerequisite software or to change settings.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Review required permissions

  • When you create your temporary environment for SharePoint Foundation 2010 or SharePoint Server 2010, you must have the appropriate permissions. For more information, see Plan for administrative and service accounts (SharePoint Foundation 2010) or Plan for administrative and service accounts (SharePoint Server 2010).

  • When you create and configure your destination SharePoint Foundation 2013 or SharePoint Server 2013 farm, you must have the appropriate permissions. For more information, see Plan for administrative and service accounts in SharePoint 2013.

Review required hardware and software

  • When you create your temporary environment for SharePoint Foundation 2010 or SharePoint Server 2010, you must meet specific hardware and software requirements. For more information, see Hardware and software requirements (SharePoint Foundation 2010) or Hardware and software requirements (SharePoint Server 2010).

  • When you create and configure your destination SharePoint 2013 farm, you must meet different hardware and software requirements. For more information, see Hardware and software requirements for SharePoint 2013.

In some environments, you must coordinate procedures that move databases to a separate farm with the database administrator. Make sure that you follow all applicable policies and guidelines for handling databases.

Prepare to upgrade

Because you perform two upgrades, you must understand every step that is involved in the upgrade to SharePoint 2010 Products and the upgrade to SharePoint 2013. The following content helps you understand these upgrade processes:

Prepare to upgrade to SharePoint 2010 Products

For SharePoint Server 2010:

  • Read the About the upgrade process (SharePoint Server 2010) chapter and the Plan and prepare for upgrade (SharePoint Server 2010) chapter on TechNet.

    In particular, read the following articles:

    • Upgrade process overview (SharePoint Server 2010)

    • Review system requirements for upgrade (SharePoint Server 2010)

    • Review upgrade best practices (SharePoint Server 2010)

    • Determine how to handle customizations (SharePoint Server 2010)

  • Read the Perform pre-upgrade steps (SharePoint Server 2010) chapter on TechNet. You must perform the following step for a database-attach upgrade:

    • Run the pre-upgrade checker (SharePoint Server 2010)

    Important:

    Follow these steps on your existing Office SharePoint Server 2007 farm.

For SharePoint Foundation 2010:

  • Read the About the upgrade process (SharePoint Foundation 2010) chapter and the Plan and prepare for upgrade (SharePoint Foundation 2010) chapter on TechNet.

    In particular, read the following articles:

    • Upgrade process overview (SharePoint Foundation 2010)

    • Review system requirements for upgrade (SharePoint Foundation 2010)

    • Review upgrade best practices (SharePoint Foundation 2010)

    • Determine how to handle customizations (SharePoint Foundation 2010)

  • Read the Perform pre-upgrade steps (SharePoint Foundation 2010) chapter on TechNet. You must perform the following step for a database-attach upgrade:

    • Run the pre-upgrade checker (SharePoint Foundation 2010)

    Important:

    Follow these steps on your existing Windows SharePoint Services 3.0 farm.

Prepare to upgrade to SharePoint 2013

  • Plan and prepare for upgrade. Read the Get started with upgrades to SharePoint 2013 chapter and the Plan for upgrade to SharePoint 2013 chapter on TechNet.

    In particular, read the following articles:

    • Overview of the upgrade process to SharePoint 2013

    • Best practices for upgrading to SharePoint 2013

    • Create a plan for current customizations during upgrade to SharePoint 2013

    • Plan for performance during upgrade to SharePoint 2013

    • Clean up an environment before an upgrade to SharePoint 2013

Prepare your farms

In this step, you follow the pre-upgrade steps on your existing farm, create your temporary farm for the upgrade to SharePoint Foundation 2010 or SharePoint Server 2010, and create your destination SharePoint Foundation 2013 or SharePoint Server 2013 farm. Use the following steps and related content when you prepare your farm for the upgrades.

Run the pre-upgrade checker

For information, see Run the pre-upgrade checker (SharePoint Foundation 2010) or Run the pre-upgrade checker (SharePoint Server 2010).

Create the temporary SharePoint 2010 Products farm

In a virtual or physical environment, create a temporary small farm that is running SharePoint Foundation 2010 or SharePoint Server 2010 depending on whether you're upgrading from Windows SharePoint Services 3.0 or Office SharePoint Server 2007. You will use this farm to upgrade your content to SharePoint Foundation 2010 or SharePoint Server 2010 on the way to SharePoint Foundation 2013 or SharePoint Server 2013.

Tip:

For best results, we recommend that you apply the latest updates to the environment. For a list of available updates, see Updates for SharePoint 2010 Products.

  1. Download the software for the temporary farm.

    • You can use the trial version of SharePoint Foundation 2010 or SharePoint Server 2010 in this temporary environment if you do not have a license agreement for the full product. You can use the trial version or 180 days. Download the trial version at Download Microsoft SharePoint Server 2010.

    • You can download SharePoint Foundation 2010 at Microsoft SharePoint Foundation 2010

  2. Install all language template packs that your sites need. For more information, see Deploy language packs (SharePoint Foundation 2010) or Deploy language packs (SharePoint Server 2010).

  3. To configure the farm, use the appropriate farm settings for your environment and reinstall all of the customizations that your content needs. You must create web applications on the temporary farm for every web application that you had in your original farm. The URL for the new web applications should match either the source farm URLs or the destination farm URLs. Otherwise, you might add references to additional temporary URLs to the content. Ideally, you should use the same URLs for the source farm and destination farm so that the temporary farm URLs are identical. This includes the port numbers.

    For more information about how to configure the farm, see Prepare the new SharePoint Foundation 2010 environment for a database attach upgrade or Prepare the new SharePoint Server 2010 environment for a database attach upgrade.

Set up your full SharePoint 2013 farm

This is the farm you will use for your production environment eventually. Therefore, make sure that you plan your infrastructure appropriately to support the solution that you are hosting. For more information about how to plan your server farm, see Plan for SharePoint 2013.

  1. Create your farm on 64-bit hardware with database servers that run a 64-bit version of SQL Server 2008 R2 with Service Pack 1 (SP1) or SQL Server 2012. For more information, see Install SharePoint 2013.

  2. Install all language template packs that your sites need. For more information, see Install or uninstall language packs for SharePoint 2013.

  3. To configure the farm, use the appropriate farm settings for your environment and reapply all of the customizations that your content needs. Again, you must create web applications on the destination farm for every web application that you had in your original farm.

    For specific information about how to create and configure a server farm for a database-attach upgrade, see Create the SharePoint 2013 farm for a database attach upgrade.

Perform the first upgrade

After you have set up and configured your farms, you are ready to upgrade your content databases to SharePoint Foundation 2010 or SharePoint Server 2010.

Important:

Run the pre-upgrade checker and review the report so that you can address any potential issues on your temporary farm before you upgrade the content. For more information, see Run the pre-upgrade checker (SharePoint Foundation 2010) or Run the pre-upgrade checker (SharePoint Server 2010).

To perform a database-attach upgrade, follow these steps:

  1. Back up the content databases.

    Content databases are any databases that use the "_content" suffix.

  2. Restore the backed-up copies to your temporary farm.

  3. Attach the databases to the web applications to start the upgrade process. You can attach databases in parallel to speed up the upgrade process.

For complete information and steps to follow, see Attach databases and upgrade to SharePoint Server 2010.

After upgrade, you might have to perform additional steps for specific services. For more information, see Attach databases and upgrade to SharePoint Foundation 2010 or Perform post-upgrade steps for a database attach upgrade (SharePoint Server 2010).

Verify the first upgrade

To verify the upgrade, do the following:

  • Review the upgrade log file.

  • Validate the upgraded environment.

  • Review the upgraded sites to make sure that they still work as expected and that all Web Parts and other custom elements work correctly.

For more information, see Verify upgrade and review upgraded sites (SharePoint Foundation 2010) or Verify upgrade and review upgraded sites (SharePoint Server 2010).

Perform the second upgrade

After you have verified that your sites work correctly, you can start the upgrade to SharePoint 2013.

To perform the database-attach upgrade, follow these steps:

  1. Back up the content databases.

  2. Restore the backed-up copies to your destination farm.

  3. Attach the databases to the web applications to start the upgrade process. You can attach databases in parallel to speed up the upgrade process.

For complete information and steps to follow, see Upgrade databases from SharePoint 2010 to SharePoint 2013.

Verify the second upgrade

To verify the upgrade, do the following:

  • Review the upgrade log file.

  • Validate the upgraded environment.

For more information, see Verify database upgrades in SharePoint 2013.

Upgrade site collections

In SharePoint 2013, site collection upgrade is a separate process from upgrading the content databases. After you have upgraded your environment, either the site collection administrator or the farm administrator can upgrade each site collection. For more information, see Upgrade site collections to SharePoint 2013.

See also

Downloadable book: Upgrading to SharePoint Server 2010
Downloadable book: Upgrading to Microsoft SharePoint Foundation 2010
Upgrade and migration Resource Center for SharePoint Foundation 2010
Resource Center: Upgrade and Migration for SharePoint Server 2010
Upgrade and Migration Resource Center for SharePoint 2013 Products


Search-first migration from FAST Search Server for SharePoint 2010 to SharePoint Server 2013

Published: March 19, 2013

This article describes how to perform a search-first migration from Microsoft FAST Search Server 2010 for SharePoint to SharePoint Server 2013.

Applies to: SharePoint Server 2013 | FAST Search Server 2010 for SharePoint

Introduction to search-first migration (SharePoint Server 2013)

Upgrading from FAST Search Server 2010 for SharePoint to SharePoint Server 2013 provides significant improvements in enterprise search capabilities. However, policy or resource constraints in an organization may pose challenges that prevent or postpone a complete upgrade. Even if your organization is not ready to perform a complete upgrade from FAST Search Server 2010 for SharePoint, you can take advantage of new SharePoint Server 2013 search capabilities by performing a search-first migration.

To be able to configure and use certain features, such as Result sources, you must perform a full migration of your farm from FAST Search Server 2010 for SharePoint to SharePoint Server 2013.

When you've completed a search-first migration, you run your system in "mixed mode." Mixed mode is when a FAST Search Server 2010 for SharePoint Enterprise Search Center is used to consume SharePoint Server 2013 search. Users can still use the FAST Search Server 2010 for SharePoint Enterprise Search Center, but queries will be sent to the SharePoint Server 2013 index.

Running your system in mixed mode means that you do not upgrade the content of your farm or the site collection to SharePoint Server 2013. The FAST Search Server 2010 for SharePoint farm can continue to provide other FAST Search Server 2010 for SharePoint functionality for your organization. FAST Search Server 2010 for SharePoint features, such as content databases and the Business Data Catalog, are not migrated or upgraded as part of a search-first migration. Functionality that is not related to search does not have to be configured in the new SharePoint Server 2013 farm. Some FAST Search Server 2010 for SharePoint features will only work in backward compatibility mode.

Your organization can complete the product upgrade at any time.

Note:

Due to the many architectural changes between FAST Search Server 2010 for SharePoint and SharePoint Server 2013, not all configurations and features can be migrated. If you are unsure of the implications of a migration from FAST Search Server 2010 for SharePoint to SharePoint Server 2013, we strongly recommend that you contact a trusted Microsoft partner or Microsoft Consulting Services for guidance.

For more information, see:

  • Features with limitations

  • FAST Search Server 2010 for SharePoint deprecated features

Supported migration path

Search-first migration supports only the partial migration of search capabilities from a FAST Search Server 2010 for SharePoint farm to a SharePoint Server 2013 farm.

High-level search-first migration steps

1.Migrate settings. 2. Migrate search settings to new SSA. Using SharePoint Server 2013 SSA, index content from SharePoint Server 2010 farms. Connect SharePoint Server 2010 Search Center to SharePoint Server 2013. Consume search. 3. Disconnect servers.

Make sure that you have a FAST Search Server 2010 for SharePoint production farm with at least one Search service application. This production farm must also be configured and operating with enterprise search functionality.

To complete a search-first migration:

  1. Install SharePoint Server 2013 on a single server with an additional dedicated SQL Server.

    See also: Install SharePoint 2013 on a single server with SQL Server

  2. On the SharePoint Server 2013SQL Server, install:

    • Microsoft .NET Framework version 4.5

    • PowerShell Snapins for SQL Server

  3. On the FAST Search Server 2010 for SharePoint farm, back up these databases:

    • FAST Search Administration database

    • FAST Content Search Service Application database

    • FAST Query Search Service Application database

  4. Download the search-first migration scripts from TechNet Gallery. For details and guidance on using these scripts, refer to the PDF included in the download package.

    • Edit the environment variables in the scripts.

    • Save and copy the scripts to the SQL Server and to the SharePoint Server 2013 server.

  5. On the SharePoint Server 2013SQL Server, run the search-first migration scripts.

  6. On the SharePoint Server 2013 server, run the search-first migration scripts.

  7. Build out the new SharePoint Server 2013 farm topology. For instructions on how to do this, see Manage the search topology in SharePoint Server 2013.

  8. On the SharePoint Server 2013, start crawling.

Note:

For information about limitations, see Features with limitations.

Summary of search-first migrated features

Feature name Migrated

Crawled properties

Yes

Custom managed properties created in addition to the default set

Yes

New mappings to default managed properties

Yes

Content sources

Yes

Crawl rules

Yes

Crawl schedules

Yes

Scopes and scope filters

  • In most cases, scopes and scope filters work after migration, but you cannot edit or change them.

  • Scope filters usually contain Path: or Site: restrictions. SharePoint Server 2013 does not tokenize the URLs. When you apply a scope filter, you might not obtain the same results after migrating to SharePoint Server 2013.

  • If the migration is complete, that is to say, if both content source and front end are upgraded to SharePoint Server 2013, Result sources replace the Scopes feature.

Yes

Federated locations

Yes

Best Bets

Yes

Visual Best Bets

Visual Best Bets are converted to Best Bets

Synonyms tied to Best Bets and Visual Best Bets

Yes

Synonyms used for query expansion

No

Promotions and demotions

No

Inclusion and exclusion dictionaries (entity extraction, spellcheck)

No

Optional processing dictionaries

No

Content processing extensibility

No

Large scale index configuration

No

Managed properties for "people search"

No

Business Connectivity Services (BCS) connector and its associated configuration

No

Custom connectors and their associated configuration

No

Rank profile

Note:

A FAST Search Server 2010 for SharePoint rank profile can't be converted to a SharePoint Server 2013 ranking model.

No

Features with limitations

When you run SharePoint Server 2013 in mixed mode, certain features will function with limitations. You'll have to use manual workarounds for these features to work correctly. The following sections explain:

  • Limitations when you migrate from FAST Search Server 2010 for SharePoint Search Center to SharePoint Server 2013

  • Limitations after a full migration to SharePoint Server 2013

Limitations when you migrate from FAST Search Server 2010 for SharePoint Search Center to SharePoint Server 2013

Feature name Limitation

Document previews

Document previews is not a backward compatible feature because SharePoint Server 2013 can't render Document previews that are generated by a FAST Search Server 2010 for SharePoint content farm.

Duplicate documents link in the search results page

The Duplicate documents link is displayed in the search results page. However, it displays no duplicate documents when it is clicked. To avoid confusion, you can disable this link by editing the XSLT file in the Core results Web Part.

Author refiner

The Author managed property was redefined and replaced by the managed property DisplayAuthor in SharePoint Server 2013. The migration script migrates the Author refiner without changing it. To make the Author refiner work, you must manually edit the XSLT in the refinement panel, and change the Author to DisplayAuthor.

Site refiner

In SharePoint Server 2013, the managed property SPSiteURL is used to populate the site refiner. If there are problems with the site refiner after migration, verify that:

  • The properties Basic:4 and ows_SPSiteURL are mapped to SPSiteURL.

  • RespectPriority of SPSiteUrl is set to true.

See also FAST Search Server 2010 for SharePoint deprecated features.

Limitations after a full migration to SharePoint Server 2013

Feature name | Limitation
Best Bets | SharePoint Server 2013 does not support Best Bets. The feature's been replaced by query rules. Best Bets are not automatically converted to query rules, so you have to create new query rules.
Front end | It isn't possible to automatically upgrade the FAST Search Server 2010 for SharePoint front end.


How to upgrade an environment that uses content type syndication (SharePoint Server 2013)

Published: April 9, 2013

Summary: Upgrade the Managed Metadata service application and site collections that use content type syndication and share the service applications to the old farm.

Applies to: SharePoint Server 2013

Content type syndication, or content type publishing, occurs when you publish a content type from a content type "hub" site collection to one or more "consuming" site collections. For more information, see Introduction to content types and content type publishing and Plan to share terminology and content types (SharePoint Server 2010).

Suppose that you use content type syndication in SharePoint Server 2010. Now you want to upgrade to SharePoint Server 2013, but you want to upgrade some site collections now and others later. In this situation, you have to follow a specific process to make sure that all content types can continue to work across versions.

Content type syndication uses the backup and restore mechanism in SharePoint Server to publish the content types across site collections. And backup and restore does not work across versions in the following scenarios:

  • Between 2010 and 2013

  • Between sites in 2010 mode on a 2013 farm and those in 2013 mode on a 2013 farm

For this reason, you have to set up sharing with multiple Managed Metadata service applications and proxies to be able to publish content types to each site collection in the appropriate version. A proxy is a connection that associates a service application with a web application.

Initial state

This article uses a specific example environment to show how to configure the service applications and connections (proxies) before you upgrade the site collections. At the start, this example environment contains the following components:

  • A Managed Metadata service application

  • A site collection based on the Document Center template

    This site collection acts as a content type hub (ContentTypeHub1) that contains the document and document set content types.

  • Two consuming site collections that are also based on the Document Center template

    The content type hub publishes documents and document set content types to these site collections.

The following illustration shows this example environment before the start of the upgrade process.

SharePoint 2010 farm with content type syndication

Original server farm for SharePoint Server 2010 that shows the Managed Metadata service application, a content type hub (ContentTypeHub1), and two consuming sites that use content syndication.

Here is more information about this illustration:

  • The Managed Metadata service application has a Content Type Hub property that is set to point to the ContentTypeHub1 site collection.

    For information about how to share content types, see Plan to share terminology and content types (SharePoint Server 2010).

  • The following Managed Metadata connection properties are selected:

    • This service application is the default storage location for Keywords.

    • This service application is the default storage location for column specific term sets.

    • Consumes content types from the Content Type Gallery at <URL>.

    • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type.

    For information about connection properties, see Managed metadata connections and Update a managed metadata service connection.

  • A document content type (Doc1) and a document set content type (DocSet1) were published from ContentTypeHub1 to the two consuming sites.

    For information about publishing content types, see Publish a content type from a content publishing hub.

  • Both consuming site collections contain document libraries that use the two content types, and documents that are based on the two published content types are stored in those libraries.

Back up the data and create a duplicate content type hub in the SharePoint 2010 environment

If you want to continue to use any of the consuming site collections in the 2010 environment but upgrade others, you must upgrade your environment so that you have a 2010 version of the content type hub and a 2013 version. The following illustration and list describe the steps to take to back up the databases and sites in preparation for upgrade, and to create a duplicate content type hub to continue service site collections in the SharePoint 2010 environment.

Original server farm for SharePoint Server 2010

Backups for upgrade: a database backup of the Managed Metadata service application, ContentTypeHub1 and the two consuming sites; a site collection backup of ContentTypeHub1. This is restored to a new web application then backed up again.

  1. Use SQL Server Management Studio to back up the database for the Managed Metadata service application.

    Name the backup something that you can remember, such as ManagedMetadata2010DB.bak. For information, see Back up the SharePoint 2010 Products databases by using SQL Server tools.

  2. Use SQL Server Management Studio to back up the database or databases that contain the content type hub and consuming site collections.

    Name the backup something that you can remember, such as 2010ContentHubDB.bak.

  3. Use Central Administration or the Backup-SPSite Windows PowerShell cmdlet to perform a site collection backup of the original content type hub.

    For more information, see Back up a site collection in SharePoint Server 2010.

    Clear the following Managed Metadata connection properties:

    • This service application is the default storage location for Keywords.

    • This service application is the default storage location for column specific term sets.

    • Consumes content types from the Content Type Gallery at <URL>.

    • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type.

    For information about connection properties, see Update a managed metadata service connection.

  4. Create a web application to host a duplicate of the content type hub.

    For information, see Create a web application (SharePoint Server 2010).

  5. Use the Restore-SPSite Windows PowerShell cmdlet to restore a copy of the original content type hub. Use the following syntax:

    Copy code
    Restore-SPSite <URL> -path <path>

    Where:

    • <URL> is the URL for the new web application.

    • <path> is the path of the backup file.

    For information, see Restore a site collection in SharePoint Server 2010.

    After you restore the site collection, you can change the name to ContentTypeHub2.

  6. Use SQL Server Management Studio to back up the database that contains the duplicate content type hub.

You now have SQL Server backups of the databases for the Managed Metadata service application, the consuming site collections, and a copy of the content type hub (now in a separate database from the consuming site collections). In the next section, you create and configure the 2013 farm, restore these databases, and upgrade them to 2013.

Restore databases and upgrade the Managed Metadata service application and site collections to SharePoint Server 2013

Now you can create the SharePoint Server 2013 environment, and restore the databases that you backed up from the 2010 environment. After you restore them in SQL Server Management Studio, you can upgrade the Managed Metadata service application, upgrade the content databases, and create the site collections.

The following illustration shows the steps to follow to restore and upgrade the databases and site collections to the 2013 environment.

Note:

Make sure that no other managed metadata service applications are in the 2013 environment.

New SharePoint 2013 farm

New farm for SharePoint Server 2013 that shows the databases being restored and upgraded for Managed Metadata service application, ContentTypeHub1 and consuming sites, and ContentTypeHub3.

  1. Use SQL Server Management Studio to restore the databases for the Managed Metadata service application and the two content databases for the original content type hub (ContentTypeHub1) and consuming sites, and the duplicate content hub.

  2. Use Windows PowerShell to create a Managed Metadata service application and use the restored database. This upgrades the information from the Managed Metadata service application in the original farm and also creates a connection (or proxy) for the new Managed Metadata service application (Managed Metadata 1).

    For information, see Upgrade the Managed Metadata service application.

  3. For the new Managed Metadata connection (proxy), in Central Administration, clear the following properties:

    • This service application is the default storage location for Keywords.

    • This service application is the default storage location for column specific term sets.

    • Consumes content types from the Content Type Gallery at <URL>.

    • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type.

    For more information, see Update a managed metadata service connection.

  4. Create a web application to host the upgraded content type hub (ContentTypeHub1) and consuming site collections. Be sure to use the same authentication method as was used in the 2010 environment.

    For information, see Create web applications.

  5. Test, and then attach the content database that contains the original content type hub (ContentTypeHub1) and consuming site collections to upgrade the database.

    For information, see Verify custom components and Attach a content database to a web application and upgrade the database.

    Note:

    When you upgrade the content database, the site collections remain in 2010 mode in the 2013 farm. Do not upgrade the site collections to 2013 mode yet. You upgrade the site collections later in this process.

  6. Use the Set-SPMetadataServiceApplication Windows PowerShellcmdlet to configure the upgraded Managed Metadata service application to point to the upgraded content type hub. Use the following syntax:

    Copy code
    Set-SPMetadataServiceApplication -Identity "<ServiceApplication>" -HubURI "<HubURI>"

    For information, see Set-SPMetadataServiceApplication.

  7. Upgrade the ContentTypeHub1 site collection to 2013 mode.

    For information, see Upgrade a site collection.

  8. Upgrade the content database that contains the duplicate content type hub (ContentTypeHub2 in the old farm) and name it ContentTypeHub3. Leave the ContentTypeHub3 in 2010 mode.

    For information, see Attach a content database to a web application and upgrade the database.

At this point, you have the following site collections in the 2013 environment:

Site collection | Site collection mode (version) | Description
ContentTypeHub1 | 2013 mode | Content type hub for sites in 2013 mode
ContentTypeHub3 | 2010 mode | Content type hub for sites in 2010 mode
ConsumingSite1 | 2010 mode | Consumes shared content types
ConsumingSite2 | 2010 mode | Consumes shared content types

Create additional Managed Metadata service applications and republish the content types

Now you are ready to create the Managed Metadata service applications that will serve content type hubs and consuming site collections running in 2010 mode in both the 2010 farm and the 2013 farm. After you create and configure those service applications, you share the Managed Metadata service application that is used for sites in 2013 mode (and that also serves as the term store for both farms) (Managed Metadata 1), and the Managed Metadata service application that is used for sites in the 2010 farm (Managed Metadata 3). After you share the service applications, you can republish the content types in both farms.

The following illustration shows the steps to create additional Managed Metadata service applications and republish the content types. All of these steps are performed in the new 2013 farm.

Create Managed Metadata service applications and re-publish content types.

SharePoint Server 2013 farm that shows two new Managed Metadata service applications that have been created. Then, content types are republished from the content type hubs to consuming sites.

  1. In Central Administration, create a Managed Metadata service application (Managed Metadata 2) and set the Content Type Hub property to the duplicate content type hub in the new farm (ContentTypeHub3).

    When you use Central Administration to create a Managed Metadata service application, the Managed Metadata connection (proxy) is created at the same time as the service application. For more information, see Create a managed metadata service application.

    For the new Managed Metadata connection, clear the following properties:

    • This service application is the default storage location for Keywords.

    • This service application is the default storage location for column specific term sets.

    • Consumes content types from the Content Type Gallery at <URL>.

    • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type.

    For more information, see Update a managed metadata service connection.

  2. In Central Administration, create a Managed Metadata service application (Managed Metadata 3) and set the Content Type Hub property to the original content type hub in the 2010 environment (ContentTypeHub1 in the 2010 farm).

    When you use Central Administration to create a Managed Metadata service application, the Managed Metadata connection (proxy) is created at the same time as the service application. For more information, see Create a managed metadata service application.

    For the new Managed Metadata connection, clear the following properties:

    • This service application is the default storage location for Keywords.

    • This service application is the default storage location for column specific term sets.

    • Consumes content types from the Content Type Gallery at <URL>.

    • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type.

    For more information, see Update a managed metadata service connection.

  3. Share the Managed Metadata 1 and Managed Metadata 3 service applications to the 2010 environment.

    Do not share Managed Metadata 2 with the 2010 environment. It is used only for sites in the 2013 farm.

    For more information, see Share service applications across farms in SharePoint 2013.

    At this stage, the 2010 environment has two additional connections (proxies), one for each service application that was shared in the previous step.

  4. Republish the content types in the 2013 environment:

    • On the 2013 content type hub that was upgraded to 2013 mode (ContentTypeHub1), republish all of the content types that were published before (Doc1 and DocSet1).

    • On the 2013 duplication content type hub that is in 2010 mode (ContentTypeHub3), republish all of the content types that were published before (Doc1 and DocSet1).

    For more information, see Publish a content type from a content publishing hub.

  5. Republish the content types in the 2010 environment:

    • On the 2010 content type hub (ContentTypeHub2), republish all of the content types that were published before (Doc1 and DocSet1).

Configure connections (proxies)

The final phase in the process is to configure the connections (proxies) for all of the Managed Metadata service applications.

The following illustration shows the connections (proxies) between the farms and the order in which they are configured.

Configure connections (or proxies) for the Managed Metadata service applications across the 2010 and 2013 farms

New farm that shows the connections (proxies) for the three Managed Metadata service applications needed for the three versions of content type hubs (2013 mode in 2013 farm, 2010 mode in 2013 farm, and 2010 farm).

  1. On the 2010 farm, on the Manage Service Applications page in Central Administration, set the following properties for the Connection to the Managed Metadata service (Managed Metadata 3):

    • Consumes content types from the Content Type Gallery at <URL>.

    • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type.

    This enables ContentTypeHub2 in the 2010 farm to consume content types that are published through the Managed Metadata 3 service application.

  2. On the 2010 farm, on the Manage Service Applications page in Central Administration, set the following properties for the Connection to the Managed Metadata service (Managed Metadata 1):

    • This service application is the default storage location for Keywords.

    • This service application is the default storage location for column specific term sets.

    This enables ContentTypeHub2 in the 2010 farm to consume terms from the term store in the Managed Metadata 1 service application.

  3. On the 2013 farm, for the connection (Managed Metadata 3) for the 2010 mode content type hub (ContentTypeHub3), clear the following properties:

    • This service application is the default storage location for Keywords.

    • This service application is the default storage location for column specific term sets.

    • Consumes content types from the Content Type Gallery at <URL>.

    • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type.

    This causes ContentTypeHub3 to be unable to consume any resources from the Managed Metadata 3 service application. Managed Metadata 3 is only used to provide content type syndication to the 2010 farm.

  4. On the 2013 farm, for the connection (Managed Metadata 2) for the duplicate content type hub (ContentTypeHub3), select the following properties:

    • Consumes content types from the Content Type Gallery at <URL>.

    • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type.

    This enables ContentTypeHub3 on the 2013 farm to consume content types that are published through the Managed Metadata 2 service application.

  5. On the 2013 farm, for the connection for the upgraded content type hub (Managed Metadata 1), select the following properties:

    • This service application is the default storage location for Keywords.

    • This service application is the default storage location for column specific term sets.

    • Consumes content types from the Content Type Gallery at <URL>.

    • Push-down Content Type Publishing updates from the Content Type Gallery to sub-sites and lists using the content type.

    This enables ContentTypeHub1 and any consuming sites in 2013 mode on the 2013 farm to consume content types that are published through the Managed Metadata 1 service application, and all content type hubs can consume terms from the term store in the Managed Metadata 1 service application.

Final state

When you have finished, the Managed Metadata connections (proxies) should be as seen in the following illustration:

New server farm for SharePoint Server 2013

Shows the final state for both farms, SharePoint Server 2013 and SharePoint Server 2010, with three Managed Metadata service applications and the connections serving three versions of content type hubs (2013 farm with 2013 and 2010 modes and 2010 farm).

Where:

  • Managed Metadata 1 is the service application that is used for content type syndication for the consuming sites in the 2013 farm that are in 2013 mode. This service application is also used for all term store operations in both the 2010 and 2013 farm.

  • Managed Metadata 2 is the service application that is used for content type syndication for the consuming sites in the 2013 farm that are still in 2010 mode.

  • Managed Metadata 3 is the service application that is used for content type syndication for the consuming sites in the 2010 farm.

Recommendations for how to manage content type syndication across the 2010 and 2013 farms

Now that you have two environments (2010 and 2013) that share content types, you must be careful how you manage shared content types when you create or change a shared content type.

When you add a content type, you must make sure that the content type ID is the same on all three Content Type Hubs. To do this, follow this procedure:

  1. On the 2013 farm, on the ContentTypeHub1, manually create the new content type and publish it.

  2. Identify the content type ID for that content type.

    Tip:

    You can use Windows PowerShell or the object model to extract the content type ID by using code. The content type ID is also encoded in the URL for the content type in the Content Type gallery. So an easier way to find the content type ID is to navigate to the Content Type Gallery for a site, and then click the content type. The URL to that content type contains a parameter, ctype, which is in fact the content type ID for that content type. For example, ctype=0x010100C0EE90869D5B8B46A4448713A9F8984C.

  3. Create a content type that uses that ID on both of the other content type hubs (ContentTypeHub2 and ContentTypeHub3), and then publish it.

    To create a content type that has a specific ID, you can't use the user interface. You have to use XML or the object model. For more information, see Creating Content Types.

When you add a new field to a content type, make sure that the field ID is the same on all three Content Type Hubs. To do this, follow this procedure:

  1. On the 2013 farm, on the ContentTypeHub1, manually create the new field for the content type and republish the content type.

  2. Use the object model or Windows PowerShell to extract the SchemaXML property of the SPContentType.

  3. Add the extracted property to the corresponding content type on both of the other content type hubs (ContentTypeHub2 and ContentTypeHub3).

  4. Republish the updated content type from the other content type hubs (ContentTypeHub2 and ContentTypeHub3).

    The following article on MSDN provides an example of how to use the object model to manipulate content types: SPContentType class.


Deploy software updates for SharePoint 2013

Updated: March 12, 2013

Summary: Learn how to prepare for, download, install, and then configure software updates and patches for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Microsoft periodically releases software updates for SharePoint 2013. The following articles on TechNet and related resources provide information about the software update process for SharePoint 2013.

TechNet articles about software updates for SharePoint 2013

The following articles about software updates for SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Software updates overview for SharePoint 2013 | Provides an overview of the software update process for SharePoint 2013.
 | Prepare to deploy software updates for SharePoint 2013 | Helps you determine which approach to use to update the servers or server farms in your environment, and lists the steps that you must take before you can start to install the update.
 | Install a software update (SharePoint 2013) | Learn how to install a software update on servers in a SharePoint farm.

Additional resources about software updates for SharePoint 2013

The following resources about software updates for SharePoint 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | Installation and Deployment for SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.

Change History

Date | Description
March 12, 2013 | Added link to Enable apps in AAM or host-header environments for SharePoint 2013.
February 12, 2013 | Initial publication


Software updates overview for SharePoint 2013

Published: February 12, 2013

Summary: Learn how to deploy a software update to a SharePoint 2013 farm.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Administrators update SharePoint 2013 to deploy or update assemblies that provide functionality and to upgrade databases. A successful update follows a methodical approach that minimizes interruptions in service. Review information in this article to learn about the process before you begin the update process.

In this article:

  • Terminology

  • Features

  • Intended audience and scope

  • Software update process

  • Software update strategy

  • Software update deployment cycle

Before you begin

Before you begin the software update process, review the following information about permissions, hardware requirements, and software requirements.

  • Account permissions and security settings in SharePoint 2013

  • Hardware and software requirements for SharePoint 2013

Terminology

To understand how to implement software updates in SharePoint 2013, it is important to understand the terminology for the core components.

Term | Definition | Comment
Cumulative Update (CU) | A CU is a rollup update that contains all previous critical on-demand hotfixes to date. Additionally, a CU contains fixes for issues that meet the hotfix acceptance criteria. These criteria may include the availability of a workaround, the effect on the customer, the reproducibility of the problem, the complexity of the code that must be changed, or other reasons. |
patch | A compiled, executable installer file that contains updates to one or more products. Examples of packages are the executable (.exe) files that you download to install a service pack, cumulative update (CU), or hotfix. Packages are also known as MSI files. |
software update | A software update is any update, update rollup, service pack, feature pack, critical update, security update, or hotfix that is used to improve or to fix a software product that is released by Microsoft Corporation. |
upgrade | Process by which you change an environment to use a newer version of software. You can upgrade to a minor release, such as an update or patch, or to a major release. An upgrade to a minor release is called a build-to-build upgrade. An upgrade to a major release is called a version-to-version upgrade. | In SharePoint 2013, for build-to-build upgrades, you can use either in-place or database-attach methods. For version-to-version upgrade, only database-attach is supported. For more information about version-to-version upgrade, see Overview of the upgrade process to SharePoint 2013. For an overview of the steps for in-place and database-attach upgrade for build-to-build upgrades, see Install a software update (SharePoint 2013)

For a complete list of terminology about software updates, see Description of the standard terminology that is used to describe Microsoft software updates.

Features

SharePoint 2013 has features that facilitate the end-to-end software update experience. Some of these features are as follows:

  • Backward compatibility between an updated services farm and non-updated content farm.

  • There is full support for automatic updates that use Windows Server Update Services (WSUS), Windows Update, and Microsoft Update.

    Note:

    An automatic update copies the binary files to the farm servers, but you must complete the software update by running the upgrade on the servers.

  • Administrators can use the SharePoint Central Administration website or Windows PowerShell to monitor the status of an update.

Intended audience and scope

Information in this article is for all IT professionals who maintain SharePoint 2013. However, specific instructions to install a software update are intended for IT professionals who have to deploy software updates on a farm of servers that host SharePoint 2013.

Information in this article applies to the following products:

  • SharePoint 2013

  • SharePoint 2013 language pack

  • Microsoft Filter Pack

Note:

The process that installs software updates in stand-alone environments of SharePoint 2013 is a simpler process than the process that installs software updates in a server farm and does not require all the steps that are required for a server farm.

Software update process

The process that deploys updates in a SharePoint 2013 environment is a two-phase process: patching and build-to-build upgrade.

Each phase has specific steps and results. It is possible to postpone the build-to-build upgrade phase.

Caution:

Although we try to ensure the highest level of backwards compatibility, the longer you run in such a state, the greater the chance of finding a case where farm behavioral issues might occur.

Patch phase

The patch phase has two steps, the patch deployment step and the binaries deployment step. During the patch deployment step, new binary files are copied to the server running SharePoint 2013. Services that use files that the patch has to replace are temporarily stopped. Stopping services reduces the requirement to restart the server to replace files that are being used. However, in some instances you have to restart the server.

The second step in the patch phase is the binaries deployment step. In this step, the installer copies support dynamic link library (.dll) files to the appropriate directories on the server that is running SharePoint 2013. This step ensures that all the web applications are running the correct version of the binary files and will function correctly after the update is installed. The update phase is complete after the binaries deployment step.

The next and final phase to deploy software updates is the build-to-build upgrade phase. This phase modifies database schemas, updates objects in the farm, and updates site collections.

Build-to-build upgrade phase

After you finish the patch phase, you must complete the update installation by starting the build-to-build upgrade phase. The build-to-build upgrade phase is task intensive and, therefore, takes the most time to finish. The first action is to upgrade all the SharePoint processes that are running. After you upgrade the processes, the databases are crawled and upgraded. After you complete a farm upgrade on one server, you have to complete the process on all other servers to maintain incompatibility.

Software update strategy

The update strategy that you select is based primarily on one of the following factors:

  • The amount of downtime that is acceptable to install the update.

  • The additional staff and computing resources that are available to reduce downtime.

As you determine your update strategy, consider how the strategy enables you to manage and control the update.

In terms of downtime reduction, the following options, ordered from most to least downtime, are available:

  • Install the update and do not postpone the upgrade phase.

  • Install the update and postpone the upgrade phase.

Software update deployment cycle

The cycle that is used for upgrading SharePoint 2013 farms and servers also applies to deploying software updates, which are a subset of an upgrade phase. We recommend that you use the update cycle in the following illustration as a guide to deploy software updates.

The software update deployment cycle

Learn

During this phase of the cycle, you learn about requirements to install the update. This information also affects new servers that you want to update and then add to the farm.

Requirements and prerequisites

First, ensure that the system can be provisioned as a farm server. For more information, see Hardware and software requirements for SharePoint 2013. Ensure that any server that you plan to update is running the same version of the operating system as the other farm servers. This includes updates, service packs, and security hotfixes.

Update strategy

Determine the strategy that you want to use to update the farm. Depending on your requirements, you can use one of the following strategies:

  • In-place

  • Database-attach

For more information about the update strategy to use, see Install a software update (SharePoint 2013)

Downtime reduction

Research and assess the options that are available to reduce downtime. First, check for missing dependencies, which may extend the amount of downtime. Identify all the dependencies for the update and either address these dependencies before you start to deploy the update, or factor the additional time into your schedule. Consider using read-only content databases and doing parallel upgrades to reduce downtime.

Common issues

Identify and address common issues such as missing or out-of-date dependencies and lack of space on the servers where you will install the update.

Prepare

To prepare for the software update, document the environment and plan an update strategy to ensure that the update will go as planned in the expected downtime window.

Document the environment

You document the environment to determine what is unique in your farm. You can use several techniques to gather information about your farm, such as manual inspection, comparisons by using WinDiff, and Windows PowerShell commands.

Document, as appropriate, the following elements of the environment:

  • Farm topology and site hierarchy

  • Language packs and filter packs that are installed

  • Customizations that could be affected by the update

Manage customizations

Customizations are typically one of the top issues during a farm upgrade or software update. Identify your farm customizations and determine whether they might be affected by the update. If in doubt, err on the side of caution and determine how you will manage the customizations. You must ensure that customizations will work after the software update. You can use the Stsadm ExportIPFSAdminObjects command to collect and export InfoPath administrator deployed forms only.

Plan the update strategy

During the Learn phase of the update cycle, you should have determined an update strategy and the required downtime minimization. In addition to determining hardware, space, and software requirements, you must include the following in your update strategy:

  • The update sequence for the farm servers

  • The order of operations

  • The downtime limits and how you plan to reduce downtime

  • A rollback process if there is a major problem

Tip:

Clean up the farm environment before you deploy the update. The benefits of a cleanup are improved update installation performance and the elimination of potential issues during and after the software update. For more information, see Clean up an environment before an upgrade to SharePoint 2013.

The two final requirements for the update strategy are a communication plan and an update schedule.

It is important to communicate with site owners and users about what to expect during an upgrade. An administrator should inform users about downtime and the risk that the upgrade may take longer than expected or that some sites may need some rework after upgrade. For more information, see Create a communication plan for the upgrade to SharePoint 2013.

Create a benchmark schedule for update operations that contains the start times of operations that are related to the update deployment. At a minimum, the plan should include the following operations:

  • Back up the farm.

  • Start the update of the farm servers.

  • Start the upgrade of the farm databases.

  • Stop the upgrade and resume operations in the non-upgraded farm.

  • Resume the upgrade, if it is required.

  • Verify that the environment is completely working, either as the original version if you rolled back or the new version if you completed the upgrade.

Make farm items ready for updates

Ensure that farm items are ready for the update. Farm items are ready if they are backed up, documented, or updated to ensure that the update can be installed. Verify that the following aspects of a farm are ready for updates:

  • Solutions

  • Features

  • Site definitions

  • Web Parts

Test

The rigor, thoroughness, and detail of your tests determine the success or failure of the software update deployment. In a production computer environment, there are no safe shortcuts, and there are consequences from insufficient testing. For more information, see Use a trial upgrade to SharePoint 2013 to find potential issues.

Build a test farm

Build a test farm that represents the production environment. We recommend that you use a copy of the production data to determine potential problem areas and monitor overview system performance during the upgrade. The key indicator is the length of time it takes from the beginning to the end of the deployment process. This should include backup and validation. You can incorporate this information in the update schedule.

If possible, use hardware in the test environment that has equivalent performance capabilities to the production servers.

Tip:

Consider the use of a test farm in a virtual environment. After you finish the tests, you can shut down the virtual farm and use it later for future updates.

Evaluate techniques

A test farm also enables you to evaluate the techniques that you plan to use to update the production environment. In addition to testing and assessing your downtime reduction strategy, you can refine update monitoring. This is especially important in the areas of validating and troubleshooting the software update.

Implement

The update strategy that you use determines whether you have to build a new farm or deploy the update on the current farm servers.

Build or update farms

Whether you build a new farm or do an in-place update, the most important farm elements to consider are as follows:

  • Content

  • Services

  • Service applications

Deploy customizations

Use solutions whenever possible so that you can deploy individual files or components.

Reduce downtime

Reduce downtime by using techniques such as read-only databases and update parallelism. For more information, see the "How to minimize downtime during upgrade" section in Determine strategy for upgrade to SharePoint 2013.

Monitor progress

The refined techniques that you use to monitor the software update in the test environment apply when you deploy the update in the production environment. Use the Upgrade and Migration page in Central Administration to monitor available status indicators. This feature enables live monitoring and provides a single location to view the patch status for all farm servers. Additionally, you can use the Upgrade and Migration page to view the update status for individual servers and the status and type of farm databases. Finally, when you use Central Administration to monitor updates, you can identify farm servers that you must update.

The following tables describe the status information that is available in Central Administration.

Status value | Description | Hyperlink
No action required | Farm server does not currently require any action to be taken by the administrator. | No hyperlink
Installation required | Farm server is missing an .msi file that is set to mandatory for all farm servers or has a patch level below the individual farm-wide effective patch version. | Hyperlink to the Patch Deployment State page
Upgrade in progress | Farm server is currently undergoing an upgrade operation. | Hyperlink to the Upgrade Status page
Upgrade available | Farm server is running in backward-compatibility mode. | Hyperlink to the Upgrade and Migration page
Upgrade required | Farm server is outside the backward-compatibility mode range with one or more databases. | Hyperlink to the Upgrade and Migration page
Upgrade blocked | If an upgrade is available and any farm server requires installation, the remaining servers that do not require installation will be set to this status unless they are currently undergoing an upgrade. | Hyperlink to the Patch Deployment State page
Installed | Indicates that no action is required | Not applicable
Missing/Required | Displayed if a product is required on each server or if a patch for a specific .msi file is located on one server but not on the server for which this status is shown | Not applicable
Missing/Optional | Displayed if a product is not required on each server | Not applicable
Superseded | Displayed if an update is no longer required on a server because a newer patch supersedes it | Not applicable

Log files and Windows PowerShell commands are other tools to monitor the update process.

Important:

Remember to monitor the length of time that the update is taking. Compare current update processes against the benchmark schedule to determine whether the update will meet the downtime window. If not, communicate this information to users of the farm.

Validate

You can start to validate the success of the update during the implementation phase and continue validation after the update is implemented.

Logged event failures

Review the event logs to discover issues that occurred during the deployment. Resolve these issues and then resume or restart the update as appropriate. For more information about event log files, see Configure diagnostic logging in SharePoint 2013.

User interface or experience issues

Any user interface or user experience issues will surface on site pages. These issues mainly occur during a version-to-version upgrade. Look for the following issues:

  • Unghosted files that are, ASP.NET (.aspx) pages that a user has modified within the site collection, and now behave differently than expected or have rendering issues caused by recent upgrades of the files on the server.

  • User interface version mismatch

  • HTML and XHTML compliance

Other issues may include missing templates, user identifiers, and content issues such as large lists.

Data issues

Data issues result from the condition of the farm databases and can include all or some of the following:

  • Connectivity issues to data sources

  • Database corruption

  • Orphaned items

  • Hidden column data

In some cases you can troubleshoot minor issues and then resume or restart the update. Be prepared to roll back the update if you cannot resolve issues.


Prepare to deploy software updates for SharePoint 2013
See also

Published: February 12, 2013

Summary: Determine an approach to use to update servers or server farms in your environment, and learn how to prepare for updates before you install them.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article describes the required and recommended tasks to complete before you install software updates on servers in a SharePoint 2013 farm.

Read and follow these sections sequentially to prepare for updates:

  • Verify account permissions and security settings

  • Determine an update approach

  • Back up the environment

  • Document the environment

  • Determine whether related items need to be updated

  • Obtain the software update and prepare the installation source (optional)

Verify account permissions and security settings

Verify that you have the required account permissions and know the security settings that are in place on the farm. For more information, see Account permissions and security settings in SharePoint 2013.

Determine an update approach

There are two basic options for deploying a software update on a farm: in-place and database-attach.

Note:

Because the action of installing a software update is related to a software upgrade, documentation about software upgrades applies to deploying software updates.

Here are the differences between the two update approaches:

  • In-place update: This approach is easier. With this method, the amount of required downtime is directly related to the size and complexity of the farm. You have two choices for an in-place update:

    • In-place without backward compatibility - You install an update on all the farm servers at the same time and upgrade content. Backward compatibility between update versions on different servers enables you to install the update binary files and postpone update completion to a later time. You cannot reduce downtime using this method. It depends entirely upon the size and complexity of the farm.

    • In-place with backward compatibility - You install an update in stages and use postponed upgrade (that is, do not run the upgrade process on the databases or site collections) with backward compatibility to reduce downtime.

  • Database attach: This approach is more complex than an in-place update, and it requires more personnel and hardware resources. This update method uses a new farm to install updates while users continue to work with existing content on the original farm.

When you use either the in-place with backward compatibility method or the database-attach method, you can use a postponed upgrade. You can choose to upgrade the content databases first and then the farm and servers afterward.

We recommend that you use the following flowchart, which presents the key decision points and subsequent actions, to determine an update approach to use.

Decision flow chart to determine update strategy

You can use either the SharePoint Products Configuration Wizard or Windows PowerShell cmdlets to upgrade your content with any method that you choose to use to update your servers

Back up the environment

To ensure that you can recover the existing environment if an update fails, we recommend that you back up the SharePoint 2013 environment before you start to install the update. A failed software update can be caused by factors other than the update process, such as the following:

  • Media failure

  • User errors (such as deleting a file by mistake)

  • Hardware failures (such as a damaged hard disk or permanent loss of a server)

  • Power failures

  • Natural disaster

You can back up all or part of a farm. The following list summarizes the farm components that you can back up individually:

  • Configuration settings

  • Web applications

  • Service applications

  • Search

  • Secure store service

  • Site collections

  • Logs

  • Apps

For more information about how to determine what you need to back up and the method to use, see Prepare to back up and restore farms in SharePoint 2013. After you determine the farm elements that you will back up, refer to the articles listed in Backup solutions in SharePoint 2013. These articles provide detailed instructions and guidance to back up all or part of a farm.

Important:

Test the farm backups before you start to deploy the software update. You have to be sure that these backups are valid so that you can recover if there is a hardware failure or data corruption during the update process.

Document the environment

Be sure to document the farm, including all custom components in the farm, in case you need to rebuild. For more information about how to create an inventory of customizations, see Create a plan for current customizations during upgrade to SharePoint 2013. In addition, document unique things about your farm, such as the following:

  • Large lists

  • Sites that have large access control lists (ACLs)

  • Sites that are critical to your organization

  • Setting for alternate access mappings

  • Internet Information Services (IIS) settings that apply to the web application (that is, URL, port numbers, and so on.)

  • Web application security (web application policies and authorization providers)

  • Web.config

  • Changes to Docicons.xml and AllowedFileTypes

  • Other service or web application related settings that you have customized

A list of these items will help you more quickly validate your environment after you apply an update.

Determine whether related items need to be updated

Consider whether the following related items need to be updated when you update your farm:

  • Filter packs

  • Language packs

All these items are updated separately from an update of SharePoint 2013. Check to see if any updates to these items are available, and evaluate whether you want to apply the updates to your farm when you apply the updates for SharePoint 2013. Language packs are usually only updated when service packs are released.

Obtain the software update and prepare the installation source (optional)

If the servers on which you want to install SharePoint 2013 are isolated from the Internet, it is usually necessary to install software updates from an offline location. Even if the servers are not isolated, if you install software updates from an offline central location, you can ensure farm server consistency by installing a well-known and controlled set of images. Use the following procedure to prepare a software update for installation on a farm server.

You do not need to complete this procedure if you are downloading and installing the update directly to your servers.

To prepare an installation source

  1. Download the software update that you want to install.

  2. Extract the software update to a shared location by using the following command:

    <package> /extract: <path>

    The /extract switch prompts you to provide a folder name for the files. Here's an example of a folder name for x64 systems:

    sps-kb999999-x64-fullfile-en-us.exe /extract:<\\computername\updateshare\Updates>

  3. Copy the extracted files from the shared location to an Updates folder that you create on the computer where you want to start to install the update.

    Note:

    You must use the name Updates for this updates folder. If you use the SupdateLocation="path-list" property to specify a different location, Setup stops responding.

You can now use this location as an installation point, or you can create an image of this source that you can save to media or save as an ISO file.

Slipstream package

In server farm deployments, all web servers must have the same software update version applied. This means that, before you add a new web server to an existing server farm, the new web server must have the same software updates as the rest of the web servers in your server farm. Likewise, when you create a farm, all servers in the farm must have the same software updates. To make sure that all new servers have the same software updates applied, we recommend that you create an installation source that contains a copy of the release version of the software and software updates that match those installed on your server farm (also known as a slipstreamed installation source). When you run Setup from this updated installation source, the new web server will have the same software update version as the rest of the web servers in your server farm. For more information, see Create an installation source that includes software updates (Office SharePoint Server 2007).

See also

Deploy software updates for SharePoint 2013
Install a software update (SharePoint 2013)


Install a software update (SharePoint 2013)

Published: February 12, 2013

Summary: Learn to install a software update on servers in a SharePoint 2013 farm.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Before you begin

Before you begin the software update process, review the following information about permissions, hardware requirements, software requirements, and update processes.

  • Account permissions and security settings in SharePoint 2013

  • Hardware and software requirements for SharePoint 2013

  • Software updates overview for SharePoint 2013

  • Prepare to deploy software updates for SharePoint 2013

In this article:

  • Verify the update strategy

  • Monitor installation progress

  • Handle update failures

  • Confirm update scenarios

  • Use the in-place method without backward compatibility

  • Use the in-place method with backward compatibility

  • Use the database-attach method for high availability of existing content

  • Verify update completion and success

Verify the update strategy

Before you start to deploy a software update, verify that the update strategy that you plan to use is optimal for your SharePoint 2013 environment. There are several factors, such as downtime reduction, cost, and complexity that determine the strategy to use to deploy a software update. Use the flowchart in the "Determine Update Strategy" section of Prepare to deploy software updates for SharePoint 2013 to verify the update strategy that you want to use: in-place, database-attach, or a combination.

Monitor installation progress

Monitor the process that deploys updates to verify that the update is proceeding as planned. There may be issues that will block the update or that will result in an updated farm that has elements that do not work as expected. Pay extra attention to database synchronization and customizations.

We recommend that you use the Upgrade and Migration page in Central Administration as the primary tool to view product and patch installation status, data status, and update status in real time.

After Setup runs, you can also view the log files and use Windows PowerShell to obtain the current results of the installation progress.

Handle update failures

SharePoint 2013 can handle upgrade failures after the patching phase finishes. If an update fails, you can restore the SharePoint 2013 database. After you resolve the update issue for the site, you can resume the update. Completed tasks do not run again. For more information, see Test and troubleshoot an upgrade to SharePoint 2013.

Confirm update scenarios

Make sure that you chose an appropriate update scenario. Review the "Determine an update approach" section in Prepare to deploy software updates for SharePoint 2013.

For more information about how the database-attach process works, see the diagrams in Overview of the upgrade process to SharePoint 2013. Note that these articles and other links in this article are about how to upgrade across software versions instead of how to install software updates. However, the general process is similar.

The following illustration shows the farm topology that is used as an example for each patching scenario that is described in this article.

Shows an example of a farm topology for a patching scenario

Initial state and required conditions

The preceding illustration shows the initial state of the farm before you install an update. Verify that the following conditions are true:

  • All the front-end web servers are load balanced together and are in rotation with the load balancer.

  • All the farm servers are operating correctly.

  • All the databases are active and operating correctly.

Do not start the update if any of the preceding conditions are not true. Resolve all issues before you continue.

Use the in-place method without backward compatibility

In this scenario you disable incoming requests to the front-end web servers to shut down the complete farm and then install the update on all the farm servers. This strategy combines the update and the upgrade phase described in the "Software Update Process" section of Software updates overview for SharePoint 2013.

The following illustration shows the sequence of steps to follow to install the update on the farm.

Illustrates how you take each front-end web server offline, patch it and bring back online. Run SharePoint Products Configuration Wizard on each application server, and then run SharePoint Products Configuration Wizard on each front-end web server.

Use the preceding illustration as a guide for to follow the recommended steps in the following procedure.

To install an update without backward compatibility

  1. Remove the web servers (WEB-1 to WEB-4) from rotation in the load balancer, or pause the load balancer to stop incoming requests to the servers.

  2. Run the executable file to install the update on the application server that hosts Central Administration (APP-1).

  3. Run the executable file to install the update on the application server that hosts the search query component (APP-2).

  4. Verify that all the servers were updated successfully by reviewing the Updates.log file.

  5. Log on to the first web server (WEB-1).

  6. Run the executable file to install the update on the web server.

  7. Run the executable file to install the update on the remaining web servers (WEB-2, WEB-3, and WEB-4).

  8. Verify that all the servers were updated successfully.

  9. Run the SharePoint Products Configuration Wizard on the Central Administration server (APP-1) to upgrade the configuration database and upgrade each content database serially.

  10. Run the SharePoint Products Configuration Wizard on the application server that hosts the search query component (APP-2).

  11. Run the SharePoint Products Configuration Wizard on the first web server (WEB-1).

    Note:

    Run the configuration wizard to ensure that if an update fails for a specific server, the error is not propagated to the other web servers. For example, a failed update for one server could make the update fail for one or more site collections.

  12. Repeat the preceding step for each remaining web server.

  13. Verify update completion and success. For more information, see Verify update completion and success.

  14. Add the web servers (WEB-1 to WEB-4) to the rotation in the load balancer, or start the load balancer to enable incoming requests to the servers.

  15. Notify users that the servers are available.

Use the in-place method with backward compatibility

This scenario takes advantage of the backward compatibility of SharePoint 2013 and the deferred upgrade feature to reduce the downtime that is required to deploy a software update. However, downtime is not completely eliminated. The sites and services will not be available while the database content is being upgraded.

This software update scenario uses two phases to install the update on farm servers. These phases are as follows:

  • Update to install the update on the farm servers.

  • Upgrade to complete the patching process.

During the update phase, the farm can continue to be in production with minimal downtime. However, during the upgrade phase, the farm will be unavailable. If you attempt to access content while the farm is upgrading, the result could be failed upgrades or excessive slowdowns in the upgrade process because of resource contention and locking. Such an attempt is unsupported and untested.

For more information about the software update process, see "The Software Update Process" section in Software updates overview for SharePoint 2013.

Update phase

The following illustration shows the sequence of steps that are required to install the update on the farm.

Illustrates how in-place with backward compatibility method works by take half of web server offline, patch it, bring back online, then repeat same for the remaining web servers. Note, the SharePoint Products Configuration Wizard is not run in this step.

Use the preceding illustration as a guide to follow the recommended steps in the following procedure.

To install the update on farm servers

  1. Remove half of the web servers (WEB-1 and WEB-2) from rotation in the load balancer, or pause the load balancer to stop incoming requests to the servers.

  2. Run the executable file to install the update on each web server that is out of the load-balancing rotation (WEB-1 and WEB-2). Do not run the SharePoint Products Configuration Wizard on either of these servers. Verify that both of the web servers were updated successfully.

  3. Remove the remaining web servers (WEB-3 and WEB-4) from rotation in the load balancer, or pause the load balancer to stop incoming requests to the servers. At this point none of the front-end web servers are receiving requests for the farm.

  4. Add the updated web servers (WEB-1 and WEB-2) back into the load-balancing rotation.

  5. Run the executable file to install the update on each web server that is still out of the load-balancing rotation. Do not run the SharePoint Products Configuration Wizard on either of these servers. Verify that both of the web servers were updated successfully.

  6. Add the updated web servers (WEB-3 and WEB-4) back to the load-balancing rotation.

  7. Run the executable file to install the update on the application server that hosts the search query component (APP-2). Do not run the SharePoint Products Configuration Wizard on this server.

  8. Run the executable file to install the update on the Central Administration server (APP-1). Do not run the SharePoint Products Configuration Wizard on this server.

  9. Verify that both of the application servers (APP-1 and APP-2) were updated successfully.

  10. Verify update completion and success. For more information, see Verify update completion and success.

At this point in the process, the databases and other components such as settings, features, and site-level data must still be upgraded because the SharePoint Products Configuration Wizard was not run on any of the farm servers. However, the farm should be capable of running in backward compatibility mode.

Upgrade phase

The following illustration shows the steps that upgrade the farm servers to finish the patching process. During this process, the sites that are being upgraded will not be available to users.

Steps to use during the upgrade phase of an in-place software update

Use the preceding illustration as a guide to follow the recommended steps in the following procedure.

Important:

Monitor the status of the upgrade on each server before you upgrade the next server in the sequence. We recommend that you create a backup of the farm before you begin to upgrade.

The following procedure shows all the steps to upgrade the farm. You can upgrade all components within the same outage window, or you can take some smaller outage windows and upgrade separate parts of the farm at different times. If you want to break up the upgrade stage, you can upgrade the following components in separate outage windows:

  • Services

    If the software update contains updates to services that must be applied, you can upgrade the service, and then resume operating the farm (steps 7 and 8 in the procedure) until it is possible to take a longer farm outage to complete the content and farm upgrade.

  • Content databases

    You can take a short farm outage to upgrade only a few content databases (steps 1 through 3 in the procedure) each time and then resume farm operation (steps 7 and 8). You can repeat the process over successive outage windows until you upgrade all content and the farm servers are ready to be upgraded.

    You can also upgrade individual content databases in parallel for a very small number of content databases at the same time. However, do not attempt to upgrade too many content databases in parallel because it will slow down the overall upgrade process and extend the outage time. We recommend that you do not upgrade more than two content databases on the same SQL Server volume at a time. Start the upgrade for each content database that will occur in parallel several minutes apart to prevent lock contention as the upgrade process starts. In addition, limit the number of content databases that you upgrade on a single web server or application server. Each additional upgrade process will consume a relatively large amount of resources. The typical number of content databases that you can upgrade per web server or application server is four databases. However, be sure not to exceed the number of databases that are being upgraded per SQL Server volume, no matter which web server or application server originates the upgrade.

To upgrade the farm

  1. Remove the web servers (WEB-1 to WEB-4) from rotation in the load balancer, or pause the load balancer to stop incoming requests to the servers.

    Important:

    The sites and services will not be available until upgrade is complete and the servers are returned to an active load-balancing state.

  2. Upgrade specific services, as needed.

    Some updates might also require you to run additional Windows PowerShell cmdlets to upgrade specific service applications. Notes for a software update might indicate that you have to upgrade a specific service so that it will continue to operate after patching. This applies to a service that cannot operate in backward compatibility mode, for example.

    You can create a short offline period to upgrade the service without having to upgrade the complete farm. The additional Windows PowerShell cmdlets to upgrade specific service applications should be in the notes if this is required.

  3. Use the Windows PowerShell Upgrade-SPContentDatabase cmdlet to upgrade each content database.

    This is an optional step, but it will help ensure that all content databases are upgraded first. It has the advantage of enabling some parallelism to reduce the outage time. If it is not performed, all remaining non-upgraded content databases will be upgraded serially when you run the SharePoint Products Configuration Wizard to upgrade the farm servers.

    Important:

    Run the Upgrade-SPContentDatabase cmdlet for each database. You can run this cmdlet from any of the upgraded web servers or application servers. Note that the content for each database will be unavailable while this process is running on that database.

  4. Run the SharePoint Products Configuration Wizard on the Central Administration server (APP-1).

    Important:

    The SharePoint Products Configuration Wizard also starts an immediate upgrade of the configuration database and all other databases that are not already upgraded. Because it is likely that the content databases are the only databases that have already been upgraded, as described in the previous step, all the service application databases are also upgraded in this step. Your sites will not be available while this process runs.

  5. Run the SharePoint Products Configuration Wizard on the remaining application server (APP-2).

  6. Run the SharePoint Products Configuration Wizard on the web servers (WEB-1 to WEB-4).

  7. Verify update completion and success. For more information, see Verify update completion and success.

  8. Add the upgraded web servers (WEB-1 to WEB-4) back into rotation in the load balancer.

Use the database-attach method for high availability of existing content

To ensure high availability for existing content, this scenario uses read-only databases on the existing farm. You install the update on a new farm and route user traffic to the new farm after updates are complete.

The following illustration shows the sequence of steps to follow to install the update on a new farm by using the database attach method. For more information, see Upgrade content databases to SharePoint 2013.

Install a software update using database attach for high availability of existing content

Use the preceding illustration as a guide to follow the recommended steps in the following procedure.

To install the update by using the database-attach method

  1. Create a new farm where you will install the software update. This farm does not require front-end web servers. For more information, see Create the SharePoint 2013 farm for a database attach upgrade.

    Note:

    If the original farm uses a database mirror, configure mirroring after you deploy the software update on the new farm.

  2. Configure the databases on the existing farm so that they are in a read-only state.

    Note:

    If the existing farm is mirrored, pause mirroring before setting the databases to read-only.

    For more information about how to configure read-only databases, see the "Set the Previous Version Databases to Be Read-Only (Database Attach with Read-Only Databases)" section in Upgrade content databases to SharePoint 2013 and Run a farm that uses read-only databases in SharePoint 2013.

  3. Configure the service application databases on the existing farm so that they are in a read-only state. This prevents unexpected changes to service applications.

  4. If you are patching the User Profile Service service application database, which is not in SharePoint Foundation 2013, you must export the User Profile Synchronization Service encryption key from the old database and then import the key to the new database. This key is also known as the Microsoft Identity Integration Server (MIIS) key, the Synchronization Service encryption key, and the Forefront Identity Manager 2010 (FIM 2010) key. If you do not export and then import the key correctly, the Synchronization Service will not start. To export the encryption key, complete these steps:

    1. Use farm administrator credentials to log on to the computer that contains the old User Profile Service service application database.

    2. Open the Command Prompt window, and then change to the following folder:

      %Program Files%\Microsoft Office Servers\15.0\Synchronization Service\Bin\

    3. Type the following command, and then press Enter:

      miiskmu.exe /e <Path>

      Where <Path> is the full path of the file to which you want to export the key.

  5. Back up the content databases on the existing farm. For more information, see Plan for backup and recovery in SharePoint 2013.

  6. To import the encryption key, complete these steps:

    1. Use farm administrator credentials to log on to the computer that contains the new User Profile Service service application database.

    2. Attempt to start the User Profile Synchronization service. Because you have not yet imported the encryption key, the service will not start. Confirm that the service did not start by using the ULS log or by making sure that the status of the service is Stopped.

    3. Open the Command Prompt window, and then change to the following folder:

      %Program Files%\Microsoft Office Servers\15.0\Synchronization Service\Bin\

    4. Type the following command, and then press Enter:

      miiskmu.exe /i <Path> {0E19E162-827E-4077-82D4-E6ABD531636E}

      Where <Path> is the full path of the file to which you exported the key.

    5. (Optional) To check that the encryption key was imported correctly, at the command prompt, type the following command, and then press Enter:

      miiskmu.exe /c {0E19E162-827E-4077-82D4-E6ABD531636E}

  7. Restore the content databases to the new database server.

  8. Create service applications on the new farm for each existing service application in the old farm.

    Duplicate all the settings from your existing farm.

  9. Use the database-attach method to create the databases on the new farm. For more information, see Upgrade databases from SharePoint 2010 to SharePoint 2013 and Attach and restore a read-only content database in SharePoint 2013.

  10. Verify that there are no issues with the new farm.

  11. Enable the new farm as the production farm by configuring DNS to point to the new farm or by making sure that the new farm is load balanced. Verify that users can access the new farm.

  12. Allow time for users to switch from cached DNS, and then decommission the old farm.

  13. Verify update completion and success. For more information, see Verify update completion and success.

Verify update completion and success

Regardless of the update strategy that you use and the monitoring that you do during the software update, you must verify update completion and success. For more information, see Verify database upgrades in SharePoint 2013.


Update Workflow in SharePoint Server 2013

Published: April 30, 2013

Summary: Walks through the steps required to keep workflow up to date in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Run cmdlets after software updates are installed

It is important that any Cumulative Updates (CU) for SharePoint Server 2013 and Workflow Manager are installed in a coordinated fashion. After an update has been performed, several Windows PowerShell cmdlets must be run in order to maintain the connection between the SharePoint Server 2013 farm and the Workflow Manager farm.

Run the following Windows PowerShell cmdlets as an administrator from the SharePoint Administration Shell after the updates have been installed for SharePoint Server 2013, Workflow Manager, and Workflow Manager Client.

Important:

The latest update level must be installed on SharePoint Server 2013, Workflow Manager, and Workflow Manager Client before you run the update cmdlets.

Copy code
$credential = [System.Net.CredentialCache]::DefaultNetworkCredentials
$site = Get-SPSite(<siteUri>)
$proxy = Get-SPWorkflowServiceApplicationProxy
$svcAddress = $proxy.GetWorkflowServiceAddress($site)
Copy-SPActivitiesToWorkflowService -WorkflowServiceAddress $svcAddress -Credential $credential -Force $true
Note:

Because workflow supports environments with multiple Site Subscriptions, the $site Site Collection address determines the proper configuration location for workflow settings.

Troubleshooting steps for workflow updates

  • Make sure all components are on the latest patch level. This includes SharePoint Server 2013, Workflow Manager, and Workflow Manager Client.

  • Verify the $proxy connection settings using the following commands:

    Copy code
    $proxy = Get-SPWorkflowServiceApplicationProxy
$site = Get-SPSite(<siteUri>)
$proxy.GetWorkflowServiceAddress($site)

  • Inspect any errors displayed in the SharePoint Designer user interface or any errors shown in the SharePoint Workflow Status user interface.


Operations for SharePoint 2013

Summary: The following articles help you operate and maintain servers, server farms, sites, and solutions in a SharePoint 2013 deployment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about operating and maintaining SharePoint 2013.

Downloadable resources about operations and maintenance in SharePoint 2013

Download the following content for information about how to operate and maintain SharePoint 2013.

 | Content | Description
Building blocks | SharePoint 2013 training for IT pros | IT pro-focused how-to training and covers changes and new features for search, social, plus deployment and performance/scalability with downloadable presentations.
Downloads | SharePoint resources in the TechNet Gallery | Find and share scripts and other resources for operating and maintaining SharePoint 2013.

TechNet articles about operations and maintenance in SharePoint 2013

The following articles about how to operate and maintain SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Operations and maintenance for server farm architecture | Operations and maintenance for solutions
Building blocks | Scenario icon
Backup and restore SharePoint 2013 Learn about how to prepare to back up and restore SharePoint 2013 and complete specific operations. | Administer sites and site collections in SharePoint 2013 Use these TechNet articles to learn how to manage sites and site collections in SharePoint 2013.
Manage databases in SharePoint 2013 Learn how to manage the databases that are associated with SharePoint 2013. | Administer mobile devices in SharePoint 2013 Learn how to improve productivity, usability, and administer the new features on mobile devices.
Monitor health in SharePoint 2013 Read articles about SharePoint monitoring, configuring SharePoint monitoring properties, viewing SharePoint logs and reports, and troubleshooting SharePoint problems. | Administer the User Profile service in SharePoint Server 2013 Learn how to administer the User Profile service.
Configure licensing in SharePoint Server 2013 Learn about new licensing functionality and how to configure licensing in SharePoint 2013. | Administer search in SharePoint Server 2013 Learn how improve search results and to manage crawling, the search schema and the search topology.
Start or stop a service (SharePoint 2013) Learn the standard process to start or stop SharePoint service. | Administer business intelligence in SharePoint Server 2013 Find resources to configure and maintain business intelligence tools in SharePoint Server 2013.
Web applications management in SharePoint Server 2013 Learn how to create and manage web applications in a SharePoint Server 2013 farm. | Administer Access Services in SharePoint Server 2013 Find resources to configure and administer Access Services in SharePoint Server 2013.
Configure People Picker in SharePoint 2013 Learn how to use the Stsadm.exe tool to manage People Picker in SharePoint 2013. | Share service applications across farms in SharePoint 2013 Describes the process and cautions that are involved in sharing service applications across farms in SharePoint 2013.

Videos about operations and maintenance in SharePoint 2013

The following video recordings about how to operate and maintain SharePoint 2013 are available to view online or to download.

 | Content | Description
Video (play button) icon | SharePoint 2013 training for IT pros | Find IT pro-focused how-to training and walkthrough videos with this interactive course about SharePoint 2013 including changes and new features for search, social, plus deployment and performance/scalability.

Additional resources about operations and maintenance in SharePoint 2013

The following resources about how to operate and maintain SharePoint 2013 are available from other subject matter experts.

Content Description

House icon

SharePoint 2013 Tech Center

Visit the TechCenter to access videos, community sites, documentation, and more.

Code icon

SharePoint developer center

Find resources for building solutions on SharePoint 2013, including how-to articles, code samples, and the SharePoint SDK.

Chat icon

  • To the SharePoint

  • Office 365 Technical Blog

  • Read draft content, learn about new content, and join the conversation at this IT pro content team blog.

  • Learn how to get the most out of SharePoint sites.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support


Backup and restore SharePoint 2013

Updated: February 19, 2013

Summary: Learn about how to prepare to back up and restore SharePoint 2013 and complete specific operations.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet and related resources provide information that information technology (IT) professionals must have to plan, design, and deploy backup and restore solutions for SharePoint 2013.

TechNet articles about backup and restore

The following articles about backup and restore solutions are available to view online. The solutions that these articles describe might be in enterprise, corporate, or branch-office environments. The IT professionals who are responsible for backup and restore solutions are expected to have an understanding of the technical details that are contained in this section. However, service-level expertise is not required to understand the enterprise-level discussions and decisions.

A backup is a copy of data that is used to restore and recover that data after a system failure. Backups enable you to restore data after a failure. Recovery enables you to quickly restore the farm if a problem arises. You can recover the complete farm or one or more components of the farm from a backup.

 | Content | Description
Building blocks | Prepare to back up and restore farms in SharePoint 2013 | Provides information to help you understand the backup and restore process in your environment.
 | Configure backup and restore permissions in SharePoint 2013 | Contains the appropriate permissions and group memberships required for backup and restore operations.
 | Backup solutions in SharePoint 2013 | Provides backup procedures for backup and restore solutions of your environment.
 | Restore (SharePoint 2013) | Provides restore procedures for backup and restore solutions of your environment.
 | Backup and restore best practices in SharePoint 2013 | Learn how to implement best practices before you back up and restore a SharePoint 2013 farm.

Change History

Date | Description
February 19, 2013 | Added link to Backup and restore best practices in SharePoint 2013.
July 16, 2012 | Initial publication


Prepare to back up and restore farms in SharePoint 2013
See also

Summary: Learn how to prepare to back up and restore your SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

It is important to make sure that you have backed up and can recover the data that you need if a failure occurs. Consider the information, procedures, and precautions in this article before you back up and restore the environment. This article discusses restrictions and requirements for backup and recovery and how to create a shared folder on the network that can receive backed-up data.

Requirements to back up and restore SharePoint 2013

  • Before you back up data, create a shared folder that stores the data. For best performance, create this folder on the database server. If you want to archive the backups to another server, you can copy the whole backup folder to that server after backup is complete. Be sure to copy and move the whole backup folder and not the individual backup folders under this folder.

  • The SQL Server VSS Writer service, which is available with SQL Server 2008 R2and SQL Server 2012 database software, must be started for the SharePoint 2013 VSS Writer service to work correctly. By default, the SharePoint 2013 VSS Writer service is not automatically started.

  • Make sure that the SharePoint Foundation 2013 Administration service is started on all farm servers before you perform a backup. By default, this service is not started on stand-alone installations.

  • Make sure that the user accounts that you want to perform a backup have access to the shared backup folder.

  • If you use Central Administration to back up, the database server's SQL service account, the Timer service account, and the Central Administration application pool identity account must have Full Control permissions to the backup locations.

  • The database server and farm server that you want to back up must be able to connect to one another.

  • If you use SQL Server with Transparent Data Encryption (TDE), and you use either SharePoint tools or SQL Server tools to back up your environment, the TDE encryption key is not backed up or restored. You must manually back up the key. When you restore the environment, you must manually restore the key before you restore the data. For more information, see Understanding Transparent Data Encryption (TDE).

Restrictions when you back up and restore SharePoint 2013

You can't back up or restore everything in a SharePoint environment. For more information about backup and recovery architecture and about backup and restore restrictions, see Overview of backup and recovery in SharePoint 2013.

  • You cannot use a backup made from one version to restore to another version.

  • You can use a backup made from one version to upgrade to another version.

  • The update level of the farm to which you restore cannot be lower than the update level of a backup.

    The destination farm must have the same or newer update level. For information about how to upgrade, see Upgrade to SharePoint 2013.

If you perform a backup while a task that creates or deletes databases is running, pending changes might not be included in the backup.

Do not modify the spbackup.xml file. SharePoint 2013 uses this file. A change can make the backups unusable.

How to create a shared folder

Use this procedure to create a shared folder on the network that can receive and hold backedup data. You can also use this shared folder when you restore data. If you already have a shared folder that serves this purpose, you do not have to perform this procedure. By performing the following procedure, you ensure that you can access the shared folder from the computer that runs SQL Server database software and from the computer that hosts the SharePoint Central Administration website.

To create a shared folder

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the computer on which you want to create the shared folder.

  2. If you create the shared folder on a computer other than the one running SQL Server, make sure that the service account for SQL Server (MSSQLSERVER) is using a domain user account and that it has Full Control permissions on the shared folder.

  3. On the server on which you want to store the backup data, create a folder.

  4. On the Sharing tab of the Properties dialog box, click Share, and then in the File Sharing dialog box, add the following accounts and assign them the Co-Owner role:

    • SQL Server service account (MSSQLSERVER)

    • The SharePoint Central Administration application pool identity account

    • The SharePoint 2013 Timer service account (if you are using SharePoint Server 2013 to perform backups).

For more information, see Shared Folders

See also

Backup solutions in SharePoint 2013
Restore (SharePoint 2013)


Configure backup and restore permissions in SharePoint 2013
See also

Summary: Learn how to configure permissions for backup and restore operations in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can configure backup and restore permissions for SharePoint 2013 by using the SharePoint Central Administration website or Windows PowerShell. The backup tool that you use depends on the kind of environment that you have deployed, your backup schedule requirements, and service level agreements that you have made with your organization.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013, except for configuring permissions for service applications, some of which are only available in SharePoint Server 2013. For example, the following service applications apply only to SharePoint Server 2013:

  • Business Data Connectivity

  • Managed Metadata Service

  • PerformancePoint Services

  • SharePoint Translation Services

  • State Service

  • Word Automation Services

In this article:

  • Before you begin

  • Permissions for the SPTimerV4 timer service and SQL Server account in SharePoint 2013

  • Group memberships required to run backup and restore operations in Central Administration

  • Setting permissions to run SharePoint backup and restore operations by using Windows PowerShell

Before you begin

Before you back up or restore SharePoint 2013, you must make sure that the timer service account, SQL Server service account, and users who run the backup or restore operations have the correct permissions or are members of the correct Windows security groups or SharePoint groups. You must configure these permissions and group memberships when you first deploy SharePoint 2013. You have to update permissions and group memberships when you add new farm components to the environment and if you want to add users who will perform backup and restore operations.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Permissions for the SPTimerV4 timer service and SQL Server account in SharePoint 2013

The Windows SharePoint Services Timer V4 (SPTimerV4) and the SQL Server service account in SharePoint 2013 perform backup and restore operations on behalf of users. These service accounts require Full Control permissions on any backup folders.

Group memberships required to run backup and restore operations in Central Administration

You must make sure all user accounts that use Central Administration to back up or restore your farm and farm components have the group memberships that are described in the following table.

Farm component | Member of Administrators group on the local computer | Member of Farm Administrators SharePoint group
Farm | Yes | No
Service Application | Yes | No
Content Database | Yes | No
Site Collection | No | Yes
Site, list, document library | No | Yes

Setting permissions to run SharePoint backup and restore operations by using Windows PowerShell

You must make sure that all user accounts that use Windows PowerShell to back up or restore your farm and farm components are added to the SharePoint_Shell_Access role for a specified database and have the permissions described in the table later in this section.

You can run the Add-SPShellAdmin cmdlet to add a user account to this role. You must run the command for each user account. Moreover, you must run the command for all databases to which you want to grant access.

Note:

You only have to grant a user account access to back up and restore a specific farm component one time. You will have to perform this task again only when you add new farm components to your environment or when you want to add users to perform backup and restore operations.

To add a user to or remove a user from the SharePoint_Shell_Access role by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Add-SPShellAdmin -Username <User account> -Database <Database ID>

    Where:

    • <Database ID> is the GUID assigned to the database.

    To add a user account to all the databases in the farm, type the following command:

    Copy code
    ForEach ($db in Get-SPDatabase) {Add-SPShellAdmin -Username <User account> -Database $db}

    Where:

    • <User account> is the user whose account you want to remove.

    To remove a user account from all the databases in the farm, type the following command:

    Copy code
    ForEach ($db in Get-SPDatabase) {Remove-SPShellAdmin -Username <User account> -Database $db}

    Where:

    • <User account> is the user whose account you want to remove.

    To view the user accounts currently added to the databases in the farm, type the following command:

    Copy code
    ForEach ($db in Get-SPDatabase) {Get-SPShellAdmin -Database $db}

For more information, see Add-SPShellAdmin.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

You might also have to grant additional permissions to the users who run the backup or restore operation by using Windows PowerShell. The following table shows the permissions that are required.

Farm component | Member of Administrators group on the local computer | Member of Farm Administrators SharePoint group | Full control on backup folder
Farm | Yes | No | Yes
Service Application | Yes | No | Yes
Content Database | Yes | No | Yes
Site Collection | No | Yes | Yes
Site, list, document library | Yes | No | Yes

See also

Plan for backup and recovery in SharePoint 2013
Prepare to back up and restore farms in SharePoint 2013
Overview of backup and recovery in SharePoint 2013


Backup solutions in SharePoint 2013
See also

Updated: May 21, 2013

Summary: Learn how to back up solutions for a SharePoint 2013 environment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet and related resources provide information about backup solutions for SharePoint 2013. These articles are written to meet the requirements of information technology (IT) professionals who are responsible for the planning, design, deployment, and operations of backup and recovery solutions. These solutions might be in enterprise, corporate, or branch office environments. The IT professionals who are responsible for backup and recovery solutions are expected to have an understanding of the technical details that are contained in this section.

A backup is a copy of data that is used to restore and recover that data after a system failure. While backups allow you to restore data after a failure they are also useful to keep for routine purposes. These purposes include copying a database from one server to another, setting up database mirroring, and archiving to comply with regulatory requirements.

If you make appropriate backups, you can recover from many system failures, such as the following:

  • Media failure

  • User errors (such as deleting a file by mistake)

  • Hardware failures (such as a damaged hard disk or permanent loss of a server)

  • Natural disasters

Downloadable resources about backup

Download the following content for information about backup.

 | Content | Description
Code | Back up and restore: SharePoint Server 2013 | A visual display of the backup and restore tools, scenarios and tasks available for SharePoint Server 2013.
 | Backup planning workbook | Workbook to help you plan strategies for backup and restore for a SharePoint 2013 environment.

TechNet articles about backup for SharePoint 2013

The following articles about backup are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Back up farms in SharePoint 2013 | Describes the procedures that you can use to back up the complete farm.
 | Back up farm configurations in SharePoint 2013 | Describes the procedures that you can use to back up farm configuration settings.
 | Back up web applications in SharePoint 2013 | Describes the procedures that you can use to back up a web application that is associated with the farm that include configuration and content databases.
 | Back up service applications in SharePoint 2013 | Describes the procedures that you can use to back up a service application that is associated with the farm that include configuration and content databases.
 | Back up User Profile service applications in SharePoint Server 2013 | Describes the procedures that you can use to back up a User Profile Service application that is associated with the farm that include configuration and content databases.
 | Back up Search service applications in SharePoint 2013 | Describes the procedures that you can use to back up the Search service application that is associated with the farm that include configuration and indexes.
 | Back up the Secure Store Service in SharePoint 2013 | Describes the procedures that you can use to back up the Secure Store service application that is associated with the farm that include configuration and content databases.
 | Back up content databases in SharePoint 2013 | Describes the procedures that you can use to back up a content database that is associated with the farm.
 | Back up databases to snapshots in SharePoint Server 2013 | Describes the procedures that you can use to back up a content database that is associated with the farm by saving the database to a snapshot.
 | Back up customizations in SharePoint 2013 | Describes the procedures that you can use to back up customizations that are associated with the farm.
 | Back up site collections in SharePoint 2013 | Describes the procedures that you can use to back up site collections that are associated with the farm.
 | Back up apps for SharePoint in SharePoint 2013 | Learn how to back up apps for SharePoint in SharePoint 2013.
 | Export sites, lists, or document libraries in SharePoint 2013 | Describes the procedures that you can use to export a list, site, or document library that is associated with the farm. You can then import the items into another farm or move them to another place in this farm.

Additional resources about backup for SharePoint 2013

The following resources about backup are available from other subject matter experts.

 | Content | Description
TechNet logo | What's New in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.

See also

Restore (SharePoint 2013)

Change History

Date | Description
May 21, 2013 | Added links for downloadable content, Back up and restore: SharePoint Server 2013 model and for the Backup planning workbook.
July 16, 2012 | Initial publication


Back up farms in SharePoint 2013
See also

Summary: Learn how to back up a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can back up a SharePoint 2013 farm by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. The backup tool that you use depends on the kind of environment that you have deployed, your backup schedule requirements, and service level agreements that you have with your organization.

Before you begin

We recommend that you regularly back up the complete farm by backing up both the configuration and content. Regularly backing up the farm reduces the possibility of data losses that might occur from hardware failures, power outages, or other problems. It is a simple process and helps so that all the farm data and configurations are available for recovery, if that is required.

For information about which tool to use for backups, see Plan for backup and recovery in SharePoint 2013.

Before you begin this operation, review the following information to help you prepare your farm backup:

  • You must create a folder on the local computer or the network in which to store the backups. For better performance, we recommend that you back up to the local computer and then move the backup files to a network folder. For more information about how to create a backup folder, see Prepare to back up and restore farms in SharePoint 2013.

  • Performing a backup does not affect the state of the farm. However, it does require resources and might slightly affect farm performance when the backup is running. You can avoid performance issues by backing up the farm during hours when farm use is lowest, such as outside office hours.

  • The farm backup process does not back up any certificates that you used to form trust relationships. Ensure that you have copies of these certificates before you back up the farm. You must re-establish these trust relationships after restoring the farm.

  • Backing up the farm backs up the configuration and Central Administration content databases, but these cannot be restored using SharePoint 2013 tools. For more information about how to back up and restore all the farm databases, see Move all databases in SharePoint 2013.

  • When you back up a farm that contains a Web application that is configured to use forms-based authentication, you must also use a file backup system to protect the Web.config files because the Web.config files were updated manually to register the membership and role providers, and manual changes to the Web.config files are not backed up. Similarly, Web.config files are not restored when you restore a Web application. After recovery, you must update the Web.config files and redeploy the providers. For more information, see Plan for user authentication methods in SharePoint 2013.

  • SharePoint 2013 backup backs up the Business Data Connectivity service external content type definitions but does not back up the data source itself. To protect the data, you should back up the data source when you back up the Business Data Connectivity service or the farm.

    If you restore the Business Data Connectivity service or the farm and then restore the data service to a different location, you must change the location information in the external content type definition. If you do not, the Business Data Connectivity service might be unable to locate the data source.

  • SharePoint 2013 backup backs up remote Binary Large Object (BLOB) stores but only if you are using the FILESTREAM remote BLOB store provider to put data in remote BLOB stores.

    If you are using another provider, you must manually back up the remote BLOB stores.

  • If you are using SQL Server with Transparent Data Encryption (TDE), and you are backing up your environment by using either SharePoint tools or SQL Server tools, the TDE encryption key in not backed up or restored. You must back up the key manually. When restoring, you must manually restore the key before you restore the data. For more information, see Understanding Transparent Data Encryption (TDE).

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Windows PowerShell to back up a farm in SharePoint

You can use Windows PowerShell to back up the farm manually or as part of a script that can be run at scheduled intervals.

To back up a farm by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPFarm -Directory <BackupFolder> -BackupMethod {Full | Differential} [-Verbose]

    Where:

    • <BackupFolder> is the path of a folder on the local computer or the network in which you want to store the backups.

    Note:

    If you are backing up the farm for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

For more information, see Backup-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to back up a SharePoint farm

You can use Central Administration to back up the farm.

To back up a farm by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, on the home page, in the Backup and Restore section, click Perform a backup.

  3. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, select the farm from the list of components, and then click Next.

  4. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select either Full or Differential.

    Note:

    If you are backing up the farm for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

  5. In the Back Up Only Configuration Settings section, click Back up content and configuration settings.

  6. In the Backup File Location section, type the UNC path of the backup folder, and then click Start Backup.

  7. You can view the general status of all backup jobs at the top of the Backup and Restore Status page in the Readiness section. You can view the status for the current backup job in the lower part of the page in the Backup section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Spbackup.log file at the UNC path that you specified in step 6.

Use SQL Server tools to back up a SharePoint farm

If you want to back up the complete farm, you must use either Windows PowerShell or Central Administration. You cannot back up the complete farm by using the SQL Server tools because you cannot use the tools to back up the farm's configuration. However, you can back up all the databases that are associated with the farm. The databases that are associated with the farm are determined by the services and features that you have installed on the farm.

To back up the databases associated with a farm by using SQL Server tools

  1. Verify that the user account that is performing this procedure is a member of the SQL Server db_owner fixed database role on all databases that are to be backed up.

  2. Open SQL Server Management Studio and connect to the correct instance of the SQL Server Database Engine.

  3. In Object Explorer, expand Databases.

  4. Right-click the database that you want to back up, point to Tasks, and then click Back Up.

  5. In the Back Up Database dialog box, in the Source area, select the kind of backup that you want to perform from the Backup type list. For more information about which backup type to use, see Recovery Models (SQL Server).

  6. In the Backup component area, click Database.

  7. Either use the default name that is provided or specify a name for the backup set in the Name text box.

  8. Specify the expiration date for the backup set. This date determines how long, or when, the backup set can be overwritten by any later backups that have the same name. By default, the backup set is set to never expire (0 days).

  9. In the Destination area, specify where you want to store the backup.

  10. Click OK to back up the database.

  11. Repeat steps 1-10 for each farm database.

See also

Backup and restore SharePoint 2013


Back up farm configurations in SharePoint 2013
See also

Summary: Learn how to back up a farm configuration in SharePoint 2013 by using Central Administration or Windows PowerShell.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can back up a farm configuration by using the SharePoint Central Administration website or Windows PowerShell. The backup tool that you use depends on the kind of environment that you have deployed, your backup schedule requirements, and service level agreements that you have with your organization.

Before you begin

We recommend that you regularly back up the complete farm by backing up both the configuration and content. However, you might want to perform configuration-only backups in test or development environments. Similarly, if you are using SQL Server tools to back up the databases for the farm, you will want to back up the configuration. Regularly backing up the farm reduces the possibility of data losses that can occur from hardware failures, power outages, or other problems. It helps make sure that all the farm data and configurations are available for recovery. For more information about what to back up, see Plan for backup and recovery in SharePoint 2013.

For information about which tool to use for backups, see Overview of backup and recovery in SharePoint 2013.

Before you begin this operation, review the following information:

  • You must create a folder on the local computer or the network in which to store the backups. For better performance, we recommend that you back up to the local computer and then move the backup files to a network folder. For more information about how to create a backup folder, see Prepare to back up and restore farms in SharePoint 2013.

  • Backing up the farm configuration will not back up the information that you have to have to restore service applications. If you want to restore a service application, you must perform a configuration and content backup of the farm. For more information about how to back up service applications, see Back up service applications in SharePoint 2013.

  • You cannot use either SQL Server tools or Data Protection Manager to back up the farm configuration.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Windows PowerShell to back up a SharePoint farm configuration

You can use Windows PowerShell to back up the configuration from any configuration database on the current farm, on another farm, or from a configuration database that is not associated with any farm. You can back up a farm configuration manually or as part of a script that can be run at scheduled intervals.

To back up the configuration from any configuration database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPConfigurationDatabase -Directory <BackupFolder> -DatabaseServer <DatabaseServerName> -DatabaseName <DatabaseName> -DatabaseCredentials <WindowsPowerShellCredentialObject> [-Verbose]

    Where:

    • <BackupFolder> is the path to the folder that has the correct backup files.

    • <DatabaseServerName> is the name of the database server for the farm that you are backing up.

    • <DatabaseName> is the name of the farm configuration database.

    • If you are not logged on with an account with db_backupoperator fixed database role on the database server where the configuration database is stored, you must specify the value for DatabaseCredentials parameter.

For more information, see Backup-SPConfigurationDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to back up a SharePoint farm configuration

You can use Central Administration to back up the configuration of the farm that Central Administration is running on. To back up the configuration of a remote farm, you must use the Central Administration Web site that is running on the remote farm. You cannot use Central Administration to back up an unattached configuration database.

To back up a farm configuration by using Central Administration

  1. Verify that the user account performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration home page, in the Backup and Restore section, click Perform a backup.

  3. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, select the farm from the list of components, and then click Next.

    Note:

    You can back up the configuration for any service or application. However, common practice is to back up configuration at the farm level.

  4. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select Full.

  5. In the Backup Only Configuration Settings section, select the Backup only configuration settings option.

  6. In the Backup File Location section, type the Universal Naming Convention (UNC) path of the backup folder, and then click Start Backup.

  7. You can view the general status of all backup jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current backup job in the lower part of the page in the Backup section. The status page updates every 30 seconds automatically. You can manually refresh the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Spbackup.log file at the UNC path that you specified in step 5.

See also

Restore farm configurations in SharePoint 2013


Back up web applications in SharePoint 2013
See also

Summary: Learn how to back up a web application in SharePoint 2013 by using Central Administration or Windows PowerShell.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can back up a web application by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. The backup tool that you use depends on the kind of environment that you have deployed, your backup schedule requirements, and service level agreements that you have with your organization.

Before you begin

Regularly backing up a web application reduces the possibility of data losses that might occur from hardware failures, power outages, or other problems. It is a simple process that can help make sure that all the web application-related data and configurations are available for recovery, if that is required. We recommend that web application backups be created in addition to regular backups at the farm level.

Before you begin this operation, review the following information:

  • Before you begin, you must create a network folder in which to store the backups. Both the Windows SharePoint Services Timer V4 service account and the server farm user account must have Full Control permissions to this folder. For more information about how to create a backup folder, see Prepare to back up and restore farms in SharePoint 2013.

  • You can back up only one web application at a time by using the procedures in this article. However, you can at the same time back up all web applications by backing up the complete farm.

  • Backing up a web application does not affect the state of the farm. However, it does require resources and might slightly affect farm performance when the backup is running. You can avoid performance issues by backing up the web application during hours when farm use is lowest, such as outside office hours.

  • If the web application uses the object cache, you must manually configure two special user accounts for the web application after you restore the web application.

  • When you back up a web application, the Internet Information Services (IIS) settings and all content databases that are associated with the web application are also backed up.

  • When you back up a web application that is configured to use forms-based authentication, you must also use a file backup system to protect the Web.config files because the Web.config files were updated manually to register the membership and role providers, and manual changes to the Web.config files are not backed up. Similarly, Web.config files are not restored when you restore a Web application. After recovery, you must update the Web.config files and redeploy the providers. For more information, see Plan for user authentication methods in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Windows PowerShell to back up a web application

You can use Windows PowerShell to back up a web application manually or as part of a script that can be run at scheduled intervals.

To back up a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

      Note:

      Alternately, the user can be a member of the db_backupoperator fixed database role on all databases that are to be updated if you do not want to assign full rights of the db_owner role.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPFarm -Directory <BackupFolder> -BackupMethod {Full | Differential} -Item <WebApplicationName> [-Verbose]

    Where:

    • <BackupFoler> is the path of the folder that you use for storing backup files.

    • <WebApplicationName> is the name of the web application. To display the name of the web application, at the Windows PowerShell command prompt, type the following command: Backup-SPFarm -ShowTree

    Note:

    If you are backing up the web application for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

For more information, see Backup-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to back up a web application

You can use Central Administration to back up a web application.

To back up a web application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Perform a backup.

  4. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, select the web application from the list of components, and then click Next.

    Note:

    The web application might consist of several components. You must select the top-level component.

  5. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select either Full or Differential.

    Note:

    If you are backing up the web application for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

  6. In the Back Up Only Configuration Settings section, click Back up content and configuration settings.

  7. In the Backup File Location section, type the Universal Naming Convention (UNC) path of the backup folder, and then click Start Backup.

  8. You can view the general status of all backup jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current backup job in the lower part of the page in the Backup section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Spbackup.log file at the UNC path that you specified in step 6.

Use SQL Server tools to back up a web application

You cannot back up the complete web application by using SQL Server tools. However, you can back up all the databases that are associated with the web application. To back up the complete web application, use either Windows PowerShell or Central Administration.

To back up a web application by using SQL Server tools

  1. Verify that the user account that is used to back up the databases is a member of the SQL Server db_backupoperator fixed database role on the database server where each database is stored. Additionally, verify that the user account has Full Control permissions on the backup folder.

  2. Open SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Right-click the database that you want to back up, point to Tasks, and then click Back Up.

  5. In the Back Up Database dialog box, in the Source area, select the kind of backup that you want to perform from the Backup type list. For more information about which backup type to use, see Recovery Models (SQL Server).

  6. In the Backup component area, click Database.

  7. Either use the default name that is provided or specify a name for the backup set in the Name text box.

  8. Specify the expiration date for the backup set. This date determines how long, or when, the backup set can be overwritten by any later backups that have the same name. By default, the backup set is set to never expire (0 days).

  9. In the Destination area, specify where you want to store the backup.

  10. Click OK to back up the database.

  11. Repeat steps 1-10 for each database that is associated with the web application.

See also

Restore web applications in SharePoint 2013
Back up farms in SharePoint 2013
Plan for backup and recovery in SharePoint 2013
Backup and restore SharePoint 2013

Data Protection and Recovery


Back up service applications in SharePoint 2013
See also

Summary: Learn how to back up a service application in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can back up a service application by using the SharePoint Central Administration website or Windows PowerShell. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

In this article:

  • Before you begin

  • Use Windows PowerShell to back up a service application in SharePoint

  • Use Central Administration to back up a service application in SharePoint

Before you begin

We recommend that you regularly back up at the farm level. However, business or IT requirements might require you to back up a service application. Regularly backing up a service application reduces the possibility of data losses that might occur from hardware failures, power outages, or other problems. It is a simple process that helps make sure that all the service application-related data and configurations are available for recovery, if that is required. You can back up one service application at a time, or you can back up all service applications at the same time. For information about what to back up and which tools to use, see Plan for backup and recovery in SharePoint 2013. For more information, see Back up farms in SharePoint 2013.

Backing up a service application does not affect the state of the farm. However, it does require resources. Therefore, backing up a service application might affect farm performance while the backup is running. You can avoid performance issues by backing up the service application during hours when farm use is lowest.

Note:

SharePoint 2013 backup backs up remote Binary Large Object (BLOB) stores but only if you are using the FILESTREAM remote BLOB store provider to put data in remote BLOB stores.

If you are using another provider, you must manually back up the remote BLOB stores.

Before you begin this operation, review the following information about prerequisites:

  • You must create a folder on the local computer or the network in which to store the backups. For better performance, we recommend that you back up to the local computer and then move the backup files to a network folder. For more information about how to create a backup folder, see Prepare to back up and restore farms in SharePoint 2013.

  • SharePoint 2013 backup backs up the SQL Server Remote BLOB Store installation package from the Feature Pack for SQL Server 2008 R2 external content type definitions but does not back up the data source itself. To protect the data, you should back up the data source when you back up the SQL Server Remote BLOB Store installation package from the Feature Pack for SQL Server 2008 R2 or the farm.

  • If you back up the SQL Server Remote BLOB Store installation package from the Feature Pack for SQL Server 2008 R2 or the farm and then restore the data source to a different location, you must change the location information in the external content type definition. If you do not, the SQL Server Remote BLOB Store installation package from the Feature Pack for SQL Server 2008 R2 might be unable to locate the data source.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Windows PowerShell to back up a service application in SharePoint

You can use Windows PowerShell to back up one or more service applications manually or as part of a script that can be run at scheduled intervals.

To back up a service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPFarm -Directory <BackupFolder> -BackupMethod {Full | Differential} -Item <ServiceApplicationName> [-Verbose]

    Where:

    • <BackupFolder> is the path of a folder on the local computer or on the network in which you want to store the backups.

    • <ServiceApplicationName> is the name of the service application that you want to back up. To display the name of the service application, at the Windows PowerShell command prompt, type the following command: Backup-SPFarm -ShowTree.

    To back up all the service applications, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPFarm -Directory <BackupFolder> -BackupMethod {Full | Differential} -Item "Farm\Shared Service Applications" [-Verbose]
    Note:

    If you are backing up the service application for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

    Some service applications always require a full backup. For these service applications, even if you select the Differential option, the system performs a full backup.

For more information, see Backup-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to back up a service application in SharePoint

You can use Central Administration to back up a service application.

To back up a service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Perform a backup.

  4. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, select the service application from the list of components, and then click Next. To back up all the service applications, select the Shared Service Applications node.

    Note:

    The service application might consist of several components. You must select the top-level component.

  5. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select either Full or Differential.

    Note:

    If you are backing up the service application for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

    Some service applications always require a full backup. For these service applications, the system performs a full backup even if you select the Differential option.

  6. In the Backup File Location section, in the Backup location box, type the path of the backup folder, and then click Start Backup.

  7. You can view the general status of all backup jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current backup job in the lower part of the page in the Backup section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Spbackup.log file at the UNC path that you specified in step 5.

See also

Restore service applications in SharePoint 2013


Back up User Profile service applications in SharePoint Server 2013
See also

Summary: Learn how to back up the User Profile Service service application in SharePoint 2013.

Applies to: SharePoint Server 2013

You can back up the User Profile service application by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

Important:

The steps in this article apply to SharePoint Server 2013.

In this article:

  • Before you begin

  • Use Windows PowerShell to back up a User Profile service application

  • Use Central Administration to back up a User Profile Service application

  • Use SQL Server tools to back up a User Profile service application database

Before you begin

We recommend that you regularly back up at the farm level. However, business or IT requirements might require you to back up the User Profile Service service application. Regularly backing up the User Profile service application reduces the possibility of data losses that might occur from hardware failures, power outages, or other problems. It is a simple process that helps make sure that all service application-related data and configurations are available for recovery, if that is required.

For information about what to back up and which tools to use, see Plan for backup and recovery in SharePoint 2013. You can back up all the service applications in the farm by backing up the complete farm. For more information, see Back up farms in SharePoint 2013.

Before you begin this operation, review the following information:

  • Backing up the User Profile service application does not affect the state of the farm. However, it does require resources. Therefore, backing up the service application might affect farm performance while the backup is running. You can avoid performance issues by backing up the service application during hours when farm use is lowest.

  • You must create a folder on the local computer or the network in which to store the backups. For better performance, we recommend that you back up to the local computer and then move the backup files to a network folder. For more information about how to create a backup folder, see Prepare to back up and restore farms in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Windows PowerShell to back up a User Profile service application

You can use Windows PowerShell to back the User Profile service application manually or as part of a script that can be run at scheduled intervals.

Note:

Backup of a User Profile service application can fail the first time that you use Windows PowerShell to perform the backup. If this occurs, repeat the backup procedure using Windows PowerShell. For details about a backup failure, see the spbackup.log or sprestore.log files in the backup directory.

To back up the User Profile service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPFarm -Directory <BackupFolder> -BackupMethod Full -Item Farm\Shared Services\Shared Service Applications\<ServiceApplicationName> [-Verbose]

    Where:

    • <BackupFolder> is the path of a folder on the local computer or on the network in which you want to store the backups.

    • <ServiceApplicationName> is the name of the User Profile Service service application that you want to back up.

      The User Profile Service service application always requires a full backup,

      Note:

      The User Profile Service service application always requires a full backup,

  4. You must also back up the service application proxy. To do this, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPFarm -Directory <BackupFolder> -BackupMethod Full -Item Farm\Shared Services\Shared Service Proxies\<ServiceApplicationProxyName > [-Verbose]

    Where:

    • <BackupFolder> is the path of a folder on the local computer or on the network in which you want to store the backups.

    • <ServiceApplicationProxyName> is the name of the User Profile Service service application proxy that you want to back up.

For more information, see Backup-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to back up a User Profile Service application

You can use Central Administration to back up the User Profile service application.

Note:

Backup of a User Profile service application can fail the first time that you use Central Administration to perform the backup. If this occurs, repeat the backup procedure using Central Administration. For details about a backup failure, see the spbackup.log or sprestore.log files in the backup directory.

To back up the User Profile service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Perform a backup.

  4. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, select the User Profile Service service application from the list of components, and then click Next.

  5. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select Full.

    Note:

    The User Profile service application always requires a full backup. You must use the Full option.

  6. In the Backup File Location section, in the Backup location box, type the path of the backup folder, and then click Start Backup.

  7. You must also back up the service application proxy. To do this, in Central Administration, on the home page, in the Backup and Restore section, click Perform a backup.

  8. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, select the User Profile Service service application proxy from the list of components, and then click Next.

  9. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select Full.

  10. In the Backup File Location section, in the Backup location box, type the path of the backup folder, and then click Start Backup.

  11. You can view the general status of all backup jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current backup job in the lower part of the page in the Backup section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Spbackup.log file at the UNC path that you specified in step 5.

Use SQL Server tools to back up a User Profile service application database

You cannot back up the whole User Profile service application or service application proxy. You must use either Windows PowerShell or Central Administration. However, you can back up all the databases that are associated with the User Profile Service service application.

To back up a User Profile service application database by using SQL Server

  1. Verify that the user account that is performing this procedure is a member of the SQL Serverdb_backupoperator fixed database role on the database server where each database is stored.

  2. Before you back up the User Profile Service service application databases, you must export the Microsoft Identity Integration Server Key (MIIS) encryption key. You will import this exported key before you restore the databases. By default, the key is located on the server that runs SharePoint Server 2013 that is hosting the Microsoft Forefront Identity Manager services in the following directory: <root directory drive>\Program Files\Microsoft Office Servers\15.0\Synchronization Service\Bin. To export the key, type the following at the command prompt:

    Copy code
    miiskmu.exe

    Use the Microsoft Identity Integration Server Key Management Utility Wizard to export the key set.

  3. Open SQL Server Management Studio and connect to the database server.

  4. In Object Explorer, expand Databases.

  5. Right-click the database that you want to back up, point to Tasks, and then click Back Up.

  6. In the Back Up Database dialog box, in the Source area, select the kind of backup that you want to perform from the Backup type list, select Full. The User Profile service application always requires a full backup.

  7. In the Backup component area, click Database.

  8. Either use the default name that is provided or specify a name for the backup set in the Name text box.

  9. Specify the expiration date for the backup set. This date determines how long, or when, the backup set can be overwritten by any later backups that have the same name. By default, the backup set is set to never expire (0 days).

  10. In the Destination area, specify where you want to store the backup.

  11. Click OK to back up the database.

  12. Repeat steps 1-10 for each farm database.

See also

Backup solutions in SharePoint 2013
Overview of the User Profile service application in SharePoint Server 2013
Windows PowerShell for SharePoint 2013 reference
Restore service applications in SharePoint 2013


Back up Search service applications in SharePoint 2013
See also

Summary: Learn how to back up Search Service Application in SharePoint 2013.

Applies to: SharePoint Server 2013

You can back up a farm by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013, except where noted.

In this article:

  • Before you begin

  • Back up a thesaurus file

  • Use Windows PowerShell to back up search in SharePoint 2013

  • Use Central Administration to back up search in SharePoint 2013

  • Use SQL Server tools to back up search

Before you begin

We recommend that you regularly back up at the farm level. However, business or IT requirements might require you to back up the search service and related resources. Regularly backing up the search system reduces the possibility of data losses that might occur from hardware failures, power outages, or other problems. It is a simple process that helps make sure that data and configurations that compose the search system are available for recovery, if that is required.

Before you begin this operation, review the following information:

  • You must create a folder on the local computer or the network in which to store the backups. For better performance, we recommend that you back up to the local computer and then move the backup files to a network folder.

  • You cannot use SQL Server tools or Data Protection Manager to back up all of the search components.

  • Backing up search does not affect the state of the farm. However, it does require resources. Therefore, backing up search might affect farm performance while the backup is running. You can avoid performance issues by backing up search during hours when farm use is lowest.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Back up a thesaurus file

Thesaurus files are used to specify synonyms for words or phrases that occur in search queries. You create and maintain the thesaurus files in systems external to SharePoint 2013 before you import them into SharePoint 2013 to make them available to the search system. The thesaurus files are therefore not included in the SharePoint 2013 search backup procedures outlined below.

To back up your thesaurus files, make sure that they are included in the backup procedures for the external system you are using to create and maintain the thesaurus files.

Use Windows PowerShell to back up search in SharePoint 2013

You can use Windows PowerShell to back up search manually or as part of a script that can be run at scheduled intervals. This procedure backs up all of the search components including the databases, the search service configuration, and all of the index files.

To back up search by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Farm Administrators SharePoint group.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPFarm -Directory <BackupFolder> -BackupMethod {Full | Differential} -Item "<SearchServiceApplicationName>" [-Verbose]

    Where:

    • <BackupFolder> is the path of the folder that you use for storing backup files.

    • <SearchServiceApplicationName> is the name of the Search service application that you are backing up.

    Note:

    If you are backing up the farm for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup. To view the progress of the backup operation, use the Verbose parameter.

    The Differential option only applies to the search databases. The search index files are always fully backed up, even when you use the Differential option.

For more information, see Backup-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to back up search in SharePoint 2013

You can use Central Administration to back up search. This procedure backs up all of the search components including the databases, the search service configuration, and all of the index files.

To back up search by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Perform a backup.

  4. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, in the list of components, expand Shared Services and then expand Shared Services Applications to view the list of service applications in the farm. Select the search service application from the list of components, and then click Next.

    Note:

    The search service application might consist of several components. You must select the top-level component. By default, the service application is named "Search Service Application".

  5. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select either Full or Differential.

    Note:

    If you are backing up search for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

    The Differential option only applies to the search databases. The search index files are always fully backed up, even when you use the Differential option.

  6. In the Backup File Location section, in the Backup location box, type the path of the backup folder, and then click Start Backup.

  7. You can view the general status of all backup jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current backup job in the lower part of the page in the Backup section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are timer service jobs. Therefore, it might take several seconds for the backup to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Spbackup.log file at the UNC path that you specified in step 6.

Use SQL Server tools to back up search

You cannot back up the complete SharePoint Search service application by using SQL Server tools. However, you can use SQL Server tools to back up the databases that are associated with the Search service application. To back up the complete Search service application, use either Windows PowerShell or Central Administration.

To use SQL Server to back up the databases that are associated with the Search service application, you must follow these steps:

  1. Pause the Search service application.

  2. Back up all the Search service application databases with SQL Server tools.

  3. Resume the Search service application.

To pause the Search service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication -Identity <SearchServiceApplicationName>
Suspend-SPEnterpriseSearchServiceApplication -Identity $ssa

    Where:

    • <SearchServiceApplicationName> is the name of the Search service application that you are backing up.

To back up all the Search service application databases by using SQL Server tools

  1. Verify that the user account that is performing this procedure is a member of the SQL Serverdb_backupoperator fixed database role on the database server where each database is stored.

  2. Start SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Right-click the database that you want to back up, point to Tasks, and then click Back Up.

  5. In the Back Up Database dialog box, in the Source area, select the kind of backup that you want to perform from the Backup type list. For more information about which backup type to use, see Recovery Models (SQL Server) in SQL Server Books Online.

  6. In the Backup component area, click Database.

  7. Either use the default name or specify a name for the backup set in the Name text box.

  8. Specify the expiration date for the backup set. This date determines how long, or when, the backup set can be overwritten by any later backups that have the same name. By default, the backup set is set to never expire (0 days).

  9. In the Destination area, specify where you want to store the backup.

  10. Click OK to back up the database.

  11. Repeat steps 1-10 for the following databases:

    • Search Administration

    • Analytics Reporting

    • Crawl

    • Link

To resume the Search service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication -Identity <SearchServiceApplicationName>
Resume-SPEnterpriseSearchServiceApplication -Identity $ssa

    Where:

    • <SearchServiceApplicationName> is the name of the Search service application.

See also

What's New in SharePoint 2013 Resource Center


Back up the Secure Store Service in SharePoint 2013
See also

Summary: Learn how to back up the Secure Store Service Application in SharePoint Server 2013.

Applies to: SharePoint Server 2013

You can back up the Secure Store Service by using the SharePoint Central Administration website, or Windows PowerShell. The backup tool that you use depends on the kind of environment that you have deployed, your backup schedule requirements, and service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Use Windows PowerShell to back up the Secure Store Service in SharePoint

  • Use Central Administration to back up the Secure Store Service in SharePoint Server 2013

Before you begin

The Secure Store Service provides the capability of securely storing credential sets and associating credentials to specific identities or a group of identities. Every time that you enter a new passphrase, SharePoint Server 2013 creates a new Master Key and re-encrypts the credentials sets with that key. The passphrase gives you access to the Master Key created by SharePoint Server 2013 that is used to encrypt the credential sets.

You should back up the Secure Store Service and record the passphrase after the Secure Store Service is first configured and again every time that you make configuration changes to the Secure Store Service or re-encrypt the credential information.

Before you begin this operation, review the following information:

  • You must create a folder on the local computer or the network in which to store the backups. For better performance, we recommend that you back up to the local computer and then move the backup files to a network folder.

  • Record the passphrase. You will need the passphrase when you access the restored Secure Store Service.

  • Ensure that you back up the Secure Store Service every time that you change or refresh the Master Key. When you change or refresh the Master key, the database is automatically re-encrypted with the new key. Backing up the Secure Store Service makes sure that the database and the Master key are in synchronization.

  • Keep the passphrase in a secure location.

Note:

Because SharePoint Server 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint Server 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Windows PowerShell to back up the Secure Store Service in SharePoint

You can use Windows PowerShell to back up the Secure Store Service manually or as part of a script that can be run at scheduled intervals.

To back up the Secure Store Service by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPFarm -Directory  <BackupFolder> -BackupMethod Full -Item <SecureStoreService > [-Verbose]

    Where:

    • <BackupFolder> is the path of a folder on the local computer or on the network in which you want to store the backups.

    • <SecureStoreService> is the name of the Secure Store Service application that you want to back up.

    Note:

    You must use the Full option to back up the Secure Store Service.

For more information, see Backup-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to back up the Secure Store Service in SharePoint Server 2013

You can use Central Administration to back up the Secure Store Service.

To back up the Secure Store Service by using Central Administration

  1. Verify that the user account that performs this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Perform a backup.

  4. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, expand the Shared Services Applications node, select the Secure Store Service application from the list of components, and then click Next.

    Note:

    The Secure Store Service application might consist of several components. You must select the top-level component.

  5. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select Full.

  6. In the Backup File Location section, in the Backup location box, type the path of the backup folder, and then click Start Backup.

  7. You can view the general status of all backup jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current backup job in the lower part of the page in the Backup section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Spbackup.log file at the UNC path that you specified in step 5.

See also

Restore Secure Store Service in SharePoint Server 2013


Back up content databases in SharePoint 2013
See also

Summary: Learn how to back up a single content database in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Add introductory text that explains the contents of the topic.

You can back up a content database by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. The backup tool that you use depends on the kind of environment that you have deployed, your backup schedule requires, and service level agreements that you have made with your organization.

Before you begin

SharePoint 2013 content databases can grow to be very large. Therefore, you might want to back them up separately from farm backups. Regularly backing up content databases reduces data losses that might occur from hardware failures, power outages, or other problems. It is a simple process and helps make sure that all the data is available for recovery, if that is required. You can only back up one content database at a time.

Before you begin this operation, review the following information:

  • You must create a folder on the local computer or the network in which to store the backups. For better performance, we recommend that you back up to the local computer and then move the backup files to a network folder.

  • SharePoint 2013 backup backs up remote Binary Large Objects (BLOB) stores but only if you are using the SQL Filestream remote BLOB store provider to place data in remote BLOB stores.

    If you are using another provider you must manually back up these remote BLOB stores.

  • If you are using SQL Server with Transparent Data Encryption (TDE), and you are backing up your environment by using either SharePoint tools or SQL Server tools, the TDE encryption key in not backed up or restored. You must back up the key manually. When restoring, you must manually restore the key before restoring the data. For more information, see Understanding Transparent Data Encryption (TDE).

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Windows PowerShell to back up a content database in SharePoint 2013

You can use Windows PowerShell to back up a content database manually or as part of a script that can be run at scheduled intervals.

To back up a content database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPFarm -Directory   <BackupFolder>  -BackupMethod {Full | Differential} -Item <ContentDatabaseName> [-Verbose]

    Where:

    • <BackupFolder> is the path of the backup folder.

    • <ContentDatabaseName> is the name of the database that you want to back up. To display the name of the content database, type the following command at the Windows PowerShell command prompt: Get-SPContentDatabase.

    To view the progress of the backup operation, use the Verbose parameter.

    Note:

    If you are backing up the content database for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

For more information, see Backup-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to back up a content database in SharePoint 2013

You can use Central Administration to back up a content database.

To back up a content database by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Perform a backup.

  4. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, select the content database that you want to back up from the list of components, and then click Next.

    Note:

    Not all content databases can be selected in the list. If a database is not selectable, you must use Windows PowerShell to back up the content database.

  5. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select either Full or Differential.

    Note:

    If you are backing up the content database for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

  6. In the Backup File Location section, type the Universal Naming Convention (UNC) path of the backup folder, and then click Start Backup.

  7. You can view the general status of all backup jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status of the current backup job in the lower part of the page in the Backup section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, review the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Spbackup.log file at the UNC path that you specified in step 5.

Use SQL Server tools to back up a content database in SharePoint 2013

You can use SQL Server tools to back up a content database.

To back up a content database by using SQL Server tools

  1. Verify that the user account that is performing this procedure is a member of the SQL Server db_backupoperator fixed database role on the database server where each database is stored.

  2. Open SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Right-click the database that you want to back up, point to Tasks, and then click Back Up.

  5. In the Back Up Database dialog box, in the Source area, select the kind of backup that you want to perform from the Backup type list. For more information about which backup type to use, see Recovery Models (SQL Server) in SQL Server Books Online.

  6. In the Backup component area, click Database.

  7. Either use the default name that is provided or specify a name for the backup set in the Name text box.

  8. Specify the expiration date for the backup set. This date determines how long, or when, the backup set can be overwritten by any later backups that have the same name. By default, the backup set is set to never expire (0 days).

  9. In the Destination area, specify where you want to store the backup.

  10. Click OK to back up the database.

  11. Repeat steps 1-9 for each content database that you want to back up.

See also

Restore content databases in SharePoint 2013

What's New in SharePoint 2013 Resource Center


Back up databases to snapshots in SharePoint Server 2013
See also

Summary: Learn how to back up databases to snapshots in SharePoint Server 2013 Enterprise Edition.

Applies to: SharePoint Server 2013

You can only back up databases to snapshots in SharePoint Server 2013 Enterprise Edition by using SQL Server tools.

Important:

The steps in this article apply to SharePoint Server 2013 Enterprise Edition only.

Before you begin

We recommend that you regularly back up the complete farm. Regularly backing up the farm reduces data losses that might occur from hardware failures, power outages, or other problems. It is a simple process and helps make sure that all the farm data and configurations are available for recovery, if that is required. For more information, see Back up farms in SharePoint 2013. However, IT requirements might require you to backup databases to snapshots. Although you can back up any farm database to a snapshot, you typically back up content databases.

Before you begin this operation, review the following information:

  • You must first create a folder on the database server for your backup files. If you want to store the snapshots at another location, you can move the backup files to a backup folder on the network after the operation is completed.

  • A database snapshot provides a read-only, static view of a source database as it existed at snapshot creation, minus any uncommitted transactions. Uncommitted transactions are rolled back in a newly created database snapshot because the Database Engine runs recovery after the snapshot was created (transactions in the database are not affected). For more information about database snapshots, see Database Snapshots (SQL Server).

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use SQL Server tools to back up a database to a snapshot in SharePoint Server

If you want to back up databases to snapshots, you must use SQL Server tools. The databases that are associated with the farm are determined by the service applications and features that you have installed on the farm.

To back up a database to a snapshot by using SQL Server tools

  1. Verify that the user account that is performing this procedure is a member of the SQL Serverdb_owner fixed database role.

  2. Open SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Select the database that you want to back up, and then click New Query.

  5. Copy the following text, and then paste it to the query pane.

    Copy code
    CREATE DATABASE <snapshot name>
ON
(
NAME=<logical name of the database file>,
FILENAME = 'c:\WSS_Backup1.ss')
AS SNAPSHOT OF <database name>;

See also

Database Snapshots (SQL Server)


Back up customizations in SharePoint 2013
See also

Summary: Learn how to back up customizations that are made to SharePoint 2013 sites.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can back up customizations that are made to SharePoint 2013 sites by using the SharePoint Central Administration website or Windows PowerShell. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

In this article:

  • Before you begin

  • Back up solution packages in SharePoint 2013

  • Backing up sandboxed solutions in SharePoint 2013

  • Back up authored site elements in SharePoint 2013

  • Back up workflows in SharePoint 2013

  • Back up changes to the Web.config file in SharePoint 2013

  • Back up third-party products in SharePoint 2013

  • Back up changes made by direct editing in SharePoint 2013

  • Back up developed customizations that are not packaged as solutions in SharePoint 2013

Before you begin

Before you begin this operation, review the following list of possible customizations that you can make to your sites:

  • Customizations packaged as solutions (.wsp files). Solutions contain developed site elements, and are typically created by developers. Developed site elements include the following:

    • Web Parts

    • Workflows

    • Site and list definitions

    • Document converters

    • Event receivers

    • Timer jobs

    • Assemblies

  • Authored site elements, which are typically created by web designers, are not explicitly compiled and are located in a content database. Authored site elements include the following:

    • Master pages

    • Cascading style sheets

    • Forms

    • Layout pages

  • Changes to the Web.config file

  • Third-party solutions and their associated binary files and registry keys, such as IFilters

  • Changes to sites created by direct editing through the browser

  • Developed customizations that are not packaged as solutions

Note:

Each of these kinds of customizations requires a different type of backup.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Back up solution packages in SharePoint 2013

Solution packages can be created by using SharePoint Designer 2013 or Visual Studio 2012. We strongly recommend that all customizations be deployed as solution packages.

A solution package is a deployable, reusable file that can contain a set of Features, site definitions, and assemblies that apply to sites, and that you can enable or disable individually. Solution packages can include Web Parts, site or list definitions, custom columns, new content types, custom fields, custom actions, coded workflows, or workflow activities and conditions.

The method that you use to back up solution packages is determined by whether the customizations are deployed as trusted solutions or sandboxed solutions.

Trusted solutions are solution packages that farm administrators deploy. Trusted solutions are deployed to the entire farm and can be used on any site within the farm. Trusted solutions are stored in the configuration database. Trusted solutions are backed up when a farm is backed up by using SharePoint 2013 backup, and are included in configuration-only backups. You can also back up trusted solutions as a group or individually. Trusted solutions are visible in the backup hierarchy.

Sandboxed solutions are solution packages that site collection administrators can deploy to a single site collection. Sandboxed solutions are stored in the content database that is associated with the site collection to which the solution packages are deployed. They are included in SharePoint 2013 farm, web application, content database, and site collection backups, but are not visible in the backup hierarchy and cannot be selected or backed up individually.

We recommend that you keep a backup of the original .wsp file and the source code used to build the .wsp file for both trusted solutions and sandboxed solutions.

To back up trusted solutions by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Perform a backup.

  4. On the Perform a Backup — Step 1 of 2: Select Component to Back Up page, select Solutions, and then click Next.

    You can also select an individual solution, if you only want to back up a single solution.

  5. On the Start Backup — Step 2 of 2: Select Backup Options page, in the Backup Type section, select either Full or Differential.

    Note:

    If you are backing up the solution for the first time, you must use the Full option. You must perform a full backup before you can perform a differential backup.

  6. In the Backup File Location section, type the Universal Naming Convention (UNC) path of the backup folder, and then click Start Backup.

  7. You can view the general status of all backup jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status of the current backup job in the lower part of the page in the Backup section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, review the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Spbackup.log file at the UNC path that you specified in step 4.

To back up trusted solutions by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command to back up all of the solutions in the farm. To back up a single solution, add the name of the solution to the item path "farm\solutions".

    Copy code
     Backup-SPFarm -backupmethod full -directory <UNC location> -item "farm\solutions"

    Where:

    • <UNC location> is the UNC location of the directory that you want to back up to.

For more information, see Backup-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Backing up sandboxed solutions in SharePoint 2013

You cannot back up only sandboxed solutions. Instead, you must back up the farm, Web application, or content database with which the sandboxed solution is associated. For more information about these methods of backing up, see Related Topics.

Back up authored site elements in SharePoint 2013

You cannot back up only authored site elements. Instead, you must back up the farm, Web application, or content database with which the authored site element is associated. For more information about these methods of backing up, see Related Topics.

Back up workflows in SharePoint 2013

Workflows are a special case of customizations that you can back up. Make sure that your backup and recovery plan addresses any of the following scenarios that apply to your environment:

  • Declarative workflows, such as those that were created in SharePoint Designer 2013, are stored in the content database for the site collection to which they are deployed. Backing up the content database protects these workflows.

  • Custom declarative workflow actions have components in the following three locations:

    1. The Visual Studio 2012 assemblies for the actions are stored in the global assembly cache (GAC).

    2. The XML definition files (.ACTIONS files) are stored in the 15\TEMPLATE\<LCID>\Workflow directory.

    3. An XML entry to mark the action as an authorized type is stored in the Web.config file for the Web applications in which it is used.

    If the farm workflows use custom actions, you should use a file backup system to protect these files and XML entries. Similar to SharePoint 2013 features such as Web Parts and event receivers, these files should be reapplied to the farm as needed after recovery.

  • Workflows that depend on custom code, such as those that are created by using Visual Studio 2012, are stored in two locations. The Visual Studio 2012 assemblies for the workflow are stored in the GAC, and the XML definition files are stored in the Features directory. This is the same as other types of SharePoint 2013 features such as Web Parts and event receivers. If the workflow was installed as part of a solution package, backing up the farm, Web application, content database, or site collection protects these workflows.

  • If you create a custom workflow that interacts with a site collection other than the one where the workflow is deployed, you must back up both site collections to protect the workflow. This includes workflows that write to a history list or other custom list in another site collection. Performing a farm backup is sufficient to back up all site collections in the farm and all workflows that are associated with them.

  • Workflows that are not yet deployed must be backed up and restored separately. When you are developing a new workflow but have not yet deployed it to the SharePoint 2013 farm, make sure that you back up the folder where you store the workflow project files by a file system backup application.

Back up changes to the Web.config file in SharePoint 2013

A common customization to SharePoint 2013 is to change the Web.config file. We strongly recommend that you make changes to the Web.config file by using Central Administration or the SharePoint 2013 APIs and object model. Because these changes are stored in the configuration database, they can be recovered from a farm or configuration-only backup.

Changes to the Web.config file that are not made by using Central Administration or the SharePoint 2013 APIs and object model should be protected by using a file system backup.

Note:

If you are using forms-based authentication, provider registration in the Web.config file is manual, and is not protected by SharePoint 2013 backup. In this case, make sure that you back up the Web.config file by using a file system backup.

Back up third-party products in SharePoint 2013

If third-party products are deployed as solution packages, they are protected by SharePoint 2013 backup. We recommend that you keep all the original files, distribution media, documentation, and the license and product keys that are required for installation.

Back up changes made by direct editing in SharePoint 2013

Changes made directly to a site by directly editing through the browser can be difficult to back up. The following table describes backup strategies for specific objects.

Edited object | Backup strategy
List | Use SharePoint Designer 2013 and save as a template. For more information, see Save a SharePoint site as a template.
Site | Use SharePoint Designer 2013 and save as a template. For more information, see Save a SharePoint site as a template.
Site collection | Use site collection backup. For more information, see Back up site collections in SharePoint 2013.

Back up developed customizations that are not packaged as solutions in SharePoint 2013

Backing up developed customizations that are not deployed as solution packages can be a complex process because the customization file locations might not be stored in standardized places and SharePoint 2013 does not automatically back them up.

Consult with the development team or customization vendor to determine whether the customizations involve additional add-in software or files in other locations. We recommend that you back up these directories with a file system backup solution. The following table lists locations where developed customizations are typically stored on Web servers.

Location | Description
%PROGRAMFILES%\Common files\Microsoft Shared\Web Server Extensions\15 | Commonly updated files, custom assemblies, custom templates, custom site definitions
Inetpub | Location of IIS virtual directories
%WINDIR%\Assembly | Global assembly cache (GAC): a protected operating system location where the Microsoft .NET Framework code assemblies are installed to provide full system access

See also

Restore customizations in SharePoint 2013
Back up farms in SharePoint 2013
Back up farm configurations in SharePoint 2013
Back up web applications in SharePoint 2013
Back up content databases in SharePoint 2013
Back up site collections in SharePoint 2013


Back up site collections in SharePoint 2013
See also

Summary: Learn how to back up a single site collection in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can back up a site collection in SharePoint 2013 by using the SharePoint Central Administration website or Windows PowerShell.

In this article:

  • Before you begin

  • Use Windows PowerShell to back up a site collection in SharePoint 2013

  • Use Central Administration to back up a site collection in SharePoint 2013

Before you begin

We recommend that you regularly back up the complete farm. However, IT practices might require you to also back up a site collection. For more information about what to back up, see Plan for backup and recovery in SharePoint 2013.

Before you begin this operation, review the following information:

  • You must first create a folder on the local computer or the network in which to store the backups. For better performance, we recommend that you back up to the local computer and then move the backup files to a network folder. For more information about how to create a backup folder, see Prepare to back up and restore farms in SharePoint 2013.

  • If the site collection's Lock status is set to Not locked or Adding content prevented, SharePoint 2013 temporarily sets the site to Read-Only while the backup operation is occurring. SharePoint 2013 does this to reduce the possibilities of users changing the site collection while it is being backed up. After the backup is complete, the setting is changed back its normal status.

  • Performing a site collection backup might require resources and might slightly affect farm performance when the backup is running. You can help avoid performance issues by backing up the farm during hours when farm use is lowest, such as outside office hours.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Windows PowerShell to back up a site collection in SharePoint 2013

You can use Windows PowerShell to back up a site collection manually or as part of a script that can be run at scheduled intervals.

To back up a site collection by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPSite -Identity <SiteCollectionGUIDorURL> -Path <BackupFile> [-Force] [-NoSiteLock] [-UseSqlSnapshot] [-Verbose]

    Where:

    • <SiteCollectionGUIDorURL> is the ID or URL for the site collection you want to back up.

    • <BackupFile> is the path to where the backup file is located.

    If you want to overwrite a previously used backup file, use the Force parameter. You can use the NoSiteLock parameter to keep the read-only lock from being set on the site collection while it is being backed up. However, using this parameter can enable users to change the site collection while it is being backed up and could lead to possible data corruption during backup. To display the site collection GUID or URL at the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSite | format-list -property id,url

    If the database server is running an Enterprise Edition of SQL Server, we recommend that you also use the UseSqlSnapshot parameter for more consistent backups. You can also export sites or lists from these snapshots.

    Note:

    If the RBS provider that you are using does not support snapshots, you cannot use snapshots for content deployment or backup. For example, the SQL FILESTREAM provider does not support snapshots.

    For more information about how to use SQL snap-shots, see Back up databases to snapshots in SharePoint Server 2013.

For more information, see Backup-SPSite.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to back up a site collection in SharePoint 2013

You can use Central Administration to back up a site collection.

To back up a site collection by using Central Administration

  1. Verify that the user account performing this procedure is a member of the Farm Administrators group. Additionally, verify that the Windows SharePoint Services Timer V4 service has Full Control permissions on the backup folder.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Perform a site collection backup.

  4. On the Site collection backup page, select the site collection from the Site Collection list.

  5. Type the local path of the backup file in the Filename box.

    Note:

    If you want to reuse a file, select the Overwrite existing file check box.

  6. Click Start Backup.

  7. You can view the general status of all backup jobs at the top of the Granular Backup Job Status page in the Readiness section. You can view the status for the current backup job in the lower part of the page in the Site Collection Backup section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, you can review them in the Failure Message column of the Granular Backup Job Status page.

See also

Plan for backup and recovery in SharePoint 2013
Restore site collections in SharePoint 2013


Back up apps for SharePoint in SharePoint 2013
See also

Published: December 11, 2012

Summary: Learn how to back up apps for SharePoint in SharePoint 2013.

Applies to: apps for SharePoint | SharePoint Foundation 2013 | SharePoint Server 2013

The apps for SharePoint is a powerful new feature for SharePoint 2013. For more information, see Overview of apps for SharePoint 2013. For a graphical representation of apps for SharePoint, see SharePoint 2013: App Overview for IT Pro.

We recommend that you regularly back up at the farm level. However, business or IT requirements might require you to back up the apps for SharePoint in addition to normal farm backups. If you regularly back up the apps for SharePoint environment, you reduce the possibility of data losses that might occur from hardware failures, power outages, or other problems. It is a simple process that helps make sure that data and configurations that compose the apps for SharePoint environment are available for recovery, if that is required.

The app for SharePoint content and packages are in the SharePoint 2013 content databases in individual site collections. All app for SharePoint license and security data is stored in the App Management Service and the Secure Store Service application databases. Additional app for SharePoint data is stored in the SharePoint 2013 configuration database, in the form of Internet Information Services (IIS) web sites or web applications, and Web Part packages. You must back up the following SharePoint 2013 databases at the same time:

  • Content

  • Configuration

  • Secure Store Service application

  • App Management service application

If you have to eventually restore the databases, you have to restore the same version of each database that you backed up. In other words, don't restore a content database that's six months older than the configuration database.

For more information about the SharePoint 2013 databases, see Database types and descriptions (SharePoint 2013). For a graphical representation of the SharePoint 2013 databases, see Databases that support SharePoint 2013

You can back up an apps for SharePoint environment by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools.

In this article:

  • Before you begin

  • Back up content databases

  • Back up the configuration database

  • Back up the Secure Store Service application database

  • Back up the App Management service application database

  • Back up a site collection

    • To back up a site collection by using Windows PowerShell

Before you begin

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Back up content databases

Content databases can store data for multiple site collections. However, if you have many site collections, we recommend that you add enough content databases to keep the size of each database below 200 GB for optimal system performance. For more information, see Back up content databases in SharePoint 2013

Note:

SharePoint 2013 content databases become very large. We recommend that you back up each content database as a separate process from other database or farm backups.

Back up the configuration database

The SharePoint 2013 configuration database stores data about all SharePoint databases and Internet Information Services (IIS) web sites or web applications. This includes trusted solutions, Web Part packages, site templates, and web application settings, and farm settings that are specific to SharePoint 2013, such as default quota and blocked file types. For more information, see Back up farm configurations in SharePoint 2013.

Back up the Secure Store Service application database

The Secure Store Service database stores and maps credentials such as account names and passwords. To back up the Secure Store database for an apps for SharePoint environment, see Back up the Secure Store Service in SharePoint 2013.

Note:

Make sure that you record the passphrase when you back up the Secure Store database. You must have the passphrase available to restore the Secure Store database.

Back up the App Management service application database

The App Management service application database stores the app licenses and permissions for all apps downloaded from the App Catalog site in SharePoint 2013. To back up the App Management database, follow the same procedures as most other SharePoint 2013 service applications. For more information, see Back up service applications in SharePoint 2013.

Back up a site collection

You may have multiple site collections that host apps for SharePoint in your environment. When you backup apps for SharePoint you must also back up all site collections where the apps are hosted.

To back up a site collection by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not displayed on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Backup-SPSite -Identity <SiteCollectionGUIDorURL> -Path <BackupFile> [-Force] [-NoSiteLock] [-UseSqlSnapshot] [-Verbose]

    Where:

    • <SiteCollectionGUIDorURL> is the ID or URL for the site collection you want to back up.

    • <BackupFile> is the path of where the backup file is located.

    If you want to overwrite a previously used backup file, use the Force parameter. You can use the NoSiteLock parameter to keep the read-only lock from being set on the site collection while it is being backed up. However, using this parameter can enable users to change the site collection while it is being backed up and could lead to possible data corruption during backup. To display the site collection GUID or URL at the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSite | format-list -property id,url

    If the database server is running an Enterprise Edition of SQL Server, we recommend that you also use the UseSqlSnapshot parameter for more consistent backups. You can also export sites or lists from these snapshots.

    Note:

    If the RBS provider that you are using does not support snapshots, you can't use snapshots for content deployment or backup. For example, the SQL FILESTREAM provider does not support snapshots.

    For more information about how to use SQL snap-shots, see Back up databases to snapshots in SharePoint Server 2013.

    For more details, see Back up site collections in SharePoint 2013

For more information, see Backup-SPSite.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Plan for backup and recovery in SharePoint 2013
Restore apps for SharePoint in SharePoint 2013


Export sites, lists, or document libraries in SharePoint 2013
See also

Summary: Learn how to export a site, list, or document library in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can export a site, list, or document library in SharePoint 2013 by using the SharePoint Central Administration website or Windows PowerShell. The backup tool that you use depends on the kind of environment that you have deployed, your backup schedule requirements, and service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Use Windows PowerShell to export a site, list, or document library in SharePoint 2013

  • Use Central Administration to export a site, list, or document library in SharePoint 2013

Before you begin

We recommend that you regularly back up the complete farm. However, business or IT requirements might require you to export a site, list, or document library. Regularly exporting sites, lists, and document libraries reduces data losses that might occur from hardware failures, power outages, or other problems. It is a simple process and helps make sure that data is available for recovery, if that is required. You can only export one site, list, or document library at a time.

For information about what to back up and which tools to use, see Plan for backup and recovery in SharePoint 2013.

Before you begin this operation, review the following information about prerequisites:

  • Before you begin, you must create a folder on the local computer or the network in which to store the export file. For better performance, we recommend that you export to the local computer and then move the export file to a network folder.

  • You cannot use SQL Server tools or Data Protection Manager to export a site, list or document library.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Windows PowerShell to export a site, list, or document library in SharePoint 2013

You can use Windows PowerShell to export a site, list, or document library manually or as part of a script that can be run at scheduled intervals.

To export a site, list or document library by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Export-SPWeb -Identity <SiteURL> -Path <Path and File Name> [-ItemUrl <URL of Site, List, or Library>] [-IncludeUserSecurity] [-IncludeVersions] [-NoFileCompression] [-GradualDelete] [-Verbose]

    Where:

    • <SiteURL> is URL for the site, list, or library that you are exporting.

    • <Path and FileName> is path and name for the site, list, or library that you are exporting.

    • <URL of Site, List, or Library> is the URL for the site, list, or library where you are exporting.

    If you are exporting a large site, list, or document library, you can use the GradualDelete parameter. When this parameter is used, the site collection is marked as deleted, which immediately prevents any further access to its content. The data in the deleted site collection is then deleted gradually over time by a timer job instead of at one time, which reduces its effect on the performance of farm servers and SQL Server.

    To specify which version of the site, list, or document library to include, use the IncludeVersions parameter and specify "LastMajor" (default), "CurrentVersion", "LastMajorandMinor", or "All". To include the user security settings with the list or document library, use the IncludeUserSecurity parameter. If you want to overwrite the file that you specified, use the Force parameter. To view the progress of the backup operation, use the Verbose parameter.

    The NoFileCompression parameter lets you specify that no file compression is performed during the export process. Using this parameter can lower resource usage up to 30% during the export process. Using this parameter will result in a backup folder being created instead of a compressed file. If you use the NoFileCompression parameter in the Export-SPWeb command, you must also use it when you import the content by using the Import-SPWeb command.

For more information, see Export-SPWeb.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to export a site, list, or document library in SharePoint 2013

You can use Central Administration to export a site, list, or document library. You can only export one site, list, or document library at a time.

To export a site, list, or document library by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, click Backup and Restore.

  4. On the Backup and Restore page, in the Granular Backup section, click Export a site or list.

  5. On the Site or List Export page, in the Site Collection section, select the site collection from the Site Collection list, and then select the site from the Site list.

  6. If you are exporting a site, skip this step, Select the list or document library from the List list.

  7. In the File Location section, in the Filename box, type the UNC path of the shared folder and the file to which you want to export the list or document library. The file name must use the .cmp extension.

  8. If the file already exists and you want to use this file, select the Overwrite existing files check box. Otherwise, specify a different file name.

  9. If you want to export all the security and permissions settings with the list or library, in the Export Full Security section, select the Export full security check box.

  10. If you want to specify which version of the list or library to export, select one of the following versions from the Export versions list:

    • All Versions

    • Last Major

    • Current Version

    • Last Major and Last Minor

  11. When you have specified the settings that you want, click Start Export.

  12. You can view the status of all backup jobs at the top of the Granular Backup Job Status page. You can view the status of the current backup job in the Content Export section of the page. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the backup to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the <file name>.export.log file at the UNC path that you specified in step 6.

See also

Plan for backup and recovery in SharePoint 2013


Understanding SharePoint 2013 Workflow Backup
See also

Published: February 5, 2013

Summary: Learn about workflow backups in SharePoint Server 2013.

Applies to: SharePoint Server 2013

In this article:

  • How backup for workflow relates to SharePoint Server 2013

  • Related topics

How backup for workflow relates to SharePoint Server 2013

SharePoint administrators must account for both the SharePoint 2010 Workflow platform and the SharePoint 2013 Workflow platform when they consider backup and restore scenarios.

The SharePoint 2010 Workflow platform is integrated with SharePoint Server. When you back up SharePoint Server, or the underlying SQL Server databases, you are automatically backing up the SharePoint 2010 Workflow platform. To learn more about backup in SharePoint Server 2013, see Backup and restore SharePoint 2013.

In contrast, backing up the SharePoint 2013 Workflow platform is a separate operation from backing up SharePoint Server 2013.

Like SharePoint Server, Workflow Manager stores all of its content and configuration information in a SQL Server database. An important assumption is that the SQL Server layer of both SharePoint Server and Workflow Manager are highly available services. In other words, both the SharePoint databases and Workflow Manager databases must be kept in sync. From the SharePoint administrator's perspective, Workflow Manager is a separate service that is backed up and administered in its own realm.

SharePoint backups should be coordinated with Workflow Manager backups. However, there are not any specific actions that must be performed in SharePoint Server in order to backup the SharePoint 2013 Workflow platform. To learn more about backup, restore, and disaster recovery for Workflow Manager, see Disaster Recovery and Scope Restore in Workflow Manager.

Important:

The information in this article applies to SharePoint Server 2013. The SharePoint 2013 Workflow platform is not supported in SharePoint Foundation 2013.

See also

SharePoint 2013 Workflow Resource Center
Installation and Deployment for SharePoint 2013 Resource Center


Restore (SharePoint 2013)
See also

Summary: The articles in this section contain restore solutions for the SharePoint 2013 environment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet and related resources provide information about how to restore SharePoint 2013 data. These articles are written to meet the requirements of information technology (IT) professionals who are responsible for the planning, design, deployment, and operations of backup and recovery solutions. These solutions might be in enterprise, corporate, or branch office environments. The IT professionals who are responsible for backup and recovery solutions are expected to have an understanding of the technical details that are contained in this section.

Note:

The following articles apply to SharePoint Server 2013 and SharePoint Foundation 2013 unless otherwise noted.

TechNet articles about restore

The following articles about restore solutions for SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Restore farms in SharePoint 2013 | Describes the procedures that you can use to restore the complete farm from a backup.
 | Restore farm configurations in SharePoint 2013 | Describes the procedures that you can use to restore the farm configuration to the same farm from a backup.
 | Document farm configuration settings in SharePoint 2013 | Describes how to use Windows PowerShell to document the configuration settings for your farm. Documenting configuration settings is important both so that you can create scripted deployments for your environment, and so that you can quickly re-create a set of configurations if a failure were to occur.
 | Copy configuration settings between farms in SharePoint 2013 | Describes the procedures that you can use to of copy configuration settings from one farm to another, such as how to back up and recover a farm without the content databases, how to back up and recover configurations only, and how to create a deployment script.
 | Restore web applications in SharePoint 2013 | Describes the procedures that you can use to restore a Web application that is associated with the farm that include configuration and content databases, from a backup.
 | Restore service applications in SharePoint 2013 | Describes the procedures that you can use to restore a service application that is associated with the farm that include configuration and content databases, from a backup.
 | Restore a User Profile Service service application in SharePoint Server 2013 | Describes how to restore the User Profile Service service application instead of restoring the complete farm. This article does not apply to SharePoint Foundation 2013.
 | Restore Search service applications in SharePoint 2013 | Describes the procedures that you can use to restore the Search service application associated with the farm that include configuration and indexes, from a backup.
 | Restore Secure Store Service in SharePoint Server 2013 | Describes the procedures that you can use to restore the Secure Store service application that is associated with the farm that include configuration and content databases, from a backup. This article does not apply to SharePoint Foundation 2013.
 | Restore content databases in SharePoint 2013 | Describes the procedures that you can use to restore a content database from a backup.
 | Attach and restore a read-only content database in SharePoint 2013 | Describes the procedures that you can use to attach a read-only content database to the farm.
 | Restore content from unattached content databases in SharePoint 2013 | Describes how you can restore or copy content, such as sites, site collections, lists, or document libraries, from a content database without having to attach the content database to the farm.
 | Restore customizations in SharePoint 2013 | Describes the procedures that you can use to restore customizations that are associated with the farm from backups.
 | Restore site collections in SharePoint 2013 | Describes the procedures that you can use to restore a site collection from a backup.
 | Restore apps for SharePoint in SharePoint 2013 | Learn how to restore apps for SharePoint in SharePoint 2013.
 | Import a list or document library in SharePoint 2013 | Describes the procedures that you can use to restore a site, list, or document library from a backup.

See also

Backup solutions in SharePoint 2013


Restore farms in SharePoint 2013
See also

Summary: Learn how to restore a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can restore a SharePoint 2013 farm by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. The backup tool that you use depends on the kind of environment that you have deployed, the backup schedule, and service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Using Windows PowerShell to restore a farm in SharePoint

    • To restore a farm by using Windows PowerShell

  • Using Central Administration to restore a farm

    • To restore a farm by using Central Administration

  • Using SQL Server tools to restore a farm

    • To restore a farm by using SQL Server tools

Before you begin

Farm-level recovery is usually performed only after a failure that involves the complete farm, or where partial recovery of part of the farm is not possible. If you only have to restore part of the farm, a specific database, a service application, a list, or document library, or a specific document, use another recovery method. For more information about alternate forms of recovery, see Related content.

Farm recovery is usually performed for any of the following reasons:

  • Restoring a farm after a fire, disaster, equipment failure, or other data-loss event.

  • Restoring farm configuration settings and data to a specific previous time and date.

  • Moving a SharePoint 2013 deployment from one farm to another farm.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about how to recover a farm in SharePoint:

  • You cannot restore a multiple-server farm to a stand-alone farm or a stand-alone farm to a multiple-server farm.

  • You cannot back up from one version of SharePoint 2013 and restore to another version of SharePoint 2013.

  • Backing up the farm will back up the configuration and Central Administration content databases, but these cannot be restored using SharePoint 2013 tools. For more information about how to back up and restoring all the farm databases, see Move all databases in SharePoint 2013.

  • When you restore the farm by using SharePoint 2013, the restore process will not automatically start all of the service applications. You must manually start them by using Central Administration or Windows PowerShell. Do not use SharePoint Products Configuration Wizard to start the services because doing this will also re-provision the services and service proxies. For more information, see Start or stop a service (SharePoint 2013).

  • The identifier (ID) of each content database is retained when you restore or reattach a database by using built-in tools. Default change log retention behavior when using built-in tools is as follows:

    1. The change logs for all databases are retained when you restore a farm.

    2. The change log for content databases is retained when you reattach or restore a database.

      When a database ID and change log are retained, the search system continues crawling based on the regular schedule that is defined by crawl rules.

      When you restore an existing database and do not use the overwrite option, a new ID is assigned to the restored database, and the database change log is not preserved. The next crawl of the database will add data from the content database to the index.

      If a restore is performed and the ID in the backup package is already being used in the farm, a new ID is assigned to the restored database and a warning is added to the restore log. The ability to perform an incremental crawl instead of a full crawl depends on the content database ID being the same as before and the change log token that is used by the search system being valid for the current change log in the content database. If the change log is not preserved, the token is not valid and the search system has to perform a full crawl.

  • SharePoint 2013 backup backs up the Business Data Connectivity service external content type definitions but does not back up the data source itself. To protect the data, you should back up the data source when you back up the Business Data Connectivity service or the farm.

    If you restore the Business Data Connectivity service or the farm and then restore the data source to a different location, you must change the location information in the external content type definition. If you do not, the Business Data Connectivity service might be unable to locate the data source.

  • SharePoint 2013 restores remote Binary Large Objects (BLOB) stores only if you are using the FILESTREAM remote BLOB store provider to put data in remote BLOB stores.

    If you are using another provider, you must manually restore the remote BLOB stores.

  • If a user has taken copies of content for off-line editing in and the content is restored from a backup on the server, when the user re-connects, the server automatically synchronizes the off-line content with the restored content. This might result in data loss on the user's copies of the content.

  • If you are sharing service applications across farms, be aware that trust certificates that were exchanged are not included in farm backups. You must back up your certificate store separately or keep the certificates in a separate location. When you restore a farm that shares a service application, you must import and redeploy the certificates, and then re-establish any inter-farm trusts.

    For more information, see Exchange trust certificates between farms in SharePoint 2013.

  • After a Web application that is configured to use claims-based authentication is restored, duplicate or additional claims providers are often visible. If duplicates appear, then you must manually save each Web application zone to remove them. For more information, see Restore web applications in SharePoint 2013.

  • Additional steps are required when you restore a farm that contains a Web application that is configured to use forms-based authentication. For more information, see Restore web applications in SharePoint 2013.

Using Windows PowerShell to restore a farm in SharePoint

You can use Windows PowerShell to restore a farm.

To restore a farm by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs .

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory <BackupFolder> -RestoreMethod Overwrite [-BackupId <GUID>]<Type the appropriate cmdlet, including parameters and values, and enclose the values for the parameters in "placeholder" tags >

    Where:

    • <BackupFolder> is the path of the folder you use for storing backup files.

    • <GUID> is the identifier of the backup to restore from.

      Note:

      If you are not logged on as the Farm account, you are prompted for the Farm account's credentials.

      If you do not specify the BackupId, the most recent backup will be used. To view the backups for the farm, at the Windows PowerShell command prompt, type the following command:

      Copy code
      Get-SPBackupHistory -Directory <BackupFolder> -ShowBackup [-Verbose]

      Where:

      • <BackupFolder> is the path of the folder you use for storing backup files.

      You cannot use a configuration-only backup to restore content databases together with the configuration.

  6. To restart a service application, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Start-SPServiceInstance -Identity <ServiceApplicationID>

    Where:

    • <ServiceApplicationID> is the GUID of the service application.

    For more information about how to restart service applications by using Windows PowerShell, see Start-SPServiceInstance.

For more information about how to restore the farm by using Windows PowerShell, see Restore-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Using Central Administration to restore a farm

You can use the Central Administration Web site to restore a farm.

To restore a farm by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, on the home page, in the Backup and Restore section, click Restore from a backup.

  3. On the Restore from Backup — Step 1 of 3: Select Backup to Restore page, from the list of backups, select the backup job that contains the farm backup, and then click Next. You can view more details about each backup by clicking the (+) next to the backup.

    Note:

    If the correct backup job does not appear, in the Backup Directory Location text box, type the Universal Naming Convention (UNC) path of the correct backup folder, and then click Refresh.

    You cannot use a configuration-only backup to restore the farm.

  4. On the Restore from Backup — Step 2 of 3: Select Component to Restore page, select the check box that is next to the farm, and then click Next.

  5. On the Restore from Backup — Step 3 of 3: Select Restore Options page, in the Restore Component section, make sure that Farm appears in the Restore the following component list.

    In the Restore Only Configuration Settings section, make sure that the Restore content and configuration settings option is selected.

    In the Restore Options section, under Type of Restore, select the Same configuration option. A dialog box will appear that asks you to confirm the operation. Click OK.

    Note:

    If the Restore Only Configuration Settings section does not appear, the backup that you selected is a configuration-only backup. You must select another backup.

    Click Start Restore.

  6. You can view the general status of all recovery jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current recovery job in the lower part of the page in the Restore section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the recovery to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Sprestore.log file at the UNC path that you specified in step 3.

  7. When the restore process has completed, you may need to restart one or more service applications. In Central Administration, on the home page, in the Application Management section, click Manage services on server.

  8. On the Services on Server page, start any services related to service applications that you want to run by clicking Start in the Actions column next to the service application.

  9. Re-establish any trust relationships. For more information, see Exchange trust certificates between farms in SharePoint 2013.

Using SQL Server tools to restore a farm

Although you cannot restore the complete farm by using SQL Server tools, you can restore most of the farm databases. If you restore the databases by using SQL Server tools, you must restore the farm configuration by using Central Administration or Windows PowerShell. For more information about how to restore the farm's configuration settings, see Restore farm configurations in SharePoint 2013.

Note:

The search index is not stored in SQL Server. If you use SQL Server tools to back up and restore search, you must perform a full crawl after you restore the content database.

Before you restore SharePoint 2013, we recommend that you configure a recovery farm for site and item recovery.

Restore the databases by following these steps:

  1. If possible, back up the live transaction log of the current database to protect any changes that were made after the last full backup.

  2. Restore the last full database backup.

  3. Restore the most recent differential database backup that occurred after the most recent full database backup.

  4. Restore all transaction log backups that occurred after the most recent full or differential database backup.

To restore a farm by using SQL Server tools

  1. Verify that the user account that is performing this procedure is a member of the sysadmin fixed server role.

  2. If the Windows SharePoint Services Timer service is running, stop the service and wait for several minutes for any currently running stored procedures to finish. Do not restart the service until after you restore all the databases that you have to restore.

  3. Start SQL Server Management Studio and connect to the database server.

  4. In Object Explorer, expand Databases.

  5. Right-click the database that you want to restore, point to Tasks, point to Restore, and then click Database.

    The database is automatically taken offline during the recovery operation and cannot be accessed by other processes.

  6. In the Restore Database dialog box, specify the destination and the source, and then select the backup set or sets that you want to restore.

    The default values for destination and source are appropriate for most recovery scenarios.

  7. In the Select a page pane, click Options.

  8. In the Restore options section, select only Overwrite the existing database. Unless your environment or policies require otherwise, do not select the other options in this section.

  9. In the Recovery state section:

    • If you have included all the transaction logs that you must restore, select RECOVER WITH RECOVERY.

    • If you must restore additional transaction logs, select RECOVER WITH NORECOVERY.

    • The third option, RECOVER WITH STANDBY is not used in this scenario.

      Note:

      For more information about these recovery options, see Restore Database (Options Page).

  10. Click OK to complete the recovery operation.

  11. Except for the configuration database, repeat steps 4 through 9 for each database that you are restoring.

    Important:

    If you are restoring the User Profile database (by default named ""User Profile Service_ProfileDB_<GUID>"), then also restore the Social database (by default named "User Profile Service_SocialDB_<GUID>"). Failing to do this can cause inaccuracies in the User Profile data that might be difficult to detect and fix.

  12. To restore the configuration settings, you must use the existing configuration database or manually create a new database and restore the configuration to that database. For more information about how to restore the farm configuration, see Restore farm configurations in SharePoint 2013.

  13. Start the Windows SharePoint Services Timer service.

  14. Start any service applications that have to be restarted. To do this, see steps 7 and 8 of the "Use Central Administration to restore a farm" procedure earlier in this article.

See also

Back up farms in SharePoint 2013
Restore farm configurations in SharePoint 2013
Restore web applications in SharePoint 2013
Restore content databases in SharePoint 2013

What's New in SharePoint 2013 Resource Center


Restore farm configurations in SharePoint 2013
See also

Summary: Learn how to restore configuration information (such as antivirus, IRM, outbound email, and some customizations) for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can restore a farm configuration in SharePoint 2013 by using the SharePoint Central Administration website or Windows PowerShell. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

In this article:

  • Before you begin

  • Using Windows PowerShell to restore a farm's configuration in SharePoint

    • To restore a farm's configuration by using Windows PowerShell

  • Using Central Administration to restore a farm's configuration in SharePoint

    • To restore a farm's configuration by using Central Administration

Before you begin

Farm-level configuration recovery is performed only after a failure that involves the configuration database but does not involve other farm data, such as a content database or Web application. If restoring the farm configuration does not solve the problems, you must restore the complete farm. For more information about how to restore the complete farm, see Restore farms in SharePoint 2013. You can restore the configuration from a farm backup that used either the Backup content and configuration settings option or the Backup only configuration settings option.

Note:

In earlier versions of SharePoint 2013, you could not restore the configuration database and, therefore, you could not restore the configuration of a farm. In this version of SharePoint 2013, you do not have to restore the configuration database because you can restore the farm configuration directly.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Using Windows PowerShell to restore a farm's configuration in SharePoint

You can use Windows PowerShell to restore a farm's configuration.

To restore a farm's configuration by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs .

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory <RestoreShare> -RestoreMethod Overwrite -ConfigurationOnly

    Where:

    • <RestoreShare> is network location where the backup file is stored.

    For more information, see Restore-SPFarm.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Using Central Administration to restore a farm's configuration in SharePoint

You can use Central Administration to restore a farm's configuration.

To restore a farm's configuration by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group on the computer that is running Central Administration.

  2. Verification: Optionally, include steps that users should perform to verify that the operation was successful.

    You must also be a member of the sysadmin fixed server role on the database server where each database is stored.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Restore from a backup.

  4. On the Restore from Backup — Step 1 of 3: Select Backup to Restore page, select the backup job that contains the farm backup from the list of backups, and then click Next.

    Note:

    You can view additional information about the backups by expanding the row that contains the backup.

    Note:

    If the correct backup job does not appear, in the Backup Directory Location text box, enter the UNC path of the correct backup folder, and then click Refresh.

  5. On the Restore from Backup — Step 2 of 3: Select Component to Restore page, select the check box that is next to the farm, and then click Next.

  6. On the Restore from Backup — Step 3 of 3: Select Restore Options page, in the Restore Component section, make sure that "Farm" appears in the Restore the following content list.

    In the Restore Only Configuration Settings section, make sure that the Restore content and configuration settings option is selected.

    In the Restore Options section, select the Type of Restore option. Use the Same configuration setting. A dialog box will appear that asks you to confirm the operation. Click OK.

    Note:

    If the Restore Only Configuration Settings section does not appear, then the backup that you selected is a configuration-only backup.

    Click Start Restore.

  7. You can view the general status of all recovery jobs at the top of the Backup and Restore Status page in the Readiness section. You can view the status of the current recovery job in the lower part of the page in the Restore section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the recovery to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Sprestore.log file at the UNC path that you specified in step 2.

See also

Back up farm configurations in SharePoint 2013

What's New in SharePoint 2013 Resource Center


Document farm configuration settings in SharePoint 2013
See also

Summary: Learn how to document farm configuration settings in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can document your farm configuration settings in SharePoint 2013 by using Windows PowerShell.

In this article:

  • Before you begin

  • Using Windows PowerShell to document farm configuration settings in SharePoint 2013

    • To document SharePoint Server 2013 configuration settings by using Windows PowerShell

  • To document SharePoint Foundation 2013 configuration settings by using Windows PowerShell

  • Example of using a cmdlet in SharePoint 2013

Before you begin

Documenting configuration settings is important both so that you can create scripted deployments for your environment and so that you can quickly re-create a set of configurations if a failure were to occur.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products

  • Keyboard shortcuts

  • Touch

Using Windows PowerShell to document farm configuration settings in SharePoint 2013

The following procedure describes how to create and run a Windows PowerShell script for SharePoint Server 2013. The next procedure describes how to create and run a Windows PowerShell for SharePoint Foundation 2013. You can then use these scripts to restore the farm configuration settings if a failure were to occur.

To document SharePoint Server 2013 configuration settings by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies (http://go.microsoft.com/fwlink/p/?LinkId=193050).

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Use a text editor, such as Notepad, to create a text file by pasting the following code into the file. The commands in the example create XML files that document the configurations of the Web applications and service applications in the current farm. Choose only those commands that are relevant to your environment.

    Copy code
    ##
## Common SharePoint configuration settings
##
#Retrieve Web Application information. The default depth of 2 does not return much detail--we recommend that you use a depth of 4 for this cmdlet.
Get-SPWebApplication | Export-Clixml .\ WebAppFilename.xml -depth 4

#Retrieve custom layout information.
Get-SPWebApplication | Get-SPCustomLayoutsPage | Export-Clixml .\Get-SPCustomLayoutsPage.xml

#Determine how SharePoint designer access is configured.
Get-SPWebApplication | Get-SPDesignerSettings  | Export-Clixml .\Get-SPDesignerSettings.xml

#Retrieve information about alternate access mapping
Get-SPAlternateURL  | Export-Clixml .\Get-SPAlternateURL.xml

#Retrieve information about content databases
Get-SPContentDatabase  | Export-Clixml .\Get-SPContentDatabase.xml

#Retrieve database properties for each database
Get-SPDatabase  | Export-Clixml .\Get-SPDatabase.xml

#Retrieve information about all SharePoint Products installed in the farm, and the versions of all updates installed for each product.
Get-SPProduct  | Export-Clixml .\Get-SPProduct.xml

#Retrieve farm information
Get-SPFarm  | Export-Clixml .\Get-SPFarm.xml
Get-SPFarmConfig  | Export-Clixml .\Get-SPFarmConfig.xml

#Retrieve information about the servers in the farm
Get-SPServer  | Export-Clixml .\Get-SPServer.xml

#Retrieve information about installed features
Get-SPFeature  | Export-Clixml .\Get-SPFeature.xml

#Retrieve information about globally-installed site templates
Get-SPWebTemplate  | Export-Clixml .\Get-SPWebTemplate.xml

#Retrieve information about deployed solutions
Get-SPSolution  | Export-Clixml .\Get-SPSolution.xml

#Retrieve information about sandboxed solutions deployed in a site collection
Get-SPSite | Get-SPUserSolution  | Export-Clixml .\Get-SPUserSolution.xml

#Retrieve information about claims authentication
Get-SPTrustedIdentityTokenIssuer  | Export-Clixml .\Get-SPTrustedIdentityTokenIssuer.xml
Get-SPTrustedServiceTokenIssuer  | Export-Clixml .\Get-SPTrustedServiceTokenIssuer.xml
Get-SPTrustedRootAuthority  | Export-Clixml .\Get-SPTrustedRootAuthority.xml

#Retrieve information about installed Help
Get-SPHelpCollection  | Export-Clixml .\Get-SPHelpCollection.xml

#Retrieve information about the logging levels that have been set
Get-SPLogLevel  | Export-Clixml .\Get-SPLogLevel.xml

#Retrieve information about the sites in the farm
Get-SPSite  | Export-Clixml .\Get-SPSite.xml
Get-SPSiteAdministration  | Export-Clixml .\Get-SPSiteAdministration.xml
Get-SPSiteSubscription  | Export-Clixml .\Get-SPSiteSubscription.xml

#Retrieve ULS logging information
Get-SPDiagnosticConfig  | Export-Clixml .\Get-SPDiagnosticConfig.xml
Get-SPDiagnosticsPerformanceCounter  | Export-Clixml .\Get-SPDiagnosticsPerformanceCounter.xml
Get-SPDiagnosticsProvider  | Export-Clixml .\Get-SPDiagnosticsProvider.xml

#Retrieve information about accounts registered in the configuration database
Get-SPManagedAccount  | Export-Clixml .\Get-SPManagedAccount.xml
Get-SPProcessAccount  | Export-Clixml .\Get-SPProcessAccount.xml
Get-SPShellAdmin  | Export-Clixml .\Get-SPShellAdmin.xml

#Retrieve specific information about the certificate authority
Get-SPCertificateAuthority  | Export-Clixml .\Get-SPCertificateAuthority.xml
Get-SPClaimProvider  | Export-Clixml .\Get-SPClaimProvider.xml
Get-SPClaimProviderManager  | Export-Clixml .\Get-SPClaimProviderManager.xml

#Retrieve information about content deployment jobs
Get-SPContentDeploymentJob | Export-Clixml .\Get-SPContentDeploymentJob.xml
Get-SPContentDeploymentPath | Export-Clixml .\Get-SPContentDeploymentPath.xml

#Retrieve information about the Mobile Messaging account.
Get-SPWebApplication | Get-SPMobileMessagingAccount  | Export-Clixml .\Get-SPMobileMessagingAccount.xml

##
##Common service infrastructure settings
##
#Retrieve information about the service applications in the farm
Get-SPServiceApplication  | Export-Clixml .\Get-SPServiceApplication.xml
Get-SPServiceApplicationPool  | Export-Clixml .\Get-SPServiceApplicationPool.xml
Get-SPServiceApplicationProxy  | Export-Clixml .\Get-SPServiceApplicationProxy.xml
Get-SPServiceApplicationProxyGroup  | Export-Clixml .\Get-SPServiceApplicationProxyGroup.xml
Get-SPServiceApplication | Get-SPServiceApplicationEndpoint  | Export-Clixml .\Get-SPServiceApplicationEndpoint.xml

#Retrieve information about the services running in the farm
Get-SPServiceInstance  | Export-Clixml .\Get-SPServiceInstance.xml

#Retrieve information about InfoPath form services
Get-SPInfoPathFormsService  | Export-Clixml .\Get-SPInfoPathFormsService.xml
Get-SPInfoPathFormTemplate  | Export-Clixml .\Get-SPInfoPathFormTemplate.xml

###WARNING: The following cmdlet requires  run as administrator rights.
Get-SPInfoPathUserAgent  | Export-Clixml .\Get-SPInfoPathUserAgent.xml

#Retrieve information about common Web service settings
Get-SPServiceHostConfig  | Export-Clixml .\Get-SPServiceHostConfig.xml

##
## Common service application settings
##
#Access Services
#Retrieve specific information for the Access Services service application
Get-SPAccessServiceApplication  | Export-Clixml .\Get-SPAccessServiceApplication.xml

#Application Discovery and Load Balancer Service Application

Get-SPTopologyServiceApplication  | Export-Clixml .\Get-SPTopologyServiceApplication.xml
Get-SPTopologyServiceApplicationProxy  | Export-Clixml .\Get-SPTopologyServiceApplicationProxy.xml

#Business Data Connectivity Service
#Retrieve information about data connection files. ###WARNING: The following cmdlet requires  run as administrator rights
Get-SPDataConnectionFile | Export-Clixml .\Get-SPDataConnectionFile.xml
###WARNING: The following cmdlet requires  run as administrator rights
Get-SPDataConnectionFile | Get-SPDataConnectionFileDependent  | Export-Clixml .\Get-SPDataConnectionFileDependent.xml

#Excel Services Application
#Note: An Excel service application must be provisioned for the following cmdlets to succeed.
Get-SPExcelServiceApplication | Get-SPExcelBlockedFileType  | Export-Clixml .\Get-SPExcelBlockedFileType.xml
Get-SPExcelServiceApplication | Get-SPExcelDataConnectionLibrary  | Export-Clixml .\Get-SPExcelDataConnectionLibrary.xml
Get-SPExcelServiceApplication | Get-SPExcelDataProvider  | Export-Clixml .\Get-SPExcelDataProvider.xml
Get-SPExcelServiceApplication | Get-SPExcelFileLocation  | Export-Clixml .\Get-SPExcelFileLocation.xml
Get-SPExcelServiceApplication | Export-Clixml .\Get-SPExcelServiceApplication.xml
Get-SPExcelServiceApplication | Get-SPExcelUserDefinedFunction  | Export-Clixml .\Get-SPExcelUserDefinedFunction.xml
Get-SPWebApplication | Get-SPInfoPathWebServiceProxy  | Export-Clixml .\Get-SPInfoPathWebServiceProxy.xml
Get-SPWebApplication | Get-SPManagedPath  | Export-Clixml .\Get-SPManagedPath.xml

#Managed Metadata Service
#Note: A Managed Metadata service application must be provisioned for the following cmdlets to succeed.
Get-SPServiceApplication | ?{$_.TypeName -eq "Managed Metadata Service"} | %{$id = $_.Id;Get-SPMetadataServiceApplication -Id $_ | Export-Clixml .\Get-SPMetadataServiceApplication-$id.xml}
Get-SPServiceApplicationProxy | ?{$_.TypeName -eq "Managed Metadata Service Connection"} | %{$id = $_.Id;Get-SPMetadataServiceApplicationProxy -Id $_ | Export-Clixml .\Get-SPMetadataServiceApplicationProxy-$id.xml}
Get-SPSite | Get-SPTaxonomySession  | Export-Clixml .\Get-SPTaxonomySession.xml

#PerformancePoint Service Application
#Note: A PerformancePoint service application must be provisioned for the following cmdlets to succeed.
Get-SPPerformancePointServiceApplication | Get-SPPerformancePointSecureDataValues  | Export-Clixml .\Get-SPPerformancePointSecureDataValues.xml
Get-SPPerformancePointServiceApplication | Export-Clixml .\Get-SPPerformancePointServiceApplication.xml
Get-SPPerformancePointServiceApplication | Get-SPPerformancePointServiceApplicationTrustedLocation  | Export-Clixml .\Get-SPPerformancePointServiceApplicationTrustedLocation.xml

#Search
#Retrieve search information
#Note:  A Search service application must be provisioned for the following cmdlets to succeed.
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchAdministrationComponent  | Export-Clixml .\Get-SPEnterpriseSearchAdministrationComponent.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchCrawlContentSource  | Export-Clixml .\Get-SPEnterpriseSearchCrawlContentSource.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchCrawlCustomConnector  | Export-Clixml .\Get-SPEnterpriseSearchCrawlCustomConnector.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchCrawlDatabase  | Export-Clixml .\Get-SPEnterpriseSearchCrawlDatabase.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchCrawlExtension  | Export-Clixml .\Get-SPEnterpriseSearchCrawlExtension.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchCrawlMapping  | Export-Clixml .\Get-SPEnterpriseSearchCrawlMapping.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchCrawlRule  | Export-Clixml .\Get-SPEnterpriseSearchCrawlRule.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchCrawlTopology  | Export-Clixml .\Get-SPEnterpriseSearchCrawlTopology.xml
$searchApp = Get-SPEnterpriseSearchServiceApplication; Get-SPEnterpriseSearchExtendedClickThroughExtractorJobDefinition -SearchApplication $searchApp | Export-Clixml .\Get-SPEnterpriseSearchExtendedClickThroughExtractorJobDefinition.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchExtendedConnectorProperty  | Export-Clixml .\Get-SPEnterpriseSearchExtendedConnectorProperty.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchExtendedQueryProperty  | Export-Clixml .\Get-SPEnterpriseSearchExtendedQueryProperty.xml
###WARNING: The following cmdlet generates a 120MB file that records the out of the box settings###
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchLanguageResourcePhrase  | Export-Clixml .\Get-SPEnterpriseSearchLanguageResourcePhrase.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchMetadataCategory  | Export-Clixml .\Get-SPEnterpriseSearchMetadataCategory.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchMetadataCrawledProperty  | Export-Clixml .\Get-SPEnterpriseSearchMetadataCrawledProperty.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchMetadataManagedProperty  | Export-Clixml .\Get-SPEnterpriseSearchMetadataManagedProperty.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchMetadataMapping  | Export-Clixml .\Get-SPEnterpriseSearchMetadataMapping.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchPropertyDatabase  | Export-Clixml .\Get-SPEnterpriseSearchPropertyDatabase.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchQueryAuthority  | Export-Clixml .\Get-SPEnterpriseSearchQueryAuthority.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchQueryDemoted  | Export-Clixml .\Get-SPEnterpriseSearchQueryDemoted.xml
 Get-SPEnterpriseSearchQueryAndSiteSettingsService  | Export-Clixml .\Get-SPEnterpriseSearchQueryAndSiteSettingsService.xml
Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance  | Export-Clixml .\Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance.xml
Get-SPEnterpriseSearchQueryAndSiteSettingsServiceProxy  | Export-Clixml .\Get-SPEnterpriseSearchQueryAndSiteSettingsServiceProxy.xml
Get-SPEnterpriseSearchService  | Export-Clixml .\Get-SPEnterpriseSearchService.xml
Get-SPEnterpriseSearchServiceInstance  | Export-Clixml .\Get-SPEnterpriseSearchServiceInstance.xml
Get-SPSearchService  | Export-Clixml .\Get-SPSearchService.xml
Get-SPSearchServiceInstance  | Export-Clixml .\Get-SPSearchServiceInstance.xml

###WARNING: The following cmdlet generates a file per site collection###
Get-SPSite | %{$id = $_.Id;Get-SPEnterpriseSearchQueryKeyword -Site $_ | Export-Clixml .\Get-SPEnterpriseSearchQueryKeyword-$id.xml}
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchQueryScope  | Export-Clixml .\Get-SPEnterpriseSearchQueryScope.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchQueryScope | Get-SPEnterpriseSearchQueryScopeRule  | Export-Clixml .\Get-SPEnterpriseSearchQueryScopeRule.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchQuerySuggestionCandidates  | Export-Clixml .\Get-SPEnterpriseSearchQuerySuggestionCandidates.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchQueryTopology  | Export-Clixml .\Get-SPEnterpriseSearchQueryTopology.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchRankingModel  | Export-Clixml .\Get-SPEnterpriseSearchRankingModel.xml
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchSecurityTrimmer  | Export-Clixml .\Get-SPEnterpriseSearchSecurityTrimmer.xml
Get-SPEnterpriseSearchServiceApplication | Export-Clixml .\Get-SPEnterpriseSearchServiceApplication.xml
Get-SPEnterpriseSearchServiceApplicationProxy  | Export-Clixml .\Get-SPEnterpriseSearchServiceApplicationProxy.xml
Get-SPEnterpriseSearchSiteHitRule  | Export-Clixml .\Get-SPEnterpriseSearchSiteHitRule.xml

#Security Token Service Application
#Retrieve information about the security token service used for incoming SOAP messages.
Get-SPSecurityTokenServiceConfig  | Export-Clixml .\Get-SPSecurityTokenServiceConfig.xml

#State Service
#Retrieve information about the State Service.
Get-SPSessionStateService  | Export-Clixml .\Get-SPSessionStateService.xml
Get-SPStateServiceApplication  | Export-Clixml .\Get-SPStateServiceApplication.xml
Get-SPStateServiceApplicationProxy  | Export-Clixml .\Get-SPStateServiceApplicationProxy.xml
Get-SPStateServiceDatabase  | Export-Clixml .\Get-SPStateServiceDatabase.xml

#Usage and Health data collection
#Retrieve information about the Usage and Health Data Collection service application.
Get-SPUsageApplication  | Export-Clixml .\Get-SPUsageApplication.xml
Get-SPUsageDefinition  | Export-Clixml .\Get-SPUsageDefinition.xml
Get-SPUsageService  | Export-Clixml .\Get-SPUsageService.xml

#Visio Service
#A Visio service application must be provisioned for the following cmdlets to succeed.
Get-SPVisioServiceApplication | Get-SPVisioExternalData  | Export-Clixml .\Get-SPVisioExternalData.xml
Get-SPVisioServiceApplication | Get-SPVisioPerformance  | Export-Clixml .\Get-SPVisioPerformance.xml
Get-SPVisioServiceApplication | Get-SPVisioSafeDataProvider  | Export-Clixml .\Get-SPVisioSafeDataProvider.xml
Get-SPVisioServiceApplication | Export-Clixml .\Get-SPVisioServiceApplication.xml
Get-SPVisioServiceApplicationProxy  | Export-Clixml .\Get-SPVisioServiceApplicationProxy.xml

#Web Analytics Service Application
A Web Analytics service application must be provisioned for the following cmdlets to succeed.
Get-SPServiceApplication | ?{$_.TypeName -eq "Web Analytics Service Application"} | %{$id = $_.Id;Get-SPWebAnalyticsServiceApplication -Id $_ | Export-Clixml .\Get-SPWebAnalyticsServiceApplication-$id.xml}
Get-SPServiceApplicationProxy | ?{$_.TypeName -eq "Web Analytics Service Application Proxy"} | %{$id = $_.Id;Get-SPWebAnalyticsServiceApplicationProxy -Id $_ | Export-Clixml .\Get-SPWebAnalyticsServiceApplicationProxy-$id.xml}
Get-SPWebApplication | Get-SPWebApplicationHttpThrottlingMonitor  | Export-Clixml .\Get-SPWebApplicationHttpThrottlingMonitor.xml
Get-SPWebPartPack  | Export-Clixml .\Get-SPWebPartPack.xml

#Word Automation Services

###Note: These cmdlets are commented out because you are unlikely to want to run them. ###
#Get-SPSite | %{$web=Get-SPWeb $_.Url;$webid=$web.Id;$web | Get-SPUser | Export-Clixml .\Get-SPUser-$webid.xml}

# Get-SPSite | %{$web=Get-SPWeb $_.Url;$webid=$web.Id;$web | Export-Clixml .\Get-SPWeb-$webid.xml}

  3. Save the file and add the .ps1 extension, such as SuggestedNameOfFile.ps1.

    Note:

    You can use a different file name, but you must save the file as an ANSI-encoded text file whose extension is .ps1.

  4. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  5. Change to the directory where you saved the file.

  6. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ./SuggestedFileName.ps1

To document SharePoint Foundation 2013 configuration settings by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies (http://go.microsoft.com/fwlink/p/?LinkId=193050).

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Use a text editor, such as Notepad, to create a text file by pasting the following code into the file. The commands in the example create XML files that document the configurations of the Web applications and service applications in the current farm. Choose only those commands that are relevant to your environment.

    Copy code
    ##
## Common SharePoint configuration settings
##
#Retrieve Web Application information. The default depth of 2 does not return much detail--we recommend that you use a depth of 4 for this cmdlet.
Get-SPWebApplication | Export-Clixml .\ WebAppFilename.xml -depth 4

#Retrieve custom layout information.
Get-SPWebApplication | Get-SPCustomLayoutsPage | Export-Clixml .\Get-SPCustomLayoutsPage.xml

#Determine how SharePoint designer access is configured
Get-SPWebApplication | Get-SPDesignerSettings  | Export-Clixml .\Get-SPDesignerSettings.xml

#Retrieve information about alternate access mapping
Get-SPAlternateURL  | Export-Clixml .\Get-SPAlternateURL.xml

#Retrieve information about content databases
Get-SPContentDatabase  | Export-Clixml .\Get-SPContentDatabase.xml

#Retrieve database properties for each database
Get-SPDatabase  | Export-Clixml .\Get-SPDatabase.xml

#Retrieve information about all SharePoint Products installed in the farm, and the versions of all updates installed for each product.
Get-SPProduct  | Export-Clixml .\Get-SPProduct.xml

#Retrieve farm information
Get-SPFarm  | Export-Clixml .\Get-SPFarm.xml
Get-SPFarmConfig  | Export-Clixml .\Get-SPFarmConfig.xml

#Retrieve information about the servers in the farm
Get-SPServer  | Export-Clixml .\Get-SPServer.xml

#Retrieve information about installed features
Get-SPFeature  | Export-Clixml .\Get-SPFeature.xml

#Retrieve information about globally-installed site templates
Get-SPWebTemplate  | Export-Clixml .\Get-SPWebTemplate.xml

#Retrieve information about deployed solutions
Get-SPSolution  | Export-Clixml .\Get-SPSolution.xml

#Retrieve information about sandboxed solutions deployed in a site collection
Get-SPSite | Get-SPUserSolution  | Export-Clixml .\Get-SPUserSolution.xml

#Retrieve information about installed Help
Get-SPHelpCollection  | Export-Clixml .\Get-SPHelpCollection.xml

#Retrieve information about the logging levels that have been set
Get-SPLogLevel  | Export-Clixml .\Get-SPLogLevel.xml

#Retrieve information about the sites in the farm
Get-SPSite  | Export-Clixml .\Get-SPSite.xml
Get-SPSiteAdministration  | Export-Clixml .\Get-SPSiteAdministration.xml
Get-SPSiteSubscription  | Export-Clixml .\Get-SPSiteSubscription.xml

#Retrieve ULS logging information
Get-SPDiagnosticConfig  | Export-Clixml .\Get-SPDiagnosticConfig.xml
Get-SPDiagnosticsPerformanceCounter  | Export-Clixml .\Get-SPDiagnosticsPerformanceCounter.xml
Get-SPDiagnosticsProvider  | Export-Clixml .\Get-SPDiagnosticsProvider.xml

#Retrieve information about accounts registered in the configuration database
Get-SPManagedAccount  | Export-Clixml .\Get-SPManagedAccount.xml
Get-SPProcessAccount  | Export-Clixml .\Get-SPProcessAccount.xml
Get-SPShellAdmin  | Export-Clixml .\Get-SPShellAdmin.xml

#Retrieve information about the Mobile Messaging account.
Get-SPWebApplication | Get-SPMobileMessagingAccount  | Export-Clixml .\Get-SPMobileMessagingAccount.xml

##
##Common service infrastructure settings
##
#Retrieve information about the service applications in the farm
Get-SPServiceApplication  | Export-Clixml .\Get-SPServiceApplication.xml
Get-SPServiceApplicationPool  | Export-Clixml .\Get-SPServiceApplicationPool.xml
Get-SPServiceApplicationProxy  | Export-Clixml .\Get-SPServiceApplicationProxy.xml
Get-SPServiceApplicationProxyGroup  | Export-Clixml .\Get-SPServiceApplicationProxyGroup.xml
Get-SPServiceApplication | Get-SPServiceApplicationEndpoint  | Export-Clixml .\Get-SPServiceApplicationEndpoint.xml

#Retrieve information about the services running in the farm
Get-SPServiceInstance  | Export-Clixml .\Get-SPServiceInstance.xml

#Retrieve information about common Web service settings
Get-SPServiceHostConfig  | Export-Clixml .\Get-SPServiceHostConfig.xml

##
## Common service application configurations
##

#Application Discovery and Load Balancer Service Application
Get-SPTopologyServiceApplication  | Export-Clixml .\Get-SPTopologyServiceApplication.xml
Get-SPTopologyServiceApplicationProxy  | Export-Clixml .\Get-SPTopologyServiceApplicationProxy.xml

#Business Data Connectivity Service
#Retrieve information about data connection files. ###WARNING: The following cmdlet requires  run as administrator rights
Get-SPDataConnectionFile | Export-Clixml .\Get-SPDataConnectionFile.xml
###WARNING: The following cmdlet requires  run as administrator rights
Get-SPDataConnectionFile | Get-SPDataConnectionFileDependent  | Export-Clixml .\Get-SPDataConnectionFileDependent.xml

#Security Token Service Application
#Retrieve information about the security token service used for incoming SOAP messages.
Get-SPSecurityTokenServiceConfig  | Export-Clixml .\Get-SPSecurityTokenServiceConfig.xml

#Usage and Health data collection
#Retrieve information about the Usage and Health Data Collection service application.
Get-SPUsageApplication  | Export-Clixml .\Get-SPUsageApplication.xml
Get-SPUsageDefinition  | Export-Clixml .\Get-SPUsageDefinition.xml
Get-SPUsageService  | Export-Clixml .\Get-SPUsageService.xml

###Note: These cmdlets are commented out because you are unlikely to want to run them. ###
#Get-SPSite | %{$web=Get-SPWeb $_.Url;$webid=$web.Id;$web | Get-SPUser | Export-Clixml .\Get-SPUser-$webid.xml}

# Get-SPSite | %{$web=Get-SPWeb $_.Url;$webid=$web.Id;$web | Export-Clixml .\Get-SPWeb-$webid.xml}

  3. Save the file and add the .ps1 extension, such as SuggestedNameOfFile.ps1.

    Note:

    You can use a different file name, but you must save the file as an ANSI-encoded text file whose extension is .ps1.

  4. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  5. Change to the directory where you saved the file.

  6. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ./SuggestedFileName.ps1

For more information, see Export-Clixml, Get-SPWebApplication, Get-SPServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Example of using a cmdlet in SharePoint 2013

This section provides an example of ways that you can use one of the recommended cmdlets.

The Get-SPAlternateURL cmdlet provides information about alternate access mapping. Piping the cmdlet to the Export-Clixml cmdlet writes the information to an XML file.

Copy code
Get-SPAlternateURL | Export-Clixml .\Get-SPAlternateURL.xml

The following section lists the content of the Get-SPAlternateURL.xml file. Some sections are collapsed.

Copy code
- <Objs Version="1.1.0.1" xmlns="http://schemas.microsoft.com/powershell/2004/04">
+ <Obj RefId="0">
- <Obj RefId="7">
  <TNRef RefId="0" />
  <ToString>Microsoft.SharePoint.Administration.SPAlternateUrl</ToString>
- <Props>
  <S N="IncomingUrl">http://servername</S>
  <URI N="Uri">http://servername/</URI>
+ <Obj N="UrlZone" RefId="8">
- <Obj N="Collection" RefId="9">
  <TNRef RefId="2" />
- <IE>
- <Obj RefId="10">
  <TNRef RefId="0" />
  <ToString>Microsoft.SharePoint.Administration.SPAlternateUrl</ToString>
+ <Props>
- <MS>
  <S N="Zone">Default</S>
  <S N="PublicUrl">http://servername</S>
  </MS>
  </Obj>
  </IE>
- <Props>
  <I32 N="Count">1</I32>
  <B N="IsReadOnly">false</B>
  <S N="TypeName">Alternate Access Mapping Collection</S>
  <S N="DisplayName">SharePoint - 80</S>
  <U64 N="DiskSizeRequired">0</U64>
  <B N="CanSelectForBackup">false</B>
  <B N="CanRenameOnRestore">false</B>
  <B N="CanSelectForRestore">false</B>
  <S N="Name">SharePoint - 80</S>
  <G N="Id">5b65a69a-222d-4fe0-904b-0fb928bc7a89</G>
  <S N="Status">Online</S>
  <S N="Parent">SPFarm Name=SERVERNAME_SharePoint_Configuration_Database</S>
  <I64 N="Version">3661</I64>
+ <Obj N="Properties" RefId="12">
  <TNRef RefId="3" />
  <DCT />
  </Obj>
  <S N="Farm">SPFarm Name=SERVERNAME_SharePoint_Configuration_Database</S>
  <Ref N="UpgradedPersistedProperties" RefId="11" />
  </Props>
  </Obj>
  <Ref N="UpgradedPersistedProperties" RefId="11" />
  </Props>
+ <MS>
+ <Obj N="Zone" RefId="13">
  <TNRef RefId="1" />
  <ToString>Default</ToString>
  <I32>0</I32>
  </Obj>
  <S N="PublicUrl">http://servername</S>
  </MS>
  </Obj>
  </Objs>

This example imports the output from the XML file so that you can see its contents more easily.

Copy code
Import-Clixml .\Get-SPAlternateURL.xml

Once an XML file is imported, you can use the objects in the pipeline as if they were real objects of the given type.

Copy code
Import-Clixml .\Get-SPAlternateURL.xml | %{$_.Uri}

You can also pipe the objects as part of the cmdlet, and view all of the expected properties, methods, and TypeNames. The following example pipes URIs.

Copy code
Import-Clixml .\Get-SPAlternateURL.xml | %{$_.Uri | Get-Member}

See also

Get-SPAlternateURL

What's New in SharePoint 2013 Resource Center
Export-Clixml
Import-Clixml
ForEach-Object
Get-Member


Copy configuration settings between farms in SharePoint 2013
See also

Summary: Learn how to copy configuration settings from one SharePoint 2013 farm to another.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can copy configuration settings between SharePoint 2013 farms by using Windows PowerShell.

In this article:

  • Before you begin

  • Backup and restore a farm without content databases to copy configuration settings in SharePoint 2013

    • To back up and restore a farm without content databases by using Windows PowerShell

  • Back up and recover configuration settings only

Before you begin

There are many ways in which you can copy configurations from one farm to another. Determine which method to use based on the configuration settings that you want to copy and how often you have to copy them.

  • Back up and restore a farm without the content databases attached. This method gives you farm settings and Web application settings, in addition to the settings for any service applications that you select.

  • Back up and restore configurations only. This method provides you with the core SharePoint Foundation 2013 settings only.

    Note:

    This method does not include Web application or service application settings. If Web application settings are required in the restored farm, use one of the other methods.

  • Create a deployment script, based on your documented configuration. This method may be more work at first, but is easy to use to maintain standardization.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Backup and restore a farm without content databases to copy configuration settings in SharePoint 2013

To copy configuration settings by using a farm backup, we recommend that you first detach the content databases from the farm. This is not a step that we recommend that you take with a live production farm.

Note:

Creating a farm backup without content databases does back up the service applications.

To back up and restore a farm without content databases by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command to document the current Web application URLs and content database mappings.

    Copy code
    Get-SPWebApplication | %{$_.Name;$_.Url;%{$_.ContentDatabases|%{$_.Name};Write-Host ""}}

  4. Either unmount all content databases, as in the following example:

    Copy code
    Get-SPContentDatabase | Dismount-SPContentDatabase

    Or unmount a specific content database, as in the following example:

    Copy code
    Get-SPContentDatabase WSS_Content | Dismount-SPContentDatabase

  5. Back up the farm.

    Copy code
    Backup-SPFarm -Directory \\servername\share -BackupMethod Full
    Note:

    You can view the progress of the backup by looking at the \\servername\share\spbr####\spbackup.log file.

  6. After the backup is complete, re-mount the content databases.

    Copy code
    Mount-SPContentDatabase -Name <WSS_Content> -WebApplication <http://servername>

    Replace the placeholders with each of the mappings documented in step 1.

    Where:

    • <WSS_Content> is the <name and ID of the database>.

    • <http://servername> is <the URL of the Web Application>.

For more information, see Get-SPAlternateURL.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Back up and recover configuration settings only

As part of farm backup, you can choose to back up only configuration settings. A configuration-only backup extracts and backs up many, but not all, configuration settings from a configuration database. By using built-in tools, you can back up the configuration of any configuration database, whether it is currently attached to a farm or not. For detailed information about how to back up a configuration, see Back up farm configurations in SharePoint 2013.A configuration backup can be restored to the same — or any other — server farm. When a configuration is restored, it will overwrite any settings present in the farm that have values that are set within the configuration backup. If any settings present in the farm are not contained in the configuration backup, they will not be overwritten. For detailed information about how to restore a farm configuration, see Restore farm configurations in SharePoint 2013.

See also

What's New in SharePoint 2013 Resource Center


Restore web applications in SharePoint 2013
See also

Summary: Learn how to restore a web application in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can restore a web application in SharePoint 2013 by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

In this article:

  • Before you begin

  • Using Windows PowerShell to restore a web application in SharePoint 2013

    • To restore a web application by using Windows PowerShell

  • Using Central Administration to restore a web application in SharePoint 2013

    • To restore a web application by using Central Administration

  • Using SQL Server tools to restore databases associated with a web application in SharePoint 2013

    • To restore databases associated with a web application by using SQL Server tools

  • Additional steps to restore a web application that uses forms-based authentication in SharePoint 2013

  • Additional steps to remove duplicate claims providers after restoring a web application that uses claims-based authentication in SharePoint 2013

  • Additional steps to re-configure object cache user accounts in SharePoint 2013

Before you begin

When you restore a web application, you also restore the Internet Information Services (IIS) settings and all content databases that are associated with the web application.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information as you prepare to restore a web application:

  • You can only restore one web application at a time by using the procedures in this article. However, you can at the same time restore all the web applications in the farm by restoring the complete farm.

  • If a web application uses the object cache, you must manually configure two special user accounts for the web application after you restore the web application.

  • You cannot use SQL Server tools to restore a web application.

  • When you restore a web application that is configured to use claims-based authentication, there are additional steps that you must follow after restoring the web application to restore claims-based authentication.

Using Windows PowerShell to restore a web application in SharePoint 2013

You can use Windows PowerShell to restore a web application manually or as part of a script that can be run at scheduled intervals.

To restore a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs .

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory <BackupFolderName> -RestoreMethod Overwrite -Item  <WebApplicationName> [-BackupId <GUID>] [-Verbose]

    Where:

    • <BackupFolderName> is the full path of the folder that you use for backup files.

    • <WebApplicationName> is the name of the web application that was backed up.

    • <GUID> is the identifier of the back up to use for the restore operation.

    If you do not specify the value of the BackupID parameter, the most recent backup will be used. You cannot restore a web application by using a configuration-only backup. You can view the backups for the farm by typing the following:

    Copy code
    Get-SPBackupHistory -Directory <BackupFolderName> -ShowBackup

For more information, see Restore-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Using Central Administration to restore a web application in SharePoint 2013

You can use Central Administration to restore a web application.

To restore a web application by using Central Administration

  1. Verify that the user account performing this procedure is a member of the Farm Administrators group. Additionally, verify that the Windows SharePoint Services Timer V4 service and the Farm Database Access account have Full Control permissions on the backup folder.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Restore from a backup.

  4. On the Restore from Backup — Step 1 of 3: Select Backup to Restore page, from the list of backups, select the backup job that contains the farm or web application backup, and then click Next. You can view more details about each backup by clicking the (+) next to the backup.

    Note:

    If the correct backup job does not appear, in the Current Directory Location text box, type the Universal Naming Convention (UNC) path of the correct backup folder, and then click Refresh.

    You cannot use a configuration-only backup to restore the web application.

  5. On the Restore from Backup — Step 2 of 3: Select Component to Restore page, select the check box that is next to the web application, and then click Next.

  6. On the Restore from Backup — Step 3 of 3: Select Restore Options page, in the Restore Component section, make sure that Farm\<Web application> appears in the Restore the following content list.

    In the Restore Only Configuration Settings section, make sure that the Restore content and configuration settings option is selected.

    In the Restore Options section, under Type of Restore, select the Same configuration option. A dialog box appears that asks you to confirm the operation. Click OK.

    Note:

    If the Restore Only Configuration Settings section does not appear, the backup that you selected is a configuration-only backup. You must select another backup.

    Click Start Restore.

  7. You can view the general status of all recovery jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current recovery job in the lower part of the page in the Restore section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the recovery to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Sprestore.log file at the UNC path that you specified.

Using SQL Server tools to restore databases associated with a web application in SharePoint 2013

You cannot restore the complete web application by using SQL Server tools. However, you can restore all the databases that are associated with the web application. To restore the complete web application, use either Windows PowerShell or Central Administration.

To restore databases associated with a web application by using SQL Server tools

  1. Verify that the user account performing this procedure is a member of the sysadmin fixed server role.

  2. If the Windows SharePoint Services Timer service is running, stop the service and wait for several minutes for any currently running stored procedures to finish. Do not restart the service until after you restore the databases.

  3. Start SQL Server Management Studio and connect to the database server.

  4. In Object Explorer, expand Databases.

  5. Right-click the database that you want to restore, point to Tasks, point to Restore, and then click Database.

    The database is automatically taken offline during the recovery operation and cannot be accessed by other processes.

  6. In the Restore Database dialog box, specify the destination and the source, and then select the backup set or sets that you want to restore.

    The default values for destination and source are appropriate for most recovery scenarios.

  7. In the Select a page pane, click Options.

  8. In the Restore options section, select only Overwrite the existing database. Unless the environment or policies require otherwise, do not select the other options in this section.

  9. In the Recovery state section:

    • If you have included all the transaction logs that you must restore, select RECOVER WITH RECOVERY.

    • If you must restore additional transaction logs, select RECOVER WITH NORECOVERY.

    • The third option, RECOVER WITH STANDBY is not used in this scenario.

      Note:

      For more information about these recovery options, see Restore Database (Options Page) (http://go.microsoft.com/fwlink/p/?LinkId=114420).

  10. Click OK to complete the recovery operation.

  11. Repeat steps 4 through 10 for each database that you are restoring.

  12. Start the Windows SharePoint Services Timer service.

Additional steps to restore a web application that uses forms-based authentication in SharePoint 2013

After you restore a web application that uses forms-based authentication, you must follow these steps to reconfigure the web application to use forms-based authentication.

  1. Re-register the membership and role providers in the Web.config file.

  2. Redeploy the providers.

For more information, see Configure forms-based authentication for a claims-based web application in SharePoint 2013.

Additional steps to remove duplicate claims providers after restoring a web application that uses claims-based authentication in SharePoint 2013

After a web application that is configured to use claims-based authentication is restored, duplicate or additional claims providers are often visible. You must use the following process to remove the duplicate providers:

  1. In Central Administration, click Manage Web application, select a web application that uses claims-based authentication, and then click Authentication Providers.

  2. Select a zone that the web application is associated with to open the Edit Authentication page, and then click Save.

  3. Repeat for each zone, and then for each web application that uses claims-based authentication.

Additional steps to re-configure object cache user accounts in SharePoint 2013

If you configured object cache user accounts for the web application, the restore process will not restore these settings. You must re-configure the settings for the web application.

See also

Back up web applications in SharePoint 2013
Plan for backup and recovery in SharePoint 2013
Backup and restore SharePoint 2013

What's New in SharePoint 2013 Resource Center


Restore service applications in SharePoint 2013
See also

Summary: Learn how to restore a service application in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can restore a service application in SharePoint 2013 by using the SharePoint Central Administration website or Windows PowerShell. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

In this article:

  • Before you begin

  • Use Windows PowerShell to restore a service application in SharePoint 2013

  • Use Central Administration to restore a service application in SharePoint 2013

  • Use SQL Server tools to restore the databases associated with a service application in SharePoint 2013

Before you begin

There are situations in which you might have to restore a specific service application instead of restoring the complete farm. Some service applications — for example, the Business Data Connectivity service application and the User Profile Service service application — provide data to other services and sites. As a result, users might experience some service interruption until the recovery process is completed.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about how to restore service applications:

  • You cannot back up from one version of Microsoft SharePoint Products and restore to another version of SharePoint Products.

  • SharePoint Server 2013 backs up the Business Data Connectivity service metadata store, which includes external content types, external systems, and Business Data Catalog models. Note that this does not back up the external data sources. To protect the data, the external data sources must be backed up.

  • If you restore the service application or the farm and then restore the data source to a different location, you must configure the location information in the external content type definition. If you do not, the Business Data Connectivity service might be unable to locate the data source.

    Note:

    SharePoint Server 2013 restores remote Binary Large Object (BLOB) stores but only if you are using the FILESTREAM provider to put data in remote BLOB stores.

    If you are using another provider, you must manually restore remote BLOB stores.

  • You cannot restore the complete service application by using SQL Server tools. However, you can restore the databases that are associated with the service application.

Use Windows PowerShell to restore a service application in SharePoint 2013

You can use Windows PowerShell to restore a service application.

To restore a service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions.

    For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory
<BackupFolder>
 -Item "
<ServiceApplicationName>
" -RestoreMethod Overwrite [-BackupId
<GUID>
] [-Verbose]

    Where:

    • <BackupFolder> is the path for the backup folder where the service application was backed up.

    • <ServiceApplicationName> is the name of the service application.

    • <GUID> is the ID of the backup to use.

    To specify which backup to use, use the BackupId parameter. You can view the backups for the farm by typing the following: Get-SPBackupHistory -Directory <BackupFolder> -ShowBackup. If you do not specify the BackupId, the most recent backup will be used. You cannot restore a service application from a configuration-only backup.

    To restore all the service applications, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory
<BackupFolder>
 -Item "Farm\Shared Service Applications" -RestoreMethod Overwrite [-BackupId
<GUID>
] [-Verbose]

    Where:

    • <BackupFolder> is the path for the backup folder where the service application was backed up.

    • <GUID> is the ID of the backup to use.

For more information, see Restore-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to restore a service application in SharePoint 2013

Use the following procedure to restore a service application by using the SharePoint Central Administration Web site.

To restore a service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Restore from a backup.

  4. On the Restore from Backup — Step 1 of 3: Select Backup to Restore page, select the backup job that contains the service application backup, or a farm-level backup, from the list of backups, and then click Next. You can view more details about each backup by clicking the (+) next to the backup.

    Note:

    If the correct backup job does not appear, in the Backup Directory Location text box, type the path of the correct backup folder, and then click Refresh.

    You cannot use a configuration-only backup to restore the farm.

  5. On the Restore from Backup — Step 2 of 3: Select Component to Restore page, expand Shared Services Applications, select the check box that is next to the service application, and then click Next. To restore all the service applications, select the Shared Services Applications node.

  6. On the Restore from Backup — Step 3 of 3: Select Restore Options page, in the Restore Component section, make sure that Farm\Shared Services Applications\<Service application> appears in the Restore the following component list.

    In the Restore Options section, under Type of restore, select the Same configuration option. A dialog box will appear that asks you to confirm the operation. Click OK.

    Click Start Restore.

  7. You can view the general status of all recovery jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current recovery job in the lower part of the page in the Restore section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take a several seconds for the recovery to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Sprestore.log file at the UNC path that you specified in step 3.

Use SQL Server tools to restore the databases associated with a service application in SharePoint 2013

You cannot restore the complete service application by using SQL Server tools. However, you can use SQL Server tools to restore the databases that are associated with the service application. To restore the complete service application, use either Windows PowerShell or Central Administration.

To restore the databases for a service application by using SQL Server tools

  1. Verify that the user account that you are using to restore the databases is a member of the sysadmin fixed server role on the database server where each database is stored.

  2. Open SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Right-click the database that you want to restore, point to Tasks, point to Restore, and then click Database.

  5. In the Restore Database dialog box, on the General page, select the database to restore to from the To database drop-down list.

  6. Select the restore source from the From database drop-down list.

  7. In the Select the backup sets to restore section area, select the check box next to the database.

  8. On the Options tab, select the recovery state from the Recover state section.

    For more information about which recovery type to use, see Recovery Models (SQL Server) in SQL Server Books Online.

  9. Click OK to restore the database.

  10. Repeat steps 1-9 for each database that is associated with the service application.

See also

What's New in SharePoint 2013 Resource Center


Restore a User Profile Service service application in SharePoint Server 2013
See also

Summary: Learn how to restore the User Profile Service service application in SharePoint Server 2013.

Applies to: SharePoint Server 2013

You can restore the User Profile Service service application by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

Important:

The steps in this article apply to SharePoint Server 2013.

In this article:

  • Before you begin

  • Using Windows PowerShell to restore the User Profile service application in SharePoint Server 2013

    • To restore the User Profile service application by using Windows PowerShell

  • Using Central Administration to restore a User Profile service application in SharePoint Server 2013

    • To restore the User Profile service application by using Central Administration

  • Using SQL Server tools to restore the databases associated with the User Profile service application in SharePoint Server 2013

    • To restore the databases associated with the User Profile service application by using SQL Server tools

Before you begin

This article describes how to restore the User Profile Service service application instead of restoring the complete farm.

Note:

Because SharePoint Server 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint Server 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about how to restore a User Profile service application:

  • The User Profile service application provides data to other services and sites. As a result, users might experience some service interruption until the recovery process is completed.

  • You cannot back up from one version of SharePoint Server and restore to another version of SharePoint Server.

  • For information about how to at the same time restore all the service applications in a farm, see Restore farms in SharePoint 2013.

Using Windows PowerShell to restore the User Profile service application in SharePoint Server 2013

You can use Windows PowerShell to restore a User Profile service application.

To restore the User Profile service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory <BackupFolder> -Item Shared Services\Shared Services Applications\<ServiceApplicationName> -RecoveryMethod Overwrite [-BackupId <GUID>] [-Verbose]

    Where:

    • <BackupFolder> is the path of the folder where the backups are stored.

    • <ServiceApplicationName> is the name of the service application.

    • <GUID> is the identifier of the backup to use in the restore process.

    If you do not specify the BackupId, the most recent backup will be used. You cannot restore a service application from a configuration-only backup.

For more information, see Restore-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Using Central Administration to restore a User Profile service application in SharePoint Server 2013

Use the following procedures to restore a User Profile service application by using the SharePoint Central Administration Web site.

To restore the User Profile service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Restore from a backup.

  4. On the Restore from Backup — Step 1 of 3: Select Backup to Restore page, select the backup job that contains the service application backup, or a farm-level backup, from the list of backups, and then click Next. You can view more details about each backup by clicking the (+) next to the backup.

    Note:

    If the correct backup job does not appear, in the Backup Directory Location text box, type the path of the correct backup folder, and then click Refresh.

    You cannot use a configuration-only backup to restore the User Profile Service service application.

  5. On the Restore from Backup — Step 2 of 3: Select Component to Restore page, expand Shared Services Applications, select the check box that is next to the User Profile Service service application, and then click Next.

  6. On the Restore from Backup — Step 3 of 3: Select Restore Options page, in the Restore Component section, make sure that Farm\Shared Services Applications\<User Profile Service service application name> appears in the Restore the following component list.

    In the Restore Options section, under Type of restore, select the Same configuration option. A dialog box will appear that asks you to confirm the operation. Click OK.

  7. Click Start Restore.

  8. You can view the general status of all recovery jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current recovery job in the lower part of the page in the Restore section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take a several seconds for the recovery to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Sprestore.log file at the UNC path that you specified in step 3.

Using SQL Server tools to restore the databases associated with the User Profile service application in SharePoint Server 2013

You cannot restore the complete service application or service application proxy by using SQL Server tools. However, you can use SQL Server tools to restore the databases that are associated with the service application. To restore the complete service application, use either Windows PowerShell or Central Administration.

Important:

If you are restoring the User Profile database (by default, it is named User Profile Service_ProfileDB_<GUID>), you must also restore the Social database (by default, it is named User Profile Service_SocialDB_<GUID>). Failing to do this can cause inaccuracies in the User Profile data that might be difficult to detect and fix.

To restore the databases associated with the User Profile service application by using SQL Server tools

  1. Verify that the user account that you are using to restore the databases is a member of the SQL Server sysadmin fixed server role on the database server where each database is stored.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, in the System Settings section, click Manage services on server.

  4. On the Services on Server page, find User Profile Service. If the service is started, click Stop to stop the service.

  5. Before you restore the User Profile Service service application databases, you must import the Microsoft Identity Integration Server (MIIS) encryption key that you exported before backing up the databases. You only have to do this one time for the restore process. To do this, on the server to which you are restoring the service application, type the following at the command prompt:

    Copy code
    miiskmu.exe /i exported.key {<GUID>}

    Where <GIUD> is the identifier of the key.

  6. Open SQL Server Management Studio and connect to the database server.

  7. In Object Explorer, expand Databases.

  8. Right-click the database that you want to restore, point to Tasks, and then click Restore Database.

  9. In the Restore Database dialog box, on the Options page, select the kind of recovery that you want to perform from the Recovery state list.

    For more information about which recovery type to use, see Recovery Models (SQL Server) in SQL Server 2008 with SP1 and Cumulative Update 2 Books Online.

  10. On the General page, in the Destination for restore section, select the database from the To database list.

  11. In the Source for restore section, select the backup source from the From database list.

  12. Alternatively, if you have moved the backup files to another computer, select the From device option. If the correct backup is not listed in the Select the backup sets to restore box, browse to the file by clicking the ellipsis button.

  13. Select the backup to restore from the Select the backup sets to restore box, and then click OK.

  14. Click OK to restore the database.

  15. Repeat steps 5-11 for the following databases associated with the User Profile Service service application (the names that are listed are the default names):

    • User Profile Service_ProfileDB_<GUID>

    • User Profile Service_SocialDB_<GUID>

    • User Profile Service_SyncDB_<GUID>

  16. In Central Administration, in the System Settings section, click Manage services on server.

  17. On the Services on Server page, find User Profile Service. If the service is stopped, click Start to start the service.

See also

Restore (SharePoint 2013)
Back up User Profile service applications in SharePoint Server 2013
Administer the User Profile service in SharePoint Server 2013
Overview of the User Profile service application in SharePoint Server 2013
Windows PowerShell for SharePoint 2013 reference

What's New in SharePoint 2013 Resource Center


Restore Search service applications in SharePoint 2013

Summary: Learn how to restore the Search service application in SharePoint 2013.

Applies to: SharePoint Server 2013

You can restore search by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. The restore tool that you use depends on the kind of environment that you have deployed, your schedule requirements, and service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Restore a thesaurus file

  • Use Windows PowerShell to restore a SharePoint Search service application

  • Use Central Administration to restore a SharePoint Search service application

  • Use SQL Server tools to restore the databases for a Search service application

Before you begin

There are situations in which you might have to restore a specific service application instead of restoring the complete farm. Some service applications — for example, the SharePoint Search service application, Business Data Connectivity service application, and the User Profile Service service application — provide data to other services and sites. As a result, users might experience some service interruption until the recovery process is completed.

Before you begin this operation, review the following information:

  • Backing up and restoring search does not affect the state of the farm. However, it does require resources. Therefore, backup and restore for search might affect farm performance while the backup is running. You can avoid performance issues by backing up search during hours when farm use is lowest.

  • You cannot restore the complete service application by using SQL Server tools. However, you can restore the databases that are associated with the service application.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Restore a thesaurus file

Thesaurus files are used to specify synonyms for words or phrases that occur in search queries. You create and maintain the thesaurus files in systems external to SharePoint 2013 before you import them into SharePoint 2013 to make them available to the search system. The thesaurus files are therefore not included in the default SharePoint 2013 search backup procedures, and also not in the search recovery procedures outlined below.

To restore a thesaurus file

  1. Follow one of the procedures below to restore the SharePoint 2013 Search service application.

  2. If necessary, restore the thesaurus file using the restore procedures for the external system you are using to create and maintain thesaurus files.

  3. Import the thesaurus file to the SharePoint 2013 search system by using the Import-SPEnterpriseSearchThesaurus Windows PowerShell cmdlet as described in Deploy a thesaurus.

Use Windows PowerShell to restore a SharePoint Search service application

You can use Windows PowerShell to restore a service application.

To restore a Search service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Farm Administrators SharePoint group.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Make sure that the server you are restoring to use the same drive mapping as the server where you created the backup.

  3. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  4. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory <BackupFolder> -Item "<ServiceApplicationName>" -RecoveryMethod Overwrite [-BackupId <GUID>] [-Verbose]

    Where:

    • <BackupFolder> is the path for the backup folder where the service application was backed up.

    • <ServiceApplicationName> is the name the service application.

    • <GUID>is the ID of the backup to use.

    To specify which backup to use, use the BackupId parameter. You can view the backups for the farm by typing the following: Get-SPBackupHistory -Directory <BackupFolder> -ShowBackup. If you do not specify the BackupId, the most recent backup will be used. You cannot restore a service application from a configuration-only backup.

    To restore all the service applications, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory <BackupFolder> -Item "Farm\Shared Service Applications" -RecoveryMethod Overwrite [-BackupId <GUID>] [-Verbose]

    Where:

    • <BackupFolder> is the path for the backup folder where the service application was backed up.

    • <GUID>is the ID of the backup to use.

    For more information, see Restore-SPFarm.

  5. When you restore a Search service application, it is automatically paused. To resume the Search service application when the restore has completed, type the following command:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication <SearchServiceApplicationName>
$ssa.ForceResume($ssa.IsPaused())

    Where:

    • <SearchServiceApplicationName> is the name the service application you want to resume.

Note:

Index files are restored to one replica per index partition. After the restore has completed, the index for each replica is replicated to the other index replicas. During this process the search topology is fully functional for crawling and queries, but is not fault tolerant.

Depending on the size of the farm and the index, the process can take several hours and the index replicas appear as degraded in the Search Administration UI and in the output of the Get-SPEnterpriseSearchStatus Windows PowerShell cmdlet.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Use Central Administration to restore a SharePoint Search service application

Use the following procedure to restore a search service application by using the SharePoint Central Administration website.

To restore a Search service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Make sure that the server you are restoring to use the same drive mapping as the server where you created the backup.

  3. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  4. In Central Administration, on the home page, in the Backup and Restore section, click Restore from a backup.

  5. On the Restore from Backup — Step 1 of 3: Select Backup to Restore page, select the backup job that contains the service application backup, or a farm-level backup, from the list of backups, and then click Next. You can view more details about each backup by clicking the (+) next to the backup.

    Note:

    If the correct backup job does not appear, in the Backup Directory Location text box, type the path of the correct backup folder, and then click Refresh.

    You cannot use a configuration-only backup to restore the farm.

  6. On the Restore from Backup — Step 2 of 3: Select Component to Restore page, expand Shared Services Applications, select the check box that is next to the Search service application, and then click Next. To restore all the service applications, select the Shared Services Applications node.

  7. On the Restore from Backup — Step 3 of 3: Select Restore Options page, in the Restore Component section, make sure that Farm\Shared Services Applications\<Service application> appears in the Restore the following component list.

    In the Restore Options section, under Type of restore, select the Same configuration option. A dialog box will appear that asks you to confirm the operation. Click OK.

    Click Start Restore.

  8. You can view the general status of all recovery jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current recovery job in the lower part of the page in the Restore section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take a several seconds for the recovery to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Sprestore.log file at the UNC path that you specified in step 3.

  9. When you restore a Search service application, it is automatically paused. To resume the Search service application when the restore has completed you need to use Windows PowerShell:

    1. Verify that you have the following memberships:

      • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

      An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

      Note:

      If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

    2. Start the SharePoint 2013 Management Shell.

      • For Windows Server 2008 R2:

        • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

      • For Windows Server 2012:

        • On the Start screen, click SharePoint 2013 Management Shell.

          If SharePoint 2013 Management Shell is not on the Start screen:

        • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

      For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

    3. At the Windows PowerShell command prompt, type the following command:

      Copy code
      $ssa = Get-SPEnterpriseSearchServiceApplication <SearchServiceApplicationName>
$ssa.ForceResume($ssa.IsPaused())

      Where:

      • <SearchServiceApplicationName> is the name the service application you want to resume.

Note:

Index files are restored to one replica per index partition. After the restore has completed, the index for each replica is replicated to the other index replicas. During this process the search topology is fully functional for crawling and queries, but is not fault tolerant.

Depending on the size of the farm and the index, the process can take several hours. The index replicas appear as degraded in the Search Administration UI and in the output of the Get-SPEnterpriseSearchStatus Windows PowerShell cmdlet during the process.

Use SQL Server tools to restore the databases for a Search service application

You cannot restore the complete SharePoint Search service application by using SQL Server tools. However, you can use SQL Server tools to restore the databases that are associated with the service application. To restore the complete Search service application, use either Windows PowerShell or Central Administration.

To restore the databases for a Search service application by using SQL Server tools

  1. Verify that the user account that you are using to restore the databases is a member of the SQL Serversysadmin fixed server role on the database server where each database is stored.

  2. Open SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Right-click the database that you want to restore, point to Tasks, point to Restore, and then click Database.

  5. In the Restore Database dialog box, on the General page, select the database to restore to from the To database drop-down list.

  6. Select the restore source from the From database drop-down list.

  7. In the Select the backup sets to restore section area, select the check box next to the database.

  8. On the Options tab, select the recovery state from the Recover state section.

    For more information about which recovery type to use, see Recovery Models (SQL Server) in SQL Server Books Online.

  9. Click OK to restore the database.

  10. Repeat steps 1-9 for each database that is associated with the service application.


Restore Secure Store Service in SharePoint Server 2013
See also

Summary: Learn how to restore the Secure Store Service application in SharePoint Server 2013.

Applies to: SharePoint Server 2013

You can restore the Secure Store service application by using the SharePoint Central Administration website or Windows PowerShell. The restore tool that you use depends on the kind of environment that you have deployed, your schedule requirements, and service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Using Central Administration to restore the Secure Store Service in SharePoint Server 2013

    • To restore the Secure Store Service by using Central Administration

  • Using Windows PowerShell to restore the Secure Store Service in SharePoint Server 2013

    • To restore the Secure Store Service by using Windows PowerShell

Before you begin

The Secure Store Service provides the capability of securely storing credential sets and associating credentials to specific identities or a group of identities.

Before you begin this operation, review the following information about the Secure Store service application:

  • Every time that you enter a new passphrase, SharePoint Server 2013 creates a new Master Key and re-encrypts the credentials sets with that key. The passphrase gives you access to the Master Key created by SharePoint Server 2013 that is used to encrypt the credential sets.

  • You will need the passphrase that was recorded when the Secure Store Service was backed up to restore the Secure Store Service.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Using Central Administration to restore the Secure Store Service in SharePoint Server 2013

Use the following procedure to restore the Secure Store Service by using Central Administration.

To restore the Secure Store Service by using Central Administration

  1. Verify that the user account performing this procedure is a member of the Farm Administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Restore from a backup.

  4. On the Restore from Backup — Step 1 of 3: Select Backup to Restore page, select the backup job that contains the backup that you want, or a farm-level backup, from the list of backups, and then click Next. You can view more details about each backup by clicking the (+) next to the backup.

    Note:

    If the correct backup job does not appear, in the Backup Directory Location text box, type the path of the correct backup folder, and then click Refresh.

    You cannot use a configuration-only backup to restore the Secure Store Service.

  5. On the Restore from Backup — Step 2 of 3: Select Component to Restore page, expand Shared Services Applications and select the check box that is next to the Secure Store Service application backup group, and then click Next.

  6. On the Restore from Backup — Step 3 of 3: Select Restore Options page, in the Restore Component section, make sure that Farm\Shared Services\Shared Services Applications\<Secure Store Service name> appears in the Restore the following component list.

    In the Restore Options section, under Type of restore, select the Same configuration option. A dialog box will appear that asks you to confirm the operation. Click OK.

    Click Start Restore.

  7. You can view the general status of all recovery jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current recovery job in the lower part of the page in the Restore section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take a several seconds for the recovery to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Sprestore.log file at the path that you specified in step 3.

  8. After the restore operation has successfully completed, you must refresh the passphrase.

  9. In Central Administration, on the home page, in the Application Management section, click Manage service applications.

  10. On the Service Applications page, click the Secure Store Service name. You might receive an error that says "Unable to obtain master key."

  11. On the Secure Store Service page, on the ribbon, click Refresh Key.

  12. In the Refresh Key dialog box, type the passphrase in the Pass Phrase box, and then click OK.

Using Windows PowerShell to restore the Secure Store Service in SharePoint Server 2013

You can use Windows PowerShell to restore the Secure Store Service.

To restore the Secure Store Service by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory <BackupFolder> -Item <SecureStoreServicename> -RecoveryMethod Overwrite [-BackupId <GUID>] [-Verbose]

    Where:

    • <BackupFolder> is the path for the backup folder where the service application was backed up.

    • <SecureStoreServicename> is the name of the Secure Store Service application.

    If you have multiple backups use the BackupId parameter to specify which backup to use. To view all of the backups for the farm, type the following command at the Windows PowerShellcommand prompt:

    Copy code
    Get-SPBackupHistory -Directory <BackupFolder> -ShowBackup
    Note:

    If you do not specify a value for the BackupId parameter, the most recent backup will be used. You cannot restore the Secure Store Service from a configuration-only backup.

  4. After the restore operation has successfully completed, you must refresh the passphrase. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Update-SPSecureStoreApplicationServerKey -Passphrase <Passphrase>

    Where <Passphrase>, is the one that you currently use.

For more information, see Restore-SPFarm and Update-SPSecureStoreApplicationServerKey.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Back up the Secure Store Service in SharePoint 2013


Restore content databases in SharePoint 2013
See also

Summary: Learn how to restore a content database in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can restore a content database in SharePoint 2013 by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. The restore tool that you use depends on the kind of environment that you have deployed, your schedule requirements, and service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Using Windows PowerShell to restore a SharePoint content database

    • To restore a content database by using Windows PowerShell

  • Using Central Administration to restore a SharePoint content database

    • To restore a content database by using Central Administration

  • Using SQL Server tools to restore a SharePoint content database

    • To restore a content database by using SQL Server tools

Before you begin

You can restore any content database or several content databases, one at a time. For information about how to back up all the content databases in a farm at the same time, see Back up farms in SharePoint 2013.

Before you begin this operation, review the following information about how to restore a content database:

  • SharePoint Server restores up remote Binary Large Objects (BLOB) stores but only if you are using the SQL Filestream remote BLOB store provider to place data in remote BLOB stores.

    If you are using another provider you must manually restore these remote BLOB stores.

  • If a user has taken copies of content for off-line editing in and the content is restored from a backup on the server, when the user re-connects, the server automatically synchronizes the off-line content with the restored content. This might result in data loss on the user's copies of the content.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Using Windows PowerShell to restore a SharePoint content database

You can use Windows PowerShell to restore a content database.

To restore a content database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory <BackupFolder> -RestoreMethod Overwrite -Item <ContentDatabase> [-BackupId <GUID>] [-Verbose]

    Where:

    • <BackupFolder> is the name and path for the backup folder where the service application was backed up.

    • <ContentDatabase> is the name of the content database.

    If you do not use the BackupId parameter, the most recent backup will be used. To view all of the backups for the farm, type the following command at the Windows PowerShellcommand prompt:

    Copy code
    Get-SPBackupHistory -Directory <Backup folder>

For more information, see Restore-SPFarm.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Using Central Administration to restore a SharePoint content database

You can use Central Administration to restore a farm or components of a farm.

To restore a content database by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Restore from a backup.

  4. On the Restore from Backup — Step 1 of 3: Select Backup to Restore page, from the list of backups, select the backup job that contains the content database backup, and then click Next.

    Note:

    If the correct backup job does not appear, in the Current Directory Location text box, enter the path of the correct backup folder, and then click Refresh.

  5. On the Restore from Backup — Step 2 of 3: Select Component to Restore page, select the check box that is next to the content database, and then click Next.

    Note:

    If the content database is not selectable, you must use Windows PowerShell or SQL Server tools to restore the content database.

  6. On the Restore from Backup — Step 3 of 3: Select Restore Options page, in the Restore Options section, under Type of Restore, click the Same configuration option. A dialog box appears that asks you to confirm the operation. Click OK.

    Click Start Restore.

  7. You can view the general status of all recovery jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current recovery job in the lower part of the page in the Restore section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the recovery to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Sprestore.log file at the UNC path that you specified in step 2.

Using SQL Server tools to restore a SharePoint content database

You can use SQL Server tools to restore a content database by following these steps:

  1. If possible, back up the live transaction log of the content database to protect any changes that were made after the last full backup.

  2. Restore the last full database backup.

  3. Restore the most recent differential database backup that occurred after the most recent full database backup.

  4. Restore all transaction log backups that occurred after the most recent full or differential database backup.

To restore a content database by using SQL Server tools

  1. Verify that the user account performing this procedure is a member of the sysadmin fixed server role.

  2. If the Windows SharePoint Services Timer service is running, stop the service and wait for several minutes for any currently running stored procedures to finish. Do not restart the service until after you restore the content databases.

  3. Start SQL Server Management Studio and connect to the database server.

  4. In Object Explorer, expand Databases.

  5. Right-click the database that you want to restore, point to Tasks, point to Restore, and then click Database.

    The database is automatically taken offline during the recovery operation and cannot be accessed by other processes.

  6. In the Restore Database dialog box, specify the destination and the source, and then select the backup set or sets that you want to restore.

    The default values for destination and source are appropriate for most recovery scenarios.

  7. In the Select a page pane, click Options.

  8. In the Restore options section, select only Overwrite the existing database. Unless the environment or policies require otherwise, do not select the other options in this section.

  9. In the Recovery state section:

    • If you have included all the transaction logs that you must restore, select RECOVER WITH RECOVERY.

    • If you must restore additional transaction logs, select RECOVER WITH NORECOVERY.

    • The third option, RECOVER WITH STANDBY is not used in this scenario.

      Note:

      For more information about these recovery options, see Restore Database (Options Page).

  10. Click OK to complete the recovery operation.

  11. Repeat steps 4 through 10 for each database that you are restoring.

  12. Start the Windows SharePoint Services Timer service.

See also

Back up content databases in SharePoint 2013


Attach and restore a read-only content database in SharePoint 2013

Summary: Learn how to attach and restore a read-only content database in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can attach and restore a read-only content database in SharePoint 2013 by using Windows PowerShell.

In this article:

  • Before you begin

  • Using Windows PowerShell to attach and restore a read-only content database

    • To attach and restore a read-only content database by using Windows PowerShell

Before you begin

A SharePoint 2013 farm in which content databases are set to be read-only can be part of a failure recovery environment that runs against mirrored or log-shipped content databases or part of a highly available maintenance or patching environment that provides user access when another version of the farm is being updated.

Before you begin this operation, review the following information about prerequisites:

  • When you re-attach the read-only databases, they become read-write.

  • For more information about how to use read-only databases, see Run a farm that uses read-only databases in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Using Windows PowerShell to attach and restore a read-only content database

You can use only Windows PowerShell to attach and restore a read-only content database.

To attach and restore a read-only content database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Mount-SPContentDatabase -Name <DatabaseName> -WebApplication <WebApplicationID> [-Verbose]

    Where:

    • <DatabaseName> is name of the read-only database.

    • <WebApplicationID> is ID assigned to the read-only database.

    Note:

    Attaching a content database by using the Mount-SPContentDatabase cmdlet differs from attaching a database in SQL Server by using SQL Server tools. Mount-SPContentDatabase associates the content database with a Web application so that the contents can be read.

For more information, see Mount-SPContentDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Restore content from unattached content databases in SharePoint 2013
See also

Summary: Learn how to restore content from an unattached content database in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can restore content from an unattached content database in SharePoint 2013 by using the SharePoint Central Administration website or Windows PowerShell. The restore tool that you use depends on the kind of environment that you have deployed, your schedule requirements, and service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Using Windows PowerShell to recover content from an unattached content database in SharePoint 2013

    • To recover content from an unattached content database by using Windows PowerShell

  • Using Central Administration to recover content from an unattached content database in SharePoint 2013

    • To recover content from an unattached content database by using Central Administration

Before you begin

You can restore or copy content, such as sites, site collections, lists, or document libraries, from a content database without having to attach the content database to the farm.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Using Windows PowerShell to recover content from an unattached content database in SharePoint 2013

You can recover content from an unattached content database by using Windows PowerShell. The following procedure shows how to use the Get-SPContentDatabase cmdlet to recover content from an unattached content database. You can also import a list or document library with the Import-SPWeb cmdlet. For more information, see Import a list or document library in SharePoint 2013.

To recover content from an unattached content database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPContentDatabase -ConnectAsUnattachedDatabase  -DatabaseName <DatabaseName> -DatabaseServer <DatabaseServer>

    Where:

    • <DatabaseName> is the name of the unattached database from which you want to recover content.

    • <DatabaseServer> is the name of the database server that hosts the unattached database from which you want to recover content.

For more information, see Get-SPContentDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Using Central Administration to recover content from an unattached content database in SharePoint 2013

You can recover content from an unattached content database by using Central Administration.

To recover content from an unattached content database by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group and is a member of the db_owner fixed database role.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, click Backup and Restore.

  4. On the Backup and Restore page, in the Granular Backup section, click Recover data from an unattached content database.

  5. On the Unattached Content Database Data Recovery page, type the database server name in the Database Server text box and type the database name in the Database Name text box.

  6. Select the database authentication method that you want to use.

  7. Select the Browse content option, and then click Next.

  8. On the Browse content page, select the site collection, site, and or list that you want to restore, select the Backup site collection or Export site or list option, and then click Next.

  9. Type the file location where you want to store the backup file, and then click Start Backup. For more information about using the Backup site collection option, see Back up site collections in SharePoint 2013.

    If you chose Export site or list in the previous page, you must select Export Full Security and choose the version that you want to export in the Export Versions drop-down menu. For more information about using the Export site or list option, see Export sites, lists, or document libraries in SharePoint 2013.

See also

Prepare to back up and restore farms in SharePoint 2013
Attach or detach content databases in SharePoint 2013


Restore customizations in SharePoint 2013

Summary: Learn how to restore customizations that are made to SharePoint 2013 sites.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can restore any customizations that are made to SharePoint 2013 by using Central Administration or Windows PowerShell. The restore tool that you use depends on the kind of environment that you have deployed, your schedule requirements, and w service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Restoring solution packages in SharePoint 2013

    • To restore a trusted solution by using Central Administration

    • To restore a trusted solution by using Windows PowerShell

  • Restoring a sandboxed solution

  • Restoring authored site elements in SharePoint 2013

  • Restoring workflows in SharePoint 2013

  • Restoring changes to the Web.config file in SharePoint 2013

  • Restoring developed customizations that are not packaged as solutions in SharePoint 2013

Before you begin

Before you begin this operation, review the following information:

  • We recommend that you keep a backup of the original .wsp file and of the source code used to build the .wsp file for both trusted and sandboxed solutions.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Restoring solution packages in SharePoint 2013

The method that you use to restore solution packages is determined by whether the customizations were deployed as trusted solutions or sandboxed solutions.

Trusted solutions are solutions that farm administrators deploy. They are deployed to the complete farm, and can be used on any site within the farm. Trusted solutions are stored in the configuration database. Trusted solutions are backed up when a farm is backed up by using SharePoint 2013 backup, and are included in configuration-only backups, and can also be backed up as a group, or individually. They are visible in the restore hierarchy.

Sandboxed solutions are solutions that site collection administrators can deploy to a single site collection. Sandboxed solutions are stored in the content database associated with the site collection that they are deployed to. They are included in SharePoint 2013 farm, Web application, content database, and site collection backups, but are not visible in the restore hierarchy, and cannot be selected or restored individually.

To restore a trusted solution by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the home page, in the Backup and Restore section, click Restore from a backup.

  4. On the Restore from Backup — Step 1 of 3: Select Backup to Restore page, from the list of backups, select the backup job that contains the solution package, and then click Next. You can view more details about each backup by clicking the (+) next to the backup.

    Note:

    If the correct backup job does not appear, in the Backup Directory Location text box, type the Universal Naming Convention (UNC) path of the correct backup folder, and then click Refresh.

  5. On the Restore from Backup — Step 2 of 3: Select Component to Restore page, select the check box that is next to the solution, and then click Next.

  6. On the Restore from Backup — Step 3 of 3: Select Restore Options page, in the Restore Component section, make sure that Solution appears in the Restore the following component list.

    In the Restore Only Configuration Settings section, make sure that the Restore content and configuration settings option is selected.

    In the Restore Options section, under Type of Restore, select the Same configuration option. A dialog box appears that asks you to confirm the operation. Click OK.

    Click Start Restore.

  7. You can view the general status of all recovery jobs at the top of the Backup and Restore Job Status page in the Readiness section. You can view the status for the current recovery job in the lower part of the page in the Restore section. The status page updates every 30 seconds automatically. You can manually update the status details by clicking Refresh. Backup and recovery are Timer service jobs. Therefore, it may take several seconds for the recovery to start.

    If you receive any errors, you can review them in the Failure Message column of the Backup and Restore Job Status page. You can also find more details in the Sprestore.log file at the UNC path that you specified in step 3.

To restore a trusted solution by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPFarm -Directory <BackupFolder> -RestoreMethod Overwrite -BackupId <GUID> -Item <SolutionPath>

    Where:

    • <BackupFolder> is the UNC location of the directory that you want to restore from.

    • <GUID> is the GUID of the backup ID that you want to restore from. If you do not specify a backup, the most recent one is used.

    • <SolutionPath> is the path of the solution within the backup tree (usually farm\solutions\SolutionName).

For more information, see Get-SPContentDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Restoring a sandboxed solution

You cannot restore only customizations that were deployed as sandboxed solutions. Instead, you must restore the farm, Web application, content database, or site collection with which the customization is associated. For more information about these methods of restoring, see Related content later in this article.

Restoring authored site elements in SharePoint 2013

You cannot restore only authored site elements. Instead, you must restore the farm, Web application, or content database with which the authored site element is associated. For more information about these methods of backing up, see Related content.

Restoring workflows in SharePoint 2013

Workflows are a special case of customizations that you can restore. Make sure that the backup and recovery plan includes any of the following scenarios that apply to the environment:

  • Declarative workflows, such as those that are created in SharePoint Designer 2013, are stored in the content database for the site collection to which they are deployed. Restoring the content database or site collection restores these workflows.

  • Custom declarative workflow actions have components in the following three locations:

    1. The Visual Studio 2012 assemblies for the actions are stored in the global assembly cache (GAC).

    2. The XML definition files (.actions files) are stored in the 15\TEMPLATE\<LCID>\Workflow directory.

    3. An XML entry to mark the action as an authorized type is stored in the Web.config file for the Web applications in which it is used.

    If the farm workflows use custom actions, you should use a file restore system to restore these files and XML entries. You can reapply the files as needed after recovery.

  • Workflows that depend on custom code, such as those that are created by using Visual Studio 2012, are stored in two locations. The Visual Studio 2012 assemblies for the workflow are stored in the GAC, and the XML definition files are stored in the Features directory. This is the same as other types of SharePoint 2013 features such as Web Parts and event receivers. If the workflow was installed as part of a solution package, follow the instructions for restoring solution packages.

  • If you create a custom workflow that interacts with a site collection other than the one where the workflow is deployed, you must restore both site collections to recover the workflow. Restoring a farm is sufficient to recover all site collections in the farm and all workflows that are associated with them.

  • Workflows that are not deployed must be restored separately by using a file system backup application.

Restoring changes to the Web.config file in SharePoint 2013

You can recover changes to the Web.config file made by using Central Administration or the SharePoint 2013 APIs and object model by performing a farm or configuration-only restore.

You should use a file system backup to protect changes to the Web.config file that are not made by using Central Administration or the SharePoint APIs and object model. You can recover the backup by using a file system restore.

Restoring developed customizations that are not packaged as solutions in SharePoint 2013

Restoring developed customizations that are not packaged as solutions can be a complex process because the customization file locations are not standardized.

Consult with the development team or customization vendor to determine whether the customizations involve additional add-in software or files in other locations. We recommend that you restore directories with a file system restore solution. The following table lists locations where customizations are typically stored on Web servers.

Location | Description
%PROGRAMFILES%\Common files\Microsoft Shared\Web Server Extensions\15 | Commonly updated files, custom assemblies, custom templates, custom site definitions
Inetpub | Location of IIS virtual directories
%WINDIR%\Assembly | Global assembly cache (GAC): a protected operating system location where the Microsoft .NET Framework code assemblies are installed to provide full system access


Restore site collections in SharePoint 2013
See also

Summary: Learn how to restore a single site collection in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can only restore a site collection in SharePoint 2013 by using Windows PowerShell.

In this article:

  • Before you begin

  • Using Windows PowerShell to restore a site collection in SharePoint 2013

    • To restore a site collection by using Windows PowerShell

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Using Windows PowerShell to restore a site collection in SharePoint 2013

You can use Windows PowerShell to restore a site collection manually or as part of a script that can be run at scheduled intervals.

Note:

If a user has taken copies of content for off-line editing in and the content is restored from a backup on the server, when the user re-connects, the server automatically synchronizes the off-line content with the restored content. This might result in data loss on the user's copies of the content.

To restore a site collection by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPSite -Identity <SiteCollectionURL> -Path <Backup file> [-DatabaseServer <DatabaseServerName>] [-DatabaseName <ContentDatabaseName>] [-HostHeader <Host header>] [-Force] [-GradualDelete] [-Verbose]

    Where:

    • <SiteCollectionURL> is URL for the site collection you want to restore.

    • <DatabaseServerName> is name of the database server where the site collection resides.

    • <ContentDatabaseName> is the name of the content database.

    If you want to restore the site collection to a specific content database, use the DatabaseServer and DatabaseName parameters to specify the content database. If you do not specify a content database, the site collection will be restored to a content database chosen by SharePoint 2013.

    If you are restoring a host-named site collection, use the Identity parameter to specify the URL of the host-named site collection and use the HostHeader parameter to specify the URL of the Web application that will hold the host-named site collection.

    If you want to overwrite an existing site collection, use the Force parameter.

    Note:

    If the site collection that you are restoring is 1 gigabyte or larger, you can use the GradualDelete parameter for better performance during the restore process. When this parameter is used, the site collection that is overwritten is marked as deleted, which immediately prevents any additional access to its content. The data in the marked site collection is then deleted gradually over time by a timer job instead of all at the same time, which reduces the impact on server performance.

For more information, see Restore-SPSite.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Back up site collections in SharePoint 2013


Restore apps for SharePoint in SharePoint 2013
See also

Published: December 11, 2012

Summary: Learn how to restore apps for SharePoint in SharePoint 2013.

Applies to: apps for SharePoint | SharePoint Server 2013 | SharePoint Foundation 2013

You can restore an apps for SharePoint environment by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. The restore tool that you use depends on the kind of environment that you have deployed, your schedule requirements, and service level agreements that you have with your organization. The app for SharePoint content and packages are stored in the SharePoint 2013 content databases in individual site collections. The restore process requires you to restore all services that the app references. The apps for SharePoint can reference the following SharePoint 2013 databases which you may have to restore. You should also restore the site collection where the app for SharePoint is located if you are restoring the apps for SharePoint to the same environment.

  • Content

  • Configuration

  • Secure Store Service application

  • App Management service application

For more information about the SharePoint 2013 databases, see Database types and descriptions (SharePoint 2013). For a graphical representation of the SharePoint 2013 databases, see Databases that support SharePoint 2013

In this article:

  • Before you begin

  • Restore content databases

  • Restore the configuration database

  • Restore the Secure Store Service application database

  • Restore the App Management service application database

  • Restore a site collection

    • To restore a site collection by using Windows PowerShell

  • Restore apps for SharePoint to a new farm

Before you begin

Content databases can store data for multiple site collections. If you have apps for SharePoint hosted in many site collections you may also have multiple content databases. To back up and restore all of the apps for SharePoint in your environment, you must back up and restore all content databases and site collections in the farm.

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Restore content databases

You can restore a single content database or several content databases one at a time. For information about how to restore a content database in a farm, see Restore content databases in SharePoint 2013. For information about how to back up and restore all the content databases in a farm at the same time, see Back up farms in SharePoint 2013.

Restore the configuration database

In SharePoint 2013 you do not have to restore the configuration database because you can restore the farm configuration directly. For more information, see Restore farm configurations in SharePoint 2013.

Restore the Secure Store Service application database

The Secure Store Service database stores and maps credentials to specific identities or a group of identities. You must have the passphrase that was recorded when the Secure Store Service was backed up to restore it. To restore the Secure Store database, see Restore Secure Store Service in SharePoint Server 2013.

Restore the App Management service application database

The App Management service application database stores the app licenses and permissions for all apps downloaded from the App Catalog site in SharePoint 2013. You must restore this database to make sure that the apps for SharePoint licenses and permissions are available in your farm. To restore the App Management database, follow the same procedures as most other SharePoint 2013 service applications. For more information, see Restore service applications in SharePoint 2013.

Restore a site collection

You can only restore a site collection in SharePoint 2013 by using Windows PowerShell. Use this section to restore a site collection that contains apps for SharePoint to the same SharePoint 2013 environment. To restore to a new farm, see Restore apps for SharePoint to a new farm.

Caution:

Any apps for SharePoint that contain remote components that are present on the backup copy of a site collection could cause problems. This is because two copies of the app for SharePoint are accessing the remote connection and can cause information disclosure or data loss. For example, when a site collection in a production environment is copied by a backup for a development purpose, this could unintentionally grant developers access to production data in remote sites if the app for SharePoint is not designed correctly.

To restore a site collection by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not displayed on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Restore-SPSite -Identity <SiteCollectionURL> -Path <Backup file> [-DatabaseServer <DatabaseServerName>] [-DatabaseName <ContentDatabaseName>] [-HostHeader <Host header>] [-Force] [-GradualDelete] [-Verbose]

    Where:

    • <SiteCollectionURL> is URL for the site collection you want to restore.

    • <DatabaseServerName> is name of the database server where the site collection resides.

    • <ContentDatabaseName> is the name of the content database.

    If you want to restore the site collection to a specific content database, use the DatabaseServer and DatabaseName parameters to specify the content database. If you do not specify a content database, the site collection will be restored to a content database chosen by SharePoint 2013.

    If you are restoring a host-named site collection, use the Identity parameter to specify the URL of the host-named site collection and use the HostHeader parameter to specify the URL of the web application that will hold the host-named site collection.

    If you want to overwrite an existing site collection, use the Force parameter.

    Note:

    If the site collection that you are restoring is 1 gigabyte or larger, you can use the GradualDelete parameter for better performance during the restore process. When this parameter is used, the site collection that is overwritten is marked as deleted, which immediately prevents any additional access to its content. The data in the marked site collection is then deleted gradually over time by a timer job instead of all at the same time, which reduces the effect on server performance.

    For more information, see Restore site collections in SharePoint 2013

    For more information, see Restore-SPSite.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Restore apps for SharePoint to a new farm

To restore apps for SharePoint to a new farm you must also backup and restore any services that the app references. These SharePoint 2013 service applications can include the Secure Store Service service application, Access Services in SharePoint Server 2013, and the App Management Service. For more information, see the following articles:

  • Restore Secure Store Service in SharePoint Server 2013

  • Restore service applications in SharePoint 2013

See also

Back up apps for SharePoint in SharePoint 2013
Restore content databases in SharePoint 2013
Restore site collections in SharePoint 2013


Import a list or document library in SharePoint 2013
See also

Summary: Learn how to import a site, list, or document library in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can import a site, list, or document library in SharePoint 2013 by using Windows PowerShell.

In this article:

  • Before you begin

  • Importing a site, list, or document library in SharePoint 2013

    • To import a site, list or document library by using Windows PowerShell

Before you begin

Although you can use either Windows PowerShell or Central Administration to export a site, list, or document library, you can use only Windows PowerShell to import a site, list, or document library. For information about how to export lists or libraries, see Export sites, lists, or document libraries in SharePoint 2013.

Before you begin this operation, review the following information:

  • You can use importing as a method of restoring the items, or as a method of moving or copying the items from one farm to another farm. You can import a site, list, or document library from a backup of the current farm, from a backup of another farm, or from a read-only content database. To import from a read-only content database, you must first attach the read-only database. For more information, see Attach and restore a read-only content database in SharePoint 2013.

  • You cannot import a site, list or document library exported from one version of SharePoint 2013 Products to another version of SharePoint 2013 Products.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Importing a site, list, or document library in SharePoint 2013

You can use Windows PowerShell to manually import a site, list, or document library or as part of a script that can be run regularly.

To import a site, list or document library by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Import-SPWeb -Identity  <SiteURL>  -Path <ExportFileName>  [-Force] [-NoFileCompression] [-Verbose]

    Where:

    • <SiteURL> is the URL for the site that you are importing to.

    • <ExportFileName> is the name of the file that you are exporting.

    Important:

    The site or subsite that you are importing must have a template that matches the template of the site specified by Identity.

    You can also use the Get-SPWeb cmdlet and pass the ID to Import-SPWeb by using the Windows PowerShell pipeline. The value of the Path parameter specifies the path and file name of the file from which to import the list or library. To include the user security settings with the list or document library, use the IncludeUserSecurity parameter. To overwrite the list or library that you specified, use the Force parameter. You can use the UpdateVersions parameter to specify how versioning conflicts will be handled. To view the progress of the operation, use the Verbose parameter.

    The NoFileCompression parameter lets you specify that no file compression is performed during the import process. Using this parameter can lower resource usage up to 30% during the export and import process. If you are importing a site, list, or document library that you exported from Central Administration, or if you exported a site, list, or document library by using Windows PowerShell and you did not use the NoFileCompression parameter in the Export-SPWeb cmdlet, you cannot use this parameter in the Import-SPWeb cmdlet.

    Note:

    There is no facility in the Import-SPWeb cmdlet import a subset of the items within the export file. Therefore, the import operation will import everything from the file.

For more information, see Import-SPWeb.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Export sites, lists, or document libraries in SharePoint 2013


Backup and restore best practices in SharePoint 2013
See also

Published: February 19, 2013

Summary: Learn how to implement best practices before you back up and restore a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Best practices for backup and restore help make sure that backup and restore operations in SharePoint 2013 are successful and that the environment is protected against data loss or continuity gaps.

In this article:

  • Performance best practices for SharePoint backup and restore operations

  • Quality assurance best practices to back up a SharePoint farm

  • Procedural best practices to back up and restore SharePoint 2013

Performance best practices for SharePoint backup and restore operations

Backup and restore operations consume server resources and limit server performance while the operations are running. Follow these best practices to reduce resource usage and increase the performance of servers and the backup or restore task.

Minimize latency between SQL Server and the backup location

In general, it is efficient to back up to a local disk on the database server instead of a network drive. You can then copy the data later to a shared folder on the network. Network drives with 1 millisecond or less latency between them and the database server perform well.

Note:

If you cannot back up to local drives, use network drives with similar latency. Because network backups are subject to network errors, verify the backup action after it finishes. For more information, see "Backing Up to a File on a Network Share" in Backup Devices (SQL Server).

To avoid I/O bottlenecks, perform the main backup to a separate disk from the disk running SQL Server 2008 R2 with Service Pack 1 (SP1) and SQL Server 2012. For more information, see Define a Logical Backup Device for a Disk File (SQL Server).

By design, most backup jobs consume all available I/O resources to complete the job. Therefore, you might see disk queuing, which can result in greater than usual latency for I/O requests. This is typical and should not be considered a problem. For more information, see Monitor Disk Usage.

Avoid processing conflicts

Do not run backup jobs during times when users need access to the system. Typically, systems run 24 hours a day, seven days a week. A best practice is to always run incremental backups to safeguard against server failure. Consider staggering backups so that all databases are not backed up at the same time.

Keep databases small for faster recovery times

Keep databases small to speed both backup and restore. For example, use multiple content databases for a web application instead of one large content database. For more information, see Database types and descriptions (SharePoint 2013).

Use incremental backups for large databases

Use incremental backups for large databases because you can make them quickly and maintain performance of the environment. Although you can restore full backups faster than incremental backups, continuous incremental backups minimize data loss. For more information about types of backups, see the following resources:

  • SQL Server 2008 R2 with SP1 Backup Overview (SQL Server)

  • SQL Server 2012 Backup Overview (SQL Server)

Use compression during backup

In some circumstances, you can use compression to decrease the size of backups and the time to complete each backup. Backup compression was introduced in SQL Server 2008 Enterprise. For more information about how backup compression affects performance in SQL Server, see the following resources:

  • SQL Server 2008 R2 with SP1 Backup Compression (SQL Server)

  • SQL Server 2012 Backup Compression (SQL Server)

Follow SQL Server backup and restore optimization recommendations

SQL Server backups use a combination of full, differential, and transaction log backups (for the full or bulk-logged recovery model) to minimize recovery time. Differential database backups are usually faster to create than full database backups and reduce the number of transaction logs required to recover the database.

If you are using the full recovery model, we recommend that you periodically truncate the transaction log files to avoid maintenance issues.

For detailed recommendations about how to optimize SQL Server backup and restore performance, see Optimizing Backup and Restore Performance in SQL Server.

Use RAID 10 if you use RAID

Carefully consider whether to use redundant array of independent disks (RAID) on the device to which you back up data. For example, RAID 5 has slow write performance, approximately the same speed as for a single disk. This is because RAID 5 has to maintain parity information. RAID 10 can provide faster backups because it doesn't need to manage parity. Therefore, it reads and writes data faster. For more information about how to use RAID with backups, see Configure RAID for maximum SQL Server I/O throughput and RAID Levels and SQL Server.

Configure SharePoint settings to improve backup or restore performance

You can only configure file compression and log file settings in Windows PowerShell. You can configure backup and restore threads in both the SharePoint Central Administration website and Windows PowerShell to increase backup or restore efficiency and performance.

If you use the Export-SPWeb Windows PowerShell cmdlet, you can use the NoFileCompression parameter. By default, SharePoint 2013 uses file compression while exporting web applications, site collection, lists, or document libraries. You can use this parameter to suppress file compression while exporting and importing. File compression can use up to 30% more resources. However, the exported file uses approximately 25% less disk space. If you use the NoFileCompression parameter when you export, you have to also use it when you import the same content.

You can also use the NoLogFile parameter. By default, SharePoint 2013 always creates a log file when you export content. Although you can use this parameter to suppress log file creation to save resources, we recommend that you always create logs. Logs are important for troubleshooting and log creation does not use many resources such as CPU or memory.

When you use the Backup-SPFarm cmdlet, you can also use the BackupThreads parameter to specify how many threads SharePoint 2013 will use during the backup process. A higher number of threads will consume more resources during backup. But the overall time to make the backup is decreased. Because each thread is recorded in the log files, the number of threads does affect log file interpretation. By default, three threads are used. The maximum number of available threads is 10.

Note:

The backup threads setting is also available through Central Administration on the Default Backup and Restore Settings page in the Backup and Restore section.

Consider site collection size when you determine the tools to use

If the business requires site collection backups in addition to farm-level or database-level backups, choose a backup tool that is based on the size of the site collection.

  • Less than 15 gigabytes (GB): Use the Backup-SPSite Windows PowerShell cmdlet. For more information, see Back up site collections in SharePoint 2013.

  • 15-100 GB: Use a SharePoint 2013 tool, a SQL Server tool, or other database backup tool to protect the content database that contains the site collection. For more information, see Back up site collections in SharePoint 2013.

  • Larger than 100 GB: Use a differential backup solution, such as SQL Server 2008 R2 with SP1 or System Center 2012 - Data Protection Manager (DPM), instead of the built-in backup and recovery tools.

Quality assurance best practices to back up a SharePoint farm

Follow these best practices to help ensure the quality of the backups of the farm environment and reduce the chances of data loss.

Ensure you have enough storage space

Be certain that the system has enough disk space to accommodate the backup. Configure a backup job in Central Administration to verify the required disk space.

Routinely test backup quality

Routinely test backups and validate their consistency. Run practice recovery operations to validate the contents of the backup and to make sure that you can restore the complete environment. To prepare for disaster recovery of geographically dispersed environments, set up a remote farm. Then you can restore the environment by using the database-attach method to upload a copy of the database to the remote farm and redirect users. Periodically perform a trial data recovery action to verify that the process correctly backs up files. A trial restoration can expose hardware problems that do not come up with software verifications and can also to make sure that the recovery time objectives (RTO) are met.

Back up ULS trace logs

The SharePoint 2013 backup process doesn't back up the Unified Logging Service (ULS) trace logs. Data in ULS trace logs can be useful for performance analysis, troubleshooting, and monitoring compliance with service level agreements. Therefore, protect this data as part of the routine maintenance.

By default, SharePoint log files are at C:\Program files\Common Files\Microsoft Shared\Web Server Extensions\15\Logs. The files are named with the server name followed by the date and time stamp. The SharePoint trace logs are created at set intervals and when you use the IISRESET command.

Store a copy of backup files off-site

To safeguard against loss from a natural disaster that destroys the primary data center, maintain duplicate copies of backups in separate locations from the servers. Duplicate copies can help prevent the loss of critical data. As a best practice, keep three copies of the backup media, and keep at least one copy offsite in a controlled environment. This should include all backup and recovery materials, documents, database and transaction log backups, and usage and trace log backups.

Procedural best practices to back up and restore SharePoint 2013

Use the following procedural best practices to plan and perform backup and restore operations.

Use FQDN server names

When you refer to servers in a different domain, always use fully qualified domain names (FQDN).

Keep accurate records

When you deploy SharePoint 2013, record the accounts that you create, the computer names, passwords, and setup options. Keep this information in a safe and secure location. Possibly, keep multiple records to make sure this information is always available.

Have a recovery environment ready

Use a farm in a secondary location to validate the success of restore operations as part of your disaster recovery strategy. For more information, see Choose a disaster recovery strategy for SharePoint 2013. In a disaster recovery situation, you can then restore the environment by using the database-attach method to upload a copy of the database to the remote farm and redirect users. For more information, review and follow the steps in Restore farms in SharePoint 2013. Also for a high availability solution, you can set up a standby environment that runs the same version of software as the production environment so that you can restore the databases and recover documents quickly. For more information, see Describing high availability.

Schedule backup operations

Use Windows PowerShell backup and recovery cmdlets to create a script file (*.ps1) and then schedule it to run with Windows Task Scheduler. This makes sure that all backup operations are run at the best time when the system is least busy and users are not accessing it. For more information, see the following:

  • Running Scripts

  • Backup and recovery cmdlets in SharePoint 2013

Use the SQL FILESTREAM provider with BLOB storage

Remote BLOB Storage (RBS) is supported in a SharePoint 2013 farm. There are both pros and cons associated with using RBS in SharePoint 2013. One related limitation of RBS with a SharePoint farm is that System Center 2012 - Data Protection Manager (DPM) cannot use the FILESTREAM provider to back up or restore RBS. SharePoint 2013 supports the FILESTREAM provider for backup and restore operations. A benefit of RBS with a SharePoint farm is that you can use either SharePoint tools or SQL Server tools to back up and restore the content database with the Remote BLOB Store (RBS) defined. This backs up and restores both the RBS and the content database. We do not recommend that you use RBS with other restore methods. For more information about the benefits and limitations of using RBS, see Plan for RBS in SharePoint 2013.

Note:

SharePoint 2013 supports the FILESTREAM provider that is included in the Microsoft® SQL Server® 2008 R2 Feature Pack. The SQL Server 2012 installation media includes RBS as an optional add-on component.

See also

Overview of backup and recovery in SharePoint 2013
Plan for backup and recovery in SharePoint 2013
Prepare to back up and restore farms in SharePoint 2013


Manage databases in SharePoint 2013

Summary: Learn how to manage the databases that are associated with SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet and related resources provide information about database management.

TechNet articles about database management

The following articles about database management are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Content Description

Building blocks

Add content databases in SharePoint 2013

Adding a content database to an existing Web application is a common task. This article describes how to add a content database to an existing SharePoint 2013 implementation.

Attach or detach content databases in SharePoint 2013

Certain operations, such as applying updates or creating copies of configuration settings, require that you detach and then attach databases. This article describes how to do these procedures.

Move site collections between databases in SharePoint 2013

Under some circumstances, you might want to move one or more site collections to a different content database. For example, a site collection can outgrow the content database on which it is located, and you would have to move the site collection to a larger content database. Conversely, if site collections do not grow to their expected capacity, it might be convenient to combine several site collections onto one content database. This article describes how to move site collections between databases.

Move content databases in SharePoint 2013

This article describes how to move content databases between servers that are running SQL Server, between instances of SQL Server, or from one SharePoint 2013 Web application to another. You can also move a content database to load balance a database server or Web application.

Rename service application databases in SharePoint 2013

  • Rename the App Management Service service application databases in SharePoint 2013

  • Rename the Business Data Connectivity service application databases in SharePoint Server 2013

  • Rename the Managed Metadata Service service application databases in SharePoint Server 2013

  • Rename the PerformancePoint Services service application databases in SharePoint Server 2013

  • Rename the Secure Store Service service application databases in SharePoint 2013

  • Rename the SharePoint Translation Services service application databases in SharePoint Server 2013

  • Rename the State Service service application databases in SharePoint Server 2013

  • Rename the Usage and Health Data Collection service application databases in SharePoint 2013

  • Rename the Word Automation Services service application databases in SharePoint Server 2013

  • Rename the Microsoft SharePoint Foundation Subscription Settings Service service application databases in SharePoint 2013

  • Rename the User Profile service application databases in SharePoint Server 2013

This section describes how to rename service application databases by using SQL Server, and then how to point the service application to the renamed database. This can be a complex process because different types of service applications require different methods of pointing to the new database name. Each article describes how to rename a specific service application database and then how to point to the renamed database.

Move service application databases (SharePoint 2013)

  • Move the App Management Service service application databases (SharePoint 2013)

  • Move the Business Data Connectivity service application databases in SharePoint Server 2013

  • Move the Managed Metadata Service service application databases in SharePoint Server 2013

  • Move the PerformancePoint service application databases in SharePoint Server 2013

  • Move the Secure Store Service service application databases in SharePoint 2013

  • Move the SharePoint Translation Services service application databases in SharePoint Server 2013

  • Move the State Service service application databases in SharePoint Server 2013

  • Move the Usage and Health Data Collection service application databases in SharePoint 2013

  • Move the Word Automation Services service application databases in SharePoint Server 2013

  • Move the Microsoft SharePoint Foundation Subscription Settings Services service application databases (SharePoint 2013)

  • Move the User Profile service application databases in SharePoint Server 2013

This section describes how to move service application databases by using SQL Server, and then how to point the service application to the moved database. This can be a complex process because different types of service applications require different methods of pointing to the new database name. Each article describes how to move a specific service application database and then how to point to the moved database.

Move all databases in SharePoint 2013

This article describes how to move all of the databases associated with SharePoint 2013 from one database server to another database server. If your databases are hosted on different servers, this procedure applies to the database server that hosts the configuration database.

Run a farm that uses read-only databases in SharePoint 2013

A read-only farm can be part of a disaster recovery environment. Alternatively, it can be part of a highly available maintenance, patching, or upgrade environment that provides user access while another version of the farm is being updated. This article describes how to run a SharePoint 2013 farm in which content databases are set to be read-only (a read-only farm).

Manage RBS in SharePoint 2013

Learn about Remote BLOB Storage (RBS) and how to manage RBS in SharePoint 2013.

Best practices for SQL Server in a SharePoint Server farm

Learn how to implement best practices for SQL Server in a SharePoint Server 2013 farm.


Add content databases in SharePoint 2013
See also

Summary: Learn how to add a content database to your SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can add a content database to a SharePoint 2013 farm by using the SharePoint Central Administration website or Windows PowerShell. The tool that you use depends on the kind of environment that you have deployed, your schedule requirements, and service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Adding a content database to a SharePoint 2013 web application

    • To add a content database to a web application by using Central Administration

    • To add a content database to a web application by using Windows PowerShell

Before you begin

You can add a new content database or attach an existing content database from a backup file.

Before you begin this operation, review the following information about prerequisites:

  • The user account that is performing this operation must be a member of the Farm Administrators SharePoint group.

  • If you use Windows authentication to connect to SQL Server, the user account must be a member of the dbcreator fixed server role on the SQL Server instance where the database is to be created.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Adding a content database to a SharePoint 2013 web application

You can use the procedures that are described in this article to create a new content database and attach it to a web application. If you are using Windows authentication to connect to SQL Server, the user account must also be a member the SQL Server dbcreator fixed server role on the SQL Server instance where the database will be created. If you are using SQL authentication to connect to SQL Server, the SQL authentication account that you specify when you create the content database must have dbcreator permission on the SQL Server instance where the database will be created.

To add a content database to a web application by using Central Administration

  1. Verify that the user account that is performing this operation is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, click Application Management.

  4. In the Databases section, click Manage content databases.

  5. On the Manage Content Databases page, click Add a content database.

  6. On the Add Content Database page:

    1. Specify a web application for the new database.

    2. Specify a database server to host the new database.

    3. Specify the authentication method that the new database will use and supply an account name and password, if they are necessary.

      Important:

      The account name and password must already exist as a SQL Server login.

    4. Specify the name of the failover database server, if one exists.

    5. Specify the number of top-level sites that can be created before a warning is issued. By default, this is 2,000.

    6. Specify the total number of top-level sites that can be created in the database. By default, this is 5,000.

  7. Click OK.

To add a content database to a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SPContentDatabase -Name <ContentDbName> -WebApplication <WebApplicationName>

    Where:

    • <ContentDbName> is the name of the content database to create.

    • <WebApplicationName> is the name of the web application to which the new database is attached.

For more information, see New-SPContentDatabase.

Note:

To attach an existing content database to a web application, use the Windows PowerShell cmdlet Mount-SPContentDatabase. For more information, see Mount-SPContentDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Attach or detach content databases in SharePoint 2013
Move site collections between databases in SharePoint 2013


Attach or detach content databases in SharePoint 2013
See also

Summary: Learn how to attach and detach content databases to your SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can attach or detach SharePoint 2013 content databases by using the SharePoint Central Administration website or Windows PowerShell 3.0

In this article:

  • Before you begin

  • Attaching and detaching content databases

    • To attach a content database by using Central Administration

    • To detach a content database by using Central Administration

    • To attach or detach a content database by using Windows PowerShell

Before you begin

Before you begin this operation, review the following information:

  • If you want to create a new content database while you attach it, the SharePoint farm service account must be a member of the SQL Server dbcreator fixed server role. To attach a content database to a web application, the SharePoint farm service account must have db_owner permission for the content database.

  • If the database already exists, it must be the same version as the SharePoint 2013 farm or this operation will fail. To attach a content database that is a different version than the farm, use the To attach or detach a content database by using Windows PowerShell procedure in the following section.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Attaching and detaching content databases

You might want to attach or detach content databases for the following reasons. You want to add a new content database for new site collections to keep content databases at a manageable size. You are restoring a content database from another farm and you want the sites that it contains to be accessed from a web application. You have archived site collections out of a content database and then detach the content database from the web application. For more information, see Move site collections between databases in SharePoint 2013

The steps to add a database and to attach a database are very similar. For more information about how to add a database, see Add content databases in SharePoint 2013.

To attach a content database by using Central Administration

  1. Verify that the user account that is being used to perform this operation is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, click Application Management.

  4. On the Application Management page, in the Databases section, click Manage content databases.

  5. On the Manage Content Databases page, click Add a content database.

  6. On the Add Content Database page:

    1. Use the web Application drop-down menu to select the web application to which you want to attach a content database.

    2. Specify the database server that hosts the database.

    3. Specify the database name. If the database does not already exist, it will be created.

    4. Specify the authentication method for the database, and supply an account name and password if you are using SQL authentication.

      Important:

      The account name and password must already exist as a SQL Server login. We recommend that you use Windows authentication instead of SQL authentication because, by default, SQL authentication sends a nonencrypted password to the computer that is running SQL Server. If you use SQL authentication, the SQL account requires the same SQL permissions as the SharePoint farm service account.

    5. Click OK.

To detach a content database by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the SharePoint Central Administration website, click Application Management.

  3. On the Application Management page, in the Databases section, click Manage content databases.

  4. Select the web application for which you want to detach a content database.

  5. Click the content database that you want to detach.

  6. On the Manage Content Database Settings page, select the Remove content database check box.

    If the content database contains data, you will receive a warning. Click OK to continue with the operation.

  7. Click OK to confirm the detachment, or click Cancel to stop the operation without detaching the database.

    After detaching the content database in Central Administration, the content database still exists in SQL Server. If you want to permanently remove the content database, you must do so by using a SQL Server procedure.

To attach or detach a content database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the appropriate command

    To attach an existing content database:

    Copy code
    Mount-SPContentDatabase "<ContentDb>" -DatabaseServer "<DbServer>" -WebApplication http://SiteName

    Where:

    • <ContentDb> is the content database to be attached.

    • <DbServer> is the name of the database server.

    • http://SiteName is the name of the web application to which the content database is being attached.

    To detach a content database:

    Copy code
    Dismount-SPContentDatabase "<ContentdBName>"

    Where <ContentdBName> is the name of the content database.

    Important:

    If you have multiple content databases that have the same name, you must use the content database GUID in this command instead of using the content database name. To retrieve the GUID of the content database, run the Get-SPContentDatabase cmdlet with no arguments.

    The Dismount-SPContentDatabase cmdlet detaches the content database from the web application, but it does not delete the content database from SQL Server. After a content database is detached, you cannot delete it by using Windows PowerShell 3.0. You can only remove it by using SQL Server tools. If you want to delete the content database from SQL Server while you detach it, use the Remove-SPContentDatabase cmdlet instead.

For more information, see Dismount-SPContentDatabase and Mount-SPContentDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Get-SPContentDatabase
New-SPContentDatabase
Remove-SPContentDatabase


Move site collections between databases in SharePoint 2013
See also

Summary: Learn how to prepare and move site collections between databases in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Under some circumstances, you might want to move one or more site collections to a different content database. For example, a site collection can outgrow the content database on which it resides, and you would have to move the site collection to a larger content database. In SharePoint 2013, you should view this procedure as moving the site collection to a larger database.

However, if site collections do not grow to their expected capacity, it might be convenient to combine several site collections onto one content database. In SharePoint 2013, this process does not merge content databases, instead the site collections are moved to and joined on a new database.

You can move site collections between databases in a SharePoint 2013 farm by using Windows PowerShell. You can also move site collections by using Backup and Restore procedures. For information about how to do this, see Back up site collections in SharePoint 2013 and Restore site collections in SharePoint 2013.

In this article:

  • Before you begin

  • Determining the size of the source site collection

    • To determine the size of the site collection by using Windows PowerShell

    • To archive and trim audit data by using Windows PowerShell

  • Moving site collections between content databases

  • To move a single site collection

  • To move multiple site collections

Before you begin

Before you begin this operation, the following conditions must be true:

  • The destination content database must already exist.

  • The source content database and destination content database must be located on the same instance of SQL Server.

  • The source content database and destination content database must be attached to the same web application. For more information about how to add a content database to a web application, see Add content databases in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Determining the size of the source site collection

When you move site collections to another content database the auditing data is copied. The size of the auditing data varies depending on the event collection settings for the site collection. If the auditing data is large, you can move the data to another database before you move the site collection. To do this, use the To archive and trim audit data by using Windows PowerShell procedure.

Regardless of the reason for moving a site collection, you should always begin the task by determining the size of the site collection that is to be moved. You can then be sure that the destination hard disk can sufficiently contain the site collection contents. Verify that the destination hard disk has at least three times the free space that is required for the site collection.

Tip:

You can stay current about the space that site collections are using by creating site quotas and e-mail alerts..

To determine the size of the site collection by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $used = (Get-SPSiteAdministration -Identity <http://ServerName/Sites/SiteName>).DiskUsed
    Copy code
    $used

    Where:

    • <http://ServerName/Sites/SiteName> is the name of the site collection.

    The amount of disk space that is being used by the specified site collection is stored in the $used variable, and is displayed at the command prompt when the second command is run.

    Note:

    The amount of disk space that is displayed does not include the disk space that is used by the auditing data that will be moved with the site collection.

For more information, see Get-SPSiteAdministration.

To archive and trim audit data by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    (Get-SPSite -Identity <http://ServerName/Sites/SiteName>).Audit.TrimAuditLog(deleteEndDate)

    Where:

    • <http://ServerName/Sites/SiteName> is the name of the site collection.

    To delete the audit data without archiving it first, type the following command:

    Copy code
    (Get-SPSite -Identity <http://ServerName/Sites/SiteName>).Audit.DeleteEntries(deleteEndDate)

For more information, see Get-SPSite.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Moving site collections between content databases

You can use the Windows PowerShell command Move-SPSite to move site collections between content databases. Two procedures are provided here. The first procedure moves a single site collection to a new content database, and the second procedure moves multiple site collections to a new content database.

To move a single site collection

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Move-SPSite <http://ServerName/Sites/SiteName> -DestinationDatabase <DestinationContentDb>

    Where:

    • <http://ServerName/Sites/SiteName> is the name of the site collection.

    • <DestinationContentDb> is the name of the destination content database.

To move multiple site collections

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPSite -ContentDatabase <SourceContentDb> | Move-SPSite -DestinationDatabase <DestinationContentDb>

    Where:

    • <SourceContentDb> is the name of the original content database.

    • <DestinationContentDb> is the name of the destination content database.

    This command moves all site collections from the source content database to the destination content database.

For more information, see Move-SPSite.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Add content databases in SharePoint 2013


Move content databases in SharePoint 2013

Summary: Learn how to move content databases in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move content databases between servers that are running SQL Server, between instances of SQL Server, or from one SharePoint 2013 web application to another.

Important:

This article only describes how to move content databases. For information about how to move other kinds of databases that are associated with SharePoint 2013, see Rename service application databases in SharePoint 2013 and Move all databases in SharePoint 2013.

You can move content databases by using the SharePoint Central Administration website or Windows PowerShell, and SQL Server tools. Which tool that you use depends on what kind of environment you have deployed, what your schedule requires, and what service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Moving content databases by using Central Administration

  • Moving content databases by using Windows PowerShell

Before you begin

Before you begin this operation, moving a content database, review the following tasks. Each task is a procedure that must be done in the order in which it is listed. Note that when you move content databases, you must use both SharePoint 2013 tools and SQL Server tools. You can use either Central Administration or Windows PowerShell 3.0 for this operation.

  1. Record the content database name and the web application it is associated with.

  2. Pause any service applications and services that might run against the content database, including timer jobs and search crawls.

  3. Remove the SharePoint 2013 content database from the web application.

  4. Detach the content database from the current SQL Server instance.

  5. Copy or move the content database .mdf, .ndf, and .ldf files from the source location to the destination location using Windows Explorer.

  6. Attach the content database to the new SQL Server instance.

  7. Add the content database to the destination web application in SharePoint 2013.

    Important:

    Use the identical name when you add the content database or SharePoint 2013 creates a new content database.

  8. Restart all service applications and services that you paused in step 2.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Moving content databases by using Central Administration

Use the following procedure to move the content databases in your SharePoint 2013 farm by using Central Administration.

Note:

The procedures in this section use Central Administration to move content databases. However when you perform the following procedures, you must use the correct tool:

  • 1. To record which content databases are associated with each web application ─ Windows PowerShell

  • 4. To detach the content databases from SQL Server ─ SQL Server tools

  • 5. To move the content databases to a new location ─ Windows Explorer

  • 6. To attach the content databases to the new instance of SQL Server ─ SQL Server tools

Note:

The procedures in this section use Central Administration to move content databases. However, the first procedure, must be performed by using Windows PowerShell.

Note:

If you are moving a content database to a different farm, you must make the server farm account a member of the Administrators group on the database server during the restore process. This enables the account to replicate the security setting for the databases. This access level can be removed after the content database is moved. For more information, see Account permissions and security settings in SharePoint 2013.

The destination farm must be running the same version or a later version of SharePoint 2013 than the source farm is running.

1. To record which content databases are associated with each web application

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • The dbcreator and securityadmin fixed server roles on the destination server, in order to attach the database and configure SQL Server logins.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPContentDatabase -WebApplication <http://SiteName>

    Where:

    • <http://SiteName> is the URL of the web application.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

2. To pause timer jobs by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, in the Monitoring section, click Check Job Status.

  3. For each scheduled job that runs against the content database that you are moving, click the job to open the Edit Timer Job page, click Disable, and then click OK.

3. To detach the content databases from a web application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, in the Application Management section, click Manage Content databases.

  3. On the Manage Content Databases page, click the content database that you want to move.

    The Manage Content Database Settings page opens.

    Note:

    If the content database does not appear in the list, it might be associated with another web application. To select another web application, on the Web Application menu, click Change Web Application.

  4. On the Manage Content Database Settings page, in the Remove Content Database section, select the Remove content database check box, and then click OK.

    Note:

    Removing the content database does not delete the database. It only removes the association of the database with the web application.

  5. Repeat steps 3 and 4 for each content database that you want to move.

4. To detach the content databases from SQL Server

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role on the database server where each database is stored.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the content database, point to Tasks, and then click Detach. Repeat this step for each content database that you want to move.

    Note:

    Use this procedure to move only content databases. Do not detach any other kinds of databases.

5. To move the content databases to a new location

  1. Verify that the user account that is performing this procedure has Write access to both the source and destination folders.

  2. Using Windows Explorer, locate the .mdf, .ldf, and .ndf files for the content databases.

  3. Select the .mdf, .ldf, and .ndf files for the database that you want to move and either copy or move them to the destination directory.

6. To attach the content databases to the new instance of SQL Server

  1. Verify that the user account that is performing this procedure is a member of the dbcreator fixed server role on the database server where each database is stored.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ldf, and .ndf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each content database that you are moving.

7. To attach the content databases to the web application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. In Central Administration, in the Application Management section, click Manage Content databases.

  3. On the Manage Content Databases page, click Add a content database.

  4. On the Add Content Database page, verify that the Web Application menu displays the correct web application.

  5. In the Server box, specify the database server that hosts the database.

  6. In the Database Name box, type the exact name of the transferred content database.

    Note:

    Verify that the name is correct. If it is not, a new database will be created.

  7. Specify the authentication method for the database, and then click OK.

  8. Repeat these steps for each database that you are adding. Be sure that you select the correct web application from the Web Application menu for each database.

8. To restart timer jobs by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. In Central Administration, in the Monitoring section, click Check Job Status.

  3. For each scheduled job that you disabled previously, click the job to open the Edit Timer Job page, click Enable, and then click OK.

Moving content databases by using Windows PowerShell

Use the following procedure to move the content databases in your SharePoint 2013 farm by using Windows PowerShell.

Note:

The procedures in this section use Windows PowerShell to move content databases. However when you perform the following procedures, you must use the correct tool:

  • 4. To detach the content databases from SQL Server ─ SQL Server tools

  • 5. To move the content databases to a new location ─ Windows Explorer

  • 6. To attach the content databases to the new instance of SQL Server ─ SQL Server tools

Note:

If you are moving a content database to a different farm, you must make the server farm account a member of the Administrators group on the database server during the restore process. This enables the account to replicate the security setting for the databases. This access level can be removed after the content database is moved.

The destination farm must be running the same version or a later version of SharePoint 2013 than the source farm is running.

1. To record which content databases are associated with each web application

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • The dbcreator and securityadmin fixed server roles on the destination server, in order to attach the database and configure SQL Server logins.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPContentDatabase -WebApplication <http://SiteName>

    Where:

    • <http://SiteName> is the URL of the web application.

For more information, see Get-SPContentDatabase

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

2. To pause timer jobs by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • The dbcreator and securityadmin fixed server roles on the destination server, in order to attach the database and configure SQL Server logins.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPTimerJob -webapplication <http://WebApplicationURL> | select name | Out-File <c:\timerjobfile.txt> -Append -Encoding ascii

ForEach($tmrjob in (Get-Content <c:\timerjobfile.txt>)) { Get-SPTimerJob -Identity $tmrjob | Disable-SPTimerjob }

    Where:

    • <http://WebApplicationURL> is the Web application associated with the content database that you are moving.

    • <c:\timerjobfile.txt> is the location of the file that you are creating that lists all timer jobs associated with the Web application.

For more information, see Get-SPTimerJob, Out-File, ForEach-Object, Get-Content, and Disable-SPTimerJob.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

3. To detach content databases from a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • The dbcreator and securityadmin fixed server roles on the destination server, in order to attach the database and configure SQL Server logins.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Dismount-SPContentDatabase "<ContentDB>"

    Where:

    • <ContentDB> is the name of the content database.

    Note:

    If you have multiple content databases that have the same name, you must use the content database GUID in this command instead of using the content database name. To retrieve the GUID of the content database, run the Get-SPContentDatabase cmdlet without arguments.

    For more information, see Dismount-SPContentDatabase and Get-SPContentDatabase.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

4. To detach the content databases from SQL Server

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role on the database server where each database is stored.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the content database, point to Tasks, and then click Detach. Repeat this step for each content database that you want to move.

    Note:

    Use this procedure to move only content databases. Do not detach any other kinds of databases.

5. To move the content databases to a new location

  1. Verify that the user account that is performing this procedure has Write access to both the source and destination folders.

  2. Using Windows Explorer, locate the .mdf, .ldf, and .ndf files for the content databases.

  3. Select the .mdf, .ldf, and .ndf files for the database that you want to move and either copy or move them to the destination directory.

6. To attach the content databases to the new instance of SQL Server

  1. Verify that the user account that is performing this procedure is a member of the dbcreator fixed server role on the database server where each database is stored.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ldf, and .ndf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each content database that you are moving.

7. To attach content databases from a web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • The dbcreator and securityadmin fixed server roles on the destination server, in order to attach the database and configure SQL Server logins.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Mount-SPContentDatabase "<ContentDB>" -DatabaseServer "<DBServer>" -WebApplication <http://SiteName>

    Where:

    • <ContentDB> is the name of the content database to be attached.

    • <DBServer> is the name of the database server.

    • <http://SiteName> is the URL of the Web application to which the content database is being attached.

    For more information, see Dismount-SPContentDatabase.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

8. To restart timer jobs by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • The dbcreator and securityadmin fixed server roles on the destination server, in order to attach the database and configure SQL Server logins.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ForEach($tmrjob in (Get-Content <c:\timerjobfile.txt>)) {Get-SPTimerJob -Identity $tmrjob | Enable-SPTimerjob}

    Where:

    • <c:\timerjobfile.txt> is the location of the file that you created that lists all of the timer jobs associated with the Web application.

    For more information, see Get-SPTimerJob, ForEach-Object, Get-Content, and Enable-SPTimerJob.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Move all databases in SharePoint 2013

Summary: Learn how to move all databases associated with SharePoint 2013 to a new database server.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can use the SharePoint Central Administration website, or SQL Server tools to move all databases that are associated with SharePoint 2013 to a new database server.

Before you begin

The procedures in this article explain how to move the following kinds of databases that are hosted on a single database server:

  • Configuration database

  • Central Administration content database

  • Content databases

  • Service application databases

The following are the minimum permissions that are required to perform this process:

  • You must be a member of the Farm Administrators SharePoint group.

  • On the computer that is running the SharePoint Central Administration Web site, you must be a member of the Administrators group.

  • On the database server from which the databases are being moved, you must be a member of the following:

    • The Administrators group

    • The db_backupoperator fixed database role

  • On the database server to which the databases are being moved, you must be a member of the following:

    • The Administrators group

    • The db_owner fixed database role

In some environments, you must coordinate the move procedures with the database administrator. Be sure to follow applicable policies and guidelines for managing databases.

Important:

When you move databases, all farm sites and assets are unavailable to users until the process is complete. Try to complete this operation outside normal business hours.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Move all databases

To move all databases from one database server to another database server, you have to work in both SharePoint 2013 and SQL Server.

Before you begin this operation, review the steps in this process:

  1. Prepare the new database server.

  2. Close all open SharePoint Management Shell windows.

  3. Stop all services that are related to SharePoint 2013 and Internet Information Services (IIS).

  4. Detach the databases from the current SQL Server instance.

  5. Copy or move all files that are associated with the databases (.mdf, .ndf, and .ldf), to the new destination server that runs SQL Server.

  6. Make sure that all of the SQL Server logins, fixed server roles, fixed database roles, and permissions for the databases are configured correctly on the new destination database server.

  7. Attach the databases to the new destination server that runs SQL Server.

  8. Use SQL Server connection aliases to point to the new database server and update all web servers.

  9. Restart all services that you stopped in step 3.

To prepare the new database server

  • Use the procedures in Configure SQL Server security for SharePoint 2013 environments to configure the new database server.

    Note:

    The new database server must run the same version of Windows Server and SQL Server as the existing database server.

To close all open sessions of SharePoint Management Shell

  1. Close all open SharePoint Management Shell windows, and all open command prompt windows.

To stop the farm

  1. On the server that is running the SharePoint Central Administration website, in the Services snap-in, stop the following services:

    • SharePoint 2013 Administration

    • SharePoint 2013 Timer

    • SharePoint 2013 Tracing

    • SharePoint 2013 User Code Host

    • SharePoint 2013 VSS Writer

    • World Wide Web Publishing Service

    • SharePoint Server Search

  2. On the server that is running the SharePoint Central Administration website, at a command prompt, type iisreset /stop.

To detach databases

  1. In SQL Server Management Studio on the original database server, detach the databases that you want to move from the instance to which they are attached. If you are running many databases, you may want to run a Transact-SQL script to detach databases.

    Note:

    A database cannot be detached if any one of the following is true:

    • The database is being mirrored.

    • A database snapshot exists on the database.

    For more information, see:

    • Detaching and Attaching Databases

    • How to: Detach a Database (SQL Server Management Studio)

    • sp_detach_db (Transact-SQL)

To move database files to the new server

  1. Verify that the user account that is performing this procedure is a member of the following:

    • On the database server from which the databases are being moved, you must be a member of the following:

      • The Administrators group

      • The db_backupoperator fixed database role

    • On the database server to which the databases are being moved, you must be a member of the following:

      • The Administrators group

      • The db_owner fixed database role

  2. Use Windows Explorer to locate the .mdf, .ldf, and .ndf files that are associated with each database that you are moving.

  3. Copy or move the files to the destination directory on the new computer that is running SQL Server.

To set up permissions on the new server

  1. Verify that the user account that is performing this procedure is a member of the following:

    • The Administrators group

    • The db_owner fixed database role

  2. On the destination database server, start SQL Server Management Studio and transfer your logon credentials and permissions from the original instance to the destination instance. We recommend that you transfer permissions by running a script. An example script is available in Knowledge Base article 918992: How to transfer the logins and the passwords between instances of SQL Server 2005.

    For more information about how to transfer SQL Server metadata between instances, see the SQL Server Books Online article Managing Metadata When Making a Database Available on Another Server Instance.

To attach databases to the new instance of SQL Server

  1. Verify that the user account that is performing this procedure is a member of the following:

    • The Administrators group

    • The db_owner fixed database role

  2. On the destination database server, attach the databases to the new instance. For more information, see How to: Attach a Database (SQL Server Management Studio) and sp_attach_db (Transact-SQL).

To point the web application to the new database server by setting up SQL Server connection aliases

  1. Verify that the user account that is performing this procedure is a member of the following:

    • The Administrators group

    • The db_owner fixed database role

  2. On the Start menu, point to All Programs, point to Microsoft SQL Server 2008 R2, point to Configuration Tools, and then click SQL Server Configuration Manager.

    Note:

    If SQL Server Configuration Manager is not installed, you must run SQL Server setup to install it.

  3. Expand SQL Native Client Configuration, right-click Aliases, and then click New Alias.

  4. In the Alias Name field, enter the name of the original SQL Server instance, for Protocol, verify that TCP/IP is selected, for Server, enter the name of the new server that is hosting the SharePoint 2013 databases, and then click OK.

  5. Repeat this procedure on each database server.

  6. Optional. If your environment relies on System Center 2012 - Data Protection Manager (DPM) or a third-party application that uses the Volume Shadow Copy Service framework for backup and recovery, you must install the SQL Server connectivity components on each web server or application server by running SQL Server setup. For more information, see How to: Install SQL Server 2008 R2 (Setup).

To restart the services in the farm

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the server that is running the SharePoint Central Administration website, at a command prompt, type iisreset /start.

  3. In the Microsoft Management Console Services snap-in, start all of the services that are related to SharePoint 2013 and IIS. These include the following services:

    • SharePoint 2013 Administration

    • SharePoint 2013 Timer

    • SharePoint 2013 Tracing

    • SharePoint 2013 User Code Host

    • SharePoint 2013 VSS Writer

    • World Wide Web Publishing Service

    • SharePoint Server Search


Run a farm that uses read-only databases in SharePoint 2013

Summary: Learn how to run a read-only SharePoint 2013 farm with some or all databases set as read-only.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can use Windows PowerShell or SQL Server tools to set your SharePoint 2013 databases to read-only. The tool that you use depends on the kind of environment that you have deployed, your schedule requirements, and service level agreements that you have made with your organization.

In this article:

  • Before you begin

  • Prepare users for the read-only experience

    • Sites that use read-only content databases

    • Farms that use read-only service application databases

  • Set content databases to read-only

    • To determine the content database that is associated with a site collection by using Windows PowerShell

    • To set content databases to read-only by using SQL Server

  • Set service application databases to read-only

    • To set service application databases to read-only by using SQL Server

Before you begin

Before you begin this operation, review the following information about the settings that make a read-only farm.

A farm is considered read-only if one of the following is true:

  • All content databases are set to read-only.

  • Service application databases are set to read-only.

    Note:

    The Search service application does not function when its databases are set as read-only.

The functionality and user experience in a read-only farm depends on the databases that are set to read-only.

Note:

A farm that uses read-only content and service application databases is likely to be part of a disaster recovery environment or a highly available maintenance, update, or upgrade environment.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Prepare users for the read-only experience

If you plan to give users access to a read-only site or farm, you should set expectations for tasks that users can complete on the site and the behavior of the user interface (UI).

Sites that use read-only content databases

The user experience of a site that uses a content database that is set to read-only is characterized by the following:

  • A statement at the top of the home page states that the site is read-only.

  • Common tasks that do not require writing to the content database are fully available.

  • Common tasks that require writing to the content database are not available either because the UI for the task is not available or because the user cannot apply changes to complete the task.

  • Some common tasks that require writing to the content database and that appear to be available return errors.

Farms that use read-only service application databases

The user experience on a farm that uses service application databases that are set to read-only is characterized by the following:

  • Common tasks that do not require writing to the service databases are fully available.

  • All common tasks that require writing to the service databases and that appear to be available return errors.

Set content databases to read-only

Before you set content databases to read-only, you may need to determine the content database that is associated with a particular site collection.

To determine the content database that is associated with a site collection by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPContentDatabase -Site <Site URL>

    Where:

    • <Site URL> is the site collection URL for which you want to know the associated content database.

      The command returns the content database that is associated with the site.

For more information, see Get-SPContentDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

You can follow these steps to set read/write content databases to be read-only by using SQL Server Management Studio. You can also use the Transact-SQL ALTER DATABASE statement to set content databases to be read-only. For more information, see ALTER DATABASE (Transact-SQL).

Important:

Do not perform this procedure on databases in a failover environment that were log-shipped or mirrored. If a database in a failover environment that is either log-shipped or mirrored is set as read-only then no updates are performed and the backup is not valid.

To set content databases to read-only by using SQL Server

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role in each database.

  2. Start SQL Server Management Studio.

  3. Right-click the content database that you want to make read-only, and then click Properties.

  4. Select the Options page, and, in the Other options list, scroll to the State section.

  5. In the Database Read-Only row, click the arrow next to False, select True, and then click OK.

  6. Repeat for all other content databases.

    Note:

    When a database is set to read-only, all connections except the one that is setting the read-only flag are stopped. After the read-only flag is set, other connections are enabled.

The site collection that is associated with a read-only content database is automatically set to read-only if the locking status of the site collection was previously None, No Additions, or Read-Only. If the locking status of the site collection was previously No Access, it remains No Access when the database locking status is changed.

Set service application databases to read-only

It is possible to set any service application database to read-only. However, some service applications do not function when their databases are set to read-only, such as those that are associated with Search and Project Server.

To set service application databases to read-only by using SQL Server

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role in each database.

  2. Start SQL Server Management Studio.

  3. Right-click the database that you want to make read-only, and then click Properties.

  4. Select the Options page, and, in the Other options list, scroll to the State section.

  5. In the Database Read-Only row, click the arrow next to False, select True, and then click OK.

  6. Repeat for other service application databases as appropriate.

    Note:

    When a database is set to read-only, all connections except the one that is setting the read-only flag are stopped. After the read-only flag is set, other connections are enabled.


Rename service application databases in SharePoint 2013
See also

Summary: Learn how to rename SharePoint 2013 service application databases.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet and related resources provide information about renaming service application databases in SharePoint 2013.

You typically rename service application databases to remove the GUID from the database name after the SharePoint Products Configuration Wizard creates the databases. You might also rename service applications database to align the databases with your organization's naming standards.

TechNet articles about how to rename service application databases in SharePoint 2013

The following articles about how to rename service application databases in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Rename the App Management Service service application databases in SharePoint 2013 | Describes how to rename the App Management Service application databases in SharePoint 2013.
 | Rename the Business Data Connectivity service application databases in SharePoint Server 2013 | Describes how to rename the Business Data Connectivity applications databases in SharePoint Server 2013.
 | Rename the Managed Metadata Service service application databases in SharePoint Server 2013 | Describes how to rename the Managed Metadata Service application databases in SharePoint Server 2013.
 | Rename the PerformancePoint Services service application databases in SharePoint Server 2013 | Describes how to rename the PerformancePoint Services application databases in SharePoint Server 2013.
 | Rename the Search service application databases in SharePoint 2013 | Describes how to rename the Search service application databases in SharePoint 2013.
 | Rename the Secure Store Service service application databases in SharePoint 2013 | Describes how to rename the Secure Store Service application databases in SharePoint 2013.
 | Rename the SharePoint Translation Services service application databases in SharePoint Server 2013 | Describes how to rename the SharePoint Translation Services application databases in SharePoint Server 2013.
 | Rename the State Service service application databases in SharePoint Server 2013 | Describes how to rename the State Service application databases in SharePoint Server 2013.
 | Rename the Usage and Health Data Collection service application databases in SharePoint 2013 | Describes how to rename the Usage and Health Data Collection service application databases in SharePoint 2013.
 | Rename the Word Automation Services service application databases in SharePoint Server 2013 | Describes how to rename the Word Automation Services application databases in SharePoint Server 2013.
 | Rename the Microsoft SharePoint Foundation Subscription Settings Service service application databases in SharePoint 2013 | Describes how to rename the Microsoft SharePoint Foundation Subscriptions Settings Service application databases in SharePoint 2013.
 | Rename the User Profile service application databases in SharePoint Server 2013 | Describes how to rename the User Profile service application databases in SharePoint Server 2013
 | Rename the PowerPivot Service service application databases in SharePoint Server 2013 | Describes how to rename the PowerPivot service application databases in SharePoint Server 2013

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Rename the App Management Service service application databases in SharePoint 2013
See also

Summary: Learn how to rename the App Management Service service application databases in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can rename the App Management Service application databases by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

In this article:

  • Before you begin

  • Rename the App Management Service application databases by using SQL Server

  • Point the App Management service application to a renamed or moved database

Before you begin

Renaming service application databases is typically done to remove the GUID from the database name after the databases were created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

The general process for renaming or moving service application databases is as follows:

  1. Rename the database by using SQL Server tools.

  2. Point the service application to the renamed database.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account, or accounts, performing the operations, you must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Rename the App Management Service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM - Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the App Management Service application database by using SQL Server Management Studio

  1. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  2. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Point the App Management service application to a renamed or moved database

You can point the App Management service application to a renamed or moved database by using Central Administration or Windows PowerShell.

Note:

You do not have to stop the App Management service before pointing to a renamed or moved database. However, stopping the App Management service will not cause a problem if you choose to do this.

To point the App Management Service application to a renamed database by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, under System Settings, click Manage services on server.

  3. In the Service list, next to the App Management service, click Stop.

  4. In the Quick Launch, click Application Management.

  5. On the Application Management page, click Manage service applications.

  6. On the Manage Service applications page, click the empty area in the row next to the App Management Service name. The ribbon becomes active.

    Note:

    You must click the empty area to activate the ribbon on the Manage Service applications page. If you click App Management Service, the settings page opens for this service application.

  7. Click Properties on the ribbon.

    The Edit App Management Service Application dialog box appears.

  8. Change the database server or database name, and then click OK.

  9. In the Quick Launch, click System Settings.

  10. On the System Settings page, under Servers, click Manage services on server.

  11. In the Service list, next to the App Management Service, click Start.

To point the App Management Service application to a renamed database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $app = Get-SPServiceApplication | where {$_.displayname -match "<AppManagementServiceName>"

    Copy code
    $db = Get-SPScaleOutDatabase -ServiceApplication $app |where {$_.Name -match "<OriginalDatabaseName>"

    Where:

    • <AppManagementServiceName> is the name of the App Management Service application that you want to rename.

    • <OriginalDatabaseName is the original name of the App Management Service application database that you want to rename.

  4. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Remove-SPScaleOutDatabase -ServiceApplication $app -Database $db
Add-SPScaleOutDatabase -ServiceApplication $app -Database <NewDatabaseName>

    Where:

    • <NewDatabaseName> is the new name of the App Management Service application database.

For more information, see Get-SPServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Deploy by using DBA-created databases (SharePoint 2013 Preview)


Rename the Business Data Connectivity service application databases in SharePoint Server 2013
See also

Summary: Learn how to rename the Business Data Connectivity service application databases in SharePoint Server 2013.

Applies to: SharePoint Server 2013

You typically rename service application databases to remove the GUID from the database name after the databases were created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can rename a Business Data Connectivity service database by using SQL Server tools.

Important:

The steps in this article apply only to SharePoint Server 2013.

In this article:

  • Accessibility

  • Renaming the service application databases by using SQL Server

    • To stop the service application

    • To rename a database by using SQL Server Management Studio

  • Pointing the Business Data Connectivity service application to a renamed or moved database

    • To document service application settings

    • To delete the service application by using Central Administration

    • To re-create the service application

    • To restart a service application

Accessibility

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Renaming the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. On the database servers on which the operations are performed, you must be a member of the following:

    • Administrators group on the local server

    • db_owner fixed database role

      In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename a database by using SQL Server Management Studio

  1. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  2. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Pointing the Business Data Connectivity service application to a renamed or moved database

The only method for pointing a Business Data Connectivity service service application to a renamed or moved database is to delete the service application and then re-create the service application. When you re-create the Business Data Connectivity service service application, use the new database name.

This method includes first documenting the Business Data Connectivity service service application settings and then deleting the service application. Next, re-create the Business Data Connectivity service service application and use the new database name. Finally, restart the service application.

To document service application settings

  1. Before you delete and re-create a service application, document the settings for the service application. To do this, use the recommended Windows PowerShell cmdlets that are described in the article Document farm configuration settings in SharePoint 2013.

To delete the service application by using Central Administration

  1. Verify that the user account that is performing this operation is a member of the Farm Administrators SharePoint group.

    Note:

    Do not delete the Business Data Connectivity service application database.

  2. On the the SharePoint Central Administration website, click Application Management, and then click Manage service applications.

  3. On the Manage service applications page, click the row that contains the Business Data Connectivity service application that you want to delete. The ribbon becomes available.

  4. On the ribbon, click Delete.

  5. In the Delete Service Application dialog box, make sure that the check box next to Delete data associated with the Service Applications is not checked.

    Note:

    If you check this box, it deletes the Business Data Connectivity service application database.

  6. Click OK to delete the Business Data Connectivity service application.

To re-create the service application

  1. Re-create the Business Data Connectivity service service application, pointing it to the renamed database, and reusing all the other initial configuration settings.

  2. Depending on the service application, you may have to manually start the related service.

To restart a service application

  1. In Central Administration, under System Settings, click Manage services on server.

  2. In the Service list, next to the Business Data Connectivity service, click Start.

See also

Deploy by using DBA-created databases (SharePoint 2013 Preview)


Rename the Managed Metadata Service service application databases in SharePoint Server 2013
See also

Summary: Learn how to rename the Managed Metadata Service service application databases in SharePoint Server 2013.

Applies to: SharePoint Server 2013

You typically rename service application databases to remove the GUID from the database name after the databases were created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can rename the Managed Metadata service application databases by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools. Which backup tool you use depends on what kind of environment you have deployed, what your backup schedule requires, and what service level agreements you have made with your organization.

Important:

The steps in this article apply to SharePoint Server 2013 only.

In this article:

  • Before you begin

  • Renaming the service application databases by using SQL Server

    • To stop the Managed Metadata service application

    • To rename the databases by using SQL Server Management Studio

  • Pointing the Managed Metadata service application to a renamed or moved database

    • To point the Managed Metadata service application to a renamed or moved database by using Central Administration

    • To point the Managed Metadata service application to a renamed or moved database by using Windows PowerShell

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM - Management Studio Express.

  • On the database servers on which the operations are performed, you must be a member of the following:

    • Administrators group on the local server

    • db_owner fixed database role

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Renaming the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

To stop the Managed Metadata service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the databases by using SQL Server Management Studio

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role.

  2. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Pointing the Managed Metadata service application to a renamed or moved database

You can point the Managed Metadata service application to a renamed or moved database by using Central Administration or Windows PowerShell.

This procedure has the following steps integrated into them, and do not require that they have already been performed:

  1. Stopping a service application

  2. Renaming a database in SQL Server Management Studio

  3. Moving a database by using SQL Server Management Studio and Windows Explorer

To point the Managed Metadata service application to a renamed or moved database by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, under System Settings, click Manage services on server.

  4. In the Service list, next to the Managed Metadata service, click Stop.

  5. In the Quick Launch, click Application Management.

  6. On the Application Management page, click Manage service applications.

  7. On the Manage Service applications page, click the empty area in the row next to Managed Metadata Service. The ribbon becomes active.

    Note:

    You must click the empty area to enable the ribbon on the Manage Service applications page. If you click Managed Metadata Service Application, the Term Store Management Tool page opens for this service application.

  8. Click Properties on the ribbon.

  9. The Edit Managed Metadata Service dialog box appears.

  10. Change the database server or database name, and then click OK.

  11. In the Quick Launch, click System Settings.

  12. On the System Settings page, under Servers, click Manage services on server.

  13. In the Service list, next to Managed Metadata Web Service, click Start.

To point the Managed Metadata service application to a renamed or moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $app = Get-SPServiceApplication -Name "<ServiceApplicationName>"
Set-SPMetadataServiceApplication -Identity $app -DatabaseName "<DatabaseName>"

    Where:

    • <ServiceApplicationName> is the name of the Managed Metadata service application.

    • <DbName> is the name of the renamed database.

See also

Deploy by using DBA-created databases (SharePoint Server 2013 Preview)


Rename the PerformancePoint Services service application databases in SharePoint Server 2013

Summary: Learn how to rename the PerformancePoint Services in SharePoint Server 2013.

Applies to: SharePoint Server 2013

You typically rename service application databases to remove the GUID from the database name after the databases have been created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can rename the PerformancePoint Services service application databases by using SQL Server tools and Windows PowerShell.

Important:

The steps in this article apply only to SharePoint Server 2013.

In this article:

  • Before you begin

  • Renaming the service application databases by using SQL Server

    • To stop the service application

    • To rename the databases by using SQL Server Management Studio

  • Pointing the PerformancePoint service application to a renamed database

    • To point the PerformancePoint service application to a renamed or moved database by using Windows PowerShell

Before you begin

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM - Management Studio Express.

Important:

On the database servers on which the operations are performed, you must be a member of the following:

  • Administrators group on the local server

  • db_owner fixed database role

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Renaming the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the databases by using SQL Server Management Studio

  1. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  2. Right-click the database that you want to rename, in this case PerformancePoint Service Application<GUID>, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Pointing the PerformancePoint service application to a renamed database

You can point the PerformancePoint service application to a renamed or moved database by using Windows PowerShell.

Note:

The PerformancePoint service application cannot be deleted and then re-created to point to an existing database.

To point the PerformancePoint service application to a renamed or moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPPerformancePointServiceApplication -Identity "<ServiceApplicationName>" -SettingsDatabase "<OptionalServerName\DatabaseName>"<Type the appropriate cmdlet, including parameters and values, and enclose the values for the parameters in "placeholder" tags >

    Where:

    • <ServiceApplicationName> is the name of the PerformancePoint Services application.

    • <OptionalServerName\DatabaseName> is the location of and the name of the renamed or moved database. Do not include the location if you are just renaming the database.

For more information, see Set-SPPerformancePointServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Rename the Search service application databases in SharePoint 2013
See also

Updated: August 20, 2013

Summary: Learn how to rename the Search service application databases in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You typically rename service application databases to remove the GUID from the name of the database after the SharePoint Products Configuration Wizard creates the databases or to make the names of databases comply your organization's naming standards.

Note:

To rename the Search service application databases, you must move them to a new location on the same database server and then rename them. Then you point to the renamed databases in the new locations.

In this article:

  • Before you begin

  • Move and rename the Search service application databases

    • To pause the Search service application by using Windows PowerShell

    • To change the read-only mode for Search service application databases

    • To rename and back up the Search service application databases

    • To set the max degree of parallelism to 1 in the new server that hosts SQL Server

    • To restore the Search service application databases to a new database server

    • To set the Search service application databases to read/write

  • Point the Search service application to renamed and moved databases

    • To point the Search service application to the renamed and moved databases by using Windows PowerShell 3.0

Before you begin

On the database servers on which you perform the operations, you must be a member of the following:

  • Administrators group on the server on which you are running the Windows PowerShell cmdlets

  • Farm Administrators SharePoint group

  • db_owner fixed database role for all of the databases that you are renaming

  • db_creator and securityadmin roles

The Search service account must have the following rights and permissions:

  • db_owner database role on the Search Administration, Crawl, and Link databases

  • SPSearchDBAdmin database role membership on Analytics Reporting database

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow applicable policies and guidelines for managing databases.

Note:

If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Move and rename the Search service application databases

To move and rename the Search service application databases, you must use SQL Server, SQL Server Management Studio, and Windows Explorer. To point to the moved and renamed databases, you must use Windows PowerShell. Complete the following steps in the listed order.

  1. Pause the Search service application.

    Important:

    The Search service application must be paused until after the databases are restored in the new location and the service is pointed to the renamed and moved databases.

  2. Set all search databases to read-only.

    This is necessary to prevent new database transactions during the backup and restore process. Make sure to coordinate with the DBA and others so they know that no new indexing will occur when you run this procedure.

  3. Back up the Search service application databases but do not resume the Search service application.

    You can either rename the Search service databases while you back them up or you when your restore them.

  4. Enable the max degree of parallelism to 1 if you use a new instance of SQL Server.

  5. Rename and restore the Search service application databases to the new location on the same database server.

  6. Point the Search service application to the moved and renamed databases.

  7. Resume the Search service application.

To pause the Search service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the instance of SQL Server.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not displayed on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication <SearchServiceApplicationName>
Suspend-SPEnterpriseSearchServiceApplication -Identity $ssa

    Where:

    • <SearchServiceApplicationName> is the name of the Search service application associated with the database move.

To change the read-only mode for Search service application databases

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role for the content database.

  2. Open SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Set the following databases to read-only mode:

    • Search Administration

    • Analytics Reporting

    • Crawl

    • Link

    1. Right-click the database that you want to set to read/write or read-only, and then click Properties.

    2. In the Database Properties dialog box, on the Options properties page, in the State section, select True or False in the list next to Database Read-Only, and then click OK.

    3. Click Yes.

To rename and back up the Search service application databases

  1. Verify that the user account that performs this procedure is a member of the SQL Server db_backupoperator fixed database role on the database server where each database is stored.

  2. Start SQL Server Management Studio and connect to the database server where the Search service application databases are stored.

  3. In Object Explorer, expand Databases.

  4. Right-click the database to rename, and then click Rename. Enter the new name and then press Enter the new database name, and then click OK.

  5. Right-click the

    database that you want to back up, point to Tasks, and then click Back Up.

  6. In the Back Up Database dialog box, in the Source area, select the kind of backup that you want to perform from the Backup type list.

    For more information about the type of backup to use, see Recovery Models (SQL Server) in SQL Server Books Online.

  7. In the Backup component area, click Database.

  8. Either use the default name or specify a name for the backup set in the Name box.

  9. Specify the expiration date for the backup set.

    This date determines when the backup set can be overwritten by later backups that have the same name. By default, the backup set is set to never expire (0 days).

  10. In the Destination area, specify where you want to store the backup.

  11. Click OK to back up the database.

  12. Repeat steps 1-10 for the following databases:

    • Search Administration

    • Analytics Reporting

    • Crawl

    • Link

To set the max degree of parallelism to 1 in the new server that hosts SQL Server

  1. Start SQL Server Management Studio and connect to the new server that hosts SQL Server where you'll move the Search service application databases.

  2. In Object Explorer, right-click the database server and then click Properties.

  3. Click Advanced.

  4. In the Max Degree of Parallelism box, select 1 to limit the number of processors to use in parallel plan execution.

    For more information, see Configure the max degree of parallelism Server Configuration Option.

To restore the Search service application databases to a new database server

  1. Verify that the user account that you are using to restore the databases is a member of the SQL Server sysadmin fixed server role on the database server where each database is stored.

  2. Start SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Right-click the database that you want to restore, point to Tasks, point to Restore, and then click Database.

  5. In the Restore Database dialog box, on the General page, select the database to restore to from the To database list.

  6. Select the restore source from the From database list.

  7. In the Select the backup sets to restore section area, select the check box next to the database.

  8. On the Options tab, select the recovery state from the Recover state section.

    For more information about which recovery type to use, see Recovery Models (SQL Server) in SQL Server Books Online.

  9. Click OK to restore the database.

  10. Repeat steps 1-9 for each database that is associated with the service application.

To set the Search service application databases to read/write

  1. Follow the steps in To change the read-only mode for Search service application databases.

Point the Search service application to renamed and moved databases

You must use Windows PowerShell 3.0 to point to the renamed Search service application databases, Search Administration, Crawl, Link, and Analytics Reporting.

To point the Search service application to the renamed and moved databases by using Windows PowerShell 3.0

  1. Verify that you have the appropriate memberships that are listed in Before you begin.

  2. An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  3. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not displayed on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  4. Point the Search service application to the renamed Search Administration database at the new location. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication <SearchServiceApplicationName>
$ssa | Set-SPEnterpriseSearchServiceApplication [-DatabaseName "<NewDbName>"] -DatabaseServer "<NewServerName>"

    Where:

    • <SearchServiceApplicationName> is the name of the Search service application where the service is installed.

    • <NewDbName> is the name of the database.

  5. Point the Search service application to the renamed Analytics Reporting database at the new location. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    Add-SPServerScaleOutDatabase -ServiceApplication $ssa -DatabaseServer <NewServerName> [-DatabaseName <NewDbName>]
$temp = Get-SPServerScaleOutDatabase -ServiceApplication $ssa
Remove-SPServerScaleOutDatabase -Database $temp[0] -ServiceApplication $ssa

    Where:

    • <NewDbName> is the name of the database.

  6. Point the Search service application to the renamed Crawl database at the new location. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $CrawlDatabase0 = ([array]($ssa | Get-SPEnterpriseSearchCrawlDatabase))[0]
$CrawlDatabase0 | Set-SPEnterpriseSearchCrawlDatabase [-DatabaseName "<NewDbName>"] -DatabaseServer "<NewServerName>"

    Where:

    • <NewDbName> is the name of the database.

  7. Point the Search service application to the renamed Link database at the new location. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $LinksDatabase0 = ([array]($ssa | Get-SPEnterpriseSearchLinksDatabase))[0]
$LinksDatabase0 | Set-SPEnterpriseSearchLinksDatabase [-DatabaseName "<NewDbName>"] -DatabaseServer "<NewServerName>"

    Where:

    • <NewDbName> is the name of the database.

  8. Set all instances of the Search service to Online. Run the following commands for each Search service application in the farm, until the instance of the Search service is reported as Online. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    get-SPEnterpriseSearchServiceInstance -Identity <Search Server> Do {write-host -NoNewline .;Sleep 10; $searchInstance = Get-SPEnterpriseSearchServiceInstance -Identity <Search Server>} while ($searchInstance.Status -ne "Online")

    Where:

    • <Search Server> is the name of each server that hosts a Search component.

  9. Resume the Search service application. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication <SearchServiceApplicationName>
Resume-SPEnterpriseSearchServiceApplication -Identity $ssa

    Where:

    • <SearchServiceApplicationName> is the name of each server that hosts a Search component.

For more information, see Set-SPEnterpriseSearchServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Database types and descriptions (SharePoint 2013)
Manage the search topology in SharePoint Server 2013
Move the Search service application databases in SharePoint 2013

Windows PowerShell for SharePoint 2013 IT pros

Change History

Date | Description
August 20, 2013 | Updated procedures in the Move and rename the Search service application databases section.
August 13, 2013 | Updated the procedures in the Move and rename the Search service application databases section.
July 16, 2012 | Initial publication


Rename the Secure Store Service service application databases in SharePoint 2013

Summary: Learn how to rename the Secure Store Service service application databases in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Renaming service application databases is typically done to remove the GUID from the database name after the databases have been created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can use the SharePoint Central Administration website and SQL Server tools to stop the service, rename the databases, and then point to the renamed databases.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

In this article:

  • Before you begin

  • Rename the service application databases by using SQL Server

    • To stop the service application

    • To rename the databases by using SQL Server Management Studio

  • Point the Secure Store service application to a renamed or moved database

    • To point the Secure Store service application to a renamed or moved database by using Central Administration

Before you begin

The general process for renaming or moving service application databases is as follows:

  1. Rename the database by using SQL Server tools.

  2. Point the service application to the renamed database.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

On the database servers on which the operations are performed, you must be a member of the following:

  • Administrators group on the local server

  • db_owner fixed database role

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Rename the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM - Management Studio Express.

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the databases by using SQL Server Management Studio

  1. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  2. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Point the Secure Store service application to a renamed or moved database

You can point the Secure Store service application to a renamed or moved database by using Central Administration. Or, you can rename or move the database, and then delete or re-create the service application. If you choose to delete and re-create the service application, you must use the same passphrase that you used when you first configured the service application.

To point the Secure Store service application to a renamed or moved database by using Central Administration

  1. Verify that the user account that is performing this task is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, under System Settings, click Manage services on server.

  3. In the Service list, next to the Secure Store service, click Stop.

  4. In the Quick Launch, click Application Management.

  5. On the Application Management page, click Manage service applications.

  6. Click the Secure Store Service service application. The ribbon becomes active.

  7. Click Properties on the ribbon.

  8. The Edit Secure Store Service Application page opens.

  9. Change the database name or database server, and then click OK.

    Note:

    If you use an incorrect name, SharePoint 2013 creates a new database.

  10. In the Quick Launch, click System Settings.

  11. On the System Settings page, under Servers, click Manage services on server.

  12. In the Service list, next to the Secure Store service, click Start.


Rename the SharePoint Translation Services service application databases in SharePoint Server 2013

Summary: Learn how to rename the SharePoint Translation Services service application databases in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Renaming service application databases is typically done to remove the GUID from the database name after the databases have been created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can use the SharePoint Central Administration website and SQL Server tools to stop the service, rename the databases, and then point to the renamed databases.

Important:

The steps in this article only apply to SharePoint Server 2013.

In this article:

  • Before you begin

  • Rename the service application databases by using SQL Server

    • To stop the service application

    • To rename the databases by using SQL Server Management Studio

  • Point the service application to a renamed or moved database

    • To point the SharePoint Translation service application to a renamed or moved database by using Central Administration

Before you begin

The general process for renaming or moving service application databases is as follows:

  1. Rename the database by using SQL Server tools.

  2. Point the service application to the renamed database.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

On the database servers on which the operations are performed, you must be a member of the following:

  • Administrators group on the local server

  • db_owner fixed database role

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Rename the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM - Management Studio Express.

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the databases by using SQL Server Management Studio

  1. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  2. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Point the service application to a renamed or moved database

You can point the SharePoint Translation Services service application to a renamed or moved database by using Central Administration.

To point the SharePoint Translation service application to a renamed or moved database by using Central Administration

  1. Verify that the user account that is performing the procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, click Application Management, and then, click Manage service applications.

  3. On the Service Applications page, place your cursor next to SharePoint Translation Services and then click the empty row.

    The ribbon becomes active.

  4. In the Operations group of the ribbon, click Properties.

    The Edit SharePoint Translation Services Application page appears.

  5. Change the database name, and then click OK.

    Note:

    If you use an incorrect database name, SharePoint Server 2013 creates a new database.

  6. In the Quick Launch, click System Settings.

  7. On the System Settings page, in the Servers section, click Manage services on server.

  8. In the Service list, next to the SharePoint Translation Services, click Start.


Rename the State Service service application databases in SharePoint Server 2013

Summary: Learn how to rename the State Service service application databases in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Renaming service application databases is typically done to remove the GUID from the database name after the databases have been created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards. You can rename the State Service application databases by using SQL Server tools and Windows PowerShell.

Important:

The steps in this article apply to SharePoint Server 2013only.

In this article:

  • Before you begin

  • Renaming the service application databases by using SQL Server

    • To stop the service application

    • To rename the databases by using SQL Server Management Studio

  • Pointing the State Service service application to a renamed or moved database

    • To add a new database to the State Service application and remove an old database by using Windows PowerShell

    • To point the State Service application to a renamed or moved database by using Windows PowerShell

Before you begin

Important:

On the database servers on which the operations are performed, you must be a member of the following:

  • Administrators group on the local server

  • db_owner fixed database role

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM - Management Studio Express.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Renaming the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the databases by using SQL Server Management Studio

  1. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  2. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Pointing the State Service service application to a renamed or moved database

The State Service database stores temporary data, state information, for InfoPath Forms Services, Exchange Server, the chart Web Part, and Visio Services. You can use Windows PowerShell to point the State Service service application to a renamed or moved database by performing one of the following procedures:

  • Add a new database in the new location, or create a database with a new name. Then add the new database to the service application, and delete the old database. For details, see To add a new database to the State Service application and remove an old database by using Windows PowerShell.

  • Dismount the old database, rename or move it by using SQL Server, and then remount the State Service database. For details, see To point the State Service application to a renamed or moved database by using Windows PowerShell.

    The following procedures have the following steps integrated into them. Therefore, they do not require that the steps have already been performed:

    • Stopping a service application

    • Renaming a database in SQL Server Management Studio

    • Moving a database by using SQL Server Management Studio and Windows

To add a new database to the State Service application and remove an old database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SPStateServiceDatabase -Name "<NewDatabaseName>"

    Then type the following command to remove the old database:

    Copy code
    Remove-SPStateServiceDatabase -Name "<OldDatabaseName>"

    Where:

    • <NewDatabaseName> is the name of the new database that you want to create.

    • <OldDatabaseName> is the name of the old database that you want to disassociate with the State service and detach from SQL Server.

For more information, see New-SPStateServiceDatabase and Remove-SPStateServiceDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

To point the State Service application to a renamed or moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Dismount-SPStateServiceDatabase -Identity <DatabaseID>

    Where:

    • <DatabaseID> is the State Service database to remove from the service application.The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a state database, or an instance of a valid SPStateServiceDatabase object.

  6. Rename the database. For details, see To rename the databases by using SQL Server Management Studio.

  7. At the Windows PowerShell command prompt, type the following command to mount the renamed database:

    Copy code
    Mount-SPStateServiceDatabase -Name "<DatabaseName>" -DatabaseServer "<ServerName>"

    Where:

    • <DatabaseName> is the name of the database to associate with the State service.

    • <ServerName> is the name of the SQL Server that hosts the State service database.

For more information, see Mount-SPStateServiceDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Rename the Usage and Health Data Collection service application databases in SharePoint 2013

Summary: Learn how to rename the Usage and Health Data Collection service application databases in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Renaming service application databases is typically done to remove the GUID from the database name after the databases have been created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can rename the Usage and Health Data Collection databases by using the SharePoint Central Administration website, Windows PowerShell, and SQL Server tools.

In this article:

  • Before you begin

  • Renaming the service application databases by using SQL Server

    • To stop the service application

    • To rename the databases by using SQL Server Management Studio

  • Pointing the Usage and Health Data Collection service application to a renamed or moved database

    • To point the Usage and Health Data Collection service application to a renamed or moved database by using Central Administration

    • To point the Usage and Health data collection service application to a renamed or moved database by using Windows PowerShell

Before you begin

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express.

Important:

On the database servers on which the operations are performed, you must be a member of the following:

  • Administrators group on the local server

  • db_owner fixed database role

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Renaming the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the databases by using SQL Server Management Studio

  1. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  2. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Pointing the Usage and Health Data Collection service application to a renamed or moved database

You can use either Central Administration or Windows PowerShell to point the Usage and Health Data Collection service application to a renamed or moved database.

To point the Usage and Health Data Collection service application to a renamed or moved database by using Central Administration

  1. Verify that the user account that is performing the procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, click Monitoring, and then on the Monitoring page, click Configure usage and health data collection.

  4. The Configure web analytics and health data collection page appears.

  5. Clear the Enable health data collection check box, and then click OK.

    You return to the Monitoring page.

  6. Click Configure usage and health data collection to return to the Configure web analytics and health data collection page.

  7. Select the Enable health data collection check box.

  8. In the Logging Database Server section, specify the updated database server and database name, and then click OK.

To point the Usage and Health data collection service application to a renamed or moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPUsageApplication -Identity "<ServiceApplicationName>" -DatabaseName "<DbName>" -DatabaseServer "<SQLServerName>"

    Where:

    • <ServiceApplicationName> is the name of the usage and health data collection service application.

    • <DbName> is the name of the database.

    • <SQLServerName> is the name of the database server.

For more information, see Set-SPUsageApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Rename the Word Automation Services service application databases in SharePoint Server 2013

Summary: Learn how to rename the Word Automation Services service application databases in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Renaming service application databases is typically done to remove the GUID from the database name after the databases have been created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can rename the Word Automation Services service application databases by using the SharePoint Central Administration website, Windows PowerShell, or SQL Server tools.

Important:

The steps in this article apply to SharePoint Server 2013 only.

In this article:

  • Before you begin

  • Renaming the service application databases by using SQL Server

    • To stop the Word Automation service application

    • To rename the databases by using SQL Server Management Studio

  • Pointing the Word Automation service application to a renamed or moved database

    • To point the Word Automation service application to a renamed or moved database by using Central Administration

    • To point the Word Automation Services service application to a renamed or moved database by using Windows PowerShell

Before you begin

On the database servers on which the operations are performed, you must be a member of the following:

  • Administrators group on the local server

  • db_owner fixed database role

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Renaming the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM - Management Studio Express.

To stop the Word Automation service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the databases by using SQL Server Management Studio

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role.

  2. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Pointing the Word Automation service application to a renamed or moved database

You can point the Word Automation service application to a renamed or moved database by using Central Administration or Windows PowerShell.

This procedure has the following steps integrated into them, and do not require that they have already been performed:

  1. Stopping a service application

  2. Renaming a database in SQL Server Management Studio

  3. Moving a database by using SQL Server Management Studio and Windows Explorer

Note:

You do not need to stop the Word Automation service before pointing to a renamed or moved database. However, stopping the Word Automation service will not cause a problem if you choose to do this.

To point the Word Automation service application to a renamed or moved database by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, under System Settings, click Manage services on server.

  4. In the Service list, next to the Word Automation service, click Stop.

  5. In the Quick Launch, click Application Management.

  6. On the Application Management page, click Manage service applications.

  7. On the Manage Service applications page, click the empty area in the row next to the Word Automation Services name. The ribbon becomes active.

    Note:

    You must click the empty area to activate the ribbon on the Manage Service applications page. If you click Word Automation Services, the settings page opens for this service application.

  8. Click Properties on the ribbon.

    The Edit Word Automation Service Application dialog box opens.

  9. Change the database server or database name, and then click OK.

  10. In the Quick Launch, click System Settings.

  11. On the System Settings page, under Servers, click Manage services on server.

  12. In the Service list, next to the Word Automation service, click Start.

To point the Word Automation Services service application to a renamed or moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $app = Get-SPServiceApplication -Name "<ServiceApplicationName>"
Set-SPWordConversionServiceApplication -Identity $app -DatabaseName "<DatabaseName>"

    Where:

    • <ServiceApplicationName> is the name of the Word Automation service application.

    • <DbName> is the name of the renamed database.

For more information, see Set-SPUsageApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Rename the Microsoft SharePoint Foundation Subscription Settings Service service application databases in SharePoint 2013

Summary: Learn how to rename the Microsoft SharePoint Foundation Subscription Settings Service service application databases in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Renaming service application databases is typically done to remove the GUID from the database name after the databases have been created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can rename the Subscription Settings databases by using Windows PowerShell and SQL Server tools.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

In this article:

  • Before you begin

  • Renaming the service application databases by using SQL Server

    • To stop the Subscription Settings service application

    • To rename the databases by using SQL Server Management Studio

  • Pointing the Subscription Settings service application to a renamed or moved database

    • To point the Subscription Settings Services service application to a renamed or moved database by using Windows PowerShell

Before you begin

Before you begin this operation, review the following information.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM - Management Studio Express.

Important:

On the database servers on which the operations are performed, you must be a member of the following:

  • Administrators group on the local server

  • db_owner fixed database role

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Renaming the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

To stop the Subscription Settings service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the databases by using SQL Server Management Studio

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the local server and a member of the db_owner fixed database role.

  2. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Pointing the Subscription Settings service application to a renamed or moved database

You can use Windows PowerShell to point the Subscription Settings service application to a renamed or moved database.

To point the Subscription Settings Services service application to a renamed or moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the SharePoint 2013 Products cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPSubscriptionSettingsServiceApplication -Identity "<ServiceApplicationName>" -DatabaseName "<DatabaseName>" -DatabaseServer "<DatabaseServer>"

    Where:

    • <ServiceApplicationName> is the name of the Subscription Settings service application.

    • <DatabaseName> is the name of the renamed database.

    • <DatabaseServer> is the name of the renamed database.

For more information, see Set-SPSubscriptionSettingsServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Rename the User Profile service application databases in SharePoint Server 2013
See also

Published: October 16, 2012

Summary: Learn how to rename the User Profile service application databases in SharePoint Server 2013.

Applies to: SharePoint Server 2013

You typically rename service application databases to remove the GUID from the database name after the databases were created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can rename a Business Data Connectivity service database by using SQL Server tools.

Important:

The steps in this article apply only to SharePoint Server 2013.

In this article:

  • Accessibility

  • Renaming the service application databases by using SQL Server

    • To stop the service application

    • To rename a database by using SQL Server Management Studio

  • Pointing the service application to a renamed database

    • To document service application settings

    • To delete the service application by using Central Administration

    • To re-create the service application

    • To restart a service application

Accessibility

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Renaming the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 R2 RTM Management Studio Express.

To stop the service application

  1. On the database servers on which the operations are performed, you must be a member of the following:

    • Administrators group on the local server

    • db_owner fixed database role

      In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename a database by using SQL Server Management Studio

  1. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  2. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Pointing the service application to a renamed database

The only method for pointing a User Profile service application to a renamed database is to delete the service application and then re-create the service application. When you re-create the User Profile service application, use the new database name.

This method includes first documenting the User Profile service application settings and then deleting the service application. Next, re-create the User Profile service application and use the new database name. Finally, restart the service application.

To document service application settings

  1. Before you delete and re-create a service application, document the settings for the service application. To do this, use the recommended Windows PowerShell cmdlets that are described in the article Document farm configuration settings in SharePoint 2013.

To delete the service application by using Central Administration

  1. Verify that the user account that is performing this operation is a member of the Farm Administrators SharePoint group.

    Note:

    Do not delete the User Profile service application database.

  2. On the the SharePoint Central Administration website, click Application Management, and then click Manage service applications.

  3. On the Manage service applications page, click the row that contains the Business Data Connectivity service application that you want to delete. The ribbon becomes available.

  4. On the ribbon, click Delete.

  5. In the Delete Service Application dialog box, make sure that the check box next to Delete data associated with the Service Applications is not checked.

    Note:

    If you check this box, it deletes the User Profile service application database.

  6. Click OK to delete the User Profile service application.

To re-create the service application

  1. Re-create the User Profile service application, pointing it to the renamed database, and reusing all the other initial configuration settings.

  2. Depending on the service application, you may have to manually start the related service.

To restart a service application

  1. In Central Administration, under System Settings, click Manage services on server.

  2. In the Service list, next to the User Profile, click Start.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Rename the PowerPivot Service service application databases in SharePoint Server 2013
See also

Published: October 30, 2012

Summary: Learn how to rename the SQL Server 2012 PowerPivot for SharePoint 2013 service application databases in SharePoint 2013.

Applies to: SharePoint Server 2013

Renaming service application databases is typically done to remove the GUID from the database name after the databases have been created by the SharePoint Products Configuration Wizard, or to bring the databases into alignment with your organization's naming standards.

You can rename the Power Pivot for SharePoint 2013 databases by using the SharePoint Central Administration website and SQL Server tools.

In this article:

  • Before you begin

  • Renaming the service application databases by using SQL Server

    • To stop the service application

    • To rename the databases by using SQL Server Management Studio

  • Pointing the Power Pivot for SharePoint 2013 service application to a renamed or moved database

    • To point the Power Pivot for SharePoint 2013 service application to a renamed or moved database by using Central Administration

Before you begin

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express.

Important:

On the database servers on which the operations are performed, you must be a member of the following:

  • Administrators group on the local server

  • db_owner fixed database role

In some environments, you must coordinate the rename procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Renaming the service application databases by using SQL Server

To rename a service application database, you must use SQL Server. To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you rename or move the related database. In general, we expect that you will either rename or move a database. That is, you will typically not perform both actions.

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. For each service application that you plan to change the database for, you must stop the service or disable the service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To rename the databases by using SQL Server Management Studio

  1. In SQL Server Management Studio, connect to the source SQL Server instance, and then expand the Databases node.

  2. Right-click the database that you want to rename, click Rename, and then type the new name. Repeat this step for each database that you want to rename.

Pointing the Power Pivot for SharePoint 2013 service application to a renamed or moved database

You can use Central Administration to point the Power Pivot for SharePoint 2013 service application to a renamed or moved database.

To point the Power Pivot for SharePoint 2013 service application to a renamed or moved database by using Central Administration

  1. Verify that the user account that is performing the procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, click Application Management, and then, click Manage service applications.

  3. On the Service Applications page, place your cursor next to Power Pivot for SharePoint 2013 and then click the empty row.

    The ribbon becomes active.

  4. In the Operations group of the ribbon, click Properties.

    The Edit Power Pivot for SharePoint 2013 Application page appears.

  5. Change the database name, and then click OK.

    Note:

    If you use an incorrect database name, SharePoint Server 2013 creates a new database.

  6. In the Quick Launch, click System Settings.

  7. On the System Settings page, in the Servers section, click Manage services on server.

  8. In the Service list, next to the Power Pivot for SharePoint 2013, click Start.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move service application databases (SharePoint 2013)
See also

Published: October 16, 2012

Summary: Learn how to move SharePoint service application databases.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about how to move service application databases.

TechNet articles about how to move service application databases in SharePoint 2013

The following articles about how to move service application databases in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Move the App Management Service service application databases (SharePoint 2013) | Describes how to move the App Management Service application databases in SharePoint 2013.
 | Move the Business Data Connectivity service application databases in SharePoint Server 2013 | Describes how to rename the Business Data Connectivity applications databases in SharePoint Server 2013.
 | Move the Managed Metadata Service service application databases in SharePoint Server 2013 | Describes how to move the Metadata Service applications databases in SharePoint Server 2013.
 | Move the PerformancePoint service application databases in SharePoint Server 2013 | Describes how to move the PerformancePoint Services application databases in SharePoint Server 2013.
 | Move the Search service application databases in SharePoint 2013 | Describes how to move the Search service application databases in SharePoint 2013.
 | Move the Secure Store Service service application databases in SharePoint 2013 | Describes how to move the Secure Store Service application databases in SharePoint 2013.
 | Move the SharePoint Translation Services service application databases in SharePoint Server 2013 | Describes how to move the SharePoint Translation Services application databases in SharePoint Server 2013.
 | Move the State Service service application databases in SharePoint Server 2013 | Describes how to move the State Service application databases in SharePoint Server 2013.
 | Move the Usage and Health Data Collection service application databases in SharePoint 2013 | Describes how to move the Usage and Health Data Collection service application databases in SharePoint 2013.
 | Move the Word Automation Services service application databases in SharePoint Server 2013 | Describes how to move the Word Automation Services application databases in SharePoint Server 2013.
 | Move the Microsoft SharePoint Foundation Subscription Settings Services service application databases (SharePoint 2013) | Describes how to move the Microsoft SharePoint Foundation Subscriptions Settings Service application databases in SharePoint 2013.
 | Move the User Profile service application databases in SharePoint Server 2013 | Describes how to move the User Profile application databases in SharePoint Server 2013.
 | Move the PowerPivot Service service application databases in SharePoint Server 2013 | Describes how to move the PowerPivot Service application databases in SharePoint Server 2013.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the App Management Service service application databases (SharePoint 2013)

Published: September 4, 2012

Summary: Learn how to move the App Management Service service application database.

Applies to: SharePoint

This article describes how to move the App Management Service service application database. Moving service application databases to another farm database server, or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Point the App Management service application to a renamed or moved database

    • To point the App Management Service application to a renamed database by using Central Administration

    • To point the App Management Service application to a renamed database by using Windows PowerShell

Before you begin

Moving service application databases to another farm database server is typically done to load balance a system.

The general process for moving service application databases is as follows:

  1. Move the database by using SQL Server tools.

  2. Point the service application to the renamed database.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account, or accounts, performing the operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the App Management Service service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Point the App Management service application to a renamed or moved database

You can point the App Management service application to a renamed or moved database by using Central Administration or Windows PowerShell.

Note:

You do not have to stop the App Management service before pointing to a renamed or moved database. However, stopping the App Management service will not cause a problem if you choose to do this.

To point the App Management Service application to a renamed database by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, under System Settings, click Manage services on server.

  3. In the Service list, next to the App Management service, click Stop.

  4. In the Quick Launch, click Application Management.

  5. On the Application Management page, click Manage service applications.

  6. On the Manage Service applications page, click the empty area in the row next to the App Management Service name. The ribbon becomes active.

    Note:

    You must click the empty area to activate the ribbon on the Manage Service applications page. If you click App Management Service, the settings page opens for this service application.

  7. Click Properties on the ribbon.

    The Edit App Management Service Application dialog box appears.

  8. Change the database server or database name, and then click OK.

  9. In the Quick Launch, click System Settings.

  10. On the System Settings page, under Servers, click Manage services on server.

  11. In the Service list, next to the App Management Service, click Start.

To point the App Management Service application to a renamed database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs.

      2. Click Microsoft SharePoint 2013 Products.

      3. Click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      1. Right-click Computer.

      2. Click All apps.

      3. Click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $app = Get-SPServiceApplication | where {$_.displayname -match "<AppManagementServiceName>"

    Copy code
    $db = Get-SPScaleOutDatabase -ServiceApplication $app |where {$_.Name -match "<OriginalDatabaseName>"

    Where:

    • <AppManagementServiceName> is the name of the App Management Service application that you want to rename.

    • <OriginalDatabaseName> is the original name of the App Management Service application database that you want to rename.

  4. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Remove-SPScaleOutDatabase -ServiceApplication $app -Database $db
Add-SPScaleOutDatabase -ServiceApplication $app -Database <NewDatabaseName>

    Where:

    • <NewDatabaseName> is the new name of the App Management Service application database.

For more information, see Get-SPServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Move the Business Data Connectivity service application databases in SharePoint Server 2013
See also

Published: September 4, 2012

Summary: Learn how to move the Business Data Connectivity Service service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the Business Data Connectivity service service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Point the service application to a moved database

    • To document service application settings

    • To delete the service application by using Central Administration

    • To create the service application

    • To start the service application

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account, or accounts, performing the operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. To stop a service application, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Point the service application to a moved database

The method for pointing a service application to a moved database that works for most service applications is to delete the service application and then re-create the service application. When you re-create the service application, use the new name or new location.

To document service application settings

  • Before you delete and re-create a service application, document the settings for the service application. To do this, use the recommended Windows PowerShell cmdlets that are described in the article Document farm configuration settings in SharePoint 2013.

To delete the service application by using Central Administration

  • Verify that the user account that is performing the procedure is a member of the Farm Administrators SharePoint group.

  • In Central Administration, click Application Management, and then, click Manage service applications.

  • On the Service Applications page, place your cursor next to Business Data Connectivity service and then click the empty row.

    The ribbon becomes active.

  • On the ribbon, click Delete.

  • In the Delete Service Application dialog box, select the check box next to Delete data associated with the Service Applications if you want to delete the service application database. If you want to retain the database, leave this check box cleared.

  • Click OK to delete the service application, or click Cancel to stop the operation.

To create the service application

  • To create a Business Data Connectivity service application, follow the procedure in Create the Business Data Connectivity service application in SharePoint 2013.

To start the service application

  1. To start a service application, see Start or stop a service (SharePoint 2013).

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the Managed Metadata Service service application databases in SharePoint Server 2013
See also

Published: September 4, 2012

Summary: Learn how to move the Managed Metadata Service service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the Managed Metadata Service service application database. Moving service application databases to another farm database server, or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Pointing the Managed Metadata service application to a renamed or moved database

    • To point the Managed Metadata service application to a new database server by using Central Administration

    • To point the App Management Service application to a new database server by using Windows PowerShell

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint 2013 Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account, or accounts, performing the move operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and right permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the Managed Metadata Service service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Pointing the Managed Metadata service application to a renamed or moved database

You can point the Managed Metadata service application to a renamed or moved database by using either Central Administration or Windows PowerShell.

To point the Managed Metadata service application to a new database server by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, under System Settings, click Manage services on server.

  3. In the Service list, next to the Managed Metadata Web Service, click Stop.

  4. In the Quick Launch, click Application Management.

  5. On the Application Management page, click Manage service applications.

  6. On the Manage Service applications page, click the empty area in the row next to the Managed Metadata Service Application name. The ribbon becomes active.

    Note:

    You must click the empty area to activate the ribbon on the Manage Service applications page. If you click Managed Metadata Service Application, the settings page opens for this service application.

  7. Click Properties on the ribbon.

    The Create New Managed Metadata Service dialog box appears.

  8. Change the database server or database name, and then click OK.

  9. In the Quick Launch, click System Settings.

  10. On the System Settings page, under Servers, click Manage services on server.

  11. In the Service list, next to the Managed Metadata Web Service, click Start.

To point the App Management Service application to a new database server by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs.

      2. Click Microsoft SharePoint 2013 Products.

      3. Click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      1. Right-click Computer.

      2. Click All apps.

      3. Click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $app = Get-SPServiceApplication -Name "<ServiceApplicationName>"
Set-SPMetadataServiceApplication -Identity $app -DatabaseName "<DbName>"

    Where:

    • <ServiceApplicationName> is the name of the Managed Metadata service application.

    • <DbName> is the name of the renamed database.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the PerformancePoint service application databases in SharePoint Server 2013
See also

Published: September 4, 2012

Summary: Learn how to move the PerformancePoint Services in SharePoint Server 2013 service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the PerformancePoint Services service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Pointing the PerformancePoint service application to a renamed or moved database

    • To point the PerformancePoint service application to a renamed or moved database by using Windows PowerShell

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint 2013 Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account, or accounts, performing the operations, you must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and right permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the PerformancePoint Services service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Pointing the PerformancePoint service application to a renamed or moved database

You can point the PerformancePoint service application to a renamed or moved database by using Windows PowerShell.

Note:

The PerformancePoint service application cannot be deleted and then re-created to point to an existing database.

To point the PerformancePoint service application to a renamed or moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Record the PerformancePoint service application name and the database name that you plan to configure.

  3. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs.

      2. Click Microsoft SharePoint 2013 Products.

      3. Click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      1. Right-click Computer.

      2. Click All apps.

      3. Click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  4. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPPerformancePointServiceApplication -Identity "<ServiceApplicationName>" -SettingsDatabase "<OptionalServerName\DatabaseName>"

    Where:

    • <ServiceApplicationName> is the name of the PerformancePoint service application.

    • <OptionalServerName\DatabaseName> is the location of and the name of the renamed or moved database. Do not include the location if you are just renaming the database.

For more information, see Set-SPPerformancePointServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the Search service application databases in SharePoint 2013
See also

Updated: June 25, 2013

Summary: Learn how to move the Search service application databases in SharePoint 2013.

You can move service application databases to another farm database server or an instance of a database to balance the load of the system. The process involves the two main tasks: move the databases files and then point the service application to the moved database.

Note:

You can use the same procedures if you need to rename the Search service application database on the same database server.

In this article:

  • Before you begin

  • Move the Search service application databases

    • To pause the Search service application by using Windows PowerShell

    • To change the read-only mode for Search service application databases

    • To back up the Search service application databases

    • To set the max degree of parallelism to 1 in the new server that hosts SQL Server

    • To restore the Search service application databases to a new database server

    • To set the Search service application databases to read/write

  • Point the Search service application to the moved databases

    • To point the Search service application to moved databases by using Windows PowerShell

Before you begin

Note:

Administrators typically use the SharePoint 2013 Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account, or accounts, that perform the operations must have the following memberships and permissions:

  • Member of the Farm Administrators SharePoint group.

  • Member of the Administrators group on the local server.

  • Read permission on the source location and write permission on the target location.

  • db_owner fixed database role for all of the databases that you are moving.

  • db_creator and securityadmin roles for all of the databases that you are moving.

The Search Service account must have the following roles:

  • db_owner fixed database role on the Administration, Link, and Crawl databases.

  • SPSearchDBAdmin database role on the Analytics Reporting database.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow applicable policies and guidelines for managing databases.

Move the Search service application databases

To move the Search service application databases, you must use SQL Server, SQL Server Management Studio, and Windows Explorer. To point to the moved databases, you must use Windows PowerShell. Complete the following steps in the listed order.

  1. Pause the Search service application.

    Important:

    The Search service application must be paused until after the databases are restored in the new location and the service is pointed to the moved databases.

  2. Set all search databases to read-only.

    This is necessary to prevent new database transactions during the backup and restore process.

  3. Back up the Search service application databases but do not resume the Search service application.

  4. Enable the max degree of parallelism to 1 in the new SQL Server.

  5. Restore the Search service application databases to the new location.

  6. Point the Search service application to the moved databases.

  7. Resume the Search service application.

To pause the Search service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the instance of SQL Server.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not displayed on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication <SearchServiceApplicationName>
Suspend-SPEnterpriseSearchServiceApplication -Identity $ssa

    Where:

    • <SearchServiceApplicationName> is the name of the Search service application associated with the database move.

To change the read-only mode for Search service application databases

  1. Verify that the user account that is performing this procedure is a member of the db_owner fixed database role for the content database.

  2. Open SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Set the following databases to read-only mode:

    • Search Administration

    • Analytics Reporting

    • Crawl

    • Link

    1. Right-click the database that you want to set to read/write or read-only, and then click Properties.

    2. In the Database Properties dialog box, on the Options properties page, in the State section, select True or False in the list next to Database Read-Only, and then click OK.

    3. Click Yes.

To back up the Search service application databases

  1. Verify that the user account that performs this procedure is a member of the SQL Server db_backupoperator fixed database role on the database server where each database is stored.

  2. Start SQL Server Management Studio and connect to the database server where the Search service application databases are stored.

  3. In Object Explorer, expand Databases.

  4. Right-click the database that you want to back up, point to Tasks, and then click Back Up.

  5. In the Back Up Database dialog box, in the Source area, select the kind of backup that you want to perform from the Backup type list.

    For more information about the type of backup to use, see Recovery Models (SQL Server) in SQL Server Books Online.

  6. In the Backup component area, click Database.

  7. Either use the default name or specify a name for the backup set in the Name box.

  8. Specify the expiration date for the backup set.

    This date determines when the backup set can be overwritten by subsequent backups that have the same name. By default, the backup set is set to never expire (0 days).

  9. In the Destination area, specify where you want to store the backup.

  10. Click OK to back up the database.

  11. Repeat steps 1-10 for the following databases:

    • Search Administration

    • Analytics Reporting

    • Crawl

    • Link

To set the max degree of parallelism to 1 in the new server that hosts SQL Server

  1. Start SQL Server Management Studio and connect to the new server that hosts SQL Server where you'll move the Search service application databases.

  2. In Object Explorer, right-click the database server and then click Properties.

  3. Click Advanced.

  4. In the Max Degree of Parallelism box, select 1 to limit the number of processors to use in parallel plan execution.

    For more information, see Configure the max degree of parallelism Server Configuration Option.

To restore the Search service application databases to a new database server

  1. Verify that the user account that you are using to restore the databases is a member of the SQL Server sysadmin fixed server role on the database server where each database is stored.

  2. Start SQL Server Management Studio and connect to the database server.

  3. In Object Explorer, expand Databases.

  4. Right-click the database that you want to restore, point to Tasks, point to Restore, and then click Database.

  5. In the Restore Database dialog box, on the General page, select the database to restore to from the To database list.

  6. Select the restore source from the From database list.

  7. In the Select the backup sets to restore section area, select the check box next to the database.

  8. On the Options tab, select the recovery state from the Recover state section.

    For more information about which recovery type to use, see Recovery Models (SQL Server) in SQL Server Books Online.

  9. Click OK to restore the database.

  10. Repeat steps 1-9 for each database that is associated with the service application.

To set the Search service application databases to read/write

  1. Follow the steps in To change the read-only mode for Search service application databases.

Point the Search service application to the moved databases

You must use Windows PowerShell 3.0 to point to the moved Search service application databases: Search Administration, Crawl, Link, and Analytics Reporting.

To point the Search service application to moved databases by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the instance of SQL Server.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs.

      2. Click Microsoft SharePoint 2013 Products.

      3. Click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not displayed on the Start screen:

      1. Right-click Computer.

      2. Click All apps.

      3. Click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. Point the Search Administration database to the new location. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication <SearchServiceApplicationName>
$ssa | Set-SPEnterpriseSearchServiceApplication [-DatabaseName "<NewDbName>"] -DatabaseServer "<NewServerName>"

    Where:

    • <NewDbName> is the name of the database.

    • <NewServerName> is the new database location.

  4. Point the Analytics Reporting database to the new location. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    Add-SPServerScaleOutDatabase -ServiceApplication $ssa -DatabaseServer <NewServerName> [-DatabaseName <NewDbName>]
$temp = Get-SPServerScaleOutDatabase -ServiceApplication $ssa
Remove-SPServerScaleOutDatabase -Database $temp[0] -ServiceApplication $ssa

  5. Point the Crawl database to the new location. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $CrawlDatabase0 = ([array]($ssa | Get-SPEnterpriseSearchCrawlDatabase))[0]
$CrawlDatabase0 | Set-SPEnterpriseSearchCrawlDatabase [-DatabaseName "<NewDbName>"] -DatabaseServer "<NewServerName>"

  6. Point the Link database to the new location. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $LinksDatabase0 = ([array]($ssa | Get-SPEnterpriseSearchLinksDatabase))[0]
$LinksDatabase0 | Set-SPEnterpriseSearchLinksDatabase [-DatabaseName "<NewDbName>"] -DatabaseServer "<NewServerName>"

  7. Set all Search service instances to Online. Run the following commands for each search service in the farm, until the Search service instance is reported as Online. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    get-SPEnterpriseSearchServiceInstance -Identity <Search Server> Do {write-host -NoNewline .;Sleep 10; $searchInstance = Get-SPEnterpriseSearchServiceInstance -Identity <Search Server>} while ($searchInstance.Status -ne "Online")

    Where:

    • <Search Server> is the name of the server that hosts the Search components.

  8. Resume the Search service application. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication <SearchServiceApplicationName>
Resume-SPEnterpriseSearchServiceApplication -Identity $ssa

    Where:

    • <SearchServiceApplicationName> is the name of the Search service application associated with the database move.

See also

Manage the search topology in SharePoint Server 2013
Database types and descriptions (SharePoint 2013)
Rename the Search service application databases in SharePoint 2013

Windows PowerShell for SharePoint 2013 IT pros

Change History

Date | Description
June 25, 2013 | Corrected the order of the first two procedures. You must pause the Search service application before you set the service application databases to read-only mode.
October 11, 2012 | Initial publication


Move the Secure Store Service service application databases in SharePoint 2013
See also

Published: September 4, 2012

Summary: Learn how to move the Secure Store Service service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the Secure Store service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Pointing the Secure Store service application to a renamed or moved database

    • To point the Secure Store service application to a renamed or moved database by using Central Administration

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account, or accounts, performing the operations, you must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the Secure Store service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that are being moved.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that are being moved.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Pointing the Secure Store service application to a renamed or moved database

You can point the Secure Store service application to a renamed or moved database by using Central Administration. Or, you can rename or move the database, and then delete or re-create the service application. If you choose to delete and re-create the service application, you must use the same passphrase that you used when you first configured the service application.

To point the Secure Store service application to a renamed or moved database by using Central Administration

  1. Verify that the user account that is performing this task is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, under System Settings, click Manage services on server.

  3. In the Service list, next to the Secure Store service, click Stop.

  4. In the Quick Launch, click Application Management.

  5. On the Application Management page, click Manage service applications.

  6. Click the Secure Store Service service application. The ribbon becomes active.

  7. Click Properties on the ribbon.

    The Edit Secure Store Service Application page opens.

  8. Change the database server or database name, and then click OK.

    Note:

    If you use an incorrect name, SharePoint 2013 creates a new database.

  9. In the Quick Launch, click System Settings.

  10. On the System Settings page, under Servers, click Manage services on server.

  11. In the Service list, next to the Secure Store Service, click Start.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the SharePoint Translation Services service application databases in SharePoint Server 2013
See also

Published: September 4, 2012

Summary: Learn how to move the SharePoint Translation Services service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the SharePoint Translation Services service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Point the service application to a moved database

    • To point the SharePoint Translation service application to a moved database by using Central Administration

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account, or accounts, performing the operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the SharePoint Translation Services service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Point the service application to a moved database

You can point the SharePoint Translation Services service application to a moved database by using Central Administration.

To point the SharePoint Translation service application to a moved database by using Central Administration

  1. Verify that the user account that is performing the procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, click Application Management, and then, click Manage service applications.

  3. On the Service Applications page, place your cursor next to SharePoint Translation Services and then click the empty row.

    The ribbon becomes active.

  4. In the Operations group of the ribbon, click Properties.

    The Edit SharePoint Translation Services Application page appears.

  5. Change the database server name, and then click OK.

  6. In the Quick Launch, click System Settings.

  7. On the System Settings page, in the Servers section, click Manage services on server.

  8. In the Service list, next to the SharePoint Translation Services, click Start.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the State Service service application databases in SharePoint Server 2013
See also

Published: September 4, 2012

Summary: Learn how to move the State Service service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the State Service service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the State Service service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Pointing the State Service service application to a moved database

    • To add a new database to the State Service service application and remove an old database by using Windows PowerShell

    • To point the State Service service application to a moved database by using Windows PowerShell

Before you begin

Note:

Administrators typically use the Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account or accounts, performing the operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the State Service service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the State Service service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Pointing the State Service service application to a moved database

The State Service database stores temporary state information data. You can use Windows PowerShell to point the State Service service application to a moved database by performing one of the following procedures:

  • Add a new database in the new location, or create a database with a new name. Then add the new database to the service application, and delete the old database. For details, see To add a new database to the State service application, and remove an old database by using Windows PowerShell.

  • Dismount the old database, move it by using SQL Server, and then remount the State Service database. For details, see To point the State service application to a moved database by using Windows PowerShell.

    The following procedures all include the steps shown in the bullet list. So, they do not require that these steps are already performed:

    • Stopping a service application

    • Moving a database by using SQL Server Management Studio and Windows

To add a new database to the State Service service application and remove an old database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command to create a new database:

    Copy code
    New-SPStateServiceDatabase -Name "<NewDatabaseName>"

    Then type the following command to remove the old database:

    Copy code
    Remove-SPStateServiceDatabase -Name "<OldDatabaseName>"

    Where:

    • <NewDatabaseName> is the name of the new database that you want to create.

    • <OldDatabaseName> is the name of the old database that you want to disassociate with the State service and detach from SQL Server.

For more information, see New-SPStateServiceDatabase and Remove-SPStateServiceDatabase.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

To point the State Service service application to a moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Record the State Service service application ID and the database ID that you will configure.

  3. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs.

      2. Click Microsoft SharePoint 2013 Products.

      3. Click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      1. Right-click Computer.

      2. Click All apps.

      3. Click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  4. At the Windows PowerShell command prompt, type the following command to dismount the database:

    Copy code
    Dismount-SPStateServiceDatabase -Identity <DatabaseID>

    Where:

    • <DatabaseID> is the State Service database to remove from the service application. The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a state database, or an instance of a valid SPStateServiceDatabase object.

    For more information, see Dismount-SPStateServiceDatabase.

  5. Move the database. For details, see To move database files to a new location by using Windows Explorer.

  6. At the Windows PowerShell command prompt, type the following command to mount the renamed or moved database:

    Copy code
    Mount-SPStateServiceDatabase -Name "<DatabaseName>" -DatabaseServer "<ServerName>"

    Where:

    • <DatabaseName> is the name of the database to associate with the State service.

    • <ServerName> is the name of the SQL Server that hosts the State service database.

    For more information, see Mount-SPStateServiceDatabase.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Database types and descriptions (SharePoint 2013)


Move the Usage and Health Data Collection service application databases in SharePoint 2013
See also

Published: September 4, 2012

Summary: Learn how to move the Usage and Health Data Collection service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the Usage and Health Data Collection service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Pointing the Usage and Health Data Collection service application to a moved database

    • To point the Usage and Health Data Collection service application to a moved database by using Central Administration

    • To point the Usage and Health data collection service application to a moved database by using Windows PowerShell

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account or accounts, performing the operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the Usage and Health Data Collection service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Pointing the Usage and Health Data Collection service application to a moved database

You can use either Central Administration or Windows PowerShell to point the Usage and Health Data Collection service application to a renamed or moved database.

To point the Usage and Health Data Collection service application to a moved database by using Central Administration

  1. Verify that the user account that is performing the procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, click Monitoring, and then on the Monitoring page, click Configure usage and health data collection.

    The Configure web analytics and health data collection page appears.

  3. Clear the Enable health data collection check box, and then click OK.

    You return to the Monitoring page.

  4. Click Configure usage and health data collection to return to the Configure web analytics and health data collection page.

  5. Select the Enable health data collection check box

  6. In the Logging Database Server section, specify the updated database server and database name, and then click OK.

To point the Usage and Health data collection service application to a moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs.

      2. Click Microsoft SharePoint 2013 Products.

      3. Click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      1. Right-click Computer.

      2. Click All apps.

      3. Click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPUsageApplication -Identity "<ServiceApplicationName>" -DatabaseName "<DbName>" -DatabaseServer "<SQLServerName>"

    Where:

    • <ServiceApplicationName> is the name of the usage and health data collection service application.

    • <DbName> is the name of the database.

    • <SQLServerName> is the name of the database server.

For more information, see Set-SPUsageApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the Word Automation Services service application databases in SharePoint Server 2013
See also

Published: September 4, 2012

Summary: Learn how to move the Word Automation Services service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the Word Automation Services service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Pointing the Word Automation service application to a moved database

    • To point the Word Automation service application to a renamed or moved database by using Central Administration

    • To point the Word Automation service application to a renamed or moved database by using Windows PowerShell

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account or accounts, performing the operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the Word Automation Services service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Pointing the Word Automation service application to a moved database

You can point the Word Automation service application to a moved database by using Central Administration or Windows PowerShell.

This procedure has the following steps included, and do not require that they have already been performed:

  1. Stopping a service application

  2. Moving a database by using SQL Server Management Studio and Windows Explorer

Note:

You do not have to stop the Word Automation service before pointing to a renamed or moved database. However, stopping the Word Automation service will not cause a problem if you choose to do this.

To point the Word Automation service application to a renamed or moved database by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, under System Settings, click Manage services on server.

  3. In the Service list, next to the Word Automation Services, click Stop.

  4. In the Quick Launch, click Application Management.

  5. On the Application Management page, click Manage service applications.

  6. In the row for the Word Automation Services, click the empty space next to it to activate the ribbon.

  7. Click Properties on the ribbon.

    The Edit Word Automation Service Application dialog box appears.

  8. Change the database server or database name, and then click OK.

  9. In the Quick Launch, click System Settings.

  10. On the System Settings page, under Servers, click Manage services on server.

  11. In the Service list, next to the Word Automation service, click Start.

To point the Word Automation service application to a renamed or moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs.

      2. Click Microsoft SharePoint 2013 Products.

      3. Click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      1. Right-click Computer.

      2. Click All apps.

      3. Click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $app = Get-SPServiceApplication -Name "<ServiceApplicationName>"
Set-SPWordConversionServiceApplication -Identity $app -DatabaseName "<DatabaseName>" -DatabaseServer "<DatabaseServer>"

    Where:

    • <ServiceApplicationName> is the name of the Word Automation service application.

    • <DatabaseName> is the name of the renamed or moved database.

    • <DatabaseServer> is the location of the renamed or moved database. Do not include this parameter if you are pointing to a renamed database in the same location.

    For more information, see Set-SPWordConversionServiceApplication.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the Microsoft SharePoint Foundation Subscription Settings Services service application databases (SharePoint 2013)
See also

Published: September 4, 2012

Summary: Learn how to move the SharePoint Foundation Subscriptions Settings Service service application database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the Subscriptions Settings Service service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Pointing the Subscription Settings Services service application to a moved database

    • To point the Subscription Settings Services service application to a moved database by using Windows PowerShell

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account or accounts, performing the operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the Subscriptions Settings Service service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Pointing the Subscription Settings Services service application to a moved database

You can use Windows PowerShell to point the Subscription Settings service application to a moved database.

To point the Subscription Settings Services service application to a moved database by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the SharePoint 2013 Products cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs.

      2. Click Microsoft SharePoint 2013 Products.

      3. Click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      1. Right-click Computer.

      2. Click All apps.

      3. Click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPSubscriptionSettingsServiceApplication -Identity "<ServiceApplicationName>" -DatabaseName "<DatabaseName>" -DatabaseServer "<DatabaseServer>"

    Where:

    • <ServiceApplicationName> is the name of the Subscription Settings service application.

    • <DatabaseName> is the name of the renamed database.

    • <DatabaseServer> is the name of the renamed database.

For more information, see Set-SPSubscriptionSettingsServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the User Profile service application databases in SharePoint Server 2013
See also

Published: October 16, 2012

Summary: Learn how to move the User Profile service application databases in SharePoint Server 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to move the User Profile service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Point the service application to a moved database

    • To document service application settings

    • To delete the service application by using Central Administration

    • To create the service application

    • To start the service application

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account, or accounts, performing the operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the Business Data Connectivity service service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Point the service application to a moved database

The method for pointing a service application to a moved database that works for most service applications is to delete the service application and then re-create the service application. When you re-create the service application, use the new name or new location.

To document service application settings

  • Before you delete and re-create a service application, document the settings for the service application. To do this, use the recommended Windows PowerShell cmdlets that are described in the article Document farm configuration settings in SharePoint 2013.

To delete the service application by using Central Administration

  • To delete a service application, follow the procedure in Create, edit, or delete User Profile service applications in SharePoint Server 2013, but do not delete the service application database.

To create the service application

  • To re-create a service application, follow the procedure in Create, edit, or delete User Profile service applications in SharePoint Server 2013.

    Note:

    When you create a new User Profile Service application, you must also export and import the encryption key for profiles. For more information, see the Export the encryption key for the User Profile service application section in this article "Attach databases and upgrade to SharePoint 2013".

To start the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, under System Settings, click Manage services on server.

  3. In the Service list, next to the service application, click Start.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Move the PowerPivot Service service application databases in SharePoint Server 2013
See also

Published: October 30, 2012

Summary: Learn how to move the PowerPivot service application database.

This article describes how to move the Power Pivot for SharePoint 2013 service application database. Moving service application databases to another farm database server or database instance can be done to load-balance a system. The process involves the two main tasks, each with sub-tasks, of moving the databases files and then pointing the service application to the moved database.

In this article:

  • Before you begin

  • Move the service application database

    • To stop the service application

    • To detach the database from SQL Server

    • To move database files to a new location by using Windows Explorer

    • To attach a database to a new instance of SQL Server

  • Pointing the Power Pivot for SharePoint 2013 service application to a moved database

    • To point the Power Pivot for SharePoint 2013 service application to a moved database by using Central Administration

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Important:

The account or accounts, performing the operations, must have the following rights and permissions:

  • A member of the Farm Administrators SharePoint group.

  • A member of the Administrators group on the local server

  • Have read permission on the source location and write permission on the target location.

  • Have the db_owner fixed database role for all of the databases that you are moving.

In some environments, you must coordinate the rename and move procedures with the database administrator. Be sure to follow any applicable policies and guidelines for managing databases.

Move the service application database

To move a service application database, you must use SQL Server and Windows Explorer. We recommend that you stop the services related to the service application before you move the related database.

The instructions in this article assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio at Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409).

To stop the service application

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. You must stop the Usage and Health Data Collection service application by following the appropriate procedure for the service application that you are working with. For more information, see Start or stop a service (SharePoint 2013).

To detach the database from SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In SQL Server Management Studio, open the source SQL Server instance, and then expand the Databases node.

  3. Right-click the database, point to Tasks, and then click Detach. Repeat this step for each database that you want to move.

To move database files to a new location by using Windows Explorer

  1. Verify that the user account that is performing this procedure has read permission on the source location and write permission on the target location.

  2. In Windows Explorer, locate the .mdf, .ndf, and .ldf files for the service application databases.

  3. Select the .mdf, .ndf, and .ldf files for the databases that you want to move, and then either copy or move them to the destination directory.

To attach a database to a new instance of SQL Server

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role for all of the databases that you are moving.

  2. In Management Studio, open the destination SQL Server instance.

  3. Right-click the Databases node, point to Tasks, and then click Attach.

  4. In the Attach Database dialog box, browse to where you transferred the .mdf, .ndf, and .ldf files, select the .mdf file for the database that you want to attach, and then click OK.

  5. Repeat for each database that you are moving.

Pointing the Power Pivot for SharePoint 2013 service application to a moved database

You can use Central Administration to point the Power Pivot for SharePoint 2013 service application to a renamed or moved database.

To point the Power Pivot for SharePoint 2013 service application to a moved database by using Central Administration

  1. Verify that the user account that is performing the procedure is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, click Application Management, and then, click Manage service applications.

  3. On the Service Applications page, place your cursor next to Power Pivot for SharePoint 2013 and then click the empty row.

    The ribbon becomes active.

  4. In the Operations group of the ribbon, click Properties.

    The Edit Power Pivot for SharePoint 2013 Application page appears.

  5. Change the database name, and then click OK.

    Note:

    If you use an incorrect database name, SharePoint Server 2013 creates a new database.

  6. In the Quick Launch, click System Settings.

  7. On the System Settings page, in the Servers section, click Manage services on server.

  8. In the Service list, next to the Power Pivot for SharePoint 2013, click Start.

See also

Database types and descriptions (SharePoint 2013)
Manage service applications in SharePoint 2013


Manage RBS in SharePoint 2013

Summary: Learn about Remote BLOB Storage (RBS) and how to manage RBS in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Remote BLOB Storage (RBS) is an add-on feature pack for SQL Server 2008. RBS is designed to move the storage of binary large objects (BLOBs) from database servers to commodity storage solutions. If the content databases in SharePoint 2013 are 4 gigabytes (GB) or larger, consider using RBS as part of your data storage solution.

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about managing RBS.

TechNet articles about managing RBS

The following articles about managing RBS are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Overview of RBS in SharePoint 2013 | This article is a conceptual overview of how RBS works with SQL Server 2008 Express and Microsoft SQL Server 2008 R2 Express. It contains important information about RBS features and providers. We strongly recommend that you read this article before you implement RBS.
Plan for RBS in SharePoint 2013 | This article provides information to help you decide whether to use Remote BLOB Storage (RBS) in a SharePoint 2013 environment, and if you use RBS, to understand the benefits and costs of using RBS in your environment.
Install and configure RBS in a SharePoint 2013 farm | This article describes how to install and configure RBS and implement the FILESTREAM provider for use with SharePoint 2013.
Install and configure RBS with a 3rd party provider (SharePoint 2013) | This article describes how to install and configure RBS without using the FILESTREAM provider.
Set a content database to use RBS in SharePoint 2013 | This article describes how to set a content database to use Remote BLOB Storage (RBS) that uses the FILESTREAM provider.
Migrate content into or out of RBS in SharePoint 2013 | This article describes how to migrate content into or out of RBS, or to a different RBS provider.
Maintain RBS in SharePoint Server 2013 | This article describes how to perform maintenance tasks that are associated with Remote BLOB Storage (RBS).
Disable RBS on SharePoint 2013 content databases | This article describes how to disable RBS in a SharePoint 2013 environment.


Install and configure RBS in a SharePoint 2013 farm
See also

Summary: Learn how to install and configure Remote BLOB Storage (RBS) in a SharePoint 2013 farm.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

SharePoint 2013 uses the RBS feature to store BLOBs outside the content database. For more information about RBS, see Overview of RBS in SharePoint 2013.

Tip:

This solution uses the FILESTREAM RBS provider that is included with SQL Server 2008. If you want to install and configure RBS using a different provider, use the procedure in Install and configure RBS with a 3rd party provider (SharePoint 2013).

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013, except for the Upgrade service application databases section, which applies only to SharePoint Server 2013.

In this article:

  • Before you begin

  • Enable FILESTREAM on the database server

  • Provision a BLOB store for each content database

  • Install the RBS client library on each web server

  • Enable RBS for each content database

  • Test the RBS installation

Before you begin

You only have to install and configure RBS with the FILESTREAM provider one time for the farm. However, if you want to enable RBS using different providers for specific content databases, you must configure RBS to use those providers. For more information about doing that, see Install and configure RBS with a 3rd party provider (SharePoint 2013).

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • The user account provisioning RBS stores must be a member of the db_owner fixed database role on each database that you are configuring RBS for.

  • The user account installing the client library must be a member of the Administrators group on all of the computers where you are installing the library.

  • The user account enabling RBS must have sufficient permissions to run Windows PowerShell.

Enable FILESTREAM on the database server

By default, the FILESTREAM feature is installed when you install SQL Server 2008. But it is not enabled. You must enable and configure FILESTREAM on the computer that is running SQL Server 2008 that hosts the SharePoint 2013 databases. You must:

  1. Enable FILESTREAM for file I/O streaming access.

  2. Allow remote clients to have streaming access to FILESTREAM data.

To enable FILESTREAM for file I/O and to allow clients access, follow the instructions in How to: Enable FILESTREAM (http://go.microsoft.com/fwlink/p/?LinkID=166110&clcid=0x409). You only have to configure these settings one time for each database server where you want to use RBS.

Provision a BLOB store for each content database

After you have enabled and configured FILESTREAM, provision a BLOB store on the file system as described in the following procedure. You must provision a BLOB store for each content database that you want to use RBS with.

To provision a BLOB store

  1. Confirm that the user account performing these steps is a member of the db_owner fixed database role on each database that you are configuring RBS for.

  2. Click Start, click All Programs, click Microsoft SQL Server 2008, and then click SQL Server Management Studio.

  3. Connect to the instance of SQL Server that hosts the content database.

  4. Expand Databases.

  5. Click the content database for which you want to create a BLOB store, and then click New Query.

  6. Paste the following SQL queries in Query pane, and then execute them in the sequence listed. In each case, replace [WSS_Content] with the content database name, and replace c:\BlobStore with the volume\directory in which you want the BLOB store created. The provisioning process creates a folder in the location that you specify. Be aware that you can provision a BLOB store only one time. If you attempt to provision the same BLOB store multiple times, you'll receive an error.

    Tip:

    For best performance, simplified troubleshooting, and as a general best practice, we recommend that you create the BLOB store on a volume that does not contain the operating system, paging files, database data, log files, or the tempdb file.

    Copy code
    use [WSS_Content]
if not exists
(select * from sys.symmetric_keys
where name = N'##MS_DatabaseMasterKey##')
create master key encryption by password = N'Admin Key Password !2#4'
    Copy code
    use [WSS_Content]
if not exists
(select groupname from sysfilegroups
where groupname=N'RBSFilestreamProvider')
alter database [WSS_Content]
add filegroup RBSFilestreamProvider contains filestream
    Copy code
    use [WSS_Content]
alter database [WSS_Content]
 add file (name = RBSFilestreamFile, filename =
'c:\Blobstore')
to filegroup RBSFilestreamProvider

Install the RBS client library on each web server

You must install RBS client library on all web servers in the SharePoint farm. The RBS client library is installed only one time per web server, but RBS is configured separately for each associated content database. The client library consists of a client-side dynamic link library (DLL) that is linked into a user application, and a set of stored procedures that are installed on SQL Server.

Warning:

Do not install the RBS client library by running the RBS_amd64.msi file and starting the Install SQL Remote BLOB Storage wizard. The wizard sets certain default values that are not recommended for SharePoint 2013.

To install the RBS client library on the on the first web server

  1. Confirm that the user account performing these steps is a member of the Administrators group on the computer where you are installing the library.

  2. On any web server, browse to http://go.microsoft.com/fwlink/p/?LinkId=271938 and download the RBS_amd64.msi file.

  3. Click Start, click Run, type cmd into the Run text box, and then click OK.

  4. Copy and paste the following command into the Command Prompt window. Replace WSS_Content with the database name, and replace DBInstanceName with the SQL Server instance name. You should run this command by using the specific database name and SQL Server instance name only one time. The action should finish within approximately one minute.

    Copy code
    msiexec /qn /lvx* rbs_install_log.txt /i RBS_amd64.msi TRUSTSERVERCERTIFICATE=true FILEGROUP=PRIMARY DBNAME="WSS_Content" DBINSTANCE="DBInstanceName" FILESTREAMFILEGROUP=RBSFilestreamProvider FILESTREAMSTORENAME=FilestreamProvider_1

To install the RBS client library on all additional web and application servers

  1. Confirm that the user account performing these steps is a member of the Administrators group on the computer where you are installing the library.

  2. On any web server, browse to http://go.microsoft.com/fwlink/p/?LinkId=271938 and download the RBS_amd64.msi file.

  3. Click Start, click Run, type cmd into the Run text box, and then click OK.

  4. Copy and paste the following command into the Command Prompt window. Replace WSS_Content with the database name, and replace DBInstanceName with the name of the SQL Server instance. The action should finish within approximately one minute.

    Copy code
    msiexec /qn /lvx* rbs_install_log.txt /i RBS_amd64.msi DBNAME="WSS_Content" DBINSTANCE="DBInstanceName" ADDLOCAL=Client,Docs,Maintainer,ServerScript,FilestreamClient,FilestreamServer

  5. Repeat this procedure for all web servers and application servers in the SharePoint farm.

To confirm the RBS client library installation

  1. The rbs_install_log.txt log file is created in the same location as the RBS_amd64.msi file. Open the rbs_install_log.txt log file by using a text editor and scroll toward the bottom of the file. Within the last 20 lines of the end of the file, an entry should read as follows: Product: SQL Remote Blob Storage - Installation completed successfully.

  2. On the computer that is running SQL Server 2008, verify that the RBS tables were created in the content database. Several tables should be listed under the content database that have names that are preceded by the letters "mssqlrbs".

Enable RBS for each content database

You must enable RBS on one web server in the SharePoint farm. It is not important which web server that you select for this activity, as long as RBS was installed on it by using the previous procedure. You must perform this procedure one time for each content database.

Note:

You can only enable RBS by using Windows PowerShell.

To enable RBS by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not displayed on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $cdb = Get-SPContentDatabase <ContentDatabaseName>
$rbss = $cdb.RemoteBlobStorageSettings
$rbss.Installed()
$rbss.Enable()
$rbss.SetActiveProviderName($rbss.GetProviderNames()[0])
$rbss

    Where:

    • <ContentDatabaseName> is the name of the content database.

For more information, see Get-SPContentDatabase.

Test the RBS installation

You should test the RBS installation on one web server in the SharePoint farm to make sure that the system works correctly.

To test the RBS data store

  1. On the computer that contains the RBS data store, click Start, and then click Computer.

  2. Browse to the RBS data store directory.

  3. Confirm that the folder is empty.

  4. On the SharePoint farm, upload a file that is at least 100 kilobytes (KB) to a document library.

  5. On the computer that contains the RBS data store, click Start, and then click Computer.

  6. Browse to the RBS data store directory.

  7. Browse to the file list and open the file that has the most recent changed date. This should be the file that you uploaded.

See also

Overview of RBS in SharePoint 2013
Plan for RBS in SharePoint 2013

How to: Enable FILESTREAM
Resource Center: Installation and Deployment for SharePoint Server 2010


Install and configure RBS with a 3rd party provider (SharePoint 2013)
See also

Summary: Learn how to install and configure Remote BLOB Storage (RBS) that uses a third-party RBS Provider.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

SharePoint 2013 uses the RBS feature to store BLOBs outside the content database. For more information about RBS, see Overview of RBS in SharePoint 2013.

Important:

This solution uses a third-part provider. Before continuing, make sure that you read the instructions from the manufacturer of the provider. If you want to install and configure RBS using the FILESTREAM provider, use the procedure in Install and configure RBS in a SharePoint 2013 farm.

Do not directly access BLOBs when you are using third-party providers. Always access these BLOBs by using SharePoint 2013.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013, except for the Upgrade service application databases section, which applies only to SharePoint Server 2013.

In this article:

  • Before you begin

  • Install the RBS client library on each Web server

  • Install the third-part provider

  • Enable RBS for each content database

  • Test the RBS installation

Before you begin

You only have to install and configure RBS with the specific third-part provider one time for the farm. However, if you want to enable RBS using the FILESTREAM provider, use the procedure in Install and configure RBS in a SharePoint 2013 farm.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • The user account provisioning RBS stores must be a member of the db_owner fixed database role on each database that you are configuring RBS for.

  • The user account installing the client library must be a member of the Administrators group on all of the computers where you are installing the library.

  • The user account enabling RBS must have sufficient permissions to run Windows PowerShell.

Install the RBS client library on each Web server

You must install RBS client library on all Web servers in the SharePoint farm. The RBS client library is installed only one time per Web server, but RBS is configured separately for each associated content database. The client library consists of a client-side DLL that is linked into a user application, and also a set of stored procedures to be installed on SQL Server.

Warning:

Do not install RBS by running the RBS_x64.msi file and starting the Install SQL Remote BLOB Storage wizard. The wizard sets certain default values that are not recommended for SharePoint 2013.

To install the RBS client library on the on the first Web server

  1. Confirm that the user account performing these steps is a member of the Administrators group on the computer where you are installing the library.

  2. On any web server, browse to http://go.microsoft.com/fwlink/p/?LinkId=271938 and download the RBS_amd64.msi file.

  3. Click Start, click Run, type cmd into the Run text box, and then click OK.

  4. Copy and paste the following command into the Command Prompt window. Replace WSS_Content with the database name, and replace DBInstanceName with the SQL Server instance name. You should run this command by using the specific database name and SQL Server instance name only one time. The operation should finish within approximately one minute.

    Copy code
    msiexec /qn /lvx* rbs_install_log.txt /i RBS-x64.msi TRUSTSERVERCERTIFICATE=true FILEGROUP=PRIMARY DBNAME="WSS_Content" DBINSTANCE="DBInstanceName" FILESTREAMFILEGROUP=RBSFilestreamProvider FILESTREAMSTORENAME=FilestreamProvider_1

To install the RBS client library on all additional Web and application servers

  1. Confirm that the user account performing these steps is a member of the Administrators group on the computer where you are installing the library.

  2. On any web server, browse to http://go.microsoft.com/fwlink/p/?LinkId=271938 and download the RBS_amd64.msi file.

  3. Click Start, click Run, type cmd into the Run text box, and then click OK.

  4. Copy and paste the following command into the Command Prompt window. Replace WSS_Content with the database name, and replace DBInstanceName with the name of the SQL Server instance. The operation should finish within approximately one minute.

    Copy code
    msiexec /qn /lvx* rbs_install_log.txt /i RBS_x64.msi DBNAME="WSS_Content" DBINSTANCE="DBInstanceName" ADDLOCAL=Client,Docs,Maintainer,ServerScript,FilestreamClient,FilestreamServer

  5. Repeat this procedure for all Web servers and application servers in the SharePoint farm.

To confirm the RBS client library installation

  1. The rbs_install_log.txt log file is created in the same location as the RBS_x64.msi file. Open the rbs_install_log.txt log file by using a text editor and scroll toward the bottom of the file. Within the last 20 lines of the end of the file, an entry should read as follows: Product: SQL Remote Blob Storage - Installation completed successfully.

  2. On the computer that is running SQL Server 2008, verify that the RBS tables were created in the content database. Several tables should be listed under the content database that have names that are preceded by the letters "mssqlrbs".

Install the third-part provider

The steps that you use to install the third-part provider will vary between manufacturers. Be sure to follow the instructions from the manufacturer of the provider.

Enable RBS for each content database

You must enable RBS on one Web server in the SharePoint farm. It is not important which Web server that you select for this activity, as long as RBS was installed on it by using the previous procedure. You must perform this procedure one time for each content database.

Note:

You can only enable RBS by using Windows PowerShell.

To enable RBS by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $cdb = Get-SPContentDatabase <ContentDatabaseName>
$rbss = $cdb.RemoteBlobStorageSettings
$rbss.Installed()
$rbss.Enable()
$rbss.SetActiveProviderName($rbss.GetProviderNames()[0])
$rbss

    Where:

    • <ContentDatabaseName> is the name of the content database.

For more information, see Get-SPContentDatabase.

Test the RBS installation

You should test the RBS installation on one Web server in the SharePoint farm to make sure that that the system works correctly.

To test the RBS data store

  1. On the computer that contains the RBS data store, click Start, and then click Computer.

  2. Browse to the RBS data store directory.

  3. Confirm that the folder is empty.

  4. On the SharePoint farm, upload a file that is at least 100 kilobytes (KB) to a document library.

  5. On the computer that contains the RBS data store, click Start, and then click Computer.

  6. Browse to the RBS data store directory.

  7. Browse to the file list and open the file that has the most recent changed date. This should be the file that you uploaded.

See also

Overview of RBS in SharePoint 2013
Plan for RBS in SharePoint 2013

How to: Enable FILESTREAM


Set a content database to use RBS in SharePoint 2013
See also

Summary: Learn how to set a SharePoint 2013 content database to use Remote BLOB Storage (RBS).

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to set a content database to use Remote BLOB Storage (RBS) that uses the FILESTREAM provider. IF you are using a third-party provider, these instructions might not apply. For more information, contact the manufacturer of the provider. These instructions assume that you have already installed RBS for use with SharePoint 2013. To install and configure RBS, see Install and configure RBS in a SharePoint 2013 farm.

In this article:

  • Before you begin

  • Set a content database to use RBS

Before you begin

You must perform this procedure on every content database that you want to set to use RBS.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • The user account that you use to perform this procedure is a member of the Administrators group on the Web.

  • The user account that you use to perform this procedure is a member of the SQL Server dbcreator and securityadmin fixed server roles on the computer that is running SQL Server 2008 R2 with Service Pack 1 (SP1) or SQL Server 2012.

Set a content database to use RBS

To set a content database to use RBS, you must provision a binary large object (BLOB) store in SQL Server, add the content database information to the RBS configuration on a Web server, and then test the RBS data store.

These instructions assume that you have installed SQL Server Management Studio on the database server. If this is not the case, you can download and install Management Studio from Microsoft SQL Server 2008 Management Studio Express (http://go.microsoft.com/fwlink/p/?LinkID=186132&clcid=0x409). You can perform the following procedures on any Web server or application server in the farm. However, for simplicity in this article, we refer to this server as a Web server.

Note:

These instructions assume that you are using the FILESTREAM RBS provider. If you are using a different RBS provider, refer to that provider's instructions to perform these operations.

To set a content database to use RBS

  1. Verify that the user account that you use to perform this procedure is a member of the Administrators group on the Web server, and is a member of the SQL Server dbcreator and securityadmin fixed server roles on the computer that is running SQL Server 2008 R2 with SP1 or SQL Server 2012.

  2. Click Start, click All Programs, click Microsoft SQL Server 2008, and then click SQL Server Management Studio.

  3. In the Connect to Server dialog box, specify the server type, server name, and authentication method of the database server that you want to connect to, and then click Connect.

  4. Expand Databases.

  5. Right-click the content database for which you want to create a BLOB store, and then click New Query.

  6. In the Query pane, copy and execute the following SQL queries in the sequence that is provided.

    Copy code
    use [ContentDbName]
if not exists (select * from sys.symmetric_keys where name = N'##MS_DatabaseMasterKey##')
create master key encryption by password = N'Admin Key Password !2#4'
    Copy code
    use [ContentDbName]
if not exists (select groupname from sysfilegroups where groupname=N'RBSFilestreamProvider')
alter database [ContentDbName] add filegroup RBSFilestreamProvider contains filestream
    Copy code
    use [ContentDbName]
alter database [ContentDbName] add file (name = RBSFilestreamFile, filename = 'c:\RBSStore') to filegroup RBSFilestreamProvider

    Where [ContentDbName] is the content database name and c:\RBSStore is the volume\directory that will contain the RBS data store. Be aware that you can provision a RBS store only one time. If you attempt to provision the same RBS data store multiple times, you will receive an error.

    Tip:

    For best performance, simplified troubleshooting, and as a general best practice, we recommend that you create the RBS data store on a volume that does not contain the operating system, paging files, database data, log files, or the tempdb file.

  7. Click Start, click Run, type cmd into the Run text box, and then click OK.

  8. Copy and paste the following command at the command prompt:

    Copy code
    msiexec /qn /i rbs.msi REMOTEBLOBENABLE=1 FILESTREAMPROVIDERENABLE=1 DBNAME=<ContentDbName> FILESTREAMSTORENAME=FilestreamProvider_1 ADDLOCAL=EnableRBS,FilestreamRunScript DBINSTANCE=<DBInstanceName>>

    Where <ContentDbName> is the name of the content database, and <DBInstanceName> is the name of the SQL Server. The operation should finish within approximately one minute.

To test the RBS data store

  1. Connect to a document library on any Web server.

  2. Upload a file that is at least 100 kilobytes (KB) to the document library.

  3. On the computer that contains the RBS data store, click Start, and then click Computer.

  4. Navigate to the RBS data store directory.

  5. Locate the folder that has the most recent modification date, other than the $FSLOG folder. Open this folder and locate the file that has the most recent modification date. Verify that this file has the same size and contents as the file that you uploaded. If does not, make sure that RBS is installed and enabled correctly.

See also

Overview of RBS in SharePoint 2013
Migrate content into or out of RBS in SharePoint 2013


Migrate content into or out of RBS in SharePoint 2013
See also

Summary: Learn how to migrate content into or out of Remote BLOB Storage (RBS), or to a different RBS provider.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

After installing RBS and setting a content database to use RBS, all existing content in that database can be migrated into the database's active provider. You use the same Windows PowerShell 3.0 command to migrate content into or out of RBS, or to another RBS provider. When RBS is implemented, SQL Server itself is regarded as an RBS provider.

You can migrate content databases at any time. But we recommend that you perform migrations during low usage periods so that this activity does not cause decrease in performance for users. Migration moves all content from the specified content database into the storage mechanism of the newly named provider.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013, except for the Upgrade service application databases section, which applies only to SharePoint Server 2013.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Migrate a content database

This operation can be performed on any Web server in the farm. You only have to perform the operation one time on one Web server for each content database that you want to migrate.

To migrate a content database by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the commands in the following steps.

  4. To obtain the content database RBS settings object:

    Copy code
    $rbs=(Get-SPContentDatabase <ContentDbName>).RemoteBlobStorageSettings

    Where <ContentDbName> is the name of the content database.

  5. To view a list the RBS providers installed on the Web server:

    Copy code
    $rbs.GetProviderNames()

  6. To set the active RBS provider:

    Copy code
    $rbs.SetActiveProviderName(<NewProvider>)

    Where <NewProvider> is the name of the provider that you want to make active for this content database. If you want to migrate the content database out of RBS completely and back into SQL Server inline storage, set this value to ().

  7. Migrate the data from RBS to the new provider or to SQL Server:

    Copy code
    $rbs.Migrate()

See also

Set a content database to use RBS in SharePoint 2013


Maintain RBS in SharePoint Server 2013
See also

Summary: Learn how to perform maintenance tasks that are associated with Remote BLOB Storage (RBS) in SharePoint 2013.

Applies to: SharePoint Foundation 2010 | SharePoint Server 2010

You perform most of the maintenance tasks associated with RBS in SharePoint 2013 by using the RBS Maintainer, which is a tool in SQL Server. The RBS Maintainer performs periodic garbage collection and other maintenance tasks for a SharePoint 2010 RBS deployment. You can schedule these tasks for each database that uses RBS by using Windows Task Scheduler or SQL Server Agent. You must provision the RBS Maintainer by using command-line parameters or through an XML file. In the case of mirrored or replicated databases, you can run the RBS Maintainer against any single instance.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013, except for the Upgrade service application databases section, which applies only to SharePoint Server 2013.

In this article:

  • Before you begin

  • Configure RBS Garbage collection

  • RBS and BLOB store consistency checks

  • Running the RBS Maintainer

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure RBS Garbage collection

SharePoint 2013 automatically marks unreferenced or deleted BLOB data for removal. SharePoint 2013 counts references to BLOBs by looking at the list of BLOB IDs stored by SharePoint 2013 in its content databases at the time of removal. Any BLOB references that are present in the RBS store tables but absent in the content database are assumed to be deleted by SharePoint 2013 and will be marked for removal. BLOBs that are not present in the content database and were created before the orphan cleanup time window, described later in this article, are also assumed to be deleted by SharePoint 2013 and will be marked for removal.

Because SharePoint 2013 tabulates BLOB references from the RBS columns of the content database, every RBS column must have a valid index before it can be registered in RBS.

The SQL Server RBS Maintainer tool removes the items marked by SharePoint 2013 for removal. You should schedule the clean-up tasks to be run during off-peak hours to reduce the effect on regular database operations.

RBS garbage collection is performed in the following three steps:

  • Reference scan. The first step compares the contents of the RBS tables in the SharePoint 2013 content database that has RBS's own internal tables and determines which BLOBs are no longer referenced. Any unreferenced BLOBs are marked for deletion.

  • Delete propagation. The next step determines which BLOBs were marked for deletion for some time longer than the garbage_collection_time_window value and deletes them from the BLOB store.

  • Orphan cleanup. The final step determines whether any BLOBs are present in the BLOB store but absent in the RBS tables. These orphaned BLOBs are then deleted.

Configuring RBS garbage collection

You can configure garbage collection by specifying the following RBS Maintainer settings and database settings:

  • Maintainer schedule. This setting determines how often the RBS Maintainer will be run.

  • Task Duration. This setting determines the maximum length that a single RBS Maintainer task can run. The default setting is two hours.

You should configure the RBS Maintainer so that its activity has minimal effect on regular activity. For information about database garbage collection settings, such as how to configure the settings, see Running RBS Maintainer.

RBS and BLOB store consistency checks

The RBS Maintainer verifies the integrity of RBS BLOB references and corrects any errors that are found. It performs several consistency checks for the database, such as verifying that indexes exist for the RBS columns, and verifying that all BLOBs that are referenced by SharePoint 2013 exist in RBS.

The Auxiliary Table Consistency Check verifies that the RBS auxiliary tables are in a consistent state. The checks performed are the following:

  • Verify that each RBS table column has a valid index.

  • Verify that RBS table columns exist; have enabled, valid indexes; and have the correct column type.

Although you can disable the following consistency checks, we recommend that you do not disable them because they help ensure the consistency of your RBS store. By default, the following consistency checks are enabled:

  • Verify that all BLOBs that are referenced by SharePoint 2013 are present in the RBS tables.

  • Verify that no BLOBs are marked as both in use and deleted.

Any discovered problems are logged and the RBS Maintainer attempts to fix them by creating missing index entries, unregistering missing columns, or marking in-use BLOBs as not deleted.

Running the RBS Maintainer

RBS requires you to define a connection string to each database that uses RBS before you run the RBS Maintainer. This string is stored in a configuration file in the <RBS installation path>\Microsoft SQL Remote Blob Storage 10.50\Maintainer folder that is ordinarily created during installation. The RBS Maintainer can be run manually by executing the Microsoft.Data.SqlRemoteBlobs.Maintainer.exe program together with the parameters that are listed in the following table.

Parameter name | Description | Values | Required?
ConnectionStringName <string name> | The name of the connection string for the configuration file. | RBSMaintainerConnection is the default name that is created during RBS setup. | Yes
Operation <space-separated list of operations to perform> | The garbage collection operations to perform. This parameter takes one to four arguments. The ForceFinalize value cannot be used in combination with any other operation. | ConsistencyCheck GarbageCollection Maintenance ConsistencyCheckForStores ForceFinalize | Yes
GarbageCollectionPhases <phases> | The garbage collection phases to perform. This parameter is used to run or complete the garbage collection. The value must be one or more letters without spaces. | r — Reference scan. d — Delete propagation. o — Orphan cleanup. | Yes, if garbage collection is to be performed.
ConsistencyCheckMode <c, r, or b> | Specifies the kind of consistency check to be performed. | c — Only a check will be performed. r — A check will be performed and any issues found will be repaired. b — A check, repair, and rebuild of the internal data structures. | Yes, if a consistency check is to be performed.
ConsistencyCheckExtent <m or c> | Specifies the extent of the consistency check. | m — Only metadata will be checked; individual BLOBs will remain unchecked. This is the default parameter. c — A complete check will be performed. | If not specified, m is assumed.
ConsistencyCheckForStores <space-separated list of BLOB store names> | Lists the names of the BLOB stores that will be checked for consistency. | By default, all BLOB stores are checked. | No
TimeLimit <time in minutes> | Specifies the time that is available for the RBS Maintainer to perform its tasks. The argument must be a positive integer. |  | No

You must schedule a separate RBS Maintainer task for every database that uses RBS. The following steps describe how to schedule an RBS Maintainer task.

To schedule an RBS Maintainer task

  1. Verify that you have Write permissions for the folder where you installed RBS.

  2. Add a connection string to the <RBS installation directory>\Maintainer\Microsoft.Data.SqlRemoteBlobs.Maintainer.exe.config file for the RBS Maintainer task that is to be performed. The RBS installer creates one connection string that is named RBSMaintainerConnection by using the connection information that was provided during setup. However, new connection strings must be added for every additional database.

    If you are using Windows authentication, the connection string does not have to be encrypted. You can add the unencrypted connection string by running the following command:

    aspnet_regiis -pef connectionStrings . -prov DataProtectionConfigurationProvider
    rename web.config Microsoft.Data.SqlRemoteBlobs.Maintainer.exe.config

    If you are using SQL authentication, the RBS Maintainer connection strings must be in an encrypted format. Therefore, to add connection strings, either the new strings must be encrypted or all the connection strings must be decrypted. Encrypted strings must be added one at a time. However all the connection strings can be decrypted at the same time by using the %windir%\Microsoft.net\Framework\<version>\Aspnet_regiis.exe tool, which is distributed as a part of the Microsoft .NET Framework.

    Run the following commands to decrypt the connection strings and store the results in a Web.config file:

    rename Microsoft.Data.SqlRemoteBlobs.Maintainer.exe.config web.config
    aspnet_regiis -pdf connectionStrings

    Strings can then be added in decrypted form and the file can be encrypted and renamed to Microsoft.Data.SqlRemoteBlobs.Maintainer.exe.config by using the following commands:

    aspnet_regiis -pef connectionStrings . -prov DataProtectionConfigurationProvider
    rename web.config Microsoft.Data.SqlRemoteBlobs.Maintainer.exe.config

  3. Create a Windows scheduler task to run the RBS Maintainer task for each applicable database. If you ran the RBS installer in GUI mode, it automatically created a Windows scheduler task. However, if you ran the RBS installer in command-line mode, you must follow these steps every time that you schedule a task to run the RBS Maintainer:

    1. On the Start menu, click Administrative Tools, and then click Task Scheduler.

    2. On the Action menu, click Create Task.

    3. On the Actions tab, click New.

    4. In the New Action dialog box, in the Action drop-down list, select Start a program.

    5. Under Settings, in the Program/script box, browse to the Maintainer binary file <RBS installation directory>\Maintainer\Microsoft.Data.SqlRemoteBlobs.Maintainer.exe, and in the Add arguments (optional) text box, add any optional arguments. The following default values are created by the installer:
      <-ConnectionStringName RBSMaintainerConnection>
      <-Operation GarbageCollection ConsistencyCheck ConsistencyCheckForStores>
      <-GarbageCollectionPhases rdo>
      <-ConsistencyCheckMode r>
      <-TimeLimit 120>

    6. Click OK.

    7. On the Triggers tab, click New.

    8. In the New Trigger dialog box, schedule the task, and then click OK. We recommend that you schedule the task to run during low system activity times.

    9. On the General tab, under Security, make sure that the user account has the appropriate permissions to run the task. You can change permissions by clicking Change User or Group.

    10. On the General tab, click Run whether user is logged on or not, and then click OK.

See also

Overview of RBS in SharePoint 2013
Install and configure RBS in a SharePoint 2013 farm
Install and configure RBS with a 3rd party provider (SharePoint 2013)
Set a content database to use RBS in SharePoint 2013
Migrate content into or out of RBS in SharePoint 2013
Disable RBS on SharePoint 2013 content databases


Disable RBS on SharePoint 2013 content databases

Summary: Learn how to disable Remote BLOB Storage (RBS) on any SharePoint 2013 content database.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

You can disable Remote BLOB Storage (RBS) on any content database. After you disable RBS on a content database, binary large objects (BLOBs) are stored inline in SQL Server for all subsequent writes to the content database. This article describes how to disable RBS on a content database.

You can disable RBS on a content database by setting the active provider name to the empty string in Windows PowerShell. Each content database has a RemoteBlobStorageSettings property that can be used to invoke the SetActiveProviderName method.

This action does not change the storage location of any BLOBs that have previously been stored in RBS or inline storage. Disabling RBS does not uninstall RBS. We do not recommend that you uninstall RBS.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013, except for the Upgrade service application databases section, which applies only to SharePoint Server 2013.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

Disable RBS for a content database

This operation can be performed on any Web server in the farm. You only have to perform the operation one time on one Web server for each content database for which you want to disable RBS.

Caution:

Do not use the Disable() method on the RemoteBlobStorageSettings object. This method is used only to uninstall RBS, and we do not recommend that you just disable the writing of new BLOBs into RBS.

You must use Windows PowerShell 3.0 cmdlets to disable RBS. There is no user interface option for this task.

To disable RBS by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $site=Get-SPSite "<http://yourSiteURL>"
$rbss=$site.ContentDatabase.RemoteBlobStorageSettings
$rbss.SetActiveProviderName("")

    Where <http://yourSiteURL> is the Web application that is attached to the content database that is being disabled for RBS.

    For more information, see Get-SPSite.


Best practices for SQL Server in a SharePoint Server farm

Published: February 26, 2013

Summary: Learn how to implement best practices for SQL Server in a SharePoint Server 2013 farm.

Applies to: SharePoint Server 2013

When you configure and maintain SharePoint Server 2013 relational databases on SQL Server 2008 R2 with Service Pack 1 (SP1) and SQL Server 2012, you have to choose options that promote performance and security. The best practices in this article are ordered based on the sequence in which they would apply, from installing and configuring SQL Server 2008 R2 with SP1 or SQL Server 2012, to deploying SharePoint Server, and then maintaining the farm. Most of the practices apply to both SQL Server 2008 R2 with SP1 and SQL Server 2012. Practices that are unique to either SQL Server version are shown in separate sections.

Note:

If you plan to use SQL Server Business Intelligence components in a SharePoint Server 2013 farm you must use SQL Server 2012 with Service Pack 1 (SP1). For information about SQL Server 2012 with SP1 BI and SharePoint Server 2013, see Guidance for Using SQL Server BI Features in a SharePoint Farm, Business Intelligence for SQL Server 2012, and Business Intelligence Features and SharePoint 2013 (SQL Server 2012 SP1).

Important:

Best practices in this article apply to the Relational Database Management System (RDBMS) of SQL Server 2008 R2 with SP1 or SQL Server 2012 with SharePoint Server 2013.

Use a dedicated server for SQL Server

To ensure optimal performance for farm operations, we recommend that you install SQL Server 2008 R2 with SP1 or SQL Server 2012 on a dedicated server that does not run other farm roles and does not host databases for other applications. The only exception is deployment of SharePoint Server 2013 on a stand-alone server, which we do not recommend for large-scale production environments.

Note:

The recommendation to use a dedicated server for relational databases also applies to virtualized SQL Server environments.

Configure specific SQL Server settings before you deploy SharePoint Server 2013

To ensure consistent behavior and performance, configure the following options and settings before you deploy SharePoint Server 2013.

  • Do not enable auto-create statistics on a server that hosts SQL Server and SharePoint Server. Enabling auto-create statistics is not supported for SharePoint Server. SharePoint Server configures the required settings during provisioning and upgrade. Manually enabling auto-create statistics on a SharePoint database can significantly change the execution plan of a query. The SharePoint databases either use a stored procedure that maintains the statistics (proc_UpdateStatistics) or rely on SQL Server to do this.

  • Set max degree of parallelism (MAXDOP) to 1 for instances of SQL Server that host SharePoint databases to make sure that a single SQL Server process serves each request.

    Important:

    Setting the max degree of parallelism to any other number can cause a less optimal query plan to be used that will decrease SharePoint Server 2013 performance.

  • To help simplify maintenance, such as to make it easier to move databases to another server, create DNS aliases that point to the IP address for all instances of SQL Server. For more information about DNS or Hostname aliases, see How to Add a Hostname Alias for a SQL Server Instance.

Harden the database server before you deploy SharePoint Server 2013

We recommend that you plan for, and harden the database server before you deploy SharePoint Server 2013. For more information, see:

  • Plan security hardening for SharePoint 2013

  • Configure SQL Server security for SharePoint 2013 environments

Configure database servers for performance and availability

As is the case with web servers and application servers, the configuration for database servers affects how well SharePoint Server 2013 performs. Some databases have to be on the same server as other databases. Conversely, some databases cannot be on the same server as other databases. For more information, see Capacity management and sizing overview for SharePoint Server 2013.

For guidance about highly available databases that use mirroring, see Database Mirroring (SQL Server) and Database Mirroring on SQL Server 2008 R2.

SQL Server 2012 AlwaysOn

SQL Server 2012 AlwaysOn Availability Groups are a new high availability and disaster recovery solution that are an alternative to database mirroring and log shipping solutions. AlwaysOn Availability Groups support a set of primary read-write databases and up to four sets of secondary databases that can be set as read-only.

AlwaysOn Availability Groups require a Windows Server Failover Clustering (WSFC) cluster. A WSFC resource group is created for every availability group that is created. For more information, see the following resources:

  • Overview of AlwaysOn Availability Groups (SQL Server)

  • AlwaysOn Availability Groups (SQL Server)

  • Configure SQL Server 2012 AlwaysOn Availability Groups for SharePoint 2013

Design storage for optimal throughput and manageability

We recommend that you separate, and prioritize your data among the drives on the database server. Ideally, you should place the tempdb database, content databases, usage database, search databases, and transaction logs on separate physical hard disks. The following list provides some guidance.

  • For collaboration or update-intensive sites, use the following ranking for storage distribution.

    The highest ranked item should be in the fastest drives.

    1. tempdb data files and transaction logs

    2. Content database transaction log files

    3. Search databases, except for the Search administration database

    4. Content database data files

  • In a heavily read-oriented portal site, prioritize data and search over transaction logs as follows.

    The highest ranked item should be in the fastest drives.

    1. tempdb data files and transaction logs

    2. Content database data files

    3. Search databases, except for the Search administration database

    4. Content database transaction log files

  • Testing and user data shows that insufficient disk I/O for tempdb can significantly impede overall farm performance. To avoid this issue, allocate dedicated disks for the drive that stores tempdb data files.

  • For best performance, use a RAID 10 array for the drive that stores tempdb data files. The number of tempdb data files should equal the number of CPU cores, and each tempdb data file should be set to the same size.

  • Separate database data and transaction log files across different disks. If data and log files must share disks due to space limitations, put files that have different usage patterns on the same disk to minimize concurrent access requests.

  • Use multiple data files for heavy-use content databases, and put each on its own disk

  • To improve manageability, monitor and make adjustments as needed to keep content databases below 200 GB, rather than restrict the database size.

    Note:

    If you manually restrict database size in SQL Server, you can cause unexpected system downtime when the capacity is exceeded.

Proper configuration of I/O subsystems is very important to the optimal performance and operation of SQL Server systems. For more information, see SQL Server: Minimize Disk I/O

Tip:

Consider that how you measure disk speed varies between data files and log files. The fastest drives for database data may not be the fastest for log files. Consider usage patterns, I/O, and file size.

Proactively manage the growth of data and log files

Following are recommendations to proactively manage the growth of data and log files:

  • When possible, increase all data files and log files to their expected final size, or periodically increase these at set periods, for example, every month or every six months, or before rollout of a new storage-intensive site such as during file migrations.

  • Enable database autogrowth as a protective measure to make sure that you do not run out of space in data and log files. Consider the following:

    Important:

    You must factor in the performance and operations issues associated with using autogrowth. For more information, see Considerations for the "autogrow" and "autoshrink" settings in SQL Server.

    • The default settings for a new database are to grow by 1 MB increments. Because this default setting for autogrowth results in increases in the size of the database, do not rely on the default setting. Instead, use the guidance provided in Set SQL Server options.

    • Set autogrowth values to a fixed number of megabytes instead of to a percentage. The bigger the database, the bigger the growth increment should be.

      Note:

      Use care when you set the autogrowth feature for SharePoint databases. If you set a database to autogrow as a percentage, for example at a 10-percent (%) growth rate, a database that is 5 GB grows by 500MB every time that a data file has to be expanded. In this scenario, you could run out of disk space.

      Consider for example, a scenario where content is gradually increased, say at 100MB increments, and autogrowth is set at 10MB. Then suddenly a new document management site requires a very large amount of data storage, perhaps with initial size of 50 GB. For this large addition, growth at 500 MB increments is more appropriate than 10MB increments.

    • For a managed production system, consider autogrowth to be merely a contingency for unexpected growth. Do not use the autogrow option to manage your data and log growth on a day-to-day basis. Instead, set the autogrowth to allow for an approximate size in one year and then add a 20 percent margin for error. Also set an alert to notify you when the database runs low on space or approaches a maximum size.

  • Maintain a level of at least 25 percent available space across drives to accommodate growth and peak usage patterns. If you add drives to a RAID array or allocate more storage to manage, monitor capacity closely to avoid running out of space.

Continuously monitor SQL Server storage and performance

We recommend that you continuously monitor SQL Server storage and performance to make sure that each production database server is adequately handling the load put on it. Additionally, continuous monitoring enables you to establish benchmarks that you can use for resource planning.

Take a comprehensive view of resource monitoring. Do not limit monitoring to resources that are specific to SQL Server. It is equally important to track the following resources on computers that are running SQL Server: CPU, memory, cache/hit ratio, and the I/O subsystem.

When one or more of the server resources seems slow or overburdened, consider the following performance guidelines based on the current and projected workload.

  • For SQL Server 2008 R2 with SP1, see Monitoring and Tuning for Performance

  • For SQL Server 2012Monitoring and Tune for Performance

  • Performance Monitoring Getting Started Guide

  • Windows Performance Monitor

Use backup compression to speed up backups and reduce file sizes

Backup compression can speed up SharePoint backup operations. It is available in SQL Server Standard and Enterprise Edition. If you set the compression option in your backup script or configure SQL Server to compress by default, you can significantly reduce the size of your database backups and shipped logs. For more information, see the following resources:

  • For SQL Server 2008 R2 with SP1, see Backup Compression (SQL Server) and Creating Compressed Tables and Indexes

  • For SQL Server 2012, see Backup Compression (SQL Server) and Data Compression

Acknowledgements

The SharePoint Server 2013 Content Publishing team thanks the following contributors to this article:

  • Kay Unkroth, Senior Program Manager, SQL Server

  • Chuck Heinzelman, Senior Program Manager, SQL Server


Monitor health in SharePoint 2013
See also

Updated: May 7, 2013

Summary: Read articles about SharePoint monitoring, configuring SharePoint monitoring properties, viewing SharePoint logs and reports, and troubleshooting SharePoint problems.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The articles in this section are written to meet the requirements of information technology (IT) professionals who are responsible for the planning, design, deployment, and operations of monitoring. These solutions might be in enterprise, corporate, or branch-office environments. The IT professionals who are responsible for monitoring solutions are expected to have an understanding of the technical details that are contained in this section. However, service-level expertise is not needed to understand the enterprise-level discussions and decisions.

The monitoring features in SharePoint 2013 help you understand how SharePoint 2013 is running, analyze and repair problems, and view metrics for the sites.

TechNet articles about how to monitor SharePoint 2013

The following articles about how to monitor SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Overview of monitoring in SharePoint 2013 | Learn about configuring monitoring, viewing SharePoint reports and logs, and using SharePoint Health Analyzer rules.
 | Configure monitoring in SharePoint 2013 | Provides links to articles about SharePoint diagnostic logging, SharePoint Health Analyzer timer jobs and rules, and usage and health data.
 | View reports and logs in SharePoint 2013 | Get links to articles about how to view SharePoint reports, timer job status, cache performance, and the SharePoint logging database.
 | Solving problems and troubleshooting in SharePoint 2013 | Read how to use SharePoint Health Analyzer to view alerts, or use Invoke-AlertFixup to update alerts when a web application's URL changes.
Scripted monitoring configuration in SharePoint 2013 | Read articles about scripted monitoring configuration for SharePoint 2013 to apply monitoring settings across an entire environment.
 | Monitoring scenarios in SharePoint 2013 | Learn about monitoring scenarios in SharePoint 2013 and tools that help to maintain a reliable environment.

See also

Plan for monitoring in SharePoint 2013

Change History

Date | Description
May 07, 2013 | Added link to Scripted monitoring configuration in SharePoint 2013.
October 16, 2012 | Initial publication


Overview of monitoring in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn about configuring monitoring, viewing SharePoint reports and logs, and using SharePoint Health Analyzer rules.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The primary goal of monitoring is to ensure a healthy SharePoint 2013 environment so that you can achieve service performance objectives such as short response time. You can use the monitoring features from the SharePoint Central Administration website, System Center Management Pack for SharePoint Server 2013, and Windows PowerShell scripts to monitor the SharePoint 2013 environment and services.

Logs and reports track SharePoint 2013 environment and service status. You can read the logs from the logging database. The advantage of using logging database is that you can configure your view and export the logs to Excel. The logs and reports from Central Administration help you understand how the SharePoint 2013 system is running, analyze and repair problems, and view metrics for the sites. In addition, System Center Management Pack for SharePoint Server 2013 provides an end-to-end monitoring and reporting system that you can use to monitor SharePoint 2013.

Monitoring the SharePoint 2013 environment includes the following tasks:

  • Configuring the various aspects of monitoring to suit business needs.

  • Viewing reports and logs to monitor the SharePoint 2013 environment.

  • Monitoring and resolving problems by using SharePoint Health Analyzer

In this article:

  • Configuring monitoring in a SharePoint environment

  • Viewing SharePoint reports and logs

  • Monitoring and resolving problems by using SharePoint Health Analyzer

Configuring monitoring in a SharePoint environment

SharePoint 2013 comes installed with default settings for its monitoring features. However, you might want to change some of these settings to better suit business needs. These settings include diagnostic logging and usage and health data collection. Diagnostic logging collects data about the SharePoint 2013 farm environment. Usage and health data is collected for SharePoint 2013 services.

Diagnostic logging

SharePoint 2013 collects data in the diagnostic log that you can use to troubleshoot the SharePoint 2013 farm environment. The default settings are sufficient for most situations, but depending upon the business needs and lifecycle of the farm, you might want to change these settings. For example, if you are deploying a new feature or making large-scale changes to the environment, you might want to change the logging level to either a more verbose level, to capture as much data about the state of the system during the changes, or to a lower level to reduce the size of the log and the resources that are required to log the data. For more information and best practices, see Configure diagnostic logging in SharePoint 2013.

Usage and health data collection and timer job

Usage and health data is collected to show how SharePoint 2013 is used. The system writes usage and health data to the logging folder and the logging database. The usage and health data might consist of performance counter data, event log data, timer service data, metrics for site collections and sites, search usage data, or various performance aspects of the Web servers. The system uses this data to create health reports, and administrative reports.

Many features in SharePoint 2013 rely on timer jobs to run services according to a schedule. SharePoint 2013 uses specific timer jobs to regularly monitor tasks and collect monitoring data. A timer job specifies the service to run and how frequently the service should be started. The SharePoint Timer Service (SPTimerV4) runs timer jobs.

You might want timer jobs to run more frequently or less frequently. You might even want to disable jobs that collect data that you are not interested in. You can perform the following tasks on timer jobs:

  • Modify the schedule that the timer job runs on.

  • Run timer jobs immediately.

  • Enable or disable timer jobs.

  • View timer job status. You can view currently scheduled jobs, failed jobs, currently running jobs, and a complete timer job history.

For more information, see Configure SharePoint Health Analyzer timer jobs in SharePoint 2013.

Viewing SharePoint reports and logs

SharePoint 2013 can be configured to collect data and create reports about server status, site use and search. See the following resources:

  • View health reports in SharePoint 2013. Health reports include slowest pages and top active pages.

  • Usage reports.

You can view logs by using Windows PowerShell or read the logs directly from the logging database. You can monitor cache performance and search. And you can also view the timer job status.

The following resources give more information about reports and logs:

  • To learn how to get detailed information about any problems that arise, see View diagnostic logs in SharePoint 2013.

  • To ensure that the farm cache settings are correct and that the caching is running at maximum performance, see Monitor cache performance in SharePoint 2013.

  • To review and update the timer jobs, see View timer job status in SharePoint 2013.

Monitoring and resolving problems by using SharePoint Health Analyzer

SharePoint 2013 includes an integrated health analysis tool that is named SharePoint Health Analyzer that you can use to check for potential configuration, performance, and usage problems. SharePoint Health Analyzer runs predefined health rules against servers in the farm. A health rule runs a test and returns a status that tells you the outcome of the test. When any rule fails, SharePoint Health Analyzer creates an alert on the Review problems and solutions page and writes status to the Windows Event log. You can click an alert to view more information about the problem and see steps to resolve the problem. You can also open the rule that raised the alert and change its settings.

You can also edit Health Analyzer Reports list items, create custom views, export the list items into Excel, subscribe to the RSS feed for the list, and perform many other tasks. Each health rule falls in one of the following categories: Security, Performance, Configuration, or Availability.

All health rules are available through Central Administration, on the Monitoring page. Farm administrators can configure specific health rules to do the following:

  • Enable or disable rules.

  • Configure rules to run on a predefined schedule.

  • Define the scope where the rules run.

  • Receive e-mail alerts when problems are found.

  • Run rules on a defined schedule or on an impromptu basis.

For more information about configuring these settings, see Configure SharePoint Health Analyzer rules in SharePoint 2013.

For more information about the health rules and how to troubleshoot problems in SharePoint 2013, see SharePoint Health Analyzer rules reference (SharePoint 2013).

See also

Overview of monitoring in SharePoint 2013
Plan for monitoring in SharePoint 2013


Configure monitoring in SharePoint 2013
See also

Published: October 16, 2012

Summary: Provides links to articles about SharePoint diagnostic logging, SharePoint Health Analyzer timer jobs and rules, and usage and health data.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The articles in this section are written to meet the requirements of information technology (IT) professionals who are responsible for the planning, design, deployment, and operations of monitoring. These solutions might be in enterprise, corporate, or branch-office environments. The IT professionals who are responsible for monitoring solutions are expected to have an understanding of the technical details that are contained in this section. However, service-level expertise is not needed to understand the enterprise-level discussions and decisions.

The SharePoint 2013 environment might require you to configure monitoring settings after initial deployment or upgrade. You might have to change the information that is collected for monitoring, when and how often it is collected, or other logging settings that better suit the business and environment requirements.

Configure monitoring

Included in this section:

  • Configure diagnostic logging in SharePoint 2013

  • Configure SharePoint Health Analyzer timer jobs in SharePoint 2013

  • Configure usage and health data collection in SharePoint 2013

  • Configure SharePoint Health Analyzer rules in SharePoint 2013

See also

Monitor health in SharePoint 2013


Configure diagnostic logging in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn to configure diagnostic logging in SharePoint 2013 from the SharePoint Central Administration website or by using Windows PowerShell.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

In this article:

  • Before you begin

  • Diagnostic logging setting best practices

  • Configure diagnostic logging by using Central Administration

  • Configure diagnostic logging by using Windows PowerShell

Before you begin

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Verify that the user account that is performing procedures from Central Administration is a member of the Farm Administrators SharePoint group.

Diagnostic logging setting best practices

The SharePoint 2013 environment might require configuration of the diagnostic logging settings after initial deployment, after upgrade, and if a change is made to the environment, such as adding or removing a server. The guidelines in the following list can help you form best practices for the specific environment.

  • Change the drive to which the server writes logs.

    By default, SharePoint 2013 writes diagnostic logs to the same drive and partition on which it was installed. Because diagnostic logging can use a large amount of drive space and compromise drive performance, you should configure SharePoint 2013 to write to another drive on which SharePoint 2013 is not installed. You should also consider the connection speed to the drive on which SharePoint 2013 writes the logs. If verbose-level logging is configured, the server records a large amount of data. Therefore, a slow connection might result in poor log performance.

  • Restrict log disk space usage.

    By default, the amount of disk space that diagnostic logging can use is unlimited. Therefore, restrict the disk space that logging uses, especially if you configure logging to write verbose-level events. When the disk reaches the restriction, SharePoint 2013 removes the oldest logs before it records new logging data.

  • Use the Verbose setting sparingly.

    You can configure diagnostic logging to record verbose-level events. This means that SharePoint 2013 records every action that it takes. Verbose-level logging can quickly use drive space and affect drive and server performance. You can use verbose-level logging to record more detail when you are making critical changes and then reconfigure logging to record only higher-level events after you make the change.

  • Regularly back up logs.

    Diagnostic logs contain important data. Therefore, back up the logs regularly to ensure that this data is preserved. When you restrict log drive space usage, or if you keep logs for only a few days, SharePoint 2013 automatically deletes log files, starting with the oldest files first, when the threshold is met.

  • Enable event log flooding protection.

    When you enable this setting, SharePoint 2013 detects repeating events in the Windows event log, and suppresses them until conditions return to a typical state.

You can set the level of diagnostic logging for the event log and for the trace log. This limits the types and amount of information that are written to each log. The following tables define the levels of logging that are available for the event log and trace log.

Event log levels

Level | Definition
None | No logging occurs.
Critical | This message type indicates a serious error that has caused a major failure in the solution.
Error | This message type indicates an urgent condition. You should investigate all error events.
Warning | This message type indicates a potential problem or issue that might require attention. You should review and track warning messages for patterns over time.
Information | Information messages do not require any action. However, they can provide valuable data for monitoring the state of your solution.
Verbose | This event log level corresponds to lengthy events or messages.

Trace log levels

Level | Definition
None | No trace logs are written.
Unexpected | This level records messages about events that cause solutions to stop processing. When set to this level, the log will include events at the Unexpected, Exception, Assert, and Critical levels.
Monitorable | This level records messages about all unrecoverable events that limit the functionality of the solution but do not stop the application. When set to this level, the log also includes events that the Unexpected setting records.
High | This level records all events that are unexpected but which do not stop the processing of a solution. When set to log at this level, the log also includes all events that the Monitorable setting records.
Medium | When set to this level, the trace log includes all messages except Verbose and VerboseEx messages. This level records all high-level information about operations that were performed. This level provides enough detail to construct the data flow and sequence of operations. Administrators or support professionals could use this level of logging to troubleshoot issues. When set to this level, the log will also include all events that the High setting records.
Verbose | When set to this level, the log includes most actions. Verbose tracing produces many log messages. This level is typically used only for debugging in a development environment. When set to log at this level, the log will also include all events that the Medium setting records.
VerboseEx | This level is only supported by the Set-SPLogLevelWindows PowerShell cmdlet, and includes very low-level diagnostic data. This level should only be used in a development environment. When set to this level, the log includes all events that the Verbose setting records.

Configure diagnostic logging by using Central Administration

You can use the SharePoint Central Administration website to configure diagnostic logging.

To configure diagnostic logging by using Central Administration

  1. In Central Administration, on the home page, click Monitoring.

  2. On the Monitoring page, in the Reporting section, click Configure diagnostic logging.

  3. On the Diagnostic Logging page, in the Event Throttling section, configure event throttling as follows:

    To configure event throttling for all categories:

    1. Select the All Categories check box.

    2. Select the event log level from the Least critical event to report to the event log list.

    3. Select the trace log level from the Least critical event to report to the trace log list.

    To configure event throttling for one or more categories:

    1. Select the check boxes of the categories that you want.

    2. Select the event log level from the Least critical event to report to the event log list.

    3. Select the trace log level from the Least critical event to report to the trace log list.

    To configure event throttling for one or more subcategories (you can expand one or more categories and select any subcategory):

    1. Click the plus (+) next to the category to expand the category.

    2. Select the check box of the subcategory.

    3. Select the event log level from the Least critical event to report to the event log list.

    4. Select the trace log level from the Least critical event to report to the trace log list.

    To return event throttling for all categories to default settings:

    1. Select the All Categories check box.

    2. Select Reset to default from the Least critical event to report to the event log list.

    3. Select Reset to default from the Least critical event to report to the trace log list.

  4. In the Event Log Flood Protection section, select the Enable Event Log Flood Protection check box.

  5. In the Trace Log section, in the Path box, type the path of the folder to which you want logs to be written.

  6. In the Number of days to store log files box, type the number of days (1-366) that you want logs to be kept. After this time, logs will automatically be deleted.

  7. To restrict the disk space that logs can use, select the Restrict Trace Log disk space usage check box, and then type the number gigabytes (GB) you want to restrict log files to. When logs reach this value, older logs will automatically be deleted.

  8. After you have made the changes that you want on the Diagnostic Logging page, click OK.

Configure diagnostic logging by using Windows PowerShell

You can use Windows PowerShell to configure diagnostic logging.

To configure diagnostic logging by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. To change the drive to which the server writes logs, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPDiagnosticConfig -LogLocation D:\DiagnosticLogs

  6. To restrict log disk space usage, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPDiagnosticConfig -LogMaxDiskSpaceUsageEnabled

    Or assign the maximum disk space for logs:

    Copy code
    Set-SPDiagnosticConfig -LogDiskSpaceUsageGB 500

  7. To change the logging level, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPLogLevel -TraceSeverity Monitorable

    To set all categories back to default levels, at the Windows PowerShell command prompt, type the following command, and then press ENTER:

    Copy code
    Clear-SPLogLevel

  8. To enable event log flooding protection, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPDiagnosticConfig -EventLogFloodProtectionEnabled

For more information, see Set-SPDiagnosticConfig and Set-SPLogLevel.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Overview of monitoring in SharePoint 2013


Configure SharePoint Health Analyzer timer jobs in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn to configure health data collection timer jobs by using the SharePoint Central Administration website or Windows PowerShell.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint Health Analyzer uses timer jobs to collect health data and then writes the data to the logging folder and to the Logging database. This data is used in reports to display health of the farm servers. You can reschedule these timer jobs, run them immediately, or enable or disable them.

On that page, you can also configure usage data collection, event selection, and usage data collection settings. For more information, see Configure usage and health data collection in SharePoint 2013.

In this article:

  • Use Central Administration to configure health data collection timer jobs

  • Use Windows PowerShell to configure health data collection timer jobs

Before you begin

For more information about SharePoint 2013 monitoring configuration, see Configure monitoring in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Use Central Administration to configure health data collection timer jobs

You can use Central Administration to configure health data collection timer jobs.

To configure health data collection timer jobs by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

    Note:

    The health data collection timer job settings are farm-wide and cannot be set for individual servers in the farm.

  2. In Central Administration, on the home page, click Monitoring.

  3. On the Monitoring page, in the Reporting section, click Configure usage and health data collection.

  4. On the Configure usage and health data collection page, in the Health Data Collection section, click Enable health data collection.

  5. In the Health Data Collection section, click Health Logging Schedule. The Job Definitions page opens. It lists all the timer jobs that collect health data.

  6. On the Job Definitions page, click the timer job that you want to configure.

  7. On the Edit Timer Job page, in the Recurring Schedule section, change the timer job schedule, and then click OK.

Use Windows PowerShell to configure health data collection timer jobs

You can configure the health data collection timer job schedule by using Windows PowerShell.

To configure health data timer jobs by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPTimerJob -Identity <SPTimerJobPipeBind> -Schedule <ScheduleString>

    The value of the Identity parameter specifies the timer job. If you do not use the Identity parameter, all timer jobs are configured. To see a list of all the timer jobs, type the following command:

    Copy code
    Get-SPTimerJob | Format-Table -property id,title

    <SPTimerJobPipeBind> can be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a timer job (for example, TimerJob1); or an instance of a valid SPTimerJob object.

    Use the value of the Schedule parameter to specify the schedule, where <ScheduleString> is one of the following:

    • Every 5 minutes between 0 and 59

    • Hourly between 0 and 59

    • Daily at 15:00:00

    • Weekly between Fri 22:00:00 and Sun 06:00:00

    • Monthly at 15 15:00:00

    • Yearly at Jan 1 15:00:00

    To see examples of timer job schedules, type the following command:

    Copy code
    Get-SPTimerJob | Format-Table -property id,title,schedule

For more information, see Get-SPTimerJob and Set-SPTimerJob.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Overview of monitoring in SharePoint 2013


Configure usage and health data collection in SharePoint 2013
See also

Published: August 15, 2012

Summary: Learn how to configure usage and health data collection in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint 2013 writes usage and health data to the logging folder and to the logging database. You can use the SharePoint Central Administration website to configure health data collection settings.

In this article:

  • Before you begin

  • Configure usage and health data collection by using Central Administration

  • Configure usage data collection by using Windows PowerShell

  • Configure usage data collection for events by using Windows PowerShell

  • Log usage data in a different logging database by using Windows PowerShell

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support in SharePoint 2013

  • Accessibility features in SharePoint Products

  • Keyboard shortcuts

  • Touch

Configure usage and health data collection by using Central Administration

The usage and health data settings are farm-wide and cannot be set for individual servers in the farm.

To configure usage and health data collection by using Central Administration:

  1. Verify that you have the following administrative credentials:

    The user account that performs this procedure has to be a member of the Farm Administrators group.

  2. In Central Administration, on the home page, click Monitoring.

  3. On the Monitoring page, in the Reporting section, click Configure usage and health data collection.

  4. On the Configure usage and health data collection page, in the Usage Data Collection section, select the Enable usage data collection check box.

  5. In the Event Selection section, select the check boxes of the events that you want to log.

    Logging uses system resources and can affect performance and disk usage. Only log those events for which you want regular reports.

    For impromptu reports or investigations, enable logging for events, and then disable logging for the events after the report or investigation is complete. For more information, see Configure usage data collection for events by using Windows PowerShell.

  6. In the Usage Data Collection Settings section, type the path of the folder to which you want usage and health information to be written in the Log file location box. The path that you specify must exist on each server in the farm.

    These settings are applied to all events.

  7. In the Health Data Collection section, select the Enable health data collection check box. To change the collection schedules, click Health Logging Schedule. You can see a list of timer jobs that collect health data. Click any of the timer jobs to change its schedule, or disable that timer job. If you disable a timer job, it stops collecting corresponding health data. For more information, see Timer job reference (SharePoint 2013).

  8. To change log collection schedules, click Log Collection Schedule, and then click any of the timer jobs to change its schedule, or disable that timer job. If you disable a timer job, it stops collecting corresponding log data.

  9. In the Logging Database Server section, to change the authentication method, select either the Windows authentication or SQL authentication option.

    To change the Database Server and Database Name values, you must use Windows PowerShell. For more information, see Log usage data in a different logging database by using Windows PowerShell.

Configure usage data collection by using Windows PowerShell

To configure usage data collection by using Windows PowerShell:

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPUsageService [-LoggingEnabled {1 | 0}] [-UsageLogLocation <Path>] [-Verbose]

    Where <Path> is a path that exists on each computer in the farm.

    To view the progress of the command, use the Verbose parameter.

    Enable usage data logging by typing.

    Copy code
    Set-SPUsageService -LoggingEnabled 1

For more information, see Set-SPUsageService.

Configure usage data collection for events by using Windows PowerShell

The event types that are listed on the Configure usage and health data collection page in Central Administration are the same as Usage Definitions in Windows PowerShell. You can use only Windows PowerShell to configure usage definitions individually. Moreover, you can configure only the DaysRetained parameter.

To configure usage data logging for events by using Windows PowerShell:

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPUsageDefinition -Identity <SPUsageDefinitionPipeBind> [-Enable] [-DaysRetained <0-31>] [-Verbose]

    Where <SPUsageDefinitionPipeBind> specifies the usage definition object that you want to update. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a usage definition (for example, SiteSubscriptionConfig1); or an instance of a valid SPUsageDefinition object. You can use the Windows PowerShellGet-SPUsageDefinition cmdlet to obtain this GUID. For more information, see Get-SPUsageDefinition.

    Use the Enable parameter to enable usage logging for this usage definition. Use the DaysRetained parameter to specify how long the usage data is retained in the log before it is deleted. The range is 0 to 31 days. To view the progress of the command, use the Verbose parameter.

For more information, see Set-SPUsageDefinition.

Log usage data in a different logging database by using Windows PowerShell

You can use Windows PowerShell to change this setting.

To log usage data in a different logging database by using Windows PowerShell:

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt type the following command:

    Copy code
    Set-SPUsageApplication -DatabaseServer <DatabaseServerName> -DatabaseName <DatabaseName> [-DatabaseUserName <UserName>] [-DatabasePassword <Password>] [-Verbose]

    Where:

    • <DatabaseServerName> is the name of host server for the logging database. You must specify a value for the DatabaseServer parameter, even if the new database is located on the same database server as the old one.

    • <DatabaseName> is the name of the logging database.

    • <UserName> is the user name to use for connecting to the logging database. Use this parameter only if SQL Server Authentication is used to access the logging database.

    • <Password> is the password for the user specified in DatabaseUserName. You must specify both <UserName> and <Password> if the database owner is a different user account than the one with which you logged on.

    To view the progress of the command, use the Verbose parameter.

For more information, see Set-SPUsageApplication.

See also

Overview of monitoring in SharePoint 2013


Configure SharePoint Health Analyzer rules in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn to configure SharePoint Health Analyzer rules by using Central Administration.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Before you begin

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configuring SharePoint Health Analyzer rules

You can accept the default settings for each health rule, or you can change settings for a health rule by using Central Administration.

To configure health rules by using Central Administration

  1. Verify that the user account that performs this procedure is a member of the Farm Administrators group.

  2. In Central Administration, on the home page, click Monitoring.

  3. On the Monitoring page, under Health Analyzer, click Review rule definitions.

  4. On the Health Analyzer Rule Definitions page, click the rule that you want to configure.

  5. In the Health Analyzer Rule Definitions dialog, click Edit Item.

  6. Edit one or more rule fields, and then click Save.

    To leave the rule unchanged, either dismiss the dialog or click Cancel.

Each health rule has configurable fields, which are described in the following table.

Configurable fields for SharePoint Health Analyzer rules

Configurable field Description

Title

The name of the health rule. You can rename a health rule to clarify its functionality. The title is the name of the rule as it appears in the Health Rule Definitions list in Central Administration.

Changing the title does not affect how the rule runs.

Scope

You can set a health rule to run against all servers or any server. If set to any server, the rule will run on the first available server that the system encounters.

Schedule

You can schedule a health rule to run hourly, daily, weekly, monthly, or on demand only.

Enabled

You can select or clear this check box to enable or disable a health rule.

Repair Automatically

You can specify whether a health rule automatically attempts to repair errors that it finds. If this option is selected, SharePoint 2013 will repair errors as soon as they are found, as defined by the rule.

Note:

If no repair is specified by the rule, the system does not attempt to repair the problem.

Version

Version history enables you to track the changes performed on each rule. The version number is updated every time that the rule is saved. The version number does not affect how the rule works.

Each health rule has read-only fields, which are described in the following table.

Read-only fields for SharePoint Health Analyzer rules

Read-only field | Description
Version | The current version number of the rule.
Created at | The date and time that the rule was originally created and the user account that created the rule.
Last modified at | The date and time that the rule was last changed and the user account that created the rule.

For more information about SharePoint 2013 monitoring configuration, see Configure monitoring in SharePoint 2013.

See also

SharePoint Health Analyzer rules reference (SharePoint 2013)


View reports and logs in SharePoint 2013
See also

Published: October 16, 2012

Summary: Get links to articles about how to view SharePoint reports, timer job status, cache performance, and the SharePoint logging database.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The articles in this section are written to meet the requirements of information technology (IT) professionals who are responsible for the planning, design, deployment, and operations of monitoring. These solutions might be in enterprise, corporate, or branch-office environments. The IT professionals who are responsible for monitoring solutions are expected to have an understanding of the technical details that are contained in this section. However, service-level expertise is not needed to understand the enterprise-level discussions and decisions.

You can monitor the SharePoint 2013 environment by viewing health reports of the system and sites and diagnostic logs that provide detailed information about any problems that might arise.

In this section:

  • View health reports in SharePoint 2013

  • View diagnostic logs in SharePoint 2013

  • View timer job status in SharePoint 2013

  • Monitor cache performance in SharePoint 2013

  • View data in the logging database in SharePoint 2013

See also

Monitor health in SharePoint 2013


View health reports in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn to view SharePoint 2013 health reports from the SharePoint Central Administration website.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to view health reports in SharePoint 2013.

Health reports are pre-built reports in SharePoint 2013 that use usage data to analyze various aspects of sites and site collections such as slowest pages and top active users.

Note:

You cannot use Windows PowerShell to view health report data.

Before you begin

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

View health reports by using Central Administration

You can view health reports only by using Central Administration.

To view health reports by using Central Administration

  1. Verify that the user account that is performing this operation is a member of the Farm Administrators SharePoint group.

  2. In Central Administration, on the home page, click Monitoring.

  3. On the Monitoring page, in the Reporting section, click View health reports.

  4. On the report page, in the Quick Launch, click the name of the report that you want to view.

  5. To view report data, select the data criteria, and then click Go.

  6. To sort rows, click the column name.

See also

Overview of monitoring in SharePoint 2013
View reports and logs in SharePoint 2013


View diagnostic logs in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn to view and filter log events by using Windows PowerShell, and view and export diagnostic logs by using the Out-GridView cmdlet.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can use data from the Unified Logging Service (ULS) logs in SharePoint 2013 to troubleshoot problems in the farm. The ULS logs can collect data at varying levels depending on the logging settings. You can use Windows PowerShell to filter the data, display it in various ways, and output the data to a data grid with which you can filter, sort, group, and export data to Excel 2013.

For more information, see Configure diagnostic logging in SharePoint 2013. For more information about viewing SharePoint 2013 reports and logs, see View reports and logs in SharePoint 2013.

In this article:

  • View and filter log events by using Windows PowerShell

  • View and export diagnostic logs by using the Windows PowerShell Out-GridView cmdlet

Before you begin

For more information about viewing SharePoint 2013 reports and logs, see View reports and logs in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

View and filter log events by using Windows PowerShell

You can use Windows PowerShell to view and filter log events. You cannot view or filter log events by using the SharePoint Central Administration website.

To view and filter log events by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    • All trace events:

      Copy code
      Get-SPLogEvent

    • By level:

      Copy code
      Get-SPLogEvent | Where-Object {$_.Level -eq "Information" }

    • By area:

      Copy code
      Get-SPLogEvent | Where-Object {$_.Area -eq <Area>}

      Where <Area> is the value of the Area property.

    • By category:

      Copy code
      Get-SPLogEvent | Where-Object {$_.Category -eq <Category>

      Where <Category> is the value of the Category property.

    • By event ID:

      Copy code
      Get-SPLogEvent | Where-Object {$_.EventID -eq <EventID>}

      Where <EventID> is the value of the EventID property.

    • By message text:

      Copy code
      Get-SPLogEvent | Where-Object {$_.Message -like "<string>"}

      Where <string> is the string found in the event message.

    • By process:

      Copy code
      Get-SPLogEvent | Where-Object {$_.Process -like "<Process>"}

      Where <Process> is the value of the Process property.

    By default, the command retrieves data from the default ULS log folder. To view and filter trace events that are on shared folder on a network, use the Directory parameter of the Get-SPLogEvent cmdlet.

    To view more details about each trace event, use the Format-List cmdlet at the end of the command. For example,

    Copy code
    Get-SPLogEvent | Where-Object {$_.Area -eq "SharePoint Foundation"} | Format-List

For more information, see Get-SPLogEvent.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

View and export diagnostic logs by using the Windows PowerShell Out-GridView cmdlet

Windows PowerShell provides a powerful and easy-to-use feature that displays tabular data resulting from Windows PowerShell commands in a filterable, searchable data grid in a separate window. You can use this grid to view log events and to perform the following operations on the data:

  • Sort the data by any column.

  • View the data in groups.

  • Filter the data by Level, Area, Category, Message, Event ID, or Timestamp.

  • Search the data for any string.

  • Export raw or sorted or filtered data to a spreadsheet.

Note:

The Out-GridView cmdlet cannot be used with cmdlets that use the Format verb. The Out-GridView cmdlet receives objects whereas the cmdlets that use the Format verb return only formatted text.

You can view a subset of the data by using the Where-Object cmdlet that filters and passes the results to the Out-GridView cmdlet. For example, Get-SPLogEvent | Where-Object {$_.Area -eq "SharePoint Foundation"} | Out-GridView.

If the grid is displaying more than several hundred rows, it might run slowly, especially if performing complex filtering operations. For faster performance, export the data to Excel 2013.

To view and filter diagnostic logs by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPLogEvent | Out-GridView

  6. To sort columns, click the column header.

  7. To search for a specific string, type the string in the Filter box. Search is performed over all columns and rows. To clear the search, click X.

  8. To filter data on only one criterion, type the following in the Search box: <property name>:<value>. For example, to search for all log entries raised by SharePoint Foundation 2013, type the following: Area:SharePoint Foundation. To clear the filter, click X.

  9. To filter data by using more than one criterion or by using criteria with "contains, begins with, ends with" or other methods:

    1. Click Add criteria button.

    2. Click the check box for the properties that you want to filter on, and then click Add.

    3. Click contains to change to a different filter method. The methods that are available are contains, does not contain, starts with, equals, does not equal, ends with, is empty, and is not empty.

    4. Type a value in the text box.

    5. Repeat steps "c" and "d" for each property that you selected in step "b".

    6. When all the filtering criteria are specified, the data that satisfies the criteria will appear.

    7. To clear a specific filter, click the X button.

    8. To clear all the filters, collapse the query view and then click the Clear All button.

To export grid data to a spreadsheet

  1. Select the rows that you want to export. You can select multiple rows by using SHIFT+DRAG to select a block of rows, CTRL+CLICK to select specific rows, or CTRL+A to select all rows.

    You can also filter and sort the results before you copy the data into a spreadsheet. When you sort or filter data, only the resulting viewable data is copied over.

  2. Copy the selected rows by using CTRL+C.

  3. Open the spreadsheet workbook page, and then paste the copied rows into it by using CTRL+V.

For more information, see Out-GridView (http://go.microsoft.com/fwlink/p/?LinkId=181248) and Out-GridView Revisited (http://go.microsoft.com/fwlink/p/?LinkId=181249).

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Configure diagnostic logging in SharePoint 2013
Overview of monitoring in SharePoint 2013


View timer job status in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn to view SharePoint timer job status by using the SharePoint Central Administration website or Windows PowerShell.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A timer job runs a specific Windows service for SharePoint 2013. The timer job contains a definition of the service to run and specifies how frequently the service is started. The SharePoint Timer Service runs timer jobs. Many features in SharePoint 2013 rely on timer jobs to run services according to a schedule. You can view the status of timer jobs that have been run by using the Central Administration website or Windows PowerShell.

In this article:

  • View timer job status by using Central Administration

  • View timer job status by using Windows PowerShell

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

View timer job status by using Central Administration

You can view timer job status by using Central Administration.

To view timer job status by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. In Central Administration, on the home page, click Monitoring.

  3. On the Monitoring page, in the Timer Jobs section, click Check job status.

  4. Timer job status is divided into three groups: Scheduled, Running, and History. To page through the timer job status data rows, click the paging arrows at the bottom of these groups.

  5. To view the timer job status for a specific group, click the title of the group. Or, in the Quick Launch, click Scheduled Jobs, Running Jobs, or Job History.

View timer job status by using Windows PowerShell

You can view timer job status by using Windows PowerShell.

To view timer job status by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPTimerJob -Identity <SPTimerJobPipeBind> | Format-Table DisplayName,Id,LastRunTime,Status

    Where <SPTimerJobPipeBind> can be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a timer job (for example, TimerJob1); or an instance of a valid SPTimerJob object.

    You can use the value of the Identity parameter to specify a timer job. If you do not use the Identity parameter, all timer jobs are returned.

    To view the history of a specific timer job, type the following command:

    Copy code
    (Get-SPTimerJob -Identity <SPTimerJobPipeBind>).HistoryEntries | Format-Table -Property Status,StartTime,EndTime,ErrorMessage

    Where <SPTimerJobPipeBind> can be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a timer job (for example, TimerJob1); or an instance of a valid SPTimerJob object.

For more information, see Get-SPTimerJob.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

View reports and logs in SharePoint 2013
Overview of monitoring in SharePoint 2013


Monitor cache performance in SharePoint 2013

Published: October 16, 2012

Summary: Learn how to monitor the SharePoint BLOB cache, the ASP.NET output cache, and the SharePoint object cache.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

By monitoring cache performance, you can make sure that that the farm cache settings are correct and that the caching is running at maximum performance.

In this article:

  • About cache monitoring

  • Monitoring BLOB cache performance

  • Monitoring ASP.NET output cache performance

  • Monitoring object cache performance

Before you begin

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

About cache monitoring

SharePoint 2013 provides three types of caches that help improve the speed at which web pages load in the browser: the BLOB cache, the ASP.NET output cache, and the object cache.

  • The BLOB cache is a disk-based cache that stores binary large object files that are used by web pages to help the pages load quickly in the browser.

  • The ASP.NET output cache stores the rendered output of a page. It also stores different versions of the cached page, based on the permissions of the users who are requesting the page.

  • The object cache reduces the traffic between the web server and the SQL database by storing objects such as lists and libraries, site settings, and page layouts in memory on the front-end web server. As a result, the pages that require these items can be rendered quickly, increasing the speed with which pages are delivered to the client browser.

Monitoring consists of regularly viewing specific performance monitors and making adjustments in the settings to correct any performance issues. The monitors measure cache hits, cache misses, cache compactions, and cache flushes. The following list describes each of these performance monitors.

  • A cache hit occurs when the cache receives a request for an object whose data is already stored in the cache. A high number of cache hits indicates good performance and a good end-user experience.

  • A cache miss occurs when the cache receives a request for an object whose data is not already stored in the cache. A high number of cache misses might indicate poor performance and a slower end-user experience.

  • Cache compaction (also known as trimming), happens when a cache becomes full and additional requests for non-cached content are received. During compaction, the system identifies a subset of the contents in the cache to remove, and removes them. Typically these contents are not requested as frequently.

    Compaction can consume a significant portion of the server's resources. This can affect both server performance and the end-user experience. Therefore, compaction should be avoided. You can decrease the occurrence of compaction by increasing the size of the cache. Compaction usually happens if the cache size is decreased. Compaction of the object cache does not consume as many resources as the compaction of the BLOB cache.

  • A cache flush is when the cache is completely emptied. After the cache is flushed, the cache hit to cache miss ratio will be almost zero. Then, as users request content and the cache is filled up, that ratio increases and eventually reaches an optimal level. A consistently high number for this counter might indicate a problem with the farm, such as constantly changing library metadata schemas.

You can monitor the effectiveness of the cache settings to make sure that the end-users are getting the best experience possible. Optimum performance occurs when the ratio of cache hits to cache misses is high and when compactions and flushes only rarely occur. If the monitors do not indicate these conditions, you can improve performance by changing the cache settings.

The following sections provide specific information for monitoring each kind of cache.

Monitoring BLOB cache performance

You can monitor the effectiveness of the cache settings by using the performance monitors that are listed in the following table.

SharePoint Publishing Cache counter group

Counter name | Ideal value or pattern | Notes
Total Number of cache Compactions | 0 | If this number is continually or frequently high, the cache size is too small for the data being requested. To improve performance, increase the size of the cache.
BLOB Cache % full | >= 90% shows red >= 80% shows yellow <80% shows green | This can show that the cache size is too small. To improve performance, increase the size of the cache.
Publishing cache flushes / second | 0 | Site owners might be performing actions on the sites that are causing the cache to be flushed. To improve performance during peak-use hours, make sure that site owners only perform these actions during off-peak hours.
Publishing cache hit ratio | Depends on usage pattern. For read-only sites, the ratio should be 1. For read-write sites, the ratio may be lower. | A low ratio can indicate that unpublished items are being requested, and these cannot be cached. If this is a portal site, the site might be set to require check-out, or many users have items checked out.
Note:

For the BLOB cache, a request is only counted as a cache miss if the user requests a file whose extension is configured to be cached. For example, if the cache is enabled to cache .jpg files only, and the cache gets a request for a .gif file, that request is not counted as a cache miss.

Monitoring ASP.NET output cache performance

You can monitor the effectiveness of the cache settings by using the performance monitors that are listed in the following table.

ASP.NET Applications counter group

Counter name Ideal value or pattern Notes

Cache API trims

0

Increase the amount of memory that is allocated to the ASP.NET output cache.

Cache API hit ratio

Depends on usage pattern. For read-only sites, the ratio should be 1. For read-write sites, the ratio may be lower.

Potential causes of a low hit ratio include the following:

  • If you are using anonymous user caching (for example, for an Internet-facing site), users are regularly requesting content that has not yet been cached.

  • If you are using ASP.NET output caching for authenticated users, many users may have edit permissions on the pages that they are viewing.

  • If you have customized any of the VaryBy* parameters on any page (or master page or page layout) or customized a cache profile, you may have configured a parameter that prevents the pages in the site from being cached effectively (For example, you might be varying by user for a site that has many users).

Note:

For the ASP.NET output cache, all pages are cached for a fixed duration that is independent of user actions. Therefore, there are flush-related monitoring events.

For more information about the ASP.NET output cache, see Output Caching and Cache Profiles (http://go.microsoft.com/fwlink/p/?LinkID=121543) or cache Element for caching (ASP.NET Settings Schema) (http://go.microsoft.com/fwlink/p/?LinkId=195986).

Monitoring object cache performance

The object cache is used to store metadata about sites, libraries, lists, list items, and documents that are used by features such as site navigation and the Content Query Web Part. This cache helps users when they browse to pages that use these features because the data that they require is stored or retrieved directly from the object cache instead of from the content database.

The object cache is stored in the RAM of each web server in the farm. Each web server maintains its own object cache.

You can monitor the effectiveness of the cache settings by using the performance monitors that are listed in the following table.

SharePoint Publishing Cache counter group

Counter name Ideal value or pattern Notes

Total number of cache compactions

0

If this number is high, the cache size is too small for the data being requested. To improve performance, increase the size of the cache.

Publishing cache flushes / second

0

Site owners might be performing actions on the sites that are causing the cache to be flushed. To improve performance during peak-use hours, make sure that site owners perform these actions only during off-peak hours.

Publishing cache hit ratio

Depends on usage pattern. For read-only sites, the ratio should be 1. For read-write sites, the ratio may be lower.

If the ratio starts to decrease, this might be caused by one or more of the following:

  • The cache was recently flushed or compacted.

  • Users are accessing content that was recently added to the site. This might occur after lots of new content is added to the site.


View data in the logging database in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn about the SharePoint logging database, how to view monitoring information, use custom SQL views, and export into Excel.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

In this article:

  • Introduction to the SharePoint logging database

  • Pre-defined SQL views in the SharePoint logging database

  • Custom SQL views in the SharePoint logging database

Before you begin

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Introduction to the SharePoint logging database

To monitor servers that are running SharePoint 2013 and the services that run on the servers, you can directly access various logs such as the Windows Server event logs, SharePoint Unified Logging Service (ULS) logs (also known as trace logs), or usage data logs. You can also go to SharePoint 2013the SharePoint Central Administration website to review various reports. SharePoint Health Analyzer reports contain rules for servers or services. Administration (diagnostics) reports contain search-related information. Web Analytics reports contain web analytics metrics. For more information about reports, see View reports and logs in SharePoint 2013.

All the monitoring methods mentioned previously have limits. For example, Windows Server event logs, SharePoint ULS logs, and usage data logs are not stored in one single place. You have to go to different places to find related logs. Similarly, although reports from Central Administration contain the most frequently used metrics and monitoring information, if you want to add more monitoring information to those reports, you cannot do it because these reports are pre-defined and cannot be changed.

You can increase monitoring efficiency by using the logging database in SharePoint 2013. The logging database is a farm-wide repository of SharePoint 2013 monitoring information from every server in the farm. The logging database provides the option to view and customize various monitoring information in one place. Moreover, the logging database is the only SharePoint 2013 database for which you can customize reports by directly changing the database.

Note:

For more information about SharePoint 2013 databases, see Database types and descriptions (SharePoint 2013).

Note:

The default name of the database is SharePoint_Logging. You can change the default name and the SharePoint database server location by using Windows PowerShell. For more information about the logging database name and database server location, see Configure usage and health data collection in SharePoint 2013.

A single place that stores various monitoring information helps you efficiently monitor SharePoint 2013 servers and services. More importantly, you can create your own reports for unique monitoring, reporting and troubleshooting requirement based on tables inside the logging database. This article describes how to create reports by using existing tables and views. You might want to write your own providers to create new tables.

Note:

A SQL view is a virtual table. One difference between a table and a SQL view is that you can modify the data inside a table but you cannot modify the data inside a SQL view.

You use SharePoint 2013Central Administration to configure logs imported into the logging database. For more information about how to configure log categories, log levels, and trace (ULS) log path, see Configure diagnostic logging in SharePoint 2013. For more information about how to enable what is written into the logging database, see Configure usage and health data collection in SharePoint 2013. For more information about how to specify the logging database server, name and database authentication information, the events to be written to the logging database, and the frequency that logs are written to the logging database (that is, timer jobs related to usage database importing), see Configure SharePoint Health Analyzer timer jobs in SharePoint 2013.

The procedures in this article use SQL Server Management Studio to access the logging database. Management Studio is a component of SQL Server 2008.

Note:

To access the logging database, you have to have either Windows authentication (recommended) or SQL authentication. The database authentication information is configured in SharePoint 2013Central Administration. For more information about authentication methods, see Configure usage and health data collection in SharePoint 2013.

Pre-defined SQL views in the SharePoint logging database

This section describes partition tables and SQL views inside the SharePoint 2013 logging database, and includes the following three procedures:

  • To access the logging database by using SQL Server Management Studio

  • To view the logging information from default views

  • To export to and view the logging data by using Excel

The logging database uses a separate partition table for the daily data for each category. For example, the timer job usage data for the first day is written to the dbo.TimerJobUsage_Partition0 table and the data for 32 days later is written to the dbo.TimerJobUsageUsage_Partition31 table. Logs within one day are written to one partition table. That means, for each log category, each partition table stores one particular day's logs.

Note:

The mapping between one partition table and the exact date depends on the logging database retention period and the starting date to write logs into the logging database. You can get the mapping by observing time information inside each table. For example, if the retention period is 14 days and today's logs are written to partition table 2, tomorrow's logs will be written into partition table 3 and so on. After 14 days, all logs are deleted and new logs are written to these partition tables starting from partition table 0.

You can use the pre-defined SQL views in Management Studio to view all monitoring information in one place. Each pre-defined view collects the data from all 32 partition tables for the specific log category. For example, you can view the monitoring information in 32 tables from dbo.TimerJobUsage_Partition0 to dbo.TimerJobUsageUsage_Partition31.

To access the pre-defined views, you must access the SharePoint 2013 logging database. Then from the logging database, you view the monitoring information.

To access the logging database by using Management Studio

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role.

  2. On the taskbar, click Start, point to All Programs, click Microsoft SQL Server 2008 or the latest Microsoft SQL Server version that is installed, and then click SQL Server Management Studio.

    Note:

    If you do not have Management Studio on the server, reinstall SQL Server 2008 and add the Management Studio component. For more information, see SQL Server Install.

  3. In the Connect to Server dialog box, choose Database Engine. Then specify the server name, for example, ServerName\SharePoint. Select the authentication type (Windows Authentication or SQL Server Authentication) that you configured through SharePoint 2013Central Administration. If it is SQL Server Authentication, specify the credentials for the database administrator. After the information is set, click Connect.

  4. Switch to the Object Explorer view by clicking View, and then clicking Object Explorer. Expand Databases to see the logging database that has default name SharePoint_Logging or a name that you configured in Central Administration.

  5. Optionally, expand the logging database to see tables and views.

To view the logging information from default views

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role.

  2. In Management Studio, go to the logging database node by using the previous procedure.

  3. Expand the Views node of the database to see the default views. Right-click the view — for example dbo.RequestUsage, and choose Select Top 1000 Rows.

    The operation Select Top 1000 Rows is the following T-SQL query script:

    Copy code
    /****** Script for SelectTopNRows command from SSMS  ******/
SELECT TOP 1000 [PartitionId]
      ,[RowId]
      ,[LogTime]
      ,[MachineName]
      ,[FarmId]
      ,[SiteSubscriptionId]
      ,[UserLogin]
      ,[CorrelationId]
      ,[WebApplicationId]
      ,[ServerUrl]
      ,[SiteId]
      ,[SiteUrl]
      ,[WebId]
      ,[WebUrl]
      ,[DocumentPath]
      ,[ContentTypeId]
      ,[QueryString]
      ,[BytesConsumed]
      ,[HttpStatus]
      ,[SessionId]
      ,[ReferrerUrl]
      ,[ReferrerQueryString]
      ,[Browser]
      ,[UserAgent]
      ,[UserAddress]
      ,[RequestCount]
      ,[QueryCount]
      ,[QueryDurationSum]
      ,[ServiceCallCount]
      ,[ServiceCallDurationSum]
      ,[OperationCount]
      ,[Duration]
      ,[RequestType]
      ,[Title]
      ,[RowCreatedTime]
  FROM [SharePoint_Logging].[dbo].[RequestUsage]

    The top 1000 rows of the table category Request Usage appear in the result window.

  4. You can modify the T-SQL query in the SQL editor window. For example, if there are more than 1000 rows in the tables, you might want to view the top 5000 rows. To do that, change the script by replacing "SELECT TOP 1000" with "SELECT TOP 5000", and then click Execute.

If you want to view logs by using tools other than Management Studio, you can extract the monitoring information from the views and save as a text file or a CSV file. In the following procedure, Excel is used as an example.

To export and view the logging data by using Excel

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role.

  2. In Management Studio, go to the logging database node.

  3. Expand the Views node, right-click the view from which you want to extract data, and then click Select Top 1000 Rows.

  4. In the result window, right-click, and then click Select All. Then right-click and then click Save Results As….

  5. In the Save Grid Results window, specify the folder in which you want to save the file, specify the Save as type as CSV(Comma delimited), and then specify an appropriate file name.

  6. Open the CSV file by double-clicking it in Excel.

Custom SQL views in the SharePoint logging database

The logging database in SharePoint 2013 enables you to create custom reports in two ways. You can generate new views by combining related information from existing tables, or you can write providers to generate new partition tables inside the logging database. The examples in this section only show the first way.

In usage tables and the ULSTraceLog tables, the CorrelationId is an important parameter for troubleshooting. This is because every error message contains a unique CorrelationId. CorrelationId is a GUID that links all the related information with respect to a request. The following procedure shows how to make a custom view that links multiple log categories by using the CorrelationId.

To create a custom SQL view that uses existing tables

  1. Verify that the user account that is performing this procedure has the db_owner fixed database role.

  2. In Management Studio, go to the logging database node.

  3. In the logging database, expand the Views node. Choose one of the views for which you want to collect information. Right-click the view, and then click New View.

  4. In the Add Table window, choose the tables to add. For example, if you want to obtain information about feature usage site requests for a single day, you can add dbo.FeatureUsage_Partion1 and dbo.RequestUsage_Partion1.

    The T-SQL query automatically inner joins the unique key PartionId in these two tables.

    Copy code
    SELECT
FROM   dbo.FeatureUsage_Partition1 INNER JOIN
    dbo.RequestUsage_Partition1 ON dbo.FeatureUsage_Partition1.PartitionId = dbo.RequestUsage_Partition1.PartitionId

  5. Disjoin the two tables by right-clicking the link between these tables and selecting removing.

  6. To inner join the two tables using CorrelationId, click the CorrelationId column in one table and move the pointer to the CorrelationId column in another table. Or you can modify the SQL query directly from the Query Editor.

    Copy code
    SELECT
FROM   dbo.FeatureUsage_Partition1 INNER JOIN
    dbo.RequestUsage_Partition1 ON dbo.FeatureUsage_Partition1.CorrelationId = dbo.RequestUsage_Partition1.CorrelationId

  7. Choose the columns in each table that you want to show in the new view.

  8. Right-click and choose Execute SQL. The results appear in the result window.

See also

View reports and logs in SharePoint 2013
Overview of monitoring in SharePoint 2013


Solving problems and troubleshooting in SharePoint 2013
See also

Published: October 16, 2012

Summary: Read how to use SharePoint Health Analyzer to view alerts, or use Invoke-AlertFixup to update alerts when a web application's URL changes.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The articles in this section are written to meet the requirements of information technology (IT) professionals who are responsible for the planning, design, deployment, and operations of monitoring. These solutions might be in enterprise, corporate, or branch-office environments. The IT professionals who are responsible for monitoring solutions are expected to have an understanding of the technical details that are contained in this section. However, service-level expertise is not needed to understand the enterprise-level discussions and decisions.

SharePoint 2013 includes SharePoint Health Analyzer, which enables you to diagnose and resolve configuration, performance, and usage problems. The SharePoint Health Analyzer runs predefined health rules against servers in the farm. A health rule runs a test and returns a message that tells you the outcome of the test. You can use the SharePoint Central Administration website to view alerts and resolve problems.

In this section:

  • View and resolve SharePoint Health Analyzer alerts in SharePoint 2013 - This article describes how you can use SharePoint Health Analyzer to view alerts and resolve problems.

  • Use Windows PowerShell to update alerts in SharePoint 2013 - This article describes how to add an advanced function that allows you to update alerts when a web application's URL changes.

See also

Monitor health in SharePoint 2013


View and resolve SharePoint Health Analyzer alerts in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn how to view and resolve SharePoint Health Analyzer alerts from Central Administration and understand the various alert fields.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint 2013 includes a tool named SharePoint Health Analyzer that enables you to diagnose and resolve configuration, performance, and usage problems. SharePoint Health Analyzer runs predefined health rules against servers in the farm. A health rule runs a test and returns an alert that tells you the outcome of the test. You can use the SharePoint Central Administration website to view alerts and resolve problems.

In this article:

  • Viewing and resolving SharePoint Health Analyzer alerts

  • Health alert fields

Before you begin

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Viewing and resolving SharePoint Health Analyzer alerts

You can use Central Administration website to view and resolve health alerts.

To view and resolve SharePoint Health Analyzer alerts by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. From the Central Administration website, on the home page, click Monitoring.

  3. On the Monitoring page, in the Health Analyzer section, click Review problems and solutions.

  4. On the Review problems and solutions page, click the alert that you want to view and resolve.

  5. To resolve the problem, follow the guidance given in the Remedy section of the Review problems and solutions dialog. Keep the dialog open so you can run the rule again to confirm the resolution.

  6. After following the guidance given in the Remedy section, in the Review problems and solutions dialog for the alert, click Reanalyze Now to confirm the resolution. If the problem is resolved, the alert status changes to 4-Success.

For more information about the health rules and how to troubleshoot problems in SharePoint 2013, see SharePoint Health Analyzer rules reference (SharePoint 2013).

Health alert fields

The fields in alerts are described in the following table.

SharePoint Health Analyzer alert fields

Field | Description
Title | The name of the alert. By default, this is the name of the health rule that generated the alert.
Severity | Possible values are as follows: 1-Error, 2-Warning, 3-Information, 4-Success, 0-Rule Execution Failure.
Category | Pre-set values are as follows: Configuration, Security, Performance, and Availability. You can also type a value in the Specify your own value box.
Explanation | A detailed explanation of the cause of the alert. This explanation might include exception or trace information.
Remedy | Details about how to resolve the problem that caused the alert. This might include precise steps or a link to more information.
Failing Servers | The server that the failure occurred on.
Failing Services | The service where the failure occurred.
Rule Settings | A link to the health rule that generated the alert. The information in the rule might be useful in analyzing the problem, or you might want to change the schedule or disable the rule.
Version [Read-only] | This number is automatically incremented every time that the alert is altered.
Created (time) [Read-only] | The date and time that the alert was generated and the domain or local security account under which the alert was generated.
Last changed (time) [Read-only] | The date and time that the alert was last changed and the domain or local security account under which the alert was changed. This information might be useful in tracking changes to the alert, such as during resolution of the problem.

See also

SharePoint Health Analyzer rules reference (SharePoint 2013)


Use Windows PowerShell to update alerts in SharePoint 2013
See also

Updated: March 12, 2013

Summary: Learn to use Invoke-AlertFixup to update the e-mail alerts associated with a URL.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes Invoke-AlertFixup, a Windows PowerShell advanced function that you can use to update the Uniform Resource Locator (URL) of a Web application used in alert e-mails after a Web application address changes. The advanced function is loaded by running a script of the same name.

For more information about advanced functions, see about_Functions_Advanced.

In this article:

  • Update URLs by using Windows PowerShell

  • Example

Before you begin

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, read about_Execution_Policies.

Update URLs by using Windows PowerShell

This section describes how to update URLs by using Windows PowerShell.

To update URLs by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Copy the code from the Script Center (http://go.microsoft.com/fwlink/p/?LinkId=196687), and then paste it into a text editor, such as Notepad.

  3. Save the file, naming it Invoke-AlertFixup.ps1.

    Note:

    You must use the provided name or the script will fail, and you must save the file as an ANSI-encoded text file.

  4. On the Start menu, click All Programs.

  5. Click Microsoft SharePoint 2013 Products.

  6. Click SharePoint 2013 Management Shell.

  7. Change to the directory where you saved the file.

  8. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ./Invoke-AlertFixup.ps1

    This script contains the Invoke-AlertFixup advanced function. After the script is loaded to memory for the current Windows PowerShell session, Invoke-AlertFixup can be used like a Windows PowerShell cmdlet, for example:

    Copy code
    Invoke-AlertFixup -site <SiteCollURL> -oldurl <OldURL>

    Where:

    • <SiteCollURL> is the Site Collection URL seen in the ImmedSubscriptions table of the content database.

    • <OldURL> is the old URL of the site.

    Note:

    For Invoke-AlertFixup to work correctly, the URLs that you specify with the site and oldurl parameters must be in the same site collection. This is necessary to allow necessary updating of alerts in a specific zone. Alerts for each zone must be updated individually using the necessary new zone URL to that of the original (old) zone URL.

  9. To display all alerts that would be updated by using the Invoke-AlertFixup command, at the Windows PowerShell command prompt type the following:

    Copy code
    Invoke-AlertFixup -site <SiteCollURL> -Oldurl <OldURL> -whatif

    Where:

    • <SiteCollURL> is the Site Collection URL seen in the ImmedSubscriptions table of the content database.

    • <OldURL> is the old URL of the site.

For more information, see Script Center.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Example

Your company has a web application that is configured to use three zones, as shown in the following table.

Coho Winery zone mapping

Description | URL | Zone
Intranet | http://cohowinery | Default
Extranet | http://extranet.cohowinery.com | Extranet
Vendor | http://vendors.cohowinery.com | Custom

Your company merges with Coho Vineyard and changes its name to Coho Winery and Vineyard. Management wants to change the Intranet and Extranet zones to reflect the new name change. The following table displays the new zone configuration.

Coho Winery and Vineyard zone mapping

Description | URL | Zone
Intranet | http://cohovineyardandwinery | Default
Extranet | http://extranet.cohovineyardandwinery.com | Extranet

After the name of the web application is changed and the alternate access mappings are updated, Invoke-AlertFixup should be run to update the e-mail alerts associated with the intranet and extranet sites, as follows:

Copy code
Invoke-AlertFixup -site http://cohovineyardandwinery -oldurl http://cohowinery
Copy code
Invoke-AlertFixup -site http://extranet.cohovineyardandwinery.com -oldurl http://extranet.cohowinery.com
Note:

No changes are made regarding the vendor site, as Coho Winery has decided not to change the name of the vendor portal.

See also

Solving problems and troubleshooting in SharePoint 2013

Running Windows PowerShell Scripts
Resource Center: Windows PowerShell for SharePoint Server 2013 IT Pros

Change History

Date | Description
March 12, 2013 | Updated the parameters of the Invoke-AlertFixup command.
October 16, 2012 | Initial publication


Scripted monitoring configuration in SharePoint 2013
See also

Published: May 7, 2013

Summary: Read articles about scripted monitoring configuration for SharePoint 2013 to apply monitoring settings across an entire environment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

As Information technology (IT) professionals, you may be responsible to plan, design, deploy, and maintain monitoring for a SharePoint environment. Scripted monitoring configuration enables an administrator to use a set of Windows PowerShell scripts and XML data files, which are known as Profiles, to automate configuration of monitoring settings in a SharePoint environment. The scripts change the monitoring settings so that all of the necessary monitoring data is collected during the event without flooding the Logging database during normal operation.

TechNet articles about scripted monitoring configuration for SharePoint 2013

The following articles about how to use scripted monitoring configuration for SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Overview of scripted monitoring configuration in SharePoint 2013 | Learn about scripted monitoring configuration. This includes how it works, where and when to use it.
 | Profile schema reference in SharePoint 2013 | Learn about the schema in xml files, which are known as Profiles, which store monitoring settings. You can create Profiles to adjust the level of monitoring or to configure monitoring on several farms at the same time.
 | Run scripted monitoring configuration in SharePoint 2013 | Learn how to run the scripts involved with scripted monitoring configuration to back up, restore, or alter your settings.

See also

Monitor health in SharePoint 2013
Use Windows PowerShell to administer SharePoint 2013


Overview of scripted monitoring configuration in SharePoint 2013
See also

Published: May 7, 2013

Summary: Learn how to use Windows PowerShell and XML to automate the configuration of monitoring settings.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

You can change the monitoring settings for the SharePoint 2013 environment several ways. One way is to use the SharePoint Central Administration website. You might use this to make a single change to a small, local farm. Another way is to use Windows PowerShell cmdlets directly. You might use this to make a single change to a local or remote farm. Still another way is to create your own Windows PowerShell scripts. You might use this to make several complex changes to a local or remote farm that might be done repeatedly.

Scripted monitoring configuration involves a set of Windows PowerShell script files and XML data files, called Profiles, to enable administrators to automate configuration of the monitoring settings in the SharePoint 2013 environment, including backing up and restoring these settings. Administrators can run the scripts before, during, and after changes to the farm. Changes might include updates of the farm topology, major security changes, software updates, or performance tests. The scripts change the monitoring settings so that all of the necessary monitoring data are collected during the event without flooding the Logging database during normal operation.

  • Diagnostic Settings

  • Usage Service settings

  • Usage definitions

  • Log level settings

  • Timer job settings

  • SharePoint Health Analyzer rule settings

You can run scripted monitoring configuration to backup and restore monitoring settings for the farm without having to run backup and restore. You can use it to change the monitoring settings so that all of the necessary monitoring data is collected during the event without flooding the Logging database during normal operation. You can also run the scripts to tune the level of monitoring during different phases of the SharePoint lifecycle. For more information, see Run scripted monitoring configuration in SharePoint 2013.

You can also copy and modify the backup Profile to create Profiles for specific purposes. For more information, see Profile schema reference in SharePoint 2013.

The components of scripted monitoring configuration

Scripted monitoring configuration consists of both Windows PowerShell scripts and Profiles that contain the settings data for changes in the farm. The scripts are available on the TechNet Library. Following are the scripts and Profiles that are involved:

  • BackupMonitoringSettings.ps1

    Run this Windows PowerShell script on a farm to back up various logging settings to an XML file.

    Important:

    This script is available on the TechNet Gallery at Scripted Monitoring Configuration - BackupMonitoringSettings.

  • AlterMonitoringSettings.ps1

    Run this Windows PowerShell script on a server to restore or change various logging settings by using an XML Profile as a data source.

    Important:

    This script is available on the TechNet Gallery at Scripted Monitoring Configuration - AlterMonitoringSettings.

  • Backup Profile

    The BackupMonitoringSettings.ps1 script creates this XML file which contains all of the monitoring settings mentioned above. You can use the AlterMonitoringSettings.ps1 script backup file to restore the settings to the farm. You can also use this file as a template to create another Profile or to make changes to another farm.

  • Profiles

    Create one or more of these XML files to modify the settings to the farm by using the AlterMonitoringSettings.ps1 script.

The scripted monitoring configuration process

  1. Run the BackupMonitoringSettings.ps1 script

    Run this script on a farm to back up various monitoring settings to an XML Profile that the script creates. The XML file name is in the form "BackupSetting_[DATE] @ [Time].xml". The script creates a new file every time you run it.

  2. Create a Profile by copying and altering settings in the backup Profile

    You can make a copy of the BackupSettings.xml file and change the settings. You can then use the updated file as the source for changes to your farm.

    Important:

    Always preserve the original BackupSettings.xml file so that you can use it to restore your farm to the original configuration. To create custom Profiles, modify a copy of the BackupSettings.xml file.

  3. Applying settings changes by running the AlterMonitorngSettings.ps1 script

    After you create your own Profile, you can run the AlterMonitoringSettings.ps1 script to apply those changes to the farm.

  4. Restore settings

    To restore the setting to a previous state, run the AlterMonitoringSettings.ps1 script and provide the path of a BackupSettings.xml file.

  5. Apply a Profile to another farm

    You can also use a Profile to apply the settings from one farm to another farm. Or you can use an updated settings file to apply settings to many farms.

See also

Profile schema reference in SharePoint 2013
Run scripted monitoring configuration in SharePoint 2013
App Management Service cmdlets in SharePoint 2013


Profile schema reference in SharePoint 2013
See also

Published: May 7, 2013

Summary: Understand the XML schema for profiles for use in scripted monitoring configuration.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

When you run the BackupMonitoringSettings.ps1 Windows PowerShell script on a SharePoint farm, you create a file that's called a Profile. The Profile follows an XML schema. You can modify settings of elements of the schema to create a custom Profile. You can then use the custom Profile to automate configuration of the monitoring settings in a SharePoint environment. For an introduction to scripted monitoring configuration, see Overview of scripted monitoring configuration in SharePoint 2013.

Administrators can run the scripts before, during, and after changes to the farm, such as farm topology, major security changes, applying software updates, or running a performance test. The scripts alter the monitoring settings so that all of the necessary monitoring data are collected during the event without flooding the Logging database during normal operation. For and introduction to scripted monitoring configuration, see Overview of scripted monitoring configuration in SharePoint 2013.

Note:

You must download the Windows PowerShell scripts to back up, restore, or modify the farm monitoring settings. The scripts are available on the TechNet Library at Scripted Monitoring Configuration - BackupMonitoringSettings and Scripted Monitoring Configuration - AlterMonitoringSettings. The BackupMonitoringSettings.ps1 Windows PowerShell script creates the backup Profile from which you can create other Profiles.

You can create one or more Profiles to adjust the level of monitoring during different phases of the SharePoint lifecycle. You can also use a custom Profile to configure monitoring on several farms at once.

You would typically create Profiles for the following purposes:

  • To complete the configuration of the monitoring settings on a farm after you install SharePoint 2013

  • To change the monitoring settings on a farm just before an administrative change, such as changing the settings of a Search service application on the farm

    As a result, you can capture more monitoring data related to that change and suppress unwanted monitoring data. Then you can return the monitoring settings to the original values after the change has been completed.

  • To restore the monitoring settings on a farm after some administrative change

  • To restore a previous set of monitoring settings on a farm

    You might do this if you are making manual adjustments to the settings and decide that you want to restore the previous settings.

  • To restore the default settings

  • To create a profile that you can apply to multiple farms

Backing up the original settings

You should always back up the default monitoring settings before altering them. That way, you can restore those settings should you need to. The backup Profile also can serve as the beginning point for the other Profiles you will create. For more information about how to back up the settings, see Run scripted monitoring configuration in SharePoint 2013.

Understanding the Profile schema

When you run the BackupMonitoringSettings.ps1 Windows PowerShell script, you create a Profile that conforms to the following XML schema. The elements of the file contain the associated monitoring settings from the farm.

Copy code
<?xml version="1.0" standalone="yes"?>
<Configuration>
  <FarmDiagnosticConfig />

  <UsageServices>
    <UsageService />
  </UsageServices>

  <UsageDefinitions>
    <UsageDefinition />
  </UsageDefinitions>

  <LogLevels>
    <LogLevel />
  </LogLevels>

  <TimerJobs>
    <TimerJob />
  </TimerJobs>

  <HealthAnalyzerRules>
    <HealthAnalyzerRule />
  </HealthAnalyzerRules>

</Configuration>

Important:

In the following tables, you cannot change values in fields that are marked as Read-Only. If you change values in Read-Only fields in your Profiles, unpredictable results may occur.

Settings for the FarmDiagnosticConfig element

Name Value Type Notes

AllowLegacyTraceProviders

Boolean

Specifies that trace providers built for previous versions of SharePoint Products and Technologies can write to the trace session for SharePoint 2013.

AppAnalyticsAutomaticUploadEnabled

Boolean

Specifies whether aggregated app usage data is automatically uploaded to Microsoft.

CustomerExperienceImprovementProgramEnabled

Boolean

Determines whether a Management Group has enabled the Customer Experience Improvement Program feature.

ErrorReportingEnabled

Boolean

Gets or sets a value to indicate whether crash data collection and error reporting is enabled.

ErrorReportingAutomaticUploadEnabled

Boolean

Specifies whether participation in the Customer Experience Improvement Program (CEIP) is enabled. The CEIP is designed to improve the quality, reliability, and performance of Microsoft products and technologies. With your permission, anonymous information about your server is sent to Microsoft to help improve SharePoint 2013.

DownloadErrorReportingUpdatesEnabled

Boolean

Specifies whether error reports are uploaded to Microsoft automatically. Error reports include the following:

  • Information about the condition of the server when a problem occurs

  • The operating system version and computer hardware in use

  • The digital product ID, which can be used to identify your license

    Note:

    The IP address of your computer is also sent because you are connecting to an online service to send error reports; however, the IP address is used only to generate aggregate statistics.

DaysToKeepLogs

Integer

Specifies the number of days to keep trace log files. The type must be a valid number between 1 and 366. The default value is 14 days.

LogMaxDiskSpaceUsageEnabled

Boolean

Specifies whether to restrict the maximum space to use for trace log files.

LogDiskSpaceUsageGB

Integer

Specifies the maximum amount of storage to use for trace log files, in gigabytes (GB). The default value is 1000 and only takes effect when the LogMaxDiskSpaceusageEnabled parameter is set to True. The type must be a valid number between 1 and 1000.

LogLocation

String:Path

This is the full path to the location where you want log files to be stored. It can be a remote location. Example: "%CommonProgramFiles%\Microsoft Shared\Web Server Extensions\15\LOGS\"

LogCutInterval

Integer

Specifies a time period to roll over to the next log file. The type must be a valid number between 0 and 1440.

EventLogFloodProtectionEnabled

Boolean

Specifies whether the Event log flood protection feature is enabled. If multiple similar events are written to the event log, some duplicate messages are suppressed. After a period of time, a summary message shows how many events were suppressed.

EventLogFloodProtectionThreshold

Integer

Specifies the number of events allowed in a given timeframe before an event is considered to be flooding the event log. The integer range is between 1 and 100. The default value is 5.

EventLogFloodProtectionTriggerPeriod

Integer

Specifies in minutes the timeframe to watch for events that may be flooding. The integer range is between 1 and 1440. The default value is 2.

EventLogFloodProtectionQuietPeriod

Integer

Specifies in minutes how much time must pass without an event firing to exit flood protection. The integer range is between 1 and 1440. The default value is 2.

EventLogFloodProtectionNotifyInterval

Integer

Specifies in minutes how often to write a summary event that indicates how many events were suppressed due to flood protection. The integer range is between 1 and 1440. The default value is 5.

ScriptErrorReportingEnabled

Boolean

Enables or disabled the reporting of script errors in the Log file.

ScriptErrorReportingRequireAuth

Boolean

Specifies whether script error reporting requires authentication.

ScriptErrorReportingDelay

Integer

Specifies the time in minutes between script error reports. The value must be a valid integer between 0 and 1440. The value is specified in minutes. The default value is 30.

The elements of the UsageServices settings

Name | Value Type | Notes
ID | GUID: Read-Only | A GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.
UsageLogLocation | Path | Specifies the path on every computer in the farm where usage log files are created. The same path must exist on all computers in the farm.
LoggingEnabled | Boolean | Specifies that usage data is logged to usage files.
UsageLogMaxFileSizeKB | Integer | Specifies the maximum size of a single usage file that is applied to all the usage providers. The minimum value is 512 kilobytes (KB) and the maximum value is 65536 KB.
UsageLogCutTime | Integer | Specifies the time in minutes of usage data that is collected per usage log file. The default time is 5 minutes. The value must be an integer in the range of 1 to 1440.

The elements of the UsageDefinition settings

Name | Value Type | Notes
ID | GUID: Read-Only | A GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.
Name | String: Read-Only | The string name of the UsageDefinition.
DaysRetained | Integer | Specifies the number of days to retain usage data for the usage provider in the usage service database. The default value is 14. The type must be an integer between 0 and 31.
DaysToKeepUsageFiles | Integer | Specifies the number of days to retain usage files. The value must be less than or equal to value of the DaysRetained parameter.
Enabled | Boolean | Enables or disables the specified usage provider.

The elements of the LogLevel settings

Name Value Type Notes

Area

String: Read-Only

The component or service that the LogLevel applies to.

Identity

String: Read-Only

Specifies the names of the category or set of categories to set the throttle for; for example, "Unified Logging Service".

Note:

If the Identity parameter is not specified, the event-throttling setting is applied to all categories in the farm.

EventSeverity

String:[None | ErrorCritical |Error | Warning |Information | Verbose]

Specifies the category level to be set. The category level is any one of the following values:[None | ErrorCritical |Error | Warning |Information | Verbose]

TraceSeverity

String:[None | Unexpected |Monitorable | High |Medium | Verbose | VerboseX]

Specifies trace throttle to set the specified categories to. The trace log files are text files that are written to the trace log path that is defined on the Diagnostic Logging Settings page on the the SharePoint Central Administration website. The type must be any one of the following values::[None | Unexpected |Monitorable | High |Medium | Verbose | VerboseX]

The elements of the TimerJob settings

Name Value Type Notes

Identity

GUID: Read-Only

Specifies the timer job to update. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Schedule

String

Specifies the schedule for running the timer job.The type must be a valid SharePoint Timer service (SPTimer) schedule in the form of any one of the following schedules:

  • Every 5 minutes between 0 and 59

  • Hourly between 0 and 59

  • Daily at 15:00:00

  • Weekly between Fri 22:00:00 and Sun 06:00:00

  • Monthly at 15 15:00:00

  • Yearly at Jan 1 15:00:00

Enabled

Boolean

Enables or disables the timer job.

The elements of the HealthAnalyzerRule settings

Name | Value Type | Notes
Identity | GUID: Read-Only | Specifies the name or GUID of the health analyzer rule to set.
Enabled | Boolean | Enables or disables the health analyzer rule.

Create Profiles

You can create an unlimited number of Profiles as. Each Profile might be used for a different purpose, such as to increase the levels of monitoring before a specific change to the environment, or to lower the levels after a change.

You only need to create profile entries for the specific changes that you want to make. The other settings will remain unchanged. For example, if you want to change a few LogLevel settings, then you only need to specify those settings in the Profile. Settings that are not specified in the Profile will not be changed.

You might want to use a naming convention for your Profiles so that you can organize them and more easily use them.

Important:

Always back up the monitoring settings before making any changes to them. Always work from a copy of the backup Profile and never from the original backup file itself.

See also

Overview of scripted monitoring configuration in SharePoint 2013
Run scripted monitoring configuration in SharePoint 2013


Run scripted monitoring configuration in SharePoint 2013
See also

Published: May 7, 2013

Summary: Learn how to use Windows PowerShell scripts and Profile files to automatically back up, restore, or change monitoring settings in a SharePoint 2013 environment.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Scripted monitoring configuration uses Windows PowerShell scripts and XML files, which are known as Profiles, to back up, restore, or configure monitoring settings in the SharePoint 2013 environment. For more conceptual information about scripted monitoring configuration, see Overview of scripted monitoring configuration in SharePoint 2013

Note:

You must download the Windows PowerShell scripts to back up, restore, or change the farm monitoring settings. When you run the BackupMonitoringSettings.ps1 Windows PowerShell script, you create the backup Profile from which you can create other Profiles.

Use the BackupMonitoringSettings.ps1 script

You can use scripted monitoring configuration to back up the monitoring settings for the farm. You should do this immediately after you complete the deployment of the farm to make sure that that you can restore the farm to its original settings. You can also back up the settings before or after any changes to the farm.

Important:

This script is available on the TechNet Gallery at Scripted Monitoring Configuration - BackupMonitoringSettings.

To back up the farm monitoring settings

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    .\BackupMonitoringSettings.ps1 "<ProfileFolder>"

    Where:

    • <ProfileFolder> is full path of the folder that you want to store the backup settings Profile in. The XML file name is in the form "BackupSetting_[DATE] @ [Time].xml". The script will create a new file every time that it is run.

Use the AlterMonitoringSettings.ps1 script

You can use scripted monitoring configuration to change or restore the monitoring settings for the farm. To change the settings, create a copy of the backup Profile and change the settings in the copy to create a new Profile. To apply the settings in the new Profile, run the AlterMonitoringSettings.ps1 script and specify the path of the specific Profile you want to use. For more information about how to create Profiles, see Profile schema reference in SharePoint 2013.

Important:

This script is available on the TechNet Gallery at Scripted Monitoring Configuration - AlterMonitoringSettings.

Restore settings

You can use scripted monitoring configuration to restore the monitoring settings for the farm at any time. You can restore the settings to any values for which you have a corresponding Profile.

To restore the farm monitoring settings

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, navigate to the folder that you downloaded the BackupMonitoringSettings.ps1 and AlterMonitoringSettings.ps1 scripts to.

  4. At the Windows PowerShell command prompt, type the following command:

    Copy code
    .\AlterMonitoringSettings.ps1 "<ProfilePath>"

    Where:

    • <ProfilePath> is full path of the backup Profile that you want to use to restore the monitoring settings for the farm.

Apply settings changes

You can use scripted monitoring configuration to change the monitoring settings for the farm. To change the settings, run the RestoreMonitoringSettings.ps1 script and specify the path of the specific Profile that you want to use. For more information about how to create Profiles, see Profile schema reference in SharePoint 2013.

To apply monitoring settings changes to the farm

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, navigate to the folder that you downloaded the BackupMonitoringSettings.ps1 and AlterMonitoringSettings.ps1 scripts to.

  4. At the Windows PowerShell command prompt, type the following command:

    Copy code
    .\AlterMonitoringSettings.ps1 "<ProfilePath>"

    Where:

    • <ProfilePath> is full path of the specific Profile that you want to use to configure the monitoring settings for the farm.

See also

Overview of scripted monitoring configuration in SharePoint 2013
Profile schema reference in SharePoint 2013


Monitoring scenarios in SharePoint 2013
See also

Published: February 5, 2013

Summary: Learn about monitoring scenarios in SharePoint 2013 and tools that help to maintain a reliable environment.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The following articles on TechNet provide information about monitoring scenarios in SharePoint 2013.

TechNet articles about monitoring scenarios in SharePoint 2013

The following articles about monitoring scenarios are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Monitor farms in SharePoint 2013 | Explains what to monitor in a SharePoint farm, how to monitor SharePoint 2013 farms, and how to monitor multiple farms.
Monitor servers in SharePoint 2013 | Explains how to monitor SharePoint servers, including database servers, application servers, and web servers, by using logs, SharePoint Health Analyzer rules, and System Center 2012 - Operations Manager.
Monitor sites and site collections in SharePoint 2013 | Describes how to monitor SharePoint 2013 sites and site collections to maintain sites that run as expected.

See also

Monitor health in SharePoint 2013
Plan for monitoring in SharePoint 2013
SharePoint Health Analyzer rules reference (SharePoint 2013)


Monitor farms in SharePoint 2013
See also

Published: February 5, 2013

Summary: Learn what to monitor in a SharePoint farm, how to monitor SharePoint 2013 farms, and how to monitor multiple farms.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Administrators develop a monitoring strategy for SharePoint 2013 to detect security issues and to keep performance at acceptable levels. You can monitor all components of the farm, such as servers, databases, sites and site collections, and service applications. You can use this information to monitor one or more farms.

In this article:

  • What to monitor

  • How to monitor

  • Monitoring multiple farms

What to monitor

You can monitor a SharePoint farm at three different levels: server, site and site collection, and service application. Each level has specific monitoring requirements. To monitor the farm, you must monitor all three levels.

  • The server level

    The server level contains all of the servers, such as web servers, application servers, and database servers, that comprise the SharePoint farm.

  • The site and site collection level

    The site and site collection level contains all sites and site collections in the farm.

  • The service application level

    The service application level contains all service applications that are contained in, or used by, the farm.

How to monitor

You can monitor a SharePoint farm by using the following:

  • The SharePoint Central Administration website

    From Central Administration, you can configure diagnostic logging, and usage and health data collection. You can view problems and solutions from Health Analyzer. In addition, SharePoint 2013 generates administrative reports and health reports for you to analyze health data. For more information, see Configure usage and health data collection in SharePoint 2013, View reports and logs in SharePoint 2013, and Configure diagnostic logging in SharePoint 2013.

  • Windows PowerShell

    You can use Windows PowerShell to view diagnostic logs. For more information, see View diagnostic logs in SharePoint 2013.

  • Logs

    Use Event Viewer to view system logs. For more information, see Event Viewer.

    You can check Unified Logging Service (ULS) logs for troubleshooting. For more information, see ULS Viewer, for SharePoint 2010 Troubleshooting. This information for SharePoint 2010 also applies to SharePoint 2013.

  • System Center 2012 - Operations Manager with System Center Management Pack for SharePoint Server 2013

    You can use Operations Manager and System Center Management Pack for SharePoint Server 2013 to monitor the health status of a SharePoint farm. It lets you monitor services, devices, and operations for many computers in a single console. For more information, see Operations Manager, and System Center Monitoring Pack for SharePoint Server 2013 or System Center Monitoring Pack for SharePoint Foundation 2013.

    You can use Network Load Balancing (NLB) to enhance the scalability and availability of server applications when you use System Center Management Pack for SharePoint Server 2013. For more information, see Network Load Balancing.

Monitoring multiple farms

A large SharePoint deployment may have more than one farm. In this case, you can use Operations Manager and System Center Management Pack for SharePoint Server 2013 to monitor multiple farms. For more information, see SharePoint 2010 Multi-Farm Monitoring. This information for SharePoint 2010 also applies to SharePoint 2013.

See also

Plan for monitoring in SharePoint 2013


Monitor servers in SharePoint 2013
See also

Published: February 5, 2013

Summary: Learn how to monitor SharePoint servers, including database servers, application servers, and web servers, by using logs, SharePoint Health Analyzer rules, and System Center 2012 - Operations Manager.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

You should monitor database servers, application servers, and web servers in a SharePoint farm to detect performance issues and maintain a healthy environment. When you monitor servers, you monitor hardware, software, and security of servers. You can use the built-in monitoring features of the SharePoint Central Administration website , such as logs and SharePoint Healthy Analyzer rules. In addition, you can deploy System Center 2012 - Operations Manager to monitor computers that run SharePoint 2013. Operations Manager is a powerful monitoring platform that lets you monitor services, devices, and operations for many computers in a single console. To use Operations Manager, we recommend that you install System Center Management Pack for SharePoint Server 2013.

In this article:

  • Monitoring tools

  • Use SharePoint Health Analyzer rules to monitor servers

  • Use System Center 2012 - Operations Manager and System Center Management Pack for SharePoint Server 2013 to monitor servers

  • Use Windows Performance Monitor to monitor servers

  • Use logs

Monitoring tools

You can use the following tools to monitor servers:

  • SharePoint Health Analyzer rules

    Built-in SharePoint Health Analyzer rules enable you to analyze and resolve issues in the following areas: security, performance, configuration, and availability. These rules are run at scheduled intervals, such as hourly, daily, weekly, and monthly.

  • System Center 2012 - Operations Manager

    System Center 2012 - Operations Manager is a powerful monitoring platform that lets you monitor services, devices, and operations for many computers in a single console. Operations Manager enables you to view status, health, performance information, and alerts that Management Packs generate for availability, performance, configuration and security situations. For more information, see Operations Manager.

  • Performance monitor

    Performance Monitor is a simple yet powerful visualization tool for viewing performance data, both in real time and from log files. You can examine performance data in a graph, histogram, or report. For more information, see Windows Performance Monitor.

  • Logs

    You can use logs for diagnosis and troubleshooting. For more information, see Use logs.

Use SharePoint Health Analyzer rules to monitor servers

You can use SharePoint Health Analyzer rules to monitor database servers, application servers, and web servers.

Monitor various servers

Type of Server SharePoint Health Analyzer rules

Database servers

  • Some content databases are growing too large (SharePoint 2013)

  • Content databases contain orphaned Apps (SharePoint 2013)

  • Database has large amounts of unused space (SharePoint 2013)

  • Databases exist on servers running SharePoint Foundation (SharePoint 2013)

  • Databases running in compatibility range, upgrade recommended (SharePoint 2013)

  • Databases require upgrade or not supported (SharePoint 2013)

  • Databases within this farm are set to read only and will fail to upgrade unless it is set to a read-write state (SharePoint 2013)

  • Drives used for SQL databases are running out of free space (SharePoint 2013)

  • Databases used by SharePoint have outdated index statistics (SharePoint 2013)

  • Search - One or more crawl databases may have fragmented indices (SharePoint 2013)

Application servers

Application pools recycle when memory limits are exceeded (SharePoint 2013)

Web servers

  • One of the cache hosts in the cluster is down (SharePoint 2013)

  • Firewall client settings on the cache host are incorrect (SharePoint 2013)

  • Web.config file has incorrect settings for the requestFiltering element (SharePoint 2013)

  • Web.config files are not identical on all machines in the farm (SharePoint 2013)

  • Alternate access URLs have not been configured (SharePoint 2013)

You can use the following SharePoint Health Analyzer rules to monitor hardware, software, and security of servers.

Monitor hardware, software, and security

Monitoring target SharePoint Health Analyzer rules or related article

Hardware

  • One or more servers is not responding (SharePoint 2013)

  • Drives used for SQL databases are running out of free space (SharePoint 2013)

Software

Product / patch installation or server upgrade required (SharePoint 2013)

Security

The Security Token Service is not available (SharePoint 2013)

For more information, see SharePoint Health Analyzer rules reference (SharePoint 2013).

Use System Center 2012 - Operations Manager and System Center Management Pack for SharePoint Server 2013 to monitor servers

Operations Manager enables you to monitor services, devices, and operations for many computers in a single console. For examples, administrators can use many views that show state, health, performance information, and alerts that Operations Manager generated for availability, performance, configuration and security situations. As a result, you can see the state of an IT environment and IT Services that are running across different services and workloads. Operators can gain rapid insight into the state of the IT environment and the IT services that are running across different systems and workloads by. For more information, see Operations Manager Monitoring Scenarios.

You can use System Center Management Pack for SharePoint Server 2013 to monitor events, collect performance counters that are specific to SharePoint components in one central location, and raise alerts for operator intervention as necessary. For more information, see System Center Monitoring Pack for SharePoint Server 2013 or System Center Monitoring Pack for SharePoint Foundation 2013.

You can use Network Load Balancing (NLB) to enhance the scalability and availability of server applications when you use System Center Management Pack for SharePoint Server 2013. For more information, see Network Load Balancing.

Use Windows Performance Monitor to monitor servers

Windows Performance Monitor uses performance counters, event trace data, and configuration information, which can be combined into Data Collector Sets.

For more information, see Windows Performance Monitor.

Use logs

You can use diagnostic logs, and health and data collection logs to monitor servers. For more information, see Configure diagnostic logging in SharePoint 2013 and Configure usage and health data collection in SharePoint 2013.

You can check Unified Logging Service (ULS) logs for troubleshooting. For more information, see ULS Viewer, for SharePoint 2010 Troubleshooting.

Note:

This information for SharePoint 2010 also applies to SharePoint 2013.

See also

Plan for monitoring in SharePoint 2013
View search diagnostics in SharePoint Server 2013


Monitor sites and site collections in SharePoint 2013
See also

Published: February 5, 2013

Summary: Learn how to monitor SharePoint 2013 sites and site collections to maintain sites that run as expected.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Several configurable tools help you monitor sites and site collections. You can run the site collection health checks to check the health status of a site collection. You can use the Web Application Availability Monitoring Template and the Web Application Transaction Monitoring Template to monitor site availability and site transaction. You can check Internet Information Services (IIS) logs for troubleshooting.

In this article:

  • Monitoring tools

  • Use SharePoint Health Analyzer rules to monitor web applications

  • Use health checks to monitor site collections and sites

  • Use System Center 2012 - Operations Manager to monitor site availability

  • Use System Center 2012 - Operations Manager to monitor site transaction performance

  • Use IIS logs

Monitoring tools

You can use a specific tool to monitor sites and site collections in various scenarios:

  • SharePoint Health Analyzer rules

    SharePoint 2013 provides built-in SharePoint Health Analyzer rules for you to monitor sites and site collections. You can monitor performance and configuration of web applications.

  • Site collection health checks

    Use the health checks to check site collections manually to prepare for an upgrade, or run them at any time to verify that a site is working as expected.

  • Web Application Availability Monitoring

    Use the Web Application Availability Monitoring template that System Center 2012 - Operations Manager provides to monitor web-based applications from different locations. The results can determine whether sites are working according to certain requirements, which you can specify.

  • Web Application Transition Monitoring

    Use the Web Application Transition Monitoring template that System Center 2012 - Operations Manager provides to monitor the availability and performance of any website or web-based application to test both general availability and functionality. For internal websites, you can use watcher nodes in different network segments to make sure that the site is available to each segment.

    In addition to general availability, you can check the functionality of the website by testing different pages and features. For example, you could check a logon process by performing a test logon with a test user account every few minutes. You could test the functionality of a search page by performing a sample search after the test user account is logged on. You can then analyze the HTML that is returned from these pages to verify that the page functioned as expected. In addition to testing this functionality, you can analyze the time that is required to fill the request to measure the performance.

  • IIS logs

    When you want to know who changed settings of a website, and the changes that occurred, you can use IIS logs.

Use SharePoint Health Analyzer rules to monitor web applications

You can use the following SharePoint Health Analyzer rules to monitor site collections and sites.

Use SharePoint Health Analyzer rules to monitor web applications

Monitoring type SharePoint Health Analyzer rules

Configuration

  • Alternate access URLs have not been configured (SharePoint 2013)

  • Web.config file has incorrect settings for the requestFiltering element (SharePoint 2013)

  • Web.config files are not identical on all machines in the farm (SharePoint 2013)

  • One or more web applications are configured to use Windows Classic authentication (SharePoint 2013)

  • Validate the My Site Host and individual My Sites are on a dedicated Web application and separate URL domain (SharePoint 2013)

For more information, see SharePoint Health Analyzer rules reference (SharePoint 2013).

Use health checks to monitor site collections and sites

You can run the health checks manually to prepare for an upgrade. You can also run the health checks at any time to verify that a site is working as expected.

The site collection health checker includes the following rules:

Site collection health check rules

Rule name | Description
Customized Files | This rule checks for any files that were customized (or unghosted) in the site collection or subsites. When run in repair mode, it can reset the page to the default (reghost the file).
Missing Galleries | This rule checks for all default galleries and reports if any are missing from the site collection or subsites.
Missing Site Templates | This rule checks to make sure that the template that the site is based on is available and reports if any elements are missing.
Unsupported Language Pack References | This rule checks to make sure that the language packs that are used by the site collection exist and are referenced correctly by the site collection.
Unsupported MUI References | This rule checks to make sure that the multi-user interface elements that are used by the site collection exist and are referenced correctly by the site collection.

For more information, see Run site collection health checks in SharePoint 2013.

Use System Center 2012 - Operations Manager to monitor site availability

Operations Manager provides a tool that is called the Web Application Availability Monitoring template. You can use this template to create availability monitoring tests for the dedicated IP addresses of the farm and run these monitoring tests from internal locations. In addition to state and alert views, you can display the status of these tests in a provided map dashboard and a details dashboard. Use the Web Application Availability Monitoring template to monitor web-based applications from different locations to see whether they are working according to certain requirements. For more information, see Web Application Availability Monitoring Template.

Use System Center 2012 - Operations Manager to monitor site transaction performance

Operations Manager provides a tool that is called the Web Application Transaction Monitoring template. You can use this template to test a website or web-based application by sending requests over HTTP, validating their responses, and measuring their performance. This can be a simple test to determine whether the website is responding, or it can be a complex set of requests to simulate a user who is performing such actions as logging on to the site and browsing pages. You can use the Web Application Transition Monitoring template to monitor the availability and performance of any website. You can also configure the Web Application Transition Monitoring template to meet your specific monitoring needs. For more information, see Web Application Transaction Monitoring Template.

Use IIS logs

You can use IIS logs to diagnose website problems. For more information, see Configuring Logging in IIS 7.

See also

Administer sites and site collections in SharePoint 2013
Plan for monitoring in SharePoint 2013

Management Pack Templates


Configure licensing in SharePoint Server 2013

Summary: Learn about new licensing functionality and how to configure licensing in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Important:

The steps in this article apply to the Standard and Enterprise versions of SharePoint Server 2013.

In this article:

  • Overview of licensing

  • Configure licensing by using Windows PowerShell

Overview of licensing

In Office SharePoint Server 2007 and SharePoint Server 2010, when companies purchased a SharePoint Server Enterprise client access license (CAL) and deployed a server running SharePoint Server Enterprise, all users who accessed that server could use the full enterpr ise feature set. There was no way to determine the CAL that a specific user had. The only way to ensure that only users who had an Enterprice CAL accessed Enterprise features was to have separate Enterprise and Standard server deployments.

In SharePoint 2013, farm administrators now can assign licenses to users and enable license checks. WIth this new functionality, you can ensure that only users with the appropriate license can use a specific feature. This SharePoint Server license implementation is managed by using new Windows PowerShell cmdlets. By default, licensing is disabled in SharePoint Server. Administrators can opt to enable it by using Windows PowerShell.

User licenses are "assigned" by mapping claims to a known type of license. For example, a claim can be an Active Directory Domain Services (AD DS) Security group. By mapping the "ContosoFinanceDept" security group to an "Enterprise" license, you assign an Enterprise license to all members of that group. Users who log on to SharePoint Server are assigned claims. SharePoint Server examines the claims of users to determine their license. If a user does not have a license to use a particular feature, that feature will be blocked at runtime for them.

Important:

You must use Windows PowerShell to create mappings for license types and to return user license types. There is no user interface for this feature.

Configure licensing by using Windows PowerShell

To configure licensing support in SharePoint Server 2013, complete the following steps in this order:

  • Return a list of supported licenses

  • Create mapping objects

  • Add mapping objects

  • Enable licensing

Note:

To avoid licensing error messages, perform the Enable licensing step last.

To configure licensing by using Windows PowerShell

  1. Verify that you have the following memberships:

    • Securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPUserLicense
    Copy code
    $a = New-SPUserLicenseMapping -SecurityGroup <yoursecuritygroup> -License Enterprise
    Copy code
    $a | Add-SPUserLicenseMapping
    Copy code
    Enable-SPUserLicensing

    Where:

    • $a is the variable that stores the mapping object that is to be used as the input for the Add-SPUserLicenseMapping cmdlet.

    • <yoursecuritygroup> corresponds to a security group in Active Directory.

For more information, see Get-SPUserLicense Get-SPUserLicensing Add-SPUserLicenseMapping New-SPUserLicenseMapping Remove-SPUserLicenseMapping.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Web applications management in SharePoint Server 2013
See also

Published: April 9, 2013

Summary: Learn how to create and manage web applications in a SharePoint Server 2013 farm.

Applies to: SharePoint Server 2013

The following articles on TechNet describe how to create and manage web applications in a SharePoint Server 2013 farm. These articles are written for farm administrators who will operate SharePoint Server 2013. The articles also describe how to configure cache settings and how to manage permissions and permission policies for a web application.

TechNet articles about web applications management

The following articles about web applications management are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Manage permissions for a web application in SharePoint 2013 | Learn how to manage permissions for web applications in SharePoint Server 2013.
 | Manage permission policies for a web application in SharePoint 2013 | Learn how policies provide a centralized way to configure and manage a set of permissions that applies to only a subset of users or groups in a web application.
 | Extend claims-based web applications in SharePoint 2013 | Learn how to extend an existing claims-based SharePoint 2013 web application into a new zone to surface content to different types of users.
 | Define managed paths in SharePoint Server 2013 | Learn how to add a managed path for a web application in SharePoint 2013.
 | Cache settings operations in SharePoint Server 2013 | Learn about the available caches and the settings that can be configured for the BLOB cache, cache profiles and object cache settings in SharePoint Server 2013.

See also

Operations for SharePoint 2013


Manage permissions for a web application in SharePoint 2013
See also

Published: October 16, 2012

Summary: Illustrates how to manage permissions for SharePoint 2013 web applications.

Applies to: SharePoint Server 2013 Standard | SharePoint Foundation 2013

A web application is composed of an Internet Information Services (IIS) web site that acts as a logical container for the site collections that you create. Before you can create a site collection, you must create a web application.

All web applications have List, Site, and Personal permissions. Permissions for a web application are comprehensive settings that apply to all users and groups for all site collections in a web application. You can control user actions by enabling or disabling the associated permission on the web application. For example, if you do not want users to be able to add pages to the web application, you can disable the Add and Customize Pages permission, which is a site-related permission.

Important:

After you disable a specific permission for a web application, the permission cannot be granted to any user of a site on the web application.

If you want to set permissions for specific users or groups in a web application, you can create a permission policy for the web application.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products

  • Keyboard shortcuts

  • Touch

Manage permissions for a web application

You can configure a set of permissions to control the way users can interact with the sites and content in a web application.

To manage permissions for a web application

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, in the Application Management section, click Manage web applications.

  4. On the WEB APPLICATIONS tab of the ribbon, click the web application for which you want to manage permissions.

  5. In the Security group of the ribbon, click User Permissions.

  6. In the User Permissions for Web Application dialog box, select the check boxes next to the permissions that you want to enable, and clear the check boxes next to those permissions that you want to disable.

    You can select all permissions by selecting the Select All check box. You can clear all permissions by clearing the Select All check box.

  7. Click Save.

See also

Operations for SharePoint 2013
Plan authentication in SharePoint 2013
Manage permission policies for a web application in SharePoint 2013


Manage permission policies for a web application in SharePoint 2013
See also

Published: October 16, 2012

Summary: Illustrates how to manage SharePoint 2013 web application permission policies.

Applies to: SharePoint Server 2013 Standard | SharePoint Foundation 2013

A web application is composed of an Internet Information Services (IIS) web site that acts as a logical container for the site collections that you create. Before you can create a site collection, you must create a web application.

A web application can contain multiple site collections. Managing permissions for multiple collections can be difficult, especially if some users or groups need permissions other than those that apply for the whole web application.

Permission policies provide a centralized way to configure and manage a set of permissions that applies to only a subset of users or groups in a web application.

The differences between specifying user permissions for a web application and creating a permission policy for a web application are the users and groups to which the permissions apply and the scope at which the permissions apply. There is also a difference in the permissions lists where individual permissions are selected.

  • Permissions for a web application are comprehensive settings that apply to all users and groups for all site collections in a web application. The permissions list contains only one column, and all permissions are enabled by default. You must disable specific permissions individually.

  • A permission policy level for a web application contains permissions that enable a subset of users or groups to work with site collections in a specific way. For example, you might want to create a permission policy level for users of a site collection who will be able to add, edit, or delete items from a list, open a list, and view items, lists, and pages. However, you might want to prevent the same users from creating or deleting lists, which would require the Manage Lists permission.

    The permissions list contains a Grant All column and a Deny All column. You can either grant or deny all permissions as part of a permission policy level. You can also grant or deny individual permissions. By default, no permissions are enabled. If a single permission is neither granted nor denied, it can be set at the discretion of the site collection administrator or site administrator.

Warning:

A permission policy differs from an information management policy. A permission policy enables centralized management of permissions for a web application. Information management policies enable you to control who can access information, what they can do with the information, and how long the information should be retained. A permission policy is also different from Group Policy, which provides an infrastructure for centralized configuration management of Windows-based computers and applications that run on them.

In this article:

  1. Manage a user permission policy

  2. Manage permission policy for anonymous users

  3. Manage permission policy levels

Manage a user permission policy

You can add users to a permission policy, edit the policy settings, and delete users from a permission policy. The following settings can be specified or changed:

  • Zone: If a website has multiple zones, you can use the zone that you want the permission policy to apply to. The default is all zones, which can be specified for Windows users only.

  • Permissions: You can specify Full Control, Full Read, Deny Write, and Deny All permissions, or you can specify a custom permission level.

  • System: This setting enables SharePoint to display SHAREPOINT\System for system-related activity regardless of the Windows user accounts that have been configured for the hosting application pool and the SharePoint farm service account. You might want to specify this setting to prevent unnecessary information disclosure to end-users and potential malicious users who would be interested in knowing more about the SharePoint deployment in the enterprise.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products

  • Keyboard shortcuts

  • Touch

Add users to a permission policy

You might want to add users to a permission policy to ensure that all users are accessing content with the same set of permissions.

To add users to a permission policy

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, in the Application Management section, click Manage web applications.

  4. Click to highlight the web application whose permission policy that you want to manage.

  5. In the Policy group of the ribbon, click User Policy.

  6. In the Policy for Web Application dialog box, select the check box next to the user or group that you want to manage, and then click Add Users.

  7. In the Add Users dialog box, in the Zone list, click the zone to which you want the permission policy to apply and then click Next.

  8. In the Add Users dialog box, in the Choose Users section, type the user names, group names, or e-mail addresses that you want to add to the permission policy.

  9. In the Choose Permissions section, select the permissions that you want the users to have.

  10. In the Choose System Settings section, check Account operates as System if you want to specify whether a user account should be displayed as SHAREPOINT\System instead of the actual accounts that perform specific tasks within the SharePoint environment.

  11. Click Finish.

Edit a user permissions policy

You can edit a user permission policy to configure the permission level or to specify whether a user account should be displayed as SHAREPOINT\System instead of the actual accounts that perform specific tasks within the SharePoint environment.

To edit a user permissions policy

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, in the Application Management section, click Manage web applications.

  4. Click to highlight the web application whose permission policy that you want to edit.

  5. In the Policy group of the ribbon, click User Policy.

  6. In the Policy for Web Application dialog box, select the check box next to the user or group that you want to manage, and then click Edit Permissions of Selected Users.

  7. On the Edit Users page, in the Permission Policy Levels section, select the permissions that you want the users to have.

  8. In the Choose System Settings section, click Account operates as System to specify whether a user account should be displayed as SHAREPOINT\System instead of the actual accounts that perform specific tasks within the SharePoint environment.

  9. Click Save.

Delete users from a permission policy

You might want to delete users from a permission policy when they are no longer members of the groups for which the policy applies. For example, when an employee leaves the company, that person's user account should be removed from all permission policies.

To delete users from a permission policy

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, in the Application Management section, click Manage web applications.

  4. Click to highlight the web application whose permission policy that you want to manage.

  5. In the Policy group of the ribbon, click User Policy.

  6. In the Policy for Web Application dialog box, select the check box next to the user or group that you want to manage, click Delete Selected Users, and then click OK.

Manage permission policy for anonymous users

You can enable or disable anonymous access for a web application. If you enable anonymous access for a web application, site administrators can then grant or deny anonymous access at the site collection, site, or item level. If anonymous access is disabled for a web application, no sites within that web application can be accessed by anonymous users.

The following permission policies can be specified for anonymous users:

  • None: No policy is specified. This setting gives anonymous users the same default permissions available to NT AUTHORITY\Authenticated Users and All Authenticated Users.

  • Deny Write: This setting enables anonymous users to read all content within the site collections in a web application. You can then restrict the Read access by site collection, site, or item.

  • Deny All: Anonymous users have no access to any part of the web application.

To manage permission policy for anonymous users

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, in the Application Management section, click Manage web applications.

  4. Click to highlight the web application whose permission policy that you want to manage.

  5. In the Policy group of the ribbon, click Anonymous Policy.

  6. In the Anonymous Access Restrictions dialog box, in the Zone list, click the zone for which you want the policy to apply.

  7. In the Permissions section, select the permission policy that you want anonymous users to have, and then click Save.

Manage permission policy levels

Permission policy levels contain permissions that apply to specific users or groups. You can specify a combination of List, Site, or Personal permissions. You can also specify one of the following levels of site collection permissions:

  • Site Collection Administrator: Has Full Control permission on the whole site collection and can perform any action on any object.

  • Site Collection Auditor: Has Full Read permission on the whole site collection and associated data, such as permissions and configuration information.

If you specify either or both permission levels, you cannot specify individual permissions.

Add a permission policy level

You can create a permission policy level to customize a set of permissions for a specific user or group.

To add a permission policy level

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, in the Application Management section, click Manage web applications.

  4. Click to highlight the line for the web application whose permission policy that you want to manage.

  5. In the Policy group of the ribbon, click Permission Policy.

  6. In the Manage Permission Policy Levels dialog box, click Add Permission Policy Level.

  7. In the Add Permission Policy Level dialog box, in the Name and Description section, type the name and description for the policy that you want to create.

  8. In the Site Collection Permissions section, select the site collection permissions for this policy.

  9. In the Permissions section, select the permissions to grant or deny for this permission level.

    • Select the Grant All check box to include all available permissions in this policy.

    • Select the Deny All check box to deny all available permissions in this policy.

    • Select either the Grant or Deny check boxes to include or exclude individual List, Site, and Personal permissions from this policy.

      Do not click either Grant or Deny if you want to enable site collection or site owners to configure this permission.

  10. Click Save.

Edit a permission policy level

You can edit a permission policy level to add or remove individual permissions, depending on the needs of the user or group that is using the permission policy level.

To edit a permission policy level

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, in the Application Management section, click Manage web applications.

  4. Click to highlight the web application whose permission policy that you want to manage.

  5. In the Policy group of the ribbon, click Permission Policy.

  6. In the Manage Permission Policy Levels dialog box, click the link for the permission policy level that you want to edit.

  7. On the Edit Permission Policy Level page, edit the settings, and then click Save.

Delete a permission policy level

You might want to delete a permission policy level if the users or groups for which you created it are no longer required to use it. It is a good practice to review all existing permission policy levels to ensure that they are still required.

To delete a permission policy level

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, in the Application Management section, click Manage web applications.

  4. Click to highlight the web application whose permission policy that you want to manage.

  5. In the Policy group of the ribbon, click Permission Policy.

  6. In the Manage Permission Policy Levels dialog box, select the check box of a permission policy level, click Delete Selected Permission Policy Levels, and then click OK.

See also

Operations for SharePoint 2013
Plan authentication in SharePoint 2013
Manage permissions for a web application in SharePoint 2013


Extend claims-based web applications in SharePoint 2013
See also

Summary: Demonstrates how to extend an existing claims-based SharePoint 2013 web application into a new zone to surface content to different types of users.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can extend a web application that uses claims-based authentication by using Central Administration or Windows PowerShell. When you extend a web application, you expose the same content to different sets of users by using an additional IIS web site to host the same content.

Use one of the following procedures to extend a web application. You typically use Central Administration to extend a web application. If you want to automate the task of extending a web application, which is common in enterprises, use Windows PowerShell. After the procedure is complete, you will have two separate IIS web sites that expose the same content to users.

Note:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products

  • Keyboard shortcuts

  • Touch

Extend a claims-based web application by using Central Administration

Use the procedure described in this section to extend a claims-based SharePoint 2013 web application using the Central Administration.

To extend a claims-based web application by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To extend a web application, you must be a member of the Farm Administrators SharePoint group and a member of the local Administrators group on the computer running Central Administration.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the Central Administration Home page, in the Application Management section, click Manage web applications.

  4. Select the web application you want to extend and, in the Contribute group of the ribbon, click Extend.

  5. On the Extend Web Application to Another IIS Web Site page, in the IIS Web Site section, configure the settings for your extended web application by selecting one of the following two options:

    • Click Use an existing IIS web site, and then select the web site on which to extend your existing web application.

    • Click Create a new IIS web site, and then type the name of the web site in the Name box.

  6. In the IIS Web Site section, in the Port box, type the port number you want to use to access the web application. If you are creating a new web site, this box contains a suggested port number. If you are using an existing web site, this box contains the current port number.

    Note:

    The default port number for HTTP access is 80, and the default port number for HTTPS access is 443. To enable users to access the web application without typing in a port number, use the appropriate default port number.

  7. Optional: In the IIS Web Site section, in the Host Header box, type the host name (for example, www.contoso.com) that you want to use to access the web application.

    Note:

    In general, this box is empty unless you want to configure two or more IIS web sites to use port 80 on the same server and DNS has been configured to point multiple server names to the same server.

  8. In the IIS Web Site section, in the Path box, type the path to the site directory on the server. If you are creating a new web site, this box contains a suggested path. If you are using an existing web site, this box contains the current path of that web site.

  9. In the Security Configuration section, select the authentication method that you want to use for the web application and choose whether or not to use Use Secure Sockets Layer (SSL).

    Important:

    Secure Sockets Layer (SSL) is a requirement for web applications that are deployed in scenarios that support server-to-server authentication and app authentication. For more information, see Plan for server-to-server authentication in SharePoint 2013.

    • Under Authentication provider, select NTLM or Negotiate (Kerberos).

      Kerberos is the recommended security configuration to use with Integrated Windows authentication. Kerberos requires the application pool account to be Network Service or special configuration by the domain administrator. NTLM authentication will work with any application pool account.

    • In the Security Configuration section, click Yes or No for the Use Secure Sockets Layer (SSL) options. If you choose Yes, you must request and install an SSL certificate to configure SSL. For more information about how to set up SSL, see How to Setup SSL on IIS 7.0.

  10. In the Public URL section, type the URL for the domain name for all sites that users will access in this web application. This URL will be the base URL for links on pages within the web application. The default URL is the current server name and port.

  11. In the Public URL section, select the zone to use for the web application in the drop-down menu.

  12. Click OK to extend the existing web application.

Extend a claims-based web application by using Windows PowerShell

Use the procedure described in this section to extend claims-based SharePoint 2013 web application using Windows PowerShell.

To extend a claims-based web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 15 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. To extend a web application to the same port, but with a different host header, at the Windows PowerShell command prompt, type the following command::

    Copy code
    Get-SPWebApplication -Identity http://sitename | New-SPWebApplicationExtension -Name <Name> -HostHeader <HostHeader> -Zone <Zone> -URL <URL> -Port <Port> -AuthenticationProvider $ap

    Where:

    • <Name> is the name of the new IIS web site in the web application.

    • <HostHeader> is the hostname assigned to this zone of the web application.

    • <Zone> is the zone with which this new extension is to be associated.

    • <URL> is the public URL for this web application zone.

    • <Port> is the port on which this zone of the web application can be accessed.

    Example

    Copy code
    $ap = New-SPAuthenticationProvider -ASPNETRoleProviderName roleprovidername -ASPNETMembershipProvider membershipprovidername
    Copy code
    Get-SPWebApplication -Identity http://sitename | New-SPWebApplicationExtension -Name IntranetSite -HostHeader www.contoso.com -Zone Intranet -URL http://intranet.sitename.com -Port 9876 -AuthenticationProvider $ap

    For more information, see New-SPWebApplicationExtension.

See also

Create claims-based web applications in SharePoint 2013

Install and deploy SharePoint 2013 for IT Pros Resource Center


Define managed paths in SharePoint Server 2013
See also

Published: January 15, 2013

Summary: Learn how to add a managed path for a web application in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

When you define managed paths, you can specify the paths in the URL namespace of a web application to use for site collections. You can specify that one or more site collections exist at a specified path. This can be a convenient method of combining multiple site access for users in various departments.

An explicitly named path (for example, http://server/sites/team) is used for a single site collection. Appending a wildcard to the path (for example, http://server/sites/), you indicate that child URLs of the path are site collections.

Important:

Do not use "/*" to indicate wildcard managed sites at the root of the site collection. This type of wildcard prevents a site from being created at the root of the web application, which is required for some SharePoint features to work.

In this article:

  • Define managed paths for a web application by using Central Administration

  • Define managed paths for a web application by using Windows PowerShell

Before you begin

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Define managed paths for a web application by using Central Administration

Use the procedures that are described here to add or delete managed paths for a web application by using Central Administration.

To add a managed path by using Central Administration

  1. Verify that the user account that is performing this task is a member of the Farm Administrators SharePoint group.

  2. On the the SharePoint Central Administration website, click Application Management.

  3. On the Application Management page, click Manage web applications.

  4. Click the web application for which you want to manage paths.

    The ribbon becomes active.

  5. In the Manage group of the ribbon, click Managed Paths.

  6. On the Define Managed Paths page, in the Add a New Path section, type the path to include.

  7. Click Check URL to confirm the path name.

  8. In the Type list, select either Wildcard inclusion or Explicit inclusion to identify the type of path.

    The Wildcard inclusion type includes all paths that are subordinate to the specified path. The Explicit inclusion type includes only the site that is indicated by the specified path. Sites subordinate to the specified path are not included.

  9. Click Add Path.

  10. When you have finished adding paths, click OK.

To remove a managed path by using Central Administration

  1. Verify that the user account that is performing this task is a member of the Farm Administrators SharePoint group.

  2. On the the SharePoint Central Administration website, click Application Management.

  3. On the Application Management page, click Manage web Applications.

  4. Click the web application for which you want to manage paths. The ribbon becomes active.

  5. In the Manage group of the ribbon, click Managed Paths.

  6. On the Define Managed Paths page, in the Included Paths section, click the check box next to the path that you want to remove.

  7. Click Delete selected paths.

    Warning:

    Be sure that you want to remove the selected path before you perform this action. You'll have no additional opportunity to confirm. Deletion is immediate.

  8. After you are finished removing paths, click OK.

Define managed paths for a web application by using Windows PowerShell

You can use the New-SPManagedPath cmdlet to add managed paths for a web application. You can use the Remove-SPManagedPath cmdlet to remove managed paths from a web application.

The New-SPManagedPath cmdlet adds a new managed path to a given web application. For use with all host header site collections, use the -HostHeader parameter. For new deployments in SharePoint 2013, we recommend that you use the HostHeader parameter. The managed path is shared among all host header site collections. Otherwise, you must specify a web application in which to create this managed path. The relative URL is a partial URL that represents the managed path. When the slash (/) is used, the root is defined. If the Explicit parameter is not provided, the new managed path is a wildcard path.

To add a managed path by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $webapp = Get-SPWebApplication
    Copy code
    New-SPManagedPath [-RelativeURL] "</RelativeURL>" -WebApplication $webapp -HostHeader

    Where:

    • <-RelativeURL> is the relative URL for the new managed path. The type must be a valid partial URL, such as site or sites/teams/.

    • <-WebApplication> is the web application group to which to add this path.

    • <-HostHeader> is a switch to indicate to use managed paths to be used for host header site collections.

For more information, see New-SPManagedPath.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

To remove a managed path by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Remove-SPManagedPath [-Identity] <ManagedPathName> -WebApplication <WebApplication>

    Where:

    • <ManagedPathName> is the name of the managed path to delete.

    • <WebApplication> is the identity of the web application that hosts the managed path to delete.

    You are prompted to confirm the deletion.

For more information, see Remove-SPManagedPath.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Get-SPManagedPath


Cache settings operations in SharePoint Server 2013
See also

Published: April 9, 2013

Summary: Learn about the available caches and the settings that can be configured for the BLOB cache, cache profiles and object cache settings.

Applies to: SharePoint Server 2013

SharePoint Server 2013 provides four types of caches that help improve the speed at which web pages load in the browser: the BLOB cache, the page output cache, the object cache, and the anonymous search results cache. The BLOB cache is enabled and configured in the Web.config file in the web application to which you want to apply the cache. The page output cache and object cache are usually configured in the user interface at the site collection level. Certain settings for these caches can also be configured at the web application level. The changes that you make to the Web.config file will be applied to all site collections and sites within the web application, and will supersede any configuration made at the site collection level or below.

Note:

To use the page output cache or the object cache, you must be using the Publishing feature on your site.

BLOB cache

SharePoint Server 2013 provides a disk-based cache that stores files that are used by web pages to help them load quickly in the browser, and reduces the load on the database server when it uses those files. These files are known as binary large objects (BLOBs), and the cache is known as the BLOB cache. The BLOB cache is stored directly on the hard disk drive of a front-end web server computer. The first time that a web page is called, these files are copied from the database to the cache on the server hard disk drive, and all subsequent requests for those files are then served from the hard disk drive cache of the server. By default, the BLOB cache is off and must be enabled to use the functionality it provides. When you enable the BLOB cache on your front-end web server, you reduce the load on the SharePoint Server 2013 database server created by read requests from web browsers.

You enable the BLOB cache in the Web.config file of the web application to which you want to apply it. The changes that you make to the Web.config file will be applied to all site collections within the web application. For information about the BLOB cache, see Plan for caching and performance in SharePoint Server 2013.

Page output cache profiles

The page output cache stores the rendered output of a page. It also stores different versions of the cached page, based on the permissions of the users who are requesting the page. Page output cache settings can be configured at the site collection level, at the site level, and for page layouts. By default, the page output cache is turned off.

The page output cache uses cache profiles that specify how long items should be held in the cache. You can specify different cache profiles to be used for anonymous and authenticated users, which optimizes the use of the cache based on the authentication methods that are allowed on the site.

You can configure cache profile settings for a web application by editing the Web.config file on the application server. The cache profile settings that you configure at the web application level will be used for all cache profiles in the site collections for that web application.

Note:

There is a known issue with the Content Search Web Part. The SendContentBeforeQuery setting in the Web Part does not work correctly on pages that use output caching. This issue is resolved in the SharePoint Server 2013 cumulative update for March 2013. For more information, see Microsoft Knowledge Base article 2767999: Description of the SharePoint Server 2013 update: March 12, 2013.

Note:

To use the page output cache and the associated cache profile settings, you must be using the Publishing feature on your site.

Object cache

The object cache reduces the amount of traffic between the web server and the SQL database by storing objects —such as lists and libraries, site settings, and page layouts —in memory on the front-end web server computer. As a result, the pages that require these items can be rendered quickly, increasing the speed with which pages are delivered to the client browser. Object cache settings can be configured at the web application level, and at the site collection level. By default, the object cache is on at the site collection level.

You can optimize the object cache for a web application by specifying the size of the object cache. Specifying a larger number can enhance performance for some large sites at the cost of memory on each front-end web server. You can configure other settings for the object cache at site collection level.

Note:

To use the object cache, you must be using the Publishing feature on your site.

Anonymous search results cache

The anonymous search results cache is primarily used by publishing sites that allow access to anonymous users. It saves search results from anonymous users and reuses them for later queries that are the same as the original query. This improves performance on site pages that use the Content Search Web Part.

Note:

There is a known issue in which Content Search Web Part and the Catalog-Item Reuse Web Part do not use the anonymous search results cache on category pages. This issue is resolved in the SharePoint Server 2013 cumulative update for March 2013. For more information, see Microsoft Knowledge Base article 2767999: Description of the SharePoint Server 2013 update: March 12, 2013.

If you have category pages that you created before the cumulative update was installed, you must re-create the category pages. Save the layouts and any customizations on the original category pages that you want to keep. Disconnect and then reconnect to the catalog, and then copy the customizations to the new category pages.

TechNet articles about cache settings

The following articles about cache settings are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Configure cache settings for a web application in SharePoint Server 2013 | Describes how to configure the disk-based BLOB cache, the page output cache profiles, and the object cache for a web application.
Building blocks | Configure object cache user accounts in SharePoint Server 2013 | Describes how to configure the object cache user accounts.
Building blocks | Flush the BLOB cache in SharePoint Server 2013 | Describes how to clear the contents of the BLOB cache for a web application.

Additional resources about cache settings

The following resources about cache settings are available from other subject matter experts.

Content Description

TechNet logo

  • Resource Center: Enterprise Content Management in SharePoint Server 2010

  • Resource Center: Web Content Management in SharePoint Server 2010

Visit the Resource Center to access videos, community sites, documentation, and more.

See also

Plan for caching and performance in SharePoint Server 2013
Monitor cache performance in SharePoint 2013


Configure cache settings for a web application in SharePoint Server 2013
See also

Published: April 9, 2013

Summary: Learn how to configure the BLOB cache, page output cache profiles, and the object cache for a web application.

Applies to: SharePoint Server 2013

This article describes how to configure the disk-based BLOB cache, the page output cache profiles, and the object cache for a web application in SharePoint Server 2013.

You enable and configure the BLOB cache, and make configuration changes to the page output cache profiles and the object cache in the Web.config file in the web application to which you want to apply those changes. The changes you make to the Web.config file will be applied to all site collections within the web application.

SharePoint Server 2013 includes cache performance monitors that let you verify that the farm cache settings are correct and that the caching is running at maximum performance. For more information, see Monitor cache performance in SharePoint 2013.

Note:

Configuring the page output cache profiles and the object cache at the web application level will supersede any configuration that was made by site administrators at the site collection level or below.

Tip:

There may be times when the BLOB cache becomes out of sync with the content. For example, after you restore a content database, the BLOB cache will be out of sync with the content. To correct that situation, you must flush the BLOB cache. For more information, see Flush the BLOB cache in SharePoint Server 2013.

For more information, see Cache settings operations in SharePoint Server 2013.

In this article:

  • Before you begin

  • Configure BLOB cache settings

  • Configure cache profile settings

  • Configure object cache settings

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure BLOB cache settings

By default, the disk-based BLOB cache is off and must be enabled on the front-end web server if you want to use it. Use the following procedure to configure disk-based cache settings for a web application.

Important:

Before you make changes to the web.config file, make a copy of it by using a different name (for example, web.config1), so that if a mistake is made in the file, you can restore the original file.

To configure BLOB cache settings

  1. Verify that you have the following administrative credentials: You must be a member of the Administrators group on the local computer to configure the BLOB cache settings.

  2. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.

  3. In Internet Information Services (IIS) Manager, in the Connections pane, click the plus sign (+) next to the server name that contains the web application, and then click the plus sign next to Sites to view the web application or applications that have been created.

  4. Right-click the name of the web application for which you want to configure the disk-based cache, and then click Explore. Windows Explorer opens, with the directories for the selected web application listed.

  5. Right-click web.config, and then click Open.

  6. If the Windows dialog box appears, select Select a program from a list of installed programs, and then click OK.

  7. In the Open With dialog box, click Notepad, and then click OK.

  8. In the web.config Notepad file, find the following line: <BlobCache location="C:\BlobCache\14" path="\.(gif|jpg|jpeg|jpe|jfif|bmp|dib|tif|tiff|themedbmp|themedcss|themedgif|themedjpg|themedpng|ico|png|wdp|hdp|css|js|asf|avi|flv|m4v|mov|mp3|mp4|mpeg|mpg|rm|rmvb|wma|wmv|ogg|ogv|oga|webm|xap)$" maxSize="10" enabled="false" />

  9. In this line, change the location attribute to specify a directory that has enough space to accommodate the cache size.

    Note:

    We strongly recommend that you specify a directory that is not on the same drive as where either the server operating system swap files or server log files are stored.

  10. To add or remove file types from the list of file types to be cached, for the path attribute, modify the regular expression to include or remove the appropriate file extension. If you add file extensions, make sure to separate each file type with a pipe (|), as shown in this line of code.

  11. To change the size of the cache, type a new number for maxSize. The size is expressed in gigabytes (GB), and 10 GB is the default.

    Important:

    It is recommended that you not set the cache size smaller than 10 GB. When you set the cache size, make sure to specify a number large enough to provide a buffer at least 20 percent bigger than the estimated size of the content that will be stored in the cache.

  12. To enable the BLOB cache, change the enabled attribute, from "false" to "true".

  13. Save the Notepad file, and then close it.

Caution:

When you save a change to the web.config file, the web application in Internet Information Services (IIS) 7.0 automatically recycles. This recycling can cause a brief interruption in service to sites contained in that web application, and users can lose session state. For information about recycling web applications in IIS 7.0, see IIS Process Recycling (http://go.microsoft.com/fwlink/p/?LinkId=154094).

Configure cache profile settings

Cache profile settings can be configured in the user interface at the site collection level by a site collection administrator, as well as at the web application level by an administrator on the front-end web server. The page output cache must be enabled at the site collection level before page output cache profiles can be configured at either the site collection level or web application level. If page output cache profiles are enabled at the web application level, the settings specified in Web.config will be used for all page output cache profiles, overriding any values that have been entered through the user interface at the site collection level.

Note:

To use the page output cache and the associated cache profile settings, you must be using the Publishing feature on your site.

Note:

There is a known issue with the Content Search Web Part. The SendContentBeforeQuery setting in the Web Part does not work correctly on pages that use output caching. This issue is resolved in the SharePoint Server 2013 cumulative update for March 2013. For more information, see Microsoft Knowledge Base article 2767999: Description of the SharePoint Server 2013 update: March 12, 2013.

Use the following procedure to configure the cache profile settings for a web application.

Important:

Before you make changes to the web.config file, make a copy of it by using a different name (for example, web.config1), so that if a mistake is made in the file, you can restore the original file.

To configure page output cache profile settings

  1. Verify that you have the following administrative credentials: You must be a member of the Administrators group on the local computer to configure the cache profile settings.

  2. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.

  3. In Internet Information Services (IIS) Manager, in the Connections pane, click the plus sign (+) next to the server name that contains the web application, and then click the plus sign next to Sites to view the web application or applications that have been created.

  4. Right-click the name of the web application for which you want to configure the disk-based cache, and then click Explore. Windows Explorer opens, with the directories for the selected web application listed.

  5. Right-click web.config, and then click Open.

  6. If the Windows dialog box appears, select Select a program from a list of installed programs, and then click OK.

  7. In the Open With dialog box, click Notepad, and then click OK.

  8. In the web.config Notepad file, find the following line: <OutputCacheProfiles useCacheProfileOverrides="false" varyByHeader="" varyByParam="*"  varyByCustom="" varyByRights="true" cacheForEditRights="false" />

  9. To enable the cache profile at the web application level, change the useCacheProfileOverrides attribute, from "false" to "true".

    Note:

    If you set this to true the settings specified in Web.config will be used for all page output cache profiles. This overrides any values that have been entered through the user interface at the site collection level.

  10. To override the varyByHeader attribute, type a custom parameter as specified in the .NET Framework Class Library entry HttpCachePolicy.VaryByHeaders Property (http://go.microsoft.com/fwlink/p/?LinkId=164238&clcid=0x409).

  11. To override the varyByParam attribute, type a custom parameter as specified in the .NET Framework Class Library entry HttpCachePolicy.VaryByParams Property (http://go.microsoft.com/fwlink/p/?LinkId=164242&clcid=0x409).

  12. To override the varyByCustom attribute, type a custom parameter as specified in the .NET Framework Class Library entry HttpCachePolicy.SetVaryByCustom Method (http://go.microsoft.com/fwlink/p/?LinkId=164240&clcid=0x409).

  13. To override the varyByRights attribute, change the value from "true" to "false". This will remove the requirement that users must have identical effective permissions on all securable objects to see the same cached page as any other user.

  14. To override the cacheForEditRights attribute, change the cacheForEditRights attribute, from "false" to "true". This will bypass the normal behavior in which people with edit permissions have their pages cached.

  15. Save the Notepad file, and then close it.

Caution:

When you save a change to the web.config file, the web application in Internet Information Services (IIS) 7.0 automatically recycles. This recycling can cause a brief interruption in service to sites contained in that web application, and users can lose session state. For information about recycling web applications in IIS 7.0, see IIS Process Recycling (http://go.microsoft.com/fwlink/p/?LinkId=154094).

Configure object cache settings

The object cache settings can be configured at the site collection level in the user interface by a site collection administrator, and is on by default. The maximum cache size can be configured at the web application level on the front-end web server to place a restriction on the maximum amount of memory that the cache will use for all site collections. For example, individual site collections might have the object cache set at 100 MB, while the web application might be set at 1 GB. In this case, no more than 1 GB of memory will be used by all the caches on the server.

Note:

To use the object cache, you must be using the Publishing feature on your site.

Use the following procedure to configure the object cache settings for a web application on a front-end web server.

Important:

Before you make changes to the web.config file, make a copy of it by using a different name (for example, web.config1), so that if a mistake is made in the file, you can restore the original file.

To configure object cache settings

  1. Verify that you have the following administrative credentials: You must be a member of the Administrators group on the local computer to configure the object cache settings.

  2. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.

  3. In Internet Information Services (IIS) Manager, in the Connections pane, click the plus sign (+) next to the server name that contains the web application, and then click the plus sign next to Sites to view the web application or applications that have been created.

  4. Right-click the name of the web application for which you want to configure the disk-based cache, and then click Explore. Windows Explorer opens, with the directories for the selected web application listed.

  5. Right-click web.config, and then click Open.

  6. If the Windows dialog box appears, select Select a program from a list of installed programs, and then click OK.

  7. In the Open With dialog box, click Notepad, and then click OK.

  8. In the Web.config Notepad file, find the following line: <ObjectCache maxSize="100" />

  9. To change the size of the cache, type a new number for maxSize. The size is expressed in megabytes (MB), and 100 MB is the default.

  10. Save the Notepad file, and then close it.

Caution:

When you save a change to the web.config file, the web application in Internet Information Services (IIS) 7.0 automatically recycles. This recycling can cause a brief interruption in service to sites contained in that web application, and users can lose session state. For information about recycling web applications in IIS 7.0, see IIS Process Recycling.

See also

Cache settings operations in SharePoint Server 2013
Plan for caching and performance in SharePoint Server 2013

Resource Center: Enterprise Content Management in SharePoint Server 2010


Configure object cache user accounts in SharePoint Server 2013
See also

Published: April 9, 2013

Summary: Learn how to configure the Portal Super User and Portal Super Reader accounts that are used by the object cache in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The object cache stores properties about items in SharePoint Server 2013. Items in this cache are used by the publishing feature when it renders web pages. The goals of the object cache are to reduce the load on the computer on which SQL Server is running, and to improve request latency and throughput. The object cache makes its queries as one of two out-of-box user accounts: the Portal Super User and the Portal Super Reader. These user accounts must be properly configured to ensure that the object cache works correctly. The Portal Super User account must be an account that has Full Control access to the web application. The Portal Super Reader account must be an account that has Full Read access to the web application.

Important:

The Portal Super User and Portal Super Reader accounts must be separate accounts, and they must not be accounts that will ever be used to log in to the site.

This article explains why these object cache user accounts must to be configured and describes how to configure the accounts. For information about the object cache, see Cache settings operations in SharePoint Server 2013.

In SharePoint Server 2013, querying for items is linked with the user account that makes the query. Various parts of the publishing feature make queries for which the results are cached in the object cache. These results are cached based on the user making the query. To optimize the cache hit rate and memory requirements, the queries must be based on whether a user can see draft items. When a publishing control requests the object cache to make a query to get data for the control, the cache makes the query, not as the user making the request, but instead it makes the query twice: once as the Portal Super User account and once as the Portal Super Reader account. The results of these two queries are stored in the object cache. The results for the Portal Super User account include draft items, and the results for the Portal Super Reader account include only published items. The object cache then checks the access control lists (ACLs) for the user who initiated the request and returns the appropriate results to that user based on whether that user can see draft items. By adding the Portal Super User and Portal Super Reader accounts to the web application, the cache must store results for only two users. This increases the number of results that are returned for a query and decreases the amount of memory that is needed to store the cache.

By default, the Portal Super User account is the site's System Account, and the Portal Super Reader account is NT Authority\Local Service. There are two main issues with using the out-of-box accounts.

  1. The first issue is that some items get checked out to System Account, so when a query that includes these items is made, the checked out version of the item is returned instead of the latest published version. This is a problem because it is not what a user would expect to have returned, so the cache has to make a second query to fetch the correct version of the file. This negatively affects server performance for every request that includes these items. The same problem would occur for any user who has items checked out, if that user's account was set to be the Portal Super User account. This is why the accounts configured to be the Portal Super User and the Portal Super Reader should not be user accounts that are used to log into the site. This ensures that the user does not inadvertently check items out and cause problems with performance.

  2. The default Portal Super Reader account is NT Authority\Local Service, which is not correctly resolved in a claims authentication application. As a result, if the Portal Super Reader account is not explicitly configured for a claims authentication application, browsing to site collections under this application will result in an "Access Denied" error, even for the site administrator. This error will occur on any site that uses any feature that explicitly uses the object cache, such as the SharePoint Server Publishing Infrastructure, metadata navigation, the Content Query Web Part, or navigation.

In this article:

  • Before you begin

  • Configure object cache user accounts by using Central Administration and Windows PowerShell

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure object cache user accounts by using Central Administration and Windows PowerShell

You can configure the user accounts for the object cache by using Central Administration and Windows PowerShell. You must first create the accounts in the Central Administration website and then add the accounts to the web application by using Windows PowerShell. You must add the user accounts to each web application.

Caution:

At the end of this procedure, you must reset Internet Information Services (IIS) to apply the changes to the web application. Be sure to perform this procedure when there will be minimal disruption to users that are connected to the site. For more information about IISReset, see IIS Reset Activity.

To create the user accounts by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. On the Central Administration website, in the Application Management section, click Manage web applications.

  3. Click the name of the web application that you want to configure.

  4. On the Web Applications tab, in the Policy group, click User Policy.

  5. In the Policy for Web Application window, click Add Users.

  6. From the Zones list, select All zones, and then click Next.

  7. In the Users box, type the user name for the Portal Super User account.

  8. Click the Check Names icon to ensure that the account name can be resolved by the authentication providers on the application server.

  9. In the Choose Permissions section, check the Full Control - Has full control box.

  10. Click Finish.

  11. Repeat Steps 5 through 8 for the Portal Super Reader account.

  12. In the Choose Permissions section, check the Full Read - Has full read-only access box.

  13. Click Finish.

  14. Make note of how the names for the Object Cache Super Reader and Object Cache Super User accounts are displayed in the User Name column. The displayed strings will be different depending on whether you are using claims authentication for the web application.

To add the user accounts to the web application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Paste the following code into a text editor, such as Notepad:

    Copy code
    $wa = Get-SPWebApplication -Identity "<WebApplication>"
$wa.Properties["portalsuperuseraccount"] = "<SuperUser>"
$wa.Properties["portalsuperreaderaccount"] = "<SuperReader>"
$wa.Update()

  3. Replace the following placeholders with values:

    • <WebApplication> is the name of the web application to which the accounts will be added.

    • <SuperUser> is the account to use for the Portal Super User account as you saw it displayed in the User Column field mentioned in Step 14 of the previous procedure.

    • <SuperReader> is account to use for the Portal Super Reader account as you saw it displayed in the User Column field mentioned in Step 14 of the previous procedure.

  4. Save the file, naming it SetUsers.ps1.

    Note:

    You can use a different file name, but you must save the file ANSI-encoded as a text file whose extension is .ps1.

  5. Close the text editor.

  6. On the Start menu, click All Programs.

  7. Click Microsoft SharePoint 2013 Products.

  8. Click SharePoint 2013 Management Shell.

  9. Change to the directory where you saved the file.

  10. At the Windows PowerShell command prompt, type the following command: ./SetUsers.ps1

  11. Reset Internet Information Services (IIS). For more information about IISReset, see IIS Reset Activity.

See also

Cache settings operations in SharePoint Server 2013


Flush the BLOB cache in SharePoint Server 2013
See also

Published: April 9, 2013

Summary: Learn how to clear the contents of the BLOB cache for a web application.

Applies to: SharePoint Server 2013

A BLOB cache is a disk-based cache that stores binary large objects (BLOBs) such as frequently used image, audio, and video files, and other files that are used to display web pages. Each front-end web server maintains its own BLOB cache. When you enable a BLOB cache, you specify the file types to include in the cache and also the location of the BLOB cache. The first time that a BLOB file is requested, the file is copied from the database to the BLOB cache on the front-end web server. Future requests to the front-end web server for that same file are then served from the file that is stored in the BLOB cache, instead of being served from the database. This reduces the network traffic and the load on the database server.

For more information about BLOB caches, see Plan for caching and performance in SharePoint Server 2013.

In this article:

  • Before you begin

  • Flush the BLOB cache

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Flush the BLOB cache

When you flush the BLOB cache, you clear the contents of the BLOB cache for a web application. This is useful if the BLOB cache becomes out of sync with the content. For example, after you restore a content database, the BLOB cache will be out of sync with the content. To correct that situation, you must flush the BLOB cache. The following procedure describes how to flush the BLOB cache for a web application.

Caution:

Flushing the BLOB cache for a web application affects all site collections in the web application.

Note:

You cannot use the user interface to flush the BLOB cache. Instead, you use Windows PowerShell and the SharePoint object model to complete this task.

To flush the BLOB cache

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Copy the following code and paste it into a text editor, such as Notepad.

    Copy code
    $webApp = Get-SPWebApplication "<WebApplicationURL>"
[Microsoft.SharePoint.Publishing.PublishingCache]::FlushBlobCache($webApp)
Write-Host "Flushed the BLOB cache for:" $webApp

  3. Replace <WebApplicationURL> with the URL of the web application whose BLOB cache you want to clear.

  4. Save the file, and name it FlushBLOBCache.ps1.

    Note:

    You can use a different file name, but you must save the file as an ANSI-encoded text file that has the file name extension .ps1.

  5. On the Start menu, click All Programs.

  6. Click Microsoft SharePoint 2013 Products.

  7. Click SharePoint 2013 Management Shell.

  8. Change to the directory where you saved the file.

  9. At the Windows PowerShell command prompt, type the following command.

    Copy code
    ./FlushBLOBCache.ps1

See also

Running Windows PowerShell Scripts


Configure People Picker in SharePoint 2013
See also

Published: October 30, 2012

Summary: Learn how to use the Stsadm.exe tool to manage People Picker in SharePoint 2013.

You configure the People Picker web control at the zone level for a farm by using the Stsadm setproperty operation. By configuring the settings for the control, you can filter and restrict the results that are displayed when a user searches for a user, group, or claim. Those settings will apply to every site within the site collection.

The information in this article applies only to web applications that use Windows authentication in either claims mode (the default for SharePoint 2013) or classic mode.

You use the People Picker control to find and select users, groups, and claims when a site, list, or library owner assigns permissions in SharePoint 2013. People Picker is configured at the zone level for a farm by using the Stsadm setproperty operation. By configuring the settings for the control, you can filter and restrict the results that are displayed when a user searches for a user, group or claim. Those settings will apply to every site within the site collection. For more information about the People Picker properties, see Peoplepicker: Stsadm properties.

Note:

There are no Windows PowerShell commands to configure People Picker.

This article contains information about People Picker Stsadm properties and how to configure People Picker for specific scenarios. For more information about the People Picker control and how it works, its relationship to authentication and claims providers, and how to plan for People Picker, see People Picker and claims providers overview (SharePoint 2013).

Before you perform the procedures in this article, you must do the following:

  • Verify that the account that you use to run Stsadm is a member of the Administrators group on the server on which SharePoint 2013 is installed.

  • Open the Command Prompt window as an administrator to perform the procedures in this article.

  • In the command prompt on the drive where SharePoint 2013 is installed, change to the following directory: %COMMONPROGRAMFILES%\Microsoft Shared\Web Server Extensions\15\Bin. %COMMONPROGRAMFILES% is typically set to <drive letter>:\Program Files\Common Files.

In this article:

  • People Picker Stsadm properties

  • Check the setting value for any property

  • Clear a property value from People Picker

  • Set an encryption key for use with a one-way trust

  • Enable cross-forest or cross-domain queries when you use a one-way trust

  • Restrict People Picker to a certain group in Active Directory

  • Define the location of administrator accounts

  • Force People Picker to pick only from users in the site collection

  • Filter Active Directory accounts by using LDAP queries

  • Return only non-Active Directory user accounts

People Picker Stsadm properties

Table 1 lists the Stsadm properties that you can use to configure People Picker.

Table 1. Properties that can be used to configure People Picker

Property name | Description
Peoplepicker-activedirectorysearchtimeout | Configures the time-out when a query is issued to Active Directory Domain Services. The default time-out value is 30 seconds. For more information, see Peoplepicker-activedirectorysearchtimeout.
Peoplepicker-distributionlistsearchdomains | Restricts the search of a distribution list to a specific subset of domains. For more information, see Peoplepicker-distributionlistsearchdomains.
Peoplepicker-nowindowsaccountsfornonwindowsauthenticationmode | Specifies not to search Active Directory when the current port is using forms-based authentication. For more information, see Peoplepicker-nowindowsaccountsfornonwindowsauthenticationmode.
Peoplepicker-onlysearchwithinsitecollection | Displays only users who are members of the site collection. For more information, see Peoplepicker-onlysearchwithinsitecollection.
Peoplepicker-peopleeditoronlyresolvewithinsitecollection | Displays only users who are members of the current site collection. For more information, see Peoplepicker-peopleeditoronlyresolvewithinsitecollection: Stsadm property (SharePoint Server 2010).
Peoplepicker-searchadcustomfilter | Enables a farm administrator to specify a unique search query. For more information, see Peoplepicker-searchadcustomfilter.
Peoplepicker-searchadcustomquery | Permits the administrator to set the custom query that is sent to Active Directory. For more information, see Peoplepicker-searchadcustomquery.
Peoplepicker-searchadforests | Permits a user to search from a second one-way trusted forest or domain. For more information, see Peoplepicker-searchadforests.
Peoplepicker-serviceaccountdirectorypaths | Enables a farm administrator to manage the site collection that has a specific organizational unit (OU) setting as defined in the Setsiteuseraccountdirectorypath setting. For more information, see Peoplepicker-serviceaccountdirectorypaths.

Check the setting value for any property

To check the setting for any People Picker property, type the following command:

stsadm.exe -o getproperty -pn<Property name>-url<Web application URL>

For more information, see Peoplepicker: Stsadm properties.

Clear a property value from People Picker

You can remove the setting for a People Picker property by specifying the property name that you want to clear, and using empty quotation marks for the property value.

To remove a property setting from People Picker, type the following command:

stsadm.exe -o setproperty -pn<Property name>-pv "" -url<Web application URL>

For more information, see Peoplepicker-searchadforests: Stsadm property.

Set an encryption key for use with a one-way trust

If the forest or domain on which SharePoint 2013 is installed has a one-way trust with another forest or domain, you must first set the credentials for an account that can authenticate with the forest or domain to be queried before you can use the Stsadm peoplepicker-searchadforests property.

Note:

The encryption key must be set on every front-end web server in the farm on which SharePoint 2013 is installed.

To set an encryption key, type the following command:

stsadm.exe -o setapppassword -password<Key>

For more information about querying additional forests or domains, see All you want to know about People Picker in SharePoint ( Functionality | Configuration | Troubleshooting ) Part-2.

Enable cross-forest or cross-domain queries when you use a one-way trust

If the forest or domain on which SharePoint 2013 is installed has a one-way trust with another forest or domain, you must specify the credentials to be used to query the forest or domain, in addition to the names of the forests or domains to be queried. People Picker will only query the forests or domains that you specify in the peoplepicker-searchadforests property setting.

To specify the forests or domains to be queried together with the credentials, type the following command:

stsadm.exe -o setproperty -pn peoplepicker-searchadforests -pv<Valid list of forests or domains, Login name, Password>-url<Web application URL>

Note:

You do not have to include the encryption key password that you assigned to the account when you use the peoplepicker-searchadforests property. If you have not already set an encryption key for the account, an error message will be displayed.

Remember that the settings for People Picker are configured per zone for a web application. Therefore, if you have more than one forest or domain in your farm, you must combine the accounts and passwords into a single command for the setproperty operation.

The following example configures People Picker for use with a forest named Contoso.com and a domain named Fabrikam.com, and includes the credentials for each:

Copy code
STSADM.exe -o setproperty -pn peoplepicker-searchadforests -pv "forest:Contoso.com,Contoso\User1,Password1; domain:Fabrikam.com,Fabrikam\User2,Password2" -url http://central

For more information, see Peoplepicker-searchadforests: Stsadm property.

Restrict People Picker to a certain group in Active Directory

If a web application is using Windows authentication and the site user directory path is not set, the People Picker control searches all the Active Directory to resolve users' names or find users, instead of searching only users in a particular organizational unit (OU). The Stsadm setsiteuseraccountdirectorypath operation allows the user's directory path to be set to a specific OU in the same domain. After the directory path is set to a site collection, the People Picker control will only search under that particular OU.

To restrict People Picker to a certain OU in Active Directory, type the following command:

stsadm -o setsiteuseraccountdirectorypath -path<Valid OU name>-url<Web application URL>

The following example configures People Picker to only return users and groups in the OU named "Sales":

Copy code
stsadm -o setsiteuseraccountdirectorypath -path "OU=Sales,DC=ContosoCorp,DC=local" -url http://central
Note:

Because this property specifies only one OU at a time, you should only run the Stsadm setsiteuseraccountdirectorypath operation once per site collection. To set multiple OUs at one time, use the Stsadm Peoplepicker-serviceaccountdirectorypaths property.

For more information, see Setsiteuseraccountdirectorypath: Stsadm operation.

Define the location of administrator accounts

Administrative user accounts are often located in a different OU from regular site users. If you have used the Stsadm setsiteuseraccountdirectorypath operation to force People Picker to only return query results from a specific OU, you must also set the Stsadm peoplepicker-serviceaccountdirectorypaths property so the administrator can manage the site collection.

Note:

Before the peoplepicker-serviceaccountdirectorypaths property will work, the Setsiteuseraccountdirectorypath operation must be set and contain a value.

To define the location of administrator accounts, type the following command:

Stsadm -o setproperty -pn peoplepicker-serviceaccountdirectorypaths -pv<List of OU names>-url<Web application URL>

The following example configures People Picker to allow users who are in the OU named FarmAdmin:

Copy code
stsadm -o setproperty -pn peoplepicker-serviceaccountdirectorypaths -pv "OU=FarmAdmin,DC=Contoso,DC=local" -url http://central

For more information, see Peoplepicker-serviceaccountdirectorypaths: Stsadm property.

Force People Picker to pick only from users in the site collection

You can force People Picker to only return users who have permissions in the site collection by using either the PeoplePicker-Peopleeditoronlyresolvewithinsitecollection property or the PeoplePicker-Onlysearchwithinsitecollection property.

For more information, see Peoplepicker-onlysearchwithinsitecollection: Stsadm property and Peoplepicker-peopleeditoronlyresolvewithinsitecollection: Stsadm property.

Filter Active Directory accounts by using LDAP queries

You can use a Lightweight Directory Access Protocol (LDAP) query to create a custom filter for displaying query results. For more information about LDAP queries, see LDAP Query Basics.

To use a custom LDAP query, type the following command:

Stsadm -o setproperty -pn peoplepicker-searchadcustomfilter -pv<LDAP query filter>-url<Web application URL>

The following example filters out user accounts that do not have e-mail addresses, or that are disabled. Because security groups do not always have e-mail addresses associated with them, an OR statement is used to ensure that security groups are still included in the query results:

Copy code
stsadm -o setproperty -pn peoplepicker-searchadcustomfilter -pv "(|(&(mail=*)(!(userAccountControl:1.2.840.113556.1.4.803:=2)))(objectcategory=group))" -url http://central

The following example only returns active users, and not groups:

Copy code
stsadm -o setproperty -pn peoplepicker-searchadcustomfilter -pv "(&(objectCategory=person)(objectClass=user)(!userAccountControl:1.2.840.113556.1.4.803:=2))" -url http://central

For an explanation of the user account control string that is used in this query, see Search Filter Syntax (http://go.microsoft.com/fwlink/p/?LinkId=210020).

The following example returns a list of Active Directory users who have the title "Manager":

Copy code
stsadm -o setproperty -pn peoplepicker-searchadcustomfilter -pv "((Title=Manager))" -url http://central
Important:

Remember that every time that you run the setproperty command for a specific property, that property's current values will be overwritten by the new values that you specify. If you must filter query results based on multiple criteria, you must build a compound LDAP query that includes all the values for which you want to filter.

For more information, see Peoplepicker-searchadcustomfilter: Stsadm property.

Return only non-Active Directory user accounts

If your web application uses forms-based authentication, you can prevent People Picker from returning Active Directory accounts in the query results.

To return only non-Active Directory user accounts, type the following command:

stsadm -o setproperty -pn peoplepicker-nowindowsaccountsfornonwindowsauthenticationmode -pv yes -url<Web application URL>

For more information, see Peoplepicker-nowindowsaccountsfornonwindowsauthenticationmode: Stsadm property.

See also

People Picker and claims providers overview (SharePoint 2013)

Peoplepicker: Stsadm properties


About service applications and services in SharePoint 2013

Published: November 6, 2012

Summary: Learn about service applications and service application connections in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In SharePoint 2013, individual services can be configured independently and third-party companies can add services. The services infrastructure gives you control over which services are deployed and how services are shared.

Services that are deployed are named service applications. A service application provides a resource that can be shared across sites throughout a farm, and can be accessed by users through a hosting web application. Service applications are associated to web applications by service application connections. Some services can be shared across farms.

For more information about the logical structure of services and service applications, see Architecture.

For more information about how to manage service applications that included instructions for publishing service applications across farms, see Manage service applications in SharePoint 2013 and Share service applications across farms in SharePoint 2013.

For more information about starting, stopping, and configuring services, see Start or stop a service (SharePoint 2013).

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch


Start or stop a service (SharePoint 2013)
See also

Published: October 16, 2012

Summary: Learn how to start and stop a service in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

SharePoint 2013 includes services that reside on individual servers in the farm. In some cases, you can configure global service settings and start or stop a service. Services are managed directly in Central Administration instead of through a separate administration site. You can also remotely monitor and manage services. Additionally, you can manage services by using Windows PowerShell 3.0.

For more information about services and service applications, see About service applications and services in SharePoint 2013.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Starting or stopping a service

You can manage services by using the SharePoint Central Administration website or by using Windows PowerShell 3.0.

To start or stop a service by using Central Administration

  1. Confirm that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the the SharePoint Central Administration website, click System Settings.

  3. On the System Settings page, in the Servers section, click Manage services on server.

  4. To change the server on which you want to start or stop the service, on the Server menu, click Change Server, and then click the server name that you want.

  5. By default, only configurable services are displayed. To view all services, on the View menu, click All.

  6. To start or stop a service, click Start or Stop in the Action column of the relevant service.

  7. Click OK to start or stop the service.

To start a service by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Start-SPServiceInstance -Identity <ServiceGUID>

    Where <ServiceGUID> is the GUID of the service. If you do not know the service GUID, you can retrieve a list of all services in the farm together with their GUIDs by using the Get-SPServiceInstance cmdlet.

For more information, see Start-SPServiceInstance.

To stop a service by using Windows PowerShell

  1. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Stop-SPServiceInstance -Identity <ServiceGUID>

    Where <ServiceGUID> is the GUID of the service. If you do not know the service GUID, you can retrieve a list of all services in the farm together with their GUIDs by using the Get-SPServiceInstance cmdlet.

For more information, see Stop-SPServiceInstance.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Get-SPServiceInstance

Operations for SharePoint 2013


Manage service applications in SharePoint 2013
See also

Published: November 6, 2012

Summary: Learn how to manage and share service applications across farms in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

SharePoint 2013 includes a set of service applications that you can use to share services across web applications. In some cases, you can also share service applications across farms. You can manage service applications by using Central Administration or by using Windows PowerShell 3.0.

The following articles on TechNet provide information about how to install and configure SharePoint 2013.

TechNet articles about SharePoint 2013 installation and configuration

The following articles about SharePoint 2013 installation and configuration are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Assign or remove administrators to a service application (SharePoint 2013) | Learn how to assign or remove service administrators to a service application in SharePoint 2013.
 | Delete a service application in SharePoint 2013 | Learn how to use the SharePoint Central Administration website or Windows PowerShell to delete a service application in SharePoint 2013.
 | Share service applications across farms in SharePoint 2013 | Describes the process and cautions that are involved in sharing service applications across farms in SharePoint 2013.
 | Administer Access Services in SharePoint Server 2013 | Use these TechNet articles to administer Access Services in SharePoint Server 2013.
 | Administer Excel Services in SharePoint Server 2013 | Provides a list of articles about Excel Services administration in SharePoint Server 20133.
 | PerformancePoint Services administration (SharePoint Server 2013) | Provides a list of links to articles about PerformancePoint Services administration.

Individual service applications have specific instructions for their creation, configuration, and management. The following table lists articles that describe how to create, configure, and manage specific service applications.

Service application | Article
Access Services | Administer Access Services in SharePoint Server 2013
Excel Services | Administer Excel Services in SharePoint Server 2013
PerformancePoint | PerformancePoint Services administration (SharePoint Server 2013)
Search Service | Administer search in SharePoint Server 2013
Secure Store | Configure the Secure Store Service in SharePoint 2013
State Service | Manage the State Service
Visio Graphics Service | Visio Graphics Service administration in SharePoint Server 2013
User Profile Service | Administer the User Profile service in SharePoint Server 2013

See also

Architecture

About service applications and services in SharePoint 2013


Assign or remove administrators to a service application (SharePoint 2013)

Published: November 6, 2012

Summary: Learn how to assign or remove service administrators to a service application in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

An administrator of a SharePoint 2013 service application can assign additional administrators to that service application. These users are granted security-trimmed access to the SharePoint Central Administration Web site and can manage settings related to the service application. An administrator of a SharePoint 2013 service application can also remove administrators from a service application.

Note:

By default, members of the Farm Administrators group have permissions to manage all service applications.

You can assign or remove service application administrators by using Central Administration or by using Windows PowerShell 3.0.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

To assign or remove administrators to a service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration Home page, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, select the row that contains the service application to which you want to add or remove administrators. The ribbon becomes available.

  4. On the ribbon, click Administrators.

  5. To add an administrator:

    1. In the first text box on the page, type the user accounts or groups that you want to add. You can click the People icon to validate a name. You can click the Address book icon to search for users to add. You can add multiple administrators into the text box.

    2. After you have added the administrators, click OK.

  6. To remove an administrator:

    1. In the second text box on the page, select the administrator whom you want to remove. Note that this step does not remove the user from the system—it merely revokes the user's administrative permissions to the selected service application.

    2. Click Remove.

    3. After you have finished removing administrators, click OK.

To assign or remove administrators to a service application by using Windows PowerShell

  1. Verify that you meet the following minimum requirements:

    • You must have membership in the securityadmin fixed server role on the SQL Server instance

    • You must have membership in the db_owner fixed database role on all databases that are to be updated.

    • You must be a member of the Administrators group on the server on which you are running the Windows PowerShell cmdlet.

    Note:

    If these permissions are not satisfied, contact your Setup administrator or SQL Server administrator to request these permissions.

    For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.If SharePoint 2013 Management Shell

        is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To create a claims principal, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $principal = New-SPClaimsPrincipal "<contoso\jane>" -IdentityType WindowsSamAccountName

    Where <contoso\jane> is the user name for which you want to assign administrative permissions. The user name should be entered in the form of jane@contoso.com or contoso\jane. The new claims principal is stored in the $principal variable.

  4. To retrieve the service application, type the following command:

    Copy code
    $spapp = Get-SPServiceApplication -Name "<ServiceApplicationDisplayName>"

    Where <ServiceApplicationDisplayName> is the display name of the service application. The service application identification is stored in the $spapp variable.

    Important:

    The display name must be enclosed in quotation marks, and it must exactly match the service application display name. This includes capitalization. If you have more than one service application that has the identical display name (we do not recommend this), you can use the Get-SPServiceApplication cmdlet to view all service applications. You can then identify the service application by its GUID. For more information, see Get-SPServiceApplication.

  5. To retrieve the administrator security object for the service application, type the following command:

    Copy code
    $security = Get-SPServiceApplicationSecurity $spapp -Admin

    The retrieved administrator security object is stored in the $security variable.

    Warning:

    It is important that you append the -Admin argument when you use this command.

  6. To assign or revoke administrative permissions for the user who is identified by the new claims principal $principal (created in step 6 of this procedure) to the service application administrator security object $security (obtained in step 8 of this procedure), use the appropriate command as shown in the following example:

    1. To assign administrative permissions, type the following command:

      Copy code
      Grant-SPObjectSecurity $security $principal "Full Control"

    2. To revoke administrative permissions, type the following command:

      Copy code
      Revoke-SPObjectSecurity $security $principal

  7. To assign the updated $security security object to the service application, type the following command:

    Copy code
    Set-SPServiceApplicationSecurity $spapp $security -Admin
    Warning:

    It is important that you append the -Admin argument when you use this command.

  8. To confirm that the service application's security object is updated appropriately, type the following command:

    Copy code
    (Get-SPServiceApplicationSecurity $spapp -Admin).AccessRules

Examples

In the following example, the service account user "contoso\jane" is added to the administrators security object for the service application named "Contoso Visio Graphics".

Copy code
$principal = New-SPClaimsPrincipal "contoso\jane" -IdentityType WindowsSamAccountName
$spapp = Get-SPServiceApplication -Name "Contoso Visio Graphics"
$security = Get-SPServiceApplicationSecurity $spapp -Admin
Grant-SPObjectSecurity $security $principal "Full Control"
Set-SPServiceApplicationSecurity $spapp $security -Admin
(Get-SPServiceApplicationSecurity $spapp -Admin).AccessRules

In the following example, the service account user "contoso\jane" is removed from the administrators security object for the service application named "Contoso Visio Graphics".

Copy code
$principal = New-SPClaimsPrincipal "contoso\jane" -IdentityType WindowsSamAccountName
$spapp = Get-SPServiceApplication -Name "Contoso Visio Graphics"
$security = Get-SPServiceApplicationSecurity $spapp -Admin
Revoke-SPObjectSecurity $security $principal "Full Control"
Set-SPServiceApplicationSecurity $spapp $security -Admin
(Get-SPServiceApplicationSecurity $spapp -Admin).AccessRules

For more information, see the following Windows PowerShell articles:

  • New-SPClaimsPrincipal

  • Get-SPServiceApplication

  • Get-SPServiceApplicationSecurity

  • Grant-SPObjectSecurity

  • Revoke-SPObjectSecurity

  • Set-SPServiceApplicationSecurity

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Delete a service application in SharePoint 2013
See also

Published: November 6, 2012

Summary: Learn how to use Central Administration or Windows PowerShell to delete a service application in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

You can delete a service application by using the SharePoint Central Administration website or by using Windows PowerShell 3.0 cmdlets.

Caution:

The act of deleting a service application is permanent—you cannot undo this operation.

Before you delete a service application, verify that its removal will not adversely affect users. As a best practice, you should ensure that no web applications are currently consuming the service application that you are going to delete. For information about how to disconnect a service application from a web application, see Add or remove service application connections from a web application in SharePoint 2013.

When you delete a service application, you have the option of also deleting the service application database. Some service applications do not have databases). If you plan to create the service application again in the future, do not delete the service application database. If the service application is temporary, you will most likely want to delete the database during this operation.

To ensure that the service application is available for potential future use, consider backing up the service application before you delete it. For more information, see Back up service applications in SharePoint 2013 and Restore service applications in SharePoint 2013.

In this article:

  • To delete a service application by using Central Administration

  • To delete a service application by using Windows PowerShell

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

To delete a service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the SharePoint Central Administration website, click Application Management, and then click Manage service applications.

  3. On the Manage Service Applications page, click the row that contains the service application that you want to delete. The ribbon becomes available.

  4. On the ribbon, click Delete.

  5. In the confirmation dialog box, select the check box next to Delete data associated with the Service Applications if you want to delete the service application database. If you want to retain the database, leave this check box cleared.

  6. Click OK to delete the service application, or click Cancel to stop the operation.

To delete a service application by using Windows PowerShell

  1. Verify that you meet the following minimum requirements:

    • You must have membership in the securityadmin fixed server role on the SQL Server instance

    • You must have membership in the db_owner fixed database role on all databases that are to be updated.

    • You must be a member of the Administrators group on the server on which you are running the Windows PowerShell cmdlet.

    Note:

    If these permissions are not satisfied, contact your Setup administrator or SQL Server administrator to request these permissions.

    For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.If SharePoint 2013 Management Shell

        is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands.

  4. To retrieve the service application that you want to delete, type the following command:

    Copy code
    $spapp = Get-SPServiceApplication -Name "<Service application display name>"

    Where <Service application display name> is the display name of the service application that you want to delete.

    The service application information will be stored in the $spapp variable.

    Important:

    You have to type the display name within quotation marks, and you have to type the exact service application display name. This includes capitalization. We recommend that you do not create multiple service applications that have the same display name. If you do have this situation, you can use the Get-SPServiceApplication cmdlet to list all service applications. You can then use the service application GUID and the -Identity parameter to specify the service application that you want to delete. For more information, see Get-SPServiceApplication.

  5. To delete the selected service application, run either of the following commands. In both cases, you are prompted to confirm the deletion.

    • To delete the selected service application without removing the service application database, type the following command:

      Copy code
      Remove-SPServiceApplication $spapp

    • To delete the selected service application and also delete the service application database, type the following command:

      Copy code
      Remove-SPServiceApplication $spapp -RemoveData

Example

Copy code
$spapp = Get-SPServiceApplication -Name "Contoso BDC Service"
Remove-SPServiceApplication $spapp -RemoveData

In this example, the service application "Contoso BDC Service" information is stored in the $spapp variable. After the action is confirmed, the service application and its database are permanently deleted.

For more information, see Get-SPServiceApplication and Remove-SPServiceApplication.

See also

Remove-SPServiceApplicationProxyGroup


Share service applications across farms in SharePoint 2013
See also

Published: September 25, 2012

Summary: Describes the process and cautions that are involved in sharing service applications across farms in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In SharePoint 2013, some service applications can be shared across server farms.

By publishing a service application, you can optimize resources, avoid redundancy, and provide enterprise-wide services without installing a dedicated enterprise services farm. You can publish the following service applications in a SharePoint 2013 farm:

  • Business Data Connectivity

  • Machine Translation

  • Managed Metadata

  • User Profile

  • Search

  • Secure Store

Additionally, a SharePoint 2010 farm can consume services from a SharePoint 2013 Server farm. This allows for upgrade of multi-farm environments in which a farm hosting service applications is upgraded first. In this scenario, the service applications and features that the SharePoint 2010 farm experiences are limited to those that are available in SharePoint 2010. For example, a SharePoint 2010 farm cannot consume the Machine Translation service application from a SharePoint Server 2013 farm and does not benefit from the new features of the User Profile service application.

Note:

If the server farms are located in different domains, the User Profile service application requires both domains to trust one another. For the Business Data Connectivity service and Secure Store service application administration features to work from the consuming farm, the domain of the publishing farm must trust the domain of the consuming farm. Other cross-farm service applications work without a trust requirement between domains.

The User Profile service must reside in the same datacenter as the content it supports — The performance of social features require the User Profile service application to be located in the same datacenter as My Sites, team sites, and community sites.

The farm that contains the service application and publishes the service application so that other farms can consume the service application is known as the publishing farm. The farm that connects to a remote location to use a service application that the remote location is hosting is known as the consuming farm.

Note:

If you are familiar with SharePoint 2010, you might find it useful to think of the publishing farm as the parent farm and the consuming farm as a child farm.

This article describes the steps that are required to publish and consume service applications across farms. These steps must be performed in the order listed.

  1. Exchange trust certificates between the farms.

    To start, an administrator of the consuming farm must provide two trust certificates to the administrator of the publishing farm: a root certificate and a security token service (STS) certificate. Additionally, an administrator of the publishing farm must provide a root certificate to the administrator of the consuming farm. By exchanging certificates, each farm acknowledges that the other farm can be trusted.

    For more information, see Exchange trust certificates between farms in SharePoint 2013.

  2. On the publishing farm, publish the service application.

    On the farm on which the service application is located, an administrator must explicitly publish the service application. Service applications that are not explicitly published are available to the local farm only.

    For more information, see Publish service applications in SharePoint 2013.

  3. On the consuming farm, set the permission to the appropriate service applications

    You must give the consuming farm permission to the Application Discovery and Load Balancing Service Application on the publishing farm. After doing this, give the consuming farm permission to the published service applications that it will be consuming.

    For more information, see Set permissions to published service applications in SharePoint 2013.

  4. On the consuming farm, connect to the remote service application.

    After the publishing farm has published the service application, an administrator of the consuming farm can connect to that service application from the consuming farm if the address of the specific service application is known.

    For more information, see Connect to service applications on remote farms in SharePoint 2013.

    Important:

    You cannot share a User Profile service application across farms that reside in separate domains unless you first establish a domain-level trust between the two domains.

  5. Add the shared service application to a Web application proxy group on the consuming farm.

    An administrator must associate the new service application connection with a local Web application on the consuming farm. Only Web applications that are configured to use this association can use the remote service application.

    For information about how to configure a Web application proxy group connection, see Add or remove service application connections from a web application in SharePoint 2013.

    Note:

    It is important that you plan the proxy group layout before you add service applications to proxy groups.

  6. Configure server-to-server authentication between the publishing and consuming farms.

    To allow a web application or an application service to request a resource from a web application on another farm on behalf of a user, you have to configure server-to-server authentication between the farms. For more information, see Configure server-to-server authentication between publishing and consuming farms.

    Note:

    Web applications or application services that request resources from an application service on another farm do not require server-to-server authentication.

See also

Technical diagrams for SharePoint 2013


Exchange trust certificates between farms in SharePoint 2013
See also

Published: September 25, 2012

Summary: Learn how to exchange trust certificates between the publishing farm and the consuming farm in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In SharePoint 2013, a SharePoint farm can connect to and consume a service application that is published on another SharePoint 2013 farm. For this to occur, the farms must exchange trust certificates.

Both farms must participate in this exchange for service application sharing to work.

For more information about how to share service applications across farms see Share service applications across farms in SharePoint 2013.

You must use Windows PowerShell 3.0 commands to export and copy the certificates between farms. After the certificates are exported and copied, you can use either Windows PowerShell 3.0 commands or Central Administration to manage the trusts within the farm.

The instructions here assume the following criteria:

  • That the servers that are used for these procedures are running Windows PowerShell 3.0.

  • That the administrator will select and use the same server in each farm for all steps in the process.

  • If User Account Control (UAC) is turned on, you must run the Windows PowerShell 3.0 commands with elevated privileges.

In this article:

  • Exporting and copying certificates

  • Managing trust certificates using Windows Powershell

  • Managing trust certificates using Central Administration

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Share service applications across farms in SharePoint 2013

  • Share service applications across farms in SharePoint 2013

  • Configure server-to-server authentication between SharePoint 2013 farms

Exporting and copying certificates

An administrator of the consuming farm must provide two trust certificates to the publishing farm: a root certificate and a security token service (STS) certificate. An administrator of the publishing farm must provide a root certificate to the consuming farm.

You can only export and copy certificates by using Windows PowerShell 3.0.

To export the root certificate from the consuming farm

  1. On a server that is running SharePoint 2013 on the consuming farm, verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $rootCert = (Get-SPCertificateAuthority).RootCertificate
    Copy code
    $rootCert.Export("Cert") | Set-Content <C:\ConsumingFarmRoot.cer> -Encoding byte

    Where:

    • <C:\ConsumingFarmRoot.cer> is the path of the root certificate.

To export the STS certificate from the consuming farm

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $stsCert = (Get-SPSecurityTokenServiceConfig).LocalLoginProvider.SigningCertificate
    Copy code
    $stsCert.Export("Cert") | Set-Content <C:\ConsumingFarmSTS.cer> -Encoding byte

    Where:

    • <C:\ConsumingFarmSTS.cer> is the path of the STS certificate..

To export the root certificate from the publishing farm

  1. On a server that is running SharePoint 2013 on the publishing farm, verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $rootCert = (Get-SPCertificateAuthority).RootCertificate
    Copy code
    $rootCert.Export("Cert") | Set-Content <C:\PublishingFarmRoot.cer> -Encoding byte

    Where:

    • <C:\PublishingFarmRoot.cer> is the path of the root certificate.

To copy the certificates

  1. Copy the root certificate and the STS certificate from the server in the consuming farm to the server in the publishing farm.

  2. Copy the root certificate from the server in the publishing farm to a server in the consuming farm.

Managing trust certificates by using Windows Powershell

Managing trust certificates in a farm involves establishing trust. This section describes how to establish trust on both the consuming and publishing farms by using Windows PowerShell 3.0 commands.

Establishing trust on the consuming farm

To establish trust on the consuming farm, you must import the root certificate that was copied from the publisher farm and create a trusted root authority.

To import the root certificate and create a trusted root authority on the consuming farm

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $trustCert = Get-PfxCertificate <C:\PublishingFarmRoot.cer>
    Copy code
    New-SPTrustedRootAuthority <PublishingFarm> -Certificate $trustCert

    Where:

    • <C:\PublishingFarmRoot.cer> is the path of the root certificate that you copied to the consuming farm from the publishing farm.

    • <PublishingFarm> is a unique name that identifies the publishing farm. Each trusted root authority must have a unique name.

Establishing trust on the publishing farm

To establish trust on the publishing farm, you must import the root certificate that was copied from the consuming farm and create a trusted root authority. You must then import the STS certificate that was copied from the consuming farm and create a trusted service token issuer.

To import the root certificate and create a trusted root authority on the publishing farm

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $trustCert = Get-PfxCertificate <C:\ConsumingFarmRoot.cer>
    Copy code
    New-SPTrustedRootAuthority <ConsumingFarm> -Certificate $trustCert

    Where:

    • <C:\ConsumingFarmRoot.cer> is the name and location of the root certificate that you copied to the publishing farm from the consuming farm.

    • <ConsumingFarm> is a unique name that identifies the consuming farm. Each trusted root authority must have a unique name.

To import the STS certificate and create a trusted service token issuer on the publishing farm

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $stsCert = Get-PfxCertificate
<c:\ConsumingFarmSTS.cer>
    Copy code
    New-SPTrustedServiceTokenIssuer <ConsumingFarm> -Certificate $stsCert

    Where:

    • <C:\ConsumingFarmSTS.cer> is the path of the STS certificate that you copied to the publishing farm from the consuming farm.

    • <ConsumingFarm> is a unique name that identifies the consuming farm. Each trusted service token issuer must have a unique name.

Where:

For more information about these Windows PowerShell 3.0 cmdlets, see the following articles:

  • Get-SPCertificateAuthority

  • Get-SPSecurityTokenServiceConfig

  • New-SPTrustedRootAuthority

  • New-SPTrustedServiceTokenIssuer

  • Get-PfxCertificate (http://go.microsoft.com/fwlink/p/?LinkID=178943&clcid=0x409)

For information about how to use a script to automate part of this process, see Exchange trust certificates between farms (http://go.microsoft.com/fwlink/?LinkId=230666).

Managing trust certificates by using Central Administration

You can manage trusts on a farm only after the relevant certificates have already been exported and copied to the farm.

To establish trust by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the SharePoint Central Administration website, click Security.

  3. On the Security page, in the General Security section, click Manage trust.

  4. On the Trust Relationship page, on the ribbon, click New.

  5. On the Establish Trust Relationship page:

    1. Supply a name that describes the purpose of the trust relationship.

    2. Browse to and select the Root Authority Certificate for the trust relationship. This must be the Root Authority Certificate that was exported from the other farm by using Windows PowerShell, as described in Exporting and copying certificates.

    3. If you are performing this task on the publishing farm, select the check box for Provide Trust Relationship. Type in a descriptive name for the token issuer and browse to and select the STS certificate that was copied from the consuming farm, as described in Exporting and copying certificates.

    4. Click OK.

    After a trust relationship is established, you can modify the Token Issuer description or the certificates that are used by clicking the trust, and then clicking Edit. You can delete a trust by clicking it, and then clicking Delete.

See also

Plan for user authentication methods in SharePoint 2013
Create a web application in SharePoint 2013
Configure SAML-based claims authentication with AD FS in SharePoint 2013


Publish service applications in SharePoint 2013
See also

Published: September 25, 2012

Summary: Learn how to publish a service application in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In SharePoint 2013, some service applications can be published across farms and thereby be made available over remote connections. For more information about the process of sharing service applications across farms see Share service applications across farms in SharePoint 2013.

In this article:

  • To publish a service application by using Central Administration

  • To publish a service application by using Windows PowerShell

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • Share service applications across farms in SharePoint 2013

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

To publish a service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the SharePoint Central Administration website, click Application Management, and then click Manage service applications.

  3. Click the row that contains the service application that you want to publish. Commands on the ribbon become available.

  4. On the ribbon, click Publish.

  5. In the Publish Service Application dialog box:

    1. Select the Connection Type that you want from the drop-down list.

    2. If you want the service application to be available to remote farms, select the check box for Publish this Service Application to other farms.

    3. We recommend that you use the instructions in Exchange trust certificates between farms in SharePoint 2013 to establish trust between the two farms.

    4. Copy the Published URL into Notepad or another text editor. You must provide this URL to remote farms to connect the remote farms to the published service application. The URL will be similar to the following: urn:schemas-microsoft-com:sharepoint:service:9c1870b7ee97445888d9e846519cfa27#authority=urn:uuid:02a493b92a5547828e21386e28056cba&authority=https://ua_powershell:32844/Topology/topology.svc.

  6. You can optionally provide descriptive text and a link to a Web page that will be visible to administrators of remote farms. After you have specified the publication options that you want, click OK to publish the service application.

To publish a service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Publish-SPServiceApplication -Identity <ServiceApplicationGUID>

    If you do not know the GUID of the service application, you can use the following Windows PowerShell 3.0 cmdlet to list all service applications in the farm, together with their GUIDS:

    Copy code
    Get-SPServiceApplication

  4. To view the published service application load balancer URL, type the following command and record the output:

    Copy code
    Get-SPTopologyServiceApplication

    Any connecting remote farms will need the information that is generated by this command.

See also

Publish-SPServiceApplication
Get-SPServiceApplication
Get-SPTopologyServiceApplication


Set permissions to published service applications in SharePoint 2013
See also

Published: September 25, 2012

Summary: Learn how to configure permissions to the Application Discovery and Load Balancing Service Application and published service applications for the consuming farm in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In SharePoint 2013, you must establish a relationship between the publishing farm and the consuming farm by giving the consuming farm permission to the Application Discovery and Load Balancing Service Application on the publishing farm. After doing this, the consuming farm can be given permission to other service applications. For more information about the process of sharing service applications across farms see Share service applications across farms in SharePoint 2013.

In this article:

  • Set permission to the Application Discovery and Load Balancing Service Application and any other service application for a consuming farm by using Windows PowerShell

  • Set permission to the Application Discovery and Load Balancing Service Application and any other published service application for a consuming farm by using Central Administration

Important:

You must perform steps 1 through 5 in the Windows PowerShell procedure to obtain the consuming farm ID, which you must have in order to complete either the Windows PowerShell or Central Administration procedures.

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • Share service applications across farms in SharePoint 2013

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Set permission to the Application Discovery and Load Balancing Service Application and any other service application for a consuming farm by using Windows PowerShell

The first procedure explains how to set permission to the Application and Load Balancing Service Application. The second explains how to set permissions to any other service applications.

To set permission to the Application Discovery and Load Balancing Service Application for a consuming farm by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On a server in the consuming farm, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On a server in the consuming farm, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPFarm | Select Id

    For more information, see Get-SPFarm.

  4. On a server in the publishing farm, access the SharePoint 2013 Management Shell and at the Windows PowerShell command prompt, type the following commands:

    Copy code
    $security=Get-SPTopologyServiceApplication | Get-SPServiceApplicationSecurity
    Copy code
    $claimprovider=(Get-SPClaimProvider System).ClaimProvider
    Copy code
    $principal=New-SPClaimsPrincipal -ClaimType "http://schemas.microsoft.com/sharepoint/2009/08/claims/farmid" -ClaimProvider $claimprovider -ClaimValue <consumingfarmid>
    Copy code
    Grant-SPObjectSecurity -Identity $security -Principal $principal -Rights "Full Control"
    Copy code
    Get-SPTopologyServiceApplication | Set-SPServiceApplicationSecurity -ObjectSecurity $security

    Where:

    Consumingfarmid is the GUID value of the consuming farm

    For more information, see the following:

    • Get-SPTopologyServiceApplication

    • Set-SPServiceApplicationSecurity

    • Get-SPServiceApplicationSecurity

    • New-SPClaimsPrincipal

    • Get-SPClaimProvider

    • Grant-SPObjectSecurity

To set permission to a published service application for a consuming farm by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On a server in the consuming farm, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On a server in the consuming farm, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $security=Get-SPServiceApplication <GUID>| Get-SPServiceApplicationSecurity
    Copy code
    $claimprovider=(Get-SPClaimProvider System).ClaimProvider
    Copy code
    $principal=New-SPClaimsPrincipal -ClaimType "http://schemas.microsoft.com/sharepoint/2009/08/claims/farmid" -ClaimProvider $claimprovider -ClaimValue <consumingfarmid>
    Copy code
    Grant-SPObjectSecurity -Identity $security -Principal $principal -Rights <NamedAccessRights>
    Copy code
    Set-SPServiceApplicationSecurity <GUID> -ObjectSecurity $security

    Where:

    Consumingfarmid is the GUID value of the consuming farm

    <GUID> is the ID of the published service application.

    <NamedAccessRights> is the name of the access right from the Get-SPServiceApplicationSecurity <GUID>.NamedRights.

    For more information, see the following:

    • Get-SPServiceApplication

    • New-SPClaimsPrincipal

    • Get-SPServiceApplication

    • Get-SPServiceApplicationSecurity

    • Grant-SPObjectSecurity

    • Set-SPServiceApplicationSecurity

Set permission to the Application Discovery and Load Balancing Service Application and any other published service application for a consuming farm by using Central Administration

This procedure explains how to set permission to any service application, but most specifically, the Application and Load Balancing Service Application.

Important:

You must perform steps 1 through 5 in the Windows PowerShell procedure to obtain the consuming farm ID, which you must have in order to complete this procedure.

To set permission to the Application Discovery and Load Balancing Service Application and any other published service application for a consuming farm by using Central Administration

  1. On the server that hosts the SharePoint Central Administration website for the publishing farm, verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the SharePoint Central Administration website, click Application Management, and then click Manage service applications.

  3. Click the row that contains Application Discovery and Load Balancing Service Application.

  4. On the ribbon, click Permissions.

  5. In the Connection Permissions dialog box, do the following:

    1. Manually paste the ID of the consuming farm from Step 5 of the Windows PowerShell section.

    2. Click Add.

    3. Select the consuming farm ID, and then select the Full Control check box.

    4. Click OK.

  6. Repeat steps 2 through 5 for any published service applications for which you want to enable access from the consuming farm and assign the necessary permission.

Note:

To enable access to the User Profile service application, which is not available in SharePoint Foundation 2013, you must give the consuming farm's web application pool identity (that is, DOMAIN\Username) the permission instead of the consuming farm ID.

See also

Share service applications across farms in SharePoint 2013


Connect to service applications on remote farms in SharePoint 2013
See also

Published: September 25, 2012

Summary: Learn how to connect to and consume a published service application in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In SharePoint 2013, you can publish some service applications to make them available over remote connections. By publishing a service application, you can optimize resources and avoid redundancy, and provide enterprise-wide services without installing a dedicated enterprise services farm.

You can connect to a service application that has been shared by another farm if you know the address of the farm's discovery service or the address of the service application. Be aware that you can only connect to a service application on a remote farm if the farm administrator for the remote farm has published the service application. For more information about the process of sharing service applications across farms see Share service applications across farms in SharePoint 2013.

In this article:

  • To connect to a service application on a remote farm by using Central Administration

  • To connect to a service application on a remote farm by using Windows PowerShell

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • Share service applications across farms in SharePoint 2013

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

To connect to a service application on a remote farm by using Central Administration

  1. Verify that you are a member of the Farm Administrators SharePoint group.

  2. On a server in the consuming farm, on the SharePoint Central Administration website, click Application Management, and then click Manage service applications.

  3. On the ribbon, click Connect.

  4. On the Connect drop-down menu, click the kind of service application to which you want to connect.

  5. On the Connect to a Remote Service Application page, type the appropriate URL in the Farm or Service Application address text box, and then click OK.

    Note:

    You can obtain the URL from the administrator of the publishing farm. For more information, see Publish service applications in SharePoint 2013. There are two kinds of URLs that you can use in this step: either the URL of the service application or the URL of the remote farm's topology service application. If you use the URL of the service application, only the corresponding service application will be listed in Step 6 of this procedure. If you use the URL of the topology service, all service applications in the farm will be listed in Step 6 of this procedure.

  6. The new Connect to a Remote Service Application dialog box displays the service applications that match the URL that you typed in Step 5. Click the row that contains the name of the service application, and then select the check box to add the service application connection to the farm's default list of service application connections (that is, the default proxy group). Click OK.

  7. You are prompted to change the connection name. Type a new name into the Connection Name text box or leave the default name, and then click OK.

  8. We recommend that you use the instructions in Exchange trust certificates between farms in SharePoint 2013 to establish trust between the two farms.

  9. After the new connection is created, you must click OK to complete the procedure.

  10. Associate the new service application connection with a local Web application. For information about how to do this, see Add or remove service application connections from a web application in SharePoint 2013.

To connect to a service application on a remote farm by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On a server in the consuming farm, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On a server in the consuming farm, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Receive-SPServiceApplicationConnectionInfo -FarmUrl <PublishingFarmTopologyURL>

    Where:

    • <PublishingFarmTopologyURL> is the information that is retrieved by running the Get-SPTopologyServiceApplication cmdlet on the publishing farm. For more information, see Publish service applications in SharePoint 2013.

  4. At the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SP*ServiceApplicationProxy -Name " <ServiceApplicationProxyName>" -Url "<PublishingFarmTopologyURL>"

    Where:

    • <ServiceApplicationProxyName> is a unique name for a service application connection on the consuming farm.

    • <PublishingFarmTopologyURL> is the service application topology URL that was also used in the previous command.

    Each kind of service application has a specific Windows PowerShell 3.0 cmdlet that should be used instead of New-SP*ServiceApplicationProxy. (These cmdlets are listed in the See Also section.) For example, the following command creates a new Managed Metadata service application proxy named "MetadataServiceProxy1" that connects to the service application located at the stated URL.

    Copy code
    New-SPMetadataServiceApplicationProxy -Name "MetadataServiceProxy1" -Uri "
urn:schemas-microsoft-com:sharepoint:service:9c1870b7ee97445888d9e846519cfa27#authority=urn:uuid:02a493b92a5547828e21386e28056cba&authority=https://ua_powershell:32844/Topology/topology.svc  "

  5. You must associate the new service application connection with a local Web application. For information about how to do this, see Add or remove service application connections from a web application in SharePoint 2013.

See also

New-SPBusinessDataCatalogServiceApplicationProxy
New-SPEnterpriseSearchServiceApplicationProxy
New-SPMetadataServiceApplicationProxy
New-SPProfileServiceApplicationProxy
New-SPSecureStoreServiceApplicationProxy


Add or remove service application connections from a web application in SharePoint 2013
See also

Published: September 25, 2012

Summary: Learn how to add or remove service application connections to a service application connection group in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

When you create a service application in SharePoint 2013, a service application connection is created. A service application connection is also referred to as an application proxy. A service application connection associates the service application to Web applications via membership in a service application connection group (also referred to as application proxy group).

Important:

If you are creating a service application connection to a service application in a remote farm, you should read the article Share service applications across farms in SharePoint 2013 to gain a full understanding of the requirements to successfully share service applications across farms.

By default, a new service application connection is added to the farm's Default group of service application connections when you create the service application by using Central Administration. You can override this default membership. If a new service application is created by using Windows PowerShell 3.0 instead of by using Central Administration, the new service application does not automatically become a member of the Default service application connections group unless the default parameter is supplied.

Note:

For more information about how to create and configure service applications, see Manage service applications in SharePoint 2013.

By default, all Web applications are associated with the farm's Default group of service application connections, although you can change this setting. You can also create one custom connection group for each Web application in the farm. You can change the service applications with which a Web application is associated at any time, and you can change the service applications that are included in the Default service application connection group.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Editing a service connection group

You can add or remove service application connections to a service application connection group by using Central Administration or by using Windows PowerShell 3.0 cmdlets.

To edit a service connection group by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the Central Administration Home page, click Application Management.

  4. On the Application Management page, in the Service Applications section, click Configure service application associations.

  5. On the Service Application Associations page, select Web Applications from the View drop-down menu.

  6. In the list of Web applications, in the Application Proxy Group column, click the name of the service application connection group that you want to change.

  7. To add a service connection to the group, select the check box that is next to the service application that you want to add to the connection group. To remove a service application connection from the connection group, clear the check box next to the service application that you want to remove from the connection group. When you have made the changes that you want, click OK.

    Note:

    You can also change custom service application connection groups by clicking Manage Web Applications from the Central Administration Home page, selecting a listed Web application, and then clicking Service Connections on the ribbon. You cannot change the default service applications connection group through this page, however.

To add a service application connection to a service application connection group by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Add-SPServiceApplicationProxyGroupMember -Identity < the service application proxy group > -Member <members to add to the service application proxy group>

    For more information, see Add-SPServiceApplicationProxyGroupMember.

To remove a service application connection from a service application connection group by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Remove-SPServiceApplicationProxyGroupMember -Identity <SPServiceApplicationProxyGroupPipeBind> -Member <SPServiceApplicationProxyPipeBind >

    For more information, see Remove-SPServiceApplicationProxyGroupMember.

See also

Share service applications across farms in SharePoint 2013


Configure server-to-server authentication between publishing and consuming farms
See also

Published: February 26, 2013

Summary: Learn how to configure server-to-server authentication when you share service applications across SharePoint 2013 publishing and consuming farms.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

To enable a web application or an application service to request a resource from a web application on another farm on behalf of a user, you must configure server-to-server authentication between the farms. A few examples of SharePoint 2013 processes that use server-to-server authentication are as follows:

  • Follow a document on a Team Sites web application when a user's personal site is located on a My Sites web application. The Team Sites web application makes a request of the My Sites web application on behalf of the user.

  • Create or reply to a site feed post for a site that is located on a Team Sites web application but performed through the user's My Site Newsfeed on the My Sites web application. The My Sites web application will make a request of the Team Sites web application on behalf of the user to write the post or the reply.

  • A User Profile Service application task to repopulate the feed cache has to read from the personal site or team site. If the User Profile Service application is running in a different farm, the User Profile Service application sends a request to the My Sites web application or Team Sites web application to read the user or site feed data into the cache.

Note:

Web applications or application services that request resources from an application service on another farm do not require server-to-server authentication.

Before you begin

To understand the procedures in this article, you should be familiar with the basic concepts in the following articles:

Authentication overview for SharePoint 2013

Plan for server-to-server authentication in SharePoint 2013

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure server-to-server authentication between publishing and consuming farms

The following procedure describes how to configure server-to-server authentication between the publishing and consuming farms.

To configure server-to-server authentication between publishing and consuming farms

  1. Choose a realm name that will be common to both farms.

  2. Verify that you are a member of the Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • Securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  3. In the SharePoint 2013 environment on both the publishing and consuming farms, start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • In the SharePoint 2013 environment, on the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • In the SharePoint 2013 environment, on the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  4. To configure the publishing farm for the common realm name, type the following command at the Windows PowerShell command prompt on a server in the publishing farm:

    Copy code
    Set-SPAuthenticationRealm -realm <RealmName>

    Where:

    RealmName is the name that you chose in step 1.

  5. To configure the Name ID for the SharePoint Security Token Service (STS) on the publishing farm to include the common realm name, type the following commands at the Windows PowerShell command prompt on a server in the publishing farm:

    Copy code
    $sts=Get-SPSecurityTokenServiceConfig
$Realm=Get-SpAuthenticationRealm
$nameId = "00000003-0000-0ff1-ce00-000000000000@$Realm"
Write-Host "Setting STS NameId to $nameId"
$sts.NameIdentifier = $nameId
$sts.Update()

  6. To configure the consuming farm for the common realm name, type the following command at the Windows PowerShell command prompt on a server in the consuming farm:

    Copy code
    Set-SPAuthenticationRealm -realm <RealmName>

    Where:

    RealmName is the name that you chose in step 1.

  7. To configure the Name ID for the SharePoint STS on the consuming farm to include the common realm name, type the following commands at the Windows PowerShell command prompt on a server in the consuming farm:

    Copy code
    $sts=Get-SPSecurityTokenServiceConfig
$Realm=Get-SpAuthenticationRealm
$nameId = "00000003-0000-0ff1-ce00-000000000000@$Realm"
Write-Host "Setting STS NameId to $nameId"
$sts.NameIdentifier = $nameId
$sts.Update()

  8. To configure the publishing farm for server-to-server authentication with the consuming farm, type the following command at the Windows PowerShell command prompt on a server in the publishing farm:

    Copy code
    New-SPTrustedSecurityTokenIssuer -MetadataEndpoint "https://<ConsumeHostName>/_layouts/15/metadata/json/1" -Name "<ConsumeFriendlyName>"

    Where:

    • ConsumeHostName is the name and port of any SSL-enabled web application of the consuming farm.

    • ConsumeFriendlyName is a friendly name for the consuming farm.

    This creates the server-to-server authentication trust with the consuming farm.

  9. To configure the consuming farm for server-to-server authentication with the publishing farm, type the following command at the Windows PowerShell command prompt on a server in the consuming farm:

    Copy code
    New-SPTrustedSecurityTokenIssuer -MetadataEndpoint "https://<PublishHostName>/_layouts/15/metadata/json/1" -Name "<PublishFriendlyName>"

    Where:

    • PublishHostName is the name and port of any SSL-enabled web application of the publishing farm.

    • PublishFriendlyName is a friendly name for the publishing farm.

    This creates the server-to-server authentication trust with the publishing farm.

See also

Share service applications across farms in SharePoint 2013


Administer Access Services in SharePoint Server 2013
See also

Summary: Use these TechNet articles to administer Access Services in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Access Services in SharePoint Server 2013 administration enables you to create and customize Access apps for SharePoint and maintain and update Access web databases that were previously created in SharePoint Server 2010.

TechNet articles about Access Services administration

The following articles about Access Services administration are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Set up and configure Access Services for Access apps in SharePoint Server 2013 | Learn how to install, set up, and provision Access apps for SharePoint in Access Services.
Building blocks | Set up and configure Access Services 2010 for web databases in SharePoint Server 2013 | Learn how to modify and republish an Access web database that was previously created in SharePoint Server 2010.

Additional resources about Access Services administration

The following resources about the new features and capabilities in Access Services administration are available from other subject matter experts.

 | Content | Description
TechNet logo | What's New in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.

See also

Use Windows PowerShell cmdlets to manage Access Services in SharePoint Server 2013


Set up and configure Access Services for Access apps in SharePoint Server 2013
See also

Published: October 16, 2012

Summary: Learn how to install, set up, and provision Access Services for Access apps in SharePoint Server 2013.

Applies to: SharePoint Server 2013

To install, set up, and provision Access apps for SharePoint in Access Services in SharePoint Server 2013, perform the following steps:

  1. Install and configure SQL Server 2012 Enterprise software, because an Access app stores its data in a separate SQL Server back-end database.

  2. Configure SharePoint Server 2013 for apps for SharePoint, because an Access app is an app for SharePoint.

  3. Configure Access Services for Access apps so that Access Services can successfully run Access apps.

  4. Create a dedicated SharePoint site collection for Access apps, because each Access app requires its own subsite.

For information about how to set up and configure Access Services for Access apps, see the following white paper:

  • White Paper: Office 2013--Access Services Setup for an On-Premises Installation

See also

Set up and configure Access Services 2010 for web databases in SharePoint Server 2013


Set up and configure Access Services 2010 for web databases in SharePoint Server 2013
See also

Published: October 30, 2012

Summary: Learn how to use Access Services 2010 to modify and publish an Access web database in SharePoint Server 2013 that was previously created in SharePoint Server 2010.

Applies to: SharePoint Server 2013

Access Services 2010 is a service application that allows users to modify and publish in SharePoint Server 2013 an Access web database that was previously created in SharePoint Server 2010.

The Access client is not required to use the published web database. However, the Access client is required to make any changes to the database structure.

In this article:

  • Set up SQL Server Reporting Services

  • Start Access Database Service 2010

  • Create an Access Services 2010 service application

  • Configure Access Services 2010 settings

Set up SQL Server Reporting Services

You can update existing reports in an Access web database, but these reports require the installation and configuration of SQL Server Reporting Services Mode for SharePoint and the content database must be running SQL Server 2012. For more information, see Install Reporting Services SharePoint Mode for SharePoint 2013 in SQL Server Books Online.

Start Access Database Service 2010

If for some reason Access Database Service 2010 has not been started, do the following:

  1. On the SharePoint Central Administration website, under System Settings, click Manage services on the server.

  2. On the same row as the Access Database Service 2010 service, under Action, click Start.

Create an Access Services 2010 service application

If for some reason an Access Services 2010 service application has not been created, do the following:

  1. In Central Administration, under Application Management, click Manage service applications.

  2. On the Manage Service Applications page, click New, and then click Access Services 2010.

  3. In the Access Services Application Name section, type Access Services 2010 in the text box.

  4. Do one of the following:

    • Select the Use existing application pool option, and then select an Application pool name from the list.

    • Select the Create new application pool option, and then type AccessServicesAppPool in the Application pool name text box.

  5. Select the Configurable option, and then from the drop-down list, select the Farm administrator account.

  6. Click OK.

Configure Access Services 2010 settings

There are no additional settings required after the initial installation of Access Services 2010. The services are ready to use as soon as the SharePoint Server 2013 installation is complete. However, you can change the default configuration settings to suit your business need. The following table contains the configurable Access Services settings.

  1. Verify that the user account that is performing this procedure is a site administrator for the Access Services 2010 service application and also has Designer permissions.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Access Services 2010 service application that you want to change.

  4. On the Access Services 2010 settings page, change any of the settings shown in the following table.

    Setting Description

    Lists and Queries

    Settings for queries used against Microsoft SharePoint Foundation lists

    Maximum Columns per query

    The maximum number of columns that can be referenced in a query. Note that some columns may automatically be reference by the query engine and will be included in this limit.

    Valid values: from 1 to 255

    Default value: 40

    Maximum Rows per query

    The maximum number of rows that a list used in a query can have, or that the output of the query can have.

    Valid values: from 1 to 200000

    Default value: 25000

    Maximum Sources per query

    The maximum number of lists that may be used as input to one query.

    Valid values: from 1 to 20

    Default value: 12

    Maximum Calculated Columns per query

    The maximum number of inline calculated columns that can be included in a query, either in the query itself or in any sub-query on which it is based. Calculated columns in the underlying SharePoint Foundation list are not included.

    Valid values: from 0 to 32

    Default value: 10

    Maximum Order by Clauses per query

    The maximum number of Order By clauses in the query.

    Valid values: from 0 to 8

    Default value: 4

    Allow Outer Joins

    Allow left and right outer joins in a query. Inner Joins are always allowed.

    Check box: selected or cleared for Outer Joins allowed.

    Allow Non Remote-able Queries

    Allow queries that cannot be remoted to the database tier to run.

    Check box: selected or cleared for Remotable Queries allowed.

    Maximum Records Per Table

    The maximum number of records that a table in an application can contain.

    Valid values: -1 (indicates no limit), any positive integer

    Default value: 500000

    Application Objects

    Limitations on the types of objects an Access Services application can contain

    Maximum Application Log Size

    The maximum number of records for an Access Services Application Log list.

    Valid values: -1 (indicates no limit), from 1 to any positive integer

    Default value: 3000

    Session Management

    Behavior of Access Database Service sessions

    Maximum Request Duration

    The maximum duration (in seconds) allowed for a request from an application.

    Valid values: -1 (indicates no limit), 1 through 2007360 (24 days)

    Default value: 30

    Maximum Sessions Per User

    The maximum number of sessions allowed per anonymous user. If a user has this many sessions and starts a new session, the user's oldest session is deleted.

    Valid values: -1 (no limit), from 1 to any positive integer

    Default value: 10

    Maximum Sessions Per Anonymous User

    The maximum number of sessions allowed per user. If a user has this many sessions and starts a new session, the user's oldest session is deleted.

    Valid values: -1 (no limit), from 1 to any positive integer

    Default value: 25

    Cache Timeout

    The maximum time (in seconds) that a data cache can remain available, as measured from the end of each request for data in that cache.

    Valid values: -1 (indicates no limit), 1 through 2007360 (24 days)

    Default value: 1500

    Maximum Session Memory

    The maximum amount of memory (in MB) that a single session can use.

    Valid values: 0 (disable) through 4095.

    Default value: 64

    Memory Utilization

    Allocation of memory on Access Database Service

    Maximum Private Bytes

    The maximum number of private bytes (in MB) allocated by the Access Database Service process.

    Valid values: -1 (the limit is set to 50% of physical memory on the computer), any positive integer

    Default value: -1

    Templates

    Settings related to template management

    Maximum Template Size

    The maximum size (in MB) allowed for Access Templates (ACCDT).

    Valid values: -1 (no limit), from 1 to any positive integer

    Default value: 30

See also

Set up and configure Access Services for Access apps in SharePoint Server 2013


Administer Excel Services in SharePoint Server 2013

Summary: A list of articles about Excel Services administration in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Excel Services is a SharePoint Server 2013 service application that allows users to share and view Excel workbooks. The service application also enables data-connected Excel workbooks and work sheets to be refreshed and updated from a variety of data sources.

TechNet articles about Excel Services administration in SharePoint Server 2013

The following articles about Excel Services administration in SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Configure Excel Services in SharePoint Server 2013 | Deploy Excel Services to your SharePoint Server 2013 farm by creating an Excel Services service application by using Central Administration.
 | Manage Excel Services global settings (SharePoint Server 2013) | Edit Excel Services settings for security, load balancing, memory, cache, and external data by using the SharePoint Central Administration website.
 | Manage Excel Services trusted file locations (SharePoint Server 2013) | Add, configure, or delete an Excel Services trusted file location by using the SharePoint Central Administration website.
 | Manage Excel Services trusted data providers (SharePoint Server 2013) | Add, configure, or delete Excel Services trusted data providers by using the SharePoint Central Administration website.
 | Manage Excel Services trusted data connection libraries (SharePoint Server 2013) | Add, configure, or delete trusted data connection libraries in Excel Services by using the SharePoint Central Administration website.
 | Manage Excel Services user defined function assemblies (SharePoint Server 2013) | Add, edit or delete Excel Services user-defined function assemblies by using the SharePoint Central Administration website.
 | Manage Excel Services data model settings (SharePoint Server 2013) | Configure instances of SQL Server 2012 Analysis Services for Data Model functionality in Excel Services.


Configure Excel Services in SharePoint Server 2013

Summary: Deploy Excel Services to your SharePoint Server 2013 farm by creating an Excel Services service application by using Central Administration.

Applies to: SharePoint Server 2013 Enterprise

Important:

The steps in this article apply to SharePoint Server 2013 Enterprise.

Excel Services in SharePoint Server 2013 is enabled by creating an Excel Services Application service application in Central Administration. This article walks you through the steps of deploying Excel Services in your SharePoint Server 2013 farm.

In this article:

  • Before you begin

  • Video demonstration

  • Configure the application pool account

  • Start the Excel Calculation Services service

  • Create an Excel Services service application

  • Additional steps

Before you begin

Before you deploy Excel Services, we recommend that you review Overview of Excel Services in SharePoint Server 2013 and its associated Excel Services planning articles.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • A domain account is required to run the Excel Services application pool.

  • You must be a member of the Farm Administrators group to perform the procedures in this article.

Video demonstration

This video shows the steps involved in creating an Excel Services service application, as described in this article.

Video: Configure Excel Services in SharePoint Server 2013

Video (play button) icon

Configure the application pool account

For better security, we recommend that you use a separate domain account to run the Excel Services application pool. Have your domain administrator create a domain account to use in running the Excel Services application pool. No specific domain privileges are required for this account.

Before you can use an account to run an application pool, you must register it as a managed account in SharePoint Server. Use the following procedure to register the account.

To register a managed account

  1. On the SharePoint Central Administration website home page, in the left navigation, click Security.

  2. On the Security page, under General Security, click Configure managed accounts.

  3. On the Managed Accounts page, click Register Managed Account.

  4. Type the user name and password of the domain account that you are registering.

  5. Optionally, select the Enable automatic password change check box if you want SharePoint Server to manage password changes for this account.

  6. Click OK.

Grant content database access to the managed account

You must also grant access to the SharePoint content database for the account that you will use to run the Excel Services application pool. Use the following procedure for each web application that will be associated with Excel Services.

To grant content database access to the managed account

  1. On a SharePoint Server application server, click Start, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell, and then click Run as Administrator.

  2. At the Windows PowerShell Command Prompt, type the following (press Enter after each line):

    Copy code
    $w = Get-SPWebApplication -identity http://<WebApplication>
$w.GrantAccessToProcessIdentity("<Domain>\<Username>")
Important:

If in the future you add additional content databases, you must rerun these cmdlets to ensure that Excel Services has access to the new databases.

Once you have granted content database access to the application pool account, the next step is to start the Excel Calculation Services service.

Start the Excel Calculation Services service

In order to use Excel Services, you must start the Excel Calculation Services service on at least one application server in the farm. Use the following procedure to start the service.

To start the Excel Calculation Services service

  1. On the Central Administration home page, in the System Settings section, click Manage services on server.

  2. To select the server where you want to start the service, above the Service list, click the Server drop-down list, and then click Change Server and choose the appropriate server.

  3. In the Service list, click Start next to Excel Calculation Services.

After the Excel Calculation Services service has been started, the next step is to create an Excel Services service application.

Create an Excel Services service application

Use the following procedure to create an Excel Services service application.

To create an Excel Services service application

  1. On the Central Administration home page, under Application Management, click Manage service applications.

  2. On the Manage Service Applications page, click New, and then click Excel Services Application.

  3. In the Name section, type a name for the service application in the text box.

  4. Select the Create new application pool option and type a name for the application pool in the text box.

  5. Select the Configurable option, and from the drop-down list, select the account that you created to run the application pool.

  6. Click OK.

Additional steps

Once you have created the service application, you are ready to start using Excel Services. See the following articles for additional configuration steps.

  • Manage Excel Services global settings (SharePoint Server 2013)

  • Manage Excel Services trusted file locations (SharePoint Server 2013)

  • Manage Excel Services trusted data providers (SharePoint Server 2013)

  • Manage Excel Services trusted data connection libraries (SharePoint Server 2013)

  • Manage Excel Services user defined function assemblies (SharePoint Server 2013)

  • Manage Excel Services data model settings (SharePoint Server 2013)


Manage Excel Services global settings (SharePoint Server 2013)
See also

Summary: Edit Excel Services settings for security, load balancing, memory, cache, and external data by using the SharePoint Central Administration website.

Applies to: SharePoint Server 2013

Important:

The steps in this article apply to SharePoint Server 2013 Enterprise.

Excel Services global settings include settings for the following:

  • Security

  • Load balancing

  • Session management

  • Memory utilization

  • Workbook cache

  • External data

This article describes how to locate and update the Excel Services global settings. For specific information about each setting and under what circumstances you might want to change it, see Plan Excel Services Global Settings in SharePoint Server 2013.

In this article:

  • Before you begin

  • Edit Excel Services global settings

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • To perform these procedures, you must be member of the Farm Administrators group or an Administrator for the Excel Services service application that you are configuring.

Edit Excel Services global settings

Use the following procedure to update one or more of the Excel Services global settings.

To edit Excel Services global settings

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to manage.

  3. On the Manage Excel Services page, click Global Settings.

  4. On the Excel Services Application Settings page, update the settings that you want to change, and then click OK.

See also

Configure Excel Services in SharePoint Server 2013


Manage Excel Services trusted file locations (SharePoint Server 2013)
See also

Summary: Add, configure, or delete an Excel Services trusted file location by using the SharePoint Central Administration website.

Applies to: SharePoint Server 2013

A trusted file location is a SharePoint Server location, network file share, or Web folder address that the administrator has explicitly enabled workbooks to be loaded from. Excel Services only loads workbooks from trusted file locations.

Use the procedures in this article to configure trusted file locations for Excel Services.

Important:

The steps in this article apply to SharePoint Server 2013 Enterprise.

In this article:

  • Before you begin

  • Add a trusted file location

  • Configure a trusted file location

  • Delete a trusted file location

Before you begin

Before you configure Excel Services trusted file locations, we recommend that you review Plan Trusted File Locations in SharePoint Server 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • To perform these procedures, you must be member of the Farm Administrators group or an Administrator for the Excel Services service application that you are configuring.

Add a trusted file location

Use the following procedure to add a trusted file location in Excel Services.

To add a trusted file location

  1. On the SharePoint Central Administration website home page, in the Application Management section, click Manage service applications.

  2. On the Manage service applications page, click the Excel Services service application that you want to configure.

  3. On the Manage Excel Services Application page, click Trusted File Locations.

  4. On the Excel Services Application Trusted File Locations page, click Add Trusted File Location.

  5. Configure the settings for the trusted file location as described in Configure a trusted file location, below.

Configure a trusted file location

Use the following procedure to configure a trusted file location.

To configure a trusted file location

  1. On the SharePoint Central Administration websitehome page, in the Application Management section, click Manage service applications.

  2. On the Manage service applications page, click the Excel Services service application that you want to configure.

  3. On the Manage Excel Services Application page, click Trusted File Locations.

  4. In the Address column, click the trusted file location that you want to configure.

  5. Configure the settings as described in the following table:

    Option Description

    Address

    The location of the Excel documents that you want Excel Services to trust.

    Location Type

    If the document library is stored in the SharePoint Foundation 2013 content database, select Microsoft SharePoint Foundation. If the document library is stored in a network file share, select UNC. If the document library is stored in a Web folder address, select HTTP.

    Trust Children

    Select Children trusted if you want to trust all child libraries or directories.

    Description

    Text description of the file location you specified.

    Session Timeout

    Value in seconds that an Excel Calculation Services session can stay open and inactive before it is shut down, as measured from the end of each open request. The default is 450 seconds.

    Short Session Timeout

    Value in seconds that an Excel Services session stays open and inactive, before any user interaction, before it is shut down. This is measured from the end of the original open request. The default is 450 seconds.

    New Workbook Session Timeout

    Value in seconds that an Excel Calculation Services session for a new workbook stays open and inactive before it is shut down, as measured from the end of each request. The default value is 1,800 seconds (30 minutes).

    Maximum Request Duration

    Value in seconds for the maximum duration of a single request in a session. The default is 300 seconds.

    Maximum Chart Render Duration

    Value in seconds for the maximum time that is spent rendering any single chart. The default is 3 seconds.

    Maximum Workbook Size

    Value in megabytes (MB) for the maximum size of workbooks that Excel Calculation Services can open. The default size is 10 megabytes.

    Maximum Chart or Image Size

    Value in megabytes (MB) for the maximum size of charts or images that Excel Calculation Services can open. The default size is 1 megabyte.

    Volatile Function Cache Lifetime

    Value in seconds that a computed value for a volatile function is cached for automatic recalculations. The default is 300 seconds.

    Workbook Calculation Mode

    Select File to perform calculations as specified in the file.

    Select Manual if you want recalculation to occur only when a Calculate request is received.

    Select Automatic if you want any change to a value to cause the recalculation of all other values that depend on that value. Also, volatile functions are called if their time-out has expired.

    Select Automatic except data tables if you want any change to a value to cause the recalculations of all other values dependent on that value (the values cannot be in a data table.) Also, volatile functions are called if their time-out has expired.

    Allow External Data

    Select None to disable all external data connections for the trusted file location.

    Select Trusted data connection libraries only to only enable using connections to data sources that are stored in a trusted data connection library. The server will ignore settings embedded in the worksheet.

    Select Trusted data connection libraries and embedded to enable connections that are embedded in the workbook file or connections that are stored in a trusted data connection library. If you do not have to have tight control or restrictions on the data connections that are used by workbooks on the server, consider selecting this option.

    Warn on Refresh

    Select the Refresh warning enabled check box to display a warning before refreshing external data for files in this location. When you select this option, you make sure that external data is not automatically refreshed without user interaction.

    Display Granular External Data Errors

    Select the Granular External Data Errors check box to display specific error messages when external data failures occur for files in this location. Displaying specific error messages can help troubleshoot data connectivity issues if they occur.

    Stop When Refresh on Open Fails

    Select the Stopping open enabled check box to prevent users from viewing files that are configured to refresh on open, if the refresh fails. This prevents users from seeing cached information in the workbook. This option is only effective if the user does not have Open Item permissions on the workbook. (A user with Open Item permissions on the workbook can open the workbook in Excel and thus has access to any cached information.)

    External Cache Lifetime (Automatic Refresh)

    In the Automatic refresh (periodic / on-open) box, type a value in seconds for the maximum time that the system can use external data query results for automatically refreshed external query results. The default is 300 seconds.

    External Cache Lifetime (Manual Refresh)

    In the Manual refresh box, type a value in seconds for the maximum time that the system can use external data query results for manually refreshed external query results. To prevent data refresh after the first query, type -1. The default is 300 seconds.

    Maximum Concurrent Queries Per Session

    Type a value for the maximum number of queries that can run at the same time during a single session. The default is 5 queries.

    Allow External Data Using REST

    Select the Data refresh from REST enabled check box to all requests from the REST API to refresh external data connections. Note that this setting has no effect if Allow External Data is set to None. Note too, that this setting has no effect if Warn on Refresh is enabled.

    Allow User-Defined Functions

    Select User-defined functions allowed if you want to allow user-defined functions in Excel Calculation Services for workbooks from this location.

  6. Click OK.

Delete a trusted file location

Use the following procedure to delete a trusted file location.

Note:

Deleting a trusted file location does not affect the file location itself or its contents. It only removes the location from the Excel Services trusted location list, and Excel Services no longer loads workbooks from that location.

To delete a trusted file location

  1. On the SharePoint Central Administration website home page, in the Application Management section, click Manage service applications.

  2. On the Manage service applications page, click the Excel Services service application that you want to configure.

  3. On the Manage Excel Services Application page, click Trusted File Locations.

  4. On the Excel Services Application Trusted File Locations page, point to the trusted file location that you want to delete, click the arrow that appears, and then click Delete.

  5. Click OK in the message box that asks whether you want to continue with the deletion.

See also

Configure Excel Services in SharePoint Server 2013


Manage Excel Services trusted data providers (SharePoint Server 2013)
See also

Summary: Add, configure, or delete Excel Services trusted data providers by using the SharePoint Central Administration website.

Applies to: SharePoint Server 2013

Important:

The steps in this article apply to SharePoint Server 2013 Enterprise.

Trusted data providers are data providers from which Excel Services accesses data. A data provider is a database type combined with a protocol for accessing data (for example, SQL Server combined with ODBC).

  • Excel Services does not access data that does not come from a trusted data provider.

  • Excel Services contains entries for common data providers. Add additional data providers as needed.

In this article:

  • Before you begin

  • Add a trusted data provider

  • Configure a trusted data provider

  • Delete a trusted data provider

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • To perform these procedures, you must be member of the Farm Administrators group or an Administrator for the Excel Services service application that you are configuring.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Add a trusted data provider

Use the following procedure to add a trusted data provider in Excel Services.

To add a trusted data provider

  1. In the Central Administration page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to configure.

  3. On the Manage Excel Services page, click Trusted Data Providers.

  4. On the Excel Services Application Trusted Data Providers page, click Add Trusted Data Provider.

  5. On the Excel Services Application Add Trusted Data Provider page, in the Provider section, type the provider ID of the trusted data provider in the Provider ID box (for example, type SQL Server). Look in a valid connection string to find the provider ID.

  6. Under Provider Type, select one of the following:

    • OLE DB Select this option to access data by using Object Linking and Embedding (OLE).

    • ODBC Select this option to access data by using Open Database Connectivity (ODBC).

    • ODBC DSN Select this option to access data by using Open Database Connectivity with Data Source Name (ODBC DSN).

  7. In the Description box, you can also type a description of the purpose for this trusted data provider.

  8. Click OK.

Configure a trusted data provider

Use the following procedure to configure a trusted data provider in Excel Services.

To configure a trusted data provider

  1. In the Central Administration page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to configure.

  3. On the Manage Excel Services page, click Trusted Data Providers.

  4. On the Excel Services Application Trusted Data Providers page, click Edit on the menu of the data provider that you want to configure.

Delete a trusted data provider

Use the following procedure to delete a trusted data provider from Excel Services.

To delete a trusted data provider

  1. In the Central Administration page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to configure.

  3. On the Manage Excel Services page, click Trusted Data Providers.

  4. On the Excel Services Application Trusted Data Providers page, click Delete on the menu of the data provider that you want to delete.

  5. Click OK in the message box that asks whether you want to continue with the deletion.

See also

Configure Excel Services in SharePoint Server 2013


Manage Excel Services trusted data connection libraries (SharePoint Server 2013)
See also

Summary: Add, configure, or delete trusted data connection libraries in Excel Services by using the SharePoint Central Administration website.

Applies to: SharePoint Server 2013

Important:

The steps in this article apply to SharePoint Server 2013 Enterprise.

Trusted data connection libraries are SharePoint Server 2013 data connection libraries that Excel Services has been configured to trust. Excel Services does not use data connection files that are not stored in a trusted data connection library.

In this article:

  • Before you begin

  • Add a trusted data connection library

  • Configure a trusted data connection library

  • Delete a trusted data connection library

Before you begin

Before you configure Excel Services trusted data connection libraries, we recommend that you review Plan Trusted Data Connection Libraries in SharePoint Server 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • To perform these procedures, you must be member of the Farm Administrators group or an Administrator for the Excel Services service application that you are configuring.

Add a trusted data connection library

Use the following procedure to add a trusted data connection library.

To add a trusted data connection library

  1. In the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to configure.

  3. On the Manage Excel Services page, click Trusted Data Connection Libraries.

  4. On the Excel Services Application Trusted Data Connection Libraries page, click Add Trusted Data Connection Library.

  5. On the Excel Services Application Add Trusted Data Connection Library page, in the Location section, type the address of the trusted data connection library in the Address box.

  6. In the Description box, you can also type a description of the purpose for this trusted data connection library.

  7. Click OK.

Configure a trusted data connection library

Use the following procedure to configure an existing trusted data connection library.

To configure a trusted data connection library

  1. In the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to configure.

  3. On the Manage Excel Services page, click Trusted Data Connection Libraries.

  4. On the Excel Services Application Trusted Data Connection Libraries page, either click the data connection library that you want to configure or point to the data connection library, click the arrow that appears, and then click Edit.

Delete a trusted data connection library

Use the following procedure to delete a trusted data connection library.

Note:

Deleting a trusted data connection library does not affect the library itself or its contents. It only removes the library as a trusted data connection library in Excel Services.

To delete a trusted data connection library

  1. In the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to configure.

  3. On the Manage Excel Services page, click Trusted Data Connection Libraries.

  4. On the Excel Services Application Trusted Data Connection Libraries page, point to the data connection library that you want to delete, click the arrow that appears, and then click Delete.

  5. Click OK in the message box that asks whether you want to continue with the deletion.

See also

Configure Excel Services in SharePoint Server 2013


Manage Excel Services user defined function assemblies (SharePoint Server 2013)
See also

Summary: Add, edit or delete Excel Services user-defined function assemblies by using the SharePoint Central Administration website.

Applies to: SharePoint Server 2013

Important:

The steps in this article apply to SharePoint Server 2013 Enterprise.

If your deployment scenarios include workbooks that contain user-defined functions to extend the capabilities of Excel Calculation Services, you must register the user-defined function assemblies on the Excel Services user-defined function assembly list.

In this article:

  • Before you begin

  • Register a user-defined function assembly

  • Edit user-defined function assembly details

  • Unregister a user-defined function assembly

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • To use user-defined functions, you must enable user-defined functions on trusted file locations that contain workbooks that require access to user-defined functions. For information about configuring trusted file locations, see Configure a trusted file location.

  • You must be a member of the Farm Administrators group or an Excel Services service application administrator to perform the procedures in this article.

Register a user-defined function assembly

Use the following procedure to register a user-defined function assembly for use with Excel Services.

To register a user-defined function assembly

  1. On the SharePoint Central Administration website home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to manage.

  3. On the Manage Excel Services page, click User Defined Function Assemblies.

  4. On the Excel Services User Defined Functions page, click Add User-Defined Function Assembly.

  5. On the Add User-Defined Function Assembly page, in the Assembly section, type the assembly name or the full path of an assembly that contains the user-defined functions, which you want to call in the Assembly box.

  6. Under Assembly Location, select one of the following:

    • Global assembly cache (a global place where signed assemblies can be deployed and run with full trust by default)

    • File path (a local or network file location)

  7. In the Enable Assembly section, select the Assembly enabled check box to enable Excel Calculation Services to call the assembly. You can clear the check box to disable the assembly without removing the function assembly from the list.

  8. In the Description box, you may choose to type a description of the purpose for the function assembly.

  9. Click OK.

Edit user-defined function assembly details

Use the following procedure to edit the user-defined function assembly details for a registered user-defined function assembly. You can also use this procedure to disable the assembly.

To edit user-defined function assembly details

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to manage.

  3. On the Manage Excel Services page, click User Defined Function Assemblies.

  4. On the Excel Services User Defined Functions page, point to the user-defined function assembly that you want to edit, click the arrow that appears, and then click Edit.

  5. Update the assembly details as needed, and then click OK.

Unregister a user-defined function assembly

Use the following procedure to remove a user-defined function assembly from the user-defined function assembly list.

To unregister a user-defined function assembly

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to manage.

  3. On the Manage Excel Services page, click User Defined Function Assemblies.

  4. On the Excel Services User Defined Functions page, point to the user-defined function assembly that you want to delete, click the arrow that appears, and then click Delete.

  5. Click OK in the message box that asks whether you want to proceed with the deletion.

See also

Configure Excel Services in SharePoint Server 2013


Manage Excel Services data model settings (SharePoint Server 2013)
See also

Summary: Configure instances of SQL Server 2012 Analysis Services for Data Model functionality in Excel Services.

Applies to: SharePoint Server 2013 Enterprise

Important:

The steps in this article apply to SharePoint Server 2013 Enterprise.

Excel Services can use instances of SQL Server 2012 SP1 Analysis Services (SSAS) perform advanced data analysis calculations. This article describes how to register, edit, and unregister instances of SQL Server 2012 Analysis Services for use by Excel Services in performing these calculations.

In this article:

  • Before you begin

  • Register an Analysis Services server

  • Edit Analysis Services server details

  • Unregister an Analysis Services server

Before you begin

Before you configure an instance of SQL Server 2012 SP1 Analysis Services (SSAS) to work with Excel Services, we recommend that you read Plan Excel Services Data Model settings in SharePoint Server 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • To perform these procedures, you must be member of the Farm Administrators group or an Administrator for the Excel Services service application that you are configuring.

  • The instance of SQL Server 2012 Analysis Services that you plan to use must be installed in SQL Server PowerPivot for SharePoint mode.

Register an Analysis Services server

Use the following procedure to register an instance of SQL Server 2012 SP1 Analysis Services (SSAS) with Excel Services.

To register an Analysis Services server

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to manage.

  3. On the Manage Excel Services page, click Data Model.

  4. Click Add Server.

  5. In the Server Name box, type the name of the instance of SQL Server 2012 SP1 Analysis Services (SSAS) that you want to add.

  6. Optionally, in the Description box, type a description for the server.

  7. Click OK.

Edit Analysis Services server details

Use the following procedure to edit the server name or description for an instance of SQL Server 2012 SP1 Analysis Services (SSAS) that has been registered with Excel Services.

To edit Analysis Services server details

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to manage.

  3. On the Manage Excel Services page, click Data Model.

  4. Hover over the server that you want to edit, click the arrow that appears, and then click Edit.

  5. Update the Server Name and Description as needed, and then click OK.

Unregister an Analysis Services server

Use the following procedure to remove an instance of SQL Server 2012 SP1 Analysis Services (SSAS) from Excel Services.

To unregister an Analysis Services server

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application that you want to manage.

  3. On the Manage Excel Services page, click Data Model.

  4. Hover over the server that you want to edit, click the arrow that appears, and then click Delete.

  5. Click OK on the delete confirmation dialog box.

See also

Configure Excel Services in SharePoint Server 2013


PerformancePoint Services administration (SharePoint Server 2013)
See also

Summary: A list of links to articles about PerformancePoint Services administration.

Applies to: SharePoint Server 2013 Enterprise

TechNet articles about operating and maintaining PerformancePoint Services

The following articles about operating and maintaining PerformancePoint Services in SharePoint are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Configure the unattended service account for PerformancePoint Services (SharePoint Server 2013) | Learn how to configure the unattended service account for PerformancePoint Services.
 | Delete a PerformancePoint Services service application (SharePoint Server 2013) | Learn how to delete a PerformancePoint Services service application by using either Windows PowerShell or Central Administration.
 | Enable trusted locations for PerformancePoint Services in SharePoint Server 2013 | Learn how to limit PerformancePoint Services features that use trusted locations by allowing only designated sites, lists or document libraries rather than the entire site collection.
 | PerformancePoint Services application settings in SharePoint Server 2013 | Learn how to customize PerformancePoint Servicesapplication settings to meet your business needs.
 | Configure a Business Intelligence Center in SharePoint Server 2013 | Create a Business Intelligence Center in SharePoint Server 2013 with the Business Intelligence Center enterprise template and creating a new site collection.

See also

PerformancePoint Services cmdlets in SharePoint Server 2013

Resource Center: Business Intelligence in SharePoint Server 2013


Configure PerformancePoint Services (SharePoint Server 2013)
See also

Published: September 25, 2012

Summary: Configure PerformancePoint Services in SharePoint Server 2013 before you make it available to users.

Applies to: SharePoint Server 2013

This article describes how to create and configure a PerformancePoint Services service application.

To properly configure PerformancePoint Services, do the following steps in the order listed:

  1. Install ADOMD.NET from the SQL Server 2012 Feature Pack

  2. Configure the PerformancePoint Services application pool account

  3. Start the PerformancePoint service

  4. Create a PerformancePoint Services service application

  5. Configure service application associations

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure the PerformancePoint Services application pool account

The application pool for the PerformancePoint Services service application requires a SharePoint Server 2013 managed account (generally an Active Directory account) to run. This account must have access to the content databases where PerformancePoint data will be stored.

If you run the service application using the same application pool account as the web application where the content databases are located, this required database access is configured automatically. However, we recommend that you use a different account for the PerformancePoint Services application pool, especially in a large or complex farm. This allows for greater control over data and resource access.

If you choose to use the same managed account for PerformancePoint Services as is being used for the web application, you can skip the procedures in this section. If you choose to create a new managed account, you must do the following:

  1. Register a managed account in SharePoint Server 2013. (You will need an Active Directory user account for this step. Have your Active Directory administrator create it.)

  2. Grant access for this account to the content databases that will contain PerformancePoint data. This process includes running a Windows PowerShell script from the SharePoint 2010 Management Shell.

The first step is to register a managed account. Use the following procedure to register the Active Directory account that you want to use for the PerformancePoint Services application pool.

To register a managed account

  1. In the SharePoint Server Central Administration Web site, click Security.

  2. In the General Security section, click Configure managed accounts.

  3. Click Register Managed Account.

  4. In the Service account credentials section, type the user name and password for the Active Directory account that you want to register.

  5. Optionally, if the account password is set to expire after a certain length of time, configure the automatic password change settings to have SharePoint Server 2013 change the password.

  6. Click OK.

Once you have registered the managed account, you must grant that account access to the content databases where PerformancePoint data will be stored. Use the following procedure to grant database access to the account. Follow this procedure for each web application that contains a content database where PerformancePoint Services data will reside.

To grant content database access to an account

  1. On an application server in the farm, click Start, click All Programs, click Microsoft SharePoint 2010 Products, right-click SharePoint 2010 Management Shell, and then click Run as Administrator.

  2. At the Windows PowerShell command prompt, type the following, pressing Enter after each line:

    Copy code
    $w = Get-SPWebApplication -identity <web application>
$w.GrantAccessToProcessIdentity("<service account>")

Once you have finished granting content database access to the managed account, the next step is to start the PerformancePoint service.

Start the PerformancePoint service

To configure PerformancePoint Services, you must first start the PerformancePoint service on the application server where you want to run PerformancePoint Services. You can start the service on multiple application servers for better performance, if you want, but the service must be started on at least one server. Use the following procedure to start the PerformancePoint service.

To start the PerformancePoint Service

  1. In Central Administration, in the System Settings section, click Manage services on server.

  2. Note the server specified in the Server box. If you want to run the PerformancePoint service on a different server, click the current server, and then click Change Server and select the server that you want.

  3. Click Start next to PerformancePoint Service.

Create a PerformancePoint Services service application

Once the service is started, you can create a PerformancePoint Services service application. Use the following procedure to create the service application.

To create a PerformancePoint Services service application

  1. In Central Administration, in the Application Management section, click Manage Service Applications.

  2. Click New, and then click PerformancePoint Service Application.

  3. Type a name for the service application and select the Add this service application's proxy to the farm's default proxy list check box.

  4. Select the Create new application pool option and type a name for the application pool.

  5. Under the Configurable option, select the managed account to run the application pool.

  6. Click Create.

  7. Click OK.

Configure service application associations

For PerformancePoint Services to function, the PerformancePoint Services service application proxy must be associated with the default web application. Use the following procedure to confirm that the association is configured between the web application and the PerformancePoint Services proxy.

To configure service application associations

  1. In Central Administration, click Application Management.

  2. In the Service Applications section, click Configure service application associations.

  3. Under the Application Proxy Group column, click default.

  4. Ensure that the PerformancePoint Services box is selected.

  5. Click OK.

Next steps

Once you have finished configuring PerformancePoint Services, you can make it available to the users. We recommend that you review the following tasks:

  • Configure data access Users of PerformancePoint Services will need access to back-end data sources. This can be configured by using the unattended service account. For more information, see Configure the unattended service account for PerformancePoint Services (SharePoint Server 2013).

  • Configure data connections Users of PerformancePoint Dashboard Designer need data connections in order to access the data sources. For more information, see Create data connections by using PerformancePoint Services (SharePoint Server 2013).

  • Configure user permissions To publish dashboards, users must have specific permissions in SharePoint Server 2013 For more information, see Authorization and permissions in PerformancePoint Services (SharePoint Server 2013).

See also

New-SPPerformancePointServiceApplication


Delete a PerformancePoint Services service application (SharePoint Server 2013)

Published: July 31, 2012

Summary: Learn how to delete a PerformancePoint Services service application by using either Windows PowerShell or the SharePoint Central Administration website.

Applies to: SharePoint Server 2013

A PerformancePoint Services service application can be deleted by using the SharePoint Central Administration Web site or Windows PowerShell 3.0. The following steps show how to delete a PerformancePoint Services service application.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Delete a PerformancePoint Services service application

To delete a PerformancePoint Services service application by using Central Administration

  1. Verify that you are a member of the farm administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website Home page, in the Application Management section, click Manage service applications.

  4. Select the PerformancePoint Services service application that you want to delete. (Do not click the link.)

  5. On the ribbon, click Delete.

  6. If you want to delete the associated database, select the Delete data associated with the Service Applications option. Click OK.

    Note:

    The option to delete data associated with the services applications is not available when you delete a service application by using Windows PowerShell.

To delete a PerformancePoint Services service application by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command and press ENTER:

    Remove-SPPerformancePointServiceApplication <ServiceAppName>

    Important:

    When you use this cmdlet to remove a PerformancePoint Services service application, the database is not removed from the database server.

For more information, see Remove-SPServiceApplication.


Enable trusted locations for PerformancePoint Services in SharePoint Server 2013

Summary: Learn how to limit PerformancePoint Services features that use trusted locations by allowing only designated sites, lists or document libraries rather than the entire site collection.

Applies to: SharePoint Server 2013

After you enable a feature on a site collection in SharePoint Server 2013, the content types or PerformancePoint Services objects are made available for others to use on any site within that site collection. An administrator may want to limit PerformancePoint Services features that use trusted locations by allowing one or more sites, lists, or document libraries rather than an entire site collection. In this way the administrator can limit use of PerformancePoint Services to specific locations in the farm to prevent unauthorized access to data sources. See To add a trusted data source location.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Establish trusted locations for data sources and dashboard content

You can specify locations in SharePoint Server where dashboard content and data sources are secured. The default is to trust all locations, but administrators can specify other trusted locations.

  • PerformancePoint Content List: A PerformancePoint Content List stores the elements that are used to construct a dashboard. A PerformancePoint Services dashboard is a related group of interactive scorecards, filters, and report views organized into a set of Web pages.

  • PerformancePoint Data Source Library: A PerformancePoint Data Source Library contains data-source definitions that identify a source of business data. It may include cubes or perspectives based on online analytical processing (OLAP) cubes, relational databases, CSV files, and Microsoft Excel Services worksheets.

  • Trusted Data Sources and Trusted Content Locations: When you navigate to either Trusted Data Sources or Trusted Content Locations pages from the Manage PerformancePoint Services page, there are two option buttons. When the Only specific locations option button is selected, the list of trusted locations is enabled. For data source or content locations, if there are no items in the list, only the toolbar button is enabled. When one or more items are listed, the Edit and Delete buttons are enabled.

    The URL you type is checked for a valid site collection, site, document library, and list. Option buttons are enabled or disabled depending on the type of site. Validation depends on whether your URL is a valid site and/or already exists.

Caution:

The default for a trusted data source and trusted content locations is to trust all.

To add a trusted data source location

  1. On the SharePoint Central Administration website, select Manage Service Applications.

  2. On the Manage Service Applications page, select the PerformancePoint Services service application you want to manage.

  3. On the Service Application tab, click Manage. The Manage PerformancePoint Services page opens.

  4. Click Trusted Data Source Locations. The Trusted Data Source Locations page opens.

  5. Select one of the following options and click Apply.

    1. All SharePoint locations: Specifies that data sources are trusted from all SharePoint Server locations.

    2. Only specific locations: Specifies that data sources are only trusted when found in the locations listed.

  6. If you select Only specific locations and click Apply, Add Trusted Data Source Location appears; otherwise All SharePoint locations is the current setting.

  7. Click Add Trusted Data Source Location to specify the URL and location for this trusted location.

  8. Enter the full Web address (it must be a site collection, site, or document library for this trusted location).

  9. Select the location type, type a description (optional), and then click OK. The location type appears under Location.

To add a trusted content location

  1. In Central Administration select Manage Service Applications.

  2. In the Manage Service Applications page, select the PerformancePoint Services service application you want to manage.

  3. On the Service Application tab, click Manage. The Manage PerformancePoint Services page opens.

  4. Click Trusted Content Locations. The Trusted Content Locations page opens.

  5. Select one of the following options, and then click Apply.

    1. All SharePoint locations: Specifies that content is trusted from all SharePoint Server locations.

    2. Only specific locations: Specifies that content is only trusted when found in the locations listed.

  6. If you select Only specific locations and click Apply, Add Trusted Content Location appears; otherwise All SharePoint locations is the current setting.

  7. Click Add Trusted Content Location to specify the URL and location for this trusted location.

  8. Enter the full Web address (it must be a site collection, site, or list address for this trusted location.)

  9. Select the location type, type a description (optional), and then click OK. The location type appears under Location.


PerformancePoint Services application settings in SharePoint Server 2013

Summary: Learn how to customize PerformancePoint Services application settings to meet your business needs.

Applies to: SharePoint Server 2013

PerformancePoint Services has settings such as cache durations, filter behavior, and query time-out that affect performance, security, and connections to external data. These settings affect anyone who uses the same service application. The settings can be managed by using the SharePoint Central Administration website. You can make additional changes to settings by using Windows PowerShell 3.0 to provision PerformancePoint Services, manage and configure a service application, configure and manage trusted locations, configure and manage proxies for the service application, and configure the global settings of the service. For more information, see PerformancePoint Services cmdlets in SharePoint Server 2013.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

PerformancePoint Services application settings

Setting Description

Secure Store and Unattended Service Account

A single shared user account is used to access all data sources. This is a low-privileged domain account stored in the Secure Store Service. An application ID is automatically mapped in the Secure Store Service that specifies the default secure store target application, PerformancePoint Services, and it looks up credential mapping when it connects to external data sources.

Important:

When you establish an unattended service account, first determine whether this account should have access to the data sources that will be retrieved in Dashboard Designer.

Comments

Users who have appropriate permissions can annotate scorecard cells in Dashboard Designer and on a deployed SharePoint site.

Note:

If a Dashboard Designer author attempts to add cell comments that are disabled, the author will receive a message that states, "An unexpected system error has occurred. Additional details have been logged for your administrator." If you want the author to be able to insert comments in a cell, select the check box, Enable comments.

You can also remove comments by clicking Delete Comments by Date. This command opens a dialog box. Select the date by which you want comments removed from the PerformancePoint Services database, and then click Delete.

Analysis Services EffectiveUserName

The Analysis Services EffectiveUserName capability is an alternative to Windows delegation for allowing individual users to securely access Analysis Services data. When this setting is enable, all connections to Analysis Services data for individual users will be made using the EffectiveUserName connection string property instead of Windows delegation.

Cache

Temporarily storing (or "caching") frequently-accessed items decreases load times for future requests. Specify the duration for items to remain in the cache.

Data Sources

Set the duration of no response before a data source query is canceled.

Filters

Specify how long to remember user-selected filter values and how often to clear expired values. Set the maximum number of members to retrieve and insert into a filter of type "tree".

Select Measure Control

Set the maximum number of measures to retrieve and insert into a dashboard Select Measure control.

Show Details

Set the limit for the number of rows returned when a user clicks "Show Details."

Decomposition Tree

Set the maximum number of individual items (per level) returned to the decomposition tree visualization. The minimum value is 0. The maximum is 1,000,000.


Restrict or enable access to a service application (SharePoint 2013)
See also

Published: January 15, 2013

Summary: Learn how to restrict access to a service application by adding and removing services accounts and reestablish local farm-wide access to a service application in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In SharePoint 2013, you can restrict the access to a service application so that the service application is available to only specified web applications.

By default, all service applications on the local farm are available to all web applications on the local farm. You might want to restrict access to a service application if you host multiple customers on the same farm, and you want to isolate one customer's service applications from another customer's web application.

If you restrict access to a service application and you later decide that you want to make it available to the whole farm, you can remove the restriction.

In this article:

  • Restrict access to a service application

  • Restore farm-wide access to a service application

  • Windows PowerShell code examples

Before you begin

Before you begin this task, review the following information about prerequisites:

  • Plan for administrative and service accounts in SharePoint 2013

  • Technical diagrams for SharePoint 2013

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Restrict access to a service application

To restrict access to a service application, remove service accounts from the service application. Conversely, to enable access to a service application, add service accounts to the service application. You can perform these tasks by using Central Administration or by using Windows PowerShell 3.0.

To restrict access to a service application, you must complete the following tasks:

  1. Add a specific service account to the service application.

  2. Remove the local farm ID from the service application.

Note:

The procedures in this article describe how to restrict or restore access to a service application. However, you can follow the steps in the procedures to add any service account to any service application or to remove any service account from any service application.

For example, the To restore local farm-wide access to a service application by using Central Administration procedure explicitly describes how to add the local farm ID to a service application. You can use the same procedure to add any other service account to a service application. To do this, you provide the appropriate service account instead of the local farm ID.

Because the local farm ID provides local farm-wide access to the service application by default, it is redundant to also grant explicit local web application permissions to a service application unless you also remove the local farm ID.

To grant permissions to a service application, you must retrieve and supply the appropriate service account. For a web application, this account is also known as an application pool identity account.

After you grant permissions to a service account and remove the local farm ID from a service application, only web applications that are managed by the assigned service account can access the service application. You can assign multiple web applications (that have different managing service accounts) to the same service application by repeating these procedures and adding the various web application service accounts to the service application.

Warning:

If you remove the local farm ID from a service application and do not assign any other service account to that service application, the service application becomes unavailable to all web applications.

In this section:

  • Restrict access to a service application by using Central Administration

  • Restrict access to a service application by using Windows PowerShell

Restrict access to a service application by using Central Administration

To restrict access to a service application by using the SharePoint Central Administration website, follow these steps:

  1. Retrieve the web application service account.

  2. Add the web application service account to the service application.

  3. Remove the local farm ID from the service application.

Procedures in this section:

  • To retrieve a web application service account by using Central Administration

  • To grant and remove permissions for service accounts to access a service application by using Central Administration

To retrieve a web application service account by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Central Administration Home page, in the Security section, click Configure service accounts.

  3. On the Service Accounts page, select the web application name from the first drop-down list.

    The service account is shown in the Select an account for this component list. Record the service account name because you'll use it in the next procedure.

  4. Click Cancel to exit the Service Accounts page without making any changes.

To grant and remove permissions for service accounts to access a service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. On the Central Administration Home page, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the row that contains the service application for which you want to assign permissions.

    The ribbon becomes available.

  4. In the Sharing group of the ribbon, click Permissions.

  5. In the Connection Permissions dialog box, type the service account name that you retrieved in the previous procedure, and then click Add.

  6. Ensure that the newly-added service account name is selected in the middle pane, and then click the appropriate check box in the bottom pane to supply the required permission level.

  7. In the middle pane, click Local Farm, and then click Remove.

  8. Verify that the Connection Permissions page now lists only the service account that you want to access the service application, and that the service account has the required permissions on the service application. Click OK to change the permissions, or click Cancel to end the task without making changes.

You can grant and remove permissions for any service account by using this procedure.

Note:

To restore the local farm ID to the service application by using Central Administration requires an additional step that does not apply to other service accounts. For information about how to do this, see Restore farm-wide access to a service application later in this article.

Restrict access to a service application by using Windows PowerShell

All procedures in this section assume that you have the appropriate permissions and have opened the Windows PowerShell 3.0 Command Prompt window, as described in the To start a Windows PowerShell session procedure later in this section.

The process that restricts access to a service application by using Windows PowerShell is more complex than performing the same task by using Central Administration. In Windows PowerShell, you'll use some procedures to collect and store information for input into later procedures.

After you have started Windows PowerShell, the remaining steps to restrict access to a service application are as follows:

  1. Retrieve the local farm ID.

  2. Retrieve the web application service account.

  3. Create a new claims principal that contains the web application service account.

  4. Retrieve the security object of the service application.

  5. Add the web application service account to the security object of the service application.

  6. Remove the local farm ID from the security object of the service application.

  7. Assign the updated security object to the service application.

  8. Display and review updated permissions

In this section:

  • To start a Windows PowerShell session

  • To retrieve the local farm ID by using Windows PowerShell

  • To retrieve a web application service account and create a new claims principal by using Windows PowerShell

  • To retrieve the security object of the service application

  • To update the service application security object by using the preferred permissions

To start a Windows PowerShell session

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is set to off the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

To retrieve a web application service account and create a new claims principal by using Windows PowerShell

  1. At the Windows PowerShell command prompt, type the following command to retrieve the service account (that is, the application pool identity account) of a web application:

    Copy code
    $webapp = Get-SPWebApplication <http://WebApplication>
$webApp.ApplicationPool.UserName

    Where:

    <http://WebApplication> is the web application URL.

    The web application service account name displays at the command prompt.

  2. To create a new claims principal, type the following command:

    Copy code
    $principal = New-SPClaimsPrincipal <ServiceAccount> -IdentityType WindowsSamAccountName

    Where:

    <ServiceAccount> is the user name (in the form of jane@contoso.com or contoso\jane) that was retrieved by running the previous command. The $principal variable will contain the new claims principal.

To retrieve the security object of the service application

  1. To retrieve the security object of the service application, type the following commands. The $security variable will store the service application security object.

    Copy code
    $spapp = Get-SPServiceApplication -Name "<ServiceApplicationDisplayName>"
$spguid = $spapp.id
$security = Get-SPServiceApplicationSecurity $spguid

    Where:

    <ServiceApplicationDisplayName>is the display name of the service application.

    Important:

    You must enclose the display name in quotation marks, and it must exactly match the service application display name. This includes capitalization. If you have more than one service application that has the same display name (we do not recommend this), you can run the Get-SPServiceApplication cmdlet without arguments to view all service applications. You can then identify the service application directly by its GUID. For example:

    Get-SpServiceApplication

    All service applications are listed.

    $spapp = Get-SpserviceApplication -Identity <GUID>

    $spguid = $spapp.id

    Where <GUID> is the GUID for the service application for which you want to update permissions.

To update the service application security object by using the preferred permissions

  1. The first step to update the service application security object is to add the new claims principal $principal to the service application security object $security. To do this, type the following command:

    Copy code
    Grant-SPObjectSecurity $security $principal -Rights "<Rights>"

    Where:

    <Rights> is the permissions that you want to grant. Typically, this will be Full Control. The available permissions can vary between service applications.

    Tip:

    If you do not want to grant Full Control permissions, and you do not know what permissions can be granted to the service application, you can run the following commands to return the available permissions strings:

    $rightslist = Get-SPServiceApplicationSecurity $spapp

    $rightslist.NamedAccessRights

  2. To remove the local farm ID (that is stored in the $farmID variable) from the service application security object $security, type the following command:

    Copy code
    Revoke-SPObjectSecurity $security $farmID

  3. To assign the updated $security security object to the service application and confirm that the security object for the service application is appropriately updated, type the following commands:

    Copy code
    Set-SPServiceApplicationSecurity $spapp -ObjectSecurity $security (Get-SPServiceApplicationSecurity $spapp).AccessRules

You can add or remove any service account to a service application by using these procedures.

Restore farm-wide access to a service application

You can restore farm-wide access to a service application by adding the local farm ID to the service application. You can do this by using Central Administration or by using Windows PowerShell commands. However, you must use Windows PowerShell 3.0 to obtain the local farm ID.

In this section:

  • To retrieve the local farm ID by using Windows PowerShell

  • To restore local farm-wide access to a service application by using Central Administration

  • To restore local farm-wide access to a service application by using Windows PowerShell

To retrieve the local farm ID by using Windows PowerShell

  1. This procedure starts after step 4 of the To start a Windows PowerShell session procedure.

  2. The following command retrieves the local farm ID, stores it in the $farmID variable, and displays the ID at the command prompt:

    Copy code
    $farmID = Get-SPFarm | select id

    If you want to restore farm-wide access by using Central Administration, copy this value into the clipboard for use in the following procedure.

    If you want to restore farm-wide access to the service application by using Windows PowerShell, type the following additional commands at the Windows PowerShell command prompt. You'll use the retrieved information in the following procedure.

    Copy code
    $claimProvider = (Get-SPClaimProvider System).ClaimProvider
$principal = New-SPClaimsPrincipal -ClaimType "http://schemas.microsoft.com/sharepoint/2009/08/claims/farmid" -ClaimProvider $claimProvider -ClaimValue $farmid

To restore local farm-wide access to a service application by using Central Administration

  1. Perform steps 1 through 3 of the procedure To grant and remove permissions for service accounts to access a service application by using Central Administration.

  2. In the Connection Permissions dialog box, copy the local farm ID that you retrieved in the previous procedure, and then click Add.

  3. Ensure that the local farm ID is selected in the middle pane. Click the Full Control check box in the bottom pane.

  4. Click OK to restore farm-wide access to the service application, or click Cancel to end the task without making changes.

To restore local farm-wide access to a service application by using Windows PowerShell

  1. This procedure starts after step 2 of the procedure To retrieve the local farm ID by using Windows PowerShell.

  2. To restore the retrieved local farm ID to the service application security object $security, type the following commands:

    Copy code
    $spapp = Get-SPServiceApplication -Name "<ServiceApplicationDisplayName>"
$spguid = $spapp.id
$security = Get-SPServiceApplicationSecurity $spguid
Grant-SPObjectSecurity -Identity $security -Principal $farmID -Rights "Full Control"
Set-SPServiceApplicationSecurity $spguid -ObjectSecurity $security

    Where:

    <ServiceApplicationDisplayName>is the display name of the service application.

    Important:

    You must enclose the display name in quotation marks, and it must exactly match the service application display name. This includes capitalization. If you have more than one service application that has the same display name (we do not recommend this), you can run the Get-SPServiceApplication cmdlet without arguments to view all service applications. You can then identify the service application directly by its GUID.

Windows PowerShell code examples

In the following example, the administrator wants to restrict access to the "Contoso BDC" service application to the http://contoso/hawaii web application, which is managed by the service account "contoso\jane." By adding "contoso\jane" and removing the local farm service account from the service application, "Contoso BDC" is restricted to only those web applications that are managed by the service account "contoso\jane" - in this case, http://contoso/hawaii.

Copy code
$farmid = Get-SPFarm | select id
$claimProvider = (Get-SPClaimProvider System).ClaimProvider
$farmappId = New-SPClaimsPrincipal -ClaimType "http://schemas.microsoft.com/sharepoint/2009/08/claims/farmid" -ClaimProvider $claimProvider -ClaimValue $farmid
webapp = get-spwebapplication http://contoso
$webapp.applicationpool
$principal = New-SPClaimsPrincipal contoso/jane -IdentityType WindowsSamAccountName
$spapp = Get-SPServiceApplication -Name "Contoso BDC"
$spguid = $spapp.id
$security = Get-SPServiceApplicationSecurity $spguid
Grant-SPObjectSecurity $security $principal -Rights "Full Control"
Revoke-SPObjectSecurity $security $farmappId
Set-SPServiceApplicationSecurity $spguid -ObjectSecurity $security
(Get-SPServiceApplicationSecurity $spguid).AccessRules

In the following example, access to the service application "Contoso BDC" is restored to all web applications in the local farm.

Copy code
$farmid = Get-SPFarm | select id
$claimProvider = (Get-SPClaimProvider System).ClaimProvider
$farmappId = New-SPClaimsPrincipal -ClaimType "http://schemas.microsoft.com/sharepoint/2009/08/claims/farmid" -ClaimProvider $claimProvider -ClaimValue $farmid
$spapp = Get-SPServiceApplication -Name "Contoso BDC"
$spguid = $spapp.id
$security = Get-SPServiceApplicationSecurity $spguid
Grant-SPObjectSecurity -Identity $security -Principal $farmappId -Rights "Full Control"
Set-SPServiceApplicationSecurity $spguid -ObjectSecurity $security
(Get-SPServiceApplicationSecurity $spguid).AccessRules

See also

Get-SPWebApplication
New-SPClaimsPrincipal
Get-SPServiceApplication
Get-SPServiceApplicationSecurity
Grant-SPObjectSecurity
Revoke-SPObjectSecurity
Set-SPServiceApplicationSecurity
Get-SPFarm
Get-SPClaimProvider

Create a web application in SharePoint 2013
Add or remove service application connections from a web application in SharePoint 2013
Account permissions and security settings in SharePoint 2013


Configure automatic password change in SharePoint 2013
See also

Published: April 2, 2013

Summary: Learn about how to configure the automatic password changes in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Automatic password change enables SharePoint 2013 to automatically generate long, cryptographically-strong passwords on a schedule that you can determine.

In this article:

  • Configure managed accounts

  • Configure automatic password change settings

  • Troubleshooting automatic password change

Configure managed accounts

You have to register managed accounts together with the farm to make the accounts available to multiple services. You can register a managed account by using the Register Managed Account page in Central Administration. There are no options on the Register Managed Account page to create an account in Active Directory Domain Services, or on the local computer. The options can be used to register an existing account on the SharePoint 2013 farm. Perform the steps in the following procedure to use Central Administration to configure managed account settings.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

To configure managed account settings by using Central Administration

  1. Verify that the user account that is performing this procedure is a farm administrator.

  2. On the the SharePoint Central Administration website, select Security.

  3. Under General Security, click Configure managed accounts.

  4. On the Managed Accounts page, click Register Managed Account.

  5. In the Account Registration section of the Register Managed Account page, enter the service account credentials.

  6. In the Automatic Password Change section, select the Enable automatic password change check box to allow SharePoint 2013 to manage the password for the selected account. Next, enter a numeric value that indicates the number of days before password expiration that the automatic password change process will be initiated.

  7. In the Automatic Password Change section, select the Start notifying by e-mail check box, and then enter a numeric value that indicates the number of days before the initiation of the automatic password change process that an e-mail notification will be sent. You can then configure a weekly or monthly e-mail notification schedule.

  8. Click OK.

Configure automatic password change settings

Use the Password Management Settings page of Central Administration to configure farm-level settings for automatic password changes. Farm administrators can configure the notification e-mail address that will be used to send all password change notification e-mails in addition to monitoring and scheduling options. Perform the steps in the following procedure to use Central Administration to configure automatic password change settings.

To configure automatic password change settings by using Central Administration

  1. Verify that the user account that is performing this procedure is a farm administrator.

  2. On the the SharePoint Central Administration website, click Security.

  3. Under General Security, click Configure password change settings.

  4. In the Notification E-Mail Address section of the Password Management Settings page, enter the e-mail address of one person or group to be notified of any imminent password change or expiration events.

  5. If automatic password change is not configured for a managed account, enter a numeric value in the Account Monitoring Process Settings section that indicates the number of days before password expiration that a notification will be sent to the e-mail address configured in the Notification E-Mail Address section.

  6. In the Automatic Password Change Settings section, enter a numeric value that indicates the number of seconds that automatic password change will wait (after notifying services of a pending password change) before starting the change. Enter a numeric value that indicates the number of times a password change will be tried before the process stops.

  7. Click OK.

Troubleshooting automatic password change

Use the following guidance to avoid the most common issues that can occur when you configure automatic password change.

Password mismatch

If the automatic password change process fails because there is a password mismatch between Active Directory Domain Services (AD DS) and SharePoint 2013, the password change process can result in access denial at logon, an account lockout, or AD DS read errors. If any of these issues occur, make sure that your AD DS passwords are configured correctly and that the AD DS account has read access for setup. Use Windows PowerShell to fix any password mismatch issues that might occur, and then resume the password change process.

To correct for a password mismatch by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. From the Windows PowerShell command prompt, type the following ENTER:

    Copy code
    Set-SPManagedAccount [-Identity] <SPManagedAccountPipeBind> -ExistingPassword <SecureString> -UseExistingPassword $true

    For more information, see Set-SPManagedAccount.

Service account provisioning failure

If service account provisioning or re-provisioning fails on one or more servers in the farm, check the status of the Timer Service. If the Timer Service has stopped, restart it. Consider using the following Stsadm command to immediately start Timer Service administration jobs: stsadm -o execadmsvcjobs

If restarting the Timer Service does not resolve the issue, use Windows PowerShell to repair the managed account on each server in the farm that has experienced a provisioning failure.

To resolve a service account provisioning failure

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. From the Windows PowerShell command prompt, type the following:

    Copy code
    Repair-SPManagedAccountDeployment

    For more information, see Repair-SPManagedAccountDeployment.

If the previous procedure does not resolve a service account provisioning failure, it is likely because the farm encryption key cannot be decrypted. If this is the issue, use Windows PowerShell to update the local server pass phrase to match the pass phrase for the farm.

To update the local server pass phrase

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. From the Windows PowerShell command prompt, type the following:

    Copy code
    Set-SPPassPhrase -PassPhrase <SecureString> -ConfirmPassPhrase <SecureString> -LocalServerOnly $true

    For more information, see Set-SPPassPhrase.

Imminent password expiration

If the password is about to expire, but automatic password change has not been configured for this account, use Windows PowerShell to update the account password to a new value that can be chosen by the administrator or automatically generated. After you have updated the account password, make sure that the Timer Service is started and the Administrator Service is enabled on all servers in the farm. Then, the password change can be propagated to all of the servers in the farm.

Note:

When an administrator performs a password change for the servers in the SharePoint search topology, there is an implied query downtime when the services are restarted. The query downtime is typically in the range of 3-5 minutes.

To update the account password

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To update the account password to a new automatically generated value, from the Windows PowerShell command prompt, type the following:

    Copy code
    Set-SPManagedAccount [-Identity] <SPManagedAccountPipeBind> -AutoGeneratePassword $true

    For more information, see Set-SPManagedAccount.

Requirement to change the farm account to a different account

If you must change the farm account to a different account, use the following Stsadm command: stsadm.exe -o updatefarmcredentials -userlogin DOMAIN\username -password password

See also

Resource Center: Identity management for SharePoint 2013 IT pros


Security and permissions (SharePoint 2013)

Published: April 23, 2013

Summary: Learn about how to manage security, permissions, and accounts for SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The following downloadable resources, articles on TechNet provide information about how to prepare for SharePoint 2013 installation and initial configuration.

TechNet articles about how to manage security and permissions for SharePoint 2013

The following articles about how to manage security and permissions for SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Configure automatic password change in SharePoint 2013 | Provides information about how to configure the automatic password changes in SharePoint 2013.
 | Change administration-account passwords in SharePoint 2013 | Provides information about how to keep account passwords synchronized for sites and site content for SharePoint 2013.
 | Configure People Picker in SharePoint 2013 | Learn how to use the Stsadm.exe tool to manage People Picker in SharePoint 2013.
 | Configure custom permissions in SharePoint 2013 | Learn how to configure custom permissions in SharePoint 2013.
 | Change the default account for crawling in SharePoint 2013 | Change the password of the default content access account, which is the default account that the SharePoint 2013 Search service uses for crawling.


Configure custom permissions in SharePoint 2013
See also

Published: April 23, 2013

Summary: Learn how to configure custom permissions in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

For more precise control of user access to sites, site collections, and site content, you can configure custom permission levels for your SharePoint 2013 assets. A custom permission level is a set of permissions that you identify and then assign to a specific group of users or to a specific securable object. SharePoint groups and permission levels are defined at the site collection level and are inherited from the parent object by default.

The steps to manage a permission level are performed by using the Site Settings page which is located in the upper-right hand corner of the the SharePoint Central Administration website and is denoted by the gear icon.

Illustrates the Site Settings page that is located in the upper-right corner of the Central Administration web site.

In this article:

  • Customize an existing permission level

  • Copy an existing permission level

  • Create a permission level

Customize an existing permission level

If you define a custom permission level that is closely aligned to an existing default permission level, you can change the default permission level as described in the following procedure.

To customize an existing permission level

  1. Verify that you have one of the following administrative credentials:

    • You are a member of the Administrators group for the site collection.

    • You are a member of the Owners group for the site.

    • You have the Manage Permissions permission.

  2. On the Site Settings page, under Users and Permissions, click Site permissions.

  3. In the Manage section of the ribbon, click Permission Levels.

  4. In the list of permission levels, click the name of the permission level that you want to customize.

  5. In the list of permissions, select or clear the check boxes to add permissions to or remove permissions from the permission level.

  6. Click Submit.

Copy an existing permission level

If the custom permission level that you want resembles an existing default permission level, and you have to use both the default permission level and your custom permission level, you can copy the default permission level, and then change the copy and save it as a new permission level.

To copy an existing permission level

  1. Verify that you have one of the following administrative credentials:

    • You are a member of the Administrators group for the site collection.

    • You are a member of the Owners group for the site.

    • You have the Manage Permissions permission.

  2. On the Site Settings page, under Users and Permissions, click Site permissions.

  3. In the Manage section of the ribbon, click Permission Levels.

  4. In the list of permission levels, click the name of the permission level that you want to copy.

  5. At the bottom of the page, click Copy Permission Level.

  6. On the Copy Permission Level page, in the Name field, type a name for the new permission level.

  7. In the Description field, type a description for the new permission level.

  8. In the list of permissions, select or clear the check boxes to add permissions to or remove permissions from the permission level.

  9. Click Create.

Create a permission level

If there is no permission level similar to the one that you need, you can create one.

To create a permission level

  1. Verify that you have one of the following administrative credentials:

    • You are a member of the Administrators group for the site collection.

    • You are a member of the Owners group for the site.

    • You have the Manage Permissions permission.

  2. On the Site Settings page, under Users and Permissions, click Site permissions.

  3. In the Manage section of the ribbon, click Permission Levels.

  4. On the toolbar, click Add a Permission Level.

  5. On the Add a Permission Level page, in the Name field, type a name for the new permission level.

  6. In the Description field, type a description of the new permission level.

  7. In the list of permissions, select the check boxes to add permissions to the permission level.

  8. Click Create.

See also

Identity Management for SharePoint 2013


Change administration-account passwords in SharePoint 2013
See also

Published: April 23, 2013

Summary: Learn about how to keep account passwords synchronized for sites and site content for SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Certain SharePoint 2013 services and features must be associated with a Windows account to run. If the account has a password, that is, if the account is anything other than the Local System account, the Local Service account, or the Network Service account then the password in SharePoint 2013 must be updated when the account's password changes.

There are two ways to keep passwords synchronized between Windows and SharePoint 2013: automatically and manually. To synchronize passwords automatically you can register managed accounts and configure SharePoint 2013 to change the managed accounts' passwords according to a schedule. SharePoint 2013 automatically generates a new password, updates the password in Active Directory Domain Services (AD DS), and propagates the changes to other servers in the farm. For more information about managed accounts, see Plan automatic password change in SharePoint 2013.

Warning:

Windows Server 2008 R2 and Windows Server 2012 include managed accounts at the operating system level. Do not use Windows Server 2008 R2 and Windows Server 2012 managed accounts. They are incompatible with SharePoint 2013 managed accounts.

We recommend that you use SharePoint 2013 managed accounts when you can. You can use managed accounts to control the passwords for the following things:

  • Central administration

  • Timer service

  • Service applications

  • Application pools

When managed accounts are unsuitable, you must change passwords in SharePoint 2013 manually when the passwords change in AD DS. Passwords must be changed manually for the following things:

  • SQL Server services

  • The default content access account

  • In SharePoint Server 2013, credentials that are used to access external data sources and are stored in the Secure Store service application. For additional information about how to change credentials to access external data sources, see Configure the Secure Store Service in SharePoint 2013.

See also

Security and permissions (SharePoint 2013)


Change passwords for SQL Server services (SharePoint Server 2013)
See also

Published: April 23, 2013

Summary: Learn how to change passwords for the SQL Server services and SQL Server Agent service accounts by using SQL Server Configuration Manager.

Applies to: SharePoint Server 2013

SharePoint Server 2013 supports SQL Server 2008 R2 with Service Pack 1 (SP1) and SQL Server 2012. In both SQL Server versions, you must update the password for the services when the service account's password changes.

Important:

Do not change the passwords for the service accounts when a failover cluster node is offline. If you do this, you'll have to reset the password again when all nodes are back online.

In this article:

  • Before you begin

  • Change the password for the SQL Server service account

  • Change the SQL Server Agent account password

Before you begin

The SQL Server services and SQL Server Agent service can use built-in Windows service accounts. Both services can use the Local System account, known as NT AUTHORITY\System. This account has unrestricted access to all local system resources, is a member of the Windows Administrators group on the local computer, and is also a member of the SQL Server sysadmin fixed server role. Because this account is so powerful for security, we recommend that you use a Windows user account that is not a member of the Windows Administrators group.

Note:

Because SharePoint 2013 runs as websites in IIS, administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information:

  • To change the service account or password that is used by SQL Server service or SQL Server Agent you must be in the active node of the SQL Server cluster.

  • When you run SQL Server on Windows Server 2008 R2, in a non-default configuration using Domain groups, and you change the service account password, you must use SQL Server Configuration Manager to stop SQL Server and take the resource groups offline.

Change the password for the SQL Server service account

Use the following procedure to change the password for the SQL Server service account.

To change the SQL Server service account password

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the computer that is running SQL Server.

    Note:

    The account must also be the domain account that SQL Server uses if the Database Engine is configured to run under a domain account.

  2. Start the SQL Server Configuration Manager.

    • For Windows Server 2008 R2:

      • On the Start menu, point to All Programs, point to Microsoft SQL Server 2012 or Microsoft SQL Server 2008 R2, point to Configuration Tools, and then click SQL Server Configuration Manager.

    • For Windows Server 2012:

      • On the Start screen, click SQL Server Configuration Manager.

        If SQL Server Configuration Manager does not appear on the Start screen:

      • Right-click Computer, click All apps, and then click SQL Server Configuration Manager.

  3. In the navigation pane of the Configuration Manager, expand SQL Server Configuration Manager (Local), and then click SQL Server Services.

  4. In the details pane, right-click the name of the SQL Server instance for which you want to change the service account password, and then click Properties.

  5. In the SQL Server <instancename> Properties dialog box, click the Log On tab, type the new password in the Password and Confirm password boxes.

  6. After you change the password, click OK.

    A message asks whether you want to restart the SQL Server service.

  7. Click Yes, and then close SQL Server Configuration Manager.

Change the SQL Server Agent account password

Use the following procedure to change the password for the SQL Server Agent service account.

To change the SQL Server Agent account password

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the computer that is running SQL Server.

    Note:

    The account must also be the domain account that SQL Server uses if the Database Engine is configured to run under a domain account.

  2. Start the SQL Server Configuration Manager.

    • For Windows Server 2008 R2:

      • On the Start menu, point to All Programs, point to Microsoft SQL Server 2012 or Microsoft SQL Server 2008 R2, point to Configuration Tools, and then click SQL Server Configuration Manager.

    • For Windows Server 2012:

      • On the Start screen, click SQL Server Configuration Manager.

        If SQL Server Configuration Manager does not appear on the Start screen:

      • Right-click Computer, click All apps, and then click SQL Server Configuration Manager.

  3. In the navigation pane of the Configuration Manager, expand SQL Server Configuration Manager (Local), and then click SQL Server Services.

  4. In the details pane, right-click SQL Server Agent (server_name), where server_name is the name of the SQL Server Agent instance for which you want to change the password of the service account, and then click Properties.

  5. In the SQL Server Agent <server_name> Properties dialog box, click the Log On tab, type the new password in the Password and Confirm password boxes.

  6. Click OK.

    A message asks whether you want to restart the SQL Server Agent service.

  7. Click Yes, and then close SQL Server Configuration Manager.

See also

Select an Account for the SQL Server Agent Service
Change the Service Startup Account for SQL Server (SQL Server Configuration Manager)
Start, Stop, Pause, Resume, Restart the Database Engine, SQL Server Agent, or SQL Server Browser Service


Administer sites and site collections in SharePoint 2013
See also

Summary: Use these TechNet articles to learn how to manage sites and site collections in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A SharePoint 2013 site collection is a hierarchical site structure that is made up of one top-level site and sites below it. This top-level website can have multiple subsites, and each subsite can have multiple subsites, for as many levels as required. Top-level websites and subsites allow different levels of control over the features and settings for sites.

TechNet articles about site and site collection administration

The following articles about how to manage sites and site collections in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Manage site collections in SharePoint 2013 | These articles explain how to create and delete site collections, how to manage site collection administrators, and how to use quota templates to manage site collection storage limits.
 | Manage sites in SharePoint 2013 | These articles explain how to determine when to lock or unlock sites, and how to use site usage data to determine whether an unused website should be deleted.
 | Manage Web Parts in SharePoint 2013 | This article helps you prepare to manage security for Web Parts pages and controls that are used with SharePoint 2013.

See also

Operations for SharePoint 2013


Manage site collections in SharePoint 2013
See also

Summary: Use these TechNet articles to learn how to manage site collections in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet provide information about how to create and delete site collections, how to manage site collection administrators, how to use quota templates to manage site collection storage limits, and how to create connections between specific types of sites in SharePoint 2013.

TechNet articles about how to manage site collections

The following articles about how to manage site collections in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Create a site collection in SharePoint 2013 | How to create a site collection based on an existing Web application or create a Web application and then create a site collection within that application.
 | Delete a site collection in SharePoint 2013 | How to delete the content, user information, and site hierarchy that comprise a site collection.
 | Restore a deleted site collection in SharePoint 2013 | How to restore a site collection that has been deleted.
 | Manage blocked file types in SharePoint 2013 | How to restrict files from being uploaded or downloaded based on their file name extension.
 | Manage the lock status for site collections in SharePoint 2013 | How to add or remove a lock from a site collection.
 | View all site collections in SharePoint 2013 | How to see the list of site collections.
 | Manage a connection to a document center or a records center in SharePoint 2013 | How to connect a web application to a SharePoint 2013 document center or records center and how to modify and delete connections.
 | Change site collection administrators in SharePoint 2013 | How to change site collection administrators for SharePoint 2013 site collections by using Central Administration or the SharePoint 2013 Management Shell.
 | Create, edit, and delete quota templates in SharePoint 2013 | How to create, edit, and delete site quota templates for a SharePoint 2013 site collection.

See also

Operations for SharePoint 2013


Create a site collection in SharePoint 2013
See also

Summary: How to create a SharePoint 2013 site collection in an existing web application.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A site collection is a grouping of websites under a common top-level site that have the same owner and share administration settings, for example, permissions. When you create a site collection, a top-level site is automatically created in the site collection. You can then create one or more subsites below the top-level site. For more information, see Overview of sites and site collections in SharePoint 2013.

Web applications host site collections. A web application can host many site collections, but a site collection can be hosted in only one web application. You must create a web application before you can create a site collection. For more information, see Create claims-based web applications in SharePoint 2013.

If your web application is for a single project or for use by a single team, you should use a single site collection to avoid the overhead of managing multiple sites. However, complex solutions benefit from multiple site collections because it is easier to organize content and manage permissions for each site collection. For example, because there is no built-in navigation from one site collection to another, having multiple site collections can provide an additional layer of security for site content. For more information, see Plan sites and site collections in SharePoint 2013.

SharePoint 2013 supports both path-based and host-named site collections. The primary difference between path-based and host-named site collections is that all path-based site collections in a web application share the same host name (DNS name), and each host-named site collection in a web application is assigned a unique DNS name. You must use Windows PowerShell to create a host-named site collection. For more information about host-named site collections, see Host-named site collection architecture and deployment (SharePoint 2013).

Data about a site collection is stored in a set of configuration databases. A farm can only have one set of configuration databases. All the data for a specific site resides in one content database. Each web application can contain many content databases. Each site collection can be associated with only one content database, although a content database can be associated with many site collections.

SharePoint provides site templates in the following categories: collaboration, meetings, enterprise, publishing, and custom. When you create a site collection, you select the template that matches what you want the site to do. For example, you can use the templates to create the following types of site collections:

  • Choose the Publishing Portal template from the Publishing category if you want to create a large intranet site that has many more readers than contributors.

  • Choose the Discovery Center template from the Enterprise category if you want to create a site to manage the preservation, search, and export of content for legal matters and investigations.

  • Choose the Records Center template from the Enterprise category if you want to create a site for records management. Records managers can configure the routing table to direct incoming files to specific locations.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

In this article:

  • Before you begin

  • Create a site collection by using Central Administration

  • Create a site collection by using Windows PowerShell

Before you begin

Before you create a site collection, ensure that the following prerequisites are available:

  • A web application in which to create the site collection.

  • A quota template, if you plan to define values that specify how much data can be stored in a site collection and the storage size that triggers an email alert to the site collection administrator. For more information, see Create, edit, and delete quota templates in SharePoint 2013.

  • A custom managed wildcard path, if you plan to create the site collection somewhere other than under the root (/) directory or the /sites/ directory. For more information, see Define managed paths in SharePoint Server 2013.

Create a site collection by using Central Administration

You typically use the Central Administration website to create a site collection in a stand-alone deployment.

To create a site collection by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To create a site collection, you must be a member of the Farm Administrators SharePoint group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the Central Administration website, in the Application Management section, click Create site collections.

  4. On the Create Site Collection page, in the Web Application section, if the web application in which you want to create the site collection is not selected, on the Web Application menu, click Change Web Application, and then click the web application in which you want to create the site collection.

  5. In the Title and Description section, type the title and description for the site collection.

  6. In the Web Site Address section, select the path to use for your URL (for example, a wildcard inclusion path such as /sites/, or the root directory (/).

    If you select a wildcard inclusion path, you must also type the site name to use in your site's URL.

  7. In the Template Selection section, in the Select experience version list, select the SharePoint experience version of the templates that you want to use.

    Select the 2010 experience version if you want the site collection to look and run like a site collection in SharePoint Server 2010. A site collection that uses the 2010 experience version runs in SharePoint 2013, but the user interface and user experience of the site collection is that of SharePoint Server 2010. A site collection that uses the 2010 experience version can be upgraded at any time to the 2013 experience version. For more information about how to upgrade a site collection, see Upgrade a site collection to SharePoint 2013.

  8. In the Template Selection section, in the Select a template list, select the template that you want to use for the top-level site in the site collection, or click the Custom tab to create an empty site and apply a template later.

    A description for the template that you select appears below the list of templates.

  9. In the Primary Site Collection Administrator section, type the user name (in the form DOMAIN\username) for the user who will be the site collection administrator.

  10. In the Secondary Site Collection Administrator section, type the user name for the secondary administrator of the site collection.

    Designating a secondary site collection administrator is a best practice to ensure that someone can manage the site collection when a primary site collection administrator is not present.

  11. If you are using quotas to manage storage for site collections, in the Quota Template section, click a template in the Select a quota template list.

  12. Click OK.

Create a site collection by using Windows PowerShell

You typically use Windows PowerShell to create a site collection when you want to automate the task, which is common in enterprises.

To create a site collection by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 15 Products.

  4. Click SharePoint 15 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following commands, and then press ENTER:

    Copy code
    Get-SPWebTemplate
    Copy code
    $template = Get-SPWebTemplate "STS#0"
    Copy code
    New-SPSite -Url "<URL for the new site collection>" -OwnerAlias "<domain\user>" -Template $template

    This example retrieves a list of all available site templates and then creates a site collection by using the Team Site template. For more information, see New-SPSite and Get-SPWebTemplate.

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Manage site collections in SharePoint 2013


Delete a site collection in SharePoint 2013
See also

Summary: How to delete SharePoint 2013 site collection content, user information, and the site hierarchy.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You might want to delete a site collection if it is no longer needed. For example, if you created a team site to track progress on a specific project, and the project has ended, you might decide to delete the site collection after a certain amount of time has passed.

When you delete a site collection, you are deleting the hierarchy of sites that comprise the collection. When you delete a site collection, you permanently destroy all content and user information, such as the following:

  • Documents and document libraries.

  • Lists and list data, including surveys, discussions, announcements, and events.

  • Site configuration settings.

  • Role and security information that is related to the website.

  • Subsites of the top-level website, their contents, and user information.

Note:

You should back up a site collection before you delete it. For more information about how to back up a site collection, see Plan for backup and recovery in SharePoint 2013.

If the site collection is associated with a Project Server service application, you must remove the association and delete the Project Web App before you delete the site collection. You can remove the site collection association with the Project Server service application from the Project Server service application settings page in the SharePoint Central Administration website.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

In this article:

  • Before you begin

  • Delete a site collection by using Central Administration

  • Delete a site collection by using Windows PowerShell

Before you begin

Before you delete a site collection, ensure that the following prerequisites are available:

  • A backup copy of the site collection and all of its contents exists.

Delete a site collection by using Central Administration

After you perform this procedure, the site collection and all of its content and user information will be permanently destroyed.

To delete a site collection by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To delete a site collection, the user account that is performing this procedure must be a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the Central Administration website, on the Quick Launch, click Application Management.

  4. On the Application Management page, in the Site Collections section, click Delete a site collection.

  5. On the Delete Site Collection page, in the Site Collection list, click Change Site Collection.

    The Select Site Collection dialog box appears.

  6. In the Web Application list, click Change Web Application.

    The Select Web Application dialog box appears.

  7. Click the name of the web application that contains the site collection that you want to delete. Relative URLs of sites in the site collections of the web application that you have selected appear on the Select Site Collection dialog box.

  8. Click the relative URL of the site collection that you want to delete, and then click OK.

  9. Read the Warning section and verify that the site collection information is correct.

  10. On the Delete Site Collection page, click Delete.

Delete a site collection by using Windows PowerShell

After you perform this procedure, the site collection and all of its content and user information will be permanently destroyed.

To delete a site collection by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command, and then press ENTER:

    Copy code
    Remove-SPSite -Identity "<URL>" -GradualDelete

    Where:

    • <URL> is the URL of the site collection you want to delete.

    This command removes the specified site collection and all subsites. Gradual deletion reduces the load on the system during the deletion process.

    The previous procedure illustrates a common way to use the Remove-SPSite cmdlet to delete a site collection. You can specify different parameters to configure this command differently. For more information, see Remove-SPSite.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Create a site collection in SharePoint 2013
Overview of sites and site collections in SharePoint 2013


Restore a deleted site collection in SharePoint 2013
See also

Summary: How to restore a site collection in SharePoint 2013 that was accidentally deleted.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes how to restore a deleted site collection in SharePoint 2013.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

When a site collection (that is, a SPSite object) is accidentally deleted in SharePoint 2013, the deleted site collection is stored in the SPDeletedSite object, not the SPSite object. To restore a deleted site collection, you must use the Restore-SPDeletedSiteWindows PowerShell cmdlet or programmatically access the object model.

For examples of how to use the SPDeletedSite cmdlets, see Use Windows PowerShell cmdlets to manage sites in SharePoint 2013.

See also

Manage site collections in SharePoint 2013


Manage blocked file types in SharePoint 2013

Summary: How to block file types in SharePoint 2013 from being uploaded or downloaded based on their file name extension.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can restrict file types from being uploaded or downloaded in SharePoint 2013. Each web application maintains a list of blocked file types that is based on file name extensions. For example, you can block files that have the .exe extension because those files can be run on the client computer and can contain malicious code.

By default, many file types are blocked, including file types that are treated as executable by Internet Explorer. Files whose names include braces (for example, filename.{doc}) are also blocked by default. If you add a file type of a file that exists in the site collection, a message informs you that the item already exists and you are prevented from entering the file type.

The following table shows the file types that are blocked by default and their corresponding file name extensions.

Table: File types blocked by default

File name extension | File type
.ade | Microsoft Access project extension
.adp | Microsoft Access project
.app | Application file
.asa | ASP declarations file
.ashx | ASP.NET Web handler file. Web handlers are software modules that handle raw HTTP requests received by ASP.NET.
.asmx | ASP.NET Web Services source file
.asp | Active Server Pages
.bas | Microsoft Visual Basic class module
.bat | Batch file
.cdx | Compound index
.cer | Certificate file
.chm | Compiled HTML Help file
.class | Java class file
.cmd | Windows NT command script
.com | Microsoft MS-DOS program
.config | Configuration file
.cpl | Control Panel extension
.crt | Security certificate
.csh | Script file
.dll | Windows dynamic-link library
.exe | Program
.fxp | Microsoft Visual FoxPro compiled program
.hlp | Help file
.hta | HTML program
.htr | Script file
.htw | HTML document
.ida | Internet Information Services file
.idc | Internet database connector file
.idq | Internet data query file
.ins | Internet Naming Service
.isp | Internet Communication settings
.its | Internet Document Set file
.jse | JScript Encoded script file
.ksh | Korn Shell script file
.lnk | Shortcut
.mad | Shortcut
.maf | Shortcut
.mag | Shortcut
.mam | Shortcut
.maq | Shortcut
.mar | Shortcut
.mas | Microsoft Access stored procedure
.mat | Shortcut
.mau | Shortcut
.mav | Shortcut
.maw | Shortcut
.mda | Microsoft Access add-in program
.mdb | Microsoft Access program
.mde | Microsoft Access MDE database
.mdt | Microsoft Access data file
.mdw | Microsoft Access workgroup
.mdz | Microsoft Access wizard program
.msc | Microsoft Common Console document
.msh | Microsoft Agent script helper
.msh1 | Microsoft Agent script helper
.msh1xml | Microsoft Agent script helper
.msh2 | Microsoft Agent script helper
.msh2xml | Microsoft Agent script helper
.mshxml | Microsoft Agent script helper
.msi | Windows Installer package
.msp | Windows Installer update package file
.mst | Visual Test source files
.ops | Microsoft Office profile settings file
.pcd | Photo CD image or Microsoft Visual Test compiled script
.pif | Shortcut to MS-DOS program
.prf | System file
.prg | Program source file
.printer | Printer file
.pst | Microsoft Outlook personal folder file
.reg | Registration entries
.rem | ACT! database maintenance file
.scf | Windows Explorer command file
.scr | Screen saver
.sct | Script file
.shb | Windows shortcut
.shs | Shell Scrap object
.shtm | HTML file that contains server-side directives
.shtml | HTML file that contains server-side directives
.soap | Simple Object Access Protocol file
.stm | HTML file that contains server-side directives
.url | Uniform Resource Locator (Internet shortcut)
.vb | Microsoft Visual Basic Scripting Edition file
.vbe | VBScript Encoded Script file
.vbs | VBScript file
.ws | Windows Script file
.wsc | Windows Script Component
.wsf | Windows Script file
.wsh | Windows Script Host settings file
Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

Add or remove blocked file types

Use this procedure when you want to prohibit files of a specific type from being saved or retrieved from any web application on a server.

To add or remove blocked file types by using Central Administration

  1. Verify that you have the following administrative credentials.

    • You must be a farm administrator on the server.

  2. In Central Administration, click Security.

  3. On the Security page, in the General Security section, click Define blocked file types.

  4. On the Blocked File Types page, if you want to change the selected web application, on the Web Application menu, click Change Web Application. Use the Select Web Application page to select a web application.

  5. Do one of the following:

    • To block an additional file type, scroll to the bottom of the Type each file name extension on a separate line text box, type the file name extension that you want to block, and then click OK.

      Note:

      You do not have to type a file name extension in the list in alphabetical order. The next time that you open the list, the file name extension you added will be correctly sorted in alphabetical order.

    • To stop blocking a file type, select a file type from the list, press the Delete key, and then click OK.


Manage the lock status for site collections in SharePoint 2013

Summary: How to manage lock status for a site collection in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You use the lock status of a site collection to control the actions allowed on a site collection. The lock states are Not locked, Adding content prevented, Read-only, and No access.

The following table describes the locking options that are available in SharePoint 2013.

Option | Description
Not locked | Unlocks the site collection and makes it available to users.
Adding content prevented | Prevents users from adding new content to the site collection. Updates and deletions are still allowed.
Read-only (blocks additions, updates, and deletions) | Prevents users from adding, updating, or deleting content. When a user attempts to add, update, or delete content, the user receives an error message that informs the user that access is denied and that the user does not have permission to perform the action or access the resource. A read-only lock can be either be site collection administrator controlled if the site collection is archived or farm administrator controlled
No access | Prevents users from accessing the site collection and its content. Users who attempt to access the site receive an error page that informs the user that the website declined to show the webpage.
Note:

If you want to limit the amount of content that can be stored in a site collection, you can apply a quota template to the site collection. When the content storage limit that is specified in the quota template is reached, the site collection is locked automatically until the storage limit quota has been increased or some content has been removed. For more information, see Create, edit, and delete quota templates in SharePoint 2013.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

Manage the lock status for a site collection by using Central Administration

Use this procedure to lock or unlock a site collection by using Central Administration.

To manage the lock status for a site collection by using Central Administration

  1. Verify that you have the following administrative credentials.

    • You must be a member of the Site Collection Administrators group for the site collection.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the Application Management page, in the Site Collections section, click Configure quotas and locks.

  4. If the site collection you want is not already selected, in the Site Collection section, on the Site Collection menu, click Change Site Collection. Use the Select Site Collection page to select a site collection.

  5. On the Site Collection Quotas and Locks page, in the Site Lock Information section, select one of the following options:

    • Not locked to unlock the site collection and make it available to users.

    • Adding content prevented to prevent users from adding new content to the site collection. Updates and deletions are still allowed.

    • Read-only (blocks additions, updates, and deletions) to prevent users from adding, updating, or deleting content. Choose whether you want this to be farm administrator controlled or site collection administrator controlled.

    • No access to prevent users from accessing the site collection and its content. Users who attempt to access the site receive an error message.

  6. If you select Adding content prevented, Read-only (blocks additions, updates, and deletions), or No access, type a reason for the lock in the Additional lock information box.

  7. Click OK.

Manage the lock status for a site collection by using Windows PowerShell

Use this procedure to lock or unlock a site collection by using Windows PowerShell.

To manage the lock status for a site collection by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command, and then press ENTER:

    Copy code
    Set-SPSite -Identity "<SiteCollection>" -LockState "<State>"

    Where:

    • <SiteCollection> is the URL of the site collection that you want to lock or unlock.

    • <State> is one of the following values:

      • Unlock to unlock the site collection and make it available to users.

      • NoAdditions to prevent users from adding new content to the site collection. Updates and deletions are still allowed.

      • ReadOnly to prevent users from adding, updating, or deleting content.

      • NoAccess to prevent users from accessing the site collection and its content. Users who attempt to access the site receive an error message.

Note:

For more information about how to use the Set-SPSite cmdlet, see Set-SPSite.


View all site collections in SharePoint 2013

Summary: How to see the list of site collections in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

A site collection is a group of websites that have the same owner and share administrative settings, for example, permissions, and quotas. Site collections are created within a web application. When you create a site collection, a top-level site is automatically created in the site collection. You can then create one or more subsites below the top-level site. The entire structure of the top-level site and all its subsites is called a site collection.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

View the site collections in a web application

Use the following procedures to view all the site collections in a web application.

To view all site collections by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To view all site collections, you must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the Application Management page, in the Site Collections section, click View all site collections.

    The Site Collection List page lists all the site collections in the web application.

  4. To display more information about a site collection, in the URL column, click the site collection.

    The following information about the site collection appears in a table on the right side of the page.

    Item Description

    URL

    The URL of the site collection.

    Title

    The current title for site collection.

    Description

    The current description for the site collection.

    Primary administrator

    The primary administrator for the site collection.

    Email address

    The email address for the primary administrator.

    Database name

    The content database that is used by the site collection.

  5. If you want to change the selected web application, click the Web Application box, and then click Change Web Application. Use the Select Web Application page to select another web application.

To view all site collections by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command, and then press ENTER:

    Copy code
    Get-SPWebApplication -Limit All | " | Get-SPSite | Format-Table -Property URL,ContentDatabase

    This command displays the URLs of all the web applications in a server farm and the site collections in each web application.

For more information, see Get-SPWebApplication and Get-SPSite.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


Manage a connection to a document center or a records center in SharePoint 2013
See also

Published: December 4, 2012

Summary: How to connect a web application to a SharePoint 2013 document center or records center and how to modify and delete connections.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

A connection is a path used for sending documents to a document center or a records center. The connection specifies the web application that documents will be sent from, the document center or records center that they will be sent to, and certain aspects of how the documents are sent. A records center is a site that is designed for records management.

Connections are created by a farm administrator in SharePoint 2013. The farm administrator configures the connection to copy content, to move content, or to move the content and leave a link in the source site collection.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

In this article:

  • Before you begin

  • Create a connection

  • Modify a connection

  • Delete a connection

Before you begin

The following is required to perform the procedures for this task:

  • You must have already created the destination document or record center and you need the URL of the destination document or record center.

Create a connection

Use this procedure to create a connection to a document repository or a records center.

To create a connection

  1. Ensure that you have the required permissions to perform this procedure. To create a connection, you must be a member of the Farm Administrators group.

  2. On the SharePoint Central Administration website, in the General Application Settings section, select Configure Send To Connections.

  3. On the Configure Send To Connections page, in the Web Application field, select the web application that hosts the site collections from which documents will be sent.

  4. In the Tenant Settings section, select Allow sites to send to connections outside their tenancy if you want tenants on this farm to able to send content to other tenants on this farm.

  5. In the Send To Connections list, select New Connection.

  6. In the Display name field, type a name for this connection. This is the name that users will see as one of the options to which to send a document.

  7. In the Send to URL field, enter the URL to the Content Organizer for the destination site. (You can find the URL in the Submission Points section of the Content Organizer : Settings page of the destination repository.) Click Click here to test if you want to confirm that you have entered a URL to a Content Organizer.

  8. To display this connection in the list that appears when a user clicks Send To, select Allow manual submission from the Send To menu.

  9. In the Send To action list, select one of the following values:

    • Copy Select this option to create a copy of the document and send the copy to the destination repository.

    • Move Select this option to delete the document from its current location and move the document to the destination repository. Users will no longer be able to access the document from its original location.

    • Move and Leave a Link Select this option to delete the document from its current location, move it to the destination repository, and leave a link at the current location indicating that the document has been moved. When a user clicks this link, a page will appear that displays the URL of the document and the document's metadata.

  10. In the Explanation dialog box, type the information to be added to the audit log when the user sends a document by using this connection. If you selected Move and Leave a Link in the previous step, the page that appears when the user clicks the link will also display the explanation.

  11. Click Add Connection to create the connection.

  12. Click OK when you are finished configuring connections.

Note:

The Allow sites to send to connections outside their tenancy option applies to all site subscription connections in a web application, and is not used when you add, modify, or delete a single connection.

Modify a connection

Use this procedure to modify an existing connection to a document repository or a records center.

To modify a connection

  1. Ensure that you have the required permissions to perform this procedure. To modify a connection, you must be a member of the Farm Administrators group.

  2. On the Central Administration website, in the General Application Settings section, select Configure Send To Connections.

  3. On the Configure Send To Connections page, in the Web Application field, select the web application that contains the site collections that use this connection.

  4. In the Send To Connections list, select the connection that you want to modify.

  5. Modify any of the connection settings as described in the previous procedure.

  6. Click Update Connection to modify the connection.

  7. Click OK when you are finished configuring connections.

Delete a connection

Use this procedure to delete an existing connection to a document repository or a records center.

To delete a connection

  1. Ensure that you have the required permissions to perform this procedure. To delete a connection, you must be a member of the Farm Administrators group.

  2. On the Central Administration website, in the General Application Settings section, select Configure Send To Connections.

  3. On the Configure Send To Connections page, in the Web Application field, select the web application that contains the site collections that use this connection.

  4. In the Send To Connections list, select the connection that you want to delete.

  5. Click Remove Connection to delete the connection.

  6. Click OK when you are finished configuring connections.

See also

Manage site collections in SharePoint 2013


Change site collection administrators in SharePoint 2013
See also

Published: December 4, 2012

Summary: How to change site collection administrators for SharePoint 2013 site collections by using SharePoint 2013 Central Administration or the SharePoint 2013 Management Shell.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

A site collection administrator in SharePoint 2013 can configure the appearance and behavior of the site, configure search settings and site directory settings, and allocate storage space. A site collection must have one primary site collection administrator and can have one secondary site collection administrator. The primary and secondary site collection administrators receive administrative email alerts for the site collection. The primary and secondary site collection administrators are automatically added to the SharePoint Site Collection Administrators group. You can add as many additional accounts as you want to the SharePoint Site Collection administrators group, but only the primary and secondary site collection administrators will receive administrative alerts for the site collection. All members of the SharePoint Site Collection Administrators group have full administrative permissions to the site collection.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

In this article:

  • Change the primary or secondary site collection administrator

  • Remove a site collection administrator

Change the primary or secondary site collection administrator

Use this procedure when you want to make a user a primary or secondary site collection administrator for a specific site collection.

Caution:

A site collection can have only one primary site collection administrator and one secondary site collection administrator. The steps in this procedure describe how to change either of them. Any user who is removed as a site collection administrator is removed from the site collection administrators group for the site collection.

To change the primary or secondary site collection administrator by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To add a site collection administrator, you must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. In Central Administration, click Application Management.

  3. On the Application Management page, in the Site Collections section, click Change site collection administrators.

  4. On the Site Collection Administrators page, click the arrow next to the site collection name, and then select Change Site Collection if the site collection you want is not already selected.

  5. If the site collection to which you want to add an administrator is listed, select the URL of the site collection, and then click OK. If the site collection is not listed, click the arrow next to the web application name, click Change Web Application, select the name of the web application that contains the site collection, select the URL of the site collection, and then click OK.

  6. In the Primary site collection administrator or Secondary site collection administrator area, either type the name of the user whom you want to add by using the format <domain>\<username> or select the user by using the address book.

  7. Click OK.

To add a primary or secondary site collection administrator by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command to replace the secondary site collection administrator:

    Copy code
    Set-SPSite -Identity "<SiteCollection>" -SecondaryOwnerAlias "<User>"

    Where:

    • <SiteCollection> is the URL of the site collection to which you want to add a site collection administrator.

    • <User> is name of the user whom you want to add in the format <domain>\<username>.

The previous procedure shows a common way to use the Set-SPSite cmdlet to add a secondary site collection administrator. You can specify different parameters to configure different settings for a site collection. For more information, see Set-SPSite.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Remove a site collection administrator

Use this procedure to specify the user to be removed from the site collection administrator list. This procedure does not remove the user from Active Directory Domain Services (AD DS).

To remove a site collection administrator by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To remove a site collection administrator, you must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. In Central Administration, select Application Management.

  3. On the Application Management page, in the Site Collections section, click Change site collection administrators.

  4. On the Site Collection Administrators page, click the arrow next to the site collection name, and then click Change Site Collection.

  5. If the site collection from which you want to remove an administrator is listed, select the URL of the site collection, and then click OK. If the site collection is not listed, click the arrow next to the web application name, click Change Web Application, select the name of the web application that contains the site collection, select the URL of the site collection, and then click OK.

  6. Every site collection must have a primary site collection administrator. If you want to remove the primary site collection administrator, you must replace it with a different primary site collection administrator. To do so, select the current administrator's name, press the Delete key, and then either type the name of the replacement site collection administrator by using the format <domain>\<username> or select a replacement site collection administrator by using the address book.

  7. To remove the secondary site collection administrator, select the administrator's name, and then press the Delete key.

  8. Click OK.

See also

Create a site collection in SharePoint 2013


Create, edit, and delete quota templates in SharePoint 2013
See also

Published: December 4, 2012

Summary: How to create, edit, and delete site quota templates for a SharePoint 2013 site collection.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

You control how much data a site collection can hold and the quantity of resources it can use by using quotas. Quotas let you set storage limit values and warning limit values. Storage limit values define the maximum limit which the site collection size cannot exceed. Warning limit values define a threshold that, when reached, triggers an email alert to the site collection administrators. Quotas can be saved as quota templates, which can then be applied to any site collection in a SharePoint farm. Using quota templates rather than individual quotas can simplify setting storage limits on new site collections. For more information about how to plan quotas, see Plan quota management (SharePoint Foundation 2010).

When the site collection reaches the maximum storage level, SharePoint 2013 sets the lock status for the site collection to Read-only, and users are prevented from adding, updating, or deleting content. SharePoint 2013 sends an email message that contains information about the issue to the site collection administrators. The site collection administrators can either delete unused content from the site collection or ask a member of the Farm Administrators group to increase the limits. A farm administrator can do any of the following to change the limits:

  • Change the storage limit on the quota template that the site collection is using. The new limits will only take effect if the quota template is removed and reapplied to the site collection

  • Designate a new quota template that has a higher storage limit to the site collection and apply it. This automatically increases the limits for the site collection to the limits in the newly designated quota template. This is the preferred method, because the settings in the new quota template are automatically applied to the site collection and no additional action is needed.

  • Change the storage limit for the site collection manually. This overrides the limits set in the quota template that is currently applied to the site collection.

Note:

When you apply a quota template to a site collection, the storage limit applies to the site collection as a whole. In other words, the storage limit applies to the sum of the content sizes for the top-level site and all subsites within the site collection. If versioning is enabled, the versions in a site and the content in the Recycle Bins count toward storage limits. You can also specify a percentage of storage limits for the second-stage Recycle Bin. For more information about Recycle Bin settings, see Configure Recycle Bin settings (SharePoint Foundation 2010).

For recommendations about how to size content databases and site collections, see Enterprise content storage planning (SharePoint Server 2010) and Storage and SQL Server capacity planning and configuration (SharePoint Server 2013).

You can also apply quota templates to a site collection that contains sandboxed solutions. A sandbox is a restricted execution environment that enables programs to access only certain resources, and that keeps problems that occur in the sandbox from affecting the rest of the server environment. You can limit the maximum usage per day and send a warning email message when the usage limit is approaching. If the maximum usage limit is reached, the sandboxed solution is disabled for the rest of the day, and an email message is sent to the site collection administrator. For more information about restricting the resources that your sandboxed solutions consume, see Configure resource points for sandboxed solutions (SharePoint Server 2010).

You can also change existing quota templates. This allows you to change storage limits for all of the site collections that use the same quota template. When you change a quota template, you must reapply it to existing site collections before the new storage limits are enforced.

You can delete a quota template if necessary. However, deleting a quota template will not delete quota values from sites that were created by using the quota template. If you want to remove quotas from all sites by using a specific quota template, you must use the object model or perform a SQL query.

Important:

The steps in this article apply to both SharePoint Foundation 2013 and SharePoint Server 2013.

In this article:

  • Before you begin

  • Create a quota template

  • Edit a quota template

  • Delete a quota template

  • Change the settings of a quota template

  • Change the quota template for a site collection

  • Change the storage limits for a site collection

Before you begin

Before you perform this procedure, confirm the following:

  • Outgoing email is configured.

    For more information, see Configure outgoing email for a SharePoint 2013 farm.

  • The Disk Quota Warning timer job is running.

    For more information about default timer jobs for SharePoint 2013, see Timer job reference (SharePoint Foundation 2010).

  • The quota template options on the quota template page in Central Administration are available only if you have already created one or more quota templates. The first time that you use this page, you will be given only the option to create a new template.

Create a quota template

You might want to create a quota template to apply to sites that have storage and performance requirements that differ from most other sites in the site collection.

To create a quota template

  1. Verify that you have the following administrative credentials:

    • You are a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. On the Central Administration home page, click Application Management.

  3. On the Application Management page, in the Site Collections section, click Specify quota templates.

  4. On the Quota Templates page, in the Template Name section, click Create a new quota template.

  5. In the New template name box, type the name of the new template.

    If you want to base your new template on an existing quota template, expand the Template to start from list, and then click the template that you want.

  6. In the Storage Limit Values section, set the values that you want to apply to the template.

    • If you want to restrict how much data that can be stored, click the Limit site storage to a maximum of check box and type the storage limit in megabytes into the box.

    • If you want an email message to be sent to the site collection administrator when a certain storage threshold is reached, click the Send warning E-mail when Site Collection storage reaches check box and type the threshold in megabytes into the box.

  7. In the Sandboxed Solutions with Code Limits section, set the values for a template for sandboxed solutions.

    1. In the Limit maximum usage per day to box, type the daily usage in points.

    2. In the Send warning e-mail when usage per day reaches box, type the daily usage warning limit in points.

      A point is a relative measurement of resource usage, for example, CPU cycles, memory, or page faults. Points enable comparisons between measurements of resource usage that could not be compared otherwise.

      For more information, see Administering sandboxed solutions.

      If you do not want to send a warning email message, clear the Send warning e-mail when usage per day reaches check box.

  8. Click OK.

Edit a quota template

You might want to edit a quota template to increase the storage limit if you find that sites are exceeding the current storage limit on a regular basis.

To edit a quota template

  1. Verify that you have the following administrative credentials:

    • You are a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. On the Central Administration home page, click Application Management.

  3. On the Application Management page, in the Site Collections section, click Specify quota templates.

  4. On the Quota Templates page, in the Template Name section, expand the Template to modify list, and then click the template that you want to edit.

  5. Change the settings as necessary, and then click OK.

Delete a quota template

You might want to delete a quota template when the site collection that required those specific settings is deleted.

To delete a quota template

  1. Verify that you have the following administrative credentials:

    • You are a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. On the Central Administration home page, click Application Management.

  3. On the Application Management page, in the Site Collections section, click Specify quota templates.

  4. In the Template Name section, expand the Template to modify list, and then click the template that you want to delete.

  5. At the bottom of the Quota Templates page, click Delete, and then click OK.

Change the settings of a quota template

Note:

A modified quota template is not automatically applied to any existing site collections that use the quota template. A member of the Farm Administrators group must manually apply all modified values to all existing sites that use the quota template.

To change the settings of a quota template by using Central Administration

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group.

  2. On the Central Administration home page, click Application Management.

  3. On the Application Management page, in the Site Collections section, click Specify quota templates.

  4. On the Quota Templates page, in the Template Name section, in the Template to modify list, select the template that you want to change.

  5. In the Storage Limit Values section, specify the values that you want to apply to the template.

    • If you want to modify the amount of data that can be stored in the database, leave the Limit site storage to a maximum of check box selected, and then type the new storage limit, in megabytes, in the box.

    • If you want an email message to be sent to the site collection administrator when a storage threshold is reached, select the Send warning E-mail when site storage reaches check box, and then type the threshold, in megabytes, in the box.

  6. In the Sandboxed Solutions With Code Limits section, specify the values that you want to apply to the template.

    • If you want to limit the maximum resource usage points per day for sandboxed solutions that contain code, type the new limit in the Limit maximum usage per day to box. The default limit is 300 points.

    • If you want an email message to be sent to the site collection administrator when the usage per day threshold is reached, select the Send warning e-mail when usage per day reaches check box, and then type the threshold, in points, in the box.

  7. Click OK.

Change the quota template for a site collection

If a site collection is close to exceeding its storage limits and you want to increase its size, you can change the quota template that is applied to the site collection to a quota template that has higher limits. This automatically updates the warning and storage limits for the site collection.

To change the quota template for a site collection by using Central Administration

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group.

  2. On the Central Administration home page, click Application Management.

  3. On the Application Management page, in the Site Collections section, click Configure quotas and locks.

  4. On the Site Collection Quotas and Locks page, ensure that the correct site collection is displayed. If you want to change the site collection, expand the Site Collection list, and then click Change Site Collection. Use the Select Site Collection page to select a site collection.

  5. In the Site Quota Information section, expand the Current quota template list, and then select the new quota template to apply.

  6. Click OK.

To change the quota template for a site collection by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. Click Start, and then click All Programs.

  3. Click Microsoft SharePoint 2010 Products.

  4. Click SharePoint 2010 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPSite -Identity "<Site>" -QuotaTemplate "<Template>"

    Where:

    • <Site> is the URL or GUID of the site collection whose quota template that you want to change.

    • <Template> is the name or GUID of the replacement quota template.

For more information, see Set-SPSite.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Change the storage limits for a site collection

Use these procedures to change the storage limits for a site collection.

To change the storage limits for a site collection by using Central Administration

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group.

  2. On the Central Administration home page, click Application Management.

  3. On the Application Management page, in the Site Collections section, click Configure quotas and locks.

  4. On the Site Collection and Quota Locks page, ensure that the correct site collection is displayed. If you want to change the site collection, in the Site Collection section, expand the Site Collection list, and then click Change Site Collection. Use the Select Site Collection page to select a site collection.

  5. If the site collection currently uses a quota template, do the following to specify an individual quota:

    • On the Site Collection Quotas and Locks page, in the Site Quota Information section, expand the Current quota template list, and then select Individual Quota.

  6. Select the Limit site storage to a maximum of check box, and then type the new maximum value in megabytes.

  7. If you want to send site storage notification email messages to the site collection administrator, select the Send warning e-mail when site storage reaches check box, and then type the value in megabytes.

  8. If you want to limit the maximum resource usage points per day for sandboxed solutions, type the new limit in the Limit maximum usage per day to box. The default is 300 points.

  9. If you want an email message to be sent to the site collection administrator when the usage per day threshold is reached, select the Send warning e-mail when usage per day reaches check box, and then type the threshold, in points, in the box. The default is 100 points.

  10. Click OK.

To change the storage limits for a site collection by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. Click Start, and then click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPSite -Identity "<Site>" -MaxSize <Limit>

    Where:

    • <Site> is the URL of the site collection whose storage limits you want to change.

    • <Limit> is the new storage limit for the site collection, in megabytes.

      Note:

      The new storage limit overrides the limit set in the quota template that is currently applied to the site collection.

      For more information about the Set-SPSite cmdlet, see Set-SPSite.

    For information about how to use Windows PowerShell and the SharePoint object model to set the maximum usage per day and the warning level threshold for sandboxed solutions, see "Using Windows PowerShell for Administration" in Chapter 4: Sandboxed Solutions, an excerpt from the book Inside Microsoft SharePoint 2010 on MSDN.

See also

Create a site collection in SharePoint 2013
Manage the lock status for site collections in SharePoint 2013


Manage sites in SharePoint 2013
See also

Summary: Use these TechNet articles to learn how to manage sites in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following articles on TechNet provide information about how to manage websites in SharePoint 2013.

TechNet articles about how to manage sites

The following articles about how to manage sites in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Manage unused site collections in SharePoint 2013 | This article explains how to release, either automatically or in response to notification from a site collection administrator, the storage space allocated to inactive sites.
 | Restore a deleted site in SharePoint 2013 | This article explains how to restore an accidentally deleted site.

See also

Operations for SharePoint 2013


Manage unused site collections in SharePoint 2013
See also

Summary: How to manage unused site collections and how to delete site collections automatically in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Note:

To send email notifications, you must configure outgoing email settings. For more information, see Configure outgoing email for a SharePoint 2013 farm.

Site usage confirmation and deletion can help to free resources that are used by site collections that are no longer needed. Site collections can be deleted automatically after a specified period of inactivity or can depend on the site collection owner's response to a notification.

Before completing the procedure in this article, you should determine the following:

  • How long to wait before you check whether a site collection is inactive.

  • How often to send email notifications to site owners to see whether their sites collections are inactive. After the first email notification, if the site collection owner does not respond, you can continue to send additional notices at daily, weekly, or monthly intervals.

  • Whether you want to automatically delete unused site collections or delete a site collection if the site collection owner does not respond to multiple email notifications. If you delete site collections without an owner's approval, we recommend that you first back up the site. You can customize this functionality so that it automatically backs up a site collection before deletion by using the SharePoint 2010 Software Development Kit (SDK).

  • If you plan to automatically delete unused site collections, determine how many email notifications will you send to the site owner before you do so. By default, 28 daily notices are sent before site collection deletion. You can configure this number from a minimum of 28 notices to a maximum of 168 notices. For weekly notices, you can send a minimum of four notices and a maximum of 24 notices. For monthly notices, you can send a minimum of two notices and a maximum of six notices to site owners. The email notification contains links to confirm whether a site collection is active or inactive. After an email notification is sent to the site collection owner, there are three possible outcomes:

    • If the site collection owner confirms that the site collection is active by clicking the confirmation link in the email notification, the certification date of the site collection is renewed.

    • The site collection owner continues to receive periodic email notifications according to the interval specified by a member of the Farm Administrators group, until the site collection owner confirms that the site collection is active or deletes the site collection.

    • If the site collection is not active, and a member of the Farm Administrators group has turned on the automatic deletion feature, email notifications are sent to the site collection owner for the specified number of times. If the site collection owner does not confirm the status of the site collection, the site collection is deleted automatically.

In this article:

  • Before you begin

  • Manage unused site collections

Before you begin

We recommend the following best practices to safeguard against the automatic deletion of a site collection:

  • Require a secondary site collection owner when users create site collections. By default, the site collection creator is listed as the primary site collection owner. A site collection owner can also specify a secondary site collection owner. Confirmation notifications are automatically sent to the primary and the secondary site collection owners.

  • Keep the organization informed about vacations and leave a contingency plan. For example, if a site collection owner is unavailable for four weeks, and a member of the Farm Administrators group has set the site collection and deletion policy, after four missed weekly confirmations, the site could be deleted without giving the site collection owner an opportunity to confirm the usage of the site.

  • Ensure that there is a schedule to back up site collections regularly so that you can restore a recent copy if a site collection is deleted.

    Note:

    Automatic deletion permanently removes all the content and information from the site collection and any sites within the site collection.

Manage unused site collections

Use this procedure to manage unused site collections. You can follow these steps to determine the schedules for notifying site collection owners of site collection inactivity before deleting unused site collections.

To manage unused site collections

  1. Verify that you meet the following minimum requirements:

    • You must be a member of the Farm Administrators group on the computer running the SharePoint Central Administration website.

  2. In Central Administration, on the Application Management page, in the Site Collections section, click Confirm site use and deletion.

  3. On the Site Use Confirmation and Deletion page, in the Web Application section, if the web application that you want to configure is not listed, expand the Web Application list, and then click Change Web Application.

  4. In the Select Web Application dialog box, click the web application that you want to configure.

  5. In the Confirmation and Automatic Deletion Settings section:

    • Select or clear the Send e-mail notification to owners of unused site collections check box.

      If you select this check box, type the number of days, after the site collection creation or after the site collection usage is confirmed, to start to send notifications. The minimum number of days is 30, and the maximum is 365.

    • Specify a daily, weekly, or monthly schedule for email notifications. By default, the schedule is daily. You can also specify the exact time to run the check for the site collection usage. By default, the time is midnight.

    • Select or clear the Automatically delete the site collection if use is not confirmed check box.

      If you select this check box, type the number of notifications to send before the site collection is deleted. By default, it is 28 notifications.

  6. Click OK.

See also

Restore a deleted site in SharePoint 2013


Restore a deleted site in SharePoint 2013
See also

Summary: How to restore a deleted site in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

In SharePoint 2013, a deleted site is not permanently deleted. Instead, it is stored in the second-stage Recycle Bin. By default, the Delete item in Recycle Bin setting is set for 30 days, which means a deleted site will be permanently removed from the farm after the time value expires. The value of the Delete item in Recycle Bin setting can be increased if more time is needed to retain the deleted site.

For more information, see Configure Recycle Bin settings (SharePoint Server 2010).

At any point before the default time value expires, a site collection administrator can use the SharePoint Central Administration website to restore the deleted site.

In this article:

  • Before you begin

  • Restore a deleted site

Before you begin

Before you restore a site, be aware of the following known behavior:

  • Any content types that were added while the site was in the Recycle Bin are not included. Therefore, field definitions might not be up-to-date.

  • Content deployment will not work for a deleted site while the site is in the Recycle Bin. To resolve it, scoped deployment must be run for this site.

  • When an update package or hotfix is installed, the update package will skip the site while it is still located in the Recycle Bin. To resolve this issue, update the site afterward.

Restore a deleted site

Use the following procedure to restore a deleted site from the second-stage Recycle Bin.

To restore a deleted site from the second-stage Recycle Bin

  1. Verify that the user account that is performing this procedure has the site collection administrator permission.

  2. In Central Administration, click Site Actions, and then click Site Settings.

  3. In the Site Collection Administration section, click Recycle Bin.

  4. On the Recycle Bin page, select the check box for the deleted site that you want to restore.

  5. Click OK.

See also

Manage unused site collections in SharePoint 2013


Manage Web Parts in SharePoint 2013
See also

Published: December 11, 2012

Summary: Helps you prepare to manage security for Web Parts pages and controls that are used with SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Web Parts are modular elements that add functionality on pages of SharePoint sites. For more information, see Build reusable components for SharePoint 2013 section of the SharePoint Foundation 2013 SDK.

In SharePoint 2013, a Web Parts page is a collection of Web Parts that combines list data, timely information, or useful graphics into a dynamic web page. The layout and content of a Web Parts page can be set for all users and then, optionally, personalized for individual users. A site owner or a site member with the appropriate permissions can create and customize Web Parts pages by using a browser to add, reconfigure, or remove Web Parts.

You can use Web Parts on Web Parts pages, wiki pages, content pages, and publishing pages.

The Web Parts infrastructure in SharePoint 2013 exists on a layer above the ASP.NET Web Parts infrastructure. To effectively protect SharePoint sites, server administrators must be familiar with security guidelines and best practices for ASP.NET. For more information, see Security Guidelines: ASP.NET in the MSDN Library Online.

Note:

The apps for SharePoint are a new way to add functionality to a site. Site owners can add apps for SharePoint to SharePoint sites so that they and other users of the site can use the application. For more information, see Add apps for SharePoint to a SharePoint 2013 site.

Security for Web Parts pages and controls

Protecting Web Parts pages and controls is a collaborative effort. Developers, site administrators, and server administrators must work together to improve security for Web Parts and Web Parts pages. Developers should validate Web Part input to prevent server attacks. Server administrators must configure Internet Information Services (IIS) to use an appropriate authentication method.

Server administrators also configure and deploy Web Parts solutions to a web server or web farm. After the solution is deployed, site administrators or server administrators define the permission levels and permissions that allow access to Web Parts pages.

The following table shows the security roles that are responsible for configuring permissions on Web Parts pages and Web Parts.

Table: Security roles to configure Web Parts and Web Parts pages

Role | Category | Applies to | Description | Recommended guidelines
Developer | Input Validation | Web Part code | Input validation refers to how your application filters, scrubs, or rejects input before additional processing. This includes verification that the input that your application receives is valid and safe. | Building Secure ASP.NET Pages and Controls Creating Web Parts For SharePoint
Server administrator | Authentication | IIS | Authentication is the process where an entity validates the identity of another entity, typically through credentials such as a user name and password. | Plan for user authentication methods in SharePoint 2013
Site administrator/ Server administrator | Authorization | Site collections | Authorization is the process that provides access controls for Web sites, lists, folders, or items by determining which users can perform specific actions on a given object. The authorization process assumes that the user has already been authenticated. | Authorization and Authentication
Server administrator | Configuration Management | .NET Framework configuration | Configuration management encompasses a broad range of settings that allow an administrator to manage the Web application and its environment. These settings are stored in XML configuration files, some of which control computer-wide settings, while others control application-specific configurations. You can define special security constraints in configuration files and computer-level code access security permissions. | Code Access Security Microsoft Windows SharePoint Services and Code Access Security Using Code Access Security with ASP.NET

See also

Administer sites and site collections in SharePoint 2013
Configure and deploy Web Parts in SharePoint 2013


Configure and deploy Web Parts in SharePoint 2013
See also

Published: January 15, 2013

Summary: Learn about securing and deploying Web Parts in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

SharePoint 2013 includes a set of Web Parts that users can add to pages after installing the product. If an organization needs custom Web Parts, a developer can write custom ASP.NET Web Parts and ask you to install them. This process typically requires testing and approval of the code before the Web Part can be deployed in a full-trust environment. A developer who uses Visual Studio can deploy a Web Part to SharePoint 2013 by right clicking the project and selecting Deploy. The destination for the Web Part is determined by the trust level established with the SharePoint server when the developer created the project in Visual Studio.

SharePoint 2013 uses some of the configuration management settings that are provided by the Microsoft .NET Framework. Some of these settings are stored in XML configuration files and they provide a broad range of settings that server administrators use to manage the Web application and its environment. For more information about ASP.NET configuration files, see Machine.Config and Web.Config Explained in "Securing Your ASP.NET Application and Web Services" in the MSDN Library Online.

In this article:

  • Configuration options

  • Setting security attributes

  • Safe Controls list

  • Deploy and configure a Web Part

  • Add a component to the Web Part Gallery

Configuration options

ASP.NET Web Parts are deployed to either the SharePoint 2013bin directory or to the Global Assembly Cache (GAC).

  • Bin directory Stored in the bin folder under the root directory of your Web application.

  • Global Assembly Cache (GAC) All standard Web Parts are automatically installed in the GAC, where the common language runtime of the .NET Framework is located, at %windir%\assembly. Web Parts stored in the GAC can be shared across applications.

The following table describes the advantages and disadvantages of each location.

Deployment location Advantages Disadvantages

Bin directory

A partial-trust location. By default, code that runs from this directory has a low level of code access security permissions. If the Web Part requires access across applications or more access than the default permissions allow, the administrator must explicitly raise permissions that are granted to a Web Part so that it can function correctly. Administrators might prefer that assemblies run in the Bin directory, with a known minimum set of required code access security permissions.

Because the Bin directory is specific to a Web application, you can use this method if you want to isolate code to a single Web application.

To run your Web Part everywhere, you must deploy your assembly to the Bin directory on each SharePoint products server with the Web Front End role installed..

GAC

A global location where you can deploy signed assemblies, which can run with full trust by default. Because the assemblies are installed globally, they work in any Web application.

Generally, there are no code access security restrictions on code that is installed to the GAC; therefore, you lose the benefit of defense-in-depth security.

Additionally, it can be difficult to deploy your program database (.pdb) files to assemblies in the GAC.

Setting security attributes

ASP.NET Web Parts that are stored in the Bin directory have additional security attributes. You can decide whether to set these attributes for your Web Part, depending on how you plan to use it.

The Bin directory is a partial-trust location. Therefore, your Web Part is not automatically granted full trust code permissions when it is executed. Because the code that calls into your Web Part is granted only partial trust permissions, the Web Part developer must configure the AllowPartiallyTrustedCallers attribute on your ASP.NET Web Part.

Marking a component as "safe" with the AllowPartiallyTrustedCallers attribute puts the responsibility for safe implementation on the development team.

By default, the Bin directory and its contents are assigned minimal code access security permissions. You should test your Web Parts carefully to determine the correct level of permissions to assign, and to ensure that the Web Part does not present a security risk to your environment.

You can elevate permissions in either of two ways:

  • (Recommended) Create a trust policy file and point your Web.config file at the new file. This option is more complex, but it enables you to set precise permissions for your Web Parts. For more information about trust policy files, see Microsoft Windows SharePoint Services and Code Access Security in the MSDN Library Online.

  • Raise the overall trust level of the Bin directory. In the Web.config file in the root directory of your Web application, locate the trust element. The default value for the trust element's level attribute is WSS_Minimal. You can change this level to WSS_Medium. Although this option is simpler, it grants arbitrary new permissions that you might not need, and it is less secure than creating a trust policy file.

    Warning:

    The WSS_Minimal and WSS_Medium entries in the Web.config file are case sensitive.

Safe Controls list

The Safe Controls list contains the names of controls and Web Parts, specific to your SharePoint site, that server administrators can designate as safe for use on any .aspx page within a site. This list is part of the Web.config file in your Web application root.

Deploy and configure a Web Part

The method that you use to deploy a new Web Part will depend on the finished package that the developer provides. If the developer provided you with the Web Part as a single dynamic-link library (DLL) file, you can manually deploy the DLL by copying it to your Web application's Bin folder. If the developer provides you with a CAB file containing the Web Part, you can use Windows PowerShell to deploy the Web Part.

To manually deploy and configure a Web Part

  1. Verify that you have the following administrative credentials:

    • You must be a member of the local Administrators group on the server hostingSharePoint products.

  2. Copy the <YourWebPartName>.dll assembly in the project's Bin directory to the Bin directory in your Web application root directory. For example: C:\inetpub\wwwroot\wss\VirtualDirectories\80\.

  3. Locate the Web.config file in your application root directory and open it for editing.

  4. Add the following safe-control entry for your custom assembly to the Web.config file:

    Copy code
    <SafeControl Assembly="<YourWebPartName>, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null" Namespace="<YourWebPartNamespace>" TypeName="*" Safe="True" AllowRemoteDesigner="True"/>

    Where:

    1. <YourWebPartName> is the name of the Web Part that is being deployed.

    2. <YourWebPartNamespace> is the namespace that is associated with your Web Part.

An alternative to manually installing a Web Part to the Bin folder or manually changing the Web.config file is to use Windows PowerShell to install the Web Part package. For this process to work, a developer or system administrator must create a CAB solution package for the Web Part. For more information about creating a CAB package, see Solutions and Web Part Packages in the MSDN Library Online. After you create a CAB file, follow these steps to deploy the Web Part.

To deploy the Web Part by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt (PS C:\>), type the following command, and then press ENTER:

    Copy code
    Install-SPWebPartPack -LiteralPath "<PathToCabFile>" -Name "<WebPartName>"

    Where:

    • <PathToCabFile> is the full path to the CAB file that is being deployed.

    • <WebPartName> is the name of the Web Part that is being deployed.

Note:

The previous procedure shows a common way to use Install-SPWebPartPack to deploy a Web Part. You can specify additional parameters to change the way the Web Part is deployed. For more information, see Install-SPWebPartPack.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Add a component to the Web Part Gallery

Every Web Part should have a .webpart file, which is an XML file that describes the Web Part. The .webpart file also causes your Web Part to appear in the Web Part gallery. The following procedure is the easiest way to create a .webpart file after you deploy your Web Part and register it in the Safe Control list.

To add a component to the Web Part gallery

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group.

  2. To create a .webpart file, navigate to http://<MyServer>/_layouts/newdwp.aspx, where <MyServer> is the name of the server on which your SharePoint site is deployed.

  3. Select the check box next to <YourWebPartNamespace>.<YourWebPartName>.

  4. Click Populate Gallery to add the YourWebPartName Web Part to the Team Site gallery.

  5. In the Web Part gallery, select Edit to edit the Web Part, and then click Import.

    You are prompted to specify a location for the .webpart file. You can also export ASP.NET Web Parts and import them to SharePoint sites.

See also

Manage Web Parts in SharePoint 2013


Administer mobile devices in SharePoint 2013
See also

Summary: Learn how to improve productivity, usability, and administer the new features on mobile devices in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint Server 2013 offers new, optimized viewing experiences across different mobile platforms. Additionally, several new features are added to help improve both worker productivity and usability on the device. For more information about all the features that are included with SharePoint Server 2013, see Overview of mobile devices and SharePoint Server 2013.

TechNet articles about mobile administration

The following articles about mobile administration in SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Configure mobile accounts in SharePoint 2013 | Describes how to subscribe to SMS alerts for your mobile device in SharePoint Server 2013.
Building blocks | Configure the browser definition file in SharePoint 2013 | Describes how to modify the browser definition file in SharePoint Server 2013 to change the redirect behavior of a mobile browser, or add or delete mobile device entries.
Building blocks | Configure external access for mobile devices in SharePoint 2013 | Describes how to access SharePoint Server 2013 on mobile devices external to a network.
Building blocks | Use the location field type in mobile applications for SharePoint 2013 | Describes how to work with the new SharePoint Server 2013 location field type for mobile application development.
Building blocks | Clear push notification registrations from the subscription store in SharePoint 2013 | Describes how to clear specific device entries that have not been updated in the subscription store for 30 days, or the entire contents of the subscription store.

Additional resources about mobile administration

The following resources about mobile administration in SharePoint Server 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | What's New in SharePoint 2013 Resource Center | Visit the Resource Center to access videos, community sites, documentation, and more.

See also

Overview of mobile devices and SharePoint Server 2013


Configure mobile accounts in SharePoint 2013
See also

Summary: Learn how to subscribe to SMS alerts for your mobile device in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article discusses how to configure and manage a mobile account for SharePoint Server 2013 to enable users to subscribe to alerts that are sent by using Short Message Service (SMS). The alerts are sent to users' mobile phones when changes are made to a SharePoint list or item.

A SharePoint site is usually located on an intranet. As a result, access to the SharePoint site can be difficult when users are away from the office — for example, when they are traveling or attending a business dinner. The mobile alert feature enables users to react quickly when they receive an SMS alert that an item in a SharePoint list has changed.

You can configure one mobile account for all web applications in a server farm, or you can configure the mobile account for a specific web application. However, you can only configure one mobile account in the farm. The scale of your implementation might determine whether you configure the mobile account for the farm or for a specific web application. If you configure the mobile account for a server farm, everyone in the organization can subscribe to alerts. This is useful, for example, in a small organization in which management wants all users to receive certain alerts. If you have several web applications that divide your organization into groups, you might want to configure a mobile account for only one of those groups. For example, you want to configure a mobile account to enable everyone in the sales group to subscribe to alerts.

Before you perform these procedures, confirm the following:

  • The server farm account has permission to access the Internet for sending alerts.

  • You have obtained the root certificate for the service provider's HTTPS web address. You can obtain the root certificate from your service provider or by using your web browser.

In this article:

  • Import a root certificate and create a trusted root authority

  • Configure a mobile account

  • Retrieve mobile account information

  • Delete a mobile account

Import a root certificate and create a trusted root authority

Before you configure a mobile account, you must import the root certificate of the service provider's HTTPS web address, and then create a trusted root authority. This step can only be performed manually by using Windows PowerShell.

To import a root certificate and create a trusted root authority by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin. Additionally, you must be a member of the Farm Administrators group and a member of the Administrators group on the local computer that is running Windows PowerShell.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To get the root certificate, at the Windows PowerShell command prompt, type the following command:

    Copy code
    $cert = Get-PfxCertificate <ObtainedCertificatePath>

    To create a trusted root authority, at the Windows PowerShell command prompt, type the following command:

    Copy code
    New-SPTrustedRootAuthority -Name <Name> -Certificate $cert

    Where:

    • <Name> is the name of the trusted root authority that you want to create.

    • <ObtainedCertificatePath> is the location of the root certificate file.

    Note:

    In the Certificate window, on the Certification Path tab, ensure that you use only the root certificate, and not the other certificates listed. The SharePoint Trusted Root Authorities list should only list root certificates.

For more information, see New-SPTrustedRootAuthority.

Configure a mobile account

You can configure a mobile account for a server farm or for a specific web application, by using either Central Administration or Windows PowerShell.

Note:

If you cannot configure a mobile account, you might have the wrong certificate file. In that case, contact your service provider.

To configure or edit a mobile account for a server farm by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To configure a mobile account for a server farm, you must be a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

  2. On the Central Administration home page, click System Settings.

  3. On the System Settings page, in the E-Mail and Text Messages (SMS) section, click Configure mobile account.

  4. On the Mobile Account Settings page, in the Text Message (SMS) Service Settings section, click the Microsoft Office Online link to access a list of service providers.

  5. On the service provider page, in the Choose your wireless service provider's country/region list, select the country or region in which your wireless service provider is located.

  6. On the service provider page, in the Choose your current wireless service provider list, select the wireless service provider that you want to use.

    After you make this selection, you are directed to the website of the service provider that you selected. On the website, you apply for the SMS service. When you receive the required information from the service provider, return to the Mobile Accounts Settings page.

  7. In the The URL of Text Message (SMS) Service box, type the URL of the SMS service.

    Note:

    Ensure that the service URL you enter is an HTTPS URL.

  8. In the User Name box and Password box, type the user name and password that you received from the SMS service provider.

  9. To confirm that the URL and user credentials are correct, click Test Service.

  10. Click OK.

To configure or edit a mobile account for a server farm by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin. Additionally, you must be a member of the Farm Administrators group and a member of the Administrators group on the local computer that is running Windows PowerShell.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPMobileMessagingAccount -Identity sms -WebApplication <WebApplicationUrl> [-ServiceUrl <ServiceUrl>] [-UserId <UserId>] [-Password <Password>]

    Where:

    • <WebApplicationUrl> is the Central Administration URL.

    • <ServiceUrl> is the URL to server where the SMS service is located.

    • <UserId> is the user name that you received from the SMS service provider.

    • <Password> is the user password that you received from the SMS service provider.

    Example

    Copy code
    Set-SPMobileMessagingAccount -Identity sms -WebApplication http://myserver:8080 -ServiceUrl https://www.example.com/omsservice.asmx -UserId someone@example.com -Password password1

    Or, if you use the pipeline operator, type the following command:

    Copy code
    Get-SPWebApplication -Identity http://myserver:8080 | Set-SPMobileMessagingAccount -Identity sms -ServiceUrl https://www.example.com/omsservice.asmx -UserId someone@example.com -Password password1
    Note:

    Ensure that the service URL you enter is an HTTPS URL.

For more information, see and Get-SPWebApplication.

To configure or edit a mobile account for a web application by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To configure a mobile account for a server farm, you must be a member of the Farm Administrators group on the computer that is running Central Administration.

  2. On the Central Administration home page, in the Application Management section, click Manage web applications.

  3. On the Web Applications page, select the web application for which you want to configure a mobile account. In General Settings on the ribbon, click Mobile Account.

  4. On the Web Application Text Message (SMS) Service Settings page, in the Text Message (SMS) Service Settings section, click the Microsoft Office Online link to access a list of service providers.

  5. On the service provider page, in the Choose your wireless service provider's country/region list, select the country or region in which your wireless service provider is located.

  6. On the service provider page, in the Choose your current wireless service provider list, select the wireless service provider that you want to use.

    After you make this selection, you are directed to the website of the service provider that you selected. On the website, you apply for the SMS service. When you receive the required information from the service provider, return to the Mobile Accounts Settings page and type the information.

  7. In the The URL of Text Message (SMS) Service box, type the URL of the SMS service.

    Note:

    Ensure that the service URL you enter is an HTTPS URL.

  8. In the User Name box and Password box, type the user name and password that you received from the SMS service provider.

  9. To confirm that the URL and user credentials are correct, click Test Service.

  10. Click OK.

To configure or edit a mobile account for a web application by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin. Additionally, you must be a member of the Farm Administrators group and a member of the Administrators group on the local computer that is running Windows PowerShell.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command:

    Copy code
    Set-SPMobileMessagingAccount -Identity sms -WebApplication <WebApplicationUrl> [-ServiceUrl <ServiceUrl>] [-UserId <UserId>] [-Password <Password>]

    Where:

    • <WebApplicationUrl> is the web application URL.

    • <ServiceUrl> is the URL to server where the SMS service is located.

    • <UserId> is the user name that you received from the SMS service provider.

    • <Password> is the user password that you received from the SMS service provider.

    Example

    Copy code
    Set-SPMobileMessagingAccount -Identity sms -WebApplication http://localhost -ServiceUrl https://www.example.com/omsservice.asmx -UserId someone@example.com -Password password1

    Or, if you use the pipeline operator, type the following command:

    Copy code
    Get-SPWebapplication -Identity http://localhost | Set-SPMobileMessagingAccount -Identity sms -ServiceUrl https://www.example.com/omsservice.asmx -UserId someone@example.com -Password password1
    Note:

    Ensure that the service URL you enter is an HTTPS URL.

For more information, see Set-SPMobileMessagingAccount and Get-SPWebApplication.

Retrieve mobile account information

You can retrieve mobile account information for a server farm or for a web application by using Windows PowerShell. You might want to do this to view the mobile account information or, for example, to verify that the set cmdlet works correctly.

To retrieve mobile account information for a server farm by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin. Additionally, you must be a member of the Farm Administrators group and a member of the Administrators group on the local computer that is running Windows PowerShell.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPMobileMessagingAccount -WebApplication <WebApplicationUrl>

    Where <WebApplicationUrl> is the Central Administration URL.

    Example

    Copy code
    Get-SPMobileMessagingAccount -WebApplication http://myserver

    Or, if you use the pipeline operator, type the following command:

    Copy code
    Get-SPWebApplication -Identity http://myserver | Get-SPMobileMessagingAccount -AccountType sms

For more information, see Get-SPMobileMessagingAccount and Get-SPWebApplication.

To retrieve mobile account information for a web application by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin. Additionally, you must be a member of the Farm Administrators group and a member of the Administrators group on the local computer that is running Windows PowerShell.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPMobileMessagingAccount -WebApplication <WebApplicationUrl>

    Where <WebApplicationUrl> is the web application URL.

    Example

    Copy code
    Get-SPMobileMessagingAccount -WebApplication http://localhost

    Or, if you use the pipeline operator, type the following command:

    Copy code
    Get-SPWebApplication -Identity http://localhost | Get-SPMobileMessagingAccount -AccountType sms

For more information, see Get-SPMobileMessagingAccount and Get-SPWebApplication.

Delete a mobile account

You can delete a mobile account for a server farm or for a web application. This makes the account unavailable so that users can no longer subscribe to SMS alerts. However, it does not delete the account that you set up with the service provider. You might want to delete a mobile account if, for example, the organization decides that there is no business value in sending out SMS alerts to users.

Note:

There is no equivalent Windows PowerShell functionality.

To delete a mobile account for a server farm

  1. Verify that you have the following administrative credentials:

    • To delete a mobile account for a server farm, you must be a member of the Farm Administrators group on the computer that is running Central Administration.

  2. On the Central Administration home page, click System Settings.

  3. On the System Settings page, in the E-mail and Text Messages (SMS) section, click Configure mobile account.

  4. On the Mobile Account Settings page, clear entries from all the boxes, and then click OK.

To delete a mobile account for a web application

  1. Verify that you have the following administrative credentials:

    • To delete a mobile account for a server farm, you must be a member of the Farm Administrators group on the computer that is running Central Administration.

  2. On the Central Administration home page, in the Application Management section, click Manage web applications.

  3. In General Settings on the ribbon, click Mobile Account.

  4. On the Web Application Text Message (SMS) Service Settings page, delete entries from all the boxes, and then click OK.

See also

Configure the browser definition file in SharePoint 2013


Configure the browser definition file in SharePoint 2013
See also

Summary: Learn how to modify the browser definition file in SharePoint 2013 to change the redirect behavior of a mobile browser, or add or delete mobile device entries.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

A mobile view is a version of the SharePoint site that has been optimized for mobile devices. The browser definition file lists the mobile browsers and devices that are supported by SharePoint Server 2013 and is used to redirect mobile browsers to the mobile views. You can modify the browser definition file to change the redirect behavior of a mobile browser, or to add or delete entries from the list of supported mobile devices.

Modify the browser definition file (compat.browser)

The browser definition file lists the mobile browsers and devices that can access mobile views in SharePoint Server 2013. When a user browses a SharePoint site from a mobile device, the mobile browser submits to the site an HTTP GET request that includes a user agent string. If the mobile browser and device model in the user agent string are listed in the browser definition file and the isMobileDevice setting for the mobile browser is set to true, SharePoint Server 2013 redirects the mobile browser to the mobile view of the site. Otherwise, a standard view of the site is shown in the mobile browser. You can modify the file to change the redirect behavior of a mobile browser.

The browser definition file lists the mobile browsers and devices that are supported by SharePoint Server 2013. The file can be updated when product updates to SharePoint Server 2013 are released. You can also modify the file to add a mobile browser or device to the list.

Note:

There is a compat.browser file for each Internet Information Services (IIS) website. If you change the compat.browser file on a SharePoint Web front-end (WFE) server you must also do so on every WFE in the farm.

To change the redirect behavior of a mobile browser

  1. Click Start, click Administrative Tools, and then Internet Information Services (IIS) Manager.

  2. Right-click the IIS website where the SharePoint web application is installed, and then click Explore.

  3. In Windows Explorer, double-click the App_Browsers folder.

  4. Open the compat.browser file in a text editor.

  5. Find the <browser> node that corresponds to the mobile browser or device that you want to modify.

  6. Find the <capability name="isMobileDevice" value="true" /> element.

  7. Set the value attribute to false to display a standard view of the site in the mobile browser.

  8. Save your changes to the compat.browser file.

  9. Restart IIS by entering the following command at the command prompt: iisreset /noforce.

To add a mobile browser or device, you create a <browser> node that identifies the mobile browser or device and defines its capabilities. For more information about what can be entered in the <browser> node, see Browser Definition File Schema (browsers Element) in the MSDN Library.

To add a mobile browser and device model

  1. Click Start, click Administrative Tools, and then click Internet Information Services (IIS) Manager.

  2. Right-click the IIS website where the SharePoint web application is installed, and then click Explore.

  3. In Windows Explorer, double-click the App_Browsers folder.

  4. Open the compat.browser file in a text editor.

  5. Find the <browsers> node.

  6. Add a new <browser> node to the end of the list of browsers.

  7. Save your changes to the compat.browser file.

  8. Restart IIS by entering the following command at the command prompt: iisreset /noforce.

See also

Configure mobile accounts in SharePoint 2013


Configure external access for mobile devices in SharePoint 2013
See also

Summary: Learn how to access SharePoint 2013 on mobile devices external to a network.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Mobile device users can access a SharePoint site either by using a mobile browser or by using a rich client application. This article describes how to make SharePoint sites available for mobile devices when the devices are used outside the corporate firewall. There are three methods for enabling external access:

  • Reverse proxy server A reverse proxy server that supports Secure Sockets Layer (SSL), such as Microsoft Forefront Unified Access Gateway (UAG), enables you to publish SharePoint sites across the corporate firewall. The following steps summarize how to make a SharePoint site available from outside the corporate firewall when you use a reverse proxy server:

    • Set up and configure the reverse proxy server such as UAG.

    • Publish the SharePoint site on the reverse proxy server.

    • Configure an alternate access mapping for the SharePoint site.

    • Add the SharePoint site to a zone that allows for cross-firewall access. For more information about cross-firewall access, see Configure cross-firewall access later in this article.

    Note:

    For more information about Forefront UAG such as planning and deployment guidance, see Forefront Unified Access Gateway (UAG) and SharePoint publishing solution guide in the Forefront Technical Library.

  • Mobile proxy server Mobile proxy servers can help mobile devices work within the IT infrastructure of a company. To access a SharePoint site from outside the corporate firewall, the mobile proxy server must pass the mobile browser's HTTP headers directly through to SharePoint Server 2013.

  • Direct Internet access The SharePoint site can be placed on the extranet. This method supports only basic authentication. We recommend that you use a combination of technology and policy safeguards, such as SSL, with any Internet-facing servers.

Configure cross-firewall access

After the SharePoint site is published outside the firewall, you must add the site to a zone that allows for cross-firewall access. A cross-firewall access zone is used to generate external PC and mobile URLs in mobile alert messages, and enables users to send an externally available URL when they click the E-mail a link or Alert Me button on the ribbon.

To configure a cross-firewall access zone

  1. Verify that you have the following administrative credentials:

    • You must be a member of the Farm Administrators group.

  2. In Central Administration, click System Settings.

  3. On the System Settings page, under Farm Management, click Configure cross firewall access zone.

  4. On the Cross Firewall Access Zone page, in Web Application, in the Web Application list, select the web application that is published across the firewall.

  5. In Cross Firewall Access Zone, in the Zone selection for cross firewall access list, select the zone that is published across the firewall.

See also

Configure mobile accounts in SharePoint 2013


Use the location field type in mobile applications for SharePoint 2013

Summary: Learn how to work with the new SharePoint 2013 location field type for mobile application development.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint Server 2013 introduces a new geolocation field type that can be used in a list. For example, you can now make lists "location-aware" and display latitude and longitude coordinates through Bing Maps. An entry is typically seen as a pushpin on the map view. Although there are several ways to use this geolocation field, one key scenario is for mobile application development. Users can track or log location-specific data while they work remotely from the corporate office. Or, the application can help users locate points of interest when they perform offsite functions. To display map views in the list, you must use the Bing Maps service.

The geolocation field is not available when you create a list through the user interface (UI). Therefore, you cannot make a custom list and add it as a column through traditional UI methods. Instead, this field must be inserted programmatically. This article does not explain how to render the geolocation field, or provide developer guidance for creating a location-based mobile application. It provides instruction for displaying map views by using Bing Maps. For information about how to render and work with this data type programmatically, see Integrating location and map functionality in SharePoint 2013.

There is an msi package named SQLSysClrTypes.msi that must be installed on every SharePoint front-end web server to view the geolocation field value or data in a list. This package is responsible for installing the components for implementing the new geometry, geography, and hierarchyid types in SQL Server 2008. By default, this file is installed for SharePoint Online. However, it is not for an on-premises deployment of SharePoint Server 2013. You must be a member of the Farm Administrators group to perform this operation. To download SQLSysClrTypes.msi, see Microsoft SQL Server 2008 R2 SP1 Feature Pack for SQL Server 2008, or Microsoft SQL Server 2012 Feature Pack for SQL Server 2012 in the Microsoft Download Center.

In this article:

  • Use Bing Maps for Map Views

  • Apply the Bing Maps key at the farm level

  • Apply the Bing Maps key at the website level

Use Bing Maps for Map Views

You must register with Bing Maps to view location-based data that uses the geolocation field. You need to create a developer account, and create a key for authentication to Bing Maps. If you do not register and apply the key, you will receive an error message when you view map data on the control. To register, see Bing Maps.

The Bing Maps key can be applied to the farm level, website level, or application level. The following table provides the Windows PowerShell for SharePoint Server 2013 cmdlets that are available for configuring Bing Maps.

Table: Windows PowerShell cmdlets for configuring Bing Maps

Cmdlet | Description | Usage example
Set-SPBingMapsKey | Allows you to set the Bing Maps key to the farm level. | Set-SPBingMapsKey -BingKey < Your Bing Maps Key>
Get-SPBingMapsKey | Retrieves the Bing Maps key. | Get-SPBingMapsKey
Set-SPBingMapsBlock | Specifies whether to block Bing Maps in all locales, or not to block them in all locales. Bing Maps will be displayed in non-restricted locales if this property is not set. The default value is 0 (not blocked). Use a value of 1 to block in all locales. | Set-SPBingMapsBlock1
Get-SPBingMapsBlock | Returns true or false on whether Bing Maps are blocked in all locales. This cmdlet will return an object, and "BlockBingMaps" property will return True or False. | Get-SPBingMapsBlock

Apply the Bing Maps key at the farm level

Use this procedure to apply the Bing Maps key at the farm level. Also, this procedure includes a verification step to ensure the key was applied.

To apply the Bing Maps key at the farm level

  1. Verify that the user account that is performing this procedure has the necessary permissions to use SharePoint Server 2013 cmdlets.

    Important:

    To run a Windows PowerShell for SharePoint Server 2013 cmdlet:

    1. Verify that you are a member of the following security roles or groups:

      • securityadmin fixed server role on the SQL Server instance.

      • db_owner fixed database role on all databases that are to be updated.

      • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

      • Add memberships that are required beyond the minimums above.

    2. An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint Server 2013 cmdlets.

    For more information about SharePoint cmdlet permissions, see "Permissions" in SharePoint 2010 Products administration by using Windows PowerShell in the Search Server 2010 Technical Library.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To apply the Bing Maps key, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPBingMapsKey -BingKey <Bing Maps Key>

    Where <Bing Maps Key> is the Bing Maps key you received after registering with Bing Maps.

  4. To verify the key was applied, at the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPBingMapsKey

Apply the Bing Maps key at the website level

Use this procedure to apply the Bing Maps key at the website level.

To apply the Bing Maps key at the website level

  1. Verify that the user account that is performing this procedure has the necessary permissions to use SharePoint Server 2013 cmdlets as explained in step 1 in the previous section.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. To apply the Bing Maps key, at the Windows PowerShell command prompt, enter the following code:

    Copy code
    $ServerName = "<SharePoint Server>"
$site = new-object Microsoft.SharePoint.SPSite($ServerName)
$web = $site.rootweb
$web.AllProperties["BING_MAPS_KEY"] = "<Your Bing Maps key>"
$web.Update()

    Where:

    • <SharePoint Server> is the name of the computer that is running SharePoint Server 2013.

    • <Your Bing Maps key> is the Bing Maps key that you receive after you register with Bing Maps.


Clear push notification registrations from the subscription store in SharePoint 2013
See also

Summary: Learn how to make room for more applications and devices by clearing the push notification subscription store on a SharePoint 2013 site.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

SharePoint Server 2013 supports applications on mobile devices that receive push notifications from a SharePoint site. Notifications can include events that occur in the site, such as when a user adds an item to a list or updates an item. When the push notification feature is activated, a subscription store is created at the website level to store information from devices that have registered with the SharePoint site to receive notifications. This subscription store is created as a hidden list that cannot be viewed directly by a user or an administrator. When the device application registers to receive notifications or unregisters from receiving notifications on the SharePoint site, a device entry is either added or deleted in the list based on the request.

Important:

To enable mobile device registration on a site, the push notifications feature must be activated. Previously, you could activate or deactivate push notifications in the site settings under Site Actions and Manage Site Features. However, the option to enable is not available through Manage Site Features in this release, and must be programmatically activated. The below section Activate push notifications will detail how to enable the feature. For more information about the Windows Phone push notifications development model including sample register and unregister API usage, see Push notifications in SharePoint apps for Windows Phone.

There might be a scenario where a user registers to receive notifications through an application, but then the user no longer uses the application or device, or the user uninstalls the application from the device. If the unregister API is not called from the application, the device entry will still exist in the subscription store. There is a limit of 2,000 device registrations for push notifications in SharePoint Server 2013. Once this limit is reached, no further registrations can be performed unless entries are cleared from the subscription store. This article provides the procedures necessary to clear specific device entries that have not been updated in the subscription store for 30 days, or the entire contents of the subscription store based on preference.

In this article:

  • Activate push notifications

  • Delete select registrations from the subscription store

  • Delete all registrations from the subscription store

Activate push notifications

In SharePoint Server 2013 the push notifications feature must be enabled in order for devices to receive SharePoint-based push notifications. You can enable the feature by using a SharePoint Server 2013 cmdlet, or through a client application. The following steps provide instruction on how to enable the feature using the Windows PowerShell cmdlet.

To activate the push notifications feature

  1. Verify that the user account that is performing this procedure has the necessary permissions to use SharePoint Server 2013 cmdlet or scripting.

    Important:

    To run a Windows PowerShell for SharePoint Server 2013 cmdlet or script:

    1. Verify that you are a member of the following security roles or groups:

      • securityadmin fixed server role on the SQL Server instance.

      • db_owner fixed database role on all databases that are to be updated.

      • Administrators group on the server on which you are running the Windows PowerShell cmdlets or scripts.

      • Add memberships that are required beyond the minimums above.

    2. An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint Server 2013 cmdlets or scripts. Also, the default execution policy for scripts in SharePoint 2013 is set to Restricted. You must adjust the execution policy setting in order to run scripts. For more information, see Scripts and execution policies in SharePoint 2010 Products administration by using Windows PowerShell.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. To activate the push notifications feature, at the Windows PowerShell command prompt, enter the following code:

    Copy code
    Enable-SPFeature -Identity 41e1d4bf-b1a2-47f7-ab80-d5d6cbba3092 -URL <YOUR SITE URL>

    Where <YOUR SITE URL> is the URL of your SharePoint site.

Delete select registrations from the subscription store

Use this procedure to remove device registrations from the subscription store that have not been updated in 30 days. It is implied that devices that have not connected to the computer that is running SharePoint Server by using the register API in that time frame are considered inactive, and should be marked for deletion. However, this time limit of 30 days can also be adjusted through the OffsetDays attribute in the following script based on preference.

Important:

This cleanup process will also clear device preferences that might have been set in the registration information. For more information about the Windows Phone push notifications development model including sample register and unregister API usage, see Push notifications in SharePoint apps for Windows Phone.

To delete select registrations from the subscription store

  1. Verify that the user account that is performing this procedure has the necessary permissions to use SharePoint Server 2013 cmdlets as explained in step 1 in the section Activate push notifications.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. To delete select registrations that have not been updated in 30 days, at the Windows PowerShell command prompt, enter the following code:

    Copy code
    $web = Get-SPWeb "<YOUR SITE URL>"
$store = $web.Lists["Push Notification Subscription Store"]
$spQuery = New-Object Microsoft.SharePoint.SPQuery
$spQuery.Query = '<Where><Lt><FieldRef Name="Modified" /><Value Type="DateTime"><Today OffsetDays="-30" /></Value></Lt></Where>'
$oldItems = $store.GetItems($spQuery)
foreach ($item in $oldItems) { $store.Items.DeleteItemById($item.Id) }
write-output "Successfully deleted all old subscriptions"

    Where <YOUR SITE URL> is the URL of your SharePoint site.

Delete all registrations from the subscription store

Use this procedure to remove all registrations or subscriptions from the push notifications subscription store.

To delete all registrations from the subscription store

  1. Verify that the user account that is performing this procedure has the necessary permissions to use SharePoint Server 2013 cmdlets as explained in step 1 in the section Activate push notifications.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. To delete all device registrations or subscriptions, at the Windows PowerShell command prompt, enter the following code:

    Copy code
    write-output "Delete all push notification subscribers"
$web = Get-SPWeb "<YOUR SITE URL>"
$spList = $web.Lists["Push Notification Subscription Store"]
write-output "Got the Subscription Store"
foreach ($item in $spList.items)
{
    $itemToDelete=$spList.GetItemById($item.ID)
    $ itemToDelete.Delete()
}
write-output "Successfully deleted all subscribers"

    Where <YOUR SITE URL> is the URL of your SharePoint site.

See also

Administer mobile devices in SharePoint 2013


Administer the User Profile service in SharePoint Server 2013

Published: October 11, 2012

Summary: Learn how to administer the User Profile service in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The User Profile service is a shared service in SharePoint Server 2013 that enables the creation and administration of user profiles that can be accessed from multiple sites and farms. Administration of User Profile service applications in SharePoint Server 2013 can be delegated to a service application administrator by the farm administrator. For more information, see About service applications and services in SharePoint 2013.

The following articles on TechNet and related resources provide information about how to administer the User Profile service application in SharePoint Server 2013.

TechNet articles about how to administer the User Profile service application in SharePoint Server 2013

The following articles about how to administer the User Profile service application in SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Create, edit, or delete User Profile service applications in SharePoint Server 2013 | Learn how to configure a User Profile service application in SharePoint Server 2013.
 | Delegate administration of User Profile service applications in SharePoint Server 2013 | Learn how to delegate administration of a User Profile service application to a service application administrator in SharePoint Server 2013.
 | Delegate administration of User Profile service application features in SharePoint Server 2013 | Learn how to delegate administration of a User Profile service application or selected features of a User Profile service application to a service application administrator in SharePoint Server 2013.
 | Delegate administration of SharePoint Server 2013 user profiles | Learn how to delegate administration of user profiles to a feature administrator in SharePoint Server 2013.
 | Remove administrators from User Profile service applications in SharePoint Server 2013 | Learn how to remove a service application administrator from a User Profile service application in SharePoint Server 2013.
 | Add, edit, or delete custom properties in SharePoint Server 2013 user profiles | Learn how to create, edit, and delete user profile properties in SharePoint Server 2013.
 | Manage user profile synchronization in SharePoint Server 2013 | Learn about articles and worksheets to help you manage User Profile synchronization in SharePoint Server 2013.

Additional resources about how to administer the User Profile service application in SharePoint Server 2013

The following resources about how to administer the User Profile service application in SharePoint Server 2013 are available from other subject matter experts.

 | Content | Description
TechNet logo | SharePoint 2013 for IT Pros | Visit the TechCenter to access videos, Community Sites, documentation, and more.


Create, edit, or delete User Profile service applications in SharePoint Server 2013
See also

Summary: Learn how to configure a User Profile service application in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The User Profile service is a shared service in SharePoint Server 2013 that provides a central location for configuring and managing the following personalization settings:

  • User profile properties

  • Audiences

  • Profile synchronization settings

  • Organization browsing and administration settings

  • My Site settings

This article contains required information and procedures for configuring a User Profile service application.

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Before you begin

  • Create a User Profile service application

  • Edit a User Profile service application

  • Delete a User Profile service application

Before reading this article, you should understand the concepts described in Overview of the User Profile service application in SharePoint Server 2013.

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • Your system is running either the Standard or Enterprise version of SharePoint Server 2013.

  • An instance of the managed metadata Service exists. For more information, see Overview of managed metadata service applications in SharePoint Server 2013.

  • A managed path exists. For more information, see Define managed paths in SharePoint Server 2013.

  • An application pool for My Sites exists. For more information, see the Application pools section of Logical architecture components (SharePoint Server 2010).

  • A site collection that uses the My Site Host template exists. For more information, see Overview of sites and site collections in SharePoint 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Create a User Profile service application

Individual services that are deployed in a SharePoint Server 2013 farm are named service applications. A service application provides a resource that can be shared across sites throughout a farm, and can be accessed by users through a service application connection to a web application.

You can create a User Profile service application by using either the SharePoint Central Administration website or Windows PowerShell.

To create a User Profile Service application by using Central Administration

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On Central Administration, in the Application Management section, click Manage service applications.

  4. On the Manage Service Applications page, click the Service Applications tab to enable the ribbon.

  5. In the Create group of the ribbon, click New, and then click User Profile Service Application in the list of service applications to create.

  6. In the Create New User Profile Service Application dialog box, in the Name section, type a unique name for the User Profile service application.

  7. In the Application Pool section, select Use existing application pool to choose an existing application pool from the list or select Create a new application pool to create a new application pool. For information about when to choose an existing application pool or create a new one, see Managing Application Pools in IIS 7.

  8. In the Application Pool section, for the Select a security account for this application pool option, select Predefined to choose an existing predefined security account from the list or select Configurable to choose an existing managed account.

  9. In the Profile Database section, in the Database Server box, type the name of the database server where you want to create the profile database. In the Database Name box, type the name that you want to use for the profile database.

  10. In the Profile Database section, for the Database authentication option, select Windows Authentication (recommended) to use Integrated Windows authentication to connect to the profile database or select SQL authentication to enter the credentials that will be used to connect to the profile database.

  11. In the Failover Server section, in the Failover Database Server box, type the name of the database server to be used together with SQL Server database mirroring.

  12. In the Synchronization Database section, in the Database Server box, type the name of the database server where you want to create the synchronization database. In the Database Name box, type the name of the synchronization database.

    Note:

    Only ASCII characters are allowed for the synchronization database name.

    Note:

    If connecting to an existing or restored synchronization database, you must wait at least 2 minutes after you start the Sync service before importing the FIM key.

  13. In the Synchronization Database section, for the Database authentication option, select Windows Authentication (recommended) to use Integrated Windows authentication to connect to the synchronization database or select SQL authentication to type the credentials that will be used to connect to the synchronization database.

  14. In the Failover Server section, in the Failover Database Server box, type the name of the database server to be used together with SQL Server database mirroring.

  15. In the Social Tagging Database section, in the Database Server box, type the name of the database server where the social tagging database will be located. In the Database Name box, type the name of the database where social tags will be stored.

  16. In the Social Tagging Database section, for the Database authentication option, select Windows Authentication (recommended) to use Integrated Windows authentication to connect to the social tagging database or select SQL authentication to type the credentials that will be used to connect to the social tagging database.

  17. In the Failover Server section, in the Failover Database Server box, type the name of the database server that you want to use with SQL Server database mirroring.

    Important:

    In the Profile Synchronization Instance section, ignore this setting because this selection is ignored when profile synchronization is configured.

  18. In the My Site Host URL section, type the URL of the site collection where the My Site Host is provisioned.

  19. In the My Site Managed Path section, type the managed path where you want to create individual My Sites.

    Note:

    Self-service site creation can be enabled for the web application that hosts My Sites. Users must have Create Personal Site permissions to create their own My Site. By default, this permission is enabled in SharePoint Server 2013 for all authenticated users. Ensure that you want the default setting to apply to the organization. Or, you can use one or more security groups to grant the Create Personal Site permission to a subset of users in an organization. For more information about self-service site creation, see Turn on or turn off self-service site creation (SharePoint Server 2010).

  20. In the Site Naming Format section, select one of the following formats for naming new personal sites:

    • User name (do not resolve conflicts)

    • User name (resolve conflicts by using domain_user name)

    • Domain and user name (will not have conflicts)

  21. In the Default Proxy Group section, select whether you want the proxy of this User Profile service application to be a part of the default proxy group on this farm.

To create a User Profile service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $app_UPA = New-SPProfileServiceApplication -Name UPA -PartitionMode  -ApplicationPool $appPool

    Where:

    • <ParameterValue> is <the value of the parameter>.

    • <ParameterValue> is <the value of the parameter>.

For more information, see New-SPProfileServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Edit a User Profile service application

Perform the following procedure to edit a User Profile service application.

To edit a User Profile service application

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Farm Administrators SharePoint group.

  2. On Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the Type column, click User Profile Service Application to highlight the row.

  4. In the Operations group of the ribbon, click Properties.

  5. In the Edit User Profile Service Application dialog box, edit the properties for which you want to make changes, and then click OK.

Delete a User Profile service application

Perform the following procedure to delete a User Profile Service application.

To delete a User Profile service application

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Farm Administrators SharePoint group.

  2. On Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the Type column, click the User Profile service application that you want to delete to highlight the row.

  4. In the Operations group of the ribbon, click Delete.

  5. In the Delete Service Application dialog box, verify that you have selected the correct User Profile service application to delete. If you want, select Delete data associated with the Service Applications to delete all data associated with the selected User Profile service application.

  6. Click OK.

See also

Administer the User Profile service in SharePoint Server 2013
Overview of the User Profile service application in SharePoint Server 2013
Plan user profiles in SharePoint Server 2013
Delegate administration of SharePoint Server 2013 user profiles
Delegate administration of User Profile service applications in SharePoint Server 2013
Delegate administration of User Profile service application features in SharePoint Server 2013


Delegate administration of User Profile service applications in SharePoint Server 2013
See also

Summary: Learn how to delegate administration of a User Profile service application to a service application administrator in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Farm administrators can delegate administration of a specific User Profile service application to a service application administrator. A service application administrator can perform all of the administrative tasks related to that User Profile service application, but can't manage other service applications or settings contained in Central Administration. For more information, see Overview of the User Profile service application in SharePoint Server 2013.

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Before you begin

  • Delegate administration of a User Profile service application by using Central Administration

  • Delegate administration of a User Profile service application by using Windows PowerShell

Before you begin

Before you begin this task, review the following information about prerequisites:

  • A User Profile service application is running in the farm.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Delegate administration of a User Profile service application by using Central Administration

You typically use the SharePoint Central Administration website to delegate administration of a User Profile service application in a small deployment, such as a single-server deployment, or in an environment where you don't have to automate the task.

To delegate administration of a User Profile service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On Central Administration, in the Application Management section, click Manage service applications.

  4. In the list of service applications, click User Profile Service Application.

  5. On the Service Applications tab, in the Operations section, click Administrators.

  6. On the Administrators for User Profile Service Application page, type or select a user or group account and then click Add.

  7. In the Permissions for Administrator: box, check the Full Control permission level, and then click OK.

Delegate administration of a User Profile service application by using Windows PowerShell

You typically use Windows PowerShell to delegate administration of a User Profile service application when you want to automate the task, which is common in enterprises.

To delegate administration of a User Profile service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • Securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, do the following:

    1. To display a list of all service applications and their GUIDs, type the following command:

      Copy code
      Get-SPServiceApplication

    2. To create a variable that contains the GUID for the User Profile service for which you want to delegate Full Control, type the following command:

      Copy code
      $serviceapp = Get-SPServiceApplication <guid>

      Where <guid> is the GUID for the User Profile service for which you want to delegate Full Control.

    3. To create a variable that contains the list of administrators for the service application, type the following command:

      Copy code
      $security = Get-SPServiceApplicationSecurity $serviceapp -Admin

    4. To create a variable that contains the claims principal for a user account, type the following command:

      Copy code
      $principalUser1 = New-SPClaimsPrincipal -Identity "<domain\user>" -IdentityType WindowsSamAccountName

      Where <domain\user> is the user to whom you want to delegate Full Control.

    5. To give Full Control permissions to the claims principal you just created, type the following command:

      Copy code
      Grant-SPObjectSecurity $security -Principal $principalUser1 -Rights "Full Control"

    6. To apply the changes to the User Profile service application, type the following command:

      Copy code
      Set-SPServiceApplicationSecurity $serviceapp -ObjectSecurity $security -Admin

For more information, see Get-SPServiceApplication, Get-SPServiceApplicationSecurity, New-SPClaimsPrincipal, Grant-SPObjectSecurity, and Set-SPServiceApplicationSecurity.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Administer the User Profile service in SharePoint Server 2013
Delegate administration of User Profile service applications in SharePoint Server 2013
Overview of the User Profile service application in SharePoint Server 2013
Windows PowerShell for SharePoint 2013 reference


Delegate administration of User Profile service application features in SharePoint Server 2013
See also

Summary: Learn how to delegate administration of a User Profile service application or selected features of a User Profile service application to a service application administrator in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Farm administrators can delegate administration of either a User Profile service application or selected features of a User Profile service application to a service application administrator. A service application administrator can delegate administration of a feature or features of a User Profile application service to another user, who is known as a feature administrator. A feature administrator can perform all administrative tasks that are related to the delegated feature or features. A feature administrator cannot manage other features, service applications, or settings that are contained in Central Administration. For more information, see Overview of the User Profile service application in SharePoint Server 2013.

Any of the following features of a User Profile service application can be delegated to a feature administrator:

  • Manage Profiles

  • Manage Audiences

  • Manage Permissions

  • Retrieve People Data for Search Crawlers

  • Manage Social Data

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Before you begin

  • Delegate administration of User Profile service features by using Central Administration

  • Delegate administration of User Profile service features by using Windows PowerShell

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • A User Profile service application is running in the farm.

  • An instance of the managed metadata service exists. For more information, see Overview of managed metadata service applications in SharePoint Server 2013.

  • The user or group to which you want to assign administration of User Profile service features is stored in the profile database.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Delegate administration of User Profile service features by using Central Administration

You typically use the SharePoint Central Administration website to delegate administration of User Profile service features in a stand-alone deployment.

To delegate administration of User Profile service features by using Central Administration

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Farm Administrators SharePoint group or has been delegated permission to administer the User Profile service application that is running in the farm.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

  3. In Central Administration, in the Application Management section, click Manage service applications.

  4. In the list of service applications, click User Profile Service Application.

  5. On the Service Applications tab, in the Operations group, click Administrators.

  6. On the Administrators for User Profile Service Application page, type or select a user or group account, and then click Add.

  7. In the Permissions for Administrator: box, check the feature or features for which you want to delegate administration, and then click OK.

Delegate administration of User Profile service features by using Windows PowerShell

You typically use Windows PowerShell to delegate administration of User Profile service features when you want to automate the task, which is common in enterprises.

To delegate administration of User Profile service features by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    1. To display a list of all service applications and their GUIDs, type the following command:

      Copy code
      Get-SPServiceApplication

    2. To create a variable that contains the GUID for the User Profile service for which you want to delegate Full Control, type the following command:

      Copy code
      $serviceapp = Get-SPServiceApplication <guid>

      Where <guid> is the GUID for the User Profile service for which you want to delegate Manage Social Data permissions.

    3. To create a variable that contains the list of administrators for the service application, type the following command:

      Copy code
      $security = Get-SPServiceApplicationSecurity $serviceapp -Admin

    4. To create a variable that contains the claims principal for a user account, type the following command:

      Copy code
      $principalUser1 = New-SPClaimsPrincipal -Identity "<domain\user>" -IdentityType WindowsSamAccountName

      Where <domain\user> is the user to whom you want to delegate Manage Social Data permissions.

    5. To give Manage Social Data permissions to the claims principal you just created, type the following command:

      Copy code
      Grant-SPObjectSecurity $security -Principal $principalUser1 -Rights "Manage Social Data"

    6. To apply the changes to the User Profile service application, type the following command:

      Copy code
      Set-SPServiceApplicationSecurity $serviceapp -ObjectSecurity $security -Admin

For more information, see Get-SPServiceApplication, Get-SPServiceApplicationSecurity, New-SPClaimsPrincipal, Grant-SPObjectSecurity, Set-SPServiceApplicationSecurity, and Set-SPProfileServiceApplicationSecurity.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Administer the User Profile service in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013


Delegate administration of SharePoint Server 2013 user profiles
See also

Summary: Learn how to delegate administration of user profiles to a feature administrator in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Farm administrators or service application administrators of a User Profile service application can delegate administration of user profiles to a feature administrator. A feature administrator can manage all settings for user profiles. A feature administrator cannot manage settings for other features or for the whole User Profile service application. A feature administrator can be either a user or a group. For more information, see Overview of the User Profile service application in SharePoint Server 2013.

Note:

Farm administrators can use Windows PowerShell to manage services. However, feature administrators cannot use Windows PowerShell for this purpose. Feature administrators must use Central Administration to manage features of the User Profile service.

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Before you begin

  • Delegate administration of user profiles by using Central Administration

  • Delegate administration of user profiles by using Windows PowerShell

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • A User Profile Service application is running in the farm. For more information, see Create, edit, or delete User Profile service applications in SharePoint Server 2013.

  • An instance of the managed metadata service exists. For more information, see Overview of managed metadata service applications in SharePoint Server 2013.

  • The user or group to which you want to assign administration of the User Profile service is stored in the profile database.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Delegate administration of user profiles by using Central Administration

You typically use the SharePoint Central Administration website to delegate administration of user profiles in a stand-alone deployment.

To delegate administration of user profiles by using Central Administration

  1. Verify that the user account that completes this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Farm Administrators SharePoint group or has been delegated permission to administer the User Profile service application that is running in the farm.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  4. In the list of service applications, click User Profile Service Application.

  5. On the Service Applications tab, in the Operations section, click Administrators.

  6. On the Administrators for User Profile Service Application page, type or select a user or group account and then click Add.

  7. In the Permissions for Administrator: box, check the Manage Profiles permission level, and then click OK.

Delegate administration of user profiles by using Windows PowerShell

You typically use Windows PowerShell to delegate administration of user profiles when you want to automate the task, which is common in enterprises.

Note:

Feature administrators cannot use Windows PowerShell to manage features of the User Profile service. Only Farm Administrators can use Windows PowerShell to manage features.

To delegate administration of user profiles by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, do the following:

    1. To display a list of all service applications and their GUIDs, type the following command:

      Copy code
      Get-SPServiceApplication

    2. To create a variable that contains the GUID for the User Profile service application, type the following command:

      Copy code
      $serviceapp = Get-SPServiceApplication <guid>

      Where <guid> is the GUID for the User Profile service application.

    3. To create a variable that contains the list of administrators for the service application, type the following command:

      Copy code
      $security = Get-SPServiceApplicationSecurity $serviceapp -Admin

    4. To create a variable that contains the claims principal for a user account, type the following command:

      Copy code
      $principalUser1 = New-SPClaimsPrincipal -Identity "<domain\user>" -IdentityType WindowsSamAccountName

      Where <domain\user> is the user to which you want to delegate administration for the Manage Profiles feature of the User Profile service application.

    5. To give Manage Profiles permissions to the claims principal that you just created, type the following command:

      Copy code
      Grant-SPObjectSecurity $security -Principal $principalUser1 -Rights "Manage Profiles"

    6. To apply the changes to the User Profile service application, type the following command:

      Copy code
      Set-SPServiceApplicationSecurity $serviceapp -ObjectSecurity $security -Admin

    For more information, see New-SPClaimsPrincipal, Get-SPServiceApplicationSecurity, New-SPClaimsPrincipal, Get-SPProfileServiceApplicationSecurity, Set-SPProfileServiceApplicationSecurity, and Grant-SPObjectSecurity.

See also

Administer the User Profile service in SharePoint Server 2013
Delegate administration of User Profile service applications in SharePoint Server 2013
Overview of the User Profile service application in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013


Remove administrators from User Profile service applications in SharePoint Server 2013
See also

Summary: Learn how to remove a service application administrator from a User Profile service application in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Farm administrators can remove a service application administrator from a User Profile service application. For example, the account for a user who leaves the organization should be removed from the list of service application administrators. Another reason for the removal is when a service application administrator is no longer required. For more information about administrators, see Choose administrators and owners for the administration hierarchy in SharePoint 2013.

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Before you begin

  • Remove an administrator from a User Profile service application by using Central Administration

  • Remove an administrator from a User Profile service application by using Windows PowerShell

Before you begin

Before you begin this task, review the following information about prerequisites:

  • A User Profile service application is running in the farm.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Remove an administrator from a User Profile service application by using Central Administration

You typically use the SharePoint Central Administration website to remove an administrator from a User Profile service application in a small deployment, such as a single-server deployment, or in an environment where you don't have to automate the task.

To remove an administrator from a User Profile service application by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On Central Administration, in the Application Management section, click Manage service applications.

  4. In the list of service applications, click User Profile Service Application.

  5. On the Service Applications tab, in the Operations group, click Administrators.

  6. On the Administrators for User Profile Service Application page, select a user or group account, click Remove, and then click OK.

Remove an administrator from a User Profile service application by using Windows PowerShell

You typically use Windows PowerShell to remove an administrator from a User Profile service application when you want to automate the task, which is common in enterprises.

To remove an administrator from a User Profile service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, do the following:

    • To get a list of all service applications and their GUIDs, type the following command:

      Copy code
      Get-SPServiceApplication

    • To create a variable that contains the GUID of the User Profile service application for which you want to remove an administrator, type the following command:

      Copy code
      $serviceapp = Get-SPServiceApplication <guid>

      Where <guid> is the GUID for the User Profile service for which you want to remove a service application administrator.

    • To create a variable that contains the list of administrators for the User Profile service application, type the following command:

      Copy code
      $security = Get-SPServiceApplicationSecurity $serviceapp -Admin

    • To create a variable that contains the claims principal for a user account, type the following command:

      Copy code
      $principalUser1 = New-SPClaimsPrincipal -Identity "<domain\user>" -IdentityType WindowsSamAccountName

      Where <domain\user> is the administrator you want to remove.

    • To remove the user from the list of service application administrators, type the following command:

      Copy code
      Revoke-SPObjectSecurity $security -Principal $principalUser1

    • To apply the changes to the User Profile service application, type the following command:

      Copy code
      Set-SPServiceApplicationSecurity $serviceapp -ObjectSecurity $security -Admin

For more information, see Get-SPServiceApplication, Get-SPServiceApplicationSecurity, Revoke-SPObjectSecurity, and Set-SPServiceApplicationSecurity.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

See also

Administer the User Profile service in SharePoint Server 2013
Delegate administration of User Profile service applications in SharePoint Server 2013
Overview of the User Profile service application in SharePoint Server 2013
Windows PowerShell for SharePoint 2013 reference


Add, edit, or delete custom properties in SharePoint Server 2013 user profiles
See also

Summary: Learn how to create, edit, and delete user profile properties in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The Manage Profile Service page of a User Profile service application in SharePoint Server 2013 is a central location for managing available user profile properties and creating new properties. For more information, see Overview of the User Profile service application in SharePoint Server 2013.

You can supplement default user profile properties with additional properties to track key information that is not otherwise available. Key business needs might encourage you to create new properties that associate users with important business processes. For example, a sales department can create a specific sales role property to share with a particular audience or audiences. Custom user profile properties can be edited to better suit business needs or they can be deleted when no longer needed.

The Manage Profile Service page cannot be accessed until an instance of a User Profile service application exists. You can use the SharePoint Central Administration website to create and manage User Profile service applications and other service applications for non-hosted environments. (For hosted environments, you do this on the Tenant Administrator page.) You can delegate administration of a User Profile service application to someone who does not have permissions to manage other services or settings contained in Central Administration. For more information, see Delegate administration of User Profile service applications in SharePoint Server 2013.

User profiles and groups are used by SharePoint Server 2013 through server-to-server authentication to access and request resources from one another on behalf of users. For more information about server-to-server authentication, see Server-to-server authentication and user profiles in SharePoint Server 2013.

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Before you begin

  • Create a user profile property

  • Edit a user profile property

  • Delete a user profile property

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • The farm is running either the Standard or Enterprise version of SharePoint Server 2013.

  • An instance of the User Profile service application exists.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Create a user profile property

Perform the following procedure to create a user profile property.

To create a user profile property

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group or is a Service Application Administrator for the User Profile service application.

  2. On Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the Type column, click the User Profile service application.

  4. In the Operations group of the ribbon, click Manage.

  5. On the Manage Profile Service page, in the People section, click Manage User Properties.

  6. On the Manage User Profile Properties page, click New Property.

  7. On the Add User Profile Property page, in the Property Settings section, in the Name text box, type a name to be used by the User Profile service application for the user profile property.

  8. In the Property Settings section, in the Display Name box, type the user profile property name that will be displayed to all users.

    Note:

    If you use multiple languages in your deployment, you can provide alternative display names for each language by clicking Edit Languages. In the dialog box, click Add Language, select a language from the menu, and then type the display name in the new language. You can add display names for any of the available languages. The display name that appears depends on the language of the operating system on the computer of the user who views the property.

  9. On the Type drop-down list, click the data type for the property.

    Note:

    If you select string (Multi Value), the property will be permanently set as a multivalued property. You cannot change this setting after you click OK. You can only delete the property and add it again as a new single value property.

  10. In the Length box, type the maximum number of characters that are allowed for values for this property.

  11. Click to select Configure a Term Set to be used for this property to associate the profile property with a managed metadata term set and select a term set from the drop-down list.

  12. In the Sub-type of Profile section, select the Default User Profile Subtype to associate the default user profile subtype with this user profile property.

  13. In the User Description section, in the Description box, type the instructions or information that is displayed to users about this user profile property.

    Note:

    If you use multiple languages in your deployment, you can provide alternative display names for each language by clicking Edit Languages. In the dialog box, click Add Language, select a language from the menu, and then type the display name in the new language. You can add display names for any of the available languages. The display name that appears depends on the language of the operating system on the computer of the user who views the property.

  14. In the Policy Settings section, select the policy setting and default privacy setting that you want for this property. Click to select User can override box to enable users to override these settings.

    Note:

    For more information, see User Profile Properties Overview (http://go.microsoft.com/fwlink/p/?LinkId=155643) and Privacy Policies (http://go.microsoft.com/fwlink/p/?LinkId=155644).

  15. In the Edit Settings section, select whether users can edit values for this property.

  16. In the Display Settings section, specify if and how the property will be viewed by users.

  17. In the Search Settings section, select the Alias check box, the Indexed check box, or both, depending on the kinds of searches that you want to be associated with this user profile property.

    Note:

    The Alias check box is unavailable unless the Default Privacy Setting is set to "Everyone".

    Note:

    If you mark a property as indexed, a search for values of that property returns that user profile. For example, if the telephone number property is indexed, a search of telephone numbers finds the employee with that number. If you mark a property as aliased, the property is a suitable alias for this user. For example, if you search for all documents by John Kane, the result returns documents that were written by johnkane@contoso.com and Jonathan Kane if profile properties are marked with those values as aliases.

  18. In the Property Mapping for Synchronization section, click Remove to delete or change an existing mapping.

  19. In the Add new Mapping section, specify the source data connection, attribute, and synchronization direction for the mapping. When you are finished, click Add.

  20. Click OK.

Edit a user profile property

Perform the following procedure to edit a user profile property.

To edit a user profile property

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group or is a Service Application Administrator for the User Profile service application.

  2. On Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the Type column, click the User Profile service application to select the row.

  4. In the Operations group of the ribbon, click Manage.

  5. On the Manage Profile Service page, in the People section, click Manage User Properties.

  6. On the Manage User Profile Properties page, in the Property Name column, select the user profile property that you want to change, and then click Edit.

  7. On the Edit User Profile Property page, locate the element or elements of the user profile property that you want to change and edit them.

  8. When you are finished, click OK.

Delete a user profile property

Perform the following procedure to delete a user profile property.

To delete a user profile property profile property by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group or is a Service Application Administrator for the User Profile service application.

  2. On Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the Type column, click the User Profile service application to select the row.

  4. In the Operations group of the ribbon, click Manage.

  5. On the Manage Profile Service page, in the People section, click Manage User Properties.

  6. On the Manage User Profile Properties page, in the Property Name column, select the user profile property that you want to remove, and then click Delete.

  7. In the dialog box, verify that you have selected the correct user profile property, and then click OK.

See also

Administer the User Profile service in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013
Delegate administration of User Profile service applications in SharePoint Server 2013
Overview of the User Profile service application in SharePoint Server 2013


Manage user profile synchronization in SharePoint Server 2013

Summary: Learn about articles and worksheets to help you manage User Profile synchronization in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Profile Synchronization in SharePoint Server 2013 enables User Profile service administrators to synchronize user and group profile information that is stored in the SharePoint Server 2013 profile store with profile information that is stored in directory services and business systems across the enterprise.

The following downloadable resources, articles on TechNet, and related resources provide information about how to configure and perform profile synchronization.

Downloadable resources about how to manage User Profile synchronization

Download the following content for information about how to manage User Profile synchronization.

Downloads Content Description

User profile properties and profile synchronization planning worksheets for SharePoint Server 2013

Includes 4 worksheets:

  • Connection planning worksheet: Contains details about each profile synchronization connection that you will create. The article Plan profile synchronization for SharePoint Server 2013 contains instructions for filling out the worksheet.

  • External content type planning worksheet: Collects information you need in order to synchronize user profiles with business systems. Use this worksheet with the instructions in Plan profile synchronization for SharePoint Server 2013.

  • User profile properties worksheet: Identifies user profile properties and how the properties are mapped to external data sources. The article Plan user profiles in SharePoint Server 2013 explains how to complete most of the worksheet, and the article Plan profile synchronization for SharePoint Server 2013 contains instructions on how to add the property mapping information.

  • Profile synchronization planning worksheet: Collects the information that you must have to create the User Profile service application and its prerequisites. If your farm already contains a User Profile service application, you can omit this worksheet.

TechNet articles about how to manage User Profile synchronization

The following articles about how to manage User Profile synchronization are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Synchronize user and group profiles in SharePoint Server 2013 | Learn how to synchronize user and group profile information by using the SharePoint Server 2013 profile synchronization method.
 | Configure profile synchronization by using SharePoint Active Directory Import in SharePoint Server 2013 | Learn how to import user profiles by using the SharePoint Active Directory Import tool.
 | Use UPRE to replicate user profiles across multiple farms in SharePoint Server 2013 | Learn how to use the User Profile Replication Engine to replicate user profiles across multiple SharePoint Server 2013 farms.
 | Maintain user profile synchronization settings in SharePoint Server 2013 | Learn how to maintain Profile Synchronization settings in SharePoint Server 2013 after you configure Profile Synchronization.
 | Start profile synchronization manually in SharePoint Server 2013 | Learn how to manually start a full or incremental profile synchronization.
 | Schedule profile synchronization in SharePoint Server 2013 | Learn how to configure the Profile Incremental Synchronization timer job to define the schedule for running incremental profile synchronization in SharePoint Server 2013.

Additional resources about how to manage User Profile synchronization

The following resources about how to manage User Profile synchronization are available from other subject matter experts.

 | Content | Description
TechNet logo | SharePoint 2013 for IT Pros | Visit the TechCenter to access Community Sites, documentation, and more.


Synchronize user and group profiles in SharePoint Server 2013
See also

Summary: Learn how to synchronize user and group profile information by using the SharePoint Server 2013 profile synchronization method.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Configuring profile synchronization (or profile sync) is a process that involves many steps. This article divides the process into shorter phases, both so that you can see progress and to reduce the number of steps through which you have to backtrack if you make an error. There are four phases to configuring profile synchronization. Depending on your situation, you might not have to perform all of the phases. This article also includes Phase 0, which contains instructions for configuring the prerequisites that are required before you can configure profile synchronization.

User profiles and groups are used by SharePoint Server 2013 through server-to-server authentication to access and request resources from one another on behalf of users. For more information about server-to-server authentication, see Server-to-server authentication and user profiles in SharePoint Server 2013.

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Before you begin

  • Phase 0: Configure the farm

  • Phase 1: Start the User Profile synchronization service

  • Phase 2: Configure connections and import data from directory services

  • Phase 3: Configure connections and import data from business systems

  • Phase 4: Configure connections and export data to directory services

Before you begin

Before you begin this operation, review the following information about prerequisites:

As you configure profile synchronization, you will need information to answer questions in the user interface. You will also need accounts that have the appropriate permissions and a SharePoint Server 2013 farm that is already partly configured. The subsections within this section explain the prerequisites that you must have before you configure profile synchronization.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Gather information

Before you perform the procedures in this article, you should complete the User profile properties and profile synchronization planning worksheets for SharePoint Server 2013. You will use the information that you record in the worksheets as you perform the procedures in this article.

  • Connection planning worksheet: Contains details about each profile synchronization connection that you will create. The article Plan profile synchronization for SharePoint Server 2013 contains instructions for filling out the worksheet.

  • User profile properties worksheet: Identifies user profile properties and how the properties are mapped to external data sources. The article Plan user profiles in SharePoint Server 2013 explains how to complete most of the worksheet, and the article Plan profile synchronization for SharePoint Server 2013 contains instructions on how to add the property mapping information.

  • Profile synchronization planning worksheet: Collects the information that you must have to create the User Profile service application and its prerequisites. If your farm already contains a User Profile service application, you can omit this worksheet.

You will have to know the name of the synchronization server. The synchronization server is the server on which the User Profile synchronization service will run. The Plan for the synchronization server section of Plan profile synchronization for SharePoint Server 2013 contains guidance on how to select the synchronization server.

Grant account permissions

To configure profile synchronization you will have to know the farm account and the farm account's password, and you will need a synchronization account for each directory service that you will synchronize with. The permissions that are required for each account are described in the Plan account permissions section of Plan profile synchronization for SharePoint Server 2013. If an account does not have the appropriate permissions, you might not know that the permissions are wrong until you have progressed part of the way through the configuration procedure.

Note:

Incorrect permissions are the most common cause of errors in configuring profile synchronization.

Install prerequisites

To set up profile synchronization you will need SharePoint Server 2013 installed in a farm configuration.

You must have a full installation of SQL Server, not the Express edition. Profile synchronization will not work if you have installed SharePoint Server 2013 by following the instructions in Install SharePoint 2013 on a single server with a built-in database.

Phase 0: Configure the farm

During this phase, you configure the infrastructure for synchronizing profiles.

This phase involves the following tasks:

  1. Create a web application to host My Sites

  2. Create a managed path for My Site

  3. Create a My Site Host site collection

  4. Create a User Profile service application

  5. Enable NetBIOS domain names for user profile synchronization by using Windows PowerShell

  6. Start the User Profile service

To perform the tasks in this phase, you must be a member of the Farm Administrators SharePoint group and a member of the Administrators group on the computer that is running SharePoint Server.

Create a web application to host My Sites

In this procedure, you create the web application in which My Sites will reside. We recommend that My Sites be in a separate web application, although the web application may be in an application pool that is shared with other collaboration sites, or it may be in a separate application pool but in a shared IIS website. For more information about SharePoint Server 2013 sites, application pools, and IIS websites, see Logical architecture components (SharePoint Server 2010). For more detailed instructions about how to create a web application, see Create a web application in SharePoint 2013.

To create a web application

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator.

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, in the Application Management section, click Manage web applications.

  4. On the ribbon, click New.

  5. On the Create New Web Application page, in the Authentication section, select the authentication mode that will be used for this web application.

  6. In the IIS Web Site section, you can configure the settings for your new web application by selecting one of the following two options (see the Profile Synchronization Planning worksheet):

    • Click Use an existing web site, and then select the website on which to install your new web application.

    • Click Create a new IIS web site, and then type the name of the website in the Name box.

      You may also provide the port number, host header, or path for the new IIS website.

  7. In the Security Configuration section, select an authentication provider, whether to allow anonymous access, and whether to use Secure Sockets Layer (SSL).

  8. In the Application Pool section, do one of the following:

    • If the My Site application pool (see the Profile Synchronization Planning worksheet) is an existing application pool, click Use existing application pool, and then select the My Site application pool from the drop-down menu.

    • If the My Site application pool (see the Profile Synchronization Planning worksheet) is a new application pool, click Create a new application pool, type the name of the My Site application pool, and either select the account that the application pool will run under (see the Profile Synchronization Planning worksheet) or create a new managed account for the application pool to run under.

  9. In the Database Name and Authentication section, select the database server, database name, and authentication method for your new web application.

  10. If you use database mirroring, in the Failover Server section, in the Failover Database Server box, type the name of a specific failover database server that you want to associate with a content database.

  11. In the Service Application Connections section, select the service application connections that will be available to the web application.

  12. In the Customer Experience Improvement Program section, click Yes or No.

  13. Click OK to create the new web application.

  14. When the Application Created page appears, click OK.

Enter the name of the web application in the My Site web application row of the Profile Synchronization Planning worksheet. You will need this information later.

Create a managed path for My Site

If you want the My Site host and users' My Sites to be at a URL that does not already have a managed path, use the procedure in Define managed paths in SharePoint Server 2013 to create the My Site managed path in the My Site web application that you previously created. In most cases, the existing managed paths will be sufficient.

Create a My Site Host site collection

In this procedure, you create the site collection that will host users' My Sites. For more detailed instructions about how to create a site collection, see Create a site collection in SharePoint 2013.

To create a My Site Host site collection

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. On Central Administration, in the Application Management section, click Create site collections.

  3. On the Create Site Collection page, in the Web Application section, select the My Site web application (see the Profile Synchronization Planning worksheet).

  4. In the Title and Description section, type the title and description for the site collection.

  5. In the Web Site Address section, select the path of the URL for the My Site host. In most cases, you can use the root directory (/).

  6. In the Template Selection section, click the Enterprise tab, and then select My Site Host.

  7. In the Primary Site Collection Administrator section, type the user name (in the form <DOMAIN>\<user name>) for the user who will be the site collection administrator.

  8. In the Secondary Site Collection Administrator section, type the user name for the secondary administrator of the site collection.

  9. If you are using quotas to manage storage for site collections, in the Quota Template section, click a template in the Select a quota template list.

  10. Click OK.

The Top-Level Site Successfully Created page will appear when the My Site Host site collection is created. Enter this URL in the My Site Host site collection URL row of the Profile Synchronization Planning worksheet. Although you can click the link to browse to the root of the site collection, doing this results in an error because the user profile cannot be loaded. This behavior is to be expected; user profiles are not imported at this point.

Create a User Profile service application

In this procedure, you create the User Profile service application through which you will manage profile synchronization.

For more detailed instructions about how to create a User Profile service application, see Create a User Profile service application.

To create a User Profile Service application

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. On Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Application page, on the ribbon, click New, and then click User Profile Service Application.

  4. In the Name section, type the User Profile service application name (see the Profile Synchronization Planning worksheet).

  5. In the Application Pool section, select the application pool that the User Profile service application will run in (if it exists), or create a new application pool. (See the Profile Synchronization Planning worksheet.)

  6. Accept the default settings for the profile database, the synchronization database, and the social tagging database (unless you want different names), and specify failover servers if you are using them.

  7. In the Profile Synchronization Instance section, select the synchronization server (see the Profile Synchronization Planning worksheet).

  8. In the My Site Host URL section, enter the My Site Host site collection URL that you created in the previous step (see the Profile Synchronization Planning worksheet).

  9. In the My Site Managed Path section, enter the part of the path which, when appended to the My Site host URL, will give the path of users' My Sites (see the Profile Synchronization Planning worksheet). For example, if the My Site host URL is http://server:12345/ and you want each user's My Site to be at http://server:12345/personal/<user name>, enter /personal for the My Site managed path. The managed path that you enter is created automatically. There does not already have to be a managed path with the name that you provide.

  10. In the Site Naming Format section, select a naming scheme.

  11. In the Default Proxy Group section, select whether you want the proxy of this User Profile Service to be a part of the default proxy group on this farm.

  12. Click Create.

  13. When the Create New User Profile Service Application page displays the message Profile Service Application successfully created, click OK.

To verify that the User Profile service application was created, refresh the Manage Service Applications page. You should see two entries whose value in the Name column is the name that you provided for the User Profile service application that you previously created. The first entry is the service application itself. The second entry is a connection (that is, a "proxy") to the service application.

Enable NetBIOS domain names for user profile synchronization by using Windows PowerShell

If the NetBIOS name of any domain with which you are synchronizing differs from its fully-qualified domain name, you must enable NetBIOS domain names on the User Profile service application. If all NetBIOS names are the same as the domain names, you may skip this procedure.

To enable NetBIOS domain names for user profile synchronization by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running Windows PowerShell cmdlets.

    • You must read about_Execution_Policies.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin.

  2. Paste the following code into a text editor, such as Notepad:

  3. Copy code
    $ServiceApps = Get-SPServiceApplication
$UserProfileServiceApp = ""
foreach ($sa in $ServiceApps)
  {if ($sa.DisplayName -eq "<UPSAName>")
    {$UserProfileServiceApp = $sa}
  }
$UserProfileServiceApp.NetBIOSDomainNamesEnabled = 1
$UserProfileServiceApp.Update()

  4. Replace <UPSAName> with the name of the User Profile service application.

  5. Save the file and add the .ps1 extension, such as EnableNetBIOS.ps1.

    Note:

    You can use a different file name, but you must save the file as an ANSI-encoded text file whose extension is .ps1.

  6. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  7. Change to the directory where you saved the file.

  8. At the Windows PowerShell command prompt, type the following command:

    Copy code
    ./EnableNetBIOS.ps1
Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Start the User Profile service

In this procedure, you start the User Profile service.

To start the User Profile service

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. On Central Administration, in the System Settings section, click Manage services on server.

  3. On the Services on Server page, in the Server box, select the synchronization server (see the Profile Synchronization Planning worksheet).

  4. Find the row whose Service column value is User Profile Service. If the value in the Status column is Stopped, click Start in the Action column.

Phase 1: Start the User Profile synchronization service

During this phase, you start the User Profile synchronization service.

This phase involves the following tasks:

  1. Start the User Profile synchronization service

  2. Remove unnecessary permissions

  3. Reset IIS

To perform the tasks in this phase, you must be a member of the Farm Administrators SharePoint group and a member of the Administrators group on the computer that is running SharePoint Server.

Start the User Profile synchronization service

In this procedure, you start the User Profile synchronization service. The User Profile synchronization service interacts with Microsoft Forefront Identity Manager (FIM) to synchronize information with external systems.

To start the User Profile synchronization service

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. On Central Administration, in the System Settings section, click Manage services on server.

  3. On the Services on Server page, in the Server box, select the synchronization server.

  4. Find the row whose Service column value is User Profile Synchronization Service. If the value in the Status column is Stopped, click Start in the Action column.

  5. On the User Profile Synchronization Service page, in the Select the User Profile Application section, select the User Profile service application.

  6. In the Service Account Name and Password section, the farm account is already selected. Enter the password for the farm account in the Password box, and enter it again in the Confirm Password box.

  7. Click OK.

The Services on Server page shows that the User Profile synchronization service has a status of Starting. When you start the User Profile synchronization service, SharePoint Server provisions FIM to participate in synchronization. This may take 10 minutes. To determine whether the User Profile synchronization service has started, refresh the Services on Server page.

If the User Profile synchronization service does not start, confirm that the farm account has the necessary permissions on the synchronization server. For more information about which permissions are required, see the Plan account permissions section of the article "Plan for profile synchronization."

Remove unnecessary permissions

After you start the User Profile synchronization service, for day to day operations, the farm account is not required to be a member of the Administrators group on the computer that is running the synchronization service. To improve the security of your SharePoint Server installation, remove the farm account from the Administrators group on the computer that is running the synchronization service. However, when you perform a backup of the User Profile application, the synchronization service provisions the User Profile application again. During the course of provisioning the User Profile application, the farm account must stop and start the synchronization service. To do this, the farm account must be a member of the Administrators group on the computer that is running the synchronization service. So, before you perform a backup, add the farm account to the Administrators group on the computer that is running the synchronization service. After the backup has finished running, you can remove the farm account from the Administrators group.

To grant the farm account the Remote Enable permission to Microsoft FIM 2010

  1. On the server that is running the synchronization service, click Start.

  2. Click Run, type wmimgmt.msc, and then click OK.

  3. Right click WMI Control, and then click Properties.

  4. In the WMI Control Properties dialog box, click the Security tab.

  5. Expand the Root list, and then select the Microsoft FIM 2010 namespace MicrosoftIdentityIntegrationServer.

  6. Click the Security button.

  7. Add the farm account to the list of groups and users, and then in the Permissions for Authenticated Users box, select Allow for the Remote Enable permission.

  8. Click OK to dismiss the Security for ROOT\MicrosoftIdentityIntegrationServer dialog box, and then click OK to dismiss the WMI Control Properties dialog box.

Reset IIS

If the SharePoint Central Administration website and the User Profile synchronization service are running on the same server, you must reset IIS after the User Profile synchronization service starts. If they are running on different servers, you may skip this procedure.

To reset IIS

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. Start a Command Prompt with elevated privileges.

    • For Windows Server 2008 R2:

      • On the synchronization server, click Start, click All Programs, expand Accessories, right-click Command Prompt, and then click Run as administrator.

    • For Windows Server 2012:

      • On the synchronization server, on the Start screen, right-click Command Prompt, and then click Run as administrator.

        If Command Prompt is not on the Start screen:

      • Right-click Computer, click All apps, right-click Command Prompt, and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In the User Account Control dialog box, click Yes.

  4. In the Administrator: Command Prompt window, type iisreset and then press ENTER.

  5. When the message Internet services successfully restarted is displayed, close the Administrator: Command Prompt window.

Note:

After you reset IIS, pages of Central Administration will take several seconds to load.

Phase 2: Configure connections and import data from directory services

To import profiles, you must have at least one synchronization connection to a directory service. During this phase, you create a synchronization connection to each directory service that you want to import profiles from. You can synchronize after you create each connection, or you can synchronize one time, after you have created all of the connections. Synchronizing after each connection will take longer, but doing this makes it easier to troubleshoot any problems that you might encounter.

To watch a video that demonstrates the tasks in Phase 2, see Configure a profile synchronization connection in SharePoint Server 2010 (video).

You must be a farm administrator or an administrator of the User Profile service application to perform these procedures. If you are not a farm administrator, start each procedure by using the Manage Profile Service page.

This phase involves the following tasks:

  1. Create a synchronization connection to a directory service

  2. Define exclusion filters for a synchronization connection

  3. Map user profile properties

  4. Start profile synchronization

Create a synchronization connection to a directory service

In this procedure, you create a connection to a directory service. The connection identifies the items to synchronize and contains the credentials that are used to interact with the directory service. The information that you enter comes from the Connection Planning worksheet.

To create a Profile synchronization connection to a directory service

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator or an administrator of the User Profile service application.

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. If the user account that is performing this procedure is a farm administrator, complete these steps. Otherwise, if the user account is not a farm administrator go to the next step:

    1. On Central Administration, in the Application Management section, click Manage service applications.

    2. On the Manage Service Applications page, select the User Profile service application.

  3. On Central Administration, on the Manage Profile Service page, in the Synchronization section, click Configure Synchronization Connections.

  4. On the Synchronizations Connections page, click Create New Connection.

  5. On the Add new synchronization connection page, type the synchronization connection name in the Connection Name box.

  6. From the Type list, select the type of directory service to which you want to connect.

  7. Fill in the Connection Settings section according to the directory service to which you are creating a connection.

    For Active Directory Domain Services (AD DS), follow these steps:

    1. In the Forest name box, type the name of the forest.

    2. Do one of the following:

      • If there is only one domain controller in the forest, click Auto discover domain controller.

      • If there are multiple domain controllers in the forest, click Specify a domain controller and type the domain controller name in the Domain controller name box.

    3. In the Authentication Provider Type box, select the type of authentication provider.

    4. If you select Forms Authentication or Trusted Claims Provider Authentication, select an authentication provider from the Authentication Provider Instance box.

      The Authentication Provider Instance box lists only the authentication providers that are currently used by a web application.

      Tip:

      You may have to select Trusted Claims Provider Authentication and then select Forms authentication in the Authentication Provider Type box before the list of authentication providers is displayed.

    5. In the Account name box, type the synchronization account.

    6. In the Password box, type the password for the synchronization account.

    7. In the Confirm Password box, type the password for the synchronization account again.

    8. In the Port box, enter the connection port.

    9. If a Secure Sockets Layer (SSL) connection is required to connect to the directory service, select Use SSL-secured connection.

      Important:

      If you use an SSL connection, you must export the certificate of the domain controller from the Active Directory server and import the certificate into the synchronization server.

    For Novell eDirectory, Sun Java System Directory Server, or IBM Tivoli Directory Server (ITDS), follow these steps:

    1. In the Directory Service Server Name box, type the name of the directory service server.

    2. In the Authentication Provider Type box, select the type of authentication provider.

    3. In the Authentication Provider Instance box, select the authentication provider.

      The Authentication Provider Instance box lists only the authentication providers that are currently used by a web application.

      Tip:

      You may have to select Trusted Claims Provider Authentication and then select Forms authentication in the Authentication Provider Type box before the list of authentication providers is displayed.

    4. In the Account name box, type the synchronization account in LDAP format, for example, uid=username,ou=ouname,dc=yourcompany,dc=Com.

    5. In the Password box, type the password for the synchronization account.

    6. In the Confirm Password box, type the password for the synchronization account again.

    7. In the Port box, enter the connection port.

    8. Verify that the Use SSL-secured connection check box is not selected. SSL connections are not supported for these directory services.

    9. In the Username attribute box, type the name of the attribute in the directory service that serves as the unique identifier of each profile.

  8. In the Containers section, click Populate Containers, and then select the containers from the directory service that you want to synchronize.

  9. Click OK.

Define exclusion filters for a synchronization connection

In this procedure, you define filters for the connection to indicate which user profiles and which groups to exclude from synchronization. The information that you enter comes from the Connection Planning worksheet.

To define connection filters

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator or an administrator of the User Profile service application.

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. If the user account that is performing this procedure is a farm administrator, complete these steps. Otherwise, if the user account is not a farm administrator go to the next step:

    1. On Central Administration, in the Application Management section, click Manage service applications.

    2. On the Manage Service Applications page, select the User Profile service application.

  3. On Central Administration, on the Manage Profile Service page, in the Synchronization section, click Configure Synchronization Connections.

  4. On the Synchronization Connections page, right-click the connection for which you want to configure User Profile synchronization connection filters, and then click Edit Connection Filters.

  5. On the Edit connection filters page, in the Exclusion Filters for Users section, select the operator to use to join the clauses of the filter.

    • To specify that all of the clauses of the filter must be true, select All apply (AND).

    • To specify that at least one of the clauses of the filter must be true, select Any apply (OR).

  6. In the Attributes list, select the directory service attribute to compare.

  7. In the Operator list, select the comparison operator to use.

    Note:

    The operators that are available depend on the data type of the attribute that you selected. For a list of which operators are available for each data type, see Connection filter data types and operators in SharePoint Server 2013.

  8. In the Filter box, type the value to which you want to compare the attribute.

  9. Click Add.

    The clause that you added is displayed in the Exclusion Filter for Users area.

  10. To add clauses to the filter, repeat steps 5 through 9.

  11. To filter which groups are synchronized, repeat steps 5 through 9, using the Exclusion Filters for Groups section of the page.

  12. When you have finished adding connection filters, click OK.

Map user profile properties

In this procedure, you determine how the properties of SharePoint Server user profiles map to the user information that is retrieved from the directory service. You should have identified how you will map user profile properties on the User profile properties data sheet in the User Profile Properties worksheet.

You will come back to this procedure in later phases to map user profile properties to information that is retrieved from business systems and to map how user profile properties in SharePoint Server can be used to write information back to the directory service. If you have not yet reached these phases, ignore the parts of the procedure that deal with business systems and exporting data.

To map user profile properties

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator or an administrator of the User Profile service application.

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. If the user account that is performing this procedure is a farm administrator, complete these steps. Otherwise, if the user account is not a farm administrator go to the next step:

    1. On Central Administration, in the Application Management section, click Manage service applications.

    2. On the Manage Service Applications page, select the User Profile service application.

  3. On Central Administration, on the Manage Profile Service page, in the People section, click Manage User Properties.

  4. On the Manage User Properties page, right-click the SharePoint Server property that you want to map to a directory service property, and then click Edit.

  5. To remove an existing mapping, in the Property Mapping for Synchronization section, select the mapping that you want to remove, and then click Remove.

  6. To add a new mapping, do the following:

    1. In the Add New Mapping section, in the Source Data Connection list, select the data connection that represents the external system to which you want to map the SharePoint Server property.

    2. In the Attribute list, select the name of the attribute in the external system to which you want to map the property.

      Tip:

      You can only map a user profile property to an attribute of an external system if the data types are compatible. If an attribute that you want to map to a user profile is not listed when you try to create a new mapping, it might be due to a data type mismatch between the user profile property and the attribute. For more information about which data types are compatible, see User profile property data types in SharePoint Server 2013.

    3. In the Direction list, select the mapping direction.

      A direction of Import means that the value of the attribute in the external system will be imported into SharePoint Server and used to set the value of the SharePoint Server property. A direction of Export means that the value of the property in SharePoint Server will be exported to the external system and used to set the value of the attribute in the external system.

      Note:

      You cannot edit a mapping. To change the direction of a mapping, you must first remove the mapping with the old direction, and then create a mapping in the new direction and add the mapping.

    4. Click Add.

  7. Click OK.

  8. Repeat steps 4 through 7 to map additional properties.

Start profile synchronization

Use this procedure to synchronize profile information between SharePoint Server 2013 and external systems such as directory services or business systems.

To start profile synchronization

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator or an administrator of the User Profile service application.

    • The user account that performs this procedure is a member of the Administrators group on the computer that is running SharePoint Server.

  2. If you have already imported users or created My Sites, and you have enabled NetBIOS domain names, you must disable the My Site cleanup timer job before you start profile synchronization. For information about this timer job, see the Timer job reference (SharePoint 2013). For information about the Windows PowerShell cmdlets that you use to enable and disable this timer job, see Use Windows PowerShell cmdlets to manage timer jobs in SharePoint 2013.

  3. If the user account that is performing this procedure is a farm administrator, complete these steps. Otherwise, if the user account is not a farm administrator go to the next step:

    1. On Central Administration, in the Application Management section, click Manage service applications.

    2. On the Manage Service Applications page, select the User Profile service application.

  4. On Central Administration, on the Manage Profile Service page, in the Synchronization section, click Start Profile Synchronization.

  5. On the Start Profile Synchronization page, select Start Full Synchronization if this is the first time that you are synchronizing or if you have added or changed any synchronization connections or property mappings since the last time that you synchronized. Select Start Incremental Synchronization to synchronize only information that has changed since the last time that you synchronized.

  6. Click OK.

    The Manage Profile Service page is displayed.

  7. If you intend to enable the My Site cleanup timer job, complete these additional steps before you enable the job:

    1. Run profile synchronization again as described in this section.

    2. After the second profile synchronization has finished running, on Central Administration, in the Application Management section, click Manage service applications.

    3. Click the User Profile Service Application name, and then click Manage User Profiles.

    4. On the Manage Profile Service page, in the People section, click Manage User Profiles.

    5. Next to View, select Profiles Missing from Import.

    6. In the Find Profiles box, type the domain for the profiles, and then click Find.

    7. For each profile that is returned, check the originating directory service, such as Active Directory, for the status of that profile. If the status of any of the returned profiles in the directory is not disabled or is not deleted, do not enable the My Site cleanup timer job. Contact Microsoft support for more assistance. Otherwise, enable the My Site cleanup timer job. For information about the Windows PowerShell cmdlets that you use to enable and disable this timer job, see Use Windows PowerShell cmdlets to manage timer jobs in SharePoint 2013.

A full synchronization can take a long time. If you refresh the Manage Profile Service page, the right side of the page displays the progress of the synchronization job. Be aware that profile synchronization consists of several stages, and the profiles will not be imported immediately. The Manage Profile Service page is not refreshed automatically as synchronization progresses.

Phase 3: Configure connections and import data from business systems

You can import data from a business system, such as a personnel system or a financial system, and use that data to add properties to existing user profiles. You should already have created an external content type that brings the information from the external system into SharePoint Server 2013. For more information about how to create an external content type to synchronize with a business system, see Plan profile synchronization for SharePoint Server 2013.

To watch a video that demonstrates creating external content types and completing the tasks in Phase 3, see Configure a synchronization connection to a SQL Server database in SharePoint Server 2010 (video).

This phase is optional.

You must be a farm administrator, or an administrator of both the User Profile service application and the Business Data Connectivity service application, to perform these procedures. If you are not a farm administrator, start each procedure at the Manage Profile Service page.

This phase involves the following tasks:

  1. Give the User Profile service application permission to use the external content type

  2. Configure a Business Data Connectivity synchronization connection

  3. Add or edit user profile properties

  4. Import data

Give the User Profile service application permission to use the external content type

Use this procedure to give the farm account permission to execute operations on the external content type. For more information about how to set permissions on an external content type, see Set permissions on an external content type.

Note:

Business Connectivity Services uses the permissions on the external content type and the permissions on the business system to determine authorization rules. You must make sure that the farm account also has permission to access the business system. For more information about authentication and permissions, see Overview of Business Connectivity Services security tasks in SharePoint 2013.

To give the User Profile service application permission to use the external content type

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator or an administrator of the Business Data Connectivity service application.

    • The user account that performs this procedure has Set Permissions permission on the external content type with which you are synchronizing.

  2. If the user account that is performing this procedure is a farm administrator, complete this step. Otherwise, if the user account is not a farm administrator go to the next step:

    • On the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  3. On Central Administration, on the Manage Service Applications page, select the Business Data Connectivity service application.

  4. Select the check box of the external content type that represents the information with which you want to synchronize.

  5. In the Permissions group, click Set Object Permissions.

  6. In the box, type the farm account, and then click Add.

  7. In the Permissions for <account> box, select Execute.

    Note:

    If the farm account is the only account that is listed in the Permissions for <account> box, you must also give the farm account Set Permissions to the external content type. At least one user, group, or claim in the external content type's access control list must have the Set Permissions permission.

  8. Click OK.

  9. Verify that the Propagate permissions to all methods of this external content type. Doing so will overwrite existing permissions. check box is selected.

  10. Repeat these steps to set permissions on additional external content types.

Configure a Business Data Connectivity synchronization connection

In this procedure, you create a connection for each external content type. The connection specifies how the business system data relates to the profile properties. The information that you enter comes from the Connection Planning worksheet.

To create a User Profile synchronization connection

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a farm administrator or administrator of both the User Profile service application and the Business Data Connectivity service application.

  2. If the user account that is performing this procedure is a farm administrator, complete these steps. Otherwise, if the user account is not a farm administrator go to the next step:

    1. On Central Administration, in the Application Management section, click Manage service applications.

    2. On the Manage Service Applications page, select the User Profile service application.

  3. On Central Administration, on the Manage Profile Service page, in the Synchronization section, click Configure Synchronization Connections.

  4. On the Synchronizations Connections page, click Create New Connection.

  5. On the Add new synchronization connection page, type a name for the synchronization connection in the Connection Name box.

  6. From the Type list, select Business Data Connectivity.

  7. In the Business Data Connectivity Entity box, type the name of the external content type.

    Tip:

    If you do not know the name of the external content type, click the Select External Content Type button to see all external content types. Select the external content type from the list, and then click OK.

  8. If each user profile maps to only one external content type instance, do the following:

    1. Click Connect User Profile Store to Business Data Connectivity Entity as a 1:1 mapping.

    2. In the Return items identified by this profile property list, select the user profile property that is used to match user profiles to external content type instances. The user profile property and the external content type identifier define the 1:1 relationship between the user profiles and the external content type, and are used to make sure that that the imported properties are applied to the correct user profile.

      Tip:

      The Return items identified by this profile property list returns all user profile properties that have a similar data type to the external content type identifier.

  9. If a user profile can map to multiple external content type instances, do the following:

    1. Click Connect User Profile Store to Business Data Connectivity Entity as a 1:many mapping.

    2. In the Filter items by list, select the filter that is used to find the set of external content type instances that apply to a user profile.

      Note:

      The Filter items by list displays all filters that are defined in the external content type.

    3. In the Use this profile property as the filter value list, select the user profile property that is used to match user profiles to external content type instances.

  10. Click OK.

  11. Repeat steps 4 through 10 to add more connections.

Add or edit user profile properties

Before you can import the business system data, you must specify how the business system data maps to the user profile properties. The User profile properties data sheet in the User profile properties worksheet lists the business system properties that you want to import and how those properties map to the profile properties in the SharePoint Server profile store.

Follow the procedure in the Map user profile properties section to map additional user profile properties. If the data maps to an existing user profile property, edit the property and add a new mapping. If the data does not map to an existing user profile property, add a new custom property and then map the property.

Import data

To import data from the business system, you must perform a full synchronization. Follow the procedure in the Start profile synchronization section to start a full synchronization.

Phase 4: Configure connections and export data to directory services

In previous phases, you configured the profile synchronization connections that that you must have. To write profile information back to a directory service, you map the profile properties to attributes in the directory service by using a mapping direction of Export. The next time that profile synchronization runs, properties will be imported and exported according to the mappings that you configured.

Note:

Although you can import profile data from business systems by using the Business Connectivity Service, you cannot export profile data to business systems.

This phase is optional.

You must be a farm administrator or an administrator of the User Profile service application to perform these procedures. If you are not a farm administrator, start each procedure by using the Manage Profile Service page.

Do not create a new synchronization connection to export properties. To export properties to a directory service, use the same synchronization connection that you created to import properties from the directory service. You cannot use a synchronization connection only to export properties.

Follow the procedure to Map user profile properties again, this time selecting Export for the mapping direction. The properties that you map will be exported from SharePoint Server to the directory service whose connection you select.

Follow the procedure to Start profile synchronization again, this time selecting to do an incremental synchronization. The values of any SharePoint Server profile properties that were mapped to be exported to directory service attributes will be updated.

Note:

For certain directory services, additional permissions may be required to write data back to the directory service. Review the information in the Plan account permissions section of the "Plan for profile synchronization" article, and make sure that that the synchronization account has the necessary permissions.

Acknowledgements

The SharePoint Server 2013 Content Publishing team thanks Spencer Harbar, Enterprise Architect, for contributing to this article. His blog can be found at http://www.harbar.net.

See also

Manage user profile synchronization in SharePoint Server 2013
Schedule profile synchronization in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013

Configure a profile synchronization connection in SharePoint Server 2010 (video)
Configure a synchronization connection to a SQL Server database in SharePoint Server 2010 (video)


Configure profile synchronization by using SharePoint Active Directory Import in SharePoint Server 2013
See also

Summary: Learn how to import user profiles by using the SharePoint Active Directory Import tool for SharePoint Server 2013.

Applies to: SharePoint Server 2013

You can use the SharePoint Active Directory Import option (AD Import) as an alternative to using SharePoint Profile Synchronization to import user profile data from Active Directory Domain Services (AD DS) in your domain. This option to configure profile synchronization (also known as profile sync) involves three steps:

  • Selecting the option

  • Creating or editing a connection

  • Mapping user profile properties

This tool works only with Active Directory Domain Services (AD DS) and does not work with other directory services.

Note:

This article assumes that you have already provisioned the User Profile Service, have created the User Profile service application, and that you have gathered the required information about your environment. For more information, see Synchronize user and group profiles in SharePoint Server 2013.

In this article:

  • Before you begin

  • Configure SharePoint Active Directory Import by using Central Administration

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • You must be a member of the Farm Administrators group.

  • You must know the credentials of the domain controller that has synchronization permissions.

    For more information about required permissions, see the "Plan account permissions" section of Plan profile synchronization for SharePoint Server 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Configure SharePoint Active Directory Import by using Central Administration

You perform three procedures in Central Administration to configure AD Import.

In the first procedure, you select the SharePoint Active Directory Import (AD Import) option to import user profile data from AD DS. This AD Import option improves the performance of the import process and is simpler to use, although it is not as flexible as the SharePoint Profile Synchronization method. Consider the following when you determine whether to use the AD Import option:

  • Import operations that use this option are significantly faster than the same operations that use SharePoint Profile Synchronization.

  • The AD Import option does not perform bidirectional synchronization. That means changes made to SharePoint user profiles will not be synchronized with the domain controller.

  • Referential integrity among users and groups is only maintained within a single Active Directory forest.

  • The AD Import option lets you configure and use only a single, farm-wide property mapping.

In the second procedure, you create a connection to a directory service. The connection identifies the items to synchronize and contains the credentials that are used to interact with the directory service. The information that you enter comes from the Connection Planning worksheet.

In the third procedure, you determine how the properties of SharePoint user profiles map to the user information that is retrieved from the directory service. You should have identified how you will map user profile properties on the User profile properties data sheet in the User Profile Properties worksheet.

To import profiles, you must have at least one synchronization connection to a directory service. You may have connections to multiple AD DS servers. During this phase, you create a synchronization connection to each AD DS server that you want to import profiles from. You can synchronize after you create each connection, or you can synchronize one time, after you have created all of the connections. Although synchronizing after each connection takes longer, doing this makes it easier to troubleshoot any problems that you might encounter.

To select SharePoint Active Directory Import

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the User Profile service application name.

  4. On the Manage Profile Service page, in the Synchronization section, click Configure Synchronization Settings.

  5. On the Configure Synchronization Settings page, in the Synchronization Options section, select the Use SharePoint Active Directory Import option, and then click OK.

To create a connection to a directory service for import

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the User Profile service application name.

  4. On the Manage Profile Service page, in the Synchronization section, click Configure Synchronization Connections.

  5. On the Synchronizations Connections page, click Create New Connection.

  6. On the Add new synchronization connection page, type the synchronization connection name in the Connection Name box.

  7. From the Type list, select Active Directory Import.

  8. Fill in the Connection Settings section by using the following steps:

    1. In the Fully Qualified Domain Name box, type the Fully Qualified Domain Name of the domain.

    2. In the Authentication Provider Type box, select the type of authentication provider.

    3. If you select Forms Authentication or Trusted Claims Provider Authentication, select an authentication provider from the Authentication Provider Instance box.

      The Authentication Provider Instance box lists only the authentication providers that are currently used by a Web application.

      Tip:

      You may have to select Trusted Claims Provider Authentication and then select Forms authentication in the Authentication Provider Type box before the list of authentication providers is displayed.

    4. In the Account name box, type the synchronization account in the form <DOMAIN>\<UserName>. The synchronization account must have Replicate Directory permissions or higher on the root OU of Active Directory.

    5. In the Password box, type the password for the synchronization account.

    6. In the Confirm password box, type the password for the synchronization account again.

    7. In the Port box, type the connection port.

    8. If a Secure Sockets Layer (SSL) connection is required to connect to the directory service, select Use SSL-secured connection.

      Important:

      If you use an SSL connection, you must export the certificate of the domain controller from the AD DS server and import the certificate into the synchronization server.

    9. If you want to filter the objects to be imported from the directory service, in the Filter in LDAP syntax for Active Directory Import box, type a standard LDAP query expression to define the filter.

  9. In the Containers section, click Populate Containers, and then select the containers from the directory service that you want to synchronize. All OUs selected will be synchronized with their child OUs. There is currently no utility to allow a parent OU to be selected with any of its child OUs excluded from synchronization.

  10. Click OK.

    The newly created connection is listed on the Synchronization Connections page.

    Tip:

    On the Synchronization Connections page, you can right-click the name of a synchronization connection, and then click Edit or Delete to edit or delete the connection.

To map user profile properties

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the User Profile service application name.

  4. On the Manage Profile Service page, in the People section, click Manage User Properties.

  5. On the Manage User Properties page, right-click the name of the property that you want to map to a directory service attribute, and then click Edit.

  6. To remove an existing mapping, in the Property Mapping for Synchronization section, select the mapping that you want to remove, and then click Remove.

  7. To add a new mapping, do the following:

    1. In the Add New Mapping section, in the Source Data Connection list, select the data connection that represents the directory service to which you want to map the user profile property.

    2. In the Attribute box, type the name of the directory service attribute to which you want to map the property.

    3. Click Add.

      Note:

      You cannot add multiple mappings or edit a mapping. To change mapping settings for a property, you must first remove the existing mapping, and then create a new mapping.

  8. Click OK.

  9. Repeat steps 5 through 8 to map additional properties.

To start profile synchronization

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the User Profile service application name.

  4. On the Manage Profile Service page, in the Synchronization section, click Start Profile Synchronization.

  5. On the Start Profile Synchronization page, select Start Full Synchronization if this is the first time that you are synchronizing or if you have added or modified any synchronization connections since the last time that you synchronized. Select Start Incremental Synchronization to synchronize only information that has changed since the last time that you synchronized.

  6. Click OK.

    The Manage Profile Service page is displayed, showing the profile synchronization status in the right pane.

See also

Manage user profile synchronization in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013
Synchronize user and group profiles in SharePoint Server 2013
Schedule profile synchronization in SharePoint Server 2013


Use UPRE to replicate user profiles across multiple farms in SharePoint Server 2013
See also

Published: January 22, 2013

Summary: Learn how to use the User Profile Replication Engine to replicate user profiles across multiple SharePoint farms.

Applies to: SharePoint Server 2013

Administrators can replicate user profiles from one SharePoint farm to another by using the User Profile Replication Engine.

In this article:

  • Before you begin

  • Benefits of replicating user profile information across multiple farms

  • Types of replication

  • Prerequisites for replication

  • Perform full replication

  • Perform incremental replication

  • Perform recovery replication

  • Monitor the replication process

Before you begin

Before you begin this task, read the following articles:

  • User Profile Replication Engine overview

  • Overview of the User Profile service application in SharePoint Server 2013

  • Plan user profiles in SharePoint Server 2013

  • Administer the User Profile service in SharePoint Server 2013

  • Best practices for people and profiles (SharePoint Server 2010)

  • Resolve accounts across multiple forests (SharePoint Server 2010)

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Benefits of replicating user profile information across multiple farms

Large international organizations can have multiple geographically dispersed SharePoint farms to hold SharePoint My Sites for local users. For example, the following figure shows one farm with 1000 users in Europe, one farm with 1000 users in America, and one farm with 1000 users in Asia. You have deployed the User Profile service application in Europe. When you replicate the user profile information of all farms to all other farms, users in each region will be able to view all user profile information on the local farm. This reduces inter-farm traffic and therefore improves performance. It also improves availability, because a failure of the User Profile service on one farm does not affect other farms.

Figure: Use the User Profile Replication Engine to replicate user files from one farm to multiple farms

Diagram that depicts how to the User Profile Replication Engine to replicate user profiles from the central farm to two regional farms

Types of replication

There are three types of replication:

  • Full replication

    By using full replication, you can replicate all user profile information and some social data (that is, followed people, followed hash tags, and @mentions) to other farms. Usually you perform full replication when you have to do the following:

    • Replicate user profile information from an existing User Profile service application to a newly deployed User Profile service application.

    • Recover data by copying user profile data from an existing User Profile service application profile database or social database.

    To perform full replication, you must be an administrator for the User Profile service application on both source and destination farms. The full replication runs under the security context of the person who starts the full replication.

  • Incremental replication

    Incremental replication replicates changes that are made after the full replication. After full replication is complete, you have to start incremental replication before the time limit specified by the maximum number of days to store the change log. This is to ensure that individual changes are being detected and replicated. By default, the change logs are stored for 14 days. The longer the storage interval, the more time it takes for the User Profile Replication Engine to replicate changes.

    After you run the incremental replication cmdlet described later in this topic, incremental replication is performed automatically at a regular interval. The default interval is 5 seconds.

    Incremental replication is performed through the Replication Engine service. Therefore, on both source and destination farms, make sure that the Replication Engine service is started under the account with which you will run the incremental replication. You must also be a member of the Administrators group for the User Profile service application.

    Note:

    There is a significant difference between full replication and incremental replication. Full replication only supports replication from one source to one destination at the same time, whereas incremental replication supports replication from one source to multiple destinations.

  • Recovery replication

    Recovery replication can fully replicate a specific user or a set of users whose information did not replicate correctly.

    You use recovery replication when you have detected a mismatch in the user profile information on the source and destination farms. It resembles full replication, except that you have to provide an accounts file that specifies the user profiles that you want to replicate from the source farm to the destination farm.

Prerequisites for replication

Before you perform either full replication or incremental replication, perform the following tasks:

  • Verify that an instance of the User Profile service application exists in each farm

  • Install the User Profile Replication Engine

  • Enable network DTC access

  • Back up the User Profile service application databases

  • Configure audiences and trusted My Site host locations

Verify that an instance of the User Profile service application exists in each farm

Ensure that an instance of the User Profile service application already exists in each source and destination farm.

  1. Verify that the user account that is performing this procedure has the Manage Profiles permission for the User Profile service application. For more information, see Delegate administration of User Profile service applications in SharePoint Server 2013.

  2. On the Central Administration website, in the Application Management section, click Manage service applications.

  3. Ensure at least one instance of the User Profile service application is available, and the status is Started.

Install the User Profile Replication Engine

The User Profile Replication Engine is included in the SharePoint 2010 Administration Toolkit. To use the User Profile Replication Engine, first download and install the SharePoint 2010 Administration Toolkit. For more information, see Installing the SharePoint 2010 Administration Toolkit (SharePoint Server 2010).

Enable network DTC access

By default, network Distributed Transaction Coordinator (DTC) access is disabled. When you do not enable network DTC access on the server, applications can only use transactions that stay on the local computer. For example, transactions cannot flow from a local computer to a database that runs on a separate computer if network DTC access is disabled. To improve the performance of replication, you must enable network DTC access.

For more information, see Enable Network DTC Access (http://go.microsoft.com/fwlink/p/?LinkID=231413).

Back up the User Profile service application databases

Before you replicate the User Profile information, back up the following User Profile service application databases on all involved farms:

  • Profile database - used to store user profile information.

  • Synchronization database - used to store configuration and staging information for synchronizing profile data from external sources such as AD DS.

  • Social tagging database - used to store social tags and notes created by users. Each social tag and note is associated with a profile ID.

For more information, see the "Use SQL Server tools to back up a User Profile service application database" section in Back up User Profile service applications in SharePoint Server 2013.

Configure audiences and trusted My Site host locations

You must add an audience for the User Profile service applications on both source and destination farms. The User Profile Replication Engine uses audiences to identify user profiles on the source farm and those on the destination farm. For more information, see Add, edit, or delete an audience (SharePoint Server 2010).

You must configure trusted My Site host locations to ensure that User Profile data is replicated correctly. When My Site host locations are specified, users are redirected to the single My Site host location that is intended for their accounts regardless of where they are browsing when they attempt to create or access their My Sites. For information, see Add or delete a trusted My Site host location (SharePoint Server 2010).

Perform full replication

You can use the Start-SPProfileServiceFullReplication cmdlet to replicate all selected user profile information and social data — including social tags, notes, and ratings — from the source User Profile Service application to the destination User Profile service application.

The User Profile Replication Engine does not replicate data that comes from Active Directory Domain Services (AD DS) because it would automatically be updated from AD DS during profile synchronization.

Note:

Because the User Profile Replication Engine deletes previous entries in bulk before it performs full replication, make sure that full replication only occurs from a master location based on the My Site host location of the currently processed user's My Site. The potential problem is that the user's account may be present in a User Profile service application even though that location is not a true master location of the account. For example, User A has a My Site in Farm A, and User B has a My Site in Farm B. User A leaves comments on the My Site that is owned by User B in Farm B. A new user profile entry for User A is then created in Farm B only to store the comments that User A leaves. In this case, to perform full replication, you must set the User Profile service application in Farm A, the master location, as the replication source. If you set the remote User Profile service application in Farm B as the replication source, the user profile created in Farm B for User A and his or her comments will be lost.

To perform full replication by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • The Manage Profiles permission and the Manage Social Data permission on the User Profile service application for the source and the destination farms.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Start-SPProfileServiceFullReplication -Destination <String> -Source <String> [-EnableInstrumentation <SwitchParameter>] [-MaxNumberOfThreads <Int32>] [-Properties <String[]>]

    Where:

    • Destination: Specifies the URL of the My Site Host to where the user profiles are replicated, for example, http://euro.contoso.com:8081/my.

    • Source: Specifies the URL of the My Site Host from where the user profiles are retrieved, for example, http://hq.contoso.com:8081/my.

    • EnableInstrumentation: Enables detailed logging by using the instrumentation log.

    • MaxNumberOfThreads: Specifies the maximum number of replication threads allowed on the server that is running the User Profile Replication Engine. The value range is between 1 and 100. The default value is 25. The actual number of running threads will be decided dynamically by the User Profile Replication Engine.

    • Properties: Specifies which user profile properties to replicate, for example, "FirstName" or "AboutMe". You can also use the Get-SPProfilePropertyCollection cmdlet to return a collection of all user profile properties. The default value returns all user profile properties. Note that properties that are mapped to the external data source will be overwritten the next time user profiles are imported.

    For example, for the destination farm at http://America.contoso.com and the source farm at http://Europe.contoso.com, the command is:

    Copy code
    Start-SPProfileServiceFullReplication -Destination http://America.contoso.com -Source http://Europe.contoso.com -EnableInstrumentation -MaxNumberOfThreads 15 -Properties "AboutMe", "PictureURL"

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

    Replication begins at the start index and can be stopped by pressing CTRL+C.

    Full replication may take several hours to several days, depending on many factors, such as the performance of the network, the volume of data that you are replicating, and the number of threads allocated for replication.

    If full replication is interrupted, check the log file for the last successful entry and restart the replication process by using the StartAtIndex parameter.

    For more information, see Start-SPProfileServiceFullReplication.

Perform incremental replication

You can use the Start-SPProfileServiceIncrementalReplication cmdlet to replicate changes that are made after the full replication.

To perform incremental replication by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. The first time that you run the incremental replication cmdlet, you must have configured the credentials for the Replication Engine service. You can retrieve these credentials by using the Get-Credential cmdlet. For more information, see Get-Credential (http://go.microsoft.com/fwlink/p/?LinkID=113311).

  4. Make sure the Replication Engine service on both source and destination farms are started and run under the credentials of the User Profile Service account on the source farm.

  5. Assign an account as the administrator for the User Profile service applications on both source and destination farms. To do this, in Central Administration, in the Application Management section, click Manage service applications. Click the row that has the User Profile service application, and then on the ribbon, click Administrators. In the Administrators dialog box, add the User Profile Service account on the source farm as an Administrator, and then grant it Full Control.

  6. Log on to the source farm with the Administrator account for the User Profile service application. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Start-SPProfileServiceIncrementalReplication -Destination <String[]> -Source <String> [-Credential <PSCredential>] [-EnableInstrumentation <SwitchParameter>] [-Properties <String[]>]

    Where:

    • Destination: Specifies the URL of the My Site Host to where the user profiles are replicated, for example, http://euro.contoso.com:8081/my.

    • Source: Specifies the URL of the My Site Host from where the user profiles are retrieved, for example, http://hq.contoso.com:8081/my.

    • Credential: Specifies the Replication Engine service credentials the first time you run this cmdlet or anytime you want to change the Replication Engine service credentials. To get the User Profile Replication Engine service credentials, use the Get-Credential cmdlet. For more information, see Get-Credential (http://go.microsoft.com/fwlink/p/?LinkID=113311).

    • EnableInstrumentation: Enables detailed logging by using the instrumentation log.

    • Properties: Specifies which user profile properties to replicate, for example, "FirstName" or "AboutMe". You can also use the Get-SPProfilePropertyCollection cmdlet to return a collection of all user profile properties. The default value returns all user profile properties. Note that properties that are mapped to the external data source will be overwritten the next time user profiles are imported.

    For example, for the destination farm at http://America.contoso.com and the source farm at http://Europe.contoso.com, the command is:

    Copy code
    Start-SPProfileServiceIncrementalReplication -Destination http://America.contoso.com -Source http://Europe.contoso.com -Credential $mycredential -EnableInstrumentation -Properties "AboutMe", "PictureURL"

    For more information, see Start-SPProfileServiceIncrementalReplication.

    Note:

    We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

  7. If you have to stop incremental replication for any reason, use the Stop-SPProfileServiceIncrementalReplication cmdlet. Do not start or stop incremental replication by manually starting or stopping the User Profile Service Replication Engine service by using the Windows MMC snap-in.

The full replication process does not use change tokens and it overwrites data in the destination regardless of changes that you made to it. Therefore, we recommend that you remove all change token files (one per each unique source-destination pair) that were created in previous incremental replication that was run immediately after full replication. This will guarantee that the next time incremental replication for such source-destination pair runs, it retrieves the fresh token from the source and does not rely on the stale token in the file. By default, the token files are stored on the server where you installed the User Profile Replication Engine, in %CommonProgramFiles%\Microsoft\SharePoint 2010 Administration Toolkit\Replication Engine\log, and named in the format of <SourceServerName>#<DestinationServerName>_Timestamp_UPS where <SourceServerName> is the name of the source server and <DestinationServerName> is the name of the destination server.

Whereas removal of a colleague on the source farm is tracked, the User Profile Replication Engine does not replicate account deletions, even though they are captured in the change log by SharePoint components. If any accounts are deleted from the source farm since the last replication, you must manually remove those accounts on the destination farm.

Perform recovery replication

You can use start-spprofileservicerecoveryreplication to perform recovery replication.

Note:

The recovery process replicates the same subset of properties from the source account as specified in parameters that are passed to cmdlet, or all if none are specified. But, during recovery replication, values of properties are retrieved directly from the source user profile, not from the change log. It means that those properties will be retrieved and updated even they are not changed, or for some reason changes are not logged in the change log store.

To perform recovery replication by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. Before performing recovery replication, you must prepare an accounts file. This file can be either the failed accounts file that is created during an instance of full replication, or you can manually create a .txt or .rcv file that contains one user profile account per line, for example:

    Domain1\User1

    Domain1\User2

    Domain2\User1

    Domain2\User2

    Domain2\User3

  4. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Start-SPProfileServiceRecoveryReplication -Destination <String> -FileName <String> -Source <String> [-EnableInstrumentation <SwitchParameter>] [-Properties <String[]>]

    Where:

    • Destination: Specifies the URL of the My Site Host to where the user profiles are replicated, for example, http://euro.contoso.com:8081/my.

    • Source: Specifies the URL of the My Site Host from where the user profiles are retrieved, for example, http://hq.contoso.com:8081/my.

    • FileName: Specifies the location of the accounts file. This file can be either the failed account file created during an instance of full replication or you can manually create a .txt or .rcv file that contains one user profile account per line.

    • EnableInstrumentation: Enables detailed logging by using the instrumentation log.

    • Properties: Specifies which user profile properties to replicate, for example, "FirstName" or "AboutMe". You can also use the Get-SPProfilePropertyCollection cmdlet to return a collection of all user profile properties. The default value returns all user profile properties. Note that properties that are mapped to the external data source will be overwritten the next time user profiles are imported.

    For example, for the destination farm at http://America.contoso.com and the source farm at http://Europe.contoso.com, the command is as follows:

    Copy code
    Start-SPProfileServiceRecoveryReplication -Destination http://America.contoso.com -FileName "d:\accounts.txt" -Source http://Europe.contoso.com -EnableInstrumentation -Properties "AboutMe", "PictureURL"

    For more information, see Start-SPProfileServiceRecoveryReplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Monitor the replication process

You can enable and view the instrumentation log to monitor the replication process by using the EnableInstrumentation parameter. When the instrumentation log is enabled, the cmdlet logs instrumentation information in the file that is named Full_<TmeStamp> for full replication or Inc_UPS_<DestinationServerName> for incremental replication, under %CommonProgramFiles%\Microsoft\SharePoint 2010 Administration Toolkit\Replication Engine\log, on the server where you installed the User Profile Replication Engine.

The following table lists the log files that the User Profile Replication Engine generates during incremental replication.

Log files for incremental replication

Log file | Description
Inc_UPS_Err | Stores error messages.
Inc_UPS_Err_Acct | Stores accounts that had errors during replication. These accounts are used by recovery replication.
Inc_UPS_Instrumentation | If you use the EnableInstrumentation parameter, verbose log entries are written in this log file.
IncrementalManager_Err_Start | Stores high-level exceptions that are captured during incremental replication.

See also

Use Windows PowerShell cmdlets to configure the User Profile service in SharePoint Server 2013


Maintain user profile synchronization settings in SharePoint Server 2013

Published: October 11, 2012

Summary: Learn how to maintain User Profile synchronization settings in SharePoint Server 2013 after you configure User Profile synchronization.

Applies to: SharePoint Server 2013

Profile synchronization in SharePoint Server 2013 enables an administrator of an instance of the User Profile service to synchronize user and group profile information that is stored in the SharePoint Server 2013 profile store with profile information that is stored in directory services across the enterprise. After you have configured User Profile synchronization, you must complete tasks to maintain those settings. These tasks include, for example, removing users whose accounts are disabled or deleted, moving or renaming a server, and starting or stopping the User Profile Synchronization service. For more information, see Plan profile synchronization for SharePoint Server 2013.

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Before you begin

  • Rename users or change user domains

  • Exclude users whose accounts are disabled

  • Remove obsolete users and groups

  • Maintain profile schema changes

  • Rename a server that is running the User Profile synchronization service

  • Move the User Profile Synchronization service to a new server

  • Reset User Profile synchronization

  • Restrict User Profile synchronization communication to a specific domain controller

  • Adjust User Profile synchronization time-outs

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • The farm is running either the Standard or Enterprise version of SharePoint Server 2013 and you have run the farm configuration wizard.

    Caution:

    Profile synchronization does not work on a stand-alone installation of SharePoint Server 2013. You must have a full installation of SQL Server, not the Express edition. As a result, User Profile synchronization will not work if you have installed SharePoint Server 2013 by following the instructions in Install SharePoint 2013 on a single server with SQL Server.

  • An instance of the User Profile service application exists and is started. For more information, see Create, edit, or delete User Profile service applications in SharePoint Server 2013.

Important:

See Hardware and software requirements for SharePoint 2013 for other requirements that may be needed for Profile Synchronization.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

Rename users or change user domains

SharePoint Server 2013 lets you handle several different user migration scenarios. The following are examples of the scenarios handled for Active Directory Domain Services (AD DS):

  • Account name (sAMAccountName) changes in the AD DS where the user exists.

  • Security Identifier (SID) changes.

  • Distinguished name (DN) changes that include changes in the organizational unit (OU) container in the AD DS where the user account exists. For example, if a user's distinguished name is moved in AD DS from "User= EUROPE\John Smith, Manager=CN=John Rodman, OU=Users, DC=EMEA1, DC=corp, DC=contoso, DC=com" to "User= EUROPE\John Smith, Manager=CN=John Rodman, OU=Managers, DC=EMEA1, DC=corp, DC=contoso,DC=com", the MigrateUser command updates the user profile store for this user. The user profile for John Smith is updated when synchronizing user profiles from the EMEA1.corp.contoso.com AD DS to the SharePoint Server user profile store.

To rename users or to change user domains

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

    • The user account that performs this procedure is a member of the Administrators group on the computer on which you installed the User Profile synchronization service.

  2. If synchronization is in progress, open Central Administration and then click Manage service applications in the Application Management section. Select the appropriate User Profile service application from the list of service applications. On the Manage service application page, click Stop Profile Synchronization.

  3. Disable the User Profile Incremental Synchronization timer job.

  4. Ensure that user migration by using stsadm -o migrateuser has succeeded.

  5. Ensure that the profile of the migrated user can be accessed by browsing to the My Site for that user, for example, http://mysite/person.aspx?accountname=<new account name>.

  6. Run User Profile synchronization. For more information, see Start profile synchronization manually in SharePoint Server 2013.

  7. Recheck access to the profile of the migrated user by browsing to the My Site for that user.

  8. Enable the User Profile Incremental Synchronization timer job.

Exclude users whose accounts are disabled

You can exclude users whose accounts are disabled in AD DS by using exclusion filters in SharePoint Server 2013. For the steps that are needed to exclude users whose accounts are disabled, see Synchronize user and group profiles in SharePoint Server 2013.

Remove obsolete users and groups

There are two reasons why obsolete users or groups can exist in the SharePoint Server 2013 user profile store:

  • Obsolete users: The My Site cleanup timer job is not active. The User Profile Synchronization timer job marks for deletion users who have been deleted from the directory source. When the My Site cleanup job runs, it looks for all users marked for deletion and deletes their profiles. Respective My Sites are then assigned to the manager for the deleted user and an e-mail message notifies the manager of this deletion.

  • Obsolete users and groups: Users and groups that were not imported by Profile Synchronization exist in the user profile store. This can occur, for example, if you upgraded from an earlier version of SharePoint Server and chose to only synchronize a subset of domains with SharePoint Server 2013.

To find and remove obsolete users and groups by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Execute permission on the ImportExport_GetNonimportedObjects and the ImportExport_PurgeNonimportedObjects stored procedures in the profile database.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets. You can use SQL Management Studio or Transact-SQL to grant database permissions. For more information, see GRANT Object Permissions (Transact-SQL) .

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, do the following:

    1. To get the User Profile Service application object, type the following command:

      Copy code
      $upa = Get-spserviceapplication <identity>

      Where <identity> is the GUID of the User Profile synchronization service application.

    2. To view the users and groups to delete, type the following command:

      Copy code
      Set-SPProfileServiceApplication $upa -GetNonImportedObjects $true

    3. To delete the obsolete users and groups, type the following command:

      Warning:

      This action cannot be undone.

      Copy code
      Set-SPProfileServiceApplication $upa -PurgeNonImportedObjects $true

For more information, see Get-SPServiceApplication and Set-SPProfileServiceApplication.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Maintain profile schema changes

Profile schema changes include things such as adding a new user profile property, changing a user profile property mapping, or changing a Profile Synchronization connection filter. When the profile schema changes, you must first perform a full nonrecurring synchronization before scheduling recurring profile synchronization. For the steps that are needed to perform full nonrecurring profile synchronization, see Start profile synchronization manually in SharePoint Server 2013.

Rename a server that is running the User Profile synchronization service

Use the following procedure to rename a profile synchronization server.

To rename a server that is running the User Profile synchronization service by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Rename-SPServer <Identity> -Name <newName>

    Where:

    • Identity is the old name of the server.

    • newName is the new name for the server.

For more information about renaming a server by using Windows PowerShell, see Rename-SPServer.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Move the User Profile Synchronization service to a new server

Use the following procedure to move the User Profile Synchronization service to a new server.

To move the User Profile Synchronization service to a new server by using Central Administration

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

    • The user account that performs this procedure is a member of the Administrators group on the computer on which you installed the User Profile synchronization service. This is required to start the User Profile Synchronization service. After the User Profile Synchronization service is started you can remove the farm account from the Administrators group.

  2. On the server that is currently running the User Profile synchronization service, on the SharePoint Central Administration website, in the System Settings section, click Manage services on Server.

  3. Next to the User Profile Synchronization Service, click Stop to stop the User Profile Synchronization service.

  4. On the new User Profile synchronization server, on the SharePoint Central Administration website, in the System Settings section, click Manage services on Server.

  5. Next to the User Profile Synchronization Service, click Start to start the User Profile synchronization service.

  6. On the new User Profile synchronization server, on the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  7. On the Service Applications page, click the link for the name of the appropriate User Profile service application.

  8. On the User Profile Service Application page, in the Synchronization section, click Start Profile Synchronization.

  9. On the Start Profile Synchronization page, select Start Full Synchronization, and then click OK.

Reset User Profile synchronization

The User Profile synchronization database serves as a staging area for User Profile information. User Profile information that is stored in the profile store and synchronization database is consumed by the User Profile service. By following these steps, you can safely reset a User Profile Synchronization database without losing information in the profile store.

To reset User Profile synchronization by using Windows PowerShell and Central Administration

  1. Verify that the user account that is performing this procedure has the following credentials:

    • The user account that performs this procedure is a member of the Farm Administrators group on the computer that is running the SharePoint Central Administration website.

    • The user account that performs this procedure is a member of the Administrators group on the computer on which you installed the User Profile synchronization service. This is required to start the User Profile Synchronization service. After the User Profile Synchronization service is started you can remove the farm account from the Administrators group.

  2. As a precaution, back up the User Profile service application. For more information, see Back up service applications in SharePoint 2013.

  3. If you are using the My Site cleanup timer job, you must disable it before you reset the synchronization database. Otherwise, the job will delete all user profiles and My Sites from the farm. For information about this timer job, see the Timer job reference (SharePoint 2013). For information about the Windows PowerShell cmdlets that you use to enable and disable this timer job, see Use Windows PowerShell cmdlets to manage timer jobs in SharePoint 2013.

  4. Disable the User Profile Incremental Synchronization timer job:

    1. On Central Administration, click Monitoring.

    2. Click Review job definitions.

    3. Click User Profile Service Application Name-User Profile Incremental Synchronization.

      Where User Profile Service Application Name is the name of the User Profile service application.

    4. Click Disable.

  5. On the Start menu, click All Programs.

  6. Click Microsoft SharePoint 2013 Products.

  7. Right-click SharePoint 2013 Management Shell and then click Run as administrator.

  8. In the User Account Control dialog box, click Yes.

  9. At the Windows PowerShell command prompt, type the following command to stop the SharePoint 2013 Timer service:

    Copy code
    net stop sptimerv4

  10. Copy the following code and paste it into a text editor, such as Notepad:

    Copy code
    $syncdb=Get-SPDatabase <SyncDBGUID>
$syncdb.Unprovision()
$syncdb.Status='Offline'
$upa=Get-SPServiceApplication <UPSAppGUID>
$upa.ResetSynchronizationMachine()
$upa.ResetSynchronizationDatabase()
$syncdb.Provision()

  11. Replace the following placeholders with values where:

    • <SyncDBGUID> is the GUID of the synchronization database.

    • <UPSAppGUID> is the GUID of the User Profile Service application.

    For more information, see Get-SPDatabase.

  12. Save the file as an ANSI-encoded text file and name the file ResetSyncDB.ps1.

  13. At the Windows PowerShell change to the directory where you saved the file.

  14. Type the following command:

    Copy code
    ./ResetSyncDB.ps1

  15. Using SQL Server Management Studio, create a login in SQL Server for the User Profile synchronization service account (that is, the farm account). Then, in the synchronization database, create a database user who maps to the login and grant it access to the db_owner database role. For more information, see How to: Create a SQL Server Login, How to: Create a Database User, and Database-Level Roles.

  16. At the Windows PowerShell command prompt, type the following command to start the SharePoint 2013 Timer service:

    Copy code
    net start sptimerv4

  17. Start the User Profile synchronization service. For more information, see the Start the User Profile synchronization service section of the "Configure profile synchronization" topic.

  18. Reset IIS. For more information about how to reset IIS, see the Reset IIS section of the "Configure profile synchronization" topic.

  19. Create connections to the data sources. For more information, see Restore service applications in SharePoint 2013.

  20. If you do not intend to use the My Site cleanup timer job, run profile synchronization. For more information about how to run profile synchronization, see Start profile synchronization manually in SharePoint Server 2013. If you intend to enable the My Site cleanup timer job, complete these additional steps before you enable the job:

    1. Run two full profile synchronizations.

    2. After the second profile synchronization is finished, on Central Administration, in the Application Management section, click Manage service applications.

    3. Click the User Profile service application name, and then click Manage User Profiles.

    4. On the Manage Profile Service page, in the People section, click Manage User Profiles.

    5. Next to View, select Profiles Missing from Import.

    6. In the Find Profiles box, type the domain for the profiles and then click Find.

    7. For each profile that is returned, check the originating directory service, such as Active Directory, for the status of that profile. If the status of any of the returned profiles in the directory is not disabled or is not deleted, do not enable the My Site cleanup timer job. Contact Microsoft support for more assistance. Otherwise, enable the My Site cleanup timer job. For information about the Windows PowerShell cmdlets that you use to enable and disable this timer job, see Use Windows PowerShell cmdlets to manage timer jobs in SharePoint 2013.

  21. Enable the User Profile Incremental Synchronization timer job:

    1. On Central Administration, click Monitoring.

    2. Click Review Job Definitions.

    3. Click User Profile Service Application Name-User Profile Incremental Synchronization.

      Where User Profile Service Application Name is the name of the User Profile service application.

    4. Click Enable.

Restrict User Profile synchronization communication to a specific domain controller

Use the following procedure to restrict profile synchronization communication to a specific domain controller.

To restrict User Profile synchronization communication to a specific domain controller by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. To get the User Profile service application object, type the following command:

    Copy code
    $upa=Get-SPServiceApplication <GUID>

    Where <GUID> is the GUID of the User Profile Synchronization Service application.

  6. To restrict profile synchronization communication to a specific domain controller, type the following command:

    Copy code
    Set-SPProfileServiceApplication $upa -UseOnlyPreferredDomainControllers $true
    Note:

    It may take five minutes for the changed property value to propagate to the SharePoint Central Administration website. Resetting IIS on the Central Administration server will force the new value to be loaded immediately. For more information about resetting IIS, see IIS Reset Activity.

For more information, see Get-SPServiceApplication and Set-SPProfileServiceApplication.

Adjust User Profile synchronization time-outs

A time-out can occur on the following occasions:

  • When trying to connect to the directory service server on the Add/Edit a synchronization connection page in Central Administration.

  • When trying to populate the list of containers on the Add/Edit a synchronization connection page in Central Administration. This will occur as a JavaScript time-out error in the status bar.

  • When clicking OK on the Add/Edit a synchronization connection page in Central Administration. This causes the following error message and occurs because of a time-out by the Forefront Identity Manager web service when creating or updating a User Profile synchronization connection:

    "The request channel timed out while waiting for a reply after 00:01:29.9062626. Increase the timeout value passed to the call to Request or increase the SendTimeout value on the Binding. The time allocated to this operation may have been a part of a longer timeout."

To adjust User Profile synchronization timeouts by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. If you want to change the time-out value for connecting to the directory server, do the following:

    1. Paste the following code into a text editor, such as Notepad:

      Copy code
      $upsAppProxy = Get-SPServiceApplicationProxy <UPSAppProxyGUID>
$upsAppProxy.LDAPConnectionTimeout = <NewTimeout>
$upsAppProxy.Update()

    2. Replace <UPSAppProxyGUID> with the GUID of the User Profile service application proxy and <NewTimeout> with the new time-out value in seconds. The default time-out is 120 seconds.

    3. Save the file as an ANSI-encoded text file whose extension is .ps1.

  3. If you want to change the time-out value for the Populate Containers control, do the following:

    1. Paste the following code into a text editor, such as Notepad:

      Copy code
      $upsAppProxy = Get-SPServiceApplicationProxy <UPSAppProxyGUID>
$upsAppProxy.ImportConnAsyncTimeout = <NewTimeout>
$upsAppProxy.Update()

    2. If you want to change the time-out value for calls into the Forefront Identity Manager web service, do the following:

      Replace <UPSAppProxyGUID> with the GUID of the User Profile service application proxy and <NewTimeout> with the new time-out value in seconds. The default time-out is 1,000 seconds (approximately 17 minutes).

    3. Paste the following code into a text editor, such as Notepad:

      Copy code
      $upsApp = Get-SPServiceApplication
<UPSAppGUID>
$upsApp.FIMWebClientTimeOut =
<NewTimeout>
$upsApp.Update()

    4. Replace <UPSAppGUID> with the GUID of the User Profile service application and <NewTimeout> with the new time-out value in milliseconds. The default time-out is 300,000 milliseconds (5 minutes).

    5. Save the file as an ANSI-encoded text file whose extension is .ps1, such as AdjustProfileSyncTimeouts.ps1.

  4. On the Start menu, click All Programs.

  5. Click Microsoft SharePoint 2013 Products.

  6. Click SharePoint 2013 Management Shell.

  7. Change to the directory where you saved the file.

  8. At the Windows PowerShell command prompt, type the following command to execute a script file:

    Copy code
    ./<file name>.ps1

    Where <file name> is the name of the file to execute.

For more information, see Get-SPServiceApplicationProxy and Get-SPServiceApplication.


Start profile synchronization manually in SharePoint Server 2013
See also

Published: October 23, 2012

Summary: Learn how to start profile synchronization manually in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

This article describes how to start profile synchronization for SharePoint Server 2013 manually. You can start a full synchronization or an incremental synchronization of profile information. You might want to consider starting profile synchronization manually if you have made considerable changes to user profiles, for example if you want to test the profile synchronization feature.

For information about when to use full or incremental synchronization, see Types of synchronization in Overview of profile synchronization in SharePoint Server 2013.

You can also schedule profile synchronization to run automatically according to a schedule. For more information, see Schedule profile synchronization in SharePoint Server 2013.

Important:

This article applies to only SharePoint Server 2013.

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • Ensure that you have completed the steps that are described in Synchronize user and group profiles in SharePoint Server 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Start profile synchronization manually

You can manually start a full synchronization or an incremental synchronization of profile information.

To start profile synchronization manually

  1. Verify that the user account that is performing this procedure is a farm administrator or an administrator of the User Profile service application to perform this procedure. If the user account is not a farm administrator, start this procedure by using the Manage Profile Service page.

  2. On the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click in the Name column of the User Profile Service Application row.

  4. On the Manage Profile Service page, in the Synchronization section, click Start Profile Synchronization.

  5. On the Start Profile Synchronization page, select Start Incremental Synchronization to synchronize only profiles that have changed since the last synchronization, or select Start Full Synchronization to synchronize all profiles.

    Note:

    Full synchronization can take a long time. For more information about when to use full synchronization and incremental synchronization, see the "Types of synchronization" section in Overview of profile synchronization in SharePoint Server 2013.

  6. Click OK.

    Note:

    Refresh the Manage Profile Service page to view the profile synchronization status.

See also

Manage user profile synchronization in SharePoint Server 2013
Overview of profile synchronization in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013
Synchronize user and group profiles in SharePoint Server 2013
Schedule profile synchronization in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013


Schedule profile synchronization in SharePoint Server 2013
See also

Published: October 23, 2012

Summary: Learn how to configure the Profile Incremental Synchronization timer job to define the schedule for running incremental profile synchronization in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

This article describes how to configure the Profile Incremental Synchronization timer job to define the schedule for running incremental profile synchronization. You must have first performed a full synchronization before you can set the incremental synchronization schedule. For more information, see Plan profile synchronization for SharePoint Server 2013.

Important:

This article applies to only SharePoint Server 2013.

In this article:

  • Before you begin

  • Schedule profile synchronization

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • Ensure that you have completed the steps that are described in Synchronize user and group profiles in SharePoint Server 2013.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Schedule profile synchronization

Follow this procedure to schedule profile synchronization. You must have first performed a full synchronization before you can set the incremental synchronization schedule.

To schedule profile synchronization

  1. Verify that the user account that is performing this procedure is a farm administrator or an administrator of the User Profile service application to perform these procedures. If the user account is not a farm administrator, start this procedure by using the Manage Profile Service page.

  2. On the Central Administration Web site, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click in the Name column of the User Profile service application row.

  4. On the Manage Profile Service page, in the Synchronization section, click Configure Synchronization Timer Job.

  5. On the Edit Timer Job page, in the Recurring Schedule section, select the frequency at which you want recurring profile synchronization to occur.

    • If you select Minutes, type the number of minutes that should pass between the start of each timer job.

    • If you select Hourly, type the number of minutes past every hour that the timer job should start to run at the earliest, and type the number of minutes past every hour that the timer job should start to run at the latest.

    • If you select Daily, select the time at which the timer job should start to run, at the earliest and at the latest, every day.

    • If you select Weekly, select the earliest and latest day and time at which the timer job should start to run every week.

    • If you select Monthly, either select the earliest and latest date and time at which the timer job should start to run every month, or select a day and time at which the timer job should start to run every month.

    Note:

    If you want to specify an exact starting time for the timer job to run, set the same value in the start and end times of the interval in which the timer job should start.

  6. Click OK.

    If you want to start the profile synchronization immediately, click Run Now.

See also

Manage user profile synchronization in SharePoint Server 2013
Administer the User Profile service in SharePoint Server 2013
Synchronize user and group profiles in SharePoint Server 2013
Start profile synchronization manually in SharePoint Server 2013
Plan profile synchronization for SharePoint Server 2013
Use Windows PowerShell cmdlets to manage timer jobs in SharePoint 2013


Administer search in SharePoint Server 2013

Summary: Learn how to improve search results and to manage crawling, the search schema and the search topology in SharePoint 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet provide information about how you operate and manage search in SharePoint 2013.

TechNet articles about administering search

The following articles about administering search in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Manage the search schema in SharePoint Server 2013 | Learn how to view, add, edit, map, and delete crawled properties, crawled property categories and managed properties in the search schema.
 | Manage the Search Center | Learn about pages that are created in a Search Center site in SharePoint 2013, and see articles about how to configure Web Parts.
 | Manage search relevance in SharePoint Server 2013 | Learn how you can configure settings to provide the most relevant search results.
 | Manage crawling in SharePoint 2013 | Learn how to crawl content that you want users to be able to search for in SharePoint 2013.
 | Manage the search topology in SharePoint Server 2013 | Learn how to manage search components to scale out the search topology in SharePoint 2013.
 | View search diagnostics in SharePoint Server 2013 | Learn about search and usage reports, query health reports, crawl health reports and the crawl log to analyze the health of the search system.
 | Enable search alerts in SharePoint Server 2013 | Learn how to enable or disable search alerts.
 | Enable query logging in SharePoint Server 2013 | Learn how to enable or disable query logging.
 | Export and import customized search configuration settings in Sharepoint Server 2013 | Learn how to import and export customized search configuration settings.


Manage the search schema in SharePoint Server 2013
See also

Updated: August 13, 2013

Summary: Learn how to view, add, edit, map, and delete crawled properties, crawled property categories and managed properties in the search schema.

Applies to: SharePoint Server 2013

Crawled properties are metadata that is extracted from documents during crawls. Metadata can be structured content (such as the title or the author from a Word document), or unstructured content (such as a detected language or extracted keywords).

Users can only search on managed properties and not on crawled properties. To make a crawled property available for search queries, you must map the crawled property to a managed property. You can map multiple crawled properties to a single managed property or map a single crawled property to multiple managed properties.

Important:

The steps in this article apply to SharePoint 2013 and use the Central Administration, unless specified otherwise.

In this article:

  • Before you begin

  • To view crawled properties and managed properties

  • To add a managed property

  • To edit a managed property

  • To delete a managed property

  • To map a crawled property to a managed property

  • To view or edit crawled property categories

  • Add a managed property using tenant administration or site collection administration

  • Search schema changes that require content to be reindexed

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application.

  • Add one or more content sources and run a full crawl.

To view crawled properties and managed properties

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Queries and Results, click Search Schema.

  5. On the Managed Properties page, you see an overview of all the managed properties, the settings on the managed properties and the crawled properties they are mapped to. To view crawled properties, click Crawled Properties. To view crawled property categories, click Categories.

To add a managed property

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Queries and Results, click Search Schema.

  5. On the Managed Properties page, click New Managed Property.

  6. On the New Managed Property page, in the Property name box in the Name and description section, enter the name of the new managed property. You can also enter a description.

  7. In the Type section, select one of the following options for the property:

    • Text

    • Integer

    • Decimal

    • Date and Time

    • Yes/No

    • Double precision float

    • Binary

  8. In the Main characteristics section, select one or several of the following:

    • Searchable

    • Advanced Searchable Settings (optional, if Searchable is selected)

    • Queryable

    • Retrievable

    • Allow multiple values

    • Refinable

    • Sortable

    • Alias

    • Token Normalization

    • Complete Matching

    Important:

    If you want to be able to use this managed property as a refiner, you must select both Refinable and Queryable.

  9. In the Mappings to crawled properties section, click Add a mapping.

  10. On the Crawled property selection page, select a crawled property to map to the managed property and then click OK. Repeat this step to map more crawled properties.

  11. On the New Managed Property page, in the Mappings to crawled properties section, specify if you want to include:

    • All content from all crawled properties mapped to this managed property

    • Content from the first crawled property that contains a value and, optionally, in which order.

  12. In the Company name extraction section, you can optionally select the check box to enable company name extraction.

  13. In the Custom entity extraction section, you can optionally select the check box to enable custom entity extraction. See Create and deploy custom entity extractors in SharePoint Server 2013 for the procedures.

  14. Click OK.

Important:

You have to perform a full crawl of the content source or sources that contain this new managed property to include it in the search index. If the new managed property is in a SharePoint library or list, you have to reindex that library or list.

For more information, see Overview of the search schema in SharePoint Server 2013.

To edit a managed property

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Queries and Results, click Search Schema.

  5. On the Managed Properties page, find the managed property that you want to edit, or enter its name in the Filter box.

  6. Point to the managed property that you want to edit, click the arrow, and then click Edit/Map property.

  7. On the Edit Managed Property page, edit the settings and then click OK.

Important:

Some changes on managed property settings require a full crawl to take effect. See the table Search schema changes that require content to be reindexed for an overview of which changes require you to reindex the content.

For more information, see Overview of the search schema in SharePoint Server 2013.

To delete a managed property

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Queries and Results, click Search Schema.

  5. On the Managed Properties page, find the managed property that you want to delete, or enter its name in the Filter box.

  6. Point to the managed property that you want to delete, click the arrow, and then click Delete.

  7. Click OK.

Important:

If you delete a managed property:

  • Users can no longer run queries using this property.

  • A query rule that uses this property no longer works.

  • A custom search application or web part that uses this property no longer works.

  • To delete this property from the search index, you'll have to perform a full crawl. If the deleted property was in a SharePoint library or list, you'll have to reindex that library or list.

To map a crawled property to a managed property

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Queries and Results, click Search Schema.

  5. On the Crawled Properties page, find the crawled property that you want to map to a managed property, or enter its name in the Filters box.

  6. Point to the crawled property that you want to map, click the arrow, and then click Edit/Map property.

  7. On the Edit Crawled Property page, in the Mappings to managed properties section, click Add a Mapping.

  8. On the Managed property selection page, select one managed property to map to the crawled property and then click OK. Repeat this step to map more managed properties to this crawled property.

  9. In the Include in full-text index section, check the box if you want to include the content of this crawled property in the full-text index.

  10. On the Edit Crawled Property page, click OK.

Note:

You have to perform a full crawl of the content source that includes the crawled property that you've mapped to a managed property for the new mapping to take effect. If the new mapping is for a SharePoint library or list, you have to reindex that library or list.

To view or edit crawled property categories

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Queries and Results, click Search Schema.

  5. On the Categories page, find the crawled property category that you want to view or edit.

    1. To view which crawled properties belong to a category, and which managed properties they are mapped to, click the crawled property category in the Categories page.

    2. To edit a category, point to the crawled property category that you want to edit, click the arrow, and then click Edit category.

      Warning:

      If you edit a crawled property category, your changes apply to all of the crawled properties within the category. Changing a crawled property category can influence performance and how items are saved in the search index. You also have to reindex the content.

Add a managed property using tenant administration or site collection administration

Tenant administrators and site collection administrators can create a search schema that is specific for their tenant or site collection. For more information how to manage the search schema for tenants and site collections, see Manage the search schema in SharePoint Online.

You can create new managed properties for a tenant or a site collection and map crawled properties to them. Alternatively, you can reuse existing, unused managed properties that do not have crawled properties mapped to them, and rename them using an Alias. Then, you must map crawled properties to the renamed managed property with the defined alias.

When you create a new managed property in the tenant or site collection administration, there are some limitations. For example, the property can only be of type Text or Yes/No, and it can't be refinable or sortable. If you need a property of a different type, or one that has different characteristics than what is available, follow the steps under To create a managed property by renaming an existing one .

When you have added a new property to a list or to a library on a SharePoint site, or when you have changed properties that are used in a list or library, the content must be re-crawled before your changes will be reflected in the search index. Because your changes are made in the search schema, and not to the actual site, the crawler will not automatically reindex the list or the library. To make sure that your changes are crawled and reindexed, you can specifically request a reindexing of the list or library. When you do this, the list or library content will be recrawled and reindexed so that you can start using your new managed properties in queries, query rules and display templates.

See the table Search schema changes that require content to be reindexed for an overview of which managed property setting changes require you to reindex the content.

To create a managed property for a tenant or a site collection

  1. Verify that the user account that is performing this procedure is an administrator for the tenant or for the site collection.

  2. Go to the Search Schema page for the tenant or for a site collection.

    • For the tenant:

      1. Sign in to the Office 365 Admin Center.

      2. Choose Admin > SharePoint. You're now in the SharePoint admin center.

      3. Click search, and then on the search administration page, click Manage Search Schema.

    • For the site collection:

      1. On your site, go to Settings, click Site settings and then under Site Collection Administration, click Search Schema.

  3. On the Managed Properties page, click New Managed Property.

  4. On the New Managed Property page, in the Property name box in the Name and description section, enter the name of the new managed property. You can also enter a description.

  5. In the Type section, select one of the following options for the property:

    • Text

    • Yes/No

  6. In the Main characteristics section, select one or several of the available options.

  7. In the Mappings to crawled properties section, click Add a mapping.

  8. On the Crawled property selection page, select a crawled property to map to the managed property and then click OK. Repeat this step to map more crawled properties.

  9. On the New Managed Property page, in the Mappings to crawled properties section, specify if you want to include:

    • All content from all crawled properties mapped to this managed property

    • Content from the first crawled property that contains a value and, optionally, in which order.

  10. Click OK.

To create a managed property by renaming an existing one

  1. Verify that the user account that is performing this procedure is an administrator for the tenant or for the site collection.

  2. Go to the Search Schema page for the tenant or for a site collection.

    • For the tenant:

      1. Sign in to the Office 365 Admin Center.

      2. Choose Admin > SharePoint. You're now in the SharePoint admin center.

      3. Click search, and then on the search administration page, click Manage Search Schema.

    • For the site collection:

      1. On your site, go to Settings, click Site settings and then under Site Collection Administration, click Search Schema.

  3. On the Managed Properties page, find an unused managed property. By unused, we mean that the property is not mapped to a crawled property: the Mapped Crawled Properties column is empty. See the Default unused managed properties table for more details. Point to the managed property, click the arrow, and then click Edit/Map property.

  4. On the Edit Managed Property page, in the Main characteristics section, under Alias, enter a name in the field.

  5. In the Mappings to crawled properties section, click Add a mapping.

  6. On the Crawled property selection page, select a crawled property to map to the managed property and then click OK. Repeat this step to map more crawled properties to this managed property.

  7. Click OK.

To reindex a list or library

  1. Verify that the user account that is performing this procedure is an administrator for the tenant or for the site collection.

  2. Browse to the list or library that you want to recrawl, and then do one of the following:

    • If you want to perform a full crawl of a library, click the LIBRARY tab, and then, on the ribbon, in the Settings group, click Library Settings.

    • If you want to perform a full crawl of a list, click the LIST tab, and then, on the ribbon, in the Settings group, click List Settings.

  3. On the Settings page, in the General Settings section, click Advanced settings.

  4. On the Advanced Settings page:

    • If you want to reindex a library: in the Reindex Library section, click Reindex Document Library.

    • If you want to reindex a list: in the Reindex List section, click Reindex List.

  5. Click OK.

Note:

The full reindex of the list or library will be performed during the next scheduled crawl.

Default unused managed properties

The following table provides an overview of the default unused managed properties that you can reuse and rename using an Alias.

Managed property type | Count | Managed property characteristics | Managed property name range
Date | 10 | Queryable | Date00 to Date09
Date | 20 | Multivalued, Queryable, Refinable, Sortable, Retrievable | RefinableDate00 to RefinableDate19
Decimal | 10 | Queryable | Decimal00 to Decimal09
Decimal | 10 | Multivalued, Queryable, Refinable, Sortable, Retrievable | RefinableDecimal00 to RefinableDecimal09
Double | 10 | Queryable | Double00 to Double09
Double | 10 | Multivalued, Queryable, Refinable, Sortable, Retrievable | RefinableDouble00 to RefinableDouble09
Integer | 50 | Queryable | Int00 to Int49
Integer | 50 | Multivalued, Queryable, Refinable, Sortable, Retrievable | RefinableInt00 to RefinableInt49
String | 100 | Multivalued, Queryable, Refinable, Sortable, Retrievable | RefinableString00 to RefinableString99

How to use an Alias: an example

Say that you want to create a managed property that contains employee numbers, and you want users to be able to search for these by typing "EmployeeID:12345", where "12345" is an example employee number. As this managed property is not of the type Text or Yes/No, you'll follow the steps in To create a managed property by renaming an existing one with this input:

  • Choose an unused managed property of the type integer, see the table Default unused managed properties. Use any unused property from Int00 to Int49 if you only want users to be able to query on the employee number, or from RefinableInt00 to RefinableInt49 if you want users to be able to query, refine, sort etc. on employee number.

  • Give the property an Alias, in this example EmployeeID.

  • Map the EmployeeID property to the crawled property that contains the employee numbers.

Search schema changes that require content to be reindexed

Managed property setting | Action | Requires a full crawl to reindex
Mapping a crawled to a managed property | Add/Delete mapping | Yes
Token normalization | Enable/Disable | Yes
Complete matching | Enable/Disable | Yes
Company name extraction | Enable/Disable | Yes
Custom entity extraction | Enable/Disable | Yes
Searchable | Enable/Disable | Yes
Queryable | Enable | Yes
Queryable | Disable | No
Retrievable | Enable | Yes
Retrievable | Disable | No
Refinable | Enable (if not already Sortable) | Yes
Refinable | Disable | No
Sortable | Enable (if not already Refinable) | Yes
Sortable | Disable | No
Alias | Add/Delete | No

See also

Overview of the search schema in SharePoint Server 2013

Change History

Date | Description
August 13, 2013 | Updated to reflect which search schema changes require content to be reindexed.
July 16, 2012 | Initial publication


Manage the Search Center

Published: November 13, 2012

Summary: Learn about pages that are created in a Search Center site in SharePoint Server 2013, and see articles about how to configure Web Parts.

Applies to: SharePoint Server 2013

When you create an Enterprise Search Center site collection as described in Create a Search Center site in SharePoint Server 2013, SharePoint 2013 creates a default search home page and a default search results page. In addition, several pages known as search verticals are also created. Search verticals are customized for searching specific content, such as People, Conversations, and Videos, and they display search results that are filtered and formatted for a specific content type or class.

The following pages are created in an Enterprise Search Center site collection:

  • default.aspx: the home page for the Search Center, and the page where end-users enter their queries.

  • results.aspx: the default search results page for the Search Center. It is also the search results page for the Everything search vertical.

  • peopleresults.aspx: the search results page for the People search vertical.

  • conversationresults.aspx: the search results page for the Conversations search vertical.

  • videoresults.aspx: the search results page for the Videos search vertical.

  • advanced.aspx: the search page where end-users can apply some restrictions to their search phrases — for example, limiting the search to an exact phrase.

These pages are located in the Pages library, and they contain Web Parts that you can customize to improve the end-user search experience. This article describes the Web Parts on these pages, and how you can configure the different Web Parts settings to improve how search results are displayed.

By default, the Web Parts on the search vertical pages (results.aspx, peopleresults.aspx, conversationresults.aspx, videoresults.aspx, advanced.aspx) are the same. However the query in the Search Results Web Part is configured differently for each search vertical page. For each search vertical page, the query in the Search Results Web Part is directed to a particular result source. This can be a result source that defines the search vertical or any result source that you want to direct queries to when you create a custom search vertical. For example, for the peopleresults.aspx search vertical page, the query in the Search Results Web Part is limited to the Local People Results (System) result source. For the videoresults.aspx search vertical page, the query in the Search Results Web Part is limited to the Local Video Results (System).

The following articles describe how to configure properties for each Web Part that is used in the Enterprise Search Center site:

  • Configure properties of the Search Box Web Part in SharePoint Server 2013

  • Configure properties of the Search Results Web Part in SharePoint Server 2013

  • Configure properties of the Refinement Web Part in SharePoint Server 2013

  • Configure properties of the Search Navigation Web Part in SharePoint Server 2013


Configure properties of the Search Box Web Part in SharePoint Server 2013
See also

Published: November 13, 2012

Summary: Learn how to configure properties of the Search Box Web Part.

Applies to: SharePoint Server 2013

By default, the Search Box Web Part is used on the home page for the Search Center (default.aspx), and all search results pages (results.aspx, peopleresults.aspx, conversationresults.aspx, videoresults.aspx). By changing properties in the Search Box Web Part you can you can do the following:

  • Change the Web Part or page where the search results should be displayed — for example, a custom Search Results Web Part or a custom search results page.

  • Turn off query suggestions and people suggestions. For more information about query suggestions, see Manage query suggestions in SharePoint Server 2013

  • Display links to a search preference page and an advanced search page.

  • Change the display template that is applied to the Web Part.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure properties of the Search Box Web Part

To configure the properties of a Search Box Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the Enterprise Search Center site.

  2. On the Search Center site home page, click the Settings menu, and then click Edit Page.

  3. In the Web Part, click the Search Box Web Part Menu arrow, and then click Edit Web Part.

  4. In the Web Part tool pane, in the Properties for Search Box section, expand the Which search results page should queries be sent to section, and then do the following:

    • To display the settings that are defined on the Search Settings page, select the Use this site's Search Settings check box.

    • To override the settings that are defined on the Search Settings page, clear the Use this site's Search Settings check box, and then do the following:

      • To display search results in a Web Part on the page, in the section Send queries to other Web Parts on this page, select a Web Part.

        Note:

        If there are no other Web Parts on a page, search results will be sent to the search results page as specified on the Search Settings page.

    • To send queries to a custom search results page, select Send queries to a custom results page URL, and then type the URL of the custom search results page.

  5. In the Web Part tool pane, in the Properties for Search Box section, expand the Query Suggestions section, and then do the following:

    • To disable query suggestions, clear the Show suggestions check box.

    • To specify additional properties for query suggestions, change the values in the following fields:

      • Number of query suggestions: How many query suggestions to display.

      • Minimum number of characters: How many characters the user must type before query suggestions are displayed.

      • Suggestions delay (in milliseconds): How many milliseconds elapse before query suggestions are displayed.

      • Number of personal favorites: How many query suggestions are displayed to the user under the text Are you looking for these again? in the search results. These suggestions are based on search results that the user has clicked previously. To disable personal favorite results, clear the Show personal favorite results check box.

    • To turn on people name suggestions, select Show people name suggestions.

  6. In the Web Part tool pane, in the Properties for Search Box section, expand the Settings section, and then do the following:

    • To show a link to a search preference page, select Show preferences link.

    • To show a link to an advanced search page, select Show advanced link, and then in the Advanced search page URL box, type the URL of the advanced search page that you want to link to.

    • To apply another display template, in the Search box control Display Template list, select the display template that you want to apply to the Web Part.

    • Select the Make the search box have focus when the page is loaded check box to make it possible for users to immediately type a query in the search box when the page is loaded without first having to click the search box. By default, this is selected.

See also

How to change the text that is displayed in the Search Box Web Part in SharePoint Server 2013


Configure properties of the Search Results Web Part in SharePoint Server 2013
See also

Published: November 13, 2012

Summary: Learn how to configure the query and properties of the Search Results Web Part, and how to disable stemming in the Web Part.

Applies to: SharePoint Server 2013

The Search Results Web Part displays the search results of a query entered in a Search Box Web Part. By default, the Search Results Web Part is used on all search vertical pages (results.aspx, peopleresults.aspx, conversationresults.aspx, videoresults.aspx). The Search Results Web Part displays the actual search results and it also passes the search results to the Refinement Web Part and the Search Navigation Web Part on the same page.

The Search Results Web Part uses a query that is specified in the Web Part to display search results. By default, the query defined in this Web Part uses the query variable {searchboxquery}. The query variable is a placeholder for a value. When a query is run, the placeholder is replaced with a value. For example, when a user types the search phrase yellow in the Search Box Web Part, the {searchboxquery} variable in the Search Results Web Part will resolve to search all items that contain the phrase yellow.

By changing the properties and query in the Search Results Web Part you can you can do the following:

  • Limit search results to a result source.

  • Add query variables or property filters that customize search results for different users.

  • Promote or demote items or pages within the search results.

  • Change the sorting of the search results.

  • Change the display template.

In this article:

  • Before you begin

  • Configure properties of the Search Results Web Part

  • To disable stemming in a Search Results Web Part

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure properties of the Search Results Web Part

To configure the properties of a Search Results Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the Enterprise Search Center site.

  2. On the search results page, click the Settings menu, and then click Edit Page.

  3. In the Search Results Web Part, click the Search Results Web Part Menu arrow, and then click Edit Web Part.

  4. In the Web Part tool pane, in the Search Criteria section, click Change query.

  5. On the BASICS tab, do one of the following:

    • To define your query by using Keyword Query Language (KQL), select options as described in the following table:

      Advanced Mode (default)

      Select a query

      Select a result source to specify which content should be searched.

      By default, the following result sources are set for the different search vertical pages:

      • Everything (results.aspx): Local SharePoint Results (System)

      • People (peopleresults.aspx): Local People Results (System)

      • Conversations (conversationresults.aspx): Conversations (System)

      • Videos (videoresults.aspx): Local Video Results (System)

      Keyword filter

      You can use keyword filters to add query variables to your query. For a list of available query variables,see Query variables in SharePoint Server 2013.

      You can select pre-defined query variables from the drop-down list, and then add them to the query by clicking Add keyword filter.

      Property filter

      You can use property filters to query the content of managed properties that are set to queryable in the search schema.

      You can select managed properties from the Property filter drop-down list. Click Add property filter to add the filter to the query.

      Query text

      By default, the query variable {searchboxquery} is defined for this field. You can change the query text by using KQL. For more information about KQL, see Keyword Query Language (KQL) syntax reference. Alternatively you can use the Keyword filter and Property filter lists to build the query.

      The keyword query can consist of free-text keywords, property filters, or operators. Use braces to enclose query variables. The query variables will be replaced with an actual value when the query is run.

      Keyword queries have a maximum length of 2,048 characters.

    • To define your query by using pre-defined variables, click Switch to Quick Mode. Select options as described in the following table:

      Quick Mode

      Select a query

      Select a result source to specify which content should be searched. If you have shared a document library or list as catalog, the catalog result source will be displayed in this drop-down list.

      Restrict by app

      Select an option from the list to restrict results to a specific site, library, list, or URL.

      Restrict by tag

      You can limit results to content that is tagged with a term from a term set.

      Select one of the following options:

      Don't restrict by any tag

      Search results will not be limited based on tags (default).

      Restrict by navigation term of current page

      Search results will be limited to content that is tagged with the term of the current page. The current tag is displayed as the last part of the friendly URL. This option is only meaningful for sites that use managed navigation.

      Restrict by current and child navigation

      Search results will be limited to content that is tagged with the term of the current page (displayed as the last part of the friendly URL), and content that is tagged with sub-terms of the current page. This option is only meaningful for sites that use managed navigation.

      Restrict on this tag

      Search results will be limited to content that is tagged with the tag that you type inside the box.

  6. The REFINERS tab lists the managed properties that are enabled as refiners in the search schema. You can specify that the search results returned in the Search Results Web Part should be limited to one or more values from the refiners. Select a refiner in the list, and then click Add to add it to the query.

    Click Show more if you want to define grouping of results. Under Group results, you can specify that the results should be grouped based on one or more managed properties. This is useful when you are displaying several variants for a given item, and want to group them under a single result.

  7. On the SORTING tab, you can specify how search results should be sorted. This tab is available only if you use Advanced Mode. If you use Quick Mode, you can define sorting options in the result source.

    In the Sort by drop-down list:

    1. Select a managed property from the list of managed properties that are set as sortable in the search schema, and then select Descending or Ascending. To add more sorting levels, click Add sort level.

    2. Select Rank to sort by relevance rank. You can then specify which ranking model to use or specify dynamic ordering rules.

      • (Optional) Select which ranking model to use for sorting in the Ranking Model list.

      • Under Dynamic ordering, you can specify additional ranking by adding rules that will change the order of results when certain conditions apply. Click Add dynamic ordering rule, and then specify conditional rules.

  8. On the SETTINGS tab, specify the settings that are listed in the following table.

    Query Rules

    Select whether to use Query Rules or not.

    URL Rewriting

    Select if the URL rewrite to the item details page should continue to be relative for each catalog item as defined when you set up the catalog connection. This option is only meaningful for sites that use managed navigation and have connected to a catalog that uses anonymous access for the catalog pages. If you select Don't rewrite URLs, the URLs for catalog items are pointed directly to the library item of the connected catalog.

    Loading Behavior

    Select when the search results returned by the Search Results Web Part appear on the web page. The default option is Async option: Issue query from the browser. Queries will be issued from the end-users browser after the complete page is received. This option may be considered for secondary content on a page — for example, Recommendations or Popular Items. If you select Sync option: Issue query from the server, queries are issued from the server, and the search results are included in the page response that is sent back from SharePoint.

  9. On the TEST tab, you can preview the query that is sent by the Search Results Web Part.

    Query text

    Shows the final query that will be run by the Search Results Web Part. It is based on the original query template where dynamic variables are substituted with current values. Other changes to the query may be made as part of a query rule.

    Click Show more to display additional information.

    Query template

    Shows the content of the query template that is applied to the query.

    Refined by

    Shows the refiners applied to the query as defined on the REFINERS tab.

    Grouped by

    Shows the managed property on which search results should be grouped as defined on the REFINERS tab.

    Applied query rules

    Shows which query rules are applied to the query.

    The Query template variables section shows the query variables that will be applied to the query, and the values of the variables that apply to the current page. You can type other values to test the effect they will have on the query. Click the Test Query button to preview the search results.

    You can also test how the query works for different user segment terms. Click Add user segment term to add terms to be added to the query.

    Click the Test query button to preview the search results.

    Query text

    Shows the final query that will be run by the Search Results Web Part. It is based on the original query template where dynamic variables are substituted with current values. Other changes to the query may be made as part of a query rule.

  10. In the Web Part tool pane, in the Display Templates section, the default selection is Use result types to display items. This selection will apply different display templates according to the result type of the search result. For example, if the result type of a search result is a PDF file, the display template PDF Item will be applied. If the result type of a search result is an image, the Picture Item display template will be applied. To apply one display template to all result types of the search results, select Use a single template to display items, and then select the display template that you want to apply.

  11. In the Web Part tool pane, in the Settings section, in the Results Settings, to further specify how search results should be shown, change the values in the following fields:

    • Number of results per page The number of search results to be displayed per page.

    • Show ranked results Clear the check box if you want to show only promoted blocks (such as promoted results or personal favorites) or result controls (such as result counts) instead of the ranked results.

    • Show promoted results Clear the check box if you do not want to show search results that you have promoted by using Query rules.

    • Show "Did you mean?" Clear the check box if you do not want to show query spelling corrections as Did you mean suggestions. For more information about query spelling corrections, see Manage query spelling correction in SharePoint Server 2013.

    • Show personal favorites Clear the check box if you do not want to show personal favorites.

    • Show View Duplicates link Select the check box if you want to show a View Duplicates link.

    • Show link to search center Select the check box if you want to show a link to the Search Center.

  12. In the Web Part tool pane, in the Settings section, in the Results control settings section, to specify how search results should be shown, change the values in the following fields:

    • Show advanced link Clear the check box if you don't want to show a link to the Advanced Search page in the Web Part.

    • Show result count Clear the check box if you don't want to show the number of results found in the Web Part.

    • Show language dropdown Clear the check box if you don't want to show the language drop-down in the Web Part.

    • Show sort dropdown Select the check box if you want to show the sort drop-down in the Web Part.

    • Show paging Clear the check box if you don't want to show paging in the Web Part.

    • Show preferences link Clear the check box if you don't want to show a link to the preferences page in the Web Part.

    • Show AlertMe link Clear the check box if you don't want to show a link to the Alert Me page in the Web Part. For more information about search alerts, see Enable search alerts in SharePoint Server 2013.

To disable stemming in a Search Results Web Part

Stemming means that nouns and adjectives in a query are expanded to different possible inflections. For example, if a person enters the English word "foot" in a query, it is automatically expanded to {"feet"}. Similarly, the word "overview" is expanded to {"overviews"}.

To disable stemming in a Search Results Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the Enterprise Search Center site.

  2. On the search results page, click the Settings menu, and then click Edit page.

  3. In the Search Results Web Part, click the Search Results Web Part Menu arrow, click Export…, and then save the Web Part to your computer.

  4. Open the Web Part in a text editor — for example, Notepad.

  5. Change the value for EnableStemming to false, and then save the file with a new name — for example, Search_Results_NoStemming.webpart.

  6. On the search results page, in the Main Zone, click Add a Web Part.

  7. In the Categories section, click the Upload a Web Part arrow.

  8. In the Upload a Web Part section, click Browse to find the Web Part file that you have edited, and then click Upload.

  9. To add the customized Search Results Web Part to the search results page, do the following:

    • Browse to the search results page.

    • Click the Settings menu, and then click Edit Page.

    • In the Web Part Zone where you want to add the Web Part, click Add a Web Part.

    • In the Categories list, select Imported Web Parts.

    • In the Parts list, select the Web Part that you uploaded, and then click Add.

  10. To remove the default Search Results Web Part from the search results page, do the following:

    • Browse to the search results page.

    • Click the Settings menu, and then click Edit Page.

    • In the Web Part, click the Search Results Web Part menu arrow, and then click Delete.

Note:

Disabling stemming turns it off for all languages except the following: Arabic, Estonian, Finnish, Hebrew, Hungarian, Korean, Latvian, and Slovak.

See also

Query variables in SharePoint Server 2013
Configure result sources for search in SharePoint Server 2013
Plan to transform queries and order results in SharePoint 2013

Blog series: How to change the way search results are displayed in SharePoint Server 2013


Configure properties of the Refinement Web Part in SharePoint Server 2013

Published: November 13, 2012

Summary: Learn how to configure properties of the Refinement Web Part, how to display refiner counts, and how to change the refiner display name.

Applies to: SharePoint Server 2013

By default, the Refinement Web Part is used on all search vertical pages (results.aspx, peopleresults.aspx, conversationresults.aspx, videoresults.aspx). The Web Part filters search results from a Search Results Web Part into categories to help users narrow search results to help them find what they are looking for. By changing properties in the Refinement Web Part you can you can do the following:

  • Specify a different Search Results Web Part from which to filter search results.

  • Specify which refiners to show in the Web Part.

  • Change the display template that is applied to each refiner.

Before you begin these procedures, verify the following:

  • The managed properties that you want to use as refiners are set to refinable and queryable in the search schema. You can verify or change this by viewing or editing the Main characteristics of the managed property as described in To add a managed property.

  • You have done a full crawl of the content source that contains the managed properties that are enabled as refiners as described in Start, pause, resume, or stop a crawl in SharePoint Server 2013.

In this article:

  • Before you begin

  • Configure properties of the Refinement Web Part

  • Change the refiner display name

  • Add refiner counts to the Refinement Web Part

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure properties of the Refinement Web Part

To configure the properties of a Refinement Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the Enterprise Search Center site.

  2. Browse to the page that contains the Refinement Web Part that you want to configure.

  3. Click the Settings menu, and then click Edit Page.

  4. In the Web Part, click the Refinement Web Part Menu arrow, and then click Edit Web Part.

  5. In the Web Part tool pane, in the Refinement Target section, select the Web Part from which from which to filter search results. By default, the Search Results Web Part is selected.

  6. In the Web Part tool pane, verify that the Choose Refiners in this Web Part is selected.

  7. Click Choose Refiners.

  8. On the Refinement configuration page, from the Available refiners section, use the buttons to select which refiners should be shown in the Web Part, and also in what order that they should be shown. If you have specified an Alias for a refinable managed property, this alias is shown in the Configuration for section.

  9. In the Configuration for section, configure how you want each refiner to appear.

    Note:

    If you have a single language site, you can change the refiner display name in the Display name section. For multilingual sites, you have to change the refiner display language as described in Change the refiner display name.

Change the refiner display name

By default, the name of the managed property that is enabled as a refiner will be used as display name for the refiner. In many cases, the managed property name is not user-friendly — for example, RefinableString00 or ColorOWSTEXT. You can change the display name of the refiner by changing a java script file in the master page gallery.

To change the refiner display name

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the Enterprise Search Center site.

  2. On the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Web Designer Galleries section, click Master pages and page layouts.

  4. On the Master Page Gallery page, click Display Templates.

  5. On the Display Templates page, click Language Files.

  6. On the Language Files page, click the folder that contains the language for which you want to change the refiner display name.

  7. Open the CustomStrings.js file.

  8. Add one line to the file for each managed property that is enabled as a refiner for which you want to change the display name by using the following syntax:

    "rf_RefinementTitle_ManagedPropertyName": "Sample Refinement Title for ManagedPropertyName"

    For example, you can add the following line to change the display name for the managed property RefinableInt00 to Price:

    "rf_RefinementTitle_RefinableInt00": "Price".

Add refiner counts to the Refinement Web Part

By default, the Refiner Web Part will not show refiner counts — that is, the number of items for each refiner value. For example, if you have enabled the managed property Color as a refiner, the refiner values will only show colors such as Red, Green, and Blue. You can add refiner counts by changing a value in an HTML file so that the refiner values are shown as Red (10), Green (12), and Blue (8).

To add refiner counts to the Refinement Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the Enterprise Search Center site.

  2. On the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Web Designer Galleries section, click Master pages and page layouts.

  4. On the Master Page Gallery page, click Display Templates.

  5. On the Display Templates page, click Filters.

  6. Open the Filter_Default.html file.

  7. Change the value for ShowCounts to true.

  8. Save the file.


Configure properties of the Search Navigation Web Part in SharePoint Server 2013

Summary: Learn how to configure properties of the Search Navigation Web Part, and how to add a link to a new search vertical page.

Applies to: SharePoint Server 2013

The Search Navigation Web Part is configured to display links to the search verticals Everything, People, Conversations and Videos. It uses search results from the Search Results Web Part so that when users click a search vertical link, the search results are filtered and displayed following the configuration of the search vertical. You can also create your own search vertical and add it to be displayed in the Search Navigation Web Part.

By changing properties on the Search Navigation Web Part you can do the following:

  • Specify a different Web Part from which search results are received.

  • Change the number of search vertical links to display.

The search vertical properties, such as display name and links, are configured on the Search Settings page for the corresponding site.

In this article:

  • Before you begin

  • Configure the properties of the Search Navigation Web Part

  • Change the properties of a search vertical in the Search Navigation Web Part

  • Add a search vertical to the Search Navigation Web Part

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure the properties of the Search Navigation Web Part

To configure the properties of a Search Navigation Web Part

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the Enterprise Search Center site.

  2. On the search results page, click the Settings menu, and then click Edit Page.

  3. In the Search Navigation Web Part, click the Search Navigation Web Part menu arrow, and then click Edit Web Part.

  4. In the Web Part tool pane, in the Control section, do the following:

    • To receive search results from another Web Part on the page, in the Use Current Query from list, select a Web Part.

    • To change the number of search vertical links to display before overflowing, in the Maximum Links Before Overflow box, type a number.

Change the properties of a search vertical in the Search Navigation Web Part

To change the properties of a search vertical in the Search Navigation Web Part

  1. Verify that the user account that performs this procedure is a member of the Owners group on the Enterprise Search Center site.

  2. On the Settings menu for the site, click Site Settings.

  3. On the Site Settings page, in the Search section, click Search Settings.

  4. On the Search Settings page, in the Configure Search Navigation section, click to select the search vertical for which you want to change the properties, and then click Edit.

  5. In the Navigation Link dialog box, do the following:

    • To change the display name of a search vertical, in the Title field, type a display name.

    • To change the URL of the search vertical, in the URL field, type a URL.

  6. On the Search Settings page, click OK to save the changes.

Add a search vertical to the Search Navigation Web Part

Before you start this procedure, verify that you have created a new page for the search vertical. We recommend that you copy one of the existing search vertical pages — for example, results.aspx, and then modify the copy to create a new page.

To add a search vertical to the Search Navigation Web Part

  1. Verify that the user account that performs this procedure is a member of the Owners group on the Enterprise Search Center site.

  2. On the Settings menu for the site, click Site Settings.

  3. On the Site Settings page, in the Search section, click Search Settings.

  4. On the Search Settings page, in the Configure Search Navigation section, click Add Link.

  5. In the Navigation Link dialog box, do the following:

    • In the Title field, type a display name.

    • In the URL field, type the URL to the new search vertical.

    • Click OK to save the new search vertical.


Manage search relevance in SharePoint Server 2013

Summary: Learn how you can configure settings to provide the most relevant search results in SharePoint 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet provide information about how you manage relevance to improve search results in SharePoint 2013.

TechNet articles about managing search relevance

The following articles about managing search relevance in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Create and deploy a thesaurus in SharePoint Server 2013 | Learn how to create and deploy a thesaurus to expand queries with synonyms.
 | Create and deploy custom entity extractors in SharePoint Server 2013 | Learn to create custom entity extractors and how to use them to set up custom refiners. Create one or more custom entity extraction dictionaries and connect them to managed properties.
 | Manage company name extraction in SharePoint Server 2013 | Learn how to include company names to be extracted from content for search results, or how to exclude company names from being extracted.
 | Manage query rules in SharePoint Server 2013 | Learn how to improve search results by creating and managing query rules.
 | Manage query suggestions in SharePoint Server 2013 | Learn how to add phrases that you want the system to always or never suggest to users as they perform a query. This article also explains how to enable or disable query suggestions.
 | Manage query spelling correction in SharePoint Server 2013 | Learn how to include single words in or exclude single words from query spelling corrections to help correct spelling errors in queries.
 | Configure authoritative pages in SharePoint 2013 | Learn how to specify authoritative pages and non-authoritative URLs and sites. Search uses the list of authoritative pages to calculate the ranking of results.


Create and deploy a thesaurus in SharePoint Server 2013
See also

Summary: Learn how to create and deploy a thesaurus to expand queries with synonyms.

Applies to: SharePoint Server 2013

Use a thesaurus file to specify synonyms for a single word or multiple words that occur in queries. The query is expanded based on the entries in the thesaurus. You create and maintain the thesaurus file in a system external to SharePoint 2013 before you import it into SharePoint 2013 to make the synonyms available to the search system.

Note:

You can only deploy one thesaurus per SharePoint 2013 farm.

In this article:

  • Before you begin

  • Create a thesaurus

  • Deploy a thesaurus

Before you begin

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

Create a thesaurus

To define the entries in your thesaurus, you enter terms and their corresponding synonyms in a comma separated (.csv) file. Optionally, you can also specify in which language the query should be written for a synonym to apply.

If you want to define more than one synonym for one key, you have to create multiple entries in the thesaurus. Also, if you want the synonym to work both ways, for example, if you want the term "IE" to also return search results for "Internet Explorer" and you want the term "Internet Explorer" to also return results for "IE", you have to create two thesaurus entries.

The matching between the thesaurus keys and query terms is not case sensitive. When a query term matches a thesaurus key, the query is expanded with the synonym(s) for that key and the search results will contain results for the original query term as well as for the synonym.

To create a thesaurus

  1. Create a .csv file with the columns Key, Synonym and Language. Make sure you use a comma as the column separator. If the file contains non-ASCII characters such as diacritics, you must encode it in UTF-8. Save the file to a location that is accessible from the server from which you will run the Windows PowerShell cmdlet to deploy the thesaurus.

    1. In the Key column, enter the term (single or multiple words) that you want to trigger a synonym for when the term occurs in a query. Make sure there are no leading or trailing spaces around the terms.

    2. In the Synonym column, enter the synonym (single or multiple words) that you want to add to the query if the term specified in the Key column occurs in a query. Synonyms consisting of multiple words will be added as phrases to the query.

    3. In the optional Language column, enter the abbreviation for the language for which the synonym should apply. See the table in Linguistic search features in SharePoint Server 2013 for an overview of available languages and their code. If you leave this column empty, the query is expanded with the synonym regardless of the query language. Make sure there are no leading or trailing spaces around the language codes.

A thesaurus is commonly used to expand acronyms. But you can also use a thesaurus to automatically include variations of a search term into the query for specific terminology used in your organization. An example thesaurus file input could look like this:

Copy code
Key,Synonym,Language
IE,Internet Explorer
Internet Explorer,IE
UN,United Nations,en
UN,Vereinte Nationen,de
BAM,billing and account management
billing and account management,billing and accounts

Deploy a thesaurus

You create and maintain the thesaurus file in a file external to SharePoint 2013 before you import it into SharePoint 2013 to make the synonyms available to the search system. You can't export a thesaurus from SharePoint 2013. If you want to make changes to your synonyms, you have to update the thesaurus file and then redeploy it.

Note:

When you redeploy a thesaurus file, the existing thesaurus will be overwritten with the information from the updated thesaurus file.

To import a thesaurus file

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $searchApp = Get-SPEnterpriseSearchServiceApplication
Import-SPEnterpriseSearchThesaurus -SearchApplication $searchApp -Filename <Path>

    Where:

    • <Path> specifies the full UNC path of the .csv file (the thesaurus) to be imported.

See also

Import-SPEnterpriseSearchThesaurus

Linguistic search features in SharePoint Server 2013


Create and deploy custom entity extractors in SharePoint Server 2013
See also

Summary: Learn to create custom entity extractors and how to use them to set up custom refiners. Create one or more custom entity extraction dictionaries and connect them to managed properties.

Applies to: SharePoint Server 2013

You create and maintain the custom entity extractor file in a system external to SharePoint 2013 before you import it into SharePoint 2013 to make the custom entity extractor available to the search system.

To use custom entities as refiners, you first create a custom entity extraction dictionary and deploy it. Then, you configure a managed property to use a custom entity extractor and run a full crawl. After that, you can configure the Refinement Web Part on the search results page to use the custom entity as a refiner.

In this article:

  • Before you begin

  • Create a custom entity extraction dictionary

  • Deploy a custom entity extraction dictionary

  • Configure a managed property for custom entity extraction

  • Configure a refiner in the Web Part

Before you begin

Note:

SharePoint 2013 runs as websites in Internet Information Services (IIS), and administrators and users therefore require the accessibility features that browsers provide. For more information, see:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

  • Add one or more content sources and run a full crawl

  • Configure a search results page

Create a custom entity extraction dictionary

To create a custom entity extraction dictionary

  1. Determine which type of custom entity extraction dictionary you want to create: Word, Word Part, Word exact or Word Part exact. See Overview of custom entity extractor types.

  2. Create a .csv file with the columns Key and Display Form. Make sure you use a comma as the column separator. If the file contains non-ASCII characters such as diacritics, you must encode it in UTF-8. Save the file to a location that is accessible from the server from which you will run the Windows PowerShell cmdlet to deploy the custom entity extraction dictionary.

    1. In the Key column, enter the term (single or multiple words) that you want to include as custom entities. You can use more than one line per key. Make sure there are no leading or trailing spaces around the terms.

    2. (Optional) In the Display form column, enter a refiner name. If you leave this column empty, the term that is extracted from the content will be displayed as the refiner in the same case as it occurs in the content. Use the Display Form column to control and standardize the way in which the refiner is displayed.

For example, an organization named Contoso has a certification system with three levels: Contoso Beginner, Contoso Professional and Contoso Expert. Contoso wants to extract these entities and wants to be able to refine on all of them. Regardless of the case in which the word "Contoso", "beginner", "professional" or "expert" is written, they want to display the refiner as Contoso Beginner, Contoso Professional and Contoso Expert. For this example, the custom entity extraction dictionary file input could look like this:

Copy code
Key,Display form
Contoso Beginner,Contoso Beginner
Contoso B1,Contoso Beginner
Contoso Professional,Contoso Professional
Contoso prof,Contoso Professional
Contoso Expert,Contoso Expert

Deploy a custom entity extraction dictionary

To deploy the custom entity extraction dictionary, you must import it into SharePoint 2013.

To import a custom entity extraction dictionary

  1. Verify that the user account that is importing the custom entity extractor dictionary is an administrator for the Search service application.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $searchApp = Get-SPEnterpriseSearchServiceApplication
Import-SPEnterpriseSearchCustomExtractionDictionary -SearchApplication $searchApp -Filename <Path> -DictionaryName <Dictionary name>

    Where:

    • <Path> specifies the full UNC path of the .csv file (the custom extraction dictionary) to be imported.

    • <Dictionary name> is the name of the type of the custom extraction dictionary.

      Depending on which type of dictionary you are importing, enter one of the following:

      • Microsoft.UserDictionaries.EntityExtraction.Custom.Word.n [where n = 1,2,3,4 or 5]

      • Microsoft.UserDictionaries.EntityExtraction.Custom.ExactWord.1

      • Microsoft.UserDictionaries.EntityExtraction.Custom.WordPart.n [where n = 1,2,3,4 or 5]

      • Microsoft.UserDictionaries.EntityExtraction.Custom.ExactWordPart.1

Configure a managed property for custom entity extraction

The following procedure describes how to associate the custom entity extraction dictionary with an existing managed property from which you want to extract custom entities. Typically, this is a managed property that you expect to contain these entities, such as the managed properties Title or Body. Custom entities are extracted from the full contents of the managed property they are associated with, even if sections in those contents are tagged as <no index>.

To specify from which existing managed property custom entities should be extracted, you edit the existing managed property. For more information about managing crawled and managed properties, see Manage the search schema in SharePoint Server 2013.

To edit a managed property for custom entity extraction

  1. Verify that the user account is the administrator of the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Queries and Results, click Search Schema.

  5. On the Managed Properties page, find the managed property that you want to associate the custom entity extraction dictionary with that contains the single or multiple words (or word parts). You can also enter the name of the managed property in the Filter box.

  6. Point to the managed property, click the arrow and then click Edit/Map property.

  7. On the Edit Managed Property page, edit the settings under Custom entity extraction. Select the custom entity extraction dictionary that you have imported, and then click OK.

After the next full crawl has completed, the custom entity extractor is enabled. The original managed property content is saved unchanged in the search index. In addition, depending on the type of custom entity extractor you have enabled, the extracted entities are copied to one or more of the following managed properties:

  • WordCustomRefiner1, WordCustomRefiner2, WordCustomRefiner3, WordCustomRefiner4, WordCustomRefiner5

  • WordExactCustomRefiner

  • WordPartCustomRefiner1, WordPartCustomRefiner2, WordPartCustomRefiner3. WordPartCustomRefiner4, WordPartCustomRefiner5

  • WordPartExactCustomRefiner

These managed properties are automatically configured to be searchable, queryable, retrievable, sortable and refinable.

Configure a refiner in the Web Part

You can use the extracted custom entities as refiners in the search results page. The refiners based on the custom entities are available in the Refinement Web Part.

To add a refiner based on a custom entity extractor

  1. Verify that the user account that performs this procedure is a member of the Designers SharePoint group on the Enterprise Search Center site.

  2. Browse to the page that contains the Refinement Web Part that you want to configure, click the Settings menu and then click Edit Page.

  3. Edit the Refinement Web Part. Click the Refinement Web Part Menu arrow, and then click Edit Web Part.

    1. In the Web Part tool pane, in the Properties for Search Refinement section, verify that the Choose Refiners in this Web Part is selected.

    2. Click Choose Refiners.

    3. On the Refinement configuration page, from the Available refiners section, use the buttons to select one or more managed properties containing extracted entities that you want to show as refiners from the list and click Add. For example, if you have deployed a word extraction dictionary, choose WordCustomRefiner1.

    4. In the Configure for section, configure how you want each refiner to appear.

  4. Click OK.

Overview of custom entity extractor types

The following table shows what type of custom extraction dictionaries you can create and how the dictionary entries are matched with content in the search index, which dictionary name you should use when you deploy the dictionary and which managed property will contain the extracted entities..

Custom entity extractor / custom entity extractor dictionary | Description | Example | Dictionary name to use in Windows PowerShell | Managed property that will contain the extracted entity
Word Extraction | Case-insensitive, dictionary entries matching tokenized content, maximum 5 dictionaries. | The entry "anchor" matches "anchor" and "Anchor," but not "anchorage" | Microsoft.UserDictionaries.EntityExtraction.Custom.Word.n [where n = 1,2,3,4 or 5] | WordCustomRefiner1 WordCustomRefiner2 WordCustomRefiner3 WordCustomRefiner4 WordCustomRefiner5
Word Part Extraction | Case-insensitive, dictionary entries matching un-tokenized content, maximum 5 dictionaries. | The entry "anchor" matches "anchor," "Anchor" and "anchorage" | Microsoft.UserDictionaries.EntityExtraction.Custom.WordPart.n [where n = 1,2,3,4 or 5] | WordPartCustomRefiner1 WordPartCustomRefiner2 WordPartCustomRefiner3 WordPartCustomRefiner4 WordPartCustomRefiner5
Word Exact Extraction | Case-sensitive, dictionary entries matching tokenized content, maximum 1 dictionary. | The entry "anchor" matches "anchor," but not "Anchor" or "Anchorage" | Microsoft.UserDictionaries.EntityExtraction.Custom.ExactWord.1 | WordExactCustomRefiner
Word Part Exact Extraction | Case-sensitive, dictionary entries matching un-tokenized content, maximum 1 dictionary. | The entry "anchor" matches "anchor" and "anchorage," but not "Anchor" | Microsoft.UserDictionaries.EntityExtraction.Custom.ExactWordPart.1 | WordPartExactCustomRefiner

See also

Import-SPEnterpriseSearchCustomExtractionDictionary


Manage company name extraction in SharePoint Server 2013

Summary: Learn how to include company names to be extracted from content for search results, or how to exclude company names from being extracted.

Applies to: SharePoint Server 2013

The search system can extract company names from content. The following conditions must be met before company names can be extracted:

  • The managed property setting Company name extraction must be enabled on the managed property that you want to extract company names from. Typically, this is a managed property that you expect to contain these entities, such as the managed properties Title or Body. Company names are extracted from the full contents of the managed property they are associated with, even if sections in those contents are tagged as <no index>.

  • The name of the company that you want to extract should either already exist in the prepopulated company name dictionary or it should be included in the Company Inclusions list.

  • A full crawl must be completed.

For example, if a company name is found in the body of a document, company name extraction is enabled on the managed property Body and a full crawl has been run, the company name is extracted and mapped to the managed property companies. You can then use the companies managed property to create refiners based on the extracted company name in the Refinement Web Part on the search results page.

There is a prepopulated dictionary for company name extraction which includes a large number of company names. You can add additional company names to be extracted or prevent particular company names from being extracted using the Company Inclusions or Company Exclusions lists.

This article explains how to maintain these lists. It does not cover how to enable a managed property to use company extraction. For more information on how to enable company extraction on a managed property, see Manage the search schema in SharePoint Server 2013.

In this article:

  • Before you begin

  • Open the Term Store Management Tool

  • Exclude company names

  • Include company names

  • Edit terms

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

Open the Term Store Management Tool

The company name exclusion and inclusion lists are managed in the Term Store. Use the Term Store Management Tool to edit the lists.

To get to the Term Store Management Tool

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. On the home page of the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application.

  4. On the Search Administration Page, in the Queries and Results section, click Search Dictionaries. The Term Store Management Tool opens.

Exclude company names

To exclude company names from being extracted as entities from content, add the company name to the Company Exclusions list.

To add a company name to the Company Exclusions list

  1. On the Site Settings: Term Store Management Tool page, click the arrow to expand the Search Dictionaries menu.

  2. Click Company Exclusions, click the arrow and then click Create Term.

  3. Type the name of the company that you want to exclude in the box that appears.

  4. Click anywhere on the page to add the term to the Company Exclusions list.

Include company names

To include company names to be extracted as entities from content, add the company name to the Company Inclusions list.

To add a company name to the Company Inclusions list

  1. On the Site Settings: Term Store Management Tool page, click the arrow to expand the Search Dictionaries menu.

  2. Click Company Inclusions, click the arrow and then click Create Term.

  3. Type the name of the company that you want to include in the box that appears.

  4. Click anywhere on the page to add the term to the Company Inclusions list.

Edit terms

You can edit the names of terms in the Company Exclusions and Company Inclusions lists.

To edit terms

  1. On the Site Settings: Term Store Management Tool page, click the arrow to expand the Search Dictionaries menu.

  2. Depending on which list the term is in, click either Company Exclusions or Company Inclusions.

  3. Double-click the term that you want to edit.

  4. Type the new name for the term.

  5. Click anywhere on the page to save the edited term.


Manage query rules in SharePoint Server 2013
See also

Published: December 11, 2012

Summary: Learn how to improve search results by creating and managing query rules.

Applies to: SharePoint Server 2013

Without using any custom code, Search service application administrators, site collection administrators, and site owners can help searches respond to the intent of users by creating query rules. In a query rule, you specify conditions and correlated actions. When a query meets the conditions in a query rule, the search system performs the actions specified in the rule to improve the relevance of the search results, such as by narrowing results or changing the order in which results are displayed. For example, a query rule condition could be that a term in a query matches a particular term in a SharePoint term set, or that a query is frequently performed on a particular result source in a search system, such as videos. When the query rule condition is satisfied, a correlated action could be to show a specific item at the top of the search results.

You can configure query rules for one or more result sources, and you can specify the time period during which the query rule is active.

In this article:

  • Before you begin

  • Creating query rules at different levels in a SharePoint farm

  • Create a query rule

  • Create and display a result block

  • Change ranked search results

  • Make a query rule inactive

  • Rank query rules

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Creating query rules at different levels in a SharePoint farm

You can create a query rule for a Search service application, a site collection, or a site. The following table shows the permissions that are required to create a query rule in each case, and where the query rule can be used.

Levels and permissions for query rules

When you create a query rule at this level | You must have this permission | The query rule can be used in
Search service application | Search service application administrator | All site collections in web applications that consume the Search service application
Site collection | Site collection administrator | All sites in the site collection
Site | Site owner | The site

To add or edit a query rule, you must go to the Manage query rules page. Depending on the level at which you are creating the query rule, use one of the following procedures to go to the Manage query rules page.

To go to the Manage query rules page for a Search service application

  1. Verify that the user account that performs this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application to which you want to add query rules.

  4. On the Search Administration page for the Search service application, in the Quick Launch, in the Queries and Results section, click Query Rules.

To go to the Manage query rules page for a site collection

  1. Verify that the user account that performs this procedure is a site collection administrator.

  2. On the Settings menu for the site collection, click Site Settings.

  3. On the Site Settings page, in the Site Collection Administration section, click Search Query Rules.

To go to the Manage query rules page for a site

  1. Verify that the user account that performs this procedure is a member of the Owners group for the site.

  2. On the Settings menu for the site, click Site Settings.

  3. On the Site Settings page, in the Site Administration section, click Query Rules.

Create a query rule

To create a query rule

  1. On the Manage Query Rules page, in the Select a Result Source menu, select a result source for the new query rule.

  2. Click New Query Rule.

  3. On the Add Query Rule page, in the General Information section, in the Rule name field, type the name for the query rule.

  4. Click to expand the Context section.

  5. In the Context section, select one of the following:

    • To apply the query rule to all result sources, select All sources.

    • To apply the query rule to one or more specific result sources, select One of these sources. By default, the result source that you specified in step 1 is selected. To add a result source for the query rule, do the following:

      Click Add Source. In the Add Source dialog box, select a result source, and then click Save.

  6. To restrict the query rule to categories —for example, that a query rule should fire only when a term from your managed navigation term set is included in the query — click Show more conditions, and then specify the following:

    • To restrict the query rule to a category, click Add category. In the Import from Taxonomy dialog box, select a term that when you include it in a query will cause the query rule to fire, and then click Save.

    • To restrict the query rule to a user segment, do the following:

      1. Click Add User Segment.

      2. In the Add User Segment dialog box, in the Title field, type the title for this rule.

      3. In the Import from taxonomy dialog box, select a term that represents a user segment that will cause the query rule to fire when it appears in a query.

      4. Click Save

  7. In the Query Conditions section, do one of the following:

    • Select one of the conditions listed in the following table.

    • Click Remove Condition to configure this query rule to fire for every query that users type at the level at which you are creating the rule, and then go to step 8.

      For example, if you are creating this rule for a site collection, click Remove Condition if you want this rule to fire for every query that users type inside any search box in the site collection.

    Query condition Description Configuration Example

    Query Matches Keyword Exactly

    Select this option if you want the query rule to fire when a query exactly matches a word or phrase that you specify.

    In the Query exactly matches one of these phrases text box, type one or more phrases separated by semicolons.

    You type "picture; pic" in the Query contains one of these phrases box. The query rule will fire when a user types "picture" or "pic" in a search box. The rule will not fire if a user types "pictures" or "sunny picture."

    Query Contains Action Term

    Select this option if you want the query rule to fire when a query contains a term that indicates something that the user wants to do. The term must be at the beginning or end of the query.

    Specify the action term that will cause the query rule to fire by doing one of the following:

    • Select Action term is one of these phrases, and type one or more phrases.

    • Select Action term is an entry in this dictionary, and then click Import from taxonomy. In the Import from taxonomy dialog box, select a term from a term set, and then click Save.

    You type the word "download" in the Action term is one of these phrases text box. When a user types "download Contoso Electronics datasheet" in a search box, the user is probably not searching for a document that contains the words "download," "Contoso," "Electronics," and "datasheet." Instead, the user is probably trying to download a Contoso Electronics datasheet. When a user types "download Contoso Electronics datasheet" in a search box, the query rule fires, and only the words "Contoso," "Electronics," and "datasheet" are passed to the search index.

    Query Matches Dictionary Exactly

    Select this option if you want the query rule to fire when the query exactly matches a dictionary entry.

    From the Query contains an entry in this dictionary menu, select a dictionary. To specify a different dictionary, click Import from taxonomy, and then from the Import from taxonomy dialog box, select a term from a term set, and then click Save.

    A word that a user types in a search box matches an entry in the pre-configured People Names dictionary.

    Query More Common in Source

    Select this option if you want the query rule to fire if the query was frequently issued by users on a different result source that you specify.

    In the Query is more likely to be used in this source menu, select a result source.

    In the Query is more likely to be used in this source menu, you select Local Video Results. The query rule will fire if a user types the word "training" in a search box and that word was frequently typed in a search box in the Videos vertical.

    Result Type Commonly Clicked

    Select this option if you want the query rule to fire if other users frequently clicked a particular result type after they typed the same query.

    In the Commonly clicked results match result type menu, select a result type.

    In the Commonly clicked results match result type box, you select SharePoint MicroBlog post. If users frequently click a microblog post in search results, then in the Actions section, you might want to configure the most recent microblog post as the first promoted result, and the next most recent microblog post as the second promoted result.

    Advanced Query Text Match

    Select this option if you want to use a regular expression, a phrase, or a dictionary entry that will cause the query rule to fire.

    To match all phone numbers that are in a certain format, you specify a regular expression in the Query matches this regular expression box.

    To match all phone numbers that are in the format nnn-nnn-nnnn, you specify the regular expression "\(?(\d{3})\)?-?(\d{3})-(\d{4})".

    To add conditions, click Add Alternate Conditions.

    Note:

    The rule will fire when any condition is true.

  8. In the Actions section, specify the action to take when the query rule fires. Specify one of the following:

    • To promote individual results so that they appear towards the top of search results, click Add Promoted Result (in SharePoint 2010 Products this was called Best Bets). In the Add Promoted Result dialog box, in the Title field, type the name that you want to give this promoted result. In the URL field, type the URL of the result that should be promoted. Render the URL as a banner instead of as a hyperlink. Click Save.

      You can add several individual promoted results. When there is more than one promoted result, you can specify the relative ranking.

    • To promote a group of search results, click Add Result Block. For more information, see Create and display a result block later in this article.

    • To change ranked search results, click Change ranked results by changing the query. For more information, see Change ranked search results later in this article.

  9. To make the query rule active during a particular time period, click Publishing, and then specify the period.

Create and display a result block

A result block is several search results that are displayed as a group. In the same manner as you can promote a specific result, you can promote a result block when a specified query condition applies.

When you configure the query condition for a result block, you can use query variables. Query variables are placeholders for values that you don't know when you specify the query. However, when the query is run, this information is known and can be used when the system sends the query to the index. Examples are {User.Name}, which represents the display name of the user who typed the query, or {searchBoxQuery}, which represents the query that a user typed in a search box. When you use Query Builder to configure the query, a list of query variables is shown. (See step 3 in the following procedure.)

To create a result block

  1. In step 8 of the previous procedure, on the Add Query Rule page, in the Actions section, click Add Result Block.

  2. In the Block Title section, in the Title field, type a name for the result block.

  3. In the Query section, to specify the query, click Launch Query Builder. In Query Builder, specify the following:

    • On the BASIC tab, select options from the following lists to define the query for the result block:

      Select a query

      Select a result source to specify which content should be searched.

      Keyword filter

      You can use keyword filters to add query variables to your query. See Query variables in SharePoint Server 2013 for a list of available query variables.

      You can select pre-defined query variables from the drop-down list, and then add them to the query by clicking Add keyword filter.

      Property filter

      You can use property filters to query the content of managed properties that are set to queryable in the search schema.

      You can select managed properties from the Property filter drop-down list. Click Add property filter to add the filter to the query.

    • On the SORTING tab, you can specify how search results within your result block should be sorted.

      • In the Sort by drop-down list:

        • To sort by managed properties that are set as sortable in the search schema, select a managed property from the list, and then select Descending or Ascending. To add more sorting levels, click Add sort level.

        • To sort by relevance rank, select Rank, and then do the following:

          • In the Ranking Model list, select which ranking model to use for sorting search results (this selection is optional).

          • In the Dynamic ordering section, to specify additional ranking by adding rules that will change the order of search results when certain conditions apply, click Add dynamic ordering rule, and then specify conditional rules.

    • On the TEST tab, you can preview the query that is sent.

      Query text

      Shows the final query that will be run by the Content Search Web Part. It is based on the original query template where dynamic variables are substituted with current values. Other changes to the query may have to be made as part of query rules.

      Click Show more to display additional information.

      Query template

      Shows the content of the query template that is applied to the query.

      Query template variables

      Shows the query variables that will be applied to the query, and the values of the variables that apply to the current page. You can type other values to test the effect they will have on the query. Click the Test Query button to preview the search results.

  4. In the Query section, in the Configure Query box, in the Search this Source drop-down list, select the result source to which this result block should be applied.

  5. In the Query section, in the Items drop-down list, select how many results to show in the result block.

  6. Click to expand the Settings section.

    The result block will only display the number of search results that you specified in the previous step. However, you can add a SHOW MORE link at the bottom of the result block that will show all search results for the result block. To add a SHOW MORE link, select "More" link goes to the following URL, and then type a URL. You can use query variables in this URL — for example, http://www.<site>/search/results.aspx?k={subjectTerms}.

  7. Skip the Routing section.

  8. Click OK.

Change ranked search results

The ranking model calculates a ranking order of search results. You can change this ranking by promoting or demoting items within the search results. For example, for a query that contains "download toolbox," you can create a query rule that recognizes the word "download" as an action term, and change the ranked search results to promote a URL of a particular download site on your intranet. You can also change the sorting order of the search results dynamically, based on several variables such as file name extension or specific keywords. Changing ranked search results by changing the query has the advantage that the results are security trimmed and refinable. Moreover, the search results will not appear if the document is no longer available.

To change ranked search results by changing the query

  1. From step 8 of the procedure Create a query rule, on the Add Query Rule page, in the Actions section, click Change ranked results by changing the query.

  2. In the Build Your Query dialog box, specify the following:

    • On the BASIC tab, select options from the following lists to change ranked search results:

      Select a query

      Select a result source to specify which content should be searched.

      Keyword filter

      You can use keyword filters to add query variables to your query. See Query variables in SharePoint Server 2013 for a list of available query variables.

      You can select pre-defined query variables from the drop-down list, and then add them to the query by clicking Add keyword filter.

      Property filter

      You can use property filters to query the content of managed properties that are set to queryable in the search schema.

      You can select managed properties from the Property filter drop-down list. Click Add property filter to add the filter to the query.

    • On the SORTING tab, you can specify how search results should be sorted by doing the following:

      • In the Sort by drop-down list:

        • To sort by managed properties that are set as sortable in the search schema, select a managed property from the list, and then select Descending or Ascending. To add more sorting levels, click Add sort level.

        • To sort by relevance rank, select Rank, and then do the following:

          • In the Ranking Model list, select which ranking model to use for sorting search results (this selection is optional).

          • In the Dynamic ordering section, to specify additional ranking by adding rules that will change the order of search results when certain conditions apply, click Add dynamic ordering rule, and then specify conditional rules.

    • On the TEST tab, you can preview the query.

      Query text

      Shows the final query that will be run by the Content Search Web Part. It is based on the original query template where dynamic variables are substituted with current values. Other changes to the query may have to be made as part of query rules.

      Click Show more to display additional information.

      Query template

      Shows the content of the query template that is applied to the query.

      Query template variables

      Shows the query variables that will be applied to the query, and the values of the variables that apply to the current page. You can type other values to test the effect they will have on the query. Click the Test Query button to preview the search results.

Make a query rule inactive

Query rules that are created at the Search service application level are inherited by site collections and sites that are in web applications that consume the Search service application. Similarly, query rules that are created at the site collection level are inherited by sites in the site collection. If you don't want a query rule to apply to a site that inherits it, you can set the query rule as inactive for the site.

To make a query rule inactive on a site

  1. Verify that the user account that performs this procedure is a member of the Owners group for the site.

  2. In the site collection, in the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Search section, click Query Rules.

  4. On the Manage Query Rules page, on the Select a Result Source menu, select the result source that contains the query rule that you want to make inactive.

  5. In the Name column, point to the query rule that you want to make inactive, click the arrow that appears, and then click Make Inactive.

Rank query rules

When multiple query rules are active for a Search service application, a site collection, or a site, more than one rule can fire for a query that is performed at that level. By default, the rules do not fire in a prescribed order. You can control the order in which the rules fire by adding the query rules that you create to query groups. To do this, you select rules to add to a group, and then you specify the order in which the rules in the group will fire if they are triggered. You can also prevent query rules that rank lowest in a group from firing even if they are triggered.

To rank query rules for a site collection

  1. Verify that the user account that performs this procedure is a site collection administrator.

  2. In the site collection, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Collection Administration section, click Search Query Rules.

  4. On the Manage Query Rules page, on the Select a Result Source menu, select the result source that contains the query rules that you want to group.

  5. For each query rule that you created that you want to add to a group, point to the rule and select the check box.

    Note:

    Query rules that you created for this site collection are listed in the Defined for this site collection section.

  6. Click Order Selected Rules.

  7. In the Order Selected Rules dialog box, do either of the following, and then click OK:

    • Select Move rules to new group with this name, and then type a name for the group.

    • Select Move rules to existing group and select a group in the drop-down list.

  8. On the Manage Query Rules page, do the following:

    1. To change the order in which a rule in a group will fire if it is triggered, change the numeric order of the rule.

    2. To prevent query rules that are ranked lowest in the group from firing, in the row for the group's query rule that should fire last, in the Actions column, in the Continue/Stop drop-down list, select Stop.

See also

Plan to transform queries and order results in SharePoint 2013
Overview of search result ranking in SharePoint Server 2013
Query variables in SharePoint Server 2013


Manage query spelling correction in SharePoint Server 2013
See also

Summary: Learn how to include single words in or exclude single words from query spelling corrections to help correct spelling errors in queries.

Applies to: SharePoint Server 2013

If a user enters a word in a search query that appears to be misspelled, the search results page displays query spelling corrections. This is also known as "Did you mean?". For example, if someone enters a query that contains the word "ampitheater", the query spelling correction would be "amphitheater".

These query spelling suggestions are based on the closest matches in the default spelling dictionaries and the Query Spelling Inclusions list. For terms that you enter in the Query Spelling Exclusions list, query spelling suggestions will never be displayed. You can edit the Query Spelling Inclusions and the Query Spelling Exclusions list, but you can't edit the default spelling dictionaries. It takes up to 10 minutes for any changes to the Query Spelling Exclusions or the Query Spelling Inclusions list to take effect.

Important:

You can only include or exclude single words.

For more information about linguistic search features for different languages see Linguistic search features in SharePoint Server 2013.

In this article:

  • Before you begin

  • Open the Term Store Management Tool

  • Exclude terms from query spelling corrections

  • Include terms in query spelling corrections

  • Edit terms

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

Open the Term Store Management Tool

The query spelling exclusions and inclusions lists are managed in the Term Store. Use the Term Store Management Tool to edit the lists.

To get to the Term Store Management Tool

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. On the home page of the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application.

  4. On the Search Administration Page, in the Queries and Results section, click Search Dictionaries. The Term Store Management Tool opens.

Exclude terms from query spelling corrections

To exclude words from query spelling corrections, add terms to the Query Spelling Exclusions list.

Important:

Create a separate term for each query spelling correction exclusion. Do not create subterms for terms in the Query Spelling Exclusions list. Term hierarchies will be ignored in this context.

To add a word to the Query Spelling Exclusions list

  1. On the Site Settings: Term Store Management Tool page, click the arrow to expand the Search Dictionaries menu.

  2. Click Query Spelling Exclusions, click the arrow and then click Create Term.

  3. Type the word that you want to exclude in the box that appears.

  4. Click anywhere on the page to add the term to the Query Spelling Exclusions list.

Include terms in query spelling corrections

To include words in query spelling corrections, add terms to the Query Spelling Inclusions list.

Important:

Create a separate term for each query spelling correction inclusion. Do not create subterms for terms in the Query Spelling Inclusions list. Term hierarchies will be ignored in this context.

To add a word to the Query Spelling Inclusions list

  1. On the Site Settings: Term Store Management Tool page, click the arrow to expand the Search Dictionaries menu.

  2. Click Query Spelling Inclusions, click the arrow and then click Create Term.

  3. Type the word that you want to include in the box that appears.

  4. Click anywhere on the page to add the term to the Query Spelling Inclusions list.

Edit terms

You can edit the names of terms in the Query Spelling Exclusions and Query Spelling Inclusions lists.

To edit terms

  1. On the Site Settings: Term Store Management Tool page, click the arrow to expand the Search Dictionaries menu.

  2. Depending on which list the term is in, click either Query Spelling Exclusions or Query Spelling Inclusions.

  3. Double-click the term that you want to edit.

  4. Type the new name for the term.

  5. Click anywhere on the page to save the edited term.

See also

Set-SPEnterpriseSearchQuerySpellingCorrection
Get-SPEnterpriseSearchQuerySpellingCorrection

Linguistic search features in SharePoint Server 2013


Manage query suggestions in SharePoint Server 2013

Published: October 23, 2012

Summary: Learn how to add phrases that you want the system to always or never suggest to users as they perform a query. This article also explains how to enable or disable query suggestions.

Applies to: SharePoint Server 2013

Query suggestions, also referred to as search suggestions, are suggested phrases that users have already searched for. Query suggestions appear in a list below the Search Box as a user types a query. By default, the search system automatically creates suggestions for a query when users have clicked the results for that query at least six times. This can be one result, or any combination of results for that query. A query suggestion appears only if it contains at least one of the words that are typed. The search system generates query suggestions daily for each result source and for each site collection. As a result, the automatically generated query suggestions can be different per result source and per site collection.

When you manually add query suggestions using the steps in this procedure, the query suggestions are added on the Search service application level and they will apply to all result sources and all site collections.

In this article:

  • Before you begin

  • Add phrases that are always or never used as query suggestions

  • Enable or disable query suggestions

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

Add phrases that are always or never used as query suggestions

To add phrases that are always or never suggested to users as they perform a query, you first have to create one or several text files that contain these phrases, and then import them into the search system. Add each phrase as a separate line in the text file that you create.

Warning:

If you import a text file with phrases for query suggestions, you overwrite any existing query suggestions in the search system.

To add phrases that are always used as query suggestions

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Open the Query Suggestion Settings page.

    1. On the home page of the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

    2. On the Manage Service Applications page, click the Search service application.

    3. On the Search Administration Page, in the Queries and Results section, click Query Suggestions. The Query Suggestion Settings page opens.

  3. In the Language for suggestion phrases section, select the language of the query suggestions that you always want to suggest.

  4. In the Always suggest phrases section, click Import from text file. Browse to the file that you want to import and click OK.

  5. Click Save Settings.

Note:

To edit query suggestions from existing phrases that you always want to suggest to users, click Export to file, update the text file and then re-import it. To remove any existing query suggestion files, upload an empty text file.

To add phrases that are never used as query suggestions

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Open the Query Suggestion Settings page.

    1. On the home page of the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

    2. On the Manage Service Applications page, click the Search service application.

    3. On the Search Administration Page, in the Queries and Results section, click Query Suggestions. The Query Suggestion Settings page opens.

  3. In the Language for suggestion phrases section, select the language of the query suggestions that you never want to suggest.

  4. In the Never suggest phrases section, click Import from text file. Browse to the file that you want to import and click OK.

  5. Click Save Settings.

Note:

To edit or remove query suggestions from existing phrases that you always or never want to suggest to users, click Export to text file, update the text file and then re-import it.

Enable or disable query suggestions

Query suggestions are turned on by default. The following steps explain how to turn query suggestions on or off.

To enable or disable query suggestions

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Open the Query Suggestion Settings page.

    1. On the home page of the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

    2. On the Manage Service Applications page, click the Search service application.

    3. On the Search Administration Page, in the Queries and Results section, click Query Suggestions. The Query Suggestion Settings page opens.

  3. In the Search Suggestions section, do one of the following:

    1. To enable query suggestions, check the Show search suggestions check box.

    2. To disable query suggestions, clear the Show search suggestions check box.

  4. Click Save Settings.


Configure authoritative pages in SharePoint 2013

Published: October 23, 2012

Summary: Learn how to specify authoritative pages and non-authoritative URLs and sites. Search uses the list of authoritative pages to calculate the ranking of results.

Applies to: SharePoint Server 2013

Static rank determines the relative importance of a page, and it is computed as the smallest number of clicks it would take a user to navigate from an authoritative page to a document. The closer a document is to the most authoritative page, the higher its static rank is.

An administrator provides a small set of authoritative pages. An example of an authoritative page could be the home page of a company portal.

An administrator with specific knowledge of an area can influence the relative importance of pages by specifying additional authoritative and non-authoritative pages. An example of non-authoritative pages could be URLs of sites that contain outdated information that are kept for record-keeping

In this article:

  • Before you begin

  • Specify pages as authoritative or non-authoritative

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application.

Specify pages as authoritative or non-authoritative

Use the following procedure to specify pages as authoritative or non-authoritative.

To specify pages as authoritative or non-authoritative

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, click Authoritative Pages.

  5. On the Specify Authoritative Pages page, in the Most authoritative pages box in the Authoritative Web Pages section, type the URLs of pages that are the most authoritative. Separate the URLs with returns so that there is one URL per line.

  6. In the Second-level authoritative pages box, type the URLs of any pages that should be seen as second-level.

  7. In the Third-level authoritative pages box, type the URLs of any pages that should be seen as third-level.

  8. In the Non-authoritative Sites section, in the Sites to demote box, type the URLs of any sites that you want to be ranked lower than all of the other sites. Type one URL per line.

    All URLs whose prefix matches the prefix of a URL in the Sites to demote box are demoted. Example: Entering http://archive/ demotes the rank of all URLs that begin with http://archive/.

  9. In the Relevance Ranking Analytics section, select the Refresh now check box to run the ranking analytics you have defined or that you have updated.

    If you clear the check box, ranking analytics run later according to a defined schedule.

  10. Click OK.


Manage crawling in SharePoint 2013
See also

Summary: Learn how to crawl content that you want users to be able to search for in SharePoint 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet provide information about how you manage crawling in SharePoint 2013.

TechNet articles about managing crawling

The following articles about managing crawling in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Manage continuous crawls in SharePoint Server 2013 | Learn how to enable continuous crawls of SharePoint content to help keep the search index and search results as fresh as possible.
 | Manage crawl rules in SharePoint Server 2013 | Learn how to specify a content access account, create crawl rules to include or exclude directories, and prioritize crawl rules.
 | Add, edit, or delete a content source in SharePoint Server 2013 | Learn how to create a content source to specify what type of content to crawl, schedules for crawling, start addresses, and crawl priority.
 | Start, pause, resume, or stop a crawl in SharePoint Server 2013 | Learn how to start, pause, resume or stop a full or incremental crawl of a content source.
 | Reset the search index in SharePoint Server 2013 | Learn how to reset the SharePoint search index.
 | Delete items from the search index or from search results in SharePoint Server 2013 | Learn how to remove an item from the search index or SharePoint search results by removing the URL.
 | Add or remove a file type from the search index in SharePoint Server 2013 | Learn how to add or remove a file type from the SharePoint search index by modifying the list of file types that the search system crawls.
 | Configure and use the Exchange connector for SharePoint 2013 | Learn how to create a crawl rule and add a content source to crawl Exchange Server public folders.
 | Configure and use the Lotus Notes connector for SharePoint Server 2013 | Learn about the administrative roles, required software, user accounts, and processes that are required to install and operate the Lotus Notes Client and the Lotus Notes Connector to work with SharePoint 2013 search.
 | Configure and use the Documentum connector in SharePoint Server 2013 | Learn how to install and configure the Microsoft SharePoint 2013 Indexing Connector for Documentum.
 | Change the default account for crawling in SharePoint 2013 | Change the user name or password of the account that the SharePoint 2013 Search service uses by default for crawling.
 | Configure time-out values for crawler connections in SharePoint 2013 | Change how long the SharePoint 2013 search crawler will wait for a connection to a content repository or for a response to a connection attempt.
 | Configure the crawler in case of SSL certificate warnings in SharePoint 2013 | Specify whether a SharePoint 2013 crawler will crawl a site if there is a problem with the site's Secure Sockets Layer (SSL) certificate.

See also

Search in SharePoint Server 2013


Manage continuous crawls in SharePoint Server 2013

Updated: May 14, 2013

Summary: Learn how to enable continuous crawls of SharePoint content to help keep the search index and search results as fresh as possible.

Applies to: SharePoint Server 2013

Enable continuous crawls is a crawl schedule option that is new in SharePoint 2013. It is available only for content sources that use the SharePoint Sites content source type. A continuous crawl starts at set intervals. The default interval is 15 minutes, but you can set continuous crawls to occur at shorter intervals by using Windows PowerShell.

Continuous crawls ensure content freshness. The search results are very fresh because the search index is kept up to date as the SharePoint content is crawled so frequently. Unlike full and incremental crawls, multiple continuous crawls can run at the same time. For example, if one continuous crawl is processing a large update, another continuous crawl can start at the same time and crawl and index other content updates.

Note:

A continuous crawl does not process or retry items that return errors. A clean up incremental crawl automatically runs every four hours on content sources that have continuous crawl enabled to re-crawl any items that return errors. This incremental crawl will retry to crawl the item or will postpone crawling the item if the error persists.

In this article:

  • Before you begin

  • Enable continuous crawl

  • Disable continuous crawl

  • Change the continuous crawl interval

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application.

  • Add one or more content sources of the type "SharePoint Sites".

Enable continuous crawl

To enable continuous crawl on an existing SharePoint content source

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Crawling, click Content Sources.

  5. On the Search Service Application: Manage Content Sources page, click the SharePoint content source for which you want to enable continuous crawl.

  6. In the Crawl Schedules section, select Enable Continuous Crawls.

  7. Click OK.

  8. Verification: In the Search Service Application: Manage Content Sources page, verify that the Status column has the status Crawling Continuous.

To enable continuous crawl on a new SharePoint content source

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Crawling, click Content Sources.

  5. On the Search Service Application: Manage Content Sources page, click New Content Source.

  6. Create a content source of the type SharePoint Sites.

    1. In the Name section, type a name in the Name field.

    2. In the Content Source Type section, select SharePoint Sites.

    3. In the Start Addresses section, type the start address or addresses.

    4. In the Crawl Settings section, select the crawling behavior for all start addresses.

    5. In the Crawl Schedules section, select Enable Continuous Crawls.

    6. In the Content Source Priority section, select the priority for this content source.

  7. Click OK.

  8. Verification: In the Search Service Application: Manage Content Sources page, verify that the newly added content source appears and that the Status column has the status Crawling Continuous.

Disable continuous crawl

To disable continuous crawl on a SharePoint content source

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application.

  4. On the Search Administration page, in the Quick Launch, under Crawling, click Content Sources.

  5. On the Search Service Application: Manage Content Sources page, click the SharePoint content source for which you want to disable continuous crawl.

  6. In the Crawl Schedules section, select Enable Incremental Crawls. This disables continuous crawl.

  7. Confirm that you want to disable continuous crawl by clicking OK.

  8. Optional: click Edit schedule to change the schedule for incremental crawls, and then click OK.

  9. On the Search Service Application: Edit Content Source page, click OK.

  10. Verification: On the Search Service Application: Manage Content Sources page, verify that the Status column has changed to Idle. This may take some time.

After you disable continuous crawl, you can make changes to the content source as usual. For example, you can add more start addresses and re-enable continuous crawl, or you can delete the content source.

Change the continuous crawl interval

To change the continuous crawl interval

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
$ssa.SetProperty("ContinuousCrawlInterval",<n>)

    Where:

    • <n> is the interval in minutes at which you want to start a continuous crawl. The default interval is set to 15 minutes. The shortest interval you can set is 1 minute.

      Note:

      If you reduce the interval, you increase the load on SharePoint and the crawler. Make sure that you plan and scale out for this increased consumption of resources accordingly.

Change History

Date | Description
May 14, 2013 | Updated with a procedure that describes how to change the continuous crawl interval.
July 16, 2012 | Initial publication


Manage crawl rules in SharePoint Server 2013

Summary: Learn how to specify a content access account, create crawl rules to include or exclude directories, and prioritize crawl rules.

Applies to: SharePoint Server 2013

You can add a crawl rule to include or exclude specific paths when you crawl content. When you include a path, you can provide alternative account credentials to crawl it. In addition to creating or editing crawl rules, you can test, delete, or reorder existing crawl rules.

Use crawl rules to do the following:

  • Prevent content on a site from being crawled. For example, if you created a content source to crawl http://www.contoso.com, but you do not want the search system to crawl content from the subdirectory http://www.contoso.com/downloads, create a crawl rule to exclude content from that subdirectory.

  • Crawl content on a site that would be excluded otherwise. For example, if you excluded content from http://www.contoso.com/downloads from being crawled, but you want content in the subdirectory http://www.contoso.com/downloads/content to be crawled, create a crawl rule to include content from that subdirectory.

  • Specify authentication credentials. If a site to be crawled requires different credentials than those of the default content access account, create a crawl rule to specify the authentication credentials.

You can use the asterisk (*) as a wildcard character in crawl rules. For example, to exclude JPEG files from crawls on http://www.contoso.com, create a crawl rule to exclude http://www.contoso.com/*.jpg.

The order of crawl rules is important, because the first rule that matches a particular set of content is the one that is applied.

In this article:

  • Before you begin

  • To create or edit a crawl rule

  • To test a crawl rule on a URL

  • To delete a crawl rule

  • To reorder crawl rules

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

To create or edit a crawl rule

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, in the list of service applications, click the Search service application.

  4. On the Search Administration page, in the Crawling section, click Crawl Rules. The Manage Crawl Rules page appears.

  5. To create a new crawl rule, click New Crawl Rule. To edit an existing crawl rule, in the list of crawl rules, point to the name of the crawl rule that you want to edit, click the arrow that appears, and then click Edit.

  6. On the Add Crawl Rule page, in the Path section:

    • In the Path box, type the path to which the crawl rule will apply. You can use standard wildcard characters in the path.

    • To use regular expressions instead of wildcard characters, select Use regular expression syntax for matching this rule.

  7. In the Crawl Configuration section, select one of the following options:

    • Exclude all items in this path. Select this option if you want to exclude all items in the specified path from crawls. If you select this option, you can refine the exclusion by selecting the following:

      • Exclude complex URLs (URLs that contain question marks (?)). Select this option if you want to exclude URLs that contain parameters that use the question mark (?) notation.

    • Include all items in this path. Select this option if you want all items in the path to be crawled. If you select this option, you can further refine the inclusion by selecting any combination of the following:

      • Follow links on the URL without crawling the URL itself. Select this option if you want to crawl links contained within the URL, but not the starting URL itself.

      • Crawl complex URLs (URLs that contain a question mark (?)). Select this option if you want to crawl URLs that contain parameters that use the question mark (?) notation.

      • Crawl SharePoint content as http pages. Normally, SharePoint sites are crawled by using a special protocol. Select this option if you want SharePoint sites to be crawled as HTTP pages instead. When the content is crawled by using the HTTP protocol, item permissions are not stored.

  8. In the Specify Authentication section, perform one of the following actions:

    Note:

    This option is not available unless the Include all items in this path option is selected in the Crawl Configuration section.

    • To use the default content access account, select Use the default content access account.

    • If you want to use a different account, select Specify a different content access account and then perform the following actions:

      1. In the Account box, type the user account name that can access the paths that are defined in this crawl rule.

      2. In the Password and Confirm Password boxes, type the password for this user account.

      3. To prevent basic authentication from being used, select the Do not allow Basic Authentication check box. The server attempts to use NTLM authentication. If NTLM authentication fails, the server attempts to use basic authentication unless the Do not allow Basic Authentication check box is selected.

    • To use a client certificate for authentication, select Specify client certificate, expand the Certificate menu, and then select a certificate.

    • To use form credentials for authentication, select Specify form credentials, type the form URL (the location of the page that accepts credentials information) in the Form URL box, and then click Enter Credentials. When the logon prompt from the remote server opens in a new window, type the form credentials with which you want to log on. You are prompted if the logon was successful. If the logon was successful, the credentials that are required for authentication are stored on the remote site.

    • To use cookies, select Use cookie for crawling, and then select either of the following options:

      • Obtain cookie from a URL. Select this option to obtain a cookie from a website or server.

      • Specify cookie for crawling. Select this option to import a cookie from your local file system or a file share. You can optionally specify error pages in the Error pages (semi-colon delimited) box.

    • To allow anonymous access, select Anonymous access.

  9. Click OK.

To test a crawl rule on a URL

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, in the list of service applications, click the Search service application.

  4. On the Search Administration page, in the Crawling section, click Crawl Rules.

  5. On the Manage Crawl Rules page, in the Type a URL and click test to find out if it matches a rule box, type the URL that you want to test.

  6. Click Test. The result of the test appears below the Type a URL and click test to find out if it matches a rule box.

To delete a crawl rule

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, in the list of service applications, click the Search service application.

  4. On the Search Administration page, in the Crawling section, click Crawl Rules.

  5. On the Manage Crawl Rules page, in the list of crawl rules, point to the name of the crawl rule that you want to delete, click the arrow that appears, and then click Delete.

  6. Click OK to confirm that you want to delete this crawl rule.

To reorder crawl rules

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, in the list of service applications, click the Search service application.

  4. On the Search Administration page, in the Crawling section, click Crawl Rules.

  5. On the Manage Crawl Rules page, in the list of crawl rules, in the Order column, specify the crawl rule position that you want the rule to occupy. Other values shift accordingly.


Add, edit, or delete a content source in SharePoint Server 2013

Summary: Learn how to create a content source to specify what type of content to crawl, schedules for crawling, start addresses, and crawl priority.

Applies to: SharePoint Server 2013

A content source is a set of options that you use to specify what, when, and how to crawl.

When a Search service application is created, a content source named "Local SharePoint sites" is automatically created and configured for crawling all SharePoint sites in the local server farm. You can create additional content sources to specify other content to crawl and how the system should crawl that content. After you create a content source, you can edit or delete it at any time.

Warning:

Changing a content source requires a full crawl for that content source.

In this article:

  • Before you begin

  • To create a content source

  • To edit a content source

  • To delete a content source

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

Create, edit, or delete a content source

To get to the Manage Content Sources page

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. On the home page of the SharePoint Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application.

  4. On the Search Administration Page, in the Crawling section, click Content Sources.

To create a content source

  1. On the Manage Content Sources page, click New Content Source.

  2. On the Add Content Source page, in the Name section, in the Name box, type a name for the new content source.

  3. In the Content Source Type section, select the type of content that you want to crawl.

  4. In the Start Addresses section, in the Type start addresses below (one per line) box, type the URLs from which the crawler should begin crawling.

  5. In the Crawl Settings section, select the crawling behavior that you want.

  6. In the Crawl Schedules section, to specify a schedule for full crawls, select a defined schedule from the Full Crawl list. A full crawl crawls all content that is specified by the content source, regardless of whether the content has changed. To define a full crawl schedule, click Create schedule.

  7. To specify a schedule for incremental crawls, select a defined schedule from the Incremental Crawl list. An incremental crawl crawls content that is specified by the content source that has changed since the last crawl. To define a schedule, click Create schedule. You can change a defined schedule by clicking Edit schedule.

    Note:

    For a content source that is of type SharePoint sites, you can enable continuous crawls. For more information, see Manage continuous crawls in SharePoint Server 2013.

  8. To set the priority of this content source, in the Content Source Priority section, on the Priority list, select Normal or High.

  9. Click OK.

To edit a content source

  1. You can edit a content source to change the schedule on which the content is crawled, the crawl start addresses, the content source priority, or the name of the crawl. Crawl settings and content source type cannot be changed when you edit a content source.

  2. On the Manage Content Sources page, in the list of content sources, point to the name of the content source that you want to edit, click the arrow that appears, and then click Edit.

  3. After you make the changes that you want, click OK.

To delete a content source

  1. On the Manage Content Sources page, in the list of content sources, point to the name of the content source that you want to delete, click the arrow that appears, and then click Delete.

  2. Click OK to confirm that you want to delete this content source.


Start, pause, resume, or stop a crawl in SharePoint Server 2013

Summary: Learn how to start, pause, resume or stop a full or incremental crawl of a content source.

Applies to: SharePoint Server 2013

When you perform a full crawl, all content specified by the content source is crawled even if the content already exists in the search index. To perform a full crawl of the content specified in a content source, you must start a full crawl of that particular content source. Clicking the Start all crawls link on the Manage Content Sources page causes the content specified in all content sources to be crawled using an incremental crawl, unless either of the following conditions is true:

  • The system detects that a full crawl is required.

  • The content source is of type SharePoint sites and Enable Continuous Crawl is selected in the Crawl Schedules section on the Add/Edit Content Sources page for the content source. Continuous crawl is a new crawl schedule option in SharePoint Server 2013 that applies only to content sources of type SharePoint sites.

In this article:

  • Before you begin

  • Start, pause, resume, or stop a crawl

  • Disable continuous crawl

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

  • Create one or more content sources

Start, pause, resume, or stop a crawl

From the Manage Content Sources page, you can start, pause, resume, or stop all crawls of any content source that does not have continuous crawl enabled.

To start, pause, resume, or stop a crawl of a content source

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, in the list of service applications, click the Search service application.

  4. On the Search Administration page, in the Crawling section, click Content Sources.

  5. On the Manage Content Sources page, in the list of content sources, point to the name of the content source that you want, click the arrow and then click one of the following menu items. The value in the Status column does not automatically change. To update the Status column, refresh the Manage Content Sources page by clicking Refresh.

    • Start Full Crawl. The value in the Status column changes to Crawling Full for the selected content source.

    • Start Incremental Crawl. The value in the Status column changes to Crawling Incremental for the selected content source.

    • Resume Crawl. The value in the Status column changes back to Crawling Full or Crawling Incremental for the selected content source.

    • Pause Crawl. The value in the Status column changes to Paused for the selected content source.

    • Stop Crawl. You must click OK to confirm that you want to stop the crawl. The value in the Status column changes to Idle for the selected content source.

Disable continuous crawl

From the Manage Content Sources page, a continuous crawl can be enabled or disabled, but it cannot be paused or resumed. If you want to pause a content source that is currently in continuous crawl mode, disable continuous crawl first. For more information, see Manage continuous crawls in SharePoint Server 2013.


Reset the search index in SharePoint Server 2013

Summary: Learn how to reset the SharePoint search index.

Applies to: SharePoint Server 2013

When you reset the search index, all content is immediately removed from the search index and users will not be able to retrieve search results. After you reset the search index, you must perform a full crawl of one or more content sources to create a new search index. Users will be able to retrieve search results again when the full crawl is finished and the new search index is created.

In this article:

  • Before you begin

  • Reset the search index

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application.

  • Add one or more content sources.

  • Perform at least one full crawl.

  • Make sure that you are not running a backup of the Search service application when you reset the search index.

Reset the search index

Use the following procedure to reset the search index.

To reset the search index

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application for which you want to reset the search index.

  2. On the SharePoint Central Administration home page, in the Application Management section, click Manage service applications.

  3. On the Manage Search Applications page, click the Search service application for which you want to reset the search index.

  4. On the Search Administration page, under System Status, verify that the Administrative status of the Search service application is Running and not Paused.

  5. On the Search Administration page, in the Crawling section, click Index Reset.

  6. On the Index Reset page, verify that the Deactivate search alerts during reset check box is checked, and then click Reset Now.

  7. In the confirmation dialog box that appears, click OK to confirm that you want to reset the index.

    The Search Administration page opens and the System Status is displayed.

After the search index reset is complete, you must perform a full crawl of all the content sources that you want to include in the search index. For more information, see Add, edit, or delete a content source in SharePoint Server 2013. Users will not be able to retrieve search results until you create a new search index.

After the full crawl has completed and a new search index has been created, you must also re-enable search alerts. See Enable search alerts in SharePoint Server 2013.


Delete items from the search index or from search results in SharePoint Server 2013

Summary: Learn how to remove an item from the search index or SharePoint search results by removing the URL.

Applies to: SharePoint Server 2013

If you want to remove an item from the search index or from the search results, you remove the URL of that item. To remove a URL from the search index, use the Remove the Item from the Index option that is available through the crawl log. To remove a URL from search results, use the Search Result Removal feature that allows for bulk URL removal. This can provide a more efficient method if many search results should be removed.

In this article:

  • Before you begin

  • Remove an item from the search index

  • Remove an item from the search results

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

  • Add one or more content sources

  • Perform at least one full crawl

Remove an item from the search index

To remove an item from the search index

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. On the SharePoint Central Administration home page, in the Application Management section, click Manage service applications.

  3. On the Manage Search Applications page, click the Search service application.

  4. On the Search Administration page, in the Diagnostics section, click Crawl Log.

  5. On the Crawl Log page, click URL View.

  6. Do one of the following:

    1. If you know the URL of the item that you want to remove, type the URL in the box.

    2. If you do not know the URL of the item that you want to remove, search for it by using the filters Content Source, Status or Message.

  7. Click Search.

  8. Find and point to the URL of the item that you want to remove, click the arrow and then click Remove the item from the Index.

  9. In the confirmation dialog that appears, click OK to confirm that you want to remove the item from the index.

  10. Verification: the text Removed from the search index by Admin appears under the URL in the crawl log.

Remove an item from the search results

To remove an item from the search results

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. On the SharePoint Central Administration home page, in the Application Management section, click Manage service applications.

  3. On the Manage Search Applications page, click the Search service application.

  4. On the Search Administration page, in the Queries and Results section, click Search Result Removal.

  5. On the Exclude URLs From Search Results page, in the URLs to remove box, type the URLs of the items that you want to remove from the search results.

  6. Click Remove Now.


Add or remove a file type from the search index in SharePoint Server 2013

Updated: June 18, 2013

Summary: Learn how to add or remove a file type from the search index and how to start or stop including content from the file type, in the search index.

Applies to: SharePoint Server 2013

Before you start, you may want to read Default crawled file name extensions and parsed file types in SharePoint Server 2013. This article lists the file types that SharePoint 2013 by default includes in the search index.

To add or remove a file type from the search index:

  1. Add or remove the file name extension from the list of file name extensions on the Manage File Types page. See Add or remove file name extensions from the Manage File Types page.

  2. Run a full crawl for all content sources that this change might affect.

When the full crawl finishes, the search index will include or exclude properties from files of the type that you have either added or removed.

To start including content from a file type, in the search index:

  1. On a server that hosts a content processing component in the Search service application, check whether the format of the file type is supported by a built-in format handler or a third-party filter-based format handler (iFilter). Built-in format handlers are the those that SharePoint 2013 has by default. See View information about file formats that can be parsed.

  2. If the server does not have a format handler for the file type, install a third-party filter-based format handler on all servers hosting content processing components in the Search service application. Follow the installation guidance given by the manufacturer of the third-party format handler.

  3. On all servers that host a content processing component in the Search service application, enable parsing of the format of the file and the file name extension. See Enable or disable parsing of a file format.

  4. Run a full crawl for all content sources that this change might affect.

When the full crawl finishes, the search index will include content from files of the type that you enabled.

To stop including content from a file type, in the search index:

  1. On a server that hosts a content processing component in the Search service application, check whether the format of the file type is supported by a built-in format handler or a third-party filter-based format handler (iFilter). Built-in format handlers are those that SharePoint 2013 has by default.

  2. On all servers that host a content processing component in the Search service application, disable parsing of the format of the file and the file name extension. See Enable or disable parsing of a file format.

  3. Run a full crawl for all content sources that this change might affect.

When the full crawl finishes, the search index will exclude content from files of the type that you disabled.

In this article:

  • Before you begin

  • Add or remove file name extensions from the Manage File Types page

  • View information about file formats that can be parsed

  • Enable or disable parsing of a file format

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

Add or remove file name extensions from the Manage File Types page

To add a file name extension to the Manage File Types page

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, in the list of service applications, click the Search service application.

  4. On the Search Administration page, in the Crawling section, click File types. The Manage File Types page appears.

  5. Click New File Type.

  6. In the File extension box, type the extension of the file type that you want to add.

  7. Click OK.

  8. Verification: make sure that the extension appears in the list of file types on the Manage File Types page.

To remove a file name extension from the Manage File Types page

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, in the list of service applications, click the Search service application.

  4. On the Search Administration page, in the Crawling section, click File types. The Manage File Types page appears.

  5. Point to the file type that you want to remove, click the arrow that appears and then click Delete.

  6. Click OK to confirm that you want to delete the file type.

  7. Verification: make sure that the extension no longer appears in the list of file types on the Manage File Types page.

View information about file formats that can be parsed

To view information about the file formats that the content processing component has format handlers for, you have to use Windows PowerShell.

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Start a SharePoint 2013 Management Shell on the server.

    • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
Get-SPEnterpriseSearchFileFormat -SearchApplication $ssa

    The result is a list of all file formats that the content processing component in the Search service application referenced by $ssa can parse. For each file format the list shows:

    • The file name extension and mime type

    • The type of format handler that the content processing component uses to parse the format. The entry "BuiltIn:True" indicates a built-in format handler. The entry "BuiltIn:False" indicates a third-party filter-based format handler.

    • The parsing state of the format. The entry "Enabled:True" indicates that parsing is enabled. The entry "Enabled:False" indicates that parsing is disabled.

Enable or disable parsing of a file format

To enable or disable parsing of a file format, you have to use Windows PowerShell.

To enable parsing of a file format using a built-in format handler

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Start a SharePoint 2013 Management Shell on the server that hosts the content processing component.

    • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchFileFormatState -SearchApplication $ssa FormatID $TRUE

    Where:

    FormatID is the identity of the file format.

    $TRUE enables the format handler to parse the file type.

  4. Restart the SharePoint Search Host Controller service to apply the changes:

    1. Open a command prompt window on the server that hosts the content processing component. On the Start menu, click All Programs, click Accessories, right-click Command Prompt and then click Run as administrator.

    2. To stop the SharePoint Search Host Controller, type this command: net stop spsearchhostcontroller

    3. To restart the SharePoint Search Host Controller, type this command: net start spsearchhostcontroller

  5. Verification: show the list of file name extensions and file formats that the content processing component can parse and make sure that the file name extension is there. See View information about file formats that can be parsed.

To disable parsing of a file format using a built-in format handler

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Start a SharePoint 2013 Management Shell on the server that hosts the content processing component.

    • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchFileFormatState -SearchApplication $ssa FormatID $FALSE

    Where:

    FormatID is the identity of the file format.

    $FALSE disables the format handler from parsing the file type.

  4. Restart the SharePoint Search Host Controller service to apply the changes:

    1. Open a command prompt window on the server that hosts the content processing component. On the Start menu, click All Programs, click Accessories, right-click Command Prompt and then click Run as administrator.

    2. To stop the SharePoint Search Host Controller, type this command: net stop spsearchhostcontroller

    3. To restart the SharePoint Search Host Controller, type this command: net start spsearchhostcontroller

  5. Verification: show the list of file name extensions and file formats that the content processing component can parse and make sure that the file name extension is not there. See View information about file formats that can be parsed.

To enable parsing of a file format using a third-party filter-based format handler

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Start a SharePoint 2013 Management Shell on the server that hosts the content processing component.

    • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
New-SPEnterpriseSearchFileFormat -SearchApplication $ssa FileNameExtension FileFormat application/FileApplication

    Where:

    FileNameExtension is the file name extension of the file type.

    FileFormat is the format of the file type. The format is often the name of the application.

    application/FileApplication is the mime type of the file type. The mime type must consist of a type and a subtype. In this example, application is the type and FileApplication is the subtype. For example, for Word files, the type is application and the subtype is msword. Together they form the complete mime type: application/msword.

  4. Restart the SharePoint Search Host Controller service to apply the changes:

    1. Open a command prompt window on the server that hosts the content processing component. On the Start menu, click All Programs, click Accessories, right-click Command Prompt and then click Run as administrator.

    2. To stop the SharePoint Search Host Controller, type this command: net stop spsearchhostcontroller

    3. To restart the SharePoint Search Host Controller, type this command: net start spsearchhostcontroller

  5. Verification: show the list of file name extensions and file formats that the content processing component can parse and make sure that the file name extension is there. See View information about file formats that can be parsed.

To disable parsing of a file format using a third-party filter-based format handler

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Start a SharePoint 2013 Management Shell on the server that hosts the content processing component.

    • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following commands:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
Remove-SPEnterpriseSearchFileFormat -SearchApplication $ssa -Identity FileNameExtension

    Where:

    FileNameExtension is the file name extension of the file type.

  4. Restart the SharePoint Search Host Controller service to apply the changes:

    1. Open a command prompt window on the server that hosts the content processing component. On the Start menu, click All Programs, click Accessories, right-click Command Prompt and then click Run as administrator.

    2. To stop the SharePoint Search Host Controller, type this command: net stop spsearchhostcontroller

    3. To restart the SharePoint Search Host Controller, type this command: net start spsearchhostcontroller

  5. Verification: show the list of file name extensions and file formats that the content processing component can parse and make sure that the file name extension is not there. See View information about file formats that can be parsed.

Change History

Date | Description
June 18, 2013 | Added steps for checking what file formats can be parsed, and for enabling or disabling parsing of a file format.
July 16, 2012 | Initial publication


Configure and use the Exchange connector for SharePoint 2013

Updated: August 6, 2013

Summary: Learn how to create a crawl rule and add a content source to crawl Exchange Server public folders.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

In this article:

  • Before you begin

  • Create a crawl rule

  • Add a content source for Exchange Server public folders

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

  • Ensure that the crawler has at least Read permission to the Exchange Server public folder.

Create a crawl rule

This following procedure describes how to create a crawl rule. You must create a crawl rule if the default content access account does not have Read permission to the Exchange Server public folders that you want to crawl.

To create a crawl rule

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, in the list of service applications, click the Search service application.

  4. On the Search Administration page, in the Crawling section, click Crawl Rules.

  5. On the Manage Crawl Rules page, click New Crawl Rule.

  6. On the Add Crawl Rule page, in the Path section, in the Path box, type the path to which the crawl rule will apply. You can use standard wildcard characters in the path.

    Note:

    When creating a crawl rule, the URL that you type inside the Path box should be in the following form: <protocol>://hostname/* where <protocol> is the protocol that you want to use (typically http or https), and hostname is the NetBIOS or fully qualified domain name of the server that is running Exchange Server.

  7. In the Crawl Configuration section, select Include all items in this path.

  8. In the Specify Authentication section, select the type of crawl authentication to use. This section is available only if Include all items in this path is selected.

  9. Click OK.

Add a content source for Exchange Server public folders

Use one of the following procedures to create a content source for Exchange Server public folders. Which procedure you should follow depends on the Exchange Server version. You can choose to add a content source to crawl public folders in:

  • Exchange Server 2007 and Exchange Server 2007 with Service Pack 1 (SP1)

  • Exchange Server 2007 with Service Pack 2 (SP2) and Exchange 2010

To add a content source for Exchange Server 2007 and Exchange Server 2007 SP1 public folders

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. On the SharePoint Central Administration home page, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application.

  4. On the Search Administration page, in the Crawling section, click Content Sources.

  5. On the Manage Content Sources page, click New Content Source.

  6. On the Add Content Source page, in the Name box, type a name for the new content source.

  7. In the Content Source Type section, select Exchange Public Folders.

  8. In the Start Addresses section, in the Type start addresses below (one per line) box, type the URLs for the Exchange Server public folders that you want to crawl. These URLs are typically in one of the following forms:

    • <protocol>://host name/public

      Where <protocol> can be http or https, and host name is the NetBIOS or fully qualified domain name (FQDN) of the server that is running Exchange Server.

    • <protocol>://host name/public/subfolder

      Where <protocol> can be http or https, host name is the NetBIOS or FQDN of the server that is running Exchange Server, and subfolder is the name of the specific subfolder that you want to crawl.

    For example, if you want to crawl all subfolders in the public folder on a server that is named exch-01 and that is in the Contoso domain, and that server does not use SSL, you could type either http://exch-01/public or http://exch-01.contoso.com. To crawl only a specific subfolder named Bob in the same public folder, type http://exch-01/public/bob or http://exch-01.contoso.com/bob.

    Note:

    For performance reasons, you cannot add the same start addresses to multiple content sources.

  9. In the Crawl Settings section, select the crawling behavior that you want.

  10. In the Crawl Schedules section, you can choose to specify when to start full and incremental crawls:

    • To create a full crawl schedule, click the Create Schedule link below the Full Crawl list.

    • To create an incremental crawl schedule, click the Create schedule link below the Incremental Crawl list.

  11. Click OK.

To add content sources for Exchange Server 2007 SP2 and Exchange 2010 public folders

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. Open a web browser and go to the Outlook Web Access webpage for the Exchange Server that contains the public folders that you want to crawl.

  3. Log on to Outlook Web Access using any user account that has Read permissions on the public folders that you want to crawl.

  4. Go to the public folder that you want to crawl, right-click the folder, and then select Open in New Window.

  5. When the new window opens, go to the address bar and copy the complete URL. This is the Outlook Web Access public folder address.

  6. On the SharePoint Central Administration home page, in the Application Management section, click Manage service applications.

  7. On the Manage Service Applications page, click the Search service application.

  8. On the Search Administration page, in the Crawling section, click Content Sources.

  9. Click New Content Source.

  10. On the Add Content Source page, in the Name box, type a name for the new content source.

  11. In the Content Source Type section, select Exchange Public Folders.

  12. In the Start Addresses section, paste the Outlook Web Access public folder address that you copied in step 5.

  13. In the Crawl Settings section, select the crawling behavior that you want.

  14. In the Crawl Schedules section, you can choose to specify when to start full and incremental crawls:

    • To create a full crawl schedule, click the Create Schedule link below the Full Crawl list.

    • To create an incremental crawl schedule, click the Create schedule link below the Incremental Crawl list.

  15. Click OK.

Change History

Date | Description
August 06, 2013 | Deleted the statement of support for crawling Exchange 2013 public folders. Currently SharePoint 2013 only supports crawling Exchange 2007 public folders and Exchange 2010 public folders.
July 16, 2012 | Initial publication


Configure and use the Lotus Notes connector for SharePoint Server 2013

Summary: Learn about the administrative roles, required software, user accounts, and processes that are required to install and operate the Lotus Notes Client and the Lotus Notes Connector to work with SharePoint 2013 search.

Applies to: SharePoint Server 2013

In this article:

  • Before you begin

  • Prerequisites

  • Install the Lotus Notes client application

  • Grant permissions on the data folder

  • Configure the Lotus Notes client application

  • Verify access to the Lotus Domino database that you want to crawl

  • Configure security mappings

  • Restart the server that hosts the crawl component

  • Register Lotus Notes with the server that hosts the crawl component

  • Provision the Lotus Notes Connector

  • Restart the OSearch15 service

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Required administrative roles

  • Required software

  • User accounts required to crawl Lotus Domino databases

The procedures in this article must be repeated on all the servers in the SharePoint Server 2013 farm that host a crawl component.

Prerequisites

The following sections list the required administrative roles, software and user accounts.

Required administrative roles

The following administrative roles are required to prepare any server that hosts a crawl component to crawl Lotus Notes content that is hosted by one or more Lotus Domino databases:

  • Administrator of the Lotus Domino server that you want to crawl.

  • Server administrator of the server that hosts a crawl component that you want to use to crawl Lotus Notes content.

  • Service application administrator for the Search service application.

Required software

The following software is required:

  • Lotus C++ API Toolkit for Notes.

  • Lotus Notes client application, available for purchase from IBM.

  • Lotus Notes Domino Server, available for purchase from IBM.

The following table shows combinations of versions of the Lotus Notes Domino server and Lotus Notes client that the Lotus Notes Connector works with.

This server version | With client 6.x | With client 7.x | With client 8.x
Server 6.x | YES | NO | NO
Server 7.x | NO | YES | YES
Server 8.x | NO | NO | YES

User accounts required to crawl Lotus Domino databases

A Domino administrator must grant a Lotus Notes user ID (which represents a Domino user) at least the Reader permission to the Lotus Domino databases and individual documents that you want to crawl. The Domino administrator must also add this Lotus Notes user ID and the Windows domain user account that is assigned to the SharePoint Server Search 15 service (OSearch15) to a mappings database on the Lotus Domino server that you want to crawl.

Note:

Only the user account that is assigned to the OSearch15 service can be used to crawl Lotus Domino databases. You cannot use the default content access account or a crawl rule to specify a different user account to crawl Lotus Domino databases.

The following table summarizes the user accounts that are required to crawl Lotus Domino databases.

Required account Comment Example

Windows domain user account

The user account that is assigned to the OSearch15 service must also be a member of the Administrators group on the server that hosts the crawl component.

Contoso\User1, where Contoso is the domain name and User1 is the name of the Windows domain user account.

Lotus Notes user ID

The Lotus Notes user ID must be granted at least Reader access on the Lotus Domino databases and on the individual documents that you want to crawl. The Domino certificate also contains this Lotus Notes user ID.

User2

Note:

The name of this account and its password do not have to match the Windows domain user account.

More information about this mappings table is provided later in this article, see Configure security mappings.

Install the Lotus Notes client application

Follow this procedure to install the Lotus Notes client application on the server that hosts the crawl component in the server farm that you want to use to crawl a Lotus Domino database. This client application serves as a protocol handler and is used to configure the Notes.ini file. Both are used by the crawler when crawling Lotus Domino databases.

To install Lotus Notes

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that hosts the crawl component and has at least Manager permissions on the Domino server.

  2. Copy the Lotus Notes client application to the server that hosts the crawl component that you want to use to crawl Lotus Notes documents.

  3. Start the Lotus Notes Installation Wizard.

  4. In the Welcome to the Installation Wizard for Lotus Notes dialog box, click Next.

  5. On the License Agreement page, click I accept the terms in the license agreement, and then click Next to continue.

  6. On the Customer Information page, type a user name in the User Name box and the name of the organization in the Organization box, or accept the default settings, and then click Next.

  7. On the Installation Path Selection page, specify the path for the program and data files, or accept the default installation paths, and then click Next.

    Note:

    By default, program files are stored in the <SystemDrive>:\Program Files (x86)\lotus\notes\ folder and data files are stored in the <SystemDrive>:\Program Files (x86)\lotus\notes\data\ folder, where <SystemDrive> is the drive on which Lotus Notes is installed.

  8. On the Custom Setup page, select the program features that you want to install on the local hard disk drive, and then click Next.

    The following table shows the features and sub-features that are required by the Lotus Notes connector.

    Feature Subfeature

    Notes Client

    Client Help Files

    Domino Enterprise Connection Services (DECS)

    Domino Designer

    Designer Help

  9. On the Ready to Install the Program page, if you do not want Lotus Notes to be the default email program, clear the selection Make Notes my default email program.

  10. Click Install.

    The Installing Lotus Notes page shows the status of the installation.

  11. On the Install Wizard Completed page, click Finish.

Grant permissions on the data folder

Follow this procedure to grant Full Control permissions for the WSS_WPG group on the <SystemDrive>:\Program Files (x86)\Lotus\Notes\Data folder on the server that hosts the crawl component.

To grant permissions on the data folder

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that hosts the crawl component and has at least Manager permissions on the Domino server.

  2. On the server that hosts the crawl component, click Start, point to All Programs, click Accessories, and then click Windows Explorer.

  3. In Windows Explorer, go to the <SystemDrive>:\Program Files (x86)\Lotus\Notes\Data folder, where <SystemDrive> is the drive on which Lotus Notes is installed.

  4. Right-click the Data folder, and then click Sharing and Security.

  5. In the Properties dialog box, on the Security tab, click Add.

  6. In the Select the object names to select box, do one of the following, and then click OK:

    • If search is installed on an Active Directory domain controller, type domain\WSS_WPG, where domain is the name of the domain that is associated with the domain controller.

    • If search is installed on a server that is not an Active Directory domain controller, type server\WSS_WPG, where server is the NetBIOS name of the server that hosts the crawl component.

  7. In the Properties dialog box, in the Permissions for WSS_WPG section, select the Allow box in the Full control row, and then click OK.

Configure the Lotus Notes client application

Follow this procedure to configure the Lotus Notes client application. The configuration settings selected in this procedure are written to the Notes.ini file, which the crawler uses to discover how to connect to the Lotus Domino server.

To configure Lotus Notes

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that hosts the crawl component and has at least Manager permissions on the Domino server.

  2. On the server that hosts the crawl component, click Start, point to All Programs, point to Lotus Applications, and then click Lotus Notes.

  3. On the Welcome page, click Next.

  4. On the User Information page, in the Your name box, type the user name associated with the Domino certificate.

  5. Type the hierarchical name of the Domino server that you want to crawl in the Domino server box. For example, Contoso/marketing/west.

  6. Ensure that I want to connect to a Domino server is selected, and then click Next.

  7. On the Notes ID File page, click Browse, and then locate where the certificate is stored. Select the certificate, click Open, and then click Next.

  8. Click Yes to copy the certificate to the specified location.

    Note:

    If you are not prompted for a Domino certificate, click Previous, and ensure that you have entered the correct information.

  9. If a dialog box appears that informs you that you are not authorized to access the specified directory, click OK to close the dialog box. This error is expected if the account that you are logged on with does not have access to the email folder on the Domino server.

  10. On the Instant Messaging Setup page, cancel the selection Setup instant messaging.

  11. Click Next.

  12. On the Additional Services page, click Next.

  13. In the Lotus Notes message box, click OK.

    The Lotus Notes Welcome screen appears.

    Leave the Lotus Notes client application open. You will need it for the next procedure.

Verify access to the Lotus Domino database that you want to crawl

Follow this procedure to verify that the certificate that you installed has access to the database that you want to crawl.

To verify access

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that hosts the crawl component and has at least Manager permissions on the Domino server.

  2. In Lotus Notes, click File, point to Database, and then click Open.

  3. In the Open Database dialog box, select the Lotus Domino server that you want to connect to from the Server list.

  4. In the Database list, select the database that you want to connect to, and then click Open.

    The documents that are contained by the database that you selected are displayed in the Document Name section. This means that the server that hosts the crawl component as the necessary permissions to crawl these documents.

  5. Repeat steps 1 to 3 for each additional database that you want to verify access to.

  6. On the File menu, click Exit Notes.

Configure security mappings

Use the information in the following table to help you create the mappings database.

Item Description

Mappings database name

Name of the Lotus Domino database that maps Lotus Notes user IDs to Windows domain user accounts.

Lotus Notes field name

Name of the field in the Lotus Domino database file that stores Lotus Notes user IDs.

Windows user field name

Name of the field in the Lotus Domino database file that stores Windows user names.

Form name

Name of the form that stores the Lotus Notes field name and Windows user field name fields.

View name

Name of the view for the form that stores the Lotus Notes user IDs to Windows user name mappings.

Note:

This name is case-sensitive.

Create the mappings database

Follow this procedure to create a mappings database by using Domino Designer. You only require one mappings database for each forest of Domino servers that contain databases that you want to crawl.

To create a mappings database

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that hosts the crawl component and has at least Manager permissions on the Domino server that you want to crawl.

  2. On the server that hosts the crawl component, open Domino Designer.

  3. Click File, point to Database, and then click New.

  4. In the New Database dialog box, do the following:

    1. Select the Domino server from the Server name list.

    2. In the Title box, type a title for the new database.

      This content automatically populates the File Name box, and it is appended with the .nsf file name extension.

      If the title that you chose is more than eight characters long, the file name will be truncated.

    3. Click OK to close the New Database dialog box.

  5. Click Create, point to Design, and then click Form.

  6. Click Create, and then click Field.

  7. In the Field dialog box, in the Name box, type the name that you want to use for this field. This field will be used to store the Lotus Notes user IDs.

  8. Close the dialog box to save the field.

  9. Click Create, and then click Field.

  10. In the Field dialog box, in the Name box, type the name that you want to use for this field. This field will be used to store the Windows domain user accounts.

  11. Close the dialog box to save the field.

  12. Click File, click Save, and then do the following:

    1. Type a name in the Save Form as box.

    2. Click OK to close the dialog box.

  13. On the Create menu, point to Design, and then click View.

  14. In the Create View dialog box, do the following:

    1. In the View name box, type a name for this view.

    2. Select Shared from the View type list.

    3. Click OK to save the view.

  15. Open the view that you created in step 14.

  16. On the Objects tab, select the column that you created in step 7. In the lower right pane, select Field and then select the field that has the same name.

  17. On the Objects tab, select the column that you created in step 10. In the lower right pane, select Field and then select the field of the same name.

  18. Click File and then click Save to save the view, and then close Domino Designer.

Add user accounts to the mappings database

Follow this procedure to add user accounts to the mappings database using the Lotus Notes client. You should add all accounts which require access to the mappings database and the Domino server.

To add user accounts to the mappings database

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that hosts the crawl component and has at least Manager permissions on the Domino server.

  2. On the server that hosts the crawl component, open the Lotus Notes client application.

  3. Click File, point to Database, and then click Open.

  4. In the Open Database dialog box, do the following:

    1. Select the Domino server from the Server name list.

    2. Select the mappings database that you created earlier.

    3. Click Open.

  5. In the left pane, select the view that you created for this database.

  6. Click Create, and then click the name of the form that you created earlier.

  7. In the form, in the field that you created to store the Lotus Notes user IDs, type a Lotus Notes user ID that you want to map to a Windows domain user account. For example, ContosoUser. This field is case-sensitive.

  8. In the field that you created to map to the Lotus Notes user IDs, type the Windows domain user account that you want to map to the Lotus Notes user ID that you entered in step 7. This must be in the form of domain\user, for example, Contoso\user1.

  9. Click File, and then click Save to save the document.

  10. Repeat steps 6 to 8 if you want to add more mappings. Otherwise, go to step 11.

  11. When finished, save the form and then close the Lotus Notes client application.

Restart the server that hosts the crawl component

You must restart the server that hosts the crawl component before continuing to the next procedure.

Important:

After the server that hosts the crawl component restarts, do not open the Lotus Notes client application again. This is because the Lotus Notes client application might lock files that could cause the following procedures and crawling Lotus Domino databases to fail.

Register Lotus Notes with the server that hosts the crawl component

Following this procedure to register Lotus Notes with the operating system of the server that hosts the crawl component.

To register Lotus Notes

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that hosts the crawl component.

  2. Run Notessetup.exe on the server that hosts the crawl component by using the same credentials that are used to provision the Lotus Notes Connector.

  3. On the server that hosts the crawl component, in Windows Explorer, go to the <SystemDrive>:\Program Files\Microsoft Office Servers\15\Bin\1033 folder, where <SystemDrive> is the drive on which Microsoft SharePoint Server 2013 is installed.

  4. Double-click NotesSetup.exe.

  5. On the Welcome to the Lotus Notes Index Setup Wizard page, click Next.

  6. In the Register Lotus Notes for use with SharePoint Server dialog box, do the following:

    1. In the Location of the notes.ini file box, ensure that the correct path of the Notes.ini file is specified. The default path of this file is <SystemDrive>:\Program Files (x86)\lotus\notes\notes.ini, where <SystemDrive> is the drive on which Lotus Notes is installed.

    2. In the Location of the Lotus Notes install directory box, ensure that the correct path of the Lotus Notes installation directory is specified. By default, the path of this directory is <SystemDrive>:\Program Files (x86)\lotus\notes.

    3. In the Password box, type the password for the user name that is associated with the Domino certificate.

    4. In the Confirm Password box, retype the password for the user name that is associated with the Domino certificate.

  7. We recommend that you leave the Ignore Lotus Notes security while building the index box cleared. This allows the crawl to include all Lotus Notes documents in the search index without restriction. Security for these documents and objects is determined by the mappings table and provides security data without excluding documents from the index.

  8. Click Next.

  9. On the Specify Lotus Notes Owner Field to Windows User Name Mapping page, do the following:

    1. In the Lotus Notes server name box, type the NetBIOS name or IP address of the Domino server.

    2. In the Lotus Notes database file name box, type the file name of the Lotus Domino database that maps the Lotus Notes user IDs to Windows domain user accounts. Ensure that you include the .nsf file name extension with this name, for example, Mappings.nsf.

    3. In the View name box, type the view name of the Lotus Domino database that stores the Lotus Notes user IDs to Windows user name mappings.

    4. In the Lotus Notes field name column title box, type the name of the column in the Lotus Notes database file that is used to store Lotus Notes user IDs.

    5. In the Windows user name column title box, type the name of the column in the Lotus Notes database file that is used to store the Windows user accounts.

  10. Click Next.

  11. On the Completing the Lotus Notes Index Setup Wizard page, click Finish.

Provision the Lotus Notes Connector

Follow this procedure to provision the Lotus Notes Connector with the operating system of the server that hosts the crawl component.

To provision Lotus Notes

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the server that hosts the crawl component.

  2. Open SharePoint Central Administration. In the System Settings section, click Manage services on Server.

  3. On the Services on Server page, in the Service column, find the Lotus Notes Connector service.

  4. In the Action column, click Start.

  5. On the Lotus Notes connector settings page, in the application pool section, select Create new application pool, and then enter a name for the new application pool.

  6. In the Configurable drop-down, select or register the same security account used for installation of the NotesSetup.exe.

  7. Click Provision.

The Lotus Notes connector is now provisioned and started.

Restart the OSearch15 service

The server administrator of the server that hosts the crawl component must restart the OSearch15 service before a content source can be created for Lotus Domino databases.

Important:

Do not use the Services on Server page on the SharePoint Central Administration Web site to restart this service. Doing so resets the search index, which requires you to do a full crawl of all content to rebuild the index.

To restart the OSearch15 service

  1. Verify that the user account that is performing this procedure is an administrator for the server that hosts the crawl component.

  2. Open a command prompt window.

  3. To stop the OSearch15 service, type this command: net stop osearch15

  4. To start the OSearch15 service, type this command: net start osearch15


Configure and use the Documentum connector in SharePoint Server 2013
See also

Updated: May 14, 2013

This article describes how to install and configure the Microsoft SharePoint 2013 Indexing Connector for Documentum.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

The Microsoft SharePoint 2013 Indexing Connector for Documentum enables you to index content that is stored in the EMC Documentum system. This article describes how to install and configure the Indexing Connector for Documentum for use with SharePoint 2013.

The Indexing Connector for Documentum:

  • Is a 64-bit connector based on the SharePoint 2013 Search Connector Framework.

  • Supports multiple versions of EMC Documentum Content Server.

  • Indexes Documentum objects and object metadata. See Reference - supported and unsupported Documentum object types and properties.

  • Supports Documentum security definitions and policies.

  • Supports Windows PowerShell for automated configuration and administration. See Reference - SPEnterpriseSearchDCTMConnectorConfig cmdlet.

  • Has a configurable search results URL to support multiple Documentum client applications.

  • Supports file and folder exclusion for crawling.

In this article:

  • Before you begin

  • Overview

  • Prepare the SharePoint 2013 servers that host a crawl component

  • Install and register the Indexing Connector for Documentum

  • Configure the Indexing Connector for Documentum

  • Create a crawl rule for Documentum

  • Create a Documentum content source

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following system prerequisites and requirements:

  • The supported operating systems are Windows Server 2008 R2, Windows Server 2008 Service Pack 2, and Windows Server 2012.

  • One of the following SharePoint 2013 Products is installed and configured:

    • Microsoft SharePoint Server 2013 Enterprise

    • Microsoft SharePoint Server 2013 Standard

  • A Search service application is installed and configured.

  • A Documentum Foundation Services (DFS) Server with a version that is compatible with DFS Productivity Layer 6.7 SP2 is installed on a Windows host.

  • DFS Productivity Layer 6.7 SP2 is installed and you have access to the .NET assemblies that are included in the DFS Productivity Layer 6.7 SP2. The Indexing Connector for Documentum uses DFS as the connectivity API to access Documentum repositories.

  • Documentum Content Server is installed. The supported versions of Documentum Content Server are determined by DFS 6.7 SP2. You can find a detailed list in the DFS Productivity Layer 6.7 SP2 release notes. You can download the release notes from the EMC customer support site http://powerlink.emc.com.

  • Configure the Indexing Connector for Documentum with -ACLTranslation "Claims" if you have to crawl Documentum repositories that have Documentum Trusted Content Services (TCS) enabled. You can also use this connector configuration to enable automatic mapping between Windows Active Directory users and Documentum users, regardless of whether the repository has TCS enabled.

Overview

The following steps provide a high-level overview of the tasks that are involved to install and configure the Indexing Connector for Documentum for use with SharePoint 2013.

  1. Preparation:

    1. Ensure that your system meets the system prerequisites and requirements in the section Before you begin.

    2. Download the SharePoint 2013 Indexing Connector for Documentum from the Microsoft Download Center.

    3. Decide which Documentum content access account to use for crawling.

    4. Prepare the SharePoint 2013 servers that host a crawl component. On each server:

      1. Set the DFS Productivity Layer .NET assemblies.

      2. Edit the machine.config file to set the Documentum bindings.

  2. Install the Indexing Connector for Documentum.

    1. Install the Indexing Connector for Documentum on each SharePoint 2013 server in the farm that hosts a crawl component.

    2. Register the Indexing Connector for Documentum to the Search service application by using Windows PowerShell.

  3. Configure the Indexing Connector for Documentum on each SharePoint 2013 server in the farm that hosts a crawl component by using the Indexing Connector for Documentum PowerShell cmdlet. Choose one of the following configurations:

    Configuration ACL Translation Description See this section

    Support crawling EMC Documentum Trusted Content Services (TCS) content or regular Documentum content with automatic user mapping.

    Claims

    You enable automatic user mapping by configuring a separate Security Trimmer Sync Service and pre- and post-trimmers.

    Configure the Indexing Connector for Documentum to support TCS and automatic user mapping

    Support crawling Documentum content and use a manually created user mapping table.

    UserMappingTable

    You manually create a user mapping table in SQL Server to specify how the Documentum users are mapped to Active Directory Domain Services (AD DS) or Active Directory service users. You configure the connector by specifying in which database you have created the user mapping table by using Windows PowerShell.

    Configure the Indexing Connector for Documentum using a user mapping table

    Support crawling Documentum content when Documentum and Windows user accounts are the same.

    SameAccountName

    The Indexing Connector for Documentum assumes that Documentum and SharePoint users share the same account, such as a shared account in Active Directory. Once an account is found that is not valid, the Indexing Connector for Documentum discards the account permission.

    Reference - SPEnterpriseSearchDCTMConnectorConfig cmdlet

    Support crawling Documentum content without security trimming the search results.

    NoSecurity

    All users will be able to see all Documentum search results. This can be useful if you have a public Documentum repository that everyone can access, for example.

    Reference - SPEnterpriseSearchDCTMConnectorConfig cmdlet

  4. Configure a Documentum crawl rule and content source in the Search service application by using Central Administration.

    1. Create a crawl rule for Documentum.

    2. Create a Documentum content source

    3. Perform a full crawl.

Prepare the SharePoint 2013 servers that host a crawl component

Decide which Documentum content access account to use for crawling

  1. You have to specify the Documentum content access account and the password later in the configuration procedure when you set up crawl rules. The Indexing Connector for Documentum uses the content access account to retrieve content from the Documentum repository. This account must have the following minimum permissions:

    • Read permission to documents that you want to crawl.

    • Browse permission to cabinets, folders, and records (documents with only metadata) that you want to crawl.

Set the DFS Productivity Layer .NET assemblies

  1. Locate the following DFS Productivity Layer .NET assemblies and verify that the version number is 6.7.2000.36 for all files. When extracted to the default path, these files are located in the %local%\emc-dfs-sdk-6.7\emc-dfs-sdk-6.7\lib\dotnet directory.

    • Emc.Documentum.FS.DataModel.Core.dll

    • Emc.Documentum.FS.DataModel.Shared.dll

    • Emc.Documentum.FS.runtime.dll

    • Emc.Documentum.FS.Services.Core.dll

  2. On each server that hosts a crawl component, log on with an account that is a member of the Administrators group on that server and deploy the DFS Productivity Layer .NET assemblies to the global assembly cache %windir%\assembly.

    Note:

    You can drag and drop the four DLLs into the global assembly cache (%windir%\assembly) to deploy them, but you might have to turn off User Account Control to do this.

The following procedure explains how to edit the machine.config file on each SharePoint 2013 server that hosts a crawl component to include WCF settings for the DFS Productivity Layer. This is done to make sure that the DFS Productivity Layer .NET assemblies function correctly.

The WCF settings that you are about to set in Edit the machine.config file allow a maximum of 30 megabytes (MB) per Documentum content object (the document file plus its metadata) transferred. The administrator can increase maxReceivedMessageSize in DfsDefaultService binding for larger content.

Edit the machine.config file

  1. On each server that hosts a crawl component, open the machine.config file. This file is located in the directory %windir%\Microsoft.NET\Framework64\v4.0.30319\Config.

  2. Copy the following XML snippet to the <configuration> element:

    Copy code
    <system.serviceModel>
<bindings>
<basicHttpBinding>
<binding name="DfsAgentService" closeTimeout="00:01:00"
 openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00"
 allowCookies="false" bypassProxyOnLocal="false" hostNameComparisonMode="StrongWildcard"
 maxBufferSize="10000000" maxBufferPoolSize="10000000" maxReceivedMessageSize="10000000"
 messageEncoding="Text" textEncoding="utf-8" transferMode="Buffered"
 useDefaultWebProxy="true">
<readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
  maxBytesPerRead="4096" maxNameTableCharCount="16384" />
<security mode="None">
<transport clientCredentialType="None" proxyCredentialType="None"
realm="" />
<message clientCredentialType="UserName" algorithmSuite="Default" />
</security>
</binding>

<binding name="DfsContextRegistryService" closeTimeout="00:01:00"
   openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00"
   allowCookies="false" bypassProxyOnLocal="false" hostNameComparisonMode="StrongWildcard"
   maxBufferSize="10000000" maxBufferPoolSize="10000000" maxReceivedMessageSize="10000000"
   messageEncoding="Text" textEncoding="utf-8" transferMode="Buffered"
   useDefaultWebProxy="true">
<readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
maxBytesPerRead="4096" maxNameTableCharCount="16384" />
<security mode="None">
<transport clientCredentialType="None" proxyCredentialType="None"
realm="" />
<message clientCredentialType="UserName" algorithmSuite="Default" />
</security>
</binding>
<binding name="DfsDefaultService" closeTimeout="00:01:00" openTimeout="00:10:00" receiveTimeout="00:20:00" sendTimeout="00:10:00" allowCookies="false" bypassProxyOnLocal="false" hostNameComparisonMode="StrongWildcard" maxBufferSize="10000000" maxBufferPoolSize="10000000" maxReceivedMessageSize="30000000" messageEncoding="Text" textEncoding="utf-8" transferMode="StreamedResponse" useDefaultWebProxy="true">
<readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384" maxBytesPerRead="1048576" maxNameTableCharCount="16384"/>
<security mode="None">
<transport clientCredentialType="None" proxyCredentialType="None" realm=""/>
<message clientCredentialType="UserName" algorithmSuite="Default"/>
</security>
</binding>
</basicHttpBinding>
</bindings>
</system.serviceModel>

Install and register the Indexing Connector for Documentum

Install the Indexing Connector for Documentum

  1. Download the Indexing Connector for Documentum from the Microsoft Download Center.

  2. On each server in the farm that hosts a crawl component, install the Indexing Connector for Documentum by running the file DCTMIndexConn.exe. Follow the steps in the installation wizard.

Register the Indexing Connector for Documentum to the Search service application

  1. Run this procedure on a SharePoint 2013 server that hosts a crawl component to register the connector to the Search service application.

  2. Start a SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    New-SPEnterpriseSearchCrawlCustomConnector -SearchApplication "<name of your Search service application>" -Protocol "dctm" -ModelFilePath "<%CommonProgramFiles%\Microsoft Shared\Web Server Extensions\15\CONFIG\SearchConnectors\Documentum\MODEL.xml>" -Name "Microsoft SharePoint 2013 Indexing Connector for Documentum"

    Where:

    • <name of your Search service application> is the name of the Search service application that you are registering the connector to.

    • <%CommonProgramFiles%\Microsoft Shared\Web Server Extensions\15\CONFIG\SearchConnectors\Documentum\MODEL.xml> is the path of the Indexing Connector for Documentum model file. The default location is given in this example.

Configure the Indexing Connector for Documentum

You configure the connector settings with the Indexing Connector for Documentum PowerShell cmdlet (Set-SPEnterpriseSearchDCTMConnectorConfig). The settings are stored in %CommonProgramFiles%\Microsoft Shared\Web Server Extensions\15\CONFIG\SearchConnectors\Documentum\DCTMConfig.xml and must be the same on each SharePoint 2013 server that hosts a crawl component.

Which PowerShell cmdlet parameters you use and which additional configuration steps you must perform depends on configuration mode you choose.

Configure the Indexing Connector for Documentum to support TCS and automatic user mapping

The following procedures explain how to configure the indexing connector for Documentum to support TCS. The procedures also show how to enable automatic user mapping by configuring the Security Trimmer Sync Service and create and deploy custom pre- and post-security trimmers. After completing these procedures, your Documentum user credentials will be automatically synced with Windows Active Directory Domain Services (AD), search results will be trimmed accordingly and users will only be able to retrieve Documentum search results that they have permission to see.

The Security Trimmer Sync Service maps Documentum users to AD users by looking at the Documentum fields user_os_domain, user_login_name, user_source and user_ldap_dn. If the user_ldap_dn field is populated, the Security Trimmer Sync Service will try to extract a domain from the first DC value. For example, if the user_ldap_dn field is populated with "CN=User Name, OU=Unit,DC=Domain,DC=Department,DC=Company", the Security Trimmer Sync Service will extract the domain from DC=Domain and will ignore DC=Department,DC=Company.

To configure the connector to support TCS and automatic user mapping

  1. Start a SharePoint 2013 Management Shell on each server that hosts a crawl component.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    Set-SPEnterpriseSearchDCTMConnectorConfig -Shared -ACLTranslation "Claims" -DisplayURLPatternForDocument "http://<MyWebTopServer:PortOfMyWebTopServer>/webtop/component/drl?objectId={ObjectId}&format={Format}&RepositoryName={RepositoryName}" -DisplayURLPatternForContainer "http://<MyWebTopServer:PortOfMyWebTopServer>/webtop/component/drl?objectId={ObjectId}&RepositoryName={RepositoryName}"

Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "<MyRepository1>" -DFSWebServiceURL @("http://<DFSWebServices>:<30000>/services"), ("http://<DFSWebServices2>:<30000>/services")

Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "<MyRepository2>" -DFSWebServiceURL @("http://<DFSWebServices>:<30000>/services")

    Where:

    • <MyWebTopServer:PortOfMyWebTopServer> is the name and the port number of the DFS Web Top Server you are using.

    • <MyRepository n> is the name of Documentum repository that you want to crawl.

    • <DFSWebServices n>:<30000> is the name and the port number of the Documentum Web Services server that hosts the Documentum repository that you want to crawl.

  3. Restart the OSearch15 service. This must be done before you create a content source for Documentum.

    Important:

    Do not use the Services on Server page on the SharePoint Central Administration website to restart this service. Doing so resets the search index, which requires you to do a full crawl of all content to rebuild the index.

    1. Verify that the user account that is performing this procedure is an administrator for the server that hosts the crawl component.

    2. Open a Command Prompt window.

    3. To stop the OSearch15 service, type this command: net stop osearch15

    4. To start the OSearch15 service, type this command: net start osearch15

To set up the Security Trimming Sync Service

  1. Open the file Microsoft.Office.Server.Search.Connector.Documentum.TrimmerSync.exe.config. This file is stored in the folder where you have installed the Indexing Connector for Documentum connector. The default location is %CommonProgramFiles%\Microsoft Shared\Web Server Extensions\15\CONFIG\SearchConnectors\Documentum.

  2. Using the same information that you provided when you configured the Indexing Connector for Documentum, edit the configuration file as follows.

    1. In the Emc.Documentum section, in the ModuleInfo element, do the following:

      • In the host attribute, type the host name of the Documentum server.

      • In the port attribute, type the port number of the Documentum server.

    2. In the Data Source: Documentum Settings section, in the Repositories element, do the following:

      • In the repository id attribute, type the Documentum repository id.

      • In the name attribute, type the name of the Documentum repository.

      • In the login attribute, type the Documentum login name. Use the same login name as the Documentum content access account. This should be a user who has elevated user permissions on the Documentum Content Server. For more information, see Decide which Documentum content access account to use for crawling.

      • In the dfs attribute, type the location of the Documentum Foundation Services (DFS) by providing the URI for the DFS.

    3. (Optional) If your Documentum connection requires SSL/HTTPS, you have to change the security mode.

      • In the Data Source: Documentum Settings section, subsection Documentum, in the basicHttpBinding element, set the security mode attribute from None to Transport for the following bindings:

        • DfsAgentService

        • DfsContextRegistryService

        • DfsDefaultService

      • In the Data Source: Documentum Settings section, subsection Documentum, in the netNamedPipeBinding element, set the security mode attribute from None to Transport for the following bindings:

        • localNamedPipeBinding

  3. Save and close the file.

  4. Copy the DFS Productivity Layer .NET assemblies to the server running the Security Trimming Sync Service.

    1. Locate the following DFS Productivity Layer .NET assemblies and verify that the version number is 6.7.2000.36 for all files. When extracted to the default path, these files are located in the %local%\emc-dfs-sdk-6.7\emc-dfs-sdk-6.7\lib\dotnet directory.

      • Emc.Documentum.FS.DataModel.Core.dll

      • Emc.Documentum.FS.DataModel.Shared.dll

      • Emc.Documentum.FS.runtime.dll

      • Emc.Documentum.FS.Services.Core.dll

    2. On the server that hosts the Security Trimming Sync Service, log on with an account that is a member of the Administrators group on that server and deploy the DFS Productivity Layer .NET assemblies to the global assembly cache %windir%\assembly.

      Note:

      You can drag and drop the four DLLs into the global assembly cache (%windir%\assembly) to deploy them, but you might have to turn off User Account Control to do this.

  5. Configure authentication for the Security Trimming Sync Service and install the service.

    1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

    2. Open a Command Prompt window on each server that hosts a query processing component.

    3. Type the following command: Microsoft.Office.Server.Search.Connector.Documentum.TrimmerSync.exe -p

      When prompted, enter the password for the account that you provided in the login attribute. Use the same login name as the Documentum content access account. The password will now automatically be encrypted and added to the Security Trimming Sync Service config file.

    4. Install the Security Trimming Sync Service. Type the following command: Microsoft.Office.Server.Search.Connector.Documentum.TrimmerSync.exe -i

  6. Start the Security Trimming Sync Service.

    1. Open Windows Server Manager.

    2. Expand the Configuration menu and click Services.

    3. Right-click the SharePoint Documentum Security Sync service and then click Properties. In the LogOn tab, select This account and provide the account details and credentials for the account that runs the SharePoint services. Click OK.

    4. Right-click the SharePoint Documentum Security Sync service and then click Start.

    5. Verify that the Status column changes to Started.

  7. Verify that the service is running and that the security sync is completed.

    1. Run the command Microsoft.Office.Server.Search.Connector.Documentum.TrimmerSync.exe -d to write the Security Trimming Sync Service memory to a text file.

    2. Verify that the Security Trimming Sync Service connects to the Documentum server. Read the file DCTMSecuritySync.log that is located in the directory <Microsoft Office Server path>\15.0\Data\Office Server\Applications\Search\Nodes.

    3. Verify that the membership information from the Documentum server is written to the file DCTMSecuritySync_Dump.txt that is located in the directory <Microsoft Office Server path>\15.0\Data\Office Server\Applications\Search\Nodes.

Before you can add the pre- and post- security trimmers, you must add one simple crawl rule for Documentum. Later, you can further specify or expand the crawl rules.

Create a simple crawl rule for Documentum

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. On the SharePoint Central Administration home page, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, click the Search service application for which you want to create a crawl rule.

  4. On the Search Administration page, in the Crawling section, click Crawl Rules.

  5. On the Manage Crawl Rules page, click New Crawl Rule.

  6. On the Add Crawl Rule page, specify the following information to create a crawl rule:

    1. In Path box, type dctm://*.

    2. In Crawl Configuration section, select Include all items in this path, and then select Crawl complex URLs (URLs that contain a question mark - ?).

    3. In the Specify Authentication section, select Specify a different content access account, and then type the Documentum content access account and password in the appropriate boxes.

    4. Make sure that the Do not allow Basic Authentication check box is cleared.

  7. Click OK to add the crawl rule.

To add the Indexing Connector for Documentum pre- and post-security trimmers

  1. Start a SharePoint 2013 Management Shell on each server that hosts a query processing component.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    New-SPEnterpriseSearchSecurityTrimmer -SearchApplication <name of your Search service application> -typeName "Microsoft.Office.Server.Search.Connector.Documentum.Trimmers.DctmTrimPre, Microsoft.Office.Server.Search.Connector.Documentum.Trimmers, Version=15.0.0.0,Culture=neutral, PublicKeyToken=48e046c834625a88, processorArchitecture=MSIL" -id 26 -RulePath dctm:\\*

New-SPEnterpriseSearchSecurityTrimmer -SearchApplication <name of your Search service application> -typeName "Microsoft.Office.Server.Search.Connector.Documentum.Trimmers.DctmTrimPost, Microsoft.Office.Server.Search.Connector.Documentum.Trimmers, Version=15.0.0.0,Culture=neutral, PublicKeyToken=48e046c834625a88, processorArchitecture=MSIL" -id 17 -RulePath dctm:\\*

    Where:

    • <name of your Search service application> is the name of the Search service application.

  3. Restart the SharePoint Search Host Controller.

    1. Open a Command Prompt window.

    2. To stop the SharePoint Search Host Controller, type this command: net stop spsearchhostcontroller

    3. To start the SharePoint Search Host Controller, type this command: net start spsearchhostcontroller

  4. Continue with Create a Documentum content source.

Configure the Indexing Connector for Documentum using a user mapping table

The following procedures explain how to manually create a user mapping table that specifies how the Documentum users are mapped to Active Directory Domain Services (AD DS) or Active Directory service users, and how to configure the connector to support crawling Documentum content and use the user mapping table.

  • The user mapping table must be in a SQL Server 2008 or a later version database.

  • The OSearch15 service account must have at least read permission on the user mapping table data.

To create a user mapping table

  1. Create a user mapping table in SQL Server 2008 or a later version. The user mapping table must have the following format:

    Column name SQL datatype Description

    DCTMCredentialDomain

    nvarchar(255) NOT NULL

    Domain name of a Documentum account. Populate this column when the account comes from the local computer or an LDAP system. The User Source property of the Documentum account should equal None or LDAP. Otherwise, leave the column empty.

    DCTMCredentialRepository

    nvarchar (32) NOT NULL

    Repository name of a Documentum account. Populate this column when the account comes from a Documentum repository.

    DCTMCredentialLoginName

    nvarchar (80) NOT NULL

    Login name of the Documentum account.

    NTCredential

    nvarchar (255) NOT NULL

    Windows domain user account that searches Documentum contents in SharePoint 2013.

    Use the following script to create a user mapping table:

    Copy code
    CREATE TABLE <replace with your user mapping table name>
(
DCTMCredentialDomain nvarchar (255) NOT NULL ,
DCTMCredentialRepository nvarchar (32) NOT NULL ,
DCTMCredentialLoginName nvarchar (80) NOT NULL ,
NTCredential nvarchar (255) NOT NULL ,
CONSTRAINT PK_CredentialMapping PRIMARY KEY CLUSTERED
( DCTMCredentialDomain, DCTMCredentialRepository, DCTMCredentialLogonName )
)

    Alternatively, you can manually create the user mapping table using SQL Server Management Studio or an equivalent tool. If you create the table manually, make sure that you use the same schema as defined in the script.

  2. Populate the user mapping table with Documentum/Windows NT credential pairs. The table in the previous step shows what kind of input is expected.

    Example:

    A Documentum repository user Dan Park has a logon that is linked to the Finance repository. Dan's Windows domain user account is Contoso\dpark. In this case, the user mapping table entry for Dan should be:

    DCTMCredentialDomain

    ''

    DCTMCredentialRepository

    Finance

    DCTMCredentialLogonName

    dpark

    NTCredential

    Contoso\dpark

    Note:

    If any cells have no value assigned, they cannot be null or empty. You must assign the following empty string value: ''.

    For each Documentum group there must be a Windows NT group in the user mapping table and they must both contain the same user information.

  3. Grant the OSearch15 account read access to the user mapping table.

To configure the connector using a user mapping table

  1. Start a SharePoint 2013 Management Shell on each server that hosts a crawl component.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    Set-SPEnterpriseSearchDCTMConnectorConfig -Shared -ACLTranslation UserMappingTable -DisplayURLPatternForContainer "http://<MyWebTopServer:PortOfMyWebTopServer>/webtop/component/drl?objectId={ObjectId}&RepositoryName={RepositoryName}" -DisplayURLPatternForDocument "http://<MyWebTopServer:PortOfMyWebTopServer>/webtop/component/drl?objectId={ObjectId}&format={Format}&RepositoryName={RepositoryName}" -UnmappedAccount "DiscardACE" -UserMappingTableSQLServer "<YourDatabaseServerName>" -UserMappingTableSQLInstance "<YourDatabaseInstanceName>" -UserMappingTableDBName "<YourMappingDatabaseName>" -UserMappingTableName "<YourMappingTableName>"

Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "<MyRepository1>" -DFSWebServiceURL @("http://<DFSWebServices>:<30000>/services", "http://<DFSWebServices2>:<30000>/services")

Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "<MyRepository2>" -DFSWebServiceURL @("http://<DFSWebServices>:<30000>/services")

    Where:

    • <MyWebTopServer:PortOfMyWebTopServer> is the name and the port number of the DFS Web Top Server you are using.

    • <YourDatabaseServerName> is the name of the database server on which you created the user mapping table.

    • <YourDatabaseInstanceName> is the name of the database instance of the database server on which you created the user mapping table.

    • <YourMappingDatabaseName> is the name of the database in which you created the user mapping table.

    • <YourMappingTableName> is the name of the user mapping table that you created.

    • <MyRepository n> is the name of Documentum repository that you want to crawl.

    • <DFSWebServices n>:<30000> is the name and port number of the Documentum Web Services server that hosts the Documentum repository that you want to crawl.

  3. Restart the OSearch15 service. The server administrator of the server that hosts the crawl component must restart the OSearch15 service before a content source can be created for Documentum.

    Important:

    Do not use the Services on Server page on the SharePoint Central Administration website to restart this service. Doing so resets the search index, which requires you to do a full crawl of all content to rebuild the index.

    1. Verify that the user account that is performing this procedure is an administrator for the server that hosts the crawl component.

    2. Open a Command Prompt window.

    3. To stop the OSearch15 service, type this command: net stop osearch15

    4. To start the OSearch15 service, type this command: net start osearch15

Continue with Create a crawl rule for Documentum and then continue with Create a Documentum content source.

Create a crawl rule for Documentum

Before a crawl, you must create at least one crawl rule to authenticate the crawler with the DFS Server. You can create more than one crawl rule to include or exclude specific content in Documentum.

To create a crawl rule for the Indexing Connector for Documentum

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. On the SharePoint Central Administration home page, in the Application Management section, click Manage Service Applications.

  3. On the Manage Service Applications page, click the Search service application for which you want to create a crawl rule.

  4. On the Search Administration page, in the Crawling section, click Crawl Rules.

  5. On the Manage Crawl Rules page, click New Crawl Rule.

  6. On the Add Crawl Rule page, specify the following information:

    1. In the Path box, type the path to which the crawl rule will apply. You can use standard wildcard characters. To use regular expressions instead of wildcard characters, select Use regular expression syntax for matching this rule. For examples, see Syntax to refer to a Documentum object.

    2. In Crawl Configuration section, select Include all items in this path, and then select Crawl complex URLs (URLs that contain a question mark - ?).

    3. In the Specify Authentication section, select Specify a different content access account, and then type the Documentum content access account and password in the boxes. See Decide which Documentum content access account to use for crawling earlier in this article.

    4. Make sure that the Do not allow Basic Authentication check box is cleared.

  7. Click OK to add the crawl rule.

    Note:

    • You can create multiple crawl rules for Documentum to include or exclude Documentum content.

    • You can use different crawl rules to specify different content access accounts for different Documentum content. For example, you have two repositories and two content access accounts for each repository. The Documentum content access account specified in a crawl rule will only be applied to Documentum content covered by the path in that crawl rule. If you use the Security Trimming Sync Service, you must set up this service for each Documentum server.

Create a Documentum content source

You create a content source for Documentum content to specify which Documentum content repositories you want to crawl.

To create a content source for the Indexing Connector for Documentum

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. On the SharePoint Central Administration home page, in the Application Management section, click Manage Service Applications.

  3. Click the Search service application in which you want to create a content source.

  4. On the Search Administration Page, in the Crawling section, click Content Sources.

  5. On the Manage Content Sources page, click New Content Source.

  6. On the Add Content Source page, do the following:

    1. In the Name box, type the name for the new content source.

    2. In the Content Source Type section, select Custom Repository.

    3. In the Type of Repository section, select SharePoint 2013 Indexing Connector for Documentum. Use the name that you specified when you registered the Indexing Connector for Documentum with the Search service application.

    4. In the Start Addresses section, type the start addresses. The start address format is the same as the path pattern. You can type more than one start address for the content source, one per line. For examples, see Syntax to refer to a Documentum object.

    5. In the Crawl Schedules section, select schedules from the Full Crawl and Incremental Crawl drop-down lists, or create schedules for each kind of crawl.

    6. In the Content Source Priority section, assign a priority level to the content source according to your business requirements.

    7. Click OK.

  7. On the Manage Content Sources page, right-click the content source for Documentum and click Start Full Crawl.

The Documentum content source is configured and the system can crawl Documentum content repositories that are specified in the content source.

SharePoint 2013 supports scalable architecture for performance scale-out. You can deploy more than one server that hosts a crawl component and you can configure multiple crawlers to crawl the EMC Documentum database at the same time.

Syntax to refer to a Documentum object

The format to refer to a Documentum object that you use for the path (when you set up a crawl rule) and the start address (when you set up a content source) is defined in the following table:

Type of Documentum object | Syntax for the path or the start address
Repository | dctm://<clientapphostname>/<repository name>
Cabinet | dctm://<clientapphostname>/<repository name>/<cabinet name>
Folder | dctm://<clientapphostname>/<repository name>/<cabinet name>/<folder name>
Document | dctm://<clientapphostname>/<repository name>/<cabinet name>/<folder name>/…/<folder name>?DocSysID=<r_object_id> (where r_object_id is the object id of that document)

<clientapphostname> is the host name of your Documentum client application such as Webtop or DA. The <clientapphostname> configured here must be the same as the one that used in the content source. <repository name>, <cabinet name>, and <folder name> are case-sensitive.

Reference - supported and unsupported Documentum object types and properties

The following lists describe supported and unsupported object types and properties for the Indexing Connector for Documentum.

Supported container objects and properties:

  • dm_cabinet and subtypes

  • dm_Folder and subtypes

  • r_object_type

  • object_name

  • title

  • subject

  • keywords

  • owner_name

  • r_creator_name

  • r_creation_date

  • r_modifier

  • r_modify_date

  • cabinetpath

  • folderpath

Supported document objects and properties:

  • dm_document

  • authors

  • keywords

  • r_full_content_size

  • r_creation_date

  • object_name

  • r_modify_date

  • r_modifier

  • subject

  • title

  • r_object_type

  • a_content_type

  • owner_name

  • r_version_label

  • r_lock_date

  • r_lock_owner

  • r_policy_id

  • r_current_state

  • log_entry

  • r_creator_name

  • r_access_date

  • a_storage_type

  • i_retain_until

  • ContainerPath

  • All custom properties

Unsupported object types:

  • Temp cabinets

  • Temp folders

  • Temp files

Reference - SPEnterpriseSearchDCTMConnectorConfig cmdlet

Use the following Windows PowerShell commands to display help and examples for the Indexing Connector for Documentum cmdlet:

  • Get-help Set-SPEnterpriseSearchDCTMConnectorConfig -full shows full help.

  • Get-help Set-SPEnterpriseSearchDCTMConnectorConfig -examples shows only examples.

The Set-SPEnterpriseSearchDCTMConnectorConfig cmdlet accepts three parameter sets. You use the Shared parameter set to change the configuration settings that affect all the Documentum repositories that you crawl. You use the Repository parameter set to change the configuration settings that affect only a specific repository. You use the Remove parameter set to remove a specific repository from the connector configuration.

The following table shows which parameters are mandatory and which are optional. For parameter descriptions and examples, see Set-SPEnterpriseSearchDCTMConnectorConfig.

Action | Mandatory parameters | Optional parameters
Configure shared repository settings | Shared | DFSURL, UserMappingTableSQLServer, UserMappingTableSQLInstance, UserMappingTableDBName, UserMappingTableName, ACLTranslation, UnmappedAccount, DisplayURLPatternForDocument, DisplayURLPatternForContainer.
Configure settings for a specific repository | Repository, RepositoryName | DFSWebServiceURL, IndexAllVersions, ACLTranslation, UnmappedAccount, DisplayURLPatternForDocument, DisplayURLPatternForContainer.
Remove a repository from configuration | Remove, RepositoryName |

See also

Set-SPEnterpriseSearchDCTMConnectorConfig

Change History

Date | Description
May 14, 2013 | Updated the supported DFS Productivity Layer version and improved the instructions to set up the Security Trimming Sync Service.
March 12, 2013 | Initial publication


Change the default account for crawling in SharePoint 2013
See also

Updated: July 23, 2013

Summary: Change the user name or password of the account that the SharePoint 2013 Search service uses by default for crawling.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The account that the SharePoint 2013 Search service uses by default for crawling is called the default content access account. It must be a domain account with a password that is current in Active Directory Domain Services (AD DS). If the password of this domain account expires, the Search service is not able to use the account to crawl content.

The password of the default content access account has two additional dependencies on the domain account password in AD DS:

  • If you change the password of the account in AD DS, you must make the same change for the password of the default content access account in SharePoint 2013.

  • If you want to change the password of the default content access account in SharePoint 2013, you must first change the password in AD DS. This is because the credentials that you enter for the default content access account in SharePoint 2013 are checked against those in AD DS. If you enter a new password for the default content access account before the account password is changed in AD DS, an error will result and the password of the default content access account will not be changed.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

The following procedure changes the user name and password for the default content access account. You can specify a different account for crawling particular URLs by using a crawl rule. If you specify a different account in a crawl rule and you want to change the password of that account, you must change the crawl rule. For more information, see Manage crawl rules in SharePoint Server 2013.

To change the default content access account

  1. Verify that the account that performs this procedure is a service application administrator for the Search service application that you want to configure.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application for which you want to change the default content access account.

  4. On the Search Administration page for the Search service application, in the System Status section, find the Default content access account, which is of the form Domain\UserName.

    Screen shot of the default content access account in the System Status section on the Search Administration page

  5. Click the default content access account name. The Default Content Access Account dialog box appears.

  6. (Optional) In the Account text box, type a new user name.

  7. In the Password text box and in the Confirm Password text box, type the new password, and then click OK.

See also

Create and configure a Search service application in SharePoint Server 2013
Manage crawl rules in SharePoint Server 2013

Change History

Date | Description
July 23, 2013 | Added instructions about how to change the user name of the default content access account.
May 21, 2013 | Initial publication


Configure time-out values for crawler connections in SharePoint 2013
See also

Published: June 18, 2013

Summary: Change how long the SharePoint 2013 search crawler will wait for a connection to a content repository or for a response to a connection attempt.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

By default, when the crawler attempts to connect to a content repository, it waits 60 seconds for a connection or for a response to a connection attempt. Use the procedure in this article to change these crawler time-out values.

If the crawler does not connect or get a response within the time specified, it tries to connect again. If the crawler does not connect on the second attempt within the time specified, it does not crawl the repository during that crawl.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013

  • Keyboard shortcuts

  • Touch

To configure time-out settings for crawler connections

  1. Verify that the user account that is performing this procedure is a farm administrator.

  2. In Central Administration, in the Quick Launch, click General Application Settings.

  3. On the General Application Settings page, in the Search section, click Farm Search Administration.

  4. On the Farm Search Administration page, in the Farm-Level Search Settings section, click either of the Time-out (seconds) setting values.

    Screenshot of crawler time-out settings on Farm Search Administration page

  5. In the Search Time-out Setting dialog box, do the following:

    1. In the Connection time (in seconds) text box, type the number of seconds that you want the crawler to wait when it attempts to connect to a content repository. The default value is 60 seconds.

    2. In the Request acknowledgement time (in seconds) text box, type the number of seconds that you want the crawler to wait for a content repository to respond to a connection attempt. The default value is 60 seconds.

    3. Click OK.

See also

Manage crawling in SharePoint 2013


Configure the crawler in case of SSL certificate warnings in SharePoint 2013
See also

Published: July 23, 2013

Summary: Specify whether a SharePoint 2013 crawler will crawl a site if there is a problem with the site's Secure Sockets Layer (SSL) certificate.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

When a crawler requests a connection to crawl a site, the system generates a warning if there is a problem with the site's SSL certificate. By default, the crawler does not crawl the site when this happens. For security reasons, we strongly recommend that you do not change this default crawler behavior unless you have sufficient reason to do so.

An SSL certificate problem can occur for reasons such as the following:

  • The certificate is expired.

  • The certificate is not signed by a trusted authority.

  • The name in the certificate does not match the site name.

    A name mismatch could be the result of an attempt to spoof the validity of a site and trick users into opening documents from the site or into providing passwords and other information that could allow a hacker to access the system.

However, if you are only crawling internal sites, you might expect SSL warnings in certain cases. For example, you might know that some site names and certificate names are mismatched for legitimate reasons, such as if the organization changed a server name or site name, or if the organization is using a single certificate for multiple sites. In such cases, it might be safe to change the default crawler behavior and thus ignore SSL certificate warnings.

Use the following procedure to specify whether the crawler will crawl sites in the event of SSL certificate warnings. The setting applies to all content sources in all Search service applications in a farm. After you change this setting, you must re-crawl all affected sites so that the appropriate content is in the search index.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

To configure the crawler for SSL certificate warnings

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators Group.

  2. In Central Administration, in the Quick Launch, click General Application Settings.

  3. On the General Application Settings page, in the Search section, click Farm Search Administration.

  4. On the Farm Search Administration page, in the Farm-Level Search Settings section, click the value of the Ignore SSL Warnings setting (Yes or No). The default setting is No.

    Screen shot of Farm Search Administration page

  5. In the Search SSL Settings dialog box, do one of the following:

    • If you do not want the crawler to crawl a site when there is an SSL certificate warning, make sure that the Ignore SSL certificate name warnings check box is cleared. For security reasons, the check box is cleared by default.

    • If you want the crawler to crawl a site even if there is an SSL certificate warning, make sure that the Ignore SSL certificate name warnings check box is selected.

  6. Click OK.

See also

Manage crawling in SharePoint 2013


Manage the search topology in SharePoint Server 2013

Summary: Learn how to manage search components to scale out the search topology in SharePoint 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet provide information about how you manage search components in SharePoint 2013.

Before you change the search topology, you must define, install and configure the required application servers and database servers that you want to use for search. For more information, see Plan enterprise search architecture in SharePoint Server 2013. For more information about hardware requirements, see Scale search for performance and availability in SharePoint Server 2013. For example farm architectures and search topologies, see the technical diagrams Enterprise search architectures for SharePoint Server 2013, Internet sites search architectures for SharePoint Server 2013 and Search architectures for SharePoint Server 2013. You can also find these diagrams in the Search section in Technical diagrams for SharePoint 2013.

TechNet articles about managing the search topology

The following articles about managing the search topology in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Building blocks | Change the default search topology in SharePoint Server 2013 | Learn how to change from the default search topology with an empty search index to a new search topology using Windows PowerShell.
 | Manage search components in SharePoint Server 2013 | Learn how to use Windows PowerShell to manage search components in an existing search topology that has content in the search index. Use these procedures to scale out or scale down the search topology of the Search service application.
 | Manage the index component in SharePoint Server 2013 | Learn how and when to use Windows PowerShell to scale out the search index by adding an index component to create an additional index replica or index partition.


Manage search components in SharePoint Server 2013

Published: November 13, 2012

Summary: Learn how to use Windows PowerShell to manage search components in an existing search topology that has content in the search index. Use these procedures to scale out or scale down the search topology of the Search service application.

Applies to: SharePoint Server 2013

The procedures and the examples in this article assume that SharePoint Server 2013 and the Search service application are installed, and that there is an existing search topology and items in the search index. If SharePoint Server 2013 and the Search service application are newly installed and there are no items in the search index, follow the procedures in Change the default search topology in SharePoint Server 2013.

The procedures in this article apply to the following search components:

  • Analytics processing component

  • Content processing component

  • Crawl component

  • Search administration component

  • Query processing component

For information about procedures to manage the index component, see Manage the index component in SharePoint Server 2013.

In this article:

  • Before you begin

  • Start a search service instance on a server

  • Retrieve the active search topology

  • Clone the active search topology

  • Add a search component

  • Remove a search component

  • Move a search component

  • Activate a search topology

Before you begin

Before you begin, review the following prerequisites.

  • SharePoint Server 2013 is installed and a Search service application with a search topology is created. The Search service application is in a healthy state and is not paused for any reason.

  • The user account that is performing the procedures in this article is a member of the Farm Administrators group.

  • You have planned a target search topology. We recommend that you plan a target search topology based on the expected number of items in the search index for search in small, medium or large enterprises. See Enterprise search architectures for SharePoint Server 2013 for recommended search topologies. If you are planning a search topology for internet sites, see Internet sites search architectures for SharePoint Server 2013.

  • SharePoint Server 2013 is installed on all the servers that you want to host search components on. You can create new application servers or define application servers in an existing deployment. The servers are added to the farm and you are an administrator on all these servers.

Important:

The procedures in this article use Windows PowerShell. You can run the Windows PowerShell commands on any server in the farm. However, if you are performing multiple search topology procedures you should use the same SharePoint 2013 Management Shell for all Windows PowerShell commands so that you can share Windows PowerShell object references between commands.

Start a search service instance on a server

Before you add search components to a new server, you must first start a search service instance on the server. The search service instance starts all the necessary Windows services that are used by the search service (OSearch15 and SPSearchHostController).

To start a search service instance

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell on one of the servers in the farm.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $<host n> = Get-SPEnterpriseSearchServiceInstance -Identity "<Server name>"
Start-SPEnterpriseSearchServiceInstance -Identity $<host n>

    Where:

    • $<host n> specifies the PowerShell object reference for the search service instance.

    • <Server name> specifies the server on which you want to add an index component. The input must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a server (for example, myserver1); or an instance of a valid SearchServiceInstance object.

    For example:

    Copy code
    $hostA = Get-SPEnterpriseSearchServiceInstance -Identity "myserver1"
$hostB = Get-SPEnterpriseSearchServiceInstance -Identity "myserver2"
Start-SPEnterpriseSearchServiceInstance -Identity $hostA
Start-SPEnterpriseSearchServiceInstance -Identity $hostB

    You use the references ($<host n>) to specify the target server when you add search components.

  4. Wait until all the search service instances are running. For each of the search service instances, at the Windows PowerShell command prompt, type the following command until the command returns the status Online:

    Copy code
    Get-SPEnterpriseSearchServiceInstance -Identity $<host n>

    For example:

    Copy code
    Get-SPEnterpriseSearchServiceInstance -Identity $hostA
TypeName    : SharePoint Server Search
Description : Index content and serve search queries
Id          : 82ce8815-ecbd-4cf3-a98e-33f20bd86039
Server      : SPServer Name=myserver1.example.com
Service     : SearchService Name=OSearch15
Role        : None
Status      : Online

Retrieve the active search topology

To view the active search topology of the Search service application, you have to use Windows PowerShell.

To view the active search topology

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell. If you already have an open SharePoint 2013 Management Shell in which you have created reusable Windows PowerShell object references, use the open shell instead.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
$active = Get-SPEnterpriseSearchTopology -Active -SearchApplication $ssa
$active

The command returns information about the active topology, for example:

Copy code
TopologyId     : 2d7bb046-1ad4-43a9-9984-754c4551a3ec
CreationDate   : 1/25/2012 3:06:00 AM
State          : Active
ComponentCount : 6

Retrieve a list of search components

To view a list of search components in the active search topology with their properties, you have to use Windows PowerShell. One of the search component properties is the search component Id. You will only need the search component Id to remove a search component.

To view a list of all search components

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell. If you already have an open SharePoint 2013 Management Shell in which you have created reusable Windows PowerShell object references, use the open shell instead.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
$active = Get-SPEnterpriseSearchTopology -SearchApplication $ssa -Active
Get-SPEnterpriseSearchComponent -SearchTopology $active

    The command returns a list of search components in the active search topology and their properties.

Clone the active search topology

To make any changes to the search topology in a search installation that has items in the search index, you first have to create a new topology object. You modify this new topology object, a clone of the active topology, by adding or removing search components. After you have made the changes to the clone topology object, you make the clone the active topology.

To clone the active topology

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell. If you already have an open SharePoint 2013 Management Shell in which you have created reusable Windows PowerShell object references, use the open shell instead.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
$active = Get-SPEnterpriseSearchTopology -SearchApplication $ssa -Active
$clone = New-SPEnterpriseSearchTopology -SearchApplication $ssa -Clone -SearchTopology $active

    The command creates a clone search topology that can be referenced with $clone if you continue to use the same SharePoint 2013 Management Shell to add or remove search components and to activate the search topology.

  4. (Optional) If you have to remove search components from the search topology, you have to retrieve the search component Id. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    Get-SPEnterpriseSearchComponent -SearchTopology $clone

    The command returns a list of search components in the cloned search topology and their properties, including the search component Id.

Add a search component

You cannot change the active search topology directly. This procedure assumes that you have created a clone topology object as described in Clone the active search topology. You can use the following Windows PowerShell cmdlets for each search component:

  • New-SPEnterpriseSearchAdminComponent

  • New-SPEnterpriseSearchAnalyticsProcessingComponent

  • New-SPEnterpriseSearchContentProcessingComponent

  • New-SPEnterpriseSearchCrawlComponent

  • New-SPEnterpriseSearchQueryProcessingComponent

Note:

The procedure to add an index component is different. For more information, see Manage the index component in SharePoint Server 2013.

To add a search component

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell. If you already have an open SharePoint 2013 Management Shell in which you have created reusable Windows PowerShell object references, use the open shell instead.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    New-SPEnterpriseSearch<SearchComponent> -SearchTopology $clone -SearchServiceInstance $<host n>

    Where:

    • <SearchComponent> is the name of the search component type that you are adding.

    • $clone is the cloned topology that you are changing. See Clone the active search topology.

    • $<host n> is the PowerShell object reference to the running search service instance on the server that you want to add the search component to. See Start a search service instance on a server.

    For example, the following command adds a content processing component to the clone topology on the server identified by the search service instance reference $hostA.

    Copy code
    New-SPEnterpriseSearchContentProcessingComponent -SearchTopology $clone -SearchServiceInstance $hostA

  4. Verify that the new search component was added to the clone topology. At the Windows PowerShell command prompt, type the command:

    Copy code
    Get-SPEnterpriseSearchComponent -SearchTopology $clone

Remove a search component

To remove a search component, you have to use Windows PowerShell. You cannot change the active search topology directly. This procedure assumes that you have created a clone topology object as described in Clone the active search topology.

Note:

The procedure to remove an index component is different. For more information, see Manage the index component in SharePoint Server 2013.

To remove a search component

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell. If you already have an open SharePoint 2013 Management Shell in which you have created reusable Windows PowerShell object references, use the open shell instead.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. Make sure that the current active topology is healthy and that the search component that you are about to remove is Active. View the status of the search topology in the Search Administration page in Central Administration or run the Windows PowerShell cmdlet Get-SPEnterpriseSearchStatus.

  4. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    Remove-SPEnterpriseSearchComponent -Identity <Search component id> -SearchTopology $clone

    Where:

    • <Search component id> is the Id of the search component that you want to remove. Use the search component Id from the clone topology. To retrieve the search component Id, see step 4 in Clone the active search topology.

    • $clone is the cloned topology that you are changing. See Clone the active search topology.

  5. When prompted, confirm that you want to remove the search component.

Move a search component

If you want to move a search component from one server to another, we recommend that you add a new search component to the search topology before you remove the old search component.

To move a search component

  1. Clone the active search topology. See Clone the active search topology.

  2. Add a new search component to the server that you eventually want the search component to be hosted on. See Add a search component.

  3. Activate the search topology. This topology will have one superfluous search component. See Activate a search topology.

  4. Make sure that the current active topology is healthy. View the status of the search topology in the Search Administration page in Central Administration or run the Windows PowerShell cmdlet Get-SPEnterpriseSearchStatus.

  5. Clone the search topology again. See Clone the active search topology.

  6. Remove the superfluous search component. See Remove a search component.

  7. Activate the search topology again. See Activate a search topology.

Activate a search topology

To activate a search topology, you have to use Windows PowerShell.

To activate a search topology

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell. If you already have an open SharePoint 2013 Management Shell in which you have created reusable Windows PowerShell object references, use the open shell instead.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    Set-SPEnterpriseSearchTopology -Identity $clone

    Where:

    • $clone is the cloned topology that you are changing. See Clone the active search topology.

  4. Verify that your new topology is active. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    Get-SPEnterpriseSearchTopology -Active -SearchApplication $ssa

    The command returns an overview of active and inactive topologies, for example:

    Copy code
    TopologyId     : fce8507d-61c6-4498-8038-4fd2d0a62c6e
CreationDate   : 1/30/2012 2:52:00 AM
State          : Inactive
ComponentCount : 6

TopologyId     : b63d48b2-df5c-41be-a7f4-9abaee483611
CreationDate   : 1/30/2012 4:30:00 AM
State          : Active
ComponentCount : 7

    You will see that the component count of the active topology reflects the changes that you have made.


Manage the index component in SharePoint Server 2013

Published: November 13, 2012

Summary: Learn how and when to use Windows PowerShell to scale out the search index by adding an index component to create an additional index replica or index partition.

Applies to: SharePoint Server 2013

The procedures and the examples in this article assume that SharePoint Server 2013 and the Search service application are installed, that there is an existing search topology and that there are items in the search index. If SharePoint Server 2013 and the Search service application are newly installed and there is no content in the search index, follow the procedures outlined in Change the default search topology in SharePoint Server 2013 to scale out the search topology.

The procedures in this article apply to the index component. For information about how to manage the analytics processing component, the content processing component, the crawl component, the search administration component and the query processing component, see Manage search components in SharePoint Server 2013.

You use the index component PowerShell cmdlet (New-SPEnterpriseSearchIndexComponent) to manage both index partitions and index replicas. Each index component in the search topology represents an index replica.

You divide the search index into discrete portions called index partitions. Each index partition is stored as a set of files on a local disk. To scale out the search index, you add a new index partition for each 10 million items.

To achieve fault tolerance for the search index, you add an index replica of an existing index partition to the search topology. Each index replica contains the same information.

In this article:

  • Before you begin

  • Add an index replica to an existing index partition

  • Add a new index partition

  • Cancel the repartitioning process

  • Remove an index component

  • Move an index component

Before you begin

Before you begin, review the following prerequisites.

  • SharePoint Server 2013 is installed and a Search service application with a search topology is created.

  • The user account that is performing the procedures in this article is a member of the Farm Administrators group.

  • You have planned a target search topology and have planned on which servers that you want to host the index partitions and the index replicas. We recommend that you plan the target number of index partitions based on the expected number of items in the search index. See Enterprise search architectures for SharePoint Server 2013 for recommended search topologies. If you are planning a search topology for Internet sites, see Internet sites search architectures for SharePoint Server 2013.

  • SharePoint Server 2013 is installed on all the servers that you want to host index components on. You can create new application servers or define application servers in an existing deployment. The servers are added to the farm and you are an administrator on all these servers.

Add an index replica to an existing index partition

You add an index replica to the search topology to achieve fault tolerance for an existing index partition. You place the index replicas on separate failure domains on separate servers. When you add an index replica, you add a new index component to the search topology and associate it with the index partition that you want to make a replica of.

Important:

This procedure uses Windows PowerShell. You can run the Windows PowerShell commands on any server in the farm. However, you should use the same SharePoint 2013 Management Shell for all Windows PowerShell commands in this procedure so that you can share Windows PowerShell object references between commands.

To add an index replica

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell on one of the servers in the farm.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. Start a search service instance on the server that you want to create the index replica on and create a reference to the search service instance Id. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $<host n> = Get-SPEnterpriseSearchServiceInstance -Identity "<Server name>"
Start-SPEnterpriseSearchServiceInstance -Identity $<host n>

    Where:

    • $<host n> specifies the PowerShell object reference for the search service instance.

    • <Server name> specifies the server on which you want to add an index component. The input must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a server (for example, myserver1); or an instance of a valid SearchServiceInstance object.

    For example:

    Copy code
    $hostA = Get-SPEnterpriseSearchServiceInstance -Identity "myserver1"
Start-SPEnterpriseSearchServiceInstance -Identity $hostA

  4. Wait until the search service instance is running. At the Windows PowerShell command prompt, type the following command until the command returns the status Online:

    Copy code
    Get-SPEnterpriseSearchServiceInstance -Identity $<host n>

  5. Clone the active search topology. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
$active = Get-SPEnterpriseSearchTopology -SearchApplication $ssa -Active
$clone = New-SPEnterpriseSearchTopology -SearchApplication $ssa -Clone -SearchTopology $active

  6. Add a new index component and associate it with a partition. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    New-SPEnterpriseSearchIndexComponent -SearchTopology $clone -SearchServiceInstance <host n> -IndexPartition <Index partition number>

    Where:

    • $clone is the cloned topology that you are changing.

    • $<host n> is the PowerShell object reference to the running search service instance on the server that you want to add the index replica to.

    • <Index partition number> is the number of the existing index partition that you are creating a replica of. For example, to create an index replica of index partition 0, choose "0" as the parameter value.

    For example:

    Copy code
    New-SPEnterpriseSearchIndexComponent -SearchTopology $clone -SearchServiceInstance $hostA -IndexPartition 0

  7. Activate the clone topology. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    Set-SPEnterpriseSearchTopology -Identity $clone

  8. Verify that your new topology is active and that the index component representing the new index replica is added. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    Get-SPEnterpriseSearchTopology -Active -SearchApplication $ssa

  9. Monitor the distribution of the existing index to the new replica. The added index replica will have the state Degraded until the distribution is finished. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    Get-SPEnterpriseSearchStatus -SearchApplication $ssa -Text

    Repeat this command until all search components, including the new index component, output the state Active. For a large search index, this could take several hours.

Add a new index partition

For each ten million items in the search index, you have to add a new index partition. When you add a new index partition, the search index has to be repartitioned. Depending on the size of the search index, this repartitioning can take several hours to complete.

To add an index partition and repartition the search index, you add a new index component to the search topology and associate this index component with a new index partition number. Adding an index partition and repartitioning the search index should be initiated as a separate process and should not be initiated while you are making other changes to the search topology.

You must add the same number of index replicas to the new index partition as you have for your existing partitions.

Before you add a new index partition to the search topology and start repartitioning the search index:

  • Back up the Search service application and the existing search index. See Back up Search service applications in SharePoint 2013.

  • Make sure that the current active topology is healthy. View the status of the search topology in the Search Administration page in Central Administration or run the Windows PowerShell cmdlet Get-SPEnterpriseSearchStatus.

  • Make sure that there is sufficient disk space available on the server where you will be adding the index partition. See Scale search for performance and availability in SharePoint Server 2013 for more information about hardware requirements.

Warning:

The Search service application is paused during index repartitioning and cannot crawl or index content. Also, users will not be able to run queries.

To add an index partition

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Start a SharePoint 2013 Management Shell on one of the servers in the farm.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. Start a search service instance on all the servers where you want to add an index replica for the new index partition. You create a PowerShell object reference to the search service instance that is used later in the procedure. For each server, at the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $<host n> = Get-SPEnterpriseSearchServiceInstance -Identity "<Server name>"
Start-SPEnterpriseSearchServiceInstance -Identity $<host n>

    Where:

    • <host n> specifies the PowerShell object reference for the search service instance.

    • <Server name> specifies the server on which you want to add an index component. The input must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a server (for example, myserver1); or an instance of a valid SearchServiceInstance object.

    For example:

    Copy code
    $hostC = Get-SPEnterpriseSearchServiceInstance -Identity "myserver3"
Start-SPEnterpriseSearchServiceInstance -Identity $hostC
$hostD = Get-SPEnterpriseSearchServiceInstance -Identity "myserver4"
Start-SPEnterpriseSearchServiceInstance -Identity $hostD

  4. Wait until the search service instances are running. For each server, at the Windows PowerShell command prompt, type the following command until the command returns the status Online:

    Copy code
    Get-SPEnterpriseSearchServiceInstance -Identity $<host n>

  5. Clone the active search topology. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
$active = Get-SPEnterpriseSearchTopology -SearchApplication $ssa -Active
$clone = New-SPEnterpriseSearchTopology -SearchApplication $ssa -Clone -SearchTopology $active

    The command creates a clone search topology that can be referenced with $clone and returns information about the clone topology. Make a note of the topology Id of the cloned topology, in case you have to cancel the repartitioning process.

  6. Add a new index partition by adding one or more index components and associate them with the new index partition. We recommend that you create the same number of index replicas for the new index partition as you have for the existing partitions. For each new index component, at the Windows PowerShell command prompt, type the following command(s):

    Copy code
    New-SPEnterpriseSearchIndexComponent -SearchTopology $clone -SearchServiceInstance <host n> -IndexPartition <Index partition number>

    Where:

    • $clone is the cloned topology that you are changing.

    • $<host n> specifies the PowerShell object reference for the search service instance.

    • <Index partition number> is the number of the index partition that you are creating. By default, you have one index partition, which is called index partition 0. If you want to create a new index partition, enter the IndexPartition parameter value 1, followed by 2, then 3 and so forth.

    For example, if you have an existing index partition 0 with index replicas on Host A and Host B, and you want to add a new index partition with index replicas on Host C and Host D:

    Copy code
    New-SPEnterpriseSearchIndexComponent -SearchTopology $clone -SearchServiceInstance $hostC -IndexPartition 1
New-SPEnterpriseSearchIndexComponent -SearchTopology $clone -SearchServiceInstance $hostD -IndexPartition 1

  7. Verify that the Search service application is running. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $ssa.IsPaused() -ne 0

    1. If this command returns False, the Search service application is running. Continue with step 8.

    2. If this command returns True, the Search service application is paused. You must resume the Search service application before you continue with step 8.

      Warning:

      Before you resume the Search service application, find out why it is paused. Any operation that requires the Search service application to be paused, for example running a backup or restore procedure, will not complete successfully if you resume the Search service application before that operation is completed.

      To resume the Search service application, at the Windows PowerShell command prompt, type the following command(s):

      Copy code
      $ssa.ForceResume($ssa.IsPaused())

  8. Start the activation of the clone topology. This will start the activation of the topology that includes the new index replicas associated with the new index partition. This will start the index repartitioning process.

    Important:

    The Search service application is paused during index repartitioning and cannot crawl or index content. Also, users will not be able to run queries. You will not be able to access the Windows PowerShell console where the activation command runs.

    Note:

    The Search Administration page in Central Administration does not show that the Search service application has been paused for index repartitioning. However, because all query processing components are suspended when you pause the Search service application for repartitioning, the Search administration page will show errors for the query processing components during this process.

    At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $ssa.PauseForIndexRepartitioning()
Set-SPEnterpriseSearchTopology -Identity $clone

  9. Monitor the progress of the index repartitioning process. You can only monitor the progress of the repartitioning process on the primary index components of the existing topology. The following steps show you how to find the primary index components.

    Note:

    You will not be able to run any commands in the existing SharePoint 2013 Management Shell until the topology activation, including the index repartitioning process, is finished. Run the following commands in a second SharePoint 2013 Management Shell.

    1. Start a second SharePoint 2013 Management Shell.

      • For Windows Server 2008 R2:

        • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

      • For Windows Server 2012:

        1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

          If SharePoint 2013 Management Shell is not on the Start screen:

        2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

      For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

    2. Find the primary index replica for each of the existing index partitions. At the Windows PowerShell command prompt of the second SharePoint 2013 Management Shell, type the following command(s):

      Copy code
      $ssa = Get-SPEnterpriseSearchServiceApplication
Get-SPEnterpriseSearchStatus -SearchApplication $ssa -Text

      The command returns a list of index components and their properties. Make a note of the names of the primary index component(s). These are the index components that have the property Primary: True.

      For example, the output could look like this. In this example, IndexComponent2 is the primary index component:

      Copy code
      Name      : IndexComponent1
State     : Active
Primary   : False
Partition : 0
Host      : MyMachine1

Name      : Cell:IndexComponent1-SPd32cdffb08a2I.0.0
State     : Active
Primary   : False
Partition : 0

Name      : IndexComponent2
State     : Active
Primary   : True
Partition : 0
Host      : MyMachine2

Name      : Cell:IndexComponent2-SPd32cdffb08a2I.1.0
State     : Active
Primary   : True
Partition : 0

  10. For each primary index component, monitor the index repartitioning progress. At the Windows PowerShell command prompt of the second SharePoint 2013 Management Shell, type the following command(s):

    Copy code
    Get-SPEnterpriseSearchStatus -SearchApplication $ssa -Healthreport -Component <Index component name> | ? { ($_.name -match "repart") -or ( $_.name -match "splitting") } | ft -AutoSize Name, Message

    Where:

    • <Index component name> is the name of the primary index component that you want to monitor the progress of, for instance IndexComponent2.

    Monitor the output of the command for each primary index component. The output of the command contains progress information about the repartitioning of the index.

    During the initial phase of the index repartitioning process, the output will look something like this:

    Copy code
    Name                                              Message
----                                              -------
repartition_component_state[SP...]                Pending

    The index partitions are split during the main phase of the index repartitioning process. During this phase, the output will look something like this:

    Copy code
    Name                                              Message
----                                              -------
index splitting: current fusion progress[SP...]   <Percentage value>
index splitting: splitting state [SP...]          Index splitter running fusion, building: <Folder>
repartition_component_state [SP...]               Splitting

    The percentage value in the output indicates the approximate progress of the repartitioning process.

    Repeat this command for all primary index components until the output of the commands no longer returns any values. That means that the index repartitioning process has completed and that the repartitioned index will now be replicated and distributed over the servers. This could take several hours.

  11. Monitor the progress of the distribution of the index to the new index replicas. To do this, verify that your new topology is active, and that all search components are healthy. At the Windows PowerShell command prompt of the second SharePoint 2013 Management Shell, type the following command(s):

    Copy code
    Get-SPEnterpriseSearchStatus -SearchApplication $ssa | ft -AutoSize Name, State, Details

    During the distribution of the index to the new index replicas, the added index replicas will return the state Degraded. The distribution is finished when all index components return the state Active in the output. This could take several hours.

    Note:

    The query processing components are suspended because you have paused the Search service application for index repartitioning. In the output, the query processing components will be listed with the state Unknown.

  12. In the SharePoint 2013 Management Shell that you used to start the topology activation process, verify that the search topology activation command has completed.

  13. (Optional) Restart the SharePoint Search Host Controller service on all the servers that hosted index components (representing a primary index replica or any other index replica) prior to the repartitioning.

    Perform this step to get a correct document count and free up memory after repartitioning the search index. If you decide not to perform this step, it will take a few days and some indexing iterations for the memory usage to be gradually reduced and the document count (as returned by PowerShell cmdlets and in the Search Administration page in Central Administration) to be correct.

    Note:

    To avoid query outages, ensure that at least one index component returns the state Running for each index partition before you restart the SharePoint Search Host Controller service.

    Important:

    Do not use the Services on Server page on the SharePoint Central Administration Web site to restart this service.

    1. To restart the SharePoint Search Host Controller, open a command prompt window on each of the servers that host index components for existing index partitions.

      1. To stop the SharePoint Search Host Controller, type this command: net stop spsearchhostcontroller

      2. To restart the SharePoint Search Host Controller, type this command: net start spsearchhostcontroller

  14. Resume the Search service application. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $ssa.ResumeAfterIndexRepartitioning()

Cancel the repartitioning process

If you, for any reason, have to cancel an ongoing repartitioning process, use the following procedure.

To cancel the repartitioning process

  1. Start a new SharePoint 2013 Management Shell on the server where you ran the topology activation command.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. Retrieve the activating topology Id. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $activating = Get-SPEnterpriseSearchTopology -Identity <Id of the activating topology> -SearchApplication $ssa

    Where:

    • <Id of the activating topology> is the identity (GUID) of the clone topology that you wrote down when you cloned the search topology.

  3. Cancel the topology activation. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $activating.CancelTopologyActivation()

Remove an index component

If you have more than one active index replica for an index partition, you can remove an index replica by performing the procedure Remove a search component in the article Manage search components in SharePoint Server 2013.

You cannot remove the last index replica of an index partition using this procedure. If you have to remove all index replicas from the search topology, you must remove and re-create the Search service application and create a completely new search topology that has the reduced number of index partitions.

Move an index component

If you want to move an index replica from one server to another, we recommend that you add a new index component to the search topology before you remove the old index component.

To move an index component

  1. Add a new index component to the server that you want to move the index replica to. Clone the search topology, add a new index replica, wait for the index to be replicated to the new index replica and activate the search topology. See Add an index replica to an existing index partition.

  2. Wait until the new index replica is ready to serve queries. View the status of the search topology in the Search Administration page in Central Administration or run the Windows PowerShell cmdlet Get-SPEnterpriseSearchStatus. Before you proceed, the index replica that you have added must be Active.

  3. Clone the search topology again.

  4. Remove the superfluous index replica by removing the index component. See the procedure Remove a search component in the article Manage search components in SharePoint Server 2013.

  5. Activate the search topology again.

This will ensure fault tolerance of the search index while you are moving the index replica.


Change the default search topology in SharePoint Server 2013

Published: November 13, 2012

Summary: Learn how to change from the default search topology with an empty search index to a new search topology using Windows PowerShell.

Applies to: SharePoint Server 2013

The procedures and the examples in this article assume that SharePoint Server 2013 and the Search service application are newly installed and that there is no content in the search index. This article explains how to create and activate search components in a new search topology coming from the default search topology.

If there are items in the search index, follow the procedures in Manage search components in SharePoint Server 2013 and Manage the index component in SharePoint Server 2013.

In this article:

  • Before you begin

  • Overview: changing a search topology without content in the search index

  • Example: Change from the default search topology to a small enterprise search topology

Before you begin

Before you begin, review the following prerequisites.

  • SharePoint Server 2013 is installed on a single server and a Search service application with a default search topology is created. In the default search topology, all the search components are located on the server that hosts Central Administration.

  • You are an administrator of the Search service application.

  • You have planned a target search topology. We recommend that you plan a target search topology based on the expected number of items in the search index for search in small, medium or large enterprises. See Enterprise search architectures for SharePoint Server 2013 for recommended search topologies. If you are planning a search topology for internet sites, see Internet sites search architectures for SharePoint Server 2013.

    SharePoint Server 2013 is installed on all the servers that you want to host search components on. You can create new application servers or define application servers in an existing deployment. The servers are added to the farm and you are an administrator on all these servers.

Overview: changing a search topology without content in the search index

The following list provides an overview of the tasks involved to change from the default search topology, without any content in the search index, to a new search topology.

  • Ensure that no crawls have been started and that the search index is empty.

  • Start a search service instance on all the servers that you want to host search components on.

  • Create a new empty search topology.

  • Add search components to the new search topology.

  • Activate the new search topology.

  • Verify that the search topology is active.

Example: Change from the default search topology to a small enterprise search topology

The following procedures will create and activate a small enterprise search topology on multiple servers, as planned for in the table Target search topology. The small enterprise search topology caters for a search index with up to ten million items. The target search topology uses virtual machines on physical application servers. All search components in this example are set up with fault tolerance, which means that all search components and index partitions are deployed across more than one physical machine on separate failure domains.

The procedures in this example explain how to scale out to the recommended search topology for a small enterprise. You can follow the same procedures using different variables if you want to scale out to a larger enterprise search topology or to a search topology for Internet Sites.

Target search topology

Virtual machine A (on physical application server X) myserver1.example.com | Virtual machine B (on physical application server X) myserver2.example.com | Virtual machine C (on physical application server Y) myserver3.example.com | Virtual machine D (on physical application server Y) myserver4.example.com
Admin component 1 Crawl component 1 Content processing component 1 Analytics processing component 1 | Query processing component 1 Index component 1 (that belongs to index partition 0) | Admin component 2 Crawl component 2 Content processing component 2 Analytics processing component 2 | Query processing component 2 Index component 2 (that belongs to index partition 0)

  1. Ensure that no crawls have been started and that the search index is empty on the server that hosts Central Administration.

    1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

    2. In Central Administration, in the Application Management section, click Manage Service Applications.

    3. On the Manage Service Applications page, in the list of service applications, click the Search service application.

    4. Verify that the search index is empty. On the Search Administration page, under System Status, verify that Searchable items displays "0".

      Warning:

      If there are items in the search index, do not continue with this procedure.

    5. Verify that no crawls have been started. On the Search Administration page, under Crawling, click Content Sources. On the Manage Content Sources page, verify that the Status column for any existing content source displays Idle.

  2. Start a SharePoint 2013 Management Shell on one of the servers in the farm.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    • For Windows Server 2012:

      1. On the Start screen, right-click SharePoint 2013 Management Shell and then click Run as administrator.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, then right-click SharePoint 2013 Management Shell and then click Run as administrator.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. Specify the new servers you want to add search components to, start a search service instance (ssi) on these servers and create references to the search service instances. In this procedure we have used the example host names "myserver<n>" for the servers as listed in the Target search topology table. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $hostA = Get-SPEnterpriseSearchServiceInstance -Identity "myserver1"
$hostB = Get-SPEnterpriseSearchServiceInstance -Identity "myserver2"
$hostC = Get-SPEnterpriseSearchServiceInstance -Identity "myserver3"
$hostD = Get-SPEnterpriseSearchServiceInstance -Identity "myserver4"
Start-SPEnterpriseSearchServiceInstance -Identity $hostA
Start-SPEnterpriseSearchServiceInstance -Identity $hostB
Start-SPEnterpriseSearchServiceInstance -Identity $hostC
Start-SPEnterpriseSearchServiceInstance -Identity $hostD

  4. Wait until all the search service instances are running. At the Windows PowerShell command prompt, type the following commands until the commands return the state "Online" for each of the search service instances:

    Copy code
    Get-SPEnterpriseSearchServiceInstance -Identity $hostA
Get-SPEnterpriseSearchServiceInstance -Identity $hostB
Get-SPEnterpriseSearchServiceInstance -Identity $hostC
Get-SPEnterpriseSearchServiceInstance -Identity $hostD

  5. Create a new search topology and a reference to the new search topology. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    $ssa = Get-SPEnterpriseSearchServiceApplication
$newTopology = New-SPEnterpriseSearchTopology -SearchApplication $ssa

  6. Add all the search components to the new search topology. The following Windows PowerShell commands will create the search components of the new topology and assign them to the new servers. In this small enterprise search topology there is one index partition, index partition 0, to cater for a maximum of ten million items. This is indicated with the parameter -IndexPartition in the command New-SPEnterpriseSearchIndexComponent. The index partition has one index replica on virtual machine B and one index replica on virtual machine D. Each index replica will contain the exact same search index and is hosted on a different physical server to achieve fault tolerance. At the Windows PowerShell command prompt, type the following command(s):

    Copy code
    New-SPEnterpriseSearchAdminComponent -SearchTopology $newTopology -SearchServiceInstance $hostA
New-SPEnterpriseSearchCrawlComponent -SearchTopology $newTopology -SearchServiceInstance $hostA
New-SPEnterpriseSearchContentProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostA
New-SPEnterpriseSearchAnalyticsProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostA
New-SPEnterpriseSearchQueryProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostB
New-SPEnterpriseSearchIndexComponent -SearchTopology $newTopology -SearchServiceInstance $hostB -IndexPartition 0
New-SPEnterpriseSearchAdminComponent -SearchTopology $newTopology -SearchServiceInstance $hostC
New-SPEnterpriseSearchCrawlComponent -SearchTopology $newTopology -SearchServiceInstance $hostC
New-SPEnterpriseSearchContentProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostC
New-SPEnterpriseSearchAnalyticsProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostC
New-SPEnterpriseSearchQueryProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostD
New-SPEnterpriseSearchIndexComponent -SearchTopology $newTopology -SearchServiceInstance $hostD -IndexPartition 0

  7. Activate the new search topology. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPEnterpriseSearchTopology -Identity $newTopology

  8. Verify that the new search topology is active. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPEnterpriseSearchTopology -SearchApplication $ssa

    The command returns an overview of active and inactive topologies, in this example:

    Copy code
    TopologyId     : fce8507d-61c6-4498-8038-4fd2d0a62c6e
CreationDate   : 1/30/2012 2:52:00 AM
State          : Inactive
ComponentCount : 6

TopologyId     : b63d48b2-df5c-41be-a7f4-9abaee483611
CreationDate   : 1/30/2012 4:30:00 AM
State          : Active
ComponentCount : 12

    The previous topology, the default topology in this example, is listed as inactive. The new active topology from this example will have a component count of twelve.

  9. Verify that all components of the new search topology are running correctly. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Get-SPEnterpriseSearchStatus -SearchApplication $ssa -Text

    This command should return a list of all the active search components. The state of the active search components should be displayed as Active.


View search diagnostics in SharePoint Server 2013

Summary: Learn about usage reports, query health reports, crawl health reports and the crawl log to analyze the health of the search system.

Applies to: SharePoint Server 2013

You can access and analyze several query and crawl health reports, logs and usage reports from the Search service application in the SharePoint 2013Central Administration to monitor the health of the search system.

In this article:

  • Before you begin

  • Query health reports

  • Crawl health reports

  • Crawl log

  • Usage reports

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • The health reports and logs only contain information after a full crawl has completed. To run a full crawl, you have to set up a Search service application, add at least one content source, and then start a full crawl.

  • To view the health reports and the crawl log, you have to be an administrator of the Search service application. Alternatively, an administrator who is a member of the Farm Administrators group can grant user accounts Read permissions on the Search service application. A user account that has Read permissions can only view the Search service application status page, the health reports and the crawl log.

Query health reports

SharePoint Server 2013 provides the following reports about query performance:

  • Trend

  • Overall

  • Main Flow

  • Federation

  • SharePoint Search Provider

  • People Search Provider

  • Index Engine

To view query health reports

  1. Verify that the user account that is performing this procedure is an administrator of or has Read permissions to the Search service application.

  2. In Central Administration, under Application Management, click Manage service applications.

  3. On the Service Applications page, click the Search service application.

  4. On the Search Administration page, in the Quick Launch, in the Diagnostics section, click Query Health Reports.

  5. On the Search Service Application: Query Latency Trend page, click the query report that you want to view.

    The following table shows which reports are available.

    Overview of query health reports

    Query Health Report

    Description

    Trend (Query Latency Trend)

    For a specified time interval, shows the query latency (in milliseconds) by percentile. For example, five percent of all queries had lower latency than the latency indicated by the fifth percentile line in the graph.

    The graph includes an overlay of query rate during the specified time interval, where query rate is the number of queries per minute for which the query object model (OM) returned results.

    The graph also includes an overlay of the crawl rate and the partial update rate for analytics.

    You can filter this report by:

    • Start date/time

    • End date/time

    • Client type

    • Result page (search results page), which only shows if verbose logging is enabled.

    By default, the graph displays data for all result pages in the Search service application.

    Overall (Overall Query Latency)

    For a specified time interval, shows the query rate (number of queries per minute) with an overlay of query latency in milliseconds.

    Shows the query latency in each of the following areas:

    • Object model. This is the time it takes to communicate between the web server and the back-end.

    • Backend. This is the time it takes to transform the query, perform index look up, process results (such as removing duplicates), and return results to the object model.

    You can filter this report by:

    • Start date/time

    • End date/time

    • Client Type

    • Result page (search results page), which only shows if verbose logging is enabled.

    By default, the graph shows data for all result pages in the Search service application.

    Main Flow (Default SharePoint Flow Query Latency)

    For a specified time interval, shows the query latency (in milliseconds) in the main flow for query and result processing. This indicates how fast the system processes a query and returns results to the web server. The graph shows the query latency for:

    • Query rule condition matching

    • Query transformation

    • Query routing

    • Result mixing

    • Layout selection

    • Query logging

    • Other

    The graph includes an overlay of query rate during the specified time interval.

    You can filter this report by:

    • Start date/time

    • End date/time

    • Client Type

    Federation (Federation Query Latency)

    For a specified time interval, shows the query latency in milliseconds for all result source types.

    By default, the graph shows data for all result pages in the Search service application.

    You can filter this report by:

    • Start date/time

    • End date/time

    • Client type

    • Result page (search results page), which only shows if verbose logging is enabled.

    • Source type (result source type):

    • Best Bet Provider

    • Exchange Search Provider

    • Local People Provider

    • Local SharePoint Provider

    • OpenSearch Provider

    • Personal Favorites Provider

    • Remote People Provider

    SharePoint Search Provider (Local SharePoint Search Flow Query Latency)

    For a specified time interval, shows the query latency (in milliseconds) for all queries that are processed by the local SharePoint search provider. The graph shows the query latency for:

    • Keyword parsing

    • Linguistics

    • Recommendations Security Trimming

    • Security token construction

    • Index lookup

    • Result type processing

    • Custom security trimming

    • Summary generation

    • Other

    The graph includes an overlay of query rate during the specified time interval.

    You can filter this report by:

    • Start date/time

    • End date/time

    • Client type

    People Search Provider (People Search Flow Query Latency)

    For a specified time interval, shows the query latency (in milliseconds) for all queries that are processed by the local people search provider. The graph shows the query latency in each of the following areas:

    • Keyword parsing

    • Linguistics

    • People pre-processing

    • Security token construction

    • Index lookup

    • Result type processing

    • Custom security trimming

    • Summary generation

    • Other

    The graph includes an overlay of query rate during the specified time interval.

    You can filter this report by:

    • Start date/time

    • End date/time

    • Client type

    Index Engine (Index Engine Query Latency

    For a specified time interval, shows the query latency in milliseconds for each index server that you filter on. By default, the graph shows data for all result pages in the Search service application. You can filter this report by:

    • Start date/time

    • End date/time

    • Index server (a computer that hosts at least one index partition)

    • Result page (search results page), which only shows if verbose logging is enabled.

    The graph includes an overlay of the index lookup time for the specified time interval in the past. Index lookup time is the average amount of time during a given minute that it took the index engine to return results. The index lookup time applies only to queries for which the index engine returned results.

Crawl health reports

SharePoint 2013 provides the following reports about crawl health:

  • Crawl Rate

  • Crawl Latency

  • Crawl Queue

  • Crawl Freshness

  • Content Processing Activity

  • CPU and Memory Load

  • Continuous Crawl

To view crawl health reports

  1. Verify that the user account that is performing this procedure is an administrator of or has Read permissions to the Search service application.

  2. In Central Administration, under Application Management, click Manage service applications.

  3. On the Service Applications page, click the Search service application.

  4. On the Search Administration page, in the Quick Launch, in the Diagnostics section, click Crawl Health Reports.

  5. On the Search Service Application: Crawl Reports page, click the crawl health report that you want to view.

    The following table shows which reports are available.

    Overview of crawl health reports

    Crawl Report

    Description

    Crawl Rate

    For a specified time interval, shows a graph and a summary of the following:

    • Number of content items crawled per minute. This includes:

    • Total content items

    • Modified items. These are content items that were changed and re-crawled.

    • Not modified items. These are content items that were not changed and were not crawled.

    • Security items. These are content items for which the security attributes were changed.

    • Deleted items. These are content items that were deleted from the content source and which must also be deleted from the index.

    • Average number of other crawl actions that were performed per minute. This includes:

    • Retries (crawl retries)

    • Errors (crawl errors)

    You can filter this report by:

    • Start date/time

    • End date/time

    • Content sources (for example, Local SharePoint sites)

    • Machine

    Crawl Latency

    For a specified time, shows a graph of the number of items that form the crawl load, for each of the following:

    • In Crawler Queue

    • Waiting to submit to content processing

    • Submitted to content processing

    • Waiting to Commit (SQL)

    You can filter this report by machine only.

    For a specified time interval, also shows a graph and a summary of the crawl latency; the amount of time in milliseconds that each content item is in each of the following subsystems in the feeding pipeline:

    • Crawler

    • Protocol handler (PH)

    • Repository

    • SQL Time

    You can filter this report by:

    • Start date/time

    • End date/time

    • Content source (for example, Local SharePoint sites)

    • Machine

    Crawl Queue

    For a specified time interval, shows the number of items in the following two crawl queues:

    • Links to process. This is the number of uncrawled URLs that are queued to be crawled.

    • Transactions queued. This is the number of crawled URLs that arequeued to be processed in the crawl pipeline.

    You can filter this report by start date/time and end date/time.

    Crawl Freshness

    For a specified time interval, shows the freshness of the content that was being indexed by the search system. The last modified time stamp of each document is compared with the time specified in the graph. You can view the freshness of the content as follows:

    • Less than 1 month ago

    • Less than 1 week ago

    • Less than 1 day ago

    • Less than 4 hours ago

    Content Processing Activity

    For a specified time interval, shows the amount of time that was spent in content processing for:

    • Content sources

    • Machines

    • Content processing components

    • Content processing activity

    The graph shows the amount of time that was spent in various content processing activities, such as:

    • Linguistics processing

    • Document parsing

    • Document summary generation

    • Indexing

    You can filter this report by:

    • Start date/time

    • End date/time

    • Content source

    • Machine

    • Content processing component name

    • Processing activity

    CPU And Memory Load

    For a specified time interval, shows the percentage of CPU used, the memory use in megabytes and the system overview for these processes:

    • MSSDmn

    • MSSearch

    • NodeRunner

    • Timer

    You can filter this report by:

    • Machine

    • Start date/time

    • End date/time

    Continuous Crawl

    For a specified time interval, shows the time (in milliseconds) that the processes took with an overlay of discovery time (in minutes) for:

    • Time In Links Table

    • Time In Queue Table

    • Crawler Time

    • PH (Protocol Handler) Time

    • Repository Time

    • Content Pipeline Time

    • SQL Time

    You can filter this report by:

    • Content sources

    • Start date/time

    • End date/time

Crawl log

The crawl log tracks information about the status of crawled content. This log lets you determine whether crawled content was successfully added to the index, whether it was excluded because of a crawl rule, or whether indexing failed because of an error. The crawl log also contains information such as the time of the last successful crawl and whether any crawl rules were applied. You can use the crawl log to diagnose problems with the search experience.

To view the crawl log

  1. Verify that the user account that is performing this procedure is an administrator of the Search service application, or has Read permissions to it.

  2. In Central Administration, under Application Management, click Manage service applications.

  3. On the Service Applications page, click the Search service application.

  4. On the Search Administration page, in the Quick Launch, in the Diagnostics section, click Crawl Log.

  5. On the Crawl Log - Content Source page, click the view that you want.

Crawl log views

The following table shows the different views that you can select to see the status of crawled content.

Overview of crawl log views

View Description

Content Source

Summarizes items crawled per content source. Shows successes, warnings, errors, top-level errors, and deleted items. The data in this view represents the current status of items that are already present in the index per content source.

You can also see the average time that it took to complete a crawl of a content source for the last crawl, for the last 24 hours, for the last 7 days and for the last 30 days. You can view the developments of the crawl duration, and see whether a particular content source is getting smaller or larger in size.

Host Name

Summarizes items crawled per host. Shows successes, warnings, errors, deleted items, top-level errors, and the total number of crawled items. The data in this view represents the current status of items that are already present in the index per host.

Crawl History

Summarizes crawl transactions that were completed during a crawl. There can be multiple crawl transactions per item in a single crawl, so the number of transactions can be larger than the total number of items. This view shows data for these crawls:

  • Full. Crawls all items in a content source.

  • Incremental. Crawls items that have changed since the last full or incremental crawl. This kind of crawl only runs if it is scheduled.

  • Delete. If start addresses are removed from a content source, a delete crawl removes items associated with the deleted start address from the index before a full or incremental crawl runs. This kind of crawl cannot be scheduled.

  • Continuous. Crawls items in a SharePoint content source on a very frequent interval.

The Search Administration database provides the data for this view. You can filter the results by content source.

This view also shows the crawl rate and the repository latency.

Error Breakdown

Provides summaries of errors per content source or per host name. The MSSCrawlURLReport table in the crawl database provides the data for this view. You can filter by content source or by host.

Note:

The filter drop-down box only shows content sources that contain errors. If there is an error on an item that does not appear in the index, the error is not listed in this view.

Databases

Lets you view the state of the crawl databases used by this Search service application.

URL View

Lets you search the crawl logs by content source, URL, or host name, and view details of all items in the index. The MSSCrawlURLReport table in the crawl database provides the data for this view. You can filter the results by setting the Status, Message, Start Time, and End Time fields.

Note that the URL View only shows the Display URL. If items have the same Display URL (for example for a folder or views) but different Access URLs, the same Display URL displays several times in the URL View. You can query the Crawl database directly to see which items have the same Display URL.

The following table shows which additional columns are available in the Content Source, Host Name and Crawl History views. These columns show information about crawled items.

Overview of additional columns in the Content Source, Host Name and Crawl History views

Item | Description
Successes | Items were successfully crawled and searchable.
Warnings | Items might not have been successfully crawled and might not be searchable.
Errors | Items were not successfully crawled and might not be searchable.
Top Level Errors | Errors in top-level documents, including start addresses, virtual servers, and content databases. Every top-level error is counted as an error, but not all errors are counted as top-level errors. Because the Errors column includes the count from the Top Level Errors column, top-level-errors are not counted again in the Host Name view.
Deletes | Items that were removed from the index and are no longer searchable.
Not Modified | Items were not changed between crawls. This column only shows in the Crawl History view.
Security Update | The security settings of items were crawled because they were changed. This column only shows in the Crawl History view.
Security Errors | The security update of items caused an error. This column only shows in the Crawl History view.

Usage reports

You can use the usage reports and the search reports provided on the View Usage Reports page to view usage data that was collected about this site collection.

To view usage reports

  1. Verify that the user account that is performing this procedure is an administrator of or has Read permissions to the Search service application.

  2. In Central Administration, under Application Management, click Manage service applications.

  3. On the Service Applications page, click the Search service application.

  4. On the Search Administration page, in the Quick Launch, in the Diagnostics section, click Usage Reports.

  5. On the View Usage Reports page, click the usage or search reports view that you want view.

The following table shows the different usage reports and search reports that you can select.

Overview of usage report or search report

Usage report or search report | Description
Number of Queries | This report shows the number of search queries performed. Use this report to identify search query volume trends and to determine times of high and low search activity.
Top Queries by Day | This report shows the most popular search queries. Use this report to understand what types of information visitors are seeking.
Top Queries by Month | This report shows the most popular search queries. Use this report to understand what types of information visitors are seeking.
Abandoned Queries by Day | This report shows popular search queries that received low click-through. Use this report to identify search queries that might create user dissatisfaction and to improve the discoverability of content. Then, consider using query rules to improve the query's results.
Abandoned Queries by Month | This report shows popular search queries that received low click-through. Use this report to identify search queries that might create user dissatisfaction and to improve the discoverability of content. Then, consider using query rules to improve the query's results.
No Result Queries by Day | This report shows popular search queries that returned no results. Use this report to identify search queries that might create user dissatisfaction and to improve the discoverability of content. Then, consider using query rules to improve the query's results.
No Result Queries by Month | This report shows popular search queries that returned no results. Use this report to identify search queries that might create user dissatisfaction and to improve the discoverability of content. Then, consider using query rules to improve the query's results.
Query Rule Usage by Day | This report shows how often query rules trigger, how many dictionary terms they use, and how often users click their promoted results. Use this report to see how useful your query rules and promoted results are to users.
Query Rule Usage by Month | This report shows how often query rules trigger, how many dictionary terms they use, and how often users click their promoted results. Use this report to see how useful your query rules and promoted results are to users.


Enable search alerts in SharePoint Server 2013

Published: October 16, 2012

Summary: Learn how to enable or disable search alerts.

Applies to: SharePoint Server 2013

Search alerts allow end-users to receive e-mail notification when specified search query results are changed or updated. Search alerts should be enabled when you want allow end-users to create alerts for search queries. Search alerts may be configured on the search query page when a search query is completed and results are displayed. Search alerts are created and configured per-user and are only configurable and viewable by the user who creates them. Search alerts are enabled by default. Use this procedure to enable or disable search alerts.

In this article:

  • Before you begin

  • To enable or disable search alerts

Before you begin

Note:

SharePoint 2013 runs as websites in Internet Information Services (IIS), and administrators and users therefore require the accessibility features that browsers provide. For more information, see:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

To enable or disable search alerts

  1. Verify that the user account that is performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application for which you want to configure search alerts.

  4. On the Search Administration page, in the System Status section, locate Search alerts status.

  5. The search alerts status displays as OffEnable or OnDisable.

  6. By default, search alerts are turned On. Click Disable to turn off search alerts or click Enable to turn on search alerts.

The option is now set. Search alerts are sent only if outgoing e-mail is configured. For more information, see Configure outgoing email for a SharePoint 2013 farm. If you enabled search alerts, users can create search alerts for search queries that they run. To configure search alerts for search queries, users can click the Alert Me link that is located on the bottom of the Search Results page. The Alert Me link will appear a few minutes after search alerts are turned on. If search alerts are turned off, this icon does not appear.


Enable query logging in SharePoint Server 2013

Published: October 16, 2012

Summary: Learn how to enable or disable query logging.

Applies to: SharePoint Server 2013

SharePoint 2013 search collects information about user search queries and search results that users select on their computers. SharePoint 2013 uses this information to improve the relevance of search results and to improve query suggestions. Site collection administrators, tenant administrators and administrators of the Search service application can also create reports based on this information. Query logging is enabled by default. Use this procedure to enable or disable query logging.

In this article:

  • Before you begin

  • To enable or disable query logging

Before you begin

Note:

SharePoint 2013 runs as websites in Internet Information Services (IIS), and administrators and users therefore require the accessibility features that browsers provide. For more information, see:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

Before you begin this operation, review the following information about prerequisites:

  • Create a Search service application

To enable or disable query logging

  1. Verify that the user account performing this procedure is an administrator for the Search service application.

  2. In Central Administration, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, click the Search service application for which you want to configure query logging.

  4. On the Search Administration page, in the System Status section, locate Query logging.

  5. The Query logging status displays as OffEnable or OnDisable.

  6. By default, query logging is turned On. Click Disable to turn off query logging or click Enable to turn on query logging.

The option is set and no other actions are necessary. User search queries and user selected results will no longer be logged if you clicked Disable, or will now be logged if you clicked Enable.


Export and import customized search configuration settings in Sharepoint Server 2013

Published: December 11, 2012

Summary: Learn how to export and import customized search configuration settings.

Applies to: SharePoint Server 2013

You can export and import customized search configuration settings between site collections and sites. The settings that you export and import include all customized query rules, result sources, result types, ranking models, and site search settings. It is also possible to export customized search configuration settings from a Search service application and import the settings to site collections and sites, but you cannot import customized search configuration settings to a Search service application. You cannot export the default search configuration settings.

You can use the following methods to export or import customized search configuration settings:

  • To export or import customized search configuration settings at a site collection or site, use the Site Settings page or CSOM.

  • To export customized search configuration settings from a Search service application, use CSOM.

If you want to transfer all Master Page Gallery files, use the Design Manager. If you want to transfer a whole site, use Save site as template. If you want to export or import customized search settings programmatically, see Exporting and importing search configuration settings in SharePoint 2013 on MSDN.

This article describes how to use the Site Settings page to export and import customized search configuration settings for site collections, and sites.

In this article:

  • Before you begin

  • Export customized search configuration settings from a site collection

  • Export customized search configuration settings from a site collection

  • Import customized search configuration settings to a site collection

  • Import customized search configuration settings to a site

  • Overview of customized search configuration settings that can be exported and imported

Before you begin

Before you begin this operation, review the information in Overview of customized search configuration settings that can be exported and imported and ensure:

  • That the search configuration file and the target for your import do not have settings with the same name, except for managed properties.

  • That the source of your export does not include managed properties or aliases that contain the invalid characters listed in Invalid characters causing the import to fail.

  • That managed property names and aliases are unique within the combination of the search configuration file and the search configuration settings on the target site and its parent site collection.

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Export customized search configuration settings from a site collection

To export customized search configuration settings from a site collection

  1. Verify that the user account that is performing this procedure has Full control permission level at the site collection.

  2. In the site collection, on the Settings menu, click Site settings.

  3. On the Site Settings page, in the Site Collection Administration section click Search Configuration Export.

  4. In the dialog box, click Save.

Export customized search configuration settings from a site

To export customized search configuration settings from a site

  1. Verify that the user account that is performing this procedure has Full control permission level at the site.

  2. On the site, on the Settings menu, click Site settings.

  3. On the Site Settings page, in the Search section click Configuration Export.

  4. In the dialog box, click Save.

Import customized search configuration settings to a site collection

To import customized search configuration settings to a site collection

  1. Verify that the user account that is performing this procedure has Full control permission level at the site collection.

  2. In the site collection, in the Settings menu, click Site settings.

  3. On the Site Settings page, in the Site Collection Administration section, click Search Configuration Import.

  4. On the Import Search Configuration page, either type the name and location of the search configuration file to import, or click Browse and select the file name and location of the search configuration file to import, and then click Import.

  5. On the Search Config List page, verify that:

    • The search configuration file that you imported is in the list, and that its status is Imported Successfully.

      If the file has not imported successfully, the Notes column provides details about what happened. The Notes column also provides details, in some cases, when the file has imported successfully. For example if the file contains a managed property that has the same name as a managed property on the target, the Notes column indicates that this managed property already exists on the target.

    • The Scope column shows that the settings you imported are at the correct level, that is, at the level you meant to import the files to. For example, if you imported your settings at the site collection level instead of at the site level, you would see this information in the Scope column. The Scope column shows at which level the search configuration settings were enabled. The levels are site collection (SPSite) or site (SPWeb).

Import customized search configuration settings to a site

To import customized search configuration settings to a site

  1. Verify that the user account that is performing this procedure has Full control permission level at the site.

  2. On the site, on the Settings menu, click Site settings.

  3. On the Site Settings page, in the Search section click Configuration Import.

  4. On the Import Search Configuration page, either type the name and location of the search configuration file to import, or click Browse and select the file name and location of the search configuration file to import, and then click Import.

  5. On the Search Config List page, verify that:

    • The search configuration file you imported is in the list, and that its status is Imported Successfully.

      If the file has not imported successfully, the Notes column provides details about what happened. The Notes column also provides details, in some cases, when the file has imported successfully. For example if the file contains a managed property that has the same name as a managed property on the target, the Notes column indicates that this managed property already exists on the target.

    • The Scope column shows that the settings you imported are at the correct level, that is, at the level you meant to import the files to. For example, if you imported your settings at the site collection level instead of at the site level, you would see this information in the Scope column. The Scope column shows at which level the search configuration settings were enabled. The levels are site collection (SPSite) or site (SPWeb).

Overview of customized search configuration settings that can be exported and imported

When you export customized search configuration settings, SharePoint 2013 creates a search configuration file in XML format. This search configuration file includes all exportable customized search configuration settings at the Search service application, site collection, or site level from where you start the export. A search configuration file for a site collection does not contain search configuration settings from the individual sites within the site collection.

When you import a search configuration file, SharePoint 2013 creates and enables each customized search configuration setting in the site collection or site from where you start the import.

This table shows the settings that you can export and import. For each setting, the table indicates any dependencies on other customized search configuration settings. If the customized search configuration settings depend on a customized search configuration setting at a different level, for example, if a site query rule depends on a result source at site collection level, you must export and import settings at all of the relevant levels.

Customized search configuration setting | Dependency on other customized search configuration settings
Query rules. These include result blocks, promoted results, and user segments. | Result sources, result types, search schema, ranking model
Result sources | Search schema
Result types | Search schema, result sources, display templates
Search schema | None
Ranking model | Search schema

Conditions that may cause the import to fail

  • If the search configuration file and the target for your import have settings with the same name, the import of the search configuration file fails when it encounters this setting. Exceptions:

    • If you reimport a search configuration file, the settings that have the same name in the search configuration file and on the target do not cause the import to fail.

    • Managed properties with the same name do not cause an import to fail if the individual managed property settings are the same on the property in the search configuration file and on the target property.

    • Managed properties with the same name do not cause an import to fail if the aliases and mappings to crawled properties are different on the managed property in the search configuration file and on the target managed property. The import adds the aliases and mappings on the managed property in the search configuration file to the aliases and mappings on the target managed property.

  • If the search configuration file contains managed property names or aliases that contain invalid characters, the import fails when it encounters that managed property name or alias.

  • The managed property names and aliases of a search schema must be unique for a site and its parent site collection. This means:

    • If your search configuration file has a managed property that has the same name as an alias for a managed property on your target site or the parent site collection of your target site, then the import fails.

    • If your search configuration file has a managed property with an alias that has the same name as a managed property on your target site or the parent site collection of your target site, then the import fails.

Note:

Customized search settings that SharePoint 2013 created and enabled before the import failed remain enabled.

If the import fails, remove the condition that caused the failure and reimport the search configuration file. For example, if the Notes column states that there is already a query rule with the same name as the query rule that you are trying to import, then you should remove that query rule either from the target or from the import file, and then reimport the file.

Invalid characters causing the import to fail

If managed properties or aliases contain any of the listed characters, the import of the customized search schema that contains these properties will fail.

Character | Name
 | space
: | colon
; | semicolon
, | comma
( | opening parenthesis
) | closing parenthesis
[ | opening bracket
] | closing bracket
{ | opening brace
} | closing brace
% | percent
$ | dollar sign
_ | underscore
+ | plus sign
! | exclamation point
* | Asterisk
= | equal sign
& | Ampersand
? | question mark
@ | at sign
# | number sign
\ | Backslash
~ | Tilde
< | opening angle bracket
> | closing angle bracket
| | Pipe
` | grave accent
^ | Caret
\' | escape sequence
\" | escape sequence


Administer web content management in SharePoint Server 2013

Published: October 16, 2012

Summary: Learn how to operate web content management features.

Applies to: SharePoint Server 2013

The articles that are listed in the following table describe how to operate web content management features in a SharePoint Server 2013 environment.

 | Content | Description
Building blocks | View usage reports in SharePoint Server 2013 | Describes how to view the Popularity Trends report and the Most Popular Items report generated by the SharePoint Analytics Processing Component.


View usage reports in SharePoint Server 2013
See also

Published: October 16, 2012

Summary: Learn how to view the Popularity Trends report and the Most Popular Items report generated by the SharePoint Analytics Processing Component.

Applies to: SharePoint Server 2013

The Analytics Processing Component generates two reports that are based on usage event types:

  • Popularity Trends shows usage event statistics for a site collection, a site, or an individual item in a library or list.

  • Most Popular Items shows usage event statistics for all items in a library or list.

The reports are broken down per usage event type. The default usage event types are as follows:

  • Views. The number of views for a single item, page or document.

  • Recommendations Displayed. The number of times a single item, page or document was displayed as a recommendation.

  • Recommendations Clicked. The number of times s single item, page or document was clicked when it was displayed as a recommendation.

If you have added any custom usage event types, these will also be displayed.

For more information about the Analytics Processing Component and usage events, see Overview of analytics processing in SharePoint Server 2013. For information about search reports — for example, Number of Queries or Top Queries by Day — see "Usage reports" in View search diagnostics in SharePoint Server 2013.

Note:

Usage reports are only available for Document Libraries and Product Catalog lists.

In this article:

  • Before you begin

  • View the Popularity Trends report

  • View the Most Popular Items report

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

View the Popularity Trends report

The Popularity Trends report is an Excel report that shows daily and monthly hits and unique users per usage event type. The report shows the daily count for the last 14 days and the monthly count for the last three years.

Important:

In a cross-site publishing scenario, the procedures below are performed on the authoring site collection.

To view the Popularity Trends report for a site collection

  1. Verify that the user account that is performing this procedure is a member of the Owners group.

  2. In the site collection, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Collection Administration section, click Popularity and Search Reports.

  4. On the View Usage Reports page, in the Usage Reports section, click Usage.

  5. In the message box, click Open to open the report in Excel, or click Save or Save as to save the report.

  6. Click the tabs to view the usage report for the different usage event types.

    Note:

    The daily count for Unique Users shows the number of unique users per day. The monthly count for Unique Users shows the sum of unique users per day within the month (SUM(UU/Day))

To view the Popularity Trends report for a site

  1. Verify that the user account that is performing this procedure is a member of the Site Collection Administrators group.

  2. In the site collection, on the Settings menu, click Site Settings.

  3. On the Site Settings page, in the Site Administration section, click Popularity Trends.

  4. On the View Usage Reports page, in the Usage Reports section, click Usage.

  5. In the message box, click Open to open the report in Excel, or click Save or Save as to save the report.

  6. Click the tabs to view the usage report for the different usage event types.

    Note:

    The daily count for Unique Users shows the number of unique users per day. The monthly count for Unique Users shows the sum of unique users per day within the month (SUM(UU/Day))

To view the Popularity Trends report for a library or list item

  1. Verify that the user account that is performing this procedure is a member of the Visitors group.

  2. In the site collection, browse to the library or list that contains the item for which you want to view the Popularity Trends report.

  3. Select the item that you want to view the Popularity Trends report for, and then do one of the following:

    • For a library, click the FILES tab, and then, on the ribbon, click Popularity Trends.

    • For a list, click the ITEMS tab, and then, on the ribbon, click Popularity Trends.

    Note:

    If you select more than one item, the Popularity Trends report will only display statistics for the View usage event type. To see statistics for all usage event types, select one item only.

  4. In the message box, click Open to open the report in Excel, or click Save or Save as to save the report.

  5. Click the tabs to view the usage report for the different usage event types.

    Note:

    The daily count for Unique Users shows the number of unique users per day. The monthly count for Unique Users shows the sum of unique users per day (SUM(UU/Day)) for a given month.

View the Most Popular Items report

The Most Popular Items report lists the most popular items per usage event type for all items in a library or list —for example, the most viewed items in the library or list. The report can be sorted by the time periods Recent or Ever. By default, the Recent time period is set to the last 14 days, but you can change this setting to be any value from 1 to 14 days. For information about how to change the Recent time period, see "To change the Recent time period for a usage event" in Configure recommendations and usage event types in SharePoint Server 2013. The Ever time period is from the first time that the item became available up to present day.

Important:

In a cross-site publishing scenario, the procedures below are performed on the authoring site collection.

To view the Most Popular Items report for all items in a SharePoint library or list

  1. Verify that the user account that is performing this procedure is a member of the Visitors group.

  2. In the site collection, browse to the library or list for which you want to view the Most Popular Items report, and then do one of the following:

    • For a library, click the LIBRARY tab, and then, on the ribbon, click Most Popular Items.

    • For a list, click the LIST tab, and then, on the ribbon, click Most Popular Items.

  3. By default, the report lists items in the library or list that has most views for the Recent time period. To view other rankings, do the following:

    • To view a report that lists items for a different usage event types, select a usage event type from the menu at the top of the page.

    • To view a report that list items for the complete time period the item was available, click Ever.

    • To search within the report list, type a search word in the search box on the top of the page.

    Note:

    The usage event Most Views by Unique Users shows a ranking based on the sum of unique users per day (SUM(UU/day)) within the specified time period.

    To view the Popularity Trends report for a specific item in the list, click the Popularity Trends link located under the item URL.

See also

Configure recommendations and usage event types in SharePoint Server 2013


Administer business intelligence in SharePoint Server 2013
See also

Summary: Find resources to configure and maintain business intelligence tools in SharePoint Server 2013.

Applies to: SharePoint Server 2013

TechNet articles about how to configure and maintain business intelligence tools in SharePoint Server 2013

The following articles about how to configure and maintain business intelligence tools in SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Administer Excel Services in SharePoint Server 2013 | Excel Services is a SharePoint Server 2013 service application that allows users to share and view Excel workbooks.
PerformancePoint Services administration (SharePoint Server 2013) | PerformancePoint Services in SharePoint Server 2013 is a performance management service that you can use to monitor and analyze your business.
Visio Graphics Service administration in SharePoint Server 2013 | The Visio Graphics Service is a SharePoint Server 2013 service application that allows users to share and view Visio diagrams by using Visio Services.
Configure a Business Intelligence Center in SharePoint Server 2013 | The Business Intelligence Center gives you a central location to store items, such as reports and dashboards. When you enable Excel Services and PerformancePoint Services, you will already have a location to store reports and dashboard content.

See also

Software requirements for business intelligence in SharePoint Server 2013


Visio Graphics Service administration in SharePoint Server 2013
See also

Summary: You can create, configure, list, or delete Visio Services service applications by using Central Administration or Windows PowerShell.

Applies to: SharePoint Server 2013

The Visio Graphics Service is a SharePoint Server 2013 service application that allows users to share and view Visio diagrams by using Visio Services. The service application also enables data-connected Visio 2013 diagrams to be refreshed and updated from different data sources.

Important:

In farms with multiple Web servers, Visio Services requires the state service to be running. Visio Services does not automatically provision this service. For more information about the State Service, see Manage the State Service (SharePoint Server 2013).

TechNet articles about Visio Graphics Service administration in SharePoint Server 2013

The following articles about Visio Graphics Service administration in SharePoint Server 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
Create a Visio Graphics Service service application in SharePoint Server 2013 | The Visio Graphics Service can be provisioned through Central Administration or with Windows PowerShell.
Delete a Visio Graphics Service service application in SharePoint Server 2013 | The Visio Graphics Service can be deleted through Central Administration or with Windows PowerShell.
List all Visio Graphics Service service applications in SharePoint Server 2013 | The provisioned Visio Services service applications can be listed through Central Administration or with Windows PowerShell.
Create a Visio Graphics Service service application proxy in SharePoint Server 2013 | A Visio Graphics Service service application proxy can be provisioned with Windows PowerShell.
Delete a Visio Graphics Service service application proxy in SharePoint Server 2013 | The Visio Graphics Service application service proxy can be deleted through Central Administration or with Windows PowerShell.
List all Visio Graphics Service service application proxies in SharePoint Server 2013 | You can list the Visio Graphics Service service application proxies by using Windows PowerShell or Central Administration.
Configure Visio Graphics Service global settings in SharePoint Server 2013 | The Visio Graphics Service global settings can be provisioned through Central Administration or with Windows PowerShell.
Configure Visio Graphics Service trusted data providers in SharePoint Server 2013 | The Visio Graphics Service trusted data providers can be provisioned through Central Administration or with Windows PowerShell.

See also

Plan for Visio Services in SharePoint Server 2013


Create a Visio Graphics Service service application in SharePoint Server 2013

Summary: The Visio Graphics Service can be provisioned through Central Administration or with Windows PowerShell.

The following steps show how to create a Visio Graphics Service service application.

Applies to: SharePoint Server 2013

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • You must be a member of the farm administrators group.

Video demonstration

This video shows the steps involved in setting up a Visio Graphics Service service application, as described in this article.

Video: Create a Visio Graphics Service service application in SharePoint Server 2013

Video (play button) icon

Create a Visio Graphics Service service application

To create a Visio Graphics Service service application by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To create a service application, you must be a member of the farm administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website Home page, in the Application Management section, click Manage service applications.

    Important:

    Visio Services in SharePoint Server 2013 requires the SharePoint Server Enterprise Site Collection Features feature to be active on each site collection where you plan to use the Visio Web Access Web Part.

  4. On the ribbon, click New, and then click Visio Graphics Service.

  5. Type a name for the new service application.

  6. Choose an existing application pool or create a new one.

  7. Choose whether to create a Visio Graphics Service Application Proxy (recommended).

  8. Click OK.

To create a Visio Graphics Service service application by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command and press Enter:

    New-SPVisioServiceApplication <ServiceAppName> -serviceapplicationpool <AppPoolName> -AddToDefaultGroup

For more information, see New-SPVisioServiceApplication.


Delete a Visio Graphics Service service application in SharePoint Server 2013

Summary: The Visio Graphics Service can be deleted through Central Administration or with Windows PowerShell.

The following steps show how to delete a Visio Graphics Service service application.

Applies to: SharePoint Server 2013

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • You must be a member of the farm administrators group.

Delete a Visio Graphics Service service application

To delete a Visio Graphics Service service application by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To delete a service application, you must be a member of the farm administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website Home page, in the Application Management section, click Manage service applications.

  4. Select the Visio Graphics Service service application that you want to delete.

  5. On the ribbon, click Delete.

  6. In the confirmation dialog box, click OK.

To delete a Visio Graphics Service service application by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command and press Enter:

    Remove-SPServiceApplication <ServiceAppName>

For more information, see Remove-SPServiceApplication.


List all Visio Graphics Service service applications in SharePoint Server 2013

Summary: The provisioned Visio Services service applications can be listed through Central Administration or with Windows PowerShell.

Applies to: SharePoint Server 2013

The following steps show how to list all the Visio Graphics Service service applications.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • You must be a member of the farm administrators group.

List all the Visio Graphics Service service applications

To list all the Visio Graphics Service service applications by using Central Administration

  1. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. On the SharePoint Central Administration website Home page, in the Application Management section, click Manage service applications.

    The Visio Graphics Service service applications are listed on the Manage Service Applications page.

To list all the Visio Graphics Service service applications by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command and press Enter:

    Get-SPVisioServiceApplication

For more information, see Get-SPVisioServiceApplication.


Create a Visio Graphics Service service application proxy in SharePoint Server 2013
See also

Summary: A Visio Graphics Service service application proxy can be provisioned with Windows PowerShell.

The following steps show how to create a Visio Graphics Service service application proxy.

Applies to: SharePoint Server 2013

Note:

A Visio Graphics Service service application proxy can only be created in the SharePoint Central Administration website when you are creating a new Visio Graphics Service service application. To do so, ensure that the Create a Visio Graphics Service Application Proxy and add it to the default proxy group check box is selected when you create a new service application.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • You must be a member of the farm administrators group.

Create a Visio Graphics Service service application proxy

To create a Visio Graphics Service service application proxy by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command and then press Enter:

    New-SPVisioServiceApplicationProxy <ServiceAppName>

For more information, see New-SPVisioServiceApplicationProxy.

See also

Delete a Visio Graphics Service service application proxy in SharePoint Server 2013


Delete a Visio Graphics Service service application proxy in SharePoint Server 2013
See also

Summary: The Visio Graphics Service application service proxy can be deleted through Central Administration or with Windows PowerShell.

The following steps show how to create a Visio Graphics Service service application.

Applies to: SharePoint Server 2013

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • You must be a member of the farm administrators group.

Delete a Visio Graphics Service service application proxy

To delete a Visio Graphics Service service application proxy by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To delete a service application proxy, you must be a member of the farm administrators group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the Central Administration Home page, in the Application Management section, click Manage service applications.

  4. Select the Visio Graphics Service service application proxy that you want to delete.

  5. On the ribbon, click Delete.

  6. In the confirmation dialog box, click OK.

To delete a Visio Graphics Service service application proxy by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command and press Enter:

    Remove-SPServiceApplicationProxy <ProxyID>

For more information, see Remove-SPServiceApplicationProxy.

See also

Get-SPVisioServiceApplicationProxy


List all Visio Graphics Service service application proxies in SharePoint Server 2013

Summary: You can list the Visio Graphics Service service application proxies by using Windows PowerShell or Central Administration.

Applies to: SharePoint Server 2013

The following steps show how to list all the Visio Graphics Service service application proxies.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • You must be a member of the farm administrators group.

List all the Visio Graphics Service service application proxies

To list all the Visio Graphics Service service application proxies by using Central Administration

  1. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  2. On the SharePoint Central Administration website Home page, in the Application Management section, click Manage service applications. The Visio Graphics Service service applications and their associated proxies are listed on the Manage Service Applications page.

To list all the Visio Graphics Service service application proxies by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. From the Windows PowerShellcommand prompt (that is, PS C:\>), type the following command and press Enter:

    Get-SPVisioServiceApplicationProxy

For more information, see Get-SPVisioServiceApplicationProxy.


Configure Visio Graphics Service global settings in SharePoint Server 2013

Summary: The Visio Graphics Service global settings can be provisioned through Central Administration or with Windows PowerShell.

Applies to: SharePoint Server 2013 Enterprise

The following steps show how to create a Visio Graphics Service service application.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • You must be a member of the farm administrators group or a Visio Services service application administrator.

Configure a Visio Graphics Service service application

To configure a Visio Graphics Service service application by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To configure a service application, you must be a member of the farm administrators group or a Visio Services service application administrator.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the SharePoint Central Administration website Home page, in the Application Management section, click Manage service applications.

  4. Click the Visio Graphics Service service application that you want to configure.

  5. On the Visio Graphics Service Settings page, configure the following settings:

    Parameter Description

    Maximum Diagram Size

    The maximum size in MB of a diagram that can be rendered. A larger size limit may lead to slower performance if the server is under heavy load, whereas a smaller limit may prevent more complex diagrams from being rendered.

    Valid values range from 1 to 50. The default value is 25 MB.

    Minimum Cache Age

    The minimum number of minutes that a diagram is cached in memory. Smaller values allow for more frequent data refresh operations for users, but increase CPU and memory usage on the server.

    This value is per user per diagram. The interval begins when a user views a diagram. That user cannot refresh that diagram until the interval expires. The interval begins for other users when they first view the diagram.

    This parameter applies to diagrams with data connections and diagrams with recalculations based on shape sheet functions. The automatic refresh setting in Visio Web Parts is also constrained by this setting.

    Valid values range from 0 to 34560 minutes. The default value is 5 minutes.

    Maximum Cache Age

    The number of minutes after which cached diagrams are purged. Larger values decrease file I/O and CPU load but increase memory usage on the server.

    Valid values range from 0 to 34560 minutes. The default value is 60 minutes.

    Maximum Recalc Duration

    The number of seconds before data refresh operations time out. Longer timeouts will allow for more complex data connected diagrams to be recalculated, but will use more processing power. This applies only to data connected diagrams.

    This parameter applies to diagrams with data connections and diagrams with recalculations based on shape sheet functions.

    Valid values range from 10 to 120. The default value is 60 seconds.

    Maximum Cache Size

    The maximum cache size in MB (between 100 and 1024000) that can be used. A larger size limit may lead to more disk resource usage by the service, while a smaller limit may impact performance.

    Valid values range from 100 to 1024000. The default value is 5120 MB.

    External Data

    The target application ID in the registered Secure Store Service that is used to reference Unattended Service Account credentials. The Unattended Service Account is a single account that all documents can use to refresh data. It is required when you connect to data sources external to SharePoint Server, such as SQL Server.

  6. Click OK.

To configure a Visio Graphics Service service application by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), the following syntax to manage the performance parameters in the Visio Graphics Service service application, and then press Enter:

    Set-SPVisioPerformance -MaxDiagramCacheAge<Minutes>-MaxDiagramSize <SizeMB>-MaxRecalcDuration<Seconds>-MinDiagramCacheAge<Minutes>-VisioServiceApplication<VisioServiceApp>-MaxCacheSize<SizeMB>

  6. From the Windows PowerShell command prompt, type the following syntax to manage the data configuration parameters in the Visio Graphics Service service application, and then press Enter:

    Set-SPVisioExternalData -VisioServiceApplication<VisioServiceApp>-UnattendedServiceAccountApplicationID<ApplicationID>

For more information, see Set-SPVisioPerformance>.


Configure Visio Graphics Service trusted data providers in SharePoint Server 2013

Summary: The Visio Graphics Service trusted data providers can be provisioned through Central Administration or with Windows PowerShell.

Applies to: SharePoint Server 2013

Trusted data providers for the Visio Graphics Service

By default, the following trusted data providers are trusted by the Visio Graphics Service:

Default trusted data providers for the Visio Graphics Service

Description | ID | Type
SQL Server OLE DB Driver (MDAC) | SQLOLEDB | 1
SQL Server OLE DB Driver (MDAC SQL Server 2000) | SQLOLEDB.1 | 1
SQL Server ODBC Driver (MDAC) | SQL Server | 3
SQL Server ODBC DSN Driver (MDAC) | SQL Server | 4
SQL Server OLE DB DSN Driver for ODBC | SQLOLEDB.1 | 4
SQL Server OLE DB Driver (SNAC) | SQLNCLI | 1
SQL Server OLE DB Driver (SNAC SQL Server 2005) | SQLNCLI.1 | 1
SQL Server ODBC Driver (SNAC) | SQL Native Client | 3
SQL Server ODBC DSN Driver (SNAC) | SQL Native Client | 4
Oracle Provider for OLE DB | OraOLEDB.Oracle.1 | 1
Oracle ODBC Driver for Oracle 9.2 | Oracle in OraHome92 | 3
Oracle ODBC DSN Driver for Oracle 9.2 | Oracle in OraHome92 | 4
IBM OLE DB Provider for DB2 | IBMDADB2 | 1
IBM DB2 ODBC Driver | IBM DB2 ODBC DRIVER | 3
IBM DB2 ODBC DSN Driver | IBM DB2 ODBC DRIVER | 4
Microsoft SQL ODBC Driver | MSDASQL.1 | 3
Microsoft SQL ODBC DSN Driver | MSDASQL.1 | 4
Microsoft SharePoint List | WSSList | 5
Excel Web Services | Microsoft.Office.Visio.Server.EcsDataHandler, Microsoft.Office.Visio.Server, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c | 6

Data Provider ID

The Data Provider ID is the name of the driver that acts as the data provider. This ID must be the same ID that is used to reference the data provider in a connection string. The driver for the data provider must be installed on every application server that is running the Visio Graphics Service. Once you have installed the driver on your application servers, you can add it as a trusted data provider in Visio Services in SharePoint Server 2013.

Data Provider type

When adding a new trusted data provider, the data provider type must be one of the following values:

Number | Type
1 | OLE DB
2 | SQL
3 | ODBC
4 | ODBC with DSN
5 | SharePoint Lists
6 | Custom Data Provider

Data Provider description

The data provider description is a friendly name that appears in the Trusted Data Providers section of the Manage the Visio Graphics Service page in the SharePoint Central Administration website.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • You must be a member of the farm administrators group or a Visio Services service application administrator.

Create, edit, and delete trusted data providers

The following steps show how to create a Visio Graphics Service service application.

To create a Visio Graphics Service trusted data provider by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To create a trusted data provider, you must be a member of the farm administrators group or a Visio Services service application administrator.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the Central Administration Home page, in the Application Management section, click Manage service applications.

  4. Click the Visio Graphics Service service application where you want to create the trusted data provider.

  5. Click Trusted Data Providers.

  6. Click Add a new Trusted Data Provider.

  7. Enter values for the following parameters:

    Parameter Description

    Trusted Data Provider ID

    The Trusted Data Provider ID

    Trusted Data Provider Type

    The Data Provider type

    Trusted Data Provider Type Description

    A description of the Trusted Data Provider type

  8. Click OK.

To edit a Visio Graphics Service trusted data provider by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To edit a trusted data provider, you must be a member of the farm administrators group or a Visio Services service application administrator.

  2. In Central Administration, under Application Management, click Manage service applications.

  3. Click the Visio Graphics Service service application where you want to edit the trusted data provider.

  4. Click Trusted Data Providers.

  5. Select the data provider that you want to edit, and from the drop-down menu select Edit Trusted Data Provider.

  6. Edit the settings that you want, and then click OK.

To delete a Visio Graphics Service trusted data provider by using Central Administration

  1. Verify that you have the following administrative credentials:

    • To delete a trusted data provider, you must be a member of the farm administrators group or a Visio Services service application administrator.

  2. In Central Administration, under Application Management, click Manage service applications.

  3. Click the Visio Graphics Service service application where you want to delete the trusted data provider.

  4. Click Trusted Data Providers.

  5. Select the data provider that you want to delete, and from the drop-down menu select Delete Trusted Data Provider.

To create a Visio Graphics Service trusted data provider by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command and press Enter:

    New-SPVisioSafeDataProvider -DataProviderId<ProviderID>-DataProviderType<Int32>-VisioServiceApplication<VisioServiceApp>

For more information, see New-SPVisioSafeDataProvider.

To edit a Visio Graphics Service trusted data provider by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command and press Enter:

    Set-SPVisioSafeDataProvider -DataProviderId<ProviderID>-DataProviderType<Int32>-Description<String>-VisioServiceApplication<VisioServiceApp>

For more information, see Set-SPVisioSafeDataProvider.

To delete a Visio Graphics Service trusted data provider by using Windows PowerShell

  1. Verify that you meet the following minimum requirements: See Add-SPShellAdmin.

  2. On the Start menu, click All Programs.

  3. Click Microsoft SharePoint 2013 Products.

  4. Click SharePoint 2013 Management Shell.

  5. From the Windows PowerShell command prompt (that is, PS C:\>), type the following command and press ENTER:

    Remove-SPVisioSafeDataProvider -DataProviderId<ProviderID>-DataProviderType<Int32>-VisioServiceApplication<VisioServiceApp>

For more information, see Remove-SPVisioSafeDataProvider.


Configure a Business Intelligence Center in SharePoint Server 2013

Summary: Create a Business Intelligence Center in SharePoint Server 2013 by using the Business Intelligence Center enterprise template and creating a new site collection.

Applies to: SharePoint Server 2013

Important:

To complete the steps in this article, you must first have completed Configure the Secure Store Service in SharePoint 2013.

The Business Intelligence Center gives you a central location to store items, such as reports and dashboards. When you enable Excel Services and PerformancePoint Services, you will already have a location to store reports and dashboard content.

Configure a Business Intelligence Center

When you create and configure a Business Intelligence Center, you create a new site collection and select the Business Intelligence Center site template. The Business Intelligence Center is a top-level site.

To create a Business Intelligence Center

  1. Verify that you have the correct administrative credentials. To create a site collection, you must be a member of the Farm Administrators SharePoint group on the computer that is running the SharePoint Central Administration website.

  2. On the SharePoint Central Administration website home page, in the left navigation, click Application Management.

  3. In Application Management, click Create site collections.

  4. In the Title and Description section, in the Title box, type BI Center.

  5. In the Web Site Address section, type BICenter in the box.

    In most instances the complete URL for this site collection is http://your server name/sites/bicenter.

  6. In the Template Selection section, click the Enterprise tab, and then click Business Intelligence Center.

  7. In the Primary Site Collection Administrator section, type FarmAdmin.

  8. Click OK.

  9. When the top-level site (Business Intelligence Center) is successfully created, click OK.

  10. Assign user permissions to the Business Intelligence Center.

The next step is to assign user permissions to the Business Intelligence Center.

To set permissions on the Business Intelligence Center

  1. Go to your Business Intelligence Center (http://servername/sites/bicenter).

  2. In the upper right corner, click Settings.

  3. Click Site Settings.

  4. Click Site Permissions.

  5. In the ribbon, click Grant Permissions.

  6. In the Share 'Central Administration'… Invite people to box, type the name of the account you want to which you wish to assign permissions.

  7. Click Show Options and select a group or permissions level.

  8. Click Share.

Repeat this for each account as needed. The following table is a simple example of organizing your accounts and permission settings for your BI Center.

Account | Permissions
servername\BICenterRead | Read Read permissions enable users to view information in the Business Intelligence Center.
servername\BICenterContribute | Contribute Contribute permissions enable users to view and create items, such as reports, and save them to this site.
servername\BICenterDesign | Design Design permissions enable users to view, create, and publish items that include dashboards.
servername\BICenterFullControl | Full Control Full Control permissions enable users to view, create, and publish dashboard content, and to view or edit user permissions
Note:

You will be unable to create and use some kinds of Web Parts in the Business Intelligence Center until Excel Services and PerformancePoint Services are enabled. For example, you cannot view or use Excel Services samples or PerformancePoint functionality. Therefore it is recommended that you configure these services before you create your BI Center.

Add links to the Quick Launch

In the Business Intelligence Center, the Documents library contains reports and files, such as Excel Services workbooks, Visio Services files, and more. The Documents library for the Business Intelligence Center already exists. It is created automatically when you create the Business Intelligence Center.

After you have created and configured the Business Intelligence Center, you may choose to create a link to the Documents library on the Quick Launch.

To add the Documents library link to the Quick Launch in the Business Intelligence Center

  1. In the Business Intelligence Center, click Settings, and then click View Site Contents.

  2. Right-click Documents, and then click Copy shortcut.

  3. In the Business Intelligence Center, click Settings, and then click Site Settings.

  4. Under Look and Feel, click Navigation.

  5. In the Structural Navigation: Editing and Sorting section, click Current Navigation, and then click Add Link.

  6. In the dialog box that opens, type Documents in the Title box, paste the link that you copied in Step 2, and then click OK to close the dialog box. (Do not close the navigation settings yet.)

  7. In the Navigation Editing and Sorting section, select Documents, and then click Move Up until Documents is the first item listed under Current Navigation.

  8. In the Navigation Editing and Sorting section, click Global Navigation, and then click Add Link.

  9. Click OK. Verify that Documents appears at the top of the list in the Quick Launch.

To make it easier for site users to locate the Business Intelligence Center, you can use the same procedure to add a link on the main team site Quick Launch.


Use SharePoint 2013
See also

Summary: Learn about using business intelligence and other SharePoint Server 2013 solutions that cross between IT pro and information worker areas.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

TechNet articles about how to use business intelligence and other SharePoint solutions

The following articles about how to use business intelligence and other SharePoint Server 2013 solutions are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks Content | Description
BI capabilities in Excel and Excel Services (SharePoint Server 2013) | Excel 2013 offers many business intelligence capabilities. Learn which capabilities are supported in Excel Services (on premises).
Share data connections by using Excel and Excel Services (SharePoint Server 2013) | Excel Services enables you to work with different external data sources to create reports, scorecards, and dashboards that remain up to date automatically.
Share workbooks by using Excel Services (SharePoint Server 2013) | Learn how to share workbooks with other people by using Excel Services.
Create Dashboards by using PerformancePoint Services (SharePoint Server 2013) | Learn how to create dashboards by using the PerformancePoint Dashboard Designer tool in SharePoint Server 2013.

Additional resources about using business intelligence solutions

The following resources provide information about how to set up business intelligence solutions.

Office 2013 | Content | Description
 | Overview of business intelligence capabilities in Microsoft SharePoint Server | Describes the various SharePoint business intelligence tools and applications that are available.
 | Learn about PerformancePoint scorecards | Scorecards are used to show performance for one or more items, such as key performance indicators (KPIs) by comparing actual results to target values. Scorecards resemble tables that include graphical indicators.
 | Creating dashboards by using PerformancePoint Dashboard Designer | A dashboard is basically a collection of scorecard and report views that dashboard users can view in a web browser.
 | Using PerformancePoint Services with multiple web browsers | In most cases, you can use Internet Explorer, Mozilla Firefox, or Apple Safari to explore data in PerformancePoint Web Parts and dashboards.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support

See also

SharePoint Business Intelligence Resource Center


Share data connections by using Excel and Excel Services (SharePoint Server 2013)
See also

Updated: February 5, 2013

Summary: Excel Services enables you to work with different external data sources to create reports, scorecards, and dashboards that remain up to date automatically.

Applies to: SharePoint Server 2013 Enterprise

Excel can connect to lots of different data sources. These include SQL Server, a SharePoint list, an Access database, a Windows Azure DataMarket Feed, an OData feed, and so on. Many of the data connections that you can use in Excel are supported as data connections in Excel Services. This means that people can refresh data in Excel Services reports, scorecards, and dashboards that use those data connections. More specifically, Excel Services supports connections to SQL Server tables, SQL Server Analysis Services cubes, and custom OLE DB/ODBC data providers.

By storing data connections in an Excel Services trusted data connection library, people can easily access the data sources that they need without having to know the names of servers and databases. Data connections are reusable so that people can create multiple reports or workbooks using those data connections. In addition, Excel Services workbooks that use connections in a trusted data connection library can be updated so that people have easy access to current information.

Use the articles in this section to learn how to create and publish external data connections using Excel Services.

In this section

  • Share a SQL Server Analysis Services data connection using Excel Services (SharePoint Server 2013)

  • Share a SQL Server data connection using Excel Services (SharePoint Server 2013)

  • Share an OLE DB or ODBC connection using Excel Services (SharePoint Server 2013)

See also

BI capabilities in Excel and Excel Services (SharePoint Server 2013)
Data sources supported in Excel Services (SharePoint Server 2013)

Change History

Date | Description
February 05, 2013 | Added a link to a new article in this section.
October 16, 2012 | Initial publication


Share a SQL Server Analysis Services data connection using Excel Services (SharePoint Server 2013)
See also

Published: October 16, 2012

Summary: Learn how to use Excel to create and share a connection to SQL Server Analysis Services data that people can use to create data models, reports, scorecards, and dashboards.

Applies to: SharePoint Server 2013 Enterprise

You can use Excel to create connections to databases such as SQL Server Analysis Services, and then share those connections with others. When you can upload a data connection to an Excel Services trusted data connection library, the data connection is available for you and others to use to create data models, reports, scorecards, and dashboards. Depending on the particular data source that is used, people can easily refresh data in Excel Services workbooks so that the most current information is displayed.

In this article:

  • Step 1: Use Excel to create connections to SQL Server Analysis Services data

  • Step 2: Upload data connections to SharePoint Server

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this task, review the following information about prerequisites:

  • You must be using Excel 2013 and SharePoint Server 2013.

  • Excel Services must be configured to include a trusted data connections library and a trusted documents library. Ideally, you'll have a Business Intelligence Center site configured that you can use for your data connections and workbooks. For more information, see Configure a Business Intelligence Center in SharePoint Server 2013.

  • You must have at least Contribute permissions assigned in SharePoint Server.

  • You will need information from a SharePoint administrator about how data authentication is configured for the databases your organization uses. This can affect how you connect to different data sources.

  • If you plan to publish workbooks that contain data models to SharePoint Server, Excel Services must be configured to support data models. For more information, see Configure Excel Services in SharePoint Server 2013.

Step 1: Use Excel to create connections to SQL Server Analysis Services data

You can use Excel to create a connection a cube that is stored in Analysis Services. This kind of connection is an Office Data Connection (ODC) file that can be used to create reports, scorecards, and dashboards by using applications such as Excel.

To create an Analysis Services data connection by using Excel

  1. In Excel, on the Data tab, in the Get External Data group, click From Other Sources, and then select From Analysis Services.

    The Data Connection Wizard opens.

  2. On the Connect to Database Server page, in the Server name box, specify the name of the server where the Analysis Services data that you want to use resides. Do not click Next yet.

  3. In the Log on credentials section, take one of the following steps:

    • If your organization is using Windows Authentication, choose Use Windows Authentication, and then choose the Next button.

    • If your organization is using specific user credentials, choose Use the following User Name and Password, specify an appropriate user name and password, and then choose the Next button.

  4. On the Select Database and Table page, in the Select the database that contains the data that you want list, select the database that you want to use. Do not click Next yet.

  5. On the Select Database and Table page, select Connect to a specific cube or table, select the cube or table that you want to use, and then click Next.

  6. On the Save Data Connection File and Finish page, take the following steps:

    1. In the File Name box, keep or change the default file name.

    2. In the Description box, type a brief description for the data connection.

    3. In the Friendly Name box, keep the default name or type a new name for file.

    4. In the Search Keywords box, type some words or phrases that will help users find the data connection when it is published to SharePoint Server.

    5. Next to Excel Services, click Authentication Settings…, and then take one of the following steps:

      • If you want this connection to use Windows Authentication or the Effective User Name feature, select Use the authenticated user's account, and then click OK.

      • If you want this connection to use Secure Store Service, select Use a stored account. In the Application ID box, specify the Secure Store target application ID, and then click OK.

      • If Excel Services is configured to use the unattended service account, select None, and then click OK.

      Important:

      If you do not know which option to choose, contact a SharePoint administrator.

    6. Click Finish to close the Save Data Connection File and Finish page.

  7. On the Import Data page, click Only Create Connection, and then click OK.

  8. Repeat steps 1-7 until you have created all the Analysis Services data connections that you want.

  9. Close Excel.

By default, data connections are saved in the My Data Sources folder in the Documents library on your computer.

Step 2: Upload data connections to SharePoint Server

After data connections are created, the next step is to upload them to a data connection library. We recommend that you use a Business Intelligence Center site to store and manage business intelligence content, such as data connections.

Note:

If you are not using a Business Intelligence Center site, make sure that you use a data connection library that is specified as a trusted location in Excel Services. For more information, see Manage Excel Services trusted data connection libraries (SharePoint Server 2013).

To upload a data connection to SharePoint Server

  1. Open a web browser and navigate to the SharePoint site that contains the data connection library that you want to use.

    If you are using a Business Intelligence Center, the website address (URL) resembles http://servername/sites/bicenter.

  2. Click Site Contents to view the lists and libraries that are available for that site.

  3. Click Data Connections to open that library.

  4. Click New Item to open the Add a document dialog box.

  5. Click Browse to open the Choose File to Upload dialog box.

  6. Assuming the data connection is saved in its default location, click Libraries, click Documents, and then double-click My Data Sources.

  7. Select the ODC file that you want to upload, and then click Open.

  8. In the Add a document dialog box, click OK.

    A Data Connections form opens.

  9. In the Data Connections form, specify the following settings:

    • In the Content Type section, confirm that Office Data Connection File is selected.

    • In the Name box, keep or change the file name of the ODC file.

    • In the Title box, keep or change the title of the ODC file.

    • In the Description box, type a description of the data connection.

    • In the Keywords box, type one or more words or phrases. This information is used by search queries to discover the data connection.

    Then click Save.

    The data connection is added to the library. Repeat this procedure for each data connection that you want to share.

See also

Share data connections by using Excel and Excel Services (SharePoint Server 2013)
Data sources supported in Excel Services (SharePoint Server 2013)


Share a SQL Server data connection using Excel Services (SharePoint Server 2013)
See also

Published: October 16, 2012

Summary: Learn how to use Excel to create and share connections to SQL Server data that people can use to create data models, reports, scorecards, and dashboards.

Applies to: SharePoint Server 2013 Enterprise

You can use Excel to create connections to databases such as SQL Server, and then share those connections with others. When you can upload a data connection to an Excel Services trusted data connection library, the data connection is available for you and others to use to create data models, reports, scorecards, and dashboards. Depending on the particular data source that is used, people can easily refresh data in Excel Services workbooks so that the most current information is displayed.

In this article:

  • Step 1: Use Excel to create connections to SQL Server data

  • Step 2: Upload data connections to SharePoint Server

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this task, review the following information about prerequisites:

  • You must be using Excel 2013 and SharePoint Server 2013.

  • Excel Services must be configured to include a trusted data connections library and a trusted documents library. Ideally, you'll have a Business Intelligence Center site configured that you can use for your data connections and workbooks. For more information, see Configure a Business Intelligence Center in SharePoint Server 2013.

  • You must have at least Contribute permissions assigned in SharePoint Server.

  • You will need information from a SharePoint administrator about how data authentication is configured for the databases your organization uses. This can affect how you connect to different data sources.

  • If you plan to publish workbooks that contain data models to SharePoint Server, Excel Services must be configured to support data models. For more information, see Configure Excel Services in SharePoint Server 2013.

Step 1: Use Excel to create connections to SQL Server data

You can use Excel to create a connection one or more tables that are stored in SQL Server. This kind of connection is an Office Data Connection (ODC) file that can be used to create reports, scorecards, and dashboards by using applications such as Excel.

To create a SQL Server tabular data connection by using Excel

  1. In Excel, on the Data tab, in the Get External Data group, click From Other Sources, and then select From SQL Server.

    The Data Connection Wizard opens.

  2. On the Connect to Database Server page, in the Server name box, specify the name of the server where the SQL Server data that you want to use resides. Do not click Next yet.

  3. In the Log on credentials section, take one of the following steps:

    • If your organization is using Windows Authentication, choose Use Windows Authentication, and then choose the Next button.

    • If your organization is using specific user credentials, choose Use the following User Name and Password, specify an appropriate user name and password, and then choose the Next button.

  4. On the Select Database and Table page, in the Select the database that contains the data that you want list, select the database that you want to use. Do not click Next yet.

  5. On the Select Database and Table page, take one of the following steps:

    • To create a connection that uses a single table, select Connect to a specific table. Select the table that you want to use, and then click Next.

    • To create a connection that uses more than one table, select both Connect to a specific table and Enable selection of multiple tables. Select the tables that you want to use, click Select Related Tables, and then click Next.

  6. On the Save Data Connection File and Finish page, take the following steps:

    1. In the File Name box, keep or change the default file name.

    2. In the Description box, type a brief description for the data connection.

    3. In the Friendly Name box, keep the default name or type a new name for file.

    4. In the Search Keywords box, type some words or phrases that will help users find the data connection when it is published to SharePoint Server.

    5. Next to Excel Services, click Authentication Settings…, and then take one of the following steps:

      • If you want this connection to use Windows Authentication or the Effective User Name feature, select Use the authenticated user's account, and then click OK.

      • If you want this connection to use Secure Store Service, select Use a stored account. In the Application ID box, specify the Secure Store target application ID, and then click OK.

      • If Excel Services is configured to use the unattended service account, select None, and then click OK.

      Important:

      If you do not know which option to choose, contact a SharePoint administrator.

    6. Click Finish to close the Save Data Connection File and Finish page.

  7. On the Import Data page, click Only Create Connection, and then click OK.

  8. Repeat steps 1-7 until you have created all the data connections that you want.

  9. Close Excel.

By default, the data connection is saved in the My Data Sources folder in the Documents library on your computer.

Step 2: Upload data connections to SharePoint Server

After data connections are created, the next step is to upload it to a data connection library. We recommend that you use a Business Intelligence Center site to store and manage business intelligence content, such as data connections.

Note:

If you are not using a Business Intelligence Center site, make sure that you use a data connection library that is specified as a trusted location in Excel Services. For more information, see Manage Excel Services trusted data connection libraries (SharePoint Server 2013).

To upload a data connection to SharePoint Server

  1. Open a web browser and navigate to the SharePoint site that contains the data connection library that you want to use.

    If you are using a Business Intelligence Center, the website address (URL) resembles http://servername/sites/bicenter.

  2. Click Site Contents to view the lists and libraries that are available for that site.

  3. Click Data Connections to open that library.

  4. Click New Item to open the Add a document dialog box.

  5. Click Browse to open the Choose File to Upload dialog box.

  6. Assuming the data connection is saved in its default location, click Libraries, click Documents, and then double-click My Data Sources.

  7. Select the ODC file that you want to upload, and then click Open.

  8. In the Add a document dialog box, click OK.

    A Data Connections form opens.

  9. In the Data Connections form, specify the following settings:

    • In the Content Type section, confirm that Office Data Connection File is selected.

    • In the Name box, keep or change the file name of the ODC file.

    • In the Title box, keep or change the title of the ODC file.

    • In the Description box, type a description of the data connection.

    • In the Keywords box, type one or more words or phrases. This information is used by search queries to discover the data connection.

    Then click Save.

    The data connection is added to the library. Repeat this procedure for each data connection that you want to share.

See also

Share data connections by using Excel and Excel Services (SharePoint Server 2013)
Data sources supported in Excel Services (SharePoint Server 2013)


Share an OLE DB or ODBC connection using Excel Services (SharePoint Server 2013)
See also

Published: December 18, 2012

Summary: Learn how to use Excel to create and share OLE DB or ODBC connections that people can use to create data models, reports, scorecards, and dashboards.

Applies to: SharePoint Server 2013 Enterprise

You can use Excel to create OLE DB or ODBC connections and then share those connections with others. An OLE DB or ODBC connection is useful for connecting to data sources, such as Excel workbooks, legacy databases, or non-Microsoft databases. When you can upload a data connection to an Excel Services trusted data connection library, the data connection is available for you and others to use to create data models, reports, scorecards, and dashboards. Depending on the particular data source that is used, people can easily refresh data in Excel Services workbooks so that the most current information is displayed.

In this article:

  • Step 1: Use Excel to create OLE DB or ODBC data connections

  • Step 2: Upload data connections to SharePoint Server

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this task, review the following information about prerequisites:

  • You must be using Excel 2013 and SharePoint Server 2013.

  • Excel Services must be configured to include a trusted data connections library and a trusted documents library. Ideally, you'll have a Business Intelligence Center site configured that you can use for your data connections and workbooks. For more information, see Configure a Business Intelligence Center in SharePoint Server 2013.

  • You must have at least Contribute permissions assigned in SharePoint Server.

  • You will need information from a SharePoint administrator about how data authentication is configured for the databases your organization uses. This can affect how you connect to different data sources.

  • You will need information about the data source that you want to use. In particular, you must know the data source name, user name, and password to connect to the data source.

  • If you plan to publish workbooks that contain data models to SharePoint Server, Excel Services must be configured to support data models. For more information, see Configure Excel Services in SharePoint Server 2013.

Step 1: Use Excel to create OLE DB or ODBC data connections

You can use Excel to create an OLE DB or ODBC connection. This enables you to connect to lots of different data sources. Examples include Microsoft SQL Server, Microsoft Access, and Oracle databases, although there are many others. You can create an OLE DB or ODBC data connection by using one of several methods:

  • You can create a connection by using the Data Connection Wizard in Excel. (This is the recommended method to use.)

  • You can create a connection by using a Microsoft Query Wizard in Excel.

Use the following procedures to create OLE DB or ODBC data connections

To create a connection by using the Data Connection Wizard in Excel

  1. In Excel, on the Data tab, in the Get External Data group, click From Other Sources, and then select From Data Connection Wizard.

    The Data Connection Wizard opens.

  2. In the What kind of data source do you want to connect to? list, choose a data source, and then click Next.

  3. Depending on the kind of data source that you selected, specify the necessary information for that data source.

    Tip:

    The information that you specify varies according to the data source. For example, a Data Feed data source requires a link or location to a data feed and logon credentials, whereas an Excel workbook data source requires you to locate where the workbook is stored. Contact a database administrator for specific details regarding the connection that you want to create.

  4. On the Select Database and Table page, in the Select the database that contains the data that you want list, select the database that you want to use. Do not click Next yet.

  5. On the Select Database and Table page, select the table (or tables) that you want to use, and then click Next.

  6. On the Save Data Connection File and Finish page, take the following steps:

    1. In the File Name box, keep or change the default file name.

    2. In the Description box, type a brief description for the data connection.

    3. In the Friendly Name box, keep the default name or type a new name for file.

    4. In the Search Keywords box, type some words or phrases that will help users find the data connection when it is published to SharePoint Server.

    5. Next to Excel Services, click Authentication Settings….

    6. Select None, and then click OK.

    7. Click Finish to close the Save Data Connection File and Finish page.

  7. On the Import Data page, click Only Create Connection, and then click OK.

  8. Repeat steps 1-7 until you have created all the data connections that you want.

If cannot create the connection that you want by using the Data Connection Wizard in Excel, you can try to create the connection by using a Microsoft Query wizard. This is useful for connecting to older databases. However, the connection that you create might not be supported in Excel Services. Contact a SharePoint administrator to verify that the connection that you create is supported so that people can refresh data in Excel Services files. The following procedure describes how to create a connection by using a Microsoft Query wizard.

To create a connection by using a Microsoft Query wizard in Excel

  1. In Excel, on the Data tab, in the Get External Data group, click From Other Sources, and then select From Microsoft Query.

    The Choose Data Source dialog box appears.

  2. Use the Databases, Queries, or OLAP Cubes tab to specify the data source that you want to use.

    Tip:

    The information that you specify varies according to the data source. For example, if you select an Access database or an Excel file, you'll be prompted to navigate to the database or file on your computer. Or, if you choose to use a data source that is not listed, you'll be prompted to create a data source and then specify the kind of data source, location, and credentials to connect to it. Contact a database administrator for specific details regarding the connection that you want to create.

  3. On the Import Data page, click Only Create Connection, and then click OK.

  4. Repeat steps 1-3 until you have created all the data connections that you want.

By default, the data connection is saved in the My Data Sources folder in the Documents library on your computer.

Step 2: Upload data connections to SharePoint Server

After data connections are created, the next step is to upload it to a data connection library. We recommend that you use a Business Intelligence Center site to store and manage business intelligence content, such as data connections.

Note:

If you are not using a Business Intelligence Center site, make sure that you use a data connection library that is specified as a trusted location in Excel Services. For more information, see Manage Excel Services trusted data connection libraries (SharePoint Server 2013).

To upload a data connection to SharePoint Server

  1. Open a web browser and navigate to the SharePoint site that contains the data connection library that you want to use.

    If you are using a Business Intelligence Center, the website address (URL) resembles http://servername/sites/bicenter.

  2. Click Site Contents to view the lists and libraries that are available for that site.

  3. Click Data Connections to open that library.

  4. Click New Item to open the Add a document dialog box.

  5. Click Browse to open the Choose File to Upload dialog box.

  6. Assuming the data connection is saved in its default location, click Libraries, click Documents, and then double-click My Data Sources.

  7. Select the ODC file that you want to upload, and then click Open.

  8. In the Add a document dialog box, click OK.

    A Data Connections form opens.

  9. In the Data Connections form, specify the following settings:

    • In the Content Type section, confirm that Office Data Connection File is selected.

    • In the Name box, keep or change the file name of the ODC file.

    • In the Title box, keep or change the title of the ODC file.

    • In the Description box, type a description of the data connection.

    • In the Keywords box, type one or more words or phrases. This information is used by search queries to discover the data connection.

    Then click Save.

    The data connection is added to the library. Repeat this procedure for each data connection that you want to share.

See also

Share data connections by using Excel and Excel Services (SharePoint Server 2013)
Data sources supported in Excel Services (SharePoint Server 2013)


Share workbooks by using Excel Services (SharePoint Server 2013)
See also

Published: April 23, 2013

Summary: Excel Services enables you to share Excel content with other people using SharePoint Server. You can share an entire workbook, or choose to display only part of a workbook.

Applies to: SharePoint Server 2013 Enterprise

Excel Services in SharePoint Server 2013 enables you to share all or parts of an Excel workbook with other people in a central location. When you publish a workbook to SharePoint Server, you can choose between several browser view options (such as worksheet view and gallery view). You can also choose to display Excel content in a special SharePoint Web Part known as the Excel Web Access Web Part. Read this article to learn how to share workbooks using Excel Services.

In this article

  • Before you begin

  • Share workbooks using Excel Services

    • Define named items in a workbook

    • Specify how you want a workbook to be displayed

    • Publish a workbook

    • Display Excel content in an Excel Web Access Web Part

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this task, review the following information about prerequisites:

  • You must be using Excel and SharePoint Server 2013.

  • Excel Services must be configured to include a trusted data connections library and a trusted document library. Ideally, you'll have a Business Intelligence Center site configured that you can use for your data connections and workbooks. For more information, see Configure a Business Intelligence Center in SharePoint Server 2013.

  • You will need information from a SharePoint administrator about how data authentication is configured for the databases your organization uses. This can affect how you connect to different data sources.

  • You must have at least Contribute permissions assigned to you for the SharePoint library where you plan to publish the workbook.

  • You should have already created an Excel workbook that contains at least one item, such as a chart, table, PivotChart report, PivotTable report, or range of data.

  • If you plan to publish workbooks that contain data models to SharePoint Server, Excel Services must be configured to support data models. For more information, see Configure Excel Services in SharePoint Server 2013.

  • If you plan to publish a workbook that contains a Power View sheet, SQL Server Reporting Services must be configured in SharePoint integrated mode. For more information, see Install SQL Server BI Features with SharePoint 2013 (SQL Server 2012 SP1).

Share workbooks using Excel Services

Suppose that you have created an Excel workbook that contains information that you want to share with others. Suppose additionally that you might want to display some content in that workbook in multiple locations. Excel Services enables you to do this by following a simple process:

  1. Define one or more named items in the workbook. These items can be charts, tables, PivotChart reports, PivotTable reports, ranges of data, and so on.

  2. Choose browser view options for the workbook. You can choose between worksheet view or gallery view.

  3. Publish the workbook to a SharePoint library. Ideally, you'll use a library such as a Document library in a Business Intelligence Center site.

  4. (This is optional.) Display all or part of an Excel workbook in an Excel Web Access Web Part.

The following sections describe how to perform the steps to share a workbook by using Excel Services.

Define named items in a workbook

Defining named items is not an absolute requirement for sharing a workbook by using Excel Services. However, as a best practice, we recommend that you define named items in Excel. Doing this can avoid confusion later, especially if you want to display a single item in a SharePoint Web Part (instead of displaying the whole workbook in the Web Part). A named item can be a chart, table, a PivotChart report, a PivotTable report, a slicer, a Timeline control, a worksheet, or even a range of data in a worksheet.

As you create items, such as PivotChart reports, PivotTable reports, slicers, Timeline controls, and so on, each item is given a name by default in Excel. For example, suppose that you create a PivotTable report on Sheet1 in Excel. By default, that PivotTable report will be labeled as PivotTable1. Now suppose that you add a PivotChart report to that same worksheet. Its default name will be PivotChart1. If you open Sheet2 and create a PivotTable report on that worksheet, its default name will be PivotTable1. It's easy to become confused between PivotTable1 on Sheet1 and PivotTable1 on Sheet2. Defining each of these items as named items using unique names can avoid this confusion. Use the following procedure to define named items in Excel.

To define named items in a workbook

  1. In an Excel workbook, identify a worksheet, chart, table, range of data, or other element that you want to define as a named item. Select the range of cells that contains the item (or items) that you want to include in the named item.

    To define the whole worksheet as a named item, choose an empty cell in the worksheet, and then press CTRL+A.

  2. On the Formulas tab, in the Defined Names group, choose Define Name to open the New Name dialog box.

  3. In the Name box, type a name for the item. Choose a unique name that won't be repeated in the workbook.

  4. In the Scope list, choose Workbook.

  5. Use the Refers to box to confirm or edit the range of selected cells.

  6. Click OK.

  7. Repeat steps 1-6 for each item that you want to define as a named item.

Specify how you want a workbook to be displayed

When you use Excel Services to share a workbook, you can choose how you want the workbook to be displayed in a browser window. Specifically, you can choose from the following browser view options:

  • Worksheet view. This option causes a whole worksheet to be displayed in a browser window, such as it is displayed in Excel.

    The following image shows an example dashboard rendered in worksheet view.

    Example dashboard created using a Data Model

  • Gallery view. This option causes one item, such as a PivotChart report or a PivotTable report, to be displayed prominently in the center part of the browser window. Slicers, filters, and Timeline controls are displayed along the left-hand side of the browser window. Additional items, such as other PivotChart reports or PivotTable reports, are displayed as thumbnail images along the right-hand side of the browser window. In gallery view, people can choose a thumbnail image to change which item is featured in the center part of the browser window.

    The following image shows the same example dashboard rendered in gallery view.

    Example dashboard shown in gallery view

Use one of the following procedures to specify browser view options for the workbook.

To configure the workbook to display using worksheet view

  1. In Excel, on the File tab, click Browser View Options.

  2. On the Show tab, use the list to select Sheets, select the worksheets that you want to display, and then click OK

  3. Save the workbook, and then close Excel.

To configure the workbook to display using gallery view

  1. In Excel, on the File tab, click Browser View Options.

  2. On the Show tab, use the list to select Items in the Workbook.

  3. Select the named items that you want to display, and then click the Parameters tab.

  4. If the workbook contains slicers or a Timeline control, click Add, select slicers or Timeline controls that you want to display, and then click OK.

  5. Click OK to close the Browser View Options dialog box.

  6. Then close Excel.

After you have specified browser view options for a workbook, the next step is to publish the workbook to SharePoint Server.

Publish a workbook

When you publish a workbook you add it to a SharePoint library, such as a Document library in a Business Intelligence Center site. The location that you use must be specified as a trusted location for Excel Services. For more information, see Administer Excel Services in SharePoint Server 2013.

To publish a workbook to a SharePoint library

  1. Open a web browser.

  2. In the address line, type the address to a library in SharePoint Server. For example, you might use a SharePoint address that resembles http://servername/sites/bicenter/documents or http://servername/SharePointsitename/documentlibraryname.

    Note:

    To specify a location as a trusted location in Excel Services, see Manage Excel Services trusted file locations (SharePoint Server 2013).

  3. In the library that you selected, choose + New Document to open the Add a Document dialog box.

  4. Choose Browse, and then use the Choose File to Upload dialog box to select the workbook that you want to publish. Then choose Open.

  5. In the Add a document dialog box, choose OK. The workbook is added to the library.

Now that you have published a workbook to a SharePoint library, you can display content from that workbook in an Excel Web Access Web Part.

Display Excel content in an Excel Web Access Web Part

Excel Services in SharePoint Server 2013 includes a special SharePoint Web Part called the Excel Web Access Web Part. This Web Part enables you to share all or part of an Excel workbook in its own Web Part on a SharePoint Web Part page. You can display a single item that is defined as a named item, or you can display the whole workbook in that Web Part.

The following procedures describe how to add an Excel Web Access Web Part to a SharePoint page and then display content in the Web Part.

To add an Excel Web Access Web Part to a SharePoint site

  1. Begin with a SharePoint page open for editing.

  2. In a zone on the page, choose the hypertext that says Add a Web Part.

    Panes showing available categories and kinds of Web Parts appear near the top of the page.

  3. In the Categories pane, choose Business Data. Then, in the Parts pane, choose Excel Web Access.

  4. Choose Add to add the Web Part to the page. Keep the page open for editing.

The next step is to connect a workbook to an Excel Web Access Web Part.

To display Excel content in an Excel Web Access Web Part

  1. Begin with a SharePoint page open for editing and an empty Excel Web Access Web Part added to the page.

    In the empty Excel Web Access Web Part, in the Select a Workbook section, click the hypertext that says Click here to open the tool pane. The tool pane opens.

  2. In the Workbook Display section in the Workbook text box, specify the web site address (URL) for the workbook. If you do not know the URL, click the Browse button, navigate to the library where the workbook was published, select the workbook that you want to use, and then click Insert.

  3. (This is optional.) To display a single item, such as a chart, table, PivotChart report, or PivotTable report, in the Named Item box, type the name of the item. This causes only that item to be displayed in the Web Part, instead of displaying the whole workbook.

  4. At the bottom of the tool pane, click OK.

The workbook is now displayed in the Web Part. If you want, you can proceed to specify navigation and interactivity settings for the Excel Web Access Web Part.

To specify navigation and interactivity settings for a workbook displayed in an Excel Web Access Web Part

  1. Begin with a SharePoint page open for editing. In the upper-right corner of the Excel Web Part, choose the down arrow to open the Web Part menu, and then choose Edit Web Part. The Excel Web Part tool pane opens.

  2. In the Toolbar and Title Bar section and in the Navigation and Interactivity section, select the properties that you want to enable. If you want to disable a property, clear its check box.

  3. At the bottom of the tool pane, choose OK to apply your changes and close the tool pane.

  4. In the SharePoint site, click Stop Editing to save your changes.

See also

Data sources supported in Excel Services (SharePoint Server 2013)
BI capabilities in Excel and Excel Services (SharePoint Server 2013)


Create Dashboards by using PerformancePoint Services (SharePoint Server 2013)

Summary: Learn how to create dashboards by using the PerformancePoint Dashboard Designer tool in SharePoint Server 2013.

Applies to: SharePoint Server 2013

TechNet articles about creating dashboards by using PerformancePoint Services in SharePoint

The following articles about creating dashboards by using PerformancePoint Services are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

What's new icon (box) Content | Description
Create data connections by using PerformancePoint Services (SharePoint Server 2013) | Learn how to create data connections from Dashboard Designer to external data sources.
Create scorecards by using Dashboard Designer | Use PerformancePoint Dashboard Designer to create scorecards that show performance metrics.
Create reports by using Dashboard Designer (SharePoint Server 2013) | Using PerformancePoint Dashboard Designer, you can create many kinds of reports for your dashboard. Examples of report types include analytic charts and grids, Excel Services reports, strategy maps, and many other kinds of reports.
Create and assemble a dashboard page by using Dashboard Designer (SharePoint Server 2013) | Learn how to create and assemble a dashboard page by using PerformancePoint Dashboard Designer in SharePoint Server 2013.


Create data connections by using PerformancePoint Services (SharePoint Server 2013)

Summary: Learn how to create data connections from Dashboard Designer to external data sources.

Applies to: SharePoint Server 2010 Enterprise

Data sources defined in PerformancePoint Dashboard Designer are stored in a trusted data connection library on SharePoint Server 2013. A trusted data connection library is a document library that you have determined as safe. It restricts using the data source files, but still lets them be read. Administrators can manage data connections on the server by creating more than one data connection library. If a user updates a data source connection in the document library, the information is shared and updated when a workspace file is opened in Dashboard Designer.

TechNet articles about data connections in PerformancePoint Services in SharePoint

The following articles about creating data connections in PerformancePoint Services are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content
SharePoint logo | Create a connection from Dashboard Designer to an Analysis Services data cube by using PerformancePoint Services
 | Create a PowerPivot data connection (PerformancePoint Services in SharePoint Server 2013)
 | Create a connection from Dashboard Designer to a SharePoint 2013 list by using PerformancePoint Services
 | Create an Excel Services data connection by using PerformancePoint Services
 | Create a connection from Dashboard Designer to a SQL Server table by using PerformancePoint Services
 | Create an Excel Workbook data connection by using PerformancePoint Services


Create a connection from Dashboard Designer to an Analysis Services data cube by using PerformancePoint Services

Summary: Learn how to set up a data connection from Dashboard Designer to an Analysis Services data cube.

Applies to: SharePoint Server 2013

In PerformancePoint Services, the security settings for data sources are stored in each data source. For Analysis Services, you have the choice of three authentication options: using the Unattended Service Account, using credentials stored in a Secure Store target application, using Per-User Identity (which requires either the Kerberos protocol or setting the EffectiveUserName property in PerformancePoint Application Settings in Central Administration.)

Note:

PerformancePoint Services accesses external data sources by using a delegated Windows identity. Consequently, external data sources must reside within the same domain as the SharePoint Server 2013 farm. If external data sources do not reside within the same domain, authentication to the external data sources fails. For more information, see Planning considerations for services that access external data sources.

Create an Analysis Services data source

Create an Analysis Services data source either by entering the name of the Analysis Services server, database, and cube name, or by typing a connection string and the cube name in Dashboard Designer.

Tip:

We recommend that you select your authentication method before you specify your server connection.

To Create an Analysis Services data source

  1. Click the Create tab, and then click Data Source.

  2. In the Category pane of the Select a Data Source Template dialog box, click Multidimensional and then click Analysis Services. Click OK.

  3. In the left navigation pane (workspace browser), type the name of your data source.

  4. In the Data Source Settings section, select the method by which to authenticate to the data source.

  5. In the Formatting Dimension drop-down list, select desired dimension formatting needed for the report.

  6. In the Cache Lifetime drop-down box, type the refresh rate (in minutes) for the cache. Data from this data source will update at this interval.

  7. In the center pane, click the Editor tab. In the Connection Settings section, select the method by which to connect to the data source.

    To use a standard connection:

    1. Select Use standard connection

    2. Type the full path for the server to which you want to connect. This populates the options in the database list.

    3. In the Database box, select a database name.

    4. (Optional) In the Roles box, type the name of the role, such as an administrator or database role. To specify multiple roles, type the names of the roles and separate them with commas.

    To use a specific connection string:

    1. Select Use the following connection.

    2. Type the connection string to the server, including the cube name to which you want to connect.

    3. From the Cube drop-down list, select the specific cube that you want to use as the data source in the database.

  8. Click Test Connection to confirm that the connection is configured correctly.

  9. From the Data Source Settings box, select one of the following Authentication methods:

    • Unattended Service Account If you select this method, all users connect by using the Unattended Service Account that was defined for the PerformancePoint shared service when they access the data source.

    • Use a stored account Enter the Application ID of a secure store target application. If you select this method, all users connect by using the credentials from the specified Secure Store target application when they access the data source.

    • Per-user identity If you select this option, the current user's identity is used to access the data source. Per-User Identity requires either the Kerberos protocol or setting the EffectiveUserName property in PerformancePoint Application Settings in Central Administration.

  10. Click Test Data Source to confirm your connection is configured correctly.


Create a connection from Dashboard Designer to a SharePoint 2013 list by using PerformancePoint Services

Summary: Learn how to set up a data connection from Dashboard Designer to SharePoint list.

Applies to: SharePoint Server 2013

Data from a SharePoint list can be used as a data source in PerformancePoint Services. The data from the SharePoint list can only be read by using PerformancePoint Services. Any editing of the data must be done from SharePoint Server. You can connect to any kind of SharePoint list.

Note:

PerformancePoint Services accesses external data sources by using a delegated Windows identity. Consequently, external data sources must reside within the same domain as the SharePoint Server 2013 farm. If external data sources do not reside within the same domain, authentication to the external data sources fails. For more information, see Planning considerations for services that access external data sources.

Create a SharePoint list data connection

In PerformancePoint Services, the security settings for data sources are stored in each data source. For SharePoint lists, you have the choice of three authentication options: using the Unattended Service Account, using credentials stored in a Secure Store target application, or using Per-User Identity. Per-User Identity requires the Kerberos protocol.

Tip:

We recommend that you select your authentication method before you specify your server connection.

To create a data source connection to a SharePoint list

  1. Click the Create tab, and then click Data Source.

  2. In the Category pane of the Select a Data Source Template dialog box, click Tabular List and then click SharePoint list. Click OK.

  3. In the left navigation pane (workspace browser), type a name for your data source.

  4. In the center pane, click the Editor tab. In the Data Source Settings section, select the method on which to authenticate to the data source.

  5. In the Cache Lifetime list, type the refresh rate (in minutes) for the cache. Data from this data source will update according to the interval you specify.

  6. In the Connection Settings section, type the URL to the SharePoint site.

  7. In the SharePoint Site List list, select a List collection.

  8. In the List list, select the SharePoint list that you want from the collection.

  9. From the Data Source Settings box, select one of the following Authentication methods:

    • Unattended Server Account If you select this method, all users connect by using the Unattended Service Account that was defined for the PerformancePoint shared service when they access the data source.

    • Use a stored account Enter the Application ID of a secure store target application. If you select this method, all users connect by using the credentials from the specified Secure Store target application when they access the data source.

    • Per-user identity If you select this option, the current user's identity is used to access the data source. Per-User Identity requires the Kerberos protocol.

  10. Click Test Data Source to confirm that the connection is configured correctly.


Create an Excel Services data connection by using PerformancePoint Services

Summary: Learn how to set up a data connection from Dashboard Designer to an Excel Services file.

Applies to: SharePoint Server 2013

A data source connection can be made to data within Excel files that have been published to Excel Services on a SharePoint site. Published parameter values can be modified from within PerformancePoint Services. This is useful when a parameter is an input to the value of a published cell. This could be used in a KPI, for example, and enable the dynamic change of that cell value from PerformancePoint Services.

Important:

PerformancePoint Services accesses external data sources by using a delegated Windows identity. Consequently, external data sources must reside within the same domain as the SharePoint Server 2013 farm. If external data sources do not reside within the same domain, authentication to the external data sources fails. For more information, see Planning considerations for services that access external data sources.

Create an Excel Services data source connection

In PerformancePoint Services the security settings for data sources are stored in each data source. For Excel Services workbooks, you have the choice of three authentication options: using the Unattended Service Account, using credentials stored in a Secure Store target application, or using Per-User Identity. Per-User Identity requires the Kerberos protocol.

Tip:

We recommend that you select your authentication method before you specify your server connection.

Security

You cannot connect to an Excel Services data source when the site or library that contains the workbook you are trying to connect to is set to Anonymous Access.

To Create an Excel Services data source connection

  1. Start Dashboard Designer.

  2. Click the Create tab, and then click Data Source.

  3. In the Category pane of the Select a Data Source Template dialog box, click Tabular List and then click Excel Services. Click OK.

  4. In the left navigation pane (workspace browser), type a name for your data source.

  5. In the center pane, click the Editor tab. In the Data Source Settings section, select the method by which to authenticate to the data source.

  6. In the Refresh Interval box, enter the duration in minutes for the data to refresh.

  7. In the Connection Settings section, type the URL of the SharePoint site.

  8. From the Document Library list, select the SharePoint document library where the workbook is located.

  9. From the Excel Workbook list, select the workbook that you want.

  10. In the Item Name list, select a Named Range or table. Only one Named Range or Table is supported per Excel Services data source.

    Important:

    If you connect to a Office Excel 2007 workbook as a data source, you must type the Item name; it will not appear in the drop-down list.

    Tip:

    Your selected Named Range or Table can be seen later on the View tab. A column from that Item can be set as a Time Dimension and configured from the Time tab.

  11. From the Data Source Settings box, select one of the following Authentication methods:

    • Unattended Server Account If you select this method, all users connect by using the Unattended Service Account that was defined for the PerformancePoint shared service when they access the data source.

    • Use a stored account Enter the Application ID of a secure store target application. If you select this method, all users connect by using the credentials from the specified Secure Store target application when they access the data source.

    • Per-user identity If you select this option, the current user's identity is used to access the data source. Per-User Identity requires the Kerberos protocol.

  12. Click Test Data Source to confirm your connection is configured correctly.


Create a connection from Dashboard Designer to a SQL Server table by using PerformancePoint Services

Summary: Learn how to set up a data connection from Dashboard Designer to a SQL Server table.

Applies to: SharePoint Server 2013

A SQL Server table or view can be used as a data source by PerformancePoint Services. Only tables and views can be used as SQL Server data sources. SQL database data cannot be modified from the Dashboard Designer.

Important:

PerformancePoint Services accesses external data sources by using a delegated Windows identity. Consequently, external data sources must reside within the same domain as the SharePoint Server 2013 farm. If external data sources do not reside within the same domain, authentication to the external data sources fails. For more information, see Planning considerations for services that access external data sources in Services architecture planning (SharePoint Server 2010).

In this article:

  • Create a SQL Server table data source connection

Create a SQL Server table data source connection

In PerformancePoint Services the security settings for data sources are stored in each data source. For SQL Server tables, you have the choice of three authentication options: using the Unattended Service Account, using credentials stored in a Secure Store target application, or by using Per-User Identity. Per-User Identity requires the Kerberos protocol.

Tip:

We recommend that you select your authentication method before you specify your server connection.

To Create a SQL Server table data source connection

  1. Start Dashboard Designer.

  2. Click the Create tab, and then click Data Source.

  3. In the Category pane of the Select a Data Source Template dialog box, click Tabular List and then click SQL Server table. Click OK.

  4. In the left navigation pane (workspace browser), type a name for your data source.

  5. In the center pane, click the Editor tab. In the Data Source Settings section, select the method by which to authenticate to the data source.

  6. In Refresh Interval, specify the duration (in minutes) before data is refreshed from the source.

  7. In the Connection Settings section, select the method by which to connect to the data source.

    To use a standard connection:

    1. Select Use standard connection.

    2. Type the full path for the server to which you want to connect. This populates the options in the database list.

    3. In the Database box, select a database name.

    To use a specific connection string:

    1. Select Use the following connection.

    2. Type a connection string with the full path of the server and database to which you want to connect.

    3. In the Table list, select the specific table that you want to use.

  8. Click Test Data Source to confirm that the connection is configured correctly.

  9. In the Workspace Browser, right-click the data source, and then click Save.

    Note:

    If the SQL Server table that you select for the data connection contains a date/time column, you might receive an error message that indicates that the data source has not been saved. This can occur even though the data source has indeed been saved. This is a known issue.

  10. From the Data Source Settings box, select one of the following Authentication methods:

    • Unattended Server Account If you select this method, all users connect by using the Unattended Service Account that was defined for the PerformancePoint shared service when they access the data source.

    • Use a stored account Enter the Application ID of a secure store target application. If you select this method, all users connect by using the credentials from the specified Secure Store target application when they access the data source.

    • Per-user identity If you select this option, the current user's identity is used to access the data source. Per-User Identity requires the Kerberos protocol.

  11. Click Test Data Source to confirm your connection settings.


Create an Excel Workbook data connection by using PerformancePoint Services

Summary: Learn how to set up a data connection from Dashboard Designer to an Excel workbook.

Applies to: SharePoint Server 2013

Create an Excel Workbook data connection (import a workbook)

An existing Excel file can be imported as an Excel workbook data source in PerformancePoint Services. Once the data source is created, an internal copy of the Excel file is used and all modifications to the data are done from the Edit tab in Dashboard Designer. The original Excel file is disconnected and independent from PerformancePoint Services. In PerformancePoint Services, security settings for data sources are stored in each data source. However, when you create a data source connection to an Excel workbook, a copy is imported and stored within PerformancePoint and is no longer an external data source.

To Create an Excel Workbook data connection (import a workbook)

  1. Click the Create tab, and then click Data Source.

  2. In the Category pane of the Select a Data Source Template dialog box, click Tabular List and then click Import from Excel Workbook. Click OK.

  3. In the left navigation pane (workspace browser), type the name of your data source.

  4. In the center pane, click Import.

Important:

Excel Web App workbooks that use the Click-to-Run method cannot be used as a data source in PerformancePoint Services.


Create a PowerPivot data connection (PerformancePoint Services in SharePoint Server 2013)

Published: October 30, 2012

Summary: Learn how to create a data connection to a PowerPivot data source when creating a dashboard in PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

PerformancePoint Services in SharePoint Server 2013 supports PowerPivot models as a data source. You can use data in a PowerPivot model and build interactive dashboards using PerformancePoint Services features such as Key Performance Indicators (KPIs), Scorecards, Analytic Charts, Analytic Grids and Filters.

Note:

PerformancePoint Services accesses external data sources by using a delegated Windows identity. Consequently, external data sources must reside within the same domain as the SharePoint Server 2013 farm. If external data sources do not reside within the same domain, authentication to the external data sources will fail. For more information, see Planning considerations for services that access external data sources.

Create a PowerPivot data source connection

To use Power Pivot as a data source within PerformancePoint Services dashboard, you must have PerformancePoint Services activated on a SharePoint Server 2013 farm and have Power Pivot for SharePoint 2013 installed. Once a Power Pivot model is created, it must be uploaded to a SharePoint Server site that has Power Pivot for SharePoint enabled.

Important:

You must apply the hotfix detailed in the Microsoft Knowledge Base article When you run a .NET Framework 2.0 based application, a System.AccessViolationException exception occurs, or a deadlock occurs on two threads in an application domain (Article ID 975954) in order to use Power Pivot as a data source in PerformancePoint Services.

Important:

You must have ADOMD.net V11 installed on the server on which you are authoring the Dashboard in order to access a Power Pivot workbook as a data source.

In PerformancePoint Services, the security setting for data sources is stored in each data source. By using PowerPivot as a data source, you can authenticate either using an unattended service account or a Per-user identity. Per-user identity requires Kerberos protocol.

Security

You cannot authenticate to a PowerPivot data source by selecting the Unattended Service Account and add authenticated user name in connection string option.

Important:

Time Intelligence is not supported for PowerPivot data sources.

To Create a PowerPivot data source connection

  1. Click the Create tab, and then click Data Source.

  2. In the Category pane of the Select a Data Source Template dialog box, click Multidimensional and then click Analysis Services. Click OK.

  3. In the left navigation pane (workspace browser), type the name of your data source.

  4. In the center pane, click the Editor tab. In the Connection Settings section, select Use the following connection.

  5. Type the connection string to the PowerPivot data source by using the following format: PROVIDER=MSOLAP;DATA SOURCE=http://contoso/Documents/PowerPivot_Sample.xlsx

  6. Select the cube from the drop-down menu. The cube name for a PowerPivot model will always be Sandbox.

  7. In the Data Source Settings section, select the method on which to authenticate to the data source.

  8. From the Formatting Dimension list, select desired dimension formatting needed for the report.

  9. From the Cache Lifetime list, type the refresh rate (in minutes) for the cache. Data from this data source will update at this interval.

  10. Click Test Connection to confirm that the connection is configured correctly.


Create scorecards by using Dashboard Designer

Summary: Use PerformancePoint Dashboard Designer to create scorecards that show performance metrics.

Applies to: SharePoint Server 2013

By using PerformancePoint Dashboard Designer, you can create lots of scorecards for your dashboards. Scorecards are dashboard items that show performance for one or more metrics. Scorecards compare actual results to specified goals and express the results by using graphical indicators.

A scorecard resembles a table that usually has Target and Actual value columns and one or more key performance indicators (KPIs).

When you create a scorecard by using Dashboard Designer, you can select from several different methods:

  • You can use a wizard to set up a basic scorecard. This is useful when you are new to Dashboard Designer and you do not have many existing dashboard items that you can reuse. This method is also useful when want to quickly and easily create a scorecard.

    When you use a wizard to create a scorecard, you start by selecting the kind of data source that will be used by at least one KPI in the scorecard. You use the wizard to create the scorecard, and then you finish configuring the scorecard in the workspace.

  • You can create a blank scorecard and then manually add the KPIs and other items that you want to use in the scorecard. This is useful when you or other dashboard authors have already created one or more KPIs.

Use the resources listed in this topic to create a scorecard by using Dashboard Designer.

TechNet articles about creating scorecards in PerformancePoint Dashboard Designer

This section contains the following articles to help you create and configure scorecards by using Dashboard Designer.

Building blocks Content | Description
Turn on or off the scorecard wizard in Dashboard Designer | Learn how to turn or (or off) the scorecard wizard feature in PerformancePoint Dashboard Designer in SharePoint Server 2013.
Create blank scorecards by using Dashboard Designer (SharePoint Server 2013) | Learn how to create a blank scorecard by using PerformancePoint Dashboard Designer in SharePoint Server 2013.


Turn on or off the scorecard wizard in Dashboard Designer

Summary: Learn how to turn or (or off) the scorecard wizard feature in PerformancePoint Services in SharePoint Server 2013.

Applies to: SharePoint Server 2013

When you use PerformancePoint Dashboard Designer to create scorecards, you typically start by clicking the Create tab in the ribbon. Then, in the Dashboard Items group, you click Scorecard. Depending on how Dashboard Designer is configured, either the Select a Scorecard Template dialog box opens or a blank scorecard opens for editing.

To configure Dashboard Designer to use the Create a Scorecard wizard or to create a blank scorecard every time that you create a scorecard, follow these steps.

To turn on (or off) the Create a Scorecard wizard

  1. In Dashboard Designer, click the Office button to open the Office Backstage view.

  2. Click Designer Options to open the Options dialog box.

  3. On the Personalize tab, select (or clear) the Use wizards to create scorecards check box.

    Tip:

    An alternate method that you can use is to clear the Use wizard to create scorecards check box on the Select a Scorecard Template page of the wizard. Then, the next time that you click Scorecard on the Create tab in the ribbon, a blank scorecard will open for editing.

  4. Click OK to close the Options dialog box.


Create blank scorecards by using Dashboard Designer (SharePoint Server 2013)

Summary: Learn how to create a blank scorecard by using Dashboard Designer in SharePoint Server 2013.

Applies to: SharePoint Server 2013

When you create a blank scorecard by using Dashboard Designer, you create an empty scorecard that has no key performance indicators (KPIs) or other information. Then, you configure the scorecard to add the KPIs and other items that you want to display in the scorecard. You would typically create a blank scorecard when you and other dashboard authors have already created KPIs.

To create a KPI, see Create and configure a KPI by using Dashboard Designer (SharePoint Server 2013).

To create a blank scorecard

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, in the Dashboard Items group, click Scorecard.

  3. Depending on whether Dashboard Designer is configured to use a wizard to create scorecards, one of the following actions occurs:

    • The Select a Scorecard Template dialog box opens.

      If this occurs, select the Blank Scorecard template. Do this by using the following procedure:

      1. In the Select a Scorecard Template dialog box, in the Category section, click Standard.

      2. In the Template section, click Blank Scorecard.

      3. Click OK to close the Select a Scorecard Template dialog box, and then proceed to Step 4.

    • A blank scorecard opens for editing.

      If this occurs, proceed to Step 4.

    Tip:

    You can configure Dashboard Designer to use or not to use a wizard to create scorecards. For more information, see Turn on or off the scorecard wizard in Dashboard Designer.

  4. In the center pane, click the Properties tab.

  5. In the Name box, type the name that you want to use for the scorecard.

  6. (This step is optional.) To specify a location for the scorecard, click the Display Folder button, and then select or create a folder.

  7. In the Workspace Browser, right-click the scorecard, and then click Save.

  8. Proceed to configure the scorecard to add content to it. See Edit scorecards by using Dashboard Designer (SharePoint Server 2013).


Create PerformancePoint scorecards by using a wizard
See also

Summary: Learn how to create a PerformancePoint Services scorecard for your dashboard by using a wizard.

Applies to: SharePoint Server 2013

You can create scorecards for your dashboards by using Dashboard Designer. A scorecard is a report type that shows organizational performance by displaying a collection of key performance indicators (KPIs) together with performance targets for those KPIs.

When you create a PerformancePoint scorecard, you can use a wizard to guide you through the process. When you use a wizard, you begin by selecting a template. The template that you select corresponds to the kind of data source that you plan to use for your scorecard.

Important:

Make sure that Dashboard Designer is configured to use a scorecard wizard. For more information, see Turn on or off the scorecard wizard in Dashboard Designer.

To select a scorecard template

  1. Identify the kind of data source that you want to use for your scorecard. The data source that you want to use will help you determine which scorecard template to select, as described in the following table.

    Data source Scorecard template

    SQL Server Analysis Services

    Analysis Services

    Tabular data source, such as one of the following:

    • An Excel Services file

    • An Excel workbook

    • A SharePoint list

    • A table that is stored in a SQL Server database

    Excel Services, Excel Workbook, SharePoint List, or SQL Server Table

    No particular data source

    Blank Scorecard or Fixed Values Scorecard

  2. Make sure that the data source that you want to use is available. Do this by using the following procedure:

    1. In Dashboard Designer, click the Home tab, and then click Refresh.

    2. In the Workspace Browser, click Data Connections.

    3. In the center pane of the workspace, review the list of data sources on the Server and Workspace tabs.

    4. Confirm that the data source that you want to use is available. If it is not listed, then you might have to create a data connection. For information about how to create a data source, see Create data connections by using PerformancePoint Services (SharePoint Server 2013).

  3. Select the template that corresponds to your data source and follow the wizard.

See also

Create Fixed Values scorecards by using Dashboard Designer (SharePoint Server 2013)
Create tabular data scorecards by using Dashboard Designer


Create Fixed Values scorecards by using Dashboard Designer (SharePoint Server 2013)
See also

Summary: Learn how to create a fixed values scorecard by using Dashboard Designer.

Applies to: SharePoint Server 2013

When you use PerformancePoint Dashboard Designer to create a scorecard, you can use a wizard to guide you through the process. You begin by selecting a template. The template that you select typically corresponds to the data source for at least one key performance indicator (KPI) in the scorecard. This article describes how to create a PerformancePoint scorecard by using the Fixed Values Scorecard template. This template does not require you to use a data source. Instead, you specify the values for the scorecard while you use the wizard.

Note:

You can configure Dashboard Designer to use or not to use a wizard to create scorecards. To create a scorecard that uses the Fixed Values template, make sure that Dashboard Designer is configured to use a scorecard wizard. For more information, see Turn on or off the scorecard wizard in Dashboard Designer.

To create a Fixed Values scorecard by using Dashboard Designer

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, in the Dashboard Items group, click Scorecard. The Select a Scorecard Template dialog box opens.

    Important:

    If the Select a Scorecard Template dialog box does not open and a blank scorecard opens instead, then Dashboard Designer is not configured to use a scorecard wizard. To use a scorecard template such as the Fixed Values Scorecard template, you must turn on the scorecard wizard. For more information, see Turn on or off the scorecard wizard in Dashboard Designer.

  3. In the Select a Scorecard Template dialog box, in the Category section, click Standard.

  4. In the Template section, click Fixed Values Scorecard, and then click OK.

  5. In the Select KPIs to import page, notice that a new KPI is already listed in the center pane.

    You can either continue with this one KPI, or you can add more KPIs.

  6. To add KPIs

    1. In the Select KPIs to Import page, click New KPI.

      A KPI from the data source that you selected for the scorecard appears.

    2. Continue to click New KPI until you see the KPI (or KPIs) that you want to use.

    3. To remove any KPIs from the list, select a KPI, and then click Delete Selected KPIs.

      Tip:

      To select multiple KPIs, press and hold the CTRL key while you click each KPI in the list.

  7. Specify a name, banding type, and actual and target values for each KPI in the list by using the following procedure:

    To set up each KPI in the list

    1. In the KPI Name column, click the default name, and then type a new name for the KPI.

    2. In the Band Type column, use the list to select one of the following options:

      • Increasing is Better

      • Decreasing is Better

      • Closer to Target is Better

    3. In the Actual column, type a number that represents actual results. For example, if you are creating a scorecard for a sales team, you might type a sales amount in this column.

    4. In the Target column, type a number that represents the goal, or target value. For example, if you are creating a scorecard for a sales team, you might type a sales quota amount in this column.

  8. After you have created, named, and configured the KPIs that you want to use in the scorecard, click Next.

  9. On the Locations page, use the Create KPIs in list to specify a location where you want the KPIs that you created to be saved, and then click Finish.

    The scorecard opens for editing.

  10. In the center pane, click the Properties tab.

  11. In the Name box, type the name that you want to use for the scorecard.

  12. (This step is optional.) To specify a location for the scorecard, click the Display Folder button, and then select or create a folder.

  13. In the Workspace Browser, right-click the scorecard, and then click Save.

After you have created the scorecard, you can configure it. Use the following procedures to configure the scorecard and its KPIs:

  • Configure a basic KPI

  • Add KPIs to a scorecard by using Dashboard Designer

  • Edit scorecards by using Dashboard Designer (SharePoint Server 2013)

See also

Create reports by using Dashboard Designer (SharePoint Server 2013)
Add a KPI Details report to a dashboard by using Dashboard Designer (SharePoint Server 2013)


Create tabular data scorecards by using Dashboard Designer
See also

Summary: When you use PerformancePoint Dashboard Designer to create a scorecard, you can use a wizard to guide you through the process. You begin by selecting a template.

Applies to: SharePoint Server 2013

The template that you select typically corresponds to the data source for at least one key performance indicator (KPI) in the scorecard. This article describes how to create a PerformancePoint scorecard by using a scorecard template for Excel Services, an Excel workbook, a SharePoint list, or a SQL Server table.

Note:

You can configure Dashboard Designer to use or not to use a wizard to create scorecards. To create a scorecard that uses a particular template, make sure that Dashboard Designer is configured to use a scorecard wizard. For more information, see Turn on or off the scorecard wizard in Dashboard Designer.

To create a scorecard by using a tabular data source

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, in the Dashboard Items group, click Scorecard. The Select a Scorecard Template dialog box opens.

    Important:

    If the Select a Scorecard Template dialog box does not open and a blank scorecard opens instead, then Dashboard Designer is not configured to use a scorecard wizard. To use a scorecard template such as the Excel Services template, you must turn on the scorecard wizard. For more information, see Turn on or off the scorecard wizard in Dashboard Designer.

  3. In the Select a Scorecard Template dialog box, in the Category section, click Tabular.

  4. In the Template section, select the template that corresponds to your tabular data source. Click OK.

  5. In the Select a Data Source page, select the tabular data source that you want to use, and then click Next.

  6. In the Select KPIs to Import page, you can either create KPIs that are based on measures in the data source that you selected or select existing KPIs. Depending on which option you choose, use one of the procedures in the following table.

    Option Procedure

    Create KPIs that are based on measures in the data source

    To create new KPIs

    1. In the Select KPIs to Import page, click Add KPI.

      A KPI from the data source that you selected for the scorecard appears.

    2. Continue to click Add KPI until you see the KPI (or KPIs) that you want to use.

    3. To remove any KPIs from the list, select a KPI, and then click Delete Selected KPIs.

      Tip:

      To select multiple KPIs, press and hold the CTRL key while you click each KPI in the list.

    4. Click Next.

    Select existing KPIs that you and other dashboard authors have created

    To select existing KPIs

    1. In the Select KPIs to Import page, click Select KPI.

      The Select a KPI dialog box opens.

    2. In the Select a KPI dialog box, use the SharePoint Site and Workspace tabs to locate the KPI (or KPIs) that you want to use, and then click OK.

      Tip:

      To select multiple KPIs, press and hold the CTRL key while you click each KPI in the list.

    3. Click Next.

  7. (This is optional.) On the Add Measure Filters page, you can add measure filters to the KPIs that you have selected or created. You use measure filters to restrict the information that you display in your scorecard. For example, suppose that you are creating a scorecard to show sales for some, but not all, geographical regions of an organization. You can use measure filters to select just the geographical regions that are of interest. You can also add time filters to show information for a particular time period, such as for the last six months or year to date.

    Note:

    To apply time filters, the data source that you are using for the scorecard must be configured to work with Time Intelligence.

    To add measure filters

    1. Select the Add measure filters check box to enable the Select Dimension button.

    2. In the Select a dimension for measure filters section, click Select Dimension.

      Select the dimension that you want to use, and then click OK to close the Select Dimension dialog box.

      The Select Members buttons are enabled.

      There are two Select Members buttons: one for actual values in the KPI, and one for target values.

    3. In the Select a dimension for actual measure filter section, click Select Members.

    4. In the Select Members dialog box, view the list of members that are in the dimension.

      Select the items that you want to include in your filter, and then click OK to close the Select Members dialog box.

    5. In the Select a dimension for target measure filter section, click Select Members.

    6. In the Select Members dialog box, view the list of members that are in the dimension.

      Select the items that you want to include in your filter, and then click OK to close the Select Members dialog box.

    To add time filters (this is optional)

    1. In the Enter a formula for actual measure filter box, type a Time Intelligence formula.

    2. In the Enter a formula for target measure filter box, type a Time Intelligence formula.

      Tip:

      For more information about formulas that you can use, see PerformancePoint Time Intelligence quick reference.

  8. In the Add Measure Filters box, click Next.

  9. (This is optional.) On the Add Member Columns page, you can add dimension members in columns in the scorecard.

    To add column members

    1. In the Add Member Columns dialog box, select the Add column members check box to enable the Select Dimension button.

    2. Click Select Dimension to open the Select Dimension dialog box.

      Select the dimension that you want to use, and then click OK to close the Select Dimension dialog box.

      The Select Members button is enabled.

    3. Click Select Members to open the Select Members dialog box.

    4. In the Select Members dialog box, view the list of members that are in the dimension.

      Select the items that you want to include as column members in your scorecard, and then click OK to close the Select Members dialog box.

  10. In the Add Member Columns box, click Next.

    If Next is not available, then click Finish and proceed to Step 13.

  11. On the Locations page, use the Create KPIs in list to specify a location where you want any KPIs that you created or imported to be saved, and then click Finish.

    The scorecard opens for editing.

  12. In the center pane, click the Properties tab.

  13. In the Name box, type the name that you want to use for the scorecard.

  14. (This step is optional.) To specify a location for the scorecard, click the Display Folder button, and then select or create a folder.

  15. In the Workspace Browser, right-click the scorecard, and then click Save.

After you have created the scorecard, you can configure it. See Edit scorecards by using Dashboard Designer (SharePoint Server 2013).

See also

Create and configure a KPI by using Dashboard Designer (SharePoint Server 2013)


Create an Analysis Services scorecard by using Dashboard Designer (SharePoint Server 2013)
See also

Published: October 30, 2012

Summary: Learn how to create an Analysis Services scorecard by using PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

When you use PerformancePoint Dashboard Designer to create a scorecard, you can use a wizard to guide you through the process. You begin by selecting a template. The template that you select typically corresponds to the data source for at least one key performance indicator (KPI) in the scorecard. This article describes how to create a PerformancePoint scorecard by using the Analysis Services template.

This template corresponds to SQL Server Analysis Services data sources that are available in Dashboard Designer.

Note:

You can configure Dashboard Designer to use or not to use a wizard to create scorecards. To create a scorecard that uses a particular template, make sure that Dashboard Designer is configured to use a scorecard wizard. For more information, see Turn on or off the scorecard wizard in Dashboard Designer.

Create a scorecard by using the Analysis Services scorecard template in Dashboard Designer

To create an Analysis Services scorecard

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, in the Dashboard Items group, click Scorecard.

    Important:

    If the Select a Scorecard Template dialog box does not open and a blank scorecard opens instead, then Dashboard Designer is not configured to use a scorecard wizard. To use a scorecard template such as the Analysis Services template, you must turn on the scorecard wizard. For more information, see Turn on or off the scorecard wizard in Dashboard Designer.

  3. In the Select a Scorecard Template dialog box, in the Category section, click Microsoft.

  4. Select Analysis Services.

  5. Click OK.

  6. In the Select a Data Source page, select the Analysis Services data source that you want to use, and then click Next.

  7. In the Select a KPI Source page, select from one the following options, and then click Next:

    • Create KPIs from SQL Server Analysis Services measures. This option enables you to create a list of potential KPIs or to select existing KPIs that are based on measures in the Analysis Services cube.

    • Import SQL Server Analysis Services KPIs. This option enables you to copy any KPIs that have been defined in the Analysis Services cube into Dashboard Designer.

  8. Depending on which option you selected in Step 7, use one of the procedures in the following table.

    Option Procedure

    Create KPIs from SQL Server Analysis Services measures

    You can either create KPIs that are based on measures in the Analysis Services cube, or select existing KPIs.

    To create new KPIs

    1. In the Select KPIs to Import page, click Add KPI.

      A KPI from the data source that you selected for the scorecard appears.

    2. Continue to click Add KPI until you see the KPI (or KPIs) that you want to use.

    3. To remove any KPIs from the list, select a KPI, and then click Delete Selected KPIs.

      Tip:

      To select multiple KPIs, press and hold the CTRL key while you click each KPI in the list.

    4. Click Next.

    To select existing KPIs

    1. In the Select KPIs to Import page, click Select KPI.

      The Select a KPI dialog box opens.

    2. In the Select a KPI dialog box, use the SharePoint Site and Workspace tabs to locate the KPI (or KPIs) that you want to use, and then click OK.

      Tip:

      To select multiple KPIs, press and hold the CTRL key while you click each KPI in the list.

    3. Click Next.

    Import SQL Server Analysis Services KPIs

    To import KPIs

    1. In the Select KPIs to Import page, wait for the list of any KPIs that have been defined in the Analysis Services cube to appear.

      Tip:

      The number of KPIs that might appear depends on the data source that you are using. For example, you might see only one KPI, or there might be no KPIs. If you do not see a KPI that you want to use, click the Previous button, select the Create KPIs from SQL Server Analysis Services measures, and then click Next.

    2. In the Import column, select the check box for each KPI that you want to use.

    3. Click Next.

  9. (This is optional.) On the Add Measure Filters page, you can add measure filters to the KPIs that you have selected or created. You use measure filters to restrict the information that you display in your scorecard. For example, suppose that you are creating a scorecard to show sales for some, but not all, geographical regions of an organization. You can use measure filters to select just the geographical regions that are of interest. You can also add time filters to show information for a particular time period, such as for the last six months or year to date.

    Note:

    To apply time filters, the Analysis Services cube that you are using for the scorecard must be configured to work with Time Intelligence. For more information, see Configure Analysis Services data source time settings by using Dashboard Designer.

    To add measure filters

    1. Select the Add measure filters check box to enable the Select Dimension button.

    2. Click the Select Dimension button to open the Select Dimension dialog box.

      Select the dimension hierarchy that you want to use, and then click OK to close the Select Dimension dialog box.

      The Select Members buttons are enabled.

      There are two Select Members buttons: one for actual values in the KPI, and one for target values.

    3. In the Select a dimension for actual measure filters section, click Select Members to open the Select Members dialog box.

    4. In the Select Members dialog box, use the expandable tree control to view the list of members that are in the dimension hierarchy.

      Select the items that you want to include in your filter, and then click OK to close the Select Members dialog box.

    5. In the Select a dimension for target measure filters section, click Select Members to open the Select Members dialog box.

    6. In the Select Members dialog box, use the expandable tree control to view the list of members that are in the dimension hierarchy.

      Select the items that you want to include in your filter, and then click OK to close the Select Members dialog box.

    To add time filters (this is optional)

    1. In the Enter a formula for actual measure filter box, type a Time Intelligence formula.

    2. In the Enter a formula for target measure filter box, type a Time Intelligence formula.

    Tip:

    For more information about formulas that you can use, see PerformancePoint Time Intelligence quick reference.

  10. In the Add Measure Filters box, click Next.

  11. (This is optional.) On the Add Member Columns page, you can add dimension members in columns in the scorecard.

    To add column members

    1. In the Add Member Columns dialog box, select the Add column members check box to enable the Select Dimension button.

    2. Click the Select Dimension button to open the Select Dimension dialog box.

      Select the dimension hierarchy that you want to use, and then click OK to close the Select Dimension dialog box.

      The Select Members button is enabled.

    3. Click Select Members to open the Select Members dialog box.

    4. In the Select Members dialog box, use the expandable tree control to view the list of members that are in the dimension hierarchy.

      Select the items that you want to include as column members in your scorecard, and then click OK to close the Select Members dialog box.

  12. In the Add Member Columns box, click Next.

  13. On the Locations page, use the Create KPIs in list to specify a location where you want any KPIs that you created or imported to be saved, and then click Finish.

    The scorecard opens for editing.

  14. In the center pane, click the Properties tab.

  15. In the Name box, type the name that you want to use for the scorecard.

  16. (This step is optional.) To specify a location for the scorecard, click the Display Folder button, and then select or create a folder.

  17. In the Workspace Browser, right-click the scorecard, and then click Save.

After you have created the scorecard, you can configure it. Use the following procedures to configure the scorecard and its KPIs:

  • Configure a basic KPI

  • Add KPIs to a scorecard by using Dashboard Designer

  • Edit scorecards by using Dashboard Designer (SharePoint Server 2013)

See also

Create reports by using Dashboard Designer (SharePoint Server 2013)
Add a KPI Details report to a dashboard by using Dashboard Designer (SharePoint Server 2013)


Create and configure a KPI by using Dashboard Designer (SharePoint Server 2013)
See also

Summary: Learn how to create a Key Performance Indicator (KPI) with PerformancePoint Dashboard Designer in SharePoint Server 2013.

Applies to: SharePoint Server 2013

In PerformancePoint Services in SharePoint Server 2013, a key performance indicator (KPI) is a scorecard element that shows at a glance whether performance is on- or off-target for a particular metric. KPIs can vary greatly in their appearance and complexity, but KPIs typically calculate how actual values compare to target values and indicate performance by using a graphical indicator.

By using Dashboard Designer, you can easily create and configure basic KPIs for your dashboard. You can extend those KPIs by configuring them to use additional functionality, such as calculated metrics, dimension filters, and trend indicators.

Create a KPI

By using Dashboard Designer, you can create a KPI by either importing a KPI from a database, such as SQL Server Analysis Services, or by using the Create a KPI wizard in Dashboard Designer.

To import a KPI by using the Create a Scorecard wizard

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the ribbon, click the Create tab.

  3. On the ribbon, in the Dashboard Items group, click Scorecard.

    The Select a Scorecard Template dialog box opens.

  4. In the Category pane, click All. In the Template pane, select the template that corresponds to the kind of data your plan to use for the scorecard. Click OK.

    Note:

    Do not select Blank Scorecard or Fixed Values Scorecard. Those templates contain no KPIs.

  5. In the Select a data source page, review the list of data sources on the SharePoint Site and Workspace tabs. Select the data source that you want to use, and then click Next.

    Note:

    If the data source that contains the KPI(s) that you want to use is not listed, then you might have to create a data connection. See Create data connections by using PerformancePoint Services (SharePoint Server 2013).

  6. If you selected the Analysis Services scorecard template, the Select a KPI Source page opens. (Otherwise, proceed to step 7.)

    Select the Create KPIs from SQL Server Analysis Services measures option, and then click Next.

  7. In the Select KPIs to Import page, select the KPI (or KPIs) that you want to use by following these steps:

    1. Click Add KPI.

      A KPI from the data source that you selected for the scorecard appears.

    2. Continue clicking Add KPI until you see the KPI (or KPIs) that you want to use.

    3. To remove any KPIs from the list, select a KPI and then click Delete Selected KPIs.

      Tip:

      To select multiple KPIs, press and hold the CTRL key while you click each KPI in the list.

    4. Click Next.

  8. On the Add Measure Filters page, click Next.

  9. On the Add Member Columns page, click Next.

  10. On the Locations page, confirm that the correct location is specified in the Create KPIs in list, and then click Finish.

The KPI (or KPIs) that you have imported can now be configured.

To create a KPI by using the Create a KPI wizard

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the ribbon, click the Create tab.

  3. On the ribbon, in the Dashboard Items group, click KPI.

    The Select a KPI Template dialog box opens.

  4. In the Template pane, select either the Blank KPI or Objective template, and then click OK.

    • Select Blank KPI to create a single KPI.

    • Select Objective to create a KPI that serves as a heading for a group of other KPIs.

    Tip:

    The main difference between the two KPI templates is in their default calculation method. By default, an Objective KPI uses no calculation, and a Blank KPI uses a normalized weighted score calculation. However, you can specify the calculation method that is used by the KPI, regardless of which template that you selected.

The KPI that you have created opens for editing in the workspace where you can configure it.

Configure a basic KPI

After you have created or imported a KPI, your next step is to configure it to measure performance. Begin with a KPI for that is open for editing, and then use the Editor tab to configure it.

To open a KPI for editing

  1. In Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

  2. Locate a KPI that you want to configure.

  3. Double-click the KPI that you want to configure to open it for editing.

To configure a basic KPI

  1. In the center pane, on the Editor tab, notice two sections: the Actual and Targets section, and the Thresholds section.

    • The Actual and Targets section is where you configure the names of the metrics, numeric formatting, kind of indicator, data source, and calculation settings that are used by the KPI.

    • The Thresholds section is where you configure the indicator and scoring settings that will be used by the KPI.

      The Thresholds section is enabled when you click a column in a Target value.

  2. Configure the Actual value for a basic KPI by specifying the name, number formatting, data mapping, and calculation settings for that value.

    To configure the Actual value for a basic KPI

    1. To edit the name of the Actual value, in the Name column, click the current name of that value to highlight its text, and then type a new name.

    2. To specify how numeric values are displayed in a scorecard, take the following steps:

      1. In the Number Format column, click the hypertext to open the Format Numbers dialog box.

      2. Specify the format and other settings that you want to use for the value in the KPI.

      3. Click OK to close the Format Numbers dialog box.

    3. To specify the data source that you want to use for an Actual value, take the following steps:

      1. In the Data Mappings column, click the hypertext. A Data Source Mapping dialog box opens.

        Depending on how the KPI was created, the Data Source Mapping dialog box will be one of the following:

        • Fixed Values Data Source Mapping dialog box

        • Dimensional Data Source Mapping dialog box

      2. Click Change Source to open the Select a Data Source dialog box.

      3. Select the data source that you want to use, and then click OK.

    4. To specify calculation settings for the Actual value, take the following steps:

      1. In the Calculation column, click the hypertext to open the Calculation dialog box.

      2. Select the kind of calculation that you want to use, and then click OK.

  3. Configure the Target value for a basic KPI by specifying the name, number formatting, data mapping, indicator, and calculation settings for that value.

    To configure the Target value for a basic KPI

    1. To edit the name of the Target value, in the Name column, click the current name of that value to highlight its text, and then type a new name.

    2. To specify which value to compare to the Target value, use the Compare to list to select an Actual value.

    3. To specify how numeric values are displayed in a scorecard, take the following steps:

      1. In the row that contains the Target value, in the Number Format column, click the hypertext to open the Format Numbers dialog box.

      2. Specify the format and other settings that you want to use for the value in the KPI.

      3. Click OK to close the Format Numbers dialog box.

    4. To configure the indicator and scoring settings that are used by each Target value, take the following steps:

      1. In the Target row, click the cell in the Indicators column.

        The Thresholds pane is enabled.

      2. In the Thresholds pane, verify that the correct settings are used for the various threshold values.

      3. To make any changes to the indicator and scoring settings, click Set Scoring Pattern and Indicator to open the Edit Banding Settings wizard.

      4. Use the wizard to specify the scoring pattern, indicator, and worst value for the KPI.

    5. To specify the data source that you want to use for a Target value, take the following steps:

      1. In the Data Mappings column, click the hypertext. A Data Source Mapping dialog box opens.

        Depending on how the KPI was created, the Data Source Mapping dialog box will be one of the following:

        • Fixed Values Data Source Mapping dialog box

        • Dimensional Data Source Mapping dialog box

      2. Click Change Source to open the Select a Data Source dialog box.

      3. Select the data source that you want to use, and then click OK.

    6. To specify calculation settings for the Target value, take the following steps:

      1. In the Calculation column, click the hypertext to open the Calculation dialog box.

      2. Select the kind of calculation that you want to use, and then click OK.

  4. Give the KPI a name, and save it.

    To name and save the KPI

    1. In the center pane, click the Properties tab.

    2. In the Name box, type the name that you want to use for the KPI.

    3. (This step is optional.) To specify a location for the KPI, click the Display Folder button, and then select or create a folder.

    4. In the Workspace Browser, right-click the KPI, and then click Save.

The KPI is now available for you and other dashboard authors to use in PerformancePoint scorecards. You can also extend it by additionally configuring the KPI. For more information, see Extend a PerformancePoint KPI.

See also

Create scorecards by using Dashboard Designer

Extend a PerformancePoint KPI


Edit scorecards by using Dashboard Designer (SharePoint Server 2013)
See also

Summary: After you and other dashboard authors have created scorecards by using PerformancePoint Dashboard Designer, you can then edit those scorecards to display information in a particular way.

Applies to: SharePoint Server 2010 Enterprise

Some examples of the kinds of changes that you can make to a scorecard include the following:

  • Change the toolbar and other viewing options for scorecard users. You can enable or disable the scorecard toolbar and configure other kinds of display settings for a scorecard.

  • Add items, such as key performance indicators (KPIs) or dimension members to a scorecard.

  • Create or change the hierarchical structure of information in a scorecard. You can configure a hierarchical structure for KPIs and dimension members in a scorecard.

TechNet articles about editing scorecards by using Dashboard Designer

Read the articles in the following table to edit a scorecard.

Task | Article
Add KPIs to a scorecard | Add KPIs to a scorecard by using Dashboard Designer
Add dimension members to a scorecard | Add dimension members to a scorecard by using Dashboard Designer

See also

Create scorecards by using Dashboard Designer


Add KPIs to a scorecard by using Dashboard Designer
See also

Summary: Learn how to add a Key Performance Indicator (KPI) to a scorecard by using PerformancePoint Dashboard Designer in SharePoint Server 2013.

Applies to: SharePoint Server 2013

When you create a PerformancePoint scorecard, the scorecard typically contains at least one key performance indicator (KPI). Use Dashboard Designer to add more KPIs to the scorecard. A scorecard can contain multiple KPIs that use the same or different data sources.

To add a KPI to a scorecard

  1. In Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

  2. Locate and double-click to open the scorecard that you want to change.

  3. In the center pane, click the Editor tab.

  4. In the Details pane, expand KPIs, and then locate the KPI that you want to add.

    Note:

    If the KPI that you want to add is not displayed, take the following steps:

    1. In Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

    2. Locate the KPI that you want to add to a scorecard.

    3. Double-click the KPI to open it for editing.

    4. Return to Step 1 to reopen the scorecard that you want to edit.

  5. From the Details pane, expand KPIs, and then drag a KPI to the scorecard.

    You can put a KPI on rows or columns in the scorecard.

  6. Repeat for each KPI that you want to add.

  7. On the Edit tab, in the View group, click Update to display the changes that you made to the scorecard.

  8. In the Workspace Browser, right-click the scorecard, and then click Save.

See also

Create scorecards by using Dashboard Designer
Create and configure a KPI by using Dashboard Designer (SharePoint Server 2013)
Create or change hierarchical structures in scorecards by using Dashboard Designer in SharePoint Server 2013
Edit scorecards by using Dashboard Designer (SharePoint Server 2013)


Add dimension members to a scorecard by using Dashboard Designer
See also

Summary: Learn how to add dimension members to a PerformancePoint Services scorecard in SharePoint Server 2013.

Applies to: SharePoint Server 2013

When you create a PerformancePoint scorecard, the scorecard typically contains at least one key performance indicator (KPI). The scorecard might not contain dimension members. You can use PerformancePoint Dashboard Designer to add one or more dimension members to the scorecard.

Important:

A scorecard can contain multiple KPIs that use the same or different data sources. To add one or more dimension members to a scorecard, the scorecard must contain at least one KPI that uses the same data source as the dimension members that you want to add. Before you begin the following procedure, make sure that the scorecard contains at least one KPI that uses the data source that contains the dimension members that you want to use. For more information about how to add a KPI to a scorecard, see Add KPIs to a scorecard by using Dashboard Designer.

Make sure that the scorecard KPIs do not contain dimension filters for the same dimension as the dimension members that you are adding to the scorecard. For example, suppose that the scorecard contains a KPI to show sales performance, and that KPI contains dimension filters to display information for certain product categories. Then, suppose that the dimension members that you want to add to the scorecard contain product categories. Before you add the dimension members to the scorecard, you must make sure that you remove the dimension filter on the KPI. Otherwise, the Decomposition Tree option will be disabled for the scorecard.

To add dimension members to a PerformancePoint scorecard

  1. In Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

  2. Double-click the scorecard that you want to change to open it.

  3. In the center pane, click the Editor tab.

  4. In the Details pane, expand Dimensions, and then locate the dimension hierarchy that you want to add.

    Note:

    If the dimension hierarchy that you want to use is not displayed, make sure that the scorecard contains at least one KPI that uses the data source that contains the dimension members that you want to use. For more information about how to add a KPI to a scorecard, see Add KPIs to a scorecard by using Dashboard Designer.

    Then, in the Details pane, in the Data Source section, use the list to select the data source that contains the dimension hierarchy that you want to use.

  5. From the Details pane, expand Dimensions, and then drag a dimension hierarchy to the scorecard.

    The Select Members dialog box opens.

    Tip:

    You can put dimension members in rows or columns in the scorecard. In addition, you can put dimension members underneath a KPI.

    As you drag a dimension hierarchy to the scorecard, small blue arrows will appear in the scorecard to show you approximately where the dimension members will be positioned. For example, if the dimension members will be at the same level as a KPI, arrows pointing downward will appear. If the dimension members will be nested underneath a KPI, arrows pointing to the right side of the KPI will appear.

  6. For each dimension hierarchy that you add to the scorecard, you can either keep the default selection (this is typically All) or select the dimension members that you want to display.

    To select individual dimension members

    1. In the Select Members dialog box, use the expandable tree control to view the list of members that are in the dimension hierarchy.

    2. Select the items that you want to display in your scorecard.

      Tip:

      To select a group of items at the same time, right-click the top-level dimension in the tree, and then click an available option, such as Select Children or Autoselect Members.

    3. Click OK.

      The Select Members dialog box closes and your scorecard updates to display the members that you selected.

  7. On the Edit tab, in the View group, click Update to refresh the scorecard.

  8. In the Workspace Browser, right-click the scorecard, and then click Save.

See also

Create scorecards by using Dashboard Designer
Create and configure a KPI by using Dashboard Designer (SharePoint Server 2013)
Edit scorecards by using Dashboard Designer (SharePoint Server 2013)


Configure view settings for a scorecard by using Dashboard Designer (SharePoint Server 2013)
See also

Published: November 6, 2012

Summary: Learn how to configure settings for a scorecard within PerformancePoint Dashboard Designer in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

By using PerformancePoint Dashboard Designer, you can configure view settings for a scorecard. These settings control how a scorecard behaves in a PerformancePoint dashboard. For example, you can control the level of interactivity in a scorecard by enabling or disabling the ability for users to leave comments in a scorecard. You can also specify whether to display a scorecard toolbar, and which toolbar commands to display.

To configure view settings for a PerformancePoint scorecard

  1. In Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

  2. Locate a scorecard for which you want to configure view settings.

  3. Double-click the scorecard that you want to change to open it for editing.

  4. In the center pane, click the Editor tab.

  5. On the Edit tab, in the View group, click Settings.

    The View Settings dialog box appears. There, you can configure the view settings that you want to use for the scorecard.

  6. To control the level of interactivity in the scorecard, in the View Settings dialog box, select Interactivity in the navigation pane. Then, select or clear the options that you want to enable or disable, as shown in the following table.

    Interactivity section Option Description

    Allow

    Expand/collapse (+/-)

    Select this option to enable dashboard authors and users to expand and collapse scorecard rows and columns.

    Row members

    Select this option to enable dashboard authors and users to expand and collapse scorecard rows.

    Column members

    Select this option to enable dashboard authors and users to expand and collapse scorecard columns.

    Comments

    Select this option to enable dashboard authors and users to leave comments in scorecard cells.

    Important:

    Before you select the Comments option, verify that "Enable comments" is selected in Central Administration settings for PerformancePoint Services. Otherwise, users might receive an error message when they try to leave comments.

    Allow once deployed

    Drill down

    Select this option to enable dashboard users to drill down to see lower levels of detail in scorecard rows and columns.

    Row members

    Select this option to enable dashboard users to drill down on data in scorecard rows.

    Column members

    Select this option to enable dashboard users to drill down on data in scorecard columns.

    Show details

    Select this option to enable dashboard users to view transaction-level details for a particular scorecard value.

    Note:

    In a dashboard, the Show Details command is available only for scorecard cells that contain data that is stored in SQL Server Analysis Services and do not contain calculated values.

    Filter by status

    Select this option to enable dashboard users to filter the information that is displayed in a scorecard by key performance indicator (KPI) status.

    Filter

    Select this option to enable dashboard users to apply filters, such as Top 10 and Value Filters to a scorecard.

    Sort

    Select this option to enable dashboard users to sort rows or columns in a scorecard.

  7. To control the display settings for the scorecard, in the View Settings dialog box, select Display in the navigation pane. Then, select or clear the options that you want to enable or disable, as shown in the following table.

    Display section Option Description

    Show

    Actual and target headers

    Select this option to display Actual and Target headings in the scorecard.

    Wrapped text in cells

    Select this option to wrap text in scorecard cells. This is useful for row or column members that have longer names.

    Gridlines

    Select this option to display gridlines in a scorecard.

    Messages

    Empty cells

    Select this option to specify what should be displayed in empty scorecard cells.

    If you select the Empty cells option, type the text that you want to display in the Empty cells box.

    Error cells

    Select this option to specify what should be displayed in scorecard cells that have errors.

    The default text is Error. To edit the text, delete the default text and type the text that you want to display in the Error cells box.

  8. To control the display settings for the scorecard, in the View Settings dialog box, select Toolbar in the navigation pane. Then, select or clear the options that you want to enable or disable, as shown in the following table.

    Option Description

    Show scorecard toolbar

    Select this option to display the scorecard toolbar.

    When you select this option, all of the following options are automatically selected. You can keep these selections to clear them to control which toolbar commands are displayed in the scorecard toolbar.

    Similarly, if you select any of the following options, the Show scorecard toolbar option will be selected.

    Filter by Status

    Select this option to display the Filter by Status toolbar command in the scorecard toolbar. This enables dashboard users to view only the KPIs that have a particular status, such as those that are on or off target.

    Default Rollup (average weighted)

    Select this option to display the Default Rollup toolbar command in the scorecard toolbar. This enables dashboard users to view overall performance for objective KPIs based on average weighted values in the scorecard.

    For example, suppose that the scorecard contains an objective KPI that has multiple KPIs nested underneath the objective KPI. If a dashboard user uses the Default Rollup toolbar command, the objective KPI will show overall performance that is based on a weighted average of the nested KPIs.

    Worst Indicator Rollup

    Select this option to display the Worst Indicator Rollup toolbar command in the scorecard. This enables dashboard users to see whether any KPIs in an objective KPI are off target.

    For example, suppose that the scorecard contains an objective KPI that has three KPIs nested underneath the objective KPI. Suppose also that two of those KPIs show that performance is on target, and the third KPI indicates performance is off target. If a dashboard user uses the Worst Indicator Rollup toolbar command, the objective KPI will show performance as off target, based on the status of the third KPI.

    Indicator Count Rollup

    Select this option to display the Indicator Count Rollup toolbar command in the scorecard. This enables dashboard users to see how many KPIs are in each kind of status for a given objective KPI.

    For example, suppose that the scorecard contains an objective KPI that has four KPIs nested underneath the objective KPI. Suppose also that one KPI shows that performance is off target, and three show that performance is on target. If a dashboard user uses the Indicator Count Rollup toolbar, objective KPI will summarize that information by displaying numeric totals for each indicator.

    Show as Tree

    Select this option to display the Show as Tree toolbar command in the scorecard. This enables dashboard users to switch between a hierarchical view or a flatter, tabular view of the scorecard.

    Collapse All

    Select this option to display the Collapse All toolbar command in the scorecard. This enables dashboard users to collapse rows in the scorecard and view only high-level information.

    Expand All

    Select this option to display the Expand All toolbar command in the scorecard. This enables dashboard users to expand rows in the scorecard to view lower levels of information.

    Show Inline Text

    Do not use this option. It does not work in the current version of PerformancePoint Services.

  9. To control the display settings for the scorecard, in the View Settings dialog box, select Filters in the navigation pane. Then, select or clear the options that you want to enable or disable, as shown in the following table.

    Option Description

    Filter empty rows

    Select this option to prevent empty rows from displaying in the scorecard.

    Filter by status

    Select any of the following options to display only the KPIs that have the status that you select.

    • On Target

    • Slightly Off Target

    • Off Target

  10. After you have specified the display options that you want to use for the scorecard, in the View Settings dialog box, click OK.

  11. On the Edit tab, in the View group, click Update to display the changes that you made to the scorecard.

  12. In the Workspace Browser, right-click the scorecard, and then click Save.

See also

Edit scorecards by using Dashboard Designer (SharePoint Server 2013)
Create scorecards by using Dashboard Designer
Create and configure a KPI by using Dashboard Designer (SharePoint Server 2013)


Create or change hierarchical structures in scorecards by using Dashboard Designer in SharePoint Server 2013
See also

Published: November 6, 2012

Summary: Learn how to create or change hierarchical structures in scorecards by using PerformancePoint Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

After you create a PerformancePoint scorecard that contains multiple key performance indicators (KPIs), you use PerformancePoint Dashboard Designer to create or configure a hierarchical structure for the scorecard. You can promote or demote individual KPIs, and configure the position of a KPI in an existing hierarchy.

KPIs can be organized into one of three categories: objective KPIs, non-leaf KPIs, and leaf-level KPIs.

  • Objective KPIs An objective KPI is a KPI that has non-leaf KPIs indented under it, or a combination of non-leaf KPIs and leaf-level KPIs.

    An objective KPI states performance for an overall goal, because it rolls up related KPI scores into a single summary indicator.

  • Non-leaf KPIs A non-leaf KPI is a KPI that has leaf-level KPIs that are indented under it.

    A non-leaf KPI heads a group of closely related measures, and it aggregates the values of the leaf-level KPIs that are in the group.

  • Leaf-level KPIs A leaf-level KPI is at the lowest level of a scorecard hierarchy. It has no KPIs under it in the hierarchy.

    A leaf-level KPI reflects a single performance measure, because it compares actual performance for a single measure to its target value.

The following image shows two objective KPIs, two non-leaf KPIs, and several leaf-level KPIs.

PerformancePoint scorecard showing multiple KPIs

In this image, the Financial Perspective and Increase Shareholder Value KPIs are objective KPIs that show overall performance that is based on the KPIs that are indented under it. The Productivity and Growth KPIs are non-leaf KPIs that each head a group of leaf-level KPIs. The leaf-level KPIs are Expense as % of Revenue, Asset Utilization, Revenue Growth, Gross Margin %, and Revenue Growth New Products.

You can also add dimension members to a scorecard, and you can nest them underneath a KPI. For more information, see Add dimension members to a scorecard by using Dashboard Designer.

Note:

Before you begin to promote or demote KPIs in a scorecard, make sure that the scorecard contains multiple KPIs. For more information, see Create and configure a KPI by using Dashboard Designer (SharePoint Server 2013) and Add KPIs to a scorecard by using Dashboard Designer.

To promote or demote a KPI in a scorecard hierarchy

  1. In Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

  2. Double-click the scorecard that you want to change to open it.

  3. In the center pane, click the Editor tab.

  4. Click the Edit tab.

  5. Make sure the KPIs are in the correct order in the scorecard. To move the KPI up or down in the scorecard, follow these steps:

    1. In the scorecard, click a KPI to select it.

    2. On the ribbon, in the Header group, use the Move Up or Move Down toolbar commands.

      Each time that you click a Move Up or Move Down toolbar command, the KPI that you selected moves one row up or down in the scorecard.

    3. Repeat until all the KPIs are in the order that you want them in the scorecard.

  6. Verify that the KPIs that you want to promote or demote are configured to use the correct calculations. For example, an objective or non-leaf KPI uses No value for its calculation setting, whereas a leaf-level KPI uses another calculation setting, such as Default, which is a normalized weighted score calculation. For more information about how to view or configure calculation settings for a KPI, see Configure a basic KPI.

  7. After you have confirmed that all the KPIs are in the correct order and use the correct calculation settings, you are ready to begin promoting or demoting KPIs. Use the following procedure:

    1. In the scorecard, click a KPI to select it.

    2. On the ribbon, in the Header group, use the Decrease Indent or Increase Indent toolbar commands to promote or demote the KPI.

    3. Repeat for each KPI in the scorecard.

  8. On the Edit tab, in the View group, click Update to display the changes that you made to the scorecard.

  9. In the Workspace Browser, right-click the scorecard, and then click Save.

See also

Create scorecards by using Dashboard Designer
Edit scorecards by using Dashboard Designer (SharePoint Server 2013)
Create and configure a KPI by using Dashboard Designer (SharePoint Server 2013)


Create reports by using Dashboard Designer (SharePoint Server 2013)
See also

Summary: Using PerformancePoint Dashboard Designer, you can create many kinds of reports for your dashboard. Examples of report types include analytic charts and grids, Excel Services reports, strategy maps, and many other kinds of reports.

Applies to: SharePoint Server 2013

To learn more about the different kinds of reports that you can create, see Learn about PerformancePoint report types.

TechNet articles about how to create reports by using Dashboard Designer

Read the following articles to learn how to create reports for your PerformancePoint dashboard.

Building blocks Content | Description
Create a KPI Details report by using Dashboard Designer (SharePoint Server 2013) | Create a KPI Details report that is connected to a scorecard to display information about KPI values and properties in a dashboard.
Create Excel Services reports by using Dashboard Designer (SharePoint Server 2013) | Create a PerformancePoint Web Part to display an existing Excel Services report.
Create strategy maps by using Dashboard Designer (SharePoint Server 2013) | Create a strategy map that is connected to a scorecard to show relationships between objectives, goals, and key performance indicators (KPIs).

See also

Assemble dashboard pages and link items together by using Dashboard Designer

Plan a PerformancePoint dashboard


Create a KPI Details report by using Dashboard Designer (SharePoint Server 2013)
See also

Summary: Learn how to create a Key Performance Indicator (KPI) report by using Dashboard Designer.

Applies to: SharePoint Server 2013

Using PerformancePoint Dashboard Designer, you can create a KPI Details report for your dashboard. KPI Details reports are used to show additional information about the KPIs and other items that are in a scorecard. The KPI Details report serves as a companion to a scorecard. This means that a KPI Details report is not used in a dashboard without its accompanying scorecard on the same dashboard page.

You can create a single KPI Details report and then reuse it in multiple dashboards.

To create a KPI Details report by using Dashboard Designer

  1. In the ribbon, click the Create tab. Then, in the Reports group, click KPI Details.

    The report opens for editing.

  2. In the center pane, click the Editor tab. There, you can specify the information that you want to display in the report.

    KPI section Option Description

    Cell Context Information

    Show cell context information

    Select this option to display the following information:

    • Metric

    • Measure

    • Row Path, which corresponds to the scorecard row that was clicked.

    • Column Path, which corresponds to the scorecard column that was clicked.

    Expand cell context sections by default

    By default, this option is selected. It causes the KPI Details report to be expanded to display the information that you specify.

    Show Indicator Options

    Show status graph

    Do not use this option. It does not work in the current version of PerformancePoint Services.

    Show indicator graphic

    Do not use this option. It does not work in the current version of PerformancePoint Services.

    Show Details Information

    Show actual

    Select this option to display actual values when cells in the scorecard's Target column are clicked.

    Show calculation

    Select this option to display how scores are calculated and what banding method is used by the KPI that was clicked.

    KPIs use one of the following calculations:

    • Increasing is better

    • Decreasing is better

    • Closer to target is better

    Show score

    Select this option to show raw scores when cells in the scorecard's Target column are clicked.

    Show threshold grid

    Select this option to determine whether to show the threshold grid when cells in the scorecard's Target column are clicked.

    The threshold grid includes the following information:

    • The kind of indicator that is used by the KPI that was clicked

    • A table showing the different thresholds and performance for a KPI.

    When you select Show threshold grid, you must also select one of the following two options:

    • Percentage threshold values

    • Target values adjusted for indicator threshold percentages

    For metrics with normalized weighted value, show Percentage values

    Select this option to display performance in percentages in the threshold grid.

    For metrics with normalized weighted value, show Target values adjusted for indicator threshold percentages

    Select this option to display performance in numeric values in the threshold grid.

    Show variance

    Select this option to show the variance from the next status threshold.

    For example, if performance is slightly off target for a particular metric, the variance would be how far away the metric is from being on target.

    Additional information

    Show Description

    Select this option to display any text that was entered in the Description box for a KPI (visible on the Properties tab for a KPI in Dashboard Designer).

    Show Comments

    Select this option to display any comments or annotations that have been added to a scorecard.

    Depending on whether comments (or annotations) are enabled in the SharePoint Central Administration Web site, both dashboard authors and dashboard consumers can add comments to a scorecard.

    • Dashboard authors can open a scorecard for editing in Dashboard Designer and add comments by using the Edit tab.

    • Dashboard users can add comments to a scorecard in its SharePoint site by right-clicking a cell, and then clicking Comments.

    Show KPI Properties

    Select this option to display any custom properties that might have been created for each KPI (visible on the Properties tab for a KPI in Dashboard Designer).

    Show Person Responsible

    Select this option to display information about the person who is responsible for the KPI status (which is visible on the Properties tab for a KPI in Dashboard Designer).

  3. In the center pane, click the Properties tab.

  4. In the Name box, type the name that you want to use for the report.

  5. (This step is optional.) To specify a location for the report, click the Display Folder button, and then select or create a folder.

  6. In the Workspace Browser, right-click the report, and then click Save.

After you have created the KPI Details report, you can add it to a dashboard page and connect it to a scorecard. For more information, see Add a KPI Details report to a dashboard by using Dashboard Designer (SharePoint Server 2013).

See also

Create and assemble a dashboard page by using Dashboard Designer (SharePoint Server 2013)
Create scorecards by using Dashboard Designer


Create Excel Services reports by using Dashboard Designer (SharePoint Server 2013)

Published: July 31, 2012

Summary: Learn how to create an Excel Services report by using PerformancePoint Dashboard Designer in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

By using Dashboard Designer, you can create Excel Services reports for your dashboards. An Excel Services report is an Excel workbook that was published to SharePoint Server 2013 by using Excel Services. Most Excel Services reports contain one or more charts and tables. When you add an Excel Services report to a PerformancePoint dashboard, you reuse an existing report that can contain views, such as PivotTable reports and PivotChart reports, which you cannot create by using Dashboard Designer.

Create a reference to an Excel Services report

In Dashboard Designer, you do not actually create an Excel Services report. Instead, you create a PerformancePoint Web Part to display an existing Excel Services report.

Important:

Before you start, make sure that you have collected the following information:

  • The name of the report that you want to use

  • The SharePoint Server location (including the SharePoint site and document library) where the Excel Services report is stored

  • Any named items that might exist in the Excel Services report

  • Any parameters that might exist in the Excel Services report, and information about how those parameters are configured. (You would typically need this information to connect a PerformancePoint dashboard filter to the Excel Services report.)

    If the Excel Services workbook is stored in a different server farm than the one that you are using for Dashboard Designer, parameters in the Excel workbook will not be available in Dashboard Designer.

Also make sure that you and the dashboard users have the necessary permissions to view the report.

When you create an Excel Services report, you do it in these stages=:

  1. Create the basic structure of the report.

  2. Create a connection to the report.

  3. Configure the report to display the particular information that you want to show.

  4. (This is optional.) Specify toolbar and interactivity settings for the report.

To create the basic structure of the report

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, in the Reports group, click Other Reports.

    The Select a Report Template dialog box opens.

  3. In the Select a Report Template dialog box, click Excel Services, and then click OK.

    The report opens for editing in the center pane of the workspace.

  4. In the center pane, click the Properties tab.

  5. In the Name box, type the name that you want to use for the report.

  6. (This step is optional.) To specify a location for the report, click the Display Folder button, and then select or create a folder.

  7. In the Workspace Browser, right-click the report, and then click Save.

  8. Create a connection to the report.

To create a connection to the report

  1. Begin with the report open for editing in Dashboard Designer. In the center pane, click the Editor tab.

  2. In the Report Settings section, in the SharePoint site box, do one of the following:

    • Type the Web site address (URL) of the SharePoint site where the Excel Services report is hosted.

    • If the SharePoint site list is available, use it to select the SharePoint site where the Excel Services report is hosted.

  3. Use the Document library list to select the document library where the Excel Services report is hosted.

  4. Use the Excel workbook list to select the Excel Services report that you want to display.

  5. (This step is optional.) If you want to view the report, do one of the following:

    • To view the report in a browser window, on the Editor tab, click the View button that is located next to the Excel workbook list.

    • To view the report in Dashboard Designer, in the center pane of the workspace, click the View tab.

  6. In the Workspace Browser, right-click the report, and then click Save.

After you have created and saved the report, you can configure it, or you can add it to a dashboard page.

To configure the report to display particular information

  1. Begin with the report open for editing in Dashboard Designer. In the center pane, click the Editor tab.

  2. (This step is optional.) If you want to display an item in the workbook instead of display the whole workbook, use the Item name list to select an item.

    If the Item name list is empty, see Publishing named items in an Excel workbook later in this article.

  3. (This step is optional.) If the Excel Services report includes parameters and you want to specify default selections for those parameters, follow these steps:

    1. In the Workbook Parameters section, locate the parameter for which you want to specify a default value.

      Note:

      If the Workbook Parameters section is empty, either the Excel Services report has no parameters or the workbook is stored in a different server farm than the one that you are using for Dashboard Designer.

    2. In the Value column for that parameter, type the default value that you want to use.

      Tip:

      You might want to view the Excel Services workbook in its SharePoint site to see which parameter(s) you want to use.

  4. In the Workspace Browser, right-click the report, and then click Save.

Now that you have created and configured the report, you can either add it to a dashboard page or specify toolbar and interactivity settings for the report.

To specify toolbar and interactivity settings for the report

  1. Begin with the report open for editing in Dashboard Designer. In the center pane, click the Editor tab.

  2. On the ribbon, click the Edit tab, and then click Report Settings.

    The Report Settings dialog box opens.

  3. In the pane on the left side of the Report Settings dialog box, click Interactivity, and then specify the options that you want to use.

    The Interactivity options are configured for the Excel workbook when it is published to SharePoint Server. To view detailed information about these options, see Interactivity Settings in Excel Web Access Web Part custom properties (http://go.microsoft.com/?linkid=9730256).

  4. In the pane on the left side of the Report Settings dialog box, click Toolbar, and then specify the options that you want to use.

    The Toolbar options are Excel Services options that are configured for the Excel workbook when it is published to Excel Services. To view detailed information about these options, see Toolbar and Title Bar section properties in Excel Web Access Web Part custom properties (http://go.microsoft.com/?linkid=9730257).

  5. In the Workspace Browser, right-click the report, and then click Save.

You can now add the report to a dashboard page.

Publish named items in an Excel workbook

If you want to configure an Excel Services report to display a named item that is defined in Excel, the named item must be published to SharePoint Server. Otherwise, the Item name list will be empty in Dashboard Designer.

Simply publishing the workbook does not ensure that named items are published, too.

To publish named items in an Excel workbook

  1. In Excel, on the File tab, click Save & Send, and then click Save to SharePoint.

  2. In the Save to SharePoint section, click Publish Options.

  3. In the Publish Options dialog box, on the Show tab, use the list to select Items in the Workbook.

  4. Select all the named items in the list, and then click OK.

  5. In the Save to SharePoint section, click Browse for a location, and then click Save As.

    The Save As dialog box opens.

  6. In the Save As dialog box, specify the Web site address (URL) to the document library where you want to publish the workbook.

    The URL resembles http://<server name>/<sharepoint site name>/<document library>.

    (For example, we use the URL http://litware-sp/bicenter/Reports.)

  7. Click Save to publish the workbook.


Create strategy maps by using Dashboard Designer (SharePoint Server 2013)

Summary: Learn how to create a strategy map by using PerformancePoint Dashboard Designer.

Applies to: SharePoint Server 2013

Using PerformancePoint Dashboard Designer, you can create a strategy map for your dashboard. The strategy map uses a scorecard as its data source, and a Visio diagram as its visual display structure. When you create and configure a strategy map, you connect individual shapes in a Visio diagram to KPIs in a scorecard. The color of each shape indicates whether performance is on or off target for that particular item.

Important:

Before you create a strategy map report, make sure that the correct version of Visio is installed on your computer. The version that you use must be compatible with PerformancePoint Dashboard Designer.

  • If you are using the 64-bit edition of Dashboard Designer, then you must install the 64-bit edition of either Visio 2010 or Visio 2013.

  • If you are using the 32-bit edition of Dashboard Designer, then you must install the 32-bit edition of either Office Visio 2007 or Visio 2010.

Create a strategy map by using Dashboard Designer

Before you begin to create your strategy map, make sure that the following items have been created:

  • A diagram that was created by using Visio 2007, Visio 2010 or Visio 2013. The diagram cannot consist of complex shapes (groups or sets of other shapes).

    Tip:

    We recommend that you create your Visio diagram before you create your strategy map. However, you can create a Visio diagram in Dashboard Designer by importing stencils.

  • A scorecard that was created by using Dashboard Designer.

When you create a strategy map, you do this in two main phases. First, you create the basic structure of the strategy map. Next, you configure the strategy map to display information.

To create the basic structure of the strategy map

  1. In Dashboard Designer, locate the Workspace Browser pane. Click PerformancePoint Content.

  2. In the ribbon, click the Create tab, and then in the Reports group, click Strategy Map. The Create a Strategy Map Report wizard opens.

  3. In the Select a Scorecard step of the wizard, select the scorecard that you want to use, and then click Finish.

    The strategy map opens in the center pane of the workspace.

  4. In the center pane, click the Properties tab. In the Name box, type the name that you want to use for the report.

    To specify a location for the report, click the Display Folder button and select or create a folder.

  5. In the Workspace Browser, right-click the strategy map, and then click Save. Proceed to the next section to configure the strategy map.

To configure the strategy map to display information

  1. Begin with the strategy map open for editing in Dashboard Designer. Click the Edit tab, and then click Edit Strategy Map.

    The Strategy Map Editor dialog box opens.

  2. In the Strategy Map Editor dialog box, do one of the following:

    Situation Action

    You have already created a Visio diagram

    click Import Visio File, and then browse to the location where the Visio diagram is saved. Then click Open.

    The Visio diagram opens in the Strategy Map Editor dialog box.

    You want to create a Visio diagram

    Click Stencil. Browse to the location where the Visio stencils are located, and then click Open.

    Use the stencil shapes to create your Visio diagram in the Strategy Map Editor dialog box.

  3. Click a shape in the Visio diagram, and then click Connect Shape.

    The Connect Shape dialog box opens and displays the scorecard that was selected for the strategy map.

  4. In the Connect Shape dialog box, click the cell that you want to connect to the shape that you selected.

    If you want the color of the shape to update automatically to indicate whether performance is on or off target, make sure that you click in a cell that is in the Target column. (The Target column is the column that contains the graphical indicator).

  5. Click Connect.

  6. (This step is optional.) To replace the text inside a shape with the text that is used for the scorecard KPI, select the check box next to Show KPI name in shape text.

    For example, if the KPI is called "Sales Amount" and you select the check box, then the words "Sales Amount" will replace whatever text was in the shape.

  7. Repeat steps 4-6 for each shape in the Visio diagram that you want to connect to the scorecard KPIs.

  8. When you have finished connecting shapes to KPIs, in the Connect Shape dialog box, click the Close button.

  9. In the Strategy Map Editor dialog box, click the Apply button.

    The dialog box closes and the strategy map appears in the center pane of the workspace.

  10. In the Workspace Browser, right-click the strategy map, and then click Save.

Edit a strategy map by using Dashboard Designer

During or after the time when you create a strategy map, you can easily edit it. For example, you can configure or replace the Visio diagram that you use for the strategy map.

To edit a strategy map

  1. In Dashboard Designer, open a strategy map.

  2. In the ribbon, click the Edit tab, and then click Edit Strategy Map.

    The Strategy Map Editor dialog box opens.

  3. Use the Strategy Map Editor to make one or more of the following changes to the strategy map:

    To achieve this Perform this step

    Move an object in the diagram

    Drag it to a new location.

    Use a different diagram

    Click Import Visio File, browse to the diagram that you want to use, and then click Open.

    (The diagram opens in the Strategy Map Editor dialog box, where you can link each shape to a KPI.)

    Open and use a stencil

    Click Stencil. Browse to the stencil that you want to use, and then click Open.

    (A stencil is a collection of shapes associated with a particular Visio template. You can use a stencil to revise all instances of a shape on the page. You can also use a stencil to change a shape by applying your own custom shape to a diagram.)

    Configure the connection between a shape and a KPI

    Click the shape, and then click Connect Shape. In the Select a KPI dialog box, select a KPI and then click Close.

    Disconnect a shape from a KPI

    Click a shape, and then click Disconnect Shape.

    Make all the shapes fit on one page in Visio

    Click Resize to Fit.

    Make all the shapes fit on one printed page

    Click Fit for Print.

  4. In the Workspace Browser, right-click the strategy map, and then click Save.


Create analytic charts or grids by using Dashboard Designer (SharePoint Server 2013)

Published: November 6, 2012

Summary: Learn how to create an analytic chart or grid by using PerformancePoint Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

By using PerformancePoint Dashboard Designer, you can create analytic reports for your dashboards. Analytic reports are dynamic, visual representations of data that can be displayed as interactive line charts, bar charts, pie charts, and tables (which are called grids). Analytic charts and grids use data that is stored in SQL Server Analysis Services (SSAS).

Create an analytic chart or grid

Before you begin to create your analytic chart, verify that the data source that you want to use is available.

To verify that your data source is available

  1. In Dashboard Designer, click the Home tab, and then click Refresh.

  2. In the Workspace Browser, click Data Connections.

  3. In the center pane of the workspace, review the list of data sources on the Server and Workspace tabs.

  4. Confirm that the data source that you want to use is available. If it is not listed, then you might have to create a data connection.

When you create an analytic chart, you do this in several stages. First, you create the basic structure of your report. Then, you configure the report to display data.

To create the basic structure of your report

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. In the ribbon, click the Create tab.

  3. In the ribbon, in the Reports group, click Analytic Chart or Analytic Grid.

    The Create an Analytic Chart Report (or Create an Analytic Grid) wizard opens.

  4. In the Select a Data Source window, select the SQL Server Analysis Services data source that you want to use.

  5. Click Finish.

    The analytic report opens for editing in the center pane of the workspace.

  6. In the center pane, click the Properties tab.

  7. In the Name box, type the name that you want to use for the report.

  8. (This step is optional.) To specify a location for the report, click the Display Folder button, and then select or create a folder.

  9. In the Workspace Browser, right-click the report, and then click Save.

After you have created the basic structure of your report, configure it to display information. When you configure the report to display information, you can select from two methods.

  • You can use the Design tab to drag items from the Details pane and preview your report. As you configure the report, it automatically updates in the center pane so you can see how it will appear in the dashboard.

  • You can use the Query tab to specify or edit the custom Multidimensional Expressions (MDX query) that is used to display information.

    Tip:

    If you create an analytic chart by using the Query tab (and not the Design tab), dashboard users might be unable to drill up or down into the data.

To configure the report to display information by using the Design tab (recommended)

  1. Begin with the analytic report open for editing in Dashboard Designer. In the center pane, click the Design tab.

  2. In the Details pane, expand Measures, Dimensions, or Named Sets to display the list of items that are available in each category.

  3. Drag an item to the Series (or Rows), Bottom Axis (or Columns), or Background section.

    Tip:

    To display data in your analytic report, you must put at least one item in each Series (or Rows) and Bottom Axis (or Columns) section.

    Placing an item in the Background section is optional.

    You can use many combinations of measures, dimensions, and named sets. For example, you can place a named set in one section and a measure in another section. Or you can put one dimension hierarchy in one section and a different dimension hierarchy in another. You can also put measures in the Background section, or you can leave the Background section blank.

    • The Series section corresponds to the vertical axis of your chart, and the Bottom Axis section corresponds to the horizontal axis.

    • The Rows section corresponds to the horizontal rows of your grid, and the Columns section corresponds to the vertical columns.

    • Any items that you put in the Background section (this is optional) serve as hidden filters for your analytic chart or grid. For example, if you put a Geography dimension in the Background section and then select some, but not all, of the geographical regions in the hierarchy, then the information that is displayed in your analytic report will be limited to those geographical regions that you selected.

      Note:

      If you put a dimension in the Background section and select the All option in the list of members, verify that you do not select individual dimension members, too. Otherwise, you might receive an error message. The error message indicates that there was an error running the data source query.

  4. For each dimension that is located on your chart, you can either keep the default selection (this is typically All), or you can select the dimension members that you want to display.

    To select individual dimension members

    1. Right-click a dimension, and then click Select Members. Or click the down arrow next to the dimension name, and then click Select Members.

      The Select Members dialog box appears.

    2. Use the expandable tree control to view the list of members that are in the dimension hierarchy.

    3. Select the items that you want to display in your analytic report.

    4. Click OK.

      The Select Members dialog box closes and your analytic report updates to display the members that you selected.

  5. Repeat steps 2-4 for each item that you want to display in your chart.

  6. In the ribbon, use the toolbar commands in the View group of the Edit tab to specify the view type and settings for your analytic report.

    Important:

    If you are creating an analytic grid that uses a Power Pivot data connection, verfiy that you use the tabular layout option instead of the compact layout. Otherwise, dashboard users might get error messages when they attempt to use Value Filters on the report.

    To apply a tabular layout to the grid, on the Edit tab, in the View group, use the Layout menu to select Tabular Layout.

  7. In the Workspace Browser, right-click the report, and then click Save.

To configure the report to display information by using the Query tab (requires familiarity with MDX)

  1. Begin with an analytic report open for editing in Dashboard Designer. In the center pane, click the Query tab.

  2. In the MDX pane, specify the MDX query that you want to use for your analytic report.

    If you want to show sales information for different products across different sales territories, your MDX query might resemble the following example.

    Copy code
    SELECT
HIERARCHIZE( { [Product].[Product].[Product Category Name].&[8], [Product].[Product].[Product Category Name].&[7], [Product].[Product].[Product Category Name].&[6], [Product].[Product].[Product Category Name].&[5], [Product].[Product].[Product Category Name].&[4], [Product].[Product].[Product Category Name].&[3], [Product].[Product].[Product Category Name].&[2], [Product].[Product].[Product Category Name].&[1] } )
ON COLUMNS,

HIERARCHIZE( { [Sales Territory].[Territory Hierarchy].[Sales Territory Group].&[North America], [Sales Territory].[Territory Hierarchy].[Sales Territory Group].&[Europe], [Sales Territory].[Territory Hierarchy].[Sales Territory Group].&[Asia] } )
ON ROWS

FROM [Sales]

WHERE ( [Measures].[Sales Amount] )

    The actual query that you use depends on the data cube and the kinds of information that you want to do display.

  3. (This is optional.) If you want to connect dashboard filters to the analytic report, you must configure the report to receive filters.

    Important:

    The following procedure applies only to analytic charts or grids that were created by using a custom MDX query.

    1. In the center pane, in the MDX pane, select a code example that represents a dimension member, dimension hierarchy, or a named set.

      Depending on the kind of filter that you want to use for the analytic chart or grid, the code example that you select will vary.

      For example, you might have an analytic chart that uses an MDX query that includes the expression, [Geography].[Geography].[Region]. That code example represents a dimension hierarchy in the Geography dimension.

      To configure the chart to receive a geography filter, select the complete code example [Geography].[Geography].[Region]

    2. In the Parameters section, type a name for your parameter, and then click Insert.

      The parameter name appears in the MDX pane.

      For example, if you insert a parameter called Geo into the code example, [Geography].[Geography].[Region], the MDX pane displays <<Geo>> instead of that code example.

      You can now link a dashboard filter to report by using this parameter. Then, when a dashboard user selects an item in the filter that is linked to this report, <<Geo>> is replaced with that item in the query. The analytic report displays the results.

    3. To add more than one parameter, repeat Steps 3a and 3b.

      For example, consider an analytic chart that has the following code, which includes two parameters.

      Copy code
      SELECT {[Time].[Calendar].[Year].&[2006]} ON COLUMNS, { TOPCOUNT({DESCENDANTS(<<Product>>, [Product].[Product].[Product])}, 20, ([Time].[Calendar].[Year].&[2009], [Measures].[Sales Amt]))} ON ROWS FROM [Sales] WHERE (<<Geography>>, [Measures].[Sales Amt])

      This query enables you to link two kinds of filters to the analytic report: a Products filter and a Geography filter.

      Based on this MDX query, a dashboard user who selects a product category in the Products filter, and then geographical region in the Geography filter, will see the top 20 products (in descending order) for that geographical region in the year 2009.

  4. In the center pane, click the Design tab to preview your analytic chart or grid.

  5. In the ribbon, use the toolbar commands in the View group of the Edit tab to specify the view type and settings for your analytic report.

  6. In the Workspace Browser, right-click the report, and then click Save.

Edit an analytic chart or grid

After you have created your analytic report, you can configure it to adjust how you want the information to be displayed. For example, you can configure the information that is displayed. Or you can change the view type of a report, such as by changing a bar chart to a line chart, or a chart to a grid.

When you want to configure the information that is displayed in an analytic report, you can use one of two methods:

  • You can use the Design tab in the center pane of the workspace to add or remove the dimensions, measures, and named sets that you use in the report. You also use the Design tab to preview the analytic report.

  • Use the Query tab in the center pane of the workspace to change the MDX query that is used to display information in the report.

To use the Design tab to add, remove, or change the items that appear in a report

  1. Begin with an analytic report open for editing in Dashboard Designer. In the center pane of the workspace, click the Design tab.

  2. Make one or more of the following changes to your analytic chart or grid:

    Action Procedure

    Add an item to an analytic chart or grid

    1. In the Details pane, expand Measures, Dimensions, or Named Sets to display the list of items that are available in that category.

    2. From the Details pane, drag an item to the Series (or Rows), Bottom Axis (or Columns), or Background section.

    3. Repeat for each item that you want to display in your chart.

    Remove an item from a chart or grid

    In the Series (or Rows), Bottom Axis (or Columns), or Background section, right-click the item that you want to remove, and then click Remove.

    Move an item to a different location in the chart or grid

    In the Series (or Rows), Bottom Axis (or Columns), or Background section, right-click the item that you want to move, and then click the section where you want to place the item.

    Or:

    Drag the item that you want to move to a different section.

    Display different dimension members in the chart or grid

    1. Right-click a dimension, and then click Select Members. The Select Members dialog box appears.

    2. Use the expandable tree control to view the list of dimension members. Select the items that you want to display in your analytic chart, and then click OK.

      The Select Members dialog box closes and your analytic chart or grid updates to display the members that you selected.

  3. In the Workspace Browser, right-click the analytic report, and then click Save.

To use the Query tab to add, remove, or configure the items that appear in a report

  1. Begin with an analytic report open for editing in Dashboard Designer. In the center pane of the workspace, click the Query tab.

  2. In the MDX pane, edit the MDX query that appears. Or, type a new MDX query.

  3. In the Workspace Browser, right-click the analytic report, and then click Save.


Create dashboard filters by using Dashboard Designer

Published: October 2, 2012

Summary: Learn how to create different types of dashboard filters by using PerformancePoint Dashboard Designer.

Applies to: SharePoint Server 2013

You can use Dashboard Designer to create many kinds of dashboard filters. Filters let you display particular information in a dashboard. You can create filters that are stand-alone dashboard items that can be reused across multiple dashboards or across multiple pages in a dashboard. These kinds of dashboard filters let dashboard users to view more specific information that is important to them.

In this section

Read the following articles to learn how create dashboard filters for your PerformancePoint dashboard.

  • Configure cascading filters by using Dashboard Designer Configure cascading filters by using Dashboard Designer describes how to configure cascading filters for PerformancePoint dashboards.

  • Create Custom Table filters by using Dashboard Designer (SharePoint Server 2013) Create Custom Table filters by using Dashboard Designer (SharePoint Server 2013) describes how to create a data table and then use that to create a dashboard filter.

  • Create MDX Query filters by using Dashboard Designer Create MDX Query filters by using Dashboard Designerdescribes how to create a dashboard filter that uses a custom Multidimensional Expressions (MDX) query.

  • Create Member Selection filters by using Dashboard Designer Create Member Selection filters by using Dashboard Designer describes how to create a dashboard filter by selecting dimension members that are stored in SQL Server Analysis Services or a tabular data source.

  • Create Named Set filters by using Dashboard Designer Create Named Set filters by using Dashboard Designer describes how to create a dashboard filter by selecting a set of members that was defined in Analysis Services.

  • Create Time Intelligence filters by using Dashboard Designer Create Time Intelligence filters by using Dashboard Designerdescribes how to create a dynamic time filter for a dashboard that remains up to date automatically. You can either create a filter that uses a list of time periods, such as Year to Date or Last Six Months, or you can create a filter that uses a calendar control.


Configure cascading filters by using Dashboard Designer
See also

Published: October 2, 2012

Important:

The ability to create cascading filters as described in this article is available only in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Server 2013. If you are using an earlier version of PerformancePoint Services, you will be unable to perform the procedures that are described in this article.

You can use PerformancePoint Dashboard Designer to create various dashboard filters that you connect to reports and scorecards. When a dashboard filter contains lots of items, dashboard users must spend time scrolling through a list or an expandable tree to select the items they want to use to filter dashboard content. To help eliminate this, you can configure dashboard filters in such a way that one is connected to another. This creates cascading filters. Cascading filters work so that as a dashboard user selects an item in one filter, the list of items in the next is scoped according to what was selected in the first. By including cascading filters in your dashboards, dashboard users can pinpoint the information that they need more efficiently.

For example, suppose that you have created a dashboard to show product sales information for North America. Dashboard users want to view information for specific cities. Rather than create a single filter that contains a long list of states or provinces and cities, you can configure cascading filters. You can create one Country filter that lists Canada and North America. You can then create a States or Provinces filter that lists all the states and provinces in North America, and a Cities filter that lists all the cities. You can connect the Country filter to the States filter and then connect the States filter to the Cities filter. After you publish the dashboard, dashboard users can view information for specific cities by first selecting a Canada or United States by using the Country filter, which narrows the list of items in the States or Provinces filter. Dashboard users can then select a state or province, which narrows the list of items in the Cities filter. Finally, dashboard users can select an item in the Cities filter to view information for a specific city.

When you configure cascading filters for a dashboard, you can add an Apply Filters button. This enables dashboard users to make their filter selections and then apply them all at the same time.

To add cascading filters to a PerformancePoint dashboard, you follow this process:

  1. Create filters to use as cascading filters

  2. Add cascading filters to a dashboard page

Create filters to use as cascading filters

During this phase, you create two or more dashboard filters to use as cascading filters. The dashboard filters must use data that is stored in SQL Server Analysis Services or Power Pivot and should use the same measure.

You can use any of the following filter templates to create your dashboard filters:

  • Member Selection

  • Named Set

  • MDX Query

    Note:

    Before you begin to create a filter by using an MDX query, make sure that you are familiar with MDX. For more information about MDX queries, see Multidimensional Expressions (MDX) Reference (http://go.microsoft.com/fwlink/p/?LinkId=185458).

Use any of the following procedures in this section to create the dashboard filters.

To create a Member Selection filter

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. In the ribbon, on the Create tab, , click Filter.

    The Select a Filter Template dialog box appears.

  3. Click Member Selection, and then click OK.

    The Select a data source page opens.

  4. Use the SharePoint Site and Workspace tabs to select the Analysis Services data source that you want to use for the filter, and then click Next.

    The Select Members page opens.

  5. In the Filter Dimension section, click Select Dimension.

    The Select Dimension dialog box appears.

  6. Select the dimension hierarchy that you want to use for the filter, and then click OK.

  7. On the Select Members page, click Select Members.

  8. Select the members that you want to use for the filter. To specify a default filter selection, right-click an item, and then click Set as Default Selection. Then click OK.

  9. Use the Filter measure list to specify a measure to use for this filter, and then click Next.

    Tip:

    Depending on the cascading filters that you want to create, you should select the same measure for all the filters. For example, suppose that you are creating cascading filters to show product sales across different geographical regions. You create several filters based on different hierarchies in the same Geography dimension. In this case, you would select a sales amount measure for all the geography filters.

  10. On the Select Display Method page, click a display type, and then click Finish.

    Tip:

    As a best practice, we recommend that you select the List display type.

  11. In the Workspace Browser, notice that the default text for the new filter is highlighted. Type a name for the filter, and then press the Enter key.

  12. In the Workspace Browser, right-click the filter, and then click Save.

  13. Take one of the following steps:

    • Repeat this procedure to create another Member Selection filter.

    • Create another filter by following one of the other procedures in this section.

    • Proceed to Add cascading filters to a dashboard page.

To create a Named Set filter

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. In the ribbon, on the Create tab, click Filter.

    The Select a Filter Template dialog box appears.

  3. Click Named Set, and then click OK.

  4. Use the SharePoint Site and Workspace tabs to select the Analysis Services data source that you want to use for the filter, and then click Next.

  5. Use the Select named set list to select a named set that is defined in Analysis Services.

    The MDX expression for the named set is displayed in the Named set expression box.

  6. Use the Filter measure list to specify a measure to use for this filter, and then click Next.

    Tip:

    Depending on the cascading filters that you want to create, you should select the same measure for all the filters. For example, suppose that you are creating cascading filters to show product sales across different geographical regions. You create several filters based on different hierarchies in the same Geography dimension. In this case, you would select a sales amount measure for all the geography filters.

  7. On the Select Display Method page, click a display type, and then click Finish.

    Tip:

    As a best practice, we recommend that you select the List display type.

  8. In the Workspace Browser, notice that the default text for the new filter is highlighted. Type a name for the filter, and then press the Enter key.

  9. In the Workspace Browser, right-click the filter, and then click Save.

  10. Take one of the following steps:

    • Repeat this procedure to create another Named Set filter.

    • Create another filter by following one of the other procedures in this section.

    • Proceed to Add cascading filters to a dashboard page.

To create an MDX Query filter

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. In the ribbon, on the Create tab, , click Filter.

    The Select a Filter Template dialog box appears.

  3. Click MDX Query, and then click OK.

  4. Use the SharePoint Site and Workspace tabs to select the Analysis Services data source that you want to use for the filter, and then click Next.

  5. In the Enter MDX Formula box, specify the multidimensional expressions (MDX) query that you want to use.

  6. Use the Filter measure list to specify a measure to use for this filter, and then click Next.

    Tip:

    Depending on the cascading filters that you want to create, you should select the same measure for all the filters. For example, suppose that you are creating cascading filters to show product sales across different geographical regions. You create several filters based on different hierarchies in the same Geography dimension. In this case, you would select a sales amount measure for all the geography filters.

  7. On the Select Display Method page, click a display type, and then click Finish.

    Tip:

    As a best practice, we recommend that you select the List display type.

  8. In the Workspace Browser, notice that the default text for the new filter is highlighted. Type a name for the filter, and then press the Enter key.

  9. In the Workspace Browser, right-click the filter, and then click Save.

  10. Take one of the following steps:

    • Repeat this procedure to create another MDX Query filter.

    • Create another filter by following one of the other procedures in this section.

    • Proceed to Add cascading filters to a dashboard page.

Add cascading filters to a dashboard page

When you are ready to add cascading filters to a dashboard, you start by creating a new dashboard page. You can either create a new dashboard or open an existing dashboard for editing and then add a new page to it.

To create a new dashboard

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. In the ribbon, on the Create tab, click Dashboard.

    The Select a Dashboard Page Template dialog box appears.

  3. Select a template, and then click OK.

    Tip:

    We recommend that you use a page layout template that enables you to put the cascading filters in a single dashboard zone. An example of such a template is the Header, 2 Columns template.

    You can also edit any page template by adding or removing dashboard zones. For more information, see Configure specific sizes of individual PerformancePoint dashboard zones or items with zones (SharePoint Server 2013).

    The new dashboard opens for editing.

  4. In the Workspace Browser, notice that the default text for the new dashboard is highlighted. Type a name for the dashboard, and then press the Enter key.

  5. Keep the dashboard open, and proceed to add cascading filters and reports to the page.

To add a new page to an existing dashboard

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

    The center pane displays two tabs: SharePoint and Workspace.

  2. Use the SharePoint and Workspace tabs to select the dashboard that you want to edit, and double-click the dashboard to open it for editing.

  3. In the center pane, on the Editor tab, in the Pages section, click New Page.

    The Select a Dashboard Page Template dialog box appears.

  4. Select a template, and then click OK.

    Tip:

    We recommend that you use a page layout template that enables you to put the cascading filters in a single dashboard zone. An example of such a template is the Header, 2 Columns template.

    You can also edit any page template by adding or removing dashboard zones. For more information, see Configure specific sizes of individual PerformancePoint dashboard zones or items with zones (SharePoint Server 2013).

    The new dashboard page opens for editing.

  5. In the Pages section, in the Name column, select the default text for the dashboard page and type a new name. Then press the Enter key.

  6. Keep the dashboard open, and proceed to add cascading filters and reports to the page.

Now that you have set up the dashboard page, the next step is to add cascading filters and reports to the page.

To add cascading filters and reports to a dashboard page

  1. Begin with a blank dashboard page open for editing. In the ribbon, click the Edit tab.

  2. Identify the dashboard zone where you want to put the cascading filters. Click that zone, and then, on the Edit tab, in the Layout group, click Zone Settings.

    The Zone Settings dialog box appears.

  3. On the Orientation tab, select Vertical, and then click OK.

    Note:

    We configure the zone that will contain the cascading filters to use a vertical orientation as a best practice. This helps make it easier for dashboard users to view and use the cascading filters.

  4. In the Details pane, expand Filters, and then expand PerformancePoint Content.

  5. From the Details pane, drag a cascading filter to the dashboard zone. Repeat for each cascading filter. Make sure to arrange them in the correct order in the zone.

  6. (This is optional.) From the Details pane, drag Apply Filters Button to the same zone where the cascading filters are positioned. Make sure to put it at the bottom of the list in the zone.

    Note:

    As a best practice, we recommend that you add the Apply Filters button when you add cascading filters to a dashboard. This enables dashboard users to make filter selections and then apply those selections all at the same time. In addition, reports and scorecards do not refresh until a dashboard user clicks the Apply Filters button.

  7. In the Details pane, expand Scorecards (or Reports), and then expand PerformancePoint Content.

  8. From the Details pane, drag a scorecard (or a report) to a zone in the dashboard.

  9. Repeat Steps 7-8 until you have added all the report types that you want to use in the dashboard.

  10. In the Workspace Browser, right-click the dashboard, and then click Save to save your changes. Do not close the dashboard.

Now that you have added dashboard items to the page, the next step is to connect the cascading filters.

To connect cascading filters

  1. Begin with the dashboard page open for editing. Locate the top-level cascading filter.

  2. Click the down arrow for a cascading filter, and then click Create Connection.

    The Connection dialog box appears.

  3. On the Items tab, use the Send values to list to select the next level cascading filter.

  4. On the Values tab, use the Source value list to select an item, such as Member Unique Name. Then click OK to close the Connection dialog box.

  5. Locate the next-level cascading filter, and repeat Steps 2-4 for that filter.

  6. Repeat Step 5 until you reach the lowest-level cascading filter.

  7. Locate the lowest-level cascading filter. Click the down arrow for that filter, and then click Create Connection.

    The Connection dialog box appears.

  8. On the Items tab, use the Send values to list to select a report or a scorecard to which you want to connect the filter.

  9. On the Values tab, select a combination of values by using the Connect to list and the Source value list.

    Depending on how a report or scorecard is configured, the list of options that are available in the Connect to and Source value lists will vary. By using these lists, you can choose from many combinations. For example, you can select a page, row, or column in one list, and Display Value or Member Unique Name in the other list.

    Although it might seem as if you can select any combination of values in the Connect to and Source value lists, not all combinations will work correctly. You will not see whether a filter connection works until you publish the dashboard to a SharePoint site, such as a designated location where you can preview and test the dashboard.

    Some examples of combinations that work are listed in the following table.

    Connect to list item Source value list item Description

    Measures

    Member Unique Name

    This configuration causes the filter to display information in a report or a scorecard for the measure that is used by the filter.

    Dimension Hierarchies on Rows or Columns

    Member Unique Name

    This configuration causes the filter to replace rows or columns in a report or scorecard to be replaced with the item or items that dashboard consumers select by using the filter.

    Axis, Page, Row, Column, or Row (or Column) Hierarchies

    Display Value

    This configuration causes member captions from a report or scorecard's underlying database to be displayed in the report or scorecard when the filter is applied. (Member captions resemble labels like "Baseball Bats" or "Baseball Gloves.")

  10. (This is optional.) To apply a formula that additionally filters the content, click the Connection Formula button. The Connection Formula dialog box appears.

    In the Connection Formula dialog box, type a formula that will be applied to filter the data before it reaches the report or scorecard. Depending on the filter that you are connecting, the formula that you specify can include a Time Intelligence statement or an MDX query. For example, if you are connecting a Time Intelligence Connection Formula filter to a report or a scorecard, you can only specify a Time Intelligence statement.

    After you have specified your formula, click OK to close the Connection Formula dialog box.

  11. Click OK to close the Connection dialog box. In the center pane of the workspace, in the Connections box for the report or scorecard, you can see the name of the filter that you have connected to it.

  12. Repeat Steps 7-11 for each item that you want to connect to the cascading filters.

  13. In the Workspace Browser, right-click the dashboard, and then click Save. Deploy the dashboard to view and test the cascading filters.

    Important:

    When you connect a filter to another filter, a report, or a scorecard, you can create an invalid filter connection that will only exhibit problems when you view the dashboard in its SharePoint site. When an invalid filter connection is made, a report or scorecard displays unexpected content or an error message. If this occurs, reconfigure the filter connection.

See also

Create dashboard filters by using Dashboard Designer

Overview of PerformancePoint dashboard filters and connections
Plan, design, and implement a PerformancePoint dashboard to show organizational performance


Create Custom Table filters by using Dashboard Designer (SharePoint Server 2013)
See also

Published: October 2, 2012

Summary: Learn how to create a custom table filter with PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013

When you use PerformancePoint Dashboard Designer to create a dashboard filter, you can select from various filter templates that include the Custom Table filter template. You would use the Custom Table filter template in situations such as those that are described in the following list:

  • You want to create one dashboard filter that pulls in data from multiple data sources. That filter will then be connected to multiple reports and scorecards in the dashboard.

  • You want to specify the names of the items that you use in the filter, instead of using the default names that are used in the data source that you plan to use for the filter.

  • You want to create your own list of items to use in the filter and then map that list to similar kinds of items that are in a database.

When you create a dashboard filter by using the Custom Table filter template, you typically use the following process:

  1. Phase 1: Create and save a table.

  2. Phase 2: Create a tabular data source.

  3. Phase 3: Create the dashboard filter.

Phase 1: Create and save a table

During this phase, you use an application such as Excel to construct a table. The table that you create is used as a mapping table to map database members to fully qualified names. This enables you to bring together information from different data sources in a single table, or to configure the names of the members that dashboard users will see.

Tip:

In this article, we assume that you use Excel to create and configure the custom table. However, you can also use a SharePoint list or a table in SQL Server.

To create a table to use with a Custom Table dashboard filter

  1. Using Excel, create a data table that contains the items that you want to use for the dashboard filter.

  2. Make sure to organize the data into columns, with one column for each kind of information. For example, you might have one column that contains regions/countries, and another that contains cities.

  3. Decide which columns will be used for the following purposes in the filter:

    • Members This column contains the members that you want to include in the filter. If you are creating a hierarchical structure in the filter, the members in this column are second-level members in the hierarchy.

      During Phase 3, when you create the dashboard filter, you will select this "Members" column as the Key column in Dashboard Designer.

    • Parent members This column contains the parent members that you want to include in the filter. These members are at a level higher than the "Members" column. If you are creating a hierarchical structure in the filter, the parent member names are the first-level members in the hierarchy. Depending on the table that you use, you might not specify a column for parent members.

      During Phase 3, when you create the dashboard filter, you will select this "Parent members" column as the Parent Key column in Dashboard Designer.

    • Display names This column contains the member names that you want dashboard users to see in the dashboard. Depending on the table that you use, you might not specify a column for default members.

      During Phase 3, when you create the dashboard filter, you will select this "Display names" column as the Display value column.

    • Default This column should contain only the values "True" and "False," and it should be configured as a dimension that has no aggregation.

      During Phase 3, when you create the dashboard filter, you could use this "Default" column as the Is default column in Dashboard Designer. However, you are not required to have a "Default" column to create the filter.

  4. Save the file to your computer, and then proceed to create a tabular data source in Dashboard Designer.

Phase 2: Create a tabular data source

During this phase, you create a data connection that uses the table that you created during Phase 1.

To create a tabular data source that uses the custom table

  1. In Dashboard Designer, in the Workspace Browser, click Data Connections.

  2. On the Create tab, in the Dashboard Items group, click Data Source.

    The Select a Data Source Template dialog box appears.

  3. In the Template pane, click Import from Excel Workbook, and then click OK.

    Tip:

    In this article, we assume that you used Excel to create the custom table. If you used a SharePoint list or a table in SQL Server, make sure that you select the appropriate tabular data source template.

    In the center pane, on the Editor tab, click Import.

  4. Locate the Excel workbook that you created, and then click Open.

    Tip:

    If an Edit data in Excel dialog box appears, specify whether to use column headers that might be on the first row of the Excel workbook. Select or clear the Headers on First Row check box, and then click either Discard changes or Accept changes.

    The data in the Excel workbook is displayed in the center pane.

  5. In the center pane, click the Properties tab.

  6. In the Name box, type the name that you want to use for the data source.

  7. (This step is optional.) To specify a location for the data source, click the Display Folder button, and then select or create a folder.

  8. In the Workspace Browser, right-click the data source, and then click Save. Proceed to create the dashboard filter.

Phase 3: Create the dashboard filter

During this phase, you create a dashboard filter by using the Custom Table filter template in Dashboard Designer.

To create a dashboard filter that uses the Custom Table filter template

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, in the Dashboard Items group, click Filter.

    The Select a Filter Template dialog box appears.

  3. In the Select a Filter Template dialog box, click Custom Table, and then click OK.

    The Create a Filter wizard opens.

  4. On the Select a Data Source page, select the data source that you want to use, and then click Next.

    • Use the SharePoint Site tab to view a list of data sources that have been saved to SharePoint Server 2013.

    • Use the Workspace tab to view a list of data sources that you have created or used.

  5. On the Preview Table page, view the information that is available in the table that you selected. Make sure to note which columns that you want to use for the dashboard filter, and then click Next.

  6. On the Choose Key Columns page, specify which columns to use as Key, Parent key, Display value, and Is default settings.

    • Use the Key list to specify the column that contains the members that you want to use in the filter. If you are creating a filter that has a hierarchical structure, the Key column represents second-level members in the filter hierarchy.

    • Depending on whether you are creating a filter that has a hierarchical structure, use the Parent Key list to specify the column that contains the members that you want to designate as first-level members in the filter hierarchy. Otherwise, set the Parent key list to (None).

    • Use the Display Value list to specify the column that contains the members that you want to designate as captions for your filter. PerformancePoint Services passes those captions to any scorecards and reports that are linked to the filter.

    • In general, set the Is default list to (None).

      If the data source contains a dimension that contains "True" and "False" values and that dimension has no aggregation, you can select that dimension in the Is default list.

      Important:

      Do not use the Is default list to select a column that contains text or non-numeric values. Otherwise, an error message will occur in the dashboard.

    Click Next.

  7. In the Select Display Method page, select one of the following display types:

    • List Select this option to display the filter as a simple list in a drop-down menu. When you use this display type, dashboard consumers click an item in the list to specify what information to display.

    • Tree Select this option to display the filter as a list that includes an expandable tree control in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select one item or a group of items to apply as a filter.

    • Multi-Select Tree Select this option to display the filter as a list that includes an expandable tree control that has check boxes in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select the check boxes for the items that they want to use as a filter.

    After you select the display type that you want to use for your filter, click Finish.

  8. In the center pane, click the Properties tab.

  9. In the Name box, type the name that you want to use for the filter.

  10. (This step is optional.) To specify a location for the filter, click the Display Folder button, and then select or create a folder.

  11. In the Workspace Browser, right-click the filter, and then click Save.

After you have created your filter, you can add it to a dashboard page and then connect it to one or more dashboard items. For more information, see Connect filters to reports or scorecards by using Dashboard Designer (SharePoint Server 2013).

See also

Create dashboard filters by using Dashboard Designer


Create MDX Query filters by using Dashboard Designer
See also

Published: October 2, 2012

Summary: Learn how to create MDX query filters using PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013

When you use PerformancePoint Dashboard Designer to create a dashboard filter, you can select from various filter templates that include the MDX Query filter template. You can use the MDX Query template to create a list of items by specifying a Multidimensional Expressions (MDX) query to select a group of items in a database.

The MDX Query template works with data that is stored in SQL Server Analysis Services. For more information about dashboard filters, see Overview of PerformancePoint dashboard filters.

Note:

Before you begin to create a filter by using an MDX query, make sure that you are familiar with MDX. For more information about MDX queries, see Multidimensional Expressions (MDX) Reference (http://go.microsoft.com/fwlink/p/?LinkId=185458).

To create an MDX Query filter

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, click Filter.

    The Select a Filter Template dialog box opens.

  3. In the Select a Filter Template dialog box, click MDX Query, and then click OK.

    The Create a Filter wizard opens.

  4. On the Select a Data Source page, select the Analysis Services data source that you want to use, and then click Next.

    • Use the SharePoint Site tab to view a list of data sources that have been saved to SharePoint Server 2013.

    • Use the Workspace tab to view a list of data sources that you have created or used.

  5. On the Enter MDX Formula page, type an MDX query to select the items that you want to use for the filter.

    The MDX query that you select might resemble the examples that are shown in the following table.

    Query Description

    [Product].[Category].members

    Create a list of the product categories that are in the Products dimension in the data cube.

    TOPCOUNT([Reseller].[Reseller].[Reseller].MEMBERS.10.([Geography].[Country].[United States]. [Measures].[Reseller Sales Amount]))

    Create a list of the top 10 resellers in the United States.

  6. Click Next.

  7. On the Select Display Method page, select one of the display types shown in the following table.

    Display method Description

    List

    Select this option to display the filter as a simple list in a drop-down menu. When you use this display type, dashboard consumers click an item in the list to specify what information to display.

    Tree

    Select this option to display the filter as a list that includes an expandable tree control in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select one item or a group of items to apply as a filter.

    Multi-Select Tree

    Select this option to display the filter as a list that includes an expandable tree control that has check boxes in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select the check boxes for the items that they want to use as a filter.

    After you select the display type that you want to use for the filter, click Finish.

  8. In the center pane, click the Properties tab.

  9. In the Name box, type the name that you want to use for the filter.

  10. (This step is optional.) To specify a location for the filter, click the Display Folder button, and then select or create a folder.

  11. In the Workspace Browser, right-click the filter, and then click Save.

After you have created the filter, you can add it to a dashboard page, and then connect it to one or more dashboard items. For more information, see Connect filters to reports or scorecards by using Dashboard Designer (SharePoint Server 2013).

See also

Create dashboard filters by using Dashboard Designer
Assemble dashboard pages and link items together by using Dashboard Designer


Create Member Selection filters by using Dashboard Designer
See also

Published: October 2, 2012

Summary: Learn how to create member selection filters by using PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013

When you use PerformancePoint Dashboard Designer to create a dashboard filter, you can select from various filter templates that include the Member Selection filter template. You can use the Member Selection template to create a list of items by selecting individual members that are in a database. The Member Selection template works with data that is stored in SQL Server 2005 Analysis Services (SSAS), SQL Server 2008 R2 Analysis Services (SSAS), SQL Server 2012 Analysis Services (SSAS) or any tabular data source that contains members.

To create a Member Selection filter

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, click Filter.

    The Select a Filter Template dialog box appears.

  3. In the Select a Filter Template dialog box, click Member Selection, and then click OK.

    The Create a Filter wizard opens.

  4. On the Select a Data Source page, select the data source that you want to use, and then click Next.

    • Use the SharePoint Site tab to view a list of data sources that were saved to SharePoint Server 2013.

    • Use the Workspace tab to view a list of data sources that you have created or used.

  5. On the Select Members page, specify the members that you want to use for the dashboard filter.

    1. Click Select Dimension to open the Select Dimension window.

    2. In the Select Dimension window, click the dimension hierarchy that you want to use for your dashboard filter, and then click OK.

      The Select Dimension window closes, and on the Select Members page, the Select Members button is enabled.

    3. Click the Select Members button to open the Select Members window.

      In the Select Members window, expand the list of dimension members.

    4. Select the members that you want to use for the dashboard filter by using one of the methods shown in the following table.

      Method and description Procedure

      Select parameterized filter options

      This option enables you to create a dashboard filter that remains up to date as the data cube changes.

      For example, suppose that you create a "Products" filter to display a list of product categories, and that new product categories will be added to the data cube after you have deployed your dashboard. If you use this method, your filter will automatically display the new product categories without requiring the dashboard filter to be changed.

      Do one of the following:

      • Right-click a level in the expandable tree, and then select an option, such as Select Children.

      • Right-click a level, click Autoselect Members, and then select an option, such as Select Children, Select Leaves, or Select All Descendants.

      Terms such as Children and Descendants are set functions that work with SQL Server Analysis Services. For more information, see MDX Function Reference (MDX) (http://go.microsoft.com/?linkid=9729738).

      Select members to create a static list

      This option enables you to create a dashboard filter that lists items that you specify.

      Select the check boxes of the dimension members that you want to include in your filter.

      Tip:

      Some members might contain next-level members. When a member contains other members, a plus sign (+) appears next to that member. You can either select a member at the first level, or expand the list and select one or more members at the next lower level.

    5. (This step is optional.) Right-click the dimension member or members that you want to specify as the default filter selection, and then click Set as Default Selection.

      By default, the items that you select will be selected in the deployed dashboard before dashboard users apply the filter. You can select All or any individual item.

    6. Click OK to return to the Select Members page.

    7. Click Next.

  6. On the Select Display Method page, select one of the display types shown in the following table.

    Display method Description

    List

    Select this option to display the filter as a simple list in a drop-down menu. When you use this display type, dashboard consumers click an item in the list to specify what information to display.

    Tree

    Select this option to display the filter as a list that includes an expandable tree control in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select one item or a group of items to apply as a filter.

    Multi-Select Tree

    Select this option to display the filter as a list that includes an expandable tree control that has check boxes in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select the check boxes for the items that they want to use as a filter.

    After you select the display type that you want to use for your filter, click Finish.

  7. In the center pane, click the Properties tab.

  8. In the Name box, type the name that you want to use for the filter.

  9. (This step is optional.) To specify a location for the filter, click the Display Folder button, and then select or create a folder.

  10. In the Workspace Browser, right-click the filter, and then click Save.

After you have created your filter, you can add it to a dashboard page and then connect it to one or more dashboard items. For more information, see Connect filters to reports or scorecards by using Dashboard Designer (SharePoint Server 2013).

See also

Assemble dashboard pages and link items together by using Dashboard Designer


Create Named Set filters by using Dashboard Designer
See also

Published: October 2, 2012

Summary: Learn how to create a named set filter by using PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013

When you use PerformancePoint Dashboard Designer to create a dashboard filter, you can select from various filter templates that include the Named Set filter template. You can use the Named Set template to create a list of items by selecting a group of items that was defined as a set in a database. The Named Set template works with data that is stored in SQL Server Analysis Services. For more information about dashboard filters, see Overview of PerformancePoint dashboard filters.

To create a Named Set filter

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, click Filter.

    The Select a Filter Template dialog box opens.

  3. In the Select a Filter Template dialog box, click Named Set, and then click OK.

    The Create a Filter wizard opens.

  4. On the Select a Data Source page, select the data source that you want to use, and then click Next.

    • Use the SharePoint Site tab to view a list of data sources that have been saved to SharePoint Server 2013.

    • Use the Workspace tab to view a list of data sources that you have created or used.

  5. On the Select Named Set page, use the Select named set list to select the group of items that you want to use for the filter.

    The Named set expression box displays the Multidimensional Expressions (MDX) query that the server uses to define that named set.

  6. Click Next.

  7. On the Select Display Method page, select one of the display types shown in the following table.

    Display method Description

    List

    Select this option to display the filter as a simple list in a drop-down menu. When you use this display type, dashboard consumers click an item in the list to specify what information to display.

    Tree

    Select this option to display the filter as a list that includes an expandable tree control in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select one item or a group of items to apply as a filter.

    Multi-Select Tree

    Select this option to display the filter as a list that includes an expandable tree control that has check boxes in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select the check boxes for the items that they want to use as a filter.

    After you select the display type that you want to use for the filter, click Finish.

  8. In the center pane, click the Properties tab.

  9. In the Name box, type the name that you want to use for the filter.

  10. (This step is optional.) To specify a location for the filter, click the Display Folder button, and then select or create a folder.

  11. In the Workspace Browser, right-click the filter, and then click Save.

After you have created the filter, you can add it to a dashboard page, and then connect it to one or more dashboard items. For more information, see Connect filters to reports or scorecards by using Dashboard Designer (SharePoint Server 2013).

See also

Create dashboard filters by using Dashboard Designer
Assemble dashboard pages and link items together by using Dashboard Designer


Create Time Intelligence filters by using Dashboard Designer
See also

Published: October 2, 2012

Summary: Learn how to create Time Intelligence filters by using PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013

When you use PerformancePoint Dashboard Designer to create a dashboard filter, you can select from various filter templates that include two Time Intelligence filter templates: the Time Intelligence filter template, and the Time Intelligence Connection Formula filter template.

  • Use the Time Intelligence filter template to create a dashboard filter that contains a list of rolling time periods that you specify. Some examples of time periods that you might use include Last Two Years, Last Six Months, and Last 30 Days. See To create a Time Intelligence filter.

  • Use the Time Intelligence Connection Formula filter template to create a dashboard filter that uses a calendar control that dashboard users can use to view information as of a particular date. By default, the calendar control is set to the current date in the dashboard. However, dashboard users can use it to select a different date. See To create a Time Intelligence Connection Formula filter.

Important:

Regardless of which template that you select for a dashboard filter, Time Intelligence filters will only work with data sources that have been configured to work with Time Intelligence. This applies not only to the data source that you use for each filter, but also to the data sources that are used by the scorecards and reports to which you want to connect a Time Intelligence dashboard filter. For more information, see Configure data sources to work with Time Intelligence by using Dashboard Designer.

In this article:

  • Create a dashboard filter by using the Time Intelligence filter template

  • Create a dashboard filter by using the Time Intelligence Connection Formula filter template

Create a dashboard filter by using the Time Intelligence filter template

To create a Time Intelligence filter

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, click Filter.

  3. In the Select a Filter Template dialog box, click Time Intelligence, and then click OK.

  4. On the Select a Data Source page, click Add Data Source.

    The Select a Data Source dialog box opens.

  5. Select the data source that you want to use, and then click OK.

    • Use the SharePoint Site tab to view a list of data sources that have been saved to SharePoint Server 2013.

    • Use the Workspace tab to view a list of data sources that you have created or used.

  6. Click Next.

  7. On the Enter Time Formula page, specify the list of items that you want to include in the filter. Do so by using the following procedure:

    1. Click a cell in the Formula column, and specify a Time Intelligence formula.

      The formula that you type might resemble one of the examples shown in the following table:

      Time Intelligence formula Description

      YearToDate

      Displays year-to-date information.

      Year:Year-2

      Displays information for a three-year period of time, from the current year to three years ago.

      Month:Month-5

      Displays information for the past six months.

      Week

      Displays information for the current week.

      For more examples of formulas that you can use, see PerformancePoint Time Intelligence quick reference.

    2. In the Display Name column, click the placeholder text, and then type a new phrase for the filter. For example, if you used YearToDate in the Formula column, you might type Year to Date in the Display Name column.

    3. Repeat steps a and b for each item that you want to use in the filter.

    4. Click the Preview button to test all the formulas that you specified. A Time Intelligence Preview window opens.

    5. In the Time Intelligence Preview window, verify that the formulas will work correctly.

      • If you receive a message that states that the data source has an invalid Time Intelligence configuration, you must configure the data source to work with Time Intelligence. Close the Time Intelligence Preview window, cancel the Create a Filter wizard, and then configure the data source. For more information, see Configure data sources to work with Time Intelligence by using Dashboard Designer.

      • If you receive a message that states that one or more of the formulas that you specified does not work, close the Time Intelligence Preview window and then configure those formulas. Next, click the Preview button to try again.

  8. After you have created and verified that the Time Intelligence formulas work, click Next.

  9. On the Select Display Method page, select one of the display types shown in the following table.

    Display method Description

    List

    Select this option to display the filter as a simple list in a drop-down menu. When you use this display type, dashboard consumers click an item in the list to specify what information to display.

    Tree

    Select this option to display the filter as a list that includes an expandable tree control in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select one item or a group of items to apply as a filter.

    Multi-Select Tree

    Select this option to display the filter as a list that includes an expandable tree control that has check boxes in a drop-down menu. When you use this display type, dashboard consumers expand the tree control, and then they select the check boxes for the items that they want to use as a filter.

    After you select the display type that you want to use for your filter, click Finish.

  10. In the center pane, click the Properties tab.

  11. In the Name box, type the name that you want to use for the filter.

  12. (This step is optional.) To specify a location for the filter, click the Display Folder button, and then select or create a folder.

  13. In the Workspace Browser, right-click the filter, and then click Save.

After you have created a Time Intelligence or Time Intelligence Connection Formula filter, your next step is to connect it to a report or a scorecard. For more information, see Connect filters to reports or scorecards by using Dashboard Designer (SharePoint Server 2013) and Use the Connection Formula dialog box in Dashboard Designer to configure a filter connection (SharePoint Server 2013).

Create a dashboard filter by using the Time Intelligence Connection Formula filter template

When you create a Time Intelligence Connection Formula filter, you do this in two phases:

  1. You create a dashboard filter by using the Time Intelligence Connection Formula filter template.

  2. You connect the filter to a report or a scorecard, and you use the Connection Formula dialog box to specify a Time Intelligence formula. You can connect the Time Intelligence Connection Formula filter to multiple reports and scorecards. However, you configure each connection separately and specify a formula for each connection.

To create a Time Intelligence Connection Formula filter

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. On the Create tab, click Filter.

  3. In the Select a Filter Template dialog box, click Time Intelligence Connection Formula, and then click OK.

  4. On the Select a Data Source page, click Add Data Source.

    The Select a Data Source dialog box opens.

  5. Select the data source that you want to use, and then click OK.

    • Use the SharePoint Site tab to view a list of data sources that have been saved to SharePoint Server 2013.

    • Use the Workspace tab to view a list of data sources that you have created or used.

  6. Click Next.

  7. On the Select Display Method page, click Finish.

    Tip:

    Notice that you did not specify any formulas or display methods. You specify a connection formula when you connect this filter to a report or a scorecard. In addition, the Time Intelligence Connection Formula filter only uses a calendar control.

  8. In the center pane, click the Properties tab.

  9. In the Name box, type the name that you want to use for the filter.

  10. (This step is optional.) To specify a location for the filter, click the Display Folder button, and then select or create a folder.

  11. In the Workspace Browser, right-click the filter, and then click Save.

    Important:

    At this point, you have created a Time Intelligence Connection Formula. However, you have not specified a formula the filter will use to display particular information. You must proceed to configure the connection between the Time Intelligence Connection Formula filter and a report or a scorecard.

When you connect a Time Intelligence Connection Formula filter to reports and scorecards in a dashboard, you configure each connection separately. Use the following procedure to connect a Time Intelligence Connection Formula filter to a report or a scorecard.

To connect a Time Intelligence Connection Formula filter to a report or a scorecard

  1. In Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

  2. Double-click the dashboard that you want to change to open it.

  3. In the Details pane on the right side of the window, expand the list of available filters. Drag the Time Intelligence Connection Formula filter that you want to use to a dashboard zone.

  4. Within the filter box that you added to the dashboard, click the down arrow located to the right side of the filter name, and then click Create Connection. The Connection dialog box opens, which enables you to configure the connection between the filter and scorecard or report.

  5. Click the Items tab. In the Send values to list, select the scorecard or report that you want to connect to the filter.

  6. Click the Values tab, and then select a combination of values by using the Connect to list and the Source value list.

    Depending on how the scorecard is configured, the list of options that are available in the Connect to and Source value lists will vary. By using these lists, you can choose from many combinations. For example, you can select a page, row, or column in one list, and Display Value or Member Unique Name in the other list.

    Although it might seem as if you can select any combination of values in the Connect to and Source value lists, not all combinations will work correctly. Some examples of combinations that work are listed in the following table.

    Connect to list item Source value list item Description

    TI formula

    Formula

    This configuration only works with PerformancePoint scorecards. It uses a Time Intelligence formula and causes the scorecard to display information for the specified time period.

    Current date-time

    Current date-time

    This configuration only works with PerformancePoint scorecards. It does not require a Time Intelligence formula and causes the scorecard to display information as of the current date.

    Axis, Page, Row, Column, or Row (or Column) Hierarchies

    Member Unique Name

    This configuration works with PerformancePoint reports and scorecards. It uses a report or scorecard member's fully qualified member name together with a Time Intelligence formula and causes the scorecard or report to display information about dimension members for the specified time period.

    Time dimension

    Data source

    This configuration works with analytic charts and grids. It uses a Time Intelligence formula and causes the analytic chart or grid to display information for the specified time period.

  7. Click the Connection Formula button. The Connection Formula dialog box opens.

  8. In the Connection Formula dialog box, type a Time Intelligence formula. The formula that you type might resemble one of the examples shown in the following table.

    Time Intelligence Formula Description

    Day

    Displays information as of the date that is selected in the calendar control.

    Quarter:Quarter-3

    Displays information for the last four quarters as of the date that is selected in the calendar control.

    YearToDate

    Displays year-to-date information as of the date that is selected in the calendar control.

    For more examples of formulas that you can use, see PerformancePoint Time Intelligence quick reference.

  9. Click OK to close the Connection Formula dialog box.

  10. Click OK to close the Connection dialog box. In the center pane of the workspace, in the Connections box for the report or scorecard, you can see the name of the filter that you have connected to it.

  11. In the Workspace Browser, right-click the dashboard and then click Save.

    Deploy the dashboard to view and test the filter connection.

    Important:

    When you connect a filter to a scorecard, you can create an invalid filter connection that you might not notice until you deploy the dashboard and view it in a SharePoint site. When an invalid filter connection is made, a scorecard might display unexpected content or an error message. If this occurs, reconfigure the filter connection.

See also

Use the Connection Formula dialog box in Dashboard Designer to configure a filter connection (SharePoint Server 2013)
Assemble dashboard pages and link items together by using Dashboard Designer


Create and assemble a dashboard page by using Dashboard Designer (SharePoint Server 2013)

Summary: Learn how to create and assemble a dashboard page by using PerformancePoint Dashboard Designer in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

When you and other dashboard authors have created the reports and scorecards that you want to display in a dashboard, you are ready to create and assemble the dashboard pages.

TechNet articles about how to set up dashboard pages

Read the following articles to learn how to set up your dashboard pages by using PerformancePoint Dashboard Designer.

Building blocks Content | Description
Create dashboard pages by using Dashboard Designer (SharePoint Server 2013) | When you have created one or more views to display in a dashboard, you are ready to create dashboard pages to contain those dashboard items.
Configure specific sizes of individual PerformancePoint dashboard zones or items with zones (SharePoint Server 2013) | Each template for a dashboard page contains one or more zones in a particular arrangement. However, you can easily add zones, remove zones, and configure the sizes of your zones.
Assemble dashboard pages and link items together by using Dashboard Designer | After you have created dashboard items, such as pages, report views, and filters, your next step is to assemble your dashboard pages by using Dashboard Designer.


Create dashboard pages by using Dashboard Designer (SharePoint Server 2013)
See also

Summary: Learn how to create dashboard pages by using PerformancePoint Dashboard Designer in SharePoint Server 2013.

Applies to: SharePoint Server 2013

When you and other dashboard authors have created one or more views to display in a dashboard, you are ready to create dashboard pages to contain those dashboard items. Read this article to learn how to create dashboard pages by using PerformancePoint Dashboard Designer.

Use Dashboard Designer to create dashboard pages

When you use Dashboard Designer to create your dashboard pages, you start by selecting a page template. You can change the page layout template selected for each page, and then you can add items to the pages.

To create the first page of a dashboard

  1. In Dashboard Designer, in the Workspace Browser, click PerformancePoint Content.

  2. In the ribbon, click the Create tab.

  3. In the ribbon, in the Dashboard Items group, click Dashboard.

    The Select a Dashboard Page Template dialog box opens.

  4. Select a page layout for the dashboard page, and then click OK.

    You can select from seven different page layout templates, as in the following list:

    • 1 Zone

    • 2 Columns

    • 2 Rows

    • 3 Columns

    • 3 Rows

    • Column, Split Column

    • Header, 2 Columns

    Tip:

    Select the page layout template that is best suited for the dashboard content that you want to display. For example, if you have only one report or scorecard to display, you might select the 1 Zone template. On the other hand, if you have several reports and a dashboard filter to display, you might select the Header, 2 Columns template.

    We recommend that you do not display too many items in a single page. Otherwise, the individual items on the page might not be displayed correctly. You can easily add more pages to a dashboard to display a large number of reports and scorecards in the dashboard.

  5. (This step is optional.) Make changes to the dashboard page layout. For example, you can add or remove a dashboard zone, or configure the sizes of dashboard zones. For more information, see Add, remove, or change the sizes of your zones by using Dashboard Designer.

  6. In the center pane, click the Properties tab.

  7. In the Name box, type the name that you want to use for the dashboard.

    Note:

    The name that you specify applies to the dashboard, not individual dashboard pages.

  8. (This step is optional.) To specify a location for the dashboard, click the Display Folder button, and then select or create a folder.

  9. (This step is optional.) To specify a name for the dashboard page, follow these steps:

    1. In the center pane, click the Editor tab.

    2. In the Pages section, click the dashboard page name to highlight it, and then type a new name for the page.

  10. In the Workspace Browser, right-click the dashboard, and then click Save.

To add pages to a dashboard

  1. Begin with the dashboard open for editing in Dashboard Designer. In the center pane, click the Editor tab.

  2. In the Pages section, click New Page to open the Select a Dashboard Page Template dialog box.

  3. Select a page layout for the dashboard page, and then click OK.

  4. (This step is optional.) Make changes to the dashboard page layout. For example, you can add or remove a dashboard zone, or configure the sizes of dashboard zones. For more information, see Add, remove, or change the sizes of your zones by using Dashboard Designer.

  5. (This step is optional.) To specify a name for the dashboard page, follow these steps:

    1. In the center pane, click the Editor tab.

    2. In the Pages section, click the dashboard page name to highlight it, and then type a new name for the page.

  6. Repeat steps 1-5 for each page that you want to add to the dashboard.

  7. If you want the page navigator displayed, then click the Properties tab and select the Include page list for navigation check box.

  8. In the Workspace Browser, right-click the dashboard, and then click Save.

After you have set up your dashboard pages, you are ready to add items, such as reports, scorecards, and filters, to those dashboard pages.

See also

Assemble dashboard pages and link items together by using Dashboard Designer


Configure specific sizes of individual PerformancePoint dashboard zones or items with zones (SharePoint Server 2013)

Summary: Learn how to configure the sizes of zones on Dashboard Designer in SharePoint Server 2013.

Applies to: SharePoint Server 2013

When you create a dashboard by using PerformancePoint Dashboard Designer, you start by selecting a page template. Each template contains one or more dashboard zones in a particular arrangement. However, you are not limited to those configurations. You can easily add zones, remove zones, and configure the sizes of your zones. And, if you have too many items to fit on one page, you can easily add another page to your dashboard.

Add, remove, or change the sizes of your zones by using Dashboard Designer

After you select a template for your dashboard you can configure the size of one or more zones in your dashboard. As you add zones to a dashboard page, all the zones are automatically resized to accommodate the additional zones.

Tip:

If you add too many zones to a single page, your dashboard items might appear so small that they are difficult to view or are overwhelming for dashboard users. In addition, chart legends might not appear correctly.

To add or remove a zone

  1. In the center pane click the Editor tab.

  2. Right-click the Dashboard Content section, and then click one of the following:

    • Add Left. Adds a new zone to the left of the pointer

    • Add Right. Adds a new zone to the right side of the pointer

    • Add Above. Adds a new zone above the pointer

    • Add Below. Adds a new zone under the pointer

    • Split Zone. Divides the zone nearest the pointer into two zones of equal size

    • Delete Zone. Removes the zone nearest the pointer

To change the size of one or more dashboard zones

  1. In the center pane click the Editor tab.

  2. In the Dashboard Content section, right-click the zone that you want to configure. Or, if the zone contains an item, right-click the header of the zone, and then click Zone Settings. The Zone Settings dialog box opens.

    • On the Size tab, specify width and height settings for the dashboard zone. Zones can only be sized based on percentage and cannot be auto-sized or sized to specific pixel counts.

    • On the Orientation tab, arrange the items in the zone. You can select Horizontal, Vertical, or Stacked. The Horizontal option arranges multiple items in a row. The Vertical option arranges multiple items in a column. The Stacked option layers multiple items in the same location on the dashboard page. Dashboard users use a drop-down list to switch between the items.

    • Click OK to save your changes and close the Zone Settings dialog box.

Add a page to your dashboard by using Dashboard Designer

You can easily group many reports and scorecards in a single dashboard and keep it easy to use by adding pages to your dashboard. And you can use a different template for each page. When you have more than one page in your dashboard, you can display a page navigator across the top of your dashboard, which enables dashboard users to easily navigate through the pages.

To add a page to a dashboard

  1. In the center workspace pane, click the Editor tab. In the Pages section, click New Page to open the Select a Dashboard Page Template dialog box.

  2. If you want the page navigator displayed, then click the Properties tab and check Include page list for navigation.


Assemble dashboard pages and link items together by using Dashboard Designer
See also

Summary: After you have created dashboard items, such as pages, report views, and filters, your next step is to assemble your dashboard pages by using Dashboard Designer.

Applies to: SharePoint Server 2013

Depending on how your dashboards are configured, you might also want to link some items, such as filters, to other items, such as reports.

TechNet articles about how to assemble dashboard pages and link items together by using Dashboard Designer

Read the following articles to assemble your dashboard pages and link items together.

Task | Article
Add dashboard items, such as reports, scorecards, and filters, to a dashboard page. | Add dashboard items to a page by using Dashboard Designer

See also

Resource Center: Business Intelligence in SharePoint Server 2010


Add dashboard items to a page by using Dashboard Designer
See also

Summary: Learn how to add dashboard items to a page by using PerformancePoint Dashboard Designer in SharePoint Server 2013.

Applies to: SharePoint Server 2013

After you have created PerformancePoint dashboard items, such as reports, scorecards, and filters, and dashboard pages, your next step is to add items to the dashboard pages.

Use Dashboard Designer to add items to a dashboard

To add items to a dashboard page, you open a dashboard for editing, and then you add the items that you want to include in the dashboard.

To open a dashboard page for editing in Dashboard Designer

  1. In PerformancePoint Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

  2. Locate a dashboard to which you want to add items.

  3. Double-click the dashboard that you want to change to open it for editing.

  4. If the dashboard contains more than one page, open the page that you want to edit. To do this, follow these steps:

    1. In the center pane, click the Editor tab.

    2. In the Pages section, click the name of the page to which you want to add dashboard items.

To add items to a dashboard page in Dashboard Designer

  1. Begin with a dashboard page open for editing in Dashboard Designer, and the Editor tab displayed.

  2. In the Details pane on the right side of the window, expand the Scorecards, Reports, or Filters list.

  3. Locate the scorecard, report, or filter that you want to add to the dashboard, and then drag it to a dashboard zone.

    As you add items to a dashboard, keep in mind the suggestions in the following list:

    • As a best practice, put dashboard filters in a separate zone from where you put reports and scorecards. Otherwise, items such as chart legends or reports might not be displayed correctly.

    • Consider using the Header, 2 Columns dashboard page template for pages that will include dashboard filters. Then, you can put the filters in the Header zone, and put reports and scorecards in the other zones.

    • If you are adding an Excel Services report to the dashboard, make sure that you use the auto-size setting. Otherwise, additional scrollbars might display in the deployed dashboard. To specify auto-size settings, follow these steps:

      1. Immediately after you have added the Excel Services report to the dashboard, on the Edit tab, in the Layout group, click Edit Item.

        The Item Settings dialog box opens.

      2. On the Size tab, in the Width section, select Auto-size width.

      3. On the Size tab, in the Height section, select Auto-size height, and then click OK.

  4. Repeat steps 2 and 3 for each item that you want to include in the dashboard.

  5. In the Workspace Browser, right-click the dashboard, and then click Save.

  6. Do one of the following tasks:

    • Connect any filters to scorecards or reports. For more information, see Connect filters to reports or scorecards by using Dashboard Designer (SharePoint Server 2013).

    • Add a KPI Details report to the page. For more information, see Add a KPI Details report to a dashboard by using Dashboard Designer (SharePoint Server 2013).

    • Publish the dashboard to SharePoint Server. For more information, see Deploy PerformancePoint dashboards (SharePoint Server 2013).

See also

Create dashboard pages by using Dashboard Designer (SharePoint Server 2013)
Assemble dashboard pages and link items together by using Dashboard Designer

Plan a PerformancePoint dashboard


Connect filters to reports or scorecards by using Dashboard Designer (SharePoint Server 2013)
See also

Published: October 16, 2012

Summary: Learn how to connect filters to reports or scorecards using PerformancePoint Services Dashboard Designer 2013.

Applies to: SharePoint Server 2013 Enterprise

When you create a dashboard using PerformancePoint Dashboard Designer, you can include one or more filters in your dashboard pages, and then link those filters to scorecards and reports. Filters are dashboard elements that you can create and attach to scorecards and reports to restrict the kinds of content that you want to display.

To connect a filter to a report or a scorecard by using Dashboard Designer

  1. In Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

  2. Double-click the dashboard that you want to change to open it.

  3. In the Details pane on the right side of the window, expand the list of available filters. Drag the filter that you want to use to a dashboard zone.

  4. Within the filter box that you added to the dashboard, click the down arrow located to the right side of the filter name, and then click Create Connection. The Connection dialog box appears, which enables you to configure the connection between the filter and dashboard item.

  5. Click the Items tab. In the Send values to list, select the report or scorecard that you want to connect to the filter.

  6. Click the Values tab, and then select a combination of values by using the Connect to list and the Source value list.

    Depending on how the scorecard is configured, the list of options that are available in the Connect to and Source value lists will vary. By using these lists, you can choose from many combinations. For example, you can select a page, row, or column in one list, and Display Value or Member Unique Name in the other list.

    Although it might seem as if you can select any combination of values in the Connect to and Source value lists, not all combinations will work correctly. You will not see whether a filter connection works until you publish the dashboard to a SharePoint site, such as a designated location where you can preview and test the dashboard.

    Some examples of combinations that work are listed in the following table.

    Connect to list item Source value list item Description

    Dimension Hierarchies on Rows or Columns

    Member Unique Name

    This configuration causes the filter to replace rows or columns in a report or scorecard to be replaced with the item or items that dashboard consumers select by using the filter.

    Axis, Page, Row, Column, or Row (or Column) Hierarchies

    Display Value

    This configuration causes member captions from a report or scorecard's underlying database to be displayed in the report or scorecard when the filter is applied. (Member captions resemble labels like "Baseball Bats" or "Baseball Gloves.")

    TI formula (This only applies to Time Intelligence filters.)

    Formula

    This configuration only works with PerformancePoint scorecards. It uses a Time Intelligence formula and causes the scorecard to display information for the specified time period.

    Current date-time (This only applies to Time Intelligence filters.)

    Current date-time

    This configuration only works with PerformancePoint scorecards. It does not require a Time Intelligence formula and causes the scorecard to display information as of the current date.

    Time dimension (This only applies to Time Intelligence filters.)

    Data source

    This configuration works with analytic charts and grids. It uses a Time Intelligence formula and causes the analytic chart or grid to display information for the specified time period.

  7. To apply a formula that additionally filters the content, click the Connection Formula button. The Connection Formula dialog box appears.

    In the Connection Formula dialog box, type a formula that will be applied to filter the data before it reaches the report or scorecard. Depending on the filter that you are connecting, the formula that you specify can include a Time Intelligence statement or an MDX query. For example, if you are connecting a Time Intelligence Connection Formula filter to a report or a scorecard, you can only specify a Time Intelligence statement.

    After you have specified your formula, click OK to close the Connection Formula dialog box.

  8. Click OK to close the Connection dialog box. In the center pane of the workspace, in the Connections box for the report or scorecard, you can see the name of the filter that you have connected to it.

  9. In the Workspace Browser, right-click the dashboard and then click Save. Deploy the dashboard to view and test the filter connection.

    Important:

    When you connect a filter to a report or a scorecard, you can create an invalid filter connection that will only become visible when you view the dashboard in its SharePoint site. When an invalid filter connection is made, a report or scorecard displays unexpected content or an error message. If this occurs, reconfigure the filter connection.

See also

Create dashboard filters by using Dashboard Designer

Overview of PerformancePoint dashboard filters and connections


Use the Connection Formula dialog box in Dashboard Designer to configure a filter connection (SharePoint Server 2013)

Published: October 16, 2012

Summary:Learn how to configure a dashboard filter connection by using the Connection Formula dialog box.

Applies to: SharePoint Server 2013 Enterprise

When you use PerformancePoint Dashboard Designer to connect a filter to a view, you can use the Connection Formula dialog box to specify a formula. The formula that you specify causes the view to display particular information. For example, you can specify a formula to show data for dynamic time periods, such as the last six months. (This is called Time Intelligence.)

The Connection Formula dialog box

You use the Connection Formula dialog box after you have connected a dashboard filter to a view and when you are connecting a Time Intelligence formula to a view. Depending on the formula that you specify, you can use the Connection Formula dialog box to display information in a view for dynamic time periods, such as the last year or the last six months. Or, you can use it to display more detailed results in a view than the filter would otherwise provide.

For example, suppose that you have created a dashboard filter that is called Products. That filter enables dashboard users to select a product category in a list, and then view information about that product category in the views that are connected to the filter. Suppose also that you want one view to show only the five best-selling products for each product category when the filter is applied. You can use the Connection Formula dialog box to specify a query to display that information in the view.

When you use the Connection Formula dialog box, you specify a Time Intelligence formula or a Multidimensional Expressions (MDX) query, depending on the information that you want to display.

Example: Specifying a Time Intelligence formula

Suppose that you create dashboards for the managers in your organization. A marketing manager wants to know how many leads a recent marketing campaign generated for the sales team. The manager also wants to see how many of those leads turned into actual sales over specific time periods, such as the last three months.

The current dashboard includes views that show the number of leads that were generated by each marketing campaign and how many leads were converted to sales. The marketing manager tells you that the dashboard provides good high-level information, but not enough data about specific periods of time.

Your solution is to create a Time Intelligence filter and connect it to your views. In the Connection Formula dialog box, you specify a formula to display information for the last three months. Then, you redeploy the dashboard.

The managers use that Time Intelligence filter to specify the time periods they want to examine, and their views display the appropriate results.

Example: Specifying an MDX query

Suppose that you create dashboards for the managers in your organization. One sales manager has a team that is responsible for multiple geographical regions. Some regional sales representatives are performing much better than other sales representatives are. In addition, the sales representatives in the major cities of each region all have varying sales amounts. The manager wants to know which cities have the highest sales in the individual regions, and how the sales amounts compare among all the cities in a particular region. The manager wants to see all this information in a single dashboard.

Your solution is to create a Geography filter that contains a list of regions. You connect the filter to the analytic views, and then you use the Connection Formula dialog box to specify an MDX query. That query causes the views that are connected to the filter to display information at the city level. Then you link the filter to the analytic charts, and redeploy the dashboard.

The managers use the Geography filter to specify a sales region, and the views automatically display information that is specific to that region. One view shows the top performing cities in the region, and another view shows the sales amounts for all the cities in the region.

Syntax of Connection Formula expressions

You can enter two kinds of expressions in the Connection Formula dialog box: a Time Intelligence expression or an MDX query.

  • A Time Intelligence expression uses the Simple Time Period Specification (STPS) syntax.

    STPS expressions take the form (Period + n) or (Period - n), where "n" is a positive integer that represents the number of time periods to include in a filter. Depending on the data sources that are used by the filter and the items connected to it, you can use time increments such as Year, Month, and Day. For example, (Year - 6) is an STPS expression that you can use to configure your filter to retrieve information for the last six years.

  • An MDX query can include one or more monikers, such as <<SourceValue>> or <<UniqueName>>. These monikers can be used alone or as part of a larger MDX query.

Important:

The specific formula that you use will vary depending on the data sources that are used for your filter and the item that you are connecting to the filter. Not all formulas work with all kinds of reports and scorecards. For example, let's say that you are connecting a filter to a report or scorecard that uses a data source that is not configured to work with Time Intelligence. In that case, the STPS expressions will not work for your filter connection. In addition, when you use some kinds of filters, such as a Time Intelligence Connection Formula filter, you must specify a formula in the Connection Formula dialog box.

Below are several examples of formulas to give you an overview of the kinds of expressions that you can use in the Connection Formula dialog box.

Examples of Time Intelligence expressions

Description | Syntax
Period-to-date functions to show results for a current period up to the current date | YearToDate or MonthToDate
Function to show a set of time periods, such as the most recent six months | (Month-5):Month

Examples of MDX expressions

Description | Syntax
Query that displays the children of a selected member | <<UniqueName>>.Children or <<SourceValue>>.Children
Function to show the top 10 items that are two levels under a selected member | TopCount({Descendants(<<UniqueName>>,2)}


Add a KPI Details report to a dashboard by using Dashboard Designer (SharePoint Server 2013)
See also

Published: October 16, 2012

Summary: Learn how to add a KPI details report to a dashboard created with PerformancePoint Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

Using PerformancePoint Dashboard Designer, you can add a KPI Details report to a dashboard that contains a scorecard. A KPI Details report is useful for providing additional information about scorecard key performance indicator (KPI) values and properties.

To add a KPI Details report, you first open a dashboard for editing, and then you add the KPI Details report to a dashboard page.

Tip:

Before you start, make sure that a KPI Details report exists. For more information, see Create a KPI Details report by using Dashboard Designer (SharePoint Server 2013).

To open a dashboard for editing

  1. In Dashboard Designer, locate the Workspace Browser on the left side of the window, and then click PerformancePoint Content. The center pane displays two tabs: SharePoint and Workspace.

  2. Locate the dashboard to which you want to add a KPI Details report.

    Note:

    Make sure that the dashboard that you select contains a scorecard. A KPI Details report must be connected to a scorecard to display information.

  3. Double-click the dashboard that you want to change to open it for editing.

  4. If the dashboard contains more than one page, open the page that you want to edit. To do this, follow these steps:

    1. In the center pane, click the Editor tab.

    2. In the Pages section, click the name of the page that will contain the KPI Details report.

To add a KPI Details report to a dashboard page

  1. Begin with a dashboard page open for editing in Dashboard Designer, and the Editor tab displayed.

  2. In the Details pane on the right side of the window, expand the list of available reports. Drag the KPI Details report to a dashboard zone.

  3. Within the KPI Details box that you added to the dashboard, click the down arrow located to the right side of the report name, and then click Create Connection. The Connection dialog box opens, which enables you to configure the connection between the KPI Details report and a scorecard.

  4. Click the Items tab. In the Get values from list, select the scorecard that you want to connect to the KPI Details report. (You should see the KPI Details report already listed in the Send values to box.

    Note:

    If the dashboard page contains any dashboard filters, you might see those filters in the Get values from list together with any scorecards that might be there. Although you can connect a filter to a scorecard, filters do not work directly with the KPI Details report. This is because all the information that is displayed in the KPI Details report is determined by where dashboard users click in its accompanying scorecard.

  5. Click the Values tab and locate the Connect to list. In the Connect to list, select Cell.

  6. Use the Source value list to select Cell: Context.

  7. Click OK to close the Connection dialog box. In the center pane of the workspace, in the Connections box for the KPI Details report, you can see the name of the scorecard that you have connected to it.

  8. In the Workspace Browser, right-click the dashboard and then click Save. Deploy the dashboard to view and test the KPI Details report.

See also

Assemble dashboard pages and link items together by using Dashboard Designer


Deploy PerformancePoint dashboards (SharePoint Server 2013)

Published: October 16, 2012

Summary: Learn how to publish a PerformancePoint Dashboard.

Applies to: SharePoint Server 2013 Enterprise

When you have assembled a PerformancePoint Services in SharePoint Server 2013dashboard and are ready to view and use it, you publish it or "deploy it" to a SharePoint document library that contains PerformancePoint dashboards.

Important:

Before you start, make sure that you have at least Design permissions to the top-level SharePoint site that contains the subsite or folder where your dashboard content is stored. Otherwise, you can get an "Access denied" error message when you attempt to publish your dashboard.

To deploy (publish) a PerformancePoint dashboard

  1. Open Dashboard Designer. In the Workspace Browser pane, click PerformancePoint Content. Then, in the ribbon, click the Home tab, and then click Refresh.

  2. In the center pane of the workspace, double-click the dashboard that you want to publish. The Workspace Browser and the center pane refresh to display a list of dashboard items that you and other dashboard authors have saved to SharePoint Server.

  3. (This step is optional.) Click the Editor tab, and verify that each dashboard page contains all the items that you want to include in your dashboard. If you want, you can add or change the items that are in your dashboard. Then, in the Workspace Browser, right-click the dashboard, and then click Save.

  4. In the Workspace Browser, right-click the dashboard, and then click Deploy to SharePoint.

  5. If you are publishing the dashboard for the first time to a SharePoint site, the Deploy To box opens.

    • Select the Dashboards library that you want to use.

    • Use the Master Page list to specify a page template for your dashboard.

    • If your dashboard consists of more than one page, select the Include page list for navigation check box.

    • After you have specified the deployment settings for the dashboard, click OK.

  6. A Deploy to SharePoint Site box opens to display the status of your dashboard deployment. After your dashboard is deployed, a browser window opens to display your dashboard. There, you can view and test your dashboard items. When you are ready to share the dashboard with other users, you can copy the website address (URL) and send it in an e-mail message.


Configure data sources to work with Time Intelligence by using Dashboard Designer
See also

Published: October 30, 2012

Summary: Learn how to configure data sources to work with Time Intelligence using PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

When you want to use Time Intelligence in your PerformancePoint dashboards, make sure that you configure the appropriate data sources correctly to work with Time Intelligence. For example, suppose that you create a dashboard filter that uses Time Intelligence, and you want to connect it to multiple reports and scorecards. The data sources that are used for those items must all be configured to work with Time Intelligence. Otherwise, the dashboard filter will not function correctly.

When you configure a data source to work with Time Intelligence, you specify the values that determine how time will be interpreted for each data source. After a data source connection is created in PerformancePoint Services, the time properties are set on the Time tab. Tabular data sources, which include Excel Services workbooks, Excel workbooks, SharePoint lists, and SQL Server tables, have a different set up page for their time properties compared to SQL Server Analysis Services data sources.

In this section:

  • Configure Analysis Services data source time settings by using Dashboard Designer

  • Configure tabular data source time settings by using Dashboard Designer

  • PerformancePoint Time Intelligence quick reference

See also

PerformancePoint Time Intelligence quick reference
Create Time Intelligence filters by using Dashboard Designer


PerformancePoint Time Intelligence quick reference
See also

Published: October 30, 2012

Summary: Learn which formulas and syntax to use when using Time Intelligence while creating dashboards with PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

PerformancePoint Services in SharePoint Server 2013 includes advanced functionality that includes Time Intelligence. You can use Time Intelligence to display information for dynamic periods of time, such as year to date or last 30 days, in your reports and scorecards. You can also create dashboard filters that use Time Intelligence.

When you include Time Intelligence in your dashboards, you use a particular syntax to create formulas that are known as TI formulas.

Read this article for an overview of the different kinds of TI formulas that you can use. For information about how to use Time Intelligence in your dashboards, see the following articles:

  • Create Time Intelligence filters by using Dashboard Designer

  • Use the Connection Formula dialog box in Dashboard Designer to configure a filter connection (SharePoint Server 2013)

Quick samples

Formula structure:

[(]<Period>[Offset>[)][ <Function>[<Offset>]]]

To display | Formula | Result
Yesterday | day-1 | The previous day relative to the current date
Tomorrow | day+1 | The next day relative to the current date.
The current quarter and today | quarter, day | A set of time periods consisting of the current day and current quarter.
Last 10 days | day:day-9 | A 10-day range including today.
Last 10 days (excluding today) | day-1:day-10 | A 10-day range NOT including today.
Same day last year | (year-1).day | Current date (month and day) for last year. For example, if the current date were December 10, 2012, then (year-1).day would show information for December 10, 2011.
Same month last year | (year-1).month | Current month for last year. For example, if the current month were December, 2012, then (year-1).month would show information for December, 2011.
Same range of a period of six months last year | (year-1).(month-5): (year-1).(month) | From 18 months ago to one year ago. For example, if the current month were December 2012, then (year-1).(month-5): (year-1).month would show information for the time period ranging from June, 2011 to December, 2011.
Same range of months to date for last year | (year-1).firstmonth: (year-1).month | From the first month of last year up to and including the month parallel to the current month this year.
Year to date | yeartodate | A single time period representing the aggregation of values from the beginning of the year up to and including the last completed period. The period corresponds to the most specific time period defined for the data source.
Year to date (by month) | yeartodate.fullmonth | A single time period representing the aggregation of values from the beginning of the year up to and including the last completed month.
Year to date (by day) | yeartodate.fullday | A single time period representing the aggregation of values from the beginning of the year up to and including the last completed day.
Parallel year to date | yeartodate-1 | The aggregation of the same set of default time periods completed in the current year except for the prior year.
Parallel year to date (by month) | (yeartodate-1).fullMonth | The aggregation of time periods last year that is equal to year to date periods for the current year.

General conventions

  • TI formulas are not case-sensitive.

  • White space is ignored.

  • Use parentheses when you use a time period with an offset together with a function.

  • Offsets can be defined on any standard and "to date" time period.

  • The current period is assumed when no offset is specified.

  • Use singular nouns, not plurals in your TI formulas. For example, use "month" and not "months."

Syntax elements

The TI formulas consist of operators, periods and functions. The formula is intentionally simple yet robust.

Operators

Operator | Use
"." | The period or "dot" operator delimits time periods from functions. The string in front of the dot always corresponds to the time period. The string following the dot always corresponds to the time period function. Example: year.firstMonth
"+" or "-" | The plus (+) and minus (-) operators are used to determine the offset relative to the current date. Use the minus sign (-) to specify time periods in the past. Use the plus sign (+) to specify time periods in the future. Example: day-1
"()" | Parentheses are used to group a time period and its offset when you use them together with a function. Required. Example: (year-1).firstMonth:(year-1).month
"," | Commas are used to delimit multiple time periods in the same formula. Example: year, Quarter, Month, day
":" | The colon operator (:) specifies a range of time periods. Example: day:day-4

Standard time periods

Standard time periods supported in PerformancePoint Services include the following:

Period | Example
Year | Year-1, year+2
Quarter | quarter, Quarter-4
Month | Month-2
Week | Week-51
Day | Day-9, day+2
Hour | Hour-12
Minute | minute-30
Second | second+5

Standard time period functions

Time period functions can be applied to any standard time period using the dot operator (.). The functions available in PerformancePoint Services include the following:

Function | Use
FirstQuarter | Specifies the first quarter in a year.
LastQuarter | Specifies the last quarter in a year
FirstMonth | Specifies the first month in a year or quarter.
LastMonth | Specifies the last month in a year or quarter.
FirstWeek | Specifies the first week in a year, quarter, or month.
LastWeek | Specifies the last week in a year, quarter, or month.
FirstDay | Specifies the first day in a week, month, or larger time period.
LastDay | Specifies the last day in a week, month, or larger time period.
FirstHour | Specifies the first hour in a day, week, or larger time period.
LastHour | Specifies the last hour in a day, week, or larger time period.
FirstMinute | Specifies the first minute in an hour, day, or larger time period.
LastMinute | Specifies the last minute in an hour, day, or larger time period.
FirstSecond | Specifies the first minute in a minute, hour, or larger time period.
LastSecond | Specifies the last minute in a minute, hour, or larger time period.

Period-to-date formulas

Period-to-date formulas are new in PerformancePoint Services. Period-to-date calculations aggregate all the time periods to date up to the last completed full period. Incomplete time periods are automatically excluded. By default, they are evaluated to the lowest degree of precision in the data source. For example, if the most specific time period in the data source were days, then the month-to-date expression will aggregate all days from the beginning of the month to the last completed full day in the month. (The opposite is true for standard time periods; these automatically include incomplete periods.) PerformancePoint Services supports the following period-to-date time periods:

Period | Use
YearToDate | Specifies a time period from the beginning of the year to the current period.
QuarterToDate | Specifies a time period from the beginning of the quarter to the current period.
MonthToDate | Specifies a time period from the beginning of the month to the current period.
WeekToDate | Specifies a time period from the beginning of the week to the current period.
DayToDate | Specifies a time period from the beginning of the day to the current period.
HourToDate | Specifies a time period from the beginning of the hour to the current period.
MinuteToDate | Specifies a time period from the beginning of the minute to the current period.

Period-to-date functions

Period-to-date functions enable you to control the level of detail for time periods to include. If, for example, you want to show the year-to-date including up to the last completed full month, you can add a full-period function. PerformancePoint Services supports the following full-period functions:

Function | Effect
FullQuarter | Specifies that the period to date should include up to the last full quarter.
FullMonth | Specifies that the period to date should include up to the last full month.
FullWeek | Specifies that the period to date should include up to the last full week.
FullDay | Specifies that the period to date should include up to the last full day.
FullHour | Specifies that the period to date should include up to the last full hour.
FullMinute | Specifies that the period to date should include up to the last full minute.
FullSecond | Specifies that the period to date should include up to the last full second.

Parallel period-to-date

You can use Time Intelligence to compare values for a set of time periods for the current year to an equivalent set of time periods for the previous year. For example, suppose that the current year to date includes January-July of 2012. You may want to compare this value to the same set of time periods for the previous year; in this case January-July 2011. This is easy to do by using TI formulas. Simply add an offset value to the to-date period.

YearToDate-1

In fact, offsets can be specified on any to-date time period. This also works when a full period function is applied additionally. Remember to use parentheses in this case.

(YearToDate-1).FullMonth

See also

Configure data sources to work with Time Intelligence by using Dashboard Designer
Create Time Intelligence filters by using Dashboard Designer
Use the Connection Formula dialog box in Dashboard Designer to configure a filter connection (SharePoint Server 2013)


Configure tabular data source time settings by using Dashboard Designer
See also

Published: October 30, 2012

Summary: Learn how to configure tabular data source time settings within PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013 Enterprise

When you want to use Time Intelligence in your PerformancePoint dashboards, make sure that you configure the appropriate data sources correctly to work with Time Intelligence. When you configure a data source to work with Time Intelligence, you specify the values that determine how time will be interpreted for each data source. Read this article to learn how to configure tabular data sources, such as Excel Services workbooks, Excel workbooks, SharePoint lists, and SQL Server tables, to work with Time Intelligence.

Semesters, quarters, and weeks are relative, and are based on the start month, whereas years, months, days, hours, minutes, and seconds are absolute and are based on the traditional calendar. In the relative time periods, Time Intelligence treats dates that are earlier than the start month as occurring in the previous year, and dates that are later than the start month as occurring in the current year.

Important:

Always have time dimensions start at the beginning of their respective year, even if that means having empty members for the first half of the year. For example, if the fiscal time dimension year starts on July 1, 2012, but only has data recorded for January 1, 2013, you still must start the fiscal time dimension on July 1, 2012, to ensure that Time Intelligence functions for the full initial fiscal year.

PerformancePoint Services automatically detects date values in a tabular data source.

If the time dimension that you want to use is not listed in the Time Dimensions section, click the View tab to preview the data source. Select the date column in the preview, and then in the Details pane under Column Type, select TimeDimension.

To set time properties in a tabular data source

  1. After creating a tabular data source connection, click the Time tab.

  2. The Time Dimensions section lists the time columns that PerformancePoint Services has auto-detected in the data source. Select the Time Dimension on which to base all Time Intelligence formulas and functions.

  3. In the Time Period Levels section, select the period levels that you want to use.

    Important:

    Time Intelligence for tabular data sources lets you select and use the whole range of levels. This differs from setting time periods in an Analysis Services cube data source, which restricts you to only those time period levels that are built in the cube's time dimension.

  4. In the Fiscal Calendar section, select the month starts the fiscal year. The first day of the selected month is the start date for the year.

  5. Click Save on the toolbar.

See also

Configure data sources to work with Time Intelligence by using Dashboard Designer
Create Time Intelligence filters by using Dashboard Designer
Use the Connection Formula dialog box in Dashboard Designer to configure a filter connection (SharePoint Server 2013)


Configure Analysis Services data source time settings by using Dashboard Designer
See also

Published: October 30, 2012

Summary:Learn how to set time properties in PerformancePoint Services Dashboard Designer for Analysis Services data sources.

Applies to: SharePoint Server 2013 Enterprise

When you want to use Time Intelligence in your PerformancePoint dashboards, make sure that you configure the appropriate data sources correctly to work with Time Intelligence. When you configure a data source to work with Time Intelligence, you specify the values that determine how time will be interpreted for each data source. Read this article to learn how to configure SQL Server Analysis Services (SSAS) data sources to work with Time Intelligence.

Important:

Always have time dimensions start at the beginning of their respective year, even if that means having empty members for the first half of the year. For example, if the fiscal time dimension year starts on July 1, 2011, but only has data recorded for January 1, 2012, you still must start the fiscal time dimension on July 1, 2011, to ensure that Time Intelligence functions for the full initial fiscal year.

To set time properties in an Analysis Services data source

  1. After creating an Analysis Services data connection, click the Time tab.

  2. From the Time Dimension drop-down list, select the time dimension for all Time Intelligence formulas and functions, such as a fiscal time dimension or a traditional calendar time dimension.

  3. From the Reference Member drop-down list, select the start of the time dimension's year by clicking an instance of the year's start date.

    Note:

    If your time dimension uses fiscal years that start on July 1, select an instance of July 1 in the member selector. Note that this could be titled as July 1 in the cube, or it might be represented as FY2012 H1 Q1 M1 D1, or perhaps some other format. If you are using a traditional calendar year time dimension, you would select an instance of January 1.

  4. Select the hierarchy level. This is where you select the precise reference member. For example, indicate if the member represents a day, month, semester, and so on.

  5. Under Reference Date, enter a calendar date that is equal to the period specified by the reference member. In this step, map the cube's time dimension to a traditional calendar.

  6. In the Time Member Associations section, map your time dimension hierarchies (listed under the Member Level column) to defined Time Intelligence hierarchies (listed under the Time Aggregation column).

  7. Click Save on the toolbar.

See also

Configure data sources to work with Time Intelligence by using Dashboard Designer
Create Time Intelligence filters by using Dashboard Designer
Use the Connection Formula dialog box in Dashboard Designer to configure a filter connection (SharePoint Server 2013)


Troubleshooting SharePoint 2013

Updated: April 30, 2013

Summary: Find quick access to information about how to resolve issues with deployments of SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

While we complete troubleshooting information for SharePoint 2013, here are some resources.

Alert icon - exclamation point Release notes for SharePoint 2013

Get Help Support for SharePoint 2013

Checklist icon (not checked) Systems Center Operations Manager articles for SharePoint Server 2010

Checklist icon (not checked) SharePoint Health Analyzer rules reference (SharePoint 2013)

We encourage you to give us your feedback. Your comments, suggestions, and troubleshooting tips can be incorporated into future versions of this content. You can send your feedback to us at ITSPDOCS@microsoft.com.

TechNet articles about troubleshooting SharePoint 2013

The following articles about how to troubleshoot SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Claims authentication does not validate user (SharePoint 2013) | This article describes the tools and techniques that you can use to troubleshoot failed claims-based user authentication attempts.
 | Troubleshoot common fine-grained permissions issues for SharePoint Server 2013 | Learn about how to troubleshoot issues that include fine-grained permission in SharePoint 2013.

Additional resources about planning for SharePoint 2013

The following resources about how to plan for SharePoint 2013 are available from other subject matter experts.

Content Description

House icon

  • SharePoint TechCenter

  • Upgrade and migration resource center

Visit the TechCenter and resource centers to access videos, community sites, documentation, and more.

Code icon

  • SharePoint for developers

  • Build apps for SharePoint

  • Find developer resources for SharePoint 2013, including code samples, training, and SDKs.

Chat icon

  • SharePoint blog

  • To the SharePoint (for IT pros)

  • Office 365 Technical Blog

  • Keep up with news from the teams that create and document SharePoint 2013.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support

Change History

Date | Description
April 30, 2013 | Added link to Troubleshoot common fine-grained permissions issues for SharePoint Server 2013.
July 16, 2012 | Initial publication


Claims authentication does not validate user (SharePoint 2013)
See also
[image]

Published: January 15, 2013

Summary: Because SharePoint 2013 recommends claims-based authentication for user access to web applications, this article describes the tools and techniques that you can use to troubleshoot failed claims-based user authentication attempts.

When users try to connect to a web application, logs record failed authentication events. If you use tools that Microsoft provides and use a systematic approach to examine failures, you can learn about common issues that relate to claims-based authentication and resolve them.

Successful access to a SharePoint resource requires both authentication and authorization. When you are using claims, authentication verifies that the security token is valid. Authorization verifies that access to the resource is allowed, based on the set of claims in the security token and the configured permissions for the resource.

To determine whether authentication or authorization causes an access issue, look closely at the error message in the browser window.

  • If the error message indicates that the user does not have access to the site, then the authentication was successful and the authorization failed. To troubleshoot authorization, try the following solutions:

    • The most common reason for failed authorization when you are using Security Assertion Markup Language (SAML) claims-based authentication is that the permissions were assigned to a user's Windows-based account (domain\user) instead of the user's SAML identity claim.

    • Verify that the user or a group to which the user belongs has been configured to use the appropriate permissions. For more information, see User permissions and permission levels in SharePoint 2013.

    • Use the tools and techniques in this article to determine the set of claims in the user's security token so that you can compare it with the configured permissions.

  • If the message indicates that authentication failed, you have an authentication problem. If the resource is contained within a SharePoint web application that uses claims-based authentication, use the information in this article to start troubleshooting.

Troubleshooting tools

The following are the primary troubleshooting tools that Microsoft provides to collect information about claims authentication in SharePoint 2013:

  • Use Unified Logging System (ULS) logs to obtain the details of authentication transactions.

  • Use Central Administration to verify the details of user authentication settings for SharePoint web applications and zones and configure levels of ULS logging.

  • If you are using Active Directory Federation Services 2.0 (AD FS) as your federation provider for Security Assertion Markup Language (SAML)-based claims authentication, you can use AD FS logging to determine the claims that are in security tokens that AD FS issues to web client computers.

  • Use Network Monitor 3.4 to capture and examine the details of user authentication network traffic.

Setting the level of ULS logging for user authentication

The following procedure configures SharePoint 2013 to log the maximum amount of information for claims authentication attempts.

To configure SharePoint 2013 for the maximum amount of user authentication logging

  1. From Central Administration, click Monitoring on the Quick Launch, and then click Configure diagnostic logging.

  2. In the list of categories, expand SharePoint Foundation, and then select Authentication Authorization and Claims Authentication.

  3. In Least critical event to report to the event log, select Verbose.

  4. In Least critical event to report to the trace log, select Verbose.

  5. Click OK.

To optimize performance when you are not performing claims authentication troubleshooting, follow these steps to set user authentication logging to its default values.

To configure SharePoint 2013 for the default amount of user authentication logging

  1. From Central Administration, click Monitoring on the Quick Launch, and then click Configure diagnostic logging.

  2. In the list of categories, expand SharePoint Foundation, and then select Authentication Authorization and Claims Authentication.

  3. In Least critical event to report to the event log, select Information.

  4. In Least critical event to report to the trace log, select Medium.

  5. Click OK.

Configuring AD FS logging

Even after you enable the maximum level of ULS logging, SharePoint 2013 does not record the set of claims in a security token that it receives. If you use AD FS for SAML-based claims authentication, you can enable AD FS logging and use Event Viewer to examine the claims for security tokens that SharePoint 2013 issues.

To enable AD FS logging

  1. On the AD FS server, from Event Viewer, click View, and then click Show Analytic and Debug Logs.

  2. In the Event Viewer console tree, expand Applications and Services Logs/AD FS 2.0 Tracing.

  3. Right-click Debug, and then click Enable Log.

  4. Open the %ProgramFiles%\Active Directory Federation Services 2.0 folder.

  5. Use Notepad to open the Microsoft.IdentityServer.ServiceHost.Exe.Config file.

  6. Click Edit, click Find, type <source name="Microsoft.IdentityModel" switchValue="Off">, and then click OK.

  7. Change switchValue="Off" to switchValue="Verbose".

  8. Click File, click Save, and then exit Notepad.

  9. From the Services snap-in, right-click the AD FS 2.0 service, and then click Restart.

You can now use Event Viewer on the AD FS server to examine details about claims from the Applications and Services Logs/AD FS 2.0 Tracing/Debug node. Look for events with Event ID 1001.

You can also enumerate claims with an HttpModule or web part or through OperationContext. For more information, see How to Get All User Claims at Claims Augmentation Time in SharePoint 2010. This information about SharePoint 2010 applies also to SharePoint 2013.

Troubleshooting methodology for claims user authentication

The following steps can help you determine the cause of failed claims authentication attempts.

Step 1: Determine the details of the failed authentication attempt

To obtain detailed and definitive information about a failed authentication attempt, you have to find it in the SharePoint ULS logs. These log files are stored in the %CommonProgramFiles%\Microsoft Shared\Web Server Extensions\15\LOGS folder.

You can find the failed authentication attempt in the ULS log files either manually or you can use the ULS Log Viewer.

To find the failed authentication attempt manually

  1. Obtain the user account name that produces the failed authentication attempt from the user.

  2. On the server that is running SharePoint Server or SharePoint Foundation, find the %CommonProgramFiles%\Microsoft Shared\Web Server Extensions\15\LOGS folder.

  3. In the LOGS folder, click Date modified to sort the folder by date, with the most recent at the top.

  4. Try the authentication task againl

  5. In the LOGS folder window, double-click the log file at the top of the list to open the file in Notepad.

  6. In Notepad, click Edit, click Find, type Authentication Authorization or Claims Authentication, and then click Find Next.

  7. Click Cancel, and then read the contents of the Message column.

To use the ULS Viewer, download it from ULS Viewer and save it to a folder on the server that is running SharePoint Server or SharePoint Foundation. After it is installed, follow these steps to locate the failed authentication attempt.

To find the failed authentication attempt with the ULS Viewer

  1. On the server that is running SharePoint Server or SharePoint Foundation, double-click Ulsviewer from the folder in which it is stored.

  2. In the ULS Viewer, click File, point to Open From, and then click ULS.

  3. In the Setup the ULS Runtime feed dialog box, verify that %CommonProgramFiles%\Common Files\Microsoft Shared\Web Server Extensions\15\LOGS folder is specified in Use ULS feed from default log-file directory. If not, click Use directory location for real-time feeds and specify the %CommonProgramFiles%\Microsoft Shared\Web Server Extensions\15\LOGS folder in Log file location.

    For %CommonProgramFiles%, substitute the value from the CommonProgramFiles environment variable of the server that is running SharePoint Server or SharePoint Foundation. For example, if the location is the C drive, %CommonProgramFiles% is set to C:\Program Files\Common Files.

  4. Click OK.

  5. Click Edit, and then click Modify Filter.

  6. In the Filter by dialog box, in Field, click Category.

  7. In Value, type Authentication Authorization or Claims Authentication, and then click OK.

  8. Repeat the authentication attempt.

  9. From the ULS Viewer window, double-click the displayed lines to view the Message portion.

From the claims encoding part of the Message portion for non-OAuth requests, you can determine the authentication method and encoded user identity from the claims-encoded string (example: i:0#.w|contoso\chris). For more information, see SharePoint 2013 and SharePoint 2010 claims encoding.

Step 2: Check configuration requirements

To determine how a web application or zone is configured to support one or more claims authentication methods, use the SharePoint Central Administration website.

To verify the authentication configuration for a web application or zone

  1. From Central Administration, click Application Management on the Quick Launch, and then click Manage web applications.

  2. Click the name of the web application that the user is trying to access, and in the Security group of the ribbon, click Authentication Providers.

  3. In the list of authentication providers, click the appropriate zone (such as Default).

  4. In the Edit Authentication dialog box, in the Claims Authentication Types section, verify the settings for claims authentication.

    • For Windows claims authentication, verify that Enable Windows Authentication and Integrated Windows authentication are selected, and that either NTLM or Negotiate (Kerberos) is selected as needed. Select Basic authentication if it is needed.

    • For forms-based authentication, verify that Enable Forms Based Authentication (FBA) is selected. Verify the values in ASP.NET Membership provider name and ASP.NET Role manager name. These values must match the membership provider and role values that you configured in your web.config files for the the SharePoint Central Administration website, web application, and SharePoint Web Services\SecurityTokenServiceApplication. For more information, see Configure forms-based authentication for a claims-based web application in SharePoint 2013.

    • For SAML-based claims authentication, verify that Trusted identity provider and the correct trusted provider name are selected. For more information, see Configure SAML-based claims authentication with AD FS in SharePoint 2013.

    • In the Sign In Page URL section, verify the option for the sign-in page. For a default sign-in page, Default Sign In Page should be selected. For a custom sign-in-page, verify the specified URL of the custom sign-in page. To verify it, copy the URL, and then attempt to access it using a web browser.

  5. Click Save to save the changes to the authentication settings.

  6. Repeat the authentication attempt. For forms-based or SAML-based authentication, does the expected sign-in page appear with the correct sign-in options?

  7. If authentication still fails, check the ULS logs to determine whether there is any difference between the authentication attempt before the authentication configuration change and after it.

Step 3: Additional items to check

After you check the log files and web application configuration, verify the following:

  • The web browser on the web client computer supports claims. For more information, see Plan browser support in SharePoint 2013.

  • For Windows claims authentication, verify that the following:

    • The computer from which the user issues the authentication attempt is a member of the same domain as the server that hosts the SharePoint web application or a member of a domain that the hosting server trusts.

    • The computer from which the user issues the authentication attempt is logged on to its Active Directory Domain Services (AD DS) domain. Type nltest /dsgetdc: /force at a Command Prompt or the SharePoint 2013 Management Shell on the web client computer to make sure that it can access a domain controller. If no domain controllers are listed, troubleshoot the lack of discoverability and connectivity between the web client computer and an AD DS domain controller.

    • The server that is running SharePoint Server or SharePoint Foundation is logged on to its AD DS domain. Type nltest /dsgetdc: /force at a Command Prompt orthe SharePoint 2013 Management Shell on the server that is running SharePoint Server or SharePoint Foundation to make sure that it can access a domain controller. If no domain controllers are listed, troubleshoot the lack of discoverability and connectivity between the server that is running SharePoint Server or SharePoint Foundation and an AD DS domain controller.

  • For forms-based authentication, verify that the following:

    • The user credentials for the configured ASP.NET membership and role provider are correct.

    • The systems that host the ASP.NET membership and role provider are available on the network.

    • Custom sign-in pages correctly collect and convey the user's credentials. To test this, configure the web application to temporarily use the default sign-in page and verify that it works.

  • For SAML-based claims authentication, verify that the following:

    • The user credentials for the configured identity provider are correct.

    • Systems that act as the federation provider (such as AD FS) and the identity provider (such as AD DS or a third-party identity provider) are available on the network.

    • Custom sign-in pages correctly collect and convey the user's credentials. To test this, configure the web application to temporarily use the default sign-in page and verify that it works.

Step 4: Use a web debug tool to monitor and analyze web traffic

Use a tool such as HttpWatch or Fiddler to analyze the following types of HTTP traffic:

  • Between the web client computer and the server that is running SharePoint Server or SharePoint Foundation

    For example, you can monitor the HTTP Redirect messages that the server that is running SharePoint Server or SharePoint Foundation sends to inform the web client computer of the location of a federation server (such as AD FS).

  • Between the web client computer and the federation server (such as AD FS)

    For example, you can monitor the HTTP messages that the web client computer sends and the responses of the federation server, which could include security tokens and their claims.

Note:

If you use Fiddler, the authentication attempt can fail after requiring three authentication prompts. To prevent this behavior, see Using Fiddler With SAML and SharePoint to Get Past the Three Authentication Prompts.

Step 5: Capture and analyze authentication network traffic

Use a network traffic tool, such as Network Monitor 3.4, to capture and analyze traffic between the web client computer, the server that is running SharePoint Server or SharePoint Foundation, and the systems on which SharePoint Server or SharePoint Foundation relies for claims authentication.

Note:

In many cases, claims authentication uses Hypertext Transfer Protocol Secure (HTTPS)-based connections, which encrypt the messages sent between computers. You cannot see the contents of encrypted messages with a network traffic tool without the aid of an add-in or extension. For example, for Network Monitor, you must install and configure the Network Monitor Decryption Expert. As an easier alternative to attempting to decrypt HTTPS messages, use a tool such as Fiddler on the server that hosts SharePoint Server or SharePoint Foundation, which can report on the unencrypted HTTP messages.

An analysis of the network traffic can reveal the following:

  • The exact set of protocols and messages that are being sent between the computers involved in the claims authentication process. Reply messages can contain error condition information, which you can use to determine additional troubleshooting steps.

  • Whether request messages have corresponding replies. Multiple sent request messages that do not receive a reply can indicate that the network traffic is not reaching its intended destination. In that case, check for packet routing issues, packet filtering devices in the path (such as a firewall), or packet filtering on the destination (such as a local firewall).

  • Whether multiple claims methods are being tried, and which are failing.

For Windows claims authentication, you can capture and analyze the traffic between the following computers:

  • The web client computer and the server that is running SharePoint Server or SharePoint Foundation

  • The server that is running SharePoint Server or SharePoint Foundation and its domain controller

For forms-based authentication, you can capture and analyze the traffic between the following computers:

  • The web client computer and the server that is running SharePoint Server or SharePoint Foundation

  • The server that is running SharePoint Server or SharePoint Foundation and the ASP.NET membership and role provider

For SAML-based claims authentication, you can capture and analyze the traffic between the following computers:

  • The web client computer and the server that is running SharePoint Server or SharePoint Foundation

  • The web client computer and its identity provider (such as an AD DS domain controller)

  • The web client computer and the federation provider (such as AD FS)

See also

Configure forms-based authentication for a claims-based web application in SharePoint 2013
Configure SAML-based claims authentication with AD FS in SharePoint 2013


Troubleshoot common fine-grained permissions issues for SharePoint Server 2013
See also

Published: April 30, 2013

Summary: Learn about how to troubleshoot issues that include fine-grained permission in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

After you implement fine-grained permission, a SharePoint environment could experience security or performance issues. Review the following information to help resolve issues that might be related to fine-grained permissions.

Recommended issues and resolutions for common fine-grained permissions performance issues

The following issues can help reduce the effect of performance issues that are related to the extensive use of fine-grained permissions. Each of the following issues covers changes to the environment security, object hierarchy or custom code that is contributing to the performance issues that are related to fine-grained permissions. Each issue starts with the following example environment where a single web contains multiple document libraries, each with many uniquely-permissioned child objects.

Illustrates a single Web contains multiple document libraries, each with a great many number of uniquely uniquely-permissioned child objects.

Issue 1: Remove fine-grained permissions and use security enforcement only at web level

To re-architect the environment so that it no longer requires fine-grained permissions, an environment cleanup process can be implemented, and then the number of scoped items can be adjusted to improve the scalability of the environment over the longer term. The following recommendations describe the environment cleanup and architectural security changes that are required to achieve this solution.

Environmental security cleanup

When a user is removed from the web-level scope, the internal Object Model must remove the user from every scope below the web level. Removing individual users to clean up existing permissions is a time-consuming process. Instead, first remove each unique item-level scope so that the item is set to inherit permissions from its parent object. This will take less time than trying to remove users first, because it has to act on only a single scope for the item.

Important:

If the current web is not at the root of the site collection, and if the web is then set to inherit permissions from its parent web, all the unique scopes under it will be removed, and all the Limited Access memberships will be overwritten at the same time in a single SQL Server roundtrip.

Ilustrates permission cleanup by removing a user from the Web-level scope. When this is performed, the internal OM must remove the user from every scope below the Web level.

After all item-level scopes are removed, individual scope memberships at the web-level scope can be replaced with one or more group memberships to allow access.

Illustrates individual scope memberships being replaced at the Web-level scope with one or more group memberships to allow access after all item-level scopes have been removed.

Environmental security architecture redesign

After the existing fine-grained permissions and scopes are removed, the long-term architecture plan should be to maintain a unique scope only at the web level. The following diagram shows how this might be structured so that only the web-level scope remains. The core requirement in the architecture is not to have too many items at the same level of hierarchy in the document libraries, because the time that is required to process items in the views increases.

Resolution:

The maximum count of items or folders at any level in the hierarchy should be about 2,000 items.

Illustrates the architecture how a Web-level scope should be structured.

If additional changes are needed to the architecture, consider moving document libraries to different webs or site collections. The number of document libraries could also be changed to more closely support business needs and scaling recommendations that are based on the taxonomy or audience of the stored content.

Issue 2: Use fine-grained permissions by hierarchical structure changes

To re-architect the environment so that it still uses fine-grained permissions, but without causing too many updates to or sizing of a single web scope, consider moving differently secured document libraries to different webs.

Environment hierarchy redesign

In the following diagram, the physical architecture was changed so that each document library is in a uniquely-permissioned web. Additionally, when item-level fine-grained permissions must be preserved, as a best practice the cumulative number of security principals who will be granted access should be limited to approximately 2,000, although this is not a fixed limit. Therefore, the effective membership of each web that includes all Limited Access members users, should be no more than approximately 2,000 users. This keeps each web-level scope from growing too large.

Illustrates a document library that is in a uniquely- permissioned Web. The membership of each Web should not exceed 2,000 users.

The number of uniquely-scoped children is not a significant issue, and can scale to large numbers. However, the number of principles that will be added as limited access up the chain of scopes to the first uniquely permissioned web will be a limiting factor.

Lastly, although not specifically an issue about fine-grained permissions, the folder structure should guarantee that no single hierarchical level of the document library ever exceeds about 2,000 items. This limit can help guarantee good performance of views requested by users.

Issue 3: Use fine-grained permissions by scope structure changes

To re-architect the environment so that it still uses fine-grained permissions, but without causing too many updates to or sizing of a single web scope, consider using a different process of securing items. This is mainly applicable if the cause of the large number of unique scopes was an automated process such as an event handler or workflow that dynamically changed object permissions. The recommendation in this case is to make a code change to whatever process was creating the unique security scopes.

Dynamic security changing code redesign

In the following diagram, the scope architecture was changed so that scope membership does not cause ACL recalculation at the parent document library and web. As mentioned earlier, the effective membership of the web that includes all Limited Access members, should be no more than approximately 2,000 to keep the web-level scope from growing too large. In this case, by implementing a new SharePoint group to hold all members who should have Limited Access rights, the scope won't grow too large. When users are added to individual scopes under the web level by using the SharePoint 2013SPRoleAssignmentCollection.AddToCurrentScopeOnly method, they can also be added, by additional code, to the new group that was established as having Limited Access rights at the web and document library level.

IIustrates scope membership which does not cause ACL recalculation at the parent document library and Web.

Resolution:

When item-level fine-grained permissions must be preserved, the cumulative number of security principals who will be granted access should be limited to about 2,000, although this is not a fixed limit. When the number of security principals increases it takes longer to recalculate the binary ACL. If the membership of a scope is changed, the binary ACL must be recalculated. The addition of users at a child item unique scope will cause parent scopes to be updated with the new Limited Access members, even if this ultimately results in no change to the parent scope membership. When this occurs, the binary ACL for the parent scopes must also be recalculated.

As in the previous solution, the number of uniquely scoped children is not a significant issue, and can scale to large numbers. The number of principles that will be added as limited access up the chain of scopes to the first uniquely-permissioned web will be a limiting factor.

See also

Fine-grained permission reference for SharePoint Server 2013
Best practices for using fine-grained permissions in SharePoint Server 2013


Technical reference for SharePoint 2013
See also

Updated: May 7, 2013

Summary: Technical reference articles provide information about Windows PowerShell for SharePoint 2013 and other useful reference information about general settings, security, and tools.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about reference content for SharePoint 2013.

Downloadable technical reference resources about SharePoint 2013

Download the following technical reference content for information about SharePoint 2013

 | Content | Description
Downloads | Download SharePoint Server 2013 | See for yourself what SharePoint 2013 can do by downloading and installing this version.
Downloads | Download SharePoint Foundation 2013 | See for yourself what SharePoint 2013 can do by downloading and installing this version.
Building blocks | SharePoint 2013 training for IT pros | IT pro-focused how-to training and covers changes and new features for search, social, plus deployment and performance/scalability with downloadable presentations.

TechNet technical reference articles about SharePoint 2013

The following technical reference articles about SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Behind the scenes icon | Content | Description
 | Windows PowerShell for SharePoint 2013 | Learn about how to use Windows PowerShell to administer SharePoint 2013
 | System Center Operations Manager knowledge articles (SharePoint 2013) | Read knowledge articles for the SharePoint Server 2013 and SharePoint Foundation 2013 management pack for System Center Operations Manager 2012 to help to troubleshoot problems in SharePoint 2013.
 | Search technical reference for SharePoint Server 2013 | Learn about default crawled file name extensions and parsed file types, default crawled and managed properties, default connectors and linguistics features per language for search in SharePoint 2013.
 | Publishing technical reference for SharePoint Server 2013 | Provides links to reference articles for SharePoint Server 2013 publishing sites.
 | SharePoint Health Analyzer rules reference (SharePoint 2013) | Learn how to troubleshoot problems in SharePoint 2013 when SharePoint Health Analyzer alerts you.
 | Database types and descriptions (SharePoint 2013) | Provides information about sizing and location information about the databases that support SharePoint 2013.
 | Connection filter data types and operators in SharePoint Server 2013 | Provides information about connection filter data types and operators for the User Profile service application in SharePoint Server 2013.
 | User permissions and permission levels in SharePoint 2013 | Learn about the default permission levels and user permissions in SharePoint 2013.
 | Language packs in SharePoint Server 2013 | Learn about the language packs available for SharePoint 2013.
 | Fine-grained permission reference for SharePoint Server 2013 | Learn about the potential impact of fine-grained permissions on performance and the complexity of maintaining a SharePoint Server 2013 environment.
 | Grant Active Directory Domain Services permissions for profile synchronization in SharePoint Server 2013 | Learn how to grant the appropriate permissions in Active Directory Domain Services that are used for profile synchronization by the User Profile service in SharePoint Server 2013.
 | Default user profile property mappings in SharePoint Server 2013 | Learn about the default user profile property mappings for the User Profile service in SharePoint Server 2013.
 | User profile property data types in SharePoint Server 2013 | Learn about user profile property data types for the User Profile service in SharePoint Server 2013.
 | Display template reference in SharePoint Server 2013 | Learn about the different display templates that are available in SharePoint Server 2013.
 | Conformance statement A-level for SharePoint Server 2013 | Conformance statement A-level for SharePoint Server 2013 in regards to Web Content Accessibility Guidelines 2.0 (http://www.w3.org/TR/WCAG20/).
 | Conformance statement AA-level for SharePoint Server 2013 | Conformance statement AA-level for SharePoint Server 2013 in regards to Web Content Accessibility Guidelines 2.0 (http://www.w3.org/TR/WCAG20/).

Videos about Windows PowerShell

The following video recordings about Windows PowerShell are available to view online or to download.

Video (play button) icon | Content | Description
 | SharePoint 2013 training for IT pros | Find IT pro-focused how-to training and walkthrough videos with this interactive course about SharePoint 2013 including changes and new features for search, social, plus deployment and performance/scalability.

Additional technical reference resources about SharePoint 2013

The following technical reference resources about SharePoint 2013 are available from other subject matter experts.

 | Content | Description
House icon | SharePoint 2013 Tech Center | Visit the TechCenter to access videos, community sites, documentation, and more.
Code icon | SharePoint developer center | Find resources for building solutions on SharePoint 2013, including how-to articles, code samples, and the SharePoint SDK.
Chat icon | To the SharePoint | Read draft content, learn about new content, and join the conversation at this IT pro content team blog.
Chat icon | Office 365 Technical Blog | Learn how to get the most out of SharePoint sites.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support

See also

Stsadm command-line tool (Office SharePoint Server)

Change History

Date | Description
May 07, 2013 | Added new article: "Language packs in SharePoint Server 2013."
April 30, 2013 | Added link to Fine-grained permission reference for SharePoint Server 2013.
July 16, 2012 | Initial publication


Windows PowerShell for SharePoint 2013

Summary: Provides links to articles that explain the Windows PowerShell cmdlets that you can use with SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Windows PowerShell cmdlets that you use in SharePoint 2013 help you complete simple and complex administrative tasks. Command-line Help is available in the SharePoint 2013 Management Shell. For information about Windows PowerShell in general, visit the Windows PowerShell Technology Center.

TechNet articles about Windows PowerShell

The following articles about Windows PowerShell are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content
Building blocks | Use Windows PowerShell to administer SharePoint 2013
 | Windows PowerShell for SharePoint 2013 reference
 | Index of Windows PowerShell cmdlets for SharePoint 2013


Use Windows PowerShell to administer SharePoint 2013

Summary: Learn about basic Windows PowerShell cmdlets and concepts and how to use Windows PowerShell with SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

In this article:

  • Overview

  • Accessing Windows PowerShell for SharePoint 2013

  • Permissions

  • Scripts and execution policies

  • Learning Windows PowerShell

Overview

Windows PowerShell is a command-line shell and scripting language that provides an administrator full access to applicable application programming interfaces (APIs). Administrators can interact directly with SharePoint 2013 to manipulate web applications, site collections, sites, lists and much more. In addition, an administrator can script cmdlets (pronounced "command-lets").

Windows PowerShell 3.0 is a prerequisite for installing SharePoint 2013. It will be installed when you run the Microsoft SharePoint Products Preparation Tool if it is not already installed. By default, Windows PowerShell is located at the following path: <%SystemRoot%>\System32\WindowsPowerShell\v1.0\PowerShell.exe.

For a list of new features for Windows PowerShell 3.0, see Windows Management Framework 3.0

For an interactive tool and guide that helps you learn Windows PowerShell syntax, see Windows PowerShell Command Builder Tool and Getting Started Guide.

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.

Accessing Windows PowerShell for SharePoint 2013

After you install SharePoint 2013, applicable Windows PowerShell cmdlets are available in the SharePoint 2013 Management Shell. You can manage most aspects of SharePoint 2013 in the SharePoint Management Shell. You can create new site collections, web applications, user accounts, service applications, proxies, and more. Commands that you type in the SharePoint Management Shell return SharePoint objects that are based on the Microsoft .NET Framework. You can apply these objects as input to subsequent commands or store the objects in local variables for later use.

With the SharePoint Management Shell, you do not have to register the snap-in that contains the cmdlets. Registration of the Microsoft.SharePoint.PowerShell.dll module for SharePoint 2013 cmdlets is automatic, as a result of the Add-PSSnapin Microsoft.SharePoint.PowerShell line in the SharePoint.ps1 file that is located in %CommonProgramFiles%\Microsoft Shared\Web Server Extensions\15\Config\PowerShell\Registration. To use the Windows PowerShell console, you must register this snap-in manually.

Whether you use the SharePoint Management Shell or the Windows PowerShell console, you can also load additional snap-ins. For more information, see Customizing Profiles.

To access the SharePoint Management Shell

  1. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

Note:

The SharePoint 2013 Management Shell and the Windows PowerShell console also differ in the use of the ReuseThread option, which defines how the threading model is used. The SharePoint 2013 Management Shell's use is defined by this line, {Host.Runspace.ThreadOptions = "ReuseThread"}, which is in the SharePoint.ps1 file. For more information, see PS Thread Options.

Permissions

On-Premises

Before you can use the Add-SPShellAdmin cmdlet to grant permissions for users to run SharePoint 2013 cmdlets, verify that you meet all of the following minimum requirements:

  • You must have membership in the securityadmin fixed server role on the SQL Server instance

  • You must have membership in the db_owner fixed database role on all databases that are to be updated.

  • You must be a member of the Administrators group on the server on which you are running the Windows PowerShell cmdlet.

Note:

If these permissions are not satisfied, contact your Setup administrator or SQL Server administrator to request these permissions.

For additional information about Windows PowerShell permissions, see Permissions and Add-SPShellAdmin

If you do not have membership in the SharePoint_Shell_Access role or WSS_Admin_WPG local group, use the Add-SPShellAdmin cmdlet to add the WSS_Admin_WPG group in all front-end web servers in the SharePoint farm and the SharePoint_Shell_Access role. If the SQL Server database does not have a SharePoint_Shell_Access role, the role is automatically created when you run the Add-SPShellAdmin cmdlet. After you run the Add-SPShellAdmin cmdlet, users can run SharePoint Windows PowerShell cmdlets in a multiple-server farm environment.

Note:

When you install SharePoint 2013, the user account from which you run the installation is granted the appropriate permissions to run Windows PowerShell cmdlets. If any users have not been added to run a Windows PowerShell cmdlet, you can use the Add-SPShellAdmin cmdlet to add them.

You must run the Add-SPShellAdmin cmdlet for all databases to which you want to grant access. If no database is specified, the farm configuration database is used. If you do specify a database, the farm content database will be included in addition to the farm configuration database that you specify.

To see a list of all of the SPShellAdmin cmdlets, from a Windows PowerShell command prompt, type Get-Command -Noun SPShellAdmin.

SharePoint Online

Verify that you have the following administrative permissions:

  • You must be assigned the global administrator role on the SharePoint Online site on which you are running the Windows PowerShell cmdlet. For more information, see Default administrative roles and user groups.

    Important:

    You can use a specific group of Windows PowerShell with SharePoint Online. For more information, see Windows PowerShell for SharePoint Online.

Scripts and execution policies

Although you can use Windows PowerShell to perform a single administrative task, you can also use a script to automate a series of tasks. A script is a text file that contains one or more Windows PowerShell commands. Windows PowerShell scripts have a .ps1 file name extension.

To run scripts, the minimum required execution policy for SharePoint 2013 is RemoteSigned, although the default policy for Windows PowerShell is Restricted. If the policy is left as Restricted, the SharePoint 2013 Management Shell will change the policy for Windows PowerShell to RemoteSigned. This means that you must select Run as administrator to start the SharePoint 2013 Management Shell with elevated administrative permission. This change will apply to all Windows PowerShell sessions. For more information, see ExecutionPolicy Enumeration.

For additional information about scripts and execution policies, see about_scripts and about_Execution_Policies respectively.

Learning Windows PowerShell

There are several Windows PowerShell learning resources for SharePoint IT professionals.

TechNet Scripting Center

The TechNet Scripting Center includes many resources to help you learn the basics about Windows PowerShell. It also contains script repositories with samples of scripts that are typically used with various Microsoft products. The following table shows the main learning resources.

Page | Description
Windows PowerShell Documentation on TechNet | This section of the TechNet Library contains web copies of the core Windows PowerShell Get-Help topics. The section also has web copies of the Windows PowerShell Getting Started document, the PowerShell.exe help, and a Windows PowerShell primer.
Scripting With Windows PowerShell | The home page for Windows PowerShell scripting learning resources.
Windows PowerShell Owner's Manual | web-based guide for getting started with Windows PowerShell.
Windows PowerShell Quick Reference | Downloadable copy of the Quick Reference document that is installed with Windows PowerShell.

As you read these resources, consider that the following concepts and cmdlets are useful ones to learn before you use Windows PowerShell for SharePoint 2013:

  • Get-Command

  • Get-Member

  • Get-Help

  • Aliasing

  • Piping and the Pipeline in Windows PowerShell

  • Cmdlet Parameter Sets

  • Foreach-Object

  • Where-Object


Windows PowerShell for SharePoint 2013 reference

Summary: Provides links to categorized Windows PowerShell cmdlets that you can use in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

TechNet articles about Windows PowerShell

The following articles about Windows PowerShell are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Content

Building blocks

  • Use Windows PowerShell cmdlets to manage Access Services in SharePoint Server 2013

  • Access Services cmdlets in SharePoint Server 2013

  • App Management Service cmdlets in SharePoint 2013

  • Backup and recovery cmdlets in SharePoint 2013

  • Use Windows PowerShell cmdlets to manage Business Connectivity Services in SharePoint Server 2013

  • Database cmdlets in SharePoint 2013

  • Enterprise content management cmdlets in SharePoint Server 2013

  • Excel Services cmdlets in SharePoint Server 2013

  • Farm cmdlets in SharePoint 2013

  • Features and solutions cmdlets in SharePoint 2013

  • Use Windows PowerShell cmdlets to administer SharePoint 2013

  • Health monitoring cmdlets in SharePoint 2013

  • Import and export cmdlets in SharePoint 2013

  • InfoPath Services cmdlets in SharePoint Server 2013

  • Use Windows PowerShell cmdlets to manage user licenses in SharePoint 2013

  • Logging and events cmdlets in SharePoint 2013

  • Use Windows PowerShell cmdlets to manage MachineTranslation Service applications in SharePoint Server 2013

  • Managed metadata cmdlets in SharePoint Server 2013

  • Office Web Apps cmdlets in SharePoint Server 2013

  • Use Windows PowerShell cmdlets to manage performance in SharePoint 2013

  • PerformancePoint Services cmdlets in SharePoint Server 2013

  • Use Windows PowerShell cmdlets to administer and configure search in SharePoint 2013

  • Secure Store Service cmdlets in SharePoint 2013

  • Use Windows PowerShell cmdlets to administer security in SharePoint 2013

  • Service application cmdlets in SharePoint 2013

  • Site collection cmdlets in SharePoint 2013

  • Use Windows PowerShell cmdlets to manage sites in SharePoint 2013

  • State service and session state cmdlets in SharePoint 2013

  • Use Windows PowerShell cmdlets to manage timer jobs in SharePoint 2013

  • Use Windows PowerShell cmdlets to upgrade to SharePoint 2013 and to migrate data

  • Use Windows PowerShell cmdlets to configure the User Profile service in SharePoint Server 2013

  • Visio Graphics Services cmdlets in SharePoint Server 2013

  • Web application cmdlets in SharePoint 2013

  • Word Services cmdlets in SharePoint Server 2013

  • Use Windows PowerShell cmdlets to manage workflow in SharePoint 2013

  • Use Windows PowerShell cmdlets to administer the Work Management Service in SharePoint Server 2013


Use Windows PowerShell cmdlets to manage Access Services in SharePoint Server 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to manage Microsoft Access service applications in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

Access Services is a service in SharePoint Server 2013 that lets an administrator view, edit, and configure a Microsoft Access service application within a Web browser.

All Access Services settings support backup and recovery, regardless of whether there is a UI setting in Central Administration. However, backup and recovery only apply to service-level and administrative-level settings; end-user content from the Access application is not backed up as part of this process.

Access Services has Windows PowerShell functionality that you can use to provision the service or provision a new instance that uses settings from a previous backup; configure and manage macro and query setting; manage and configure session management; and configure all the global settings of the service.

All cmdlets on this page are new to SharePoint Server 2013.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPAccessServicesApplication | Returns an Access Services application or a collection of Access Services applications.
Get-SPAccessServicesDatabase | Returns an Access Services database or a collection of Access Services databases.
Get-SPAccessServicesDatabaseServer | Returns the settings for all application servers.
Get-SPAccessServicesDatabaseServerGroup | Returns the settings for all application server groups.
Get-SPAccessServicesDatabaseServerGroupMapping | Returns the mapping from a source package type to the database server group.
New-SPAccessServicesApplication | Creates a new instance of an Access Services application in SharePoint Server 2013.
New-SPAccessServicesDatabaseServer | Adds a new SQL Server database to the list of servers.
Remove-SPAccessServicesDatabaseServer | Removes the specified database server.
Reset-SPAccessServicesDatabasePassword | Resets the passwords for all logons for user application databases.
Set-SPAccessServicesApplication | Sets global properties of an existing Access Services application in SharePoint Server 2013.
Set-SPAccessServicesDatabaseServer | Specifies whether or not a database in SQL Server is available.
Set-SPAccessServicesDatabaseServerGroupMapping | Sets server group mappings.

See also

Windows PowerShell for SharePoint 2013 reference


Get-SPAccessServicesApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns an Access Services application or a collection of Access Services applications.

Get-SPAccessServicesApplication [[-Identity] <SPServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the Access Services application to return.

The value must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPAccessServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPAccessServiceApplication cmdlet retrieves an Access Services application. If an identity is not specified, the cmdlet returns the collection of Access Services applications that are in the farm. The properties returned from this cmdlet are read-only. To update properties of a Access Services application, use the Set-SPAccessServiceApplication cmdlet. Updates affect all servers in the farm in which this Access Services application runs.

Input Types

Return Types

Example

------------EXAMPLE 1----------------

Copy code
Get-SPAccessServiceApplication -Identity "MyAccessService"

This example returns an Access Services application named MyAccessService.

------------EXAMPLE 2----------------

Copy code
Get-SPAccessServiceApplication

This example returns every Access Services application in the farm.

See also

New-SPAccessServicesApplication
Set-SPAccessServicesApplication


Get-SPAccessServicesDatabase
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns an Access Services database or a collection of Access Services databases.

Get-SPAccessServicesDatabase [[-Identity] <AccessServicesDatabasePipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabasePipeBind

Specifies the Access Services Database to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAccessServicesDatabase cmdlet to return an Access Services database. If the Identity parameter is not specified, the cmdlet returns the collection of Access Services databases that are in the Web service application.

Input Types

Return Types

Example

---------EXAMPLE----------

Copy code
$asdbs = Get-SPAccessServicesDatabase | select-object -property Url,DatabaseName,DatabaseServer;

This example returns Access Services databases in the farm that display the Url, DatabaseName, and DatabaseServer properties.


Get-SPAccessServicesDatabaseServer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the settings for all application servers.

Get-SPAccessServicesDatabaseServer [-ServiceContext] <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind>]
Get-SPAccessServicesDatabaseServer [-ServiceContext] <SPServiceContextPipeBind> -DatabaseServer <AccessServicesDatabaseServerPipeBind> -DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for the database server.

DatabaseServer

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerPipeBind

Specifies the database server to return.

DatabaseServerGroup

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerGroupPipeBind

Specifies the database server group to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for the database server.

DatabaseServer

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerPipeBind

Specifies the database server to return.

DatabaseServerGroup

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerGroupPipeBind

Specifies the database server group to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Get-SPAccessServicesDatabaseServer cmdlet to return the settings for all application servers that use the Access Services 2013 service.

Input Types

Return Types

Example

--------------EXAMPLE--------

Copy code
$ASapp = Get-SPAccessServicesApplication
Copy code
$app = $Null
Copy code
if ($ASapp.length -ne $Null) { $app = $ASapp[0] } else { $app = $ASapp }
Copy code
$context = [Microsoft.SharePoint.SPServiceContext]::GetContext($app.ServiceApplicationProxyGroup, [Microsoft.SharePoint.SPSiteSubscriptionIdentifier]::Default)
Copy code
$server2 = $Null
Copy code
$getservers = Get-SPAccessServicesDatabaseServer $context

This example returns all Access Services databases from the farm.

See also

New-SPAccessServicesDatabaseServer
Remove-SPAccessServicesDatabaseServer
Set-SPAccessServicesDatabaseServer


Get-SPAccessServicesDatabaseServerGroup
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the settings for all application server groups.

Get-SPAccessServicesDatabaseServerGroup [-ServiceContext] <SPServiceContextPipeBind> [[-DatabaseServerGroup] <AccessServicesDatabaseServerGroupPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

DatabaseServerGroup

Optional

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerGroupPipeBind

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAccessServicesDatabaseServerGroup cmdlet to display the settings for all application server groups using the Access Services 2013 service. If the database server group is not specified, the cmdlet returns the collection of Access Services database server groups that are in the Web service Application.

Input Types

Return Types

Example

-------------EXAMPLE-------

Copy code
$ASapp = Get-SPAccessServicesApplication
Copy code
$app = $Null
Copy code
if ($ASapp.length -ne $Null) { $app = $ASapp[0] } else { $app = $ASapp }
Copy code
$context = [Microsoft.SharePoint.SPServiceContext]::GetContext($app.ServiceApplicationProxyGroup, [Microsoft.SharePoint.SPSiteSubscriptionIdentifier]::Default)
Copy code
$dsg = Get-SPAccessServicesDatabaseServerGroup -ServiceContext $context

This example returns all Access Services database server group from the farm.

See also

Set-SPAccessServicesDatabaseServerGroupMapping


Get-SPAccessServicesDatabaseServerGroupMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the mapping from a source package type to the database server group.

Get-SPAccessServicesDatabaseServerGroupMapping [-ServiceContext] <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPAccessServicesDatabaseServerGroupMapping cmdlet to return the mapping from a source package type to the database server group within a Web service application.

Input Types

Return Types

Example

------------EXAMPLE-------

Copy code
$ASapp = Get-SPAccessServicesApplication
Copy code
$app = $Null
Copy code
if ($ASapp.length -ne $Null) { $app = $ASapp[0] } else { $app = $ASapp }
Copy code
$context = [Microsoft.SharePoint.SPServiceContext]::GetContext($app.ServiceApplicationProxyGroup, [Microsoft.SharePoint.SPSiteSubscriptionIdentifier]::Default)
Copy code
$dsgm = Get-SPAccessServicesDatabaseServerGroupMapping -ServiceContext $context

This example returns all Access Services database server group mappings from the farm.

See also

Set-SPAccessServicesDatabaseServerGroupMapping


New-SPAccessServicesApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new instance of an Access Services application in SharePoint Server 2013.

New-SPAccessServicesApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CacheTimeout <Int32>] [-Confirm [<SwitchParameter>]] [-Default <SwitchParameter>] [-Hosted <$true | $false>] [-Name <String>] [-PrivateBytesMax <Int32>] [-QueryTimeout <Int32>] [-RequestDurationMax <Int32>] [-SessionsPerAnonymousUserMax <Int32>] [-SessionsPerUserMax <Int32>] [-WhatIf [<SwitchParameter>]]
New-SPAccessServicesApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> -DatabaseServer <String> -Default <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-CacheTimeout <Int32>] [-Confirm [<SwitchParameter>]] [-DatabaseServerCredentials <PSCredential>] [-Encrypt <$true | $false>] [-Hosted <$true | $false>] [-Name <String>] [-PrivateBytesMax <Int32>] [-QueryTimeout <Int32>] [-RequestDurationMax <Int32>] [-SessionsPerAnonymousUserMax <Int32>] [-SessionsPerUserMax <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing Internet Information Services (IIS) application pool to run the Web service in for the new Access Services application.

The value must be a valid instance of a SPIisWebServiceApplicationPool object.

Default

Required

System.Management.Automation.SwitchParameter

Specifies that the service application is associated with web applications by adding this service application's proxy to the farm's default proxy list.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CacheTimeout

Optional

System.Int32

Specifies the number of seconds that a data cache will remain active on Access Services with no user activity. Valid values include: -1, cache never times out; 1 to 2073600, cache remains active from 1 second to 24 days.

The value must be the integers -1, or an integer in the range of 1 to 2073600 (24 days). The default value is 300.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Hosted

Optional

System.Boolean

Specifies that the Access Services application is used in a hosted environment that includes management of logical servers.

The default value is false.

Name

Optional

System.String

Specifies the display name of the Access Services application to create. The name can contain a maximum of 128 characters and can contain the comma (,), equal sign (=), or colon (:) characters if they are enclosed in quotation marks.

The type must be a valid name of an Access Services application; for example, AccessSrvApp1.

PrivateBytesMax

Optional

System.Int32

Specifies the maximum private bytes in megabytes (MB) that can be used by Access Services. When set to -1, Access Services defaults to 75 percent of physical memory on the server. Valid values are -1 (no limit), and from 1 to any positive integer.The default value is -1.

QueryTimeout

Optional

System.Int32

<Need description>

RequestDurationMax

Optional

System.Int32

Specifies the maximum number of seconds that a request to perform an operation can use before the request times out. Valid values include: -1, no limit, 1 to 2073600, cache remains active 1 second to 24 days. The default value is 30.

The value must be the integer -1, or an integer in the range of 1 to 2073600 (24 days)

SessionsPerAnonymousUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed per user. If this maximum is exceeded, the oldest session is deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The value must be the integer -1, or an integer in the range of 1 to MaxInt.

SessionsPerUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed per user. If this maximum is exceeded, the oldest session is deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The value must be the integer -1, or an integer in the range of 1 to MaxInt.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing Internet Information Services (IIS) application pool to run the Web service in for the new Access Services application.

The value must be a valid instance of a SPIisWebServiceApplicationPool object.

DatabaseServer

Required

System.String

<Need description>

Default

Required

System.Management.Automation.SwitchParameter

Specifies that the service application is associated with web applications by adding this service application's proxy to the farm's default proxy list.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CacheTimeout

Optional

System.Int32

Specifies the number of seconds that a data cache will remain active on Access Services with no user activity. Valid values include: -1, cache never times out; 1 to 2073600, cache remains active from 1 second to 24 days.

The value must be the integers -1, or an integer in the range of 1 to 2073600 (24 days). The default value is 300.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseServerCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL authentication. If no database credentials are provided, Windows authentication is used.

Encrypt

Optional

System.Boolean

<Need description>

Hosted

Optional

System.Boolean

Specifies that the Access Services application is used in a hosted environment that includes management of logical servers.

The default value is false.

Name

Optional

System.String

Specifies the display name of the Access Services application to create. The name can contain a maximum of 128 characters and can contain the comma (,), equal sign (=), or colon (:) characters if they are enclosed in quotation marks.

The type must be a valid name of an Access Services application; for example, AccessSrvApp1.

PrivateBytesMax

Optional

System.Int32

Specifies the maximum private bytes in megabytes (MB) that can be used by Access Services. When set to -1, Access Services defaults to 75 percent of physical memory on the server. Valid values are -1 (no limit), and from 1 to any positive integer.The default value is -1.

QueryTimeout

Optional

System.Int32

<Need description>

RequestDurationMax

Optional

System.Int32

Specifies the maximum number of seconds that a request to perform an operation can use before the request times out. Valid values include: -1, no limit, 1 to 2073600, cache remains active 1 second to 24 days. The default value is 30.

The value must be the integer -1, or an integer in the range of 1 to 2073600 (24 days)

SessionsPerAnonymousUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed per user. If this maximum is exceeded, the oldest session is deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The value must be the integer -1, or an integer in the range of 1 to MaxInt.

SessionsPerUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed per user. If this maximum is exceeded, the oldest session is deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The value must be the integer -1, or an integer in the range of 1 to MaxInt.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPAccessServiceApplication cmdlet creates a new instance of an Access Services application in SharePoint Server 2013. After you create a new Access Services application, use the Set-SPAccessServiceApplication cmdlet to modify its global settings.

Input Types

Return Types

Example

-----------EXAMPLE--------

Copy code
$serviceAppName = "Access Services"
Copy code
$onPremAppPool = "on-prem-pool"
Copy code
$sqlServerName = "SQLServer2012AppDbServer"
Copy code
$ApplicationPool = Get-SPServiceApplicationPool -Identity $onPremAppPool
Copy code
New-SPAccessServicesApplication -Name $serviceAppName -ApplicationPool $ApplicationPool -Default -DatabaseServer $sqlServerName

This example creates a new Access Services services application named Access Services

See also

Get-SPAccessServicesApplication
Set-SPAccessServicesApplication


New-SPAccessServicesDatabaseServer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a new SQL Server database to the list of servers.

New-SPAccessServicesDatabaseServer [-ServiceContext] <SPServiceContextPipeBind> -DatabaseServerName <String> [-AssignmentCollection <SPAssignmentCollection>] [-AvailableForCreate <$true | $false>] [-Confirm [<SwitchParameter>]] [-DatabaseServerCredentials <PSCredential>] [-DatabaseServerGroupName <String>] [-Encrypt <$true | $false>] [-Exclusive <SwitchParameter>] [-ServerReferenceId <Guid>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context to create the Access Services database server.

DatabaseServerName

Required

System.String

Specifies the name of the server running SQL Server that you choose to host the new Access Services application databases.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AvailableForCreate

Optional

System.Boolean

Specifies whether the new server should be available for new database creation.

The default value is True. Setting the value to True will set all other servers in the list to False.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseServerCredentials

Optional

System.Management.Automation.PSCredential

Specifies the Credential object for the database user. Use this parameter if you use SQL Server Authentication. If no database credentials are provided, Windows authentication is used.

DatabaseServerGroupName

Optional

System.String

Specifies the Access Services database server group name.

Encrypt

Optional

System.Boolean

Specifies all connections to the database server will use Secure Sockets Layer (SSL) if the database supports it.

Exclusive

Optional

System.Management.Automation.SwitchParameter

Enables the AvailableForCreate flag for this server and disables it for all other servers in the DatabaseServerGroup.

ServerReferenceId

Optional

System.Guid

A unique identifier for the database server. Used for maintaining continuity when restoring an existing content database to a different or new farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPAccessServicesDatabaseServer cmdlet to add a new SQL Server database to the list of servers for application databases.

If you use the New-SPAccessServicesDatabaseServer cmdlet does in hosted mode, you receive the following error message:

This operation is not supported when Access Services is running in hosted mode.

If the SQL Authentication method is selected for the database credentials, the method checks that the Secure Store service is running and is accessible to the service. If the Secure Store service is unable to connect, the following message is displayed:

Operation failed. Secure Store Service must be running and accessible to the service in order to use SQL Authentication credentials.

Input Types

Return Types

Example

--------------EXAMPLE---------

Copy code
$serverGroupName = 'DEFAULT'
Copy code
$farm = Get-SPFarm;
Copy code
$account = $($farm.DefaultServiceAccount.Name);
Copy code
$serviceAppName = "Access Services"
Copy code
$onPremAppPool = "on-prem-pool"
Copy code
$identity = Get-SPServiceApplication -Name $serviceAppName
Copy code
$acct = Get-SPManagedAccount -Identity $account
Copy code
$ApplicationPool = Get-spserviceapplicationpool -Identity $onPremAppPool
Copy code
if($ApplicationPool -eq $NULL)
{
    $ApplicationPool = new-spserviceapplicationpool -name $onPremAppPool -account $acct
}
Copy code
New-SPAccessServicesApplication -Name $serviceAppName -ApplicationPool $ApplicationPool -Default
Copy code
$ASapp = Get-SPAccessServicesApplication
Copy code
$app = $Null
Copy code
if ($ASapp.length -ne $Null) { $app = $ASapp[0] } else { $app = $ASapp }
Copy code
$context = [Microsoft.SharePoint.SPServiceContext]::GetContext($app.ServiceApplicationProxyGroup, [Microsoft.SharePoint.SPSiteSubscriptionIdentifier]::Default)
Copy code
$newdbserver = New-SPAccessServicesDatabaseServer -ServiceContext $context -DatabaseServerName $sqlServerName -DatabaseServerGroup $serverGroupName -AvailableForCreate $true

This example creates a new Access Services database server.

See also

Get-SPAccessServicesDatabaseServer
Remove-SPAccessServicesDatabaseServer
Set-SPAccessServicesDatabaseServer


Remove-SPAccessServicesDatabaseServer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes the specified database server.

Remove-SPAccessServicesDatabaseServer [-ServiceContext] <SPServiceContextPipeBind> -DatabaseServer <AccessServicesDatabaseServerPipeBind> -DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context to remove the Access Services database server.

DatabaseServer

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerPipeBind

Specifies the database server to be deleted.

DatabaseServerGroup

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerGroupPipeBind

Specifies the Access Services database server group to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPAccessServicesDatabaseServer cmdlet to remove the target Access Services database server by using the DatabaseServerGroup and ServiceContext parameters.

Input Types

Return Types

Example

--------------EXAMPLE--------

Copy code
$serverGroupName = 'DEFAULT'
Copy code
$context = [Microsoft.SharePoint.SPServiceContext]::GetContext($app.ServiceApplicationProxyGroup, [Microsoft.SharePoint.SPSiteSubscriptionIdentifier]::Default)
Copy code
$sqlServerName = "SQLServer2012AppDbServer"
Copy code
$newdbserver = New-SPAccessServicesDatabaseServer -ServiceContext $context -DatabaseServerName $sqlServerName -DatabaseServerGroup $serverGroupName -AvailableForCreate $true
Copy code
Remove-SPAccessServicesDatabaseServer -ServiceContext $context -DatabaseServer $newdbserver -DatabaseServerGroup "DEFAULT"

This example removes all Access Services database servers from the default group.

See also

Get-SPAccessServicesDatabaseServer
New-SPAccessServicesDatabaseServer
Set-SPAccessServicesDatabaseServer


Reset-SPAccessServicesDatabasePassword
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Resets the passwords for all logons for user application databases.

Reset-SPAccessServicesDatabasePassword [-ServiceContext] <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Reset-SPAccessServicesDatabasePassword [-ServiceContext] <SPServiceContextPipeBind> -Database <AccessServicesDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context to the Access Services database password to reset.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context to the Access Services database password to reset.

Database

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabasePipeBind

Specifies the ServerID of the server running SQL Serverthat will be affected. If not provided, all application logons are updated on all servers.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Reset-SPAccessServicesDatabasePassword cmdlet resets the passwords for all logons for user application databases.

If you use the Reset-SPAccessServicesDatabasePassword cmdlet in hosted mode, you receive the following error message:

This operation is not supported when Access Services is running in hosted mode.

Input Types

Return Types

Example

-------------EXAMPLE--------

Copy code
$context = [Microsoft.SharePoint.SPServiceContext]::GetContext($app.ServiceApplicationProxyGroup, [Microsoft.SharePoint.SPSiteSubscriptionIdentifier]::Default)
Copy code
Reset-SPAccessServicesDatabasePassword -ServiceContext $context

This example resets the password for the specified service context by using the $context variable.


Set-SPAccessServicesApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets global properties of an existing Access Services application in SharePoint Server 2013.

Set-SPAccessServicesApplication [-Identity] <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CacheTimeout <Int32>] [-Confirm [<SwitchParameter>]] [-PrivateBytesMax <Int32>] [-RequestDurationMax <Int32>] [-SessionsPerAnonymousUserMax <Int32>] [-SessionsPerUserMax <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the Access Services application to update.

The value must be in one of the following forms:

  • A valid name of an Access Services application; for example, AccessSrvApp1

  • A valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh

  • An instance of a valid SPAccessServiceApplication object

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CacheTimeout

Optional

System.Int32

Specifies the number of seconds that a data cache will remain active on Access Services with no user activity. Valid values include: -1, cache never times out; 1 to 2073600, cache remains active from 1 second to 24 days.

The type must be the integers -1, or an integer in the range of 1 to 2073600 (24 days). The default value is 300.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PrivateBytesMax

Optional

System.Int32

Specifies the maximum private bytes in megabytes that can be used by Access Services. When set to -1, it defaults to 75 percent of physical memory on the server. Valid values: -1, no limit, from 1 to any positive integer.The default value is -1.

RequestDurationMax

Optional

System.Int32

Specifies the maximum number of seconds that a request to perform an operation can use before the request times out. Valid values include: -1, no limit, 1 to 2073600, cache remains active 1 second to 24 days. The default value is 30.

The type must be the integer -1, or an integer in the range of 1 to 2073600 (24 days)

SessionsPerAnonymousUserMax

Optional

System.Int32

The maximum number of sessions allowed per user. If this maximum is exceeded, the oldest session will be deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The integer -1, or an integer in the range of 1 to MaxInt

SessionsPerUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed per user. If this maximum is exceeded, the oldest session is deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The integer -1, or an integer in the range of 1 to MaxInt.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPAccessServiceApplication cmdlet sets the global runtime properties of an existing Access Services application in SharePoint Server 2013. If you use this cmdlet to update properties, updates affect all servers in the farm on which this Access Services application runs.

Input Types

Return Types

Example

------------EXAMPLE 1------------------

Copy code
Set-SPAccessServiceApplication -Identity "MyAccessService" -RequestDurationMax 100

This example sets the Access Services application named MyAccessService to let requests take up to 100 seconds before they time out.

------------EXAMPLE 2------------------

Copy code
Get-SPAccessServiceApplication | Set-SPAccessServiceApplication -SessionsPerUserMax 5

This example sets every Access Services application in the farm to allow up to five sessions per user on each back-end application server computer on which Access Services runs.

First, every Access Services application is returned, and then a new value is set by using the Set-SPAccessServiceApplication cmdlet.

See also

Get-SPAccessServicesApplication
New-SPAccessServicesApplication


Set-SPAccessServicesDatabaseServer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Specifies whether or not a database in SQL Server is available.

Set-SPAccessServicesDatabaseServer [-ServiceContext] <SPServiceContextPipeBind> -DatabaseServer <AccessServicesDatabaseServerPipeBind> -DatabaseServer <AccessServicesDatabaseServerPipeBind> -DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind> -DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseServerCredentials <PSCredential>] [-DatabaseServerName <String>] [-WhatIf [<SwitchParameter>]]
Set-SPAccessServicesDatabaseServer [-ServiceContext] <SPServiceContextPipeBind> -DatabaseServer <AccessServicesDatabaseServerPipeBind> -DatabaseServer <AccessServicesDatabaseServerPipeBind> -DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind> -DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind> -Encrypt <$true | $false> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Set-SPAccessServicesDatabaseServer [-ServiceContext] <SPServiceContextPipeBind> -AvailableForCreate <$true | $false> -DatabaseServer <AccessServicesDatabaseServerPipeBind> -DatabaseServer <AccessServicesDatabaseServerPipeBind> -DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind> -DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Exclusive <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for the Access Services database server to be set.

DatabaseServer

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerPipeBind

Specifies the ServerID of the server running SQL Server to update.

DatabaseServerGroup

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerGroupPipeBind

Specifies the Access Services database server group to be set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseServerCredentials

Optional

System.Management.Automation.PSCredential

Specifies the Credential object for the database user. Use this parameter if you use SQL Server Authentication. If no database credentials are provided, Windows authentication is used.

DatabaseServerName

Optional

System.String

Specifies the database server name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for the Access Services database server to be set.

DatabaseServer

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerPipeBind

Specifies the ServerID of the server running SQL Server to update.

DatabaseServerGroup

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerGroupPipeBind

Specifies the Access Services database server group to be set.

Encrypt

Required

System.Boolean

Specifies all connections to the database server will use Secure Sockets Layer (SSL) if the database supports it.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for the Access Services database server to be set.

AvailableForCreate

Required

System.Boolean

Specifies whether the new server should be available for new database creation.

The default value is True. Setting the value to True will set all other servers in the list to False.

DatabaseServer

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerPipeBind

Specifies the ServerID of the server running SQL Server to update.

DatabaseServerGroup

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerGroupPipeBind

Specifies the Access Services database server group to be set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Exclusive

Optional

System.Management.Automation.SwitchParameter

Enables the AvailableForCreate flag for this server and disables it for all other servers in the DatabaseServerGroup.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPAccessServicesDatabaseServer cmdlet to specify whether or not a database in SQL Server is available for creation of new Access Services applications.

If you use the Set-SPAccessServicesDatabaseServer cmdlet in hosted mode, you receive the following error message:

This operation is not supported when Access Services is running in hosted mode.

Input Types

Return Types

Example

Copy code
$context = [Microsoft.SharePoint.SPServiceContext]::GetContext($app.ServiceApplicationProxyGroup, [Microsoft.SharePoint.SPSiteSubscriptionIdentifier]::Default)
Copy code
$sqlServerName = "SQLServer2012AppDbServer"
Copy code
$serverGroupName = 'DEFAULT'
Copy code
$newdbserver = New-SPAccessServicesDatabaseServer -ServiceContext $context -DatabaseServerName $sqlServerName -DatabaseServerGroup $serverGroupName -AvailableForCreate $true
Copy code
Set-SPAccessServicesDatabaseServer $context -DatabaseServer $newdbserver -DatabaseServerGroup "DEFAULT" -AvailableForCreate $false

This example sets the Access Services database server by using the $context and $newdbserver variables.

See also

Get-SPAccessServicesDatabaseServer
Remove-SPAccessServicesDatabaseServer
New-SPAccessServicesDatabaseServer


Set-SPAccessServicesDatabaseServerGroupMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets server group mappings.

Set-SPAccessServicesDatabaseServerGroupMapping [-ServiceContext] <SPServiceContextPipeBind> -DatabaseServerGroup <AccessServicesDatabaseServerGroupPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-CorporateCatalog <SwitchParameter>] [-DeveloperSite <SwitchParameter>] [-ObjectModel <SwitchParameter>] [-RemoteObjectModel <SwitchParameter>] [-StoreFront <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Set-SPAccessServicesDatabaseServerGroupMapping [-ServiceContext] <SPServiceContextPipeBind> -ClearMapping <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-CorporateCatalog <SwitchParameter>] [-DeveloperSite <SwitchParameter>] [-ObjectModel <SwitchParameter>] [-RemoteObjectModel <SwitchParameter>] [-StoreFront <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context to set.

DatabaseServerGroup

Required

Microsoft.Office.Access.Services.PowerShell.AccessServicesDatabaseServerGroupPipeBind

Specifies the database server group mapping to set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CorporateCatalog

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the App Catalog.

DeveloperSite

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the developer site.

ObjectModel

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the Object model.

RemoteObjectModel

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the client side object model.

StoreFront

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the SharePoint Store.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context to set.

ClearMapping

Required

System.Management.Automation.SwitchParameter

Removes any existing mappings between the source of the creation and the DatabaseServerGroup.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CorporateCatalog

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the App Catalog.

DeveloperSite

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the developer site.

ObjectModel

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the Object model.

RemoteObjectModel

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the client side object model.

StoreFront

Optional

System.Management.Automation.SwitchParameter

Specifies Apps that are created from the SharePoint Store.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPAccessServicesDatabaseServerGroupMapping cmdlet to set the mapping between the source of the request to create the application and the DatabaseServerGroup containing the server that is selected to create new databases on. Specify one or more of the sources to map them to the DatabaseServerGroup.

Input Types

Return Types

Example

------------EXAMPLE----------

Copy code
$context = [Microsoft.SharePoint.SPServiceContext]::GetContext($app.ServiceApplicationProxyGroup, [Microsoft.SharePoint.SPSiteSubscriptionIdentifier]::Default)
Copy code
$dsg = Get-SPAccessServicesDatabaseServerGroup -ServiceContext $context
Copy code
Set-SPAccessServicesDatabaseServerGroupMapping -ServiceContext $context -DatabaseServerGroup $dsg

This example sets a Access Services database server group mapping by using the $context and $dsg variables.

See also

Get-SPAccessServicesDatabaseServerGroupMapping


Access Services cmdlets in SharePoint Server 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you manage Access Services applications that run in a 2010 SharePoint experience version of a site collection.

Applies to: SharePoint Server 2013 Enterprise

Access Services 2010 is a service in SharePoint Server 2013 that lets an administrator view, edit, and configure a Microsoft Access service application that runs in a 2010 SharePoint experience version of a site collection. A site collection that uses the 2010 experience version runs in SharePoint 2013, but the user interface and user experience of the site collection is that of SharePoint Server 2010.

All Access Services settings support backup and recovery, regardless of whether there is a user interface setting in Central Administration. However, backup and recovery only apply to service-level and administrative-level settings; end-user content from the Access Services application is not backed up as part of this process.

Access Services has Windows PowerShell functionality that you can use to provision the service or provision a new instance that uses settings from a previous backup; configure and manage macro and query setting; manage and configure session management; and configure all the global settings of the service.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPAccessServiceApplication | Returns an Access Services application or a collection of Access Services applications.
New-SPAccessServiceApplication | Creates a new instance of an Access Services application.
Set-SPAccessServiceApplication | Sets global properties of an existing Access Services application.

See also

Windows PowerShell for SharePoint 2013 reference


Get-SPAccessServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns an Access Services application or a collection of Access Services applications.

Get-SPAccessServiceApplication [[-Identity] <SPAccessServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Access.Server.PowerShell.SPAccessServiceApplicationPipeBind

Specifies the Access Services application to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPAccessServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPAccessServiceApplication cmdlet retrieves an Access Services application. If an identity is not specified, the cmdlet returns the collection of Access Services applications that are in the farm. The properties returned from this cmdlet are read-only. If changes need to be made, use the Set-SPAccessServiceApplication cmdlet. These changes affect all computers in the farm in which this Access Services application runs.

Input Types

Return Types

Example

------------EXAMPLE 1----------------

Copy code
Get-SPAccessServiceApplication -identity "MyAccessService"

This example displays an Access Services application named MyAccessService.

------------EXAMPLE 2----------------

Copy code
Get-SPAccessServiceApplication | where {$_.recordsintablemax -gt 10000}

This example displays every Access Services application that run in the farm, which allows more than 10,000 records in a table.

------------EXAMPLE 3----------------

Copy code
Get-SPAccessServiceApplication

This example displays every Access Services application in the farm.

See also

Set-SPAccessServiceApplication


New-SPAccessServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new instance of an Access Services application in SharePoint Server 2013.

New-SPAccessServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-ApplicationLogSizeMax <Int32>] [-AssignmentCollection <SPAssignmentCollection>] [-CacheTimeout <Int32>] [-ColumnsMax <Int32>] [-Confirm [<SwitchParameter>]] [-Default <SwitchParameter>] [-Name <String>] [-NonRemotableQueriesAllowed <SwitchParameter>] [-OrderByMax <Int32>] [-OuterJoinsAllowed <SwitchParameter>] [-OutputCalculatedColumnsMax <Int32>] [-PrivateBytesMax <Int32>] [-RecordsInTableMax <Int32>] [-RequestDurationMax <Int32>] [-RowsMax <Int32>] [-SessionMemoryMax <Int32>] [-SessionsPerAnonymousUserMax <Int32>] [-SessionsPerUserMax <Int32>] [-SourcesMax <Int32>] [-TemplateSizeMax <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Optional

System.String

Specifies the display name of the Access Services application to create. The name can contain a maximum of 128 characters and can contain the comma (,), equal sign (=), or colon (:) characters provided they are enclosed in quotation marks.

The type must be a valid name of an Access Services application; for example, AccessSrvApp1.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing Internet Information Services (IIS) application pool to run the Web service in for the new Access Services application.

The type must be a valid instance of a SPIisWebServiceApplicationPool object.

ApplicationLogMaxSize

Optional

System.Int32

Specifies the maximum number of records for an Access Services Application Log list. Valid valies: -1 to maxint. 0 means none are allowed. The default value is 3000.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CacheTimeout

Optional

System.Int32

Specifies the number of seconds that a data cache will remain active on Access Services with no user activity. Valid values include: -1, cache never times out; 1 to 2073600, cache remains active from 1 second to 24 days.

The type must be the integers -1, or an integer in the range of 1 to 2073600 (24 days). The default value is 300.

ColumnsMax

Optional

System.Int32

Specifies the maximum number of columns that a list involved in a query can contain, or that the output of the query can contain. The default value is 30.

The type must be an integer in the range of 1 to 255

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Default

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application is associated with Web applications by adding this service application's proxy to the farm's default proxy list.

NonRemotableQueriesAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies that queries that cannot be remoted to the database tier can run.

OrderByMax

Optional

System.Int32

Specifies the maximum number of Order By clauses in the query. The default value is 4.

The type must be an integer in the range of 1 to 8.

OuterJoinsAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies that left and right outer joins are supported. Inner joins are always supported.

OutputCalculatedColumnsMax

Optional

System.Int32

Specifies the maximum number of calculated columns that can be included in the output as a part of the query. Calculated columns in the underlying list are not included. The default value is 10.

The type must be an integer in the range of 1 to 32.

PrivateBytesMax

Optional

System.Int32

Specifies the maximum private bytes in megabytes (MB) that can be used by Access Services. When set to -1, Access Services defaults to 75 percent of physical memory on the machine. Valid values are -1 (no limit), and from 1 to any positive integer.The default value is -1.

RecordsInTableMax

Optional

System.Int32

Specifies the maximum number of records allowed for a table in the Access Services application. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 500000.

The type must be the integer -1, or an integer in the range of 1 to MaxInt.

RequestDurationMax

Optional

System.Int32

Specifies the maximum number of seconds that a request to perform an operation can use before the request times out. Valid values include: -1, no limit, 1 to 2073600, cache remains active 1 second to 24 days. The default value is 30.

The type must be the integer -1, or an integer in the range of 1 to 2073600 (24 days)

RowsMax

Optional

System.Int32

Specifies the maximum number of rows that a list involved in a query can have, or that the output of the query can have. The default value is 50000.

The type must be an integer in the range of 1 to 200000.

SessionMemoryMax

Optional

System.Int32

Specifies the maximum allowable size, in megabytes, of an individual session. Valid values include 0, disable property, and 1 to 4095. The default value is 64.

The type must be the integer 0, or an integer in the range of 1 to 4095.

SessionsPerAnonymousUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed per user. If this maximum is reached, the oldest session will be deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The type must be the integer -1, or an integer in the range of 1 to MaxInt.

SessionsPerUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed per user. If this maximum is reached, the oldest session will be deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The type must be the integer -1, or an integer in the range of 1 to MaxInt.

SourcesMax

Optional

System.Int32

Specifies the maximum number of lists that can be used as input to a query at one time. The default value is 8.

The type must be an integer in the range of 1 to 20.

TemplateSizeMax

Optional

System.Int32

The maximum allowable size in megabytes allowed for Access templates (.accdt file files) uploaded into the solution gallery. Valid values: -1(no limit), from 1 to any positive integer.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPAccessServiceApplication cmdlet creates a new instance of an Access Services application in SharePoint Server 2013. After you create a new Access Services application, use the Set-SPAccessServiceApplication cmdlet to modify its global settings.

Input Types

Return Types

Example

------------EXAMPLE 1----------------

Copy code
New-SPAccessServiceApplication -Name "MyAccessService" -SPIisWebServiceApplicationPool MyAppPool

This example creates a new instance of Access Services named MyAccessService that runs under the application pool named MyAppPool.

------------EXAMPLE 2----------------

Copy code
New-SPAccessServiceApplication -Name "MyAccessService" -SPIisWebServiceApplicationPool MyAppPool -SessionsPerUserMax 25

This example creates a new instance of Access Services named MyAccessService that runs under the application pool named MyAppPool, which allows up to 25 sessions per user on each back end application server machine on which Access Services runs.

See also

Set-SPAccessServiceApplication
Get-SPAccessServiceApplication


Set-SPAccessServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets global properties of an existing Access Services application in SharePoint Server 2013.

Set-SPAccessServiceApplication [-Identity] <SPAccessServiceApplicationPipeBind> [-ApplicationLogSizeMax <Int32>] [-AssignmentCollection <SPAssignmentCollection>] [-CacheTimeout <Int32>] [-ColumnsMax <Int32>] [-Confirm [<SwitchParameter>]] [-NonRemotableQueriesAllowed <SwitchParameter>] [-OrderByMax <Int32>] [-OuterJoinsAllowed <SwitchParameter>] [-OutputCalculatedColumnsMax <Int32>] [-PrivateBytesMax <Int32>] [-RecordsInTableMax <Int32>] [-RequestDurationMax <Int32>] [-RowsMax <Int32>] [-SessionMemoryMax <Int32>] [-SessionsPerAnonymousUserMax <Int32>] [-SessionsPerUserMax <Int32>] [-SourcesMax <Int32>] [-TemplateSizeMax <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Access.Server.PowerShell.SPAccessServiceApplicationPipeBind

Specifies the Access Services application to update.

The type must be a valid name of an Access Services application; for example, AccessSrvApp1; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPAccessServiceApplication object.

ApplicationLogMaxSize

Optional

System.Int32

The maximum number of records for an Access Services Application Log list. Valid valies: -1 to maxint. A value of zero means none is allowed. The default value is 3000.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CacheTimeout

Optional

System.Int32

Specifies the number of seconds that a data cache will remain active on Access services with no user activity. Valid values include: -1, cache never times out; 1 to 2073600, cache remains active from 1 second to 24 days.

The type must be the integers -1, or an integer in the range of 1 to 2073600 (24 days). The default value is 300.

ColumnsMax

Optional

System.Int32

Specifies the maximum number of columns that a list involved in a query can contain, or that the output of the query can contain. The default value is 30.

The type must be an integer in the range of 1 to 255.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

NonRemotableQueriesAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies that queries that cannot be sent remotely to the database tier can run.

OrderByMax

Optional

System.Int32

Specifies the maximum number of Order By clauses in the query. The default value is 4.

The type must be an integer in the range of 1 to 8.

OuterJoinsAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies that left and right outer joins are supported. Inner joins are always supported.

OutputCalculatedColumnsMax

Optional

System.Int32

Specifies the maximum number of calculated columns that can be included in the output as a part of the query. Calculated columns in the underlying SharePoint list are not included. The default value is 10.

The type must be an integer in the range of 1 to 32.

PrivateBytesMax

Optional

System.Int32

Specifies the maximum private bytes in megabytes that can be used by Access Services. When set to -1 it defaults to 75 percent of physical memory on the machine. Valid values: -1, no limit, from 1 to any positive integer.The default value is -1.

RecordsInTableMax

Optional

System.Int32

Specifies the maximum number of records allowed for a table in the Access Services application. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 500000.

The type must be the integer -1, or an integer in the range of 1 to MaxInt.

RequestDurationMax

Optional

System.Int32

Specifies the maximum number of seconds that a request to perform an operation can use before the request times out. Valid values include: -1, no limit, 1 to 2073600, cache remains active 1 second to 24 days. The default value is 30.

The type must be the integer -1, or an integer in the range of 1 to 2073600 (24 days)

RowsMax

Optional

System.Int32

Specifies the maximum number of rows that a list involved in a query can have, or that the output of the query can have. The default value is 50000.

The type must be an integer in the range of 1 to 200000.

SessionMemoryMax

Optional

System.Int32

Specifies the maximum allowable size, in megabytes, of an individual session. Valid values include: 0, disable property, 1 to 4095. The default value is 64.

The type must be the integer 0, or an integer in the range of 1 to 4095.

SessionsPerAnonymousUserMax

Optional

System.Int32

The maximum number of sessions allowed per user. If this maximum is reached, the oldest session will be deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The integer -1, or an integer in the range of 1 to MaxInt

SessionsPerUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed per user. If this maximum is reached, the oldest session will be deleted when a new session is started. Valid values include: -1, no limit, and 1 to any positive integer. The default value is 10.

The integer -1, or an integer in the range of 1 to MaxInt.

SourcesMax

Optional

System.Int32

Specifies the maximum number of lists that may be used as input to a query at one time. The default value is 8.

The type must be an integer in the range of 1 to 20.

TemplateSizeMax

Optional

System.Int32

The maximum allowable size in megabytes (MB) allowed for Access templates (.accdt files) uploaded into the solution gallery. Valid values: -1, no limit, from 1 to any positive integer.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPAccessServiceApplication cmdlet sets the global runtime properties of an existing Access Services application in SharePoint Server 2013. The changes made to the properties by using this cmdlet affect all machines in the farm on which this Access Services application runs.

Input Types

Return Types

Example

------------EXAMPLE 1------------------

Copy code
Set-SPAccessServiceApplication -identity "MyAccessService" -requestDurationMax 100

This example sets the Access Services application named MyAccessService to let requests take up to 100 seconds before they time out.

------------EXAMPLE 2------------------

Copy code
Get-SPAccessServiceApplication | Set-SPAccessServiceApplication -sessionsPerUserMax 5

This example sets every Access Services application in the farm to allow up to five sessions per user on each back-end application server computer on which Access Services runs.

First, every Access Services application is retrieved, and then a new value is set by using the Set-SPAccessServiceApplication cmdlet.

------------EXAMPLE 3------------------

Copy code
Get-SPAccessServiceApplication | where {$_.rowsMax -gt 50000 } | Set-SPAccessServiceApplication -rowsMax 50000

This example sets every Access Services application in the farm that allows more than 50,000 rows to be returned from, or used in, a query, and then sets the service application to allow up to 50,000 rows only.

First, every Access Services application that has more than 50,000 rows is retrieved, and then a new value is set by using the Set-SPAccessServiceApplication cmdlet.

See also

Get-SPAccessServiceApplication


App Management Service cmdlets in SharePoint 2013
See also

Summary: Provides a list of Windows PowerShell cmdlets that you can use to manage apps in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use the App Management cmdlets to add specific information or functionality to a SharePoint site.

All cmdlets on this page are new to SharePoint Server 2013.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Add-SPAppDeniedEndpoint | Adds an endpoint to the apps denied endpoint list.
Clear-SPAppDeniedEndpoints | Obsolete. For the replacement, see Clear-SPAppDeniedEndpointList.
Clear-SPAppDeniedEndpointList | Removes all app-denied endpoints.
Disable-SPAppAutoProvision | Disables automatic provisioning of an app.
Enable-SPAppAutoProvision | Enables automatic provisioning of an app.
Export-SPAppPackage | Exports an app package.
Get-SPAppAcquisitionSettings | Obsolete. For the replacement, see Get-SPAppAcquisitionConfiguration
Get-SPAppAcquisitionConfiguration | Returns app acquisition settings.
Get-SPAppAutoProvisionConnection | Returns provision connection settings for an app.
Get-SPAppDeniedEndpoints | Obsolete. For the replacement, see Get-SPAppDeniedEndpointList
Get-SPAppDeniedEndpointList | Gets the App denied endpoint list.
Get-SPAppDomain | Gets the domain used to host app.
Get-SPAppHostingQuotas | Obsolete. For the replacement, see Get-SPAppHostingQuotaConfiguration
Get-SPAppHostingQuotaConfiguration | Returns the hosting quotas for an app.
Get-SPAppInstance | Returns the metadata for an instance of an app.
Get-SPAppMarketplaceSettings | Obsolete. For the replacement, see Get-SPAppStoreConfiguration
Get-SPAppStoreConfiguration | Returns app SharePoint Store settings.
Get-SPAppScaleProfile | Returns settings for an app profile.
Get-SPAppDisableSettings | Obsolete. For the replacement, see Get-SPAppDisablingConfiguration
Get-SPAppDisablingConfiguration | Returns the disable list sync state for an app.
Get-SPAppStateUpdateInterval | Returns the interval in hours between updates of the app state update job.
Get-SPAppStateSyncLastRunTime | Returns the latest time the app state update job was invoked.
Get-SPInternalAppStateSyncLastRunTime | Returns the latest time the internal app state update job was invoked.
Get-SPInternalAppStateUpdateInterval | Returns the interval in hours between updates of the internal app state update job.
Import-SPAppPackage | Imports an app package.
Install-SPApp | Installs an instance of an app.
New-SPAppManagementServiceApplication | Creates an App Management Service application.
New-SPAppManagementServiceApplicationProxy | Creates an App Management Service application proxy.
Remove-SPAppDeniedEndpoint | Removes an endpoint from the app denied endpoint list.
Restart-SPAppInstanceJobs | Obsolete. For replacement, see Restart-SPAppInstanceJob
Restart-SPAppInstanceJob | Restarts an app instance.
Set-SPAppAcquisitionSettings | Obsolete. For the replacement, see Set-SPAppAcquisitionConfiguration
Set-SPAppAcquisitionConfiguration | Sets app acquisition settings.
Set-SPAppAutoProvisionConnection | Sets provision connection settings for an app.
Set-SPAppDomain | Sets the domain used to host app.
Set-SPAppHostingQuotas | Obsolete. For the replacement, see Set-SPAppHostingQuotaConfiguration
Set-SPAppHostingQuotaConfiguration | Sets hosting quotas for an app.
Set-SPAppManagementDeploymentId | Sets the identifier of the farm or tenant used by the Office Marketplace to issue App licenses.
Set-SPAppMarketplaceSettings | Obsolete. For the replacement, see Set-SPAppStoreConfiguration
Set-SPAppStoreConfiguration | Sets SharePoint Store settings for an app.
Set-SPAppScaleProfile | Sets settings for the app profile.
Set-SPAppDisableSettings | Obsolete. For the replacement, see Set-SPAppDisablingConfiguration
Set-SPAppDisablingConfiguration | Sets the disable list sync state for an app.
Set-SPAppStateUpdateInterval | Sets the interval in hours between updates of the app state update job.
Set-SPInternalAppStateUpdateInterval | Sets the interval in hours between updates of the internal app state update job.
Uninstall-SPAppInstance | Uninstalls an instance of an app.
Update-SPAppCatalogSettings | Obsolete. For the replacement, see Update-SPAppCatalogConfiguration
Update-SPAppCatalogConfiguration | Sets a specific site collection as the App Catalog site collection.
Update-SPAppInstance | Updates the app instance.
Get-SPMarketplaceConnectionSettings | Returns SharePoint Store settings.
New-SPMarketplaceWebServiceApplicationProxy | Creates a service application proxy for the app identity data web service.
Set-SPMarketplaceConnectionSettings | Sets SharePoint Store connection settings.
Get-SPAppDisableSettings | Obsolete. For the replacement, see Get-SPAppDisablingConfiguration
Get-SPAppDisablingConfiguration | Returns the disable list sync state for an app.
Set-SPAppDisableSettings | Obsolete. For the replacement, see Set-SPAppDisablingConfiguration
Set-SPAppDisablingConfiguration | Sets the disable list sync state for an app.
Get-SPAppSiteSubscriptionName | Returns the name of the specified site subscription.
Get-SPOfficeStoreAppsDefaultActivation | Returns the properties of apps for Office.
Set-SPAppSiteSubscriptionName | Sets or changes the name for the specified site subscription.
Set-SPOfficeStoreAppsDefaultActivation | Sets the properties of apps for Office.
Set-SPAppSiteDomain | Creates or changes the URL of any installed app.
Get-SPWebApplicationAppDomain | Returns all app domains for a specific web application.
New-SPWebApplicationAppDomain | Creates or changes a AppDomain entry.
Remove-SPWebApplicationAppDomain | Deletes the AppDomain.

See also

Windows PowerShell for SharePoint 2013 reference


Add-SPAppDeniedEndpoint
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a relative URL endpoint of a server to the list of app-denied endpoints.

Add-SPAppDeniedEndpoint [-Endpoint] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Endpoint

Required

System.String

Specifies a relative URL endpoint of a server that is added to the list of app-denied endpoints. Apps will not be able to access relative URL endpoints of a server that exist in the app-denied endpoint list.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Add-SPAppDeniedEndpoint cmdlet to add a relative URL endpoint of a server to the list of app-denied endpoints in the farm.

Input Types

Return Types

Example

-------------EXAMPLE-------------

Copy code
Add-SPAppDeniedEndpoint -Endpoint "/_vti_bin/contoso/service.asmx"

This example adds the "/_vti_bin/contoso/service.asmx" endpoint to the list of denied endpoints for apps. Apps will not be able to access this endpoint.

See also

Clear-SPAppDeniedEndpoints
Get-SPAppDeniedEndpoints
Remove-SPAppDeniedEndpoint
Set-SPServiceApplicationEndpoint


Clear-SPAppDeniedEndpoints
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Clear-SPAppDeniedEndpointList.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Disable-SPAppAutoProvision
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Disables automatic provisioning of an app.

Disable-SPAppAutoProvision [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site collection for which auto provisioning is to be disabled.

Detailed Description

Use the Disable-SPAppAutoProvision cmdlet to disable automatic provisioning of an app to the farm.

Input Types

Return Types

Example

---------------EXAMPLE 1--------------

Copy code
Disable-SPAppAutoProvision

This example disables app auto provisioning for the farm. The app auto provisioning is enabled by default. This setting overrides site subscription level setting.

---------------EXAMPLE 2--------------

Copy code
$subscription = Get-SPSiteSubscription http://Contoso.com
Copy code
Disable-SPAppAutoProvision -SiteSubscription $subscription

This example disables app auto provisioning for the site subscription for Contoso.Com site. The app auto provisioning is enabled by default.

See also

Enable-SPAppAutoProvision
Get-SPAppAutoProvisionConnection
Set-SPAppAutoProvisionConnection


Enable-SPAppAutoProvision
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Enables automatic provisioning of an app.

Enable-SPAppAutoProvision [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site collection for which auto provisioning is to be enabled.

Detailed Description

Use the Enable-SPAppAutoProvision cmdlet to enable automatic provisioning of an app to the farm.

Input Types

Return Types

Example

--------------EXAMPLE 1--------

Copy code
Enable-SPAppAutoProvision

This example enables auto provisioning for the farm. The app auto provisioning is enabled by default. This setting overrides site subscription level setting.

--------------EXAMPLE 2--------

Copy code
$subscription = Get-SPSiteSubscription http://Contoso.com
Copy code
Enable-SPAppAutoProvision -SiteSubscription $subscription

This example enables app auto provisioning for the site subscription for Contoso.Com site. The app auto provisioning is enabled by default.

See also

Disable-SPAppAutoProvision
Get-SPAppAutoProvisionConnection
Set-SPAppAutoProvisionConnection


Export-SPAppPackage
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Exports an app package.

Export-SPAppPackage -App <SPApp> -Path <String> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

App

Required

Microsoft.SharePoint.Administration.SPApp

Specifies the App for which to export the package.

Path

Required

System.String

Specifies the path of the exported file.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Export-SPAppPackage cmdlet to export an app package from the content database.

Input Types

Return Types

Example

--------------EXAMPLE-----------

Copy code
$instance = Get-SPAppInstance -AppInstanceId $instance.Id
Copy code
Export-SPAppPackage -App $instance.App -Path .\exported.spapp

This example exports an app package to the \exported.spapp location.

See also

Import-SPAppPackage


Get-SPAppAcquisitionSettings
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Get-SPAppAcquisitionConfiguration

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Get-SPAppAutoProvisionConnection
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns provision connection settings for an app.

Get-SPAppAutoProvisionConnection [-AssignmentCollection <SPAssignmentCollection>] [-ConnectionType <RemoteWebHost>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ConnectionType

Optional

Microsoft.SharePoint.Administration.SPAppCmdlets.GetAppAutoProvisionCmdlet+ConnectionTypes

Specifies the connection type to provision the app.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site collection from which to return the provision connection.

Detailed Description

Use the Get-SPAppAutoProvisionConnection cmdlet to return the provision connection settings for an app.

Input Types

Return Types

Example

---------------EXAMPLE 1----------

Copy code
Get-SpAppAutoProvisionConnection

This example returns the entire app auto provisioning connection information for the default site subscription.

---------------EXAMPLE 2----------

Copy code
$subscription = Get-SPSiteSubscription http://Contoso.com
Copy code
Get-SPAppAutoProvisionConnection -SiteSubscription $subscription -ConnectionType RemoteWebHost

This example returns the remote web host app auto provisioning connection information for the site subscription for Contoso.com site

See also

Set-SPAppAutoProvisionConnection


Get-SPAppDeniedEndpoints
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Get-SPAppDeniedEndpointList.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Get-SPAppDomain
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the domain used to host apps.

Get-SPAppDomain [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAppDomain cmdlet to return the domain used to host apps in the farm.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Get-SPAppDomain

This example returns the domain name that hosts apps in the entire farm.

See also

Set-SPAppDomain


Get-SPAppHostingQuotas
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Get-SPAppHostingQuotaConfiguration.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Get-SPAppInstance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the hosting quotas for an app.

Get-SPAppInstance -Identity <SPAppInstance> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPAppInstance -Web <SPWebPipeBind> [-App <SPApp>] [-AssignmentCollection <SPAssignmentCollection>]
Get-SPAppInstance -AppInstanceId <Guid> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.Administration.SPAppInstance

Specifies the App instance for which to find metadata.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

App

Optional

Microsoft.SharePoint.Administration.SPApp

Specifies the App. This parameter returns metadata for all instances of an app.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

3

Parameter

Required

Type

Description

Site

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Sets the query scope to a site.

Note:

Subsites are not included.

App

Optional

Microsoft.SharePoint.Administration.SPApp

Specifies the App. This parameter returns metadata for all instances of an app.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Get-AppInstance cmdlet to get a collection of app instances that are installed on an SPWeb object.

Input Types

Return Types

Example

-----------EXAMPLE 1-----------

Copy code
$instances = Get-SPAppInstance -Web http://localhost

This example returns a collection if more than one app is installed on http://localhost. If only one app is installed, a single object is returned.

-----------EXAMPLE 2-----------

Copy code
$instance = Get-SPAppInstance -AppInstanceId $instance.Id

This example returns the ID of an instance of an app.

See also

Restart-SPAppInstanceJobs
Uninstall-SPAppInstance
Update-SPAppInstance


Get-SPAppMarketplaceSettings
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Get-SPAppStoreConfiguration.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Get-SPAppScaleProfile
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns settings for an app profile.

Get-SPAppScaleProfile [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAppScaleProfile cmdlet to return settings for an app profile.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
$scaleProfile = Get-SPAppScaleProfile
Copy code
$scaleProfile.MaxDatabaseSize
Copy code
$scaleProfile.RemoteWebSiteInstanceCount

This example returns the farm level app scale profile.

See also

Set-SPAppScaleProfile


Get-SPAppStateUpdateInterval
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the interval in hours between updates of the app state update job.

Get-SPAppStateUpdateInterval [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAppStateUpdateInterval cmdlet to return the interval in hours between updates of the the app state update job. The app state update job updates the app states, including app updates, in SharePoint 2013 based on information in the SharePoint Store.

Input Types

Return Types

Example

Copy code
Get-SPAppStateUpdateInterval

This example returns the app state update timer job invocation interval in hours.

See also

Set-SPAppStateUpdateInterval


Get-SPAppStateSyncLastRunTime
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the latest time the app state update job was invoked.

Get-SPAppStateSyncLastRunTime [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAppStateSyncLastRunTime cmdlet to return the latest time the app state update job was invoked. The app state update job updates the app states in SharePoint from the marketplace including app updates.

Input Types

Return Types

Example

----------------EXAMPLE------------

Copy code
Get-SPAppStateSyncLastRunTime

This example returns the latest time the app state update job was invoked


Get-SPInternalAppStateSyncLastRunTime
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the latest time the internal app state update job was invoked.

Get-SPInternalAppStateSyncLastRunTime [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPInternalAppStateSyncLastRunTime cmdlet to return the latest time the internal app state update job was invoked. The internal app state update job gets app upgrades from the internal app directory and sets them on app instances.

Input Types

Return Types

Example

-------------EXAMPLE-----------

Copy code
Get-SPInternalAppStateSyncLastRunTime

This example returns the latest time the internal app state update job was invoked.


Get-SPInternalAppStateUpdateInterval
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the interval in hours between updates of the internal app state update job.

Get-SPInternalAppStateUpdateInterval [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPInternalAppStateUpdateInterval cmdlet to return the interval in hours between updates of the internal app state update job. The internal app state update job gets app upgrades from the internal app directory and sets them on app instances.

Input Types

Return Types

Example

------------EXAMPLE-----------

Copy code
Get-SPInternalAppStateUpdateInterval

This example returns the interval in hours between updates of the internal app state update job.

See also

Set-SPInternalAppStateUpdateInterval


Import-SPAppPackage
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Imports an app package.

Import-SPAppPackage -Path <String> -Site <SPSitePipeBind> -Source <InvalidSource | Marketplace | CorporateCatalog | DeveloperSite | ObjectModel | RemoteObjectModel> [-AssetId <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ContentMarket <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Path

Required

System.String

Specifies the path of the input file.

SiteCollection

Required

Microsoft.SharePoint.SPSite

Sets the scope of the location of the imported app package. Valid value is: Site collection.

Source

Required

Microsoft.SharePoint.Administration.SPAppSource

Defines the source of the app.

The following are valid values:

--SharePoint Store

--App catalog

--SharePointService- Indicates apps that were built in place with SharePoint features, for example Access Services.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Import-SPAppPackage cmdlet to import an app package from the content database and create an app inside the site collection by using the SiteCollection parameter.

Input Types

Return Types

Example

-----------EXAMPLE----------

Copy code
$spapp = Import-SPAppPackage -Path .\feature-upgrade-v1.spapp -Site http://localhost -Source ([microsoft.sharepoint.administration.spappsource]::ObjectModel)

This example imports an app package.

See also

Export-SPAppPackage


Install-SPApp
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Installs an instance of an app.

Install-SPApp -Identity <SPApp> -Web <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Administration.SPApp

Specifies the app to install. The App object is created by using the Import-SPAppPackage cmdlet.

Site

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the web, either as an ID or URL, in which the app will be installed.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Install-SPApp cmdlet to install an instance of an app within a web application.

Input Types

Return Types

Example

------------EXAMPLE------------

Copy code
$spapp = Import-SPAppPackage -Path .\feature-upgrade-v1.spapp -Site http://localhost -Source ([microsoft.sharepoint.administration.spappsource]::ObjectModel)
Copy code
$instance = Install-SPApp -Web http://localhost -Identity $spapp

This example installs an app by first importing the app package, and then installing it.

See also

Import-SPAppPackage


New-SPAppManagementServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates an App Management Service application.

New-SPAppManagementServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-FailoverDatabaseServer <String>] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool of the service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the credentials to use when creating the service application database. These credentials will have owner rights on the newly created service application database. If a value is not provided, the current user's credentials are used by default.

DatabaseName

Optional

System.String

Specifies the name of the service application database to be created. If a value is not provided, a default database name is provided.

DatabaseServer

Optional

System.String

Specifies the server of the service application database to be created, If a value is not provided, the default database server is used.

FailoverDatabaseServer

Optional

System.String

Specifies the failover server of the service application database to be created, If a value is not provided, there will not be a failover server for the service application database.

Name

Optional

System.String

Specifies the name of the service application to be created. If not provided, the default name is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPAppManagementServiceApplication cmdlet to create an App Management Service application with the specified name on the specified application pool with a single database which specified parameters create.

Input Types

Return Types

Example

--------------EXAMPLE----------

Copy code
New-SPAppManagementServiceApplication -Name AppManagement -DatabaseServer MyDatabaseServer -DatabaseName AppManagementDB -ApplicationPool MyServiceAppPool

This example creates an App Management Service application named AppManagement with a database server MyDatabaseServer and database name AppManagementDB. The new service application will run under the app pool named MyServiceAppPool

See also

New-SPAppManagementServiceApplicationProxy


New-SPAppManagementServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates an App Management Service application proxy.

New-SPAppManagementServiceApplicationProxy -Uri <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Name <String>] [-UseDefaultProxyGroup <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
New-SPAppManagementServiceApplicationProxy -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Name <String>] [-UseDefaultProxyGroup <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Uri

Required

System.String

Specifies the endpoint URI of the App Management Service application in which to create the service application proxy.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Name

Optional

System.String

Specifies the name of the service application proxy to be created. If a value is not provided, a default name is used.

UseDefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies whether to add the newly created service application proxy to the default proxy group.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the App Management Service application for which you are creating the service application proxy.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Name

Optional

System.String

Specifies the name of the service application proxy to be created. If a value is not provided, a default name is used.

UseDefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies whether to add the newly created service application proxy to the default proxy group.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the New-SPAppManagementServiceApplicationProxy cmdlet to create an App Management Service application proxy with the specified name for the specified App Management Service application or the specified endpoint. Depending on the parameter value, it also adds the new proxy to the default proxy group.

Input Types

Return Types

Example

---------------EXAMPLE-------------

Copy code
$appManagementServiceApplication= ???
Copy code
New-SPAppManagementServiceApplicationProxy -Name AppManagementProxy -UseDefaultProxyGroup -ServiceApplication $appManagementServiceApplication

This example creates a new App Management Service application proxy named AppManagementProxy for the specified service application and adds the new App Management Service application proxy to the default proxy group.

See also

New-SPAppManagementServiceApplication


Remove-SPAppDeniedEndpoint
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a relative URL endpoint of a server from the list of app-denied endpoints.

Remove-SPAppDeniedEndpoint [-Endpoint] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Endpoint

Required

System.String

Specifies a relative URL endpoint of a server that will be removed from the list of app-denied endpoints. Apps will not be able to access relative URL endpoints of a server that exist in the app-denied endpoint list.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPAppDeniedEndpoint cmdlet to remove a relative URL endpoint of a server from the list of app-denied endpoints.

Input Types

Return Types

Example

-----------EXAMPLE----------

Copy code
Remove-SPAppDeniedEndpoint -Endpoint "/_vti_bin/contoso/service.asmx"

This example removes the "/_vti_bin/contoso/service.asmx" endpoint from the list of denied endpoints for apps. Apps will be able to access this endpoint because it is being removed from the app-denied endpoint list.

See also

Get-SPServiceApplicationEndpoint
Remove-SPAppDeniedEndpoint
Set-SPServiceApplicationEndpoint


Restart-SPAppInstanceJobs
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For replacement, see Restart-SPAppInstanceJob.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Set-SPAppAcquisitionSettings
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Set-SPAppAcquisitionConfiguration.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Set-SPAppAutoProvisionConnection
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets provision connection settings for an app.

Set-SPAppAutoProvisionConnection -ConnectionType <RemoteWebHost> -EndPoint <String> -Password <String> -Username <String> [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]
Set-SPAppAutoProvisionConnection -ConnectionType <RemoteWebHost> -EndPoint <String> [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]
Set-SPAppAutoProvisionConnection -ConnectionType <RemoteWebHost> -Password <String> -Username <String> [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]
Set-SPAppAutoProvisionConnection -Remove <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]

Parameters

1

Parameter

Required

Type

Description

ConnectionType

Required

Microsoft.SharePoint.Administration.SPAppCmdlets.SetupAppAutoProvisionCmdlet+ConnectionTypes

Specifies the connection type to provision.

EndPoint

Required

System.String

Specifies the end point of the provision connection.

Password

Required

System.String

Specifies the password for the provision connection.

Username

Required

System.String

Specifies the user name of the connection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site collection for which the provision connection is to be associated.

2

Parameter

Required

Type

Description

ConnectionType

Required

Microsoft.SharePoint.Administration.SPAppCmdlets.SetupAppAutoProvisionCmdlet+ConnectionTypes

Specifies the connection type to provision.

EndPoint

Required

System.String

Specifies the end point of the provision connection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site collection for which the provision connection is to be associated.

3

Parameter

Required

Type

Description

ConnectionType

Required

Microsoft.SharePoint.Administration.SPAppCmdlets.SetupAppAutoProvisionCmdlet+ConnectionTypes

Specifies the connection type to provision.

Password

Required

System.String

Specifies the password for the provision connection.

Username

Required

System.String

Specifies the user name of the connection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site collection for which the provision connection is to be associated.

4

Parameter

Required

Type

Description

Remove

Required

System.Management.Automation.SwitchParameter

Removes the auto provision connection of the app.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site collection for which the provision connection is to be associated.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPAppAutoProvisionConnection cmdlet to set provision connection settings for a specified app.

Input Types

Return Types

Example

------------EXAMPLE 1--------

Copy code
Set-SpAppAutoProvisionConnection -ConnectionType RemoteWebHost -EndPoint https://SPremotewebhost -Password passname -Username <username>

This example configures remote web host to be used provision apps that use this functionality for the default site subscription server on http://SPremotewebhost.

------------EXAMPLE 2--------

Copy code
$subscription = Get-SPSiteSubscription http://Contoso.com
Copy code
Set-SPAppAutoProvisionConnection -ConnectionType RemoteWebHost -EndPoint https://SPremotewebhost -Password passname -Username <username> -SiteSubscription $subscription

This example configures remote web host to be used provision apps that use this functionality for the site subscription of Contoso.com site to server on http://SPremotewebhost.

------------EXAMPLE 3--------

Copy code
Set-SPAppAutoProvisionConnection -ConnectionType RemoteWebHost -EndPoint https://SPremotewebhost

This example updates the endpoint of the already configured remote web host server https://SPRemotewebhost for the default site subscription.

------------EXAMPLE 4--------

Copy code
Set-SPAppAutoProvisionConnection -ConnectionType RemoteWebHost -Remove

This example removes the remote web host configuration for the default site subscription.

See also

Get-SPAppAutoProvisionConnection


Set-SPAppDomain
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the domain used to host apps.

Set-SPAppDomain [-AppDomain] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AppDomain

Required

System.String

Specifies the domain to be used for apps.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAppDomain cmdlet to set the domain used to host apps in the farm.

Input Types

Return Types

Example

------------EXAMPLE----------

Copy code
Set-SPAppDomain -AppDomain apps.contoso.com

This example sets the app domain to apps.contoso.com. All apps in the farm will be hosted in the apps.contoso.com domain.

See also

Get-SPAppDomain


Set-SPAppHostingQuotas
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Set-SPAppHostingQuotaConfiguration.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Set-SPAppManagementDeploymentId
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the identifier of the farm or tenant used by the Office Marketplace to issue App licenses.

Set-SPAppManagementDeploymentId -AppManagementServiceApplication <AppManagementServiceApplication> -DeploymentId <Guid> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Identity <SPSiteSubscriptionPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AppManagementServiceApplication

Required

Microsoft.SharePoint.AppManagement.AppManagementServiceApplication

Specifies the app management service application object that is running on the farm.

DeploymentId

Required

System.Guid

Specifies the deployment identifier value for the tenant. This parameter works in conjunction with the value that is defined with Identity parameter. If Identity parameter is omitted, then it is assumed that this deployment identifier value belongs to the farm.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Identity

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Identifies the site subscription object representing the tenant to which the DeploymentId parameter is to be assigned. If the Identity parameter is omitted, it is assumed that the deployment identifier belongs to the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAppManagementDeploymentId cmdlet to set the identifier of the farm or tenant used by the Office Marketplace to issue App Licenses. To ensure you do not lose rights to the use of all Apps you have purchased on the Marketplace, do not change the deployment id unless directed by Microsoft documentation or support.

Input Types

Return Types

Example

-----------EXAMPLE 1----------

Copy code
$appManagementServiceApplication = Get-SPServiceApplication | where {$_.TypeName -eq "App Management Service Application"}
Copy code
Set-SPAppManagementDeploymentId -DeploymentId 3102B7C3-1866-48EE-91CB-84E20AD24BF2 -AppManagementServiceApplication $appManagementServiceApplication

This example sets the deployment identifier of the current farm to 3102B7C3-1866-48EE-91CB-84E20AD24BF2.

-----------EXAMPLE 2----------

Copy code
$appManagementServiceApplication = Get-SPServiceApplication | where {$_.TypeName -eq "App Management Service Application"}
Copy code
Get-SPSiteSubscription | where{$_.Id.Id -eq "88f16a50-0530-4f3f-b749-24ef0b30d685"} | Set-SPAppManagementDeploymentId -DeploymentId 3102B7C3-1866-48EE-91CB-84E20AD24BF2 -AppManagementServiceApplication $appManagementServiceApplication

This example sets the deployment identifier of the tenant with the site subscription identifier 88f16a50-0530-4f3f-b749-24ef0b30d685 to 3102B7C3-1866-48EE-91CB-84E20AD24BF2.


Set-SPAppMarketplaceSettings
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Set-SPAppStoreConfiguration

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Set-SPAppScaleProfile
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets settings for the app profile.

Set-SPAppScaleProfile [-AssignmentCollection <SPAssignmentCollection>] [-MaxDatabaseSize <String>] [-RemoteWebSiteInstanceCount <Int32>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

MaxDatabaseSize

Optional

System.String

Specifies the database size of the app profile.

RemoteWebSiteInstanceCount

Optional

System.Int32

Specifies whether a remote site can access the profilefrom.

Detailed Description

Use the Set-SPAppScaleProfile cmdlet to set settings for an app profile.

Input Types

Return Types

Example

-----------------EXAMPLE-----------

Copy code
Set-SPAppScaleProfile -MaxDatabaseSize "2 GB" -RemoteWebSiteInstanceCount 1

This example sets the farm level app scale profile.

See also

Get-SPAppScaleProfile


Set-SPAppStateUpdateInterval
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the interval in hours between updates of the app state update job.

Set-SPAppStateUpdateInterval -AppStateSyncHours <Int32> -FastAppRevocationHours <Int32> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AppStateSyncHours

Required

System.Int32

Specifies the interval in hours between updates of the app states. Values are 1 to 24 inclusive.

FastAppRevocationHours

Required

System.Int32

Specifies the interval in hours between checks of the list of revoked apps in the SharePoint Store. If the list of revoked apps has changed from the last time, the app states are updated.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAppStateUpdateInterval cmdlet to set the interval in hours between updates of the app state update job. The app state update job updates the app states, including app updates, in SharePoint 2013 based on information in the SharePoint Store .

Input Types

Return Types

Example

-------------EXAMPLE--------------

Copy code
Set-SPAppStateUpdateInterval -AppStateSyncHours 24 -FastAppRevocationHours 6

This example sets the app state update interval to 24 hours and the fast app revocation interval to 6 hours.

See also

Get-SPAppStateUpdateInterval


Set-SPInternalAppStateUpdateInterval
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the interval in hours between updates of the internal app state update job.

Set-SPInternalAppStateUpdateInterval -AppStateSyncHours <Int32> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AppStateSyncHours

Required

System.Int32

Specifies the hour for which the internal app states are updated.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPInternalAppStateUpdateInterval cmdlet to set the interval in hours between updates of the the internal app state update job. The internal app state update job gets app upgrades from the internal app directory and sets them on app instances.

Input Types

Return Types

Example

-------------EXAMPLE------------

Copy code
Set-SPInternalAppStateUpdateInterval -AppStateSyncHours 24

This example sets a 24-hour interval between updates of the internal app state update job.

See also

Get-SPInternalAppStateUpdateInterval


Uninstall-SPAppInstance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Uninstalls an instance of an app.

Uninstall-SPAppInstance -Identity <SPAppInstance> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Administration.SPAppInstance

Specifies the app instance for which to find metadata.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Uninstall-SPAppInstance cmdlet to uninstall an instance of an app. This cmdlet is required to be run before a migration process.

Input Types

Return Types

Example

-------------EXAMPLE--------------

Copy code
$instance = Get-SPAppInstance -AppInstanceId $instance.Id
Copy code
Uninstall-SPAppInstance -Identity $spapp

This example uninstalls an instance of an app.

See also

Get-SPAppInstance
Restart-SPAppInstanceJobs
Uninstall-SPAppInstance
Uninstall-SPAppInstance


Update-SPAppCatalogSettings
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Update-SPAppCatalogConfiguration.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Update-SPAppInstance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Updates the app instance.

Update-SPAppInstance -App <SPApp> -Identity <SPAppInstance> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

App

Required

Microsoft.SharePoint.Administration.SPApp

Specifies the app version to upgrade to.

Identity

Required

Microsoft.SharePoint.Administration.SPAppInstance

Specifies The app instance to upgrade.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Update-SPAppInstance cmdlet to update the app instance.

Input Types

Return Types

Example

--------EXAMPLE---------

Copy code
$spapp = Import-SPAppPackage -Path .\feature-upgrade-v2.spapp -Site http://localhost -Source ([microsoft.sharepoint.administration.spappsource]::ObjectModel)
Copy code
$instance = Get-SPAppInstance -AppInstanceId $instance.Id
Copy code
Update-SPAppInstance -Identity $instance -App $spapp

This example updates an instance of an app.

See also

Get-SPAppInstance
Restart-SPAppInstanceJobs
Uninstall-SPAppInstance


Get-SPMarketplaceConnectionSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns SharePoint Store settings.

Get-SPMarketplaceConnectionSettings [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPMarketplaceConnectionSettings cmdlet to return SharePoint Store connection settings for apps in the farm.

Input Types

Return Types

Example

Copy code

  See also
Set-SPMarketplaceConnectionSettings


New-SPMarketplaceWebServiceApplicationProxy
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a service application proxy for the app identity data web service.

New-SPMarketplaceWebServiceApplicationProxy -Name <String> -ServiceEndpointUri <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the service application proxy.

ServiceEndpointUri

Required

System.String

Specifies the URI of the app identity data web service.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies whether to add the service application proxy to the default proxy group.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPMarketplaceWebServiceApplicationProxy cmdlet to create a service application proxy for the app identity data web service.

Input Types

Return Types

Example

-----------EXAMPLE--------

Copy code
New-SPMarketplaceWebServiceApplicationProxy -Name ApplicationIdentityData -ServiceEndpointUri http://server:7800/ApplicationIdentityData.svc -DefaultProxyGroup

This example adds a proxy named ApplicationIdentityData to the app identity web service.


Set-SPMarketplaceConnectionSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets SharePoint Store connection settings.

Set-SPMarketplaceConnectionSettings -Enable <$true | $false> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Enable

Required

System.Boolean

Specifies whether to enable to disable connection settings with SharePoint Store.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPMarketplaceConnectionSettings cmdlet to set SharePoint Store connection settings for apps in the farm.

Input Types

Return Types

Example

Copy code

  See also
Get-SPMarketplaceConnectionSettings


Get-SPAppDisableSettings
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Get-SPAppDisablingConfiguration.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Set-SPAppDisableSettings
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Obsolete. For the replacement, see Set-SPAppDisablingConfiguration.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Get-SPAppSiteSubscriptionName
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Returns the name of the specified site subscription.

Get-SPAppSiteSubscriptionName [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the SPSiteSubscription object or the SPSiteSubscription Id or the URL of an SPSite. If this parameter is not specified, then the default site subscription is used. All SharePoint SPSites are members of the default site subscription if they have not been specifically assigned a site subscription.

Detailed Description

Use the Get-SPAppSiteSubscriptionName cmdlet to return the name of the specified site subscription.

Input Types

Return Types

Example

------------EXAMPLE 1-------

Copy code
Get-SPAppSiteSubscriptionName

This example returns the name of the default site subscription.

------------EXAMPLE 2-------

Copy code
Get-SPAppSiteSubscriptionName -SiteSubscription https://www.contoso.com

This example returns the name of the site subscription for SPSite https://www.contoso.com

See also

Set-SPAppSiteSubscriptionName


Get-SPOfficeStoreAppsDefaultActivation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Returns the properties of apps for Office.

Get-SPOfficeStoreAppsDefaultActivation -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPOfficeStoreAppsDefaultActivation -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, or name of the web application to which the setting applies.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

SiteSubscription

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the Site Group to which the settings apply.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Get-SPOfficeStoreAppsDefaultActivation cmdlet to return settings for apps for Office that run in a specific web application.

Input Types

Return Types

Example

--------EXAMPLE 1------

Copy code
Get-SPOfficeStoreAppsDefaultActivation -WebApplication http://sphvm-8044

This examples returns the setting for the web application http://sphvm-8044.

--------EXAMPLE 2------

Copy code
Get-SPOfficeStoreAppsDefaultActivation -SiteSubscription efca5b88-b3a3-448d-afbc-ef620f4744f1

This examples returns the Subscription ID setting for the tenant

See also

Set-SPOfficeStoreAppsDefaultActivation


Set-SPAppSiteSubscriptionName
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Sets or changes the name for the specified site subscription.

Set-SPAppSiteSubscriptionName -Name <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name for the site subscription.

Each site subscription must have a unique name. The name is used in part to determine the domain that apps for SharePoint are installed in for each site subscription.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

The site subscription name is recorded in other databases in the SharePoint farm. In cases such as disaster recovery or restore of the SharePoint farm, the Force parameter can be specified to ensure that the site subscription name has been propagated appropriately throughout the SharePoint farm.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the SPSiteSubscription object or the SPSiteSubscription Id or the URL of an SPSite. If this parameter is not specified, then the default site subscription is used. All SharePoint SPSites are members of the default site subscription if they have not been specifically assigned a site subscription.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAppSiteSubscriptionName cmdlet to set or change the name for a specified site subscription by using the Name parameter.

Input Types

Return Types

Example

-----------EXAMPLE 1----------

Copy code
Set-SPAppSiteSubscriptionName -Name Contoso

This example sets the name of the default site subscription to "Contoso".

-----------EXAMPLE 2----------

Copy code
Set-SPAppSiteSubscriptionName -Name Contoso -SiteSubscription https://www.contoso.com

This example changes the name of the site subscription for SPSite from https://www.contoso.com to "Contoso".

See also

Get-SPAppSiteSubscriptionName


Set-SPOfficeStoreAppsDefaultActivation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Sets the properties of apps for Office.

Set-SPOfficeStoreAppsDefaultActivation -Enable <$true | $false> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Set-SPOfficeStoreAppsDefaultActivation -Enable <$true | $false> -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Enable

Required

System.Boolean

Specifies whether the apps for Office from the Office Store should be started.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, or name of the web application to which the setting applies.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Enable

Required

System.Boolean

Specifies whether the apps for Office from the Office Store should be started.

SiteSubscription

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the Site Group to which the settings apply.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPOfficeStoreAppsDefaultActivation cmdlet to set app settings for Office that are on the Office Store and would be started when the document that contains those apps in their browser is opened.

Input Types

Return Types

Example

-------EXAMPLE------

Copy code
Set-SPOfficeStoreAppsDefaultActivation -SiteSubscription efca5b88-b3a3-448d-afbc-ef620f4744f1 -Enable $true

This example enables the apps for Office from the Office Store Office client that uses the subscription id, efca5b88-b3a3-448d-afbc-ef620f4744f1.

See also

Get-SPOfficeStoreAppsDefaultActivation


Update-SPAppCatalogConfiguration
Example
[image]

Published: October 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Sets a specific site collection as the App Catalog site collection.

Update-SPAppCatalogConfiguration [-Site] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-SkipWebTemplateChecking <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site collection to be set as the app catalog site collection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Specifies to force marking the site collection even if there are validation errors.

SkipWebTemplateChecking

Optional

System.Management.Automation.SwitchParameter

Specifies whether to skip checking if the template of the site is APCATALOG#0

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Update-SPAppCatalogConfiguration cmdlet to set a specific site collection as the App Catalog site collection. The App Catalog site collection contains catalogs for Apps for SharePoint and Apps for Office. It is used to help ITPro administrators distribute SharePoint Apps and Office Apps to their end users. Each Web Application or Tenancy can have 1 App Catalog Site collection associated to it.

Input Types

Return Types

Example

---------------EXAMPLE-----------

Copy code
Update-SPAppCatalogConfiguration -Site http://localhost/sites/appcatalog_1 -Force:$true -SkipWebTemplateChecking:$true

This example sets http://localhost/sites/appcatalog_1 as the app catalog site collection for the tenant it belongs to.


Set-SPAppStoreConfiguration
See also Example
[image]

Published: October 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets SharePoint Storesettings for an app.

Set-SPAppStoreConfiguration -Enable <$true | $false> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Url <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Url

Required

System.String

Specifies the URL of the app for which to set SharePoint Store settings.

Note:

The SharePoint store value should not be changed unless instructed by a Microsoft representative.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAppStoreConfiguration cmdlet to set SharePoint Store settings for a specified app.

Input Types

Return Types

Example

-----------EXAMPLE 1--------

Copy code
Set-SPAppStoreConfiguration -Url https://officetestfive1.microsoft.com -Enable $true

This example sets the URL to the Office.com server.

-----------EXAMPLE 2--------

Copy code
Set-SPAppStoreConfiguration -Enable $false

This example turns off the SharePoint Store.

-----------EXAMPLE 3--------

Copy code
Set-SPAppStoreConfiguration -Enable $true

This example turns on the SharePoint Store.

See also

Get-SPAppStoreConfiguration


Set-SPAppHostingQuotaConfiguration
See also Example
[image]

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets hosting quotas for an app.

Set-SPAppHostingQuotaConfiguration -AppHostingLicenseQuota <Double> -AppInstanceCountQuota <Double> -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AppHostingLicenseQuota

Required

System.Double

Specifies the app licensing quota.

AppInstanceCountQuota

Required

System.Double

Specifies the number instances of an app.

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site for which to set hosting quotas.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAppHostingQuotaConfiguration cmdlet to set hosting quotas for a specified app by using the Identity parameter.

Input Types

Return Types

Example

----------------EXAMPLE 1----------
Copy code
Set-SPAppHostingQuotaConfiguration -Identity 586d4a32-98c3-42ce-80be-3c76c10c250c -AppInstanceCountQuota 50 -AppHostingLicenseQuota 25

This example sets hosting Quotas for the SiteSubscriptionId "586d4a32-98c3-42ce-80be-3c76c10c250c" with hosted appinstance limit as 50 and hosted apps licenses assigned as 25.

----------------EXAMPLE 2----------
Copy code
Get-SPSiteSubscription | Set-SPAppHostingQuotaConfiguration -Identity $_ -AppInstanceCountQuota 50 -AppHostingLicenseQuota 25

This example sets hosting Quotas for all SiteSubscriptions in the farm with hosted apps limit as 50 and hosted apps licenses assigned as 25.

See also

Get-SPAppHostingQuotaConfiguration


Set-SPAppDisablingConfiguration
See also Example
[image]

Published: October 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Sets the disable list sync state for an app.

Set-SPAppDisablingConfiguration -Enable <$true | $false> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Enable

Required

System.Boolean

Specifies whether to enable or disable an entry from the list.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAppDisablingConfiguration cmdlet to set the disabled sync list state for an app .

Input Types

Return Types

Example

-------------EXAMPLE--------

Copy code
Set-SPAppDisablingConfiguration

This example sets the disable lync state for apps.

See also

Get-SPAppDisablingConfiguration


Set-SPAppAcquisitionConfiguration
See also Example
[image]

Published: October 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Sets app acquisition settings.

Set-SPAppAcquisitionConfiguration -Enable <$true | $false> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Set-SPAppAcquisitionConfiguration -Enable <$true | $false> -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Enable

Required

System.Boolean

Specifies whether acquisition is enabled or disabled.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the web application for which acquisitions settings are to be set.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Enable

Required

System.Boolean

Specifies whether acquisition is enabled or disabled.

SiteSubscription

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site collection for which to set app acquisition settings.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPAppAcquisitionConfiguration cmdlet to set app acquisition settings from the SharePoint Store or App Catalog.

Input Types

Return Types

Example

------------EXAMPLE 1--------

Copy code
Set-SPAppAcquisitionConfiguration -WebApplication http://localhost -Enable:$false

This example disables app purchase for the specified web application.

------------EXAMPLE 2--------

Copy code
Set-SPAppAcquisitionConfiguration -SiteSubscription http://localhost/sites/SharePointOnlineAdmin1 -Enable:$false

This example disables app purchase for the specified tenant.

See also

Get-SPAppAcquisitionConfiguration


Set-SPAppSiteDomain
Example
[image]

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Creates or changes the URL of any installed app.

Set-SPAppSiteDomain -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the SPSite object or the GUID of the SPSite or the URL of the SPSite.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAppSiteDomain cmdlet to create or change the URL of any installed app by using the Site parameter to reset the subscription name and app site domain identifier.

Input Types

Return Types

Example

--------------EXAMPLE-----------

Copy code
Set-SPAppSiteDomain -Site https://www.contoso.com

This example sets the subscription name and app site domain identifier for the https://www.contoso.com site.


Restart-SPAppInstanceJob
See also Example
[image]

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Restarts an app instance.

Restart-SPAppInstanceJob -AppInstance <SPAppInstance> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AppInstance

Required

Microsoft.SharePoint.Administration.SPAppInstance

Specifies the app instance object to restart.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Restart-SPAppInstanceJob cmdlet to restart an app instance.

Input Types

Return Types

Example

-----------EXAMPLE-------------
Copy code
$instance = Get-SPAppInstance -AppInstanceId $instance.Id
Copy code
Restart-SPAppInstanceJob -AppInstance $instance

This example restarts an instance of an app by first returning the ID of the instance and then restarting it.

See also

Get-SPAppInstance
Uninstall-SPAppInstance
Uninstall-SPAppInstance


Get-SPAppStoreConfiguration
See also Example
[image]

Published: October 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Returns app SharePoint Store settings.

Get-SPAppStoreConfiguration [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAppStoreConfiguration cmdlet to return all apps and their associated SharePoint Store settings.

Input Types

Return Types

Example

------------EXAMPLE-------

Copy code
Get-SPAppStoreConfiguration

This example returns the settings for all of the apps.

See also

Set-SPAppStoreConfiguration


Get-SPAppHostingQuotaConfiguration
See also Example
[image]

Applies to: SharePoint Server 2013

Returns the hosting quotas for an app.

Get-SPAppHostingQuotaConfiguration -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site for which to return hosting quotas.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPAppHostingQuotaConfiguration cmdlet to return the hosting quotas for a specified app by using the Identity parameter.

Input Types

Return Types

Example

--------------EXAMPLE 1---------
Copy code
Get-SPAppHostingQuotaConfiguration -Identity 586d4a32-98c3-42ce-80be-3c76c10c250c

This example returns the hosted app quota associated to SiteSubscriptionID "586d4a32-98c3-42ce-80be-3c76c10c250c".

--------------EXAMPLE 2---------
Copy code
Get-SPSiteSubscription | Get-SPAppHostingQuotaConfiguration -Identity $_

This example returns the hosted app quota associated for all site subscriptions in the farm.

See also

Set-SPAppHostingQuotaConfiguration


Get-SPAppDisablingConfiguration
See also Example
[image]

Published: October 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Returns the disable list sync state for an app .

Get-SPAppDisablingConfiguration [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAppDisablingConfiguration cmdlet to return the disable sync list state for an app .

Input Types

Return Types

Example

-------------EXAMPLE-------

Copy code
Get-SPAppDisablingConfiguration

This example returns disable list sync state of a pp.

See also

Set-SPAppDisablingConfiguration


Get-SPAppAcquisitionConfiguration
See also Example
[image]

Published: October 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Returns app acquisition settings.

Get-SPAppAcquisitionConfiguration -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPAppAcquisitionConfiguration -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the web application for which app acquisition settings are to be returned.

2

Parameter

Required

Type

Description

SiteSubscription

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site collection for which app acquisition settings are to be returned.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Get-SPAppAcquisitionConfiguration cmdlet to return app acquisition settings from the SharePoint Storeor App Catalog.

Input Types

Return Types

Example

------------EXAMPLE 1-------

Copy code
Get-SPAppAcquisitionConfiguration -WebApplication http://localhost

This example returns app acquisition settings for the specified web application.

------------EXAMPLE 2-------

Copy code
Get-SPAppAcquisitionConfiguration -SiteSubscription http://localhost/sites/SharePointOnlineAdmin

This example returns app acquisition settings for the specified tenant.

See also

Set-SPAppAcquisitionConfiguration


Get-SPAppDeniedEndpointList
See also Example
[image]

Published: October 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

Returns the app-denied endpoint list.

Get-SPAppDeniedEndpointList [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAppEndpoint cmdlet to return the app-denied endpoint list for the entire farm.

Input Types

Return Types

Example

------------EXAMPLE----------

Copy code
Get-SPAppDeniedEndpoint

This example returns all the app-denied endpoints within the farm.

See also

Add-SPAppDeniedEndpoint
Remove-SPAppDeniedEndpoint

Clear-SPAppDeniedEndpointList


Clear-SPAppDeniedEndpointList
See also Example
[image]

Published: October 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

Removes all app-denied endpoints.

Clear-SPAppDeniedEndpointList [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Clear-SPAppDeniedEndpoint cmdlet to remove all app-denied endpoints in the farm.

Input Types

Return Types

Example

------------EXAMPLE---------

Copy code
Clear-SPAppDeniedEndpoint

This example removes all app-denied endpoints from the farm.

See also

Add-SPAppDeniedEndpoint
Remove-SPAppDeniedEndpoint

Get-SPAppDeniedEndpointList


Get-SPWebApplicationAppDomain
See also Example
[image]

Published: March 26, 2013

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Returns all app domains for a specific web application.

Get-SPWebApplicationAppDomain [[-Identity] <SPAppDomainPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Zone <Default | Intranet | Internet | Custom | Extranet>]
Get-SPWebApplicationAppDomain [[-Identity] <SPAppDomainPipeBind>] -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Zone <Default | Intranet | Internet | Custom | Extranet>]
Get-SPWebApplicationAppDomain [[-Identity] <SPAppDomainPipeBind>] -AppDomain <String> [-AssignmentCollection <SPAssignmentCollection>] [-Zone <Default | Intranet | Internet | Custom | Extranet>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.Administration.SPAppCmdlets.SPAppDomainPipeBind

Specifies the string of a domain name (that is, contoso.com) or a SPAppDomain object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Zone

Optional

Microsoft.SharePoint.Administration.SPUrlZone

Specifies the security zone to which the app domain will be assigned.

  • Default

  • Intranet

  • Internet

  • Extranet

  • Custom

If no value is specified, Default is applied.

2

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.Administration.SPAppCmdlets.SPAppDomainPipeBind

Specifies the string of a domain name (that is, contoso.com) or a SPAppDomain object.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the GUID, URI, or name of the web application for which the app domain is being configured.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Zone

Optional

Microsoft.SharePoint.Administration.SPUrlZone

Specifies the security zone to which the app domain will be assigned.

  • Default

  • Intranet

  • Internet

  • Extranet

  • Custom

If no value is specified, Default is applied.

3

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.Administration.SPAppCmdlets.SPAppDomainPipeBind

Specifies the string of a domain name (that is, contoso.com) or a SPAppDomain object.

AppDomain

Required

System.String

Specifies the URI of the app domain.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Zone

Optional

Microsoft.SharePoint.Administration.SPUrlZone

Specifies the security zone to which the app domain will be assigned.

  • Default

  • Intranet

  • Internet

  • Extranet

  • Custom

If no value is specified, Default is applied.

Detailed Description

Note:

The Get-SPWebApplicationAppDoman cmdlet was first introduced in the March 2013 Public Update. For additional information about updates, see Updates for SharePoint 2013 Resource Center

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Get-SPWebApplicationAppDoman cmdlet to return all app domains for a specific web application or for all web applications. If you do not specify parameters, the default zone is used.

Input Types

Return Types

Example

-----------EXAMPLE 1---------

Copy code
Get-SPWebApplicationAppDomain

Returns a list of SPAppDomain objects, one for each of the app domains for all web applications in the farm.

-----------EXAMPLE 2---------

Copy code
Get-SPWebApplicationAppDomain -Zone Default

Returns a list of SPAppDomain objects, one for each of the app domains for the Default zone for all web applications in the farm.

-----------EXAMPLE 3---------

Copy code
Get-SPWebApplicationAppDomain -WebApplication http://www.contoso.com

Returns a list of SPAppDomain objects, one for each of all the app domains for the specified web application for all zones.

-----------EXAMPLE 4---------

Copy code
Get-SPWebApplicationAppDomain -AppDomain contosoapps.com

Returns a list of SPAppDomain objects, one for each web application and zone pair that shares the specified app domain.

See also

New-SPWebApplicationAppDomain
Remove-SPWebApplicationAppDomain


New-SPWebApplicationAppDomain
See also Example
[image]

Published: March 26, 2013

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Creates an AppDomain entry.

New-SPWebApplicationAppDomain [-AppDomain] <String> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Port <Int32>] [-SecureSocketsLayer <SwitchParameter>] [-WhatIf [<SwitchParameter>]] [-Zone <Default | Intranet | Internet | Custom | Extranet>]

Parameters

Parameter Required Type Description

AppDomain

Required

System.String

Specifies the URI of the app domain.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the GUID, URI, or name of the web application for which the app domain is being configured.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Port

Optional

System.Int32

Specifies the IIS port number to which the app domain will be assigned. If no value is specified, the same port used by the web application for the zone is applied.

SecureSocketsLayer

Optional

System.Management.Automation.SwitchParameter

Specifies that the app domain will use Secured Sockets Layer (SSL) security. If no value is specified, no SSL security will be used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Zone

Optional

Microsoft.SharePoint.Administration.SPUrlZone

Specifies the security zone to which the app domain will be assigned.

  • Default

  • Intranet

  • Internet

  • Extranet

  • Custom

If no value is specified, Default is applied.

Detailed Description

Note:

The New-SPWebApplicationAppDoman cmdlet was first introduced in the March 2013 Public Update. For additional information about updates, see Updates for SharePoint 2013 Resource Center

Use the New-SPWebApplicationAppDomain cmdlet to create an AppDomain entry. If you specify a port, the cmdlet adds a port binding to the Internet Information Services (IIS) site corresponding to the webapp/ zone combination.

Input Types

Return Types

Example

----------EXAMPLE 1------------

Copy code
New-SPWebApplicationAppDomain -AppDomain contosoapps.com -WebApplication http://www.contoso.com

Creates a new app domain for apps for SharePoint for the specified web application in the default zone.

----------EXAMPLE 2------------

Copy code
New-SPWebApplicationAppDomain -AppDomain contosoapps.com -WebApplication http://www.contoso.com -Zone Internet -Port 10000

Creates a new app domain for apps for SharePoint for the specified web application in the internet zone at port 10000.

See also

Get-SPWebApplicationAppDomain
Remove-SPWebApplicationAppDomain


Remove-SPWebApplicationAppDomain
See also Example
[image]

Published: March 26, 2013

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Deletes the AppDomain.

Remove-SPWebApplicationAppDomain [-Identity] <SPAppDomainPipeBind> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]][-Zone <Default | Intranet | Internet | Custom | Extranet>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Administration.SPAppCmdlets.SPAppDomainPipeBind

Specifies the string of a domain name (that is, contoso.com) or a SPAppDomain object to remove.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the GUID, URI, or name of the web application for which the app domain is being removed.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Zone

Optional

Microsoft.SharePoint.Administration.SPUrlZone

Specifies the security zone to which the app domain will be assigned.

  • Default

  • Intranet

  • Internet

  • Extranet

  • Custom

If no value is specified, Default is applied.

Detailed Description

Note:

The Remove-SPWebApplicationAppDoman cmdlet was first introduced in the March 2013 Public Update. For additional information about updates, see Updates for SharePoint 2013 Resource Center

Use the Remove-SPWebApplicationAppDomain cmdlet to delete the AppDomain for a specified zone or to delete all the app domains for the web application if no zone is specified.

Note:

This cmdlet also deletes the Internet Information Services (IIS) port binding if any was added for the WebApp/Zone combination.

Input Types

Return Types

Example

---------------EXAMPLE 1--------------

Copy code
Remove-SPWebApplicationAppDomain -WebApplication http://www.contoso.com

Removes all of the app domains for the specified web application.

---------------EXAMPLE 2--------------

Copy code
Remove-SPWebApplicationAppDomain -WebApplication http://www.contoso.com -Zone Internet

Removes the app domains for the internet zone for the specified web application.

See also

Get-SPWebApplicationAppDomain
New-SPWebApplicationAppDomain


Backup and recovery cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you complete backup and recovery operation in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

A backup is a copy of data that is used to restore and recover that data after a system failure. Maintaining backups of data is useful for routine purposes, such as copying a database from one server to another, setting up database mirroring, archiving for governmental purposes, and disaster recovery.

In SharePoint 2013, you can use Windows PowerShell functionality to perform a backup or restore process for the following items:

  • Farm

  • Site collection

  • Configuration database

  • Services

  • List or document

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Backup-SPConfigurationDatabase | Performs a farm-level configuration-only backup.
Backup-SPFarm | Creates a backup of an individual database, Web application, or the entire farm.
Restore-SPFarm | Restores one or more items from a backup.
Backup-SPSite | Performs a backup of a site collection.
Restore-SPSite | Restores a site collection.
Get-SPBackupHistory | Returns a history of backup and restore operations.

See also

Windows PowerShell for SharePoint 2013 reference


Backup-SPConfigurationDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Performs a farm-level configuration-only backup.

Backup-SPConfigurationDatabase -Directory <String> [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-Item <String>]
Backup-SPConfigurationDatabase -ShowTree <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-Item <String>]

Parameters

1

Parameter

Required

Type

Description

Directory

Required

System.String

Specifies the path where SharePoint 2010 Products stores the backup package it generates. If you have a computer on which SQL Server 2008 and an instance of SharePoint 2010 Products are installed, you can use local drive paths. This includes a basic installation. However, if SQL Server 2008 and SharePoint 2010 Products are installed on multiple computers or if you have multiple servers running SharePoint 2010 Products, you must use Universal Naming Convention (UNC) share paths so that the SQL Server database and search components are written to the same location; for example, \\computer_name\volume\Backup).

Multiple backup packages can be stored in the same location. This is the same path that you pass to the Directory parameter of the Restore-SPFarm cmdlet.

The type must be either of the valid paths:

- C:\folder_name

- \\server_name\folder_name

Note:

The spbr* folders are automatically created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the ID and password that corresponds to the administrator user name for the SQL Server database.

This parameter should only be specified if SQL authentication is used to connect to the database. If Windows authentication is used to connect to the database, then this parameter should not be specified.

DatabaseName

Optional

System.String

Specifies the configuration database name.

DatabaseServer

Optional

System.String

Specifies the SQL database server that contains the configuration database. The default value is the local computer name.

The type must be a valid database server; for example, DS.

Item

Optional

System.String

Indicates the part of the farm to back up. You may use the full farm path notation as displayed by the ShowTree parameter or the name of the target component in the path if the component has a unique name. If multiple items match the name, the full path must be provided. Surround the item or path in quotation marks if it contains a space.

If the Item parameter is not specified, the entire farm configuration is backed up.

2

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the ID and password that corresponds to the administrator user name for the SQL Server database.

This parameter should only be specified if SQL authentication is used to connect to the database. If Windows authentication is used to connect to the database, then this parameter should not be specified.

DatabaseName

Optional

System.String

Specifies the configuration database name.

DatabaseServer

Optional

System.String

Specifies the SQL database server that contains the configuration database. The default value is the local computer name.

The type must be a valid database server; for example, DS.

Item

Optional

System.String

Indicates the part of the farm to back up. You may use the full farm path notation as displayed by the ShowTree parameter or the name of the target component in the path if the component has a unique name. If multiple items match the name, the full path must be provided. Surround the item or path in quotation marks if it contains a space.

If the Item parameter is not specified, the entire farm configuration is backed up.

ShowTree

Optional

System.Management.Automation.SwitchParameter

Displays which objects in the farm will be backed up based on the other parameters passed to the backup cmdlet, namely the Item parameter. Items that will be excluded from the backup based on the other parameters passed to the Backup-SPConfigurationDatabase cmdlet will be preceded with an asterisk character (*). Items that cannot be backed up will be enclosed in square brackets ([ ]). A backup will not be performed if the ShowTree parameter is present.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Backup-SPConfigurationDatabase cmdlet performs a configuration-only backup of the current farm or a configuration-only backup of a separate configuration database which is not attached to the current farm. If you wish to perform a configuration-only backup of the current farm, there is no need to specify the DatabaseServer and DatabaseName parameters. However, using the Backup-SPFarm cmdlet with the ConfigurationOnly parameter is recommended for such a scenario.

An example of a configuration backup is an administrator creates a farm configuration template which then can be applied to other SharePoint farms by performing a restore using the Restore-SPFarm cmdlet.

Input Types

Return Types

Example

-------------------EXAMPLE 1--------------------

Copy code
Backup-SPConfigurationDatabase -DatabaseName SharePoint_Config -DatabaseServer SqlServer1 -Directory \\server\share\Backup -ShowTree

This example displays components that are available for inclusion in a configuration-only backup.

-------------------EXAMPLE 2--------------------

Copy code
Backup-SPConfigurationDatabase -DatabaseName SharePoint_Config -DatabaseServer SqlServer1 -Directory \\server\share\Backup -Verbose

This example performs a configuration-only backup with verbose output.

See also

Connect-SPConfigurationDatabase
Disconnect-SPConfigurationDatabase
New-SPConfigurationDatabase
Remove-SPConfigurationDatabase
Restore-SPFarm


Backup-SPFarm
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a backup of an individual database, Web application, or the entire farm.

Backup-SPFarm -BackupMethod <String> -Directory <String> [-AssignmentCollection <SPAssignmentCollection>] [-BackupThreads <Int32>] [-ConfigurationOnly <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-Item <String>] [-Percentage <Int32>] [-WhatIf [<SwitchParameter>]]
Backup-SPFarm -ShowTree <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-ConfigurationOnly <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-Item <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

BackupMethod

Required

System.String

Specifies the type of backup file to be created.

If a backup is performed with the -ShowTree parameter, then the BackupMethod parameter is not used.

A full backup is a backup of all the selected data. A differential backup is a backup of all the selected data that has changed since the last full backup. If an item does not support differential backup, then a full backup is performed for that item instead.

The type must be either of the following:

- Full

- Differential

Directory

Required

System.String

Specifies the path where SharePoint 2010 Products stores the backup package it generates. If you have a computer on which SQL Server 2008 and an instance of SharePoint 2010 Products are installed, you can use local drive paths. This includes a basic installation. However, if SQL Server 2008 and SharePoint 2010 Products are installed on multiple computers or if you have multiple servers running SharePoint 2010 Products, you must use Universal Naming Convention (UNC) share paths so that the SQL Server database and search components are written to the same location; for example, \\computer_name\volume\Backup).

Multiple backup packages can be stored in the same location. This is the same path that you pass to the Directory parameter of the Restore-SPFarm cmdlet.

The type must be either of the valid paths:

- C:\folder_name

- \\server_name\folder_name

Note:

The spbr* folders are automatically created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BackupThreads

Optional

System.Int32

Specifies the number of threads to be used during the backup. The fewer the threads, the easier the backup log file is to read and understand. The more the threads, the more components that can be backed up in parallet, potentially resulting in a faster backup operation. The minimum value is 1 and the maximum value is 10.

The default value is 3.

If a backup is performed with the -ShowTree parameter, then the BackupMethod parameter is not used.

ConfigurationOnly

Optional

System.Management.Automation.SwitchParameter

If set, the backup will contain configuration settings only (no data) for each of the objects to be backed up.

Force

Optional

System.Management.Automation.SwitchParameter

Specifies to proceed with a backup operation even if the estimation is that the backup directory does not have sufficient space to hold the entire backup.

If a backup is performed with the ShowTree parameter, then the Force parameter is not used.

Item

Optional

System.String

Indicates the part of the farm to back up. You might use the full farm path notation as displayed by the ShowTree parameter or the name of the target component in the path if the component has a unique name. If multiple items are included in the same match, the full path must be provided. By default, the top node is selected. Surround the item or path in quotation marks if it contains a space. If this parameter is not specified, the entire farm is backed up.

The type must be a valid item; for example, Farm\Microsoft SharePoint Foundation Web Application\SharePoint - 80.

Percentage

Optional

System.Int32

Requests progress updates about the backup operation to be displayed in increments of that percentage; for example, a value of 5 displays backup progress updates at every 5 percent completed, and a value of 10 displays backup progress updates at every 10 percent completed. To have progress outputs displayed, you must specify the Verbose parameter.

Note:

This percentage is not precise and the actual progress updates might be lower or higher than requested. Progress updates are always recorded in the backup log file.

The percentage value is not prcesie and the actual progress updates might be lower or higher than requested.

The default value is 5. For a very large database, 1 is the recommended value.

Valid values are an integer value between 1 and 100.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ShowTree

Required

System.Management.Automation.SwitchParameter

Displays which objects in the farm will be backed up based on the other parameters passed to the Backup-SPFarm cmdelt, namely the Item parameter. Items that will be excluded from the backup based on the other parameters passed to the Backup-SPFarm cmdlet will be preceded with an asterisk character (*). Items that cannot be backed up will be enclosed in square brackets ([ ]). A backup will not be performed if the ShowTree parameter is present.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ConfigurationOnly

Optional

System.Management.Automation.SwitchParameter

If set, the backup will contain configuration settings only (no data) for each of the objects to be backed up.

Item

Optional

System.String

Indicates the part of the farm to back up. You might use the full farm path notation as displayed by the ShowTree parameter or the name of the target component in the path if the component has a unique name. If multiple items are included in the same match, the full path must be provided. By default, the top node is selected. Surround the item or path in quotation marks if it contains a space. If this parameter is not specified, the entire farm is backed up.

The type must be a valid item; for example, Farm\Microsoft SharePoint Foundation Web Application\SharePoint - 80.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Backup-SPFarm cmdlet creates a backup for the entire farm or individual components within the farm. It can also be used to back up just the configuration settings of a farm to be used as a farm template for other SharePoint farms. If you want to back up a single site collection, use the Backup-SPSite cmdlet.

Input Types

Return Types

Example

--------------------EXAMPLE 1---------------------

Copy code
Backup-SPFarm -Directory \\file_server\share\Backup -BackupMethod full -ConfigurationOnly

This example backs up the configuration settings of the farm to the \\file_server\share\Backup directory.

--------------------EXAMPLE 2---------------------

Copy code
Backup-SPFarm -ShowTree -Item "Microsoft SharePoint Foundation Web Application" -Verbose

This example shows which components of the farm would be backed up under the "Microsoft SharePoint Foundation Web Application" node, but do not actually back them up.

--------------------EXAMPLE 3---------------------

Copy code
Backup-SPFarm -Directory C:\Backup -BackupMethod full -BackupThreads 10 -Force

This example performs a backup of a farm using 10 threads and forces the backup to be saved to the C:\Backup directory even though SharePoint estimates that it does not have sufficient space available.

See also

Backup-SPConfigurationDatabase
Get-SPBackupHistory
Restore-SPFarm


Backup-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Performs a backup of a site collection.

Backup-SPSite [-Identity] <SPSitePipeBind> -Path <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-NoSiteLock <SwitchParameter>] [-UseSqlSnapshot <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site collection to be backed up.

For example, a valid URL, such as http://server_name/sites/site_name or a GUID such as, "01234567-89ab-cdef-0123-456789abcdef"

Path

Required

System.String

Specifies the full path to the backup file (that is, C:\Backup\site_name.bak.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Specify to overwrite an existing backup file if it already exists.

NoSiteLock

Optional

System.Management.Automation.SwitchParameter

Specifies the site collection to remain read and write during the backup.

If the NoSiteLock parameter is not specified, then a site collection that has a site collection lock setting of "none" or "no additions" will be temporarily set to "read only" while the site collection backup is performed. Once the backup has completed, the site collection lock will return to its original state. The backup package will record the original site collection lock state so that it is restored to that state.

If users are writing to the site collection while the site collection is being backed up, then the NoSiteLock parameter is not recommended for potential impact to backup integrity

UseSqlSnapshot

Optional

System.Management.Automation.SwitchParameter

Specifies a SQL Database Snapshot will be created when the backup begins, and all site collection data will be retrieved directly from the database snapshot. This snapshot will be deleted automatically when the backup completes

The UseSqlSnapshot parameter is recommended if the database server hosting your content database supports database snapshots such as SQL Server Enterprise Edition and SQL Server Developer Edition. This is because it will ensure a valid backup while allowing users to continue reading and writing to the site collection during the backup. It is not necessary to specify the NoSiteLock parameter when specifying the UseSqlSnapshot parameter.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Backup-SPSite cmdlet performs a backup of the site collection when the Identity parameter is used.

By default, the site collection will be set to read-only for the duration of the backup to reduce the potential for user activity during the backup operation to corrupt the backup. If you have SQL Server Enterprise Edition, we recommend that UseSqlSnapshot parameter be used because this ensures a valid backup while it allows users to continue reading and writing to the site collection during the backup.

Input Types

Return Types

Example

-------------------EXAMPLE 1--------------------

Copy code
Backup-SPSite http://server_name/sites/site_name -Path C:\Backup\site_name.bak

This example backs up a site collection at http://server_name/sites/site_name to the C:\Backup\site_name.bak file.

-------------------EXAMPLE 2--------------------

Copy code
Get-SPSiteAdministration http://server_name/sites/site_name | Backup-SPSite -Path C:\Backup\site_name.bak

This example backs up a site collection at http://server_name/sites/site_name to the C:\Backup\site_name.bak file. Same result as Example 1, but a different way of performing the operation.

-------------------EXAMPLE 3--------------------

Copy code
Backup-SPSite http://server_name/sites/site_name -Path C:\Backup\site_name.bak -UseSqlSnapshot

This example backs up a site collection using database snapshots to ensure backup integrity.

See also

Get-SPSite
Move-SPSite
Restore-SPSite
Set-SPSite
Get-SPSiteAdministration


Get-SPBackupHistory
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a history of backup and restore operations.

Get-SPBackupHistory -Directory <String> [-AssignmentCollection <SPAssignmentCollection>] [-ShowBackup <SwitchParameter>] [-ShowRestore <SwitchParameter>]

Parameters

Parameter Required Type Description

Directory

Required

System.String

Specifies the path where the SharePoint 2010 Products backup packages generated from a farm backup have been stored.

The type must be a valid path in either of the following forms:

- C:\folder_name

- \\server_name\folder_name

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ShowBackup

Optional

System.Management.Automation.SwitchParameter

Filters the output so that the history of backup operations only is displayed. If both the ShowBackup and the ShowRestore parameters are not specified, the history of both backup and restore operations is displayed.

ShowRestore

Optional

System.Management.Automation.SwitchParameter

Filters the output so that the history of restore operations only is displayed. If both the ShowBackup and the ShowRestore parameters are absent, the history of both backup and restore operations is displayed.

Detailed Description

The Get-SPBackupHistory cmdlet reads a history of backup and restore operations that have been run. Specifies whether you want to display only the backup history, only the restore history, or all of the history.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------

Copy code
Get-SPBackupHistory -Directory \\file_server\share\Backup

This example returns all farm backup and restore operations that have been run for the \\file_server\share\Backup directory.

------------------EXAMPLE 2-----------------

Copy code
Get-SPBackupHistory -Directory C:\Backup -ShowBackup

This example returns all of the farm backup operations that have been run for the C:\Backup directory.

------------------EXAMPLE 3-----------------

Copy code
(Get-SPBackupHistory -Directory C:\Backup -ShowBackup)[0].SelfId | Restore-SPFarm -Directory C:\Backup -RestoreMethod overwrite

This example gets all of the farm backup operations that have been run for the C:\Backup directory, finds the most recent backup, and then passes its backup GUID to the Restore-SPFarm cmdlet. The Restore-SPFarm cmdlet will then perform an overwrite restore from that backup package.

See also

Backup-SPFarm
Backup-SPConfigurationDatabase
Restore-SPFarm


Restore-SPFarm
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Restores one or more items from a backup.

Restore-SPFarm -Directory <String> -RestoreMethod <String> [-AssignmentCollection <SPAssignmentCollection>] [-BackupId <Guid>] [-ConfigurationOnly <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-FarmCredentials <PSCredential>] [-Force <SwitchParameter>] [-Item <String>] [-NewDatabaseServer <String>] [-Percentage <Int32>] [-RestoreThreads <Int32>] [-WhatIf [<SwitchParameter>]]
Restore-SPFarm -Directory <String> -ShowTree <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-BackupId <Guid>] [-ConfigurationOnly <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-Item <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Directory

Optional

System.String

Specifies the path where SharePoint 2010 Products stored the backup package. If you have a computer on which SQL Server 2008 and an instance of SharePoint 2010 Products are installed, you can use local drive paths. This includes a basic installation. However, if SQL Server 2008 and SharePoint 2010 Products are installed on multiple computers, you must use Universal Naming Convention (UNC) share paths so that the SQL Server 2008 and SharePoint 2010 Products can read from the same location (for example, \\computer_name \volume\Backup).

The type must be either of the valid paths:

- C:\folder_name

- \\server_name\folder_name

Note:

The spbr* folders are created automatically.

RestoreMethod

Optional

System.String

Specifies the method of restore to perform.

The valid values are:

- New; Specifies a new location to restore the content and is intended to be used when restoring to a different farm. Additional prompts will be presented to specify the new settings.

- Overwrite; Restores content and settings to their original locations and is intended to be used when restoring to the same farm it was backed up from. If the Overwrite parameter is used, a confirmation prompt is displayed. If you want the confirmation prompt suppressed, use the Force parameter.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BackupId

Optional

System.Guid

Specifies the GUID of the backup package that is to be restored. Each backup package has a unique GUID associated with it. The GUID can be seen by using the Get-SPBackupHistory cmdlet to view the backup history. If this parameter is not specified, the most recent backup package in the path that is specified with the Directory parameter is used.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890abcdef.

ConfigurationOnly

Optional

System.Management.Automation.SwitchParameter

Specifies settings only (no data) will be restored from the backup package and applied to objects on the destination farm.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FarmCredentials

Optional

System.Management.Automation.PSCredential

Specifies the credentials that will be used for all components being restored. For example, the application pool credentials for Web applications being restored. If an application pool being restored already exists in the farm, the credentials specified by the FarmCredentials parameter is ignored when restoring that application pool.

Force

Optional

System.Management.Automation.SwitchParameter

Suppresses the prompt warning that you will overwrite components when you perform an overwrite restore operation.

Item

Optional

System.String

Indicates the part of the backup package to be restored. You can use the full farm path notation as displayed by the ShowTree parameter or the name of the target component in the path if it has a unique name. If multiple items match the name, the full path must be provided. Surround the item or path in double quotation marks if it contains a space. If this parameter is absent, the entire backup package is restored.

The type must be a valid item, such as:

Farm\Microsoft SharePoint Foundation Web Application\SharePoint - 80

NewDatabaseServer

Optional

System.String

Specifies a valid SQL Database Server name. If specified, will be used as a default Database Server name for all databases within the restore operation.

This parameter is only valid when restoring as new. It is not valid for overwrite restores.

Percentage

Optional

System.Int32

Requests that progress updates about the restore operation be displayed in increments of that percentage. For example, a value of 5 displays restore progress updates at every 5 percent completed, and a value of 10 displays restore progress updates at every 10 percent completed.

Note: Progress will only be displayed in the output if the -Verbose parameter is specified. Otherwise, you may see the progress in the restore log file.

This percentage is not precise and the actual progress updates might be lower or higher than requested.

For a very large database, 1 is the recommended value.

The type must be an integer value between 1 and 100.

The default value is 5.

RestoreThreads

Optional

System.Int32

The number of threads that should be used during the restore.

The fewer the restore threads, the easier it is to understand the restore log. However, the more restore threads, the more components can be restored in parallel, potentially resulting in a faster restore.

The valid range is between 1 and 10. The default value is 3.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Directory

Optional

System.String

Specifies the path where SharePoint 2010 Products stored the backup package. If you have a computer on which SQL Server 2008 and an instance of SharePoint 2010 Products are installed, you can use local drive paths. This includes a basic installation. However, if SQL Server 2008 and SharePoint 2010 Products are installed on multiple computers, you must use Universal Naming Convention (UNC) share paths so that the SQL Server 2008 and SharePoint 2010 Products can read from the same location (for example, \\computer_name \volume\Backup).

The type must be either of the valid paths:

- C:\folder_name

- \\server_name\folder_name

Note:

The spbr* folders are created automatically.

ShowTree

Optional

System.Management.Automation.SwitchParameter

Displays which objects in the farm will be restored based on the other parameters passed to the Restore-SPFarm cmdlet namely the Item and ConfigurationOnly parameters. Items that will be excluded from the restore based on the other parameters passed to the Restore-SPFarm cmdlet will be preceded with an asterisk (*). Items that cannot be restored will be enclosed in square brackets ([ ]). A restore operation will not be performed if the ShowTree parameter is present.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BackupId

Optional

System.Guid

Specifies the GUID of the backup package that is to be restored. Each backup package has a unique GUID associated with it. The GUID can be seen by using the Get-SPBackupHistory cmdlet to view the backup history. If this parameter is not specified, the most recent backup package in the path that is specified with the Directory parameter is used.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890abcdef.

ConfigurationOnly

Optional

System.Management.Automation.SwitchParameter

Specifies settings only (no data) will be restored from the backup package and applied to objects on the destination farm.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Item

Optional

System.String

Indicates the part of the backup package to be restored. You can use the full farm path notation as displayed by the ShowTree parameter or the name of the target component in the path if it has a unique name. If multiple items match the name, the full path must be provided. Surround the item or path in double quotation marks if it contains a space. If this parameter is absent, the entire backup package is restored.

The type must be a valid item, such as:

Farm\Microsoft SharePoint Foundation Web Application\SharePoint - 80

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Restore-SPFarm cmdlet restores one or more items from a backup such as an individual database, Web application, or the entire farm. This cmdlet can also be used to apply a farm template to the entire farm.

Input Types

Return Types

Example

-------------------EXAMPLE 1-----------------------

Copy code
Restore-SPFarm -Directory \\file_server\share\Backup -BackupId 12345678-90ab-cdef-1234-567890abcdef -RestoreMethod new -ConfigurationOnly

This example restores the configuration settings from the backup package in the \\file_server\share\Backup directory to the farm.

-------------------EXAMPLE 2-----------------------

Copy code
Restore-SPFarm -ShowTree -Directory \\file_server\share\Backup -BackupId 12345678-90ab-cdef-1234-567890abcdef -Item "Microsoft SharePoint Foundation Web Application" -Verbose

This example show which components of the farm would be restored under the Microsoft SharePoint Foundation Web Application node, but does not actually restore them.

-------------------EXAMPLE 3-----------------------

Copy code
Restore-SPFarm -Directory C:\Backup -BackupId 12345678-90ab-cdef-1234-567890abcdef  -RestoreMethod overwrite -RestoreThreads 10 -Force

This example restores a farm by using 10 threads and suppresses the overwrite warning.

See also

Backup-SPFarm
Backup-SPConfigurationDatabase
Get-SPBackupHistory


Restore-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Restores a site collection.

Restore-SPSite [-Identity] <String> -Path <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ContentDatabase <SPContentDatabasePipeBind>] [-Force <SwitchParameter>] [-GradualDelete <SwitchParameter>] [-HostHeaderWebApplication <String>] [-PreserveSiteID <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Restore-SPSite [-Identity] <String> -Path <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseName <String>] [-DatabaseServer <String>] [-Force <SwitchParameter>] [-GradualDelete <SwitchParameter>] [-HostHeaderWebApplication <String>] [-PreserveSiteID <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

System.String

Specifies the URL location to which the site collection is restored.

A site collection does not have to already exist at the URL location to perform a restore. However, you must specify a valid URL location that a site collection can be created. If a site collection already exists at the specified URL location, you must specify the Force parameter to overwrite it.

The type must be a valid URL, in the form http://server_name/sites/site_name.

Path

Required

System.String

Specifies a valid path to the location of the backup. For example, C:\Backup\site_name.bak.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentDatabase

Optional

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the SQL Server content database where the site collection data will be stored. If no content database is specified, the content database with the greatest unused site collection capacity and whose database status is ready will be used.

Force

Optional

System.Management.Automation.SwitchParameter

Specifies that the existing site collection at the URL location is to be overwritten by this restoration.

GradualDelete

Optional

System.Management.Automation.SwitchParameter

Specifies that the site collection being overwritten with the Force parameter should be gradually deleted over time by a timer job instead of all at once, which reduces its impact on SharePoint 2010 Products and SQL Server performance. This option is recommended for large site collections.

HostHeaderWebApplication

Optional

System.String

A valid URL assigned to the Web application by using alternate access mapping, such as http://server_name

Restores a site collection as a host-named site collection instead of a path-based site collection. When the HostHeaderWebApplication parameter is present, the value of the Identity parameter is the URL of the host-named site collection and the value of the HostHeaderWebApplication parameter is the URL of the Web application that will hold the host-named site collection.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

System.String

Specifies the URL location to which the site collection is restored.

A site collection does not have to already exist at the URL location to perform a restore. However, you must specify a valid URL location that a site collection can be created. If a site collection already exists at the specified URL location, you must specify the Force parameter to overwrite it.

The type must be a valid URL, in the form http://server_name/sites/site_name.

Path

Required

System.String

Specifies a valid path to the location of the backup. For example, C:\Backup\site_name.bak.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseName

Optional

System.String

Specifies the SQL Server content database where the site collection data will be stored. If no content database is specified, the content database with the greatest unused site collection capacity and whose database status is ready will be used.

The type must be a valid database name, in the form SQLDB1.

DatabaseServer

Optional

System.String

Specifies the name of the SQL Server containing the content database specified by the DatabaseName parameter.

The type must be a valid database server name, in the form SQLBE1 and needs to be used in conjunction with the DatabaseName parameter.

Force

Optional

System.Management.Automation.SwitchParameter

Specifies that the existing site collection at the URL location is to be overwritten by this restoration.

GradualDelete

Optional

System.Management.Automation.SwitchParameter

Specifies that the site collection being overwritten with the Force parameter should be gradually deleted over time by a timer job instead of all at once, which reduces its impact on SharePoint 2010 Products and SQL Server performance. This option is recommended for large site collections.

HostHeaderWebApplication

Optional

System.String

A valid URL assigned to the Web application by using alternate access mapping, such as http://server_name

Restores a site collection as a host-named site collection instead of a path-based site collection. When the HostHeaderWebApplication parameter is present, the value of the Identity parameter is the URL of the host-named site collection and the value of the HostHeaderWebApplication parameter is the URL of the Web application that will hold the host-named site collection.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Restore-SPSite cmdlet performs a restoration of the site collection to a location specified by the Identity parameter. A content database may only contain one copy of a site collection. If a site collection is backed up and restored to a different URL location within the same Web application, an additional content database must be available to hold the restored copy of the site collection.

Return Types

Example

----------------------EXAMPLE 1----------------------

Copy code
Restore-SPSite http://server_name/sites/site_name -Path C:\Backup\site_name.bak

This example restores a site collection from the backup file C:\Backup\site_name.bak to the site collection URL http://server_name/sites/site_name.

----------------------EXAMPLE 2----------------------

Copy code
Restore-SPSite http://server_name/sites/site_name -Path C:\Backup\site_name.bak -Force -DatabaseServer SQLBE1 -DatabaseName SQLDB1

This example restores a site collection backup from the backup file C:\Backup\site_name.bak, but overwrites the existing site collection at http://server_name/sites/site_name while specifying that the site collection must be stored in a specific content database.

----------------------EXAMPLE 3----------------------

Copy code
Restore-SPSite http://www.example.com -Path \\file_server\share\site_name.bak -HostHeaderWebApplication http://server_name

This example restores a site collection backup from the backup file \\file_server\share\site_name.bak to the host-named site collection http://www.example.com on the Web application http://server_name.

See also

Backup-SPSite
Get-SPSite
Move-SPSite
New-SPSite
Remove-SPSite
Set-SPSite


Use Windows PowerShell cmdlets to manage Business Connectivity Services in SharePoint Server 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to manage Business Connectivity Services in SharePoint Server 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The following table shows the Windows PowerShell cmdlets that you can use to manage Business Connectivity Services in a SharePoint Server 2013 farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Clear-SPSiteSubscriptionBusinessDataCatalogConfig | Deletes all data from the Business Data Connectivity Metadata Store for a specified partition.
Copy-SPBusinessDataCatalogAclToChildren | Copies a set of permissions of a Business Data Connectivity Metadata Store metadata object to its child objects.
Disable-SPBusinessDataCatalogEntity | Deactivates an external content type in the Business Data Connectivity Metadata Store.
Enable-SPBusinessDataCatalogEntity | Activates an external content type in the Business Data Connectivity Metadata Store.
Export-SPBusinessDataCatalogModel | Exports a Business Data Connectivity Model.
Export-SPSiteSubscriptionBusinessDataCatalogConfig | Exports all data from the Business Data Connectivity Metadata Store associated with a partition.
Get-SPBusinessDataCatalogMetadataObject | Returns a Business Data Connectivity Metadata Store metadata object.
Grant-SPBusinessDataCatalogMetadataObject | Grants a right to a principal for the specified Business Data Connectivity Metadata Store metadata object.
Import-SPBusinessDataCatalogDotNetAssembly | Imports data that is associated with the Business Data Connectivity Metadata Store for a partition.
Import-SPBusinessDataCatalogModel | Imports a Business Data Connectivity Model.
New-SPBusinessDataCatalogServiceApplication | Creates a new Business Data Connectivity service application in the farm.
New-SPBusinessDataCatalogServiceApplicationProxy | Creates a new Business Data Connectivity service application proxy in the farm.
Remove-SPBusinessDataCatalogModel | Deletes a Business Data Connectivity Model.
Revoke-SPBusinessDataCatalogMetadataObject | Revokes a right to a principal in the specified Business Data Connectivity Metadata Store metadata object.
Set-SPBusinessDataCatalogMetadataObject | Sets the value of a property or attribute of a Business Data Connectivity Metadata Store metadata object.
Set-SPBusinessDataCatalogServiceApplication | Sets global properties for a Business Data Connectivity service application in the farm.
Import-SPSiteSubscriptionBusinessDataCatalogConfig | Imports data associated with an exported file that contains all data associated with the Business Data Connectivity Metadata Store for a given partition.
Remove-SPSiteSubscriptionBusinessDataCatalogConfig | Removes the Business Data Connectivity Metadata Store for a partition.
Clear-SPBusinessDataCatalogEntityNotificationWeb | Clears the entity notification site.
Get-SPBusinessDataCatalogEntityNotificationWeb | Returns the entity notification site.
Get-SPODataConnectionSetting | Returns Business Connectivity Services OData connection properties.
Get-SPODataConnectionSettingMetaData | Returns a Business Data Connectivity service metadata object.
Remove-SPODataConnectionSetting | Removes a Business Connectivity Services connection.
New-SPODataConnectionSetting | Creates a new Business Data Connectivity service connection.
New-SPBECWebServiceApplicationProxy | Do not use this cmdlet.
Set-SPBusinessDataCatalogEntityNotificationWeb | Sets the entity notification site.
Set-SPODataConnectionSetting | Sets or updates global properties for a Microsoft Business Connectivity Services connection.
Set-SPODataConnectionSettingMetaData | Updates properties for the metadata of a Business Connectivity Services connection.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Clear-SPSiteSubscriptionBusinessDataCatalogConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes all data from the Business Data Connectivity Metadata Store for a specified partition.

Clear-SPSiteSubscriptionBusinessDataCatalogConfig -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for which the Business Data Connectivity models are deleted.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Clear-SPSiteSubscriptionBusinessDataCatalogConfig cmdlet deletes all models and data from the Business Data Connectivity Metadata Store for a specified service partition.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Clear-SPSiteSubscriptionBusinessDataCatalogConfig -ServiceContext http://contoso

This example deletes all data from the Business Data Connectivity Metadata Store for the specified site.

See also

Export-SPSiteSubscriptionBusinessDataCatalogConfig
Import-SPSiteSubscriptionBusinessDataCatalogConfig


Copy-SPBusinessDataCatalogAclToChildren
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Copies a set of permissions of a Business Data Connectivity Metadata Store metadata object to its child objects.

Copy-SPBusinessDataCatalogAclToChildren -MetadataObject <MetadataObject> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

MetadataObject

Required

Microsoft.SharePoint.BusinessData.Administration.MetadataObject

Specifies the Business Data Connectivity metadata object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Copy-SPBusinessDataCatalogAclToChildren cmdlet copies a set of rights of a Business Data Connectivity metadata object to its child objects.

Any principals and their rights will be lost from the child metadata objects. Make sure that the parent metadata object has the final permissions you want, or make sure to append them to the child object again after you run this cmdlet.

Running this cmdlet on a BdcObjectType BdcCatalog (Business Data Connectivity Metadata Store) will propagate to:

- BDC Models

- External Systems

- External Content Types

- Methods

- Method Instances

Running this cmdlet on a BdcObjectType Model (Business Data Connectivity Model) will propagate to:

- Nothing; this type has no child metadata objects

Running this cmdlet on a BdcObjectType LobSystem (External System) will propagate to:

- External Content Types

- Methods

- Method Instances

Running this cmdlet on a BdcObjectType Entity (External Content Type) will propagate to:

- Methods

- Method Instances

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ExternalSystem = Get-SPBusinessDataCatalogMetadataObject -BdcObjectType "LobSystem" -ServiceContext http://contoso -Name "ContosoDatabase"

This example looks at the principals (users) and their corresponding rights given for the External System metadata object, and overwrites the permissions of its child metadata objects with these same principals and rights.

Any principals and their rights will be lost from the child metadata objects. Make sure that the parent metadata object has the final permissions you want, or make sure to append them to the child object again after you run this cmdlet.

See also

Get-SPBusinessDataCatalogMetadataObject
Grant-SPBusinessDataCatalogMetadataObject


Disable-SPBusinessDataCatalogEntity
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deactivates an External Content type in the Business Data Connectivity Metadata Store.

Disable-SPBusinessDataCatalogEntity -Identity <Entity> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.Entity

Specifies the External Content type in the Business Data Connectivity Metadata Store to deactivate.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Disable-SPBusinessDataCatalogEntity cmdlet deactivates an External Content type in the Business Data Connectivity Metadata Store.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$entityToDisable = Get-SPBusinessDataCatalogMetadataObject -Namespace "Contoso" -Name "Customer" -BdcObjectType "Entity" -ServiceContext http://contoso
Copy code
Disable-SPBusinessDataCatalogEntity -Identity $entityToDisable

This example deactivates the External Content type of the name Customer in the Contoso. Note that the terms External Content type and Entity refer to the same object type, and the term Disable refers to the same action as the Business Data Connectivity term Deactivate.

See also

Enable-SPBusinessDataCatalogEntity


Enable-SPBusinessDataCatalogEntity
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Activates an External Content type in the Business Data Connectivity Metadata Store.

Enable-SPBusinessDataCatalogEntity -Identity <Entity> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.Entity

Specifies the External Content type in the Business Data Connectivity Metadata Store to activate.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Enable-SPBusinessDataCatalogEntity cmdlet activates an External Content type in the Business Data Connectivity Metadata Store.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$entityToEnable = Get-SPBusinessDataCatalogMetadataObject -Namespace "Contoso" -Name "Customer" -BdcObjectType "Entity" -ServiceContext http://contoso
Copy code
Enable-SPBusinessDataCatalogEntity -Identity $entityToEnable

This example activates the External Content type with the name Customer in the Contoso namespace on the site http://contoso. Note that the terms External Content type and Entity refer to the same object type.

See also

Disable-SPBusinessDataCatalogEntity


Export-SPBusinessDataCatalogModel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Exports a Business Data Connectivity Model.

Export-SPBusinessDataCatalogModel -Identity <MetadataObject> -Path <String> [-AssignmentCollection <SPAssignmentCollection>] [-Force <SwitchParameter>] [-LocalizedNamesIncluded <SwitchParameter>] [-ModelsIncluded <SwitchParameter>] [-PermissionsIncluded <SwitchParameter>] [-PropertiesIncluded <SwitchParameter>] [-ProxiesIncluded <SwitchParameter>] [-SettingId <String>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.MetadataObject

Specifies the Business Data Connectivity Metadata Store metadata object from which to export the Business Data Connectivity Model.

Path

Required

System.String

Specifies the path and name to use to create the export file.

The type must be a valid path in either of the following forms:

- C:\folder_name \file.bdcm

- \\server_name\folder_name \file.bdcm

- …\folder_name\file.bdcm

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Force

Optional

System.Management.Automation.SwitchParameter

Overwrites the output file if the file exists.

LocalizedNamesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that names for business data fields in multiple languages are exported.

ModelsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that models are included in the exported Business Data Connectivity Model file. A model contains the base XML metadata for a system.

PermissionsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that permissions from the Business Data Connectivity Model are exported.

PropertiesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that properties from the application definition are exported.

ProxiesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that proxies for Business Data Connectivity Service applications are exported.

SettingId

Optional

System.String

Specifies the custom environment settings model slice to export.

The type must be a valid string that identifies a model slice; for example, ModelSlice1.

Detailed Description

The Export-SPBusinessDataCatalogModel cmdlet exports a Business Data Connectivity Model. There are two types of Business Data Connectivity models: Model type (.bdcm) and Resource type (.bdcr). The Model type contains the base XML metadata, and can also include resource properties. The Resource type includes only resource properties.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$Model = Get-SPBusinessDataCatalogMetadataObject -BdcObjectType "Model" -Name "ContosoModel" -ServiceConext http://contoso
Copy code
Export-SPBusinessDataCatalogModel -Identity $Model -Path "C:\folder\model.bdcm"

This example gets a Business Data Connectivity Model from the Business Data Connectivity Metadata Store and exports it to the location specified with the name model and using the bdcm file extension.

See also

Import-SPBusinessDataCatalogModel
Remove-SPBusinessDataCatalogModel


Export-SPSiteSubscriptionBusinessDataCatalogConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Exports all data from the Business Data Connectivity Metadata Store associated with a partition.

Export-SPSiteSubscriptionBusinessDataCatalogConfig -Path <String> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-LocalizedNamesIncluded <SwitchParameter>] [-ModelsIncluded <SwitchParameter>] [-PermissionsIncluded <SwitchParameter>] [-PropertiesIncluded <SwitchParameter>] [-ProxiesIncluded <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Path

Required

System.String

Specifies the path and name to use to create the export file.

The type must be a valid path in either of the following forms:

- C:\folder_name\file.xml

- \\server_name\folder_name\file.xml

- …\folder_name\file.xml

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context of the data to be exported.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a service context (for example, http://ServiceContext1); or an instance of a valid SPServiceContext object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Overwrites the output file if the file exists.

LocalizedNamesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that names for business data fields in multiple languages are exported.

ModelsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that Business Data Connectivity models are included in the exported file.

PermissionsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that permissions from the Business Data Connectivity Models are exported.

PropertiesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that properties from the Business Data Connectivity Models are exported.

ProxiesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that proxies for Business Data Connectivity Service applications are exported.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The SPSiteSubscriptionBusinessDataCatalogConfig cmdlet exports all data from the Business Data Connectivity Metadata Store associated with a specified partition.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Export-SPSiteSubscriptionBusinessDataCatalogConfig -ServiceContext http://contoso -Path "C:\folder\exportedFile.xml"

This example exports the data file named exportedFile.xml.

See also

Import-SPSiteSubscriptionBusinessDataCatalogConfig
Clear-SPSiteSubscriptionBusinessDataCatalogConfig


Get-SPBusinessDataCatalogMetadataObject
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a Business Data Connectivity Metadata Store metadata object.

Get-SPBusinessDataCatalogMetadataObject -BdcObjectType <Catalog | Model | LobSystem | LobSystemInstance | Entity> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-ContainingLobSystem <String>] [-Name <String>] [-Namespace <String>]

Parameters

Parameter Required Type Description

BdcObjectType

Required

Microsoft.SharePoint.BusinessData.SharedService.SPGetSPBusinessDataCatalogMetadataObjectCmdlet+PSBdcObjectType

Specifies the type of the metadata object to return.

The type must be one of the following valid metadata object types: BdcCatalog, Model, LobSystem, LobSystemInstance, or Entity.

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context of the Business Data Connectivity Metadata Store metadata object to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Name

Optional

System.String

Specifies the name of the metadata object.

Namespace

Optional

System.String

Specifies the namespace of the metadata object.

Detailed Description

The Get-SPBusinessDataCatalogMetadataObject cmdlet reads a Business Data Connectivity Metadata Store metadata object from a Business Data Connectivity Service application. Output for this cmdlet can be a series of objects.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$Model = Get-SPBusinessDataCatalogMetadataObject -BdcObjectType "Model" -Name "ContosoModel" -ServiceConext http://contoso

This example gets a metadata object of type Model with the name ContosoModel from the Business Data Connectivity Metadata Store on the given site.

See also

Set-SPBusinessDataCatalogMetadataObject
Grant-SPBusinessDataCatalogMetadataObject
Revoke-SPBusinessDataCatalogMetadataObject


Grant-SPBusinessDataCatalogMetadataObject
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Grants a right to a principal for the specified Business Data Connectivity Metadata Store metadata object.

Grant-SPBusinessDataCatalogMetadataObject -Identity <MetadataObject> -Principal <SPClaim> -Right <Execute | Edit | SetPermissions | SelectableInClients> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SettingId <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.MetadataObject

Specifies the Business Data Connectivity Metadata Store metadata object that contains the principal.

Principal

Required

System.String

Specifies the principal to whom the rights apply.

The type must be a claim.

Right

Required

Microsoft.SharePoint.BusinessData.SharedService.SPGrantSPBusinessDataCatalogMetadataObjectCmdlet+PSBdcRight

Specifies the right to grant the principal.

The type must be one of the following valid PSBdcRight object types: All, Execute, Edit, SetPermissions, or SelectableInClients.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SettingId

Optional

System.String

Specifies the model slice for which to grant the right.

The type must be a valid string that identifies a model slice; for example, ModelSlice1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Grant-SPBusinessDataCatalogMetadataObject cmdlet grants the right to a specified principal (user) for a Business Data Connectivity Metadata Store metadata object. This cmdlet checks to verify that the Identity parameter is a valid IndividuallySecurableMetadata object.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$claimJohn = New-SPClaimsPrincipal -Identity "CONTOSO\johndoe" -IdentityType WindowsSamAccountName
Copy code
$Model = Get-SPBusinessDataCatalogMetadataObject -BdcObjectType "Model" -ServiceContext http://contoso -Name "ContosoModel"
Copy code
Grant-SPBusinessDataCatalogMetadataObject -Identity $Model -Principal $claimJohn -Right Edit

This example gives Edit permissions to the user with the identity johndoe on domain CONTOSO, for the model metadata object with the name ContosoModel.

See also

Set-SPBusinessDataCatalogMetadataObject
Get-SPBusinessDataCatalogMetadataObject
Revoke-SPBusinessDataCatalogMetadataObject


Import-SPBusinessDataCatalogDotNetAssembly
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Imports a .NET Connectivity assembly.

Import-SPBusinessDataCatalogDotNetAssembly -LobSystem <LobSystem> -Path <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DependentAssemblyPaths <String[]>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

LobSystem

Required

Microsoft.SharePoint.BusinessData.Administration.LobSystem

Specifies the LobSystem that the assembly corresponds to.

Path

Required

System.String

Specifies the path to the primary assembly.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DependentAssemblyPaths

Optional

System.String[]

Specifies a list of paths to dependent assemblies.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Import-SPBusinessDataCatalogDotNetAssembly cmdlet imports a .NET Connectivity Assembly that corresponds to a .NET Assembly Connector and LobSystem in the metadata store.

Input Types

Return Types

Example

-----------------EXAMPLE 1----------------

Copy code
Import-SPBusinessDataCatalogDotNetAssembly -LobSystem $ContosoDB -Path "c:\Folder\Assembly.dll"

This example imports the assembly Assembly.

-----------------EXAMPLE 2----------------

Copy code
Import-SPBusinessDataCatalogDotNetAssembly -LobSystem $ContosoDB -Path "c:\Folder\Assembly.dll" -DependentAssemblyPaths "c:\Folder\Assembly2.dll","c:\Folder\Assembly3.dll"

This example imports the assembly Assembly, and also imports the dependent assemblies Assembly2 and Assembly3.


Import-SPBusinessDataCatalogModel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Imports a Business Data Connectivity Model.

Import-SPBusinessDataCatalogModel -Identity <MetadataObject> -Path <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-LocalizedNamesIncluded <SwitchParameter>] [-ModelsIncluded <SwitchParameter>] [-PermissionsIncluded <SwitchParameter>] [-PropertiesIncluded <SwitchParameter>] [-SettingId <String>] [-WhatIf [<SwitchParameter>]]
Import-SPBusinessDataCatalogModel -Path <String> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-LocalizedNamesIncluded <SwitchParameter>] [-ModelsIncluded <SwitchParameter>] [-PermissionsIncluded <SwitchParameter>] [-PropertiesIncluded <SwitchParameter>] [-SettingId <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.MetadataObject

Specifies the Business Data Connectivity Metadata Store metadata object to import to.

Path

Required

System.String

Specifies the path and name to use.

The type must be a valid path in either of the following forms:

- C:\folder_name\file.bdcm

- \\server_name\folder_name\file.bdcm

- …\folder_name\file.bdcm

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Overwrites the Business Data Connectivity Model if the file exists.

LocalizedNamesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that names for business data fields in multiple languages are imported.

ModelsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that models are included in the imported Business Data Connectivity Model file. A model contains the base XML metadata for a system.

PermissionsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that permissions from the Business Data Connectivity Model are imported.

PropertiesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that properties from the Business Data Connectivity Model are imported.

SettingId

Optional

System.String

Specifies the custom environment settings model slice to import.

The type must be a valid string that identifies a model slice; for example, ModelSlice1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Path

Required

System.String

Specifies the path and name to use.

The type must be a valid path in either of the following forms:

- C:\folder_name\file.bdcm

- \\server_name\folder_name\file.bdcm

- …\folder_name\file.bdcm

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Overwrites the Business Data Connectivity Model if the file exists.

LocalizedNamesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that names for business data fields in multiple languages are imported.

ModelsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that models are included in the imported Business Data Connectivity Model file. A model contains the base XML metadata for a system.

PermissionsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that permissions from the Business Data Connectivity Model are imported.

PropertiesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that properties from the Business Data Connectivity Model are imported.

SettingId

Optional

System.String

Specifies the custom environment settings model slice to import.

The type must be a valid string that identifies a model slice; for example, ModelSlice1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Import-SPBusinessDataCatalogModel cmdlet imports a Business Data Connectivity Model. There are two types of Business Data Connectivity models: Model type (.bdcm) and Resource type (.bdcr). The Model type contains the base XML metadata, and can also include resource properties. The Resource type includes only resource properties.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$MetadataStore = Get-SPBusinessDataCatalogMetadataObject -BdcObjectType "Catalog" -ServiceConext http://contoso
Copy code
Import-SPBusinessDataCatalogModel -Path "C:\folder\model.bdcm" -Identity $MetadataStore

This example gets the Business Data Connectivity Metadata Store and then imports a Business Data Connectivity Model of Model type to it from the path specified with the name model.

------------------EXAMPLE 2------------------

Copy code
Import-SPBusinessDataCatalogModel -Path "C:\Program Files\Duet Enterprise\2.0\BDC Models\Reporting.en-us.bdcr -Identity $bdcCatalog -ModelsIncluded:$false

This example imports a resource only file by using the ModelsIncluded parameter.

See also

Export-SPBusinessDataCatalogModel
Remove-SPBusinessDataCatalogModel


New-SPBusinessDataCatalogServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Business Data Connectivity service application in the farm.

New-SPBusinessDataCatalogServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-Name <String>] [-PartitionMode <SwitchParameter>] [-Sharing <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the IIS application pool to use for the new Business Data Connectivity service application.

DatabaseName

Required

System.String

Specifies the name for the Business Data Connectivity database.

DatabaseServer

Required

System.String

Specifies the name of the host server for the database specified in DatabaseName.

The type must be a valid SQL Server host name; for example, SERVER\Database.

Name

Required

System.String

Specifies a display name for the new Business Data Connectivity service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL Server Authentication.

The type must be a valid PSCredential object.

DatabasePassword

Optional

System.Security.SecureString

Specifies the password for the user specified in DatabaseUserName. Use this parameter only if SQL Server Authentication is used to access the Business Data Connectivity database.

The type must be a valid password.

DatabaseUsername

Optional

System.String

Specifies the user name to use for connecting to the database. Use this parameter only if SQL Server Authentication is used to access the Business Data Connectivity database.

FailoverDatabaseServer

Optional

System.String

Specifies the name of the host server for the failover database server.

PartitionMode

Required

System.Management.Automation.SwitchParameter

Specifies that the service application restricts data by subscription ID. This property cannot be changed after the service application is created.

Sharing

Required

System.Management.Automation.SwitchParameter

Specifies that the Business Data Connectivity application is published and shared across the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPBusinessDataCatalogServiceApplication cmdlet creates a new Business Data Connectivity service application in the farm.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
New-SPBusinessDataCatalogServiceApplication -ApplicationPool "SharePoint Web Services Default" -DatabaseName "ContosoBdcDB" -DatabaseServer "CONTOSO\SharePoint" -Name "ContosoServiceApp"

This example creates a Business Data Connectivity service application named ContosoServiceApp. In this process it uses the SharePoint Web Services Default application pool and creates a database named ContosoBdcDB.

See also

Set-SPBusinessDataCatalogServiceApplication
New-SPBusinessDataCatalogServiceApplicationProxy


New-SPBusinessDataCatalogServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Business Data Connectivity service application proxy in the farm.

New-SPBusinessDataCatalogServiceApplicationProxy -Uri <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-Name <String>] [-PartitionMode <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
New-SPBusinessDataCatalogServiceApplicationProxy -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Name

Required

System.String

Specifies a display name for the new Business Data Connectivity service application proxy.

Uri

Required

System.Uri

Specifies the URI of a remote service application to which to connect.

The type must be a valid URI, in the form file:\\server_name\sitedocs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Required

System.Management.Automation.SwitchParameter

Specifies that the service application proxy is added to the default proxy group for the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Name

Required

System.String

Specifies a display name for the new Business Data Connectivity service application proxy.

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the Business Data Connectivity service application associated with the new proxy.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Required

System.Management.Automation.SwitchParameter

Specifies that the service application proxy is added to the default proxy group for the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPBusinessDataCatalogServiceApplicationProxy cmdlet creates a new Business Data Connectivity service application proxy for a Business Data Connectivity service application in the farm.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
New-SPBusinessDataCatalogServiceApplicationProxy -Name "ContosoServiceAppProxy" -ServiceApplication $serviceApplication

This example creates a new Business Data Connectivity service application proxy with the name ContosoServiceAppProxy for the given service application.

See also

New-SPBusinessDataCatalogServiceApplication
Set-SPBusinessDataCatalogServiceApplication


Remove-SPBusinessDataCatalogModel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes a Business Data Connectivity Model.

Remove-SPBusinessDataCatalogModel -Identity <MetadataObject> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.MetadataObject

Specifies the Business Data Connectivity Metadata Store metadata object to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPBusinessDataCatalogModel cmdlet deletes a Business Data Connectivity Model.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$modelFile = Get-SPBusinessDataCatalogMetadataObject -Name "ContosoModel" -BdcObjectType Model -ServiceContext http://contoso
Copy code
Remove-SPBusinessDataCatalogModel -Identity $modelFile

This example removes the Business Data Connectivity Model file named ContosoModel.

See also

Import-SPBusinessDataCatalogModel
Export-SPBusinessDataCatalogModel


Revoke-SPBusinessDataCatalogMetadataObject
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Revokes a right to a principal in the specified Business Data Connectivity Metadata Store metadata object.

Revoke-SPBusinessDataCatalogMetadataObject -Identity <MetadataObject> -Principal <SPClaim> -Right <Execute | Edit | SetPermissions | SelectableInClients> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SettingId <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.MetadataObject

Specifies the Business Data Connectivity Metadata Store metadata object that contains the principal.

Principal

Required

System.String

Specifies the principal to whom the rights apply.

The type must be a claim.

Right

Required

Microsoft.SharePoint.BusinessData.SharedService.SPGrantSPBusinessDataCatalogMetadataObjectCmdlet+PSBdcRight

Specifies the right to revoke the principal.

The type must be one of the following valid PSBdcRight object types: All, Execute, Edit, SetPermissions, or SelectableInClients.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SettingId

Optional

System.String

Specifies the custom environment settings model slice for which to revoke the right.

The type must be a valid string that identifies a model slice; for example, ModelSlice1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Revoke-SPBusinessDataCatalogMetadataObject cmdlet revokes a right granted to a principal user in the specified Business Data Connectivity Metadata Store metadata object.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$claimJohn = New-SPClaimsPrincipal -Identity "CONTOSO\johndoe" -IdentityType WindowsSamAccountName
Copy code
$MetadataObject = Get-SPBusinessDataCatalogMetadataObject -BdcObjectType "LobSystem" -ServiceContext http://contoso -Name "ContosoDatabase"
Copy code
Revoke-SPBusinessDataCatalogMetadataObject -Identity $MetadataObject -Principal $claimJohn -Right "Execute"

This example removes the execute right from the External System with the name ContosoDatabase for the user with the identity of johndoe on the domain CONTOSO.

See also

Set-SPBusinessDataCatalogMetadataObject
Get-SPBusinessDataCatalogMetadataObject
Grant-SPBusinessDataCatalogMetadataObject


Set-SPBusinessDataCatalogMetadataObject
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the value of a property or attribute of a Business Data Connectivity Metadata Store metadata object.

Set-SPBusinessDataCatalogMetadataObject -Identity <MetadataObject> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-PropertyName <String>] [-PropertyValue <PSObject>] [-Remove <SwitchParameter>] [-SettingId <String>] [-WhatIf [<SwitchParameter>]]

Set-SPBusinessDataCatalogMetadataObject -Identity <MetadataObject> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DisplayName <String>] [-Remove <SwitchParameter>] [-SettingId <String>] [-WhatIf [<SwitchParameter>]]

Set-SPBusinessDataCatalogMetadataObject -Identity <MetadataObject> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-PropertyName <String>] [-Remove <SwitchParameter>] [-Remove <SwitchParameter>] [-SettingId <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.MetadataObject

Specifies the Business Data Connectivity Metadata Store metadata object to update.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PropertyName

Optional

System.String

Specifies the name of the property to update.

PropertyValue

Optional

System.Management.Automation.PSObject

Sets the new value of the property specified in the PropertyName parameter.

Remove

Optional

System.Management.Automation.SwitchParameter

Removes the property specified in the PropertyName parameter.

SettingId

Optional

System.String

Specifies the custom environment settings model slice for which the property applies.

The type must be a valid string that identifies a model slice; for example, ModelSlice1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.MetadataObject

Specifies the Business Data Connectivity Metadata Store metadata object to update.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DisplayName

Optional

System.String

Specifies the display name of the Business Data Connectivity Metadata Store metadata object.

Remove

Optional

System.Management.Automation.SwitchParameter

Removes the property specified in the PropertyName parameter.

SettingId

Optional

System.String

Specifies the custom environment settings model slice for which the property applies.

The type must be a valid string that identifies a model slice; for example, ModelSlice1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.BusinessData.Administration.MetadataObject

Specifies the Business Data Connectivity Metadata Store metadata object to update.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PropertyName

Optional

System.String

Specifies the name of the property to update.

Remove

Optional

System.Management.Automation.SwitchParameter

Removes the property specified in the PropertyName parameter.

SettingId

Optional

System.String

Specifies the custom environment settings model slice for which the property applies.

The type must be a valid string that identifies a model slice; for example, ModelSlice1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPBusinessDataCatalogMetadataObject cmdlet sets the value of a property or attribute of a Business Data Connectivity Metadata Store metadata object.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$objectToSetOn = Get-SPBusinessDataCatalogMetadataObject -Namespace "ContosoDatabase" -Name "ContosoDatabase" -BdcObjectType "LobSystemInstance" -ServiceContext http://contoso
Copy code
Set-SPBusinessDataCatalogMetadataObject -Identity $objectToSetOn -PropertyName "ShowInSearchUI" -PropertyValue "True"

This example creates a property on the LobSystemInstance (External System Instance) of name ContosoDatabase. The property has the name ShowInSearchUI and a value of True.

See also

Get-SPBusinessDataCatalogMetadataObject
Revoke-SPBusinessDataCatalogMetadataObject
Grant-SPBusinessDataCatalogMetadataObject


Set-SPBusinessDataCatalogServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets global properties for a Business Data Connectivity service application in the farm.

Set-SPBusinessDataCatalogServiceApplication -Identity <SPServiceApplicationPipeBind> [-ApplicationPool <SPIisWebServiceApplicationPool>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-Name <String>] [-Sharing <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ApplicationPool

Optional

Microsoft.SharePoint.Administration.SPIisWebServiceApplicationPool

Specifies the IIS application pool to use for the new Business Data Connectivity service application.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL Server Authentication.

The type must be a valid PSCredential object.

DatabaseName

Optional

System.String

Specifies the name of the Business Data Connectivity database.

The type must be a valid name of a SQL Server database; for example, UsageLogDB1.

DatabasePassword

Optional

System.Security.SecureString

Specifies the password for the user specified in DatabaseUserName. Use this parameter only if SQL Server Authentication is used to access the Business Data Connectivity database.

The type must be a valid password.

DatabaseServer

Optional

System.String

Specifies the name of the Business Data Connectivity database.

The type must be a valid name of a SQL Server database; for example, UsageLogDB1.

DatabaseUsername

Optional

System.String

Specifies the user name to use for connecting to the catalog database. Use this parameter only if SQL Server Authentication is used to access the Business Data Connectivity database.

The type must be a valid user name; for example, UserName1.

FailoverDatabaseServer

Optional

System.String

Specifies the name of the host server for the failover database server.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

Identity

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the Business Data Connectivity service application associated with the new proxy.

Name

Optional

System.String

Specifies a display name for the new Business Data Connectivity service application proxy.

Sharing

Optional

System.Management.Automation.SwitchParameter

Specifies that the Business Data Connectivity service application is published and shared across the farm.

AssignmentColletion

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPBusinessDataCatalogServiceApplication cmdlet sets global properties for a Business Data Connectivity service application in the farm.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
Set-SPBusinessDataCatalogServiceApplication -Identity $serviceApplication -FailoverDatabaseServer "CONTOSO\Backup"

This example sets the failover database server to CONTOSO\Backup for the given service application.

See also

New-SPBusinessDataCatalogServiceApplication
New-SPBusinessDataCatalogServiceApplicationProxy


Import-SPSiteSubscriptionBusinessDataCatalogConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Imports data associated with an exported file that contains all data associated with the Business Data Connectivity Metadata Store for a given partition.

Import-SPSiteSubscriptionBusinessDataCatalogConfig -Path <String> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-LocalizedNamesIncluded <SwitchParameter>] [-ModelsIncluded <SwitchParameter>] [-PermissionsIncluded <SwitchParameter>] [-PropertiesIncluded <SwitchParameter>] [-ProxiesIncluded <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Path

Required

System.String

Specifies the path and name to use to create the export file.The type must be a valid path in either of the following forms:

C:\folder_name

\\server_name\folder_name

..\folder_name\file.xml

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context of the data to be exported.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a service context (for example, http://ServiceContext1); or an instance of a valid SPServiceContext object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

LocalizedNamesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that names for business data fields in multiple languages be imported.

ModelsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that Business Data Connectivity models be included in the imported file.

PermissionsIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that permissions from the Business Data Connectivity model be exported.

PropertiesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that properties from the Business Data Connectivity model be imported.

ProxiesIncluded

Optional

System.Management.Automation.SwitchParameter

Specifies that proxies for Business Data Connectivity Service Applications be exported.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Import-SPSiteSubscriptionBusinessDataCatalogConfig cmdlet to import a data file that contains Business Data Connecitivity models and all data associated with the Business Data Connectivity Metadata Store for a given partition.

Input Types

Return Types

Example

---------------------EXAMPLE---------------------------

Copy code
Import-SPSiteSubscriptionBusinessDataCatalogConfig -Path "C:\folder\importFile.xml" -ServiceContext http://contoso

This example imports the data file named importFile.xml.

See also

Clear-SPSiteSubscriptionBusinessDataCatalogConfig
Export-SPSiteSubscriptionBusinessDataCatalogConfig
Remove-SPSiteSubscriptionBusinessDataCatalogConfig


Remove-SPSiteSubscriptionBusinessDataCatalogConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes the Business Data Connectivity Metadata Store for a partition.

Remove-SPSiteSubscriptionBusinessDataCatalogConfig -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context of the Business Data Connectivity Metadata Store to remove.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a service context (for example, http://ServiceContext1); or an instance of a valid SPServiceContext object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPSiteSubscriptionBusinessDataCatalogConfig cmdlet removes the Business Data Connectivity Metadata Store and all associated data for a specified partition. To completely remove a partition and the data that it contains, run the Clear-SPSiteSubscriptionBusinessDataCatalogConfig cmdlet to remove the data from the Business Data Connectivity Metadata Store, and then run the Remove-SPSiteSubscriptionBusinessDataCatalogConfig cmdlet.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Remove-SPSiteSubscriptionBusinessDataCatalogConfig -ServiceContext http://contoso

This example removes the Business Data Connectivity Metadata Store for the partition http://contoso.

See also

Export-SPSiteSubscriptionBusinessDataCatalogConfig
Import-SPSiteSubscriptionBusinessDataCatalogConfig


Clear-SPBusinessDataCatalogEntityNotificationWeb
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Clears the entity notification site.

Clear-SPBusinessDataCatalogEntityNotificationWeb -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the dervice context for which the entity notification web has to be cleared.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Clear-SPBusinessDataCatalogEntityNotificationWeb cmdlet to clear the entity notification site for the given service context.

Input Types

Return Types

Example

-----------EXAMPLE-----------

Copy code
Clear- SPBusinessDataCatalogEntityNotificationWeb -ServiceContext "http://contoso"

This example clears the entity notification site for the service context corresponding to the site http://contoso.

See also

Get-SPBusinessDataCatalogEntityNotificationWeb
Set-SPBusinessDataCatalogEntityNotificationWeb


Get-SPBusinessDataCatalogEntityNotificationWeb
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the entity notification site.

Get-SPBusinessDataCatalogEntityNotificationWeb -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for which the entity notification web has to be returned.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPBusinessDataCatalogEntityNotificationWeb cmdlet to return the entity notification site that can receive and forward external system notifications.

Input Types

Return Types

Example

-------EXAMPLE-----------

Copy code
Get-SPBusinessDataCatalogEntityNotificationWeb -ServiceContext "http://contoso"

This example returns the entity notification site for the site collection at http://contoso.

See also

Clear-SPBusinessDataCatalogEntityNotificationWeb
Set-SPBusinessDataCatalogEntityNotificationWeb


Get-SPODataConnectionSetting
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns Business Connectivity Services OData connection properties.

Get-SPODataConnectionSetting -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Name <String>]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context which is in the form of an instance of an SPServiceContext object, an SPSiteAdministration object identifier, or a SPSite object. An example of a service context value is an identifier from the ID field, a string identifier, a URI, or a string representation of a GUID.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Name

Optional

System.String

Specifies the name of the Business Connectivity Services connection object.

Detailed Description

Use the Get-SPODataConnectionSetting cmdlet to display Business Connectivity Services OData connection properties for a specified Business Connectivity Services connection.

If the name of the connection is not specified by using the Name parameter, this cmdlet will return the list of the connections for the specified BDC service context.

Note:

This cmdlet applies to an on-premises environment only. You cannot use this command in the SharePoint Online Management Shell.

Input Types

Return Types

Example

----------------EXAMPLE 1------------

Copy code
Get-SPODataConnectionSetting -ServiceContext  "http://contoso" -Name "ContosoServiceApp"

This example returns properties of the BCS connection named ContosoServiceApp

----------------EXAMPLE 2------------

Copy code
Get-SPODataConnectionSetting -ServiceContext "http://contoso"

This example returns a list of BCS connections for the service context named http://contoso

See also

New-SPODataConnectionSetting
Remove-SPODataConnectionSetting
Set-SPODataConnectionSetting


Get-SPODataConnectionSettingMetaData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a Business Data Connectivity service metadata object.

Get-SPODataConnectionSettingMetadata -Name <String> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context which is in the form of an instance of an SPServiceContext object, an SPSiteAdministration object identifier, or a SPSite object. An example of a service context value is an identifier from the ID field, a string identifier, a URI, or a string representation of a GUID.

Name

Required

System.String

Specifies the name of the Business Connectivity Services connection whose metadata properties the user wants to see displayed.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPODataConnectionSettingMetaData cmdlet to return a Business Data Connectivity service metadata object for a specific Business Connectivity Services service application.

Note:

This cmdlet applies to an on-premises environment only. You cannot use this command in the SharePoint Online Management Shell.

Input Types

Return Types

Example

-------------EXAMPLE------------

Copy code
Get-SPODataConnectionSettingMetadata -ServiceContext "http://contoso" -Name "ContosoServiceApp"

This example displays metadata properties of BCS connection named ContosoServiceApp

See also

Set-SPODataConnectionSettingMetaData


Remove-SPODataConnectionSetting
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a Business Connectivity Services connection.

Remove-SPODataConnectionSetting -Name <String> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Remove-SPODataConnectionSetting [-Identity] <ODataConnectionSettings> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context which is in the form of an instance of an SPServiceContext object, an SPSiteAdministration object identifier, or a SPSite object. An example of a service context value is an identifier from the ID field, a string identifier, a URI, or a string representation of a GUID.

Name

Required

System.String

Specifies the name of the existing Business Connectivity Services connection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.BusinessData.SystemSpecific.OData.ODataConnectionSettings

Specifies the OData Connection Settings object.

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context which is in the form of an instance of an SPServiceContext object, an SPSiteAdministration object identifier, or a SPSite object. An example of a service context value is an identifier from the ID field, a string identifier, a URI, or a string representation of a GUID.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Remove-SPODataConnectionSetting cmdlet to remove a Business Connectivity Services connection for a particular Business Connectivity Services service application in the farm.

The metadata object associated with the Business Connectivity Services connection is also deleted.

Note:

This cmdlet applies to an on-premises environment only. You cannot use this command in the SharePoint Online Management Shell.

Input Types

Return Types

Example

----------------EXAMPLE 1------------

Copy code
Remove-SPODataConnectionSetting -ServiceContext "http://contoso" -Name "ContosoServiceApp"

This example removes the Business Connectivity Services connection named ContosoServiceApp. Metadata properties are also removed.

----------------EXAMPLE 2------------

Copy code
Remove-SPODataConnectionSetting -ServiceContext "http://contoso" -Name "ContosoServiceApp-metadata"

This example removes the Business Connectivity Services connection metadata named ContosoServiceApp.

The associated Business Connectivity Services connection object is also removed.

----------------EXAMPLE 3------------

Copy code
$ConnectionVariable = Get-SPODataConnectionSettingMetadata -ServiceContext http://contoso -Name "ContosoServiceApp"
Copy code
Remove-SPODataConnectionSetting -Identity $ConnectionVariable -ServiceContext "http://contoso"

This example removes the Business Connectivity Services and its associated metadata connection named ContosoServiceApp.

See also

Get-SPODataConnectionSetting
New-SPODataConnectionSetting
Set-SPODataConnectionSetting


New-SPODataConnectionSetting
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Business Data Connectivity service connection.

New-SPODataConnectionSetting -AuthenticationMode <PassThrough | RevertToSelf | Credentials | WindowsCredentials | DigestCredentials | ClientCertificate | Anonymous> -Name <String> -ServiceAddressURL <Uri> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-ExtensionProvider <String>] [-SecureStoreTargetApplicationId <String>]

Parameters

Parameter Required Type Description

AuthenticationMode

Required

Microsoft.SharePoint.BusinessData.SystemSpecific.OData.ODataAuthenticationMode

Specifies the type of authentication mode required for the Business Connectivity Services connection.

The value for the authentication mode is any one of the following options:

--PassThrough

--RevertToSelf

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

--Anonymous

ServiceAddressURL

Required

System.Uri

Specifies the URL for the OData service. The URL does not have be Internet facing. This is the final destination from which data is retrieved.

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context which is in the form of an instance of an SPServiceContext object, an SPSiteAdministration object identifier, or a SPSite object. An example of a service context value is an identifier from the ID field, a string identifier, a URI, or a string representation of a GUID.

Name

Required

System.String

Specifies the name of the Business Connectivity Services connection object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ExtensionProvider

Optional

System.String

Extends the functionality provided by the OData connector in Business Connectivity Service as well as provides the fully qualified assembly name of an OData extension provider. Fully qualified assembly name should contain following parameters in this order:

Namespace.Class, Assembly Name, Version, Culture and Public Key. E.g. "Contoso.ExtensionProvider.Server, Contoso.ExtensionPRovider, Version=1.0.0.0, Culture=neutral, PublicKeyToken=31ba4812ca364d35". To clear the value of ExtensionProvider, provide an empty string, for example, "".

SecureStoreTargetApplicationId

Optional

System.String

Specifies the Secure Store Target Application ID. Works in conjunction with the AuthenticationMode parameter.

The value for the SecureStoreTargetApplicationId parameter is any one of the following options:

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

Detailed Description

Use the New-SPODataConnectionSetting cmdlet to create a new Business Data Connectivity service connection and its associated metadata properties in the farm. To see the metadata settings, use the Get-SPODataConnectionSettingMetaData cmdlet.

Note:

This cmdlet applies to an on-premises environment only. You cannot use this command in the SharePoint Online Management Shell.

Input Types

Return Types

Example

--------------EXAMPLE--------------

Copy code
New-SPODataConnectionSetting -Name "ContosoServiceApp" -ServiceContext "http://contoso" -ServiceAddressURL "https://expensereporting.cloudapp.net/expensereporting.svc" -AuthenticationMode "Credentials" -SecureStoreTargetApplicationId "DallasUserName" -ExtensionProvider "Contoso.ExtensionProvider.Server, Contoso.ExtensionPRovider, Version=1.0.0.0, Culture=neutral, PublicKeyToken=31ba4812ca364d35"

This example creates a new Business Data Connectivity service connection named ContosoServiceApp.

In this process, a Microsoft Business Connectivity Services connection metadata object is created.

See also

Get-SPODataConnectionSetting
Remove-SPODataConnectionSetting
Set-SPODataConnectionSetting


New-SPBECWebServiceApplicationProxy
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Warning:

Do not use this cmdlet.

New-SPBECWebServiceApplicationProxy -Name <String> -ServiceEndpointUri <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter | Required | Type | Description

Detailed Description

Warning:

Do not use this cmdlet.

Input Types

Return Types

Example

Copy code


Set-SPBusinessDataCatalogEntityNotificationWeb
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the entity notification site.

Set-SPBusinessDataCatalogEntityNotificationWeb -Web <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Web

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the site to be set as the entity notification site for its own service context.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPBusinessDataCatalogEntityNotificationWeb cmdlet to sets the entity notification site for the specified service context by using the Web parameter.

Input Types

Return Types

Example

----------EXAMPLE--------

Copy code
Set- SPBusinessDataCatalogEntityNotificationWeb -Web "http://contoso"

This example sets http://contoso as the entity notification site for the service context of the site at http://contoso.

See also

Clear-SPBusinessDataCatalogEntityNotificationWeb
Get-SPBusinessDataCatalogEntityNotificationWeb


Set-SPODataConnectionSetting
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets or updates global properties for a Microsoft Business Connectivity Services connection.

Set-SPODataConnectionSetting -Name <String> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AuthenticationMode <Nullable>] [-Confirm [<SwitchParameter>]] [-ExtensionProvider <String>] [-SecureStoreTargetApplicationId <String>] [-ServiceAddressURL <Uri>] [-WhatIf [<SwitchParameter>]]
Set-SPODataConnectionSetting [-Identity] <ODataConnectionSettings> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AuthenticationMode <Nullable>] [-Confirm [<SwitchParameter>]] [-ExtensionProvider <String>] [-SecureStoreTargetApplicationId <String>] [-ServiceAddressURL <Uri>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context which is in the form of an instance of an SPServiceContext object, an SPSiteAdministration object identifier, or a SPSite object: An example of a service context value is an identifier from the ID field, a string identifier, a URI, or a string representation of a GUID.

Name

Required

System.String

Specifies the name of the existing Business Connectivity Services connection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuthenticationMode

Optional

System.Nullable

Specifies the type of authentication mode that is required for the Business Connectivity Services connection.

The value for the authentication mode is any one of the following options:

--PassThrough

--RevertToSelf

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

--Anonymous

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ExtensionProvider

Optional

System.String

Extends the functionality provided by the OData connector in Business Connectivity Service as well as provides the fully qualified assembly name of an OData extension provider. Fully qualified assembly name should contain following parameters in this order:

Namespace.Class, Assembly Name, Version, Culture and Public Key. E.g. "Contoso.ExtensionProvider.Server, Contoso.ExtensionPRovider, Version=1.0.0.0, Culture=neutral, PublicKeyToken=31ba4812ca364d35". To clear the value of ExtensionProvider, provide an empty string for example, "".

SecureStoreTargetApplicationId

Optional

System.String

Specifies the Secure Store Target Application ID. Works in conjunction with the AuthenticationMode parameter.

The value for the SecureStoreTargetApplicationId parameter is any one of the following options:

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

ServiceAddressURL

Optional

System.Uri

Specifies the URL for the OData service. The URL does not have to be Internet facing. This is the final destination from which data is retrieved.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.BusinessData.SystemSpecific.OData.ODataConnectionSettings

Specifies the OData Connection Settings object.

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context which is in the form of an instance of an SPServiceContext object, an SPSiteAdministration object identifier, or a SPSite object: An example of a service context value is an identifier from the ID field, a string identifier, a URI, or a string representation of a GUID.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuthenticationMode

Optional

System.Nullable

Specifies the type of authentication mode that is required for the Business Connectivity Services connection.

The value for the authentication mode is any one of the following options:

--PassThrough

--RevertToSelf

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

--Anonymous

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ExtensionProvider

Optional

System.String

Extends the functionality provided by the OData connector in Business Connectivity Service as well as provides the fully qualified assembly name of an OData extension provider. Fully qualified assembly name should contain following parameters in this order:

Namespace.Class, Assembly Name, Version, Culture and Public Key. E.g. "Contoso.ExtensionProvider.Server, Contoso.ExtensionPRovider, Version=1.0.0.0, Culture=neutral, PublicKeyToken=31ba4812ca364d35". To clear the value of ExtensionProvider, provide an empty string for example, "".

SecureStoreTargetApplicationId

Optional

System.String

Specifies the Secure Store Target Application ID. Works in conjunction with the AuthenticationMode parameter.

The value for the SecureStoreTargetApplicationId parameter is any one of the following options:

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

ServiceAddressURL

Optional

System.Uri

Specifies the URL for the OData service. The URL does not have to be Internet facing. This is the final destination from which data is retrieved.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPODataConnectionSetting cmdlet to update the properties of an existing connection for a specific Business Connectivity Services service application.

Note:

This cmdlet applies to an on-premises environment only. You cannot use this command in the SharePoint Online Management Shell.

Input Types

Return Types

Example

-------------EXAMPLE 1-----------

Copy code
Set-SPODataConnectionSetting -Name "ContosoServiceApp" -ServiceContext "http://contoso" -AuthenticationMode "PassThrough" -ExtensionProvider "Contoso.ExtensionProvider.Server, Contoso.ExtensionProvider, Version=1.0.0.0, Culture=neutral, PublicKeyToken=31ba4812ca364d35"

This example updates the properties of Business Connectivity Services connection named ContosoServiceApp.

-------------EXAMPLE 2-----------

Copy code
$ConnectionVariable = Get-SPODataConnectionSetting -ServiceContext http://contoso -Name "ContosoServiceApp"
Copy code
Set-SPODataConnectionSetting -Identity $ConnectionVariable -AuthenticationMode "PassThrough"

This example updates the properties of the Business Connectivity Services service connection named ContosoServiceApp.

-------------EXAMPLE 3-----------

Copy code
Set-SPODataConnectionSetting -Name "ContosoServiceApp" -ServiceContext "http://contoso" -AuthenticationMode "PassThrough" -ExtensionProvider ""

This example updates the properties of Business Connectivity Services connection named ContosoServiceApp, the authentication mode has been changed, and extension provider value has been cleared.

See also

Get-SPODataConnectionSetting
New-SPODataConnectionSetting
Remove-SPODataConnectionSetting


Set-SPODataConnectionSettingMetaData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Updates properties for the metadata of a Business Connectivity Services connection.

Set-SPODataConnectionSettingMetadata -Name <String> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AuthenticationMode <Nullable>] [-Confirm [<SwitchParameter>]] [-SecureStoreTargetApplicationId <String>] [-ServiceAddressMetadataURL <Uri>] [-WhatIf [<SwitchParameter>]]
Set-SPODataConnectionSettingMetadata [-Identity] <ODataConnectionSettings> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AuthenticationMode <Nullable>] [-Confirm [<SwitchParameter>]] [-SecureStoreTargetApplicationId <String>] [-ServiceAddressMetadataURL <Uri>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context which is in the form of an instance of an SPServiceContext object, an SPSiteAdministration object identifier, or an SPSite object. An example of a service context value is an identifier from the ID field, a string identifier, a URI, or a string representation of a GUID.

Name

Required

System.String

Specifies the name of the existing Business Connectivity Services connection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuthenticationMode

Optional

System.Nullable

Specifies the type of authentication mode that the Business Connectivity Services connection requires.

The value for the authentication mode is any one of the following options:

--PassThrough

--RevertToSelf

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

--Anonymous

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SecureStoreTargetApplicationId

Optional

System.String

Specifies the Secure Store Target Application ID. Works in conjunction with the AuthenticationMode parameter.

The value for the SecureStoreTargetApplicationId parameter is any one of the following options:

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

ServiceAddressMetadataURL

Optional

System.Uri

Specifies the metadata URL for the OData service. This URL does not have to be Internet facing. If a value is not specified for a connection, a default value is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.BusinessData.SystemSpecific.OData.ODataConnectionSettings

Specifies the OData Connection Settings object.

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context which is in the form of an instance of an SPServiceContext object, an SPSiteAdministration object identifier, or an SPSite object. An example of a service context value is an identifier from the ID field, a string identifier, a URI, or a string representation of a GUID.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuthenticationMode

Optional

System.Nullable

Specifies the type of authentication mode that the Business Connectivity Services connection requires.

The value for the authentication mode is any one of the following options:

--PassThrough

--RevertToSelf

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

--Anonymous

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SecureStoreTargetApplicationId

Optional

System.String

Specifies the Secure Store Target Application ID. Works in conjunction with the AuthenticationMode parameter.

The value for the SecureStoreTargetApplicationId parameter is any one of the following options:

--Credentials

--WindowsCredentials

--DigestCredentials

--ClientCertificate

ServiceAddressMetadataURL

Optional

System.Uri

Specifies the metadata URL for the OData service. This URL does not have to be Internet facing. If a value is not specified for a connection, a default value is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPODataConnectionSettingMetaData cmdlet to update properties for a Business Connectivity Services connection for a Business Connectivity Services service application in the farm.

Note:

This cmdlet applies to an on-premises environment only. You cannot use this command in the SharePoint Online Management Shell.

Input Types

Return Types

Example

--------------EXAMPLE 1-------------

Copy code
Set-SPODataConnectionSettingMetadata -Name "ContosoServiceApp" -ServiceContext "http://contoso" -AuthenticationMode "PassThrough"

This example updates the authentication mode of the metadata of Business Connectivity Services connection named ContosoServiceApp.

--------------EXAMPLE 2-------------

Copy code
$ConnectionVariable = Get-SPODataConnectionSettingMetadata -ServiceContext  http://contoso -Name "ContosoServiceApp"
Copy code
Set-SPODataConnectionSettingMetadata -Identity $ConnectionVariable -AuthenticationMode "PassThrough"

This example updates the Metadata properties of the Business Connectivity Services connection named ContosoServiceApp.

See also

Get-SPODataConnectionSettingMetaData


Database cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that enable you to manage databases in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use Windows PowerShell cmdlets to manage databases in a SharePoint 2013 farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Connect-SPConfigurationDatabase | Connects the local server computer to a farm.
Disconnect-SPConfigurationDatabase | Disconnects the local server computer from the farm.
Move-SPBlobStorageLocation | Copies a content database by using Remote BLOB Storage (RBS).
New-SPConfigurationDatabase | Creates a new configuration database.
Remove-SPConfigurationDatabase | Permanently removes a configuration database.
Dismount-SPContentDatabase | Detaches a content database from the web application it is currently associated with.
Get-SPContentDatabase | Returns one or more content databases.
Mount-SPContentDatabase | Attaches an existing content database to the farm.
New-SPContentDatabase | Creates a new content database and attaches it to the specified web application.
Remove-SPContentDatabase | Deletes a content database.
Set-SPContentDatabase | Sets global properties of a SharePoint content database.
Test-SPContentDatabase | Tests a content database.
Get-SPDatabase | Retrieves all properties of a database.
Split-SPScaleOutDatabase | Moves a specified percentage of partitions from one scale-out database to another.
Set-SPScaleOutDatabaseDataRange | Extends the range of a specified scale-out database.
Set-SPScaleOutDatabaseDataSubRange | Creates a subrange for a specified scale-out database.
Remove-SPScaleOutDatabase | Removes a specific scale-out database.
Import-SPScaleOutDatabaseTenantData | Imports data from the specified subscription id.
Get-SPScaleOutDatabaseLogEntry | Queries a scale-out database for scale-out logs.
Get-SPScaleOutDatabaseInconsistency | Displays all inconsistencies related to scale-out databases' ranges.
Get-SPScaleOutDatabaseDataState | Returns the state information about the specified scale-out database.
Get-SPScaleOutDatabase | Returns all scale-out database objects.
Export-SPScaleOutDatabaseTenantData | Exports the data of the specified subscription.
Clear-SPScaleOutDatabaseTenantData | Removes all data related to the specified site subscription.
Clear-SPScaleOutDatabaseLog | Clears all scale-out logs.
Clear-SPScaleOutDatabaseDeletedDataSubRange | Clears all partitions inside the specified deleted subrange.
Add-SPScaleOutDatabase | Adds an existing scale-out database to the specified service application.
Add-SPServerScaleOutDatabase | Adds an existing scale-out database to the specified service application.
Clear-SPServerScaleOutDatabaseDeletedDataSubRange | Clears all partitions inside the specified deleted subrange.
Clear-SPServerScaleOutDatabaseLog | Clears all scale-out logs.
Clear-SPServerScaleOutDatabaseTenantData | Removes all data related to the specified site subscription.
Export-SPServerScaleOutDatabaseTenantData | Exports the data of the specified subscription.
Get-SPServerScaleOutDatabase | Returns all scale-out database objects.
Get-SPServerScaleOutDatabaseDataState | Returns the state information about the specified scale-out database.
Get-SPServerScaleOutDatabaseInconsistency | Displays all inconsistencies related to scale-out databases' ranges.
Get-SPServerScaleOutDatabaseLogEntry | Queries a scale-out database for scale-out logs.
Import-SPServerScaleOutDatabaseTenantData | Imports data from the specified subscription id.
Remove-SPServerScaleOutDatabase | Removes a specific scale-out database.
Set-SPServerScaleOutDatabaseDataRange | Extends the range of a specified scale-out database.
Set-SPServerScaleOutDatabaseDataSubRange | Creates a subrange for a specified scale-out database.
Split-SPServerScaleOutDatabase | Moves a specified percentage of partitions from one scale-out database to another.

See also

Windows PowerShell for SharePoint 2013 reference


Connect-SPConfigurationDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Connects the local server computer to a farm.

Connect-SPConfigurationDatabase [-DatabaseName] <String> [-Passphrase] <SecureString> [[-SkipRegisterAsDistributedCacheHost] <SwitchParameter>] -DatabaseServer <String> [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseCredentials <PSCredential>]

Parameters

Parameter Required Type Description

DatabaseName

Required

System.String

Specifies the name of the configuration database to which to connect the server.

The type must be a valid database name; for example, DB1.

DatabaseServer

Required

A valid database server, such as "DS"

Specifies the server on which to create the configuration database. The default value is the local computer name.

Passphrase

Required

System.Security.SecureString

Specifies the secure password phrase for connecting the current server to the configuration database.

The type must be a valid secure string; for example, MyBDCApp1serverkey.

SkipRegisterAsDistributedCacheHost

Optional

System.Management.Automation.SwitchParameter

By default all the servers in the farm are registered as a cache host (that is, DistributedCacheService is running by default).

Use this parameter to not register the server computer as a distributed cache host. If you want to have a dedicated cache host, then use this parameter to make sure that caching service is not installed on the computer.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL authentication. If this parameter is not specified, the current user is used.

The type must be a valid PSCredential object.

Detailed Description

The Connect-SPConfigurationDatabase cmdlet connects the current server to the specified configuration database.

Essentially, this cmdlet connects the server to the farm. If the current computer cannot be connected to a farm, the following error message is displayed:

"This machine is already connected to a SharePoint farm. See: Dismount-SPConfigurationDatabase"

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Connect-SPConfigurationDatabase -DatabaseServer "ServerName\InstanceName" -DatabaseName "SharePointConfigurationDatabaseName" -Passphrase (ConvertTo-SecureString "MyP@ssw0rd") -AsPlainText -Force
Copy code
Start-Service SPTimerv4

This example joins the local server computer to a farm that is configured to use the database SharePointConfigurationDatabase on an instance of SQL Server by using the name ServerName\InstanceName with the passphrase MyP@ssw0rd.

See also

Backup-SPConfigurationDatabase
Disconnect-SPConfigurationDatabase
Dismount-SPContentDatabase
New-SPConfigurationDatabase
Remove-SPConfigurationDatabase


Disconnect-SPConfigurationDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Disconnects the local server computer from the farm.

Disconnect-SPConfigurationDatabase [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Disconnect-SPConfigurationDatabase cmdlet disconnects the active server computer from the SharePoint configuration database. This operation removes the server computer from the farm. The configuration database must be disconnected before the database can be removed.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
Disconnect-SPConfigurationDatabase -Confirm:$false

This example removes the local server computer from a farm without prompting for user confirmation.

See also

New-SPConfigurationDatabase
Remove-SPConfigurationDatabase
Connect-SPConfigurationDatabase
Backup-SPConfigurationDatabase


Move-SPBlobStorageLocation
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Copies a content database to a new location by using Remote BLOB Storage (RBS).

Move-SPBlobStorageLocation [-SourceDatabase] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DestinationDatabase <String>] [-DestinationDataSourceInstance <String>] [-Dir <String>] [-VerboseMod <$true | $false>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SourceDatabase

Required

System.String

Specifies the name of the Windows Internal Database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DestinationDatabase

Optional

System.String

Specifies the name of the migrated database. If the DestinationDatabase parameter is not specified, the SourceDatabase parameter is used.

DestinationDataSourceInstance

Optional

System.String

Specifies the name of the instance of the destination database. The value in the SourceDatabase parameter is migrated to this instance. The name of the instance of the database should be SQL Server 2008 with Service Pack 1 (SP1) and Cumulative Update 2 version or higher. If the DestinationDataSourceInstance parameter is not specified, the local host name is used.

Dir

Optional

System.String

Used for all disk operations, including storing temporary backups and database (.mdf) files of a migrated database. If the Dir parameter is not specified, a default directory of the destination SQL Server instance is used. The free space in this directory should be at least two times the size of the source database.

VerboseMod

Optional

System.Boolean

Generates verbose log output to be displayed in the Command Prompt window. If the VerboseMod parameter is not specified, no output is displayed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Move-SPBlobStorageLocation cmdlet to use Remote BLOB Storage (RBS) to copy a content database to an instance of a SQL Server database. The database size limitation for SQL Server is 4 gigabytes (GB). If a content database is greater than 4 GB, the database cannot be copied directly to a SQL Server database instance. The Move-SPBlobStorageLocation cmdlet uses the advantage of RBS and copies databases larger than 4 GB. RBS stores the data on the local hard disk and keeps the links to the data in the database, which results in a smaller database.

Input Types

Return Types

Example

-------------------EXAMPLE 1-----------------------

Copy code
Move-SPBlobStorageLocation WSS_Content

This example copies the content database named WSS_Content from the Windows Internal Database to the same database name in SQL Server 2008 Express by using RBS.

-------------------EXAMPLE 2-----------------------

Copy code
Move-SPBlobStorageLocation WSS_Content -DestinationDatabase WSS_V4_Content -BackupDatabase WSSBackupDB -VerboseMod:$true

This example copies the content database named WSS_Content from the Windows Internal Database to a database in SQL Server 2008 Express. The name of the new database will be WSS_V4_Content. During the move, the backup file name will be WSSBackupDB. The output of this command displays log information to the Command Prompt window.


New-SPConfigurationDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new configuration database.

New-SPConfigurationDatabase [-DatabaseName] <String> [-DatabaseServer] <String> [[-DirectoryDomain] <String>] [[-DirectoryOrganizationUnit] <String>] [[-AdministrationContentDatabaseName] <String>] [[-DatabaseCredentials] <PSCredential>] [-FarmCredentials] <PSCredential> [-Passphrase] <SecureString> [[-SkipRegisterAsDistributedCacheHost] <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

DatabaseName

Required

System.String

Specifies the name of the new configuration database.

DatabaseServer

Required

System.String

Specifies the database server on which to create the configuration database. If no value is specified, the default value is used.

DirectoryDomain

Optional

System.String

Specifies the directory domain for the new farm. If no domain is specified, the domain in which the local computer is located is used.

DirectoryOrganizationUnit

Optional

System.String

Specifies the directory organizational unit for the new configuration database. If no organizational unit is specified, the organizational unit in which the local computer is located is used.

AdministrationContentDatabaseName

Required

System.String

Specifies the name for the Central Administration content database for the new farm. If no name is specified, a default name is used.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the Credential object for the database user. Use this parameter if you use SQL Server Authentication. If no database credentials are provided, Windows authentication is used.

FarmCredentials

Required

System.Management.Automation.PSCredential

Specifies credentials for the Farm Administrator account.

Passphrase

Required

System.Security.SecureString

Specifies the secure password phrase for the new farm. This passphrase is used to join other machines to this farm.

SkipRegisterAsDistributedCacheHost

Optional

System.Management.Automation.SwitchParameter

By default all the servers in the farm are registered as a cache host (that is, DistributedCacheService is running by default).

Use this parameter to not register the server computer as a distributed cache host. If you want to have a dedicated cache host, then use this parameter to make sure that caching service is not installed on the computer.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The New-SPConfigurationDatabase cmdlet creates a new configuration database on the specified database server. This is the central database for a new SharePoint farm.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
New-SPConfigurationDatabase -DatabaseName "SharePointConfigDB1" -DatabaseServer "SQL-01" -Passphrase (ConvertTo-SecureString "MyPassword" -AsPlainText -force) -FarmCredentials (Get-Credential)

This example prompts the user to provide user credentials for the default Farm Administrator account.

See also

Backup-SPConfigurationDatabase
Disconnect-SPConfigurationDatabase
Connect-SPConfigurationDatabase
Remove-SPConfigurationDatabase
Dismount-SPContentDatabase


Remove-SPConfigurationDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Permanently removes a configuration database.

Remove-SPConfigurationDatabase [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPConfigurationDatabase cmdlet permanently removes the farm's configuration database. The configuration database must be already dismounted from any associated farm.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Remove-SPConfigurationDatabase

This example permanently deletes a configuration database from a farm.

See also

Backup-SPConfigurationDatabase
Disconnect-SPConfigurationDatabase
Connect-SPConfigurationDatabase
Dismount-SPContentDatabase
New-SPConfigurationDatabase


Dismount-SPContentDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Detaches a content database from its currently associated Web application.

Dismount-SPContentDatabase [-Identity] <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the content database to detach.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint content database (for example, SPContentDB1); or an instance of a valid SPContentDatabase object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Dismount-SPContentDatabase cmdlet to detatch the given content database from its currently associated Web application. This cmdlet will not delete the content database. Use the Remove-SPContentDatabase cmdlet to delete a content database.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

--------------EXAMPLE 1------------

Copy code
Dismount-SPContentDatabase 12345678-90ab-cdef-1234-567890abcdef

This example detaches the content database with the GUID 12345678-90ab-cdef-1234-567890abcdef from its current parent Web application.

--------------EXAMPLE 2------------

Copy code
Get-SPContentDatabase -WebApplication http://sitename | Dismount-SPContentDatabase -WhatIf

This example detaches all content databases from the Web application on port 80 of the local machine. Remove the WhatIf parameter to perform the operation.

See also

Get-SPContentDatabase
Set-SPContentDatabase
New-SPContentDatabase
Remove-SPContentDatabase
Mount-SPContentDatabase
Test-SPContentDatabase


Get-SPContentDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns one or more content databases.

Get-SPContentDatabase [[-Identity] <SPContentDatabasePipeBind>] [-AssignmentCollection <SPAssignmentCollection>]
Get-SPContentDatabase -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPContentDatabase -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPContentDatabase -ConnectAsUnattachedDatabase <SwitchParameter> -DatabaseName <String> -DatabaseServer <String> [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseCredentials <PSCredential>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies a specific content database to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint content database (for example, SPContentDB1); or an instance of a valid SPContentDatabase object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Returns the content databases for the specified Web application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

3

Parameter

Required

Type

Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Returns the content database for the specified site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

4

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ConnectAsUnattachedDatabase

Optional

System.Management.Automation.SwitchParameter

Specifies that only unattached databases in the farm are returned.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPContentDatabase cmdlet returns the specified content databases.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

----------------EXAMPLE 1------------

Copy code
Get-SPContentDatabase -webapplication http://sitename

This example returns all content databases used by the sitename Web application.

----------------EXAMPLE 2------------

Copy code
Get-SPContentDatabase -site http://contoso.com

This example returns the content database that contains the site collection at http://contoso.com.

See also

Set-SPContentDatabase
New-SPContentDatabase
Remove-SPContentDatabase
Mount-SPContentDatabase
Test-SPContentDatabase
Upgrade-SPContentDatabase


Mount-SPContentDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Attaches an existing content database to the farm.

Mount-SPContentDatabase [-Name] <String> [-WebApplication] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AssignNewDatabaseId <SwitchParameter>] [-ChangeSyncKnowledge <SwitchParameter>] [-ClearChangeLog <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseServer <String>] [-MaxSiteCount <Int32>] [-NoB2BSiteUpgrade <SwitchParameter>] [-SkipIntegrityChecks <SwitchParameter>] [-WarningSiteCount <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the existing content database to attach to the farm.

The type must be a valid name of a SharePoint content database; for example, SPContentDB1.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Attaches the content database to the specified SharePoint web application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AssignNewDatabaseId

Optional

System.Management.Automation.SwitchParameter

Creates a new database ID automatically when the content database is attached.

ChangeSyncKnowledge

Optional

System.Management.Automation.SwitchParameter

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ClearChangeLog

Optional

System.Management.Automation.SwitchParameter

Clears any pending changes from the change log in the content database.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL Authentication.

The type must be a valid PSCredential object.

DatabaseServer

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the name of the host server for the content database specified in the Name parameter.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

MaxSiteCount

Optional

System.Int32

Specifies the maximum number of web sites that can use the content database.

The type must be a positive integer.

NoB2BSiteUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies not to upgrade all child objects when performing a build-to-build upgrade. This parameter has no effect when a version-to-version upgrade is specified.

SkipIntegrityChecks

Optional

System.Management.Automation.SwitchParameter

WarningSiteCount

Optional

System.Int32

Specifies the number of sites that can be created before a warning event is generated and the owner of the site collection is notified.

The type must be a positive integer.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Mount-SPContentDatabase cmdlet attaches an existing content database to the farm. If the database being mounted requires an upgrade, this cmdlet will cause the database to be upgraded.

The default behavior of this cmdlet causes an upgrade of the schema of the database and initiates upgraded builds for all site collections within the specified content database if required. To prevent initiation of upgraded builds of site collections, use the NoB2BSiteUpgrade parameter. This cmdlet does not trigger version-to-version upgrade of any site collections.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

-----------------EXAMPLE 1---------------------

Copy code
Mount-SPContentDatabase "MyDatabase" -DatabaseServer "MyServer" -WebApplication http://sitename

This example mounts an existing database to the sitename web application. If upgrades are required, it triggers database schema upgrade and then performs only build-to-build upgrade actions on existing site collections if required. This operation does not changed the CompatibilityLevel for existing site collections in this database.

-----------------EXAMPLE 2---------------------

Copy code
Mount-SPContentDatabase "MyDatabase" -DatabaseServer "MyServer" -WebApplication http://sitename -NoB2BSiteUpgrade

This example mounts an existing database to the sitename web application but it prevents any site upgrades from occurring. If upgrades are required, it triggers database schema upgrades only and no build-to-build upgrade actions are performed on any site collections. This operation does not change the CompatibilityLevel for existing site collections in this database.

See also

Get-SPContentDatabase
Set-SPContentDatabase
Remove-SPContentDatabase
Upgrade-SPContentDatabase
Dismount-SPContentDatabase
Get-SPServer


New-SPContentDatabase
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new content database and attaches it to the specified Web application.

New-SPContentDatabase [-Name] <String> [-WebApplication] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AssignNewDatabaseId <SwitchParameter>] [-ChangeSyncKnowledge <SwitchParameter>] [-ClearChangeLog <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseServer <String>] [-MaxSiteCount <Int32>] [-WarningSiteCount <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the new content database to create within the farm.

The type must be a valid name of a SharePoint content database; for example, SPContentDB1.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Attaches the content database to the specified SharePoint Web application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AssignNewDatabaseId

Optional

System.Management.Automation.SwitchParameter

Creates a new database ID automatically when the content database is attached.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ClearChangeLog

Optional

System.Management.Automation.SwitchParameter

Clears any pending changes from the change log in the content database.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL Server Authentication.

The type must be a valid PSCredential object.

DatabaseServer

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the name of the host server for the content database specified in the Name parameter.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

MaxSiteCount

Optional

System.Int32

Specifies the maximum number of Web sites that can use the content database.

The type must be a positive integer.

WarningSiteCount

Optional

System.Int32

Specifies the number of sites that can be created before a warning event is generated and the owner of the site collection is notified.

The type must be a positive integer.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPContentDatabase cmdlet creates a new content database and attaches it to the specified Web application.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

--------------EXAMPLE--------------------

Copy code
New-SPContentDatabase "MyDatabase" -DatabaseServer "MyServer" -WebApplication http://sitename

This example creates a new content database for the sitename Web application.


Remove-SPContentDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes a content database.

Remove-SPContentDatabase [-Identity] <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the content database to delete.

The type must be a valid GUID, such as 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint content database (for example, SPContentDB1); or an instance of a valid SPContentDatabase object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPContentDatabase cmdlet deletes a content database permanently from SQL Server 2008 R2 with Service Pack 1 (SP1) or SQL Server 2012. In situations where data needs to be persisted, use the Dismount-SPContentDatabase cmdlet. This will remove the content database from SharePoint 2010 Products but not from SQL Server 2008 R2 with SP1 or SQL Server 2012.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

-----------------EXAMPLE---------------------

Copy code
Get-SPContentDatabase 12345678-90ab-cdef-1234-567890abcdef | Remove-SPContentDatabase

This example deletes the specified content database.

See also

Get-SPContentDatabase
New-SPContentDatabase
Set-SPContentDatabase
Upgrade-SPContentDatabase
Test-SPContentDatabase


Set-SPContentDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets global properties of a SharePoint content database.

Set-SPContentDatabase [-Identity] <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MaxSiteCount <Int32>] [-Status <Online | Disabled | Offline | Unprovisioning | Provisioning | Upgrading>] [-WarningSiteCount <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the content database to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint content database (for example, SPContentDB1); or an instance of a valid SPContentDatabase object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MaxSiteCount

Optional

System.Int32

Specifies the maximum number of site collections that this database can host.

The type must be a positive integer. Set to $null to clear this value.

Status

Optional

Microsoft.SharePoint.Administration.SPObjectStatus

Specifies the status of the SQL Server database. Set this parameter to Ready to make the database available to host new sites. Set this parameter to Offline to make the database unavailable to host new sites.

The type must be either of the following: Ready or Offline

WarningSiteCount

Optional

System.Int32

Specifies the number of site collections that can be created before a warning event is generated and the owner of the site collection is notified.

The type must be a positive integer. Set to $null to clear this value.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPContentDatabase cmdlet sets global properties of a SharePoint content database.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

---------------EXAMPLE 1---------------

Copy code
Get-SPContentDatabase http://contoso.com | Set-SPContentDatabase -MaxSiteCount 1

This example sets the MaxSiteCount for the content database that contains contoso.com to 1.

---------------EXAMPLE 2---------------

Copy code
Get-SPContentDatabase -WebApplication http://sitename | Set-SPContentDatabase -WarningSiteCount $null

This example clears the WarningSiteCount for all databases in the sitename Web application.

See also

Get-SPContentDatabase
New-SPContentDatabase
Remove-SPContentDatabase
Upgrade-SPContentDatabase
Dismount-SPContentDatabase
Test-SPContentDatabase


Test-SPContentDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Tests a content database.

Test-SPContentDatabase [-Identity] <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseCredentials <PSCredential>] [-ExtendedCheck <SwitchParameter>] [-ServerInstance <SPDatabaseServiceInstancePipeBind>] [-ShowLocation <SwitchParameter>] [-ShowRowCounts <SwitchParameter>]
Test-SPContentDatabase -Name <String> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseCredentials <PSCredential>] [-ExtendedCheck <SwitchParameter>] [-ServerInstance <SPDatabaseServiceInstancePipeBind>] [-ShowLocation <SwitchParameter>] [-ShowRowCounts <SwitchParameter>]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies an existing connected SharePoint 2013 content database to one of the two parameter sets in the form of a GUID or database name if it is unique.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL Server Authentication.

The type must be a valid PSCredential object.

ExtendedCheck

Optional

System.Management.Automation.SwitchParameter

Checks for inconsistent authentication modes during database-attach upgrade process.

The selected mode, claims or classic, must be the same in both versions.

ServerInstance

Optional

Microsoft.SharePoint.PowerShell.SPDatabaseServiceInstancePipeBind

Specifies the instance of the database service to use to test the specified content database.

The type must be a valid GUID, such as 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SQL Server instance (for example, DBSvrInstance1); or an instance of a valid SPDatabaseServiceInstance object.

ShowLocation

Optional

System.Management.Automation.SwitchParameter

Specifies the locations where missing templates and features are being used within the database. Typically, reported locations are scoped within the site collections that are within the specified content database.

Note:

The use of the parameter significantly increases the time to complete the test procedure.

ShowRowCounts

Optional

System.Management.Automation.SwitchParameter

Returns database statistics which are row counts for tables in the content database.

2

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the existing content database to test.

The type must be a valid name of a SharePoint content database; for example, SPContentDB1.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the SharePoint Web application to use to test the content database.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL Server Authentication.

The type must be a valid PSCredential object.

ExtendedCheck

Optional

System.Management.Automation.SwitchParameter

Checks for inconsistent authentication modes during database-attach upgrade process.

The selected mode, claims or classic, must be the same in both versions.

ServerInstance

Optional

Microsoft.SharePoint.PowerShell.SPDatabaseServiceInstancePipeBind

Specifies the instance of the database service to use to test the specified content database.

The type must be a valid GUID, such as 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SQL Server instance (for example, DBSvrInstance1); or an instance of a valid SPDatabaseServiceInstance object.

ShowLocation

Optional

System.Management.Automation.SwitchParameter

Specifies the locations where missing templates and features are being used within the database. Typically, reported locations are scoped within the site collections that are within the specified content database.

Note:

The use of the parameter significantly increases the time to complete the test procedure.

ShowRowCounts

Optional

System.Management.Automation.SwitchParameter

Returns database statistics which are row counts for tables in the content database.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Test-SPContentDatabase cmdlet to test a content database against a Web application to verify all customizations referenced within the content database are also installed in the web application. This cmdlet can be issued against a content database currently attached to the farm, or a content database that is not connected to the farm. It can be used to test content databases from SharePoint 2010 Products and from SharePoint Products and Technologies.

Note:

The Test-SPContentDatabase cmdlet does not change any of the data or structure of the content database, but can cause load on the database while the checks are in progress, which could temporarily block use of the content database. This cmdlet should only be used against a content database that is currently under low or no usage.

Input Types

Return Types

Example

----------------------------EXAMPLE 1-----------------------

Copy code
Test-SPContentDatabase -name WSS_Content_DB -webapplication http://sitename

This example tests the WSS_Content_DB content database against the sitename Web application, and returns a list of issues.

----------------------------EXAMPLE 2-----------------------

Copy code
$DB = Get-SPContentDatabase -site http://contoso.com
Copy code
Test-SPContentDatabase $DB -showrowcounts

This example gets the content database that contains the site collection at http://contoso.com, and then tests the database against the Web application that hosts it to determine issues. Together with displaying the list of issues, by specifying the ShowRowCounts parameter, this also returns the table size metrics from the content database.

See also

Get-SPContentDatabase
New-SPContentDatabase
Set-SPContentDatabase
Remove-SPContentDatabase
Mount-SPContentDatabase
Upgrade-SPContentDatabase


Get-SPDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Retrieves all properties of a database.

Get-SPDatabase [[-Identity] <SPDatabasePipeBind>] [-AssignmentCollection <SPAssignmentCollection>]
Get-SPDatabase -ServerInstance <SPDatabaseServiceInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the name of the database to display public properties.

The type must be a valid GUID, in the form 1234-3456-567kg.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

ServerInstance

Required

Microsoft.SharePoint.PowerShell.SPDatabaseServiceInstancePipeBind

Specifies the name of the SQL instance that contains the database in either the form "Server" for a default SQL instance or "Server\Instance" for a named SQL instance.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPDatabase cmdlet displays all public properties of a database to the current window. If the Identity parameter is specified, only properties of that ID are displayed.

Input Types

Return Types

Example

--------------------EXAMPLE---------------------

Copy code
Get-SPDatabase -ServerInstance "ServerA\SharePoint"

This example gets all databases on a specific named SQL Server Express instance.

See also

Get-SPContentDatabase
New-SPContentDatabase
Set-SPContentDatabase


Split-SPScaleOutDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Moves a specified percentage of partitions from one scale-out database to another.

Split-SPScaleOutDatabase -NewDatabaseName <String> -SourceDatabase <SPDatabasePipeBind> -SourceServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MoveLowerHalf <SwitchParameter>] [-NewDatabaseCredentials <PSCredential>] [-NewDatabaseFailoverServer <String>] [-NewDatabaseServer <String>] [-SourcePercentage <Int32>] [-WhatIf [<SwitchParameter>]]
Split-SPScaleOutDatabase -SourceDatabase <SPDatabasePipeBind> -SourceServiceApplication <SPServiceApplicationPipeBind> -TargetDatabase <SPDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MoveLowerHalf <SwitchParameter>] [-SourcePercentage <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

NewDatabaseName

Required

System.String

Specifies the name of a new scale-out database that you are creating.

SourceDatabase

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

The source scale-out database to move data from.

SourceServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

The service application in which the data move operation will take place.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MoveLowerHalf

Optional

System.Management.Automation.SwitchParameter

Specifies whether to move the lower or the upper side of the data range from the source scale-out database. If this parameter is not specified, the default behavior is to move the upper side of the source scale-out database data range.

NewDatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the credentials to use when creating the scale-out database. These credentials will have owner rights on the newly created scale-out database. If a value is not provided, the current user's credentials will be used by default.

NewDatabaseFailoverServer

Optional

System.String

Specifies the failover server name of the new scale-out database to be created. If a value is not provided, the new scale-out database does not have a failover server.

NewDatabaseServer

Optional

System.String

Specifies the name of the server of the new scale-out database to be created. If a value is not provided, the default database server is used.

SourcePercentage

Optional

System.Int32

Specifies the percentage of data in the source scale-out database to move. If a value is not provided, the default value of 50 percent is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

SourceDatabase

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

The source scale-out database to move data from.

SourceServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

The service application in which the data move operation will take place.

TargetDatabase

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

The target scale-out database to move data to.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MoveLowerHalf

Optional

System.Management.Automation.SwitchParameter

Specifies whether to move the lower or the upper side of the data range from the source scale-out database. If this parameter is not specified, the default behavior is to move the upper side of the source scale-out database data range.

SourcePercentage

Optional

System.Int32

Specifies the percentage of data in the source scale-out database to move. If a value is not provided, the default value of 50 percent is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Split-SPScaleOutDatabase cmdlet to move a specified percentage of partitions from a source database to an existing target database or to a new database that you create with the specified parameters.

Input Types

Return Types

Example

---------------EXAMPLE---------------

Copy code
$databases = Get-SPScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
database = $databases[0]
Copy code
Split-SPScaleOutDatabase -NewDatabaseName Database2 -NewDatabaseServer MyDatabaseServer -SourceDatabase $database -SourceServiceApplication $serviceApplication -SourcePercentage 30

This example creates a new scale-out database named Database2 on the MyDatabaseServer database server in the given service application. The example also moves 30 percent of the data from the upper side of the data range in the first scale-out database of the given service application.

See also

Add-SPScaleOutDatabase
Get-SPScaleOutDatabase
Remove-SPScaleOutDatabase


Set-SPScaleOutDatabaseDataRange
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Extends the range of a specified scale-out database.

Set-SPScaleOutDatabaseDataRange -Database <SPDatabasePipeBind> -IsUpperSubRange <$true | $false> -Range <SPScaleOutDataRange> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-NewRangePoint <Byte[]>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database to which to extend the data range.

IsUpperSubRange

Required

System.Boolean

Specifies whether to set the start or the end point of the data range with the specified value in the NewRangePoint parameter.

Range

Required

Microsoft.SharePoint.SPScaleOutDataRange

Specifies the expected data range of the scale-out database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

NewRangePoint

Optional

System.Byte[]

Specifies the new start or end point of the database.

The maximum value is NULL.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPScaleOutDatabaseDataRange cmdlet to extend the range of a specified scale-out database towards a specified direction.

Input Types

Return Types

Example

--------------EXAMPLE------------

Copy code
$databases = Get-SPScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
$state = Get-SPScaleOutDatabaseDataState -Database $database
Copy code
Set-SPScaleOutDatabaseDataRange -Database $database -Range $state.Range -NewRangePoint $null -IsUpperSubRange $true

This example extends the data range end point of the first database in the specified service application up to the maximum range point.

See also

Set-SPScaleOutDatabaseDataSubRange
Get-SPScaleOutDatabase
Get-SPScaleOutDatabaseDataState


Set-SPScaleOutDatabaseDataSubRange
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a subrange for a specified scale-out database.

Set-SPScaleOutDatabaseDataSubRange -Database <SPDatabasePipeBind> -IsUpperSubRange <$true | $false> -Range <SPScaleOutDataRange> -SubRangeMode <ReadWrite | ReadOnly | Changing | Deleted> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-IgnoreSubRangePointOnBoundary <SwitchParameter>] [-SubRangePoint <Byte[]>] [-WhatIf [<SwitchParameter>]]
Set-SPScaleOutDatabaseDataSubRange -ConnectionString <String> -IsUpperSubRange <$true | $false> -Range <SPScaleOutDataRange> -SubRangeMode <ReadWrite | ReadOnly | Changing | Deleted> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-IgnoreSubRangePointOnBoundary <SwitchParameter>] [-IsAzureDatabase <SwitchParameter>] [-SubRangePoint <Byte[]>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database to create the data subrange.

IsUpperSubRange

Required

System.Boolean

Specifies whether to create the data subrange on the upper or lower side of the data range.

Range

Required

Microsoft.SharePoint.SPScaleOutDataRange

Specifies the expected current range of the scale-out database prior to this operation.

SubRangeMode

Required

Microsoft.SharePoint.SPScaleOutDatabaseSubRangeMode

Specifies the mode of the data subrange to be created. The data subrange mode values are the following:

--NULL- The data subrange on the specified side (lower or upper) of the data range will be removed.

--ReadOnly - The partitions which are inside the new data subrange can be read, but cannot be modified.

--Changing -The partitions which are inside the new data subrange cannot be read or modified

--Deleted- The partitions which are inside the new data subrange cannot be read or modified

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IgnoreSubRangePointOnBoundary

Optional

System.Management.Automation.SwitchParameter

Specifies whether to complete without any errors if the new subrange's start and end points are the same. If this parameter is specified, no errors are displayed.

SubRangePoint

Optional

System.Byte[]

Specifies the start or end point of the data subrange to be created as defined by the following criteria:

--The start point if the data sub-range is created on the upper side of the data range.

--The end point if the data sub-range is created on the lower side of the data range.

The maximum value is NULL.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ConnectionString

Required

System.String

Specifies the connection string for the scale-out database to create the new data sub-range.

IsUpperSubRange

Required

System.Boolean

Specifies whether to create the data subrange on the upper or lower side of the data range.

Range

Required

Microsoft.SharePoint.SPScaleOutDataRange

Specifies the expected current range of the scale-out database prior to this operation.

SubRangeMode

Required

Microsoft.SharePoint.SPScaleOutDatabaseSubRangeMode

Specifies the mode of the data subrange to be created. The data subrange mode values are the following:

--NULL- The data subrange on the specified side (lower or upper) of the data range will be removed.

--ReadOnly - The partitions which are inside the new data subrange can be read, but cannot be modified.

--Changing -The partitions which are inside the new data subrange cannot be read or modified

--Deleted- The partitions which are inside the new data subrange cannot be read or modified

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IgnoreSubRangePointOnBoundary

Optional

System.Management.Automation.SwitchParameter

Specifies whether to complete without any errors if the new subrange's start and end points are the same. If this parameter is specified, no errors are displayed.

IsAzureDatabase

Optional

System.Management.Automation.SwitchParameter

Specifies whether the database is hosted on SQL Azure.

SubRangePoint

Optional

System.Byte[]

Specifies the start or end point of the data subrange to be created as defined by the following criteria:

--The start point if the data sub-range is created on the upper side of the data range.

--The end point if the data sub-range is created on the lower side of the data range.

The maximum value is NULL.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPScaleOutDatabaseDataSubRange cmdlet to create a subrange with the specified parameters for a specified scale-out database or a database which will be connected with a specified connection string. A subrange is a subset of a range of data.

Input Types

Return Types

Example

--------------EXAMPLE-------------

Copy code
$databases = Get-SPScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
$state = Get-SPScaleOutDatabaseDataState -Database $database
Copy code
Set-SPScaleOutDatabaseDataSubRange -Database $database -Range $state.Range -SubRangePoint $state.Range.RangeEnd -SubRangeMode ReadOnly -IsUpperSubRange $false

This example creates a read-only subrange that starts from the data range start point and ends at the data range end point on the first scale-out database of the specified service application.

See also

Clear-SPScaleOutDatabaseDeletedDataSubRange


Remove-SPScaleOutDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a specific scale-out database.

Remove-SPScaleOutDatabase -Database <SPDatabasePipeBind> -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DeleteData <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database to remove.

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application of the scale-out database to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DeleteData

Optional

System.Management.Automation.SwitchParameter

Specifies whether to delete data when the scale out database is removed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPScaleOutDatabase cmdlet to remove a specific scale-out database from a specified service application.

Input Types

Return Types

Example

--------------EXAMPLE-------------

Copy code
$databases = Get-SPScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
Remove-SPScaleOutDatabase -ServiceApplication $serviceApplication -Database $database

This example removes the specified scale-out database from the specified service application.

See also

Add-SPScaleOutDatabase
Get-SPScaleOutDatabase


Import-SPScaleOutDatabaseTenantData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Imports data from the specified subscription id.

Import-SPScaleOutDatabaseTenantData -FilePath <String> -ServiceApplication <SPServiceApplicationPipeBind> -SiteSubscriptionId <Guid> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

FilePath

Required

System.String

Specifies the absolute path to the data file.

An absolute path includes the root directory and all sub-directories.

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application to import the data to.

SiteSubscriptionId

Required

System.Guid

Specifies the site subscription id to import the data from. This value will replace the site subscription id value from the data file.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Import-SPScaleOutDatabaseTenantData cmdlet to import data from the specified file for the specified subscription id to the specified service application.

Input Types

Return Types

Example

-------------EXAMPLE----------

Copy code
Import-SPScaleOutDatabaseTenantData -FilePath "C:\ TenantData.dat" -ServiceApplication $serviceApplication -SiteSubscriptionId "5CAF2F99-A75F-4239-B9CD-7FE63D1CE904"

This example imports data from the file at C:\ TenantData.dat, to the specified service application and marks all the imported data with the site subscription id 5CAF2F99-A75F-4239-B9CD-7FE63D1CE904

See also

Clear-SPScaleOutDatabaseTenantData
Export-SPScaleOutDatabaseTenantData


Get-SPScaleOutDatabaseLogEntry
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Queries a scale-out database for scale-out logs.

Get-SPScaleOutDatabaseLogEntry -Count <Int32> -Database <SPDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-CorrelationId <Nullable>] [-MajorAction <Nullable>] [-RangeLimitPoint <Byte[]>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Count

Required

System.Int32

Specifies the number of scale-out log entries to return.

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database from which to return the scale-out logs

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CorrelationId

Optional

System.Nullable

Specifies the correlation id of the scale-out logs to be returned. Correlation id of the log entries that belong to the same major action are the same.

MajorAction

Optional

System.Nullable

Specifies the major action of the scale-out log entries to be returned. The values are the following:

DataMove -A data migration operation between two scale-out databases.

Recovery -Any data recovery operation that is performed to recover from a failure.

RangeLimitPoint

Optional

System.Byte[]

Specifies the range limit point of the scale-out log entries to be returned.

The range limit point has different meaning depending on the action that records the log entry.

  • If the action is to create, change or delete a data subrange, the range limit point represents the following:

  • If the action targets a lower data subrange, the range limit point represents the start point of that lower data subrange.

  • If the action targets an upper data subrange, the range limit point represents the end point of that upper data subrange.

  • If the action is to extend a data range, the range limit point represents the following:

  • If the action extends the start point of the data range, range limit point represents the new start point of the data range.

  • If the action extends the end point of the data range, range limit point represents the new end point of the data range.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPScaleOutDatabaseLogEntry cmdlet to query a scale-out database for scale-out logs that include specified criteria.

Input Types

Return Types

Example

-------------EXAMPLE-----------

Copy code
$databases = Get-SPScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
Get-SPScaleOutDatabaseLogEntry -Database  $database -Count 10 -MajorAction DataMove

This example gets the 10 most recent scale-out log entries from the first scale-out database of the given service application.


Get-SPScaleOutDatabaseInconsistency
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Displays all inconsistencies related to scale-out databases' ranges.

Get-SPScaleOutDatabaseInconsistency -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application for which to return the scale-out inconsistencies.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPScaleOutDatabaseInconsistency cmdlet to return all inconsistencies related to scale out databases' ranges and subranges for a specified service application.

Input Types

Return Types

Example

-------------EXAMPLE--------------

Copy code
$serviceApplication = Get-SPServiceApplication -Name "AppManagement"
Copy code
Get-SPScaleOutDatabaseInconsistency -ServiceApplication $serviceApplication

This example gets all the scale-out inconsistencies for the given service application.


Get-SPScaleOutDatabaseDataState
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the state information about the specified scale-out database.

Get-SPScaleOutDatabaseDataState -Database <SPDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Get-SPScaleOutDatabaseDataState -ConnectionString <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-IsAzureDatabase <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database to return the state information about.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ConnectionString

Required

System.String

Specifies the connection string for the scale-out database from which to return the state information.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IsAzureDatabase

Optional

System.Management.Automation.SwitchParameter

Specifies whether the state information of the scale-out database is in the form of a Microsoft SQL Azure Database.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Get-SPScaleOutDatabaseDataState cmdlet to return state information about the specified scale-out database or about the database which will be connected with the specified connection string. The database state information includes total count of partitions, total weight of the partitions, the range and the subranges of the database.

Input Types

Return Types

Example

----------------EXAMPLE--------------

Copy code
$databases = Get-SPScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
Get-SPScaleOutDatabaseDataState -Database $database

This example gets the data state of the scale-out database for the first scale-out database of the given service application.


Get-SPScaleOutDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all scale-out database objects.

Get-SPScaleOutDatabase -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application of the scale-out databases.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPScaleOutDatabase cmdlet to returns all scale-out database objects for the specified service application.

A scale-out database is a database which implements the Shared Service Database Scale Out Generic Protocol. For additional information about the Database Scale Out Generic Protocol, see SharePoint Shared Service Database Scale Out Generic Protocol Specification

Input Types

Return Types

Example

----------EXAMPLE--------------

Copy code
$serviceApplication = Get-SPServiceApplication -Name "AppManagement"
Copy code
Get-SPScaleOutDatabase -ServiceApplication $serviceApplication

This example gets all scale-out databases for the given service application by using the $serviceApplication variable.

See also

Add-SPScaleOutDatabase
Remove-SPScaleOutDatabase
Split-SPScaleOutDatabase


Export-SPScaleOutDatabaseTenantData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Exports the data of the specified subscription.

Export-SPScaleOutDatabaseTenantData -FilePath <String> -ServiceApplication <SPServiceApplicationPipeBind> -SiteSubscriptionId <Guid> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

FilePath

Required

System.String

Specifies the output path for the file to export the data to.

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application to export the data from.

SiteSubscriptionId

Required

System.Guid

Specifies the site subscription id of the site subscription to export the data from.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Overwrites an existing data file without prompting for confirmation.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Export-SPScaleOutDatabaseTenantData cmdlet to export the data of the specified subscription id to the specified file from the specified service application.

Input Types

Return Types

Example

----------EXAMPLE-------

Copy code
Export-SPScaleOutDatabaseTenantData -FilePath "C:\ TenantData.dat" -ServiceApplication $serviceApplication -SiteSubscriptionId "5CAF2F99-A75F-4239-B9CD-7FE63D1CE904"

This example exports data for the site subscription with id 5CAF2F99-A75F-4239-B9CD-7FE63D1CE904 to the file at C:\ TenantData.dat, from the specified service application.

See also

Clear-SPScaleOutDatabaseTenantData
Import-SPScaleOutDatabaseTenantData


Clear-SPScaleOutDatabaseTenantData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes all data related to the specified site subscription.

Clear-SPScaleOutDatabaseTenantData -ServiceApplication <SPServiceApplicationPipeBind> -SiteSubscriptionId <Guid> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application in which to clear data.

SiteSubscriptionId

Required

System.Guid

Specifies the site subscription id of the site subscription in which to clear data.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Clear-SPScaleOutDatabaseTenantData cmdlet removes all data related to the specified site subscription from the specified service application.

Input Types

Return Types

Example

------------EXAMPLE---------

Copy code
Clear-SPScaleOutDatabaseTenantData -ServiceApplication $serviceApplication -SiteSubscriptionId "5CAF2F99-A75F-4239-B9CD-7FE63D1CE904"

This example clears all data related to the site subscription with id 5CAF2F99-A75F-4239-B9CD-7FE63D1CE904 from the specified service application.

See also

Export-SPScaleOutDatabaseTenantData
Import-SPScaleOutDatabaseTenantData


Clear-SPScaleOutDatabaseLog
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Clears all scale-out logs.

Clear-SPScaleOutDatabaseLog -Database <SPDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-LogEntryTimeout <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database from which to clear the logs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

LogEntryTimeout

Optional

System.Int32

Specifies the time-out value in minutes for the log entries. If there is at least one log entry which is more recent than this value, no log entries will be deleted.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Clear-SPScaleOutDatabaseLog cmdlet clears all scale-out logs in the specified scale-out database unless there is a scale-out log entry newer than the specified time-out value.

Input Types

Return Types

Example

-----------EXAMPLE-------

Copy code
$databases = Get-SPScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
Clear-SPScaleOutDatabaseLog -Database $database -LogEntryTimeout 30

This example removes all scale-out log entries in the first scale-out database of the specified service application unless there is a scale-out log entry which is more recent than 30 minutes.


Clear-SPScaleOutDatabaseDeletedDataSubRange
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Clears all partitions inside the specified deleted subrange.

Clear-SPScaleOutDatabaseDeletedDataSubRange -Database <SPDatabasePipeBind> -IsUpperSubRange <$true | $false> -Range <SPScaleOutDataRange> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database to clear the deleted subrange from.

IsUpperSubRange

Required

System.Boolean

Specifies whether the subrange with deleted mode is on the upper or lower side of the data range.

Range

Required

Microsoft.SharePoint.SPScaleOutDataRange

Specifies the expected data range of the scale-out database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Clear-SPScaleOutDatabaseDeletedDataSubRange cmdlet to clear all partitions inside the specified deleted subrange that are contained within a specified scale-out database.

Input Types

Return Types

Example

--------------EXAMPLE--------------

Copy code
$databases = Get-SPScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
$state = Get-SPScaleOutDatabaseDataState -Database $database
Copy code
Set-SPScaleOutDatabaseDataSubRange -Database $database -Range $state.Range -SubRangePoint $state.Range.RangeEnd -SubRangeMode Deleted -IsUpperSubRange $false
Copy code
$state = Get-SPScaleOutDatabaseDataState -Database $database
Copy code
Clear-SPScaleOutDatabaseDeletedDataSubRange -Database $database -Range $state.Range -IsUpperSubRange $false

This example creates a deleted subrange that starts from the data range start point and ends at the data range end point on the first scale-out database of the specified service application. The example then clears that subrange and all data in the partitions in the subrange.

See also

Set-SPScaleOutDatabaseDataSubRange


Add-SPScaleOutDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds an existing scale-out database to the specified service application.

Add-SPScaleOutDatabase -DatabaseName <String> -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseFailoverServer <String>] [-DatabaseServer <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

DatabaseName

Required

System.String

Specifies the name of the database to add to the specified service application.

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application of the scale-out databases.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the owner's credentials of the scale-out database to be added to the service application.

DatabaseFailoverServer

Optional

System.String

The name of the failover server for the scale-out database to be added.

DatabaseServer

Optional

System.String

The name of the server hosting the scale-out database to be added. If a value is not provided, the default database server will be used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Add-SPScaleOutDatabase cmdlet to add an existing scale-out database to the specified service application by using the ServiceApplication parameter or creates a new scale-out database and adds it to the specified service application.

Input Types

Return Types

Example

-------------EXAMPLE------------

Copy code
$serviceApplication = Get-SPServiceApplication -Name "AppManagement"
Copy code
Add-SPScaleOutDatabase -ServiceApplication $serviceApplication

This example adds a new or existing scale out database into a specific service application.

See also

Get-SPScaleOutDatabase
Remove-SPScaleOutDatabase
Split-SPScaleOutDatabase


Add-SPServerScaleOutDatabase
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Adds an existing scale-out database to the specified service application.

Add-SPServerScaleOutDatabase -DatabaseName <String> -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseFailoverServer <String>] [-DatabaseServer <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

DatabaseName

Required

System.String

Specifies the name of the database to add to the specified service application.

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application of the scale-out databases.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the owner's credentials of the scale-out database to be added to the service application.

DatabaseFailoverServer

Optional

System.String

The name of the failover server for the scale-out database to be added.

DatabaseServer

Optional

System.String

The name of the server hosting the scale-out database to be added. If a value is not provided, the default database server will be used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Add-SPServerScaleOutDatabase cmdlet to add an existing scale-out database to the specified service application by using the ServiceApplication parameter or creates a new scale-out database and adds it to the specified service application.

Input Types

Return Types

Example

-------------EXAMPLE------------

Copy code
$serviceApplication = Get-SPServiceApplication -Name "AppManagement"
Copy code
Add-SPServerScaleOutDatabase -ServiceApplication $serviceApplication

This example adds a new or existing scale out database into a specific service application.

See also

Get-SPServerScaleOutDatabase
Remove-SPServerScaleOutDatabase
Split-SPServerScaleOutDatabase


Clear-SPServerScaleOutDatabaseDeletedDataSubRange
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Clears all partitions inside the specified deleted subrange.

Clear-SPServerScaleOutDatabaseDeletedDataSubRange -Database <SPDatabasePipeBind> -IsUpperSubRange <$true | $false> -Range <SPScaleOutDataRange> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database to clear the deleted subrange from.

IsUpperSubRange

Required

System.Boolean

Specifies whether the subrange with deleted mode is on the upper or lower side of the data range.

Range

Required

Microsoft.SharePoint.SPScaleOutDataRange

Specifies the expected data range of the scale-out database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Clear-SPServerScaleOutDatabaseDeletedDataSubRange cmdlet to clear all partitions inside the specified deleted subrange that are contained within a specified scale-out database.

Input Types

Return Types

Example

--------------EXAMPLE--------------

Copy code
$databases = Get-SPServerScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
$state = Get-SPServerScaleOutDatabaseDataState -Database $database
Copy code
Set-SPServerScaleOutDatabaseDataSubRange -Database $database -Range $state.Range -SubRangePoint $state.Range.RangeEnd -SubRangeMode Deleted -IsUpperSubRange $false
Copy code
$state = Get-SPServerScaleOutDatabaseDataState -Database $database
Copy code
Clear-SPServerScaleOutDatabaseDeletedDataSubRange -Database $database -Range $state.Range -IsUpperSubRange $false

This example creates a deleted subrange that starts from the data range start point and ends at the data range end point on the first scale-out database of the specified service application. The example then clears that subrange and all data in the partitions in the subrange.

See also

Set-SPServerScaleOutDatabaseDataSubRange


Clear-SPServerScaleOutDatabaseLog
Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Clears all scale-out logs.

Clear-SPServerScaleOutDatabaseLog -Database <SPDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-LogEntryTimeout <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database from which to clear the logs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

LogEntryTimeout

Optional

System.Int32

Specifies the time-out value in minutes for the log entries. If there is at least one log entry which is more recent than this value, no log entries will be deleted.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Clear-SPServerScaleOutDatabaseLog cmdlet clears all scale-out logs in the specified scale-out database unless there is a scale-out log entry newer than the specified time-out value.

Input Types

Return Types

Example

-----------EXAMPLE-------

Copy code
$databases = Get-SPServerScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
Clear-SPServerScaleOutDatabaseLog -Database $database -LogEntryTimeout 30

This example removes all scale-out log entries in the first scale-out database of the specified service application unless there is a scale-out log entry which is more recent than 30 minutes.


Clear-SPServerScaleOutDatabaseTenantData
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Removes all data related to the specified site subscription.

Clear-SPServerScaleOutDatabaseTenantData -ServiceApplication <SPServiceApplicationPipeBind> -SiteSubscriptionId <Guid> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application in which to clear data.

SiteSubscriptionId

Required

System.Guid

Specifies the site subscription id of the site subscription in which to clear data.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Clear-SPServerScaleOutDatabaseTenantData cmdlet removes all data related to the specified site subscription from the specified service application.

Input Types

Return Types

Example

------------EXAMPLE---------

Copy code
Clear-SPServerScaleOutDatabaseTenantData -ServiceApplication $serviceApplication -SiteSubscriptionId "5CAF2F99-A75F-4239-B9CD-7FE63D1CE904"

This example clears all data related to the site subscription with id 5CAF2F99-A75F-4239-B9CD-7FE63D1CE904 from the specified service application.

See also

Export-SPServerScaleOutDatabaseTenantData
Import-SPServerScaleOutDatabaseTenantData


Export-SPServerScaleOutDatabaseTenantData
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Exports the data of the specified subscription.

Export-SPServerScaleOutDatabaseTenantData -FilePath <String> -ServiceApplication <SPServiceApplicationPipeBind> -SiteSubscriptionId <Guid> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter | Required | Type | Description

Detailed Description

Use the Export-SPServerScaleOutDatabaseTenantData cmdlet to export the data of the specified subscription id to the specified file from the specified service application.

Input Types

Return Types

Example

----------EXAMPLE-------

Copy code
Export-SPServerScaleOutDatabaseTenantData -FilePath "C:\ TenantData.dat" -ServiceApplication $serviceApplication -SiteSubscriptionId "5CAF2F99-A75F-4239-B9CD-7FE63D1CE904"

This example exports data for the site subscription with id 5CAF2F99-A75F-4239-B9CD-7FE63D1CE904 to the file at C:\ TenantData.dat, from the specified service application.

See also

Clear-SPServerScaleOutDatabaseTenantData
Import-SPServerScaleOutDatabaseTenantData


Get-SPServerScaleOutDatabase
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Returns all scale-out database objects.

Get-SPServerScaleOutDatabase -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application of the scale-out databases.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPServerScaleOutDatabase cmdlet to return all scale-out database objects for the specified service application.

A scale-out database is a database which implements the Shared Service Database Scale Out Generic Protocol. For more information, see SharePoint Shared Service Database Scale Out Generic Protocol Specification

Input Types

Return Types

Example

----------EXAMPLE--------------

Copy code
$serviceApplication = Get-SPServiceApplication -Name "AppManagement"
Copy code
Get-SPServerScaleOutDatabase -ServiceApplication $serviceApplication

This example gets all scale-out databases for the given service application by using the $serviceApplication variable.

See also

Add-SPServerScaleOutDatabase
Remove-SPServerScaleOutDatabase
Split-SPServerScaleOutDatabase


Get-SPServerScaleOutDatabaseDataState
Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Returns the state information about the specified scale-out database.

Get-SPServerScaleOutDatabaseDataState -Database <SPDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Get-SPServerScaleOutDatabaseDataState -ConnectionString <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-IsAzureDatabase <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database for which the command returns state information.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ConnectionString

Required

System.String

Specifies the connection string for the scale-out database from which to return the state information.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IsAzureDatabase

Optional

System.Management.Automation.SwitchParameter

Specifies whether the state information of the scale-out database is in the form of a Microsoft Windows Azure SQL Database.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Get-SPServerScaleOutDatabaseDataState cmdlet to return state information about the specified scale-out database or about the database which will be connected with the specified connection string. The database state information includes total count of partitions, total weight of the partitions, the range and the subranges of the database.

Input Types

Return Types

Example

----------------EXAMPLE--------------

Copy code
$databases = Get-SPServerScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
Get-SPServerScaleOutDatabaseDataState -Database $database

This example gets the data state of the scale-out database for the first scale-out database of the given service application.


Get-SPServerScaleOutDatabaseInconsistency
Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Displays all inconsistencies related to scale-out databases' ranges.

Get-SPServerScaleOutDatabaseInconsistency -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application for which to return the scale-out inconsistencies.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPServerScaleOutDatabaseInconsistency cmdlet to return all inconsistencies related to scale out databases' ranges and subranges for a specified service application.

Input Types

Return Types

Example

-------------EXAMPLE--------------

Copy code
$serviceApplication = Get-SPServiceApplication -Name "AppManagement"
Copy code
Get-SPServerScaleOutDatabaseInconsistency -ServiceApplication $serviceApplication

This example gets all the scale-out inconsistencies for the given service application.


Get-SPServerScaleOutDatabaseLogEntry
Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Queries a scale-out database for scale-out logs.

Get-SPServerScaleOutDatabaseLogEntry -Count <Int32> -Database <SPDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-CorrelationId <Nullable>] [-MajorAction <Nullable>] [-RangeLimitPoint <Byte[]>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Count

Required

System.Int32

Specifies the number of scale-out log entries to return.

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database from which to return the scale-out logs

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CorrelationId

Optional

System.Nullable

Specifies the correlation id of the scale-out logs to be returned. Correlation id of the log entries that belong to the same major action are the same.

MajorAction

Optional

System.Nullable

Specifies the major action of the scale-out log entries to be returned. The values are the following:

DataMove -A data migration operation between two scale-out databases.

Recovery -Any data recovery operation that is performed to recover from a failure.

RangeLimitPoint

Optional

System.Byte[]

Specifies the range limit point of the scale-out log entries to be returned.

The range limit point has different meaning depending on the action that records the log entry.

  • If the action is to create, change or delete a data subrange, the range limit point represents the following:

  • If the action targets a lower data subrange, the range limit point represents the start point of that lower data subrange.

  • If the action targets an upper data subrange, the range limit point represents the end point of that upper data subrange.

  • If the action is to extend a data range, the range limit point represents the following:

  • If the action extends the start point of the data range, range limit point represents the new start point of the data range.

  • If the action extends the end point of the data range, range limit point represents the new end point of the data range.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPServerScaleOutDatabaseLogEntry cmdlet to query a scale-out database for scale-out logs that include specified criteria.

Input Types

Return Types

Example

-------------EXAMPLE-----------

Copy code
$databases = Get-SPServerScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
Get-SPServerScaleOutDatabaseLogEntry -Database $database -Count 10 -MajorAction DataMove

This example gets the 10 most recent scale-out log entries from the first scale-out database of the given service application.


Import-SPServerScaleOutDatabaseTenantData
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Imports data from the specified subscription id.

Import-SPServerScaleOutDatabaseTenantData -FilePath <String> -ServiceApplication <SPServiceApplicationPipeBind> -SiteSubscriptionId <Guid> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

FilePath

Required

System.String

Specifies the absolute path to the data file.

An absolute path includes the root directory and all sub-directories.

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application to import the data to.

SiteSubscriptionId

Required

System.Guid

Specifies the site subscription id to import the data from. This value will replace the site subscription id value from the data file.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Import-SPServerPScaleOutDatabaseTenantData cmdlet to import data from the specified file for the specified subscription id to the specified service application.

Input Types

Return Types

Example

-------------EXAMPLE----------

Copy code
Import-SPServerScaleOutDatabaseTenantData -FilePath "C:\ TenantData.dat" -ServiceApplication $serviceApplication -SiteSubscriptionId "5CAF2F99-A75F-4239-B9CD-7FE63D1CE904"

This example imports data from the file at C:\ TenantData.dat, to the specified service application and marks all the imported data with the site subscription id 5CAF2F99-A75F-4239-B9CD-7FE63D1CE904

See also

Clear-SPServerScaleOutDatabaseTenantData
Export-SPServerScaleOutDatabaseTenantData


Remove-SPServerScaleOutDatabase
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Removes a specific scale-out database.

Remove-SPServerScaleOutDatabase -Database <SPDatabasePipeBind> -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DeleteData <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database to remove.

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application of the scale-out database to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DeleteData

Optional

System.Management.Automation.SwitchParameter

Specifies whether to delete data when the scale out database is removed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPServerScaleOutDatabase cmdlet to remove a specific scale-out database from a specified service application.

Input Types

Return Types

Example

--------------EXAMPLE-------------

Copy code
$databases = Get-SPServerScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
Remove-SPServerScaleOutDatabase -ServiceApplication $serviceApplication -Database $database

This example removes the specified scale-out database from the specified service application.

See also

Add-SPServerScaleOutDatabase
Get-SPServerScaleOutDatabase
Split-SPServerScaleOutDatabase


Set-SPServerScaleOutDatabaseDataRange
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Extends the range of a specified scale-out database.

Set-SPServerScaleOutDatabaseDataRange -Database <SPDatabasePipeBind> -IsUpperSubRange <$true | $false> -Range <SPScaleOutDataRange> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-NewRangePoint <Byte[]>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database to which to extend the data range.

IsUpperSubRange

Required

System.Boolean

Specifies whether to set the start point or the end point of the data range with the specified value in the NewRangePoint parameter.

Range

Required

Microsoft.SharePoint.SPScaleOutDataRange

Specifies the expected data range of the scale-out database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

NewRangePoint

Optional

System.Byte[]

Specifies the new start point or end point of the database.

The maximum value is NULL.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPServerScaleOutDatabaseDataRange cmdlet to extend the range of a specified scale-out database in a specified direction.

Input Types

Return Types

Example

--------------EXAMPLE------------

Copy code
$databases = Get-SPServerScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
$state = Get-SPServerScaleOutDatabaseDataState -Database $database
Copy code
Set-SPServerScaleOutDatabaseDataRange -Database $database -Range $state.Range -NewRangePoint $null -IsUpperSubRange $true

This example extends the data range end point of the first database in the specified service application up to the maximum range point.

See also

Set-SPServerScaleOutDatabaseDataSubRange
Clear-SPServerScaleOutDatabaseDeletedDataSubRange


Set-SPServerScaleOutDatabaseDataSubRange
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Creates a subrange for a specified scale-out database.

Set-SPServerScaleOutDatabaseDataSubRange -Database <SPDatabasePipeBind> -IsUpperSubRange <$true | $false> -Range <SPScaleOutDataRange> -SubRangeMode <ReadWrite | ReadOnly | Changing | Deleted> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-IgnoreSubRangePointOnBoundary <SwitchParameter>] [-SubRangePoint <Byte[]>] [-WhatIf [<SwitchParameter>]]
Set-SPServerScaleOutDatabaseDataSubRange -ConnectionString <String> -IsUpperSubRange <$true | $false> -Range <SPScaleOutDataRange> -SubRangeMode <ReadWrite | ReadOnly | Changing | Deleted> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-IgnoreSubRangePointOnBoundary <SwitchParameter>] [-IsAzureDatabase <SwitchParameter>] [-SubRangePoint <Byte[]>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Database

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the scale-out database to create the data subrange.

IsUpperSubRange

Required

System.Boolean

Specifies whether to create the data subrange on the upper or lower side of the data range.

Range

Required

Microsoft.SharePoint.SPScaleOutDataRange

Specifies the expected current range of the scale-out database prior to this operation.

SubRangeMode

Required

Microsoft.SharePoint.SPScaleOutDatabaseSubRangeMode

Specifies the mode of the data subrange to be created. The data subrange mode values are the following:

--NULL- The data subrange on the specified side (lower or upper) of the data range will be removed.

--ReadOnly - The partitions which are inside the new data subrange can be read, but cannot be modified.

--Changing -The partitions which are inside the new data subrange cannot be read or modified

--Deleted- The partitions which are inside the new data subrange cannot be read or modified

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IgnoreSubRangePointOnBoundary

Optional

System.Management.Automation.SwitchParameter

Specifies whether to complete without any errors if the new subrange's start and end points are the same. If this parameter is specified, no errors are displayed.

SubRangePoint

Optional

System.Byte[]

Specifies the start or end point of the data subrange to be created as defined by the following criteria:

--The start point if the data sub-range is created on the upper side of the data range.

--The end point if the data sub-range is created on the lower side of the data range.

The maximum value is NULL.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ConnectionString

Required

System.String

Specifies the connection string for the scale-out database to create the new data sub-range.

IsUpperSubRange

Required

System.Boolean

Specifies whether to create the data subrange on the upper or lower side of the data range.

Range

Required

Microsoft.SharePoint.SPScaleOutDataRange

Specifies the expected current range of the scale-out database prior to this operation.

SubRangeMode

Required

Microsoft.SharePoint.SPScaleOutDatabaseSubRangeMode

Specifies the mode of the data subrange to be created. The data subrange mode values are the following:

--NULL- The data subrange on the specified side (lower or upper) of the data range will be removed.

--ReadOnly - The partitions which are inside the new data subrange can be read, but cannot be modified.

--Changing -The partitions which are inside the new data subrange cannot be read or modified

--Deleted- The partitions which are inside the new data subrange cannot be read or modified

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IgnoreSubRangePointOnBoundary

Optional

System.Management.Automation.SwitchParameter

Specifies whether to complete without any errors if the new subrange's start and end points are the same. If this parameter is specified, no errors are displayed.

IsAzureDatabase

Optional

System.Management.Automation.SwitchParameter

Specifies whether the database is hosted on SQL Azure.

SubRangePoint

Optional

System.Byte[]

Specifies the start or end point of the data subrange to be created as defined by the following criteria:

--The start point if the data sub-range is created on the upper side of the data range.

--The end point if the data sub-range is created on the lower side of the data range.

The maximum value is NULL.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPServerScaleOutDatabaseDataSubRange cmdlet to create a subrange with the specified parameters for a specified scale-out database or a database which will be connected with a specified connection string. A subrange is a subset of a range of data.

Input Types

Return Types

Example

--------------EXAMPLE-------------

Copy code
$databases = Get-SPServerScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
$database = $databases[0]
Copy code
$state = Get-SPServerScaleOutDatabaseDataState -Database $database
Copy code
Set-SPServerScaleOutDatabaseDataSubRange -Database $database -Range $state.Range -SubRangePoint $state.Range.RangeEnd -SubRangeMode ReadOnly -IsUpperSubRange $false

This example creates a read-only subrange that starts from the data range start point and ends at the data range end point on the first scale-out database of the specified service application.

See also

Clear-SPServerScaleOutDatabaseDeletedDataSubRange


Split-SPServerScaleOutDatabase
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Moves a specified percentage of partitions from one scale-out database to another.

Split-SPServerScaleOutDatabase -NewDatabaseName <String> -SourceDatabase <SPDatabasePipeBind> -SourceServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MoveLowerHalf <SwitchParameter>] [-NewDatabaseCredentials <PSCredential>] [-NewDatabaseFailoverServer <String>] [-NewDatabaseServer <String>] [-SourcePercentage <Int32>] [-WhatIf [<SwitchParameter>]]
Split-SPServerScaleOutDatabase -SourceDatabase <SPDatabasePipeBind> -SourceServiceApplication <SPServiceApplicationPipeBind> -TargetDatabase <SPDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MoveLowerHalf <SwitchParameter>] [-SourcePercentage <Int32>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

NewDatabaseName

Required

System.String

Specifies the name of a new scale-out database that you are creating.

SourceDatabase

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

The source scale-out database to move data from.

SourceServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

The service application in which the data move operation will take place.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MoveLowerHalf

Optional

System.Management.Automation.SwitchParameter

Specifies whether to move the lower or the upper side of the data range from the source scale-out database. If this parameter is not specified, the default behavior is to move the upper side of the source scale-out database data range.

NewDatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the credentials to use when creating the scale-out database. These credentials will have owner permissions on the new scale-out database. If you do not provide a value, the credentials of the logged on user will be used.

NewDatabaseFailoverServer

Optional

System.String

Specifies the failover server name of the new scale-out database. If you do not provide a value, the new scale-out database does not have a failover server.

NewDatabaseServer

Optional

System.String

Specifies the name of the server of the new scale-out database. If you do not provide a value, the name of the default database server is used.

SourcePercentage

Optional

System.Int32

Specifies the percentage of data in the source scale-out database to move. If you do not provide a value, the default value, 50 percent, is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

SourceDatabase

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

The source scale-out database to move data from.

SourceServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

The service application in which the data move operation will take place.

TargetDatabase

Required

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

The target scale-out database to move data to.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MoveLowerHalf

Optional

System.Management.Automation.SwitchParameter

Specifies whether to move the lower or the upper side of the data range from the source scale-out database. If this parameter is not specified, the default behavior is to move the upper side of the source scale-out database data range.

SourcePercentage

Optional

System.Int32

Specifies the percentage of data in the source scale-out database to move. If you do not provide a value, the default value, 50 percent, is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Split-SPServerScaleOutDatabase cmdlet to move a specified percentage of partitions from a source database to an existing target database or to a new database that you create with the specified parameters.

Input Types

Return Types

Example

---------------EXAMPLE---------------

Copy code
$databases = Get-SPServerScaleOutDatabase -ServiceApplication $serviceApplication
Copy code
database = $databases[0]
Copy code
Split-SPServerScaleOutDatabase -NewDatabaseName Database2 -NewDatabaseServer MyDatabaseServer -SourceDatabase $database -SourceServiceApplication $serviceApplication -SourcePercentage 30

This example creates a new scale-out database named Database2 on the MyDatabaseServer database server in the given service application. The example also moves 30 percent of the data from the upper side of the data range in the first scale-out database of the given service application.

See also

Add-SPServerScaleOutDatabase
Get-SPServerScaleOutDatabase
Remove-SPServerScaleOutDatabase


Enterprise content management cmdlets in SharePoint Server 2013
See also

Summary: List Windows PowerShell cmdlets that help you manage content in SharePoint Server 2013 environments.

Applies to: SharePoint Server 2013

Enterprise content management (ECM) is the strategies, methods, and tools used to obtain, retain, and deliver content and documents related to processes within an organization. In SharePoint Server 2013, Windows PowerShell cmdlets focus on two aspects of content deployment functionality.

Content deployment copies content from a source SharePoint Server 2013 site collection to a destination site collection. You can copy the entire source site collection or a subset of sites.

Note:

Make sure that you run the initial content deployment as a full deployment. After you complete a full deployment, you can run an incremental deployment, which deploys only changed pages and related assets.

The Windows PowerShell cmdlets that are related to content deployment focus on two areas:

  • Content deployment path A content deployment path defines the relationship between a source and destination site collection for content deployment. After you create a path, you can create jobs and associate them with the path to begin deploying content.

    Use the Windows PowerShell noun, SPContentDeploymentPath, to retrieve, set, and create deployment paths.

  • Content deployment job A content deployment job is associated with a content deployment path. It defines the specific content to be deployed from the source to the destination, and the schedule on which the deployment should occur.

    The Windows PowerShell noun, SPContentDeploymentJob, lets the administrator retrieve, set, and create deployment jobs.

This article also lists cmdlets that support administration of metadata.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Content deployment

Cmdlet name | Description
Get-SPContentDeploymentJob | Returns a content deployment job or a collection of content deployment jobs.
Get-SPContentDeploymentPath | Returns a content deployment path or a collection of content deployment paths.
Get-SPSiteSubscriptionEdiscoveryHub | Displays the eDiscovery hub for a site subscription.
Get-SPSiteSubscriptionEdiscoverySearchScope | Displays the search scope for the eDiscovery hub of the specified site collection.
New-SPContentDeploymentJob | Creates a content deployment job.
New-SPContentDeploymentPath | Creates a new content deployment path.
Remove-SPContentDeploymentJob | Removes a content deployment job.
Remove-SPContentDeploymentPath | Removes a content deployment path.
Set-SPContentDeploymentJob | Sets properties of a content deployment job.
Set-SPContentDeploymentPath | Sets properties of a content deployment path.
Set-SPSiteSubscriptionEdiscoveryHub | Sets properties for the eDiscovery hub of a site subscription.
Start-SPContentDeploymentJob | Starts a content deployment job.

Metadata administration

Cmdlet name | Description
Clear-SPMetadataWebServicePartitionData | Removes all data for a site subscription on a metadata Web service application
Export-SPMetadataWebServicePartitionData | Exports the data from a metadata Web service for a site subscription.
Get-SPMetadataServiceApplication | Returns the properties of a service application or a collection of service applications.
Get-SPMetadataServiceApplicationProxy | Returns the properties of a service application proxy or a collection of service application proxies.
Get-SPSiteSubscriptionMetadataConfig | Returns the site subscription configuration settings for a metadata service application.
Get-SPTaxonomySession | Returns a TaxonomySession object.
Import-SPMetadataWebServicePartitionData | Restores the data for a site subscription.
New-SPMetadataServiceApplication | Creates a new metadata service application.
New-SPMetadataServiceApplicationProxy | Creates a new metadata service application proxy.
Remove-SPSiteSubscriptionMetadataConfig | Removes site subscription configuration settings.
Set-SPMetadataServiceApplication | Sets the properties for a metadata service application.
Set-SPMetadataServiceApplicationProxy | Sets the properties for a metadata service application proxy.
Set-SPSiteSubscriptionMetadataConfig | Sets the site subscription configuration settings for a specified metadata service application.

See also

Windows PowerShell for SharePoint 2013 reference


Get-SPContentDeploymentJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a content deployment job or a collection of content deployment jobs.

Get-SPContentDeploymentJob [[-Identity] <SPContentDeploymentJobPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Path <SPContentDeploymentPathPipeBind>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.Publishing.Cmdlet.SPContentDeploymentJobPipeBind

Specifies the content deployment job to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content deployment job (for example, DeployJob1); or an instance of a valid SPContentDeploymentJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Path

Optional

Microsoft.SharePoint.Publishing.Cmdlet.SPContentDeploymentPathPipeBind

Specifies that content deployment jobs for only the specified content deployment path are returned.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content deployment job (for example; DeployPath1); or an instance of a valid SPContentDeploymentPath object.

Detailed Description

The Get-SPContentDeploymentJob cmdlet reads the specified content deployment job. If the Identity parameter is not specified, this cmdlet returns the collection of content deployment jobs on the farm.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Get-SPContentDeploymentJob "Job 1"

This example returns the content deployment job called Job 1.

See also

New-SPContentDeploymentJob
Remove-SPContentDeploymentJob
Set-SPContentDeploymentJob
Start-SPContentDeploymentJob


Get-SPContentDeploymentPath
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a content deployment path or a collection of content deployment paths.

Get-SPContentDeploymentPath [[-Identity] <SPContentDeploymentPathPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.Publishing.Cmdlet.SPContentDeploymentPathPipeBind

Specifies the content deployment path to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content deployment path (for example, DeployPath1); or an instance of a valid SPContentDeploymentJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPContentDeploymentPath cmdlet reads the specified content deployment path. If the Identity parameter is not specified, this cmdlet returns the collection of content deployment paths on the farm.

Input Types

Return Types

Example

--------------EXAMPLE--------------

Copy code
Get-SPContentDeploymentPath "Path 1"

This example returns the content deployment path named Path1.

See also

New-SPContentDeploymentPath
Remove-SPContentDeploymentPath
Set-SPContentDeploymentPath


Get-SPSiteSubscriptionEdiscoveryHub
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Displays the eDiscovery hub for a site subscription.

Get-SPSiteSubscriptionEdiscoveryHub [-Identity] <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the URL of the site collections to the eDiscovery hub. Can pipe the result from the Get-SPSiteSubcription cmdlet.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPSiteSubscriptionEdiscoveryHub cmdlet to display the site collection configured as the eDiscovery hub for the specified site subscription.

Input Types

Return Types

Example

------------------EXAMPLE----------------------

Copy code
Get-SPSiteSubscriptionEdiscoveryHub -Identity http://contoso.com

This example displays the eDiscovery hub for the specified site collection.

See also

Get-SPSiteSubscriptionEdiscoverySearchScope
Set-SPSiteSubscriptionEdiscoveryHub


Get-SPSiteSubscriptionEdiscoverySearchScope
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Displays the search scope for the eDiscovery hub of the specified site collection.

Get-SPSiteSubscriptionEdiscoverySearchScope [-Identity] <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the URL to the group of site collections that contained the search scope.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPSiteSubscriptionEdiscoverySearchScope cmdlet to retrieve the search scope that has been configured for the eDiscovery hub of the specified site subscription.

Input Types

Return Types

Example

-------------------EXAMPLE--------------------

Copy code
Get-SPSiteSubscriptionEdiscoverySearchScope - Identity http://contoso.com

This example displays the search scope for the eDiscovery hub for the specified site collection.

See also

Get-SPSiteSubscriptionEdiscoveryHub
Set-SPSiteSubscriptionEdiscoveryHub


New-SPContentDeploymentJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a content deployment job.

New-SPContentDeploymentJob -Name <String> -SPContentDeploymentPath <SPContentDeploymentPathPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-EmailAddresses <String[]>] [-EmailNotifications <None | SendEmailOnFailure | SendEmailOnSuccess | SendEmailOnAlways>] [-HostingSupportEnabled <SwitchParameter>] [-IncrementalEnabled <SwitchParameter>] [-Schedule <String>] [-ScheduleEnabled <SwitchParameter>] [-Scope <SPWebPipeBind[]>] [-SqlSnapshotSetting <None | CreateNew>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the new content deployment job.

The type must be a valid name of a content deployment job; for example, DeployJob1.

SPContentDeploymentPath

Required

Microsoft.SharePoint.Publishing.Cmdlet.SPContentDeploymentPathPipeBind

Specifies the deployment path to associate with the new deployment job.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content deployment job (for example; DeployJob1); or an instance of a valid SPContentDeploymentJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies the description for the content deployment job. The name can be a maximum of 4096 alphanumeric characters.

The type must be a valid string.

EmailAddresses

Optional

System.String[]

Specifies the e-mail addresses of individuals who receive notification e-mails about this ContentDeploymentJob object.

The type must be a list of valid e-mail addresses.

EmailNotifications

Optional

Microsoft.SharePoint.Publishing.Administration.ContentDeploymentNotificationSettings

Specifies how e-mail notifications are sent about this ContentDeploymentJob object.

The type must be one of the following:

-Never specifies that e-mail notifications will not be sent when a job succeeds or fails.

- SendEmailOnSuccess specifies that e-mail notifications will be sent if a content deployment job succeeds.

- SendEmailOnFailure specifies that e-mail notifications will be sent if a content deployment job fails.

- SendEmailOnAlways specifies that e-mail notifications will be sent when a job succeeds or fails.

HostingSupportEnabled

Optional

System.Management.Automation.SwitchParameter

Enables special hosting- behavior. The default value is False.

Normally, a content deployment job is enabled or disabled by using the SharePoint Central Administration Web site. However, in the case of hosting, the tenant administrator does not have permissions to access the Central Administration page to configure jobs. Therefore, when the HostingSupportEnabled parameter is set to True, the hoster creates the job, so that tenants can enable or disable their deployment jobs from their tenant administration site.

IncrementalEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies that only incremental changes are deployed to the destination site collection.

Schedule

Optional

System.String

Sets the schedule for the deployment job.

The type must be a valid SPSchedule object.

ScheduleEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies to enable the schedule for the deployment job. If the schedule is not enabled the job can be run only manually.

Scope

Optional

Microsoft.SharePoint.PowerShell.SPWebPipeBind[]

Sets the scope of the deployment job. SPSites passed in must exist in the current path of the source site collection. The default scope is the entire site collection. Valid values include an SPWeb object or an array of SPWeb objects.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint Foundation 2013 Web site (for example, MySPSite1); or an instance of a valid SPWeb object.

SqlSnapshotSetting

Optional

Microsoft.SharePoint.Publishing.Administration.ContentDeploymentSqlSnapshotSetting

Creates a database snapshot of the source SharePoint Foundation 2013 content database to use for the export process.

The type must be one of the following values:

- None

- CreateNew

Note:

The CreateNew value requires thatSQL Server Enterprise Edition be installed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPContentDeploymentJob cmdlet adds a new content deployment job to a farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPContentDeploymentPath "Path 1" | New-SPContentDeploymentJob -Name "Deployment Job" -SPContentDeploymentPath $_ -IncrementalEnabled:$true -ScheduleEnabled:$false

This example creates a new content deployment job called Deployment Job by using the deployment path Path 1. The job is configured to be an incremental job with no schedule.

See also

Get-SPContentDeploymentJob
Remove-SPContentDeploymentJob
Set-SPContentDeploymentJob
Start-SPContentDeploymentJob


New-SPContentDeploymentPath
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new content deployment path.

New-SPContentDeploymentPath -DestinationCentralAdministrationURL <Uri> -DestinationSPSite <String> -DestinationSPWebApplication <Uri> -Name <String> -PathAccount <PSCredential> -SourceSPSite <SPSitePipeBind> -SourceSPWebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Authentication <Basic | Windows>] [-CompressionEnabled <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-DeploySecurityInformation <None | WssOnly | All>] [-DeployUserNamesEnabled <SwitchParameter>] [-Description <String>] [-EventReceiversEnabled <SwitchParameter>] [-KeepTemporaryFilesOptions <Never | Always | Failure>] [-PathEnabled <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

DestinationCentralAdministrationURL

Required

System.Uri

Specifies the SharePoint Central Administration URL for the destination farm.

The type must be a valid URL, in the form http://server_name.

DestinationSPSite

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the destination site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

DestinationSPWebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the destination Web application.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

Name

Required

System.String

Specifies the name of the new content deployment path.

The type must be a valid name of a content deployment path; for example, DeployPath1.

PathAccount

Required

System.Management.Automation.PSCredential

Specifies the user ID that is an administrator on the Central Administration page on the destination farm.

The type must be a valid SharePoint user.

SourceSPSite

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the source site collection for the deployment path. Must be a site collection in the source specified in the SourceSPWebApplication parameter.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

SourceSPWebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the source Web application for the deployment path.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Authentication

Optional

Microsoft.SharePoint.Publishing.Administration.PathAuthenticationOption

Sets the Windows-based authentication type that the source front-end Web server uses to communicate with the destination Web application.

The type must be one of the following values: WindowsAuth or BasicAuth.

CompressionEnabled

Optional

System.Management.Automation.SwitchParameter

Turns on compression during the export.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DeploySecurityInformation

Optional

Microsoft.SharePoint.Deployment.SPIncludeSecurity

Specifies the user and group information to include during the export operation for this content deployment path. The default value is All.

The type must be one of the following values: None, All, or WssOnly- Applies only SharePoint Foundation 2013 security settings. Includes user memberships and role assignments such as default roles, for example, Web Designer or any custom roles that extend from the default roles. The access control list (ACL) for each object is migrated. No user information defined in the DAP or LDAP servers is included.

DeployUserNamesEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether to include user names during a deployment.

Valid values are one of the following:

- $True Retains the original author and editor information, time and date stamp, and user lookup value.

- $False Retains the original date and time stamp, but replaces the author and editor data with the System Account, and replaces the user lookup value with an empty string ("").

Description

Optional

System.String

Sets the description for the content deployment path. The description can contain a maximum of 4096 alphanumeric characters.

The type must be a valid string.

EventReceiversEnabled

Optional

System.Management.Automation.SwitchParameter

Turns on event receivers during import.

KeepTemporaryFilesOptions

Optional

Microsoft.SharePoint.Publishing.Administration.TemporaryFilesOption

Specifies that temporary files are kept after content deployment is finished.

The type must be one of the following values: Never, Always, or OnFailure.

PathEnabled

Optional

System.Management.Automation.SwitchParameter

Enables the new content deployment path.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPContentDeploymentPath cmdlet adds a new content deployment path for a content deployment job.

Input Types

Return Types

Example

-----------------EXAMPLE----------------------

Copy code
$source = Get-SPSite "http://source/"
Copy code
$credentials=Get-Credential
Copy code
New-SPContentDeploymentPath -Name "Deployment Path" -SourceSPWebApplication $source.WebApplication -SourceSPSite $source DestinationCentralAdministrationURL "http://destination:8080" -DestinationSPWebApplication "http://destination" -DestinationSPSite "http://destination" -KeepTemporaryFilesOptions "Failure" -PathAccount $credentials -PathEnabled:$true

This example creates a new deployment path called Deployment Path that connects a source at http://source to a destination at http://destination. The path is enabled and configured to keep temporary files on job failure.

See also

Get-SPContentDeploymentPath
Remove-SPContentDeploymentPath
Set-SPContentDeploymentPath


Remove-SPContentDeploymentJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a content deployment job.

Remove-SPContentDeploymentJob [-Identity] <SPContentDeploymentJobPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Publishing.Cmdlet.SPContentDeploymentPathPipeBind

Specifies the content deployment job to remove. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content deployment job (for example; DeployJob1); or an instance of a valid SPContentDeploymentJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPContentDeploymentJob cmdlet removes a content deployment job.

Input Types

Return Types

Example

-------------------EXAMPLE------------------

Copy code
Remove-SPContentDeploymentJob -Identity "DeployJob1"

This example removes a deployment job named DeployJob1.

See also

Get-SPContentDeploymentPath
New-SPContentDeploymentPath
Set-SPContentDeploymentPath
Start-SPContentDeploymentJob


Remove-SPContentDeploymentPath
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a content deployment path.

Remove-SPContentDeploymentPath [-Identity] <SPContentDeploymentPathPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Publishing.Cmdlet.SPContentDeploymentPathPipeBind

Specifies the content deployment path to remove. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content deployment path (for example; DeployPath1); or an instance of a valid SPContentDeploymentPath object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPContentDeploymentPath cmdlet removes a content deployment path.

Input Types

Return Types

Example

--------------------EXAMPLE-----------------------

Copy code
Remove-SPContentDeploymentPath -Path1

This example removes a content path named Path1.

See also

Get-SPContentDeploymentPath
New-SPContentDeploymentPath
Set-SPContentDeploymentPath


Set-SPContentDeploymentJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a content deployment job.

Set-SPContentDeploymentJob [-Identity] <SPContentDeploymentJobPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-EmailAddresses <String[]>] [-EmailNotifications <None | SendEmailOnFailure | SendEmailOnSuccess | SendEmailOnAlways>] [-HostingSupportEnabled <SwitchParameter>] [-IncrementalEnabled <SwitchParameter>] [-Name <String>] [-Schedule <String>] [-ScheduleEnabled <SwitchParameter>] [-Scope <SPWebPipeBind[]>] [-SqlSnapshotSetting <None | CreateNew>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Publishing.Cmdlet.SPContentDeploymentJobPipeBind

Specifies the content deployment job to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content deployment job (for example, DeployJob1); or an instance of a valid SPContentDeploymentJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies the description for the content deployment job. The name can be a maximum of 4096 alphanumeric characters.

The type must be a valid string.

EmailAddresses

Optional

System.String[]

Specifies the e-mail addresses of individuals who receive notification e-mails about this ContentDeploymentJob object.

The type must be a list of valid e-mail addresses.

EmailNotifications

Optional

Microsoft.SharePoint.Publishing.Administration.ContentDeploymentNotificationSettings

Specifies how e-mail notifications are sent about this ContentDeploymentJob object.

The type must be one of the following:

-Never specifies that e-mail notifications will not be sent when a job succeeds or fails.

- Success specifies that e-mail notifications will be sent if a content deployment job succeeds.

- Failure specifies that e-mail notifications will be sent if a content deployment job fails.

- Always specifies that e-mail notifications will be sent when a job succeeds or fails.

HostingSupportEnabled

Optional

System.Management.Automation.SwitchParameter

Enables special hosting behavior. The default value is False.

Normally, a content deployment job is enabled or disabled by using the SharePoint Central Administration Web site. However, in the case of hosting, the tenant administrator does not have permissions to access the Central Administration page to configure jobs. Therefore, when the HostingSupportEnabled parameter is set to True, the hoster creates the job, so that tenants can enable or disable their deployment jobs from their tenant administration site.

IncrementalEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies that only incremental changes are deployed to the destination site collection.

Name

Optional

System.String

Specifies the name of the new content deployment job.

The type must be a valid name of a content deployment job; for example, DeployJob1.

Schedule

Optional

System.String

Sets the schedule for the deployment job.

The type must be a valid SPSchedule object.

ScheduleEnabled

Optional

System.Management.Automation.SwitchParameter

Enables the schedule for the deployment job. If the schedule is not enabled, the job can be run manually only.

Scope

Optional

Microsoft.SharePoint.PowerShell.SPWebPipeBind[]

Sets the scope of the deployment job. SPSite objects that are passed in must exist in the current path of the source site collection. The default scope is the entire site collection. Valid values include a SPWeb object or an array of SPWeb objects.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint Foundation 2013 Web site (for example, MySPSite1); or an instance of a valid SPWeb object.

SqlSnapshotSetting

Optional

Microsoft.SharePoint.Publishing.Administration.ContentDeploymentSqlSnapshotSetting

Backs up the SharePoint Foundation 2013 content database by using SQL Server.

The type must be one of the following values: None or CreateNew.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPContentDeploymentJob cmdlet sets the properties of a content deployment job.

Input Types

Return Types

Example

-----------------EXAMPLE------------------

Copy code
Get-SPContentDeploymentJob "Job 1" | Set-SPContentDeploymentJob -Schedule "hourly between 0 and 59" -ScheduleEnabled:$true

This example sets the deployment job called Job 1 to run hourly.

See also

Get-SPContentDeploymentPath
New-SPContentDeploymentJob
Remove-SPContentDeploymentJob
Start-SPContentDeploymentJob


Set-SPContentDeploymentPath
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a content deployment path.

Set-SPContentDeploymentPath [-Identity] <SPContentDeploymentPathPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Authentication <Basic | Windows>] [-CompressionEnabled <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-DeploySecurityInformation <None | WssOnly | All>] [-DeployUserNamesEnabled <SwitchParameter>] [-Description <String>] [-DestinationCentralAdministrationURL <Uri>] [-EventReceiversEnabled <SwitchParameter>] [-KeepTemporaryFilesOptions <Never | Always | Failure>] [-Name <String>] [-PathAccount <PSCredential>] [-PathEnabled <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Publishing.Cmdlet.SPContentDeploymentPathPipeBind

Specifies the content deployment path to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content deployment job (for example; DeployPath1); or an instance of a valid SPContentDeploymentPath object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Authentication

Optional

Microsoft.SharePoint.Publishing.Administration.PathAuthenticationOption

Sets the Windows-based authentication type that the source front-end Web server uses to communicate with the destination Web application.

The type must be one of the following values: WindowsAuth or BasicAuth.

CompressionEnabled

Optional

System.Management.Automation.SwitchParameter

Turns on compression during the export.

DeploySecurityInformation

Optional

Microsoft.SharePoint.Deployment.SPIncludeSecurity

Specifies the user and group information to include during the export operation for this content deployment path. The default value is All.

The type must be one of the following values: None, All, or WssOnly- Applies only SharePoint Foundation 2013 security settings. Includes user memberships and role assignments such as default roles, for example, Web Designer or any custom roles that extend from the default roles. The access control list (ACL) for each object is migrated. No user information defined in the DAP or LDAP servers is included.

DeployUserNamesEnabled

Optional

System.Management.Automation.SwitchParameter

Specify to enable event receivers during import.

Description

Optional

System.String

Sets the description for the content deployment path. The description can contain a maximum of 4096 alphanumeric characters.

The type must be a valid string.

DestinationCentralAdministrationURL

Optional

System.Uri

Specifies the SharePoint Central Administration URL for the destination farm.

The type must be a valid URL, in the form http://server_name.

EventReceiversEnabled

Optional

System.Management.Automation.SwitchParameter

Turns on event receivers during import.

KeepTemporaryFilesOptions

Optional

Microsoft.SharePoint.Publishing.Administration.TemporaryFilesOption

Specifies that temporary files are kept after content deployment is finished.

The type must be one of the following values: Never, Always, or OnFailure.

Name

Optional

System.String

Specifies the name of the content deployment path.

The type must be a valid name of a content deployment path; for example, DeploymentPath1.

PathAccount

Optional

System.Management.Automation.PSCredential

Specifies the user ID that is an administrator on the Central Administration page on the destination farm.

The type must be a valid SharePoint user.

PathEnabled

Optional

System.Management.Automation.SwitchParameter

Enables the content deployment path.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPContentDeploymentPath cmdlet sets the properties of a content deployment path for a content deployment job.

Input Types

Return Types

Example

------------EXAMPLE-------------

Copy code
Get-SPContentDeploymentPath "Path 1" | Set-SPContentDeploymentPath -PathEnabled:$false

This example sets the deployment path Path 1 to be disabled.

See also

Get-SPContentDeploymentPath
New-SPContentDeploymentPath
Remove-SPContentDeploymentPath


Set-SPSiteSubscriptionEdiscoveryHub
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties for the eDiscovery hub of a site subscription.

Set-SPSiteSubscriptionEdiscoveryHub -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchScope <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection for the Ediscovery hub.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchScope

Optional

System.String

Specifies the name for the search scope. The default value is All Sites.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPSiteSubscriptionEdiscoveryHub cmdlet sets global properties and settings for the Ediscovery hub.

Input Types

Return Types

Example

--------------------EXAMPLE--------------------

Copy code
Set-SPSiteSubscriptionEdiscoverySearchScope -Site http://contoso.com/sites/sitecollection1 -SearchScope 1

This example enables the search scope for the entire site subscription. A value of zero (0) disables the search scope across the entire site subscription.

See also

Get-SPSiteSubscriptionEdiscoveryHub
Get-SPSiteSubscriptionEdiscoverySearchScope


Start-SPContentDeploymentJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Starts a content deployment job.

Start-SPContentDeploymentJob [-Identity] <SPContentDeploymentJobPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DeploySinceTime <String>] [-TestEnabled <SwitchParameter>] [-UseSpecificSnapshot <String>] [-WaitEnabled <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Publishing.Cmdlet.SPContentDeploymentJobPipeBind

Specifies the content deployment job to run.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content deployment job (for example, DeployJob1); or an instance of a valid SPContentDeploymentJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DeploySinceTime

Optional

System.String

Specifies the date to use to determine what changes to export incrementally. This parameter is ignored if the deployment job type is full.

The type must be a valid DateTime type, in the form 2010,12,05.

TestEnabled

Optional

System.Management.Automation.SwitchParameter

Runs the content deployment job in test mode only.

WaitEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies that the command is not returned until the operation is complete.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Start-SPContentDeploymentJob cmdlet starts a content deployment job.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPContentDeploymentPath "Path 1" | New-SPContentDeploymentJob -Name "Job 1" -SPContentDeploymentPath $_ -IncrementalEnabled:$true -ScheduleEnabled:$false | Start-SPContentDeploymentJob

This example creates a content deployment job Job 1 and runs it immediately.

See also

Get-SPContentDeploymentJob
New-SPContentDeploymentJob
Remove-SPContentDeploymentJob
Set-SPContentDeploymentJob


Clear-SPMetadataWebServicePartitionData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes all data for a site subscription on a metadata Web service application.

Clear-SPMetadataWebServicePartitionData [-Identity] <SPSiteSubscriptionPipeBind> [-ServiceProxy] <SPMetadataServiceProxyCmdletPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription configuration to remove.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscriptionConfig1); or an instance of a valid SiteSubscription object.

ServiceProxy

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceProxyCmdletPipeBind

Specifies the service proxy for the service application that contains the site subscription.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of the service application proxy (for example, ServiceAppProxy1); or an instance of a valid SPMetadataServiceProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Clear-SPMetadataWebServicePartitionData cmdlet to clear all data for a site subscription on a metadata Web service application.

Input Types

Return Types

Example

----------------EXAMPLE---------------

Copy code
Clear-SPMetadataWebServicePartitionData -Identity $siteSubscriptionPipeBind1 -ServiceProxy "MetadataServiceProxy2"

This example removes data for a site subscription on a Metadata Service application.

See also

Export-SPMetadataWebServicePartitionData
Import-SPMetadataWebServicePartitionData


Export-SPMetadataWebServicePartitionData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Exports the data from a metadata Web service for a site subscription.

Export-SPMetadataWebServicePartitionData [-Identity] <SPSiteSubscriptionPipeBind> [-ServiceProxy] <SPMetadataServiceProxyCmdletPipeBind> -Path <String> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription to export.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscriptionConfig1); or an instance of a valid SiteSubscription object.

ServiceProxy

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceProxyCmdletPipeBind

Specifies the service proxy for the service application that contains the site subscription.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of the service application proxy (for example, ServiceAppProxy1); or an instance of a valid SPMetadataServiceProxy object.

Path

Required

System.String

Specifies the path and file name for the file to create from the exported data.

The type must be a valid path in either of the following forms:

- C:\folder_name\subscription_export

- \\server_name\folder_name\file_name.cab

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Export-SPMetadataWebServicePartitionData cmdlet to export the data from a metadata Web service that is associated with the specified site subscription.

Input Types

Return Types

Example

-----------------EXAMPLE--------------

Copy code
Export-SPMetadataWebServicePartitionData -Identity $siteSubscriptionPipeBind1 -ServiceProxy "MetadataServiceProxy2" -Path "\\server_name\folder_name\file_name.cab"

This example creates a backup of data for a specific site subscription on a Metadata Service application.

See also

Clear-SPMetadataWebServicePartitionData
Import-SPMetadataWebServicePartitionData


Get-SPMetadataServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a managed metadata service application.

Get-SPMetadataServiceApplication [-Identity] <SPMetadataServiceCmdletPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceCmdletPipeBind

Specifies the managed metadata service application to get.

The type must be a valid GUID or the name of a valid managed metadata service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPMetadataServiceApplication cmdlet to retrieve a specified managed metadata service application.

Input Types

Return Types

Example

----------------EXAMPLE-----------------

Copy code
Get-SPMetadataServiceApplication -Identity "ManagedMetadataServiceApp1"

This example retrieves an existing managed metadata service application.

See also

New-SPMetadataServiceApplication
Set-SPMetadataServiceApplication


Get-SPMetadataServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns an existing connection to a managed metadata service application, which is also known as a proxy, to the managed metadata service application.

Get-SPMetadataServiceApplicationProxy [-Identity] <SPMetadataServiceProxyCmdletPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceProxyCmdletPipeBind

Specifies the service application proxy to read.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of the service application proxy (for example, ServiceAppProxy1); or an instance of a valid SPMetadataServiceProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPMetadataServiceApplicationProxy cmdlet to get a specified connection to a managed metadata service application.

Input Types

Return Types

Example

----------------EXAMPLE-------------

Copy code
Get-SPMetadataServiceApplicationProxy -Identity "MetadataServiceProxy1"

This example retrieves an existing connection to a managed metadata service application.

See also

New-SPMetadataServiceApplicationProxy
Set-SPMetadataServiceApplicationProxy


Get-SPSiteSubscriptionMetadataConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the site subscription configuration settings for a Metadata Service application.

Get-SPSiteSubscriptionMetadataConfig [-Identity] <SPSiteSubscriptionPipeBind> [-ServiceProxy] <SPMetadataServiceProxyCmdletPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription to read.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscriptionConfig1); or an instance of a valid SiteSubscription object.

ServiceProxy

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceProxyCmdletPipeBind

Specifies the proxy of the metadata Service application for the site subscription.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of the service application proxy (for example, ServiceAppProxy1); or an instance of a valid SPMetadataServiceProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPSiteSubscriptionMetadataConfig cmdlet to read the site subscription configuration settings for a specified shared service application for the Metadata Service.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
Get-SPSiteSubscriptionMetadataConfig -Identity $siteSubscriptionPipeBind1 -ServiceProxy "MetadataServiceProxy2"

This example retrieves the site subscription-specific settings for an existing partitioned Metadata Service application.

See also

Remove-SPSiteSubscriptionMetadataConfig
Set-SPSiteSubscriptionMetadataConfig


Get-SPTaxonomySession
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a TaxonomySession object.

Get-SPTaxonomySession -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the SharePoint site mapped to the set of metadata term stores for the taxonomy session.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPTaxonomySession cmdlet to get a TaxonomySession object. A TaxonomySession object contains the set of metadata term stores for a taxonomy session.

Input Types

Return Types

Example

-----------------EXAMPLE--------------------

Copy code
$session = Get-SPTaxonomySession -Site "http://sitename"

This example retrieves a TaxonomySession object, which can be used to access term stores associated with the Web application for a site.


Import-SPMetadataWebServicePartitionData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Restores the data for a site subscription.

Import-SPMetadataWebServicePartitionData [-Identity] <SPSiteSubscriptionPipeBind> [-ServiceProxy] <SPMetadataServiceProxyCmdletPipeBind> -Path <String> [-AssignmentCollection <SPAssignmentCollection>] [-OverwriteExisting <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription to import.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscriptionConfig1); or an instance of a valid SiteSubscription object.

ServiceProxy

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceProxyCmdletPipeBind

Specifies the proxy for the service application that contains the site subscription.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of the service application proxy (for example, ServiceAppProxy1); or an instance of a valid SPMetadataServiceProxy object.

Path

Required

System.String

Specifies the path and name of the subscription data file to import.

The type must be a valid path in either of the following forms:

- C:\folder_name\formtemplate_name

- \\server_name\folder_name\file_name.cab

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

OverwriteExisting

Optional

System.Management.Automation.SwitchParameter

Specifies whether to overwrite the existing site subscription data, if it exists.

Detailed Description

Use the Import-SPMetadataWebServicePartitionData cmdlet to restore data for a site subscription to a shared service application for the Metadata Service.

Input Types

Return Types

Example

-------------------EXAMPLE----------------------

Copy code
Import-SPMetadataWebServicePartitionData -Identity $siteSubscriptionPipeBind1 -ServiceProxy "MetadataServiceProxy2" -Path "\\server_name\folder_name\file_name.cab"

This example restores a backup of Metadata Service application data for a specific site subscription on a Metadata Service application.

See also

Clear-SPMetadataWebServicePartitionData
Export-SPMetadataWebServicePartitionData


New-SPMetadataServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new managed metadata service application.

New-SPMetadataServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> -Name <String> [-AdministratorAccount <String>] [-AssignmentCollection <SPAssignmentCollection>] [-CacheTimeCheckInterval <Int32>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-FailoverDatabaseServer <String>] [-FullAccessAccount <String>] [-HubUri <String>] [-MaxChannelCache <Int32>] [-PartitionMode <SwitchParameter>] [-ReadAccessAccount <String>] [-RestrictedAccount <String>] [-SyndicationErrorReportEnabled <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the service application to create. The name can contain a maximum of 128 characters.

AdministratorAccount

Optional

System.String

A comma-separated list of user accounts or service accounts in the format <domain>\<account> that may create and run the service application. The accounts must already exist.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies an existing IIS application pool in which to run the new managed metadata service application.

The value must be a GUID that is the identity of an SPServiceApplicationPool object; the name of an existing application pool, or an instance of an SPServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CacheTimeCheckInterval

Optional

System.Int32

Specifies an interval, in seconds, that a front-end Web Server should wait before asking the application server for changes. This value is set per timer job, client application, or Web application.

The mininum value is 1, and there is no maximum value. The default value is 10.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL authentication.

If SQL authentication is to be used, either DatabaseCredentials must be specified or both the DatabaseUserName and DatabasePassword parameters must be set.

The type must be a valid PSCredential object.

DatabaseName

Optional

System.String

Specifies the name of the database to create for the new managed metadata service application.

The type must be a valid name of a SQL Server database; for example MeatadataDB1.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the database specified in DatabaseName.

The type must be a valid name of a SQL Server database; for example SqlServerHost1.

FailoverDatabaseServer

Optional

System.String

Specifies the name of the host server for the failover database server.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

FullAccessAccount

Optional

System.String

Specifies a comma-separated set of application pool accounts in the format <domain>\<account> that will be given read/write permission to the managed metadata service's term store and content type gallery. The accounts must already exist.

HubUri

Optional

System.String

Specifies the fully qualified URL of the site collection that contains the content type gallery that the service will provide access to.

MaxChannelCache

Optional

System.Int32

Specifies the maximum number of Windows Communication Foundation (WCF) channels that a front-end Web server should hold open to the application server. This value is set per timer job, client application, or Web application.

The minimum value is 0, and there is no maximum value. The default value is 4.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application restrict data by subscription.

Note This property cannot be changed after the service application has been created.

ReadAccessAccount

Optional

System.String

Specifies a comma-separated set of application pool accounts in the format <domain>\<account> that will be given read-only permission to the managed metadata service's term store and content type gallery. The accounts must already exist.

RestrictedAccount

Optional

System.String

Specifies a comma-separated set of application pool accounts in the format <domain>\<account> that will be given permission to read the managed metadata service's term store and content type gallery, and permission to write to open term sets and local term sets and to create new enterprise keywords. The accounts must already exist.

SyndicationErrorReportEnabled

Optional

System.Management.Automation.SwitchParameter

Enables reporting of errors when content types are imported.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPMetadataServiceApplication cmdlet to create a new managed metadata service application.

Input Types

Return Types

Example

-------------------EXAMPLE 1-------------

Copy code
New-SPMetadataServiceApplication -Name "MetadataServiceApp1" -ApplicationPool "AppPool1" -DatabaseName "MetadataDB1"

This example creates a new managed metadata service application.

-------------------EXAMPLE 2-------------

Copy code
New-SPMetadataServiceApplication -Name "MetadataServiceApp2" -ApplicationPool "AppPool1" -DatabaseName "MetadataDB2" -HubUri "http://sitename" -SyndicationErrorReportEnabled

This example creates a new managed metadata service application and specifies a content type hub to be used for syndication. It also enables error reporting during syndication.

-------------------EXAMPLE 3-------------

Copy code
New-SPMetadataServiceApplication -Name "MetadataServiceApp3" -ApplicationPool "AppPool1" -DatabaseName "MetadataDB3" -PartitionMode

This example creates a new managed metadata service application that is partitioned, for use by sites in a subscription.

See also

Get-SPMetadataServiceApplication
Set-SPMetadataServiceApplication


New-SPMetadataServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new connection to a managed metadata service application.

New-SPMetadataServiceApplicationProxy -Name <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ContentTypePushdownEnabled <SwitchParameter>] [-ContentTypeSyndicationEnabled <SwitchParameter>] [-DefaultKeywordTaxonomy <SwitchParameter>] [-DefaultProxyGroup <SwitchParameter>] [-DefaultSiteCollectionTaxonomy <SwitchParameter>] [-PartitionMode <SwitchParameter>] [-ServiceApplication <SPMetadataServiceCmdletPipeBind>] [-Uri <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the display name of the service application proxy to create. The name can contain a maximum of 128 characters.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentTypePushdownEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies that existing instances of changed content types in subsites and libraries will be updated.

ContentTypeSyndicationEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies that this connection will provide access to the content types that are associated with the managed metadata service application.

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the connection be added to the default proxy group for the farm.

DefaultKeywordTaxonomy

Optional

System.Management.Automation.SwitchParameter

Specifies that new enterprise keywords will be stored in the term store associated with the managed metadata service application.

DefaultSiteCollectionTaxonomy

Optional

System.Management.Automation.SwitchParameter

Specifies that the term set that is created when you create a new managed metadata column will be stored in the term store associated with the managed metadata application.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application restrict data by subscription.

Note:

This property cannot be changed after the service application proxy has been created.

ServiceApplication

Optional

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceCmdletPipeBind

Specifies the local managed metadata service application to connect to. The service application must exist on the local farm.

The type must be a valid GUID; a valid name of the service application; or an instance of a valid SPMetadataServiceApplication object.

Uri

Optional

System.String

Specifies the URI of a remote managed metadata service application to connect to.

Note:

To specify the managed metadata service application that this proxy is connecting to, you must set only the URI parameter or only the ServiceApplication parameter.

The type must be a valid URL, in the form urn:schemas-microsoft-com:sharepoint:service:fa5c65ebed244a15817768825004f3a7#authority=urn:uuid:acdd6deff6sd4bb899f5beb42051bf3b7&authority=https:// <server>:32844/Topology/topology.svc.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPMetadataServiceApplicationProxy cmdlet to create a new connection to a managed metadata service application.

Input Types

Return Types

Example

-------------------EXAMPLE 1----------------

Copy code
New-SPMetadataServiceApplicationProxy -Name "MetadataServiceProxy1" -ServiceApplication "MetadataServiceApp1"

This example creates a connection to a managed metadata service application in the local farm.

-------------------EXAMPLE 2----------------

Copy code
New-SPMetadataServiceApplicationProxy -Name "MetadataServiceProxy3" -ServiceApplication "MetadataServiceApp3" -PartitionMode

This example creates a partitioned connection to a managed metadata service application in the local farm.

See also

Get-SPMetadataServiceApplicationProxy
Set-SPMetadataServiceApplicationProxy


Remove-SPSiteSubscriptionMetadataConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes site subscription configuration settings.

Remove-SPSiteSubscriptionMetadataConfig [-Identity] <SPSiteSubscriptionPipeBind> [-ServiceProxy] <SPMetadataServiceProxyCmdletPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription for which to remove the Metadata Service application settings.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscriptionConfig1); or an instance of a valid SiteSubscription object.

ServiceProxy

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceProxyCmdletPipeBind

Specifies the local metadata service proxy for the service application containing the site subscription-specific settings.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of the service application proxy (for example, ServiceAppProxy1); or an instance of a valid SPMetadataServiceProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPSiteSubscriptionMetadataConfig cmdlet to remove the site subscription-specific configuration settings for a specified Metadata Service application.

Input Types

Return Types

Example

--------------------EXAMPLE-------------------

Copy code
Remove-SPSiteSubscriptionMetadataConfig -Identity $siteSubscriptionPipeBind1 -ServiceProxy "MetadataServiceProxy2"

This example removes the site subscription-specific settings from an existing partitioned Metadata Service application.

See also

Set-SPSiteSubscriptionMetadataConfig
Get-SPSiteSubscriptionMetadataConfig


Set-SPMetadataServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets the properties of a managed metadata service application.

Set-SPMetadataServiceApplication [-Identity] <SPMetadataServiceCmdletPipeBind> [-AdministratorAccount <String>] [-ApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-CacheTimeCheckInterval <Int32>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-DoNotUnpublishAllPackages <SwitchParameter>] [-FailoverDatabaseServer <String>] [-FullAccessAccount <String>] [-HubUri <String>] [-MaxChannelCache <Int32>] [-Name <String>] [-ReadAccessAccount <String>] [-RestrictedAccount <String>] [-SyndicationErrorReportEnabled <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceCmdletPipeBind

Specifies the managed metadata service application to update.

The type must be a valid GUID or the name of a valid managed metadata service application.

AdministratorAccount

Optional

System.String

A comma-separated list of user accounts or service accounts in the format <domain>\<account> that may create and run the service application. The accounts must already exist.

If a value is set by using this parameter, any existing values for the FullAccessAccount, ReadAccessAccount, and RestrictedAccount parameters are removed. Consider setting all four parameters at the same time.

ApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies an existing IIS application pool in which to run the Web service for the managed metadata service application.

The value must be a GUID that is the identity of an SPServiceApplicationPool object; the name of an existing application pool; or an instance of a valid SPServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CacheTimeCheckInterval

Optional

System.Int32

Specifies the interval, in seconds, that a front-end Web server should wait before asking the application server for changes. This value is set per timer job, client application, or Web application.

The mininum value is 1, and there is no maximum value. The default value is 10.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL authentication.

If SQL authentication is to be used, either the DatabaseCredentials parameter must be specified or both the DatabaseUserName and DatabasePassword parameters must be set.

The type must be a valid PSCredential object.

DatabaseName

Optional

System.String

Specifies the name of the database that contains the term store for the managed metadata service application.

The type must be a valid name of a SQL Server database; for example MeatadataDB1.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the database specified in DatabaseName.

The type must be a valid name of a SQL Server database; for example SqlServerHost1.

DoNotUnpublishAllPackages

Optional

System.Management.Automation.SwitchParameter

If this flag is set, the packages will not be unpublished. If the HubUri parameter is changed, all content type packages will be unpublished by default.

If the HubUri parameter is not changed, this flag has no effect.

FailoverDatabaseServer

Optional

System.String

Specifies the name of the host server for the failover database server.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

FullAccessAccount

Optional

System.String

Specifies a comma-separated set of application pool accounts in the format <domain>\<account> that will be given read/write permission to the managed metadata service's term store and content type gallery. The accounts must already exist.

If a value is set by using this parameter, any existing values for the AdministratorAccount, ReadAccessAccount, and RestrictedAccount parameters are removed. Consider setting all four parameters at the same time.

Name

Optional

System.String

Specifies the new name of the service application. The name can contain a maximum of 128 characters.

RestrictedAccount

Optional

System.String

Specifies a comma-separated set of application pool accounts in the format <domain>\<account> that will be given permission to read the managed metadata service's term store and content type gallery, and permission to write to open term sets and local term sets and to create new enterprise keywords. The accounts must already exist.

If a value is set by using this parameter, any previous values for the FullAccessAccount, ReadAccessAccount, and AdministratorAccount parameters are removed. Consider setting all four parameters at the same time.

SyndicationErrorReportEnabled

Optional

System.Management.Automation.SwitchParameter

Enables reporting of errors when content types are imported.

HubUri

Optional

System.String

Specifies the fully qualified URL of the site collection that contains the content type gallery that the service will provide access to.

MaxChannelCache

Optional

System.Int32

Specifies the maximum number of Windows Communication Foundation (WCF) channels that a front-end Web server holds open to the application server. This value is set per timer job, client application, or Web application.

The minimum value is 0, and there is no maximum value. The default value is 4.

ReadAccessAccount

Optional

System.String

Specifies a comma-separated set of application pool accounts in the format <domain>\<account> that will be given read-only permission to the managed metadata service's term store and content type gallery. The accounts must already exist.

If a value is set by using this parameter, any previous values for the FullAccessAccount, RestrictedAccount, and AdministratorAccount parameters are removed. Consider setting all four parameters at the same time.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPMetadataServiceApplication cmdlet to set the properties of a managed metadata service application.

Input Types

Return Types

Example

--------------------EXAMPLE 1---------------------

Copy code
Set-SPMetadataServiceApplication -Identity "MetadataServiceApp1" -HubUri "http://sitename" -SyndicationErrorReportEnabled

This example adds a content type hub to an existing managed metadata service application. It also enables error reporting when content types are imported.

--------------------EXAMPLE 2---------------------

Copy code
Set-SPMetadataServiceApplication -Identity "MetadataServiceApp1" -AdministratorAccount "contoso\username1" -FullAccessAccount "contoso\AppPoolAccount1,contoso\AppPoolAccount2" -RestrictedAccount "contoso\AppPoolAccount3,contoso\AppPoolAccount4,contoso\AppPoolAccount5" -ReadAccessAccount "contoso\AppPoolAccount6"

This example sets permissions on an existing managed metadata service application.

Note:

If you use Windows PowerShell to set any of the account values, you should set all of them. The Set-SPMetadataServiceApplication cmdlet first erases all accounts, then adds the accounts that you specified.

See also

Get-SPMetadataServiceApplication
New-SPMetadataServiceApplication


Set-SPMetadataServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets the properties of a connection to a managed metadata service application.

Set-SPMetadataServiceApplicationProxy [-Identity] <SPMetadataServiceProxyCmdletPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ContentTypePushdownEnabled <SwitchParameter>] [-ContentTypeSyndicationEnabled <SwitchParameter>] [-DefaultKeywordTaxonomy <SwitchParameter>] [-DefaultProxyGroup <SwitchParameter>] [-DefaultSiteCollectionTaxonomy <SwitchParameter>] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceProxyCmdletPipeBind

Specifies the connection to update.

The type must be a GUID that represents the identity of the connection to modify, the name of a valid connection to a managed metadata service, or an instance of a valid SPMetadataServiceProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentTypePushdownEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies that existing instances of changed content types in subsites and libraries will be updated.

ContentTypeSyndicationEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies that this connection will provide access to the content types that are associated with the managed metadata service application.

DefaultKeywordTaxonomy

Optional

System.Management.Automation.SwitchParameter

Specifies that new enterprise keywords will be stored in the term store associated with the managed metadata service application.

Note:

Do not make more than one connection the default keyword location.

DefaultSiteCollectionTaxonomy

Optional

System.Management.Automation.SwitchParameter

Specifies that the term set that is created when you create a new managed metadata column will be stored in the term store associated with the managed metadata service application.

Note:

Do not make more than one connection the default location for site collection term sets.

Name

Optional

System.String

Specifies the new display name of the connection. The name can contain a maximum of 128 characters.

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the connection be added to the default proxy group of the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPMetadataServiceApplicationProxy cmdlet to set the properties of a connection to a managed metadata service application.

Input Types

Return Types

Example

-----------------EXAMPLE 1---------------------

Copy code
Set-SPMetadataServiceApplicationProxy -Identity "MetadataServiceProxy1" -ContentTypeSyndicationEnabled -ContentTypePushdownEnabled

This example enables content type syndication and enables content type pushdown on an existing connection to a managed metadata service application.

-----------------EXAMPLE 2---------------------

Copy code
Set-SPMetadataServiceApplicationProxy -Identity "MetadataServiceProxy1" -ContentTypeSyndicationEnabled:$false -ContentTypePushdownEnabled:$false

This example disables content type syndication and disables content type pushdown on an existing connection to a managed metadata service application.

-----------------EXAMPLE 3---------------------

Copy code
Set-SPMetadataServiceApplicationProxy -Identity "MetadataServiceProxy1" -DefaultKeywordTaxonomy -DefaultSiteCollectionTaxonomy:$false

This example configures an existing connection to a managed metadata service application to be the default location for storing enterprise keywords and prevents it from being the default location for storing column-specific term sets.

See also

Get-SPMetadataServiceApplicationProxy
New-SPMetadataServiceApplicationProxy


Set-SPSiteSubscriptionMetadataConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets the site subscription configuration settings for a specified Metadata Service application.

Set-SPSiteSubscriptionMetadataConfig [-Identity] <SPSiteSubscriptionPipeBind> [-ServiceProxy] <SPMetadataServiceProxyCmdletPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DoNotUnpublishAllPackages <SwitchParameter>] [-HubUri <String>] [-SyndicationErrorReportEnabled <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription for which to set the Metadata Service application settings.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscriptionConfig1); or an instance of a valid SiteSubscription object.

ServiceProxy

Required

Microsoft.SharePoint.Taxonomy.Cmdlet.SPMetadataServiceProxyCmdletPipeBind

Specifies the local metadata service proxy for the service application that contains the site subscription-specific settings.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of the service application proxy (for example, ServiceAppProxy1); or an instance of a valid SPMetadataServiceProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DoNotUnpublishAllPackages

Optional

System.Management.Automation.SwitchParameter

HubUri

Optional

System.String

Specifies the URI of the syndication hub.

The type must be a valid URI, in the form file:\\server_name\sitedocs.

SyndicationErrorReportEnabled

Optional

System.Management.Automation.SwitchParameter

Enables error reporting for content type syndication.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPSiteSubscriptionMetadataConfig cmdlet to set the site subscription-specific settings for a specified shared service application for the Metadata Service.

Input Types

Return Types

Example

--------------------EXAMPLE---------------------

Copy code
Set-SPSiteSubscriptionMetadataConfig -Identity $siteSubscriptionPipeBind1 -ServiceProxy "MetadataServiceProxy2" -HubUri "http://sitename" -SyndicationErrorReportEnabled:$false

This example sets the content type syndication hub and disables syndication error reporting for a specific site subscription on an existing partitioned Metadata Service application.

See also

Remove-SPSiteSubscriptionMetadataConfig
Get-SPSiteSubscriptionMetadataConfig


Excel Services cmdlets in SharePoint Server 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you manage Excel Services applications in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

Excel Services Application is a service application in SharePoint Server 2013 that you can use to share, secure, and manage Excel 2013 workbooks (.xlsx, .xlsb, and .xlsm extensions) as interactive reports in a consistent way throughout the enterprise.

All Excel Services Application settings will support backup and recovery regardless of whether there is a UI setting in the SharePoint Central Administration website. This means that all global settings, trusted locations, user-defined-functions, data connection libraries, and trusted data provider settings will support backup and recovery. However, the following items will not be backed up as part of the backup and recovery process:

  • User-defined function assemblies. These assemblies will not be backed up or restored because they are binary files and not simply settings; however, the data in the list of trusted user-defined functions is backed up.

  • Trusted data provider binaries. The full list of trusted data providers and all associated properties, however, are backed up.

  • Any Excel Web Access (EWA) Web Part properties.

  • Office data connection (.odc extension) files and workbook files.

Note:

URLs of any kind (that is, URLs to trusted locations, user-defined functions, or data connection libraries) must be manually fixed after a restore operation because they might no longer be valid.

In addition to using Windows PowerShell for Excel Services Application backup and recovery functionality, you can use Windows PowerShell to provision the service application from scratch or provision a new instance that uses settings from a previous backup, and manage and configure trusted file locations, data providers, data connection libraries, and settings for user-defined function assemblies. You can also change global settings for Excel Services Application.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet Name | Description
Get-SPExcelBlockedFileType | Returns a file type or list of file types that are prevented from being loaded.
Get-SPExcelDataConnectionLibrary | Returns a trusted data connection library or a list of trusted data connection libraries.
Get-SPExcelDataProvider | Returns a safe data provider or a list of safe data providers.
Get-SPExcelFileLocation | Returns a trusted file location or a list of trusted file locations.
Get-SPExcelServiceApplication | Returns an SPExcelServiceApplication object.
Get-SPExcelUserDefinedFunction | Returns a user-defined function or a collection of user-defined functions.
New-SPExcelBlockedFileType | Adds a file type to the list of file types that Excel Services Application prevents from being loaded.
New-SPExcelDataConnectionLibrary | Adds a new data connection library to Excel Services Application.
New-SPExcelDataProvider | Adds a new safe data provider to Excel Services Application.
New-SPExcelFileLocation | Adds a new trusted location to Excel Services Application.
New-SPExcelServiceApplication | Creates a new instance of Excel Services Application.
New-SPExcelUserDefinedFunction | Adds a new user-defined function to Excel Services Application.
Remove-SPExcelBlockedFileType | Removes an entry from the list of file types that are prevented from being loaded on Excel Services Application.
Remove-SPExcelDataConnectionLibrary | Removes a data connection library from Excel Services Application.
Remove-SPExcelDataProvider | Removes a data provider from Excel Services Application.
Remove-SPExcelFileLocation | Removes a trusted file location from Excel Services Application.
Remove-SPExcelUserDefinedFunction | Removes a user-defined function from Excel Services Application.
Set-SPExcelDataConnectionLibrary | Sets properties of a data connection library for Excel Services Application.
Set-SPExcelDataProvider | Sets properties of a safe data provider for Excel Services Application.
Set-SPExcelFileLocation | Sets properties of a trusted file location for Excel Services Application.
Set-SPExcelServiceApplication | Sets global properties for Excel Services Application.
Set-SPExcelUserDefinedFunction | Sets properties of a user-defined function in Excel Services Application.

See also

Windows PowerShell for SharePoint 2013 reference


Get-SPExcelBlockedFileType
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a file type or list of file types that are prevented from loading.

Get-SPExcelBlockedFileType [[-Identity] <SPExcelBlockedFileTypePipeBind>] -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelBlockedFileTypePipeBind

Specifies the BlockedFileType object to return. If the Identity parameter is not specified, this cmdlet returns the list of file extensions that are currently prevented from loading on Excel Services Application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a file type (for example, FileType1); one of the following file types: XLSX, XLSB, XLSM; or an instance of a valid SPExcelBlockedFileType object.

ExcelServiceApplication

Yes

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPBlockedExcelFileType list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPExcelBlockedFileType cmdlet reads a file type or a list of file types that cannot be loaded in Excel Services Application. Excel Services Application does not load any files that correspond to a file type in this list.

Input Types

Return Types

Example

--------------EXAMPLE 1----------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelBlockedFileType | format-table

This example returns a list of file extensions that currently cannot be loaded by using Excel Services Application, and then formats the result in a table.

See also

New-SPExcelBlockedFileType
Remove-SPExcelBlockedFileType


Get-SPExcelDataConnectionLibrary
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a trusted data connection library or a list of trusted data connection libraries.

Get-SPExcelDataConnectionLibrary [[-Identity] <SPExcelDCLPipeBind>] -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelDCLPipeBind

Specifies the DataConnectionLibrary object to return. If the identity parameter is not specified, this cmdlet returns all the data connection libraries that have connection files that can be loaded by Excel Services Application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a data connection library (for example, DataConnectionLib1); a valid URL, in the form http://server_name; or an instance of a valid SPExcelDCL object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelDataConnectionLibrary list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPExcelDataConnectionLibrary cmdlet gets a library of data connection files that Excel Services Application and the Excel client use to connect to an external data source. Excel Services Application loads data connection files only if they are stored in a data connection library that is in the list of trusted data connection libraries.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelserviceapplication -Identity "MyExcelService" | Get-SPExcelDataConnectionLibrary

This example displays all the data connection libraries that connection files can be loaded by an Excel Services Application Web service application.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelserviceapplication -identity "MyExcelService" | Get-SPExcelDataConnectionLibrary | where {$_.Description.Contains("Sales Cube")}

This example displays all the data connection libraries that have descriptions containing the words Sales Cube from the specified Excel Services Application Web service application.

See also

New-SPExcelDataConnectionLibrary
Remove-SPExcelDataConnectionLibrary
Set-SPExcelDataConnectionLibrary


Get-SPExcelDataProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a safe data provider or a list of safe data providers.

Get-SPExcelDataProvider -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelDataProvider list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPExcelDataProvider cmdlet reads a safe data provider or a list of safe data providers for an Excel Services Application. Excel Services Application refreshes external data connections only if the data provider for the connection is on the list of safe data providers. Excel Services Application includes a set of common data providers on this list. Therefore, using cmdlets to modify safe data providers is typically done only in custom data connection scenarios.

Input Types

Return Types

Example

---------------------EXAMPLE---------------------

Copy code
Get-SPExcelServiceApplication -Identity "ExcelServices" | Get-SPExcelDataProvider | where {$_.ProviderID -eq "SQLOLEDB"}

This example displays the data provider with the provider identifier (ID) SQLOLEDB from the list of data providers that is on the MyExcelService application. To select a specific provider from the list of safe providers, you must pipe a where clause that can filter the list of providers.

--------------EXAMPLE--------------

Copy code
Get-SPExcelDataProvider -ExcelServiceApplication "Excel Services" | format-table

This example displays a list of safe data providers for the specific Excel Services Application Web service application, and then formats the results of the data providers in a table.

See also

New-SPExcelDataProvider
Remove-SPExcelDataProvider
Set-SPExcelDataProvider


Get-SPExcelFileLocation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a trusted file location or a list of trusted file locations.

Get-SPExcelFileLocation [[-Identity] <SPExcelFileLocationPipeBind>] -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelFileLocationPipeBind

Specifies the SPExcelFileLocation object to return. If the Identity parameter is not specified, the cmdlet returns all the file locations in the specified. Excel Services Application Web service application.

The type must be a valid string that identifies the file location, in the form http://myPortal/myTeam; a valid string that identifies the path, in the form C:\folder_name; a valid UNC path to a trusted location in the form, \\computer_name\share; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPExcelFileLocation object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelFileLocation list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPExcelFileLocation cmdlet gets locations from which Excel Services Application loads workbooks. Excel Services Application loads only workbooks that are stored in a trusted file location. Properties of trusted file locations control how workbooks can be used when loaded by Excel Services Application. Excel Services Application always enforces the properties that are defined by the trusted file location from which a workbook was loaded. The properties of the trusted file location to use are determined through comparison of the file path for the workbook with the address of the trusted file location.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelFileLocation

This example displays a list of trusted file locations for the Excel Services Application Web service application named MyExcelService.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelFileLocation | Format-list *

This example displays a list of trusted file locations for the Excel Services Application Web service application named MyExcelService, and then formats the list of properties into a table.

--------------EXAMPLE 3--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelFileLocation | where {$_.ExternalDataAllowed -ne "None"}

This example displays a list of trusted file locations that allow external data connectivity for the Excel Services Application Web service application named MyExcelService.

See also

New-SPExcelFileLocation
Remove-SPExcelFileLocation
Set-SPExcelFileLocation


Get-SPExcelServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns an SPExcelServiceApplication object.

Get-SPExcelServiceApplication [[-Identity] <SPExcelServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the ExcelServiceApplication object to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPExcelServiceApplication cmdlet retrieves an SPExcelServiceApplication object. If the object returned by this cmdlet is changed, the change affects all instances of the specified Excel Services Application Web service application in the farm.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelServiceApplication "MyExcelServices"

This example displays the Excel Services Application Web service application named MyExcelServices.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication

This example displays every Excel Services Application Web service application that runs in the farm.

--------------EXAMPLE 3--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | format-list *

This example displays Excel Services Application Web service application named MyExcelService, and then displays all of its settings in a list format.

See also

New-SPExcelServiceApplication
Set-SPExcelServiceApplication


Get-SPExcelUserDefinedFunction
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a user-defined function or a collection of user-defined functions.

Get-SPExcelUserDefinedFunction [[-Identity] <SPExcelUDFPipeBind>] -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelUDFPipeBind

Specifies the UserDefinedFunction object to get. If the Identity parameter is not specified, the cmdlet returns all of the functions in the user defined functions list.

The type must be a valid name of the code assembly (for example, SampleCompany.SampleApplication.SampleUdf); or an instance of a valid SPExcelUDF object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelUserDefinedFunction list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPExcelUserDefinedFunction cmdlet reads a user-defined function and its properties, or returns the collection of user-defined functions for an Excel Services Application Web service application. Excel Services Application uses only user-defined functions that are in the list of user-defined functions. User-defined functions are managed code assemblies that can be called from an Excel Services Application workbook by using standard Excel Services Application formula syntax. The assemblies can perform custom logic or other actions, such as refreshing data. Windows PowerShell cmdlets operate on the entries in the user-defined function list, but do not operate on the assemblies.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelUserDefinedFunction -Identity SampleCompany.SampleApplication.SampleUdf

This example displays the user-defined function named SampleCompany.SampleApplication.SampleUdf from the list of user-defined functions that is in the Excel Services Application Web service application named MyExcelService.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication | Get-SPExcelUserDefinedFunction | format-list

This example displays every user-defined function for every Excel Services Application Web service application in the farm, and then displays the results in a list.

See also

New-SPExcelUserDefinedFunction
Remove-SPExcelUserDefinedFunction
Set-SPExcelUserDefinedFunction


New-SPExcelBlockedFileType
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a file type to the list of file types that Excel Services Application prevents from loading.

New-SPExcelBlockedFileType -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> -FileType <XLSX | XLSB | XLSM> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPBlockedExcelFileType list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

FileType

Required

Microsoft.Office.Excel.Server.FileType

Specifies the file types that are blocked from loading.

The type must be one of the following file extensions: XLSX, XLSB, or XLSM.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPExcelBlockedExcelFileType cmdlet adds an entry to the list of file types that Excel Services Application prevents from loading. Excel Services Application does not load any files that correspond to a file type that is on this list. The specified file type is prevented from loading by all instances of Excel Services Application for the specified Excel Services Application Web service application.

Input Types

Return Types

Example

--------------EXAMPLE--------------

Copy code
Get-SPExcelServiceApplication -identity "MyExcelService" | New-SPExcelBlockedExcelFileType -FileType XLSM

This example adds an entry for XLSM to the list of file types that Excel Services Application currently prevents from loading.

See also

Get-SPExcelBlockedFileType
Remove-SPExcelBlockedFileType


New-SPExcelDataConnectionLibrary
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a new data connection library to Excel Services Application.

New-SPExcelDataConnectionLibrary -Address <String> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Address

Required

System.String

Specifies the address of the data connection library. The address must be unique in the list of trusted data connection libraries.

The type must be a valid URL, in the form http://server_name.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelDataConnectionLibrary list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies a friendly description for the data connection library.

The type must be a valid string; for example, this is a custom OLEDB provider.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPExcelDataConnectionLibrary cmdlet adds a data connection library to the list of trusted data connection libraries for an Excel Services Application Web service application. Excel Services Application loads only data connection files that are stored in a data connection library that is on the list of trusted data connection libraries. Data connection libraries contain data connection files, which contain all the resources that Excel Services Application and the Excel client require to connect to an external data source. Data connection libraries enable you to reuse and share data connections. Data connections can be loaded by using information from the workbook file; however, using a data connection library to load data connections allows data connections to be managed separately from workbooks.

Input Types

Return Types

Example

--------------EXAMPLE----------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | New-SPExcelDataConnectionLibrary -address "http://portal/site/salesDCL" -description "This is the DCL where all the connections to the sales data are stored."

This example adds a new data connection library (DCL), and then sets its description to the list of trusted data connection libraries that is in the Excel Services Application Web service application named MyExcelService.

Workbooks can use connection files stored in that library to refresh data on the Excel Services Application Web service application.

See also

Get-SPExcelDataConnectionLibrary
Remove-SPExcelDataConnectionLibrary
Set-SPExcelDataConnectionLibrary


New-SPExcelDataProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a new safe data provider to Excel Services Application.

New-SPExcelDataProvider -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> -ProviderId <String> -ProviderType <Oledb | Odbc | OdbcDsn> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelDataProvider list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

ProviderId

Required

System.String

Specifies the name of the provider. This ID should be present in the connection strings generated by this provider and the ID must be unique for the provider type.

The type must be a valid name of a provider; for example CustomOLEDB.

ProviderType

Required

Microsoft.Office.Excel.Server.DataProviderType

Specifies the supported type of data provider to add to safe provider list.

The type must be one of the following: OleDb, Odbc, or OdbcDsn.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies a friendly description for the new data provider.

The type must be a valid string; for example, "This is a custom OLEDB provider".

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPExcelDataProvider cmdlet adds a data provider to the list of safe data providers in an Excel Services Application Web service application. Excel Services Application refreshes external data connections only if the data provider for a connection is on the list of safe data providers. Excel Services Application includes a set of common data providers on this list. Therefore, using cmdlets to modify safe data providers typically occurs only in custom data connection scenarios.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelServiceApplication -identity "MyExcelService" | New-SPExcelDataProvider -providerID "CustomOLEDB" -ProviderType OleDb -description "This is a custom OLEDB provider"

This example adds a new custom OLEDB data provider to the list of safe data providers for the Excel Services Application Web service application named MyExcelService.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication | New-SPExcelDataProvider -providerID "CustomOLEDB" -ProviderType OleDb -description "This is a custom OLEDB provider"

This example adds a new custom OLEDB data provider to the list of safe data providers for all Excel Services Application Web service application in the farm.

See also

Get-SPExcelDataProvider
Remove-SPExcelDataProvider
Set-SPExcelDataProvider


New-SPExcelFileLocation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a new trusted location to Excel Services Application.

New-SPExcelFileLocation -Address <String> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AbortOnRefreshOnOpenFail <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-AutomaticVolatileFunctionCacheLifetime <Int32>] [-ChartAndImageSizeMax <Int32>] [-ChartRenderDurationMax <Int32>] [-ConcurrentDataRequestsPerSessionMax <Int32>] [-Confirm [<SwitchParameter>]] [-DefaultWorkbookCalcMode <File | Manual | Auto | AutoDataTables>] [-Description <String>] [-DisplayGranularExtDataErrors <SwitchParameter>] [-ExternalDataAllowed <None | Dcl | DclAndEmbedded>] [-IncludeChildren <SwitchParameter>] [-LocationType <SharePoint | Unc | Http>] [-ManualExtDataCacheLifetime <Int32>] [-NewWorkbookSessionTimeout <Int32>] [-PeriodicExtDataCacheLifetime <Int32>] [-RequestDurationMax <Int32>] [-RESTExternalDataAllowed <SwitchParameter>] [-SessionTimeout <Int32>] [-ShortSessionTimeout <Int32>] [-UdfsAllowed <SwitchParameter>] [-WarnOnDataRefresh <SwitchParameter>] [-WhatIf [<SwitchParameter>]] [-WorkbookSizeMax <Int32>]

Parameters

Parameter Required Type Description

Address

Required

System.String

Specifies a Web folder, or file directory from which Excel Services Application can load workbooks.

The type must be a valid URL, in the form http://myPortal/myTeam; or a valid UNC path in form, \\server_name\folder_name

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelFileLocation list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AbortOnRefreshOnOpenFail

Optional

System.Management.Automation.SwitchParameter

Specifies that the loading of a Excel Services Application file automatically fails if an automatic data refresh operation fails when the file is opened. The load is failed only if the following conditions are true:

- The user has SharePoint Product and Technologies read-only permissions to the file.

- The workbook file has data connections that are refreshed automatically when the Excel Services Application file is opened.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AutomaticVolatileFunctionCacheLifetime

Optional

System.Int32

Specifies the maximum time, in seconds, that a computed value for a volatile function is cached for automatic recalculations. Valid values include:

-1 Calculates once when the workbook loads.

0 Always calculates.

1 to 2073600 Caches 1 second to 24 days. The default integer value is 300.

The type must be the integers -1 or 0, or an integer value in the range of 1 to 2073600.

ChartAndImageSizeMax

Optional

System.Int32

Specifies the maximum size, in megabytes, of a chart or image that can be opened. The default value is 1.

The type must be a valid integer greater than 0.

ConcurrentDataRequestsPerSessionMax

Optional

System.Int32

Specifies the maximum number of concurrent external data requests allowed in each session. If a session must issue more than this number of requests, additional requests must be queued. The scope of this setting is the logical server. The default value is 5.

The type must be a positive integer.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultWorkbookCalcMode

Optional

Microsoft.Office.Excel.Server.DefaultWorkbookCalcMode

Specifies the calculation mode of workbooks. Settings other than File override the workbook settings. The default setting is File.

The type must be one of the following: File, Manual, Auto, or AutoDataTables.

Description

Optional

System.String

Specifies a friendly description for the new file location.

The type must be a valid string; for example, this is the file location of the monthly sales reports.

DisplayGranularExtDataErrors

Optional

System.Management.Automation.SwitchParameter

Displays granular error messages for external data failures for files in this location.

ExternalDataAllowed

Optional

Microsoft.Office.Excel.Server.AllowExternalData

Specifies the type of external data access allowed for workbooks.None specifies that data refresh is disabled. Dcl specifies that data is refreshed only when it uses a connection file in a trusted data connection library. DclandEmbedded specifies that a data connection library can be used but is not required. The scope of this setting is the trusted location. The default value is None.

The type must be any of the following settings:

None

Dcl

DclAndEmbedded

IncludeChildren

Optional

System.Management.Automation.SwitchParameter

Indicates that subordinate URLs, directories and libraries are trusted. For example, if the trusted file location is http://portal, and IncludeChildren is true, http://portal/subSite is also trusted, as is any URL subordinate to the URL specified in Address.

LocationType

Optional

Microsoft.Office.Excel.Server.LocationType

Specifies the type of location. Location type indicates how Excel Services Application retrieves files from the location specified in Address. The default setting is the SharePoint type. The default value is SharePoint.

The type must be one of the following: SharePoint, UNC, or HTTP.

ManualExtDataCacheLifetime

Optional

System.Int32

Specifies the time, in seconds, that Excel Services Application waits before it re-issues a manual, or user-initiated, external data request. During this time period, the results from the previous external data request can be returned from an external data cache. The default value is 300.

The valid values are any one of the following items:

-1 Never refresh after first query.1 to 2073600- Caches 1 second to 24 days.

NewWorkbookSessionTimeout

Optional

System.Int32

Specifies the time, in seconds, that a session for a new, unsaved, workbook remains active on Excel Services Application with no user activity. Valid values include the following:

-1 Session never expires.

0 Session expires at the end of a single request.

1 to 2073600 Remains active 1 second to 24 days. The default value is 1800.

The type must be -1, 0, or an integer in the range of 1 to 2073600.

PeriodicExtDataCacheLifetime

Optional

System.Int32

Specifies the time, in seconds, that Excel Services Application waits before it re-issues an on-open or periodic (that is, automatic) external data request. During this time period, the results from the previous external data request can be returned from an external data cache. A value of -1 specifies never to refresh after the first query. The default value is 300.

The type must be -1, 0, or integer in the range of 1 to 2073600.

RequestDurationMax

Optional

System.Int32

Specifies the maximum duration, in seconds, for a single request in a session. After this time elapses, the request times out. The default value is 300.

The type must be -1 (no limit) or an integer in the range of 1 to 2073600.

RESTExternalDataAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies whether requests from the Representational State Transfer (REST) Application Programming Interface (API) are permitted to refresh external data connections. The RESTExternalDataAllowed parameter has no effect if ExternalDataAllowed parameter is set to None.

SessionTimeout

Optional

System.Int32

Specifies the time, in seconds, that a session remains active on Excel Services Application with no user activity. Valid values include the following:

-1 Session never expires.

0 session expires at the end of a single request.

1 to 2073600 Remains active 1 second to 24 days. The default value is 300.

The type must be -1, 0, or an integer in the range of 1 to 2073600.

ShortSessionTimeout

Optional

System.Int32

Specifies the time, in seconds, that a user has to make the initial interaction with a spreadsheet. After this time has elapsed, if the user is not active, the session is closed. The value must always be less than SessionTimeout. If the ShortSessionTimeout value is greater than or equal to SessionTimeout, an error is returned. The default value is 75.

The type must be -1 or an integer in the range of 1 to 2073600.

UdfsAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies that user-defined functions can be called by workbooks that are loaded from the trusted file location that is specified in Address.

The default value is False.

WarnOnDataRefresh

Optional

System.Management.Automation.SwitchParameter

Specifies that a warning is displayed to the user on the first refresh of data for the workbook. The default value is True.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WorkbookSizeMax

Optional

System.Int32

Specifies the maximum size, in megabytes, of a workbook that can be loaded. The default value is 10.

The type must be an integer value in the range of 1 to 2000.

Detailed Description

The New-SPExcelFileLocation cmdlet adds a new location to the list of trusted file locations in an Excel Services Application Web service application. Excel Services Application loads only workbooks that are stored in a trusted file location. Properties of trusted file locations control how workbooks can be used when loaded on Excel Services Application. Excel Services Application always enforces the properties defined by the trusted file location from which a workbook was loaded. The properties that the trusted file location uses are determined through comparison of the file path for the workbook with the Address parameter of the trusted file location.

The longest match takes precedence. For example, if http://portal/site/ and http://portal/site/subsite are trusted locations, and you load a workbook from the subsite, the application uses the properties from the subsite trusted location because it has the longest matching address.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelServiceApplication -identity "MyExcelService" | New-SPExcelFileLocation -address "http://myPortal/myTeam" -includechildren -locationType SharePoint -description "This is my team's site on myPortal." -workbooksizemax 50 -externaldataallowed DclAndEmbedded -WarnOnDataRefresh:$false

This example adds a new trusted file location to the list of trusted file locations that is in the Excel Services Application Web service application named MyExcelService.

This example enables workbooks to load from any child or subfolder that starts with http://myPortal/myTeam. All workbooks loaded from this location must be smaller than 50 megabytes (MB) in size. The workbooks can refresh external data by using connections that are embedded in the workbook file or stored in a data connection library. A warning message that the workbook is attempting to refresh external data will not be displayed.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication -identity "MyExcelService" | New-SPExcelFileLocation -address http://myPortal/myTeam/managers -locationType SharePoint -description "This is the manager's subsite for myTeam."

This example adds a new trusted file location to the list of trusted file locations that is in the Excel Services Application Web service application named MyExcelService with a given address and description.

See also

Get-SPExcelFileLocation
Remove-SPExcelFileLocation
Set-SPExcelFileLocation


New-SPExcelServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new instance of Excel Services Application.

New-SPExcelServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CachingOfUnusedFilesEnable <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-CrossDomainAccessAllowed <SwitchParameter>] [-Default <SwitchParameter>] [-EncryptedUserConnectionRequired <None | Connection>] [-ExternalDataConnectionLifetime <Int32>] [-FileAccessMethod <UseImpersonation | UseFileAccessAccount>] [-LoadBalancingScheme <WorkbookUrl | RoundRobin | Local>] [-MemoryCacheThreshold <Int32>] [-Name <String>] [-PrivateBytesMax <Int32>] [-SessionsPerUserMax <Int32>] [-SiteCollectionAnonymousSessionsMax <Int32>] [-TerminateProcessOnAccessViolation <SwitchParameter>] [-ThrottleAccessViolationsPerSiteCollection <Int32>] [-UnattendedAccountApplicationId <String>] [-UnusedObjectAgeMax <Int32>] [-WhatIf [<SwitchParameter>]] [-WorkbookCache <String>] [-WorkbookCacheSizeMax <Int32>]

Parameters

Parameter Required Type Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS application pool to run the Web service in for the new Excel Service application.

The type must be a valid SPIisWebServiceApplicationPool object.

Name

Required

System.String

Specifies a friendly name for the new Excel Services Application Web service application. The name that you use must be a unique name of an Excel Services Application Web service application that is in this farm. The name can be a maximum of 128 characters. The default value is Service_numofapplications+1.

The type must be a valid string; for example, MyExcelServiceApp1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CachingOfUnusedFilesEnable

Optional

System.Management.Automation.SwitchParameter

Specifies that files that are no longer used by Excel Services Application can remain in the cache for later use. The default is true when the parameter is not specified on the command.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CrossDomainAccessAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies that trusted workbooks and data connection files can be requested and rendered by Web Parts or pages that reside in other HTTP domains.

Default

Optional

System.Management.Automation.SwitchParameter

Specifies that the proxy for this service application is added to the default proxy group of the farm.

EncryptedUserConnectionRequired

Optional

Microsoft.Office.Excel.Server.EncryptedConnectionMode

Requires that encryption is used between the end user and the Excel Services Application server. The scope of this setting is the logical server. The default value is None.

The type must be one of the following: None or Connection.

ExternalDataConnectionLifetime

Optional

System.Int32

Specifies the maximum number of seconds that an external data connection can remain open in the connection pool. Valid values include:

-1 Never recycle

1 to 2073600 Remain active 1 second to 24 days.

The default value is 1800.

FileAccessMethod

Optional

Microsoft.Office.Excel.Server.FileAccessMethod

Specifies the authentication method that Excel Services Application uses to retrieve files. UseFileAccessAccount specifies that all workbooks always use the credentials of the service account running Excel Services Application. UseImpersonation specifies that Excel Services Application retrieves the workbook files as the user who is making the request. The default value is UseImpersonation.

The type must be one of the following: UseImpersonation or UseFileAccessAccount.

LoadBalancingScheme

Optional

Microsoft.Office.Excel.Server.LoadBalancingScheme

Specifies the load-balancing schema that is used by the Excel Services Application Web service application for sending requests to different back-end computers that are running Excel Calculation Services. The default value is WorkbookURL.

The type must be one of the following: RoundRobin, Local, or WorkbookURL.

MemoryCacheThreshold

Optional

System.Int32

Specifies the percentage of the maximum private bytes that can be allocated to inactive objects. When the memory cache threshold is exceeded, cached objects that are not currently in use are released. Setting this value to 0 disables caching of inactive objects. The default value is 90.

The type must be an integer in the range of 0 to 95.

PrivateBytesMax

Optional

System.Int32

Specifies the maximum private bytes, in megabytes, used by Excel Services Application. When set to -1, the maximum private bytes defaults to 50 percent of physical memory on the computer. Valid values include -1 for no limit, and any positive integer. The default value is -1.

The type must be -1 or any positive integer.

SessionsPerUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed for a user. If a user reaches this maximum, the oldest session will be deleted when a new session is started. Valid values include -1 for no limit, and any positive integer. The default value is 25.

The type must be -1 or any positive integer.

SiteCollectionAnonymousSessionsMax

Optional

System.Int32

Specifies the maximum number of anonymous sessions allowed per site collection. A value of 0 specifies that no anonymous sessions are allowed. Valid values include -1 for no limit, 0 to disable the setting, or any positive integer. The default value is 25.

The type must be -1, 0, or any positive integer.

TerminateProcessOnAccessViolation

Optional

System.Management.Automation.SwitchParameter

Terminates Excel Services Application when an access violation occurs in the process.

ThrottleAccessViolationsPerSiteCollection

Optional

System.Int32

Specifies that if a workbook causes an access violation error on Excel Services Application, all files that originate from that workbook's site collection are blocked from loading for the specified period (in seconds). Existing sessions for files on that site collection are unaffected. Valid values include 0 to disable the setting, and the range of 1 to 2073600 seconds (24 days). The default value is 0.

The type must be an integer value in the range of 0 to 2073600.

UnattendedAccountApplicationId

Optional

System.String

Specifies that the application ID that is used to look up the unattended service account credentials from the secure store service specified by UnattendedAccountSecureServiceAppName. The secure store service is contacted when this parameter is set and specific error cases occur. Valid values are alphanumeric strings with a maximum of 256 characters. The default value is an empty string.

The type must be a valid string of alphanumeric characters; for example, UnattendedServiceAccountID.

Note:

The unattended account is a single account that all workbooks can use to refresh data. An unattended account is required when workbook connections specify None for authentication, or when any non-Windows credentials are used to refresh data.

UnusedObjectAgeMax

Optional

System.Int32

Specifies the maximum amount of time, in minutes, that objects not currently used in a session are kept in the memory cache. Valid values include -1 for no maximum setting, and a positive integer in the range of 1 to 34560 minutes (24 days). The default value is -1.

The type must be -1, or an integer in the range of 1 to 34560.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WorkbookCache

Optional

System.String

Specifies the local file system location of the cache that is used for storing workbooks used by Excel Services Application.

If no value is specified, then the default value is a subdirectory in the system temporary directory.

The type must be a valid path in either of the following forms:

-- C:\folder_name

-- \\server_name\folder_name

WorkbookCacheSizeMax

Optional

System.Int32

Specifies the maximum allowable size, in megabytes, of an individual session. The default value is 0.

The type must be any positive integer.

Detailed Description

The New-SPExcelServiceApplication cmdlet creates a new Excel Services Application Web service application with new settings. After you create a new Excel Services Application Web service application, you can use the Set-SPExcelServiceApplication cmdlet to modify the global settings of the new application.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
New-SPExcelServiceApplication -Name "MyExcelService" -ApplicationPool "SharePoint Services"

This example creates a new instance of Excel Services Application with the display name MyExcelService.

--------------EXAMPLE 2--------------

Copy code
New-SPExcelServiceApplication -Name "My Excel Service" -ApplicationPool "SharePoint Services" -SessionsPerUserMax 5

This example creates a new instance of Excel Services Application with the display name My Excel Service and allows only five sessions per user for each back-end application server computer that is running Excel Services Application.

See also

Get-SPExcelServiceApplication
Set-SPExcelServiceApplication


New-SPExcelUserDefinedFunction
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a new user-defined function to Excel Services Application.

New-SPExcelUserDefinedFunction -Assembly <String> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssemblyLocation <GAC | LocalFile>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-Enable <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Assembly

Required

System.String

Specifies the strongly typed name of the assembly. The name must be unique in the list of user-defined functions. The name can be a maximum of 4096 alphanumeric characters.

The type must be a string of alphanumeric characters; for example:

-- SampleCompany.SampleApplication.SampleUdf

-- C:\UDFs\SampleUdf.dll

-- \\MyNetworkServer\UDFs\SampleUdf.dll

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the list of user-defined functions.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssemblyLocation

Optional

Microsoft.Office.Excel.Server.AssemblyLocation

Specifies the location where the assembly is stored. The default value is GAC.

The type must be one of the following: GAC or LocalFile.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies a friendly description for the user-defined function. The name can be a maximum of 4096 alphanumeric characters. The default value is an empty string.

The type must be a valid string of alphanumeric characters; for example, this is the user-defined function for consolidation reports.

Enable

Optional

System.Management.Automation.SwitchParameter

Activates the user-defined function for use with Excel Services Application. The default value is True.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPExcelUserDefinedFunction cmdlet adds a user-defined function to an Excel Services Application Web service application. Excel Services Application uses only user-defined functions that have an entry in the list of user-defined functions. User-defined functions are managed code assemblies that can be called from an Excel Services Application workbook by using standard Excel Services Application formula syntax. The assemblies can perform custom logic or other actions, such as refresh data. Windows PowerShell cmdlets operate on the entries that are in the list of user-defined functions, but they do not operate on the assemblies.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
New-SPExcelUserDefinedFunction -ExcelServiceApplication "MyExcelService" -Assembly "SampleCompany.SampleApplication.SampleUdf" -AssemblyLocation GAC

This example adds the SampleComany.SampleApplication.SampleUdf file to the Excel Services Application Web service application named MyExcelService as a new user-defined function.

The user-defined function assembly is deployed to the global assembly cache (GAC).

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication | New-SPExcelUserDefinedFunction -Assembly "SampleCompany.SampleApplication.SampleUdf" -AssemblyLocation GAC

This example adds the SampleComany.SampleApplication.SampleUdf file to every Excel Services Application Web service application in the farm.

The user-defined function assembly is deployed to the global assembly cache (GAC).

See also

Get-SPExcelUserDefinedFunction
Remove-SPExcelUserDefinedFunction
Set-SPExcelUserDefinedFunction


Remove-SPExcelBlockedFileType
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes an entry from the list of file types that are prevented from loading on Excel Services Application.

Remove-SPExcelBlockedFileType [-Identity] <SPExcelBlockedFileTypePipeBind> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelBlockedFileTypePipeBind

Specifies the file type to remove from the list of blocked file types.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; one of the following file types: XLSX, XLSB, XLSM; or an instance of a valid SPExcelBlockedFileType object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPBlockedExcelFileType list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPExcelBlockedExcelFileType cmdlet removes an entry from the list of file types that are prevented from loading on an Excel Services Application Web service application. Excel Services Application does not load any file types that correspond to a file type that is on this list.

Input Types

Return Types

Example

--------------EXAMPLE----------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Remove-SPExcelBlockedExcelFileType -FileType XLSX

This example removes the .xlsx file name extensions from the list of file types that are prevented from loading by Excel Services Application.

After the .xlsx file name extension is removed from the list, these extensions are allowed to load in Excel Services Application.

See also

Get-SPExcelBlockedFileType
New-SPExcelBlockedFileType


Remove-SPExcelDataConnectionLibrary
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a data connection library from Excel Services Application.

Remove-SPExcelDataConnectionLibrary [-Identity] <SPExcelDCLPipeBind> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelDCLPipeBind

Specifies the data connection library to remove.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a data connection library (for example, DataConnectionLib1); a valid URL, in the form http://server_name; or an instance of a valid SPExcelDCL object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelDataConnectionLibrary list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPExcelDataConnectionLibrary cmdlet removes a library from the Excel Services Application trusted data connection libraries list. Excel Services Application loads data connection files only if they are stored in a data connection library that is on the trusted data connection libraries list.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Remove-SPExcelDataConnectionLibrary -Identity "http://portal/site/salesDCL"

This example removes the http://portal/site/salesDCL library from the list of trusted data connection libraries, which is on the Excel Services Application Web service application named MyExcelService.

Connection files are no longer loaded from this library. Workbooks that depend on this connection file might not refresh data.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication | Get-SPExcelDataConnectionLibrary | Remove-SPExcelDataConnectionLibrary

This example removes all data connection libraries from all Excel Services Application running in the farm.

Connection files are no longer loaded from any libraries. Workbooks that depend on any connection files might not refresh data.

See also

Get-SPExcelDataConnectionLibrary
New-SPExcelDataConnectionLibrary
Set-SPExcelDataConnectionLibrary


Remove-SPExcelDataProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a data provider from Excel Services Application.

Remove-SPExcelDataProvider [-Identity] <SPExcelDataProviderPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelDataProviderPipeBind

Specifies the SPExcelDataProvider object to remove.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, or an instance of a valid SPExcelDataProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPExcelDataProvider cmdlet removes a data provider that is stored on the list of safe data providers. Excel Services Application refreshes external data connections only if the data provider for that connection is on the list of safe data providers. Excel Services Application includes a set of common data providers on this list, so using cmdlets to modify safe data providers is typically done only in custom data connection scenarios.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelDataProvider | where {$_.providerID -eq "SQLOLEDB" } | Remove-SPExcelDataProvider

This example removes the default SQL OLEDB data provider from the list of safe data providers that is on the Excel Services Application Web service application named MyExcelService.

Excel Services Application will no longer refresh any data connections that use this data provider.

--------------EXAMPLE 2--------------

Copy code
$provider = Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelDataProvider | { where {$_.providerID -eq "MyCustomProvider"}
Copy code
Remove-SPExcelDataProvider $provider

This example removes a custom data provider from the list of safe data providers that is on the Excel Services Application Web service application named MyExcelService.

Excel Services Application will no longer refresh any data connections that use this data provider.

See also

Get-SPExcelDataProvider
New-SPExcelDataProvider
Set-SPExcelDataProvider


Remove-SPExcelFileLocation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a trusted file location from Excel Services Application.

Remove-SPExcelFileLocation [-Identity] <SPExcelFileLocationPipeBind> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelFileLocationPipeBind

Specifies the FileLocation object to remove.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid string that identifies the file location, in the form http://myPortal/myTeam; a valid string that identifies the path, in the form C:\folder_name; or an instance of a valid SPExcelFileLocation object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelFileLocation list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPExcelFileLocation cmdlet removes a location from the list of trusted file locations. Excel Services Application loads only workbooks that are stored in a trusted file location. Properties of trusted file locations control how workbooks can be used when loaded on Excel Services Application. Excel Services Application always enforces the properties defined by the trusted file location from which a workbook was loaded. The properties used by the trusted file location are determined by comparing the file path for the workbook with the Address parameter of the trusted file location.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Remove-SPExcelFileLocation -ExcelServiceApplication "My Excel Service" -Identity http://portal/badTeamSite

This example removes the http://portal/badTeamSite from the list of trusted file locations for the Excel Services Application Web service application named My Excel Service.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication | Get-SPExcelFileLocation | where {$_.Address -ne "http://"} | Remove-SPExcelFileLocation

This example removes all nondefault trusted file locations from every Excel Services Application Web service application in the farm.

See also

Get-SPExcelFileLocation
New-SPExcelFileLocation
Set-SPExcelFileLocation


Remove-SPExcelUserDefinedFunction
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a user-defined function from Excel Services Application.

Remove-SPExcelUserDefinedFunction [-Identity] <SPExcelUDFPipeBind> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelUDFPipeBind

Specifies the SPExcelUserDefinedFunction object that you want to remove.

The type must be a valid name of the code assembly (for example, SampleCompany.SampleApplication.SampleUdf); or an instance of a valid SPExcelUDF object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the list of user-defined functions.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPExcelUserDefinedFunction cmdlet removes a user-defined function from the list of user-defined functions. User-defined functions are managed code assemblies that can be called from an Excel Services Application workbook by using standard Excel Services Application formula syntax. The assemblies can perform custom logic or other actions, such as refresh data. The Windows PowerShell cmdlets operate on the entries in the user-defined function list, but do not operate on the assemblies.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Remove-SPExcelUserDefinedFunction -ExcelServiceApplication "My Excel Service" -Identity "SampleCompany.SampleApplication.SampleUdf"

This example removes the SampleCompany.SampleApplication.SampleUdf user-defined function from the list of user-defined functions that is in the Excel Services Application Web service application named MyExcelService.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication | Remove-SPExcelUserDefinedFunction -Identity "SampleCompany.SampleApplication.SampleUdf"

This example removes the SampleCompany.SampleApplication.SampleUdf user-defined function from the list of user-defined functions for every Excel Services Application Web service application in the farm.

See also

Get-SPExcelUserDefinedFunction
New-SPExcelUserDefinedFunction
Set-SPExcelUserDefinedFunction


Set-SPExcelDataConnectionLibrary
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a data connection library for Excel Services Application.

Set-SPExcelDataConnectionLibrary [-Identity] <SPExcelDCLPipeBind> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-Address <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelDCLPipeBind

Specifies the DataConnectionLibrary object to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a data connection library (for example, DataConnectionLib1); a valid URL, in the form http://server_name; or an instance of a valid SPExcelDCL object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains SPExcelDataConnectionLibrary list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

Address

Optional

System.String

Specifies the address of the data connection library. The address must be unique in the list of trusted data connection libraries.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies a friendly description for the data connection library.

The type must a valid a string; for example, "This is the data connection library where all the connections to the sales data are stored".

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPExcelDataConnectionLibrary cmdlet sets the properties of a library from which Excel Services Application loads data connection files. Excel Services Application loads data connection files only if they are stored in a data connection library that is on the list of trusted data connection libraries. Data connection libraries constitute a kind of list that contains data connection files. These files contain everything that Excel Services Application and the Excel client require to connect to an external data source. Data connection libraries enable you to reuse and share data connections. Data connections can be loaded by using information from the workbook file. However, using a data connection library to load data connections provides an additional layer for data connections so that they can be managed separately from workbooks.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelDataConnectionLibrary | where {$_.address -eq "http://portal/site/salesDCL" } | Set-SPExcelDataConnectionLibrary -Description "This is the DCL where all the connections to the sales data are stored

This example sets a display description for the entry http://portal/site/salesDCL in the list of trusted data connection libraries (DCLs) that is on the Excel Services Application Web service application named MyExcelService.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelDataConnectionLibrary | where {$_.address -eq "http://portal/site/salesDCL" } | Set-SPExcelDataConnectionLibrary -Address "http://portal/site/salesDCL

This example updates the address of the data connection library for the entry http://portal/test/site/salesDCL to http://portal/site/salesDCL in the list of trusted data connection libraries, which is on the Excel Services Application Web service application named MyExcelService.

See also

Get-SPExcelDataConnectionLibrary
New-SPExcelDataConnectionLibrary
Remove-SPExcelDataConnectionLibrary


Set-SPExcelDataProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a safe data provider for Excel Services Application.

Set-SPExcelDataProvider [-Identity] <SPExcelDataProviderPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-ProviderId <String>] [-ProviderType <Oledb | Odbc | OdbcDsn>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelDataProviderPipeBind

Specifies the SPExcelDataProvider object to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, or an instance of a valid SPExcelDataProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies a display description for the data provider.

The type must a valid a string; for example, this is a custom OLEDB provider.

ProviderId

Optional

System.String

Specifies the name of the data provider. This ID should be present in the connection strings generated by this data provider, and the ID must be unique for the data provider type.

The type must a valid name of a provider; for example, CustomOLEDB.

ProviderType

Optional

Microsoft.Office.Excel.Server.DataProviderType

Specifies the supported type of the data provider to set.

The type must be one of the following: OleDb, Odbc, or OdbcDsn.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPExcelDataProvider cmdlet sets the properties of a data provider that is stored in the list of safe data providers. Excel Services Application refreshes external data connections only if the data provider for that connection is in the list of safe data providers. Excel Services Application include a set of common data providers in this list. Therefore, using cmdlets to modify safe data providers is typically an operation of custom data connection scenarios.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelDataProvider | where {$_.providerID -eq "SQLOLEDB" } | Set-SPExcelDataProvider -Description "This is the Microsoft SQL OLEDB driver (MDAC)"

This example retrieves the SQLOLEDB data provider from the list of safe data providers that is on the Excel Services Application Web service application named MyExcelService, and then adds a display description.

--------------EXAMPLE 2--------------

Copy code
$provider = Get-SPExcelServiceApplication -Identity "MyExcelService" | Get-SPExcelDataProvider | where {$_.providerID -eq "SQLOLEDB" }
Copy code
Set-SPExcelDataProvider $provider -Description "The SQLOLEDB provider description has changed."
Copy code
$provider | format-table

This example retrieves the SQLOLEDB data provider from the list of safe data providers that is on the Excel Services Application Web service application named MyExcelService, as an object, adds a new display description, and then displays the provider output in a Command Prompt window, formatted as a table.

See also

Get-SPExcelDataProvider
Remove-SPExcelDataProvider
Set-SPExcelDataProvider


Set-SPExcelFileLocation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a trusted file location for Excel Services Application.

Set-SPExcelFileLocation [-Identity] <SPExcelFileLocationPipeBind> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-AbortOnRefreshOnOpenFail <SwitchParameter>] [-Address <String>] [-AssignmentCollection <SPAssignmentCollection>] [-AutomaticVolatileFunctionCacheLifetime <Int32>] [-ChartAndImageSizeMax <Int32>] [-ChartRenderDurationMax <Int32>] [-ConcurrentDataRequestsPerSessionMax <Int32>] [-Confirm [<SwitchParameter>]] [-DefaultWorkbookCalcMode <File | Manual | Auto | AutoDataTables>] [-Description <String>] [-DisplayGranularExtDataErrors <SwitchParameter>] [-ExternalDataAllowed <None | Dcl | DclAndEmbedded>] [-IncludeChildren <SwitchParameter>] [-LocationType <SharePoint | Unc | Http>] [-ManualExtDataCacheLifetime <Int32>] [-NewWorkbookSessionTimeout <Int32>] [-PeriodicExtDataCacheLifetime <Int32>] [-RequestDurationMax <Int32>] [-RESTExternalDataAllowed <SwitchParameter>] [-SessionTimeout <Int32>] [-ShortSessionTimeout <Int32>] [-UdfsAllowed <SwitchParameter>] [-WarnOnDataRefresh <SwitchParameter>] [-WhatIf [<SwitchParameter>]] [-WorkbookSizeMax <Int32>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelFileLocationPipeBind

Specifies the FileLocation object to update. The name must be unique in the list of file locations.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid string identifying the file location, in the form http://myPortal/myTeam; a valid string identifying the path, in the form C:\folder_name; or an instance of a valid SPExcelFileLocation object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelFileLocation list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AbortOnRefreshOnOpenFail

Optional

System.Management.Automation.SwitchParameter

Specifies that the load of a Excel Services Application file automatically fails if an automatic data refresh operation fails when the file is opened. The load is failed only if the following conditions are true:

-- User has read-only permissions to the Excel Services Application file.

-- Workbook file has data connections that refresh automatically when the Excel file is opened.

Address

Optional

System.String

Specifies a Web folder, or file directory from which Excel Services Application can load workbooks.

The type must be a valid URL, in the form http://myPortal/myTeam; or a valid UNC path in form, \\server_name\folder_name

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AutomaticVolatileFunctionCacheLifetime

Optional

System.Int32

Specifies the maximum time, in seconds, that a computed value for a volatile function is cached for automatic recalculations. Valid values include:

-1, calculate once when the workbook loads

0, always calculate

1 to 2073600, cache 1 second to 24 days

The type must be the integers -1 or 0, or an integer value in the range of 1 to 2073600.

ChartAndImageSizeMax

Optional

System.Int32

Specifies the maximum size, in megabytes, of a chart or image that can be opened. The default value is 1.

The type must be a valid integer greater than 0.

ConcurrentDataRequestsPerSessionMax

Optional

System.Int32

Specifies the maximum number of concurrent external data requests allowed in each session. If a session must issue more than this number of requests, additional requests must be queued. The scope of this setting is the logical server. The default value is 5.

The type must be a positive integer.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultWorkbookCalcMode

Optional

Microsoft.Office.Excel.Server.DefaultWorkbookCalcMode

Specifies the calculation mode of workbooks. All of the settings except the File setting override the workbook settings. If this parameter is changed, it is applied to all new sessions on Excel Services Application when the ConfigDB properties cache is refreshed. The default setting is File.

The type must be one of the following: File, Manual, Auto, or AutoDataTables.

Description

Optional

System.String

Specifies a friendly description for the new file location.

The type must be a valid string; for example, this is the file location of the monthly sales reports.

DisplayGranularExtDataErrors

Optional

System.Management.Automation.SwitchParameter

Displays granular error messages for external data failures for files in this location.

ExternalDataAllowed

Optional

Microsoft.Office.Excel.Server.AllowExternalData

Specifies the type of external data access allowed for workbooks:None specifies that data refresh is disabled. Dcl specifies that data is refreshed only when it uses a connection file in a trusted data connection library. DclandEmbedded specifies that a data connection library can be used but is not required. The scope of this setting is the trusted location.

The default value is None.

The type must be one of the following: None, Dcl, or DclAndEmbedded.

IncludeChildren

Optional

System.Management.Automation.SwitchParameter

Indicates that subordinate URLs, directories and libraries are trusted. For example, if the trusted file location is http://portal, and IncludeChildren is true, then http://portal/subSite is also trusted, as is any subURL under the URL specified in Address.

LocationType

Optional

Microsoft.Office.Excel.Server.LocationType

The type of location. LocationType indicates how Excel Services Application retrieves files from that location specified in Address. The default value is SharePoint.

The type must be one of the following: SharePoint, UNC, or HTTP.

ManualExtDataCacheLifetime

Optional

System.Int32

Specifies the time, in seconds, that Excel Services Application waits before re-issuing a manual, or user-initiated, external data request. During this period, the results from the previous external data request may be returned from an external data cache.

Valid values are:

-1 Never refresh after first query

1 to 2073600 Caches 1 second to 24 days.

The default value is 300.

NewWorkbookSessionTimeout

Optional

System.Int32

Specifies the time, in seconds, that a session for a new, unsaved, workbook will remain active on Excel Services Application with no user activity. The default value 1800. Valid values include the following:

-1, session never expires

0, session expires at the end of a single request

1 to 2073600, remain active 1 second to 24 days.

The type must be -1, 0, or an integer in the range of 1 to 2073600.

PeriodicExtDataCacheLifetime

Optional

System.Int32

Specifies the time, in seconds, that Excel Services Application waits before re-issuing an on-open or periodic (that is, automatic) external data request. During this period, the results from the previous external data request may be returned from an external data cache. A value -1 specifies to never refresh after the first query.

The type must be -1, 0, or an integer in the range of 1 to 2073600.

The default value is 300.

RequestDurationMax

Optional

System.Int32

Specifies the maximum duration, in seconds, for a single request in a session. After this time elapses the request is timed out.

The type must be -1 (no limit) or an integer in the range of 1 to 2073600.

The default value is 300.

RESTExternalDataAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies whether requests from the Representational State Transfer (REST) Application Programming Interface (API) are permitted to refresh external data connections.

The RESTExternalDataAllowed parameter has no effect if the External DataAllowed parameter is set to None.

SessionTimeout

Optional

System.Int32

Specifies the time, in seconds, that a session will remain active on Excel Services Application with no user activity. The default is 300 seconds. The default value is 300. Valid values include:

-1, session never expires

0, session expires at the end of a single request

1 to 2073600, remain active 1 second to 24 days

The type must be -1, 0, or an integer in the range of 1 to 2073600.

ShortSessionTimeout

Optional

System.Int32

Specifies the time, in seconds, that a user has to make the initial interaction with a spreadsheet. After this time has elapsed, if the user is not active, then the session is closed. The value must always be less than SessionTimeout. If the ShortSessionTimeout value is greater than or equal to SessionTimeout, an error is returned. The default value is 75.

The type must be -1 or an integer in the range of 1 to 2073600.

UdfsAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies that user-defined functions can be called by workbooks loaded from the trusted file location that is specified in Address.

WarnOnDataRefresh

Optional

System.Management.Automation.SwitchParameter

Specifies that a warning is displayed to the user on the first refresh of data for the workbook. The default value is True.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WorkbookSizeMax

Optional

System.Int32

Specifies the maximum size, in megabytes, of a workbook that can be loaded. The default value is 10.

The type must be an integer value in the range of 1 to 2000.

Detailed Description

The Set-SPExcelFileLocation cmdlet sets properties of a location from which Excel Services Application loads workbooks. Excel Services Application loads only workbooks that are stored in a trusted file location. Properties of trusted file locations control how workbooks can be used when they are loaded on Excel Services Application. Excel Services Application always enforces the properties that are defined by the trusted file location from which a workbook was loaded. The properties that are used by the trusted file location are determined by comparison of the file path for the workbook with the Address parameter of the trusted file location.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Get-SPExcelFileLocation -ExcelServiceApplication "My Excel Service" | where { $_.externaldataallowed -eq "DclAndEmbedded"} | Set-SPExcelFileLocation -ExernalDataAllowed Dcl

This example gets every trusted file location for the Excel Services Application Web service application named My Excel Service that allows data connections to load from workbook files and specifies that the locations must use a data connection library to load data connections.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication | Get-SPExcelFileLocation | where {$_.Address -eq "http://"} | Set-SPExcelFileLocation -Description "This is the default trusted file location for Excel Services Application. It allows any file from anywhere in SharePoint to load."

This example changes the description of the default file location for every Excel Services Application Web service application in the farm.

See also

Get-SPExcelFileLocation
New-SPExcelFileLocation
Remove-SPExcelFileLocation


Set-SPExcelServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets global properties for Excel Services Application.

Set-SPExcelServiceApplication [[-Identity] <SPExcelServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-CachingOfUnusedFilesEnable <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-CrossDomainAccessAllowed <SwitchParameter>] [-EncryptedUserConnectionRequired <None | Connection>] [-ExternalDataConnectionLifetime <Int32>] [-FileAccessMethod <UseImpersonation | UseFileAccessAccount>] [-LoadBalancingScheme <WorkbookUrl | RoundRobin | Local>] [-MemoryCacheThreshold <Int32>] [-PrivateBytesMax <Int32>] [-SessionsPerUserMax <Int32>] [-SiteCollectionAnonymousSessionsMax <Int32>] [-TerminateProcessOnAccessViolation <SwitchParameter>] [-ThrottleAccessViolationsPerSiteCollection <Int32>] [-UnattendedAccountApplicationId <String>] [-UnusedObjectAgeMax <Int32>] [-WhatIf [<SwitchParameter>]] [-WorkbookCache <String>] [-WorkbookCacheSizeMax <Int32>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the SPExcelServiceApplication object to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CachingOfUnusedFilesEnable

Optional

System.Management.Automation.SwitchParameter

Specifies that files that are no longer used by Excel Services Application can remain in the cache for later use. The default is true when the parameter is not specified on the command.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CrossDomainAccessAllowed

Optional

System.Management.Automation.SwitchParameter

Specifies that trusted workbooks and data connection files can be requested and rendered by Web Parts or pages that reside in other HTTP domains.

EncryptedUserConnectionRequired

Optional

Microsoft.Office.Excel.Server.EncryptedConnectionMode

Requires that encryption is used between the end-user and the server running Excel Services Application. The scope of this setting is the logical server. The default value is None.

The type must be one of the following: None or Connection.

ExternalDataConnectionLifetime

Optional

System.Int32

Specifies the maximum number of seconds that an external data connection can remain open in the connection pool.

Valid values are:

-1 Never recycle

1 to 2073600 Remain active 1 second to 24 days.

The default value is 1800.

FileAccessMethod

Optional

Microsoft.Office.Excel.Server.FileAccessMethod

Specifies the authentication method that Excel Services Application uses to retrieve files. UseFileAccessAccount specifies that all workbooks always use the credentials of the service account running Excel Services Application. UseImpersonation specifies that Excel Services Application retrieves the workbook files as the user who makes the request. The default value is UseImpersonation.

The type must be one of the following: UseImpersonation or UseFileAccessAccount.

LoadBalancingScheme

Optional

Microsoft.Office.Excel.Server.LoadBalancingScheme

Specifies the load-balancing schema that is used by the Excel Services Application Web service application to send requests to different back-end Excel Services Application computers. The default value is WorkbookURL.

The type must be one of the following: RoundRobin, Local, or WorkbookURL.

MemoryCacheThreshold

Optional

System.Int32

Specifies the percentage of the maximum private bytes that can be allocated to inactive objects. When the memory cache threshold is exceeded, cached objects that are not currently in use are released. Setting this value to 0 disables caching of inactive objects. The default value is 90.

The type must be an integer in the range of 0 to 95.

PrivateBytesMax

Optional

System.Int32

Specifies the maximum private bytes, in megabytes, that are used by Excel Services Application. When set to -1, the maximum private bytes defaults to 50 percent of physical memory on the computer. Valid values include -1 for no limit, and any positive integer. The default value is -1.

The type must be -1 or any positive integer.

SessionsPerUserMax

Optional

System.Int32

Specifies the maximum number of sessions allowed for a user. If a user reaches this maximum the oldest session is deleted when a new session is started. Valid values include -1 for no limit, and any positive integer. The default value is 25.

The type must be -1 or any positive integer.

SiteCollectionAnonymousSessionsMax

Optional

System.Int32

Specifies the maximum number of anonymous sessions allowed per site collection. A value of 0 specifies that no anonymous sessions are allowed. Valid values include -1 for no limit, 0 to disable the setting, or any positive integer. The default value is 25.

The type must be -1, 0, or any positive integer.

TerminateProcessOnAccessViolation

Optional

System.Management.Automation.SwitchParameter

Terminates Excel Services Application when an access violation occurs in the process.

ThrottleAccessViolationsPerSiteCollection

Optional

System.Int32

Specifies that if a workbook causes an access violation error on Excel Services Application, all files originating from that workbook's site collection are blocked from loading for the specified period (in seconds). Existing sessions for files on that site collection are unaffected. Valid values include 0 to disable the setting, and the range of 1 to 2073600 seconds (24 days). The default value is 0.

The type must be an integer value in the range of 0 to 2073600.

UnattendedAccountApplicationId

Optional

System.String

Specifies that the application ID that is used to look up the unattended service account credentials from the secure storage service that is specified by the UnattendedAccountSecureServiceAppName parameter. The secure storage service is contacted when this parameter is set and specific error cases occur. Valid values are alphanumeric strings with a maximum of 256 characters. The default value is an empty string.

The type must be a valid string of alphanumeric characters; for example, UnattendedServiceAccountID.

Note:

The unattended account is a single account that all workbooks can use to refresh data. An unattended account is required when workbook connections specify None for authentication, or when any non-Windows credentials are used to refresh data.

UnusedObjectAgeMax

Optional

System.Int32

Specifies the maximum amount of time, in minutes, that objects not currently used in a session are kept in the memory cache. Valid values include -1 for no maximum setting, and a positive integer in the range of 1 to 34560 minutes (24 days). The default value is -1.

The type must be -1, or an integer in the range of 1 to 34560.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WorkbookCache

Optional

System.String

Specifies the local file system location of the cache that is used to store workbooks that are used by Excel Services Application.

If no value is specified, the default value is a subdirectory in the system temporary directory.

The type must be a valid path in either of the following forms:

-- C:\folder_name

-- \\server_name\folder_name

WorkbookCacheSizeMax

Optional

System.Int32

Specifies the maximum allowable size, in megabytes, of an individual session. The default value is 0.

The type must be any positive integer.

Detailed Description

The Set-ExcelServiceApplication cmdlet changes global runtime properties for Excel Services Application. Changes to properties that are made by using this cmdlet affect all machines in the farm that are running an instance of the specified Excel Services Application Web service application.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Set-SPExcelServiceApplication ExcelServiceTestApplication -sessionsperusermax 10

This example sets the Excel Services Application Web service application named ExcelServiceTestApplication to enable each user to open no more than 10 sessions at one time on a back-end application server that runs Excel Services Application.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication | where{ $_.privatebytesmax -ne -1 } | Set-SPExcelServiceApplication -PrivateBytesMax -1

This example displays every Excel Services Application application that runs in the farm that is using a user-specified value for the maximum number of private bytes of memory on the computer, and then sets that value to -1, which indicates that Excel Services Application will consume 50 percent of the available memory resources.

See also

Get-SPExcelServiceApplication
New-SPExcelServiceApplication


Set-SPExcelUserDefinedFunction
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a user-defined function in Excel Services Application.

Set-SPExcelUserDefinedFunction [-Identity] <SPExcelUDFPipeBind> -ExcelServiceApplication <SPExcelServiceApplicationPipeBind> [-Assembly <String>] [-AssemblyLocation <GAC | LocalFile>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-Enable <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelUDFPipeBind

Specifies the SPExcelUserDefinedFunction object to update.

The type must be a valid name of the code assembly; for example, SampleCompany.SampleApplication.SampleUdf; or an instance of a valid SPExcelUDF object.

ExcelServiceApplication

Required

Microsoft.Office.Excel.Server.Cmdlet.SPExcelServiceApplicationPipeBind

Specifies the Excel Services Application Web service application that contains the SPExcelUserDefinedFunction list object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an Excel Services Application Web service application in the farm (for example, MyExcelService1); or an instance of a valid SPExcelServiceApplication object.

Assembly

Optional

System.String

Specifies the strongly-typed name of the assembly. The name must be unique in the list of user-defined functions, and cannot be more than 4096 alphanumeric characters long.

The type must be a string of alphanumeric characters; for example, SampleCompany.SampleApplication.SampleUdf, C:\UDFs\SampleUdf.dll, or \\MyNetworkServer\UDFs\SampleUdf.dll.

AssemblyLocation

Optional

Microsoft.Office.Excel.Server.AssemblyLocation

Specifies the location where the assembly is stored.

The type must be one of the following: GAC or LocalFile.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies a display description for the user-defined function. The name cannot be more than 4096 alphanumeric characters long.

The type must be a string of alphanumeric characters; for example, this is the user-defined function for consolidation reports.

Enable

Optional

System.Management.Automation.SwitchParameter

Activates the user-defined function for use with Excel Services Application.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPExcelUserDefinedFunction cmdlet sets properties of a user-defined function assembly. Excel Services Application uses only user-defined functions that have an entry in the user-defined function list. User-defined functions are managed code assemblies that can be called from an Excel Services Application workbook by using standard Excel Services Application formula syntax. The assemblies can perform custom logic or other actions, such as refresh data. Windows PowerShell cmdlets operate on the entries in the user-defined function list and do not operate on the assemblies.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Set-SPExcelUserDefinedFunction -ExcelServiceApplication "My Excel Service" -Identity SampleCompany.SampleApplication.SampleUdf -Description "This is the new description for the sample UDF"

This example changes the description of the user-defined function (UDF) to the UDF SampleCompany.SampleApplication.SampleUdf file for the Excel Services Application Web service application named My Excel Service.

--------------EXAMPLE 2--------------

Copy code
Get-SPExcelServiceApplication "My Excel Service" | Set-SPExcelUserDefinedFunction -Identity SampleCompany.SampleApplication.SampleUdf -Enable: $false

This example disables the sample UDF SampleCompany.SampleApplication.SampleUdf file from the Excel Services Application named My Excel Service.

See also

Get-SPExcelUserDefinedFunction
New-SPExcelUserDefinedFunction
Remove-SPExcelUserDefinedFunction


Farm cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you administer a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPFarmConfig | Returns a global property or a collection of global properties for the local farm.
Get-SPProcessAccount | Returns a system account or a managed account.
Get-SPWebTemplate | Displays all globally installed site templates that match the given identity.
New-SPCentralAdministration | Creates a new SharePoint Central Administration web application.
Set-SPCentralAdministration | Sets the port for the SharePoint Central Administration website.
Set-SPFarmConfig | Sets a global property or a collection of global properties for the local farm.
Set-SPPassPhrase | Sets the passphrase to a new value.
Start-SPAdminJob | Immediately starts any waiting administrative job on the local computer.

See also

Windows PowerShell for SharePoint 2013 reference


Get-SPFarmConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a global property or a collection of global properties for the local farm.

Get-SPFarmConfig [-AssignmentCollection <SPAssignmentCollection>] [-ServiceConnectionPoint <SwitchParameter>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ServiceConnectionPoint

Optional

System.Management.Automation.SwitchParameter

Gets the information stored in the current farm's service connection point in Active Directory.

Detailed Description

The Get-SPFarmConfig cmdlet retrieves global settings for the local farm that are not members of the SPFarm object. This cmdlet creates a new PSCustomObject object from the collection of properties returned from the local farm, and then adds this object to the pipeline. The PSCustomObject object can be read, or modified and passed to the Set-SPFarmConfig cmdlet to change parameter values.

The properties collected in the PSCustomObject object must be farm-wide settings, and must be configurable only once for the entire farm. The parameter name added to the PSCustomObject object must match exactly the input parameter name for the Set-SPFarmConfig cmdlet.

Input Types

Return Types

Example

-------------EXAMPLE----------------

Copy code
$a = Get-SPFarmConfig
Copy code
$a.AjaxTimeout = 200
Copy code
$a | Set-SPFarmConfig

This example uses the Get-SPFarmConfig cmdlet to add the Ajax Timeout setting to the PSCustomObject object, sets the value for Ajax Timeout, and then passes PSCustomObject to the Set-SPFarmConfig cmdlet to change the Ajax Timeout setting. Ajax Timeout, a farm-wide setting, is a member of the SPWebService object and cannot be accessed with a Windows PowerShell cmdlet.

You can perform the same operations with either of the following commands.

Copy code
Set-SPFarmConfig -AjaxTimeout 200
Copy code
Get-SPFarmConfig | Select AjaxTimeout 200

See also

Set-SPFarmConfig


Get-SPProcessAccount
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a system account or a managed account.

Get-SPProcessAccount [-AssignmentCollection <SPAssignmentCollection>] [-NetworkService <SwitchParameter>]
Get-SPProcessAccount [-AssignmentCollection <SPAssignmentCollection>] [-LocalSystem <SwitchParameter>]
Get-SPProcessAccount [-AssignmentCollection <SPAssignmentCollection>] [-LocalService <SwitchParameter>]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

NetworkService

Optional

System.Management.Automation.SwitchParameter

Returns the NetworkService account.

2

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

LocalSystem

Optional

System.Management.Automation.SwitchParameter

Returns the LocalSystem account.

3

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

LocalService

Optional

System.Management.Automation.SwitchParameter

Returns the LocalService account.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPProcessAccount cmdlet returns a system account or a managed account and creates the SPProcessAccountPipeBind object. All operations that can accept an account can accept the SPProcessAccountPipeBind in place of the SPManagedAccountPipeBind.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE 1-----------------------

Copy code
Get-SPProcessAccount -NetworkService

This example creates the SPProcessAccountPipeBind type by using the NetworkService account.

------------------EXAMPLE 2-----------------------

Copy code
Get-SPProcessAccount -NetworkService | New-SPServiceApplicationPool -Account $_

This example creates an SPServiceApplicationPool account by using the NetworkService account returned by the Get-SPProcessAccount cmdlet.


Get-SPWebTemplate
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Displays all globally installed site templates that match the given identity.

Get-SPWebTemplate [[-Identity] <SPWebTemplatePipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <UInt32>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the name of the Web template to display.

The type must be the ID or full or partial name of the Web template.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompatibilityLevel

Optional

System.UInt32

Specifies the version of templates to use when creating a new SPSite object. This value sets the initial CompatibilityLevel value for the site collection. The values for this parameter can be either SharePoint Server 2010 or SharePoint Server 2013. When this parameter is not specified, the CompatibilityLevel will default to the highest possible version for the Web application depending on the SiteCreationMode setting

Detailed Description

The Get-SPWebTemplate cmdlet displays all installed site templates that match the full or partial identity that was given.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
$template = Get-SPWebTemplate "STS#0"
Copy code
New-SPSite http://contoso.com -OwnerAlias "DOMAIN\JDOE" -Template $template

This example creates a site collection by using the team site Web template (ID=STS#0).

--------------EXAMPLE 2-----------------

Copy code
Get-SPWebTemplate "STS*"

This example displays basic information about all the STS templates.


New-SPCentralAdministration
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new SharePoint Central Administration Web application.

New-SPCentralAdministration [[-Port] <Int32>] [[-WindowsAuthProvider] <String>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Port

Optional

System.Int32

Specifies the port number for Central Administration. If no port is specified, a nonconflicting port number is auto-generated.

The type must be a valid port number.

Important:

If you specify a port number that has already been assigned, IIS does not start the new site until you change either the port number of the new site or the port number of the old site.

WindowsAuthProvider

Optional

System.String

Specifies the authorization provider for this Web application. If no authentication provider is specified, the default value NTLM is used.

The type must be one of two values: Kerberos, orNTLM.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The New-SPCentralAdministration cmdlet creates a new Central Administration Web application and starts the central administration service on the local computer. Central Administration is available only on computers where this service runs.

Input Types

Return Types

None.

Example

------------------EXAMPLE-----------------------

Copy code
New-SPCentralAdministration -Port 3000

This example creates the Central Administration site at port 3000 on the local farm.

See also

Set-SPCentralAdministration


Set-SPCentralAdministration
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the port for the SharePoint Central Administration Web site.

Set-SPCentralAdministration -Port <Int32> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Port

Required

System.Int32

Specifies the administration port for the Central Administration site.

The type must be a valid port number; for example, 8080.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPCentralAdministration cmdlet sets the port for the Central Administration site.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Set-SPCentralAdministration -Port 8282

This example sets the port for the Central Administration web application on the local farm to 8282.

See also

New-SPCentralAdministration


Set-SPFarmConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets a global property or a collection of global properties for the local farm.

Set-SPFarmConfig [-ASPScriptOptimizationEnabled <$true | $false>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DataFormWebPartAutoRefreshEnabled <$true | $false>] [-Force <SwitchParameter>] [-InstalledProductsRefresh <SwitchParameter>] [-ServiceConnectionPointBindingInformation <String>] [-ServiceConnectionPointDelete <SwitchParameter>] [-UserAccountDirectoryPathIsImmutable <Nullable>] [-WhatIf [<SwitchParameter>]] [-WorkflowBatchSize <Int32>] [-WorkflowEventDeliveryTimeout <Int32>] [-WorkflowPostponeThreshold <Int32>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DataFormWebPartAutoRefreshEnabled

Optional

System.Boolean

Specifies whether any DataFormWebPart on any page in this farm is allowed to periodically refresh its contents asynchronously (after the page has finished rendering). When set to false, all DataFormWebParts will ignore the automatic refresh interval provided in Web Part properties.

Force

Optional

System.Management.Automation.SwitchParameter

Forces the deletion or updating of the service connection point.

InstalledProductsRefresh

Optional

System.Management.Automation.SwitchParameter

Updates the current machine license state with the list of products that are installed in the farm.

ServiceConnectionPointBindingInformation

Optional

System.String

Adds or updates the service connection point for the current farm in Active Directory Domain Service (AD DS).

The type must be an array of strings that are key value pairs that will be added to the service connection point.

ServiceConnectionPointDelete

Optional

System.Management.Automation.SwitchParameter

Delete the service connection point for the current farm in AD DS.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WorkflowBatchSize

Optional

System.Int32

Specifies the paging size for events delivered to a single workflow instance. For each request, the events are streamed out 100 at a time.

Batch size is the number of events processed for a single workflow instance, which can have many events queued at the same time. Throttle will override batch size; if the workflow instance cannot be started or restarted because there are too many instances running across all front-end Web servers, none of the events will be fetched, regardless of the batch size.

WorkflowEventDeliveryTimeout

Optional

System.Int32

Specifies the time as an integer in which a workflow job must run without the job timing out. If the workflow job does time out, it gets put back in the queue to be run again.

For example, if the value is set to 5, the workflow job must run within 5 minutes are the workflow job will time out. Any workflow job that does time out is placed back in the queue to run again.The default value is 5.

WorkflowPostponeThreshold

Optional

System.Int32

Specifies the number of workflows that can be running in IIS against a content database at a time before new workflow instances get postponed into a queue.

Detailed Description

The Set-SPFarmConfig cmdlet updates a collection of global settings for the local farm that are not members of the SPFarm object. Use the Get-SPFarmConfig cmdlet to read global settings for the local farm and to create a new PSCustomObject object from the collection of properties returned from the local farm, and then add this object to the pipeline. Modify the PSCustomObject object and pass it to the Set-SPFarmConfig cmdlet to change the parameter values.

The properties collected in the PSCustomObject object must be farm-wide settings, and must be configurable only once for the entire farm. The parameter name added to the PSCustomObject object must match exactly the input parameter name for the Set-SPFarmConfig cmdlet.

Input Types

Return Types

Example

---------------------EXAMPLE--------------------------

Copy code
$a = Get-SPFarmConfig
Copy code
$a.AjaxTimeout = 200
Copy code
$a | Set-SPFarmConfig

This example uses the Get-SPFarmConfig cmdlet to add the Ajax Timeout setting to the PSCustomObject object, sets the value for Ajax Timeout, and then passes PSCustomObject to the Set-SPFarmConfig cmdlet to change the Ajax Timeout setting. Ajax Timeout, a farm-wide setting, is a member of the SPWebService object and cannot be accessed by using a Windows PowerShell cmdlet.

You can perform the same operations with either of the following commands.

Copy code
Set-SPFarmConfig -AjaxTimeout 200

See also

Get-SPFarmConfig


Set-SPPassPhrase
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the pass phrase to a new value.

Set-SPPassPhrase -ConfirmPassPhrase <SecureString> -PassPhrase <SecureString> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Set-SPPassPhrase -PassPhrase <SecureString> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-LocalServerOnly <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

LocalServerOnly

Optional

System.Management.Automation.SwitchParameter

Scopes the Passphrase change to the local server only. If this parameter is not used, the Passphrase change is performed farm-wide.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPPassPhrase cmdlet sets the Passphrase to a new Passphrase value. If the LocalServerOnly parameter is not used, the farm encryption key is re-encrypted with the new value and attempts to propagate this value to all other servers in the farm. If the LocalServerOnly parameter is used, this is updated on the local machine only, and the farm encryption key is not changed. The Passphrase value must be the same on all servers in the farm if the farm is to function correctly. So if the Passphrase fails to propagate to all servers, the LocalServerOnly parameter can be used to set the remaining servers to the new Passphrase value manually.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
$passphrase = ConvertTo-SecureString -asPlainText -Force
Copy code
Set-SPPassPhrase -PassPhrase $passphrase -Confirm

This example queries for a string to use as a passphrase, and sets the farm passphrase to a new value.


Start-SPAdminJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Immediately starts any waiting administrative job on the local computer.

Start-SPAdminJob [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Start-SPAdminJob cmdlet to execute all administrative timer jobs immediately rather than waiting for the timer job to run.

When the service account for the SharePoint 2010 Administration service (SPAdminV4)) is disabled (necessary in some installations for security reasons), the Start-SPAdminJob cmdlet must be run on all computers to perform administrative task like provisioning.

When you run this cmdlet in person (not in script), use the Verbose parameter to see the individual administrative operations that are run.

Input Types

Return Types

none

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE-----------------------

Copy code
Start-SPAdminJob -Verbose

This example runs all waiting administrative jobs and shows verbose output to the administrator.

See also

Get-SPTimerJob
Set-SPTimerJob
Enable-SPTimerJob
Disable-SPTimerJob


Features and solutions cmdlets in SharePoint 2013
See also

Summary: List Windows PowerShell cmdlets that help you manage features and solutions in a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Add-SPSiteSubscriptionFeaturePackMember | Adds a feature to a SharePoint feature set.
Add-SPSolution | Uploads a SharePoint solution package to the farm.
Add-SPUserSolution | Uploads a new sandboxed solution to the solution gallery.
Disable-SPFeature | Disables an installed SharePoint feature at a given scope.
Enable-SPFeature | Enables an installed SharePoint feature at the given scope.
Get-SPFeature | Returns the SharePoint features based on a given scope.
Get-SPSiteSubscriptionFeaturePack | Retrieves available SharePoint feature sets or the Feature set assigned to a given site subscription.
Get-SPSolution | Returns a specified SharePoint solution.
Get-SPUserSolution | Returns a specified sandboxed solution.
Install-SPFeature | Installs a SharePoint feature by using the Feature.xml file.
Install-SPSolution | Deploys an installed SharePoint solution in the farm.
Install-SPUserSolution | Activates a sandboxed solution in a site collection.
New-SPSiteSubscriptionFeaturePack | Creates a new SharePoint feature set that can be used to limit the features available to a site subscription.
Remove-SPSiteSubscriptionFeaturePack | Removes a SharePoint feature set from a site subscription.
Remove-SPSiteSubscriptionFeaturePackMember | Removes a feature definition from the provided SharePoint feature set.
Remove-SPSolution | Removes a SharePoint solution from a farm.
Remove-SPUserSolution | Removes a sandboxed solution from the solution gallery.
Remove-SPSolutionDeploymentLock | Removes the solution deployment lock for a server.
Uninstall-SPFeature | Uninstalls an installed feature definition.
Uninstall-SPUserSolution | Deactivates a sandboxed solution in a site collection.
Uninstall-SPSolution | Retracts a deployed SharePoint solution.
Update-SPSolution | Upgrades a deployed SharePoint solution.
Update-SPUserSolution | Upgrades an activated sandboxed solution in a farm.

See also

Windows PowerShell for SharePoint 2013 reference


Add-SPSiteSubscriptionFeaturePackMember
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a feature to a SharePoint Feature set.

Add-SPSiteSubscriptionFeaturePackMember [-Identity] <SPSiteSubscriptionFeaturePackPipeBind> -FeatureDefinition <SPFeatureDefinitionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPFeatureSetPipeBind

Specifies the Feature set object or GUID to which the given SharePoint Feature is added.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a Feature set (for example, FeatureSet1); or an instance of a valid SPFeatureSet object.

FeatureDefinition

Required

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the Feature definition, name, or GUID to add to the Feature set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Add- SPSiteSubscriptionFeaturePackMember cmdlet adds features to the provided SharePoint Feature set. Feature sets are an Allow List of SharePoint Features that can be associated with any site subscription. If a Feature set is assigned to a site subscription, only the SPFeatures object in that Feature set are available for use on the site collections and Web sites that are members of the site subscription. Feature sets contain a list of the GUIDs of each Feature that are on the Allow List for associated site subscriptions.

Input Types

Return Types

Example

-------------EXAMPLE----------------

Copy code
$fs = New-SPFeatureSet
Copy code
Get-SPFeature -limit all | Where{ $_.Scope -eq "WEB" } | Add-SPSiteSubscriptionFeaturePackMember -id $fs
Copy code
$fs = Get-SPFeatureSet $fs

This example creates a Feature set and adds all Web site scoped Features to the set.

The Feature set is refreshed in the last line so that the local object has the correct values.

See also

Remove-SPSiteSubscriptionFeaturePackMember


Add-SPSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Uploads a SharePoint solution package to the farm.

Add-SPSolution [-LiteralPath] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Language <UInt32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

LiteralPath

Required

System.String

Specifies the path to the solution package.

The type must be a valid path in either of the following forms:

- C:\folder_name

- \\server_name\folder_name

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Language

Optional

System.UInt32

Specifies the language pack to install with the solution package.

The type must be a valid language identifier; for example, 1033.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Add-SPSolution cmdlet adds a SharePoint solution package to the farm. This cmdlet does not deploy the uploaded SharePoint solution. Use the Install-SPSolution cmdlet to deploy the SharePoint solution in the farm.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
Add-SPSolution -LiteralPath c:\contoso_solution.wsp

This example adds the SharePoint solution in the file contoso_solution.wsp to the farm.

See also

Get-SPSolution
Update-SPSolution
Uninstall-SPSolution
Remove-SPSolution
Install-SPSolution
Remove-SPSolutionDeploymentLock


Add-SPUserSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Uploads a new sandboxed solution to the solution gallery.

Add-SPUserSolution [-LiteralPath] <String> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

LiteralPath

Required

System.String

Specifies the path to the sandboxed solution package.

The type must be a valid path in either of the following forms:

- C:\folder_name

- \\server_name\folder_name

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the sandboxed solution is to be added.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSiteobject.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Add-SPUserSolution cmdlet uploads a new sandboxed solution package to the solution gallery. This cmdlet does not activate the uploaded sandboxed solution; to activate the solution in the site collection, use the Install-SPUserSolution cmdlet.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

-------------------EXAMPLE---------------------

Copy code
Add-SPUserSolution -LiteralPath c:\contoso_solution.wsp -Site http://sitename

This example adds the sandboxed solution c:\contoso_solution.wsp to the site http://sitename.

See also

Update-SPUserSolution
Install-SPUserSolution
Uninstall-SPUserSolution
Remove-SPUserSolution
Get-SPUserSolution


Disable-SPFeature
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Disables an installed SharePoint Feature at a given scope.

Disable-SPFeature [-Identity] <SPFeatureDefinitionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-Url <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the Feature or GUID to disable.

The type must be the name of the Feature folder located in the 14\Template\Features folder or GUID, in the format 21d186e1-7036-4092-a825-0eb6709e9281.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces a Feature to be disabled.

Url

Optional

System.String

Specifies the URL of the Web application, site collection, or Web site to which the Feature is being disabled.

The type must be a valid URL, such as http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Disable-SPFeature cmdlet disables a SharePoint Feature at the given scope. If the scope of the Feature is the farm, the URL is not needed. Otherwise, provide the URL at which this Feature is to be deactivated (explicit scope is not needed).

Input Types

Return Types

none

Example

--------------EXAMPLE 1-----------------

Copy code
Disable-SPFeature -identity "MyCustom" -URL http://somesite

This example disables the "MyCustom" Web site scoped feature at http://somesite.

--------------EXAMPLE 2-----------------

Copy code
$w = Get-SPWeb http://somesite/myweb | ForEach{ $_.URL }
Copy code
Get-SPFeature -Web $w |%{ Disable-SPFeature -Identity $_ -URL $w}

This example disables all features in the subsite at http://somesite/myweb.

You do not need to use the SPAssignment cmdlets in this case because the Web object is not stored — only the string value for the URL.

See also

Install-SPFeature
Enable-SPFeature
Get-SPFeature
Uninstall-SPFeature


Enable-SPFeature
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Enables an installed SharePoint Feature at the given scope.

Enable-SPFeature [-Identity] <SPFeatureDefinitionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-PassThru <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Enable-SPFeature [-Identity] <SPFeatureDefinitionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-PassThru <SwitchParameter>] [-Url <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the Feature or GUID to uninstall.

The type must be the name of the Feature folder located in the 14\Template\Features folder or GUID, in the form 21d186e1-7036-4092-a825-0eb6709e9281.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces the activation of a Feature. This causes any custom code associated with the Feature to rerun.

PassThru

Optional

System.Management.Automation.SwitchParameter

If provided, the cmdlet outputs the Feature definition object after enable.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the Feature or GUID to uninstall.

The type must be the name of the Feature folder located in the 14\Template\Features folder or GUID, in the form 21d186e1-7036-4092-a825-0eb6709e9281.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces the activation of a Feature. This causes any custom code associated with the Feature to rerun.

PassThru

Optional

System.Management.Automation.SwitchParameter

If provided, the cmdlet outputs the Feature definition object after enable.

Url

Optional

System.String

Specifies the URL of the Web application, site collection, or Web site for which the Feature is being activated.

The type must be a valid URL; for example, http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Enable-SPFeature cmdlet enables an installed feature at the given scope. If the feature is a farm feature, no URL is needed. Otherwise, provide the URL where the feature is to be enabled and it will be enabled at the proper scope based on the Feature definition.

This cmdlet has no output unless the PassThru parameter is provided, in which case the SPFeatureDefinition object for the newly enabled feature is returned.

Note:

If you try to use the Url parameter on a farm-scoped feature, you receive the following error message:

The feature '<feature name>' applies to the entire farm; the Url parameter cannot be used with farm-scoped features.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Enable-SPFeature -identity "MyCustom" -URL http://somesite

This example enables the "MyCustom" site scoped SharePoint Feature at http://somesite.

--------------EXAMPLE 2-----------------

Copy code
$w = Get-SPWeb http://somesite/myweb | ForEach{ $_.URL }
Copy code
Get-SPFeature -Web $w |%{ Enable-SPFeature -Identity $_ -URL $w}

This example enables all SharePoint Features in the subsite at http://somesite/myweb.

See also

Disable-SPFeature
Install-SPFeature
Uninstall-SPFeature
Get-SPFeature


Get-SPFeature
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the SharePoint Features based on a given scope.

Get-SPFeature [[-Identity] <SPFeatureDefinitionPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Limit <String>]
Get-SPFeature [[-Identity] <SPFeatureDefinitionPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Farm <SwitchParameter>] [-Limit <String>]
Get-SPFeature [[-Identity] <SPFeatureDefinitionPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Limit <String>] [-Sandboxed <SwitchParameter>] [-Site <SPSitePipeBind>]
Get-SPFeature [[-Identity] <SPFeatureDefinitionPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Limit <String>] [-Web <SPWebPipeBind>]
Get-SPFeature [[-Identity] <SPFeatureDefinitionPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Limit <String>] [-WebApplication <SPWebApplicationPipeBind>]
Get-SPFeature [[-Identity] <SPFeatureDefinitionPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Limit <String>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the Feature to retrieve.

The type must be the full or partial name, in the form Feature1, or a GUID, in the form 1234-4567-9879, of the Feature to get .

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Limit

Optional

System.String

Limits the display results. If "All" is specified, all Features are displayed.

The type must be a valid number greater than 0. The default value is 200.

2

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the Feature to retrieve.

The type must be the full or partial name, in the form Feature1, or a GUID, in the form 1234-4567-9879, of the Feature to get .

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Farm

Optional

System.Management.Automation.SwitchParameter

Specifies that if this parameter is used, only enabled farm Features are displayed.

Limit

Optional

System.String

Limits the display results. If "All" is specified, all Features are displayed.

The type must be a valid number greater than 0. The default value is 200.

3

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the Feature to retrieve.

The type must be the full or partial name, in the form Feature1, or a GUID, in the form 1234-4567-9879, of the Feature to get .

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Limit

Optional

System.String

Limits the display results. If "All" is specified, all Features are displayed.

The type must be a valid number greater than 0. The default value is 200.

Site

Optional

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the name of the site collection from which to get enabled Features.

The type must be a valid URL for a site collection, in the form http://server_name .

4

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the Feature to retrieve.

The type must be the full or partial name, in the form Feature1, or a GUID, in the form 1234-4567-9879, of the Feature to get .

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Limit

Optional

System.String

Limits the display results. If "All" is specified, all Features are displayed.

The type must be a valid number greater than 0. The default value is 200.

Web

Optional

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the URL or GUID of the Web.

The type must be a valid URL, in the form http://server_name , or a GUID, in the form 1234-5678-9876-0987.

5

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the Feature to retrieve.

The type must be the full or partial name, in the form Feature1, or a GUID, in the form 1234-4567-9879, of the Feature to get .

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Limit

Optional

System.String

Limits the display results. If "All" is specified, all Features are displayed.

The type must be a valid number greater than 0. The default value is 200.

Web

Optional

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the URL or GUID of the Web.

The type must be a valid URL, in the form http://server_name , or a GUID, in the form 1234-5678-9876-0987.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the name of the Web application from which to get enabled Features.

The type must be a valid URL to the Web application in the form http://server_name .

6

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the Feature to retrieve.

The type must be the full or partial name, in the form Feature1, or a GUID, in the form 1234-4567-9879, of the Feature to get .

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Limit

Optional

System.String

Limits the display results. If "All" is specified, all Features are displayed.

The type must be a valid number greater than 0. The default value is 200.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

All parameter sets take the Identity parameter, which can be either the relative path of the SharePoint Feature (considered the feature name) or the GUID of a Feature definition. If the Identity parameter is provided, the cmdlets attempt to find the given Feature definition or instance for the given scope. If no parameters are specified, all installed features are returned.

The Get-SPFeature cmdlet behaves differently at each scope, returning the enabled Features at each level. If no scope is provided, all installed Features are returned.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPFeature -Limit ALL | Where-Object {$_.Scope -eq "SITE"}

This example returns a list of all installed SITE scoped Features.

--------------EXAMPLE 2-----------------

Copy code
Get-SPSite http://somesite | Get-SPWeb -Limit ALL |%{ Get-SPFeature -Web $_ } | Select DisplayName,ID -Unique

This example returns the name and identifier (ID) of each uniquely enabled Feature on every SPWeb object in the site collection at http://somesite.

See also

Install-SPFeature
Enable-SPFeature
Disable-SPFeature
Uninstall-SPFeature


Get-SPSiteSubscriptionFeaturePack
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Retrieves available SharePoint Feature sets or the Feature set assigned to a given site subscription.

Get-SPSiteSubscriptionFeaturePack [[-Identity] <SPSiteSubscriptionFeaturePackPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]
Get-SPSiteSubscriptionFeaturePack [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPFeatureSetPipeBind

Specifies a valid name or GUID of the Feature set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

If provided, ensures that the returned Feature set is the Feature set that is currently assigned to the given site subscription.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPSiteSubscriptionFeaturePack cmdlet retrieves available SharePoint Feature sets or the Feature set assigned to a given site subscription.

Warning:

Be careful when you assign Feature sets to variables because changes to the Feature set are not reflected until the variable is refreshed.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Get- SPSiteSubscriptionFeaturePack

This example returns all defined Feature sets in the local farm.

------------------EXAMPLE 2------------------

Copy code
Get-SPSiteSubscriptionFeaturePack -SiteSubscription http://contoso.com | ForEach{ $_.FeatureDefinitions }

This example returns the list (name, ID, and scope) of all Features allowed in the Feature set that is currently assigned to the site subscription of http://contoso.com.

See also

New-SPSiteSubscriptionFeaturePack
Remove-SPSiteSubscriptionFeaturePack
Add-SPSiteSubscriptionFeaturePackMember


Get-SPSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a specified SharePoint solution.

Get-SPSolution [[-Identity] <SPSolutionPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPSolutionPipeBind

Specifies the SharePoint solution to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint solution (for example, SPSolution1); or an instance of a valid SPSolution object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPSolution cmdlet returns a specified SharePoint solution. If the Identity parameter is not specified, this cmdlet returns the collection of all installed SharePoint solutions in the farm.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
Get-SPSolution

This example returns the collection of all installed SharePoint solutions in the farm.

See also

Get-SPSolution
Add-SPSolution
Update-SPSolution
Uninstall-SPSolution
Remove-SPSolution
Install-SPSolution
Remove-SPSolutionDeploymentLock


Get-SPUserSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a specified sandboxed solution.

Get-SPUserSolution [[-Identity] <SPUserSolutionPipeBind>] -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPUserSolutionPipeBind

Specifies the sandboxed solution to get.

The type must be a valid name of a user solution (for example, UserSolution1); or an instance of a valid SPUserSolution object.

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection that contains the sandboxed solution.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPUserSolution cmdlet returns a specified sandboxed solution. If the Identity parameter is not specified, this cmdlet returns the collection of sandboxed solutions in the site collection. A user solution is a sandboxed solution.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

-----------------EXAMPLE---------------------

Copy code
Get-SPUserSolution -Site http://sitename

This example displays information about sandboxed solutions in the site http://sitename.

See also

Update-SPUserSolution
Install-SPUserSolution
Uninstall-SPUserSolution
Remove-SPUserSolution
Add-SPUserSolution


Install-SPFeature
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Installs a SharePoint Feature by using the Feature.xml file.

Install-SPFeature [-Path] <String> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Install-SPFeature -AllExistingFeatures <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-SolutionId <String>] [-WhatIf [<SwitchParameter>]]
Install-SPFeature -ScanForFeatures <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-SolutionId <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Path

Required

System.String

Specifies an authentic file path; for example, MyFeature.

The path to feature must be a literal path to the 14\Template\Features directory. The feature.xml file name is implied and does not need to be provided.

If the path to the feature is not found , the following error message is displayed: "Failed to find the XML file at location 14\Template\Features\<file path>."

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompatibilityLevel

Optional

System.Int32

Specifies the version of feature to install. When the version is not specified it will default to the web applications MaxVersion value.

The values for this can be either SharePoint Server 2010 or SharePoint Server 2013

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces the installation of an already installed feature.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

AllExistingFeatures

Required

System.Management.Automation.SwitchParameter

Scans for existing, but unregistered features, and then registers them with the farm.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces the installation of an already installed feature.

SolutionId

Optional

System.String

Specifies the solution ID of the features. If the SolutionId parameter is not provided, all solution IDs are scanned.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

ScanForFeatures

Required

System.Management.Automation.SwitchParameter

Scans and then displays a feature. The ScanForFeatures parameter does not install a feature.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces the installation of an already installed feature.

SolutionId

Optional

System.String

Specifies the solution ID of the features. If the SolutionId parameter is not provided, all solution IDs are scanned.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Install-SPFeature cmdlet installs a specific SPFeature by providing, in the Identity parameter, the relative path from the version-specific common FEATURES folder to the feature. The version-specific FEATURES folder is "$env:ProgramFiles\Common Files\Microsoft Shared\Web Server Extensions\14\TEMPLATE\FEATURES\" if the site collection is in 14 mode, and "$env:ProgramFiles\Common Files\Microsoft Shared\Web Server Extensions\15\TEMPLATE\FEATURES\" if the site collection is in 15 mode. The SharePoint Feature's files must already be put in the proper directory, either manually or by using a solution installer.

If the value of the AllExistingFeatures parameter is true, the file system is scanned and all new features that are in both FEATURES folders are installed. This is generally only used during deployment and upgrade.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Install-SPFeature -path "MyCustomFeature"

This example installs a new feature at $env:ProgramFiles\Common Files\Microsoft Shared\Web Server Extensions\15\TEMPLATE\FEATURES\MyCustomFeature/feature.xml.

--------------EXAMPLE 2-----------------

Copy code
Install-SPFeature -AllExistingFeatures -Whatif

This example shows the unregistered features that are available on the file system and that are installed if this command is run without the WhatIf parameter. This is commonly done after an upgrade process.

--------------EXAMPLE 3-----------------

Copy code
Install-SPFeature -path "MyCustomFeature"  -CompatibilityLevel 14

This example installs a new feature at $env:ProgramFiles\Common Files\Microsoft Shared\Web Server Extensions\15\TEMPLATE\FEATURES\MyCustomFeature\feature.xml.

--------------EXAMPLE 4-----------------

Copy code
Install-SPFeature -path "MyCustomFeature"  -CompatibilityLevel 15

This example installs a new feature at $env:ProgramFiles\Common Files\Microsoft Shared\Web Server Extensions\15\TEMPLATE\FEATURES\MyCustomFeature\feature.xml.

See also

Get-SPFeature
Enable-SPFeature
Disable-SPFeature
Uninstall-SPFeature


Install-SPSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deploys an installed SharePoint solution in the farm.

Install-SPSolution [-Identity] <SPSolutionPipeBind> [-AllWebApplications <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-CASPolicies <SwitchParameter>] [-CompatibilityLevel <String>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-FullTrustBinDeployment <SwitchParameter>] [-GACDeployment <SwitchParameter>] [-Language <UInt32>] [-Local <SwitchParameter>] [-Time <String>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]
Install-SPSolution [[-Identity] <SPSolutionPipeBind>] -Synchronize <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Language <UInt32>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSolutionPipeBind

Specifies the SharePoint solution to deploy.

The value must be an authentic GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; an authentic name of a SharePoint solution (for example, SPSolution1); or an instance of an authentic SPSolution object.

AllWebApplications

Optional

System.Management.Automation.SwitchParameter

Specifies that the new SharePoint solution is deployed for all SharePoint web applications in the farm.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CASPolicies

Optional

System.Management.Automation.SwitchParameter

Specifies that code access security (CAS) policies can be deployed for the new SharePoint solution.

CompatibilityLevel

Optional

System.String

Specifies whether to install into the solution, into a specific version directory based on CompatibilityLevel. The default behavior if this parameter is not specified is to install the solution only to the version directory based on the version tracked in the manifest of the solution's cab file. For the list of values, see the table in the Detailed Description section.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces the deployment of the new SharePoint solution.

FullTrustBinDeployment

Optional

System.Management.Automation.SwitchParameter

Specifies that full trust Bin deployment is permitted. This parameter is to be used if the solution is fully trusted.

Bin assembly is an assembly installed into the bin directory of the virtual server. The assembly in the package will have DeploymentTarget=WebApplication attribute set. For additional information about bin assembly, see Assembly Element

GACDeployment

Optional

System.Management.Automation.SwitchParameter

Specifies that global assembly cache (GAC) can be deployed for the new SharePoint solution.

Language

Optional

System.UInt32

Specifies a language for the solution when a solution language package is deployed. If this parameter is not specified, zero ("0") is assumed. Use zero for solutions that are valid for all languages.

Local

Optional

System.Management.Automation.SwitchParameter

Deploys the solution on the active server.

Time

Optional

System.String

Specifies when the solution will be deployed. The default value is immediate deployment.

The type must be a valid DateTime value, in the form 2010, 5, 1.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Deploys the SharePoint solution for the specified SharePoint web application.

The value must be in one of the following forms:

  • An authentic GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh

  • An authentic name of a SharePoint web application (for example, MyOfficeApp1)

  • An instance of an authentic SPWebApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSolutionPipeBind

Specifies the SharePoint solution to deploy.

The value must be an authentic GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; an authentic name of a SharePoint solution (for example, SPSolution1); or an instance of an authentic SPSolution object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Language

Optional

System.UInt32

Specifies a language for the solution when a solution language package is deployed. If this parameter is not specified, zero ("0") is assumed. Use zero for solutions that are valid for all languages.

Synchronize

Optional

System.Management.Automation.SwitchParameter

Synchronizes all solutions or the specified solution in the local farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Install-SPSolution cmdlet deploys an installed SharePoint solution in the farm. Use the Add-SPSolution cmdlet to install a SharePoint solution package in the farm.

The following table lists the valid values for the CompatabilityLevel parameter:

Value | Result
14 | Installs solution to 14 directories only
15 | Installs solution to 15 directories only
"14,15" | Installs solution to both 14 and 15 directories
"AllVersions" or "All" | Installs solution to both 14 and 15 directories
"OldVersions" or "Old" | Installs solution to 14 directories only
"NewVersion" or "New" | Installs solution to 15 directories only

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Install-SPSolution -Identity contoso_solution.wsp -GACDeployment

This example deploys the installed SharePoint solution contoso_solution.wsp in the farm and specifies that GAC can be deployed for the new SharePoint solution.

------------------EXAMPLE 2------------------

Copy code
Install-SPSolution -Identity contoso_solution.wsp -GACDeployment --CompatibilityLevel 15

This example deploys the installed SharePoint solution contoso_solution.wsp in the farm within the latest version directories and specifies that global assembly cache (GAC) can be deployed for the new SharePoint solution.

------------------EXAMPLE 3------------------

Copy code
Install-SPSolution -Identity contoso_solution.wsp -GACDeployment -CompatibilityLevel {14,15}

This example deploys the installed SharePoint solution installs a previously added solution so it can be used correctly in both 14 and 15 mode site collections.

See also

Get-SPSolution
Add-SPSolution
Update-SPSolution
Uninstall-SPSolution
Remove-SPSolution
Remove-SPSolutionDeploymentLock


Install-SPUserSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Activates a sandboxed solution in a site collection.

Install-SPUserSolution [-Identity] <SPUserSolutionPipeBind> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUserSolutionPipeBind

Specifies the sandboxed solution to activate.

The type must be a valid name of a sandboxed solution (for example, UserSolution1); or an instance of a valid SPUserSolution object.

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Activates the sandboxed solution for the specified site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Install-SPUserSolution cmdlet activates a sandboxed solution in a site collection. A user solution is a sandboxed solution.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

-------------------EXAMPLE---------------------

Copy code
Install-SPUserSolution -Identity contoso_solution.wsp -Site http://sitename

This example activates the sandboxed solution contoso_solution.wsp in the site http://sitename.

See also

Update-SPUserSolution
Uninstall-SPUserSolution
Remove-SPUserSolution
Get-SPUserSolution
Add-SPUserSolution


New-SPSiteSubscriptionFeaturePack
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new SharePoint Feature set that can be used to limit the features available to a site subscription.

New-SPSiteSubscriptionFeaturePack [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New- SPSiteSubscriptionFeaturePack cmdlet to create a new SharePoint Feature set that limits the Features available to a specified site subscription.

SharePoint Feature sets are on an Allow List of SharePoint Features that can be associated with any site subscription. If a Feature set is assigned to a site subscription, only SPFeatures objects in that Feature set are available for use on the site collections and Webs that are members of the site subscription. Feature sets contain a list of the GUIDs of each Feature that is on an Allow List for associated site subscriptions.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
$fs = New-SPSiteSubscriptionFeaturePack

This example creates a new SharePoint Feature set and stores it in a variable.

See also

Get-SPSiteSubscriptionFeaturePack
Add-SPSiteSubscriptionFeaturePackMember
New-SPSiteSubscriptionFeaturePack
Add-SPSiteSubscriptionFeaturePackMember


Remove-SPSiteSubscriptionFeaturePack
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a SharePoint Feature set from a site subscription.

Remove-SPSiteSubscriptionFeaturePack [-Identity] <SPSiteSubscriptionFeaturePackPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPFeatureSetPipeBind

Specifies the Feature set object to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a feature set (for example, FeatureSet1); or an instance of a valid SPFeatureSet object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove- SPSiteSubscriptionFeaturePack cmdlet removes a SharePoint Feature set by specifying the GUID or Feature set object.

Input Types

Return Types

Example

-----------------EXAMPLE------------------------

Copy code
Remove-SPFeatureSet -Identity "30daa535-b0fe-4d10-84b0-fb04029d161a"

This example removes a SharePoint Feature set that has the ID 30daa535-b0fe-4d10-84b0-fb04029d161a.

See also

Get-SPSiteSubscriptionFeaturePack
New-SPSiteSubscriptionFeaturePack
Remove-SPSiteSubscriptionFeaturePack
Add-SPSiteSubscriptionFeaturePackMember


Remove-SPSiteSubscriptionFeaturePackMember
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a feature definition from the provided SharePoint Feature set.

Remove-SPSiteSubscriptionFeaturePackMember [-Identity] <SPSiteSubscriptionFeaturePackPipeBind> -FeatureDefinition <SPFeatureDefinitionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Remove-SPSiteSubscriptionFeaturePackMember [-Identity] <SPSiteSubscriptionFeaturePackPipeBind> -AllFeatureDefinitions <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPFeatureSetPipeBind

Specifies the Feature set from which to remove a feature.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a feature set (for example, FeatureSet1); or an instance of a valid SPFeatureSet object.

FeatureDefinition

Required

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the feature definition to be removed.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPFeatureSetPipeBind

Specifies the Feature set from which to remove a feature.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a feature set (for example, FeatureSet1); or an instance of a valid SPFeatureSet object.

AllFeatureDefinitions

Required

System.Management.Automation.SwitchParameter

Clears all features from the Feature set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Remove-SPSiteSubscriptionFeaturePackMember cmdlet removes the provided FeatureDefintion parameter from the feature set specified by the Identity parameter. If the AllFeatureDefinitions flag is provided, all feature definitions are removed from the given Feature set.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
$FS = Get-SPSiteSubscriptionFeaturePack "30daa535-b0fe-4d10-84b0-fb04029d161a"
Copy code
Remove-SPSiteSubscriptionFeaturePackMember -Identity $fs -FeatureDefinition (Get-SPFeature "PublishingSite")

This example removes the PublishingSite feature from the Feature set that has ID 30daa535-b0fe-4d10-84b0-fb04029d161a.

------------------EXAMPLE 2-----------------------

Copy code
Get-SPSiteSubscriptionFeaturePack "30daa535-b0fe-4d10-84b0-fb04029d161a" | Remove-SPSiteSubscriptionFeaturePackMember -AllFeatureDefinitions

This example removes all features from the Feature set 30daa535-b0fe-4d10-84b0-fb04029d161a.

See also

Add-SPSiteSubscriptionFeaturePackMember
Get-SPSiteSubscriptionFeaturePack
Remove-SPSiteSubscriptionFeaturePack


Remove-SPSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a SharePoint solution from a farm.

Remove-SPSolution [-Identity] <SPSolutionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-Language <UInt32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSolutionPipeBind

Specifies the SharePoint solution to remove.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint solution (for example, SPSolution1); or an instance of a valid SPSolution object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces the removal of the SharePoint solution. You can use this parameter to remove SharePoint solutions that have been added to the server, even if they have not been deployed by using the Install-SPSolution cmdlet.

Language

Optional

System.UInt32

Removes the language pack for the specified language.

The type must be a valid language identifier; for example, 1033.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPSolution cmdlet deletes a SharePoint solution from a farm. Before you use this cmdlet, you must use the Uninstall-SPSolution cmdlet to retract the solution files from the front-end Web server.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
Remove-SPSolution -Identity contoso_solution.wsp

This example removes the SharePoint solution contoso_solution.wsp.

See also

Get-SPSolution
Add-SPSolution
Update-SPSolution
Uninstall-SPSolution
Install-SPSolution


Remove-SPUserSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a sandboxed solution from the solution gallery.

Remove-SPUserSolution [-Identity] <String> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUserSolutionPipeBind

Specifies the sandboxed solution to remove.

The type must be a valid name of a sandboxed solution (for example, UserSolution1); or an instance of a valid SPUserSolution object.

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Remove the sandboxed solution from the specified site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPUserSolution cmdlet completely removes a sandboxed solution from the solution gallery. Before you can remove the sandboxed solution from the solution gallery, you must deactivate it by using the Uninstall-SPUserSolution cmdlet.

Input Types

Return Types

Example

----------------EXAMPLE----------------------

Copy code
Remove-SPUserSolution -Identity contoso_solution.wsp -Site http://sitename

This example removes the sandboxed solution contoso_solution.wsp from the site http://sitename.

See also

Update-SPUserSolution
Install-SPUserSolution
Uninstall-SPUserSolution
Get-SPUserSolution
Add-SPUserSolution


Remove-SPSolutionDeploymentLock
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes the solution deployment lock for a server.

Remove-SPSolutionDeploymentLock [[-Identity] <SPServerPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the server for which the solution deployment lock is to be removed.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; the IP address of a server computer, in the form 208.77.188.166; a valid name of a SQL Server host service (for example, SQLServerHost1); or an instance of a valid SPServer object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPSolutionDeploymentLock cmdlet removes the solution deployment lock for a server. If the Identity parameter is not specified, this cmdlet removes the solution deployment lock for all servers in the farm.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
Remove-SPSolutionDeploymentLock

This example removes the solution deployment lock for all servers in the farm.

See also

Remove-SPSolution
Get-SPSolution
Add-SPSolution
Update-SPSolution
Uninstall-SPSolution
Install-SPSolution


Uninstall-SPFeature
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Uninstalls an installed feature definition.

Uninstall-SPFeature [-Identity] <SPFeatureDefinitionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Parameter

Microsoft.SharePoint.PowerShell.SPFeatureDefinitionPipeBind

Specifies the name of the feature or GUID to uninstall.

The type must be the name of the feature folder located in the <drive>:\program files\common files\Microsoft Shared\Web server extensions\15\template\features folder, or must be a GUID, in the form 21d186e1-7036-4092-a825-0eb6709e9281.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompatibilityLevel

Optional

System.Int32

Specifies the version of feature to uninstall. When the version is not specified it will default to the web applications MaxVersion value.

The values for this can be either SharePoint Server 2010 or SharePoint Server 2013.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

No

System.Management.Automation.SwitchParameter

Forces the uninstallation of a feature that is already installed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Uninstall-SPFeature cmdlet removes the specified feature definition from the collection of feature definitions in the farm.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
Uninstall-SPFeature -Identity "MyCustomFeature"

This example uninstalls the feature at $env:ProgramFiles\Common Files\Microsoft Shared\Web Server Extensions\15\TEMPLATE\FEATURES\MyCustomFeature/feature.xml.

------------------EXAMPLE 2-----------------------

Copy code
Uninstall-SPFeature -Identity "MyCustomFeature" -CompatibilityLevel 14

This example uninstalls the feature at $env:ProgramFiles\Common Files\Microsoft Shared\Web Server Extensions\15\TEMPLATE\FEATURES\MyCustomFeature/feature.xml.

See also

Get-SPFeature
Enable-SPFeature
Disable-SPFeature
Install-SPFeature


Uninstall-SPUserSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deactivates a sandboxed solution in a site collection.

Uninstall-SPUserSolution [-Identity] <SPUserSolutionPipeBind> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUserSolutionPipeBind

Specifies the sandboxed solution to deactivate.

The type must be a valid name of a sandboxed solution (for example, UserSolution1); or an instance of a valid SPUserSolution object.

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Deactivates the sandboxed solution for the specified site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Uninstall-SPUserSolution cmdlet deactivates a sandboxed solution in a site collection so that you can delete it by using the Remove-SPUserSolution cmdlet. A user solution is a sandboxed solution.

Input Types

Return Types

Example

------------------EXAMPLE---------------

Copy code
Uninstall-SPUserSolution -Identity contoso_solution.wsp -Site http://sitename

This example deactivates the sandboxed solution contoso_solution.wsp on the site http://sitename.

See also

Update-SPUserSolution
Install-SPUserSolution
Remove-SPUserSolution
Get-SPUserSolution
Add-SPUserSolution


Uninstall-SPSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Retracts a deployed SharePoint solution.

Uninstall-SPSolution [-Identity] <SPSolutionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <String>] [-Confirm [<SwitchParameter>]] [-Language <UInt32>] [-Local <SwitchParameter>] [-Time <String>] [-WhatIf [<SwitchParameter>]]
Uninstall-SPSolution [-Identity] <SPSolutionPipeBind> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <String>] [-Confirm [<SwitchParameter>]] [-Language <UInt32>] [-Local <SwitchParameter>] [-Time <String>] [-WhatIf [<SwitchParameter>]]
Uninstall-SPSolution [-Identity] <SPSolutionPipeBind> -AllWebApplications <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <String>] [-Confirm [<SwitchParameter>]] [-Language <UInt32>] [-Local <SwitchParameter>] [-Time <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSolutionPipeBind

Specifies the SharePoint solution to uninstall.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint solution (for example, SPSolution1); or an instance of a valid SPSolution object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CompatibilityLevel

Optional

System.String

Specifies whether to uninstall the solution, from a specific version directory based on CompatibilityLevel. The default behavior if this parameter is not specified is to uninstall the solution only from the version directory based on the version tracked in the manifest of the solution's cab file. For the list of values, see the table in the Detailed Description section.

Language

Optional

System.UInt32

Uninstalls the language pack for the specified language.

The type must be a valid language identifier; for example, 1033.

Local

Optional

System.Management.Automation.SwitchParameter

Uninstalls the solution from the active server computer.

Time

Optional

System.String

Specifies when the solution will be uninstalled. The default value is immediate retraction.

The type must be a valid DateTime value, in the form 2010,12,05.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSolutionPipeBind

Specifies the SharePoint solution to uninstall.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint solution (for example, SPSolution1); or an instance of a valid SPSolution object.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Uninstalls the SharePoint solution for the specified SharePoint Web application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CompatibilityLevel

Optional

System.String

Specifies whether to uninstall the solution, from a specific version directory based on CompatibilityLevel. The default behavior if this parameter is not specified is to uninstall the solution only from the version directory based on the version tracked in the manifest of the solution's cab file. For the list of values, see the table in the Detailed Description section.

Language

Optional

System.UInt32

Uninstalls the language pack for the specified language.

The type must be a valid language identifier; for example, 1033.

Local

Optional

System.Management.Automation.SwitchParameter

Uninstalls the solution from the active server computer.

Time

Optional

System.String

Specifies when the solution will be uninstalled. The default value is immediate retraction.

The type must be a valid DateTime value, in the form 2010,12,05.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSolutionPipeBind

Specifies the SharePoint solution to uninstall.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint solution (for example, SPSolution1); or an instance of a valid SPSolution object.

AllWebApplications

Required

System.Management.Automation.SwitchParameter

Specifies that the new SharePoint solution will be uninstalled for all SharePoint Web applications in the farm.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CompatibilityLevel

Optional

System.String

Specifies whether to uninstall the solution, from a specific version directory based on CompatibilityLevel. The default behavior if this parameter is not specified is to uninstall the solution only from the version directory based on the version tracked in the manifest of the solution's cab file. For the list of values, see the table in the Detailed Description section.

Language

Optional

System.UInt32

Uninstalls the language pack for the specified language.

The type must be a valid language identifier; for example, 1033.

Local

Optional

System.Management.Automation.SwitchParameter

Uninstalls the solution from the active server computer.

Time

Optional

System.String

Specifies when the solution will be uninstalled. The default value is immediate retraction.

The type must be a valid DateTime value, in the form 2010,12,05.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Uninstall-SPSolution cmdlet retracts a deployed SharePoint solution in preparation for removing it from the farm entirely. This cmdlet removes files from the front-end Web server. Use the Remove-SPSolution cmdlet to delete the solution package from the solution store of the farm; be sure to use the Remove-SPSolution cmdlet only after you have run Uninstall-SPSolution.

The following table lists the valid values for the CompatabilityLevel parameter:

Value | Result
14 | Uninstalls solution from 14 directories only
15 | Uninstalls solution from 15 directories only
"14,15" | Uninstalls solution from both 14 and 15 directories
"AllVersions" or "All" | Uninstalls solution from both 14 and 15 directories
"OldVersions" or "Old" | Uninstalls solution from 14 directories only
"NewVersion" or "New" | Uninstalls solution from 15 directories only

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Uninstall-SPUserSolution -Identity contoso_solution.wsp

This example retracts the deployed SharePoint solution contoso_solution.wsp.

See also

Get-SPSolution
Add-SPSolution
Update-SPSolution
Remove-SPSolution
Install-SPSolution
Remove-SPSolutionDeploymentLock


Update-SPSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Upgrades a deployed SharePoint solution.

Update-SPSolution [-Identity] <SPSolutionPipeBind> -LiteralPath <String> [-AssignmentCollection <SPAssignmentCollection>] [-CASPolicies <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-FullTrustBinDeployment <SwitchParameter>] [-GACDeployment <SwitchParameter>] [-Local <SwitchParameter>] [-Time <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSolutionPipeBind

Specifies the SharePoint solution to deploy.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint solution (for example, SPSolution1); or an instance of a valid SPSolution object.

LiteralPath

Required

System.String

Specifies the path to the solution package.

The type must be a valid path in either of the following forms:

- C:\folder_name

- \\server_name\folder_name

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CASPolicies

Optional

System.Management.Automation.SwitchParameter

Specifies that Code Access Security (CAS) policies can be deployed for the new SharePoint solution.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces the deployment of the new SharePoint solution.

GACDeployment

Optional

System.Management.Automation.SwitchParameter

Specifies that the new SharePoint solution can be deployed to the global assembly cache (GAC).

Local

Optional

System.Management.Automation.SwitchParameter

Deploys the solution on the local computer only.

Time

Optional

System.String

Specifies when the solution will be deployed. The default value is immediate deployment.

The type must be a valid DateTime value, in the form 2010, 5, 1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Update-SPSolution cmdlet upgrades a deployed SharePoint solution in the farm. Use this cmdlet only if a new solution contains the same set of files and features as the deployed solution. If files and features are different, the solution must be retracted and redeployed by using the Uninstall-SPSolution and Install-SPSolution cmdlets, respectively.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Update-SPSolution -Identity contoso_solution.wsp -LiteralPath c:\contoso_solution_v2.wsp -GACDeployment

This example upgrades the deployed SharePoint solution contoso_solution.wsp to the solution c:\contoso_solution_v2.wsp.

See also

Get-SPSolution
Add-SPSolution
Uninstall-SPSolution
Remove-SPSolution
Install-SPSolution
Remove-SPSolutionDeploymentLock


Update-SPUserSolution
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Upgrades an activated sandboxed solution in a farm.

Update-SPUserSolution [-Identity] <SPUserSolutionPipeBind> -Site <SPSitePipeBind> -ToSolution <SPUserSolutionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUserSolutionPipeBind

Specifies the sandboxed solution to upgrade.

The type must be a valid name of a sandboxed solution (for example, UserSolution1); or an instance of a valid SPUserSolution object.

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Upgrade the sandboxed solution for the specified site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

ToSolution

Required

Microsoft.SharePoint.PowerShell.SPUserSolutionPipeBind

Specifies the sandboxed solution you want to upgrade to.

The type must be a valid name of a sandboxed solution (for example, UserSolution1); or an instance of a valid SPUserSolution object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Update-SPUserSolution cmdlet upgrades a sandboxed solution that has already been activated in a specified site collection. A user solution is a sandboxed solution. Before you use this cmdlet to upgrade the activated solution, use the Add-SPUserSolution cmdlet to upload the upgraded solution to the solution gallery.

Input Types

Return Types

Example

------------------EXAMPLE---------------------

Copy code
Update-SPUserSolution -Identity contoso_solution.wsp -Site http://sitename -ToSolution contoso_solution_v2.wsp

This example upgrades the sandboxed solution contoso_solution.wsp in the site http://sitename to the sandboxed solution contoso_solution_v2.wsp.

See also

Install-SPUserSolution
Uninstall-SPUserSolution
Remove-SPUserSolution
Get-SPUserSolution
Add-SPUserSolution


Use Windows PowerShell cmdlets to administer SharePoint 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use for general administration of SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The following table shows the Windows PowerShell cmdlets that you can for general administration of a SharePoint 2013 farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPBrowserCustomerExperienceImprovementProgram | Returns the current opt-in state for the browser Customer Experience Improvement Program.
Get-SPHelpCollection | Returns Help collection files.
Install-SPHelpCollection | Installs the provided Help site collection files in the current farm.
Set-SPBrowserCustomerExperienceImprovementProgram | Turns on or off the browser Customer Experience Improvement Program.
Start-SPAssignment | Initiates a new assignment store.
Stop-SPAssignment | Disposes of objects in the provided assignment collection.
Uninstall-SPHelpCollection | Removes Help collection files.
Get-SPBingMapsKey | Returns the Bing Maps key.
Set-SPBingMapskey | Sets the Bing Maps key.
Get-SPBingMapsBlock | Sets Bing maps to blocked status.
Set-SPBingMapsBlock | Returns Bing Maps blocked status.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Get-SPBrowserCustomerExperienceImprovementProgram
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the current opt-in state for the browser Customer Experience Improvement Program.

Get-SPBrowserCustomerExperienceImprovementProgram -Farm <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPBrowserCustomerExperienceImprovementProgram -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPBrowserCustomerExperienceImprovementProgram -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Farm

Required

System.Management.Automation.SwitchParameter

Specifies that the opt-in state for the farm is returned by this cmdlet.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Returns the opt-in state for the specified SharePoint Web application.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

3

Parameter

Required

Type

Description

SiteSubscription

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Returns the opt-in state for the specified site subscription.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscription1); or an instance of a valid SiteSubscription object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPBrowserCustomerExperienceImprovementProgram cmdlet reads the current opt-in state for the browser Customer Experience Improvement Program.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
Get-SPBrowserCustomerExperienceImprovementProgram -WebApplication http://WebAppexample1

This example returns the current Customer Experience Improvement Program opt-in state for the Web application, WebAppexample1.

------------------EXAMPLE 2-----------------------

Copy code
Get-SPSiteSubscription http://SiteSubscription1 | Get- SPBrowserCustomerExperienceImprovementProgram

The following example returns the Customer Experience Improvement Program opt-in state for the site subscription, SiteSubscription1.

See also

Set-SPBrowserCustomerExperienceImprovementProgram


Get-SPHelpCollection
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns Help collection files.

Get-SPHelpCollection [-AssignmentCollection <SPAssignmentCollection>] [-Name <String>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Name

Optional

System.String

Specifies the name of the Help collection files to get.

The type must be a valid name of a Help collection folder; for example, HelpDocs1.

Detailed Description

The Get-SPHelpCollection cmdlet reads the specified Help collection files. If the Name parameter is not specified, this cmdlet returns all installed Help collection files.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
Get-SPHelpCollection

This example gets all installed Help collection files.

See also

Install-SPHelpCollection
Uninstall-SPHelpCollection


Install-SPHelpCollection
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Installs the provided Help site collection files in the current farm.

Install-SPHelpCollection -LiteralPath <String> [-AssignmentCollection <SPAssignmentCollection>]
Install-SPHelpCollection -All <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

LiteralPath

Optional

System.String

Specifies the exact path to a specific custom Help file in the Help site collection cab file.

The type must be a valid path in either of the following forms:

- C:\folder_name

- \\server_name\folder_name

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

All

Required

System.Management.Automation.SwitchParameter

If the LiteralPath parameter is not specified, specifies that all Help Collection CABs under %Program Files%\Common Files\Microsoft Shared\Web Server Extensions\14\HCCab\<LCID> in the Help site collection are installed, and existing Help collections are overwritten.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Install-SPHelpCollection cmdlet installs the Help site collection files for SharePoint 2010 Products in the current farm. Use the LiteralPath parameter to install specific custom Help collection files. If the LiteralPath parameter is not specified, all available Help in the Help site collection is installed and existing Help collection files are overwritten.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Install-SPHelpCollection -LiteralPath 'C:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\14\HCCab\1033\OSSAdmin.cab'

This example installs the specified help collection in the current farm.

See also

Get-SPHelpCollection
Uninstall-SPHelpCollection


Set-SPBrowserCustomerExperienceImprovementProgram
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Turns on or off the browser Customer Experience Improvement Program.

Set-SPBrowserCustomerExperienceImprovementProgram -Farm <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Enable <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Set-SPBrowserCustomerExperienceImprovementProgram -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Enable <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Set-SPBrowserCustomerExperienceImprovementProgram -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Enable <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Farm

Required

System.Management.Automation.SwitchParameter

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Enable

Optional

System.Management.Automation.SwitchParameter

Turns on the browser Customer Experience Improvement Program. The default value is True.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Sets the Customer Experience Improvement Program opt-in state for the specified SharePoint Web application.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Enable

Optional

System.Management.Automation.SwitchParameter

Turns on the browser Customer Experience Improvement Program. The default value is True.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

SiteSubscription

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Sets the Customer Experience Improvement Program opt-in state for the specified site subscription.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscription1); or an instance of a valid SiteSubscription object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Enable

Optional

System.Management.Automation.SwitchParameter

Turns on the browser Customer Experience Improvement Program. The default value is True.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPBrowserCustomerExperienceImprovementProgram cmdlet turns on or off the browser Customer Experience Improvement Program for collecting software quality metrics.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
Set-SPBrowserCustomerExperienceImprovementProgram -Farm -Enable

This example turns on the browser Customer Experience Improvement Program for the farm.

------------------EXAMPLE 2-----------------------

Copy code
Set-SPBrowserCustomerExperienceImprovementProgram -Farm -Enable:$False

This example turns off the browser Customer Experience Improvement Program for the farm.

------------------EXAMPLE 3-----------------------

Copy code
Set-SPWebApplication http://MyOfficeApp1 | Get- SPBrowserCustomerExperienceImprovementProgram -Enable

This example turns on the browser Customer Experience Improvement Program for the Web application, MyOfficeApp1.

See also

Get-SPBrowserCustomerExperienceImprovementProgram


Start-SPAssignment
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Initiates a new assignment store.

Start-SPAssignment [-AssignmentCollection <SPAssignmentCollection>] [-Global <SwitchParameter>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Global

Optional

System.Management.Automation.SwitchParameter

If you use this parameter, all objects are assigned to the lifetime of the script and are disposed of when the Stop-SPAssignment cmdlet is called.

If you do not use this parameter, you must assign the output of this cmdlet to a variable and then dispose of objects by using the Identity parameter of the Stop-SPAssignment cmdlet.

Detailed Description

The Start-SPAssignment cmdlet properly disposes of objects used with variable assignments.

Large amounts of memory are often required when SPWeb, SPSite, or SPSiteAdminsitration objects are used. So the use of these objects, or lists of these objects, in Windows PowerShell scripts requires proper memory management. By default, all Get commands dispose of these objects immediately after the pipeline finishes, but by using SPAssignment, you can assign the list of objects to a variable and dispose of the objects after they are no longer needed. You can also ensure that the objects remain as long as you need them, even throughout multiple iterations of commands.

There are three levels of assignment:

-- No assignment — The object is not assigned to a variable and is disposed of after each iteration of the command.

-- Simple assignment — All objects are assigned to the global assignment store. This is done by using the Global parameter. When using this level, all objects are assigned to a global store and are disposed of when the Stop-SPAssignment cmdlet is called.

-- Advanced assignment — Objects are assigned to named stores for disposal. You can dispose of objects by using the Identity parameter with the Stop-SPAssignment cmdlet.

Note:

Regardless of the assignment level used, all objects are disposed of when the Windows PowerShell run space is closed.

Input Types

Return Types

SPAssignmentCollection

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE 1-----------------------

Copy code
Start-SPAssignment -global
Copy code
$w = Get-SPWeb http://MyWeb
Copy code
$w | Set-SPWeb -title "Accounting"
Copy code
Stop-SPAssignment -global

This example uses simple assignment. Although it is easier to use simple assignment, it is not a good idea to run commands that iterate through multiple SPSite or SPWeb objects while simple assignment is enabled. Ensure that you run Stop-SPAssignment before you attempt any iterations of multiple objects.

------------------EXAMPLE 2-----------------------

Copy code
$gc = Start-SPAssignment
Copy code
$web = $gc | Get-SPWeb http://MyWeb
Copy code
$web | Set-SPWeb -title "Accounting"
Copy code
Stop-SPAssignment -Identity $gc

This example sets the title of the SPWeb object in multiple lines and controls the rate of disposal. This is an advanced example. Only developers are advised to use it.

See also

Stop-SPAssignment


Stop-SPAssignment
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Disposes of objects in the provided assignment collection.

Stop-SPAssignment [[-SemiGlobal] <SPAssignmentCollection>] [-AssignmentCollection <SPAssignmentCollection>] [-Global <SwitchParameter>]

Parameters

Parameter Required Type Description

SemiGlobal

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentColletion

Provides the assignment collector from which to dispose of objects.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Global

Optional

System.Management.Automation.SwitchParameter

Stops the global assignment collector from storing objects, and disposes of any objects contained by the global assignment collector.

Detailed Description

The Stop-SPAssignment cmdlet disposes of objects in the provided assignment collection. Use the Global parameter to dispose of all objects in the global assignment collector and to stop the global store from collecting additional objects. Provide a SemiGlobal assignment collector to dispose of all contained objects.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
Start-SPAssignment -global
Copy code
$w=Get-SPWeb http://MyWeb
Copy code
$w | Set-SPWeb -title "Accounting"
Copy code
Stop-SPAssignment -global

This example uses simple assignment. While easier to use simple assignment, running commands that iterate through multiple SPSite or SPWeb objects while simple assignment is enabled is not recommended. Ensure that Stop-SPAssignment is run before attempting any iterations of multiple objects.

See also

Start-SPAssignment


Uninstall-SPHelpCollection
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes Help collection files.

Uninstall-SPHelpCollection -Name <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the Help collection files to uninstall.

The type must be a valid name of a Help collection; for example, HelpDocs1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Uninstall-SPHelpCollection cmdlet removes the specified Help collection files from the product Help library in the current farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Uninstall-SPHelpCollection - Name "OSSAdmin.1033"

This example uninstalls a Help collection. The folder name of the Help collection to uninstall is OSSAdmin.1033.

See also

Get-SPHelpCollection
Install-SPHelpCollection


Get-SPBingMapsKey
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the Bing Maps key.

Get-SPBingMapsKey [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPBingMapsKey cmdlet to return the current Bing Maps key for the farm.

Input Types

Return Types

Example

------------EXAMPLE-----------

Copy code
Get-SPBingMapsKey

This example returns the Bing Maps key for the farm.

See also

Set-SPBingMapskey


Set-SPBingMapskey
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the Bing Maps key.

Set-SPBingMapskey [-BingKey] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

BingKey

Required

System.String

Specifies the Bing Maps key to set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPBingMapsKey cmdlet to set the Bing Maps key. This key lets you access Bing Maps. For additional information about Bing Keys, see Bing Maps Account Center

Input Types

Return Types

Example

---------------EXAMPLE----------

Copy code
Set-SPBingMapsKey -BingKey <Bing Maps Key>

This example sets the key that is used by Bing Maps.

See also

Get-SPBingMapsKey


Set-SPBingMapsBlock
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Sets Bing maps to blocked status.

Set-SPBingMapsBlock [[-BlockBingMapsInAllLocales] <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

BlockBingMapsInAllLocales

Optional

System.Management.Automation.SwitchParameter

Specifies whether Bing Maps are blocked in all locales.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPBingMapsBlock cmdlet to specify whether to block Bing Maps in all locales, or not to block them in all locales. Bing Maps will be displayed only in non-restricted locales if this property is not set. The default value is 0 (not blocked). Use a value of 1 to block in all locales.

Input Types

Return Types

Example

-------------EXAMPLE----------

Copy code
Set-SPBingMapsBlock 1

This example displays how to block Bing Maps in all locales for the farm.

See also

Get-SPBingMapsBlock
Get-SPBingMapsKey
Set-SPBingMapskey


Get-SPBingMapsBlock
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Returns Bing Maps blocked status.

Get-SPBingMapsBlock [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPBingMapsBlock cmdlet to return true or false on whether Bing Maps are blocked in all locales. This cmdlet will return an object, and "BlockBingMapsInAllLocales" property will return True or False.

Input Types

Return Types

Example

-----------EXAMPLE-----------

Copy code
Get-SPBingMapsBlock

This example returns an object, and BlockBingMapsInAllLocales property will return True or False on whether Bing Maps are blocked in all locales.

See also

Set-SPBingMapsBlock
Get-SPBingMapsKey
Set-SPBingMapskey


Health monitoring cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you create and manage health analyzer rules in a SharePoint Server 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Disable-SPHealthAnalysisRule | Disables a health analyzer rule.
Enable-SPHealthAnalysisRule | Enables a health analyzer rule.
Get-SPHealthAnalysisRule | Returns a health analyzer rule.

See also

Windows PowerShell for SharePoint 2013 reference


Get-SPHealthAnalysisRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Gets a health analyzer rule.

Get-SPHealthAnalysisRule [-AssignmentCollection <SPAssignmentCollection>]
Get-SPHealthAnalysisRule [-Identity] <SPHealthAnalysisRuleInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPHealthAnalysisRuleInstancePipeBind

Specifies the name or GUID of the health analyzer rule to get.

The type must be a valid name, an instance of a valid SPHealthAnalysisRule object, or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Get-SPHealthAnalysisRule cmdlet to return a list of a health analyzer rules. To return a specify health analyzer rule, use the Identity parameter; otherwise, all health analyzer rules will be returned.

The SPHealthAnalysisRule cmdlets were first introduced in the February 2011 Cumulative Update, which is available for download as follows:

--Description of the SharePoint Foundation 2010 Cumulative Update Server Hotfix Package (SharePoint Foundation server-package)

--Description of the SharePoint Server 2010 Cumulative Update Server Hotfix Package (MOSS server-package

Input Types

Return Types

Example

---------------------EXAMPLE 1---------------------------

Copy code
Get-SPHealthAnalysisRule -Identity "CustomRule"

This example returns the health analyzer rule named CustomRule.

See also

Disable-SPHealthAnalysisRule
Enable-SPHealthAnalysisRule


Enable-SPHealthAnalysisRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Enables a health analyzer rule.

Enable-SPHealthAnalysisRule [-Identity] <SPHealthAnalysisRuleInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPHealthAnalysisRuleInstancePipeBind

Specifies the name or GUID of the health analyzer rule to enable.

The type must be a valid name, an instance of a valid SPHealthAnalysisRule object, or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Enable-SPHealthAnalysisRule cmdlet to enable a health analyzer rule.

Note:

The SPHealthAnalysisRule cmdlets were first introduced in the February 2011 Cumulative Update, which is available for download as follows:

--Description of the SharePoint Foundation 2010 Cumulative Update Server Hotfix Package (SharePoint Foundation server-package)

--Description of the SharePoint Server 2010 Cumulative Update Server Hotfix Package (MOSS server-package

Input Types

Return Types

Example

---------------------EXAMPLE 1---------------------------

Copy code
Enable-SPHealthAnalysisRule -Identity "CustomRule"

This example enables the health analyzer rule named CustomRule.

See also

Disable-SPHealthAnalysisRule
Get-SPHealthAnalysisRule


Disable-SPHealthAnalysisRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Disables health analyzer rules.

Disable-SPHealthAnalysisRule [-Identity] <SPHealthAnalysisRuleInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPHealthAnalysisRuleInstancePipeBind

Specifies the name or GUID of the health analyzer rule to disable.

The type must be a valid name; an instance of a valid SPHealthAnalysisRule object, or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Disable-SPHealthAnalysisRule cmdlet to disable a health analyzer rule.

Note:

The SPHealthAnalysisRule cmdlets were first introduced in the February 2011 Cumulative Update, which is available for download as follows:

--Description of the SharePoint Foundation 2010 Cumulative Update Server Hotfix Package (SharePoint Foundation server-package)

--Description of the SharePoint Server 2010 Cumulative Update Server Hotfix Package (MOSS server-package

Input Types

Return Types

Example

---------------------EXAMPLE 1---------------------------

Copy code
Disable-SPHealthAnalysisRule -Identity "CustomRule"

This example disables the health analyzer rule named CustomRule.

See also

Enable-SPHealthAnalysisRule
Get-SPHealthAnalysisRule


Import and export cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you import or export site collections, web applications, lists, or libraries in a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use Windows PowerShell to import or export a site collection, web application, list, or library.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Import-SPWeb | Imports a site collection, web application, list, or library.
Export-SPWeb | Exports a site collection, web application, list, or library.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Import-SPWeb
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Imports a web, list, or library.

Import-SPWeb [-Identity] <SPWebPipeBind> -Path <String> [-ActivateSolutions <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-HaltOnError <SwitchParameter>] [-HaltOnWarning <SwitchParameter>] [-IncludeUserCustomAction <None | All>] [-IncludeUserSecurity <SwitchParameter>] [-NoFileCompression <SwitchParameter>] [-NoLogFile <SwitchParameter>] [-UpdateVersions <Append | Overwrite | Ignore>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the URL or GUID of the Web to import into.

The type must be a valid URL, GUID, or object; for example, a valid URL, in the form http://server_name, or a GUID, in the form, 1234-4567-5678a.

Path

Required

System.String

Specifies the name of the import file.

If the NoFileCompression parameter is used, a directory must be specified; otherwise, any file format is valid.

ActivateSolutions

Optional

System.Management.Automation.SwitchParameter

Specifies whether user solutions are activated during import.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forcefully overwrites the export package if it already exists.

The type must be either of the following values

-True

-False

The default value is False.

HaltOnError

Optional

System.Management.Automation.SwitchParameter

Stops the import process when an error occurs.

HaltOnWarning

Optional

System.Management.Automation.SwitchParameter

Stops the import process when a warning occurs.

IncludeUserCustomAction

Optional

Microsoft.SharePoint.Deployment.SPIncludeUserCustomAction

Specifies whether User Custom Actions are included during import.

IncludeUserSecurity

Optional

System.Management.Automation.SwitchParameter

Preserves the user security settings except for SPLists that have broken inheritance and item level permissions set.

NoFileCompression

Optional

System.Management.Automation.SwitchParameter

Either enables or disables file compression in the import package. The import package is stored in the folder specified by the Path parameter or Identity parameter. We recommend that you use this parameter for performance reasons. If compression is enabled, the import process can increase by approximately 30 percent.

NoLogFile

Optional

System.Management.Automation.SwitchParameter

Suppresses the generation of an import log file. If this parameter is absent, the Import-SPWeb cmdlet will generate an export log file in the same location as the export package. The log file uses Unified Logging Service (ULS).

We recommend that you use this parameter. However, for performance reasons, you might not want to generate a log file.

UpdateVersions

No

Microsoft.SharePoint.Deployment.SPUpdateVersions

Indicates how to resolve situations where a file to be imported to a site already exists in that site. If the UpdateVersions parameter is absent, the import operation by default uses a value of 1.

The type must be any one of the following:

-Add new versions to the current file

-Overwrite the file and all of its versions (delete then insert)

-Ignore the file if it exists on the destination

The default value is Add new versions to the current file.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Import-SPWeb cmdlet imports a web, list, or library. The capability to import from a library is a new feature in SharePoint 2010 Products.

Input Types

Return Types

Example

---------------------EXAMPLE----------------------

Copy code
Import-SPWeb http://site -Path export.cmp -UpdateVersions Overwrite

This example imports the contents of export.cmp into a site at http://site, overwriting the versioned content on the site with the contents of the export.cmp file.

See also

Export-SPWeb
Get-SPWeb
New-SPWeb
Remove-SPWeb
Set-SPWeb


Export-SPWeb
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Exports a site, list, or library.

Export-SPWeb [-Identity] <SPWebPipeBind> -Path <String> [-AppLogFilePath <String>] [-AssignmentCollection <SPAssignmentCollection>] [-CompressionSize <Int32>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-HaltOnError <SwitchParameter>] [-HaltOnWarning <SwitchParameter>] [-IncludeUserSecurity <SwitchParameter>] [-IncludeVersions <LastMajor | CurrentVersion | LastMajorAndMinor | All>] [-ItemUrl <String>] [-NoFileCompression <SwitchParameter>] [-NoLogFile <SwitchParameter>] [-UseSqlSnapshot <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the URL or GUID of the Web to be exported.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint site (for example, MySPSite1); or an instance of a valid SPWeb object.

Path

Required

System.String

Specifies the name of the export file.

If the NoFileCompression parameter is used, a directory must be specified; otherwise, any file format is valid.

AppLogFilePath

Optional

System.String

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompressionSize

Optional

System.Int32

Sets the maximum file size for the compressed export files. If the total size of the exported package is greater than this size, the exported package will be split into multiple files.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forcefully overwrites the export package if it already exists.

The type must be either of the following values:

-True

-False

The default value is False.

HaltOnError

Optional

System.Management.Automation.SwitchParameter

Stops the export process when an error occurs.

HaltOnWarning

Optional

System.Management.Automation.SwitchParameter

Stops the export process when a warning occurs.

IncludeUserSecurity

Optional

System.Management.Automation.SwitchParameter

Preserves the user security settings except for SPLists that have broken inheritance and item level permissions set.

IncludeVersions

Optional

Microsoft.SharePoint.Deployment.SPIncludeVersions

Indicates the type of file and list item version history to be included in the export operation. If the IncludeVersions parameter is absent, the Export-SPWeb cmdlet by default uses a value of 1.

The type must be any one of the following versions:

-Last major version for files and list items (default)

-The current version, either the last major version or the last minor version

-Last major and last minor version for files and list items

-All versions for files and list items

ItemUrl

Optional

System.string

Specifies the URL of the Web application, GUID, or object to be exported.

The type must be a valid URL; for example, http://server_name.

NoFileCompression

Optional

System.Management.Automation.SwitchParameter

Either enables or disables file compression in the export package. The export package is stored in the folder specified by the Path parameter or Identity parameter. We recommend that you use this parameter for performance reasons. If compression is enabled, the export process can increase by approximately 30 percent.

NoLogFile

Optional

System.Management.Automation.SwitchParameter

Suppresses the generation of an export log file. If this parameter is not specified, the Export-SPWeb cmdlet will generate an export log file in the same location as the export package. The log file uses Unified Logging Service (ULS).

It is recommended to use this parameter. However, for performance reasons, you might not want to generate a log file.

UseSqlSnapshot

Optional

System.Management.Automation.SwitchParameter

Specifies a SQL Database Snapshot will be created when the export process begins, and all exported data will be retrieved directly from the database snapshot. This snapshot will be automatically deleted when export completes.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Export-SPWeb cmdlet exports a site, list, or library. The capability to export from a library is a new feature in SharePoint 2013.

Input Types

Return Types

Example

--------------------EXAMPLE-----------------------.

Copy code
Export-SPWeb http://site -Path "site export.cmp"

This example exports the site at http://site/ to a file called site export.cmp in the current directory.

See also

Get-SPWeb
New-SPWeb
Set-SPWeb
Import-SPWeb
Remove-SPWeb


InfoPath Services cmdlets in SharePoint Server 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you manage InfoPath Forms Services in a SharePoint Server 2013 farm.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

InfoPath Forms Services is a service in SharePoint Server 2013 that you can use to view, edit, and configure a form template in InfoPath 2013 or viewed within a Web browser.

All InfoPath Forms Services settings will support backup and recovery regardless of whether there is a UI setting in the Central Administration Web site. However, backup and recovery only apply to the service and administrative-level settings; end-user content is not backed up as part of this process.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Add-SPInfoPathUserAgent | Adds a user agent to a farm.
Disable-SPInfoPathFormTemplate | Deactivates an InfoPath 2013 form template from the specified site collection.
Enable-SPInfoPathFormTemplate | Activates an InfoPath 2013 form template in the specified site collection.
Export-SPInfoPathAdministrationFiles | Saves InfoPath 2013 form templates on the SharePoint Central Administration Web site and .udcx files to a .cab file.
Get-SPDataConnectionFile | Returns a data connection file or a collection of data connection files.
Get-SPDataConnectionFileDependent | Returns deployed forms on the server dependent on a universal data connection.
Get-SPInfoPathFormsService | Returns the InfoPath Forms Services in SharePoint Server 2013 settings that are in the farm.
Get-SPInfoPathFormTemplate | Returns an InfoPath 2013 form template.
Get-SPInfoPathUserAgent | Returns a user agent or all the currently defined user agents for the farm.
Get-SPInfoPathWebServiceProxy | Returns the Web proxy settings for the Web application.
Import-SPInfoPathAdministrationFiles | Imports InfoPath 2013 form templates and .udcx files that are located on the SharePoint Central Administration Web site.
Install-SPDataConnectionFile | Installs the provided data connection file.
Install-SPInfoPathFormTemplate | Installs an InfoPath 2013 form template on a farm.
Remove-SPInfoPathUserAgent | Removes a user agent.
Set-SPDataConnectionFile | Sets properties of a data connection file.
Set-SPInfoPathFormsService | Sets parameters for InfoPath Forms Services in SharePoint Server 2013.
Set-SPInfoPathFormTemplate | Sets properties of an InfoPath 2013 form template.
Set-SPInfoPathWebServiceProxy | Sets parameters for an existing SharePoint Web service application.
Start-SPInfoPathFormTemplate | Activates a previously quiesced InfoPath 2013 form template.
Stop-SPInfoPathFormTemplate | Disables an InfoPath 2013 form template on a farm before an upgrade.
Test-SPInfoPathFormTemplate | Validates that an InfoPath 2013 form template is browser-enabled.
Uninstall-SPDataConnectionFile | Removes a data connection file.
Uninstall-SPInfoPathFormTemplate | Removes an InfoPath 2013 form template from a farm.
Update-SPInfoPathUrl | Updates InfoPath 2013 form templates (.xsn files) and universal data connections (.udcx files), including all .xsn files and .udcx files that were deployed by an administrator.
Update-SPInfoPathFormTemplate | Upgrades all InfoPath 2013 form templates on the farm.
Update-SPInfoPathUserFileUrl | Updates InfoPath form templates (.xsn files) and universal data connections (.udcx files).

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Add-SPInfoPathUserAgent
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a user agent to a farm.

Add-SPInfoPathUserAgent [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the user agent to receive InfoPath 2013 files. These user agents represent search bots that are commonly used in an enterprise environment. If a different search technology is being used and InfoPath 2013 files are not being indexed, you can add additional search bots for that technology to the collection.

The type must be a valid file name; for example UserAgentName1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Add-SPInfoPathUserAgent cmdlet creates a user agent to receive the .xml file that contains the data of the form for indexing. The user agent receives the InfoPath 2013 files from InfoPath Forms Services in SharePoint Server 2013 instead of Web pages in response to an HTTP request.

Input Types

Return Types

Example

------------EXAMPLE-----------------

Copy code
Add-SPInfoPathUserAgent -Name "NewAgent"

This example creates a new agent named NewAgent.

See also

Get-SPInfoPathUserAgent
Remove-SPInfoPathUserAgent


Disable-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Deactivates a InfoPath 2013 form template from the specified site collection.

Disable-SPInfoPathFormTemplate [-Identity] <SPFormTemplatePipeBind> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormTemplatePipeBind

Specifies the InfoPath 2013 form template to disable.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a form template (for example, InfoPathFormTemplate1); a valid name of a form template files (for example, FormTemplateFile1.xsn); or an instance of a valid SPFormTemplate object.

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection that contains the InfoPath 2013 form template to deactivate.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Disable-SPInfoPathFormTemplate cmdlet deactivates the InfoPath 2013 form template that is specified in the Identity parameter.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Disable-SPInfoPathFormTemplate -Identity "FormTemplate.xsn" -Site http://testSite
Copy code
"FormTemplatexsn" | Disable-SPInfoPathFormTemplate -Site "http://testSite"

This example deactivates an InfoPath 2013 form template from a site collection named TestSite.

See also

Enable-SPInfoPathFormTemplate
Get-SPInfoPathFormTemplate
Install-SPInfoPathFormTemplate
Set-SPInfoPathFormTemplate
Start-SPInfoPathFormTemplate
Stop-SPInfoPathFormTemplate
Test-SPInfoPathFormTemplate
Uninstall-SPInfoPathFormTemplate
Update-SPInfoPathFormTemplate


Enable-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Activates a InfoPath 2013 form template in the specified site collection.

Enable-SPInfoPathFormTemplate [-Identity] <SPFormTemplatePipeBind> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormTemplatePipeBind

Specifies the InfoPath 2013 form template to activate. The form template must be an administrator-approved, browser-enabled form template that is available on the server farm.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a form template (for example, InfoPathFormTemplate1); a valid name of a form template files (for example, FormTemplateFile1.xsn); or an instance of a valid SPFormTemplate object.

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection that contains the InfoPath 2013 form template to activate.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Enable-SPInfoPathFormTemplate cmdlet activates an InfoPath 2013 form template to the SharePoint site collection specified in the Site parameter. This cmdlet returns a new InfoPath 2013 form template.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Enable-SPInfoPathFormTemplate -Identity "FormTemplate.xsn" -Site "http://TestSite"
Copy code
"FormTemplatexsn" | Enable-SPInfoPathFormTemplate -Site "http://TestSite"

This example activates an InfoPath 2013 form template to a site collection named TestSite.

See also

Disable-SPInfoPathFormTemplate
Get-SPInfoPathFormTemplate
Install-SPInfoPathFormTemplate
Set-SPInfoPathFormTemplate
Start-SPInfoPathFormTemplate
Stop-SPInfoPathFormTemplate
Test-SPInfoPathFormTemplate
Uninstall-SPInfoPathFormTemplate
Update-SPInfoPathFormTemplate


Export-SPInfoPathAdministrationFiles
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Saves InfoPath 2013 form templates on the SharePoint Central Administration Web site and .udcx files to a .cab file.

Export-SPInfoPathAdministrationFiles [-Path] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Identity <SPFormsServicePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Path

Required

System.String

Specifies the location and name of the output .cab file.

The type must be a valid file path, in the form \\ipadmin\folder\backups1\ipfsfiles.cab.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Identity

Optional

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormsServicePipeBind

Specifies the site collection that contains the InfoPath 2013 form template and Central Administration .udcx files to export.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Export-SPInfoPathAdministrationFiles cmdlet saves all InfoPath 2013 form templates (.xsn files) and universal data connections (.udcx files) that are located on the Central Administration page. The backup package includes all workflow forms in InfoPath that were deployed by an administrator and not included with SharePoint Server 2013, and includes browser forms that were deployed by an administrator. The backup package is output to the specified .cab file.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Export-SPInfoPathAdministrationFiles -path d:\file.cab

This example saves all InfoPath 2013 form templates (.xsn files) and universal data connections (.udcx files) located on the SharePoint Central Administration Web site in a compressed cabinet file named file.cab.

See also

Import-SPInfoPathAdministrationFiles


Get-SPDataConnectionFile
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a data connection file or a collection of data connection files.

Get-SPDataConnectionFile [[-Identity] <SPDataConnectionFilePipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.InfoPath.Server.Cmdlet.SPDataConnectionFilePipeBind

Specifies the data file connection to get.

The type must be a valid GUID, in form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a data connection file (for example, DataConnectionFileName1.udcx); or an instance of a valid SPDataConnectionFile object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPDataConnectionFile cmdlet gets a specified data connection file or a collection of data connection files. If the Identity parameter is not specified, the cmdlet returns the collection of data connection files for the farm.

Input Types

Return Types

Example

---------------EXAMPLE 1--------------

Copy code
Get-SPDataConnectionFile

This example lists the Identity, DisplayName, and WebAccessible properties ofeach .udcx file.

---------------EXAMPLE 2--------------

Copy code
"Sample.udcx" | Get-SPDataConnectionFile

This example lists the Identity, DisplayName, and WebAccessible properties of the specified file, named Sample.udcx.

---------------EXAMPLE 3--------------

Copy code
Get-SPDataConnectionFile | where {$_.Category -eq "Category1"}

This example lists the Identity, DisplayName, and WebAccessible properties of all .udcx files with the specified Category.

See also

Install-SPDataConnectionFile
Set-SPDataConnectionFile
Uninstall-SPDataConnectionFile


Get-SPDataConnectionFileDependent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns deployed forms on the server dependent on a universal data connection.

Get-SPDataConnectionFileDependent [-Identity] <SPDataConnectionFilePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPDataConnectionFilePipeBind

Specifies the data connection file to get.

The type must be a valid GUID, in form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a data connection file (for example, DataConnectionFileName1.udcx); or an instance of a valid SPDataConnectionFile object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPDataConnectionFileDependent returns all administrator deployed forms that depend on a specified universal data connection (.udc) file located in the central data connection store.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPDataConnectionFileDependant -Identity "FileName.udcx
Copy code
"FileName.udcx" | Get-SPDataConnectionFileDependant

This example displays a list of deployed forms with a specified name.


Get-SPInfoPathFormsService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the InfoPath Forms Services in SharePoint Server 2013 settings that are in the farm.

Get-SPInfoPathFormsService [-AssignmentCollection <SPAssignmentCollection>] [-Identity <SPFormsServicePipeBind>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Identity

Optional

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormsServicePipeBind

Specifies the InfoPath Forms Services settings to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a forms service (for example, FormsService1); or an instance of a valid SPFormsService object.

Detailed Description

The Get-SPInfoPathFormsService cmdlet reads the settings for the InfoPath Forms Services in SharePoint Server 2013.

Input Types

Return Types

Example

-----------EXAMPLE----------------

Copy code
Get-SPInfoPathFormsService

This example displays the InfoPath Forms Services settings for the entire farm.

See also

Set-SPInfoPathFormsService


Get-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a InfoPath 2013 form template.

Get-SPInfoPathFormTemplate [[-Identity] <SPFormTemplatePipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormTemplatePipeBind

Specifies the InfoPath 2013 form template to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a form template (for example, InfoPathFormTemplate1); a valid name of a form template files (for example, FormTemplateFile1.xsn); or an instance of a valid SPFormTemplate object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPInfoPathFormTemplate cmdlet reads a specific InfoPath 2013 form template or the collection of templates. If the Identity parameter is not specified, the cmdlet returns the collection of InfoPath 2013 form templates for the farm.

Input Types

Return Types

Example

---------------EXAMPLE 1--------------

Copy code
Get-SPInfoPathFormTemplate

This example lists the Identity, DisplayName, and FormTemplateStatus property for each admininstrator-deployed InfoPath 2013 form template.

---------------EXAMPLE 2--------------

Copy code
"SomeFormTemplate.xsn" | Get-SPInfoPathFormTemplate | format-list

This example lists all the properties of the specified InfoPath 2013 form template.

See also

Disable-SPInfoPathFormTemplate
Enable-SPInfoPathFormTemplate
Install-SPInfoPathFormTemplate
Set-SPInfoPathFormTemplate
Start-SPInfoPathFormTemplate
Stop-SPInfoPathFormTemplate
Test-SPInfoPathFormTemplate
Uninstall-SPInfoPathFormTemplate
Update-SPInfoPathFormTemplate


Get-SPInfoPathUserAgent
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a user agent or all the currently defined user agents for the farm.

Get-SPInfoPathUserAgent [[-Identity] <SPUserAgentPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.InfoPath.Server.Cmdlet.SPUserAgentPipeBind

Specifies the user agent to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a user agent (for example, UserAgent1; or an instance of a valid SPUserAgent object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPInfoPathUserAgent cmdlet reads the user agent specified in Identity. If the Identity parameter is not specified, this cmdlet returns the collection of user agents for the farm.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPInfoPathUserAgent

This example displays a list of user agents in the entire farm.

See also

Add-SPInfoPathUserAgent
Remove-SPInfoPathUserAgent


Get-SPInfoPathWebServiceProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the Web proxy settings for the Web application.

Get-SPInfoPathWebServiceProxy [-Identity] <SPWebServiceProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPWebServiceProxyPipeBind

Specifies the SharePoint Web application to get.

The type must be a valid URL, in the form http://server_name, or a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPInfoPathWebServiceProxy cmdlet reads the Web proxy settings for the SharePoint Web application specified in Identity.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPInfoPathWebServiceProxy -Identity "http://server_name"

This example displays the Web service proxy settings for a specified Web application.

See also

Set-SPInfoPathWebServiceProxy


Import-SPInfoPathAdministrationFiles
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Imports InfoPath 2013 form templates and .udcx files that are located on the SharePoint Central Administration Web site.

Import-SPInfoPathAdministrationFiles [-Path] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Identity <SPFormsServicePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Path

Required

System.String

Specifies the location of the .cab file to import.

The type must be a valid file path, in the form \\ipadmin\folder\backups1\ipfsfiles.cab.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Identity

Optional

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormsServicePipeBind

Specifies the destination InfoPath Forms Services service for the import.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a forms service (for example, FormsService1); or an instance of a valid SPFormsService object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Import-SPInfoPathAdministrationFiles cmdlet imports InfoPath 2013 form templates (.xsn files) and universal data connections (.udcx files) that are located on the SharePoint Central Administration Web site into the specified InfoPath Forms Services service. This cmdlet imports from a backup package that includes all workflow forms in InfoPath that were deployed by an administrator and not included with SharePoint Foundation 2013, and browser forms that were deployed by an administrator.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Import-SPInfoPathAdministrationFiles -path "backupfiles.cab"

This example imports form templates (XSN files) and universal data connections (UDCX files) located on the SharePoint Central Administration Web site into the specified Forms service.

See also

Export-SPInfoPathAdministrationFiles


Install-SPDataConnectionFile
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Installs the provided data connection file.

Install-SPDataConnectionFile [-Path] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Category <String>] [-Confirm [<SwitchParameter>]] [-Overwrite <SwitchParameter>] [-WebAccessible <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Path

Required

System.String

Specifies the full path to the name of the file in the data connection store.

The type must be the name of a valid data connection file; for example, C:\foldername\myconnection.udcx.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Category

Optional

System.String

Sets an arbitrary category on the file which can be used to group the files. The category name can have a maximum of 255 characters.

The type must be a valid string value; for example, Category1.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Overwrite

Optional

System.Management.Automation.SwitchParameter

Overwrites the existing data connection file. The default value is False.

WebAccessible

Optional

System.Management.Automation.SwitchParameter

Specifies that the universal data connection file can be accessed by using the Web service. If False, only the Forms Server 2013 can retrieve the universal data connection files internally. The default value is False.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Install-SPDataConnectionFile cmdlet installs the provided data connection file. If the specified data connection file exists, the user is prompted to replace the existing file.

This cmdlet does not create a new file. Instead, it creates a new data connection file object.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Install-SPDataConnectionFile -Path .\folder\sample.udcx -Category "Install" -WebAccessible $true
Copy code
".\folder\sample.udcx" | Install-SPDataConnectionFile -Category "Install" -Category "Category1"  -Overwrite $true

This example uploads a data connection file to a specified category.

This cmdlet is equivalent to the Upload Data Connection File user interface setting that is located on the Manage Data Connection Files page of the SharePoint Central Administration Web site.

See also

Get-SPDataConnectionFile
Set-SPDataConnectionFile
Uninstall-SPDataConnectionFile


Install-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Installs an InfoPath 2013 form template on a farm.

Install-SPInfoPathFormTemplate [-Path] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-EnableGradualUpgrade <SwitchParameter>] [-NoWait <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Path

Required

System.String

Specifies the path and name of the form template to install.

The type must be a valid path and file name of a form template, in the form:

- C:\folder_name\formtemplate_name

- \\server_name\folder_name\formtemplate_name

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

EnableGradualUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies that the new form can be gradually upgraded.

- If specified and the form template file exists, the form template is gradually upgraded and is then used for new sessions only.

- If not specified and the form template does not exist, the form is overwritten during an upgrade and is then used for exisiting and new sessions.

- If specified and the form template file does not exist, ignore the switch.

- If not specified and the file exists, the user is prompted to upgrade and to use the gradual upgrade if the upgrade is allowed.

NoWait

Optional

System.Management.Automation.SwitchParameter

Specifies that the form template is installed in the background and that the progress of the installation not be shown.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Install-SPInfoPathFormTemplate cmdlet installs an InfoPath 2013 form template on a farm.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Install-SPInfoPathFormTemplate -Path c:\Form.xsn
Copy code
"FormTemplateFirst.xsn", "FormTemplateSecond.xsn", "FormTemplateThird.xsn" | Install-SPInfoPathFormTemplate

This example installs multiple form templates on a farm.

See also

Disable-SPInfoPathFormTemplate
Enable-SPInfoPathFormTemplate
Get-SPInfoPathFormTemplate
Set-SPInfoPathFormTemplate
Start-SPInfoPathFormTemplate
Stop-SPInfoPathFormTemplate
Test-SPInfoPathFormTemplate
Uninstall-SPInfoPathFormTemplate
Update-SPInfoPathFormTemplate


Remove-SPInfoPathUserAgent
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a user agent.

Remove-SPInfoPathUserAgent [-Identity] <SPUserAgentPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPUserAgentPipeBind

Specifies the name of the user agent to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a user agent (for example, UserAgent1; or an instance of a valid SPUserAgent object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPIPUserAgent cmdlet removes a specified user agent from the user agent collection on a farm.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Remove-SPInfoPathUserAgent -Identity "UserAgentName"

This example removes a user agent.

See also

Add-SPInfoPathUserAgent
Get-SPInfoPathUserAgent


Set-SPDataConnectionFile
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a data connection file.

Set-SPDataConnectionFile [-Identity] <SPDataConnectionFilePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Category <String>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-DisplayName <String>] [-WebAccessible <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPDataConnectionFilePipeBind

Specifies the data connection file to update.

The type must be a valid GUID, in form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a data connection file (for example, DataConnectionFileName1.udcx); or an instance of a valid SPDataConnectionFile object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Category

Optional

System.String

Sets an arbitrary category on the file which can be used to group the files. The category name can have a maximum of 255 characters.

The type must be a valid string value; for example, Category1.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Sets the description for the data connection file. The name can be a maximum of 4096 alphanumeric characters.

The type must be a valid string; for example, Description of my universal data connection file.

DisplayName

Optional

System.String

Specifies the display name that describes the data connection file. The name can have a maximum of 255 characters.

The type must be a valid string; for example, InfoPathUDC1.

WebAccessible

Optional

System.String

Specifies that the universal data connection file can be accessed by using the Web service. If false, only the forms server can retrieve the universal data connection files internally. The default value is False.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPDataConnectionFile cmdlet sets the properties of the data connection file specified in the Identity parameter.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Set-SPDataConnectionFile -Identity "sample.udcx" -Category "Temp"

This example updates the Category of the specified .udcx file.

--------------EXAMPLE 2-----------------

Copy code
Set-SPDataConnectionFile -Identity "sample.udcx" -DisplayName "NewDisplayName"

This example updates the DisplayName of the specified .udcx file.

--------------EXAMPLE 3-----------------

Copy code
Sample.udcx" | Set-SPDataConnectionFile -Category "Temp"

This example updates the Category of the specified .udcx file.

--------------EXAMPLE 4-----------------

Copy code
Get-SPDataConnectionFile | where {$_.Category -eq "Category1"}  | Set-SPDataConnectionFile -Category "Category2"

This example updates the Category field for the collection of .udcx files that are returned from a query used by the Get-SPDataConnectionFile cmdlet.

See also

Get-SPDataConnectionFile
Install-SPDataConnectionFile
Uninstall-SPDataConnectionFile


Set-SPInfoPathFormsService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets parameters for InfoPath Forms Services in SharePoint Server 2013.

Set-SPInfoPathFormsService [-ActiveSessionTimeout <Nullable>] [-AllowEmbeddedSqlForDataConnections <String>] [-AllowUdcAuthenticationForDataConnections <String>] [-AllowUserFormBrowserEnabling <String>] [-AllowUserFormBrowserRendering <String>] [-AllowUserFormCrossDomainDataConnections <String>] [-AllowViewState <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultDataConnectionTimeout <Nullable>] [-Identity <SPFormsServicePipeBind>] [-MaxDataConnectionResponseSize <Nullable>] [-MaxDataConnectionRoundTrip <Nullable>] [-MaxDataConnectionTimeout <Nullable>] [-MaxFormLoadTime <Nullable>] [-MaxPostbacksPerSession <Nullable>] [-MaxSizeOfUserFormState <Nullable>] [-MaxUserActionsPerPostback <Nullable>] [-MemoryCacheSize <Nullable>] [-RequireSslForDataConnections <String>] [-ViewStateThreshold <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ActiveSessionTimeout

Optional

System.Nullable

Specifies the duration, in minutes, that a form's session state can remain active. The default value is 1440.

The type must be a non-negative integer value in the range from 0 through 999,999.

AllowEmbeddedSqlForDataConnections

Optional

System.String

Specifies a value that indicates whether embedded SQL authentication can be used by browser-enabled InfoPath 2013 form templates.

The type must be one of the following values: True, False (default)

AllowUdcAuthenticationForDataConnections

Optional

System.String

Specifies that authentication information in a universal data connection (.udcx file) can be used.

The type must be one of the following values: True (default), False

AllowUserFormBrowserEnabling

Optional

System.String

Specifies that users can browser enable form templates that do not contain form code, require full trust, enable rendering on a mobile device, or use a data connection managed by a server administrator.

The type must be one of the following values: True (default), False

AllowUserFormBrowserRendering

Optional

System.String

Specifies that browser-enabled form templates will be rendered by InfoPath Forms Services.

The type must be one of the following values: True (default), False

AllowUserFormCrossDomainDataConnections

Optional

System.String

Specifies that data connections to data sources located in a different domain can be queried.

The type must be one of the following values: True, False (default)

AllowViewState

Optional

System.String

Defines the location to store form session state: View state when True, or Session State Service when False.

The type must be one of the following values: True, False (default)

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultDataConnectionTimeout

Optional

System.Nullable

Specifies the default data connection timeout in milliseconds. The default value is 10000 (10 seconds).

The type must be a non-negative integer and less than or equal to the value set for MaxDataConnectionTimeout.

Identity

Optional

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormsServicePipeBind

Specifies the InfoPath Forms Services service to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an InfoPath Forms Services service (for example, FormsService1); or an instance of a valid SPFormsService object.

MaxDataConnectionResponseSize

Optional

System.Nullable

Specifies the maximum size allowed for a data connection response. The default value is 15000 kilobytes (KB).

The type must be a non-negative integer.

MaxDataConnectionRoundTrip

Optional

System.Nullable

Sets a threshold, in milliseconds, for the maximum time it takes from the start of a data request to the return of the data request on the server (the data connection round trip). If the data connection round trip time exceeds this threshold, an event is logged in the Operational log.

MaxDataConnectionTimeout

Optional

System.Nullable

Specifies the maximum data connection timeout in milliseconds. The default value is 20000 (20 seconds).

The type must be a non-negative integer and less than or equal to 999999.

MaxFormLoadTime

Optional

System.Nullable

Sets a threshold, in milliseconds, for maximum form load time. If form load time exceeds this threshold, an event is logged in the Operational log.

The MaxFormLoadTime parameter measures the time it takes for a form to open, starting from when the request is accepted by the server until it leaves the server.

MaxPostbacksPerSession

Optional

System.Nullable

Specifies the value of the maximum postbacks that an instance of a browser-enabled InfoPath 2013 form template can make to the InfoPath Forms Services service. The default value is 20.

The type must be a non-negative integer and less than or equal to 999999.

MaxSizeOfFormSessionState

Optional

System.Nullable

Specifies the value of the maximum size in kilobytes of session state an instance of a browser-enabled InfoPath form template can use. The default value is 4096.

The type must be a non-negative integer and less than or equal to 999999.

MaxUserActionsPerPostback

Optional

System.Nullable

Specifies the maximum user actions per postback. The default value is 200.

The type must be a non-negative integer and less than or equal to 999999.

MemoryCacheSize

Optional

System.Nullable

Sets the size, in megabytes (MB), of the cache for solutions in memory.

The default value is 250 MB.

RequireSslForDataConnections

Optional

System.String

Specifies the Secure Sockets Layer (SSL) requirement value. If data connections in browser-enabled form templates require basic authentication or digest authentication, a password is sent over the network. Set this value to True to require an SSL-encrypted connection for these authentication types.

The type must be one of the following values: True (default), False.

ViewStateThreshold

Optional

System.Nullable

Specifies the maximum size in kilobytes of the session state when stored in the form view. The default value is 40.

The type must be a non-negative integer and less than or equal to 99,999,999.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPInfoPathFormsService cmdlet modifies the settings for InfoPath Forms Services in SharePoint Server 2013.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Set-SPInfoPathFormsService -AllowUserFormBrowserEnabling $true -AllowUserFormBrowserRendering $false

This example modifies the AllowUserFormBrowserEnabling and AllowUserFormBrowserRendering parameter values.

--------------EXAMPLE 2-----------------

Copy code
Set-SPInfoPathFormsService -AllowViewState $true -ViewStateThreshold 40961

This example modifies the AllowViewState and ViewStateThreshold parameter values.

See also

Get-SPInfoPathFormsService


Set-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a InfoPath 2013 form template.

Set-SPInfoPathFormTemplate [-Identity] <SPFormTemplatePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Category <String>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormTemplatePipeBind

Specifies the InfoPath 2013 form template to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a form template (for example, InfoPathFormTemplate1); a valid name of a form template files (for example, FormTemplateFile1.xsn); or an instance of a valid SPFormTemplate object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Category

Optional

System.String

Specifies the category of the form template. The category name can have a maximum of 255 characters.

The type must be a valid name of a form template category; for example, FormTemplateCategory1.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPInfoPathFormsTemplate cmdlet modifies the category of an InfoPath 2013 form template or to specify the browser streams for the form template.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Set-InfoPathFormTemplate -Identity "Sample.xsn" -Category "WorkFlowCategory"

This example modifies the category property of a form template for a specified name.

See also

Disable-SPInfoPathFormTemplate
Enable-SPInfoPathFormTemplate
Get-SPInfoPathFormTemplate
Install-SPInfoPathFormTemplate
Start-SPInfoPathFormTemplate
Stop-SPInfoPathFormTemplate
Test-SPInfoPathFormTemplate
Uninstall-SPInfoPathFormTemplate
Update-SPInfoPathFormTemplate


Set-SPInfoPathWebServiceProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets parameters for an existing SharePoint Web service application.

Set-SPInfoPathWebServiceProxy [-Identity] <SPWebServiceProxyPipeBind> [-AllowForUserForms <String>] [-AllowWebServiceProxy <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPWebServiceProxyPipeBind

Specifies the SharePoint Web service application proxy to update.

The type must be a valid URL, in the form http://server_name; a valid name of a Web application (for example, WebApp1); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPWebServiceProxy object.

AllowForUserForms

Optional

System.String

Specifies that a form opened in the InfoPath client can use the InfoPath Forms Services Web service proxy to connect to a Web service. This parameter can be set only when AllowWebServiceProxy is set to True.

The type must be one of the following: True, False The default value is False.

AllowWebServiceProxy

Optional

System.String

Specifies that browser-enabled form templates can use the InfoPath Forms Services Web service proxy to connect to a Web service.

The type must be one of the following: True, False The default value is False.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPInfoPathWebServiceProxy cmdlet configures exposed parameters for an existing SharePoint Web application.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Set-SPInfoPathWebServiceProxy -Identity "http://server_name" -AllowWebServiceProxy $true

This example sets the Web service proxy for a Web application.

See also

Get-SPInfoPathWebServiceProxy


Start-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Activates a previously quiesced InfoPath 2013 form template.

Start-SPInfoPathFormTemplate [-Identity] <SPFormTemplatePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormTemplatePipeBind

Specifies the InfoPath 2013 form template to start.

The type must be a valid URL, in the form http://server_name; a valid name of a Web application (for example, WebApp1); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPWebServiceProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Start-SPInfoPathFormTemplate cmdlet activates a previously quiesced InfoPath 2013 form template after the form is upgraded. During update, a form is quiesced, which disables access to the form.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Start-SPInfoPathFormTemplate -Identity formName.xsn

This example activates a form with a specified name.

See also

Disable-SPInfoPathFormTemplate
Enable-SPInfoPathFormTemplate
Get-SPInfoPathFormTemplate
Install-SPInfoPathFormTemplate
Set-SPInfoPathFormTemplate
Stop-SPInfoPathFormTemplate
Test-SPInfoPathFormTemplate
Uninstall-SPInfoPathFormTemplate
Update-SPInfoPathFormTemplate


Stop-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Disables a InfoPath 2013 form template on a farm before an upgrade.

Stop-SPInfoPathFormTemplate [-Identity] <SPFormTemplatePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-TimeLeft <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormTemplatePipeBind

Specifies the InfoPath 2013 form template to start.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a form template (for example, InfoPathFormTemplate1); a valid name of a form template files (for example, FormTemplateFile1.xsn); or an instance of a valid SPFormTemplate object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

TimeLeft

Optional

System.Nullable

Specifies the time duration, in minutes, before the form template will be quiesced. The default value is 0.

An integer value in the range from 0 to 1440.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Stop-SPInfoPathFormTemplate cmdlet quiesces, or disables, an InfoPath 2013 form template before it upgrades the form. Before a form is updated it is quiesced, which disables access to the form. Use Start-SPIPFormTemplate to unquiesce, or activate, a form template after the form is upgraded.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Stop-SPInfoPathFormTemplate -Identity formName.xsn

This example disables a form template for a specified name.

See also

Disable-SPInfoPathFormTemplate
Enable-SPInfoPathFormTemplate
Get-SPInfoPathFormTemplate
Install-SPInfoPathFormTemplate
Set-SPInfoPathFormTemplate
Start-SPInfoPathFormTemplate
Test-SPInfoPathFormTemplate
Uninstall-SPInfoPathFormTemplate
Update-SPInfoPathFormTemplate


Test-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Validates that a InfoPath 2013 form template is browser-enabled.

Test-SPInfoPathFormTemplate [-Path] <String> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Path

Required

System.String

Specifies the path and name of the InfoPath 2013 form template to install.

The type must be a valid path and file name of a form template, in the form:

- C:\folder_name\formtemplate_name

- \\server_name\folder_name\formtemplate_name

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Test-SPInfoPathFormTemplate cmdlet validates that an InfoPath 2013 form template can be browser-enabled.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Test-SPInfoPathFormTemplate -Identity formName.xsn

This example validates an InfoPath 2013 form template for a specified name.

See also

Disable-SPInfoPathFormTemplate
Enable-SPInfoPathFormTemplate
Get-SPInfoPathFormTemplate
Install-SPInfoPathFormTemplate
Set-SPInfoPathFormTemplate
Start-SPInfoPathFormTemplate
Stop-SPInfoPathFormTemplate
Uninstall-SPInfoPathFormTemplate
Update-SPInfoPathFormTemplate


Uninstall-SPDataConnectionFile
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a data connection file.

Uninstall-SPDataConnectionFile [-Identity] <SPDataConnectionFilePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPDataConnectionFilePipeBind

Specifies the data connection file to remove.

The type must be a valid GUID, in form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a data connection file (for example, DataConnectionFileName1.udcx); or an instance of a valid SPDataConnectionFile object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Uninstall-SPDataConnectionFile cmdlet removes the data connection file specified in the Identity parameter.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Uninstall-SPDataConnectionFile -Identity "Sample.udcx
Copy code
"Sample1.udcx", "Sample2.udcx", "Sample3.udcx" | Uninstall-SPDataConnectionFile

This example uninstalls a specified data connection file in two different ways.

See also

Get-SPDataConnectionFile
Install-SPDataConnectionFile
Set-SPDataConnectionFile


Uninstall-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a InfoPath 2013 form template from a farm.

Uninstall-SPInfoPathFormTemplate [-Identity] <SPFormTemplatePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.InfoPath.Server.Cmdlet.SPFormTemplatePipeBind

Specifies the InfoPath form template to uninstall.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a form template (for example, InfoPathFormTemplate1); a valid name of a form template files (for example, FormTemplateFile1.xsn); or an instance of a valid SPFormTemplate object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Uninstall-SPInfoPathFormTemplate cmdlet removes a specified InfoPath 2013 form template from a farm.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Uninstall-SPInfoPathFormTemplate -Identity formName.xsn

This example removes an InfoPath 2013 form template from a farm.

See also

Disable-SPInfoPathFormTemplate
Enable-SPInfoPathFormTemplate
Get-SPInfoPathFormTemplate
Install-SPInfoPathFormTemplate
Set-SPInfoPathFormTemplate
Start-SPInfoPathFormTemplate
Stop-SPInfoPathFormTemplate
Test-SPInfoPathFormTemplate
Update-SPInfoPathFormTemplate


Update-SPInfoPathAdminFileUrl
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Updates InfoPath form templates (.xsn files) and universal data connections (.udcx files), including all .xsn files and .udcx files that were deployed by an administrator.

Update-SPInfoPathAdminFileUrl -Find <Uri> -Replace <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Scan <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Find

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://previous_server_name.

Replace

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Scan

Optional

System.Management.Automation.SwitchParameter

Run the tool and log the actions that can be taken. No content is changed as a result of the scan.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Update-SPInfoPathAdminFileUrl cmdlet updates data connections in administrator-approved InfoPath form templates (.xsn files) and universal data connections (.udcx files). This allows for InfoPath data connections that reference the current farm to be updated when content is migrated to a different farm URL. This cmdlet cannot update any references to URLs that exist in form template business logic (code). Typically, this cmdlet is used with the Import-SPInfoPathAdministratorFiles cmdlet.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPWebApplication http://contoso2010 | Update-SPInfoPathAdminFileUrl-find "http://contoso2007" -replace "http://contoso2010"

This example updates data connections in administrator-approved InfoPath form templates and universal data connection files. Data connections that reference http://contoso 2007 are updated to reference http://contoso2010.


Update-SPInfoPathFormTemplate
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Upgrades all InfoPath form templates on the farm.

Update-SPInfoPathFormTemplate [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Update-SPInfoPathFormTemplate cmdlet upgrades all the InfoPath form templates on a farm that were deployed by an administrator. Use this cmdlet after the farm is upgraded to a new version.

Input Types

Return Types

Example

---------------EXAMPLE--------------

Copy code
Update-SPInfoPathFormTemplate

This example updates InfoPath form templates on the entire farm.

See also

Disable-SPInfoPathFormTemplate
Enable-SPInfoPathFormTemplate
Get-SPInfoPathFormTemplate
Install-SPInfoPathFormTemplate
Set-SPInfoPathFormTemplate
Start-SPInfoPathFormTemplate
Stop-SPInfoPathFormTemplate
Test-SPInfoPathFormTemplate
Uninstall-SPInfoPathFormTemplate


Update-SPInfoPathUrl
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Runs a InfoPath 2013 .xsn/.udc fix-up on SharePoint Foundation 2013.

Update-SPInfoPathUrl -WebApplication <SPWebApplicationPipeBind> -Find <Uri> -Replace <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-CentralAdministrationFiles <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-PrepForGradualUpgrade <SwitchParameter>] [-Scan <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Update-SPInfoPathUrl -ContentDatabase <SPContentDatabase> -Find <Uri> -Replace <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-CentralAdministrationFiles <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-PrepForGradualUpgrade <SwitchParameter>] [-Scan <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Update-SPInfoPathUrl -Site <SPSitePipeBind> -Find <Uri> -Replace <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-CentralAdministrationFiles <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-PrepForGradualUpgrade <SwitchParameter>] [-Scan <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Update-SPInfoPathUrl -File <Uri> -Find <Uri> -Replace <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-CentralAdministrationFiles <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-PrepForGradualUpgrade <SwitchParameter>] [-Scan <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the parent SharePoint Web application where the update will start.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

Find

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://server_name.

Replace

Required

System.Uri

Specifies the URL to replace.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CentralAdministrationFiles

Optional

System.Management.Automation.SwitchParameter

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PrepForGradualUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies that the gradualUpgradeURL.xml file is inserted into the form template and SPFile persisted properties are added.

Scan

Optional

System.Management.Automation.SwitchParameter

Specifies that functionality is scanned.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ContentDatabase

Required

Microsoft.SharePoint.Administration.SPContentDatabase

Specifies the parent content database where the update will start.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content database (for example, SPContent DB1); or an instance of a valid SPContentDatabase object.

Find

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://server_name.

Replace

Required

System.Uri

Specifies the URL to replace.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CentralAdministrationFiles

Optional

System.Management.Automation.SwitchParameter

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PrepForGradualUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies that the gradualUpgradeURL.xml file is inserted into the form template and SPFile persisted properties are added.

Scan

Optional

System.Management.Automation.SwitchParameter

Specifies that functionality is scanned.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the parent site collection where the update will start.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

Find

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://server_name.

Replace

Required

System.Uri

Specifies the URL to replace.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CentralAdministrationFiles

Optional

System.Management.Automation.SwitchParameter

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PrepForGradualUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies that the gradualUpgradeURL.xml file is inserted into the form template and SPFile persisted properties are added.

Scan

Optional

System.Management.Automation.SwitchParameter

Specifies that functionality is scanned.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

4

Parameter

Required

Type

Description

File

Required

System.Uri

Specifies the parent file on a SharePoint Web site where the update will start.

Find

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://server_name.

Replace

Required

System.Uri

Specifies the URL to replace.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CentralAdministrationFiles

Optional

System.Management.Automation.SwitchParameter

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PrepForGradualUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies that the gradualUpgradeURL.xml file is inserted into the form template and SPFile persisted properties are added.

Scan

Optional

System.Management.Automation.SwitchParameter

Specifies that functionality is scanned.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Update-SPInfoPathUrls cmdlet updates form templates (.xsn files) and universal data connections (.udcx files) that are located on the SharePoint Central Administration Web site.

This cmdlet supports parameter sets for Web application, Content Database, Site, and File.

Input Types

Return Types

Example

--------------EXAMPLE-------------------

Copy code
Update-SPInfoPathUrl -Site "http://server_name" -Find "http://findUrl" -Replace "http://ReplaceUrl"

This example updates connection settings.


Update-SPInfoPathUserFileUrl
Example
[image]

Published: July 31, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Updates InfoPath form templates (.xsn files) and universal data connections (.udcx files).

Update-SPInfoPathUserFileUrl [-WebApplication] <SPWebApplicationPipeBind> -Find <Uri> -Replace <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Scan <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Update-SPInfoPathUserFileUrl [-ContentDatabase] <SPContentDatabasePipeBind> -Find <Uri> -Replace <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Scan <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Update-SPInfoPathUserFileUrl [-Site] <SPSitePipeBind> -Find <Uri> -Replace <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Scan <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the parent SharePoint Web application where the update will start.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object

Find

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://previous_server_name.

Replace

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Scan

Optional

System.Management.Automation.SwitchParameter

Run the tool and log the actions that can be taken. No content is changed as a result of the scan.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ContentDatabase

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the parent content database where the update will start.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a content database (for example, SPContent DB1); or an instance of a valid SPContentDatabase object.

Find

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://previous_server_name.

Replace

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Scan

Optional

System.Management.Automation.SwitchParameter

Run the tool and log the actions that can be taken. No content is changed as a result of the scan.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the parent site collection where the update will start.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://sites/example; or an instance of a valid SPSite object.

Find

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://previous_server_name.

Replace

Required

System.Uri

Specifies the URL to find.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Scan

Optional

System.Management.Automation.SwitchParameter

Run the tool and log the actions that can be taken. No content is changed as a result of the scan.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Update-SPInfoPathAdminFileUrl cmdlet updates data connections in InfoPath form templates (.xsn files) and universal data connections (.udcx files). This allows for InfoPath data connections that reference the current farm to be updated when content is migrated to a different farm URL.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPWebApplication http://contoso2010 | Update-SPInfoPathUserFileUrl-find "http://contoso2007" -replace "http://contoso2010"

This example updates data connections in InfoPath form templates and universal data connection files, for all content under the Web application http://contoso2010. Data connections that reference http://contoso2007 are updated to reference http://contoso2010.


Use Windows PowerShell cmdlets to manage user licenses in SharePoint 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to manage user licenses in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

The following table shows the Windows PowerShell cmdlets that you can use to manage SharePoint user licenses.

All cmdlets on this page are new to SharePoint Server 2013.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Add-SPUserLicenseMapping | Maps a security group, forms-based role, or claim to a SharePoint user license.
Disable-SPUserLicensing | Disables user license enforcement.
Enable-SPUserLicensing | Enables user-license enforcement.
Get-SPUserLicense | Returns the list of supported SharePoint user licenses.
Get-SPUserLicenseMapping | Returns the claim-to-user license mappings.
Get-SPUserLicensing | Returns the state of user-license enforcement.
New-SPUserLicenseMapping | Creates a license mapping object.
Remove-SPUserLicenseMapping | Removes a claim-to-SharePoint user license mapping.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Add-SPUserLicenseMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Maps a security group, forms-based role, or claim to a SharePoint user license.

Add-SPUserLicenseMapping -Mapping <List> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Mapping

Required

System.Collections.Generic.List

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Add-SPUserLicenseMapping cmdlet maps a claim, Active Directory Domain Services (AD DS) security group, or forms-based role to a SharePoint user license for a farm or web application. To specify a mapping to a specific web application, use the WebApplication parameter. If you do not specify parameters, mapping applies to the entire SharePoint farm.

Input Types

Return Types

Example

---------------EXAMPLE 1-------------------

Copy code
$a = New-SPUserLicenseMapping -SecurityGroup yoursecuritygroup -License Enterprise
Copy code
Add-SPUserLicenseMapping -Mapping $a

This example adds user mappings for the entire farm.

See also

Disable-SPUserLicensing
Enable-SPUserLicensing
Get-SPUserLicenseMapping
Remove-SPUserLicenseMapping


Disable-SPUserLicensing
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Disables user license enforcement.

Disable-SPUserLicensing [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Disable-SPUserLicensing cmdlet disables user license enforcement on the SharePoint farm.

Input Types

Return Types

Example

--------------EXAMPLE 1-------------------

Copy code
Disable-SPUserLicensing

This example disables user license enforcement on the SharePoint farm.


Enable-SPUserLicensing
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Enables user-license enforcement.

Enable-SPUserLicensing [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Enable-SPUserLicensing cmdlet enables user-license enforcement on the SharePoint farm.

Input Types

Return Types

Example

--------------EXAMPLE------------------

Copy code
Enable-SPUserLicensing

This example enables user-license enforcement on the SharePoint farm.


Get-SPUserLicense
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the list of supported SharePoint user licenses.

Get-SPUserLicense [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPUserLicense cmdlet returns the list of supported SharePoint user licenses in the SharePoint farm.

Input Types

Return Types

Example

-----------------EXAMPLE-------------------

Copy code
Get-SPUserLicense

This example returns the list of supported SharePoint user licenses for the SharePoint farm.


Get-SPUserLicenseMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the claim-to-user license mappings.

Get-SPUserLicenseMapping [-AssignmentCollection <SPAssignmentCollection>] [-WebApplication <SPWebApplicationPipeBind>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, web application name, or instance of a web application object from which to get the user license mappings. The type must be an URL in the form http://server_name or http://server_name/sites/sitename, a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh), a web application name (that is, SharePoint - 80), or an instance of a web application object.

Detailed Description

The Get-SPUserLicenseMapping cmdlet returns the claim-to-user license mappings for the entire SharePoint farm or a specific web application.

Note:

Getting the mappings for the entire farm does not retrieve any specific mappings on a web application.

If you specify no parameters, the license mappings for the entire farm are returned. To display the license mappings for a specific web application, use the WebApplication parameter.

Input Types

Return Types

Example

---------------EXAMPLE 1-----------------

Copy code
Get-SPUserLicenseMapping

This example returns all claim-to-user license mappings for the entire SharePoint farm.

---------------EXAMPLE 2 -----------------

Copy code
Get-SPUserLicenseMapping -WebApplication "SharePoint - 80"

This example returns all claim-to-user license mappings for the web application with the name "SharePoint - 80".

---------------EXAMPLE 3 -----------------

Copy code
Get-SPUserLicenseMapping -WebApplication http://<server_name>/sitename

This example returns all claim-to-user license mappings for the Web application with the URL http://<server_name>/sites/sitename.

See also

Add-SPUserLicenseMapping
Remove-SPUserLicenseMapping


Get-SPUserLicensing
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the state of user-license enforcement.

Get-SPUserLicensing [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPUserLicensing cmdlet returns the state of user-license enforcement for an entire SharePoint farm.

If user-license enforcement is enabled on a SharePoint farm, the return value is true. Otherwise the value is false.

Input Types

Return Types

Example

---------------EXAMPLE-------------

Copy code
Get-SPUserLicensing

This example returns the state of user-license enforcement on the SharePoint farm.

See also

Disable-SPUserLicensing
Enable-SPUserLicensing


New-SPUserLicenseMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a license mapping object.

New-SPUserLicenseMapping -License <String> -SecurityGroup <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]
New-SPUserLicenseMapping -License <String> -Role <String> -RoleProviderName <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]
New-SPUserLicenseMapping -ClaimType <String> -License <String> -OriginalIssuer <String> -Value <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ValueType <String>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]
New-SPUserLicenseMapping -Claim <SPClaim> -License <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

License

Required

System.String

Specifies the name of a supported SharePoint user license. For the full list of supported licenses on a SharePoint farm, see the Get-SPUserLicense cmdlet.

SecurityGroup

Required

System.String

Specifies the name of an AD DS security group. The value must be a name of an Active Directory security group.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, web application name, or web application object instance where the mapping is to be added. If you omit this parameter, the mapping is applied to the entire farm.

The type must be an URL in the form http://server_name or http://server_name/sites/sitename, a GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh), a name of a web application (for example, SharePoint - 80), or an instance of a web application object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

License

Required

System.String

Specifies the name of a supported SharePoint user license. For the full list of supported licenses on a SharePoint farm, see the Get-SPUserLicense cmdlet.

Role

Required

System.String

Specifies the name of a forms-based role. The value must be an authentic name of a forms-based role.

RoleProviderName

Required

System.String

Specifies the name of a role provider. The value must be an authentic name of a role provider.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, web application name, or web application object instance where the mapping is to be added. If you omit this parameter, the mapping is applied to the entire farm.

The type must be an URL in the form http://server_name or http://server_name/sites/sitename, a GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh), a name of a web application (for example, SharePoint - 80), or an instance of a web application object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

Claim

Required

Microsoft.SharePoint.Administration.Claims.SPClaim

Specifies the claims principal to license. The value must be an authentic claims principal.

ClaimType

Required

System.String

Specifies the type of the claim. The value must be an authentic name of a claim type.

License

Required

System.String

Specifies the name of a supported SharePoint user license. For the full list of supported licenses on a SharePoint farm, see the Get-SPUserLicense cmdlet.

OriginalIssuer

Required

System.String

Specifies the original issuer of the claim. The value must be the authentic name of an original issuer.

Value

Required

System.String

Specifies the value of the claim. The value must be an authentic claim value.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ValueType

Optional

System.String

Specifies the value type of the claim. The value must be an authentic name of a claim value type.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, web application name, or web application object instance where the mapping is to be added. If you omit this parameter, the mapping is applied to the entire farm.

The type must be an URL in the form http://server_name or http://server_name/sites/sitename, a GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh), a name of a web application (for example, SharePoint - 80), or an instance of a web application object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

4

Parameter

Required

Type

Description

Claim

Required

Microsoft.SharePoint.Administration.Claims.SPClaim

Specifies the claims principal to license. The value must be an authentic claims principal.

License

Required

System.String

Specifies the name of a supported SharePoint user license. For the full list of supported licenses on a SharePoint farm, see the Get-SPUserLicense cmdlet.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, web application name, or web application object instance where the mapping is to be added. If you omit this parameter, the mapping is applied to the entire farm.

The type must be an URL in the form http://server_name or http://server_name/sites/sitename, a GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh), a name of a web application (for example, SharePoint - 80), or an instance of a web application object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the New-SPUserLicenseMapping cmdlet to create a new license mapping object. This cmdlet must be used first before the Add-SPUserLicenseMapping cmdlet can be used.

The object created by using the New-SPUserLicenseMapping cmdlet is stored in memory and is not written to any database in SharePoint Server 2013. After the object is created you can pipe the result to the Add-SPUserLicenseMapping cmdlet.

Input Types

Return Types

Example

----------EXAMPLE-------------

Copy code
$a=New-SPUserLicenseMapping -SecurityGroup yoursecuritygroup -License Enterprise
Copy code
$a | Add-SPUserLicenseMapping

This example creates a license mapping object and then pipes the result to the Add-SPUserLicenseMapping cmdlet.

See also

Add-SPUserLicenseMapping
Get-SPUserLicenseMapping
Remove-SPUserLicenseMapping


Remove-SPUserLicenseMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a claim-to-SharePoint user license mapping.

Remove-SPUserLicenseMapping -Identity <List> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

System.Collections.Generic.List

Specifies the unique ID of a claim-to-license mapping. The type must be a valid GUID (that is, e69ba7cc-4be0-4723-ad63-58d06173afff).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPUserLicenseMapping cmdlet uses the Identity parameter to remove a claim-to-SharePoint user license mapping.

Input Types

Return Types

Example

----------------EXAMPLE---------------

Copy code
Remove-SPUserLicenseMapping -Identity e69ba7cc-4be0-4723-ad63-58d06173afff

This example removes the claim-to-license mapping that has the unique ID, e69ba7cc-4be0-4723-ad63-58d06173afff.

See also

Add-SPUserLicenseMapping
Get-SPUserLicenseMapping


Logging and events cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that enable you to log system events and perform diagnostics in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

You can use Windows PowerShell cmdlets to log system events and perform diagnostics.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Clear-SPLogLevel | Resets the Windows trace logging and event logging levels to their default values.
Get-SPLogLevel | Returns a list of objects or diagnostic levels.
Set-SPLogLevel | Sets the trace and event level for a set of categories.
Get-SPLogEvent | Returns results from a Unified Logging Service (ULS) trace log.
Get-SPDiagnosticConfig | Retrieves ULS diagnostic configuration values of the farm.
Get-SPDiagnosticsProvider | Returns a diagnostics provider.
Merge-SPLogFile | Combines trace log entries from all farm computers into a single log file on the local computer.
New-SPLogFile | Creates a new log file.
New-SPUsageLogFile | Starts a new usage log file on the current server computer.
Set-SPDiagnosticConfig | Sets diagnostic configuration settings on the farm.
Set-SPDiagnosticsProvider | Enables a diagnostics provider and updates its retention policy.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Clear-SPLogLevel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Resets the Windows trace logging and event logging levels to their default values.

Clear-SPLogLevel [-AssignmentCollection <SPAssignmentCollection>] [-Identity <String[]>] [-InputObject <PSObject>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Identity

Optional

System.String[]

Specifies the name(s) of the category or set of categories to set the throttle for; for example, "Unified Logging Service". If the Identity parameter is not specified, the event throttling setting is applied to all categories in the farm.

Providing an invalid category is a non-terminating error and will be ignored.

InputObject

Optional

System.Management.Automation.PSObject

Specifies the result of the InputObject parameter to be piped. The value can be a string in a format identical to the Identity parameter, or can be an SPDiagnosticsCategory object. The user can retrieve one or more categories from the Get-SPLogLevel cmdlet, modify their values, and then pipe the results to the Set-SPLogLevel cmdlet.

Detailed Description

The Clear-SPLogLevel cmdlet resets the Windows event logging and trace logging levels for the specified categories to the default values. If the Identity parameter is not provided, all categories are affected.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Clear-SPLogLevel -Identity Cat1

This example resets the log levels for a single category.

--------------EXAMPLE 2-----------------

Copy code
"Cat1", "Cat2", "Cat3" | Clear-SPLogLevel

This example resets the log levels for multiple categories.

--------------EXAMPLE 3-----------------

Copy code
Get-SPLogLevel | Clear-SPLogLevel

This example resets the log levels for all categories.

See also

Get-SPLogLevel
Set-SPLogLevel


Get-SPLogLevel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a list of objects or diagnostic levels.

Get-SPLogLevel [-AssignmentCollection <SPAssignmentCollection>] [-Identity <String[]>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Identity

Optional

System.String[]

Specifies a valid category name; for example, Backup and Restore, or Administration.

Detailed Description

The Get-SPLogLevel cmdlet displays a list of objects or diagnostic levels based on the criteria specified. If no parameter is specified, a list of all diagnostic levels for all categories is returned.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPLogLevel

This example displays throttle levels for all categories.

--------------EXAMPLE 2-----------------

Copy code
Get-SPLogLevel -Identity "Category1"

This example displays the throttle level for the Category1 category.

--------------EXAMPLE 3-----------------

Copy code
"Cat1", "Cat2", "Cat3" | Get-SpLogLevel

This example displays the throttle level for multiple categories.

--------------EXAMPLE 4-----------------

Copy code
Get-SPLogLevel -Identity "Area:*"

This example displays the throttle level for all categories in one area.

See also

Set-SPLogLevel
Clear-SPLogLevel


Set-SPLogLevel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the trace and event level for a set of categories.

Set-SPLogLevel [-AssignmentCollection <SPAssignmentCollection>] [-EventSeverity <String>] [-Identity <String[]>] [-InputObject <PSObject>] [-TraceSeverity <String>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

EventSeverity

Optional

System.String

Specifies the category level to be set. The category level is any one of the following values:

- None

- ErrorCritical

- Error

- Warning

- Information

- Verbose

Identity

Optional

System.String[]

Specifies the name(s) of the category or set of categories to set the throttle for; for example, "Unified Logging Service". If the Identity parameter is not specified, the event-throttling setting is applied to all categories in the farm.

InputObject

Optional

System.Management.Automation.PSObject

The InputObject is pipelined to the cmdlet and can be a string in a format identical to the Identity parameter, or can be an SPDiagnosticsCategory object. The user can retrieve one or more categories from the Get-SPLogLevel cmdlet, modify the category values, and then pipeline them into the Set-SPLogLevel cmdlet.

TraceSeverity

Optional

System.String

Specifies trace throttle to set the specified categor(ies) to. The trace log files are text files that are written to the trace log path that is defined on the Diagnostic Logging Settings page on the SharePoint Central Administration site. The type must be any one of the following values:

- None (no traces are written to the trace log)

- Unexpected

- Monitorable

- High

- Medium

- Verbose

- VerboseEx

Detailed Description

The Set-SPLogLevel cmdlet sets the Windows event logging and trace logging levels for one or more diagnostic logging categories registered in the farm. If an event or trace associated with a category occurs, but is less severe than that category's logging level, the event or trace is not written to the event log or the trace log. If an event or trace associated with a category occurs and is equally severe or more severe than that category's logging level, the event or trace is written to the event log or the trace log.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
set-sploglevel -TraceSeverity Monitorable

This example sets the TraceSeverity values for all categories to Monitorable.

------------------EXAMPLE 2-----------------------

Copy code
Set-SPLogLevel -TraceSeverity High -EventSeverity Warning -Identity "Cat1"

This example sets the EventSeverity and TraceSeverity values for a single category.

------------------EXAMPLE 3-----------------------

Copy code
"Cat1", "Cat2", "Cat3" | Set-SPLogLevel -EventSeverity Error

This example sets the EventSeverity values for multiple categories.

------------------EXAMPLE 4-----------------------

Copy code
Set-SPLogLevel -EventSeverity Warning -Identity "AreaName:*"

This example sets the EventSeverity values for all categories in the same area.

See also

Get-SPLogLevel
Clear-SPLogLevel


Get-SPLogEvent
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns results from a Unified Logging Service (ULS) trace log.

Get-SPLogEvent [-AssignmentCollection <SPAssignmentCollection>] [-AsString <SwitchParameter>] [-ContextKey <String[]>] [-Directory <String>] [-EndTime <DateTime>] [-MinimumLevel <String>] [-StartTime <DateTime>]
Get-SPLogEvent [-AssignmentCollection <SPAssignmentCollection>] [-AsString <SwitchParameter>] [-ContextKey <String[]>] [-EndTime <DateTime>] [-File <String>] [-MinimumLevel <String>] [-StartTime <DateTime>]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentColletion

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AsString

Optional

System.Management.Automation.SwitchParameter

Returns each record as a separate string

ContextKey

Optional

System.String[]

Specifies that context data should be added to the results for the specified Context Keys, for example: -ContextKey @("UserName", "SiteName").

Directory

Optional

System.String

Lists log files from an alternate directory (any directory other than the configured LogLocation directory).

MinimumLevel

Optional

System.String

Returns records at or above the specified level. The valid values are Error or Warning.

EndTime

Optional

System.DateTime

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

StartTime

Optional

System.DateTime

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

2

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentColletion

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AsString

Optional

System.Management.Automation.SwitchParameter

Returns each record as a separate string

ContextKey

Optional

System.String[]

Specifies that context data should be added to the results for the specified Context Keys, for example: -ContextKey @("UserName", "SiteName").

MinimumLevel

Optional

System.String

Returns records at or above the specified level. The valid values are Error or Warning.

EndTime

Optional

System.DateTime

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

File

Optional

System.String

Specifies a specific file to query records from.

StartTime

Optional

System.DateTime

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPLogEvent cmdlet returns records from a ULS trace log file that match the criteria. If no parameters are specified, all records from all log files are returned. Use the StartTime and EndTime parameters to filter on a time range. The use of these parameters is recommended to optimize performance of this cmdlet.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPLogEvent -MinimumLevel "Warning"

This example returns all log entries equal to or more severe than Warning from the default log directory.

--------------EXAMPLE 2-----------------

Copy code
Get-SPLogEvent -Directory "C:\Logs" | Where-Object {$_.Level -eq "Warning"}

This example returns all warning entries from log files in the C:\Logs directory.

--------------EXAMPLE 3-----------------

Copy code
Get-SPLogEvent -StartTime "12/04/2007 17:00" -EndTime "12/04/2007 18:00"

This example returns error entries that occurred during a particular time range, which is culture-specific to the United States.

--------------EXAMPLE 4-----------------

Copy code
Get-SPLogEvent -ContextKey @("UserName" ,"SiteName")

This example returns the contents of the most recent log file and adds the specified context key data.

--------------EXAMPLE 5-----------------

Copy code
Get-SPLogEvent | Where-Object {$_.Level -eq "Error" -and {$_.Area -eq "SharePoint Foundation "}

This example returns all error entries related to SharePoint Foundation.

--------------EXAMPLE 6-----------------

Copy code
Get-SPLogEvent -ContextKey @("Name") | %{$_.ToString() + "'t" + $_.Context["Name"]}

This example returns the contents of the log file and adds context data.

See also

New-SPLogFile
Get-SPLogLevel


Get-SPDiagnosticConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Retrieves ULS diagnostic configuration values of the farm.

Get-SPDiagnosticConfig [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPDiagnoticConfig cmdlet retrieves ULS diagnostic configuration values of the farm.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPDiagnosticConfig

This example returns all diagnostic configuration values.

See also

Set-SPDiagnosticConfig


Get-SPDiagnosticsProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a diagnostics provider.

Get-SPDiagnosticsProvider [[-Identity] <SPDiagnosticsProviderPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPDiagnosticsProviderPipeBind

Specifies the diagnostics provider to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a diagnostic provider (for example, DiagnosticsProv1); or an instance of a valid SPDiagnosticsProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPDiagnosticsProvider cmdlet reads the specified diagnostics provider. If the Identity parameter is not specified, this cmdlet returns the collection diagnostics providers in the farm.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Get-SPDiagnosticsProvider

This example returns all the diagnostics providers in the farm.

------------------EXAMPLE 2-----------------------

Copy code
Get-SPDiagnosticsProvider job-diagnostics-event-log-provider

This example returns the event log diagnostics provider.

See also

Set-SPDiagnosticsProvider


Merge-SPLogFile
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Combines trace log entries from all farm computers into a single log file on the local computer.

Merge-SPLogFile -Path <String> [-Area <String[]>] [-AssignmentCollection <SPAssignmentCollection>] [-Category <String[]>] [-ContextFilter <String[]>] [-Correlation <Guid[]>] [-EndTime <DateTime>] [-EventID <String[]>] [-ExcludeNestedCorrelation <SwitchParameter>] [-Level <String>] [-Message <String[]>] [-Overwrite <SwitchParameter>] [-Process <String[]>] [-StartTime <DateTime>] [-ThreadID <UInt32[]>]

Parameters

Parameter Required Type Description

Path

Required

System.String

Specifies the path and file name to which to write the merged log file. Relative paths are supported.

Area

Optional

System.String[]

Specifies the area name to filter on.

The type must be a valid name; for example, SharePoint Foundation.

The use of wildcards is supported.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Category

Optional

System.String[]

Specifies the category ID to filter on.

The type must be a valid category name; for example, category1.

The use of wildcards is supported.

ContextFilter

Optional

System.String[]

Specifies a filter for trace entries in a particular context in the form key=value, for example, user=contoso\joeuser.

Correlation

Optional

System.Guid[]

Specifies the correlation ID to filter on. The type must be a valid GUID, in the form F0BB0790-4323-A153-096F-ABCDC80E24D4.

EndTime

Optional

System.DateTime

Specifies the end time of the log entries returned.

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

EventID

Optional

System.String[]

Specifies the Event ID to filter on. The use of wildcards is supported.

ExcludeNestedCorrelation

Optional

System.Management.Automation.SwitchParameter

Excludes nested correlation values in the results. This parameter is only used when filtering results by using the ContextFilter parameter

By default, records returned from the ContextFilter parameter include all related records in addition to the records that match the filter. Specifying this option includes only the records that match the filter and excludes any related records.

Level

Optional

System.String

Specifies the level name to filter on.

Results include the specified level and everything more severe.

Message

Optional

System.String[]

Specifies the message text to filter on.

The type must be valid text. Text with spaces should be enclosed with quotation marks; for example, "This is a test."

The use of wildcards is supported.

Overwrite

No

System.Management.Automation.SwitchParameter

Overwrites the log file if it already exists at the specified path.

The type must be either of the following values:

- $True

- $False

The default value is $False.

Process

Optional

System.String[]

Specifies the process name to filter on.

The use of wildcards is supported.

StartTime

Optional

System.DateTime

Specifies the start time of the log entries returned.

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

The default is one hour prior to the current time on the local computer.

ThreadID

Optional

System.UInt32[]

Specifies the thread ID to filter on.

The type must be a valid integer from 0 through 4,294,967,295.

Detailed Description

The Merge-SPLogFile cmdlet returns records from Unified Logging Service (ULS) trace log files on each farm server that match the criteria, and writes the results to a new log file on the local computer. If no results are returned, a warning is written to the Windows PowerShell console window.

We recommend that you filter by using the StartTime and EndTime parameters to optimize performance of this cmdlet. Some filtering parameters such as Process, Area, Category, EventID and Message support wildcards.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Merge-SPLogFile -Path "C:\Logs\FarmMergedLog.log" -Overwrite

This example merges the last hour of log data from all farm computers with no filtering.

--------------EXAMPLE 2-----------------

Copy code
Merge-SPLogFile -Path "C:\Logs\FarmMergedLog.log" -Overwrite -Area Search

This example merges the last hour of log data from the Search area.

--------------EXAMPLE 3-----------------

Copy code
Merge-SPLogFile -Path "C:\Logs\FarmMergedLog.log" -Overwrite -Area "SharePoint Foundation","Web Analytics Services"

This example merges the last hour of log data from the SharePoint Foundation and Web Analytics Services areas.

--------------EXAMPLE 4-----------------

Copy code
Merge-SPLogFile -Path "C:\Logs\FarmMergedLog.log" -Overwrite -Level High

This example merges the log data of level High or higher.

--------------EXAMPLE 5-----------------

Copy code
Merge-SPLogFile -Path "C:\Logs\FarmMergedLog.log" -Overwrite -StartTime "06/09/2008 16:00" - EndTime "06/09/2008 16:15"

This example merges the log data for events in a particular time range, which is culture-specific to the United States.

--------------EXAMPLE 6-----------------

Copy code
Merge-SPLogFile -Path "C:\Logs\FarmMergedLog.log" -Overwrite -Message "*permission changed*"

This example merges the log data for events with permission changed in the message text.

--------------EXAMPLE 7-----------------

Copy code
Merge-SPLogFile -Overwrite -Path d:\1.log -ContextFilter "name=timer job*" -Area "*search*"

This example merges the log data for all search timer jobs.

--------------EXAMPLE 8-----------------

Copy code
Merge-SPLogFile -Overwrite -Path d:\2.log -ContextFilter "user=contoso?joeuser"

This example shows how to merge the log data for all user names that have a contoso\joeuser or Contoso/joeuser format.

See also

New-SPLogFile


New-SPLogFile
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new log file.

New-SPLogFile [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The New-SPLogFile cmdlet ends the current log file and starts a new log file.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
New-SPLogFile

This example ends the current log file and starts a new log file.

See also

Merge-SPLogFile


New-SPUsageLogFile
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Starts a new usage log file on the current server computer.

New-SPUsageLogFile [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The New-SPUsageLogFile cmdlet starts a new usage log file on the current server computer. The usage data in memory is flushed to the current usage log file before the new log file is created.

Input Types

Return Types

Example

-------------------EXAMPLE-------------------

Copy code
New-SPUsageLogFile

This example terminates the current usage log file and creates a new one.


Set-SPDiagnosticConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets diagnostic configuration settings on the farm.

Set-SPDiagnosticConfig [-AllowLegacyTraceProviders <SwitchParameter>] [-AppAnalyticsAutomaticUploadEnabled <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-CustomerExperienceImprovementProgramEnabled <SwitchParameter>] [-DaysToKeepLogs <Int32>] [-DownloadErrorReportingUpdatesEnabled <SwitchParameter>] [-ErrorReportingAutomaticUploadEnabled <SwitchParameter>] [-ErrorReportingEnabled <SwitchParameter>] [-EventLogFloodProtectionEnabled <SwitchParameter>] [-EventLogFloodProtectionNotifyInterval <Int32>] [-EventLogFloodProtectionQuietPeriod <Int32>] [-EventLogFloodProtectionThreshold <Int32>] [-EventLogFloodProtectionTriggerPeriod <Int32>] [-InputObject <PSObject>] [-LogCutInterval <Int32>] [-LogDiskSpaceUsageGB <Int32>] [-LogLocation <String>] [-LogMaxDiskSpaceUsageEnabled <SwitchParameter>] [-ScriptErrorReportingDelay <Int32>] [-ScriptErrorReportingEnabled <SwitchParameter>] [-ScriptErrorReportingRequireAuth <SwitchParameter>]

Parameters

Parameter Required Type Description

AllowLegacyTraceProviders

Optional

System.Management.Automation.SwitchParameter

Specifies that trace providers built for previous versions of SharePoint Products and Technologies can write to the trace session for SharePoint 2010 Products.

AppAnalyticsAutomaticUploadEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether aggregated app usage data is automatically uploaded to Microsoft.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CustomerExperienceImprovementProgramEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether participation in the Customer Experience Improvement Program (CEIP) is enabled.

The CEIP is designed to improve the quality, reliability, and performance of Microsoft products and technologies. With your permission, anonymous information about your server is sent to Microsoft to help improve SharePoint 2010 Products.

The type must be either of the following values:

- $True

- $False

The default value is $True.

DaysToKeepLogs

Optional

System.Int32

Specifies the number of days to keep trace log files. The type must be a valid number between 1 and 366. The default value is 14 days..

DownloadErrorReportingUpdatesEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether the error reporting remote control file is downloaded.

The type must be either of the following values:

- $True

- $False

The default value is $True.

ErrorReportingAutomaticUploadEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether error reports are uploaded to Microsoft automatically.

Error reports include the following: information regarding the condition of the server when a problem occurs; the operating system version and computer hardware in use; and the digital product ID, which can be used to identify your license. The IP address of your computer is also sent because you are connecting to an online service to send error reports; however, the IP address is used only to generate aggregate statistics.

The type must be either of the following values:

- $True

- $False

The default value is $True.

ErrorReportingEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether collection of error reports is enabled.

Error reports are created when your system encounters hardware or software problems. Microsoft and its partners actively use these reports to improve the reliability of the software. Error reports include the following: information regarding the condition of the server when the problem occurs; the operating system version and computer hardware in use; and the digital product ID, which can be used to identify your license. The IP address of your computer is also sent because you are connecting to an online service to send error reports; however, the IP address is used only to generate aggregate statistics.

The type must be either of the following values:

- $True

- $False

The default value is $True.

EventLogFloodProtectionEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether the Event log flood protection feature is enabled.

If multiple similar events are written to the event log, some duplicate messages are suppressed. Then, after a period of time, a summary message is written that shows how many events were suppressed.

The type must be either of the following values:

- $True

- $False

The default value is $True.

EventLogFloodProtectionNotifyInterval

Optional

System.Int32

Specifies in minutes how often to write a summary event indicating how many events were suppressed due to flood protection.

The integer range is between 1 and 1440. The default value is 5.

EventLogFloodProtectionQuietPeriod

Optional

System.Int32

Specifies in minutes how much time must pass without an event firing to exit flood protection.

The integer range is between 1 and 1440. The default value is 2.

EventLogFloodProtectionThreshold

Optional

System.Int32

Specifies the number of events allowed in a given timeframe before an event is considered to be flooding the event log.

The integer range is between 1 and 100. The default value is 5.

EventLogFloodProtectionTriggerPeriod

Optional

System.Int32

Specifies in minutes the timeframe to watch for events that may be flooding.

The integer range is between 1 and 1440. The default value is 2.

InputObject

Optional

System.Management.Automation.PSObject

Use the result from the Get-SPDiagnosticConfig cmdlet, make modifications, and then pipeline the object into Set-SPDiagnosticConfig cmdlet to update the content database.

LogCutInterval

Optional

System.Int32

Specifies a time period to roll over to the next log file.

The type must be a valid number between 0 and 1440.

The default value is 30.

LogDiskSpaceUsageGB

Optional

System.Int32

Specifies the maximum amount of storage to use for trace log files, in gigabytes (GB).

The default value is 1000 and only takes effect when the LogMaxDiskSpaceusageEnabled cmdlet is set to True.

The type must be a valid number between 1 and 1000.

LogLocation

Optional

System.String

Specifies the path of where to log files will reside.

The type must be a valid path, in the form C:\Logs.

The default location is %CommonProgramFiles%\Microsoft Shared\Web Server Extensions\14\Logs.

LogMaxDiskSpaceUsageEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether to restrict the maximum space to use for trace log files.

The type must be either of the following values:

- $True

- $False

The default value is $False.

ScriptErrorReportingDelay

Optional

System.Int32

Specifies the time (in minutes) between script error reports.

The type must be a valid integer between 0 and 1440. The value is specified in minutes.

The default value is 30.

ScriptErrorReportingEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether error reporting is enabled for client script errors.

The type must be either of the following values:

- $True

- $False

The default value is $True.

ScriptErrorReportingRequireAuth

Optional

System.Management.Automation.SwitchParameter

Specifies whether script error reporting requires authentication.

The type must be either of the following values:

- $True

- $False

The default value is $True.

Detailed Description

Use the Set-SPDiagnosticConfig cmdlet to set diagnostic configuration settings on the entire farm.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
set-spdiagnosticconfig -errorReportingEnable -DownloadErrorReportingUpdatesEnabled:$false -DaysToKeepLog  60

This example enables ErrorReporting, disables DownloadErrorReportingUpdatesEnable, and sets DaysToKeepLog to 60.

------------------EXAMPLE 2-----------------------

Copy code
$L = get-spdiagnosticconfig
Copy code
$L.CustomerExperienceImprovementProgramEnabled = $false
Copy code
$L.LogCutInterval = 60
Copy code
$L | Set-SPDiagnosticConfig

This example disables CEIP and sets LogCutInterval to 60 minutes.

See also

Get-SPDiagnosticConfig


Set-SPDiagnosticsProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Enables a diagnostics provider and updates its retention policy.

Set-SPDiagnosticsProvider [-Identity] <SPDiagnosticsProviderPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DaysRetained <Int32>] [-Enable <SwitchParameter>] [-MaxTotalSizeInBytes <Int64>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPDiagnosticsProviderPipeBind

Specifies the diagnostics provider to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a diagnostic provider (for example, DiagnosticProv1); or an instance of a valid SPDiagnosticsProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DaysRetained

Optional

System.Int32

Specifies the number of days to retain the data collected by a diagnostics provider.

The type must be a valid integer value in the range of 1 to 14.

Enable

Optional

System.Management.Automation.SwitchParameter

Turns on or off the specified diagnostics provider.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPDiagnosticsProvider cmdlet enables a diagnostics provider and updates its retention policy.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
Get-SPDiagnosticsProvider job-diagnostics-event-log-provider | Set-SPDiagnosticsProvider -Enable:$false
Copy code
Get-SPDiagnosticsProvider job-diagnostics-event-log-provider

This example disables the event log diagnostics provider.

------------------EXAMPLE 2-----------------------

Copy code
Get-SPDiagnosticsProvider job-diagnostics-event-log-provider | Set-SPDiagnosticsProvider -Enable -DaysRetained 10
Copy code
Get-SPDiagnosticsProvider job-diagnostics-event-log-provider

This example enables the event log diagnostics provider and changes its retention policy to 10 days.

See also

Get-SPDiagnosticsProvider


Use Windows PowerShell cmdlets to manage MachineTranslation Service applications in SharePoint Server 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to manage Machine Translation Service service applications in SharePoint 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The following table shows the Windows PowerShell cmdlets that you can use to manage Machine Translation Service service applications in SharePoint 2013.

All of the cmdlets listed on this page are new to SharePoint Server 2013.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
New-SPTranslationServiceApplication | Provisions a new instance of the Machine Translation service.
New-SPTranslationServiceApplicationProxy | Creates a Machine Translation Service application proxy on the local farm.
Remove-SPTranslationServiceJobHistory | Removes Machine Translation service jobs.
Set-SPTranslationServiceApplication | Sets property settings on a Machine Translation service application.
Set-SPTranslationServiceApplicationProxy | Sets properties to the Machine Translation service application proxy.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


New-SPTranslationServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Provisions a new instance of the Machine Translation service.

New-SPTranslationServiceApplication [-Name] <String> -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredential <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-Default <SwitchParameter>] [-FailoverDatabaseServer <String>] [-PartitionMode <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the unique identifier of Translation Service instance to be created.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the managed application pool that the instance of Translation Service will run in.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredential

Optional

System.Management.Automation.PSCredential

Specifies the SQL Server credentials used for this Translation Service instance. This parameter to be used only used for SQL authentication; if not present, Windows authentication is used instead.

DatabaseName

Optional

System.String

Specifies the database name which is to be used for this Translation Service instance.

DatabaseServer

Optional

System.String

Specifies the database server which is to be used for this Translation Service instance.

Default

Optional

System.Management.Automation.SwitchParameter

Determines whether or not the proxy for this service application should be added to the default proxy group for this Web application.

FailoverDatabaseServer

Optional

System.String

Specifies the SQL server instance that will be used as a backup to the primary SQL Server instance.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Restricts this service to behave uniquely on a partitioned set of site collections. This cannot be changed after the application is provisioned

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPTranslationServiceApplication cmdlet to provision a new instance of the Machine Translation service on the farm.

Input Types

Return Types

Example

-------------EXAMPLE---------------

Copy code
New-SPTranslationServiceApplication -Name TranslationService -ApplicationPool "SharePoint Web Services Default" -DatabaseServer Server1 -DatabaseName TranslationServiceDatabase

This example creates a Machine Translation service application named TranslationService which will run in the SharePoint Web Services Default service application pool. The database will be called TranslationServiceDatabase and will be hosted on the Server1 SQL server instance.

See also

Set-SPTranslationServiceApplication
New-SPTranslationServiceApplicationProxy
Set-SPTranslationServiceApplicationProxy


New-SPTranslationServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a Machine Translation Service application proxy on the local farm.

New-SPTranslationServiceApplicationProxy -Name <String> -ServiceApplication <TranslationServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-PartitionMode <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
New-SPTranslationServiceApplicationProxy -Name <String> -Uri <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-PartitionMode <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the display name for the new Machine Translation Service application. The name that you use must be a unique name of a Machine Translation Service application in this farm. The name can be a maximum of 128 characters.

ServiceApplication

Required

Microsoft.Office.TranslationServices.Powershell.TranslationServiceApplicationPipeBind

Specifies the local Machine Translation Service application that is associated with the new proxy.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Machine Translation Service application (for example, MachTrans1); or an instance of a valid SPServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the Machine Translation Service application proxy be added to the default proxy group for the local farm.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application restrict data by site group. After the PartitionMode parameter is set and the service application is created, it cannot be changed

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the display name for the new Machine Translation Service application. The name that you use must be a unique name of a Machine Translation Service application in this farm. The name can be a maximum of 128 characters.

Uri

Required

System.String

Specifies the URI of the remote machine translation service application this proxy should communicate with. This value is required only if you plan to connect a Machine Translation Service application from a remote farm.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the Machine Translation Service application proxy be added to the default proxy group for the local farm.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application restrict data by site group. After the PartitionMode parameter is set and the service application is created, it cannot be changed

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPTranslationServiceApplicationProxy cmdlet creates a Machine Translation Service application proxy on the local farm. The proxy is added to the default proxy group for the local farm.

Input Types

Return Types

Example

-----------EXAMPLE---------

Copy code
New-SPTranslationServiceApplicationProxy -Name TranslationServiceProxy -ServiceApplication TranslationService -DefaultProxyGroup

This example creates a Machine Translation Service application proxy in the default proxy group named TranslationServiceProxy which connects to the Machine Translation Service application named TranslationService.

See also

New-SPTranslationServiceApplication
Set-SPTranslationServiceApplication
Set-SPTranslationServiceApplicationProxy


Remove-SPTranslationServiceJobHistory
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes Machine Translation service jobs.

Remove-SPTranslationServiceJobHistory [-Identity] <TranslationServiceApplicationPipeBind> [-AllPartitions <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-BeforeDate <Nullable>] [-Confirm [<SwitchParameter>]] [-IncludeActiveJobs <SwitchParameter>] [-JobId <Nullable>] [-PartitionId <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.TranslationServices.Powershell.TranslationServiceApplicationPipeBind

Specifies the URL or GUID of the instance of the Machine Translation service to remove.

The type must be a valid URL, in the form http://server_name or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

AllPartitions

Optional

System.Management.Automation.SwitchParameter

Removes all the jobs from the database given other parameters.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BeforeDate

Optional

System.Nullable

Specifies all expired jobs before a given date.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IncludeActiveJobs

Optional

System.Management.Automation.SwitchParameter

Specifies expired jobs which contain active translations. By default, jobs are not deleted if a translation is active.

JobId

Optional

System.Nullable

Specifies only a job Id and its items to expire.

PartitionId

Optional

System.Nullable

Specifies only a partition Id and its items to expire.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPTranslationServiceJobHistory cmdlet to remove a machine translation service job from the job history database.

Input Types

Return Types

Example

------------------EXAMPLE--------------

Copy code
Remove-SPTranslationServiceJobHistory TranslationService -BeforeDate 2012/01/31

This example removes all jobs completed before 2012/01/31 in the database associated with the Machine Translation Service application named TranslationService.


Set-SPTranslationServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets property settings on a Machine Translation service application.

Set-SPTranslationServiceApplication [-Identity] <TranslationServiceApplicationPipeBind> [-AddEnabledFileExtensions <String[]>] [-ApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-ClearEnabledFileExtensions <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-DatabaseCredential <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-DisableBinaryFileScan <Nullable>] [-EnableAllFileExtensions <SwitchParameter>] [-FailoverDatabaseServer <String>] [-JobExpirationDays <Nullable>] [-KeepAliveTimeout <Nullable>] [-MachineTranslationAddress <String>] [-MachineTranslationCategory <String>] [-MachineTranslationClientId <String>] [-MaximumBinaryFileSize <Nullable>] [-MaximumItemsPerDay <Nullable>] [-MaximumItemsPerPartitionPerDay <Nullable>] [-MaximumSyncTranslationRequests <Nullable>] [-MaximumTextFileSize <Nullable>] [-MaximumTranslationAttempts <Nullable>] [-MaximumTranslationTime <Nullable>] [-MaximumWordCharacterCount <Nullable>] [-RecycleProcessThreshold <Nullable>] [-RemoveEnabledFileExtensions <String[]>] [-TimerJobFrequency <Nullable>] [-TotalActiveProcesses <Nullable>] [-TranslationsPerInstance <Nullable>] [-UseDefaultInternetSettings <SwitchParameter>] [-WebProxyAddress <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.TranslationServices.Powershell.TranslationServiceApplicationPipeBind

Specifies the URL or GUID of the instance of the Machine Translation service to set.

The type must be a valid URL in the form, http://server_name or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

AddEnabledFileExtensions

Optional

System.String[]

Comma delimited list of file extensions that you want to add to the set of enabled file extensions for the Machine Translation Service application

To return a list of supported file extensions, type [Microsoft.Office.TranslationServices.TranslationService]::EnumerateFileExtensions().

ApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the managed application pool that the instance of Translation Service will run in.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ClearEnabledFileExtensions

Optional

System.Management.Automation.SwitchParameter

Disables all file extensions for the Machine Translation Service application.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredential

Optional

System.Management.Automation.PSCredential

Specifies the SQL Server credentials used for this Translation Service instance. This parameter to be used only used for SQL authentication; if not present, Windows authentication is used instead.

DatabaseName

Optional

System.String

Specifies the database name which is to be used for this Translation Service instance.

DatabaseServer

Optional

System.String

Specifies the database server which is to be used for this Translation Service instance.

DisableBinaryFileScan

Optional

System.Nullable

Determines whether Gatekeeper is run on binary files.

EnableAllFileExtensions

Optional

System.Management.Automation.SwitchParameter

Enables all file extensions for the Machine Translation Service application.

FailoverDatabaseServer

Optional

System.String

Specifies the SQL server instance that will be used as a backup to the primary SQL Server instance.

JobExpirationDays

Optional

System.Nullable

Specifies the amount of days after which completed jobs can be automatically removed from the Machine Translation Service queue database.

KeepAliveTimeout

Optional

System.Nullable

Specifies the length of time (in seconds) that the worker can be inactive before it is automatically stopped.

The valid values are 60 to 600. The default value is 60.

MachineTranslationAddress

Optional

System.String

Specifies the service URL the service application will use to call the translation provider. For example, https://api.microsofttranslator.com/v2/soap.svc

MachineTranslationCategory

Optional

System.String

Specifies the category which will be used by the service when calling the translation provider.

MachineTranslationClientId

Optional

System.String

Specifies the AppId which will be used by the service when calling the translation provider.

MaximumBinaryFileSize

Optional

System.Nullable

Specifies the maximum file size in kilobytes (KB) which can be translated for file types which contain binary data. The valid values are 100 to 524288. The default value is 51200.

MaximumItemsPerDay

Optional

System.Nullable

Specifies the maximum number of items which can be added to the job queue in a 24-hour period. A value of zero indicates no limit.

The valid values are 100 to 1000000. A value of zero indicates no limit. The default value is zero.

MaximumItemsPerPartitionPerDay

Optional

System.Nullable

Specifies the maximum number of items which can be added to the job queue in a 24-hour period per partition. A value of zero indicates no limit.

The valid values are 100 to 1000000. A value of zero indicates no limit. The default value is zero.

MaximumSyncTranslationRequests

Optional

System.Nullable

Specifies the maximum number of items which can be added to the sync queue. A valid of zero indicates no limit.

The valid values are 0 to 300. The default value is 25.

MaximumTextFileSize

Optional

System.Nullable

Specifies the maximum file size in kilobytes (KB) which can be translated for file types which contain mostly text data. The valid values are 100 to 15360. The default value is 5120.

MaximumTranslationAttempts

Optional

System.Nullable

Specifies the maximum number of attempts an unsuccessful job is tried before it is marked as Failed.

The valid values are 1 to 10. The default value is 2.

MaximumTranslationTime

Optional

System.Nullable

Specifies the maximum length of time (in minutes) that a translation can take.

The valid values are 60 to 3600. The default value is 600.

MaximumWordCharacterCount

Optional

System.Nullable

Specifies the maximum character count for a Microsoft Word document which can be translated.

The valid Int values are 10000 to 10000000. The default value is 500000.

RecycleProcessThreshold

Optional

System.Nullable

Specifies the number of documents which are translated before a Translation Worker process is recycled.

The valid values are 1 to 1,000. The default value is 100.

RemoveEnabledFileExtensions

Optional

System.String[]

Comma delimited list of file extensions that you want to remove from the set of enabled file extensions for the Machine Translation Service application.

To return a list of supported file extensions, type [Microsoft.Office.TranslationServices.TranslationService]::EnumerateFileExtensions().

TimerJobFrequency

Optional

System.Nullable

Specifies the frequency (in minutes) with which the timer job for this service application runs. The valid values are 1 to 59. The default value is 15 minutes.

TotalActiveProcesses

Optional

System.Nullable

Specifies the number of Translation Workers which are simultaneously running on a single machine.

The valid values are 1 to 5. The default value is 1.

TranslationsPerInstance

Optional

System.Nullable

Specifies the number of translations dispatched to each service instance every time the timer job is run.

Valid values are 1 to 1,000. The default value is 200.

UseDefaultInternetSettings

Optional

System.Management.Automation.SwitchParameter

Determines whether the service application will use default Internet settings for the user service account to connect to the translation provider.

WebProxyAddress

Optional

System.String

Specifies the web proxy address and port that the service application will use to connect to the translation provider.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPTranslationServiceApplication cmdlet to set properties on a Machine Translation service application in the farm.

Input Types

Return Types

Example

---------------EXAMPLE---------------

Copy code
Set-SPTranslationServiceApplication TranslationService -JobExpirationDays 14 -TotalActiveProcesses 3

This example sets the job expiration to 14 days and the number of worker processes per server to 3 for the Machine Translation Service application named TranslationService.

See also

New-SPTranslationServiceApplication
New-SPTranslationServiceApplicationProxy
Set-SPTranslationServiceApplicationProxy


Set-SPTranslationServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties to the Machine Translation service application proxy.

Set-SPTranslationServiceApplicationProxy [-Identity] <TranslationServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-MaximumGroupSize <Nullable>] [-MaximumItemCount <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.TranslationServices.Powershell.TranslationServiceApplicationProxyPipeBind

Specifies the GUID of the service application proxy.

The type must be a valid GUID in the form, 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the Machine Translation Service application proxy be added to the default proxy group for the local farm.

MaximumGroupSize

Optional

System.Nullable

Maximum number of bytes the proxy will send to the service in a single request. The valid values are 131072 to 10485760. The default value is 2097152.

Note:

We do not recommend use of this parameter.

MaximumItemCount

Optional

System.Nullable

Maximum number of documents to be translated that the proxy will send to the service in a single request. The valid values are 1 to 40960. The default value is 9000.

Note:

We do not recommend use of this parameter.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPTranslationServiceApplicationProxy cmdlet to set properties on a Machine Translation service application proxy in the farm.

Input Types

Return Types

Example

-------------EXAMPLE---------

Copy code
Set-SPTranslationServiceApplicationProxy TranslationServiceProxy -DefaultProxyGroup

This example adds the Machine Translation Service application proxy named TranslationServiceProxy to the default proxy group.

See also

New-SPTranslationServiceApplication
New-SPTranslationServiceApplicationProxy
Set-SPTranslationServiceApplication


Managed metadata cmdlets in SharePoint Server 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you administrate managed metadata in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Managed metadata is a hierarchical collection of centrally managed terms that you can define and then use as attributes for items in SharePoint Server 2013.

This article lists cmdlets that support administration of managed metadata.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Managed metadata administration

Cmdlet name | Description
Clear-SPMetadataWebServicePartitionData | Removes all data for a site subscription on a managed metadata Web service application.
Export-SPMetadataWebServicePartitionData | Exports the data from a managed metadata Web service for a site subscription.
Get-SPMetadataServiceApplication | Returns a managed metadata service application.
Get-SPMetadataServiceApplicationProxy | Returns an existing connection to a managed metadata service application, which is also known as a proxy, to the managed metadata service application.
Get-SPSiteSubscriptionMetadataConfig | Returns the site subscription configuration settings for a managed metadata service application.
Get-SPTaxonomySession | Returns a TaxonomySession object.
Import-SPMetadataWebServicePartitionData | Restores the data for a site subscription.
New-SPMetadataServiceApplication | Creates a new managed metadata service application.
New-SPMetadataServiceApplicationProxy | Creates a new connection to a managed metadata service application.
Remove-SPSiteSubscriptionMetadataConfig | Removes site subscription configuration settings.
Set-SPMetadataServiceApplication | Sets the properties of a managed metadata service application.
Set-SPMetadataServiceApplicationProxy | Sets the properties of a connection to a managed metadata service application.
Set-SPSiteSubscriptionMetadataConfig | Sets the site subscription configuration settings for a specified managed metadata service application.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Office Web Apps cmdlets in SharePoint Server 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to configure Web Application Open Platform Interface Protocol (WOPI) applications in SharePoint Server 2013.

Applies to: SharePoint Server 2013

The following table shows the Windows PowerShell cmdlets that you can use to configure WOPI applications settings in a SharePoint farm.

All cmdlets on this page are new to SharePoint Server 2013.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPWOPIBinding | Returns a list of bindings that were created by using New-SPWOPIBinding on the current SharePoint farm where this cmdlet is run.
Get-SPWOPISuppressionSetting | Returns the suppression settings on the current SharePoint farm where this cmdlet is run.
Get-SPWOPIZone | Returns the zone that is configured on the current SharePoint farm for the WOPI application to use.
New-SPWOPIBinding | Creates a new binding to associate file name extensions or applications with actions on the current SharePoint farm where this cmdlet is run.
Remove-SPWOPIBinding | Removes bindings for applications, file name extensions, and their associated actions on the current SharePoint farm where this cmdlet is run.
Remove-SPWOPISuppressionSetting | Removes the suppression settings for a file type or program ID (ProgID) on the current SharePoint farm where this cmdlet is run.
Set-SPWOPIBinding | Updates the default click action for an application or file name extension binding.
Set-SPWOPIZone | Configures the zone that the current SharePoint farm will use to navigate the browser to the WOPI application.
New-SPWOPISuppressionSetting | The New-SPWOPISuppressionSetting cmdlet turns off Office Web Apps for the action and document type or binding you've specified on the current SharePoint farm.
Update-SPWOPIProofKey | Updates the public key that is used to connect to the WOPI application on the current SharePoint farm where this cmdlet is run.

See also

Windows PowerShell for SharePoint 2013 reference


Get-SPWOPIBinding
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 | Office Web Apps

Returns a list of bindings that were created by using New-SPWOPIBinding on the current SharePoint farm where this cmdlet is run.

Get-SPWOPIBinding [-Action <String>] [-Application <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Extension <String>] [-ProgId <String>] [-Server <String>] [-WOPIZone <String>]

Parameters

Parameter Required Type Description

Action

Optional

System.String

Specifies the action to return bindings for.

Application

Optional

System.String

Specifies the application to return bindings for.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Extension

Optional

System.String

Specifies the file name extension to return bindings for.

ProgId

Optional

System.String

Specifies the programmatic identifier (ProgID) for an application to return bindings for.

Server

Optional

System.String

Specifies the name of WOPI application (such as a server that runs Office Web Apps Server) to return bindings for.

WOPIZone

Optional

System.String

Specifies the zone to return bindings for.

Detailed Description

The Get-SPWOPIBinding returns a list of bindings that were created by using New-SPWOPIBinding on the current SharePoint farm where this cmdlet is run. Results include actions, applications, file types and zones that are configured for a WOPI application (such as a server that runs Office Web Apps Server).

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPWOPIBinding -Server "Server.corp.Contoso.com"

This example returns a list of bindings that were created on the current SharePoint farm where this cmdlet is run for the WOPI application "Server.corp.Contoso.com." The WOPI application may be the server that runs Office Web Apps Server.

--------------EXAMPLE 2-----------------

Copy code
Get-SPWOPIZone | Get-SPWOPIBinding

This example returns a list of bindings that were created on the current SharePoint farm where this cmdlet is run for the zone configured for the WOPI application.

See also

New-SPWOPIBinding
Set-SPWOPIBinding
Remove-SPWOPIBinding

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


Get-SPWOPISuppressionSetting
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 | Office Web Apps

Returns the suppression settings on the current SharePoint farm where this cmdlet is run.

Get-SPWOPISuppressionSetting [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPWOPISuppressionSetting cmdlet returns the suppression settings on the current SharePoint farm where this cmdlet is run.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPWOPISuppressionSetting

This example returns all the suppression settings on the current SharePoint farm where this cmdlet is run. The suppression settings returned include the DocType and WOPIAction.

See also

New-SPWOPISuppressionSetting
Remove-SPWOPISuppressionSetting

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


Get-SPWOPIZone
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | Office Web Apps | SharePoint Server 2013

Returns the zone that is configured on the current SharePoint farm for the WOPI application to use.

Get-SPWOPIZone [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPWOPIZone returns the zone that is configured on the current SharePoint farm for the WOPI application (such as a server that runs Office Web Apps Server) to use.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPWOPIZone

This example returns the zone that is configured for the WOPI application (such as a server that runs Office Web Apps Server) to use. Return values may be "internal-http," "internal-https," "external-http" or "external-https."

See also

Set-SPWOPIZone

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


New-SPWOPIBinding
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | Office Web Apps | SharePoint Server 2013

Creates a new binding to associate file name extensions or applications with actions on the current SharePoint farm where this cmdlet is run.

New-SPWOPIBinding -ServerName <String> [-Action <String>] [-AllowHTTP <SwitchParameter>] [-Application <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Extension <String>] [-FileName <String>] [-ProgId <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServerName

Required

System.String

Specifies the name or fully qualified domain name (FQDN) of the WOPI application (such as a server that runs Office Web Apps Server).

Action

Optional

System.String

Specifies the action to bind. For example, "view," "edit," and "embedview." For a list of actions that the WOPI application supports, run Get-SPWOPIBinding. Typically, you will not use this parameter. If you specify some actions but not others, some SharePoint features may not work.

AllowHTTP

Optional

System.Management.Automation.SwitchParameter

Specifies that the cmdlet can use HTTP for discovery of what the WOPI application supports. If this is specified as True, the discovery information from the WOPI application will be sent on a nonsecure connection.

Application

Optional

System.String

Specifies applications to bind. Possible applications are as follows: "Word," "Excel," "PowerPoint," or "OneNote." Run Get-SPWOPIBinding to get the full list of application the WOPI application supports.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Extension

Optional

System.String

Specifies the file name extensions to bind. Run Get-SPWOPIBinding to get the list of file name extensions the WOPI application supports.

FileName

Optional

System.String

Specifies the path of the xml file that contains the discover information for the WOPI application. You can load discovery information from an xml file instead of requesting from the WOPI application directly.

ProgId

Optional

System.String

Specifies the programmatic identifier (ProgID) for an application to bind. Run Get-SPWOPIBinding to get the list of ProgIDs that the WOPI application supports. You may only want to use this parameter to associate an action to an OneNote folder.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPWOPIBinding cmdlet associates file name extensions or applications to actions on the current SharePoint farm where this cmdlet is run. Each binding allows you to use the WOPI application to view or edit files in your SharePoint library. For example, when a user sees a Word document in a SharePoint document list, the SharePoint list will display the available options to view or edit the document based on the actions that are bound to Word on that SharePoint farm.

To use a WOPI application, such as a server that runs Office Web Apps Server, for Office Web Apps, you must run this cmdlet on the SharePoint farm before you can use the Office Web Apps.

If you run New-SPWOPIBinding for an application or file name extension where the binding (or association) already exists, the cmdlet will fail.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
New-SPWOPIBinding -ServerName "Server.corp.Contoso.com"

This example creates bindings for all the applications and file name extensions that the WOPI application supports on the current SharePoint farm where this cmdlet is run.

--------------EXAMPLE 2-----------------

Copy code
New-SPWOPIBinding -ServerName "Server.corp.Contoso.com" -Application "Excel"

This example associates Excel with all the actions that the WOPI application supports for Excel on the current SharePoint farm where this cmdlet is run.

See also

Get-SPWOPIBinding
Set-SPWOPIBinding
Remove-SPWOPIBinding

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


Remove-SPWOPIBinding
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | Office Web Apps | SharePoint Server 2013

Removes bindings for applications, file name extensions, and their associated actions on the current SharePoint farm where this cmdlet is run.

Remove-SPWOPIBinding [[-Identity] <SPWopiBindingPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Remove-SPWOPIBinding [-Action <String>] [-Application <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Extension <String>] [-ProgId <String>] [-Server <String>] [-WhatIf [<SwitchParameter>]] [-WOPIZone <String>]
Remove-SPWOPIBinding [-All <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPWopiBindingPipeBind

Specifies the binding.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Action

Optional

System.String

Specifies the action to remove bindings for. For example, "view," "edit," and "embedview." For a list of actions run Get-SPWOPIBinding. Most typically you will not use this parameter. If you specify some actions but not others, some features in SharePoint may not work.

Application

Optional

System.String

Specifies application to remove bindings for. Possible applications are as follows: "Word," "Excel," "PowerPoint," or "OneNote." Run Get-SPWOPIBinding to get the list of applications.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters.

Extension

Optional

System.String

Specifies the file name extensions to remove bindings for. Run Get-SPWOPIBinding to get the list of file name extensions.

ProgId

Optional

System.String

Specifies the programmatic identifier (ProgID) for an application to remove bindings for. Run Get-SPWOPIBinding to get the list of ProgIDs. You may only want to use this parameter to remove bindings for OneNote.

Server

Optional

System.String

Specifies the name of WOPI application (like Office Web Apps Server) to remove bindings for.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WOPIZone

Optional

System.String

Specifies the zone to remove bindings for.

3

Parameter

Required

Type

Description

All

Optional

System.Management.Automation.SwitchParameter

Removes all bindings.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPWOPIBinding cmdlet removes bindings for applications, file name extensions, and their associated actions on the current SharePoint farm where this cmdlet is run. After you run this cmdlet, you can use New-SPWOPIBinding to re-create the bindings as needed. If you remove all the bindings for an application, users cannot use Office Web Apps or the SharePoint Share by link feature for that application. If you remove all the bindings on the SharePoint farm where this cmdlet is run, users cannot use Office Web Apps or the SharePoint Share by link feature for any applications in the SharePoint library.

If you want to stop using Office Web Apps for default clicks, but must preserve the bindings' discovery information and the ability for users to use the SharePoint Share by link feature to send a link to a document and allow the recipient to use Office Web Apps for that document type, use the New-SPWOPISuppression cmdlet instead.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Remove-SPWOPIBinding -Application "Excel"

This example removes all bindings for Excel on the current SharePoint farm where this cmdlet is run.

--------------EXAMPLE 2-----------------

Copy code
Remove-SPWOPIBinding -All:$true

This example removes all bindings on the current SharePoint farm where this cmdlet is run.

--------------EXAMPLE 3-----------------

Copy code
Get-SPWOPIBinding -Action "MobileView" | Remove-SPWOPIBinding

This example removes all bindings for Office Mobile Web Apps on the current SharePoint farm where this cmdlet is run.

See also

New-SPWOPIBinding
Get-SPWOPIBinding
Set-SPWOPIBinding
New-SPWOPISuppressionSetting

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


Remove-SPWOPISuppressionSetting
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | Office Web Apps | SharePoint Server 2013

Removes the suppression settings for a file name extension or programmatic ID and action on the current SharePoint farm where this cmdlet is run.

Remove-SPWOPISuppressionSetting [-Action <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Extension <String>] [-ProgId <String>] [-WhatIf [<SwitchParameter>]]
Remove-SPWOPISuppressionSetting [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Identity <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Action

Optional

System.String

Specifies the action for a given file name extension or programmatic identifier (ProgId). For example, "view," "edit," and "embedview."

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters.

Extension

Optional

System.String

Specifies the file name extension. Run Get-SPWOPIBinding to get the list of file name extensions the WOPI application supports.

ProgId

Optional

System.String

Specifies the programmatic identifier (ProgID) for an application to suppress. Run Get-SPWOPIBinding to get the list of ProgIDs that the WOPI application supports.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters.

Identity

Optional

System.String

Specifies a string that represents a SPWOPISuppressionSetting. Run Get-SPWOPISuppressionSetting to see examples of such strings.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPWOPISuppressionSetting cmdlet removes the suppression settings for a file name extension or programmatic indentifier (ProgID) and action on the current SharePoint farm where this cmdlet is run.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Remove-SPWOPISuppressionSetting -Extension "XLSX" -Action "view"

This example removes suppression settings for viewing Excel workbooks that have the file name extension ".xlsx."

--------------EXAMPLE 2-----------------

Copy code
Get-SPWOPISuppressionSetting | Remove-SPWOPISuppressionSetting

This example removes all suppression settings on the current SharePoint farm where this cmdlet is run.

See also

New-SPWOPISuppressionSetting
Get-SPWOPISuppressionSetting

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


Set-SPWOPIBinding
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | Office Web Apps | SharePoint Server 2013

Updates the default click action for an application or file name extension binding.

Set-SPWOPIBinding [-Identity] <SPWopiBindingPipeBind> -DefaultAction <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWopiBindingPipeBind

Specifies the binding.

DefaultAction

Required

System.Management.Automation.SwitchParameter

Specifies whether the binding should be set as the default click action for an application or file name extension in the binding.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters.

Detailed Description

The Set-SPWOPIBinding cmdlet updates the default click action for an application or file name extension binding. For example, you can set the default click action to view for a Word document in a SharePoint library. To do this, you set the default action to true for the "view"-"Word" bindings.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
 Get-SPWOPIBinding -Action "view" -Application "Word"| Set-SPWOPIBinding -DefaultAction:$true

This example sets the default click action to view for a Word document in a SharePoint library. You can verify that the default click action is set to view for Word by running the cmdlet Get-SPWOPIBinding -Action "view" -Application "Word". The IsDefaultAction value is set to "True."

See also

Get-SPWOPIBinding
Remove-SPWOPIBinding
New-SPWOPIBinding

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


Set-SPWOPIZone
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | Office Web Apps | SharePoint Server 2013

Configures the zone that the current SharePoint farm will use to navigate the browser to the WOPI application.

Set-SPWOPIZone [[-Zone] <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Zone

Optional

System.String

Specifies the zone. For a list of zones that the WOPI application supports, run Get-SPWOPIBinding.

If you have a SharePoint farm that's internal and external, specify external. If you have a SharePoint farm that's internal only, specify internal. Only use HTTP when you are on a fully secure network that uses IPSEC (full encryption) or in a test environment that does not contain sensitive data. The options are as follows:

- Internal-HTTP

- Internal-HTTPS

- External-HTTP

- External-HTTPS

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters.

Detailed Description

The Set-SPWOPIZone cmdlet configures the zone that the current SharePoint farm will use to navigate the browser to the WOPI application (such as a server that runs Office Web Apps Server). The SharePoint Server page in the browser creates a frame that contains a page on the WOPI application. The zone for the URL of the WOPI application page is determined by this setting.

If you do not set the zone, the default is "internal-HTTPS." If you select a zone that is not supported by the WOPI application, Office Web Apps will not work. Only use HTTP when you are on a fully secure network that uses IPSEC (full encryption) or in a test environment that does not contain sensitive data.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Set-SPWOPIZone -Zone "external-https"

This example configures the current SharePoint farm to use external connections through HTTPS to the WOPI application (such as a server that runs Office Web Apps Server).

See also

Get-SPWOPIZone

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


New-SPWOPISuppressionSetting
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | Office Web Apps | SharePoint Server 2013

The New-SPWOPISuppressionSetting cmdlet turns off Office Web Apps for the action, file name extension, or programmatic identifier that you've specified on the current SharePoint farm.

New-SPWOPISuppressionSetting [-Action <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Extension <String>] [-ProgId <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Action

Optional

System.String

Specifies the action to suppress for a given extension or programmatic identifier (ProgId). For example, "view," "edit," and "embedview." For a full list of actions, run Get-SPWOPIBinding.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Extension

Optional

System.String

Specifies the file name extension to suppress. Run Get-SPWOPIBinding to get the list of file name extensions the WOPI application supports.

ProgId

Optional

System.String

Specifies the programmatic identifier (ProgId) for an application to suppress. Run Get-SPWOPIBinding to get the list of ProgIds that the WOPI application supports.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters.

Detailed Description

The New-SPWOPISuppressionSetting cmdlet turns off Office Web Apps for the action, file name extension, or programmatic identifier (ProgId) that you've specified on the current SharePoint farm. The cmdlet does this without removing the discovery information or the ability for users to use the SharePoint Share by link feature to send a link to a document and allow the recipient to use Office Web Apps for that document type. You may have to use this cmdlet if you want to use Excel Services to view Excel workbooks instead of the WOPI application (for example Office Web Apps Server).

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
New-SPWOPISuppressionSetting -Extension "XLSX" -Action "view"
Copy code
New-SPWOPISuppressionSetting -Extension "XLS" -Action "view"

This example turns off the ability of a user to use Office Web Apps to view Excel workbooks that have file name extensions ".xlsx" or ".xls".

See also

Get-SPWOPISuppressionSetting
Remove-SPWOPISuppressionSetting

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


Update-SPWOPIProofKey
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 | Office Web Apps

Updates the public key that is used to connect to the WOPI application on the current SharePoint farm where this cmdlet is run.

Update-SPWOPIProofKey [-AssignmentCollection <SPAssignmentCollection>] [-ServerName <String>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ServerName

Optional

System.String

Specifies the WOPI application to obtain the key from. This may be a server that runs Office Web Apps Server. If this parameter is missing, public keys for all WOPI applications which are connected to the current SharePoint farm, are updated.

Detailed Description

The Update-SPWOPIProofKey cmdlet updates the public key that is used to connect to the WOPI application (which could be a server that runs Office Web Apps Server) on the current SharePoint farm where this cmdlet is run. You may want to use this cmdlet if the keys become unsynchronized between the SharePoint farm and the WOPI application. If the keys are unsynchronized, documents may not open in the browser and messages such as "Invalid Proof Signature for file…" or "Invalid Proof Signature for folder..." are found in the Unified Logging System (ULS) logs.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Update-SPWOPIProofKey -ServerName "Server.corp.Contoso.com"

This example obtains the current public key from the WOPI application (such as a server that runs Office Web Apps Server) and updates the key that is stored on the SharePoint farm.

See also

Content roadmap for Office Web Apps
Use Office Web Apps with SharePoint 2013


Use Windows PowerShell cmdlets to manage performance in SharePoint 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to manage performance for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following table shows the Windows PowerShell cmdlets that you can use to manage performance for a SharePoint 2013 farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Add-SPDiagnosticsPerformanceCounter | Adds an instance of a performance counter.
Get-SPDiagnosticsPerformanceCounter | Returns a collection of performance counters.
Remove-SPDiagnosticsPerformanceCounter | Removes an instance of a performance counter.
Disable-SPWebApplicationHttpThrottling | Turns off network throttling for a web application.
Enable-SPWebApplicationHttpThrottling | Turns on network throttling for a web application.
Get-SPBusinessDataCatalogThrottleConfig | Returns the throttling configuration for a Business Data Connectivity Service application.
Set-SPBusinessDataCatalogThrottleConfig | Sets the throttling configuration for a Business Data Connectivity Service application.
Get-SPWebApplicationHttpThrottlingMonitor | Reads all counters for network throttling on a web application.
Set-SPWebApplicationHttpThrottlingMonitor | Sets the Health Score bucket values for an existing network throttling performance counter for a specified web application.
Start-SPDiagnosticsSession | Reports diagnostic information to the usage database.
Stop-SPDiagnosticsSession | Stops the diagnostics session.
Add-SPRoutingMachineInfo | Adds a new routing target to the farm.
Add-SPRoutingMachinePool | Adds a new machine pool.
Add-SPRoutingRule | Adds a routing rule.
Add-SPThrottlingRule | Adds a new throttling rule.
Get-SPRoutingMachineInfo | Returns all the routing targets.
Get-SPRoutingMachinePool | Returns all available routing pools.
Get-SPRoutingRule | Returns all routing rules.
Get-SPThrottlingRule | Returns all throttling rules.
Remove-SPRoutingMachineInfo | Removes an external routing target.
Remove-SPRoutingMachinePool | Removes a routing pool from Request Manager.
Remove-SPRoutingRule | Removes a routing rule.
Remove-SPThrottlingRule | Removes a throttling rule.
Set-SPRoutingMachineInfo | Sets routing target properties.
Set-SPRoutingMachinePool | Sets properties of a machine pool.
Set-SPRoutingRule | Changes properties of an existing routing rule.
Set-SPThrottlingRule | Changes properties of an existing throttling rule.
Get-SPRequestManagementSettings | Returns a Request Manager object.
New-SPRequestManagementRuleCriteria | Creates criteria for the rule to match.
Set-SPRequestManagementSettings | Sets Request Manager properties.
Get-SPDistributedCacheClientSetting | Returns distributed cache settings from usage.
Clear-SPDistributedCacheItem | Clears cached items from the distributed cache server.
Set-SPDistributedCacheClientSetting | Sets distributed cache settings.
Stop-SPDistributedCacheServiceInstanceGracefullyOnLocalServer | Obsolete. For replacement, see Stop-SPDistributedCacheServiceInstance
Stop-SPDistributedCacheServiceInstance | Stops an instance of the distributed cache service on a local server.
Remove-SPDistributedCacheServiceInstanceOnLocalServer | Obsolete. For replacement, see Remove-SPDistributedCacheServiceInstance
Remove-SPDistributedCacheServiceInstance | Removes an instance of the distributed cache service from a local server.
Add-SPDistributedCacheServiceInstanceOnLocalServer | Obsolete. For replacement, see Add-SPDistributedCacheServiceInstance
Add-SPDistributedCacheServiceInstance | Adds an instance of the distributed cache service to a local server.
Update-SPDistributedCacheSize | Reconfigures the allocation of memory that is dedicated to the Distributed Cache service.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Add-SPDiagnosticsPerformanceCounter
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a new instance of a performance counter to a Web front end computer or a database server.

Add-SPDiagnosticsPerformanceCounter [-Category] <String> -Counter <String> [-AllInstances <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseServer <SwitchParameter>] [-WebFrontEnd <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Add-SPDiagnosticsPerformanceCounter [-Category] <String> -Instance <String> [-AllInstances <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Counter <String>] [-DatabaseServer <SwitchParameter>] [-WebFrontEnd <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Category

Required

System.String

Specifies the category of performance counter to add to the target Web front end computer or database server.

The type must be a valid name of a category of performance counters; for example, ASP.NET, PhysicalDisk, or Processor.

Counter

Required

System.String

Specifies the type of counter to add to the target Web front end computer or database server.

The type must be a valid name of counter type; for example, Requests Queued, Avg. Disk Queue Length, and % Processor Time.

AllInstances

Optional

System.Management.Automation.SwitchParameter

Collects all instances of a counter category and type on the target Web front end computer or database server.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseServer

Optional

System.Management.Automation.SwitchParameter

Adds the specified performance counter to all database servers in the farm.

WebFrontEnd

Optional

System.Management.Automation.SwitchParameter

Adds the specified performance counter to all Web front end computers in the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Category

Required

System.String

Specifies the category of performance counter to add to the target Web front end computer or database server.

The type must be a valid name of a category of performance counters; for example, ASP.NET, PhysicalDisk, or Processor.

Counter

Required

System.String

Specifies the type of counter to add to the target Web front end computer or database server.

The type must be a valid name of counter type; for example, Requests Queued, Avg. Disk Queue Length, and % Processor Time.

Instance

Required

System.String

Specifies the display name of the new performance counter.

The type must be a valid name of a performance counter instance; for example Total_PerfCounter.

AllInstances

Optional

System.Management.Automation.SwitchParameter

Collects all instances of a counter category and type on the target Web front end computer or database server.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseServer

Optional

System.Management.Automation.SwitchParameter

Adds the specified performance counter to all database servers in the farm.

WebFrontEnd

Optional

System.Management.Automation.SwitchParameter

Adds the specified performance counter to all Web front end computers in the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Add-SPDiagnosticsPerformanceCounter cmdlet adds a performance counter to a front end Web server or a database server. A performance counter is read and recorded in the usage database. By default, the new performance counter is added to the database servers in the farm.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Add-SPDiagnosticsPerformanceCounter -category ASP.NET -Counter "Requests Queued"

This example adds the counter that has the name ASP.NET\Requests Queued on front end Web servers.

------------------EXAMPLE 2------------------

Copy code
Add-SPDiagnosticsPerformanceCounter -category PhysicalDisk -counter "Avg. Disk Queue Length" -allinstances

This example adds all instances of the counter PhysicalDisk in the category Avg. Disk Queue Length on front end Web servers.

------------------EXAMPLE 3------------------

Copy code
Add-SPDiagnosticsPerformanceCounter -category Processor -counter "% Processor Time" -instance "_Total" -databaseserver

This example adds the _Total instance of the counter % Processor Time in the category Processor on database servers.

See also

Get-SPDiagnosticsPerformanceCounter
Remove-SPDiagnosticsPerformanceCounter


Get-SPDiagnosticsPerformanceCounter
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a collection of performance counters.

Get-SPDiagnosticsPerformanceCounter [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseServer <SwitchParameter>] [-WebFrontEnd <SwitchParameter>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DatabaseServer

Optional

System.Management.Automation.SwitchParameter

Returns performance counters collected for the database servers in the farm.

WebFrontEnd

Optional

System.Management.Automation.SwitchParameter

Returns performance counters collected for the front end Web servers in the farm.

Detailed Description

The Get-SPDiagnosticsPerformanceCounter cmdlet returns the collection of performance counters that are read and recorded in the usage database. If neither the DatabaseServer or WebFrontEnd parameters are specified, this cmdlet returns the performance counters on the front end Web servers and database servers in the farm.

To distinguish counters that are collected on database servers and counters that are collected on front end Web servers, note that counters that are collected on database servers have a Provider Name of job-diagnostics-performance-counter-sql-provider, and counters that are collected on front end Web servers have a Provider Name of job-diagnostics-performance-counter-wfe-provider.

Note:

The Get-SPDiagnosticsPerformanceCounter cmdlet is only available by using Windows PowerShell. There is no user interface.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Get- SPDiagnosticsPerformanceCounter

This example gets the performance counter settings for front end Web servers and database servers.

------------------EXAMPLE 2------------------

Copy code
Get- SPDiagnosticsPerformanceCounter -WebFrontEnd

This example gets the performance counter settings for front end Web servers.

------------------EXAMPLE 3------------------

Copy code
Get- SPDiagnosticsPerformanceCounter -DatabaseServer

This example gets the performance counter settings for database servers.

See also

Add-SPDiagnosticsPerformanceCounter
Remove-SPDiagnosticsPerformanceCounter


Remove-SPDiagnosticsPerformanceCounter
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes an instance of a performance counter.

Remove-SPDiagnosticsPerformanceCounter [-Category] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Counter <String>] [-DatabaseServer <SwitchParameter>] [-Instance <String>] [-WebFrontEnd <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Category

Required

System.String

Specifies the category of performance counters to remove.

The type must be a valid name of a category of performance counters; for example, ASP.NET, PhysicalDisk, or Processor.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Counter

Optional

System.String

Specifies the type of counter to remove. If this parameter is not specified, this cmdlet removes all performance counters of the specified category.

The type must be a valid name of counter type; for example, Requests Queued, Avg. Disk Queue Length, and % Processor Time.

DatabaseServer

Optional

System.Management.Automation.SwitchParameter

Removes the specified performance counters that are collected on the database servers in the farm.

Instance

Optional

System.String

Specifies the instance name of the performance counter to remove. If this parameter is not specified, this cmdlet removes all instances of the specified performance counter.

The type must be a valid name of a performance counter instance; for example Total_PerfCounter.

WebFrontEnd

Optional

System.Management.Automation.SwitchParameter

Removes performance counters that are collected on the front end Web servers in the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPDiagnosticsPerformanceCounter cmdlet removes performance counters from the collection of performance counters that are read and recorded in the usage database. This cmdlet can also be used to remove entire categories and types of counters from the collection. If either the DatabaseServer or WebFrontEnd parameters are not specified, this cmdlet removes the specified performance counters on the front end Web servers in the farm.

Note:

The Remove-SPDiagnosticsPerformanceCounter cmdlet is only available by using Windows PowerShell. There is no user interface.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Remove-SPDiagnosticsPerformanceCounter -category ASP.NET

This example removes all the counters in the category ASP.NET on front end Web servers.

------------------EXAMPLE 2------------------

Copy code
Remove-SPDiagnosticsPerformanceCounter -category ASP.NET -Counter "Requests Queued"

This example removes the counters in the category ASP.NET that have requests queued on front end Web servers.

------------------EXAMPLE 3------------------

Copy code
Remove-SPDiagnosticsPerformanceCounter -category Processor -counter "% Processor Time" -instance "_Total" -databaseserver

This example removes the counters of the _Total instance, with the counter % Processor Time in the category Processor on database servers.

See also

Add-SPDiagnosticsPerformanceCounter
Get-SPDiagnosticsPerformanceCounter


Disable-SPWebApplicationHttpThrottling
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Turns off network throttling for a Web application.

Disable-SPWebApplicationHttpThrottling [-Identity] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Turns off network throttling on the specified SharePoint Web application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Disable-SPWebApplicationHttpThrottling cmdlet turns off network throttling for a Web application. This operation prompts you to confirm that you want to turn off network throttling.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Disable-SPWebApplicationHTTPThrottling http://sitename

This example disables network throttling on the Web application http://sitename.

See also

Get-SPWebApplicationHttpThrottlingMonitor
Enable-SPWebApplicationHttpThrottling
Set-SPWebApplicationHttpThrottlingMonitor


Enable-SPWebApplicationHttpThrottling
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Turns on network throttling for a Web application.

Enable-SPWebApplicationHttpThrottling [-Identity] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Turns on network throttling on the specified SharePoint Web application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Enable-SPWebApplicationHttpThrottling cmdlet turns on network throttling for a Web application. This operation prompts you to confirm that you want to turn on network throttling.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Enable-SPWebApplicationHttpThrottling http://sitename

This example enables network throttling on the http://sitename Web application.

See also

Get-SPWebApplicationHttpThrottlingMonitor
Disable-SPWebApplicationHttpThrottling
Set-SPWebApplicationHttpThrottlingMonitor


Get-SPBusinessDataCatalogThrottleConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the throttling configuration for a Business Data Connectivity Service application.

Get-SPBusinessDataCatalogThrottleConfig -Scope <Global | Database | WebService | Wcf | Custom | OData> -ServiceApplicationProxy <SPServiceApplicationProxyPipeBind> -ThrottleType <None | Items | Size | Connections | Timeout | MetadataSize | ModelSize | MaxNumberOfModels> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPBusinessDataCatalogThrottleConfig -FileBacked <SwitchParameter> -Scope <Global | Database | WebService | Wcf | Custom | OData> -ThrottleType <None | Items | Size | Connections | Timeout | MetadataSize | ModelSize | MaxNumberOfModels> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Scope

Required

Microsoft.BusinessData.SystemSpecific.ThrottleScope

Returns the throttling configuration for the specified the scope.

The type must be one of the following: Wcf, WebService, Database, Global, or Custom.

ServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the Business Data Connectivity Service application proxy that contains the throttling configuration to get.

ThrottleType

Required

Microsoft.BusinessData.SystemSpecific.ThrottleType

Returns the throttling configuration for the specified throttle type.

The type must be one of the following: None, Items, Size, Connections, or Timeout.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

FileBacked

Required

System.Management.Automation.SwitchParameter

Requests the throttling configuration for file backed metadata catalogs.

Scope

Required

Microsoft.BusinessData.SystemSpecific.ThrottleScope

Returns the throttling configuration for the specified the scope.

The type must be one of the following: Wcf, WebService, Database, Global, or Custom.

ThrottleType

Required

Microsoft.BusinessData.SystemSpecific.ThrottleType

Returns the throttling configuration for the specified throttle type.

The type must be one of the following: None, Items, Size, Connections, or Timeout.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPBusinessDataCatalogThrottleConfig cmdlet reads the throttling configuration for a Business Data Connectivity Service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPBusinessDataCatalogThrottleConfig -Scope Database -ThrottleType Items -ServiceApplicationProxy $contosoServAppProxy

This example returns the throttling information that is related to database items for the given service application.

See also

Set-SPBusinessDataCatalogThrottleConfig


Set-SPBusinessDataCatalogThrottleConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the throttling configuration for a Business Data Connectivity Service application.

Set-SPBusinessDataCatalogThrottleConfig -Default <Int32> -Identity <ThrottleConfig> -Maximum <Int32> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Set-SPBusinessDataCatalogThrottleConfig -Enforced <SwitchParameter> -Identity <ThrottleConfig> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Default

Required

System.Int32

Specifies the default setting of the throttle configuration.

Identity

Required

Microsoft.SharePoint.BusinessData.SharedService.ThrottleConfig

Specifies the throttle configuration to update.

Maximum

Required

System.Int32

Specifies the maximum value of the throttling configuration setting.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Enforced

Required

System.Management.Automation.SwitchParameter

Specifies that the throttle configuration setting cannot be overridden.

Identity

Required

Microsoft.SharePoint.BusinessData.SharedService.ThrottleConfig

Specifies the throttle configuration to update.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPBusinessDataCatalogThrottleConfig cmdlet sets the throttling configuration for a Business Data Connectivity Service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPBusinessDataCatalogThrottleConfig -Scope Database -ThrottleType Items -ServiceApplicationProxy $contosoServAppProxy | Set-SPBusinessDataCatalogThrottleConfig -Maximum 1000000000 -Default 500000

This example sets the database item throttling to values of 1000000000 maximum and 500000 default for the given service application.

See also

Get-SPBusinessDataCatalogThrottleConfig


Get-SPWebApplicationHttpThrottlingMonitor
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all counters and their associated Health Score bucket values for network throttling on a Web application.

Get-SPWebApplicationHttpThrottlingMonitor [-Identity] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Returns throttling performance counter settings for the specified SharePoint Web application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPWebApplicationHttpThrottlingMonitor cmdlet reads all counters for network throttling on a Web application. This cmdlet returns a list that contains all of the performance counters and their associated Health Score bucket values.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$s = get-SPWebApplicationHTTPThrottlingMonitors http://sharepoint

This example gets all performance counters that are being read in the network throttling monitor for the http://sharepoint Web application.

See also

Set-SPWebApplicationHttpThrottlingMonitor
Enable-SPWebApplicationHttpThrottling
Disable-SPWebApplicationHttpThrottling


Set-SPWebApplicationHttpThrottlingMonitor
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the Health Score bucket values for an existing network throttling performance counter for a specified Web application.

Set-SPWebApplicationHttpThrottlingMonitor [-Identity] <SPWebApplicationPipeBind> [-Category] <String> [-Counter] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-HealthScoreBuckets <Double[]>] [-Instance <String>] [-IsDESC <SwitchParameter>] [-LowerLimit <Double>] [-UpperLimit <Double>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the SharePoint Web application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

Category

Required

System.String

Specifies the name of the performance counter category.

The type must be a valid performance counter category in the throttling monitor. Use the Get-SPWebApplicationHttpThrottlingMonitor cmdlet to return a list of performance counter categories in the throttling monitor.

Counter

Required

System.String

Specifies the name of the performance counter.

The type must be a valid performance counter in the throttling monitor. Use the Get-SPWebApplicationHttpThrottlingMonitor cmdlet to return a list of performance counters in the throttling monitor.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

HealthScoreBuckets

Optional

System.Double[]

Specifies bucket ranges to use in determining the calculation of the server Health Score for this counter.

Instance

Optional

System.String

Specifies the instance of the performance counter. The default value is empty. If the specified value is invalid, this cmdlet will not run.

IsDESC

Optional

System.Management.Automation.SwitchParameter

Specifies that this counter is interpreted in descending order.

If this parameter is set, Health Score bucket values are interpreted in descending order; for example, set this parameter by using the Memory category and Available Mbytes counter to monitor available memory.

LowerLimit

Optional

System.Double

Specifies the lower limit of the numerical threshold of the specified performance counter. The lower limit is the lowest value in the Health Score bucket values.

UpperLimit

Optional

System.Double

Specifies the upper limit of the numerical threshold of the specified performance counter. The upper limit is the highest value in the Health Score bucket values.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPWebApplicationHttpThrottlingMonitor cmdlet sets the Health Score bucket values for an existing network throttling performance counter for a specified Web application.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$buckets=(2000,1000,500,300,200,100,50,30,20,10)Set-SPWebApplicationHttpThrottlingMonitor http://sharepoint -Category Memory -Counter 'Available Mbytes' -IsDesc -HealthScoreBuckets $buckets

This example sets the Health Score bucket values for the Memory\Available Mbytes counter to the array listed for the http://sharepoint Web application.

------------------EXAMPLE 2------------------

Copy code
Set-SPWebApplicationHttpThrottlingMonitor http://sharepoint0 -Category Memory -Counter 'Available Mbytes' -IsDesc -UpperLimit 3000

This example sets the upper limit for the Memory\Available Mbytes counter, the highest value in the Health Score buckets, to 3000 for the http://sharepoint Web application.

See also

Get-SPWebApplicationHttpThrottlingMonitor
Enable-SPWebApplicationHttpThrottling
Disable-SPWebApplicationHttpThrottling


Start-SPDiagnosticsSession
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Starts a diagnostic session to report diagnostic information to the usage database.

Start-SPDiagnosticsSession [-AssignmentCollection <SPAssignmentCollection>] [-CorrelationId <Guid>] [-Dashboard <SwitchParameter>] [-TraceLevel <String>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CorrelationId

Optional

System.Guid

Specifies the correlation ID to be used for the diagnostic session.

Dashboard

Optional

System.Management.Automation.SwitchParameter

Specifies that diagnostics behave as if the developer dashboard were enabled.

TraceLevel

Optional

System.String

Specifies the Unified Logging Service (ULS) trace level override.

  • High

  • Medium

  • Monitorable

  • Unexpected

  • Verbose

  • VerboseEx

  • None

Detailed Description

Use the Start-SPDiagnosticsSession cmdlet to report diagnostic information to the usage database. After a diagnostic session starts, all Windows PowerShell for SharePoint cmdlets in Windows PowerShell scripts will use the same correlation to report diagnostic information.

Input Types

Return Types

Example

-------------EXAMPLE-------

Copy code
$correlationId = [guid]::NewGuid()
Copy code
Start-SPDiagnosticsSession -CorrelationId $correlationId -Dashboard:$true -TraceLevel Verbose

This example starts a diagnostic session for a specified correlation ID with the trace level of verbose.

See also

Stop-SPDiagnosticsSession


Stop-SPDiagnosticsSession
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Stops a diagnostic session.

Stop-SPDiagnosticsSession [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Stop-SPDiagnosticsSession cmdlet to stop a diagnostic session.

Input Types

Return Types

Example

-------------EXAMPLE---------

Copy code
Stop-SPDiagnosticsSession

This example stops a diagnostic session.

See also

Start-SPDiagnosticsSession


Add-SPRoutingMachineInfo
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a new routing target to the farm.

Add-SPRoutingMachineInfo [-RequestManagementSettings] <SPRequestManagementSettingsPipeBind> [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Availability <Nullable>] [-OutgoingPort <Nullable>] [-OutgoingScheme <Nullable>] [-StaticWeight <Nullable>]

Parameters

Parameter Required Type Description

RequestManagementSettings

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the name of the request management settings object to add to the routing target.

Name

Required

System.String

Specifies the name of the computer to add to the route.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Availability

Optional

System.Nullable

Specifies whether or not the added computer will be available for routing.

The valid values are:

--Available

--Unavailable

OutgoingPort

Optional

System.Nullable

Specifies the port used by Request Manager to make an outgoing connection.

OutgoingScheme

Optional

System.Nullable

Determines the Http scheme of outgoing connections.

The valid values are:

--SameAsIncoming

--Http

--Https

StaticWeight

Optional

System.Nullable

Specifies the static weight of a computer routing that is used by Request Manager. If the static weight is higher, more requests will be routed to the computer.

Detailed Description

Use the Add-SPRoutingMachineInfo cmdlet to add a new routing target to the farm by using the RequestManagementSettings and Name parameters.

Input Types

Return Types

Example

-------------EXAMPLE--------------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Add-SPRoutingMachineInfo -RequestManagementSettings $rm -Name <MachineName> -Availability Available
Copy code

This example adds a routing target for a specified identity to the farm.
  See also
Get-SPRoutingMachineInfo
Remove-SPRoutingMachineInfo
Set-SPRoutingMachineInfo


Add-SPRoutingMachinePool
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a new machine pool.

Add-SPRoutingMachinePool [-RequestManagementSettings] <SPRequestManagementSettingsPipeBind> [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-MachineTargets <SPRoutingRuleTargetPipeBind[]>]

Parameters

Parameter Required Type Description

RequestManagementSettings

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the name of the request management settings object to add to the routing machine pool.

Name

Required

System.String

Specifies the name of machine pool.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

MachineTargets

Optional

Microsoft.SharePoint.PowerShell.SPRoutingRuleTargetPipeBind[]

Specifies the routing targets collection that the machine pool will contain.

Detailed Description

Use the Add-SPRoutingMachinePool cmdlet to add a machine pool by using the RequestManagementSettings and Name parameters.

Input Types

Return Types

Example

----------EXAMPLE--------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Add-SPRoutingMachinePool -RequestManagementSettings $rm -Name <MachineName>

This example adds a machine pool.

See also

Get-SPRoutingMachinePool
Remove-SPRoutingMachinePool
Set-SPRoutingMachinePool


Add-SPRoutingRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a routing rule.

Add-SPRoutingRule [-RequestManagementSettings] <SPRequestManagementSettingsPipeBind> [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Criteria <SPRequestManagementRuleCriteriaPipeBind[]>] [-ExecutionGroup <Nullable>] [-Expiration <Nullable>] [-MachinePool <SPRoutingMachinePoolPipeBind>]

Parameters

Parameter Required Type Description

RequestManagementSettings

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the name of the request management settings object to add to the routing rule.

Name

Required

System.String

Specifies the name of the rule.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Criteria

Optional

Microsoft.SharePoint.PowerShell.SPRequestManagementRuleCriteriaPipeBind[]

Specifies the criteria for the rule to match.

ExecutionGroup

Optional

System.Nullable

Specifies the group in which the rule will be placed.

Expiration

Optional

System.Nullable

Specifies the expiration date and time of the rule.

MachinePool

Optional

Microsoft.SharePoint.PowerShell.SPRoutingMachinePoolPipeBind

Specifies the pool of machines to which a request will be routed if the created rule is matched.

Detailed Description

The Add-SPRoutingRule cmdlet adds a routing rule for the farm.

Input Types

Return Types

Example

--------------EXAMPLE--------

Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Get-SPRoutingRule -RequestManagementSettings $rm
Copy code
$machines=Get-SPRoutingMachineInfo -RequestManagementSettings $rm
Copy code
Add-SPRoutingMachinePool -RequestManagementSettings $rm -Name <Name of Pool> -MachineTargets $machines

This examples adds a routing rule to the farm by using the $rm and $machines variables.

See also

Get-SPRoutingRule
Remove-SPRoutingRule
Set-SPRoutingRule


Add-SPThrottlingRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a new throttling rule.

Add-SPThrottlingRule [-RequestManagementSettings] <SPRequestManagementSettingsPipeBind> [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Criteria <SPRequestManagementRuleCriteriaPipeBind[]>] [-Expiration <Nullable>] [-Threshold <Nullable>]

Parameters

Parameter Required Type Description

RequestManagementSettings

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the name of the request management settings object to add.

Name

Required

System.String

Specifies the name of the throttling rule.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Criteria

Optional

Microsoft.SharePoint.PowerShell.SPRequestManagementRuleCriteriaPipeBind[]

Specifies the criteria for the rule to match.

Expiration

Optional

System.Nullable

Specifies the expiration date and time of the rule.

Threshold

Optional

System.Nullable

Specifies a value between 0 and 10 which defines the maximum threshold for throttling. The Request Manager will remove routing targets if their Health-Score becomes greater than this value.

Detailed Description

The Add-SPThrottlingRule cmdlet adds a new throttling rule for the farm by using the Name and RequestManagementSettings parameters.

Input Types

Return Types

Example

-----------EXAMPLE---------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
$c=New-SPRequestManagementRuleCriteria -Value http -Property url -MatchType startswith -CaseSensitive $false
Copy code
Add-SPThrottlingRule -RequestManagementSettings $rm -Name <Rule Name> -Criteria $c -Threshold 4

This example adds a throttling rule for a specified identity by using the $rm and $c variables.

See also

Get-SPThrottlingRule
Remove-SPThrottlingRule
Set-SPThrottlingRule


Get-SPRoutingMachineInfo
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all the routing targets.

Get-SPRoutingMachineInfo [-RequestManagementSettings] <SPRequestManagementSettingsPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Availability <Nullable>] [-Name <String>]

Parameters

Parameter Required Type Description

RequestManagementSettings

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the name of the request management settings object to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Availability

Optional

System.Nullable

Specifies whether or not the specified computer will be available for routing. If no value is specified, all computers are returned.

The values for this parameter are filtered based on availability.

The valid values are:

--Available

--Unavailable

Name

Optional

System.String

Specifies the name of the computer for which you want to return routing information.

Detailed Description

Use the Get-SPRoutingMachineInfo cmdlet to return all the routing targets that are being used by the Request Manager object.

Input Types

Return Types

Example

------------EXAMPLE------------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Get-SPRoutingMachineInfo -RequestManagementSettings $rm

This example returns a routing target for a specified identity.

See also

Add-SPRoutingMachineInfo
Remove-SPRoutingMachineInfo
Set-SPRoutingMachineInfo


Get-SPRoutingMachinePool
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all available routing pools.

Get-SPRoutingMachinePool [-RequestManagementSettings] <SPRequestManagementSettingsPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Name <String>]

Parameters

Parameter Required Type Description

RequestManagementSettings

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the name of the request management settings object to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Name

Optional

System.String

Specifies the name of the machine pool to return.

Detailed Description

Use the Get-SPRoutingMachinePool cmdlet to return all available routing pools by using the RequestManagementSettings parameter.

Input Types

Return Types

Example

--------------EXAMPLE---------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Get-SPRoutingMachinePool -RequestManagementSettings $rm

This example returns a routing pool for the specified identity.

See also

Add-SPRoutingMachinePool
Remove-SPRoutingMachinePool
Set-SPRoutingMachinePool


Get-SPRoutingRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all routing rules.

Get-SPRoutingRule [-RequestManagementSettings] <SPRequestManagementSettingsPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Name <String>]

Parameters

Parameter Required Type Description

RequestManagementSettings

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the name of the request management settings object to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Name

Optional

System.String

Specifies the name of the rule to return.

Detailed Description

Use the Get-SPRoutingRule cmdlet to return routing rules for the farm.

Input Types

Return Types

Example

--------------EXAMPLE------------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Get-SPRoutingRule -RequestManagementSettings $rm

This example returns a routing rule for the farm.

See also

Add-SPRoutingRule
Remove-SPRoutingRule
Set-SPRoutingRule


Get-SPThrottlingRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all throttling rules.

Get-SPThrottlingRule [-RequestManagementSettings] <SPRequestManagementSettingsPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Name <String>]

Parameters

Parameter Required Type Description

RequestManagementSettings

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the name of the request management settings object to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Name

Optional

System.String

Specifies the name of the throttling rule to return.

Detailed Description

Use the Get-SPThrottlingRule cmdlet to return all the throttling rules from the farm.

Input Types

Return Types

Example

----------EXAMPLE--------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Get-SPThrottlingRule -RequestManagementSettings $rm

This example returns throttling rules for the farm by using the $rm and $web variables.

See also

Add-SPThrottlingRule
Remove-SPThrottlingRule
Set-SPThrottlingRule


Remove-SPRoutingMachineInfo
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes an external routing target.

Remove-SPRoutingMachineInfo [-Identity] <SPRoutingMachineInfoPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPRoutingMachineInfoPipeBind

Specifies the computer object that Request Manager will remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Remove-SPRoutingMachineInfo cmdlet to remove an external routing target by using the Identity parameter.

Input Types

Return Types

Example

----------EXAMPLE-------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
$M=Get-SPRoutingMachineInfo -RequestManagementSettings $rm -Name <MachineName>
Copy code
Remove-SPRoutingMachineInfo -Identity $M

This example removes a routing target for a specified identity.

See also

Add-SPRoutingMachineInfo
Get-SPRoutingMachineInfo
Set-SPRoutingMachineInfo


Remove-SPRoutingMachinePool
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a routing pool from Request Manager.

Remove-SPRoutingMachinePool [-Identity] <SPRoutingMachinePoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPRoutingMachinePoolPipeBind

Specifies the Request Manager object to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Remove-SPRoutingMachinePool cmdlet to remove a routing pool from the Request Manager object by using the Identity parameter.

Input Types

Return Types

Example

-------------EXAMPLE----------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
$pool=Get-SPRoutingMachinePool -RequestManagementSettings $rm
Copy code
Remove-SPRoutingMachinePool -Identity $pool

This example removes a routing pool for the specified identity by using the $pool variable.

See also

Add-SPRoutingMachinePool
Get-SPRoutingMachinePool
Set-SPRoutingMachinePool


Remove-SPRoutingRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a routing rule.

Remove-SPRoutingRule [-Identity] <SPRoutingRulePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPRoutingRulePipeBind

Specifies the rule object to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Remove-SPRoutingRule cmdlet removes a routing rule by using the Identity parameter. If the Identity parameter is not specified, the routing rules for the entire farm are removed.

Input Types

Return Types

Example

--------------EXAMPLE----------

Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Get-SPRoutingRule -RequestManagementSettings $rm
Copy code
$machines=Get-SPRoutingMachineInfo -RequestManagementSettings $rm
Copy code
$pool=Add-SPRoutingMachinePool -RequestManagementSettings $rm -Name <Name of Pool> -MachineTargets $machines
Copy code
$c=New-SPRequestManagementRuleCriteria -Value http -Property url -MatchType startswith -CaseSensitive $false
Copy code
$rule=Add-SPRoutingRule -RequestManagementSettings $rm -Name <Rule Name> -Criteria $c -MachinePool $pool
Copy code
Remove-SPRoutingRule -Identity $rule

This example removes a routing for a specified identity by using the $rule variable.

See also

Add-SPRoutingRule
Get-SPRoutingRule
Set-SPRoutingRule


Remove-SPThrottlingRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a throttling rule.

Remove-SPThrottlingRule [-Identity] <SPThrottlingRulePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPThrottlingRulePipeBind

Specifies the throttling rule object to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Remove-SPThrottlingRule cmdlet to remove a throttling rule from the farm.

Input Types

Return Types

Example

------------EXAMPLE-------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
$c=New-SPRequestManagementRuleCriteria -Value http -Property url -MatchType startswith -CaseSensitive $false
Copy code
$throttlingrule=Add-SPThrottlingRule -RequestManagementSettings $rm -Name <Rule Name> -Criteria $c -Threshold 4
Copy code
Remove-SPThrottlingRule -Identity $throttlingrule

This example removes a throttling rule for a specified identity by using the $throttlingrule variable.

See also

Add-SPThrottlingRule
Get-SPThrottlingRule
Set-SPThrottlingRule


Set-SPRoutingMachineInfo
See also Example
[image]

Updated: March 12, 2013

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets routing target properties.

Set-SPRoutingMachineInfo [-Identity] <SPRoutingMachineInfoPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Availability <Nullable>] [-ClearOutgoingPort <SwitchParameter>] [-OutgoingPort <Nullable>] [-OutgoingScheme <Nullable>] [-StaticWeight <Nullable>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPRoutingMachineInfoPipeBind

Specifies the name of the request management settings object to set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Availability

Optional

System.Nullable

Specifies whether or not the specified computer will be available for routing.

The valid values are:

--Available

--Unavailable

ClearOutgoingPort

Optional

System.Management.Automation.SwitchParameter

Clears the outgoing port if it is set.

OutgoingPort

Optional

System.Nullable

Specifies the listening port for the computer that Request Management will use to communicate with.

OutgoingScheme

Optional

System.Nullable

Determines the schema of outgoing connections.

The valid values are:

--SameAsIncoming

--Http

--Https

StaticWeight

Optional

System.Nullable

Specifies whether the static weight of a computer routing is used by Request Manager. If the static weight is higher, more requests will be routed to the computer.

Detailed Description

Use the Set-SPRoutingMachineInfo cmdlet to set routing target properties by using the Identity parameter.

Input Types

Return Types

Example

------------EXAMPLE----------

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
$m=Get-SPRoutingMachineInfo -RequestManagementSettings $rm -Name <MachineName>
Copy code
Set-SPRoutingMachineInfo -Identity $m -Availability Unavailable

This example sets the "Availability" routing target property to Unavailable for a specified identity.

See also

Add-SPRoutingMachineInfo
Get-SPRoutingMachineInfo
Remove-SPRoutingMachineInfo

Change History

Date | Description
March 12, 2013 | Updated the description for the OutgoingPort parameter.
July 16, 2012 | Initial publication


Set-SPRoutingMachinePool
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets properties of a machine pool.

Set-SPRoutingMachinePool [-Identity] <SPRoutingMachinePoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-MachineTargets <SPRoutingRuleTargetPipeBind[]>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPRoutingMachinePoolPipeBind

Specifies the name of the request management settings object to set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

MachineTargets

Optional

Microsoft.SharePoint.PowerShell.SPRoutingRuleTargetPipeBind[]

Specifies the routing targets collection that the machine pool will contain.

Detailed Description

Use the Set-SPRoutingMachinePool cmdlet to set properties of a machine pool by using the Identity parameter.

Input Types

Return Types

Example

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
$pool=Get-SPRoutingMachinePool -RequestManagementSettings $rm
Copy code
Set-SPRoutingMachinePool -Identity $pool -MachineTargets <Machine collections>

This example sets the machine pool property of MachineTargets for a specified identity as defined by the $pool variable.

See also

Add-SPRoutingMachinePool
Get-SPRoutingMachinePool
Remove-SPRoutingMachinePool


Set-SPRoutingRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Changes properties of an existing routing rule.

Set-SPRoutingRule [-Identity] <SPRoutingRulePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Criteria <SPRequestManagementRuleCriteriaPipeBind[]>] [-ExecutionGroup <Nullable>] [-Expiration <Nullable>] [-MachinePool <SPRoutingMachinePoolPipeBind>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPRoutingRulePipeBind

Specifies the name of the request management settings object to set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Criteria

Optional

Microsoft.SharePoint.PowerShell.SPRequestManagementRuleCriteriaPipeBind[]

Specifies the criteria for the rule to match.

ExecutionGroup

Optional

System.Nullable

Specifies the group in which the rule will be placed.

Expiration

Optional

System.Nullable

Specifies the expiration date and time of the rule.

MachinePool

Optional

Microsoft.SharePoint.PowerShell.SPRoutingMachinePoolPipeBind

Specifies the pool of machines to which a request will be routed if the changed rule is matched.

Detailed Description

Use the Set-SPRoutingRule cmdlet to change properties of an existing routing rule.

Input Types

Return Types

Example

------------EXAMPLE---------

Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
Get-SPRoutingRule -RequestManagementSettings $rm
Copy code
$machines=Get-SPRoutingMachineInfo -RequestManagementSettings $rm
Copy code
$pool=Add-SPRoutingMachinePool -RequestManagementSettings $rm -Name <Name of Pool> -MachineTargets $machines
Copy code
$criteria=New-SPRequestManagementRuleCriteria -Value http -Property url -MatchType startswith -CaseSensitive $false
Copy code
$rule=Add-SPRoutingRule -RequestManagementSettings $rm -Name <Rule Name> -Criteria $c -MachinePool $pool
Copy code
$criteriaNew = New-SPRequestManagementRuleCriteria -Property UserAgent -MatchType Equals -Value "Mozilla/4.0 (compatible; MSIE 4.01; Windows NT; MS Search 6.0 Robot)"
Copy code
Set-SPRoutingRule -Identity $rule -Criteria $criteriaNew

This example sets a routing rule for the specified identity by using the $rule variable.

See also

Add-SPRoutingRule
Get-SPRoutingRule
Remove-SPRoutingRule


Set-SPThrottlingRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Changes properties of an existing throttling rule.

Set-SPThrottlingRule [-Identity] <SPThrottlingRulePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Criteria <SPRequestManagementRuleCriteriaPipeBind[]>] [-Expiration <Nullable>] [-Threshold <Nullable>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPThrottlingRulePipeBind

Specifies the throttling rule object to set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Criteria

Optional

Microsoft.SharePoint.PowerShell.SPRequestManagementRuleCriteriaPipeBind[]

Specifies the criteria for the rule to match.

Expiration

Optional

System.Nullable

Specifies the expiration date and time of the rule.

Threshold

Optional

System.Nullable

Specifies a value between 0 and 10 which defines the maximum threshold for throttling. The Request Manager will remove routing targets if the Health-Score becomes greater than this value.

Detailed Description

Use the Set-SPThrottlingRule cmdlet to change the properties of an existing throttling rule by using the Identity parameter.

Input Types

Return Types

Example

Copy code
$web=Get-SPWebApplication -Identity <URL of web application>
Copy code
$rm=Get-SPRequestManagementSettings -Identity $web
Copy code
$c=New-SPRequestManagementRuleCriteria -Value http -Property url -MatchType startswith -CaseSensitive $false
Copy code
$throttlingrule=Add-SPThrottlingRule -RequestManagementSettings $rm -Name <Rule Name> -Criteria $c -Threshold 4
Copy code
$criteriaNew = New-SPRequestManagementRuleCriteria -Property UserAgent -MatchType Equals -Value "Mozilla/4.0 (compatible; MSIE 4.01; Windows NT; MS Search 6.0 Robot)"
Copy code
Set-SPThrottlingRule -Identity $ throttlingrule -Criteria $criteriaNew -Threshold 8

This example sets throttling rule property

See also

Add-SPThrottlingRule
Get-SPThrottlingRule
Remove-SPThrottlingRule


Get-SPRequestManagementSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a Request Manager object.

Get-SPRequestManagementSettings [-Identity] <SPRequestManagementSettingsPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the web-application for which a user wants to enable routing or throttling.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPRequestManagementSettings cmdlet returns a Request Manager object which is base for performing any request manager management operation.

Input Types

Return Types

Example

-----------EXAMPLE-------

Copy code
Get-SPRequestManagementSettings -Identity <GUID>

This example returns a request manager object for a specified identity.

See also

Set-SPRequestManagementSettings
New-SPRequestManagementRuleCriteria


New-SPRequestManagementRuleCriteria
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates criteria for the rule to match.

New-SPRequestManagementRuleCriteria [-Value] <String> [-CustomHeader] <String> [[-CaseSensitive] <Nullable>] [[-MatchType] <Nullable>] [-AssignmentCollection <SPAssignmentCollection>]
New-SPRequestManagementRuleCriteria [-Value] <String> [-Property] <Nullable> [[-CaseSensitive] <Nullable>] [[-MatchType] <Nullable>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Value

Required

System.String

Specifies a value for the rule to match.

CustomHeader

Required

System.String

CaseSensitive

Optional

System.Nullable

Specifies whether or not the match is case sensitive.

MatchType

Optional

System.Nullable

Defines operators for the match.

The following are the valid values:

--Equals

--Regex

--StartsWith

--EndsWith

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

Value

Required

System.String

Specifies a value for the rule to match.

Property

Required

System.Nullable

Specifies a header for a value to match.

The following are the valid values:

--Url

--Urlreferrer

--UserAgent

--Host

--IP

--HttpMethod

--SoapAction

--CustomHeader

CaseSensitive

Optional

System.Nullable

Specifies whether or not the match is case sensitive.

MatchType

Optional

System.Nullable

Defines operators for the match.

The following are the valid values:

--Equals

--Regex

--StartsWith

--EndsWith

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the New-SPRequestManagementRuleCriteria cmdlet to create criteria for the rule to match.

Input Types

Return Types

Example

Copy code

  See also
Get-SPRequestManagementSettings
Set-SPRequestManagementSettings


Set-SPRequestManagementSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets Request Manager properties.

Set-SPRequestManagementSettings [-Identity] <SPRequestManagementSettingsPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-RoutingEnabled <Nullable>] [-RoutingScheme <Nullable>] [-ThrottlingEnabled <Nullable>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPRequestManagementSettingsPipeBind

Specifies the Request Manager object for which settings will be applied.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

RoutingEnabled

Optional

System.Nullable

Specifies whether routing is enabled or disabled for the Request Manager object.

RoutingScheme

Optional

System.Nullable

Specifies the routing scheme.

The value is one of the following:

--Default- Performs random selection.

--StaticMachineWeight- Uses Static weight of target.

--HealthBased- Considers health score of machine.

ThrottlingEnabled

Optional

System.Nullable

Specifies whether throttling is enabled or disabled for the Request Manager object.

Detailed Description

Use the Set-SPRequestManagementSettings cmdlet to set properties for the Request Manager.

Input Types

Return Types

Example

Copy code

  See also
Get-SPRequestManagementSettings
New-SPRequestManagementRuleCriteria


Get-SPDistributedCacheClientSetting
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Returns distributed cache settings from usage.

Get-SPDistributedCacheClientSetting [-ContainerType] <DistributedDefaultCache | DistributedAccessCache | DistributedActivityFeedCache | DistributedBouncerCache | DistributedLogonTokenCache | DistributedServerToAppServerAccessTokenCache | DistributedSearchCache | DistributedSecurityTrimmingCache | DistributedActivityFeedLMTCache | DistributedViewStateCache> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

ContainerType

Required

Microsoft.SharePoint.DistributedCaching.Utilities.SPDistributedCacheContainerType

Specifies the container type to clear.

The valid values are the following:

  • DistributedDefaultCache

  • DistributedAccessCache

  • DistributedActivityFeedCache

  • DistributedBouncerCache

  • DistributedLogonTokenCache

  • DistributedServerToAppServerAccessTokenCache

  • DistributedSearchCache

  • DistributedSecurityTrimmingCache

  • DistributedActivityFeedLMTCache

  • DistributedViewStateCache

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPDistributedCacheClientSettings cmdlet to return distributed cache settings from usage. Usage can be any type of cache that the ContainerType parameter specifies.

Input Types

Return Types

Example

------------EXAMPLE--------

Copy code
Get-SPDistributedCacheClientSetting -ContainerType DistributedLogonTokenCache

This example returns the Distributed Cache client settings for DistributedLogonTokenCache.

See also

Set-SPDistributedCacheClientSetting


Clear-SPDistributedCacheItem
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013

Clears cached items from the distributed cache server.

Clear-SPDistributedCacheItem [-ContainerType] <DistributedDefaultCache | DistributedAccessCache | DistributedActivityFeedCache | DistributedBouncerCache | DistributedLogonTokenCache | DistributedServerToAppServerAccessTokenCache | DistributedSearchCache | DistributedSecurityTrimmingCache | DistributedActivityFeedLMTCache | DistributedViewStateCache> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ContainerType

Required

Microsoft.SharePoint.DistributedCaching.Utilities.SPDistributedCacheContainerType

Specifies the container type to clear.

The valid values are the following:

  • DistributedDefaultCache

  • DistributedAccessCache

  • DistributedActivityFeedCache

  • DistributedBouncerCache

  • DistributedLogonTokenCache

  • DistributedServerToAppServerAccessTokenCache

  • DistributedSearchCache

  • DistributedSecurityTrimmingCache

  • DistributedActivityFeedLMTCache

  • DistributedViewStateCache

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Clear-SPDistributedCacheItems cmdlet to clear cached items from the distributed cache server.

Input Types

Return Types

Example

------------EXAMPLE------

Copy code
Clear-SPDistributedCacheItem -ContainerType DistributedLogonTokenCache

This example removes all the cache items for distributed token cache.


Set-SPDistributedCacheClientSetting
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Sets distributed cache settings.

Set-SPDistributedCacheClientSetting [-ContainerType] <DistributedDefaultCache | DistributedAccessCache | DistributedActivityFeedCache | DistributedBouncerCache | DistributedLogonTokenCache | DistributedServerToAppServerAccessTokenCache | DistributedSearchCache | DistributedSecurityTrimmingCache | DistributedActivityFeedLMTCache | DistributedViewStateCache> [-DistributedCacheClientSettings] <SPDistributedCacheClientSettings> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

ContainerType

Required

Microsoft.SharePoint.DistributedCaching.Utilities.SPDistributedCacheContainerType

Specifies the container type to clear.

The valid values are the following:

  • DistributedDefaultCache

  • DistributedAccessCache

  • DistributedActivityFeedCache

  • DistributedBouncerCache

  • DistributedLogonTokenCache

  • DistributedServerToAppServerAccessTokenCache

  • DistributedSearchCache

  • DistributedSecurityTrimmingCache

  • DistributedActivityFeedLMTCache

  • DistributedViewStateCache

DistributedCacheClientSettings

Required

Microsoft.SharePoint.PowerShell.SPDistributedCacheClientSettings

Updates the various cache client settings. It is recommended to use the default settings.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Set-SPDistributedCacheClientSettings cmdlet to set the distributed cache service based on usage. Usage can be any type of cache that the ContainerType parameter specifies.

Input Types

Return Types

Example

---------EXAMPLE------

Copy code
$settings = Get-SPDistributedCacheClientSetting -ContainerType DistributedLogonTokenCache
Copy code
$settings.MaxConnectionsToServer = 10
Copy code
Set-SPDistributedCacheClientSetting -ContainerType DistributedLogonTokenCache -DistributedCacheClientSettings $settings

This example updates the MaxConnectionsToServer to 10 for DistributedLogonTokenCache.

See also

Get-SPDistributedCacheClientSetting


Stop-SPDistributedCacheServiceInstanceGracefullyOnLocalServer
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Obsolete. For replacement, see Stop-SPDistributedCacheServiceInstance

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Remove-SPDistributedCacheServiceInstanceOnLocalServer
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Obsolete. For replacement, see Remove-SPDistributedCacheServiceInstance

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Add-SPDistributedCacheServiceInstanceOnLocalServer
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Obsolete. For replacement, see Add-SPDistributedCacheServiceInstance.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Stop-SPDistributedCacheServiceInstance
See also Example
[image]

Published: July 31, 2012

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Stops an instance of the distributed cache service on a local server.

Stop-SPDistributedCacheServiceInstance [[-Graceful] <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Graceful

Optional

System.Management.Automation.SwitchParameter

Specifies whether to gracefully stop an instance of the distributed cache service.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Stop-SPDistributedCacheServiceInstance cmdlet to stop an instance of the distributed cache service on a local server.

Execution of this cmdlet moves cached items to another server to preserve them. If you stop the distributed service before you stop each instance, cached items are lost. To prevent cached items from being lost, use the Graceful parameter.

Input Types

Return Types

Example

------------EXAMPLE----------

Copy code
Stop-SPDistributedCacheServiceInstance -Graceful

This example gracefully stops an instance of a distributed cache service on a local server.

See also

Remove-SPDistributedCacheServiceInstanceOnLocalServer
Add-SPDistributedCacheServiceInstanceOnLocalServer


Add-SPDistributedCacheServiceInstance
See also Example
[image]

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Adds an instance of the distributed cache service to a local server.

Add-SPDistributedCacheServiceInstance  [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Add-SPDistributedCacheServiceInstance cmdlet to add an instance of the distributed cache server to a local server. This is required to start the AppFabric service.

Input Types

Return Types

Example

------------EXAMPLE---------

Copy code
Add-SPDistributedCacheServiceInstance

This example adds an instance of the distributed cache service to a local server.

See also

Stop-SPDistributedCacheServiceInstance

Remove-SPDistributedCacheServiceInstance


Remove-SPDistributedCacheServiceInstance
See also Example
[image]

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Removes an instance of the distributed cache service from a local server.

Remove-SPDistributedCacheServiceInstance [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Remove-SPDistributedCacheServiceInstance cmdlet to remove an instance of the distributed cache service from a local server. This is required to stop the AppFabric service.

Input Types

Return Types

Example

------EXAMPLE----

Copy code
Remove-SPDistributedCacheServiceInstance

This example removes an instance of a distributed cache.

See also

Stop-SPDistributedCacheServiceInstance

Add-SPDistributedCacheServiceInstance


Update-SPDistributedCacheSize
Example
[image]

Applies to: SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

Reconfigures the allocation of memory that is dedicated to the Distributed Cache service.

Update-SPDistributedCacheSize [-CacheSizeInMB] <UInt32> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

CacheSizeInMB

Required

System.UInt32

Specifies the memory size in megabytes (MB) that you want to allocate to the Distributed Cache service. The default value is 5 percent of total system random access memory (RAM). This value should not be more than 40 percent of total system RAM with a maximum limit of 16 gigabytes (GB).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Update-SPDistributedCacheSize cmdlet to allocate memory to the Distributed cache service.

Input Types

Return Types

Example

-------------EXAMPLE----------

Copy code
Update-SPDistributedCacheSize -CacheSizeInMB 2048


PerformancePoint Services cmdlets in SharePoint Server 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you manage PerformancePoint Services in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

PerformancePoint Services in SharePoint Server 2013 is a powerful performance management service in SharePoint Server 2013 that you can use to monitor and analyze your business. By providing flexible, easy-to-use tools for building dashboards, scorecards, and key performance indicators (KPIs), PerformancePoint Services can help everyone across your organization make informed business decisions that align with company-wide objectives and strategy.

You can use Windows PowerShell functionality to provision PerformancePoint Services, manage and configure a service application, configure and manage trusted locations, configure and manage proxies for the service application, and configure the global settings of the service.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Clear-SPPerformancePointServiceApplicationTrustedLocation | Clears all the trusted locations for a PerformancePoint Services application identity
Get-SPPerformancePointServiceApplication | Returns a PerformancePoint Service application object and properties.
Get-SPPerformancePointServiceApplicationTrustedLocation | Returns a trusted location object and properties for a PerformancePoint Services application.
New-SPPerformancePointServiceApplication | Creates a new service application for PerformancePoint Services.
New-SPPerformancePointServiceApplicationProxy | Creates a proxy for a PerformancePoint Services application.
New-SPPerformancePointServiceApplicationTrustedLocation | Creates a new trusted location for a PerformancePoint Services application.
Remove-SPPerformancePointServiceApplication | Deletes a PerformancePoint Services application from a farm.
Remove-SPPerformancePointServiceApplicationProxy | Deletes the proxy for a PerformancePoint Services application.
Remove-SPPerformancePointServiceApplicationTrustedLocation | Removes a single trusted location from a PerformancePoint Services application.
Set-SPPerformancePointSecureDataValues | Sets global settings for the unattended service account.
Set-SPPerformancePointServiceApplication | Sets global run-time properties for a PerformancePoint Services application.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Clear-SPPerformancePointServiceApplicationTrustedLocation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Clears all the trusted locations for a PerformancePoint Service application identity.

Clear-SPPerformancePointServiceApplicationTrustedLocation -ServiceApplication <SPPerformancePointMonitoringServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-TrustedLocationType <DataSource | Content>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationPipeBind

Specifies the PerformancePoint Service application that contains the trusted locations.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a PerformancePoint Service application (for example, PerfPointApp1); or an instance of a valid SPPerformancePointMonitoringServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

TrustedLocationType

Optional

System.Nullable

Specifies the type of trusted locations to clear. If the TrustedLocationType parameter is not specified, this cmdlet clears all the trusted locations for the specified PerformancePoint Service application.

The type must be one of the following: content, data source.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Clear-SPPerformancePointServiceApplicationTrustedLocation cmdlet removes all the trusted locations for a PerformancePoint Service application. Use the TrustedLocationType parameter to remove only the trusted locations for a trusted location type.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Clear-SPPerformancePointServiceApplicationTrustedLocation -ServiceApplication My_Service_Application

This example removes trusted locations from the Service application named, My_Service_Application.

See also

Get-SPPerformancePointServiceApplicationTrustedLocation
New-SPPerformancePointServiceApplicationTrustedLocation
Remove-SPPerformancePointServiceApplicationTrustedLocation


Get-SPPerformancePointServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a PerformancePoint Service application object and properties.

Get-SPPerformancePointServiceApplication [[-Identity] <SPPerformancePointMonitoringServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationPipeBind

Specifies the PerformancePoint Service application to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a PerformancePoint Service application (for example, PerfPointApp1); or an instance of a valid SPPerformancePointMonitoringServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPPerformancePointServiceApplication cmdlet to read a PerformancePoint Service application object and properties. If the Identity parameter is not specified, the cmdlet returns the collection of PerformancePoint Service applications in the farm.

Input Types

Return Types

Example

-------------------EXAMPLE------------------

Copy code
Get-SPPerformancePointServiceApplication "PPSApp_01"

This example gets a PerformancePoint Service application named PPSApp_01.

See also

New-SPPerformancePointServiceApplication
Remove-SPPerformancePointServiceApplication
Set-SPPerformancePointServiceApplication


Get-SPPerformancePointServiceApplicationTrustedLocation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a trusted location object and properties for a PerformancePoint Service application.

Get-SPPerformancePointServiceApplicationTrustedLocation [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Identity <SPPerformancePointMonitoringServiceApplicationTrustedLocationPipeBind>] [-ServiceApplication <SPPerformancePointMonitoringServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Identity

Optional

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationTrustedLocationPipeBind

Specifies the trusted location to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPPerformancePointMonitoringServiceApplicationTrustedLocation object.

ServiceApplication

Optional

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationPipeBind

Specifies the PerformancePoint Service application that contains the trusted location.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a PerformancePoint Service application (for example, PerfPointApp1); or an instance of a valid SPPerformancePointMonitoringServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPPerformancePointMonitoringServiceApplicationTrustedLocation cmdlet to read a trusted location object and properties. If the Identity parameter is not specified, this cmdlet returns the list of all trusted locations and their properties for a PerformancePoint Service application.

Input Types

Return Types

Example

----------------------EXAMPLE----------------------

Copy code
Get-SPPerformancePointServiceApplication PPSApp_01 | Get-SPPerformancePointServiceApplicationTrustedLocation -Identity $_.ID | select *

This example retrieves TrustedLocation information for the PPSApp_01 PerformancePoint Service application.

See also

Clear-SPPerformancePointServiceApplicationTrustedLocation
New-SPPerformancePointServiceApplicationTrustedLocation
Remove-SPPerformancePointServiceApplicationTrustedLocation


New-SPPerformancePointServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new service application for the PerformancePoint Service.

New-SPPerformancePointServiceApplication [-Name] <String> -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AnalyticQueryCellMax <Int32>] [-AnalyticQueryLoggingEnabled <$true | $false>] [-AnalyticResultCacheMinimumHitCount <Int32>] [-ApplicationCacheEnabled <$true | $false>] [-ApplicationCacheMinimumHitCount <Int32>] [-ApplicationProxyCacheEnabled <$true | $false>] [-AssignmentCollection <SPAssignmentCollection>] [-CommentsDisabled <$true | $false>] [-CommentsScorecardMax <Int32>] [-Confirm [<SwitchParameter>]] [-DatabaseFailoverServer <String>] [-DatabaseName <String>] [-DatabaseServer <String>] [-DatabaseSQLAuthenticationCredential <PSCredential>] [-DataSourceQueryTimeoutSeconds <Int32>] [-DecompositionTreeMaximum <Int32>] [-ElementCacheSeconds <Int32>] [-FilterRememberUserSelectionsDays <Int32>] [-FilterTreeMembersMax <Int32>] [-IndicatorImageCacheSeconds <Int32>] [-MSMQEnabled <$true | $false>] [-MSMQName <String>] [-SelectMeasureMaximum <Int32>] [-SessionHistoryHours <Int32>] [-ShowDetailsInitialRows <Int32>] [-ShowDetailsMaxRows <Int32>] [-ShowDetailsMaxRowsDisabled <$true | $false>] [-TrustedContentLocationsRestricted <$true | $false>] [-TrustedDataSourceLocationsRestricted <$true | $false>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the new PerformancePoint Service application.

The type must be a valid name of a PerformancePoint Service application; for example, PerfPointApp1.

ApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS application pool to run the Web service in for the service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

AnalyticQueryCellMax

Optional

System.Int32

Specifies the maximum number of returned cells in an analytic grid.

A valid integer value from 1 through 1,000,000,000. The default value is 100,000.

AnalyticQueryLoggingEnabled

Optional

System.Nullable

Turns on verbose logging of query events.

The type must be one of the following: True or False. The default value is False.

ApplicationCacheEnabled

Optional

System.Nullable

Specifies whether the rendered output cache on the application server is on (True) or off (False). The default value is True.

ApplicationCacheMinimumHitCount

Optional

System.Nullable

Specifies the minimum number of times rendered output must be requested before it is added to cache. The default value is 2.

ApplicationProxyCacheEnabled

Optional

System.Nullable

Specifies rendered output cache on the front end Web server. The default value is True.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CommentsDisabled

Optional

System.Nullable

Specifies that users can add comments to scorecard cells.

The type must be one of the following: true or false.

CommentsScorecardMax

Optional

System.Nullable

Specifies the maximum number of comments that can be added to a scorecard. The default value is 1000.

The type must be an integer value from 1 through 1,000,000.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseFailoverServer

Optional

System.String

Specifies the name of the database server that contains the PerformancePoint Services database that must be mirrored.

This parameter was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

DatabaseName

Optional

System.String

Specifies the name of the PerformancePoint Services database that will be created when the service application is provisioned.

This parameter was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

DatabaseServer

Optional

System.String

Specifies the name of the database server where the PerformancePoint Services database will be created. This should be the same server name that is used for the SharePoint content and configuration databases.

The value may be written as SQL instance\server if it is not referring to the default instance.

This parameter was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

DatabaseSQLAuthenticationCredential

Optional

System.Management.Automation.PSCredential

Determines whether to use Windows authentication or SQL Server authentication when connecting to a PerformancePoint Services database.

This parameter was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

DataSourceQueryTimeoutSeconds

Optional

System.Nullable

Specifies the time, in seconds, before a data source query times out. The default value is 300.

The type must be an integer value in the range of 1 to 36,000.

DecompositionTreeMaximum

Optional

System.Nullable

Specifies the maximum number of items (per level) returned to the decomposition tree visualization.

A valid integer value from 1 through 1,000,000. The default value is 25.

ElementCacheSeconds

Optional

System.Int32

Specifies the first class object cache expiration time. The default value is 15.

FilterRememberUserSelectionsDays

Optional

System.Nullable

Specifies the number of days that user filter selections are remembered. The default value is 90.

The type must be an integer value from 1 through 10,000.

FilterTreeMembersMax

Optional

System.Nullable

Specifies the maximum number of records to show in filter treeview control. The default value is 500.

The type must be an integer value from 1 through 100,000.

IndicatorImageCacheSeconds

Optional

System.Nullable

Specifies the time, in seconds, that key performance indicator (KPI) icons are cached. The default value is 10.

The type must be an integer value from 1 through 3,600.

MSMQEnabled

Optional

System.Nullable

Specifies that notifications are sent to Microsoft Message Queuing (MSMQ) on content change.

The type must be one of the following: true or false. The default value is False.

MSMQName

Optional

System.String

Specifies the name of the queue. The queue name can contain a maximum of 380 characters, and cannot contain the following characters: CR (ASCII 13), LF (ASCII 10), backslash (\), plus sign (+, comma (,), or quotation marks ("") .

The type must be a valid MSMQ name; for example, MessageQueue1.

SelectMeasureMaximum

Optional

System.Nullable

Specifies the maximum number of measures to show in a dashboard Select Measure control. The default value is 1000.

The type must be an integer value from 1 through 1,000,000.

SessionHistoryHours

Optional

System.Nullable

Specifies the number of hours between clearing expired user navigation history. The default value is 2.

The type must be an integer value from 1 through 48.

ShowDetailsInitialRows

Optional

System.Nullable

Specifies the initial number of rows to retrieve for show details. The default value is 1,000.

The type must be an integer value from 1 through 100,000.

ShowDetailsMaxRows

Optional

System.Nullable

Specifies the maximum number of rows to retrieve for show details.

The type must be an integer value from 1 through 1,000,000. The default value is 10,000.

ShowDetailsMaxRowsDisabled

Optional

System.Nullable

Turns off the ShowDetailsInitialRows setting. If set to True, Analysis Services controls limit.

The type must be one of the following: True or False. The default value is False.

TrustedContentLocationsRestricted

Optional

System.Nullable

Specifies that only specified locations are trusted. The default setting is false (trust all content locations).

The type must be one of the following: True or False. The default value is False.

TrustedDataSourceLocationsRestricted

Optional

System.Nullable

Specifies that only specified locations are trusted. The default setting is false (trust all data source locations).

The type must be one of the following: True or False. The default value is False.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPPerformancePointServiceApplication cmdlet creates a new PerformancePoint Service on the farm.

Input Types

Return Types

Example

-----------------EXAMPLE------------------------

Copy code
New-SPPerformancePointServiceApplication -Name PPS_Application_01 -ApplicationPool PPS_Application_Pool_01

This example creates a new PerformancePoint Service application named PPSApp_01 and sets it to run under an application pool named PPS_Application_Pool_01.

See also

Get-SPPerformancePointServiceApplication
Remove-SPPerformancePointServiceApplication
Set-SPPerformancePointServiceApplication


New-SPPerformancePointServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a proxy for a PerformancePoint Service application.

New-SPPerformancePointServiceApplicationProxy [-Name] <String> -ServiceApplication <SPPerformancePointMonitoringServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Default <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the PerformancePoint Service application proxy to create.

The type must be a valid name of a PerformancePoint Service application proxy; for example, PerfPointAppProxy1.

ServiceApplication

Required

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationPipeBind

Specifies the PerformancePoint Service application that is associated with the new service application proxy.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a PerformancePoint service application (for example, PerfPointApp1); or an instance of a valid SPPerformancePointMonitoringServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Default

Optional

System.Management.Automation.SwitchParameter

Specifies that the new application proxy will be added to the default service application proxy group.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPPerformancePointServiceApplicationProxy cmdlet creates a proxy for a PerformancePoint Service application.

Input Types

Return Types

Example

--------------------EXAMPLE--------------------

Copy code
New-SPPerformancePointServiceApplicationProxy -Name PPS_Application_Proxy_01 -ServiceApplication PPS_Application_01 -Default

This example creates a new PerformancePoint Service application proxy named PPS_Application_Proxy_01, associated with the service application named PPS_Application_01 and is added to the Default proxy group.

See also

Remove-SPPerformancePointServiceApplicationProxy


New-SPPerformancePointServiceApplicationTrustedLocation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new trusted location for a PerformancePoint Service application.

New-SPPerformancePointServiceApplicationTrustedLocation -ServiceApplication <SPPerformancePointMonitoringServiceApplicationPipeBind> -TrustedLocationType <DataSource | Content> -Type <SiteCollection | Site | List | DocumentLibrary> -Url <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationPipeBind

Specifies the PerformancePoint Service application to which the new trusted location will be added.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a PerformancePoint Service application (for example, PerfPointApp1); or an instance of a valid SPPerformancePointMonitoringServiceApplication object.

TrustedLocationType

Required

Microsoft.PerformancePoint.Scorecards.TrustedFileType

Specifies the type of trusted locations to create. If TrustedLocationType is not specified, this cmdlet creates all the trusted locations for the specified PerformancePoint Service application.

The type must be one of the following: Content or Data Source.

Type

Required

Microsoft.PerformancePoint.Scorecards.RepositoryLocationType

Specifies the type of trusted location.

The type must be one of the following: Site Collection, Site, Document Library, List

Url

Required

System.String

Specifies the URL of the trusted location site, site collection, site, document library, or list. The type must be a valid URL, in the form http://server_name, or http://server_name/sitecollection/site/list.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies the description of the new safe data provider.

The type must be a valid string with a maximum of 4096 characters.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPPerformancePointServiceApplicationTrustedLocation cmdlet creates a new trusted location for a PerformancePoint Service application. The new trusted location can be a Content or Data Source trusted location type and is enforced only when it is enabled in the PerformancePoint Service application.

Input Types

Return Types

Example

------------------EXAMPLE---------------------

Copy code
New-SPPerformancePointServiceApplicationTrustedLocation -ServiceApplication PPSApp_01 -url "http://Some_Valid_Site_URL" -Type Site -TrustedLocationType Content

This example creates a new TrustedLocation for the PPSApp_01 service application. This creates a Content trusted location of type Site with the specified URL.

See also

Clear-SPPerformancePointServiceApplicationTrustedLocation
Get-SPPerformancePointServiceApplicationTrustedLocation
Remove-SPPerformancePointServiceApplicationTrustedLocation


Remove-SPPerformancePointServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Deletes a PerformancePoint Service application from a farm.

Remove-SPPerformancePointServiceApplication [-Identity] <SPPerformancePointMonitoringServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationPipeBind

Specifies the PerformancePoint Service application to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a PerformancePoint Service application (for example, PerfPointApp1); or an instance of a valid SPPerformancePointMonitoringServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPPerformancePointServiceApplication cmdlet deletes a PerformancePoint Service application.

Input Types

Return Types

Example

--------------------EXAMPLE-----------------

Copy code
Remove-SPPerformancePointServiceApplication -Identity PPSApp_01

This example removes the PPSApp_01 PerformancePoint Service application.

See also

Get-SPPerformancePointServiceApplication
New-SPPerformancePointServiceApplication
Set-SPPerformancePointServiceApplication


Remove-SPPerformancePointServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Deletes the proxy for a PerformancePoint Service application.

Remove-SPPerformancePointServiceApplicationProxy [-Identity] <SPPerformancePointMonitoringServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationProxyPipeBind

Specifies the PerformancePoint Service application proxy to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a PerformancePoint Service application proxy (for example, PerfPointAppProxy1); or an instance of a valid SPPerformancePointMonitoringServiceApplicationProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPPerformancePointServiceApplicationProxy cmdlet deletes the proxy for a PerformancePoint Service application.

Input Types

Return Types

Example

------------------EXAMPLE--------------------

Copy code
Remove-SPPerformancePointServiceApplicationProxy -Identity PPS_Application_Proxy_01

This example removes the PPS_Application_Proxy_01 application proxy from its associated PerformancePoint Service application.

See also

New-SPPerformancePointServiceApplicationProxy


Remove-SPPerformancePointServiceApplicationTrustedLocation
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a single trusted location from a PerformancePoint Service application.

Remove-SPPerformancePointServiceApplicationTrustedLocation -Identity <SPPerformancePointMonitoringServiceApplicationTrustedLocationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationTrustedLocationPipeBind

Specifies the trusted location to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPPerformancePointMonitoringServiceApplicationTrustedLocation object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPPerformancePointServiceApplicationTrustedLocation cmdlet deletes a single trusted location from a PerformancePoint Service application.

Input Types

Return Types

Example

---------------------EXAMPLE--------------------

Copy code
Remove-SPPerformancePointServiceApplicationTrustedLocation -Identity <Valid GUID of a Trusted Location in an Application>

This example removes a Trusted Location having the specified GUID from a PerformancePoint Service Application.

See also

Clear-SPPerformancePointServiceApplicationTrustedLocation
Get-SPPerformancePointServiceApplicationTrustedLocation
New-SPPerformancePointServiceApplicationTrustedLocation


Set-SPPerformancePointSecureDataValues
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets global settings for the unattended service account.

Set-SPPerformancePointSecureDataValues [-ServiceApplication] <SPPerformancePointMonitoringServiceApplicationPipeBind> -DataSourceUnattendedServiceAccount <PSCredential> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationPipeBind

Specifies the PerformancePoint Service application that is to be configured.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a PerformancePoint Service application (for example, PerfPointApp1); or an instance of a valid SPPerformancePointServiceApplication object.

DataSourceUnattendedServiceAccount

Required

System.Management.Automation.PSCredential

Specifies the user credentials (user name and password) for the data source of the unattended service account.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPPerformancePointSecureDataValues cmdlet sets global settings and properties for the unattended service account.

Input Types

Return Types

Example

--------------------EXAMPLE 1--------------------

Copy code
Set-SPPerformancePointSecureDataValues -ServiceApplication "PerformancePoint Service Application" -DataSourceUnattendedServiceAccount (get-credential)

This example shows how to set the unattended service account by prompting the user for the user name and password.

--------------------EXAMPLE 2--------------------

Copy code
Set-SPPerformancePointSecureDataValues -ServiceApplication "PerformancePoint Service Application" -DataSourceUnattendedServiceAccount (New-Object System.Management.Automation.PSCredential "domain\user", (ConvertTo-SecureString "password" -AsPlainText -Force))

This example shows how to pass the user name and password as parameters to the cmdlet.

The DataSourceUnattendedServiceAccount parameter accepts a PSCredential object. Therefore, to pass in this value as a parameter, a new PSCredential object must be created using the desired username and password values. The PSCredential object requires that the password be given as a SecureString type.


Set-SPPerformancePointServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets global runtime properties for a PerformancePoint Services application.

Set-SPPerformancePointServiceApplication [-Identity] <SPPerformancePointMonitoringServiceApplicationPipeBind> [-AnalyticQueryCellMax <Int32>] [-AnalyticQueryLoggingEnabled <$true | $false>] [-AnalyticResultCacheMinimumHitCount <Int32>] [-ApplicationCacheEnabled <$true | $false>] [-ApplicationCacheMinimumHitCount <Int32>] [-ApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-ApplicationProxyCacheEnabled <$true | $false>] [-AssignmentCollection <SPAssignmentCollection>] [-CommentsDisabled <$true | $false>] [-CommentsScorecardMax <Int32>] [-Confirm [<SwitchParameter>]] [-DatabaseFailoverServer <String>] [-DatabaseName <String>] [-DatabaseServer <String>] [-DatabaseSQLAuthenticationCredential <PSCredential>] [-DatabaseUseWindowsAuthentication <$true | $false>] [-DataSourceQueryTimeoutSeconds <Int32>] [-DecompositionTreeMaximum <Int32>] [-ElementCacheSeconds <Int32>] [-FilterRememberUserSelectionsDays <Int32>] [-FilterTreeMembersMax <Int32>] [-IndicatorImageCacheSeconds <Int32>] [-MSMQEnabled <$true | $false>] [-MSMQName <String>] [-SelectMeasureMaximum <Int32>] [-SessionHistoryHours <Int32>] [-SettingsDatabase <String>] [-ShowDetailsInitialRows <Int32>] [-ShowDetailsMaxRows <Int32>] [-ShowDetailsMaxRowsDisabled <$true | $false>] [-TrustedContentLocationsRestricted <$true | $false>] [-TrustedDataSourceLocationsRestricted <$true | $false>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.PerformancePoint.Scorecards.SPPerformancePointMonitoringServiceApplicationPipeBind

Specifies the PerformancePoint Service application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a PerformancePoint Service application (for example, PerfPointApp1); or an instance of a valid SPPerformancePointMonitoringServiceApplication object.

AnalyticQueryCellMax

Optional

System.Int32

Specifies the maximum number of returned cells in an analytic grid.

A valid integer between 1-1,000,000,000. The default value is 100,000.

AnalyticQueryLoggingEnabled

Optional

System.Nullable

Turns on verbose logging of query events.

The type must be one of the following: True, False. The default value is False.

ApplicationCacheEnabled

Optional

System.Nullable

Specifies whether rendered output cache on the application server is on (True) or off (False). The default value is True.

ApplicationCacheMinimumHitCount

Optional

System.Nullable

Specifies the minimum number of times rendered output must be requested before it is added to cache. The default value is 2.

ApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS application pool to run the Web service in for the service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

ApplicationProxyCacheEnabled

Optional

System.Nullable

Specifies rendered output cache on the web front end. The default value is True.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CommentsDisabled

Optional

System.Nullable

Specifies that users can add comments to scorecard cells.

The type must be one of the following: $True, $False. The default value is $False.

CommentsScorecardMax

Optional

System.Nullable

Specifies the maximum number of comments that can be added to a scorecard. The default value is 1000.

The type must be an integer value in the range of 1 to 1,000,000.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseFailoverServer

Optional

System.String

Specifies the name of the database server that contains the PerformancePoint Services database that must be mirrored.

This parameter was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

DatabaseName

Optional

System.String

Specifies the name of the PerformancePoint Services database that will be created when the service application is provisioned.

This parameter was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

DatabaseServer

Optional

System.String

Specifies the name of the database server where the PerformancePoint Services database will be created. This should be the same server name that is used for the SharePoint content and configuration databases.

The value may be written as SQL instance\server if it is not referring to the default instance.

This parameter was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

DatabaseSQLAuthenticationCredential

Optional

System.Management.Automation.PSCredential

Determines whether to use Windows authentication or SQL Server authentication when connecting to a PerformancePoint Services database.

This parameter was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

DataSourceQueryTimeoutSeconds

Optional

System.Nullable

Specifies the time, in seconds, before a data source query times out. The default value is 300.

The type must be an integer value in the range of 1 to 36,000.

DecompositionTreeMaximum

Optional

System.Nullable

Specifies the maximum number of items (per level) returned to the decomposition tree visualization.

A valid integer value between 1-1,000,000. The default value is 25.

ElementCacheSeconds

Optional

System.Int32

Specifies the first class object cache expiration time. The default value is 15.

FilterRememberUserSelectionsDays

Optional

System.Nullable

Specifies the number of days that user filter selections are remembered. The default value is 90.

The type must be an integer value in the range of 1 to 10,000.

FilterTreeMembersMax

Optional

System.Nullable

The maximum number of records to show in filter treeview control. The default value is 500.

An integer value in the range of 1 to 100,000

IndicatorImageCacheSeconds

Optional

System.Nullable

Specifies the time, in seconds, that key performance indicator (KPI) icons are cached. The default value is 10.

The type must be an integer value in the range of 1 to 3600.

MSMQEnabled

Optional

System.Nullable

Specifies that notifications are sent to Microsoft Message Queuing (MSMQ) on content change.

The type must be one of the following: True, False. The default value is False.

MSMQName

Optional

System.String

Specifies the name of the queue. The queue name can contain a maximum of 380 characters, and cannot contain the following characters: CR (ASCII 13), LF (ASCII 10), backslash (\), plus sign (+), comma (,), or quotation marks ("").

The type must be a valid MSMQ name; for example, MessageQueue1.

SelectMeasureMaximum

Optional

System.Nullable

Specifies the maximum number of measures to show in a dashboard Select Measure control. The default value is 1000.

The type must be an integer value in the range of 1 to 1,000,000.

SessionHistoryHours

Optional

System.Nullable

Specifies the number of hours between clearing of expired user navigation history. The default value is 2.

The type must be an integer value in the range of 1 to 48.

SettingsDatabase

Optional

System.String

Specifies the name of the PerformancePoint Service database used for that service application.

ShowDetailsInitialRows

Optional

System.Nullable

Specifies the initial number of rows to retrieve for show details. The default value is 1000.

The type must be an integer value in the range of 1 to 100,000.

ShowDetailsMaxRows

Optional

System.Nullable

Specifies the maximum number of rows to retrieve for show details.

The type must be an integer value in the range of 1 to 1,000,000.

ShowDetailsMaxRowsDisabled

Optional

System.Nullable

Turns off the ShowDetailsInitialRows setting. If set to true, Analysis Services controls limit.

The type must be one of the following: True, False. The default value is False.

TrustedContentLocationsRestricted

Optional

System.Nullable

Specifies that only specified locations are trusted. The default setting is false (trust all content locations).

The type must be one of the following: True, False. The default value is False.

TrustedDataSourceLocationsRestricted

Optional

System.Nullable

Specify to trust only specified data source locations. The default is to trust all data source locations.

The type must be one of the following: True, False. The default value is False.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPPerformancePointServiceApplication cmdlet updates global runtime properties for a PerformancePoint Service application. The changes made to properties by using this cmdlet affect all servers in the farm that run the instance of the specified PerformancePoint Service application.

Input Types

Return Types

Example

----------------EXAMPLE----------------------

Copy code
Set-SPPerformancePointServiceApplication -Identity PPSApp_01 -DataSourceQueryTimeoutSeconds 5000

This example sets the Data Source Query Timeout setting to a value of 5000. This cmdlet is equivalent to the PerformancePoint Service Settings page on the SharePoint Central Administration Web site.

See also

Get-SPPerformancePointServiceApplication
New-SPPerformancePointServiceApplication
Remove-SPPerformancePointServiceApplication


PowerPoint conversion cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you create and use PowerPoint Conversion Service applications.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
New-SPPowerPointConversionServiceApplication | Creates a PowerPoint Conversion Service application.
New-SPPowerPointConversionServiceApplicationProxy | Creates a PowerPoint Conversion Service application proxy.
Set-SPPowerPointConversionServiceApplication | Configures settings for a PowerPoint Conversion Service application.

See also

Windows PowerShell for SharePoint 2013 reference


New-SPPowerPointConversionServiceApplication
See also Example
[image]

Published: August 21, 2012

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Creates a PowerPoint Conversion Service application.

New-SPPowerPointConversionServiceApplication [-Name] <String> -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the PowerPoint Conversion Service application.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Assigns an application pool that Internet Information Services (IIS) will use for this service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPPowerPointConversionServiceApplication cmdlet to create a new instance of a PowerPoint Conversion Service application by using the Name parameter.

After the PowerPoint Conversion Service application is created, you can convert PowerPoint presentations to various formats.

Input Types

Return Types

Example

-------------EXAMPLE-----------

Copy code
New-SPPowerPointConversionServiceApplication -Name "MyWorkgroupPPTApp" -ApplicationPool "SharePoint Web Services Default"

This example creates a new instance of the PowerPoint Conversion Service application named MyWorkgroupPPTApp and assigns it to the default application pool.

See also

New-SPPowerPointConversionServiceApplicationProxy
Set-SPPowerPointConversionServiceApplication


New-SPPowerPointConversionServiceApplicationProxy
See also Example
[image]

Published: August 21, 2012

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Creates a PowerPoint Conversion Service application proxy.

New-SPPowerPointConversionServiceApplicationProxy [-Name] <String> -ServiceApplication <SPPowerPointConversionServiceApplicationPipeBind> [-AddToDefaultGroup <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the service application proxy.

ServiceApplication

Required

Microsoft.Office.Server.PowerPoint.PowerShell.SPPowerPointConversionServiceApplicationPipeBind

Specifies the name of the service application to bind.

AddToDefaultGroup

Optional

System.Management.Automation.SwitchParameter

Adds the newly created proxy to the default service application proxy group. If not specified, the proxy is not added to a group.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPPowerPointConversionServiceApplicationProxy cmdlet to create a PowerPoint Conversion Service application proxy. The service application proxy is instantiated on the front-end web server and acts as an intermediary between the client computer and the service application back end.

Input Types

Return Types

Example

-----------EXAMPLE---------

Copy code
New-SPPowerPointConversionServiceApplicationProxy -Name "MyWorkgroupPPTAppProxy" -ServiceApplication "MyWorkgroupPPTApp" -AddtoDefaultGroup

This example creates a new instance of the PowerPoint Conversion Service application proxy named MyWorkgroupPPTAppProxy, binds it to the MyWorkgroupPPTApp service application, and then adds it to the default service application proxy group

See also

New-SPPowerPointConversionServiceApplication
Set-SPPowerPointConversionServiceApplication


Set-SPPowerPointConversionServiceApplication
See also Example
[image]

Published: August 21, 2012

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Configures settings for a PowerPoint Conversion Service application.

Set-SPPowerPointConversionServiceApplication [-Identity] <SPPowerPointConversionServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CacheExpirationPeriodInSeconds <UInt32>] [-MaximumConversionsPerWorker <UInt32>] [-WorkerKeepAliveTimeoutInSeconds <UInt32>] [-WorkerProcessCount <UInt32>] [-WorkerTimeoutInSeconds <UInt32>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.PowerPoint.PowerShell.SPPowerPointConversionServiceApplicationPipeBind

Specifies the unique name of this PowerPoint Conversion Service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CacheExpirationPeriodInSeconds

Optional

System.UInt32

Specifies the maximum time, in seconds, that items remain in the back-end server cache. The default value is 600 seconds (10 minutes).

MaximumConversionsPerWorker

Optional

System.UInt32

Specifies the maximum number of presentations that a conversion worker process can convert before recycling. The default value is 5.

WorkerKeepAliveTimeoutInSeconds

Optional

System.UInt32

Specifies the maximum time, in seconds, that a conversion worker process can be unresponsive before being terminated. The default value is 120 seconds.

WorkerProcessCount

Optional

System.UInt32

Specifies the number of active instances of the conversion worker process on each back-end. This value must be less than the Windows Communication Foundation (WCF) connection limit for this computer. The default value is 3.

WorkerTimeoutInSeconds

Optional

System.UInt32

Specifies the maximum time, in seconds, that a conversion worker process is given for any single conversion. The default is 300 seconds (5 minutes).

Detailed Description

Use the Set-SPPowerPointConversionServiceApplication cmdlet to set properties and settings for an instance of a PowerPoint Conversion Service application that is in a farm.

Input Types

Return Types

Example

-----------EXAMPLE 1-------

Copy code
Set-SPPowerPointConversionServiceApplication -Identity "MyWorkgroupPPTApp" -CacheExpirationPeriodInSeconds 1200

This example establishes new operational defaults for the conversion cache expiration.

-----------EXAMPLE 2-------

Copy code
Set-SPPowerPointConversionServiceApplication -Identity "MyWorkgroupPPTApp" -DisableBinaryScan:$false

This example disables binary scanning of documents.

See also

New-SPPowerPointConversionServiceApplication
New-SPPowerPointConversionServiceApplicationProxy


Use Windows PowerShell cmdlets to administer and configure search in SharePoint 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to administrate and configure Search for SharePoint 2013.

Applies to: SharePoint Server 2013

Search is composed of several components, all of which provide specific functionality that is required for Search to operate. The following tables show the Windows PowerShell cmdlets that you can use to configure these Search components and manage Search operations for a SharePoint farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Administration

Cmdlet name | Description
Get-SPEnterpriseSearchStatus | Retrieves diagnostics information for the search components.
New-SPEnterpriseSearchAdminComponent | Creates a new admin component for the given topology and search service instance.

Crawling

Cmdlet name | Description
Get-SPEnterpriseSearchCrawlContentSource | Returns a crawl content source.
Get-SPEnterpriseSearchCrawlCustomConnector | Returns a CustomConnector object type.
Get-SPEnterpriseSearchCrawlDatabase | Returns a crawl store.
Get-SPEnterpriseSearchCrawlExtension | Returns the file types to be included in the content index.
Get-SPEnterpriseSearchCrawlMapping | Returns a crawl mapping for the search application.
Get-SPEnterpriseSearchCrawlRule | Accesses crawl rules.
New-SPEnterpriseSearchCrawlComponent | Adds a query component to a query topology.
New-SPEnterpriseSearchCrawlContentSource | Creates a new crawl content source for a shared search application.
New-SPEnterpriseSearchCrawlCustomConnector | Registers a protocol for custom crawling.
New-SPEnterpriseSearchCrawlDatabase | Creates a crawl database which can be added to a search service application.
New-SPEnterpriseSearchCrawlExtension | Adds an extension rule to a shared search application.
New-SPEnterpriseSearchCrawlMapping | Creates a crawl mapping rule for a shared search application.
New-SPEnterpriseSearchCrawlRule | Creates a new crawl rule.
Remove-SPEnterpriseSearchCrawlContentSource | Deletes a specified crawl content source from a search application.
Remove-SPEnterpriseSearchCrawlCustomConnector | Removes a CustomConnector object.
Remove-SPEnterpriseSearchCrawlDatabase | Sets properties of a crawl database for a search service application.
Remove-SPEnterpriseSearchCrawlExtension | Removes a file name extension from the list of files that can be crawled.
Remove-SPEnterpriseSearchCrawlMapping | Deletes a crawl mapping.
Remove-SPEnterpriseSearchCrawlRule | Deletes a crawl rule.
Set-SPEnterpriseSearchCrawlContentSource | Sets the properties of a crawl content source for a shared search application.
Set-SPEnterpriseSearchCrawlDatabase | Sets properties of a crawl database for a search service application.
Set-SPEnterpriseSearchCrawlRule | Sets properties for a crawl rule.
Set-SPEnterpriseSearchCrawlLogReadPermission | Grants users permission to view the crawl log information.
Get-SPEnterpriseSearchCrawlLogReadPermission | Retrieves the list of users which have permission to access the crawl log information.
Remove-SPEnterpriseSearchCrawlLogReadPermission | Removes permission to view crawl log information.
Set-SPEnterpriseSearchDCTMConnectorConfig | Configures the Microsoft SharePoint 2013 Indexing Connector for Documentum.

Service Application

Cmdlet name | Description
Get-SPEnterpriseSearchService | Returns the search service for a farm.
Get-SPEnterpriseSearchServiceApplication | Returns the search service application for a farm.
Get-SPEnterpriseSearchServiceApplicationProxy | Returns the search service application proxy.
Get-SPEnterpriseSearchServiceInstance | Returns the search service instance for a farm.
New-SPEnterpriseSearchServiceApplication | Adds a search service application to a farm.
New-SPEnterpriseSearchServiceApplicationProxy | Adds a new search application proxy to a farm..
Remove-SPEnterpriseSearchServiceApplication | Deletes a search service application.
Remove-SPEnterpriseSearchServiceApplicationProxy | Deletes a search service application proxy.
Restore-SPEnterpriseSearchServiceApplication | Restores a third-party backup of a search application.
Resume-SPEnterpriseSearchServiceApplication | Resumes a search service application that was suspended.
Set-SPEnterpriseSearchService | Sets the properties of a search service for a farm.
Set-SPEnterpriseSearchServiceApplication | Sets the properties of a search service application for a farm.
Set-SPEnterpriseSearchServiceApplicationProxy | Sets properties of a search service application proxy.
Start-SPEnterpriseSearchServiceInstance | Starts an instance of a search service.
Stop-SPEnterpriseSearchServiceInstance | Stops an instance of a search manager service.
Suspend-SPEnterpriseSearchServiceApplication | Suspends a search service application, pausing all crawls and search operations, to perform a task such as system maintenance.
Upgrade-SPEnterpriseSearchServiceApplication | Upgrades a search service application.
Backup-SPEnterpriseSearchServiceApplicationIndex | Takes a backup of the search index to a specified backup location.
Upgrade-SPEnterpriseSearchServiceApplicationSiteSettings | Upgrades search settings for a particular site collection.
Restore-SPEnterpriseSearchServiceApplicationIndex | Restores the search index from the specified backup files.
Remove-SPEnterpriseSearchServiceApplicationSiteSettings | Cleans up search settings for a particular site collection, subscription, or search application.
Get-SPEnterpriseSearchOwner | Returns the search object owner.
Suspend-SPEnterpriseSearchServiceApplication | Suspends a search service application, pausing all crawls and search operations, to perform a task such as system maintenance.
Set-SPEnterpriseSearchServiceInstance | Sets the properties of a search service instance.

Querying

Cmdlet name | Description
Get-SPEnterpriseSearchQueryAndSiteSettingsService | Returns the search manager service.
Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance | Returns the service manager service instance.
Get-SPEnterpriseSearchQueryAndSiteSettingsServiceProxy | Returns the search manager service proxy.
Get-SPEnterpriseSearchQueryAuthority | Returns an authoritative page.
Get-SPEnterpriseSearchQueryDemoted | Returns a demoted site rule.
Get-SPEnterpriseSearchQueryKeyword | Returns a keyword term.
Get-SPEnterpriseSearchQueryScope | Returns a query results scope.
Get-SPEnterpriseSearchQueryScopeRule | Returns a shared scope rule.
Get-SPEnterpriseSearchQuerySuggestionCandidates | Returns a list of queries.
Get-SPEnterpriseSearchRankingModel | Returns a ranking model.
Get-SPEnterpriseSearchSecurityTrimmer | Returns a custom security trimmer.
New-SPEnterpriseSearchQueryAuthority | Adds an authoritative page to a shared search application.
New-SPEnterpriseSearchQueryDemoted | Adds a demoted site rule to a shared search application.
New-SPEnterpriseSearchQueryKeyword | Adds a keyword term to a shared search application.
New-SPEnterpriseSearchQueryScope | Adds a query results scope to a shared search application.
New-SPEnterpriseSearchQueryScopeRule | Adds a shared scope rule to a query scope.
New-SPEnterpriseSearchRankingModel | Adds a ranking model to a shared search application.
New-SPEnterpriseSearchSecurityTrimmer | Adds a custom security trimmer to a shared search application.
Remove-SPEnterpriseSearchQueryAuthority | Deletes an authoritative page.
Remove-SPEnterpriseSearchQueryDemoted | Deletes a demoted site rule.
Remove-SPEnterpriseSearchQueryKeyword | Deletes a query keyword.
Remove-SPEnterpriseSearchQueryScope | Deletes a query scope.
Remove-SPEnterpriseSearchQueryScopeRule | Deletes query results scope rules.
Remove-SPEnterpriseSearchRankingModel | Deletes a ranking model.
Remove-SPEnterpriseSearchSecurityTrimmer | Deletes a custom security trimmer.
Set-SPEnterpriseSearchQueryAuthority | Sets the properties of an authoritative page for a shared search application.
Set-SPEnterpriseSearchQueryKeyword | Sets the properties of a keyword term for a shared search application.
Set-SPEnterpriseSearchQueryScope | Sets the properties of a query results scope for a shared search application.
Set-SPEnterpriseSearchQueryScopeRule | Sets the properties of a shared scope rule for a query scope.
Set-SPEnterpriseSearchRankingModel | Sets the properties of a ranking model for a shared search application.
Start-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance | Starts an instance of a search manager service.
Stop-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance | Stops an instance of a search manager service.
Import-SPEnterpriseSearchPopularQueries | Sets properties of a result item type.
Set-SPEnterpriseSearchResultItemType | Sets properties of a result item type.
Set-SPEnterpriseSearchQuerySpellingCorrection | Sets the operation status of the Query Spelling Corrections (QSC) component.
Remove-SPEnterpriseSearchResultItemType | Creates a new result item type.
New-SPEnterpriseSearchResultItemType | Creates a new Result Type.
Import-SPEnterpriseSearchThesaurus | Deploys the dictionary to the thesaurus component in the query processing flow.
Get-SPEnterpriseSearchResultItemType | Returns result item types.
Get-SPEnterpriseSearchQuerySpellingCorrection | Returns the object that exposes the Query Spelling Correction (QSC) configuration.

Metadata

Cmdlet name | Description
Get-SPEnterpriseSearchMetadataCategory | Returns a crawled property category.
Get-SPEnterpriseSearchMetadataCrawledProperty | Returns a crawled property.
Get-SPEnterpriseSearchMetadataManagedProperty | Returns a managed property.
Get-SPEnterpriseSearchMetadataMapping | Returns the current state of a managed property mapping.
New-SPEnterpriseSearchMetadataCategory | Adds a crawled property category to a search service application.
New-SPEnterpriseSearchMetadataCrawledProperty | Adds a crawled property to a search application crawled property category.
New-SPEnterpriseSearchMetadataManagedProperty | Adds a managed property to a shared search application.
New-SPEnterpriseSearchMetadataMapping | Adds a managed property mapping to a shared search application.
Remove-SPEnterpriseSearchMetadataCategory | Deletes a crawled property category.
Remove-SPEnterpriseSearchMetadataManagedProperty | Deletes a metadata managed property.
Remove-SPEnterpriseSearchMetadataMapping | Deletes a metadata mapping from a managed property.
Set-SPEnterpriseSearchMetadataCategory | Sets properties of a crawled property category for a shared search application.
Set-SPEnterpriseSearchMetadataCrawledProperty | Sets the properties of a metadata crawled property for a shared search application.
Set-SPEnterpriseSearchMetadataManagedProperty | Sets the properties of a metadata managed property.
Set-SPEnterpriseSearchMetadataMapping | Sets the properties of a managed property mapping for a shared search application.
Get-SPEnterpriseSearchPropertyRuleCollection | Returns the collection of rules that are applied to search results.
Get-SPEnterpriseSearchPropertyRule | Returns a property rule.

Topology

Cmdlet name | Description
Import-SPEnterpriseSearchTopology | Imports and activates a topology from an XML file.
Export-SPEnterpriseSearchTopology | Exports an existing search topology.
Set-SPEnterpriseSearchTopology | Activates a given search topology.
Remove-SPEnterpriseSearchTopology | Removes an inactive search topology from a search service application.
Remove-SPEnterpriseSearchComponent | Removes the specified search component from the given search topology.
New-SPEnterpriseSearchTopology | Creates a new search topology in the given search service application.
New-SPEnterpriseSearchQueryProcessingComponent | Creates a new query processing component for the given topology and search service instance.
New-SPEnterpriseSearchIndexComponent | Creates a new index component for the given topology and search service instance.
New-SPEnterpriseSearchContentProcessingComponent | Creates a new content processing component for the given topology and search service instance.
Get-SPEnterpriseSearchTopology | Retrieves one or all search topologies that belong to a given search service application.

General

Cmdlet name | Description
Get-SPEnterpriseSearchLanguageResourcePhrase | Returns a language resource phrase.
Get-SPEnterpriseSearchSiteHitRule | Returns the shared site hit rule.
New-SPEnterpriseSearchLanguageResourcePhrase | Adds a language resource phrase to a shared search application.
New-SPEnterpriseSearchSiteHitRule | Adds a new site hit rule for a search application.
Remove-SPEnterpriseSearchLanguageResourcePhrase | Deletes a language resource phrase from a shared search application.
Remove-SPEnterpriseSearchSiteHitRule | Deletes a site hit rule.
Get-SPEnterpriseSearchVssDataPath | Retrieves the index paths for all active search index components on the current server.
Get-SPEnterpriseSearchContentEnrichmentConfiguration | Returns the content enrichment configuration for the specified search service application.
Set-SPEnterpriseSearchPrimaryHostController | Sets the primary search host controller for the farm.
Set-SPEnterpriseSearchLinguisticComponentsStatus | Sets the operation status of the linguistic query and document processing components.
Set-SPEnterpriseSearchContentEnrichmentConfiguration | Stores the specified content enrichment configuration to the search service application.
Remove-SPEnterpriseSearchContentEnrichmentConfiguration | Removes the current content enrichment configuration from the search service application.
New-SPEnterpriseSearchContentEnrichmentConfiguration | Creates a new ContentEnrichmentConfiguration object.
Get-SPEnterpriseSearchLinguisticComponentsStatus | Returns the status of the linguistic query and document processing components.
Get-SPEnterpriseSearchHostController | Lists the specified or all search host controllers in the farm.
Set-SPEnterpriseSearchLinksDatabase | Sets properties of a links database for a search service application.
Repartition-SPEnterpriseSearchLinksDatabases | Obsolete. For replacement, see Move-SPEnterpriseSearchLinksDatabases
Move-SPEnterpriseSearchLinksDatabases | Repartitions data across links databases.
Remove-SPEnterpriseSearchTenantSchema | Removes a defined search schema.
Remove-SPEnterpriseSearchTenantConfiguration | Removes all tenant specific search settings.
Remove-SPEnterpriseSearchLinksDatabase | Deletes a links database.
Remove-SPEnterpriseSearchFileFormat | Remove a previously registered file format from the system.
New-SPEnterpriseSearchLinksDatabase | Creates a new links database for a search service application.
New-SPEnterpriseSearchFileFormat | Adds a new file format in the parsing system.
New-SPEnterpriseSearchAnalyticsProcessingComponent | Creates a new analytics processing component for the given topology and search service instance.
Import-SPEnterpriseSearchCustomExtractionDictionary | Imports a custom extraction dictionary.
Get-SPEnterpriseSearchLinksDatabase | Retrieves a reference to a links database.
Get-SPEnterpriseSearchFileFormat | Retrieves all parseable file formats.
Set-SPEnterpriseSearchFileFormatState | Enables or disables parsing of a given file format.
Get-SPEnterpriseSearchComponent | Retrieves one or all search components in a given search topology.
Get-SPEnterpriseSearchServiceApplicationBackupStore | Retrieves information about the search service application backup files.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Get-SPEnterpriseSearchCrawlContentSource
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a crawl content source.

Get-SPEnterpriseSearchCrawlContentSource [[-Identity] <ContentSourcePipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ContentSourcePipeBind

Specifies the content source to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a ContentSource object (for example, ContentSource1); or an instance of a valid ContentSource object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the content source.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchCrawlContentSource cmdlet reads the content source when the rules of content source are created, updated, or deleted, or reads a CrawlContentSource object when the search functionality is initially configured and after any new content source is added.

If the Identity parameter is not specified, this cmdlet returns the content source collection for the specified search application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication " SearchApp1" $contentsource = Get-SPEnterpriseSearchCrawlContentSource -SearchApplication $searchapp -Identity "Local SharePoint Sites" $contentsource.StartFullCrawl()

This example retrieves the default content source for the search service application, SearchApp1, and starts a full crawl on the content source.

See also

New-SPEnterpriseSearchCrawlContentSource
Set-SPEnterpriseSearchCrawlContentSource
Remove-SPEnterpriseSearchCrawlContentSource


Get-SPEnterpriseSearchCrawlCustomConnector
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a CustomConnector object type.

Get-SPEnterpriseSearchCrawlCustomConnector -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Protocol <String>]

Parameters

Parameter Required Type Description

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the Search application with which the CustomConnector objects are associated.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Protocol

Optional

System.String

Specifies the string version of the protocol for which to return the CustomConnector object. For example, "dctm://"

Detailed Description

The Identity parameter displays a custom connector for a specified Web application. If no parameters are specified, all the objects of the CustomConnector object type are returned.

Input Types

Return Types

Example

--------------------EXAMPLE----------------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication MySearchServiceApp$crawlConn = Get-SPEnterpriseSearchCrawlCustomConnector -SearchApplication$searchApp -Protocol "http://"

This example obtains a reference to all custom crawl connectors for the http:// protocol for a search service application named MySearchServiceApp.

See also

New-SPEnterpriseSearchCrawlCustomConnector
Remove-SPEnterpriseSearchCrawlCustomConnector
Get-SPEnterpriseSearchServiceApplication


Get-SPEnterpriseSearchCrawlDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a crawl store.

Get-SPEnterpriseSearchCrawlDatabase [[-Identity] <CrawlStorePipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.CrawlStorePipeBind

Specifies the crawl database to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a CrawlStore object, in the form CrawlStore1; or an instance of a valid CrawlStore object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl database.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchCrawlDatabase cmdlet returns a CrawlStore object for use during configuration and when a crawl database for a search service application is modified or deleted. A crawl database stores crawl history data for a search service application.

If the Identity parameter is not specified, this cmdlet returns the crawl database collection for the specified search application.

Input Types

Return Types

Example

-------------------EXAMPLE-------------------

Copy code
$crawlDatabase = Get-SPEnterpriseSearchCrawlDatabase -SearchApplicationMySearchServiceApp -Identity CrawlDB_1

This example gets a reference to the crawl database CrawlDB_1 from the search service application named MySearchServiceApp.

See also

New-SPEnterpriseSearchCrawlDatabase
Set-SPEnterpriseSearchCrawlDatabase
Remove-SPEnterpriseSearchCrawlDatabase


Get-SPEnterpriseSearchCrawlExtension
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the file types to be included in the content index.

Get-SPEnterpriseSearchCrawlExtension [[-Identity] <ExtensionPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ExtensionPipeBind

Specifies the file name extension to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid file name extension (for example, .xml); or an instance of a valid CrawlExtension object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the extension collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchCrawlExtension cmdlet returns any or all file extensions in the index for a search application.

Run this cmdlet at the initial search configuration, and after any new IFilter interface is added to read the rule when you create, update, or delete the extension rule. If the Identity parameter is not specified, this cmdlet returns the crawl extension collection for the specified search application.

Input Types

Return Types

Example

Add code example.

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "Sample Search Service Application"$searchapp | Get-SPEnterpriseSearchCrawlExtension "pdf"

This example checks whether the pdf file type is included in the file types to be included in the content index.

See also

New-SPEnterpriseSearchCrawlExtension
Remove-SPEnterpriseSearchCrawlExtension


Get-SPEnterpriseSearchCrawlMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a crawl mapping for the search application.

Get-SPEnterpriseSearchCrawlMapping [[-Identity] <CrawlMappingPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.CrawlMappingPipeBind

Specifies the crawl mapping to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://crawlmap1; or an instance of a valid CrawlMapping object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl mapping collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchCrawlMapping cmdlet reads a CrawlMapping object when one of the crawl mapping rules is created, updated, or deleted. Run this cmdlet when the search is initially configured, and when access is changed through a different mechanism to create the crawl mapping rule; for example, when a rule is changed to use file:\\ rather than http://.

If the Identity parameter is not specified, this cmdlet returns the crawl mapping collection for the specified search application.

Input Types

Return Types

Example

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1"$searchapp | Get-SPEnterpriseSearchCrawlMapping

This example returns the crawl mappings for the search application SearchApp1.

See also

New-SPEnterpriseSearchCrawlMapping
Remove-SPEnterpriseSearchCrawlMapping


Get-SPEnterpriseSearchCrawlRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Accesses crawl rules.

Get-SPEnterpriseSearchCrawlRule [[-Identity] <CrawlRulePipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.CrawlRulePipeBind

Specifies the search crawl rule path. A valid URL, such as "http://server_name", or an instance of a valid CrawlRule object

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl rule. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPEnterpriseSearchCrawlRule cmdlet for a search administrator to run this procedure to retrieve the crawl rule when the crawl rule is updated or deleted.

Input Types

Return Types

Example

---------------EXAMPLE 1-----------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication ExampleSearchServiceApplication $crawlRule = Get-SPEnterpriseSearchCrawlRule -SearchApplication  $searchApp -Identity http://example$crawlRule | Set-SPEnterpriseSearchCrawlRule -Type InclusionRule

This example uses the Get-SPEnterpriseSearchCrawlRule cmdlet to retrieve a crawl rule in order to change its type from ExclusionRule to InclusionRule.

---------------EXAMPLE 2---------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication MySearchServiceApp Get-SPEnterpriseSearchCrawlRule -SearchApplication $searchApp | where {$_.Path -like "*example*"}

This example returns a list of crawl rules with paths that contain the word example from the search service application named, MySearchServiceApp.

See also

New-SPEnterpriseSearchCrawlRule
Set-SPEnterpriseSearchCrawlRule
Remove-SPEnterpriseSearchCrawlRule


New-SPEnterpriseSearchCrawlComponent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Creates a new crawl component for the given topology and search service instance.

New-SPEnterpriseSearchCrawlComponent -SearchServiceInstance <SearchServiceInstancePipeBind> -SearchTopology <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SearchServiceInstance

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance that will host the new crawl component. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a search topology server, or an instance of a valid SearchServiceInstance object.

SearchTopology

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology where the new crawl component should be added.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the search topology.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Creates a new crawl component and adds it to an inactive search topology in a specific search service instance. The change is effectuated when the search topology is enabled.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchCrawlComponent -SearchTopology 06e6651d-ecdd-4105-bb65-6a83b6155525 -SearchServiceInstance 56e6651d-ecdd-4105-bb65-6a83b6155525 -SearchApplication $ssa

This example adds a new crawl component to the search topology with the identity 06e6651d-ecdd-4105-bb65-6a83b6155525 in the search service instance with identity 56e6651d-ecdd-4105-bb65-6a83b6155525 in the default search service application referenced by $ssa.


New-SPEnterpriseSearchCrawlContentSource
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Creates a content source for a Search service application.

New-SPEnterpriseSearchCrawlContentSource [-Name] <String> -SearchApplication <SearchServiceApplicationPipeBind> -Type <Business | O12Business | CustomRepository | Custom | Exchange | File | LotusNotes | SharePoint | Web> [-AssignmentCollection <SPAssignmentCollection>] [-BDCApplicationProxyGroup <SPServiceApplicationProxyGroupPipeBind>] [-Confirm [<SwitchParameter>]] [-CrawlPriority <Nullable>] [-CustomProtocol <String>] [-LOBSystemSet <String[]>] [-MaxPageEnumerationDepth <Nullable>] [-MaxSiteEnumerationDepth <Nullable>] [-SharePointCrawlBehavior <Nullable>] [-StartAddresses <String>] [-Tag <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the content source to create.

The type must be a valid name of a ContentSource object (for example, ContentSource1).

SearchApplication

Yes

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the content source.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid Search service application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Type

Required

Microsoft.Office.Server.Search.Administration.ContentSourceType

Specifies the name of the content source type. The value Business is for the Business Data Connectivity metadata store. The value Exchange is for Microsoft Exchange public folders. The value Custom is for a custom content source type.

The type must be the valid name of a content source type; for example, custom.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BDCApplicationProxyGroup

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies the proxy to use for a business type content source. This proxy group must contain a default Business Data Connectivity Metadata Store proxy.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CrawlPriority

Optional

System.Nullable

Specifies the priority of this content source.

The value must be one of the following integers: 1= Normal, 2=High.

CustomProtocol

Optional

System.String

Specifies the custom protocol, handled by the custom connector, to use for this content source.

LOBSystemSet

Optional

System.String[]

Specifies a comma-separated list of Business Data Connectivity metadata store system names and system instance names for a business type content source.

MaxPageEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of page hops that the crawler can make from the start address to a content item.

MaxSiteEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of site hops that the crawler can take from the start address to a content item.

SharePointCrawlBehavior

Optional

System.Nullable

Specifies crawl behavior for a sharepoint type content source. The behavior can be either:

CrawlSites to crawl only particular site collections.

CrawlVirtualServers to crawl the entire server and all site collections on the server.

StartAddresses

Optional

System.String

Specifies the comma-separated list of URLs at which to start a crawl for this content source.

The type must be a valid URL, in the form http://server_name.

Tag

Optional

System.String

Specifies the URL for the page to modify the settings for a custom content source. The string that specifies the URL can contain a maximum of 1,024 characters.

The type must be a valid URL, in the form http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchCrawlContentSource cmdlet creates a new content source.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1"New-SPEnterpriseSearchCrawlContentSource -SearchApplication $searchapp -Type file -name somename -StartAddresses file://someserver/public

This example creates a new content source of type file to crawl a file system.


New-SPEnterpriseSearchCrawlCustomConnector
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Registers a protocol for custom crawling.

New-SPEnterpriseSearchCrawlCustomConnector -ModelFilePath <String> -Protocol <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ModelFilePath

Required

System.String

Specifies the path to a model file.

Protocol

Required

System.String

Specifies the string version of the protocol; for example, dctm://.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that is associated with the protocol.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Name

Optional

System.String

Specifies the display name of the custom connector that appears on the SharePoint Central Administration Web site.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchCrawlCustomConnector cmdlet registers, for a search system, the protocol that is used to crawl the custom repository.

If the Name parameter is not provided, in the administration application user interface (UI) the name protocol identifies the protocol specified.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication mySearchServiceAppNew-SPEnterpriseSearchCrawlCustomConnector -SearchApplication $searchApp -ModelFilePath \\models\myFileTypeModel.mft -Protocol "mftml://"

This example creates a custom connector for a file type whose model is located at \\models\myFileTypeModel.mft and has the protocol name mftml://.


New-SPEnterpriseSearchCrawlDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Creates a crawl database which can be added to a search service application.

New-SPEnterpriseSearchCrawlDatabase -DatabaseName <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

DatabaseName

Required

System.String

Specifies the name of the database to create for the crawl database.

The type must be a valid name of a SQL Server database; for example, CrawlStoreDB1.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl database.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabasePassword

Optional

System.String

Specifies the name of the password for the Microsoft SQL Server database server.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the database specified in DatabaseName.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

DatabaseUsername

Optional

System.String

Specifies the account name specified in the Database Server parameter.

FailoverDatabaseServer

Optional

System.String

Server that is used for failover when SQL Server mirroring is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchCrawlDatabase cmdlet is used during initial configuration and farm scale-out to create a new crawl database, which can be added to a search service application. A crawl database stores crawl history for a search application.

Input Types

Return Types

Exceptions

Exceptions | Description

Example

------------------EXAMPLE------------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication mySearchServiceAppNew-SPEnterpriseSearchCrawlDatabase -SearchApplication $searchApp -DatabaseName newCrawlDB

This example creates a new crawl database named newCrawlDB for the mySearchServiceApp search service application.

See also

Set-SPEnterpriseSearchCrawlDatabase
Get-SPEnterpriseSearchCrawlDatabase
Remove-SPEnterpriseSearchCrawlDatabase


New-SPEnterpriseSearchCrawlExtension
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds an extension rule to a Search service application.

New-SPEnterpriseSearchCrawlExtension [[-Name] <String>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Optional

System.String

Specifies the new file name extension.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the extension collection.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid search application name (for example, SearchApp1), or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchCrawlExtension cmdlet adds a file name extension to the list of file types that you want to include in the index. After a new IFilter is registered, run this cmdlet so that the new file type will be crawled. If a file type is added without registering an associated IFilter, only the file properties will be crawled and included in the index. After you run this cmdlet, you must run a full crawl of all content sources that might contain this file type to guarantee that files of this type are in the index.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1"$searchapp | New-SPEnterpriseSearchCrawlExtension "pdf"

This example adds the PDF file type to the list of file name extensions to include in the index.

See also

Get-SPEnterpriseSearchCrawlExtension
Remove-SPEnterpriseSearchCrawlExtension


New-SPEnterpriseSearchCrawlMapping
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Creates a crawl mapping rule for a shared search application.

New-SPEnterpriseSearchCrawlMapping [-Url] <String> -SearchApplication <SearchServiceApplicationPipeBind> -Target <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Url

Required

System.String

Specifies the source URI for the crawl mapping.

The type must be a valid URL, in the form http://server_name.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl mapping collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Target

Required

System.String

Specifies the target URI for the crawl mapping to get.

The type must be a valid URI; for example, file:\\ server_name\sitedocs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchCrawlMapping cmdlet is run when the search functionality is initially configured, and when access is changed through a different mechanism to create the crawl mapping rule; for example, when a rule is changed to use file:\\ rather than http://.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1"New-SPEnterpriseSearchCrawlMapping -SearchApplication $searchapp -Url "file://location1" -Target "http://location2"

This example will change the query results link from the file share where the item was crawled to the Web site location from which the item can be browsed.


New-SPEnterpriseSearchCrawlRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Creates a new crawl rule.

New-SPEnterpriseSearchCrawlRule [-Path] <String> -SearchApplication <SearchServiceApplicationPipeBind> -Type <InclusionRule | ExclusionRule> [-AccountName <String>] [-AccountPassword <SecureString>] [-AssignmentCollection <SPAssignmentCollection>] [-AuthenticationType <Nullable>] [-Confirm [<SwitchParameter>]] [-ContentClass <String>] [-CrawlAsHttp <Nullable>] [-FollowComplexUrls <Nullable>] [-IsAdvancedRegularExpression <Nullable>] [-PluggableSecurityTrimmerId <Nullable>] [-Priority <Nullable>] [-SuppressIndexing <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Path

Required

Microsoft.Office.Server.Search.Cmdlet.CrawlRulePipeBind

Specifies a unique path to which a crawl rule applies.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the Search application that is associated with the crawl rule to be modified.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Type

Required

Microsoft.Office.Server.Search.Administration.CrawlRuleType

Specifies the type of crawl rule. A value of zero (0) includes the rule, a value of 1 excludes the rule.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuthenticationType

Optional

System.Nullable

Specifies one of the following authentication types to access matching URLs:

BasicAccountRuleAccess — Specifies the account name and password that are required for this authentication type.

CertificateRuleAccess — Specifies the valid client certificate name that is required for this authentication type.

NTLMAccountRuleAccess — Specifies the account name for integrated authentication.

FormRuleAccess — Specifies a valid URL for HTTP POST or HTTP GET, public and private parameters, and a list of error pages that are used by this authentication type.

CookieRuleAccess — Specifies private parameters and a list of error pages that are used by this authentication type.

AnonymousAccess— Specifies that the matching URLs have to be accessed anonymously.

AccountName

Optional

System.String

Specifies the account to use when applying the crawl rule.

AccountPassword

Optional

System.Security.SecureString

Specifies the account to use when applying the crawl rule.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentClass

Optional

System.String

Specifies the string that is sent to the protocol handler for any content that matches the crawl rule.

CrawlAsHttp

Optional

System.Nullable

Specifies whether the crawler should crawl content from a hierarchical content source as HTTP content.

FollowComplexUrls

Optional

System.Nullable

Specifies whether the index engine should crawl content with URLs that contain a question mark (?).

IsAdvancedRegularExpression

Optional

System.Nullable

Specifies whether the rule has a full regular expression syntax.

The default value is False.

PluggableSecurityTrimmerId

Optional

System.Nullable

Specifies the ID of the custom pluggable security trimmer to use, if registered.

Priority

Optional

System.Nullable

Defines where in the list of crawl rules this crawl rule should be applied.

The priority value cannot be less than 0 or greater than or equal to the number of crawl rules for the search application.

SuppressIndexing

Optional

System.Nullable

Specifies whether the crawler should exclude the content of items that this rule applies to from the content index.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchCrawlRule cmdlet creates special rules for crawling items that are contained in the specified path.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
New-SPEnterpriseSearchCrawlRule -SearchApplication mySearchServiceApp -Identity http://ExampleSharePointSite -CrawlAsHttp 1 -Type InclusionRule

This example creates an inclusion type crawl rule for the site at http://ExampleSharePointSite. The rule specifies that the site be crawled as an HTTP site.

See also

Set-SPEnterpriseSearchCrawlRule
Get-SPEnterpriseSearchCrawlRule
Remove-SPEnterpriseSearchCrawlRule


Remove-SPEnterpriseSearchCrawlContentSource
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a specified crawl content source from a search application.

Remove-SPEnterpriseSearchCrawlContentSource [-Identity] <ContentSourcePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ContentSourcePipeBind

The crawl content source to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a ContentSource object (for example, ContentSource1); or an instance of a valid ContentSource object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl content source.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchCrawlContentSource cmdlet deletes a specified crawl content source from a service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1"
Copy code
Remove-SPEnterpriseSearchCrawlContentSource -SearchApplication $searchapp -Identity <name>

This example retrieves the search service application and deletes a content source.

See also

Get-SPEnterpriseSearchCrawlContentSource
New-SPEnterpriseSearchCrawlContentSource
Set-SPEnterpriseSearchCrawlContentSource


Remove-SPEnterpriseSearchCrawlCustomConnector
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Removes a CustomConnector object.

Remove-SPEnterpriseSearchCrawlCustomConnector -Identity <SPCustomConnectorPipeBind> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SPCustomConnectorPipeBind

Specifies the CustomConnector object to remove. The Identity parameter must be an instance of a valid CustomConnector object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Get-SPEnterpriseSearchCrawlCustomConnector selects the custom connector or connectors, and then pipes them to the Remove-SPEnterpriseSearchCrawlCustomConnector cmdlet.

Input Types

Return Types

Example

--------------------EXAMPLE------------------

Copy code
Get-SPEnterpriseSearchCrawlCustomConnector -SearchApplication MySearchServiceApp" -Identity "dctm://" | Remove-SPEnterpriseSearchCrawlCustomConnector

This example removes a custom connector for the dctm:// protocol from the MySearchServiceApp search service application.

See also

New-SPEnterpriseSearchCrawlCustomConnector
Get-SPEnterpriseSearchCrawlCustomConnector


Remove-SPEnterpriseSearchCrawlDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a crawl database.

Remove-SPEnterpriseSearchCrawlDatabase [-Identity] <CrawlStorePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.CrawlStorePipeBind

Specifies the crawl database to delete.

A valid crawl database name, in the form CrawlStore1; or a valid GUID, such as 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid CrawlStore object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl database collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchCrawlDatabase cmdlet deletes a specified crawl database from a search service application. A crawl database stores crawl history for a search service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Remove-SPEnterpriseSearchCrawlDatabase -Identity CrawlDB-0-SearchApplication mySearchServiceApp

This example removes the CrawlDB-0 crawl database from the mySearchServiceApp search service application.

See also

Get-SPEnterpriseSearchCrawlDatabase
New-SPEnterpriseSearchCrawlDatabase
Set-SPEnterpriseSearchCrawlDatabase


Remove-SPEnterpriseSearchCrawlExtension
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Removes a file name extension from the list of files that can be crawled.

Remove-SPEnterpriseSearchCrawlExtension [-Identity] <ExtensionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ExtensionPipeBind

The file name extension to remove.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid file name extension (for example, .xml); or an instance of a valid CrawlExtension object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the extension collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchCrawlExtension cmdlet prevents files with this extension from being crawled.

Input Types

Return Types

Example

Add code example.

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1"$searchapp | Get-SPEnterpriseSearchCrawlExtension "pdf" | Remove-SPEnterpriseSearchCrawlExtension

This example removes the PDF IFilter and removes the pdf file extension from the list of file types to include in the content index.

See also

Get-SPEnterpriseSearchCrawlExtension
New-SPEnterpriseSearchCrawlExtension
Remove-SPEnterpriseSearchCrawlExtension


Remove-SPEnterpriseSearchCrawlMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a crawl mapping.

Remove-SPEnterpriseSearchCrawlMapping [-Identity] <CrawlMappingPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.CrawlMappingPipeBind

The crawl mapping to delete.

A valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid CrawlMapping object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl mapping collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchCrawlMapping cmdlet deletes a crawl mapping from the crawl mapping collection.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "Sample Search Service Application"$mappingtodelete = Get-SPEnterpriseSearchCrawlContentSource -Identity "somemapping"$mappingtodelete | Remove-SPEnterpriseSearchCrawlMapping

This example removes a crawl mapping from a search application.

See also

Get-SPEnterpriseSearchCrawlMapping
New-SPEnterpriseSearchCrawlMapping


Remove-SPEnterpriseSearchCrawlRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a crawl rule.

Remove-SPEnterpriseSearchCrawlRule [-Identity] <CrawlRulePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.CrawlRulePipeBind

The crawl rule to delete.

A valid crawl rule URL, such as http://server_name, or an instance of a valid CrawlRule object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

The search application that contains the crawl rule collection.

A valid search application name, such as SearchApp1, or a valid GUID, such as 12345678-90ab-cdef-1234-567890bcdefgh, or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchCrawlRule cmdlet deletes a crawl rule that is used to crawl content for a content source.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication mySearchServiceAppRemove-SPEnterpriseSearchCrawlRule -Identity http://mySPSite -SearchApplication $searchApp

This example removes a crawl rule pertaining to the path http://mySPSite from the mySearchServiceApp search service application.

See also

Get-SPEnterpriseSearchCrawlRule
New-SPEnterpriseSearchCrawlRule
Set-SPEnterpriseSearchCrawlRule


Set-SPEnterpriseSearchCrawlContentSource
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets the properties of a crawl content source for a Search service application.

Set-SPEnterpriseSearchCrawlContentSource [-Identity] <ContentSourcePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-BDCApplicationProxyGroup <SPServiceApplicationProxyGroupPipeBind>] [-Confirm [<SwitchParameter>]] [-CrawlPriority <Nullable>] [-CustomProtocol <String>] [-EnableContinuousCrawls <Nullable>] [-LOBSystemSet <String[]>] [-MaxPageEnumerationDepth <Nullable>] [-MaxSiteEnumerationDepth <Nullable>] [-Name <String>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-StartAddresses <String>] [-Tag <String>] [-WhatIf [<SwitchParameter>]]
Set-SPEnterpriseSearchCrawlContentSource [-Identity] <ContentSourcePipeBind> -ScheduleType <Nullable> [-AssignmentCollection <SPAssignmentCollection>] [-BDCApplicationProxyGroup <SPServiceApplicationProxyGroupPipeBind>] [-Confirm [<SwitchParameter>]] [-CrawlPriority <Nullable>] [-CrawlScheduleRepeatDuration <Nullable>] [-CrawlScheduleRepeatInterval <Nullable>] [-CrawlScheduleRunEveryInterval <Nullable>] [-CrawlScheduleStartDateTime <Nullable>] [-CustomProtocol <String>] [-DailyCrawlSchedule <SwitchParameter>] [-EnableContinuousCrawls <Nullable>] [-LOBSystemSet <String[]>] [-MaxPageEnumerationDepth <Nullable>] [-MaxSiteEnumerationDepth <Nullable>] [-Name <String>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-StartAddresses <String>] [-Tag <String>] [-WhatIf [<SwitchParameter>]]
Set-SPEnterpriseSearchCrawlContentSource [-Identity] <ContentSourcePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-BDCApplicationProxyGroup <SPServiceApplicationProxyGroupPipeBind>] [-Confirm [<SwitchParameter>]] [-CrawlPriority <Nullable>] [-CustomProtocol <String>] [-EnableContinuousCrawls <Nullable>] [-LOBSystemSet <String[]>] [-MaxPageEnumerationDepth <Nullable>] [-MaxSiteEnumerationDepth <Nullable>] [-Name <String>] [-RemoveCrawlSchedule <SwitchParameter>] [-ScheduleType <Nullable>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-StartAddresses <String>] [-Tag <String>] [-WhatIf [<SwitchParameter>]]
Set-SPEnterpriseSearchCrawlContentSource [-Identity] <ContentSourcePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-BDCApplicationProxyGroup <SPServiceApplicationProxyGroupPipeBind>] [-Confirm [<SwitchParameter>]] [-CrawlPriority <Nullable>] [-CrawlScheduleDaysOfMonth <Nullable>] [-CrawlScheduleMonthsOfYear <Nullable>] [-CrawlScheduleRepeatDuration <Nullable>] [-CrawlScheduleRepeatInterval <Nullable>] [-CrawlScheduleStartDateTime <Nullable>] [-CustomProtocol <String>] [-EnableContinuousCrawls <Nullable>] [-LOBSystemSet <String[]>] [-MaxPageEnumerationDepth <Nullable>] [-MaxSiteEnumerationDepth <Nullable>] [-MonthlyCrawlSchedule <SwitchParameter>] [-Name <String>] [-ScheduleType <Nullable>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-StartAddresses <String>] [-Tag <String>] [-WhatIf [<SwitchParameter>]]
Set-SPEnterpriseSearchCrawlContentSource [-Identity] <ContentSourcePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-BDCApplicationProxyGroup <SPServiceApplicationProxyGroupPipeBind>] [-Confirm [<SwitchParameter>]] [-CrawlPriority <Nullable>] [-CrawlScheduleDaysOfWeek <Nullable>] [-CrawlScheduleRepeatDuration <Nullable>] [-CrawlScheduleRepeatInterval <Nullable>] [-CrawlScheduleRunEveryInterval <Nullable>] [-CrawlScheduleStartDateTime <Nullable>] [-CustomProtocol <String>] [-EnableContinuousCrawls <Nullable>] [-LOBSystemSet <String[]>] [-MaxPageEnumerationDepth <Nullable>] [-MaxSiteEnumerationDepth <Nullable>] [-Name <String>] [-ScheduleType <Nullable>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-StartAddresses <String>] [-Tag <String>] [-WeeklyCrawlSchedule <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ContentSourcePipeBind

Specifies the crawl content source to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a ContentSource object (for example, ContentSource1); or an instance of a valid ContentSource object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BDCApplicationProxyGroup

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies the proxy to use for a business type content source. This proxy group must contain a default Business Data Connectivity Metadata Store proxy.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CrawlPriority

Optional

System.Nullable

Specifies the priority of this content source.

The type must be one of the following integers: 1= Normal, 2=High.

CustomProtocol

Optional

System.String

Specifies the custom protocol, handled by the custom connector, to use for this content source.

EnableContinuousCrawls

Optional

System.Nullable

Specifies the value of the EnableContinuousCrawls parameter: True or False.

LOBSystemSet

Optional

System.String[]

Specifies a comma-separated list of Business Data Connectivity Metadata Store system names and system instance names for a business type content source.

MaxPageEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of page hops that the crawler can make from the start address to a content item.

MaxSiteEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of site hops that the crawler can take from the start address to a content item.

Name

Optional

System.String

Specifies the new display name for the content source.

The type must be a valid name of a content source; for example, ContentSource1.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the content source.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

StartAddresses

Optional

System.String

Specifies the comma-separated list of URLs at which to start a crawl for this content source.

The type must be a valid URL, in the form http://server_name.

Tag

Optional

System.String

Specifies the URL for the page to modify the settings for a custom content source. The string that specifies the URL can contain a maximum of 1,024 characters.

The type must be a valid URL, in the form http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ContentSourcePipeBind

Specifies the crawl content source to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a ContentSource object (for example, ContentSource1); or an instance of a valid ContentSource object.

ScheduleType

Required

System.Nullable

Specifies the type of crawl schedule.

The type must be one of the following values: Full or Incremental.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BDCApplicationProxyGroup

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies the proxy to use for a business type content source. This proxy group must contain a default Business Data Connectivity Metadata Store proxy.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CrawlPriority

Optional

System.Nullable

Specifies the priority of this content source.

The type must be one of the following integers: 1= Normal, 2=High.

CrawlScheduleRepeatDuration

Optional

System.Nullable

Specifies the number of times to repeat the crawl schedule.

CrawlScheduleRepeatInterval

Optional

System.Nullable

Specifies the number of minutes between each repeat interval for the crawl schedule

CrawlScheduleRunEveryInterval

Optional

System.Nullable

Specifies the interval between crawls.

When the DailyCrawlSchedule parameter is set, specifies the number of days between crawls.

When the WeeklyCrawlSchedule parameter is set, specifies the number of weeks between crawls.

CrawlScheduleStartDateTime

Optional

System.Nullable

Specifies the initial date of the crawl. The default value is midnight on the current day.

CustomProtocol

Optional

System.String

Specifies the custom protocol, handled by the custom connector, to use for this content source.

DailyCrawlSchedule

Optional

System.Management.Automation.SwitchParameter

Base schedule on days between crawls.

EnableContinuousCrawls

Optional

System.Nullable

Specifies the value of the EnableContinuousCrawls parameter: True or False.

LOBSystemSet

Optional

System.String[]

Specifies a comma-separated list of Business Data Connectivity Metadata Store system names and system instance names for a business type content source.

MaxPageEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of page hops that the crawler can make from the start address to a content item.

MaxSiteEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of site hops that the crawler can take from the start address to a content item.

Name

Optional

System.String

Specifies the new display name for the content source.

The type must be a valid name of a content source; for example, ContentSource1.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the content source.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

StartAddresses

Optional

System.String

Specifies the comma-separated list of URLs at which to start a crawl for this content source.

The type must be a valid URL, in the form http://server_name.

Tag

Optional

System.String

Specifies the URL for the page to modify the settings for a custom content source. The string that specifies the URL can contain a maximum of 1,024 characters.

The type must be a valid URL, in the form http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ContentSourcePipeBind

Specifies the crawl content source to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a ContentSource object (for example, ContentSource1); or an instance of a valid ContentSource object.

ScheduleType

Required

System.Nullable

Specifies the type of crawl schedule.

The type must be one of the following values: Full or Incremental.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BDCApplicationProxyGroup

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies the proxy to use for a business type content source. This proxy group must contain a default Business Data Connectivity Metadata Store proxy.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CrawlPriority

Optional

System.Nullable

Specifies the priority of this content source.

The type must be one of the following integers: 1= Normal, 2=High.

CustomProtocol

Optional

System.String

Specifies the custom protocol, handled by the custom connector, to use for this content source.

EnableContinuousCrawls

Optional

System.Nullable

Specifies the value of the EnableContinuousCrawls parameter: True or False.

LOBSystemSet

Optional

System.String[]

Specifies a comma-separated list of Business Data Connectivity Metadata Store system names and system instance names for a business type content source.

MaxPageEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of page hops that the crawler can make from the start address to a content item.

MaxSiteEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of site hops that the crawler can take from the start address to a content item.

Name

Optional

System.String

Specifies the new display name for the content source.

The type must be a valid name of a content source; for example, ContentSource1.

RemoveCrawlSchedule

Optional

System.Management.Automation.SwitchParameter

Deletes the specified crawl.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the content source.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

StartAddresses

Optional

System.String

Specifies the comma-separated list of URLs at which to start a crawl for this content source.

The type must be a valid URL, in the form http://server_name.

Tag

Optional

System.String

Specifies the URL for the page to modify the settings for a custom content source. The string that specifies the URL can contain a maximum of 1,024 characters.

The type must be a valid URL, in the form http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

4

Parameter

Required

Type

Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ContentSourcePipeBind

Specifies the crawl content source to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a ContentSource object (for example, ContentSource1); or an instance of a valid ContentSource object.

ScheduleType

Required

System.Nullable

Specifies the type of crawl schedule.

The type must be one of the following values: Full or Incremental.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BDCApplicationProxyGroup

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies the proxy to use for a business type content source. This proxy group must contain a default Business Data Connectivity Metadata Store proxy.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CrawlPriority

Optional

System.Nullable

Specifies the priority of this content source.

The type must be one of the following integers: 1= Normal, 2=High.

CrawlScheduleDaysOfMonth

Optional

System.Nullable

Specifies the days on which to crawl when the MonthlyCrawlSchedule parameter is set.

CrawlScheduleMonthsOfYear

Optional

System.Nullable

Specifies the months on which to crawl when the MonthlyCrawlSchedule parameter is set.

CrawlScheduleRepeatDuration

Optional

System.Nullable

Specifies the number of times to repeat the crawl schedule.

CrawlScheduleRepeatInterval

Optional

System.Nullable

Specifies the number of minutes between each repeat interval for the crawl schedule

CrawlScheduleStartDateTime

Optional

System.Nullable

Specifies the initial date of the crawl. The default value is midnight on the current day.

CustomProtocol

Optional

System.String

Specifies the custom protocol, handled by the custom connector, to use for this content source.

EnableContinuousCrawls

Optional

System.Nullable

Specifies the value of the EnableContinuousCrawls parameter: True or False.

LOBSystemSet

Optional

System.String[]

Specifies a comma-separated list of Business Data Connectivity Metadata Store system names and system instance names for a business type content source.

MaxPageEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of page hops that the crawler can make from the start address to a content item.

MaxSiteEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of site hops that the crawler can take from the start address to a content item.

MonthlyCrawlSchedule

Optional

System.Management.Automation.SwitchParameter

Base the schedule on months between crawls.

Name

Optional

System.String

Specifies the new display name for the content source.

The type must be a valid name of a content source; for example, ContentSource1.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the content source.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

StartAddresses

Optional

System.String

Specifies the comma-separated list of URLs at which to start a crawl for this content source.

The type must be a valid URL, in the form http://server_name.

Tag

Optional

System.String

Specifies the URL for the page to modify the settings for a custom content source. The string that specifies the URL can contain a maximum of 1,024 characters.

The type must be a valid URL, in the form http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

5

Parameter

Required

Type

Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ContentSourcePipeBind

Specifies the crawl content source to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a ContentSource object (for example, ContentSource1); or an instance of a valid ContentSource object.

ScheduleType

Required

System.Nullable

Specifies the type of crawl schedule.

The type must be one of the following values: Full or Incremental.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BDCApplicationProxyGroup

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies the proxy to use for a business type content source. This proxy group must contain a default Business Data Connectivity Metadata Store proxy.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CrawlPriority

Optional

System.Nullable

Specifies the priority of this content source.

The type must be one of the following integers: 1= Normal, 2=High.

CrawlScheduleDaysOfWeek

Optional

System.Nullable

Specifies the days on which to crawl when the WeeklyCrawlSchedule parameter is set.

CrawlScheduleRepeatDuration

Optional

System.Nullable

Specifies the number of times to repeat the crawl schedule.

CrawlScheduleRepeatInterval

Optional

System.Nullable

Specifies the number of minutes between each repeat interval for the crawl schedule

CrawlScheduleRunEveryInterval

Optional

System.Nullable

Specifies the interval between crawls.

When the DailyCrawlSchedule parameter is set, specifies the number of days between crawls.

When the WeeklyCrawlSchedule parameter is set, specifies the number of weeks between crawls.

CrawlScheduleStartDateTime

Optional

System.Nullable

Specifies the initial date of the crawl. The default value is midnight on the current day.

CustomProtocol

Optional

System.String

Specifies the custom protocol, handled by the custom connector, to use for this content source.

EnableContinuousCrawls

Optional

System.Nullable

Specifies the value of the EnableContinuousCrawls parameter: True or False.

LOBSystemSet

Optional

System.String[]

Specifies a comma-separated list of Business Data Connectivity Metadata Store system names and system instance names for a business type content source.

MaxPageEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of page hops that the crawler can make from the start address to a content item.

MaxSiteEnumerationDepth

Optional

System.Nullable

Specifies, for a web or custom type content source, the number of site hops that the crawler can take from the start address to a content item.

Name

Optional

System.String

Specifies the new display name for the content source.

The type must be a valid name of a content source; for example, ContentSource1.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the content source.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

StartAddresses

Optional

System.String

Specifies the comma-separated list of URLs at which to start a crawl for this content source.

The type must be a valid URL, in the form http://server_name.

Tag

Optional

System.String

Specifies the URL for the page to modify the settings for a custom content source. The string that specifies the URL can contain a maximum of 1,024 characters.

The type must be a valid URL, in the form http://server_name.

WeeklyCrawlSchedule

Optional

System.Management.Automation.SwitchParameter

Base the schedule on weeks between crawls.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPEnterpriseSearchCrawlContentSource cmdlet updates the rules of a crawl content source when the search functionality is initially configured and after any new content source is added. This cmdlet is called once to set the incremental crawl schedule for a content source, and it is called again to set a full crawl schedule.

The value of the optional EnableContinuousCrawls parameter can be True or False. A value of True enables continuous crawls of items in this content source. This causes the search system to automatically start incremental crawls to process the latest changes to items in the corresponding data repositories. This helps to keep the index fresh for items in this content source. Search service application administrators can still configure full crawls as needed.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1"$cs = Get-SPEnterpriseSearchCrawlContentSource -SearchApplication $searchapp ""$cs | Set-SPEnterpriseSearchCrawlContentSource -ScheduleType Full -DailyCrawlSchedule -CrawlScheduleRunEveryInterval 30$cs | Set-SPEnterpriseSearchCrawlContentSource -ScheduleType Incremental -DailyCrawlSchedule -CrawlScheduleRepeatInterval 60 -CrawlScheduleRepeatDuration 1440

This example returns an existing content source ExampleContentSource1, and creates a schedule to run a full crawl every 30 days and an incremental crawl every hour every day.

See also

Get-SPEnterpriseSearchCrawlContentSource
New-SPEnterpriseSearchCrawlContentSource
Remove-SPEnterpriseSearchCrawlContentSource


Set-SPEnterpriseSearchCrawlDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets properties of a crawl database for a Search service application.

Set-SPEnterpriseSearchCrawlDatabase [-Identity] <CrawlStorePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.CrawlStorePipeBind

Specifies the crawl database to modify.

A valid crawl database name, in the form CrawlStore1; or a valid GUID, such as 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid CrawlStore object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FailoverDatabaseServer

Optional

System.String

Specifies the server to be used for failover when SQL Server mirroring is used.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the name of the search application to which the crawl database applies.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPEnterpriseSearchCrawlDatabase cmdlet sets properties of a specified crawl database for a Search service application. A crawl database stores crawl history for a Search service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication mySearchServiceAppSet-SPEnterpriseSearchCrawlDatabase -Identity SearchApp_CrawlStore-SearchApplication $searchApp -FailoverDatabaseServer \\failoverServer

This example sets the failover database server for the crawl database, SearchApp_CrawlStore, to the \\failoverServer server.

See also

Get-SPEnterpriseSearchCrawlDatabase
New-SPEnterpriseSearchCrawlDatabase
Remove-SPEnterpriseSearchCrawlDatabase


Set-SPEnterpriseSearchCrawlRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets properties for a crawl rule.

Set-SPEnterpriseSearchCrawlRule [-Identity] <CrawlRulePipeBind> [-AccountName <String>] [-AccountPassword <SecureString>] [-AssignmentCollection <SPAssignmentCollection>] [-AuthenticationType <Nullable>] [-Confirm [<SwitchParameter>]] [-ContentClass <String>] [-CrawlAsHttp <Nullable>] [-FollowComplexUrls <Nullable>] [-IsAdvancedRegularExpression <Nullable>] [-PluggableSecurityTimmerId <Nullable>] [-Priority <Nullable>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SuppressIndexing <Nullable>] [-Type <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.CrawlRulePipeBind

Specifies the name of the crawl rule.

The type must be a valid crawl rule URL, such as http://server_name, or an instance of a valid CrawlRule object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuthenticationType

Optional

System.Nullable

Specifies one of the following authentication types:

BasicAccountRuleAccess Specifies basic authentication.

CertificateRuleAccess Specifies the X.509 certificate name.

NTLMAccountRuleAccess Specifies the account name for integrated authentication.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentClass

Optional

System.String

Specifies a string that is sent to the protocol handler for any content that matches the crawl rule.

CrawlAsHttp

Optional

System.Nullable

Specifies whether the crawler crawls content from a hierarchical content source as HTTP content.

FollowComplexUrls

Optional

System.Nullable

Specifies whether the index engine crawls content from URLs that contain a question mark (?).

IsAdvancedRegularExpression

Optional

System.Nullable

Specifies whether the rule has full regular expression syntax.

The default value is False.

PluggableSecurityTimmerId

Optional

System.Nullable

Specifies the ID of the custom pluggable security trimmer to use, if registered.

Priority

Optional

System.Nullable

Defines where in the list of crawl rules this crawl rule is to be applied.

The priority value cannot be less than 0 or greater than or equal to the number of crawl rules for the search application.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

The name of the search application that is associated with the crawl rule to be modified.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

SuppressIndexing

Optional

System.Nullable

Specifies whether the crawler excludes the content of items, to which this rule applies, from the content index.

Type

Optional

System.Nullable

Specifies the type of crawl rule. A value of zero (0) includes the rule, and a value of 1 excludes the rule.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

A search administrator runs the Set-SPEnterpriseSearchCrawlRule cmdlet at initial search configuration or any other time, to set or update various attributes of a crawl rule.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$crawlRule = Get-SPEnterpriseSearchCrawlRule -Identityfile://fileserver/root -SearchApplication mySearchServiceAppSet-SPEnterpriseSearchCrawlRule -Identity $crawlRule -Type "ExclusionRule"

This example sets the type of the crawl rule pertaining to the URL, file://fileserver/root, to exclude this path from future crawls.

See also

Get-SPEnterpriseSearchCrawlRule
New-SPEnterpriseSearchCrawlRule
Remove-SPEnterpriseSearchCrawlRule


Get-SPEnterpriseSearchService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the search service for the farm.

Get-SPEnterpriseSearchService [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet returns the SearchService object when the search service is updated or deleted.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchService = Get-SPEnterpriseSearchService

This example obtains a reference to the search service of the current farm.

See also

Set-SPEnterpriseSearchService


Get-SPEnterpriseSearchServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the search service application for a farm.

Get-SPEnterpriseSearchServiceApplication [[-Identity] <SearchServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application to retrieve.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a search service application (for example, MySearchApp); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet retrieves the SearchServiceApplication object.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity MySSA

This example obtains a reference to a search service application named MySSA.

See also

New-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchServiceApplication
Remove-SPEnterpriseSearchServiceApplication
Restore-SPEnterpriseSearchServiceApplication
Upgrade-SPEnterpriseSearchServiceApplication
Suspend-SPEnterpriseSearchServiceApplication
Resume-SPEnterpriseSearchServiceApplication


Get-SPEnterpriseSearchServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the search service application proxy.

Get-SPEnterpriseSearchServiceApplicationProxy [[-Identity] <SearchServiceApplicationProxyPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationProxyPipeBind

Specifies the search service application proxy to retrieve.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a search service application proxy (for example, SearchServiceAppProxy1); or an instance of a valid SearchServiceApplicationProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet reads the SearchServiceApplicationProxy object when the search service application proxy is created updated or deleted. If the Identity parameter is not specified, this cmdlet returns the search service application proxy collection for the farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssaProxy = Get-SPEnterpriseSearchServiceApplicationProxy -Identity SsaProxy

This example obtains a reference to a search service application proxy with the name SsaProxy.

See also

Set-SPEnterpriseSearchServiceApplicationProxy
New-SPEnterpriseSearchServiceApplicationProxy
Remove-SPEnterpriseSearchServiceApplicationProxy


Get-SPEnterpriseSearchServiceInstance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the search service instance for a farm.

Get-SPEnterpriseSearchServiceInstance [[-Identity] <SearchServiceInstancePipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Local <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance to return.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a query server (for example, MyQueryServer); or an instance of a valid SearchServiceInstance object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Local

Optional

System.Management.Automation.SwitchParameter

Returns the search service instance for the current search server.

Detailed Description

This cmdlet returns the SearchServiceInstance object when the object is created, updated, or deleted.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssInstance = Get-SPEnterpriseSearchServiceInstance -Local

This example obtains a reference to the local search service instance.

See also

Start-SPEnterpriseSearchServiceInstance
Stop-SPEnterpriseSearchServiceInstance


New-SPEnterpriseSearchServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Adds a search service application to a farm.

New-SPEnterpriseSearchServiceApplication [[-Name] <String>] -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AdminApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-Partitioned <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the names of the new search application.

The type must be a valid name of a search application, for example, SearchApp1.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the IIS application pool to use for the new search application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL of a search application, in the form http://server_name; or an instance of a valid SPIisWebServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseName

Optional

System.String

Specifies the name of the database to create for the new search application.

The type must be a valid name of a SQL Server database, for example, SearchAppDB1.

DatabasePassword

Optional

System.String

Specifies the password for the user ID that is used for accessing the search application database on SQL Server.

The type must be a valid password.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the database specified in DatabaseName.

The type must be a valid SQL Server host name, for example, SQLServerHost1.

DatabaseUsername

Optional

System.String

Specifies the user ID to use for accessing the search application SQL Server database.

The type must be a valid user name, for example, SearchUserName1.

Partitioned

Optional

System.Management.Automation.SwitchParameter

Specifies that the search service application uses web-hosted mode. web-hosted mode segregates results for a given hosted subscription.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet is used when the search functionality is first configured or when a new shared search application is added to a farm. SPEnterpriseSearchServiceApplication represents a self-contained aggregation of indexed content and properties available for search, and provides an anchor class for setting global search properties. A farm can include multiple search service applications.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$appPool = New-SPServiceApplicationPool -name "SsaAppPool" -account contoso\adminUser
Copy code
$ssa = New-SPEnterpriseSearchServiceApplication -Name "NewSSA" -ApplicationPool $appPool

This example creates a new search service application named NewSSA in a new application pool. A search service application that is created in this manner will have active search topology, but no search components.

See also

Get-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchServiceApplication
Remove-SPEnterpriseSearchServiceApplication
Restore-SPEnterpriseSearchServiceApplication
Upgrade-SPEnterpriseSearchServiceApplication
Suspend-SPEnterpriseSearchServiceApplication
Resume-SPEnterpriseSearchServiceApplication


New-SPEnterpriseSearchServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds a new search application proxy to a farm.

New-SPEnterpriseSearchServiceApplicationProxy [[-Name] <String>] -Uri <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MergeWithDefaultPartition <SwitchParameter>] [-Partitioned <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
New-SPEnterpriseSearchServiceApplicationProxy [[-Name] <String>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MergeWithDefaultPartition <SwitchParameter>] [-Partitioned <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the display name of the search application proxy to create.

The type must be a valid string, for example, SearchAppProxy1.

Uri

Required

System.String

Specifies the URI to the search application to use for search.

The type must be a valid URI, in the form file:\\server_name\searchapp.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MergeWithDefaultPartition

Optional

System.Management.Automation.SwitchParameter

Merges the index partition for the proxy with the default index partition collection for the search service application.

Partitioned

Optional

System.Management.Automation.SwitchParameter

Specifies that the search service application must use web-hosted mode. web-hosted mode segregates results for a given hosted subscription.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the display name of the search application proxy to create.

The type must be a valid string, for example, SearchAppProxy1.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the URI to the search application to use for search.

The type must be a valid URI, in the form file:\\server_name\searchapp.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MergeWithDefaultPartition

Optional

System.Management.Automation.SwitchParameter

Merges the index partition for the proxy with the default index partition collection for the search service application.

Partitioned

Optional

System.Management.Automation.SwitchParameter

Specifies that the search service application must use web-hosted mode. web-hosted mode segregates results for a given hosted subscription.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

This cmdlet creates a proxy for a search service application. The search service application proxy can be used by a web application or another service consumer to use the functionality that is provided by the search application.

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
New-SPEnterpriseSearchServiceApplicationProxy -Name MyNewProxy -SearchApplication MySSA

This example adds a search service application proxy to a search service application named MySSA.

See also

Get-SPEnterpriseSearchServiceApplicationProxy
Set-SPEnterpriseSearchServiceApplicationProxy
Remove-SPEnterpriseSearchServiceApplicationProxy


Remove-SPEnterpriseSearchServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a search service application.

Remove-SPEnterpriseSearchServiceApplication [-Identity] <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-RemoveData <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application to delete.

A valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

RemoveData

Optional

System.Management.Automation.SwitchParameter

Specifies that all search databases and index files associated with the search service application to be deleted.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet deletes a specified SearchServiceApplication from a farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Remove-SPEnterpriseSearchServiceApplication -Identity MySSA

This example removes the search service application named MySSA from the farm.

See also

New-SPEnterpriseSearchServiceApplication
Get-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchServiceApplication
Restore-SPEnterpriseSearchServiceApplication
Upgrade-SPEnterpriseSearchServiceApplication
Suspend-SPEnterpriseSearchServiceApplication
Resume-SPEnterpriseSearchServiceApplication


Remove-SPEnterpriseSearchServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a search service application proxy.

Remove-SPEnterpriseSearchServiceApplicationProxy [-Identity] <SearchServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationProxyPipeBind

Specifies the search service application proxy to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a service application proxy (for example, ServiceAppProxy1); or an instance of a valid SearchServiceApplicationProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet deletes the specified search service application proxy from a farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Remove-SPEnterpriseSearchServiceApplicationProxy -Identity SearchProxy

This example removes a search service application proxy named SearchProxy.

See also

Get-SPEnterpriseSearchServiceApplicationProxy
Set-SPEnterpriseSearchServiceApplicationProxy
New-SPEnterpriseSearchServiceApplicationProxy


Restore-SPEnterpriseSearchServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Restores third-party backup of a search application.

Restore-SPEnterpriseSearchServiceApplication [-Name] <String> -AdminSearchServiceInstance <SearchServiceInstancePipeBind> -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> -DatabaseName <String> -DatabaseServer <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabasePassword <SecureString>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-WhatIf [<SwitchParameter>]]
Restore-SPEnterpriseSearchServiceApplication [-Name] <String> -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> -TopologyFile <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-KeepId <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the new Search application name.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool for the query web service.

AdminSearchServiceInstance

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance to be used with the administration component.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseName

Optional

System.String

Specifies the name of the database to create for the restoring the search application.

The type must be a valid name of a SQL Server database, for example, RestoreDB1.

DatabasePassword

Optional

System.String

Specifies the name of the password for the database server on the SQL Server.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the database specified in DatabaseName.

The type must be a valid SQL Server host name, for example, SQLServerHost1.

DatabaseUsername

Optional

System.String

Specifies the account name that is specified in the Database Server parameter.

FailoverDatabaseServer

Optional

System.String

Use this parameter if you want the administration database to use a failover database server.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool for the query web service.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the new Search application name.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool for the query web service.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

KeepId

Optional

System.Management.Automation.SwitchParameter

Specifies if the search service application ID's from the topology .xml file should be used for the restored search service application.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool for the query web service.

TopologyFile

Required

System.String

Specifies the path of the .XML file that contains the application topology information.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Parameters

1

Parameter

Required

Type

Description

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the new Search application name.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool for the query web service.

AdminSearchServiceInstance

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance to be used with the administration component.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseName

Optional

System.String

Specifies the name of the database to create for the restoring the search application.

The type must be a valid name of a SQL Server database, for example, RestoreDB1.

DatabasePassword

Optional

System.String

Specifies the name of the password for the database server on the SQL Server.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the database specified in DatabaseName.

The type must be a valid SQL Server host name, for example, SQLServerHost1.

DatabaseUsername

Optional

System.String

Specifies the account name that is specified in the Database Server parameter.

FailoverDatabaseServer

Optional

System.String

Use this parameter if you want the administration database to use a failover database server.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool for the query web service.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the new Search application name.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool for the query web service.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

KeepId

Optional

System.Management.Automation.SwitchParameter

Specifies if the search service application ID's from the topology .xml file should be used for the restored search service application.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool for the query web service.

TopologyFile

Required

System.String

Specifies the path of the .XML file that contains the application topology information.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

This cmdlet is used by third parties to create a search application that uses existing data.

Some third parties back up the application data and have to restore the application later. So, the data is restored and uses the Restore-SPEnterpriseSearchServiceApplication cmdlet to create a new search application that uses the restored data.

This cmdlet supports parameter sets. The first set of parameters is for Application Configuration Attach mode and the second set of parameters is for Search Application Attach mode.

Application Configuration Attach mode only restores configuration data that is stored in the administration database. However, Search Application Attach restores configuration, topology and all crawled data.

Input Types

Return Types

Example

-------------EXAMPLE 1--------------

Copy code
$searchInstance = Get-SPEnterpriseSearchServiceInstance -local
Copy code
$applicationPool = New-SPServiceApplicationPool -Name "SearchServiceApplicationPool" -Account "domain\username"
Copy code
Restore-SPEnterpriseSearchServiceApplication -Name "SearchServiceApplication" -ApplicationPool $applicationPool -AdminSearchServiceInstance $searchInstance -DatabaseName "SearchServiceApplication_Admindb" -DatabaseServer "SQLServer1"

This example uses Application Configuration Attach mode to restore configuration data.

-------------EXAMPLE 2--------------

Copy code
$applicationPool = New-SPServiceApplicationPool -Name "SearchServiceApplicationPool" -Account "domain\username"
Copy code
Restore-SPEnterpriseSearchServiceApplication -Name "SearchServiceApplication" -ApplicationPool $applicationPool -TopologyFile "C:\TopologyFile.xml"

This example uses Search Application Attach mode to restore topology data in the file that is named topology.xml.

See also

Get-SPEnterpriseSearchServiceApplication
New-SPEnterpriseSearchServiceApplication
Remove-SPEnterpriseSearchServiceApplication
Resume-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchServiceApplication
Upgrade-SPEnterpriseSearchServiceApplication
Suspend-SPEnterpriseSearchServiceApplication


Resume-SPEnterpriseSearchServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Resumes a search service application that was suspended.

Resume-SPEnterpriseSearchServiceApplication [-Identity] <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application to resume.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, MyQueryServer); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet reads the SearchServiceApplication object and moves it from the Paused for: External Request status to the Resumed status.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity MySSA$ssa | Resume-SPEnterpriseSearchServiceApplication

This example obtains a reference to a search service application named MySSA and then resumes it.

See also

New-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchServiceApplication
Remove-SPEnterpriseSearchServiceApplication
Suspend-SPEnterpriseSearchServiceApplication
Restore-SPEnterpriseSearchServiceApplication
Get-SPEnterpriseSearchServiceApplication
Upgrade-SPEnterpriseSearchServiceApplication


Set-SPEnterpriseSearchService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets the properties of a search service for a farm.

Set-SPEnterpriseSearchService [[-Identity] <SearchServicePipeBind>] [-AcknowledgementTimeout <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ConnectionTimeout <String>] [-ContactEmail <String>] [-IgnoreSSLWarnings <String>] [-InternetIdentity <String>] [-PerformanceLevel <String>] [-ProxyType <String>] [-ServiceAccount <String>] [-ServicePassword <SecureString>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServicePipeBind

Specifies the search service to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchService1); or an instance of a valid SearchService object.

AcknowledgementTimeout

Optional

System.String

Specifies the time in seconds that the crawl component will wait for request acknowledgement while connecting to other services.

The type must be string input that can be parsed to an integer value.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ConnectionTimeout

Optional

System.String

Specifies the time in seconds that the crawl component waits while connecting to other services.

The type must be string input that can be parsed to an integer value.

ContactEmail

Optional

System.String

Specifies an e-mail address to which external site administrators can write if problems occur when the site is being crawled.

The type must be a valid e-mail address, in the form MyAddress@mycompany.com.

IgnoreSSLWarnings

Optional

System.String

Specifies that the search service will ignore Secure Sockets Layer (SSL) certificate name warnings. The default value is False.

The type must be a string that can be cast to a Boolean value, for example, True or False.

InternetIdentity

Optional

System.String

Specifies the value that the crawler sends in the headers of its HTTP requests to sites when it fetches their pages.

PerformanceLevel

Optional

System.String

Specifies the relative number of threads for the crawl component performance:

Reduced: Total number of threads = number of processors, Max Threads/host = number of processors

Partly Reduced: Total number of threads = 4 times the number of processors , Max Threads/host = 16 time the number of processors

Maximum: Total number of threads = number of processors

The type must be one of the following values: Reduced, PartlyReduced, or Maximum.

ProxyType

Optional

System.String

Specifies whether the search service uses a proxy server or connects directly when crawling content. The default value is Direct, (No proxy server is used).

The type must be one of the following values: Direct or Proxy.

ServiceAccount

Optional

System.String

Specifies the user account or service account to use for running the search service. The type must be a valid account name on the domain, in the form Domain\user name or user name.

When this parameter is used, the ServicePassword parameter must also be specified.

Note:

After using this cmdlet to change the service account, you must restart the SharePoint 2013 Search Host Controller service on servers hosting any of the following search components: the index component, query processing component, search administration component, content processing component, or analytics processing component.

ServicePassword

Optional

System.String

Specifies the password for the service account specified in ServiceAccount.

The type must contain the domain password to the account specified in the ServiceAccount parameter.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet updates properties of a search service for a farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$password = Read-Host -AsSecureString**********
Copy code
Set-SPEnterpriseSearchService -IgnoreSSLWarnings $true -ServiceAccount contoso\adminAccount -ServicePassword $password

This example configures the search service to ignore SSL warnings, and changes the service account for the search service.

See also

Get-SPEnterpriseSearchService


Set-SPEnterpriseSearchServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets the properties of a search service application for a farm.

Set-SPEnterpriseSearchServiceApplication [-Identity] <SearchServiceApplicationPipeBind> [-AdminApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-ApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-DefaultContentAccessAccountName <String>] [-DefaultContentAccessAccountPassword <SecureString>] [-DefaultSearchProvider <Nullable>] [-DiacriticSensitive <String>] [-FailoverDatabaseServer <String>] [-VerboseQueryMonitoring <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a search service application (for example, MySearchApp); or an instance of a valid SearchServiceApplication object.

AdminApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the application pool for the administrative web service for the search service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AdminAppPool1); or an instance of a valid IISWebServiceApplicationPool object.

ApplicationPool

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies an application pool for the search service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPool1); or an instance of a valid IISWebServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseName

Optional

System.String

Specifies the name of the database for the Web service administration.

The type must be a valid name of a SQL Server database, for example WebAdminDB1.

DatabasePassword

Optional

System.String

Specifies the password for the user ID that is used for accessing the web service administration database on SQL Server.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the web service administration database.

The type must be a valid SQL Server host name, for example, SQLServerHost1.

DatabaseUsername

Optional

System.String

Specifies the user ID to use for accessing the web service administration database.

The type must be a valid user name, for example, WebAdminUserDB1.

DefaultContentAccessAccountName

Optional

System.String

Specifies the account ID to use for accessing content.

The type must be a valid user name, for example, ContentAccessUser1.

DefaultContentAccessAccountPassword

Optional

System.Security.SecureString

Specifies the password for the content access account.

The type must be a valid password.

DefaultSearchProvider

Optional

System.Nullable

Specifies the search application type to be used for this application. This parameter has been deprecated for SharePoint Server 2013.

DiacriticSensitive

Optional

System.String

Specifies that the search application respects diacritics (for example, ä). The default value is false.

FailoverDatabaseServer

Optional

System.String

Specifies the name of the host SQL instance for the failover database server.

The type must be a valid SQL Server instance name, for example, SQLServerHost1.

VerboseQueryMonitoring

Optional

System.String

Enables verbose query logging. The default value is False.

The type must be a string that can be cast to a Boolean value, for example, True or False.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet updates properties of a search service application. SPEnterpriseSearchServiceApplication represents a self-contained aggregation of indexed content and properties available for search, and provides an anchor class for setting global search properties. A search application can include multiple search service applications.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Set-SPEnterpriseSearchServiceApplication -Identity "Search Service Application" -VerboseQueryMonitoring True

This example turns on verbose query logging in the default search service application named Search Service Application.

See also

New-SPEnterpriseSearchServiceApplication
Get-SPEnterpriseSearchServiceApplication
Remove-SPEnterpriseSearchServiceApplication
Restore-SPEnterpriseSearchServiceApplication
Upgrade-SPEnterpriseSearchServiceApplication
Suspend-SPEnterpriseSearchServiceApplication
Resume-SPEnterpriseSearchServiceApplication


Set-SPEnterpriseSearchServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets properties of a search service application proxy.

Set-SPEnterpriseSearchServiceApplicationProxy [-Identity] <SearchServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationProxyPipeBind

Specified the search service application proxy to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a search service application proxy (for example, SearchServiceAppProxy1); or an instance of a valid SearchServiceApplicationProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Name

Optional

System.String

Specifies the display name of the search application proxy to retrieve.

The type must be a valid string, for example, SearchAppProxy1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet updates properties of a site administration service application proxy for a search application. SPEnterpriseSearchServiceApplicationProxy represents the proxy for search site administration functionality. One search service application proxy exists for each search application on a farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPEnterpriseSearchServiceApplicationProxy -Identity SsaProxy | Set- SPEnterpriseSearchServiceApplicationProxy -Name ContosoSearchProxy

This example sets the display name of a search service application proxy.

See also

Get-SPEnterpriseSearchServiceApplicationProxy
New-SPEnterpriseSearchServiceApplicationProxy
Remove-SPEnterpriseSearchServiceApplicationProxy


Start-SPEnterpriseSearchServiceInstance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Starts an instance of a search service.

Start-SPEnterpriseSearchServiceInstance [-Identity] <SearchServiceInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance to start.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a query server (for example, MyQueryServer); or an instance of a valid SearchServiceInstance object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet starts an instance of a search service on a farm.

Note:

If you run this cmdlet on a running search service instance, the associated search components are also restarted. This may lead to a short downtime for queries.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPEnterpriseSearchServiceInstance -Local | Start-SPEnterpriseSearchServiceInstance

This example starts the local search service instance.

See also

Stop-SPEnterpriseSearchServiceInstance
Get-SPEnterpriseSearchServiceInstance


Stop-SPEnterpriseSearchServiceInstance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Stops an instance of a search service.

Stop-SPEnterpriseSearchServiceInstance [-Identity] <SearchServiceInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the shared search service instance to stop.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a query server (for example, MyQueryServer); or an instance of a valid SearchServiceInstance object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet stops an instance of a search service.

Note:

Before you can stop a search service instance, you must remove all search topology components on the associated server from the active topology. This can be done in three ways:

- Removing components from the search topology. If there are items in the search index, see Manage search components in SharePoint Server 2013 and Manage the index component in SharePoint Server 2013. If there are no items in the search index, see Change the default search topology in SharePoint Server 2013.

- Moving components to another server. If there are items in the search index, see Manage search components in SharePoint Server 2013 and Manage the index component in SharePoint Server 2013. If there are no items in the search index, see Change the default search topology in SharePoint Server 2013.

- Removing the search service application. For more information, see Remove-SPEnterpriseSearchServiceApplication

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPEnterpriseSearchServiceInstance -Local | Stop-SPEnterpriseSearchServiceInstance

This example stops the local search service instance.

See also

Get-SPEnterpriseSearchServiceInstance
Start-SPEnterpriseSearchServiceInstance


Suspend-SPEnterpriseSearchServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Suspends a search service application, pausing all crawls and search operations, to perform a task such as system maintenance.

Suspend-SPEnterpriseSearchServiceApplication [-Identity] <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application to suspend.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet reads the SearchServiceApplication object and moves it from Paused for: External Request status to Suspend status.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity MySSA$ssa | Suspend-SPEnterpriseSearchServiceApplication

This example obtains a reference to a search service application named MySSA and pauses it, stopping all crawls and other search components such as content processing components, analytics processing components and indexing components.

See also

Get-SPEnterpriseSearchServiceApplication
New-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchServiceApplication
Remove-SPEnterpriseSearchServiceApplication
Resume-SPEnterpriseSearchServiceApplication
Restore-SPEnterpriseSearchServiceApplication
Upgrade-SPEnterpriseSearchServiceApplication


Upgrade-SPEnterpriseSearchServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Upgrades a search service application.

Upgrade-SPEnterpriseSearchServiceApplication [-Identity] <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application to upgrade.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet starts an upgrade process on a search service application. This cmdlet runs the associated upgrade actions for the search service application. Also, you can upgrade multiple search service applications in parallel by starting several instances of this cmdlet. It is not necessary to run this cmdlet if you already have run the SharePoint Products Configuration Wizard.

Note:

For the upgrade process to run successful, all of the computers in the farm must have the same version of binaries installed.

Input Types

Return Types

Example

----------------EXAMPLE 1-----------------

Copy code
Get-SPEnterpriseSearchServiceApplication | Upgrade-SPEnterpriseSearchServiceApplication

This example upgrades a search service application.

----------------EXAMPLE 2-----------------

Copy code
Upgrade-SPEnterpriseSearchServiceApplication -Identity 846ceb0b-31d6-4c79-82c1-3a9deafe0b45

This example upgrades a search service application.

----------------EXAMPLE 3-----------------

Copy code
Upgrade-SPEnterpriseSearchServiceApplication "DefaultSearchApplication"

This example upgrades a search service application.

See also

New-SPEnterpriseSearchServiceApplication
Get-SPEnterpriseSearchServiceApplication
Remove-SPEnterpriseSearchServiceApplication
Restore-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchServiceApplication
Suspend-SPEnterpriseSearchServiceApplication
Resume-SPEnterpriseSearchServiceApplication


Get-SPEnterpriseSearchQueryAndSiteSettingsService
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the search manager service.

Get-SPEnterpriseSearchQueryAndSiteSettingsService [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchQueryAndSiteSettingsService cmdlet returns a manager service. A manager service is the endpoint for the search service application to process queries and site administration requests from the search service application proxy.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$qssService = Get-SPEnterpriseSearchQUeryAndSiteSettingsService

This example obtains a reference to the query and site settings service.


Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the service manager service instance.

Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance [[-Identity] <SearchQueryAndSiteSettingsServiceInstancePipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Local <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchManagerServiceInstancePipeBind

Specifies the search manager service instance to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid server name on which search manager service instance runs; or an instance of a valid SearchManagerServiceInstance object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Local

Optional

System.Management.Automation.SwitchParameter

Specifies that the service manager service instance for the current search server is returned.

Detailed Description

The Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance cmdlet returns the service manager service instance when a search manager service is started or stopped.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$qqssSvcInstance = Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance -Local

This example obtain a reference to the query and site setting service instance on the local farm.

------------------EXAMPLE 2------------------

Copy code
$qssSvcInstance = Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance -Identity myServer

This example obtain a reference to the query and site setting service instance from a specific server name.


Get-SPEnterpriseSearchQueryAndSiteSettingsServiceProxy
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the search manager service proxy.

Get-SPEnterpriseSearchQueryAndSiteSettingsServiceProxy [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchQueryAndSiteSettingsServiceProxy cmdlet reads the SearchQueryAndSiteSettingsServiceProxy object when a search Web service manager service is started or stopped.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$qssSvcProxy = Get-SPEnterpriseSearchQueryAndSiteSettingsServiceProxy

This example obtains a reference to the query and site settings service proxy.


Get-SPEnterpriseSearchQueryAuthority
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns an authoritative page.

Get-SPEnterpriseSearchQueryAuthority [[-Identity] <AuthorityPagePipeBind>] -Owner <SearchObjectOwner> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.AuthorityPagePipeBind

Specifies the query authority to get.

The type must be a valid URL, in the form http://server_name; or an instance of a valid AuthorityPage object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding Query Authority is created.The owner must be one of the following valid levels:- Search Service Application- Site Subscription

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the authority page to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchQueryAuthority cmdlet reads a QueryAuthority object when the authoritative page is created or deleted or when the query rank is modified.

If the Identity parameter is not specified, this cmdlet returns the authority page collection for the specified search application.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity "MySSA"$qAuth = $ssa | Get-SPEnterpriseSearchQueryAuthority -Identity "http://contoso.com"

This example obtains the authoritative page for the URL http://contoso.com from the search service application named MySSA.

------------------EXAMPLE 2------------------

Copy code
$qaCollection = Get-SPEnterpriseSearchQueryAuthority -SearchApplication "MySSA"

This example obtains the collection of query authority pages from a search service application named MySSA.

See also

New-SPEnterpriseSearchQueryAuthority
Set-SPEnterpriseSearchQueryAuthority
Remove-SPEnterpriseSearchQueryAuthority


Get-SPEnterpriseSearchQueryDemoted
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a demoted site rule.

Get-SPEnterpriseSearchQueryDemoted [[-Identity] <DemotedPipeBind>] -Owner <SearchObjectOwner> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.DemotedPipeBind

Specifies the demoted site rule to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance a valid Demoted object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding Demoted object is created.The owner must be one of the following valid levels:- Search Service Application- Site Subscription

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the demoted site rule collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchQueryDemoted cmdlet reads the DemotedSite object when a demoted site rule is created or deleted, or when the demoted site rule is updated to modify the query rank.

If the Identity parameter is not specified, this cmdlet returns the demoted site rule collection for the specified search application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$demotedRule = Get-SPEnterpriseSearchQueryDemoted -Identity http://somesite.com -SearchApplication MySSA$demotedRule | Remove-SPEnterpriseSearchQueryDemoted

This example obtains a reference to a site demotion rule for the URL http://somesite.com, and removes it.

See also

New-SPEnterpriseSearchQueryDemoted
Remove-SPEnterpriseSearchQueryDemoted


Get-SPEnterpriseSearchQueryKeyword
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Returns a keyword term.

Get-SPEnterpriseSearchQueryKeyword [[-Identity] <KeywordPipeBind>] -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.KeywordPipeBind

Specifies the keyword term to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid string that contains a keyword term (for example, KeywordTerm1); or an instance of a valid Keyword object.

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Filters to return keywords with the specified results URL.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchQueryKeyword cmdlet reads a QueryKeyword object when the keyword rule is created, updated, or deleted.

If the Identity parameter is not specified, this cmdlet returns the query keyword collection from the specified search application.

Note:

You can use this cmdlet for keywords in site collections that are in SharePoint Server 2010 mode. You cannot use this cmdlet after a site collection is upgraded to SharePoint Server 2013 mode because keywords and Best Bets are automatically migrated to query rules.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPEnterpriseSearchQueryKeyword -Identity Engineering -Site http://myserver/sites/engineering | Set-SPEnterpriseSearchQueryKeyword -StartDate "12/25/2009" -EndDate "12/24/2010" -Site http://myserver/sites/engineering

This example gets a reference to the keyword with the term Engineering from the site http://myserver/sites/engineering and sets the start dates and end dates for the keyword.

See also

New-SPEnterpriseSearchQueryKeyword
Set-SPEnterpriseSearchQueryKeyword
Remove-SPEnterpriseSearchQueryKeyword


Get-SPEnterpriseSearchQueryScope
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Returns a query results scope.

Get-SPEnterpriseSearchQueryScope [[-Identity] <ScopePipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Url <Uri>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ScopePipeBind

Specifies the results scope to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a scope (for example, Scope1); or an instance of a valid Scope object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query scope.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Url

Optional

System.Uri

Filters to return scopes for the specified results URL.

The type must be a valid URL, in the form http://server_name.

Detailed Description

The Get-SPEnterpriseSearchQueryScope cmdlet reads a QueryScope object when the shared scope is created or deleted, or when the definition of the shared scope is updated.

If the Identity parameter is not specified, this cmdlet returns the query scope collection from the specified search application.

Note:

In SharePoint Server 2013, result sources provide the functionality that scopes provided in SharePoint Server 2010.

During an upgrade from SharePoint Server 2010, to retain legacy settings, shared scopes are automatically migrated. However, these scopes are read-only after the migration. This cmdlet can be used to read a shared scope that has been migrated.

During an upgrade from SharePoint Server 2010, to preserve legacy settings, local scopes are also automatically migrated when the corresponding sites or site collections are migrated. In a SharePoint Server 2013 farm, the scopes of a site or site collection that is in SharePoint Server 2010 mode are read-write, whereas the scopes of a site or site collection after upgrade to SharePoint Server 2013 mode are read-only. This cmdlet can be used to read a migrated local scope in either situation.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPenterpriseSearchServiceApplication -Identity MySSAGet-SPEnterpriseSearchQueryScope -Identity MustCrawl -SearchApplication $ssa | Set-SPEnterpriseSearchQueryScope -Description "Business critical sites to index" -CompilationType 1 -AlternateResultsPage http://altServer

This example obtains a reference to the scope named MustCrawl on the search application named MySSA, and changes the description, compilation type, and alternate access URL.

See also

New-SPEnterpriseSearchQueryScope
Set-SPEnterpriseSearchQueryScope
Remove-SPEnterpriseSearchQueryScope
New-SPEnterpriseSearchQueryScopeRule


Get-SPEnterpriseSearchQueryScopeRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Returns a shared scope rule.

Get-SPEnterpriseSearchQueryScopeRule [[-Identity] <ScopeRulePipeBind>] -Scope <ScopePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-Url <Uri>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ScopeRulePipeBind

Specifies the scope rule to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a scope rule (for example, ScopeRule1); or an instance of a valid ScopeRule object.

Scope

Required

Microsoft.Office.Server.Search.Cmdlet.ScopePipeBind

Returns query scope rules for the specified scope.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a scope (for example, Scope1); or an instance of a valid Scope object.

Url

Required

System.Uri

The type must be a valid URL, in the form http://server_name.

Returns query scope rules for the specified results URL.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query scope rule collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Detailed Description

The Get-SPEnterpriseSearchQueryScopeRule cmdlet reads a QueryScopeRule object when the shared scope rule is created, updated, or deleted. SPEnterpriseSearchQueryScopeRule represents a query result scope rule that can be applied to a scope.

Note:

In SharePoint Server 2013, result sources provide the functionality that scopes provided in SharePoint Server 2010.

During an upgrade from SharePoint Server 2010, to retain legacy settings, shared scopes are automatically migrated. However, these scopes are read-only after the migration. This cmdlet can be used to read a scope rule of a shared scope that has been migrated.

During an upgrade from SharePoint Server 2010, to preserve legacy settings, local scopes are also automatically migrated when the corresponding sites or site collections are migrated. In a SharePoint Server 2013 farm, the scopes of a site or site collection that is in SharePoint Server 2010 mode are read-write, whereas the scopes of a site or site collection after upgrade to SharePoint Server 2013 mode are read-only. This cmdlet can be used to read a scope rule of a migrated local scope in either situation.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity "MySSA"$scope = Get-SPEnterpriseSearchQueryScope -Identity MustCrawl -SearchApplication $ssaGet-SPEnterpriseSearchQueryScopeRule -Scope $scope -Url http://criticalSite | Set-SPEnterpriseSearchQueryScopeRule -Url http://criticalSite -UrlScopeRuleType Url

This example gets a reference to a scope rule for the URL http://criticalSite, and sets its rule type to URL.

See also

New-SPEnterpriseSearchQueryScopeRule
Set-SPEnterpriseSearchQueryScopeRule
Remove-SPEnterpriseSearchQueryScopeRule


Get-SPEnterpriseSearchQuerySuggestionCandidates
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a list of queries.

Get-SPEnterpriseSearchQuerySuggestionCandidates -Owner <SearchObjectOwner> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-SourceId <Guid>]

Parameters

Parameter Required Type Description

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding LanguageResourcePhrase is created.

The owner must be one of the following valid levels:

- Search Service Application

- Site Subscription

- Site Collection

- Site

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query topology.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SourceId

Optional

System.Guid

Identifies the search result source for which the LanguageResourcePhrase applies to.

Detailed Description

Use the Get-SPEnterpriseSearchQuerySuggestionCandidates cmdlet to return a list of popular queries that can be displayed in a related queries Web Part. The list gives the administrator a chance to review potential queries and add some of them to the related queries list.

Input Types

Return Types

Example

---------------------EXAMPLE------------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchQuerySuggestionCandidates -SearchApplication $searchapp

This example returns popular search queries by using the search application contained in the variable $searchapp.


Get-SPEnterpriseSearchRankingModel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Returns a ranking model.

Get-SPEnterpriseSearchRankingModel [[-Identity] <RankingModelPipeBind>] -Owner <SearchObjectOwner> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.RankingModelPipeBind

Specifies the ranking model to retrieve.

The type must be a valid GUID in the form 8f6fd0bc-06f9-43cf-bbab-08c377e083f4, or an instance of a valid RankingModel object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the scope where the ranking model is available. The available scopes are: SSA, Tenant, Site Collection or Site. A ranking model can be available in multiple scopes.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the ranking model.

The type must be a valid GUID in the form 9bf36458-fc99-4f7b-b060-867e5a63adce, a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet reads the RankingModel object when a ranking model is created, removed, or updated.

If the Identity parameter is not specified or the identity does not match any of the ranking models in the collection, all rank models for the search application are returned.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity "Search Service Application"
Copy code
$owner = Get-SPEnterpriseSearchOwner -Level ssa
Copy code
Get-SPEnterpriseSearchRankingModel -Identity 8f6fd0bc-06f9-43cf-bbab-08c377e083f4 -SearchApplication $ssa -Owner $owner

This example retrieves the ranking model on the search service application level with the identity 8f6fd0bc-06f9-43cf-bbab-08c377e083f4 for the search application Search Service Application.

------------------EXAMPLE 2------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity "Search Service Application"
Copy code
$owner = Get-SPEnterpriseSearchOwner -Level ssa
Copy code
Get-SPEnterpriseSearchRankingModel -SearchApplication $ssa -Owner $owner

This example retrieves all ranking models defined on the search service application level for the search application Search Service Application.

See also

New-SPEnterpriseSearchRankingModel
Set-SPEnterpriseSearchRankingModel
Remove-SPEnterpriseSearchRankingModel


Get-SPEnterpriseSearchSecurityTrimmer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Returns a custom security trimmer.

Get-SPEnterpriseSearchSecurityTrimmer [[-Identity] <SecurityTrimmerPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SecurityTrimmerPipeBind

Specifies the pluggable security trimmer used for the specified search application.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, or an instance of a valid SecurityTrimmer object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the security trimmer.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet returns the SecurityTrimmer. A custom security trimmer trims search results before the results are returned to the user.

If the Identity parameter is not specified, this cmdlet returns the security trimmer collection for the specified search application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPEnterpriseSearchServiceApplication -Identity MySSA | Get-SPEnterpriseSearchSecurityTrimmer

This example obtains the pluggable security trimmers registered in the search service application MySSA.

See also

New-SPEnterpriseSearchSecurityTrimmer
Remove-SPEnterpriseSearchSecurityTrimmer


New-SPEnterpriseSearchQueryAuthority
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds an authoritative page to a shared search application.

New-SPEnterpriseSearchQueryAuthority [-Url] <String> -Level <Single> -Owner <SearchObjectOwner> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Url

Required

System.String

Specifies the query authority page to create.

The type must be a valid URL, in the form http://server_name.

Level

Required

System.Single

Specifies the level of the new authoritative page. Authoritative pagesare expert pages that link to the most relevant information. A search service application can have multiple authoritative pages. The Level property is used to specify the relative relevance adjustment of the authoritative pages. This parameter may receive a floating point value of 0.0 - 2.0, where 0.0 has the most positive impact on relevance.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding Query Authority is created.The owner must be one of the following valid levels:- Search Service Application- Site Subscription

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the authority page collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchQueryAuthority cmdlet adds an authoritative page to adjust query rank. SPEnterpriseSearchQueryAuthority represents authoritative sites that rank higher in relevance than demoted sites, which are de-emphasized in relevance.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplicationNew-SPEnterpriseSearchQueryAuthority -SearchApplication $ssa -Url http://contoso.com -Level 1.5

This example designates the URL http://contoso.com as an authoritative page with a relative importance of 1.5.

See also

Get-SPEnterpriseSearchQueryAuthority
Set-SPEnterpriseSearchQueryAuthority
Remove-SPEnterpriseSearchQueryAuthority


New-SPEnterpriseSearchQueryDemoted
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds a demoted site rule to a shared search application.

New-SPEnterpriseSearchQueryDemoted [-Url] <String> -Owner <SearchObjectOwner> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Url

Required

System.String

Specifies the identity of the new demoted site rule.

The type must be a valid URL, in the form http://server_name.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding Demoted object is created.The owner must be one of the following valid levels:- Search Service Application- Site Subscription

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the demoted site rule collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchQueryDemoted cmdlet adjusts query rank by adding a demoted site rule to the shared search application. Query demoted sites are de-emphasized in relevance.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
Get-SPEnterpriseSearchServiceApplication -Identity MySSA | New-SPEnterpriseSearchQueryDemoted -Url http://examplesite

This example adds a demoted site rule for the URL http://examplesite.com to a search service application.

See also

Get-SPEnterpriseSearchQueryDemoted
Remove-SPEnterpriseSearchQueryDemoted


New-SPEnterpriseSearchQueryKeyword
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Adds a keyword term to a shared search application.

New-SPEnterpriseSearchQueryKeyword [-Term] <String> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Contact <String>] [-Definition <String>] [-EndDate <Nullable>] [-ReviewDate <Nullable>] [-StartDate <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Term

Required

System.String

Specifies the keyword term to create.

The type must be a valid string that contains a keyword term (for example, KeywordTerm1).

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Associates the new keyword term to the specified results URL.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Contact

Optional

System.String

Specifies the user name associated with the new keyword.

The type must be a valid user name; for example, KeywordUser1.

Definition

Optional

System.String

Specifies the definition of the new keyword term.

The type must be a valid string; for example, a keyword term definition.

EndDate

Optional

System.Nullable

Specifies the expiration date of the keyword term. The default value is MaxDate.

The type must be a valid DateTime type, in the form 2010,12,05.

ReviewDate

Optional

System.Nullable

Specifies the review date of the keyword term. The default value is MaxDate.

The type must be a valid date, in the form 2010,12,05.

StartDate

Optional

System.Nullable

Specifies the activation date for the keyword term. The default value is the current date.

The type must be a valid date, in the form 2010,12,05.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchQueryKeyword cmdlet changes query results by creating a new keyword. A query keyword is a query component of a query topology. SPEnterpriseSearchQueryKeyword represents relevance setting through keywords.

Note:

You can use this cmdlet for keywords in site collections that are in SharePoint Server 2010 mode. You cannot use this cmdlet after a site collection is upgraded to SharePoint Server 2013 mode because keywords and Best Bets are automatically migrated to query rules.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
New-SPEnterpriseSearchQueryKeyword -Term Tangible -Site http://myserver/sites/team

This example creates a new query keyword for the site http://myserver/sites/team with the term Tangible.

See also

Get-SPEnterpriseSearchQueryKeyword
Set-SPEnterpriseSearchQueryKeyword
Remove-SPEnterpriseSearchQueryKeyword


New-SPEnterpriseSearchQueryScope
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Adds a query results scope to a shared search application.

New-SPEnterpriseSearchQueryScope [-Name] <String> -Description <String> -DisplayInAdminUI <Nullable> -SearchApplication <SearchServiceApplicationPipeBind> [-AlternateResultsPage <String>] [-AssignmentCollection <SPAssignmentCollection>] [-CompilationType <Nullable>] [-Confirm [<SwitchParameter>]] [-ExtendedSearchFilter <String>] [-OwningSiteUrl <Uri>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the identity of the scope to create.

The type must be a valid name of a scope (for example, Scope1).

Description

Required

System.String

Adds a description of the new query scope.

The type must be a valid string; for example, a description of a query scope.

DisplayInAdminUI

Required

System.Nullable

Specifies that the new scope is displayed in the administration application user interface (UI). The default setting is to hide the new scope in the administration application UI.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query scope collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AlternateResultsPage

Required

System.String

Specifies the location to display results for the new query scope.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompilationType

Optional

System.Nullable

Specifies the compilation type of the new scope. The value 0 specifies the conditionally compiled scope type, and the value 1 specifies the always compiled scope type.

The type must be either of the following: 0 or 1.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

OwningSiteUrl

Optional

System.Uri

Specifies the SharePoint site that is associated with the new scope.

The type must be a valid SharePoint site URL, in the form http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Note:

After you upgrade a Search service application from SharePoint Server 2010 to SharePoint Server 2013, you can view shared scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for shared scopes after upgrade. However, you can convert shared scopes to result sources, which serve a similar purpose. Similarly, after you upgrade a SharePoint Server 2010 site collection to SharePoint Server 2013 mode, you can view local scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for local scopes after you upgrade a site collection. However, you can convert local scopes to result sources, which serve a similar purpose.

Use the New-SPEnterpriseSearchQueryScope cmdlet to create a new shared scope. SPEnterpriseSearchQueryScope represents a query results scope used by all shared search applications on the farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity MySSA$ssa | New-SPEnterpriseSearchQueryScope -Name MustCrawl -Description "Sites we must crawl" -DisplayInAdminUI $true

This example adds a scope named MustCrawl that will be displayed in the administration UI to the search service application named MySSA.

See also

Get-SPEnterpriseSearchQueryScope
Set-SPEnterpriseSearchQueryScope
Remove-SPEnterpriseSearchQueryScope
New-SPEnterpriseSearchQueryScopeRule


New-SPEnterpriseSearchQueryScopeRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Adds a shared scope rule to a query scope.

New-SPEnterpriseSearchQueryScopeRule -RuleType <String> -Scope <ScopePipeBind> -Url <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-FilterBehavior <String>] [-ManagedProperty <ManagedPropertyPipeBind>] [-MatchingString <String>] [-PropertyValue <String>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-UrlScopeRuleType <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

RuleType

Required

System.String

Specifies the type of scope rule to create.

The type must be one of the following values: AllContent, Url, or PropertyQuery.

Scope

Required

Microsoft.Office.Server.Search.Cmdlet.ScopePipeBind

Applies the query scope rule to the specified scope.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a scope (for example, Scope1); or an instance of a valid Scope object.

Url

Required

System.Uri

Specifies the results URL that is associated with the query scope rule.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FilterBehavior

Optional

System.String

Specifies the type of scope rule to create for the query scope. The default value is Include.

The type must be one of the following values: Exclude, Include, or Require.

ManagedProperty

Optional

Microsoft.Office.Server.Search.Cmdlet.ManagedPropertyPipeBind

Specifies the managed property to use for the PropertyQuery scope rule.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a managed property (for example, ManagedProperty1); or an instance of a valid ManagedProperty object.

MatchingString

Optional

System.String

Specifies the string to use when matching the URL rule type.

PropertyValue

Optional

System.String

Specifies the property value to use when matching the PropertyQuery rule type.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query scope rule collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

UrlScopeRuleType

Optional

System.String

Specifies the value to use when matching the URL rule type.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Note:

After you upgrade a Search service application from SharePoint Server 2010 to SharePoint Server 2013, you can view shared scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for shared scopes after upgrade. However, you can convert shared scopes to result sources, which serve a similar purpose. Similarly, after you upgrade a SharePoint Server 2010 site collection to SharePoint Server 2013 mode, you can view local scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for local scopes after you upgrade a site collection. However, you can convert local scopes to result sources, which serve a similar purpose.

The New-SPEnterpriseSearchQueryScopeRule cmdlet creates a new shared scope rule. SPEnterpriseSearchQueryScopeRule represents a query results scope rule that can be applied to a scope.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity
Copy code
$scope = Get-SPEnterpriseSearchQueryScope -Identity MustCrawl -SearchApplication $ssa
Copy code
$sr = New-SPEnterpriseSearchQueryScopeRule -Scope $scope -RuleType AllContent -Url http://criticalSite
Copy code
Get-SPEnterpriseSearchQueryScopeRule -Scope $scope -Url http://criticalSite

This example creates a new scope rule of type AllContent for the URL http://criticalSite.

See also

Remove-SPEnterpriseSearchQueryScopeRule
Get-SPEnterpriseSearchQueryScopeRule
Set-SPEnterpriseSearchQueryScopeRule
Get-SPEnterpriseSearchQueryScope


New-SPEnterpriseSearchRankingModel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Adds a ranking model to a shared search application.

New-SPEnterpriseSearchRankingModel -Owner <SearchObjectOwner> -RankingModelXML <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the scope where the ranking model is available. The available scopes are: SSA, Tenant, Site Collection or Site. A ranking model can be available in multiple scopes.

RankingModelXML

Required

System.String

Specifies the name of the XML representation of the new ranking model.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the ranking model.

The type must be a valid GUID in the 9bf36458-fc99-4f7b-b060-867e5a63adce, a valid search application name (for example, SearchApp1), or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet adds a new ranking model to the assignment collection. The name, description, and identifier (ID) for the new ranking model are contained in the .xml file specified in RankingModelXML.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity "Search Service Application"
Copy code
$owner = Get-SPEnterpriseSearchOwner -Level SPWeb -SPWeb http://sharepoint/team
Copy code
$rankmodel = Get-Content .\rankModel.xml$rankmodel = [String]$rankmodel
Copy code
New-SPEnterpriseSearchRankingModel -SearchApplication $ssa -Owner $owner -RankingModelXML $rankmodel

This example creates a ranking model for the site http://sharepoint/team for the search service application Search Service Application from the file rankModel.xml which is stored in the current directory.

See also

Get-SPEnterpriseSearchRankingModel
Set-SPEnterpriseSearchRankingModel
Remove-SPEnterpriseSearchRankingModel


New-SPEnterpriseSearchSecurityTrimmer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Adds a custom security trimmer to a shared search application.

New-SPEnterpriseSearchSecurityTrimmer [-Id] <Int32> -SearchApplication <SearchServiceApplicationPipeBind> -TypeName <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Properties <String>] [-RulePath <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Id

Required

System.Int32

Specifies the identity of the security trimmer to use for the specified search application. If this parameter specifies an existing custom security trimmer, the trimmer will be removed and replaced with the custom trimmer. Remove the existing trimmer before you add a new one.

RulePath

Optional

System.String

Specifies the content path where the security trimmer will be applied.

The string must be a valid URI in the form file:\\server_name\content, and it must correspond to an existing crawl rule.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Adds the security trimmer to the specified search application.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

TypeName

Required

System.String

Specifies the strong named assembly name of a security trimmer type. The strong name must refer to a type whose assembly is deployed to the global assembly cache on a query server, and that type must implement the ISecurityTrimmerPre , ISecurityTrimmerPost or ISecurityTrimmer2 interface. Security trimming can be done in two places: before query execution (ISecurityTrimmerPre) or after the results set has returned (ISecurityTrimmerPost or ISecurityTrimmer2). For how to reference a strong name assembly, see http://msdn.microsoft.com/en-us/library/s1sx4kfb.aspx

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Properties

Optional

System.String

Specifies the name-value pairs that specify the configuration properties.

The type must be in the following name/value pair format: Name1~Value1~Name2~Value2~

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet creates a new object to configure the security trimmer. SPEnterpriseSearchSecurityTrimmer represents a security trimmer that performs customized security trimming of search results at query time, when the results are returned to the user.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchSecurityTrimmer -SearchApplication $searchapp -TypeName "SearchCustomSecurityTrimmer.CustomSecurityTrimmerPost, SearchCustomSecurityTrimmer, Version=1.0.0.0, Culture=neutral, PublicKeyToken=48e046c834625a88, processorArchitecture=MSIL" -Id 1

This example adds a new custom security trimmer for trimming the returned result set. This new security trimmer is added to the search application by using the id 1. The strong named assembly contains the class CustomSecurityTrimmerPost, which implements the ISecurityTrimmerPost interface.

See also

Get-SPEnterpriseSearchSecurityTrimmer
Remove-SPEnterpriseSearchSecurityTrimmer


Remove-SPEnterpriseSearchQueryAuthority
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes an authoritative page.

Remove-SPEnterpriseSearchQueryAuthority [-Identity] <AuthorityPagePipeBind> -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.AuthorityPagePipeBind

Specifies the query authority page to delete.

The type must be a valid URL, in the form http://server_name; or an instance a valid AuthorityPage object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding Query Authority is created.The owner must be one of the following valid levels:- Search Service Application- Site Subscription

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the authoritative page collection to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid Search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchQueryAuthority cmdlet adjusts query rank by deleting an authoritative page. SPEnterpriseSearchQueryAuthority represents authoritative sites that rank higher in relevance than demoted sites, which are de-emphasized in relevance.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Remove-SPEnterpriseSearchQueryAuthority -Identity http://contoso.com -SearchApplication MySSA

This example removes the query authority URL http://contoso.com from the search service application named MySSA.

See also

Get-SPEnterpriseSearchQueryAuthority
New-SPEnterpriseSearchQueryAuthority
Set-SPEnterpriseSearchQueryAuthority


Remove-SPEnterpriseSearchQueryDemoted
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a demoted site rule.

Remove-SPEnterpriseSearchQueryDemoted [-Identity] <DemotedPipeBind> -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.DemotedPipeBind

Specifies the demoted site rule to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid Demoted object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding Demoted object is created.The owner must be one of the following valid levels:- Search Service Application- Site Subscription

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the demoted site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchQueryDemoted cmdlet adjusts query rank by deleting a demoted site rule from the demoted site collection. Query demoted sites are de-emphasized in relevance.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$demotedRule = Get-SPEnterpriseSearchQueryDemoted -Identity http://somesite.com -SearchApplication MySSA$demotedRule | Remove-SPEnterpriseSearchQueryDemoted

This example obtains a reference to a site demotion rule for the URL http://somesite.com, and removes it.

See also

Get-SPEnterpriseSearchQueryDemoted
New-SPEnterpriseSearchQueryDemoted


Remove-SPEnterpriseSearchQueryKeyword
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Deletes a query keyword.

Remove-SPEnterpriseSearchQueryKeyword [-Identity] <KeywordPipeBind> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.KeywordPipeBind

Specifies the keyword term to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid string that contains a keyword term (for example, KeywordTerm1); or an instance of a valid Keyword object.

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Filters to delete keywords from the specified site collection of results.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchQueryKeyword cmdlet deletes unused or unwanted keywords from the query keyword collection.

Note:

You can use this cmdlet for keywords in site collections that are in SharePoint Server 2010 mode. You cannot use this cmdlet after a site collection is upgraded to SharePoint Server 2013 mode because keywords and Best Bets are automatically migrated to query rules.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPEnterpriseSearchQueryKeyword -Identity Engineering -Site http://myserver/sites/engineering | Remove-SPEnterpriseSearchQueryKeyword -Site http://myserver/sites/engineering

This example removes the Engineering keyword from the site collection at http://myserver/sites/engineering.

See also

Get-SPEnterpriseSearchQueryKeyword
New-SPEnterpriseSearchQueryKeyword
Set-SPEnterpriseSearchQueryKeyword


Remove-SPEnterpriseSearchQueryScope
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Deletes a query scope.

Remove-SPEnterpriseSearchQueryScope [-Identity] <ScopePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-Url <Uri>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ScopePipeBind

Specifies the query scope to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a scope (for example, Scope1); or an instance of a valid Scope object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query scope collection.

The type must be a valid GUID, of the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Url

Optional

System.Uri

Filters to delete scopes of the specified results URL.

The type must be a valid URL, in the form http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Note:

After you upgrade a Search service application from SharePoint Server 2010 to SharePoint Server 2013, you can view shared scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for shared scopes after upgrade. However, you can convert shared scopes to result sources, which serve a similar purpose. Similarly, after you upgrade a SharePoint Server 2010 site collection to SharePoint Server 2013 mode, you can view local scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for local scopes after you upgrade a site collection. However, you can convert local scopes to result sources, which serve a similar purpose.

The Remove-SPEnterpriseSearchQueryScope cmdlet deletes one or more specified shared scopes from the query scope collection. A query scope represents a query results scope used by all shared search applications on the farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPenterpriseSearchServiceApplication -Identity MySSAGet-SPEnterpriseSearchQueryScope -Identity MustCrawl -SearchApplication $ssa | Remove-SPEnterpriseSearchQueryScope

This example removes a scope named MustCrawl from a search service application named MySSA.

See also

Get-SPEnterpriseSearchQueryScope
New-SPEnterpriseSearchQueryScope
Set-SPEnterpriseSearchQueryScope
Get-SPEnterpriseSearchQueryScopeRule


Remove-SPEnterpriseSearchQueryScopeRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Deletes query results scope rules.

Remove-SPEnterpriseSearchQueryScopeRule [-Identity] <ScopeRulePipeBind> -Url <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Scope <ScopePipeBind>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ScopeRulePipeBind

Specifies the scope rule to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a scope rule (for example, ScopeRule1); or an instance of a valid ScopeRule object.

Url

Required

System.Uri

Filters to delete query scope rules for the specified results URL.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Scope

Optional

Microsoft.Office.Server.Search.Cmdlet.ScopePipeBind

Filters to delete multiple rules for a specified scope.

The type must be a valid string that identifies the scope; for example, Scope1.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query scope rule collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Note:

After you upgrade a Search service application from SharePoint Server 2010 to SharePoint Server 2013, you can view shared scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for shared scopes after upgrade. However, you can convert shared scopes to result sources, which serve a similar purpose. Similarly, after you upgrade a SharePoint Server 2010 site collection to SharePoint Server 2013 mode, you can view local scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for local scopes after you upgrade a site collection. However, you can convert local scopes to result sources, which serve a similar purpose.

The Remove-SPEnterpriseSearchQueryScopeRule cmdlet deletes one or more shared scope rules from the scope rule collection.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity "MySSA"$scope = Get-SPEnterpriseSearchQueryScope -Identity MustCrawl -SearchApplication $ssaGet-SPEnterpriseSearchQueryScopeRule -Scope $scope -Url http://criticalSite | Remove-SPEnterpriseSearchQueryScopeRule -Url http://criticalSite

This example removes a scope rule for the URL http://criticalSite from a search service application named MySSA.

See also

Get-SPEnterpriseSearchQueryScopeRule
New-SPEnterpriseSearchQueryScopeRule
Set-SPEnterpriseSearchQueryScopeRule
Get-SPEnterpriseSearchQueryScope


Remove-SPEnterpriseSearchRankingModel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Deletes a ranking model.

Remove-SPEnterpriseSearchRankingModel [-Identity] <RankingModelPipeBind> -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.RankingModelPipeBind

Specifies the ranking model to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, or an instance of a valid RankingModel object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the scope where the ranking model is available. The available scopes are: SSA, Tenant, Site Collection or Site. A ranking model can be available in multiple scopes.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the ranking model.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet deletes a specified ranking model.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity "Search Service Application"
Copy code
$owner = Get-SPEnterpriseSearchOwner -Level ssa
Copy code
Remove-SPEnterpriseSearchRankingModel -Identity 8f6fd0bc-06f9-43cf-bbab-08c377e083f4 -SearchApplication $ssa -Owner $owner

This example removes the ranking model for the search service application with the identity 8f6fd0bc-06f9-43cf-bbab-08c377e083f4.

See also

Get-SPEnterpriseSearchRankingModel
New-SPEnterpriseSearchRankingModel
Set-SPEnterpriseSearchRankingModel


Remove-SPEnterpriseSearchSecurityTrimmer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a custom security trimmer.

Remove-SPEnterpriseSearchSecurityTrimmer [[-Identity] <SecurityTrimmerPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SecurityTrimmerPipeBind

Specifies the security trimmer to delete.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, or an instance of a valid SecurityTrimmer object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the security trimmer.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet deletes the customized security trimmer that is used for a search application's query results. A custom security trimmer trims search results before the results are returned to the user.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPEnterpriseSearchSecurityTrimmer -SearchApplication MySSA |  Remove-SPEnterpriseSearchSecurityTrimmer

This example removes the security trimmer registered in the search service application named MySSA.

See also

Get-SPEnterpriseSearchSecurityTrimmer
New-SPEnterpriseSearchSecurityTrimmer


Set-SPEnterpriseSearchQueryAuthority
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets the properties of an authoritative page for a shared search application.

Set-SPEnterpriseSearchQueryAuthority [-Identity] <AuthorityPagePipeBind> -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Level <Nullable>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.AuthorityPagePipeBind

Specifies the query authority page to update.

The type must be a valid URL, in the form http://server_name; or an instance of a valid AuthorityPage object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding Query Authority is created.The owner must be one of the following valid levels:- Search Service Application- Site Subscription

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Level

Required

System.Single

Specifies the level of the new authoritative page. Authoritative pages, designated by the service application administrator, are expert pages that link to the most relevant information. Because a search service application can have several designated authoritative pages, you use the Level property to specify the value of a specific page. This parameter sets the level for the most valuable authoritative pages to 0.

The type must be one of the following floating-point numbers: 0, 1, or 2.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the authority page collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPEnterpriseSearchQueryAuthority cmdlet updates properties of an authoritative page and adjusts the query rank of an authoritative page. SPEnterpriseSearchQueryAuthority represents authoritative sites that rank higher in relevance than demoted sites, which are de-emphasized in relevance.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Set-SPEnterpriseSearchQueryAuthority -Identity http://contoso.com -Level 0.5 -SearchApplication MySSA

This example adjusts the authoritative level of the URL http://contoso.com to 0.5 on the search service application named MySSA.

See also

New-SPEnterpriseSearchQueryAuthority
Get-SPEnterpriseSearchQueryAuthority
Remove-SPEnterpriseSearchQueryAuthority


Set-SPEnterpriseSearchQueryKeyword
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets the properties of a keyword term for a shared search application.

Set-SPEnterpriseSearchQueryKeyword [-Identity] <KeywordPipeBind> -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Contact <String>] [-Definition <String>] [-EndDate <Nullable>] [-ReviewDate <Nullable>] [-StartDate <Nullable>] [-Term <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.KeywordPipeBind

Specifies the keyword term to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid string that contains a keyword term (for example, KeywordTerm1); or an instance of a valid Keyword object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Contact

Optional

System.String

Specifies the user name associated with the new keyword.

The type must be a valid user name; for example, KeywordUser1.

Definition

Optional

System.String

Specifies the definition of the new keyword term.

The type must be a valid string; for example, a keyword term definition.

EndDate

Optional

System.Nullable

Specifies the expiration date of the keyword term. The default value is MaxDate.

The type must be a valid DateTime type, in the form 2010,12,05.

ReviewDate

Optional

System.Nullable

Specifies the review date of the keyword term. The default value is MaxDate.

The type must be a valid DateTime type, in the form 2010,12,05.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query keyword collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Site

Optional

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Associates the new keyword term to the specified results URL.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

StartDate

Optional

System.Nullable

Specifies the activation date for the keyword term. The default value is the current date.

The type must be a valid date, in the form 2010,12,05.

Term

Optional

System.String

Specifies the keyword term that triggers keyword results.

The type must be a valid string; for example, a keyword term.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPEnterpriseSearchQueryKeyword cmdlet updates properties and rules of a keyword term. A query keyword is a query component of a query topology. SPEnterpriseSearchQueryKeyword represents relevance setting through keywords.

Note:

You can use this cmdlet for keywords in site collections that are in SharePoint Server 2010 mode. You cannot use this cmdlet after a site collection is upgraded to SharePoint Server 2013 mode because keywords and Best Bets are automatically migrated to query rules.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPEnterpriseSearchQueryKeyword -Identity Engineering -Site http://myserver/sites/engineering | Set-SPEnterpriseSearchQueryKeyword -StartDate "12/25/2009" -EndDate "12/24/2010" -Site http://myserver/sites/engineering

This example gets a reference to the keyword with the term Engineering from the site http://myserver/sites/engineering, and sets the start dates and end dates for the keyword.

See also

New-SPEnterpriseSearchQueryKeyword
Get-SPEnterpriseSearchQueryKeyword
Remove-SPEnterpriseSearchQueryKeyword


Set-SPEnterpriseSearchQueryScope
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets the properties of a query results scope for a shared search application.

Set-SPEnterpriseSearchQueryScope [-Identity] <ScopePipeBind> -AlternateResultsPage <String> [-AssignmentCollection <SPAssignmentCollection>] [-CompilationType <Nullable>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-DisplayInAdminUI <Nullable>] [-Name <String>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-Url <Uri>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ScopePipeBind

Specifies the identity of the scope to create.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a scope (for example, Scope1); or an instance of a valid Scope object.

AlternateResultsPage

Required

System.String

Specifies the location to display results for the new query scope.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompilationType

Optional

System.Nullable

Specifies the compilation type of the new scope. The value 0 specifies the conditionally compiled scope type, and the value 1 specifies the always compiled scope type.

The type must be either of the following: 0 or 1.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Adds a description of the new query scope.

The type must be a valid string; for example, a description of a query scope.

DisplayInAdminUI

Optional

System.Nullable

Specifies that the new scope is displayed in the administration application user interface (UI). The default setting is to hide the new scope in the administration application UI.

Name

Optional

System.String

Specifies a name for the query scope.

The type must be a valid name of a query scope; for example, QueryScope1.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query scope collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Url

Optional

System.Uri

Filters to delete scopes for the specified results URL.

The type must be a valid URL, in the form http://server_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Note:

After you upgrade a Search service application from SharePoint Server 2010 to SharePoint Server 2013, you can view shared scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for shared scopes after upgrade. However, you can convert shared scopes to result sources, which serve a similar purpose. Similarly, after you upgrade a SharePoint Server 2010 site collection to SharePoint Server 2013 mode, you can view local scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for local scopes after you upgrade a site collection. However, you can convert local scopes to result sources, which serve a similar purpose.

The Set-SPEnterpriseSearchQueryScope cmdlet updates properties of a shared scope. SPEnterpriseSearchQueryScope represents a query results scope used by all shared search applications on the farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPenterpriseSearchServiceApplication -Identity MySSAGet-SPEnterpriseSearchQueryScope -Identity MustCrawl -SearchApplication $ssa | Set-SPEnterpriseSearchQueryScope -Description "Business critical sites to index" -CompilationType 1 -AlternateResultsPage http://altServer

This example obtains a reference to the scope named MustCrawl on the search service application named MySSA, and changes the description, compilation type, and alternate access URL.

See also

New-SPEnterpriseSearchQueryScope
Get-SPEnterpriseSearchQueryScope
Remove-SPEnterpriseSearchQueryScope
Get-SPEnterpriseSearchQueryScopeRule


Set-SPEnterpriseSearchQueryScopeRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets the properties of a shared scope rule for a query scope.

Set-SPEnterpriseSearchQueryScopeRule [-Identity] <ScopeRulePipeBind> -Url <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-FilterBehavior <String>] [-ManagedPropertyName <String>] [-MatchingString <String>] [-PropertyValue <String>] [-Scope <ScopePipeBind>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-UrlScopeRuleType <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ScopeRulePipeBind

Specifies the scope rule to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a scope rule (for example, ScopeRule1); or an instance a valid ScopeRule object.

Url

Required

System.Uri

Specifies the results URL that is associated with the query scope rule.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FilterBehavior

Optional

System.String

Specifies the type of scope rule to create for the query scope.

The type must be one of the following values: Exclude, Include, or Require.

ManagedPropertyName

Optional

System.String

Specifies the name of the managed property to use for the PropertyQuery scope rule.

The type must be a valid name of a managed property; for example, ManagedProp1.

MatchingString

Optional

System.String

Specifies the string to use when matching the URL rule type.

PropertyValue

Optional

System.String

Specifies the property value to use when matching the PropertyQuery rule type.

Scope

Optional

Microsoft.Office.Server.Search.Cmdlet.ScopePipeBind

Applies the query scope rule to the specified scope.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a scope (for example, Scope1); or an instance of a valid Scope object.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the query scope rule collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

UrlScopeRuleType

Optional

System.String

Specifies the value to use when matching the URL rule type.

The type must be one of the following values: Folder, HostName, or Domain.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Note:

After you upgrade a Search service application from SharePoint Server 2010 to SharePoint Server 2013, you can view shared scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for shared scopes after upgrade. However, you can convert shared scopes to result sources, which serve a similar purpose. Similarly, after you upgrade a SharePoint Server 2010 site collection to SharePoint Server 2013 mode, you can view local scopes, but you cannot create, update, or delete them. Therefore, you cannot use this cmdlet for local scopes after you upgrade a site collection. However, you can convert local scopes to result sources, which serve a similar purpose.

The Set-SPEnterpriseSearchQueryScopeRule cmdlet updates the properties of a query scope. SPEnterpriseSearchQueryScopeRule represents a query results scope rule that can be applied to a scope.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity "MySSA"$scope = Get-SPEnterpriseSearchQueryScope -Identity MustCrawl -SearchApplication $ssaGet-SPEnterpriseSearchQueryScopeRule -Scope $scope -Url http://criticalSite | Set-SPEnterpriseSearchQueryScopeRule -Url http://criticalSite -UrlScopeRuleType Url

This example gets a reference to a scope rule for the URL http://criticalSite and sets its rule type to Url.

See also

New-SPEnterpriseSearchQueryScopeRule
Get-SPEnterpriseSearchQueryScopeRule
Remove-SPEnterpriseSearchQueryScopeRule
Get-SPEnterpriseSearchQueryScope


Set-SPEnterpriseSearchRankingModel
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets the properties of a ranking model for a shared search service application.

Set-SPEnterpriseSearchRankingModel [-Identity] <RankingModelPipeBind> -Owner <SearchObjectOwner> -RankingModelXML <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.RankingModelPipeBind

Specifies the ranking model to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, or an instance of a valid RankingModel object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the scope where the ranking model is available. The available scopes are: SSA, Tenant, Site Collection or Site. A ranking model can be available in multiple scopes.

RankingModelXML

Required

System.String

Specifies the name of the XML representation of the new ranking model.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the ranking model.

The type must be a valid GUID in the 9bf36458-fc99-4f7b-b060-867e5a63adce, a valid search application name (for example, SearchApp1), or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet updates properties of a ranking model for a search service application. The name, description, and identifier (ID) for a ranking model are contained in the .xml file specified in RankingModelXML. If the Identity parameter is not specified or the identity does not match any of the ranking models in the collection, an exception is thrown and the default ranking model is used.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication -Identity "Search Service Application"
Copy code
$owner = Get-SPEnterpriseSearchOwner -Level ssa
Copy code
$rankingModel = Get-SPEnterpriseSearchRankingModel -Identity 8f6fd0bc-06f9-43cf-bbab-08c377e083f4 -SearchApplication $ssa -Owner $owner
Copy code
$newrankmodel = Get-Content .\newRankModel.xml$newrankmodel = [String]$newrankmodel
Copy code
Set-SPEnterpriseSearchRankingModel -Identity $rankingModel -SearchApplication $ssa -Owner $owner -RankingModelXML $newrankmodel

This example reconfigures the ranking model with the identity 8f6fd0bc-06f9-43cf-bbab-08c377e083f4 with the new ranking model specified in newRankModel.xml.

See also

New-SPEnterpriseSearchRankingModel
Get-SPEnterpriseSearchRankingModel
Remove-SPEnterpriseSearchRankingModel


Start-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Starts an instance of a search manager service.

Start-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance [-Identity] <SearchQueryAndSiteSettingsServiceInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchManagerServiceInstancePipeBind

Specifies the search manager service instance to start.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid SPServer name, or the name of a search manager service instance (for example, SearchManagerServiceInstance1); or an instance of a valid SearchManagerServiceInstance object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Start-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance cmdlet starts the query and site settings service instance on the server instance in the same farm as the search service application to host the query object model (OM), Windows Communication Foundation (WCF) endpoint, and query processor for the search service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$qssInstance = Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance -LocalStart-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance -Identity $qssInstance

This example starts the local query and site settings instance.


Stop-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Stops an instance of a search manager service.

Stop-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance [-Identity] <SearchQueryAndSiteSettingsServiceInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchManagerServiceInstancePipeBind

Specifies the search manager service instance to stop.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid SPServer name, or the name of a search manager service instance (for example, SearchManagerServiceInstance1); or an instance of a valid SearchManagerServiceInstance object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Stop-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance cmdlet stops an instance of a search manager service.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$qssInstance = Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance -LocalStop-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance -Identity $qssInstance

This example stops the local query and site settings service instance.


Get-SPEnterpriseSearchMetadataCategory
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a crawled property category.

Get-SPEnterpriseSearchMetadataCategory [[-Identity] <CategoryPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-SiteCollection <Guid>] [-Tenant <Guid>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.CategoryPipeBind

Specifies the metadata category to retrieve.

The type must a valid search application name, for example, MetadataCategory1, or an instance of a valid Category object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the enterprise search metadata categories.

The type must a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteCollection

Optional

System.Guid

Specifies that the metadata categories returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the metadata categories returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Detailed Description

This cmdlet reads a MetadataCategory object when the category is created, updated, or deleted. You should run this cmdlet when the initial search is configured, and after a new crawled property category is discovered during a crawl. SPEnterpriseSearchMetadataCategory represents a category in the enterprise search metadata property schema.

If the Identity parameter is not specified, this cmdlet returns the metadata category collection for the specified search service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchMetadataCategory -SearchApplication $searchapp

This example retrieves the metadata category collection of a search service application for the default search service application.

See also

New-SPEnterpriseSearchMetadataCategory
Set-SPEnterpriseSearchMetadataCategory
Remove-SPEnterpriseSearchMetadataCategory


Get-SPEnterpriseSearchMetadataCrawledProperty
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a crawled property.

Get-SPEnterpriseSearchMetadataCrawledProperty [[-Name] <String>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Category <CategoryPipeBind>] [-Limit <String>] [-PropSet <Nullable>] [-SiteCollection <Guid>] [-Tenant <Guid>] [-VariantType <Nullable>]

Parameters

Parameter Required Type Description

Name

Optional

System.String

Specifies the crawled property to retrieve.

The type must be a valid crawled property name, for example "urn:schemas-microsoft-com:sharepoint:portal:profile:UserName"

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawled property.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Category

Optional

Microsoft.Office.Server.Search.Cmdlet.CategoryPipeBind

Specifies the metadata category of the crawled property to return.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a metadata category, for example, MetadataCategory1, or an instance of a valid Category object.

Limit

Optional

System.String

Specifies the maximum number of items to return. Specify ALL to return all possible results.

PropSet

Optional

System.Nullable

Specifies to return crawled properties that use the specified property set. A property set belongs to one crawled property category.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

SiteCollection

Optional

System.Guid

Specifies that the crawled properties returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the crawled properties returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

VariantType

Optional

System.Nullable

Specifies to return crawled properties that use the specified variant type.

The type must be an integer that specifies the variant data type of the property set.

Detailed Description

This cmdlet reads a CrawledProperty object for a crawled property that was created or updated. You should run this cmdlet when the search functionality is configured for the first time, and after new crawled properties are discovered during a crawl. If the Name parameter is not specified, this cmdlet returns all crawled properties for the specified category for the specified search application. If neither the Name nor the Category parameter is specified, this cmdlet returns all crawled properties for the specified search application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
$cat = Get-SPEnterpriseSearchMetadataCategory -SearchApplication $searchapp -Identity People
Copy code
Get-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Category $cat -Limit 1

This example returns the first crawled property in the PeopleSearch_Scope metadata category for the default search service application.


Get-SPEnterpriseSearchMetadataManagedProperty
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a managed property.

Get-SPEnterpriseSearchMetadataManagedProperty [[-Identity] <ManagedPropertyPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Limit <String>] [-SiteCollection <Guid>] [-Tenant <Guid>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ManagedPropertyPipeBind

Specifies the managed property to retrieve.

The type must be a valid name of metadata property, for example MetadataProperty1, or an instance of a valid ManagedProperty object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the managed property collection.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Limit

Optional

System.String

Specifies the maximum number of managed properties to return. Specify ALL to return all possible results.

SiteCollection

Optional

System.Guid

Specifies that the managed properties returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the managed properties returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Detailed Description

This cmdlet reads a ManagedProperty object for managed properties that are created or updated.

If the Identity parameter is not specified, this cmdlet returns the managed property collection for the specified search application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchMetadataManagedProperty -SearchApplication $searchapp -Identity UserName

This example retrieves the managed property UserName from the default search service application.

See also

New-SPEnterpriseSearchMetadataManagedProperty
Set-SPEnterpriseSearchMetadataManagedProperty
Remove-SPEnterpriseSearchMetadataManagedProperty


Get-SPEnterpriseSearchMetadataMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the current status of a managed property mapping.

Get-SPEnterpriseSearchMetadataMapping -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CrawledProperty <CrawledPropertyPipeBind>] [-ManagedProperty <ManagedPropertyPipeBind>] [-SiteCollection <Guid>] [-Tenant <Guid>]

Parameters

Parameter Required Type Description

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the metadata mapping.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CrawledProperty

Optional

Microsoft.Office.Server.Search.Cmdlet.CrawledPropertyPipeBind

Specifies the crawled property from which to return mappings.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid URL in the form http://server_name, or an instance of a valid CrawledProperty object.

ManagedProperty

Optional

Microsoft.Office.Server.Search.Cmdlet.ManagedPropertyPipeBind

Specifies the managed property from which to return mappings.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a managed property, for example, ManagedProperty1, or an instance of a valid ManagedProperty object.

SiteCollection

Optional

System.Guid

Specifies that the metadata mappings returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the metadata mappings returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Detailed Description

This cmdlet reads a Mapping object when a managed property mapping is created, updated, or deleted. SPEnterpriseSearchMetadataMapping represents a category of a mapping between a managed property and one or more crawled properties in the enterprise search metadata property schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
$mp = Get-SPEnterpriseSearchMetadataManagedProperty -SearchApplication $searchapp -Identity UserName
Copy code
Get-SPEnterpriseSearchMetadataMapping -SearchApplication $searchapp -ManagedProperty $mp

This example lists all crawled properties mapped to the managed property UserName for the default search service application.

See also

New-SPEnterpriseSearchMetadataMapping
Set-SPEnterpriseSearchMetadataMapping
Remove-SPEnterpriseSearchMetadataMapping


New-SPEnterpriseSearchMetadataCategory
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds a crawled property category to a search service application.

New-SPEnterpriseSearchMetadataCategory [-Name] <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AutoCreateNewManagedProperties <Nullable>] [-Confirm [<SwitchParameter>]] [-DiscoverNewProperties <Nullable>] [-MapToContents <Nullable>] [-PropSet <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the identity of the new metadata category.

The type must be a valid name of a metadata category, for example, MetadataCategory1.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the enterprise search metadata categories.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AutoCreateNewManagedProperties

Optional

System.Nullable

Specifies that when a new crawled property in this category is found, a corresponding managed property is created and mapped to this new crawled property.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DiscoverNewProperties

Optional

System.Nullable

Specifies that if there are unknown properties in this category, these new properties are discovered during a crawl.

MapToContents

Optional

System.Nullable

Specifies that all crawled properties of type string are mapped to corresponding managed properties of this category.

PropSet

Optional

System.Nullable

Creates a new metadata category with the specified property set.

Note that the specified property set is the identifier of the category. Therefore, two categories cannot share a property set.

The type must be a valid GUID that specifies the property set, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet creates the new crawled property category. SPEnterpriseSearchMetadataCategory represents a category in the enterprise search metadata property schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
$guid = [System.Guid]::NewGuid()
Copy code
New-SPEnterpriseSearchMetadataCategory -SearchApplication $searchapp -Name MyCategory -DiscoverNewProperties $true -PropSet $guid

This example adds a new metadata category named MyCategory to the default search service application. The DiscoverNewProperties parameter is set to true. Therefore, new crawled properties will be added to the MyCategory metadata category and the unique category identifier is set with the PropSet parameter.

See also

Get-SPEnterpriseSearchMetadataCategory
Set-SPEnterpriseSearchMetadataCategory
Remove-SPEnterpriseSearchMetadataCategory


New-SPEnterpriseSearchMetadataCrawledProperty
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds a crawled property.

New-SPEnterpriseSearchMetadataCrawledProperty -Category <CategoryPipeBind> -IsNameEnum <$true | $false> -Name <String> -PropSet <Guid> -SearchApplication <SearchServiceApplicationPipeBind> -VariantType <Int32> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-IsMappedToContents <Nullable>] [-SiteCollection <Guid>] [-Tenant <Guid>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

Microsoft.Office.Server.Search.Cmdlet.CrawledPropertyPipeBind

Specifies the identity of the new crawled property.

The type must be a valid crawled property name, for example "urn:schemas-microsoft-com:sharepoint:portal:profile:UserName"

Category

Required

Microsoft.Office.Server.Search.Cmdlet.CategoryPipeBind

Specifies to which metadata category the crawled property should be added

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a metadata category, for example, MetadataCategory1, or an instance of a valid Category object.

IsNameEnum

Required

System.Boolean

Specifies whether the crawled property name is of type integer. Specified by true or false.

PropSet

Optional

System.Guid

Specifies the property set that belongs to an existing category.

A valid GUID that specifies the property set, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawled property.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

VariantType

Required

System.Int32

Adds the crawled property as the specified variant type. For more information about valid values for this property, see VARIANT Type Constants (http://go.microsoft.com/fwlink/p/?LinkId=143322&clcid=0x409).

The type must be an integer that specifies the variant data type of the property set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IsMappedToContents

Optional

System.Nullable

Specifies that the crawled property should be mapped to managed properties. Specify true to map a crawled property to a managed property.

SiteCollection

Optional

System.Guid

Specifies that the crawled properties returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the crawled properties returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet is used when the search functionality is configured for the first time, and to add new crawled properties after the first configuration. SPEnterpriseSearchMetadataCrawledProperty represents a crawled property in the enterprise search metadata property schema. Or, crawled properties are automatically created during regular crawls (see SPEnterpriseSearchMetadataCategory).

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
$cat = Get-SPEnterpriseSearchMetadataCategory -SearchApplication $searchapp -Identity People
Copy code
$crawlprop = Get-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Category $cat -Limit 1
Copy code
New-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Name "MyCrawlProp" -PropSet $crawlprop.PropSet -Category $crawlprop.CategoryName -IsNameEnum $false -VariantType $crawlprop.VariantType -IsMappedToContents $false

This example maps the new crawled property MyCrawlProp to the People metadata category for the default search service application. The mapping uses the constraints from the existing People category.

See also

Get-SPEnterpriseSearchMetadataCrawledProperty
Set-SPEnterpriseSearchMetadataCrawledProperty

VARIANT Type Constants (http://go.microsoft.com/fwlink/p/?LinkId=143322&clcid=0x409)


New-SPEnterpriseSearchMetadataManagedProperty
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds a managed property to a shared search application.

New-SPEnterpriseSearchMetadataManagedProperty [-Name] <String> -SearchApplication <SearchServiceApplicationPipeBind> -Type <Int32> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultForQueryIndependentRank <Nullable>] [-Description <String>] [-EnabledForQueryIndependentRank <Nullable>] [-EnabledForScoping <Nullable>] [-FullTextQueriable <Nullable>] [-IncludeInAlertSignature <Nullable>] [-IncludeInMd5 <Nullable>] [-NameNormalized <Nullable>] [-NoWordBreaker <Nullable>] [-Queryable <Nullable>] [-RemoveDuplicates <Nullable>] [-RespectPriority <Nullable>] [-Retrievable <Nullable>] [-SafeForAnonymous <Nullable>] [-SiteCollection <Guid>] [-Tenant <Guid>] [-UserFlags <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the new managed property.

The type must be a valid name of a managed property, for example, ManagedProperty1.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the managed property collection.

The type must be a valid search application name (for example, SearchApp1), or an instance of a valid SearchServiceApplication object.

Type

Required

System.Int32

Specifies the data type of the new managed property.

The type must be one of the following data types:

1 = Text

2 = Integer

3 = Decimal

4 = DateTime

5 = YesNo

6 = Binary

7 = Double

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultForQueryIndependentRank

Optional

System.Nullable

Specifies that the managed property is mandatory when it is used in query-independent rank (relevance).

Description

Optional

System.String

Adds a description to the metadata managed property.

The type must be a valid string.

EnabledForQueryIndependentRank

Optional

System.Nullable

Specifies that the managed property is mandatory when it is used in the custom ranking model for the query-independent work of ranking.

The type must be one of the following query-independent ranking features in the custom model XML:

  • queryIndependentFeature

  • categoryFeature

  • languageFeature

EnabledForScoping

Optional

System.Nullable

Specifies that the managed property can be used in a scope definition.

FullTextQueriable

Optional

System.Nullable

Specifies that the managed property can be used in enterprise search SQL queries.

IncludeInMd5

Optional

System.Nullable

Specifies that the managed property is included in the hash used by the crawler to determine whether a document has changed.

NameNormalized

Optional

System.Nullable

Specifies if the values of the managed property should be normalized, that is, enable to return results independent of letter casing and diacritics used in the query. If value is set to true, the values are normalized.

NoWordBreaker

Optional

System.Nullable

Specifies that the values for this managed property are processed by a word breaker.

Queryable

Optional

System.Nullable

Specifies whether this managed property is queryable or not.

RemoveDuplicates

Optional

System.Nullable

Specifies that duplicate values for the managed property are removed.

RespectPriority

Optional

System.Nullable

Specifies that when a mapped crawled property contains multiple values, and RespectPriority is set to true, only the first mapped crawled property is copied. Otherwise, all mapped crawled properties that have a value are copied.

Retrievable

Optional

System.Nullable

Specifies whether this managed property is retrievable or not.

SiteCollection

Optional

System.Guid

Specifies that the managed properties returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the managed properties returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

UserFlags

Optional

System.Nullable

Reserved for future use.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet creates a new managed property. SPEnterpriseSearchMetadataManagedProperty represents a managed property in the enterprise search metadata property schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchMetadataManagedProperty -Name AboutMeUpdate -SearchApplication $searchapp -Type 4

This example creates a new managed property named AboutMeUpdate in the default search service application, and sets it type to DateTime.

See also

Get-SPEnterpriseSearchMetadataManagedProperty
Set-SPEnterpriseSearchMetadataManagedProperty
Remove-SPEnterpriseSearchMetadataManagedProperty


New-SPEnterpriseSearchMetadataMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds a managed property mapping.

New-SPEnterpriseSearchMetadataMapping -CrawledProperty <CrawledPropertyPipeBind> -ManagedProperty <ManagedPropertyPipeBind> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SiteCollection <Guid>] [-Tenant <Guid>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

CrawledProperty

Required

Microsoft.Office.Server.Search.Cmdlet.CrawledPropertyPipeBind

Specifies the crawled property to map.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid URL in the form http://server_name, or an instance of a valid CrawledProperty object.

ManagedProperty

Required

Microsoft.Office.Server.Search.Cmdlet.ManagedPropertyPipeBind

Specifies the managed property to which the crawled property should be mapped.

The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a managed property, for example, ManagedProperty1, or an instance of a valid ManagedProperty object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the metadata mapping.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SiteCollection

Optional

System.Guid

Specifies that the metadata mapping returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the metadata mapping returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet maps a crawled property to a managed property. SPEnterpriseSearchMetadataMapping represents a snapshot of a mapping between a managed property and one or more crawled properties in the enterprise search metadata property schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
$mp = Get-SPEnterpriseSearchMetadataManagedProperty -SearchApplication $searchapp -Identity UserName
Copy code
$cat = Get-SPEnterpriseSearchMetadataCategory -SearchApplication $searchapp -Identity People
Copy code
$cp = Get-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Category $cat -Limit 1
Copy code
$ncp = New-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Name "MyCrawlProp" -PropSet $cp.PropSet -Category $cp.CategoryName -IsNameEnum $false -VariantType $cp.VariantType -IsMappedToContents $true
Copy code
New-SPEnterpriseSearchMetadataMapping -SearchApplication $searchapp -ManagedProperty $mp -CrawledProperty $ncp

This example maps the created crawled property MyCrawlProp to the managed property UserName for the default search service application.

See also

Get-SPEnterpriseSearchMetadataMapping
Set-SPEnterpriseSearchMetadataMapping
Remove-SPEnterpriseSearchMetadataMapping

VARIANT Type Constants (http://go.microsoft.com/fwlink/p/?LinkId=143322&clcid=0x409)


Remove-SPEnterpriseSearchMetadataCategory
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a crawled property category.

Remove-SPEnterpriseSearchMetadataCategory [-Identity] <CategoryPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.CategoryPipeBind

Specifies the metadata category to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a metadata category, for example, MetadataCategory1, or an instance of a valid Category object.

Note that if only a name for a category is specified, a SearchApplication must also be specified.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the enterprise search metadata property schema.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet deletes a crawled property category. You should use this cmdlet after a crawl to delete unused or unwanted categories from the metadata property schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
Remove-SPEnterpriseSearchMetadataCategory -Identity MyCategory -SearchApplication $searchapp

This example removes the metadata category named MyCategory for the default search service application.

See also

Get-SPEnterpriseSearchMetadataCategory
Set-SPEnterpriseSearchMetadataCategory
New-SPEnterpriseSearchMetadataCategory


Remove-SPEnterpriseSearchMetadataManagedProperty
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a metadata managed property.

Remove-SPEnterpriseSearchMetadataManagedProperty [-Identity] <ManagedPropertyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SiteCollection <Guid>] [-Tenant <Guid>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ManagedPropertyPipeBind

Specifies the managed property to delete.

The type must be a valid name of a managed property, for example ManagedProperty1, or an instance of a valid ManagedProperty object.

Note that if only a name of a managed property is specified, a SearchApplication must also be specified.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the managed property collection.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

SiteCollection

Optional

System.Guid

Specifies that the managed properties returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the managed properties returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet deletes a specified managed property from the managed property collection.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
$mp = Get-SPEnterpriseSearchMetadataManagedProperty -SearchApplication $searchapp -Identity AboutMeUpdate
Copy code
Remove-SPEnterpriseSearchMetadataManagedProperty -Identity $mp

This example removes the managed property AboutMeUpdate from the default search service application.

See also

Get-SPEnterpriseSearchMetadataManagedProperty
New-SPEnterpriseSearchMetadataManagedProperty
Set-SPEnterpriseSearchMetadataManagedProperty


Remove-SPEnterpriseSearchMetadataMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a metadata mapping from a managed property.

Remove-SPEnterpriseSearchMetadataMapping [-Identity] <MappingPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.MappingPipeBind

Specifies the metadata mapping to delete.

The type must be a valid URL, in the form http://server_name, or an instance of a valid Mapping object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the managed property collection.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet deletes mappings from a managed property. A metadata mapping is the mapping between a managed property and one or more crawled properties in the enterprise search metadata property schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
$cat = Get-SPEnterpriseSearchMetadataCategory -SearchApplication $searchapp -Identity People
Copy code
$cp = Get-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Category $cat -Limit 1
Copy code
$mycp = New-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Name "MyCrawlProp" -PropSet $cp.PropSet -Category $cp.CategoryName -IsNameEnum $false -VariantType $cp.VariantType
Copy code
$mp = Get-SPEnterpriseSearchMetadataManagedProperty -SearchApplication $searchapp -Identity UserName
Copy code
New-SPEnterpriseSearchMetadataMapping -SearchApplication $searchapp -ManagedProperty $mp -CrawledProperty $mycp
Copy code
# Retrieve the new mapping
$map = Get-SPEnterpriseSearchMetadataMapping -SearchApplication $searchapp -ManagedProperty $mp -CrawledProperty $mycp
Copy code
Remove-SPEnterpriseSearchMetadataMapping -Identity $map -confirm:$false

This example removes an existing mapping between the managed property UserName and the crawled property MyCrawlProp (see Set-SPEnterpriseSearchMetadataMapping) for the default search service application.

See also

Get-SPEnterpriseSearchMetadataMapping
New-SPEnterpriseSearchMetadataMapping
Set-SPEnterpriseSearchMetadataMapping


Set-SPEnterpriseSearchMetadataCategory
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets properties of a crawled property category.

Set-SPEnterpriseSearchMetadataCategory [-Identity] <CategoryPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AutoCreateNewManagedProperties <Nullable>] [-Confirm [<SwitchParameter>]] [-DiscoverNewProperties <Nullable>] [-MapToContents <Nullable>] [-Name <String>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.CategoryPipeBind

Specifies the metadata category to update.

The type must be a valid name of a metadata category, for example, MetadataCategory1, or an instance of a valid Category object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AutoCreateNewManagedProperties

Optional

System.Nullable

Specifies that when a new crawled property in this category is found, a corresponding managed property is created and mapped to this new crawled property.

Note:Null indicates that the value is unchanged.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DiscoverNewProperties

Optional

System.Nullable

Specifies that if there are unknown properties in this category, these new properties are discovered during a crawl.

Note:Null indicates that the value is unchanged.

MapToContents

Optional

System.Nullable

Specifies that all crawled properties of type string are mapped to corresponding managed properties of this category.

Note:Null indicates that the value is unchanged.

Name

Optional

System.String

Specifies the name of the enterprise search metadata category.

The type must be a valid name of a metadata category, for example MetadataCategory1.

Note:Null indicates that the value is unchanged.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the enterprise search metadata categories.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet updates properties of a crawled property category when the search functionality is configured for the first time, and after a new crawled property category is discovered during a crawl. SPEnterpriseSearchMetadataCategory represents a category in the enterprise search metadata property schema.

Note that a category may represent multiple propsets. Changes to the category will overwrite all propsets.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
Set-SPEnterpriseSearchMetadataCategory -Identity People -SearchApplication $searchapp -DiscoverNewProperties $false -MapToContents $false

This example sets both DiscoverNewProperties and MapToContents properties to False for the People category for the default search service application.

See also

New-SPEnterpriseSearchMetadataCategory
Get-SPEnterpriseSearchMetadataCategory
Remove-SPEnterpriseSearchMetadataCategory


Set-SPEnterpriseSearchMetadataCrawledProperty
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets the properties of a metadata crawled property.

Set-SPEnterpriseSearchMetadataCrawledProperty [-Identity] <CrawledPropertyPipeBind> -IsMappedToContents <Nullable> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.CrawledPropertyPipeBind

Specifies the crawled property to update.

The type must be an instance of a valid CrawledProperty object.

IsMappedToContents

Required

System.Nullable

Specifies that the crawled property is mapped to managed properties. Specify true to map a crawled property to a managed property.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet updates properties of a crawled property when the search functionality is configured for the first time and after any new crawled property is added to create the rules for the crawled property. SPEnterpriseSearchMetadataCrawledProperty represents a crawled property in the enterprise search metadata property schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
$crawlprop = Get-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Name MyCrawlProp
Copy code
Set-SPEnterpriseSearchMetadataCrawledProperty -Identity $crawlprop -IsMappedToContent $true

This example sets the IsMappedToContent parameter of the crawled property MyCrawlProp to false (see the example for the New-SPEnterpriseSearchMetadataCrawledProperty command) for the default search service application.

See also

New-SPEnterpriseSearchMetadataCrawledProperty
Get-SPEnterpriseSearchMetadataCrawledProperty

VARIANT Type Constants (http://go.microsoft.com/fwlink/p/?LinkId=143322&clcid=0x409)


Set-SPEnterpriseSearchMetadataManagedProperty
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets the properties of a metadata managed property.

Set-SPEnterpriseSearchMetadataManagedProperty [-Identity] <ManagedPropertyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultForQueryIndependentRank <Nullable>] [-Description <String>] [-EnabledForQueryIndependentRank <Nullable>] [-EnabledForScoping <Nullable>] [-FullTextQueriable <Nullable>] [-IncludeInAlertSignature <Nullable>] [-IncludeInMd5 <Nullable>] [-Name <String>] [-NameNormalized <Nullable>] [-NoWordBreaker <Nullable>] [-RemoveDuplicates <Nullable>] [-RespectPriority <Nullable>] [-Retrievable <Nullable>] [-SafeForAnonymous <Nullable>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SiteCollection <Guid>] [-Tenant <Guid>] [-UserFlags <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ManagedPropertyPipeBind

Specifies the managed property to update.

The type must be a valid name of a managed property, for example, ManagedProperty1, or an instance of a valid ManagedProperty object

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultForQueryIndependentRank

Optional

System.Nullable

Specifies that the managed property is mandatory when it is used in query-independent rank (relevance).

Note:Null indicates that the value is unchanged.

Description

Optional

System.String

Adds a description to the metadata managed property.

The type must be a valid string.

Note: Null indicates that the value is unchanged.

EnabledForQueryIndependentRank

Optional

System.Nullable

Specifies that the managed property is mandatory when it is used in the custom ranking model for the query-independent work of ranking.

The type must be one of the following query-independent ranking features in the custom model XML:

  • queryIndependentFeature

  • categoryFeature

  • languageFeature

Note: Null indicates that the value is unchanged.

EnabledForScoping

Optional

System.Nullable

Specifies that the managed property can be used in a scope definition.

Note: Null indicates that the value is unchanged.

FullTextQueriable

Optional

System.Nullable

Specifies that the managed property can be used in enterprise search SQL queries.

Note: Null indicates that the value is unchanged.

IncludeInMd5

Optional

System.Nullable

Specifies that the managed property is included in the hash used by the crawler to determine whether a document has changed.

Note: Null indicates that the value is unchanged.

Name

Optional

System.String

Specifies a name for the managed property.

The type must be a valid managed property name, for example ManagedProperty1.

Note: Null indicates that the value is unchanged.

NameNormalized

Optional

System.Nullable

Specifies if the values of the managed property should be normalized, that is, enable to return results independent of letter casing and diacritics used in the query. If value is set to true, the values are normalized.

Note: Null indicates that the value is unchanged.

NoWordBreaker

Optional

System.Nullable

Specifies that the values for this managed property are processed by a word breaker.

Note: Null indicates that the value is unchanged.

RemoveDuplicates

Optional

System.Nullable

Specifies that duplicate values for the managed property are removed.

RespectPriority

Optional

System.Nullable

Specifies that when a mapped crawled property contains multiple values, and RespectPriority is set to true, only the first mapped crawled property is copied. Otherwise, all mapped crawled properties that have a value are copied.

Note: Null indicates that the value is unchanged.

Retrievable

Optional

System.Nullable

Specifies whether the values for this managed property are retrievable or not.

Note: Null indicates that the value is unchanged.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the managed property collection.

The type must be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

SiteCollection

Optional

System.Guid

Specifies that the managed properties returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the managed properties returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

UserFlags

Optional

System.Nullable

Reserved for future use.

Note: Null indicates that the value is unchanged.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet updates the properties of a managed property. It is typically used to change the name or description of a managed property. SPEnterpriseSearchMetadataManagedProperty represents a managed property in the enterprise search metadata property schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication
Copy code
Set-SPEnterpriseSearchMetadataManagedProperty -SearchApplication $searchapp -Identity UserName -EnabledForScoping $true

This example sets the EnabledForScoping property to true for the managed property named UserName in the default search service application.

See also

New-SPEnterpriseSearchMetadataManagedProperty
Get-SPEnterpriseSearchMetadataManagedProperty
Remove-SPEnterpriseSearchMetadataManagedProperty


Set-SPEnterpriseSearchMetadataMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets the properties of a managed property mapping for a search service application.

Set-SPEnterpriseSearchMetadataMapping [-Identity] <MappingPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-CrawledProperty <CrawledPropertyPipeBind>] [-ManagedProperty <ManagedPropertyPipeBind>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SiteCollection <Guid>] [-Tenant <Guid>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.MappingPipeBind

Specifies the metadata mapping to update.

The type must be a valid URL, in the form http://server_name, or an instance of a valid Mapping object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the metadata mapping.

The type be a valid search application name, for example, SearchApp1, or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CrawledProperty

Optional

Microsoft.Office.Server.Search.Cmdlet.CrawledPropertyPipeBind

Specifies the crawled property to map.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid URL in the form http://server_name, or an instance of a valid CrawledProperty object.

Note: Null indicates that the value is unchanged.

ManagedProperty

Optional

Microsoft.Office.Server.Search.Cmdlet.ManagedPropertyPipeBind

Specifies the managed property to receive the crawled property mapping.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a managed property, for example, ManagedProperty1, or an instance of a valid ManagedProperty object.

Note: Null indicates that the value is unchanged.

SiteCollection

Optional

System.Guid

Specifies that the metadata mappings returned are to be within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Tenant

Optional

System.Guid

Specifies that the metadata mappings returned are to be within the scope of a tenant.

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet updates properties of a managed property mapping. SPEnterpriseSearchMetadataMapping represents a mapping between a managed property and one or more crawled properties in the enterprise search metadata property schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication## get the crawl property to set to, in this case a new property is created$cat = Get-SPEnterpriseSearchMetadataCategory -SearchApplication $searchapp -Identity People$cp = Get-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Category $cat -Limit 1$ncp = New-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Name "MyNewCrawlProp" -PropSet $cp.PropSet -Category $cp.CategoryName -IsNameEnum $false -VariantType $cp.VariantType -IsMappedToContents $true## get the mapping to replace$mycp = Get-SPEnterpriseSearchMetadataCrawledProperty -SearchApplication $searchapp -Name MyCrawlProp$map = Get-SPEnterpriseSearchMetadataMapping -SearchApplication $searchapp -ManagedProperty $mp -CrawledProperty $mycp## set the new crawl property to map to for this mappingSet-SPEnterpriseSearchMetadataMapping -Identity $map -SearchApplication $searchapp -CrawledProperty $ncp

This example updates an existing mapping between the managed property UserName and the crawled property MyCrawlProp (see New-SPEnterpriseSearchMetadataMapping) for the default search service application. The crawled property is replaced with a new crawled property named MyNewCrawlProp.

See also

New-SPEnterpriseSearchMetadataMapping
Get-SPEnterpriseSearchMetadataMapping
Remove-SPEnterpriseSearchMetadataMapping

VARIANT Type Constants


Import-SPEnterpriseSearchTopology
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Imports and activates a topology from an XML file.

Import-SPEnterpriseSearchTopology -Filename <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Filename

Optional

System.String

Specifies the path and file name of the topology XML file to import.

The type must be a valid path, in the form MyFeature\Feature.xml.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application to which to apply the topology.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Import-SPEnterpriseSearchTopology cmdlet imports from an XML file the topology for a shared search application. The Export-SPEnterpriseSearchTopology cmdlet is used to save a search topology.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Import-SPEnterpriseSearchTopology -SearchApplication $ssa -Filename .\topology.xml

This example imports a topology from a file named topology.xml to the default search service application.

See also

New-SPEnterpriseSearchTopology
Get-SPEnterpriseSearchTopology
Set-SPEnterpriseSearchTopology
Remove-SPEnterpriseSearchTopology
Export-SPEnterpriseSearchTopology


Export-SPEnterpriseSearchTopology
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Saves an existing search topology.

Export-SPEnterpriseSearchTopology -Filename <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Filename

Required

System.String

Specifies the path and file name to use to create the topology XML file.

The type must be a valid path, in the form MyFeature\Feature.xml.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application with the topology to export.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Export-SPEnterpriseSearchTopology cmdlet exports the topology for a shared search application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Export-SPEnterpriseSearchTopology -SearchApplication $ssa -Filename topology.xml

This example exports the topology to a file named topology.xml in the search service application referenced by $ssa.

See also

New-SPEnterpriseSearchTopology
Get-SPEnterpriseSearchTopology
Set-SPEnterpriseSearchTopology
Remove-SPEnterpriseSearchTopology
Import-SPEnterpriseSearchTopology


Get-SPEnterpriseSearchLanguageResourcePhrase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a language resource phrase.

Get-SPEnterpriseSearchLanguageResourcePhrase [[-Identity] <LanguageResourcePhrasePipeBind>] -Owner <SearchObjectOwner> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Language <String>] [-Mapping <String>] [-SourceId <Guid>] [-Type <Nullable>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.LanguageResourcePhrasePipeBind

Specifies the language resource phrase to get.

The type must be a string; a valid name of a language resource phrase (for example, LanguageResourcePhrase1); or an instance of a valid LanguageResourcePhrase object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding LanguageResourcePhrase is created.

The owner must be one of the following valid levels:

- Search Service Application

- Site Subscription

- Site Collection

- Site

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the language resources.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Language

Optional

System.String

Filters to return phrases of a specified source language.

The type must be a valid name of a language; for example, en-us or ja-jp.

Mapping

Optional

System.String

Allows a term or phrase to be mapped to another term or phrase. For example, the nickname "John" could be mapped to "Jonathan".

This parameter only applies to nicknames and substitutions.

SourceId

Optional

System.Guid

Identifies the search result source for which the LanguageResourcePhrase applies to.

Type

Optional

System.Nullable

Filters to return phrases of a specified type.

The type must be one of the following valid types of phrases:

- QuerySuggestionBlockList

- QuerySuggestionAlwaysSuggest

- Nickname

- QuerySuggestionSubstitution

Detailed Description

The Get-SPEnterpriseSearchLanguageResourcePhrase cmdlet reads a LanguageResourcePhrase object when the language resource phrase is created or deleted.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1" Get-SPEnterpriseSearchLanguageResourcePhrase -SearchApplication $searchapp -Language en-us -Type QuerySuggestionBlockList

This example returns all language resource entries for the en-us language in the QuerySuggestionBlockList type.

See also

New-SPEnterpriseSearchLanguageResourcePhrase
Remove-SPEnterpriseSearchLanguageResourcePhrase


Get-SPEnterpriseSearchSiteHitRule
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the shared site hit rule.

Get-SPEnterpriseSearchSiteHitRule [[-Identity] <SiteHitRulePipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-SearchService <SearchServicePipeBind>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SiteHitRulePipeBind

Specifies the site hit rule to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, or an instance of a valid SiteHitRule object.

SearchService

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServicePipeBind

Specifies the search service that hosts the crawler with the specified shared site search rules.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchSiteHitRule cmdlet reads a SiteHitRule object when the site hit rule is created, updated, or deleted. A SiteHitRule object sets how many crawler sessions (threads) can simultaneously crawl the given site.

If the Identity parameter is not specified, this cmdlet returns the site hit rule collection for the specified search application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$shRule = Get-SPEnterpriseSearchSiteHitRule -Identity MySiteHitRule

The following example obtains a reference to the site hit rule with the name MySiteHitRule.


New-SPEnterpriseSearchLanguageResourcePhrase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds a language resource phrase to a shared search application.

New-SPEnterpriseSearchLanguageResourcePhrase [-Name] <String> -Language <String> -Owner <SearchObjectOwner> -SearchApplication <SearchServiceApplicationPipeBind> -Type <Nullable> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Mapping <String>] [-SourceId <Guid>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the term to add to the list specified in the Type parameter.

The type must be a valid name of a language resource phrase (for example, LanguageResourcePhrase1).

Language

Required

System.String

Adds the phrase for the specified source language.

The type must be a valid name of a language; for example, en-us or ja-jp.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding LanguageResourcePhrase is created.

The owner must be one of the following valid levels:

- Search Service Application

- Site Subscription

- Site Collection

- Site

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the language resources.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Type

Required

System.Nullable

Specifies the type of the new phrase.

The type must be one of the following valid types of phrases:

- QuerySuggestionBlockList

- QuerySuggestionAlwaysSuggest

- Nickname

- QuerySuggestionSubstitution

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Mapping

Optional

System.String

Allows a term or phrase to be mapped to another term or phrase. For example, the nickname "John" could be mapped to "Jonathan".

This parameter only applies to nicknames and substitutions.

SourceId

Optional

System.Guid

Identifies the search result source for which the LanguageResourcePhrase applies to.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchLanguageResourcePhrase cmdlet adds a query keyword phrase to a shared search application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1"New-SPEnterpriseSearchLanguageResourcePhrase -SearchApplication $searchapp -Language en-us -Type QuerySuggestionBlockList -Name secret

This example adds a new entry to the QuerySuggestionBlockList for the en-us language.

See also

Get-SPEnterpriseSearchLanguageResourcePhrase
Remove-SPEnterpriseSearchLanguageResourcePhrase


New-SPEnterpriseSearchSiteHitRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds a new site hit rule for a search application.

New-SPEnterpriseSearchSiteHitRule [-Name] <String> -Behavior <String> -HitRate <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchService <SearchServicePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SiteHitRulePipeBind

The name of the host to which the site hit rule should be applied.

Behavior

Required

System.String

Defines a rule to be followed when the farm's search service crawls the given site. If a value of zero is specified, the hit rate is the maximum number of simultaneous requests. If a value of 1 is specified, then hit rate is the number of seconds to delay between requests to the server.

HitRate

Required

System.String

Value to use for maximum requests or seconds of delay, according to behavior.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchService

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServicePipeBind

Specifies the search service in the farm that hosts the crawl.

The type must be an instance of a valid SearchService object; otherwise, the local service on the server that hosts the Windows PowerShell cmdlet will be used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchSiteHitRule cmdlet sets the maximum limits for crawling a site. The new site hit rule is used by all search service applications on the current farm.

Input Types

Return Types

Example

----------------EXAMPLE------------------

Copy code
New-SPEnterpriseSearchSiteHitRule -Identity myHost -Behavior 0 -HitRate 40

This example creates a new site hit rule on the myHost host that limits to 40 the number of simultaneous requests.

See also

Get-SPEnterpriseSearchSiteHitRule
Remove-SPEnterpriseSearchSiteHitRule


Remove-SPEnterpriseSearchLanguageResourcePhrase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a language resource phrase from a shared search application.

Remove-SPEnterpriseSearchLanguageResourcePhrase [-Identity] <LanguageResourcePhrasePipeBind> -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Language <String>] [-Mapping <String>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SourceId <Guid>] [-Type <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.LanguageResourcePhrasePipeBind

The language resource phrase to delete.

The type must be a string; a valid name of a language resource phrase (for example, LanguageResourcePhrase1); or an instance of a valid LanguageResourcePhrase object.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the corresponding LanguageResourcePhrase is created.

The owner must be one of the following valid levels:

- Search Service Application

- Site Subscription

- Site Collection

- Site

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Language

Optional

System.String

Deletes phrases of the specified language only.

The type must be a valid name of a language; for example, en_us.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the language resources.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

SourceId

Optional

System.Guid

Identifies the search result source for which the LanguageResourcePhrase applies to.

Type

Optional

System.Nullable

Constrains to delete phrases of specified type.

The type must be one of the following valid types of phrases:

- QuerySuggestionBlockList

- QuerySuggestionAlwaysSuggest

- Nickname

- QuerySuggestionSubstitution

Mapping

Optional

System.String

Allows a term or phrase to be mapped to another term or phrase. For example, the nickname "John" could be mapped to "Jonathan".

This parameter only applies to nicknames and substitutions.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchLanguageResourcePhrase cmdlet deletes one or more language resource phrases from the collection of language resource phrases in a shared search application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchapp = Get-SPEnterpriseSearchServiceApplication "SearchApp1"$obsoletephrase = Get-SPEnterpriseSearchLanguageResourcePhrase -SearchApplication $searchapp -Language en-us -Type QuerySuggestionBlockList -Identity secret$obsoletephrase | Remove-SPEnterpriseSearchLanguageResourcePhrase -SearchApplication $searchapp -Type QuerySuggestionBlockList -Language en-us

This example removes a language resource item on the QuerySuggestionBlockList for the en-us language.

See also

Get-SPEnterpriseSearchLanguageResourcePhrase
New-SPEnterpriseSearchLanguageResourcePhrase


Remove-SPEnterpriseSearchSiteHitRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Deletes a site hit rule.

Remove-SPEnterpriseSearchSiteHitRule [-Identity] <SiteHitRulePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchService <SearchServicePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SiteHitRulePipeBind

The rule that is used for the specified site.

The type must be a valid site hit rule host or an instance of a valid SiteHitRule object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchService

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServicePipeBind

Specifies the search service in the farm that hosts the crawl.

The type must be an instance of a valid SearchService object; otherwise, the local service on the server that hosts the Windows PowerShell cmdlet is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchSiteHitRule cmdlet deletes the site hit rule that controls the number of threads used to crawl a given site.

Input Types

Return Types

Example

------------------EXAMPLE-------------------

Copy code
Remove-SPEnterpriseSearchSiteHitRule -Identity myHost

This example removes a site hit rule for the myHost host.

See also

Get-SPEnterpriseSearchSiteHitRule
New-SPEnterpriseSearchSiteHitRule


Get-SPEnterpriseSearchVssDataPath
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Retrieves the index paths for all active search index components on the current server.

Get-SPEnterpriseSearchVssDataPath [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet retrieves the index paths for all active index components on the current server. This list is required as input by the Search VSS Writer in order to perform VSS backup of the current server. This cmdlet will typically be called from a VSS script, and rarely used directly.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
Get-SPEnterpriseSearchVssDataPath

This example gets the index paths for all active index components on the current server.


Backup-SPEnterpriseSearchServiceApplicationIndex
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Takes a backup of the search index to a specified backup location.

Backup-SPEnterpriseSearchServiceApplicationIndex [-Phase] <Int32> [-SearchApplication] <SearchServiceApplication> [-BackupFolder] <String> [-BackupHandleFile] <String> [[-Retries] <Int32>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Backup-SPEnterpriseSearchServiceApplicationIndex [-Abort] <SwitchParameter> [-SearchApplication] <SearchServiceApplication> [-BackupHandleFile] <String> [[-Retries] <Int32>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Phase

Required

System.Int32

Specifies the phase of the backup job.

SearchApplication

Required

Microsoft.Office.Server.Search.Administration.SearchServiceApplication

Name of the search service application to be backed up

BackupFolder

Required

System.String

Full UNC path of the backup files should be written.

BackupHandleFile

Required

System.String

Specifies a file handle for an ongoing backup job.

Retries

Optional

System.Int32

Number of times to retry if temporary failure occurs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

SearchApplication

Required

Microsoft.Office.Server.Search.Administration.SearchServiceApplication

Name of the search service application to be backed up

BackupHandleFile

Required

System.String

Specifies a file handle for an ongoing backup job.

Retries

Optional

System.Int32

Number of times to retry if temporary failure occurs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet will take a backup of the search index to a specified backup location. The cmdlet has to be run in two phases. Phase one will take a backup of what is present in the index at the time that the backup cmdlet is run. Phase two will take a differential backup of what was added to the index after you started the first phase index backup.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplicationBackup-SPEnterpriseSearchServiceApplicationIndex -Phase 1 -SearchApplication $ssa -BackupFolder "\\backuphost\backupfolder" -BackupHandleFile "\\backuphost\backupfolder\backuphandle.txt" -Retries 3

This example starts a Phase 1 backup of the search index for the default search application, and stores the backup at the location \\backuphost\backupfolder. The cmdlet stores a handle file backuphandle.txt that is used by the second phase cmdlet.

------------------EXAMPLE 2------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplicationBackup-SPEnterpriseSearchServiceApplicationIndex -Phase 1 $ssa -BackupFolder "\\backuphost\backupfolder" -BackupHandleFile "\\backuphost\backupfolder\backuphandle.txt" -Retries 3

This example checks the backup status and progress by re-running the cmdlet for Phase 1.

------------------EXAMPLE 3------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplicationBackup-SPEnterpriseSearchServiceApplicationIndex -Phase 2 -SearchApplication $ssa -BackupFolder "\\backuphost\backupfolder" -BackupHandleFile "\\backuphost\backupfolder\backuphandle.txt" -Retries 3

This example starts the Phase 2 of the search index backup by using the same backup location and backup handle file as used for Phase 1. The Search Service Application must be paused before the second phase can be started.


Get-SPEnterpriseSearchContentEnrichmentConfiguration
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the content enrichment configuration for the specified Search service application.

Get-SPEnterpriseSearchContentEnrichmentConfiguration -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the SearchServiceApplication that contains the ContentEnrichmentConfiguration.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet returns the ContentEnrichmentConfiguration object for the SearchServiceApplication.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchContentEnrichmentConfiguration -SearchApplication $ssa

This example retrieves the ContentEnrichmentConfiguration object from the default SearchServiecApplication.

See also

Set-SPEnterpriseSearchContentEnrichmentConfiguration
New-SPEnterpriseSearchContentEnrichmentConfiguration
Remove-SPEnterpriseSearchContentEnrichmentConfiguration
Get-SPEnterpriseSearchServiceApplication


Set-SPEnterpriseSearchPrimaryHostController
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets the primary search host controller for the farm.

Set-SPEnterpriseSearchPrimaryHostController [-SearchServiceInstance] <SearchServiceInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SearchServiceInstance

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

SearchServiceInstance of the server from where the SearchHostController object is returned.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Force the change of the primary SearcHostController. No confirmation messages are asked, even if user tries to set primary to a SearchHostController not running the latest version of the repository.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet sets the primary SearchHostController for the farm to the defined SearchHostController.

The SearchHostController is related to the SearchServiceInstance, where the SearchHostController manages the search components that run on a server, and maintains a local repository for linguistic dictionaries. The search components retrieve the linguistic dictionaries from the PrimaryHostController.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssi = Get-SPEnterpriseSearchServiceInstance -Local
Set-SPEnterpriseSearchPrimaryHostController $ssi

This example sets the local SearchHostController instance as the new primary SearchHostController. It is up to the user to select the HostController with latest version available. If you choose a SearchHostController that is not running the latest version of the repository, you will have to confirm before you continue.

------------------EXAMPLE 2------------------

Copy code
$ssi = Get-SPEnterpriseSearchServiceInstance -Local
Set-SPEnterpriseSearchPrimaryHostController $ssi -Force

This example sets the local SearchHostController instance as the new primary SearchHostController. If you choose a SearchHostController that is not running the latest version of the repository, you will not get a confirmation message before you continue.

See also

Get-SPEnterpriseSearchServiceInstance


Set-SPEnterpriseSearchLinguisticComponentsStatus
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets the operation status of the linguistic query and document processing components.

Set-SPEnterpriseSearchLinguisticComponentsStatus [[-Identity] <LinguisticComponentsStatusPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AllEnabled <Nullable>] [-AssignmentCollection <SPAssignmentCollection>] [-EntityExtractionEnabled <Nullable>] [-QuerySpellingEnabled <Nullable>] [-StemmingEnabled <Nullable>] [-ThesaurusEnabled <Nullable>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.LinguisticComponentsStatusPipeBind

An object that represents the current status of the linguistic components.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the linguistic processing components.

AllEnabled

System.Nullable

A Boolean value to enable or deactivate all linguistic functionalities.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

EntityExtractionEnabled

Optional

System.Nullable

A Boolean value to enable or deactivate the company extractor and all custom extractors during document processing.

QuerySpellingEnabled

Optional

System.Nullable

A Boolean value to enable or deactivate query spelling correction.

StemmingEnabled

Optional

System.Nullable

A Boolean value to enable or deactivate expansive stemming during query processing.

ThesaurusEnabled

Optional

System.Nullable

A Boolean value to enable or deactivate thesaurus lookup during query processing.

Detailed Description

This cmdlet sets the operational status of the linguistic query and document processing components.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplicationSet-SpEnterpriseSearchLinguisticComponentsStatus -SearchApplication $searchApp -StemmingEnabled $false

This example shows how to disable stemming during query processing by setting the parameter StemmingEnabled to false.

------------------EXAMPLE 2-----------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplicationSet-SpEnterpriseSearchLinguisticComponentsStatus -SearchApplication $searchApp -AllEnabled $false

This example shows how to disable all linguistic query and document processing functionalities.

See also

Get-SPEnterpriseSearchLinguisticComponentsStatus


Set-SPEnterpriseSearchContentEnrichmentConfiguration
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Stores the specified content enrichment configuration to the Search service application.

Set-SPEnterpriseSearchContentEnrichmentConfiguration -ContentEnrichmentConfiguration <ContentEnrichmentConfigurationPipeBind> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ContentEnrichmentConfiguration

Required

Microsoft.Office.Server.Search.Cmdlet.PipeBind.ContentEnrichmentConfigurationPipeBind

Specifies the ContentEnrichmentConfiguration that should be stored in the SearchServiceApplication.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the SearchServiceApplication that contains the ContentEnrichmentConfiguration.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet validates the ContentEntrichmentConfiguration object and stores the provided configuration in the SearchServiceApplication. Both a ContentEnrichmentConfiguration and a SearchServiceApplication object have to be provided.

Input Types

Return Types

Example

------------------EXAMPLE 1 ------------------

Copy code
$config = New-SPEnterpriseSearchContentEnrichmentConfiguration$config.Endpoint = "http://server/service"$config.InputProperties = "Title", "Url"$config.OutputProperties = "Title", "Url"$ssa = Get-SPEnterpriseSearchServiceApplicationSet-SPEnterpriseSearchContentEnrichmentConfiguration -SearchApplication $ssa -ContentEnrichmentConfiguration $config

This example creates a new ContentEnrichmentConfiguration object. The URL of the external web service is stored in the $config.Endpoint property. The new ContentEnrichmentConfiguration is configured to use Title and URL, which are the managed properties that you want to send to the external web service. It is also configured to expect the external web service to output the same managed properties. The SearchServiceApplication object is retrieved, and used for storing the newly created ContentEnrichmentConfiguration.

------------------EXAMPLE 2 ------------------

Copy code
$config = New-SPEnterpriseSearchContentEnrichmentConfiguration
Copy code
$config.Endpoint = "http://server/service"$config.InputProperties = "Title"$config.OutputProperties = "Title"$config.Trigger = 'Contains(Title, "Example")'
Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Set-SPEnterpriseSearchContentEnrichmentConfiguration -SearchApplication $ssa -ContentEnrichmentConfiguration $config

This example creates a new ContentEnrichmentConfiguration object. The URL of the external web service is stored in the $config.Endpoint property. The new ContentEnrichmentConfiguration is configured to use Title, which is the managed property that you want to send to the external web service. It is also configured to expect the external web service to output the same managed property. The $config.Trigger is set to only send the managed property when the Boolean trigger expression is true, in this case when the managed property Title contains the string "Example". The SearchServiceApplication object is retrieved, and used for storing the newly created ContentEnrichmentConfiguration.

See also

Get-SPEnterpriseSearchContentEnrichmentConfiguration
New-SPEnterpriseSearchContentEnrichmentConfiguration
Remove-SPEnterpriseSearchContentEnrichmentConfiguration


Remove-SPEnterpriseSearchContentEnrichmentConfiguration
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes the current content enrichment configuration from the Search service application.

Remove-SPEnterpriseSearchContentEnrichmentConfiguration -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the SearchServiceApplication that contains content enrichment configuration.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet removes the current content enrichment configuration from the SearchServiceApplication.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Remove-SPEnterpriseSearchContentEnrichmentConfiguration -SearchApplication $ssa

This example removes the content enrichment configuration from the default Search service application.

See also

Get-SPEnterpriseSearchContentEnrichmentConfiguration
Set-SPEnterpriseSearchContentEnrichmentConfiguration
New-SPEnterpriseSearchContentEnrichmentConfiguration
Get-SPEnterpriseSearchServiceApplication


New-SPEnterpriseSearchContentEnrichmentConfiguration
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new ContentEnrichmentConfiguration object.

New-SPEnterpriseSearchContentEnrichmentConfiguration [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet creates a new ContentEnrichmentConfiguration object that the user can change.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$config = New-SPEnterpriseSearchContentEnrichmentConfiguration

This example creates a new ContentEnrichmentConfiguration object.

See also

Get-SPEnterpriseSearchContentEnrichmentConfiguration
Set-SPEnterpriseSearchContentEnrichmentConfiguration
Remove-SPEnterpriseSearchContentEnrichmentConfiguration


Import-SPEnterpriseSearchPopularQueries
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Imports queries from a comma-separated list. The search box will suggest these queries as users type.

Import-SPEnterpriseSearchPopularQueries -ResultSource <Source> -SearchApplicationProxy <SearchServiceApplicationProxyPipeBind> -Web <SPWeb> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Filename <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ResultSource

Required

Microsoft.Office.Server.Search.Administration.Query.Source

Specifies the Result Source to associate with the imported queries. The type must be an instance of a valid Source object.

SearchApplicationProxy

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationProxyPipeBind

Specifies the proxy for the search application to which the queries file should be imported. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application proxy name (for example, SearchAppProxy1); or an instance of a valid SearchServiceApplicationProxy object.

Web

Required

Microsoft.SharePoint.SPWeb

Specifies the SPWeb to associate with the imported queries. The type must be an instance of a valid SPWeb object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filename

Optional

System.String

Specifies the full UNC (Universal Naming Convention) path of the file to import.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Import-SPEnterpriseSearchPopularQueries cmdlet imports queries from a comma-separated list. As the user types a query in the search box, the search box will suggest queries from the comma-separated list. The search box bases these suggestions on:

- The SPWeb the search box is located on.

- The Result Source configured on the search box.

For example, if the search box is located on the "Engineering" SPWeb, the suggested queries will differ from if the search box is located on the "Management" SPWeb. Likewise, if the Result Source on the search box is "Local SharePoint Results", the suggested queries will differ from if the Result Source is "Conversations".

The comma-separated list must consist of one line per query, where each line contains the following items:

Query Text. The actual query expression.

Query Count. The number of times this query was executed.

Click Count. The number of times any user clicked any result for this query.

LCID. The locale identifier (LCID) for the language of the query.

Each line must use the formatting: Query Text,Query Count,Click Count,LCID. For example, Company store,100,80,1033. For suggestions to appear in the search box, the Click Count value must be more than five. The search box ranks query suggestions by their Click Count values (approximately).

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$ssap = Get-SPEnterpriseSearchServiceApplicationProxy
Copy code
$hostname = hostname
Copy code
$web = get-spsite | get-spweb | where {$_.Url-eq "http://$hostname"}
Copy code
$owner = new-object Microsoft.Office.Server.Search.Administration.SearchObjectOwner -ArgumentList @([Microsoft.Office.Server.Search.Administration.SearchObjectLevel]::SPWeb,$web)
Copy code
$mgr = new-object Microsoft.Office.Server.Search.Administration.Query.FederationManager -ArgumentList $ssap
Copy code
$source = $mgr.GetSourceByName("Local SharePoint Results", $owner)
Copy code
Import-SPEnterpriseSearchPopularQueries -SearchApplicationProxy $ssap -Filename C:\input.txt -ResultSource $source -Web $web

This example uses the Import-SPEnterpriseSearchPopularQueries cmdlet to import the queries file that is named C:\input.txt and associate with it the Result Source referenced by $source and the SPWeb referenced by $web. The example defines the variable $web as the SPWeb with URL http://hostname, and the variable $source as the Result Source named "Local SharePoint Results" at the SPWeb referenced by $web.


Get-SPEnterpriseSearchStatus
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Retrieves diagnostics information for the search components.

Get-SPEnterpriseSearchStatus -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Component <String>] [-Constellation <SwitchParameter>] [-Detailed <SwitchParameter>] [-DetailSearchRuntime <SwitchParameter>] [-HealthReport <SwitchParameter>] [-JobStatus <SwitchParameter>] [-Primary <SwitchParameter>] [-Text <SwitchParameter>]

Parameters

Parameter Required Type Description

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the search components.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Component

Optional

System.String

Specifies the name of the search component. This parameter is only used in association with the HealthReport and Primary parameter.

Constellation

Optional

System.Management.Automation.SwitchParameter

Specifies if internal diagnostic information for the search topology should be provided. This parameter should only be used for debugging.

Detailed

Optional

System.Management.Automation.SwitchParameter

Specifies the level of detail for the HealthReport parameter. When this parameter is used, the cmdlet will also output verbose diagnostic information.

DetailSearchRuntime

Optional

System.Management.Automation.SwitchParameter

Specifies if internal diagnostic information for the search runtime should be provided. This parameter should only be used for debugging.

HealthReport

Optional

System.Management.Automation.SwitchParameter

Specifies if diagnostic information for the search component should be provided. When using this parameter, you must specify the component name using the Component parameter.

JobStatus

Optional

System.Management.Automation.SwitchParameter

Specifies if status information for the Search Analytics and Usage Analytics timer jobs should be provided.

Primary

Optional

System.Management.Automation.SwitchParameter

Specifies if the Admin component has the Primary role. When using this parameter, you must specify the component name using the Component parameter. Returns true if the Admin Component has the Primary role.

Text

Optional

System.Management.Automation.SwitchParameter

Specifies if the print output from this cmdlet should be outputted in a format that is convenient for reading. If not used, this cmdlet outputs a SearchStatusInfo object.

When using this parameter, the output is printed to the console and cannot be piped to a file or another program.

Detailed Description

This cmdlet retrieves diagnostic information for all or specified search components in the active topology of a Search Service Application.

If you don't specify any of the optional parameters, the cmdlet will retrieve the health status of all the search components within the Search Service Application. Each search component will have one of the following states:

  • Active: The search component is running OK

  • Degraded: The search component is in a status where it cannot perform all operations correctly. The reason for the degraded status is typically a transient situation related to a restart or network issues.

  • Failed: The search component is not running. This status indicated that the component cannot perform operations correctly.

  • Unknown: The component can't be reached. The reason for the unknown status is typically hardware or communication issues.

If you have defined more than one Index component for a partition in your search topology, this cmdlet will indicate which index component that has the Primary role for this partition.

You can use the cmdlet to output the following additional information:

  • List the status of background activities (batch jobs) initiated by the search components

  • List detailed diagnostic information for the index component

  • Debug information that may be used by Microsoft for detailed issue resolution

If you don't want to iterate over the output in a script, use the Text parameter. If you do not use the Text parameter, the cmdlet will output a set of objects that have the following properties:

  • string Name: the name of a search component, a health report item or a constellation property

  • string State: the status of the search component

  • string Level: when you are using the HealthReport parameter, this property indicates the importance level of each health report item (Error, Warning, Info, Verbose)

  • string Message: additional information that is provided as a text string

  • ReadOnlyDictionary<string,string>Details: dictionary name/value pairs that provide additional diagnostic information

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchStatus -Text

This example retrieves diagnostics information about all search components of the default Search Service Application.

------------------EXAMPLE 2------------------

Copy code
Get-SPEnterpriseSearchStatus -SearchApplication "Search Service Application" -JobStatus -Text

This example retrieves the background activity job status for the search analytics timer jobs.

------------------EXAMPLE 3------------------

Copy code
Get-SPEnterpriseSearchServiceApplication | Get-SPEnterpriseSearchStatus -HealthReport -Component IndexComponent1 -Text

This example retrieves the diagnostic information for the index component named IndexComponent1.


Get-SPEnterpriseSearchPropertyRuleCollection
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the collection of rules that are applied to search results.

Get-SPEnterpriseSearchPropertyRuleCollection [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchPropertyRuleCollection cmdlet returns the collection of rules that are applied to search results. Rules can be added and removed from the rule collection.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$rule = Get-SPEnterpriseSearchPropertyRule -PropertyName "ContentTypeId" -Operator "StartsWith"$rule.AddValue( "0x010063C2F478ACC511DFB869B5BFDFD720851252" )$ruleCollection = Get-SPEnterpriseSearchPropertyRuleCollection$ruleCollection.Add( $rule )

This example returns a rule for the result property "ContentTypeId", the rule specifies that this property must start with the value "0x010063C2F478ACC511DFB869B5BFDFD720851252". Thereafter the example returns the rule collection, and adds the rule to the rule collection.

See also

Get-SPEnterpriseSearchPropertyRule


Get-SPEnterpriseSearchPropertyRule
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns a property rule instance, which can be used in result item types.

Get-SPEnterpriseSearchPropertyRule [-PropertyName] <String> [-Operator] <IsEqual | NotEqual | Contains | NotContains | LessThan | GreaterThan | StartsWith> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

PropertyName

Required

System.String

Specifies the name of the property that the rule concerns.

Operator

Required

Microsoft.Office.Server.Search.Administration.PropertyRuleOperator+DefaultOperator

Specifies the operation to apply to the property, for example "Starts with".

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchPropertyRule cmdlet returns an instance of a property rule, given the specified condition. The value for the condition is set in a separate step. Such a rule can be used in result item types, to group the results based on the condition of a result property.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$rule = Get-SPEnterpriseSearchPropertyRule -PropertyName "ContentTypeId" -Operator "StartsWith"$rule.AddValue( "0x010063C2F478ACC511DFB869B5BFDFD720851252" )

This example returns a rule for the property "ContentTypeId", where the condition is that the property shall start with a specific value. The second step specifies the value that the property shall start with.

See also

Get-SPEnterpriseSearchPropertyRuleCollection


Get-SPEnterpriseSearchLinguisticComponentsStatus
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Returns the status of the linguistic query and document processing components.

Get-SPEnterpriseSearchLinguisticComponentsStatus [[-Identity] <LinguisticComponentsStatusPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.LinguisticComponentsStatusPipeBind

An object that represents the current status of the linguistic components.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the linguistic processing components.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet returns an object that represents the operational status of the linguistic query and document processing components.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplicationGet-SpEnterpriseSearchLinguisticComponentsStatus -SearchApplication $searchApp

This example gets the current status of the linguistic query and document processing components from the default SearchServiceApplication.

See also

Set-SPEnterpriseSearchLinguisticComponentsStatus
Get-SPEnterpriseSearchServiceApplication


Get-SPEnterpriseSearchHostController
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Lists the specified or all search host controllers in the farm.

Get-SPEnterpriseSearchHostController [-AssignmentCollection <SPAssignmentCollection>] [-SearchServiceInstance <SearchServiceInstancePipeBind>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SearchServiceInstance

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

SearchServiceInstance of the server from where the SearchHostController object is returned.

Detailed Description

This cmdlet lists the specified or all SearchHostControllers in the farm. The SearchHostController is related to the SearchServiceInstance, where the SearchHostController manages the search components that run on a server, and maintains a local repository for linguistic dictionaries. The search components retrieve the linguistic dictionaries from the PrimaryHostController.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Get-SPEnterpriseSearchHostController

This example retrieves a list of all HostControllers in the farm with their status (primary/secondary) and repository version.

------------------EXAMPLE 2------------------

Copy code
$ssi = Get-SPEnterpriseSearchServiceInstance -Local
Copy code
Get-SPEnterpriseSearchHostController -SearchServiceInstance $ssi

This example retrieves the status information for the SearchHostController on the local server.

See also

Get-SPEnterpriseSearchServiceInstance


Upgrade-SPEnterpriseSearchServiceApplicationSiteSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Upgrades search settings for a particular site collection.

Upgrade-SPEnterpriseSearchServiceApplicationSiteSettings -Identity <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection for which to upgrade search settings. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Upgrade-SPEnterpriseSearchServiceApplicationSiteSettings cmdlet to upgrade the search settings for specified site collection from 2010 to 2013 experience. The upgrades include conversion of best bets to query rules.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$site= Get-SPSite http://test
Copy code
Upgrade-SPEnterpriseSearchServiceApplicationSiteSettings -Identity $site

This example upgrades the search settings for the site collection referenced by $site.

See also

Remove-SPEnterpriseSearchServiceApplicationSiteSettings


Set-SPEnterpriseSearchTopology
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Activates a given search topology.

Set-SPEnterpriseSearchTopology [-Identity] <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology to enable.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application to which the search topology will belong.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet enables the search topology with the given identity, marking the currently active search topology as inactive.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
$topology = Get-SPEnterpriseSearchTopology -SearchApplication $ssa -Identity 10fa59cb-4b32-4fe6-8f8d-065388df201e
Copy code
Set-SPEnterpriseSearchTopology -Identity $topology

This example enables a search topology with the Identity 10fa59cb-4b32-4fe6-8f8d-065388df201e.

------------------EXAMPLE 2------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Set-SPEnterpriseSearchTopology -Identity $topo -SearchApplication $ssa

This example enables the search topology referenced by $topo in the search service application referenced by $ssa.

See also

Get-SPEnterpriseSearchTopology
New-SPEnterpriseSearchTopology
Remove-SPEnterpriseSearchTopology
Export-SPEnterpriseSearchTopology
Import-SPEnterpriseSearchTopology


Set-SPEnterpriseSearchResultItemType
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets properties of a result item type.

Set-SPEnterpriseSearchResultItemType [-Identity] <ResultItemTypePipeBind> -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DisplayProperties <String>] [-DisplayTemplateUrl <String>] [-Name <String>] [-OptimizeForFrequentUse <Nullable>] [-RulePriority <Nullable>] [-Rules <PropertyRuleCollection>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SearchApplicationProxy <SearchServiceApplicationProxyPipeBind>] [-SourceID <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ResultItemTypePipeBind

Specifies the result item type to update. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the result item type was created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DisplayProperties

Optional

System.String

Specifies which result properties to display.

DisplayTemplateUrl

Optional

System.String

Specifies the URL of the display template that shall be used for rendering the results.

Name

Optional

System.String

Specifies the name of the result item type.

OptimizeForFrequentUse

Optional

System.Nullable

??

RulePriority

Optional

System.Nullable

Specifies which priority the collection of rules has compared to other rules.

Rules

Optional

Microsoft.Office.Server.Search.Administration.PropertyRuleCollection

Specifies the collection of rules to evaluate the result properties against.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the name of the search application. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

SearchApplicationProxy

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationProxyPipeBind

Specifies the proxy of the search application that contains the result item type. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application proxy name (for example, SearchAppProxy1); or an instance of a valid SearchServiceApplicationProxy object.

SourceID

Optional

System.Nullable

Identifies the search result source that the result item type applies to.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPEnterpriseSearchResultItemType cmdlet sets properties of user-created result item types. You cannot use this cmdlet to set or change properties of the built-in result item types that are included with SharePoint products.

Result item types enable you to change the look of search results based on the type of result. You start by defining a collection of rules, which will be evaluated against the properties of results. Then you define the display template to use for rendering that type of result. Once you have created the result item type, results matching the rules of the result item type will render using the specified display template.

Example use cases:

  • Change the look of results for a particular file name extension, for example Word documents.

  • Change the look of a particular content type in search results.

  • Change the look of results from a particular author.

  • Add a result action to results from a particular result source as part of a custom search application.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$web = Get-SPWeb "UrlOfTheSite"$tenantOwner = Get-SPEnterpriseSearchOwner -Level SPSite -SPWeb $web$searchapp = Get-SPEnterpriseSearchServiceApplication$resultType = Get-SPEnterpriseSearchResultItemType -Owner $tenantOwner -SearchApplication $searchapp$resultType.BuiltIn$rule = Get-SPEnterpriseSearchPropertyRule -PropertyName "ContentTypeId" -Operator "StartsWith"$rule.AddValue( "0x010063C2F478ACC511DFB869B5BFDFD720851252" )$ruleCollection = Get-SPEnterpriseSearchPropertyRuleCollection$ruleCollection.Add( $rule )$displayProperties = "WorkId,Rank,Title,Size,Path,Description,SiteName,HitHighlightedSummary,HitHighlightedProperties,ViewsLifeTime"$displaytemplateUrl = "~sitecollection/_catalogs/masterpage/Display Templates/Search/Item_MyCustomDisplayTemplate.js"Set-SPEnterpriseSearchResultItemType -Identity $resultType `-SearchApplication $searchapp `-Name "CustomResultType" `-Rules $ruleCollection `-RulePriority 1 -DisplayProperties $displayProperties `-DisplayTemplateUrl $displaytemplateUrl `-Owner $tenantOwner

This example first defines variables for the URL of the site, the search owner, and search application. It retrieves the result item type and checks whether the result item type is a built-in result item type. If $resultType.BuiltIn returns false then the result item type is not built-in and you can set its properties by using the Set-SPEnterpriseSearchResultItemType.

Next, the example creates the rule that result item types shall be matched against, and adds it to a property rule collection.

Next, the example defines which properties of the result item type that shall be displayed and the display template to use.

Finally, the example uses the Set-SPEnterpriseSearchResultItemType cmdlet to modify the result item type.

See also

New-SPEnterpriseSearchResultItemType
Get-SPEnterpriseSearchResultItemType
Remove-SPEnterpriseSearchResultItemType
Get-SPEnterpriseSearchOwner
Get-SPEnterpriseSearchPropertyRule
Get-SPEnterpriseSearchPropertyRuleCollection


Set-SPEnterpriseSearchQuerySpellingCorrection
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets the operation status of the Query Spelling Corrections (QSC) component.

Set-SPEnterpriseSearchQuerySpellingCorrection [[-Identity] <QuerySpellingCorrectionPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-ContentAlignmentEnabled <Nullable>] [-DiacriticsInSuggestionsEnabled <Nullable>] [-MaxDictionarySize <Nullable>] [-MaxProcessingTime <Nullable>] [-SecurityTrimmingEnabled <Nullable>] [-SpellingDictionary <Nullable>] [-TermFrequencyThreshold <Nullable>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.QuerySpellingCorrectionPipeBind

Specifies an object that represents the current status for the query spelling correction.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the QSC components.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ContentAlignmentEnabled

Optional

System.Nullable

A Boolean value to enable or deactivate the content alignment process.

DiacriticsInSuggestionsEnabled

Optional

System.Nullable

A switch to enable or disable spelling suggestions that contain diacritics (for example, German umlaut). The default setting is true.

MaxDictionarySize

Optional

System.Nullable

Specifies the maximal number of terms in a content-aligned spelling dictionary. In a multi-tenant environment, this number is valid per tenant.

MaxProcessingTime

Optional

System.Nullable

Specifies the maximum runtime for compiling a content-aligned spelling dictionary. The default value is 6 hours.

SecurityTrimmingEnabled

Optional

System.Nullable

A Boolean value to enable or disable the security check for spelling suggestions. If enabled, only spelling suggestions that deliver at least one document for the current user are shown.

SpellingDictionary

Optional

System.Nullable

Specifies the dictionary to be used for query spelling correction. The two available values are dynamic and static. When value is set to dynamic, the query spelling correction uses the content-aligned dictionary. When value is set to static, the query spelling correction uses the out of the box static spelling dictionaries.

TermFrequencyThreshold

Optional

System.Nullable

Specifies the minimum number of documents that must contain the most frequently used term in the document collection for the content-alignment process to be executed. In a multi-tenant environment, this number is valid per tenant.

Detailed Description

This cmdlet provides access to the configuration options for the QSC component. The two most prominent configuration options are the switch to enable the content-alignment process, and the selection of dictionaries to be used for query spelling correction, that is the set of fixed dictionaries per language or the dynamic dictionary that is being produced by the content alignment process.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication
Copy code
Set-SpEnterpriseSEarchQuerySpellingCorrection -SearchApplication $searchApp -SpellingDictionary dynamic

This example sets the dictionary named dynamic to be used for query spelling correction for the default search service application.


Set-SPEnterpriseSearchLinksDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Sets properties of a links database for a search service application.

Set-SPEnterpriseSearchLinksDatabase [-Identity] <LinksStorePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.LinksStorePipeBind

Specifies the links database to modify. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a LinksStore object, in the form LinksStore1; or an instance of a valid LinksStore object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseName

Optional

System.String

Specifies the links database name.

DatabasePassword

Optional

System.Security.SecureString

Specifies the password of the account to connect to the database.

DatabaseServer

Optional

System.String

Specifies the server to use for the host SQL database.

DatabaseUsername

Optional

System.String

Specifies the name of the account to connect to the database.

FailoverDatabaseServer

Optional

System.String

Specifies the server to use for failover when using SQL Server mirroring.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the links database. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Detailed Description

The Set-SPEnterpriseSearchLinksDatabase cmdlet sets properties of a specified links database for a search service application. A links database stores query logging and analytics information.

Input Types

Return Types

Example

---------EXAMPLE---------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication mySearchServiceAppSet-SPEnterpriseSearchLinksDatabase -Identity SearchApp_LinksStore -SearchApplication $searchApp -FailoverDatabaseServer \\failoverServer

This example sets the failover database server to \\failoverServer for the links database SearchApp_LinksStore in the search service application mySearchServiceApp.

See also

New-SPEnterpriseSearchLinksDatabase
Get-SPEnterpriseSearchLinksDatabase
Remove-SPEnterpriseSearchLinksDatabase

Move-SPEnterpriseSearchLinksDatabases


Set-SPEnterpriseSearchCrawlLogReadPermission
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Grants users permission to view the crawl log information.

Set-SPEnterpriseSearchCrawlLogReadPermission [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Identity <CrawlLogReadPermissionPipeBind>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-Tenant <Guid>] [-UserNames <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.CrawlLogReadPermissionPipeBind

Specifies the crawl log permissions list to which users should be added.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl log. The type must be a valid GUID, of the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Tenant

Optional

System.Guid

Specifies that the users shall be added to the crawl log permissions list within the scope of this tenant only. The type must be a valid GUID of the form 12345678-90ab-cdef-1234-567890bcdefgh.

UserNames

Optional

System.String

Specifies the user names that shall be granted permission to view the crawl log information Use "domain\username" or "username". When adding several user names, separate names with semi-colons.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Only the Search Service Application administrator can use this cmdlet.

The administrator uses the Set-SPEnterpriseSearchCrawlLogReadPermission cmdlet to grant users permission to view crawl log information. The administrator can choose to restrict the permission to crawl log information from a particular tenant.

Input Types

Return Types

Example

--------EXAMPLE --------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication$crawlLogPermission = Get-SPEnterpriseSearchCrawlLogReadPermission -SearchApplication $ssa -Tenant "00000000-0000-0000-0000-000000000001"Set-SPEnterpriseSearchCrawlLogReadPermission -Identity $crawlLogPermission -SearchApplication $ssa -UserNames "user1;user2" -Tenant "00000000-0000-0000-0000-000000000001"

This example first defines $crawlLogPermission, which is the list of users who have permission to view the crawl log information from the tenant with id "00000000-0000-0000-0000-000000000001" on the search application referenced by $ssa. Then the example uses the Set-SPEnterpriseSearchCrawlLogReadPermission cmdlet to add user1 and user2 to the list of users referenced by $crawlLogPermission.

See also

Get-SPEnterpriseSearchCrawlLogReadPermission
Remove-SPEnterpriseSearchCrawlLogReadPermission


Restore-SPEnterpriseSearchServiceApplicationIndex
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Restores the search index from the specified backup files.

Restore-SPEnterpriseSearchServiceApplicationIndex [-SearchApplication] <SearchServiceApplication> [-Handle] <String> [[-Retries] <Int32>] [[-RetryPauseSeconds] <Int32>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Restore-SPEnterpriseSearchServiceApplicationIndex [-SearchApplication] <SearchServiceApplication> [-BackupFolder] <String> [[-AllReplicas] <SwitchParameter>] [[-AllowMove] <SwitchParameter>] [[-Retries] <Int32>] [[-RetryPauseSeconds] <Int32>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

SearchApplication

Required

Microsoft.Office.Server.Search.Administration.SearchServiceApplication

Specifies the search service application that contains the index files that should be restored.

Handle

Required

System.String

A handle returned from an initial call using Parameter set 1.

Retries

Optional

System.Int32

Specifies the number of times to retry if temporary failure occurs.

RetryPauseSeconds

Optional

System.Int32

Seconds to pause between retries if temporary failure occurs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

SearchApplication

Required

Microsoft.Office.Server.Search.Administration.SearchServiceApplication

Specifies the search service application that contains the index files that should be restored.

BackupFolder

Required

System.String

Specifies the full file path of the backup files.

AllReplicas

Optional

System.Management.Automation.SwitchParameter

Specifies a switch to restore all replicas, not just the primary.

AllowMove

Optional

System.Management.Automation.SwitchParameter

Specifies a switch to move instead of copying files when restoring. Moving may be faster than copying.

Retries

Optional

System.Int32

Specifies the number of times to retry if temporary failure occurs.

RetryPauseSeconds

Optional

System.Int32

Seconds to pause between retries if temporary failure occurs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

This cmdlet will clear the complete search index for a specified search service application and replace it with the search index from the specified backup files.

This cmdlet supports parameter sets. The first set of parameters is for Application Configuration Attach mode and the second set of parameters is for Search Application Attach mode.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication$handle = Restore-SPEnterpriseSearchServiceApplicationIndex -SearchApplication $ssa -BackupFolder "\\sample\backup\spbr0000"Restore-SPEnterpriseSearchServiceApplicationIndex -SearchApplication $ssa -Handle $handle

This example starts a restore of the search index in the default search service application from a backup located at \\sample\backup\spbr0000.

------------------EXAMPLE 2------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplicationRestore-SPEnterpriseSearchServiceApplicationIndex -SearchApplication $ssa -Handle $handle

This example checks the status of the running job to restore of the search index in the search service application Search Service Application with the handle $handle .


Remove-SPEnterpriseSearchTopology
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Removes an inactive search topology from a search service application.

Remove-SPEnterpriseSearchTopology [-Identity] <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology to retrieve.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application to which the search topology belongs.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet removes the given inactive search topology from the search service application to which it belongs.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
$topology = Get-SPEnterpriseSearchTopology -SearchApplication $ssa -Identity 4b32-4fe6-8f8d-065388df201e
Copy code
Remove-SPEnterpriseSearchTopology -Identity $topology

This example removes a search topology with the identity 4b32-4fe6-8f8d-065388df201e.

------------------EXAMPLE 2------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Remove-SPEnterpriseSearchTopology -Identity $topo -SearchApplication $ssa

This example removes the search topology referenced by $topo in the search service application referenced by $ssa.

See also

Get-SPEnterpriseSearchTopology
New-SPEnterpriseSearchTopology
Set-SPEnterpriseSearchTopology
Export-SPEnterpriseSearchTopology
Import-SPEnterpriseSearchTopology


Remove-SPEnterpriseSearchTenantSchema
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Removes a defined search schema.

Remove-SPEnterpriseSearchTenantSchema [-Identity] <TenantSchemaPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SiteCollection <Guid>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.PowerShell.cmdlets.OSS.PipeBind.TenantSchemaPipeBind

Specifies the tenant of the search schema to be removed.

The type must be a valid GUID, in string form, that identifies the tenant in the form 12345678-90ab-cdef-1234-567890bcdefgh.

The tenant GUID can be found in the Search Service Application database, in the folder \Databases\Search_Service_Application\Tables\dbo.MSSTenant.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the enterprise search schema to be removed.

The type must be a valid search application name (for example, SearchApp1), or an instance of a valid SearchServiceApplication object.

SiteCollection

Optional

System.Guid

Specifies that the search schema to be removed is within the scope of a site collection (SPSite).

The type must be a valid GUID that specifies the property set in the form 12345678-90ab-cdef-1234-567890bcdefgh.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet removes a search schema. Use this cmdlet to remove an unused or unwanted search schema.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication$tenant = "909b84cb-90f2-4a1b-8df4-22547a9b2227"Remove-SPEnterpriseSearchTenantSchema -Identity $tenant -SearchApplication $ssa

This example removes the search schema for the tenant with GUID 909b84cb-90f2-4a1b-8df4-22547a9b2227.


Remove-SPEnterpriseSearchTenantConfiguration
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Removes all tenant specific search settings.

Remove-SPEnterpriseSearchTenantConfiguration [-SiteSubscriptionId] <Guid> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SiteSubscriptionId

Required

System.Guid

Specifies the site subscription of the tenant. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the name of the search application that contains the tenant configuration. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchTenantConfigurationcmdlet removes all tenant specific search settings. The removed settings are: query Rules, result types, result sources, managed metadata, ranking models, search dictionaries, authoritative pages, query suggestion settings, client types, and the default search center. Use this cmdlet when removing tenants and in conjunction with moving tenants. When moving a tenant, copy the tenant configuration from the source to the destination, and then use this cmdlet to remove the tenant configuration from the source farm.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplicationRemove-SPEnterpriseSearchTenantConfiguration -SiteSubscriptionId "00000000-0000-0000-0000-000000000001" -SearchApplication $ssa

This example uses Remove-SPEnterpriseSearchTenantConfiguration to remove all tenant specific settings from the search service application referenced by $ssa.


Remove-SPEnterpriseSearchServiceApplicationSiteSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Cleans up search settings for a particular site collection, subscription, or search application.

Remove-SPEnterpriseSearchServiceApplicationSiteSettings [-Identity] <SiteSettingsPipeBind> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-TenantId <Guid>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SiteSettingsPipeBind

Specifies the site collection to remove search settings from. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the name of the search application. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

TenantId

Optional

System.Guid

Specifies the tenant from which to remove search settings. The type must be a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPEnterpriseSearchServiceApplicationSiteSettings cmdlet to remove all search settings for the specified site collection, subscription, or search application.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$app = Get-SPEnterpriseSearchServiceApplication
Copy code
$GC = Start-SPAssignment
Copy code
$s = $GC | Get-SPSite UrlOfASiteCollection
Copy code
Remove-SPEnterpriseSearchServiceApplicationSiteSettings -Identity $s.ID.ToString() -SearchApplication $app
Copy code
Stop-SPAssignment $GC

This example removes the search settings for the site collection referenced by $s in the search application referenced by $app. $s is the site collection with URL "UrlOfSiteCollection", and $s.ID.ToString() is the string representation of the site ID.

See also

Upgrade-SPEnterpriseSearchServiceApplicationSiteSettings


Remove-SPEnterpriseSearchResultItemType
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Removes a result item type for a search object owner.

Remove-SPEnterpriseSearchResultItemType [-Identity] <ResultItemTypePipeBind> -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SearchApplicationProxy <SearchServiceApplicationProxyPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.ResultItemTypePipeBind

Specifies the result item type to update. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the result item type is created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the name of the search application. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

SearchApplicationProxy

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationProxyPipeBind

Specifies the proxy of the search application that contains the result item type. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application proxy name (for example, SearchAppProxy1); or an instance of a valid SearchServiceApplicationProxy object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchResultItemType cmdlet removes a user-created result item type, given a result type identity and a search owner. You cannot use this cmdlet to remove the built-in result item types that are included with SharePoint products.

Result item types enable you to change the look of search results based on the type of result. You start by defining a collection of rules, which will be evaluated against the properties of results. Then you define the display template to use for rendering that type of result. Once you have created the result item type, results matching the rules of the result item type will display using the specified display template.

Example use cases:

- Change the look of results for a particular file name extension, for example Word documents.

- Change the look of a particular content type in search results.

- Change the look of results from a particular author.

- Add a result action to results from a particular result source as part of a custom search application.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$web = Get-SPWeb "UrlOfTheSite"$tenantOwner = Get-SPEnterpriseSearchOwner -Level SPSite -SPWeb $web$searchapp = Get-SPEnterpriseSearchServiceApplication$resultType = Get-SPEnterpriseSearchResultItemType -Owner $tenantOwner -SearchApplication $searchapp$resultType.BuiltInRemove-SPEnterpriseSearchResultItemType -Identity $resultType -Owner $tenantOwner -SearchApplication $searchapp

This example first defines variables for the URL of the site, the search owner, and search application. It then retrieves the result item type and checks whether the result item type is a built-in result item type or not. If $resultType.BuiltIn returns false, the result item type is not built-in and you can modify it. Next, the example removes the result item type referenced by $resultType for the owner referenced by $tenantOwner.

See also

New-SPEnterpriseSearchResultItemType
Set-SPEnterpriseSearchResultItemType
Get-SPEnterpriseSearchResultItemType
Get-SPEnterpriseSearchOwner


Remove-SPEnterpriseSearchLinksDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deletes a links database.

Remove-SPEnterpriseSearchLinksDatabase [-Identity] <LinksStorePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.LinksStorePipeBind

Specifies the links database to delete. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a LinksStore object, in the form LinksStore1; or an instance of a valid LinksStore object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the links database. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchLinksDatabase cmdlet deletes a specified links database from a search service application. A links database stores query logging and analytics information.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication$linksDatabase = $ssa | Get-SPEnterpriseSearchLinksDatabase Links2Remove-SPEnterpriseSearchLinksDatabase -Identity $linksDatabase

This example removes the links database referenced by $linksDatabase. $linksDatabase is the identity of the links database Links2 on the search service application referenced by $ssa.

See also

New-SPEnterpriseSearchLinksDatabase
Set-SPEnterpriseSearchLinksDatabase
Get-SPEnterpriseSearchLinksDatabase

Move-SPEnterpriseSearchLinksDatabases


Remove-SPEnterpriseSearchFileFormat
See also Example
[image]

Updated: June 18, 2013

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Disables parsing of a file format.

Remove-SPEnterpriseSearchFileFormat [-Identity] <DocumentParserFileFormatPipeBind> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.DocumentParserFileFormatPipeBind

Specifies the identification of the format to disable parsing of.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the Search service application that contains the file format.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPEnterpriseSearchFileFormat removes the ability of the content processing component to use a third-party filter-based format handler (iFilter) to parse files with a specified file format and file name extension. You can use the Get-SPEnterpriseSearchFileFormat cmdlet to verify that a content processing component uses a third-party iFilter for a specified file format.

During iFilter installation, the operating system registered the iFilter with one or more file name extensions. Use the Remove-SPEnterpriseSearchFileFormat cmdlet for each registered file name extension that the content processing component no longer shall parse. Do this on each server that hosts a content processing component in the Search service application.

Your change is effective after you restart the SharePoint 2013 Search Host Controller process of each server that hosts a content processing component in the Search service application.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Remove-SPEnterpriseSearchFileFormat -SearchApplication $ssa -Identity sample

This example uses the Remove-SPEnterpriseSearchFileFormat cmdlet to remove the file format with the belonging file name extension "sample" in the Search service application referenced by $ssa.

See also

New-SPEnterpriseSearchFileFormat
Get-SPEnterpriseSearchFileFormat

Set-SPEnterpriseSearchFileFormatState

Change History

Date | Description
June 18, 2013 | Clarified that the cmdlet only can be used on formats parsed by a third-party format handler.
July 16, 2012 | Initial publication


Remove-SPEnterpriseSearchCrawlLogReadPermission
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Removes permission to view crawl log information.

Remove-SPEnterpriseSearchCrawlLogReadPermission [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Identity <CrawlLogReadPermissionPipeBind>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-Tenant <Guid>] [-UserNames <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.CrawlLogReadPermissionPipeBind

Specifies the crawl log permissions list from which to remove the user(s).

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the crawl log. The type must be a valid GUID, of the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Tenant

Optional

System.Guid

Specifies the tenant for which the user permissions shall be removed. The type must be a valid GUID of the form 12345678-90ab-cdef-1234-567890bcdefgh.

UserNames

Optional

System.String

Specifies the user names that shall no longer have permission to view the crawl log information. Separate names with semi-colons.

Specifies the user names that no longer shall have permission to view the crawl log information. Use the form "domain\username". When adding several user names, separate names with semi-colons.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Only the Search Service Application administrator can use this cmdlet.

The Remove-SPEnterpriseSearchCrawlLogReadPermission cmdlet removes the permission to view crawl log information for one or more users. The administrator can choose to restrict this removal to a particular tenant.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication$crawlLogPermission = Get-SPEnterpriseSearchCrawlLogReadPermission -SearchApplication $ssa -Tenant "00000000-0000-0000-0000-000000000001"Remove-SPEnterpriseSearchCrawlLogReadPermission -Identity $crawlLogPermission -UserNames "contoso\user1;contoso\user2"

This example removes user1 and user2 from the list of users referenced by $crawlLogPermission. $crawlLogPermission is the list of users who have permission to view the crawl log information from the tenant with id "00000000-0000-0000-0000-000000000001" on the search application referenced by $ssa.

See also

Set-SPEnterpriseSearchCrawlLogReadPermission
Get-SPEnterpriseSearchCrawlLogReadPermission


Remove-SPEnterpriseSearchComponent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Removes the specified search component from the given search topology.

Remove-SPEnterpriseSearchComponent [-Identity] <SearchComponentPipeBind> -SearchTopology <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.SearchComponentPipeBind

Specifies the identity for a search component

SearchTopology

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology from which to retrieve one or several search components.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the Search service application that contains the search topology and one or several search components.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet removes the specified search component from an inactive search topology.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
$topology = Get-SPEnterpriseSearchTopology -SearchApplication $ssa -Identity 10fa59cb-4b32-4fe6-8f8d-065388df201e
Copy code
Remove-SPEnterpriseSearchComponent -SearchTopology $topology -Identity c1642176-b9ae-4096-834c-080da5fba90e

This example removes the search component with identity c1642176-b9ae-4096-834c-080da5fba90e from the search topology with identity 10fa59cb-4b32-4fe6-8f8d-065388df201e from the default search application.


New-SPEnterpriseSearchTopology
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Creates a new search topology in the given search service application.

New-SPEnterpriseSearchTopology -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Clone <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-SearchTopology <SearchTopologyPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application to which the search topology will belong.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Clone

Optional

System.Management.Automation.SwitchParameter

Confirm

Optional

System.Management.Automation.SwitchParameter

Specifies that the new search topology is to be created by cloning an existing search topology.

SearchTopology

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the existing search topology of which the new topology will be a clone.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet creates a new, inactive search topology in the given search service application. If the Clone switch is used, a cloned topology is created. Otherwise, an empty topology is created.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchTopology -SearchApplication $ssa

This example creates a new, empty search topology in the search service application referenced by $ssa.

------------------EXAMPLE 2------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchTopology -SearchApplication $ssa -Clone -SearchTopology $topo

This example creates a new search topology in the search service application referenced by $ssa by cloning the existing topology referenced by $topo.

See also

Get-SPEnterpriseSearchTopology
Set-SPEnterpriseSearchTopology
Remove-SPEnterpriseSearchTopology
Export-SPEnterpriseSearchTopology
Import-SPEnterpriseSearchTopology


New-SPEnterpriseSearchResultItemType
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Creates a new result item type.

New-SPEnterpriseSearchResultItemType [-Name] <String> [-Rules] <PropertyRuleCollection> [[-RulePriority] <Int32>] [[-DisplayProperties] <String>] [[-SourceID] <Nullable>] [-DisplayTemplateUrl] <String> -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-OptimizeForFrequentUse <Nullable>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SearchApplicationProxy <SearchServiceApplicationProxyPipeBind>] [-WhatIf [<SwitchParameter>]]
New-SPEnterpriseSearchResultItemType [[-Name] <String>] [[-Rules] <PropertyRuleCollection>] [[-RulePriority] <Int32>] [[-DisplayProperties] <String>] [[-SourceID] <Nullable>] [[-DisplayTemplateUrl] <String>] -ExistingResultItemType <ResultItemTypePipeBind> -ExistingResultItemTypeOwner <SearchObjectOwner> -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-OptimizeForFrequentUse <Nullable>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SearchApplicationProxy <SearchServiceApplicationProxyPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the result item type.

Rules

Required

Microsoft.Office.Server.Search.Administration.PropertyRuleCollection

Specifies the collection of rules to evaluate the result properties against.

RulePriority

Optional

System.Int32

Specifies which priority the collection of rules has compared to other rules.

DisplayProperties

Optional

System.String

Specifies which result properties to display.

SourceID

Optional

System.Nullable

Identifies the search result source that the result item type applies to. Leave this parameter blank to apply to all result sources.

DisplayTemplateUrl

Required

System.String

Specifies the URL of the display template that shall be used for rendering the results. Specify an absolute URL.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the result item type is created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

OptimizeForFrequentUse

Optional

System.Nullable

Enable this flag if you always want the properties of this result item type to be requested, regardless of whether the result type is triggered. This will improve performance as long as it is only enabled on the most frequently used result item types.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the result item type. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

SearchApplicationProxy

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationProxyPipeBind

Specifies the proxy of the search application that contains the result item type. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application proxy name (for example, SearchAppProxy1); or an instance of a valid SearchServiceApplicationProxy object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the result item type.

Rules

Required

Microsoft.Office.Server.Search.Administration.PropertyRuleCollection

Specifies the collection of rules to evaluate the result properties against.

RulePriority

Optional

System.Int32

Specifies which priority the collection of rules has compared to other rules.

DisplayProperties

Optional

System.String

Specifies which result properties to display.

SourceID

Optional

System.Nullable

Identifies the search result source that the result item type applies to. Leave this parameter blank to apply to all result sources.

DisplayTemplateUrl

Required

System.String

Specifies the URL of the display template that shall be used for rendering the results. Specify an absolute URL.

ExistingResultItemType

Required

Microsoft.Office.Server.Search.Cmdlet.ResultItemTypePipeBind

Specifies an existing result item type to which new rules or displayed properties can be added.

ExistingResultItemTypeOwner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which an existing result item type was created.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the result item type is created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

OptimizeForFrequentUse

Optional

System.Nullable

Enable this flag if you always want the properties of this result item type to be requested, regardless of whether the result type is triggered. This will improve performance as long as it is only enabled on the most frequently used result item types.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the result item type. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

SearchApplicationProxy

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationProxyPipeBind

Specifies the proxy of the search application that contains the result item type. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application proxy name (for example, SearchAppProxy1); or an instance of a valid SearchServiceApplicationProxy object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPEnterpriseSearchResultItemType cmdlet to create a new result item type.

Result item types enable you to change the look of search results based on the type of result. You start by defining a collection of rules, which will be evaluated against the properties of results. Then you define the display template to use for rendering that type of result. Once you have created the result item type, results matching the rules of the result item type will render using the specified display template.

Example use cases:

  • Change the look of results for a particular file name extension, for example Word documents.

  • Change the look of a particular content type in search results.

  • Change the look of results from a particular author.

  • Add a result action to results from a particular result source as part of a custom search application.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$rule = Get-SPEnterpriseSearchPropertyRule -PropertyName "ContentTypeId" -Operator "StartsWith"$rule.AddValue( "0x010063C2F478ACC511DFB869B5BFDFD720851252" )$ruleCollection = Get-SPEnterpriseSearchPropertyRuleCollection$ruleCollection.Add( $rule )$displayProperties = "WorkId,Rank,Title,Size,Path,Description,SiteName,HitHighlightedSummary,HitHighlightedProperties,ViewsLifeTime"$displaytemplateUrl = "~sitecollection/_catalogs/masterpage/Display Templates/Search/Item_MyCustomDisplayTemplate.js"$web = Get-SPWeb "UrlOfTheSite"$tenantOwner = Get-SPEnterpriseSearchOwner -Level SPSite -SPWeb $web$svcAppProxy = Get-SPEnterpriseSearchServiceApplicationProxyNew-SPEnterpriseSearchResultItemType -SearchApplicationProxy $svcAppProxy `-Name "CustomResultType" `-Rules $ruleCollection `-RulePriority 1 -DisplayProperties $displayProperties `-DisplayTemplateUrl $displaytemplateUrl `-Owner $tenantOwner

This example first defines the rule to apply to the search results in order to target results with a specific property, and adds the rule to the rule collection. Thereafter the example defines the properties of the result that shall be displayed and the URL to the display template governing the appearance of the rendered results. Finally, the example defines the rule item type by its name, the rule collection, the display properties, the display template, and the tenant owner.

See also

Set-SPEnterpriseSearchResultItemType
Get-SPEnterpriseSearchResultItemType
Remove-SPEnterpriseSearchResultItemType
Get-SPEnterpriseSearchOwner
Get-SPEnterpriseSearchPropertyRule
Get-SPEnterpriseSearchPropertyRuleCollection


New-SPEnterpriseSearchQueryProcessingComponent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Creates a new query processing component for the given topology and search service instance.

New-SPEnterpriseSearchQueryProcessingComponent -SearchServiceInstance <SearchServiceInstancePipeBind> -SearchTopology <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SearchServiceInstance

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance that will host the new query processing component. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a search topology server, or an instance of a valid SearchServiceInstance object.

SearchTopology

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology where the new query processing component should be added.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the search topology.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Creates a new query processing component and adds it to an inactive search topology in a specific search service instance. The change is effectuated when the search topology is enabled.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchQueryProcessingComponent -SearchTopology 06e6651d-ecdd-4105-bb65-6a83b6155525 -SearchServiceInstance 56e6651d-ecdd-4105-bb65-6a83b6155525 -SearchApplication $ssa

This example adds a new query processing component to the search topology with identity 06e6651d-ecdd-4105-bb65-6a83b6155525 in the search service instance with identity 56e6651d-ecdd-4105-bb65-6a83b6155525 in the default search service application referenced by $ssa.


New-SPEnterpriseSearchLinksDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Creates a new links database for a search service application.

New-SPEnterpriseSearchLinksDatabase -DatabaseName <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

DatabaseName

Required

System.String

Specifies the links database to obtain. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a LinksStore object, in the form LinksStore1; or an instance of a valid LinksStore object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the links database. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabasePassword

Optional

System.Security.SecureString

Specifies the password of the account to connect to the database.

DatabaseServer

Optional

System.String

Specifies the server to use for the host SQL database.

DatabaseUsername

Optional

System.String

Specifies the name of the account to connect to the database.

FailoverDatabaseServer

Optional

System.String

Specifies the server to use for failover in the case of SQL Server mirroring.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPEnterpriseSearchLinksDatabase cmdlet during initial configuration and farm scale out to create a new links database, which can be added to a search service application. A links database stores query logging and analytics information.

Input Types

Return Types

Example

---------EXAMPLE---------

Copy code
New-SPEnterpriseSearchLinksDatabase -DatabaseName LinksDB_1 -SearchApplication MySearchServiceApp

This example adds a new links database LinksDB_1 to the search service application named MySearchServiceApp.

See also

Set-SPEnterpriseSearchLinksDatabase
Get-SPEnterpriseSearchLinksDatabase
Remove-SPEnterpriseSearchLinksDatabase

Move-SPEnterpriseSearchLinksDatabases


New-SPEnterpriseSearchIndexComponent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Creates a new index component for the given topology and search service instance.

New-SPEnterpriseSearchIndexComponent -SearchServiceInstance <SearchServiceInstancePipeBind> -SearchTopology <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-IndexPartition <UInt32>] [-RootDirectory <String>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SearchServiceInstance

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance that will host the new index component. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a search topology server, or an instance of a valid SearchServiceInstance object.

SearchTopology

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology where the new index component should be added.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IndexPartition

Optional

System.UInt32

Specifies the index partition number to assign to the new search index component.

RootDirectory

Optional

System.String

Specifies the root directory that will hold the index location for the new search index component. This is needed if you want to isolate the index on dedicated discs in order to avoid I/O contention with other parts of the system, other system sharing the same disks, or because you do not want to risk the index filling up the OS disk (generally C: )

Note:

If you specify the root directory to be the root of a volume, e.g. E:, the index will not be cleaned up if you delete the SSA. You will then have to delete the index files manually.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the search topology.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Creates a new index component and adds it to an inactive search topology in a specific search service instance. The change is effectuated when the search topology is enabled.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchIndexComponent -SearchTopology 06e6651d-ecdd-4105-bb65-6a83b6155525 -SearchServiceInstance 56e6651d-ecdd-4105-bb65-6a83b6155525 -SearchApplication $ssa -IndexPartition 1 -RootDirectory E:\Index

This example adds a new search index component to the search topology with identity 06e6651d-ecdd-4105-bb65-6a83b6155525 in the search service instance with identity 56e6651d-ecdd-4105-bb65-6a83b6155525 in the default search service application referenced by $ssa, with index partition 1 and root directory E:\Index.


New-SPEnterpriseSearchFileFormat
See also Example
[image]

Updated: June 18, 2013

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Adds the ability to parse a new file format.

New-SPEnterpriseSearchFileFormat [-FormatId] <String> [-FormatName] <String> [-MimeType] <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

FormatId

Required

System.String

Specifies the file name extension of the format to parse.

FormatName

Required

System.String

Specifies the name of the format to parse. Usually this is the name of the application handling the format.

MimeType

Required

System.String

Specifies the mime type of the format to parse.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application for which to add the new file format. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPEnterpriseSearchFileFormat cmdlet enables the content processing component to parse files with a specified file format and file name extension. The cmdlet can only enable parsing of the file format and file name extension if the server that hosts the content processing component has a relevant third-party filter-based format handler (iFilter) installed. You can use the Get-SPEnterpriseSearchFileFormat cmdlet to verify that an iFilter is installed for a specified file format.

During iFilter installation, the operating system registered the iFilter with one or more file name extensions. Use the New-SPEnterpriseSearchFileFormat cmdlet for each registered file name extension that you want to enable the content processing component to parse. Do this on each server that hosts a content processing component in the Search service application.

Your change is effective after you restart the SharePoint 2013 Search Host Controller process of each server that hosts a content processing component in the Search service application.

Input Types

Return Types

Example

-------------EXAMPLE-------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
New-SPEnterpriseSearchFileFormat -SearchApplication $ssa sample SampleApp application/SampleApp

This example uses the New-SPEnterpriseSearchFileFormat cmdlet to enable the content processing component in the Search service application referenced by $ssa to parse files that have the file name extension "sample", the file format "SampleApp", and the mime type "application/SampleApp".

See also

Get-SPEnterpriseSearchFileFormat
Remove-SPEnterpriseSearchFileFormat

Set-SPEnterpriseSearchFileFormatState

Change History

Date | Description
June 18, 2013 | Added information about when changes are effective.
July 16, 2012 | Initial publication


New-SPEnterpriseSearchContentProcessingComponent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Creates a new content processing component for the given topology and search service instance.

New-SPEnterpriseSearchContentProcessingComponent -SearchServiceInstance <SearchServiceInstancePipeBind> -SearchTopology <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SearchServiceInstance

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance that will host the new content processing component. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a search topology server, or an instance of a valid SearchServiceInstance object.

SearchTopology

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology where the new content processing component should be added.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the search topology.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Creates a new content processing component and adds it to an inactive search topology in a specific search service instance. The change is effectuated when the search topology is enabled.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchContentProcessingComponent -SearchTopology 06e6651d-ecdd-4105-bb65-6a83b6155525 -SearchServiceInstance 56e6651d-ecdd-4105-bb65-6a83b6155525 -SearchApplication $ssa

This example adds a new content processing component to the search topology with identity 06e6651d-ecdd-4105-bb65-6a83b6155525 in the search service instance with identity 56e6651d-ecdd-4105-bb65-6a83b6155525 in the default search service application referenced by $ssa.


New-SPEnterpriseSearchAnalyticsProcessingComponent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Creates a new analytics processing component for the given topology and search service instance.

New-SPEnterpriseSearchAnalyticsProcessingComponent -SearchServiceInstance <SearchServiceInstancePipeBind> -SearchTopology <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SearchServiceInstance

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance that will host the new analytics processing component. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a search topology server, or an instance of a valid SearchServiceInstance object.

SearchTopology

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology where the new analytics processing component should be added.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the search topology.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Creates a new analytics processing component and adds it to an inactive search topology in a specific search service instance. The change is effectuated when the search topology is enabled.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchAnalyticsProcessingComponent -SearchTopology 06e6651d-ecdd-4105-bb65-6a83b6155525 -SearchServiceInstance 56e6651d-ecdd-4105-bb65-6a83b6155525 -SearchApplication $ssa

This example adds a new analytics processing component to the search topology with identity 06e6651d-ecdd-4105-bb65-6a83b6155525 in the search service instance with identity 56e6651d-ecdd-4105-bb65-6a83b6155525 in the default search service application referenced by $ssa.


New-SPEnterpriseSearchAdminComponent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Creates a new admin component for the given topology and search service instance.

New-SPEnterpriseSearchAdminComponent -SearchServiceInstance <SearchServiceInstancePipeBind> -SearchTopology <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SearchApplication <SearchServiceApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SearchServiceInstance

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance that will host the new admin component. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a search topology server, or an instance of a valid SearchServiceInstance object.

SearchTopology

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology where the new admin component should be added.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the search topology.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Creates a new search admin component and adds it to an inactive search topology in a specific search service instance. The change is effectuated when the search topology is enabled.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
New-SPEnterpriseSearchAdminComponent -SearchTopology 06e6651d-ecdd-4105-bb65-6a83b6155525 -SearchServiceInstance 56e6651d-ecdd-4105-bb65-6a83b6155525 -SearchApplication $ssa

This example adds a new search admin component to the search topology with identity 06e6651d-ecdd-4105-bb65-6a83b6155525 in the search service instance with identity 56e6651d-ecdd-4105-bb65-6a83b6155525 in the default search service application referenced by $ssa.


Import-SPEnterpriseSearchThesaurus
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Deploys the dictionary to the thesaurus component in the query processing flow.

Import-SPEnterpriseSearchThesaurus -FileName <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

FileName

Required

System.String

Specifies the full UNC (Universal Naming Convention) path of the .cvs file to be imported.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application to which the thesaurus dictionary should be imported

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet imports a thesaurus dictionary using a .cvs file, and deploys it to the query processing flow. A previously deployed thesaurus is overwritten by an import of a new .cvs file.

NOTE: If an empty .cvs file is imported, an empty thesaurus will be deployed. No synonyms will then be added to the queries.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication
Copy code
Import-SPEnterpriseSearchThesaurus -SearchApplication $searchApp -Filename \\host\share\thesaurus.csv

This example imports a thesaurus dictionary .cvs file named thesaurus.csv that is located at \\host\share to the default search service application.

See also

Get-SPEnterpriseSearchServiceApplication


Import-SPEnterpriseSearchCustomExtractionDictionary
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Imports a custom entity extraction dictionary.

Import-SPEnterpriseSearchCustomExtractionDictionary -DictionaryName <String> -FileName <String> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

DictionaryName

Required

System.String

Specifies the name of the target dictionary. The name must be one of the following 12 predefined dictionaries. The name signifies the "case sensitivity" and "token matching" behavior.

  1. Microsoft.UserDictionaries.EntityExtraction.Custom.Word.1

  2. Microsoft.UserDictionaries.EntityExtraction.Custom.Word.2

  3. Microsoft.UserDictionaries.EntityExtraction.Custom.Word.3

  4. Microsoft.UserDictionaries.EntityExtraction.Custom.Word.4

  5. Microsoft.UserDictionaries.EntityExtraction.Custom.Word.5

  6. Microsoft.UserDictionaries.EntityExtraction.Custom.ExactWord.1

  7. Microsoft.UserDictionaries.EntityExtraction.Custom.WordPart.1

  8. Microsoft.UserDictionaries.EntityExtraction.Custom.WordPart.2

  9. Microsoft.UserDictionaries.EntityExtraction.Custom.WordPart.3

  10. Microsoft.UserDictionaries.EntityExtraction.Custom.WordPart.4

  11. Microsoft.UserDictionaries.EntityExtraction.Custom.WordPart.5

  12. Microsoft.UserDictionaries.EntityExtraction.Custom.ExactWordPart.1

FileName

Required

System.String

Specifies the full UNC (Universal Naming Convention) path of the .csv file to be imported.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application to which the custom entity extraction dictionary should be imported.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet imports a custom entity extraction dictionary from a .csv file. In order to activate custom entity extraction you must also configure entity extraction in the search schema.

Input Types

Return Types

Example

------------------EXAMPLE-----------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication
Copy code
Import-SPEnterpriseSearchCustomExtractionDictionary -SearchApplication $searchApp -Filename \\host\share\entity_extraction.csv -DictionaryName Microsoft.UserDictionaries.EntityExtraction.Custom.Word.1

This example imports the custom entity extraction dictionary that is located at \\host\share to the default search service application. The entries of this dictionary will be matched in a case-insensitive way against the terms in the documents being indexed.

See also

Create and deploy custom entity extractors in SharePoint Server 2013


Get-SPEnterpriseSearchTopology
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Retrieves one or all search topologies that belong to a given search service application.

Get-SPEnterpriseSearchTopology [[-Identity] <SearchTopologyPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-Active <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology to retrieve.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application to which the search topology belongs.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Active

Optional

System.Management.Automation.SwitchParameter

Specifies that the active search topology should be returned.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet retrieves a given search topology, the active search topology, or all search topologies that belong to a given search service application.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchTopology -SearchApplication $ssa

This example retrieves all search topologies of the search service application referenced by $ssa.

------------------EXAMPLE 2------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchTopology -SearchApplication $ssa -Active

This example retrieves the active search topology of the search service application referenced by $ssa.

------------------EXAMPLE 3------------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchTopology -SearchApplication $ssa -Identity 10fa59cb-4b32-4fe6-8f8d-065388df201e

This example retrieves search topology with the identity 10fa59cb-4b32-4fe6-8f8d-065388df201e of the search service application referenced by $ssa.

See also

New-SPEnterpriseSearchTopology
Set-SPEnterpriseSearchTopology
Remove-SPEnterpriseSearchTopology
Export-SPEnterpriseSearchTopology
Import-SPEnterpriseSearchTopology


Get-SPEnterpriseSearchResultItemType
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Retrieves result item types.

Get-SPEnterpriseSearchResultItemType [[-Identity] <ResultItemTypePipeBind>] -Owner <SearchObjectOwner> [-AssignmentCollection <SPAssignmentCollection>] [-SearchApplication <SearchServiceApplicationPipeBind>] [-SearchApplicationProxy <SearchServiceApplicationProxyPipeBind>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.ResultItemTypePipeBind

Specifies the result item type to update. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Owner

Required

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner that defines the scope at which the result item type is created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the name of the search application. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

SearchApplicationProxy

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationProxyPipeBind

Specifies the proxy of the search application that contains the result item type. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application proxy name (for example, SearchAppProxy1); or an instance of a valid SearchServiceApplicationProxy object.

Detailed Description

The Get-SPEnterpriseSearchResultItemType cmdlet retrieves the result item types that exist for the specified owner.

Result item types enable you to change the look of search results based on the type of result. You start by defining a collection of rules, which will be evaluated against the properties of results. Then you define the display template to use for rendering that type of result. Once you have created the result item type, results matching the rules of the result item type will render using the specified display template.

Example use cases:

- Change the look of results for a particular file name extension, for example Word documents.

- Change the look of a particular content type in search results.

- Change the look of results from a particular author.

- Add a result action to results from a particular result source as part of a custom search application.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication$tenantOwner = Get-SPEnterpriseSearchOwner -Level SPSiteGet-SPEnterpriseSearchResultItemType -Owner $tenantOwner -SearchApplication $ssa

This example retrieves the result item types that are defined for the owner referenced by $tenantowner for the search application referenced by $ssa. Although SearchApplication and SearchApplicationProxy are optional parameters, this cmdlet requires use of one of them.

See also

New-SPEnterpriseSearchResultItemType
Set-SPEnterpriseSearchResultItemType
Remove-SPEnterpriseSearchResultItemType
Get-SPEnterpriseSearchOwner


Get-SPEnterpriseSearchQuerySpellingCorrection
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Returns the object that exposes the Query Spelling Correction (QSC) configuration.

Get-SPEnterpriseSearchQuerySpellingCorrection [[-Identity] <QuerySpellingCorrectionPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.QuerySpellingCorrectionPipeBind

Specifies an object that represents the current status for the query spelling correction.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the Search service application that contains the query spelling correction parameters.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet returns the object that exposes the QSC configuration parameters.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$searchApp = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchQuerySpellingCorrection -SearchApplication $searchApp

Returns the current configuration for the Query Spelling Correction component for the default Search service application.


Get-SPEnterpriseSearchOwner
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Retrieves the search object owner.

Get-SPEnterpriseSearchOwner [[-Identity] <SearchObjectOwner>] -Level <SPWeb | SPSite | SPSiteSubscription | Ssa> [-AssignmentCollection <SPAssignmentCollection>] [-SPWeb <SPWebPipeBind>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Administration.SearchObjectOwner

Specifies the search object owner to retrieve.

Level

Required

Microsoft.Office.Server.Search.Administration.SearchObjectLevel

Specifies whether the owner object resides at the SPWeb, SPSite, SPSite Subscription, or SSA level.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SPWeb

Optional

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the SPWeb or SPSite in which this object resides. It is only needed if Level is equal to SPWeb or SPSite.

Detailed Description

The Get-SPEnterpriseSearchOwner cmdlet retrieves the search object owner. Get-SPEnterpriseSearchOwner provides scoping context to other cmdlets such as SPEnterpriseSearchResultItemType.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$tenantOwner = Get-SPEnterpriseSearchOwner -Level SPSite

This example shows how to retrieve the tenant owner of a search object at the SPSite level.


Get-SPEnterpriseSearchLinksDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Retrieves a reference to a links database.

Get-SPEnterpriseSearchLinksDatabase [[-Identity] <LinksStorePipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.LinksStorePipeBind

Specifies the links database to get. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a LinksStore object, in the form LinksStore1; or an instance of a valid LinksStore object.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the links database. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchLinksDatabase cmdlet returns a LinksStore object for use during configuration and when a links database for a search service application is modified or deleted. A links database stores query logging and search analytics data for a search service application. If the Identity parameter is not specified, this cmdlet returns all links databases for the specified search application.

Input Types

Return Types

Example

---------EXAMPLE---------

Copy code
$linksDatabase = Get-SPEnterpriseSearchLinksDatabase  -Identity LinksDB_1 -SearchApplication MySearchServiceApp

This example gets a reference to the links database LinksDB_1 from the search service application MySearchServiceApp.

See also

New-SPEnterpriseSearchLinksDatabase
Set-SPEnterpriseSearchLinksDatabase
Remove-SPEnterpriseSearchLinksDatabase

Move-SPEnterpriseSearchLinksDatabases


Get-SPEnterpriseSearchFileFormat
See also Example
[image]

Updated: June 18, 2013

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Retrieves all file formats that the parsing system has format handlers for.

Get-SPEnterpriseSearchFileFormat [[-Identity] <DocumentParserFileFormatPipeBind>] -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.DocumentParserFileFormatPipeBind

Specifies the format ID for which to retrieve file format information.

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the Search application for which to retrieve file format information. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPEnterpriseSearchFileFormat cmdlet retrieves the following information about a specified file format:

  • The file name extension.

  • The mime type of the format.

  • The type of format handler the content processing component uses to parse the format. The entry "BuiltIn:True" indicates a built-in format handler. The entry "BuiltIn:False" indicates a third-party filter-based format handler.

  • The parsing state of the format. The entry "Enabled:True" indicates that parsing is enabled. The entry "Enabled:False" indicates that parsing is disabled.

If you do not specify a format ID, the cmdlet returns the list of information for all the file formats that the content processing component has format handlers for.

Input Types

Return Types

Example

-------------EXAMPLE 1-------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Get-SPEnterpriseSearchFileFormat -SearchApplication $ssa

This example uses the Get-SPEnterpriseSearchFileFormat to retrieve all file formats that the Search service application referenced by $ssa has format handlers for.

-------------EXAMPLE 2-------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Get-SPEnterpriseSearchFileFormat -SearchApplication $ssa zip

This example uses the Get-SPEnterpriseSearchFileFormat cmdlet to retrieve information about the file format "zip" in the Search service application referenced by $ssa. The result is as follows:

Identity  :zip
Name   :ZIP Archive
MimeType  :application/zip
Extension :.zip
BuiltIn   :True
Enabled   :False

See also

New-SPEnterpriseSearchFileFormat
Remove-SPEnterpriseSearchFileFormat

Set-SPEnterpriseSearchFileFormatState

Change History

Date | Description
June 18, 2013 | Added a description of the information that the cmdlet returns.
July 16, 2012 | Initial publication


Get-SPEnterpriseSearchCrawlLogReadPermission
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Retrieves the list of users with permission to access the crawl log information.

Get-SPEnterpriseSearchCrawlLogReadPermission -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Tenant <Guid>]

Parameters

Parameter Required Type Description

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the name of the search application for which to list crawl log permissions. The type must be a valid GUID, of the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Tenant

Optional

System.Guid

Specifies that the list of users shall be within the scope of this tenant. The type must be a valid GUID of the form 12345678-90ab-cdef-1234-567890bcdefgh.

Detailed Description

Only the Search Service Application administrator can use the Get-SPEnterpriseSearchCrawlLogReadPermission cmdlet.

The Search Service Application administrator uses the cmdlet to retrieve a list of users with permission to view the crawl log information. The administrator can choose to limit this list to users with permission to view crawl log information from a particular tenant.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplicationGet-SPEnterpriseSearchCrawlLogReadPermission -SearchApplication $ssa -Tenant "00000000-0000-0000-0000-000000000001"

This example retrieves a list of users who have permission to view the crawl log information for a tenant with id "00000000-0000-0000-0000-000000000001" on the search application referenced by $ssa.

See also

Set-SPEnterpriseSearchCrawlLogReadPermission
Remove-SPEnterpriseSearchCrawlLogReadPermission


Get-SPEnterpriseSearchComponent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Retrieves one or all search components in a given search topology.

Get-SPEnterpriseSearchComponent [[-Identity] <SearchComponentPipeBind>] -SearchTopology <SearchTopologyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-SearchApplication <SearchServiceApplicationPipeBind>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchComponentPipeBind

Specifies the identity for a search component.

SearchTopology

Required

Microsoft.Office.Server.Search.Cmdlet.SearchTopologyPipeBind

Specifies the search topology from which to retrieve the search component/search components.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SearchApplication

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search service application that contains the search topology and search component/search components.

Detailed Description

This cmdlet retrieves the search component with the specified identity from the given search topology. If an identity is not provided, all search components in the given search topology will be retrieved.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchComponent -SearchTopology 56e6651d-ecdd-4105-bb65-6a83b6155525 -Identity 06e6651d-ecdd-4105-bb65-6a83b6155525 -SearchApplication $ssa

This example retrieves the search component with the identity 06e6651d-ecdd-4105-bb65-6a83b6155525 from the search topology with identity 56e6651d-ecdd-4105-bb65-6a83b6155525 in the search service application referenced by $ssa.

------------------EXAMPLE 2-----------------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Copy code
Get-SPEnterpriseSearchComponent -SearchTopology 56e6651d-ecdd-4105-bb65-6a83b6155525 -SearchApplication $ssa

This example retrieves all search components from the search topology with the identity 56e6651d-ecdd-4105-bb65-6a83b6155525 in the search service application referenced by $ssa.


Get-SPEnterpriseSearchServiceApplicationBackupStore
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Retrieves information about the Search service application backup files.

Get-SPEnterpriseSearchServiceApplicationBackupStore [-BackupFolder] <String> [-Name] <String> [[-BackupId] <String>] [[-UseMostRecent] <SwitchParameter>] [[-IsVerbose] <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

BackupFolder

Required

System.String

Specifies the full file path of the backup files.

Name

Required

System.String

Specifies the name of the Search service application from which to retrieve the related backup information.

BackupId

Optional

System.String

Specifies the GUID of the backup in the referred package.

UseMostRecent

Optional

System.Management.Automation.SwitchParameter

A switch to specify if the most recent backup should be used.

IsVerbose

Optional

System.Management.Automation.SwitchParameter

A switch to specify if messages should be printed out when the cmdlet is running.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet returns information about the search databases and index files in a specified Search service application backup location.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------

Copy code
Get-SPEnterpriseSearchServiceApplicationBackupStore -BackupFolder \\sample\backup -Name "Search Service Application" -BackupId 3222ad97-91ad-471f-a764-780ec1f05f74

This example retrieves the backup of the search databases and index files that are located at \\sample\backup with the backup id 3222ad97-91ad-471f-a764-780ec1f05f74 from the Search service application Search Service Application.

------------------EXAMPLE 2-----------------

Copy code
Get-SPEnterpriseSearchServiceApplicationBackupStore -BackupFolder \\sample\backup -Name "Search Service Application" -UseMostRecent

This example retrieves the most recently taken backup of the search databases and index files that are located at \\sample\backup from the Search service application Search Service Application.


Repartition-SPEnterpriseSearchLinksDatabases
See also
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Obsolete. For the replacement, see Move-SPEnterpriseSearchLinksDatabases.

  See also
Updates to Windows PowerShell cmdlets (SharePoint 2013)


Set-SPEnterpriseSearchServiceInstance
See also Example
[image]

Published: August 21, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard

Sets the properties of a search service instance.

Set-SPEnterpriseSearchServiceInstance [-Identity] <SearchServiceInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultIndexLocation <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Search.Cmdlet.SearchServiceInstancePipeBind

Specifies the search service instance to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a query server (for example, MyQueryServer); or an instance of a valid SearchServiceInstance object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultIndexLocation

Optional

System.String

This parameter is obsolete and has no function. You should not use this parameter.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet updates properties of the search service instance for a farm.

Input Types

Return Types

Example

Copy code

  See also
Get-SPEnterpriseSearchServiceInstance
Start-SPEnterpriseSearchServiceInstance
Stop-SPEnterpriseSearchServiceInstance


Move-SPEnterpriseSearchLinksDatabases
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Moves data across links databases.

Move-SPEnterpriseSearchLinksDatabases [-SearchApplication] <SearchServiceApplicationPipeBind> [[-RepartitioningId] <Nullable>] [[-SourceStores] <LinksStore[]>] [[-TargetStores] <LinksStore[]>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the links database. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

RepartitioningId

Optional

System.Nullable

Resumes the move with this identifier.

SourceStores

Optional

Microsoft.Office.Server.Search.Administration.LinksStore[]

Specifies a source list of databases. If this parameter is not specified then all currently existing links databases will be used as a source list.

TargetStores

Optional

Microsoft.Office.Server.Search.Administration.LinksStore[]

Specifies a target list of databases. If this parameter is not specified then all currently existing links databases will be used as a target list.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the search application that contains the links database. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

Detailed Description

The Move-SPEnterpriseSearchLinksDatabases cmdlet moves data across a given list of links databases during farm configuration and scale out, to improve the performance and resource load of the farm. Once the move has started, the cmdlet will return a unique identifier, the RepartitioningId. Use this identifier to retrigger if the current run fails. After the move has finished, the old databases can be removed.

A links database stores query logging and analytics information.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$ssa=Get-SPEnterpriseSearchServiceapplication
$ssa | New-SPEnterpriseSearchLinksDatabase -DatabaseName "links1"
$ssa | New-SPEnterpriseSearchLinksDatabase -DatabaseName "links2"
$ssa | New-SPEnterpriseSearchLinksDatabase -DatabaseName "links3"
$dbs = $ssa | Get-SPEnterpriseSearchLinksDatabase
$ssa | Repartition-SPEnterpriseSearchLinksDatabases -TargetStores $dbs

This example adds 3 new links databases and uses Move-SPEnterpriseSearchLinksDatabases to move data from the current links databases into new databases.

See also

New-SPEnterpriseSearchLinksDatabase
Set-SPEnterpriseSearchLinksDatabase
Get-SPEnterpriseSearchLinksDatabase
Remove-SPEnterpriseSearchLinksDatabase


Set-SPEnterpriseSearchFileFormatState
See also Example
[image]

Updated: June 18, 2013

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | SharePoint Foundation 2013

Enables or disables parsing of a specified file format.

Set-SPEnterpriseSearchFileFormatState [-Identity] <DocumentParserFileFormatStatePipeBind> [-Enable] <$true | $false> -SearchApplication <SearchServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Search.Cmdlet.DocumentParserFileFormatStatePipeBind

Specifies the identification of the file format to be disabled or enabled.

Enable

Required

System.Boolean

Specifies the activation state of the file format. The activation state can be $FALSE (disabled) or $TRUE (enabled).

SearchApplication

Required

Microsoft.Office.Server.Search.Cmdlet.SearchServiceApplicationPipeBind

Specifies the name of the search application that contains the file format. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid search application name (for example, SearchApp1); or an instance of a valid SearchServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPEnterpriseSearchFileFormatState cmdlet enables or disables the content processing component from parsing a specified file format. You can only use this cmdlet for file formats that the content processing component parses with a built-in format handler. You can use the Get-SPEnterpriseSearchFileFormatState cmdlet to verify that a content processing component uses a built-in format handler for a specified file format.

To enable parsing of a file format, set Enabled to "$TRUE". To disable parsing of a file format, set Enabled to "$FALSE".

Note:

A file format can support more than one file name extension, see Default crawled file name extensions and parsed file types in SharePoint Server 2013 for an overview. The Set-SPEnterpriseSearchFileFormatState cmdlet enables or disables parsing of all file name extensions the file format supports.

Your change is effective after you restart the SharePoint 2013 Search Host Controller process of each server that hosts a content processing component in the Search service application.

Input Types

Return Types

Example

--------EXAMPLE--------

Copy code
$ssa = Get-SPEnterpriseSearchServiceApplication
Set-SPEnterpriseSearchFileFormatState -SearchApplication $ssa PDF $FALSE

This example uses the Set-SPEnterpriseSearchFileFormatState cmdlet to disable the format handler for the file format "PDF".

See also

New-SPEnterpriseSearchFileFormat
Get-SPEnterpriseSearchFileFormat
Remove-SPEnterpriseSearchFileFormat

Change History

Date | Description
June 18, 2013 | Clarified that this cmdlet can be used only for file formats parsed using built-in format handlers.
July 16, 2012 | Initial publication


Set-SPEnterpriseSearchDCTMConnectorConfig
Example
[image]

Published: March 12, 2013

Applies to: SharePoint Server 2013 | SharePoint Server 2013 Enterprise

Configures the Microsoft SharePoint 2013 Indexing Connector for Documentum.

Set-SPEnterpriseSearchDCTMConnectorConfig -ACLTranslation <Nullable> -DisplayURLPatternForContainer <String> -DisplayURLPatternForDocument <String> -Shared <SwitchParameter> [-DFSURL <String>] [-PersistDCTMACL <Nullable>] [-UnmappedAccount <Nullable>] [-UserMappingTableDBName <String>] [-UserMappingTableName <String>] [-UserMappingTableSQLInstance <String>] [-UserMappingTableSQLServer <String>]
Set-SPEnterpriseSearchDCTMConnectorConfig -Repository <SwitchParameter> -RepositoryName <String> [-ACLTranslation <Nullable>] [-DFSWebServiceURL <String[]>] [-DisplayURLPatternForContainer <String>] [-DisplayURLPatternForDocument <String>] [-IndexAllVersions <SwitchParameter>] [-PersistDCTMACL <Nullable>] [-UnmappedAccount <Nullable>]
Set-SPEnterpriseSearchDCTMConnectorConfig -Remove <SwitchParameter> -RepositoryName <String>

Parameters

1

Parameter

Required

Type

Description

ACLTranslation

Required

System.Nullable

Specifies how the Documentum indexing connector processes security descriptors of the documents it crawls. It is an enumeration with four possible values:

UserMappingTable: This is the default value. Documentum security descriptors will be translated to Windows security descriptors based on the mappings defined in a user mapping table in a database. There can be only one Documentum user mapping table per SharePoint farm, and multiple SharePoint farms can reference the same mapping table. The parameters UserMappingTableSQLServer, UserMappingTableSQLInstance, and UserMappingTableName must be set using the Shared parameter set if the SharedACLTranslation type is UserMappingTable or if any repository's ACLTranslation type is UserMappingTable, even if the SharedACLTranslation type is not UserMappingTable. The UnMappedAccount parameter is optional when ACLTranslation type is UserMappingTable.

NoSecurity: Documentum security descriptors are ignored at crawl time. All documents from Documentum will be searchable by any SharePoint user. This option is intended to be used with a custom security trimming solution.

SameAccountName: Permissions to a document are granted using the Documentum account name in the Windows domain. This setting is used when users have the same username for both Documentum and Windows domain accounts, such as a shared account in Active Directory. If a document's security descriptor contains an account name that is not an existing Windows account, that security entry is ignored.

Claims: The Documentum security descriptor is encoded in a claims format. This is intended to be used with the Documentum custom security trimmer included with the indexing connector.

The ACLTranslation parameter must be supplied when the Shared parameter set is used. If this setting has not been configured using the Shared parameter set, you must supply this parameter when you use the Repository parameter set. If this setting has been configured using the Shared parameter set, then this parameter is optional when using the Repository parameter set.

A repository-specific setting overrides the Shared setting.

DisplayURLPatternForContainer

Required

System.String

This parameter sets the format of the display URL for Documentum folders and cabinets. The value of this parameter must be a valid URL. There are two placeholders that can be used in this URL:

{ObjectId} - This placeholder will be replaced with the Documentum object ID.

{RepositoryName} - This placeholder will be replaced with the Documentum repository name.

The following example is an example of a folder or cabinet which would be accessible from a Documentum Webtop server named "MyWebtopServer" on port 20000:

-DisplayURLPatternForContainer "http://MyWebtopServer:20000/webtop/drl/objectId/{ObjectId}"

This parameter must be supplied when the Shared parameter set is used. If this setting has not been configured using the Shared parameter set, you must supply this parameter when you use the Repository parameter set. If this setting has been configured using the Shared parameter set, then this parameter is optional when using the Repository parameter set.

A repository-specific setting overrides the Shared setting.

DisplayURLPatternForDocument

Required

System.String

This parameter sets the format of the display URL for Documentum documents. The value of this parameter must be a valid URL. There are three placeholders that can be used in this URL:

{ObjectId} - This placeholder will be replaced with the Documentum object ID.

{RepositoryName} - This placeholder will be replaced with the Documentum repository name.

{Format} - This placeholder will be replaced by the MIME type of the attachment to the document. If there is no attachment, this will be replaced with an empty string.

The following example is an example of a document which would be accessible from a Documentum Webtop server named "MyWebtopServer" on port 20000:

-DisplayURLPatternForContainer "http://MyWebtopServer:20000/webtop/drl/objectId/{ObjectId}/format/{Format}"

This parameter must be supplied when the Shared parameter set is used. If this setting has not been configured using the Shared parameter set, you must supply this parameter when you use the Repository parameter set. If this setting has been configured using the Shared parameter set, then this parameter is optional when using the Repository parameter set.

A repository-specific setting overrides the Shared setting.

Shared

Required

System.Management.Automation.SwitchParameter

Mandatory switch parameter for the shared configuration parameter set.

DFSURL

Optional

System.String

Specifies one or more DFS web service URLs for one or more repositories. The format of this parameter's value is a repository name followed by one or more DFS web service URLs, each separated with a single backslash. More than one repository can be specified by separating repositories by a double backslash. The following example specifies the DFS web service URLs of two repositories. Repository Alpha has one DFS web service URL and repository Beta has two:

-DFSURL "Alpha\http://dfsAlpha:10000/services\\Beta\http://dfsBetaOne:10000/services\http://dfsBetaTwo:10000/services"

This parameter may be used only with the Shared parameter set.

PersistDCTMACL

Optional

System.Nullable

This parameter is obsolete and has no function. You should not use this parameter.

UnmappedAccount

Optional

System.Nullable

This parameter is used only when the ACLTranslation mode is set to UserMappingTable. This parameter sets the behavior when a Documentum account is not found in the user mapping table. It is an enumeration with two possible values:

DiscardACE: This is the default value. The indexing connector for Documentum discards a Documentum account when no mapped Windows domain account is found. If there is any other mapped account for the document, the document will be crawled. If none of the Documentum accounts for a document can be mapped, the document will not be added to the search index and an error will be reported for this document in the crawl log.

AssumeSameAccount: If a Documentum account does not have a mapping in the user mapping table, the connector will try to map the Documentum account to an account in the Windows domain with the same username. If no such account exists, the security entry will be ignored.

This parameter may be used with both the Shared and Repository parameter sets.

A repository specific setting overrides the Shared setting.

UserMappingTableDBName

Optional

System.String

Name of the SQL Server database which contains the user mapping table.

This parameter may be used only with the Shared parameter set.

UserMappingTableName

Optional

System.String

Name of the user mapping table.

This parameter may be used only with the Shared parameter set.

UserMappingTableSQLInstance

Optional

System.String

Name of the SQL Server instance that contains the user mapping table.

This parameter may be used only with the Shared parameter set.

UserMappingTableSQLServer

Optional

System.String

Host name of the SQL Server that contains the user mapping table.

This parameter may be used only with the Shared parameter set.

2

Parameter

Required

Type

Description

ACLTranslation

Required

System.Nullable

Specifies how the Documentum indexing connector processes security descriptors of the documents it crawls. It is an enumeration with four possible values:

UserMappingTable: This is the default value. Documentum security descriptors will be translated to Windows security descriptors based on the mappings defined in a user mapping table in a database. There can be only one Documentum user mapping table per SharePoint farm, and multiple SharePoint farms can reference the same mapping table. The parameters UserMappingTableSQLServer, UserMappingTableSQLInstance, and UserMappingTableName must be set using the Shared parameter set if the SharedACLTranslation type is UserMappingTable or if any repository's ACLTranslation type is UserMappingTable, even if the SharedACLTranslation type is not UserMappingTable. The UnMappedAccount parameter is optional when ACLTranslation type is UserMappingTable.

NoSecurity: Documentum security descriptors are ignored at crawl time. All documents from Documentum will be searchable by any SharePoint user. This option is intended to be used with a custom security trimming solution.

SameAccountName: Permissions to a document are granted using the Documentum account name in the Windows domain. This setting is used when users have the same username for both Documentum and Windows domain accounts, such as a shared account in Active Directory. If a document's security descriptor contains an account name that is not an existing Windows account, that security entry is ignored.

Claims: The Documentum security descriptor is encoded in a claims format. This is intended to be used with the Documentum custom security trimmer included with the indexing connector.

The ACLTranslation parameter must be supplied when the Shared parameter set is used. If this setting has not been configured using the Shared parameter set, you must supply this parameter when you use the Repository parameter set. If this setting has been configured using the Shared parameter set, then this parameter is optional when using the Repository parameter set.

A repository-specific setting overrides the Shared setting.

DisplayURLPatternForContainer

Required

System.String

This parameter sets the format of the display URL for Documentum folders and cabinets. The value of this parameter must be a valid URL. There are two placeholders that can be used in this URL:

{ObjectId} - This placeholder will be replaced with the Documentum object ID.

{RepositoryName} - This placeholder will be replaced with the Documentum repository name.

The following example is an example of a folder or cabinet which would be accessible from a Documentum Webtop server named "MyWebtopServer" on port 20000:

-DisplayURLPatternForContainer "http://MyWebtopServer:20000/webtop/drl/objectId/{ObjectId}"

This parameter must be supplied when the Shared parameter set is used. If this setting has not been configured using the Shared parameter set, you must supply this parameter when you use the Repository parameter set. If this setting has been configured using the Shared parameter set, then this parameter is optional when using the Repository parameter set.

A repository-specific setting overrides the Shared setting.

DisplayURLPatternForDocument

Required

System.String

This parameter sets the format of the display URL for Documentum documents. The value of this parameter must be a valid URL. There are three placeholders that can be used in this URL:

{ObjectId} - This placeholder will be replaced with the Documentum object ID.

{RepositoryName} - This placeholder will be replaced with the Documentum repository name.

{Format} - This placeholder will be replaced by the MIME type of the attachment to the document. If there is no attachment, this will be replaced with an empty string.

The following example is an example of a document which would be accessible from a Documentum Webtop server named "MyWebtopServer" on port 20000:

-DisplayURLPatternForContainer "http://MyWebtopServer:20000/webtop/drl/objectId/{ObjectId}/format/{Format}"

This parameter must be supplied when the Shared parameter set is used. If this setting has not been configured using the Shared parameter set, you must supply this parameter when you use the Repository parameter set. If this setting has been configured using the Shared parameter set, then this parameter is optional when using the Repository parameter set.

A repository-specific setting overrides the Shared setting.

Repository

Required

System.Management.Automation.SwitchParameter

Mandatory switch parameter for the repository-specific configuration parameter set.

RepositoryName

Required

System.String

Supplies the repository name. This name is case sensitive and should match the Documentum repository name.

This parameter must be supplied when using either the Repository or Remove parameter set.

DFSWebServiceURL

Optional

System.String[]

Specifies the DFS web service URLs for the named repository.

This parameter is part of the Repository parameter set. If the specified repository has no DFS web service URLs, you must supply this parameter with at least one DFS web service URL. If the specified repository has one or more DFS web service URL, this parameter is optional.

IndexAllVersions

Optional

System.Management.Automation.SwitchParameter

If this parameter is set to True, all versions of all documents for the named repository will be indexed instead of just the current version. You should specify this parameter only if you have a specific requirement to index all versions of a document.

This parameter may be used only with the Repository parameter set.

PersistDCTMACL

Optional

System.Nullable

This parameter is obsolete and has no function. You should not use this parameter.

UnmappedAccount

Optional

System.Nullable

This parameter is used only when the ACLTranslation mode is set to UserMappingTable. This parameter sets the behavior when a Documentum account is not found in the user mapping table. It is an enumeration with two possible values:

DiscardACE: This is the default value. The indexing connector for Documentum discards a Documentum account when no mapped Windows domain account is found. If there is any other mapped account for the document, the document will be crawled. If none of the Documentum accounts for a document can be mapped, the document will not be added to the search index and an error will be reported for this document in the crawl log.

AssumeSameAccount: If a Documentum account does not have a mapping in the user mapping table, the connector will try to map the Documentum account to an account in the Windows domain with the same username. If no such account exists, the security entry will be ignored.

This parameter may be used with both the Shared and Repository parameter sets.

A repository specific setting overrides the Shared setting.

3
Parameter | Required | Type | Description
Remove | Required | System.Management.Automation.SwitchParameter | Mandatory switch parameter for the repository removal parameter set.
Repository | Required | System.Management.Automation.SwitchParameter | Mandatory switch parameter for the repository-specific configuration parameter set.
RepositoryName | Required | System.String | Supplies the repository name. This name is case sensitive and should match the Documentum repository name. This parameter must be supplied when using either the Repository or Remove parameter set.

Detailed Description

Use this cmdlet to configure the Indexing Connector for Documentum.

Important:

Before you run the cmdlet, you may have to perform other procedures. Which procedures you must perform depends on which connector configuration mode you choose. For more information, see Configure and use the Documentum connector in SharePoint Server 2013.

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------

Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Shared -ACLTranslation UserMappingTable -DisplayURLPatternForContainer "http://WebTopServer:20000/webtop/component/drl?objectId={ObjectId}&RepositoryName={RepositoryName}" -DisplayURLPatternForDocument "http://WebTopServer:20000/webtop/component/drl?objectId={ObjectId}&format={Format}&RepositoryName={RepositoryName}" -UnmappedAccount "DiscardACE" -UserMappingTableSQLServer "YourDatabaseServerName" -UserMappingTableSQLInstance "YourDatabaseInstanceName" -UserMappingTableDBName "YourMappingDatabaseName" -UserMappingTableName "YourMappingTableName"
Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "RepositoryOne" -DFSWebServiceURL @("http://DFSWebServices:30000/services", "http://DFSWebServices2:30000/services")
Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "RepositoryTwo" -DFSWebServiceURL @("http://DFSWebServices:30000/services")

This example configures the Indexing Connector for Documentum to index two repositories, RepositoryOne, and RepositoryTwo. The connector is configured to use a user mapping table, and common display URL patterns are set. The repositories and their respective DFS web service URLs are then added to the configuration.

------------------EXAMPLE 2-----------------

Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Shared -ACLTranslation UserMappingTable -DisplayURLPatternForContainer "http://WebTopServer:20000/webtop/component/drl?objectId={ObjectId}&RepositoryName={RepositoryName}" -DisplayURLPatternForDocument "http://WebTopServer:20000/webtop/component/drl?objectId={ObjectId}&format={Format}&RepositoryName={RepositoryName}" -UnmappedAccount "DiscardACE" -UserMappingTableSQLServer "YourDatabaseServerName" -UserMappingTableSQLInstance "YourDatabaseInstanceName" -UserMappingTableDBName "YourMappingDatabaseName" -UserMappingTableName "YourMappingTableName"
Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "RepositoryOne" -DFSWebServiceURL @("http://DFSWebServices:30000/services", "http://DFSWebServices2:30000/services")
Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "RepositoryTwo" -DFSWebServiceURL @("http://DFSWebServices:30000/services") -ACLTranslation SameAccountName
Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "RepositoryThree" -DFSWebServiceURL @("http://DFSWebServices2:30000/services") -ACLTranslation Claims

This example configures the Documentum indexing connector to index three repositories, RepositoryOne, RepositoryTwo and RepositoryThree. The connector is configured to use a user mapping table, and common display URL patterns are set. The repositories and their respective DFS web service URLs are then added to the configuration. The repositories are individually configured, with their DFS web service URLs and the ACLTranslation settings of RepositoryTwo and RepositoryThree are overridden.

Any repositories that are subsequently added will use the user mapping table, unless that setting is overridden.

------------------EXAMPLE 3-----------------

Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Remove -RepositoryName "RepositoryTwo"

This example assumes you have run the PowerShell commands as listed in Example 2. This example removes RepositoryTwo from the configuration.

------------------EXAMPLE 4-----------------

Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Shared -ACLTranslation UserMappingTable -DisplayURLPatternForContainer "http://WebTopServer:20000/webtop/component/drl?objectId={ObjectId}&RepositoryName={RepositoryName}" -DisplayURLPatternForDocument "http://WebTopServer:20000/webtop/component/drl?objectId={ObjectId}&format={Format}&RepositoryName={RepositoryName}" -UnmappedAccount "DiscardACE" -UserMappingTableSQLServer "YourDatabaseServerName" -UserMappingTableSQLInstance "YourDatabaseInstanceName" -UserMappingTableDBName "YourMappingDatabaseName" -UserMappingTableName "YourMappingTableName"Set-SPEnterpriseSearchDCTMConnectorConfig -Remove -RepositoryName "RepositoryTwo"
Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "RepositoryOne" -DFSWebServiceURL @("http://DFSWebServices:30000/services", "http://DFSWebServices2:30000/services") -DisplayURLPatternForContainer "http://DifferentWebTopServer:20000/webtop/component/drl?objectId={ObjectId}&RepositoryName={RepositoryName}" -DisplayURLPatternForDocument "http://DifferentWebTopServer:20000/webtop/component/drl?objectId={ObjectId}&format={Format}&RepositoryName={RepositoryName}"
Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "RepositoryTwo" -DFSWebServiceURL @("http://DFSWebServices:30000/services") -ACLTranslation SameAccountName
Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Repository -RepositoryName "RepositoryThree" -DFSWebServiceURL @("http://DFSWebServices2:30000/services") -ACLTranslation NoSecurity -IndexAllVersions

This example specifies different display URL patterns for RepositoryOne, and it sets the IndexAllVersions switch parameter for RepositoryThree.

------------------EXAMPLE 5-----------------

Copy code
Set-SPEnterpriseSearchDCTMConnectorConfig -Shared -ACLTranslation Claims -DisplayURLPatternForContainer "http://WebTopServer:20000/webtop/component/drl?objectId={ObjectId}&RepositoryName={RepositoryName}" -DisplayURLPatternForDocument "http://WebTopServer:20000/webtop/component/drl?objectId={ObjectId}&format={Format}&RepositoryName={RepositoryName}" -DFSURL "RepositoryOne\http://DFSWebServices:10000/services\\RepositoryTwo\http://DFSWebServices2:20000/services\http://DFSWebServices3:30000/services"

This example uses a single cmdlet invocation to fully configure two repositories.


Secure Store Service cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you manage the Secure Store Service in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

The Secure Store Service is a claims-aware authentication service that includes a secure database for storing credentials that are associated with application IDs. These application IDs can be used to authorize access to external data sources. The Secure Store Service provides the capability of securely storing credentials and associating them to specific identities or a group of identities. A common scenario for Secure Store Service is an application trying to authenticate against a system in which the current user is known by a different name or has a different account for authentication. When used with Microsoft Business Connectivity Services, the Secure Store Service provides a means to authenticate against external data sources.

When you use Windows PowerShell cmdlets, you can create and configure a Secure Store Service instance, configure the settings of a credentials database, and configure all global settings of the Secure Store Service.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Clear-SPSecureStoreCredentialMapping | Deletes a credential mapping from a Secure Store Service application.
Clear-SPSecureStoreDefaultProvider | Clears the secure store provider.
Disable-SPSingleSignOn | Disables the single sign-on (SSO) service on a farm server.
Get-SPSecureStoreApplication | Returns a Secure Store application.
New-SPSecureStoreApplication | Creates a new Secure Store application.
New-SPSecureStoreApplicationField | Creates a new Secure Store application fields object.
New-SPSecureStoreServiceApplication | Creates a new Secure Store Service application in the farm.
New-SPSecureStoreServiceApplicationProxy | Creates a new Secure Store Service application proxy in the farm.
New-SPSecureStoreTargetApplication | Creates a new Secure Store target application.
Remove-SPSecureStoreApplication | Deletes a Secure Store application.
Set-SPSecureStoreApplication | Sets properties of a Secure Store application.
Set-SPSecureStoreDefaultProvider | Sets or updates the secure store provider.
Set-SPSecureStoreServiceApplication | Sets properties of a Secure Store Service application in the farm.
Update-SPSecureStoreApplicationServerKey | Synchronizes the key on a server running SharePoint Server by using the Secure Store master key.
Update-SPSecureStoreCredentialMapping | Sets a new credential mapping for a Secure Store Service application.
Update-SPSecureStoreGroupCredentialMapping | Sets a new group credential mapping for a Secure Store Service application.
Update-SPSecureStoreMasterKey | Changes the master key of a Secure Store Service application.
Upgrade-SPSingleSignOnDatabase | Migrates the application definitions from single sign-on (SSO) database to Secure Store database as target applications.
Add-SPSecureStoreSystemAccount | Adds an account to a designated list.
Get-SPSecureStoreSystemAccount | Returns a list of users from a designated list.
Remove-SPSecureStoreSystemAccount | Removes a user account from a designated list.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Clear-SPSecureStoreCredentialMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes a credential mapping from a Secure Store Service application.

Clear-SPSecureStoreCredentialMapping -Identity <SPSecureStoreApplication> -Principal <SPClaim> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Clear-SPSecureStoreCredentialMapping -All <SwitchParameter> -Principal <SPClaim> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.Office.SecureStoreService.PowerShellCmdlet.SPSecureStoreApplication

Specifies the Secure Store application (that contains the principal) from which to delete the credential mapping.

Principal

Required

Microsoft.SharePoint.SPClaim

Specifies the SPClaims object that contains the principal.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

All

Required

System.Management.Automation.SwitchParameter

Specifies that the principal is deleted from all Secure Store applications.

Principal

Required

Microsoft.SharePoint.SPClaim

Specifies the SPClaims object that contains the principal.

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for which the credential mapping will be deleted.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Clear-SPSecureStoreCredentialMapping cmdlet deletes a credential mapping from a Secure Store application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssApp = Get-SPSecureStoreApplication -ServiceContext http://contoso -Name "ContosoTargetApplication"
Copy code
$userClaim = New-SPClaimsPrincipal -Identity "CONTOSO\janedoe" -IdentityType WindowsSamAccountName
Copy code
Clear-SPSecureStoreCredentialMapping -Identity $ssApp -Principal $userClaim

This example deletes the credential mapping from the target application ContosoTargetApplication for the user with alias johndoe and domain CONTOSO.

See also

Update-SPSecureStoreCredentialMapping


Clear-SPSecureStoreDefaultProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Clears the secure store provider.

Clear-SPSecureStoreDefaultProvider [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Clear-SPSecureStoreDefaultProvider cmdlet clears the secure store provider.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Clear-SPSecureStoreDefaultProvider

This example clears the secure store provider.

See also

Set-SPSecureStoreDefaultProvider


Disable-SPSingleSignOn
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Disables the single sign-on (SSO) Service on a farm server.

Disable-SPSingleSignOn -ServerName <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServerName

Required

System.String

Specifies the name of the server in which the service is running.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Disable-SPSingleSignOn cmdlet to disable the SSO Service on a farm server.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Disable-SPSingleSignOn myOldSSO -ServerName CONTOSO

This example turns off the SSO Service on the server named CONTOSO.

See also

Upgrade-SPSingleSignOnDatabase


Get-SPSecureStoreApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a Secure Store application.

Get-SPSecureStoreApplication -Name <String> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPSecureStoreApplication -All <SwitchParameter> -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the Secure Store application to get.

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for the local Secure Store application to connect to.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for the local Secure Store application to connect to.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPSecureStoreApplication cmdlet returns a Secure Store application.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$ssApp = Get-SPSecureStoreApplication -ServiceContext http://contoso -Name "ContosoTargetApplication"

This example gets the Secure Store application for the target application with the name ContosoTargetApplication.

------------------EXAMPLE 2------------------

Copy code
Get-SPSecureStoreApplication -ServiceContext http://contoso -All

This example returns all of the Secure Store applicationshttp://contoso.

See also

New-SPSecureStoreApplication
Set-SPSecureStoreApplication
Remove-SPSecureStoreApplication
Update-SPSecureStoreApplicationServerKey


New-SPSecureStoreApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Secure Store application.

New-SPSecureStoreApplication -Fields <TargetApplicationField[]> -ServiceContext <SPServiceContextPipeBind> -TargetApplication <TargetApplication> [-Administrator <SPClaim[]>] [-AssignmentCollection <SPAssignmentCollection>] [-CredentialsOwnerGroup <SPClaim[]>] [-TicketRedeemer <SPClaim[]>]

Parameters

Parameter Required Type Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for the target application.

TargetApplication

Required

Microsoft.Office.SecureStoreService.Server.TargetApplication

Specifies information about the target application. For example, the TargetApplication object includes data values for application name, display name, contact info, enable ticketing flag, and URL address to set the credential. The schema for the TargetApplication object is defined in the ISecureSToreProviderExtended interface that exposes the target application metadata.

Administrator

Optional

Microsoft.SharePoint.SPClaim[]

Specifies the administrator of the new Secure Store application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CredentialsOwnerGroup

Optional

Microsoft.SharePoint.SPClaim[]

Specifies the claims object for the groups that own the group credentials.

Fields

Optional

Microsoft.Office.SecureStoreService.Server.TargetApplicationField[]

Specifies the field information for the application. The default fields are username and password.

TicketRedeemer

Optional

Microsoft.SharePoint.SPClaim[]

Specifies the ticket redeemer claim value.

Detailed Description

The New-SPSecureStoreApplication cmdlet creates a new Secure Store application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$usernameField = New-SPSecureStoreApplicationField -Name "UserName" -Type WindowsUserName -Masked:$false

$passwordField = New-SPSecureStoreApplicationField -Name "Password" -Type WindowsPassword -Masked:$true

$fields = $usernameField,$passwordField

$userClaim = New-SPClaimsPrincipal -Identity "CONTOSO\janedoe" -IdentityType WindowsSamAccountName

$contosoTargetApp = New-SPSecureStoreTargetApplication -Name "ContosoTargetApplication" -FriendlyName "Contoso Target Application" -ApplicationType Group

New-SPSecureStoreApplication -ServiceContext http://contoso -TargetApplication $contosoTargetApp -Fields $fields -Administrator $claimUser

This example creates a new group target application ContosoTargetApplication, and then a new application for that target application. This new application has two fields; UserName of type WindowsUserName, and Password of type WindowsPassword. The user with identity janedoe on the CONTOSO domain is set as the target application administrator.

See also

Get-SPSecureStoreApplication
Set-SPSecureStoreApplication
Remove-SPSecureStoreApplication


New-SPSecureStoreApplicationField
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Secure Store application fields object.

New-SPSecureStoreApplicationField -Masked <SwitchParameter> -Name <String> -Type <UserName | Password | Pin | Key | Generic | WindowsUserName | WindowsPassword | Certificate | CertificatePassword> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Masked

Required

System.Management.Automation.SwitchParameter

Masks the visible characters that are typed in the field.

Name

Required

System.String

Specifies the name of the new target application field.

Type

Required

Microsoft.BusinessData.Infrastructure.SecureStore.SecureStoreCredentialType

Specifies the type of credential field to add to a target application.

The type must be one of the following: UserName, Password, Pin, Key, Generic, WindowsUserName, or WindowsPassword.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The New-SPSecureStoreApplicationField cmdlet creates a new Secure Store application field object for a target application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
New-SPSecureStoreApplicationField -Name "UserName" -Type WindowsUserName -Masked:$false

This example creates a new credential field of type WindowsUserName with the name UserName, and the masked property (which when true will hide characters as they are typed in by the user) set to false. This cmdlet is typically used in conjunction with the New-SPSecureStoreApplication cmdlet.

See also

New-SPSecureStoreTargetApplication
New-SPSecureStoreApplication


New-SPSecureStoreServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Secure Store Service application in the farm.

New-SPSecureStoreServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> -AuditingEnabled <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-AuditlogMaxSize <Nullable>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-Name <String>] [-PartitionMode <SwitchParameter>] [-Sharing <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ApplicationPool

Required

Microsoft.SharePoint.Administration.SPIisWebServiceApplicationPool

Specifies the existing IIS application pool to run the Web service in for the new service application.

AuditingEnabled

Required

System.Management.Automation.SwitchParameter

Turns on auditing for the Secure Store Service.

Name

Required

System.String

Specifies the name of the new Secure Store Service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuditlogMaxSize

Optional

System.Nullable

Specifies the number of days to retain the audit log.

The type must be a valid integer.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL authentication.

DatabaseName

Optional

System.String

Specifies the name of the Secure Store service database.

DatabasePassword

Optional

System.Security.SecureString

Specifies the password for the user specified in DatabaseUserName. Use this parameter only if SQL authentication is used to access the metadata service application database.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the database specified in DatabaseName.

DatabaseUsername

Optional

System.String

Specifies the user name to use for connecting to the database for the Secure Store service application. Use this parameter only if SQL authentication is used to access the service application database.

FailoverDatabaseServer

Optional

System.String

Specifies the name of the host server for the failover database server.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application restricts data by subscription ID. This property cannot be changed after the service application is created.

Sharing

Optional

System.Management.Automation.SwitchParameter

Specifies that the Secure Store service application is published and shared across the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPSecureStoreServiceApplication cmdlet creates a new Secure Store Service application in the farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
New-SPSecureStoreServiceApplication -ApplicationPool "SharePoint Web Services Default" -AuditingEnabled:$false -DatabaseServer "CONTOSO\SharePoint" -DatabaseName "ContosoSSDatabase"-Name "Contoso Secure Store"

This example creates a new Secure Store Service application with the name Contoso Secure Store with auditing disabled, and creates a database with the name ContosoSSDatabase on the given database server for use with the service application.

See also

Set-SPSecureStoreServiceApplication
New-SPSecureStoreServiceApplicationProxy


New-SPSecureStoreServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Secure Store Service application proxy in the farm.

New-SPSecureStoreServiceApplicationProxy -Uri <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-Name <String>] [-WhatIf [<SwitchParameter>]]
New-SPSecureStoreServiceApplicationProxy -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Uri

Required

System.Uri

Specifies the URI of a remote Secure Store Service application associated with the new proxy.

The type must be a valid URI, in the form file:\\server_name\sitedocs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application proxy be added to the farm's default proxy group.

Name

Optional

System.String

Specifies the name of the new service application proxy to create.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the local Secure Store Service application associated with the new proxy.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application proxy be added to the farm's default proxy group.

Name

Optional

System.String

Specifies the name of the new service application proxy to create.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPSecureStoreServiceApplicationProxy cmdlet creates a new Secure Store Service application proxy for a Secure Store Service application in the farm.

The New-SPSecureStoreServiceApplicationProxy cmdlet does not specify whether the service application proxy is partitioned or not. If you want to specify a partitioned service application proxy, a partitioned service application can be created by using the New-SPSecureStoreServiceApplication cmdlet. The result of the New-SPSecureStoreServiceApplication cmdlet can be passed to the New-SPSecureStoreServiceApplicationProxy cmdlet. Similarly, if you want to specify an unpartitioned service application proxy, an unpartitioned service application can be created by using the New-SPSecureStoreServiceApplication cmdlet. The result of the New-SPSecureStoreServiceApplication cmdlet can be passed to the New-SPSecureStoreServiceApplicationProxy cmdlet.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE 1------------------

Copy code
New-SPSecureStoreServiceApplicationProxy -Name "Contoso Service Application Proxy" -ServiceApplication $SSServiceApp

This example creates a new Secure Store Service application proxy with the name Contoso Service Application Proxy for the given service application.

------------------EXAMPLE 2------------------

Copy code
$nameofproxy = "Connection to: HostedSecureStoreInParentFarm"
Copy code
$proxy = Get-SPServiceApplicationProxy | where {$_ -match $nameofproxy}
Copy code
$prop = $proxy.Properties
Copy code
$type = $prop["Microsoft.Office.Server.Utilities.SPPartitionOptions"].GetType()
Copy code
$partition = [enum]::Parse( $type, 1 )
Copy code
$prop["Microsoft.Office.Server.Utilities.SPPartitionOptions"] = $partition
Copy code
$proxy.Update()

This example converts an unpartitioned secure store service application proxy in the child to a partitioned one.

See also

New-SPSecureStoreServiceApplication
Set-SPSecureStoreServiceApplication


New-SPSecureStoreTargetApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Secure Store target application.

New-SPSecureStoreTargetApplication -ApplicationType <Individual | Group | IndividualWithTicketing | GroupWithTicketing | RestrictedIndividual | RestrictedGroup> -FriendlyName <String> -Name <String> [-AssignmentCollection <SPAssignmentCollection>] [-ContactEmail <String>] [-SetCredentialsUri <Uri>] [-TimeoutInMinutes <Int32>]

Parameters

Parameter Required Type Description

ApplicationType

Required

Microsoft.BusinessData.Infrastructure.SecureStore.TargetApplicationType

Specifies the type of target application.

The type must be one of the following: Individual, Group, IndividualWithTicketing, GroupWithTicketing, RestrictedIndividual, or RestrictedGroup.

FriendlyName

Required

System.String

Specifies the name of the new target application.

Name

Required

System.String

Specifies the display name of the new target application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ContactEmail

Optional

System.String

Specifies the contact information for the target application.

SetCredentialsUri

Optional

System.Uri

Specifies the URI for setting the user application credentials.

The type must be a valid URI, in the form file:\\server_name\sitedocs.

TimeoutInMinutes

Optional

System.Int32

The time, in minutes, a ticket is valid if it is not redeemed by the target application. Make sure that the ticket time-out value is long enough to last between the time when the ticket is issued to the time that it is redeemed The default value is 2.

The type must be a valid integer.

Detailed Description

The New-SPSecureStoreTargetApplication cmdlet creates a new Secure Store Target application.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
New-SPSecureStoreTargetApplication -Name "ContosoTargetApplication" -FriendlyName "Contoso Target Application" -ApplicationType Group

This example creates a new group type target application with the given name and friendly display name.

See also

New-SPSecureStoreApplicationField


Remove-SPSecureStoreApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes a Secure Store application.

Remove-SPSecureStoreApplication -Identity <SPSecureStoreApplication> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.SecureStoreService.PowerShellCmdlet.SPSecureStoreApplication

Specifies the Secure Store application to delete.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPSecureStoreApplication cmdlet deletes a Secure Store application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPSecureStoreApplication -ServiceContext http://contoso -Name "ContosoTargetApp" | Remove -SPSecureStoreApplication

This example removes the specified application and target.

See also

Get-SPSecureStoreApplication
New-SPSecureStoreApplication
Set-SPSecureStoreApplication


Set-SPSecureStoreApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets properties of a Secure Store application.

Set-SPSecureStoreApplication -Identity <SPSecureStoreApplication> [-Administrator <SPClaim[]>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-CredentialsOwnerGroup <SPClaim[]>] [-Fields <TargetApplicationField[]>] [-TargetApplication <TargetApplication>] [-TicketRedeemer <SPClaim[]>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.SecureStoreService.PowerShellCmdlet.SPSecureStoreApplication

Specifies the Secure Store application to update.

Administrator

Optional

Microsoft.SharePoint.SPClaim[]

Specifies the administrator of the Secure Store application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

CredentialsOwnerGroup

Optional

Microsoft.SharePoint.SPClaim[]

Specifies the claims object for the groups that own the group credentials.

Fields

Optional

Microsoft.Office.SecureStoreService.Server.TargetApplicationField[]

Specifies the field information for the application. The default fields are username and password.

TargetApplication

Optional

Microsoft.Office.SecureStoreService.Server.TargetApplication

Specifies the target application.

TicketRedeemer

Optional

Microsoft.SharePoint.SPClaim[]

Specifies the ticket redeemer claim value.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPSecureStoreApplication cmdlet sets properties of a Secure Store application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$targetApp.FriendlyName = "Updated Contoso Target App"
Copy code
Set-SPSecureStoreApplication -Identity $application -TargetApplication $targetApp

This example sets a new display name Updated Contoso Target App for the target application.

See also

Get-SPSecureStoreApplication
New-SPSecureStoreApplication
Remove-SPSecureStoreApplication


Set-SPSecureStoreDefaultProvider
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Updates the secure store provider.

Set-SPSecureStoreDefaultProvider -Type <Type> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Type

Required

System.Type

Specifies the provider type. The type must be loaded in memory.

The type must be a secure store provider type enclosed in square brackets; for example, [Reflection.Assembly].

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Set-SPSecureStoreDefaultProvider cmdlet sets or replaces the secure store provider. To register a third-party secure store, implement the ISecureStoreProvider interface. With the interface defined, place the DLL file in the global assembly cache, and then load the DLL and load the type, as shown in the example. You can then set the secure store provider.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
[Reflection.Assembly]::LoadFrom("C:\ContosoFolder\contosoSecureStore.dll")
Copy code
$type = [Contoso.SecureStore.ContosoSecureStoreProvider]
Copy code
Set-SPSecureStoreDefaultProvider -Type $type

This example sets the custom implemented secure store provider.


Set-SPSecureStoreServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets properties of a Secure Store Service application in the farm.

Set-SPSecureStoreServiceApplication -Identity <SPServiceApplicationPipeBind> [-ApplicationPool <SPIisWebServiceApplicationPool>] [-AssignmentCollection <SPAssignmentCollection>] [-AuditingEnabled <SwitchParameter>] [-AuditlogMaxSize <Nullable>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-Sharing <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application to update.

ApplicationPool

Optional

Microsoft.SharePoint.Administration.SPIisWebServiceApplicationPool

Specifies the existing IIS application pool to run the Web service in for the new service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuditingEnabled

Optional

System.Management.Automation.SwitchParameter

Turns on auditing for the Secure Store Service.

AuditlogMaxSize

Optional

System.Nullable

Specifies the number of days to retain the audit log.

The type must be a valid integer.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL authentication.

DatabaseName

Optional

System.String

Specifies the name of the Secure Store service database.

DatabasePassword

Optional

System.Security.SecureString

Specifies the password for the user specified in DatabaseUserName. Use this parameter only if SQL authentication is used to access the metadata service application database.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the database specified in DatabaseName.

DatabaseUsername

Optional

System.String

Specifies the user name to use for connecting to the database for the Secure Store service application. Use this parameter only if SQL authentication is used to access the service application database.

FailoverDatabaseServer

Optional

System.String

Specifies the name of the host server for the failover database server.

Sharing

Optional

System.Management.Automation.SwitchParameter

Specifies that the Secure Store Service application is published and shared across the farm.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPSecureStoreServiceApplication cmdlet sets properties of a Secure Store Service application in the farm.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Set-SPSecureStoreServiceApplication -Identity $contosoServApp -AuditlogMaxSize 40

This example sets the maximum size of the audit log to 40 days for the given service application.

See also

New-SPSecureStoreServiceApplication
New-SPSecureStoreServiceApplicationProxy


Update-SPSecureStoreApplicationServerKey
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Synchronizes the key on a Microsoft SharePoint server with the Secure Store master key.

Update-SPSecureStoreApplicationServerKey -Passphrase <String> -ServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Passphrase

Required

System.String

Specifies the passphrase that is used for the Secure Store service database.

ServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the proxy of the service application that contains the server key to synchronize.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Update-SPSecureStoreApplicationServerKey cmdlet synchronizes the key on a SharePoint server with the master key for the Secure Store service database.

Updating a server key is required when:

  • A new SharePoint server that will run a Secure Store service instance is joined to the farm.

  • The key stored in the server is not the key required for the current Secure Store service database (because of server or networking issues).

  • The master key is updated but during propagation of the new key, this process fails on one or more of the servers.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$newPassPhrase = "abcDEF123!"

Update-SPSecureStoreApplicationServerKey -ServiceApplicationProxy $contosoProxy -Passphrase $newPassPhrase

This example synchronizes the passphrase of the server key on a SharePoint server with the master key for the Secure Store service database.

See also

Update-SPSecureStoreMasterKey


Update-SPSecureStoreCredentialMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets a new credential mapping for a Secure Store Service application.

Update-SPSecureStoreCredentialMapping -Identity <SPSecureStoreApplication> -Principal <SPClaim> -Values <SecureString[]> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.SecureStoreService.PowerShellCmdlet.SPSecureStoreApplication

Specifies the Secure Store Service application (that contains the principal) from which to delete the credential mapping.

Principal

Required

Microsoft.SharePoint.SPClaim

Specifies the SPClaims object that contains the principal.

Values

Required

System.Security.SecureString[]

Specifies the field values for the credential mapping.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Update-SPSecureStoreCredentialMapping cmdlet sets a new credential mapping for a Secure Store Service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssApp = Get-SPSecureStoreApplication -ServiceContext http://contoso -Name "ContosoTargetApplication"

$firstCredential = ConvertTo-SecureString "LOBDATABASE\jdoe" -AsPlainText -Force

$secondCredential = ConvertTo-SecureString "abcDEF123$%^" -AsPlainText -Force

$credentialValues = $firstCredential,$secondCredential

$userClaim = New-SPClaimsPrincipal -Identity "CONTOSO\janedoe" -IdentityType WindowsSamAccountName

Update-SPSecureStoreCredentialMapping -Identity $ssApp -Values $credentialValues -Principal $userClaim

This example updates a credential mapping for the given site and the target application ContosoTargetApplication, for the user with the identity janedoe on domain CONTOSO. This user is mapped to a pair of credential values on the External System with a username of identity jdoe on domain LOBDATABASE and password abcDEF123$%^.

See also

Clear-SPSecureStoreCredentialMapping
Update-SPSecureStoreGroupCredentialMapping


Update-SPSecureStoreGroupCredentialMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets a new group credential mapping for a Secure Store Service application.

Update-SPSecureStoreGroupCredentialMapping -Identity <SPSecureStoreApplication> -Values <SecureString[]> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.SecureStoreService.PowerShellCmdlet.SPSecureStoreApplication

Specifies the Secure Store application (that contains the principal) from which to delete the credential mapping.

Values

Required

System.Security.SecureString[]

Specifies the field values for the credential mapping.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Detailed Description

The Update-SPSecureStoreGroupCredentialMapping cmdlet sets a new group credential mapping for a Secure Store Service application. Group credentials are a set of credentials that are associated with multiple identities. Target applications will get credentials for a Secure Store application by using the current user. If the current user meets the authorization rule defined in the Secure Store application for the group credentials, then the data is provided.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$ssApp = Get-SPSecureStoreApplication -ServiceContext http://contoso -Name "ContosoGroupTargetApplication"

$firstCredential = ConvertTo-SecureString "LOBDATABASE\fulltimeemployees" -AsPlainText -Force

$secondCredential = ConvertTo-SecureString "abcDEF123$%^" -AsPlainText -Force

$credentialValues = $firstCredential,$secondCredential

Update-SPSecureStoreGroupCredentialMapping -Identity $ssApp -Values $credentialValues

This example adds a credential mapping for the target application ContosoGroupTargetApplication, for all users in this group target application. These users are mapped to a pair of credential values on the External System with a username of identity fulltimeemployees on domain LOBDATABASE and with password abcDEF123$%^.

See also

Update-SPSecureStoreCredentialMapping
Clear-SPSecureStoreCredentialMapping


Update-SPSecureStoreMasterKey
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Changes the master key of a Secure Store Service application.

Update-SPSecureStoreMasterKey -Passphrase <String> -ServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Passphrase

Required

System.String

Specifies the passphrase that is used for the Secure Store database. The passphrase that you enter is not stored. Make sure that you write down the passphrase and store it in a secure location. The passphrase will be required to add new Secure Store service servers.

ServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the proxy of the Secure Store service application that contains the master key to update.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Reencrypt

Optional

System.Management.Automation.SwitchParameter

Specifies that the database for the Secure Store service application is re-encrypted. This synchronizes the master key in all servers that run an instance of the Secure Store application.

Detailed Description

The Update-SPSecureStoreApplicationServerKey cmdlet changes the master key of a Secure Store Service application.

Updating the master key is required when:

  • A new instance of a service application is created and the database for the Secure Store service application is new or empty.

  • The master key or passphrase has been compromised.

  • Security guidelines require that the passphrase or key be replaced.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$newPassPhrase = "abcDEF123!"
Copy code
Update-SPSecureStoreMasterKey -ServiceApplicationProxy $contosoProxy -Passphrase $newPassPhrase

This example creates a new master key for the given service application.

See also

Update-SPSecureStoreApplicationServerKey


Upgrade-SPSingleSignOnDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Migrates the application definitions from Single Sign-On (SSO) database to Secure Store database as target applications.

Upgrade-SPSingleSignOnDatabase -SecureStoreConnectionString <String> -SecureStorePassphrase <SecureString> -SSOConnectionString <String> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

SecureStoreConnectionString

Required

System.String

Specifies the SQL Server connection string for the Secure Store database.

SecureStorePassphrase

Required

System.Security.SecureString

Specifies the passphrase used for the Secure Store database.

SSOConnectionString

Required

System.String

Specifies the SQL Server connection string for the SSO database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Upgrade-SPSingleSignOnDatabase cmdlet migrates the application definitions from SSO database to Secure Store database as target applications. Use the Upgrade-SPSingleSignOn cmdlet to convert an SSO database to a Secure Store database. SSO is a SharePoint Server feature. SSO functionality is performed by the Secure Store Service in SharePoint Server 2013.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Upgrade-SPSingleSignOnDatabase -SSOConnectionString "Data Source=oldServer;Database=SSO;Trusted_Connection=yes;" -SecureStoreConnectionString "Data Source=CONTOSO\SQLDatabase;Database=ContosoSSDatabase;Trusted_Connection=yes;" -SecureStorePassphrase "abcDEF123!@#"

This example migrates the SSO database at the SSO connection to a Secure Store database at the Secure Store connection.

See also

Disable-SPSingleSignOn


Add-SPSecureStoreSystemAccount
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Adds an account to a designated list.

Add-SPSecureStoreSystemAccount [-AccountName] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AccountName

Required

System.String

Specifies the account name to add.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Add-SPSecureStoreSystemAccount cmdlet to add a user to a list that of accounts which will be considered a system account.

Input Types

Return Types

Example

------------EXAMPLE----------

Copy code
Add-SPSecureStoreSystemAccount -AccountName contoso\jdoe

This example adds the account name jdoe.

See also

Get-SPSecureStoreSystemAccount
Remove-SPSecureStoreSystemAccount


Get-SPSecureStoreSystemAccount
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Returns a list of users from a designated list.

Get-SPSecureStoreSystemAccount [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPSecureStoreSystemAccount cmdlet to return a list of user accounts which are considered to be a system account.

Input Types

Return Types

Example

-------------EXAMPLE----------

Copy code
Get-SPSecureStoreSystemAccount

This example returns a list of user accounts for the secure store system.

See also

Add-SPSecureStoreSystemAccount
Remove-SPSecureStoreSystemAccount


Remove-SPSecureStoreSystemAccount
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Removes a user account from a designated list.

Remove-SPSecureStoreSystemAccount [-Identity] <SPSecureStoreSystemAccountPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.SecureStoreService.PowerShellCmdlet.SPSecureStoreSystemAccountPipeBind

Specifies the name, object, or GUID to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPSecureStoreSystemAccount cmdlet to remove a user account from a designated list of accounts which will be considered a system account.

Input Types

Return Types

Example

--------------EXAMPLE 1----------

Copy code
Remove-SPSecureStoreSystemAccount -Identity contoso\jdoe

This example removes a specific user name jdoe by using the Identity parameter.

--------------EXAMPLE 2----------

Copy code
Get-SPSecureStoreSystemAccount | Where-Object -filter {$_.AccountName -eq 'Contoso\admin'} | Remove-SPSecureStoreSystemAccount

This example removes the admin, user from the contoso domain by filtering the results from the Get-SPSecureStoreSystemAccount cmdlet.

See also

Add-SPSecureStoreSystemAccount
Get-SPSecureStoreSystemAccount


Use Windows PowerShell cmdlets to administer security in SharePoint 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to administer security for SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following table shows the Windows PowerShell cmdlets that you can use to administer security for SharePoint 2013.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Add-SPShellAdmin | Adds a user to the SharePoint_Shell_Access role for the specified database.
Get-SPShellAdmin | Returns the names of all users who have the SharePoint_Shell_Access role.
Remove-SPShellAdmin | Removes a user from the SharePoint_Shell_Access role.
Add-SPClaimTypeMapping | Adds a claim mapping to a trusted security token service (STS) identity provider.
Get-SPAuthenticationProvider | Returns an authentication provider.
Get-SPCertificateAuthority | Returns the SharePoint certificate authority (CA).
Get-SPClaimProvider | Returns a claim provider.
Get-SPClaimProviderManager | Returns a claim provider manager.
Get-SPClaimTypeEncoding | Returns a list of all the types of claims.
Get-SPManagedAccount | Retrieves accounts registered in the configuration database.
Get-SPManagedPath | Returns all managed paths that match the given criteria.
Get-SPSecurityTokenServiceConfig | Returns the security token service (STS) for the farm.
Get-SPServiceApplicationSecurity | Returns the SPObjectSecurity object for a service application.
Get-SPTrustedIdentityTokenIssuer | Returns an identity provider.
Get-SPTrustedRootAuthority | Returns a trusted root authority.
Get-SPTrustedServiceTokenIssuer | Returns the object that represents the farm trust.
Grant-SPObjectSecurity | Adds a new security principal to an SPObjectSecurity object.
Initialize-SPResourceSecurity | Enforces resource security on the local server.
New-SPAuthenticationProvider | Creates a new authentication provider in the farm.
New-SPClaimProvider | Registers a new claim provider in the farm.
New-SPClaimsPrincipal | Creates a new claims principal.
New-SPClaimTypeEncoding | Registers a new type of claim.
New-SPClaimTypeMapping | Creates a claim mapping rule for a security token service (STS) identity provider.
New-SPManagedAccount | Registers a new managed account.
New-SPManagedPath | Creates a new managed path for the given Web application for all host header site collections.
New-SPTrustedIdentityTokenIssuer | Creates an identity provider in the farm.
New-SPTrustedRootAuthority | Creates a trusted root authority.
New-SPTrustedServiceTokenIssuer | Creates a trust with a SharePoint farm.
Remove-SPClaimProvider | Unregisters a claim provider.
Remove-SPClaimTypeMapping | Deletes a claim type mapping rule for a security token service (STS) identity provider.
Remove-SPManagedAccount | Removes a managed account registration from the farm.
Remove-SPManagedPath | Deletes the specified managed path from the specified host header or Web application.
Remove-SPTrustedIdentityTokenIssuer | Deletes a security token service (STS) identity provider from the farm.
Remove-SPTrustedRootAuthority | Deletes a trusted root authority.
Remove-SPTrustedServiceTokenIssuer | Deletes the object that represents the farm trust.
Repair-SPManagedAccountDeployment | Repairs the local managed account credential deployment.
Revoke-SPObjectSecurity | Removes a security principal from a SPObjectSecurity object.
Set-SPClaimProvider | Updates registration of a claims provider.
Set-SPManagedAccount | Configures the managed account.
Set-SPSecurityTokenServiceConfig | Updates the settings of the SharePoint security token service (STS) identity provider.
Set-SPServiceApplicationSecurity | Updates the SPObjectSecurity object for a service application.
Set-SPTrustedIdentityTokenIssuer | Sets the identity providers of a Web application.
Set-SPTrustedRootAuthority | Creates a new trusted root authority.
Set-SPTrustedServiceTokenIssuer | Updates a trust with the farm.
Update-SPFarmEncryptionKey | Changes the value of the farm encryption key and, using the new key, re-encrypts all the data.
Get-SPAuthenticationRealm | Returns the authentication realms.
Get-SPTrustedSecurityTokenIssuer | Returns the trusted security token issuer object.
New-SPAzureAccessControlServiceApplicationProxy | Creates a new service application proxy group.
New-SPTrustedSecurityTokenIssuer | Creates a trust between a server to server principal.
Remove-SPTrustedSecurityTokenIssuer | Removes the trusted security token service object.
Set-SPAuthenticationRealm | Sets the authentication realm.
Set-SPTrustedSecurityTokenIssuer | Sets the trusted token issuer.
Get-SPAppPrincipal | Displays a specific app principal object.
Register-SPAppPrincipal | Lets an on-premises or SharePoint Online administrator register an app principal.
Remove-SPAppPrincipalPermission | Removes the permissions on a specified app principal.
Set-SPAppPrincipalPermission | Sets the permissions on a given app principal.
Convert-SPWebApplication | Converts the authentication mode of a web application.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Add-SPShellAdmin
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a user to the SharePoint_Shell_Access role for the specified database.

Add-SPShellAdmin [-UserName] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-database <SPDatabasePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

UserName

Required

System.String

Specifies the name of the user to add to the SharePoint_Shell_Access role in the target database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

database

Optional

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the GUID of the database or the Database object that includes the SharePoint_Shell_Access role to which you want to add the user. If the database parameter is not specified, the configuration database is used. The farm configuration database is always included, even if you specify another database.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Important:

When you run this cmdlet to add a user to the SharePoint_Shell_Access role, you must have membership in the securityadmin fixed server role on the SQL Server instance, membership in the db_owner fixed database role on all affected databases, and local administrative permission on the local computer.

This cmdlet is intended only to be used with a database that uses Windows authentication. There is no need to use this cmdlet for databases that use SQL authentication; in fact, doing so may result in an error message.

Use the Add-SPShellAdmin cmdlet to add a user to the SharePoint_Shell_Access role as follows:

--If you specify only the user, the user is added to the role for the farm configuration database.

--If you use the database parameter, the user is added to the role on the farm configuration database, the Central Administration content database, and the specified database. Using the database parameter is the preferred method because most of the administrative operations require access to the Central Administration content database.

The user is added to the WSS_Admin_WPG group on all Web servers when the user is added to the SharePoint_Shell_Access role. If the target database does not have a SharePoint_Shell_Access role, the role is automatically created.

Important:

In order to use Windows PowerShell for SharePoint 2010 Products, a user must be a member of the SharePoint_Shell_Access role on the configuration database and a member of the WSS_ADMIN_WPG local group on the computer where SharePoint 2010 Products is installed. However, the result of running this cmdlet is that the user specified with the UserName parameter will have the dbo_owner role access on the affected databases as described above. Therefore, you should carefully plan which users are given this access.

Input Types

Return Types

Example

-------------------EXAMPLE 1-------------------------

Copy code
Add-SPShellAdmin -UserName CONTOSO\User1

This example adds a new user named User1 to the SharePoint_Shell_Access role in the farm configuration database only, and also ensures the user is added to the WSS_Admin_WPG local group on each server in the farm.

-------------------EXAMPLE 2-------------------------

Copy code
Add-SPShellAdmin -UserName CONTOSO\User1 -database 4251d855-3c15-4501-8dd1-98f960359fa6

This example adds a new user named User1 to the SharePoint_Shell_Access role in both the specified content database and the configuration database by passing a database GUID to the cmdlet.

-------------------EXAMPLE 3-------------------------

Copy code
Get-SPDatabase | Where-Object {$_.WebApplication -like "SPAdministrationWebApplication"} | Add-SPShellAdmin CONTOSO\User1

This example adds a new user named User1 to the SharePoint_Shell_Access role in both the specified Central Administration content database and the configuration database.

-------------------EXAMPLE 4-------------------------

Copy code
Get-SPDatabase | ?{$_.Name -eq "WSS_Content"} | Add-SPShellAdmin -Username CONTOSO\User1

This example adds a new user named User1 to the SharePoint_Shell_Access role of both the specified content database and the configuration database by passing the name of the database to the cmdlet.

See also

Get-SPShellAdmin
Remove-SPShellAdmin


Get-SPShellAdmin
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the names of all users who have the SharePoint_Shell_Access role.

Get-SPShellAdmin [[-database] <SPDatabasePipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

database

Optional

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the GUID of the database or the Databse Object that includes includes the SharePoint_Shell_Access role whose user names you want to display. If the database parameter is not specified, the configuration database is used.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPShellAdmin cmdlet to return the names of all users who have the SharePoint_Shell_Access role in a database.

Input Types

Return Types

Example

--------------------EXAMPLE----------------------

Copy code
Get-SPShellAdmin -database 4251d855-3c15-4501-8dd1-98f960359fa6

This example returns the name of each user who has the SharePoint_Shell_Access role in the database specified.

See also

Add-SPShellAdmin
Remove-SPShellAdmin


Remove-SPShellAdmin
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a user from the SharePoint_Shell_Access role.

Remove-SPShellAdmin [-UserName] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-database <SPDatabasePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

UserName

Required

System.String

Specifies the name of the user you want to remove from the SharePoint_Shell_Access role in the specified database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

database

Optional

Microsoft.SharePoint.PowerShell.SPDatabasePipeBind

Specifies the GUID of the database or the Databse Object that includes the SharePoint_Shell_Access role from which the user is to be removed. If the database parameter is not specified, the configuration database is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPShellAdmin cmdlet to remove a user from the SharePoint_Shell_Access role in a specified database.

When you use this cmdlet to remove a user from the role, you do not remove the user from the WSS_ADMIN_WPG group in the target database.

When you run this cmdlet to add a user to the SharePoint_Shell_Access role, the user must have the following security permissions:

- Security_Admin role access on the instance of SQL Server and the db_owner role in the database.

- Administrative permission to the local computer.

Input Types

Return Types

Example

-----------------------EXAMPLE-----------------------------

Copy code
Remove-SPShellAdmin -UserName CONTOSO\User1 -database 4251d855-3c15-4501-8dd1-98f960359fa6

This example removes an existing user named User1 from the SharePoint_Shell_Access role in the database specified.

See also

Add-SPShellAdmin
Get-SPShellAdmin


Add-SPClaimTypeMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a claim mapping to a trusted security token service (STS) identity provider.

Add-SPClaimTypeMapping [-Identity] <SPClaimMappingPipeBind> [-TrustedIdentityTokenIssuer] <SPTrustedIdentityTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Force <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPClaimMappingPipeBind

Specifies the STS for the farm that will issue the security token for the identity provider.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a claim mapping rule (for example, ClaimMap1); or an instance of a valid SPClaimMapping object.

TrustedIdentityTokenIssuer

Required

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Specifies the farm trust Token Issuer (STS authentication provider).

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of an authentication provider (for example, MyIDprovider1); or an instance of a valid SPTrustedIdentityTokenIssuer object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Force

Optional

System.Management.Automation.SwitchParameter

Overwrites the claim mapping rule if it exists.

Detailed Description

The Add-SPClaimTypeMapping cmdlet adds a claim type mapping rule to a security token service (STS) identity provider from a farm trust STS authentication provider.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-TrustedIdentityTokenIssuer -Identity "LiveIDSTS" | Add-SPClaimTypeMapping -IncomingClaimType "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier" -IncomingClaimTypeDisplayName "PUID" -LocalClaimType "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/thumbprint"

This example adds a claim mapping to a trusted identity token issuer.

See also

New-SPClaimTypeMapping
Remove-SPClaimTypeMapping


Get-SPAuthenticationProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns an authentication provider.

Get-SPAuthenticationProvider [[-Identity] <SPAuthenticationProviderPipeBind>] [-WebApplication] <SPWebApplicationPipeBind> [-Zone] <Default | Intranet | Internet | Custom | Extranet> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPAuthenticationProviderPipeBind

Specifies the authentication provider to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint authentication provider (for example, NTLM); or an instance of a valid SPAuthenticationProvider object.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Returns the content databases for the specified Web application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

Zone

Required

Microsoft.SharePoint.Administration.SPUrlZone

Specifies the Web application zone or zones for which to return the authentication provider.

The type must be any one of the valid zones: Default, Intranet, Internet, Extranet, or Custom.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPAuthenticationProvider cmdlet returns an authentication provider on a specified Web application zone. The following are the standard authentication providers available for SharePoint 2010 Products: NTLM, Classic NTLM, Negotiate, and Classic Negotiate.

Input Types

Return Types

Example

-----------------EXAMPLE 1-----------------

Copy code
New-SPWebApplication http://sharepointonline.com -AuthenticationProvider (Get-SPAuthenticationProvider "LiveID STS")

This example registers the LiveID STS authentication provider for the new Web application.

-----------------EXAMPLE 2-----------------

Copy code
New-SPWebApplication http://contoso.com -AuthenticationProvider (New-SPAuthenticationProvider -ASPNetMembershipProvider "myMembershipProvider" -ASPNetRoleProvider "myRoleProvider")

This example registers ASPNet for the new Web application. Note that ASPNET memberships are not persisted and must be re-created every use.

-----------------EXAMPLE 3-----------------

Copy code
New-SPWebApplication http://contoso.com -AuthenticationProvider (Get-SPAuthenticationProvider "NTLM")

This example registers the NTLM authentication provider for the new Web application. This command is equivalent to the command New-SPWebApplication http://contoso.com; NTLM is default authentication provider.

-----------------EXAMPLE 4-----------------

Copy code
$ip = @( (Get-SPAuthenticationProvider "LiveID STS"), (New-SPAuthenticationProvider -ASPNetMembershipProvider "myMembershipProvider" -ASPNetRoleProvider "myRoleProvider"), (Get-SPAuthenticationProvider "NTLM")) )New-SPWebApplication http://contoso.com -AuthenticationProvider $ip

This example registers the NTLM, ASPNet, and LiveID STS authentication providers for the new Web application.

-----------------EXAMPLE 5-----------------

Copy code
New-SPWebApplication http://contoso.com -AuthenticationProvider (Get-SPAuthenticationProvider "Legacy NTLM")

This example registers the Legacy NTLM authentication provider for the new Web application.

See also

New-SPAuthenticationProvider


Get-SPCertificateAuthority
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the SharePoint certificate authority (CA).

Get-SPCertificateAuthority [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPCertificateAuthority cmdlet returns the SharePoint certificate authority (CA).

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$signingCert = (Get-SPServiceApplication | where $_.Name -eq 'SecurityTokenServiceApplication').SigningCertificate

This example gets the security token service (STS) identity provider signing certificate.


Get-SPClaimProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a claim provider.

Get-SPClaimProvider [[-Identity] <SPClaimProviderPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind

Specifies the claim provider to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a claim provider (for example, MyClaimProvider1); or an instance of a valid SPClaimProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPClaimProvider cmdlet returns a claim provider.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPClaimProvider -Identity "MyClaimProvider" | Set-SPClaimProvider -Enabled $false

This example disables the claim provider MyClaimProvider.

See also

New-SPClaimProvider
Set-SPClaimProvider
Remove-SPClaimProvider
Get-SPClaimProviderManager


Get-SPClaimProviderManager
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a claim provider manager.

Get-SPClaimProviderManager [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPClaimProviderManager cmdlet reads a claim provider manager.

Input Types

Return Types

Example

-------------EXAMPLE--------

Copy code
Get-SPClaimProviderManager

This example returns a claim provider manager for the farm.

See also

Get-SPClaimProvider
New-SPClaimProvider
Set-SPClaimProvider


Get-SPClaimTypeEncoding
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Returns a list of all the types of claims.

Get-SPClaimTypeEncoding [-AssignmentCollection <SPAssignmentCollection>] [-ClaimType <String>] [-EncodingCharacter <Char>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ClaimType

Optional

System.String

Specifies an encoding character that is mapped to a type of input claim.

EncodingCharacter

Optional

System.Char

Specifies a type of claim that is mapped to an input character.

Detailed Description

Use the Get-SPClaimTypeEncoding cmdlet to return the following:

  • A list of all the types of claims that are registered in the farm

  • The Unicode character that will be encoded when the SPClaim.ToEncodedString method is invoked

  • The SPClaim.ClaimType property is set to a valid value

For additional information about the SPClaim methods and properties, see ToEncodedString and ClaimType respectively.

Input Types

Return Types

Example

--------------EXAMPLE 1--------

Copy code
Get-SPClaimTypeEncoding

This example returns a list of all types of claima in the farm.

--------------EXAMPLE 2--------

Copy code
Get-SPClaimTypeEncoding -ClaimType "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/country"

This example returns a specific claim type by using the ClaimType parameter.

See also

New-SPClaimTypeEncoding


Get-SPManagedAccount
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Retrieves accounts registered in the configuration database.

Get-SPManagedAccount [[-Identity] <SPManagedAccountPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Service <SPServicePipeBind>]
Get-SPManagedAccount [[-Identity] <SPManagedAccountPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-WebApplication <SPWebApplicationPipeBind>]
Get-SPManagedAccount [[-Identity] <SPManagedAccountPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Server <SPServerPipeBind>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Service

Optional

Microsoft.SharePoint.PowerShell.SPServicePipeBind

Specifies the scope to a service.

2

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the scope to a Web application.

3

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Server

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the scope to a server.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPManagedAccount cmdlet returns the managed accounts that match the given scope. The scope can be any one of the following values: Web application, service, or server.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPManagedAccount

This example displays all the managed accounts in the farm.

See also

New-SPManagedAccount
Set-SPManagedAccount
Remove-SPManagedAccount


Get-SPManagedPath
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all managed paths that match the given criteria.

Get-SPManagedPath [[-Identity] <SPPrefixPipeBind>] -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPManagedPath [[-Identity] <SPPrefixPipeBind>] -HostHeader <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPPrefixPipeBind

Specifies the URL or GUID of the managed path to return.

The type must be a valid URL, in the http://server_name or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL or GUID of the Web application from which to get the managed path.

The type must be a valid URL, in the form http://server_name, or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPPrefixPipeBind

Specifies the URL or GUID of the managed path to return.

The type must be a valid URL, in the http://server_name or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

HostHeader

Required

System.Management.Automation.SwitchParameter

If provided, the managed paths returned are for the HostHeader sites in the farm.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPManagedPath cmdlet returns the SharePoint managed path that matches the provided Identity for either a Web application, site collection or for all HostHeader site collections. If an Identity parameter is not provided, all managed paths for the given scope are returned.

HostHeader sites (no matter the Web application in which they are contained) share a single set of managed paths. Use the HostHeader parameter to return host header managed paths.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPManagedPath -WebApplication http://sitename

This example returns all managed paths for the specified Web application.

--------------EXAMPLE 2-----------------

Copy code
Get-SPManagedPath -identity "Sites" -HostHeader

This example gets the Sites managed path from the HostHeader managed paths.

See also

New-SPManagedPath
Remove-SPManagedPath


Get-SPSecurityTokenServiceConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the security token service (STS) for the farm.

Get-SPSecurityTokenServiceConfig [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPSecurityTokenServiceConfig cmdlet reads the security token service (STS) for the farm. An STS authenticates security tokens in incoming SOAP messages.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Set-SPSecurityTokenServiceConfig -ServiceTokenLifetime 1000

This example gets the security token service (STS) for the farm and sets the expiration for the service token cache to 1000 minutes.

See also

Set-SPSecurityTokenServiceConfig


Get-SPServiceApplicationSecurity
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the SPObjectSecurity object for a service application.

Get-SPServiceApplicationSecurity [-Identity] <SPServiceApplicationPipeBind> [-Admin <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a service application (for example, SearchServiceApp1); or an instance of a valid SPServiceApplication object.

Admin

Optional

System.Management.Automation.SwitchParameter

Returns the access control list (ACL) that contains the administrators list of the service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPServiceApplicationSecurity cmdlet returns a security object for the specified service application. Use this cmdlet with the Grant-SPObjectSecurity and Set-SPServiceApplicationSecurity cmdlets to manage security for a service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$security = Get-SPServiceApplicationSecurity $serviceApp -AdminGrant-SPObjectSecurity $security $principal "Full Control"Set-SPServiceApplicationSecurity $serviceApp -Admin $security

This example retrieves the SPObjectSecurity object corresponding to the administrator ACL on a service application, and adds a new user principal to that ACL. The new user is an administrator for the service application $serviceApp.

See also

Set-SPServiceApplicationSecurity
Grant-SPObjectSecurity
Revoke-SPObjectSecurity


Get-SPTrustedIdentityTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns an identity provider.

Get-SPTrustedIdentityTokenIssuer [[-Identity] <SPTrustedIdentityTokenIssuerPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPIdentityProviderPipeBind

Specifies the identity provider to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of identity provider (for example, LiveID STS); or an instance of a valid SPIdentityProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPTrustedIdentityTokenIssuer cmdlet returns an identity provider.

Input Types

Return Types

Example

--------------------------EXAMPLE 1------------------------

Copy code
$trustedsts=Get-SPTrustedIdentityTokenIssuer "LiveIDSTS"

This example gets a trusted identity token issuer.

See also

Set-SPTrustedIdentityTokenIssuer
New-SPTrustedIdentityTokenIssuer
Remove-SPTrustedIdentityTokenIssuer


Get-SPTrustedRootAuthority
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a trusted root authority.

Get-SPTrustedRootAuthority [[-Identity] <SPTrustedRootAuthorityPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPTrustedRootAuthorityPipeBind

Specifies the trusted root authority to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a trusted root authority (for example, WFEFarm1); or an instance of a valid SPTrustedRootAuthority object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPTrustedRootAuthority cmdlet returns a trusted root authority. If a certificate file is used, it must have only one X509 certificate without private keys, otherwise an exception is raised.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$rootauthority=Get-SPTrustedRootAuthority -Identity "WFEFarm1"

This example creates a new trusted root authority, WFEFarm1.

See also

New-SPTrustedRootAuthority
Set-SPTrustedRootAuthority
Remove-SPTrustedRootAuthority


Get-SPTrustedServiceTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the object that represents the farm trust.

Get-SPTrustedServiceTokenIssuer [[-Identity] <SPTrustedServiceTokenIssuerPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPTrustedServiceTokenIssuerPipeBind

Specifies the trusted service token issuer to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a trusted service token issuer (for example, WFEFarm1); or an instance of a valid SPTrustedRootAuthority object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPTrustedServiceTokenIssuer cmdlet returns the object that represents the farm trust.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPTrustedServiceTokenIssuer "WFEFarm1"

This example gets the trusted services token issuer WFEFarm1.

See also

Set-SPTrustedServiceTokenIssuer
New-SPTrustedServiceTokenIssuer
Remove-SPTrustedServiceTokenIssuer


Grant-SPObjectSecurity
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a new security principal to an SPObjectSecurity object.

Grant-SPObjectSecurity [-Identity] <SPObjectSecurity> [-Principal] <SPClaim> [-Rights] <String[]> [-AssignmentCollection <SPAssignmentCollection>] [-Replace <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Administration.AccessControl.SPObjectSecurity

Specifies the SPObjectSecurity object to which the new security principal is added. You can use the Get-SPServiceApplicationSecurity cmdlet to get a SPObjectSecurity object .

Principal

Required

Microsoft.SharePoint.Administration.Claims.SPClaim

Specifies the principal to whom the rights apply.

The type must a valid name a principal; for example, Full Control.

Rights

Required

System.String[]

Specifies the rights granted to the principal.

The type must a valid array of strings that represents the rights granted to the principal.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Replace

Optional

System.Management.Automation.SwitchParameter

Replaces the existing rights on the SPObjectSecurity object with the new rights specified. If this parameter is not specified, the new rights are added to the existing rights.

Detailed Description

The Grant-SPObjectSecurity cmdlet adds a new security principal, such as a user, to a SPObjectSecurity object. An SPObjectSecurity object is a common object that is used to represent the security access control list (ACL) of SharePoint administrative objects, in particular, service applications.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$security = Get-SPServiceApplicationSecurity $serviceApp -AdminGrant-SPObjectSecurity $security $principal "Full Control"Set-SPServiceApplicationSecurity $serviceApp -Admin $security

This example retrieves the SPObjectSecurity object corresponding to the administrator ACL on a service application, and adds a new user principal to that ACL. The new user is an administrator for the service application $serviceApp.

See also

Revoke-SPObjectSecurity
Get-SPServiceApplicationSecurity


Initialize-SPResourceSecurity
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Enforces resource security on the local server.

Initialize-SPResourceSecurity [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Initialize-SPResourceSecurity cmdlet enforces resource security on the local server. This cmdlet enforces security for all resources, including files, folders, and registry keys.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Initialize-SPResourceSecurity

This example enforces resource security on the local server.


New-SPAuthenticationProvider
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new authentication provider in the farm.

New-SPAuthenticationProvider [-AllowAnonymous <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-DisableKerberos <SwitchParameter>] [-UseBasicAuthentication <SwitchParameter>] [-UseWindowsIntegratedAuthentication <SwitchParameter>]
New-SPAuthenticationProvider -ASPNETMembershipProvider <String> -ASPNETRoleProviderName <String> [-AssignmentCollection <SPAssignmentCollection>]
New-SPAuthenticationProvider -TrustedIdentityTokenIssuer <SPTrustedIdentityTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

AllowAnonymous

Optional

System.Management.Automation.SwitchParameter

Specifies whether the web application allows anonymous access.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DisableKerberos

Optional

System.Management.Automation.SwitchParameter

Specifies whether the web application disables Kerberos authentication.

UseBasicAuthentication

Optional

System.Management.Automation.SwitchParameter

Specifies whether the web application uses Basic authentication.

UseWindowsIntegratedAuthentication

Optional

System.Management.Automation.SwitchParameter

Specifies whether the web application uses Integrated Windows authentication.

2

Parameter

Required

Type

Description

ASPNETMembershipProvider

Required

System.String

Specifies the name of the membership provider.

The value must be a valid name of an ASP.NET membership provider; for example, myMembershipProvider.

ASPNETRoleProviderName

Required

System.String

Specifies the name of the role provider.

The value must be a valid name of an ASP.NET role provider; for example, myRoleProvider.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

3

Parameter

Required

Type

Description

TrustedIdentityTokenIssuer

Required

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Specifies the identity of the authentication provider.

The value must be in one of the following forms:

--A valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh

--A valid name of a TrustedIdentityTokenIssuer (for example, myRoleProvider)

--An instance of a valid SPTrustedIdentityTokenIssuer object

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPAuthenticationProvider cmdlet creates a new authentication provider in the farm.

--NTLM, Classic NTLM, Negotiate, and Classic Negotiate can be set only in a web application.

--For ASP.NET Membership Provider or Role providers, no objects are persisted. The object is created and used for setting this type of Authentication provider in a web application.

--For STS Authentication providers, an object is created and persisted in the SPFarm object.

You cannot use classic NTLM with any claims-based authentication type.

Input Types

Return Types

Example

---------------------------EXAMPLE1------------------

Copy code
$ap = New - SPAuthenticationProvider -UseWindowsIntegratedAuthentication
Copy code
Set-SPWebApplication -Name "Claims Windows Web App" -ApplicationPool "Claims App Pool" -ApplicationPoolAccount "redmond\appool" -Url http://<servername> -Port 80 -AuthenticationProvider $ap

This example creates a Windows claims authentication provider.

---------------------------EXAMPLE2------------------

Copy code
$ap = New-SPAuthenticationProvider -ASPNETMembershipProvider "membership" -ASPNETRoleProviderName "rolemanager"
Copy code
Set-SPWebApplication -Name "Claims Windows Web App" -ApplicationPool "Claims App Pool" -ApplicationPoolAccount "redmond\appool" -Url http://<servername> -Port 80 -AuthenticationProvider $ap

This example creates an authentication provider that is based on the ASP.NET membership role provider.

---------------------------EXAMPLE3------------------

Copy code
$ap = New - SPAuthenticationProvider -TrustedIdentityTokenIssuer | Get-SPTrustedIdentityTokenIssuer "LiveIDSTS"
Copy code
Set-SPWebApplication -Name "Claims Windows Web App" -ApplicationPool "Claims App Pool" -ApplicationPoolAccount "redmond\appool" -Url http://<servername> -Port 80 -AuthenticationProvider $ap

This example creates a trusted token issuer authentication provider.


New-SPClaimProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Registers a new claim provider in the farm.

New-SPClaimProvider -AssemblyName <String> -Description <String> -DisplayName <String> -Type <String> [-AssignmentCollection <SPAssignmentCollection>] [-Default <SwitchParameter>] [-Enabled <SwitchParameter>]

Parameters

Parameter Required Type Description

AssemblyName

Required

System.String

The type must be a valid name of an assembly; for example, ClaimAssembly1.

Specifies the name of the assembly with the claim provider.

Description

Required

System.String

Specifies the description of the claim provider.

The type must be a valid name of an assembly; for example, ClaimAssembly1.

DisplayName

Required

System.String

Specifies the display name of the new claim provider.

The type must be a valid name of a claim provider; for example, ClaimProvider1.

Type

Required

System.String

Specifies the type of the claim.

The type must be a valid name of a claim type; for example MyClaimProvider.Providers.CustomProvider.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Default

Optional

System.Management.Automation.SwitchParameter

Specifies that the claim provider applies to all Web applications and zones.

Enabled

Optional

System.Management.Automation.SwitchParameter

Turns on the claim provider.

Detailed Description

The New-SPClaimProvider cmdlet registers a new claim provider in the farm.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
New-SPClaimProvider -Name "MyClaimProvider" -Type "MyClaimProvider.Providers.CustomProvider" -AllWebApplications

This example registers a claim provider in the farm.

------------------EXAMPLE 2------------------

Copy code
New-SPClaimProvider -Name "MyClaimProvider" -Type "MyClaimProvider.Providers.CustomProvider" -Scope (Get-SPWebApplication http://test)

This example registers a claim provider scoped to a given Web application.

See also

Get-SPClaimProvider
Set-SPClaimProvider
Remove-SPClaimProvider


New-SPClaimsPrincipal
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a claims principal.

New-SPClaimsPrincipal [-Identity] <String> [-IdentityType] <WindowsSamAccountName | WindowsSecurityGroupName | WindowsSecurityGroupSid | FormsUser | FormsRole | EncodedClaim> [-AssignmentCollection <SPAssignmentCollection>]
New-SPClaimsPrincipal [-Identity] <String> [-TrustedIdentityTokenIssuer] <SPTrustedIdentityTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>]
New-SPClaimsPrincipal [-ClaimValue] <String> [[-ClaimType] <String>] [-TrustedIdentityTokenIssuer] <SPTrustedIdentityTokenIssuerPipeBind> [[-IdentifierClaim] <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>]
New-SPClaimsPrincipal [-EncodedClaim] <String> [-AssignmentCollection <SPAssignmentCollection>]
New-SPClaimsPrincipal [-ClaimValue] <String> [-ClaimType] <String> [-ClaimProvider] <SPClaimProvider> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

System.String

Specifies the name of the new claims principal.

The type must be a valid name of a claims principal.

IdentityType

Required

Microsoft.SharePoint.Administration.Claims.SPIdentifierTypes

Specifies the type of the new claims principal.

The type must be one of the following: WindowsSamAccountName, WindowsSecurityGroupSid, FormsUser, FormsRole, or EncodedClaim.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

Identity

Required

System.String

Specifies the name of the new claims principal.

The type must be a valid name of a claims principal.

TrustedIdentityTokenIssuer

Required

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Specifies the ID of the authentication provider.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of an Authentication provider (for example, MyAuthprovider1); or an instance of a valid SPTrustedIdentityTokenIssuer object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

3

Parameter

Required

Type

Description

ClaimValue

Required

System.String

Specifies the claim value of the claims object. The claims value specifies the user, group, or computer that the claim is authenticating.

The type must be a valid claim value; for example, john@contoso.com.

ClaimType

Required

System.String

Specifies the type of claim to create. The value I indicates a unique user identity claim, and the value C indicates all other claims.

The type must be either of the following values: I or C.

TrustedIdentityTokenIssuer

Required

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Specifies the ID of the authentication provider.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of an Authentication provider (for example, MyAuthprovider1); or an instance of a valid SPTrustedIdentityTokenIssuer object.

IdentifierClaim

Optional

System.Management.Automation.SwitchParameter

Specifies if the new claim is an identity claim.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

4

Parameter

Required

Type

Description

EncodedClaim

Required

System.String

Converts a simple claim to a full encoded claim.

The type must be a valid claim value; for example, i:001w|redmond\user.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

5

Parameter

Required

Type

Description

ClaimValue

Required

System.String

Specifies the claim value of the claims object. The claims value specifies the user, group, or computer that the claim is authenticating.

The type must be a valid claim value; for example, john@contoso.com.

ClaimType

Required

System.String

Specifies the type of claim to create. The value I indicates a unique user identity claim, and the value C indicates all other claims.

The type must be either of the following values: I or C.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPClaimsPrincipal cmdlet creates a claims principal.

Input Types

Return Types

Example

-------------------------EXAMPLE 1-----------------------------

Copy code
New-SPSite http://sitename/sites/newsite -owner (New-SPClaimsPrincipal contoso\johndoe -TrustedIdentityTokenIssuer "NTLM")

This example creates a claim principal for a Windows user.

-------------------------EXAMPLE 2-----------------------------

Copy code
New-SPSite http://localhost/sites/newsite -owner (New-SPClaimsPrincipal contoso\allusers -TrustedIdentityTokenIssuer "NTLM")

This example creates a claim principal for a Windows group.

-------------------------EXAMPLE 3-----------------------------

Copy code
New-SPSite http://sitename/sites/newsite -owner (New-SPClaimsPrincipal -ClaimValue "john@contoso.com" -ClaimType Email -TrustedIdentityTokenIssuer "LiveID STS" -IdentifierClaim Yes)

This example creates a claim principal for a trusted identity token issuer claim.

-------------------------EXAMPLE 4-----------------------------

Copy code
$ip = New-SPIdentityProvider -ASPNetMembershipProvider "myMembershipProvider" -ASPNetRoleProvider "myRoleProvider"
Copy code
New-SPSite http://sitename/sites/newsite -owner (New-SPClaimsPrincipal "john@contoso.com" -TrustedIdentityTokenIssuer $ip)

This example creates a claim principal for a ASPNet Membership User.

-------------------------EXAMPLE 5-----------------------------

Copy code
New-SPSite http://sitename/sites/newsite -owner (New-SPClaimsPrincipal "Sales Manager Role" -IdentityProvider "myRoleProvider")

This example creates a claim principal for a ASPNet Role.

-------------------------EXAMPLE 6-----------------------------

Copy code
 $cp = New-SPClaimsPrincipal -Identity "redmond\SiteOwner" -IdentityType 1
Copy code
New-SPSite http://servername:port -OwnerAlias $cp.ToEncodedString() -Template "STS#0"

This example creates a claim principal for a Basic Claim Role, which is also called an encoded claim).


New-SPClaimTypeEncoding
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Registers a new type of claim.

New-SPClaimTypeEncoding -ClaimType <String> -EncodingCharacter <Char> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ClaimType

Required

System.String

Specifies the type of claim for which you want to create a mapping.

EncodingCharacter

Required

System.Char

Specifies the Unicode character to which you want to create a mapping.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Suppresses confirmation messages to any claim type that is added.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPClaimTypeEncoding cmdlet to register the following:

  • A new type of claim

  • The Unicode character to which it should be encoded when the SPClaim.ToEncodedString method is invoked

  • The SPClaim.ClaimType property is set to a valid value

For more information about the SPClaim methods and properties, see ToEncodedString and ClaimType respectively.

Input Types

Return Types

Example

------------EXAMPLE-------

Copy code
New-SPClaimTypeEncoding -EncodingCharacter '1' -ClaimType "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/country"

This example registers a new type of claim.

See also

Get-SPClaimTypeEncoding


New-SPClaimTypeMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a claim mapping rule for a security token service (STS) identity provider.

New-SPClaimTypeMapping [-IncomingClaimType] <String> [-IncomingClaimTypeDisplayName] <String> [[-LocalClaimType] <String>] [-AssignmentCollection <SPAssignmentCollection>] [-SameAsIncoming <SwitchParameter>]

Parameters

Parameter Required Type Description

IncomingClaimType

Required

System.String

Specifies the URI of the incoming claim type.

The type must be a valid URI, in the form http://schemas.microsoft.com/email.

IncomingClaimTypeDisplayName

Required

System.String

Specifies the display name of the incoming claim type.

The type must be a valid name of an incoming claim type; for example, Email.

LocalClaimType

Optional

System.String

Specifies the URI of the local claim type. If the SameAsIncoming parameter is False, this is a required parameter.

The type must be a valid URI, in the form http://schemas.microsoft.com/email.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SameAsIncoming

Optional

System.Management.Automation.SwitchParameter

Specifies that the claim type specified in the IncomingClaimType parameter is used for the LocalClaimType parameter.

Detailed Description

The New-SPClaimTypeMapping cmdlet creates a claim mapping rule for a security token service (STS) identity provider.

Input Types

Return Types

Example

--------------------EXAMPLE 1----------------------------

Copy code
$map1 = New-SPClaimTypeMapping -IncomingClaimType "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress" -IncomingClaimTypeDisplayName "EmailAddress" -SameAsIncoming
Copy code
$map2 = New-SPClaimTypeMapping -IncomingClaimType "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier" -IncomingClaimTypeDisplayName "PUID" -LocalClaimType "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/thumbprint"
Copy code
New-SPTrustedIdentityTokenIssuer -Name "LiveIDSTS" -Description "LiveID Provider" -Realm "urn:domain.company.com" -ImportTrustCertificate $cert -ClaimsMappings $map1[,$map2..] -SignInUrl "https://login.live.com/login.srf" -IdentifierClaim $map2.InputClaimType

This example creates a claim map from an incoming token to a SharePoint token.

See also

Add-SPClaimTypeMapping
Remove-SPClaimTypeMapping


New-SPManagedAccount
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Registers a new managed account.

New-SPManagedAccount [-Credential] <PSCredential> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Credential

Required

System.Management.Automation.PSCredential

Indicates the Credential object that specifies the credentials of the new managed account. If you use Credential, you cannot specify Username and Password.

Password

Required

System.Security.SecureString

Specifies the password for the user specified in Username. If you use Credential, you cannot specify Username and Password.

Username

Required

System.String

Specifies the user name of the new managed account. If you use Credential, you cannot specify Username and Password.

The type must be a valid user name, in the form domain\username.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The New-SPManagedAccount cmdlet registers a new managed account for the specified Credential or Username, and Password.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
$cred = Get-Credential
Copy code
New-SPManagedAccount -Credential $cred

This example adds a new managed account to the farm by using credentials that are prompted.

See also

Get-SPManagedAccount
Set-SPManagedAccount
Remove-SPManagedAccount


New-SPManagedPath
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new managed path for the given Web application for all host header site collections.

New-SPManagedPath [-RelativeURL] <String> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Explicit <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
New-SPManagedPath [-RelativeURL] <String> -HostHeader <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Explicit <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

RelativeURL

Required

System.String

Specifies the relative URL for the new managed path.

The type must be a valid partial URL such as site or sites/teams/.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the Web application group to add this path.

The type must be a valid URL, in the form http://server_name, or a GUID, in the form 1234-5678-0987645a.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Explicit

Optional

System.Management.Automation.SwitchParameter

Specifies whether the managed path is explicit or wildcard.

If not provided, the managed path is a wildcard path.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

RelativeURL

Required

System.String

Specifies the relative URL for the new managed path.

The type must be a valid partial URL such as site or sites/teams/.

HostHeader

Required

System.Management.Automation.SwitchParameter

If this parameter is provided, this managed path applies to all host header site collections.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Explicit

Optional

System.Management.Automation.SwitchParameter

Specifies whether the managed path is explicit or wildcard.

If not provided, the managed path is a wildcard path.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPManagedPath cmdlet adds a new managed path to a given Web application or for use with all host header site collections. If the HostHeader switch is provided, the managed path is shared among all host header site collections; otherwise, a Web application must be specified to create this managed path within. The relative URL is a partial URL that represents the managed path. When the slash mark (/) is used, the root is defined. If the Explicit parameter is not provided, the new managed path is a wildcard path.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
New-SPManagedPath "Teams" -WebApplication "http://somesite"

This example creates a Teams managed path for a given Web application (http://somesite).

See also

Get-SPManagedPath
Remove-SPManagedPath


New-SPTrustedIdentityTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates an identity provider in the farm.

New-SPTrustedIdentityTokenIssuer -ClaimsMappings <SPClaimMappingPipeBind[]> -Description <String> -IdentifierClaim <String> -Name <String> -Realm <String> -SignInUrl <String> [-AssignmentCollection <SPAssignmentCollection>] [-ClaimProvider <SPClaimProviderPipeBind>] [-Confirm [<SwitchParameter>]] [-ImportTrustCertificate <X509Certificate2>] [-UseWReply <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
New-SPTrustedIdentityTokenIssuer -ClaimsMappings <SPClaimMappingPipeBind[]> -Description <String> -IdentifierClaim <String> -Name <String> -Realm <String> -SignInUrl <String> [-AssignmentCollection <SPAssignmentCollection>] [-ClaimProvider <SPClaimProviderPipeBind>] [-Confirm [<SwitchParameter>]] [-MetadataEndPoint <Uri>] [-UseWReply <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

ClaimsMappings

Required

Microsoft.SharePoint.PowerShell.SPClaimMappingPipeBind[]

Specifies the mapping of the claims from the original token to the SharePoint token.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a claim mapping rule (for example, Email); or an instance of a valid SPClaimMapping object.

Description

Required

System.String

Specifies a description for the new identity provider.

The type must be a valid string; for example, LiveID STS.

IdentifierClaim

Required

System.String

Specifies which claim type from the trusted STS will be used for the new identity provider.

The type must be a valid claim type from the trusted STS; for example, http://schemas.microsoft.com/2007/05/Claims/Puid.

Name

Required

System.String

Specifies the name of the new identity provider.

The type must be a valid name of an identity provider; for example, LiveIDSTS.

Realm

Required

System.String

Specifies the realm, or resource partition, associated with this trust.

The type must be a name of a valid realm; for example, MD_REALM.

SignInUrl

Required

System.String

Specifies the sign-in URLs for this trusted STS identity provider.

The type must be a valid URL, in the form http://int.live.com/.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ClaimProvider

Optional

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind

Specifies the IP STS that can resolve and search claims for claims people picker.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of identity provider (for example, MyIDprovider1); or an instance of a valid SPIdentityProvider object.

ImportTrustCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the X.509 certificate object from trusted authentication provider farm.

The type must be a name of a valid X.509 certificate; for example, Certificate1.

UseWReply

Optional

System.Management.Automation.SwitchParameter

Includes a WReply with the token request. WReply is a URL at the relying party to which the requestor is redirected once sign-out processing is complete.

2

Parameter

Required

Type

Description

ClaimsMappings

Required

Microsoft.SharePoint.PowerShell.SPClaimMappingPipeBind[]

Specifies the mapping of the claims from the original token to the SharePoint token.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a claim mapping rule (for example, Email); or an instance of a valid SPClaimMapping object.

Description

Required

System.String

Specifies a description for the new identity provider.

The type must be a valid string; for example, LiveID STS.

IdentifierClaim

Required

System.String

Specifies which claim type from the trusted STS will be used for the new identity provider.

The type must be a valid claim type from the trusted STS; for example, http://schemas.microsoft.com/2007/05/Claims/Puid.

Name

Required

System.String

Specifies the name of the new identity provider.

The type must be a valid name of an identity provider; for example, LiveIDSTS.

Realm

Required

System.String

Specifies the realm, or resource partition, associated with this trust.

The type must be a name of a valid realm; for example, MD_REALM.

SignInUrl

Required

System.String

Specifies the sign-in URLs for this trusted STS identity provider.

The type must be a valid URL, in the form http://int.live.com/.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ClaimProvider

Optional

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind

Specifies the IP STS that can resolve and search claims for claims people picker.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of identity provider (for example, MyIDprovider1); or an instance of a valid SPIdentityProvider object.

MetadataEndPoint

Optional

System.Uri

UseWReply

Optional

System.Management.Automation.SwitchParameter

Includes a WReply with the token request. WReply is a URL at the relying party to which the requestor is redirected once sign-out processing is complete.

Detailed Description

The New-SPTrustedIdentityTokenIssuer cmdlet creates an identity provider in the farm. This object is created and used only for setting this type of identity provider in a Web application. The specified claim type cannot be NTLM, Classic NTLM, Negotiate, or Classic Negotiate. For ASP.NET Membership provider or Role providers, no objects are persisted. For security token service (STS) identity providers, this cmdlet creates and persists the identity provider object in the SPFarm object.

Input Types

Return Types

Example

----------------------- EXAMPLE---------------------------

Copy code
New-SPTrustedIdentityTokenIssuer -Name "LiveIDSTS" - Description "LiveID STS" -Certificate (Get-ChildItem"cert:Certificates (LocalComputer)\Personal\Certificates -Name "LiveID Cert") -SignInUrl http://int.contoso.com/ -IdentifierClaim "http://schemas.contoso.com/2007/05/Claims/Puid"
Copy code
Set -SPWebApplication http://contoso.com -IdentityProvider (Get-SPTrustedIdentityTokenIssuer "LiveIDSTS")

This example creates a new identity provider in the farm named LiveIDSTS.

See also

Get-SPTrustedIdentityTokenIssuer
Set-SPTrustedIdentityTokenIssuer
Remove-SPTrustedIdentityTokenIssuer


New-SPTrustedRootAuthority
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Creates a trusted root authority.

New-SPTrustedRootAuthority [-Name] <String> -Certificate <X509Certificate2> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
New-SPTrustedRootAuthority [-Name] <String> -MetadataEndPoint <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the trusted root authority to create.

The value must be a valid name of a trusted root authority; for example, WFEFarm1.

Certificate

Required

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the X.509 certificate of the trusted root authority.

The value must be a name of a valid X.509 certificate; for example, Certificate1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the trusted root authority to create.

The value must be a valid name of a trusted root authority; for example, WFEFarm1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The New-SPTrustedRootAuthority cmdlet creates a trusted root authority. If a certificate file is used, it must have only one X509 certificate without private keys, otherwise an exception is raised.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$cert = Get-PfxCertificate C:\LiveIDSigningCert.pfx
Copy code
New-SPTrustedRootAuthority -Name "WFEFarm1" -Certificate $cert

This example creates a new trusted root authority, WFEFarm1.

See also

Get-SPTrustedRootAuthority
Set-SPTrustedRootAuthority
Remove-SPTrustedRootAuthority


New-SPTrustedServiceTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a trust with a SharePoint farm.

New-SPTrustedServiceTokenIssuer [-Name] <String> -Certificate <X509Certificate2> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-WhatIf [<SwitchParameter>]]
New-SPTrustedServiceTokenIssuer [-Name] <String> -MetadataEndPoint <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the trust.

The type must be a valid name of a trusted service issuer; for example, WFEFarmTrust1.

Certificate

Required

System.Security.Cryptography.X509Certificates.X509Certificate2

The type must be a name of a valid X.509 certificate; for example, Certificate1.

Specifies the X.509 certificate object from trusted authentication provider farm.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Description

Optional

System.String

Specifies a description for the trust.

The type must be a valid string; for example, WFE Farm Trust1.

2

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the trust.

The type must be a valid name of a trusted service issuer; for example, WFEFarmTrust1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Description

Optional

System.String

Specifies a description for the trust.

The type must be a valid string; for example, WFE Farm Trust1.

Detailed Description

The New-SPTrustedServiceTokenIssuer cmdlet creates a trust with a SharePoint farm. If a certificate file is used, it must have only one X509 certificate without private keys, otherwise an exception is raised.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$cert = Get-PfxCertificate C:\LiveIDSigningCert.pfx
Copy code
New-SPTrustedServiceTokenIssuer -Name "WFEFarm1" -Description "WFE Farm 1" -Certificate $cert

This example shows how to create a new SharePoint Farm trust using the trust certificate from a file.

See also

Get-SPTrustedServiceTokenIssuer
Set-SPTrustedServiceTokenIssuer
Remove-SPTrustedServiceTokenIssuer


Remove-SPClaimProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Unregisters a claim provider.

Remove-SPClaimProvider [-Identity] <SPClaimProviderPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind

Specifies the claim provider to unregister.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a claim provider (for example, MyClaimProvider1); or an instance of a valid SPClaimProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Remove-SPClaimProvider cmdlet unregisters a claim provider. If the unregistered claim provider was assigned to a trusted identity token issuer, the trusted token issuer will use the default (system) claim provider.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Remove - SPClaimProvider -Identity "12345678-90ab-cdef-1234-567890bcdefgh"

This example removes a claim provider from the farm

See also

Get-SPClaimProvider
New-SPClaimProvider
Set-SPClaimProvider


Remove-SPClaimTypeMapping
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes a claim type mapping rule for a security token service (STS) identity provider.

Remove-SPClaimTypeMapping [-Identity] <SPClaimMappingPipeBind> [-TrustedIdentityTokenIssuer] <SPTrustedIdentityTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPClaimMappingPipeBind

Specifies the claim mapping to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a claim mapping rule (for example, Email); or an instance of a valid SPClaimMapping object.

IdentityProvider

Required

Microsoft.SharePoint.PowerShell.SPIdentityProviderPipeBind

Specifies the farm trust identity provider STS that contains the claim mapping rule.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of identity provider (for example, LiveIDSTS); or an instance of a valid SPIdentityProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Remove-SPClaimMapping cmdlet deletes a claim type mapping rule from a farm trust STS identity provider.

Input Types

Return Types

Example

--------------------EXAMPLE-------------------------

Copy code
Remove-SPClaimMapping "Email" | Get-SPIdentityProvider "LiveIDSTS"

This example removes an identity provider named LiveIDSTS.

See also

Add-SPClaimTypeMapping
New-SPClaimTypeMapping


Remove-SPManagedAccount
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a managed account registration from the farm.

Remove-SPManagedAccount [-Identity] <SPManagedAccountPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Remove-SPManagedAccount [-Identity] <SPManagedAccountPipeBind> -NewPassword <SecureString> [-AssignmentCollection <SPAssignmentCollection>] [-ChangePassword <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

NewPassword

Required

System.Security.SecureString

Specifies a secure string for the new password (that is, $MySecureString).Works in conjunction with the ChangePassword parameter.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ChangePassword

Optional

System.Management.Automation.SwitchParameter

Specifies whether a password is to be changed. Works in conjunction with the NewPassword parameter. When the ChangePassword value is set, a secure string value is required for the NewPassword parameter (that is, $MySecureString).

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Remove-SPManagedAccount cmdlet removes account registration from the configuration database within the farm.

Input Types

Return Types

Example

----------------------EXAMPLE-------------------

Copy code
Remove-SPManagedAccount -Identity DOMAIN\ServiceAcct

This example removes the DOMAIN\ServiceAcct managed account from the farm.

See also

Get-SPManagedAccount
New-SPManagedAccount
Set-SPManagedAccount


Remove-SPManagedPath
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes the specified managed path from the specified host header or Web application.

Remove-SPManagedPath [-Identity] <SPPrefixPipeBind> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Remove-SPManagedPath [-Identity] <SPPrefixPipeBind> -HostHeader <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPPrefixPipeBind

Specifies the name of the managed path to delete. For example, in the URL http://sitename/sites/site1, "sites" is the name of the managed path.

WebApplication

Required

Microsoft.SharePoint.PowerShell.WebApplicationPipeBind

Specifies the identity of the Web application that hosts the managed path to delete. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid Web application name (for example, WebApplication1212); or a valid name, in the form WebApp2423.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPPrefixPipeBind

Specifies the name of the managed path to delete. For example, in the URL http://sitename/sites/site1, "sites" is the name of the managed path.

HostHeader

Required

System.Management.Automation.SwitchParameter

Specifies that the Identity is a host header managed path.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Remove-SPManagedPath cmdlet deletes the managed path specified by the Identity parameter from the host header or the Web application. The Identity must be the partial URL of the managed path to be deleted.

If you are using host headers, specify the HostHeader parameter. To delete a HostHeader managed path, provide the HostHeader switch. Otherwise, you must specify the Web application that contains the managed path to be deleted.

Input Types

Return Types

Example

----------------------EXAMPLE 1----------------------------

Copy code
Remove-SPManagedPath "sites" -HostHeader

This example removes the sites managed path from the list of HostHeader managed paths.

Depending on the confirmation level of the local system, the preceding example can prompt prior to execution.

------------------EXAMPLE 2-----------------------

Copy code
Get-SPWebApplication | Remove-SPManagedPath "personal" -confirm:$false

This example removes the personal managed path from all Web applications in the farm. This command does not prompt for confirmation.

See also

Get-SPManagedPath
New-SPManagedPath


Remove-SPTrustedIdentityTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Deletes a Security Token Service (STS) identity provider from the farm.

Remove-SPTrustedIdentityTokenIssuer [-Identity] <SPTrustedIdentityTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Specifies the identity provider to remove.

The type must be one of the following forms:

--A valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh

--A valid name of identity provider (for example, LiveID STS)

--An instance of a valid SPIdentityProvider object

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPTrustedIdentityTokenIssuer cmdlet deletes a Security Token service (STS) identity provider from the farm.

Input Types

Return Types

Example

------------------EXAMPLE--------------------

Copy code
Remove-SPTrustedIdentityTokenIssuer "LiveIDSTS"

This example removes an identity provider named LiveIDSTS from the farm.

See also

Get-SPTrustedIdentityTokenIssuer
Set-SPTrustedIdentityTokenIssuer
New-SPTrustedIdentityTokenIssuer


Remove-SPTrustedRootAuthority
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes a trusted root authority.

Remove-SPTrustedRootAuthority [-Identity] <SPTrustedRootAuthorityPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedRootAuthorityPipeBind

Specifies the trusted root authority to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a trusted root authority (for example, WFEFarm1); or an instance of a valid SPTrustedRootAuthority object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Remove-SPTrustedRootAuthority cmdlet deletes a trusted root authority from a signing certificate store.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Remove - SPTrustedRootAuthority -Name "WFEFarm1"

This example removes the trusted root authority WFEFarm1.

See also

New-SPTrustedRootAuthority
Get-SPTrustedRootAuthority
Set-SPTrustedRootAuthority


Remove-SPTrustedServiceTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes the object that represents the farm trust.

Remove-SPTrustedServiceTokenIssuer [-Identity] <SPTrustedServiceTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedServiceTokenIssuerPipeBind

Specifies the trusted service token issuer to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a trusted service token issuer (for example, WFEFarm1); or an instance of a valid SPTrustedRootAuthority object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Remove-SPTrustedServiceTokenIssuer cmdlet deletes the object that represents the farm trust.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Remove-SPTrustedServiceTokenIssuer "WFE Farm 2"

This example deletes the trusted service token issuer WFE Farm 2.

See also

Set-SPTrustedServiceTokenIssuer
New-SPTrustedServiceTokenIssuer
Get-SPTrustedServiceTokenIssuer


Repair-SPManagedAccountDeployment
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Repairs the local managed account credential deployment.

Repair-SPManagedAccountDeployment [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Repair-SPManagedAccountDeployment cmdlet to repair the local deployment of managed account credentials deployment on a server for the rare cases that the managed accounts service credentials are in a broken state. It re-deploys each local service and Web applications credentials and also determines if the passphrase is not correct on the server and repairs provides warnings accordingly. The Repair-SPManagedAccountDeployment cmdlet should not be used as part of the regular credential update process, but should be one of the first troubleshooting steps, specifically if a servers' services are failing to start when other servers' services are working correctly.

Input Types

Return Types

Example

----------EXAMPLE-----------

Copy code
Repair-SPManagedAccountDeployment

This example repairs the deployment of credentials on all services and Web application associated with managed account (s) on the local server.


Revoke-SPObjectSecurity
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a security principal from a SPObjectSecurity object.

Revoke-SPObjectSecurity [-Identity] <SPObjectSecurity> [-Principal] <SPClaim> [[-Rights] <String[]>] [-AssignmentCollection <SPAssignmentCollection>]
Revoke-SPObjectSecurity [-Identity] <SPObjectSecurity> -All <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.Administration.AccessControl.SPObjectSecurity

Specifies the SPObjectSecurity object from which the security principal is removed. You can use the Get-SPServiceApplicationSecurity cmdlet to get a SPObjectSecurity object .

Principal

Required

Microsoft.SharePoint.Administration.Claims.SPClaim

Specifies the principal for whom the rights are removed.

The type must a valid name a principal; for example, Full Control.

Rights

Optional

System.String[]

Specifies the rights of the principal to revoke.

The type must a valid array of strings that represents the rights of the principal to revoke.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.Administration.AccessControl.SPObjectSecurity

Specifies the SPObjectSecurity object from which the security principal is removed. You can use the Get-SPServiceApplicationSecurity cmdlet to get a SPObjectSecurity object .

All

Required

System.Management.Automation.SwitchParameter

Specifies that all security principals are removed from the specified SPObjectSecurity object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Revoke-SPObjectSecurity cmdlet to remove a security principal, such as a user, from a SPObjectSecurity object. An SPObjectSecurity object is a common object that is used to represent the security access control list (ACL) of SharePoint administrative objects, in particular service applications.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$security = Get-SPServiceApplicationSecurity $serviceApp -AdminRevoke-SPObjectSecurity $security "domain\user"Set-SPServiceApplicationSecurity $serviceApp -Admin $security

This example retrieves the SPObjectSecurity object corresponding to the administrator ACL on a service application, and removes a user from that ACL. The removed an administrator for the service application $serviceApp.

See also

Grant-SPObjectSecurity
Get-SPServiceApplicationSecurity


Set-SPClaimProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Updates registration of a claims provider.

Set-SPClaimProvider [-Identity] <SPClaimProviderPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Default <SwitchParameter>] [-Enabled <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind

Specifies the claim provider to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a claim provider (for example, MyClaimProvider1); or an instance of a valid SPClaimProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Default

Optional

System.Management.Automation.SwitchParameter

Specifies that the claim provider applies to all Web applications and zones.

Enabled

Optional

System.Management.Automation.SwitchParameter

Turns on the claim provider.

Detailed Description

The Set-SPClaimProvider cmdlet updates registration of a claims provider.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Set-SPClaimProvider -Identity "12345678-90ab-cdef-1234-567890bcdefgh"

This example turns off the specified claim provider.

See also

Get-SPClaimProvider
Remove-SPClaimProvider
New-SPClaimProvider


Set-SPManagedAccount
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Configures the managed account.

Set-SPManagedAccount [-Identity] <SPManagedAccountPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-EmailNotification <Int32>] [-PreExpireDays <Int32>] [-Schedule <String>] [-WhatIf [<SwitchParameter>]]
Set-SPManagedAccount [-Identity] <SPManagedAccountPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AutoGeneratePassword <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-EmailNotification <Int32>] [-PreExpireDays <Int32>] [-Schedule <String>] [-WhatIf [<SwitchParameter>]]
Set-SPManagedAccount [-Identity] <SPManagedAccountPipeBind> -Password <SecureString> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-EmailNotification <Int32>] [-PreExpireDays <Int32>] [-Schedule <String>] [-WhatIf [<SwitchParameter>]]
Set-SPManagedAccount [-Identity] <SPManagedAccountPipeBind> -ConfirmPassword <SecureString> -NewPassword <SecureString> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-EmailNotification <Int32>] [-PreExpireDays <Int32>] [-Schedule <String>] [-SetNewPassword <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Set-SPManagedAccount [-Identity] <SPManagedAccountPipeBind> -ExistingPassword <SecureString> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-EmailNotification <Int32>] [-PreExpireDays <Int32>] [-Schedule <String>] [-UseExistingPassword <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

EmailNotification

Optional

System.Int32

Specifies the number of days before password change to begin e-mail notifications.

The default value is 5.

PreExpireDays

Optional

System.Int32

Specifies the number of days before expiration to schedule password change.

The default value is 2.

Schedule

Optional

System.String

Specifies the new schedule on which the password change job is to run.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AutoGeneratePassword

Optional

System.Management.Automation.SwitchParameter

Automatically generates a new password.

The type must be either of the following values:

- True

- False

The default value is False.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

EmailNotification

Optional

System.Int32

Specifies the number of days before password change to begin e-mail notifications.

The default value is 5.

PreExpireDays

Optional

System.Int32

Specifies the number of days before expiration to schedule password change.

The default value is 2.

Schedule

Optional

System.String

Specifies the new schedule on which the password change job is to run.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

Password

Required

System.Security.SecureString

Sets a password for the managed account.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

EmailNotification

Optional

System.Int32

Specifies the number of days before password change to begin e-mail notifications.

The default value is 5.

PreExpireDays

Optional

System.Int32

Specifies the number of days before expiration to schedule password change.

The default value is 2.

Schedule

Optional

System.String

Specifies the new schedule on which the password change job is to run.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

4

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

ConfirmPassword

Required

System.Security.SecureString

Confirms the new password for this managed account.

NewPassword

Required

System.Security.SecureString

Sets a new password for the managed account

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

EmailNotification

Optional

System.Int32

Specifies the number of days before password change to begin e-mail notifications.

The default value is 5.

PreExpireDays

Optional

System.Int32

Specifies the number of days before expiration to schedule password change.

The default value is 2.

Schedule

Optional

System.String

Specifies the new schedule on which the password change job is to run.

SetNewPassword

Optional

System.Management.Automation.SwitchParameter

Sets the password to the new value that is passed in, and changes the value in AD DS.

The type must be either of the following values:

- True

- False

The default value is False.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

5

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPManagedAccountPipeBind

Specifies the full name or partial name of the managed accounts to retrieve.

The type must be a valid account name, in the form Domain\User, or a GUID, in the form 1234-3456-09876.

ExistingPassword

Required

System.Security.SecureString

Sets the password for this managed account to an existing value that has already been changed in Active Directory Domain Services (AD DS).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

EmailNotification

Optional

System.Int32

Specifies the number of days before password change to begin e-mail notifications.

The default value is 5.

PreExpireDays

Optional

System.Int32

Specifies the number of days before expiration to schedule password change.

The default value is 2.

Schedule

Optional

System.String

Specifies the new schedule on which the password change job is to run.

UseExistingPassword

Optional

System.Management.Automation.SwitchParameter

Sets the password to a new value passed in where the value is already changed in AD DS.

The type must be either of the following values:

- True

- False

The default value is False.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPManagedAccount cmdlet sets the properties on the given managed account.

You can use this cmdlet to change the password expiration and notification settings for the managed account: Use the default parameter set. Additionally, you can use this cmdlet to change the password for the managed account to automatically generated passwords on a set schedule: Use the parameter set that includes the AutoGeneratePassword parameter. You can also use this cmdlet to change the password for the managed account to a new value, known to the administrator: Use the parameter set that includes the SetNewPassword parameter. Finally, you can use this cmdlet to change the password for the managed account to an existing value that has been already been changed in Active Directory Domain Services (AD DS): Use the parameter set that includes the UseExistingPassword parameter.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
$m = Get-SPManagedAccount -Identity "DOMAINx\UserY"
Copy code
Set-SPManagedAccount -Identity $m -AutoGeneratePassword true

This example displays an explicit managed account if it exists, and then attempts to update it to use automatically generated passwords.

See also

Get-SPManagedAccount
New-SPManagedAccount
Remove-SPManagedAccount


Set-SPSecurityTokenServiceConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Updates the settings of the SharePoint security token service (STS) identity provider.

Set-SPSecurityTokenServiceConfig [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-FormsTokenLifetime <Int32>] [-ImportSigningCertificate <X509Certificate2>] [-MaxLogonTokenCacheItems <Int32>] [-MaxServiceTokenCacheItems <Int32>] [-ServiceTokenCacheExpirationWindow <Int32>] [-ServiceTokenLifetime <Int32>] [-WhatIf [<SwitchParameter>]] [-WindowsTokenLifetime <Int32>]
Set-SPSecurityTokenServiceConfig -SigningCertificateThumbprint <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-FormsTokenLifetime <Int32>] [-MaxLogonTokenCacheItems <Int32>] [-MaxServiceTokenCacheItems <Int32>] [-ServiceTokenCacheExpirationWindow <Int32>] [-ServiceTokenLifetime <Int32>] [-SigningCertificateStoreName <String>] [-WhatIf [<SwitchParameter>]] [-WindowsTokenLifetime <Int32>]
Set-SPSecurityTokenServiceConfig [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-FormsTokenLifetime <Int32>] [-MaxLogonTokenCacheItems <Int32>] [-MaxServiceTokenCacheItems <Int32>] [-QueueSigningCertificate <X509Certificate2>] [-ServiceTokenCacheExpirationWindow <Int32>] [-ServiceTokenLifetime <Int32>] [-WhatIf [<SwitchParameter>]] [-WindowsTokenLifetime <Int32>]
Set-SPSecurityTokenServiceConfig -QueueSigningCertificateThumbprint <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-FormsTokenLifetime <Int32>] [-MaxLogonTokenCacheItems <Int32>] [-MaxServiceTokenCacheItems <Int32>] [-QueueSigningCertificateStoreName <String>] [-ServiceTokenCacheExpirationWindow <Int32>] [-ServiceTokenLifetime <Int32>] [-WhatIf [<SwitchParameter>]] [-WindowsTokenLifetime <Int32>]
Set-SPSecurityTokenServiceConfig [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-FormsTokenLifetime <Int32>] [-MaxLogonTokenCacheItems <Int32>] [-MaxServiceTokenCacheItems <Int32>] [-RevokeSigningCertificate <X509Certificate2>] [-ServiceTokenCacheExpirationWindow <Int32>] [-ServiceTokenLifetime <Int32>] [-WhatIf [<SwitchParameter>]] [-WindowsTokenLifetime <Int32>]
Set-SPSecurityTokenServiceConfig -RevokeSigningCertificateThumbprint <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-FormsTokenLifetime <Int32>] [-MaxLogonTokenCacheItems <Int32>] [-MaxServiceTokenCacheItems <Int32>] [-RevokeSigningCertificateStoreName <String>] [-ServiceTokenCacheExpirationWindow <Int32>] [-ServiceTokenLifetime <Int32>] [-WhatIf [<SwitchParameter>]] [-WindowsTokenLifetime <Int32>]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FormsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to ASP.NET Membership Provider and Role providers. The default value is 1380.

The type must be a valid integer.

ImportSigningCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the X.509 certificate object from trusted authentication provider farm.

The type must be a name of a valid X.509 certificate; for example, Certificate1.

MaxLogonTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory logon token cache. The default value is 10000 entries.

The type must be a valid integer.

MaxServiceTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory service token cache. The default value is 10000 entries.

The type must be a valid integer.

ServiceTokenCacheExpirationWindow

Optional

System.Int32

Specifies the interval, in minutes, for automatically renewing the token in the cache. The default value is 2 minutes.

The type must be a valid integer.

ServiceTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for the security token service cache. The default value is 15 minutes.

The type must be a valid integer.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WindowsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to Windows users. The default value is 1380 minutes.

The type must be a valid integer.

2

Parameter

Required

Type

Description

SigningCertificateThumbprint

Required

System.String

Specifies the thumbrpint of the signing certificate.

The type must be a valid identity of a signing certificate; for example 2796BAE63F1801E277261BA0D77770028F20EEE4.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FormsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to ASP.NET Membership Provider and Role providers. The default value is 1380.

The type must be a valid integer.

MaxLogonTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory logon token cache. The default value is 10000 entries.

The type must be a valid integer.

MaxServiceTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory service token cache. The default value is 10000 entries.

The type must be a valid integer.

ServiceTokenCacheExpirationWindow

Optional

System.Int32

Specifies the interval, in minutes, for automatically renewing the token in the cache. The default value is 2 minutes.

The type must be a valid integer.

ServiceTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for the security token service cache. The default value is 15 minutes.

The type must be a valid integer.

SigningCertificateStoreName

Optional

System.String

Specifies the certificate store where the signing certificate resides. The identity store for an identity provider can be a SQL database table, an Active Directory Domain Services (AD DS), or Active Directory Lightweight Directory Service (AD LDS).

The type must be a valid identity of a signing certificate store; for example IdentityStore1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WindowsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to Windows users. The default value is 1380 minutes.

The type must be a valid integer.

3

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FormsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to ASP.NET Membership Provider and Role providers. The default value is 1380.

The type must be a valid integer.

MaxLogonTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory logon token cache. The default value is 10000 entries.

The type must be a valid integer.

MaxServiceTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory service token cache. The default value is 10000 entries.

The type must be a valid integer.

QueueSigningCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

ServiceTokenCacheExpirationWindow

Optional

System.Int32

Specifies the interval, in minutes, for automatically renewing the token in the cache. The default value is 2 minutes.

The type must be a valid integer.

ServiceTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for the security token service cache. The default value is 15 minutes.

The type must be a valid integer.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WindowsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to Windows users. The default value is 1380 minutes.

The type must be a valid integer.

4

Parameter

Required

Type

Description

QueueSigningCertificateThumbprint

Required

System.String

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FormsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to ASP.NET Membership Provider and Role providers. The default value is 1380.

The type must be a valid integer.

MaxLogonTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory logon token cache. The default value is 10000 entries.

The type must be a valid integer.

MaxServiceTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory service token cache. The default value is 10000 entries.

The type must be a valid integer.

QueueSigningCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

QueueSigningCertificateStoreName

Optional

System.String

ServiceTokenCacheExpirationWindow

Optional

System.Int32

Specifies the interval, in minutes, for automatically renewing the token in the cache. The default value is 2 minutes.

The type must be a valid integer.

ServiceTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for the security token service cache. The default value is 15 minutes.

The type must be a valid integer.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WindowsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to Windows users. The default value is 1380 minutes.

The type must be a valid integer.

5

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FormsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to ASP.NET Membership Provider and Role providers. The default value is 1380.

The type must be a valid integer.

MaxLogonTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory logon token cache. The default value is 10000 entries.

The type must be a valid integer.

MaxServiceTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory service token cache. The default value is 10000 entries.

The type must be a valid integer.

RevokeSigningCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

ServiceTokenCacheExpirationWindow

Optional

System.Int32

Specifies the interval, in minutes, for automatically renewing the token in the cache. The default value is 2 minutes.

The type must be a valid integer.

ServiceTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for the security token service cache. The default value is 15 minutes.

The type must be a valid integer.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WindowsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to Windows users. The default value is 1380 minutes.

The type must be a valid integer.

6

Parameter

Required

Type

Description

RevokeSigningCertificateThumbprint

Required

System.String

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

FormsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to ASP.NET Membership Provider and Role providers. The default value is 1380.

The type must be a valid integer.

MaxLogonTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory logon token cache. The default value is 10000 entries.

The type must be a valid integer.

MaxServiceTokenCacheItems

Optional

System.Int32

Specifies the maximum number of entries for the in-memory service token cache. The default value is 10000 entries.

The type must be a valid integer.

RevokeSigningCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

RevokeSigningCertificateStoreName

Optional

System.String

ServiceTokenCacheExpirationWindow

Optional

System.Int32

Specifies the interval, in minutes, for automatically renewing the token in the cache. The default value is 2 minutes.

The type must be a valid integer.

ServiceTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for the security token service cache. The default value is 15 minutes.

The type must be a valid integer.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WindowsTokenLifetime

Optional

System.Int32

Specifies the expiration time, in minutes, for tokens issued to Windows users. The default value is 1380 minutes.

The type must be a valid integer.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPSecurityTokenServiceConfig cmdlet updates the settings of the SharePoint security token service (STS) identity provider. If a certificate file is used, the certificate must be an X509 certificate with private keys, otherwise an exception is raised.

Note:

This cmdlet operates only with certificates that can be exported. To create a certificate which can be used in this cmdlet specify the X509KeyStorageFlags.Exportable bit in the keyStorageFlags parameter of the x509Certificate2 object constructor.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Set-SPSecurityTokenServiceConfig -SigningCertificateThumbprint "2796BAE63F1801E277261BA0D77770028F20EEE4"

This example updates the signing certificate of the SharePoint security token service (STS) identity provider with a certificate that has been deployed in the certificate store.

------------------EXAMPLE 2------------------

Copy code
$stsCert = New-Object System.Security.Cryptography.X509Certificates.X509Certificate2 "c:\sts.pfx","a",20
Copy code
Set-SPSecurityTokenServiceConfig -ImportSigningCertificate $stsCert

This example imports the signing certificate for the SharePoint STS identity provider.

See also

Get-SPSecurityTokenServiceConfig


Set-SPServiceApplicationSecurity
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Updates the SPObjectSecurity object for a service application.

Set-SPServiceApplicationSecurity [-Identity] <SPServiceApplicationPipeBind> [-ObjectSecurity] <SPObjectSecurity> [-Admin <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application that contains the SPObjectSecurity object to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a service application (for example, ServiceApp1); or an instance of a valid SPServiceApplication object.

ObjectSecurity

Required

Microsoft.SharePoint.Administration.AccessControl.SPObjectSecurity

Specifies the SPObjectSecurity object to update.

Admin

Optional

System.Management.Automation.SwitchParameter

Updates the access control list (ACL) that contains the administrators list of the service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Set-SPServiceApplicationSecurity cmdlet updates a security object for the specified service application. Use this cmdlet with the Grant-SPObjectSecurity and Get-SPServiceApplicationSecurity cmdlets to manage security for a service application.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$security = Get-SPServiceApplicationSecurity $serviceApp -AdminGrant-SPObjectSecurity $security $principal "Full Control"Set-SPServiceApplicationSecurity $serviceApp -Admin $security

This example retrieves the SPObjectSecurity object corresponding to the administrator ACL on a service application, and adds a new user principal to that ACL. The new user is an administrator for the service application $serviceApp.

See also

Get-SPServiceApplicationSecurity
Grant-SPObjectSecurity
Revoke-SPObjectSecurity


Set-SPTrustedIdentityTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the identity providers of a Web application.

Set-SPTrustedIdentityTokenIssuer [-Identity] <SPTrustedIdentityTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-ClaimProvider <SPClaimProviderPipeBind>] [-ClaimsMappings <SPClaimMappingPipeBind[]>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-ImportTrustCertificate <X509Certificate2>] [-Realm <String>] [-SignInUrl <String>] [-UseWReply <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Set-SPTrustedIdentityTokenIssuer [-Identity] <SPTrustedIdentityTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-ClaimProvider <SPClaimProviderPipeBind>] [-ClaimsMappings <SPClaimMappingPipeBind[]>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-MetadataEndPoint <Uri>] [-Realm <String>] [-SignInUrl <String>] [-UseWReply <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Specifies the identity provider to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of identity provider (for example, LiveID STS); or an instance of a valid SPIdentityProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ClaimProvider

Optional

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind

Specifies the IP STS that can resolve and search claims for claims people picker.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a claim provider (for example, MyIDprovider1); or an instance of a valid SPClaimProvider object.

ClaimsMappings

Optional

Microsoft.SharePoint.PowerShell.SPClaimMappingPipeBind[]

Specifies the mapping of the claims from the original token to the SharePoint token.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a claim mapping rule (for example, Email); or an instance of a valid SPClaimMapping object.

Description

Optional

System.String

Specifies a description for the new identity provider.

The type must be a valid string; for example, LiveID STS.

ImportTrustCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the X.509 certificate object from trusted authentication provider farm.

The type must be a name of a valid X.509 certificate; for example, Certificate1.

Realm

Optional

System.String

Specifies the realm, or resource partition, associated with this trust.

The type must be a name of a valid realm; for example, MD_REALM.

SignInUrl

Optional

System.String

Specifies the sign-in URLs for this trusted identity provider STS.

The type must be a valid URL, in the form http://int.live.com/.

UseWReply

Optional

System.Management.Automation.SwitchParameter

Includes a WReply with the token request. Wreply is a URL at the relying party to which the requestor is redirected once sign-out processing is complete.

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Specifies the identity provider to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of identity provider (for example, LiveID STS); or an instance of a valid SPIdentityProvider object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ClaimProvider

Optional

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind

Specifies the IP STS that can resolve and search claims for claims people picker.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a claim provider (for example, MyIDprovider1); or an instance of a valid SPClaimProvider object.

ClaimsMappings

Optional

Microsoft.SharePoint.PowerShell.SPClaimMappingPipeBind[]

Specifies the mapping of the claims from the original token to the SharePoint token.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid name of a claim mapping rule (for example, Email); or an instance of a valid SPClaimMapping object.

Description

Optional

System.String

Specifies a description for the new identity provider.

The type must be a valid string; for example, LiveID STS.

MetadataEndPoint

Optional

System.Uri

Realm

Optional

System.String

Specifies the realm, or resource partition, associated with this trust.

The type must be a name of a valid realm; for example, MD_REALM.

SignInUrl

Optional

System.String

Specifies the sign-in URLs for this trusted identity provider STS.

The type must be a valid URL, in the form http://int.live.com/.

UseWReply

Optional

System.Management.Automation.SwitchParameter

Includes a WReply with the token request. Wreply is a URL at the relying party to which the requestor is redirected once sign-out processing is complete.

Detailed Description

The Set-SPTrustedIdentityTokenIssuer cmdlet sets the identity providers of a Web application or extended Web application. For the ASP.NET Membership provider and Role provider, this cmdlet changes the identity provider only if the result is piped to a variable and passed to a Web application. For security token service (STS) identity providers, this cmdlet changes the persisted identity provider object in the SPFarm object.

Input Types

Return Types

Example

-------------------------EXAMPLE 1----------------------

Copy code
Set-SPTrustedIdentityTokenIssuer "LiveIDSTS" -ImportTrustCertificate (Get-ChildItem"cert:Certificates (LocalComputer)\Personal\Certificates -Name "LiveID Cert")

This example sets the identity provider to LiveIDSTS.

-------------------------EXAMPLE 2----------------------

Copy code
$ip = @( (Get-SPTrustedIdentityTokenIssuer "LiveID STS"), (New-SPTrustedIdentityTokenIssuer -ASPNetMembershipProvider "myMembershipProvider" -ASPNetRoleProvider "myRoleProvider"), (Get-SPTrustedIdentityTokenIssuer "NTLM")) )New-SPWebApplication http://contoso.com -IdentityProvider $ip

This example sets the identity provider using the .ASPNetMembership and Role parameters. When these parameters are used, a variable must be set; otherwise, the values do not take effect.

See also

Get-SPTrustedIdentityTokenIssuer
New-SPTrustedIdentityTokenIssuer
Remove-SPTrustedIdentityTokenIssuer


Set-SPTrustedRootAuthority
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new trusted root authority.

Set-SPTrustedRootAuthority [-Identity] <SPTrustedRootAuthorityPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Certificate <X509Certificate2>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Set-SPTrustedRootAuthority [-Identity] <SPTrustedRootAuthorityPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MetadataEndPoint <Uri>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedRootAuthorityPipeBind

Specifies the trusted root authority to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a trusted root authority (for example, WFEFarm1); or an instance of a valid SPTrustedRootAuthority object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Certificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the X.509 certificate of the trusted root authority.

The type must be a name of a valid X.509 certificate; for example, Certificate1.

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedRootAuthorityPipeBind

Specifies the trusted root authority to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a trusted root authority (for example, WFEFarm1); or an instance of a valid SPTrustedRootAuthority object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Set-SPTrustedRootAuthority cmdlet creates a new trusted root authority. If a certificate file is used, the certificate must be an X509 certificate with private keys, otherwise an exception is raised.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
$cert = Get-PfxCertificate C:\LiveIDSigningCert.pfxGet - SPTrustedRootAuthority -Name "WFEFarm1" | Set- SPTrustedRootAuthority -Certificate $cert

This example updates the certificate of the trusted root authority WFEFarm1.

See also

Remove-SPTrustedRootAuthority
New-SPTrustedRootAuthority
Get-SPTrustedRootAuthority


Set-SPTrustedServiceTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Updates a trust with the farm.

Set-SPTrustedServiceTokenIssuer [-Identity] <SPTrustedServiceTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Certificate <X509Certificate2>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-WhatIf [<SwitchParameter>]]
Set-SPTrustedServiceTokenIssuer [-Identity] <SPTrustedServiceTokenIssuerPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-MetadataEndPoint <Uri>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedServiceTokenIssuerPipeBind

Specifies the trusted service token issuer to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a trusted service token issuer (for example, WFEFarm1); or an instance of a valid SPTrustedRootAuthority object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Certificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the X.509 certificate object from trusted authentication provider farm.

The type must be a name of a valid X.509 certificate; for example, Certificate1.

Description

Optional

System.String

Specifies a description for the trust.

The type must be a valid string; for example, WFE Farm Trust1.

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedServiceTokenIssuerPipeBind

Specifies the trusted service token issuer to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a trusted service token issuer (for example, WFEFarm1); or an instance of a valid SPTrustedRootAuthority object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Description

Optional

System.String

Specifies a description for the trust.

The type must be a valid string; for example, WFE Farm Trust1.

Detailed Description

The Set-SPTrustedServiceTokenIssuer cmdlet updates a trust with a SharePoint farm. If a certificate file is used, it must have only one X509 certificate without private keys, otherwise an exception is raised.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
$cert = Get-PfxCertificate C:\LiveIDSigningCert.pfxSet-SPTrustedServiceTokenIssuer "WFEFarm1" - Description "WFE Farm 1" - ImportTrustCertificate $cert

This example updates a SharePoint Farm trust using the trust certificate from a file.

------------------EXAMPLE 2------------------

Copy code
Set-SPTrustedServiceTokenIssuer "WFEFarm1" - Description "WFE Farm 1" -FederationMetadataUrl "https://liveid.com/STS/2007/03/fedmetadata.xml"

This example updates a SharePoint farm trust using the trust certificate from the federation metadata endpoint URL.

See also

Get-SPTrustedServiceTokenIssuer
New-SPTrustedServiceTokenIssuer
Remove-SPTrustedServiceTokenIssuer


Update-SPFarmEncryptionKey
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Changes the value of the farm encryption key and, using the new key, re-encrypts all the data.

Update-SPFarmEncryptionKey [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Resume <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Resume

Optional

System.Management.Automation.SwitchParameter

Resumes re-encryption of data with the new farm encryption key if a previous attempt failed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Update-SPFarmEncryptionKey cmdlet changes the farm encryption key to a new randomly generated value. When the new key is used, all the data is re-encrypted.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE-----------------------

Copy code
Update-SPFarmEncryptionKey -confirm

This example changes the farm encryption key to a new value and re-encrypts all the data.


Get-SPAuthenticationRealm
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the authentication realms.

Get-SPAuthenticationRealm [[-ServiceContext] <SPServiceContextPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

ServiceContext

Optional

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for which the realm needs to be displayed. For example, $root.web.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAuthenticationRealm cmdlet to display the authentication realms of the farm.

Input Types

Return Types

Example

----------------EXAMPLE-------------

Copy code
Get-SPAuthenticationRealm

This example displays the authentication realms in the entire farm.

See also

Set-SPAuthenticationRealm


Get-SPTrustedSecurityTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the trusted security token issuer object.

Get-SPTrustedSecurityTokenIssuer [[-Identity] <SPTrustedSecurityTokenServicePipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPTrustedSecurityTokenServicePipeBind

Specifies the ID of the trusted security token issuer object that you want to return. If you do not specify this parameter, the cmdlet returns all the objects.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPTrustedSecurityTokenService cmdlet to return the trusted security token issuer by using the Identity parameter. This cmdlet returns the SPSecurityTokenServiceManager object. The properties on this object can be set by using the Set-SPTrustedSecurityTokenIssuer cmdlet and then updated back to the object.

Input Types

Return Types

Example

-------------EXAMPLE----------

Copy code
Get-SPTrustedSecurityTokenService

This example displays all trusted security token service objects from the farm.

See also

New-SPTrustedSecurityTokenIssuer
Remove-SPTrustedSecurityTokenIssuer
Set-SPTrustedSecurityTokenIssuer


New-SPAzureAccessControlServiceApplicationProxy
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new service application proxy group.

New-SPAzureAccessControlServiceApplicationProxy -MetadataServiceEndpointUri <String> -Name <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

MetadataServiceEndpointUri

Required

System.String

Specifies the URL of the Azure Access Control Service's metadata document.

Name

Required

System.String

Specifies the name of the proxy that you want to create.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies whether the proxy needs to be added to the default proxy group.

Note:

We recommend that you add the proxy to the default proxy group.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPAzureAccessContrlServiceApplicationProxy cmdlet to create a new service application proxy group for the Azure Control service application.

Input Types

Return Types

Example

--------------EXAMPLE--------------

Copy code
New-SPAzureAccessControlServiceApplicationProxy -Name "ACS" -metadataEndpointUri "http://test" -DefaultProxyGroup

This example creates a proxy group named ACS which will be added to the default proxy group.


New-SPTrustedSecurityTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a trust between a server to server principal.

New-SPTrustedSecurityTokenIssuer [-Name] <String> -Certificate <X509Certificate2> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-IsTrustBroker <SwitchParameter>] [-RegisteredIssuerName <String>] [-WhatIf [<SwitchParameter>]]
New-SPTrustedSecurityTokenIssuer [-Name] <String> -MetadataEndPoint <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-IsTrustBroker <SwitchParameter>] [-RegisteredIssuerName <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the issuer.

Certificate

Required

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the X509Certificate object that represents the public key of the signing certificate of the security token issuer.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies the description of the issuer.

IsTrustBroker

Optional

System.Management.Automation.SwitchParameter

Specifies whether the trust is established with a self-issuer partner app (that is, Exchange Server 2010 or Exchange Server 2007 or Lync).

RegisteredIssuerName

Optional

System.String

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the issuer.

MetadataEndPoint

Required

System.Uri

Specifies the URI for the metadata endpoint of the issuer.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies the description of the issuer.

IsTrustBroker

Optional

System.Management.Automation.SwitchParameter

Specifies whether the trust is established with a self-issuer partner app (that is, Exchange Server 2010 or Exchange Server 2007 or Lync).

RegisteredIssuerName

Optional

System.String

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the New-SPTrustedSecurityTokenIssuer cmdlet to establish a trust between a server to server principal.

Input Types

Return Types

Example

-----------EXAMPLE-----------

Copy code
New-SPTrustedSecurityTokenIssuer -Name "SPFarmA" -MetadataEndPoint https://mysite/my/_layouts/metadata/test/1/ -isSelfIssuer "false"

This example creates a new trusted security token named SPFarmA.

See also

Get-SPTrustedSecurityTokenIssuer
Remove-SPTrustedSecurityTokenIssuer
Set-SPTrustedSecurityTokenIssuer


Remove-SPTrustedSecurityTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes the trusted security token service object.

Remove-SPTrustedSecurityTokenIssuer [-Identity] <SPTrustedSecurityTokenServicePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedSecurityTokenServicePipeBind

Specifies the ID of the trusted security token issuer object to be removed.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPTrustedSecurityTokenService cmdlet to remove the trusted security token service object by using the Identity parameter.

Input Types

Return Types

Example

-------------EXAMPLE---------

Copy code
Remove-SPTrustedSecurityTokenService -Identity FarmA

This example removes the trusted security token issuer object named FarmA from the farm.

See also

Get-SPTrustedSecurityTokenIssuer
New-SPTrustedSecurityTokenIssuer
Set-SPTrustedSecurityTokenIssuer


Set-SPAuthenticationRealm
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the authentication realm.

Set-SPAuthenticationRealm [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Realm <String>] [-ServiceContext <SPServiceContextPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Realm

Optional

System.String

Specifies the realm to be set.

ServiceContext

Optional

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for which the realm needs to be set. For example, $root.web.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAuthenticationRealm cmdlet to set the authentication realm at the farm or site collection level by using the Realm parameter.

Input Types

Return Types

Example

------------EXAMPLE-------

Copy code
$c = Get-SPServiceContext -Site "https://<websiteurl>"
Copy code
Set-SPAuthenticationRealm -ServiceContext $c -Realm "t686d436-9f16-42db-09b7-cb578e110ccd"

This example sets the authentication realm as specified by the realm parameter.

See also

Get-SPAuthenticationRealm


Set-SPTrustedSecurityTokenIssuer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets the trusted token issuer.

Set-SPTrustedSecurityTokenIssuer [-Identity] <SPTrustedSecurityTokenServicePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-IsTrustBroker <SwitchParameter>] [-MetadataEndPoint <Uri>] [-RegisteredIssuerName <String>] [-WhatIf [<SwitchParameter>]]
Set-SPTrustedSecurityTokenIssuer [-Identity] <SPTrustedSecurityTokenServicePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Certificate <X509Certificate2>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-IsTrustBroker <SwitchParameter>] [-RegisteredIssuerName <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedSecurityTokenServicePipeBind

Specifies the id of the SPTrustedSecurityTokenIssuer object to be set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies the description of the issuer.

IsTrustBroker

Optional

System.Management.Automation.SwitchParameter

Specifies whether the trust is established with a self-issuer partner app (that is, Exchange Server 2010 or Exchange Server 2007 or Lync).

MetadataEndPoint

Optional

System.Uri

Specifies the URI for the metadata endpoint of the issuer.

RegisteredIssuerName

Optional

System.String

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTrustedSecurityTokenServicePipeBind

Specifies the id of the SPTrustedSecurityTokenIssuer object to be set.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Certificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the X509Certificate object that represents the public key of the signing certificate of the security token issuer.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Specifies the description of the issuer.

IsTrustBroker

Optional

System.Management.Automation.SwitchParameter

Specifies whether the trust is established with a self-issuer partner app (that is, Exchange Server 2010 or Exchange Server 2007 or Lync).

RegisteredIssuerName

Optional

System.String

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPTrustedSecurityTokenIssuer cmdlet to set the trusted token issuer.

To set the certificate successfully, all of the required parameters must be specified.

Input Types

Return Types

Example

--------EXAMPLE---------

Copy code
$a=Get-SPTrustedSecurityTokenIssuer
Copy code
Set-SPTrustedSecurityTokenIssuer -Identity $a -MetadataEndpoint https://<webappurl/>/_layouts/15/metadata/json/1/

This example sets the metadata endpoint of the url for the self-issue.

See also

Get-SPTrustedSecurityTokenIssuer
New-SPTrustedSecurityTokenIssuer
Remove-SPTrustedSecurityTokenIssuer


Get-SPAppPrincipal
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Displays a specific app principal object.

Get-SPAppPrincipal -NameIdentifier <String> -Site <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

NameIdentifier

Required

System.String

Specifies the app principal's name identifier to search for.

Site

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPAppPrincipal cmdlet to display a specific app principal object from the SharePoint app registry.

Input Types

Return Types

Example

-----------EXAMPLE--------

Copy code
Get-SPAppPrincipal -NameIdentifier "00000003-0000-0ff1-ce00-000000000000@f686d426-8d16-42db-81b7-cb578e110ccd"

This example returns the app principal for a specified ID.

See also

Register-SPAppPrincipal


Register-SPAppPrincipal
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Lets an on-premise or SharePoint Online administrator register an app principal.

Register-SPAppPrincipal -DisplayName <String> -NameIdentifier <String> -Site <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

DisplayName

Required

System.String

Specifies the friendly name to use for the app principal that is being registered.

NameIdentifier

Required

System.String

Specifies the app principal's name identifier that needs to be added to the app management service.

Site

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Register-SPAppPrincipal cmdlet to let an on-premise farm or SharePoint Online administrator to register an app principal management service.

Input Types

Return Types

Example

------------EXAMPLE--------

Copy code
$site = Get-SPSite "https://<urlofsite>"
Copy code
Register-SPAppPrincipal -site $site.root -NameIdentifier "00000003-0000-0ff1-ce00-000000000000@f686d426-8d16-42db-81b7-cb578e110ccd" -DisplayName "Contoso SharePoint Online"

This example registers the app principal named Contoso SharePoint Online.

See also

Get-SPAppPrincipal


Remove-SPAppPrincipalPermission
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes the permissions on a specified app principal.

Remove-SPAppPrincipalPermission -AppPrincipal <SPAppPrincipal> -Scope <Site | SiteCollection | SiteSubscription> -Site <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DisableAppOnlyPolicy <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AppPrincipal

Required

Microsoft.SharePoint.SPAppPrincipal

Specifies the AppPrincipal object to remove.

Scope

Required

Microsoft.SharePoint.PowerShell.SPCmdletAppPrincipalPermissionScope

Specifies the scope to which to apply the principal permission.

The value is any of the following scopes:

--Farm

--Site collection

--SharePoint Online

--Web

--Documents, List, or Library

Site

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the site (that is, SPWeb object) to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPAppPrincipalPermission cmdlet to remove the permissions on a specified app principal for a given scope (that is, SharePoint Online, site collection, or web).

Input Types

Return Types

Example

---------------EXAMPLE------------

Copy code
$appPrincipal= Get-SPApplicationPrincipal -nameIdentifier $spTrustedIssuer.nameIdentifier - web $site.rootWeb
Copy code
Remove-AppPrincipalPermission -appPrincipal $appPrincipal -site $site.rootweb -scope "spweb"

This example removes the App Principal permission from the site collection scope.

See also

Set-SPAppPrincipalPermission


Set-SPAppPrincipalPermission
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the permissions on a given app principal.

Set-SPAppPrincipalPermission -AppPrincipal <SPAppPrincipal> -Right <Read | Write | Manage | FullControl> -Scope <Site | SiteCollection | SiteSubscription> -Site <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-EnableAppOnlyPolicy <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AppPrincipal

Required

Microsoft.SharePoint.SPAppPrincipal

Specifies the AppPrincipal object.

Right

Required

Microsoft.SharePoint.PowerShell.SPCmdletAppPrincipalPermissionKind

Specifies the permission level for the principal object.

The value is any of the following levels:

----Read

--Write

--Manage

--Full Control

Scope

Required

Microsoft.SharePoint.PowerShell.SPCmdletAppPrincipalPermissionScope

Specifies the scope to which to apply the principal permission.

The value is any of the following scopes:

--Farm

--Site collection

--SharePoint Online

--Web

--Documents, List, or Library

Site

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPAppPrincipalPermission cmdlet to set the permissions on a given app principal for a given scope (tenant, site collection, and web) and given levels (Read, Write, Manage, Full Control).

Input Types

Return Types

Example

---------------EXAMPLE-------------

Copy code
$appPrincipal= Get-SPApplicationPrincipal -nameIdentifier $spTrustedIssuer.nameIdentifier -web $site.rootWeb
Copy code
Set-AppPrincipalPermission -appPrincipal $appPrincipal -site $site.rootweb -scope "spweb" -level "WRITE"

This example sets the Write permission level of to the SPWeb scope.

See also

Remove-SPAppPrincipalPermission


Convert-SPWebApplication
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Converts the authentication mode of a web application.

Convert-SPWebApplication -Identity <SPWebApplicationPipeBind> -To <String> [-AssignmentCollection <SPAssignmentCollection>] [-Force <SwitchParameter>] [-RetainPermissions <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL of the web application that you want to convert, for example: http://mysite/app1

To

Required

System.String

Specifies the string Claims that dictates that the application needs to be converted to claims authentication mode.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Force

Optional

System.Management.Automation.SwitchParameter

Forces the conversion of the web application.

RetainPermissions

Optional

System.Management.Automation.SwitchParameter

Specifies the account under which the cmdlet is run and retains the permission in the web application.

Detailed Description

Use the Convert-SPWebApplication cmdlet to convert the authentication mode of a Web application to Windows Claims authentication mode and migrate the user accounts in the content database to claims encoded values.

Input Types

Return Types

Example

------------EXAMPLE-------

Copy code
Convert-SPWebApplication -Identity "https://<webappurl>" -To Claims -RetainPermissions [-Force]

This example converts a web application specified by the Identity parameter to use the claim authentication mode.


Service application cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you administer service applications in a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use Windows PowerShell cmdlets to administer service applications in a SharePoint farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Add-SPServiceApplicationProxyGroupMember | Adds a member to the service application proxy group.
Get-SPServiceApplication | Returns the specified service application.
Get-SPServiceApplicationEndpoint | Returns the endpoint of a service application.
Get-SPServiceApplicationPool | Returns the specified Internet Information Services (IIS) application pool.
Get-SPServiceApplicationProxy | Returns an instance of the specified service application proxy.
Get-SPServiceApplicationProxyGroup | Returns the proxy group for the specified service application.
Get-SPServiceContext | Returns a service context.
Get-SPServiceHostConfig | Returns the common Web service settings.
Get-SPServiceInstance | Returns the services instance for a specific server or the entire farm.
Get-SPTopologyServiceApplication | Displays properties of the topology service application for the current farm.
Get-SPTopologyServiceApplicationProxy | Retrieves the topology service application proxy.
Get-SPUsageApplication | Returns a specified usage application.
Get-SPUsageDefinition | Returns a usage definition object.
Get-SPUsageService | Returns a usage service.
Install-SPService | Installs and provisions services on a farm.
New-SPServiceApplicationPool | Creates a new Web service application pool.
New-SPServiceApplicationProxyGroup | Creates a new service application proxy group.
New-SPSubscriptionSettingsServiceApplication | Creates a new subscription settings service application.
New-SPSubscriptionSettingsServiceApplicationProxy | Creates an application proxy to a subscription settings service application.
New-SPUsageApplication | Creates a new usage application.
Publish-SPServiceApplication | Shares the specified local service application outside the farm.
Remove-SPServiceApplication | Deletes the specified service application on the local server.
Remove-SPServiceApplicationPool | Completely deletes the specified Web service application pool.
Remove-SPServiceApplicationProxy | Deletes the specified service application proxy.
Remove-SPServiceApplicationProxyGroup | Completely deletes the specified service application proxy group.
Remove-SPServiceApplicationProxyGroupMember | Removes one or more proxies from the specified service application proxy group.
Remove-SPSiteSubscriptionBusinessDataCatalogConfig | Removes the Business Data Connectivity Metadata Store for a partition.
Remove-SPUsageApplication | Removes a usage application from the local farm.
Set-SPServiceApplication | Sets properties of a service application.
Set-SPServiceApplicationEndpoint | Sets the host of an endpoint for a service application.
Set-SPServiceApplicationPool | Changes the account used for the Identity of the specified application pool.
Set-SPServiceHostConfig | Configures one or more common settings for all Web services.
Set-SPTopologyServiceApplication | Sets the properties on the topology service application of the local farm.
Set-SPTopologyServiceApplicationProxy | Sets the proxy properties of the topology service application.
Set-SPUsageApplication | Sets properties of a usage application.
Set-SPUsageDefinition | Sets the retention period for a usage provider.
Set-SPUsageService | Sets the properties of a usage service.
Start-SPServiceInstance | Starts the service instance for a service on a specific server or the farm.
Stop-SPServiceInstance | Stops the service instance for a service.
Unpublish-SPServiceApplication | Stops sharing the specified service application outside the farm.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Add-SPServiceApplicationProxyGroupMember
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a member to the service application proxy group.

Add-SPServiceApplicationProxyGroupMember [-Identity] <SPServiceApplicationProxyGroupPipeBind> [-Member] <SPServiceApplicationProxyPipeBind[]> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

SPServiceApplicationProxyGroupPipeBind.

Specifies the service application proxy group to which to add the member.

Member

Required

SPServiceApplicationProxyPipeBind[]

Specifies an array of members to add to the service application proxy group.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Add-SPServiceApplicationProxyGroupMember cmdlet adds a member to the service application proxy group.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Add-SPServiceApplicationProxyGroupMember RemoteProxyGroup -Member babab30e-8e3a-428b-8ff4-4d5c8f455e6d

This example adds a select service application proxy to the service application proxy group named RemoteProxyGroup.

The service application proxy group GUID is unique to every farm. You can run Get-SPServiceApplicationProxyGroup | Select Name,Id to see the GUID of the serviceapplication proxy groups. Use this result for any other SPServiceApplicationProxyGroup cmdlets.

See also

Remove-SPServiceApplicationProxyGroupMember


Get-SPServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the specified service application.

Get-SPServiceApplication [[-Identity] <SPServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Name <String>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the GUID of the service application to get.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPServiceApplication cmdlet returns the service application specified by the Identity parameter. If no parameter is specified, the cmdlet returns all service applications in the farm.

Input Types

Return Types

Example

------------------EXAMPLE----------------------

Copy code
Get-SPServiceApplication

This example returns all service applications in the farm.

See also

Set-SPServiceApplication
Get-SPServiceApplicationProxy


Get-SPServiceApplicationEndpoint
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the endpoint of a service application.

Get-SPServiceApplicationEndpoint [-Identity] <SPServiceEndpointPipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPServiceApplicationEndpoint -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Name <String>]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceEndpointPipeBind

Specifies the service endpoint to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URI of an endpoint address, in the form http://sitename:8003/servicemodelsamples/service; or an instance of a valid SPServiceEndpoint object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubscriptionSettingsApp1); or an instance of a valid SPServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Name

Optional

System.String

Specifies the name of the service application endpoint.

The type must be a valid name of an service application endpoint; for example, SvcAppEndpoint1.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPServiceApplicationEndpoint cmdlet sets the host of a service endpoint. Use the second parameter set and do not specify the Name parameter to return a collection of all endpoints for the specified service application.

Input Types

Return Types

Example

-------------------EXAMPLE--------------------

Copy code
Get- SPServiceApplicationEndpoint -ServiceApplication "ServiceSubApp1"

This example returns the SPServiceEndpoint object based on the specified service application.

See also

Set-SPServiceApplicationEndpoint


Get-SPServiceApplicationPool
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the specified Internet Information Services (IIS) application pool.

Get-SPServiceApplicationPool [[-Identity] <SPIisWebServiceApplicationPoolPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the name or identifier (ID) of the application pool to get.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPServiceApplicationPool cmdlet returns the IIS application pool specified by the Identity parameter, or returns all application pools if the Identity parameter is not specified.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPServiceApplicationPool

This example returns all the service application pools in the farm.

See also

New-SPServiceApplicationPool
Set-SPServiceApplicationPool
Remove-SPServiceApplicationPool


Get-SPServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns an instance of the specified service application proxy.

Get-SPServiceApplicationProxy [[-Identity] <SPServiceApplicationProxyPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the GUID of the service application proxy to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPServiceApplicationProxy cmdlet returns an instance of the service application proxy specified by the Identity parameter.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPServiceApplicationProxy

This example retrieves all the service application proxies in the farm.

See also

Remove-SPServiceApplicationProxy
New-SPServiceApplicationProxyGroup
Remove-SPServiceApplicationProxyGroup
Get-SPServiceApplicationProxyGroup


Get-SPServiceApplicationProxyGroup
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the proxy group for the specified service application.

Get-SPServiceApplicationProxyGroup [[-Identity] <SPServiceApplicationProxyGroupPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]
Get-SPServiceApplicationProxyGroup -Default <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies the name or the GUID of the proxy group.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

Default

Required

System.Management.Automation.SwitchParameter

Returns the default sevice proxy group for the farm.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPServiceApplicationProxyGroup cmdlet displays a list of the proxy groups in the farm. To display a specific proxy group, use the Identity parameter. If no parameter value is specified, a list of all proxy groups is displayed.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPServiceApplicationProxyGroup

This example retrieves all of the service application proxy groups in the farm.

See also

New-SPServiceApplicationProxyGroup
Remove-SPServiceApplicationProxyGroup
Add-SPServiceApplicationProxyGroupMember


Get-SPServiceContext
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a service context.

Get-SPServiceContext [-Site] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPServiceContext -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Returns the service context for only the Web application that contains the specified site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Returns the service context for only the Web application that contains the specified site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

SiteSubscription

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Returns all of the service contexts for all Web applications in which the specified site subscription has site collections.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscriptionConfig1); or an instance of a valid SiteSubscription object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPServiceContext cmdlet returns a service context or a collection of service contexts. Specify the Site parameter to return an individual service context, or specify the SiteSubscription parameter to return a collection of service contexts.

Input Types

Return Types

Example

----------------EXAMPLE---------------

Copy code
$sitesub = Get-SPSiteSubscription http://my.contoso.com/
Copy code
Get-SPServiceContext $sitesub

This example returns the service context for a site in a hosted environment.


Get-SPServiceHostConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the common Web service settings.

Get-SPServiceHostConfig [-AssignmentCollection <SPAssignmentCollection>] [-Default <SwitchParameter>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Default

Optional

System.Management.Automation.SwitchParameter

This parameter has no effect.

Detailed Description

The Get-SPServiceHostConfig returns the common Web service settings.

Input Types

Return Types

Example

--------------EXAMPLE-------------------

Copy code
Get-SPServiceHostConfig

This example displays the Web service settings.

See also

Set-SPServiceHostConfig


Get-SPServiceInstance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the services instance for a specific server or the entire farm.

Get-SPServiceInstance [[-Identity] <SPServiceInstancePipeBind>] [-All <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>]
Get-SPServiceInstance -Server <SPServerPipeBind> [-All <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPServiceInstancePipeBind

Specifies the GUID of the service instance.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

Server

Required

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the server from which to return the service instance.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPServiceInstance cmdlet returns the services instance specified by the Identity parameter for a specific server. If the Server parameter is not specified, the Get-SPServiceInstance cmdlet returns results for the entire farm.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPServiceInstance -Server ServerA

This example displays the service instances from a given server.

See also

Start-SPServiceInstance
Stop-SPServiceInstance


Get-SPTopologyServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Displays properties of the topology service application for the current farm.

Get-SPTopologyServiceApplication [[-Identity] <SPTopologyWebServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPTopologyWebServiceApplicationPipeBind

Specifies the GUID of the application.

The type must be a valid GUID, in the form 1234-4567-098jhj.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPTopologyServiceApplication cmdlet displays the advanced properties of an application when the Identity parameter is used.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPTopologyServiceApplication

This example displays properties of the topology service application for the current farm.

See also

Set-SPTopologyServiceApplication
Get-SPTopologyServiceApplicationProxy


Get-SPTopologyServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Retrieves the topology service application proxy.

Get-SPTopologyServiceApplicationProxy [[-Identity] <SPTopologyWebServiceProxyPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPTopologyWebServiceProxyPipeBind

Specifies the GUID of the application proxy.

The type must be a valid GUID, in the form 1234-4567-098jhj.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPTopologyServiceApplicationProxy cmdlet retrieves the local topology service application proxy.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPTopologyServiceApplicationProxy

This example displays the topology service application proxy in the farm.

See also

Set-SPTopologyServiceApplicationProxy
Set-SPTopologyServiceApplication


Get-SPUsageApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a specified usage application.

Get-SPUsageApplication [[-Identity] <SPUsageApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-UsageService <SPUsageServicePipeBind>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPUsageApplicationPipeBind

Specifies the usage application to get. If the Identity parameter is not specified, the cmdlet returns the local usage application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a usage application (for example, UsageApplication1); or an instance of a valid SPUsageApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

UsageService

Optional

Microsoft.SharePoint.PowerShell.SPUsageServicePipeBind

Filters to return the usage application with the specified parent SPUsageService object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a usage service (for example, UsageService1); or an instance of a valid SPUsageService object.

Detailed Description

The Get-SPUsageApplication cmdlet return a specified usage application. If the Identity parameter is not specified, the cmdlet returns the local usage application.

Input Types

Return Types

Example

---------------EXAMPLE------------------

Copy code
Get-SPUsageApplication -Identity "Usage and Health data collection"

This example returns the usage application named, Usage and Health data collection

See also

New-SPUsageApplication
Set-SPUsageApplication
Remove-SPUsageApplication


Get-SPUsageDefinition
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a usage definition object.

Get-SPUsageDefinition [[-Identity] <SPUsageDefinitionPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPUsageDefinitionPipeBind

Specifies the usage definition object to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a usage definition (for example, SiteSubscriptionConfig1); or an instance of a valid SPUsageDefinition object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPUsageDefinition cmdlet reads a usage definition object. If the Identity parameter is not specified, this cmdlet returns the collection of usage definitions in the farm. A usage definition object defines a specific type of usage.

Input Types

Return Types

Example

-----------------EXAMPLE-----------------

Copy code
Get-SPUsageDefinition -Identity "Page Requests"

This example returns the SPRequestUsage provider on the local farm.

See also

Set-SPUsageDefinition


Get-SPUsageService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a usage service.

Get-SPUsageService [[-Identity] <SPUsageServicePipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPUsageServicePipeBind

Specifies the usage service to get. If the Identity parameter is not specified, the cmdlet returns the local usage service.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a usage service (for example, UsageService1); or an instance of a valid SPUsageService object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPUsageService cmdlet returns the specified usage service. If the Identity parameter is not specified, the cmdlet returns the local usage service.

Input Types

Return Types

Example

-------------------EXAMPLE-------------------------

Copy code
Get-SPUsageService -Identity 57055d99-9914-4af6-a3bf-7b76e3f231c2

This example returns a SPUsageService object of the specified ID.

See also

Set-SPUsageService


Install-SPService
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Installs and provisions services on a farm.

Install-SPService [-AssignmentCollection <SPAssignmentCollection>] [-Provision <SwitchParameter>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Provision

Optional

System.Management.Automation.SwitchParameter

Specifies default settings when installing a standalone service application.

Detailed Description

The Install-SPService cmdlet installs and optionally provisions services on a farm. This cmdlet installs all services, service instances, and service proxies specified in the registry on the local server computer. Use this cmdlet in a script that you build to install and deploy a SharePoint farm or to install a custom developed service.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Install-SPService

This example installs all services, service instances and service proxies specified in the registry on the local server computer.


New-SPServiceApplicationPool
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Web service application pool.

New-SPServiceApplicationPool [-Name] <String> [-Account] <SPProcessAccountPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the new Web service application pool.

Account

Required

Microsoft.SharePoint.PowerShell.SPProcessAccountPipeBind

Specifies the credentials that will be the identity of the new application pool.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPServiceApplicationPool cmdlet creates a new Web service application pool in Internet Information Services (IIS).

Input Types

Return Types

Example

--------------------EXAMPLE-----------------------

Copy code
New-SPServiceApplicationPool -Name TestServiceWebApplicationPool -Account testdomain\testuser1

This example creates a new Web service application pool.

For the Account parameter, the name of a managed account in the farm can be given. Use the Get-SPManagedAccount cmdlet to view the existing managed account in the farm. Also, a process account from the output of the Get-SPProcessAccount cmdlet can be used.

See also

Get-SPServiceApplicationPool
Set-SPServiceApplicationPool
Remove-SPServiceApplicationPool


New-SPServiceApplicationProxyGroup
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new service application proxy group.

New-SPServiceApplicationProxyGroup [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the new service application proxy group.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPServiceApplicationProxyGroup cmdlet creates a new service application proxy group specified by the Name parameter.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
New-SPServiceApplicationProxyGroup -Name RemoteProxyGroup

This example creates a new service application proxy with the name RemoteProxyGroup.

See also

Get-SPServiceApplicationProxyGroup
Add-SPServiceApplicationProxyGroupMember
Remove-SPServiceApplicationProxyGroup


New-SPSubscriptionSettingsServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Creates an application proxy to a subscription settings service application.

New-SPSubscriptionSettingsServiceApplicationProxy -Uri <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
New-SPSubscriptionSettingsServiceApplicationProxy -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Uri

Required

System.String

Specifies the address of the subscription settings service application to associate the new application proxy with.

The type must be a valid URI, in the form file:\\server_name\sitedocs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the subscription settings service application associated with the new proxy.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubscriptionSettingsApp1); or an instance of a valid SPServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the New-SPSubscriptionSettingsServiceApplicationProxy cmdlet to create an application proxy to a subscription settings service application. This is required for the local farm to consume a subscription settings service application.

Input Types

Return Types

Example

--------------------EXAMPLE---------------------------

Copy code
$AppPool = New-SPIisWebServiceApplicationPool -Name SettingsServiceAppPool -Account (Get-SPManagedAccount DOMAIN\jdoe)
Copy code
$App = New-SPSubscriptionSettingsServiceApplication -ApplicationPool $appPool -Name SettingsServiceApp -DatabaseName SettingsServiceDB
Copy code
$proxy = New-SPSubscriptionSettingsServiceApplicationProxy -ServiceApplication $App
Copy code
Get-SPServiceInstance | where{$_.TypeName -eq "Microsoft SharePoint Foundation Subscription Settings Service"} | Start-SPServiceInstance

This example creates an application pool, a new settings service application, a settings service application proxy, and then starts the service instance on the local machine. This example assumes that a managed account for DOMAIN\jdoe already exists.

See also

New-SPSubscriptionSettingsServiceApplication
Set-SPSubscriptionSettingsServiceApplication


New-SPSubscriptionSettingsServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Creates a new subscription settings service application.

New-SPSubscriptionSettingsServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-FailoverDatabaseServer <String>] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the IIS application pool to use for the new subscription settings application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL Server Authentication.

The type must be a valid PSCredential object.

DatabaseName

Optional

System.String

Specifies the name of the subscription settings database.

If not provided, one will be generated.

The type must be a valid name of a SQL Server database; for example, SubscriptionSettingsApp1.

DatabaseServer

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the name of the host SQL Server instance for the database specified in the DatabaseName parameter. If not provided, the default database server will be used

The type must be a valid SQL Server instance name; for example, SQLServerHost1.

The type must be a valid name of a SQL Server database; for example, SubscriptionSettingsApp1.

FailoverDatabaseServer

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the name of the host SQL Server instance for the failover database server.

The type must be a valid SQL Server instance name; for example, SQLServerHost1.

Name

Optional

System.String

Specifies the friendly name of the new subscription settings service.

The type must be a valid name of a subscription settings service application; for example, SubscriptionSettingsApp1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPSubscriptionSettingsServiceApplication cmdlet to create a subscription settings service application that can be used to store settings that are shared across all site collections in a single site subscription. This cmdlet is used only in an environment where site subscriptions are used to delegate administration or partition services that are used for storing settings that are shared across all site collections in a single site subscription. This cmdlet is used only in an environment where site subscriptions are used to delegate administration or partition services.

Input Types

Return Types

Example

-------------EXAMPLE---------------

Copy code
$AppPool = New-SPServiceApplicationPool -Name SettingsServiceAppPool -Account (Get-SPManagedAccount DOMAIN\jdoe)
Copy code
$App = New-SPSubscriptionSettingsServiceApplication -ApplicationPool $appPool -Name SettingsServiceApp -DatabaseName SettingsServiceDB
Copy code
$proxy = New-SPSubscriptionSettingsServiceApplicationProxy -ServiceApplication $App
Copy code
Get-SPServiceInstance | where{$_.TypeName -eq "Microsoft SharePoint Foundation Subscription Settings Service"} | Start-SPServiceInstance

This example creates an application pool, a new subscription settings service application, a subscription settings service application proxy, and starts the service instance on the local machine. This example assumes that a managed account for DOMAIN\jdoe already exists.

See also

Set-SPSubscriptionSettingsServiceApplication
New-SPSubscriptionSettingsServiceApplicationProxy


New-SPUsageApplication
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Creates a new usage application.

New-SPUsageApplication [[-Name] <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-FailoverDatabaseServer <String>] [-UsageService <SPUsageServicePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Optional

System.String

Specifies the friendly name of the new usage application.

The type must be a valid name of a usage application; for example, UsageApplication1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseName

Optional

System.String

Specifies the name of the logging database. If the logging database does not exist, a logging database is automatically created.

The type must be a valid name of a SQL Server database; for example, UsageLogDB1.

DatabasePassword

Optional

System.Security.SecureString

Specifies the password for the user specified in DatabaseUserName. Use this parameter only if SQL Server Authentication is used to access the logging database.

The type must be a valid password.

DatabaseServer

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the SPServer object where the logging database is created.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; the IP address of a server computer, in the form 208.77.188.166; a valid name of a SQL Server host service (for example, SQLServerHost1); or an instance of a valid SPServer object.

DatabaseUsername

Optional

System.String

Specifies the user name to use for connecting to the logging database. Use this parameter only if SQL Server Authentication is used to access the logging database.

The type must be a valid user name; for example, UserName1.

FailoverDatabaseServer

Optional

System.String

Specifies the name of the host SQL Server instance for the failover database server.

The type must be a valid SQL Server instance name; for example, SQLServerHost1.

UsageService

Optional

Microsoft.SharePoint.PowerShell.SPUsageServicePipeBind

Filters to return the usage application with the specified parent SPUsageService object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a usage service (for example, UsageService1); or an instance of a valid SPUsageService object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPUsageApplication cmdlet creates a new usage application in the local farm.

Input Types

Return Types

Example

-------------------EXAMPLE-------------------------

Copy code
New-SPUsageApplication -Name "Usage Application For Farm ABC"

This example creates a new usage application for the specified name.


Publish-SPServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Shares the specified local service application outside the farm.

Publish-SPServiceApplication [-Identity] <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-InfoLink <Uri>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the GUID of the service application to share outside the farm.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Description

Optional

System.String

Describes the service application to share outside the farm. If no value is specified, the value is left blank.

InfoLink

Optional

System.Uri

Specifies the link to more information about the service application to share outside the farm. If no link is specified, no link is made available.

The type must be a valid URL, in the form http://server_name/Site_Name/page_name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Publish-SPServiceApplication cmdlet publishes the local service application, specified by the Identity parameter, outside the farm.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Publish-SPServiceApplication 053c34be-d251-488c-8e94-644eae94da26 -Description "Connect to this TestServiceApplcation of you want to use FeatureA in your farm" -InfoLink http://testurl

This example publishes a service application to another farm.

The service application GUID is unique to every farm. You can run the Get-SPServiceApplication cmdlet to see the GUID of the service applications, and then use the result from the Get-SPServiceApplication cmdlet for other SPServiceApplication cmdlets; for example, Grant-SPServiceApplication.

See also

Get-SPServiceApplication
Set-SPServiceApplication
Remove-SPServiceApplication


Remove-SPServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes the specified service application on the local server.

Remove-SPServiceApplication [-Identity] <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-RemoveData <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the GUID of the service application to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

RemoveData

Optional

SwitchParameter

Deletes all databases and other data associated with the service application.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPServiceApplication cmdlet deletes the specified service application from the farm.

Input Types

Return Types

Example

--------------------EXAMPLE---------------------------

Copy code
Remove-SPServiceApplication 053c34be-d251-488c-8e94-644eae94da26 -RemoveData

This example deletes the service application and its database.

The service application GUID is unique to every farm. You can run the Get-SPServiceApplication cmdlet to see the GUID of the service applications, and then use the result from the Get-SPServiceApplication cmdlet for other SPServiceApplication cmdlets; for example, or Publish-SPServiceApplication.

See also

Get-SPServiceApplication
Set-SPServiceApplication
Publish-SPServiceApplication


Remove-SPServiceApplicationPool
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Completely deletes the specified Web service application pool.

Remove-SPServiceApplicationPool [-Identity] <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the identity of the Web service application pool to delete.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPServiceApplicationPool cmdlet completely deletes the specified Web service application pool.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Remove-SPServiceApplicationPool TestServiceWebApplicationPool

This example deletes the selected service application pool.

See also

Get-SPServiceApplicationPool
Set-SPServiceApplicationPool
Remove-SPServiceApplicationPool


Remove-SPServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes the specified service application proxy.

Remove-SPServiceApplicationProxy [-Identity] <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-RemoveData <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the GUID of the service application proxy to remove.

The type must be a GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

RemoveData

Optional

System.Management.Automation.SwitchParameter

Deletes all databases and other data associated with the service application proxy.

AssignmentColletion

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentColletion

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPServiceApplicationProxy cmdlet deletes the service application proxy specified by the Identity parameter.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Remove-SPServiceApplicationProxy babab30e-8e3a-428b-8ff4-4d5c8f455e6d

This example deletes the given service application proxy.

The service application GUID is unique to every farm. You can run the Get-SPServiceApplication cmdlet to see the GUID of the service applications, and then use the result from the Get-SPServiceApplication cmdlet for other SPServiceApplication cmdlets; for example, Grant-SPServiceApplication or Publish-SPServiceApplication.

See also

Get-SPServiceApplicationProxy
New-SPServiceApplicationProxyGroup
Remove-SPServiceApplicationProxy


Remove-SPServiceApplicationProxyGroup
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Completely deletes the specified service application proxy group.

Remove-SPServiceApplicationProxyGroup [-Identity] <SPServiceApplicationProxyGroupPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

The identity of the service application proxy group to delete.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Completely deletes the specified service application proxy group.

Input Types

Return Types

Example

--------------------EXAMPLE-------------------------

Copy code
Remove-SPServiceApplicationProxyGroup RemoteProxyGroup

This example deletes the service application proxy group named RemoteProxyGroup.

The service application proxy group GUID is unique to every farm. You can run Get-SPServiceApplicationProxyGroup | Select Name,Id to see the GUID of the service application proxy groups. Use this result for any other SPServiceApplicationProxyGroup cmdlets.

See also

Get-SPServiceApplicationProxyGroup
New-SPServiceApplicationProxyGroup


Remove-SPServiceApplicationProxyGroupMember
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes one or more proxies from the specified service application proxy group.

Remove-SPServiceApplicationProxyGroupMember [-Identity] <SPServiceApplicationProxyGroupPipeBind> [-Member] <SPServiceApplicationProxyPipeBind[]> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies the identity of the service application proxy group from which to remove the member or members.

Member

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind[]

Specifies the member or members to remove from the service application proxy group.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPServiceApplicationProxyGroupMember cmdlet removes one or more proxies from the specified service application proxy group.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Remove-SPServiceApplicationProxyGroupMember RemoteProxyGroup -Member babab30e-8e3a-428b-8ff4-4d5c8f455e6d

This example removes a service application proxy from the selected service application proxy group named RemoteProxyGroup.

The service application proxy group GUID is unique to every farm. You can run Get-SPServiceApplicationProxyGroup | Select Name,Id to see the GUID of the service application proxy groups. Use this result for any other SPServiceApplicationProxyGroup cmdlets.

See also

Add-SPServiceApplicationProxyGroupMember


Remove-SPUsageApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Removes a usage application from the local farm.

Remove-SPUsageApplication [-Identity] <SPUsageApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-RemoveData <SwitchParameter>] [-UsageService <SPUsageServicePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUsageApplicationPipeBind

Specifies the usage application to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a usage application (for example, UsageApplication1); or an instance of a valid SPUsageApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

RemoveData

Optional

System.Management.Automation.SwitchParameter

Specifies that the logging database is also removed.

UsageService

Optional

Microsoft.SharePoint.PowerShell.SPUsageServicePipeBind

Reserved for future use.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPUsageApplication cmdlet deletes a usage application from the local farm.

Input Types

Return Types

Example

-------------------EXAMPLE--------------------

Copy code
Remove-SPUsageApplication -Identity "Usage and Health data collection" -RemoveData

This example removes the existing usage application and the associated logging DB.

See also

Get-SPUsageApplication
Set-SPUsageApplication
New-SPUsageApplication


Set-SPServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets properties of a service application.

Set-SPServiceApplication [-Identity] <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultEndpoint <SPServiceEndpointPipeBind>] [-IisWebServiceApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-ServiceApplicationProxyGroup <SPServiceApplicationProxyGroupPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the service application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubSettingsApp1); or an instance of a valid SPServiceApplication object.

DefaultEndpoint

Optional

Microsoft.SharePoint.PowerShell.SPServiceEndpointPipeBind

Specifies the address of the default endpoint of the service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

IisWebServiceApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the name or identity of the application pool used by the service application.

The IisWebServiceApplicationPool parameter only applies to Web Service applications.

ServiceApplicationProxyGroup

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies a custom service application proxy group for the Web application to use. The Web application will use the proxies in this proxy group to connect to service applications. If the ServiceApplicationProxyGroup parameter is not specified, the farm's default proxy group is used.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPServiceApplication cmdlet to set various properties of a service application such as the default endpoint, and the application pool used by the service application.

Input Types

Return Types

Example

---------------------EXAMPLE----------------

Copy code
$serviceapp = Get-SPServiceApplication "My Service App"
Copy code
Set-SPServiceApplication $serviceapp -DefaultEndpoint https

This example sets the default endpoint of the service application to be https.

See also

Get-SPServiceApplication
Publish-SPServiceApplication
Remove-SPServiceApplication


Set-SPServiceApplicationEndpoint
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the host of an endpoint for a service application.

Set-SPServiceApplicationEndpoint [-Identity] <SPServiceEndpointPipeBind> -HostName <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Set-SPServiceApplicationEndpoint [-Identity] <SPServiceEndpointPipeBind> -ResetHostName <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceEndpointPipeBind

Specifies the service endpoint to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URI of an endpoint address, in the form http://sitename:8003/servicemodelsamples/service; or an instance of a valid SPServiceEndpoint object.

HostName

Required

System.String

Specifies the default host of the service endpoint.

The type must be a valid full load balanced URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceEndpointPipeBind

Specifies the service endpoint to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid URI of an endpoint address, in the form http://sitename:8003/servicemodelsamples/service; or an instance of a valid SPServiceEndpoint object.

ResetHostName

Required

System.Management.Automation.SwitchParameter

Removes the current host of the service endpoint and uses the default host.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set- SPServiceApplicationEndpoint cmdlet sets the host of a service endpoint. Use the second parameter set to reset the host of the service endpoint to use the default endpoint.

Input Types

Return Types

Example

--------------------EXAMPLE-------------------

Copy code
Set-SPServiceApplicationEndpoint -Identity "ServiceApp1" -HostName http://sitename -ResetHostName $true

This example associates the SPServiceEndpoint object with the specified identity and resets the hostname.

See also

Get-SPServiceApplicationEndpoint


Set-SPServiceApplicationPool
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Changes the account used for the Identity of the specified application pool.

Set-SPServiceApplicationPool [-Identity] <SPIisWebServiceApplicationPoolPipeBind> [[-Account] <SPProcessAccountPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the identity of the Web service application pool to configure.

Account

Optional

Microsoft.SharePoint.PowerShell.SPProcessAccountPipeBind

Specifies the credentials that will be the new Identity of the application pool.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPServiceApplicationPool cmdlet changes the account used for the Identity of the specified application pool.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Set-SPServiceApplicationPool  TestServiceWebApplicationPool -Account testdomain\testuser1

This example changes the identity of the selected service application pool.

For the Account parameter, the name of a managed account in the farm can be given. Use the Get-SPManagedAccount cmdlet to view the existing managed account in the farm. Also, a process account from the output of the Get-SPProcessAccount cmdlet can be used.

See also

Get-SPServiceApplicationPool
New-SPServiceApplicationPool
Remove-SPServiceApplicationPool


Set-SPServiceHostConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Configures one or more common settings for all Web services.

Set-SPServiceHostConfig [-Identity] <SPIisWebServiceSettings> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-HttpPort <Int32>] [-HttpsPort <Int32>] [-ImportSslCertificate <X509Certificate2>] [-NetTcpPort <Int32>] [-NoWait <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Set-SPServiceHostConfig [-Identity] <SPIisWebServiceSettings> -SslCertificateThumbprint <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-HttpPort <Int32>] [-HttpsPort <Int32>] [-NetTcpPort <Int32>] [-NoWait <SwitchParameter>] [-SslCertificateStoreName <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.Administration.SPIisWebServiceSettings

Specifies the identity of the Web service application to configure.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

HttpPort

Optional

System.Int32

Specifies the new port for the Web service.

HttpsPort

Optional

System.Int32

Specifies the new secure port for the Web service.

ImportSslCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the SSL Certificate to use for secure protocols.

NetTcpPort

Optional

System.Int32

Sets the TCP port for the Web service.

NoWait

Optional

System.Management.Automation.SwitchParameter

For more information, see TechNet.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.Administration.SPIisWebServiceSettings

Specifies the identity of the Web service application to configure.

SslCertificateThumbprint

Required

System.String

Specifies the thumbprint of the SSL certificate to retrieve for secure protocols.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

HttpPort

Optional

System.Int32

Specifies the new port for the Web service.

HttpsPort

Optional

System.Int32

Specifies the new secure port for the Web service.

NetTcpPort

Optional

System.Int32

Sets the TCP port for the Web service.

NoWait

Optional

System.Management.Automation.SwitchParameter

For more information, see TechNet.

SslCertificateStoreName

Optional

System.String

Specifies the thumbprint of the SSL certificate to retrieve for secure protocols.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set- SPServiceHostConfig cmdlet configures one or more common settings for all Web services.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Set-SPServiceHostConfig -Port 12345

This example sets the HTTP port for the Web services.

See also

Get-SPServiceHostConfig


Set-SPTopologyServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the properties on the topology service application of the local farm.

Set-SPTopologyServiceApplication [-Identity] <SPTopologyWebServiceApplicationPipeBind> -LoadBalancerUrl <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTopologyWebServiceApplicationPipeBind

Specifies the GUID of the application to be set.

The type must be a valid GUID, in the form 1234-456-854gh.

LoadBalancerUrl

Required

System.String

Specifies an external physical load balancer.

The type must be a valid URL, in the form http://search.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPTopologyServiceApplication cmdlet sets the advanced properties of an application when the Identity parameter is used.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Set-SPTopologyServiceApplication 67877d63-bff4-4521-867a-ef4979ba07ce -LoadBalancedURL "https://testurl"

This example sets the load-balanced URL for the topology service application.

The topology service application GUID is unique to every farm. You can run the Get-SPTopologyServiceApplication cmdlet to retrieve the GUID.

See also

Get-SPTopologyServiceApplication
Set-SPTopologyServiceApplicationProxy


Set-SPTopologyServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the proxy properties of the topology service application.

Set-SPTopologyServiceApplicationProxy [-Identity] <SPTopologyWebServiceProxyPipeBind> -BadListPeriod <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTopologyWebServiceProxyPipeBind

Specifies the GUID of the application proxy.

The type must be a valid GUID, in the form 1234-4567-098jhj.

BadListPeriod

Required

System.String

Specifies the time period that a node is kept in a bad list.

The type must be a valid value between 1 and 480 (in minutes).

The default value is 10.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPTopologyServiceApplicationProxy cmdlet sets the properties of the local topology service application proxy and the default load balancer.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Set-SPTopologyServiceApplicationProxy 67877d63-bff4-4521-867a-ef4979ba07ce -BadListPeriod 1234

This example sets the bad list period for the given topology service application proxy.

The topology service application GUID is unique to every farm. You can run the Get-SPTopologyServiceApplication cmdlet to retrieve the GUID.

See also

Get-SPTopologyServiceApplicationProxy
Get-SPTopologyServiceApplication


Set-SPUsageApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Sets properties of a usage application.

Set-SPUsageApplication [-Identity] <SPUsageApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseName <String>] [-DatabasePassword <SecureString>] [-DatabaseServer <String>] [-DatabaseUsername <String>] [-EnableLogging <SwitchParameter>] [-FailoverDatabaseServer <String>] [-UsageService <SPUsageServicePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUsageApplicationPipeBind

Specifies the usage application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, a valid name of a usage application (for example; UsageApp1); or an instance of a valid SPServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseName

Optional

System.String

Specifies the name of the logging database.

The type must be a valid name of a SQL Server database; for example, UsageLogDB1.

If the logging database does not exist, a logging database will be automatically created.

DatabasePassword

Optional

System.Security.SecureString

Specifies the password for the user specified in DatabaseUserName. Use this parameter only if SQL Server Authentication is used to access the logging database.

The type must be a valid password.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the database specified in DatabaseName.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

DatabaseUsername

Optional

System.String

Specifies the user name to use for connecting to the logging database. Use this parameter only if SQL Server Authentication is used to access the logging database.

The type must be a valid user name; for example, UserName1.

EnableLogging

Optional

System.Management.Automation.SwitchParameter

Specifies that this usage application collects usage data.

FailoverDatabaseServer

Optional

System.String

UsageService

Optional

Microsoft.SharePoint.PowerShell.SPUsageServicePipeBind

Specifies the SPUsageService object that is the parent of the usage application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a usage service (for example, UsageService1); or an instance of a valid SPUsageService object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPUsageApplication cmdlet sets properties of a usage application.

Input Types

Return Types

Example

-------------------EXAMPLE----------------------

Copy code
Set-SPUsageApplication -Identity "Usage and Health data collection" -DatabaseServer "Server Name" -DatabaseName "New Logging DB"

This example changes the database server and database name used by the usage logging service to store logging data.

See also

Get-SPUsageApplication
New-SPUsageApplication
Remove-SPUsageApplication


Set-SPUsageDefinition
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the retention period for a usage provider.

Set-SPUsageDefinition [-Identity] <SPUsageDefinitionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DaysRetained <Int32>] [-DaysToKeepUsageFiles <Int32>] [-Enable <SwitchParameter>] [-MaxTotalSizeInBytes <Int64>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUsageDefinitionPipeBind

Specifies the usage definition object to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a usage definition (for example, SiteSubscriptionConfig1); or an instance of a valid SPUsageDefinition object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DaysRetained

Optional

System.Int32

Specifies the number of days that usage data for the usage provider is retained in the usage service database. The default value is 14.

The type must be an integer between 0 and 31.

DaysToKeepUsageFiles

Optional

System.Int32

Specifies the number of days to keep usage file retention. The value must be less than or equal to value of the DaysRetained parameter.

Enable

Optional

System.Management.Automation.SwitchParameter

Turns on the specified usage provider.

MaxTotalSizeInBytes

Optional

System.Int64

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPUsageDefinition cmdlet sets the retention period for a specified usage provider. A usage definition object defines a specific type of usage provider.

Input Types

Return Types

Example

-----------------EXAMPLE--------------------

Copy code
Set-SPUsageDefinition -Identity "Page Requests" -DaysRetained 31

This example sets the number of days that stores page requests usage data to 31.

See also

Get-SPUsageDefinition


Set-SPUsageService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Updates the properties of a usage service.

Set-SPUsageService [[-Identity] <SPUsageServicePipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-LoggingEnabled <Nullable>] [-UsageLogCutTime <UInt32>] [-UsageLogLocation <String>] [-UsageLogMaxFileSizeKB <UInt32>] [-UsageLogMaxSpaceGB <UInt32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPUsageServicePipeBind

Specifies the usage service to update.

The type must be in one of the following forms:

--A valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh

--A valid name of a usage service (for example, UsageService1)

--An instance of a valid SPUsageService object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

LoggingEnabled

Optional

System.Nullable

Specifies that usage data is logged to usage files.

UsageLogCutTime

Optional

System.UInt32

Specifies the time, in minutes, of usage data that is collected per usage log file. The default time is 5 minutes.

The value must be an integer in the range of 1 to 1440.

UsageLogLocation

Optional

System.String

Specifies the path on every computer in the farm where usage log files are created.

The value must be a valid local path in the following form:

- C:\folder_name

UsageLogMaxFileSizeKB

Optional

System.UInt32

Specifies the maximum size of a single usage file that is applied to all the usage providers.

The minimum value is 512 kilobytes (KB) and the maximum value is 65536 KB.

UsageLogMaxSpaceGB

Optional

System.UInt32

The parameter is not used in SharePoint Server 2013.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPUsageService cmdlet updates the properties of a usage service. If the Identity parameter is not specified, the cmdlet applies the changes to the local usage service.

Input Types

Return Types

Example

--------------------EXAMPLE-----------------

Copy code
Set-SPUsageService -LoggingEnabled $false
Copy code
Set-SPUsageService -UsageLogLocation "D:\\testusagelogdir"
Copy code
Set-SPUsageService -UsageLogCutTime 5

The examples disables usage logging, changes the directory where usage files are stored, and creates a new usage log file every 5 minutes.

See also

Get-SPUsageService


Start-SPServiceInstance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Starts the service instance for a service on a specific server or the farm.

Start-SPServiceInstance [-Identity] <SPServiceInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceInstancePipeBind

Specifies the GUID of the service instance to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Start-SPServiceInstance cmdlet to start the service instance for a service on a specific server or on the farm.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE-----------------------

Copy code
Start-SPServiceInstance 67877d63-bff4-4521-867a-ef4979ba07ce

This example starts the given service instance on the server.

The service instance GUID is unique to every farm. You can run the Get-SPServiceInstance cmdlet to see the GUID of the service instances, and then use the result from the SPServiceInstance cmdlet for other cmdlets.

See also

Get-SPServiceInstance


Stop-SPServiceInstance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Stops the service instance for a service.

Stop-SPServiceInstance [-Identity] <SPServiceInstancePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceInstancePipeBind

Specifies the GUID of the service instance to get.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Stops the service instance for a service on the specified server or for the farm.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE-----------------------

Copy code
Stop-SPServiceInstance 67877d63-bff4-4521-867a-ef4979ba07ce

This example stops the service instance in the given server.

The service instance GUID is unique to every farm. You can run the Get-SPServiceInstance cmdlet to see the GUID of the service instances, and then use the result from the SPServiceInstance cmdlet for other cmdlets.

See also

Get-SPServiceInstance
Start-SPServiceInstance


Unpublish-SPServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Stops sharing the specified service application outside the farm.

Unpublish-SPServiceApplication [-Identity] <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the GUID of the service application to stop sharing outside the farm.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Unpublish-SPServiceApplication cmdlet to stop publishing the service application, specified by the Identity parameter, outside the farm.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
UnPublish-SPServiceApplication 053c34be-d251-488c-8e94-644eae94da26

This example stops publishing of the specified service application outside the farm.

The service application GUID is unique to every farm. You can run the Get-SPServiceApplication cmdlet to see the GUID of the service applications, and then use the result from the Get-SPServiceApplication cmdlet for other SPServiceApplication cmdlets; for example, Publish-SPServiceApplication.

See also

Get-SPServiceApplication
Set-SPServiceApplication
Publish-SPServiceApplication


Site collection cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets for site collection administration in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use Windows PowerShell cmdlets for site collection administration for SharePoint 2013.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPWebPartPack | Returns the Web Part packages that were installed for the specified scope.
Install-SPWebPartPack | Installs the specified Web Part package to the specified location.
Uninstall-SPWebPartPack | Uninstalls the specified Web Part package.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Get-SPWebPartPack
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the Web Part packages that were installed for the specified scope.

Get-SPWebPartPack [[-Identity] <String>] [-AssignmentCollection <SPAssignmentCollection>] [-GlobalOnly <SwitchParameter>] [-WebApplication <SPWebApplicationPipeBind>]

Parameters

Parameter Required Type Description

Identity

Optional

System.String

Specifies the full or partial name of the Web Part package from the configuration database.

The type must be a valid name of a Web Part package; for example, MyWebPartPackage.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

GlobalOnly

Optional

System.Management.Automation.SwitchParameter

Returns only Web Part packages that are installed in the global assembly cache (GAC).

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the Web application from which to list Web Part packages. If no Web application is specified, the specified Web Part packages will be returned from all Web applications.

Detailed Description

The Get-SPWebPartPack cmdlet returns the installed Web Part packages that match the Identity parameter. The scope of results can be narrowed by using the optional WebApplication parameter. The scope does not include any Web Part packages installed in the global assembly cache (GAC) unless the GlobalOnly parameter is used. If this parameter is used, only Web Part packages that have been installed in the GAC are returned.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPWebPartPack -WebApplication http://zsharepoint2:80

This example returns all Web Part packages that have been installed on the Web application on port 80 in local farm.

See also

Install-SPWebPartPack
Uninstall-SPWebPartPack


Install-SPWebPartPack
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Installs the specified Web Part package to the specified location.

Install-SPWebPartPack [-LiteralPath] <String> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <String>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-GlobalInstall <SwitchParameter>] [-Language <UInt32>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Install-SPWebPartPack [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <String>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-GlobalInstall <SwitchParameter>] [-Language <UInt32>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

LiteralPath

Required

System.String

Specifies the exact path to the Web Part package.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Overwrites any existing Web Part package with the same name or installed in the same location.

GlobalInstall

Optional

System.Management.Automation.SwitchParameter

Installs the Web Part package in the global assembly cache (GAC) rather than in the /bin directory of each Web application. This installation makes the Web Part globally accessible on the servers.

Language

Optional

System.UInt32

Specifies the language ID for the Web Part package.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the Web application on which to install the Web Part pack. If no Web application is specified, the Web Part pack is installed on all Web applications.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Name

Required

System.String

Specifies the name of the Web Part package to install.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Overwrites any existing Web Part package with the same name or installed in the same location.

GlobalInstall

Optional

System.Management.Automation.SwitchParameter

Installs the Web Part package in the global assembly cache (GAC) rather than in the /bin directory of each Web application. This installation makes the Web Part globally accessible on the servers.

Language

Optional

System.UInt32

Specifies the language ID for the Web Part package.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the Web application on which to install the Web Part pack. If no Web application is specified, the Web Part pack is installed on all Web applications.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Install-SPWebPartPack cmdlet installs the Web Part package, at the LiteralPath parameter location, in the local farm. The Web Part package can be installed in a specific Web application by using the WebApplication parameter. If a Web application is not specified, the Web Part package is installed in all Web applications.

Use the Language parameter to specify a package language.

Use the GlobalInstall parameter to install the package to the global assembly cache (GAC). Assemblies in the GAC are granted FullTrust permission, which gives this package full access to all system-wide resources.

Use the Force parameter to install the package to overwrite any existing Web Part package with the same name or installed in the same location.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Install-SPWebPartPack "MyCustomWebPartPack" -LiteralPath "c:/mywebpart.wpp" -GlobalInstall

This example installs the Web Part Package with the name MyCustomWebPartPack globally in the farm from the path c:/mywebpart.wpp.

See also

Uninstall-SPWebPartPack
Get-SPWebPartPack


Uninstall-SPWebPartPack
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Uninstalls the specified Web Part package.

Uninstall-SPWebPartPack [-Identity] <String> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <String>] [-Confirm [<SwitchParameter>]] [-Language <UInt32>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

System.String

Specifies the Web Part package in the farm's configuration database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Language

Optional

System.Int32

Specifies the language ID of the Web Part package to delete. If no language is specified, the Web Part package is uninstalled for all languages.

The type must be a valid language identifier, in the form 1033.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the Web application from which to uninstall the Web Part package. If no Web application is specified, the Web Part package is uninstalled from all Web applications.

The type must be a valid name, in the form WebApplication-1212, or a URL, in the form http://server_name/WebApplication-1212.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Uninstall-SPWebPartPack cmdlet uninstalls the Web Part package specified by the Identity parameter.

Input Types

Return Types

None

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------------EXAMPLE1------------------

Copy code
Uninstall-SPWebPartPack  "mypart.wpp" -WebApplication http://portal

This example uninstalls mypart.wpp to from the Web application http://portal.

------------------EXAMPLE2------------------

Copy code
Get-SPWebPartPack -WebApplication http://portal | Uninstall-SPWebPartPack

This example uninstalls all Web part packages from the Web application http://portal.

See also

Get-SPWebPartPack
Install-SPWebPartPack


Use Windows PowerShell cmdlets to manage sites in SharePoint 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to manage sites in a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

The following table shows the Windows PowerShell cmdlets that you can use to manage sites in a SharePoint farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPCustomLayoutsPage | Returns a mapping to a custom layout page.
Get-SPUser | Returns the user account or accounts that match a given search criteria.
Get-SPWeb | Returns all subsites that match the given criteria.
Get-SPWebApplication | Returns all Web applications that match the given criteria.
Get-SPFarm | Returns the local SharePoint farm.
Get-SPProduct | Returns a list of the SharePoint-related products installed in the farm and the versions of all updates installed for each product.
Get-SPServer | Returns the server or servers in the farm that match the given identity.
Get-SPDeletedSite | Gets a list of deleted site collections. This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1).
Get-SPSite | Returns all site collections that match the given criteria.
Get-SPSiteAdministration | Returns a site administration object that farm administrators can use to view certain information about site collections to which they might not have access.
Get-SPSiteSubscription | Returns the site subscription for the given URL or all site subscriptions in the local farm.
Get-SPSiteSubscriptionConfig | Returns the configuration properties of a site subscription.
Move-SPSite | Moves site collections from one content database to another.
Move-SPUser | Migrates a user account in SharePoint 2010 Products.
New-SPSite | Creates a new site collection at the specified URL.
New-SPSiteSubscription | Creates a new site subscription.
New-SPUser | Adds an existing user to a SharePoint site with the designated permissions.
New-SPWeb | Creates a new site in an existing site collection.
New-SPWebApplication | Creates a new Web application within the local farm.
New-SPWebApplicationExtension | Creates a new zone instance for the Web application.
Remove-SPDeletedSite | Removes a deleted site collection. This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1).
Remove-SPSite | Completely deletes an existing site collection and all subsites.
Remove-SPSiteSubscription | Removes data stored in a subscription settings service application for a set of site subscriptions.
Remove-SPSiteSubscriptionSettings | Removes the settings service data for a specified site subscription, or finds and removes orphaned data.
Remove-SPUser | Removes a user from a Web site.
Remove-SPWeb | Completely deletes the specified Web.
Remove-SPWebApplication | Deletes the specified Web application.
Rename-SPServer | Renames a server that is currently connected to the farm.
Restore-SPDeletedSite | Restores a deleted site collection. This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1).
Set-SPSite | Configures the specified site collection.
Set-SPSiteAdministration | Allows farm administrators to configure any site collection.
Set-SPSiteSubscriptionConfig | Sets the configuration properties of a site subscription.
Set-SPSubscriptionSettingsServiceApplication | Sets properties of a subscription settings service application.
Set-SPUser | Configures properties on an existing user.
Set-SPWebApplication | Configures the specified Web application.
Set-SPWeb | Configures the specified subsite.
Export-SPSiteSubscriptionSettings | Creates a backup file of site subscription data.
Import-SPSiteSubscriptionSettings | Restores a backup of subscription site settings to the given subscription identifier.
Get-SPDeletedSite | Gets a list of deleted site collections.
Remove-SPDeletedSite | Removes a deleted site collection.
Restore-SPDeletedSite | Restores a deleted site collection.
Get-SPSiteUrl | Displays all URL mappings for the site.
Remove-SPSiteUrl | Removes an URL mapping from the site.
Set-SPSiteUrl | Adds or changes an URL mapping for the site.
Get-SPSiteSubscriptionIRMConfig | Gets the Information Rights Management (IRM) settings.
Move-SPDeletedSite | Moves deleted site collections from one content database to another.
Set-SPIRMSettings | Sets the Information Rights Management (IRM) settings.
Set-SPSiteSubscriptionIRMConfig | Sets the Information Rights Management (IRM) settings.
Get-SPIRMSettings | Returns the Information Rights Management (IRM) settings.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Get-SPCustomLayoutsPage
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a mapping to a custom layout page.

Get-SPCustomLayoutsPage -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Identity <None | AccessDenied | Confirmation | Error | Login | RequestAccess | Signout | WebDeleted>]

Parameters

Parameter Required Type Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the SharePoint Web application that contains the custom layout page.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Identity

Optional

Microsoft.SharePoint.Administration.SPWebApplication+SPCustomPage

Specifies the custom layout page to get.

The type must be one of the following: None, AccessDenied, Confirmation, Error, Login, RequestAccess, Signout, or WebDeleted.

Detailed Description

The Get-SPCustomLayoutsPagecmdlet cmdlet returns a mapping to a custom layout page in a Web application. If the Identity parameter is not specified, this cmdlet returns the collection of mappings for all custom layout pages.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Get-SPCustomLayoutsPage -Identity "_layouts/accessdenied.aspx" -WebApplication "http://server_name/mywebapp"

This example returns the mapping of the AccessDenied layout page in the Web application.


Get-SPUser
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the user account or accounts that match a given search criteria.

Get-SPUser [[-Identity] <SPUserPipeBind>] -Web <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Group <SPGroupPipeBind>] [-Limit <String>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPUserPipeBind

Specifies the GUID or login name of the user to be returned.

The type must be a valid URL, in the form http://server_name, or GUID, in the form1234-5678-9807.

Web

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the Web site to be used as a scope.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint Foundation 2013 Web site (for example, MySPSite1); or an instance of a valid SPWeb object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Group

Optional

Microsoft.SharePoint.PowerShell.SPGroupPipeBind

Specifies the user group to which the new user belongs.

Limit

Optional

System.String

Specifies the maximum number of users to return. The default value is 500.

Detailed Description

The Get-SPUser cmdlet returns all SharePoint user accounts that match the scope given by the Identity, Web, or Group parameters.

The Identity parameter can use the alias of a user for returning exact matches. However, a scope must be provided if the Get-SPUser cmdlet is to work.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Get-SPUser -Web "http://zsharepoint2" -Group "Viewers"

This example returns all members of the group Viewers on the Web site http://zsharepoint2.

See also

Move-SPUser
New-SPUser
Set-SPUser
Remove-SPUser


Get-SPWeb
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all subsites that match the given criteria.

Get-SPWeb [[-Identity] <SPWebPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-Regex <SwitchParameter>] [-Site <SPSitePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the name or full or partial URL of the subsite. If you use a relative path, you must specify the Site parameter.

A valid URL in the form http://server_name or a relative path in the form of /SubSites/MySubSite.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filter

Optional

System.Management.Automation.ScriptBlock

Specifies the server-side filter to use for the specified scope.

The type must be a valid filter in the form {filterName <operator> "filterValue"}.

Limit

Optional

System.String

Limits the maximum number of subsites to return. The default value is 200. To return all sites, enter ALL

The type must be a valid number greater than 0 or ALL.

Regex

Optional

System.Management.Automation.SwitchParameter

Specifies the URL that is provided by the Identity parameter is treated as a regular expression.

Site

Optional

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site collection from which to list subsites.

The type must be a valid URL, in the form of http://server_name; a GUID, in the form 1234-5678-9807, or an SPSite object.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Get-SPWeb cmdlet returns all subsites that match the scope given by the Identity parameter. All subsites that meet the criteria are returned.

The Identity can be either the full URL or a relative path. If you specify a relative path, you must also specify the Site parameter to identify the site collection from which to return the subsite.

The Identity parameter also supports providing a partial URL that ends in a wildcard character (*). All subsites that match this partial URL for the specified scope are returned. Additionally, if the Regex parameter is provided, the Identity parameter is treated as a regular expression and any subweb with a URL provided in the given scope that matches the expression is returned.

The Filter parameter is a server-side filter for certain subsite properties that are stored in the content database; without the Filter parameter, filtering on these properties is a slow process. These subsite properties are Template and Title. The Filter parameter is a script block that uses the same syntax as a Where-Object statement, but is run server-side for faster results.

It is important to note that every site collection returned by the Get-SPWeb cmdlet is automatically disposed of at the end of the pipeline. To store the results of Get-SPWeb in a local variable, the Start-SPAssignment and Stop-SPAssignment cmdlets must be used to avoid memory leaks.

Input Types

Return Types

Example

--------------------EXAMPLE 1----------------------

Copy code
Get-SPWeb -site http://sitename/sites/site1

This example returns all the subwebs in a given site collection.

--------------------EXAMPLE 2----------------------

Copy code
Get-SPWeb -Site http://sitename/sites/site1  -filter {$_.Template -eq "STS#0"}

This example displays all subsites that use the "STS#0" template.

--------------------EXAMPLE 3----------------------

Copy code
Start-SPAssignment -Global
Copy code
$w = Get-SPWeb http://sitename
Copy code
$w.set_SiteLogoUrl("http://PathToImage/test.jpg")
Copy code
$w.Update()
Copy code
Stop-SPAssignment -Global

This example demonstrates how to save a subsite as a variable and to call object model methods on the SPAssignment object.

See also

New-SPWeb
Set-SPWeb
Remove-SPWeb
Import-SPWeb


Get-SPWebApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all Web applications that match the given criteria.

Get-SPWebApplication [[-Identity] <SPWebApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-IncludeCentralAdministration <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the name, URL, or GUID of the Web application.

The type must be a valid URL, in the form http://server_name; a GUID, in the form 1234-5678-9876-0987; or a valid name, in the form SPWebApplication - 1212.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

IncludeCentralAdministration

Optional

System.Management.Automation.SwitchParameter

Includes the Central Administration Web application in the collection of Web applications that can be returned. The IncludeCentral Administration parameter must still meet any other filters provided.

Detailed Description

The Get-SPWebApplication cmdlet returns all Web applications that match the scope given by the Identity parameter. The Identity can be the name of the name, URL, or GUID of the Web application. If no Identity is specified, all Web applications are returned.

The Central Administration Web application is only returned if its exact identity is provided or the IncludeCentralAdministration flag is provided.

Input Types

Return Types

Example

------------------EXAMPLE 1----------------------

Copy code
$w = Get-SPWebApplication http://sitename

This example gets the Web application for http://sitename and stores it in a variable.

------------------EXAMPLE 2-----------------------

Copy code
Get-SPWebApplication -IncludeCentralAdministration | Where { $_.DefaultServerComment -eq "SharePoint Central Administration v4"} | Format-List *

This example displays all public properties on the SharePoint Central Administration Web application in list format.

See also

Get-SPWebApplicationHttpThrottlingMonitor


Get-SPFarm
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the local SharePoint farm.

Get-SPFarm [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPFarm cmdlet returns the local SharePoint farm. No parameters are used.

Input Types

Return Types

SPFarm

Example

Copy code
$f = Get-SPFarm

This example stores the local farm in a variable.

See also

Get-SPFarmConfig
Set-SPFarmConfig
Backup-SPFarm
Restore-SPFarm


Get-SPProduct
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a list of the SharePoint-related products installed in the farm and the versions of all updates installed for each product.

Get-SPProduct [-AssignmentCollection <SPAssignmentCollection>] [-Local <SwitchParameter>]
Get-SPProduct [-AssignmentCollection <SPAssignmentCollection>] [-Server <SPServerPipeBind>]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Local

Optional

System.Management.Automation.SwitchParameter

Returns product and update information for only the local computer. If you use the Local parameter, you cannot use the Server parameter.

2

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Server

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Returns product and update information for a specified server. If you use the Server parameter, you cannot use the Local parameter.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPProduct cmdlet returns a list of the SharePoint-related products installed in the farm and the versions of all updates installed for each product. By default this cmdlet returns the list of SharePoint-related products installed in the farm. Use the Local parameter to get only information about the local server or for a specific server to get the list, use the Server parameter.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPProduct -Local

This example displays the SharePoint-related products installed on the local server.


Get-SPServer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the server or servers in the farm that match the given identity.

Get-SPServer [[-Identity] <SPServerPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the address of the server to return.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPServer cmdlet returns the SPServer object for the given identity (if it exists in the farm). If no parameters are specified, the cmdlet returns all servers in the farm.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPServer

This example returns all servers in the local farm in a list.

--------------EXAMPLE 2-----------------

Copy code
Get-SPServer | Where{ $_.NeedsUpgrade -eq $TRUE}

This example returns a list of all servers in the farm that need an upgrade.

See also

Rename-SPServer


Get-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all site collections that match the specified criteria.

Get-SPSite [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]
Get-SPSite [-Identity] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-Regex <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Get-SPSite -ContentDatabase <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-WhatIf [<SwitchParameter>]]
Get-SPSite -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompatibilityLevel

Optional

System.Int32

Specifies the version of templates to use when creating a new SPSite object. This value sets the initial CompatibilityLevel value for the site collection. The values for this parameter can be either SharePoint Server 2010 or SharePoint Server 2013. When this parameter is not specified, the CompatibilityLevel will default to the highest possible version for the web application depending on the SiteCreationMode setting.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filter

Optional

System.Management.Automation.ScriptBlock

Specifies the script block of the server-side filter to apply.

The type must be a valid filter name and value in the form {$_PropertyName <operator> "filterValue"}.

Valid operators are: EQ, NE, LIKE, NOTLIKE.

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 200.

The type must be a valid non-negative number. Specify ALL to return all site collections for the given scope.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, or name of the web application from which to list sites.

The type must be a valid URL, in the form, http://server_name, a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh); or the name of the web application (for example, WebApplication1212).

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site collection to get.

The type must be a valid URL, in the form, http://server_name or http://server_name/sites/sitename, or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompatibilityLevel

Optional

System.Int32

Specifies the version of templates to use when creating a new SPSite object. This value sets the initial CompatibilityLevel value for the site collection. The values for this parameter can be either SharePoint Server 2010 or SharePoint Server 2013. When this parameter is not specified, the CompatibilityLevel will default to the highest possible version for the web application depending on the SiteCreationMode setting.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filter

Optional

System.Management.Automation.ScriptBlock

Specifies the script block of the server-side filter to apply.

The type must be a valid filter name and value in the form {$_PropertyName <operator> "filterValue"}.

Valid operators are: EQ, NE, LIKE, NOTLIKE.

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 200.

The type must be a valid non-negative number. Specify ALL to return all site collections for the given scope.

Regex

Optional

System.Management.Automation.SwitchParameter

When used, the URL provided for the Identity parameter is treated as a regular expression.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

ContentDatabase

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the GUID of the content database from which to list site collections.

The type must be a valid database name, in the form, SPContentDB01, or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompatibilityLevel

Optional

System.Int32

Specifies the version of templates to use when creating a new SPSite object. This value sets the initial CompatibilityLevel value for the site collection. The values for this parameter can be either SharePoint Server 2010 or SharePoint Server 2013. When this parameter is not specified, the CompatibilityLevel will default to the highest possible version for the web application depending on the SiteCreationMode setting.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filter

Optional

System.Management.Automation.ScriptBlock

Specifies the script block of the server-side filter to apply.

The type must be a valid filter name and value in the form {$_PropertyName <operator> "filterValue"}.

Valid operators are: EQ, NE, LIKE, NOTLIKE.

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 200.

The type must be a valid non-negative number. Specify ALL to return all site collections for the given scope.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

4

Parameter

Required

Type

Description

SiteSubscription

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription from which to get site collections.

The type must be a valid URL, in the form, http://server_name or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompatibilityLevel

Optional

System.Int32

Specifies the version of templates to use when creating a new SPSite object. This value sets the initial CompatibilityLevel value for the site collection. The values for this parameter can be either SharePoint Server 2010 or SharePoint Server 2013. When this parameter is not specified, the CompatibilityLevel will default to the highest possible version for the web application depending on the SiteCreationMode setting.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filter

Optional

System.Management.Automation.ScriptBlock

Specifies the script block of the server-side filter to apply.

The type must be a valid filter name and value in the form {$_PropertyName <operator> "filterValue"}.

Valid operators are: EQ, NE, LIKE, NOTLIKE.

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 200.

The type must be a valid non-negative number. Specify ALL to return all site collections for the given scope.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPSite cmdlet returns either a single site that matches the Identity parameter, or all the sites that match the Filter parameter for the specified scope. The scopes are the WebApplication, ContentDatabase , and SiteSubscription parameters. If none of these scopes is provided, the scope is the farm. If the scope is specified with no Filter parameter, all sites in that scope are returned.

The Identity parameter supports providing a partial URL that ends in a wildcard character (*). All site collections that match this partial URL for the specified scope are returned. Additionally, if the Regex parameter is provided, the Identity parameter is treated as a regular expression and any site collection with a URL provided in the given scope that matches the expression is returned.

The Filter parameter is a server-side filter for certain site collection properties that are stored in the content database; without the Filter parameter, filtering on these properties is a slow process. These site collection properties are Owner, SecondaryOwner, and LockState. The Filter parameter is a script block that uses the same syntax as a Where-Object statement, but is run on the server for faster results.

Valid values for LockState are: Unlock, NoAdditions, ReadOnly, NoAccess.

It is important to note that every site collection that the Get-SPSite cmdlet returns is automatically destroyed at the end of the pipeline. To store the results of Get-SPSite in a local variable, use the Start-SPAssignment and Stop-SPAssignment cmdlets to avoid memory leaks.

Input Types

None

Return Types

Example

------------------EXAMPLE 1---------------------

Copy code
Get-SPSite 'http://<site name>' | Get-SPWeb -Limit All | Select Title

This example gets the collection of subweb titles in site collection at http://<site name>.

------------------EXAMPLE 2---------------------

Copy code
Get-SPSite -ContentDatabase "b399a366-d899-4cff-8a9b-8c0594ee755f" | Format-Table -Property Url, Owner, SecondaryOwner

This example gets a subset of data from all sites in the content database b399a366-d899-4cff-8a9b-8c0594ee755f.

------------------EXAMPLE 3---------------------

Copy code
Start-SPAssignment -Global
Copy code
$s = Get-SPSite -Identity http://<MyApp>/Sites/Site1
Copy code
$s.Url
Copy code
Stop-SPAssignment -Global

This example gets the sites specified by the Identity parameter and inserts the results in the variable s

The previous example uses the Global method of assignment collection. The Global method is easy to use but the contents of this object grows quickly. Be careful not to run a Get-SPSite command that returns many results while global assignment is enabled.

------------------EXAMPLE 4---------------------

Copy code
$GC = Start-SPAssignment
Copy code
$Sites = $GC | Get-SPSite -Filter {$_.Owner -eq "DOMAIN\JDow"} -Limit 50
Copy code
Stop-SPAssignment $GC

This example gets the first 50 sites owned by user DOMAIN\JDow by using a server-side query, and assigns them to a local variable.

This example uses advanced assignment collection methods.

------------------EXAMPLE 5---------------------

Copy code
Get-SPWebApplication http://<site name> | Get-SPSite -Limit All |ForEach-Object {$sum=0}{ $sum+=$_.Usage.Storage }{$sum}

This example shows a command that returns the sum of the disk space usage for all sites in a given web application.

------------------EXAMPLE 6---------------------

Copy code
Get-SPSite -Identity "http://localserver/(my|personal)/sites" -Regex

This example returns all sites that match the given regular expression.

The Quotes on the Identity parameter are required when the Regex parameter is used.

------------------EXAMPLE 7---------------------

Copy code
Get-SPSite http://<site name>/sites/teams/* -Limit 100

This example gets up to 100 of the sites under the URL http://sitename/sites/teams.

------------------EXAMPLE 8---------------------

Copy code
Get-SPSite | select url, @{Expression={$_.Usage.Storage}}

This example gets the amount of storage used by a site collection, by using the storage field of the .UsageInfo property.

------------------EXAMPLE 9---------------------

Copy code
Get-SPSite -Limit all -CompatibilityLevel 14

This example returns all SharePoint Server 2010 mode site collections.

See also

Backup-SPSite
Move-SPSite
New-SPSite
Remove-SPSite
Restore-SPSite
Set-SPSite


Get-SPSiteAdministration
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a site administration object that allows farm administrators to view certain information about site collections to which they might not have access.

Get-SPSiteAdministration [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]
Get-SPSiteAdministration [-Identity] <SPSiteAdministrationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-Regex <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Get-SPSiteAdministration -ContentDatabase <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-WhatIf [<SwitchParameter>]]
Get-SPSiteAdministration -SiteSubscription <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Filter <ScriptBlock>] [-Limit <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filter

Optional

System.Management.Automation.ScriptBlock

Specifies the script block of the server-side filter to apply.

The type must be a valid filter name and a value in the form { $_ PropertyName <operator > "filterValue"}}

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 200.

The type must be a valid non-negative number. Provide ALL to return all site collections for the given scope.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, or name of the Web application from which to list sites.

The type must be a valid URL, in the form http://server_name; a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh); or the Web application name (for example, WebApplication1212).

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteAdministrationPipeBind

Specifies the URL (full or partial) or GUID of the site collection to retrieve.

The type must be a valid URL, in the form http://server_name, or a GUID, in the form 1234-456-987fg.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filter

Optional

System.Management.Automation.ScriptBlock

Specifies the script block of the server-side filter to apply.

The type must be a valid filter name and a value in the form { $_ PropertyName <operator > "filterValue"}}

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 200.

The type must be a valid non-negative number. Provide ALL to return all site collections for the given scope.

Regex

Optional

System.Management.Automation.SwitchParameter

Enabling this switch causes the URL provided for the Identity parameter to be treated as a regular expression.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

ContentDatabase

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the URL (full or partial) or GUID of the site collection to retrieve.

The type must be a valid URL, in the form http://server_name, or a GUID, in the form, 1234-456-987fg.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filter

Optional

System.Management.Automation.ScriptBlock

Specifies the script block of the server-side filter to apply.

The type must be a valid filter name and a value in the form { $_ PropertyName <operator > "filterValue"}}

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 200.

The type must be a valid non-negative number. Provide ALL to return all site collections for the given scope.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

4

Parameter

Required

Type

Description

SiteSubscription

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site group from which to get site collections.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; an SPSite (object or URL) of a site collection that is a member of the site subscription; or an instance of a valid SiteSubscription object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Filter

Optional

System.Management.Automation.ScriptBlock

Specifies the script block of the server-side filter to apply.

The type must be a valid filter name and a value in the form { $_ PropertyName <operator > "filterValue"}}

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 200.

The type must be a valid non-negative number. Provide ALL to return all site collections for the given scope.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPSiteAdminitration cmdlet returns a site administration object that allows farm administrators to view certain information about site collections to which they might not have access.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Get-SPSiteAdministration | Select -Property Url, OwnerLoginName, @{Name="Storage";Expression={$_.Quota.StorageMaximumLevel}}

This example gets a subset of data from all of the sites in the content database with the URL b399a366-d899-4cff-8a9b-8c0594ee755f (farm administrator does not require access). This command uses the calculated property Storage to display the maximum storage value for the content database.

------------------EXAMPLE 2------------------

Copy code
Start-SPAssignment -Global$s = Get-SPSiteAdministration -Identity http://MyApp/Sites/Site1$s.UrlStop-SPAssignment -Global

This example gets the site collections specified by the Identity parameter and inserts the results into the variable s. This example uses the Global method of garbage collection. This method is easier to use but grows quickly. Do not run a Get-SPSite command that returns many results while global assignment is on.

------------------EXAMPLE 3------------------

Copy code
$GC = Start-SPAssignment$Sites = $GC | Get-SPSiteAdministration -Filter {$_.Owner -eq "DOMAIN\JDoe"} -Limit 50Stop-SPAssignment $GC

This example gets the first 50 sites owned by user DOMAIN\JDoe by using a server-side query, and assigns the returned sites to a local variable. This command uses advanced assignment collection methods.

------------------EXAMPLE 4------------------

Copy code
Get-SPWebApplication http://sitename | Get-SPSiteAdministration -Limit All |ForEach-Object {$sum=0}{ $sum+=$_.DiskUsed }{$sum}

This command returns the sum of the disk space usage for all sites in the specified Web application.

------------------EXAMPLE 5------------------

Copy code
Get-SPWebApplication http://sitename | Get-SPSiteAdministration -Limit ALL | Select URL

This example gets the URLs for all site collections in a Web application.

------------------EXAMPLE 6------------------

Copy code
Get-SPSiteAdministration -identity "http://localserver/(my|personal)/sites" -Regex

This example returns all sites that match the given regular expression. The quotation marks around the value specified for the Identity parameter are required when using the Regex flag.

------------------EXAMPLE 7------------------

Copy code
Get-SPSite "http://sitename/sites/teams/*" -Limit 100

This example gets up to 100 of the sites under the URL http://sitename/sites/teams.

See also

Set-SPSiteAdministration


Get-SPSiteSubscription
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the site subscription for the given URL or all site subscriptions in the local farm.

Get-SPSiteSubscription [[-Identity] <SPSiteSubscriptionPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the ID of the subscription.

The type must be a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Default

Optional

System.Management.Automation.SwitchParameter

Specifies the default site subscription. Any site created without specifying a site subscription ID will be part of the default.

Detailed Description

The Get-SPSiteSubscription cmdlet returns the site subscription for the given URL when the Identity parameter is used. If no parameter is specified, all unique site subscriptions in the farm are listed.

Input Types

Return Types

Example

------------------EXAMPLE----------------------

Copy code
$SiteSub = Get-SPSiteSubscription http://Contoso.com
Copy code
$SiteSub = Get-SPSite http://contoso.com | Get-SPSiteSubscription

This example retrieves the site subscription for http://Contoso.com.

See also

New-SPSiteSubscription
Remove-SPSiteSubscription


Get-SPSiteSubscriptionConfig
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the configuration properties of a site subscription.

Get-SPSiteSubscriptionConfig [-Identity] <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription configuration to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; an SPSite (object or URL) of a site collection that is a member of the site subscription; or an instance of a valid SiteSubscription object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPSiteSubscriptionConfig cmdlet returns the configuration properties of a site subscription.

Input Types

Return Types

Example

---------------EXAMPLE---------------

Copy code
Get-SPSiteSubscriptionConfig http://contoso.com | Select FeatureSet

This example gets the feature set ID for the site subscription that contains the Web site http://contoso.com.


Move-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Moves site collections from one content database to another.

Move-SPSite [-Identity] <SPSitePipeBind> -DestinationDatabase <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-CopyEvents <$true | $false>] [-RbsProviderMapping <Hashtable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the identity of the site collection to be moved. For example, http://servername/sites/sitename.

DestinationDatabase

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the content database that the site collection should be moved to. For example, ContentDB2.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

RbsProviderMapping

Optional

System.Collections.Hashtable

Note:

This parameter was added in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Used to move an RBS-enabled site collection from one RBS-enabled content database to another RBS-enabled content database without moving the underlying BLOB content. If the content database has more than one RBS provider associated with it, you must specify all providers. The same providers must be enabled on the target content database and the source content database.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Move-SPSite cmdlet moves the data in the specified site collection from its current content database to the content database specified by the DestinationDatabase parameter. A no-access lock is applied to the site collection to prevent users from altering data within the site collection while the move is taking place. Once the move is complete, the site collection is returned to its original lock state. The destination content database specified must already exist, must be attached to the same SQL Server as the site collection's current content database, and must be attached to the site collection's current Web application.

After you run the Move-SPSite cmdlet, run the IISReset command to update changes to IIS.

Input Types

Return Types

Example

---------------------EXAMPLE 1-----------------------

Copy code
Move-SPSite http://servername/sites/sitename -DestinationDatabase ContentDb2

This example moves the site collection http://servername/sites/sitename to the content database ContentDb2.

---------------------EXAMPLE 2-----------------------

Copy code
Get-SPSite -ContentDatabase ContentDb1 | Move-SPSite -DestinationDatabase ContentDb2

This example moves all site collections in ContentDb1 to ContentDb2.

---------------------EXAMPLE 3-----------------------

Copy code
Get-SPSiteAdministration | where { $_.OwnerLoginName -eq "DOMAIN\username" } | Move-SPSite -DestinationDatabase ContentDb2

This example moves all site collections where DOMAIN\username is the site collection owner to ContentDb2. The Get-SPSiteAdministration cmdlet is used instead of the Get-SPSite cmdlet because you must have permission within the site collection to access the properties of the SPSite object. You can access the properties of the SPSiteAdministration object as a SharePoint farm administrator.

---------------------EXAMPLE 4-----------------------

Copy code
Move-SPSite -Identity siteUrl -DestinationDatabase databaseName -RbsProviderMapping       @{"sourceProvider1"="targetProvider1", "sourceProvider2"="targetProvider2"}

This example moves an RBS-enabled site collection from one RBS-enabled content database to another RBS-enabled content database, sourceProvider1 is the source RBS provider and targetProvider1 is the target RBS provider.

See also

Backup-SPSite
Get-SPSite
Restore-SPSite
Get-SPSiteAdministration


Move-SPUser
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Migrates a user account in SharePoint 2010 Products.

Move-SPUser [-Identity] <SPUserPipeBind> -NewAlias <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-IgnoreSID <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUserPipeBind

Specifies the GUID or login name of the user to be returned.

The type must be a valid login name or GUID of the user, in the form DOMAIN\username or 1234-5678-9876-0987.

NewAlias

Required

System.String

Specifies the new login name of the user account.

The type must be a valid login name, in the form DOMAIN\username.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IgnoreSID

Optional

System.Management.Automation.SwitchParameter

Indicates (if present) that Active Directory will not be queried for the SID history attribute to ensure that the new login name is correspondent to the old login name.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Move-SPUser cmdlet migrates user access from one domain user account to another. If an entry for the new login name already exists, the entry is marked for deletion to make way for the migration.

Input Types

Return Types

Errors

Error | Description

Example

------------------EXAMPLE 1------------------

Copy code
Move-SPUser -Identity "DOMAIN\JaneDoe" -NewAlias "Domain\JaneSmith"

This example migrates DOMAIN\JaneDoe to the new account of DOMAIN\JaneSmith.

------------------EXAMPLE 2------------------

Copy code
Move-SPUser -Identity "DomainA\JaneDoe" -NewAlias "DomainB\JaneDoe"

This example migrates DOMAIN\JaneDoe from DomainA to the new account of DOMAINB\JaneDoe in DomainB.

See also

New-SPUser
Set-SPUser
Remove-SPUser
Get-SPUser


New-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new site collection at the specified URL.

New-SPSite [-Url] <String> -OwnerAlias <SPUserPipeBind> [-AdministrationSiteType <None | TenantAdministration>] [-AssignmentCollection <SPAssignmentCollection>] [-CompatibilityLevel <Int32>] [-Confirm [<SwitchParameter>]] [-ContentDatabase <SPContentDatabasePipeBind>] [-Description <String>] [-HostHeaderWebApplication <SPWebApplicationPipeBind>] [-Language <UInt32>] [-Name <String>] [-OverrideCompatibilityRestriction <SwitchParameter>] [-OwnerEmail <String>] [-QuotaTemplate <SPQuotaTemplatePipeBind>] [-SecondaryEmail <String>] [-SecondaryOwnerAlias <SPUserPipeBind>] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-Template <SPWebTemplatePipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Url

Required

System.String

Specifies the URL that the new site collection uses. If the URL is not a host header site, the URL must start with the the web application URL.

OwnerAlias

Required

System.String

Specifies the user login name of the site owner.

The type must be a valid user alias, in the form, Domain\username.

AdministrationSiteType

Optional

Microsoft.SharePoint.SPAdministrationSiteType

Specifies the site type.

Valid values are None or TentantAdministration.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CompatibilityLevel

Optional

System.Int32

Specifies the version of templates to use when creating a new SPSite object. This value sets the initial CompatibilityLevel value for the site collection. The values for this parameter can be either 14 for SharePoint Server 2010 experience sites or 15 for SharePoint Server 2013 experience sites . When this parameter is not specified, the CompatibilityLevel will default to the highest possible version for the web application depending on the CompatibilityRange setting.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentDatabase

Optional

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the name or GUID of the content database in which to create the new site. If no content database is specified, the site collection is selected automatically.

The type must be a valid database name in the form, SiteContent1212, or a GUID in the form, 1234-5678-9807.

Description

Optional

System.String

Describes the new site. If no value is specified, the value is left blank.

HostHeaderWebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies that if the URL provided is a host header, the HostHeaderWebApplication parameter must be the name, URL, GUID, or SPWebApplication object for the web application in which this site collection is created. If no value is specified, the value is left blank.

The type must be a valid name in one of the following forms:

  • WebApplication-1212

  • A URL (for example, http://server_name)

  • A GUID (for example, 1234-5678-9876-0987)

Language

Optional

System.Int32

Specifies the language ID for the new site collection. If no language is specified, the site collection is created with the same language that was specified when the product was installed.

This must be a valid language identifier (LCID).

Name

Optional

System.String

Specifies the title of the new site collection. If no name is specified, the default name is applied.

OverrideCompatibilityRestriction

Optional

System.Management.Automation.SwitchParameter

OwnerEmail

Optional

System.String

Specifies the email address of site owner. If no value is specified, the value is left blank.

The type must be a email address in the form, someone@example.com.

QuotaTemplate

Optional

Microsoft.SharePoint.PowerShell.SPQuotaTemplatePipeBind

Specifies the quota template for the new site. The template must exist already. If no template is specified, no quota is applied.

SecondaryEmail

Optional

System.String

Specifies the email address of the secondary site owner. If no value is specified, the value is left blank.

The type must be a email address, in the form, someone@example.com.

SecondaryOwnerAlias

Optional

System.String

Specifies the user login credentials of the secondary site owner. If no value is specified, the value is left blank.

The type must be a valid user alias, in the form, Domain\username.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the Site Group to get site collections.

Template

Optional

Microsoft.SharePoint.PowerShell.SPWebTemplatePipeBind

Specifies the Web template for the root web of the new site collection. The template must be already installed. If no template is specified, no template is provisioned.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPSite cmdlet creates a new site collection with the URL and owner that the Url and OwnerAlias parameters. specify This cmdlet can create site collections in either the SharePoint Server 2010 mode which uses the legacy 2010 versions of templates and features, or can be created in SharePoint Server 2013 mode which uses the new versions of templates and features.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
New-SPSite http://<site name>/sites/test -OwnerAlias "DOMAIN\JDoe" -Language 1033

This example creates an English site collection at http://<site name>/sites/test that is owned by user DOMAIN\Jdow.

------------------EXAMPLE 2-----------------------

Copy code
$w = Get-SPWebApplication http://<site name>
Copy code
New-SPSite http://www.contoso.com -OwnerAlias "DOMAIN\jdow" -HostHeaderWebApplication $w -Name "Contoso" -Template "STS#0"

This example creates a host header site collection. Because the template is provided, the root web of this site collection will be created.

------------------EXAMPLE 3-----------------------

Copy code
Get-SPWebTemplate | Where{ $_.Title -eq "Team Site" } | ForEach-Object{ New-SPSite http://<site name</sites/test -OwnerAlias DOMAIN\jdow -Template $_ }

This example creates a site collection by using the "Team Site" Web template.

------------------EXAMPLE 4-----------------------

Copy code
New-SPSite -URL http://<site name>/sites/testsite -OwnerAlias "DOMAIN\JDow" -Language 1033 -CompatibilityLevel 14

This example creates an English 14 mode site collection by using the Team site template at http://<site name>/sites/testsite that is owned by user DOMAIN\Jdow

See also

Get-SPSite
Set-SPSite
Backup-SPSite
Move-SPSite
Restore-SPSite


New-SPSiteSubscription
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new site subscription.

New-SPSiteSubscription [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The New-SPSiteSubscription cmdlet creates a new subscription to which the SPSites object can belong. Sites that are members of a site subscription can share settings and configuration information. A site collection can be a member of only one site subscription and, once set, cannot be changed.

Site subscriptions are not persisted in a database until used in conjunction with either an SPSite or the Site Subscription Settings Service. After a site subscription is applied to any site collection in the farm, the site subscription can be retrieved by using the Get-SPSiteSubscription cmdlet.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
New-SPSiteSubscription |%{ New-SPSite http://contoso.com/sites/admin -SiteSubscription $_ -Template "TenantAdmin#0"}
Copy code

This example creates a new site subscription and applies it to a new Tenant Administration site collection.
------------------EXAMPLE 2-----------------------
    Copy code
$s = New-SPSiteSubscription

    Copy code
Get-SPSite http://sitename | Set-SPSite -SiteSubscription $s

    Copy code
Set-SPSite http://sitename -SiteSubscription {New-SPSiteSubscription}

This example adds a new subscription to an existing site collection at http://sitename.
  See also
Get-SPSiteSubscription
Remove-SPSiteSubscription


New-SPUser
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds an existing user to a SharePoint site with the designated permissions.

New-SPUser [-UserAlias] <String> -Web <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DisplayName <String>] [-Email <String>] [-Group <SPGroupPipeBind>] [-PermissionLevel <String[]>] [-SiteCollectionAdmin <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

UserAlias

Required

System.String

Web

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the URL or GUID of the web on which to create this user.

The type must be a valid URL, in the form http://server_name, or a GUID, in the form 1234-5678-9876-0987.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DisplayName

Optional

System.String

Specifies a string that contains the display name of the user.

The type must be a valid user name; for example, Joe.

Email

Optional

System.String

Specifies the email address of the new user.

The type must be a valid email address, in the form someone@contoso.com.

Group

Optional

Microsoft.SharePoint.PowerShell.SPGroupPipeBind

Specifies the user group to which the new user belongs.

PermissionLevel

Optional

System.String[]

Adds a user to a permission level.

The type must be a valid permission level for the web application; for example, Full Control, Read, Contribute, or All.

SiteCollectionAdmin

Optional

System.Management.Automation.SwitchParameter

Specifies whether to add the user as an administrator to the site collection.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPUser cmdlet adds an existing user to a SharePoint web site with the designated permissions. This user has the given permissions in all subsites that inherit permissions. The user account must already exist in the user directory.

If your environment is in Active Directory mode, the user must already exist in Active Directory Domain Services (AD DS) and only the UserAlias parameter is required; all other fields are pulled from AD DS. If only an alias is given and the farm is in Active Directory Account Create mode, the Email parameter is also required.

Input Types

Return Types

Example

------------------EXAMPLE 1----------------------

Copy code
PS> New-SPUser - UserAlias 'Contoso\Jdow'-displayname 'Jane Dow' -web http://contoso.com

This example adds a new user named Jane Dow to the Contoso domain.

------------------EXAMPLE 2----------------------

Copy code
Get-SPWeb http://sitename | New-SPUser -UserAlias Contoso\Jdow

This example adds Contoso\Jdow to all webs in the http://sitename site collection. Because this site collection uses inherited permissions, only the top-level web site needs to be touched.

See also

Get-SPUser
Set-SPUser
Move-SPUser
Remove-SPUser


New-SPWeb
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new site in an existing site collection.

New-SPWeb [-Url] <String> [-AddToQuickLaunch <SwitchParameter>] [-AddToTopNav <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-Language <UInt32>] [-Name <String>] [-Template <SPWebTemplatePipeBind>] [-UniquePermissions <SwitchParameter>] [-UseParentTopNav <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Url

Required

System.String

Specifies the URL where the new site is to be created. The URL must be inside an existing site collection. The URL must be a valid URL, in the form http://server_name/site1.

Language

Optional

System.UInt32

Specifies the language template identifier for the new site. If no language is specified, the site is created with the same language that was specified when the product was installed.

The type must be a valid language identifier (LCID).

Template

Optional

SPWebTemplatePipeBind

Specifies the Web template for the new site. The template must already exist. If no template is specified, no template is applied and a template can be selected later.

Name

Optional

System.String

Specifies the title of the new site. If no title is specified, the default title is applied. The default title is configured for each template.

Description

Optional

System.String

Describes the new site. If no description is specified, the entry is left blank.

AddToQuickLaunch

Optional

System.Management.Automation.SwitchParameter

Adds this site to the Quick Launch.

UniquePermissions

Optional

System.Management.Automation.SwitchParameter

Specifies that this site is to be created with unique permissions.

AddToTopNav

Optional

System.Management.Automation.SwitchParameter

Adds this site to the top-level navigation bar.

UseParentTopNav

Optional

System.Management.Automation.SwitchParameter

Specifies that the same top-level navigation bar as the parent site is to be used for this site.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPWeb cmdlet creates a new site in the existing site collection specified by the Url parameter. You can create a site with a specific default language by specifying the Language parameter. If no language is specified, the site is created with the same language that was specified when the product was installed. You can create a site from a specific template by specifying the Template parameter. If no template is specified, the site is created and the template can be provided later or by the first user to log on.

Input Types

none

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
New-SPWeb http://somesite/subweb1 -Template "STS#0"

This example creates a new subsite by using the Team Site template at the provided URL (http://somesite/subweb1). The Team Site template is a value referenced as the variable STS#0 for the Template parameter.

See also

Get-SPWeb
Set-SPWeb
Remove-SPWeb
Import-SPWeb


New-SPWebApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new Web application within the local farm.

New-SPWebApplication -ApplicationPool <String> -Name <String> [-AdditionalClaimProvider <SPClaimProviderPipeBind[]>] [-AllowAnonymousAccess <SwitchParameter>] [-ApplicationPoolAccount <SPProcessAccountPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-AuthenticationMethod <String>] [-AuthenticationProvider <SPAuthenticationProviderPipeBind[]>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-HostHeader <String>] [-Path <String>] [-Port <UInt32>] [-SecureSocketsLayer <SwitchParameter>] [-ServiceApplicationProxyGroup <SPServiceApplicationProxyGroupPipeBind>] [-SignInRedirectProvider <SPTrustedIdentityTokenIssuerPipeBind>] [-SignInRedirectURL <String>] [-Url <String>] [-UserSettingsProvider <SPUserSettingsProviderPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ApplicationPool

Required

System.String

Specifies the name of an application pool to use; for example, SharePoint - 1213. If an application pool with the name provided does not exist, the ApplicationPoolAccount parameter must be provided and a new application pool will be created. If no value is specified, the default application pool will be used.

Name

Required

System.String

Specifies the name of the new Web application.

AdditionalClaimProvider

Optional

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind[]

Adds a specific claim provider to the defined Web application.

AllowAnonymousAccess

Optional

System.Management.Automation.SwitchParameter

Allows anonymous access to the Web application.

ApplicationPoolAccount

Optional

Microsoft.SharePoint.PowerShell.SPProcessAccountPipeBind

Specifies the user account that this application pool will run as. Use the Get-SPIisWebServicApplicationPool cmdlet to use a system account.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuthenticationMethod

Optional

System.String

Uses Kerberos or NTLM to specify the authentication method. If no value is specified, the default NTLM is applied.

AuthenticationProvider

Optional

Microsoft.SharePoint.PowerShell.SPAuthenticationProviderPipeBind[]

Specifies the authentication provider or providers that apply to a Web application.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the Windows PowerShell Credential object for the database user account.

DatabaseName

Optional

System.String

Specifies the name of the initial content database for the new Web application.

The type must be a valid database name; for example, ContentDB1. If no value is specified, a value in the format WSS_Content_<GUID> is auto-generated.

DatabaseServer

Optional

System.String

Specifies the database server name. The type must be a valid database server name, in the form SQL1; where named instances are used, the format can appear as server\server. The default SQL server instance is used if a value is not provided.

HostHeader

Optional

System.String

Specifies a valid URL assigned to the Web application that must correlate to the alternate access mapping configuration, in the form server_name.

When the HostHeader parameter is present, the value of this field is the internal URL for the Web application. The Url parameter is used to specify the public URL.If no value is specified, the value is left blank.

Path

Optional

System.String

Specifies the physical directory for the new Web application in the virtual directories folder. The type is a valid path, in the form C:\Inutepub\wwwroot\MyWebApplication. If no value is specified, the value %wwwroot%\wss\VirtualDirectories\<portnumber> is applied.

Port

Optional

System.UInt32

Specifies the port on which this Web application can be accessed. This can be any valid port number. If no port is specified, a nonconflicting port number is automatically generated.

Important:

If you specify a port number that has already been assigned, IIS does not start the new site until you change either the port number of the new site or the port number of the old site.

SecureSocketsLayer

Optional

System.Management.Automation.SwitchParameter

Enables Secure Sockets Layer (SSL) encryption for this Web application. If you choose to use SSL, you must add the certificate on each server by using the IIS administration tools. Until this is done, the Web application will be inaccessible from this IIS Web site.

ServiceApplicationProxyGroup

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies a custom service application proxy group for the Web application to use. The Web application will use the proxies in this proxy group to connect to service applications. If this parameter is not specified, the default proxy group for the farm is used.

SignInRedirectProvider

Optional

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Sets the sign-in redirect URL to point to the URL that is defined in the specified authentication provider.

SignInRedirectURL

Optional

System.String

Specifies the sign-in redirect URL for the Web application.

Url

Optional

System.String

Specifies the load-balanced URL for the Web application.

UserSettingsProvider

Optional

Microsoft.SharePoint.PowerShell.SPUserSettingsProviderPipeBind

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Creates a new Web application specified by the Name parameter. The user specified by the DatabaseCredentials parameter must be a member of the dbcreator fixed server role on the database server.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
$ap = New-SPAuthenticationProvider
Copy code
New-SPWebApplication -Name "Contoso Internet Site" -Port 80 -HostHeader sharepoint.contoso.com -URL "https://www.contoso.com" -ApplicationPool "ContosoAppPool" -ApplicationPoolAccount (Get-SPManagedAccount "DOMAIN\jdoe") -AuthenticationProvider $ap -SecureSocketsLayer

This example creates a new Web application by using an internal host header of sharepoint.contoso.com and a public URL of https://www.contoso.com.

See also

Get-SPWebApplication
Set-SPWebApplication
Get-SPWebApplication


New-SPWebApplicationExtension
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new zone instance for the Web application.

New-SPWebApplicationExtension [-Identity] <SPWebApplicationPipeBind> -Name <String> -Zone <Default | Intranet | Internet | Custom | Extranet> [-AdditionalClaimProvider <SPClaimProviderPipeBind[]>] [-AllowAnonymousAccess <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-AuthenticationMethod <String>] [-AuthenticationProvider <SPAuthenticationProviderPipeBind[]>] [-Confirm [<SwitchParameter>]] [-HostHeader <String>] [-Path <String>] [-Port <UInt32>] [-SecureSocketsLayer <SwitchParameter>] [-SignInRedirectProvider <SPTrustedIdentityTokenIssuerPipeBind>] [-SignInRedirectURL <String>] [-Url <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the Web application to extend.

Name

Required

System.String

Specifies the name of the new IIS Web site in the Web application.

Zone

Required

System.String

Specifies one of the five zones with which the internal URL of this new extension is to be associated. This zone cannot already be in use..

The type must be any one of the following values: Default, Intranet, Internet, Extranet, or Custom

AdditionalClaimProvider

Optional

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind[]

Adds a specific claim provider to the defined Web application.

AllowAnonymousAccess

Optional

System.Management.Automation.SwitchParameter

Allows anonymous access to the Web application zone.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuthenticationMethod

Optional

String

Uses Kerberos or NTLM to specify the authentication method.

AuthenticationProvider

Optional

Microsoft.SharePoint.PowerShell.SPAuthenticationProviderPipeBind[]

Specifies the authentication provider(s) that applies to a Web apllication.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

HostHeader

Optional

System.String

Specifies a valid URL assigned to the Web application by that must correlate to the alternate access mapping configuration, in the form http://server_name.

When the HostHeader parameter is present, the value of this field is the internal URL for the Web application. The Url parameter is used to specify the public URL.

Path

Optional

System.String

Specifies the physical directory for the new Web site (in the virtual directories folder). The type is a valid path, in the form C:\Inetpub\wwwroot\MyWebApplication.

Port

Optional

System.UInt32

Specifies the application port. Can be any valid port number.

If no port is specified, a nonconflicting port number is automatically generated.

Important:

If you specify a port number that is already assigned, IIS does not start the new site until you change either the port number of the new site or the port number of the old site.

SecureSocketsLayer

Optional

System.Management.Automation.SwitchParameter

Enables Secure Sockets Layer (SSL) encryption for this Web application. If you use SSL, you must add the certificate on each server by using the IIS administration tools. Until this is done, the Web application is inaccessible from this IIS Web site.

SignInRedirectProvider

Optional

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Sets the sign-in redirect URL to point to the URL that is defined in the specified authentication provider.

SignInRedirectURL

Optional

System.String

Specifies the sign-in redirect URL for the Web application.

Url

Optional

System.String

Specifies the load-balanced URL for the Web application zone.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPWebApplicationExtension cmdlet creates a new zone instance for the Web application. This is also known as extending a Web application and allows alternate permissions to be configured for the same content that is available in the existing Web application.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Get-SPWebApplication http://sitename | New-SPWebApplicationExtension -Name "ExtranetSite" -SecureSocketsLayer -Zone "Extranet" -URL "https://extranet.sitename.com"

This example extends the given Web application at http://sitename to the Extranet zone for SSL use.

See also

Get-SPWebApplication
Set-SPWebApplication


Remove-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Completely deletes an existing site collection and all subsites.

Remove-SPSite [-Identity] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DeleteADAccounts <SwitchParameter>] [-GradualDelete <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the identity of the site to delete. The identity can be either a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an SPSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DeleteADAccounts

Optional

System.Management.Automation.SwitchParameter

Forces deletion of user accounts from Active Directory Domain Services (AD DS). This applies when in AD DS account creation mode and the value of this parameter is True, AD DS accounts associated with the site collection are also deleted from AD DS.

GradualDelete

Optional

System.Management.Automation.SwitchParameter

If provided, occurs gradually to use less system load. This operation is strongly recommended for deleting very large sites.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPSite cmdlet completely deletes an existing site collection and all subsites. This operation cannot be undone.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Remove-SPSite -Identity "http://sitename" -GradualDelete -Confirm:$False

This example removes the given site collection and all included sites by using GradualDelete; confirmation has been suppressed.

See also

Get-SPSite
Set-SPSite
New-SPSite
Backup-SPSite
Remove-SPSite
Move-SPSite
Restore-SPSite


Remove-SPSiteSubscription
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes data stored in a subscription settings service application for a set of site subscriptions.

Remove-SPSiteSubscription [-Identity] <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Specifies the name of the site subscription to remove.

Specifies the site subscription settings service application that contains the service data to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubscriptionSettingsApp1); or an instance of a valid SPSubscriptionSettingsServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Forces the removal of a site subscription and is the only way to stop this command from prompting for confirmation.

The type must be either of the following values:

- True

- False

The default value is False.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPSiteSubscription cmdlet removes a site subscription along with all contained site collections and settings.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Remove-SPSiteSubscription "http://contoso.com"

This example removes all data for the contoso.com site subscription (site collections, site subscription, and settings).

See also

Get-SPSiteSubscription
New-SPSiteSubscription
Remove-SPSiteSubscription


Remove-SPSiteSubscriptionSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes the settings service data for a specified site subscription, or finds and removes orphaned data.

Remove-SPSiteSubscriptionSettings [-Identity] <SPServiceApplicationPipeBind> -SiteSubscriptions <Guid[]> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Remove-SPSiteSubscriptionSettings [-Identity] <SPServiceApplicationPipeBind> -FindAllOrphans <SwitchParameter> [-AlternativeSiteSubscriptions <Guid[]>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the site subscription settings service application that contains the service data to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubscriptionSettingsApp1); or an instance of a valid SPSubscriptionSettingsServiceApplication object.

SiteSubscriptions

Required

System.Guid[]

Specifies the site subscriptions with the settings service data to delete.

The type must be an array of valid GUIDs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the site subscription settings service application that contains the service data to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubscriptionSettingsApp1); or an instance of a valid SPSubscriptionSettingsServiceApplication object.

FindAllOrphans

Required

System.Management.Automation.SwitchParameter

Specifies that orphaned settings stores in the service application are deleted.

AlternativeSiteSubscriptions

Optional

System.Guid[]

Specifies the complete collection or comma-separated list of site subscriptions that should exist in the settings service application. Any data not matching the items in this list will be removed.

This parameter is important when the FindAllOrphans parameter is used. The value specified for AlternativeSiteSubscriptions parameter is stating that any site subscriptions not on the local farm will be deleted, unless an alternate list of site subscriptions is given.

The type must be an array of valid GUIDs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Automatically bypasses the secondary warning provided by the cmdlet prior to the operation.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Remove-SPSiteSubscriptionSettings cmdlet deletes site subscription stored data for the specified site subscription. If the FindAllOrphans parameter is specified, this cmdlet locates any data in the service application that does not exist in the list of local site subscriptions or the alternate list of subscriptions.

The set of site subscriptions can be specified directly, or discovered by comparing data in the service application to the set of existing site subscriptions which finds the data set that corresponds to nonexistent site subscriptions.

Important:

If this cmdlet is run on a federated service application without specifying the complete list of site subscription IDs for the AlternativeSiteSubscriptions parameter, data loss can result.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

------------EXAMPLE 1--------------

Copy code
Remove-SPSiteSubscriptionSettings -FindAllOrphans -Whatif

This example finds all orphans and displays them on the screen. Remove the WhatIf parameter to remove these extra settings.

------------EXAMPLE 2--------------

Copy code
Remove-SPSubscriptionSettingsServiceApplication -FindAllOrphans -AlternativeSiteSubscriptions $SubscriptionList

Use this example if the service application is consumed by a remote farm and you want the clean orphaned site subscription settings data (an array of all site subscriptions whose data must remain in the service application is assigned to the $SubscriptionList variable.

See also

Import-SPSiteSubscriptionSettings
Export-SPSiteSubscriptionSettings


Remove-SPUser
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a user from a Web site.

Remove-SPUser [-Identity] <SPUserPipeBind> -Web <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Group <SPGroupPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUserPipeBind

Specifies the GUID, the user name, or SPUser object to remove.

The type must be a valid GUID of the user, in the form 1234-5678-9876-0987.

Web

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the name of the URL or GUID from which the user is to be removed. This parameter is needed only if the identity provided is the user name.

The type must be a valid URL, in the form http://server_name, or a GUID, in the form 1234-5678-9807.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Group

Optional

Microsoft.SharePoint.PowerShell.SPGroupPipeBind

The user only gets removed from that group. Otherwise, the user gets removed from the site.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPUser cmdlet specifies the identity and user group from which a user is to be removed. The Remove-SPUser cmdlet does not remove the user from Active Directory Domain Services (AD DS).

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
Remove-SPUser "Contoso \jdoe" -web http://test/web1
Copy code
Get-SPWeb "http://test/web1" | Remove-SPUser "Contoso\jdoe"

This example removes the user (Contoso\jdoe) from the Web application http://test/web1.

------------------EXAMPLE 2-----------------------

Copy code
Get-SPSite http://contoso.com |Get-SPWeb |Remove-SPUser "Contoso\jdoe"

This syntax removes the user (Contoso\Jdoe) from every Web in a site collection located at http://contoso.com.

See also

Get-SPUser
Set-SPUser
New-SPUser
Remove-SPUser


Remove-SPWeb
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Completely deletes the specified Web.

Remove-SPWeb [-Identity] <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Recycle <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the identity of the Web to delete.

The type must be a valid full URL, in the form http://server_name/site_name, or an SPWeb object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPWeb cmdlet completely deletes the Web specified by the Identity parameter.

Important:

Deleting the top level Web site of a site collection causes the entire site collection to be removed.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Remove-SPWeb http://sitename/subsite

This example completely deletes a subsite.

See also

Get-SPWeb
Set-SPWeb
Remove-SPWeb
New-SPWeb
Import-SPWeb


Remove-SPWebApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Deletes the specified Web application.

Remove-SPWebApplication [-Identity] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DeleteIISSite <SwitchParameter>] [-RemoveContentDatabases <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Remove-SPWebApplication [-Identity] <SPWebApplicationPipeBind> -Zone <Default | Intranet | Internet | Custom | Extranet> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DeleteIISSite <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL or name of the Web application to delete.

The type must be a valid URL, in the form http://server_name, or a valid name, in the form WebApplication-1212.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DeleteIISSite

Optional

System.Management.Automation.SwitchParameter

Deletes the associated IIS Web sites. If this parameter is not provided, the IIS site is not removed.

RemoveContentDatabases

Optional

System.Management.Automation.SwitchParameter

Permanently deletes all associated content databases. If this parameter is not provided, no content databases are removed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL or name of the Web application to delete.

The type must be a valid URL, in the form http://server_name, or a valid name, in the form WebApplication-1212.

Zone

Required

System.String

Specifies one of the five zones to be removed. If this parameter is not provided, all Web application zones are removed.

The type must be any one of the following values: Default, Intranet, Internet, Extranet, or Custom.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DeleteIISSite

Optional

System.Management.Automation.SwitchParameter

Deletes the associated IIS Web sites. If this parameter is not provided, the IIS site is not removed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Remove-SPWebApplication cmdlet deletes the Web application specified by the Identity and Zone parameters. If no zone is provided, the entire Web application and all zones are removed.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
Get-SPWebApplication http://sitename | Remove-SPWebApplication -Zone "Internet" -Confirm

This example prompts and then removes the Internet zone Web application extension on the Web application at http://sitename. This command does not remove the content databases or the IIS Web site.

------------------EXAMPLE 2-----------------------

Copy code
Remove-SPWebApplication http://sitename -Confirm -DeleteIISSite -RemoveContentDatabases

This example permanently removes the Web application, all content databases, and the IIS Web site at http://sitename

See also

Get-SPWebApplication
Set-SPWebApplication
New-SPWebApplication


Rename-SPServer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Renames a server that is currently connected to the farm.

Rename-SPServer [-Identity] <SPServerPipeBind> -Name <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the original name of the server.

The type must be a URL, in the form http://server_name, or a GUID, in the form 1234-4567-987gb.

Name

Required

System.String

Specifies the new name of the server.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Rename-SPServer cmdlet changes the name of the server for internal use within SharePoint Products. The server itself must be manually renamed.

Input Types

Return Types

Example

------------------EXAMPLE------------------

Copy code
Rename-SPServer -Identity "wfb1" -Name "WFE1"

This example changes the name of the SharePoint server wfb1 to WFE1.

See also

Get-SPServer


Set-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Configures the specified sites.

Set-SPSite [-Identity] <SPSitePipeBind> [-AdministrationSiteType <None | TenantAdministration>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-LockState <String>] [-MaxSize <Int64>] [-OwnerAlias <SPUserPipeBind>] [-QuotaTemplate <SPQuotaTemplatePipeBind>] [-SecondaryOwnerAlias <SPUserPipeBind>] [-SharingType <String>] [-Template <SPWebTemplatePipeBind>] [-Url <String>] [-UserAccountDirectoryPath <String>] [-WarningSize <Int64>] [-WhatIf [<SwitchParameter>]]
Set-SPSite [-Identity] <SPSitePipeBind> [-AdministrationSiteType <None | TenantAdministration>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site collection to configure, or refers to an SPSite object that contains sites to configure.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an SPSite object.

AdministrationSiteType

Optional

Microsoft.SharePoint.SPAdministrationSiteType

Specifies the site type.

Valid values are None or TentantAdministration.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

LockState

Optional

System.String

Sets the lock state of this site collection. The valid lock states are

Unlock Unlocks the site collection and makes it available to users

NoAdditions Prevents users from adding new content to the site collection. Updates and deletions are still allowed

ReadOnly Prevents users from adding, updating, or deleting content.

NoAccess Prevents access to content completely. Users who attempt to access the site receive an access-denied message.

MaxSize

Optional

System.Int32

Sets the maximum storage size for the site collection in megabytes.

The integer value must be larger than the WarningSize value. You cannot use this parameter if the site collection is using a quota template.

OwnerAlias

Optional

System.String

Specifies the alias name of the site collection administrator.

The type must be a valid e-mail alias, in the form domain\username.

QuotaTemplate

Optional

Microsoft.SharePoint.PowerShell.SPQuotaTemplatePipeBind

Specifies the new quota template for this site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890abcdef or a string

SecondaryOwnerAlias

Optional

System.String

Sets the alias of the secondary site collection administrator.

The type must be a valid e-mail alias, in the form domain\username.

SharingType

Optional

System.String

Specifies whether external access a site collection should be disabled, limited to external users only, or enabled for external users and anonymous guests.

Template

Optional

Microsoft.SharePoint.PowerShell.SPWebTemplatePipeBind

Specifies the template for this site collection.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890abcdef.

Url

Optional

System.String

Specifies the URL of the new site.

UserAccountDirectoryPath

Optional

String

Sets an organization unit to which to scope user accounts.

WarningSize

Optional

System.Int32

Sets the storage warning level for the site collection.

The integer value must be between 0 and the MaxSize value. You cannot use this parameter if the site collection is using a quota template.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site collection to configure, or refers to an SPSite object that contains sites to configure.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an SPSite object.

AdministrationSiteType

Optional

Microsoft.SharePoint.SPAdministrationSiteType

Specifies the site type.

Valid values are None or TentantAdministration.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Suppresses confirmation messages involved in setting the site subscription. This parameter is used in conjunction with the SiteSubscription parameter.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the Site Group to get site collections.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPSite cmdlet configures the site collection that is specified by the Identity parameter. If a parameter is not used, the value is not changed.

Note:

The QuotaTemplate parameter is mutually exclusive to the MaxSize parameter and WarningSize parameter.

Input Types

Return Types

Example

------------------EXAMPLE 1---------------------

Copy code
Get-SPSite http://sitename/sites/teams/* | Set-SPSite -SecondaryOwner "DOMAIN\Jdoe"

This example sets the secondary owner on a set of site collections to DOMAIN\Jdoe.

------------------EXAMPLE 2---------------------

Copy code
Set-SPSite -identity "http://sitename" -MaxSize 4000000 -WarningSize 2000000

This example configures the Quota settings for the site collection http://sitename.

See also

Get-SPSite
New-SPSite
Restore-SPSite
Remove-SPSite
Move-SPSite
Restore-SPSite


Set-SPSiteAdministration
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Allows farm administrators to configure any site collection.

Set-SPSiteAdministration [-Identity] <SPSiteAdministrationPipeBind> [-AdministrationSiteType <None | TenantAdministration>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-LockState <String>] [-MaxSize <Int64>] [-OwnerAlias <SPUserPipeBind>] [-SecondaryOwnerAlias <SPUserPipeBind>] [-Template <SPWebTemplatePipeBind>] [-WarningSize <Int64>] [-WhatIf [<SwitchParameter>]]
Set-SPSiteAdministration [-Identity] <SPSiteAdministrationPipeBind> [-AdministrationSiteType <None | TenantAdministration>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteAdministrationPipeBind

Specifies the URL (full or partial) or GUID of the site collection.

The type must be a valid URL, in the form http://server_name, or a GUID, in the form 1234-456-987fg.

AdministrationSiteType

Optional

Microsoft.SharePoint.SPAdministrationSiteType

Specifies the site type.

Valid values are None or TentantAdministration.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

LockState

Optional

System.String

Specifies the lock state for the given site collection.

The type must be any of the following values:

- Unlock: Sets the site collection to unlock.

- Content: No new content can be added. Updates and deletions are allowed.

- Readonly: Sets the site collection to read-only.

- Noaccess: Sets the site collection to unavailable to all users.

MaxSize

Optional

System.Int32

Sets the maximum storage size of the site collection.

The type must be a valid number greater than or equal to 0. .

Set to 0 for unlimited.

OwnerAlias

Optional

System.String

Sets the owner of this site collection.

The type must be a valid user alias.

SecondaryOwnerAlias

Optional

System.String

Sets the secondary owner of this site collection.

The type must be a valid user alias.

Template

Optional

Microsoft.SharePoint.PowerShell.SPWebTemplatePipeBind

Specifies the Web template for the top-level Web site of this site collection. This can only be given if the template has not already been configured.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890abcdef, or an SPWebTemplate object.

WarningSize

Optional

System.Int64

Specifies the site collection warning size limit.

The type must be a valid number greater than or equal to 0. Set to 0 for unlimited.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteAdministrationPipeBind

Specifies the URL (full or partial) or GUID of the site collection.

The type must be a valid URL, in the form http://server_name, or a GUID, in the form 1234-456-987fg.

AdministrationSiteType

Optional

Microsoft.SharePoint.SPAdministrationSiteType

Specifies the site type.

Valid values are None or TentantAdministration.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Suppresses confirmation messages involved in setting the site subscription. This parameter is used in conjunction with the SiteSubscription parameter.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the Site Group to get site collections.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPSiteAdministration cmdlet allows a farm administrator to configure particular settings on a site collection even if the farm administrator is not granted explicit permissions. Any parameter that is not provided is not changed.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Set-SPSiteAdministration http://sitename -OwnerAlias "DOMAIN\NewOwner"

This example allows farm administrators to change the ownership of a site collection to which they do not have access.

See also

Get-SPSiteAdministration
Get-SPSite


Set-SPSiteSubscriptionConfig
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the configuration properties of a site subscription.

Set-SPSiteSubscriptionConfig [-Identity] <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-FeaturePack <SPSiteSubscriptionFeaturePackPipeBind>] [-PassThru <SwitchParameter>] [-UserAccountDirectoryPath <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription configuration to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; an SPSite (object or URL) of a site collection that is a member of the site subscription; or an instance of a valid SiteSubscription object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PassThru

Optional

System.Management.Automation.SwitchParameter

Specifies the output object can be passed through the pipeline.

FeatureSet

Optional

Microsoft.SharePoint.PowerShell.SPFeatureSetPipeBind

Specifies the feature set that is associated with the site subscription.

Specifies a null value to clear the current association.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPFeatureSetobject.

UserAccountDirectoryPath

Optional

System.String

Sets the site user account directory path to a specific organizational unit (OU) that is in the same domain as the site subscription.

The type must be a name of a distinguished OU; for example, OU=Contoso1, DC=OSGCorp,DC=local.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPSiteSubscriptionConfig cmdlet sets the configuration properties of a site subscription.

Input Types

Return Types

Example

------------EXAMPLE---------------

Copy code
Set-SPSiteSubscription http://contoso.com -FeatureSet 12345678-90ab-cdef-1234-567890abcdef

This example sets the Feature set of the entire site subscription that contains http://contoso.com with a Feature set GUID.


Set-SPSubscriptionSettingsServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Sets properties of a subscription settings service application.

Set-SPSubscriptionSettingsServiceApplication [-Identity] <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-FailoverDatabaseServer <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the settings service application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubscriptionSettingsApp1); or an instance of a valid SPSubscriptionSettingsServiceApplication object.

ApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the Internet Information Services (IIS) application pool to use for the new subscription settings application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the PSCredential object that contains the user name and password to be used for database SQL Server Authentication.

The type must be a valid PSCredential object.

DatabaseName

Optional

System.String

Specifies the name of the subscription settings database.

The type must be a valid name of a SQL Server database; for example, SubscriptionSettingsAppDB1.

DatabaseServer

Optional

Microsoft.SharePoint.PowerShell.SPServerPipeBind

Specifies the name of the host SQL Server instance for the database specified in DatabaseName parameter.

The type must be a valid SQL Server instance name; for example, SQLServerHost1.

FailoverDatabaseServer

Optional

System.String

Specifies the name of the host SQL Server instance for the failover database server.

The type must be a valid SQL Server instance name; for example, SQLServerHost1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPSubscriptionSettingsServiceApplication cmdlet to set properties on a subscription settings service application.

Input Types

Return Types

Example

---------------------EXAMPLE--------------------------

Copy code
$applicationPool = GetServiceApplicationPool SettingsApplicationPool
Copy code
Get-SPServiceApplication -Name SettingsServiceApp | Set-SPSubscriptionSettingsServiceApplication -ApplicationPool $applicationPool

This example changes the application pool of the subscription settings service application. This command assumes that a subscription settings service application named SettingsServiceApp exists and that an application pool named SettingsApplicationPool exists

See also

New-SPSubscriptionSettingsServiceApplication
New-SPSubscriptionSettingsServiceApplicationProxy


Set-SPUser
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Configures properties of an existing user.

Set-SPUser [-Identity] <SPUserPipeBind> [-AddPermissionLevel <String[]>] [-AssignmentCollection <SPAssignmentCollection>] [-ClearPermissions <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-DisplayName <String>] [-Email <String>] [-Group <SPGroupPipeBind>] [-IsSiteCollectionAdmin <SwitchParameter>] [-PassThru <SwitchParameter>] [-RemovePermissionLevel <String[]>] [-SyncFromAD <SwitchParameter>] [-Web <SPWebPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUserPipeBind

Specifies the GUID, login name, or SPUser object of the user to be returned.

The type must be a GUID of an existing user in the form, 1234-5678-9876-0987.

AddPermissionLevel

Optional

System.String[]

Specifies the permission level to add to the user.

The value must be one of the following options:

--Contribute

Can view, add, update, and delete list items and documents.

--Design

Can view, add, update, delete, approve, and customize documents.

--Full Control

Has full control for all documents.

--Limited Access

Can view specific lists, document libraries, list items, folders, or documents when permissions are granted.

--Read

Can view pages and list items and download documents.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ClearPermissions

Optional

System.Management.Automation.SwitchParameter

Deletes all assigned permissions from the user. If Clear and Add values exist, permissions are first cleared, and then new permissions are added.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DisplayName

Optional

System.String

Specifies the new display name of the user.

The type must be a valid name.

Email

Optional

System.String

Specifies the new email address of the user.

Group

Optional

Microsoft.SharePoint.PowerShell.SPGroupPipeBind

Adds the user to an existing group in the given site.

IsSiteCollectionAdmin

Optional

none

Specifies whether to set the user as a site collection administrator.

PassThru

Optional

none

If not provided, indicates that this cmdlet has no output. If provided, this parameter indicates that the SPUser object for this user is to be returned.

RemovePermissionLevel

Optional

System.String[]

Removes the permission level from the user.

SyncFromAD

Optional

System.Management.Automation.SwitchParameter

If provided, specifies that user information will be synchronized from the user directory store.

Web

Optional

Microsoft.SharePoint.PowerShell.SPWebPipeBind

Specifies the name of the URL or GUID to be used as a scope. This parameter is not needed if the SPUser object is provided as the identity.

The value must be an authentic URL, in the form http://server_name, or GUID, in the form 1234-5678-9807.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPUser cmdlet configures properties of an existing user.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Set-SPUser -Identity 'Contoso\jdow' -Web http:// test -AddPermissionLevel "Contributor"

This example sets a user (Contoso\jdow) to be a contributor on http://test.

See also

Get-SPUser
New-SPUser
Remove-SPUser
Move-SPUser


Set-SPWebApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Configures the specified Web application.

Set-SPWebApplication [-Identity] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultQuotaTemplate <String>] [-DefaultTimeZone <Int32>] [-Force <SwitchParameter>] [-ServiceApplicationProxyGroup <SPServiceApplicationProxyGroupPipeBind>] [-WhatIf [<SwitchParameter>]]
Set-SPWebApplication [-Identity] <SPWebApplicationPipeBind> -Zone <Default | Intranet | Internet | Custom | Extranet> [-AdditionalClaimProvider <SPClaimProviderPipeBind[]>] [-AssignmentCollection <SPAssignmentCollection>] [-AuthenticationMethod <String>] [-AuthenticationProvider <SPAuthenticationProviderPipeBind[]>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-SignInRedirectProvider <SPTrustedIdentityTokenIssuerPipeBind>] [-SignInRedirectURL <String>] [-WhatIf [<SwitchParameter>]]
Set-SPWebApplication [-Identity] <SPWebApplicationPipeBind> -SMTPServer <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-OutgoingEmailAddress <String>] [-ReplyToEmailAddress <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the name or URL of the Web application.

The type must be a valid name, in the form WebApplication-1212, or URL, in the form http://server_name/WebApplicaiton-1212.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultQuotaTemplate

Optional

System.String

Specifies the new default site quota template for this Web application.

DefaultTimeZone

Optional

System.Int32

Specifies the default time zone for new site collections in this Web application.

Force

Optional

System.Management.Automation.SwitchParameter

Suppresses confirmation messages involved in settings for a Web application.

ServiceApplicationProxyGroup

Optional

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyGroupPipeBind

Specifies a custom service application proxy group for the Web application to use. The Web application will use the proxies in this proxy group to connect to service applications. If this parameter is not specified, the farm's default proxy group is used.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the name or URL of the Web application.

The type must be a valid name, in the form WebApplication-1212, or URL, in the form http://server_name/WebApplicaiton-1212.

Zone

Required

Microsoft.SharePoint.Administration.SPUrlZone

When configuring zone-specific settings, the zone to configure must be specified. This zone must already exist.

The type must be any one of the following values: Default, Intranet, Internet, Extranet, or Custom.

AdditionalClaimProvider

Optional

Microsoft.SharePoint.PowerShell.SPClaimProviderPipeBind[]

Adds a specific claim provider to the defined Web application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AuthenticationMethod

Optional

System.String

Use to set a Web application to classic Windows authentication. The valid values are NTLM or Kerberos.

AuthenticationProvider

Optional

Microsoft.SharePoint.PowerShell.SPAuthenticationProviderPipeBind[]

Defines the authentication provider(s) that applies to the Web application.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Suppresses confirmation messages involved in settings for a Web application.

SignInRedirectProvider

Optional

Microsoft.SharePoint.PowerShell.SPTrustedIdentityTokenIssuerPipeBind

Sets the sign-in redirect URL to point to the URL that is defined in the specified authentication provider.

SignInRedirectURL

Optional

System.String

Specifies the sign-in redirect URL for the Web application.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

3

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the name or URL of the Web application.

The type must be a valid name, in the form WebApplication-1212, or URL, in the form http://server_name/WebApplicaiton-1212.

OutgoingEmailAddress

Optional

System.String

Specifies the new outgoing e-mail address for e-mail messages sent from this Web application. The type must be a valid address; for example, someone@example.com.

ReplyToEmailAddress

Optional

System.String

Configures the reply e-mail address.

The type must be a valid address; for example, someone@example.com.

SMTPServer

Required

System.String

Specifies the new outbound SMTP server that this Web application will use.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

Optional

System.Management.Automation.SwitchParameter

Suppresses confirmation messages involved in settings for a Web application.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPWebApplication cmdlet configures the Web application specified by the Identity parameter. For any settings that are zone-specific (for the Zone parameter set), the zone to configure must be provided. The provided zone must already exist.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Get-SPWebApplication http://somesite | Set-SPWebApplication -Zone "Extranet" -HostHeader "http://www.contoso.com" - AllowAnonymousAccess

This example sets the HostHeader URL for the Extranet zone of the given Web application as http://www.contoso.com and enables anonymous access.

See also

Get-SPWebApplication
New-SPWebApplication
Remove-SPWebApplication


Set-SPWeb
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Configures the specified subsite.

Set-SPWeb [-Identity] <SPWebPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Description <String>] [-RelativeUrl <String>] [-Template <SPWebTemplatePipeBind>] [-Theme <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPWebPipeBind

The URL of the Web or SPWeb object that represents the Web.

The type must be a valid URL, in the form http://server_name, or an SPWeb object.

Name

Optional

String

Specifies the new name of the Web.

Description

Optional

System.String

Specifies the new description of the Web.

RelativeUrl

Optional

System.String

Specifies the new relative URL for the Web. This is the URL path after the site collection URL.

Theme

Optional

System.String

Specifies the new theme to apply to the Web.

Template

Optional

Microsoft.SharePoint.PowerShell.SPWebTemplatePipeBind

Specifies the new template to apply to the Web. This cannot be done if the template is already applied.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPWeb cmdlet configures the subsite specified by the Identity parameter. Settings for any parameters that are not provided are not changed.

Input Types

Return Types

one

Example

------------------EXAMPLE-----------------------

Copy code
Get-SPWeb http://sitename/subweb | Set-SPWeb -Title "My Site Title"

This example sets the title of an existing subsite.

See also

Get-SPWeb
New-SPWeb
Remove-SPWeb
Export-SPWeb
Import-SPWeb


Export-SPSiteSubscriptionSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a backup file of site subscription data.

Export-SPSiteSubscriptionSettings [-Identity] <SPSiteSubscriptionPipeBind> -Path <String> [-AdminProperties <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Force <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the ID of the site subscription from which to back up data.

The type must be a valid URL, in the form http://server_name or a GUID in the form 1234-4567-985tg.

Path

Required

System.String

Specifies the location of the output file.

The type must be a valid path; for example, C:/backupfile.back..

AdminProperties

Optional

System.Management.Automation.SwitchParameter

Specifies that only administrator subscription properties are exported. If this parameter is not set, only non-administrator subscription properties are exported.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Force

No

System.Management.Automation.SwitchParameter

Forces the output backup file (if provided) to overwrite any existing file at the given path.

Detailed Description

The Export-SPSiteSubscriptionSettings cmdlet generates a backup file of all settings in the subscription data store for the given site subscription.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPSiteSubscription http://contoso.com | Backup-SPSiteSubscriptionSettings -path "c:/backups"

The example backs up the subscription settings store of http://www.contoso.com.

See also

Import-SPSiteSubscriptionSettings
Remove-SPSiteSubscriptionSettings


Import-SPSiteSubscriptionSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Restores a backup of subscription site settings to the given subscription identifier.

Import-SPSiteSubscriptionSettings [-Identity] <SPSiteSubscriptionPipeBind> -Path <String> [-AdminProperties <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Force <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the ID of the subscription to restore .

The type must be a valid URL, in the form http://server_name, or a GUID, in the form 1234-4567-985tg.

Path

Required

System.String

Specifies the location of the input file.

The type must be a valid path, in the form C:\filename.bak.

AdminProperties

Optional

System.Management.Automation.SwitchParameter

Specifies that only administrator subscription properties are imported. If this parameter is not set, only non-administrator subscription properties are imported.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Force

No

System.Management.Automation.SwitchParameter

If a setting key already exists, determines whether the value must be overwritten with the value in the backup file.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Import-SPSiteSubscriptionSettings cmdlet restores a backup of subscription site settings to the given subscription identifier when the Identity parameter is used. To overwrite existing settings, use the Force parameter.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPSiteSubscription http://contoso.com | Import-SPSiteSubscriptionSettings -path "c:/backups/contoso_settings_file.bak" -force

This example restores the subscription settings store of contoso.com.

See also

Export-SPSiteSubscriptionSettings
Remove-SPSiteSubscriptionSettings


Get-SPDeletedSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Gets a list of deleted site collections.

Get-SPDeletedSite [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ContentDatabase <SPContentDatabasePipeBind>] [-DateTimeFrom <String>] [-DateTimeTo <String>] [-Limit <String>] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]
Get-SPDeletedSite [-Identity] <SPDeletedSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ContentDatabase <SPContentDatabasePipeBind>] [-DateTimeFrom <String>] [-DateTimeTo <String>] [-Limit <String>] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentDatabase

Optional

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the GUID of the content database from which to list site collections.

The type must be a valid database name in the form SPContentDB01 or a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh.

DateTimeFrom

Optional

System.String

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

DateTimeTo

Optional

System.String

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 1000.

The type must be a valid non-negative number. Specify ALL to return all site collections for the given scope.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription from which to get site collections.

The type must be a valid URL in the form http://server_name or a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, or name of the Web application from which to list sites.

The type must be a valid URL in the form http://server_name; a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh; or the Web application name, for example, WebApplication1212.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPDeletedSitePipeBind

Specifies the URL or GUID of the site collection to get.

The identity can be either a valid server-relative URL in the form /sites/site_name or a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentDatabase

Optional

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the GUID of the content database from which to list site collections.

The type must be a valid database name in the form SPContentDB01 or a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh.

DateTimeFrom

Optional

System.String

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

DateTimeTo

Optional

System.String

The type must be a valid DateTime format that is culture-specific to the administrative language, such as 2/16/2007 12:15:12 for English-US.

Limit

Optional

System.String

Limits the maximum number of site collections to return. The default value is 1000.

The type must be a valid non-negative number. Specify ALL to return all site collections for the given scope.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription from which to get site collections.

The type must be a valid URL in the form http://server_name or a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, or name of the Web application from which to list sites.

The type must be a valid URL in the form http://server_name; a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh; or the Web application name, for example, WebApplication1212.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Use the Get-SPDeletedSite cmdlet to display a list of deleted site collections by using the Identity parameter. If no parameter is specified, then all deleted site collections in the farm are displayed.

Unlike the Get-SPSite cmdlet that uses the host name and scheme for the Identity parameter (that is, http://server_name), the value of the identity parameter for all SPDeletedSite cmdlets use a server-relative URL. Typically, the forward slash character (/) begins the relative URL and also denotes the root site.

For additional information about a server-relative URL or understanding general concepts about absolute and relative URLs, see Server-relative URL Property or Understanding Absolute and Relative URL Addresses.

Input Types

Return Types

Example

------------------EXAMPLE 1---------------------

Copy code
Get-SPDeletedSite -Identity 610857cb-8414-4a89-8bf3-ad3628f6c86c

This example gets a specific deleted site collection by using a site ID.

------------------EXAMPLE 2---------------------

Copy code
Get-SPDeletedSite "/"

This example gets a deleted site collection from the root site.

------------------EXAMPLE 3---------------------

Copy code
Get-SPDeletedSite '/Site/cat*'

This example matches a deleted site collection that contains any combination with the string "cat". The asterisk (*) wildcard character requests a match for multiple characters.

See also

Remove-SPDeletedSite
Restore-SPDeletedSite


Remove-SPDeletedSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a deleted site collection.

Remove-SPDeletedSite [-Identity] <SPDeletedSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ContentDatabase <SPContentDatabasePipeBind>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPDeletedSitePipeBind

Specifies the identity of the deleted site collection to permanently delete. The identity can be either a valid server-relative URL in the form /sites/site_name; a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an SPDeletedSite object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentDatabase

Optional

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the GUID of the content database from which to list site collections.

The type must be a valid database name in the form SPContentDB01 or a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, or name of the Web application from which to list sites.

The type must be a valid URL in the form http://server_name; a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh; or the Web application name, for example, WebApplication1212.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Use the Remove-SPDeletedSite cmdlet to permanently remove a deleted site collection from the farm.

Unlike the Remove-SPSite cmdlet that uses the host name and scheme for the Identity parameter (that is, http://server_name), the value of the identity parameter for all SPDeletedSite cmdlets use a server-relative URL. Typically, the forward slash character (/) begins the relative URL and also denotes the root site.

For additional information about a server-relative URL or understanding general concepts about absolute and relative URLs, see Server Relative URL Property or Understanding Absolute and Relative URL Addresses.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Remove-SPDeletedSite -Identity 610857cb-8414-4a89-8bf3-ad3628f6c86c

This example permanently removes a specific deleted site collection by using a site ID.

See also

Get-SPDeletedSite
Restore-SPDeletedSite


Restore-SPDeletedSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Restores a deleted site collection.

Restore-SPDeletedSite [-Identity] <SPDeletedSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ContentDatabase <SPContentDatabasePipeBind>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPDeletedSitePipeBind

Specifies the identity of the deleted site collection to be restored. The identity can be either a valid server-relative URL in the form /sites/site_name; a valid GUID in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an SPDeletedSite object

A site collection must not already exist at the URL location to perform a restore.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentDatabase

Optional

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the SQL Server content database where the site collection data will be stored. If no content database is specified, the content database with the greatest unused site collection capacity and whose database status is ready will be used.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, or name of the Web application from which to list sites.

The type must be a valid URL in the form http://server_name; a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh; or the Web application name, for example, WebApplication1212.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Use the Restore-SPDeletedSite cmdlet to restore a previously deleted site collection.

Unlike the Restore-SPSite cmdlet that uses the host name and scheme for the Identity parameter (that is, http://server_name), the value of the identity parameter for all SPDeletedSite cmdlets use a server-relative URL. Typically, the forward slash character (/) begins the relative URL and also denotes the root site.

For additional information about a server-relative URL or understanding general concepts about absolute and relative URLs, see Server-relative URL Property or Understanding Absolute and Relative URL Addresses.

Input Types

Return Types

Example

----------------------EXAMPLE 1----------------------

Copy code
Restore-SPDeletedSite -Identity 610857cb-8414-4a89-8bf3-ad3628f6c86c

This example restores a specific deleted site collection by using the site ID.

See also

Get-SPDeletedSite
Remove-SPDeletedSite


Get-SPSiteUrl
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Displays all URL mappings for the site.

Get-SPSiteUrl [-Identity] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site collection to display. Must be the root site collection of a host name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPSiteUrl cmdlet to display all the URL mappings of the site by using the Identity parameter.

The Get-SPSiteUrl cmdlet only applies to the root site collection for a host name, that is http://www.contoso.com. This cmdlet cannot be directly run against a managed path site collection underneath the root, that is, http://www.contoso.com/sites/test.

Input Types

Return Types

Example

-----------EXAMPLE----------

Copy code
$site = Get-SPSite 'http://www.contoso.com'
Copy code
Get-SPSiteURL -Identity $site

This example displays all the URLs that bind to the site collection, http://www.contoso.com.

See also

Remove-SPSiteUrl
Set-SPSiteUrl


Remove-SPSiteUrl
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes an URL mapping from the site.

Remove-SPSiteUrl [-Url] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Url

Required

System.String

Specifies the URL to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPSiteUrl cmdlet removes an URL mapping from the site.

The Remove-SPSiteUrl cmdlet only applies to the root site collection for a host name, that is, http://www.contoso.com. This cmdlet cannot be directly run against a managed path site collection underneath the root, that is, http://www.contoso.com/sites/test.

Note:

You cannot remove the primary URL for a given site collection, which is typically defined as the first URL in the default zone.

Input Types

Return Types

Example

------------EXAMPLE------

Copy code
Remove-SPSiteURL -Url http://contoso.sharepoint.com

This example removes the URL from the site collection, http://contoso.sharepoint.com.

See also

Get-SPSiteUrl
Set-SPSiteUrl


Set-SPSiteUrl
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds or changes an URL mapping for the site.

Set-SPSiteUrl [-Identity] <SPSitePipeBind> -Url <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]] [-Zone <Default | Intranet | Internet | Custom | Extranet>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site collection to set. Must be the root site collection for a host-name.

Url

Required

System.String

Specifies the URL. This must be unique. This must be an absolute URL including scheme (that is, https://www.contoso.com). If URL exists, the current entry is updated. Otherwise, the URL entry is added and cannot be in use by another site collection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Zone

Optional

Microsoft.SharePoint.Administration.SPUrlZone

Specifies one of the five zones with which the alternate URL is associated.

The type must be any one of the following values:

  • Default

  • Intranet

  • Internet

  • Custom

  • Extranet

If the Zone parameter is not specified and is a new entry, the default value is set. If an entry exists and is not specified, do not change.

Detailed Description

The Set-SPSiteUrl cmdlet adds or changes an URL mapping for the site.

The Set-SPSiteUrl cmdlet only applies to the root site collection for a host name that is, http://www.contoso.com. This cmdlet cannot be directly run against a managed path site collection underneath the root that is, http://www.contoso.com/sites/test.

Input Types

Return Types

Example

---------------EXAMPLE------------

Copy code
$site = Get-SPSite 'http://www.contoso.com'
Copy code
Set-SPSiteURL -Identity $site -Url http://contoso.sharepoint.com -Zone Default

This example adds an additional URL, http://contoso.sharepoint.com, to the site collection. The newly added URL is in the default zone.

See also

Get-SPSiteUrl
Remove-SPSiteUrl


Get-SPSiteSubscriptionIRMConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Gets the Information Rights Management (IRM) settings.

Get-SPSiteSubscriptionIRMConfig [-Identity] <SPSiteSubscriptionPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the site subscription for a particular tenant.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPSiteSubscriptionIRMConfig cmdlet to display IRM setting information for a specified tenant when the Identity parameter is used.

Input Types

Return Types

Example

------------EXAMPLE-----------

Copy code
site = Get-SPSite http://myspserver
Copy code
$subscription = $site.SiteSubscription
Copy code
Get-SPSiteSubscriptionIRMConfig -Identity $subscription

This example gets the IRM settings for a specified tenant by using the Identity parameter.

See also

Set-SPSiteSubscriptionIRMConfig


Move-SPDeletedSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Moves deleted site collections from one content database to another.

Move-SPDeletedSite [-Identity] <SPDeletedSitePipeBind> -DestinationDatabase <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ContentDatabase <SPContentDatabasePipeBind>] [-RbsProviderMapping <Hashtable>] [-WebApplication <SPWebApplicationPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPDeletedSitePipeBind

Specifies the identity of the site collection to be moved. For example, http://servername/sites/sitename.

DestinationDatabase

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the content database that the site collection should be moved to. For example, ContentDB2.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ContentDatabase

Optional

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the SQL Server content database where the site collection data will be stored. If no content database is specified, the content database with the greatest unused site collection capacity and whose database status is ready will be used.

RbsProviderMapping

Optional

System.Collections.Hashtable

Used to move a Remote BLOB Storage (RBS)-enabled site collection from one RBS-enabled content database to another RBS-enabled content database without moving the underlying Binary Large Object (BLOB) content. If the content database has more than one RBS provider associated with it, you must specify all providers. The same providers must be enabled on the target content database and the source content database.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the URL, GUID, or name of the Web application from which to list sites.

The type must be a valid URL in the form http://server_name; a valid GUID, for example, 12345678-90ab-cdef-1234-567890bcdefgh; or the Web application name, for example, WebApplication1212.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Move-SPDeletedSite cmdlet to move data in a specified site collection from its current content database to the content database specified by the DestinationDatabase parameter.

Input Types

Return Types

Example

----------EXAMPLE----------

Copy code
Move-SPDeletedSite -Identity 610857cb-8414-4a89-8bf3-ad3628f6c86c -DestinationDatabase "ContentDB2"

This example moves deleted site collections from the specified GUID to the database named "ContentDB2".

See also

Get-SPDeletedSite
Remove-SPDeletedSite
Restore-SPDeletedSite


Set-SPIRMSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets the Information Rights Management (IRM) settings.

Set-SPIRMSettings -IrmEnabled <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-CertificatePassword <SecureString>] [-Confirm [<SwitchParameter>]] [-ServiceAuthenticationCertificate <X509Certificate2>] [-SubscriptionScopeSettingsEnabled <SwitchParameter>] [-UseActiveDirectoryDiscovery <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Set-SPIRMSettings -CertificateServerUrl <Uri> -IrmEnabled <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-CertificatePassword <SecureString>] [-Confirm [<SwitchParameter>]] [-ServiceAuthenticationCertificate <X509Certificate2>] [-SubscriptionScopeSettingsEnabled <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

IrmEnabled

Required

System.Management.Automation.SwitchParameter

Specifies whether or not IRM is enabled in the tenant.

The default value is false.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CertificatePassword

Optional

System.Security.SecureString

Specifies the password to access the Service Authentication Certificate. This password is required in order to install the certificate in the machine certificate store.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ServiceAuthenticationCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the service authentication certificate.

If the parameter is specified and not null, the authentication certificate is used when connecting from this farm to the RMS server. If the parameter is not specified, the local farm connects to RMS server using integrated windows authentication.

SubscriptionScopeSettingsEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether or not IRM can be configured at the site subscription scope.

Site subscriptions can only configure custom IRM settings if IRM is enabled at the Farm scope.

UseActiveDirectoryDiscovery

Optional

System.Management.Automation.SwitchParameter

Specifies whether or not the RMS service should be used for discovery that will determine the address of the RMS server in the domain.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

CertificateServerUrl

Required

System.Uri

Specifies the address of the RMS certificate server to use for the tenant.

IrmEnabled

Required

System.Management.Automation.SwitchParameter

Specifies whether or not IRM is enabled in the tenant.

The default value is false.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CertificatePassword

Optional

System.Security.SecureString

Specifies the password to access the Service Authentication Certificate. This password is required in order to install the certificate in the machine certificate store.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ServiceAuthenticationCertificate

Optional

System.Security.Cryptography.X509Certificates.X509Certificate2

Specifies the service authentication certificate.

If the parameter is specified and not null, the authentication certificate is used when connecting from this farm to the RMS server. If the parameter is not specified, the local farm connects to RMS server using integrated windows authentication.

SubscriptionScopeSettingsEnabled

Optional

System.Management.Automation.SwitchParameter

Specifies whether or not IRM can be configured at the site subscription scope.

Site subscriptions can only configure custom IRM settings if IRM is enabled at the Farm scope.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPIRMSettings cmdlet to set the Information Rights Management (IRM) settings for the tenant.

Input Types

Return Types

Example

--------------EXAMPLE 1------------

Copy code
Set-SPIRMSettings -IrmEnabled -UseActiveDirectoryDiscovery

This example enables IRM for the farm and configures it to use the default RMS server configured in Active Directory.

--------------EXAMPLE 2------------

Copy code
Set-SPIRMSettings -IrmEnabled -CertificateServerUrl http://myrmsserver

This example enables IRM for the farm and specifies the URL of the RMS server to use.

--------------EXAMPLE 3------------

Copy code
site = Get-SPSite http://myspserver
Copy code
$subscription = $site.SiteSubscription
Copy code
Set-SPIRMSettings -SiteSubscription $subscription -IrmEnabled -CertificateServerUrl http://myrmsserver

This example enables IRM for the specified tenant and specifies the URL of the RMS server to use.

--------------EXAMPLE 4------------

Copy code
Set-SPIRMSettings -IrmEnabled:$false

This example disables IRM for the farm.

See also

Get-SPIRMSettings


Set-SPSiteSubscriptionIRMConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets the Information Rights Management (IRM) settings.

Set-SPSiteSubscriptionIRMConfig [-Identity] <SPSiteSubscriptionPipeBind> -IrmEnabled <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-CertificateServerUrl <Uri>] [-Confirm [<SwitchParameter>]] [-PassThru <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies a site subscription for a particular tenant.

IrmEnabled

Required

System.Management.Automation.SwitchParameter

Specifies whether IRM is enabled in the tenant.

The default value is false.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CertificateServerUrl

Optional

System.Uri

Specifies the address of the RMS certificate server to use for the tenant.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PassThru

Optional

System.Management.Automation.SwitchParameter

Specifies that the output object can be passed through the pipeline.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Identity parameter of the Set-SPSiteSubscriptionIRMConfig cmdlet to set the IRM setting for a specified tenant.

Input Types

Return Types

Example

--------------EXAMPLE 1------------

Copy code
site = Get-SPSite  HYPERLINK "http://<myspserver>" http:// <myspserver>
Copy code
$subscription = $site.SiteSubscription
Copy code
Set-SPSiteSubscriptionIRMConfig -Identity $subscription -IrmEnabled -CertificateServerUrl http:// <rmsserver>

This example enables IRM for the tenant and configures it to use the specified RMS server.

--------------EXAMPLE 2------------

Copy code
site = Get-SPSite  HYPERLINK "http://myspserver" http:// <myspserver>
Copy code
$subscription = $site.SiteSubscription
Copy code
Set- SPSiteSubscriptionIRMConfig -Identity $subscription -IrmEnabled:$false

This example disables IRM for the tenant.

See also

Get-SPSiteSubscriptionIRMConfig


Get-SPIRMSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the Information Rights Management (IRM) settings.

Get-SPIRMSettings [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPIRMSettings cmdlet to display IRM settings for the farm.

Input Types

Return Types

Example

----------------EXAMPLE----------------

Copy code
Get-SPIRMSettings

This example returns IRM settings for the entire farm.

See also

Set-SPIRMSettings


Set-SPCustomLayoutsPage
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Maps a new path for a custom layout page.

Set-SPCustomLayoutsPage -Identity <None | AccessDenied | Confirmation | Error | Login | RequestAccess | Signout | WebDeleted> -RelativePath <String> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Set-SPCustomLayoutsPage -Identity <None | AccessDenied | Confirmation | Error | Login | RequestAccess | Signout | WebDeleted> -Reset <SwitchParameter> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.Administration.SPWebApplication+SPCustomPage

Specifies the custom layout page to set.

The type must be one of the following: None, AccessDenied, Confirmation, Error, Login, RequestAccess, Signout, or WebDeleted.

RelativePath

Required

System.String

Specifies the path of the custom layout page.

The type must be a valid path of a layout page, in the form _layouts/custompages/myaccessdenied.aspx.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the SharePoint Web application that contains the custom layout page.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.Administration.SPWebApplication+SPCustomPage

Specifies the custom layout page to set.

The type must be one of the following: None, AccessDenied, Confirmation, Error, Login, RequestAccess, Signout, or WebDeleted.

Reset

Required

System.Management.Automation.SwitchParameter

Resets the mapping of a custom layouts page.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the SharePoint Web application that contains the custom layout page.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPCustomLayoutsPage cmdlet maps a new path for a custom layouts page in a Web application. To remove the mapping for a custom layouts page, use the Reset parameter instead of the RelativePath parameter.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Set-SPCustomLayoutsPage -Identity "_layouts/accessdenied.aspx" -RelativePath "/_layouts/custompages/myaccessdenied.aspx" -WebApplication "http://server_name/mywebapp"

This example maps the specified path for the AccessDenied layout page in the Web application "http://server_name/mywebapp".

See also

Get-SPCustomLayoutsPage


State service and session state cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that are used to support session state and the state service in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

These Windows PowerShell cmdlets are used to support session state and the state service.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Disable-SPSessionStateService | Turns off the session state service on the farm
Dismount-SPStateServiceDatabase | Removes the association to a state service database from the farm without dropping the database in the Microsoft SQL Server database
Enable-SPSessionStateService | Creates a session state database and turns on the session state service
Get-SPSessionStateService | Returns the properties of the session state service, including time-out and database settings
Get-SPStateServiceApplication | Returns state service applications on the farm
Get-SPStateServiceApplicationProxy | Returns state service application proxies on the farm.
Get-SPStateServiceDatabase | Returns a state service database.
Initialize-SPStateServiceDatabase | Installs the state database schema into a state service database
Mount-SPStateServiceDatabase | Attaches an existing state service database to the farm
New-SPStateServiceApplication | Creates a new state service application
New-SPStateServiceApplicationProxy | Creates a proxy for a state service application
New-SPStateServiceDatabase | Creates and provisions a new state service database, and installs the state database schema into it
Remove-SPStateServiceDatabase | Removes a state service database from a state service application and drops it from the SQL Server
Resume-SPStateServiceDatabase | Resumes a paused state service database so that new rows of data are received
Set-SPSessionStateService | Updates the credentials that are used to communicate with the state service database
Set-SPStateServiceApplication | Updates the name of a state service application
Set-SPStateServiceApplicationProxy | Updates the name of a state service application proxy
Set-SPStateServiceDatabase | Updates properties of a state service database
Suspend-SPStateServiceDatabase | Pauses a state database and thus prevents new rows of data from being added to a database

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Disable-SPSessionStateService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Turns off the session state service on the farm.

Disable-SPSessionStateService [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Disable-SPSessionStateService cmdlet turns off the session state service. If your farm does not depend on session state service, we recommend that you disable it.

Note:

When session state is disabled, some SharePoint Server 2013 services, components, and third-party components no longer function. Changing this property modifies the Web.config file on every content Web application on every server in the farm.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Disable-SPSessionStateService

This example turns off ASP.NET session state on the farm.

See also

Enable-SPSessionStateService
Get-SPSessionStateService
Set-SPSessionStateService


Dismount-SPStateServiceDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes the association to a state service database from the farm without dropping the database in the Microsoft SQL Server database.

Dismount-SPStateServiceDatabase [-Identity] <SPStateDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Administration.SPStateDatabasePipeBind

Specifies the state service database to remove from the service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a state database (for example, StateSvcDB1); or an instance of a valid SPStateServiceDatabase object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Dismount-SPStateServiceDatabase cmdlet removes a state service database from a service application and deletes the associated SharePoint object. This cmdlet does not delete or alter the state service database.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Dismount-SPStateServiceDatabase -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b

This example removes the association between the SharePoint farm and the SQL Server database without dropping the SQL Server database.

--------------EXAMPLE 2-----------------

Copy code
Get-SPStateServiceDatabase -ServiceApplication F9168C5E-CEB2-4faa-B6BF-329BF39FA1E4 | Dismount-SPStateServiceDatabase

This example dismounts a single database because only the Identity parameter is used.

See also

Initialize-SPStateServiceDatabase
Mount-SPStateServiceDatabase
New-SPStateServiceDatabase
Remove-SPStateServiceDatabase
Resume-SPStateServiceDatabase
Set-SPStateServiceDatabase
Suspend-SPStateServiceDatabase


Enable-SPSessionStateService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a session state database and turns on the session state service.

Enable-SPSessionStateService -DatabaseName <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-DatabaseServer <String>] [-SessionTimeout <Nullable>] [-WhatIf [<SwitchParameter>]]
Enable-SPSessionStateService -DefaultProvision <SwitchParameter> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SessionTimeout <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

DatabaseName

Required

System.String

Specifies the name of the database for the session state service.

The type must be a valid name of a SQL Server database; for example, SessionStateDB1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the database credentials for SQL Authentication used to access the session state service database. If this parameter is not specified, Windows authentication is used.

The type must be a valid PSCredential object.

DatabaseServer

Optional

System.String

Specifies the host SQL Server for the state service database.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

SessionTimeout

Optional

System.Nullable

Specifies the time, in minutes, that a ASP .NET session state service will remain active with no user activity. The default value is 60.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

DefaultProvision

Required

System.Management.Automation.SwitchParameter

Specifies that the default provisioning settings are used. The default provisioning settings are: Windows Authentication, Auto SQL Server (configuration database), and Auto Catalog Name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SessionTimeout

Optional

System.Nullable

Specifies the time, in minutes, that a ASP .NET session state service will remain active with no user activity. The default value is 60.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Enable-SPSessionStateService cmdlet creates a session state database, installs the ASP.NET session state schema, and updates the Web.config files on the farm to turn on the session state service.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Enable-SPSessionStateService -DefaultProvision

This example enables a ASP.NET session state on a SharePoint Server 2013 farm that uses the defaults (database hosted on the configuration database SQL Server, using Windows authentication, 60-minute session time-out).

--------------EXAMPLE 2-----------------

Copy code
Enable-SPSessionStateService -DatabaseName "SessionStateDatabase" -DatabaseServer "localhost" -SessionTimeout 120

This example enables a ASP.NET session state on a SharePoint Server 2013 farm that uses a custom database name, database server, session time-out of 120 minutes, and Windows credentials (due to the lack of a DatabaseCredentials parameter).

See also

Disable-SPSessionStateService
Get-SPSessionStateService
Set-SPSessionStateService


Get-SPSessionStateService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the properties of the session state service, including time-out and database settings.

Get-SPSessionStateService [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPSessionStateService cmdlet reads the properties of the session state service.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPSessionStateService

This example returns the current configuration of the session state service.

See also

Disable-SPSessionStateService
Enable-SPSessionStateService
Set-SPSessionStateService


Get-SPStateServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns state service applications on the farm.

Get-SPStateServiceApplication [[-Identity] <SPStateServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Administration.SPStateServiceApplicationPipeBind

Specifies the state service application to get.

The type must be a valid name of a state service application (for example, StateServiceApp1) or a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Get-SPStateServiceApplication cmdlet returns a state service application on the farm. If the Identity parameter is not specified, this cmdlet returns the collection of all state service applications on the farm.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPStateServiceApplication

This example displays all state service applications in the farm.

--------------EXAMPLE 2-----------------

Copy code
Get-SPStateServiceApplication -Identity "StateServiceApp1"

This example displays a specific state service application in the farm.

See also

New-SPStateServiceApplication
Set-SPStateServiceApplication


Get-SPStateServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns state service application proxies on the farm.

Get-SPStateServiceApplicationProxy [[-Identity] <SPStateServiceApplicationProxyPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Server.Administration.SPStateServiceApplicationProxyPipeBind

Specifies the state service application proxy to get.

The type must be a valid name of a state service application proxy (for example, StateServiceProxy); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Get-SPStateServiceApplicationProxy cmdlet returns a state service application proxy on the farm. If the Identity parameter is not specified, this cmdlet returns the collection of all state service application proxies on the farm.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPStateServiceApplicationProxy

This example displays all the state service application proxies on the farm.

--------------EXAMPLE 2-----------------

Copy code
Get-SPStateServiceApplicationProxy -Identity 81dc50e0-c0f9-4d2c-8284-bb03bb1ea676

This example displays a specific state service application proxy on the farm.

See also

New-SPStateServiceApplicationProxy
Set-SPStateServiceApplicationProxy


Get-SPStateServiceDatabase
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns a state service database.

Get-SPStateServiceDatabase [[-Identity] <SPStateDatabasePipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Get-SPStateServiceDatabase [[-ServiceApplication] <SPStateServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.Office.Server.Administration.SPStateDatabasePipeBind

Specifies the state service database to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh or an instance of a valid SPStateServiceDatabase object (for example, StateSvcDB1).

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ServiceApplication

Optional

Microsoft.Office.Server.Administration.SPStateServiceApplicationPipeBind

Filters to return only the state service database associated with the specified state service application.

The type must be a valid name of a state service application (for example, StateServiceApp1); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPStateServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPStateServiceDatabase cmdlet returns a state service database on the farm. If the Identity parameter is not specified, this cmdlet returns the collection of all state service databases on the farm.

Input Types

Return Types

Example

--------------EXAMPLE 1----------------

Copy code
Get-SPStateServiceDatabase

This example displays all of the state service databases on the farm.

--------------EXAMPLE 2--------------

Copy code
Get-SPStateServiceDatabase -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b

This example displays a specific state service database in the farm.

--------------EXAMPLE 3--------------

Copy code
Get-SPStateServiceDatabase -ServiceApplication "StateServiceApp1"

This example displays all state service databases associated with a specific service.


Initialize-SPStateServiceDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Installs the state database schema into a state service database.

Initialize-SPStateServiceDatabase [-Identity] <SPStateDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Administration.SPStateDatabasePipeBind

Specifies the state service database to initialize.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a state database (for example, StateSvcDB1); or an instance of a valid SPStateServiceDatabase object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Initialize-SPStateServiceDatabase cmdlet installs the session state database schema in an empty state service database. The current user's credentials are used to create the state database schema.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Initialize-SPStateServiceDatabase -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b

This example installs the state service database schema into the database associated with the provided identity.

See also

Dismount-SPStateServiceDatabase
Mount-SPStateServiceDatabase
New-SPStateServiceDatabase
Remove-SPStateServiceDatabase
Resume-SPStateServiceDatabase
Set-SPStateServiceDatabase
Suspend-SPStateServiceDatabase


Mount-SPStateServiceDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Attaches an existing state service database to the farm.

Mount-SPStateServiceDatabase [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseCredentials <PSCredential>] [-DatabaseServer <String>] [-ServiceApplication <SPStateServiceApplicationPipeBind>] [-Weight <Nullable>]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the database name that is created in the SQL Server database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the database credentials for SQL Authentication used to access the state service database. If this parameter is not specified, Windows authentication is used.

The type must be a valid PSCredential object.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the state service database.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

ServiceApplication

Optional

Microsoft.Office.Server.Administration.SPStateServiceApplicationPipeBind

Specifies the state service application to which to add the state database.

The type must be a valid name of a state service application (for example, StateServiceApp1); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPStateServiceApplication object.

Weight

Optional

System.Nullable

Specifies the weight for the state database used to load balance the allocation of new data. The default value is 1.

The type must be a valid integer in the range of 1 to 10.

Detailed Description

The Mount-SPStateServiceDatabase cmdlet attaches an existing state service database to the farm. If the session state database schema is not installed in the state service database, use the Initialize-SPStateServiceDatabase cmdlet to install the schema after the state service database has been mounted.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Mount-SPStateServiceDatabase -Name "statedata1" -DatabaseServer "localhost"

This example associates a SharePoint Server 2013 farm with a SQL Server database.

This example is used in least privilege scenarios when an administrator cannot create databases in SQL. The database must already exist and be empty. The database cannot be used until the Initialize-SPStateServiceDatabase cmdlet is run, so errors could occur with this example.

--------------EXAMPLE 2-----------------

Copy code
Mount-SPStateServiceDatabase -Name "statedata1" -DatabaseServer "localhost" -ServiceApplication "ServiceApp1" -Weight 10 | Initialize-SPStateServiceDatabase

This example associates a SharePoint Server 2013 farm with a SQL Server database, at the same time that it also associates the database with a service application and gives a weight of 10. The result is immediately piped to the Initialize-SPStateServiceDatabase cmdlet so that the database can be used.

See also

Dismount-SPStateServiceDatabase
Initialize-SPStateServiceDatabase
New-SPStateServiceDatabase
Remove-SPStateServiceDatabase
Resume-SPStateServiceDatabase
Set-SPStateServiceDatabase
Suspend-SPStateServiceDatabase


New-SPStateServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new state service application.

New-SPStateServiceApplication [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-Database <SPStateDatabasePipeBind>]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the new service application.

The type must be a valid name of a service application; for example, StateSvcApp1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Database

Optional

Microsoft.Office.Server.Administration.SPStateDatabasePipeBind

Specifies the state service database that is associated with the new service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a state database (for example, StateSvcDB1); or an instance of a valid SPStateServiceDatabase object.

Detailed Description

The New-SPStateServiceApplication cmdlet creates a new state service application on the farm. A state service application is the container for state service databases.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
New-SPStateServiceApplication -Name "State Service Application 1"

This example creates a new state service application, named State Service Application 1, on the farm.

State service applications are the container for databases. State service applications must have a proxy and a database created to be usable.

--------------EXAMPLE 2-----------------

Copy code
New-SPStateServiceDatabase -Name "State Service Database" | New-SPStateServiceApplication -Name "StateServiceApp1" | New-SPStateServiceApplicationProxy -DefaultProxyGroup

This example creates a new state service database, a new state service application associated with the database and a new state service application proxy associated with the state service application proxy.

This example configures all the objects required to have State Service operational on a farm.

See also

Get-SPStateServiceApplication
Set-SPStateServiceApplication


New-SPStateServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a proxy for a state service application.

New-SPStateServiceApplicationProxy [-ServiceApplication] <SPStateServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-DefaultProxyGroup <SwitchParameter>] [-Name <String>]

Parameters

Parameter Required Type Description

ServiceApplication

Required

Microsoft.Office.Server.Administration.SPStateServiceApplicationPipeBind

Specifies the state service application to associate with the new proxy.

The type must be a valid name of a state service application (for example, StateServiceApp1); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPStateServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application proxy is added to the farm's default proxy group.

Name

Optional

System.String

Specifies the display name of the new proxy.

The type must be a valid name of a SQL Server database; for example, SessionStateDB1. Service application proxy; for example, StateSvcAppProxy1.

Detailed Description

The New-SPStateServiceApplicationProxy cmdlet creates a proxy for a state service application.

Input Types

Return Types

Example

--------------EXAMPLE-------------------

Copy code
Get-SPServiceApplication -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b | New-SPStateServiceApplicationProxy -DefaultProxyGroup

This example creates a new service application proxy, associates it with a provided service application, and adds it to the farm's default proxy group.

See also

Get-SPStateServiceApplicationProxy
Set-SPStateServiceApplicationProxy


New-SPStateServiceDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates and provisions a new state service database, and installs the state database schema into it.

New-SPStateServiceDatabase [-Name] <String> [-AssignmentCollection <SPAssignmentCollection>] [-DatabaseCredentials <PSCredential>] [-DatabaseServer <String>] [-ServiceApplication <SPStateServiceApplicationPipeBind>] [-Weight <Nullable>]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name for the state service database that is stored in SQL Server.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the database credentials for SQL Authentication used to access the state service database. If this parameter is not specified, Windows authentication is used.

The type must be a valid PSCredential object.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the state service database.

The type must be a valid SQL Server host name; for example, SQLServerHost1.

ServiceApplication

Optional

Microsoft.Office.Server.Administration.SPStateServiceApplicationPipeBind

Specifies the state service application to add the state database to.

The type must be a valid name of a state service application (for example, StateServiceApp1); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPStateServiceApplication object.

Weight

Optional

System.Nullable

Specifies the weight for the state database. The default value is 1.

This parameter is used when new rows of data are allocated among the collection of databases that are associated with a service application

The type must be a valid integer in the range of 1 to 10.

Detailed Description

The New-SPStateServiceDatabase cmdlet creates and a new state service database. This cmdlet installs the session state database schema in the state service database.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPStateServiceApplication -name "State Service Application 1" | New-SPStateServiceDatabase -Name "statedata1" -DatabaseServer "localhost"

This example creates a new state service database by using Windows authentication, and associates it with the provided service application.

--------------EXAMPLE 2-----------------

Copy code
$cred = Get-Credential
Copy code
Get-SPStateServiceApplication -name "State Service Application 1" | New-SPStateServiceDatabase -Name "statedata1" -DatabaseServer "localhost" -DatabaseCredentials $cred

This example creates a new state service database, a new state service application associated with the database and a new state service application proxy associated with the state service application proxy.

This example configures all the objects required to have State Service operational on a farm.

See also

Dismount-SPStateServiceDatabase
Initialize-SPStateServiceDatabase
Mount-SPStateServiceDatabase
Remove-SPStateServiceDatabase
Resume-SPStateServiceDatabase
Set-SPStateServiceDatabase
Suspend-SPStateServiceDatabase


Remove-SPStateServiceDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a state service database from a state service application and drops it from the SQL Server.

Remove-SPStateServiceDatabase [-Identity] <SPStateDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Administration.SPStateDatabasePipeBind

Specifies the state service database to remove.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a state database (for example, StateSvcDB1); or an instance of a valid SPStateServiceDatabase object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPStateServiceDatabase cmdlet removes a state service database from a state service application and deletes the database. To remove a state service database and not delete the database, use the Dismount-SPStateServiceDatabase cmdlet.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Remove-SPStateServiceDatabase -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b

This example removes the specified database from a SharePoint Server 2013 farm and drops the database from the SQL Server (data loss).

See also

Dismount-SPStateServiceDatabase
Initialize-SPStateServiceDatabase
Mount-SPStateServiceDatabase
New-SPStateServiceDatabase
Resume-SPStateServiceDatabase
Set-SPStateServiceDatabase
Suspend-SPStateServiceDatabase


Resume-SPStateServiceDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Resumes a paused state service database so that new rows of data are received.

Resume-SPStateServiceDatabase [-Identity] <SPStateDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Administration.SPStateDatabasePipeBind

Specifies the state service database to resume.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a state database (for example, StateSvcDB1); or an instance of a valid SPStateServiceDatabase object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Resume-SPStateServiceDatabase cmdlet resumes a paused state service database, an operation that adds the state service database to the set of databases that can receive new data as required by SharePoint Server 2013 applications.

Input Types

Return Types

Example

--------------EXAMPLE------------------

Copy code
Resume-SPStateServiceDatabase -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b

This example resumes a paused state service database.

See also

Dismount-SPStateServiceDatabase
Initialize-SPStateServiceDatabase
Mount-SPStateServiceDatabase
New-SPStateServiceDatabase
Remove-SPStateServiceDatabase
Set-SPStateServiceDatabase
Suspend-SPStateServiceDatabase


Set-SPSessionStateService
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Updates the credentials that are used to communicate with the state service database.

Set-SPSessionStateService [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-SessionTimeout <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the database credentials for SQL Authentication that are used to access the state service database. If this parameter is not specified, Windows authentication is used.

The type must be a valid PSCredential object.

SessionTimeout

Optional

System.Nullable

Specifies the time, in minutes that an ASP.NET session will remain active with no user activity.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPSessionStateService cmdlet updates the credentials that are used to communicate with the state service database.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Set-SPSessionStateService -SessionTimeout 120

This example changes the ASP.NET session state time-out to 2 hours.

See also

Disable-SPSessionStateService
Enable-SPSessionStateService
Get-SPSessionStateService


Set-SPStateServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Updates the name of a state service application.

Set-SPStateServiceApplication [-Identity] <SPStateServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Administration.SPStateServiceApplicationPipeBind

Specifies the state service application to update.

The type must be a valid name of a state service application (for example, StateServiceApp1); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPStateServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Name

Optional

System.String

Specifies the display name of the state service application.

The type must be a valid name of a state service application; for example, StateSvc1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPStateServiceApplication cmdlet updates the name of a state service application.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Set-SPStateServiceApplication -Identity "State Service Application 1" -Name "New name for State Service Application 1"

This example changes the display name of a state service application.

See also

Get-SPStateServiceApplication
New-SPStateServiceApplication


Set-SPStateServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Updates the name of a state service application proxy.

Set-SPStateServiceApplicationProxy [-Identity] <SPStateServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Administration.SPStateServiceApplicationProxyPipeBind

Specifies the state service application proxy to update.

The type must be a valid name of a state service application proxy (for example, StateServiceProxy); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPStateServiceApplicationProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Name

Optional

System.String

Specifies the display name of the state service application proxy.

The type must be a valid name of a state service application; for example, StateSvcProxy1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Detailed Description

The Set-SPStateServiceApplicationProxy cmdlet updates the name of a state service application proxy.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Set-SPServiceApplicationProxy -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b -Name "New Service Application Proxy Name"

This example changes the display name of a state service application proxy.

See also

Get-SPStateServiceApplicationProxy
New-SPStateServiceApplicationProxy


Set-SPStateServiceDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Updates properties of a state service database.

Set-SPStateServiceDatabase [-Identity] <SPStateDatabasePipeBind> [[-ServiceApplication] <SPStateServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredentials <PSCredential>] [-Weight <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Administration.SPStateDatabasePipeBind

Specifies the state service database to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a state database (for example, StateSvcDB1); or an instance of a valid SPStateServiceDatabase object.

ServiceApplication

Optional

Microsoft.Office.Server.Administration.SPStateServiceApplicationPipeBind

Specifies the state service application to which to add the state database.

The type must be a valid name of a state service application (for example, StateServiceApp1); a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or an instance of a valid SPStateServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredentials

Optional

System.Management.Automation.PSCredential

Specifies the database credentials for SQL Authentication used to access the state service database. If this parameter is not specified, Windows authentication is used.

The type must be a valid PSCredential object.

Weight

Optional

System.Nullable

Specifies the weight for the state database. The default value is 1.

The type must be a valid integer in the range of 1 to 10.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPStateServiceDatabase cmdlet manages the credentials that are used to communicate with the database, sets the weight of the database, or changes the state service application with which it is associated.

Input Types

Return Types

Example

--------------EXAMPLE 1--------------

Copy code
Set-SPStateServiceDatabase -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b -Weight 10

This example updates the database weight to the maximum (10).

--------------EXAMPLE 2--------------

Copy code
Set-SPStateServiceDatabase -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b -ServiceApplication "StateSvcApp1"

This example updates the associated service application for a state service database.

--------------EXAMPLE 3--------------

Copy code
$cred = Get-Credential
Copy code
Set-SPStateServiceDatabase -Identity "StateSvcDB1" -DatabaseCredentials $cred

This example updates the SQL Authentication credentials that are used for a given database.

See also

Dismount-SPStateServiceDatabase
Initialize-SPStateServiceDatabase
Mount-SPStateServiceDatabase
New-SPStateServiceDatabase
Remove-SPStateServiceDatabase
Resume-SPStateServiceDatabase
Suspend-SPStateServiceDatabase


Suspend-SPStateServiceDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Pauses a state database and thus prevents new rows of data from being added to a database.

Suspend-SPStateServiceDatabase [-Identity] <SPStateDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.Administration.SPStateDatabasePipeBind

Specifies the state database to pause.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a state database (for example, StateSvcDB1); or an instance of a valid SPStateServiceDatabase object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Suspend-SPStateServiceDatabase cmdlet pauses a state database. This cmdlet updates the state database object that is specified in the Identity parameter.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Suspend-SPStateServiceDatabase -Identity 9703f7e2-9521-47c3-bd92-80e3eeba391b

This example suspends a specified state service database.

See also

Dismount-SPStateServiceDatabase
Initialize-SPStateServiceDatabase
Mount-SPStateServiceDatabase
New-SPStateServiceDatabase
Remove-SPStateServiceDatabase
Resume-SPStateServiceDatabase
Set-SPStateServiceDatabase


Use Windows PowerShell cmdlets to manage timer jobs in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you manage timer jobs in a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use Windows PowerShell cmdlets to manage timer jobs in a SharePoint 2013 farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Disable-SPTimerJob | Disables a timer job.
Enable-SPTimerJob | Enables a timer job.
Get-SPTimerJob | Returns timer jobs.
Set-SPTimerJob | Sets the schedule for running a timer job.
Start-SPTimerJob | Runs a timer job once.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Disable-SPTimerJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Disables a timer job.

Disable-SPTimerJob [-Identity] <SPTimerJobPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTimerJobPipeBind

Specifies the timer job to disable.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a timer job (for example, TimerJob1); or an instance of a valid SPTimerJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Disable-SPTimerJob cmdlet disables a timer job.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

--------------------EXAMPLE-----------------------

Copy code
Get-SPTimerJob job-ceip-datacollection | Disable-SPTimerJob

This example disables the timer job named job-ceip-datacollection.

See also

Get-SPTimerJob
Enable-SPTimerJob
Set-SPTimerJob
Start-SPTimerJob


Enable-SPTimerJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Enables a timer job.

Enable-SPTimerJob [-Identity] <SPTimerJobPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTimerJobPipeBind

Specifies the timer job to enable.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a timer job (for example, TimerJob1); or an instance of a valid SPTimerJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Enable-SPTimerJob cmdlet enables a timer job. A timer job must be enabled before it can be started.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

-------------------EXAMPLE---------------------

Copy code
Get-SPTimerJob job-ceip-datacollection | Enable-SPTimerJob

This example enables the timer job named job-ceip-datacollection.

See also

Get-SPTimerJob
Set-SPTimerJob
Start-SPTimerJob
Disable-SPTimerJob


Get-SPTimerJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns timer jobs.

Get-SPTimerJob [[-Identity] <SPTimerJobPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Type <String>] [-WebApplication <SPWebApplicationPipeBind>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPTimerJobPipeBind

Specifies the timer job to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a timer job (for example, TimerJob1); or an instance of a valid SPTimerJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Type

Optional

System.String

Filters to return timer jobs of a specified type.

The type must be a name of a valid timer job type; for example, TimerJob1.

WebApplication

Optional

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Filters to return timer jobs defined for the scope of a specified SharePoint Web application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a SharePoint Web application (for example, MyOfficeApp1); or an instance of a valid SPWebApplication object.

Detailed Description

The Get-SPTimerJob cmdlet reads a specified timer job, timer jobs of a specified type, or timer jobs defined for a specified scope. If no parameters are specified, this cmdlet returns all timer job definitions for the farm.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

---------------------EXAMPLE---------------------

Copy code
Get-SPTimerJob -WebApplication "http://servername" | select Name, DisplayName

This example displays all timer jobs for a specified Web application.

See also

Set-SPTimerJob
Start-SPTimerJob
Disable-SPTimerJob
Enable-SPTimerJob


Set-SPTimerJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets the schedule for running a timer job.

Set-SPTimerJob [-Identity] <SPTimerJobPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Schedule <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTimerJobPipeBind

Specifies the timer job to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a timer job (for example, TimerJob1); or an instance of a valid SPTimerJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Schedule

Required

System.String

Specifies the schedule for running the timer job.

The type must be a valid SharePoint Timer service (SPTimer) schedule in the form of any one of the following schedules:

- Every 5 minutes between 0 and 59

- Hourly between 0 and 59

- Daily at 15:00:00

- Weekly between Fri 22:00:00 and Sun 06:00:00

- Monthly at 15 15:00:00

- Yearly at Jan 1 15:00:00

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPTimerJob cmdlet sets the schedule for running a specified timer job.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

-------------------EXAMPLE------------------------

Copy code
Get-SPTimerJob job-recycle-bin-cleanup | Set-SPTimerJob -Schedule "weekly at sat 5:00"

This example sets the schedule to run the job-recylce-bin-cleanup timer job to weekly at sat 5:00.

See also

Get-SPTimerJob
Start-SPTimerJob
Disable-SPTimerJob
Enable-SPTimerJob


Start-SPTimerJob
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Runs a timer job once.

Start-SPTimerJob [-Identity] <SPTimerJobPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPTimerJobPipeBind

Specifies the timer job to run.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a timer job (for example, TimerJob1); or an instance of a valid SPTimerJob object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Start-SPTimerJob cmdlet runs a timer job once on each front-end Web server where the parent service is provisioned.

Input Types

Return Types

Example

-----------------EXAMPLE----------------

Copy code
Get-SPTimerJob job-recycle-bin-cleanup | Start-SPTimerJob

This example starts the timer job named, job-recycle-bin-cleanup.

See also

Get-SPTimerJob
Set-SPTimerJob
Disable-SPTimerJob
Enable-SPTimerJob


Use Windows PowerShell cmdlets to upgrade to SharePoint 2013 and to migrate data
See also

Summary: Lists Windows PowerShell cmdlets that help perform an upgrade from an earlier version of SharePoint Server 2013 or SharePoint Foundation 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use Windows PowerShell cmdlets to help perform an upgrade from an earlier version of SharePoint Server or SharePoint Foundation.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Test-SPContentDatabase | Tests a content database.
Upgrade-SPContentDatabase | Upgrades a content database.
Get-SPPendingUpgradeActions | Displays pending upgrade actions.
Get-SPSiteUpgradeSessionInfo | Manage or report site upgrade.
Get-SPUpgradeActions | Returns all upgrade actions.
Remove-SPSiteUpgradeSessionInfo | Removes an SPSite object from upgrade.
Repair-SPSite | Activates the RunRepairs method against the referenced SPSite object.
Request-SPUpgradeEvaluationSite | Requests an upgrade evaluation site for a specified site.
Test-SPSite | Activates the RunTests method against a referenced SPSite object.
Upgrade-SPFarm | Activates the Upgrade method for the local farm.
Upgrade-SPSite | Starts the upgrade process on a site collection.
Copy-SPSite | Makes a copy of a site collection.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Upgrade-SPContentDatabase
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Resumes a failed database upgrade or begins a build-to-build database upgrade.

Upgrade-SPContentDatabase [-Identity] <SPContentDatabasePipeBind> [[-ForceDeleteLock] <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-NoB2BSiteUpgrade <SwitchParameter>] [-ServerInstance <SPDatabaseServiceInstancePipeBind>] [-SkipIntegrityChecks <SwitchParameter>] [-UseSnapshot <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
Upgrade-SPContentDatabase [[-ForceDeleteLock] <SwitchParameter>] -Name <String> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-NoB2BSiteUpgrade <SwitchParameter>] [-ServerInstance <SPDatabaseServiceInstancePipeBind>] [-SkipIntegrityChecks <SwitchParameter>] [-UseSnapshot <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the content database to upgrade.

The value must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh or an instance of a valid SPContentDatabase object.

ForceDeleteLock

Optional

System.Management.Automation.SwitchParameter

Forces deletion of locks on the database before the upgrade starts.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

NoB2BSiteUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies to not upgrade all child objects when performing a build-to-build upgrade.

ServerInstance

Optional

Microsoft.SharePoint.PowerShell.SPDatabaseServiceInstancePipeBind

The SQL Server instance that hosts the attached content database.

SkipIntegrityChecks

Optional

System.Management.Automation.SwitchParameter

Specifies the upgrade process not to run the internal integrity checks such as missing templates, and orphan detection as part of the upgrade process.

UseSnapshot

Optional

System.Management.Automation.SwitchParameter

Specifies to use the snapshot method to perform unattached upgrade. This will make a snapshot of the current database and then perform all upgrade operations that apply to the database, and optionally to its contents.

The existing connections to the content database will be set to use the snapshot for the duration of the upgrade, and then switched back after successful completion of upgrade. A failed upgrade reverts the database to its state when the snapshot was taken.

This parameter only works for versions of SQL Server that support creation and use of snapshots, for example, SQL ServerEnterprise edition.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ForceDeleteLock

Optional

System.Management.Automation.SwitchParameter

Forces deletion of locks on the database before the upgrade starts.

Name

Required

System.String

Specifies the name of attached content database.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the web application that hosts the attached content database.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

NoB2BSiteUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies to not upgrade all child objects when performing a build-to-build upgrade.

ServerInstance

Optional

Microsoft.SharePoint.PowerShell.SPDatabaseServiceInstancePipeBind

The SQL Server instance that hosts the attached content database.

SkipIntegrityChecks

Optional

System.Management.Automation.SwitchParameter

Specifies the upgrade process not to run the internal integrity checks such as missing templates, and orphan detection as part of the upgrade process.

UseSnapshot

Optional

System.Management.Automation.SwitchParameter

Specifies to use the snapshot method to perform unattached upgrade. This will make a snapshot of the current database and then perform all upgrade operations that apply to the database, and optionally to its contents.

The existing connections to the content database will be set to use the snapshot for the duration of the upgrade, and then switched back after successful completion of upgrade. A failed upgrade reverts the database to its state when the snapshot was taken.

This parameter only works for versions of SQL Server that support creation and use of snapshots, for example, SQL ServerEnterprise edition.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Upgrade-SPContentDatabase cmdlet to resume a failed database upgrade or begin a build-to-build database upgrade against a SharePoint content database. The Upgrade-SPContentDatabase cmdlet initiates an upgrade of an existing content database that is attached to the current farm. This cmdlet begins a new upgrade session, which can be used either to resume a failed version-to-version or build-to-build upgrade of a content database or to begin a build-to-build upgrade of a content database.

If the database is hosted on a version of SQL Server that supports creation and use of snapshots of the database, this cmdlet can use a database snapshot for build-to-build upgrades. During upgrade, users see a ready-only version of the database, which is the snapshot. After upgrade users see upgraded content.

The default behavior of this cmdlet causes an upgrade of the schema of the database and initiates build-to-build upgrades for all site collections within the specified content database if required. To prevent build-to-build upgrades of site collections, use the NoB2BSiteUpgrade parameter. This cmdlet does not trigger version-to-version upgrade of any site collections.

Input Types

Return Types

Example

--------------------------EXAMPLE 1------------------------------

Copy code
Upgrade-SPContentDatabase WSS_Content

This example upgrades the existing WSS_Content content database schema and then performs only build-to-build upgrade actions on existing site collections if required. This operation does not changed the CompatibilityLevel for existing site collections in this database.

--------------------------EXAMPLE 2------------------------------

Copy code
Upgrade-SPContentDatabase WSS_Content -NoB2BSiteUpgrade

This example upgrades the existing WSS_Content content database schema only. No build-to-build upgrade actions are performed on any site collections. This operation does not change The CompatibilityLevel for existing site collections in this database.

--------------------------EXAMPLE 3------------------------------

Copy code
Upgrade-SPContentDatabase WSS_Content -NoB2BSiteUpgrade -UseSnapshot

This example upgrades the existing WSS_Content content database schema only while using a snapshot of the database to retain read-only access to the content during the upgrade. No build-to-build upgrade actions are performed on any site collections. This operation does not change the CompatibilityLevel for existing site collections in this database.

See also

Dismount-SPContentDatabase
Get-SPContentDatabase
Mount-SPContentDatabase
New-SPContentDatabase
Remove-SPContentDatabase
Set-SPContentDatabase
Test-SPContentDatabase


Get-SPPendingUpgradeActions
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Displays pending upgrade actions.

Get-SPPendingUpgradeActions [-RootObject] <IUpgradable> [-AssignmentCollection <SPAssignmentCollection>] [-Recursive <SwitchParameter>]

Parameters

Parameter Required Type Description

RootObject

Required

Microsoft.SharePoint.Administration.IUpgradable

Specifies a SharePoint object where you check for which upgrade actions are outstanding for that object based on its current upgrade status. This object must be inherited from IUpgradable.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Recursive

Optional

System.Management.Automation.SwitchParameter

Specifies whether to perform the same pending upgrade action checks on each IUpgradable object that occurs under the RootObject parameter that is specified.

Detailed Description

Use the Get-SPPendingUpgradeActions cmdlet to display the current pending upgrade actions for the farm.

Input Types

Return Types

Example

-----------EXAMPLE-------

Copy code
Get-SPFarm | Get-SPPendingUpgradeActions -Recursive


Get-SPSiteUpgradeSessionInfo
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Manage or report site upgrade.

Get-SPSiteUpgradeSessionInfo -ContentDatabase <SPContentDatabasePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-HideWaiting <SwitchParameter>] [-ShowCompleted <SwitchParameter>] [-ShowFailed <SwitchParameter>] [-ShowInProgress <SwitchParameter>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]
Get-SPSiteUpgradeSessionInfo -Site <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

ContentDatabase

Required

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the GUID of the content database from which to list site collections.The type must be a valid database name, in the form SPContentDB01, or a valid GUID (for example, 12345678-90ab-cdef-1234-567890bcdefgh).

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

HideWaiting

Optional

System.Management.Automation.SwitchParameter

Specifies to hide site collections that upgrade has not started.

ShowCompleted

Optional

System.Management.Automation.SwitchParameter

Specifies to show site collections that has completed upgrade.

ShowFailed

Optional

System.Management.Automation.SwitchParameter

Specifies to show site collections that have failed upgrade.

ShowInProgress

Optional

System.Management.Automation.SwitchParameter

Displays site collections that are in the process of being upgraded.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies to limit the result to site collections within the site subscription.

2

Parameter

Required

Type

Description

Site

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Get-SPSiteUpgradeSessionInfo cmdlet to manage or report site upgrade of the farm.

This cmdlet has two modes, get upgrade information for a specific SPSite object or for a given content database.

Input Types

Return Types

Errors

Error | Description

Exceptions

Exceptions | Description

Example

-----------EXAMPLE 1----------

Copy code
$db = Get-SPContentDatabase -Identity wss_content
Copy code
Get-SPSiteUpgradeSessionInfo -ContentDatabase $db

This example returns siteupgradeinfo for every SPContentDatabase returned from Get-SPContentDatabase cmdlet.

-----------EXAMPLE 2----------

Copy code
$site=Get-SPSite -Identity http://localhost
Copy code
Get-SPSiteUpgradeSessionInfo -Site $site

This example returns siteupgradeinfo for every SPSite object returned from Get-SPSite cmdlet.

See also

Remove-SPSiteUpgradeSessionInfo


Get-SPUpgradeActions
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all upgrade actions.

Get-SPUpgradeActions [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPUpgradeActions cmdlet to return all upgrade actions (that is, detail on the action name, type, target object type, schema version, and compatibility level) within the farm.

Input Types

Return Types

Example

--------------EXAMPLE------------

Copy code
Get-SPUpgradeActions

This example returns all upgrade actions within the farm.


Remove-SPSiteUpgradeSessionInfo
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes an SPSite object from upgrade.

Remove-SPSiteUpgradeSessionInfo [-Identity] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site from which to remove the site collections.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPSiteUpgradeSessionInfo cmdlet to remove an SPSite object from the upgrade queue.

If the site is not in the upgrade queue, the returned value is Null.

Input Types

Return Types

Example

------------EXAMPLE-------------

Copy code
Get-SPSite | Remove-SPSiteUpgradeSessionInfo

This example removes the SPSite objects from the farm.

See also

Get-SPSiteUpgradeSessionInfo


Repair-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Activates the RunRepairs method against the referenced SPSite object.

Repair-SPSite [-Identity] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-RuleId <Guid>] [-RunAlways <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site to run a repair.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

RuleId

Optional

System.Guid

Specifies the specific site health rule to run instead of running all applicable rules at once.

RunAlways

Optional

System.Management.Automation.SwitchParameter

Forces a rule to run even if a health check was run.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Repair-SPSite cmdlet runs one or all site collection health checks on the site collection and its contents. This cmdlet automatically repairs issues that it finds.

Run the Test-SPSite cmdlet for reports of rules which were run and a summary of the results.

Input Types

Return Types

Example

------------EXAMPLE 1---------------

Copy code
Repair-SPSite http://<site name</sites/testsite

This example runs all the site collection health checks in repair mode on the http://<site name>/sites/testsite site collection.

------------EXAMPLE 2---------------

Copy code
Repair-SPSite http://<site name>/sites/testsite -Rule "ee967197-ccbe-4c00-88e4-e6fab81145e1"

This example runs just the "Missing Galleries Check" in repair mode on the http://<site name>/sites/testsite site collection.

See also

Test-SPSite


Request-SPUpgradeEvaluationSite
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Requests an upgrade evaluation site for a specified site.

Request-SPUpgradeEvaluationSite [-Identity] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Email <SwitchParameter>] [-NoUpgrade <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the SPSite object for the new upgrade evaluation site collection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Email

Optional

System.Management.Automation.SwitchParameter

Specifies not to send the requester and site collection administrators a notification email when the upgrade evaluation site is ready. The default value is not to send an email message.

NoUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies not to perform an upgrade as part of the process that creates the upgrade evaluation site.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Request-SPUpgradeEvaluationSite cmdlet to initiate a request to create temporary copy of a site collection at an auto-generated URL and upgrade the site collection to a newer experience. Users can view the site to see how their site will work in the new experience.

Input Types

Return Types

Example

-------------EXAMPLE------------

Copy code
$site=Get-SPSite https://contoso.com/sites/TeamSite1
Copy code
Request-SPUpgradeEvaluationSite $site -NoUpgrade -Email

This example requests an upgrade evaluation site the specified contoso.com team site.


Test-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Activates the RunTests method against a referenced SPSite object.

Test-SPSite [-Identity] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-RuleId <Guid>] [-RunAlways <SwitchParameter>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL or GUID of the site to run a test.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

RuleId

Optional

System.Guid

Specifies one specific site health rule to run.

RunAlways

Optional

System.Management.Automation.SwitchParameter

Forces a rule to run even if a health check was run.

Detailed Description

The Test-SPSite cmdlet runs one or all site collection health checks on the site collection and its contents. This cmdlet reports the rules which were run and provides a summary of the results.

To run tests in repair mode, use the Repair-SPSite cmdlet.

Input Types

Return Types

Example

--------------EXAMPLE 1------------

Copy code
Test-SPSite http://<site name>/sites/testsite

This example runs all the site collection health checks on the http://<site name>/sites/testsite site collection.

--------------EXAMPLE 2------------

Copy code
Test-SPSite http://<site name</sites/testsite -Rule "ee967197-ccbe-4c00-88e4-e6fab81145e1"

This example runs just the "Missing Galleries Check" on the http://<site name>/sites/testsite site collection.

See also

Repair-SPSite


Upgrade-SPFarm
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Activates the Upgrade method for the local farm.

Upgrade-SPFarm [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Upgrade-SPFarm cmdlet starts the upgrade process on the local farm.

Input Types

Return Types

Example

-----------EXAMPLE---------

Copy code
Upgrade-SPFarm

This example starts the upgrade process on the local farm.


Upgrade-SPSite
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Starts the upgrade process on a site collection.

Upgrade-SPSite [-Identity] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Email <SwitchParameter>] [-QueueOnly <SwitchParameter>] [-Unthrottled <SwitchParameter>] [-VersionUpgrade <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the SPSite object to run upgrade operations against.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Email

Optional

System.Management.Automation.SwitchParameter

Specifies whether to send mail on completion of the site collection upgrade.

QueueOnly

Optional

System.Management.Automation.SwitchParameter

Unthrottled

Optional

System.Management.Automation.SwitchParameter

Specifies a farm administrator to bypass the throttle which permits a site collection to be upgraded even if there are "too many" site collections in the throttle to be upgraded.

VersionUpgrade

Optional

System.Management.Automation.SwitchParameter

Specifies to perform a version-to-version upgrade on the SPSite object. When this parameter is set, it internally triggers all available build-to-build actions that are associated with the current site collection operating mode. Version-to-version actions follow to bring site collections to the next site collection operating mode inclusive of all new build-to-build actions that are associated with the new site collection operating mode. When this parameter is not set, it triggers only available build-to-build upgrade actions that are associated with the current site collection operating mode.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Upgrade-SPSite cmdlet starts the upgrade process on a site collection.

The Upgrade-SPSite cmdlet activates the upgrade process for the specified SPSite object. You can also use this cmdlet to resume failed upgrades. When you use this cmdlet to initiate upgrade on an SPSite object, the object can be either a build-to-build or version-to-version upgrade. By default, the Upgrade-SPSite cmdlet operates as a build-to-build upgrade. This prevents unexpected version upgrades of site collections if you use this cmdlet after a patching operation. When in version-to-version upgrade mode, site collection health checks are run in repair mode to ensure that the site collection is healthy enough to upgrade successfully. If successful, the remainder of the upgrade occurs.

Input Types

Return Types

Example

-------------EXAMPLE 1----------

Copy code
Upgrade-SPSite http://<site name>/sites/testsite

This example upgrades the existing http://<site name>/sites/testsite site collection by using only build-to-build upgrade actions. The SPSite.CompatibilityLevel will not be changed by this operation.

-------------EXAMPLE 2----------

Copy code
Upgrade-SPSite http://<site name>/sites/testsite -VersionUpgrade

This example upgrades the existing http://<site name>/sites/testsite site collection by using only build-to-build upgrade actions. The SPSite.CompatibilityLevel will not be changed by this operation.


Copy-SPSite
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Makes a copy of a site collection.

Copy-SPSite [-Identity] <SPSitePipeBind> [-TargetUrl] <String> [-AssignmentCollection <SPAssignmentCollection>] [-DestinationDatabase <SPContentDatabasePipeBind>] [-HostHeaderWebApplication <String>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection to copy. This can be a valid URL or GUID.

TargetUrl

Required

System.String

The URL that will be used for the destination copy of the site collection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DestinationDatabase

Optional

Microsoft.SharePoint.PowerShell.SPContentDatabasePipeBind

Specifies the location where the copy will be sent to.

HostHeaderWebApplication

Optional

System.String

Use when the site collection is a host header named site collection that allows the site to land on the correct web application.

Detailed Description

Use the Copy-SPSite cmdlet to make a copy of a site collection from an implied source content database to a specified destination content database.

The copy of the site collection has a new URL and a new SiteID. When you have database snapshot capabilities on a computer runningSQL Server, a temporary snapshot of the source database is created for the duration of the copy to prevent any data changes during the copy process. If you do not have database snapshot capabilities on the server running SQL Server, you can back up the source and restore it to the destination to get the same result.

Input Types

Return Types

Example

--------------EXAMPLE-------------

Copy code
Copy-SPSite http://contoso/sites/OldTeam -DestinationDatabase WSS_Content -TargetUrl http://contoso/sites/NewTeam

This example makes a copy of the http://contoso/sites/OldTeam site collection from its database to the WSS_Content database with the new URL, http://contoso/sites/NewTeam and a new Site ID.

See also

Test-SPSite
Repair-SPSite


Use Windows PowerShell cmdlets to configure the User Profile service in SharePoint Server 2013
See also

Summary: Learn about the Windows PowerShell cmdlets that you can use to configure the User Profile Service in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

In SharePoint Server 2013, the User Profile Service is used to store and process information about users. This information is stored as a collection of user profile properties per user. The user information must be imported into the user profile store before it can be used by various personalization-related features and people search. These properties can be imported from line-of-business applications and directory services (primarily Active Directory directory service and Lightweight Directory Access Protocol (LDAP)).

SharePoint Server 2013 provides an enterprise-wide repository for storing social and expertise tags and for associating those tags with a user's profile. Administrators can control who can tag items on a given site, decide which tags can be used, and delete tags prior to a specific date or based on a specific user profile ID. Tagging relies on the Managed Metadata Service and can be enabled by using either the UI or Windows PowerShell cmdlets.

Profile synchronization synchronizes data in the SharePoint profile store with profile information contained in directory services across the enterprise, such as Active Directory or LDAP. After a connection to the appropriate directory service has been set up, profile synchronization can be scheduled to run on a regular basis.

You can use Windows PowerShell cmdlets for the User Profile Service to create and configure the User Profile Service and profile tags, and to configure permissions and all global settings for the User Profile Service.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name Description

Add-SPSiteSubscriptionProfileConfig

Adds a new site subscription to a User Profile Service application.

Get-SPProfileServiceApplicationSecurity

Returns permission and identity information.

Move-SPProfileManagedMetadataProperty

Moves multiple-string values into a term set.

New-SPProfileServiceApplication

Adds a User Profile Service application to a farm.

New-SPProfileServiceApplicationProxy

Creates a User Profile Service application proxy on the local farm.

Remove-SPSiteSubscriptionProfileConfig

Deletes a site subscription from a User Profile Service application.

Remove-SPSocialItemByDate

Deletes tags, notes, or ratings.

Set-SPProfileServiceApplication

Sets properties of a User Profile Service application.

Set-SPProfileServiceApplicationProxy

Sets properties of a proxy for a User Profile Service application.

Set-SPProfileServiceApplicationSecurity

Sets permission and identity information.

Set-SPSiteSubscriptionProfileConfig

Sets the parameters of a site subscription.

Update-SPProfilePhotoStore

Updates the profile photo store to be compatible with SharePoint Server 2013.

Add-SPPluggableSecurityTrimmer

Adds a pluggable security trimmer to a User Profile service application proxy.

Get-SPPluggableSecurityTrimmer

Gets pluggable security trimmers that have been added to a User Profile service application proxy.

Remove-SPPluggableSecurityTrimmer

Removes pluggable security trimmers that have been added to a User Profile service application proxy.

Add-SPProfileLeader

Adds a company leader.

Get-SPProfileLeader

Returns the current company leaders.

Move-SPSocialComments

Moves social comments.

Remove-SPProfileLeader

Removes a company leader.

Remove-SPProfileSyncConnection

Removes a synchronization connection.

Add-SPProfileSyncConnection

Adds a synchronization connection.

Update-SPRepopulateMicroblogFeedCache

Refreshes the cache.

Update-SPRepopulateMicroblogLMTCache

Refreshes the cache.

Add-SPSocialAppPermissions

Warning:

Do not use this cmdlet.

Remove-SPSocialAppPermissions

Warning:

Do not use this cmdlet.

Get-SPProfilePropertyCollection

Gets all user profile properties.

Start-SPProfileServiceFullReplication

Replicates all selected user profile properties from the source User Profile service application to the destination User Profile service application.

Start-SPProfileServiceIncrementalReplication

Replicates changes for selected profile properties from the source User Profile service application to the destination.

Stop-SPProfileServiceIncrementalReplication

Stops incremental profile replication.

Start-SPProfileServiceRecoveryReplication

Recovers user profiles that failed to replicate during full profile replication.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Add-SPSiteSubscriptionProfileConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Adds a new site subscription to a User Profile Service application.

Add-SPSiteSubscriptionProfileConfig [-Identity] <SPSiteSubscriptionPipeBind> -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MySiteHostLocation <SPSitePipeBind>] [-SynchronizationOU <String>] [-WhatIf [<SwitchParameter>]]
Add-SPSiteSubscriptionProfileConfig [-Identity] <SPSiteSubscriptionPipeBind> -MySiteHostLocation <SPSitePipeBind> -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MySiteHostLocation <SPSitePipeBind>] [-MySiteManagedPath <SPPrefixPipeBind>] [-SiteNamingConflictResolution <String>] [-SynchronizationOU <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the proxy of the User Profile Service application to add the site subscription to.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a User Profile Service application proxy (for example, UserProfileSvcProxy1); or an instance of a valid SPServiceApplicationProxy object.

MySiteHostLocation

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the My Site host for the site subscription is provisioned.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the identifier for the User Profile Service Application proxy where the tenant is to be created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SynchronizationOU

Optional

System.String

Specifies the organizational unit serving the site subscription.

The type must be a valid name of an organizational unit; for example, OrgUnit1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the proxy of the User Profile Service application to add the site subscription to.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a User Profile Service application proxy (for example, UserProfileSvcProxy1); or an instance of a valid SPServiceApplicationProxy object.

MySiteHostLocation

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the My Site host for the site subscription is provisioned.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the identifier for the User Profile Service Application proxy where the tenant is to be created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MySiteManagedPath

Optional

Microsoft.SharePoint.PowerShell.SPPrefixPipeBind

Specifies the managed path where personal sites will be created.

The type must be a valid URL, in the form http://server_name.

SiteNamingConflictResolution

Optional

System.String

Specifies the format to use to name personal sites.

Use one of the following integer values:

1 Personal site collections are to be named based on user names without any conflict resolution. For example, http://portal_site/location/username/

2 Personal site collections are to be based on user names with conflict resolution by using domain names. For example, .../username/ or .../domain_username/

3 Personal site collections are to be named by using domain and user name always, to avoid any conflicts. For example, http://portal_site/location/domain_username/

The default value is 1 (do not resolve conflicts).

SynchronizationOU

Optional

System.String

Specifies the organizational unit serving the site subscription.

The type must be a valid name of an organizational unit; for example, OrgUnit1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Add-SPSiteSubscriptionProfileConfig cmdlet adds a new site subscription to a User Profile Service application.

Input Types

Return Types

Example

--------------EXAMPLE------------------

Copy code
#Get UPA Proxy$pr = Get-SPServiceApplicationProxy | ? {$_.DisplayName.Contains(PartitionedUserProfileApplication_Proxy)}
Copy code
#Add tenant to UPA Add-SPSiteSubscriptionProfileConfig -Identity $sub -ProfileServiceApplicationProxy $pr -MySiteHostLocation http://contoso/my
Copy code
#Create new site subscription$sub = New-SPSiteSubscription

This example creates a new User Profile Service application tenant.

See also

Remove-SPSiteSubscriptionProfileConfig
Set-SPSiteSubscriptionProfileConfig


Get-SPProfileServiceApplicationSecurity
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns permission and identity information.

Get-SPProfileServiceApplicationSecurity -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-Type <String>]

Parameters

Parameter Required Type Description

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the unique identifier for the proxy.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the account under which this service should run. This parameter is mandatory in a hosted-environment and optional in a non-hosted environment.

Type

Optional

System.String

Specifies the type of object to display.

The type is any one of the following values:

- MySiteReaderACL

- MySiteHostReaderACL

- UserACL

Detailed Description

Use the Get-SPProfileServiceApplicationSecurity cmdlet to display permission and identity information for the following User Profile objects:

- Read individual My Sites

- Use Personal Features

- Use Social Features

- Create Personal Site

Input Types

Return Types

Example

-------------------EXAMPLE--------------------

Copy code
$UPAProxy = Get-SPServiceApplicationProxy -Identity "UPA proxy 1"
Copy code
Get- SPProfileServiceApplicationSecurity - ProfileServiceApplicationProxy $UPAProxy -Type MySiteReaderACL

This example displays MySite information on UPA Proxy 1.


Move-SPProfileManagedMetadataProperty
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Moves multiple-string values into a term set.

Move-SPProfileManagedMetadataProperty -Identity <String> -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-AvailableForTagging <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-TermSetName <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

System.String

Specifies the name of the profile property that needs to be migrated to the taxonomy.

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the name of the User Profile Service Application Proxy to use.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

AvailableForTagging

Optional

System.Management.Automation.SwitchParameter

Determines whether the terms in the resulting term set can be used for Managed Metadata tagging. If a term set has more than 30,000 terms, using it for Managed Metadata tagging may lead to performance issues on the client computer. Because a majority of the profile properties may have more than 30,000 terms, the default value is No.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

TermSetName

Optional

System.String

When specified, the term set name is created. If the TermSetName parameter is not specified, the property is mapped to the Keywords term set in Managed Metadata Service.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Move-SPProfileManagedMetadataProperty cmdlet to move multiple-string or single-string property values into a term set that you specify. If you do not specify a term set, the values are moved into the Keywords term set. Any new values you add to the property after running the cmdlet will be moved into the term set that you specified.

After a user profile application has been upgraded from Office SharePoint Server 2007, single-string and multiple-string value properties are not available for use unless the Move-SPProfileManagedMetadataProperty cmdlet is run to map them to term sets within Managed Metadata Service.

Input Types

Return Types

Example

---------------EXAMPLE 1------------------

Copy code
Move-SPProfileManagedMetadataProperty -Identity SPS-Interests -TermSetName Interests -AvailableForTagging -ProfileServiceApplicationProxy dbc4ccf5-b245-4e0f-8696-235402f83260

This example moves values from the SPS-Interests property into a new term set called Interests, and marks that term set as available for tagging.

---------------EXAMPLE 2------------------

Copy code
Get-SPServiceApplicationProxy | ?{$_.DisplayName.Contains("User Profile Service")} | Move-SPProfileManagedMetadataProperty -Identity SPS-Interests -TermSetName Interests -AvailableForTagging

This example performs the same task as Example 1, but pipes the result for the ProfileServiceApplicationProxy parameter by using the Get-SPServiceApplicationProxy cmdlet.


New-SPProfileServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a User Profile Service application to a farm.

New-SPProfileServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MySiteHostLocation <SPSitePipeBind>] [-Name <String>] [-PartitionMode <SwitchParameter>] [-ProfileDBCredentials <PSCredential>] [-ProfileDBFailoverServer <String>] [-ProfileDBName <String>] [-ProfileDBServer <String>] [-ProfileSyncDBCredentials <PSCredential>] [-ProfileSyncDBFailoverServer <String>] [-ProfileSyncDBName <String>] [-ProfileSyncDBServer <String>] [-SocialDBCredentials <PSCredential>] [-SocialDBFailoverServer <String>] [-SocialDBName <String>] [-SocialDBServer <String>] [-WhatIf [<SwitchParameter>]]
New-SPProfileServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> -MySiteHostLocation <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MySiteHostLocation <SPSitePipeBind>] [-MySiteManagedPath <SPPrefixPipeBind>] [-Name <String>] [-PartitionMode <SwitchParameter>] [-ProfileDBCredentials <PSCredential>] [-ProfileDBFailoverServer <String>] [-ProfileDBName <String>] [-ProfileDBServer <String>] [-ProfileSyncDBCredentials <PSCredential>] [-ProfileSyncDBFailoverServer <String>] [-ProfileSyncDBName <String>] [-ProfileSyncDBServer <String>] [-SiteNamingConflictResolution <String>] [-SocialDBCredentials <PSCredential>] [-SocialDBFailoverServer <String>] [-SocialDBName <String>] [-SocialDBServer <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS application pool in which to run the Web service for the service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

Name

Optional

System.String

Specifies the display name for the new User Profile Service application. The name must be a unique name of a User Profile Service application in this farm. The name can be a maximum of 64 characters.

The type must be a valid name of a service application; for example, UserProfileSvcApp1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MySiteHostLocation

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the My Site will be created.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application restrict data by site group. After the PartitionMode parameter is set and the service application is created, it cannot be changed.

ProfileDBCredentials

Optional

System.Management.Automation.PSCredential

Specifies the set of security credentials, such as a user name and a password, that is used to connect to the User Profile database that this cmdlet creates.

The type must be a valid PSCredential object.

ProfileDBName

Optional

System.String

Specifies the name of the database where the User Profile database is created.

ProfileDBServer

Optional

System.String

Specifies the database where the User Profile database will be created.

The type must be a valid name of a SQL Server database; for example, ProfileAppDB1.

ProfileSyncDBCredentials

Optional

System.Management.Automation.PSCredential

Specifies the set of security credentials, such as a user name and a password, that will be used to connect to the Profile Sync database that is specified in the ProfileSyncDBName parameter.

The type must be a valid PSCredential object.

ProfileDBFailoverServer

Optional

System.String

Associates a content database with a specific failover server that is used in conjunction with SQL Server database mirroring. The server name is the required value.

ProfileSyncDBName

Optional

System.String

Specifies the database where the Profile Sync database will be created.

The type must be a valid name of a SQL Server database; for example, ProfileSyncAppDB1.

ProfileSyncDBServer

Optional

System.String

Specifies the database server that will host the Profile Sync database that is specified in the ProfileSyncDBName parameter.

The type must be a valid name of a SQL Server host; for example, SQLServerProfileSyncHost1.

ProfileSyncDBFailoverServer

Optional

System.String

Associates a Profile Sync database with a specific failover server that is used in conjunction with SQL Server database mirroring. The server name is the required value.

SocialDBCredentials

Optional

System.Management.Automation.PSCredential

The set of security credentials, including a user name and a password, that is used to connect to the Social database that this cmdlet creates.

The type must be a valid PSCredential object.

SocialDBName

Optional

System.String

Specifies the database where the Social database will be created.

The type must be a valid name of a SQL Server host; for example, SQLServerSocialHost1.

SocialDBServer

Optional

System.String

Specifies the database server that will host the Social database that is specified in SocialDBName.

The type must be a valid name of a SQL Server host; for example, SQLServerSocialHost1.

SocialDBFailoverServer

Optional

System.String

Associates a Social database with a specific failover server that is used in conjunction with SQL Server database mirroring. The server name is the required value.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS application pool in which to run the Web service for the service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

Name

Optional

System.String

Specifies the display name for the new User Profile Service application. The name must be a unique name of a User Profile Service application in this farm. The name can be a maximum of 64 characters.

The type must be a valid name of a service application; for example, UserProfileSvcApp1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MySiteHostLocation

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the My Site will be created.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

MySiteManagedPath

Optional

System.String

Specifies the managed path where personal sites will be created.

The type must be a valid URL, in the form http://server_name.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application restrict data by site group. After the PartitionMode parameter is set and the service application is created, it cannot be changed.

ProfileDBCredentials

Optional

System.Management.Automation.PSCredential

Specifies the set of security credentials, such as a user name and a password, that is used to connect to the User Profile database that this cmdlet creates.

The type must be a valid PSCredential object.

ProfileDBName

Optional

System.String

Specifies the name of the database where the User Profile database is created.

ProfileDBServer

Optional

System.String

Specifies the database where the User Profile database will be created.

The type must be a valid name of a SQL Server database; for example, ProfileAppDB1.

ProfileSyncDBCredentials

Optional

System.Management.Automation.PSCredential

Specifies the set of security credentials, such as a user name and a password, that will be used to connect to the Profile Sync database that is specified in the ProfileSyncDBName parameter.

The type must be a valid PSCredential object.

ProfileDBFailoverServer

Optional

System.String

Associates a content database with a specific failover server that is used in conjunction with SQL Server database mirroring. The server name is the required value.

ProfileSyncDBName

Optional

System.String

Specifies the database where the Profile Sync database will be created.

The type must be a valid name of a SQL Server database; for example, ProfileSyncAppDB1.

ProfileSyncDBServer

Optional

System.String

Specifies the database server that will host the Profile Sync database that is specified in the ProfileSyncDBName parameter.

The type must be a valid name of a SQL Server host; for example, SQLServerProfileSyncHost1.

ProfileSyncDBFailoverServer

Optional

System.String

Associates a Profile Sync database with a specific failover server that is used in conjunction with SQL Server database mirroring. The server name is the required value.

SiteNamingConflictResolution

Optional

System.String

Specifies the format to use to name personal sites.

Use one of the following integer values:

1 Personal site collections are to be based on user names without any conflict resolution. For example, http://portal_site/location/username/

2 Personal site collections are to be based on user names with conflict resolution by using domain names. For example, .../username/ or .../domain_username/

3 Personal site collections are to be named by using domain and user name always, to avoid any conflicts. For example, http://portal_site/location/domain_username/

The default value is 1 (do not resolve conflicts).

SocialDBCredentials

Optional

System.Management.Automation.PSCredential

The set of security credentials, including a user name and a password, that is used to connect to the Social database that this cmdlet creates.

The type must be a valid PSCredential object.

SocialDBName

Optional

System.String

Specifies the database where the Social database will be created.

The type must be a valid name of a SQL Server host; for example, SQLServerSocialHost1.

SocialDBServer

Optional

System.String

Specifies the database server that will host the Social database that is specified in SocialDBName.

The type must be a valid name of a SQL Server host; for example, SQLServerSocialHost1.

SocialDBFailoverServer

Optional

System.String

Associates a Social database with a specific failover server that is used in conjunction with SQL Server database mirroring. The server name is the required value.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPProfileServiceApplication cmdlet adds and creates a new profile service application, or creates an instance of a profile service.

Input Types

Return Types

Example

----------------------EXAMPLE-------------------------

Copy code
$appPool = New-SPIisWebServiceApplicationPool -Name HostedAppPool -Account (Get-SPManagedAccount "contoso\AppPoolAccount")New-SPProfileServiceApplication -Name PartitionedUserProfileApplication -PartitionMode -ApplicationPool $appPool

This example creates a new User Profile Service application.

See also

Set-SPProfileServiceApplication


New-SPProfileServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a User Profile Service application proxy on the local farm.

New-SPProfileServiceApplicationProxy -Uri <Uri> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-Name <String>] [-PartitionMode <SwitchParameter>] [-WhatIf [<SwitchParameter>]]
New-SPProfileServiceApplicationProxy -ServiceApplication <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-Name <String>] [-PartitionMode <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Uri

Required

System.Uri

The URI of the remote user profile service application this proxy should communicate with. This value is required only if you plan to connect a User Profile Service application from a remote farm.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the User Profile Service application proxy be added to the default proxy group for the local farm.

Name

Optional

System.String

Specifies the display name for the new User Profile Service application. The name that you use must be a unique name of a User Profile Service application in this farm. The name can be a maximum of 128 characters.

The type must be a name of a valid User Profile Service application proxy; for example, UserProfileSvcProxy1.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application restrict data by site group. After the PartitionMode parameter is set and the service application is created, it cannot be changed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the local User Profile Service application that is associated with the new proxy.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription User Profile Service application (for example, ProfileSvcApp1); or an instance of a valid SPServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the User Profile Service application proxy be added to the default proxy group for the local farm.

Name

Optional

System.String

Specifies the display name for the new User Profile Service application. The name that you use must be a unique name of a User Profile Service application in this farm. The name can be a maximum of 128 characters.

The type must be a name of a valid User Profile Service application proxy; for example, UserProfileSvcProxy1.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application restrict data by site group. After the PartitionMode parameter is set and the service application is created, it cannot be changed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPProfileServiceApplicationProxy creates a User Profile Service application proxy on the local farm. The proxy is added to the default proxy group for the local farm.

Input Types

Return Types

Example

--------------------EXAMPLE---------------------

Copy code
$app = Get-SPServiceApplication -Name PartitionedUserProfileApplication. New-SPProfileServiceApplicationProxy -Name PartitionedUserProfileApplication_Proxy -ProfileServiceApplication $app -PartitionMode

This example creates a new User Profile Service application proxy.

See also

Set-SPProfileServiceApplicationProxy


Remove-SPSiteSubscriptionProfileConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Deletes a site subscription from a User Profile Service application.

Remove-SPSiteSubscriptionProfileConfig [-Identity] <SPSiteSubscriptionPipeBind> -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]
Remove-SPSiteSubscriptionProfileConfig -ServiceContext <SPServiceContextPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the proxy of the User Profile Service application that contains the site subscription to delete.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a service application proxy (for example, UserProfileSvcProxy1); or an instance of a valid SPServiceApplicationProxy object.

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Name of the proxy of the User Profile Service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

ServiceContext

Required

Microsoft.SharePoint.PowerShell.SPServiceContextPipeBind

Specifies the service context for the User Profile service application to connect to.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPSiteSubscriptionProfileConfig cmdlet deletes a site subscription from a User Profile Service application.

Input Types

Return Types

Example

----------------EXAMPLE-----------------

Copy code
$sub = Get-SPSiteSubscription http://contoso/my
Copy code
$pr = Get-SPServiceApplicationProxy | ? {$_.DisplayName.Contains(PartitionedUserProfileApplication_Proxy)}Remove-SPSiteSubscriptionProfileConfig -Identity $sub -ProfileServiceApplicationProxy $pr

This example removes tenant data.

See also

Add-SPSiteSubscriptionProfileConfig
Set-SPSiteSubscriptionProfileConfig


Remove-SPSocialItemByDate
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Deletes tags, notes, or ratings.

Remove-SPSocialItemByDate -EndDate <DateTime> -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-RemoveComments <$true | $false>] [-RemoveRatings <$true | $false>] [-RemoveTags <$true | $false>] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

EndDate

Required

System.DateTime

Specifies the date before which data is to be deleted.

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the unique identifier for the proxy.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

RemoveComments

Optional

System.Boolean

When this parameter is specified, comments will be removed.

Valid values for this parameter are:

-- $True

-- $False

RemoveRatings

Optional

System.Boolean

When this parameter is specified, ratings will be removed.

Valid values for this parameter are:

--$True

--$False

RemoveTags

Optional

System.Boolean

When this parameter is specified, tags will be removed.

Valid values for this parameter are:

--$True

--$False

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the account under which this service should run. This parameter is mandatory in a hosted-environment and optional in a non-hosted environment.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPSocialItemByDate cmdlet to delete, tags, notes, ratings created before a particular date.

Input Types

Return Types

Example

--------------EXAMPLE------------

Copy code
Remove-SPSocialItemByDate -RemoveTags 1 -ProfileServiceApplicationProxy c6681d53-e6c4-432f-9f31-22d3de81b00c -EndDate 9/15/2009

This example removes tags before 9/15/09 from the specified User Profile Service Application Proxy.


Set-SPProfileServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a User Profile Service application.

Set-SPProfileServiceApplication [-Identity] <SPServiceApplicationPipeBind> [-ApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-GetNonImportedObjects <$true | $false>] [-MySiteHostLocation <SPSitePipeBind>] [-Name <String>] [-ProfileDBCredentials <PSCredential>] [-ProfileDBFailoverServer <String>] [-ProfileSyncDBCredentials <PSCredential>] [-ProfileSyncDBFailoverServer <String>] [-PurgeNonImportedObjects <$true | $false>] [-SocialDBCredentials <PSCredential>] [-SocialDBFailoverServer <String>] [-UseOnlyPreferredDomainControllers <$true | $false>] [-WhatIf [<SwitchParameter>]]
Set-SPProfileServiceApplication [-Identity] <SPServiceApplicationPipeBind> -MySiteHostLocation <SPSitePipeBind> [-ApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-GetNonImportedObjects <$true | $false>] [-MySiteHostLocation <SPSitePipeBind>] [-MySiteManagedPath <SPPrefixPipeBind>] [-Name <String>] [-ProfileDBCredentials <PSCredential>] [-ProfileDBFailoverServer <String>] [-ProfileSyncDBCredentials <PSCredential>] [-ProfileSyncDBFailoverServer <String>] [-PurgeNonImportedObjects <$true | $false>] [-SiteNamingConflictResolution <String>] [-SocialDBCredentials <PSCredential>] [-SocialDBFailoverServer <String>] [-UseOnlyPreferredDomainControllers <$true | $false>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the User Profile Service application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubscriptionSettingsApp1); or an instance of a valid SPServiceApplication object.

ApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS application pool in which to run the Web service for the service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

GetNonImportedObjects

Optional

System.Boolean

Specifies whether to inform the users that did not come from the import pipeline and will be marked for deletion. The list of users marked for deletion is displayed to the console window.

MySiteHostLocation

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the My Site will be provisioned.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscription1); or an instance of a valid SiteSubscription object.

ProfileDBCredentials

Optional

System.Management.Automation.PSCredential

Specifies the set of security credentials, such as a user name and a password, that is used to connect to the User Profile database that this cmdlet creates.

The type must be a valid PSCredential object.

ProfileSyncDBCredentials

Optional

System.Management.Automation.PSCredential

Specifies the set of security credentials, such as a user name and a password, that will be used to connect to the Profile Sync database that is specified in the ProfileSyncDBName parameter.

The type must be a valid PSCredential object.

ProfileSyncDBFailoverServer

Optional

System.String

Specifies the name of the failover SQL server for Profile database. It is used to build the connection string for the Profile database.

PurgeNonImportedObjects

Optional

System.Boolean

Specifies whether to mark the non-imported users in the profile store for deletion and then inform the users that did not come from the import pipeline which will be marked for deletion. The list of users marked for deletion is displayed on the console window

SocialDBCredentials

Optional

System.Management.Automation.PSCredential

The set of security credentials, including a user name and a password, that is used to connect to the Social database that this cmdlet creates.

The type must be a valid PSCredential object.

SocialDBFailoverServer

Optional

System.String

Specifies the name of the failover SQL server for Social database. It is used to build the connection string for the Social database.

Name

Optional

System.String

Specifies the display name for the new User Profile Service application. The name that you use must be a unique name of a User Profile Service application in this farm. The name can be a maximum of 128 characters.

The type must be a valid name of a User Profile Service application; for example, UserProfileSvcApp1.

UseOnlyPreferredDomainControllers

Optional

System.Boolean

Restricts profile synchronization communication to a specific domain controller.

The valid values are $true or $false.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the User Profile Service application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubscriptionSettingsApp1); or an instance of a valid SPServiceApplication object.

ApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS application pool in which to run the Web service for the service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

GetNonImportedObjects

Optional

System.Boolean

Specifies whether to inform the users that did not come from the import pipeline and will be marked for deletion. The list of users marked for deletion is displayed to the console window.

MySiteHostLocation

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the My Site will be provisioned.

The type must be a valid URL, in the form http://server_name; a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a site subscription (for example, SiteSubscription1); or an instance of a valid SiteSubscription object.

MySiteManagedPath

Optional

Microsoft.SharePoint.PowerShell.SPPrefixPipeBind

Specifies the managed path location of personal sites.

The type must be a valid URL, in the form http://server_name.

ProfileDBCredentials

Optional

System.Management.Automation.PSCredential

Specifies the set of security credentials, such as a user name and a password, that is used to connect to the User Profile database that this cmdlet creates.

The type must be a valid PSCredential object.

ProfileSyncDBCredentials

Optional

System.Management.Automation.PSCredential

Specifies the set of security credentials, such as a user name and a password, that will be used to connect to the Profile Sync database that is specified in the ProfileSyncDBName parameter.

The type must be a valid PSCredential object.

ProfileSyncDBFailoverServer

Optional

System.String

Specifies the name of the failover SQL server for Profile database. It is used to build the connection string for the Profile database.

PurgeNonImportedObjects

Optional

System.Boolean

Specifies whether to mark the non-imported users in the profile store for deletion and then inform the users that did not come from the import pipeline which will be marked for deletion. The list of users marked for deletion is displayed on the console window

SiteNamingConflictResolution

Optional

System.String

Specifies the format to use to name personal sites.

Use one of the following integer values:

1--Personal site collections are to be based on user names without any conflict resolution. For example, http://portal_site/location/username/

2-- Personal site collections are to be based on user names with conflict resolution by using domain names. For example, .../username/ or .../domain_username/

3 Personal site collections are to be named by using domain and user name always, to avoid any conflicts. For example, http://portal_site/location/domain_username/

The default value is 1 (do not resolve conflicts).

SocialDBCredentials

Optional

System.Management.Automation.PSCredential

The set of security credentials, including a user name and a password, that is used to connect to the Social database that this cmdlet creates.

The type must be a valid PSCredential object.

SocialDBFailoverServer

Optional

System.String

Specifies the name of the failover SQL server for Social database. It is used to build the connection string for the Social database.

Name

Optional

System.String

Specifies the display name for the new User Profile Service application. The name that you use must be a unique name of a User Profile Service application in this farm. The name can be a maximum of 128 characters.

The type must be a valid name of a User Profile Service application; for example, UserProfileSvcApp1.

UseOnlyPreferredDomainControllers

Optional

System.Boolean

Restricts profile synchronization communication to a specific domain controller.

The valid values are $true or $false.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPProfileServiceApplication cmdlet sets properties of a User Profile Service application.

Input Types

Return Types

Example

---------------EXAMPLE---------------------

Copy code
$ap = Get-SPServiceApplication -Name PartitionedUserProfileApplication
Copy code
#Change the name of the applicationSet-SPProfileServiceApplication -Identity $ap -Name PartitionedUserProfileApplication2

This example sets profile information by using the specified identity.

See also

New-SPProfileServiceApplication


Set-SPProfileServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a proxy for a User Profile Service application.

Set-SPProfileServiceApplicationProxy [-Identity] <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-MySiteHostLocation <SPSitePipeBind>] [-MySiteManagedPath <SPPrefixPipeBind>] [-Name <String>] [-SiteNamingConflictResolution <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the User Profile Service application proxy to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a service application proxy (for example, UserProfileSvcProxy1); or an instance of a valid SPServiceApplicationProxy object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the User Profile Service application proxy is added to the default proxy group for the local farm.

MySiteHostLocation

Optional

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the My Site will be created.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

MySiteManagedPath

Optional

Microsoft.SharePoint.PowerShell.SPPrefixPipeBind

Specifies the managed path location of personal sites.

The type must be a valid URL, in the form http://server_name.

Name

Optional

System.String

Specifies the display name for the User Profile Service application. The name that you use must be a unique name of a User Profile Service application in this farm. The name can be a maximum of 128 characters.

The type must be a name of a valid service application proxy; for example, UserProfileSvcProxy1.

SiteNamingConflictResolution

Optional

System.String

Specifies the format to use to name personal sites.

Use one of the following integer values:

1 Personal site collections are to be based on user names without any conflict resolution. For example, http://portal_site/location/username/

2 Personal site collections are to be based on user names with conflict resolution by using domain names. For example, .../username/ or .../domain_username/

3 Personal site collections are to be named by using domain and user name always, to avoid any conflicts. For example, http://portal_site/location/domain_username/

The default value is 1 (do not resolve conflicts).

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPProfileServiceApplicationProxy cmdlet sets properties of a proxy for a User Profile Service application.

Input Types

Return Types

Example

----------------EXAMPLE---------------------

Copy code
#Get UPA Proxy$pr = Get-SPServiceApplicationProxy | ? {$_.DisplayName.Contains(PartitionedUserProfileApplication_Proxy)}
Copy code
#Change the name of the proxySet-SPProfileServiceApplicationProxy -Identity $pr -Name PartitionedUserProfileApplication_Proxy2

This example sets a proxy for the User Profile Service application.

See also

New-SPProfileServiceApplicationProxy


Set-SPProfileServiceApplicationSecurity
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets permission and identity information.

Set-SPProfileServiceApplicationSecurity -Identity <SPObjectSecurity> -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-Type <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.Administration.AccessControl.SPObjectSecurity

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the unique identifier for the proxy.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the account under which this service should run. This parameter is mandatory in a hosted-environment and optional in a non-hosted environment.

Type

Optional

System.String

Specifies the type of object to display.

The type is any one of the following values:

- MySiteReaderACL

- UserACL

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPProfileServiceApplictionSecurity cmdlet to set permission and identity information for the following User Profile objects:

- Read individual My Sites

- Use Personal Features

- Use Social Features

- Create Personal Site

Input Types

Return Types

Example

Copy code


Set-SPSiteSubscriptionProfileConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Sets the parameters of a site subscription.

Set-SPSiteSubscriptionProfileConfig [-Identity] <SPSiteSubscriptionPipeBind> -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MySiteHostLocation <SPSitePipeBind>] [-SynchronizationOU <String>] [-WhatIf [<SwitchParameter>]]
Set-SPSiteSubscriptionProfileConfig [-Identity] <SPSiteSubscriptionPipeBind> -MySiteHostLocation <SPSitePipeBind> -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MySiteHostLocation <SPSitePipeBind>] [-MySiteManagedPath <SPPrefixPipeBind>] [-SiteNamingConflictResolution <String>] [-SynchronizationOU <String>] [-WhatIf [<SwitchParameter>]]

Parameters

1

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the proxy of the User Profile Service application that contains the site subscription to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a User Profile Service application proxy (for example, UserProfileSvcProxy1); or an instance of a valid SPServiceApplicationProxy object.

MySiteHostLocation

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the My Site host for the site subscription is provisioned.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the name of the proxy for the User Profile Service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SynchronizationOU

Optional

System.String

Specifies the organizational unit that serves the site subscription.

The type must be a valid name of an organizational unit; for example, OrgUnit1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

2

Parameter

Required

Type

Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the proxy of the User Profile Service application that contains the site subscription to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a User Profile Service application proxy (for example, UserProfileSvcProxy1); or an instance of a valid SPServiceApplicationProxy object.

MySiteHostLocation

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the site collection where the My Site host for the site subscription is provisioned.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; or a valid URL, in the form http://server_name; or an instance of a valid SPSite object.

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the name of the proxy for the User Profile Service application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MySiteManagedPath

Optional

Microsoft.SharePoint.PowerShell.SPPrefixPipeBind

Specifies the managed path where personal sites will be created.

The type must be a valid URL, in the form http://server_name.

SiteNamingConflictResolution

Optional

System.String

Specifies the format to use to name personal sites.

Use one of the following integer values:

1-- Personal site collections to be named after user names without any conflict resolution. For example, http://portal_site/location/username/

2-- Personal site collections to be named after user names with conflict resolution by using domain names. For example, .../username/ or .../domain_username/

3-- Personal site collections to be named using domain and username always to avoid any conflicts. For example, http://portal_site/location/domain_username/

The default value is 1 (do not resolve conflicts).

SynchronizationOU

Optional

System.String

Specifies the organizational unit that serves the site subscription.

The type must be a valid name of an organizational unit; for example, OrgUnit1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Set-SPSiteSubscriptionProfileConfig cmdlet sets the parameters of a site subscription.

Input Types

Return Types

Example

Copy code

  See also
Add-SPSiteSubscriptionProfileConfig
Remove-SPSiteSubscriptionProfileConfig


Update-SPProfilePhotoStore
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Updates the profile photo store to be compatible with SharePoint Server 2013.

Update-SPProfilePhotoStore -MySiteHostLocation <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-CreateThumbnailsForImportedPhotos <$true | $false>] [-NewBaseUri <Uri>] [-NoDelete <$true | $false>] [-OldBaseUri <Uri>]

Parameters

Parameter Required Type Description

MySiteHostLocation

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the URL for the My Site host location where the photos are to be uploaded.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

CreateThumbnailsForImportedPhotos

Optional

System.Boolean

Creates thumbnails for all the imported user profile pictures.

NewBaseUri

Optional

System.Uri

Specifies the new URL for profile pictures. For example, http://server2/.

NoDelete

Optional

System.Boolean

When the value is set to true, it specifies the deletion of imported user profile pictures after creating thumbnails for them.

OldBaseUri

Optional

System.Uri

Specifies the old URL for profile pictures. For example, http://server1/.

Detailed Description

After upgrading from Office SharePoint Server 2007 to SharePoint Server 2013, run the Update-SPProfilePhotoStore cmdlet to ensure that the SharePoint profile photo store is compatible with SharePoint Server 2013. The Update-SPProfilePhotoStore cmdlet should be used only after an upgrade from Office SharePoint Server 2007 has completed. When the Update-SPProfilePhotoStore cmdlet is used, three thumbnail versions with predictable sizes and names are created from the original photo, the new photos are placed into the My Site Host's User Photos library, and the property value in the profile database is updated.

During the operation, the original image is left as-is. If the operation fails for certain users for any reason, it continues on to the next user.

During the migration of profile photos from one server URL to another, one can use the OldBaseUri and NewBaseUri parameters. You just need to specify the starting portion of the URL that has changed from old to new and an attempt to rebase the profile picture URLs will occur.

For example, OldBaseUri: http://server1/my/ProfilePhotos; NewBaseUri: http://server1/my/NewLocation/ProfilePhotos

Input Types

Return Types

Example

------------------EXAMPLE-------------------

Copy code
Update-SPProfilePhotoStore -MySiteHostLocation http://mysites

This example uploads photos to a specified My Site host location.


Add-SPPluggableSecurityTrimmer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a pluggable security trimmer to a Profile service application proxy.

Add-SPPluggableSecurityTrimmer [-UserProfileApplicationProxyId] <Guid> -PlugInId <Int32> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-CustomProperties <NameValueCollection>] [-QualifiedTypeName <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

UserProfileApplicationProxyId

Required

System.Guid

Specifies the ID of the User Profile service application proxy to which you are adding the pluggable security trimmer.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

PlugInId

Required

System.Int32

The index of the pluggable security trimmer must have an integer value greater than or equal to zero.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

QualifiedTypeName

Optional

System.String

Specifies the qualified type name of the class that implements the pluggable security trimmer.

The type must be a valid qualified type name, in the form Microsoft.Office.Server.SocialData.SocialSecurityTrimmer,Microsoft.Office.Server.UserProfiles,Version=14.0.0.0,Culture=neutral,PublicKeyToken=71e9bce111e9429c.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Add-SPPluggableSecurityTrimmer cmdlet to add a specified pluggable security trimmer to a User Profile service application proxy.

Input Types

Return Types

Example

----------------EXAMPLE 1--------------------

Copy code
$pr = Get-SPServiceApplicationProxy | ? {$_.TypeName.Contains("Profile")}
Copy code
Add-SPPluggableSecurityTrimmer -UserProfileApplicationProxyId $pr.Id -PlugInId 0

This example adds a pluggable security trimmer that is related to the User Profile service application proxy.

-----------------EXAMPLE 2----------------------

Copy code
$proxy = Get-SPServiceApplicationProxy | ? {$_.TypeName.Contains("Profile")} $proxy.Id
Copy code
Add-SPPluggableSecurityTrimmer -UserProfileApplicationProxyId $proxy.Id -PlugInId 0

This example turns on security trimming in a User Profile Service Application.

See also

Get-SPPluggableSecurityTrimmer
Remove-SPPluggableSecurityTrimmer


Get-SPPluggableSecurityTrimmer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Gets pluggable security trimmers added to a profile service application proxy.

Get-SPPluggableSecurityTrimmer [-UserProfileApplicationProxyId] <Guid> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

UserProfileApplicationProxyId

Required

System.Guid

Specifies the ID of the User Profile service application proxy to which the pluggable security trimmers have been added.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPPluggableSecurityTrimmer cmdlet to list the pluggable security trimmers that have been added to a User Profile service application proxy.

Input Types

Return Types

Example

-------------------EXAMPLE---------------------

Copy code
$pr = Get-SPServiceApplicationProxy | ? {$_.TypeName.Contains("Profile")}
Copy code
Get-SPPluggableSecurityTrimmer -UserProfileApplicationProxyId $pr.Id

This example gets a list of the pluggable security trimmers that are associated with the User Profile service application proxy.

See also

Add-SPPluggableSecurityTrimmer
Remove-SPPluggableSecurityTrimmer


Remove-SPPluggableSecurityTrimmer
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a pluggable security trimmer from a profile service application proxy.

Remove-SPPluggableSecurityTrimmer [-UserProfileApplicationProxyId] <Guid> -PlugInId <Int32> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

UserProfileApplicationProxyId

Required

System.Guid

Specifies the ID of the User Profile service application proxy from which the pluggable security trimmer is removed.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

PlugInId

Required

System.Int32

The index of the pluggable security trimmer must have an integer value greater than or equal to zero.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Remove-SPPluggableSecurityTrimmer cmdlet to remove a specified pluggable security trimmer from a User Profile service application proxy.

Input Types

Return Types

Example

-----------------EXAMPLE 1----------------------

Copy code
$pr = Get-SPServiceApplicationProxy | ? $_.TypeName.Contains("Profile")}
Copy code
Remove-SPPluggableSecurityTrimmer -UserProfileApplicationProxyId $pr.Id -PlugInId 0

This example removes a pluggable security trimmer.

-----------------EXAMPLE 2----------------------

Copy code
$proxy = Get-SPServiceApplicationProxy | ? {$_.TypeName.Contains("Profile")} $proxy.Id
Copy code
Remove-SPPluggableSecurityTrimmer -UserProfileApplicationProxyId $proxy.Id -PlugInId 0

This example turns off security trimming in a User Profile Service Application.

See also

Add-SPPluggableSecurityTrimmer
Get-SPPluggableSecurityTrimmer


Add-SPProfileLeader
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Adds a company leader.

Add-SPProfileLeader [-ProfileServiceApplicationProxy] <SPServiceApplicationProxyPipeBind> [-Name] <SPProfileLeaderPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the name of the User Profile Service Application Proxy to use.

Name

Required

Microsoft.Office.Server.UserProfiles.PowerShell.SPProfileLeaderPipeBind

Specifies the account name to be added as a leader for the new User Profile Service application. For example, Contoso\Joe.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the account under which this service should run. This parameter is mandatory in a hosted-environment and optional in a non-hosted environment.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Use the Add-SPProfileLeader cmdlet to add a user as the company leader.

For additional information about SPProfileLeader cmdlets, see The *-SPProfileLeader Windows PowerShell cmdlets in SharePoint Server 2010 SP1 (http://go.microsoft.com/fwlink/p/?LinkId=226295).

Note:

After you use the Add-SPProfileLeader cmdlet to add a company leader, you have to complete a full crawl of your content sources for the changes to take effect.

Input Types

Return Types

Example

---------EXAMPLE------------

Copy code
$upaProxy = Get-SPServiceApplicationProxy 1232b6f7-b9ff-99ad-0cd0-fg1g67h981aq
Copy code
Add-SPProfileLeader -ProfileServiceApplicationProxy $upaProxy -Name "contoso\janedow"

This example adds a company leader named, Jane Dow.

See also

Get-SPProfileLeader
Remove-SPProfileLeader


Get-SPProfileLeader
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the current company leaders.

Get-SPProfileLeader [-ProfileServiceApplicationProxy] <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]

Parameters

Parameter Required Type Description

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the name of the User Profile Service Application Proxy to use.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the account under which this service should run. This parameter is mandatory in a hosted-environment and optional in a non-hosted environment.

Detailed Description

This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Use the Get-SPProfileLeader cmdlet to display the current company leaders.

For additional information about SPProfileLeader cmdlets, see The *-SPProfileLeader Windows PowerShell cmdlets in SharePoint Server 2010 SP1 (http://go.microsoft.com/fwlink/p/?LinkId=226295).

Input Types

Return Types

Example

----------EXAMPLE-----------------

Copy code
$upaProxy = Get-SPServiceApplicationProxy 1232b6f7-b9ff-99ad-0cd0-fg1g67h981aq
Copy code
Get-SPProfileLeader -ProfileServiceApplicationProxy $upaProxy

This example returns a company leader from the specific user profile service application as indicated by the variable, $upaProxy.

See also

Add-SPProfileLeader
Remove-SPProfileLeader


Move-SPSocialComments
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Moves social comments.

Move-SPSocialComments -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-NewUrl <String>] [-OldUrl <String>] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the name of the User Profile Service Application Proxy to use.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

NewUrl

Optional

System.String

Specifies the target URI to which the social notes will be moved.

OldUrl

Optional

System.String

Specifies the source URI from which the social notes will be moved.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the account under which this service should run. This parameter is mandatory in a hosted-environment and optional in a non-hosted environment.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Use the Move-SPSocialComments cmdlet to move social comments from one page to another page.

Note:

This cmdlet does not move Tags or Ratings.

Input Types

Return Types

Example

-----------EXAMPLE-----------

Copy code
$upaProxy = Get-SPServiceApplicationProxy 1232b6f7-b9ff-99ad-0cd0-fg1g67h981aq
Copy code
Move-SPSocialComments -ProfileServiceApplicationProxy $upaProxy -OldUrl "http://contoso/Pages/oldtest.aspx" -NewUrl "http://contoso/Pages/newtest.aspx"
Copy code

This example moves social comments from oldtest.aspx to newtest.aspx.


Remove-SPProfileLeader
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Remove a company leader.

Remove-SPProfileLeader [-ProfileServiceApplicationProxy] <SPServiceApplicationProxyPipeBind> [-Name] <SPProfileLeaderPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-SiteSubscription <SPSiteSubscriptionPipeBind>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the name of the User Profile Service Application Proxy to use.

Name

Required

Microsoft.Office.Server.UserProfiles.PowerShell.SPProfileLeaderPipeBind

Specifies the account name to be removed as a leader for the new User Profile Service application. For example, Contoso\Joe.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the account under which this service should run. This parameter is mandatory in a hosted-environment and optional in a non-hosted environment.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Use the Remove-SPProfileLeader cmdlet to remove a user as the company leader.

For additional information about SPProfileLeader cmdlets, see The *-SPProfileLeader Windows PowerShell cmdlets in SharePoint Server 2010 SP1 (http://go.microsoft.com/fwlink/p/?LinkId=226295).

Input Types

Return Types

Example

---------------EXAMPLE------------

Copy code
$upaProxy = Get-SPServiceApplicationProxy 1232b6f7-b9ff-99ad-0cd0-fg1g67h981aq
Copy code
Remove-SPProfileLeader -ProfileServiceApplicationProxy $upaProxy -Name "contoso\janedow"

This example removes the user "Jane Dow" from the leaders list for a specific user profile service application.

See also

Add-SPProfileLeader
Get-SPProfileLeader


Remove-SPProfileSyncConnection
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a synchronization connection.

Remove-SPProfileSyncConnection [-ProfileServiceApplication] <SPServiceApplicationPipeBind> -ConnectionDomain <String> -ConnectionForestName <String> -ConnectionPassword <SecureString> -ConnectionSynchronizationOU <String> -ConnectionUserName <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ConnectionNamingContext <String>] [-ConnectionServerName <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ProfileServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the name of the User Profile service application.

ConnectionDomain

Required

System.String

Specifies the NetBIOS name of the domain you are connecting to.

ConnectionForestName

Required

System.String

Specifies the forest name you are connecting to.

ConnectionPassword

Required

System.Security.SecureString

Specifies the password of the account used for directory connection.

ConnectionSynchronizationOU

Required

System.String

Specifies the top level organizational unit (OU) that you would like to synchronize. The value must be a domain name and you can only include one container per command.

ConnectionUserName

Required

System.String

Specifies the user name to be used for the synchronization connection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ConnectionNamingContext

Optional

System.String

Specifies the naming context of the directory information tree to connect to.

ConnectionServerName

Optional

System.String

Specifies the name of the connection server.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Use the Remove-SPProfileSyncConnection cmdlet to remove a User Profile synchronization connection.

For additional information about profile synchronization connections, see Overview of profile synchronization in SharePoint Server 2013

Note:

This cmdlet only works with Active Directory Synchronization Connections

Input Types

Return Types

Example

------------EXAMPLE--------------

Copy code
Remove-SPProfileSyncConnection -ProfileServiceApplication 888ds256-9ad9-53a9-f135-99eecd245670b -ConnectionDomain "Fabrikam" -ConnectionUserName "Testupa" -ConnectionPassword convertto-securestring "Password1" -asplaintext -force -ConnectionSynchronizationOU "OU=SharePoint Users,DC=fabrikam,DC=com"

This example removes a user from the fabrikam domain using a specific user profile service application.


Add-SPProfileSyncConnection
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Standard

Adds a synchronization connection.

Add-SPProfileSyncConnection [-ProfileServiceApplication] <SPServiceApplicationPipeBind> -ConnectionDomain <String> -ConnectionForestName <String> -ConnectionPassword <SecureString> -ConnectionSynchronizationOU <String> -ConnectionUserName <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-ConnectionClaimIDMapAttribute <String>] [-ConnectionClaimProviderIdValue <String>] [-ConnectionClaimProviderTypeValue <String>] [-ConnectionNamingContext <String>] [-ConnectionPort <Int32>] [-ConnectionServerName <String>] [-ConnectionUseDisabledFilter <$true | $false>] [-ConnectionUseSSL <$true | $false>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ProfileServiceApplication

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the name of the User Profile service application.

ConnectionDomain

Required

System.String

Specifies the NetBIOS name of the domain you are connecting to.

ConnectionForestName

Required

System.String

Specifies the fully qualified domain name (FQDN) of the forest you are connecting to.

ConnectionPassword

Required

System.Security.SecureString

Specifies the password of the account used for directory connection.

ConnectionSynchronizationOU

Required

System.String

Specifies the top level organizational unit (OU) that you would like to synchronize. The value must be a domain name and you can only include one container per command.

ConnectionUserName

Required

System.String

Specifies the user name to be used for the synchronization connection.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ConnectionClaimIDMapAttribute

Optional

System.String

Specifies the Claims ID used by the Claim Provider, that is, samAccountName.

ConnectionClaimProviderIdValue

Optional

System.String

Specifies the Claims Provider ID or Name for an authentication type while a Web App is configured.

ConnectionClaimProviderTypeValue

Optional

System.String

Specifies the Authentication claim Provider that will be used to encode the User Profile accounts names. For example, Windows/Forms etc. This means if a user logs in using the given Authentication Type, then a profile can be found by looking up a claim encoded credentials.

ConnectionNamingContext

Optional

System.String

Specifies the naming context of the directory information tree to connect to.

ConnectionPort

Optional

System.Int32

Specifies the port to be used to connect to the directory service. The default port is 389.

ConnectionServerName

Optional

System.String

Specifies the name of the domain controller to connect to.

ConnectionUseSSL

Optional

System.Boolean

Specifies if the connection to the directory service must be over SSL.

The valid values are: $True or $False

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

This cmdlet was introduced in SharePoint Server 2010 with Service Pack 1 (SP1) and SharePoint Foundation 2010 with Service Pack 1 (SP1).

Use the Add-SPProfileSyncConnection cmdlet to add a User Profile synchronization connection.

For additional information about profile synchronization connections, see Overview of profile synchronization in SharePoint Server 2013

Note:

This cmdlet only works with Active Directory Synchronization Connections

Input Types

Return Types

Example

----------EXAMPLE-----------

Copy code
Add-SPProfileSyncConnection -ProfileServiceApplication 888ds256-9ad9-53a9-f135-99eecd245670b -ConnectionForestName "fabrikam.com"-ConnectionDomain "Fabrikam" -ConnectionUserName "Testupa" -ConnectionPassword convertto-securestring "Password1" -asplaintext -force -ConnectionSynchronizationOU "OU=SharePoint Users,DC=fabrikam,DC=com"

This example adds a user from the fabrikam domain using a specific user profile service application.

See also

Remove-SPProfileSyncConnection


Update-SPRepopulateMicroblogFeedCache
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Refreshes the cache.

Update-SPRepopulateMicroblogFeedCache -[AccountName <String>] -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-SiteSubscription <SPSiteSubscriptionPipeBind>]-[SiteUrl <String>]

Parameters

Parameter Required Type Description

AccountName

Optional

System.String

Specifies the user's account name for the User Profile Service application. If you don't specify this parameter, you must specify the SiteUrl parameter. If neither parameter is specified, an error message is displayed.

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the User Profile Service application proxy to update.

The type must be in one of the following forms:

  • A valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh

  • A valid name of a service application proxy (for example, UserProfileSvcProxy1)

  • An instance of a valid SPServiceApplicationProxy object

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

SiteSubscription

Optional

Microsoft.SharePoint.PowerShell.SPSiteSubscriptionPipeBind

Specifies the account under which this service should run. This parameter is mandatory in a hosted-environment and optional in a non-hosted environment.

SiteUrl

Optional

System.String

Specifies the Site's URL to repopulate the site feeds. If you don't specify this parameter, you must specify the AccountName parameter. If neither parameter is specified, an error message is displayed.

Detailed Description

Use the Update-SPRepopulateMicroblogFeedCache cmdlet to refresh the feeds of a given user. It can be used in scenarios where the automatic refresh has failed or when reverting to an old version of a user's personal site.

Note:

When you refresh the cache, the Update-SPRepopulateMicroblogLMTCache cmdlet should be run first, and then the Update-SPRepopulateMicroblogFeedCache cmdlet second.

Input Types

Return Types

Example

------------EXAMPLE 1------------

Copy code
Update-SPRepopulateMicroblogFeedCache -ProfileServiceApplicationProxy a4f93369-0795-4aee-8a21-46f5ade29606 -AccountName contoso\<user>

This example refreshes the feeds for a specific user by using the AccountName parameter.

------------EXAMPLE 2------------

Copy code
Update-SPRepopulateMicroblogFeedCache -ProfileServiceApplicationProxy a4f93369-0795-4aee-8a21-46f5ade29606 -AccountName contoso\<user> -SiteSubscription 0C37852B-34D0-418e-91C6-2AC25AF4BE5B

This example refreshes the feeds for a specific user by using the AccountName parameter.

------------EXAMPLE 3------------

Copy code
Update-SPRepopulateMicroblogFeedCache -ProfileServiceApplicationProxy a4f93369-0795-4aee-8a21-46f5ade29606 -SiteUrl http://test/sites/usertest -SiteSubscription 0C37852B-34D0-418e-91C6-2AC25AF4BE5B

This example repopulates the site entity.

See also

Update-SPRepopulateMicroblogLMTCache


Update-SPRepopulateMicroblogLMTCache
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Refreshes the cache.

Update-SPRepopulateMicroblogLMTCache -ProfileServiceApplicationProxy <SPServiceApplicationProxyPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

ProfileServiceApplicationProxy

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationProxyPipeBind

Specifies the User Profile Service application proxy to update.

The type must be in one of the following forms:

  • A valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh

  • A valid name of a service application proxy (for example, UserProfileSvcProxy1)

  • An instance of a valid SPServiceApplicationProxy object

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Update-SPRepopulateMicroblogLMTCache cmdlet to refresh when the Feed Cache Repopulation Job timer job fails to work. The Update-SPRepopulateMicroblogLMTCache cmdlet forcefully refreshes the last modified times of all the known persisted entities to FeedCache.

Note:

When you refresh the cache, the Update-SPRepopulateMicroblogLMTCache cmdlet should be run first, and then the Update-SPRepopulateMicroblogFeedCache cmdlet second.

Input Types

Return Types

Example

------------EXAMPLE-----------

Copy code
Update-SPRepopulateMicroblogLMTCache -ProfileServiceApplicationProxy a4f93369-0795-4aee-8a21-46f5ade29606

This example refreshes the cache for the specified proxy.

See also

Update-SPRepopulateMicroblogFeedCache


Get-SPUserSettingsProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns a list of User Settings Providers installed on the farm.

Get-SPUserSettingsProvider [[-Identity] <SPUserSettingsProviderPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPUserSettingsProviderPipeBind

Specifies the GUID ID for a User Settings Provider.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPUserSettingsProvider cmdlet to return a list of User Settings Providers. To return a list of a specific user setting provider, use the Identity parameter. Otherwise, the list for the entire farm is returned.

Input Types

Return Types

Example

-----------EXAMPLE--------

Copy code
$provider = Get-SPUserSettingsProvider
Copy code
$site = Get-SPSite -Identity http://someserver
Copy code
$user = $site.RootWeb.CurrentUser
Copy code
ctx = $provider.GetProviderContext($user)
Copy code
$provider.GetUserRegionalSettings($ctx,$user)

This example returns the regional settings for a specified user.

See also

New-SPUserSettingsProvider
Remove-SPUserSettingsProvider
Get-SPUserSettingsProviderManager


Get-SPUserSettingsProviderManager
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns the User Settings Provider Manager.

Get-SPUserSettingsProviderManager [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Get-SPUserSettingsProviderManager cmdlet to return the User Settings Provider Manager for the farm.

Input Types

Return Types

Example

----------EXAMPLE--------

Copy code
Get-SPUserSettingsProviderManager

This example returns the User Settings Provider Manager for the farm.

See also

Get-SPUserSettingsProvider
New-SPUserSettingsProvider
Remove-SPUserSettingsProvider


New-SPUserSettingsProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Adds a new User Settings Provider.

New-SPUserSettingsProvider -AssemblyName <String> -DisplayName <String> -Type <String> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssemblyName

Required

System.String

Specifies the assembly name for the provider.

DisplayName

Required

System.String

Specifies the display name to use for this provider.

Type

Required

System.String

Specifies the type name to use for this provider.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the New-SPUserSettingsProvider cmdlet to add a new User Settings Provider to the farm.

Input Types

Return Types

Example

-----------EXAMPLE-------

Copy code
New-SPUserSettingsProvider -DisplayName "My User Settings Provider" -AssemblyName MyProvider.dll -Type MyProvider

This example adds a user setting provider with a display name of "My User Settings Provider" which uses the MyProvider.dll file.

See also

Get-SPUserSettingsProvider
Remove-SPUserSettingsProvider
Get-SPUserSettingsProviderManager


Remove-SPUserSettingsProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Removes a User Settings Provider.

Remove-SPUserSettingsProvider [-Identity] <SPUserSettingsProviderPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPUserSettingsProviderPipeBind

Specifies the GUID ID for a User Settings Provider to remove.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

Use the Remove-SPUserSettingsProvider cmdlet to remove a User Settings Provider from the farm.

Input Types

Return Types

Example

-----------EXAMPLE--------

Copy code
Remove-SPUserSettingsProvider -Identity "234bf0ed-70db-4158-a332-4dfd683b4148"

This example removes a specific User Settings Provider by using the GUID, 234bf0ed-70db-4158-a332-4dfd683b4148.

See also

Get-SPUserSettingsProvider
New-SPUserSettingsProvider
Get-SPUserSettingsProviderManager


Add-SPSocialAppPermissions
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Warning:

Do not use this cmdlet.

Add-SPSocialAppPermissions -MySiteHostLocation <SPSitePipeBind> [-ApplicationPrincipal <String>] [-AssignmentCollection <SPAssignmentCollection>] [-ContinueOnError <$true | $false>]

Parameters

Parameter | Required | Type | Description

Detailed Description

Warning:

Do not use the Add-SPSocialAppPermissions cmdlet. The use of the Add-SPSocialAppPermissions cmdlet can result in profile synchronization connections that are unusable and non-editable.

Input Types

Return Types

Example

Copy code

  See also
Remove-SPSocialAppPermissions


Remove-SPSocialAppPermissions
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Warning:

Do not use this cmdlet.

Remove-SPSocialAppPermissions -MySiteHostLocation <SPSitePipeBind> [-ApplicationPrincipal <String>] [-AssignmentCollection <SPAssignmentCollection>] [-ContinueOnError <$true | $false>]

Parameters

Parameter | Required | Type | Description

Detailed Description

Warning:

Do not use the Remove-SPSocialAppPermissions cmdlet. The use of the Remove-SPSocialAppPermissions cmdlet can result in profile synchronization connections that are unusable and non-editable.

Input Types

Return Types

Example

Copy code

  See also
Add-SPSocialAppPermissions


Get-SPProfilePropertyCollection
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Gets all user profile properties.

Get-SPProfilePropertyCollection [-Source] <String>

Parameters

Parameter | Required | Type | Description
Source | Required | System.String | Specifies the URL of the My Site Host from where the user profiles are retrieved, for example, http://hq.contoso.com:8081/my.

Detailed Description

The Get-SPProfilePropertyCollection cmdlet returns an object that contains a collection of all profile property subtypes from the source server. You can pipe the resulting object to other User Profile Replication Engine cmdlets.

Note:

Duplicate profile property subtypes are removed.

Input Types

Return Types

Example

----------Example ----------

Copy code
get-spprofilepropertycollection -source http://hq.contoso.com:8081

This example gets all of the profile property subtypes from hq.contoso.com.

See also

Stop-SPProfileServiceIncrementalReplication


Start-SPProfileServiceFullReplication
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Replicates all selected user profile properties from the source User Profile service application to the destination User Profile service application. The User Profile Replication Engine will run as a modal Windows PowerShell 3.0 cmdlet until the replication is complete.

Start-SPProfileServiceFullReplication -Destination <String> -Source <String> [-ActiveDirectoryDomains <String[]>] [-DoSocialReplication <SwitchParameter>] [-EnableInstrumentation <SwitchParameter>] [-MaxNumberOfErrors <Int32>] [-MaxNumberOfThreads <Int32>] [-NumberOfRetry <Int32>] [-Properties <String[]>] [-StartAtIndex <Int32>] [-Timeout <Int32>]

Parameters

Parameter | Required | Type | Description
Destination | Required | System.String | Specifies the URL of the My Site Host to where the user profiles are replicated, for example, http://euro.contoso.com:8081/my.
Source | Required | System.String | Specifies the URL of the My Site Host from where the user profiles are retrieved, for example, http://hq.contoso.com:8081/my.
ActiveDirectoryDomains | Optional | System.String | Specifies the Active Directory Domain Services (AD DS) accounts to be replicated, for example, "headquarters" or "Europe".The default value returns all AD DS domains.
DoSocialReplication | Optional | System.Management.Automation.SwitchParameter | Enables replication of social tags, notes, and ratings. Only use when both source and destination User Profile service applications are SharePoint Server 2013-based.
EnableInstrumentation | Optional | System.Management.Automation.SwitchParameter | Enables detailed logging by using the instrumentation log.
MaxNumberOfErrors | Optional | System.Int32 | Stops the replication process when a specified number of profiles do not replicate. The value range is between 1 and 100,000. The default value is 1000.
MaxNumberOfThreads | Optional | System.Int32 | Specifies the maximum number of replication threads allowed on the server that is running the User Profile Replication Engine. The value range is between 1 and 100. The default value is 25. The actual number of running threads will be decided dynamically by the User Profile Replication Engine.
NumberOfRetry | Optional | System.Int32 | Specifies the number of times that the User Profile Replication Engine should attempt to restart in the event of a failure, for example, a network disconnection. The default value is 10.
Properties | Optional | System.String[] | Specifies which user profile properties to replicate, for example, "FirstName" or "AboutMe". You can also use the Get-SPProfilePropertyCollection cmdlet to return a collection of all user profile properties. The default value returns all user profile properties.
StartAtIndex | Optional | System.Int32 | Specifies which profile index in the profile database should be used as the start index. The default value is 0.
Timeout | Optional | System.Int32 | Specifies the amount of time the User Profile Replication Engine should wait for a response from the Web service before timing out. The default value is the Web service timeout.

Detailed Description

The Start-SPProfileServiceFullReplication cmdlet replicates all selected user profile information and social data—including social tags, notes, and ratings—from the source User Profile Service application to the destination User Profile service application. Replication begins at the start index and can be stopped by pressing CTRL+C.

Note:

It may take several seconds for all threads to stop once you have pressed CTRL+C.

If full replication is interrupted, check the log file for the last successful entry and restart using the StartAtIndex parameter.

The account running this cmdlet must be an administrator for the User Profile service application.

Input Types

Return Types

Example

----------Example----------

Copy code
Start-SPProfileServiceFullReplication -source http://hq.contoso.com:8081 -destination http://euro.contoso.com:8081 -EnableInstrumentation -MaxNumberOfThreads 3 -DoSocialReplication

This example gets a collection of all user profile properties and replicates all user profile information and social data from hq.contoso.com to euro.contoso.com.

See also

Start-SPProfileServiceIncrementalReplication
Start-SPProfileServiceRecoveryReplication
Stop-SPProfileServiceIncrementalReplication


Start-SPProfileServiceIncrementalReplication
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Replicates changes for selected profile properties from the source User Profile service application to the destination User Profile service application using the Replication Engine Windows service.

Start-SPProfileServiceIncrementalReplication -Destination <String[]> -Source <String> [-ActiveDirectoryDomains <String[]>] [-Credential <PSCredential>] [-DoSocialReplication <SwitchParameter>] [-EnableInstrumentation <SwitchParameter>] [-FeedProperties <String[]>] [-MaxNumberOfThreads <Int32>] [-NumberOfRetry <Int32>] [-Properties <String[]>] [-ReplicationInterval <Int32>] [-Timeout <Int32>] [-WaitTimeBetweenFailures <Int32>]

Parameters

Parameter | Required | Type | Description
Destination | Required | System.String[] | Specifies the URL of the My Site Host to where the user profiles are replicated, for example, http://euro.contoso.com:8081/my.
Source | Required | System.String | Specifies the URL of the My Site Host from where the user profiles are retrieved, for example, http://hq.contoso.com:8081/my.
ActiveDirectoryDomains | Optional | System.String[] | Specifies the Active Directory Domain Services (AD DS) accounts to be replicated, for example, "headquarters" or "Europe".The default value returns all AD DS domains.
Credential | Optional | System.Management.Automation.PSCredential | Specifies the User Profile Replication Engine Windows service credentials the first time you run this cmdlet or anytime you want to change the Replication Engine service credentials. To get the User Profile Replication Engine Windows service credentials, use the Get-Credential cmdlet. For more information, see Get-Credential (http://go.microsoft.com/fwlink/p/?LinkID=113311).
DoSocialReplication | Optional | System.Management.Automation.SwitchParameter | Enables replication of social tags, notes, and ratings. Only use this parameter when both the source User Profile service application and the destination User Profile service application are SharePoint Server 2013-based.
EnableInstrumentation | Optional | System.Management.Automation.SwitchParameter | Enables detailed logging by using the instrumentation log.
FeedProperties | Optional | System.String[] | Specifies that the trusted My Site host locations list should be ignored when replicating changes for the specified user profile properties.
MaxNumberOfThreads | Optional | System.Int32 | Specifies the maximum number of replication threads allowed on the server that is running the User Profile Replication Engine. The value range is between 1 and 100. The default value is 25. The actual number of running threads will be decided dynamically by the User Profile Replication Engine.
NumberOfRetry | Optional | System.Int32 | Specifies the number of times that the User Profile Replication Engine should attempt to restart in the event of a failure, for example, a network disconnection. The default value is 3.
Properties | Optional | System.String[] | Specifies which user profile properties to replicate, for example, "FirstName" or "AboutMe". You can also use the Get-SPProfilePropertyCollection cmdlet to return a collection of all user profile properties. The default value returns all user profile properties.
ReplicationInterval | Optional | System.Int32 | Specifies the amount of time, in seconds, between each replication iteration. The default value is 5.
Timeout | Optional | System.Int32 | Specifies the amount of time the User Profile Replication Engine should wait for a response from the Web service before timing out. The default value is the Web service timeout.
WaitTimeBetweenFailures | Optional | System.Int32 | Specifies the amount of time, in seconds, that the User Profile Replication Engine should wait after it fails to replicate a user profile before the Start-SPProfileServiceRecoveryReplication process begins. The default value is 300.

Detailed Description

The Start-SPProfileServiceIncrementalReplication cmdlet replicates any changes to the user profile information and social data—including social tags, notes, and ratings—for the selected user profile properties from the source User Profile service application to the destination User Profile service application. The first time you run this cmdlet, you must provide the credentials for the User Profile Replication Engine Windows service. These credentials can be retrieved using the Get-credentials cmdlet. Once started, you can view the instrumentation log to verify if any changes are present.

If you need to stop incremental profile replication for any reason, use the Stop-SPProfileServiceIncrementalReplication cmdlet. Do not start or stop incremental profile replication by manually starting or stopping the User Profile Service Replication Engine Windows service using the Windows MMC snap-in.

You must have configured a trusted My Site host location by using the User Profile Service Administration Web page in Central Administration. For additional information about how to configure a trusted My Site host locations, see Add or delete a trusted My Site host location.

Input Types

Return Types

Example

----------Example----------

Copy code
Start-SPProfileServiceIncrementalReplication -source http://hq.contoso.com:8081 -destination http://euro.contoso.com:8081 -EnableInstrumentation -Credential $mycredential

This example replicates any changes to all user profile properties from hq.contoso.com to euro.contoso.com and tracks any changes in the instrumentation log.

See also

Start-SPProfileServiceFullReplication
Start-SPProfileServiceRecoveryReplication
Stop-SPProfileServiceIncrementalReplication


Start-SPProfileServiceRecoveryReplication
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Recovers user profiles that failed to replicate during full profile replication. This cmdlet will copy and overwrite all user profile properties in the destination User Profile Service application for the specified profiles.

Start-SPProfileServiceRecoveryReplication -Destination <String> -FileName <String> -Source <String> [-DoSocialReplication <SwitchParameter>] [-EnableInstrumentation <SwitchParameter>] [-MaxNumberOfThreads <Int32>] [-Properties <String[]>] [-Timeout <Int32>]

Parameters

Parameter | Required | Type | Description
Destination | Required | System.String | Specifies the URL of the My Site Host to where the user profiles are replicated, for example, http://euro.contoso.com:8081/my.
FileName | Required | System.String | Specifies the location of the accounts file. This file can be either the failed account file created during an instance of full replication or you can manually create a .txt or .rcv file that contains one user profile account per line, for example:Domain1\User1Domain1\User2Domain2\User1Domain2\User2Domain2\User3.
Source | Required | System.String | Specifies the URL of the My Site Host from where the user profiles are retrieved, for example, http://hq.contoso.com:8081/my.
DoSocialReplication | Optional | System.Management.Automation.SwitchParameter | Enables replication of social tags, notes, and ratings. Only use this parameter when both the source User Profile service application and the destination User Profile service application are SharePoint Server 2013-based.
EnableInstrumentation | Optional | System.Management.Automation.SwitchParameter | Enables detailed logging by using the instrumentation log.
Properties | Optional | System.String[] | Specifies which user profile properties to replicate, for example, "FirstName" or "AboutMe". You can also use the Get-SPProfilePropertyCollection cmdlet to return a collection of all user profile properties. The default value returns all user profile properties.
MaxNumberOfThreads | Optional | System.Int32 | Specifies the maximum number of replication threads allowed on the server that is running the User Profile Replication Engine. The value range is between 1 and 100. The default value is 25. The actual number of running threads will be decided dynamically by the User Profile Replication Engine.
Timeout | Optional | System.Int32 | Specifies the amount of time the User Profile Replication Engine should wait for a response from the Web service before timing out. The default is the Web service timeout.

Detailed Description

The Start-SPProfileServiceRecoveryReplication cmdlet replicates user profile information and social data—including social tags, notes, and ratings—for user profiles that failed to replicate during full profile replication. The list of these user profile accounts is saved to an accounts file that is created during full profile replication. The profile information and social data are replicated from the source User Profile service application to the destination User Profile service application.

Input Types

Return Types

Example

----------Example----------

Copy code
Start-SPProfileServiceRecoveryReplication -source http://hq.contoso.com:8081 -destination http://euro.contoso.com:8081 -EnableInstrumentation -FileName "d:\accounts.txt"

This example retrieves a list of user profiles that failed to replicate during incremental profile replication and replicates the user profile information and social data from the source User Profile service application to the destination User Profile service application.

See also

Start-SPProfileServiceFullReplication
Start-SPProfileServiceIncrementalReplication
Stop-SPProfileServiceIncrementalReplication


Stop-SPProfileServiceIncrementalReplication
See also Example
[image]

Published: December 11, 2012

Applies to: SharePoint Server 2013

Stops incremental profile replication.

Stop-SPProfileServiceIncrementalReplication

Detailed Description

The Stop-SPProfileServiceIncrementalReplication cmdlet stops profile replication when performing incremental replication of user profile information from a source User Profile service application to a destination User Profile service application. You should use this cmdlet to stop the User Profile Replication Engine Windows service. Do not start or stop incremental profile replication by manually starting or stopping the User Profile Replication Engine Windows service using the Windows MMC snap-in.

The Stop-SPProfileServiceIncrementalReplication cmdlet does not take any parameters.

Input Types

Return Types

Example

----------Example----------

Copy code
Stop-SPProfileServiceIncrementalReplication

This example stops incremental profile replication.

See also

Start-SPProfileServiceFullReplication
Start-SPProfileServiceIncrementalReplication
Start-SPProfileServiceRecoveryReplication


Visio Graphics Services cmdlets in SharePoint Server 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you administer the Visio Graphics Service in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Visio Graphics Service is a service in SharePoint Server 2013 that users can use to view published Visio diagrams. The service also refreshes published Visio diagrams that are connected to supported data sources.

All Visio Graphics Service settings will support backup and recovery, regardless of whether there is a UI setting. This means all global settings will support backup and restore operations.

The Visio Graphics Service has Windows PowerShell functionality that you can use to provision a new instance, manage and configure available data sources, manage and configure a list of safe data providers, and configure all the global settings of the service.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPVisioExternalData | Returns the settings for external data connections for a Visio Services application.
Get-SPVisioPerformance | Returns the Visio Services settings for the performance of a Visio Services application.
Get-SPVisioSafeDataProvider | Returns the settings of a safe data provider for a Visio Services application.
Get-SPVisioServiceApplication | Returns properties of a Visio Services application or a collection of Visio Services applications.
Get-SPVisioServiceApplicationProxy | Returns properties of a Visio Services application proxy or a collection of Visio Services application proxies
New-SPVisioSafeDataProvider | Adds a new data provider to a Visio Services application.
New-SPVisioServiceApplication | Adds a new Visio Services application to a farm.
New-SPVisioServiceApplicationProxy | Adds a new Visio Services application proxy to a farm.
Remove-SPVisioSafeDataProvider | Removes a data provider from a Visio Services application.
Set-SPVisioExternalData | Configures settings related to external data connections for a Visio Services application.
Set-SPVisioPerformance | Sets performance properties for a Visio Services application.
Set-SPVisioSafeDataProvider | Specifies a description of a safe data provider for a Visio Services application.
Set-SPVisioServiceApplication | Sets the ServiceApplicationPool property for a Visio Services application.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Get-SPVisioExternalData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the settings for external data connections for a Visio Services application.

Get-SPVisioExternalData -VisioServiceApplication <SPVisioServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

VisioServiceApplication

Required

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application that contains the SPVisioExternalData object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPVisioExternalData cmdlet reads the service settings for managing settings that are related to connecting to external data.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------------

Copy code
Get-SPVisioExternalData -VisioServiceApplication "VGS1"

This example gets settings related to external data for a Visio Services application.

------------------EXAMPLE 2------------------------

Copy code
Get-SPVisioServiceApplication -identity "VGS1" | Get-SPVisioExternalData

This example uses a pipe bind to get settings related to external data for a Visio Services application.

See also

Set-SPVisioExternalData


Get-SPVisioPerformance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the Visio Services settings for the performance of a Visio Services application.

Get-SPVisioPerformance -VisioServiceApplication <SPVisioServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

VisioServiceApplication

Required

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application that contains the SPVisioPerformance object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPVisioPerformance cmdlet reads the service settings for managing and configuring peformance for a Visio Services application.

Input Types

Return Types

Example

-----------------EXAMPLE----------------------

Copy code
Get-SPVisioPerformance -VisioServiceApplication "VGS1"

This example gets settings related to performance for a Visio Services application.

See also

Set-SPVisioPerformance


Get-SPVisioSafeDataProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns the settings of a safe data provider for a Visio Services application.

Get-SPVisioSafeDataProvider -VisioServiceApplication <SPVisioServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-DataProviderId <String>] [-DataProviderType <Int32>]

Parameters

Parameter Required Type Description

VisioServiceApplication

Required

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application that contains the SPVisioSafeDataProvider object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DataProviderId

Optional

System.String

Specifies the safe data provider to get. The combination of DataProviderID and DataProviderType uniquely identify a data provider for a Visio Graphics Service application. The string that identifies the data provider can be a maximum of 255 alphanumeric characters.

The type must be a valid string that identifies the data provider; for example, VisioDataProvider1.

DataProviderType

Optional

System.Int32

Specifies the supported type of the data provider to get. Custom data types are supported; for example, Excel services.

The type must be a valid identity of a data provider type.

Detailed Description

The Get-SPVisioSafeDataProvider cmdlet retrieves the settings of the safe provider for a Visio Services application. If the DataProviderID parameter is not specified, this cmdlet returns the collection of safe providers in the farm.

Input Types

Return Types

Example

-------------------EXAMPLE 1----------------------

Copy code
Get-SPVisioSafeDataProvider -VisioServiceApplication "VGS1"

This example returns a list of safe data providers for a specific Visio Services application.

-------------------EXAMPLE 2----------------------

Copy code
Get-SPVisioSafeDataProvider -VisioServiceApplication "VGS1" -DataProviderID "SQLOLEDB" -DataProviderType 1

This example returns information about a specified safe data provider for a specific Visio Services application.

See also

New-SPVisioSafeDataProvider
Remove-SPVisioSafeDataProvider
Set-SPVisioSafeDataProvider


Get-SPVisioServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns properties of a Visio Services application or a collection of Visio Services applications.

Get-SPVisioServiceApplication [[-Identity] <SPVisioServiceApplicationPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPVisioServiceApplication cmdlet retrieves the settings of the specified Visio Services application. If the Identity parameter is not specified, this cmdlet returns the collection of Visio Services applications in the farm.

Input Types

Return Types

Example

-----------------------EXAMPLE 1-------------------------

Copy code
Get-SPVisioServiceApplication

This example returns a collection of all Visio Services applications in the farm.

-----------------------EXAMPLE 2-------------------------

Copy code
Get-SPVisioServiceApplication "VGS1"

This example returns properties of the VGS1 Visio Services application.

See also

New-SPVisioServiceApplication
Set-SPVisioServiceApplication


Get-SPVisioServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Returns properties of a Visio Services application proxy or a collection of Visio Services application proxies.

Get-SPVisioServiceApplicationProxy [[-Identity] <SPVisioServiceApplicationProxyPipeBind>] [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationProxyPipeBind

Specifies the Visio Services application proxy to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPVisioServiceApplicationProxy cmdlet reads the settings of a Visio Services application proxy. If the Identity parameter is not specified, this cmdlet returns the collection of Visio Services application proxies on the farm.

Input Types

Return Types

Example

----------------EXAMPLE 1---------------------

Copy code
Get-SPVisioServiceApplicationProxy

This example returns a list of Visio Services application proxies.

----------------EXAMPLE 2---------------------

Copy code
Get-SPVisioServiceApplicationProxy "Connection to VGS2"

This example returns settings for a Visio Services application proxy.

See also

New-SPVisioServiceApplicationProxy


New-SPVisioSafeDataProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a new data provider to a Visio Services application.

New-SPVisioSafeDataProvider -DataProviderId <String> -DataProviderType <Int32> -VisioServiceApplication <SPVisioServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Description <String>]

Parameters

Parameter Required Type Description

DataProviderId

Required

System.String

Specifies the name of the data provider to create. The combination of DataProviderID and DataProviderType uniquely identify a data provider for a Visio Services application. The string that identifies the data provider can be a maximum of 255 alphanumeric characters.

The type must be a valid string that identifies the data provider; for example, VisioDataProvider1.

DataProviderType

Required

System.Int32

The type must be a valid identity of a data provider type.

Specifies the supported type of the data provider to add. Custom data types are supported; for example, Excel Services.

VisioServiceApplication

Required

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application in which to add the new safe data provider.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Description

Optional

System.String

Specifies the description of the new safe data provider.

The type must be a string with a maximum of 4096 characters.

Detailed Description

The New-SPVisioSafeDataProvider cmdlet adds a new data provider to the list of safe data providers for a Visio Services application.

Input Types

Return Types

Example

-------------------EXAMPLE------------------------

Copy code
New-SPVisioSafeDataProvider -VisioServiceApplication "VGS1" -DataProviderID "CustomProvider" -DataProviderType 5 -Description "Custom Data Provider"

This example creates a new safe data provider for a specified Visio Services application.

See also

Get-SPVisioSafeDataProvider
Remove-SPVisioSafeDataProvider
Set-SPVisioSafeDataProvider


New-SPVisioServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a new Visio Services application to a farm.

New-SPVisioServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AddToDefaultGroup <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS application pool in which to run the Web service for the service application.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

AddToDefaultGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that a default proxy is created for the new Visio Services application.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Name

Optional

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application to create.

The type must be a valid name of a Visio Service application; for example, MyVisioService1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPVisioServiceApplication cmdlet adds a new Visio Services application to a farm.

Input Types

Return Types

Example

----------------EXAMPLE 1---------------------

Copy code
New-SPVisioServiceApplication -Identity "VGS2" -ServiceApplicationPool "SharePoint Web Services Default" -CreateDefaultProxy

This example creates a new Visio Services application VGS2, and also creates a service application proxy associated with it.

----------------EXAMPLE 2---------------------

Copy code
Get-SPIISWebServiceApplicationPool "SharePoint Web Services System Default" | New-SPVisioServiceApplication "VGS3"

This example creates a new Visio Services application VGS3 without creating an associated service application proxy. You can pipe the results from the Get-SPIISWebServiceApplicationPool cmdlet.

See also

Get-SPVisioServiceApplication
Set-SPVisioServiceApplication


New-SPVisioServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Adds a new Visio Services application proxy to a farm.

New-SPVisioServiceApplicationProxy -ServiceApplication <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ServiceApplication

Required

System.String

Specifies the Visio Services application that is associated with the application proxy.

The type must be a valid name of a Visio Services application; for example, MyVisioService1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Name

Optional

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationProxyPipeBind

Specifies the Visio Services application proxy to create.

The type must be a valid name of a Visio Services application; for example, MyVisioService1.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPVisioServiceApplicationProxy cmdlet adds a new Visio Services application proxy to a farm.

Input Types

Return Types

Example

--------------------EXAMPLE------------------------

Copy code
New-SPVisioServiceApplicationProxy -Identity "ProxyToVGS3" -ServiceApplicationName "VGS3"

This example creates a new Visio Services application proxy connected to a Visio Services application.

See also

Get-SPVisioServiceApplicationProxy


Remove-SPVisioSafeDataProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes a data provider from a Visio Services application.

Remove-SPVisioSafeDataProvider -DataProviderId <String> -DataProviderType <Int32> -VisioServiceApplication <SPVisioServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

DataProviderId

Required

System.String

Specifies the name of the data provider to delete. The combination of DataProviderID and DataProviderType uniquely identifies a data provider for a Visio Services application. The string that identifies the data provider can be a maximum of 255 alphanumeric characters.

The type must be a valid string that identifies the data provider.

DataProviderType

Required

System.Int32

Specifies the supported type of the data provider to delete.

The type must be a valid identity of a data provider type.

VisioServiceApplication

Required

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application that contains the SPVisioSafeDataProvider object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Remove-SPVisioSafeDataProvider cmdlet deletes the safe data provider that is specified in the DataProviderID parameter.

Input Types

Return Types

Example

-------------------EXAMPLE------------------------

Copy code
Remove-SPVisioSafeDataProvider -VisioServiceApplication "VGS1" -DataProviderID "CustomProvider" -DataProviderType 5

This example removes a safe data provider for a specified Visio Services application.

See also

Get-SPVisioSafeDataProvider
New-SPVisioSafeDataProvider
Set-SPVisioSafeDataProvider


Set-SPVisioExternalData
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Configures settings related to external data connections for a Visio Services application.

Set-SPVisioExternalData -UnattendedServiceAccountApplicationID <String> -VisioServiceApplication <SPVisioServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

UnattendedServiceAccountApplicationID

Required

System.String

Specifies the target application ID in the registered secure store service that is used to reference unattended service account credentials. The unattended service account is a single account that all documents can use to refresh data. It is required when connecting to external data sources.

The type must be a valid value less than or equal to 256 characters. The application ID must be registered in the secure store service application or an error message will be displayed.

VisioServiceApplication

Required

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application that contains the SPVisioExternalData object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Set-SPVisioExternalData cmdlet sets and configures settings for external data connections for the Visio Services application.

Input Types

Return Types

Example

--------------------EXAMPLE-----------------------

Copy code
Set-SPVisioExternalData -VisioServiceApplication "VGS1" -UnattendedServiceAccountApplicationID "SSSApp1"

This example sets the unattended service account application ID to SSSApp1 for the Visio Services application named VGS1.

See also

Get-SPVisioExternalData


Set-SPVisioPerformance
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets performance properties for a Visio Services application.

Set-SPVisioPerformance -MaxDiagramCacheAge <Int32> -MaxDiagramSize <Int64> -MaxRecalcDuration <Int32> -MinDiagramCacheAge <Int32> -VisioServiceApplication <SPVisioServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

MaxDiagramCacheAge

Required

System.Int32

Specifies the time, in minutes, after which cached items are purged. This value affects memory use on the server. A large cache age slows the rate at which diagrams can be refreshed by users and reduces CPU and memory use of the server. The default value is 60 minutes.

The type must be an integer in the range of 0 to 34560 (24 days).

MaxDiagramSize

Required

System.Int64

Specifies the maximum size, in megabytes, of a diagram that can be opened by the Visio Services application. The default value is 5.

The type must be an integer in the range of 1 to 50.

MaxRecalcDuration

Required

System.Int32

Specifies the maximum time, in seconds, that a diagram can only be recalculated by the Visio Services application. Diagram recalculation operations that take longer than this number of seconds are canceled by the service. A low value increases performance by allowing only simple diagrams to be processed by the server, which minimizes CPU and memory use. A larger value allows the recalculation of more complex diagrams while using more CPU cycles and memory.

The type must be a valid integer value in the range of 1 to 120 seconds (2 minutes). The default value is 60 seconds.

MinDiagramCacheAge

Required

System.Int32

Specifies the minimum time, in minutes, a diagram is cached in memory. This value affects memory use on the server. A small value allows users to refresh their diagrams more often, but will increase memory and CPU load of the server. The default value is 5.

The type must be an integer in the range of 0 to 34560 (24 days).

VisioServiceApplication

Required

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application that contains the SPVisioPerformance object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Set-SPVisioPerformance cmdlet sets properties related to performance for a Visio Services application.

Input Types

Return Types

Example

-------------------EXAMPLE 1----------------------

Copy code
Set-SPVisioPerformance -VisioServiceApplication "VGS2" -MaxDiagramSize 10 -MaxRecalcDuration 120 -MinDiagramCacheAge 1 -MaxDiagramCacheAge 4

This example changes settings that are related to performance for a Visio Services application.

-------------------EXAMPLE 2----------------------

Copy code
Set-SPVisioPerformance -VisioServiceApplication "VGS2" -MaxDiagramSize 10

This example changes settings that are related to performance for a Visio Services application. Note that only one setting value is specified. The cmdlet prompts you for the other parameter values.

See also

Get-SPVisioPerformance


Set-SPVisioSafeDataProvider
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Specifies a description of a safe data provider for a Visio Services application.

Set-SPVisioSafeDataProvider -DataProviderId <String> -DataProviderType <Int32> -Description <String> -VisioServiceApplication <SPVisioServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

DataProviderId

Required

System.String

Specifies the name of the data provider to update. The combination of DataProviderID and DataProviderType uniquely identifies a data provider for a Visio Services application. The string that identifies the data provider can be a maximum of 255 alphanumeric characters. Custom data types are supported; for example, Excel Services.

The type must be a valid string that identifies the data provider.

DataProviderType

Required

System.Int32

Specifies the supported type of the data provider to get. Custom data types are supported; for example, Excel services.

The type must be a valid identity of a data provider type.

Description

Required

System.String

Specifies the description of the safe data provider to set.

The type must be a string with a maximum of 4096 characters.

VisioServiceApplication

Required

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application that contains the SPVisioSafeDataProvider object.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Set-SPVisioSafeDataProvider cmdlet sets the Description property of a safe data provider for a Visio Services application.

Input Types

Return Types

Example

-------------------EXAMPLE 1----------------------

Copy code
Set-SPVisioSafeDataProvider -VisioServiceApplication "VGS1" -DataProviderID "SQLOLEDB" -DataProviderType 1 -Description "SQL OLEDB Driver!"

This example sets the description property of a safe data provider for a specific Visio Services application.

-------------------EXAMPLE 2----------------------

Copy code
Get-SPVisioServiceApplication -Identity "VGS1" | Set-SPVisioSafeDataProvider -DataProviderID "SQLOLEDB" -DataProviderType 1 -Description "SQL OLEDB Driver!"

This example sets the Description property of a safe data provider for a specific Visio Services application. The result is piped from the Set-SPVisioSafeDataProvider cmdlet.

See also

Remove-SPVisioSafeDataProvider
Get-SPVisioSafeDataProvider
New-SPVisioSafeDataProvider


Set-SPVisioServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets the ServiceApplicationPool property for a Visio Services application.

Set-SPVisioServiceApplication [-Identity] <SPVisioServiceApplicationPipeBind> [-ServiceApplicationPool] <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Visio.Server.Cmdlet.SPVisioServiceApplicationPipeBind

Specifies the Visio Services application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Visio Services application (for example, MyVisioService1); or an instance of a valid SPVisioServiceApplication object.

ServiceApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the IIS application pool to change. The Web service for the service application runs in the specified application pool.

The type must be a valid name of a Visio Service application pool, such as MyVisioServiceAppPool1; or a valid GUID, such as 12345678-90ab-cdef-1234-567890bcdefgh, or an instance of a valid SPIisWebServiceApplicationPoolPipeBind object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPVisioServiceApplication cmdlet sets the ServiceApplicationPool property for a Visio Services application.

Input Types

Return Types

Example

-----------------EXAMPLE 1----------------------

Copy code
Set-SPVisioServiceApplication -identity "VGS1" -ServiceApplicationPool "SharePoint Web Services System Default"

This example changes the application pool of the VGS1 service application.

-----------------EXAMPLE 2----------------------

Copy code
Get-SPServiceApplicationPool "SharePoint Web Services Default" | Set-SPVisioServiceApplication VGS1

This example changes the application pool of the VGS1 service application. The results are piped from the Get-SPServiceApplicationPool cmdlet.

See also

New-SPVisioServiceApplication
Get-SPVisioServiceApplication
Get-SPVisioServiceApplication


Web application cmdlets in SharePoint 2013
See also

Summary: Lists Windows PowerShell cmdlets that help you administer web applications in a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use Windows PowerShell cmdlets to administer web applications in a SharePoint 2013 farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPAlternateURL | Returns all alternate URLs that match a given set of criteria.
Get-SPMobileMessagingAccount | Retrieves mobile messaging accounts for the specified web application.
Install-SPApplicationContent | Copies shared application data to existing web application folders.
New-SPAlternateUrl | Creates a new public or internal URL for the specified web application zone or resource.
Remove-SPAlternateUrl | Completely deletes the specified alternate URL.
Set-SPAlternateUrl | Configures the specified alternate URL.
Set-SPMobileMessagingAccount | Configures the specified mobile messaging account.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Get-SPAlternateURL
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns all alternate URLs that match a given set of criteria.

Get-SPAlternateURL [[-Identity] <SPAlternateUrlPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Zone <Default | Intranet | Internet | Custom | Extranet>]
Get-SPAlternateURL [[-Identity] <SPAlternateUrlPipeBind>] -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Zone <Default | Intranet | Internet | Custom | Extranet>]
Get-SPAlternateURL [[-Identity] <SPAlternateUrlPipeBind>] -ResourceName <String> [-AssignmentCollection <SPAssignmentCollection>] [-Zone <Default | Intranet | Internet | Custom | Extranet>]

Parameters

1

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPAlternateUrlPipeBind

Specifies the URL or GUID of the alternate URL to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, or a valid URL, in the form http://server_name.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Zone

Optional

System.String

Specifies one of the five zones with which the alternate URLs is associated.

Must be a valid zone: Default, Intranet, Internet, Extranet, or Custom

2

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPAlternateUrlPipeBind

Specifies the URL or GUID of the alternate URL to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, or a valid URL, in the form http://server_name.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the Web application from which to list alternate URLs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Zone

Optional

System.String

Specifies one of the five zones with which the alternate URLs is associated.

Must be a valid zone: Default, Intranet, Internet, Extranet, or Custom

3

Parameter

Required

Type

Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPAlternateUrlPipeBind

Specifies the URL or GUID of the alternate URL to get.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh, or a valid URL, in the form http://server_name.

ResourceName

Required

System.String

Specifies the name of the resource from which to list alternate URLs.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Zone

Optional

System.String

Specifies one of the five zones with which the alternate URLs is associated.

Must be a valid zone: Default, Intranet, Internet, Extranet, or Custom

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPAlternateURL cmdlet returns all alternate URLs that match the scope given by either the optional Identity parameter or by a combination of the optional WebApplication, Zone, or Resource parameters. Each criterion that is added narrows the scope. If no criteria are specified then all alternate URLs are returned.

If the Identity parameter is used, only the specific matching alternate URL is returned. If no alternate URL with the given identity exists at the given scope, nothing is returned.

Input Types

Return Types

Example

--------------EXAMPLE 1-----------------

Copy code
Get-SPAlternateURL -WebApplication http://sitename

This example displays all the alternate URLs on a given Web application.

--------------EXAMPLE 2-----------------

Copy code
Get-SPAlternateURL -ResourceName "MyResource"

This example displays all the alternate URLs for a given resource.

See also

New-SPAlternateUrl
Set-SPAlternateUrl
Remove-SPAlternateUrl


Get-SPMobileMessagingAccount
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Retrieves mobile messaging accounts for the specified Web application.

Get-SPMobileMessagingAccount [[-Identity] <SPMobileMessagingAccountPipeBind>] -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

Identity

Optional

Microsoft.SharePoint.PowerShell.SPMobileMessagingAccountPipeBind

Specifies whether to return either Short Message Service (SMS) or Multimedia Messaging Service (MMS) account information. Valid values are:SMS and MMS. If you do not specify this parameter, account information is returned for both SMS and MMS.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the identity of the Web application to delete. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid Web application name (for example, WebApplication1212); or a valid name (for example, WebApp2423).

You either must specify WebApplication or must use the HostHeader switch and specify the full URL in the Identity parameter.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPMobileMessagingAccount cmdlet retrieves the specified mobile messaging accounts for the specified Web application.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPMobileMessagingAccount -WebApplication http://sitename

This example retrieves the current mobile account settings information of the Web application http://sitename.

See also

Set-SPMobileMessagingAccount


Install-SPApplicationContent
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Copies shared application data to existing Web application folders.

Install-SPApplicationContent [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Install-SPApplicationContent cmdlet copies shared application data to existing Web application folders.

This cmdlet does not take any parameters.

Input Types

Return Types

Example

---------------------EXAMPLE--------------------

Copy code
Install-SPApplicationContent

This example copies data to a Web application in the existing folders.


New-SPAlternateUrl
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Creates a new public or internal URL for the specified Web application zone or resource.

New-SPAlternateUrl [-Url] <String> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Internal <SwitchParameter>] [-WhatIf [<SwitchParameter>]] [-Zone <Default | Intranet | Internet | Custom | Extranet>]
New-SPAlternateUrl [-Url] <String> -ResourceName <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Internal <SwitchParameter>] [-WhatIf [<SwitchParameter>]] [-Zone <Default | Intranet | Internet | Custom | Extranet>]

Parameters

1

Parameter

Required

Type

Description

Url

Required

System.String

Specifies the public URL that users access to sign in to the Web application.

The type must be a valid URL, in the form http://server_name.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the name, URL, or GUID of the Web application for which to create the mapping.

The type must be a valid name, URL, in the form WebApplication-1212, http://server_name, or GUID, in the form 1234-5678-9876-0987.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Internal

Optional

System.Management.Automation.SwitchParameter

Makes this alternate URL an internal URL. If this parameter is not provided, the URL is a public URL.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Zone

Optional

System.String

Specifies one of the five zones with which the alternate URL is associated.

The type must be a valid zone: Default, Intranet, Internet, Extranet, or Custom.

2

Parameter

Required

Type

Description

Url

Required

System.String

Specifies the public URL that users access to sign in to the Web application.

The type must be a valid URL, in the form http://server_name.

ResourceName

Required

System.String

Specifies the resource name, if the alternate URL is for an external resource. If no value is specified, the value is left blank.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Internal

Optional

System.Management.Automation.SwitchParameter

Makes this alternate URL an internal URL. If this parameter is not provided, the URL is a public URL.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Zone

Optional

System.String

Specifies one of the five zones with which the alternate URL is associated.

The type must be a valid zone: Default, Intranet, Internet, Extranet, or Custom.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The New-SPAlternateUrl cmdlet creates a new public or internal URL for the specified Web application zone or resource. Use the ResourceName parameter if the alternate URL is for an external resource.

Each Web application can be associated with a collection of mappings between internal and public URLs. Both internal and public URLs consist of the protocol and domain portion of the full URL; for example, https://www.fabrikam.com. Users type a public URL to get to the SharePoint site, and that URL appears in the links on the pages. Internal URLs are in the URL requests that are sent to the SharePoint site. Many internal URLs can be associated with a single public URL in multiserver farms; for example, when a load balancer routes requests to specific IP addresses to various servers in the load-balancing cluster.

Each Web application supports five collections of mappings per URL; the five collections correspond to five zones (default, intranet, extranet, Internet, and custom). When the Web application receives a request for an internal URL in a particular zone, links on the pages returned to the user have the public URL for that zone.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
#create the public URLNew-SPAlternateURL https://www.contoso.com -Zone "Internet"
Copy code
#create the internal URLNew-SPAlternateURL http://sharepoint.contoso.com -Zone "Internet" -internal

This example translates incoming requests for https://www.contoso.com into http://sharepoint.contoso.com (on the Internet zone).

When a reverse proxy is being set up to handle public URL SSL termination, alternate access mappings must be configured to handle the URL translation.

See also

Set-SPAlternateUrl
Get-SPAlternateURL
Remove-SPAlternateUrl


Remove-SPAlternateUrl
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Completely deletes the specified alternate URL.

Remove-SPAlternateUrl [-Identity] <SPAlternateUrlPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPAlternateUrlPipeBind

Specifies the identity of the alternate URL to delete. The identity can be either a valid URL, in the form http://server_name, or a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPAlternateUrl cmdlet completely deletes the alternate URL specified by the Identity parameter.

Input Types

Return Types

Example

------------------EXAMPLE 1-----------------------

Copy code
Remove-SPAlternateURL -WebApplication http://sitename -Zone Extranet

This example deletes the extranet URL for the given Web application.

------------------EXAMPLE 2-----------------------

Copy code
Get-SPWebApplication |%{ Get-SPAlternateURL -WebApplication $_ -Zone "Extranet" } | Remove-SPAlternateURL

This example removes all extranet alternate URLs in the farm.

See also

New-SPAlternateUrl
Get-SPAlternateURL
Set-SPAlternateUrl


Set-SPAlternateUrl
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Configures the specified alternate URL.

Set-SPAlternateUrl [-Identity] <SPAlternateUrlPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Url <String>] [-WhatIf [<SwitchParameter>]] [-Zone <Default | Intranet | Internet | Custom | Extranet>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPAlternateUrlPipeBind

Specifies the URL or GUID of the alternate URL to change.

The type must be a valid URL, in the form http://server_name/WebApplication/site, or a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh.

Url

Required

System.String

Specifies the new alternate URL.

Zone

Required

System.String

Sets the supplied alternate URL as one of the five zones.

The type must be any one of the following values: Default, Intranet, Internet, Extranet, or Custom.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPAlternateUrl cmdlet changes the URL or zone of the alternate URL specified by the Identity parameter. This cmdlet can be used to change only the zone of internal URLs, and cannot be used to change the zone of public URLs.

Input Types

Return Types

Example

------------------EXAMPLE 1------------------

Copy code
Set-SPAlternateURL -Identity https://www.contoso.com -Zone "Internet"

This example changes the zone of the alternate URL https://www.contoso.com.

------------------EXAMPLE 2------------------

Copy code
Set-SPAlternateURL -Identity https://www.contoso.com -Url https://sharepoint.contoso.com -Zone "Default"

This example changes the URL and zone of the alternate URL https://www.contoso.com.

------------------EXAMPLE 3------------------

Copy code
Get-SPAlternateURL https://www.contoso.com | Set-SPAlternateURL -Zone "Internet"

This example changes the zone of the alternate URL https://www.contoso.com.

------------------EXAMPLE 4------------------

Copy code
Get-SPWebApplication |%{ Get-SPAlternateURL -WebApplication $_ -Zone "Extranet" } | Set-SPAlternateURL -Zone "Intranet"

This example changes the zone of the alternate URL for the specified Web application from Extranet to Intranet.

See also

Get-SPAlternateURL
New-SPAlternateUrl
Remove-SPAlternateUrl


Set-SPMobileMessagingAccount
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Configures the specified mobile messaging account.

Set-SPMobileMessagingAccount [-Identity] <SPMobileMessagingAccountPipeBind> -WebApplication <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Password <String>] [-ServiceName <String>] [-ServiceUrl <String>] [-UserId <String>]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPMobileMessagingAccountPipeBind

Specifies whether to return either Short Message Service (SMS) or Multimedia Messaging Service (MMS) account information. Valid values are SMS and MMS. If you do not specify this parameter account, information is returned for both SMS and MMS.

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the identity of the Web application that hosts the managed path to delete. The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid Web application name (for example, WebApplication1212); or a valid name (for example, WebApp2423).

You either must specify WebApplication or must use the HostHeader switch and specify the full URL in the Identity parameter.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Password

Optional

System.String

Specifies the password, if credentials are required for the account.

ServiceName

Optional

System.String

Specifies the name of the SMS service.

ServiceUrl

Optional

System.String

Specifies the URL of the SMS service.

UserId

Optional

System.String

Specifies the user name, if credentials are required for the account.

Detailed Description

The Set-SPMobileMessagingAccount cmdlet configures the specified mobile messaging account.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Set-SPMobileMessagingAccount -WebApplication http://sitename -Identity SMS -ServiceName SMSLink -ServiceUrl https://www.adatum.com/Service/MessagingService.asmx-UserId someone@example.com -Password password1

This example changes the SMS mobile account settings of the Web application, http://sitename, to the following values:service name: SMSLink; service URL: https://www.adatum.com/Service/MessagingService.asmx; user ID: someone@example.com; and password: password1.

See also

Get-SPMobileMessagingAccount


Word Services cmdlets in SharePoint Server 2013
See also

Summary: Lists the Windows PowerShell cmdlets that you can use to perform automated document conversions on the server.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use Word Services in SharePoint Server 2013 to perform automated document conversions on the server.

You can use Windows PowerShell functionality to provision Word Services from scratch or provision a new instance by using settings from a previous backup, configure and manage macro and query settings, and configure the global settings of the service.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
New-SPWordConversionServiceApplication | Creates a new instance of a Word Automation Services application on the farm.
Remove-SPWordConversionServiceJobHistory | Removes entries from the Word Automation Services job history database.
Set-SPWordConversionServiceApplication | Sets properties of a Word Automation Services application.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


New-SPWordConversionServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new instance of a Word Automation Services application on the farm.

New-SPWordConversionServiceApplication [-Name] <String> -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DatabaseCredential <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-Default <SwitchParameter>] [-PartitionMode <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the name of the new Word Automation Services application.

The type must be a valid name of a Word Automation Services application; for example, WordSvcApp1.

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS-managed application pool in which this instance of Word Automation Services runs.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DatabaseCredential

Optional

System.Management.Automation.PSCredential

Specifies the credentials to use for connecting to the database for the Word Automation Services application. Use this parameter only if SQL Server Authentication is used to access the service application database.

When the DatabaseCredential parameter is specified, the DatabaseName and DatabaseServer parameters are required.

DatabaseName

Optional

System.String

Specifies the name of the database to create for the new Word Automation Services application.

The type must be a valid SQL database name; for example, MetadataDB1.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the Word Automation Services database.

The type must be a valid SQL database server host name; for example, SQLServerHost1.

Default

Optional

System.Management.Automation.SwitchParameter

Specifies that the service application proxy is added to the farm's default proxy group for this Web application.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Specifies that this service behaves uniquely on a partitioned set of site collections. This property cannot be changed after the application is provisioned.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The New-SPWordConversionServiceApplication cmdlet creates a new instance of a Word Automation Services application on the farm.

Input Types

Return Types

Example

---------------EXAMPLE---------------

Copy code
Get-SPServiceApplicationPool -Identity MyAppPool | New-SPWordConversionServiceApplication -Name WordServices1

This example creates a new Word Automation Services application named WordServices1 in an existing application pool named MyAppPool.

See also

Set-SPWordConversionServiceApplication


Remove-SPWordConversionServiceJobHistory
Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Removes entries from the Word Automation Services job history database.

Remove-SPWordConversionServiceJobHistory [-Identity] <SPServiceApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-BeforeDate <Nullable>] [-Confirm [<SwitchParameter>]] [-IncludeActiveJobs <SwitchParameter>] [-JobId <Nullable>] [-SubscriptionId <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the Word Automation Services application to be processed.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Word Automation Services application (for example, WordSvcApp1); or an instance of a valid SPServiceApplication object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

BeforeDate

Optional

System.Nullable

Specifies that only jobs started before this date are to be removed.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

IncludeActiveJobs

Optional

System.Management.Automation.SwitchParameter

Specifies that jobs that contain active conversions can be removed. By default, jobs that have active conversions are not removed.

JobId

Optional

System.Nullable

Specifies that only the job with the specified ID is to be removed.

SubscriptionId

Optional

System.Nullable

Specifies that only jobs corresponding to this subscription ID are to be removed.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Remove-SPWordConversionServiceJobHistory cmdlet removes entries from the Word Automation Services job history database.

Input Types

Return Types

Example

---------------------EXAMPLE 1------------------------

Copy code
Get-SPServiceApplication -Name TestWordServer | Remove-SPWordConversionServiceJobHistory -BeforeDate 1/1/2009

This example deletes all the items in the database before 1/1/2009.

---------------------EXAMPLE 2------------------------

Copy code
Get-SPServiceApplication -Name TestWordServer | Remove-SPWordConversionServiceJobHistory -JobId 00000000-0000-0112-08FF-63927635FEF1 -IncludeActiveJobs

This example deletes the job with the specified ID, even if it is still processing.


Set-SPWordConversionServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets properties of a Word Automation Services application.

Set-SPWordConversionServiceApplication [-Identity] <WordServiceApplicationPipeBind> [-ActiveProcesses <Nullable>] [-AddSupportedFormats <String[]>] [-ApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-ClearSupportedFormats <SwitchParameter>] [-Confirm [<SwitchParameter>]] [-ConversionsPerInstance <Nullable>] [-ConversionTimeout <Nullable>] [-DatabaseCredential <PSCredential>] [-DatabaseName <String>] [-DatabaseServer <String>] [-DisableBinaryFileScan <SwitchParameter>] [-DisableEmbeddedFonts <SwitchParameter>] [-KeepAliveTimeout <Nullable>] [-MaximumConversionAttempts <Nullable>] [-MaximumConversionTime <Nullable>] [-MaximumGroupSize <Nullable>] [-MaximumMemoryUsage <Nullable>] [-RecycleProcessThreshold <Nullable>] [-RemoveSupportedFormats <String[]>] [-TimerJobFrequency <Nullable>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.SharePoint.PowerShell.SPServiceApplicationPipeBind

Specifies the Word Automation Services application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a Word Automation Services application (for example, WordSvcApp1); or an instance of a valid SPServiceApplication object.

ActiveProcesses

Optional

System.Nullable

Specifies the number of conversion processes on each machine on which the service application runs. This value is equivalent to the number of simultaneous conversions. The default value is 8.

The type must be a valid integer in the range from 1 to 1000.

AddSupportedFormats

Optional

System.String[]

Specifies a set of file formats to be enabled for use by the service application.

The value must be a comma-delimited list of one or more of the following: docx, doc, mht, rtf, xml.

ApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the existing IIS managed application pool in which this instance of Word Automation Services runs.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of an application pool (for example, AppPoolName1); or an instance of a valid IISWebServiceApplicationPool object.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

ClearSupportedFormats

Optional

System.Management.Automation.SwitchParameter

Specifies that all file formats should be disabled for use by the service application.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ConversionsPerInstance

Optional

System.Nullable

Specifies the number of items sent to each conversion process (see the ActiveProcesses parameter description earlier in this table) every time the timer job is run. The default value is 12.

The type must be a valid integer.

ConversionTimeout

Optional

System.Nullable

Specifies the time, in minutes, after which a conversion that is marked InProgress is confirmed to be still running each time the timer job runs and, if necessary, the conversion is restarted. The default value is 5.

The type must be a valid integer in the range from 1 to 60.

DatabaseCredential

Optional

System.Management.Automation.PSCredential

Specifies the credentials to use for connecting to the database for the Word Automation Services application. Use this parameter only if SQL Authentication is used to access the service application database.

When the DatabaseCredential parameter is specified, the DatabaseName and DatabaseServer parameters are required.

DatabaseName

Optional

System.String

Specifies the name of the database to use for this instance of the Word Automation Services application.

The type must be a valid SQL database name; for example, MetadataDB1.

DatabaseServer

Optional

System.String

Specifies the name of the host server for the Word Automation Services database.

The type must be a valid SQL database server host name; for example, SQLServerHost1.

DisableBinaryFileScan

Optional

System.Management.Automation.SwitchParameter

Specifies whether additional checks are run when Word 97 to Word 2003 documents are processed. Turn this setting off only if all documents processed by the service are trusted.

DisableEmbeddedFonts

Optional

System.Management.Automation.SwitchParameter

Specifies whether embedded fonts are ignored when present in input documents.

KeepAliveTimeout

Optional

System.Nullable

Specifies the length of time, in seconds, that a conversion can be non-responsive before it is terminated. The default value is 30.

The type must be a valid integer in the range from 10 to 60.

MaximumConversionAttempts

Optional

System.Nullable

The maximum number of conversion attempts before a conversion is marked with status "Failed". The default value is 2.

The type must be a valid integer in the range from 1 to 10.

MaximumConversionTime

Optional

System.Nullable

Specifies the maximum length of time, in seconds, that a conversion can run before it is terminated. The default value is 300.

The type must be a valid integer in the range from 60 to MaxInt.

MaximumMemoryUsage

Optional

System.Nullable

Specifies the maximum percentage of system memory which can be used by the service application. The default value is 100.

The type must be a valid integer in the range from 10 to 100.

RecycleProcessThreshold

Optional

System.Nullable

Specifies the number of documents which are converted before a conversion process is recycled. For additional information about the conversion process, see the ActiveProcess parameter description earlier in this table.

The type must be a valid integer in the range from 1 to 1000.

RemoveSupportedFormats

Optional

System.String[]

Specifies a set of file formats to be disabled for use by the service application.

The value must be a comma delimited list of one or more of the following: docx, doc, mht, rtf, xml.

TimerJobFrequency

Optional

System.Nullable

Specifies the frequency, in minutes, with which the timer job for this service application runs. The default value is 15.

The type must be a valid integer in the range from 1 to 59.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPWordConversionServiceApplication cmdlet sets global properties of a Word Automation Services application.

Input Types

Return Types

Example

-----------EXAMPLE-----------------

Copy code
Get-SPServiceApplication -Name WordServices1 | Set-SPWordConversionServiceApplication -TimerJobFrequency 30

This example sets the timer job frequency of the WordServices1 application to 30 minutes.

See also

New-SPWordConversionServiceApplication


Use Windows PowerShell cmdlets to manage workflow in SharePoint 2013
See also

Summary: Lists the Windows PowerShell cmdlets that you can use to manage workflows in a SharePoint 2013 farm.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

You can use Windows PowerShell cmdlets to manage workflows in a SharePoint farm.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
Get-SPWorkflowConfig | Returns workflow settings for the specified Web application.
Set-SPWorkflowConfig | Configures the workflow settings for the specified Web application.
Get-SPDesignerSettings | Displays SharePoint Designer 2013 features.
Set-SPDesignerSettings | Sets SharePoint Designer 2013 features.
Register-SPWorkflowService | Configures the SharePoint host to use a workflow service.
Copy-SPActivitiesToWorkflowService | Copies workflow activities.
Get-SPWorkflowServiceApplicationProxy | Returns the current SharePoint Workflow Service application proxy object.
New-SPWorkflowServiceApplicationProxy | Creates a Workflow Service application proxy.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Get-SPWorkflowConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Returns workflow settings for the specified Web application.

Get-SPWorkflowConfig [-WebApplication] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]
Get-SPWorkflowConfig [-SiteCollection] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

1

Parameter

Required

Type

Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the name or URL of the Web application.

The type must be a valid name, in the form WebApplication-1212, or a URL, in the form http://server_name/WebApplication-1212.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

2

Parameter

Required

Type

Description

SiteCollection

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the name or URL of the site collection.

The only other parameter that is used with the SiteCollection parameter is the DeclarativeWorkflowsEnabled parameter. No other parameters are used.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

The Get-SPWorkflowConfig cmdlet returns workflow settings for the Web application specified by the WebApplication parameter.

Input Types

Return Types

Example

--------------EXAMPLE-----------------

Copy code
Get-SPWorkFlowConfig -webapplication http://sitename

This example gets workflow settings for the specified Web application (http://sitename).

To get farm-level workflow settings for event delivery time-out, postpone threshold, and batch size, use the Get-SPFarmConfig cmdlet.

See also

Set-SPWorkflowConfig


Set-SPWorkflowConfig
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Configures the workflow settings for the specified Web application.

Set-SPWorkflowConfig [-WebApplication] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-DeclarativeWorkflowsEnabled <$true | $false>] [-EmailNoPermissionParticipantsEnabled <$true | $false>] [-SendDocumentToExternalParticipants <$true | $false>]
Set-SPWorkflowConfig [-SiteCollection] <SPSitePipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-DeclarativeWorkflowsEnabled <$true | $false>] [-EmailNoPermissionParticipantsEnabled <$true | $false>] [-SendDocumentToExternalParticipants <$true | $false>]

Parameters

1

Parameter

Required

Type

Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the name or URL of the Web application.

The type must be a valid name or GUID, in the form WebApplication-1212, or a URL, in the form http://server_name/WebApplication-1212.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DeclarativeWorkflowsEnabled

Optional

System.Boolean

Sets whether declarative workflows are allowed to run in the Web application.

The type must be either 1 for True or 0 for False.

EmailNoPermissionParticipantsEnabled

Optional

System.Boolean

Sets whether workflows send task e-mail messages to users who do not have permissions to the site in which the workflows are running.

The type must be either 1 for True or 0 for False.

SendDocumentToExternalParticipants

Optional

System.Boolean

Sets whether workflows automatically send a copy of the document as an e-mail attachment to participants who do not have access to the site or who are not in any linked directory other than Active Directory Domain Services (AD DS).

The type must be either 1 for True or 0 for False.

2

Parameter

Required

Type

Description

SiteCollection

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies the name or URL of the site collection.

The only other parameter that is used with the SiteCollection parameter is the DeclarativeWorkflowsEnabled parameter. No other parameters are used.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

DeclarativeWorkflowsEnabled

Optional

System.Boolean

Sets whether declarative workflows are allowed to run in the Web application.

The type must be either 1 for True or 0 for False.

EmailNoPermissionParticipantsEnabled

Optional

System.Boolean

Sets whether workflows send task e-mail messages to users who do not have permissions to the site in which the workflows are running.

The type must be either 1 for True or 0 for False.

SendDocumentToExternalParticipants

Optional

System.Boolean

Sets whether workflows automatically send a copy of the document as an e-mail attachment to participants who do not have access to the site or who are not in any linked directory other than Active Directory Domain Services (AD DS).

The type must be either 1 for True or 0 for False.

Detailed Description

This cmdlet contains more than one parameter set. You may only use parameters from one parameter set, and you may not combine parameters from different parameter sets. For more information about how to use parameter sets, see Cmdlet Parameter Sets.

Use the Set-SPWorkflowConfig cmdlet to configure the workflow settings for the specified Web application.

Input Types

Return Types

Example

------------------EXAMPLE-----------------------

Copy code
Set-SPWorkflowConfig -webapplication http://sitename DeclarativeWorkflowsEnabled $true -EmailNoPermissionParticipantsEnabled $true -SendDocumentToExternalParticipants $false

This example sets the workflow settings for the specified Web application to turn on declarative workflows, turn on e-mail to participants who do not have permissions to the site, and turn off the functionality to send e-mail messages as attachments to external participants.

No return values. Use the Get-SPWorkflowConfig cmdlet to see values.To set farm-level workflow settings for event-delivery time-out and to postpone threshold and batch size, use Set-SPFarmConfig.

See also

Get-SPWorkflowConfig


Get-SPDesignerSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Displays SharePoint Designer 2013 features.

Get-SPDesignerSettings [-WebApplication] <SPWebApplicationPipeBind> [-AssignmentCollection <SPAssignmentCollection>]

Parameters

Parameter Required Type Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the Web application in which the settings apply.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Detailed Description

The Get-SPDesignerSettings cmdlet determines whether SharePoint Designer 2013 features are enabled on the specified Web application.

Input Types

Return Types

Example

---------------------EXAMPLE------------------------

Copy code
Get-SPDesignerSettings -webapplication http://contoso

This example retrieves the SharePoint Designer 2013 settings for the Web application, http://contoso.

See also

Set-SPDesignerSettings


Set-SPDesignerSettings
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Enterprise

Sets SharePoint Designer 2013 features.

Set-SPDesignerSettings [-WebApplication] <SPWebApplicationPipeBind> [-AllowCreateDeclarativeWorkflow <$true | $false>] [-AllowDesigner <$true | $false>] [-AllowMasterPageEditing <$true | $false>] [-AllowRevertFromTemplate <$true | $false>] [-AllowSaveDeclarativeWorkflowAsTemplate <$true | $false>] [-AllowSavePublishDeclarativeWorkflow <$true | $false>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DesignerDownloadUrl <String>] [-RequiredDesignerVersion <String>] [-ShowURLStructure <$true | $false>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

WebApplication

Required

Microsoft.SharePoint.PowerShell.SPWebApplicationPipeBind

Specifies the Web application in which the settings will apply.

AllowDesigner

Optional

System.Boolean

Specifies whether to allow users to edit sites in a web application by using SharePoint Designer 2013. The default value is True

AllowMasterPageEditing

Optional

System.Boolean

Specifies whether to allow site administrators to customize master pages and layout pages using SharePoint Designer 2013. The default value is True.

AllowRevertFromTemplate

Optional

System.Boolean

Specifies whether to allow site administrators to detach pages from the original site definition using SharePoint Designer 2013. The default value is True.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

ShowURLStructure

Optional

System.Boolean

Specifies whether to allow site administrators to manage the URL structure of their Web sites by using SharePoint Designer 2013. The default value is True.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

The Set-SPDesignerSettings cmdlet sets SharePoint Designer 2013 features on a specified Web application when the WebApplicaton is used.

Input Types

Return Types

Example

-------------------EXAMPLE--------------------

Copy code
Set-SPDesignerSettings -WebApplication http://constoso -AllowRevertFromTemplate $False -AllowMasterPageEditing $False

This example disables the ability to detach pages from existing site definitions and to edit master pages and page layouts.

See also

Get-SPDesignerSettings


Register-SPWorkflowService
See also Example
[image]

Configures the SharePoint host to use a workflow service.

Register-SPWorkflowService -SPSite <SPSitePipeBind> -WorkflowHostUri <String> [-AllowOAuthHttp <SwitchParameter>] [-AssignmentCollection <SPAssignmentCollection>] [-Force <SwitchParameter>] [-PartitionMode <SwitchParameter>] [-ScopeName <String>]

Parameters

Parameter Required Type Description

SPSite

Required

Microsoft.SharePoint.PowerShell.SPSitePipeBind

Specifies a site collection to configure.

WorkflowHostUri

Required

System.String

Specifies a string of the full URI for the Workflow Service.

AllowOAuthHttp

Optional

System.Management.Automation.SwitchParameter

Support OAuth over HTTP.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Force

Optional

System.Management.Automation.SwitchParameter

Use this parameter to overwrite existing configuration settings and ignore errors.

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Determines whether a workflow connects the farm to a single instance of the Workflow Service or connects each site subscription to its own instance of the Workflow Service.

ScopeName

Optional

System.String

A name that identifies SharePoint to the workflow service.

Detailed Description

Use the Register-SPWorkflowService cmdlet to configure the SharePoint host to use a workflow service by using the SPSite and WorkflowHostUri parameters.

Input Types

Return Types

Example

----------------EXAMPLE 1------------
Copy code
Register-SPWorkflowService -SPSite 'https://myhost/mysite' -WorkflowHostUri 'https://workflowhost'

This example configures the SharePoint host by using the WorkflowHostUri parameter.

----------------EXAMPLE 2------------
Copy code
Register-SPWorkflowService -SPSite 'https://myhost/mysite' -WorkflowHostUri 'https://workflowhost' -AllowOAuthHttp -Force

This example configures the SharePoint host to use OAuth by using the WorkflowHostUri and AllowOAuthHttp parameters.

See also

Get-SPWorkflowServiceApplicationProxy
New-SPWorkflowServiceApplicationProxy


Copy-SPActivitiesToWorkflowService
See also Example
[image]

Copies workflow activities.

Copy-SPActivitiesToWorkflowService [-ActivityName <String>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Credential <ICredentials>] [-Force <$true | $false>] [-WhatIf [<SwitchParameter>]] [-WorkflowServiceAddress <String>]

Parameters

Parameter Required Type Description

ActivityName

Optional

System.String

Limits the copy to a specific activity. For example, LookupSPList.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Credential

Optional

System.Net.ICredentials

Specifies the service account used to communicate with the Workflow Service.

Force

Optional

System.Boolean

Copy all activities regardless of existing versions.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

WorkflowServiceAddress

Optional

System.String

Specifies a string of the full URI for the Workflow Service.

Detailed Description

Use the Copy-SPActivitiesToWorkflowService cmdlet to copy workflow activities installed on the SharePoint host to an instance of the Workflow Service.

For additional information about workflow activities and how to obtain the list of workflow activity names, see Workflow actions in SharePoint Designer

Input Types

Return Types

Example

---------------EXAMPLE------------
Copy code
$cred=[System.Net.CredentialCache]::DefaultNetworkCredentials
Copy code
Copy-SPLocalActivitiesToWorkflowService -WorkflowServiceAddress 'https://workflowhost/' -Credential $cred -Force $true

This example copies workflow activities to the workflowhost address using the default credentials.

See also

Get-SPWorkflowServiceApplicationProxy
New-SPWorkflowServiceApplicationProxy
Register-SPWorkflowService


Get-SPWorkflowServiceApplicationProxy
See also Example
[image]

Returns the current SharePoint Workflow Service application proxy object.

Get-SPWorkflowServiceApplicationProxy [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Get-SPWorkflowServiceApplicationProxy cmdlet to return the current SharePoint Workflow Service application proxy object.

Input Types

Return Types

Example

---------------EXAMPLE----------
Copy code
Get-WorkflowServiceApplicationProxy

This example returns the Workflow Service application proxy for the farm.

See also

New-SPWorkflowServiceApplicationProxy
Register-SPWorkflowService


New-SPWorkflowServiceApplicationProxy
See also Example
[image]

Creates a Workflow Service application proxy.

New-SPWorkflowServiceApplicationProxy [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-PartitionMode <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

PartitionMode

Optional

System.Management.Automation.SwitchParameter

Determines whether a workflow connects the farm to a single workflow service or connects each site subscription to its own workflow service.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPWorkflowServiceApplicationProxy cmdlet to create a Workflow Service application proxy that is used to connect SharePoint to an instance of the Workflow Service.

Input Types

Return Types

Example

-----------------EXAMPLE-----------
Copy code
New-SPWorkflowServiceApplicationProxy -PartitionMode

This example creates a WorkFlow Service application proxy with the PartitionMode parameter enabled.

See also

Get-SPWorkflowServiceApplicationProxy
Register-SPWorkflowService


Use Windows PowerShell cmdlets to administer the Work Management Service in SharePoint Server 2013
See also

Summary: Provides a list of Windows PowerShell cmdlets that you can use to administer Work Management Service applications in a SharePoint Server 2013 farm.

Applies to: SharePoint Server 2013

You can use Windows PowerShell cmdlets to administer Work Management Service applications in a SharePoint farm.

All cmdlets on this page are new in SharePoint Server 2013.

Index of Windows PowerShell cmdlets for SharePoint 2013 includes a complete list of all cmdlets in SharePoint 2013.

Cmdlet name | Description
New-SPWorkManagementServiceApplication | Creates a new Work Management Service application.
New-SPWorkManagementServiceApplicationProxy | Creates a new service application proxy group.
Set-SPWorkManagementServiceApplication | Sets settings for the Work Management Service application.
Set-SPWorkManagementServiceApplicationProxy | Sets the settings for the Work Management Service application proxy.

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


New-SPWorkManagementServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new Work Management Service application.

New-SPWorkManagementServiceApplication -ApplicationPool <SPIisWebServiceApplicationPoolPipeBind> -Name <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-Proxy <SwitchParameter>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

ApplicationPool

Required

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the name of an application pool to use; for example, SharePoint - 1213. If no value is specified, the default application pool is used.

Name

Required

System.String

Specifies the name of the Work Management Service application to be created.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

Proxy

Optional

System.Management.Automation.SwitchParameter

Specifies whether to add the Work Management Service application to the proxy group.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPWorkManagementServiceApplication cmdlet to create a new Work Management Service application.

Input Types

Return Types

Example

------------EXAMPLE----------

Copy code
$appPool = Get-SPServiceApplicationPool "SharePoint Web Services System Default"
Copy code
New-SPWorkManagementServiceApplication -Name "WM Service App" -ApplicationPool $appPool

This example creates a new Work Management Service Application using the "SharePoint Web Services System Default" App Pool.

See also

New-SPWorkManagementServiceApplicationProxy
Set-SPWorkManagementServiceApplication
Set-SPWorkManagementServiceApplicationProxy


New-SPWorkManagementServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Creates a new service application proxy group.

New-SPWorkManagementServiceApplicationProxy -Name <String> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-ServiceApplication <SPWorkManagementServiceCmdletPipeBind>] [-Uri <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Name

Required

System.String

Specifies the display name for the new Work Management Service application proxy. The name that you use must be a unique name of a Work Management Service application proxy in the farm. The maximum length is 128 characters.

The value must be a name of a valid Work Management Service application proxy; for example, WorkMgmtSvcProxy1.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies that the Work Management Service application proxy be added to the default proxy group for the local farm.

ServiceApplication

Optional

Microsoft.Office.Server.WorkManagement.Cmdlet.SPWorkManagementServiceCmdletPipeBind

Specifies the local Work Management Service application that is associated with the new proxy.

The value must be in one of the following forms:

--A valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh

--A valid name of a Work Management Service application (for example, WorkManServ1)

--An instance of a valid SPServiceApplication object

Uri

Optional

System.String

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the New-SPWorkManagementServiceApplicationProxy cmdlet to create a new Work Management Service application proxy object.

Input Types

Return Types

Example

---------------EXAMPLE-----------

Copy code
$serviceApp = Get-SPServiceApplication -name "Work Management Service Application"
Copy code
New-SPWorkManagementServiceApplicationProxy -name "WMServiceProxy" -ServiceApplication $serviceApp

This example creates a new SPWorkManagementServiceApplicationProxy called "WMServiceProxy" mapped to the "Work Management Service Application" Service Application.

See also

New-SPWorkManagementServiceApplication
Set-SPWorkManagementServiceApplication
Set-SPWorkManagementServiceApplicationProxy


Set-SPWorkManagementServiceApplication
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets settings for the Work Management Service application.

Set-SPWorkManagementServiceApplication [-Identity] <SPWorkManagementServiceCmdletPipeBind> [-ApplicationPool <SPIisWebServiceApplicationPoolPipeBind>] [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-MinimumTimeBetweenEwsSyncSubscriptionSearches <TimeSpan>] [-MinimumTimeBetweenProviderRefreshes <TimeSpan>] [-MinimumTimeBetweenSearchQueries <TimeSpan>] [-Name <String>] [-NumberOfSubscriptionSyncsPerEwsSyncRun <UInt32>] [-NumberOfUsersEwsSyncWillProcessAtOnce <UInt32>] [-NumberOfUsersPerEwsSyncBatch <UInt32>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.WorkManagement.Cmdlet.SPWorkManagementServiceCmdletPipeBind

Specifies the service application to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubSettingsApp1); or an instance of a valid SPWorkManagementServiceApplication object

ApplicationPool

Optional

Microsoft.SharePoint.PowerShell.SPIisWebServiceApplicationPoolPipeBind

Specifies the name of an application pool to use; for example, SharePoint - 1213. If no value is specified, the default application pool is used.

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

MinimumTimeBetweenEwsSyncSubscriptionSearches

Optional

System.TimeSpan

Specifies the minimum amount of time (in minutes) to find new tenants that want to synchronize Exchange Web Services tasks. Each tenant needs to be found once using this routine, subsequent users from the same tenant will be picked up on the next tenant synchronization.

MinimumTimeBetweenProviderRefreshes

Optional

System.TimeSpan

Specifies the minimum amount of time (in minutes) between refreshes for a provider for a given user. There cannot be a refresh of data if the value is not met and all refresh operations will contain a null value before a refresh. The default value is 5 minutes.

MinimumTimeBetweenSearchQueries

Optional

System.TimeSpan

Specifies the minimum amount of time (in hours) between calls to search for a given user. This parameter is used to discover new providers not yet known to have tasks for this user. The default value is 3 hours.

Name

Optional

System.String

Specifies the name of the Work Management Service application.

NumberOfSubscriptionSyncsPerEwsSyncRun

Optional

System.UInt32

Specifies the minimum amount of time (in minutes) between calls for a new tenant to synchronize Exchange Web Services tasks. Each tenant needs to be found once using this method, and subsequent users from the same tenant will be found on the next tenant synchronization. The default value is 30 minutes.

NumberOfUsersEwsSyncWillProcessAtOnce

Optional

System.UInt32

Specifies the maximum number of users a service instance machine will synchronize by using Exchange Web Services at one time across all tenants. This has direct influence on the computer workload. Each synchronization will last 45 seconds (constant). The default value is 10.

NumberOfUsersPerEwsSyncBatch

Optional

System.UInt32

Specifies the maximum number of users a service instance will try to synchronize on a given tenant by using the Exchange Web Services per Timer job interval. The default value is 100.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPWorkManagementServiceApplication cmdlet to set settings (that is, minimum time between refreshes for aggregating tasks and load per machine for synchronization with Exchange) for the specified Work Management Service Application by using the Identity parameter.

Input Types

Return Types

Example

---------------EXAMPLE---------------

Copy code
$wmservice = Get-SPServiceApplication -Name "Work Management Service Application"
Copy code
$refreshTime = New-Timespan -Minutes 10
Copy code
Set-SPWorkManagementServiceApplication -Identity $wmservice -MinimumTimeBetweenProviderRefreshes $refreshTime

This example sets the minimum time between provider refreshes to 10 minutes on the service application named "Work Management Service Application".

See also

New-SPWorkManagementServiceApplication
New-SPWorkManagementServiceApplicationProxy
Set-SPWorkManagementServiceApplicationProxy


Set-SPWorkManagementServiceApplicationProxy
See also Example
[image]

Published: July 16, 2012

Applies to: SharePoint Server 2013 Enterprise

Sets the settings for the Work Management Service application proxy.

Set-SPWorkManagementServiceApplicationProxy [-Identity] <SPWorkManagementServiceProxyCmdletPipeBind> [-AssignmentCollection <SPAssignmentCollection>] [-Confirm [<SwitchParameter>]] [-DefaultProxyGroup <SwitchParameter>] [-Name <String>] [-WhatIf [<SwitchParameter>]]

Parameters

Parameter Required Type Description

Identity

Required

Microsoft.Office.Server.WorkManagement.Cmdlet.SPWorkManagementServiceProxyCmdletPipeBind

Specifies the service application proxy to update.

The type must be a valid GUID, in the form 12345678-90ab-cdef-1234-567890bcdefgh; a valid name of a subscription settings service application (for example, SubSettingsApp1); or an instance of a valid SPWorkManagementServiceApplicationProxy object

AssignmentCollection

Optional

Microsoft.SharePoint.PowerShell.SPAssignmentCollection

Manages objects for the purpose of proper disposal. Use of objects, such as SPWeb or SPSite, can use large amounts of memory and use of these objects in Windows PowerShell scripts requires proper memory management. Using the SPAssignment object, you can assign objects to a variable and dispose of the objects after they are needed to free up memory. When SPWeb, SPSite, or SPSiteAdministration objects are used, the objects are automatically disposed of if an assignment collection or the Global parameter is not used.

Note:

When the Global parameter is used, all objects are contained in the global store. If objects are not immediately used, or disposed of by using the Stop-SPAssignment command, an out-of-memory scenario can occur.

Confirm

Optional

System.Management.Automation.SwitchParameter

Prompts you for confirmation before executing the command. For more information, type the following command: get-help about_commonparameters

DefaultProxyGroup

Optional

System.Management.Automation.SwitchParameter

Specifies whether the Work Management Service application proxy is to the default proxy group for the local farm.

Name

Optional

System.String

Specifies the display name for the new Work Management Service application. For example, WorkManService1.

WhatIf

Optional

System.Management.Automation.SwitchParameter

Displays a message that describes the effect of the command instead of executing the command. For more information, type the following command: get-help about_commonparameters

Detailed Description

Use the Set-SPWorkManagementServiceApplicationProxy cmdlet to set the settings for the Work Management service application proxy.

Input Types

Return Types

Example

-------------EXAMPLE--------

Copy code
Set-SPWorkManagementServiceApplicationProxy -Identity "9187d901-e0e0-4509-b117-9eca20d3ead5" -DefaultProxyGroup

This example makes the Work Management service part of the default proxy group.

See also

New-SPWorkManagementServiceApplication
New-SPWorkManagementServiceApplicationProxy
Set-SPWorkManagementServiceApplication


Index of Windows PowerShell cmdlets for SharePoint 2013

Summary: Lists Windows PowerShell cmdlets that are included with SharePoint 2013 in verb order and noun order.

Cmdlets that have an New cmdlet in 2013 icon next to them are new cmdlets in SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

  • SharePoint 2013 cmdlets in verb order

  • SharePoint 2013 cmdlets in noun order

SharePoint 2013 cmdlets in verb order

Cmdlet name | Description
Add-SPAppDeniedEndpoint New cmdlet in 2013 | Adds an endpoint to the Apps denied endpoint list.
Add-SPClaimTypeMapping New cmdlet in 2013 | Adds a claim mapping to a trusted security token service (STS) identity provider.
Add-SPDiagnosticsPerformanceCounter | Adds an instance of a performance counter.
Add-SPDistributedCacheServiceInstance New cmdlet in 2013 | Adds an instance of the distributed cache service to a local server.
Add-SPInfoPathUserAgent | Adds a user agent to a farm.
Add-SPProfileLeader | Adds a company leader.
Add-SPRoutingMachineInfo New cmdlet in 2013 | Adds a new routing target to the farm.
Add-SPRoutingMachinePool New cmdlet in 2013 | Adds a new machine pool.
Add-SPRoutingRule New cmdlet in 2013 | Adds a routing rule.
Add-SPScaleOutDatabase New cmdlet in 2013 | Adds an existing scale-out database to the specified service application.
Add-SPSecureStoreSystemAccount New cmdlet in 2013 | Adds an account to a designated list.
Add-SPServerScaleOutDatabase New cmdlet in 2013 | Adds an existing scale-out database to the specified service application.
Add-SPServiceApplicationProxyGroupMember | Adds a member to the service application proxy group.
Add-SPShellAdmin | Adds a user to the SharePoint_Shell_Access role for the specified database.
Add-SPSiteSubscriptionFeaturePackMember | Adds a feature to a SharePoint feature set.
Add-SPSiteSubscriptionProfileConfig | Adds a new site subscription to a User Profile Service application.
Add-SPSocialAppPermissions New cmdlet in 2013 | Do not use this cmdlet.
Add-SPSolution | Uploads a SharePoint solution package to the farm.
Add-SPThrottlingRule New cmdlet in 2013 | Adds a new throttling rule.
Add-SPUserLicenseMapping New cmdlet in 2013 | Maps a security group, forms-based role, or claim to a SharePoint user license.
Add-SPUserSolution | Uploads a new sandboxed solution to the solution gallery.
Backup-SPConfigurationDatabase | Performs a farm-level configuration-only backup.
Backup-SPEnterpriseSearchServiceApplicationIndex New cmdlet in 2013 | Takes a backup of the search index to a specified backup location.
Backup-SPFarm | Creates a backup of an individual database, web application, or the entire farm.
Backup-SPSite | Performs a backup of a site collection.
Clear-SPAppDeniedEndpointList New cmdlet in 2013 | Removes all App denied endpoints.
Clear-SPBusinessDataCatalogEntityNotificationWeb | Clears the entity notification site.
Clear-SPDistributedCacheItem New cmdlet in 2013 | Clears cached items from the distributed cache server.
Clear-SPLogLevel | Resets the Windows trace logging and event logging levels to their default values.
Clear-SPMetadataWebServicePartitionData | Removes all data for a site subscription on a metadata Web service application
Clear-SPPerformancePointServiceApplicationTrustedLocation | Clears all the trusted locations for a PerformancePoint Services application identity
Clear-SPScaleOutDatabaseDeletedDataSubRange New cmdlet in 2013 | Clears all partitions inside the specified deleted subrange.
Clear-SPScaleOutDatabaseLog New cmdlet in 2013 | Clears all scale-out logs.
Clear-SPScaleOutDatabaseTenantData New cmdlet in 2013 | Removes all data related to the specified site subscription.
Clear-SPSecureStoreCredentialMapping | Deletes a credential mapping from a Secure Store Service application.
Clear-SPSecureStoreDefaultProvider | Clears the secure store provider.
Clear-SPServerScaleOutDatabaseDeletedDataSubRange New cmdlet in 2013 | Clears all partitions inside the specified deleted subrange.
Clear-SPServerScaleOutDatabaseLog New cmdlet in 2013 | Clears all scale-out logs.
Clear-SPServerScaleOutDatabaseTenantData New cmdlet in 2013 | Removes all data related to the specified site subscription.
Clear-SPSiteSubscriptionBusinessDataCatalogConfig | Deletes all data from the Business Data Connectivity Metadata Store for a specified partition.
Connect-SPConfigurationDatabase | Connects the local server computer to a farm.
Convert-SPWebApplication New cmdlet in 2013 | Converts the authentication mode of a web application.
Copy-SPBusinessDataCatalogAclToChildren | Copies a set of permissions of a Business Data Connectivity Metadata Store metadata object to its child objects.
Copy-SPSite | Makes a copy of a site collection.
Disable-SPAppAutoProvision New cmdlet in 2013 | Disables automatic provisioning of an app.
Disable-SPBusinessDataCatalogEntity | Deactivates an external content type in the Business Data Connectivity Metadata Store.
Disable-SPFeature | Disables an installed SharePoint feature at a given scope.
Disable-SPInfoPathFormTemplate | Deactivates an InfoPath 2013 form template from the specified site collection.
Disable-SPSessionStateService | Turns off the session state service on the farm
Disable-SPSingleSignOn | Disables the single sign-on (SSO) service on a farm server.
Disable-SPTimerJob | Disables a timer job.
Disable-SPUserLicensing New cmdlet in 2013 | Disables user license enforcement.
Disable-SPWebApplicationHttpThrottling | Turns off network throttling for a web application.
Disconnect-SPConfigurationDatabase | Disconnects the local server computer from the farm.
Dismount-SPContentDatabase | Detaches a content database from the web application it is currently associated with.
Dismount-SPStateServiceDatabase | Removes the association to a state service database from the farm without dropping the database in the Microsoft SQL Server database
Enable-SPAppAutoProvision New cmdlet in 2013 | Enables automatic provisioning of an app.
Enable-SPBusinessDataCatalogEntity | Activates an external content type in the Business Data Connectivity Metadata Store.
Enable-SPFeature | Enables an installed SharePoint feature at the given scope.
Enable-SPInfoPathFormTemplate | Activates an InfoPath 2013 form template in the specified site collection.
Enable-SPSessionStateService | Creates a session state database and turns on the session state service
Enable-SPTimerJob | Enables a timer job.
Enable-SPUserLicensing New cmdlet in 2013 | Enables user-license enforcement.
Enable-SPWebApplicationHttpThrottling | Turns on network throttling for a web application.
Export-SPAppPackage New cmdlet in 2013 | Exports an app package.
Export-SPBusinessDataCatalogModel | Exports a Business Data Connectivity Model.
Export-SPEnterpriseSearchTopology | Exports an existing search topology.
Export-SPInfoPathAdministrationFiles | Saves InfoPath 2013 form templates on the SharePoint Central Administration web site and .udcx files to a .cab file.
Export-SPMetadataWebServicePartitionData | Exports the data from a metadata Web service for a site subscription.
Export-SPScaleOutDatabaseTenantData New cmdlet in 2013 | Exports the data of the specified subscription.
Export-SPServerScaleOutDatabaseTenantData New cmdlet in 2013 | Exports the data of the specified subscription.
Export-SPSiteSubscriptionBusinessDataCatalogConfig | Exports all data from the Business Data Connectivity Metadata Store associated with a partition.
Export-SPSiteSubscriptionSettings | Creates a backup file of site subscription data.
Export-SPWeb | Exports a site collection, web application, list, or library.
Get-SPAccessServiceApplication | Returns an Access Services application or a collection of Access Services applications.
Get-SPAccessServicesApplication New cmdlet in 2013 | Returns an Access Services application or a collection of Access Services applications.
Get-SPAccessServicesDatabase New cmdlet in 2013 | Returns an Access Services database or a collection of Access Services databases.
Get-SPAccessServicesDatabaseServer New cmdlet in 2013 | Returns the settings for all application servers.
Get-SPAccessServicesDatabaseServerGroup New cmdlet in 2013 | Returns the settings for all application server groups.
Get-SPAccessServicesDatabaseServerGroupMapping New cmdlet in 2013 | Returns the mapping from a source package type to the database server group.
Get-SPAlternateURL | Returns all alternate URLs that match a given set of criteria.
Get-SPAppAcquisitionConfiguration New cmdlet in 2013 | Returns app acquisition settings.
Get-SPAppAutoProvisionConnection New cmdlet in 2013 | Returns provision connection settings for an app.
Get-SPAppDeniedEndpointList New cmdlet in 2013 | Returns the App denied endpoint list.
Get-SPAppDisablingConfiguration New cmdlet in 2013 | Returns the disable list sync state for an app.
Get-SPAppDomain New cmdlet in 2013 | Gets the domain used to host Apps.
Get-SPAppHostingQuotaConfiguration New cmdlet in 2013 | Returns the hosting quotas for an app.
Get-SPAppInstance New cmdlet in 2013 | Returns the hosting quotas for an app.
Get-SPAppStoreConfiguration New cmdlet in 2013 | Returns app SharePoint Store settings.
Get-SPAppPrincipal New cmdlet in 2013 | Displays a specific app principal object.
Get-SPAppScaleProfile New cmdlet in 2013 | Returns settings for an app profile.
Get-SPAppSiteSubscriptionName New cmdlet in 2013 | Returns the name of the specified site subscription.
Get-SPAppDisablingConfiguration New cmdlet in 2013 | Returns the disable list sync state for an app.
Get-SPAppStateSyncLastRunTime New cmdlet in 2013 | Returns the latest time the app state update job was invoked.
Get-SPAppStateUpdateInterval New cmdlet in 2013 | Returns the interval in hours between updates of the app state update job.
Get-SPAuthenticationProvider | Returns an authentication provider.
Get-SPAuthenticationRealm New cmdlet in 2013 | Returns the authentication realms.
Get-SPBackupHistory | Returns a history of backup and restore operations.
Get-SPBingMapsBlock New cmdlet in 2013 | Sets Bing maps to blocked status.
Get-SPBingMapsKey New cmdlet in 2013 | Returns the Bing Maps key.
Get-SPBrowserCustomerExperienceImprovementProgram | Returns the current opt-in state for the browser Customer Experience Improvement Program.
Get-SPBusinessDataCatalogEntityNotificationWeb New cmdlet in 2013 | Returns the entity notification site.
Get-SPBusinessDataCatalogMetadataObject | Returns a Business Data Connectivity Metadata Store metadata object.
Get-SPBusinessDataCatalogThrottleConfig | Returns the throttling configuration for a Business Data Connectivity service application.
Get-SPCertificateAuthority | Returns the SharePoint certificate authority (CA).
Get-SPClaimProvider | Returns a claim provider.
Get-SPClaimProviderManager | Returns a claim provider manager.
Get-SPClaimTypeEncoding New cmdlet in 2013 | Returns a list of all the types of claims.
Get-SPContentDatabase | Returns one or more content databases.
Get-SPContentDeploymentJob | Returns a content deployment job or a collection of content deployment jobs.
Get-SPContentDeploymentPath | Returns a content deployment path or a collection of content deployment paths.
Get-SPCustomLayoutsPage | Returns a mapping to a custom layout page.
Get-SPDatabase | Retrieves all properties of a database.
Get-SPDataConnectionFile | Returns a data connection file or a collection of data connection files.
Get-SPDataConnectionFileDependent | Returns deployed forms on the server dependent on a universal data connection.
Get-SPDesignerSettings | Displays SharePoint Designer 2013 features.
Get-SPDiagnosticConfig | Retrieves ULS diagnostic configuration values of the farm.
Get-SPDiagnosticsPerformanceCounter | Returns a collection of performance counters.
Get-SPDiagnosticsProvider | Returns a diagnostics provider.
Get-SPDistributedCacheClientSetting New cmdlet in 2013 | Returns distributed cache settings from usage.
Get-SPEnterpriseSearchComponent New cmdlet in 2013 | Retrieves one or all search components in a given search topology.
Get-SPEnterpriseSearchContentEnrichmentConfiguration New cmdlet in 2013 | Returns the content enrichment configuration for the specified search service application.
Get-SPEnterpriseSearchCrawlContentSource | Returns a crawl content source.
Get-SPEnterpriseSearchCrawlCustomConnector | Returns a CustomConnector object type.
Get-SPEnterpriseSearchCrawlDatabase | Returns a crawl store.
Get-SPEnterpriseSearchCrawlExtension | Returns the file types to be included in the content index.
Get-SPEnterpriseSearchCrawlMapping | Returns a crawl mapping for the search application.
Get-SPEnterpriseSearchCrawlRule | Accesses crawl rules.
Get-SPEnterpriseSearchFileFormat New cmdlet in 2013 | Lists all parseable file formats.
Get-SPEnterpriseSearchHostController New cmdlet in 2013 | Lists the specified or all search host controllers in the farm.
Get-SPEnterpriseSearchLanguageResourcePhrase | Returns a language resource phrase.
Get-SPEnterpriseSearchLinguisticComponentsStatus New cmdlet in 2013 | Returns the status of the linguistic query and document processing components.
Get-SPEnterpriseSearchLinksDatabase New cmdlet in 2013 | Retrieves a reference to a links database.
Get-SPEnterpriseSearchMetadataCategory | Returns a crawled property category.
Get-SPEnterpriseSearchMetadataCrawledProperty | Returns a crawled property.
Get-SPEnterpriseSearchMetadataManagedProperty | Returns a managed property.
Get-SPEnterpriseSearchMetadataMapping | Returns the current state of a managed property mapping.
Get-SPEnterpriseSearchOwner New cmdlet in 2013 | Returns the search object owner.
Get-SPEnterpriseSearchPropertyRule New cmdlet in 2013 | Returns a property rule.
Get-SPEnterpriseSearchPropertyRuleCollection New cmdlet in 2013 | Returns the collection of rules that are applied to search results.
Get-SPEnterpriseSearchQueryAndSiteSettingsService | Returns the search manager service.
Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance | Returns the service manager service instance.
Get-SPEnterpriseSearchQueryAndSiteSettingsServiceProxy | Returns the search manager service proxy.
Get-SPEnterpriseSearchQueryAuthority | Returns an authoritative page.
Get-SPEnterpriseSearchQueryDemoted | Returns a demoted site rule.
Get-SPEnterpriseSearchQueryKeyword | Returns a keyword term.
Get-SPEnterpriseSearchQueryScope | Returns a query results scope.
Get-SPEnterpriseSearchQueryScopeRule | Returns a shared scope rule.
Get-SPEnterpriseSearchQuerySpellingCorrection New cmdlet in 2013 | Returns the object that exposes the Query Spelling Correction (QSC) configuration.
Get-SPEnterpriseSearchQuerySuggestionCandidates | Returns a list of queries.
Get-SPEnterpriseSearchRankingModel | Returns a ranking model.
Get-SPEnterpriseSearchResultItemType New cmdlet in 2013 | Returns result item types.
Get-SPEnterpriseSearchSecurityTrimmer | Returns a custom security trimmer.
Get-SPEnterpriseSearchService | Returns the search service for a farm.
Get-SPEnterpriseSearchServiceApplication | Returns the search service application for a farm.
Get-SPEnterpriseSearchServiceApplicationBackupStore New cmdlet in 2013 | Retrieves information about the search service application backup files.
Get-SPEnterpriseSearchServiceApplicationProxy | Returns the search service application proxy.
Get-SPEnterpriseSearchServiceInstance | Returns the search service instance for a farm.
Get-SPEnterpriseSearchSiteHitRule | Returns the shared site hit rule.
Get-SPEnterpriseSearchStatus | Retrieves diagnostics information for the search components.
Get-SPEnterpriseSearchTopology New cmdlet in 2013 | Retrieves one or all search topologies that belong to a given search service application.
Get-SPEnterpriseSearchVssDataPath New cmdlet in 2013 | Retrieves the index paths for all active search index components on the current server.
Get-SPExcelBlockedFileType | Returns a file type or list of file types that are prevented from being loaded.
Get-SPExcelDataConnectionLibrary | Returns a trusted data connection library or a list of trusted data connection libraries.
Get-SPExcelDataProvider | Returns a safe data provider or a list of safe data providers.
Get-SPExcelFileLocation | Returns a trusted file location or a list of trusted file locations.
Get-SPExcelServiceApplication | Returns an SPExcelServiceApplication object.
Get-SPExcelUserDefinedFunction | Returns a user-defined function or a collection of user-defined functions.
Get-SPFarm | Returns the local SharePoint farm.
Get-SPFarmConfig | Returns a global property or a collection of global properties for the local farm.
Get-SPFeature | Returns the SharePoint features based on a given scope.
Get-SPHelpCollection | Returns Help collection files.
Get-SPInfoPathFormsService | Returns the InfoPath Forms Services in SharePoint Server 2013 settings that are in the farm.
Get-SPInfoPathFormTemplate | Returns an InfoPath 2013 form template.
Get-SPInfoPathUserAgent | Returns a user agent or all the currently defined user agents for the farm.
Get-SPInfoPathWebServiceProxy | Returns the web proxy settings for the web application.
Get-SPInternalAppStateSyncLastRunTime New cmdlet in 2013 | Returns the latest time the internal app state update job was invoked.
Get-SPInternalAppStateUpdateInterval New cmdlet in 2013 | Returns the interval in hours between updates of the internal app state update job.
Get-SPIRMSettings New cmdlet in 2013 | Returns the Information Rights Management (IRM) settings.
Get-SPLogEvent | Returns results from a Unified Logging Service (ULS) trace log.
Get-SPLogLevel | Returns a list of objects or diagnostic levels.
Get-SPManagedAccount | Retrieves accounts registered in the configuration database.
Get-SPMarketplaceConnectionSettings New cmdlet in 2013 | Returns SharePoint Store settings.
Get-SPManagedPath | Returns all managed paths that match the given criteria.
Get-SPMetadataServiceApplication | Returns the properties of a service application or a collection of service applications.
Get-SPMetadataServiceApplicationProxy | Returns the properties of a service application proxy or a collection of service application proxies.
Get-SPMobileMessagingAccount | Retrieves mobile messaging accounts for the specified web application.
Get-SPODataConnectionSettingMetaData New cmdlet in 2013 | Returns a Business Data Connectivity service metadata object.
Get-SPOfficeStoreAppsDefaultActivation New cmdlet in 2013 | Returns the properties of apps for Office.
Get-SPPendingUpgradeActions New cmdlet in 2013 | Displays pending upgrade actions.
Get-SPPerformancePointServiceApplication | Returns a PerformancePoint Service application object and properties.
Get-SPPerformancePointServiceApplicationTrustedLocation | Returns a trusted location object and properties for a PerformancePoint Services application.
Get-SPProcessAccount | Returns a system account or a managed account.
Get-SPProduct | Returns a list of the SharePoint-related products installed in the farm and the versions of all updates installed for each product.
Get-SPProfileLeader | Returns the current company leaders.
Get-SPProfileServiceApplicationSecurity | Returns permission and identity information.
Get-SPRequestManagementSettings New cmdlet in 2013 | Returns a Request Manager object.
Get-SPRoutingMachineInfo New cmdlet in 2013 | Returns all the routing targets.
Get-SPRoutingMachinePool New cmdlet in 2013 | Returns all available routing pools.
Get-SPRoutingRule New cmdlet in 2013 | Returns all routing rules.
Get-SPScaleOutDatabase New cmdlet in 2013 | Returns all scale-out database objects.
Get-SPScaleOutDatabaseDataState New cmdlet in 2013 | Returns the state information about the specified scale-out database.
Get-SPScaleOutDatabaseInconsistency New cmdlet in 2013 | Displays all inconsistencies related to scale-out databases' ranges.
Get-SPScaleOutDatabaseLogEntry New cmdlet in 2013 | Queries a scale-out database for scale-out logs.
Get-SPSecureStoreApplication | Returns a Secure Store application.
Get-SPSecureStoreSystemAccount New cmdlet in 2013 | Returns a list of users from a designated list.
Get-SPSecurityTokenServiceConfig | Returns the security token service (STS) for the farm.
Get-SPServer | Returns the server or servers in the farm that match the given identity.
Get-SPServerScaleOutDatabase New cmdlet in 2013 | Returns all scale-out database objects.
Get-SPServerScaleOutDatabaseDataState New cmdlet in 2013 | Returns the state information about the specified scale-out database.
Get-SPServerScaleOutDatabaseInconsistency New cmdlet in 2013 | Displays all inconsistencies related to scale-out databases' ranges.
Get-SPServerScaleOutDatabaseLogEntry New cmdlet in 2013 | Queries a scale-out database for scale-out logs.
Get-SPServiceApplication | Returns the specified service application.
Get-SPServiceApplicationEndpoint | Returns the endpoint of a service application.
Get-SPServiceApplicationPool | Returns the specified Internet Information Services (IIS) application pool.
Get-SPServiceApplicationProxy | Returns an instance of the specified service application proxy.
Get-SPServiceApplicationProxyGroup | Returns the proxy group for the specified service application.
Get-SPServiceApplicationSecurity | Returns the SPObjectSecurity object for a service application.
Get-SPServiceContext | Returns a service context.
Get-SPServiceHostConfig | Returns the common web service settings.
Get-SPServiceInstance | Returns the services instance for a specific server or the entire farm.
Get-SPSessionStateService | Returns the properties of the session state service, including time-out and database settings
Get-SPShellAdmin | Returns the names of all users who have the SharePoint_Shell_Access role.
Get-SPSite | Returns all site collections that match the given criteria.
Get-SPSiteAdministration | Returns a site administration object that farm administrators can use to view certain information about site collections to which they might not have access.
Get-SPSiteSubscription | Returns the site subscription for the given URL or all site subscriptions in the local farm.
Get-SPSiteSubscriptionConfig | Returns the configuration properties of a site subscription.
Get-SPSiteSubscriptionEdiscoveryHub | Displays the eDiscovery hub for a site subscription.
Get-SPSiteSubscriptionEdiscoverySearchScope | Displays the search scope for the eDiscovery hub of the specified site collection.
Get-SPSiteSubscriptionFeaturePack | Retrieves available SharePoint feature sets or the Feature set assigned to a given site subscription.
Get-SPSiteSubscriptionIRMConfig New cmdlet in 2013 | Gets the Information Rights Management (IRM) settings.
Get-SPSiteSubscriptionMetadataConfig | Returns the site subscription configuration settings for a metadata service application.
Get-SPSiteUpgradeSessionInfo New cmdlet in 2013 | Manage or report site upgrade.
Get-SPSiteUrl New cmdlet in 2013 | Displays all URL mappings for the site.
Get-SPSolution | Returns a specified SharePoint solution.
Get-SPStateServiceApplication | Returns state service applications on the farm
Get-SPStateServiceApplicationProxy | Returns state service application proxies on the farm.
Get-SPStateServiceDatabase | Returns a state service database.
Get-SPTaxonomySession | Returns a TaxonomySession object.
Get-SPThrottlingRule New cmdlet in 2013 | Returns all throttling rules.
Get-SPTimerJob | Returns timer jobs.
Get-SPTopologyServiceApplication | Displays properties of the topology service application for the current farm.
Get-SPTopologyServiceApplicationProxy | Retrieves the topology service application proxy.
Get-SPTrustedIdentityTokenIssuer | Returns an identity provider.
Get-SPTrustedRootAuthority | Returns a trusted root authority.
Get-SPTrustedSecurityTokenIssuer New cmdlet in 2013 | Returns the trusted security token issuer object.
Get-SPUpgradeActions New cmdlet in 2013 | Returns all upgrade actions.
Get-SPUsageApplication | Returns a specified usage application.
Get-SPUsageDefinition | Returns a usage definition object.
Get-SPUsageService | Returns a usage service.
Get-SPUser | Returns the user account or accounts that match a given search criteria.
Get-SPUserLicense New cmdlet in 2013 | Returns the list of supported SharePoint user licenses.
Get-SPUserLicenseMapping New cmdlet in 2013 | Returns the claim-to-user license mappings.
Get-SPUserLicensing New cmdlet in 2013 | Returns the state of user-license enforcement.
Get-SPUserSolution | Returns a specified sandboxed solution.
Get-SPVisioExternalData | Returns the settings for external data connections for a Visio Services application.
Get-SPVisioPerformance | Returns the Visio Services settings for the performance of a Visio Services application.
Get-SPVisioSafeDataProvider | Returns the settings of a safe data provider for a Visio Services application.
Get-SPVisioServiceApplication | Returns properties of a Visio Services application or a collection of Visio Services applications.
Get-SPVisioServiceApplicationProxy | Returns properties of a Visio Services application proxy or a collection of Visio Services application proxies
Get-SPWeb | Returns all subsites that match the given criteria.
Get-SPWebApplication | Returns all web applications that match the given criteria.
Get-SPWebApplicationAppDomain | Returns all app domains for a specific web application.
Get-SPWebApplicationHttpThrottlingMonitor | Reads all counters for network throttling on a web application.
Get-SPWebPartPack | Returns the Web Part packages that were installed for the specified scope.
Get-SPWebTemplate | Displays all globally installed site templates that match the given identity.
Get-SPWorkflowConfig | Returns workflow settings for the specified web application.
Get-SPWOPIBinding New cmdlet in 2013 | Returns a list of bindings that were created by using New-SPWOPIBinding on the current SharePoint farm where this cmdlet is run.
Get-SPWOPISuppressionSetting New cmdlet in 2013 | Returns the suppression settings on the current SharePoint farm where this cmdlet is run.
Get-SPWOPIZone New cmdlet in 2013 | Returns the zone that is configured on the current SharePoint farm for the WOPI application to use.
Grant-SPBusinessDataCatalogMetadataObject | Grants a right to a principal for the specified Business Data Connectivity Metadata Store metadata object.
Grant-SPObjectSecurity | Adds a new security principal to an SPObjectSecurity object.
Import-SPAppPackage New cmdlet in 2013 | Imports an app package.
Import-SPBusinessDataCatalogDotNetAssembly | Imports data that is associated with the Business Data Connectivity Metadata Store for a partition.
Import-SPBusinessDataCatalogModel | Imports a Business Data Connectivity Model.
Import-SPEnterpriseSearchCustomExtractionDictionary New cmdlet in 2013 | Imports a custom extraction dictionary.
Import-SPEnterpriseSearchPopularQueries New cmdlet in 2013 | Imports queries from a comma-separated list. The search box will suggest these queries as users type.
Import-SPEnterpriseSearchThesaurus New cmdlet in 2013 | Deploys the dictionary to the thesaurus component in the query processing flow.
Import-SPEnterpriseSearchTopology | Imports and activates a topology from an XML file.
Import-SPInfoPathAdministrationFiles | Imports InfoPath 2013 form templates and .udcx files that are located on the SharePoint Central Administration web site.
Import-SPMetadataWebServicePartitionData | Restores the data for a site subscription.
Import-SPScaleOutDatabaseTenantData New cmdlet in 2013 | Imports data from the specified subscription id.
Import-SPServerScaleOutDatabaseTenantData New cmdlet in 2013 | Imports data from the specified subscription id.
Import-SPSiteSubscriptionSettings | Restores a backup of subscription site settings to the given subscription identifier.
Import-SPWeb | Imports a site collection, web application, list, or library.
Initialize-SPResourceSecurity | Enforces resource security on the local server.
Initialize-SPStateServiceDatabase | Installs the state database schema into a state service database
Install-SPApp New cmdlet in 2013 | Installs an instance of an app.
Install-SPApplicationContent | Copies shared application data to existing web application folders.
Install-SPDataConnectionFile | Installs the provided data connection file.
Install-SPFeature | Installs a SharePoint feature by using the Feature.xml file.
Install-SPHelpCollection | Installs the provided Help site collection files in the current farm.
Install-SPInfoPathFormTemplate | Installs an InfoPath 2013 form template on a farm.
Install-SPService | Installs and provisions services on a farm.
Install-SPSolution | Deploys an installed SharePoint solution in the farm.
Install-SPUserSolution | Activates a sandboxed solution in a site collection.
Install-SPWebPartPack | Installs the specified Web Part package to the specified location.
Merge-SPLogFile | Combines trace log entries from all farm computers into a single log file on the local computer.
Mount-SPContentDatabase | Attaches an existing content database to the farm.
Mount-SPStateServiceDatabase | Attaches an existing state service database to the farm
Move-SPBlobStorageLocation | Copies a content database by using Remote BLOB Storage (RBS).
Move-SPDeletedSite | Moves deleted site collections from one content database to another.
Move-SPEnterpriseSearchLinksDatabases New cmdlet in 2013 | Repartitions data across links databases.
Move-SPProfileManagedMetadataProperty | Moves multiple-string values into a term set.
Move-SPSocialComments | Moves social comments.
Move-SPSite | Moves site collections from one content database to another.
Move-SPUser | Migrates a user account in SharePoint 2010 Products.
New-SPAccessServiceApplication | Creates a new instance of an Access Services application.
New-SPAccessServicesApplication New cmdlet in 2013 | Creates a new instance of an Access Services application in SharePoint Server 2013.
New-SPAccessServicesDatabaseServer New cmdlet in 2013 | Adds a new SQL Server database to the list of servers.
New-SPAlternateUrl | Creates a new public or internal URL for the specified web application zone or resource.
New-SPAppManagementServiceApplication New cmdlet in 2013 | Creates an App Management Service application.
New-SPAppManagementServiceApplicationProxy New cmdlet in 2013 | Creates an App Management Service application proxy.
New-SPAuthenticationProvider | Creates a new authentication provider in the farm.
New-SPAzureAccessControlServiceApplicationProxy New cmdlet in 2013 | Creates a new service application proxy group.
New-SPBECWebServiceApplicationProxy New cmdlet in 2013 | Do not use this cmdlet.
New-SPBusinessDataCatalogServiceApplication | Creates a new Business Data Connectivity service application in the farm.
New-SPBusinessDataCatalogServiceApplicationProxy | Creates a new Business Data Connectivity service application proxy in the farm.
New-SPCentralAdministration | Creates a new SharePoint Central Administration web application.
New-SPClaimProvider | Registers a new claim provider in the farm.
New-SPClaimsPrincipal | Creates a new claims principal.
New-SPClaimTypeEncoding New cmdlet in 2013 | Registers a new type of claim.
New-SPClaimTypeMapping New cmdlet in 2013 | Creates a claim mapping rule for a security token service (STS) identity provider.
New-SPConfigurationDatabase | Creates a new configuration database.
New-SPContentDatabase | Creates a new content database and attaches it to the specified web application.
New-SPContentDeploymentJob | Creates a content deployment job.
New-SPContentDeploymentPath | Creates a new content deployment path.
New-SPEnterpriseSearchAdminComponent New cmdlet in 2013 | Creates a new admin component for the given topology and search service instance.
New-SPEnterpriseSearchAnalyticsProcessingComponent New cmdlet in 2013 | Creates a new analytics processing component for the given topology and search service instance.
New-SPEnterpriseSearchContentEnrichmentConfiguration New cmdlet in 2013 | Creates a new ContentEnrichmentConfiguration object.
New-SPEnterpriseSearchContentProcessingComponent | Creates a new content processing component for the given topology and search service instance.
New-SPEnterpriseSearchCrawlComponent | Adds a query component to a query topology.
New-SPEnterpriseSearchCrawlContentSource | Creates a new crawl content source for a shared search application.
New-SPEnterpriseSearchCrawlCustomConnector | Registers a protocol for custom crawling.
New-SPEnterpriseSearchCrawlDatabase | Creates a crawl database which can be added to a search service application.
New-SPEnterpriseSearchCrawlExtension | Adds an extension rule to a shared search application.
New-SPEnterpriseSearchCrawlMapping | Creates a crawl mapping rule for a shared search application.
New-SPEnterpriseSearchCrawlRule | Creates a new crawl rule.
New-SPEnterpriseSearchFileFormat New cmdlet in 2013 | Adds a new file format in the parsing system.
New-SPEnterpriseSearchIndexComponent New cmdlet in 2013 | Creates a new index component for the given topology and search service instance.
New-SPEnterpriseSearchLanguageResourcePhrase New cmdlet in 2013 | Adds a language resource phrase to a shared search application.
New-SPEnterpriseSearchLinksDatabase New cmdlet in 2013 | Creates a new links database for a search service application.
New-SPEnterpriseSearchMetadataCategory | Adds a crawled property category to a search service application.
New-SPEnterpriseSearchMetadataCrawledProperty | Adds a crawled property to a search application crawled property category.
New-SPEnterpriseSearchMetadataManagedProperty | Adds a managed property to a shared search application.
New-SPEnterpriseSearchMetadataMapping | Adds a managed property mapping to a shared search application.
New-SPEnterpriseSearchQueryAuthority | Adds an authoritative page to a shared search application.
New-SPEnterpriseSearchQueryDemoted | Adds a demoted site rule to a shared search application.
New-SPEnterpriseSearchQueryKeyword | Adds a keyword term to a shared search application.
New-SPEnterpriseSearchQueryProcessingComponent New cmdlet in 2013 | Creates a new query processing component for the given topology and search service instance.
New-SPEnterpriseSearchQueryScope | Adds a query results scope to a shared search application.
New-SPEnterpriseSearchQueryScopeRule | Adds a shared scope rule to a query scope.
New-SPEnterpriseSearchRankingModel | Adds a ranking model to a shared search application.
New-SPEnterpriseSearchResultItemType New cmdlet in 2013 | Creates a new result item type.
New-SPEnterpriseSearchSecurityTrimmer | Adds a custom security trimmer to a shared search application.
New-SPEnterpriseSearchServiceApplication | Adds a search service application to a farm.
New-SPEnterpriseSearchServiceApplicationProxy | Adds a new search application proxy to a farm..
New-SPEnterpriseSearchSiteHitRule | Adds a new site hit rule for a search application.
New-SPEnterpriseSearchTopology New cmdlet in 2013 | Creates a new search topology in the given search service application.
New-SPExcelBlockedFileType | Adds a file type to the list of file types that Excel Services Application prevents from being loaded.
New-SPExcelDataConnectionLibrary | Adds a new data connection library to Excel Services Application.
New-SPExcelDataProvider | Adds a new safe data provider to Excel Services Application.
New-SPExcelFileLocation | Adds a new trusted location to Excel Services Application.
New-SPExcelServiceApplication | Creates a new instance of Excel Services Application.
New-SPExcelUserDefinedFunction | Adds a new user-defined function to Excel Services Application.
New-SPLogFile | Creates a new log file.
New-SPManagedAccount | Registers a new managed account.
New-SPManagedPath | Creates a new managed path for the given web application for all host header site collections.
New-SPMarketplaceWebServiceApplicationProxy New cmdlet in 2013 | Creates a service application proxy for the app identity data web service.
New-SPMetadataServiceApplication | Creates a new metadata service application.
New-SPMetadataServiceApplicationProxy | Creates a new metadata service application proxy.
New-SPODataConnectionSetting New cmdlet in 2013 | Creates a new Business Data Connectivity service connection.
New-SPPerformancePointServiceApplication | Creates a new service application for PerformancePoint Services.
New-SPPerformancePointServiceApplicationProxy | Creates a proxy for a PerformancePoint Services application.
New-SPPerformancePointServiceApplicationTrustedLocation | Creates a new trusted location for a PerformancePoint Services application.
New-SPPowerPointConversionServiceApplication | Creates a PowerPoint Conversion Service application.
New-SPPowerPointConversionServiceApplicationProxy | Creates a PowerPoint Conversion Service application proxy.
New-SPProfileServiceApplication | Adds a User Profile Service application to a farm.
New-SPProfileServiceApplicationProxy | Creates a User Profile Service application proxy on the local farm.
New-SPRequestManagementRuleCriteria New cmdlet in 2013 | Creates criteria for the rule to match.
New-SPSecureStoreApplication | Creates a new Secure Store application.
New-SPSecureStoreApplicationField | Creates a new Secure Store application fields object.
New-SPSecureStoreServiceApplication | Creates a new Secure Store Service application in the farm.
New-SPSecureStoreServiceApplicationProxy | Creates a new Secure Store Service application proxy in the farm.
New-SPSecureStoreTargetApplication | Creates a new Secure Store target application.
New-SPServiceApplicationPool | Creates a new Web service application pool.
New-SPServiceApplicationProxyGroup | Creates a new service application proxy group.
New-SPSite | Creates a new site collection at the specified URL.
New-SPSiteSubscription | Creates a new site subscription.
New-SPSiteSubscriptionFeaturePack | Creates a new SharePoint feature set that can be used to limit the features available to a site subscription.
New-SPStateServiceApplication | Creates a new state service application
New-SPStateServiceApplicationProxy | Creates a proxy for a state service application
New-SPStateServiceDatabase | Creates and provisions a new state service database, and installs the state database schema into it
New-SPSubscriptionSettingsServiceApplication | Creates a new subscription settings service application.
New-SPSubscriptionSettingsServiceApplicationProxy | Creates an application proxy to a subscription settings service application.
New-SPTranslationServiceApplication New cmdlet in 2013 | Provisions a new instance of the Machine Translation service.
New-SPTranslationServiceApplicationProxy New cmdlet in 2013 | Creates a Machine Translation Service application proxy on the local farm.
New-SPTrustedIdentityTokenIssuer | Creates an identity provider in the farm.
New-SPTrustedRootAuthority | Creates a trusted root authority.
New-SPTrustedSecurityTokenIssuer New cmdlet in 2013 | Creates a trust between a server to server principal.
New-SPTrustedServiceTokenIssuer | Creates a trust with a SharePoint farm.
New-SPUsageApplication | Creates a new usage application.
New-SPUsageLogFile | Starts a new usage log file on the current server computer.
New-SPUser | Adds an existing user to a SharePoint site with the designated permissions.
New-SPUserLicenseMapping New cmdlet in 2013 | Creates a license mapping object.
New-SPVisioSafeDataProvider | Adds a new data provider to a Visio Services application.
New-SPVisioServiceApplication | Adds a new Visio Services application to a farm.
New-SPVisioServiceApplicationProxy | Adds a new Visio Services application proxy to a farm.
New-SPWeb | Creates a new site in an existing site collection.
New-SPWebApplication | Creates a new web application within the local farm.
New-SPWebApplicationAppDomain | Creates or changes a AppDomain entry.
New-SPWebApplicationExtension | Creates a new zone instance for the web application.
New-SPWOPIBinding New cmdlet in 2013 | Creates a new binding to associate file name extensions or applications with actions on the current SharePoint farm where this cmdlet is run.
New-SPWOPISuppressionSetting New cmdlet in 2013 | The New-SPWOPISuppressionSetting cmdlet turns off Office Web Apps for the action and document type or binding you've specified on the current SharePoint farm.
New-SPWordConversionServiceApplication | Creates a new instance of a Word Automation Services application on the farm.
New-SPWorkManagementServiceApplication New cmdlet in 2013 | Creates a new Work Management Service application.
New-SPWorkManagementServiceApplicationProxy New cmdlet in 2013 | Creates a new service application proxy group.
Publish-SPServiceApplication | Shares the specified local service application outside the farm.
Register-SPAppPrincipal | Lets an on-premises or SharePoint Online administrator register an app principal.
Register-SPWorkflowService | Configures the SharePoint host to use a workflow service.
Remove-SPAccessServicesDatabaseServer New cmdlet in 2013 | Removes the specified database server.
Remove-SPAlternateUrl | Completely deletes the specified alternate URL.
Remove-SPAppDeniedEndpoint New cmdlet in 2013 | Removes an endpoint from the Apps denied endpoint list.
Remove-SPAppPrincipalPermission New cmdlet in 2013 | Removes the permissions on a specified app principal.
Remove-SPBusinessDataCatalogModel | Deletes a Business Data Connectivity Model.
Remove-SPClaimProvider | Unregisters a claim provider.
Remove-SPClaimTypeMapping | Deletes a claim type mapping rule for a security token service (STS) identity provider.
Remove-SPConfigurationDatabase | Permanently removes a configuration database.
Remove-SPContentDatabase | Deletes a content database.
Remove-SPContentDeploymentJob | Removes a content deployment job.
Remove-SPContentDeploymentPath | Removes a content deployment path.
Remove-SPDiagnosticsPerformanceCounter | Removes an instance of a performance counter.
Remove-SPDistributedCacheServiceInstance New cmdlet in 2013 | Removes an instance of the distributed cache service from a local server.
Remove-SPEnterpriseSearchComponent New cmdlet in 2013 | Removes the specified search component from the given search topology.
Remove-SPEnterpriseSearchContentEnrichmentConfiguration New cmdlet in 2013 | Removes the current content enrichment configuration from the search service application.
Remove-SPEnterpriseSearchCrawlContentSource | Deletes a specified crawl content source from a search application.
Remove-SPEnterpriseSearchCrawlCustomConnector | Removes a CustomConnector object.
Remove-SPEnterpriseSearchCrawlDatabase | Sets properties of a crawl database for a search service application.
Remove-SPEnterpriseSearchCrawlExtension | Removes a file name extension from the list of files that can be crawled.
Remove-SPEnterpriseSearchCrawlLogReadPermission New cmdlet in 2013 | Removes permission to view crawl log information.
Remove-SPEnterpriseSearchCrawlMapping | Deletes a crawl mapping.
Remove-SPEnterpriseSearchCrawlRule | Deletes a crawl rule.
Remove-SPEnterpriseSearchFileFormat New cmdlet in 2013 | Remove a previously registered file format from the system.
Remove-SPEnterpriseSearchLanguageResourcePhrase | Deletes a language resource phrase from a shared search application.
Remove-SPEnterpriseSearchLinksDatabase New cmdlet in 2013 | Deletes a links database.
Remove-SPEnterpriseSearchMetadataCategory | Deletes a crawled property category.
Remove-SPEnterpriseSearchMetadataManagedProperty | Deletes a metadata managed property.
Remove-SPEnterpriseSearchMetadataMapping | Deletes a metadata mapping from a managed property.
Remove-SPEnterpriseSearchQueryAuthority | Deletes an authoritative page.
Remove-SPEnterpriseSearchQueryDemoted | Deletes a demoted site rule.
Remove-SPEnterpriseSearchQueryKeyword | Deletes a query keyword.
Remove-SPEnterpriseSearchQueryScope | Deletes a query scope.
Remove-SPEnterpriseSearchQueryScopeRule | Deletes query results scope rules.
Remove-SPEnterpriseSearchRankingModel | Deletes a ranking model.
Remove-SPEnterpriseSearchResultItemType New cmdlet in 2013 | Creates a new result item type.
Remove-SPEnterpriseSearchSecurityTrimmer | Deletes a custom security trimmer.
Remove-SPEnterpriseSearchServiceApplication | Deletes a search service application.
Remove-SPEnterpriseSearchServiceApplicationProxy | Deletes a search service application proxy.
Remove-SPEnterpriseSearchServiceApplicationSiteSettings New cmdlet in 2013 | Cleans up search settings for a particular site collection, subscription, or search application
Remove-SPEnterpriseSearchSiteHitRule | Deletes a site hit rule.
Remove-SPEnterpriseSearchTenantConfiguration New cmdlet in 2013 | Removes all tenant specific search settings.
Remove-SPEnterpriseSearchTenantSchema New cmdlet in 2013 | Removes a defined search schema.
Remove-SPEnterpriseSearchTopology New cmdlet in 2013 | Removes an inactive search topology from a search service application.
Remove-SPExcelBlockedFileType | Removes an entry from the list of file types that are prevented from being loaded on Excel Services Application.
Remove-SPExcelDataConnectionLibrary | Removes a data connection library from Excel Services Application.
Remove-SPExcelDataProvider | Removes a data provider from Excel Services Application.
Remove-SPExcelFileLocation | Removes a trusted file location from Excel Services Application.
Remove-SPExcelUserDefinedFunction | Removes a user-defined function from Excel Services Application.
Remove-SPInfoPathUserAgent | Removes a user agent.
Remove-SPManagedAccount | Removes a managed account registration from the farm.
Remove-SPManagedPath | Deletes the specified managed path from the specified host header or web application.
Remove-SPODataConnectionSetting New cmdlet in 2013 | Removes a Business Connectivity Services connection.
Remove-SPPerformancePointServiceApplication | Deletes a PerformancePoint Services application from a farm.
Remove-SPPerformancePointServiceApplicationProxy | Deletes the proxy for a PerformancePoint Services application.
Remove-SPPerformancePointServiceApplicationTrustedLocation | Removes a single trusted location from a PerformancePoint Services application.
Remove-SPProfileLeader | Remove a company leader.
Remove-SPRoutingMachineInfo New cmdlet in 2013 | Removes an external routing target.
Remove-SPRoutingMachinePool New cmdlet in 2013 | Removes a routing pool from Request Manager.
Remove-SPRoutingRule New cmdlet in 2013 | Removes a routing rule.
Remove-SPScaleOutDatabase New cmdlet in 2013 | Removes a specific scale-out database.
Remove-SPSecureStoreApplication | Deletes a Secure Store application.
Remove-SPSecureStoreSystemAccount New cmdlet in 2013 | Removes a user account from a designated list.
Remove-SPServerScaleOutDatabase New cmdlet in 2013 | Removes a specific scale-out database.
Remove-SPServiceApplication | Deletes the specified service application on the local server.
Remove-SPServiceApplicationPool | Completely deletes the specified Web service application pool.
Remove-SPServiceApplicationProxy | Deletes the specified service application proxy.
Remove-SPServiceApplicationProxyGroup | Completely deletes the specified service application proxy group.
Remove-SPServiceApplicationProxyGroupMember | Removes one or more proxies from the specified service application proxy group.
Remove-SPShellAdmin | Removes a user from the SharePoint_Shell_Access role.
Remove-SPSite | Completely deletes an existing site collection and all subsites.
Remove-SPSiteSubscription | Removes data stored in a subscription settings service application for a set of site subscriptions.
Remove-SPSiteSubscriptionBusinessDataCatalogConfig | Removes the Business Data Connectivity Metadata Store for a partition.
Remove-SPSiteSubscriptionFeaturePack | Removes a SharePoint feature set from a site subscription.
Remove-SPSiteSubscriptionFeaturePackMember | Removes a feature definition from the provided SharePoint feature set.
Remove-SPSiteSubscriptionMetadataConfig | Removes site subscription configuration settings.
Remove-SPSiteSubscriptionProfileConfig | Deletes a site subscription from a User Profile Service application.
Remove-SPSiteSubscriptionSettings | Removes the settings service data for a specified site subscription, or finds and removes orphaned data.
Remove-SPSiteUpgradeSessionInfo New cmdlet in 2013 | Removes an SPSite object from upgrade.
Remove-SPSiteUrl New cmdlet in 2013 | Removes an URL mapping from the site.
Remove-SPSocialAppPermissions New cmdlet in 2013 | Do not use this cmdlet.
Remove-SPSocialItemByDate | Deletes tags, notes, or ratings.
Remove-SPSolution | Removes a SharePoint solution from a farm.
Remove-SPSolutionDeploymentLock | Removes the solution deployment lock for a server.
Remove-SPStateServiceDatabase | Removes a state service database from a state service application and drops it from the SQL Server
Remove-SPThrottlingRule New cmdlet in 2013 | Removes a throttling rule.
Remove-SPTranslationServiceJobHistory New cmdlet in 2013 | Removes Machine Translation service jobs.
Remove-SPTrustedIdentityTokenIssuer | Deletes a security token service (STS) identity provider from the farm.
Remove-SPTrustedRootAuthority | Deletes a trusted root authority.
Remove-SPTrustedSecurityTokenIssuer New cmdlet in 2013 | Removes the trusted security token service object.
Remove-SPTrustedServiceTokenIssuer | Deletes the object that represents the farm trust.
Remove-SPUsageApplication | Removes a usage application from the local farm.
Remove-SPUser | Removes a user from a web site.
Remove-SPUserLicenseMapping New cmdlet in 2013 | Removes a claim-to-SharePoint user license mapping.
Remove-SPUserSolution | Removes a sandboxed solution from the solution gallery.
Remove-SPVisioSafeDataProvider | Removes a data provider from a Visio Services application.
Remove-SPWeb | Completely deletes the specified web.
Remove-SPWebApplication | Deletes the specified web application.
Remove-SPWebApplicationAppDomain | Deletes the AppDomain.
Remove-SPWOPIBinding New cmdlet in 2013 | Removes bindings for applications, file name extensions, and their associated actions on the current SharePoint farm where this cmdlet is run.
Remove-SPWOPISuppressionSetting New cmdlet in 2013 | Removes the suppression settings for a file type or program ID (ProgID) on the current SharePoint farm where this cmdlet is run.
Remove-SPWordConversionServiceJobHistory | Removes entries from the Word Automation Services job history database.
Rename-SPServer | Renames a server that is currently connected to the farm.
Repair-SPManagedAccountDeployment | Repairs the local managed account credential deployment.
Repair-SPSite | Activates the RunRepairs method against the referenced SPSite object.
Request-SPUpgradeEvaluationSite New cmdlet in 2013 | Requests an upgrade evaluation site for a specified site.
Reset-SPAccessServicesDatabasePassword New cmdlet in 2013 | Resets the passwords for all logons for user application databases.
Restart-SPAppInstanceJobs New cmdlet in 2013 | Restarts an app instance.
Restore-SPEnterpriseSearchServiceApplication | Restores a third-party backup of a search application.
Restore-SPEnterpriseSearchServiceApplicationIndex New cmdlet in 2013 | Restores the search index from the specified backup files.
Restore-SPFarm | Restores one or more items from a backup.
Restore-SPSite | Restores a site collection.
Resume-SPEnterpriseSearchServiceApplication | Resumes a search service application that was suspended.
Resume-SPStateServiceDatabase | Resumes a paused state service database so that new rows of data are received
Revoke-SPBusinessDataCatalogMetadataObject | Revokes a right to a principal in the specified Business Data Connectivity Metadata Store metadata object.
Revoke-SPObjectSecurity | Removes a security principal from a SPObjectSecurity object.
Set-SPAccessServicesApplication New cmdlet in 2013 | Sets global properties of an existing Access Services application in SharePoint Server 2013.
Set-SPAccessServicesDatabaseServer New cmdlet in 2013 | Specifies whether or not a database in SQL Server is available.
Set-SPAccessServicesDatabaseServerGroupMapping New cmdlet in 2013 | Sets server group mappings.
Set-SPAccessServiceApplication | Sets global properties of an existing Access Services application.
Set-SPAlternateUrl | Configures the specified alternate URL.
Set-SPAppAcquisitionConfiguration New cmdlet in 2013 | Sets app acquisition settings.
Set-SPAppAutoProvisionConnection New cmdlet in 2013 | Sets provision connection settings for an app.
Set-SPAppDisablingConfiguration New cmdlet in 2013 | Sets the disable list sync state for an app.
Set-SPAppDomain New cmdlet in 2013 | Sets the domain used to host Apps.
Set-SPAppHostingQuotaConfiguration New cmdlet in 2013 | Sets hosting quotas for an app.
Set-SPAppManagementDeploymentId New cmdlet in 2013 | Sets the identifier of the farm or tenant used by the Office Marketplace to issue App licenses.
Set-SPAppStoreConfiguration New cmdlet in 2013 | Sets SharePoint Store settings for an app.
Set-SPAppPrincipalPermission New cmdlet in 2013 | Sets the permissions on a given app principal.
Set-SPAppScaleProfile New cmdlet in 2013 | Sets settings for the app profile.
Set-SPAppSiteSubscriptionName New cmdlet in 2013 | Sets or changes the name for the specified site subscription.
Set-SPAppDisablingConfiguration New cmdlet in 2013 | Sets the disable list sync state for an app.
Set-SPAppStateUpdateInterval New cmdlet in 2013 | Sets the interval in hours between updates of the app state update job.
Set-SPAuthenticationRealm New cmdlet in 2013 | Sets the authentication realm.
Set-SPBingMapskey New cmdlet in 2013 | Sets the Bing Maps key.
Set-SPBrowserCustomerExperienceImprovementProgram | Turns on or off the browser Customer Experience Improvement Program.
Set-SPBusinessDataCatalogEntityNotificationWeb | Sets the entity notification site.
Set-SPBusinessDataCatalogMetadataObject | Sets the value of a property or attribute of a Business Data Connectivity Metadata Store metadata object.
Set-SPBusinessDataCatalogServiceApplication | Sets global properties for a Business Data Connectivity service application in the farm.
Set-SPBusinessDataCatalogThrottleConfig | Sets the throttling configuration for a Business Data Connectivity Service application.
Set-SPCentralAdministration | Sets the port for the SharePoint Central Administration web site.
Set-SPClaimProvider | Updates registration of a claims provider.
Set-SPContentDatabase | Sets global properties of a SharePoint content database.
Set-SPContentDeploymentJob | Sets properties of a content deployment job.
Set-SPContentDeploymentPath | Sets properties of a content deployment path.
Set-SPCustomLayoutsPage | Maps a new path for a custom layout page.
Set-SPDataConnectionFile | Sets properties of a data connection file.
Set-SPDesignerSettings | Sets SharePoint Designer 2013 features.
Set-SPDiagnosticConfig | Sets diagnostic configuration settings on the farm.
Set-SPDiagnosticsProvider | Enables a diagnostics provider and updates its retention policy.
Set-SPDistributedCacheClientSetting | Sets distributed cache settings.
Set-SPEnterpriseSearchContentEnrichmentConfiguration New cmdlet in 2013 | Stores the specified content enrichment configuration to the search service application.
Set-SPEnterpriseSearchCrawlContentSource | Sets the properties of a crawl content source for a shared search application.
Set-SPEnterpriseSearchCrawlDatabase | Sets properties of a crawl database for a search service application.
Set-SPEnterpriseSearchCrawlLogReadPermission New cmdlet in 2013 | Grants users permission to view the crawl log information.
Set-SPEnterpriseSearchCrawlRule | Sets properties for a crawl rule.
Set-SPEnterpriseSearchDCTMConnectorConfig New cmdlet in 2013 | Configures the Microsoft SharePoint 2013 Indexing Connector for Documentum.
Set-SPEnterpriseSearchFileFormatState | Enables or disables parsing of a given file format.
Set-SPEnterpriseSearchLinguisticComponentsStatus New cmdlet in 2013 | Sets the operation status of the linguistic query and document processing components.
Set-SPEnterpriseSearchLinksDatabase New cmdlet in 2013 | Sets properties of a links database for a search service application.
Set-SPEnterpriseSearchMetadataCategory | Sets properties of a crawled property category for a shared search application.
Set-SPEnterpriseSearchMetadataCrawledProperty | Sets the properties of a metadata crawled property for a shared search application.
Set-SPEnterpriseSearchMetadataManagedProperty | Sets the properties of a metadata managed property.
Set-SPEnterpriseSearchMetadataMapping | Sets the properties of a managed property mapping for a shared search application.
Set-SPEnterpriseSearchPrimaryHostController New cmdlet in 2013 | Sets the primary search host controller for the farm.
Set-SPEnterpriseSearchQueryAuthority | Sets the properties of an authoritative page for a shared search application.
Set-SPEnterpriseSearchQueryKeyword | Sets the properties of a keyword term for a shared search application.
Set-SPEnterpriseSearchQueryScope | Sets the properties of a query results scope for a shared search application.
Set-SPEnterpriseSearchQueryScopeRule | Sets the properties of a shared scope rule for a query scope.
Set-SPEnterpriseSearchQuerySpellingCorrection New cmdlet in 2013 | Sets the operation status of the Query Spelling Corrections (QSC) component.
Set-SPEnterpriseSearchRankingModel | Sets the properties of a ranking model for a shared search application.
Set-SPEnterpriseSearchResultItemType New cmdlet in 2013 | Sets properties of a result item type.
Set-SPEnterpriseSearchService | Sets the properties of a search service for a farm.
Set-SPEnterpriseSearchServiceApplication | Sets the properties of a search service application for a farm.
Set-SPEnterpriseSearchServiceApplicationProxy | Sets properties of a search service application proxy.
Set-SPEnterpriseSearchServiceInstance | Sets the properties of a search service instance.
Set-SPEnterpriseSearchTopology New cmdlet in 2013 | Activates a given search topology.
Set-SPExcelDataConnectionLibrary | Sets properties of a data connection library for Excel Services Application.
Set-SPExcelDataProvider | Sets properties of a safe data provider for Excel Services Application.
Set-SPExcelFileLocation | Sets properties of a trusted file location for Excel Services Application.
Set-SPExcelServiceApplication | Sets global properties for Excel Services Application.
Set-SPExcelUserDefinedFunction | Sets properties of a user-defined function in Excel Services Application.
Set-SPFarmConfig | Sets a global property or a collection of global properties for the local farm.
Set-SPInfoPathFormsService | Sets parameters for InfoPath Forms Services in SharePoint Server 2013.
Set-SPInfoPathFormTemplate | Sets properties of an InfoPath 2013 form template.
Set-SPInfoPathWebServiceProxy | Sets parameters for an existing SharePoint Web service application.
Set-SPInternalAppStateUpdateInterval New cmdlet in 2013 | Sets the interval in hours between updates of the internal app state update job.
Set-SPIRMSettings New cmdlet in 2013 | Sets the Information Rights Management (IRM) settings.
Set-SPLogLevel | Sets the trace and event level for a set of categories.
Set-SPManagedAccount | Configures the managed account.
Set-SPMarketplaceConnectionSettings | Sets SharePoint Store connection settings.
Set-SPMetadataServiceApplication | Sets the properties for a metadata service application.
Set-SPMetadataServiceApplicationProxy | Sets the properties for a metadata service application proxy.
Set-SPMobileMessagingAccount | Configures the specified mobile messaging account.
Set-SPODataConnectionSetting New cmdlet in 2013 | Sets or updates global properties for a Microsoft Business Connectivity Services connection.
Set-SPODataConnectionSettingMetaData New cmdlet in 2013 | Updates properties for the metadata of a Business Connectivity Services connection.
Set-SPOfficeStoreAppsDefaultActivation New cmdlet in 2013 | Sets the properties of apps for Office.
Set-SPPassPhrase | Sets the passphrase to a new value.
Set-SPPerformancePointSecureDataValues | Sets global settings for the unattended service account.
Set-SPPerformancePointServiceApplication | Sets global run-time properties for a PerformancePoint Services application.
Set-SPPowerPointConversionServiceApplication | Configures settings for a PowerPoint Conversion Service application.
Set-SPProfileServiceApplication | Sets properties of a User Profile Service application.
Set-SPProfileServiceApplicationProxy | Sets properties of a proxy for a User Profile Service application.
Set-SPProfileServiceApplicationSecurity | Sets permission and identity information.
Set-SPRequestManagementSettings New cmdlet in 2013 | Sets Request Manager properties.
Set-SPRoutingMachineInfo New cmdlet in 2013 | Sets routing target properties.
Set-SPRoutingMachinePool New cmdlet in 2013 | Sets properties of a machine pool.
Set-SPRoutingRule New cmdlet in 2013 | Changes properties of an existing routing rule.
Set-SPScaleOutDatabaseDataRange New cmdlet in 2013 | Extends the range of a specified scale-out database.
Set-SPScaleOutDatabaseDataSubRange New cmdlet in 2013 | Creates a subrange for a specified scale-out database.
Set-SPSecureStoreApplication | Sets properties of a Secure Store application.
Set-SPSecureStoreDefaultProvider | Sets or updates the secure store provider.
Set-SPSecureStoreServiceApplication | Sets properties of a Secure Store Service application in the farm.
Set-SPSecurityTokenServiceConfig | Updates the settings of the SharePoint security token service (STS) identity provider.
Set-SPServerScaleOutDatabaseDataRange New cmdlet in 2013 | Extends the range of a specified scale-out database.
Set-SPServerScaleOutDatabaseDataSubRange New cmdlet in 2013 | Creates a subrange for a specified scale-out database.
Set-SPServiceApplication | Sets properties of a service application.
Set-SPServiceApplicationEndpoint | Sets the host of an endpoint for a service application.
Set-SPServiceApplicationPool | Changes the account used for the Identity of the specified application pool.
Set-SPServiceApplicationSecurity | Updates the SPObjectSecurity object for a service application.
Set-SPServiceHostConfig | Configures one or more common settings for all Web services.
Set-SPSessionStateService | Updates the credentials that are used to communicate with the state service database
Set-SPSite | Configures the specified site collection.
Set-SPSiteAdministration | Allows farm administrators to configure any site collection.
Set-SPSiteSubscriptionConfig | Sets the configuration properties of a site subscription.
Set-SPSiteSubscriptionEdiscoveryHub | Sets properties for the eDiscovery hub of a site subscription.
Set-SPSiteSubscriptionIRMConfig New cmdlet in 2013 | Sets the Information Rights Management (IRM) settings.
Set-SPSiteSubscriptionMetadataConfig | Sets the site subscription configuration settings for a specified metadata service application.
Set-SPSiteSubscriptionProfileConfig | Sets the parameters of a site subscription.
Set-SPSiteUrl New cmdlet in 2013 | Adds or changes an URL mapping for the site.
Set-SPStateServiceApplication | Updates the name of a state service application
Set-SPStateServiceApplicationProxy | Updates the name of a state service application proxy
Set-SPStateServiceDatabase | Updates properties of a state service database
Set-SPSubscriptionSettingsServiceApplication | Sets properties of a subscription settings service application.
Set-SPThrottlingRule New cmdlet in 2013 | Changes properties of an existing throttling rule.
Set-SPTimerJob | Sets the schedule for running a timer job.
Set-SPTopologyServiceApplication | Sets the properties on the topology service application of the local farm.
Set-SPTopologyServiceApplicationProxy | Sets the proxy properties of the topology service application.
Set-SPTranslationServiceApplication New cmdlet in 2013 | Sets property settings on a Machine Translation service application.
Set-SPTranslationServiceApplicationProxy New cmdlet in 2013 | Sets properties to the Machine Translation service application proxy.
Set-SPTrustedIdentityTokenIssuer | Sets the identity providers of a web application.
Set-SPTrustedRootAuthority | Creates a new trusted root authority.
Set-SPTrustedSecurityTokenIssuer New cmdlet in 2013 | Sets the trusted token issuer.
Set-SPTrustedServiceTokenIssuer | Updates a trust with the farm.
Set-SPUsageApplication | Sets properties of a usage application.
Set-SPUsageDefinition | Sets the retention period for a usage provider.
Set-SPUsageService | Sets the properties of a usage service.
Set-SPUser | Configures properties on an existing user.
Set-SPVisioExternalData | Configures settings related to external data connections for a Visio Services application.
Set-SPVisioPerformance | Sets performance properties for a Visio Services application.
Set-SPVisioSafeDataProvider | Specifies a description of a safe data provider for a Visio Services application.
Set-SPVisioServiceApplication | Sets the ServiceApplicationPool property for a Visio Services application.
Set-SPWeb | Configures the specified subsite.
Set-SPWebApplication | Configures the specified web application.
Set-SPWebApplicationHttpThrottlingMonitor | Sets the Health Score bucket values for an existing network throttling performance counter for a specified web application.
Set-SPWOPIBinding New cmdlet in 2013 | Updates the default click action for an application or file name extension binding.
Set-SPWOPIZone New cmdlet in 2013 | Configures the zone that the current SharePoint farm will use to navigate the browser to the WOPI application.
Set-SPWordConversionServiceApplication | Sets properties of a Word Automation Services application.
Set-SPWorkflowConfig | Configures the workflow settings for the specified web application.
Set-SPWorkManagementServiceApplication New cmdlet in 2013 | Sets settings for the Work Management Service application.
Set-SPWorkManagementServiceApplicationProxy New cmdlet in 2013 | Sets the settings for the Work Management Service application proxy.
Split-SPScaleOutDatabase New cmdlet in 2013 | Moves a specified percentage of partitions from one scale-out database to another.
Split-SPServerScaleOutDatabase New cmdlet in 2013 | Moves a specified percentage of partitions from one scale-out database to another.
Start-SPAdminJob | Immediately starts any waiting administrative job on the local computer.
Start-SPAssignment | Initiates a new assignment store.
Start-SPContentDeploymentJob | Starts a content deployment job.
Start-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance | Starts an instance of a search manager service.
Start-SPEnterpriseSearchServiceInstance | Starts an instance of a search service.
Start-SPInfoPathFormTemplate | Activates a previously quiesced InfoPath 2013 form template.
Start-SPServiceInstance | Starts the service instance for a service on a specific server or the farm.
Start-SPTimerJob | Runs a timer job once.
Stop-SPAssignment | Disposes of objects in the provided assignment collection.
Start-SPDiagnosticsSession New cmdlet in 2013 | Reports diagnostic information to the usage database.
Stop-SPDiagnosticsSession New cmdlet in 2013 | Stops the diagnostics session.
Stop-SPDistributedCacheServiceInstance New cmdlet in 2013 | Stops an instance of the distributed cache service on a local server.
Stop-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance | Stops an instance of a search manager service.
Stop-SPEnterpriseSearchServiceInstance | Stops an instance of a search manager service.
Stop-SPInfoPathFormTemplate | Disables an InfoPath 2013 form template on a farm before an upgrade.
Stop-SPServiceInstance | Stops the service instance for a service.
Suspend-SPEnterpriseSearchServiceApplication | Suspends a search service application, pausing all crawls and search operations, to perform a task such as system maintenance.
Suspend-SPEnterpriseSearchServiceApplication | Suspends a search service application, pausing all crawls and search operations, to perform a task such as system maintenance.
Suspend-SPStateServiceDatabase | Pauses a state database and thus prevents new rows of data from being added to a database
Test-SPContentDatabase | Tests a content database.
Test-SPInfoPathFormTemplate | Validates that an InfoPath 2013 form template is browser-enabled.
Test-SPSite New cmdlet in 2013 | Activates the RunTests method against a referenced SPSite object.
Uninstall-SPAppInstance New cmdlet in 2013 | Uninstalls an instance of an app.
Uninstall-SPDataConnectionFile | Removes a data connection file.
Uninstall-SPFeature | Uninstalls an installed feature definition.
Uninstall-SPHelpCollection | Removes Help collection files.
Uninstall-SPInfoPathFormTemplate | Removes an InfoPath 2013 form template from a farm.
Uninstall-SPSolution | Retracts a deployed SharePoint solution.
Uninstall-SPUserSolution | Deactivates a sandboxed solution in a site collection.
Uninstall-SPWebPartPack | Uninstalls the specified Web Part package.
Unpublish-SPServiceApplication | Stops sharing the specified service application outside the farm.
Update-SPAppCatalogSettings New cmdlet in 2013 | Sets a specific site collection as the App Catalog site collection.
Update-SPAppInstance New cmdlet in 2013 | Updates the app instance.
Update-SPFarmEncryptionKey | Changes the value of the farm encryption key and, using the new key, re-encrypts all the data.
Update-SPInfoPathAdminFileUrl | Updates InfoPath 2013 form templates (.xsn files) and universal data connections (.udcx files), including all .xsn files and .udcx files that were deployed by an administrator.
Update-SPInfoPathUserFileUrl | Updates InfoPath form templates (.xsn files) and universal data connections (.udcx files).
Update-SPProfilePhotoStore | Updates the profile photo store to be compatible with SharePoint 2013
Update-SPRepopulateMicroblogFeedCache New cmdlet in 2013 | Refreshes the cache.
Update-SPRepopulateMicroblogLMTCache New cmdlet in 2013 | Refreshes the cache.
Update-SPSecureStoreApplicationServerKey | Synchronizes the key on a server running SharePoint Server by using the Secure Store master key.
Update-SPSecureStoreCredentialMapping | Sets a new credential mapping for a Secure Store Service application.
Update-SPSecureStoreGroupCredentialMapping | Sets a new group credential mapping for a Secure Store Service application.
Update-SPSecureStoreMasterKey | Changes the master key of a Secure Store Service application.
Update-SPSolution | Upgrades a deployed SharePoint solution.
Update-SPUserSolution | Upgrades an activated sandboxed solution in a farm.
Update-SPWOPIProofKey New cmdlet in 2013 | Updates the public key that is used to connect to the WOPI application on the current SharePoint farm where this cmdlet is run.
Upgrade-SPContentDatabase | Upgrades a content database.
Upgrade-SPEnterpriseSearchServiceApplication | Upgrades a search service application.
Upgrade-SPEnterpriseSearchServiceApplicationSiteSettings New cmdlet in 2013 | Upgrades search settings for a particular site collection
Upgrade-SPFarm | Activates the Upgrade method for the local farm.
Upgrade-SPSingleSignOnDatabase | Migrates the application definitions from single sign-on (SSO) database to Secure Store database as target applications.
Upgrade-SPSite | Starts the upgrade process on a site collection.

SharePoint 2013 cmdlets in noun order

Cmdlet name | Description
Get-SPAccessServiceApplication | Returns an Access Services application or a collection of Access Services applications.
Get-SPAccessServicesApplication New cmdlet in 2013 | Returns an Access Services application or a collection of Access Services applications.
Get-SPAccessServicesDatabase New cmdlet in 2013 | Returns an Access Services database or a collection of Access Services databases.
Get-SPAccessServicesDatabaseServer New cmdlet in 2013 | Returns the settings for all application servers.
Get-SPAccessServicesDatabaseServerGroup New cmdlet in 2013 | Returns the settings for all application server groups.
Get-SPAccessServicesDatabaseServerGroupMapping New cmdlet in 2013 | Returns the mapping from a source package type to the database server group.
New-SPAccessServiceApplication | Creates a new instance of an Access Services application.
New-SPAccessServicesApplication New cmdlet in 2013 | Creates a new instance of an Access Services application in SharePoint Server 2013.
New-SPAccessServicesDatabaseServer New cmdlet in 2013 | Adds a new SQL Server database to the list of servers.
Remove-SPAccessServicesDatabaseServer New cmdlet in 2013 | Removes the specified database server.
Reset-SPAccessServicesDatabasePassword New cmdlet in 2013 | Resets the passwords for all logons for user application databases.
Set-SPAccessServiceApplication | Sets global properties of an existing Access Services application.
Set-SPAccessServicesApplication New cmdlet in 2013 | Sets global properties of an existing Access Services application in SharePoint Server 2013.
Set-SPAccessServicesDatabaseServer New cmdlet in 2013 | Specifies whether or not a database in SQL Server is available.
Set-SPAccessServicesDatabaseServerGroupMapping New cmdlet in 2013 | Sets server group mappings.
Start-SPAdminJob | Immediately starts any waiting administrative job on the local computer.
Get-SPAlternateURL | Returns all alternate URLs that match a given set of criteria.
New-SPAlternateUrl | Creates a new public or internal URL for the specified web application zone or resource.
Remove-SPAlternateUrl | Completely deletes the specified alternate URL.
Set-SPAlternateUrl | Configures the specified alternate URL.
Install-SPApp New cmdlet in 2013 | Installs an instance of an app.
Get-SPAppAcquisitionConfiguration New cmdlet in 2013 | Returns app acquisition settings.
Set-SPAppAcquisitionConfiguration New cmdlet in 2013 | Sets app acquisition settings.
Disable-SPAppAutoProvision New cmdlet in 2013 | Disables automatic provisioning of an app.
Enable-SPAppAutoProvision New cmdlet in 2013 | Enables automatic provisioning of an app.
Get-SPAppAutoProvisionConnection New cmdlet in 2013 | Returns provision connection settings for an app.
Set-SPAppAutoProvisionConnection New cmdlet in 2013 | Sets provision connection settings for an app.
Update-SPAppCatalogConfiguration New cmdlet in 2013 | Sets a specific site collection as the App Catalog site collection.
Add-SPAppDeniedEndpoint New cmdlet in 2013 | Adds an endpoint to the Apps denied endpoint list.
Remove-SPAppDeniedEndpoint New cmdlet in 2013 | Removes an endpoint from the Apps denied endpoint list.
Clear-SPAppDeniedEndpointList New cmdlet in 2013 | Removes all App denied endpoints.
Get-SPAppDeniedEndpointList New cmdlet in 2013 | Gets the App denied endpoint list.
Get-SPAppDisablingConfiguration New cmdlet in 2013 | Returns the disable list sync state for an app.
Set-SPAppDisablingConfiguration New cmdlet in 2013 | Sets the disable list sync state for an app.
Get-SPAppDomain New cmdlet in 2013 | Gets the domain used to host Apps.
Set-SPAppDomain New cmdlet in 2013 | Sets the domain used to host Apps.
Get-SPAppHostingQuotaConfiguration New cmdlet in 2013 | Returns the hosting quotas for an app.
Set-SPAppHostingQuotaConfiguration New cmdlet in 2013 | Sets hosting quotas for an app.
Get-SPAppInstance New cmdlet in 2013 | Returns the hosting quotas for an app.
Uninstall-SPAppInstance New cmdlet in 2013 | Uninstalls an instance of an app.
Update-SPAppInstance New cmdlet in 2013 | Updates the app instance.
Restart-SPAppInstanceJobs New cmdlet in 2013 | Restarts an app instance.
Install-SPApplicationContent | Copies shared application data to existing web application folders.
Set-SPAppManagementDeploymentId New cmdlet in 2013 | Sets the identifier of the farm or tenant used by the Office Marketplace to issue App licenses.
New-SPAppManagementServiceApplication New cmdlet in 2013 | Creates an App Management Service application.
New-SPAppManagementServiceApplicationProxy New cmdlet in 2013 | Creates an App Management Service application proxy.
Export-SPAppPackage New cmdlet in 2013 | Exports an app package.
Import-SPAppPackage New cmdlet in 2013 | Imports an app package.
Get-SPAppPrincipal New cmdlet in 2013 | Displays a specific app principal object.
Register-SPAppPrincipal New cmdlet in 2013 | Lets an on-premises or SharePoint Online administrator register an app principal.
Remove-SPAppPrincipalPermission New cmdlet in 2013 | Removes the permissions on a specified app principal.
Set-SPAppPrincipalPermission New cmdlet in 2013 | Sets the permissions on a given app principal.
Get-SPAppScaleProfile New cmdlet in 2013 | Returns settings for an app profile.
Set-SPAppScaleProfile New cmdlet in 2013 | Sets settings for the app profile.
Get-SPAppSiteSubscriptionName New cmdlet in 2013 | Returns the name of the specified site subscription.
Set-SPAppSiteSubscriptionName New cmdlet in 2013 | Sets or changes the name for the specified site subscription.
Get-SPAppStateUpdateInterval New cmdlet in 2013 | Returns the interval in hours between updates of the app state update job.
Set-SPAppStateUpdateInterval New cmdlet in 2013 | Sets the interval in hours between updates of the app state update job.
Get-SPAppStateSyncLastRunTime New cmdlet in 2013 | Returns the latest time the app state update job was invoked.
Get-SPAppStoreConfiguration New cmdlet in 2013 | Returns app SharePoint Store settings.
Set-SPAppStoreConfiguration New cmdlet in 2013 | Sets SharePoint Store settings for an app.
Start-SPAssignment | Initiates a new assignment store.
Stop-SPAssignment | Disposes of objects in the provided assignment collection.
Get-SPAuthenticationProvider | Returns an authentication provider.
New-SPAuthenticationProvider | Creates a new authentication provider in the farm.
Get-SPAuthenticationRealm New cmdlet in 2013 | Returns the authentication realms.
Set-SPAuthenticationRealm New cmdlet in 2013 | Sets the authentication realm.
New-SPAzureAccessControlServiceApplicationProxy New cmdlet in 2013 | Creates a new service application proxy group.
Get-SPBackupHistory | Returns a history of backup and restore operations.
New-SPBECWebServiceApplicationProxy New cmdlet in 2013 | Do not use this cmdlet.
Get-SPBingMapsBlock New cmdlet in 2013 | Sets Bing maps to blocked status.
Get-SPBingMapsKey | Returns the Bing Maps key.
Set-SPBingMapsBlock New cmdlet in 2013 | Returns Bing Maps blocked status.
Set-SPBingMapskey New cmdlet in 2013 | Sets the Bing Maps key.
Move-SPBlobStorageLocation | Copies a content database by using Remote BLOB Storage (RBS).
Get-SPBrowserCustomerExperienceImprovementProgram | Returns the current opt-in state for the browser Customer Experience Improvement Program.
Set-SPBrowserCustomerExperienceImprovementProgram | Turns on or off the browser Customer Experience Improvement Program.
Copy-SPBusinessDataCatalogAclToChildren | Copies a set of permissions of a Business Data Connectivity Metadata Store metadata object to its child objects.
Import-SPBusinessDataCatalogDotNetAssembly | Imports data that is associated with the Business Data Connectivity Metadata Store for a partition.
Disable-SPBusinessDataCatalogEntity | Deactivates an external content type in the Business Data Connectivity Metadata Store.
Enable-SPBusinessDataCatalogEntity | Activates an external content type in the Business Data Connectivity Metadata Store.
Get-SPBusinessDataCatalogMetadataObject | Returns a Business Data Connectivity Metadata Store metadata object.
Grant-SPBusinessDataCatalogMetadataObject | Grants a right to a principal for the specified Business Data Connectivity Metadata Store metadata object.
Revoke-SPBusinessDataCatalogMetadataObject | Revokes a right to a principal in the specified Business Data Connectivity Metadata Store metadata object.
Set-SPBusinessDataCatalogMetadataObject | Sets the value of a property or attribute of a Business Data Connectivity Metadata Store metadata object.
Export-SPBusinessDataCatalogModel | Exports a Business Data Connectivity Model.
Import-SPBusinessDataCatalogModel | Imports a Business Data Connectivity Model.
Remove-SPBusinessDataCatalogModel | Deletes a Business Data Connectivity Model.
New-SPBusinessDataCatalogServiceApplication | Creates a new Business Data Connectivity service application in the farm.
Set-SPBusinessDataCatalogServiceApplication | Sets global properties for a Business Data Connectivity service application in the farm.
New-SPBusinessDataCatalogServiceApplicationProxy | Creates a new Business Data Connectivity service application proxy in the farm.
Get-SPBusinessDataCatalogThrottleConfig | Returns the throttling configuration for a Business Data Connectivity Service application.
Set-SPBusinessDataCatalogThrottleConfig | Sets the throttling configuration for a Business Data Connectivity Service application.
Clear-SPBusinessDataCatalogEntityNotificationWeb New cmdlet in 2013 | Clears the entity notification site.
Get-SPBusinessDataCatalogEntityNotificationWeb New cmdlet in 2013 | Returns the entity notification site.
Set-SPBusinessDataCatalogEntityNotificationWeb New cmdlet in 2013 | Sets the entity notification site.
New-SPCentralAdministration | Creates a new SharePoint Central Administration web application.
Set-SPCentralAdministration | Sets the port for the SharePoint Central Administration web site.
Get-SPCertificateAuthority | Returns the SharePoint certificate authority (CA).
Get-SPClaimProvider | Returns a claim provider.
New-SPClaimProvider | Registers a new claim provider in the farm.
Remove-SPClaimProvider | Unregisters a claim provider.
Set-SPClaimProvider | Updates registration of a claims provider.
Get-SPClaimProviderManager | Returns a claim provider manager.
Get-SPClaimTypeEncoding New cmdlet in 2013 | Returns a list of all the types of claims.
New-SPClaimTypeEncoding New cmdlet in 2013 | Registers a new type of claim.
New-SPClaimsPrincipal | Creates a new claims principal.
Add-SPClaimTypeMapping | Adds a claim mapping to a trusted security token service (STS) identity provider.
New-SPClaimTypeMapping | Creates a claim mapping rule for a security token service (STS) identity provider.
Remove-SPClaimTypeMapping | Deletes a claim type mapping rule for a security token service (STS) identity provider.
Backup-SPConfigurationDatabase | Performs a farm-level configuration-only backup.
Connect-SPConfigurationDatabase | Connects the local server computer to a farm.
Disconnect-SPConfigurationDatabase | Disconnects the local server computer from the farm.
New-SPConfigurationDatabase | Creates a new configuration database.
Remove-SPConfigurationDatabase | Permanently removes a configuration database.
Dismount-SPContentDatabase | Detaches a content database from the web application it is currently associated with.
Get-SPContentDatabase | Returns one or more content databases.
Mount-SPContentDatabase | Attaches an existing content database to the farm.
New-SPContentDatabase | Creates a new content database and attaches it to the specified web application.
Remove-SPContentDatabase | Deletes a content database.
Set-SPContentDatabase | Sets global properties of a SharePoint content database.
Test-SPContentDatabase | Tests a content database.
Upgrade-SPContentDatabase | Upgrades a content database.
Get-SPContentDeploymentJob | Returns a content deployment job or a collection of content deployment jobs.
New-SPContentDeploymentJob | Creates a content deployment job.
Remove-SPContentDeploymentJob | Removes a content deployment job.
Set-SPContentDeploymentJob | Sets properties of a content deployment job.
Start-SPContentDeploymentJob | Starts a content deployment job.
Get-SPContentDeploymentPath | Returns a content deployment path or a collection of content deployment paths.
New-SPContentDeploymentPath | Creates a new content deployment path.
Remove-SPContentDeploymentPath | Removes a content deployment path.
Set-SPContentDeploymentPath | Sets properties of a content deployment path.
Get-SPCustomLayoutsPage | Returns a mapping to a custom layout page.
Set-SPCustomLayoutsPage | Maps a new path for a custom layout page.
Get-SPDatabase | Retrieves all properties of a database.
Get-SPDataConnectionFile | Returns a data connection file or a collection of data connection files.
Install-SPDataConnectionFile | Installs the provided data connection file.
Set-SPDataConnectionFile | Sets properties of a data connection file.
Uninstall-SPDataConnectionFile | Removes a data connection file.
Get-SPDataConnectionFileDependent | Returns deployed forms on the server dependent on a universal data connection.
Move-SPDeletedSite | Moves deleted site collections from one content database to another.
Get-SPDesignerSettings | Displays SharePoint Designer 2013 features.
Set-SPDesignerSettings | Sets SharePoint Designer 2013 features.
Get-SPDiagnosticConfig | Retrieves ULS diagnostic configuration values of the farm.
Set-SPDiagnosticConfig | Sets diagnostic configuration settings on the farm.
Add-SPDiagnosticsPerformanceCounter | Adds an instance of a performance counter.
Get-SPDiagnosticsPerformanceCounter | Returns a collection of performance counters.
Remove-SPDiagnosticsPerformanceCounter | Removes an instance of a performance counter.
Get-SPDiagnosticsProvider | Returns a diagnostics provider.
Set-SPDiagnosticsProvider | Enables a diagnostics provider and updates its retention policy.
Start-SPDiagnosticsSession New cmdlet in 2013 | Reports diagnostic information to the usage database.
Stop-SPDiagnosticsSession New cmdlet in 2013 | Stops the diagnostics session.
Get-SPDistributedCacheClientSetting New cmdlet in 2013 | Returns distributed cache settings from usage.
Set-SPDistributedCacheClientSetting New cmdlet in 2013 | Sets distributed cache settings.
Clear-SPDistributedCacheItem New cmdlet in 2013 | Clears cached items from the distributed cache server.
Add-SPDistributedCacheServiceInstance New cmdlet in 2013 | Adds an instance of the distributed cache service to a local server.
Remove-SPDistributedCacheServiceInstance New cmdlet in 2013 | Removes an instance of the distributed cache service from a local server.
Stop-SPDistributedCacheServiceInstance | Stops an instance of the distributed cache service on a local server.
New-SPEnterpriseSearchAdminComponent New cmdlet in 2013 | Creates a new admin component for the given topology and search service instance.
New-SPEnterpriseSearchAnalyticsProcessingComponent New cmdlet in 2013 | Creates a new analytics processing component for the given topology and search service instance.
Get-SPEnterpriseSearchComponent New cmdlet in 2013 | Retrieves one or all search components in a given search topology.
Remove-SPEnterpriseSearchComponent New cmdlet in 2013 | Removes the specified search component from the given search topology.
Get-SPEnterpriseSearchContentEnrichmentConfiguration New cmdlet in 2013 | Returns the content enrichment configuration for the specified search service application.
New-SPEnterpriseSearchContentEnrichmentConfiguration New cmdlet in 2013 | Creates a new ContentEnrichmentConfiguration object.
Remove-SPEnterpriseSearchContentEnrichmentConfiguration New cmdlet in 2013 | Removes the current content enrichment configuration from the search service application.
Set-SPEnterpriseSearchContentEnrichmentConfiguration New cmdlet in 2013 | Stores the specified content enrichment configuration to the search service application.
New-SPEnterpriseSearchContentProcessingComponent New cmdlet in 2013 | Creates a new content processing component for the given topology and search service instance.
New-SPEnterpriseSearchCrawlComponent | Adds a query component to a query topology.
Get-SPEnterpriseSearchCrawlContentSource | Returns a crawl content source.
New-SPEnterpriseSearchCrawlContentSource | Creates a new crawl content source for a shared search application.
Remove-SPEnterpriseSearchCrawlContentSource | Deletes a specified crawl content source from a search application.
Set-SPEnterpriseSearchCrawlContentSource | Sets the properties of a crawl content source for a shared search application.
Get-SPEnterpriseSearchCrawlCustomConnector | Returns a CustomConnector object type.
New-SPEnterpriseSearchCrawlCustomConnector | Registers a protocol for custom crawling.
Remove-SPEnterpriseSearchCrawlCustomConnector | Removes a CustomConnector object.
Get-SPEnterpriseSearchCrawlDatabase | Returns a crawl store.
New-SPEnterpriseSearchCrawlDatabase | Creates a crawl database which can be added to a search service application.
Remove-SPEnterpriseSearchCrawlDatabase | Sets properties of a crawl database for a search service application.
Set-SPEnterpriseSearchCrawlDatabase | Sets properties of a crawl database for a search service application.
Get-SPEnterpriseSearchCrawlExtension | Returns the file types to be included in the content index.
New-SPEnterpriseSearchCrawlExtension | Adds an extension rule to a shared search application.
Remove-SPEnterpriseSearchCrawlExtension | Removes a file name extension from the list of files that can be crawled.
Remove-SPEnterpriseSearchCrawlLogReadPermission New cmdlet in 2013 | Removes permission to view crawl log information.
Set-SPEnterpriseSearchCrawlLogReadPermission New cmdlet in 2013 | Grants users permission to view the crawl log information.
Get-SPEnterpriseSearchCrawlMapping | Returns a crawl mapping for the search application.
New-SPEnterpriseSearchCrawlMapping | Creates a crawl mapping rule for a shared search application.
Remove-SPEnterpriseSearchCrawlMapping | Deletes a crawl mapping.
Get-SPEnterpriseSearchCrawlRule | Accesses crawl rules.
New-SPEnterpriseSearchCrawlRule | Creates a new crawl rule.
Remove-SPEnterpriseSearchCrawlRule | Deletes a crawl rule.
Set-SPEnterpriseSearchCrawlRule | Sets properties for a crawl rule.
Set-SPEnterpriseSearchDCTMConnectorConfig New cmdlet in 2013 | Configures the Microsoft SharePoint 2013 Indexing Connector for Documentum.
Import-SPEnterpriseSearchCustomExtractionDictionary New cmdlet in 2013 | Imports a custom extraction dictionary.
Get-SPEnterpriseSearchFileFormat New cmdlet in 2013 | Lists all parseable file formats.
New-SPEnterpriseSearchFileFormat New cmdlet in 2013 | Adds a new file format in the parsing system.
Remove-SPEnterpriseSearchFileFormat New cmdlet in 2013 | Remove a previously registered file format from the system.
Set-SPEnterpriseSearchFileFormatState | Enables or disables parsing of a given file format.
Get-SPEnterpriseSearchFileFormat New cmdlet in 2013 | Lists the specified or all search host controllers in the farm.
New-SPEnterpriseSearchIndexComponent New cmdlet in 2013 | Creates a new index component for the given topology and search service instance.
Get-SPEnterpriseSearchLinguisticComponentsStatus New cmdlet in 2013 | Returns the status of the linguistic query and document processing components.
Set-SPEnterpriseSearchLinguisticComponentsStatus New cmdlet in 2013 | Sets the operation status of the linguistic query and document processing components.
Get-SPEnterpriseSearchLinksDatabase New cmdlet in 2013 | Retrieves a reference to a links database.
New-SPEnterpriseSearchLinksDatabase New cmdlet in 2013 | Creates a new links database for a search service application.
Remove-SPEnterpriseSearchLinksDatabase New cmdlet in 2013 | Deletes a links database.
Set-SPEnterpriseSearchLinksDatabase New cmdlet in 2013 | Sets properties of a links database for a search service application.
Move-SPEnterpriseSearchLinksDatabases New cmdlet in 2013 | Repartitions data across links databases.
Get-SPEnterpriseSearchLanguageResourcePhrase | Returns a language resource phrase.
New-SPEnterpriseSearchLanguageResourcePhrase | Adds a language resource phrase to a shared search application.
Remove-SPEnterpriseSearchLanguageResourcePhrase | Deletes a language resource phrase from a shared search application.
Get-SPEnterpriseSearchMetadataCategory | Returns a crawled property category.
New-SPEnterpriseSearchMetadataCategory | Adds a crawled property category to a search service application.
Remove-SPEnterpriseSearchMetadataCategory | Deletes a crawled property category.
Set-SPEnterpriseSearchMetadataCategory | Sets properties of a crawled property category for a shared search application.
Get-SPEnterpriseSearchMetadataCrawledProperty | Returns a crawled property.
New-SPEnterpriseSearchMetadataCrawledProperty | Adds a crawled property to a search application crawled property category.
Set-SPEnterpriseSearchMetadataCrawledProperty | Sets the properties of a metadata crawled property for a shared search application.
Get-SPEnterpriseSearchMetadataManagedProperty | Returns a managed property.
New-SPEnterpriseSearchMetadataManagedProperty | Adds a managed property to a shared search application.
Remove-SPEnterpriseSearchMetadataManagedProperty | Deletes a metadata managed property.
Set-SPEnterpriseSearchMetadataManagedProperty | Sets the properties of a metadata managed property.
Get-SPEnterpriseSearchMetadataMapping | Returns the current state of a managed property mapping.
New-SPEnterpriseSearchMetadataMapping | Adds a managed property mapping to a shared search application.
Remove-SPEnterpriseSearchMetadataMapping | Deletes a metadata mapping from a managed property.
Set-SPEnterpriseSearchMetadataMapping | Sets the properties of a managed property mapping for a shared search application.
Get-SPEnterpriseSearchOwner New cmdlet in 2013 | Returns the search object owner.
Import-SPEnterpriseSearchPopularQueries New cmdlet in 2013 | Imports queries from a comma-separated list. The search box will suggest these queries as users type.
Set-SPEnterpriseSearchPrimaryHostController New cmdlet in 2013 | Sets the primary search host controller for the farm.
Get-SPEnterpriseSearchPropertyRule New cmdlet in 2013 | Returns a property rule.
Get-SPEnterpriseSearchPropertyRuleCollection New cmdlet in 2013 | Returns the collection of rules that are applied to search results.
Get-SPEnterpriseSearchQueryAndSiteSettingsService | Returns the search manager service.
Get-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance | Returns the service manager service instance.
Start-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance | Starts an instance of a search manager service.
Stop-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance | Stops an instance of a search manager service.
Get-SPEnterpriseSearchQueryAndSiteSettingsServiceProxy | Returns the search manager service proxy.
Get-SPEnterpriseSearchQueryAuthority | Returns an authoritative page.
New-SPEnterpriseSearchQueryAuthority | Adds an authoritative page to a shared search application.
Remove-SPEnterpriseSearchQueryAuthority | Deletes an authoritative page.
Set-SPEnterpriseSearchQueryAuthority | Sets the properties of an authoritative page for a shared search application.
Get-SPEnterpriseSearchQueryDemoted | Returns a demoted site rule.
New-SPEnterpriseSearchQueryDemoted | Adds a demoted site rule to a shared search application.
Remove-SPEnterpriseSearchQueryDemoted | Deletes a demoted site rule.
Get-SPEnterpriseSearchQueryKeyword | Returns a keyword term.
New-SPEnterpriseSearchQueryKeyword | Adds a keyword term to a shared search application.
Remove-SPEnterpriseSearchQueryKeyword | Deletes a query keyword.
Set-SPEnterpriseSearchQueryKeyword | Sets the properties of a keyword term for a shared search application.
New-SPEnterpriseSearchQueryProcessingComponent New cmdlet in 2013 | Creates a new query processing component for the given topology and search service instance.
Get-SPEnterpriseSearchQueryScope | Returns a query results scope.
New-SPEnterpriseSearchQueryScope | Adds a query results scope to a shared search application.
Remove-SPEnterpriseSearchQueryScope | Deletes a query scope.
Set-SPEnterpriseSearchQueryScope | Sets the properties of a query results scope for a shared search application.
Get-SPEnterpriseSearchQueryScopeRule | Returns a shared scope rule.
New-SPEnterpriseSearchQueryScopeRule | Adds a shared scope rule to a query scope.
Remove-SPEnterpriseSearchQueryScopeRule | Deletes query results scope rules.
Set-SPEnterpriseSearchQueryScopeRule | Sets the properties of a shared scope rule for a query scope.
Get-SPEnterpriseSearchQuerySpellingCorrection New cmdlet in 2013 | Returns the object that exposes the Query Spelling Correction (QSC) configuration.
Set-SPEnterpriseSearchQuerySpellingCorrection New cmdlet in 2013 | Sets the operation status of the Query Spelling Corrections (QSC) component.
Get-SPEnterpriseSearchQuerySuggestionCandidates | Returns a list of queries.
Get-SPEnterpriseSearchRankingModel | Returns a ranking model.
New-SPEnterpriseSearchRankingModel | Adds a ranking model to a shared search application.
Remove-SPEnterpriseSearchRankingModel | Deletes a ranking model.
Set-SPEnterpriseSearchRankingModel | Sets the properties of a ranking model for a shared search application.
Get-SPEnterpriseSearchResultItemType New cmdlet in 2013 | Returns result item types.
New-SPEnterpriseSearchResultItemType New cmdlet in 2013 | Creates a new result item type.
Remove-SPEnterpriseSearchResultItemType New cmdlet in 2013 | Creates a new result item type.
Set-SPEnterpriseSearchResultItemType New cmdlet in 2013 | Sets properties of a result item type.
Get-SPEnterpriseSearchSecurityTrimmer | Returns a custom security trimmer.
New-SPEnterpriseSearchSecurityTrimmer | Adds a custom security trimmer to a shared search application.
Remove-SPEnterpriseSearchSecurityTrimmer | Deletes a custom security trimmer.
Get-SPEnterpriseSearchService | Returns the search service for a farm.
Set-SPEnterpriseSearchService | Sets the properties of a search service for a farm.
Get-SPEnterpriseSearchServiceApplication | Returns the search service application for a farm.
New-SPEnterpriseSearchServiceApplication | Adds a search service application to a farm.
Remove-SPEnterpriseSearchServiceApplication | Deletes a search service application.
Restore-SPEnterpriseSearchServiceApplication | Restores a third-party backup of a search application.
Resume-SPEnterpriseSearchServiceApplication | Resumes a search service application that was suspended.
Set-SPEnterpriseSearchServiceApplication | Sets the properties of a search service application for a farm.
Suspend-SPEnterpriseSearchServiceApplication | Suspends a search service application, pausing all crawls and search operations, to perform a task such as system maintenance.
Upgrade-SPEnterpriseSearchServiceApplication | Upgrades a search service application.
Get-SPEnterpriseSearchServiceApplicationBackupStore New cmdlet in 2013 | Retrieves information about the search service application backup files.
Backup-SPEnterpriseSearchServiceApplicationIndex New cmdlet in 2013 | Takes a backup of the search index to a specified backup location.
Restore-SPEnterpriseSearchServiceApplicationIndex New cmdlet in 2013 | Restores the search index from the specified backup files.
Get-SPEnterpriseSearchServiceApplicationProxy | Returns the search service application proxy.
New-SPEnterpriseSearchServiceApplicationProxy | Adds a new search application proxy to a farm..
Remove-SPEnterpriseSearchServiceApplicationProxy | Deletes a search service application proxy.
Set-SPEnterpriseSearchServiceApplicationProxy | Sets properties of a search service application proxy.
Remove-SPEnterpriseSearchServiceApplicationSiteSettings New cmdlet in 2013 | Cleans up search settings for a particular site collection, subscription, or search application.
Upgrade-SPEnterpriseSearchServiceApplicationSiteSettings New cmdlet in 2013 | Upgrades search settings for a particular site collection.
Get-SPEnterpriseSearchServiceInstance | Returns the search service instance for a farm.
Set-SPEnterpriseSearchServiceInstance | Sets the properties of a search service instance.
Start-SPEnterpriseSearchServiceInstance | Starts an instance of a search service.
Stop-SPEnterpriseSearchServiceInstance | Stops an instance of a search manager service.
Get-SPEnterpriseSearchSiteHitRule | Returns the shared site hit rule.
New-SPEnterpriseSearchSiteHitRule | Adds a new site hit rule for a search application.
Remove-SPEnterpriseSearchSiteHitRule | Deletes a site hit rule.
Get-SPEnterpriseSearchStatus New cmdlet in 2013 | Retrieves diagnostics information for the search components.
Remove-SPEnterpriseSearchTenantConfiguration New cmdlet in 2013 | Removes all tenant specific search settings.
Remove-SPEnterpriseSearchTenantSchema New cmdlet in 2013 | Removes a defined search schema.
Import-SPEnterpriseSearchThesaurus New cmdlet in 2013 | Deploys the dictionary to the thesaurus component in the query processing flow.
Export-SPEnterpriseSearchTopology | Exports an existing search topology.
Get-SPEnterpriseSearchTopology New cmdlet in 2013 | Retrieves one or all search topologies that belong to a given search service application.
New-SPEnterpriseSearchTopology New cmdlet in 2013 | Creates a new search topology in the given search service application.
Import-SPEnterpriseSearchTopology | Imports and activates a topology from an XML file.
Remove-SPEnterpriseSearchTopology New cmdlet in 2013 | Removes an inactive search topology from a search service application.
Set-SPEnterpriseSearchTopology New cmdlet in 2013 | Activates a given search topology.
Get-SPEnterpriseSearchVssDataPath New cmdlet in 2013 | Retrieves the index paths for all active search index components on the current server.
Get-SPExcelBlockedFileType | Returns a file type or list of file types that are prevented from being loaded.
New-SPExcelBlockedFileType | Adds a file type to the list of file types that Excel Services Application prevents from being loaded.
Remove-SPExcelBlockedFileType | Removes an entry from the list of file types that are prevented from being loaded on Excel Services Application.
Get-SPExcelDataConnectionLibrary | Returns a trusted data connection library or a list of trusted data connection libraries.
New-SPExcelDataConnectionLibrary | Adds a new data connection library to Excel Services Application.
Remove-SPExcelDataConnectionLibrary | Removes a data connection library from Excel Services Application.
Set-SPExcelDataConnectionLibrary | Sets properties of a data connection library for Excel Services Application.
Get-SPExcelDataProvider | Returns a safe data provider or a list of safe data providers.
New-SPExcelDataProvider | Adds a new safe data provider to Excel Services Application.
Remove-SPExcelDataProvider | Removes a data provider from Excel Services Application.
Set-SPExcelDataProvider | Sets properties of a safe data provider for Excel Services Application.
Get-SPExcelFileLocation | Returns a trusted file location or a list of trusted file locations.
New-SPExcelFileLocation | Adds a new trusted location to Excel Services Application.
Remove-SPExcelFileLocation | Removes a trusted file location from Excel Services Application.
Set-SPExcelFileLocation | Sets properties of a trusted file location for Excel Services Application.
Get-SPExcelServiceApplication | Returns an SPExcelServiceApplication object.
New-SPExcelServiceApplication | Creates a new instance of Excel Services Application.
Set-SPExcelServiceApplication | Sets global properties for Excel Services Application.
Get-SPExcelUserDefinedFunction | Returns a user-defined function or a collection of user-defined functions.
New-SPExcelUserDefinedFunction | Adds a new user-defined function to Excel Services Application.
Remove-SPExcelUserDefinedFunction | Removes a user-defined function from Excel Services Application.
Set-SPExcelUserDefinedFunction | Sets properties of a user-defined function in Excel Services Application.
Backup-SPFarm | Creates a backup of an individual database, web application, or the entire farm.
Get-SPFarm | Returns the local SharePoint farm.
Restore-SPFarm | Restores one or more items from a backup.
Upgrade-SPFarm | Activates the Upgrade method for the local farm.
Get-SPFarmConfig | Returns a global property or a collection of global properties for the local farm.
Set-SPFarmConfig | Sets a global property or a collection of global properties for the local farm.
Update-SPFarmEncryptionKey | Changes the value of the farm encryption key and, using the new key, re-encrypts all the data.
Disable-SPFeature | Disables an installed SharePoint feature at a given scope.
Enable-SPFeature | Enables an installed SharePoint feature at the given scope.
Get-SPFeature | Returns the SharePoint features based on a given scope.
Install-SPFeature | Installs a SharePoint feature by using the Feature.xml file.
Uninstall-SPFeature | Uninstalls an installed feature definition.
Get-SPHelpCollection | Returns Help collection files.
Install-SPHelpCollection | Installs the provided Help site collection files in the current farm.
Uninstall-SPHelpCollection | Removes Help collection files.
Update-SPInfoPathAdminFileUrl | Updates InfoPath 2013 form templates (.xsn files) and universal data connections (.udcx files), including all .xsn files and .udcx files that were deployed by an administrator.
Export-SPInfoPathAdministrationFiles | Saves InfoPath 2013 form templates on the SharePoint Central Administration web site and .udcx files to a .cab file.
Import-SPInfoPathAdministrationFiles | Imports InfoPath 2013 form templates and .udcx files that are located on the SharePoint Central Administration web site.
Get-SPInfoPathFormsService | Returns the InfoPath Forms Services in SharePoint Server 2013 settings that are in the farm.
Set-SPInfoPathFormsService | Sets parameters for InfoPath Forms Services in SharePoint Server 2013.
Disable-SPInfoPathFormTemplate | Deactivates an InfoPath 2013 form template from the specified site collection.
Enable-SPInfoPathFormTemplate | Activates an InfoPath 2013 form template in the specified site collection.
Get-SPInfoPathFormTemplate | Returns an InfoPath 2013 form template.
Install-SPInfoPathFormTemplate | Installs an InfoPath 2013 form template on a farm.
Set-SPInfoPathFormTemplate | Sets properties of an InfoPath 2013 form template.
Start-SPInfoPathFormTemplate | Activates a previously quiesced InfoPath 2013 form template.
Stop-SPInfoPathFormTemplate | Disables an InfoPath 2013 form template on a farm before an upgrade.
Test-SPInfoPathFormTemplate | Validates that an InfoPath 2013 form template is browser-enabled.
Uninstall-SPInfoPathFormTemplate | Removes an InfoPath 2013 form template from a farm.
Update-SPInfoPathFormTemplate | Upgrades all InfoPath form templates on the farm.
Add-SPInfoPathUserAgent | Adds a user agent to a farm.
Get-SPInfoPathUserAgent | Returns a user agent or all the currently defined user agents for the farm.
Remove-SPInfoPathUserAgent | Removes a user agent.
Update-SPInfoPathUserFileUrl | Updates InfoPath form templates (.xsn files) and universal data connections (.udcx files).
Get-SPInfoPathWebServiceProxy | Returns the web proxy settings for the web application.
Set-SPInfoPathWebServiceProxy | Sets parameters for an existing SharePoint Web service application.
Get-SPInternalAppStateSyncLastRunTime New cmdlet in 2013 | Returns the latest time the internal app state update job was invoked.
Get-SPInternalAppStateUpdateInterval New cmdlet in 2013 | Returns the interval in hours between updates of the internal app state update job.
Set-SPInternalAppStateUpdateInterval New cmdlet in 2013 | Sets the interval in hours between updates of the internal app state update job.
Get-SPIRMSettings New cmdlet in 2013 | Returns the Information Rights Management (IRM) settings.
Set-SPIRMSettings New cmdlet in 2013 | Sets the Information Rights Management (IRM) settings.
Get-SPLogEvent | Returns results from a Unified Logging Service (ULS) trace log.
Merge-SPLogFile | Combines trace log entries from all farm computers into a single log file on the local computer.
New-SPLogFile | Creates a new log file.
Clear-SPLogLevel | Resets the Windows trace logging and event logging levels to their default values.
Get-SPLogLevel | Returns a list of objects or diagnostic levels.
Set-SPLogLevel | Sets the trace and event level for a set of categories.
Get-SPManagedAccount | Retrieves accounts registered in the configuration database.
New-SPManagedAccount | Registers a new managed account.
Remove-SPManagedAccount | Removes a managed account registration from the farm.
Set-SPManagedAccount | Configures the managed account.
Repair-SPManagedAccountDeployment | Repairs the local managed account credential deployment.
Get-SPManagedPath | Returns all managed paths that match the given criteria.
New-SPManagedPath | Creates a new managed path for the given web application for all host header site collections.
Remove-SPManagedPath | Deletes the specified managed path from the specified host header or web application.
Get-SPMarketplaceConnectionSettings New cmdlet in 2013 | Returns SharePoint Store settings.
New-SPMarketplaceWebServiceApplicationProxy New cmdlet in 2013 | Creates a service application proxy for the app identity data web service.
Set-SPMarketplaceConnectionSettings New cmdlet in 2013 | Sets SharePoint Store connection settings.
Get-SPMetadataServiceApplication | Returns the properties of a service application or a collection of service applications.
New-SPMetadataServiceApplication | Creates a new metadata service application.
Set-SPMetadataServiceApplication | Sets the properties for a metadata service application.
Get-SPMetadataServiceApplicationProxy | Returns the properties of a service application proxy or a collection of service application proxies.
New-SPMetadataServiceApplicationProxy | Creates a new metadata service application proxy.
Set-SPMetadataServiceApplicationProxy | Sets the properties for a metadata service application proxy.
Clear-SPMetadataWebServicePartitionData | Removes all data for a site subscription on a metadata Web service application
Export-SPMetadataWebServicePartitionData | Exports the data from a metadata Web service for a site subscription.
Import-SPMetadataWebServicePartitionData | Restores the data for a site subscription.
Get-SPMobileMessagingAccount | Retrieves mobile messaging accounts for the specified web application.
Set-SPMobileMessagingAccount | Configures the specified mobile messaging account.
Grant-SPObjectSecurity | Adds a new security principal to an SPObjectSecurity object.
Revoke-SPObjectSecurity | Removes a security principal from a SPObjectSecurity object.
Get-SPODataConnectionSettingMetaData New cmdlet in 2013 | Returns a Business Data Connectivity service metadata object.
Remove-SPODataConnectionSetting New cmdlet in 2013 | Removes a Business Connectivity Services connection.
New-SPODataConnectionSetting New cmdlet in 2013 | Creates a new Business Data Connectivity service connection.
Set-SPODataConnectionSetting New cmdlet in 2013 | Sets or updates global properties for a Microsoft Business Connectivity Services connection.
Set-SPODataConnectionSettingMetaData New cmdlet in 2013 | Updates properties for the metadata of a Business Connectivity Services connection.
Get-SPOfficeStoreAppsDefaultActivation New cmdlet in 2013 | Returns the properties of apps for Office.
Set-SPOfficeStoreAppsDefaultActivation New cmdlet in 2013 | Sets the properties of apps for Office.
Set-SPPassPhrase | Sets the passphrase to a new value.
Get-SPPendingUpgradeActions New cmdlet in 2013 | Displays pending upgrade actions.
Set-SPPerformancePointSecureDataValues | Sets global settings for the unattended service account.
Get-SPPerformancePointServiceApplication | Returns a PerformancePoint Service application object and properties.
New-SPPerformancePointServiceApplication | Creates a new service application for PerformancePoint Services.
Remove-SPPerformancePointServiceApplication | Deletes a PerformancePoint Services application from a farm.
Set-SPPerformancePointServiceApplication | Sets global run-time properties for a PerformancePoint Services application.
New-SPPerformancePointServiceApplicationProxy | Creates a proxy for a PerformancePoint Services application.
Remove-SPPerformancePointServiceApplicationProxy | Deletes the proxy for a PerformancePoint Services application.
Clear-SPPerformancePointServiceApplicationTrustedLocation | Clears all the trusted locations for a PerformancePoint Services application identity
Get-SPPerformancePointServiceApplicationTrustedLocation | Returns a trusted location object and properties for a PerformancePoint Services application.
New-SPPerformancePointServiceApplicationTrustedLocation | Creates a new trusted location for a PerformancePoint Services application.
Remove-SPPerformancePointServiceApplicationTrustedLocation | Removes a single trusted location from a PerformancePoint Services application.
New-SPPowerPointConversionServiceApplication | Creates a PowerPoint Conversion Service application.
New-SPPowerPointConversionServiceApplicationProxy | Creates a PowerPoint Conversion Service application proxy.
Set-SPPowerPointConversionServiceApplication | Configures settings for a PowerPoint Conversion Service application.
Get-SPProcessAccount | Returns a system account or a managed account.
Get-SPProduct | Returns a list of the SharePoint-related products installed in the farm and the versions of all updates installed for each product.
Add-SPProfileLeader | Adds a company leader.
Get-SPProfileLeader | Returns the current company leaders.
Remove-SPProfileLeader | Remove a company leader.
Move-SPProfileManagedMetadataProperty | Moves multiple-string values into a term set.
Update-SPProfilePhotoStore | Updates the profile photo store to be compatible with SharePoint Server 2013.
New-SPProfileServiceApplication | Adds a User Profile Service application to a farm.
Set-SPProfileServiceApplication | Sets properties of a User Profile Service application.
New-SPProfileServiceApplicationProxy | Creates a User Profile Service application proxy on the local farm.
Set-SPProfileServiceApplicationProxy | Sets properties of a proxy for a User Profile Service application.
Get-SPProfileServiceApplicationSecurity | Returns permission and identity information.
Set-SPProfileServiceApplicationSecurity | Sets permission and identity information.
Update-SPRepopulateMicroblogFeedCache New cmdlet in 2013 | Refreshes the cache.
Update-SPRepopulateMicroblogLMTCache New cmdlet in 2013 | Refreshes the cache.
Get-SPRequestManagementSettings New cmdlet in 2013 | Returns a Request Manager object.
New-SPRequestManagementRuleCriteria New cmdlet in 2013 | Creates criteria for the rule to match.
Set-SPRequestManagementSettings New cmdlet in 2013 | Sets Request Manager properties.
Initialize-SPResourceSecurity | Enforces resource security on the local server.
Add-SPRoutingMachineInfo New cmdlet in 2013 | Adds a new routing target to the farm.
Add-SPRoutingMachinePool New cmdlet in 2013 | Adds a new machine pool.
Add-SPRoutingRule New cmdlet in 2013 | Adds a routing rule.
Get-SPRoutingMachineInfo New cmdlet in 2013 | Returns all the routing targets.
Get-SPRoutingMachinePool New cmdlet in 2013 | Returns all available routing pools.
Get-SPRoutingRule New cmdlet in 2013 | Returns all routing rules.
Remove-SPRoutingMachineInfo New cmdlet in 2013 | Removes an external routing target.
Remove-SPRoutingMachinePool New cmdlet in 2013 | Removes a routing pool from Request Manager.
Remove-SPRoutingRule New cmdlet in 2013 | Removes a routing rule.
Set-SPRoutingMachineInfo New cmdlet in 2013 | Sets routing target properties.
Set-SPRoutingMachinePool New cmdlet in 2013 | Sets properties of a machine pool.
Set-SPRoutingRule New cmdlet in 2013 | Changes properties of an existing routing rule.
Add-SPScaleOutDatabase New cmdlet in 2013 | Adds an existing scale-out database to the specified service application.
Clear-SPScaleOutDatabaseDeletedDataSubRange New cmdlet in 2013 | Clears all partitions inside the specified deleted subrange.
Clear-SPScaleOutDatabaseLog New cmdlet in 2013 | Clears all scale-out logs.
Clear-SPScaleOutDatabaseTenantData New cmdlet in 2013 | Removes all data related to the specified site subscription.
Export-SPScaleOutDatabaseTenantData New cmdlet in 2013 | Exports the data of the specified subscription.
Get-SPScaleOutDatabase New cmdlet in 2013 | Returns all scale-out database objects.
Get-SPScaleOutDatabaseDataState New cmdlet in 2013 | Returns the state information about the specified scale-out database.
Get-SPScaleOutDatabaseInconsistency New cmdlet in 2013 | Displays all inconsistencies related to scale-out databases' ranges.
Get-SPScaleOutDatabaseLogEntry New cmdlet in 2013 | Queries a scale-out database for scale-out logs.
Import-SPScaleOutDatabaseTenantData New cmdlet in 2013 | Imports data from the specified subscription id.
Remove-SPScaleOutDatabase New cmdlet in 2013 | Removes a specific scale-out database.
Set-SPScaleOutDatabaseDataRange New cmdlet in 2013 | Extends the range of a specified scale-out database.
Set-SPScaleOutDatabaseDataSubRange New cmdlet in 2013 | Creates a subrange for a specified scale-out database.
Split-SPScaleOutDatabase New cmdlet in 2013 | Moves a specified percentage of partitions from one scale-out database to another.
Get-SPSecureStoreApplication | Returns a Secure Store application.
New-SPSecureStoreApplication | Creates a new Secure Store application.
Remove-SPSecureStoreApplication | Deletes a Secure Store application.
Set-SPSecureStoreApplication | Sets properties of a Secure Store application.
New-SPSecureStoreApplicationField | Creates a new Secure Store application fields object.
Update-SPSecureStoreApplicationServerKey | Synchronizes the key on a server running SharePoint Server by using the Secure Store master key.
Clear-SPSecureStoreCredentialMapping | Deletes a credential mapping from a Secure Store Service application.
Update-SPSecureStoreCredentialMapping | Sets a new credential mapping for a Secure Store Service application.
Clear-SPSecureStoreDefaultProvider | Clears the secure store provider.
Set-SPSecureStoreDefaultProvider | Sets or updates the secure store provider.
Update-SPSecureStoreGroupCredentialMapping | Sets a new group credential mapping for a Secure Store Service application.
Update-SPSecureStoreMasterKey | Changes the master key of a Secure Store Service application.
New-SPSecureStoreServiceApplication | Creates a new Secure Store Service application in the farm.
Set-SPSecureStoreServiceApplication | Sets properties of a Secure Store Service application in the farm.
New-SPSecureStoreServiceApplicationProxy | Creates a new Secure Store Service application proxy in the farm.
Add-SPSecureStoreSystemAccount New cmdlet in 2013 | Adds an account to a designated list.
Get-SPSecureStoreSystemAccount New cmdlet in 2013 | Returns a list of users from a designated list.
Remove-SPSecureStoreSystemAccount New cmdlet in 2013 | Removes a user account from a designated list.
New-SPSecureStoreTargetApplication | Creates a new Secure Store target application.
Get-SPSecurityTokenServiceConfig | Returns the security token service (STS) for the farm.
Set-SPSecurityTokenServiceConfig | Updates the settings of the SharePoint security token service (STS) identity provider.
Get-SPServer | Returns the server or servers in the farm that match the given identity.
Rename-SPServer | Renames a server that is currently connected to the farm.
Add-SPServerScaleOutDatabase New cmdlet in 2013 | Adds an existing scale-out database to the specified service application.
Clear-SPServerScaleOutDatabaseDeletedDataSubRange New cmdlet in 2013 | Clears all partitions inside the specified deleted subrange.
Clear-SPServerScaleOutDatabaseLog New cmdlet in 2013 | Clears all scale-out logs.
Clear-SPServerScaleOutDatabaseTenantData New cmdlet in 2013 | Removes all data related to the specified site subscription.
Export-SPServerScaleOutDatabaseTenantData New cmdlet in 2013 | Exports the data of the specified subscription.
Get-SPServerScaleOutDatabase New cmdlet in 2013 | Returns all scale-out database objects.
Get-SPServerScaleOutDatabaseDataState New cmdlet in 2013 | Returns the state information about the specified scale-out database.
Get-SPServerScaleOutDatabaseInconsistency New cmdlet in 2013 | Displays all inconsistencies related to scale-out databases' ranges.
Get-SPServerScaleOutDatabaseLogEntry New cmdlet in 2013 | Queries a scale-out database for scale-out logs.
Import-SPServerScaleOutDatabaseTenantData New cmdlet in 2013 | Imports data from the specified subscription id.
Remove-SPServerScaleOutDatabase New cmdlet in 2013 | Removes a specific scale-out database.
Set-SPServerScaleOutDatabaseDataRange New cmdlet in 2013 | Extends the range of a specified scale-out database.
Set-SPServerScaleOutDatabaseDataSubRange New cmdlet in 2013 | Creates a subrange for a specified scale-out database.
Split-SPServerScaleOutDatabase New cmdlet in 2013 | Moves a specified percentage of partitions from one scale-out database to another.
Install-SPService | Installs and provisions services on a farm.
Get-SPServiceApplication | Returns the specified service application.
Publish-SPServiceApplication | Shares the specified local service application outside the farm.
Remove-SPServiceApplication | Deletes the specified service application on the local server.
Set-SPServiceApplication | Sets properties of a service application.
Unpublish-SPServiceApplication | Stops sharing the specified service application outside the farm.
Get-SPServiceApplicationEndpoint | Returns the endpoint of a service application.
Set-SPServiceApplicationEndpoint | Sets the host of an endpoint for a service application.
Get-SPServiceApplicationPool | Returns the specified Internet Information Services (IIS) application pool.
New-SPServiceApplicationPool | Creates a new Web service application pool.
Remove-SPServiceApplicationPool | Completely deletes the specified Web service application pool.
Set-SPServiceApplicationPool | Changes the account used for the Identity of the specified application pool.
Get-SPServiceApplicationProxy | Returns an instance of the specified service application proxy.
Remove-SPServiceApplicationProxy | Deletes the specified service application proxy.
Get-SPServiceApplicationProxyGroup | Returns the proxy group for the specified service application.
New-SPServiceApplicationProxyGroup | Creates a new service application proxy group.
Remove-SPServiceApplicationProxyGroup | Completely deletes the specified service application proxy group.
Add-SPServiceApplicationProxyGroupMember | Adds a member to the service application proxy group.
Remove-SPServiceApplicationProxyGroupMember | Removes one or more proxies from the specified service application proxy group.
Get-SPServiceApplicationSecurity | Returns the SPObjectSecurity object for a service application.
Set-SPServiceApplicationSecurity | Updates the SPObjectSecurity object for a service application.
Get-SPServiceContext | Returns a service context.
Get-SPServiceHostConfig | Returns the common Web service settings.
Set-SPServiceHostConfig | Configures one or more common settings for all Web services.
Get-SPServiceInstance | Returns the services instance for a specific server or the entire farm.
Start-SPServiceInstance | Starts the service instance for a service on a specific server or the farm.
Stop-SPServiceInstance | Stops the service instance for a service.
Disable-SPSessionStateService | Turns off the session state service on the farm
Enable-SPSessionStateService | Creates a session state database and turns on the session state service
Get-SPSessionStateService | Returns the properties of the session state service, including time-out and database settings
Set-SPSessionStateService | Updates the credentials that are used to communicate with the state service database
Add-SPShellAdmin | Adds a user to the SharePoint_Shell_Access role for the specified database.
Get-SPShellAdmin | Returns the names of all users who have the SharePoint_Shell_Access role.
Remove-SPShellAdmin | Removes a user from the SharePoint_Shell_Access role.
Disable-SPSingleSignOn | Disables the single sign-on (SSO) service on a farm server.
Upgrade-SPSingleSignOnDatabase | Migrates the application definitions from single sign-on (SSO) database to Secure Store database as target applications.
Backup-SPSite | Performs a backup of a site collection.
Copy-SPSite New cmdlet in 2013 | Makes a copy of a site collection.
Get-SPSite | Returns all site collections that match the given criteria.
Move-SPSite | Moves site collections from one content database to another.
New-SPSite | Creates a new site collection at the specified URL.
Remove-SPSite | Completely deletes an existing site collection and all subsites.
Repair-SPSite New cmdlet in 2013 | Activates the RunRepairs method against the referenced SPSite object.
Restore-SPSite | Restores a site collection.
Set-SPSite | Configures the specified site collection.
Test-SPSite New cmdlet in 2013 | Activates the RunTests method against a referenced SPSite object.
Upgrade-SPSite | Starts the upgrade process on a site collection.
Get-SPSiteAdministration | Returns a site administration object that farm administrators can use to view certain information about site collections to which they might not have access.
Set-SPSiteAdministration | Allows farm administrators to configure any site collection.
Get-SPSiteSubscription | Returns the site subscription for the given URL or all site subscriptions in the local farm.
New-SPSiteSubscription | Creates a new site subscription.
Remove-SPSiteSubscription | Removes data stored in a subscription settings service application for a set of site subscriptions.
Clear-SPSiteSubscriptionBusinessDataCatalogConfig | Deletes all data from the Business Data Connectivity Metadata Store for a specified partition.
Export-SPSiteSubscriptionBusinessDataCatalogConfig | Exports all data from the Business Data Connectivity Metadata Store associated with a partition.
Remove-SPSiteSubscriptionBusinessDataCatalogConfig | Removes the Business Data Connectivity Metadata Store for a partition.
Get-SPSiteSubscriptionConfig | Returns the configuration properties of a site subscription.
Set-SPSiteSubscriptionConfig | Sets the configuration properties of a site subscription.
Get-SPSiteSubscriptionEdiscoveryHub | Displays the eDiscovery hub for a site subscription.
Set-SPSiteSubscriptionEdiscoveryHub | Sets properties for the eDiscovery hub of a site subscription.
Get-SPSiteSubscriptionEdiscoverySearchScope | Displays the search scope for the eDiscovery hub of the specified site collection.
Get-SPSiteSubscriptionFeaturePack | Retrieves available SharePoint feature sets or the Feature set assigned to a given site subscription.
Get-SPSiteSubscriptionIRMConfig New cmdlet in 2013 | Gets the Information Rights Management (IRM) settings.
Set-SPSiteSubscriptionIRMConfig New cmdlet in 2013 | Sets the Information Rights Management (IRM) settings.
New-SPSiteSubscriptionFeaturePack | Creates a new SharePoint feature set that can be used to limit the features available to a site subscription.
Remove-SPSiteSubscriptionFeaturePack | Removes a SharePoint feature set from a site subscription.
Add-SPSiteSubscriptionFeaturePackMember | Adds a feature to a SharePoint feature set.
Remove-SPSiteSubscriptionFeaturePackMember | Removes a feature definition from the provided SharePoint feature set.
Get-SPSiteSubscriptionMetadataConfig | Returns the site subscription configuration settings for a metadata service application.
Remove-SPSiteSubscriptionMetadataConfig | Removes site subscription configuration settings.
Set-SPSiteSubscriptionMetadataConfig | Sets the site subscription configuration settings for a specified metadata service application.
Add-SPSiteSubscriptionProfileConfig | Adds a new site subscription to a User Profile Service application.
Remove-SPSiteSubscriptionProfileConfig | Deletes a site subscription from a User Profile Service application.
Set-SPSiteSubscriptionProfileConfig | Sets the parameters of a site subscription.
Export-SPSiteSubscriptionSettings | Creates a backup file of site subscription data.
Import-SPSiteSubscriptionSettings | Restores a backup of subscription site settings to the given subscription identifier.
Remove-SPSiteSubscriptionSettings | Removes the settings service data for a specified site subscription, or finds and removes orphaned data.
Get-SPSiteUpgradeSessionInfo New cmdlet in 2013 | Manage or report site upgrade.
Remove-SPSiteUpgradeSessionInfo New cmdlet in 2013 | Removes an SPSite object from upgrade.
Get-SPSiteUrl New cmdlet in 2013 | Displays all URL mappings for the site.
Remove-SPSiteUrl New cmdlet in 2013 | Removes an URL mapping from the site.
Set-SPSiteUrl New cmdlet in 2013 | Adds or changes an URL mapping for the site.
Add-SPSocialAppPermissions New cmdlet in 2013 | Do not use this cmdlet.
Remove-SPSocialAppPermissions New cmdlet in 2013 | Do not use this cmdlet.
Move-SPSocialComments | Moves social comments.
Remove-SPSocialItemByDate | Deletes tags, notes, or ratings.
Add-SPSolution | Uploads a SharePoint solution package to the farm.
Get-SPSolution | Returns a specified SharePoint solution.
Install-SPSolution | Deploys an installed SharePoint solution in the farm.
Remove-SPSolution | Removes a SharePoint solution from a farm.
Uninstall-SPSolution | Retracts a deployed SharePoint solution.
Update-SPSolution | Upgrades a deployed SharePoint solution.
Remove-SPSolutionDeploymentLock | Removes the solution deployment lock for a server.
Get-SPStateServiceApplication | Returns state service applications on the farm
New-SPStateServiceApplication | Creates a new state service application
Set-SPStateServiceApplication | Updates the name of a state service application
Get-SPStateServiceApplicationProxy | Returns state service application proxies on the farm.
New-SPStateServiceApplicationProxy | Creates a proxy for a state service application
Set-SPStateServiceApplicationProxy | Updates the name of a state service application proxy
Dismount-SPStateServiceDatabase | Removes the association to a state service database from the farm without dropping the database in the Microsoft SQL Server database
Get-SPStateServiceDatabase | Returns a state service database.
Initialize-SPStateServiceDatabase | Installs the state database schema into a state service database
Mount-SPStateServiceDatabase | Attaches an existing state service database to the farm
New-SPStateServiceDatabase | Creates and provisions a new state service database, and installs the state database schema into it
Remove-SPStateServiceDatabase | Removes a state service database from a state service application and drops it from the SQL Server
Resume-SPStateServiceDatabase | Resumes a paused state service database so that new rows of data are received
Set-SPStateServiceDatabase | Updates properties of a state service database
Suspend-SPStateServiceDatabase | Pauses a state database and thus prevents new rows of data from being added to a database
New-SPSubscriptionSettingsServiceApplication | Creates a new subscription settings service application.
Set-SPSubscriptionSettingsServiceApplication | Sets properties of a subscription settings service application.
New-SPSubscriptionSettingsServiceApplicationProxy | Creates an application proxy to a subscription settings service application.
Get-SPTaxonomySession | Returns a TaxonomySession object.
Add-SPThrottlingRule New cmdlet in 2013 | Adds a new throttling rule.
Get-SPThrottlingRule New cmdlet in 2013 | Returns all throttling rules.
Remove-SPThrottlingRule New cmdlet in 2013 | Removes a throttling rule.
Set-SPThrottlingRule New cmdlet in 2013 | Changes properties of an existing throttling rule.
Disable-SPTimerJob | Disables a timer job.
Enable-SPTimerJob | Enables a timer job.
Get-SPTimerJob | Returns timer jobs.
Set-SPTimerJob | Sets the schedule for running a timer job.
Start-SPTimerJob | Runs a timer job once.
Get-SPTopologyServiceApplication | Displays properties of the topology service application for the current farm.
Set-SPTopologyServiceApplication | Sets the properties on the topology service application of the local farm.
Get-SPTopologyServiceApplicationProxy | Retrieves the topology service application proxy.
Set-SPTopologyServiceApplicationProxy | Sets the proxy properties of the topology service application.
New-SPTranslationServiceApplication New cmdlet in 2013 | Provisions a new instance of the Machine Translation service.
New-SPTranslationServiceApplicationProxy New cmdlet in 2013 | Creates a Machine Translation Service application proxy on the local farm.
Remove-SPTranslationServiceJobHistory New cmdlet in 2013 | Removes Machine Translation service jobs.
Set-SPTranslationServiceApplication New cmdlet in 2013 | Sets property settings on a Machine Translation service application.
Set-SPTranslationServiceApplicationProxy New cmdlet in 2013 | Sets properties to the Machine Translation service application proxy.
Get-SPTrustedIdentityTokenIssuer | Returns an identity provider.
New-SPTrustedIdentityTokenIssuer | Creates an identity provider in the farm.
Remove-SPTrustedIdentityTokenIssuer | Deletes a security token service (STS) identity provider from the farm.
Set-SPTrustedIdentityTokenIssuer | Sets the identity providers of a web application.
Get-SPTrustedRootAuthority | Returns a trusted root authority.
New-SPTrustedRootAuthority | Creates a trusted root authority.
Remove-SPTrustedRootAuthority | Deletes a trusted root authority.
Set-SPTrustedRootAuthority | Creates a new trusted root authority.
Get-SPTrustedSecurityTokenIssuer New cmdlet in 2013 | Returns the trusted security token issuer object.
New-SPTrustedSecurityTokenIssuer New cmdlet in 2013 | Creates a trust between a server to server principal.
Remove-SPTrustedSecurityTokenIssuer New cmdlet in 2013 | Removes the trusted security token service object.
Set-SPTrustedSecurityTokenIssuer New cmdlet in 2013 | Sets the trusted token issuer.
Get-SPTrustedServiceTokenIssuer | Returns the object that represents the farm trust.
New-SPTrustedServiceTokenIssuer | Creates a trust with a SharePoint farm.
Remove-SPTrustedServiceTokenIssuer | Deletes the object that represents the farm trust.
Set-SPTrustedServiceTokenIssuer | Updates a trust with the farm.
Get-SPUpgradeActions New cmdlet in 2013 | Returns all upgrade actions.
Request-SPUpgradeEvaluationSite New cmdlet in 2013 | Requests an upgrade evaluation site for a specified site.
Get-SPUsageApplication | Returns a specified usage application.
New-SPUsageApplication | Creates a new usage application.
Remove-SPUsageApplication | Removes a usage application from the local farm.
Set-SPUsageApplication | Sets properties of a usage application.
Get-SPUsageDefinition | Returns a usage definition object.
Set-SPUsageDefinition | Sets the retention period for a usage provider.
New-SPUsageLogFile | Starts a new usage log file on the current server computer.
Get-SPUsageService | Returns a usage service.
Set-SPUsageService | Sets the properties of a usage service.
Get-SPUser | Returns the user account or accounts that match a given search criteria.
Move-SPUser | Migrates a user account in SharePoint 2010 Products.
New-SPUser | Adds an existing user to a SharePoint site with the designated permissions.
Remove-SPUser | Removes a user from a web site.
Set-SPUser | Configures properties on an existing user.
Add-SPUserLicenseMapping New cmdlet in 2013 | Maps a security group, forms-based role, or claim to a SharePoint user license.
Disable-SPUserLicensing New cmdlet in 2013 | Disables user license enforcement.
Enable-SPUserLicensing New cmdlet in 2013 | Enables user-license enforcement.
Get-SPUserLicense New cmdlet in 2013 | Returns the list of supported SharePoint user licenses.
Get-SPUserLicenseMapping New cmdlet in 2013 | Returns the claim-to-user license mappings.
Get-SPUserLicensing New cmdlet in 2013 | Returns the state of user-license enforcement.
New-SPUserLicenseMapping New cmdlet in 2013 | Creates a license mapping object.
Remove-SPUserLicenseMapping New cmdlet in 2013 | Removes a claim-to-SharePoint user license mapping.
Add-SPUserSolution | Uploads a new sandboxed solution to the solution gallery.
Get-SPUserSolution | Returns a specified sandboxed solution.
Install-SPUserSolution | Activates a sandboxed solution in a site collection.
Remove-SPUserSolution | Removes a sandboxed solution from the solution gallery.
Uninstall-SPUserSolution | Deactivates a sandboxed solution in a site collection.
Update-SPUserSolution | Upgrades an activated sandboxed solution in a farm.
Get-SPVisioExternalData | Returns the settings for external data connections for a Visio Services application.
Set-SPVisioExternalData | Configures settings related to external data connections for a Visio Services application.
Get-SPVisioPerformance | Returns the Visio Services settings for the performance of a Visio Services application.
Set-SPVisioPerformance | Sets performance properties for a Visio Services application.
Get-SPVisioSafeDataProvider | Returns the settings of a safe data provider for a Visio Services application.
New-SPVisioSafeDataProvider | Adds a new data provider to a Visio Services application.
Remove-SPVisioSafeDataProvider | Removes a data provider from a Visio Services application.
Set-SPVisioSafeDataProvider | Specifies a description of a safe data provider for a Visio Services application.
Get-SPVisioServiceApplication | Returns properties of a Visio Services application or a collection of Visio Services applications.
New-SPVisioServiceApplication | Adds a new Visio Services application to a farm.
Set-SPVisioServiceApplication | Sets the ServiceApplicationPool property for a Visio Services application.
Get-SPVisioServiceApplicationProxy | Returns properties of a Visio Services application proxy or a collection of Visio Services application proxies
New-SPVisioServiceApplicationProxy | Adds a new Visio Services application proxy to a farm.
Export-SPWeb | Exports a site collection, web application, list, or library.
Get-SPWeb | Returns all subsites that match the given criteria.
Import-SPWeb | Imports a site collection, web application, list, or library.
New-SPWeb | Creates a new site in an existing site collection.
Remove-SPWeb | Completely deletes the specified web.
Set-SPWeb | Configures the specified subsite.
Convert-SPWebApplication New cmdlet in 2013 | Converts the authentication mode of a web application.
Get-SPWebApplication | Returns all web applications that match the given criteria.
New-SPWebApplication | Creates a new web application within the local farm.
Remove-SPWebApplication | Deletes the specified web application.
Set-SPWebApplication | Configures the specified web application.
Get-SPWebApplicationAppDomain | Returns all app domains for a specific web application.
New-SPWebApplicationAppDomain | Creates or changes a AppDomain entry.
Remove-SPWebApplicationAppDomain | Deletes the AppDomain.
New-SPWebApplicationExtension | Creates a new zone instance for the web application.
Disable-SPWebApplicationHttpThrottling | Turns off network throttling for a web application.
Enable-SPWebApplicationHttpThrottling | Turns on network throttling for a web application.
Get-SPWebApplicationHttpThrottlingMonitor | Reads all counters for network throttling on a web application.
Set-SPWebApplicationHttpThrottlingMonitor | Sets the Health Score bucket values for an existing network throttling performance counter for a specified web application.
Get-SPWebPartPack | Returns the Web Part packages that were installed for the specified scope.
Install-SPWebPartPack | Installs the specified Web Part package to the specified location.
Uninstall-SPWebPartPack | Uninstalls the specified Web Part package.
Get-SPWebTemplate | Displays all globally installed site templates that match the given identity.
Get-SPWOPIBinding New cmdlet in 2013 | Returns a list of bindings that were created by using New-SPWOPIBinding on the current SharePoint farm where this cmdlet is run.
Get-SPWOPISuppressionSetting New cmdlet in 2013 | Returns the suppression settings on the current SharePoint farm where this cmdlet is run.
Get-SPWOPIZone New cmdlet in 2013 | Returns the zone that is configured on the current SharePoint farm for the WOPI application to use.
New-SPWOPIBinding New cmdlet in 2013 | Creates a new binding to associate file name extensions or applications with actions on the current SharePoint farm where this cmdlet is run.
New-SPWOPISuppressionSetting New cmdlet in 2013 | The New-SPWOPISuppressionSetting cmdlet turns off Office Web Apps for the action and document type or binding you've specified on the current SharePoint farm.
Remove-SPWOPIBinding New cmdlet in 2013 | Removes bindings for applications, file name extensions, and their associated actions on the current SharePoint farm where this cmdlet is run.
Remove-SPWOPISuppressionSetting New cmdlet in 2013 | Removes the suppression settings for a file type or program ID (ProgID) on the current SharePoint farm where this cmdlet is run.
Set-SPWOPIBinding New cmdlet in 2013 | Updates the default click action for an application or file name extension binding.
Set-SPWOPIZone New cmdlet in 2013 | Configures the zone that the current SharePoint farm will use to navigate the browser to the WOPI application.
Update-SPWOPIProofKey New cmdlet in 2013 | Updates the public key that is used to connect to the WOPI application on the current SharePoint farm where this cmdlet is run.
New-SPWordConversionServiceApplication | Creates a new instance of a Word Automation Services application on the farm.
Set-SPWordConversionServiceApplication | Sets properties of a Word Automation Services application.
Remove-SPWordConversionServiceJobHistory | Removes entries from the Word Automation Services job history database.
Get-SPWorkflowConfig | Returns workflow settings for the specified web application.
Set-SPWorkflowConfig | Configures the workflow settings for the specified web application.
Register-SPWorkflowService | Configures the SharePoint host to use a workflow service.
New-SPWorkManagementServiceApplication New cmdlet in 2013 | Creates a new Work Management Service application.
New-SPWorkManagementServiceApplicationProxy New cmdlet in 2013 | Creates a new service application proxy group.
Set-SPWorkManagementServiceApplication New cmdlet in 2013 | Sets settings for the Work Management Service application.
Set-SPWorkManagementServiceApplicationProxy New cmdlet in 2013 | Sets the settings for the Work Management Service application proxy.


Updates to Windows PowerShell cmdlets (SharePoint 2013)
See also

Published: October 16, 2012

Summary: Learn about latest changes to Windows PowerShell cmdlets for SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article lists the Windows PowerShell cmdlets that have been changed — or are no longer available — since the Preview release of SharePoint 2013.

SharePoint 2013 Preview | SharePoint 2013
Get-SPAppAcquisitionSettings | Get-SPAppAcquisitionConfiguration
Set-SPAppAcquisitionSettings | Set-SPAppAcquisitionConfiguration
Update-SPAppCatalogSettings | Update-SPAppCatalogConfiguration
Clear-SPAppDeniedEndpoints | Clear-SPAppDeniedEndpointList
Get-SPAppDeniedEndpoints | Get-SPAppDeniedEndpointList
Get-SPAppDisableSettings | Get-SPAppDisablingConfiguration
Set-SPAppDisableSettings | Set-SPAppDisablingConfiguration
Get-SPAppHostingQuotas | Get-SPAppHostingQuotaConfiguration
Set-SPAppHostingQuotas | Set-SPAppHostingQuotaConfiguration
Get-SPAppMarketplaceSettings | Get-SPAppStoreConfiguration
Set-SPAppMarketplaceSettings | Set-SPAppStoreConfiguration
Repartition-SPEnterpriseSearchLinksDatabase | Move-SPEnterpriseSearchLinksDatabases
Not available | Set-SPEnterpriseSearchFileFormatState
Not available | Update-SPDistributedCacheSize
Not available | Set-SPAppSiteDomain

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


Stsadm to Windows PowerShell mapping in SharePoint 2013
See also

Summary: Lists Stsadm operations and their equivalent Windows PowerShell cmdlets.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

Where there is no one-to-one mapping between the operations and cmdlets, the table lists the specific Windows PowerShell parameters you must use to get the same functionality.

Stsadm operation

Windows PowerShell cmdlet

Activatefeature

Enable-SPFeature

Activateformtemplate

Enable-SPInfoPathFormTemplate

Addalternatedomain

New-SPAlternateUrl

Addcontentdb

Mount-SPContentDatabase

New-SPContentDatabase

Adddataconnectionfile

Install-SPDataConnectionFile

Add-ecsfiletrustedlocation

New-SPExcelFileLocation

Add-ecssafedataprovider

New-SPExcelDataProvider

Add-ecstrusteddataconnectionlibrary

New-SPExcelDataConnectionLibrary

Add-ecsuserdefinedfunction

New-SPExcelUserDefinedFunction

Addexemptuseragent

Add-SPInfoPathUserAgent

Addpath

New-SPManagedPath

Addpermissionpolicy

None

Addsolution

Add-SPSolution

Addtemplate

None

Adduser

New-SPUser

Addwppack

Install-SPWebPartPack

Addzoneurl

New-SPAlternateUrl

Allowuserformwebserviceproxy

Set-SPInfoPathWebServiceProxy

Use the AllowForUserForms and Identity parameters.

Allowwebserviceproxy

Set-SPInfoPathWebServiceProxy

Use the AllowWebServiceProxy and Identity parameters.

Authentication

Set-SPWebApplication

Use the AuthenticationMethod or AuthenticationProvider parameters.

Backup

Backup-SPConfigurationDatabase

Backup-SPFarm

Backup-SPSite

Backuphistory

Get-SPBackupHistory

Binddrservice

None

Blockedfilelist

None

Canceldeployment

None

Changepermissionpolicy

None

Copyappbincontent

None

Createadminvs

New-SPCentralAdministration

Creategroup

None

Createsite

New-SPSite

Createsiteinnewdb

New-SPSite Use the ContentDatabase parameter.

New-SPContentDatabase

Createweb

New-SPWeb

Databaserepair

None

Deactivatefeature

Disable-SPFeature

Deactivateformtemplate

Disable-SPInfoPathFormTemplate

Deleteadminvs

None

Deletealternatedomain

Remove-SPAlternateUrl

Deleteconfigdb

Remove-SPConfigurationDatabase

Deletecontentdb

Dismount-SPContentDatabase

Deletegroup

None

Deletepath

Remove-SPManagedPath

Deletepermissionpolicy

None

Deletesite

Remove-SPSite

Deletesolution

Remove-SPSolution

Deletetemplate

None

Deleteuser

Remove-SPUser

Deleteweb

Remove-SPWeb

Deletewppack

Uninstall-SPWebPartPack

Deletezoneurl

Remove-SPAlternateUrl

Deploysolution

Install-SPSolution

Deploywppack

Install-SPWebPartPack

Disablessc

None

Displaysolution

Get-SPSolution

Editcontentdeploymentpath

Set-SPContentDeploymentPath

Email

None

Enablessc

None

Enumalternatedomains

Get-SPAlternateURL

Enumcontentdbs

Get-SPContentDatabase

Enumdataconnectionfiledependants

Get-SPDataConnectionFileDependent

Enumdataconnectionfiles

Get-SPDataConnectionFile

Enumdeployments

None

Enumexemptuseragents

Get-SPInfoPathUserAgent

Enumformtemplates

Get-SPInfoPathFormTemplate

Enumgroups

None

Enumroles

None

Enumservices

Get-SPServiceInstance

Enumsites

Get-SPSiteAdministration (To run this cmdlet, you must be a member of the Farm Administrators group.)

Get-SPSite (To run this cmdlet, you must be a local administrator on the computer where SharePoint 2013 is installed.)

Enumsolutions

Get-SPSolution

Enumsubwebs

Get-SPWeb

Enumtemplates

Get-SPWebTemplate

Enumusers

Get-SPUser

Enumwppacks

Get-SPWebPartPack

Enumzoneurls

Get-SPAlternateURL

Execadmsvcjobs

Start-SPAdminJob

Export

Export-SPWeb

Extendvs

New-SPWebApplication

Extendvsinwebfarm

New-SPWebApplicationExtension

Forcedeletelist

None

Getadminport

Get-SPWebApplication

Use the following syntax:

  • Get-SPWebApplication -IncludeCentralAdministration | ? {$_.IsAdministrationWebApplication -eq $true}

Getdataconnectionfileproperty property

Get-SPDataConnectionFile

Use the following syntax:

  • Get-SPDataConnectionFile | where {$_.Name -eq "dataConFileName"} | format-list

Getformtemplateproperty property

Get-SPInfoPathFormTemplate

Use the following syntax:

  • Get-SPInfoPathFormTemplate | where {$_.DisplayName -eq "formTemplateName"} | format-list

Getosearchsetting

None

Getproperty

Get-SPFarmConfig

Get-SPTimerJob

Disable-SPTimerJob

Enable-SPTimerJob

Set-SPTimerJob

Start-SPTimerJob

Getsitelock

Get-SPSiteAdministration

Getsiteuseraccountdirectorypath

None

Geturlzone

Get-SPAlternateURL

Import

Import-SPWeb

Installfeature

Install-SPFeature

Listlogginglevels

Get-SPLogLevel

Listqueryprocessoroptions

None

Listregisteredsecuritytrimmers

Get-SPEnterpriseSearchSecurityTrimmer

Localupgradestatus

None

Managepermissionpolicylevel

None

Mergecontentdbs

Move-SPSite

Migrateuser

Move-SPUser

Osearch

For the Osearch parameters farmcontactemail, farmperformancelevel, farmserviceaccount, and farmservicepassword, use the Get-SPEnterpriseSearchService and Set-SPEnterpriseSearchService cmdlets.

For the Osearch parameters start and stop, use the Start-SPEnterpriseSearchServiceInstance and Stop-SPEnterpriseSearchServiceInstance cmdlets, respectively.

For the Osearch parameter defaultindexlocation, use the Get-SPEnterpriseSearchServiceInstance cmdlet.

Osearchdiacriticsensitive

Use the Get-SPEnterpriseSearchServiceApplication cmdlet to retrieve the specific Search service application, and then use DiacriticSensitive parameter from the Set-SPEnterpriseSearchServiceApplication cmdlet.

Profilechangelog

None.

However, you can use the Stsadm profilechangelog operation if you replace the Shared Services Provider (SSP) name with the service application (SA) name:

Copy code
stsadm -o profilechangelog
-title <SA name>
-daysofhistory <number of days>
-generateanniversaries

For more information about service applications, see About service applications and services in SharePoint 2013.

Provisionservice

Start-SPServiceInstance

Quiescefarm

None

Quiescefarmstatus

None

Quiesceformtemplate

Stop-SPInfoPathFormTemplate

Reconvertallformtemplates

Update-SPInfoPathFormTemplate

Refreshdms

None

Refreshsitedms

None

Registersecuritytrimmer

New-SPEnterpriseSearchSecurityTrimmer

Registerwsswriter

None

Removedataconnectionfile

Uninstall-SPDataConnectionFile

Remove-ecsfiletrustedlocation

Remove-SPExcelFileLocation

Remove-ecssafedataprovider

Remove-SPExcelDataProvider

Remove-ecstrusteddataconnectionlibrary

Remove-SPExcelDataConnectionLibrary

Remove-ecsuserdefinedfunction

Remove-SPExcelFileLocation

Removedrservice

None

Removeexemptuseragent

Remove-SPInfoPathUserAgent

Removeformtemplate

Uninstall-SPInfoPathFormTemplate

Removesolutiondeploymentlock

None

Renameserver

Rename-SPServer

Renamesite

Set-SPSite

Use the Url parameter.

Renameweb

Set-SPWeb

Use the RelativeUrl parameter.

Restore

Restore-SPFarm

Restore-SPSite

Retractsolution

Uninstall-SPSolution

Retractwppack

None

Runcontentdeploymentjob

Start-SPContentDeploymentJob

Scanforfeatures

Install-SPFeature

Use the Scanforfeatures parameter.

Setadminport

Set-SPCentralAdministration

Setapppassword

None

Setconfigdb

Connect-SPConfigurationDatabase

Setcontentdeploymentjobschedule

Set-SPContentDeploymentJob

Setdataconnectionfileproperty

Set-SPDataConnectionFile

Set-ecsexternaldata

Set-SPExcelFileLocation

Set-ecsloadbalancing

Set-SPExcelServiceApplication

Use the LoadBalancingScheme parameter.

Set-ecsmemoryutilization

Set-SPExcelServiceApplication

Use the MemoryCacheThreshold and PrivateBytesMax parameters.

Set-ecssecurity

Set-SPExcelServiceApplication

Use the CrossDomainAccessAllowed, EncryptedUserConnectionRequired, and FileAccessMethod parameters.

Set-ecssessionmanagement

Set-SPExcelServiceApplication

Use the SessionsPerUserMax and SiteCollectionAnonymousSessionsMax parameters.

Set-ecsworkbookcache

Set-SPExcelServiceApplication

Use the Workbookcache and WorkbookCacheSizeMax parameters.

Setformtemplateproperty

Set-SPInfoPathFormTemplate

Setlogginglevel

Set-SPLogLevel

Setosearchsetting

None

Setproperty

Set-SPFarmConfig

Get-SPTimerJob

Disable-SPTimerJob

Enable-SPTimerJob

Set-SPTimerJob

Start-SPTimerJob

Setqueryprocessoroptions

None

Setsitelock

Set-SPSiteAdministration

Use the LockState parameter.

Setsiteuseraccountdirectorypath

Get-SPSiteSubscription

New-SPSiteSubscription

Remove-SPSiteSubscription

Setworkflowconfig

Set-SPWorkflowConfig

Siteowner

Set-SPSiteAdministration

Syncsolution

Install-SPSolution

Use the Synchronize parameter.

Unextendvs

Remove-SPWebApplication

Uninstallfeature

Uninstall-SPFeature

Unquiescefarm

None

Unquiesceformtemplate

Start-SPInfoPathFormTemplate

Unregistersecuritytrimmer

Remove-SPEnterpriseSearchSecurityTrimmer

Unregisterwsswriter

None

Updateaccountpassword

Set-SPManagedAccount

Updatealerttemplates

None

Updatefarmcredentials

None

Upgrade

None

Upgradeformtemplate

Install-SPInfoPathFormTemplate

Upgradesolution

Update-SPSolution

Upgradetargetwebapplication

None

Uploadformtemplate

Install-SPInfoPathFormTemplate

Userrole

Get-SPUser

Move-SPUser

New-SPUser

Remove-SPUser

Set-SPUser

Verifyformtemplate

Test-SPInfoPathFormTemplate

See also

Index of Windows PowerShell cmdlets for SharePoint 2013


System Center Operations Manager knowledge articles (SharePoint 2013)
See also

Navigate to SharePoint 2013 articles about resolving alerts from the Systems Center Operations Manager management pack.

Applies to: SharePoint Server 2013 | SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

The articles in this section are knowledge articles for the SharePoint Server 2013 and SharePoint Foundation 2013 Monitoring Pack for System Center Operations Manager 2012. Typically, you would see these articles after you click a link in an alert in the Operations Manager console. You can use these articles to help you troubleshoot problems in SharePoint 2013. Download and install System Center Monitoring Pack for SharePoint Server or System Center Monitoring Pack for SharePoint Foundation.

In this section:

  • Access Services in SharePoint Server 2013 knowledge articles

  • Machine Translation service in SharePoint Server 2013 knowledge articles

  • Project Server 2013 knowledge articles for Systems Center Operations Manager

  • Search in SharePoint 2013 knowledge articles for Systems Center Operations Manager

  • Visio Services in SharePoint Server 2013 knowledge articles

See also

Plan for monitoring in SharePoint 2013
Monitor health in SharePoint 2013

System Center Monitoring Pack for SharePoint Foundation
System Center Monitoring Pack for SharePoint Server


Access Services in SharePoint Server 2013 knowledge articles
See also

Published: October 16, 2012

Learn how to resolve alerts about Access Services in the SharePoint Server 2013 management pack for Systems Center Operations Manager.

Applies to: SharePoint Server 2013 Enterprise

The articles in this section are knowledge articles for Access Services in SharePoint Server 2013. Typically, you would see these articles after clicking a link in an alert in the Operations Manager console. You can use these articles to help you troubleshoot and resolve problems in Access Services. Download and install System Center Monitoring Pack for SharePoint Server or System Center Monitoring Pack for SharePoint Foundation.

  • No application info from content database

  • WFE to ADS communication failure

  • No servers available for database creation

  • Partitioned SSS communication failure

  • Unpartitioned SSS communication failure

  • Trigger for excessive failed SQL connections requests

  • Excessive failed SQL connections

  • Trigger for excessive SQL connection retries

  • Excessive SQL connection retries

  • Trigger for excessive SQL write failures

  • Excessive SQL write failures

  • No available ADS servers

  • No default proxy

  • Failed to register database server

No application info from content database

Alert Name: Access Services: No application info from content database

Summary: Access Data Services tries to retrieve application information from the SharePoint Content Database, but cannot find the relevant app's information. If this occurs, the application will not be available for use.

Cause

Someone creates a site that uses an Access template that is not actually an Access application.

Resolution

Delete the site that is created incorrectly.

WFE to ADS communication failure

Alert Name: Access Services: WFE to ADS communication failure

Summary: Access Data Services WFE (Web Front End) is unable to communicate with the ADS (Access Data Services) middle tier.

Cause

One or more of the following might be the cause:

  • Network issues

  • Hardware failure

  • SharePoint service failure

  • Disabled Access Database Services on the server

Resolution

  1. Ensure that network is healthy.

  2. Ensure that ADS server is available.

  3. Ensure that ADS server can be accessed from WFE.

  4. Ensure IIS Process for ADS application pool is running.

  5. Ensure that the ADS service is enabled on the failing ADS server.

No servers available for database creation

Alert Name: Access Services: No servers available for database creation

Summary: During application creation, Access Data services cannot find an available SQL Server to provision the new database.

Cause

No SQL database servers are configured for Access to provision new databases.

Resolution

  • If the creation failure occurs while creating from the Access client, check the Database Server group mappings to determine where the shortage has occurred:

    1. Use Get-SPAccessServicesDatabaseServerGroupMapping to determine whether there is a mapping from the Object Model to the Server Group.

    2. Use Get-SPAccessServicesDatabaseServerGroup to determine whether the server group has at least one database.

    3. Use Get-SPAccessServicesDatabaseServer to determine whether there is at least one database in the server group marked as "AvailableForCreate".

  • If the creation failure occurs while creating from the Corporate Catalog, check the Database Server group mappings to determine where the shortage has occurred:

    1. Use Get-SPAccessServicesDatabaseServerGroupMapping to determine whether there is a mapping from the Corporate Catalog to the Server Group.

    2. Use Get-SPAccessServicesDatabaseServerGroup to determine whether the server group has at least one database.

    3. Use Get-SPAccessServicesDatabaseServer to determine whether there is at least one database in the server group marked as "AvailableForCreate".

Related topics

Get-SPAccessServicesDatabaseServerGroupMapping

Get-SPAccessServicesDatabaseServerGroup

Get-SPAccessServicesDatabaseServer

Partitioned SSS communication failure

Alert Name: Access Services: Partitioned SSS communication failure

Summary: Access Data Services tries to communicate with SharePoint partitioned Secure Store Service, but is unable to communicate with it.

Cause

Partitioned Secure Store Service in the farm is down or unreachable because of Network issues or incorrect configurations.

Resolution

  1. Ensure partitioned Secure Store Service Application exists and is running.

  2. Ensure Proxy for partitioned Secure Store Service exists and is in the default Proxy group.

Related topics

Configure the Secure Store Service in SharePoint 2013

Unpartitioned SSS communication failure

Alert Name: Access Services: Unpartitioned SSS communication failure

Summary: Access Data Services tries to communicate with SharePoint unpartitioned Secure Store Service, but is unable to communicate with it.

Cause

Unpartitioned Secure Store Service in the farm is down or unreachable because of Network issues or incorrect configurations.

Resolution

  1. Ensure unpartitioned Secure Store Service Application exists and is running.

  2. Ensure Proxy for unpartitioned Secure Store Service exists and is in the default Proxy group.

Related topics

Configure the Secure Store Service in SharePoint 2013

Trigger for excessive failed SQL connections requests

Alert Name: Access Services: Trigger for excessive failed SQL connections requests

Summary: This alert occurs when Access Data services exceed the expected number of retries when the services connect to the SQL Server Databases.

Cause

SQL Server database server is down, unavailable, or unreachable.

Resolution

  • Check network health.

  • Make sure that the SQL Server database server is available and healthy.

Excessive failed SQL connections

Alert Name: Access Services: Excessive failed SQL connections

Summary: This tracks the number of failed SQL connections.

Cause

N/A

Resolution

N/A

Trigger for excessive SQL connection retries

Alert Name: Access Services: Trigger for excessive SQL connection retries

Summary: This alert occurs when Access Data services exceed the expected number of retries when the services connect to the Application SQL Databases.

Cause

One or more of the following might be the cause:

  • Network issues

  • Application SQL databases are unavailable or unreachable.

Resolution

  1. Check network health.

  2. Check Application SQL databases availability and healthy states.

Excessive SQL connection retries

Alert Name: Access Services: Excessive SQL connection retries

Summary: This monitors the number of SQL Database Server Connection retries.

Cause

N/A

Resolution

N/A

Trigger for excessive SQL write failures

Alert Name: Access Services: Trigger for excessive SQL write failures

Summary: This alert occurs if there are too many SQL Write failures.

Cause

Excessive number of SQL Write failures.

Resolution

  1. Check network health.

  2. Check status of SQL Azure service.

  3. Raise an incident with SQL Azure for resolution.

Excessive SQL write failures

Alert Name: Access Services: Excessive SQL write failures

Summary: Monitors the number of failed SQL Database Server writes

Cause

One or more of the following might be the cause:

  • Application SQL Databases are unavailable or unreachable.

  • Deadlock occurs on the server.

  • Excessive server load makes the database server unresponsive.

Resolution

Ensure that the Database server is available, is not overloaded, and has no deadlocks.

No available ADS servers

Alert Name: Access Services: No available ADS servers

Summary: There are no Access Data Services Servers or the available Access Data Services Servers are not healthy enough to serve the request.

Cause

One or more of the following might be the cause:

  • Excessive memory consumption overloads your ADS Servers.

  • Network problems

  • A number of Access Database Server instances fail or are down.

Resolution

  1. Ensure that Access Database Services is enabled on at least one server in the farm.

  2. Reboot Access Database Service instances to free memory.

  3. Ensure Access Database Service instances are available and are configured correctly.

No default proxy

Alert Name: Access Services: No default proxy

Summary: There is no Access Data Services Proxy in the Default Proxy group.

Cause

No default proxy is established during configuration, or there is a problem during provisions and a default proxy is not established.

Resolution

Use new-SPAccessServicesApplicationProxy to create a new default proxy.

Related topics

New-SPAccessServicesApplication

Failed to register database server

Alert Name: Access Services: Failed to register database server

Summary: During Database server configuration, a server fails to register.

Cause

One or more of the following might be the cause:

  • Network issues connecting to the server

  • Incorrect Database server version

  • Server does not have required features or insufficient permissions

Resolution

  1. Check network health.

  2. Update the database server version.

  3. Install required features or update permissions.

Note:

App pool user must have DBCreator and SecurityAdmin permissions.

See also

Plan for monitoring in SharePoint 2013
Monitor health in SharePoint 2013

System Center Monitoring Pack for SharePoint Foundation
System Center Monitoring Pack for SharePoint Server


Machine Translation service in SharePoint Server 2013 knowledge articles
See also

Learn how to resolve alerts about the Machine Translation service in the SharePoint Server 2013 management pack for Systems Center Operations Manager.

Applies to: SharePoint Server 2013 | SharePoint Server 2013 Enterprise

The articles in this section are knowledge articles for the Machine Translation service in SharePoint Server 2013. Typically, you would see these articles after clicking a link in an alert in the Operations Manager console. You can use these articles to help you troubleshoot and resolve problems that involve the Machine Translation service. Download and install System Center Monitoring Pack for SharePoint Server or System Center Monitoring Pack for SharePoint Foundation.

  • Machine Translation Service: Queue database not accessible

  • Machine Translation Service: Machine translation failure

  • Machine Translation Service: Machine translation failure

  • Machine Translation Service not accessible

  • Machine Translation Service: Content not accessible

  • Machine Translation Service: Worker failure

Machine Translation Service: Queue database not accessible

Alert Name:Machine Translation Service: Queue database not accessible

Summary: A critical state of this Monitor indicates that the Machine Translation Service cannot access content that it has to translate.

Symptoms:

  • New Jobs cannot be submitted successfully.

  • Existing Job Items never complete or seem to "hang" and make no progress in the Job Queue.

Cause

One or more of the following might be the cause:

  • The queue database is not responsive enough because of activity on the network or physical SQL server.

  • Permissions to access the custom database are no longer valid.

  • The queue database is inaccessible.

Resolution

Resolution 1: Verify the status of the SQL Server Machine Translation Service database:

  1. On the SharePoint Central Administration website, in the System Settings section, from the reading pane, click Manage Servers in this farm.

  2. In the Farm Information section, note the Machine Translation Service database server, and the name and the version of the configuration database.

  3. Start SQL Server Management Studio and connect to the configuration database server.

  4. If the configuration database does not exist, run the SharePoint Products and Technologies Configuration Wizard.

Resolution 2: Verify the SQL Server network connection:

  1. On the Central Administration website, in the System Settings section, from the reading pane, click Manage Servers in this farm.

  2. In the Farm Information section, note the Machine Translation Service database server, and the name and the version of the configuration database information.

  3. Open a Command Prompt window and type ping to confirm the server connection.

  4. Failure to contact the server indicates a problem with the network connection or another problem that prevents a response from the server.

  5. Log on to the server and troubleshoot the issue.

Related topics

Machine Translation Service: Machine translation failure

Alert Name:Machine Translation Service: Machine translation failure

Summary: A critical state of this Monitor indicates that machine translation through the online translation service, is failing.

Symptoms:

As long as a connection to the online translation service is not established, the service will function correctly but will fail every Translation Item that is processed.

Cause

One or more of the following might be the cause:

  • The Machine Translation Service is not connected to the Internet.

  • The online translation service is down.

  • The online translation service has experienced a certain amount of intermittent failures (beyond a set threshold).

Resolution

Ensure the Machine Translation Service application has web access:

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the list of service applications, click Machine Translation Service.

  4. In the Online Translation Connection section, in the web proxy server box, do one of the following:

    • Click Use default internet settings.

    • Click Use the proxy specified, and enter a web proxy server and a port number.

Validate the MachineTranslationAddress, MachineTranslationClientId, and MachineTranslationCategory for the Machine Translation Service application:

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. In the PowerShell command prompt, type the following:

    Get-SPServiceApplication -Name "name" | ft MachineTranslationAddress, MachineTranslationClientId, MachineTranslationCategory

    where "name" is the Name of your Machine Translation Service application.

  3. Validate the values returned by comparing against any documentation or making a test call.

  4. Correct any values based on validation. If a value cannot be validated, use the default value.

Machine Translation Service: Machine translation failure

Alert Name:Machine Translation Service: Machine translation failure

Summary:A critical state of this Monitor indicates that the Machine Translation Service Timer Job is failing.

Symptoms:

  • New Jobs will successfully enter into the database. However, the translation items for that job will never start.

  • The existing Jobs may not finish: Any translation items that are already assigned to application servers may still succeed, but translation items that are not assigned to application servers will not start. That leaves the Job perpetually incomplete.

Cause

The Machine Translation Service's queue timer job is not running.

Resolution

Resolution 1: Restart the Machine Translation Service

  1. On the Central Administration website, in the System Settings section, from the reading pane, click Manage servers in this farm.

  2. In the Server column, click the name of the failing application server. The Services on Server page opens.

  3. In the Service column, locate the Machine Translation Service. Click Stop, and then click Start.

Resolution 2: Create a new Machine Translation Service application

  1. On the Central Administration website, in the Application Management section, from the reading pane, click Manage service applications.

  2. In the Type column, click the name of the Visio Services application Machine Translation Service application that has the failing service instance.

  3. On the ribbon, click Delete.

  4. In the Delete Service Application dialog box, click OK.

  5. Create a new Machine Translation Service application.

Machine Translation Service not accessible

Alert Name:Machine Translation Service not accessible

Summary: A critical state of this Monitor indicates that the Machine Translation Service is not accessible.

Symptoms:If service calls are not working for the Machine Translation Service, no jobs can be submitted to the application server for immediate processing or submission to the Job Queue. That is, the service is inaccessible and does not function.

Cause

One or more of the following might be the cause:

  • The specified SharePoint Server application server is inaccessible.

  • The specified application server is responding slowly because of heavy network activity or load on the specific server.

Resolution

Resolution 1: Check the error logs:

  • Open the Windows Event Viewer.

  • Search for event ID 8049 in the Windows. Application Event log.

  • In the event description, note the application server that is failing

Resolution 2: Verify the application server connection:

  • From the failing application server, open the SharePoint Central Administration Web site.

  • If you cannot access the Central Administration site from the failing server, check that the network settings are correct and that the server has appropriate permissions to join the SharePoint farm.

Resolution 3: Verify that the Machine Translation Service runs on the failing server:

  1. On the Central Administration website, in the reading pane, in the System Settings section, click Manage servers in this farm.

  2. Verify that the Machine Translation Service runs on the failing application server.

  3. If there is a service application proxy for the failing service application, create a new service application.

Resolution 4: Restart the Machine Translation Service:

  1. On the Central Administration website, in the reading pane, in the System Settings section, click Manage servers in this farm.

  2. In the Server column, click the name of the failing application server. The Services on Server page opens.

  3. In the Service column, locate the Machine Translation Service, click Stop, and then click Start.

Resolution 5: Create a new Machine Translation Service application:

  1. On the Central Administration website, in the reading pane, in the Application Management section, click Manage service applications.

  2. In the Type column, click the name of the Visio Services application Machine Translation Service application that has the failing service instance.

  3. On the ribbon, click Delete.

  4. In the Delete Service Application dialog box, click OK.

  5. Create a new Machine Translation Service application.

Machine Translation Service: Content not accessible

Alert Name:Machine Translation Service: Content not accessible

Summary: Critical state of this Monitor indicates that back-end to front-end CSOM calls are failing.

Symptoms: No files can be retrieved for processing and items that are already being processed will not be written. That is, files are inaccessible and items will continuously fail.

Cause

One or more of the following might be the cause:

  • Server to server Authentication is configured incorrectly.

  • The content database is not responsive enough because of activity on the network or physical SQL server.

  • Permissions to access the content database are no longer valid.

  • The content database is inaccessible.

Resolution

Resolution 1: Verify the status of the SQL Server content database:

  1. On the SharePoint Central Administration website, in the System Settings section from the reading pane, click Manage Servers in this farm.

  2. In the Farm Information section, note the content database server, and the name and the version of the configuration database.

  3. Start SQL Server Management Studio and connect to the content database server.

  4. If the content database does not exist, run the SharePoint Products and Technologies Configuration Wizard.

Resolution 2: Verify the SQL Server network connection:

  1. On the Central Administration website, in the System Settings section, from the reading pane, click Manage Servers in this farm.

  2. In the Farm Information section, note the content database server and the name and the version of the content database information.

  3. Open a Command Prompt window and type ping to confirm the server connection.

    Failure to contact the server indicates a problem with the network connection or another problem that prevents a response from the server.

  4. Log on to the server and troubleshoot the issue.

Resolution 3: Verify Server to Server Authentication is configured correctly:

See Configure server-to-server authentication in SharePoint 2013.

Machine Translation Service: Worker failure

Alert Name:Machine Translation Service: Worker failure

Summary: A critical state of this Monitor indicates that the Machine Translation Service worker processes are failing.

Symptoms:These errors have to be monitored so end-users are not seeing all the items fail over a certain span of time.

Cause

One or more of the following might be the cause:

  • Corrupt input file

  • Translation worker crash

  • Error of saving the file to the local store

Resolution

Resolution 1: Check the error logs:

  1. Open the Windows Event Viewer.

  2. Search for event ID 8049 in the Windows Application Event log.

  3. In the event description, note the application server that is failing.

Resolution 2: Verify the application server connection:

  1. From the failing application server, open the SharePoint Central Administration website.

  2. If you cannot access the Central Administration website from the failing server, check that the network settings are correct and that the server has appropriate permissions to join the SharePoint farm.

Resolution 3: Verify that the Machine Translation Service runs on the failing server:

  1. On the Central Administration website, in the reading pane, in the System Settings section, click Manage servers in this farm.

  2. Verify that the Machine Translation Service runs on the failing application server.

  3. If there is a service application proxy for the failing service application, create a new service application.

Resolution 4: Restart the Machine Translation Service:

  1. On the Central Administration website, in the reading pane, in the System Settings section, click Manage servers in this farm.

  2. In the Server column, click the name of the failing application server. The Services on Server page opens.

  3. In the Service column, locate the Machine Translation Service, click Stop, and then click Start.

Resolution 5: Create a new Machine Translation Service application

  1. On the Central Administration website, from the reading pane, in the Application Management section, from the reading pane, click Manage service applications.

  2. In the Type column, click the name of the Visio Services application Machine Translation Service application that has the failing service instance.

  3. On the ribbon, click Delete.

  4. In the Delete Service Application dialog box, click OK.

  5. Create a new Machine Translation Service application.

See also

Plan for monitoring in SharePoint 2013
Monitor health in SharePoint 2013
Create and configure Machine Translation services in SharePoint Server 2013

System Center Monitoring Pack for SharePoint Foundation
System Center Monitoring Pack for SharePoint Server


Project Server 2013 knowledge articles for Systems Center Operations Manager
See also

Summary: Learn how to resolve alerts about Project Server in the SharePoint Server 2013 management pack for Systems Center Operations Manager (SCOM).

Applies to: Project Server 2013

The articles in this section are knowledge articles for Project Server 2013 that appear in the SharePoint Server 2013 management pack (MP). Typically, you would see these articles after clicking a link in an alert in the Operations Manager console. You can use these articles to help you troubleshoot and resolve problems in Project Server 2013.

New SCOM alerts in Project Server 2013:

  • Project WFE to application server connection failed (SharePoint 2013 monitoring rule)

  • Project WFE to application server connection failed

Alerts for Project Server 2013 and Project Server 2010:

  • Project Active Directory Connection Failed

  • Project Active Directory Exception Occurred During Synchronization

  • Project Active Directory Nested Foreign Security Principal Could Not Be Resolved

  • Project Active Directory Nested Object Could Not Be Resolved

  • Project Active Directory PWA Group Could Not Be Resolved

  • Project Active Directory Top Level Group Has No Members

  • Project Creating Report Center Web Failed

  • Project Cube Build Service Analysis Services Server Connection Failure

  • Project Cube Build Service Analysis Services Server Lock Time Out

  • Project Cube Build Service Attempt To Overwrite Failed

  • Project Cube Build Service Decision Support Object Is Not Installed

  • Project Cube Build Service OLAP Processing Failure

  • Project Failure Creating a Project Workspace

  • Project General Data Access Layer Error Connecting To Database

  • Project General Data Access Layer Error While Getting Connection Strings

  • Project Notification Email Delivery Failed

  • Project Notification XSLT Transformation Error

  • Project Queue General Percentage SQL Retries Per Day

  • Project Queue General Percentage SQL Retries Per Hour

  • Project Queue Jobs Average Wait Time Per Day

  • Project Queue Jobs Percentage Jobs Failed Per Day

  • Project Queue Jobs Percentage Jobs Failed Per Hour

  • Project Queue System Restarting Due to Unexpected Error

  • Project Reporting Server Side Event Has Failed

  • Project Server Side Event Handler Could Not Be Found

  • Project Server Event Service Could Not Be Found

  • Project SQL User View Refresh Message Was Not Queued

  • Project User View Was Truncated

  • Project Windows SharePoint Services Format Error

  • Project Winproj Average Time Taken For Project Open

  • Project Winproj Percentage Of Incremental Save To Full Save

  • Project Workspace User Synchronization Failed

Project WFE to application server connection failed (SharePoint 2013 monitoring rule)

Alert Name:Project WFE to application server connection failed

Summary: This alert occurs when a Project Server front-end server cannot connect to a back-end server. Requests are no longer transferred from the front-end to the back-end.

Cause

Potential root causes include:

  • Hardware issues

  • Networking issues

  • Permissions issues

Resolution

Check standard connectivity on the faulty computers:

  1. Ensure there are no hardware failures on any computer that reported the error.

  2. Perform basic network connectivity checks between the front-end and back-end computers.

  3. Check Project service accounts credentials and permissions.

Project WFE to application server connection failed

Alert Name:Project WFE to application server connection failed

Summary: This alert occurs when a Project Server front-end server cannot connect to a back-end server. Requests are no longer transferred from the front-end to the back-end.

Cause

Potential root causes include:

  • Hardware issues

  • Networking issues

  • Permissions issues

Resolution

Check standard connectivity on the faulty computers:

  1. Ensure there are no hardware failures on any computer that reported the error.

  2. Perform basic network connectivity checks between the front-end and back-end computers.

  3. Check Project service accounts credentials and permissions.

See also

Plan for monitoring in SharePoint 2013
Monitor health in SharePoint 2013
System Center Operations Manager knowledge articles (SharePoint 2013)

Operations for Project Server 2013


Search in SharePoint 2013 knowledge articles for Systems Center Operations Manager
See also

Published: October 16, 2012

Learn how to resolve alerts about the search index, content processing, query processing, and other search issues in the SharePoint 2013 management pack for Systems Center Operations Manager.

Applies to: SharePoint Server 2013 | SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

The articles in this section are knowledge articles for search services in SharePoint 2013. Typically, these articles appear when you click a link in an alert in the Operations Manager console. You can use these articles to help you troubleshoot and resolve problems in search. Download and install System Center Monitoring Pack for SharePoint Server or System Center Monitoring Pack for SharePoint Foundation.

  • Analytics analysis: failed to start - search analytics

  • Analytics analysis: failed to start warning - search analytics

  • Content Processing: Fallback word breaker did not load

  • Content Processing: Query classification dictionary exceeds size limit

  • Content Processing: Spelling dictionary exceeds size limit

  • Content Processing: Search Custom Dictionaries Update

  • Content Processing: Spelling Dictionary Update

  • Content Processing: Gatherer Content Processing connector

  • Content Processing: flow failed to start

  • Content Processing: Query classification dictionary close to size limit

  • Content Processing: Spelling dictionary close to size limit

  • Crawler: Search Gatherer Host Unavailable

  • DocParsing: No More Parser Server Workers

  • DocParsing: Parser Server Worker Failed to Restart

  • Index: Lost Generations

  • Index: Missing partition

  • Index: Indexing Blocked

  • Index: Journal IO Exception Read

  • Index: Journal IO Exception Write

  • Index Lookup: Schema service availability query processing

  • Index Lookup: Missing partition

  • Query Processing: Query classification dictionary update

  • Query Processing: Search Service Application Availability

  • Query Processing: Component Availability - Query Processing

  • Query processing: flow failed to start

  • Query Processing: Fallback word breaker did not load

  • Query Processing: Query Component Get Configuration

  • Query Processing: Query Normalization Schema Service Availability

  • Query Processing: Query Parsing Schema Service Availability

  • Query Processing: QueryParsing Scope Cache Availability

  • Query Service: Service availability query processing

  • Query Service: Start Service Availability - Query Processing

  • Query Service: Unable to stop query processing

  • Query URL Mapping: Alternate URL Mapping Service Availability - Query Processing

  • Schema Reader: Schema Service Availability - Query Processing

  • Search Admin Platform Services: Repository Initialization Failed

  • Search Admin Platform Services: Repository Installation Failed

  • Search Admin Platform Services: Repository Replication

  • Search Analytics: analysis run state Search Analytics

  • Search analytics: Timer job cannot resolve Analytics Processing Engine (APE)

  • Search Analytics: Timer job cannot resolve Link database

  • Search Analytics: analysis run state search analytics

  • Search Gatherer: Disk Full Crawler

  • Search Usage Analytics: Analysis configuration failed

  • Search Usage Analytics: Analysis failed to start

  • Search Usage Analytics: Feeding failure

  • Search Usage Analytics: Reporting API write failure

  • Search Usage Analytics: Store not available

  • Search Usage Analytics: Usage analytics APE not available

  • Usage table exceeded max bytes limit

  • Usage table exceeded max bytes limit

  • Services Host Controller

Analytics analysis: failed to start - search analytics

Alert Name: Analytics analysis: failed to start - search analytics

Summary: At a preconfigured time interval (once every 24 hours) the timer job will try to start a run of the search analytics analysis. This alert is triggered when the timer job fails to start the analysis.

Multiple problems can prevent the analysis from being started. If the timer job fails to start the analysis, the timer job will stop and retry later (in 10 minutes).

Cause

  • Analytics processing component is not available.

  • Network outage.

  • Server issues.

  • Analysis configuration database not available.

Resolution

Make sure these areas are functioning:

  • The analytics processing component is functioning properly.

  • There are no networking issues.

  • There are no server issues.

  • The analysis reporting database is available.

Analytics analysis: failed to start warning - search analytics

Alert Name: Analytics analysis: failed to start warning - search analytics

Summary: If a search analytics analysis is still running when the timer job is trying to start a new run of the same analysis, this new start has to be postponed. The system with try to restart the search analytics analysis as soon as the timer job detects that the running analysis has stopped.

Cause

One or more of the following might be the cause:

  • Previous analysis run has not completed.

  • Heavy load on servers or network leads to longer analysis run time.

Resolution

Make sure these areas are functioning:

  • Current running analysis does have progress. If not, investigate why there is no progress. There might be a networking or server issue. Resolve these. Do make sure that all databases are available (Link database, analytics reporting database, etc.).

  • You might have to perform a manual stop of the analysis if it is running without any progress.

Content Processing: Fallback word breaker did not load

Alert Name: Content Processing: Fallback word breaker did not load

Summary: The word breaker service could not load the fallback word breaker for the indicated word breaker language.

Cause

Installation error or another transient error that might be resolved by a content processing component restart or rebooting the server In an on-premises setting, it could also indicate an error caused by changing the word breaker configuration.

Resolution

Restart the content processing component or restart the server. component. If a word breaker customization was tried, the logs could suggest more information to indicate a cause and resolution.

Content Processing: Query classification dictionary exceeds size limit

Alert Name: Content Processing: Query classification dictionary exceeds size limit

Summary: The dictionary has grown too large and is exceeding the size limit. The current dictionary will still be used and no dictionary updates will occur until dictionary compilation succeeds again. The system will retry until the dictionary compiles again. But a reduction in data from the Term Store may be required.

Cause

The dictionary used for query classification rules has grown too large and is now exceeding the size limit.

Resolution

Check the term sets used for query classification rules. Entries may need reducing to make the dictionary compile again. The recurring retries may otherwise create a high load on the content processing component.

Content Processing: Spelling dictionary exceeds size limit

Alert Name: Content Processing: Spelling dictionary exceeds size limit

Summary: The query spelling correction dictionary has grown too large and is now exceeding the size limit. The current dictionary will still be used and no dictionary updates will occur until dictionary compilation succeeds again. The system will retry until the dictionary compiles again. But a reduction in data in the search index or a reconfiguration of the query spelling components may be required.

Cause

The dynamic query spelling correction dictionary has grown too large and is exceeding the size limit.

Resolution

Check the size of the index. This error indicates that the index is very large and might need splitting soon. Also, consider lowering the number of dictionary terms allowed per organization by using the cmdlet Set-SPEnterpriseSearchQuerySpellingCorrection. The recurring retries may otherwise create a high load on the content processing component.

Content Processing: Search Custom Dictionaries Update

Alert Name: Content Processing: Search Custom Dictionaries Update

Summary: The timer job "Search Custom Dictionaries Update" fails.

Cause

One or more of the following might be the cause:

  • The Search service application or the term store is paused or not available.

  • An error occurred during the deployment of the custom entity extraction dictionary or while establishing a connection.

Resolution

  • Check the status of the Search service application and the term store, restart if it is necessary.

  • Check whether the custom entity extraction dictionary is deployed, and make sure that connection is present.

  • Restart timer job if necessary.

Content Processing: Spelling Dictionary Update

Alert Name: Content Processing: Spelling Dictionary Update

Summary: The timer job "Spelling Dictionary Update" fails.

Cause

One or more of the following might be the cause:

  • The Search service application or the term store is paused or not available.

  • An error occurs during deployment or connection establishment.

Resolution

  • Check the status of the Search service application and the term store, restart if it is necessary.

  • Make sure that connection is present.

  • Restart timer job if it is necessary.

Content Processing: Gatherer Content Processing connector

Alert Name: Content Processing: Gatherer Content Processing connector

Summary: The crawler could not connect to content processing.

Cause

This may be caused by intermittent loss of network connectivity, or the content processing component is not available.

Resolution

If the problem persists, check network connectivity between the crawler and content Processing. Also, check the content processing component, and restart if it is necessary.

Content Processing: flow failed to start

Alert Name: Content Processing: flow failed to start

Summary: The indicated processing flow is not started as expected.

Cause

The required services are not present, or the search index may be unavailable.

Resolution

Check that the required search components and databases are running and restart these if necessary.

Content Processing: Query classification dictionary close to size limit

Alert Name: Content Processing: Query classification dictionary close to size limit

Summary: The dictionary has grown close to its size limit (at or beyond 80 percent of its size limit).

Cause

The number of terms in the corresponding dictionary used for query classification rules across all organizations is growing towards the limit.

Resolution

Check the term sets used for query classification.

Content Processing: Spelling dictionary close to size limit

Alert Name: Content Processing: Spelling dictionary close to size limit

Summary: The query spelling correction dictionary has grown close to its size limit (at or beyond 80 percent of its size limit).

Cause

The number of terms relevant for the dynamic query spelling correction dictionary across all organizations is growing towards the limit.

Resolution

Check the number of indexed documents. If the number of indexed documents is close to the system's limit, this warning can be discarded.

Crawler: Search Gatherer Host Unavailable

Alert Name: Crawler: Search Gatherer Host Unavailable

Summary: As part of a search crawl, the servers that contain the crawl components communicate with content servers to retrieve the items for the crawl. Network communication problems between crawl server and content server will block this crawl. When SharePoint is crawling content from a specific content server and network communication problems exist, SharePoint might display the following symptoms:

  • The crawl of the specific content server does not progress and seems to stall.

  • The crawl logs show no new crawled documents for the specific content server.

Cause

Network issues might be preventing the communication. Check that the content server is online and can connect to the server that hosts the crawl component.

Resolution

Check the status of the content server. If the content server is online and serves content to the crawl account, check for network connection issues.

DocParsing: No More Parser Server Workers

Alert Name: DocParsing: No More Parser Server Workers

Summary: All parser server workers cannot restart. Therefore the pool has no more workers available. At this point, only format handlers that are not configured to run in a sandbox can run.

Cause

One or more of the following might be the cause:

  • Broken pipe between the parser server and the content processing component.

  • Excessive resource usage causing a time-out to obtain resources.

  • Permission failure to any of the required directories.

  • External change in directory permission of either the parser process or the temporary directory that it writes to.

  • Misplaced or corrupted configuration file.

Resolution

  • Check CPU and memory usage of the content processing component.

  • Check appropriate permissions to parserserver.exe and the related directories.

  • Check the configuration file.

DocParsing: Parser Server Worker Failed to Restart

Alert Name: DocParsing: Parser Server Worker Failed to Restart

Summary: A parser server worker cannot restart. Therefore it is being removed from the pool. The pool still has the indicated number of workers available. This occurs when a worker inside the parser server pool could not restart. When this happens, the number of available workers in the pool is decreased, which reduces throughput.

Cause

One or more of the following might be the cause:

  • Broken pipe between the parser server and the content processing component

  • Excessive resource usage causing a time-out to obtain resources.

  • Permission failure to any of the required directories;

  • External change in directory permission of either the parser process or the temporary directory that it writes to.

  • Misplaced or corrupted configuration file.

Resolution

  • Check CPU and memory usage of the content processing component.

  • Check appropriate permissions to parserserver.exe and the related directories.

  • Check the configuration file.

Index: Lost Generations

Alert Name: Index: Lost Generations

Summary: Data acknowledged as indexed is permanently lost. Potentially lost documents on the index system indicated, between the given generations.

Cause

This may be caused by the amount failures exceeding the fault-tolerance.

Resolution

A full re-crawl may be required.

Index: Missing partition

Alert Name: Index: Missing partition

Summary: Incomplete result set because of one or more missing partitions on the indicated index system. This may require resending of information if the related search components remain unavailable. That is, it continues to fail.

Cause

One or more of the following might be the cause:

  • Missing injection from index component on the query processing component.

  • Lost network connectivity.

  • Index component fails.

Resolution

  • Lookup Service will restart automatically.

  • Check index component.

  • Check communication issues.

Index: Indexing Blocked

Alert Name: Index: Indexing Blocked

Summary: Information flow from content processor to index is blocked; waiting for a checkpoint (time indicated). This is limiting index speed; indexing queues remain full for longer than expected.

Cause

One or more of the following might be the cause:

  • Indexer not receiving enough resources.

  • Information coming in too quickly.

Resolution

Investigate resource usage on the index component, and possibly adjust the search topology to lower the feeding rate.

Index: Journal IO Exception Read

Alert Name: Index: Journal IO Exception Read

Summary: Unable to read Journal file. This indicates a potential problem with recovery or replication. Indexing is stopped.

Cause

Journal file is stored on disk, external cause to indexer may be:

  • Lock on file.

  • Changes to file.

  • Physical disk problem.

Resolution

  • Release lock on file.

  • Revert changes.

  • Fix disk.

This issue may require deleting the Journal and refeeding.

Index: Journal IO Exception Write

Alert Name: Index: Journal IO Exception Write

Summary: Unable to write to Journal file. This indicates a potential problem with recovery or replication. Indexing is stopped.

Cause

Journal file is stored on disk. External cause to indexer may be:

  • Lock on file.

  • Changes to file.

  • Physical disk problems.

Resolution

  • Release lock on file.

  • Revert changes.

  • Fix disk.

This issue may require deleting the Journal and refeeding.

Index Lookup: Schema service availability query processing

Alert Name: Index Lookup: Schema service availability query processing

Summary: Index lookup could not work because the schema service was not available.

Cause

The indexer or the database, or both are unavailable.

Resolution

Check, and restart, the Schema service or OM, if it is necessary.

Index Lookup: Missing partition

Alert Name: Index Lookup: Missing partition

Summary: One or more partitions are missing on the index system indicated. This means that at least one content processing component has no connection to one primary index component. Therefore the system cannot feed for that particular connection.

Cause

Possible causes include the following:

  • Index component down.

  • Missing injection from index component on the content processing component.

  • Lost network connectivity.

Resolution

The service will restart automatically; check index component; check communication issues, restart if it is necessary.

Query Processing: Query classification dictionary update

Alert Name: Query Processing: Query classification dictionary update

Summary: The timer job Query Classification Dictionary fails.

Cause

One or more of the following might be the cause:

  • The Search service application is paused or not available.

  • An error occurred during deployment or connection establishment.

Resolution

  • Check the status of the Search service application, and restart if it is necessary.

  • Make sure that connection is present.

  • Restart timer job if it is necessary.

Query Processing: Search Service Application Availability

Alert Name: Query Processing: Search Service Application Availability

Summary: Query parsing could not work because the Search service application with the indicated ID is not available. The Search service application is down. Therefore service is interrupted.

Cause

The Search service application is not available.

Resolution

Check, and restart, the Search service application if it is necessary.

Query Processing: Component Availability - Query Processing

Alert Name: Query Processing: Component Availability - Query Processing

Summary: The query processing component is stopped and is unavailable.

Cause

The query processing component is stopped under either expected or unexpected conditions.

Resolution

If the issue persists, this indicates system issues. Check and restart the query processing component, if it is necessary.

Query processing: flow failed to start

Alert Name: Query processing: flow failed to start

Summary: The indicated processing flow is not started as expected.

Cause

The required services are not present, or the index may be unavailable.

Resolution

Check that the required search components and databases are running and restart these if necessary.

Query Processing: Fallback word breaker did not load

Alert Name: Query Processing: Fallback word breaker did not load

Summary: The word breaker service could not load the fallback word breaker, for the indicated word breaker language.

Cause

Installation error or another transient error that might be resolved by a component restart or rebooting the server. In an on-premises setting, it could also indicate an error caused by changing the word breaker configuration.

Resolution

Restart the query processing component or restart the server. If a word breaker customization was tried, the logs could suggest more information to indicate a cause and resolution.

Query Processing: Query Component Get Configuration

Alert Name: Query Processing: Query Component Get Configuration

Summary: Unable to get the configuration for query processing component. So, the query service cannot start and is currently not working.

Cause

Corrupt or missing configuration.

Resolution

Check settings for the query processing component.

Query Processing: Query Normalization Schema Service Availability

Alert Name: Query Processing: Query Normalization Schema Service Availability

Summary: Query normalization could not work for the particular query because the schema service was not available. Query processing fails for particular queries.

Cause

The indexer is unavailable, or the search administration database is down, or both.

Resolution

Check and restart the schema service or OM.

Query Processing: Query Parsing Schema Service Availability

Alert Name: Query Processing: Query Parsing Schema Service Availability

Summary: Query parsing could not work for the particular query because the schema service related to the indicated Search service application was not available. Query parsing fails for particular queries.

Cause

The indexer is unavailable, or the search administration database is down, or both.

  1. The query processing component has restarted and cannot access any index component. Check index components.

  2. Indexers are available, but cannot provide the schema to query processing.

Resolution

Check and restart the schema service or OM.

Query Processing: QueryParsing Scope Cache Availability

Alert Name: Query Processing: QueryParsing Scope Cache Availability

Summary: Query parsing could not work for the particular query because the query rules for the indicated Search Service service Aapplication was not available.

Cause

Query rules are not available.

Resolution

Check the query rules.

Query Service: Service availability query processing

Alert Name: Query Service: Service availability query processing

Summary: The query service that has the indicated service URI has stopped.

Cause

Query processing component is stopped under either expected or unexpected conditions. That leads to the shutdown of the WCF service it exposes.

Resolution

If the issue persists, check and restart the query processing component.

Query Service: Start Service Availability - Query Processing

Alert Name: Query Service: Start Service Availability - Query Processing

Summary: Unable to start the query service that has the indicated service URI because the query service is not working correctly.

Cause

Potential network communication service issues. For example, the WCF port is in use.

Resolution

Restart the query processing component, the query service or WCF services if the WCF port is in use and has to be released.

Query Service: Unable to stop query processing

Alert Name: Query Service: Unable to stop query processing

Summary: Unable to stop the query service that has the indicated service URI.

Cause

Potential network communication service issues. For example, the WCF port is in use.

Resolution

Restart the query processing component, the query Service or WCF services if the WCF port is in use and has to be released.

Query URL Mapping: Alternate URL Mapping Service Availability - Query Processing

Alert Name: Query URL Mapping: Alternate URL Mapping Service Availability - Query Processing

Summary: The alternate URL mapping did not work because the mapping service was not available. Query or results processing fails.

Cause

The Alternate Access Mapping OM is unavailable.

Resolution

Check, and restart, the Alternate Access Mapping service or OM if it is necessary.

Schema Reader: Schema Service Availability - Query Processing

Alert Name: Schema Reader: Schema Service Availability - Query Processing

Summary: The schema reader cannot work for the particular query because the schema service is not available. Query processing fails for particular queries.

Cause

The Indexer is unavailable, or the search administration database is down, or both.

Resolution

Check and restart the schema service or OM if it is necessary.

Search Admin Platform Services: Repository Initialization Failed

Alert Name: Search Admin Platform Services: Repository Initialization Failed

Summary: The PackageManager service in each component will read the Default-manifest.txt on component startup to find the current status of the repository quickly. While running, the PackageManager in each component obtains updates about installs and uninstalls from the host controller. In this case, the repository could not be initialized. This means that there was a failure when the repository was initializing on host controller startup. For example, during a primary failover or during a repository reset.

Cause

The cause could be an ACL issue or a corrupted repository manifest file. If it is a corrupted repository with a good manifest file, initialization will try to rebuild the repository again. However, the same event is also sent when rebuild fails.

Resolution

  1. Check for potential ACL issues.

  2. Follow this procedure for fixing the repository on secondary (not primary) hosts:

    • Stop the host controller.

    • Delete the directory C:\Program Files\Microsoft Office Servers\15.0\Data\Office Server\Applications\Search\Repository.

    • Start the host controller. This will affect the host controller to create an empty repository with a GUID that does not match the primary. So, the secondary will immediately start to replicate the contents of the primary.

Search Admin Platform Services: Repository Installation Failed

Alert Name: Search Admin Platform Services: Repository Installation Failed

Summary: Repository installation fails for the file indicated. When dictionary installation fails for the primary, users should be aware that linguistic features such as query suggestions might get outdated.

Cause

The file may already be installed in the repository, or the related timer job may have failed.

Resolution

Check the repository. Make sure that a dictionary compilation timer job has completed successfully after the event. You can manually trigger the timer job from Central Administration or by using Windows PowerShell in order to re-install.

Search Admin Platform Services: Repository Replication

Alert Name: Search Admin Platform Services: Repository Replication

Summary: This situation occurs in secondary repositories. The repository in the local host controller has found that it has a lower repository version than the primary host controller (or lower version than other secondary host controllers if the primary is down). When this happens, the local repository attempts to obtain the latest version from the primary or a secondary based on how it is triggered. This indicates that something went wrong during the replication.

Cause

Connection to the remote repository which is being replicated can be lost due to a network issue or due to a remote repository (host controller) issue during replication. The local repository can be corrupted or have an ACL issue.

Resolution

If persistent, a manual intervention might require to make it correct based on the problem (see cause). Except for the obvious resolutions on network and ACL and so on, remote host controller can be restarted. If the repository is corrupted, usually it is automatically rebuilt.

Search Analytics: analysis run state Search Analytics

Alert Name: Search Analytics: analysis run state Search Analytics

Summary: An analysis can encounter different problems. Hence the system cannot guarantee a successful run of search analytics analysis. The timer job, following the analysis failure model, will try to re-schedule a new analysis run to prevent from waiting until daily schedule is triggered.

Symptoms: Monitor is triggered when unsuccessful analysis run is detected by the timer job.

Cause

One or more of the following might be the cause:

  • Analytics processing component(s) or some other farm components are not available.

  • Databases (Link database, analytics reporting database, etc.) are not running or reachable.

  • Network outage.

  • Server issues.

Resolution

Make sure these areas are functioning:

  • The analytics processing component(s) and other farm components are functioning correctly.

  • There are no networking issues.

  • There are no server issues.

  • The analytics databases are available and that the user can read or write to the databases.

Search analytics: Timer job cannot resolve Analytics Processing Engine (APE)

Alert Name: Search analytics: Timer job cannot resolve Analytics Processing Engine (APE)

Summary: After the timer job has successfully found the Search service application it will try to resolve the Analysis Processing Engine in the analytics processing component. This component is needed to be able to read or write the analysis configuration and to start, stop, suspend, or resume the analysis. Symptoms: If the system cannot locate or communicate with the Analysis Processing Engine, it will be unable to start a new run of the analysis.

Cause

One or more of the following might be the cause:

  • Unable to connect to Search service application.

  • Unable to connect to the search administration component.

  • Unable to connect to System Manager.

  • Unable to connect to the Analysis Processing Engine.

Resolution

Ensure that the following components are up and running:

  • Search service application.

  • Search administration component.

  • System Manager.

  • Analysis Processing component.

Search Analytics: Timer job cannot resolve Link database

Alert Name: Search Analytics: Timer job cannot resolve Link database

Summary: The timer job will check that all Link database partitions are available before it tries to start the search analytics analysis.Symptoms:If the Link database partitions are unavailable when it is time to start a new analysis run, the start try will be aborted. New Link database checks followed by a new start try will be performed in the next timer job polls (every 10 minutes).

Cause

One or more of the following might be the cause:

  • Unable to resolve the Search service application.

  • Link database connection timed out.

  • Link database connection is refused.

  • Link database is not available.

Resolution

Verify that the Link database is available and reachable. Also verify that the user has access to read from the Link database.

Search Analytics: analysis run state search analytics

Alert Name: Search Analytics: analysis run state search analytics

Summary: The search analytics analysis is started by its timer job. The analysis will run until all its tasks are completed, and the analysis state will be set to Stopped. If some tasks cannot be completed, the analysis run will be stopped (after some retries) and the state set to Failed. Stopped before completion indicates that the analysis has reached the Stopped state, but all analysis tasks have NOT completed. Some of the work done by the analysis might have been sent to the index then, but to make sure nothing is lost and all of the work is processed again during next analysis run.

Cause

Analysis is stopped for the following reasons:

  • A manual stop on a running search analytics analysis was performed

  • Or, system maintenance tasks require stopping a running search analytics analysis.

Resolution

Check the state of the search analytics analysis and any active system maintenance tasks.

Search Gatherer: Disk Full Crawler

Alert Name: Search Gatherer: Disk Full Crawler

Summary: As the crawler crawls content, it creates files in a temporary location. This temporary location can grow over time. The disk where the temporary location is located is running out of space. SharePoint experiences the following symptoms when this happens:

  • The crawl does not progress and seems to stall.

  • The crawl logs show no new crawled documents.

Cause

The disk on which the crawler creates temporary files is running out of space.

Resolution

  • Free up space on the disk on which the crawler creates the temporary files. To free up disk space: Use Disk Cleanup to delete temporary files on the drive where the temporary index files are stored. Use the procedure following this one to determine the location of the index files.

    Note:

    If the temporary files are located on a drive other than the operating system drive (drive C), you must restart the search service to test the performance of the crawler after you delete the temporary files.

  • After Disk Cleanup is complete, test the performance of the crawler.

  • If the crawler is not crawling content, delete unnecessary files and folders on the selected drive.

  • If you cannot clear any disk space, restart the search service. Restarting the search service recreates the Temp directory for crawled files. In a Command Prompt window, run the command net stop osearch15 to stop the search service. Run the command net start osearch15 to restart the search service.

Search Usage Analytics: Analysis configuration failed

Alert Name: Search Usage Analytics: Analysis configuration failed

Summary:

  1. If the system cannot get or set the analysis configuration, it will not schedule a new run of the analysis. The timer job will retry later.

  2. Analysis run with wrong event configuration:

    • Wrong recommendations weight.

    • Wrong event rate weight.

  3. When the deletion scopes are fetched, any errors from the API will result in an event. The analysis can still run without this. However, the quality or correctness of the result will deteriorate over time.

Cause

One or more of the following might be the cause:

  1. Analytics processing component not available.

    • Network issues.

    • Time-out from API.

    • Analytics processing component throwing exceptions.

    • Analytics reporting database down.

    • Networking issues.

    • Errors in configuration.

  2. Getting wrong event configuration from API.

    • No configuration data is present in the system.

    • Networking problems causing API calls to fail.

    • API returning time-out.

  3. Network issues causing failures when you are using the API.

    • The API returning errors.

Resolution

  1. Make sure these areas are functioning:

    • There is a Search service application in the system.

    • The Analytics processingcomponent is functioning correctly.

    • There are no networking issues.

  2. Check configuration.

  3. Verify that the component where the API is running is up and functioning.

    • Check for any network problems.

  4. Verify that search analytics has run the last 30 days.

Search Usage Analytics: Analysis failed to start

Alert Name: Search Usage Analytics: Analysis failed to start

Summary: Usage analytics analysis cannot start, or usage analytics analysis fails during execution.

Cause

One or more of the following might be the cause:

  1. This can be caused by external dependencies like configuration, analytics processing component or Search service application dependencies or networking issues.

  2. This monitor can also be triggered if the usage analytics analysis fails during execution.

  3. This can be caused by failures in components usage analytics depend on, such as the analytics processing component or other networking issues.

  4. There can also be something in the events being processed causing the analysis to fail.

Resolution

Verify other System Center Operations Manager monitors and see whether any parent errors are present.

  • The Search service application is up.

  • The analytics processing database and link databases are running, and are in healthy state.

  • There is no problem with the analytics processing component

  • There is no problem with disk space.

  • There is no metwork connectivity issue.

  • The usage analytics timer job is running.

  • The search analytics timer job is running.

  • Verify the status of the search analytics analysis.

Search Usage Analytics: Feeding failure

Alert Name: Search Usage Analytics: Feeding failure

Summary: This means the recommendations and statistics provided by usage analytics will be old or missing. Any recent analysis changes will not be visible.

Symptom: usage analytics feeding required for the analysis was unsuccessful.

Cause

One or more of the following might be the cause:

  • The indexer is returning errors.

  • The content processing component is not working.

  • The component that the indexer is running on could be down.

Resolution

  • Verify that the index system is functioning correctly.

  • Check for network errors.

  • Make sure there are no errors on the analytics processing component.

Search Usage Analytics: Reporting API write failure

Alert Name: Search Usage Analytics: Reporting API write failure

Summary: Background or symptoms:

  1. The information written to the reporting API or database is used if the cache files must be rebuilt. When usage analytics cannot write to the reporting API, this means that the recommendations and data is not updated. Counts presented to the user are therefore out of date, and old or wrong data will also be presented next time that the cache is rebuilt.

  2. The Reporting API could not be read so that no cache files could be created and the analysis will therefore not be run. Running the analysis in this state would in effect overwrite the current data.

Impact:

  • There will be no usage analytics analysis run.

  • Recommendations will not be updated for items in the system.

Cause

One or more of the following might be the cause:

  • Reporting API is returning an error saying database is down.

  • Reporting API is responding that the wrong data is being sent (nothing is stored).

  • The reporting API cannot be reached (networking issues).

  • Reporting API is returning an error saying database is down

  • Reporting API is returning empty (wrong data).

  • The cache dumper is malfunctioning.

Resolution

  1. Verify that there are no database problems in the system, and make sure that the analytics reporting database is functioning.

  2. Verify that analytics processing component is functioning. This means that analyses can run.

  3. Check for any networking issues.

Search Usage Analytics: Store not available

Alert Name: Search Usage Analytics: Store not available

Summary: Background or symptoms:

  1. Usage analytics cannot communicate with the event store. The usage analysis will not be started, and usage analytics data in the analytics reporting database and the search index will be stale.

  2. During the first step of the usage, the system fetches the event data from the event store. This is the raw input to the analysis. It contains the actions for the users in the system. Without this data, the analysis cannot be run.

Cause

One or more of the following might be the cause:

  • Network outage, Event Store process is down, or the event store is returning errors in response to request.

  • The event store can be down. The event store is returning no data because the components registering events are not functioning correctly, or there are networking issues so that the event store cannot be reached.

Resolution

  • Ensure that the event store is up and running.

  • Verify that the event store is functioning correctly.

  • Check for networking errors.

  • Make sure the databases in the system are running.

Search Usage Analytics: Usage analytics APE not available

Alert Name: Search Usage Analytics: Usage analytics APE not available

Summary: Background or symptoms:

  1. Fails to retrieve Search service application, which means that no new analysis can be run, and recommendations cannot be updated.

  2. Fails to retrieve Analysis Engine Service so that no new analysis can be started.

Cause

Inability to connect to the Search service application may be caused by one or more of the following:

  • Network issues.

  • Search service application not created.

  • User permissions mismatch.

Inability to connect to the Analysis Engine Service can be caused by one or more of the following:

  • Unable to connect to Search service application.

  • Unable to connect to the search administration component.

  • Unable to connect to System Manager.

  • Network problems.

  • User rights or WCF errors.

  • Unable to connect to the Analytics processing component.

Resolution

Check the following areas:

  1. Check the following areas:

    • A Search service application does not exist.

    • Network problems.

    • User permissions or WCF errors.

  2. Ensure that the following components are up and running:

    • Search service application.

    • Search administration component.

    • System Manager.

    • Analysis processing component

    • Networking is ok on host.

Usage table exceeded max bytes limit

Alert Name: Usage table exceeded max bytes limit

Summary: This alert is to report that a usage table exceeds its quota. Usage data is stored in various tables. And each table has its quota. Once a table is full, new data cannot be inserted.

Cause

Too much usage data is generated in one day.

Resolution

There are two ways to resolve this issue:

  1. Extend the table quota defined in "configurations" table.

  2. Disable the usage provider to stop generating data.

Usage table exceeded max bytes limit

Alert Name: Usage table exceeded max bytes limit

Summary: This alert is to report that a usage table exceeds its quota. Usage data is stored in various tables. And each table has its quota. Once a table is full, new data cannot be inserted.

Cause

Too much usage data is generated in one day.

Resolution

There are two ways to resolve this issue:

  1. Extend the table quota defined in the "configurations" table.

  2. Disable the usage provider to stop generating data.

Services Host Controller

Alert Name: Services Host Controller

Summary: The host controller service is currently unavailable.

Cause

This may indicate an issue internal to the host controller.

Resolution

If persistent or recurring, check the host controller and restart if it is necessary.

See also

Plan for monitoring in SharePoint 2013
Monitor health in SharePoint 2013
Administer search in SharePoint Server 2013

System Center Monitoring Pack for SharePoint Foundation
System Center Monitoring Pack for SharePoint Server


Visio Services in SharePoint Server 2013 knowledge articles
See also

Published: October 16, 2012

Resolve alerts in Visio Services in SharePoint Server 2013: symptoms, causes, and possible resolutions.

Applies to: SharePoint Server 2013 Enterprise

The articles in this section are knowledge articles for Visio Services in SharePoint Server 2013. Typically, you would see these articles after clicking a link in an alert in the Systems Center Operations Manager console. You can use these articles to help you troubleshoot and resolve problems in Visio Services. Download and install System Center Monitoring Pack for SharePoint Server or System Center Monitoring Pack for SharePoint Foundation.

In this section:

  • Visio Graphics Service failed to initialize the rasterizer

  • Visio Graphics Service failed to initialize the rasterizer

  • Visio Graphics Service cannot find the configuration manager

  • Visio Graphics Service unable to connect to the application server returned by the application proxy

Visio Graphics Service failed to initialize the rasterizer

Alert Name:Visio Graphics Service failed to initialize the rasterizer

Summary: Visio Services in Microsoft SharePoint Server 2013 requires a rasterizer to render a Visio diagram. When the rasterizer is not initialized by Visio Services, VSDX and VSDM diagrams will not render.Symptoms: One or more of the following symptoms might appear:

  • Visio Services might not render diagrams.

  • This event appears in the event log: Event ID: 8076 Description: Rasterizer initialization failed.

Cause

The rasterizer, an internal component of Visio Graphics Services, is not running or was not initialized correctly.

Resolution

Restart Visio Services:

  1. On the Central Administration page, in the System Settings section, from the reading pane, click Manage servers in this farm.

  2. In the Server column, click the name of the failing application server. The Services on Server page opens.

  3. In the Service column, locate Visio Graphics Service. Click Stop, and then click Start.

Visio Graphics Service failed to initialize the rasterizer

Alert Name:Visio Graphics Service failed to initialize the rasterizer

Summary: Visio Services in Microsoft SharePoint Server 2013 requires a rasterizer to render a Visio diagram. When the rasterizer is not initialized by Visio Services, VSDX and VSDM diagrams will not render. This rule is triggered when the Visio Graphics Services failed to initialize the rasterizer.

Cause

Symptoms: One or more of the following symptoms might appear:

  • Visio Services might not render diagrams.

  • This event appears in the event log: Event ID: 8076 Description: Rasterizer initialization failed.

Resolution

Restart Visio Services:

  1. On the Central Administration page, in the System Settings section, from the reading pane, click Manage servers in this farm.

  2. In the Server column, click the name of the failing application server. The Services on Server page opens.

  3. In the Service column, locate Visio Graphics Service. Click Stop, and then click Start.

Visio Graphics Service cannot find the configuration manager

Alert Name:Visio Graphics Service cannot find the configuration manager

Summary: Visio Services in Microsoft SharePoint Server 2013 stores its application settings in the configuration-a12-n database. Access to this database is extremely important for the service to function.

This rule is triggered when the Visio Graphics Service cannot find configuration manager.

Symptoms: One or more of the following symptoms might appear:

  • Visio Services might not render diagrams.

  • This event appears in the event log: Event ID: 8040 Description: Can't find configuration manager.

Cause

One or more of the following might be the cause:

  • The configuration database is inaccessible.

  • The configuration database is responding slowly because of heavy network activity or load on the Microsoft SQL Server.

Resolution

Resolution 1: Verify the status of the SQL Server configuration database:

  1. On the SharePoint Central Administration website, in the System Settings section in the reading pane, click Manage Servers in this farm.

  2. In the Farm Information section, note the Configuration database server and the name and the version of the configuration database.

  3. Start SQL Server Management Studio and connect to the configuration database server.

  4. If the configuration database does not exist, run the SharePoint Products and Technologies Configuration Wizard.

Resolution 2: Verify the SQL Server network connection:

  1. On the Central Administration website, in the System Settings section, from the reading pane, click Manage Servers in this farm.

  2. In the Farm Information section, note the Configuration database server and the name and the version of the configuration database information.

  3. Open a Command Prompt window and type ping to confirm the server connection.

    Failure to contact the server indicates a problem with the network connection or another problem that prevents a response from the server

  4. Log on to the server and troubleshoot the issue.

Visio Graphics Service unable to connect to the application server returned by the application proxy

Alert Name:Visio Graphics Service unable to connect to the application server returned by the application proxy

Summary: The application for Visio Services in Microsoft SharePoint Server 2013 uses a proxy to abstract communication between the front-end service and back-end service. This proxy also provides a load-balancing mechanism between servers. For Visio Services to function, the front-end service must be connected to the application server that is returned by the application proxy. This rule is triggered when the Visio Graphics Service cannot connect to the application server.

Symptoms: One or more of the following symptoms might appear:

  • Visio Services in SharePoint might not render diagrams.

  • This event appears in the event log: Event ID: 8049 Description: Application proxy invalid endpoint for <descriptive text>.

Cause

One or more of the following might be the cause:

  • The specified SharePoint Server application server is inaccessible.

  • The specified application server is responding slowly because of heavy network activity or load on the specific server.

Resolution

Resolution 1: Check the error logs:

  1. Open the Windows Event Viewer.

  2. Search for event ID 8049 in the Windows Application Event log.

  3. In the event description, note the application server that is failing.

Resolution 2: Verify the application server connection:

  1. From the failing application server, open the SharePoint Central Administration website.

  2. If you cannot access the Central Administration site from the failing server, make sure that the network settings are correct and that the server has appropriate permissions to join the SharePoint farm.

Resolution 3: Verify that Visio Services runs on the failing server:

  1. On the Central Administration website, in the System Settings section, from the reading pane, click Manage servers in this farm.

  2. Verify that Visio Services runs on the failing application server.

If there is a service application proxy for the failing service application, create a new service application.

Resolution 4: Restart Visio Services:

  1. On the Central Administration page, in the reading pane, in the System Settings section, click Manage servers in this farm.

  2. In the Server column, click the name of the failing application server. The Services on Server page opens.

  3. In the Service column, locate Visio Graphics Service, click Stop, and then click Start.

Resolution 5: Create a new Visio Services application:

  1. On the Central Administration website, in the Application Management section, from the reading pane, click Manage service applications.

  2. In the Type column, click the name of the Visio Services application that has the failing service instance.

  3. On the ribbon, click Delete.

  4. In the Delete Service Application dialog box, click OK.

  5. Create a new Visio Services application.

See also

Plan for monitoring in SharePoint 2013
Plan for Visio Services in SharePoint Server 2013

System Center Monitoring Pack for SharePoint Foundation
System Center Monitoring Pack for SharePoint Server


Search technical reference for SharePoint Server 2013

Summary: Learn about default crawled file name extensions and parsed file types, default crawled and managed properties, default connectors and linguistics features per language for search in SharePoint 2013.

Applies to: SharePoint Server 2013

The following articles on TechNet provide technical reference information for search in SharePoint 2013.

TechNet articles

The following articles about default crawled file extensions and parsed file types, default crawled and managed properties, default connectors, linguistics features per language for search in SharePoint 2013 and query variables are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

Building blocks | Content | Description
 | Default crawled file name extensions and parsed file types in SharePoint Server 2013 | Learn which file name extensions are crawled by default and which file formats are parsed by default.
 | Linguistic search features in SharePoint Server 2013 | Learn which linguistic features SharePoint 2013 uses for which languages during search.
 | Overview of crawled and managed properties in SharePoint Server 2013 | Get an overview of the default mapping between crawled and managed properties.
 | Default connectors in SharePoint Server 2013 | Learn which connectors are installed by default in SharePoint 2013.
 | Query variables in SharePoint Server 2013 | Learn about the query variables that can be used when you configure a query.
 | Result types and display templates that are used to display search results in SharePoint Server 2013 | Result types and display templates help users quickly distinguish between different types of search results . Learn about the default result types and display templates, and how they are connected.


Default crawled file name extensions and parsed file types in SharePoint Server 2013

Updated: June 18, 2013

Summary: Learn which file name extensions SharePoint 2013 crawls by default and which file types it parses by default.

Applies to: SharePoint Server 2013

The crawl component can only crawl a file if the list on the Manage File Types page includes the file name extension. The content processing component can only parse the contents of a crawled file:

  • When it has a format handler that can parse the file format.

  • When it is enabled to use the format handler to parse files that have the file format and file name extension.

By default, SharePoint 2013 satisfies these requirements for many file types.

Default crawled file name extensions and parsed file formats

The following table shows all the file formats that SharePoint 2013 has built-in format handlers for. The table shows one or several format ID and file name extensions for each file format. By default SharePoint 2013 is enabled to parse files that have these file formats and file name extensions. For each file name extension the table also indicates whether the Manage File Types page by default includes the file name extension.

File format | Format ID | File name extension | File name extension listed on the Manage File Types page by default
Email message | eml | .eml | Yes
Email message | nws | .nws | Yes
HTML | html | .ascx | Yes
HTML | html | .asp | Yes
HTML | html | .aspx | Yes
HTML | html | .css | No
HTML | html | .hta | No
HTML | html | .htm | Yes
HTML | html | .html | Yes
HTML | html | .htw | No
HTML | html | .htx | No
HTML | html | .jhtml | No
HTML | html | .stm | No
MHTML document | mhtml | .mht | Yes
MHTML document | mhtml | .mhtml | Yes
Microsoft Excel | xlb | .xlb | No
Microsoft Excel | xlc | .xlc | No
Microsoft Excel | xls | .xls | Yes
Microsoft Excel | xlsb | .xlsb | Yes
Microsoft Excel | xlsm | .xlsm | Yes
Microsoft Excel | xlsx | .xlsx | Yes
Microsoft Excel | xlt | .xlt | No
Microsoft OneNote | one | .one | No
Microsoft PowerPoint | pot | .pot | No
Microsoft PowerPoint | ppa | .ppa | No
Microsoft PowerPoint | pps | .pps | No
Microsoft PowerPoint | ppt | .ppt | Yes
Microsoft PowerPoint | pptm | .pptm | Yes
Microsoft PowerPoint | pptx | .pptx | Yes
Microsoft Publisher | pub | .pub | Yes
Microsoft Word | doc | .doc | Yes
Microsoft Word | docm | .docm | Yes
Microsoft Word | docx | .docx | Yes
Microsoft Word | dot | .dot | Yes
Microsoft Word | dotx | .dotx | Yes
Microsoft XPS | xps | .xps | No
Open Document Chart | odc | .odc | Yes
Open Document Presentation | odp | .odp | Yes
Open Document Spreadsheet | ods | .ods | Yes
Open Document Text | odt | .odt | Yes
Outlook item | msg | .msg | Yes
Portable Document Format | pdf | .pdf | Yes
Rich Text Format | rtf | .rtf | No
Text | txt | .asm | Yes
Text | txt | .bat | No
Text | txt | .c | No
Text | txt | .cmd | No
Text | txt | .cpp | No
Text | txt | .csv | Yes
Text | txt | .cxx | Yes
Text | txt | .def | Yes
Text | txt | .h | No
Text | txt | .hpp | No
Text | txt | .lnk | No
Text | txt | .mpx | No
Text | txt | .php | No
Text | txt | .trf | No
Text | txt | .txt | Yes
Text | txt | .url | No
TIFF | tiff | .tif | No
TIFF | tiff | .tiff | No
Visio | vdw | .vdw | Yes
Visio | vdx | .vdx | Yes
Visio | vsd | .vsd | Yes
Visio | vsdm | .vsdm | Yes
Visio | vsdx | .vsdx | Yes
Visio | vss | .vss | Yes
Visio | vssm | .vssm | Yes
Visio | vssx | .vssx | Yes
Visio | vst | .vst | Yes
Visio | vstm | .vstm | Yes
Visio | vstx | .vstx | Yes
Visio | vsx | .vsx | Yes
Visio | vtx | .vtx | Yes
XML | xml | .jsp | Yes
XML | xml | .mspx | No
XML | xml | .rss | No
XML | xml | .xml | Yes
ZIP | zip | .zip | Yes

Change History

Date | Description
June 18, 2013 | Clarified requirements for parsing file formats.
July 16, 2012 | Initial publication


Linguistic search features in SharePoint Server 2013

Updated: August 20, 2013

Summary: Learn which linguistic features search by default uses, and for which languages.

Applies to: SharePoint Server 2013

SharePoint products use several linguistic features to help improve search relevance.

Linguistic search features

The following table shows the languages that SharePoint 2013 by default supports for each linguistic feature search uses. The support of these languages doesn't depend on any installed language packs.

Note:

For dynamic spelling correction to work, you should have at least several thousand medium-sized documents.

People search uses fuzzy name matching. Fuzzy name matching includes phonetic matching of names, and can't be disabled.

Language | Code | Document language detection | Word breaking | Stemming | Spelling variants | Spelling correction, static | Spelling correction, dynamic | Decompounding | Fuzzy name matching | Company name extraction
Afrikaans | af | Yes | No | No | No | No | Yes | Not applicable | No | No
Albanian | sq | Yes | No | No | No | No | Yes | Not applicable | No | No
Arabic | ar | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | Yes
Armenian | hy | Yes | No | No | No | No | Yes | Not applicable | No | No
Azerbaijani | az | Yes | No | No | No | No | Yes | Not applicable | No | No
Bangla | bn | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Basque (Basque) | eu | Yes | No | No | No | Yes | Yes | Not applicable | No | No
Belarusian | be | Yes | No | No | No | No | Yes | Not applicable | No | No
Bosnian | bs | Yes | No | No | No | No | Yes | Not applicable | No | No
Breton | br | Yes | No | No | No | No | Yes | Not applicable | No | No
Bulgarian | bg | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Catalan | ca | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Chinese Simplified | zh-cn | Yes | Yes | No | No | No | No | Not applicable | No | No
Chinese Traditional | zh-tw | Yes | Yes | No | No | No | No | Not applicable | No | No
Croatian | hr | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Czech | cs | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Danish | da | Yes | Yes | Yes | Yes | Yes | Yes | Yes | No | No
Dutch | nl | Yes | Yes | Yes | Yes | Yes | Yes | Yes | Yes | Yes
English | en | Yes | Yes | Yes | No | Yes | Yes | Not applicable | Yes | Yes
Estonian | et | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Faeroese | fo | Yes | No | No | No | No | Yes | Not applicable | No | No
Farsi | fa | Yes | No | No | No | No | Yes | Not applicable | No | No
Filipino | tl | Yes | No | No | No | No | Yes | Not applicable | No | No
Finnish | fi | Yes | Yes | Yes | No | No | Yes | Yes | No | No
French | fr | Yes | Yes | Yes | Yes | Yes | Yes | Not applicable | Yes | Yes
Frisian | fy | Yes | No | No | No | No | Yes | Not applicable | No | No
Galician | gl | Yes | No | No | No | Yes | Yes | Not applicable | No | No
Georgian | ka | Yes | No | No | No | No | Yes | Not applicable | No | No
German | de | Yes | Yes | Yes | Yes | Yes | Yes | Yes | Yes | Yes
Greek | el | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Gujarati | gu | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Hausa | ha | Yes | No | No | No | No | Yes | Not applicable | No | No
Hebrew | he | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Hindi | hi | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Hungarian | hu | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Icelandic | is | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Indonesian | id | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Irish Gaelic | ga | Yes | No | No | No | No | Yes | Not applicable | No | No
Italian | it | Yes | Yes | Yes | No | Yes | Yes | Not applicable | Yes | Yes
Japanese | ja | Yes | Yes | No | No | No | No | Not applicable | Yes | Yes
Kannada | kn | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Kazakh | kk | Yes | No | Yes | No | Yes | Yes | Not applicable | No | No
Kirghiz | ky | Yes | No | No | No | No | Yes | Not applicable | No | No
Korean | ko | Yes | Yes | Yes | No | No | No | Not applicable | No | No
Kurdish | ku | Yes | No | No | No | No | Yes | Not applicable | No | No
Latin | la | Yes | No | No | No | No | Yes | Not applicable | No | No
Latvian | lv | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Lithuanian | lt | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Luxembourgish | lb | Yes | No | No | No | No | Yes | Not applicable | No | No
Macedonian | mk | Yes | No | No | No | No | Yes | Not applicable | No | No
Malay | ms | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Malayalam | ml | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Maltese | mt | Yes | No | No | No | No | Yes | Not applicable | No | No
Maori | mi | Yes | No | No | No | No | Yes | Not applicable | No | No
Marathi | mr | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Mongolian | mn | Yes | No | No | No | No | Yes | Not applicable | No | No
Norwegian Bokmål | nb | Yes | Yes | Yes | No | Yes | Yes | Yes | No | Yes
Norwegian NyNorsk | nn | Yes | No | No | No | Yes | Yes | Not applicable | No | No
Pashto | ps | Yes | No | No | No | No | Yes | Not applicable | No | No
Polish | pl | Yes | Yes | Yes | No | Yes | Yes | Not applicable | Yes | No
Portuguese | pt | Yes | Yes | Yes | Yes | Yes | Yes | Not applicable | Yes | Yes
Punjabi | pa | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Romanian | ro | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Romansh | rm | Yes | No | No | No | No | Yes | Not applicable | No | No
Russian | ru | Yes | Yes | Yes | No | Yes | Yes | Not applicable | Yes | Yes
Sami Nothern | se | Yes | No | No | No | No | Yes | Not applicable | No | No
Serbian | sr | Yes | Yes | No | No | Yes | Yes | Not applicable | No | No
Slovak | sk | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Slovenian | sl | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Sorbian | wen | Yes | No | No | No | No | Yes | Not applicable | No | No
Spanish | es | Yes | Yes | Yes | Yes | Yes | Yes | Not applicable | Yes | Yes
Swahili | sw | Yes | No | No | No | No | Yes | Not applicable | No | No
Swedish | sv | Yes | Yes | Yes | No | Yes | Yes | Yes | No | No
Tamil | ta | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Telugu | te | Yes | Yes | No | No | No | Yes | Not applicable | No | No
Thai | th | Yes | Yes | No | No | No | Yes | Not applicable | No | No
Turkish | tr | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Ukrainian | uk | Yes | Yes | Yes | No | Yes | Yes | Not applicable | No | No
Urdu | ur | Yes | Yes | Yes | No | No | Yes | Not applicable | No | No
Uzbek | uz | Yes | No | No | No | No | Yes | Not applicable | No | No
Vietnamese | vi | Yes | Yes | No | No | No | Yes | Not applicable | No | No
Welsh | cy | Yes | No | No | No | No | Yes | Not applicable | No | No
Yiddish | yi | Yes | No | No | No | No | Yes | Not applicable | No | No
Zulu | zu | Yes | No | No | No | No | Yes | Not applicable | No | No

Change History

Date | Description
August 20, 2013 | Corrected a linguistic feature name, from "people search" to" fuzzy name matching." Added more information about fuzzy name matching.
July 16, 2012 | Initial publication


Overview of crawled and managed properties in SharePoint Server 2013

Summary: Learn about the default managed properties, their settings and the default mapping between crawled and managed properties.

Applies to: SharePoint Server 2013

A crawled property is content and metadata that is extracted from an item, such as a document or a URL, during a crawl. A crawled property can be an author, title, or subject. To include the content and metadata of crawled properties in the search index, you map crawled properties to managed properties. Managed properties can have a large number of settings, or attributes. These attributes determine how the contents are shown in search results. The search schema contains the attributes on managed properties and the mapping between crawled properties and managed properties. For more information, see Overview of the search schema in SharePoint Server 2013 and Manage the search schema in SharePoint Server 2013.

Managed properties overview

The following table lists the default managed properties and their attributes. For each managed property that by default is mapped to one or several crawled properties, these crawled properties are listed in the Mapped Crawled Properties column.

Property name | Type | Multi-valued | Queryable | Searchable | Retrievable | Refinable | Sortable | Mapped crawled properties | Aliases
AboutMe | Text | No | Yes | No | Yes | No | No | People:AboutMe, ows_Notes |
Account | Text | No | Yes | No | Yes | No | No | ows_Name |
AccountName | Text | No | Yes | Yes | Yes | No | No | People:AccountName |
acronym | Text | No | No | No | Yes | No | No |  |
acronymaggre | Text | No | Yes | Yes | Yes | No | No |  |
acronymexpansion | Text | No | No | No | Yes | No | No |  |
acronymexpansionaggre | Text | No | No | No | Yes | No | No |  |
AnchorText | Text | No | No | Yes | No | No | No | Basic:28 |
AssignedTo | Text | No | Yes | No | Yes | No | No | ows_AssignedTo, ows_Assigned_x0020_To |
AttachmentDescription | Text | No | No | No | Yes | No | No | ows_MediaLinkDescription |
AttachmentType | Integer | No | Yes | No | Yes | Yes | No | ows_MediaLinkType |
AttachmentURI | Text | No | No | No | Yes | No | No | ows_MediaLinkURI |
Author | Text | Yes | Yes | Yes | Yes | No | Yes | Author, MailFrom, Mail:6 | DocAuthor, urn:schemas-microsoft-com:office:office#Author
BaseOfficeLocation | Text | No | Yes | No | Yes | Yes | No | People:SPS-Location |
BasicScope | Binary Data | No | No | No | Yes | No | No |  |
body | Text | No | No | Yes | No | No | No |  |
CategoryNavigationUrl | Text | No | Yes | No | No | No | No | Basic:CategoryUrlNavigation |
CCAMetadata | Text | No | No | No | Yes | No | No |  |
charset | Text | No | Yes | No | Yes | No | No |  |
clickdistance | Integer | No | No | No | No | No | Yes |  |
CollapsingStatus | Integer | No | No | No | Yes | No | No |  |
Colleagues | Text | Yes | Yes | No | No | No | No | People:Colleagues |
CombinedName | Text | Yes | No | Yes | Yes | No | No | People:CombinedName |
CombinedUserProfileNames | Text | No | Yes | No | No | Yes | No |  |
companies | Text | Yes | Yes | No | Yes | Yes | Yes |  |
contentclass | Text | No | Yes | No | Yes | Yes | No | DAV:contentclass, DAV:contentclass, DAV:contentclass | DAV:contentclass
ContentModifiedTime | Date and Time | No | No | No | Yes | No | No |  |
Contents | Text | No | No | Yes | No | No | No | ows_VideoSetDescription, ows_DocumentSetDescription, Basic:19 |
ContentsHidden | Text | Yes | Yes | Yes | No | No | No | People:SPS-Location, People:Office, People:SPS-PastProjects |
ContentSource | Text | No | Yes | No | Yes | No | No |  |
ContentType | Text | No | Yes | No | Yes | Yes | No | Basic:5, ows_ContentType | MimeType, DAV:getcontenttype
ContentTypeId | Text | No | Yes | No | Yes | Yes | No | ows_ContentTypeId |
Created | Date and Time | No | Yes | No | Yes | Yes | Yes | Office:12, Basic:15 | DocCreatedTm, urn:schemas-microsoft-com:office:office#Created, DAV:creationdate
CreatedBy | Text | No | Yes | No | Yes | No | No | ows_Created_x0020_By |
Date00 | Date and Time | No | Yes | No | No | No | No |  |
Date01 | Date and Time | No | Yes | No | No | No | No |  |
Date02 | Date and Time | No | Yes | No | No | No | No |  |
Date03 | Date and Time | No | Yes | No | No | No | No |  |
Date04 | Date and Time | No | Yes | No | No | No | No |  |
Date05 | Date and Time | No | Yes | No | No | No | No |  |
Date06 | Date and Time | No | Yes | No | No | No | No |  |
Date07 | Date and Time | No | Yes | No | No | No | No |  |
Date08 | Date and Time | No | Yes | No | No | No | No |  |
Date09 | Date and Time | No | Yes | No | No | No | No |  |
Decimal00 | Decimal | No | Yes | No | No | No | No |  |
Decimal01 | Decimal | No | Yes | No | No | No | No |  |
Decimal02 | Decimal | No | Yes | No | No | No | No |  |
Decimal03 | Decimal | No | Yes | No | No | No | No |  |
Decimal04 | Decimal | No | Yes | No | No | No | No |  |
Decimal05 | Decimal | No | Yes | No | No | No | No |  |
Decimal06 | Decimal | No | Yes | No | No | No | No |  |
Decimal07 | Decimal | No | Yes | No | No | No | No |  |
Decimal08 | Decimal | No | Yes | No | No | No | No |  |
Decimal09 | Decimal | No | Yes | No | No | No | No |  |
deeplinks | Text | No | Yes | No | Yes | No | No |  |
def | Text | No | No | No | Yes | No | No |  |
defaggre | Text | No | Yes | Yes | Yes | No | No |  |
DefaultEncodingURL | Text | No | No | No | Yes | No | No | ows_VideoSetDefaultEncoding, ows_EncodedAbsUrl |
definitioncontent | Text | No | No | No | Yes | No | No |  |
definitioncontentaggre | Text | No | No | No | Yes | No | No |  |
Department | Text | No | Yes | No | Yes | Yes | No | People:Department, ows_Department | urn:schemas-microsoft-com:sharepoint:portal:profile:Department
Description | Text | No | Yes | No | Yes | No | No | Description, Office:6, DESCRIPTION | urn:schemas.microsoft.com:fulltextqueryinfo:description
DetectedLanguage | Text | No | Yes | No | Yes | No | No | ows_q_TEXT_TranslationLanguage |
DetectedLanguageRanking | Integer | No | No | No | No | No | Yes |  |
DiscoveredTime | Date and Time | No | No | No | Yes | No | No |  |
DisplayAuthor | Text | Yes | Yes | No | Yes | Yes | No |  |
DisplayDate | Date and Time | No | Yes | No | Yes | No | No | ows_ImageCreateDate, ows_Image_x0020_CreateDate | DatePictureTaken, ImageCreateDate
DMSDocAccessRight | Text | No | Yes | No | Yes | No | Yes | ows_DMSDocAccessRight |
DMSDocAuthor | Text | No | Yes | Yes | Yes | Yes | Yes | ows_DMSDocAuthor |
DMSDocTitle | Text | No | Yes | Yes | Yes | No | Yes | ows_DMSDocTitle |
DMSLeaseTerm | Text | No | No | Yes | Yes | No | No | ows_DMSLeaseTerm |
docacl | Text | No | Yes | No | No | No | No |  |
docaclmeta | Text | No | No | No | Yes | No | No |  |
DocComments | Text | No | Yes | No | No | No | No | Description, Office:6 |
DocId | Text | No | Yes | No | Yes | No | No | ows__dlc_DocId |
DocKeywords | Text | No | Yes | No | No | No | No | Office:5 | urn:schemas-microsoft-com:office:office#Keywords
docrank | Integer | No | No | No | Yes | No | Yes |  |
DocSignature | Text | No | Yes | No | No | No | No | Basic:6 | urn:schemas.microsoft.com:fulltextqueryinfo:docsignature
DocSubject | Text | No | Yes | No | Yes | No | No | Subject, Office:3 |
DocumentSignature | Integer | Yes | Yes | No | Yes | No | Yes |  |
DocumentSummary | Binary Data | No | No | No | Yes | No | No |  |
DocumentSummarySize | Integer | No | No | No | Yes | No | No |  |
docvector | Text | No | No | No | Yes | No | No |  |
domain | Text | No | Yes | No | Yes | No | No |  |
Double00 | Double precision float | No | Yes | No | No | No | No |  |
Double01 | Double precision float | No | Yes | No | No | No | No |  |
Double02 | Double precision float | No | Yes | No | No | No | No |  |
Double03 | Double precision float | No | Yes | No | No | No | No |  |
Double04 | Double precision float | No | Yes | No | No | No | No |  |
Double05 | Double precision float | No | Yes | No | No | No | No |  |
Double06 | Double precision float | No | Yes | No | No | No | No |  |
Double07 | Double precision float | No | Yes | No | No | No | No |  |
Double08 | Double precision float | No | Yes | No | No | No | No |  |
Double09 | Double precision float | No | Yes | No | No | No | No |  |
DuplicateHash | Integer | Yes | Yes | No | Yes | No | No |  |
Duplicates | Text | No | No | No | Yes | No | No |  |
EduAssignmentCategory | Text | No | Yes | No | Yes | No | No | ows_EduAssignmentCategory |
EduAssignmentFormat | Text | No | Yes | No | Yes | No | No | ows_EduAssignmentFormat |
EduEntityId | Text | No | No | No | Yes | No | No | ows_EduEntityId |
EduMaximumScore | Text | No | Yes | No | Yes | No | No | ows_EduMaximumScore |
EndDate | Date and Time | No | Yes | No | Yes | No | No | ows_End_x0020_Date |
EventRate | Double precision float | No | No | No | No | No | Yes |  |
ExcludeFromSummary | Text | No | No | No | Yes | No | No | EmbeddedContent, LINK.OFFICECHILD, Description |
ExpirationTime | Date and Time | No | Yes | No | No | No | Yes | ows_Announcement_x0020_Expires, ows_Expires |
ExternalMediaURL | Text | No | No | No | Yes | No | No | ows_VideoSetExternalLink |
ExtractedAuthor | Text | No | Yes | No | Yes | No | No |  |
ExtractedDate | Date and Time | No | Yes | No | Yes | No | No |  |
fcocount | Integer | No | No | No | Yes | No | No |  |
FileExtension | Text | No | Yes | No | Yes | Yes | Yes | FileExtension, ows_File_x0020_Type, ows_FileType |
Filename | Text | No | Yes | Yes | Yes | No | Yes | Basic:10 | DAV:displayname
FileType | Text | No | Yes | No | Yes | Yes | No | FileType |
FirstLevelColleagues | Text | Yes | Yes | No | Yes | No | No |  |
FirstLevelMutualFollowings | Text | Yes | Yes | No | Yes | No | No |  |
FirstName | Text | Yes | Yes | No | Yes | No | Yes | People:FirstName, People:SPS-PhoneticFirstName |
FollowAllAnchor | Text | No | Yes | No | No | No | No | Basic:31 |
format | Text | No | Yes | No | Yes | Yes | No |  |
FullPostBody | Text | No | No | No | Yes | No | No | ows_SearchContent |
FullPostTitle | Text | No | No | No | Yes | No | No | ows_SearchTitle |
GeneratedTitle | Text | No | Yes | Yes | Yes | No | No |  |
Genre | Text | No | Yes | No | Yes | No | No |  |
HierarchyUrl | Text | No | Yes | No | Yes | No | No | People:ProfileHierarchyViewUrl |
HitHighlightedProperties | Text | No | Yes | No | Yes | No | No |  |
HitHighlightedSummary | Text | No | Yes | No | Yes | No | No |  |
HostingPartition | Text | No | Yes | No | No | Yes | No |  |
hwboost | Integer | No | Yes | No | No | No | Yes |  |
ImageDateCreated | Date and Time | No | Yes | No | Yes | No | No | ows_ImageCreateDate, ows_Image_x0020_CreateDate |
importance | Integer | No | Yes | No | Yes | No | Yes |  |
Int00 | Integer | No | Yes | No | No | No | No |  |
Int01 | Integer | No | Yes | No | No | No | No |  |
Int02 | Integer | No | Yes | No | No | No | No |  |
Int03 | Integer | No | Yes | No | No | No | No |  |
Int04 | Integer | No | Yes | No | No | No | No |  |
Int05 | Integer | No | Yes | No | No | No | No |  |
Int06 | Integer | No | Yes | No | No | No | No |  |
Int07 | Integer | No | Yes | No | No | No | No |  |
Int08 | Integer | No | Yes | No | No | No | No |  |
Int09 | Integer | No | Yes | No | No | No | No |  |
Int10 | Integer | No | Yes | No | No | No | No |  |
Int11 | Integer | No | Yes | No | No | No | No |  |
Int12 | Integer | No | Yes | No | No | No | No |  |
Int13 | Integer | No | Yes | No | No | No | No |  |
Int14 | Integer | No | Yes | No | No | No | No |  |
Int15 | Integer | No | Yes | No | No | No | No |  |
Int16 | Integer | No | Yes | No | No | No | No |  |
Int17 | Integer | No | Yes | No | No | No | No |  |
Int18 | Integer | No | Yes | No | No | No | No |  |
Int19 | Integer | No | Yes | No | No | No | No |  |
Int20 | Integer | No | Yes | No | No | No | No |  |
Int21 | Integer | No | Yes | No | No | No | No |  |
Int22 | Integer | No | Yes | No | No | No | No |  |
Int23 | Integer | No | Yes | No | No | No | No |  |
Int24 | Integer | No | Yes | No | No | No | No |  |
Int25 | Integer | No | Yes | No | No | No | No |  |
Int26 | Integer | No | Yes | No | No | No | No |  |
Int27 | Integer | No | Yes | No | No | No | No |  |
Int28 | Integer | No | Yes | No | No | No | No |  |
Int29 | Integer | No | Yes | No | No | No | No |  |
Int30 | Integer | No | Yes | No | No | No | No |  |
Int31 | Integer | No | Yes | No | No | No | No |  |
Int32 | Integer | No | Yes | No | No | No | No |  |
Int33 | Integer | No | Yes | No | No | No | No |  |
Int34 | Integer | No | Yes | No | No | No | No |  |
Int35 | Integer | No | Yes | No | No | No | No |  |
Int36 | Integer | No | Yes | No | No | No | No |  |
Int37 | Integer | No | Yes | No | No | No | No |  |
Int38 | Integer | No | Yes | No | No | No | No |  |
Int39 | Integer | No | Yes | No | No | No | No |  |
Int40 | Integer | No | Yes | No | No | No | No |  |
Int41 | Integer | No | Yes | No | No | No | No |  |
Int42 | Integer | No | Yes | No | No | No | No |  |
Int43 | Integer | No | Yes | No | No | No | No |  |
Int44 | Integer | No | Yes | No | No | No | No |  |
Int45 | Integer | No | Yes | No | No | No | No |  |
Int46 | Integer | No | Yes | No | No | No | No |  |
Int47 | Integer | No | Yes | No | No | No | No |  |
Int48 | Integer | No | Yes | No | No | No | No |  |
Int49 | Integer | No | Yes | No | No | No | No |  |
Interests | Text | Yes | Yes | No | Yes | No | No | People:SPS-Interests |
InternalFileType | Integer | No | No | No | Yes | No | Yes |  |
IsContainer | Yes/No | No | Yes | No | Yes | No | No | Basic:7 |
IsData | Yes/No | No | Yes | Yes | Yes | No | No | ows_IsData, IsData |
IsDefaultView | Yes/No | No | No | No | Yes | No | No | ows_IsDefaultView |
IsDocument | Yes/No | No | Yes | No | Yes | No | No | SharePoint:isdocument, SharePoint:isdocument, Basic:22 | urn:schemas.microsoft.com:sharepoint:portal:isdocument
IsEmptyList | Yes/No | No | No | No | Yes | No | No | ows_IsEmptyList |
IsListItem | Yes/No | No | No | No | Yes | No | No | ows_isItem |
IsMyDocuments | Yes/No | No | Yes | No | Yes | No | No | ows_IsMyDocuments |
IsPublishingCatalog | Text | No | Yes | No | Yes | No | No | IsPublishingCatalog |
IsReport | Yes/No | No | Yes | Yes | Yes | No | No | ows_IsReport, IsReport |
ItemCategoryText | Text | No | No | Yes | No | No | No | ProductCatalogItemCategory |
JobTitle | Text | No | Yes | Yes | Yes | Yes | No | People:SPS-JobTitle, People:Title, ows_JobTitle | urn:schemas-microsoft-com:sharepoint:portal:profile:Title
Keywords | Text | No | Yes | No | Yes | No | No | ows_Keywords |
language | Text | No | Yes | No | Yes | No | No | ows_ProductCatalogLanguageTag |
languages | Text | Yes | Yes | No | Yes | Yes | No |  |
LastAnalyticsUpdateTime | Integer | No | No | No | Yes | No | No |  |
LastModifiedTime | Date and Time | No | Yes | No | Yes | Yes | Yes | LastSavedDateTime, Basic:14, Basic:16 | Write, FileWrite, DAV:getlastmodified
LastName | Text | No | Yes | No | Yes | No | No | People:LastName, People:SPS-PhoneticLastName |
LevelsToTop | Integer | No | No | No | Yes | No | Yes | People:LevelsToTop |
LikesCount | Integer | No | No | No | Yes | No | No | ows_LikesCount |
ListID | Text | No | Yes | No | Yes | No | No | ows_ListID |
ListItemID | Text | No | Yes | No | Yes | No | No | ows_ListItemID |
ListUrl | Text | No | Yes | No | Yes | No | No | ListUrl |
Location | Text | No | Yes | No | Yes | Yes | No | ows_Location |
ManagedProperties | Text | Yes | Yes | No | No | Yes | No |  |
MediaDuration | Integer | No | Yes | No | Yes | Yes | No | ows_MediaLengthInSeconds |
Memberships | Text | Yes | Yes | Yes | Yes | No | No | People:QuickLinks |
MetadataAuthor | Text | No | Yes | No | Yes | No | No | Author, MailFrom, Mail:6 |
MicroBlogType | Integer | No | Yes | No | Yes | No | No | ows_MicroBlogType |
MobilePhone | Text | No | Yes | No | Yes | No | No | People:CellPhone, ows_CellPhone, ows_Cell_x0020_Phone |
ModifiedBy | Text | No | Yes | No | Yes | No | Yes | ows_ModifiedBy, ows_Modified_x0020_By, LastModifiedBy |
NLCodePage | Integer | No | Yes | No | No | No | No | Web:4 |
Notes | Text | No | Yes | No | Yes | No | No | ows_Note, ows_Notes |
NumItemsInCollection | Integer | No | No | No | Yes | No | No |  |
OfficeNumber | Text | No | Yes | No | Yes | No | No | People:Office |
OrgNames | Text | Yes | Yes | No | Yes | No | No | People:OrganizationNames, ows_Company | Company
OrgParentNames | Text | Yes | Yes | No | Yes | No | No | People:OrganizationParentNames |
OrgParentUrls | Text | Yes | Yes | No | Yes | No | No | People:OrganizationParentURLs |
OrgUrls | Text | Yes | Yes | No | Yes | No | No | People:OrganizationURLs |
OriginalPath | Text | No | No | No | Yes | No | No | Basic:11, Basic:9, Web:2 |
OWS_ItemURL | Text | No | No | No | Yes | No | No |  |
OWS_URL | Text | No | Yes | No | No | No | No | ows_URL |
owsmetadatafacetinfo | Text | No | Yes | No | Yes | Yes | No | ows_MetadataFacetInfo |
owstaxidmetadataalltagsinfo | Text | Yes | Yes | No | Yes | Yes | No | ows_taxId_MetadataAllTagsInfo |
owstaxIdProductCatalogItemCategory | Text | Yes | Yes | Yes | Yes | Yes | No | ows_taxId_ProductCatalogItemCategory |
ParentLink | Text | No | Yes | No | Yes | No | No | ows_ParentURL |
PastProjects | Text | Yes | Yes | No | Yes | No | No | People:SPS-PastProjects |
Path | Text | No | Yes | No | Yes | No | No | Basic:11, Basic:9, Web:2 | DAV:href, VPath, DocAddress, ...
People | Text | Yes | Yes | No | Yes | Yes | No | ows_People, Author, MailFrom |
PeopleInMedia | Text | Yes | Yes | No | Yes | Yes | No | ows_PeopleInMedia |
PeopleKeywords | Text | Yes | Yes | No | Yes | Yes | No | People:SPS-Responsibility, People:SPS-Skills, People:SPS-Interests |
PhoneNumber | Text | Yes | Yes | No | Yes | No | No |  |
PictureHeight | Integer | No | Yes | No | Yes | No | No | ows_ImageHeight, ows_VideoHeightInPixels | ImageHeight, urn:schemas-microsoft-com:office:office#ows_ImageHeight
PictureThumbnailURL | Text | No | Yes | No | Yes | No | No | ows_AlternateThumbnailUrl, ows_EncodedAbsThumbnailUrl, ows_DMSCoverImage |
PictureURL | Text | No | Yes | No | Yes | No | No | ows_PictureURL, People:PictureURL | urn:schemas.microsoft.com:fulltextqueryinfo:PictureURL
PictureWidth | Integer | No | Yes | No | Yes | No | No | ows_ImageWidth, ows_VideoWidthInPixels | ImageWidth, urn:schemas-microsoft-com:office:office#ows_ImageWidth
PopularSocialTags | Text | Yes | No | No | Yes | No | No |  |
PostAuthor | Text | No | Yes | No | Yes | Yes | No | ows_PostAuthor |
PreferredName | Text | No | Yes | Yes | Yes | No | No | People:PreferredName | urn:schemas-microsoft-com:sharepoint:portal:profile:PreferredName
Priority | Text | No | Yes | No | Yes | No | No | ows_Priority |
PrivateColleagues | Text | Yes | Yes | No | No | No | No | People:ColleaguesNonPublic |
processingtime | Date and Time | No | Yes | No | Yes | No | Yes |  |
ProductCatalogGroupNumberOWSTEXT | Text | No | Yes | No | Yes | No | Yes | ows_ProductCatalogGroupNumber |
ProfileExpertise | Text | No | Yes | No | No | No | No | People:SPS-Responsibility, People:SPS-PastProjects, People:SPS-Skills |
ProfileName | Text | No | Yes | No | No | No | No | People:PreferredName, People:FirstName, People:LastName |
Pronunciations | Text | No | Yes | Yes | Yes | No | No | People:FirstName, People:LastName, People:PreferredName |
PublishingCatalogSettings | Text | No | No | No | Yes | No | No | PublishingCatalogSettings |
PublishingImage | Text | No | No | No | Yes | No | No |  |
Purpose | Text | No | Yes | No | No | No | No | ows_Purpose |
QueryTerms | Text | Yes | No | No | Yes | No | No |  |
Rank | Integer | No | No | No | Yes | No | No | urn:schemas.microsoft.com:fulltextqueryinfo:rank |
RankDetail | Text | No | Yes | No | Yes | No | No |  |
RankingWeightHigh | Text | Yes | Yes | Yes | No | No | No | People:OrganizationNames, People:Department |
RankingWeightLow | Text | Yes | Yes | Yes | No | No | No | People:SPS-Skills, People:SPS-Interests |
RankingWeightName | Text | Yes | Yes | Yes | No | No | No | People:CombinedName, People:UserName, People:WorkEmail |
Rating | Double precision float | No | No | No | Yes | No | No |  |
recommendedfor | Text | Yes | Yes | No | No | Yes | Yes |  |
RecsClickedLifeTime | Integer | No | No | No | Yes | No | Yes |  |
RecsClickedRecent | Integer | No | No | No | Yes | No | Yes |  |
RefinableDate00 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate01 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate02 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate03 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate04 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate05 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate06 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate07 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate08 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate09 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate10 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate11 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate12 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate13 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate14 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate15 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate16 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate17 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate18 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDate19 | Date and Time | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal00 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal01 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal02 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal03 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal04 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal05 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal06 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal07 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal08 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDecimal09 | Decimal | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble00 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble01 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble02 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble03 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble04 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble05 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble06 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble07 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble08 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableDouble09 | Double precision float | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt00 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt01 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt02 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt03 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt04 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt05 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt06 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt07 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt08 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt09 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt10 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt11 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt12 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt13 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt14 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt15 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt16 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt17 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt18 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt19 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt20 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt21 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt22 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt23 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt24 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt25 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt26 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt27 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt28 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt29 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt30 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt31 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt32 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt33 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt34 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt35 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt36 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt37 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt38 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt39 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt40 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt41 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt42 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt43 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt44 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt45 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt46 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt47 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt48 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableInt49 | Integer | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString00 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString01 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString02 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString03 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString04 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString05 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString06 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString07 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString08 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString09 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString10 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString11 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString12 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString13 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString14 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString15 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString16 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString17 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString18 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString19 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString20 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString21 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString22 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString23 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString24 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString25 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString26 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString27 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString28 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString29 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString30 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString31 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString32 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString33 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString34 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString35 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString36 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString37 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString38 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString39 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString40 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString41 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString42 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString43 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString44 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString45 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString46 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString47 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString48 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString49 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString50 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString51 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString52 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString53 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString54 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString55 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString56 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString57 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString58 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString59 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString60 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString61 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString62 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString63 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString64 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString65 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString66 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString67 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString68 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString69 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString70 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString71 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString72 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString73 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString74 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString75 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString76 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString77 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString78 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString79 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString80 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString81 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString82 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString83 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString84 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString85 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString86 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString87 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString88 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString89 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString90 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString91 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString92 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString93 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString94 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString95 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString96 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString97 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString98 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
RefinableString99 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
ReplyCount | Integer | No | No | No | Yes | No | No | ows_ReplyCount |
Responsibilities | Text | Yes | Yes | Yes | Yes | Yes | No | People:SPS-Responsibility | Responsibility
RobotsNoIndex | Yes/No | No | Yes | No | No | No | No | ows_RobotsNoIndex |
RootPostID | Text | No | Yes | No | Yes | No | No | ows_RootPostID |
RootPostOwnerID | Text | No | Yes | No | Yes | No | No | ows_RootPostOwnerID |
RootPostUniqueID | Text | No | Yes | No | Yes | No | No | ows_RootPostUniqueID |
Schools | Text | Yes | Yes | No | Yes | No | No | People:SPS-School |
SecondaryFileExtension | Text | No | Yes | No | Yes | No | No | ows_FileType, ows_File_x0020_Type |
SecondLevelColleagues | Text | Yes | Yes | No | Yes | No | No |  |
SectionIndexes | Text | Yes | No | No | Yes | No | No |  |
SectionNames | Text | Yes | No | No | Yes | No | No |  |
ServerRedirectedEmbedURL | Text | No | No | No | Yes | No | No | ows_ServerRedirectedEmbedUrl |
ServerRedirectedPreviewURL | Text | No | No | No | Yes | No | No | ows_ServerRedirectedPreviewUrl |
ServerRedirectedURL | Text | No | Yes | No | Yes | No | No | ows_ServerRedirectedUrl |
ServiceApplicationID | Text | No | Yes | No | Yes | No | No |  |
SharedWithInternal | Text | Yes | Yes | No | Yes | Yes | No | ows_SharedWithInternal |
SipAddress | Text | No | Yes | Yes | Yes | No | No | People:SPS-SipAddress |
Site | Text | No | Yes | No | Yes | Yes | No | urn:schemas.microsoft.com:fulltextqueryinfo:sitename |
SiteClosed | Yes/No | No | Yes | No | No | No | No |  |
SiteDescription | Text | No | No | No | Yes | No | No | ows_SiteDescription |
SiteID | Text | No | Yes | No | Yes | No | No | ows_SiteID |
SiteLogo | Text | No | No | No | Yes | No | No | LogoURL |
SitemapChangeFrequency | Integer | No | No | No | Yes | No | No |  |
SitemapPriority | Double precision float | No | No | No | Yes | No | No |  |
SiteMembers | Text | Yes | No | No | Yes | No | No |  |
sitename | Text | No | Yes | No | Yes | Yes | No |  |
SiteOwners | Text | Yes | No | No | Yes | No | No |  |
siterank | Integer | No | No | No | No | No | Yes |  |
SiteTitle | Text | No | Yes | No | Yes | No | No | ows_SiteName | urn:schemas-microsoft-com:office:office#ows_SiteName
Size | Integer | No | Yes | No | Yes | Yes | Yes | Basic:12, ows_ImageSize | DAV:getcontentlength, PictureSize, ImageSize
Skills | Text | Yes | Yes | No | Yes | No | No | People:SPS-Skills |
SocialTag | Text | No | Yes | Yes | Yes | No | No |  |
SocialTagTextUrl | Text | Yes | Yes | No | No | No | No | People:SocialTagTextUrl |
SPContentType | Text | No | Yes | No | No | Yes | No | ows_ContentType |
SpellingTerms | Text | No | No | Yes | No | No | No |  |
SPSiteURL | Text | No | Yes | No | Yes | No | Yes | ows_SPSiteURL |
SPVersion | Integer | No | No | No | Yes | No | No | ows_SPVersion |
StartDate | Date and Time | No | Yes | No | Yes | No | No | ows_Start_x0020_date, ows_DMSReleaseDate |
Status | Text | No | Yes | No | Yes | No | No | ows_Issue_x0020_Status, ows_Task_x0020_Status |
Tags | Text | Yes | Yes | No | Yes | Yes | No | ows_SearchTag1, ows_SearchTag2, ows_SearchTag3 |
teaser | Text | No | No | No | Yes | No | No |  |
Text1 | Text | No | No | Yes | No | No | No |  |
Text2 | Text | No | No | Yes | No | No | No |  |
Text3 | Text | No | No | Yes | No | No | No |  |
Title | Text | No | Yes | Yes | Yes | No | No | Office:2, ows_BaseName, Title | DocTitle, urn:schemas.microsoft.com:fulltextqueryinfo:displaytitle
tld | Text | No | Yes | No | Yes | No | No |  |
UniqueID | Text | No | No | No | Yes | No | No | ows_UniqueID |
url | Text | No | No | No | Yes | No | No | ows_DMSDocAuthorURL |
UrlDepth | Integer | No | Yes | No | Yes | Yes | Yes |  |
urlkeywords | Text | No | Yes | Yes | No | No | No |  |
urls | Text | Yes | Yes | No | Yes | No | No |  |
UsageAnalyticsId | Text | No | Yes | No | Yes | No | No | ows_ProductCatalogItemNumber |
UsageEvent10LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent10Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent11LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent11Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent12LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent12Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent1LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent1Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent2LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent2Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent3LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent3Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent4LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent4Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent5LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent5Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent6LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent6Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent7LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent7Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent8LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent8Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent9LifeTime | Integer | No | No | No | Yes | No | Yes |  |
UsageEvent9Recent | Integer | No | No | No | Yes | No | Yes |  |
UsageEventItemId | Text | No | Yes | No | Yes | Yes | No | ows_ProductCatalogItemNumber |
UserEncodingURL | Text | No | No | No | Yes | No | No | ows_VideoSetUserOverrideEncoding |
UserName | Text | No | Yes | Yes | Yes | No | No | People:UserName, ows_FullName, ows_Full_x0020_Name |
UserProfile_GUID | Text | No | Yes | No | Yes | No | No | People:UserProfile_GUID |
ViewsLast1Days | Integer | No | No | No | Yes | No | No |  |
ViewsLast1DaysUniqueUsers | Integer | No | No | No | Yes | No | No |  |
ViewsLast2Days | Integer | No | No | No | Yes | No | No |  |
ViewsLast2DaysUniqueUsers | Integer | No | No | No | Yes | No | No |  |
ViewsLast3Days | Integer | No | No | No | Yes | No | No |  |
ViewsLast3DaysUniqueUsers | Integer | No | No | No | Yes | No | No |  |
ViewsLast4Days | Integer | No | No | No | Yes | No | No |  |
ViewsLast4DaysUniqueUsers | Integer | No | No | No | Yes | No | No |  |
ViewsLast5Days | Integer | No | No | No | Yes | No | No |  |
ViewsLast5DaysUniqueUsers | Integer | No | No | No | Yes | No | No |  |
ViewsLast6Days | Integer | No | No | No | Yes | No | No |  |
ViewsLast6DaysUniqueUsers | Integer | No | No | No | Yes | No | No |  |
ViewsLast7Days | Integer | No | No | No | Yes | No | No |  |
ViewsLast7DaysUniqueUsers | Integer | No | No | No | Yes | No | No |  |
ViewsLastMonths1 | Integer | No | No | No | Yes | No | No |  |
ViewsLastMonths1Unique | Integer | No | No | No | Yes | No | No |  |
ViewsLastMonths2 | Integer | No | No | No | Yes | No | No |  |
ViewsLastMonths2Unique | Integer | No | No | No | Yes | No | No |  |
ViewsLastMonths3 | Integer | No | No | No | Yes | No | No |  |
ViewsLastMonths3Unique | Integer | No | No | No | Yes | No | No |  |
ViewsLifeTime | Integer | No | No | No | Yes | No | Yes |  |
ViewsLifeTimeUniqueUsers | Integer | No | No | No | Yes | No | Yes |  |
ViewsRecent | Integer | No | No | No | Yes | No | Yes |  |
ViewsRecentUniqueUsers | Integer | No | No | No | Yes | No | Yes |  |
WebId | Text | No | Yes | No | Yes | No | No | ows_WebId |
WebTemplate | Text | No | Yes | No | No | Yes | No | WebTemplate |
WeightedMemberships | Text | Yes | No | No | Yes | No | No | People:WeightedMemberships |
WikiCategory | Text | No | Yes | No | Yes | No | No | ows_Wiki_x0020_Page_x0020_Categories |
WordCustomRefiner1 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordCustomRefiner2 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordCustomRefiner3 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordCustomRefiner4 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordCustomRefiner5 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordExactCustomRefiner | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordPartCustomRefiner1 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordPartCustomRefiner2 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordPartCustomRefiner3 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordPartCustomRefiner4 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordPartCustomRefiner5 | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WordPartExactCustomRefiner | Text | Yes | Yes | No | Yes | Yes | Yes |  |
WorkEmail | Text | No | Yes | Yes | Yes | No | No | People:WorkEmail, ows_EMail, ows_EMail_x0020_ | urn:schemas-microsoft-com:sharepoint:portal:profile:WorkEmail
WorkId | Integer | No | No | No | Yes | No | No |  |
WorkPhone | Text | No | Yes | No | Yes | No | No | People:WorkPhone, ows_WorkPhone, ows_Work_x0020_Phone | urn:schemas-microsoft-com:sharepoint:portal:profile:WorkPhone
YomiDisplayName | Text | No | Yes | No | Yes | No | No | People:SPS-PhoneticDisplayName |


Default connectors in SharePoint Server 2013

Summary: Learn which connectors that by default are installed in SharePoint products.

Applies to: SharePoint Server 2013

The crawler uses connectors to connect to content repositories. In previous SharePoint products connectors were known as protocol handlers.

Default connectors reference

The following table lists the connectors that by default are installed in SharePoint products, and to which content repositories they connect.

Connector | Content repository
Bcs | Business Connectivity Services (internal protocol)
Bcs2 | Business Connectivity Services URLs (internal protocol)
File | File shares
http | Web sites
https | Web sites over Secure Sockets Layer (SSL)
Notes | Lotus Notes databases
Rb | Exchange public folders for versions prior to Microsoft Exchange Server 2003
Rbs | Exchange public folders over SSL for versions prior to Exchange Server 2003
Sps | People profiles in Microsoft Office SharePoint Portal Server 2003
Sps3 | People profiles in Microsoft Office SharePoint Server 2007
Sps3s | People profiles in Office SharePoint Server 2007 over SSL
Spss | People profiles in SharePoint Portal Server 2003 over SSL
Sts3 | Windows SharePoint Services 3.0 and Office SharePoint Server 2007 sites
Sts3s | Windows SharePoint Services 3.0 and Office SharePoint Server 2007 sites over SSL
Sts4 | Microsoft SharePoint Foundation 2010, SharePoint Server 2010, SharePoint Foundation 2013, and SharePoint Server 2013 sites
Sts4s | SharePoint Foundation 2010, SharePoint Server 2010, SharePoint Foundation 2013, and SharePoint Server 2013 sites over SSL


Query variables in SharePoint Server 2013

Published: October 16, 2012

Summary: Learn about the query variables that can be used when you configure a query.

Applies to: SharePoint Server 2013

Query variables

The following tables show the query variables for SharePoint Server 2013, and examples on how they can be used.

Site and site collection properties

Query variable | Definition
{Site} or {Site.URL} | URL of the site from where the query was issued. For example, this value can be used to query content of the managed property Path.
{Site.ID} | GUID of site from where the query was issued. This value corresponds to the value of the managed property SiteID.
{Site.LCID} | Numeric value of the locale as specified by the Regional Settings in the Site Settings on the Site from where the query was issued.
{Site.Locale} | Language of the Site from where the query was issued in ll-cc format — for example, en-us.
{Site.<property>} | Any property from the property bag of the site (SPWeb) from where the query was issued, including custom properties.
{SiteCollection} or {SiteCollection.URL} | URL of site collection from where the query was issued. For example, this value can be used to query content of the managed property Path.
{SiteCollection.ID} | GUID of site collection from where the query was issued.
{SiteCollection.LCID} | Numeric value of the locale as specified by the Regional Settings in the Site Settings on the Site Collection from where the query was issued.
{SiteCollection.Locale} | Language of the Site Collection from where the query was issued in ll-cc format — for example, en-us.
{SiteCollection.<property>} | Any property from the property bag of the root site (SPWeb) in the site collection (SPSite) from where the query was issued, including custom properties.

Page, URL token, query string and request properties

Query variable | Definition
{Page} or {Page.URL} | URL of the page from where the query was issued. For example, this value can be used to query content of the managed property Path.
{Page.UsageAnalyticsId} | Item ID for Usage Analytics
{Page.<FieldName>} | The value of a field on the page from where the query was issued. For example, if the page from where the query was issued contained a site column named "ContentOwner," specifying {Page.ContentOwner} would allow you to query for the value of "ContentOwner."
{URLToken.<integer>} | A value from the URL of a page. The integer represents the position of the value in the URL as counted from right to left. For example, for the page http://www.contoso/audio/mp3/1010101, the query variable {URLToken.1} will query for the last value in the URL, 1010101. The query variable {URLToken.3} will query for the third last property in the URL, audio. You can query for values up to the ninth last position in a ULR.
{QueryString.<ParameterName>} | A value from a query string in the URL of the current page. For example, if the URL of the current page contains a query string such as ItemNumber=567, you could obtain the value 567 by specifying {QueryString.ItemNumber}.
{Request.<PropertyName>} | A value from the current http request - for example, {Request.Url}.

User properties

Query variable | Definition
{User} or {User.Name} | Display name of the user who issued the query. For example, this value can be used to query content of the managed property Author.
{User.Email} | Email address of the user who issued the query. For example, this value can be used to query content of the managed property WorkEmail.
{User.SID} | SID of the user who issued the query.
{User.LCID} | Numeric value of locale as defined in the profile of the user who issued the query.
{User.PreferredContentLanguage} | Language as specified as Preferred Content Language in the profile of the user who issued the query.
{User.PreferredDisplayLanguage} | Language as specified as Preferred Display Language in the profile of the user who issued the query.
{User.<property>} | Any property from the user profile of the user who issued the query — for example, SPS-Interests, including custom properties.

Term and term set properties

Query variable | Definition
{Term} or {Term.ID} or {Term.IDNoChildren} | GUID of current site navigation node with a prefix of #0 — for example, #083e99dcb-7907-4dc9-abc8-b5614a284f1c. For example, this value can be used to query content of the managed property owstaxIdMetadataAllTagsInfo or owstaxIdProductCatalogItemCategory in a Product Catalog Site Collection.
{Term.IDWithChildren} | GUID of current site navigation node with a prefix of # — for example, #83e99dcb-7907-4dc9-abc8-b5614a284f1c. This will return all items tagged with the current site navigation term, or children of the current site navigation term. For example, this value can be used to query content of the managed property owstaxIdProductCatalogItemCategory in a Product Catalog Site Collection. This value cannot be used to query the content of the managed property owstaxidmetadataalltagsinfo.
{Term.Name} | Label of the site navigation node — for example, Audio.
{Term.<property>} | Any property from the property bag of the term, including custom properties.
{TermSet} or {TermSet.ID} | GUID of the term set used for current site navigation.
{TermSet.Name} | Label of the term set used for current site navigation.

List and list item properties

Query variable | Definition
{List} | URL of the current list.
{List.<property>} | Any property of the current list.
{ListItem} | URL of the current list item.
{ListItem.<property>} | Any property of the current list item.

Other properties

Query variable | Definition
{Today+/- <integer value for number of days>} | A date calculated by adding/subtracting the specified number of days to/from the date when the query is issued. Date format is YYYY-MM-DD. For example, this value can be used to query content of the managed property LastModifiedTime.
{SearchBoxQuery} | The query value entered into a search box on a page.
{CurrentDisplayLanguage} | The current display language based on MUI in ll-cc format.
{CurrentDisplayLCID} | Numeric value of the current display language based on MUI in ll-cc format.

Dealing with spaces in values

Search queries use the space character to tokenize query values issued by users. When a query variable is expanded to a value that contains a space, the complete value is enclosed in double quotations. For example, for the query author:{User}, the expanded value becomes author:"John Smith".

If you don't want the value to be enclosed with double quotations — for example, when concatenating multiple values — you can use the escape character in the query variable. For example: customProperty:"{\User.Name};{\User.ZipCode}" would become customProperty:"John Smith;98109".

Query variables with multiple values

Some query variables may return multiple values. For query variables that return multiple values, the following syntax must be used: {|ManagedProperty:{QueryVariable}}. All the query variable values will be combined by using the bitwise OR operation. For example, say that you have a term set that is used to categorized interest of users. All users are configured to have one or more interests using the multi-value property SPS-Interests in the User Profile Service Application. To issue a query for any of the interests of the current user, the following syntax could be used: {|owstaxIdMetadataAllTagsInfo:{User.SPS-Interests}}. If the current user is configured to have two interests — football (#0f95d1fdf-781f-42f4-99f9-c656c1341b2e) and basketball (#0c2cff933-9377-4692-aa98-ce59768aa38b) — the query will be transformed to (owstaxIdMetadataAllTagsInfo:#0f95d1fdf-781f-42f4-99f9-c656c1341b2e) OR (owstaxIdMetadataAllTagsInfo:#0c2cff933-9377-4692-aa98-ce59768aa38b).

There are some restrictions with using multiple values. Only the OR operator ({|) is supported for multiple values. The AND operator is not supported. Also, only columns of type Managed Metadata work correctly for multiple value cases. Other types of columns that may use multiple values, such as columns of type Person or Group or Choice, the items will be expanded into a delimited string.


Result types and display templates that are used to display search results in SharePoint Server 2013
See also

Published: September 3, 2013

Summary: Learn about the default result types and display templates that are used to display search results.

Applies to: SharePoint Server 2013

SharePoint 2013 includes many default search features that do a great job in helping users find what they're looking for. But you might want your search results to look a certain way, for example, display information that's specific to your company or business. To customize how search results look and what information they contain, you can create new result types and display templates or change existing ones. This article does not describe how you can do this, but gives an overview of the default result types and display templates that are used to display search results.

In this article:

  • About result types

  • How result types and display templates are connected

  • Common display templates that are used by all result types

  • Display template that is used for promoted results

About result types

When you search for something on a SharePoint site, very often many search results are returned. By default, the search results are displayed differently so that you can easily differentiate between the different types of search results. For example, just by glancing at the image below you can see that the first two search results are PowerPoint presentations, the third result is a Word document, and so on.

Search results displayed according to result type

To display search results differently like this, search results are sorted into result types. A result type is a classification of a search result. For example, if a search result is found in a Microsoft PowerPoint presentation, the search result belongs to the Microsoft PowerPoint result type. If a search result is found in a PDF file, the search result belongs to the PDF result type.

The following table shows the default result types.

Result type | Search result found in
Person | The Local People Results result source
Microsoft Access | A Microsoft Access file
Microsoft Excel | A Microsoft Excel file
Microsoft OneNote | A Microsoft OneNote file
Microsoft PowerPoint | A Microsoft PowerPoint file
Microsoft Publisher | A Microsoft Publisher file
Microsoft Visio | A Microsoft Visio file
Microsoft Word | A Microsoft Word file
Discussion | An entry within a community site
Reply | A reply to an e-mail
Email | An e-mail
Image | An image file
PDF | A PDF file
Text | A TXT file
Video | A video file
XML | An XML file
Zip | A ZIP file
SharePoint Blog | A SharePoint Blog site
SharePoint Community | A SharePoint Community Site
SharePoint Discussion Board | A SharePoint Discussion Board library
SharePoint Document Library | A SharePoint Document library
SharePoint List | A SharePoint list
SharePoint MicroBlog Post | A blog post within a SharePoint Blog Site
SharePoint Picture Library | A SharePoint Picture library
SharePoint site | A SharePoint site
SharePoint Survey | A SharePoint survey
SharePoint Wiki | A SharePoint Enterprise Wiki Site
SharePoint Picture Library List Item | An item in a SharePoint picture library
SharePoint List Item | An item in a SharePoint list
Webpage | External web pages, for example HTML or ASPX pages
Default Result Type | Anything not covered by the other result types, for example Java files, C++ or C#

How result types and display templates are connected

In a SharePoint Search Center, search results are displayed in a Search Results Web Part. To control how the search results are displayed, two types of display templates are used:

  1. Item display template

  2. Hover panel display template

Display templates used to control how the search results are displayed

The item display template defines how each result is displayed. The hover panel display template shows additional information when a user hovers with the mouse pointer over a search result.

The following diagram shows how result types and display templates are connected.

How result types and display templates are connected

  1. Each result type refers to an item display template.

  2. Each item display template contains a variable that refers to a hover panel display template. This variable is var hoverUrl.

The following table shows how the default result types are connected to item display templates and hover panel display templates.

Result type | Item display template title as shown in the user interface | Item display template file name as shown in the Master Page Gallery | Hover panel display template file name as shown in the Master Page Gallery
Person | People Item | Item_Person | Item_Person_HoverPanel
Microsoft Access | Office Document Item | Item_OfficeDocument | Item_OfficeDocument_HoverPanel
Microsoft Excel | Excel Item | Item_Excel | Item_Excel_HoverPanel
Microsoft OneNote | OneNote Item | Item_OneNote | Item_OneNote_HoverPanel
Microsoft Powerpoint | PowerPoint Item | Item_PowerPoint | Item_PowerPoint_HoverPanel
Microsoft Publisher | Office Document Item | Item_OfficeDocument | Item_OfficeDocument_HoverPanel
Microsoft Visio | Office Document Item | Item_OfficeDocument | Item_OfficeDocument_HoverPanel
Microsoft Word | Word Item | Item_Word | Item_Word_HoverPanel
Discussion | Discussion | Item_Discussion | Item_Discussion_HoverPanel
Reply | Reply Item | Item_Reply | Item_Reply_HoverPanel
Email | Default Item | Item_Default | Item_Default_HoverPanel
Image | Default Item | Item_Default | Item_Default_HoverPanel
PDF | PDF Item | Item_PDF | Item_PDF_HoverPanel
Text | Default Item | Item_Default | Item_Default_HoverPanel
Video | Video Item | Item_Video | Item_Video_HoverPanel
XML | Default Item | Item_Default | Item_Default_HoverPanel
Zip | Default Item | Item_Default | Item_Default_HoverPanel
SharePoint Blog | Default Item | Item_Default | Item_Default_HoverPanel
SharePoint Community | Community Item | Item_Community | Item_Community_HoverPanel
SharePoint Discussion Board | Default Item | Item_Default | Item_Default_HoverPanel
SharePoint Document Library | Default Item | Item_Default | Item_Default_HoverPanel
SharePoint List | Default Item | Item_Default | Item_Default_HoverPanel
SharePoint MicroBlog Post | Default Item | Item_Default | Item_Default_HoverPanel
SharePoint Picture Library | Default Item | Item_Default | Item_Default_HoverPanel
SharePoint Site | Site Item | Item_Site | Item_Site_HoverPanel
SharePoint Survey | Default Item | Item_Default | Item_Default_HoverPanel
SharePoint Wiki | Default Item | Item_Default | Item_Default_HoverPanel
SharePoint Picture Library List Item | Picture Item | Item_Picture | Item_Picture_HoverPanel
SharePoint List Item | Default Item | Item_Default | Item_Default_HoverPanel
Webpage | Web Page Item | Item_WebPage | Item_WebPage_HoverPanel
Default Result Type | Default Item | Item_Default | Item_Default_HoverPanel

Common display templates that are used by all result types

In addition to the display templates that are listed in the previous section, there are some display templates that are used by all result types. These are called common display templates. The common display templates are referred to from both the item display templates and the hover panel display template. The following diagram shows how they are referenced.

How result types and all display templates are connected

  1. Each item display template refers to the Common Item Body item display template. The reference is _#=ctx.RenderBody(ctx)=#_.

  2. Each hover panel display template contains three references to the three common hover panel display templates. The references are _#=ctx.RenderHeader(ctx)=#_,_#=ctx.RenderBody(ctx)=#_ and _#=ctx.RenderFooter(ctx)=#_.

The following table shows the common display templates.

Display template title as shown in the user interface | Display template name as shown in the Master Page Gallery | Description
Common Item Body | Item_CommonItem_Body | Displays information in the body of the Search Results Web Part.
Common Hover Panel Header | Item_CommonHoverPanel | Displays information in the header of the hover panel.
Common Hover Panel | Item_CommonPanel_Body | Displays information in the body of the hover panel.
Common Hover Panel Actions | Item_CommonHoverPanel_Actions | Displays actions in the footer of the hover panel, such as Edit or Send.

Display template that is used for promoted results

You can use query rules to promote individual results so that they appear towards the top of the search results list. The promoted results are displayed by using a specific item display template that is not connected to a result type. Therefore, it is used to display all search results that are promoted. This display template does not refer to a hover panel display template.

The following table shows the display template that is used for promoted results.

Item display template title | Item display template file name as shown in the Master Page Gallery | Description
Best Bet Item | Item_BestBet | Displays search results that are promoted by using query rules.

See also

Customize search result types in SharePoint 2013
Manage the Search Center
Manage query rules in SharePoint Server 2013
Display template reference in SharePoint Server 2013


Publishing technical reference for SharePoint Server 2013

Published: August 15, 2012

Summary: Provides links to reference articles for SharePoint Server 2013 publishing sites.

Applies to: SharePoint Server 2013

In this section:

  • Automatically created managed properties in SharePoint Server 2013


Automatically created managed properties in SharePoint Server 2013

Published: August 28, 2012

Summary: Learn about the naming conventions for automatically created crawled properties and managed properties.

Applies to: SharePoint Server 2013

In this article:

  • How site columns become managed properties

  • Special characters and non-supported characters

  • Default site columns for the Product Catalog content type

How site columns become managed properties

When you add columns to a SharePoint library or list, you can choose to add regular columns or site columns. For information about the difference between regular columns and site columns, see Introduction to columns. In SharePoint Server 2013, only site columns that contain values will automatically become managed properties when they are crawled. Regular columns will not automatically become managed properties when they are crawled.

Before you can share content in a library or list with other site collections, you must share the library or list as a catalog, and then start a full crawl of the content. For more information, see "Share a library or list as a catalog" in Configure cross-site publishing in SharePoint Server 2013.

During the crawl of library content, the following actions are performed on the site columns:

  1. A crawled property is created. Spaces are removed from the site column name, and then the following prefixes are added to the site column name to create the crawled property name:

    • For site columns of type Publishing HTML and Multiple line of text: ows_r_<four letter code>_

    • For site columns of type Managed Metadata: ows_taxId_

    • For all other site column types: ows_q_<four letter code>_

  2. A managed property is created and mapped to the corresponding crawled property. Spaces are removed from the site column name, and the following items are added to the site column name to create the managed property name:

    • For all site columns of type Managed Metadata, the following prefix is added: owstaxId

    • For all other site column types, the following suffix is added: OWS <four letter code>

Important:

The four letter code represents the site column type, not the managed property type. All automatically created managed properties are of type Text.

Examples of automatically created crawled property names and managed property names for site columns without special characters

Site column type Site column name Crawled property name Managed property name Data format

Single line of text

Site Column Name

ows_q_TEXT_SiteColumnName

SiteColumnNameOWSTEXT

As is.

Multiple lines of text

Site Column Name

ows_r_MTXT_SiteColumnName

SiteColumnNameOWSMTXT

As is.

Choice

Site Column Name

ows_q_CHCS_SiteColumnName

SiteColumnNameOWSCHCS

The text value of the choice.

Choice (allow multiple selections)

Site Column Name

ows_q_CHCM_SiteColumnName

SiteColumnNameOWSCHCM

Selected values separated by semicolon and hash mark — for example, MultiValue 2;# MultiValue 4;#.

Number

Site Column Name

ows_q_NMBR_SiteColumnName

SiteColumnNameOWSNMBR

Textual representation of the number. The value will use dot as a decimal symbol.

This format cannot be used in a greater than or less than comparison with other integers. It should only be used when querying for and displaying an exact value.

Currency

Site Column Name

ows_q_CURR_SiteColumnName

SiteColumnNameOWSCURR

Textual representation of the number. The value will use dot as a decimal symbol.

This format cannot be used in a greater than or less than comparison with other integers. It should only be used when querying for and displaying an exact value.

Date and Time

Site Column Name

ows_q_DATE_SiteColumnName

SiteColumnNameOWSDATE

Textual representation of the date in the format YYYY-MM-DDTHH:MM:SSZ. For example, December 25, 2012, 7 AM GMT is 2012-12-25T07:00:00Z.

This format cannot be used in a greater than or less than comparison with other dates. It should only be used when querying for and displaying an exact date.

Yes/No

Site Column Name

ows_q_BOOL_SiteColumnName

SiteColumnNameOWSBOOL

For true, use value 1. For false, use value 0.

Person or Group

Site Column Name

ows_q_USER_SiteColumnName

SiteColumnNameOWSUSER

Email | Display | Name | EncodedClaim Claim. For example, "ellenk@contoso.com | Ellen Kessels | 693A30232E777C7265646D6F6E645C70696E676A i:0#.w|contoso\ellenk"

Hyperlink or Picture

Site Column Name

ows_q_URLH_SiteColumnName

SiteColumnNameOWSURHL

URL, description. For example, http://www.contoso.com, Welcome to the home page of Contoso.

Publishing HTML

Site Column Name

ows_r_HTML_SiteColumnName

SiteColumnNameOWSHTML

Html escaped enclosed in a paragraph tag. For example, <p>&lt;div&gt;&lt;b&gt;some html &lt;/b&&lt;/div&gt;</p>.

Publishing Image

Site Column Name

ows_q_IMGE_SiteColumnName

SiteColumnNameOWSIMGE

Html image tag. For example, <img alt="" src="/sites/pub/SiteCollectionImages/home.jpg" style="BORDER&#58;0px solid;" />.

Publishing Link

Site Column Name

ows_q_LINK_SiteColumnName

SiteColumnNameOWSLINK

Html link tag. For example, <a href="http&#58;//www.microsoft.com" target="_blank" title="mytooltip">Microsoft Website</a>.

Managed Metadata

Site Column Name

ows_taxId_SiteColumnName

owstaxIdSiteColumnName

See "Data format for Managed Metadata" below.

Integer*

Site Column Name

ows_q_INTG_SiteColumnName

SiteColumnNameOWSINTG

Textual representation of the integer.

This format cannot be used in a greater than or less than comparison with other integers. It should only be used when querying for and displaying an exact value.

GUID*

Site Column Name

ows_q_GUID_SiteColumnName

SiteColumnNameOWSGUID

Values separated by hyphens, enclosed in brackets. For example, {147C6BA1-709C-4401-964A-27AC36B62C54}.

Grid Choice*

Site Column Name

ows_q_CHCG_SiteColumnName

SiteColumnNameOWSCHCG

For each row, row name separated by semi-colon and hash mark, followed by the selected value.

ContentTypeIDFieldType*

Site Column Name

ows_q_CTID_SiteColumnName

SiteColumnNameOWSCTID

Name:#ContentTypeID;#

SPS average rating

Site Column Name

ows_q_RAVG_SiteColumnName

SiteColumnNameOWSRAVG

Textual representation of the number. The value will use dot as a decimal symbol.

SPS rating count

Site Column Name

ows_q_RCNT_SiteColumnName

SiteColumnNameOWSRCNT

Textual representation of the integer.

*Column creation not available through user interface.

Note:

Automatic creation of managed properties is not supported for the following site column types:

  • Lookup

  • Calculated

  • Task outcome

  • Summary Links data

  • Rich media data for publishing

Data format for Managed Metadata.
To query for items tagged with a Managed Metadata field, you have to use the Unique Identifier for each label. You can find the Unique Identifier for each term in a term set in the Term Store Management Tool, on the GENERAL tab. In addition, the data format that is used in the query has to specify from which level in the term set the query should apply. This specification is set by adding one of the following prefixes to the Unique Identifier:

  • To query for all items that are tagged with a term: GP0|#

  • To query for all items that are tagged with a child of term: GPP|#

  • To query for all items that are tagged with a term from a term set: GTSet|#

For example, let's say that you have a catalog of restaurants around the world. The catalog has a managed metadata site column named Location, which is tied to the term set named World. The term set has the following structure (the GUID for each term is shown in parentheses):

  • World (fc01ae6d-8ed3-4872-9cef-d2199d52d61c)

    • India (c8a43f13-5ea1-45f2-b46d-3a1986a1cbd7)

      • Mumbai (ad491ed9-c21c-46d9-896c-c0d148957c60)

      • Delhi (c195b6e0-9062-446a-9af1-8ec1a642fede)

    • France (17587ed2-8433-45a4-9f4b-6825164fcd09)

      • Paris (01031cfe-2492-47f1-8723-45c63ef70ec9)

      • Lyon (3b2137a9-3c3a-4676-a50a-14f72ab29175)

The catalog entries and examples of queries are shown in the following tables.

Catalog entries for restaurants and locations

Restaurant | Location
Restaurant 1 | Mumbai
Restaurant 2 | Mumbai
Restaurant 3 | Delhi
Restaurant 4 | Paris
Restaurant 5 | Lyon

Query examples

Query for | Data format | Query will return
All restaurants in Mumbai | GP0|#ad491ed9-c21c-46d9-896c-c0d148957c60 | Restaurant 1, Restaurant 2
All restaurants in Delhi | GP0|#c195b6e0-9062-446a-9af1-8ec1a642fede | Restaurant 3
All restaurants in India | GPP|#c8a43f13-5ea1-45f2-b46d-3a1986a1cbd7 | Restaurant 1, Restaurant 2, Restaurant 3
All restaurants in the World | GTSet|#fc01ae6d-8ed3-4872-9cef-d2199d52d61c | Restaurant 1, Restaurant 2, Restaurant 3, Restaurant 4, Restaurant 5

To display values by label — for example, Mumbai — you have to use the prefix L0|.

Special characters and non-supported characters

If a site column name contains diacritics, such as the German umlaut, or a non-supported character, such as #, these characters are included in the crawled property name, but not in the managed property name.

Examples of automatically created crawled property names and managed property names for site columns with special or non-supported characters

Site column name | Crawled property name | Managed property name
Germanäö | ows_q_TEXT_ Germanäö | GermanOWSTEXT
Site_Column# | ows_q_TEXT_Site_Column# | SiteColumnOWSTEXT
Note:

The following Unicode code blocks are considered non-supported characters: Unicode 0000-0021, Unicode 0080 - 00a1, Unicode 2000 - 2070, Unicode ff00 ff10, and Unicode ff1a ff20.

Default site columns for the Product Catalog content type

The Product Catalog list in the Product Catalog site collection has six default site columns associated with its content type. The following table shows the names for these site columns and the names for their crawled properties and managed properties.

Automatically created crawled property names and managed property names for site columns that belong to the Product Catalog content type

Site column name | Crawled property name | Managed property name
Title | Title | Title
Item Number | ows_q_TEXT_ProductCatalogItemNumber | ProductCatalogItemNumberOWSTEXT
Group Number | ows_q_TEXT_ProductCatalogGroupNumber | ProductCatalogGroupNumberOWSTEXT
Language Tag | ows_q_CHCS_ProductCatalogLanguageTag | ProductCatalogLanguageTagOWSCHCS
Item Category | ows_taxId_ProductCatalogItemCategory | owstaxIdProductCatalogItemCategory
Rollup Image | ows_r_IMGE_PublishingRollupImage | PublishingImage


SharePoint Health Analyzer rules reference (SharePoint 2013)

Summary: Learn how to troubleshoot problems in SharePoint 2013 Products that SharePoint Health Analyzer has alerted you about.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

In this section:

  • A State Service Application has no database defined (SharePoint 2013)

  • Accounts used by application pools or service identities are in the local machine Administrators group (SharePoint 2013)

  • All State Service databases are paused for a State Service Application (SharePoint 2013)

  • Alternate access URLs have not been configured (SharePoint 2013)

  • Application pools recycle when memory limits are exceeded (SharePoint 2013)

  • Business Data Connectivity connectors are currently enabled in a partitioned environment (SharePoint 2013)

  • Cached objects have been evicted (SharePoint 2013)

  • Critical state of this rule indicates that the Word Automation Services is not running when it should be running (SharePoint 2013)

  • Content databases contain orphaned Apps (SharePoint 2013)

  • Database has large amounts of unused space (SharePoint 2013)

  • Databases exist on servers running SharePoint Foundation (SharePoint 2013)

  • Databases require upgrade or not supported (SharePoint 2013)

  • Databases running in compatibility range, upgrade recommended (SharePoint 2013)

  • Databases used by SharePoint have outdated index statistics (SharePoint 2013)

  • Databases within this farm are set to read only and will fail to upgrade unless it is set to a read-write state (SharePoint 2013)

  • SPHA rule: Dedicated crawl target configuration has one or more invalid servers (SharePoint 2013)

  • Distributed cache service is not enabled in this deployment

  • Drives used for SQL databases are running out of free space (SharePoint 2013)

  • Expired sessions are not being deleted from the ASP.NET Session State database (SharePoint 2013)

  • Firewall client settings on the cache host are incorrect (SharePoint 2013)

  • Immediate translations for the Machine Translation service are disabled (SharePoint 2013)

  • InfoPath form library forms cannot be filled out in a Web browser (SharePoint 2013)

  • InfoPath Forms Services forms cannot be filled out in a Web browser because no State Service connection is configured (SharePoint 2013)

  • More Cache hosts are running in this deployment than are registered with SharePoint (SharePoint 2013)

  • One of the cache hosts in the cluster is down (SharePoint 2013)

  • One or more servers is not responding (SharePoint 2013)

  • One or more web applications are configured to use Windows Classic authentication (SharePoint 2013)

  • People Search relevance is not optimized when the Active Directory has errors in the manager reporting structure (SharePoint 2013)

  • Product / patch installation or server upgrade required (SharePoint 2013)

  • Search - One or more crawl databases may have fragmented indices (SharePoint 2013)

  • Some content databases are growing too large (SharePoint 2013)

  • The Application Discovery and Load Balancer Service is not running in this farm (SharePoint 2013)

  • The InfoPath Forms Services Maintenance Timer Job not enabled (SharePoint 2013)

  • The Machine Translation Service is not running when it should be running (SharePoint 2013)

  • The number of Distributed Cache hosts in the farm exceeds the recommended value

  • The Security Token Service is not available (SharePoint 2013)

  • The settings for the Machine Translation Service are not within the recommended limits (SharePoint Server 2013)

  • The settings for Word Automation Services are not within the recommended limits (SharePoint 2013)

  • The State Service Delete Expired Sessions timer job is not enabled (SharePoint 2013)

  • The timer service failed to recycle (SharePoint 2013)

  • The unattended Service Account Application ID is not specified or has an invalid value (SharePoint 2013)

  • The Visio Graphics Service has a maximum cache age setting that will adversely impact performance (SharePoint Server 2013)

  • The Visio Graphics Service has a maximum cache size setting that may adversely impact performance ((SharePoint Server 2013)

  • The Visio Graphics Service has a maximum recalculation duration setting that will adversely impact performance ((SharePoint Server 2013)

  • The Visio Graphics Service has a maximum Web Drawing Size setting that will adversely impact performance (SharePoint Server 2013)

  • The Visio Graphics Service has a minimum cache age setting that may cause a security issue ((SharePoint Server 2013)

  • The Visio Graphics Service has a minimum cache age setting that will adversely impact performance ((SharePoint Server 2013)

  • This Distributed Cache host may cause cache reliability problems (SharePoint 2013)

  • Validate the My Site Host and individual My Sites are on a dedicated Web application and separate URL domain (SharePoint 2013)

  • Verify each User Profile service application has a My Site host configured ((SharePoint Server 2013)

  • Verify each User Profile Service Application has an associated Managed Metadata Service Connection ((SharePoint Server 2013)

  • Verify each User Profile Service Application has an associated Search Service Connection (SharePoint Server 2013)

  • Verify that OAuth is configured correctly for the Machine Translation Service application in SharePoint 2013

  • Verify that OAuth is configured correctly for the Machine Translation Service application proxy in SharePoint 2013

  • Verify that the Activity Feed Timer Job is enabled (SharePoint 2013)

  • Verify that the critical User Profile Application and User Profile Proxy Application timer jobs are available and have not been mistakenly deleted (SharePoint 2013)

  • Web Applications using Claims authentication require an update (SharePoint 2013)

  • Web.config file has incorrect settings for the requestFiltering element (SharePoint 2013)

  • Web.config files are not identical on all machines in the farm (SharePoint 2013)

  • XLIFF translations for the Machine Translation Service is disabled (SharePoint 2013)


A State Service Application has no database defined (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "A State Service Application has no database defined."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: A State Service Application has no database defined

Summary: A State Service service application has no State Service database defined. This may result in errors when using some SharePoint components such as InfoPath Web browser forms and the Microsoft SharePoint Server Chart Web Part.

Cause: One or more of the following might be causing this:

  • The farm administrator deleted all databases associated with the State Service service application.

  • The farm administrator never created or associated a database with the State Service service application.

Resolution: Create a new database or use an existing database for the State Service service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. If no database already exists that you can use, type the following command at the Windows PowerShell command prompt:

    Copy code
    New-SPStateServiceDatabase -Name <DatabaseName> -DatabaseServer <ServerName> [-DatabaseCredentials <Credential>] [-ServiceApplication <ID>]

    Where:

    • <DatabaseName> is name of the database as a String.

    • <ServerName> is name of the database server.

    • <Credential> is SQL Server authentication credentials for the database. If this parameter is not used, Windows authentication will be used.

    • <ID> is the identifier for the State Service service application as a string or a GUID. If there is only one State Service service application, you do not have to specify this parameter.

  4. In some environments, you must connect to an existing, empty SQL database. In this case, type the following command at the Windows PowerShell command prompt:

    Copy code
    Mount-SPStateServiceDatabase -Name <DatabaseName> -DatabaseServer <ServerName> [-DatabaseCredentials <Credential>] [-ServiceApplication <ID>]

    Where:

    • <DatabaseNname> is name of the database as a String.

    • <ServerName> is name of the database server.

    • <Credential> is the SQL Server authentication credentials for the database. If this parameter is not used, Windows authentication will be used.

    • <ID> is the identifier for the State Service service application as a string or a GUID. If there is only one State Service service application, you do not have to specify this parameter.

For more information, see Mount-SPStateServiceDatabase or New-SPStateServiceDatabase.


Accounts used by application pools or service identities are in the local machine Administrators group (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Accounts used by application pools or service identities are in the local machine Administrators group."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Accounts used by application pools or service identities are in the local machine Administrators group.

Summary: A user account that is used by application pools or services must have permissions of a domain user account and must not be a member of the Farm Administrators group or a member of the Administrators group on the local computer. Using highly privileged accounts for application pools or services poses a security risk to the farm, and could allow malicious code to execute.

Cause: Accounts that are used by application pools or services are members of the Administrators group on the local computer.

Resolution: Change the user account to a predefined account, or to a domain user account that is not a member of the Administrators group.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration home page, in the Security section, click Configure service accounts.

  3. On the Service Accounts page, in the Select the component to update list, click the application pool or service that uses the credentials of a member of the Administrators group on the local computer as its security account.

  4. In the Select an account list, click an appropriate account for this component — for example, the predefined account Network Service — or click Register new managed account, and then on the Register Managed Account page, specify the credentials and the password change settings that you want.

  5. Click OK.

For more information, see Account permissions and security settings in SharePoint 2013.


All State Service databases are paused for a State Service Application (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "All State Service databases are paused for a State Service Application."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: All State Service databases are paused for a State Service Application

Summary: All of the databases associated with a State Service service application are paused. This may result in errors when using some SharePoint 2013 components such as InfoPath Web browser forms and the Microsoft SharePoint Chart Web Part.

Cause: This might be caused by the administrator pausing all databases for the service application.

Resolution: Resume the State Service service application databases by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. To identify the paused database, type the following command at the Windows PowerShell command prompt:

    Copy code
    Get-SPStateServiceDatabase

  4. If you want to resume a paused database, type the following command at the Windows PowerShell command prompt:

    Copy code
    Resume-SPStateServiceDatabase -Identity <DatabaseID>

    Where:

    • <DatabaseID> is the identifier for the State Service service application database as a GUID.

  5. If you want to create a new database instead of using an existing database, type the following command at the Windows PowerShell command prompt:

    Copy code
    New-SPStateServiceDatabase -Name <DatabaseName> -ServiceApplication <ID> -DatabaseServer <ServerName> [-DatabaseCredentials <Credential>]

    Where:

    • <DatabaseName> is name of the database as a string.

    • <ID> is the identifier for the affected State Service service application as a string or a GUID. If there is only one State Service service application, you do not have to specify this parameter.

    • <ServerName> is name of the database server.

    • <Credential> is SQL Server authentication credentials for the database server. If this parameter is not specified, Windows authentication will be used.

For more information, see Resume-SPStateServiceDatabase or New-SPStateServiceDatabase.


Alternate access URLs have not been configured (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Alternate access URLs have not been configured."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Alternate access URLs have not been configured.

Summary: A default zone URL must not point to the computer name of a Web front-end server. Because this installation has more than one Web front-end server, an incorrectly configured default zone URL can result in a variety of errors, including incorrect links and failed operations.

Cause: A default zone URL is pointing to the computer name of a Web front-end server.

Resolution: Change the default zone URL to a URL that differs from the computer name of any Web front-end server.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration home page, in the System Settings section, click Configure alternate access mappings.

  3. On the Alternate Access Mappings page, on the Alternate Access Mapping Collection menu, click Change Alternate Access Mapping Collection.

  4. In the Select An Alternate Access Mapping Collection dialog box, click the alternate access mapping collection for which you want to change the default zone URL.

  5. On the Alternate Access Mappings page, click Edit Public URLs.

  6. On the Edit Public Zone URLs page, in the Default text box, type a new default zone URL that differs from the computer name of any Web front-end server, and then click Save.


Application pools recycle when memory limits are exceeded (SharePoint 2013)
See also

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Application pools recycle when memory limits are exceeded."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Application pools recycle when memory limits are exceeded.

Summary: Application pools recycle because memory limits have been enabled and exceeded. Recycling based on memory limits is not usually necessary in a 64-bit environment, and therefore recycling should not be enabled. Unnecessary recycling can result in dropped requests from the recycled worker process and slow performance for end users who are making requests to the new worker process.

Cause: Application pools are configured to recycle when memory limits are exceeded.

Resolution: Change the application pool recycling settings in Internet Information Services (IIS).

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Identify the server on which this event occurs. On the Central Administration Web site, in the Monitoring section, click Review problems and solutions, and then find the name of the server in the Failing Servers column. If there are multiple failing servers in a server farm, you must repeat the following steps on each failing server.

  3. Verify that the user account that is performing the following steps is a member of the Administrators group on the local computer that you identified in the previous step.

  4. Log on to the server on which this event occurs.

  5. Click Start, click Administrative Tools, and then click Internet Information Services (IIS) Manager.

  6. In the Internet Information Services management console, in the Connections pane, expand the tree view, and then click Application Pools.

  7. In the Application Pools list, right-click the application pool on which you want to disable the memory limits, and then click Recycling.

  8. In the Edit Application Pool Recycling Settings dialog box, in the Memory Based Maximums section, clear the Virtual memory usage (in KB) and Private memory usage (in KB) check boxes, and then click Next.

  9. In the Recycling Events to Log dialog box, click Finish.

See also

Configuring Recycling Settings for an Application Pool (IIS 7)


Business Data Connectivity connectors are currently enabled in a partitioned environment (SharePoint 2013)

Published: January 22, 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Business Data Connectivity connectors are currently enabled in a partitioned environment."

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Rule Name: Business Data Connectivity connectors are currently enabled in a partitioned environment

Summary: Business Data Connectivity (BDC) Models containing External Content Types with database, WCF, Web service or custom connectors can be used by tenants to elevate their user permissions. In a partitioned environment, we recommend you disable the Business Data Connectivity connectors.

Cause: Business Data Connectivity connectors are currently enabled in a partitioned environment.

Resolution: Disable unwanted connectors by using Windows PowerShell.

  • To disable the unwanted connectors, follow the instructions in Business Data Connectivity connectors in a partitioned environment in SharePoint Server 2010 or in SharePoint Foundation 2010.


Cached objects have been evicted (SharePoint 2013)
See also

Published: January 22, 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Cached objects have been evicted."

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Rule Name: Cached objects have been evicted

Summary: When the memory consumption of the cache service on a cache host exceeds the low watermark threshold, objects that have already expired are evicted. When memory consumption exceeds the high watermark threshold, objects are evicted from memory, whether they have expired or not, until memory consumption returns to the low watermark. Subsequently cached objects may be rerouted to other hosts to maintain an optimal distribution of memory.

Cause: There is not sufficient memory in the cache cluster.

Resolution: Add more RAM to the server

  • You can add more RAM to the server to increase the memory. To identify the failing server: in the SharePoint Central Administration website, in the Monitoring section, click Review problems and solutions, and then find the name of the server in the Failing Servers list. If there are multiple failing servers in a server farm, you must repeat this resolution on each failing server.

Resolution: Increase the memory allocation of the distributed cache

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Farm Administrators group.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. Check the current distributed cache settings from usage. To do this, run the following command:

    Get-SPDistributedCacheClientSetting

    For more information, see Get-SPDistributedCacheClientSetting

  4. Stop the Distributed Cache service on all cache hosts in the farm. To do this, run the following command on each cache host:

    Stop-SPDistributedCacheServiceInstance -Graceful

    For more information, see "Perform a graceful shutdown of the Distributed Cache service" in Manage the Distributed Cache service in SharePoint Server 2013.

  5. To increase the cache size of the Distributed Cache service, run the following command one time only on any cache host at the Windows PowerShell command prompt:

    Update-SPDistributedCacheSize -CacheSizeInMB CacheSize

    Where:

    • CacheSize is the cache size's memory allocation assignment in megabytes (MB). The default value is 5 percent of total system RAM. This value should not be more than 40 percent of total system RAM with a maximum limit of 16 gigabytes (GB).

  6. Start the Distributed Cache service on all cache hosts. To start the Distributed Cache service, go to the Services on Server page in Central Administration, and start the Distributed Cache service on all cache hosts in the farm.

See also

Manage the Distributed Cache service in SharePoint Server 2013
Plan for feeds and the Distributed Cache service in SharePoint Server 2013

Update-SPDistributedCacheSize
Planning and using the Distributed Cache service


Content databases contain orphaned Apps (SharePoint 2013)
See also

Published: January 22, 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Content databases contain orphaned Apps."

Rule Name: Content databases contain orphaned Apps.

Summary: In some situations, a content database that is used by SharePoint 2013 may become corrupted. The corrupted database may contain orphaned apps. Orphaned apps are not accessible, which causes unnecessary resource and license consumption and may result in failures in SharePoint upgrade.

Cause: There are orphaned apps in the content databases.

Resolution: Remove the orphaned apps.

  • The content database has orphaned apps on a site collection. Remove these apps. For more information, see Remove app for SharePoint instances from a SharePoint 2013 site.

See also

Install and manage apps for SharePoint 2013


Critical state of this rule indicates that the Word Automation Services is not running when it should be running (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Critical state of this rule indicates that the Word Automation Services is not running when it should be running."

Applies to: SharePoint Server 2013

Rule Name: Critical state of this rule indicates that the Word Automation Services is not running when it should be running.

Summary: Word Automation Services uses a timer job to pull conversion items from the Word Automation Services database and then assign those conversion items to individual application servers. If the timer job does not run, conversion items cannot start to convert.

Cause: The Word Automation Services timer job is not enabled.

Resolution: Enable the Word Automation Services timer job.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration Web site, click Monitoring.

  3. On the Monitoring page, in the Timer Jobs section, click Review job definitions.

  4. On the Job Definitions page, in the list of timer jobs, click Word Automation Services Timer Job.

  5. On the Edit Timer Job page, in the Recurring Schedule section, specify when you want the timer job to run, and then click Enable.


Database has large amounts of unused space (SharePoint 2013)
See also

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Database has large amounts of unused space."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Database has large amounts of unused space.

Summary: The database has large amounts of unused space allocated on the disk. This database uses a large amount of space on the file system unless it is shrunk down to a small size. This event occurs if the unused space is more than 20% of the disk space and the unused space is greater than the auto-growth size plus 50 megabytes (MB).

Cause: Many activities can create unused space in the database. These activities include running the Windows PowerShell Move-SPSite command, and deleting documents, document libraries, lists, list items, and sites.

Resolution: Ignore this event, or shrink the database if you have to.

  • Normally you can safely ignore this event. You shrink a database only if it proves absolutely necessary — for example, when you have performed an operation that removes a very large quantity of data from a database, and the free space is not expected to be used again. You can shrink the database by using the DBCC ShrinkDatabase command or SQL Server Management Studio. For more information, see DBCC SHRINKDATABASE (Transact-SQL) (http://go.microsoft.com/fwlink/p/?LinkID=110852) and How to: Shrink a Database (SQL Server Management Studio) (http://go.microsoft.com/fwlink/p/?LinkID=224904).

    The white paper Database maintenance for SharePoint 2013 (http://go.microsoft.com/fwlink/p/?LinkID=229104) provides very important guidelines for shrinking a database. We strongly recommend that you read this white paper before you shrink a database.

See also

Shrinking a Database


Databases exist on servers running SharePoint Foundation (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Databases exist on servers running SharePoint Foundation."

Applies to: SharePoint Foundation 2013

Rule Name: Databases exist on servers running SharePoint Foundation.

Summary: For optimal performance, databases should not share servers with other applications.

Cause: Databases share servers with other applications.

Resolution: Move the databases to a separate server.

  • To resolve this issue, you must move the databases to a separate server. For more information, see Move content databases in SharePoint 2013 and Move all databases in SharePoint 2013.


Databases require upgrade or not supported (SharePoint 2013)
See also

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Databases require upgrade or not supported."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Databases require upgrade or not supported.

Summary: The databases require upgrade because their versions are earlier than the backward-compatible range, or the databases are not supported because their versions are later than the current version of SharePoint 2013.

Cause: Versions of databases are earlier than the backward-compatible range, or are later than the current version of SharePoint 2013.

Resolution: Upgrade databases to SQL Server 2008 R2.

  • See the following resource for information about how to upgrade databases: Upgrading to SQL Server 2008 R2.

See also

Microsoft SQL Server 2008 R2 Enterprise Edition and Microsoft SharePoint Server 2010: Better Together


Databases running in compatibility range, upgrade recommended (SharePoint 2013)
See also

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Databases running in compatibility range, upgrade recommended."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Databases running in compatibility range, upgrade recommended.

Summary: The databases have versions that are earlier than the current SharePoint software, but are within the backward-compatible range. To achieve optimal results, upgrade the databases.

Cause: Versions of databases are earlier than the current SharePoint software.

Resolution: Upgrade databases to SQL Server 2008 R2.

  • See the following resource for information about how to upgrade databases: Upgrading to SQL Server 2008 R2.

See also

Microsoft SQL Server 2008 R2 Enterprise Edition and Microsoft SharePoint Server 2010: Better Together


Databases within this farm are set to read only and will fail to upgrade unless it is set to a read-write state (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Databases within this farm are set to read only and will fail to upgrade unless it is set to a read-write state."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Databases within this farm are set to read only and will fail to upgrade unless it is set to a read-write state

Summary: The databases are set to read-only and cannot be upgraded.

Cause: The databases are set to read-only.

Resolution: Set the databases to read-write.

  • See Content database is Read-Only - Event 4971 (SharePoint 2010 Products).


Databases used by SharePoint have outdated index statistics (SharePoint 2013)
See also

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Databases used by SharePoint have outdated index statistics."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Databases used by SharePoint have outdated index statistics.

Summary: Outdated index statistics can decrease query performance and cause SharePoint 2013 to respond slowly.

Cause: Index statistics in SharePoint 2013 databases are out of date.

Resolution: Edit the rule definition so that the configuration is automatically repaired.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration Home page, click Monitoring.

  3. On the Monitoring page, in the Health Analyzer section, click Review rule definitions.

  4. On the Health Analyzer Rule Definitions - All Rules page, in the Category: Configuration section, click the name of the rule.

  5. In the Health Analyzer Rule Definitions dialog box, click Edit Item.

  6. Select the Repair Automatically check box, and then click Save.

See also

Index Statistics


SPHA rule: Dedicated crawl target configuration has one or more invalid servers (SharePoint 2013)
See also

Published: January 22, 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Dedicated crawl target configuration has one or more invalid servers."

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Rule Name: Dedicated crawl target configuration has one or more invalid servers.

Summary: Dedicated crawl target configuration has one or more invalid servers. This may degrade search crawl performance.

Cause: The URI is incorrect, or the server is not joined with a valid role to the SharePoint farm.

Resolution: Make sure the uniform resource identifier (URI) is correct, and the server is joined with a valid role to the SharePoint farm.

  1. Make sure that the URI is correct. A valid URI meets the following criteria:

    • The host portion of the URI should be the name of a server that has joined the SharePoint farm.

    • The URI Scheme should be HTTP.

    • The URI must not contain an absolute path.

    For more information, see URI class (http://go.microsoft.com/fwlink/p/?LinkID=193513).

  2. Make sure that the server is joined with a valid role to the SharePoint farm. The server can be any of the following:

    • A front-end web server

    • An application server

    • The stand-alone server in the SharePoint farm

For more information, see Manage crawling in SharePoint 2013.

See also

Add web or application servers to farms in SharePoint 2013


Distributed cache service is not enabled in this deployment
See also

Published: January 22, 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Distributed cache service is not enabled in this deployment."

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Rule Name: Distributed cache service is not enabled in this deployment.

Summary: The Distributed Cache service is started on all servers that run SharePoint products at installation time. However, an administrator that performs maintenance and operational tasks might need to start and stop the Distributed Cache service. This event occurs when the Distributed Cache service is stopped.

Cause: The Distributed Cache service is disabled on this server.

Resolution: Enable the Distributed Cache service by using Windows PowerShell.

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Farm Administrators group.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the server on which you want to enable the Distributed Cache service, run the following command:

    Add-SPDistributedCacheServiceInstance

  4. Verify that the Distributed Cache service is started. To do this, in the SharePoint Central Administration website, click Application Management. In the Service Applications section, click Manage services on server. On the Services on Server page, make sure that the Distributed Cache service is listed, and the status is Started.

See also

Manage the Distributed Cache service in SharePoint Server 2013
Plan for feeds and the Distributed Cache service in SharePoint Server 2013

Add-SPDistributedCacheServiceInstance
Planning and using the Distributed Cache service


Drives used for SQL databases are running out of free space (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Drives used for SQL databases are running out of free space."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Drives used for SQL databases are running out of free space.

Summary: The databases have one or more files that exceed the available free disk drive space. If this happens, operations will fail. A disk drive should have enough free space to allow the largest database file to automatically grow to twice its size.

Cause: The databases have large files that may exceed the available free space.

Resolution: Free disk space on the database server computer.

  1. Verify that the user account that is performing the following step is a member of the Administrators group on the local database server computer.

  2. Click Start, click All Programs, click Accessories, click System Tools, and then click Disk Defragmenter.

  3. Run the Disk Defragmenter tool to free disk space on the server computer.

  4. If the event persists, move some large files to another disk drive to free up space.

Resolution: Decrease the number of days to store log files.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration Home page, click Monitoring.

  3. On the Monitoring page, in the Reporting section, click Configure diagnostic logging.

  4. On the Diagnostic Logging page, in the Trace Log section, in the Number of days to store log files box, type a smaller number.

  5. Click OK.


Expired sessions are not being deleted from the ASP.NET Session State database (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Expired sessions are not being deleted from the ASP.NET Session State database."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Expired sessions are not being deleted from the ASP.NET Session State database

Summary: If expired sessions are not deleted, the server that hosts the ASP.NET Session State database may run out of disk space and the SharePoint farm may cease to function.

Cause: One or more of the following might be causing this:

  • The SQL Server Agent service was stopped.

  • SQL Server Express is installed.

    Important:

    You cannot run the SQL Server Agent service on an instance of SQL Server Express.

Resolution: Start the SQL Server Agent service

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the database server that is hosting the ASP.NET Session State database.

  2. In the Services snap-in, start the SQL Server Agent service.


Firewall client settings on the cache host are incorrect (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Firewall client settings on the cache host are incorrect."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Firewall client settings on the cache host are incorrect.

Summary: Firewall rule settings for App fabric caching are disabled.

Cause: Firewall rule settings for App fabric caching are disabled.

Resolution: Enable the firewall rules for the AppFabric Caching service.

  1. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer.

  2. Click Start, Administrative Tools, Windows Firewall with Advanced Security.

  3. In the Windows Firewall with Advanced Security console tree, click Inbound Rules.

  4. In the Inbound Rules list, right-click AppFabric Caching Service (TCP-In), and then select Enable Rule.

  5. In the Windows Firewall with Advanced Security console tree, click Outbound Rules.

  6. In the Outbound Rules list, right-click AppFabric Caching Service (TCP-Out) and then select Enable Rule.

By default, the Repair Automatically option is enabled for this rule. You can restore the default setting for this rule by doing the following:

  1. On the Central Administration website, click Monitoring.

  2. On the Monitoring page, in the Health Analyzer section, click Review rule definitions.

  3. On the Health Analyzer Rule Definitions - All Rules page, in the Category: Configuration section, click the name of the rule.

  4. On the Health Analyzer Rule Definitions page, click Edit Item.

  5. Select the Repair Automatically check box, and then click Save.


Immediate translations for the Machine Translation service are disabled (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Immediate translations for the Machine Translation service are disabled."

Applies to: SharePoint Server 2013

Rule Name: Immediate translations for the Machine Translation service are disabled.

Summary: There are several features in SharePoint 2013 that rely on the Machine Translation Service synchronous translation mode. If immediate translations are disabled, these features don't function correctly.

Cause: Synchronous translations for the Machine Translation service are disabled.

Resolution: Enable synchronous translations for the Machine Translation service.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the list of service applications, click Machine Translation Service.

  4. In the Maximum Synchronous Translation Requests section, type a value that ranges from 1 to 1000 in the Maximum number of synchronous translation requests (per server) text box. A value of 0 indicates that synchronous translations are disabled.


InfoPath form library forms cannot be filled out in a Web browser (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "InfoPath form library forms cannot be filled out in a Web browser."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: InfoPath form library forms cannot be filled out in a Web browser

Summary: InfoPath Forms Services users can publish browser-enabled form templates to a SharePoint 2013 form library but cannot open the forms in a Web browser.

Note:

This issue only applies to forms published to form libraries. It does not apply to list forms or to forms that have been uploaded by farm administrators.

Cause: One or more of the following might be causing this:

  • The Render form templates that are browser-enabled by users check box in Central Administration is cleared.

  • The following Windows PowerShell command has been run: Set-SPInfoPathFormsService -AllowUserFormBrowserRendering $false.

Resolution: Enable browser rendering of user forms by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the Home page, click General Application Settings.

  4. On the General Application Settings page, in the InfoPath Forms Services section, click Configure InfoPath Forms Services.

  5. On the Configure InfoPath Forms Services page, in the User Browser-enabled Form Templates section, select the Render form templates that are browser-enabled by users check box.

  6. Click OK at the bottom of the page.

Resolution: Enable browser rendering of user forms by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPInfoPathFormsService -AllowUserFormBrowserRendering $true

For more information, see Set-SPInfoPathFormsService.


InfoPath Forms Services forms cannot be filled out in a Web browser because no State Service connection is configured (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "InfoPath Forms Services forms cannot be filled out in a Web browser because no State Service connection is configured."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: InfoPath Forms Services forms cannot be filled out in a Web browser because no State Service connection is configured

Summary: InfoPath Forms Services depends on the Web application having a service connection to a State Service Proxy to store data across HTTP requests. Without a service connection, users cannot successfully open or fill browser-enabled InfoPath forms.

Cause: No service connection for the State Service is configured for the Web application that is in the Health Analyzer alert.

Resolution: Configure a service connection by using Central Administration

  1. Verify that the user account performing this procedure is a member of the Farm Administrators group.

  2. If a State Service already exists, you can proceed to step 7.

  3. If a State Service does not exist, you must create one. To do this, in Central Administration, on the home page, click Configuration Wizards.

  4. On the Configuration Wizards page, under Farm Configuration, click Launch Farm Configuration Wizard.

  5. On the Configure your Farm page, click Start the Wizard.

  6. On the next page, ensure that the State Service check box is selected, and then click OK at the bottom of the page.

  7. Complete the wizard to create the State Service.

  8. Associate the State Service with the Web application mentioned in the health analyzer rule. To do this in Central Administration, on the home page, under Application Management, click Manage web applications.

  9. On the Web Applications page, click the Web application for which you want to configure a service connection, and then click Service Connections on the ribbon.

  10. In the Configure Service Application Associations dialog box, ensure that the State Service check box is selected, and then click OK.


More Cache hosts are running in this deployment than are registered with SharePoint (SharePoint 2013)
See also

Published: January 22, 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "More Cache hosts are running in this deployment than are registered with SharePoint."

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Rule Name: More Cache hosts are running in this deployment than are registered with SharePoint.

Summary: Some cache hosts are running but not registered with SharePoint 2013.

Cause: SharePoint 2013 fails to identify some cache hosts.

Resolution: Log on to the cache host that is not registered with SharePoint 2013, and then manually stop the AppFabric Caching Service.

  1. Identify the cache hosts that are not registered with SharePoint 2013. To do this, in the SharePoint Central Administration website, in the Monitoring section, click Review problems and solutions, and then find the name of the server in the Failing Servers list. If there are multiple failing servers in a server farm, you must repeat the following steps on each failing server.

  2. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer.

  3. Click Start, Administrative Tools, Services.

  4. In the Services list, double-click AppFabric Caching Service.

  5. In the AppFabric Caching Service Properties (Local Computer) dialog box, click Stop.

See also

Manage the Distributed Cache service in SharePoint Server 2013
Plan for feeds and the Distributed Cache service in SharePoint Server 2013

Planning and using the Distributed Cache service


One of the cache hosts in the cluster is down (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "One of the cache hosts in the cluster is down."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: One of the cache hosts in the cluster is down.

Summary: One of the cache hosts in the cluster is down. This indicates that the SharePoint cache client is trying to connect to the wrong cache host.

Cause: The AppFabric Caching service is stopped.

Resolution: Start the AppFabric Caching service.

  • Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer.

  • Click Start, Administrative Tools, Services.

  • In the Services list, make sure that the status of AppFabric Caching Service is Started. If not, double-click AppFabric Caching Service.

  • In the AppFabric Caching Service Properties (Local Computer) dialog box, click Start.

By default, the Repair Automatically option is enabled for this rule. You can restore the default setting for this rule by doing the following:

  1. On the Central Administration website, click Monitoring.

  2. On the Monitoring page, in the Health Analyzer section, click Review rule definitions.

  3. On the Health Analyzer Rule Definitions - All Rules page, in the Category: Configuration section, click the name of the rule.

  4. On the Health Analyzer Rule Definitions page, click Edit Item.

  5. Select the Repair Automatically check box, and then click Save.


One or more servers is not responding (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "One or more servers is not responding."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: One or more servers is not responding.

Summary: SharePoint 2013 cannot detect one or more servers in the farm. These servers are managed by the farm, but do not respond.

Cause: The servers are not running, are disconnected from the network, or are physically removed from the farm.

Resolution: Ensure that the servers are running and connected to the network, restart the SharePoint 2010 Timer service (SPTimerV4), or remove the server record from the SharePoint topology.

  • Make sure the SharePoint 2010 Timer service is started. If not, start the service.

    1. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer.

    2. On the Start menu, click Administrative Tools, and then click Services.

    3. In the Services list, make sure the status of SharePoint 2010 Timer is Started. If not, double-click SharePoint 2010 Timer.

    4. In the SharePoint 2010 Timer Properties (Local Computer) dialog box, click Start.

    Alternatively, you can start the SharePoint 2010 Timer service by doing the following on each server that does not respond:

    1. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer.

    2. Open the Command Prompt window, type the following command, and then press ENTER:

      net start SPTimerV4

    For more information about starting the SharePoint 2010 Timer service, see SharePoint Timer service could not start (SharePoint 2010 Products).

  • If the server was intentionally removed from the farm, follow these steps to remove the record of the server from the SharePoint topology in Central Administration.

    1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

    2. On the Central Administration Web site, in the System Settings section, click Manage servers in this farm.

    3. In the Server list, find the server that you want to remove, and then click Remove Server.

    4. In the warning message dialog box, click OK.


One or more web applications are configured to use Windows Classic authentication (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "One or more web applications are configured to use Windows Classic authentication."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: One or more web applications are configured to use Windows Classic authentication.

Summary: This health rule is triggered when at least one Web application is configured to use Windows Classic authentication mode. Windows Classic authentication is deprecated in SharePoint 2013. We recommend that you migrate to claims-based authentication, because many of the features in SharePoint 2013 require the claims-based authentication mode.

Cause: Web applications are configured to use Windows Classic authentication mode.

Resolution: Migrate Web applications from classic mode to claims-based authentication.

  • You have to migrate Web applications from classic mode to claims-based authentication. For more information, see Migrate from classic-mode to claims-based authentication in SharePoint 2013.


People Search relevance is not optimized when the Active Directory has errors in the manager reporting structure (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "People Search relevance is not optimized when the Active Directory has errors in the manager reporting structure".

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: People Search relevance is not optimized when the Active Directory has errors in the manager reporting structure.

Summary: In Active Directory Domain Services (AD DS), only company leaders should have the Manager property set to NULL. If the Manager property is set to NULL for other users, people search relevance is reduced. To optimize people search relevance, explicitly specify company leaders. People search can then use this information to improve relevance.

Cause: Company leaders have not been explicitly specified.

Resolution: Specify company leaders.

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    $upaProxy = Get-SPServiceApplicationProxy <AppID>

    where <AppID> is the GUID of the User Profile service application proxy. For more information, see Get-SPProfileLeader.

  4. Type the following command:

    Copy code
    Add-SPProfileLeader -ProfileServiceApplicationProxy $upaProxy -Name "<Domain\UserName>"

    where <Domain\UserName> is the user account that you want to add as a leader — for example, Contoso\Joe.Healy. For more information, see Add-SPProfileLeader.

  5. You are prompted to confirm. Type Y to confirm.

  6. Run a full crawl on the content source that contains the start address (URL) of the User Profile application. For more information, see Start, pause, resume, or stop a crawl (SharePoint Server 2010).

Repeat the commands to add more user accounts as company leaders.

For more information, see The *-SPProfileLeader Windows PowerShell cmdlets in SharePoint Server 2010 SP1 (http://go.microsoft.com/fwlink/p/?LinkId=226295).


Product / patch installation or server upgrade required (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Product / patch installation or server upgrade required."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Product / patch installation or server upgrade required

Summary: You must install all required products on all servers in the farm, and all products should have the same software update and upgrade level across the farm.

Cause: You have not installed required products or updates, or the server needs to be upgraded.

Resolution: Install software updates and security updates or upgrade the server.

  • Check if there are any pending updates and restart all the servers.

    1. Log on to one server.

    2. Verify that the user account that is performing this procedure is a member of the Administrators group on the local computer.

    3. On the Start menu, click Control Panel, click System and Security, and then click Windows Update. If there are any pending updates or a restart is required, schedule the updates or restart the computer.

    4. Repeat the previous steps on all servers.

    For more information, see Deploy software updates for SharePoint 2013.

  • If a previous upgrade attempt has failed, you must resolve upgrade issues before attempting upgrade again. You can use the Central Administration Web site to find information about current and previous upgrade attempts and determine issues that may be preventing upgrade from succeeding. To do this in Central Administration, in the Upgrade and Migration section, click Check upgrade status. For more information, see Upgrading to SharePoint Server 2010 (http://go.microsoft.com/fwlink/p/?LinkID=224171).


Search - One or more crawl databases may have fragmented indices (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Search - One or more crawl databases may have fragmented indices."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Search - One or more crawl databases may have fragmented indices

Summary: This article describes the SharePoint Health Analyzer rule for Search service application crawl database defragmentation. The fragmentation of crawl data indexes occurs on a different level than regular disk fragmentation. It occurs in each crawl database as data is created, updated, or deleted during normal crawl activity. When you run the health rule, the system makes used storage contiguous, eliminates unused storage, and compacts the database.

We recommend that you run the crawl database rule under the following circumstances:

  • If you are using Microsoft SQL Server 2008 Enterprise. Running the crawl database rule automatically enables the Page Compression feature to optimize I/O and disk storage usage.

  • If significant performance degradation is determined to be caused by crawl database fragmentation. This should be a rare occurrence because crawl databases will usually have some level of fragmentation.

Symptoms: One or more of the following symptoms might appear:

  • Crawl rate may decrease as more time is spent writing crawl history to the crawl database.

  • The crawl database defragmentation health rule is run and attempts to correct the fragmentation. Note: when this rule is correcting the fragmentation, the crawl rate is affected. Crawl rate may decrease as more time is spent writing metadata to the property database.

Cause: Fragmentation exists when indexes have pages in which the logical ordering, based on the key value, does not match the physical ordering inside the data file. All leaf pages of an index contain pointers to the next and the previous pages in the index. This forms a doubly linked list of all index/data pages. Ideally, the physical order of the pages in the data file should match the logical ordering. Overall disk throughput is increased when the physical ordering matches the logical ordering of the data.

For more information about database fragmentation, including how to manually detect and repair fragmented indexes, see the SQL Server documentation.

Resolution: Enable and run the crawl database defragmentation health rule

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. In Central Administration, on the home page, click Monitoring.

  3. On the Monitoring page, in the Health Analyzer section, click Review rule definitions.

  4. On the All Rules page, in the Performance section, click Search - One or more crawl databases may have fragmented indices.

  5. If the rule is not enabled, in the Health Analyzer Rule Definitions dialog, click Edit Item on the ribbon. Ensure that the Enabled check box is selected, and then click Save on the ribbon.

  6. On the ribbon, click Run Now.

  7. Click Close.

The rule iterates over all crawl databases in all Search service applications. When it runs, it attempts to perform an online defragmentation first, and then it switches to offline defragmentation where required. In online defragmentation, only the SQL Server leaf pages are defragmented, not the SQL Server locked pages. In offline defragmentation, the locked pages and all the leaf pages are defragmented.

Note:

In SQL Server 2008 Enterprise, the health rule automatically enables the Page Compression feature to optimize I/O and disk usage.


Some content databases are growing too large (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Some content databases are growing too large."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Some content databases are growing too large

Summary: The content databases have grown larger than 100 gigabytes (GB). Large content databases can be difficult to back up and restore. They are also more likely to cause the application to stop responding when you perform operations that affect entire databases.

Cause: Content databases exceed 100 GB.

Resolution: Edit the rule definition to prevent new sites from being added to these databases, and then move some site collections to other databases.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration Home page, click Monitoring.

  3. On the Monitoring page, in the Health Analyzer section, click Review rule definitions.

  4. On the Health Analyzer Rule Definitions page, in the Availability category, click the name of the rule.

  5. In the Health Analyzer Rule Definitions dialog box, click Edit Item, and then select the Repair Automatically check box.

  6. Click Save. You can no longer add new sites to databases that exceed 100 GB.

  7. Move some site collections to smaller databases. For more information, see Move site collections between databases in SharePoint 2013.


The Application Discovery and Load Balancer Service is not running in this farm (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Application Discovery and Load Balancer Service is not running in this farm."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: The Application Discovery and Load Balancer Service is not running in this farm.

Summary: The Application Discovery and Load Balancer service provides information about the topology of the farm to users who are using services offered by the farm. Users can use this information to perform load balancing. The Application Discovery and Load Balancer Service should be running on at least one server in the farm.

Cause: The Application Discovery and Load Balancer service is stopped.

Resolution: Start the Application Discovery and Load Balancer service on at least one server in the farm.

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Get-SPServiceInstance -ALL

    For more information, see Get-SPServiceInstance.

  4. Find the GUID of the Application Discovery and Load Balancer service.

  5. Type the following command:

    Start-SPServiceInstance [-Identity]

    Where [-Identity] is the GUID for the Application Discovery and Load Balancer service. For more information, see Start-SPServiceInstance.


The InfoPath Forms Services Maintenance Timer Job not enabled (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The InfoPath Forms Services Maintenance timer job is not enabled."

Applies to: SharePoint Server 2013

Rule Name: The InfoPath Forms Services Maintenance timer job is not enabled.

Summary: The InfoPath Forms Services Maintenance timer job is not enabled.

The InfoPath Forms Services Maintenance timer job is used by InfoPath Forms Services to improve performance by caching form template data on each front-end web server.

Cause: The timer job may have been disabled on the Job Definitions page on the SharePoint Central Administration website or the Windows PowerShell Disable-SPTimerJob cmdlet was used.

Resolution: Enable the timer job by using the Central Administration web site

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators SharePoint group.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the home page of the SharePoint Central Administration website, click Monitoring.

  4. Click Review Job definitions.

  5. Click InfoPath Forms Services Maintenance.

  6. Click Enable.

Resolution: Enable the timer job by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Add memberships that are required beyond the minimums above.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Enable-SPTimerJob "<FormsMaintenanceJobDefinition>"

    Where:

    • <FormsMaintenanceJobDefintion> is the actual name of the timer job to enable.

For more information, see Enable-SPTimerJob.


The Machine Translation Service is not running when it should be running (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Machine Translation Service is not running when it should be running."

Applies to: SharePoint Server 2013

Rule Name: The Machine Translation Service is not running when it should be running.

Summary: The Machine Translation Service batch mode uses a timer job to pull translation items from the Machine Translation Service database and then assign those translation items to individual application servers. If the timer job doesn't run, items can't be translated.

Cause: The Machine Translation Service timer job isn't enabled.

Resolution: Enable the Machine Translation Service timer job.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration website, click Monitoring.

  3. On the Job Definitions page, in the list of timer jobs, click Machine Translation Service Timer Job.

  4. On the Edit Timer Job page, in the Recurring Schedule section, specify when you want the timer job to run, and then click Enable.


The number of Distributed Cache hosts in the farm exceeds the recommended value
See also

Published: January 22, 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The number of Distributed Cache hosts in the farm exceeds the recommended value."

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Rule Name: The number of Distributed Cache hosts in the farm exceeds the recommended value.

Summary: On a farm with four or more servers, you must not start the Distributed Cache service on all servers on the farm. If you configure all servers as cache hosts, you may experience reliability and performance problems in the farm.

Cause: The Distributed Cache service is started on every server on this farm

Resolution: Reduce the number of cache hosts by using Windows PowerShell.

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Farm Administrators group.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. Remove one or more servers from the cache cluster. On each server that you want to remove from the cache cluster, run the following cmdlet:

    Remove-SPDistributedCacheServiceInstance

  4. Verify that the server is removed from the cache cluster. To do this, in the SharePoint Central Administration website, click Manage services on server, and then, on the Services on Server page, make sure that the Distributed Cache service is not listed for the server from which you removed the service.

See also

Manage the Distributed Cache service in SharePoint Server 2013
Plan for feeds and the Distributed Cache service in SharePoint Server 2013

Add-SPDistributedCacheServiceInstance
Planning and using the Distributed Cache service


The Security Token Service is not available (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Security Token Service is not available."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: The Security Token Service is not available.

Summary: The Security Token Service is not issuing tokens.

Cause: The service could be malfunctioning or in a bad state, or some assemblies are missing when you deploy the custom claims provider.

Resolution: Restart the Security Token Service application pool.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Identify the server on which this event occurs. On the Central Administration Home site, in the Monitoring section, click Review problems and solutions, and then find the name of the server in the Failing Servers column. If there are multiple failing servers in a server farm, you must repeat the following steps on each failing server.

  3. Verify that the user account that is performing the following steps is a member of the Administrators group on the local computer that you identified in the previous step.

  4. Log on to the server on which this event occurs.

  5. Click Start, click Administrative Tools, and then click Internet Information Services (IIS) Manager.

  6. In the Internet Information Services management console, in the Connections pane, expand the tree view, and then click Application Pools.

  7. In the Application Pools list, right-click SecurityTokenServiceApplicationPool, and then click Start. If the application pool is started already, click Stop and then, in the Action pane, click Start to restart it.

For more information, see Configure the security token service (SharePoint Server 2010) and Set-SPSecurityTokenServiceConfig.

Resolution: Install the missing assemblies into the global assembly cache (GAC) manually.

  1. Check the event logs and ULS logs on all servers to find out which assemblies of the custom claims provider are missing.

  2. Install the missing assemblies into the global assembly cache manually. For more information, see How to: Install an Assembly into the Global Assembly Cache (http://go.microsoft.com/fwlink/p/?LinkId=169102).


The settings for the Machine Translation Service are not within the recommended limits (SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The settings for the Machine Translation Service are not within the recommended limits."

Applies to: SharePoint Server 2013

Rule Name: The settings for the Machine Translation Service are not within the recommended limits.

Summary: The throughput of the Machine Translation Service is limited by system resources on the application server. If the values for translation processes and translation throughput are set too high, the overall health of the application server can decrease, and other services on the computer can be affected. Additionally, the Machine Translation Service can experience decreased throughput and more translation failures.

Cause: The settings for the Machine Translation Service are incorrect.

Resolution: Change the settings for the Machine Translation Service.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the list of service applications, click Machine Translation Service.

  4. In the Translation Processes section, type a value that ranges from 1 to 1000 in the Translation processes box.


The settings for Word Automation Services are not within the recommended limits (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The settings for Word Automation Services are not within the recommended limits."

Applies to: SharePoint Server 2013

Rule Name: The settings for Word Automation Services are not within the recommended limits.

Summary: The throughput of Word Automation Services is limited by system resources on the application server. If the values for conversion processes and conversion throughput are set too high, the overall health of the application server can degrade, and other services on the computer can be affected. Additionally, Word Automation Services can experience decreased throughput and more conversion failures.

Cause: The settings for Word Automation Services are incorrect.

Resolution: Change the settings for Word Automation Services.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration Web site, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the list of service applications, click Word Automation Services.

  4. In the Conversion Processes section, type a value that ranges from 1 to 1000 in the Conversion processes text box.

  5. In the Conversion Throughput section, type a value that ranges from 1 to 59 in the Frequency with which to start conversions (minutes) text box, and a value that ranges from 1 to 1000 in the Number of conversions to start (per conversion process) text box, and then click OK.


The State Service Delete Expired Sessions timer job is not enabled (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The State Service Delete Expired Sessions timer job is not enabled."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: The State Service Delete Expired Sessions timer job is not enabled

Summary: The State Service uses a timer job to delete data for expired sessions from the State Service databases. If this timer job is not enabled, the server that hosts the State Service database will run out of disk space and the SharePoint farm will cease to function

Cause: The State Service Delete Expired Sessions timer job is not enabled.

Resolution: Enable the timer job by using Central Administration

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

    Note:

    The timer job settings are farm-wide and cannot be set for individual servers in the farm.

  2. Start SharePoint 2013 Central Administration.

    • For Windows Server 2008 R2:

      • Click Start, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Central Administration.

        If SharePoint 2013 Central Administration is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Central Administration.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. In Central Administration, on the Home page, click Monitoring.

  4. On the Monitoring page, in the Timer Jobs section, click Review job definitions.

  5. On the Job Definitions page, click the State Service Delete Expired Sessions timer job.

  6. On the Edit Timer Job page, specify the schedule that you want, and then click Enable.

Resolution: Enable the timer job by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      1. On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Enable-SPTimerJob StateServiceExpiredSessionJobDefinition

For more information, see Enable-SPTimerJob.

Note:

We recommend that you use Windows PowerShell when performing command-line administrative tasks. The Stsadm command-line tool has been deprecated, but is included to support compatibility with previous product versions.


The timer service failed to recycle (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The timer service failed to recycle."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: The timer service failed to recycle.

Summary: The last attempt to recycle the timer service failed. More than half of the attempts during the past week have also failed.

Cause: The Timer Service Recycle job conflicts with other long-running timer jobs.

Resolution: Change the schedule for the Timer Service Recycle job so that it does not conflict with other long-running timer jobs.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration Home page, click Monitoring.

  3. On the Monitoring page, in the Timer Jobs section, click Review job definitions.

  4. On the Job Definitions page, click Timer Service Recycle.

  5. On the Edit Timer Job page, change the schedule so that it does not conflict with other long-running timer jobs, and then click OK.

For more information, see Timer job reference (SharePoint 2013).


The unattended Service Account Application ID is not specified or has an invalid value (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Unattended Service Account Application ID is not specified or has an invalid value."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule name: The Unattended Service Account Application ID is not specified or has an invalid value

Summary: The Unattended Service Account Application ID setting stores an application identifier (ID) in the registered Secure Store Service. The application ID is used to reference the Unattended Service Account credentials. The Unattended Service Account is a single, low-privileged account that Visio Graphics Service impersonates when it connects to data sources external to SharePoint 2013, such as SQL Server. This account is required to connect to these external data sources. For more information about Visio Graphics Service, see Plan for Visio Services in SharePoint Server 2013 and Plan Visio Services security in SharePoint Server 2013.

Resolution: Specify a valid application ID value

  1. Verify that the user account that is performing this procedure is an administrator of the Visio Graphics Service service application and the Secure Store Service service application.

  2. In Central Administration, on the Home page, in the Application Management section, click Manage service applications.

  3. On the Service Applications page, click the Secure Store Service service application.

  4. On the Secure Store Service page, record the application ID from the Target Application ID column.

    For more information about the Secure Store Service service application, see Plan the Secure Store Service in SharePoint Server 2013.

  5. On the Service Applications page, click the Visio Graphics service application.

  6. On the Manage the Visio Graphics Service page, click Global Settings.

  7. On the Visio Graphics Service Settings page, in the External Data section, in the Unattended Service Account text box, type the application ID that you recorded in step 4 of this procedure.

  8. Click OK.


The Visio Graphics Service has a maximum cache age setting that will adversely impact performance (SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Visio Graphics Service has a maximum cache age setting that will adversely impact performance."

Applies to: SharePoint Server 2013

Rule Name: The Visio Graphics Service has a maximum cache age setting that will adversely impact performance

Summary: The Visio Graphics Service has a maximum cache age setting that will adversely impact performance. If the Maximum Cache Age setting is longer than 60 minutes it might result in a large memory load of the Visio Graphics Service.

Cause: The Maximum Cache Age setting was set greater than 60 minutes.

Resolution: Reduce the value of the Maximum Cache Age setting

  1. Verify that the user account that is performing this procedure is an administrator of the Visio Graphics Service service application.

  2. In Central Administration, on the Home page, in the Application Management section, click Manage service applications.

  3. On the Service Applications page, click the Visio Graphics service application.

  4. On the Manage the Visio Graphics Service page, click Global Settings.

  5. Ensure that the settings have the values that are listed in the following table. If they do not, type the value in the corresponding text box.

    Setting Value

    Maximum Web Drawing Size

    <= 25 (Megabytes)

    Minimum Cache Age

    >= 5 (Minutes)

    Maximum Cache Age

    <= 60 (Minutes)

    Maximum Recalc Duration

    <= 60 (Seconds)

    Maximum Cache Size

    >= 1024 (Megabytes)

  6. Click OK.


The Visio Graphics Service has a maximum cache size setting that may adversely impact performance ((SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Visio Graphics Service has a Maximum Cache Size setting that will adversely impact performance."

Applies to: SharePoint Server 2013

Rule Name: The Visio Graphics Service has a Maximum Cache Size setting that will adversely impact performance

Summary: The Visio Graphics Service has a maximum Cache size setting that will adversely affect performance. If the Maximum Cache Size setting is smaller than 1024 MB, it might decrease the expected performance of the Visio Graphics Service.

Cause: The Maximum Cache Size setting was set smaller than 1024 MB.

Resolution: Increase the value of the Maximum Cache Size setting

  1. Verify that the user account that is performing this procedure is an administrator of the Visio Graphics Service service application.

  2. In Central Administration, on the Home page, in the Application Management section, click Manage service applications.

  3. On the Service Applications page, click the Visio Graphics service application.

  4. On the Manage the Visio Graphics Service page, click Global Settings.

  5. Ensure that the settings have the values that are listed in the following table. If they do not, type the value in the corresponding text box.

    Setting Value

    Maximum Web Drawing Size

    <= 25 (Megabytes)

    Minimum Cache Age

    >= 5 (Minutes)

    Maximum Cache Age

    <= 60 (Minutes)

    Maximum Recalc Duration

    <= 60 (Seconds)

    Maximum Cache Size

    >= 1024 (Megabytes)

  6. Click OK.


The Visio Graphics Service has a maximum recalculation duration setting that will adversely impact performance ((SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Visio Graphics Service has a maximum recalc duration setting that will adversely impact user perceived performance."

Applies to: SharePoint Server 2013

Rule Name: The Visio Graphics Service has a maximum recalc duration setting that will adversely impact user perceived performance

Summary: The Visio Graphics Service has a maximum recalculation duration setting that will adversely affect performance. If the Maximum Recalc Duration setting is longer than 60 seconds, it might result in large processor load of the Visio Graphics Service and SharePoint 2013, decreasing the expected performance of both.

A shorter duration increases performance by only allowing simple data-connected diagrams to be recalculated by the server, minimizing CPU and memory usage. A longer duration allows the recalculation of more complex data-connected diagrams while using more CPU cycles and memory. The default duration is 60 seconds.

Cause: The Maximum Recalc Duration setting was set longer than 60 seconds.

Resolution: Decrease the value of the Maximum Recalc Duration setting

  1. Verify that the user account that is performing this procedure is an administrator of the Visio Graphics Service service application.

  2. In Central Administration, on the Home page, in the Application Management section, click Manage service applications.

  3. On the Service Applications page, click the Visio Graphics service application.

  4. On the Manage the Visio Graphics Service page, click Global Settings.

  5. Ensure that the settings have the values that are listed in the following table. If they do not, type the value in the corresponding text box.

    Setting Value

    Maximum Web Drawing Size

    <= 25 (Megabytes)

    Minimum Cache Age

    >= 5 (Minutes)

    Maximum Cache Age

    <= 60 (Minutes)

    Maximum Recalc Duration

    <= 60 (Seconds)

    Maximum Cache Size

    >= 1024 (Megabytes)

  6. Click OK.


The Visio Graphics Service has a maximum Web Drawing Size setting that will adversely impact performance (SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Visio Graphics Service has a Maximum Web Drawing Size setting that will adversely impact performance."

Applies to: SharePoint Server 2013

Rule Name: The Visio Graphics Service has a Maximum Web Drawing Size setting that will adversely impact performance

Summary: The Visio Graphics Service has a Maximum Web Drawing Size setting that will adversely affect performance. If the Maximum Web Drawing Size setting is larger than 25 MB, it might result in increased bandwidth usage, decreasing the expected performance of the Visio Graphics Service.

A Web drawing size increases performance by downloading smaller images which, minimizes bandwidth usage.

Cause: The Maximum Web Drawing Size setting was set greater than 25 MB.

Resolution: Decrease the value of the Maximum Web Drawing Size setting

  1. Verify that the user account that is performing this procedure is an administrator of the Visio Graphics Service service application.

  2. In Central Administration, on the Home page, in the Application Management section, click Manage service applications.

  3. On the Service Applications page, click the Visio Graphics service application.

  4. On the Manage the Visio Graphics Service page, click Global Settings.

  5. Ensure that the settings have the values that are listed in the following table. If they do not, type the value in the corresponding text box.

    Setting Value

    Maximum Web Drawing Size

    <= 25 (Megabytes)

    Minimum Cache Age

    >= 5 (Minutes)

    Maximum Cache Age

    <= 60 (Minutes)

    Maximum Recalc Duration

    <= 60 (Seconds)

    Maximum Cache Size

    >= 1024 (Megabytes)

  6. Click OK.


The Visio Graphics Service has a minimum cache age setting that may cause a security issue ((SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Visio Graphics Service has a minimum cache age setting that may cause a security issue."

Applies to: SharePoint Server 2013

Rule Name: The Visio Graphics Service has a minimum cache age setting that may cause a security issue

Summary: Setting Minimum Cache Age to 0 minutes may leave the Visio Graphics Service open to a denial of service (DoS) attack. A value of 0 for this setting might lead to large processor and network load of the Visio Graphics Service and SharePoint 2013, decreasing the expected performance of both. However, increasing this value means that users will not see their data-connected diagrams refreshing as frequently.

Cause: The Minimum Cache Age setting was set to 0 minutes.

Resolution: Increase the value of the Minimum Cache Age setting

  1. Verify that the user account that is performing this procedure is an administrator of the Visio Graphics Service service application.

  2. In Central Administration, on the Home page, in the Application Management section, click Manage service applications.

  3. On the Service Applications page, click the Visio Graphics service application.

  4. On the Manage the Visio Graphics Service page, click Global Settings.

  5. Ensure that the settings have the values that are listed in the following table. If they do not, type the value in the corresponding text box.

    Setting Value

    Maximum Web Drawing Size

    <= 25 (Megabytes)

    Minimum Cache Age

    >= 5 (Minutes)

    Maximum Cache Age

    <= 60 (Minutes)

    Maximum Recalc Duration

    <= 60 (Seconds)

    Maximum Cache Size

    >= 1024 (Megabytes)

  6. Click OK.


The Visio Graphics Service has a minimum cache age setting that will adversely impact performance ((SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "The Visio Graphics Service has a minimum cache age setting that will adversely impact performance."

Applies to: SharePoint Server 2013

Rule Name: The Visio Graphics Service has a minimum cache age setting that will adversely impact performance

Summary: The Visio Graphics Service has a minimum cache age setting that will adversely affect performance. If the Minimum Cache Age setting is shorter than 5 minutes, it might result in large processor and network load of the Visio Graphics Service and SharePoint 2013, decreasing the expected performance of both. However, increasing this value means that users will not see their data-connected diagrams refreshing as frequently.

Cause: The Minimum Cache Age setting was set shorter than 5 minutes.

Resolution: Increase the value of the Minimum Cache Age setting

  1. Verify that the user account that is performing this procedure is an administrator of the Visio Graphics Service service application.

  2. In Central Administration, on the Home page, in the Application Management section, click Manage service applications.

  3. On the Service Applications page, click the Visio Graphics service application.

  4. On the Manage the Visio Graphics Service page, click Global Settings.

  5. Ensure that the settings have the values listed in the following table. If they do not, type the values in the corresponding text boxes, and then click OK.

    Setting Value

    Maximum Web Drawing Size

    <= 25 (Megabytes)

    Minimum Cache Age

    >= 5 (Minutes)

    Maximum Cache Age

    <= 60 (Minutes)

    Maximum Recalc Duration

    <= 60 (Seconds)

    Maximum Cache Size

    >= 1024 (Megabytes)

  6. Click OK.


This Distributed Cache host may cause cache reliability problems (SharePoint 2013)
See also

Published: January 22, 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "This Distributed Cache host may cause cache reliability problems."

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

Rule Name: This Distributed Cache host may cause cache reliability problems

Summary: The Distributed Cache service on this cache host has been stopped but has not been unregistered from the farm. To avoid reliability issues, we recommend that you either start the Distributed Cache service on the server, or remove the cache host from the cache cluster.

Cause: The Distributed Cache service on this Distributed Cache host has been stopped but not unregistered from the farm.

Resolution: Start the Distributed Cache service on the server by using Windows PowerShell.

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Farm Administrators group.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. On the server on which you want to start the Distributed Cache service, type the following command at the Windows PowerShell command prompt:

    Copy code
    Add-SPDistributedCacheServiceInstance

  4. In the SharePoint Central Administration website, click Application Management. In the Service Applications section, click Manage services on server.

  5. On the Services on Server page, verify that the Distributed Cache service is listed and the status is Started.

Resolution: Remove the cache host from the cache cluster by using Windows PowerShell.

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    • Farm Administrators group.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      1. On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      2. Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. Type the following command at the Windows PowerShell command prompt:

    Copy code
    Remove-SPDistributedCacheServiceInstance
    Note:

    This command stops the cache service and nonpersisted cached data will be lost. If you want to keep the cached data, use the graceful shutdown procedure that is described in Manage the Distributed Cache service in SharePoint Server 2013, and then run the Remove-SPDistributedCacheServiceInstance cmdlet. The Remove-SPDistributedCacheServiceInstance cmdlet involves stopping and disabling the underlying AppFabric Caching service. Do not restart the AppFabric Caching service other than by running the Add-SPDistributedCacheServiceInstance cmdlet.

    For more information, see Remove-SPDistributedCacheServiceInstance.

  4. Verify that the server is removed from the cache cluster. To do this, in Central Administration, click Manage services on server, and then, on the Services on Server page, make sure that the Distributed Cache service is not listed.

See also

Plan for feeds and the Distributed Cache service in SharePoint Server 2013

Planning and using the Distributed Cache service


Validate the My Site Host and individual My Sites are on a dedicated Web application and separate URL domain (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Validate the My Site Host and individual My Sites are on a dedicated Web application and separate URL domain."

Applies to: SharePoint Server 2013

Rule Name: Validate the My Site Host and individual My Sites are on a dedicated Web application and separate URL domain.

Summary: For performance and manageability reasons, we recommend that the My Site host and individual My Sites be deployed in a dedicated Web application. The owner of each individual My Site is the site collection administrator for that My Site. Having a dedicated Web application for the My Site host and individual My Sites reduces the security risk that a My Site owner can introduce same-domain scripting attacks on other sites that are hosted on the same Web application.

Cause: The My Site host and individual My Sites are deployed in the same Web application as the root site collection. If the User Profile Service was configured by using the Farm Configuration Wizard, this is how My Sites are set up.

Resolution: Set up a dedicated Web application

  • We recommend that you have a separate, dedicated Web application to host the My Site host and individual My Sites.

    For more information, see Create a web application in SharePoint 2013.


Verify each User Profile service application has a My Site host configured ((SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Verify each User Profile service application has a My Site Host configured."

Applies to: SharePoint Server 2013

Rule Name: Verify each User Profile service application has a My Site Host configured

Summary: Without a My Site host, end-users are not able to use personal sites or people profiles. Therefore, we recommend that if you create a User Profile Service service application, you also create a My Site host for the User Profile Service.

Symptoms: My Sites and other people profile features are not available to users.

Cause: The administrator who created the User Profile Service service application did not also create a My Site host.

Resolution: Verify that a My Site site collection has been created

  • For information about setting up a My Site site collection, see Configure My Sites in SharePoint Server 2013.

Resolution: Associate the My Site host with a User Profile Service service application by using Windows PowerShell

  1. Verify that you have the following memberships:

    • securityadmin fixed server role on the SQL Server instance.

    • db_owner fixed database role on all databases that are to be updated.

    • Administrators group on the server on which you are running the Windows PowerShell cmdlets.

    An administrator can use the Add-SPShellAdmin cmdlet to grant permissions to use SharePoint 2013 Products cmdlets.

    Note:

    If you do not have permissions, contact your Setup administrator or SQL Server administrator to request permissions. For additional information about Windows PowerShell permissions, see Add-SPShellAdmin.

  2. Start the SharePoint 2013 Management Shell.

    • For Windows Server 2008 R2:

      • On the Start menu, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Management Shell.

    • For Windows Server 2012:

      • On the Start screen, click SharePoint 2013 Management Shell.

        If SharePoint 2013 Management Shell is not on the Start screen:

      • Right-click Computer, click All apps, and then click SharePoint 2013 Management Shell.

    For more information about how to interact with Windows Server 2012, see Common Management Tasks and Navigation in Windows Server 2012.

  3. At the Windows PowerShell command prompt, type the following command:

    Copy code
    Set-SPProfileServiceApplication [-Name <UserProfileServiceApplicationName>] -MySiteHostLocation <URL>

    Where:

    • <UserProfileServiceApplicationName> is the friendly name of the User Profile Service service application. If you only have one User Profile Service service application, you do not need to specify the name.

    • <URL> is URL of an empty site collection that has no templates associated with it.


Verify each User Profile Service Application has an associated Managed Metadata Service Connection ((SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Verify each User Profile Service Application has an associated Managed Metadata Service Connection."

Applies to: SharePoint Server 2013

Rule Name: Verify each User Profile Service Application has an associated Managed Metadata Service Connection.

Summary: If the Managed Metadata service is not associated with the User Profile service application, features such as social tagging and properties backed by managed terms do not work.

Cause: The Managed Metadata service connection is not included in the group of connections that is associated with the User Profile service application.

Resolution: Edit the connections for the User Profile service application.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration website, click Application Management.

  3. On the Application Management page, in the Service Applications section, click Configure service application associations.

  4. On the Service Application Associations page, in the View list, click Service Applications.

  5. In the Web Application/Service Application column, click the User Profile service application for which you want to edit the connection.

  6. In the Configure Service Application Associations dialog box, select the Managed Metadata Service check box, or select Default in the Edit the following group of connections list, and then click OK. By default, all connections are included.


Verify each User Profile Service Application has an associated Search Service Connection (SharePoint Server 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Verify each User Profile Service Application has an associated Search Service Connection."

Applies to: SharePoint Server 2013

Rule Name: Verify each User Profile Service Application has an associated Search Service Connection.

Summary: The User Profile service presents URLs to end users in places such as the "What's happening with my network?" Web Part and tag profile pages. These URLs are trimmed for security to make sure that users do not see URLs to which they do not have permissions. The User Profile service uses the Search service to perform this security trimming. If there is no Search service associated with the User Profile service application, security trimming does not work, and URLs are visible to everyone. Although users are denied access when they click a URL for which they do not have permissions, they nonetheless can see the URL in the search results.

Cause: A Search service connection is not included in the group of connections for the User Profile service application.

Resolution: Edit the group of connections for the User Profile service application.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration website, click Application Management.

  3. On the Application Management page, in the Service Applications section, click Configure service application associations.

  4. On the Service Application Associations page, in the View list, click Service Applications.

  5. In the Web Application/Service Application column, click the User Profile service application for which you want to edit connections.

  6. In the Configure Service Application Associations dialog box, select the Search Service check box, or select Default in the Edit the following group of connections list, and then click OK. By default, all connections are included.


Verify that OAuth is configured correctly for the Machine Translation Service application in SharePoint 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Verify that OAuth is configured correctly for the Machine Translation Service application."

Applies to: SharePoint Server 2013

Rule Name: Verify that OAuth is configured correctly for the Machine Translation Service application.

Summary: The Machine Translation Service application that is provisioned on the farm can function correctly only when OAuth is correctly configured.

Cause: OAuth isn't configured correctly for the Machine Translation Service application.

Resolution: Ensure that a default User Profile Service Application proxy exists in the default farm service application proxy group.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration website, click Application Management.

  3. On the Application Management page, in the Service Applications section, click Configure service application associations.

  4. In the Application Proxy Group column, click the proxy group for the Web application or service application that you want to configure. Usually it is the default Application Proxy Group.

  5. Select the User Profile Service Application Proxy check box.


Verify that OAuth is configured correctly for the Machine Translation Service application proxy in SharePoint 2013

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Verify that OAuth is configured correctly for the Machine Translation Service application proxy."

Applies to: SharePoint Server 2013

Rule Name: Verify that OAuth is configured correctly for the Machine Translation Service application proxy.

Summary: The Machine Translation Service application proxy that is provisioned on the farm can function correctly only when OAuth is correctly configured.

Cause: OAuth is not configured correctly for the Machine Translation Service application proxy.

Resolution: Ensure that every Web application with a Machine Translation Service application proxy has a connection to a User Profile service application and an App Management service application, and is in claims-based authentication mode.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration website, click Application Management.

  3. On the Application Management page, in the Service Applications section, click Configure service application associations.

  4. In the Application Proxy Group column, click the proxy group for the Web application or service application that you want to configure. Usually it is the default Application Proxy Group.

  5. Select the User Profile Service Application Proxy check box and the App Management Service Application Proxy check box.

  6. Go back to the Central Administration Home page. In the Application Management section, click Manage web applications.

  7. Click the Web application you want to configure, and then click the Authentication Providers button on the ribbon.

  8. Ensure that the Membership Provider Name for the Default zone is Claims Based Authentication. If not, you have to migrate the Web applications from classic mode to claims-based authentication. For more information, see Migrate from classic-mode to claims-based authentication in SharePoint 2013.


Verify that the Activity Feed Timer Job is enabled (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Verify that the Activity Feed Timer Job is enabled."

Applies to: SharePoint Server 2013

Rule Name: Verify that the Activity Feed Timer Job is enabled.

Summary: You must enable the Activity Feed timer job if you want users to receive information about their colleagues, such as updates to profile properties and creation of social tags and notes.

Cause: The Activity Feed timer job is not enabled.

Resolution: Enable the Activity Feed timer job

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration Web site, on the Quick Launch, click Monitoring.

  3. On the Monitoring page, in the Timer Jobs section, click Review job definitions.

  4. On the Job Definitions page, in the list of timer jobs, click User Profile Service Application - Activity Feed Job.

  5. On the Edit Timer Job page, in the Recurring Schedule section, specify when you want the timer job to run, and then click Enable.


Verify that the critical User Profile Application and User Profile Proxy Application timer jobs are available and have not been mistakenly deleted (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Verify that the critical User Profile Application and User Profile Proxy Application timer jobs are available and have not been mistakenly deleted."

Applies to: SharePoint Server 2013

Rule Name: Verify that the critical User Profile Application and User Profile Proxy Application timer jobs are available and have not been mistakenly deleted.

Summary: User Profile Service Application or User Profile service proxy timer jobs are not available and might have been deleted.

Cause: A required timer job for the User Profile service or the User Profile service proxy is missing.

Resolution: Edit the rule definition so that the configuration is automatically repaired.

  1. On the Central Administration website, click Monitoring.

  2. On the Monitoring page, in the Health Analyzer section, click Review rule definitions.

  3. On the Health Analyzer Rule Definitions - All Rules page, in the Category: Configuration section, click the name of the rule.

  4. In the Health Analyzer Rule Definitions dialog box, click Edit Item.

  5. Select the Repair Automatically check box, and then click Save.

The system automatically creates the missing timer jobs.

For more information, see Timer job reference (SharePoint 2013).


Web Applications using Claims authentication require an update (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Web Applications using Claims authentication require an update."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Web Applications using Claims authentication require an update

Event ID: None

Summary: Web applications that use claims-based authentication are at risk for a potential security vulnerability that might allow users to elevate privileges. Web servers that host Web applications that use claims-based authentication are potentially vulnerable.

Cause: This can happen when you deploy a Microsoft ASP.NET 2.0-based Web application to a Web site that is hosted on a server running SharePoint 2013 and you have Internet Information Services (IIS) 7.0 or IIS 7.5 running in Integrated mode on the server.

If you deploy partially trusted Web Parts or create external lists on the SharePoint site, these Web Parts or external lists can have more permissions than they should have. This issue might create a security risk on the SharePoint site. For example, these Web Parts or external lists may unexpectedly generate database requests or HTTP requests.

This issue occurs because of a change in the ASP.NET 2.0 authentication component. The change causes the partially trusted Web Parts or external lists to impersonate the application pool account. Therefore, the Web Parts have full permission to access the SharePoint site.

Resolution: Install the update

  • To download the update, go to KB979917 - QFE for SharePoint issues - Perf Counter fix & User Impersonation.

  • For more information about update, see Knowledge Base article 979917.


Web.config file has incorrect settings for the requestFiltering element (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Web.config file has incorrect settings for the requestFiltering element."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Web.config file has incorrect settings for the requestFiltering element.

Summary: To support file names that contain the + character, the requestFiltering element in the Web.config file must have the allowDoubleEscaping attribute set to True and it must have a requestLimits element that has a maxAllowedContentLength value set to 2147483647 to avoid interfering with file upload.

Cause: The settings of the requestFiltering element in the Web.config file are incorrect.

Resolution: Change the requestFiltering settings in the Web.config file in Internet Information Services (IIS).

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Identify the server on which this event occurs. On the Central Administration Web site, in the Monitoring section, click Review problems and solutions, and then find the name of the server in the Failing Servers column. If there are multiple failing servers in a server farm, you must repeat the following steps on each failing server.

  3. Verify that the user account that is performing the following steps is a member of the Administrators group on the local computer that you identified in the previous step.

  4. Log on to the server on which this event occurs.

  5. Click Start, click Administrative Tools, and then click Internet Information Services (IIS) Manager.

  6. In the Internet Information Services management console, in the Connections pane, expand the tree view of the server name, expand Sites, and then click the site for which you want to change the requestFiltering settings.

  7. On the site Home page, switch to Features View, and then in the Management section, double-click Configuration Editor.

  8. In the Section list, expand system.webServer, expand security, and then click requestFiltering.

  9. On the Configuration Editor page, ensure the following attributes or elements exist and are configured correctly:

    • The allowDoubleEscaping attribute is set to True.

    • The requestLimits element exists.

    • The requestLimits element has a maxAllowedContentLength attribute and its value is set to 2147483647.

    For more information, see How to: Add and Remove Web.config Settings Programmatically (http://go.microsoft.com/fwlink/p/?LinkId=227014).

  10. After you have made changes to these settings, in the Actions pane, click Apply.


Web.config files are not identical on all machines in the farm (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "Web.config files are not identical on all machines in the farm."

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

Rule Name: Web.config files are not identical on all machines in the farm.

Summary: If you have multiple front-end Web servers in the farm and have made manual changes to the Web.config files, you will experience a problem where a front-end Web server cannot read session state that was saved by another server in the farm.

Cause: The Web.config files on the front-end Web servers in the farm are not identical.

Resolution: Ensure that the Web.config files are identical on all front-end Web servers in the farm.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. Identify the server on which this event occurs. On the Central Administration website, in the Monitoring section, click Review problems and solutions, and then find the name of the server in the Failing Servers column. If there are multiple failing servers in a server farm, you must repeat the following steps on each failing server.

  3. Verify that the user account that is performing the following steps is a member of the Administrators group on the local computer that you identified in the previous step.

  4. Log on to the server on which this event occurs.

  5. Typically the Web.config file is stored at C:\inetpub\wwwroot\wss\VirtualDirectories\Port_Number. Note the modified date of the Web.config file.

  6. Repeat the previous steps on other failing servers.

  7. Compare these Web.config files and decide which one is correct. To view the content of the Web.config file, do the following:

    1. Click Start, click Administrative Tools, and then click Internet Information Services (IIS) Manager.

    2. In the Internet Information Services management console, in the Connections pane, expand the tree view of the server name, expand Sites, and then click the site for which you want to view the settings of the Web.config file.

    3. On the site Home page, switch to the Features View, and then in the Management section, double-click Configuration Editor.

    4. In the Section list, select a section to view the settings of the Web.config file.

  8. Delete the incorrect Web.config file on each failing server, and then copy and paste the correct Web.config file.

For more information, see Working with Web.config Files (http://go.microsoft.com/fwlink/p/?LinkId=149266).

By default, the Repair Automatically option is enabled for this rule. You can restore the default setting for this rule by doing the following:

  1. On the Central Administration Web site, click Monitoring.

  2. On the Monitoring page, in the Health Analyzer section, click Review rule definitions.

  3. On the Health Analyzer Rule Definitions - All Rules page, in the Category: Configuration section, click the name of the rule.

  4. In the Health Analyzer Rule Definitions dialog box, click Edit Item.

  5. Select the Repair Automatically check box, and then click Save.


XLIFF translations for the Machine Translation Service is disabled (SharePoint 2013)

Summary: Learn how to resolve the SharePoint Health Analyzer rule "XLIFF translation for the Machine Translation Service is disabled."

Applies to: SharePoint Server 2013

Rule Name: XLIFF translation for the Machine Translation Service is disabled.

Summary: There are several features in SharePoint 2013 that rely on the Machine Translation Service processing the XLIFF file format. If the .xlf extension is disabled, these features don't function correctly.

Cause: The .xlf file name extension is disabled for the Machine Translation Service.

Resolution: Enable the .xlf file name extension for the Machine Translation Service.

  1. Verify that the user account that is performing this procedure is a member of the Farm Administrators group.

  2. On the Central Administration website, in the Application Management section, click Manage service applications.

  3. On the Manage Service Applications page, in the list of service applications, click Machine Translation Service.

  4. In the Enabled File Extensions section, select the check box for the .xlf file name extension under the XLIFF Parser.


Timer job reference (SharePoint 2013)

Published: January 22, 2013

Summary: Learn about the timer jobs in SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

This article describes the default timer jobs for SharePoint 2013. A timer job runs in a specific Windows service for SharePoint 2013. Timer jobs perform infrastructure tasks for the Timer service, such as clearing the timer job history and recycling the Timer service. Timer jobs also perform tasks for web applications, such as sending email alerts. A timer job contains a definition of the service to run and specifies how frequently the service is started. The SharePoint Timer service (SPTimerv4) runs timer jobs. Many features in SharePoint 2013 rely on timer jobs to run services according to a schedule.

In this article:

  • Manage timer jobs

  • Default timer jobs

Manage timer jobs

the SharePoint Central Administration website has a Timer Job Status page on which you can check the status of a timer job and a Job Definitions page on which you can edit the timer job definition. You can find links to these pages in Central Administration, on the Monitoring page, in the Timer Jobs section. You can click Review job definitions to see a list of all timer jobs, or click Check job status to see scheduled and running timer jobs.

On the Timer Job Status page, on the View menu, you can filter the timer jobs at the following levels:

  • All Displays all timer jobs for the farm.

  • Service Displays all the timer jobs for a particular service. If you select this option, use the Service menu to select the service by which you want to filter the listed jobs.

  • Web Application Displays all the timer jobs for a web application. If you select this option, use the Web Application menu to select the web application by which you want to filter the listed jobs.

  • Server Displays all the timer jobs for the specified server. If you select this option, use the Server menu to select the server by which you want to filter the listed jobs.

  • Job Definition Displays all the timer jobs for the specified job definition. On the Timer Job Status page, open the Job Definition menu, and then click Change Job Definition to get a list of job definitions.

  • Failed Jobs Displays all the timer jobs on the farm that failed to finish.

The SharePoint Timer service (SPTimerv4) is based on the Gregorian calendar for scheduling. For every job that you schedule, you specify when the timer job will run, specified in a 24-hour time format. You must specify the time in local time instead of as an offset from Coordinated Universal Time (UTC). The time is stored in that format. By default, daily, weekly, and monthly schedules also include a window of execution. The timer service selects a random time within the window of execution interval to start the job on each applicable server. This capability helps to reduce the overall load of resource-intensive timer jobs that run on multiple servers on the farm. You can specify timer job schedules on the Edit Timer Job page or by using Windows PowerShell. For more information, see Use Windows PowerShell cmdlets to manage timer jobs in SharePoint 2013.

Default timer jobs

The following table lists the default timer jobs for SharePoint 2013.

Timer job Description Default schedule

Access Services monitor

Monitors the connectivity of Access Services on SharePoint Online and SQL Azure.

5 minutes

Analytics Event Store Retention

Periodically cleans up the Event Store and the Reporting Database. All data older than 14 days is removed from the Event Store whereas all data older than 3 years is removed from the Reporting Database.

Weekly

Analytics for Search service application

Periodically schedules analytics for the Search service application.

10 minutes

App installation service

Installs and uninstalls apps.

5 minutes

App state update

Retrieves and applies updated information on apps from the SharePoint Store. It includes the availability of updates and information about disabled apps.

Hourly

Application addresses refresh

Synchronizes connection information for remote service applications.

15 minutes

Application server

Manages shared service instances that do not perform highly privileged operations. The Search service instance is managed by this job on stand-alone server deployments.

1 minute

Application server administration service

Manages shared service instances that may perform highly privileged operations. Requires that the SharePoint Administration service is running. The Search service instance is managed by this job on deployments other than stand-alone server deployments.

1 minute

Audit log trimming

Trims audit trail entries from site collections.

Monthly

Autohosted app instance counter

Counts the number of autohosted app instances per site subscription.

Weekly

Bulk workflow task processing

Processes bulk workflow task completion.

Daily

CEIP data collection

Collects farm data for the Customer Experience Improvement Program.

Daily

Cell storage data cleanup

Deletes temporary cell storage data and frees SQL Server disk space.

Daily

Change log

Records many types of changes that you make to SharePoint sites. Removes expired entries from the change log of the web application.

Weekly

Content organizer processing

Processes documents in the drop-off library that match organizing rules.

Daily

Content type hub

Tracks content type log maintenance and manages unpublished content types.

Daily

Content type subscriber

Retrieves content type packages from the hub and applies them to the local content type gallery. For more information about content types, see Plan to share term sets and content types in SharePoint Server 2013.

Hourly

Crawl log cleanup for Search service application

Performs crawl log cleanup for Search service applications.

Daily

Create upgrade evaluation site collections

Creates upgrade evaluation site collections.

Daily

Dead site delete

When auto site cleanup is enabled, sites that are not used in a certain period of time are deleted.

Weekly

Delete job history

Deletes old entries from the timer job history.

Weekly

Delete upgrade evaluation site collections

Deletes upgrade evaluation site collections that are past their expiry date and sends notifications to those that are near expiry date.

Daily

Diagnostic data provider: app usage

Periodically collects App statistics.

Daily

Diagnostic data provider: event log

Collects Windows Event Log entries and stores the data in the logging database.

10 minutes

Diagnostic data provider: IO intensive SQL queries

Collects a SQL trace of I/O intensive SQL queries.

1 minute

Diagnostic data provider: per-database IO

Collects I/O statistics for each database file.

2 minutes

Diagnostic data provider: performance counters - database servers

Collects Performance Monitor Counters data on database servers and stores the data in the logging database.

Important:

The timer service account must have sufficient permission to collect counters on the database server. The account should be a member of the Performance Monitor Users (PMU) group.

1 minute

Diagnostic data provider: performance counters - web front ends

Collects performance monitor counters data on front-end Web servers and stores the data in the logging database.

1 minute

Diagnostic data provider: site size

Collects size data for each site collection.

Daily

Diagnostic data provider: SQL blocking queries

Collects data associated with blocked SQL queries and stores the data in the logging database.

15 seconds

Diagnostic data provider: SQL blocking reports

Captures the text of any queries that cause SQL blocking.

1 minute

Diagnostic data provider: SQL deadlocks

Captures the call graphs of SQL deadlocks.

1 minute

Diagnostic data provider: SQL DMV

Collects SQL Dynamic Management Views (DMV) data and stores the data in the logging database.

30 minutes

Diagnostic data provider: SQL memory DMV

Collects SQL Dynamic Management Views (DMV) data and stores the data in the logging database.

15 seconds

Diagnostic data provider: trace log

Collects trace log entries and stores the usage data in the logging database.

10 minutes

Disk quota warning

Looks for sites that have exceeded the storage quota, and sends out disk quota warning email notifications.

Weekly

Document ID assignment

Work item that assigns document ID to all items in the site collection.

Daily

Document ID enable/disable

Work item that propagates content type changes across all sites when the Document ID feature is reconfigured.

Daily

Document Set fields synchronization

Synchronizes metadata from the document set to the items inside the document library.

15 minutes

Document Set template update

Propagates changes that are made to the document set template to the existing items.

Hourly

eDiscovery in-place hold processing

The in-place hold timer job starts and releases the holds of SharePoint websites.

Hourly

Education bulk operation

Carries out the education bulk operations.

Hourly

Enterprise Metadata site data update

Updates all site collections after a language pack addition or an Enterprise Metadata service application restore.

Hourly

Expiration policy

Enumerates list items and looks for those with an expiration date that has already occurred. For those items, runs disposition processing. Disposition processing most often results in deleting items. But it can perform other actions, such as processing disposition workflows.

Weekly

Gradual site delete

Deletes all the data from the host content database for all deleted site collections.

Daily

Health analysis (Daily, Central Administration, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run the Central Administration web application and the Usage and Health Data Collection service application.

Daily

Health analysis (Daily, Central Administration, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the Central Administration web application and the Usage and Health Data Collection service application.

Daily

Health analysis (Daily, Machine Translation service, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run the Machine Translation service application and the Usage and Health Data Collection service application.

Daily

Health Analysis (Daily, Machine Translation service, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the Machine Translation service application and the Usage and Health Data Collection service application.

Daily

Health Analysis (Daily, Microsoft SharePoint Foundation Timer, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run the SharePoint Timer Service and the Usage and Health Data Collection service application.

Daily

Health Analysis (Daily, Microsoft SharePoint Foundation Timer, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the SharePoint Timer Service and the Usage and Health Data Collection service application.

Daily

Health Analysis (Daily, Microsoft SharePoint Foundation web application, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run SharePoint web applications and the Usage and Health Data Collection service application.

Daily

Health Analysis (Daily, Microsoft SharePoint Foundation web application, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs SharePoint web applications and the Usage and Health Data Collection service application.

Daily

Health Analysis (Daily, User Profile service, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the User Profile service application and the Usage and Health Data Collection service application.

Daily

Health Analysis (Daily, Visio Graphics service, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs Visio Services in SharePoint Server 2013 and the Usage and Health Data Collection service application.

Daily

Health Analysis (Daily, Word Automation Services, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run Word Automation Services and the Usage and Health Data Collection service application.

Daily

Health Analysis (Hourly, distributed cache, all servers)

Runs SharePoint Health Analyzer jobs on all servers that run the Distributed Cache service.

Hourly

Health Analysis (Hourly, Microsoft SharePoint Foundation Timer, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run the SharePoint Timer Service and the Usage and Health Data Collection service application.

Hourly

Health Analysis (Hourly, Microsoft SharePoint Foundation Timer, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the SharePoint Timer Service and the Usage and Health Data Collection service application.

Hourly

Health Analysis (Hourly, Security Token Service, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run the Security Token Service (STS) and the Usage and Health Data Collection service application.

Hourly

Health Analysis (Hourly, User Profile service, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the User Profile service and the Usage and Health Data Collection service application.

Hourly

Health Analysis (Hourly, Word Automation Services, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs Word Automation Services and the Usage and Health Data Collection service application.

Hourly

Health Analysis (Monthly, Microsoft SharePoint Foundation Timer, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the SharePoint Timer Service and the Usage and Health Data Collection service application.

Monthly

Health Analysis (Monthly, User Profile Service, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the User Profile Service and the Usage and Health Data Collection service application.

Monthly

Health Analysis (Weekly, Central Administration, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run the Central Administration website and the Usage and Health Data Collection service application.

Weekly

Health Analysis (Weekly, Microsoft SharePoint Foundation Timer, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run the SharePoint Timer Service and the Usage and Health Data Collection service application.

Weekly

Health Analysis (Weekly, Microsoft SharePoint Foundation Timer, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the SharePoint Timer Service and the Usage and Health Data Collection service application.

Weekly

Health Analysis (Weekly, Microsoft SharePoint Foundation web application, all servers)

Runs SharePoint Health Analyzer jobs on all servers in the farm that run SharePoint web applications and the Usage and Health Data Collection service application.

Weekly

Health Analysis (Weekly, User Profile service, any server)

Runs SharePoint Health Analyzer jobs on the first server found in the farm that runs the User Profile service and the Usage and Health Data Collection service application.

Weekly

Health statistics updating

Updates the statistics for the Usage and Health Data Collection service application.

1 minute

Hold processing and reporting

Generates a hold report by enumerating items in a hold and updating them to remove them from hold, as appropriate.

Daily

Immediate Alerts

Sends out immediate and scheduled alerts.

5 minutes

Indexing schedule manager on SQL Server

Starts scheduled crawls.

5 minutes

InfoPath Forms Services maintenance

Performs maintenance operations on administrator-approved InfoPath Forms Services form templates across all front-end Web servers.

Daily

Information management policy

Performs background processing for information policies, such as calculating updated expiration dates for items with a new retention policy.

Weekly

Internal app state update

Retrieves and applies updated information on apps from App Catalogs.

Hourly

License renewal

Renews all licenses of the apps from the SharePoint Store.

Hourly

Licensing synchronizer

Synchronizes trial expiration time licensing information to the configuration database.

Hourly

Machine Translation Service - Language Support

Updates the languages available to the Machine Translation Service.

Weekly

Machine Translation Service - Machine Translation Service

Initiates translation of documents that were submitted to the Machine Translation Service for asynchronous translation.

15 minutes

Machine Translation Service - Remove Job History

Removes the history for expired jobs from the Machine Translation Service queue database.

Weekly

Microsoft SharePoint Foundation Usage Data Import

Imports usage log files into the event store.

5 minutes

Microsoft SharePoint Foundation Usage Data Processing

Checks for expired usage data at the farm level and deletes the data. Expired usage data consists of records in the central usage data collection database that are older than 30 days.

Daily

My Site cleanup

Starts a workflow on a deleted user's My Site. The default behavior is to send an email message to the manager with a link to the deleted user's site. The email message contains a request to the manager to move any documents or data that the manager wants to preserve, because the site might be deleted in the future.

Daily

My Site instantiation interactive request queue

A timer job queue for interactive (web initiated) My Site instantiation requests.

1 minute

My Site instantiation non-interactive request queue

A timer job queue for non-interactive (Office-client initiated) My Site instantiation requests.

1 minute

My Site second instantiation interactive request queue

A second timer job queue for interactive (web initiated) My Site instantiation requests.

1 minute

Notification

Queries and updates the notification list and sends out pending scheduling notifications.

Daily

Password management

Sends email and logs events for expiring passwords and password changes. This timer job helps ensure that managed passwords are changed before they expire.

Daily

Performance metric provider

Collects the performance metrics data.

1 minute

Persisted navigation term set synchronization

Synchronizes the persisted copy of navigation term sets.

Hourly

Prepare query suggestions

Prepares candidate queries for query suggestion and performs pre-computations for result block ranking.

Daily

Product version

Checks the installation status of the computer and adds that data to the database.

Daily

Project Server: database maintenance job for Project Service Application

Performs routine maintenance on the Project Server database including defragmenting the indexes and updating the database usage.

Daily

Project Server: product feedback job for Project Service Application

Collects statistical data on the usage, reliability and performance of Project Server features and sends this information to Microsoft to be used to improve the product in future releases.

Daily

Project Server: Project Web App provisioning job for Project Service Application

Provisions new instances of Project Server.

Monthly

Project Server: Queue maintenance job for Project Service Application

Purges older Project Server queue jobs to maintain the performance of the Project Server queue.

Daily

Project Server: queue service health job for Project Service Application

Monitors the health of Queue service instances and takes corrective action when it is required.

5 minutes

Project Server: resource capacity refresh job for Project Service Application

Refreshes the resource capacity information in Project Web App reporting.

Daily

Project Server: synchronization of SharePoint Server permissions to Project Web App permissions job for Project Service Application

Synchronizes SharePoint Server permissions to Project Web App.

1 minute

Project Server: task list synchronizer for SharePoint Tasks List Projects job for Project Service Application

Updates Project Server with the latest changes from connected SharePoint Server Project Task Lists.

5 minutes

Project Server: workflow maintenance job for Project Service Application

Maintains the health of Project Server workflows. It resolves issues between Enterprise Project Templates and workflows, updates the status of workflows, and closes completed workflows.

Daily

Project Web App: Shared Service

Enables per-instance Project Web App jobs to be managed.

1 minute

Query classification dictionary update for Search service application.

Periodically updates dictionary that is used for query classification.

30 minutes

Query logging

Updates query and click logs by inserting new entries and deleting old entries.

15 minutes

Recycle Bin

Looks for content in the Recycle Bins and moves it to the next stage or deletes it.

Weekly

Scheduled Approval

Looks for content that is scheduled for approval and moves it to the next stage in the process.

1 minute

Scheduled Unpublish

Looks for content that is scheduled to be unpublished and removes it.

1 minute

Search and process

Processes a search result that is scoped to a site collection and puts search results on hold.

Daily

Search change log generator

Generates appropriate change logs when SharePoint items change. This is required for search to function correctly.

5 minutes

Search custom dictionaries update

Updates the custom dictionaries used for search. These include custom dictionaries for company extraction and for query spelling correction.

10 minutes

Search engine sitemap

Generates search engine sitemaps and updates robots.txt.

Daily

Search health monitoring - trace events

Runs to check the events that are being traced for search health monitoring.

1 minute

SharePoint BI maintenance

Deletes temporary dashboard objects and user-persistent filter values from the database. The longevity of these values can be set on the PerformancePoint Services Settings page.

Hourly

Site policy and Exchange site mailbox policy update

Updates Exchange site mailboxes with the site policy of the associated SharePoint site.

Daily

Solution daily resource usage update

Marks the daily boundary for sandboxed solution resource quota monitoring.

Daily

Solution resource usage log processing

Aggregates resource usage data from sandboxed solution execution.

5 minutes

Solution resource usage update

Records resource usage data from sandboxed solution execution, and sends email to owners of site collections that are exceeding their allocated resource quota.

15 minutes

Spelling customizations upgrade

Upgrades user spelling customizations from the previous SharePoint version to this version. This job will run on schedule until it succeeds with the upgrade and then be set to disabled. If there are no spelling customizations to upgrade, it will be set to disabled after the first run.

Hourly

Spelling dictionary update

Updates the dynamic dictionary that is used to correct the spelling of queries with changes in the indexed content.

Note:

This is a time-consuming operation. Do not schedule it to run more frequently than one time per day.

Daily

State Service delete expired sessions

Deletes expired data that is stored in the state service databases.

Hourly

Storage metrics processing

Processes storage metrics changes for site collections.

5 minutes

Taxonomy update scheduler

Updates site collections with the latest term changes that were made to the Enterprise Metadata service.

Hourly

Timer service recycle

Recycles the Timer service to free resources.

Daily

Translation Export Job Definition

Exports page and list content to XLIFF for human translation or machine translation via the Machine Translation Service.

15 minutes

Translation Import Job Definition

Imports translated page and list content from XLIFF to correct location in a site collection.

15 minutes

Upgrade site collections

Upgrades site collections in a content database.

1 minute

Upgrade work item

Processes deferred upgrade work items which were generated during an upgrade. For example, generating thumbnails for upgraded image libraries.

Daily

Usage Analytics for Search service application

Periodically schedules processing of the Usage Analytics analysis.

10 minutes

User Profile service application - activity feed

Pre-computes activities to be shown in users' activity feeds.

10 minutes

User Profile service application - activity feed cleanup

Cleans up pre-computed activities that are used in activity feeds that are older than 14 days. This job does not affect the User Profile change log.

Daily

User Profile service application - audience compilation

Computes memberships of defined audiences.

Weekly

User Profile service application - My Site suggestions email

Sends email messages that contain colleague and keyword suggestions to people who do not update their profiles often.

Monthly

User Profile service application - social data maintenance

Aggregates social tags and ratings and cleans the social data change log.

Hourly

User Profile service application - system job to manage user profile synchronization

Manages provisioning and runs additional tasks that are related to User Profile Synchronization.

Note:

Do not change the information or frequency of this job. If you have to change how often incremental synchronization is performed, in Central Administration, go to the Manage User Profile Service Application page, and then in the Synchronization category, click Schedule Incremental User Profile Synchronization.

1 minute

User Profile service application - user profile change

Processes changes to user profiles. Changes the user profile. User rights can be migrated from one user to another user. This timer job is used when a user has to be migrated. But the previous user profile remains in AD DS.

Hourly

User Profile service application - user profile change cleanup

Cleans up data that is 14 days old from User Profile change log. Migrates user rights from one user to another user, and migrates the user rights and removes that user from Active Directory Domain Services (AD DS). This is mainly used when the name of a user is changed in AD DS. The older user name is replaced by a new user name, and the older one is removed from AD DS.

If you want to change retention settings, see the Profilechangelog: Stsadm operation in Stsadm to Windows PowerShell mapping in SharePoint 2013.

Daily

User Profile service application - user profile incremental synchronization

Runs at the specified interval to synchronize user, group and group membership changes between the User Profile service application and specified directory source (such as AD DS or Lightweight Directory Access Protocol (LDAP)). Synchronization will look for changes since the last time this job was run and only perform these changes for AD DS and LDAP sources.

Note:

Do not change the settings or frequency of this timer job. To change the schedule for incremental synchronization, see Schedule profile synchronization in SharePoint Server 2013.

Daily

User Profile service application - user profile language synchronization

Looks for new language pack installations and makes sure that strings that relate to the user profile service are localized correctly.

Hourly

User Profile service application proxy - feed cache repopulation

Handles the repopulation of feed cache.

5 minutes

User Profile service application proxy - social rating synchronization

Synchronizes rating values between the social database and content database.

Hourly

User Profile service application proxy - User Profile to SharePoint full synchronization

Synchronizes user information from the User Profile service application to SharePoint users and synchronizes site memberships from SharePoint to the User Profile service application.

Hourly

User Profile service application proxy - User Profile to SharePoint language and region synchronization

Synchronizes language and region information from the User Profile service application to SharePoint users.

1 minute

User Profile service application proxy - User Profile to SharePoint quick synchronization

Synchronizes user information from the User Profile service application to SharePoint users who were recently added to a site.

5 minutes

Variations create hierarchies job definition

Creates a complete variations hierarchy by spawning all sites and pages from the source site hierarchy for all variation labels.

Hourly

Variations propagate list items job definition

Propagates list items to variant sites.

15 minutes

Variations propagate page job definition

Creates or updates peer pages of the source page that was approved or published in all target labels. The resulting peer pages are in an unpublished state.

15 minute

Variations propagate sites and lists

Creates variant sites when the Variations Automatic Creation setting is enabled.

30 minute

Video query rule provisioner

Provisions video query rule for a site when the Search service application becomes available.

Daily

Word Automation Services

Processes and distributes queued conversion job items to application servers.

15 minutes

Word Automation Services - Remove Job History

Removes the history for expired jobs from Word Automation Services.

Weekly

Work Management synchronize with Exchange

Triggers Exchange Sync operations for the Work Management service.

1 minute

Workflow

Processes workflow events that are in the scheduled items table, such as delays.

5 minute

Workflow auto cleanup

Deletes tasks and instances in the workflow instance table for workflows that were marked completed more than n days in the past, where n is specified in the workflow association. Crawls through tasks and the workflow instance table.

Daily

Workflow failover

Processes events for workflows that have failed and are marked to be retried.

15 minute


Database types and descriptions (SharePoint 2013)
See also

Updated: May 14, 2013

Summary: Learn about sizing and location information about the databases that support SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

This article describes the databases that are installed for SharePoint 2013. Each database description includes information about sizing and placement.

Databases for SharePoint 2013 can be hosted in SQL Server 2008 R2 with Service Pack 1 (SP1) or SQL Server 2012. For more information see Hardware and software requirements for SharePoint 2013.

All database names that are listed in this article are automatically created when you run the SharePoint Products Configuration Wizard. You do not have to use these naming conventions. You can either specify your own database names when you create them or change the names after they are created. For more information, see Rename service application databases in SharePoint 2013

The database sizes listed in this article are based on the following ranges.

Descriptor | Size range
Very Small | Up to 100 megabyte (MB)
Small | 1 gigabyte (GB) or less
Medium | Up to 100 GB
Large | Up to 1 terabyte
Extra-large | More than 1 terabyte

In this article:

  • SharePoint 2013 databases

  • SharePoint Server 2013 databases

  • SQL Server system databases

  • SQL Server Reporting Services databases

For a graphical overview of the databases that support SharePoint 2013, see Database model.

SharePoint 2013 databases

The following databases are part of all SharePoint 2013 deployments. These databases are installed when any SharePoint 2013 edition is deployed. The Configuration, Central Administration Content, and Content databases are the 3 databases that are automatically installed when you deploy SharePoint 2013.

Configuration

The configuration database contains data about the following:

  • SharePoint databases

  • Internet Information Services (IIS) web sites

  • Web applications

  • Trusted solutions

  • Web Part packages

  • Site templates

  • Web applications

The configuration database also contains specific data for SharePoint 2013 farm settings, such as default quota settings and blocked file types.

Configuration database

Category | Description
Default database name when it is installed with the SharePoint Products Configuration Wizard | SharePoint_Config
Location requirements | Must be co-located with the Central Administration database
General size information and growth factors | Small Transaction log files that are stored in the configuration database are likely to become large. For more information, see Additional notes.
Read/write characteristics | Read-intensive
Recommended scaling method | Must scale-up because only one configuration database is supported per farm. (Significant growth is unlikely.)
Associated health rules | None
Supported backup tools | SharePoint 2013 backup and restore, SQL Server, and System Center 2012 - Data Protection Manager (DPM). Backing up and restoring the configuration databases is special because of the transaction log. For more information, see Additional notes.
Default recovery model | Full. We recommend that you switch the configuration database to the simple recovery model to restrict growth of the log file.

Additional notes

Transaction log files. We recommend that you back up the transaction log for the configuration database regularly to force truncation. If you are mirroring your system, then change the database to run in Simple recovery mode. For more information, see Transaction Log Truncation.

Backup and Restore. The configuration database is backed up when you perform a SharePoint farm configuration and content backup. Note that some configuration settings from the database are exported and stored as XML file. When a farm is restored, the configuration database is not restored. Instead, the saved configuration settings are imported. The configuration database can be successfully backed up and restored by using SQL Server or other tools if the SharePoint farm is first taken offline.

Note:

Many configuration settings are not saved during a farm configuration-only backup or restore. These configuration settings may include particular Web application settings, service application settings, and settings that are specific to the local server. These settings are saved during a farm content and configuration backup. But some of them, such as service application proxy settings, cannot be restored during a farm recovery. For information about what is saved during a configuration backup, see Back up farm configurations in SharePoint 2013. For information about how to document and copy configuration settings that are not backed up, see Copy configuration settings between farms in SharePoint 2013.

Central Administration content

The Central Administration content database is considered to be a configuration database. It stores all configuration data for the Central Administration site collection. If SQL Server 2012 Power Pivot for SharePoint 2013 is installed, the Central Administration content database also stores the Excel worksheets and Power Pivot data files used in the Power Pivot Management Dashboard. Note that Power Pivot for SharePoint 2013 can only be installed on SharePoint Server 2013.

Central Administration content database

Category | Description
Default database name prefix when it is installed by using the SharePoint Products Configuration Wizard | SharePoint_Admin_Content
Location requirements | Must be located on the same database engine instance with the configuration database.
General size information, and growth factors | Small If you use Power Pivot for SharePoint 2013 and use the default settings that keep usage data collection and data refresh history for 365 days, the Central Administration content database will grow over the span of one year. For more information about Power Pivot for SharePoint 2013, see Plan a PowerPivot Deployment in a SharePoint Farm.
Read/write characteristics | Varies
Recommended scaling method | Must scale-up. The database must grow larger because only one Central Administration content database is supported per farm. (Significant growth is unlikely.)
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, SQL Server, and System Center 2012 - Data Protection Manager (DPM). Backing up and restoring the Central Administration content databases is special. For more information, see Additional notes.
Default recovery model | Full

Additional notes

Backup and restore. The Central Administration content database is backed up when you perform a SharePoint farm configuration and content backup. When a farm is restored, the Central Administration content database is not restored. The Central Administration content database can be successfully backed up and restored by using SQL Server or other tools if the SharePoint farm is first taken offline.

Content databases

Content databases store all content for a site collection. This includes site documents or files in document libraries, list data, Web Part properties, audit logs, and sandboxed solutions, in addition to user names and rights.

All of the files that are stored for a specific site collection are located in one content database on only one server. A content database can be associated with more than one site collection.

Content databases also store user data for Power Pivot for SharePoint, if you installed it in your SharePoint Server 2013 environment. Note that Power Pivot for SharePoint can only be installed on SharePoint Server 2013

Content database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | WSS_Content
Location requirements | None
General size information and growth factors | We recommend limiting the size of content databases to 200 GB to help ensure system performance. For more information, see Additional notes. Content database size varies significantly by usage. For more information, see Additional notes.
Read/write characteristics | Varies by usage. For example, collaboration environments are write-intensive and document management environments are read-intensive.
Recommended scaling method | Content databases that support a site collection must scale-up. The database must be able to grow larger as needed. You can create additional site collections that are associated with a Web application and associate the new site collection with a different content database. If a content database is associated with multiple site collections, you can move a site collection to another database.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, SQL Server, and System Center 2012 - Data Protection Manager (DPM).
Default recovery model | Full

Additional notes

Recommended content database size limitations

Content database sizes up to 1 terabyte are supported only for large, single-site repositories and archives in which data remains reasonably static, such as reference document management systems and Records Center sites. Larger database sizes are supported for these scenarios because their I/O patterns and typical data structure formats have been designed for, and tested at, larger scales.

Content database size estimation

Content database size varies significantly with the usage of the site. Growth factors include the number of documents, number of users, use of versioning, use of Recycle Bins, size of quotas, whether the audit trail is configured, and how many items are chosen for auditing.

If Power Pivot for SharePoint is being used, the Excel files stored in SharePoint Server grow larger, which increases the size of the content database. For more information, see Plan a PowerPivot Deployment in a SharePoint Farm.

SharePoint 2013 service application databases

The following service application databases are available in both SharePoint Foundation 2013 and SharePoint Server 2013 deployments.

App Management database

The App Management database is used by the App Management Service application. It stores the app licenses and permissions that are downloaded from the SharePoint Store or App Catalog.

App Management database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | AppManagement
Location requirements | None
General size information and growth factors | Small. Scale-up when the service application database reaches 10 GB. Scale out only on SharePoint Online.
Read/write characteristics | Write-heavy during apps installation and license renewal.
Recommended scaling method | App License Management databases can scale out only on SharePoint Online.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

Business Data Connectivity service application database

The Business Data Connectivity service application database stores external content types and related objects.

Business Data Connectivity database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | Bdc_Service_DB_<GUID>
Location requirements | None
General size information and growth factors | Small. Size is determined by the number of connections.
Read/write characteristics | Read-heavy
Recommended scaling method | Must scale-up. The database must grow larger, because only one Business Data Connectivity database is supported per farm. (Significant growth is unlikely.)
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

Search service application databases

The Search service application has four databases that support SharePoint 2013. The four Search service application databases are shown in the following list. The tables that follow the list display the relevant database information.

  • Search Administration: The Search Administration database hosts the Search service application configuration and access control list (ACL) for the crawl component.

  • Analytics Reporting: The Analytics Reporting database stores the results for usage analysis reports and extracts information from the Link database when needed.

  • Crawl: The Crawl database stores the state of the crawled data and the crawl history.

  • Link: The Link database stores the information that is extracted by the content processing component and the click through information.

Search Administration database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | Search_Service_Application_DB_<GUID>
Location requirements | The Administration database should fit into RAM on the server so that the server can handle the end-user query load most efficiently. Because of this requirement, it is usually best not to have the Administration and Crawl databases located on the same server.
General size information and growth factors | Medium. The factors that influence growth include the number of best bets, the number of content sources and crawl rules, the security descriptions for the corpus, and how much traffic.
Read/write characteristics | Equal read/write ratio
Recommended scaling method | Scale-up the database that supports the service application instance. Scale out by creating additional instances of the service application, however, the decision to create a separate service application is likely to be based on business, rather than scale, requirements.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Simple

Analytics Reporting database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | Search_Service_Application_AnalyticsReportingStoreDB_<GUID>
Location requirements | None
General size information and growth factors | Medium to large.
Read/write characteristics | Write heavy during nightly analytics update.
Recommended scaling method | Scale out by creating additional Analytics Reporting database using a split operation when the main database becomes >200 GB.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Simple

Crawl database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | Search_Service_Application_CrawlStoreDB_<GUID>
General size information and growth factors | Medium.
Read/write characteristics | Read heavy.
Recommended scaling method | Scale out by creating additional Crawl database per every 20 million items crawled.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Simple

Link database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | Search_Service_Application_LinkStoreDB_<GUID>
Location requirements | We recommend that if you have sites that have heavy traffic, the Link database should use separate spindles from other databases.
General size information and growth factors | Medium to Large. The Link database grows on disk by 1 GB per 1 million documents fed. The click through data grows linearly with query traffic, 1 GB per million queries.
Read/write characteristics | Write heavy during content processing.
Recommended scaling method | Scale out by creating additional Link database per every 60 million documents crawled. Also add additional Link database per 100 million expected queries per year.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Simple

Secure Store Service database

The Secure Store Service application database stores and maps credentials, such as account names and passwords.

Secure Store database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | Secure_Store_Service_DB_<GUID>
Location requirements | For secure credential storage, we recommend that the Secure Store database be hosted on a separate database instance or database server that has access limited to one administrator. By default, if the database is hosted on the default SharePoint database server and instance, all database administrators will have access to the Secure Store database.
General size information and growth factors | Small. Size and growth are determined by the number of target applications, number of credential fields per target application, and the number of users stored in each target application. If auditing is turned on, the number of read and write operations performed against a given target application also affects size.
Read/write characteristics | Equal read/write ratio
Recommended scaling method | Scale-up the database that supports the service application instance. You can scale out by creating additional instances of the service application, however, the decision to create a separate service application is likely to be based on business, rather than scale, requirements.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

Usage and Health Data Collection database

The Usage and Health Data Collection database is used by the Usage and Health Data Collection service application. It stores health monitoring and usage data temporarily, and can be used for reporting and diagnostics. The Usage and Health Data Collection database is the only SharePoint database that supports schema modifications.

Note:

For more information on supported Read operations, see "Read Operations Addendum" in KB 841057: Support for changes to the databases that are used by Office server products and by Windows SharePoint Services.

Usage database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | SharePoint_Logging
Location requirements | The Usage and Health Data Collection database is very active, and should be put on a separate disk or spindle, if it is possible.
General size information and growth factors | Extra large. Database size depends on the retention factor, number of items enabled for logging and external monitoring, how many Web applications are running in the environment, how many users are currently working, and which features are enabled.
Read/write characteristics | Write-heavy
Recommended scaling method | Must scale-up. That is, the database must grow larger, because only one Usage and Health Data Collection service application instance is supported per farm.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Simple

Subscription Settings Service database

The Microsoft SharePoint Foundation Subscription Settings service application database stores features and settings for hosted customers. The Subscription Settings service application and database are not created by the SharePoint Products Configuration Wizard — they must be created by using Windows PowerShell cmdlets or SQL Server. For more information, see New-SPSubscriptionSettingsServiceApplication.

Subscription Settings database

Category | Description
Default database name when installed by using the Windows PowerShellNew-SPSubscriptionSettingsServiceApplication cmdlet | SettingsServiceDB
Location requirements | None
General size information and growth factors | Small. Size is determined by the number of tenants, farms, and features supported.
Read/write characteristics | The subscription database is read-heavy.
Recommended scaling method | Scale-up the database that supports the service application instance. You can scale out by creating additional instances of the service application, however, the decision to create a separate service application is likely to be based on business, rather than scale, requirements.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

SharePoint Server 2013 databases

The following databases are available in a SharePoint Server 2013 deployment.

SharePoint User Profile service application databases

The User Profile service has three databases that support SharePoint Server 2013. The three User Profile service databases are shown in the following list. The tables that follow the list display the relevant database information.

  • Profile: The Profile database stores and manages users and associated information. It also stores information about a user's social network in addition to memberships in distribution lists and sites.

  • Synchronization: The Synchronization database stores configuration and staging data for use when profile data is being synchronized with directory services such as Active Directory.

  • Social Tagging: The Social Tagging database stores social tags and notes created by users, alongside their respective URLs.

Profile database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | User Profile Service Application_ProfileDB_<GUID>
Location requirements | None
General size information and growth factors | Medium to large. Growth factors include additional users and the use of news feeds. News feeds grow with user activities. The default is to maintain the last two weeks of activity, after which a time job deletes the news feed items older than two weeks.
Read/write characteristics | Read-heavy
Recommended scaling method | Scale-up the database that supports the service application instance. You can scale out by creating additional instances of the service application, however, the decision to create a separate service application is likely to be based on business, rather than scale, requirements.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Simple

Synchronization database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | User Profile Service Application_SyncDB_<GUID>
Location requirements | None
General size information and growth factors | Medium to large. Growth factors include the number of users, groups, and the ratio of users to groups.
Read/write characteristics | Equal read/write ratio.
Recommended scaling method | Scale-up the database that supports the service application instance. You can scale out by creating additional instances of the service application, however, the decision to create a separate service application is likely to be based on business, rather than scale, requirements.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Simple

Social Tagging database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | User Profile Service Application_SocialDB_<GUID>
Location requirements | None
General size information and growth factors | Small to extra-large. Growth factors include the number of tags, ratings, and notes that have been created and used.
Read/write characteristics | Read-heavy
Recommended scaling method | Scale-up the database that supports the service application instance. You can scale out by creating additional instances of the service application, however, the decision to create a separate service application is likely to be based on business, rather than scale, requirements.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Simple

Word Automation Services service application database

The Word Automation Services database stores information about pending and completed document conversions and updates. The Word Automation Services Timer Job processes and distributes this information as queued conversion job items to application servers.

Word Automation Services database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | WordAutomationServices_<GUID>
Location requirements | None
General size information and growth factors | Small
Read/write characteristics | Read-heavy, once per conversion item.
Recommended scaling method | Scale-up the database that supports the service application instance. You can scale out by creating additional instances of the service application, however, the decision to create a separate service application is likely to be based on business, rather than scale, requirements.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

Managed Metadata Service service application database

The Managed Metadata service application database stores managed metadata and syndicated content types.

Important:

The Taxonomy service works in conjunction with the Managed Metadata Service that provides the Term Store Management Tool in the SharePoint Central Administration website. This means that the Managed Metadata service application database stores the metadata for the Taxonomy service. The Taxonomy service metadata is stored in a hierarchical structure for items that are used for tagging content and building site collections.

Managed Metadata database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | Managed Metadata Service Application_Metadata_<GUID>
Location requirements | None
General size information and growth factors | Medium. Growth factors include the amount of managed metadata.
Read/write characteristics | Read-heavy
Recommended scaling method | Scale-up the database that supports the service application instance. Scale out by creating additional instances of the service application
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

SharePoint Translation Services service application database

The Machine Translation Services stores information about pending and completed batch document translations with file extensions that are enabled.

Machine Translation Services database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | SharePoint Translation Services_<GUID>
Location requirements | None
General size information and growth factors | Small
Read/write characteristics | Read-heavy
Recommended scaling method | Scale-up the database that supports the service application instance. You can scale out by creating additional instances of the service application, however, the decision to create a separate service application is likely to be based on business, rather than scale, requirements.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

Project Server service application database

Project Server creates a separate database for each instance of Project Web App. Each Project Web App database contains the following data:

  • All Project and Portfolio Management (PPM) data

  • Time tracking and Timesheet data

  • Aggregated SharePoint project site data

Project Server database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | ProjectWebApp
Location requirements | None
General size information and growth factors | Small to medium.
Read/write characteristics | Read-heavy
Recommended scaling method | Scale-up the SQL Server that hosts the Project Web App database. (Significant growth is unlikely.)
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

SQL Server Power Pivot Service service application database

The Power Pivot Service database stores data refresh schedules, and Power Pivot usage data that is copied from the central usage data collection database.

Important:

SQL Server 2012 Power Pivot for SharePoint 2013 requires SQL Server 2012 Analysis Services (SSAS), Business Intelligence or Enterprise edition.

Note:

When being used, Power Pivot stores additional data in content databases and in the Central Administration Content database (WSS_Content).

Power Pivot database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | DefaultPowerPivotServiceApplicationDB_<GUID>
Location requirements | None
General size information and growth factors | Small.
Read/write characteristics | Read-heavy
Recommended scaling method | Scale-up. (Significant growth is unlikely.)
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

PerformancePoint Services service application database

The PerformancePoint Services database stores temporary objects and persisted user comments and settings.

PerformancePoint Services database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | PerformancePoint Service _<GUID>
Location requirements | None
General size information and growth factors | Small.
Read/write characteristics | Read-heavy
Recommended scaling method | Scale-up the database that supports the service application instance. Scale out by creating additional instances of the service application, however, the decision to create a separate service application is likely to be based on business, rather than scale requirements.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

State Service service application database

The State Service database stores temporary state information for InfoPath Forms Services, Exchange Server, the chart Web Part, and Visio Services.

State Service database

Category | Description
Default database name when installed by using the SharePoint Products Configuration Wizard | SessionStateService_<GUID>
Location requirements | None
General size information and growth factors | Medium to large, depending on usage of features that store data in the State Service database.
Read/write characteristics | Read-heavy
Recommended scaling method | Scale out by creating another State Service database with Windows PowerShell cmdlets.
Associated Health rules | None
Supported backup tools | SharePoint 2013 backup and restore, Windows PowerShell, and SQL Server.
Default recovery model | Full

SQL Server system databases

SharePoint Server 2013 is built on SQL Server and uses the SQL Server system databases. SQL Server does not let users directly update information in system objects such as system tables, system stored procedures, and catalog views. Instead, SQL Server provides a complete set of administrative tools that let users fully administer their system and manage all users and objects in a database. For more information about the SQL Server system databases, see System Databases.

master database

The master database records all the system-level information for a SQL Server instance. This includes logins, configurations, and other databases.

master

Category | Description
Default database name | master
Location requirements | The master database must be located on the same SQL Server instance that SharePoint uses.
General size information and growth factors | Small
Read/write characteristics | Varies
Recommended scaling method | Scale-up. (Significant growth is unlikely.)
Associated Health rules | None
Supported backup tools | SQL Server backup and restore.
Default recovery model | Simple

model database

The model database is used as the template for all databases created on the SQL Server instance. Any modifications made to the model database are also applied to all databases created afterward.

model

Category | Description
Default database name | model
Location requirements | The model database must be located on the same SQL Server instance that SharePoint uses.
General size information and growth factors | Small
Read/write characteristics | Varies
Recommended scaling method | Scale-up. (Significant growth is unlikely.)
Associated Health rules | None
Supported backup tools | SQL Server backup and restore.
Default recovery model | Full

msdb database

The msdb database is used by SQL Server Agent for scheduling alerts and jobs.

msdb

Category | Description
Default database name | msdb
Location requirements | The msdb database must be located on the same SQL Server instance that SharePoint uses.
General size information and growth factors | Small
Read/write characteristics | Varies
Recommended scaling method | Scale-up. (Significant growth is unlikely.)
Associated Health rules | None
Supported backup tools | SQL Server backup and restore.
Default recovery model | Simple

tempdb database

The tempdb database holds temporary objects or intermediate result sets. For example, it holds all temporary tables, temporary stored procedures, and any other temporary storage needs. The tempdb is recreated every time SQL Server starts.

tempdb

Category | Description
Default database name | tempdb
Location requirements | Locate on a fast disk, on a separate spindle from other databases. Create as many files as needed to maximize disk bandwidth. Using multiple files reduces tempdb storage contention and yields significantly better scalability. However, do not create too many files because this can decrease performance and increase management overhead. As a general guideline, create one data file for each CPU on the server and adjust the number of files up or down as necessary. Note that a dual-core is two CPUs.
General size information and growth factors | Medium, depending on activities such as how many users are using the system, in addition to the specific processes that are running. For example, online rebuilds of large indexes, or large sorts cause the database to grow quickly.
Read/write characteristics | Varies
Recommended scaling method | Scale-up. (Significant growth is unlikely.)
Associated Health rules | None
Supported backup tools | SQL Server backup and restore.
Default recovery model | Simple

SQL Server Reporting Services databases

The following SQL Server Reporting Services (SSRS) can be used as part of a SharePoint 2013 deployment.

Note:

If you are running Access Services in SharePoint Server 2013, then SQL Server 2012 is required. The requirements for Reporting Services depend on the mode in which you are running, as follows:

  • Local mode requires only SharePoint Server 2013 and the SQL Server Reporting Services Add-in.

  • Connected mode requires SharePoint Server 2013, the SSRS Add-in, and SQL Server 2012, available in Standard or Enterprise Edition.

Report Server Catalog database

The SQL Server Reporting Services Report Server Catalog database stores all report metadata including report definitions, report history and snapshots, and scheduling information. When Report Server Catalog is used, report documents are stored in SharePoint content databases.

Report Server Catalog

Category | Description
Default database name | ReportingService_<GUID>
Location requirements | Must be located on the same database server as the ReportServerTempDb database.
General size information and growth factors | Small
Read/write characteristics | Read heavy
Recommended scaling method | Scale-up the database.
Associated Health rules | None
Supported backup tools | SQL Server backup and restore.
Default recovery model | Full

ReportServerTempDB database

The SQL Server Reporting Services ReportServerTempDB database stores all the temporary snapshots while reports are running.

ReportServerTempDB

Category | Description
Default database name | ReportingService_<GUID>_TempDB
Location requirements | Must be located on the same database server as the Report Server Catalog database.
General size information and growth factors | This database size varies and goes from small to extra-large frequently. The size depends on use of cached report snapshots.
Read/write characteristics | Read heavy
Recommended scaling method | Scale-up the database.
Associated Health rules | None
Supported backup tools | SQL Server backup and restore, but we do not recommend that you back up this database.
Default recovery model | Full

Report Server Alerting database

The Report Server Alerting database stores all Data Alerts metadata and runtime information that is required to produce Data Alerts for Reporting Services operational reports. Data from reports is processed in the database to match rules that are defined in Alert Definitions.

Report Server Alerting

Category | Description
Default database name | ReportingService_<GUID>_Alerting
Location requirements | Must be located on the same database server as the Report Server Catalog database.
General size information and growth factors | This database size varies and goes from small to extra-large frequently. The size depends on use of Data Alerts.
Read/write characteristics | Equal read heavy and write heavy.
Recommended scaling method | Scale-up to optimize the file I/O and memory usage.
Associated Health rules | None
Supported backup tools | SQL Server backup and restore.
Default recovery model | Full

See also

Technical reference for SharePoint 2013
Manage databases in SharePoint 2013

Change History

Date | Description
May 14, 2013 | Updated the "Managed Metadata Service service application database" section to show that the Managed Metadata Service application database stores the Taxonomy service application metadata.
October 16, 2012 | Initial publication


Connection filter data types and operators in SharePoint Server 2013
See also

Published: October 16, 2012

Summary: Learn about connection filter data types and operators for the User Profile service application in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise

When you synchronize profile information with a directory service in SharePoint Server 2013, you can provide a filter that identifies the users or groups to exclude from synchronization. A filter consists of a set of clauses in the format <attribute><operator><value>, and the way to join the clauses. The data type of the attribute determines which operators are available. For more information about filters and how to create them, see Plan profile synchronization for SharePoint Server 2013.

The following table identifies the operators that are available for each Active Directory Domain Services (AD DS) data type.

AD DS data type | Operators
Boolean | is present, is not present, true, false
Case insensitive string | is present, is not present, equals, does not equal, starts with, does not start with, ends with, does not end with, contains, does not contain
Distinguished name | is present, is not present, equals, does not equal, starts with, does not start with, ends with, does not end with, contains, does not contain
IA5-String | is present, is not present, equals, does not equal, starts with, does not start with, ends with, does not end with, contains, does not contain
Integer | is present, is not present, equals, does not equal, less than, less than or equal, greater than, greater than or equal, bit on equals, bit off equals
Large integer or interval | is present, is not present
Numerical string | is present, is not present, equals, does not equal, starts with, does not start with, ends with, does not end with, contains, does not contain
Octet string | is present, is not present The AD DS attribute unicodePwd is an octet string, but SharePoint Server treats it as a Unicode string for the purpose of profile synchronization.
SID | is present, is not present
Unicode string | is present, is not present, equals, does not equal, starts with, does not start with, ends with, does not end with, contains, does not contain
UTC coded time | is present, is not present, equals, does not equal, starts with, does not start with, ends with, does not end with, contains, does not contain

The bit on equals operator checks whether specific bits are turned on. For example, the clause "userAccountControl bit on equals 2" is true if the second bit of the userAccountControl attribute is a one. Similarly, the bit off equals operator checks whether specific bits are turned off (zero). The value that you provide for the bit comparison operators is the decimal equivalent of the bitmask you want to compare with. If, for example, you want to check the fifth bit (0000 0000 0001 0000), you would use the value 16.

See also

Plan profile synchronization for SharePoint Server 2013


User permissions and permission levels in SharePoint 2013
See also

Published: October 16, 2012

Summary: Learn about the default permission levels and user permissions in SharePoint 2013.

Applies to: SharePoint Server 2013 Standard | SharePoint Server 2013 Enterprise | SharePoint Foundation 2013

Default permission levels are predefined sets of permissions that you can assign to individual users, groups of users, or security groups, based on the functional requirements of the users and on security considerations. SharePoint 2013 permission levels are defined at the site collection level and are inherited from the parent object by default.

In this article:

  • Default permission levels

  • User permissions

Default permission levels

Default permission levels are made up of a set of permissions that enable users to perform a collection of related tasks. SharePoint 2013 includes seven permission levels. You can customize the permissions contained within five of these permission levels. You cannot customize the permissions within the Limited Access and Full Control permission levels.

Note:

Although you cannot directly edit the Limited Access and Full Control permission levels, you can make individual permissions unavailable for the entire web application, which removes those permissions from the Limited Access and Full Control permission levels. For more information, see Manage permissions for a web application in SharePoint 2013.

The following table lists the default permission levels for team sites in SharePoint 2013.

Permission level Description Permissions included by default

View Only

Enables users to view application pages. The View Only permission level is used for the Excel Services Viewers group.

  • View Application Pages

  • View Items

  • View Versions

  • Create Alerts

  • Use Self Service Site Creation

  • View Pages

  • Browse User Information

  • Use Remote Interfaces

  • Use Client Integration Features

  • Open

Limited Access

Enables users to access shared resources and a specific asset. Limited Access is designed to be combined with fine-grained permissions to enable users to access a specific list, document library, folder, list item, or document, without enabling them to access the whole site. Limited Access cannot be edited or deleted.

  • View Application Pages

  • Browse User Information

  • Use Remote Interfaces

  • Use Client Integration Features

  • Open

Read

Enables users to view pages and list items, and to download documents.

Limited Access permissions, plus:

  • View Items

  • Open Items

  • View Versions

  • Create Alerts

  • Use Self-Service Site Creation

  • View Pages

Contribute

Enables users to manage personal views, edit items and user information, delete versions in existing lists and document libraries, and add, remove, and update personal Web Parts.

Read permissions, plus:

  • Add Items

  • Edit Items

  • Delete Items

  • Delete Versions

  • Browse Directories

  • Edit Personal User Information

  • Manage Personal Views

  • Add/Remove Personal Web Parts

  • Update Personal Web Parts

Edit

Enables users to manage lists.

Contribute permissions, plus:

  • Manage Lists

Design

Enables users to view, add, update, delete, approve, and customize items or pages in the website.

Edit permissions, plus:

  • Add and Customize Pages

  • Apply Themes and Borders

  • Apply Style Sheets

  • Override List Behaviors

  • Approve Items

Full Control

Enables users to have full control of the website.

All permissions

If you use a site template other than the team site template, you will see a different list of default SharePoint permission levels. For example, the following table shows additional permission levels provided with the publishing template.

Permission level Description Permissions included by default

Restricted Read

View pages and documents. For publishing sites only.

  • View Items

  • Open Items

  • View Pages

  • Open

Approve

Edit and approve pages, list items, and documents. For publishing sites only.

Contribute permissions, plus:

  • Override List Behaviors

  • Approve Items

Manage Hierarchy

Create sites; edit pages, list items, and documents, and change site permissions. For Publishing sites only.

Design permissions minus the Approve Items, Apply Themes and Borders, and Apply Style Sheets permissions, plus:

  • Manage permissions

  • View Web Analytics Data

  • Create Subsites

  • Manage Alerts

  • Enumerate Permissions

  • Manage Web Site

User permissions

SharePoint 2013 includes 33 permissions, which are used in the default permission levels. You can configure which permissions are included in a particular permission level (except for the Limited Access and Full Control permission levels), or you can create a new permission level to contain specific permissions.

Permissions are categorized as list permissions, site permissions, and personal permissions, depending on the objects to which they can be applied. For example, site permissions apply to a particular site, list permissions apply only to lists and libraries, and personal permissions apply only to certain objects, such as personal views and private Web Parts. The following tables describe what each permission is used for, the dependent permissions, and the permission levels in which it is included.

List permissions

Permission | Description | Dependent permissions | Included in these permission levels by default
Manage Lists | Create and delete lists, add or remove columns in a list, and add or remove public views of a list. | View Items, View Pages, Open | Edit, Design, Full Control, Manage Hierarchy
Override List Behaviors | Discard or check in a document that is checked out to another user, and change or override settings that allow users to read/edit only their own items. | View Items, View Pages, Open | Design, Full Control
Add Items | Add items to lists, and add documents to document libraries. | View Items, View Pages, Open | Contribute, Edit, Design, Full Control
Edit Items | Edit items in lists, edit documents in document libraries, and customize Web Part pages in document libraries. | View Items, View Pages, Open | Contribute, Edit, Design, Full Control
Delete Items | Delete items from a list, and documents from a document library. | View Items, View Pages, Open | Contribute, Edit, Design, Full Control
View Items | View items in lists, and documents in document libraries. | View Pages, Open | Read, Contribute, Edit, Design, Full Control
Approve Items | Approve a minor version of list items or document. | Edit Items, View Items, View Pages, Open | Design, Full Control
Open Items | View the source of documents with server-side file handlers. | View Items, View Pages, Open | Read, Contribute, Edit, Design, Full Control
View Versions | View past versions of a list item or document. | View Items, Open Items, View Pages, Open | Read, Contribute, Edit, Design, Full Control
Delete Versions | Delete past versions of list items or documents. | View Items, View Versions, View Pages, Open | Contribute, Edit, Design, Full Control
Create Alerts | Create alerts. | View Items, View Pages, Open | Read, Contribute, Edit, Design, Full Control
View Application Pages | View forms, views, and application pages. Enumerate lists. | Open | All

Site permissions

Permission | Description | Dependent permissions | Included in these permission levels by default
Manage Permissions | Create and change permission levels on the web site and assign permissions to users and groups. | View Items, Open Items, View Versions, Browse Directories, View Pages, Enumerate Permissions, Browse User Information, Open | Full Control
View Usage Data | View reports on website usage. | View Pages, Open | Full Control
Create Subsites | Create subsites such as team sites, Meeting Workspace sites, and Document Workspace sites. | View Pages, Browse User Information, Open | Full Control
Manage Web Site | Grants the ability to perform all administration tasks for the web site, as well as manage content. | View Items, Add and Customize Pages, Browse Directories, View Pages, Enumerate Permissions, Browse User Information, Open | Full Control
Add and Customize Pages | Add, change, or delete HTML pages or Web Part pages, and edit the website. | View Items, Browse Directories, View Pages, Open | Design, Full Control
Apply Themes and Borders | Apply a theme or borders to the whole website. | View Pages, Open | Design, Full Control
Apply Style Sheets | Apply a style sheet (.css file) to the website. | View Pages, Open | Design, Full Control
Create Groups | Create a group of users that can be used anywhere within the site collection. | View Pages, Browse User Information, Open | Full Control
Browse Directories | Enumerate files and folders in a website by using SharePoint Designer 2013 and Web DAV interfaces. | View Pages, Open | Contribute, Edit, Design, Full Control
Use Self-Service Site Creation | Create a website using Self-Service Site Creation. | View Pages, Browse User Information, Open | Read, Contribute, Edit, Design, Full Control
View Pages | View pages in a website. | Open | Read, Contribute, Edit, Design, Full Control
Enumerate Permissions | Enumerate permissions on the website, list, folder, document, or list item. | Browse Directories, View Pages, Browse User Information, Open | Full Control
Browse User Information | View information about users of the website. | Open | All
Manage Alerts | Manage alerts for all users of the website. | View Items, View Pages, Open, Create Alerts | Full Control
Use Remote Interfaces | Use SOAP, Web DAV, the Client Object Model, or SharePoint Designer 2013 interfaces to access the website. | Open | All
Use Client Integration Features | Use features that launch client applications. Without this permission, users must work on documents locally and then upload their changes. | Use Remote Interfaces, Open, View Items | All
Open | Enables users to open a website, list, or folder to access items inside that container. | None | All
Edit Personal User Information | Enables users to change their own user information, such as adding a picture. | Browse User Information, Open | Contribute, Edit, Design, Full Control

Personal permissions

Permission | Description | Dependent permissions | Included in these permission levels by default
Manage Personal Views | Create, change, and delete personal views of lists. | View Items, View Pages, Open | Contribute, Edit, Design, Full Control
Add/Remove Personal Web Parts | Add or remove personal Web Parts on a Web Part page. | View Items, View Pages, Open, Update Personal Web Parts | Contribute, Edit, Design, Full Control
Update Personal Web Parts | Update Web Parts to display personalized information. | View Items, View Pages, Open | Contribute, Edit, Design, Full Control

See also

Manage permissions for a web application in SharePoint 2013


Language packs in SharePoint Server 2013
See also

Published: May 7, 2013

Summary: Learn about the language packs available for SharePoint 2013.

Applies to: SharePoint Server 2013 | SharePoint Online | SharePoint Foundation 2013

This article lists the language packs that are available for SharePoint Foundation 2013, SharePoint Server 2013, and SharePoint Online. Language packs enable you to create site collections and sites in multiple languages without requiring separate installations of SharePoint in each language. For more information about language packs, see Install or uninstall language packs for SharePoint 2013.

Language packs for SharePoint Server 2013 can be downloaded at Language packs for SharePoint Server 2013 on the Microsoft Download Center. Language packs for SharePoint Foundation 2013 can be downloaded at Language Packs for SharePoint Foundation 2013 on the Download Center.

Important:

If you are using SharePoint Online, all language packs are already installed.

Available language packs for SharePoint 2013

The following table lists the language packs that are available for SharePoint Foundation 2013, SharePoint Server 2013, and SharePoint Online.

Table: Available language packs

Language | Language ID | SharePoint Foundation 2013 | SharePoint Server 2013 | SharePoint Online
Arabic | 1025 | Yes | Yes | Yes
Basque (Basque) | 1069 | Yes | Yes | Yes
Bulgarian | 1026 | Yes | Yes | Yes
Catalan | 1027 | Yes | Yes | Yes
Chinese (Simplified) | 2052 | Yes | Yes | Yes
Chinese (Traditional) | 1028 | Yes | Yes | Yes
Croatian | 1050 | Yes | Yes | Yes
Czech | 1029 | Yes | Yes | Yes
Danish | 1030 | Yes | Yes | Yes
Dutch | 1043 | Yes | Yes | Yes
English | 1033 | Yes | Yes | Yes
Estonian | 1061 | Yes | Yes | Yes
Finnish | 1035 | Yes | Yes | Yes
French | 1036 | Yes | Yes | Yes
Galician | 1110 | Yes | Yes | Yes
German | 1031 | Yes | Yes | Yes
Greek | 1032 | Yes | Yes | Yes
Hebrew | 1037 | Yes | Yes | Yes
Hindi | 1081 | Yes | Yes | Yes
Hungarian | 1038 | Yes | Yes | Yes
Indonesian | 1057 | Yes | Yes | No
Italian | 1040 | Yes | Yes | Yes
Japanese | 1041 | Yes | Yes | Yes
Kazakh | 1087 | Yes | Yes | Yes
Korean | 1042 | Yes | Yes | Yes
Latvian | 1062 | Yes | Yes | Yes
Lithuanian | 1063 | Yes | Yes | Yes
Malay (Malaysia) | 1086 | Yes | Yes | No
Norwegian (Bokmål) | 1044 | Yes | Yes | Yes
Polish | 1045 | Yes | Yes | Yes
Portuguese (Brazil) | 1046 | Yes | Yes | Yes
Portuguese (Portugal) | 2070 | Yes | Yes | Yes
Romanian | 1048 | Yes | Yes | Yes
Russian | 1049 | Yes | Yes | Yes
Serbian (Cyrillic) | 3098 | Yes | Yes | No
Serbian (Latin) | 2074 | Yes | Yes | Yes
Slovak | 1051 | Yes | Yes | Yes
Slovenian | 1060 | Yes | Yes | Yes
Spanish | 3082 | Yes | Yes | Yes
Swedish | 1053 | Yes | Yes | Yes
Thai | 1054 | Yes | Yes | Yes
Turkish | 1055 | Yes | Yes | Yes
Ukrainian | 1058 | Yes | Yes | Yes
Vietnamese | 1066 | Yes | Yes | No

See also

Install or uninstall language packs for SharePoint 2013


Fine-grained permission reference for SharePoint Server 2013
See also

Published: April 30, 2013

Summary: Learn about the potential impact of fine-grained permissions on performance and the complexity of maintaining a SharePoint 2013 environment.

Applies to: SharePoint Server 2013 | SharePoint Foundation 2013

By default, permissions within a site are inherited from the site. However, fine-grained permissions is when you break this inheritance for any securable object that is at a lower level in the hierarchy by editing the permissions (creating a unique permission assignment) on that securable object.

Note:

We recommend that you use fine-grained permissions only when a business case justifies it. Fine-grained permissions can increase the cost to manage a deployment. Because it is inefficient to maintain permissions for individual users, we recommend that you use group permissions as much as possible. Particularly if you are using fine-grained permissions, you should use groups to avoid having to track permissions for individual user accounts. Because people can move in and out of teams and change responsibilities frequently, you might not want to track all of those changes and continually update the permissions for uniquely secured objects.

Overview of fine-grained permissions

In this article, the terms web and site equate to the SPWeb object, and site collections equate to the SPSite object. In addition, the term fine-grained refers to permission on a list, library, folder, item, or document that restricts actions that users can complete. Fine-grained permissions enable you to customize user permissions in a site collection. For more information, see SPWeb and SPSite.

SharePoint permissions scope system overview

This section describes the SharePoint permissions scope system. For more information about how to plan site security, see Plan site permissions in SharePoint 2013.

Permission levels

A permission level contains a set of individual permissions, for example, View Items or Create Alerts. Permission levels can be assigned to an individual user, groups of users, or security groups by using a predefined permission level or a user can create a custom permission level. The set of permissions can be changed even within the predefined permission levels.

SharePoint groups

A SharePoint group is a site collection-wide object that can hold other security principals, such as Windows user accounts, non-Windows users (for example, forms-based accounts), and Active Directory groups.

Scope

A scope is the security boundary for a securable object and any of its children that do not have a separate security boundary defined. The scope contains an Access Control List (ACL), but unlike NTFS ACLs, a scope can include SharePoint-specific security principals. The members of an ACL for a scope can include Windows users, non-Windows users (such as forms-based accounts in SharePoint Products and Technologies or claims-based accounts in SharePoint 2013), Active Directory groups, SharePoint groups or other scopes.

There is no maximum number of scopes that can be created in a parent scope. But after you have created 1,000 scopes, a code path that requires additional Microsoft® SQL Server round trips to analyze the scopes before rendering a view is used. When there are 1,000 or fewer scopes, only one roundtrip is required. In SharePoint 2013, the limit of number of scopes returned before switching to a different algorithm is based on a query throttle limit that has a default value of 5,000. This value, even at default, can be large enough to significantly detract from performance.

In SharePoint 2013, you can use the SPRoleAssignmentCollection.AddToCurrentScopeOnly method to assign roles. For additional information about role assignments, see SPRoleAssignmentCollection.AddToCurrentScopeOnly (http://msdn.microsoft.com/en-us/library/microsoft.sharepoint.sproleassignmentcollection.addtocurrentscopeonly.aspx).

Securable object

A securable object is an object that can have an ACL assigned to it. In SharePoint 2013, you can use the SPSecurableObject class. For additional information about securable objects, see SPSecurableObject class (http://msdn.microsoft.com/en-us/library/microsoft.sharepoint.spsecurableobject.aspx).

Inheritance

If a securable object does not have a unique scope, the object inherits the scope of its parent. When an object inherits from its parent, no scope is created for the object. Instead, when a security check is made, it verifies only against the parent object. In the simplest environment, this scope is at the root web of the site collection that contains the item. When an item or container is changed to have unique membership, its inheritance is broken, which means that a new scope is created for that item and, by default, for any of its children that inherit its permission scopes.

The following diagram shows an object hierarchy for a document library, in which all objects but one inherit their scope from their parents. Each numbered gold hexagon represents a permissions scope. All child objects in a container inherit from that parent scope unless they have their own unique permissions scope.

IIustrates object hierarchy for a document library, in which all objects but one inherit their scope from their parents.

Limited access

When a security principal is added to the scope of an item with unique permissions, the security principal is immediately added by using the Limited Access permission level to each unique permission scope in the hierarchy above the item until a parent web with unique permissions is located.

The reason to add the user to the scopes with Limited Access is to allow enough access to the object hierarchically above the uniquely permissioned item so that the Object Model (OM), master pages, and navigation can display when the user attempts to navigate to the item. Without the Limited Access permissions at the parent scopes, the user wouldn't be able to successfully browse to or open the item that has unique permissions.

The following diagram shows how the hierarchical depth of scopes can affect the work that is required to add Limited Access users to parent scopes. The larger the number of unique scopes above the item, up to and including the uniquely permissioned web, the larger the number of additions that must occur. The diagram shows a simplified representation of a physical structure that has unique scopes defined at every level from the web down to individual items. As in the previous diagram, each differently numbered gold hexagon represents a unique permission scope, and all child objects within that container inherit from that scope unless they have their own unique permissions scope. The chain of Limited Access promotion is shown using red arrows.

IIustrates how the hierarchical depth of scopes can affect the amount of work required to add Limited Access users to parent scopes.

The diagram also includes the set of unique scopes and the Limited Access membership additions that must occur on each parent scope, represented by separate boxes within the scope. No additional programming is required to add unique scopes when a security principal is added to an object scope with unique permissions that is below a web with unique permissions.

When a security principal with the Limited Access permission level is added to a parent scope, no check is made to see whether the security principal is already in the parent scope. A security principal that already has access to the parent scope is added again with Limited Access permissions, regardless of its existing permissions on the parent scope.

When a security principal is removed from the Limited Access permission level at a parent scope, each instance of that security principal within every child scope is removed from the Limited Access permission level, regardless of whether the security principal has Limited Access or a wider set of permissions at the child scopes.

Binary ACL

A binary ACL performs rapid comparisons of a user token to determine whether the user should have access to the object covered by the scope. A binary ACL is calculated when the membership of a scope changes. This includes when a new limited access member is added. The binary ACL takes more time to calculate as the membership becomes larger, and access to the objects will be blocked until the ACL can be recalculated.

Although there is no explicit size limitation on a binary ACL other than the maximum size of an image column in SQL Server, some services can't accept an ACL that is larger than 64KB. In this case, the number of security principals in the binary ACL may grow very large, but should be limited because of performance and interoperability considerations. For information about limitations in image column sizes in SQL Server, see ntext, text, and image (Transact-SQL) (http://msdn.microsoft.com/en-us/library/ms187993.aspx).

See also

Best practices for using fine-grained permissions in SharePoint Server 2013
Troubleshoot common fine-grained permissions issues for SharePoint Server 2013


Grant Active Directory Domain Services permissions for profile synchronization in SharePoint Server 2013
See also

Published: October 23, 2012

Summary: Learn how to grant the appropriate permissions in Active Directory Domain Services that are used for profile synchronization by the User Profile service in SharePoint Server 2013.

Applies to: SharePoint Server 2013

This article contains procedures that an Active Directory Domain Services (AD DS) administrator can use to configure the permissions that are required to synchronize profile information with SharePoint Server 2013. The "Plan account permissions" section of Plan account permissions describes the required permissions for various circumstances.

The procedures in this article use the phrase "synchronization account" for the account to which you grant permissions. The synchronization account is the account that SharePoint Server uses to connect to AD DS during profile synchronization.

In this article:

  • Before you begin

  • Grant Replicate Directory Changes permission on a domain

  • Add an account to the Pre-Windows 2000 Compatible Access group

  • Grant Replicate Directory Changes permission on the cn=configuration container

  • Grant Create Child Objects and Write permission

Before you begin

Note:

Administrators typically use the SharePoint Central Administration website and the SharePoint Management Shell to manage deployments. For information about accessibility for administrators, see Accessibility for SharePoint 2013.

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Grant Replicate Directory Changes permission on a domain

Use this procedure to grant Replicate Directory Changes permission on a domain to an account.

The Replicate Directory Changes permission enables the synchronization account to read AD DS objects and to discover AD DS objects that have been changed in the domain. The Grant Replicate Directory Changes permission does not enable an account to create, modify or delete AD DS objects.

To grant Replicate Directory Changes permission on a domain

  1. On the domain controller, click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  2. In Active Directory Users and Computers, right-click the domain, and then click Delegate Control.

  3. On the first page of the Delegation of Control Wizard, click Next.

  4. On the Users or Groups page, click Add.

  5. Type the name of the synchronization account, and then click OK.

  6. Click Next.

  7. On the Tasks to Delegate page, select Create a custom task to delegate, and then click Next.

  8. On the Active Directory Object Type page, select This folder, existing objects in this folder, and creation of new objects in this folder, and then click Next.

  9. On the Permissions page, in the Permissions box, select Replicating Directory Changes (select Replicate Directory Changes on Windows Server 2003), and then click Next.

  10. Click Finish.

Add an account to the Pre-Windows 2000 Compatible Access group

Use this procedure to add an account to the Pre-Windows 2000 Compatible Access group.

To add an account to the Pre-Windows 2000 Compatible Access group

  1. On the domain controller, click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  2. In Active Directory Users and Computers, expand the domain, expand Builtin, right-click Pre-Windows 2000 Compatible Access, and then click Properties.

  3. In the Properties dialog box, click the Members tab, and then click Add.

  4. Type the name of the synchronization account, and then click OK.

  5. Click OK.

Grant Replicate Directory Changes permission on the cn=configuration container

Use this procedure to grant Replicate Directory Changes permission on the cn=configuration container to an account.

To grant Replicate Directory Changes permission on the cn=configuration container

  1. On the domain controller, click Start, click Run, type adsiedit.msc, and then click OK.

  2. If the Configuration node is not already present, do the following:

    1. In the navigation pane, click ADSI Edit.

    2. On the Action menu, click Connect to.

    3. In the Connection Point area of the Connection Settings dialog box, click Select a well know Naming Context, select Configuration from the drop-down list, and then click OK.

  3. Expand the Configuration node, right-click the CN=Configuration... node, and then click Properties.

  4. In the Properties dialog box, click the Security tab.

  5. In the Group or user names section, click Add.

  6. Type the name of the synchronization account, and then click OK.

  7. In the Group or user names section, select the synchronization account.

  8. In the Permissions section, select the Allow check box next to the Replicating Directory Changes (Replicate Directory Changes on Windows Server 2003) permission, and then click OK.

Grant Create Child Objects and Write permission

Use this procedure to grant Create Child Objects and Write permission to an account.

To grant Create Child Objects and Write permission

  1. On the domain controller, click Start, click Run, type adsiedit.msc, and then click OK.

  2. If the Default naming context node is not already present, do the following:

    1. In the navigation pane, click ADSI Edit.

    2. On the Action menu, click Connect to.

    3. In the Connection Point area of the Connection Settings dialog box, click Select a well know Naming Context, select Default naming context from the drop-down list, and then click OK.

  3. In the navigation pane of the ADSI Edit window, expand the domain, expand the DC=... node, right-click the OU to which you want to grant permission, and then click Properties.

  4. On the Security tab of the Properties dialog box, click Advanced.

  5. In the Advanced Security Settings dialog box, select the row whose value in the Name column is the synchronization account and whose value in the Inherited From column is <not inherited>, and then click Edit. If this row is not present, click Add, click Locations, select Entire Directory, click OK, type the synchronization account, and then click OK. This adds the appropriate row, which you can now select.

    Note:

    Do not select the row for the synchronization account that is inherited from another location. Doing so would only enable you to apply the permissions to the OU and not to the contents of the OU.

  6. In the Permission Entry dialog box, select This object and all descendant objects from the Apply to box, (select This object and all child objects on Windows Server 2003), select the Allow check box in the rows for the Write all properties and Create all child objects properties, and then click OK.

  7. Click OK to close the Advanced Security Settings dialog box.

  8. Click OK to close the Properties dialog box.

  9. Repeat steps 3 through 8 to grant permissions on any additional OUs.

See also

Plan profile synchronization for SharePoint Server 2013
Synchronize user and group profiles in SharePoint Server 2013


Default user profile property mappings in SharePoint Server 2013
See also

Published: October 23, 2012

Summary: Learn about the default user profile property mappings for the User Profile service in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Some user profile properties are mapped automatically to their corresponding directory service attributes after you run a profile synchronization. This topic describes the user profile properties that are mapped by default.

In this topic:

  • Default user profile property mappings for Active Directory Domain Services

  • Default user profile property mappings for Novell eDirectory, Sun Java System Directory Server, or IBM Tivoli Directory Server

Default user profile property mappings for Active Directory Domain Services

The following table describes the user profile properties that are automatically mapped when you import user profiles from Active Directory Domain Services (AD DS).

Note:

When you upgrade from SharePoint Server 2010 to SharePoint Server 2013, the user profile mapping property WorkEmail retains the default mapping to mail (that is "WorkEmail" maps to "mail"), however when a new synchronization connection mapping property is created in SharePoint Server 2013, the new mapping defaults to the ProxyAddress property (that is, "mail" maps to "ProxyAddress"). After the upgrade process has been completed successfully, the mapping properties can be manually changed based on your organizational requirements.

User profile property | AD DS attribute
SPS-DistinguishedName | dn
SID | objectSid
Manager | manager
PreferredName | displayName
FirstName | givenName
LastName | sn
SPS-PhoneticDisplayName | msDS-PhoneticDisplayName
SPS-PhoneticFirstName | msDS-PhoneticFirstName
SPS-PhoneticLastName | msDS-PhoneticLastName
WorkPhone | telephoneNumber
WorkEmail | mail
Office | physicalDeliveryOfficeName
SPS-JobTitle | title
Department | department
UserName | sAMAccountName
PublicSiteRedirect | wWWHomePage
SPS-ProxyAddresses | proxyAddresses
SPS-SourceObjectDN | msDS-SourceObjectDN
SPS-ClaimID | <specific to connection>
SPS-ClaimProviderID | <specific to connection>
SPS-ClaimProviderType | <specific to connection>

Default user profile property mappings for Novell eDirectory, Sun Java System Directory Server, or IBM Tivoli Directory Server

The following table describes the user profile properties that are mapped automatically when you import user profiles from Novell eDirectory, Sun Java System Directory Server, or IBM Tivoli Directory Server.

User profile property | Directory service attribute
SPS-DistinguishedName | dn
FirstName | givenName
LastName | sn
WorkPhone | telephoneNumber
WorkEmail | mail
Office | physicalDeliveryOfficeName
SPS-JobTitle | title
UserName | <specific to connection>
SPS-ClaimID | <specific to connection>
SPS-ClaimProviderID | <specific to connection>
SPS-ClaimProviderType | <specific to connection>

See also

Plan profile synchronization for SharePoint Server 2013
Synchronize user and group profiles in SharePoint Server 2013

Default user profile properties (SharePoint Server 2013)


User profile property data types in SharePoint Server 2013
See also

Published: October 23, 2012

Summary: Learn about user profile property data types for the User Profile service in SharePoint Server 2013.

Applies to: SharePoint Server 2013

When you map a SharePoint Server 2013 user profile property to an element in an external system, the property and the element must have compatible data types. This article identifies Active Directory Domain Services (AD DS) data types and the .NET data types that are compatible with the data types of SharePoint Server 2013 user profile properties.

In this article:

  • AD DS data type compatibility

  • .NET data type compatibility

AD DS data type compatibility

The following table lists the AD DS data types that are compatible with each user profile data type.

User profile service data type | AD DS data type
big integer | Large Integer, Integer
binary | Octet String, SID
boolean | Boolean
date | UTC Coded Time
date no year | UTC Coded Time
date time | UTC Coded Time
E-mail | Unicode String, IA5-String, Case Insensitive String
float | Unicode String
HTML | Unicode String, IA5-String, Case Insensitive String
integer | Integer
Person | Distinguished Name
string (multi-value) | Unicode String, IA5-String, Case Insensitive String
string (single-value) | Unicode String, IA5-String, Case Insensitive String
time zone | Integer
unique identifier | Octet String, SID
URL | Unicode String, IA5-String, Case Insensitive String
Note:

The AD DS attribute unicodePwd is an octet string, but SharePoint Server treats it as a Unicode string for the purpose of profile synchronization.

.NET data type compatibility

When you create an external content type in SharePoint Server 2013, you specify the .NET data type of each column of the external content type. If you map user profile properties to columns of an external content type by using a Business Data Connectivity connection, the data types must be compatible. The following table lists the user profile property data types that are compatible with each .NET data type.

.NET data type | User Profile service data type
System.Boolean | Boolean
System.String | String (Only multi-value string is supported)
System.DateTime | Date/DateTime
System.Int64 | BigInteger
System.Int32 | BigInteger/Integer
System.Int16 | BigInteger/Integer
System.SByte | BigInteger/Integer
System.UInt64 | BigInteger
System.UInt32 | BigInteger/Integer
System.UInt16 | BigInteger/Integer
System.Byte | BigInteger/Integer
System.Single | Float
System.Double | Float
Note:

You cannot use a business data connectivity connection to map a binary property to a property that implements the Stream accessor method.

See also

Plan profile synchronization for SharePoint Server 2013

Default user profile properties (SharePoint Server 2013)


Display template reference in SharePoint Server 2013

Published: February 12, 2013

Summary: Learn about the different display templates that are available in SharePoint Server 2013.

Applies to: SharePoint Server 2013

Display templates for the Content Search Web Part

You can use the following display templates to change the appearance of content that is shown in a Content Search Web Part. These display template files are located in the Content Web Parts subfolder in the Display Templates folder in the Master Page Gallery.

Display template type | Name in Web Part Tool Pane | Name in Master Page Gallery | Description
Control display template | List | Control_List | Displays the items in the Web Part as a list. It is the default control display template when you add a new Content Search Web Part to a page.
Control display template | List with Paging | Control_ListWithPaging | Displays the items in the Web Part as a list, and lets users page through the items by using arrows. It is the default control display template for Content Search Web Parts on Category pages.
Control display template | Slideshow | Control_Slideshow | Displays the items in the Web Part as a picture slide show that rotates through a set of images every 5 seconds. It shows one item at a time, with the title of the item overlaying the picture.
Item display template | Diagnostic | Item_Diagnostic | Displays the underlying values for items returned by the query specified in the Web Part. This item display template can be very helpful when troubleshooting why items do not appear correctly in the Web Part.
Item display template | Large picture | Item_LargePicture | Displays an image of the item returned by the query specified in the Web Part, with the title of the item overlaying the image. This item display template should be used with the Slideshow control display template, and with images that are more than 400 pixels wide.
Item display template | Picture on left, 3 lines on right | Item_Picture3Lines | Displays a 100 pixel x 100 pixel image of the item returned by the query specified in the Web Part. The title and the default item description are displayed to the right of the image. An additional line is available as a placeholder that can be used to display a managed property.
Item display template | Picture on top, 3 lines on bottom | Item_PictureOnTop | Displays a 304 pixel x 100 pixel image of the item returned by the query specified in the Web Part. The title and the default item description are displayed below the image. An additional line is available as a placeholder that can be used to display a managed property.
Item display template | Recommended Items: Picture on left, 3 lines on right | Item_RecommendationsClickLogging | Displays a 100 pixel x 100 pixel image of the item returned by the query specified in the Web Part. The title and the default item description are displayed to the right of the image. An additional line is available as a placeholder that can be used to display a managed property.
Item display template | Two lines | Item_TwoLines | Displays a small thumbnail icon next to a hyperlink of the title of the item returned by the query specified in the Web Part. An additional line is available as a placeholder that can be used to display a managed property.
 |  | Group_Content | This file is used to render the different display templates. You should not change this file.

Display templates for the Refinement Web Part and the Taxonomy Refinement Web Part

You can use the display templates listed in the following table to change the appearance of content that is shown in a Refinement Web Part and a Taxonomy Refinement Web Part. These display template files are located in the Filters subfolder in the Display Templates folder in the Master Page Gallery. Note that there are different display templates for different refiner types.

Display template type | Name in Web Part Tool Pane | Name in Master Page Gallery | Description
Control display template | Vertical | Control_Refinement | The control display template for the Refinement Web Part.
Control display template | Default Taxonomy Refinement | Control_TaxonomyRefinement | The control display template for the Taxonomy Refinement Web Part.
Item display template | Refinement Item | Filter_Default | Item display template for refiners of type Text, Decimal, and Date. Displays the refiners in a list. Users can click a specific refiner to narrow the search results.
Item display template | Multi-value Refinement Item | Filter_MultiValue | Item display template for refiners of type Text, Decimal, and Date. Displays the refiners in a list that has a check box next to each refiner. Users can select multiple refiners to narrow the search results. If you want to change how multi-value refiners are shown on a page, you should not change this display template, but instead use the Multi-value Refinement Item Body template.
Item display template | Multi-value Refinement Item Body | Filter_MultiValue_Body | Item display template that works together with Multi-value Refinement Item file. If you want to change how multi-value refiners are shown on a page, you should change this display template.
Item display template | Slider | Filter_Slider | Item display template for refiners of type Decimal. Displays the refiners according to ranges in a slider bar. Users can slide the bar to narrow search results.
Item display template | Slider with bar graph | Filter_SliderBarGraph | Item display template for refiners of type Decimal. Displays the refiners according to ranges in a slider bar and bar graph. Users can slide the bar or click a bar graph to narrow search results.
Item display template | Link with count | Filter_TaxonomyRefinement | The default item display template for the Taxonomy Refinement Web Part. Displays the refiners in a list. For each refiner, the number of items that contains the refiner value is displayed. Users can click a specific taxonomy refiner to narrow the search results.
 | User Specified Refinement Exchange | Filter_eDiscoveryExchangeRefinement | This is a system file, and you'll be unable to apply this to a Web Part. You should not change this file.
 | Message Type Refinement | Filter_eDiscoveryExchangeTypeRefinement | This is a system file, and you'll be unable to apply this to a Web Part. You should not change this file.
 | User Specified Refinement SharePoint | Filter_eDiscoverySharepointRefinement | This is a system file, and you'll be unable to apply this to a Web Part. You should not change this file.

Display templates for the Search Results Web Part

You can use the display templates in the following table to change the appearance of content shown in a Search Results Web Part. Note that the hover panels for the different result types have separate display templates. These display template files are located in the Search subfolder in the Display Templates folder in the Master Page Gallery.

Display template type Name in Web Part Tool Pane Name in Master Page Gallery Description

Control display template

Default Search Box

Control_SearchBox

Displays the search box in a Search Box Web Part. It is the default control display template for the Search Box Web Part.

Control display template

Site Search Box

Control_SearchBoxCompact

Displays the search box in a Search Box Web Part in a compact form.

Control display template

Default Result

Control_SearchResults

The default control display template for the Search Results Web Part.

Control display template

Default Group

Group_Default

Displays the default group template. Items can be arranged horizontally or vertically depending on how the item template styled. Note that this control display is hidden, so that you will not be able to select this in the Web Part tool pane.

Item display template

Best Bet Item

Item_BestBet

Displays a single promoted result that is specified by using query rules.

Hover panel

Common Hover Panel Actions

Item_CommonHoverPanel_Actions

Displays the hover panel actions that are common to all search results.

Hover panel

Common Hover Panel Body

Item_CommonHoverPanel_Body

Displays the hover panel footer elements that are common to all search results.

Hover panel

Common Hover Panel Header

Item_CommonHoverPanel

Displays the hover panel header elements that are common to all search results.

Item display template

Common Item Body

Item_CommonItem_Body

Displays the inline search result body elements that are common to all search results.

Item display template

Community Item

Item_Community

Displays a search result that is customized for community posts and replies.

Hover panel

Community Hover Panel

Item_Community_HoverPanel

Displays a search result hover panel that is customized for community posts and replies.

Item display template

Default Item

Item_Default

Displays the default search result item template.

Hover panel

Default Hover Panel

Item_Default_HoverPanel

Displays the default search hover panel template.

Item display template

Discussion Item

Item_Discussion

Displays a search result that is customized for community discussions.

Hover panel

Discussion Hover Panel

Item_Discussion_HoverPanel

Displays a search result hover panel that is customized for community discussions.

Item display template

Excel Item

Item_Excel

Displays a search result that is customized for Microsoft Excel documents.

Hover panel

Excel Hover Panel

Item_Excel_HoverPanel

Displays a search result hover panel that is customized for Microsoft Excel documents.

Item display template

Microblog Item

Item_MicroBlog

Displays a search result that is customized for microblog feed posts and replies.

Hover panel

Microblog Hover Panel

Item_MicroBlog_HoverPanel

Displays a search result hover panel that is customized for microblog feed posts and replies.

Item display template

Office Document Item

Item_OfficeDocument

Displays a search result that is customized for Microsoft Office documents.

Hover panel

Office Document Hover Panel

Item_OfficeDocument_HoverPanel

Displays a search result hover panel that is customized for a Microsoft Office document.

Item display template

OneNote Item

Item_OneNote

Displays a search result that is customized for Microsoft OneNote documents.

Hover panel

OneNote Hover Panel

Item_OneNote_HoverPanel

Displays a search result hover panel that is customized for Microsoft OneNote document.

Item display template

PDF Item

Item_PDF

Displays search results that are customized for Portable Document Format (PDF) documents.

Hover panel

PDF Hover Panel

Item_PDF_HoverPanel

Displays a search result hover panel that is customized for a PDF document.

Item display template

People Item

Item_Person

Displays a search result that is customized for a person.

Item display template

People Intent Item

Item_Person_CompactHorizontal

Displays a search result that is customized for showing a person in a compact and horizontal layout.

Hover panel

People Hover Panel

Item_Person_HoverPanel

Displays a search result hover panel that is customized for a person.

Item display template

Personal Result Item

Item_PersonalFavorite

Displays a personal favorite search result.

Item display template

Picture Item

Item_Picture

Displays a search result that is customized for a picture.

Hover panel

Picture Hover Panel

Item_Picture_HoverPanel

Displays a search result hover panel that is customized for a picture.

Item display template

PowerPoint Item

Item_PowerPoint

Displays a search result that is customized for a Microsoft PowerPoint document.

Hover panel

PowerPoint Hover Panel

Item_PowerPoint_HoverPanel

Displays a search result hover panel that is customized for a Microsoft PowerPoint document.

Item display template

Reply Item

Item_Reply

Displays a search result that is customized for a reply in community discussions.

Hover panel

Reply Hover Panel

Item_Reply_HoverPanel

Displays a search result hover panel that is customized for a reply in community discussions.

Item display template

Site Item

Item_Site

Displays a search result that is customized for a SharePoint site.

Hover panel

Site Hover Panel

Item_Site_HoverPanel

Displays a search result hover panel that is customized for a SharePoint site.

Item display template

Video Item

Item_Video

Displays a search result that is customized for a video file.

Item display template

Video

Item_VideoCompactHorizontal

Displays a search result that is customized for a video file horizontal layout.

Note:

The Video Hover Panel will not work with this display template

Hover panel

Video Hover Panel

Item_Video_HoverPanel

Displays a search result hover panel that is customized for video file.

Item display template

Web Page Item

Item_WebPage

Displays a search result that is customized for a web page.

Hover panel

Web page Hover Panel

Item_WebPage_HoverPanel

Displays a search result hover panel that is customized for a web page.

Item display template

Word Item

Item_Word

Displays a search result that is customized for a Microsoft Word document.

Hover panel

Word Hover Panel

Item_Word_HoverPanel

Displays a search result hover panel that is customized for a Microsoft Word document.


Conformance statement A-level for SharePoint Server 2013

Published: May 7, 2013

Summary: Conformance statement A-level for SharePoint Server 2013 in regards to Web Content Accessibility Guidelines 2.0 (http://www.w3.org/TR/WCAG20/).

Applies to: SharePoint Server 2013

Level A Principle 1: Perceivable - Information and user interface components must be presentable to users in ways they can perceive

Guideline 1.1 Text Alternatives: Provide text alternatives for any non-text content so that it can be changed into other forms people need, such as large print, braille, speech, symbols or simpler language.

Criteria Supporting Feature Remarks and Explanations

1.1.1 Non-text Content: All non-text content that is presented to the user has a text alternative that serves the equivalent purpose, except for the situations listed below.

  • Controls, Input

    If non-text content is a control or accepts user input, then it has a name that describes its purpose.

    Refer to Guideline 4.1 for additional requirements for controls and content that accepts user input.

  • Time-Based Media

    If non-text content is time-based media, then text alternatives at least provide descriptive identification of the non-text content.

    Refer to Guideline 1.2 for additional requirements for media.

  • Test

    If non-text content is a test or exercise that would be invalid if presented in text, then text alternatives at least provide descriptive identification of the non-text content.

  • Sensory

    If non-text content is primarily intended to create a specific sensory experience, then text alternatives at least provide descriptive identification of the non-text content.

  • CAPTCHA

    If the purpose of non-text content is to confirm that content is being accessed by a person rather than a computer, then text alternatives that identify and describe the purpose of the non-text content are provided, and alternative forms of CAPTCHA using output modes for different types of sensory perception are provided to accommodate different disabilities.

  • Decoration, Formatting, Invisible

    If non-text content is pure decoration, is used only for visual formatting, or is not presented to users, then it is implemented in a way that it can be ignored by assistive technology.

Supported

Guideline 1.2 Time-based Media: Provide alternatives for time-based media.

Criteria Supporting Feature Remarks and Explanations

1.2.1 Audio-only and Video-only (prerecorded): For prerecorded audio-only and prerecorded video-only media, the following are true, except when the audio or video is a media alternative for text and is clearly labeled as such:

  • Prerecorded audio-only

    An alternative for time-based media is provided that presents equivalent information for prerecorded audio-only content.

  • Prerecorded video-only

    Either an alternative for time-based media or an audio track is provided that presents equivalent information for prerecorded video-only content.

Not Applicable

1.2.2 Captions (Prerecorded): Captions are provided for all prerecorded audio content in synchronized media, except when the media is a media alternative for text and is clearly labeled as such.

Not Applicable

1.2.3 Audio Description or Media Alternative (Prerecorded): An alternative for time-based media or audio description of the prerecorded video content is provided for synchronized media, except when the media is a media alternative for text and is clearly labeled as such.

Not Applicable

Guideline 1.3 Adaptable: Create content that can be presented in different ways (for example simpler layout) without losing information or structure.

Criteria | Supporting Feature | Remarks and Explanations
1.3.1 Info and Relationships: Information, structure, and relationships conveyed through presentation can be programmatically determined or are available in text. | Supported |
1.3.2 Meaningful Sequence: When the sequence in which content is presented affects its meaning, a correct reading sequence can be programmatically determined. | Supported |
1.3.3 Sensory Characteristics: Instructions provided for understanding and operating content do not rely solely on sensory characteristics of components such as shape, size, visual location, orientation, or sound. | Supported |

Guideline 1.4 Distinguishable: Make it easier for users to see and hear content including separating foreground from background.

Criteria | Supporting Feature | Remarks and Explanations
1.4.1 Use of Color: Color is not used as the only visual means of conveying information, indicating an action, prompting a response, or distinguishing a visual element. | Supported |
1.4.2 Audio Control: If any audio on a Web page plays automatically for more than 3 seconds, either a mechanism is available to pause or stop the audio, or a mechanism is available to control audio volume independently from the overall system volume level. | Not Applicable |

Level A Principle 2: Operable - User interface components and navigation must be operable

Guideline 2.1 Keyboard Accessible: Make all functionality available from a keyboard.

Criteria | Supporting Feature | Remarks and Explanations
2.1.1 Keyboard: All functionality of the content is operable through a keyboard interface without requiring specific timings for individual keystrokes, except where the underlying function requires input that depends on the path of the user's movement and not just the endpoints. | Supported |
2.1.2 No Keyboard Trap: If keyboard focus can be moved to a component of the page using a keyboard interface, then focus can be moved away from that component using only a keyboard interface. If it requires more than unmodified arrow or tab keys or other standard exit methods, the user is advised of the method for moving focus away. | Supported |

Guideline 2.2 Enough Time: Provide users enough time to read and use content.

Criteria Supporting Feature Remarks and Explanations

2.2.1 Timing Adjustable: For each time limit that is set by the content, at least one of the following is true:

  • Turn off

    The user is allowed to turn off the time limit before encountering it.

  • Adjust

    The user is allowed to adjust the time limit before encountering it over a wide range that is at least ten times the length of the default setting.

  • Extend

    The user is warned before time expires and given at least 20 seconds to extend the time limit with a simple action (for example, "press the space bar"), and the user is allowed to extend the time limit at least ten times.

  • Real-time Exception

    The time limit is a required part of a real-time event (for example, an auction), and no alternative to the time limit is possible.

  • Essential Exception

    The time limit is essential and extending it would invalidate the activity.

  • 20 Hour Exception

    The time limit is longer than 20 hours.

Supported

2.2.2 Pause, Stop, Hide: For moving, blinking, scrolling, or auto-updating information, all of the following are true:

  • Moving, blinking, scrolling

    For any moving, blinking or scrolling information that (1) starts automatically, (2) lasts more than five seconds, and (3) is presented in parallel with other content, there is a mechanism for the user to pause, stop, or hide it unless the movement, blinking, or scrolling is part of an activity where it is essential.

  • Auto-updating

    For any auto-updating information that (1) starts automatically and (2) is presented in parallel with other content, there is a mechanism for the user to pause, stop, or hide it or to control the frequency of the update unless the auto-updating is part of an activity where it is essential.

Supported

Guideline 2.3 Seizures: Do not design content in a way that is known to cause seizures.

Criteria | Supporting Feature | Remarks and Explanations
2.3.1 Three Flashes or Below Threshold: Web pages do not contain anything that flashes more than three times in any one second period, or the flash is below the general flash and red flash thresholds. | Supported |

Guideline 2.4 Navigable: Provide ways to help users navigate, find content, and determine where they are.

Criteria | Supporting Feature | Remarks and Explanations
2.4.1 Bypass Blocks: A mechanism is available to bypass blocks of content that are repeated on multiple web pages. | Supported |
2.4.2 Page Titled: Web pages have titles that describe topic or purpose. | Supported |
2.4.3 Focus Order: If a web page can be navigated sequentially and the navigation sequences affect meaning or operation, focusable components receive focus in an order that preserves meaning and operability. | Supported |
2.4.4 Link Purpose (In Context): The purpose of each link can be determined from the link text alone or from the link text together with its programmatically determined link context, except where the purpose of the link would be ambiguous to users in general. | Supported |

Level A Principle 3: Understandable - Information and the operation of user interface must be understandable.

Guideline 3.1 Readable: Make text content readable and understandable.

Criteria | Supporting Feature | Remarks and Explanations
3.1.1 Language of Page: The default human language of each web page can be programmatically determined. | Supported |

Guideline 3.2 Predictable: Make web pages appear and operate in predictable ways.

Criteria | Supporting Feature | Remarks and Explanations
3.2.1 On Focus: When any component receives focus, it does not initiate a change of context. | Supported |
3.2.2 On Input: Changing the setting of any user interface component does not automatically cause a change of context unless the user has been advised of the behavior before using the component. | Supported |

Guideline 3.3 Input Assistance: Help users avoid and correct mistakes.

Criteria | Supporting Feature | Remarks and Explanations
3.3.1 Error Identification: If an input error is automatically detected, the item that is in error is identified and the error is described to the user in text. | Supported |
3.3.2 Labels or Instructions: Labels or instructions are provided when content requires user input. | Supported |

Level A Principle 4: Robust - Content must be robust enough that it can be interpreted reliably by a wide variety of user agents, including assistive technologies

Guideline 4.1 Compatible: Maximize compatibility with current and future user agents, including assistive technologies.

Criteria Supporting Feature Remarks and Explanations

4.1.1 Parsing: If markup languages implement content, elements have complete start and end tags, elements are nested according to their specifications, elements do not contain duplicate attributes, and any IDs are unique, except where the specifications allow these features.

Supported

4.1.2 Name, Role, Value: For all user interface components (including but not limited to form elements, links, and components that scripts generate), the name and role can be programmatically determined. States, properties, and values that can be set by the user can be programmatically set. Notification of changes to these items is available to user agents, including assistive technologies.

Note:

This success criterion is primarily for web authors who develop or script their own user interface components. For example, standard HTML controls already meet this success criterion when used according to specification.

Supported

Customization of the product voids this conformance statement from Microsoft. Customers may make independent conformance statements if they have conducted due diligence to meet all relevant requirements for their customization.

Please consult with Assistive Technology (AT) vendors for compatibility specifications of specific AT products. AT products that are compatible with all the rely-upon-technologies are expected to be functional with the product.

This document is for informational purposes only. MICROSOFT MAKES NO WARRANTIES, EXPRESS OR IMPLIED, IN THIS DOCUMENT.

Revised 05/07/2013.

Microsoft regularly updates its websites and provides new information about the accessibility of products as that information becomes available.


Conformance statement AA-level for SharePoint Server 2013

Summary: Conformance statement AA-level for SharePoint Server 2013 in regards to Web Content Accessibility Guidelines 2.0 (http://www.w3.org/TR/WCAG20/).

Applies to: SharePoint Server 2013

Level AA Principle 1: Perceivable - Information and user interface components must be presentable to users in ways they can perceive

Guideline 1.2 Time-based Media: Provide alternatives for time-based media.

Criteria | Supporting Feature | Remarks and Explanations
1.2.4 Captions (Live): Captions are provided for all live audio content in synchronized media. | Not Applicable |
1.2.5 Audio Description (Prerecorded): Audio description is provided for all prerecorded video content in synchronized media. | Not Applicable |

Guideline 1.4 Distinguishable: Make it easier for users to see and hear content including separating foreground from background.

Criteria Supporting Feature Remarks and Explanations

1.4.3 Contrast (Minimum): The visual presentation of text and images of text has a contrast ratio of at least 4.5:1, except for the following:

  • Large Text

    Large-scale text and images of large-scale text have a contrast ratio of at least 3:1.

  • Incidental

    Text or images of text that are part of an inactive user interface component, that are pure decoration, that are not visible to anyone, or that are part of a picture that contains significant other visual content, have no contrast requirement.

  • Logotypes

    Text that is part of a logo or brand name has no minimum contrast requirement.

Supported

1.4.4 Resize text: Except for captions and images of text, text can be resized without assistive technology up to 200 percent without loss of content or functionality.

Supported

1.4.5 Images of Text: If the technologies being used can achieve the visual presentation, text is used to convey information rather than images of text except for the following:

  • Customizable

    The image of text can be visually customized to the user's requirements.

  • Essential

    A particular presentation of text is essential to the information being conveyed.

Supported

Level AA Principle 2: Operable - User interface components and navigation must be operable

Guideline 2.4 Navigable: Provide ways to help users navigate, find content, and determine where they are.

Criteria | Supporting Feature | Remarks and Explanations
2.4.5 Multiple Ways: More than one way is available to locate a web page within a set of web pages except where the web page is the result of, or a step in, a process. | Supported |
2.4.6 Headings and Labels: Headings and labels describe topic or purpose. | Supported |
2.4.7 Focus Visible: Any keyboard operable user interface has a mode of operation where the keyboard focus indicator is visible. | Supported |

Level AA Principle 3: Understandable - Information and the operation of user interface must be understandable

Guideline 3.1 Readable: Make text content readable and understandable.

Criteria | Supporting Feature | Remarks and Explanations
3.1.2 Language of Parts: The human language of each passage or phrase in the content can be programmatically determined except for proper names, technical terms, words of indeterminate language, and words or phrases that have become part of the vernacular of the immediately surrounding text. | Supported |

Guideline 3.2 Predictable: Make web pages appear and operate in predictable ways.

Criteria | Supporting Feature | Remarks and Explanations
3.2.3 Consistent Navigation: Navigational mechanisms that are repeated on multiple web pages within a set of web pages occur in the same relative order each time they are repeated, unless a change is initiated by the user. | Supported |
3.2.4 Consistent Identification: Components that have the same functionality within a set of web pages are identified consistently. | Supported |

Guideline 3.3 Input Assistance: Help users avoid and correct mistakes.

Criteria Supporting Feature Remarks and Explanations

3.3.3 Error Suggestion: If an input error is automatically detected and suggestions for correction are known, then the suggestions are provided to the user, unless it would jeopardize the security or purpose of the content.

Supported

3.3.4 Error Prevention (Legal, Financial, Data): For web pages that cause legal commitments or financial transactions for the user to occur, that modify or delete user-controllable data in data storage systems, or that submit user test responses, at least one of the following is true:

  • Reversible: Submissions are reversible.

  • Checked: Data entered by the user is checked for input errors and the user is provided an opportunity to correct them.

  • Confirmed: A mechanism is available for reviewing, confirming, and correcting information before finalizing the submission.

Supported

Customization of the product voids this conformance statement from Microsoft. Customers may make independent conformance statements if they have conducted due diligence to meet all relevant requirements for their customization.

Please consult with Assistive Technology (AT) vendors for compatibility specifications of specific AT products. AT products that are compatible with all the rely-upon-technologies are expected to be functional with the product.

This document is for informational purposes only. MICROSOFT MAKES NO WARRANTIES, EXPRESS OR IMPLIED, IN THIS DOCUMENT.

Revised 05/07/2013.

Microsoft regularly updates its websites and provides new information about the accessibility of products as that information becomes available.


Solutions for the real world in SharePoint 2013

Summary SharePoint 2013 can provide solutions to many common business problems. Use these resources to explore real-world scenarios.

Applies to: SharePoint Server 2013

Scenarios and solutions

The following scenarios and solutions in SharePoint 2013 are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
Scenario icon | Business intelligence scenarios and solutions | Learn about using SharePoint 2013 to create solutions for business intelligence.
Building blocks | Hybrid for SharePoint Server 2013 | Learn about hybrid for SharePoint Server and Microsoft Office 365 - SharePoint Online.
Downloads | How to build a social media-sharing site in SharePoint 2013 (white paper) | Learn how to build a social media-sharing site in SharePoint 2013.

Additional resources for SharePoint 2013

The following resources about scenarios and solutions for SharePoint 2013 are available from other subject matter experts.

Content Description

House icon

  • SharePoint TechCenter

  • Upgrade and migration resource center

Visit the TechCenter and resource centers to access videos, community sites, documentation, and more.

Code icon

  • SharePoint for developers

  • Build apps for SharePoint

  • Find developer resources for SharePoint 2013, including code samples, training, and SDKs.

Chat icon

  • SharePoint blog

  • To the SharePoint (for IT pros)

  • Office 365 Technical Blog

  • Keep up with news from the teams that create and document SharePoint 2013.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support


Business intelligence scenarios and solutions
See also

Published: July 26, 2012

Summary Learn about using SharePoint 2013 to create solutions for business intelligence.

Applies to: SharePoint Server 2013 Enterprise

The articles in this section are intended to help you apply and integrate SharePoint 2013 service applications to meet your business intelligence needs.

TechNet articles about business intelligence scenarios and solutions

The following articles about business intelligence scenarios and solutions are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

SharePoint logo | Content | Description
 | Configure AdventureWorks for Business Intelligence solutions | Configure the AdventureWorks sample data for use with Excel, Excel Services, and PerformancePoint Services Business Intelligence scenarios.
 | Creating solutions by using Adventure Works sample data | Create, publish, and use dashboards that consume AdventureWorks sample data.
 | Configure Analysis Services for processing data models in Excel Services | Install SQL Server Analysis Services 2012 SP1 CTP3 for processing data models in Excel Services in SharePoint Server 2013.
 | Refreshing Excel workbooks with embedded PowerPivot models from SharePoint Online (white paper) | Perform scheduled refresh of workbooks that contain data models published to SharePoint Online using data sources that are on-premises or in the cloud.
 | Secure Store for Business Intelligence service applications (SharePoint Server 2013) | Learn how Secure Store works with Excel Services, PerformancePoint Services, and Visio Services to refresh data on SharePoint Server 2013.
 | Test Lab Guides for Business Intelligence | This series of articles describes how to configure the Business Intelligence features in SharePoint Server 2013 in a test lab environment.
 | Use Analysis Services EffectiveUserName in SharePoint Server 2013 | Use the EffectiveUserName option in Excel Services or PerformancePoint Services for per-user authentication with Analysis Services data sources.
 | Use Secure Store with SQL Server Authentication (SharePoint Server 2013) | Use Secure Store Service to store credentials for data sources that require SQL Server Authentication.
 | Use Visio Services with external lists in SharePoint 2013 | Connect to an external list in Visio by using Microsoft Business Connectivity Services and display the diagram in a browser by using Visio Services.
 | Use Visio Services with SharePoint lists (SharePoint Server 2013) | Connect a Visio diagram to the data in a SharePoint list and maintain that connection when you publish the diagram to SharePoint Server 2013.
 | Viewing reports and dashboards on mobile devices | Learn how to view reports and dashboards on mobile devices, such as Apple iPad and Windows 8 tablet devices.

See also

Resource Center: Business Intelligence in SharePoint Server 2013
Business intelligence capabilities in Excel 2013 and SharePoint Online (Office 365)


Configure AdventureWorks for Business Intelligence solutions

Summary: Configure the AdventureWorks sample data for use with Excel, Excel Services, and PerformancePoint Services business intelligence scenarios.

Applies to: SharePoint Server 2013 Enterprise

The AdventureWorks sample data set provides a sample database, data warehouse, and OLAP cube. The subsequent articles in this section make use of this sample data to demonstrate Business Intelligence capabilities in Excel 2013, Excel Services, and PerformancePoint Services. This article describes how to install and configure the AdventureWorks sample data set and configure a Business Intelligence Center on your SharePoint Server 2013 farm.

Important:

This scenario applies only to SharePoint Server 2013 Enterprise.

In this article:

  • Scenario overview

  • Before you begin

  • Video demonstration

  • Install the AdventureWorks sample data

  • Create a Business Intelligence Center

  • Scenarios that use this configuration

Scenario overview

Installing the AdventureWorks sample data set consists of downloading the sample data, attaching the sample databases in SQL Server Management Studio, and deploying the sample OLAP cube using the SQL Server Data Tools.

Creating a Business Intelligence Center consists of creating a new site collection with the Business Intelligence Center template using the SharePoint Central Administration website.

The procedures for completing both of these tasks, plus procedures for configuring the required user access and permissions are included in this article.

Before you begin

Before starting, read the following information about permissions and software requirements:

  • To deploy the AdventureWorks sample data, you must be a SQL Server and Analysis Services administrator.

  • To create a Business Intelligence Center, you must be a farm administrator on the SharePoint Server 2013 farm.

The subsequent articles make use of Excel Services and PerformancePoint Services. It is assumed that these are configured on your farm. For information about deploying Excel Services, see Overview of Excel Services in SharePoint Server 2013 and Configure Excel Services in SharePoint Server 2013. For information about deploying PerformancePoint Services, see PerformancePoint Services administration (SharePoint Server 2013).

When using Excel Services or PerformancePoint Services, user access can be provided using Windows Authentication with Kerberos delegation, the Secure Store Service, or, with OLAP data sources, the EffectiveUserName feature. It is assumed that one or more of these options are configured on your farm. For information about configuring Secure Store, see Plan the Secure Store Service in SharePoint Server 2013 and Configure the Secure Store Service in SharePoint 2013. For information about configuring the EffectiveUserName feature for OLAP data sources, see Use Analysis Services EffectiveUserName in SharePoint Server 2013.

Video demonstration

This video shows the steps involved in installing and configuring the AdventureWorks sample data set, as described in this article.

Video: Configure AdventureWorks for Business Intelligence solutions

Video (play button) icon

Install the AdventureWorks sample data

The AdventureWorks sample data consists of:

  • The AdventureWorks2012 database

  • The AdventureWorksDW2012 database

  • The AdventureWorksDW2012Multidimensional-EE OLAP cube

The following sections describe how to deploy each of these data sets.

Deploy the AdventureWorks sample databases

Each of the two AdventureWorks sample databases must be downloaded separately.

Use the following procedure to download and deploy the AdventureWorks2012 database.

To deploy the AdventureWorks2012 database

  1. Download AdventureWorks2012_Data.mdf.

    Note:

    Because this file was downloaded from the Internet, it may be blocked by Windows. Right-click the file, and then click Properties. Click the Unblock button if it is present, and then click OK. (If the Unblock button is not present, then the file is not blocked.)

  2. Copy AdventureWorks2012_Data.mdf to your default database directory (normally \Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA) or other location as designated by your database administrator.

  3. Open SQL Server Management Studio.

  4. Connect to the database engine.

  5. Right-click Databases, and then click Attach.

  6. On the Attach Databases dialog box, click Add.

  7. Navigate to the location where you copied AdventureWorks2012_Data.mdf, select the file, and then click OK.

  8. Under "AdventureWorks2012" database details, select the row where File Type is Log.

  9. Click Remove.

  10. Click OK.

Use the following procedure to download and deploy the AdventureWorksDW2012 data warehouse database.

To deploy the AdventureWorksDW2012 data warehouse

  1. Download AdventureWorksDW2012_Data.mdf.

    Note:

    Because this file was downloaded from the Internet, it may be blocked by Windows. Right-click the file, and then click Properties. Click the Unblock button if it is present, and then click OK. (If the Unblock button is not present, then the file is not blocked.)

  2. Copy AdventureWorksDW2012_Data.mdf to your default database directory (normally \Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA) or other location as designated by your database administrator.

  3. Open SQL Server Management Studio.

  4. Connect to the database engine.

  5. Right-click Databases, and then click Attach.

  6. On the Attach Databases dialog box, click Add.

  7. Navigate to the location where you copied AdventureWorksDW2012_Data.mdf, select the file, and then click OK.

  8. Under "AdventureWorksDW2012" database details, select the row where File Type is Log.

  9. Click Remove.

  10. Click OK.

Deploy the AdventureWorks sample OLAP cube

The following requirements must be met before you can deploy the sample OLAP cube. Procedures are provided to accomplish each of these tasks if they have not already been completed in your environment.

  • The AdventureWorksDW2012 database must be deployed on the SQL Server database engine as covered in the section above.

  • The SQL Server Data Tools must be installed as part of your SQL Server and Analysis Services deployment.

    Note:

    SQL Server Data Tools was known as Business Intelligence Developer Studio (BIDS) in previous versions of SQL Server.

  • The account running the Analysis Services service must have a login on the SQL Server database engine.

If you have not deployed the AdventureWorksDW2012 database, do so now using the procedures under Deploy the AdventureWorks sample databases before proceeding with the procedures in this section.

If you have not deployed the SQL Server Data Tools, use the following procedure to deploy them.

Note:

You can determine if the SQL Server Data Tools are installed by clicking Start, All Programs, and then Microsoft SQL Server 2012 on the computer running SQL Server. If the SQL Server Data Tools are installed, it will appear in the menu under Microsoft SQL Server 2012.

To install the SQL Server Data Tools

  1. On the SQL Server 2012 DVD, run setup.exe.

  2. In the SQL Server Installation Center, on the left pane, click Installation.

  3. In the right pane, click New SQL Server stand-alone installation or add features to an existing installation.

  4. On the Setup Support Rules page, click OK.

  5. On the Product Updates page click Next.

  6. On the Setup Support Rules page, click Next.

  7. On the Installation Type page, select the Add features to an existing instance of SQL Server 2012 option, and select the instance where you want to install the SQL Server Data Tools.

  8. Click Next.

  9. On the Feature Selection page, select the SQL Server Data Tools check box, and then click Next.

  10. On the Installation Rules page, click Next.

  11. On the Disk Space Requirements page, click Next.

  12. On the Error Reporting page, click Next.

  13. On the Installation Configuration Rules page, click Next.

  14. On the Ready to Install page, click Install.

  15. When the installation completes, click Close.

Once the SQL Server Data Tools have been installed, the next step is to create a login for the account running Analysis Services if one does not already exist.

If you do not know what account is running Analysis Services, use the following procedure to determine the account.

To determine the Analysis Services service account

  1. On the computer running Analysis Services, click Start, click All Programs, click Microsoft SQL Server 2012, click Configuration Tools, and then click SQL Server Configuration Manager.

  2. In the left pane, click SQL Server Services.

  3. In the right pane, find the instance of Analysis Services that you will be using, and note the account listed in the Log On As column. This is the account for which you must add a logon in SQL Server.

If you do not already have a SQL Server login for the account running Analysis Services, use the following procedure to create one.

To add a login for the Analysis Services service account

  1. Open SQL Server Management Studio.

  2. Connect to the database engine.

  3. Expand Security.

  4. Right-click Logins and click New Login.

  5. In the Login name text box, type the name of the account running the Analysis Services service.

  6. Click OK.

    Note:

    This login does not require any Server Roles other than the default role of Public. No User Mapping is necessary.

Once you have configured the login for the Analysis Services service account, the next step is to download and deploy the AdventureWorks OLAP cube. Use the following procedure to download and deploy the cube.

To configure the AdventureWorks OLAP cube

  1. Download AdventureWorks Multidimensional Models SQL Server 2012.zip

    Note:

    Because this file was downloaded from the Internet, it may be blocked by Windows. Right-click the file, and then click Properties. Click the Unblock button if it is present, and then click OK. (If the Unblock button is not present, then the file is not blocked.)

  2. Unzip the file to a location on the computer running Analysis Services.

  3. In the Enterprise folder, double-click AdventureWorksDW2012Multidimensional-EE.sln.

  4. If the Choose Default Environment Settings dialog box appears, choose the Business Intelligence Settings option, and then click Start Visual Studio.

  5. In Visual Studio, at the top of the Solution Explorer window, right click AdventureWorksDW2012Multidimensional-EE and click Deploy.

  6. Close Visual Studio without saving changes.

Configure AdventureWorks user access

Once the databases and the cube have been deployed, you must grant your users access to them. The following access is required:

  • Users who will be creating reports or dashboards in the subsequent articles in this section must have db_datareader access to the AdventureWorks databases and Read access to the AdventureWorks cube.

  • If you are using the unattended service account with Excel Services or PerformancePoint Services, that account must have db_datareader access to the AdventureWorks databases and Read access to the AdventureWorks cube.

  • If you are using Secure Store to refresh data in Excel Services or PerformancePoint Services, the target application credentials must have db_datareader access to the AdventureWorks databases and Read access to the AdventureWorks cube.

We recommend that you use an Active Directory group containing the users to whom you want to grant access.

Use the following procedure to grant access to the AdventureWorks databases. If you choose to grant access to each user individually instead of using an Active Directory group, you must create a separate login for each user.

To grant access to the AdventureWorks databases

  1. In SQL Server Management Studio, connect to the database engine.

  2. Expand Security.

  3. Right-click Logins, and then click New Login.

  4. Click Search.

  5. If you are using an Active Directory group, click Object Types, select the Groups check box, and then click OK.

  6. On the Select User or Group dialog box, type the name of the Active Directory group or user to whom you want to grant database access, and then click OK.

  7. Under Select a page, click User Mapping.

  8. Select the Map check box for AdventureWorks2012, and then select the db_datareader database role membership check box.

  9. Select the Map check box for AdventureWorksDW2012, and then select the db_datareader database role membership check box.

  10. Click OK.

Use the following procedure to grant access to the AdventureWorks OLAP cube.

To grant access to the AdventureWorks OLAP cube

  1. In SQL Server Management Studio, connect to Analysis Services.

  2. Expand Databases, and then expand AdventureWorksDW2012Multidimensional-EE.

    Note:

    If the AdventureWorksDW2012Multidimensional-EE database is not present, then right-click Databases and click Refresh.

  3. Right-click Roles and then click New Role.

  4. In the Role name text box, type a name for the role.

  5. In the Select a page pane, click Membership.

  6. Click Add.

  7. Type the name of the users or Active Directory group to whom you want to grant cube access.

    Note:

    If you will be using Secure Store or an unattended service account to access the cube, include those credentials here.

  8. On the Select Users or Groups dialog box, click OK.

  9. In the Select a page pane, click Cubes.

  10. In the right pane, in the Access column, click select Read from the dropdown list for Adventure Works and Mined Customers.

  11. In the right pane, in the Local Cube/Drillthrough Access column, click select Drillthrough from the dropdown list for Adventure Works and Mined Customers.

  12. Click OK.

Create a Business Intelligence Center

The subsequent articles in this section rely on a Business Intelligence Center site being present. If you have an existing Business Intelligence Center, you can use it. However, we recommend creating a new Business Intelligence Center that is not part of your production environment.

Use the following procedure to create a Business Intelligence Center.

To create a Business Intelligence Center

  1. On the SharePoint Central Administration website, under Application Management, click Create site collections.

  2. On the Create Site Collection page:

    1. Type a title in the Title text box.

    2. Type the URL that you want to use in the URL text box.

    3. Under Select a template, choose the Enterprise tab, and then select Business Intelligence Center.

    4. In the Primary Site Collection Administrator section, type a name for the primary site collection administrator in the User name text box.

    5. Optionally, type a name for the secondary site collection administrator.

    6. Optionally, select a quota template.

    7. Click OK.

Configure BI Center access

The following table describes the permissions available in a Business Intelligence Center.

Business Intelligence Center permissions

Account | Permissions
Visitors | Read Read permissions enable users to view information in the Business Intelligence Center.
Members | Contribute Contribute permissions enable users to view and create items, such as reports, and save them to this site.
Designers | Design Design permissions enable users to view, create, and publish items that include dashboards.
Owners | Full Control Full Control permissions enable users to view, create, and publish dashboard content, and to view or edit user permissions

For the scenarios described in the subsequent articles in this section, users will need the following permissions.

  • Users publishing workbooks to the Business Intelligence Center from Excel require Contribute permissions and must be added to the Members group.

  • Users publishing dashboards from PerformancePoint Dashboard Designer require Design permissions and must be added to the Designers group.

  • Users who are only viewing reports or dashboards in the Business Intelligence Center but not publishing only require Read permission and can be added to the Visitors group.

Use the following procedure to configure permissions for the Business Intelligence Center.

To set permissions in the Business Intelligence Center

  1. In the Business Intelligence Center, click Share.

  2. Type the names of the users or groups to whom you want to grant access.

  3. Click Show Options.

  4. On the Select a group or permission level dropdown list, select the permission level that you want.

  5. Click Share.

Scenarios that use this configuration

The following scenarios use the AdventureWorks sample data and Business Intelligence Center as configured in this article:

  • Create an Excel Services dashboard using SQL Server Analysis Services data


Configure Power Pivot for SharePoint 2013

Published: October 1, 2013

Summary: Learn how to configure Power Pivot for SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

Important:

This scenario applies only to SharePoint Server 2013 Enterprise and SQL Server 2012 with Service Pack 1 (SP1).

In this scenario, we'll take a look at how to set up Power Pivot for SharePoint 2013. This includes installing Power Pivot for SharePoint on the servers in your farm, configuring a Power Pivot service application, and running some tests to make sure everything is working properly.

Before you begin

Before getting started, make sure you have:

  • Configured Excel Services in your SharePoint Server farm.

  • Configured a data model server in Excel Services. You'll need an instance of Analysis Services 2012 SP1 configured in Power Pivot mode in order to do this.

  • Configured Secure Store in your SharePoint Server farm.

  • Downloaded Microsoft SQL Server 2012 SP1 PowerPivot for Microsoft SharePoint (spPowerPivot.msi). (We'll be installing this program using the procedures in this article.)

  • Created an Active Directory account for the Power Pivot application pool. This is a domain user account and doesn't require any special permissions. It should be a unique account created for this purpose.

  • Created an Active Directory account for the Power Pivot unattended data refresh account. This is a domain user account and must have read permissions to the data sources that you plan to use for your Power Pivot reports. It should be a unique account created for this purpose.

You may notice that the Power Pivot configuration tool that we'll be using has options for deploying Excel Services and Secure Store. However, the Power Pivot configuration tool is not able to configure these services using the recommended accounts, so we recommend that you configure these services manually using the links above.

Prepare the farm

In this section, we will prepare the farm for Power Pivot installation. This includes registering a managed account and configuring some Secure Store settings in Central Administration, as well as configuring some security settings in SQL Server. You'll need to be a farm administrator and a SQL Server administrator to do these steps, as well as a Shell Administrator to do the Windows PowerShell steps.

Register a domain account as a managed account in SharePoint Server 2013
The first step is to register the domain account that you want to use to run the Power Pivot application pool as a managed account in SharePoint Server. This will make the account available for us to use when we create the Power Pivot service application later on.

To register a managed account

  1. In Central Administration, click Security.

  2. Under General Security, click Configure managed accounts.

  3. Click Register Managed Account.

  4. Type the username and password of the account that you created to run the Power Pivot application pool.

  5. If you want SharePoint Server to handle account password changes for you, select the Enable password change check box, and then fill in the details on when you want the password changed.

  6. Click OK.

Grant the managed account access to the content database
You must also grant access to the SharePoint content database for this account. Use the following procedure for each web application that will be associated with Power Pivot.

To grant content database access to the managed account

  1. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell, and then click Run as Administrator.

  2. At the Windows PowerShell Command Prompt, type the following syntax (press ENTER after each line):

    Copy code
    $w = Get-SPWebApplication -identity http://<WebApplication>
$w.GrantAccessToProcessIdentity("<Domain>\<PowerPivotApplicationPoolAccount>")
Important:

If in the future you add more content databases, you'll need to rerun these cmdlets to ensure that Power Pivot has access to the new databases.

Create a target application in Secure Store
The next step is to create a target application in Secure Store for the Power Pivot unattended data refresh account. This target application will be used to refresh the data in your Power Pivot reports.

To create a target application

  1. In Central Administration, under Application Management, click Manage service applications.

  2. Click the Secure Store service application.

  3. In the ribbon, click New.

  4. In the Target Application ID box, type PowerPivotUnattendedAccount.

    Note:

    Be sure to use this value so that the Power Pivot for SharePoint 2013 Configuration tool will recognize it.

  5. Type a display name and email address.

  6. For Target Application Type, make sure Individual is selected, and then click Next.

  7. Ensure Field Type is set to Windows User Name and Windows Password, and click Next.

  8. Type a name or group for the Target Application Administrators, and then click OK.

  9. Select the target application that you just created, and then in the Credentials section of the ribbon, click Set.

  10. For Credential Owner, type the account that you created for the Power Pivot application pool (the one that you just configured as a managed account).

  11. Type the user name and password of the credentials that have access to your data sources.

  12. Click OK.

Grant access to the SharePoint Server admin content database
In order for the Power Pivot Management Dashboard reports to work, the account that runs the Excel Services application pool must have read access to the SharePoint Server admin content database. You configure this in SQL Server.

To grant admin content database access

  1. Open SQL Server Management Studio and connect to the database engine.

  2. Expand Security and double-click the account that is used for the Excel Services application pool.

  3. On the User Mapping page, click the SharePoint Admin content database (usually named SharePoint_AdminContent_<GUID>).

  4. Select the SPDataAccess database role check box.

  5. Click OK.

The basic farm setup is now complete, so the next thing to do is to install and configure Power Pivot for SharePoint.

Configure Power Pivot for SharePoint

In this section, we'll configure Power Pivot itself, including installing the Power Pivot software and configuring a service application.

Install Power Pivot on each server in the farm
The first step in configuring Power Pivot in a SharePoint Server farm is to install SQL Server 2012 SP1 PowerPivot for Microsoft SharePoint (sppowerpivot.msi) on each server in the farm.

Use the following procedure to run sppowerpivot.msi on each server in your farm.

To install Power Pivot for SharePoint 2013

  1. Double-click sppowerpivot.msi.

  2. Follow the wizard to install Power Pivot for SharePoint 2013. When you see the Feature Selection page, leave all of the items selected (this is the default), and then complete the wizard.

Run the Power Pivot for SharePoint configuration tool
Once you have installed sppowerpivot.msi on each server in the farm, the next step is to run the PowerPivot for SharePoint 2013 Configuration tool. Run this program on the server that is running the SharePoint Central Administration website.

To run the Power Pivot for SharePoint 2013 Configuration tool

  1. Click Start > All Programs > Microsoft SQL Server 2012 > PowerPivot for SharePoint 2013 Configuration.

  2. Choose the Configure or Repair Power Pivot for SharePoint option, and then click OK.

  3. In the Power Pivot Configuration Tool, in the left pane, select Create PowerPivot Service application.

  4. On the Parameters tab, clear the Include this action in the task list check box. This will prevent the tool from creating a service application for Power Pivot. We will create the Power Pivot service application manually later.

    Screenshot of the checkbox unchecked.

    This will also prevent further configuration steps from being completed, but we'll come back and do those later as well.

  5. Click Run.

  6. Click Yes to confirm.

  7. When the action completes, click OK, and then click Exit.

If you have additional servers in your farm, we'll eventually run the Power Pivot for SharePoint 2013 Configuration tool on those as well, but first there are a few more steps to do.

Create a Power Pivot service application
We prevented the Power Pivot configuration tool from creating a Power Pivot service application, so that we could create one manually and use the application pool account that we created earlier. Now, we need to go back and create the service application.

To create a Power Pivot service application

  1. In Central Administration, under Application Management, click Manage service applications.

  2. In the ribbon, click New, and then click SQL Server Power Pivot Service Application.

  3. Type a name for the service application in the Name text box.

  4. Type a name for the new application pool in the Application pool name text box.

  5. From the Configurable dropdown list, choose the account that you registered as a managed account for the Power Pivot application pool.

  6. Click OK.

The Power Pivot service application has now been created, though you may need to refresh the page to see it.

Configure the Power Pivot unattended data refresh account
The next step is to configure the Power Pivot unattended data refresh account. We do this in the Power Pivot service application settings by specifying the unattended data refresh account that we created in Secure Store.

To configure the unattended data refresh account

  1. In Central Administration, under Application Management, click Manage service applications.

  2. Click the Power Pivot service application.

  3. Under Actions, click Configure service application settings.

  4. Under Data Refresh (about a third of the way down), type the target application ID of the target application that you created (PowerPivotUnattendedAccount) in the PowerPivot Unattended Data Refresh Account box.

  5. Click OK.

Rerun the Power Pivot for SharePoint 2013 Configuration tool
Now that the service application has been created and we've configured the unattended data refresh account, we need to run the Power Pivot for SharePoint 2013 Configuration tool once again to complete the remainder of the steps.

To run the Power Pivot for SharePoint 2013 Configuration tool

  1. Click Start > All Programs > Microsoft SQL Server 2012 > Power Pivot for SharePoint 2013 Configuration.

  2. Choose the Configure or Repair Power Pivot for SharePoint option, and then click OK.

  3. In the Power Pivot Configuration Tool, in the left pane, select Activate Power Pivot Feature in a Site Collection.

  4. On the Parameters tab, choose the site collection where you want to active Power Pivot from the Site URL dropdown list.

    Note:

    If you want to activate Power Pivot in more than one site collection, choose one to start with here. It's easy to add more later.

  5. If you changed the default site collection setting, click Validate.

  6. Click Run, and then click Yes to confirm.

  7. When the action completes, click OK, and then click Exit.

Power Pivot setup is now complete and Power Pivot is ready to use.

Run the Power Pivot for SharePoint Configuration tool on other servers in the farm
Because we've only run the Power Pivot for SharePoint 2013 Configuration tool on one server, the SQL Server Power Pivot System Service will only be available to run on this server. It's fine to use Power Pivot this way, but if you have multiple servers in your farm, we recommend that you install the service on all of them. This will allow you to change which server you run the service on (for example, if you want to balance out the services on your farm) or to run the service on multiple servers for greater capacity.

You install the SQL Server Power Pivot System Service by running the Power Pivot for SharePoint 2013 Configuration tool on the other servers in your farm.

Use the following procedure on each server in your farm.

To run the Power Pivot for SharePoint 2013 Configuration tool

  1. Click Start > All Programs > Microsoft SQL Server 2012 > PowerPivot for SharePoint 2013 Configuration.

  2. Choose the Configure or Repair Power Pivot for SharePoint option, and then click OK.

  3. If you see Activate PowerPivot Feature in a Site Collection in the left pane, click on it, and then select the site collection where you want to activate Power Pivot or uncheck the Include this action in the task list check box if you don't want to activate Power Pivot in another site collection.

  4. If you made any changes, click Validate.

  5. Click Run, and then click Yes to confirm.

  6. When the tasks complete, click OK, and then click Exit.

When you run the Power Pivot for SharePoint 2013 Configuration tool, it installs and turns on the SQL Server Power Pivot System Service on each server where you run it. You probably don't want this service running on every server, so be sure to go to Manage services on server in Central Administration and stop the service on the servers where you don't want to run it.

Test the Power Pivot for SharePoint installation

Now that everything is configured, we can do a simple test to see if it's working. We'll build a data model in Excel and publish it to a document library in the site collection where we enabled Power Pivot.

To create a test workbook

  1. In Excel, on the Data tab, choose From Other Sources, then choose From SQL Server.

  2. Type the name of the instance of SQL Server where your data resides.

  3. Follow the wizard through to connect to the table that contains your data.

  4. When the wizard completes, you should see the Import Data dialog box. Choose the Only Create Connection option and select the Add this data to the Data Model check box.

  5. Click OK.

  6. On the Power Pivot tab, click Manage.

  7. In the Power Pivot ribbon, click PivotTable.

  8. On the Insert Pivot dialog box, choose the Existing Worksheet option, and then click OK.

  9. Select the fields that you want in the PivotTable report.

  10. Save the workbook to a document library on the site collection where you enabled Power Pivot.

Once you've saved the workbook to the document library, you can access the Power Pivot settings by clicking the ellipsis (...) control twice, and then choosing Manage Power Pivot Data Refresh.

Screenshot of controls in document library.

On the Manage Data Refresh page, select the Enable and Also refresh as soon as possible check boxes. Also, ensure that the Use the data refresh account configured by the administrator option is selected. (This is the default.)

Screenshot of Power Pivot data refresh settings.

Repeat this several times while making some changes to your data. If the changes show up in the report when it's rendered in the browser, then data refresh is working properly.


Creating solutions by using Adventure Works sample data
See also

Published: December 18, 2012

Learn how to create and use reports and dashboards using downloadable AdventureWorks sample data.

Applies to: SharePoint Server 2013 Enterprise

Are you or people in your organization new to business intelligence with Office? Have you or your colleagues wanted to learn, step by step, how to create and consume reports, scorecards, and dashboards? The articles in this section can help.

In this section

This section contains detailed information about how to create and consume reports, scorecards, and dashboards using downloadable AdventureWorks sample data. Each article describes how to perform specific tasks so you'll know your way around business intelligence applications, such as Excel Services. The following table describes the articles that are included in this section.

Table: Summary of articles in this section

Article Description

Create an Excel Services dashboard using an OData data feed

This scenario shows how to create a basic dashboard that contains two reports and two slicers using data that is imported into Excel. This scenario also covers how to publish a workbook to a Documents library in either Office 365 or SharePoint Server 2013.

By following the steps in this article, you'll learn how to perform the following tasks:

  • Import data into Excel using an OData data feed

  • Create a relationship between two tables in a simple Data Model

  • Create and configure a basic dashboard that contains two reports and two slicers

  • Publish a dashboard to a Documents library in SharePoint Server (on premises) or Office 365 (online)

  • View and navigate a dashboard in a browser window

Create an Excel Services dashboard using SQL Server Analysis Services data

Learn how to create a basic dashboard in Excel using a single external data connection to a cube that is stored in SQL Server Analysis Services.

This scenario shows how to create a dashboard that contains four reports and a timeline control in Excel. This scenario also covers how to publish content to SharePoint Server, and how to consume the content in a browser window.

By following the steps in this article, you'll learn how to perform the following tasks:

  • Create and share an external data connection using Excel Services

  • Create and configure a dashboard that includes two PivotChart reports, two PivotTable reports, and a timeline control

  • View and navigate a dashboard in a browser window by using Excel Services

Create an Excel Services dashboard using a Data Model (SharePoint Server 2013)

Learn how to create a basic dashboard in Excel using a simple Data Model.

This scenario shows how to create a basic Data Model that contains several tables that are stored in SQL Server, and how to use that Data Model to create two reports and a slicer. This scenario also covers how to configure the reports to display meaningful information, and how to specify how you want a dashboard to be displayed in a browser window.

By following the steps in this article, you'll learn how to perform the following tasks:

  • Create a Data Model that consists of several tables of data

  • Create and configure a dashboard that includes two reports and a slicer

  • Configure a PivotChart chart report to display meaningful information in the chart legend

  • Format numeric information in a PivotTable report

  • Configure a dashboard to be displayed using worksheet view or gallery view in a browser window

See also

Configure AdventureWorks for Business Intelligence solutions


Create an Excel Services dashboard using an OData data feed
See also

Published: January 8, 2013

Summary: Learn how to create an Excel Services dashboard that can be published to a library in SharePoint Server or Office 365.

Applies to: SharePoint Server 2013 Enterprise

This article describes, step by step, how to use Excel 2013 to create a basic dashboard that contains two reports and two filters. The example dashboard described in this article resembles the following image:

Figure: Basic Excel Services dashboard that contains two reports and two slicers

Basic Excel Services dashboard

Our example dashboard uses data that is imported into Excel using an OData data feed. This makes it possible to publish the workbook to a library in either SharePoint Server or Office 365. By following the steps in this article, you'll learn how to import data into Excel, use that data to create reports in a worksheet, and connect filters to those reports.

In this article:

  • Before you begin

  • Plan the dashboard

  • Create the dashboard

    • Part 1: Create a data connection

    • Part 2: Create reports

    • Part 3: Create a filter

  • Publish the dashboard

  • Use the dashboard

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Excel 2013 must be installed on the computer that you are using to create and publish the dashboard.

  • This scenario uses Adventure Works sample data and a Business Intelligence Center site in SharePoint Server 2013.

    The Adventure Works sample data that we'll use is available via an OData data feed. For more information, see AdventureWorks OData Feed (on CodePlex).

    If you do not have a Business Intelligence Center site, have an IT administrator configure it for you by using the instructions in Configure AdventureWorks for Business Intelligence solutions.

  • If your organization is using SharePoint Server 2013 (on premises), then Excel Services must be configured to support Data Models. For information about how to deploy Excel Services, see Configure Excel Services in SharePoint Server 2013 and Manage Excel Services data model settings (SharePoint Server 2013).

  • If your organization is using Office 365 Preview, then you must have a subscription plan that includes Excel Services capabilities. For more information about Office 365 subscription plans, see Insights feature availability across Office 365 plans.

Plan the dashboard

Before you begin to create a dashboard, we recommend that you create a dashboard plan. The plan does not have to be extensive or complex. However, it should give you an idea of what you want to include in the dashboard. To help you prepare a dashboard plan, consider questions such as the following:

  • Who will use the dashboard?

  • What kinds of information do they want to see?

  • Does data exist that you can use to create the dashboard?

Our example dashboard is designed to be a prototype that you can use to learn how to create and publish Excel Services dashboards. To show how we might create a dashboard plan for a similar dashboard, see the following table.

Table: Basic plan for our example dashboard

Question Response

Who will use the dashboard?

The dashboard is intended for use by sales representatives, sales managers, corporate executives, and other stakeholders who are interested in sales information for the fictitious company Adventure Works Cycles.

How will the dashboard be used? That is, what kinds of information do the dashboard consumers want to see?

Sales representatives, managers, executives, and other dashboard consumers want to use the dashboard to view, explore, and analyze data. At a minimum, the dashboard consumers want to see the following kinds of information:

  • Sales amounts across different geographical areas

  • Sales amounts across different geographical areas

  • Sales amounts for different years

  • Sales amounts for different sales representatives

Dashboard consumers want to use the dashboard to view, explore, and analyze data to obtain answers to specific questions.

The dashboard consumers also want to be able to use filters to focus on more specific information, such as sales for a particular year or a particular sales representative.

Does data exist that we can use to create the dashboard?

Yes. The Adventure Works sample database that we'll use contains the data that we can use for the dashboard.

What items should the dashboard contain?

Our example dashboard includes the following items:

  • Data that is imported by using an OData data feed

  • A chart showing product sales information for different geographical areas

  • A chart showing sales information for different geographical areas

  • A slicer that dashboard consumers can use to view information for a particular year

  • A slicer that dashboard consumers can use to view information for a particular sales representative

Where will the dashboard be published?

Because our example dashboard uses native data in Excel, the dashboard can be published to a SharePoint library in SharePoint Server 2013 or in SharePoint Online. This enables people to consume the dashboard content internally or via an Internet connection. It also enables people to view the dashboard by using a mobile device, such as Apple iPad or Windows 8 tablet.

Now that we have created our dashboard plan, we can begin to create the dashboard.

Create the dashboard

To create the dashboard, we begin by creating a data connection. Then, we use that data connection to import data into Excel. Next, we create the reports and the filter that we want to use. After that, we publish the workbook to SharePoint Server or to Office 365 or both.

Part 1: Get data into Excel

Our example dashboard uses data that is imported into Excel via an OData data feed to connect to Adventure Works sample data. For more information, see AdventureWorks OData Feed (on CodePlex). We begin by importing data into Excel.

To import data into Excel by using an OData data feed

  1. Open Microsoft Excel.

  2. Choose Blank workbook to create a workbook.

  3. On the Data tab, choose Get External Data group, choose From Other Sources, and then choose From OData Data Feed.

    The Data Connection Wizard opens.

  4. On the Connect to Database Server page, in the Location of the data feed box, specify the website address (URL) for the data feed.

    For our example dashboard, we used http://services.odata.org/AdventureWorksV3/AdventureWorks.svc.

  5. In the Log on credentials section, take one of the following steps:

    • Choose Use the sign-in information for the person opening this file, and then choose the Next button.

    • Choose Use this name and password, specify an appropriate user name and password, and then choose the Next button.

    Tip:

    If you don't know which option to choose, contact a SharePoint administrator.

  6. On the Select Tables page, choose the CompanySales table and the TerritorySalesDrilldown table. Then choose the Next button.

  7. On the Save Data Connection File and Finish page, choose the Finish button.

  8. On the Import Data page, take the following steps:

    1. Select the Table option.

    2. Make sure the Add this data to the Data Model option is selected.

    3. Choose the OK button.

    Sheet2 and Sheet3 that contain data are added to the workbook.

  9. Keep Excel open.

At this point, we have imported data into Excel by using an OData data feed. The next step is to create a relationship between the tables of data. To do that, we'll use the Power Pivot Add-In for Excel. If the PowerPivot tab is not visible in Excel, enable the add-in by using the following procedure.

To enable the PowerPivot add-in for Excel

  1. In Excel, on the File tab, choose Options.

  2. In the Excel Options dialog box, choose Add-Ins.

  3. In the Manage list, choose COM Add-Ins, and then choose the Go button to open the COM Add-Ins dialog box.

  4. Select Microsoft Office PowerPivot for Excel 2013, and then choose OK. The PowerPivot tab is now visible in Excel.

  5. Keep Excel open.

Now that the Power Pivot add-in for Excel is enabled, the next step is to create a relationship between the tables of data. This will enable us to create reports and filters using data from the two tables.

To create a relationship between tables in a Data Model

  1. In Excel, on the PowerPivot tab, in the Data Model group, choose Manage. Power Pivot for Excel opens.

  2. In the PowerPivot for Excel window, on the Design tab, in the Relationships group, choose Create Relationship.

  3. In the Create Relationship dialog box, specify the following settings:

    • In the Table list, verify that CompanySales is selected.

    • In the Column list, choose ID.

    • In the Related Lookup Table list, choose TerritorySalesDrilldown.

    • In the Related Column Lookup list, verify that ID is selected.

    Then choose the Create button.

  4. Close the PowerPivot for Excel window, but keep Excel open.

At this point, we have imported two tables of data into Excel. We have also created a relationship between the tables so that we can create reports and filters that use the two tables as a single data source.

Part 2: Create reports

For our example dashboard, we'll create two reports, as described in the following table:

Table: Dashboard reports

Report Type | Report Name | Description
PivotChart report | ProductSales | Bar chart that shows sales amounts across different product categories.
PivotChart report | GeoSales | Bar chart that shows sales amounts across different sales geographical areas.

We begin by creating the ProductSales report.

To create the ProductSalesReport chart

  1. In Excel, select Sheet1.

  2. On the Insert tab, in the Charts section, choose PivotChart.The Create PivotChart dialog box appears.

  3. In the Choose the data that you want to analyze section, choose the Use an external data source option, and then choose the Choose Connection button.

    The Existing Connections dialog box appears.

  4. On the Tables tab, select the Tables in Workbook Data Model option, and then choose the Open button.

  5. In the Create PivotChart dialog box, choose the Existing Worksheet option, and then choose the OK button.

    Chart1 opens for editing.

  6. In the PivotChart Fields list, specify the following options:

    • From the CompanySales section, drag ProductCategory to the Legend (Series) field well.

    • In the CompanySales section, select the check box next to Sales.

      The chart updates to display sales amounts across different product categories.

  7. Move the PivotChart report closer to the upper-left corner of the worksheet. To do this, drag the report so that the upper-left corner aligns with the upper-left corner of cell D1 in the worksheet.

  8. To avoid confusion about report names later, we'll specify a new name for the report. To do that, take the following steps:

    1. Somewhere in the PivotChart report, right-click, and then choose PivotChart Options.

    2. In the PivotChart Options dialog box, in the PivotChart Name box, type ProductSalesReport.

      Tip:

      Make sure that the name that you specify contains only alphanumeric characters (no spaces).

    3. Choose the OK button.

  9. Save the workbook by using a file name such as Adventure Works Sales Reports.

  10. Keep the workbook open.

At this point, we have created a PivotChart report showing product sales. The next step is to create a PivotChart report that shows sales amounts across different geographical locations.

To create the GeoSalesReport chart

  1. In Excel, on the same worksheet that was used to create the ProductSales report, choose cell B17.

  2. On the Insert tab, choose PivotChart.

  3. In the Choose the data that you want to analyze section, choose the Use an external data source option, and then choose the Choose Connection button.

    The Existing Connections dialog box appears.

  4. On the Tables tab, select the Tables in Workbook Data Model option, and then choose the Open button.

  5. In the Create PivotChart dialog box, choose the Existing Worksheet option, and then choose the OK button.

    PivotChart2 opens for editing.

  6. In the PivotChart Fields list, specify the following options:

    • In the CompanySales section, select Sales.

    • In the TerritorySalesDrilldown section, drag TerritoryName to the Legend (Series) field well.

    The report updates to display a chart showing sales amounts for different geographical areas.

  7. Move the report so that its upper-left corner aligns with the upper-left corner of cell D16.

  8. To specify a name for the report, take the following steps:

    1. Somewhere in the report, right-click and then choose PivotChart Options.

    2. In the PivotChart Name box, type GeoSalesReport.

    3. Choose OK.

  9. On the File tab, choose the Save button.

  10. Keep the workbook open.

At this point, we have created our two reports for our basic dashboard. The next step is to create filters.

Part 3: Add filters

Using Excel, there are several different kinds of filters we can create and add to a dashboard. For example, we can create a simple filter by putting a field in the Filter section of the Fields list. We can create a slicer, or, if we are using a multidimensional data source such as Analysis Services, we can create a timeline control. For this example dashboard, we'll create two slicers. This filter will enable people to view information for a particular year or a particular sales representative.

To add slicers to the dashboard

  1. In Excel, on the same worksheet that was used to create the reports, choose cell A1.

  2. On the Insert tab, in the Filter group, choose Slicer.

    The Existing Connections dialog box appears.

  3. On the Data Model tab, select the Tables in Workbook Data Model option, and then choose the Open button.

  4. In the Insert Slicers dialog box, take the following steps:

    1. In the CompanySales section, choose OrderYear.

    2. In the TerritorySalesDrilldown section, choose EmployeeLastName.

    3. Choose the OK button.

  5. Move the slicers so that the upper-left corner of the OrderYear slicer aligns with the upper-left corner of cell A1, and the EmployeeLastName slicer is positioned immediately below the OrderYear slicer.

  6. Connect the slicers to the reports by following these steps:

    1. Select the OrderYear slicer.

    2. On the Options tab, in the Slicer group, choose the Report Connections toolbar command.

    3. In the Report Connections dialog box, choose the ProductSalesReport and GeoSalesReport check boxes, and then choose the OK button.

    4. Repeat these steps for the EmployeeLastName slicer.

  7. On the File tab, choose the Save button.

  8. Keep the Excel workbook open.

At this point, we have created a dashboard. The next step is to publish it to SharePoint Server, where it can be used by others.

Publish the dashboard

To publish the workbook to SharePoint Server, we'll follow a two-step process. First, we make some adjustments that affect how the workbook is displayed. Then, we publish the workbook to a SharePoint library.

We begin by making adjustments to the workbook. By default, our example dashboard displays gridlines on the worksheet that contains our dashboard. In addition, by default, the worksheet is called Sheet1. We can make some minor adjustments that will improve how the dashboard will be displayed.

To make minor display improvements to the workbook

  1. In Excel, choose the View tab.

  2. To remove gridlines from the view, on the View tab, in the Show group, clear the Gridlines check box.

  3. To remove row and column headings, on the View tab, in the Show group, clear the Headings check box.

  4. To rename the worksheet, right-click its tab where it says Sheet1, and then choose Rename. Immediately type a new name for the worksheet, such as SalesInfo, and then press the Enter key.

  5. On the File tab, choose Save.

  6. Close Excel.

The next step is to publish the workbook to a SharePoint library. The workbook uses native data that we imported into Excel, which means that we can publish it to a library in SharePoint Server 2013 or in SharePoint Online (Office 365 Preview). Use one of the following procedures to publish the workbook.

To publish the workbook to a library in SharePoint Server

  1. Open a web browser.

  2. In the address line, type the SharePoint address to a library in SharePoint Server.

    For our example, we used the Documents library that is available by default in a Business Intelligence Center site. The SharePoint address we used resembles http://servername/sites/bicenter/documents.

    Tip:

    Contact a SharePoint administrator if you do not know the SharePoint address for a library that you can use.

  3. In the Documents library, click + New Document to open the Add a Document dialog box.

  4. Choose Browse, and then use the Choose File to Upload dialog box to select the Adventure Works Sales Reports workbook. Then choose Open.

  5. In the Add a document dialog box, choose OK. The workbook is added to the library.

To publish the workbook to a library in SharePoint Online (Office 365 Preview)

  1. Log in to your Office 365 environment.

  2. Open the library that you want to use.

    We used the Documents library that is available by default in a Business Intelligence Center site.

    Tip:

    Contact a SharePoint administrator if you do not know how to open a library that you can use.

  3. In the Documents library, click + New Document.

  4. Choose Upload Existing File to open the Add a document dialog box.

  5. Choose Browse, and then use the Choose File to Upload dialog box to select the Adventure Works Sales Reports workbook. Then choose Open.

  6. In the Add a document dialog box, choose OK. The workbook is added to the library.

Now that we have created and published the dashboard, we can use it to explore data.

Use the dashboard

After the dashboard was published to SharePoint Server, it is available for people to view and use it.

To open the dashboard

  1. Open a web browser.

  2. In the address bar, type the address to the Business Intelligence Center site where the dashboard was published.

  3. Choose Site Contents, and then choose Documents.

  4. Choose the Adventure Works Sales Reports dashboard. The dashboard opens for viewing in a browser window.

Now that the dashboard is open for viewing, we can use it to obtain answers to specific questions, such as those that are described in the following table.

Table: Using the dashboard to obtain answers to specific questions

Question Action

In 2005, which product category had the most sales?

In the OrderYear slicer, choose 2005. Notice that in the ProductSalesReport chart, the Bikes product category has the highest sales amount.

Which year had the highest amount of sales for the Bikes product category?

To find the answer, we'll use the Quick Explore feature. Follow these steps:

  1. Clear the OrderYear slicer.

  2. In the ProductSalesReport chart, select the Bikes bar. The Quick Explore button appears.

  3. Click (or tap) the Quick Explore button to open the Explore dialog box.

  4. Expand CompanySales, choose OrderYear, and then choose Drill To OrderYear. The ProductSalesReport chart updates to show sales amounts for the Bikes product category.

According to the ProductSalesReport chart, 2007 was the year in which this company had the highest sales amounts for the Bikes category.

In France, which product subcategory has the highest amount of sales?

To find the answer, we'll use the Quick Explore feature. Follow these steps:

  • Refresh the browser window to restore the dashboard to its default view.

  • In the GeoSalesReport chart, select the France bar to display the Quick Explore button.

  • Click (or tap) the Quick Explore button.

  • Expand CompanySales, choose ProductSubCategory, and then choose Drill To ProductSubCategory. The chart updates to display lots of products.

  • Point to the tallest bar. A callout appears that indicates that bar corresponds to the Road Bikes subcategory.

According to the GeoSalesReport chart, Road Bikes has the highest amount of sales in France for this company.

See also

BI capabilities in Excel and Excel Services (SharePoint Server 2013)
Create an Excel Services dashboard using a Data Model (SharePoint Server 2013)


Create an Excel Services dashboard using SQL Server Analysis Services data
See also

Published: July 31, 2012

Summary: Learn how to create, publish and use a basic sales dashboard by using Excel and Excel Services.

Applies to: SharePoint Server 2013 Enterprise

This article describes, step by step, how to use Excel 2013 to create a basic sales dashboard that contains several reports and a filter using an external data connection. The example dashboard described in this article resembles the following image:

Figure: Basic sales dashboard example

Example dashbboard using Adventure Works data

This article also describes how to publish the dashboard to SharePoint Server where others can view and use it. By following the steps in this article, you'll learn how to create and arrange different reports in a worksheet and connect a filter to those reports.

In this article:

  • Before you begin

  • Plan the dashboard

  • Create the dashboard

    • Part 1: Create a data connection

    • Part 2: Create reports

    • Part 3: Create a filter

  • Publish the dashboard

  • Use the dashboard

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Excel 2013 must be installed on the computer that you are using to create and publish the dashboard.

  • This scenario uses Adventure Works sample data and a Business Intelligence Center site in SharePoint Server 2013. If you do not have the sample data and a Business Intelligence Center site, have an IT administrator configure them for you using the instructions in Configure AdventureWorks for Business Intelligence solutions.

  • Excel Services must be configured in the SharePoint environment that you are using.

  • You must have some information about what authentication settings are used for Excel Services. User access can be provided using Windows Authentication with Kerberos delegation, the Secure Store Service, or, with OLAP data sources, the EffectiveUserName feature.

    For information about how to configure Secure Store, see Plan the Secure Store Service in SharePoint Server 2013 and Configure the Secure Store Service in SharePoint 2013. For information about how to configure the EffectiveUserName feature for OLAP data sources, see Use Analysis Services EffectiveUserName in SharePoint Server 2013.

Plan the dashboard

Before you begin to create a dashboard, we recommend that you create a dashboard plan. The plan does not have to be extensive or complex. However, it should give you an idea of what you want to include in the dashboard. To help you prepare a dashboard plan, consider questions such as the following:

  • Who will use the dashboard?

  • What kinds of information do they want to see?

  • Does data exist that you can use to create the dashboard?

Our example dashboard is designed to be a prototype that you can use to learn how to create and publish Excel Services dashboards. To show how we might create a dashboard plan for a similar dashboard, see the following table.

Table: Basic plan for our example dashboard

Question Response

Who will use the dashboard?

The dashboard is intended for use by sales representatives, sales managers, corporate executives, and other stakeholders who are interested in sales information for the fictitious company Adventure Works Cycles.

How will the dashboard be used? That is, what kinds of information do the dashboard consumers want to see?

Sales representatives, managers, executives, and other dashboard consumers want to use the dashboard to view, explore, and analyze data. At a minimum, the dashboard consumers want to see the following kinds of information:

  • Sales amounts for different product categories

  • Sales amounts for different sales territories

  • Sales for Internet and Reseller channels

Dashboard consumers want to use the dashboard to view, explore, and analyze data to obtain answers to specific questions.

The dashboard consumers also want to be able to use filters to focus on more specific information, such as sales for a particular period of time.

Does data exist that we can use to create the dashboard?

Yes. The Adventure Works sample database contains the data that we want to use for the dashboard. Because this sample data is a multidimensional data cube, it will enable us to create interactive reports that dashboard users can use to explore data by viewing different levels of detail.

What items should the dashboard contain?

Our example dashboard includes the following items:

  • A data connection to SQL Server Analysis Services

  • A report showing product sales information for different product categories

  • A report showing sales information for different sales territories

  • A report showing orders and sales information for different sales channels

  • A report showing orders and sales across different product categories

  • A filter that dashboard consumers can use to view information for a particular period of time or a range of time

Now that we have created our dashboard plan, we can begin to create the dashboard.

Create the dashboard

To create the dashboard, we begin by creating a data connection. Then, we use that data connection to create the reports and the filter that we want to use. After that, we publish the workbook to SharePoint Server.

Part 1: Create a data connection

Our example dashboard uses a single data connection to data that is stored in SQL Server 2012 Analysis Services. We'll use this data connection to create the reports and filter for the dashboard.

To create a connection to Analysis Services data

  1. Open Microsoft Excel.

  2. Choose Blank workbook to create a workbook.

  3. On the Data tab, choose Get External Data group, choose From Other Sources, and then choose From Analysis Services.

    The Data Connection Wizard opens.

  4. On the Connect to Database Server page, in the Server name box, specify the name of the server where the Analysis Services data that you want to use resides.

  5. In the Log on credentials section, take one of the following steps:

    • If your organization is using Windows Authentication, choose Use Windows Authentication, and then choose the Next button.

    • If your organization is using specific user credentials, choose Use the following User Name and Password, specify an appropriate user name and password, and then choose the Next button.

    Tip:

    If you don't know which option to choose, contact a SharePoint administrator.

  6. On the Select Database and Table page, choose the AdventureWorksDW2012Multidimensional-EE database, choose the Adventure Works cube, and then choose the Next button.

  7. On the Save Data Connection File and Finish page, choose the Finish button.

  8. On the Import Data page, select the Only Create Connection option, and then choose the OK button.

  9. Keep Excel open.

At this point, we have created a connection to the Adventure Works cube in Analysis Services. By default, this data connection is saved in a My Data Sources folder in the Documents library on the computer and is embedded in the workbook. We'll use the ODC connection that is embedded in the workbook for the dashboard.

The next step is to create reports for the dashboard.

Part 2: Create reports

For our example dashboard, we'll create four reports, as described in the following table:

Table: Dashboard reports

Report Type | Report Name | Description
PivotChart report | ProductSales | Bar chart report that shows sales amounts across different product categories.
PivotChart report | GeoSales | Bar chart report that shows sales amounts across different sales territories.
PivotTable report | ChannelSales | Table that shows order quantities and sales amounts across the Internet and Reseller channels.
PivotTable report | OrderSales | Table that shows order quantities and sales amounts across different product categories.

We begin by creating the ProductSales report.

To create the ProductSales report

  1. In Excel, on the Insert tab, in the Charts section, choose PivotChart.

    The Create PivotChart dialog box appears.

  2. In the Choose the data that you want to analyze section, choose the Use an external data source option, and then choose the Choose Connection button.

    The Existing Connections dialog box appears.

  3. In the Connections in this Workbook section, select the AdventureWorksDW2012Multidimensional-EE data connection, and then choose the Open button.

  4. In the Create PivotChart dialog box, choose the Existing Worksheet option, and then choose the OK button.

    Chart1 opens for editing.

  5. In the PivotChart Fields list, specify the following options:

    • In the Sales Summary section, choose Sales Amount.

      Sales Amount is displayed in the Values section, and the report updates to display a single bar.

    • In the Product section, choose Product Categories.

      Product Categories is displayed in the Axis section, and the report updates to display sales amounts across different product categories.

  6. To sort the bars in descending order, take the following steps:

    1. In the PivotChart Fields list, click (or touch) the Product Categories dimension, and then choose the down arrow that appears.

      The Select field dialog box appears.

    2. Choose More Sort Options… to open the Sort (Category) dialog box.

    3. In the Sort options section, choose the Descending (Z to A) by option, and then use the list to select Sales Amount.

    4. Click OK.

  7. To ensure that there is room for more reports, we'll move the PivotChart report closer to the upper-left corner of the worksheet. To do this, drag the report so that the upper-left corner aligns with the upper-left corner of cell B10 in the worksheet.

  8. To avoid confusion about report names later, we'll specify a new name for the report. On the Analyze tab, in the PivotChart group, in the Chart Name box, delete the text that says Chart1, type ProductSales, and then press the Enter key.

    Tip:

    Ensure that the name that you specify contains only alphanumeric characters (no spaces).

  9. To ensure we don't encounter sizing issues later with the report, we'll specify size settings for the report. To do this, follow these steps:

    1. In an empty section of the report, such as inside the upper-right corner of the report, right-click (or touch and hold for a second), and then choose Format Chart Area.

      The Format Chart Area list opens.

    2. Below the Chart Options, choose the Size and Properties toolbar command.

    3. Expand the Size section, and then choose the Lock aspect ratio option.

    4. Expand the Properties section, choose the Don't move or size with cells option, and verify that the Locked option is selected.

    5. To optionally specify alternate text for the report, expand the Alt Text section, and then type the text that you want to use for the report.

    6. Close the Format Chart Area list.

  10. Save the workbook by using a file name such as Adventure Works Sales.

  11. Keep the workbook open.

At this point, we have created a PivotChart report. The next step is to create another PivotChart report and name it GeoSales that shows sales amounts across different geographical locations.

To create the GeoSales report

  1. In Excel, on the same worksheet that was used to create the ProductSales report, choose cell K10.

  2. On the Insert tab, choose PivotChart.

  3. In the Choose the data that you want to analyze section, choose the Use an external data source option, and then choose the Choose Connection button.

    The Existing Connections dialog box appears.

  4. In the Connections in this Workbook section, select the AdventureWorksDW2012Multidimensional-EE data connection, and then choose the Open button.

  5. In the Create PivotChart dialog box, choose the Existing Worksheet option, and then choose the OK button.

    Chart2 opens for editing.

  6. Move the chart so that its upper-left corner aligns with the upper-left corner of cell J10 in the worksheet.

  7. In the PivotChart Fields list, specify the following options:

    • In the Sales Summary section, choose Sales Amount.

    • In the Sales Territory section, drag Sales Territory to the Legend section.

    The report updates to display a bar chart showing sales amounts for Europe, North America, and Pacific.

  8. Specify size settings for the report by following these steps:

    1. In an empty section of the report, right-click (or touch and hold for a second), and then choose the Format Chart Area option.

      The Format Chart Area list opens.

    2. Below the Chart Options, choose the Size and Properties toolbar command.

    3. Expand the Size section, and then choose the Lock aspect ratio option.

    4. Expand the Properties section, choose the Don't move or size with cells option, and verify that Locked is selected.

    5. To optionally specify alt text for the report, expand the Alt Text section, and then type the text that you want to use for the report.

    6. Close the Format Chart Area list.

  9. Specify a new name for the report. On the Analyze tab, in the PivotChart group, in the Chart Name box, delete the text that says Chart2, type GeoSales, and then press the Enter key.

  10. On the File tab, choose the Save button.

  11. Keep the workbook open.

At this point, we have created two reports. The next step is to create the ChannelSales report.

To create the ChannelSales report

  1. In Excel, on the same worksheet that was used to create the previous reports, choose cell B26.

  2. On the Insert tab, choose PivotTable.

  3. In the Choose the data that you want to analyze section, choose the Use an external data source option, and then choose the Choose Connection button.

    The Existing Connections dialog box appears.

  4. In the Connections in this Workbook section, select the AdventureWorksDW2012Multidimensional-EE data connection, and then choose the Open button.

  5. Choose the Existing Worksheet option, and then choose the OK button.

    PivotTable3 opens for editing.

  6. In the PivotTable Fields list, specify the following options:

    • In the Sales Orders section, choose Order Count.

    • In the Sales Summary section, choose Sales Amount.

    • In the Sales Channel section, choose Sales Channel.

    The report updates to display a table showing order counts and sales amounts for the Internet and Reseller channels.

  7. Choose cell B26, and then, in the Formula bar, delete the text that says Row Labels, and type Channel Sales. Then press the Enter key.

  8. Specify a new name for the report. On the Analyze tab, in the PivotTable group, in the PivotTable Name box, delete the text that says PivotTable3, type ChannelSales, and then press the Enter key.

  9. On the File tab, choose the Save button.

  10. Keep the Excel workbook open.

At this point, we have created three reports using the same data source. The next step is to create the OrderSales report.

To create the OrderSales report

  1. In Excel, on the same worksheet that was used to create the previous reports, choose cell H26.

  2. On the Insert tab, choose PivotTable.

  3. In the Choose the data that you want to analyze section, choose the Use an external data source option, and then choose the Choose Connection button.

    The Existing Connections dialog box appears.

  4. In the Connections in this Workbook section, select the AdventureWorksDW2012Multidimensional-EE data connection, and then choose the Open button.

  5. Choose the Existing Worksheet option, and then choose the OK button.

    PivotTable4 opens for editing.

  6. In the PivotTable Fields list, specify the following options:

    • In the Sales Orders section, choose Order Count.

    • In the Sales Summary section, choose Sales Amount.

    • In the Product section, choose Product Categories.

    The report updates to display a table showing order counts and sales amounts for different product categories.

  7. Choose cell H26, and then, in the Formula bar, delete the default text that says Row Labels, and then type Products. Then press the Enter key.

  8. Specify a new name for the report. On the Analyze tab, in the PivotTable group, in the PivotTable Name box, delete the text that says PivotTable4, type OrderSales, and then press the Enter key.

  9. On the File tab, choose the Save button.

  10. Keep the workbook open.

At this point, we have created our four reports for our basic dashboard. The next step is to create a filter.

Part 3: Create a filter

Using Excel, there are several different kinds of filters we can create. For example, we can create a simple filter by putting a field in the Filter section of the Fields list. We can create a slicer, or, if we are using a multidimensional data source such as Analysis Services, we can create a timeline control. For this example dashboard, we'll create a timeline control. This filter will enable people to view information for a particular time.

To create a timeline control

  1. In Excel, on the same worksheet that was used to create the reports, choose cell B1.

  2. On the Insert tab, in the Filter group, choose Timeline.

    The Existing Connections dialog box appears.

  3. In the Connections in this Workbook section, select the AdventureWorksDW2012Multidimensional-EE data connection, and then choose the Open button.

  4. The Insert Timelines dialog box appears.

  5. Choose the Date option, and then choose the OK button.

    A timeline control opens.

  6. Move the timeline control so that its upper-left corner aligns with the upper-left corner of cell B1.

  7. To make the timeline control wider, use the resizing handles, and drag the sizing handle on the right side of the control to column M.

  8. Select the timeline control, and then, on the Options tab, in the Timeline group, choose the Report Connections toolbar command.

    The Report Connections dialog box appears.

  9. Choose ChannelSales, GeoSales, OrderSales, and ProductSales, and then choose the OK button.

  10. On the File tab, choose the Save button.

  11. Keep the Excel workbook open.

At this point, we have created a dashboard. The next step is to publish it to SharePoint Server, where it can be used by others.

Publish the dashboard

To publish the workbook to SharePoint Server, we'll follow a four-step process. First, we make some adjustments that affect how the workbook is displayed. Then, we specify Excel Services data authentication settings for the external data connection that we use. Next, we specify publish options for the workbook. Finally, we publish the workbook to SharePoint Server.

We begin by making adjustments to the workbook. By default, our example dashboard displays gridlines on the worksheet that contains our dashboard. In addition, by default, the worksheet is called Sheet1. We can make some minor adjustments that will improve how the dashboard will be displayed.

To make minor display improvements to the workbook

  1. In Excel, choose the View tab.

  2. To remove gridlines from the view, on the View tab, in the Show group, clear the Gridlines check box.

  3. To remove row and column headings, on the View tab, in the Show group, clear the Headings check box.

  4. To rename the worksheet, right-click its tab where it says Sheet1, and then choose Rename. Immediately type a new name for the worksheet, such as SalesDashboard, and then press the Enter key.

  5. On the File tab, choose Save.

  6. Keep the workbook open.

The workbook we created uses an external data connection that we want to keep active when we publish the workbook. To ensure that the data connection remains live so that data refresh is supported in Excel Services, we must specify authentication settings.

To specify authentication settings for the external data connection

  1. In Excel, on the Data tab, choose the Connections toolbar command.

    The Workbook Connections dialog box appears and displays the AdventureWorksDW2012Multidimensional-EE data connection.

  2. Choose the Properties button.

  3. In the Connection Properties dialog box, on the Definition tab, next to Excel Services, choose the Authentication Settings… button.

  4. In the Excel Services Authentication Settings dialog box, take one of the following steps:

    • If Excel Services is configured to use Windows Authentication or the EffectiveUserName feature, select Use the authenticated user's account, and then choose the OK button.

    • If Excel Services is configured to use Secure Store Service, select Use a stored account. In the Application ID box, specify the Secure Store target application ID, and then choose the OK button.

    • If Excel Services is configured to use the unattended service account, select None, and then choose the OK button.

    Important:

    If you do not know which option to choose, contact a SharePoint administrator.

  5. Choose the OK button to close the Connection Properties dialog box.

  6. If you see a message that states that the connection in the workbook will no longer be identical to the connection that is defined in the external file, choose Yes.

  7. Choose the Close button to close the Workbook Connections dialog box.

When we created the reports for the dashboard, we gave each one a unique name and defined it as a named item in Excel. In addition to publishing the workbook to SharePoint Server, we should publish the named items that we defined. This makes it possible to display a named item in its own SharePoint Web Part later. We do this by specifying publish options for the workbook.

Tip:

This article does not describe how to display a named item in its own SharePoint Web Part. Therefore, the following procedure is optional. However, we recommend that, as a best practice, you perform the following procedure. This can save you from having to republish the workbook later.

To specify publish options for the workbook

  1. On the File tab, choose Info, and then choose Browser View Options.

  2. Choose the Browser View Options button.

  3. On the Show tab, use the list to choose Items in the Workbook.

  4. Choose All Charts and All PivotTables, and then choose the OK button.

  5. On the File tab, choose the Save button.

  6. Keep the workbook open.

The next step is to publish the workbook to SharePoint Server.

To publish the workbook to SharePoint Server

  1. In Excel, on the File tab, choose Save As, choose Computer, and then choose the Browse button.

    The Save As dialog box appears.

  2. In the address line, type the SharePoint address to an Excel Services trusted file location.

  3. Choose the Save button.

    The workbook is published in the SharePoint library that you specified.

  4. Close the Excel workbook.

Now that we have created and published the dashboard, we can use it to explore data.

Use the dashboard

After the dashboard was published to SharePoint Server, it is available for people to view and use it.

To open the dashboard

  1. Open a web browser.

  2. In the address bar, type the address to the Business Intelligence Center site where the dashboard was published.

  3. Choose Site Contents, and then choose Documents.

  4. Choose the Adventure Works Sales dashboard.

    The dashboard opens for viewing.

Now that the dashboard is open for viewing, we can use it to obtain answers to specific questions, such as those that are described in the following table.

Table: Using the dashboard to obtain answers to specific questions

Question | Action
Which product category has the largest number of orders? | Using the OrderSales report, view the Order Count column for various product categories. You can see that Accessories has the largest number of orders. Notice also that Accessories also has the least total sales amount of all four product categories.
Does this company sell more merchandise through the Internet channel, or the Reseller channel? | Using the ChannelSales report, you can see that, although the Internet channel has more orders, the Reseller channel has the highest sales amount.
Which year resulted in the highest total sales amount? | Using the timeline control near the top of the screen, choose the down arrow next to MONTHS and select YEARS. Use the control to select one year at a time. Notice that the year 2007 has the highest sales amount.
Which sales territory has the highest sales amount for this company for all time? | Clear the filter from the timeline control by selecting the Clear Filter toolbar command in the upper-right corner of the timeline control. Notice that North America has the highest sales amount for this particular company.
Which subcategory of bikes has the highest overall sales? | Using the ProductSales report, double-click (or touch and hold for a second) the bar for Bikes. The report updates to display three subcategories: Mountain Bikes, Road Bikes, and Touring Bikes. Notice that the Mountain Bikes subcategory has the highest sales amount.

See also

BI capabilities in Excel and Excel Services (SharePoint Server 2013)
Create an Excel Services dashboard using a Data Model (SharePoint Server 2013)


Create an Excel Services dashboard using a Data Model (SharePoint Server 2013)
See also

Published: December 18, 2012

Summary: Learn how to create, publish and use a basic Excel Services dashboard using a Data Model that is created in Excel.

Applies to: SharePoint Server 2013 Enterprise

This article describes, step by step, how to create a Data Model, how to create some reports and a slicer, and then how to publish the dashboard to SharePoint Server. The example dashboard described in this article resembles the following image:

Figure: Basic dashboard example

Example dashboard created using a Data Model

This article also covers different display options that you can use when you publish a workbook. By following the steps in this article, you'll learn how to create and configure reports in a worksheet and connect a slicer to those reports.

In this article:

  • Before you begin

  • Plan the dashboard

  • Create the dashboard

    • Part 1: Create a data connection

    • Part 2: Create reports

    • Part 3: Create a filter

  • Publish the dashboard

  • Use the dashboard

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Before you begin this operation, review the following information about prerequisites:

  • Excel 2013 must be installed on the computer that you are using to create and publish the dashboard.

  • This scenario uses Adventure Works sample data and a Business Intelligence Center site in SharePoint Server 2013. If you do not have the sample data and a Business Intelligence Center site, have an IT administrator configure them for you using the instructions in Configure AdventureWorks for Business Intelligence solutions.

  • Excel Services must be configured to support Data Models in the SharePoint environment that you are using. For information about how to deploy Excel Services, see Configure Excel Services in SharePoint Server 2013 and Manage Excel Services data model settings (SharePoint Server 2013).

  • You must have some information about what authentication settings are used for Excel Services. For example, if your organization is using Secure Store Service, you will need the Secure Store target application ID for Excel Services data access.

    For information about how to configure Secure Store, see Plan the Secure Store Service in SharePoint Server 2013 and Configure the Secure Store Service in SharePoint 2013.

Plan the dashboard

Before you begin to create a dashboard, we recommend that you create a dashboard plan. The plan does not have to be extensive or complex. However, it should give you an idea of what you want to include in the dashboard. To help you prepare a dashboard plan, consider questions such as the following:

  • Who will use the dashboard?

  • What kinds of information do they want to see?

  • Does data exist that you can use to create the dashboard?

Our example dashboard is designed to be a prototype that you can use to learn how to create and publish Excel Services dashboards. To show how we might create a dashboard plan for a similar dashboard, see the following table.

Table: Basic plan for our example dashboard

Question Response

Who will use the dashboard?

The dashboard is intended for use by sales representatives, sales managers, corporate executives, and other stakeholders who are interested in sales information for the fictitious company Adventure Works Cycles.

How will the dashboard be used? That is, what kinds of information do the dashboard consumers want to see?

Sales representatives, managers, executives, and other dashboard consumers want to use the dashboard to view, explore, and analyze data. At a minimum, the dashboard consumers want to see the following kinds of information:

  • Sales amounts across different sales territories at the country level

  • Order quantities for products in the Internet and reseller sales channels

  • Order quantities and sales amounts for various promotions the company held

Dashboard consumers want to use the dashboard to view, explore, and analyze data to obtain answers to specific questions.

The dashboard consumers also want to be able to use a filter to focus on more specific information, such as how many orders and how much sales were generated from different promotions.

Does data exist that we can use to create the dashboard?

The Adventure Works sample database contains the data that we want to use for the dashboard. The sample database contains lots of tables. We can easily create a Data Model in Excel that will enable us to create reports using multiple tables as a single data source. This will enable us to create interactive reports that dashboard users can use to explore data by viewing different levels of detail.

What items should the dashboard contain?

Our example dashboard includes the following items:

  • A Data Model that includes several tables that are stored in SQL Server.

  • A report showing product sales information across different countries

  • A report showing orders and sales information for different products

  • A filter that dashboard consumers can use to view information for a particular promotion

Now that we have created our dashboard plan, we can begin to create the dashboard.

Create the dashboard

To create the dashboard, we begin by creating the Data Model. Then, we use that Data Model to create the reports and the filter that we want to use. After that, we publish the workbook to SharePoint Server.

Part 1: Create a Data Model

Our example dashboard uses a Data Model that consists of five tables that are stored in SQL Server.

To create a Data Model

  1. Open Excel.

  2. Choose Blank workbook to create a workbook.

  3. On the Data tab, choose Get External Data group, choose From Other Sources, and then choose From SQL Server.

    The Data Connection Wizard opens.

  4. In the Data Connection Wizard, in the Server name box, specify the name of the server where the Adventure Works sample dataset is stored.

  5. In the Select Database and Table dialog box, in the Select the database that contains the data that you want list, choose AdventureWorksDW2012.

  6. Select both Connect to a specific table and Enable section of multiple tables, and then select the following tables:

    • DimProduct

    • DimPromotion

    • DimSalesTerritory

    • FactInternetSales

    • FactResellerSales

  7. Verify that Import relationships between tables is selected, and then click Next.

  8. In the Save Connection and Finish dialog box, next to Excel Services, click Authentication Settings.

  9. In the Excel Services Authentication Settings dialog box, take one of the following steps:

    • If Excel Services is configured to use Secure Store Service, select Use a stored account. In the Application ID box, specify the Secure Store target application ID, and then choose the OK button.

    • If Excel Services is configured to use the unattended service account, select None, and then choose the OK button.

    Important:

    If you do not know which option to choose, contact a SharePoint administrator.

  10. Do not click Finish yet. In the Save Data Connection File and Finish dialog box, click Browse.

  11. Type the address of the Business Intelligence Center site that you are using. The address typically takes the form http://servername/sites/bicenter.

  12. Double-click Data Connections, and then click Save.

  13. Click Finish. A Data Connections dialog box appears.

  14. In the Data Connections dialog box, take the following steps:

    1. In the Title box, specify a title, such as Adventure Works Data Model.

    2. In the Description box, specify a description for the Data Model.

    3. In the Keywords box, specify some words and phrases, such as Adventure Works and Data Model.

    4. Click OK to close the Data Connections dialog box.

  15. On the Import Data dialog box, choose Only Create Connection. Make sure the Add this data to the Data Model is selected, and then click OK. The Data Model is created and saved in the Data Connections library in the Business Intelligence Center site.

    Keep the workbook open.

At this point, we have used Excel to create and upload an Adventure Works Data Model that uses five tables that are stored in SQL Server.

The next step is to create reports for the dashboard.

Part 2: Create reports

For our example dashboard, we'll create two reports, as described in the following table:

Table: Dashboard reports

Report Type | Report Name | Description
PivotChart report | Territory Sales | Bar chart report that shows sales amounts across different countries.
PivotTable report | Product Orders and Sales | Table that shows order quantities and sales amounts for products across the Internet and Reseller channels.

We begin by creating the Territory Sales report.

To create the Territory Sales report

  1. In Excel, on the Insert tab, click PivotChart.

  2. In the Create PivotChart dialog box, select Use an external data source, and then click Choose Connection.

  3. In the Existing Connections dialog box, on the Tables tab, select Tables in Workbook Data Model, and then click Open.

  4. In the Create PivotChart dialog box, choose Existing Worksheet, and then click OK. Chart 1 opens for editing. In the PivotChart Fields section, notice the five tables that you selected for the Data Model are listed.

  5. Expand DimSalesTerritory, and then select SalesTerritoryCountry.

  6. Expand FactInternetSales, and then select SalesAmount. The chart updates to show sales amounts across different countries.

  7. Notice that the chart legend says Total, which is not necessarily useful information. To change that, follow these steps:

    1. In the PivotChart Fields section, in the Values field well, click Sum of SalesAmount, and then click Value Field Settings.

    2. In the Value Field Settings dialog box, in the Custom Name box, type Internet Sales, and then click OK. The chart does not seem to have changed at this point, but you will see the changes after you complete the next step.

  8. In the PivotChart Fields section, expand FactResellerSales, and then select SalesAmount. The chart updates to show two sets of bars representing sales amounts across different countries.

  9. To change how the sales amount information for the reseller channel is represented in the chart legend, follow these steps:

    1. In the PivotChart Fields section, in the Values field well, click Sum of SalesAmount, and then click Value Field Settings.

    2. In the Value Field Settings dialog box, in the Custom Name box, type Reseller Sales, and then click OK.

    The chart legend clearly indicates which values apply to Internet sales and which to reseller sales.

  10. Somewhere on the chart, such as in a blank area, right-click, and then choose PivotChart Options.

  11. In the PivotChart Name box, type a name for the report, such as Territory Sales, and then click OK.

  12. To move the report, click a blank area in the PivotChart report, and then drag report so that its upper-left corner aligns with the upper-left corner of cell D1 in the worksheet.

    Keep the workbook open.

At this point, we have created a PivotChart report that displays information that comes from three tables in SQL Server. The Data Model in the workbook enables us to create a single view, such as the Territory Sales report by using those three tables.

The next step is to create the Product Orders and Sales PivotTable report.

To create the Product Orders and Sales report

  1. In Excel, click cell D21. Then, on the Insert tab, click PivotTable.

  2. On the Create PivotTable dialog box, choose Use an external data source, and then click Choose connection.

  3. On the Tables tab, select Tables in Workbook Data Model, and then click Open.

  4. Verify that Existing Worksheet is selected, and then click OK. PivotTable 2 opens for editing.

  5. In the PivotTable Fields section, expand DimProduct, and then select ModelName. The report updates to display a list of products.

  6. To replace the default text that says Row Labels, click cell D21, and type Product Model.

  7. In the PivotTable Fields section, expand FactInternetSales, and then select OrderQuantity.

  8. In the PivotTable Fields section, in the Values field well, click Sum of OrderQuantity, and then click Value Field Settings.

  9. In the Value Field Settings dialog box, in the Custom Name box, type Internet Orders, and then click OK.

  10. In the PivotTable Fields section, expand FactInternetSales, and then select SalesAmount.

  11. In the PivotTable Fields section, in the Values field well, select Sum of SalesAmount, and then click Value Field Settings.

  12. In the Format Cells dialog box, in the Category pane, choose Currency, and then click OK.

  13. Click OK to close the Value Field Settings dialog box. The report now shows order quantities and sales amounts for various products sold online.

  14. In the PivotTable Fields list, in the FactResellerSales section, select OrderQuantity.

  15. In the PivotTable Fields section, in the Values field well, click Sum of OrderQuantity, and then click Value Field Settings.

  16. In the Value Field Settings dialog box, in the Custom Name field, type Reseller Orders, and then click OK.

  17. In the PivotTable Fields section, in the FactResellerSales section, select SalesAmount.

  18. In the PivotTable Fields section, in the Values field well, select Sum of SalesAmount, and then click Value Field Settings.

  19. In the Custom Name box, type Reseller Sales, and then click Number Format.

  20. In the Format Cells dialog box, in the Category pane, choose Currency, and then click OK.

  21. Click OK to close the Value Field Settings dialog box.

    The report now shows order quantities and sales amounts for various products sold online and through resellers.

  22. Somewhere inside the PivotTable report, right-click, and then choose PivotTable Options.

  23. In the PivotTable Name box, type a name for the report, such as Product Orders and Sales. Clear the Autofit column widths on update option, and then click OK.

    Keep the workbook open.

Now we have a second report displaying information that comes from three tables in SQL Server. To resize the PivotChart report so that its width matches the width of the PivotTable report, drag the lower-right corner of the PivotChart report so that it aligns with the lower-right corner of cell H21.

The next step is to create a filter for the dashboard.

Part 3: Create a filter

Using Excel, there are several different kinds of filters we can create. For example, we can create a simple filter by putting a field in the Filter section of the Fields list. We can create a slicer, or, if we are using a data source that has a date hierarchy defined, we can create a timeline control. For this example dashboard, we'll create a slicer. This filter will enable people to view information for a particular promotion.

To create the Promotion slicer

  1. In Excel, click cell A1. Then, on the Insert tab, click Slicer.

  2. In the Existing Connections dialog box, on the Data Model tab, select the Data Model we've been using in this workbook, and then click Open.

  3. In the Insert Slicers dialog box, in the DimPromotion section, select EnglishPromotionName, and then click OK. The slicer appears on the worksheet.

  4. Move the slicer so that its upper-left corner aligns with the upper-left corner of cell A1.

  5. Expand the height of the slicer so that all its items are visible.

  6. To change the default name of the slicer, on the Options tab, in the Slicer Caption box, type Promotion.

At this point, we have created the slicer but we have not connected it to the reports yet. The next step is to connect the slicer to the Territory Sales and Product Orders and Sales reports.

To connect the Promotion slicer to the reports

  1. Click to select the slicer. Then, on the Slicer Tools Options tab, in the Slicer group, click Report Connections.

  2. In the Report Connections dialog box, select the Product Orders and Sales report and the Territory Sales report, and then click OK. The slicer is now connected to the reports.

To test the slicer, choose an item, such as No Discount. The reports refresh to show sales and order amounts for which No Discount was entered as the promotion type. Choose another item in the slicer, such as Mountain-100 Clearance. Notice that the reports update to show only reseller sales information. This means that for that promotion, no online sales were made. To clear the slicer, click the filter toolbar command next to the title of the slicer. The reports refresh to display information for all promotions.

The next step is to save the workbook.

To save the workbook

  1. In Excel, on the File tab, click Save As, and then click Browse.

  2. In the File name box, type a name for the workbook such as Adventure Works Sales and Orders, and then click Save. The workbook is saved to your computer.

At this point, we have created a dashboard. The next step is to publish it to SharePoint Server, where it can be used by others.

Publish the dashboard

To publish the workbook to SharePoint Server, we'll follow a three-step process. First, we make some adjustments that affect how the workbook is displayed. Next, we specify how we want the workbook to display in a web browser. Finally, we publish the workbook to SharePoint Server.

We begin by making adjustments to the workbook. By default, our example dashboard displays gridlines on the worksheet that contains our dashboard. In addition, by default, the worksheet is called Sheet1. We can make some minor adjustments that will improve how the dashboard will be displayed.

To make minor display improvements to the workbook

  1. In Excel, choose the View tab.

  2. To remove gridlines from the view, on the View tab, in the Show group, clear the Gridlines check box.

  3. To remove row and column headings, on the View tab, in the Show group, clear the Headings check box.

  4. To rename the worksheet, right-click its tab where it says Sheet1, and then choose Rename. Immediately type a new name for the worksheet, such as Orders and Sales, and then press the Enter key.

  5. On the File tab, choose Save.

  6. Keep the workbook open.

When you publish a workbook to SharePoint Server, you can choose from several display browser view options, as described in the following list.

  • Worksheet view. You can have the workbook displayed in worksheet view in the browser window so that it looks much like it does in Excel. The slicer and reports are displayed together in the browser window, just like they look in the Excel client.

    The following image shows our example dashboard rendered in worksheet view.

    Example dashboard created using a Data Model

  • Gallery view. You can have the workbook displayed in a gallery view, which features one report at a time in the center part of the screen and a slicer along the left side of the screen.

    The following image shows our example dashboard rendered in gallery view.

    Example dashboard shown in gallery view

Use one of the following procedures to specify browser view options for the workbook.

To configure the workbook to display using worksheet view

  1. In Excel, on the File tab, click Browser View Options.

  2. On the Show tab, use the list to select Sheets, select Orders and Sales, and then click OK

  3. Save the workbook, and then close Excel.

To configure the workbook to display using gallery view

  1. In Excel, on the File tab, click Browser View Options.

  2. On the Show tab, use the list to select Items in the Workbook.

  3. Select the Territory Sales report and the Product Orders and Sales reports, and then click the Parameters tab.

  4. Click Add, select the Promotion slicer, and then click OK.

  5. Click OK to close the Browser View Options dialog box.

  6. Then close Excel.

The next step is to publish the workbook to the Documents library in the Business Intelligence Center site.

To upload the workbook to a Documents library

  1. Open a web browser. In the address line, type the website address (URL) to the Business Intelligence Center site that you are using. The address typically takes the form http://servername/sites/bicenter.

  2. Click Site Contents, and then click Documents.

  3. Click + new document to open the Add a document dialog box.

  4. Click Browse to open the Choose File to Upload dialog box.

  5. Select the Adventure Works Sales and Orders workbook, and then click Open.

  6. In the Add a document dialog box, click OK.

Now that we have created and published the dashboard, we can use it to explore data.

Use the dashboard

After the dashboard was published to SharePoint Server, it is available for people to view and use it.

To open the dashboard

  1. Open a web browser.

  2. In the address bar, type the address to the Business Intelligence Center site where the dashboard was published.

  3. Choose Site Contents, and then choose Documents.

  4. Choose the Adventure Works Sales and Orders dashboard. The dashboard opens in a browser window.

Now that the dashboard is open for viewing, we can use it to obtain answers to specific questions, such as those that are described in the following table.

Table: Using the dashboard to obtain answers to specific questions

Question Action

Which two countries sold more on the Internet than through resellers?

Look at the bar chart. Notice that in Australia and German, Internet sales amounts are greater than reseller sales amounts.

For the Volume Discount 41 to 60 promotion, which item had the highest sales amount?

In the Promotion slicer, select Volume Discount 41 to 60. Notice the reports update to show reseller sales information only. In the PivotTable report, notice that Women's Mountain Shorts has the highest sales amount.

What product had the highest sales amounts for the reseller channel across all promotions?

To answer this question, follow these steps.

  1. Open the workbook in Excel.

  2. Make sure the slicer is cleared so that data for all promotions is displayed.

  3. In the PivotTable report, click a row in the Reseller Sales column.

  4. On the Data tab, click Sort to open the Sort by Value dialog box.

  5. Under Sort Options, select Largest to Smallest, and then click OK. Notice that the PivotTable report shows Mountain-200 with the highest sales amount in the reseller channel.

Is it possible to change the bar chart to display order quantities across different countries instead of sales amounts?

Click the bar chart to open the PivotChart Fields list. In the FactInternetSales section, select OrderQuantity and clear SalesAmount. In the FactResellerSales section, select OrderQuantity and clear SalesAmount. The bar chart updates to display order quantities across the different countries.

See also

BI capabilities in Excel and Excel Services (SharePoint Server 2013)
Create an Excel Services dashboard using SQL Server Analysis Services data


Configure Analysis Services for processing data models in Excel Services

Published: September 4, 2012

Summary: Install SQL Server Analysis Services 2012 SP1 CTP3 for processing data models in Excel Services in SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

In Excel Services in SharePoint Server 2013, you can specify one or more instances of SQL Server 2012 Analysis Services (SSAS) for use in processing Data Models that are created in Excel 2013. In this configuration, SQL Server 2012 Analysis Services provides a backend service for Excel Services to load, query, and refresh Excel 2013 Data Models so that users can interact with these types of workbooks in the browser.

This scenario describes how to install and configure an instance of Analysis Services 2012 SP1 CTP3 for use in processing data models in Excel Services.

In this article:

  • Before you begin

  • Install SQL Server Analysis Services 2012 SP1 CTP3

  • Configure data model settings in Excel Services

Before you begin

Before starting, read the following information about permissions and software requirements. Follow the specified steps to install or configure prerequisite software or to modify settings. For example:

  • This scenario requires SQL Server 2012 with Service Pack 1 (SP1). You can download it from the Microsoft Download Center (http://go.microsoft.com/fwlink/p/?LinkId=286738).

  • To configure Excel Services, you must be a Farm Administrator or an Excel Services service application administrator.

  • You must know what account is being used to run the Excel Services application pool. This account will be added to the Analysis Services administrators group.

Install SQL Server Analysis Services 2012 SP1 CTP3

The first step is to install SQL Server Analysis Services 2012 SP1 CTP3. This must be installed on a server on the domain, but does not need to be installed on a SharePoint Server application server. If you plan on a large amount of data model use in your organization, we recommend installing this instance of Analysis Services on its own server.

To install Analysis Services 2012 SP1 CTP3

  1. Run the SQL Server Installation Wizard (Setup.exe).

  2. In the left pane, click Installation.

  3. Click New SQL Server stand-alone installation or add features to an existing installation.

  4. On the Setup Support Rules page, review any warnings and click OK.

  5. On the Product Key page select Evaluation or type a product key, and then click Next.

  6. On the License Terms page, accept the license agreement, and then click Next.

  7. If you see another Setup Support Rules page, review any warnings and click Next.

  8. On the Setup Role page:

    • Select the SQL Server PowerPivot for SharePoint option.

    • Clear the Add SQL Server Database Relational Engine Services to this installation check box.

      Note:

      If you want to install the SQL Server management tools, you can leave this check box selected even if you do not plan to use the SQL Server Database Relational Engine.

    • Click Next.

  9. On the Feature Selection page, click Next.

  10. On the Installation Rules page, review any warnings and click Next.

  11. On the Instance Configuration page, click Next.

  12. One the Disk Space Requirements page, verify that you have sufficient disk capacity to install the feature and then click Next.

  13. On the Server Configuration page, type NT AUTHORITY\NETWORK SERVICE (recommended), or the account name and password for an Active Directory account to run the Analysis Services instance, in the SQL Server Analysis Services row, and then click Next.

  14. On the Analysis Services Configuration page:

    • Click Add Current User if you want to add the current user as an Analysis Services administrator.

    • Click Add, and on the Select Users, Computers, Service Accounts, or Groups dialog box, type the name of the account that runs the Excel Services application pool and click OK.

      Note:

      You can add additional administrators here as required by your organization.

    • Click Next.

  15. On the Error Reporting page, click Next.

  16. On the Installation Configuration Rules page, review any warnings and click Next.

  17. On the Ready to Install page, click Install.

  18. When the installation is complete, click Close.

  19. Restart the computer.

If you have a firewall in your environment, review the SQL Server Books Online article, Configure the Windows Firewall to Allow Analysis Services Access.

Configure data model settings in Excel Services

After the instance of Analysis Services has been installed, you must configure Excel Services to use this instance to process data models. This is configured in Excel Services Global Settings.

To configure data model settings

  1. On the SharePoint Central Administration website, under Application Management, click Manage service applications.

  2. Click the Excel Services service application.

  3. On the Manage Excel Services Application page, click Data Model Settings.

  4. On the Excel Services Application Data Model Settings page:

    • Click Add Server.

    • In the Server Name text box, type the name of the instance of Analysis Services that you installed, in the format <ServerName>\POWERPIVOT.

    • Optionally, type a description for the server.

    • Click OK.

After you have configured the instance of Analysis Services in Excel Services Global Settings, Excel Services is ready to process data models.

Note:

It can take up to five minutes for the changes to take effect.

If your data processing needs require it, you can specify multiple instances of SQL Server Analysis Services 2012 SP1 CTP3 to provide greater scale and processing power.

Verify that data models are loading correctly

To verify that Excel Services can load a data model, upload a sample workbook that contains a data model and a slicer that uses that data model. Open the workbook in the browser, and then click on a slicer. Excel Services typically shows cached data without loading the data model when opening a workbook. Clicking on a slicer requires Excel Services to update the data cache, which in turn requires loading the data model on the registered Analysis Services instance.


Secure Store for Business Intelligence service applications (SharePoint Server 2013)
See also

Summary: Learn how Secure Store works with Excel Services, PerformancePoint Services, and Visio Services to refresh data on SharePoint Server 2013.

Applies to: SharePoint Server 2013

This article describes how SharePoint Server 2013 business intelligence features use the Secure Store Service to provide access to external data sources (such as SQL Server) for SharePoint Server 2013 users. For the purposes of this article, the SharePoint Server 2013 business intelligence service applications are:

  • Excel Services

  • PerformancePoint Services

  • Visio Services

The SharePoint Server 2013 business intelligence service applications offer two methods of data access for users:

  • Integrated Windows authentication using Constrained Kerberos delegation

  • Secure Store Service (including an unattended service account)

Excel Services and PerformancePoint Services also support the SQL Server Analysis Services (SSAS) EffectiveUserName feature for Analysis Services connections.

This article covers Secure Store and its relationship to the business intelligence service applications.

For information about configuring specific scenarios in your SharePoint Server 2013 farm, see the following articles:

  • Use Excel Services with Secure Store Service in SharePoint Server 2013

  • Use Visio Services with Secure Store Service in SharePoint 2013

  • Use PerformancePoint Services with Secure Store Service in SharePoint Server 2013

Secure Store Service and the business intelligence service applications in SharePoint Server 2013

Secure Store is a feature in SharePoint Server 2013 that helps provide access to data outside SharePoint Server 2013 (for example, SQL Server data) by allowing a business intelligence service application to use a set of credentials with data access on behalf of a SharePoint Server 2013 user who is attempting to access that data. Such use of credentials by business intelligence service applications on behalf of users is called impersonation.

Secure Store provides this mapping between business intelligence services applications, users, and credentials through the use of a target application. A Secure Store target application is a collection of metadata that specifies which users shall be allowed access to a particular set of credentials that a business intelligence service application will use for impersonation when accessing external data. This metadata is stored in the Secure Store database along with the credentials themselves, which are encrypted.

Secure Store target applications can be used in many ways within SharePoint Server 2013, but for the purposes of SharePoint Server 2013 business intelligence scenarios, target applications consist of the following settings, configurable by the Farm Administrator:

  • Administrators Target application Administrators are users who have privileges to administer a given Secure Store target application. This can be the Farm Administrator or a specific user or users, depending on your needs.

  • Members The Members of a target application are the users on behalf of whom the Business Intelligence Service Application will impersonate the target application Credentials when it accesses external data. This could be a single user, multiple users, or an Active Directory group. Members are also referred to as Credential Owners.

  • Credentials Target application Credentials consist of an account with direct access to data sources. (You must grant the required data access to this account directly — access to external data sources is not controlled by SharePoint Server 2013. This should be a low-privileged account that only allows data access.) It is this account that is impersonated by business intelligence service applications to give users access to data.

The Administrators, Members, and Credentials are configurable by the Farm Administrator directly through Secure Store. Additionally, both Excel Services and PerformancePoint Services provide an option to automatically create a Secure Store target application for use with the unattended service account.

The business intelligence service applications can use Secure Store by using one of two methods:

  • Specified target application A specific target application is specified by the Excel worksheet, Visio diagram, or PerformancePoint data source. When a user accesses the worksheet, diagram, or dashboard, Secure Store uses the credentials associated with that target application for data access.

  • No specified target application (unattended service account) The unattended service account is specified by the Excel worksheet, Visio diagram, or PerformancePoint data source. When a user accesses the worksheet, diagram, or dashboard connected to an external data source, Secure Store uses the target application specified in the Global Settings of Excel Services, Visio Services, or PerformancePoint Services. When a target application is specified globally for a business intelligence service application, the target application credentials are referred to as the unattended service account.

The basic sequence of events that occurs is as follows:

  1. A SharePoint Server 2013 user accesses a data-connected object such as an Excel Services worksheet, Visio Services diagram, or PerformancePoint Services dashboard.

  2. The Business Intelligence Service Application accesses the target application specified by the object.

  3. If the user is a Member of that target application, the credentials stored in the target application are returned and the Business Intelligence Service Application impersonates the credentials while accessing the data.

  4. The data is displayed to the user within the context of the worksheet, Visio diagram, or dashboard.

Data connection files

All of the business intelligence service applications can use data connection files to specify authentication information. Excel Services and Visio Services use Office Data Connection (.ODC) files and PerformancePoint Services uses PerformancePoint Services Data Connection (.PPSDC) files. Use of such files allows multiple Excel Services worksheets, Visio Services diagrams, or PerformancePoint Services dashboards to share a common set of data access parameters.

The SharePoint Server 2013 business intelligence service applications each use data connection files differently. For a description of how each uses data connection files, see the section for each service application, below.

Data access from client and server

Excel 2013 and Visio 2013 are client applications that function independently from SharePoint Server 2013. Though they can publish documents to SharePoint Server 2013, they cannot use Secure Store directly for authentication to data sources. When you create or edit a data-connected worksheet or diagram, you must use Integrated Windows authentication or another applicable authentication method to connect directly to a data source from Excel 2013 or Visio 2013. (Other authentication methods you might use include SQL Authentication or an OLEDB connection string.) Once the worksheet or diagram is published to SharePoint Server 2013, Excel Services or Visio Services can use Secure Store to connect to the data source when it displays the content to a user.

PerformancePoint Dashboard Designer is directly integrated with SharePoint Server 2013. Dashboard Designer can use Secure Store directly to authenticate by using the unattended service account. As a result, users of Dashboard Designer do not need direct access to data sources through Integrated Windows authentication, provided the unattended service account has the required access.

See also

Configure the Secure Store Service in SharePoint 2013
Overview of Excel Services in SharePoint Server 2013
Plan for Visio Services in SharePoint Server 2013


Use Excel Services with Secure Store Service in SharePoint Server 2013

Summary: Learn about the options available for using the Secure Store Service with Excel Services to refresh data from external data sources.

Applies to: SharePoint Server 2013

This series of articles describes how to configure data refresh in Excel Services in SharePoint Server 2013 by using the Secure Store Service to map user and group credentials to the credentials of external data sources.

In Secure Store you specify a group of users to whom you want to grant access to a data source and a set of credentials that has access to that data source. The user information is stored in a Secure Storetarget application and the associated credentials are stored, encrypted, in the Secure Store database. You can then specify the target application in a workbook, an Office Data Connection (ODC) file, or in Excel Services Global Settings, and Excel Services will use the stored credentials on behalf of the specified users to refresh data in a data-connected workbook.

Note:

These articles assume that you have already deployed a Secure Store Service Application. If you have not deployed Secure Store, see Plan the Secure Store Service in SharePoint Server 2013 and Configure the Secure Store Service in SharePoint 2013.

Excel Services can be used with Secure Store in three primary scenarios:

  • Unattended Service Account: The unattended service account is an account that is used by Excel Services to provide broad database access to all users in the farm. Use the unattended service account for accessing data that is not considered sensitive or where you do not want to restrict access to a certain group of users. For information about how to configure this scenario, see Configure Excel Services data refresh by using the unattended service account in SharePoint Server 2013.

  • Embedded Connections: In Excel, you can specify a Secure Store target application directly in the workbook. When the workbook is published to a SharePoint document library and then rendered by using Excel Services, the specified target application is used to refresh the data. For information about how to configure this scenario, see Configure Excel Services data refresh by using embedded data connections in SharePoint Server 2013.

  • External Data Connections: You can specify a Secure Store target application in an Office Data Connection (ODC) file and then connect to that ODC file in Excel. When you publish the workbook to a SharePoint document library, it maintains its connection to the ODC file. The connection information in the ODC file is used when Excel Services refreshes the data in the workbook. Using an ODC file has the following advantages:

    • A single ODC file can be referenced by multiple workbooks. If the data source connection parameters change (for example, if you want to use a different Secure Store target application than the one originally specified) you need only update the ODC file and not the workbooks themselves.

    • Using ODC files allows administrators to create and maintain the data connections that are used by the organization. You can create data connections appropriate for users, place them in a trusted data connection library, and then notify the users of which ODC files to use for their queries.

    For information about how to configure this scenario, see Configure Excel Services data refresh by using external data connections in SharePoint Server 2013.


Configure Excel Services data refresh by using the unattended service account in SharePoint Server 2013
See also

Summary: Configure Excel Services in SharePoint Server 2013 to use the unattended service account for authentication to external data.

Applies to: SharePoint Server 2013

Excel Services in SharePoint Server 2013 provides three methods of using Secure Store Service to refresh the external data source in a workbook:

  • You can use an unattended service account. This article describes how to do this.

  • You can specify a Secure Store target application in a workbook. (This is known as an embedded connection.) For more information, see Configure Excel Services data refresh by using embedded data connections in SharePoint Server 2013.

  • You can use an Office Data Connection (ODC) file that specifies a Secure Store target application. For more information, see Configure Excel Services data refresh by using external data connections in SharePoint Server 2013.

Using the unattended service account involves configuring an Active Directory account and granting it access to your data, storing the credentials for this account in Secure Store, and configuring Excel Services to use the stored credentials when it needs to refresh the data in a workbook.

The following steps are required to configure the unattended service account in Excel Services.

  1. Configure a data access account

  2. Configure Excel Services Global Settings

  3. Configure a workbook to use the unattended service account

Configure a data access account

The unattended service account requires an Active Directory account for data access. Have your domain administrator create an Active Directory account that you can use for data access.

After the account has been created, you must grant this account read access to the data source that you will be using in your data-connected Excel workbook. Use the following procedure to create a logon for the data access account in SQL Server. (If you are using a data source other than SQL Server, see the instructions for your data source to create a logon with data-read permissions for the data access account.)

To create a SQL Server logon for the data access account

  1. In SQL Server Management Studio, connect to the database engine.

  2. In Object Explorer, expand Security.

  3. Right-click Logins, and then click New Login.

  4. In the Login name box, type the name of the Active Directory account that you created for data access.

  5. In the Select a page section, click User Mapping.

  6. Select the Map check box for the database that you want to provide access to, and then, in the Database role membership for: <database> section, select the db_datareader check box.

  7. Click OK.

Now that you have created a logon for the data access account and granted the account access to your data source, you must create a target application in Secure Store to contain the credentials for the data access account.

Configure Excel Services Global Settings

The unattended service account configuration is part of the Excel Services Global Settings. Use the following procedure to configure the unattended service account in Excel Services.

To configure Excel Services Global Settings

  1. On the the SharePoint Central Administration website home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Excel Services service application.

  3. On the Manage the Excel Services page, click Global Settings.

  4. On the Excel Services Settings page, in the External Data section:

    • Select the Create a new Unattended Service Account option.

    • Type the user name and password of the account that you created for data access.

  5. Click OK.

With the Excel Services Global Settings configured, setup of the unattended service account is complete. The next section describes how to configure the Excel Services authentication settings in a data-connected Excel workbook to refresh the data with the unattended service account after the workbook has been published to a SharePoint document library.

Configure a workbook to use the unattended service account

You must configure the Excel Services Authentication Settings in the workbook before you publish it to SharePoint Server 2013. Doing so enables the workbook to use the unattended service account to refresh data when the workbook is rendered in Excel Services. Use the following procedure to configure the authentication settings.

To configure Excel Services authentication settings

  1. In a data-connected Excel workbook, on the Data tab, click Connections.

  2. On the Workbook Connections dialog box, select the data connection that you want to update, and then click Properties.

  3. On the Connection Properties dialog box, on the Definition tab, click Authentication Settings.

  4. On the Excel Services Authentication Settings dialog box, select the None option, and then click OK.

  5. On the Connection Properties dialog box, click OK.

    Note:

    If you see a warning that the link to the external connection file will be removed, click Yes.

  6. On the Workbook Connections dialog box, click Close.

With the Excel Services Authentication Settings set to None, Excel Services uses the unattended service account to refresh the data in the workbook after you have published it to SharePoint Server 2013.

See also

Use Excel Services with Secure Store Service in SharePoint Server 2013


Configure Excel Services data refresh by using embedded data connections in SharePoint Server 2013
See also

Summary: Configure Excel Services to use a Secure Store target application for external data refresh.

Applies to: SharePoint Server 2013

Excel Services in SharePoint Server 2013 supports three methods of using Secure Store Service to connect to external data:

  • You can specify a Secure Store target application in a workbook. (This is known as an embedded connection.) This article describes how to do this.

  • You can use an unattended service account. For more information, see Configure Excel Services data refresh by using the unattended service account in SharePoint Server 2013.

  • You can use an Office Data Connection (ODC) file that specifies a Secure Store target application. For more information, see Configure Excel Services data refresh by using external data connections in SharePoint Server 2013.

To configure Excel Services data access to use embedded data connections, you use the following process:

  1. Configure a data access account

  2. Create a Secure Store target application

  3. Configure a workbook to use an embedded data connection

Configure a data access account

You must have an account that can be granted access to the data source to which you want to connect your Excel workbook. This can be a Windows Active Directory account, a SQL Server logon, or other set of credentials as required by your data source. This account will be stored in Secure Store.

Once you have created the account, the next step is to grant that account read access to the required data. (In this article, we use the example of accessing a SQL Server database through an Active Directory account. If you are using a data source other than SQL Server, see the instructions for your data source to create a logon with data-read permissions for the data access account.)

Follow these steps to create a SQL Server logon and grant Read access to the database.

To create a SQL Server logon for the data access account

  1. In SQL Server Management Studio, connect to the database engine.

  2. In Object Explorer, expand Security.

  3. Right-click Logins, and then click New Login.

  4. In the Login name box, type the name of the Active Directory account that you created for data access.

  5. In the Select a page section, click User Mapping.

  6. Select the Map check box for the database that you want to provide access to, and then, under Database role membership for: <database>, select the db_datareader check box.

  7. Click OK.

Now that you have created a data access account and granted it access to a data source, the next step is to create a Secure Store target application.

Create a Secure Store target application

You must create a target application in Secure Store that contains the credentials that you created for data access. This target application can then be specified in data-connected Excel workbooks and will be used by Excel Services when it refreshes data in the workbook.

When you create the target application, you have to specify which users will be authorized to use the credentials stored in Secure Store. You can list users individually, or you can use an Active Directory group. We recommend that you use an Active Directory group for ease of administration.

Note:

The users that you list in the target application do not have direct access to the stored credentials. Instead, Excel Services uses the credentials on their behalf to refresh data in data-connected workbooks that specify this target application.

Use the following procedure to create a Secure Store target application.

To create a target application

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store service application.

  3. On the ribbon, click New.

  4. In the Target Application ID box, type a unique identifier for this target application (for example, ExcelServicesDataAccess).

  5. In the Display Name box, type a friendly name or short description.

  6. In the Contact E-mail box, type the e-mail address for a contact for this target application.

  7. In the Target Application Type drop-down list, select Group.

  8. Click Next.

  9. On the Credential Fields page, if you are using Windows credentials, leave the default credential fields. If you are using credentials other than Windows credentials, modify the Field Type drop-down lists to comply with the credentials that you are using. Click Next.

  10. On the Specify the membership settings page:

    • In the Target Application Administrators box, type the account of the user who will administer this target application.

      Note:

      You can specify multiple users or an Active Directory group.

    • In the Members box, type the users to whom you want to grant the ability to refresh data.

      Note:

      You can specify multiple users or an Active Directory group.

  11. Click OK.

Use the following procedure to set the credentials for the target application.

To set the credentials for the target application

  1. On the Secure Store Service Application page, in the Target Application ID column, point to the target application that you just created, click the arrow that appears, and then click Set Credentials.

  2. Type the user name and password of the data access account.

  3. Click OK.

Once you have set the credentials for the target application, the target application is ready to use. The next step is to specify this target application in the Excel Services authentication settings in your data-connected Excel workbook.

Configure a workbook to use an embedded data connection

You must configure the Excel Services Authentication Settings in the workbook before you publish it to SharePoint Server 2013. Doing so enables the workbook to use a Secure Store target application to refresh data that is rendered using Excel Services. Use the following procedure to configure the authentication settings.

To configure Excel Services authentication settings

  1. In a data-connected Excel workbook, on the Data tab, click Connections.

  2. On the Workbook Connections dialog box, select the data connection that you want to update, and then click Properties.

  3. On the Connection Properties dialog box, on the Definition tab, click Authentication Settings.

  4. On the Excel Services Authentication Settings dialog box, select the Use a stored account option, type the Application ID of the target application in the text box, and then click OK.

    Note:

    If you are using Excel 2010, select the SSS option.

  5. On the Connection Properties dialog box, click OK.

    Note:

    If you see a warning that the link to the external connection file will be removed, click Yes.

  6. On the Workbook Connections dialog box, click Close.

With the target application specified in the Excel Services Authentication Settings, Excel Services uses the credentials associated with that target application to refresh the data in the workbook after you have published it to SharePoint Server 2013.

See also

Configure the Secure Store Service in SharePoint 2013


Configure Excel Services data refresh by using external data connections in SharePoint Server 2013
See also

Summary: Configure Excel Services data refresh by using Secure Store and an external Office Data Connection (ODC) file.

Applies to: SharePoint Server 2013

Excel Services in SharePoint Server 2013 provides three methods of using Secure Store Service to refresh the external data source in a workbook:

  • You can use an unattended service account. For more information, see Configure Excel Services data refresh by using the unattended service account in SharePoint Server 2013.

  • You can specify a Secure Store target application in a workbook. (This is known as an embedded connection.) For more information, see Configure Excel Services data refresh by using embedded data connections in SharePoint Server 2013.

  • You can use an Office Data Connection (ODC) file that specifies a Secure Store target application. This article describes how to do this.

By using an ODC file for your data connection, you separate your Excel workbooks from the data connection information. This allows you to share a single ODC file among multiple workbooks and also allows you to centrally manage your data connections.

Using Excel Services with an ODC file consists of the following steps:

  1. Configure a data access account

  2. Create a Secure Store target application

  3. Create and publish an ODC file

  4. Configure an Excel workbook to use the published ODC file as a data connection

Configure a data access account

You must have an account that can be granted access to the data source to which you want to connect your Excel workbook. This can be an Active Directory account, a SQL Server logon, or other set of credentials as required by your data source. This account will be stored in Secure Store.

After you have created the account, the next step is to grant that account read access to the required data. (in this article, we use the example of accessing a SQL Server database through an Active Directory account. If you are using a data source other than SQL Server, see the instructions for your data source to create a logon with data read permissions for the data access account.)

Follow these steps to create a SQL Server logon and grant Read access to the database.

To create a SQL Server logon for the data access account

  1. In SQL Server Management Studio, connect to the database engine.

  2. In Object Explorer, expand Security.

  3. Right-click Logins, and then click New Login.

  4. In the Login name box, type the name of the Active Directory account that you created for data access.

  5. In the Select a page section, click User Mapping.

  6. Select the Map check box for the database that you want to provide access to, and then, in the Database role membership for: <database> section, select the db_datareader check box.

  7. Click OK.

Now that you have created a data access account and granted it access to a data source, the next step is to create a Secure Store target application.

Create a Secure Store target application

You must create a target application in Secure Store that contains the credentials that you created for data access. This target application can then be specified in an ODC file and will be used by Excel Services when it refreshes data in the workbook.

When you create the target application, you have to specify which users will be authorized to use the credentials stored in Secure Store. You can list users individually, or you can use an Active Directory group. We recommend that you use an Active Directory group for ease of administration.

Note:

The users that you list in the target application do not have direct access to the stored credentials. Instead, Excel Services uses the credentials on their behalf to refresh data in data-connected workbooks that specify this target application.

Use the following procedure to create a Secure Store target application.

To create a target application

  1. On the the SharePoint Central Administration website home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store Service service application.

  3. On the ribbon, click New.

  4. In the Target Application ID box, type a unique identifier for this target application (for example, ExcelServicesDataAccess).

  5. In the Display Name box, type a friendly name or short description.

  6. In the Contact E-mail box, type the email address for a contact for this target application.

  7. In the Target Application Type drop-down list, select Group.

  8. Click Next.

  9. On the Credential Fields page, if you are using Windows credentials, leave the default credential fields. If you are using credentials other than Windows credentials, modify the Field Type drop-down list to comply with the credentials that you are using. Click Next.

  10. On the Specify the membership settings page:

    • In the Target Application Administrators box, type the account of the user who will administer this target application.

      Note:

      You can specify multiple users or an Active Directory group.

    • In the Members box, type the users to whom you want to grant the ability to refresh data.

      Note:

      You can specify multiple users or an Active Directory group.

  11. Click OK.

Use the following procedure to set the credentials for the target application.

To set the credentials for the target application

  1. On the Secure Store Service Application page, in the Target Application ID column, point to the target application that you just created, click the arrow that appears, and then click Set Credentials.

  2. Type the user name and password of the data access account.

  3. Click OK.

Once you have set the credentials for the target application, the target application is ready to use. The next step is to create an ODC file that specifies this target application for Excel Services data refresh.

Create and publish an ODC file

Now that the Secure Store target application is configured, the next step is to create the ODC file and publish it to a trusted data connection library. Use the following procedure to create an ODC file that specifies the target application that you just created.

Note:

The following procedures use Excel 2013. The procedures for Excel 2010 are similar.

To create and publish an ODC file

  1. In Excel, on the Data tab, in the Get External Data section, click From Other Sources, and then select your data source.

  2. Complete the wizard to create a data connection to your data source.

  3. On the Data tab, click Connections.

  4. On the Workbook Connections dialog box, select the connection that you just created, and then click Properties.

  5. On the Connection Properties dialog box, on the Definition tab, click Authentication Settings.

  6. On the Excel Services Authentication Settings dialog box, select the Use a stored account option, and in the Application ID box, type the Application ID of the Secure Store target application that you created.

    Note:

    In Excel 2010, select the SSS option.

  7. Click OK.

  8. On the Connection Properties dialog box, click Export Connection File.

  9. Save the ODC file to a trusted data connection library on your farm.

Configure an Excel workbook to use the published ODC file as a data connection

In order for a workbook to use the ODC file that you just created, you must connect to it as a data source. Once it is connected, you can publish the workbook to a SharePoint Server 2013 document library and it will maintain its connection to the ODC file. Excel Services then uses the connection information specified in the ODC file when it refreshes data in the workbook.

Use the following procedure to connect to the ODC file in Excel.

To use an ODC file as a data source in Excel

  1. In Excel, on the Data tab, in the Get External Data section, click Existing Connections.

  2. On the Existing Connections dialog box, click Browse for More.

  3. On the Select Data Source dialog box, in the URL box, type the URL for the trusted data connection library where you saved the ODC file, and then press Enter.

    Note:

    It may take several moments for the list to refresh with content from the specified location.

  4. On the list of Data Connections, select the ODC file that you saved, and then click Open.

  5. On the Import Data dialog box, select the PivotTable Report or PivotChart and PivotTable Report option, and then click OK.

  6. On the Data tab, click Connections.

  7. On the Workbook Connections dialog box, select the connection that you just opened, and then click Properties.

  8. On the Connection Properties dialog box, on the Definition tab, select the Always use connection file check box, and then click OK.

    Note:

    This ensures that the connection file that you connected to will be used rather than the embedded connection information.

  9. Click Close.

Once you have completed the data connection wizard, you can create your report and then publish it to a document library. When the workbook is rendered using Excel Services, Excel Services uses the connection information specified in the ODC file to refresh the data.

Note:

You must publish the workbook to an Excel Services trusted file location.

See also

Configure the Secure Store Service in SharePoint 2013


Use PerformancePoint Services with Secure Store Service in SharePoint Server 2013

Published: October 30, 2012

Summary: Learn about the options available for using the Secure Store Service with PerformancePoint Services to connect to and refresh data from external data sources.

Applies to: SharePoint Server 2013 Enterprise

This series of articles describes how to configure data access in PerformancePoint Services in SharePoint Server 2013 by using the Secure Store Service to map user and group credentials to the credentials of external data sources.

In Secure Store you specify a group of users to whom you want to grant access to a data source and a set of credentials that has access to that data source. The user information is stored in a Secure Storetarget application and the associated credentials are stored, encrypted, in the Secure Store database. You can then specify the target application in PerformancePoint Dashboard Designer, and PerformancePoint Services will use the stored credentials on behalf of the specified users to access data in Dashboard Designer and in the browser.

Note:

These articles assume that you have already deployed a Secure Store Service Application. If you have not deployed Secure Store, see Plan the Secure Store Service in SharePoint Server 2013 and Configure the Secure Store Service in SharePoint 2013.

PerformancePoint Services can be used with Secure Store in two primary scenarios:

  • Unattended Service Account: The unattended service account is an account that is used by PerformancePoint Services to provide broad database access to all users in the farm. Use the unattended service account for accessing data that is not considered sensitive or where you do not want to restrict access to a certain group of users. For information about how to configure this scenario, see Configure the unattended service account for PerformancePoint Services (SharePoint Server 2013).

  • Specified target application: You can specify a Secure Store target application in Dashboard Designer and Dashboard Designer will use the credential stored in Secure Store to access the selected data source. When you publish your dashboard, PerformancePoint Services will use these credentials to provide data refresh for authorized users. For information about how to configure this scenario, see Configure Secure Store for use with PerformancePoint Services.


Configure the unattended service account for PerformancePoint Services (SharePoint Server 2013)

Summary: Learn how to configure the unattended service account for PerformancePoint Services.

Applies to: SharePoint Server 2013

The unattended service account is an Active Directory account that is used for accessing PerformancePoint Services data sources. This account is used by PerformancePoint Services on behalf of authorized users to provide access to external data sources for the purposes of creating and using dashboards and other PerformancePoint Services content. To configure the unattended service account, see Configure the unattended service account for PerformancePoint Services in this article.

Note:

The unattended service account is a universal account that provides equal data access to all authorized users. If you need more fine-grained data access, see Configure Secure Store for use with PerformancePoint Services.

PerformancePoint Services uses Secure Store Service to store the unattended service account password. Before using the Unattended Service Account, make sure that Secure Store has been configured.

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

Configure the unattended service account for PerformancePoint Services

Use the following procedure to configure the unattended service account for PerformancePoint Services.

To configure the unattended service account for PerformancePoint Services

  1. On the SharePoint Central Administration Web site, in the Application Management section, click Manage Service Applications, and then click the PerformancePoint Services service application.

  2. On the Manage PerformancePoint Services page, click PerformancePoint Service Application Settings.

  3. In the Secure Store and Unattended Service Account section, enter the user name and password for the account that you want to use as the unattended service account.

  4. Click OK.

You will see the Secure Store Service name and the user name that represents the unattended service account.

Once the unattended service account has been configured, you must grant that account access to your data sources:

  • For SQL Server data, the account must have a SQL logon with db_datareader permissions on each database that you want to access.

  • For SQL Server Analysis Services data, the account must have read access to the cube or an appropriate portion of the cube, depending on your needs.

  • For Excel Services data, the account must have access to the Excel workbook in a SharePoint document library.

  • For data in a SharePoint list, the account must have read access to the list.


Configure Secure Store for use with PerformancePoint Services
See also

Published: October 30, 2012

Summary: Configure PerformancePoint Services to use a Secure Store target application for external data refresh.

Applies to: SharePoint Server 2013 Enterprise

PerformancePoint Services in SharePoint Server 2013 supports two methods of using Secure Store Service to connect to external data:

  • You can specify a Secure Store target application in PerformancePoint Dashboard Designer. This article describes how to do this.

  • You can use an unattended service account. For more information, see Configure the unattended service account for PerformancePoint Services (SharePoint Server 2013).

To configure PerformancePoint Services data access to use a Secure Store target application, you use the following process:

  1. Configure a data access account

  2. Create a Secure Store target application

  3. Configure a data connection to use a Secure Store target application

Configure a data access account

You must have a Windows Active Directory account that can be granted access to the data source to which you want to connect in Dashboard Designer. This account will be stored in Secure Store.

Once you have created the account, the next step is to grant that account read access to the required data. (In this article, we use the example of accessing a SQL Server database. If you are using a data source other than SQL Server, see the instructions for your data source to create a logon with data-read permissions for the data access account.)

Follow these steps to create a SQL Server logon and grant Read access to the database.

To create a SQL Server logon for the data access account

  1. In SQL Server Management Studio, connect to the database engine.

  2. In Object Explorer, expand Security.

  3. Right-click Logins, and then click New Login.

  4. In the Login name box, type the name of the Active Directory account that you created for data access.

  5. In the Select a page section, click User Mapping.

  6. Select the Map check box for the database that you want to provide access to, and then, under Database role membership for: <database>, select the db_datareader check box.

  7. Click OK.

Now that you have created a data access account and granted it access to a data source, the next step is to create a Secure Store target application.

Create a Secure Store target application

You must create a target application in Secure Store that contains the credentials that you created for data access. This target application can then be specified in the data source settings in Dashboard Designer.

When you create the target application, you have to specify which users will be authorized to use the credentials stored in Secure Store. You can list users individually, or you can use an Active Directory group. We recommend that you use an Active Directory group for ease of administration.

Note:

The users that you list in the target application do not have direct access to the stored credentials. Instead, Dashboard Designer uses the credentials on their behalf to connect to the database, and PerformancePoint Services uses the credentials on their behalf when refreshing data in a published dashboard.

Use the following procedure to create a Secure Store target application.

To create a target application

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store service application.

  3. On the ribbon, click New.

  4. In the Target Application ID box, type a unique identifier for this target application (for example, PerformancePointServicesDataAccess).

  5. In the Display Name box, type a friendly name or short description.

  6. In the Contact E-mail box, type the e-mail address for a contact for this target application.

  7. In the Target Application Type drop-down list, select Group.

  8. Click Next.

  9. On the Credential Fields page, leave the default values of Windows User Name and Windows Password and click Next.

  10. On the Specify the membership settings page:

    • In the Target Application Administrators box, type the account of the user who will administer this target application.

      Note:

      You can specify multiple users or an Active Directory group.

    • In the Members box, type the users to whom you want to grant the ability to refresh data.

      Note:

      You can specify multiple users or an Active Directory group.

  11. Click OK.

Use the following procedure to set the credentials for the target application.

To set the credentials for the target application

  1. On the Secure Store Service Application page, in the Target Application ID column, point to the target application that you just created, click the arrow that appears, and then click Set Credentials.

  2. Type the user name and password of the data access account.

  3. Click OK.

Once you have set the credentials for the target application, the target application is ready to use. The next step is to specify this target application in Dashboard Designer as part of the data source settings.

Configure a data connection to use a Secure Store target application

You must configure your PerformancePoint Services data connection to use the Secure Store. After doing so, you can connect to the external data source in Dashboard Designer and create your dashboard. Use the following procedure to configure a PerformancePoint Services data connection.

To configure a data connection to use a Secure Store target application

  1. In Dashboard Designer, on the Create tab, click Data Source.

  2. On the Select a Data Source Template dialog box, choose your data source and click OK.

  3. In the Data Source Settings section, choose the Use a stored account option.

  4. In the Application ID box, type the target application ID of the Secure Store target application that you created.

  5. In the Connection Settings section, connect to your external data source.

  6. Click Test Data Source to test the connection.

  7. Create and publish your dashboard.

    Note:

    For detailed information about creating dashboards, see Create Dashboards by using PerformancePoint Services (SharePoint Server 2013).

With the target application specified in Dashboard Designer, PerformancePoint Services uses the credentials associated with that target application to refresh the data in the dashboard after you have published it to SharePoint Server 2013.

See also

Configure the Secure Store Service in SharePoint 2013


Use Visio Services with Secure Store Service in SharePoint 2013
See also

Summary: Secure Store can be used to store encrypted credentials for use in refreshing data-connected Visio diagrams in Visio Services.

Applies to: SharePoint Server 2013

Visio Services in SharePoint Server 2013 can be configured to use the Secure Store Service to provide user authentication for data-connected diagrams that use an external data source such as SQL Server.

Note:

This article assumes that you have already deployed a Secure Store Service service application. If you have not deployed Secure Store, see Plan the Secure Store Service in SharePoint Server 2013 and Configure the Secure Store Service in SharePoint 2013.

Secure Store provides a method of mapping users who do not have direct data access to an account that does have data access. Secure Store and Visio Services work together in the following basic sequence of events:

  1. A user accesses a data-connected diagram on a SharePoint site.

  2. Visio Services passes the user's identity to Secure Store.

  3. Secure Store determines whether the user is authorized to access the data. If so, Secure Store returns the data access credentials to Visio Services.

  4. Visio Services impersonates the data access credentials, accesses the data, and displays the data to the user.

Visio Services provides three methods of using Secure Store to provide data access:

  • Unattended Service Account: The unattended service account is an account that is used by Visio Services to provide broad database access to all users in the farm. Use the unattended service account for accessing data that is not considered sensitive or where you do not want to restrict access to a certain group of users. For information about how to configure this scenario, see Configure Visio Services data refresh in SharePoint Server 2013 by using the unattended service account.

  • External Data Connections: You can specify a Secure Store target application in an Office Data Connection (ODC) file and then connect to that ODC file in Visio. When you publish the diagram to a SharePoint document library, it maintains its connection to the ODC file. The connection information in the ODC file is used when Visio Services refreshes the data in the workbook. Using an ODC file has the following advantages:

    • A single ODC file can be referenced by multiple diagrams. If the data source connection parameters change (for example, if you want to use a different Secure Store target application than the one originally specified) you need only update the ODC file and not the diagrams themselves.

    • Using ODC files allows administrators to create and maintain the data connections used by the organization. You can create data connections appropriate for users, place them in a trusted data connection library, and then notify the users of which ODC files to use for their queries.

    Note:

    ODC files that will be used with Visio and Visio Services must be created in Excel 2010 or Excel 2013.

    For information about how to configure this scenario, see Configure Visio Services data refresh in SharePoint Server 2013 by using external data connections.

Visio Professional 2013, which is used to create the diagrams, does not use Secure Store for data authentication. You must configure direct data access for diagram authors. Once the diagram has been published to a SharePoint site, Visio Services can use Secure Store when it renders the diagram.

See also

Secure Store for Business Intelligence service applications (SharePoint Server 2013)


Configure Visio Services data refresh in SharePoint Server 2013 by using the unattended service account
See also

Summary: Configure Visio Services in SharePoint Server 2013 to refresh data by using the unattended service account.

Applies to: SharePoint Server 2013

Configuring an unattended service account for Visio Services consists of the following steps:

  1. Create an account to use for data access

  2. Create a logon for the data access account on the data source

  3. Create a Secure Store target application that uses the data access account credentials

  4. Configure Visio Services to use the Secure Store target application for the unattended service account

  5. Create an Office Data Connection (ODC) file by using Visio and publish it to a SharePoint data connection library

  6. Use the ODC file as a data source in Visio

The first step is to create an account to use for data access. Have your domain administrator create an Active Directory account that you can use to access your data sources.

Important:

Visio Services requires an Active Directory account for the unattended service account. You cannot use a non-Windows account.

Once the account has been created, follow these steps to create a logon for the data access account in SQL Server. (If you are using a data source other than SQL Server, see the instructions for your data source to create a logon with data read permissions for the data access account.)

To create a SQL Server logon for the data access account

  1. In SQL Server Management Studio, connect to the database engine.

  2. In Object Explorer, expand Security.

  3. Right-click Logins, and then click New Login.

  4. In the Login name box, type the name of the Active Directory account that you created for data access.

  5. In the Select a page section, click User Mapping.

  6. Select the Map check box for the database that you want to provide access to, and then in the Database role membership for: <database> section, select the db_datareader check box.

  7. Click OK.

After you have created a logon for the data access account and granted the account access to your data source, you must create a target application in Secure Store to contain the credentials for the data access account.

To create a target application for the unattended service account

  1. On the the SharePoint Central Administration website home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store Service service application.

  3. On the ribbon, click New.

  4. In the Target Application ID box, type an ID for the target application (for example, VisioServicesUnattended).

  5. In the Display Name box, type a name for the target application.

  6. In the Contact E-mail box, type an email address.

  7. In the Target Application Type drop-down list, select Group.

  8. Click Next.

  9. Leave the default credential fields, and then click Next.

  10. On the "Specify the membership settings" page:

    1. In the Target Application Administrators box, type the account of the user who will administer this account.

      Note:

      You can type multiple names or the name of an Active Directory group that contains the users whom you want to administer this target application.

    2. In the Members box, type Everyone.

      Note:

      The unattended service account is intended for granting broad database access. You can restrict the users who have access to the unattended service account to a specific Active Directory group if you want, but be aware that only one unattended service account can be created per Visio Services service application.

    3. Click OK.

After the target application has been created, you must set the target application to use the credentials for the data access account that you created. Use the following procedure to set the credentials.

To set the credentials for the target application

  1. On the Secure Store Service Application page, in the Target Application ID column, point to the target application that you just created, click the arrow that appears, and then click Set Credentials.

  2. In the Windows User Name box, type the Active Directory account that you created for data access.

  3. Type and confirm the password for the account.

  4. Click OK.

The target application configuration is now complete. The next step is to designate this target application for use as the unattended service account in Visio Services. Use the following procedure to configure the unattended service account in Visio Services Global Settings.

To configure Visio Services Global Settings

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click the Visio Services service application.

  3. On the Manage the Visio Graphics Service page, click Global Settings.

  4. On the Visio Graphics Service Settings page, in the External Data section, in the Application ID box, type the ID of the Secure Store target application that you just created.

  5. Click OK.

Once you have configured the External Data setting in Visio Services Global Settings, the unattended service account is configured and ready to use.

The next step is to create an ODC file that specifies the unattended service account. You can create the ODC file in Visio as part of your diagram creation process.

Use the following procedure to create an ODC file and publish it to a data connection library.

Note:

This procedure uses Visio Professional 2013. If you are using Visio 2010, then you must create the ODC file in Excel.

Use the following procedure to create a data-connected diagram by using an ODC file.

To create an ODC file and link data to shapes in Visio

  1. In Visio Professional 2013, open a diagram or create a new diagram.

  2. On the ribbon, click the Data tab, and then click Link Data to Shapes.

  3. On the Connect to Database Server page, type the name of your database server, and then click Next.

  4. On the Select Database and Table page, select the database to which you want to connect, and then click Next.

  5. On the Save Data Connection File and Finish page:

    1. Click Authentication Settings.

    2. On the Visio Services Authentication Settings dialog box, choose the None option and click OK.

    3. Click Browse.

    4. Browse to a data connection library.

      Note:

      Visio Services does not require that ODC files be saved to a data connection library. However, for easiest administration, we recommend using data connection libraries to store all your data connection files.

    5. Type a name for the ODC file, and then click Save.

    6. Click Finish.

  6. If the Web File Properties dialog box appears, click Cancel.

  7. On the Select Data Connection page, click Finish.

  8. Connect the data to the shapes in your diagram.

  9. When you are ready to save the drawing, click File, click Save, and then browse to a SharePoint document library.

  10. Type a file name, and then click Save.

Once the diagram has been published, it is available to view by using Visio Services. When the data in the diagram is refreshed, it uses the ODC file that you specified. The None option specified in the ODC file will cause Visio Services to use the unattended service account.

Once the ODC file has been saved to the data connection library, you can connect directly to it when linking data to shapes in Visio. This allows you to share a single data connection file among multiple Visio diagrams.

Use the following procedure to connect to an existing ODC file.

To create a data-connected diagram by using an ODC file

  1. In Visio Professional 2013, open a diagram or create a new diagram.

  2. On the ribbon, click the Data tab, and then click Link Data to Shapes.

  3. On the Data Selector page of the wizard, click Previously created connection, and then click Next.

  4. On the Select Data Connection page, click Browse.

  5. On the Existing Connections dialog box, click Browse for More.

  6. In the Data Selector dialog box, in the URL box, type the URL of the data connection library where you saved the ODC file, and then press Enter.

  7. Select the ODC file and then click Open.

  8. On the Select Data Connection page, click Finish.

  9. Connect the data to the shapes in your diagram.

  10. When you are ready to save the drawing, click File, click Save, and then browse to a SharePoint document library.

  11. Type a file name, and then click Save.

See also

Configure Visio Services data refresh in SharePoint Server 2013 by using external data connections


Configure Visio Services data refresh in SharePoint Server 2013 by using external data connections
See also

Summary: Configure Visio Services in SharePoint Server 2013 to refresh data using an external Office Data Connection (ODC) file and a Secure Store Service target application.

Applies to: SharePoint Server 2013

You can map a specific group of users to a specific data source by using group mappings and an external data connection file in Secure Store. This provides more fine-grained security than using the unattended service account. Creating a group mapping with an external data connection file consists of the following steps:

  1. Create an account to use for data access

  2. Create a logon for the data access account on the data source

  3. Create a Secure Store target application that uses the data access account credentials

  4. Create an Office Data Connection (ODC) file by using Visio and publish it to a SharePoint data connection library

  5. Use the ODC file as a data source in Visio

The first step is to create an account to use for data access. Have your administrator create an Active Directory account that you can use to access your data sources.

Note:

You can also use a SQL Server logon with SQL Server authentication. For information about how to use SQL Server with Secure Store, see Use Secure Store with SQL Server Authentication (SharePoint Server 2013).

Once the account has been created, follow these steps to create a logon for the data access account in SQL Server. (If you are using a data source other than SQL Server, see the instructions for your data source to create a logon with data-read permissions for the data access account.)

To create a SQL Server logon for the data access account

  1. In SQL Server Management Studio, connect to the database engine.

  2. In Object Explorer, expand Security.

  3. Right-click Logins, and then click New Login.

  4. In the Login name box, type the name of the Active Directory account that you created for data access.

  5. Under Select a page, click User Mapping.

  6. Select the Map check box for the database that you want to provide access to, and then, in the Database role membership for: <database> section, select the db_datareader check box.

  7. Click OK.

Once you have created a logon for the data access account and granted the account access to your data source, you must create a target application in Secure Store to contain the credentials for the data access account. This target application will be used to map the data access account to the users to whom you want to grant data access.

When you create the target application, you will be able to specify individual users to whom you want to grant data access, or you can specify an Active Directory group. For ease of administration, we recommend that you use an Active Directory group. This allows you to update the user list in the future without having to update the target application.

Use the following procedure to create the target application.

To create a target application

  1. On the the SharePoint Central Administration website home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store Service service application.

  3. On the ribbon, click New.

  4. In the Target Application ID box, type an ID for the target application (for example, VisioServicesDataAccess).

  5. In the Display Name box, type a name for the target application.

  6. In the Contact E-mail box, type an email address.

  7. In the Target Application Type drop-down list, select Group.

  8. Click Next.

  9. Leave the default credential fields, and then click Next.

  10. On the "Specify the membership settings" page:

    1. In the Target Application Administrators box, type the account of the user who will administer this account.

      Note:

      You can type multiple names or the name of an Active Directory group that contains the users whom you want to administer this target application.

    2. In the Members box, type the names of the users to whom you want to give data access or the name of the Active Directory group that contains those users.

    3. Click OK.

Once the target application has been created, you must set the target application to use the credentials for the data access account that you created. Use the following procedure to set the credentials.

To set the credentials for the target application

  1. On the Secure Store Service Application page, in the Target Application ID column, point to the target application that you just created, click the arrow that appears, and then click Set Credentials.

  2. In the Windows User Name box, type the Active Directory account that you created for data access.

  3. Type and confirm the password for the account.

  4. Click OK.

The next step is to create an ODC file that references the Secure Store target application that you just created. You can create the ODC file in Visio as part of your diagram creation process.

Use the following procedure to create an ODC file and publish it to a data connection library.

Note:

This procedure uses Visio Professional 2013. If you are using Visio 2010, then you must create the ODC file in Excel.

Use the following procedure to create a data-connected diagram by using an ODC file.

To create an ODC file and link data to shapes in Visio

  1. In Visio Professional 2013, open a diagram or create a new diagram.

  2. On the ribbon, click the Data tab, and then click Link Data to Shapes.

  3. On the Data Selector page, choose the Microsoft SQL Server database option, and then click Next.

  4. On the Connect to Database Server page, type the name of your database server, and then click Next.

  5. On the Select Database and Table page, select the database to which you want to connect, and then click Next.

  6. On the Save Data Connection File and Finish page:

    1. Click Authentication Settings.

    2. On the Visio Services Authentication Settings dialog box, choose the Use a stored account option, type the application ID of the Secure Store target application that you created in the Application ID text box, and click OK.

    3. Click Browse.

    4. Browse to a data connection library.

      Note:

      Visio Services does not require that ODC files be saved to a data connection library. However, for easiest administration, we recommend using data connection libraries to store all your data connection files.

    5. Type a name for the ODC file, and then click Save.

    6. Click Finish.

  7. If the Web File Properties dialog box appears, click OK.

  8. On the Select Data Connection page, click Finish.

  9. Connect the data to the shapes in your diagram.

  10. When you are ready to save the drawing, click File, click Save, and then browse to a SharePoint document library.

  11. Type a file name, and then click Save.

Once the diagram has been published, it is available to view by using Visio Services. When the data in the diagram is refreshed, it uses the ODC file that you specified and the Secure Store target application specified within.

Once the ODC file has been saved to the data connection library, you can connect directly to it when linking data to shapes in Visio. This allows you to share a single data connection file among multiple Visio diagrams.

Use the following procedure to connect to an existing ODC file.

To create a data-connected diagram by using an ODC file

  1. In Visio Professional 2013, open a diagram or create a new diagram.

  2. On the ribbon, click the Data tab, and then click Link Data to Shapes.

  3. On the Data Selector page of the wizard, click Previously created connection, and then click Next.

  4. On the Select Data Connection page, click Browse.

  5. On the Existing Connections dialog box, click Browse for More.

  6. In the Data Selector dialog box, in the URL box, type the URL of the data connection library where you saved the ODC file, and then press Enter.

  7. Select the ODC file and then click Open.

  8. On the Select Data Connection page, click Finish.

  9. Connect the data to the shapes in your diagram.

  10. When you are ready to save the drawing, click File, click Save, and then browse to a SharePoint document library.

  11. Type a file name, and then click Save.

See also

Configure Visio Services data refresh in SharePoint Server 2013 by using the unattended service account

Configure Visio Services data refresh by using embedded data connections (SharePoint Server 2013)


Test Lab Guides for Business Intelligence

Published: December 18, 2012

Summary: Configure the Business Intelligence features of SharePoint Server 2013 in a test lab environment.

Applies to: SharePoint Server 2013 Enterprise

This series of articles describes how to configure the Business Intelligence features in SharePoint Server 2013 in a test lab environment. These test labs are all part of the Microsoft TechNet Test Lab Guides series.

All of the test labs in this section have as a minimum prerequisite Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm and all the prerequisites listed in that test lab guide. The test lab guides in this series all make use of the three-tier infrastructure.

Each test lab guide in this series may have additional prerequisites. See each guide for its list of prerequisites.

The test lab guides in this series include:

  • Test Lab Guide: Create a Business Intelligence Baseline Environment - This test lab guide describes how to create a Business Intelligence Center and how to create Active Directory accounts for the subsequent test lab guides.

  • Test Lab Guide: Configure Secure Store - This test lab guide describes how to configure Secure Store in a test lab environment. Subsequent test lab guides for Excel Services, Visio Services, and PerformancePoint Services make use of Secure Store.

  • Test Lab Guide: Configure Excel Services - This test lab guide and the subsequent Excel Services guides describe how to configure Excel Services in a test lab environment, and how to enable data refresh.

  • Test Lab Guide: Configure Visio Services - This test lab guide and the subsequent Visio Services guides describe how to configure Visio Services in a test lab environment, and how to enable data refresh.

  • Test Lab Guide: Configure PerformancePoint Services - This test lab guide and the subsequent PerformancePoint Services guide describes how to configure PerformancePoint Services in a test lab environment, and how to enable data refresh.


Test Lab Guide: Create a Business Intelligence Baseline Environment

Published: January 8, 2013

Summary: Create a Business Intelligence Center in a test lab environment.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to create a Business Intelligence Center in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

The Business Intelligence Center gives you a central location to store items, such as reports and dashboards. When you enable Excel Services and PerformancePoint Services, you will already have a location to store reports and dashboard content.

Important:

Creating the Business Intelligence Center does not automatically enable the use of any of the business intelligence tools including PerformancePoint Services, Visio Graphics Service and Excel Services. This includes not being able to view or use the Excel Services samples or launch PerformancePoint ServicesDashboard Designer. After you finish creating your BI Center, configure the services you need. These features will then be activated on your BI Center.

In this article:

  • Scenario overview

  • Before you begin

  • Configure accounts

  • Create a Business Intelligence Center

  • Set permissions on the Business Intelligence Center

Scenario overview

This test lab guide explains how to create and configure the Business Intelligence Center. This includes:

  • Create a Business Intelligence Center

  • Set Permissions on the Business Intelligence Center

Before you begin

Before starting, make sure you have completed the steps in Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

Configure accounts

To configure SharePoint Server 2013 in a server farm environment, there are several domain accounts needed to provide the most optimal and secure configuration. This article describes how to create accounts and groups at the domain level for use in the remaining configuration steps in this series of articles.

Account | Domain account
Client user account | CORP\John.Woods
Client user account | CORP\Susan.Burk
Client user account | CORP\Cindy.White
Client user account | CORP\David.Hamilton
Client user account | CORP\Jill.Frank
Note:

Additional accounts will be created for SharePoint Server 2013 service applications and for data access as part of the other hands-on labs in this series.

Perform the following procedure for each account listed in the table. To create these accounts, you must be logged on to DC1 as CORP\administrator).

To create an Active Directory account

  1. Log onto DC1 as CORP\Administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the domain node.

  4. Right-click Users, click New, and then click User.

  5. For a user account (for example, John Woods or Susan Burk) type the first and last name in the First name and Last name text boxes. For a service account, leave these text boxes blank.

  6. In the Full name box, for service accounts, type the name of the account (for example, CORP\User1).

    Note:

    This text box is automatically populated for user accounts when you specify the First name and Last name fields.

  7. In the User logon name box, type the logon name for the account. For service accounts, this is the same as Full name; for user accounts this should be in the format first.last (for example, Susan.Burk).

  8. Click Next.

  9. Type and confirm a password for the account.

  10. Clear the User must change password at next logon check box.

  11. Select the Password never expires check box.

  12. Click Next.

  13. Click Finish.

Leave Active Directory Users and Computers open for the next procedure.

Once you have created the user accounts listed in the previous table, you must create an Active Directory group to contain these accounts. These groups are used to grant access to the Business Intelligence Center that we will create later in this series of labs.

We will create the groups listed in the following table.

Group | Description
BICenterRead | Provides Read access to the BI Center.
BICenterContribute | Provides Contribute access to the BI Center.
BICenterDesign | Provides Design access to the BI Center.
BICenterFullControl | Provides Full Control access to the BI Center.

Use the following procedure to create each Active Directory group.

To create an Active Directory group

  1. In Active Directory Users and Computers, right-click Users, click New, and then click Group.

  2. In the Group name text box, type the name of the group that you are creating from the previous table.

  3. Click OK.

Leave Active Directory Users and Computers open for the next procedure.

Once the groups have been created, you must add a user to each group, as specified in the following table.

Add this user | To this group
CORP\John.Woods | BICenterRead
CORP\Susan.Burk | BICenterContribute
CORP\Cindy.White | BICenterDesign
CORP\David.Hamilton | BICenterFullControl

Use the following procedure to add the specified user to each group.

To add users to an Active Directory group

  1. In Active Directory Users and Computers, click Users.

  2. In the pane on the right side, double-click the group to which you want to add a user.

  3. On the Members tab, click Add.

  4. In the Enter the object names to select box, type the name of the user whom you want to add to the group (for example, CORP\john.woods for the BICenterRead group).

  5. Click OK.

  6. Confirm that the appropriate user is now listed on the Members tab, and then click OK.

Create a Business Intelligence Center

To create and configure a Business Intelligence Center, you first create a new site collection using the Business Intelligence Center site template. The Business Intelligence Center is a top-level site.

To create a Business Intelligence Center

  1. Log in to APP1 using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the SharePoint Central Administration website home page, in the left navigation, click Application Management.

  4. In Application Management, click Create site collections.

  5. In the Title and Description section, in the Title box, type BI CENTER.

  6. In the Web Site Address section, type BICENTER in the box.

    The complete URL for this site collection is http://WFE1/sites/BICenter.

  7. In the Template Selection section, click the Enterprise tab, and then click Business Intelligence Center.

  8. In the Primary Site Collection Administrator section, type CORP\User1.

  9. Click OK.

  10. When the top-level site (Business Intelligence Center) is successfully created, click OK.

  11. Assign user permissions to the Business Intelligence Center.

Set permissions on the Business Intelligence Center

The next step is to assign user permissions to the Business Intelligence Center.

  1. Go to your Business Intelligence Center (http://WFE1/sites/BICenter).

  2. In the upper right corner, click Share.

  3. Click Site Settings.

  4. Click Site Permissions.

  5. In the ribbon, click Grant Permissions.

  6. In the Share 'Central Administration'… Invite people to box, type the name of the account you want to which you wish to assign permissions.

  7. Click Show Options and select a group or permissions level.

  8. Click Share.

Repeat this for each account as needed. The following table is a simple example of organizing your accounts and permission settings for your BI Center.

Account | Permissions
CORP\BICenterRead | Read Read permissions enable users to view information in the Business Intelligence Center.
CORP\BICenterContribute | Contribute Contribute permissions enable users to view and create items, such as reports, and save them to this site.
CORP\BICenterDesign | Design Design permissions enable users to view, create, and publish items that include dashboards.
CORP\BICenterFullControl | Full Control Full Control permissions enable users to view, create, and publish dashboard content, and to view or edit user permissions


Test Lab Guide: Configure Secure Store
See also

Published: December 18, 2012

Summary: Configure Secure Store in a test lab environment.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to set up the Secure Store Service in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Scenario overview

  • Before you begin

  • Configure a managed account

  • Configure a Secure Store service application

  • Generate an encryption key

Scenario overview

This test lab guide explains how to configure Secure Store. This includes:

  • Creating an Active Directory account to run the Secure Store application pool and registering it as a managed account in SharePoint Server.

  • Starting the Secure Store Service and creating a Secure Store service application.

  • Generating an encryption key for the Secure Store database.

Before you begin

Before starting, make sure you have completed the steps in Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

Configure a managed account

The Secure Store service application requires an application pool to operate. The application pool requires an Active Directory account to run. Use the following procedure to create an Active Directory account for the application pool.

To create an Active Directory account

  1. Log on to DC1 as Corp\Administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand corp.contoso.com.

  4. Right-click ServiceAccounts, click, New, and then click User.

  5. In the Full name text box, type Secure Store Application Pool.

  6. In the User logon name text box, type SecureStore.

  7. Click Next.

  8. Type and confirm a password for the account.

  9. Clear the User must change password at next logon checkbox.

  10. Select the Password never expires checkbox.

  11. Click Next.

  12. Click Finish.

Once the account has been created, the next step is to register it as a managed account in SharePoint Server 2013. Use the following procedure to register the managed account.

To register a managed account in SharePoint Server

  1. Log on to APP1 as Corp\User1.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the Central Administration home page, in the left navigation, click Security.

  4. On the Security page, in the General Security section, click Configure managed accounts.

  5. On the Managed Accounts page, click Register Managed Account.

  6. In the User name text box, type CORP\SecureStore.

  7. In the Password text box, type the password for the CORP\SecureStore account.

  8. Click OK.

Once the CORP\SecureStore account has been registered as a managed account, the next step is to configure a Secure Store service application. This is covered in the next section.

Configure a Secure Store service application

Prior to creating a Secure Store service application, we need to start the Secure Store Service on APP1.

To start the Secure Store Service

  1. On the Central Administration home page, in the System Settings section, click Manage services on server.

  2. Above the Service list, click the Server drop-down list, and then click Change Server.

  3. Click APP1.

  4. In the Service list, click Start next to Secure Store Service.

Once the Secure Store Service has been started, the next step is to create a Secure Store service application.

To create a Secure Store service application

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click New, and then click Secure Store Service.

  3. In the Service Application Name box, type Secure Store.

  4. In the Database Server box, type SQL1.

  5. Select the Create new application pool option and type SecureStoreAppPool in the text box.

  6. Select the Configurable option, and, from the drop-down list, select CORP\SecureStore.

  7. Click OK.

The Secure Store Service has now been configured. The next step is to generate an encryption key for encrypting the Secure Store database.

Generate an encryption key

The first time that you access the Secure Store service application, your only option is to generate a new encryption key. Once the key has been generated, the rest of the Secure Store functionality becomes available.

Use the following procedure to generate an encryption key for Secure Store.

To generate a new encryption key

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. Click the Secure Store service application.

  3. On the ribbon, in the Key Management section, click Generate New Key.

  4. On the Generate New Key page, type a pass phrase string in the Pass Phrase box, and type the same string in the Confirm Pass Phrase box. This pass phrase is used to encrypt the Secure Store database.

    Important:

    A pass phrase string must be at least eight characters and must have at least three of the following four elements:

    • Uppercase characters

    • Lowercase characters

    • Numerals

    • Any of the following special characters

      "! " # $ % & ' ( ) * + , - . / : ; < = > ? @ [ \ ] ^ _ ` { | } ~

    Important:

    The pass phrase that you enter is not stored. Make sure that you write this down and store it in a safe place. You must have it to refresh the key, such as when you add a new application server to the server farm.

  5. Click OK.

Once the key has been generated, Secure Store is ready to use.

See also

Configure the Secure Store Service in SharePoint 2013


Test Lab Guide: Configure Excel Services
See also

Published: December 18, 2012

Summary: Configure Excel Services in a test lab environment.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to set up Excel Services in SharePoint Server 2013 in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm and Test Lab Guide: Create a Business Intelligence Baseline Environment test lab guides.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Scenario overview

  • Before you begin

  • Configure a managed account

  • Configure an Excel Services service application

  • Configure trusted locations

  • Configure Excel client data access

Scenario overview

This test lab guide explains how to configure Excel Services. This includes:

  • Creating an Active Directory account to run the Excel Services application pool

  • Starting the Excel Calculation Services service

  • Creating a Excel Services service application

  • Configuring data access for Excel users.

Before you begin

Before starting, make sure you have completed the steps in Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

You must also complete all the steps in Test Lab Guide: Create a Business Intelligence Baseline Environment. This test lab guide includes configuring Excel Services trusted locations for libraries in the Business Intelligence Center.

Configure a managed account

The Excel Services service application requires an application pool to operate. The application pool requires an Active Directory account to run. Use the following procedure to create an Active Directory account for the application pool.

To create an Active Directory account

  1. Log on to DC1 as Corp\Administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand corp.contoso.com.

  4. Right-click ServiceAccounts, click, New, and then click User.

  5. In the Full name text box, type Excel Services Application Pool.

  6. In the User logon name text box, type ExcelAppPool.

  7. Click Next.

  8. Type and confirm a password for the account.

  9. Clear the User must change password at next logon checkbox.

  10. Select the Password never expires checkbox.

  11. Click Next.

  12. Click Finish.

Once the account has been created, the next step is to register it as a managed account in SharePoint Server 2013. Use the following procedure to register the managed account.

To register a managed account in SharePoint Server

  1. Log on to APP1 as Corp\User1.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the Central Administration home page, in the left navigation, click Security.

  4. On the Security page, in the General Security section, click Configure managed accounts.

  5. On the Managed Accounts page, click Register Managed Account.

  6. In the User name text box, type CORP\ExcelAppPool.

  7. In the Password text box, type the password for the CORP\ExcelAppPool account.

  8. Click OK.

In order for Excel Services to work, the application pool account must have access to the SharePoint Server 2013 content database. Use the following procedure to grant the needed access to the content database.

To grant content database access to the managed account

  1. On APP1, click Start, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell, and then click Run as Administrator.

  2. At the Windows PowerShell Command Prompt, type the following (press Enter after each line):

    Copy code
    $w = Get-SPWebApplication -identity http://WFE1
$w.GrantAccessToProcessIdentity("CORP\ExcelAppPool")

Once the CORP\ExcelAppPool account has been registered as a managed account and granted access to the content database, the next step is to start the Excel Calculation Services service and create an Excel Services service application.

Configure an Excel Services service application

Use the following procedure to start the Excel Calculation Services service on APP1.

To start the Excel Calculation Services service

  1. On the Central Administration home page, in the System Settings section, click Manage services on server.

  2. Above the Service list, in the Server drop-down list, ensure APP1 is selected.

  3. In the Service list, click Start next to Excel Calculation Services.

Once the service has been started, the next step is to create an Excel Services service application.

To create an Excel Services service application

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click New, and then click Excel Services Application.

  3. In the Name box, type Excel Services.

  4. Select the Create new application pool option and type ExcelServicesAppPool in the text box.

  5. Select the Configurable option, and, from the drop-down list, select CORP\ExcelAppPool.

  6. Click OK.

Excel Services has now been configured. The next step is to configure trusted locations.

Configure trusted locations

Excel Services will only load workbooks from trusted file locations. Use the following procedure to create a trusted file location in the Business Intelligence Center.

To configure a trusted file location

  1. On the Central Administration home page, under Application Management, click Manage services applications.

  2. In the list of service applications, click Excel Services.

  3. Click Trusted File Locations.

  4. On the Trusted File Locations page, click Add Trusted File Location.

  5. In the Location section:

    1. Type http://WFE1/sites/BICenter/Documents in the Address text box.

    2. Select the Children trusted check box.

  6. In the External Data section:

    1. Under Allow External Data, select the Trusted data connection libraries and embedded option.

    2. In the Automatic refresh and Manual refresh text boxes, type 0.

      Note:

      In a production environment, you would not typically set these values to 0. (Setting the cache values to 0 can cause additional resource utilization on the server.) However, in this series of labs, we are testing data refresh for data-connected workbooks, and setting the cache settings to 0 enables us to see data refresh results immediately.

  7. Click OK.

By creating a trusted file location, we can now publish data-connected workbooks with embedded data connections. However, for Excel Services to correctly render data-connected workbooks with external data connections, we must configure a trusted data connection library.

To configure a trusted data connection library

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. In the list of service applications, click Excel Services.

  3. Click Trusted Data Connection Libraries.

  4. On the Trusted Data Connection Libraries page, click Add Trusted Data Connection Library.

  5. In the Address box, typehttp://WFE1/sites/BICenter/Data%20Connections.

  6. Click OK.

When you have completed all of the previous procedures, Excel Services configuration is complete. The next step is to configure data access for the users who will create data-connected Excel workbooks.

Configure Excel client data access

In the following Excel Services labs, we will be configuring data refresh for Excel workbooks by using Secure Store. However, you should know that there are differences in the way that Excel Services and the Excel client application authenticate with data sources.

Although Excel Services can use Secure Store to authenticate with a data source when rendering a data-connected workbook, Excel does not use Secure Store for data authentication. Excel requires that workbook authors have direct database access in order to access external data from the workbook.

In this case, we will create an Active Directory group to contain our workbook authors, and then create a SQL Server logon for that Active Directory group.

To create an Active Directory group

  1. Log on to DC1 by using the CORP\administrator account.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.contoso.com node.

  4. Right-click Users, click New, and then click Group.

  5. In the Group Name box, type ExcelWorkbookAuthors, and then click OK.

Next, we need to add users to the group. In this case, we will add the user Susan Burk to the group because Susan Burk has Contribute access to the Business Intelligence Center where we will publish our data-connected workbooks in successive Excel Services labs.

Note:

Although we are only adding a single user to the group in this lab, in a production scenario you would add all the workbook authors to the group. (Using a group provides easier administration than adding individual logons for each user.) Depending on how your data is organized in your production environment, you may want to use multiple groups if different sets of users need access to different databases.

To populate the ExcelWorkbookAuthors Active Directory group

  1. In Active Directory Users and Computers, double-click the ExcelWorkbookAuthors group.

  2. On the Members tab, click Add.

  3. In the Enter object names to select box, type CORP\Susan.Burk, and then click OK.

  4. Verify that Susan Burk appears in the Members list, and then click OK.

Now that the Susan Burk account has been added to the ExcelWorkbookAuthors group, the next step is to create a SQL Server logon for that group.

To create a SQL Server logon

  1. Log on to SQL1 by using the CORP\USER1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. Connect to the Database Engine.

  4. Expand the Security node.

  5. Right-click Logins, and then click New Login.

  6. On the Login - New page, click Search.

  7. On the Select User or Group dialog box, click Object Types.

  8. On the Object Types dialog box, select the Groups check box, and then click OK.

  9. On the Select User or Group dialog box, in the Enter the object name to select box, type CORP\ExcelWorkbookAuthors, and then click OK.

  10. On the Login - New page, click OK.

When you have completed all of the previous procedures, Excel Services will be operational and ready to use. The next step is to configure security access to your data sources. The following labs cover how to configure data refresh using Secure Store:

  • Test Lab Guide: Configure the Excel Services unattended service account

  • Test Lab Guide: Configure Excel Services data refresh by using an embedded connection

  • Test Lab Guide: Configure Excel Services data refresh by using an external connection

See also

Configure Excel Services in SharePoint Server 2013


Test Lab Guide: Configure the Excel Services unattended service account
See also

Published: December 18, 2012

Summary: Configure data refresh in Excel Services by using the unattended service account.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to set up the Excel Services in SharePoint Server 2013 unattended service account in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Scenario overview

  • Before you begin

  • Create sample data

  • Configure a data access account

  • Configure Excel Services

  • Publish a workbook with an external data source

  • Test data refresh

Scenario overview

This test lab guide explains how to configure the unattended service account for Excel Services. This includes:

  • Configuring sample data and a data access account

  • Configuring the unattended service account in Excel Services Global Settings

In this lab, we will also create a sample PivotTable report in Excel and publish it to the Business Intelligence Center to confirm that data refresh is working.

Before you begin

This test lab guide assumes that you have completed all the steps in the following test lab guides:

  • Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

  • Test Lab Guide: Create a Business Intelligence Baseline Environment

  • Test Lab Guide: Configure Excel Services

  • Test Lab Guide: Configure Secure Store

  • Test Lab Guide Mini-Module: Installing Microsoft Office Professional Plus 2013 on CLIENT1 (en-US)

You must have completed all of the steps in the above-listed test lab guides before beginning the procedures in this test lab guide.

Create sample data

For the purposes of this lab, we will create a SQL Server database and table. The table contains some simple data that we can use in a data-connected workbook which we will publish to the SharePoint document library in the Business Intelligence Center.

Note:

If you have previously followed the steps in Test Lab Guide: Configure Excel Services data refresh by using an embedded connection or Test Lab Guide: Configure Excel Services data refresh by using an external connection, this database may already exist. In this case, there is no need to recreate the database.

Use the following procedure to create the SQL Server database and table.

To create a database and table with sample data

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. On the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [master]
GO
CREATE DATABASE CorporateAccounts;
GO
USE [CorporateAccounts]
GO
CREATE TABLE [dbo].[Accounts](
[Region] [varchar] (50) NULL,
[Sales] [money] NULL,
[OpEx] [money] NULL,
[AssetValue] [money] NULL
) ON [PRIMARY]
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('North', 23486.56, 16874.53, 64789.34);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('South', 19864.35, 11265.84, 55349.37);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('East', 31824.65, 22849.67, 87318.27);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('West', 27691.26, 17628.43, 84287.67);
GO

  6. On the toolbar, click Execute.

With the sample database and table created, the next step is to create an Active Directory account for use as the unattended service account.

Configure a data access account

The Excel Services unattended service account requires an Active Directory account for data access. Use the following procedure to create an Active Directory account for data access.

To create an Active Directory account for data access

  1. Log on to DC1 as CORP\Administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.contoso.com node.

  4. Right-click Users, click New, and then click User.

  5. In the Full name and User logon name boxes, type ExcelUnattended.

  6. Click Next.

  7. Type and confirm a password for the account.

  8. Clear the User must change password at next logon check box.

  9. Select the Password never expires check box.

  10. Click Next, and then click Finish.

Once the account has been created, the next step is to grant that account Read access to the required data. In a production scenario, you would grant access to whatever data source that you need to access from your Excel 2013 workbook. Use the following procedure to create a SQL Server logon and grant that logon db_datareader access to the CorporateAccounts database.

To create a SQL Server logon

  1. Log on to SQL1 as CORP\User1.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine as the Server type, type SQL1 in the Server name box, and then click Connect.

  4. In Object Explorer, expand Security.

  5. Right-click Logins, and then click New Login.

  6. In the Login name box, type CORP\ExcelUnattended.

  7. Under Select a page, click User Mapping.

  8. Select the Map check box for the CorporateAccounts database, and then, under Database role membership for: CorporateAccounts, select the db_datareader check box.

  9. Click OK.

The account that we will use as the unattended service account now has access to the CorporateAccounts database, but we must also grant access to the CORP\ExcelWorkbookAuthors group in order for users to have database access from Excel. Use the following procedure to grant database access to the CORP\ExcelWorkbookAuthors group.

Note:

If you created the database when you did a different test lab guide, the CORP\ExcelWorkbookAuthors group may already have database access.

To configure database access for Excel workbook authors

  1. In Management Studio, under Logins, double-click the CORP\ExcelWorkbookAuthors login.

  2. Under Select a page, click User Mapping.

  3. Select the Map check box for the CorporateAccounts database, and then, under Database role membership for: CorporateAccounts, select the db_datareader check box.

  4. Click OK.

With the account created and granted the appropriate data access, we can now configure Excel Services.

Configure Excel Services

The unattended service account configuration is part of the Excel Services Global Settings. Use the following procedure to configure the unattended service account in Excel Services.

To configure the Excel Services unattended service account

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click Excel Services.

  3. On the Manage the Excel Services page, click Global Settings.

  4. On the Excel Services Settings page, in the External Data section, select the Create a new Unattended Service Account option.

  5. In the User Name: (Domain\UserName) text box, type CORP\ExcelUnattended.

  6. Type and confirm the password for the CORP\ExcelUnattended account.

  7. Click OK.

With the Excel Services Global Settings configured, setup of the unattended service account is complete. In the next section, we create an Excel workbook with external data and publish it to the SharePoint document library in the Business Intelligence Center. We then test data refresh using the unattended service account.

Publish a workbook with an external data source

To test the configuration of the unattended service account, we must first create a workbook with an external data connection. Use the following procedure to create the workbook.

To create a workbook with an external data connection

  1. Log on to CLIENT1 by using the CORP\Susan.Burk account.

  2. Click Start, click All Programs, click Microsoft Office 2013, and then click Excel 2013.

  3. If you are prompted to choose a template, choose the Blank workbook template.

  4. On the Data tab, in the Get External Data group, click From Other Sources, and then click From SQL Server. This starts the Data Connection Wizard, which has three pages.

  5. In the Server name box, type SQL1.

  6. Under Log on credentials, click the Use Windows Authentication option, and then click Next to go to page 2 of the Data Connection Wizard.

  7. In the Select the database that contains the data you want section, select CorporateAccounts. In the table list section, select Accounts, and then click Next.

  8. On the Save Data Connection File and Finish page, click Finish.

    Note:

    If you are prompted to overwrite the connection file, click Yes.

  9. On the Import Data dialog box, select the PivotTable Report option, and then click OK.

  10. In the pane on the right side, in the Pivot Table Field List:

    1. Select the AssetValue check box.

    2. Select the OpEx check box.

    3. Select the Region check box.

    4. Select the Sales check box.

Leave the Excel workbook open for the next procedure.

We now have a data-connected workbook that contains a report. However, we must modify the Excel 2013 settings before we publish the workbook to the document library. By default, the Excel 2013 settings are configured to use Windows authentication, which is not the correct setting for using the unattended service account. Use the following procedure to modify the Excel 2013 authentication settings in the workbook that we just created.

To configure Excel Services authentication settings

  1. In the Excel workbook, on the Data tab, click Connections.

  2. On the Workbook Connections dialog box, click Properties.

  3. On the Connection Properties dialog box, on the Definition tab, click Authentication Settings.

  4. On the Excel Services Authentication Settings dialog box, select the None option, and then click OK.

  5. On the Connection Properties dialog box, click OK.

    Note:

    If you see a warning that the link to the external connection file will be removed, click Yes. (Although Excel requires you to save a connection file, that file is not required by Excel Services for authentication.)

  6. On the Workbook Connections dialog box, click Close.

Leave the Excel workbook open for the next procedure.

Now that we have set the Excel Services authentication settings, the next step is to publish the workbook to the document library in the Business Intelligence Center and confirm that data refresh is working correctly.

To publish a workbook to a SharePoint document library

  1. In the Excel workbook, click File, click Save, and then click Browse.

  2. On the Save As dialog box, in the URL box, type http://WFE1/sites/BICenter, and then press Enter.

    Note:

    It may take several moments for the file list to refresh.

  3. In the Document Libraries list, double-click Documents.

  4. In the File name box, type CorporateAccountsUnattended.xlsx.

  5. Click Save.

  6. When the save has completed, navigate to the document libaray in the Business Intelligence Center (http://wfe1/sites/BICenter/Documents) and click on the CorporateAccountsUnattended.xlsx file to render it in the browser using Excel Services.

Once the workbook has been loaded in a browser, the next step is to confirm that data refresh is working correctly.

Leave the browser that displays the CorporateAccountsUnattended.xlsx workbook open for the procedures in the next section.

Test data refresh

To confirm that data refresh works with the unattended service account, we will follow these steps:

  • Refresh the data currently displayed in the browser on CLIENT1

  • Change a value in the CorporateAccounts database

  • Refresh the data displayed in the browser on CLIENT1 again and confirm that the new information is displayed

First, we will refresh the existing data. Use the following procedure to refresh the data in the browser.

To refresh a data-connected workbook by using Excel Services

  1. In the browser, on the Data drop-down list, click Refresh All Connections.

    Note:

    If a warning message appears, click OK.

If the unattended service account is configured correctly, the data will refresh without error, although we will not see any changes in data values at this point. The next step is to change a value in the CorporateAccounts database and confirm that the changes appear in the workbook.

To update data in the CorporateAccounts database

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. In the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [CorporateAccounts]
GO
UPDATE dbo.Accounts set dbo.Accounts.AssetValue = 65000.00 where dbo.Accounts.Region = 'North'
GO

  6. In the toolbar, click Execute.

Return to the CLIENT1 virtual machine, where CorporateAccountsUnattendeds.xlsx is displayed in the browser.

Note the currently displayed value for AssetValue for the North region in the spreadsheet. We updated this row to a value of $65,000.00 in the Accounts table, so the new value should appear when we refresh the workbook. Use the following procedure to refresh the workbook.

Note:

If you see a warning that the page has expired, click OK and restart the procedure.

To refresh a data-connected workbook by using Excel Services

  1. In the browser, on the Data drop-down list, click Refresh All Connections.

    Note:

    If a warning message appears, click OK.

The new value of 65000.00 should now appear for AssetValue for the North region, confirming that data refresh through the unattended service account is working.

Note:

The Excel Services cache settings affect how quickly the new results appear when you refresh the workbook. In the Test Lab Guide: Configure Excel Services lab, we set the cache settings to zero (0), allowing immediate refresh. In a production environment, refresh will likely take longer depending on how you configure the cache.

See also

Configure Excel Services data refresh by using the unattended service account in SharePoint Server 2013


Test Lab Guide: Configure Excel Services data refresh by using an embedded connection
See also

Published: December 18, 2012

Summary: Configure data refresh in Excel Services by using an embedded data connection.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to set up data refresh using Excel Services in SharePoint Server 2013 in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Scenario overview

  • Before you begin

  • Create sample data

  • Configure a data access account

  • Configure Secure Store

  • Create a PivotTable report by using a SQL Server table

  • Test data refresh

Scenario overview

This test lab guide explains how to configure data refresh in Excel Services using an embedded data connection. This includes:

  • Configuring sample data and a data access account

  • Configuring a Secure Store target application to contain the data access credentials

In this lab, we will also create a sample PivotTable report in Excel and publish it to the Business Intelligence Center to confirm that data refresh is working.

Before you begin

This test lab guide assumes that you have completed all the steps in the following test lab guides:

  • Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

  • Test Lab Guide: Create a Business Intelligence Baseline Environment

  • Test Lab Guide: Configure Excel Services

  • Test Lab Guide: Configure Secure Store

  • Test Lab Guide Mini-Module: Installing Microsoft Office Professional Plus 2013 on CLIENT1 (en-US)

You must have completed all of the steps in the above-listed test lab guides before beginning the procedures in this test lab guide.

Create sample data

For the purposes of this lab, we will create a SQL Server database and table. The table contains some simple data that we can use in a data-connected workbook which we will publish to the SharePoint document library in the Business Intelligence Center.

Note:

If you have previously followed the steps in Test Lab Guide: Configure the Excel Services unattended service account or Test Lab Guide: Configure Excel Services data refresh by using an external connection, this database may already exist. In this case, there is no need to recreate the database.

Use the following procedure to create the SQL Server database and table.

To create a database and table with sample data

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. On the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [master]
GO
CREATE DATABASE CorporateAccounts;
GO
USE [CorporateAccounts]
GO
CREATE TABLE [dbo].[Accounts](
[Region] [varchar] (50) NULL,
[Sales] [money] NULL,
[OpEx] [money] NULL,
[AssetValue] [money] NULL
) ON [PRIMARY]
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('North', 23486.56, 16874.53, 64789.34);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('South', 19864.35, 11265.84, 55349.37);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('East', 31824.65, 22849.67, 87318.27);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('West', 27691.26, 17628.43, 84287.67);
GO

  6. On the toolbar, click Execute.

With the sample database and table created, the next step is to create an Active Directory account for use as the data access account.

Configure a data access account

To configure Excel Services to use embedded data connections, we begin by configuring a data access account. We then grant this account Read access to data that is stored in SQL Server.

To create an Active Directory account for data access

  1. Log into DC1 using the CORP\administrator account.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.contoso.com node.

  4. Right-click Users, click New, and then click User.

  5. In the Full name and User logon name text boxes, type ExcelDataEmbed, and then click Next.

  6. Type and confirm a password for the account.

  7. Clear the User must change password at next logon check box.

  8. Select the Password never expires check box.

  9. Click Next, and then click Finish.

Now that the ExcelDataEmbed account is created, the next step is to grant that account read access to the required data. Use the following procedure to create a SQL Server logon and grant Read access to the database.

To create a SQL Server logon

  1. Log in to SQL1 using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine as the Server type, type SQL1 in the Server name text box, and then click Connect.

  4. In Object Explorer, expand Security.

  5. Right-click Logins, and then click New Login.

    The Login - New dialog box opens.

  6. Next to the Login name text box, type CORP\ExcelDataEmbed.

  7. In the Login - New dialog box, in the Select a page pane, click User Mapping.

    A list of databases appears.

  8. Select the Map check box for the CorporateAccounts database, and then in the Database role membership for: CorporateAccounts section, select the db_datareader check box.

  9. Click OK to close the Login - New dialog box. Notice that the CORP\ExcelDataEmbed data access account is now displayed in the Logins list.

The data access account now has access to the CorporateAccounts database, but we must also grant access to the CORP\ExcelWorkbookAuthors group in order for users to have database access from Excel. Use the following procedure to grant database access to the CORP\ExcelWorkbookAuthors group.

Note:

If you created the database when you did a different test lab guide, the CORP\ExcelWorkbookAuthors group may already have database access.

To configure database access for Excel workbook authors

  1. In Management Studio, under Logins, double-click the CORP\ExcelWorkbookAuthors login.

  2. Under Select a page, click User Mapping.

  3. Select the Map check box for the CorporateAccounts database, and then, under Database role membership for: CorporateAccounts, select the db_datareader check box.

  4. Click OK.

Now that we have created a data access account, the next step is to configure Secure Store.

Configure Secure Store

To configure Secure Store, we begin by creating an Active Directory group. This group will be used to provide data access to Excel users who are using embedded data connections.

To create an Active Directory group for user data access

  1. Log into DC1 using the CORP\Administrator account.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.contoso.com node.

  4. Right-click Users, click New, and then click Group.

    The New Object - Group dialog box opens.

  5. In the Group name box, type ExcelDataEmbedGroup, and then click OK.

    Notice that ExcelDataEmbedGroup now appears in the list of groups and users.

  6. Double-click ExcelDataEmbedGroup to open it for editing.

  7. Click the Members tab, and then click Add.

    The Select Users, Contacts, Computers, Services Accounts, or Groups dialog box opens.

  8. In the Enter the object names to select box, type CORP\susan.burk; CORP\john.woods, and then click Check Names.

    The user accounts are verified and then appear as hyperlinks.

  9. Click OK to close the Select Users, Contacts, Computers, Services Accounts, or Groups dialog box.

  10. Click OK to close the ExcelDataEmbedGroup Properties dialog box.

Now that we have created our Active Directory accounts, the next step is to configure Secure Store. We begin by creating a target application.

To create a Secure Store target application

  1. Log into APP1 using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the Central Administration home page, under Application Management, click Manage service applications.

  4. Click the Secure Store service application.

  5. On the ribbon, click New.

  6. In the Target Application ID text box, type ExcelServicesEmbeddedData.

  7. In the Display Name text box, type Excel Services Embedded Data.

  8. In the Contact E-mail text box, type User1@contoso.com.

    Note:

    Although e-mail notifications are not configured in this environment, you must specify an email address in the Contact E-mail box.

  9. In the Target Application Type drop-down list, select Group, and then click Next.

  10. Keep the default credential fields, and then click Next.

  11. On the Specify the membership settings page, in the Target Application Administrators box, type CORP\User1.

  12. In the Members box, type CORP\ExcelDataEmbedGroup, and then click OK. Do not leave the page yet.

  13. Position the pointer on ExcelServicesEmbeddedData, click the down arrow that appears, and then click Set Credentials.

    The Set Credentials for Secure Store Target Application (Group) page opens.

  14. In the Windows User Name box, type CORP\ExcelDataEmbed.

  15. Type and confirm the password for the CORP\ExcelDataEmbed account, and then click OK.

Now that we have configured the target application, the next step is to create and publish an Excel workbook that uses an embedded connection. We will then use this workbook to verify that data updates correctly in Excel Services.

Create a PivotTable report by using a SQL Server table

In this section, we describe how to create a PivotTable report that uses data that is stored in SQL Server and publish the workbook to SharePoint Server. We will then refresh the data in the workbook that uses the embedded connection.

For this report, we use the Accounts table in the CorporateAccounts database that we created.

To create a PivotTable report by using external SQL Server data

  1. Log into CLIENT1 using the CORP\Susan.Burk account.

  2. In Excel 2013, on the Data tab, in the Get External Data group, click From Other Sources, and then click From SQL Server. The Data Connection Wizard opens.

  3. In the Server name box, type SQL1, and then click Next.

  4. Use the Select the database that contains the data that you want to select CorporateAccounts.

  5. Select the Connect to a specific table check box, and then select Accounts. Then, click Next.

  6. In the Description box, type Corporate Accounts, and then click Finish.

    The Import Data dialog box opens.

    Note:

    If you are prompted to replace the ODC file that is located on your local computer, click Yes.

  7. In the Select how you want to view this data in your workbook section, click PivotTable Report, and then click OK.

    An empty PivotTable report opens.

  8. In the pane on the right side, in the Pivot Table Field List:

    1. Select the AssetValue check box.

    2. Select the OpEx check box.

    3. Select the Region check box.

    4. Select the Sales check box.

  9. Do not close the workbook. Keep it open for the next procedure.

At this point, we have created a PivotTable report in Excel. However, we have not yet embedded the external data connection information in the workbook. The next step is to configure and embed that connection.

To embed external data connection information in an Excel workbook

  1. In Excel 2013, on the Data tab, in the Connections group, click Connections.

    The Workbook Connections dialog box opens.

  2. Select the SQL1 CorporateAccounts Accounts connection, and then click Properties.

    The Connection Properties dialog box opens.

  3. Select the Definition tab.

  4. In the Excel Services section, click Authentication Settings.

    The Excel Services Authentication Settings dialog box opens.

  5. Select the Use a stored account option, and then, in the Application ID box, type ExcelServicesEmbeddedData.

  6. Click OK to close the Excel Services Authentication Settings dialog box, and then click OK to close the Connection Properties dialog box.

  7. If a warning appears that states that the link to the external odc file will be removed, click Yes.

  8. In the Workbook Connections dialog box, click Close. Do not close the workbook yet.

At this point, we have created a workbook that contains an embedded data connection. The next step is to publish the workbook to SharePoint Server.

To publish a workbook to a SharePoint document library

  1. In the Excel workbook, click File, click Save, and then click Browse.

  2. On the Save As dialog box, in the URL box, type http://WFE1/sites/BICenter, and then press Enter.

    Note:

    It may take several moments for the file list to refresh.

  3. In the Document Libraries list, double-click Documents.

  4. In the File name box, type CorporateAccountsEmbedded.xlsx.

  5. Click Save.

  6. When the save has completed, navigate to the document libaray in the Business Intelligence Center (http://wfe1/sites/BICenter/Documents) and click on the CorporateAccountsEmbedded.xlsx file to render it in the browser using Excel Services.

At this point, we have created and published a workbook that uses an embedded data connection. The next and final step is to verify that the data updates correctly.

Test data refresh

To confirm that data refresh works with the embedded connection account, we will follow these steps:

  • Refresh the data currently displayed in the browser on CLIENT1

  • Change a value in the CorporateAccounts database

  • Refresh the data displayed in the browser on CLIENT1 again and confirm that the new information is displayed

First, we will refresh the existing data. Use the following procedure to refresh the data in the browser.

To refresh a data-connected workbook by using Excel Services

  1. In the browser, on the Data drop-down list, click Refresh All Connections.

    Note:

    If a warning message appears, click OK.

If the embedded connection is configured correctly, the data will refresh without error, although we will not see any changes in data values at this point. The next step is to change a value in the CorporateAccounts database and confirm that the changes appear in the workbook.

To update data in the CorporateAccounts database

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. In the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [CorporateAccounts]
GO
UPDATE dbo.Accounts set dbo.Accounts.OpEx = 18000.00 where dbo.Accounts.Region = 'North'
GO

  6. In the toolbar, click Execute.

Return to the CLIENT1 virtual machine, where CorporateAccountsEmbedded.xlsx is displayed in the browser.

Note the currently displayed value for OpEx for the North region in the spreadsheet. We updated this row to a value of $18,000.00 in the Accounts table, so the new value should appear when we refresh the workbook. Use the following procedure to refresh the workbook.

Note:

If you see a warning that the page has expired, click OK and restart the procedure.

To refresh a data-connected workbook by using Excel Services

  1. In the browser, on the Data drop-down list, click Refresh All Connections.

    Note:

    If a warning message appears, click OK.

The new value of 18000.00 should now appear for OpEx for the North region, confirming that data refresh through the embedded connection and Secure Store is working.

Note:

The Excel Services cache settings affect how quickly the new results appear when you refresh the workbook. In the Test Lab Guide: Configure Excel Services lab, we set the cache settings to zero (0), allowing immediate refresh. In a production environment, refresh will likely take longer depending on how you configure the cache.

See also

Configure Excel Services data refresh by using embedded data connections in SharePoint Server 2013


Test Lab Guide: Configure Excel Services data refresh by using an external connection
See also

Published: December 18, 2012

Summary: Configure data refresh in Excel Services by using an external data connection.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to set up data refresh using Excel Services in SharePoint Server 2013 in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Scenario overview

  • Before you begin

  • Create sample data

  • Configure a data access account

  • Configure Secure Store

  • Create and publish an ODC file

  • Test data refresh

Scenario overview

This test lab guide explains how to configure data refresh in Excel Services using an external data connection. This includes:

  • Configuring sample data and a data access account

  • Configuring a Secure Store target application to contain the data access credentials

  • Creating an Office Data Connection (ODC) file that contains the connection information.

In this lab, we will also create a sample PivotTable report in Excel and publish it to the Business Intelligence Center to confirm that data refresh is working.

Before you begin

This test lab guide assumes that you have completed all the steps in the following test lab guides:

  • Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

  • Test Lab Guide: Create a Business Intelligence Baseline Environment

  • Test Lab Guide: Configure Excel Services

  • Test Lab Guide: Configure Secure Store

  • Test Lab Guide Mini-Module: Installing Microsoft Office Professional Plus 2013 on CLIENT1 (en-US)

Create sample data

When you configure the data access account, you have to grant the account access to the data source to which your Excel workbook will be connected. For the purposes of this lab, we will create a SQL Server table. The table contains some simple data that we can use in a data-connected workbook which we will publish to the SharePoint document library in the Business Intelligence Center.

Note:

If you have previously followed the steps in Test Lab Guide: Configure Excel Services data refresh by using an embedded connection or Test Lab Guide: Configure the Excel Services unattended service account, this database may already exist. In this case, there is no need to recreate the database.

Use the following procedure to create the SQL Server table.

To create a table with sample data

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. On the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [master]
GO
CREATE DATABASE CorporateAccounts;
GO
USE [CorporateAccounts]
GO
CREATE TABLE [dbo].[Accounts](
[Region] [varchar] (50) NULL,
[Sales] [money] NULL,
[OpEx] [money] NULL,
[AssetValue] [money] NULL
) ON [PRIMARY]
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('North', 23486.56, 16874.53, 64789.34);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('South', 19864.35, 11265.84, 55349.37);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('East', 31824.65, 22849.67, 87318.27);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('West', 27691.26, 17628.43, 84287.67);
GO

  6. On the toolbar, click Execute.

With the sample database and table created, the next step is to create an Active Directory account for use as the data access account.

Configure a data access account

When you configure data access through Secure Store, you must grant the account access to the data source to which your Excel Services workbook will be connected.

To create an Active Directory account for data access

  1. Log on to DC1 as CORP\Administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.contoso.com node.

  4. Right-click Users, click New, and then click User.

  5. In the Full name and User logon name boxes, type ExcelODCAccess.

  6. Click Next.

  7. Type and confirm a password for the account.

  8. Clear the User must change password at next logon check box.

  9. Select the Password never expires check box.

  10. Click Next, and then click Finish.

Once the account is created, the next step is to grant that account Read access to the required data. In a production scenario, you would grant access to whatever data source that you have to access from your Excel Services workbook. In this lab we will grant access to the CorporateAccounts database. Use the following procedure to create a SQL Server logon and grant that logon db_datareader access to the database.

To create a SQL Server logon

  1. Log on to SQL1 as CORP\User1.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine as the Server type, type SQL1 in the Server name box, and then click Connect.

  4. In Object Explorer, expand Security.

  5. Right-click Logins, and then click New Login.

  6. In the Login name box, type CORP\ExcelODCAccess.

  7. Under Select a page, click User Mapping.

  8. Select the Map check box for the CorporateAccounts database, and then under Database role membership for: CorporateAccounts, select the db_datareader check box.

  9. Click OK.

Configure Secure Store

Earlier in this lab series, we configured Secure Store in the Test Lab Guide: Configure Secure Store article. Now we must create a target application for Excel Services with a series of procedures. These procedures explain how to create an Active Directory group, how to create the target application in Secure Store, and finally how to assign credentials to this target application.

In the Secure Store target application, we will map a specific group of users to the CORP\ExcelODCAccess account that we created in the previous section. Although these users will never have direct access to this account, Excel Services will use this account on their behalf to refresh data-connected workbooks.

To avoid the complexity of administering individual users, we will create an Active Directory group to contain them.

To create an Active Directory group for user data access

  1. Log on to DC1 as CORP\Administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.contoso.com node.

  4. Right-click Users, click New, and then click Group.

  5. In the Group name box, type ExcelODCAccessGroup.

  6. Click OK.

After the group account is created in Active Directory, we must now populate the group with user accounts to which we want to give data access through Secure Store. The following procedure explains how to do this.

To populate the data access group

  1. In Active Directory Users and Computers, in the users list, double-click the ExcelODCAccessGroup group.

  2. On the Members tab, click Add.

  3. On the Select Users dialog box, type CORP\susan.burk; CORP\john.woods, and the click OK.

  4. The Members tab should now show Susan Burk and John Woods as members of the group.

  5. Click OK.

Now that you have created Active Directory accounts for data access, you can create a target application for Excel Services to use with an Office Data Connection (ODC). Use the following procedure to create and configure the target application.

To create a target application

  1. Log in to APP1 using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the SharePoint Central Administration Web site home page, in the Application Management section, click Manage service applications.

  4. Click the Secure Store application.

  5. On the ribbon, click New.

  6. In the Target Application ID box, type ExcelServicesODC.

  7. In the Display Name box, type ExcelServicesODC.

  8. In the Contact E-mail box, type User1@contoso.com.

    Note:

    Although e-mail notifications are not configured in this environment, Contact E-mail is a required field.

  9. In the Target Application Type drop-down list, select Group.

  10. Click Next.

  11. Leave the default credential fields, and then click Next.

  12. On the Specify the membership settings page:

    • In the Target Application Administrators box, type CORP\User1.

    • In the Members box, type CORP\ExcelODCAccessGroup.

    • Click OK.

Once the target application has been created, the next step is to associate the data access account that we created (CORP\ExcelODCAccess) with the target application. Use the following procedure to set the credentials for the target application.

To set the credentials for the target application

  1. On the Secure Store Service Application page, in the Target Application ID column, point to ExcelServicesODC, click the arrow that appears, and then click Set Credentials.

  2. In the Windows User Name box, type CORP\ExcelODCAccess.

  3. Type and confirm the password for the CORP\ExcelODCAccess account.

  4. Click OK.

Create and publish an ODC file

Now that Secure Store has been configured, the next step is to create the ODC file and publish it to a trusted data connection library. Use the following procedure to create an ODC file that has a connection to the CorporateAccounts database.

To create and publish an ODC file

  1. Log on to the CLIENT1 virtual machine by using the CORP\Susan.Burk account.

  2. Click Start, click All Programs, click Office, and then click Excel 2013.

  3. If a template selection page is displayed, choose Blank workbook.

  4. On the Data tab, click From Other Sources, and then click From SQL Server.

  5. On the Connect to Database Server page of the Data Connection Wizard, type SQL1 in the Server name box, and then click Next.

  6. On the Select Database and Table page, select CorporateAccounts from the drop-down list.

  7. In the list of tables, select Accounts, and then click Next.

  8. Click Finish.

    Note:

    If you are prompted to overwrite the ODC file on the local disk, click Yes.

  9. On the Import Data dialog box, select the Only Create Connection option, and then click OK.

  10. On the Data tab, click Connections.

  11. On the Workbook Connections dialog box, click Properties.

  12. On the Connection Properties dialog box, on the Definition tab, click Authentication Settings.

  13. On the Excel Services Authentication Settings dialog box, select the Use a stored account option, type ExcelServicesODC in the Application ID box, and then click OK.

  14. On the Connection Properties dialog box, click Export Connection File.

  15. On the File Save dialog box, in the URL box, type http://WFE1/sites/BICenter, and then press Enter.

    Note:

    It may take several moments for the list to refresh with content from the BI Center.

  16. In the list of All Site Content, double-click Data Connections.

  17. In the File name box, type AccountsTable, and then click Save.

  18. On the Data Connections dialog box, select Office Data Connection File from the Content Type drop-down list, and then click OK.

  19. When the export has completed, on the Connection Properties dialog box, click OK, and then, on the Workbook Connections dialog box, click Close.

  20. Exit Excel.

    Note:

    You do not have to save the workbook.

Remain logged on to CLIENT1 as Susan Burk for the next procedure.

We have now successfully published an ODC file that contains a data connection to the Accounts table of the CorporateAccounts database and uses the ExcelServicesODC target application in Secure Store for authentication.

Test data refresh

In this section we will test what we previously configured by publishing a data-connected Excel workbook that uses the AccountsTable.odc file that we published earlier for data connectivity. Use the following procedure to create and publish a pivot table.

To create and publish a pivot table

  1. On CLIENT1, click Start, click All Programs, click Office, and then click Excel 2013.

  2. If a template selection page is displayed, choose Blank workbook.

  3. On the Data tab, click Existing Connections.

  4. On the Existing Connections dialog box, click Browse for More.

  5. On the Select Data Source dialog box, in the URL box, type http://WFE1/sites/BICenter, and then press Enter.

    Note:

    It may take several moments for the list to refresh with content from the BI Center.

  6. In the list of All Site Content, double-click Data Connections.

  7. On the list of Data Connections, select AccountsTable.odc in the Name column, and then click Open.

  8. On the Import Data dialog box, select the PivotTable Report option, and then click OK.

  9. In the pane on the right side, in the Pivot Table Field List:

    1. Select the AssetValue check box.

    2. Select the OpEx check box.

    3. Select the Region check box.

    4. Select the Sales check box.

  10. Click File, click Save, and then click Browse.

  11. On the Save As dialog box, in the URL box, type http://WFE1/sites/BICenter, and then press Enter.

    Note:

    It may take several moments for the file list to refresh.

  12. In the Document Libraries list, double-click Documents.

  13. In the File name box, type CorporateAccountsExternal.xlsx.

  14. Click Save.

  15. When the save has completed, navigate to the document libaray in the Business Intelligence Center (http://wfe1/sites/BICenter/Documents) and click on the CorporateAccountsExternal.xlsx file to render it in the browser using Excel Services.

Leave the browser open for the following procedures.

To confirm that data refresh is works by using the ODC file and Secure Store, we will follow these steps:

  • Refresh the data currently displayed in the browser on CLIENT1

  • Change a value in the CorporateAccounts database

  • Refresh the data displayed in the browser on CLIENT1 again and confirm that the new information is displayed

First, we will refresh the existing data. Use the following procedure to refresh the data in the browser.

To refresh a data-connected workbook by using Excel Services

  1. In the browser, on the Data drop-down list, click Refresh All Connections.

    Note:

    If a warning message appears, click OK.

If everything is configured correctly, the data will refresh without error, although we will not see any changes in values at this point. The next step is to change a value in the CorporateAccounts database and confirm that the changes appear in the workbook.

To update data in the CorporateAccounts database

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. In the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [CorporateAccounts]
GO
UPDATE dbo.Accounts set dbo.Accounts.Sales = 25000.00 where dbo.Accounts.Region = 'North'
GO

  6. In the toolbar, click Execute.

    Note:

    After the query runs, you should see (47 row(s) affected) in the Messages window.

Return to the CLIENT1 virtual machine, where CorporateAccountsExternal.xlsx is displayed in the browser.

Note the currently displayed number for Sales in the North region is 23486.56. We changed that to 25000 in the Accounts table, so the new value should appear when we refresh the workbook. Use the following procedure to refresh the workbook.

Note:

If you see a warning that the page has expired, click OK and restart the procedure.

To refresh a data-connected workbook by using Excel Services

  1. In the browser, on the Data drop-down list, click Refresh All Connections.

    Note:

    If a warning message appears, click OK.

Notice that the Sales amount for the North region is now $25,000, confirming that data refresh through the ODC file and Secure Store is working.

Note:

The Excel Services cache settings affect how quickly the new results appear when you refresh the workbook. In the Test Lab Guide: Configure Excel Services lab, we set the cache settings to zero (0), allowing immediate refresh. In a production environment, refresh will likely take longer depending on how you configure the cache.

See also

Configure Excel Services data refresh by using external data connections in SharePoint Server 2013


Test Lab Guide: Configure Visio Services
See also

Published: December 18, 2012

Summary: Configure Visio Services in a test lab environment.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to set up Visio Services in SharePoint Server 2013 in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Scenario overview

  • Before you begin

  • Configure a managed account

  • Configure a Visio Services service application

  • Configure Visio Services Global Settings

  • Configure Visio client data access

Scenario overview

This test lab guide explains how to configure Visio Services. This includes:

  • Creating an Active Directory account to run the Visio Services application pool

  • Starting the Visio Graphics Service

  • Creating a Visio Services service application

  • Configuring data access for Visio users

Before you begin

Before starting, make sure you have completed the steps in Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

You must also complete the steps in Test Lab Guide: Create a Business Intelligence Baseline Environment, as the Visio configuration steps require the user accounts created in that test lab guide.

Configure a managed account

The Visio Services service application requires an application pool to operate. The application pool requires an Active Directory account to run. Use the following procedure to create an Active Directory account for the application pool.

To create an Active Directory account

  1. Log on to DC1 as Corp\Administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand corp.contoso.com.

  4. Right-click ServiceAccounts, click, New, and then click User.

  5. In the Full name text box, type Visio Services Application Pool.

  6. In the User logon name text box, type VisioAppPool.

  7. Click Next.

  8. Type and confirm a password for the account.

  9. Clear the User must change password at next logon checkbox.

  10. Select the Password never expires checkbox.

  11. Click Next.

  12. Click Finish.

Once the account has been created, the next step is to register it as a managed account in SharePoint Server 2013. Use the following procedure to register the managed account.

To register a managed account in SharePoint Server

  1. Log on to APP1 as Corp\User1.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the Central Administration home page, in the left navigation, click Security.

  4. On the Security page, in the General Security section, click Configure managed accounts.

  5. On the Managed Accounts page, click Register Managed Account.

  6. In the User name text box, type CORP\VisioAppPool.

  7. In the Password text box, type the password for the CORP\VisioAppPool account.

  8. Click OK.

In order for Visio Services to work, the application pool account must have access to the SharePoint Server 2013 content database. Use the following procedure to grant the needed access to the content database.

To grant content database access to the managed account

  1. On APP1, click Start, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell, and then click Run as Administrator.

  2. At the Windows PowerShell Command Prompt, type the following (press Enter after each line):

    Copy code
    $w = Get-SPWebApplication -identity http://WFE1
$w.GrantAccessToProcessIdentity("CORP\VisioAppPool")

Once the CORP\VisioAppPool account has been registered as a managed account and granted access to the content database, the next step is to start the Visio Graphics Service and create an Visio Services service application.

Configure a Visio Services service application

Use the following procedure to start the Visio Graphics Service on APP1.

To start the Visio Graphics Service

  1. On the Central Administration home page, in the System Settings section, click Manage services on server.

  2. Above the Service list, in the Server drop-down list, ensure APP1 is selected.

  3. In the Service list, click Start next to Visio Graphics Service.

Once the service has been started, the next step is to create an Visio Services service application.

To create a Visio Services application

  1. On the Central Administration home page, in the Application Management section, click Manage service applications.

  2. On the Manage Service Applications page, click New, and then click Visio Graphics Service.

  3. In the Name box, type Visio Services.

  4. Select the Create new application pool option and type VisioServicesAppPool in the text box.

  5. Select the Configurable option, and, from the drop-down list, select CORP\VisioAppPool.

  6. Click OK.

Visio Services has now been configured. The next step is to configure the Visio Services global cache settings.

Configure Visio Services Global Settings

To efficiently demonstrate data refresh in the following Visio Services labs, we must change the default cache settings to allow for immediate data refresh.

To configure the Visio Services minimum cache age

  1. On the Central Administration home page, under Application Management, click Manage service applications.

  2. In the list of service applications, click the Visio Services service applications.

  3. Click Global Settings.

  4. In the Minimum Cache Age text box, type 0.

  5. Click OK.

In a production environment, setting the minimum cache age to zero (0) could put unnecessary strain on the server. We recommend that you leave the cache settings at their default values for best performance in a production environment. However, for this series of labs we want to be able to show immediate data refresh to validate that we have correctly configured data connectivity.

Once you have finished configuring the cache settings in Visio Services Global Settings, the next step is to configure data access for diagram authors working in Visio Professional 2013.

Configure Visio client data access

In the following Visio Services labs, we will be configuring data refresh for Visio diagrams by using Secure Store. However, you should know that there are differences in the way that Visio Services and the Visio client application authenticate with data sources.

Although Visio Services can use Secure Store to authenticate with a data source when rendering a data-connected diagram, Visio does not use Secure Store for data authentication. Visio requires that diagram authors have direct database access in order to access external data from the diagram.

In this case, we will create an Active Directory group to contain our diagram authors, and then create a SQL Server logon for that Active Directory group.

To create an Active Directory group

  1. Log on to DC1 by using the CORP\administrator account.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.contoso.com node.

  4. Right-click Users, click New, and then click Group.

  5. In the Group Name box, type VisioDiagramAuthors, and then click OK.

Next, we need to add users to the group. In this case, we will add the user Susan Burk to the group because Susan Burk has Contribute access to the Business Intelligence Center where we will publish our data-connected diagrams in successive Visio Services labs.

Note:

Although we are only adding a single user to the group in this lab, in a production scenario you would add all the diagram authors to the group. (Using a group provides easier administration than adding individual logons for each user.) Depending on how your data is organized in your production environment, you may want to use multiple groups if different sets of users need access to different databases.

To populate the VisioDiagramAuthors Active Directory group

  1. In Active Directory Users and Computers, double-click the VisioDiagramAuthors group.

  2. On the Members tab, click Add.

  3. In the Enter object names to select box, type CORP\Susan.Burk, and then click OK.

  4. Verify that Susan Burk appears in the Members list, and then click OK.

Now that the Susan Burk account has been added to the VisioDiagramAuthors group, the next step is to create a SQL Server logon for that group.

To create a SQL Server logon

  1. Log on to SQL1 by using the CORP\USER1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. Connect to the Database Engine.

  4. Expand the Security node.

  5. Right-click Logins, and then click New Login.

  6. On the Login - New page, click Search.

  7. On the Select User or Group dialog box, click Object Types.

  8. On the Object Types dialog box, select the Groups check box, and then click OK.

  9. On the Select User or Group dialog box, in the Enter the object name to select box, type CORP\VisioDiagramAuthors, and then click OK.

  10. On the Login - New page, click OK.

When you have completed all of the previous procedures, Visio Services will be operational and ready to use.

The following labs cover how to configure data refresh in Visio Services using Secure Store:

  • Test Lab Guide: Configure the Visio Services unattended service account

  • Test Lab Guide: Configure Visio Services data refresh using an external connection

See also

Create a Visio Graphics Service service application in SharePoint Server 2013


Test Lab Guide: Configure the Visio Services unattended service account
See also

Published: December 18, 2012

Summary: Configure the Visio Services unattended service account in a test lab environment.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to set up Visio Services in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Scenario overview

  • Before you begin

  • Create sample data

  • Configure a data access account

  • Configure Secure Store

  • Configure Visio Services

  • Grant database access to the diagram author

  • Publish a data-connected diagram

  • Test data refresh

Scenario overview

This test lab guide explains how to configure the unattended service account for Visio Services. This includes:

  • Configure a data access account

  • Configure a Secure Store target application

  • Configure the unattended service account in Visio Services Global Settings

In this lab, we will also create a sample diagram in Visio and publish it to the Business Intelligence Center to confirm that data refresh is working.

Before you begin

This test lab guide assumes that you have completed all the steps in the following test lab guides:

  • Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

  • Test Lab Guide: Create a Business Intelligence Baseline Environment

  • Test Lab Guide: Configure Visio Services

  • Test Lab Guide: Configure Secure Store

  • Test Lab Guide Mini-Module: Installing Microsoft Office Professional Plus 2013 on CLIENT1 (en-US)

You must have completed all of the steps in the above-listed test lab guides before beginning the procedures in this test lab guide.

You must also install Visio Professional 2013 on CLIENT1 if you have not already done so. You can download a trial version of Visio Professional 2013 from the TechNet Evaluation Center.

Create sample data

When you configure the unattended service account, you have to grant the account access to the data source to which your Visio diagram will be connected. For the purposes of this lab, we will create a SQL Server table. The table contains some simple data that we can use in a data-connected diagram which we will publish to the SharePoint document library in the Business Intelligence Center.

Use the following procedure to create the SQL Server table.

To create a table with sample data

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. On the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [master]
GO
CREATE DATABASE CorporateDirectory;
GO
USE [CorporateDirectory]
GO
CREATE TABLE [dbo].[Office](
[Name] [varchar] (50) NULL,
[Office] [varchar] (50) NULL
) ON [PRIMARY]
GO
INSERT INTO Office ([Name], [Office])
VALUES ('John Woods', '1501');
GO
INSERT INTO Office ([Name], [Office])
VALUES ('Susan Burk', '1502');
GO
INSERT INTO Office ([Name], [Office])
VALUES ('Cindy White', '1503');
GO
INSERT INTO Office ([Name], [Office])
VALUES ('David Hamilton', '1504');
GO

  6. On the toolbar, click Execute.

With the sample table created, the next step is to create an Active Directory account for use as the unattended service account.

Configure a data access account

The unattended service account requires an Active Directory account for data access. Use the following procedure to create the account.

To create an Active Directory account for data access

  1. Log on to DC1 as CORP\Administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the contoso.local node.

  4. Right-click Users, click New, and then click User.

  5. In the Full name and User logon name text boxes, type VisioUnattended.

  6. Click Next.

  7. Type and confirm a password for the account.

  8. Clear the User must change password at next logon check box.

  9. Select the Password never expires check box.

  10. Click Next, and then click Finish.

Once the account has been created, the next step is to grant that account read access to the required data. In a production scenario, you would grant access to whatever data source you need to access from your Visio diagram. In this lab we will grant access to the sample SQL Server database that we created earlier. Use the following procedure to create a SQL Server logon and grant that logon data reader access to the CorporateDirectory database.

To create a SQL Server logon

  1. Log on to SQL1 as CORP\User1.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine as the Server type, type SQL1 in the Server name box, and then click Connect.

  4. In Object Explorer, expand Security.

  5. Right-click Logins, and then click New Login.

  6. In the Login name box, type CORP\VisioUnattended.

  7. Under Select a page, click User Mapping.

  8. Select the Map check box for the CorporateDirectory database, and then under Database role membership for:CorporateDirectory, select the db_datareader check box.

  9. Click OK.

With the account created and granted the appropriate data access, we can now configure Secure Store.

Configure Secure Store

Secure Store uses a target application to define connection parameters and authorized users. A Secure Store target application is used to define the unattended service account in Visio Services.

The unattended service account is generally considered a catch-all account that is used for general data access, so usually all users are granted access to the unattended service account through the target application.

Use the following procedure to create a target application for the unattended service account.

To create a target application for the unattended service account

  1. Log in to APP1 using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the SharePoint Central Administration Web site home page, in the Application Management section, click Manage service applications.

  4. Click the Secure Store service application.

  5. On the ribbon, click New.

  6. In the Target Application ID box, type VisioServicesUnattended.

  7. In the Display Name box, type Visio Services Unattended Service Account.

  8. In the Contact E-mail box, type User1@contoso.com.

    Note:

    Although e-mail notifications are not configured in this environment, Contact E-mail is a required field.

  9. In the Target Application Type drop-down list, select Group.

  10. Click Next.

  11. Leave the default credential fields, and then click Next.

  12. On the Specify the membership settings page:

    1. In the Target Application Administrators box, type CORP\User1.

    2. In the Members box, type Everyone.

      Note:

      In a production scenario, you would typically include all users here. You can restrict the users who have access to the unattended service account to a specific Active Directory group if you want, but be aware that only one unattended service account can be created per Visio Services service application.

    3. Click OK.

Once the target application has been created, you must specify which credentials should be used by it. The target application credentials are those to which data access has been granted — in our case, the CORP\VisioUnattended account to which we granted db_datareader access to the CorporateDirectory database.

Use the following procedure to set the credentials for the target application.

To set the credentials for the target application

  1. On the Secure Store Service Application page, in the Target Application ID column, point to VisioServicesUnattended, click the arrow that appears, and then click Set Credentials.

  2. In the Windows User Name box, type CORP\VisioUnattended.

  3. Type and confirm the password for the CORP\VisioUnattended account.

  4. Click OK.

With the credentials set for the target application, the Secure Store configuration for the unattended service account is complete. The next step is to configure Visio Services to use this target application for the unattended service account.

Configure Visio Services

The unattended service account configuration is part of the Visio Services Global Settings. Use the following procedure to configure the unattended service account in Visio Services.

To configure Visio Services Global Settings

  1. On the Central Administration home page, under Application Management, click Manage service applications.

  2. On the Manage Service Applications page, click Visio Services.

  3. On the Manage the Visio Graphics Service page, click Global Settings.

  4. On the Visio Graphics Service Settings page, in the External Data section, in the Application ID box, type VisioServicesUnattended.

  5. Click OK.

With the Visio Services Global Settings configured, setup of the unattended service account is complete. In the next section, we will create a data-connected diagram, publish it to a SharePoint document library, and render it by using Visio Services. This enables us to test data refresh by using the unattended service account.

Grant database access to the diagram author

When Visio Services renders a data-connected diagram, it can use Secure Store and the unattended service account to refresh the data. However, Visio does not use Secure Store or the unattended service account, but instead requires the user to have direct database access to work with a data-connected diagram. Because of this, in order to create a data-connected diagram in Visio, we must first grant Read access to the CorporateDirectory database to the user who will create the diagram.

In Test Lab Guide: Configure Visio Services, we created an Active Directory group named VisioDiagramAuthors for granting database access to diagram authors. We must now grant db_datareader access to that group for the CorporateDirectory database.

Use the following procedure to grant database access to the CORP\VisioDiagramAuthors group.

To grant database access to a user

  1. Log on to SQL1 as CORP\User1.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. Connect to the Database Engine.

  4. In SQL Server Management Studio, expand Security, and then expand Logins.

  5. Right-click the CORP\VisioDiagramAuthors logon, and then click Properties.

  6. In the pane on the left side, click User Mapping.

  7. Select the Map check box for the CorporateDirectory database.

  8. In the Database role membership for: CorporateDirectory list, select the db_datareader check box, and then click OK.

Publish a data-connected diagram

To confirm that we have successfully configured Visio Services and the unattended service account, we will create a data-connected diagram that uses the CorporateDirectory table that we created in SQL Server.

To create a diagram

  1. Log on to CLIENT1 by using the CORP\Susan.Burk account.

  2. Click Start, click All Programs, click Microsoft Office 2013, and then click Microsoft Visio 2013.

  3. On the Choose a Template page, click Maps and Floor Plans.

  4. In the Category list, click Floor Plans.

  5. Click Floor Plan, and then click Create.

  6. From the Shapes list, drag four Room shapes onto the page and organize them in two rows of two with a small space between the rows.

  7. Drag a Door shape onto the bottom wall of each of the top two Room shapes.

  8. Drag a Door shape onto the top wall of each of the bottom two Room shapes.

You should now have a diagram that resembles the following:

Image of floorplan

The next step is to connect the data in the CorporateDirectory database to the floor plan that we just created.

To connect the Visio diagram to data

  1. On the ribbon, click the Data tab, and then click Link Data to Shapes.

  2. On the Data Selector page of the wizard, click Microsoft SQL Server database, and then click Next.

  3. On the Connect to Database Server page, type SQL1 in the Server name box, and then click Next.

  4. On the Select Database and Table page select CorporateDirectory from the drop-down list, and then click Next.

  5. On the Save Data Connection File and Finish page, click Finish.

    Note:

    If you are prompted to overwrite the existing data connection file, click Yes.

  6. On the Select Data Connection page, click Next.

  7. On the Connect to data page, click Next.

  8. On the Configure Refresh Unique Identifier page, clear the Name check box and select the Office check box.

  9. Click Finish.

  10. On the drawing page:

    1. From the External Data section, drag John Woods to the upper-left office in the drawing.

    2. Select the upper-left office in the drawing, and then on the Data tab, click Data Graphics, and then click Edit Data Graphic.

    3. Select the Name row in the Data Field list, and then in the Default position section, select Left from the Horizontal drop-down list.

    4. With the Name row still selected, click Edit Item.

    5. From the Style list, select Heading 3, and then click OK.

    6. Select the Office row in the Data Field list, and then in the Default position section, ensure that Horizontal is set to Left.

    7. With the Office row still selected, click Edit Item.

    8. From the Style list, select Heading 3, and then click OK.

    9. Click OK.

    10. From the External Data section, drag Susan Burk to the lower-left office in the diagram (under John Woods).

    11. From the External Data section, drag Cindy White to the upper-right office in the diagram (to the right side of John Woods).

    12. From the External Data section, drag David Hamilton to the lower-right office in the diagram (under Cindy White).

  11. Leave the diagram open for the next procedure.

You should now see a diagram similar to the following.

Image of floorplan

The next step is to publish this diagram to the Business Intelligence Center as a data-connected diagram.

To publish a data-connected diagram

  1. Click File, and then click Save.

  2. Click Browse.

  3. On the Save As dialog box, type http://APP1/sites/BICenter in the location box at the top, and then press Enter.

    Note:

    It may take some time for the dialog box to refresh and show the site content.

  4. In the All Site Content list, double-click Documents.

  5. In the File name box, type Floor plan, and then click Save.

  6. When the save has completed, navigate to the document libaray in the Business Intelligence Center (http://wfe1/sites/BICenter/Documents) and click on the Floorplan.vsdx file to render it in the browser using Visio Services.

  7. When the drawing is displayed, if a Refresh Disabled warning is displayed, click Allow Refresh.

    Leave this browser window open for the data refresh test procedure that follows.

The rendered diagram shows the data currently in the CorporateDirectory database. Next, we will test data refresh.

Test data refresh

To test the data refresh mechanism, we can modify the data in the Office table in SQL Server and then refresh the diagram to see the change.

Use the following procedure to modify the data in SQL Server and then refresh the diagram.

Note:

Remain logged in to CLIENT1 as Susan Burk while you do this procedure.

To test Visio Services data refresh

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. In the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [CorporateDirectory]
GO
UPDATE dbo.Office set dbo.Office.Name = 'David Hamilton' where dbo.Office.Office = '1501'
GO
UPDATE dbo.Office set dbo.Office.Name = 'John Woods' where dbo.Office.Office = '1504'
GO

  6. In the toolbar, click Execute.

  7. Return to CLIENT1 where the Server Status diagram is displayed.

    Note that in the original drawing, John Woods is in office 1501 and David Hamilton is in office 1504.

  8. On the Visio Web Access toolbar, click Refresh.

    Note that John Woods and David Hamilton have now swapped offices, reflecting the manual changes we made in SQL Server.

    Note:

    The Visio Services cache settings affect how quickly the new results appear when you refresh the drawing. In the Test Lab Guide: Configure Visio Services lab, we set the cache settings to zero (0), allowing immediate refresh. In a production environment, refresh will likely take longer depending on how you configure the cache.

See also

Configure Visio Services data refresh in SharePoint Server 2013 by using the unattended service account


Test Lab Guide: Configure Visio Services data refresh using an external connection
See also

Published: December 18, 2012

Summary: Configure Visio Services data refresh in a test lab environment.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to set up Visio Services in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Scenario overview

  • Before you begin

  • Create sample data

  • Configure a data access account

  • Configure Secure Store

  • Grant database access to the diagram author

  • Create a data-connected diagram by using an ODC file

  • Test data refresh

Scenario overview

This test lab guide explains how to configure the data access account for Visio Services. This includes:

  • Configure a data access account

  • Configure a Secure Store target application

In this lab, we will also create a sample diagram with an external data connection in Visio and publish it to the Business Intelligence Center to confirm that data refresh is working.

Before you begin

This test lab guide assumes that you have completed all the steps in the following test lab guides:

  • Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

  • Test Lab Guide: Create a Business Intelligence Baseline Environment

  • Test Lab Guide: Configure Visio Services

  • Test Lab Guide: Configure Secure Store

  • Test Lab Guide Mini-Module: Installing Microsoft Office Professional Plus 2013 on CLIENT1 (en-US)

You must have completed all of the steps in the above-listed test lab guides before beginning the procedures in this test lab guide.

You must also install Visio Professional 2013 on CLIENT1 if you have not already done so. You can download a trial version of Visio Professional 2013 from the TechNet Evaluation Center.

Create sample data

When configuring data access through Secure Store, you have to grant the account access to the data source to which your Visio diagram will be connected. For the purposes of this lab, we will create a SQL Server table. The table contains some simple data which we can use in a data-connected diagram which we will publish to a document library in the Business Intelligence Center.

Use the following procedure to create the SQL Server table.

To create a table with sample data

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. On the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [master]
GO
CREATE DATABASE ServerStatus;
GO
USE [ServerStatus]
GO
CREATE TABLE [dbo].[Status](
[Server] [varchar](50) NULL,
[Status] [bit] NULL
) ON [PRIMARY]
GO
INSERT INTO Status ([SERVER], [Status])
VALUES ('Seattle', 'TRUE');
GO
INSERT INTO Status ([SERVER], [Status])
VALUES ('New York', 'TRUE');
GO
INSERT INTO Status ([SERVER], [Status])
VALUES ('London', 'FALSE');
GO

  6. On the toolbar, click Execute.

With the sample table created, the next step is to create an Active Directory account for use as the data access account.

Configure a data access account

Secure Store maps users designated to have data access to an account that has data access. For this lab, we will create an Active Directory account and give it access to the ServerStatus database that we created in the previous section. Use the following procedure to create the account.

To create an Active Directory account for data access

  1. Log into DC1 as CORP\Administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.contoso.com node.

  4. Right-click Users, click New, and then click User.

  5. In the Full name and User logon name boxes, type VisioDataAccess.

  6. Click Next.

  7. Type and confirm a password for the account.

  8. Clear the User must change password at next logon check box.

  9. Select the Password never expires check box.

  10. Click Next, and then click Finish.

Once the account has been created, the next step is to grant that account read access to the required data. In a production scenario, you would grant access to whatever data source that you need to access from your Visio diagram. In this lab we will grant access to the sample SQL Server that we created earlier. Use the following procedure to create a SQL Server logon and grant that logon data reader access to the ServerStatus table.

To create a SQL Server logon

  1. Log on to SQL1 as CORP\User1.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine as the Server type, type SQL1 in the Server name box, and then click Connect.

  4. In Object Explorer, expand Security.

  5. Right-click Logins, and then click New Login.

  6. In the Login name box, type CORP\VisioDataAccess.

  7. Under Select a page, click User Mapping.

  8. Select the Map check box for the ServerStatus database, and then under Database role membership for: ServerStatus, select the db_datareader check box.

  9. Click OK.

Now that the CORP\VisioDataAccess account has access to the ServerStatus database that we created, the next step is to configure Secure Store.

Configure Secure Store

Configuring Secure Store involves three steps:

  • Determine which users should have data access through Secure Store

  • Create a Secure Store target application that contains those users

  • Map the target application to the credentials that have data access

Generally, you will want to provide data access to multiple users. The easiest way to manage that is by creating an Active Directory group and then populating that group with the users to whom you want to grant data access.

Use the following procedure to create the Active Directory group.

To create an Active Directory group for user data access

  1. Log on to DC1 using the CORP\Administrator account.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.contoso.com node.

  4. Right-click Users, click New, and then click Group.

  5. In the Group name box type VisioDataAccessGroup.

  6. Click OK.

Next, we will populate the group with the users to whom we want to grant data access. In this case, we will use the Susan Burk and John Woods accounts. Use the following procedure to populate the VisioDataAccessGroup.

To populate the data access group

  1. In Active Directory Users and Computers, in the users list, double-click the VisioDataAccessGroup group.

  2. On the Members tab, click Add.

  3. On the Select Users dialog box, type CORP\susan.burk; CORP\john.woods, and then click OK.

    The Members tab should now show Susan Burk and John Woods as members of the group.

  4. Click OK.

The next step is to create a Secure Store target application that contains the VisioDataAccessGroup group. Use the following procedure to create the target application.

To create a target application

  1. Log on to the APP1 virtual machine using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the Central Administration home page, under Application Management, click Manage service applications.

  4. Click the Secure Store service application.

  5. On the ribbon, click New.

  6. In the Target Application ID box, type VisioServicesData.

  7. In the Display Name box, type Visio Services Data Access.

  8. In the Contact E-mail box, type User1@contoso.com.

    Note:

    Although e-mail notifications are not configured in this environment, Contact E-mail is a required field.

  9. In the Target Application Type drop-down list, select Group.

  10. Click Next.

  11. Leave the default credential fields, and then click Next.

  12. On the Specify the membership settings page:

    1. In the Target Application Administrators box, type CORP\User1.

    2. In the Members box, type CORP\VisioDataAccessGroup.

    3. Click OK.

Now that the target application has been created, we must associate it with the credentials that have data access (the CORP\VisioDataAccess account). Use the following procedure to set the credentials for the target application.

To set the credentials for the target application

  1. On the Secure Store Service Application page, in the Target Application ID column, point to VisioServicesData, click the arrow that appears, and then click Set Credentials.

  2. In the Windows User Name box, type CORP\VisioDataAccess.

  3. Type and confirm the password for the CORP\VisioDataAccess account.

  4. Click OK.

The Secure Store configuration is now complete. In the next section, we will configure data access for the Visio user who will be creating data-connected diagrams.

Grant database access to the diagram author

When Visio Services renders a data-connected diagram, it can use Secure Store to refresh the data. However, Visio does not use Secure Store, but instead require the user to have direct database access to work with an ODC file or a data-connected diagram. Because of this, we must first grant Read access to the ServerStatus database to the user who will create the diagram.

In Test Lab Guide: Create a Business Intelligence Baseline Environment, we created an Active Directory group named VisioDiagramAuthors for granting database access to diagram authors. We must now grant db_datareader access to that group for the ServerStatus database.

Use the following procedure to grant database access to the CORP\VisioDiagramAuthors group.

To grant database access to a user

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. Connect to the Database Engine.

  4. In SQL Server Management Studio, expand Security, and then expand Logins.

  5. Right-click the CORP\VisioDiagramAuthors logon, and then click Properties.

  6. In the pane on the left side, click User Mapping.

  7. Select the Map check box for the ServerStatus database.

  8. In the Database role membership for: ServerStatus list, select the db_datareader check box, and then click OK.

With configuration of database access for the CORP\VisioDiagramAuthors group complete, the next step is to create an Office Data Connection file.

Create a data-connected diagram by using an ODC file

In this section, we create a data-connected diagram using an external connection file, and then publish it to the document library in the Business Intelligence center. This helps us confirm that data refresh through Secure Store is working correctly.

Use the following procedure to create the diagram.

To create an ODC file and link data to shapes in Visio

  1. Log into CLIENT1 using the CORP\Susan.Burk account.

  2. Click Start, click All Programs, click Microsoft Office, and then click Microsoft Visio 2013.

  3. On the Choose a Template page, in the Template Categories section, click Network.

  4. Click Detailed Network Diagram, and then click Create.

  5. On the ribbon, click the Data tab, and then click Link Data to Shapes.

  6. On the Data Selector page, choose the Microsoft SQL Server database option, and then click Next.

  7. On the Connect to Database Server page, type SQL1, and then click Next.

  8. On the Select Database and Table page, select the ServerStatus database, and then click Next.

  9. On the Save Data Connection File and Finish page:

    1. Click Authentication Settings.

    2. On the Visio Services Authentication Settings dialog box, choose the Use a stored account option, type the application ID of the Secure Store target application that you created (VisioServicesData) in the Application ID text box, and click OK.

    3. Click Browse.

    4. Browse to a the data connection library in the Business Intelligence Center (http://WFE1/sites/BICenter/Data%20Connections).

      Note:

      Visio Services does not require that ODC files be saved to a data connection library. However, for easiest administration, we recommend using data connection libraries to store all your data connection files.

    5. Type ServerStatusConnection.odc in the File name box, and then click Save.

    6. Click Finish.

  10. If the Web File Properties dialog box appears, click OK.

  11. On the Select Data Connection page, click Finish.

  12. On the blank drawing page:

    • Drag three Server icons from the Shapes area onto the page.

    • Drag each row from the data table in the External Data section to one of the shapes.

      Each shape should now have a data graphic connected to it indicating the server name and status (1 or 0).

You should now have a diagram similar to the following.

Image of servers with data callouts

The next step is to publish the diagram as a data-connected diagram and then confirm that data refresh is working correctly.

Use the following procedure to publish the drawing.

To publish a data-connected diagram

  1. When you are ready to save the drawing, click File, click Save, and then click Browse.

  2. On the Save As dialog box, type http://APP1/sites/BICenter in the location box at the top, and then press Enter.

    Note:

    It may take some time for the dialog box to refresh and show the site content.

  3. In the All Site Content list, double-click Documents.

  4. In the File name box, type Server Status, and then click Save.

  5. When the save has completed, navigate to the document libaray in the Business Intelligence Center (http://wfe1/sites/BICenter/Documents) and click on the ServerStatus.vsdx file to render it in the browser using Visio Services.

  6. When the drawing is displayed, if a Refresh Disabled warning is displayed, click Allow Refresh.

  7. Note the server statuses displayed:

    • Seattle - True (1)

    • New York - True (1)

    • London - False (0)

    Leave this browser window open for the data refresh test procedure that follows.

The rendered diagram shows the data currently in the ServerStatus database. To test the data refresh mechanism, we can modify the data in the Status table in SQL Server and then refresh the diagram to see the change.

Test data refresh

Use the following procedure to modify the data in SQL Server and then refresh the diagram.

Note:

Remain logged on to CLIENT1 as Susan Burk while you do this procedure.

To test Visio Services data refresh

  1. Log into SQL1 using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. In the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [ServerStatus]
GO
UPDATE dbo.Status set dbo.Status.status = 1 where dbo.Status.server = 'London'
GO

  6. In the toolbar, click Execute.

  7. Return to CLIENT1 where the Server Status diagram is displayed.

    Note that the London server still shows False (0).

  8. On the Visio Web Access toolbar, click Refresh.

    Note that the London server now shows True (1), reflecting the manual changes we made in SQL Server.

    Note:

    The Visio Services cache settings affect how quickly the new results appear when you refresh the drawing. In this lab, we set the cache settings to zero (0), allowing immediate refresh. In a production environment, refresh will likely take longer depending on how you configure the cache.

See also

Configure Visio Services data refresh in SharePoint Server 2013 by using external data connections


Test Lab Guide: Configure PerformancePoint Services

Published: December 18, 2012

Summary: Learn how to configure PerformancePoint Services in a test lab environment.

Applies to: SharePoint Server 2013 Enterprise

This article explains how to setup PerformancePoint Services in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Scenario overview

  • Before you begin

  • Create an account for the application pool

  • To start the PerformancePoint Service

  • To create a PerformancePoint Services service application

Scenario overview

This test lab guide explains how to configure PerformancePoint Services. This includes:

  • Creating an Active Directory account for the application pool under which the PerformancePoint Services service application will run

  • Registering that account as a managed account in SharePoint Server 2013

  • Starting the PerformancePoint Service

  • Creating a PerformancePoint Services service application

Before you begin

Before starting, make sure you have completed the steps in Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

Important:

To take advantage of the new Business Intelligence features, you must install SQL Server 2012 on SQL1. You cannot use SQL Server 2008 R2 on SQL1.

You must also complete the steps in Test Lab Guide: Create a Business Intelligence Baseline Environment, as the PerformancePoint Services configuration steps require the user accounts created in that test lab guide.

Create an account for the application pool

The first step in deploying PerformancePoint Services is to create an account in the Active Directory directory service to run the application pool for the PerformancePoint Services service application. Use the following procedure to create the account.

To create an account for the application pool

  1. Log in to DC1 by using the CORP\User1 account.

  2. On the DC1 virtual machine, click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the CORP.local node.

  4. Right-click Users, click New, and then click User.

  5. In the Full name box and the User logon name box, type PPSAppPool.

  6. Click Next.

  7. In the Password and Confirm password boxes, type a password for the account.

  8. Clear the User must change password at next logon check box.

  9. Select the Password never expires check box.

  10. Click Next.

  11. Click Finish.

  12. Log off DC1.

Once the Active Directory account has been created, it must be registered in SharePoint Server 2013 before it can be used to run an application pool. Use the following procedure to register the account.

To register a managed account

  1. Log on to APP1 by using the CORP\USER1 account.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the SharePoint Central Administration Web site home page, in the left navigation, click Security.

  4. On the Security page, under General Security, click Configure managed accounts.

  5. On the Managed Accounts page, click Register Managed Account.

  6. In the User name box, type CORP\PPSAppPool.

  7. In the Password box, type the password for the CORP\PPSAppPool account.

  8. Click OK.

By default, the application pool account does not have the required access to the SharePoint content database. Access to this database is required by PerformancePoint Services. Use the following procedure to grant the required database access to the application pool account.

To grant content database access to the managed account

  1. On APP1, click Start, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell, and then click Run as Administrator.

  2. At the Windows PowerShell Command Prompt, type the following and press Enter after each line:

    Copy code
    $w = Get-SPWebApplication -identity http://WFE1
$w.GrantAccessToProcessIdentity("CORP\PPSAppPool")

Once you have granted database access to the application pool account, you must start the PerformancePoint Service. This is the SharePoint Server 2013 service that performs all processing and activities associated with PerformancePoint Services.

You must start this service on at least one application server. In a production environment, you would choose a server or servers on which to run the service, depending on your capacity requirements.

Use the following procedure to start the PerformancePoint Service.

To start the PerformancePoint Service

  1. On the Central Administration home page, under System Settings, click Manage services on server.

  2. Above the Service list, click the Server drop-down, and then click Change Server.

    Note that the application server, APP1, is listed together with SQL1. In a farm that has multiple application servers, you would use this dialog box to select the server where you want to run Secure Store Service, and then start the service as shown later in this article.

  3. Click APP1.

  4. In the Service list, click Start next to PerformancePoint Service.

Once the PerformancePoint Service has been started, you must create a PerformancePoint Services service application. Use the following procedure to create the service application.

To create a PerformancePoint Services service application

  1. On the Central Administration home page, under Application Management, click Manage service applications.

  2. On the Manage Service Applications page, click New, and then click PerformancePoint Service Application.

  3. In the Name section, type PerformancePoint Services in the box.

  4. Select the Add this service application's proxy to the farm's default proxy list check box.

  5. Select the Create new application pool option and type PPSAppPool in the Application pool name box.

  6. Select the Configurable option and, from the drop-down list, select CORP\ppsapppool.

  7. Click Create.

  8. When the service application has been successfully created, click OK.

When you have completed all of the previous procedures, PerformancePoint Services is operational and ready to use. The next step is to configure security access to your data sources. The following lab covers configuring security access by using Secure Store Service:

  • Test Lab Guide: Configure data access for PerformancePoint Services


Test Lab Guide: Configure data access for PerformancePoint Services
See also

Published: December 18, 2012

Summary: Learn how to configure data access for PerformancePoint Services.

Applies to: SharePoint Server 2013 Enterprise

This article describes how to configure data access for PerformancePoint Services in a test lab that is based on the Configure SharePoint Server 2013 Preview in a Three-Tier Farm test lab guide.

Important:

This scenario applies only to Microsoft TechNet Test Lab Guides.

In this article:

  • Create sample data

  • Configure a data access account

  • To create a SQL Server logon

  • Configure the unattended service account

Scenario overview

This test lab guide explains how to data access for PerformancePoint Services. This includes the following:

  • Create sample SQL data

  • Configure a data access account and creating an Active Directory account

  • Creating a SQL Server login

  • Configuring the unattended service account in the PerformancePoint global settings

Before you begin

Before starting, make sure you have completed the steps in Test Lab Guide: Configure SharePoint Server 2013 in a Three-Tier Farm, including the prerequisite test lab guides discussed in that document. This test lab uses the three-tier infrastructure that is created in the Configure SharePoint Server 2013 in a Three-Tier Farm test lab guide.

Important:

To take advantage of the new Business Intelligence features, you must install SQL Server 2012 on SQL1. You cannot use SQL Server 2008 R2 on SQL1.

You must also complete the steps in Test Lab Guide: Create a Business Intelligence Baseline Environment, as the PerformancePoint Services configuration steps require the user accounts created in that test lab guide.

Create sample data

For the purposes of this lab, we will create a SQL Server database and table. The table contains some simple data that we can use in a data-connected workbook which we will publish to the SharePoint document library in the Business Intelligence Center.

Note:

If you have previously followed the steps in Test Lab Guide: Configure Excel Services data refresh by using an embedded connection or Test Lab Guide: Configure Excel Services data refresh by using an external connection, this database may already exist. In this case, there is no need to recreate the database.

Use the following procedure to create the SQL Server database and table.

To create a database and table with sample data

  1. Log on to SQL1 by using the CORP\User1 account.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine for the Server type, and then click Connect.

  4. On the toolbar, click New Query.

  5. Copy the following query to the query window:

    Copy code
    USE [master]
GO
CREATE DATABASE CorporateAccounts;
GO
USE [CorporateAccounts]
GO
CREATE TABLE [dbo].[Accounts](
[Region] [varchar] (50) NULL,
[Sales] [money] NULL,
[OpEx] [money] NULL,
[AssetValue] [money] NULL
) ON [PRIMARY]
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('North', 23486.56, 16874.53, 64789.34);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('South', 19864.35, 11265.84, 55349.37);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('East', 31824.65, 22849.67, 87318.27);
GO
INSERT INTO Accounts ([Region], [Sales], [OpEx], [AssetValue])
VALUES ('West', 27691.26, 17628.43, 84287.67);
GO

  6. On the toolbar, click Execute.

With the sample database and table created, the next step is to create an Active Directory account for use as the unattended service account.

Configure a data access account

The first step is to create an Active Directory account for use as the unattended service account.

To configure a data access account for PerformancePoint Services, start by creating an Active Directory account.

To create an Active Directory account for data access

  1. Log into DC1 as CORP\User1.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the corp.local node.

  4. Right-click Users, click New, and then click User.

  5. In the Full name and User logon name text boxes, type PPSUnattended.

  6. Click Next.

  7. Type and confirm a password for the account.

  8. Clear the User must change password at next logon check box.

  9. Select the Password never expires check box.

  10. Click Next, and then click Finish.

Next, we create a SQL Server login. This account will be used to view data that is stored in SQL Server.

To create a SQL Server logon

  1. Log in to SQL1 as CORP\User1.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, select Database Engine as the Server type, type SQL1 in the Server name text box, and then click Connect.

  4. In Object Explorer, expand Security.

  5. Right click Logins, and then click New Login.

  6. In the Login name text box, type CORP\PPSUnattended.

  7. Under Select a page, click User Mapping.

  8. Select the Map check box for the CorporateAccounts database, and then under Database role membership for: CorporateAccounts, select the db_datareader check box.

  9. Click OK.

Now that the data access account is configured, the next step is to configure the unattended service account for PerformancePoint Services.

Configure the unattended service account

To configure the unattended service account, we begin by specifying an unattended service account for PerformancePoint. We do this by editing PerformancePoint Services Global Settings.

To configure the unattended service account

  1. Log into APP1 as CORP\User1.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, and then click SharePoint 2013 Central Administration.

  3. On the Central Administration home page, under Application Management, click Manage service applications.

  4. On the Manage Service Applications page, click PerformancePoint Services.

  5. On the Manage the PerformancePoint Services page, click PerformancePoint Service Application Settings.

  6. On the PerformancePoint Service Application Settings page, in the SecureStore and Unattended Service Account section:

    1. In the User Name text box, type CORP\PPSUnattended.

    2. In the Password text box, type the password for the CORP\PPSUnattended account.

  7. Click OK.

See also

Test Lab Guide: Create a Business Intelligence Baseline Environment


Use Analysis Services EffectiveUserName in SharePoint Server 2013

Summary: Use the EffectiveUserName option in Excel Services or PerformancePoint Services for per-user authentication with Analysis Services data sources.

Applies to: SharePoint Server 2013 Enterprise

EffectiveUserName is a SQL Server Analysis Services connection string property that contains the name of the user who is accessing a report or dashboard. In SharePoint Server 2013, you can use this property in conjunction with Excel Services or PerformancePoint Services to pass the identity of the user who is viewing the report or dashboard to SQL Server Analysis Services. This allows per-user identity without the need to configure Kerberos delegation.

Enable EffectiveUserName in Excel Services

Using the EffectiveUserName feature with Excel Services requires the following:

  • The Excel Services application pool account must be an Analysis Services Administrator.

  • You must enable the EffectiveUserName option in Excel Services Global Settings.

  • You must select the Use the authenticated user's account option in the Excel Services Authentication Settings in Excel.

Use the following procedure to enable the EffectiveUserName feature in Excel Services.

To enable EffectiveUserName in Excel Services

  1. In Central Administration, in the Application Management section, click Manage service applications.

  2. Click the Excel Services service application.

  3. Click Global Settings.

  4. On the Excel Services Application Settings page, in the External Data section, select the Use the EffectiveUserName property check box.

  5. Click OK.

For a more detailed look at using EffectiveUserName in Excel Services, see Use EffectiveUserName with Excel Services (SharePoint Server 2013).

Enable EffectiveUserName in PerformancePoint Services

Using the EffectiveUserName feature with PerformancePoint Services requires the following:

  • The PerformancePoint Services application pool account must be an Analysis Services Administrator.

  • You must enable the EffectiveUserName option in PerformancePoint Service Application Settings.

  • You must select the Per-user Identity option when you create the data source in PerformancePoint Dashboard Designer.

Note:

The EffectiveUserName feature does not work in conjunction with Power Pivot data sources.

Note:

If you use a connection string to create the data connection, and the connection string contains an effective user field, the EffectiveUserName feature will override the user-supplied effective user value with the system-supplied value.

Use the following procedure to enable the EffectiveUserName feature in PerformancePoint Services.

To enable EffectiveUserName in PerformancePoint Services

  1. In Central Administration, in the Application Management section, click Manage service applications.

  2. Click the PerformancePoint Services service application.

  3. Click PerformancePoint Service Application Settings.

  4. On the PerformancePoint Service Application Settings page, select the Use the EffectiveUserName connection string property instead of Windows delegation check box.

  5. Click OK.

For a more detailed look at using EffectiveUserName in PerformancePoint Services, see Use EffectiveUserName in PerformancePoint Services (SharePoint Server 2013).


Use EffectiveUserName with Excel Services (SharePoint Server 2013)

Published: February 5, 2013

Summary: Use the Analysis Services EffectiveUserName feature to refresh data-connected workbooks in Excel Services using the workbook viewer's Windows identity.

Applies to: SharePoint Server 2013 Enterprise

Important:

This scenario applies only to Excel Services with an Analysis Services data source on SharePoint Server 2013 Enterprise.

In this article:

  • Scenario overview

  • Before you begin

  • Configure Excel Services Global Settings

  • Configure Analysis Services access

  • Configure OLAP cube access

  • Create and publish a report

Scenario overview

Using the EffectiveUserName feature with Excel Services allows the identity of a user viewing a report to be passed to SQL Server Analysis Services. This allows you to specify the appropriate level of data access for a given user on the OLAP cube itself.

Using the EffectiveUserName option allows passing the user's identity to SQL Server Analysis Services without the need to configure Secure Store or Kerberos delegation.

Before you begin

Before starting, read the following information about permissions and software requirements.

  • This scenario assumes that you have Excel Services configured on your farm and an Excel Services trusted file location where you can save your report. For information about configuring Excel Services, see Overview of Excel Services in SharePoint Server 2013 and Configure Excel Services in SharePoint Server 2013. For information about configuring a trusted file location, see Manage Excel Services trusted file locations (SharePoint Server 2013).

  • This scenario requires that you have Farm Administrator access to the SharePoint Server 2013 farm and administrator access to SQL Server Analysis Services.

Configure Excel Services Global Settings

The first step in configuring the EffectiveUserName feature is to enable the feature in Excel Services global settings. Use the following procedure to enable the EffectiveUserName feature.

To enable EffectiveUserName in Excel Services

  1. In Central Administration, under Application Management, click Manage service applications.

  2. Click the Excel Services service application.

  3. Click Global Settings.

  4. On the Excel Services Application Settings page, in the External Data section, select the Use the EffectiveUserName property check box.

  5. Click OK.

Configure Analysis Services access

Using the EffectiveUserName feature requires that the account that is running the Excel Services application pool be an Analysis Services administrator.

If you do not know what account is running the Excel Services application pool in your farm, use the following procedure to determine the account. If you know the account, skip this procedure.

To determine the Excel Services application pool account

  1. On the SharePoint Central Administration Web site home page, click Security.

  2. On the Security page, under General Security, click Configure service accounts.

  3. On the Service Account page, in the Credential Management section, from the drop-down list, select the application pool that runs Excel Services Application.

    When this option is selected, the name of the Excel Services service application appears in the box underneath the drop-down list. The account shown in the Select an account for this component dropdown list is the Windows identity that you need to add as an Analysis Services administrator.

  4. Click Cancel.

You must add the Excel Services application pool account as an Analysis Services administrator. Use the following procedure to add this account as an administrator in Analysis Services.

To add an Analysis Services administrator

  1. In SQL Server Management Studio, connect to Analysis Services.

  2. Right click the Analysis Services top node, and then click Properties.

  3. On the Security page, click Add.

  4. Type the name of the account that runs the Excel Services application pool, and then click OK.

  5. Click OK.

Configure OLAP cube access

You must grant access to the OLAP cube for the users who will be creating or viewing Excel Services reports. To do this, you must create a role in the OLAP cube. (You can use an existing role if you have created one previously.)

Within the role, you can grant access to users or Active Directory groups. We recommend using Active Directory groups for easier administration.

Analysis Services provides a variety of access options for a given role. You can create multiple roles if you have different groups of users who need different levels of access to the cube.

Use the following procedure to create a role and assign permissions to users.

Note:

This procedure describes how to grant read access to a cube. You can adjust the permissions for the role as needed for your users.

To create a role

  1. In SQL Server Management Studio, connect to Analysis Services.

  2. Expand Databases and expand the database where you want to create the role.

  3. Right-click Roles and click New Role.

  4. On the General page, type a name for the role.

  5. On the Membership page, add the users or Active Directory group containing the users to whom you want to grant cube access.

  6. On the Cubes page, select Read from the Access dropdown list for the cubes that you want to grant access to.

  7. Click OK.

Once granted read permissions to the OLAP cube, users will be able to connect to the cube in Excel to create reports and will also be able to refresh the data in Excel Services.

Note:

Once granted access to an OLAP cube, users can also connect to the cube directly in SQL Server Management Studio. The access that they are granted to the cube determines what actions they can perform in Management Studio.

Create and publish a report

Once a user has been granted access to the cube, they can connect to it in Excel. Use the following procedure to connect to the cube.

To connect to an OLAP data source

  1. In Excel, on the Data tab, in the Get External Data section, click From Other Sources, and then click From Analysis Services.

  2. In the Server name text box, type the name of the instance of Analysis Services that you want to connect to, and then click Next.

  3. Select the cube that you want to connect to, and then click Next.

  4. Click Finish.

In order for the EffectiveUserName feature to be used in a published report, the Excel Services authentication settings must be configured to use Windows authentication. Use the following procedure to configure the Excel Services authentication settings for your data source.

To configure Excel Services authentication settings

  1. In Excel, on the Data tab, in the Connections section, click Connections.

  2. Select the connection to your Analysis Services cube, and then click Properties.

  3. On the Definition tab, click Authentication Settings.

  4. On the Excel Services Authentication Settings dialog box, select the Use the authenticated user's account (Excel 2013) or Windows Authentication (Excel 2010) option, and then click OK.

  5. Click OK and then click Close.

When you have finished creating your report, the next step is to save it to a SharePoint Server document library that has been configured as a trusted file location in Excel Services. Use the following procedure to save your workbook.

Note:

This procedure uses Excel 2013. In Excel 2010, use File, Save & Send to publish the workbook to SharePoint Server.

To publish the report to SharePoint Server

  1. In Excel, on the File tab, click Save.

  2. Click Computer, and then click Browse.

  3. Type the URL of the SharePoint document library where you want to save the file.

  4. Type a filename, and then click Save.

Once the workbook has been saved to SharePoint Server, you can render it using Excel Services and the data will refresh based on the refresh settings configured in the Excel Services trusted file location settings.


Use EffectiveUserName in PerformancePoint Services (SharePoint Server 2013)

Published: February 5, 2013

Summary: Learn how to use the EffectiveUserName option when it connects to an Analysis Services data from PerformancePoint Services Dashboard Designer.

Applies to: SharePoint Server 2013

EffectiveUserName is a SQL Server Analysis Services connection string property that contains the name of the user who is accessing a report or dashboard. In SharePoint Server 2013, you can use this property together with PerformancePoint Services to pass the identity of the user who is viewing the report or dashboard to SQL Server Analysis Services. This enables per-user identity without the requirement to configure Kerberos delegation.

  • Scenario overview

  • Before you begin

  • Configure PerformancePoint Services Application Settings

  • Configure Analysis Services access

  • Create and publish a report

Scenario overview

Using the EffectiveUserName feature with PerformancePoint Services allows the identity of a user viewing a report to be passed to SQL Server Analysis Services.

Using the EffectiveUserName option allows for passing the user's identity to SQL Server Analysis Services without the requirement to configure Secure Store or Kerberos delegation.

Before you begin

Before starting, confirm that you have met the software and permission requirements.

  • You have PerformancePoint Services configured on your farm.

  • You have Farm Administrator access to the SharePoint Server 2013 farm and administrator access to SQL Server Analysis Services.

Configure PerformancePoint Services Application Settings

Using the EffectiveUserName feature with PerformancePoint Services requires the following:

  • The PerformancePoint Services application pool account must be an Analysis Services Administrator.

  • The EffectiveUserName option in must be enabled in the PerformancePoint Service Application Settings.

  • You must select the Per-user Identity option when you create the data source in PerformancePoint Dashboard Designer.

This setting applies to all Analysis Services data sources configured for per user authentication. When this setting is enabled, all connections to Analysis Services data for individual users will be made using the EffectiveUserName connection string property instead of Windows delegation.

To enable EffectiveUserName in PerformancePoint Services

  1. In Central Administration, in the Application Management section, click Manage service applications.

  2. Click the PerformancePoint Services service application.

  3. Click PerformancePoint Service Application Settings.

  4. Select the Use the EffectiveUserName connection string property instead of Windows delegation check box.

  5. Click OK.

Note:

The EffectiveUserName feature does not work with Power Pivot data sources.

Important:

If you use a connection string to create the data connection, and the connection string contains an effective user field, the EffectiveUserName feature will override the user-supplied effective user value with the system-supplied value.

Configure Analysis Services access

If you do not know what account is running the PerformancePoint Services application pool in your farm, follow these steps to determine the account. If you know the account, skip this procedure.

To determine the PerformancePoint Services application pool account

  1. On the SharePoint Central Administration website home page, click Security.

  2. On the Security page, under General Security, click Configure service accounts.

  3. On the Service Account page, in the Credential Management section, from the drop-down list, select the application pool that runs PerformancePoint Services Application.

    When this option is selected, the name of the service application appears in the box underneath the drop-down list. The account shown in the Select an account for this component drop-down list is the Windows identity that you need to add as an Analysis Services administrator.

  4. Click Cancel.

You must add the PerformancePoint Services application pool account as an Analysis Services administrator. Use the following procedure to add this account as an administrator in Analysis Services.

To add an Analysis Services administrator

  1. In SQL Server Management Studio, connect to Analysis Services.

  2. Right click the Analysis Services top node, and then click Properties.

  3. On the Security page, click Add.

  4. Type the name of the account that runs the PerformancePoint Services application pool, and then click OK.

  5. Click OK.

Connect to an Analysis Services data source from Dashboard Designer

You can connect to an Analysis Services data source either by entering the name of the Analysis Services server, database, and cube name, or by typing a connection string and the cube name in Dashboard Designer.

To connect to an Analysis Services data source with the EffectiveUserName option enabled

  1. start Dashboard Designer.

  2. Click the Create tab, and then click Data Source.

  3. In the Category pane of the Select a Data Source Template dialog box, click Multidimensional and then click Analysis Services. Click OK.

  4. In the left navigation pane (workspace browser), type the name of your data source.

  5. In the Formatting Dimension drop-down list, select desired dimension formatting needed for the report.

  6. In the Cache Lifetime drop-down box, type the refresh rate (in minutes) for the cache. Data from this data source will update at this interval.

  7. In the center pane, click the Editor tab. In the Connection Settings section, select the method by which to connect to the data source. To use a standard connection:

    1. Select Use standard connection

    2. Type the full path for the server to which you want to connect. This populates the options in the database list.

    3. In the Database box, select a database name.

    4. (Optional) In the Roles box, type the name of the role, such as an administrator or database role. To specify multiple roles, type the names of the roles and separate them with commas.

    5. From the Cube drop-down list, select the specific cube that you want to use as the data source in the database.

  8. In the Data Source Settings section, select Per-user identity as the method by which to authenticate to the data source.

  9. Click Test Data Source to confirm your connection is configured correctly.


Use Secure Store with SQL Server Authentication (SharePoint Server 2013)
See also

Published: December 4, 2012

Summary: Use Secure Store in SharePoint Server 2013 to store SQL Server credentials.

You can use the Secure Store Service to store credentials for data sources that require SQL Server Authentication. You can then use these credentials to access data sources that require SQL Server Authentication (such as Windows Azure SQL Database) through Excel Services in SharePoint Server 2013 or Visio Services in SharePoint Server 2013.

Note:

Using SQL Server credentials stored in Secure Store is not supported in PerformancePoint Services.

We recommend storing credentials in Secure Store over storing them in a workbook file or Office Data Connection file. When you store credentials in Secure Store, they are not stored in plain text and you can manage the credentials in a central location, which can be easier to update than credentials embedded in workbook files or ODC files.

Using Secure Store together with Excel Services or Visio Services to access data sources through SQL Server Authentication requires the following:

  • A Secure Store target application containing the SQL Server credentials with access to the data source must be configured.

  • The Unattended Service Account must be configured.

The procedures in this article assume that you have already deployed Secure Store and Excel Services or Visio Services. For more information about how to deploy Secure Store, Excel Services, and Visio Services, see the related links at the end of this article.

Configure a Secure Store target application

To use Secure Store for SQL Server authentication, you must create a target application which contains the SQL Server login with data access (usually db_datareader permissions). Use the following procedure to create the target application.

To create a target application for SQL Server Authentication

  1. On the SharePoint Central Administration home page, under Application Management, click Manage Service Applications.

  2. Click the Secure Store service application.

  3. On the Edit tab, click New.

  4. On the Target Application Settings page:

    1. Type an application ID in the Target Application ID text box.

    2. Type a display name in the Display Name text box.

    3. Type an e-mail address in the Contact E-mail text box.

    4. From the Target Application Type drop-down list, choose Group.

    5. Click Next.

  5. On the Specify Credentials page:

    1. Change the Windows User Name field name to User ID and change the associated Field Type from Windows User Name to User Name.

    2. Change the Windows Password field name to Password and change the associated Field Type from Windows Password to Password.

    3. Click Next.

  6. On the Specify Membership page:

    1. In the Target Application Administrators box, type the name of the user account that you want to administer this target application.

    2. In the Members box, type the names of or browse for the users or Active Directory groups to which you want to give data access. To give access to all users, type Everyone.

    3. Click OK.

Once you have created the target application, you must set the credentials for the target application. These are the SQL Server credentials that have access to your data source. Use the following procedure to set the credentials for the target application.

To set credentials for the target application

  1. On the SharePoint Central Administration home page, under Application Management, click Manage Service Applications.

  2. Click the Secure Store service application.

  3. On the Secure Store page, select the check box for the target application that you created for SQL Server Authentication, and then, in the Credentials section of the ribbon, click Set.

  4. In the User ID text box, type the SQL Server account that has data access.

  5. In the Password and Confirm Password text boxes, type the password for the SQL Server account.

  6. Click OK.

Configure a target application for the Unattended Service Account

Using Secure Store for SQL Server Authentication with Excel Services or Visio Services requires that the Unattended Service Account be configured. The Unattended Service Account requires no specific permissions for this scenario; it only has to exist in the system. If you currently have an Unattended Service Account configured, you can skip the procedures in this section.

Note:

You can determine if an unattended service account has been configured by checking the External Data settings in Excel Services or Visio Services Global Settings.

If you have not configured the Unattended Service Account for Excel Services or Visio Services, you must first create a target application in Secure Store that can be used as the Unattended Service Account. Use the following procedure to create the target application.

To create a target application for the Unattended Service Account

  1. On the SharePoint Central Administration home page, under Application Management, click Manage Service Applications.

  2. Click the Secure Store service application.

  3. On the Edit tab, click New.

  4. On the Target Application Settings page:

    1. Type an application ID in the Target Application ID text box.

    2. Type a display name in the Display Name text box.

    3. Type an e-mail address in the Contact E-mail text box.

    4. From the Target Application Type drop-down list, choose Group.

    5. Click Next.

  5. On the Specify Credentials page, click Next.

  6. On the Specify Membership page:

    1. In the Target Application Administrators box, type the name of the user account that you want to administer this target application.

    2. In the Members box, type the name of the Windows account that runs the application pool for Excel Services or Visio Services.

    3. Click OK.

Once the target application has been created, you must associate a set of Windows credentials with it. This must be a Windows domain account, but it requires no specific permissions for this scenario. Use the following procedure to set the credentials for the target application.

To set credentials for the target application

  1. On the SharePoint Central Administration home page, under Application Management, click Manage Service Applications.

  2. Click the Secure Store service application.

  3. On the Secure Store page, select the check box for the target application that you created for the unattended services account, and then, in the Credentials section of the ribbon, click Set.

  4. In the Windows User Name text box, type the user name of a Windows account.

  5. In the Windows Password and Confirm Windows Password text boxes, type the password for the Windows account.

  6. Click OK.

Once the credentials have been set for the target application, follow the Unattended Service Account configuration steps for Excel Services or Visio Services in the following sections.

Configure Excel Services

If you are using Excel Services, use the procedures in this section to complete the necessary configuration steps.

If the Unattended Service Account has not already been configured for Excel Services, follow these steps to configure it.

To configure the Unattended Service Account

  1. On the SharePoint Central Administration home page, under Application Management, click Manage Service Applications.

  2. Click the Excel Services service application.

  3. Click Global Settings.

  4. In the External Data section, choose the Use an existing Unattended Service Account option, and then type the name of the target application that you created for the Unattended Service Account in the Target Application ID text box.

  5. Click OK.

In order to use Excel Services with Secure Store, you must specify a Secure Store target application in Excel before publishing the Excel workbook to a SharePoint site to be rendered with Excel Services. In this case, you must specify the Secure Store target application that you created that contains the SQL Server login credentials.

Use the following procedure to specify a Secure Store target application from Excel.

Note:

This procedure uses Excel 2013. The steps for Excel 2010 are similar.

To configure Secure Store settings in Excel

  1. In Excel, on the Data tab, click From Other Sources, and then click From SQL Server.

  2. On the Connect to Database Server page:

    1. Type the name of the instance of SQL Server that you want to connect to in the Server name text box.

    2. Choose the Use the following User Name and Password option, and then type the user name and password of a SQL Server account that has access to your data source.

    3. Click Next.

  3. On the Select Database and Table page, select the database and table that you want to connect to, and then click Next.

  4. On the Save Data Connection File and Finish page, click Authentication Settings.

  5. In the Excel Services Authentication Settings dialog box, select the Use a stored account option, type the name of the Secure Store target application that you created to use for SQL Server Authentication, and then click OK.

  6. On the Save Data Connection File and Finish page, type a name for the data connection file (or keep the default) in the File Name text box, and then click Finish.

  7. In the Import Data dialog box, choose one of the PivotTable options, and then click OK.

  8. If a SQL Server Login dialog box appears, type the password for the Login ID, and then click OK.

Once you have connected to the data source, you can complete your Excel workbook and publish it to a SharePoint site to be rendered with Excel Services. The connection information to the Secure Store target application will remain embedded in the file.

Note:

Excel connects to the database directly. It does not use Secure Store. Secure Store is only used by Excel Services when rendering a workbook from a SharePoint site.

Optionally, you can export the Secure Store connection information as an ODC file and then use it to connect additional Excel workbooks to the same data source. This allows for easier management and distribution of data connections. Use the following procedure if you want to export the Secure Store connection as an ODC file.

Important:

You must export the ODC file to a trusted data connection library. Trusted data connection libraries are specified in the Excel Services service application settings. For more information, Manage Excel Services trusted data connection libraries (SharePoint Server 2013) see.

To export the ODC file

  1. In Excel, on the Data tab, click Connections.

  2. Select the connection that you are using and then click Properties.

  3. In the Connection Properties dialog box, click the Definition tab.

  4. On the Definition tab, click Authentication Settings.

  5. Confirm that you have the Use a stored account option selected and the correct Secure Store target application is specified in the Application ID: text box, and then click OK.

  6. Click Export Connection File.

  7. Navigate to an appropriate Data Connection Library on the SharePoint site, type a file name, and then click Save.

Once you have exported the ODC file, you can choose to connect to it from any Excel workbook where you want to connect to that data source. If the data connection information changes, you only have to update the ODC file itself and all Excel workbooks referencing it will have the new connection information.

Note:

You must select the Always use connection file check box in the Excel connection properties to ensure that the Excel workbook will always use the connection file.

Configure Visio Services

If you are using Visio Services, use the procedures in this section to complete the necessary configuration steps.

If the Unattended Service Account has not already been configured for Visio Services, follow these steps to configure it.

To configure the Unattended Service Account

  1. On the SharePoint Central Administration home page, under Application Management, click Manage Service Applications.

  2. Click the Visio Services service application.

  3. Click Global Settings.

  4. In the External Data section, in the Application ID text box, type the name of the target application that you created for the Unattended Service Account.

  5. Click OK.

In order to use Visio Services with Secure Store, you must specify a Secure Store target application in the Visio data connection wizard and export the connection file to SharePoint Server before publishing the Visio diagram to a SharePoint site to be rendered with Visio Services. In this case, you must specify the Secure Store target application that you created that contains the SQL Server login credentials.

Use the following procedure to specify a Secure Store target application from Visio.

To create a data-connected diagram for use with a Secure Store target application

  1. In Visio Professional 2013, open a diagram or create a new diagram.

  2. On the ribbon, click the Data tab, and then click Link Data to Shapes.

  3. On the Data Selector page, choose the Microsoft SQL Server database option, and then click Next.

  4. On the Connect to Database Server page, type the name of your database server, choose the Use the following User Name and Password option, and then type your SQL Server username and password.

  5. Click Next.

  6. On the Select Database and Table page, select the database to which you want to connect, and then click Next.

  7. On the Save Data Connection File and Finish page:

    1. Click Authentication Settings.

    2. On the Visio Services Authentication Settings dialog box, choose the Use a stored account option, type the application ID of the Secure Store target application that you created in the Application ID text box, and click OK.

    3. Click Browse.

    4. Browse to a data connection library.

      Note:

      Visio Services does not require that ODC files be saved to a data connection library. However, for easiest administration, we recommend using data connection libraries to store all your data connection files.

    5. Type a name for the ODC file, and then click Save.

    6. Click Finish.

  8. If the Web File Properties dialog box appears, update the Title, Description, and Keywords if desired, and click OK.

  9. On the Select Data Connection page, click Finish.

  10. Connect the data to the shapes in your diagram.

  11. When you are ready to save the drawing, click File, click Save, and then browse to a SharePoint document library.

  12. Type a file name, and then click Save.

Note:

Visio connects to the database directly. It does not use Secure Store. Secure Store is only used by Visio Services when rendering a Visio diagram from a SharePoint site.

Once you have published the diagram to a SharePoint document library, you can render it using Visio Services and Visio Services will use the SQL Server credentials stored in the Secure Store target application to refresh the data in the diagram.

See also

Plan the Secure Store Service in SharePoint Server 2013
Configure the Secure Store Service in SharePoint 2013
Overview of Excel Services in SharePoint Server 2013
Administer Excel Services in SharePoint Server 2013
Plan for Visio Services in SharePoint Server 2013
Visio Graphics Service administration in SharePoint Server 2013


Use Visio Services with external lists in SharePoint 2013

Summary: Connect to an external list in Visio by using Microsoft Business Connectivity Services and render the diagram in a browser by using Visio Services.

Applies to: SharePoint Server 2013

This document describes the procedures necessary to connect a Visio diagram to an external list in SharePoint Server 2013.

An external list is a data source outside SharePoint Server (for example, a SQL Server table) that has been connected to a SharePoint list by using Microsoft Business Connectivity Services. The data connection and the external list are both created by using Visual Studio 2012 or SharePoint Designer 2013. The connection information is managed and stored by using the Business Data Connectivity service, a component of Business Connectivity Services in SharePoint Server 2013.

Before you begin

The following service applications must be running and configured on your SharePoint Server 2013 farm:

  • Business Data Connectivity service

  • Visio Graphics Service

  • Secure Store Service

You also need the following domain accounts:

  • An account that has read access to your data source. This account is stored in Secure Store for use by Microsoft Business Connectivity Services.

  • A user account that has Design permissions to the SharePoint site where you want to create the external list.

  • An account that has Farm Administrator permissions to configure various settings on the SharePoint Central Administration website.

Configure a Secure Store target application

The Business Data Connectivity service External Content Type uses credentials that are stored in Secure Store to access the data source. You must create a Secure Store target application for the External Content Type to use in accessing these credentials.

Use the following procedure to create the target application.

To create a Secure Store Target Application

  1. In Central Administration, in the Application Management section, click Manage Service Applications.

  2. Click the Secure Store service application.

  3. In the Manage Target Applications group on the ribbon, click New.

  4. In the Target Application ID box, type a unique identifier for this target application. Note the name that you use here; you will need it when you create the External Content Type.

  5. Type a Display Name and Contact E-Mail address.

  6. From the Target Application Type list, select Group.

  7. Click Next.

  8. On the Field Names page, keep the default settings and then click Next.

  9. In the Target Application Administrators box, type the names of the users whom you want to be able to administer this target application.

  10. In the Members box, type the names of the users whom you want to allow to trigger data refresh. (That is, the users who will be viewing the Visio diagram that you create.)

  11. Click OK.

After the target application has been created, you must set the credentials that are to be associated with this target application. In this case, you must use a domain account that has read access to the data source that you want to connect to through Microsoft Business Connectivity Services.

To set the credentials for the target application

  1. On the Secure Store administration page, select the check box next to the target application that you just created.

  2. In the Credentials group on the ribbon, click Set.

  3. In the Windows User Name box, type the domain account that has access to your data source.

  4. Type and confirm the password for that account.

  5. Click OK.

Configure Business Data Connectivity service metadata store permissions

You must create the External Content Type with a user account that has permissions to the Business Data Connectivity service metadata store. Use the following procedure to grant a user permissions to the Business Data Connectivity service metadata store. (You can skip this step if you already have a user account that has these permissions.)

To grant a user permissions to the Business Data Connectivity service metadata store

  1. In Central Administration, in the Application Management section, click Manage Service Applications.

  2. Click the Business Data Connectivity service service application.

  3. In the Permissions section of the ribbon, click Set Metadata Store Permissions.

  4. Type the user account to which you want to grant permissions, and then click Add.

  5. Select the user account that you just added, and then select the Edit and Execute check boxes.

  6. Click OK.

Note that Edit is a highly privileged permission that is required to create or modify External Content Types in Business Data Connectivity service. We recommend that you set Edit permissions when the site is first designed or changed and then remove the Edit permissions for users who do not require it. Execute permissions are required to query the External Content Type.

Create an External Content Type

After your user account has permissions to the Business Data Connectivity service metadata store, you can create the External Content Type. To complete the procedures in this section, your account must also have Design permissions on the SharePoint site where you plan to create the external list. If you want to set permissions on the list (an optional step) you must have Full Control permissions on the site.

External content types for Business Data Connectivity service are created and managed in SharePoint Designer 2013 or Visual Studio 2012. This example uses a SQL Server data source, and the external content type is created by using SharePoint Designer 2013.

The following procedures describe how to create and configure an External Content Type. Follow these procedures on a computer that is running SharePoint Designer 2013.

To create an External Content Type

  1. Log on to a computer by using an account that has Design permissions on the SharePoint site where you want to create the external list and permissions to the Business Data Connectivity service metadata store.

  2. Open SharePoint Designer 2013.

  3. In the Open SharePoint Site section, click Open Site.

  4. In the Site name box, type the URL of the site where you want to create the external list, and then click Open.

  5. In the left navigation, click External Content Types.

  6. In the New section of the ribbon, click External Content Type.

  7. Type a Name and Display Name for the content type.

  8. Click Click here to discover external data sources and define operations.

  9. Click Add Connection.

  10. Select your data source type from the Data Source Type list. (This example assumes a SQL Server data source.)

  11. In the SQL Server Connection dialog box:

    • In the Database Server box, type the name of your database server.

    • In the Database Name box, type the name of your database.

    • Select the Connect with Impersonated Windows Identity option.

    • In the Secure Store Application ID box, type the ID of the Secure Store target application that you created.

    • Click OK.

  12. In the Data Source Explorer, find the table that you want to connect to.

  13. Right-click the table and then click Create All Operations.

  14. Complete the All operations wizard.

  15. When you have completed the wizard, on the File menu, click Save.

After you have created the External Content Type, the next step is to create an external list based on it.

To create an external list

  1. In SharePoint Designer, in the left navigation pane, click External Content Types. (If the External Content Type that you just created does not appear in the list, you may have to refresh the list.)

  2. Right-click the External Content Type that you created, and then click External List.

  3. Type a name for the list, and then click OK.

  4. Optionally, click Permissions for this list to set list permissions. (By default, the list inherits permissions from the site.)

Configure Business Data Connectivity service object permissions

Users who will be using the external list in SharePoint or who will be viewing a Visio diagram connected to that list must have permissions to the External Content Type. Use the following procedure to grant the users permissions to the External Content Type in Business Data Connectivity service.

To grant a user permissions to the Business Data Connectivity service External Content Type

  1. In Central Administration, in the Application Management section, click Manage Service Applications.

  2. Click the Business Data Connectivity service service application.

  3. Click the External Content Type that you created.

  4. In the Permissions group on the ribbon, click Set Object Permissions.

  5. Type the user account or an Active Directory group to which you want to grant permissions, and then click Add.

  6. Select the user account that you just added, and then select the Execute check box.

  7. Click OK.

Connect to the external list in Visio

The external list is now available on the SharePoint site. You can now connect to the list from Visio.

To connect to an external list in Visio

  1. In Visio 2013, on the Data tab, click Link Data to Shapes.

  2. Choose the Microsoft SharePoint Foundation list option, and then click Next.

  3. On the Select a site page, type the URL for the SharePoint site where your external list is located, and then click Next.

  4. On the Select a list page, choose the external list that you created, and then click Finish.

The data from the external list is now available in Visio and you can link it to your shapes. After you have linked the data to shapes, the next step is to save the file to a SharePoint document library.

To save a diagram to a SharePoint document library

  1. In Visio, click File, and then click Save.

  2. Click Computer, and then click Browse.

  3. Type the URL of the SharePoint document library in the location box at the top of the Save As dialog box, and then press Enter.

  4. Type a file name, and then click Save.

After the diagram has been saved to the SharePoint document library, you can go to the document library and click the Visio file to render it in a browser by using Visio Services.


Use Visio Services with SharePoint lists (SharePoint Server 2013)

Published: October 16, 2012

You can connect a Visio diagram to the data in a SharePoint list and maintain that connection when you publish the diagram to SharePoint Server 2013.

Applies to: SharePoint Server 2013 Enterprise

To connect to the SharePoint list from Visio, you must have at least Read access to the SharePoint list. Likewise, once the diagram has been published to a SharePoint document library, viewers must have Read access to the list in order to refresh the data from the list.

Note:

This scenario requires you to have Visio Services in SharePoint Server 2013 deployed. For information about how to deploy Visio Services, see Plan for Visio Services in SharePoint Server 2013. This scenario specifically covers using Visio Professional 2013 to publish the Visio diagram to SharePoint Server 2013. To learn how to do this using Visio 2010 with either SharePoint Server 2010 or SharePoint Server 2013, see Use Visio Services with SharePoint lists (SharePoint Server 2010).

Publishing a diagram connected to a SharePoint list

Publishing a data-connected diagram that is connected to a SharePoint list consists of two steps:

  • Create the diagram in Visio and connect shapes in the diagram to the data in the SharePoint list

  • Publish the diagram to a SharePoint document library

To connect a Visio diagram to a SharePoint list

  1. In Visio, open the diagram that you want to connect to the SharePoint list, or create a new diagram.

  2. On the Data tab, click Link Data to Shapes.

  3. On the Data selector page, select the Microsoft SharePoint Foundation list option, and then click Next.

  4. On the Select a site page, in the Site box, type the URL for the SharePoint site where the SharePoint list is located, and then click Next.

  5. On the Select a list page, in the Lists list, select the list to which you want to connect, and then click Next.

  6. Click Finish.

Once you have connected to the SharePoint list, you can drag the data rows onto the page to link data to your existing shapes, or add new shapes. When you have completed the diagram, you can save it to a SharePoint document library and render it with Visio Services.

To publish a diagram to a SharePoint document library

  1. In Visio, click File.

  2. Click Save, and then browse to a SharePoint document library.

  3. Type a file name, and then click Save.

Once the diagram has been saved to the SharePoint document library, you can view the diagram by clicking it directly or by configuring it to appear in a Visio Web Access Web Part. The diagram remains connected to the data in the SharePoint list, and the data refreshes based on the refresh settings that you have configured for Visio Services and for the Visio Web Access Web Part, if applicable.


Viewing reports and dashboards on mobile devices
See also

Updated: February 19, 2013

Learn how to view reports and dashboards on mobile devices, such as Apple iPad and Windows 8 tablet devices.

Applies to: SharePoint Server 2013

Have you been wondering about how to view business intelligence content, such as reports, scorecards, and dashboards on mobile devices? Are you interested in enabling people to consume business intelligence content on the go? Use the articles in this section to learn how to create and configure different reports, scorecards, and dashboards that can be consumed on certain kinds of mobile devices, such as Apple iPad and Windows 8 tablets.

In this section

This section contains detailed information about how to create reports, scorecards, and dashboards that can be viewed by using a mobile device, such as Apple iPad and Windows 8 tablets. The following table describes the articles that are included in this section.

Table: Summary of articles in this section

Article Description

Configuring business intelligence content for viewing on mobile devices

Provides tips and tricks to consider when you configure reports and dashboards to be consumed on mobile devices.

View and explore data in a dashboard

This video shows how you can explore an Excel Services dashboard using Windows 8 tablet. The video highlights the following capabilities:

  • How an Excel Services dashboard can be displayed using worksheet view or gallery view

  • How to open the Fields list for a value in a PivotChart report or a PivotTable report

  • How to apply a slicer to view more specific information

  • How to open and use Quick Explore to view additional information about a value in a PivotChart report or a PivotTable report

See also

Administer mobile devices in SharePoint 2013

Change History

Date | Description
February 19, 2013 | Added a link to a new video about viewing Excel Services dashboards on Apple iPad.
December 18, 2012 | Initial publication


Configuring business intelligence content for viewing on mobile devices
See also

Published: December 18, 2012

Summary: Learn tips and tricks of configuring reports, scorecards, and dashboards to be displayed correctly on mobile devices.

Applies to: SharePoint Server 2013 Enterprise

Office 2013, together with SQL Server applications, enables you to create lots of reports, scorecards, and dashboards. Whether your organization is using SharePoint Server 2013 (on premises) or Office 365 (which includes SharePoint Online) to share business intelligence content, you probably have people in your organization who want to view that content on mobile devices. This article contains recommendations on how to configure business intelligence content to display on devices such as Apple iPad or Windows 8 tablet devices.

Requirements

People must be able to connect to the sites where business intelligence content resides.

  • If your business intelligence content is published to SharePoint Server, then people must be able to connect to the corporate network to access the content.

    See Plan for mobile devices in SharePoint 2013 for important information.

  • If your business intelligence content is published to Office 365, then people must have a user name and password to log on to view the content online.

Configuring reports, scorecards, and dashboards to display on mobile devices

As you create and publish reports, scorecards, and dashboards in your organization, consider certain items or potential issues that can arise as people attempt to consume that content on mobile devices. The following table contains frequently asked questions that might arise, together with recommendations for best results.

Table: Potential Issues and Recommendations

Item or Potential Issue Recommendation

Display size

Depending on how much content is displayed in a dashboard page, reports, scorecards, and dashboards might look very small on mobile devices. This can make it difficult for people to view the content on a mobile device.

When you create reports, scorecards, and dashboards that will be displayed on mobile devices, such as Apple iPad and Windows 8 tablet devices, make sure that you do not display too many items on a single page. For example, consider creating views that do not contain lots of columns. In addition, reports that are viewed on tablet devices generally display much smaller than you would see on a computer. Consider creating pages that contain just a few (no more than four) reports on a single page.

Filters

Some kinds of slicers might not work as expected on Excel Services reports displayed on touch devices that do not use external keyboards. In particular, when people use touch devices, people can apply single-item slicers, but not slicers that include multiple selections.

Consider creating filters and slicers that will enable people to view the information that they need. Some applications, such as PerformancePoint Services or SQL Server Reporting Services, enable you to create filters that enable people to select multiple items in a list. Excel Services supports a timeline control that you can create by using Excel, which enables people to view information for a particular period of time.

Links and right-click menus

People might not know how to open some kinds of hyperlinks and context menus as they do when they view business intelligence content on a Windows-based computer.

Mobile devices do not typically support right-click functionality or the ability to double-click a SharePoint folder to open it. But, this does not mean that context menus or folders are unavailable.

To open a SharePoint folder or a shortcut menu or a hyperlink in a browser window on a mobile device, tap and hold a position for approximately 1-2 seconds. A shortcut menu opens from which you can select the option that you want.

Note:

If your organization is running SharePoint Server 2013 in SharePoint Server 2010 mode, context menus might not be available for PerformancePoint content.

Exporting content

Certain kinds of Web Parts contain commands that enable people to export a view to another application. For example, some PerformancePoint Web Parts have Export to PowerPoint or Export to Excel commands. Other kinds of Web Parts might have different export commands. Depending on the kind of Web Part and how a device is configured, people might be unable to export content, even if a Web Part menu contains an export command that is displayed on a device.

Some kinds of reports and scorecards can be exported if the necessary software is installed on the mobile device.

  • To use an Export to PowerPoint command, verify that you have installed an application that is compatible with PowerPoint on the device.

  • To use an Export to Excel command, verify that you have installed an application that is compatible with Excel on the device.

Operating systems and compatibility issues

As updates to operating systems are released, browsing functionality can be affected. For example, people who were using one version of an operating system's browser to view a dashboard might find that it no longer works using an updated version of that operating system's browser.

In addition, views that require client-side applications, such as Silverlight, might not be displayed on mobile devices.

Consider testing your business intelligence content on various devices and operating systems to determine which features and functionality work in your environment. You won't be able to control when updates are released and when people install those updates, but by periodically testing your business intelligence content on various devices, you can be aware of issues people might face.

See also

Plan for mobile devices in SharePoint 2013
Mobile security and authentication in SharePoint 2013
View and explore data in a dashboard


View and explore data in a dashboard
See also

Published: February 19, 2013

Summary: Watch this video to learn how to explore data in an Excel Services dashboard using a Windows 8 tablet.

Applies to: SharePoint Server 2013 Enterprise

Video: Viewing an Excel Services dashboard using a Windows 8 tablet

Video (play button) icon

Summary

Watch this video to see how you can explore data in an Excel Services dashboard using a Windows 8 tablet. In this video, you'll see an Excel Services dashboard that was published using worksheet view and gallery view display options. You'll also see how to use the Fields list for a PivotChart report or a PivotTable report, how to apply slicers, and how to use Quick Explore to view additional information about a value in a PivotChart or PivotTable report.

For information about how to create a dashboard that resembles our example dashboard, see Create an Excel Services dashboard using an OData data feed.

Related resources

Resource | Description
Viewing reports and dashboards on mobile devices | Find more information about how to create and configure different reports, scorecards, and dashboards that can be consumed on certain kinds of mobile devices, such as Apple iPad and Windows 8 tablets.
Business Intelligence Resource Center | Find resources and tools to learn more about business intelligence capabilities in SharePoint 2013.
SharePoint Products Tech Center (http://technet.microsoft.com/en-us/sharepoint/default.aspx) | Find details about related technologies, downloads, and additional resources.

See also

Business intelligence scenarios and solutions
Creating solutions by using Adventure Works sample data


Business Intelligence Governance automation using Windows PowerShell

Published: May 28, 2013

Summary: Automate requests for data access by using Windows PowerShell, SharePoint lists, and workflows.

Applies to: SharePoint Server 2013 Enterprise

The articles in this section describe three scenarios in which you can use Windows PowerShell to automate your business processes.

Using Windows PowerShell to automate your business processes allows you to ensure that they are followed the same way each time they are used, giving you predictable results. It can also save your administrators some time by automating processes that might otherwise require a user to file a help ticket.

The purpose of these articles is to show some ideas around how to automate processes by using features like Windows PowerShell and SharePoint workflows. While these scenarios are specific to the business intelligence scenario of granting users access to data sources, the ideas can be applied to other areas also.

  • Self-service data access In this scenario, a user requests access to a data source by using a SharePoint list and the requested access is configured automatically by the Windows PowerShell script.

    This scenario is covered in Self-service data access using Windows PowerShell.

  • Department-specific data access In this scenario, a user requests access to a data source by using a SharePoint list and the Windows PowerShell script grants a specific level of access based on the user's Department in Active Directory.

    This scenario is covered in Department-specific data access using Windows PowerShell.

  • Admin-approved data access In this scenario, a user requests access to a data source by using a SharePoint list. The request is then copied by a workflow to another SharePoint list where administrators can approve or reject requests. The Windows PowerShell script processes those requests that the administrator approved.

    This scenario is covered in Admin-approved data access using Windows PowerShell.


Self-service data access using Windows PowerShell

Published: May 28, 2013

Summary: Automatically grant users database access by using Windows PowerShell, a SharePoint list, and Task Scheduler.

Applies to: SharePoint Server 2013 Enterprise

This scenario describes how to use a Windows PowerShell script running as a scheduled task to automatically process user requests for access to data sources.

Important:

This scenario applies only to SharePoint Server 2013.

In this article:

  • Scenario overview

  • Before you begin

  • Initial setup

    • Video demonstration

    • Configure Active Directory groups and accounts

    • Configure SQL Server access

    • Create a SharePoint list

  • Automation and scripting

    • Video demonstration

    • Create a Windows PowerShell script

    • Configure a script administrator

    • Create a scheduled task

  • Test and verify functionality

    • Video demonstration

    • Verifying functionality

Scenario overview

This article uses the AdventureWorks sample data set to show an example of automating database access requests using Windows PowerShell. By using Windows PowerShell, you can encapsulate your business processes into a script to make sure that they are consistently applied. Using Windows PowerShellalso saves on administration time and allows specific Active Directory functions to be performed without the direct involvement of a domain administrator.

This article provides one example of how to use Windows PowerShell to automate governance processes in an organization. You may want to modify the script and processes to meet your specific needs.

You can install AdventureWorks and follow the steps in this article to create a working prototype, or you can use your own data sources instead of AdventureWorks.

This article describes how to:

  1. Create a SharePoint list where users can request access to data sources.

  2. Create a Windows PowerShell script that, running as a scheduled task, scans the SharePoint list, and adds users to the appropriate Active Directory group to give them the requested data access.

Before you begin

Before starting, note the following:

  • You will need a SharePoint site where you can create a SharePoint list. The procedures in this article assume that you are using a site with the BI Center template, though a Team site will work also. If you want to configure a site with the BI Center template, see Configure a Business Intelligence Center in SharePoint Server 2013.

  • The examples in this article use the AdventureWorks sample data set. You can use AdventureWorks or your own data sources. If you want to install AdventureWorks, see Configure AdventureWorks for Business Intelligence solutions.

  • You will need to create Active Directory accounts and groups as part of the procedures in this article. One of the accounts will need to be added to the Domain Admins group. We recommend using a test environment where you have direct access to a domain controller. Alternatively, you can work with your domain administrator to get the needed accounts and groups configured.

Note:

If you have followed the steps in related articles in this series, some of the users and groups that you are asked to create may already exist in your environment. If that is the case, you can use the existing users and groups. There is no need to recreate existing users or groups.

Initial setup

In this section, we will:

  1. Configure the needed Active Directory accounts and groups.

  2. Configure data access for the Active Directory groups in SQL Server and Analysis Services.

  3. Create a SharePoint list for collecting data access requests.

Completing these steps will provide the infrastructure needed for the Windows PowerShell automation and task scheduling described in the following section.

Video demonstration

This video shows the steps involved in setting up accounts and groups and creating a SharePoint list, as described in this article. (Time: 12:25.)

Video: Initial setup

Video (play button) icon

Configure Active Directory groups and accounts

Create an Active Directory group for each data source to which you want to grant access. For AdventureWorks, we'll create Active Directory groups for the following data sources:

  • AdventureWorks database We'll create a group called AdventureWorksDBUsers

  • AdventureWorks data warehouse We'll create a group called AdventureWorksDWUsers

  • AdventureWorks OLAP cube We'll create a group called AdventureWorksOLAPUsers

Use the following procedure to create an Active Directory group. Follow the procedure for each of the AdventureWorks groups listed above or each of your own data sources.

To create an Active Directory group

  1. Log on to a domain controller as a domain administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the domain node.

  4. Right-click Users, click New, and then click Group.

  5. On the New Object - Group dialog box, type a name for the group in the Group name text box, and then click OK.

For this scenario, we also need a domain administrator account. This account will be used to run a scheduled job that will add users to the Active Directory groups that we created above. You can use an existing domain administrator account, but we recommend that you create a new one specifically for this purpose. We'll refer to this account as the domain proxy account.

Use the following procedure to create an Active Directory account.

To create an Active Directory account

  1. In Active Directory Users and Computers, right-click Users, click New, and then click User.

  2. In the Full name box, type a name for the user account (for example, ADProxyAccount).

  3. In the User logon name text box, type a logon name.

  4. Click Next.

  5. Type and confirm a password for the account.

  6. Choose the password options appropriate for your organization, and then click Next.

  7. Click Finish.

Once the account has been created, you must add it to the Domain Admins group in Active Directory. Use the following procedure to add the account to the Domain Admins group.

To add an account to the Domain Admins group

  1. In Active Directory Users and Computers, under Users, double-click the Domain Admins group.

  2. On the Members tab, click Add.

  3. Type the name of the account that you just created, and then click OK.

  4. Click OK.

Once you have completed the Active Directory configuration steps, the next step is to grant the appropriate database access to the new Active Directory groups.

Configure SQL Server access

Each data source to which you want to grant user access will need a login in SQL Server or a role in Analysis Services for the corresponding Active Directory group. For AdventureWorks, the databases require the following logins:

  • AdventureWorks database A login for the AdventureWorksDBUsers Active Directory group

  • AdventureWorks data warehouse A login for the AdventureWorksDWUsers Active Directory group

Use the following procedure to create a SQL Server login. Follow the procedure for each AdventureWorks databases or each of your own databases.

To create a SQL Server login

  1. Log in to the computer running SQL Server as a SQL Server administrator.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, choose Database Engine from the Server type dropdown list, and then click Connect.

  4. Expand the Security node.

  5. Right-click Logins, and then click New Login.

  6. Click Search.

  7. On the Select User or Group dialog box, click Object Types.

  8. On the Object Types dialog box, select the Groups check box, and then click OK.

  9. On the Select User of Group dialog box, type the name of the Active Directory group for which you want to create the login (for example Contoso\AdvenureWorksDBUsers), and then click OK.

  10. In the Select a page pane, click User Mapping.

  11. Select the check box for the appropriate database (for example, AdventureWorks2012), and then under Database role membership, select the db_datareader check box.

  12. Click OK.

You must also create an Analysis Services role for access to any Analysis Services cubes. For AdventureWorks, the cube requires a role for the AdventureWorksOLAPUsers Active Directory group.

Use the following procedure to create an Analysis Services role. Create a role for the AdventureWorks OLAP cube or for your own Analysis Services cube.

To create an Analysis Services role

  1. Log in to the computer running SQL Server as a SQL Server administrator.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, choose Analysis Services from the Server type dropdown list, and then click Connect.

  4. Expand Databases.

  5. Expand the AdventureWorksDW2012Multidimensional-EE database.

  6. Right-click Roles, and then click New Role.

  7. On the General page, type a name (for example, General Access) in the Role name text box.

  8. Select the Membership page, and then:

    1. Click Add.

    2. On the Select User or Group dialog box, click Object Types.

    3. On the Object Types dialog box, select the Groups check box, and then click OK.

    4. On the Select User of Group dialog box, type the name of the Active Directory group for which you want to create the login (for example Contoso\AdvenureWorksOLAPUsers), and then click OK.

  9. Select the Cube page, and then choose Read from the Access dropdown list for both cubes.

  10. Click OK.

Once SQL Server and Analysis Services have been configured with the needed logins and roles, the next step is to create a SharePoint list to use for data access requests.

Create a SharePoint list

In the SharePoint list, we need fields that can be used to define a database access request. This includes the alias of the user requesting access, the data source that they wish to access, and an area for them to specify the business justification for the request. We also need a field that the Windows PowerShell script can use to track the status of the request, as well as a field where logging information can be stored.

Use the following procedure to create the SharePoint list. You can add additional fields if you need them, but be sure not to omit any fields or the Windows PowerShell script will not work.

To create a SharePoint list

  1. Go to the site where you want to create the list.

  2. In the left navigation, click Site Contents.

  3. Click add an app.

  4. Click Custom List.

  5. In the Adding Custom List dialog box, type Self-service Data Access in the Name text box, and then click Create.

    Note:

    You can choose a different name, but you will need to update the list name in the Windows PowerShell script provided later in this article.

  6. On the Site Contents page, click the Self-service Data Access list.

  7. On the list page, on the List tab in the ribbon, click List Settings.

  8. On the list settings page, under Columns, use the Create column link to create columns as described in the following table.

    Field name Description Options

    Status

    The status of the request.

    Choose the Choice (menu to choose from) option and type New, Succeeded, and Failed for the available choices in the Type each choice on a separate line box. Specify a Default value of New.

    Data Source

    A list of the available data sources.

    Choose the Choice (menu to choose from) option and type AdventureWorks DB, AdventureWorks DW, and AdventureWorks OLAP for the available choices in the Type each choice on a separate line box. (If you are using your own data sources, type those here instead of the AdventureWorks options.)

    User alias

    The alias of the user for whom data access is being requested.

    Use the Single line of text option, and make sure this is a required field by selecting Yes under Require that this column contains information.

    Business justification

    This is an optional field in case you want to keep a record of why a user is requesting data access.

    Use the Multiple lines of text option for this field.

    Log

    A log generated by the Windows PowerShell script describing the actions undertaken by the script.

    Use the Multiple lines of text option for this field.

In order for our Windows PowerShell script to work, the domain proxy account requires read/write access to this list. This is most easily accomplished by granting the account Edit access to the site where the list is located.

To grant access to a site

  1. On the site where the list is located, click Share.

  2. Type the user account for the domain proxy account (for example, contoso\ADProxyAccount).

  3. Click Show Options.

  4. From the Select a group or permission level dropdown list, choose [Edit].

  5. Click Share.

Once you have created the SharePoint list and granted Edit permissions to the domain proxy account, the next step is to automate the process of granting access to the data sources by tying the list together with a Windows PowerShell script. The next section describes the process of creating the script and automating it as a scheduled task.

Automation and scripting

In this section we will:

  1. Create a Windows PowerShell script that reads the SharePoint list and applies the requested permissions in Active Directory.

  2. Create a scheduled task in Windows Server that runs the script at a specified interval.

With the script in place and the scheduled task running, users can add their database requests to the SharePoint list and they will be automatically handled within a short time of being added to the list.

Note:

The script performs functions in Active Directory. In order for the Active Directory Windows PowerShell module to load, the Remote Server Administration Tools must be configured on the server where you are going to run the script. Remote Server Administration Tools is a feature that you can add through Server Manager.

Video demonstration

This video shows the steps involved in configuring a Windows PowerShell script that reads the SharePoint list and applies the requested permissions, and configuring a scheduled task to run the Windows PowerShell script. (Time: 10:35.)

Video: Automation and scripting

Video (play button) icon

Create a Windows PowerShell script

To automate the process of granting access to the requested data source, we'll use a Windows PowerShell script. The sample script below performs the following basic functions:

  1. Loads the SharePoint list where users request data access.

  2. Cycles through each list item looking for a status of New.

  3. For each item with a status of New, the script adds the user specified in the User alias field to the Active Directory group associated with the data source specified in the Data Source filed.

  4. The status of the list item is changed from New to Succeeded or Failed depending on the outcome.

  5. A brief log of events is written to the Log field in the list item.

Use the following procedure to create the Windows PowerShell script. Create the script on your SharePoint Server 2013 application server.

To create a Windows PowerShell script

  1. On the SharePoint Server application server, click Start, click Run, type PowerShell_ISE.exe, and then click OK.

  2. Copy and paste the following script into the Windows PowerShell editor:

    Copy code
    # Add SharePoint and Active Directory cmdlets
if ((Get-PSSnapin "Microsoft.SharePoint.PowerShell" -ErrorAction SilentlyContinue) -eq $null) {
     Add-PSSnapin "Microsoft.SharePoint.PowerShell"
 }
 if ((Get-Module ActiveDirectory -ErrorAction SilentlyContinue) -eq $null) {
     Import-module ActiveDirectory
 }

# Get-SPWeb for the site where the list is located
$ListWeb = Get-SPWeb http://contoso-appsrv1/sites/BICenter

# Get the list by name
$ListName = $ListWeb.Lists["Self-service Data Access"]

# Get the list items
$ListItems = $ListName.items

# Loop through each list item
$ListItems | foreach {

$ListItem = $_

# Look for list items with a status of "New"
if($ListItem["Status"] -eq "New") {

    # Clear out the variables for each loop
    $LogText = ""
    $ActionStatus = ""
    $ActionTime = ""
    $DataSourceADGroup = ""

    # Add-ADGroupMember requires alias with no domain, so remove the domain\ if it exists
    $SharePointUser = $ListItem["User alias"]
    $SharePointUser = $SharePointUser.ToLower()

    # Replace contoso in the line below with the name of your domain
    $SharePointUser = $SharePointUser.Replace("contoso\","")

    # Determine data source being requested and assign the associated AD group to the $DataSourceADGroup variable
    if($ListItem["Data Source"] -eq "AdventureWorks DB") {$DataSourceADGroup = "AdventureWorksDBUsers"}
    if($ListItem["Data Source"] -eq "AdventureWorks DW") {$DataSourceADGroup = "AdventureWorksDWUsers"}
    if($ListItem["Data Source"] -eq "AdventureWorks OLAP") {$DataSourceADGroup = "AdventureWorksOLAPUsers"}

    # Add user request and data source information to the log variable
    $LogText += "User " + $ListItem["User alias"] + " requesting access to " + $DataSourceADGroup + "`n`r"

    # Try to add the requested user to the AD group
    try{
        Add-ADGroupMember -Identity $DataSourceADGroup -Members $SharePointUser

        # Note success in the log variable
        $LogText += "Adding " + $ListItem["User alias"] + " to " + $DataSourceADGroup + "`n`r"

        # Note success in the $ActionStatus variable for later update to the SharePoint list
        $ActionStatus = "Succeeded"
        }
    catch{
        # If Add-ADGroupMember fails, so note in the log variable
        $LogText += "Error: could not add " + $ListItem["User alias"] + " to " + $DataSourceADGroup + ": " + $_ + "`n`r"

        # Note failure in the $ActionStatus variable for later update to the SharePoint list
        $ActionStatus = "Failed"
        }

    # Get the current date and time
    $ActionTime = Get-Date

    # Append the date, time, and final status to the log variable
    $LogText += $ActionStatus + " " + $ActionTime

    # Update the list item with the final status and the log text
    $ListItem["Status"] = $ActionStatus
    $ListItem["Log"] = $LogText
    $ListItem.Update()
    }
}

  3. Click File, click Save, and save the file to a location on the local disk.

Important:

For test purposes, you can save the Windows PowerShell script to a convenient location. In a production environment, have your domain administrator create a folder that requires domain administrator privileges to access and save the script there. This will increase security and help prevent unauthorized changes to the script.

Depending on your environment, you may need to update the following script items:

  • The URL for the site where the SharePoint list is located is set to http://contoso-appsrv1/sites/BICenter. Update this value to the URL for your environment. This is stored in the $ListName variable.

  • On the line $SharePointUser = $SharePointUser.Replace("contoso\","") you must replace contoso with your domain.

  • The Data Source and $DataSourceADGroup values are configured for the AdventureWorks options discussed in this article. If you are using your own data sources, you must update these values to correspond to your data sources.

  • If you named any of the SharePoint list fields differently than those noted in the procedure for creating the list, you must update the script to use the values that you chose. Use the values listed in the procedure for creating the list to find the corresponding values in the script.

Once you have the script saved to your local disk, the next step is to configure the domain proxy account as a script administrator.

Configure a script administrator

In order to successfully run the Windows PowerShell script, the domain proxy account needs permissions to make updates to the SharePoint list by using Windows PowerShell. This is accomplished by using the Add-SPShellAdmin Windows PowerShell cmdlet to give the account shell administrator privileges.

Use the following procedure to configure the domain proxy account as a shell administrator.

Note:

If you previously configured the domain proxy account as a shell administrator in another scenario in this series, there is no need to redo the procedure.

To configure a script administrator

  1. Log in to your SharePoint Server application server as a Farm Administrator.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell, and then click Run as administrator.

  3. In the Windows PowerShell command window, type the following syntax:

    Copy code
    Get-SPContentDatabase | Add-SPShellAdmin -UserName domain\username

    For example:

    Copy code
    Get-SPContentDatabase | Add-SPShellAdmin -UserName Contoso\ADProxyAccount

  4. Press Enter.

Once the domain proxy account has been added as a shell administrator, it can be used to run the Windows PowerShell script as part of a scheduled task.

Create a scheduled task

By using a scheduled task to run the Windows PowerShell script on a repeating basis, we can automate the addition of the users requesting data access to the appropriate Active Directory group.

Use the following procedure to create a scheduled task.

To create a scheduled task

  1. Log into your SharePoint Server application server as a local administrator.

  2. Click Start, click Administrative Tools, and then click Task Scheduler.

  3. In the Actions pane, click Create Task.

  4. On the General tab:

    1. Type a name for the task in the Name text box.

    2. Choose the Run whether user is logged on or not option.

    3. Select the Run with highest privileges check box.

  5. On the Triggers tab:

    1. Click New.

    2. Select the Repeat task every check box, and choose 10 minutes from the dropdown list.

    3. Choose Indefinitely from the for a duration of dropdown list.

    4. Click OK.

  6. On the Actions tab:

    1. Click New.

    2. In the Program/script text box, type PowerShell.exe.

    3. In the Add arguments (optional) text box, type the path and filename of your Windows PowerShell script (for example, C:\Scripts\SelfServiceDataAccess.PS1))

    4. Click OK.

  7. Click OK.

  8. Type the username and password of the account that you want to run the script. This is the Active Directory domain administrator account that you configured as a Windows PowerShell script administrator.

Once the scheduled task has been created, the setup steps for this scenario are complete. The next step is to test the functionality by adding items to the SharePoint list.

Test and verify functionality

In this section, we add some items to the SharePoint list to test the functionality of the script and the scheduled task.

Video demonstration

This video shows some examples of testing this scenario. (Time: 7:46.)

Video: Test and verify functionality

Video (play button) icon

Verifying functionality

Try the following actions to verify that the script and scheduled task are working properly:

  • Add an item to the list. Check the task in Task Scheduler to see when the task is next scheduled to run. Wait until the task has run, then check the SharePoint list to make sure the Status and Log fields have been updated. Check the appropriate Active Directory group to ensure the specified user has been added.

  • Add an item to the list for each data source that you have (the AdventureWorks database, data warehouse, and OLAP cube in our example). In Task Scheduler, right-click the task, and then click Run (to avoid having to wait for the next scheduled time). Check the SharePoint list and Active Directory groups to ensure you're getting the expected results.

  • Create two identical list items (two requests for the same user and data source). Run the scheduled task. This should produce an error in the second request since the user was already added to the appropriate Active Directory group in the first request. Note that the log entry for the second item specifies this error, which was returned by the Add-ADGroupMember cmdlet.

  • Have the users who have been granted data access try to access the data sources from Excel.


Department-specific data access using Windows PowerShell

Published: May 28, 2013

Summary: Automatically grant users database access based on their Active Directory department by using Windows PowerShell, a SharePoint list, and Task Scheduler.

Applies to: SharePoint Server 2013

This scenario describes how to use a Windows PowerShell script running as a scheduled task to automatically process user requests for access to data sources, and assign those users the appropriate level of access based on their Active Directory department.

Important:

This scenario applies only to SharePoint Server 2013.

In this article:

  • Scenario overview

  • Before you begin

  • Initial setup

    • Video demonstration

    • Configure Active Directory groups and accounts

    • Configure SQL Server access

    • Create a SharePoint list

  • Automation and scripting

    • Video demonstration

    • Create a Windows PowerShell script

    • Configure a script administrator

    • Create a scheduled task

  • Test and verify functionality

    • Video demonstration

    • Verifying functionality

Scenario overview

This article uses the AdventureWorks sample data set to show an example of automating database access requests using Windows PowerShell. By using Windows PowerShell, you can encapsulate your business processes into a script to make sure that they are consistently applied. Using Windows PowerShell also saves on administration time and allows specific Active Directory functions to be performed without the direct involvement of a domain administrator.

In this scenario, we will use Windows PowerShell to retrieve the requesting user's Department from Active Directory. Using this information, the Windows PowerShell script will assign the user appropriate access. In the AdventureWorks example described in this article, users in the Sales department will be given full read access to any of the AdventureWorks data sources, whereas users who are not in the Sales department will be given limited OLAP cube access that excludes certain financial information.

This article provides one example of how to use Windows PowerShell to automate governance processes in an organization. You may want to modify the script and processes to meet your specific needs.

You can install AdventureWorks and follow the steps in this article to create a working prototype, or you can use your own data sources instead of AdventureWorks.

This article describes how to:

  1. Create a SharePoint list where users can request access to data sources.

  2. Create roles in Analysis Services to provide different levels of data access to different groups of users.

  3. Create a Windows PowerShell script that runs as a scheduled task, scans the SharePoint list, and adds users to the appropriate Active Directory group, based on their Active Directory department, to give them the appropriate data access.

Before you begin

Before starting, note the following:

  • You will need a SharePoint site where you can create a SharePoint list. The procedures in this article assume that you are using a site with the BI Center template, though a Team site will work also. If you want to configure a site with the BI Center template, see Configure a Business Intelligence Center in SharePoint Server 2013.

  • The examples in this article use the AdventureWorks sample data set. You can use AdventureWorks or your own data sources. If you want to install AdventureWorks, see Configure AdventureWorks for Business Intelligence solutions.

  • The examples in this article use an OLAP cube to provide varying levels of access to different users. We use AdventureWorks for the example, but you can use your own cube if you prefer.

  • You will need to create Active Directory accounts and groups as part of the procedures in this article. One of the accounts will need to be added to the Domain Admins group. We recommend using a test environment where you have direct access to a domain controller. Alternatively, you can work with your domain administrator to get the needed accounts configured.

Note:

If you have followed the steps in related articles in this series, some of the users and groups that you are asked to create may already exist in your environment. If that is the case, you can use the existing users and groups. There is no need to recreate existing users and groups.

Initial setup

In this section, we will:

  1. Configure the needed Active Directory accounts and groups.

  2. Configure data access for the Active Directory groups in SQL Server and Analysis Services.

  3. Create a SharePoint list for collecting data access requests.

Completing these steps will provide the infrastructure needed for the Windows PowerShell automation and task scheduling described in the following section.

Video demonstration

This video shows the steps involved in setting up accounts and groups and creating a SharePoint list, as described in this article. (Time: 13:01.)

Video: Initial setup

Video (play button) icon

Configure Active Directory groups and accounts

Create an Active Directory group for each data source to which you want to grant access. For AdventureWorks, we'll create Active Directory groups for the following data sources:

  • AdventureWorks database - we'll create a group called AdventureWorksDBUsers

  • AdventureWorks data warehouse - we'll create a group called AdventureWorksDWUsers

  • AdventureWorks OLAP cube- we'll create a group called AdventureWorksOLAPUsers for restricted cube access, and a group called AdventureWorksOLAPSales for full cube access.

Use the following procedure to create an Active Directory group. Follow the procedure for each of the AdventureWorks groups listed above or each of your own data sources.

To create an Active Directory group

  1. Log on to a domain controller as a domain administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the domain node.

  4. Right-click Users, click New, and then click Group.

  5. On the New Object - Group dialog box, type a name for the group in the Group name text box, and then click OK.

For this scenario, we also need a domain administrator account. This account will be used to run a scheduled job that will add users to the Active Directory groups that we created above. You can use an existing domain administrator account, but we recommend that you create a new one specifically for this purpose. We'll refer to this account as the domain proxy account.

Use the following procedure to create an Active Directory account.

To create an Active Directory account

  1. In Active Directory Users and Computers, right-click Users, click New, and then click User.

  2. In the Full name text box, type a name for the user account (for example, ADProxyAccount).

  3. In the User logon name text box, type a logon name.

  4. Click Next.

  5. Type and confirm a password for the account.

  6. Choose the password options appropriate for your organization, and then click Next.

  7. Click Finish.

Once the account has been created, you must add it to the Domain Admins group in Active Directory. Use the following procedure to add the account to the Domain Admins group.

To add an account to the Domain Admins group

  1. In Active Directory Users and Computers, under Users, double-click the Domain Admins group.

  2. On the Members tab, click Add.

  3. Type the name of the account that you just created, and then click OK.

  4. Click OK.

As part of this scenario, we will be checking users Active Directory account settings to determine what department they belong to. You will need one or more users that have a department of Sales, and one or more users that have a different department (for example, Engineering).

Use the following procedure to set the department for the Active Directory user accounts that you will be using as part of this scenario.

To configure an Active Directory user's department

  1. In Active Directory Users and Computers, under Users, double-click the user that you want to update.

  2. Click the Organization tab.

  3. In the Department text box, type the department name that you want to use for this user.

  4. Click OK.

Once you have completed the Active Directory configuration steps, the next step is to grant the appropriate database access to the new Active Directory groups.

Configure SQL Server access

Each data source to which you want to grant user access will need a login in SQL Server or a role in Analysis Services for the corresponding Active Directory group. For AdventureWorks, the databases require the following logins:

  • AdventureWorks database - A login for the AdventureWorksDBUsers Active Directory group

  • AdventureWorks data warehouse - A login for the AdventureWorksDWUsers Active Directory group

Use the following procedure to create a SQL Server login. Follow the procedure for each AdventureWorks databases or each of your own databases.

To create a SQL Server login

  1. Log in to the computer running SQL Server as a SQL Server administrator.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, choose Database Engine from the Server type dropdown list, and then click Connect.

  4. Expand the Security node.

  5. Right-click Logins, and then click New Login.

  6. Click Search.

  7. On the Select User or Group dialog box, click Object Types.

  8. On the Object Types dialog box, select the Groups check box, and then click OK.

  9. On the Select User of Group dialog box, type the name of the Active Directory group for which you want to create the login (for example Contoso\AdvenureWorksDBUsers), and then click OK.

  10. In the Select a page pane, click User Mapping.

  11. Select the check box for the appropriate database (for example, AdventureWorks2012), and then under Database role membership, select the db_datareader check box.

  12. Click OK.

You must also create an Analysis Services role for access to any Analysis Services cubes. For AdventureWorks, the cube requires the following roles for the AdventureWorksOLAPUsers and AdventureWorksOLAPSales Active Directory groups:

  • General Access- this role will be used to give access to the AdventureWorksOLAPUsers group. This will be for users who are not part of the Sales department.

  • Sales Access - this role will be used to give access to the AdventureWorksOLAPSales group. This will be for users who are members of the Sales department.

Use the following procedure to create an Analysis Services role for each Active Directory group. Create roles for the AdventureWorks OLAP cube or for your own Analysis Services cube.

To create an Analysis Services role

  1. Log in to the computer running SQL Server as a SQL Server administrator.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, choose Analysis Services from the Server type dropdown list, and then click Connect.

  4. Expand Databases.

  5. Expand the AdventureWorksDW2012Multidimensional-EE database.

  6. Right-click Roles, and then click New Role.

  7. On the General page, type a name (for example, General Access or Sales Access) in the Role name text box.

  8. Select the Membership page, and then:

    1. Click Add.

    2. On the Select User or Group dialog box, click Object Types.

    3. On the Object Types dialog box, select the Groups check box, and then click OK.

    4. On the Select User of Group dialog box, type the name of the Active Directory group for which you want to create the login (for example Contoso\AdvenureWorksOLAPUsers), and then click OK.

  9. Select the Cube page, and then choose Read from the Access dropdown list for both cubes.

  10. Click OK.

Once the roles have been created, we need to modify the General Access role to limit the data available to members of this role. In this example, we will use an MDX query to remove some fields containing financial information, preventing users who are not from the Sales department from seeing this data.

Use the following procedure to modify the General Access role.

To limit cube access using MDX

  1. In Analysis Services, under the AdventureWorksDW2012Multidimensional-EE database database, double click the General Access role.

  2. Select the Cell Data page in the left pane.

  3. Select the Enable read permissions check box.

  4. In the Allow reading of cube content box, type the following MDX statement:

    Copy code
    NOT Measures.CurrentMember IS Measures.[Total Product Cost] and NOT Measures.CurrentMember IS Measures.[Standard Product Cost] and NOT Measures.CurrentMember IS Measures.[Gross Profit] and NOT Measures.CurrentMember IS Measures.[Gross Profit Margin] and NOT Measures.CurrentMember IS Measures.[Expense to Revenue Ratio]
    Note:

    There is additional financial information in the AdventureWorks OLAP cube, but this MDX statement will remove enough information to be effective for our example.

  5. Click OK.

Once SQL Server and Analysis Services have been configured with the needed logins and roles, the next step is to create a SharePoint list to use for data access requests.

Create a SharePoint list

In the SharePoint list, we need fields that can be used to define a database access request. This includes the alias of the user requesting access, the data source that they wish to access, and an area for them to specify the business justification for the request. We also need a field that the Windows PowerShell script can use to track the status of the request, as well as a field where logging information can be stored.

Use the following procedure to create the SharePoint list. You can add additional fields if you need them, but be sure not to omit any fields or the Windows PowerShell script will not work.

To create a SharePoint list

  1. Go to the site where you want to create the list.

  2. In the left navigation, click Site Contents.

  3. Click add an app.

  4. Click Custom List.

  5. In the Adding Custom List dialog box, type Department Data Access in the Name text box, and then click Create.

    Note:

    You can choose a different name, but you will need to update the list name in the Windows PowerShell script provided later in this article.

  6. On the Site Contents page, click the Department Data Access list.

  7. On the list page, on the List tab in the ribbon, click List Settings.

  8. On the list settings page, under Columns, use the Create column link to create columns as described in the following table.

    Field name Description Options

    Status

    The status of the request.

    Choose the Choice (menu to choose from) option and type New, Succeeded, and Failed for the available choices in the Type each choice on a separate line box. Specify a Default value of New.

    Data Source

    A list of the available data sources.

    Choose the Choice (menu to choose from) option and type AdventureWorks DB, AdventureWorks DW, and AdventureWorks OLAP for the available choices in the Type each choice on a separate line box. (If you are using your own data sources, type those here instead of the AdventureWorks options.)

    User alias

    The alias of the user for whom data access is being requested.

    Use the Single line of text option, and make sure this is a required field by selecting Yes under Require that this column contains information.

    Business justification

    This is an optional field in case you want to keep a record of why a user is requesting data access.

    Use the Multiple lines of text option for this field.

    Log

    A log generated by the Windows PowerShell script describing the actions undertaken by the script.

    Use the Multiple lines of text option for this field.

In order for our Windows PowerShell script to work, the domain proxy account requires read/write access to this list. This is most easily accomplished by granting the account Edit access to the site where the list is located.

To grant access to a site

  1. On the site where the list is located, click Share.

  2. Type the user account for the domain proxy account (for example, contoso\ADProxyAccount).

  3. Click Show Options.

  4. From the Select a group or permission level dropdown list, choose [Edit].

  5. Click Share.

Once you have created the SharePoint list and granted Edit permissions to the domain proxy account, the next step is to automate the process of granting access to the data sources by tying the list together with a Windows PowerShell script. The next section describes the process of creating the script and automating it as a scheduled task.

Automation and scripting

In this section we will:

  1. Create a Windows PowerShell script that reads the SharePoint list and applies the appropriate permissions in Active Directory based on the user's department.

  2. Create a scheduled task in Windows Server that runs the script at a specified interval.

With the script in place and the scheduled task running, users can add their database requests to the SharePoint list and they will be automatically handled within a short time of being added to the list.

Note:

The script performs functions in Active Directory. In order for the Active Directory Windows PowerShell module to load, the Remote Server Administration Tools must be configured on the server where you are going to run the script. Remote Server Administration Tools is a feature that you can add through Server Manager.

Video demonstration

This video shows the steps involved in configuring a Windows PowerShell script that reads the SharePoint list and applies the requested permissions based on the user's department, and configuring a scheduled task to run the Windows PowerShell script. (Time: 11:42.)

Video: Automation and scripting

Video (play button) icon

Create a Windows PowerShell script

To automate the process of granting access to the requested data source, we'll use a Windows PowerShell script. The sample script below performs the following basic functions:

  1. Loads the SharePoint list where users request data access.

  2. Cycles through each list item looking for a status of New.

  3. For each item with a status of New, the script:

    1. Checks the Active Directory department of the user.

    2. If the user specified in the User alias field is in the Sales department, then the user is added to the Active Directory group associated with the data source specified in the Data Source filed.

    3. If the user specified in the User alias field is not in the Sales department and they have requested cube access, then the user is added to the AdventureWorksOLAPUsers Active Directory group, giving them limited cube access.

    4. If the user specified in the User alias field is not in the Sales department and they have requested access to the AdventureWorks database or data warehouse, then the request is denied and a string is added to the log noting that access was denied because they are not in the Sales department.

  4. The status of the list item is changed from New to Succeeded or Failed depending on the outcome.

  5. A brief log of events is written to the Log field in the list item.

  6. An email is sent to the user specified in the User alias field giving the final status of the request.

In this scenario, we deny users access to either of the relational databases if they are not in the Sales department because sensitive financial information exists in these databases and there is no easy way for us to filter that out. In the OLAP cube, however, we have a role set up that excludes the sensitive information, so we can allow non-Sales users access to the cube in a limited fashion.

Use the following procedure to create the Windows PowerShell script. Create the script on your SharePoint Server 2013 application server.

To create a Windows PowerShell script

  1. On the SharePoint Server application server, click Start, click Run, type PowerShell_ISE.exe, and then click OK.

  2. Copy and paste the following script into the Windows PowerShell editor:

    Copy code
    # Add SharePoint and Active Directory cmdlets
if ((Get-PSSnapin "Microsoft.SharePoint.PowerShell" -ErrorAction SilentlyContinue) -eq $null) {
     Add-PSSnapin "Microsoft.SharePoint.PowerShell"
 }
 if ((Get-Module ActiveDirectory -ErrorAction SilentlyContinue) -eq $null) {
     Import-module ActiveDirectory
 }

# Create a SMTP client object for sending final status email
$MailServer = new-object System.Net.Mail.SMTPClient("Contoso-Exch")

# Get-SPWeb for the site where the list is located
$ListWeb = Get-SPWeb http://contoso-appsrv1/sites/BICenter

# Get the list by name
$ListName = $ListWeb.Lists["Department Data Access"]

# Get the list items
$ListItems = $ListName.items

# Loop through each list item
$ListItems | foreach {

$ListItem = $_

# Look for list items with a status of "New"
if($ListItem["Status"] -eq "New") {

    # Clear out the variables for each loop
    $LogText = ""
    $ResultsText = ""
    $ActionStatus = ""
    $ActionTime = ""
    $DataSourceADGroup = ""

    # Add-ADGroupMember requires alias with no domain, so remove the domain\ if it exists
    $SharePointUser = $ListItem["User alias"]
    $SharePointUser = $SharePointUser.ToLower()
    $SharePointUser = $SharePointUser.Replace("contoso\","")

    # Set user's email for status email
    $SharePointUserEmail = $SharePointUser + "@contoso.local"

    # Get the user's department from Active Directory
    $department = Get-ADUser -Identity $SharePointUser -Properties Department
    $department = $department.department

    # Add user request and data source information to the log variable
    $LogText += "User " + $ListItem["User alias"] + " (" + $department + ") requesting access to " + $ListItem["Data Source"] + "`n`r"

    # If the user's department is Sales, then they're allowed full read access to the data source they chose
    if($department -eq "Sales")
    {
        # Determine data source being requested and assign the associated AD group to the $DataSourceADGroup variable
        if($ListItem["Data Source"] -eq "AdventureWorks DB") {$DataSourceADGroup = "AdventureWorksDBUsers"}
        if($ListItem["Data Source"] -eq "AdventureWorks DW") {$DataSourceADGroup = "AdventureWorksDWUsers"}
        if($ListItem["Data Source"] -eq "AdventureWorks OLAP") {$DataSourceADGroup = "AdventureWorksOLAPSales"}

        # Try to add the requested user to the AD group
        try{
            Add-ADGroupMember -Identity $DataSourceADGroup -Members $SharePointUser

            # Note success in the log variable
            $LogText += "Adding " + $ListItem["User alias"] + " to " + $DataSourceADGroup + "`n`r"

            # Note success in the $ActionStatus variable for later update to the SharePoint list
            $ActionStatus = "Succeeded"

            # Note success for the Request results field
            $ResultsText = "Access to " + $ListItem["Data Source"] + " has been granted."
            }
        catch{
            # If Add-ADGroupMember fails, so note in the log variable
            $LogText += "Error: could not add " + $ListItem["User alias"] + " to " + $DataSourceADGroup + ": " + $_ + "`n`r"

            # Note failure in the $ActionStatus variable for later update to the SharePoint list
            $ActionStatus = "Failed"

            # Note in the Results text that there was an error
            $ResultsText = "There was an error in processing your request for access to " + $ListItem["Data Source"] + ". Please contact your administrator"
            }
    }
    else
    # If the user's department is not Sales, then they're only allowed limited read access to the cube
    {

        # If the user is requesting cube access, then attempt to grant that access
        if($ListItem["Data Source"] -eq "AdventureWorks OLAP")
            {
            $DataSourceADGroup = "AdventureWorksOLAPUsers"
            try{
                Add-ADGroupMember -Identity $DataSourceADGroup -Members $SharePointUser

                # Note success in the log variable
                $LogText += "Adding " + $ListItem["User alias"] + " to " + $DataSourceADGroup + "`n`r"

                # Note success in the $ActionStatus variable for later update to the SharePoint list
                $ActionStatus = "Succeeded"

                # Note success in the Results text
                $ResultsText = "Your request for access to " + $ListItem["Data Source"] + " was completed successfully."
                }
            catch{
                # If Add-ADGroupMember fails, so note in the log variable
                $LogText += "Error: could not add " + $ListItem["User alias"] + " to " + $DataSourceADGroup + ": " + $_ + "`n`r"

                # Note failure in the $ActionStatus variable for later update to the SharePoint list
                $ActionStatus = "Failed"

                # Note in the Results text that there was an error
                $ResultsText = "There was an error in processing your request for access to " + $ListItem["Data Source"] + ". Please contact your administrator"
                }
            }

        # If a non-sales user is requesting database access, then access is denied
        else
            {

            # Note in the log that user was denied access to the database because they're not in Sales
            $LogText += "Error: could not add " + $ListItem["User alias"] + " to AdventureWorksDBUsers: User is not in the Sales department `n`r"

            # Uptdate the Results text for the list item and email
            $ResultsText = "Access denied. Access to " + $ListItem["Data Source"] + " is not available to users in " + $department + "."

            # Note failure in the $ActionStatus variable for later update to the SharePoint list
            $ActionStatus = "Failed"
            }
    }

    # Get the current date and time
    $ActionTime = Get-Date

    # Append the date, time, and final status to the log variable
    $LogText += $ActionStatus + " " + $ActionTime

    # Update the list item with the final status and the log text
    $ListItem["Request results"] = $ResultsText
    $ListItem["Status"] = $ActionStatus
    $ListItem["Log"] = $LogText
    $ListItem.Update()

    # Send mail to the user for whom access was requested
    $EmailMessage = new-object System.Net.Mail.MailMessage

    $EmailMessage.From = "DatabaseRequests@contoso.local"
    $EmailMessage.ReplyTo = "DatabaseRequests@contoso.local"
    $EmailMessage.To.Add($SharePointUserEmail)
    $EmailMessage.subject = "Access request for " + $ListItem["Data Source"]
    $EmailMessage.body = "Your reqest for data access had been processed: `n`r"
    $EmailMessage.body += $ResultsText

    $MailServer.Send($EmailMessage)

    }
}

# Clean up the mail server object
$MailServer.Dispose()

  3. Click File, click Save, and save the file to a location on the local disk.

Important:

For test purposes, you can save the Windows PowerShell script to a convenient location. In a production environment, have your domain administrator create a folder that requires domain administrator privileges to access and save the script there. This will increase security and help prevent unauthorized changes to the script.

Depending on your environment, you may need to update the following script items:

  • The URL for the site where the SharePoint list is located is set to http://contoso-appsrv1/sites/BICenter. Update this value to the URL for your environment. This is stored in the $ListName variable.

  • On the line $SharePointUser = $SharePointUser.Replace("contoso\","") you must replace contoso with your domain.

  • The Data Source and $DataSourceADGroup values are configured for the AdventureWorks options discussed in this article. If you are using your own data sources, you must update these values to correspond to your data sources.

  • The $MailServer value must be updated with the name of your mail server.

  • If you named any of the SharePoint list fields differently than those noted in the procedure for creating the list, you must update the script to use the values that you chose. Use the values listed in the procedure for creating the list to find the corresponding values in the script.

Once you have the script saved to your local disk, the next step is to configure the domain proxy account as a script administrator.

Configure a script administrator

In order to successfully run the Windows PowerShell script, the domain proxy account needs permissions to make updates to the SharePoint list using Windows PowerShell. This is accomplished by using the Add-SPShellAdmin Windows PowerShell cmdlet to give the account shell administrator privileges.

Use the following procedure to configure the domain proxy account as a shell administrator.

Note:

If you previously configured the domain proxy account as a shell administrator in another scenario in this series, there is no need to redo the procedure.

To configure a script administrator

  1. Log in to your SharePoint Server application server as a Farm Administrator.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell, and then click Run as administrator.

  3. In the Windows PowerShell command window, type the following syntax:

    Copy code
    Get-SPContentDatabase | Add-SPShellAdmin -UserName domain\username

    For example:

    Copy code
    Get-SPContentDatabase | Add-SPShellAdmin -UserName Contoso\ADProxyAccount

  4. Press Enter.

Once the domain proxy account has been added as a shell administrator, it can be used to run the Windows PowerShell script as part of a scheduled task.

Create a scheduled task

By using a scheduled task to run the Windows PowerShell script on a repeating basis, we can automate the addition of the users requesting data access to the appropriate Active Directory group.

Use the following procedure to create a scheduled task.

To create a scheduled task

  1. Log into your SharePoint Server application server as a local administrator.

  2. Click Start, click Administrative Tools, and then click Task Scheduler.

  3. In the Actions pane, click Create Task.

  4. On the General tab:

    1. Type a name for the task in the Name text box.

    2. Choose the Run whether user is logged on or not option.

    3. Select the Run with highest privileges check box.

  5. On the Triggers tab:

    1. Click New.

    2. Select the Repeat task every check box, and choose 10 minutes from the dropdown list.

    3. Choose Indefinitely from the for a duration of dropdown list.

    4. Click OK.

  6. On the Actions tab:

    1. Click New.

    2. In the Program/script text box, type PowerShell.exe.

    3. In the Add arguments (optional) text box, type the path and filename of your Windows PowerShell script (for example, C:\Scripts\DepartmentDataAccess.PS1))

    4. Click OK.

  7. Click OK.

  8. Type the username and password of the account that you want to run the script. This is the Active Directory domain administrator account that you configured as a Windows PowerShell script administrator.

Once the scheduled task has been created, the setup steps for this scenario are complete. The next step is to test the functionality by adding items to the SharePoint list.

Test and verify functionality

In this section, we'll add some items to the SharePoint list to test the functionality of the script and the scheduled task.

Video demonstration

This video shows some examples of testing this scenario. (Time: 10:20.)

Video: Test and verify functionality

Video (play button) icon

Verifying functionality

Try the following actions to verify that the script and scheduled task are working properly:

  • Add an item to the list. Check the task in Task Scheduler to see when the task is next scheduled to run. Wait until the task has run, then check the SharePoint list to make sure the Status and Log fields have been updated. Check the appropriate Active Directory group to ensure the specified user has been added.

  • Add an item to the list for each data source that you have (the AdventureWorks database, data warehouse, and OLAP cube in our example). In Task Scheduler, right-click the task, and then click Run (to avoid having to wait for the next scheduled time). Check the SharePoint list and Active Directory groups to ensure you're getting the expected results:

    • Users that are members of the Sales department should have their requests completed successfully.

    • Users that are not members of the Sales department should be denied access to the databases, but granted access to the cube via the AdventureWorksOLAPUsers group.

  • Create two identical list items (two requests for the same user and data source). Run the scheduled task. This should produce an error in the second request since the user was already added to the appropriate Active Directory group in the first request. Note that the log entry for the second item specifies this error, which was returned by the Add-ADGroupMember cmdlet.

  • Have the users who have been granted data access try to access the data sources from Excel.

You can confirm that users have varying levels of access to the OLAP cube by having a member of the Sales department create a report in Excel using financial data such as profit margin and then having a user from outside the Sales department attempt to create the same report.

Use the following procedure to create an Excel report using the AdventureWorks OLAP cube. Use a user account that is a member of the Sales department.

To create an Excel report

  1. In Excel, on the Data tab, click From Other Sources, and then click From Analysis Services.

  2. In the Server name box, type the name of the server running Analysis Services, and then click Next.

  3. On the Select Database and Table page, select AdventureWorks, and then click Next.

  4. Choose a name for the connection file, and then click Finish.

  5. On the Import Data dialog box, choose the PivotTable Report option, and then click OK.

  6. In the PivotTable Fields list, select the following check boxes:

    • Sales Territory

    • Sales Amount

    • Gross Profit

A user who is a member of the Sales department should be able to see all of the fields. A user who is not a member of the Sales department should not be able to see the Gross Profit field.


Admin-approved data access using Windows PowerShell

Published: May 28, 2013

Summary: Grant users database access by using Windows PowerShell, a SharePoint list, workflow, and Task Scheduler.

Applies to: SharePoint Server 2013

This scenario describes how to use workflow and a Windows PowerShell script running as a scheduled task to process user requests for access to data sources.

Important:

This scenario applies only to SharePoint Server 2013.

In this article:

  • Scenario overview

  • Before you begin

  • Initial setup

    • Video demonstration

    • Configure Active Directory groups and accounts

    • Configure SQL Server access

    • Create and configure SharePoint lists

  • Automation and scripting

    • Video demonstration

    • Create site workflows

    • Create a Windows PowerShell script

    • Configure a script administrator

    • Create a scheduled task

  • Test and verify functionality

    • Video demonstration

    • Verifying functionality

Scenario overview

This article uses the AdventureWorks sample data set to show an example of automating database access requests using workflow and Windows PowerShell. By using workflow and PowerShell, you can encapsulate your business processes into a pre-defined sequence of events to make sure that they are consistently applied. Using Windows PowerShell also saves on administration time and allows specific Active Directory functions to be performed without the direct involvement of a domain administrator.

This article provides one example of how to use workflow and Windows PowerShell to automate governance processes in an organization. You may want to modify the workflows and the Windows PowerShell script to meet your specific needs.

You can install AdventureWorks and follow the steps in this article to create a working prototype, or you can use your own data sources instead of AdventureWorks.

This article describes how to:

  1. Create a SharePoint list where users can request access to data sources.

  2. Create a SharePoint list where administrators can approve or deny those requests.

  3. Create workflows that copy items between the two lists and emails users and administrators with status and requests.

  4. Create a Windows PowerShell script that, running as a scheduled task, scans the appropriate SharePoint list, and adds approved users to the appropriate Active Directory group to give them the requested data access.

The processes described in this scenario are illustrated in a Business Process Model and Notation (BPMN) diagram that is available for download from the Microsoft Download Center. We recommend that you download this diagram for reference while following the steps in this article. Download the BPMN diagram.

Before you begin

Before starting, note the following:

  • You will need a SharePoint site where you can create SharePoint lists. The procedures in this article assume that you are using a site with the BI Center template, though a Team site will work also. If you want to configure a site with the BI Center template, see Configure a Business Intelligence Center in SharePoint Server 2013.

  • The examples in this article use the AdventureWorks sample data set. You can use AdventureWorks or your own data sources. If you want to install AdventureWorks, see Configure AdventureWorks for Business Intelligence solutions.

  • You will need to create Active Directory accounts and groups as part of the procedures in this article. One of the accounts will need to be added to the Domain Admins group. We recommend using a test environment where you have direct access to a domain controller. Alternatively, you can work with your domain administrator to get the needed accounts and groups configured.

  • You will need a computer running SharePoint Designer 2013 in order to create the workflows.

  • The workflows in this example send emails to the users requesting data access and to the administrators approving or denying those requests. You must have Outgoing E-Mail configured in Central Administration in order for the email functionality to work.

Note:

If you have followed the steps in related articles in this series, some of the users and groups that you are asked to create may already exist in your environment. If that is the case, you can use the existing users and groups. There is no need to recreate existing users and groups.

Initial setup

In this section, we will:

  1. Configure the needed Active Directory accounts and groups.

  2. Configure data access for the Active Directory groups in SQL Server and Analysis Services.

  3. Create a SharePoint list for collecting data access requests and one for administrators to use in approving or denying those requests.

Completing these steps will provide the infrastructure needed for the workflow, Windows PowerShell automation, and task scheduling described in the following section.

Video demonstration

This video shows the steps involved in setting up accounts and groups and creating the SharePoint lists, as described in this article. (Time: 17:30.)

Video: Initial setup

Video (play button) icon

Configure Active Directory groups and accounts

Create an Active Directory group for each data source to which you want to grant access. For AdventureWorks, we'll create Active Directory groups for the following data sources:

  • AdventureWorks database - we'll create a group called AdventureWorksDBUsers

  • AdventureWorks data warehouse - we'll create a group called AdventureWorksDWUsers

  • AdventureWorks OLAP cube- we'll create a group called AdventureWorksOLAPUsers

Use the following procedure to create an Active Directory group. Follow the procedure for each of the AdventureWorks groups listed above or each of your own data sources.

To create an Active Directory group

  1. Log on to a domain controller as a domain administrator.

  2. Click Start, click Administrative Tools, and then click Active Directory Users and Computers.

  3. Expand the domain node.

  4. Right-click Users, click New, and then click Group.

  5. On the New Object - Group dialog box, type a name for the group in the Group name text box, and then click OK.

For this scenario, we also need two domain accounts:

  • A domain administrator account - This account will be used to run a scheduled job that will add users to the Active Directory groups that we created above. You can use an existing domain administrator account, but we recommend that you create a new one specifically for this purpose. We'll refer to this account as the domain proxy account.

  • A workflow proxy account - This account will be used to create the workflows and to run them when users and administrators make updates to the SharePoint lists. This account does not require any specific domain privileges, but does require Edit permissions to the SharePoint site where the lists are located.

Use the following procedure to create each of the Active Directory accounts listed above.

To create an Active Directory account

  1. In Active Directory Users and Computers, right-click Users, click New, and then click User.

  2. In the Full name text box, type a name for the user account (for example, ADProxyAccount or WFProxyAccount).

  3. In the User logon name text box, type a logon name.

  4. Click Next.

  5. Type and confirm a password for the account.

  6. Choose the password options appropriate for your organization, and then click Next.

  7. Click Finish.

You must add the domain proxy account to the Domain Admins group in Active Directory. Use the following procedure to add the account to the Domain Admins group.

To add an account to the Domain Admins group

  1. In Active Directory Users and Computers, under Users, double-click the Domain Admins group.

  2. On the Members tab, click Add.

  3. Type the name of the account that you just created, and then click OK.

  4. Click OK.

Once you have completed the Active Directory configuration steps, the next step is to grant the appropriate database access to the new Active Directory groups.

Configure SQL Server access

Each data source to which you want to grant user access will need a login in SQL Server or a role in Analysis Services for the corresponding Active Directory group. For AdventureWorks, the databases require the following logins:

  • AdventureWorks database - A login for the AdventureWorksDBUsers Active Directory group

  • AdventureWorks data warehouse - A login for the AdventureWorksDWUsers Active Directory group

Use the following procedure to create a SQL Server login. Follow the procedure for each of the AdventureWorks databases or each of your own databases.

To create a SQL Server login

  1. Log in to the computer running SQL Server as a SQL Server administrator.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, choose Database Engine from the Server type dropdown list, and then click Connect.

  4. Expand the Security node.

  5. Right-click Logins, and then click New Login.

  6. Click Search.

  7. On the Select User or Group dialog box, click Object Types.

  8. On the Object Types dialog box, select the Groups check box, and then click OK.

  9. On the Select User of Group dialog box, type the name of the Active Directory group for which you want to create the login (for example Contoso\AdvenureWorksDBUsers), and then click OK.

  10. In the Select a page pane, click User Mapping.

  11. Select the check box for the appropriate database (for example, AdventureWorks2012), and then under Database role membership, select the db_datareader check box.

  12. Click OK.

You must also create an Analysis Services role for access to any Analysis Services cubes. For AdventureWorks, the cube requires a role for the AdventureWorksOLAPUsers Active Directory group.

Use the following procedure to create an Analysis Services role. Create a role for the AdventureWorks OLAP cube or for your own Analysis Services cube.

To create an Analysis Services role

  1. Log in to the computer running SQL Server as a SQL Server administrator.

  2. Click Start, click All Programs, click Microsoft SQL Server 2012, and then click SQL Server Management Studio.

  3. On the Connect to Server dialog box, choose Analysis Services from the Server type dropdown list, and then click Connect.

  4. Expand Databases.

  5. Expand the AdventureWorksDW2012Multidimensional-EE database.

  6. Right-click Roles, and then click New Role.

  7. On the General page, type a name (for example, General Access) in the Role name text box.

  8. Select the Membership page, and then:

    1. Click Add.

    2. On the Select User or Group dialog box, click Object Types.

    3. On the Object Types dialog box, select the Groups check box, and then click OK.

    4. On the Select User of Group dialog box, type the name of the Active Directory group for which you want to create the login (for example Contoso\AdvenureWorksOLAPUsers), and then click OK.

  9. Select the Cube page, and then choose Read from the Access dropdown list for both cubes.

  10. Click OK.

Once SQL Server and Analysis Services have been configure with the needed logins and roles, the next step is to create the SharePoint lists needed to handle the data access requests.

Create and configure SharePoint lists

In this scenario, we need two SharePoint lists:

  • Request list - This list is used by users requiring data access to enter their requests. This list will contain fields that can be used to define a database access request. This includes the alias of the user requesting access, the data source that they wish to access, and an area for them to specify the business justification for the request.

  • Approval list - This list is used by administrators to approve or deny data access requests. It contains all of the fields present in the Request list, plus an additional field that the Windows PowerShell script can use to track the status of the request, as well as a field where logging information can be stored.

Use the following procedure to create the Request list. You can add additional fields if you need them, but be sure not to omit any fields or the Windows PowerShell script will not work.

To create a SharePoint list for access requests

  1. Go to the site where you want to create the list.

  2. In the left navigation, click Site Contents.

  3. Click add an app.

  4. Click Custom List.

  5. In the Adding Custom List dialog box, type Access Requests in the Name text box, and then click Create.

    Note:

    You can choose a different name, but you will need to update the list name in the Windows PowerShell script provided later in this article.

  6. On the Site Contents page, click the Access Requests list.

  7. On the list page, on the List tab in the ribbon, click List Settings.

  8. On the list settings page, under Columns, use the Create column link to create columns as described in the following table.

    Field name Description Options

    Status

    The status of the request.

    Choose the Choice (menu to choose from) option and type New, In Progress, Approved, and Rejected for the available choices in the Type each choice on a separate line box. Specify a Default value of New.

    Data Source

    A list of the available data sources.

    Choose the Choice (menu to choose from) option and type AdventureWorks DB, AdventureWorks DW, and AdventureWorks OLAP for the available choices in the Type each choice on a separate line box. (If you are using your own data sources, type those here instead of the AdventureWorks options.)

    User alias

    The alias of the user for whom data access is being requested.

    Use the Single line of text option, and make sure this is a required field by selecting Yes under Require that this column contains information.

    Business justification

    This is an optional field in case you want to keep a record of why a user is requesting data access.

    Use the Multiple lines of text option for this field.

    Comments

    A place for the requestor to type comments for the administrator.

    Use the Multiple lines of text option for this field.

    Request ID

    A workflow-generated value used to maintain a link between the two lists.

    Use the Single line of text option for this field.

In order for our Windows PowerShell script to work, the domain proxy account requires read/write access to this list. This is most easily accomplished by granting the account Edit access to the site where the list is located.

Likewise, the workflow proxy account must have Design permissions to the site in order to publish workflows.

Follow the procedure for each account, choosing Edit access for the domain proxy account and Design access for the workflow proxy account.

To grant access to a site

  1. On the site where the list is located, click Share.

  2. Type the user account for the domain proxy account (for example, contoso\ADProxyAccount).

  3. Click Show Options.

  4. From the Select a group or permission level dropdown list, choose [Edit] or [Design].

  5. Click Share.

Once you have created the SharePoint list and granted Edit permissions to the domain proxy account, the next step is to create the Approval list for administrators to use in approving or denying database access.

Use the following procedure to create the Approval list. You can add additional fields if you need them, but be sure not to omit any fields or the Windows PowerShell script will not work.

To create a SharePoint list for administrators

  1. Go to the site where you want to create the list.

  2. In the left navigation, click Site Contents.

  3. Click add an app.

  4. Click Custom List.

  5. In the Adding Custom List dialog box, type Access Approval in the Name text box, and then click Create.

    Note:

    You can choose a different name, but you will need to update the list name in the Windows PowerShell script provided later in this article.

  6. On the Site Contents page, click the Access Approval list.

  7. On the list page, on the List tab in the ribbon, click List Settings.

  8. On the list settings page, under Columns, use the Create column link to create columns as described in the following table.

    Field name Description Options

    Status

    The status of the request.

    Choose the Choice (menu to choose from) option and type New, Approved, Rejected, Approved - Pending, and Error for the available choices in the Type each choice on a separate line box. Leave the Default value field blank.

    Data Source

    A list of the available data sources.

    Choose the Choice (menu to choose from) option and type AdventureWorks DB, AdventureWorks DW, and AdventureWorks OLAP for the available choices in the Type each choice on a separate line box. (If you are using your own data sources, type those here instead of the AdventureWorks options.)

    User alias

    The alias of the user for whom data access is being requested.

    Use the Single line of text option, and make sure this is a required field by selecting Yes under Require that this column contains information.

    Business justification

    This is an optional field in case you want to keep a record of why a user is requesting data access.

    Use the Multiple lines of text option for this field.

    Comments

    A place for the administrator to type comments for the requestor.

    Use the Multiple lines of text option for this field.

    Request ID

    A workflow-generated value used to maintain a link between the two lists.

    Use the Single line of text option for this field.

    Log

    A log generated by the Windows PowerShell script describing the actions undertaken by the script.

    Use the Multiple lines of text option for this field.

Since this list is specifically for administrators to use, we must modify the list permissions to prevent the list from inheriting permissions from the parent site, and then grant administrators direct access to the list. We must also grant the workflow proxy account and domain proxy account read/write access to the list so that our workflows and Windows PowerShell script will work properly.

Use the following procedure to modify the list permissions.

To modify list permissions

  1. Go to the Approval list

  2. In the ribbon, on the List tab, click List Settings.

  3. Click Permissions for this list.

  4. In the ribbon, on the Permissions tab, click Stop Inheriting Permissions.

  5. Click OK on the confirmation dialog box.

  6. In the ribbon, on the Permissions tab, click Grant Permissions.

  7. Type the name of the site owner or administrator (for example, the account that you are using to modify the list).

  8. Click Show Options.

  9. From the Select a group or permission level dropdown list, choose Full Control.

  10. Click Share.

  11. Select all of the existing permissions groups (except the user or group that you just added), and then click Remove User Permissions in the ribbon.

    Important:

    If you keep any of the default groups, the list may continue to inherit permissions from the parent site through these groups.

  12. In the ribbon, on the Permissions tab, click Grant Permissions.

  13. Type the names of the domain proxy account and any administrators who will be using the list.

  14. Click Show Options.

  15. From the Select a group or permission level dropdown list, choose Contribute.

  16. Click Share.

  17. In the ribbon, on the Permissions tab, click Grant Permissions.

  18. Type the name of the workflow proxy account.

  19. Click Show Options.

  20. From the Select a group or permission level dropdown list, choose Design.

    Note:

    Because the workflow proxy account will be used to publish workflows from SharePoint Designer, it must have at least Design permissions for the list.

  21. Click Share.

Once you have created the SharePoint lists and granted the necessary permissions to the domain and workflow proxy accounts, the next step is to tie the lists together with workflows and automate the process of granting access to the data sources by using a Windows PowerShell script. The next section describes the process of creating the workflows and script and automating the script as a scheduled task.

Automation and scripting

In this section we will:

  1. Create a Windows PowerShell script that reads the Access Approval list and applies the requested permissions in Active Directory.

  2. Create two workflows to copy list items between the two SharePoint lists.

  3. Create a scheduled task in Windows Server that runs the script at a specified interval.

With the script and workflows in place and the scheduled task running, users can add their database requests to the Access Requests list and they will be automatically copied to the Access Approval list where the administrator can approve or deny them. The script will then apply user permissions for approved users.

Note:

The script performs functions in Active Directory. In order for the Active Directory Windows PowerShell module to load, the Remote Server Administration Tools must be configured on the server where you are going to run the script. Remote Server Administration Tools is a feature that you can add through Server Manager.

Video demonstration

This video shows the steps involved in configuring the workflows, the Windows PowerShell script, and configuring a scheduled task to run the Windows PowerShell script. (Time: 28:02.)

Video: Automation and scripting

Video (play button) icon

Create site workflows

For this scenario, we need to create two workflows:

  • Copy Request - This workflow copies the original data access request from the Access Requests list to the Access Approval list. It also creates a unique ID to tie the two entries together, and sends an email to the administrator notifying them that there is an outstanding request in the Access Approval list that requires their attention.

  • Update Request - This workflow updates the request status for both lists and sends an email to the user for whom data access was requested informing them if their request was approved or denied.

To create each workflow, you must log into a computer that has SharePoint Designer 2013 using the workflow proxy account. It is important to create the workflows using this account so that you can configure the workflows to run under this account.

When completed, the Copy Request workflow should look like the following screenshot.

Screenshot of workflow in SharePoint Designer 2013

Use the following procedure to create the Copy Request workflow.

To create the Copy Request workflow

  1. Log in to a computer with SharePoint Designer 2013 installed using the workflow proxy account.

  2. Click Start, click All Programs, click Microsoft Office 2013, and then click SharePoint Designer 2013.

  3. Click Open Site, type the URL of the site where your SharePoint lists are located, and then click Open.

  4. In the left pane, select Workflows.

  5. In the ribbon, click List Workflow, and then choose the Access Requests list.

  6. On the Create List Workflow dialog box, type Copy Request for the name, choose SharePoint 2010 Workflow for the Platform Type, and then click OK.

  7. Click in the white space above the Step 1 box.

  8. On the ribbon, click Impersonation Step.

  9. Select the Step 1 box, and then in the ribbon, click Delete.

  10. In the Impersonation Step box, click below the line of text.

  11. Add workflow conditions and actions as follows:

    Condition or Action Values Notes

    Condition = If current item field equals value

    Field = Status

    Value = New

    Causes the workflow to run when the status of the saved list item is New.

    Action = Do Calculation

    First value: Data source = Current Item, Field from source = ID.

    Second value: Data source = Current Item, Field = Created.

    Output to new string variable called ReqID

    This action creates a unique identifier that can be used in both lists to link the two related records together.

    Action = Set Field in Current Item

    Field = Request ID

    Value: Data source = Workflow variables and Parameters, Field from source = Variable: ReqID

    This action sets the Request ID field in the current item to the unique ID that we created in the previous step.

    Action = Copy List Item

    First value: Current Item, second value: Access Approval

    This action copies the list item from the Access Requests list to the Access Approval list.

    Action = Update List Item

    List: Current Item

    Add a Value Assignment: Set Status to In Progress

    This action sets the status for the current list item to In Progress.

    Action = Send an Email

    To an administrator with access to the Access Approval list

    This action sends an email to an administrator with access to the Access Approval list. Include text telling the administrator that an access request awaits their action and include a link to the Access Approval list.

  12. Click Copy Request in the breadcrumb on the Copy Request tab.

  13. On the workflow settings page, under Start Options, select the Start workflow automatically when an item is created and Start workflow automatically when an item is changed check boxes.

  14. In the ribbon, click Save, and then click Publish.

  15. Click OK on the impersonation warning dialog box.

Once the Copy Request workflow has been saved and published, the next step is to create the Update Request workflow. When completed, the Update Request workflow should look like the following screenshot.

Screenshot of workflow in SharePoint Designer 2013

Use the following procedure to create the Update Request workflow.

To create the Update Request workflow

  1. In SharePoint Designer 2013, in the left pane, select Workflows.

  2. In the ribbon, click List Workflow, and then choose the Access Approval list.

  3. On the Create List Workflow dialog box, type Update Request for the name, choose SharePoint 2010 Workflow for the Platform Type, and then click OK.

  4. Click in the white space above the Step 1 box.

  5. On the ribbon, click Impersonation Step.

  6. Select the Step 1 box, and then in the ribbon, click Delete.

  7. In the Impersonation Step box, click below the line of text

  8. Add workflow conditions and actions as follows:

    Condition or Action Values Notes

    Condition = If current item field equals value

    Field = Status

    Value = Approved

    Causes this section of the workflow to run when the status of the saved list item is Approved.

    Action = Update List Item

    Add: List = Access Requests, Field = Status, Value = Approved

    Find the List Item: Field = Request ID, Value = lookup of Data Source = Current Item, Field from source = Request ID

    This action updates the Status field in the Access Requests list to Approved.

    We match the Request ID from the Access Approval list to the same field in the Access Request list in order to find the correct item.

    Note that an alert will appear at the end of this step warning that the lookup may not return a single value. In this case, we are using an unique identifier, so only a single value will be returned.

    Action = Set Field in Current Item

    Set Status = Approved - Pending

    This action sets the list item in the Access Approval item to Approved - Pending, which is the value that the Windows PowerShell script looks for.

    Action = Send an Email

    To: Workflow Lookup for a User

    Data source = Current Item, Field from source = User alias

    This action sends an email to the user for whom data access was requested.

    When specifying a user to send the mail to, choose the Workflow Lookup for a User option and use the User alias field from the SharePoint list. Note in the body of the email that the user's access has been approved.

    Condition = If current item field equals value

    Field = Status

    Value = Rejected

    Causes this section of the workflow to run when the status of the saved list item is Approved.

    Be sure to put this condition at the same level as the Item = Approved fork so that this fork appear as an Else if statement.

    Action = Update List Item

    Add: List = Access Requests, Field = Status, Value = Rejected

    Find the List Item: Field = Request ID, Value = lookup of Data Source = Current Item, Field from source = Request ID

    This action updates the Status field in the Access Requests list to Rejected.

    We match the Request ID from the Access Approval list to the same field in the Access Request list in order to find the correct item.

    Note that an alert will appear at the end of this step warning that the lookup may not return a single value. In this case, we are using an unique identifier, so only a single value will be returned.

    Action = Send an Email

    To: Workflow Lookup for a User

    Data source = Current Item, Field from source = User alias

    This action sends an email to the user for whom data access was requested.

    When specifying a user to send the mail to, choose the Workflow Lookup for a User option and use the User alias field from the SharePoint list. Note in the body of the email that the user's access has been approved.

  9. Click Update Request in the breadcrumb on the Update Request tab.

  10. On the workflow settings page, under Start Options, select the Start workflow automatically when an item is created and Start workflow automatically when an item is changed check boxes.

  11. In the ribbon, click Save, and then click Publish.

  12. Click OK on the impersonation warning dialog box.

Create a Windows PowerShell script

To automate the process of granting access to the requested data source, we'll use a Windows PowerShell script. The sample script below performs the following basic functions:

  1. Loads the Access Approval SharePoint list.

  2. Cycles through each list item looking for a status of Approved - Pending (the Status set by the Update Request workflow when an administrator approves a request).

  3. For each item with a status of Approved - Pending, the script adds the user specified in the User alias field to the Active Directory group associated with the data source specified in the Data Source field.

  4. The status of the list item is changed from Approved - Pending to Approved or Error depending on the outcome.

  5. A brief log of events is written to the Log field in the list item.

Use the following procedure to create the Windows PowerShell script. Create the script on your SharePoint Server 2013 application server.

To create a Windows PowerShell script

  1. On the SharePoint Server application server, click Start, click Run, type PowerShell_ISE.exe, and then click OK.

  2. Copy and paste the following script into the Windows PowerShell editor:

    Copy code
    # Add SharePoint and Active Directory cmdlets
if ((Get-PSSnapin "Microsoft.SharePoint.PowerShell" -ErrorAction SilentlyContinue) -eq $null) {
     Add-PSSnapin "Microsoft.SharePoint.PowerShell"
 }
 if ((Get-Module ActiveDirectory -ErrorAction SilentlyContinue) -eq $null) {
     Import-module ActiveDirectory
 }

# Get-SPWeb for the site where the list is located
$ListWeb = Get-SPWeb http://contoso-appsrv1/sites/BICenter

# Get the list by name
$ListName = $ListWeb.Lists["Access Approval"]

# Get the list items
$ListItems = $ListName.items

# Loop through each list item
$ListItems | foreach {

$ListItem = $_

# Look for list items with a status of "Approved - Pending"
if($ListItem["Status"] -eq "Approved - Pending") {

    # Clear out the variables for each loop
    $LogText = ""
    $DataSourceADGroup = ""
    $ActionStatus = ""
    $ActionTime = ""

    # Add-ADGroupMember requires alias with no domain, so remove the domain\ if it exists
    $SharePointUser = $ListItem["User alias"]
    $SharePointUser = $SharePointUser.ToLower()
    $SharePointUser = $SharePointUser.Replace("contoso\","")

    # Determine data source being requested and assign the associated AD group to the $DataSourceADGroup variable
    if($ListItem["Data Source"] -eq "AdventureWorks DB") {$DataSourceADGroup = "AdventureWorksDBUsers"}
    if($ListItem["Data Source"] -eq "AdventureWorks DW") {$DataSourceADGroup = "AdventureWorksDWUsers"}
    if($ListItem["Data Source"] -eq "AdventureWorks OLAP") {$DataSourceADGroup = "AdventureWorksOLAPUsers"}

    # Add user request and data source information to the log variable
    $LogText += "User " + $ListItem["User alias"] + " requesting access to " + $DataSourceADGroup + "`n`r"

    # Try to add the requested user to the AD group
    try{
        Add-ADGroupMember -Identity $DataSourceADGroup -Members $SharePointUser

        # Note success in the log variable
        $LogText += "Adding " + $ListItem["User alias"] + " to " + $DataSourceADGroup + "`n`r"

        # Note success in the $ActionStatus variable for later update to the SharePoint list
        $ActionStatus = "Succeeded"
        }
    catch{
        # If Add-ADGroupMember fails, so note in the log variable
        $LogText += "Error: could not add " + $ListItem["User alias"] + " to " + $DataSourceADGroup + ": " + $_ + "`n`r"

        # Note failure in the $ActionStatus variable for later update to the SharePoint list
        $ActionStatus = "Failed"
        }

    # Get the current date and time
    $ActionTime = Get-Date

    # Append the date, time, and final status to the log variable
    $LogText += $ActionStatus + " " + $ActionTime

    # Update the list item with the final status and the log text
    if($ActionStatus -eq "Succeeded") {$ListItem["Status"] = "Approved"}
    if($ActionStatus -eq "Failed") {$ListItem["Status"] = "Error"}
    $ListItem["Log"] = $LogText
    $ListItem.Update()
    }
}

  3. Click File, click Save, and save the file to a location on the local disk.

Important:

For test purposes, you can save the Windows PowerShell script to a convenient location. In a production environment, have your domain administrator create a folder that requires domain administrator privileges to access and save the script there. This will increase security and help prevent unauthorized changes to the script.

Depending on your environment, you may need to update the following script items:

  • The URL for the site where the SharePoint list is located is set to http://contoso-appsrv1/sites/BICenter. Update this value to the URL for your environment. This is stored in the $ListName variable.

  • On the line $SharePointUser = $SharePointUser.Replace("contoso\","") you must replace contoso with your domain.

  • The Data Source and $DataSourceADGroup values are configured for the AdventureWorks options discussed in this article. If you are using your own data sources, you must update these values to correspond to your data sources.

  • If you named any of the SharePoint list fields differently than those noted in the procedure for creating the list, you must update the script to use the values that you chose. Use the values listed in the procedure for creating the list to find the corresponding values in the script.

Once you have the script saved to your local disk, the next step is to configure the domain proxy account as a script administrator.

Configure a script administrator

In order to successfully run the Windows PowerShell script, the domain proxy account needs permissions to make updates to the SharePoint list using Windows PowerShell. This is accomplished by using the Add-SPShellAdmin Windows PowerShell cmdlet to give the account shell administrator privileges.

Use the following procedure to configure the domain proxy account as a shell administrator.

Note:

If you previously configured the domain proxy account as a shell administrator in another scenario in this series, there is no need to redo the procedure.

To configure a script administrator

  1. Log in to your SharePoint Server application server as a Farm Administrator.

  2. Click Start, click All Programs, click Microsoft SharePoint 2013 Products, right-click SharePoint 2013 Management Shell, and then click Run as administrator.

  3. In the Windows PowerShell command window, type the following syntax:

    Copy code
    Get-SPContentDatabase | Add-SPShellAdmin -UserName domain\username

    For example:

    Copy code
    Get-SPContentDatabase | Add-SPShellAdmin -UserName Contoso\ADProxyAccount

  4. Press Enter.

Once the domain proxy account has been added as a shell administrator, it can be used to run the Windows PowerShell script as part of a scheduled task.

Create a scheduled task

By using a scheduled task to run the Windows PowerShell script on a repeating basis, we can automate the addition of the users requesting data access to the appropriate Active Directory group.

Use the following procedure to create a scheduled task.

To create a scheduled task

  1. Log into your SharePoint Server application server as a local administrator.

  2. Click Start, click Administrative Tools, and then click Task Scheduler.

  3. In the Actions pane, click Create Task.

  4. On the General tab:

    1. Type a name for the task in the Name text box.

    2. Choose the Run whether user is logged on or not option.

    3. Select the Run with highest privileges check box.

  5. On the Triggers tab:

    1. Click New.

    2. Select the Repeat task every check box, and choose 10 minutes from the dropdown list.

    3. Choose Indefinitely from the for a duration of dropdown list.

    4. Click OK.

  6. On the Actions tab:

    1. Click New.

    2. In the Program/script text box, type PowerShell.exe.

    3. In the Add arguments (optional) text box, type the path and filename of your Windows PowerShell script (for example, C:\Scripts\AdminApprovedDataAccess.PS1))

    4. Click OK.

  7. Click OK.

  8. Type the username and password of the account that you want to run the script. This is the Active Directory domain administrator account that you configured as a Windows PowerShell script administrator.

Once the scheduled task has been created, the setup steps for this scenario are complete. The next step is to test the functionality by adding items to the SharePoint list.

Test and verify functionality

In this section, we'll add some items to the SharePoint list to test the functionality of the script and the scheduled task.

Video demonstration

This video shows some examples of testing this scenario. (Time: 9:19.)

Video: Test and verify functionality

Video (play button) icon

Verifying functionality

Try the following actions to verify that the script and scheduled task are working properly:

  • Add an item to the Access Request list with a Status of New. Wait for the Copy Request workflow to complete. Check the Access Approval list to make sure the workflow copied the item correctly. Also check the email of the administrator to whom the workflow sent mail.

  • Have the administrator approve the item in the Access Approval list. Wait for the Update Request workflow to complete. Check the task in Task Scheduler to see when the task is next scheduled to run. Wait until the task has run, then check the SharePoint list to make sure the Status and Log fields have been updated. Check the equivalent item in the Access Request list to ensure that the comments and status have been copied over. Check the appropriate Active Directory group to ensure the specified user has been added.

  • Add an item to the list for each data source that you have (the AdventureWorks database, data warehouse, and OLAP cube in our example). When the Copy Request workflow has completed for each, have the administrator approve or deny each request in the Access Approval list. When the Update Request workflow has completed for each, in Task Scheduler, right-click the task, and then click Run (to avoid having to wait for the next scheduled time). Check both SharePoint lists and the Active Directory groups to ensure you're getting the expected results.

  • Have the users who have been granted data access try to access the data sources from Excel.


Hybrid for SharePoint Server 2013

Updated: August 27, 2013

Summary: Learn about the end-to-end hybrid configuration process and the hybrid solutions available for SharePoint Server 2013 and SharePoint Online.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Server 2013 Standard | Office 365 Enterprise

A hybrid environment that uses SharePoint Server 2013 and SharePoint Online enables solutions that integrate functionality between services and features such as Search, Microsoft Business Connectivity Services, and Duet Enterprise Online for Microsoft SharePoint and SAP in both environments. This article describes the phases, solutions, and functionality that SharePoint Server 2013 and SharePoint Online hybrid environments support.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

The tasks that you must complete to configure a hybrid SharePoint Server 2013 and SharePoint Online environment are divided into three phases, which you must complete in order:

  • Phase 1: Configure the hybrid environment infrastructure.

  • Phase 2: Configure the hybrid identity management infrastructure.

  • Phase 3: Configure a hybrid solution by using Search, Business Connectivity Services, or Duet Enterprise Online.

Important:

The instructions in these articles should not be performed outside the phased, end-to-end deployment for a specific SharePoint 2013 hybrid scenario.

The following table describes each phase and provides links to associated articles.

Phase Topics Notes

Phase 1: Configure the hybrid environment infrastructure

Configure the hybrid environment infrastructure

In Phase 1, you configure the basic infrastructure for a hybrid environment by using SharePoint Server 2013 and SharePoint Online.

This article includes the following information:

  • Learn about requirements, supported features, authentication topologies, testing, and troubleshooting.

  • Configure your on-premises Active Directory Domain Services (AD DS) environment to support single sign-on (SSO) and directory synchronization.

  • Configure your on-premises SharePoint Server 2013 farm and SharePoint Online tenant to support hybrid features and functionality.

  • If required, configure a reverse proxy device.

    For guidance about how to configure a reverse proxy device, see Configure Forefront TMG for a hybrid environment.

After you complete and validate the procedures in this article, you will proceed to Phase 2.

Phase 2: Configure the hybrid identity management infrastructure

Configure the hybrid identity management infrastructure

In Phase 2, you configure identity management for your hybrid environment.

This article includes the following information:

  • Configure SSO for the on-premises AD DS environment and the Office 365 subscription.

  • Configure server-to-server authentication between the on-premises SharePoint Server 2013 farm and SharePoint Online.

After you complete and validate the procedures in this article, you will proceed to Phase 3.

Phase 3: Configure a hybrid solution

In Phase 3, you configure the solution or solutions that best meet your business needs.

Configure a hybrid Search solution

Configure hybrid search for SharePoint Server 2013

This article provides guidance to configure a hybrid Search solution, which enables users to get search results in SharePoint Server 2013 or in SharePoint Online from the SharePoint Server 2013 and SharePoint Online search indexes.

Configure a hybrid Business Connectivity Services (BCS) solution

Deploy a Business Connectivity Services hybrid solution in SharePoint 2013

This article provides guidance to configure a hybrid Business Connectivity Services solution, which enables users to use an app for SharePoint or an external list that is installed on a SharePoint Online site collection to work with data in an on-premises OData service.

Configure a hybrid Duet Enterprise Online solution

Configure hybrid Duet Enterprise Online for SharePoint Server 2013

This article provides guidance to configure a hybrid Duet Enterprise Online solution, which enables SharePoint Online users to perform both read and write operations against an on-premises SAP system.

Videos about hybrid solutions

The following video recordings about hybrid solutions for SharePoint 2013 are available to view online.

Video (play button) icon | Content | Description
 | Overview of Business Connectivity Services in SharePoint 2013 | Watch an overview video about the Business Connectivity Services hybrid solution.
 | Deploy a Business Connectivity Services hybrid solution in SharePoint 2013 | Watch a demonstration of the Business Connectivity Services hybrid scenario.
 | Fast Learner Module: Hybrid for SharePoint Server 2013 and Office 365 | Watch this video to understand the identity management infrastructure requirements and key scenarios for hybrid in SharePoint Server 2013 and Office 365.

Downloadable resources about hybrid solutions

Download the following content about hybrid solutions for SharePoint 2013.

Architecture icon | Content | Description
 | BCS Hybrid Flow Model | Illustrates the Business Connectivity Services hybrid flow in SharePoint 2013. Zoom into the model in full detail with Zoom.it from Microsoft Visio version PDF version
 | Thumbnail picture of Hybrid Topologies model | Helps you decide which hybrid topology is appropriate for your environment. Visio version PDF version

Change History

Date | Description
August 27, 2013 | Added a link to a new model poster: Which hybrid topology should I use for SharePoint Server 2013 with Office 365?
August 20, 2013 | Added links to the video and downloadable content available for Hybrid.
November 9, 2012 | Initial publication


Configure the hybrid environment infrastructure
See also

Updated: August 27, 2013

Summary: Learn how to configure the basic infrastructure for SharePoint 2013 hybrid environments.

Applies to: SharePoint Server 2013 | SharePoint Online

This article provides guidance for Phase 1 of the hybrid environment deployment process, which describes how to configure the basic infrastructure for a hybrid environment using SharePoint Server 2013 and SharePoint Online. After you complete and validate the procedures in this article, you will proceed to Configure the hybrid identity management infrastructure, which provides guidance for Phase 2 of the hybrid configuration process.

Important:

You must begin the hybrid environment configuration process by using this article.

This article provides guidance for the following:

  • Supported features and authentication topologies

  • Required accounts and their roles

  • Configuring your on-premises Active Directory environment to support SSO and directory synchronization

  • Configuring your on-premises SharePoint Server 2013 farm and Office 365 tenant to support hybrid features and functionality

  • Validating your configuration to ensure that the environment is properly prepared for the procedures in Phase 2, Configure the hybrid identity management infrastructure

  • Designing a testing strategy

  • Understanding the available troubleshooting tools and procedures

In this article:

  • Supported features and authentication topologies

  • Before you begin

  • Glossary

  • Accounts for configuration and testing

  • Configure your on-premises environment

  • Configure SharePoint Online

  • Validation and next steps

  • Testing and troubleshooting

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

Supported features and authentication topologies

A hybrid environment using SharePoint Server 2013 and SharePoint Online enables solutions that integrate functionality between services and features in both environments such as Search, Microsoft Business Connectivity Services, and Duet Enterprise Online. This section describes the solutions, functionality and authentication topologies supported for hybrid environments.

A hybrid environment provides three layers of trust and service integration:

  • Domain federation: This layer enables SSO and AD directory synchronization, which provides federated authentication and account synchronization from on-premises AD to Windows Azure Active Directory (Azure AD). Azure AD provides authentication services for Office 365 user accounts and federated accounts from a connected on-premises AD DS domain, and also acts as a trusted token issuer in hybrid environments.

    Note:

    The Azure AD tenancy associated with your Office 365 tenant is not itself an independent tenant, but is rather a unique identifier for your Office 365 tenant within the global Office 365 Azure AD tenant. You cannot perform administrative operations on the Windows Azure AD tenant.

    Integration at this level was also supported in SharePoint Server 2010.

  • Server-to-server (S2S) trust and identity management: This layer enables trusted communications between SharePoint Server 2013 and SharePoint Online, and enables OAuth authentication for federated users.

    Integration at this level is dependent on the Open Authorization 2.0 (OAuth 2.0) web authorization protocol, which is supported in SharePoint Server 2013. SharePoint Server 2010 does not include support for OAuth. For more information about OAuth in SharePoint Server 2013, see Plan authentication in SharePoint 2013.

  • Service integration: This layer enables integration between supported SharePoint Server 2013 and SharePoint Online services such as Search, Business Connectivity Services, and Duet Enterprise Online.

    Integration at this level is dependent on new features and integration support included in SharePoint Server 2013.

A hybrid environment can be configured in any of three authentication topologies: one-way outbound, one-way inbound, or two-way (bidirectional).

Architecture icon

The model poster "Which hybrid topology should I use?" summarizes the points to consider while you decide which hybrid authentication topology is appropriate for your environment. Download the Visio version or PDF version and decide.

Here's a description and diagram for each authentication topology:

  • One-way outbound: A one-way outbound authentication topology enables the on-premises SharePoint Server 2013 farm to connect to SharePoint Online. For example, users of an on-premises SharePoint Server 2013 Enterprise Search portal can see both local and remote search results, but only local results are available in the SharePoint Online search portal.

    This diagram illustrates the connections and solutions supported in a one-way outbound authentication topology.

  • One-way inbound: A one-way inbound authentication topology enables SharePoint Online to connect to SharePoint Server 2013 through a reverse proxy device. For example, users of a SharePoint Online Search portal can see both local and remote search results, but only local results are available in the SharePoint Server 2013 search portal.

    This diagram illustrates the connections and solutions supported in a one-way inbound authentication topology.

  • Two-way (bidirectional): A two-way or bidirectional authentication topology enables hybrid connections between both environments. For example, search can be configured to allow users of either SharePoint Server 2013 or SharePoint Online Search portals to see both local and remote search results. Additionally, if extranet authentication services are configured, this topology also allows extranet users to log in remotely with an on-premises Active Directory account and use all available hybrid functionality.

    This diagram illustrates the connections and solutions supported in a two-way (inbound and outbound) authentication topology.

Configuration details differ substantially between these authentication topologies, and the topology you configure determines the availability and functionality of hybrid solutions.

Hybrid environments using SharePoint Server 2013 and SharePoint Online support the following hybrid solutions and functionality:

Solution Authentication topologies Supported functionality

SharePoint Server 2013 Search

One-way outbound

SharePoint Server 2013 Search services can query SharePoint Online site collections and return federated results to SharePoint Server 2013 Search.

For more information, see Configure hybrid search for SharePoint Server 2013.

One-way inbound

SharePoint Online Search services can query SharePoint Server 2013 site collections and return federated results to SharePoint Online Search.

For more information, see Configure hybrid search for SharePoint Server 2013.

Two-way (bidirectional)

Both SharePoint Server 2013 and SharePoint Online Search services can query site collections in the other environment and return federated results.

For more information, see Configure hybrid search for SharePoint Server 2013.

Business Connectivity Services

One-way inbound or Two-way (bidirectional)

By using an app for SharePoint or an external list that is installed on a SharePoint Online site collection, the SharePoint Online Business Connectivity Services can connect to an on-premises SharePoint Server 2013 farm. The Business Connectivity Services configured on the on-premises farm brokers the connection to on-premises OData Service endpoints, and supports both read and write operations. Business Connectivity Services hybrid solutions can be configured to support full CRUDQ functionality.

For more information, see Deploy a Business Connectivity Services hybrid solution in SharePoint 2013.

Duet Enterprise Online

One-way inbound or Two-way (bidirectional)

By using an app for SharePoint that is installed on a SharePoint Online site collection, or by enabling a Duet Enterprise Online feature, SharePoint Online users can perform both read and write operations against an on-premises SAP system.

For more information, see Configure hybrid Duet Enterprise Online for SharePoint Server 2013.

Note:

Duet Enterprise Online for SharePoint Online is required to support this capability.

For more information about specific requirements for each supported solution, see the Phase 3 solution configuration topics at Hybrid for SharePoint Server 2013.

The following diagram shows the architecture, major topology components and authentication flow in an example of a two-way hybrid authentication topology.

This diagram illustrates the major topology components and authentication flow in a two-way hybrid authentication topology.

Before you begin

To complete the procedures in this set of articles, you will need the following:

  • An operational on-premises AD DS domain in a forest that has a Windows Server 2008, Windows Server 2008 R2 or Windows Server 2012 forest functional level.

  • An on-premises server for AD FS 2.0.

  • An on-premises server for the Windows Azure Directory Synchronization tool.

  • A supported on-premises reverse proxy device.

  • An Internet domain (such as https://adventureworks.com) and access to DNS records for the domain.

  • An operational on-premises SharePoint Server 2013 farm.

  • An X.509 wildcard or SAN certificate issued by a public root authority (if you are configuring an inbound authentication topology).

  • An Office 365 Enterprise subscription that includes a SharePoint Online subscription with 15.0.0.4420 as the minimum build number, and provisioned with SharePoint Online by using one of the following subscription plans:

    • E1 (Search only)

    • E3

    • E4

    For more information about the supported plans, see the Plans & pricing page on the Office 365 site.

    For more information about the SharePoint Online features supported for different Office 365 plans, see SharePoint Online feature availability across Office 365 plans.

    Note:

    To find the build of your Office 365 tenant, navigate to your site collection at https://<your Office 365 domain>/_vti_pvt/service.cnf and find the entry vti_extenderversion:SR. The value following this entry must be at least 15.0.0.4420.

Glossary

This section defines terms you will see in this content and related articles.

Term Definition

Federated user

A federated user is a user whose on-premises Active Directory domain account is synchronized between SharePoint Server 2013 and SharePoint Online, and who accesses resources in both environments by authenticating with the federation identity provider (such as Active Directory Federation Services (AD FS) 2.0).

It is important to test SSO authentication using federated test user accounts because unfederated AD accounts and native Office 365 user accounts are not recognized by both directory services. Therefore, they cannot authenticate using SSO, and cannot be granted permissions to resources in both environments.

Extranet user

An extranet user is an on-premises domain user who accesses secure resources from an unsecured network (such as the Internet), and authenticates using an ADFS proxy server or other identity provider that is accessible from the Internet.

Outbound

Outbound refers to the direction of authentication, and assumes the on-premises environment as the point of reference. An outbound authentication topology enables the on-premises SharePoint Server 2013 farm to make authenticated connections to SharePoint Online. Connections to SharePoint Online that originate from SharePoint Server 2013 are referred to as outbound connections.

Inbound

Inbound refers to the direction of authentication. An inbound authentication topology enables SharePoint Online to make authenticated connections to the on-premises SharePoint Server 2013 farm. Connections to SharePoint Server 2013 that originate from SharePoint Online are referred to as inbound connections.

Primary web application

In a hybrid environment configured for an inbound authentication topology, the primary web application is a single SharePoint Server 2013 web application that is configured for inbound connections, and is used for receiving all inbound connections and for configuring services and connection objects for the hybrid features deployed in the environment.

External endpoint

The external endpoint is the Internet-facing network adapter of the reverse proxy device that you configure to accept inbound connections from SharePoint Online. A DNS record for your public domain resolves the external (public) URL of your SharePoint Server 2013 web application to an IP address bound to this network adapter. Inbound connections addressed to the external URL are received by the external endpoint, and relayed to the SharePoint Server 2013 web application according to the connection rules configured on the reverse proxy device.

External URL

In a hybrid environment configured for an inbound authentication topology, the external URL is the public URL you create in your public DNS domain that resolves to the external endpoint of your reverse proxy device (such as https://external.sharepoint.adventureworks.com). The external URL is also assigned to the primary web application of your on-premises SharePoint Server 2013 farm.

Reverse proxy device

A reverse proxy device is a computer, router, or network service that relays inbound connection requests to an internal server. In a hybrid SharePoint Server 2013 environment, a reverse proxy device is configured to authenticate and relay connections from SharePoint Online to SharePoint Server 2013.

Windows Azure Active Directory

Windows Azure Active Directory (also known as Windows Azure AD, or Access Control Services (ACS)) is the trust broker for both the on-premises SharePoint Server 2013 farm and SharePoint Online. Windows Azure AD is used in a hybrid SharePoint environment as a trusted token issuer, and is used during the user authentication process to sign security tokens on behalf of the on-premises STS Service.

Windows Azure AD also provides account directory services for SharePoint Online.

Accounts for configuration and testing

Configuration of a hybrid environment requires several user accounts in both your on-premises Active Directory and Windows Azure AD directory services, and with different permissions and group or role memberships. Some of these accounts will be used to deploy and configure software, and some are needed for testing specific functionality to ensure that security and authentication systems are functioning as expected.

Note:

This table does not include service accounts, which may be required for specific services in specific hybrid solutions. For more information about specific requirements for each supported solution, see the Phase 3 solution configuration topics at Hybrid for SharePoint Server 2013.

The following table lists the accounts you will need, along with their role and identity provider.

Account Identity provider Role

Domain Administrator

On-premises AD

Use an AD account in the Domain Admins group to configure and test AD, ADFS, DNS, certificates, and other tasks that require elevation.

Global Administrator

Office 365/Windows Azure AD

Use an Office 365 account that has been assigned to the Global Administrator role for Office 365 configuration tasks such as configuring SharePoint Online features, running Windows Azure AD and SharePoint Online PowerShell cmdlets, and testing SharePoint Online.

SharePoint Farm Administrator

On-premises AD

Use an AD account in the Farm Administrators SharePoint group for SharePoint Server 2013 configuration tasks such as running Windows PowerShell cmdlets in the SharePoint Management Shell to configure S2S trusts, create and configure web applications and site collections, deploy and configure SQL Server databases, and troubleshoot SharePoint Server 2013.

This account must also have additional privileges to use the SharePoint Management Shell:

  • Membership in the securityadmin fixed server role on the SQL Server instance

  • Membership in the db_owner fixed database role on all databases that are to be updated

  • Membership in the Administrators group on the server on which you are running the Windows PowerShell cmdlets

For more information on the permissions required to use SharePoint Management Shell, see the Permissions section in Use Windows PowerShell to administer SharePoint 2013.

For more information about required account permissions in SharePoint Server 2013, see Account permissions and security settings in SharePoint 2013

Federated User 1

On-premises AD

Use an AD account in the Domain Users group that has been synchronized with Office 365 to test authentication using SSO, and access to specific resources in both SharePoint Server 2013 and SharePoint Online. Ensure that this account has group memberships and permissions to the site collections and SharePoint resources in both environments. Use this account to test that the account can only view Search results and SharePoint resources to which it has permissions.

Federated User 2

On-premises AD

Configure this account similarly to User 1, but with different permissions or group memberships. Use this account to test for appropriate security trimming and access to site resources.

Configure your on-premises environment

You have to complete several tasks to configure your on-premises environment:

  • Configure basic deployment requirements

  • Create and install certificates

  • Configure SharePoint Server

  • Configure SharePoint Online

  • Configure a reverse proxy device

After you have completed the configuration tasks in this topic, you will be ready for Phase 2, in which you configure identity management for your hybrid scenario. To proceed to Phase 2, see Configure the hybrid identity management infrastructure.

Important:

It is recommended that you thoroughly document your deployment strategy, and that you maintain detailed work logs during the entire hybrid environment configuration process. In any complex implementation project, a detailed record of every design decision, server configuration, procedure and output is a crucial reference for troubleshooting, support and awareness.

Configure basic deployment requirements

To deploy SSO and directory synchronization between SharePoint Server 2013 and SharePoint Online, you must ensure that your on-premises environment meets certain requirements. These requirements may include:

  • A public Internet domain (such as sharepoint.adventureworks.com)

  • An A record in your public domain for the published SharePoint site (such as external.sharepoint.adventureworks.com)

  • A UPN suffix in your on-premises AD domain that matches the public domain (sharepoint.adventureworks.com)

For information on how to prepare your on-premises AD environment, see the Prepare Active Directory section in Prepare for single sign-on.

You can use OnRamp for Office 365 to validate the configuration of your on-premises environment. OnRamp provides browser-based discovery tools to capture key information in your on-premises environment, including specific tests for hybrid environment requirements. It also provides detailed information about required configuration changes and compliance with known limits.

Create and install certificates

X.509 certificates establish server identity and provide authentication for several different services and connections in a SharePoint hybrid environment. These certificates include the following:

  • Secure Channel certificate: This certificate provides authentication and encryption for the secure communication channel between the reverse proxy device and Office 365, acting as both a server and client certificate. It also verifies the identity of the external endpoint used to publish the on-premises SharePoint Server 2013 site collection. This certificate must be either a wildcard or SAN certificate, must be issued by a public root certificate authority, and must use at least 2048-bit encryption.

  • STS certificate: This certificate, which replaces the default SharePoint STS certificate, establishes trust between the on-premises SharePoint site collection and SharePoint Online, and is also used by the STS service and Windows Azure AD to sign security tokens. This certificate must use at least 2048-bit encryption.

Important:

Certificates typically expire at 1-year intervals, so it is important to plan in advance for certificate renewals to avoid service interruptions.

Create and install the Secure Channel certificate

If you are configuring a one-way outbound authentication topology, no Secure Channel certificate is required. If you are configuring a one-way inbound or two-way authentication topology, you must create and install a Secure Channel certificate.

In scenarios where SharePoint Online is configured to request information from SharePoint Server 2013, an SSL certificate is required for three reasons:

  • To encrypt traffic over the secure channel

  • To enable the reverse proxy device to authenticate inbound connections using Certificate Authentication

  • To allow SharePoint Online to identify and trust the external endpoint

The Secure Channel certificate must be stored in both the reverse proxy device, and in a SharePoint OnlineSecure Store target application that you will configure later in this article.

Configuring your environment with a Secure Channel certificate involves the following steps:

  1. Acquire an SSL wildcard or SAN (Subject Alternative Names) certificate for your public domain (for example, *.adventureworks.com) from a well-known certificate authority such as VeriSign. This certificate must support multiple names, and must be at least 2048 bits.

  2. Assign the certificate to the published endpoint of your SharePoint site collection on the reverse proxy device. For more information about reverse proxy certificate configuration and requirements, see the Configure a reverse proxy device section later in this article.

  3. Configure a target application in the SharePoint OnlineSecure Store and install the Secure Channel certificate. For more information, see the Configure SharePoint Online section later in this article.

Create and install the STS certificate

When SharePoint Server 2013 is installed, the Security Token Service (STS) of the on-premises SharePoint farm creates a default certificate to validate incoming tokens. In a hybrid environment, Windows Azure AD acts as a trusted token signing service for SharePoint Server, and uses the STS certificate as the signing certificate. However, Windows Azure AD cannot use the default STS certificate as a signing certificate.

Therefore, you must replace the default STS certificate on each farm server with either a certificate issued by a public certification authority (CA) that is trusted by Windows Azure AD, or with a self-signed certificate. You will replace the default STS certificate in Phase 2 of the hybrid configuration process.

Important:

This certificate must be at least 2048 bits.

We recommend using a certificate issued by a public CA for production environments, both to ensure maximum security, and because self-signed certificates might have integration issues with other applications and services. You can use a self-signed certificate for test or pilot environments.

Important:

You must replace the STS certificate on each server in the SharePoint Server 2013 farm.

Important:

Certificates typically expire at 1-year intervals, so it is important to plan in advance for certificate renewals to avoid service interruptions.

For more information on replacing the STS certificate in a SharePoint Server 2013 farm, see Configure the security token service (http://technet.microsoft.com/library/ee806864.aspx).

Configure SharePoint Server

The following section describes how to prepare your SharePoint Server 2013 farm for use in a hybrid environment.

Note:

The procedures in this section assume that you have an existing SharePoint Server 2013 farm with a web application and site collection you intend to use for hybrid functionality.

All hybrid environments require that certain services are enabled and correctly configured, and certain specific scenarios require additional configuration of your on-premises SharePoint Server 2013 farm. Additionally, Integrated Windows authentication (NTLM) must be enabled for site collections used for hybrid scenarios.

If you plan to configure a one-way inbound or two-way hybrid environment, specific configuration might be required for web application name mapping using either alternate access mappings or host-named site collections.

This section will help you perform the following configuration tasks:

  • Configure the required SharePoint Server 2013 services

  • Configure web application name mapping to support inbound connections

Configure SharePoint services

The following services must be enabled and configured to support hybrid functionality:

  • User Profile Service

  • App Management Service

  • Subscription Settings Service

The User Profile Service must be configured to synchronize user and group profiles from your on-premises Active Directory domain. When federated users access resources in a hybrid environment, the STS Service makes calls to the User Profile Service to acquire user account metadata, such as the UPN and e-mail property values. This metadata is used by the STS Service to construct security tokens during the authentication process.

For information about how to configure user profile synchronization in the User Profile Service, see Synchronize user and group profiles in SharePoint Server 2013.

For complete information about administering the User Profile Service, see Administer the User Profile service in SharePoint Server 2013.

The App Management and Subscription Settings services must be enabled, which requires basic service configuration. These services must be enabled to support certain configuration procedures, and to provide support for registering SharePoint Online as a high-trust app in SharePoint Server 2013.

For information about how to enable and configure the App Management and Subscription Settings services, see the "Configure the Subscription Settings and App Management service applications" section of Configure an environment for apps for SharePoint (SharePoint 2013).

Configure your primary web application

If your hybrid environment is configured for an inbound authentication topology, you must ensure that a single on-premises web application is configured to receive requests from SharePoint Online. This web application is referred to as the primary web application for your hybrid environment.

This section describes how to configure the primary web application to accept requests from the external endpoint URL. No specific web application configuration is required to support a one-way outbound authentication topology.

In a SharePoint Server 2013 hybrid environment, outbound connections can be made from any on-premises SharePoint Server 2013 web application using the feature-specific configurations described in the solution configuration topics. A single SharePoint Server 2013 web application must be configured for inbound connections, and is used as the primary web application for accepting inbound connections and configuring services and connection objects for the hybrid features you deploy. You can either create a new web application and site collection, or configure an existing web application for this purpose.

Web application name mapping

This section describes how to determine if a web application name mapping strategy for the primary web application is required, and how to choose a strategy that best suits your needs.

Inbound requests from SharePoint Online are addressed to the external endpoint URL, and contain the external URL in the request header. In order for SharePoint Server 2013 to process these requests, the primary web application must either contain the root site collection on a SharePoint Server 2013 farm server with the same DNS name as the external endpoint, or be configured to map the external endpoint URL to the internal URL of the web application.

Note:

If the internal web application URL and external endpoint URL are identical, you do not need to configure name mapping.

You can configure name mapping in one of two ways:

  • Using alternate access mapping: Configure alternate access mappings for the web application using the external URL for the Internet Zone. If you choose to use alternate access mappings, the web application must first be extended so that it can be configured to accept connections for both the internal and external URLs. The procedures in this section are primarily focused on configuring alternate access mappings.

  • Using a host-named site collection: Create a new host-named site collection with a host header that is identical to the external endpoint URL.

    Important:

    If you choose to create a host-named site collection, your on-premises DNS server must be configured with a forward lookup zone for the DNS domain you used for your public URL, and an A record in the forward lookup zone that has the IP address of the SharePoint Server 2013 server and the host name of your external endpoint URL.

    To create a host-named site collection, see Plan for host-named site collections (SharePoint Server 2010).

Create or configure the primary web application

Use the information in this section to create or configure a primary web application that you can use with either alternate access mappings or host-named site collections.

Note:

You must complete this step only if you do not plan to use an existing web application as your primary web application, or if the existing web application is configured differently than indicated in this section.

To create a new web application, or to configure an existing web application, use the procedures in Create claims-based web applications in SharePoint 2013. In general, you should use the default settings, but the following configuration settings are required:

  • Under IIS Web Site, in the Port text box, ensure that the value is 80, or the HTTP port specified by your network administrator.

  • Ensure that the Host Header text box is blank.

  • Under Security Configuration, ensure that Allow Anonymous and Use Secure Sockets Layer (SSL) are both set to No.

  • Under Claims Authentication Types, select the Enable Windows Authentication check box, select the Integrated Windows authentication check box, and in the drop-down menu, select NTLM.

  • Under Public URL, ensure that the Zone value is set to Default.

Extend the primary web application and configure alternate access mappings

Use the information in this section to extend your web application to use alternate access mappings, which will create a new IIS web site that is configured with the name of the external URL you created in the Configure basic deployment requirements section. When you have completed this step, you will have two IIS web sites that both use the primary web application to connect to the same content database. The original IIS web site will be configured with the internal URL (such as http://sharepoint.adventureworks.com) in the default zone. By extending the primary web application, you will create a second IIS web site configured with the external URL (such as https://external.sharepoint.adventureworks.com) in the Internet zone.

Important:

Ensure that you perform these procedures on the specific web application you intend to use.

Extend the web application

To extend the web application, use the procedures in Extend claims-based web applications in SharePoint 2013. In general, you should use the default settings, but the following configuration settings are required:

  • Under IIS Web Site, in the Port text box, ensure that the value is set to the appropriate port number for one of the following two choices:

    • If you choose to configure the primary web application for unencrypted HTTP connections, you should use port 80, or the HTTP port specified by your network administrator. All inbound service connections from the reverse proxy device to the web application's site collection will be in the format http://sharepoint.adventureworks.com.

    • If you choose to configure the primary web application for encrypted HTTPS connections, you should use port 443, or the SSL port specified by your network administrator. All inbound service connections from the reverse proxy device to the web application's site collection will be in the format https://sharepoint.adventureworks.com.

  • Under IIS Web Site, in the Host Header text box, type the URL of the internal DNS name of the web application (i.e. https://sharepoint.adventureworks.com).

  • Under Security Configuration, ensure that Allow Anonymous is set to No.

  • Choose the appropriate value for Use Secure Sockets Layer (SSL). If you choose No, the web application will use unencrypted HTTP. If you choose Yes, the web application will use encrypted HTTPS, and you must request and install an SSL certificate to configure SSL for the web application.

    Important:

    If you choose to use SSL, the SSL certificate you bind to the primary web application's IIS web site must contain the external endpoint host name in the Issued To field (for example, sharepoint.adventureworks.com).

    For more information about how to set up SSL, see How to Setup SSL on IIS 7.0.

  • Under Claims Authentication Types, select the Enable Windows Authentication check box, select the Integrated Windows authentication check box, and in the drop-down menu, select NTLM.

  • Under Public URL, in the URL text box, type the external URL (such as https://external.sharepoint.adventureworks.com).

  • Set the Zone value to Internet.

  • Click OK to save your settings.

Configure alternate access mappings

After you have extended the web application, perform the following procedure to enable SharePoint Server 2013 to dynamically translate links in requests using the external URL. Do the following:

  1. In Central Administration, in the Application Management section, click Configure Alternate Access Mappings.

  2. On the Alternate Access Mappings page, click Add Internal URLs.

  3. Under Alternate Access Mapping Collection, ensure that the name of your web application is displayed. If No selection is displayed, click the link and then click Change Alternate Access Mapping Collection.

  4. In the Select An Alternate Access Mapping Collection dialog, click the name of your web application.

  5. Under Add Internal URL, in the URL protocol, host and port text box, type the internal URL of the web application (the Host Header URL you entered in the previous procedure, such as http://sharepoint.adventureworks.com). Ensure that the protocol corresponds to your SSL configuration (http:// or https://).

  6. In the Zone drop-down menu, select Internet.

  7. Click Save.

Restart IIS

After you have configured alternate access mappings, do the following:

  • On the web server, open an elevated Windows command prompt and run iisreset /noforce.

Configure OAuth over HTTP (if required)

OAuth in SharePoint Server 2013 requires HTTPS by default. If you have configured your primary web application to use HTTP for connections with SharePoint Online, you must enable OAuth over HTTP on every web server in your SharePoint Server 2013 farm.

Note:

If you configured your primary web application to use SSL, this step is not required.

To enable OAuth over HTTP, run the following commands as a farm administrator account from the Windows PowerShell command prompt on each web server in your SharePoint Server 2013 farm:

Copy code
$serviceConfig = Get-SPSecurityTokenServiceConfig
$serviceConfig.AllowOAuthOverHttp = $true
$serviceConfig.Update()

If you have enabled OAuth over HTTP for testing, but want to reconfigure your environment to use SSL, you can disable OAuth over HTTP by running the following commands as a farm administrator account from the Windows PowerShell command prompt on each web server in your SharePoint Server 2013 farm:

Copy code
$serviceConfig = Get-SPSecurityTokenServiceConfig
$serviceConfig.AllowOAuthOverHttp = $false
$serviceConfig.Update()

Configure SharePoint Online

If your hybrid environment is configured for either a one-way inbound or two-way authentication topology, you must create a target application in the SharePoint OnlineSecure Store for the Secure Channel certificate described in the Create and install certificates section. If your hybrid environment will only be configured for a one-way outbound authentication topology, you do not need to perform any specific configuration tasks in SharePoint Online in this phase of the hybrid environment configuration, and you can skip to the next section, Configure a reverse proxy device.

This section describes how to create and configure the Secure Store target application in SharePoint Online.

When you configure SharePoint Online for a hybrid environment that provides Search or Business Connectivity Services functionality, you must first acquire a Secure Channel certificate. Then, you must create and configure a target application in the Secure Store Service application in SharePoint Online to store the certificate and enable it to be used by SharePoint Online services. This target application is referred to as the Secure Channel Target App.

Note:

You can use either a Private Information Exchange (.pfx) file or an Internet Security Certificate File (.cer). If you use a .pfx file, you must provide a password for the private key later in this procedure.

When you configure hybrid solutions using the topics in Hybrid for SharePoint Server 2013, you will provide the name of the target application you configure in this step for SharePoint Online search and Business Connectivity Services to use for authentication with the reverse proxy server.

Use the following procedure in SharePoint Online to create a target application for the Secure Channel certificate.

To create a target application to store the reverse proxy certificate

  1. Verify that the user account that is performing this procedure is a global administrator in SharePoint Online.

  2. In the SharePoint Online Administration Center, in the left pane, click secure store.

  3. In the Edit tab, click New to create a Secure Store target application in the Secure Store Service application.

    This creates the Secure Store target application into which you will place the reverse proxy certificate.

  4. In the Target Application Settings section, do the following:

    1. In the Target Application ID text box, type the name (which will be the ID) that you want to use for the target application—for example, SecureChannelTargetApp. Do not use spaces in this name.

      Note:

      You create the ID in this step—you do not get the ID from somewhere else. This ID is a unique target application name that cannot be changed.

    2. In the Display Name text box, type the name that you want to use as the display name for the new target application, for example, Secure Channel Target App.

    3. In the Contact E-mail text box, type the name of the primary contact for this target application.

    4. In the Credential Fields section, name two fields by doing the following:

      1. Under Field Name, in the first row, delete any existing text that is in the text box, and then type Certificate in the text box.

      2. Under Field Type, in the first row, in the drop-down list, select Certificate.

      3. Under Field Name, in the second row, delete any existing text that is in the text box, and then type Certificate Password in the text box.

        Note:

        You must only perform this step if you are importing the certificate from a Private Information Exchange (.pfx) file.

      4. Under Field Type, in the second row, in the drop-down list, select Certificate Password.

    5. In the Target Application Administrators section, in the text box, type the names of users who will have access to manage the settings of this target application. Make sure to add any users who will be testing the hybrid configuration.

    6. In the Members section, in the text box, type the names of Windows Azure AD users and groups mapped to the credentials that are defined for this target application.

      The Office 365 global administrator can create Windows Azure AD groups. These are domain groups, not SharePoint groups.

    7. Click OK.

    8. On the Edit tab, under Target Application ID, do the following:

      1. Select the check box next to the ID of the target application that you created—for example, SecureChannelTargetApp.

      2. On the Edit tab, in the Credentials group, click Set.

    9. In the set credentials for secure store target application dialog box, do the following:

      1. Next to the Certificate Name field, click Browse.

      2. Browse to the location of the certificate that was exported on the computer that hosts the reverse proxy, click the exported certificate, and then click OK.

      3. In the Certificate Password field, type the name of the password of the exported certificate.

        Note:

        You must only perform this step if you are importing the certificate from a Private Information Exchange (.pfx) file.

      4. In the Confirm Certificate Password field, type the name of the password of the exported certificate.

      5. Click OK.

For more information, see Configure the Secure Store Service in SharePoint 2013.

Configure a reverse proxy device

If your planned authentication topology is one-way inbound or two-way, and therefore requires inbound requests from SharePoint Online, you must configure a reverse proxy device to provide a secure Internet endpoint for the connection.

Requirements for a reverse proxy device include:

  • The device must support certificate authentication using a wildcard or SAN X.509 certificate as the client certificate.

  • The device must support or allow passthrough of OAuth 2.0 redirection-based authentication.

  • The device must support preservation of request headers. Requests from SharePoint Online must be received by SharePoint Server 2013 with the original request headers.

  • If the internal and external URLs of your on-premises SharePoint Server 2013 are different, the device must support path mapping and link translation.

Currently, Forefront Threat Management Gateway (TMG) 2010 is the only reverse proxy device for which specific configuration guidance is available. Other devices may support the reverse proxy device requirements as well, but have not yet been tested.

Note:

Microsoft Unified Access Gateway (UAG) is not supported for use as a reverse proxy device in hybrid environments that require certificate authentication.

For guidance on configuring TMG 2010 as a reverse proxy device for your hybrid environment, see Configure Forefront TMG for a hybrid environment.

For complete information about Forefront Threat Management Gateway (TMG) 2010, see Forefront Threat Management Gateway (TMG) 2010.

Validation and next steps

After completing the configuration tasks in this topic, you should validate the following items:

  • Verify that your public domain name can be resolved in DNS

  • If you have configured name mapping for your SharePoint Server web application, verify that you can connect to the web application using both the internal and external URLs.

  • If you have configured a reverse proxy device, verify that you can successfully access your on-premises site collection from the Internet by using the external URL of your reverse proxy endpoint. The computer you use for this validation step must have the Secure Channel certificate installed in the Personal certificate store of the computer account.

After you have completed and validated the configuration tasks in this topic, you will be ready for Phase 2, in which you configure identity management for your hybrid scenario. To proceed to Phase 2, see Configure the hybrid identity management infrastructure.

Testing and troubleshooting

Read this section for guidance on testing and troubleshooting hybrid environments.

Testing

Because a hybrid environment involves a complex security and authentication topology, it is important to test a given scenario to ensure that users can authenticate from expected locations, and that permissions and security trimming produce the expected results. In many cases, the administrator accounts you use to configure different components in the hybrid environment might not be federated, or might not have permissions to certain resources in SharePoint Server or SharePoint Online.

For example, in a two-way Search environment, an Office 365 Global Administrator account cannot be used to test Search queries from a SharePoint Online Search portal that are expected to return results from the on-premises SharePoint Server farm. These queries will be unauthorized because there is no way to add a native Office 365 user account to an on-premises SharePoint group. Similarly, an on-premises domain administrator account is unlikely to be federated, and therefore cannot be assigned permissions in a SharePoint Online site collection configured for hybrid Search. This account cannot successfully use the SharePoint Server Enterprise Search portal to query SharePoint Online.

For these reasons, you should carefully design a test strategy that uses test user accounts that are specifically configured to emulate the authentication and authorization characteristics of a general user in your corporate environment.

It is important to test SSO using a non-administrator federated account to make sure that domain users can successfully authenticate. In some scenarios, it may be necessary to test authentication for federated test users from both on-premises computers and from the Internet to ensure that the federation identity provider is accessible and correctly configured. We recommend that when you design your test strategy, you plan for test client computers that are appropriately connected to either the on-premises network or the Internet/extranet, and ensure that they are configured with the security settings and software that you use in production.

Troubleshooting

Due to the complex technologies and integrations involved in a hybrid deployment, troubleshooting can require a variety of tools and skills. This section provides guidance on some of the tools and resources that can be useful for troubleshooting problems and configuration issues.

A key factor in troubleshooting is ensuring that diagnostic logging is enabled in SharePoint Server, and is configured to log events that can help you identify and resolve issues. For testing purposes, there are certain diagnostic logging categories that should be set to report verbose events to the event log and the trace log. When your testing is complete, you can reconfigure logging to an appropriate level for a production environment.

For more information on configuring diagnostic logging in SharePoint Server, see Configure diagnostic logging in SharePoint 2013.

During testing, you should configure verbose diagnostic logging for the following categories:

  • Secure Store Service: Select this top-level category and all subcategories.

  • SharePoint Foundation: Select this top-level category and all subcategories.

  • Services Infrastructure: Select this top-level category and all subcategories.

  • SharePoint Portal Server: Select the following subcategories:

    • Claims Authentication

    • User Profiles

    • Soap Server Exception

  • SharePoint Server: Select the following subcategories:

    • Distributed Cache

    • Logging Correlation Data

    • Shared Services

  • SharePoint Server Search: If you are configuring a hybrid search solution, select this top-level category and all subcategories.

  • Business Connectivity Services: If you are configuring a hybrid Business Connectivity Services solution, select this top-level category and all subcategories.

  • Duet Enterprise: If you are configuring a hybrid Duet Enterprise solution, select this top-level category and all subcategories.

The following table provides a list of troubleshooting tools that are commonly used to troubleshoot issues in a hybrid environment:

Resource | Scope | Link | Notes
OnRamp | On-premises environment readiness for hybrid integration | OnRamp for Office 365 | OnRamp for Office 365 is an automated assistance tool that helps you gather configuration requirements and perform deployment readiness checks against your on-premises environment.
Microsoft Online Services Diagnostics and Logging (MOSDAL) Support Toolkit | On-premises connectivity with Office 365, SSO | MOSDAL (Microsoft Online Services Diagnostics and Logging) Support Toolkit | The Microsoft Online Services Diagnostics and Logging (MOSDAL) Support Toolkit performs network diagnostics and collects system configuration, network configuration, and logging information for applications that are used to connect to Office 365. Includes the Active Directory Federation Services (AD FS) 2.0 Authentication Diagnostic tool.
Remote Connectivity Analyzer | SSO | Remote Connectivity Analyzer | Remote Connectivity Analyzer is a free connectivity test platform for Office 365. It tests the availability of the required Office 365 SSO service endpoint for expected behavior by acting upon those services from the Internet.
SharePoint Server ULS logs | SharePoint Server | View diagnostic logs in SharePoint 2013 | ULS logs are the single most important source of SharePoint Server troubleshooting information.
ULS Viewer | SharePoint Server | ULS Viewer | ULS Viewer allows users to open SharePoint Server ULS log files and display their contents in a user friendly format, with advanced functions such as filtering, sorting, highlighting, and reading real-time logging data. This tool is indispensable for reading ULS logs.
Log Parser 2.2 | SharePoint Server and other on-premises logs | Log Parser 2.2 | Log parser is a powerful, versatile tool that provides universal query access to text-based data such as log files, XML files and CSV files, as well as key data sources on the Windows operating system such as the Event Log, the Registry, the file system, and Active Directory. For more information about using Log Parser, see Log Parser Examples
Windows PowerShell for SharePoint Online | SharePoint Online | Windows PowerShell for SharePoint Online | You can use the SharePoint Online Management Shell to efficiently manage users, sites, and organizations. Some included cmdlets are useful for returning information for troubleshooting purposes.
Fiddler | Web traffic debugging | Fiddler | Fiddler is a Web Debugging Proxy which logs all HTTP and HTTPS traffic between your computer and the Internet. Fiddler allows you to inspect traffic, set breakpoints, and "fiddle" with incoming or outgoing data.
Microsoft Network Monitor 3.4 | Network protocol analysis | Microsoft Network Monitor 3.4 | Network Monitor 3.4 is a protocol analyzer. It allows you to capture network traffic and view and analyze it, and is extensible with a range of experts and parsers for analysis of specific kinds of traffic.

The following table provides links to web resources that may contain useful troubleshooting information:

Web Resource | Link | Notes
How to update or to repair the configuration of the Office 365 federated domain | http://support.microsoft.com/kb/2647048 | Several scenarios require rebuilding the configuration of the Office 365 federated domain in AD FS 2.0 to correct technical problems. This article contains step-by-step guidance on how to update or to repair the configuration of the Office 365 federated domain.
Tips and FAQs: OAuth and remote apps for SharePoint 2013 | http://msdn.microsoft.com/en-us/library/fp179932.aspx | Get tips and answers to some FAQs for an app for SharePoint that runs in a remote web application and communicates back to SharePoint Server 2013.
Claims authentication does not validate user | Claims authentication does not validate user (SharePoint 2013) | This article describes the tools and techniques that you can use to troubleshoot failed claims-based user authentication attempts in SharePoint Server 2013.
Troubleshooting SharePoint 2013 | Troubleshooting SharePoint 2013 | Find quick access to information about how to resolve issues with deployments of SharePoint Server 2013.
Configure diagnostic logging in SharePoint 2013 | Configure diagnostic logging in SharePoint 2013 | Learn to configure diagnostic logging in SharePoint Server 2013 from the SharePoint Central Administration website or by using Windows PowerShell.

See also

Configure the hybrid identity management infrastructure
Configure Forefront TMG for a hybrid environment

Hybrid for SharePoint Server 2013

Change History

Date | Description
August 27, 2013 | Added a link to a new model poster: Which hybrid topology should I use for SharePoint Server 2013 with Office 365?
April 9, 2013 | Initial publication


Configure the hybrid identity management infrastructure
See also

Published: April 9, 2013

Summary: Learn how to configure the identity management infrastructure for SharePoint 2013 hybrid environments.

Applies to: SharePoint Server 2013 | SharePoint Online

This article describes Phase 2 of the hybrid environment deployment process, in which you configure identity management for a hybrid environment using SharePoint Server 2013 and SharePoint Online. Before you perform the steps in this article, you must have completed and validated the procedures in Configure the hybrid environment infrastructure, which provides guidance for Phase 1 of the hybrid configuration process.

This article will help you perform the following:

  • Configure single sign-on (SSO) for the on-premises Active Directory environment and the Office 365 subscription

  • Configure server-to-server authentication between the on-premises farm and SharePoint Online

There are two parts to configuring identity management for a SharePoint 2013 hybrid environment:

  • Part A: Configure SSO for Office 365

    In Part A, you configure SSO so that intranet or extranet users can access both on-premises SharePoint Server 2013 and SharePoint Online resources using security credentials from your on-premises Active Directory forest.

  • Part B: Configure server-to-server authentication

    In Part B, you configure server-to-server authentication to establish a trust relationship between SharePoint Server 2013 and SharePoint Online so that requests from each environment can be validated by the other. This trust relationship is referred to as an authentication topology, and can be configured to authenticate connections in several different directions.

    For more information about the possible authentication topologies, see the Supported features and authentication topologies section in Configure the hybrid environment infrastructure.

Important:

This article is designed to work together with other SharePoint 2013 hybrid configuration articles. The instructions in this article should not be performed outside the phased, end-to-end deployment for a specific SharePoint 2013 hybrid scenario. For the list of SharePoint 2013 hybrid scenarios, see the solutions listed under Phase 3 in Hybrid for SharePoint Server 2013.

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

Part A: Configure SSO for Office 365

SSO enables users to use their AD DS domain credentials to access servers on the on-premises farm and on Office 365. Without SSO, network administrators would have to maintain a separate set of online accounts and credentials, and users would be prompted to provide online credentials every time they accessed a SharePoint resource on Office 365. SSO also provides the OAuth infrastructure that is used to allow SAML claims to be passed between SharePoint Server 2013 and SharePoint Online.

Note:

In order for federated extranet users to log in remotely using SSO, you must configure your federation identity provider (such as ADFS) to support extranet authentication.

This section will help you to configure domain federation and directory synchronization between your on-premises Active Directory and your Office 365 tenant using Active Directory Federation Services (AD FS) 2.0 and the Windows Azure Active Directory Synchronization tool (previously known as the Microsoft Online Services Directory Synchronization tool).

To configure SSO and directory synchronization for Office 365, complete the procedures in the following articles:

  1. Configure Directory Synchronization

  2. Configure single sign-on

For complete information on planning for directory integration, see Directory integration.

Important:

You can configure directory synchronization to control the user objects that are synchronized with Office 365. For more information, see Configure filtering for directory synchronization.

Validate your SSO configuration

Before you proceed to Part B: Configure server-to-server authentication, validate SSO by completing the following procedures:

  • Use OnRamp for Office 365 to validate the configuration of your on-premises environment. OnRamp provides browser-based discovery tools to capture key information in your on-premises environment, including specific tests for hybrid environment requirements. It also provides detailed information about required configuration changes and compliance with known limits.

  • Verify that federated user accounts can access the on-premises SharePoint Server 2013 farm using SSO.

    • Intranet authentication: A federated user account should be able to log on to a computer in the on-premises intranet and access the SharePoint Server 2013 farm using the external URL without being prompted for credentials.

    • Extranet authentication: If you have configured your federation identity provider to support extranet authentication, a federated user account should be able to log on to a computer on the Internet and access the SharePoint Server 2013 farm using the external URL. Depending on the specific SSO configuration, you may be prompted for credentials by the federation identity provider.

      Note:

      The computer you use for this validation step must have the Secure Channel certificate installed in the Personal certificate store of the computer account.

  • Verify that federated users can access the SharePoint Online site collection without being prompted for credentials.

    • Intranet authentication: A federated user account should be able to log on to a computer in the on-premises intranet and access the SharePoint Online site collection without being prompted for credentials.

    • Extranet authentication: If you have configured your federation identity provider to support extranet authentication, a federated user account should be able to log on to a computer on the Internet and access the SharePoint Online site collection. Depending on the specific SSO configuration, you may be prompted for credentials by the federation identity provider.

  • Verify that the People Picker user interface for the on-premises SharePoint Server 2013 farm shows the users and groups in AD DS.

  • Verify that the People Picker user interface for SharePoint Online shows the federated users and groups in AD DS that have been synchronized with Windows Azure AD.

To troubleshoot SSO issues in Office 365, you can use the Remote Connectivity Analyzer. This browser-based tool provides several connectivity tests, including tests that analyze Office 365 SSO. For more information about the Remote Connectivity Analyzer, see How to diagnose single sign-on (SSO) logon issues in Office 365 by using Remote Connectivity Analyzer

For additional Office 365 SSO troubleshooting information and guidance, see Troubleshoot single sign-on implementation in Office 365.

Part B: Configure server-to-server authentication

This section will help you to configure server-to-server authentication between SharePoint Server 2013, SharePoint Online and Windows Azure AD.

To configure server-to-server authentication for hybrid environments, you have to establish a trust relationship between your on-premises SharePoint Server 2013 farm, your SharePoint Online tenant, and Windows Azure AD. After you establish this relationship, both SharePoint Server 2013 and SharePoint Online trusts the security tokens issued by Windows Azure AD, and SharePoint Online is registered as a high-trust application in SharePoint Server 2013. The security tokens are used by authentication services in both SharePoint Server 2013 and SharePoint Online to grant access to SharePoint resources on behalf of federated users.

Registering SharePoint Online as a high-trust application in SharePoint Server 2013 enables server-to-server authentication using the STS Service for connections between SharePoint Server 2013 and SharePoint Online.

For more information on server-to-server authentication and OAuth in SharePoint Server 2013, see Authorization and authentication for apps in SharePoint 2013.

For more information on high-trust apps in SharePoint Server 2013, see How to: Create high-trust apps for SharePoint 2013 using the server-to-server protocol.

Note:

In the steps in this section, you will open a single Windows PowerShell window on a web server in your SharePoint Server farm. This Windows PowerShell window will have multiple modules and snap-ins loaded to provide concurrent connectivity to SharePoint Server 2013 and SharePoint Online. Authentication to each of these connected environments requires different user accounts, which have the following requirements:

  • The user account you use to connect to your SharePoint Server 2013 farm must be a SharePoint Server farm administrator. The account you use to log in to the farm web server computer is used when you run SharePoint Server 2013 PowerShell cmdlets to configure the SharePoint Server farm.

    This account must also be a member of the local Administrators group on the web server, and have the permissions described in the Permissions section of Use Windows PowerShell to administer SharePoint 2013.

  • The user account you use to connect to your SharePoint Online tenant must be a SharePoint Online global administrator.

For more information on required accounts, see the Accounts for configuration and testing section in Configure the hybrid environment infrastructure.

Tip:

In order to maintain a record of the configuration steps and important command outputs and errors, you should plan to capture the entire contents of the Windows PowerShell buffer to a file before closing the window. This will provide you with a functional history of the configuration session for future reference, and also help you to maintain a running record of the configuration process in the event that the entire process spans multiple sessions.

Step 1. Replace the default STS certificate

In this step, you will replace the default STS certificate of your on-premises farm with a new X.509 certificate, either with a certificate issued by a well-known certification authority, or with a self-signed certificate. This certificate establishes trust between the on-premises SharePoint site collection and SharePoint Online, and is also used by the STS service and Windows Azure AD to sign security tokens.

Important:

Certificates typically expire at 1-year intervals, so it is important to plan in advance for certificate renewals to avoid service interruptions.

When SharePoint Server is installed, the Security Token Service (STS) of the on-premises SharePoint farm creates a default certificate to validate incoming tokens. In a hybrid environment, Windows Azure AD acts as a trusted token signing service for SharePoint Server, and uses the STS certificate as the signing certificate. However, Windows Azure AD cannot use the default STS certificate as a signing certificate because the trust chain of the default certificate is not supported by Windows Azure AD.

Therefore, you must replace the default STS certificate on each farm server with either a certificate issued by a public certification authority (CA) that is trusted by Windows Azure AD, or with a self-signed certificate. This certificate must be at least 2048 bits.

Important:

You must replace the STS certificate on each server in the SharePoint Server 2013 farm.

We recommend using a certificate issued by a public CA for production environments, both to ensure maximum security, and because self-signed certificates might have integration issues with other applications and services. You can use a self-signed certificate for test or pilot environments.

Important:

You will need copies of the new certificate in two formats, a Personal Information Exchange file (.pfx) that includes a private key, and a base-64 encoded Security Certificate file (.cer). Each of these different certificate types is required in later steps.

If you have already replaced the default STS certificate, then skip to the next step.

For more information on replacing the STS certificate in a SharePoint Server 2013 farm, see Configure the security token service (http://technet.microsoft.com/library/ee806864.aspx).

Create a self-signed certificate

The following procedure creates a new certificate in two formats, a Personal Information Exchange file (.pfx) and a Security Certificate file (.cer). Each of these different certificate types is required in later steps.

To generate a self-signed certificate as a Personal Information Exchange (.pfx) file, use the IIS snap-in to complete the following steps:

  1. From the Windows Server desktop on an on-premises SharePoint Server, click Start, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.

  2. In the console tree, click the server name.

  3. In the details pane, double-click Server Certificates in the IIS group.

  4. In the Actions pane, click Create Self-Signed Certificate.

  5. On the Specify Friendly Name page, type a name for the certificate, and then click OK.

  6. In the details pane, right-click the new certificate, and then click Export.

  7. In Export Certificate, specify a path and name to store the .pfx file for the certificate in Export to, and a password for the certificate file in Password and Confirm password. This creates a .pfx file containing the private key.

  8. On the Completing the Certificate Export Wizard page, click Finish, and then click OK twice.

To create a copy of the new certificate in the Security Certificate file (.cer) format, complete the following steps:

  1. From the Windows Server desktop on an on-premises SharePoint Server, click Start, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.

  2. In the console tree, click the server name.

  3. In the details pane, double-click Server Certificates in the IIS group.

  4. In the details pane, right-click the new certificate you created in the previous step, and then click View.

  5. Click the Details tab, and then click Copy to File.

  6. On the Welcome to the Certificate Export Wizard page, click Next.

  7. On the Export Private Key page, click Next.

  8. On the Export File Format page, click Base-64 encoded X.509 (.CER), and then click Next.

  9. On the File to Export page, type a path and file name for the .cer file, and then click Next.

  10. On the Completing the Certificate Export Wizard page, click Finish, and then click OK twice.

Replace the STS certificate

In this section, you will replace the default STS certificate on each farm server with either your new self-signed certificate, or with a certificate obtained from a public CA that is trusted by Windows Azure AD. You will also add the new certificate to the Trusted Root Certificate Authority store on each farm server.

Important:

You must replace the STS certificate on each server in the SharePoint Server 2013 farm.

Caution:

Perform this procedure during a maintenance window because the procedure replaces the STS certificate of the on-premises farm. You must restart both IIS and the SharePoint timer service, which will interrupt service on your SharePoint Server farm.

On each web server in your SharePoint Server farm, supply the required values (indicated in < > placeholders) and run the following commands from the Windows PowerShell command prompt:

Copy code
$pfxPath = "<path to replacement certificate (.pfx file)>"
$pfxPass = "<certificate password>"
$stsCertificate = New-Object System.Security.Cryptography.X509Certificates.X509Certificate2 $pfxPath, $pfxPass, 20
Set-SPSecurityTokenServiceConfig -ImportSigningCertificate $stsCertificate
certutil -addstore -enterprise -f -v root $STScert
iisreset
net stop SPTimerV4
net start SPTimerV4
Note:

These commands will not display any output if they are successful.

To validate this step, on each farm server, type the following command at the Windows PowerShell command prompt:

Copy code
$stscertificate |fl

In the output, confirm that the certificate has the new friendly name.

For more information about replacing the STS certificate in a SharePoint Server farm, see Configure the security token service (http://technet.microsoft.com/library/ee806864.aspx).

Step 2. Install configuration tools

In this step, you will install the following configuration tools on a single SharePoint Server 2013 web server in your on-premises farm:

  • The Microsoft Online Services Sign-In Assistant

  • The Windows Azure Active Directory Module for Windows PowerShell

  • The SharePoint Online Management Shell

Once you have installed these tools, you will then authenticate with your Office 365 tenant. Installing these tools will install the Windows PowerShell modules and snap-ins required to perform the subsequent steps in this article.

  1. Configure remoting in Windows PowerShell.

    On a web server in your on-premises SharePoint Server 2013 farm, run the following commands from the Windows PowerShell command prompt as local computer administrator:

    Copy code
    enable-psremoting
new-pssession

    For more information, see about_Remote_Requirements.

  2. Install the Microsoft Online Services Sign-In Assistant:

    • Microsoft Online Services Sign-In Assistant (IDCRL7) (64 bit version) (http://go.microsoft.com/fwlink/p/?linkid=236300)

      For more information about the Microsoft Online Services Sign-In Assistant, see Microsoft Online Services Sign-In Assistant for IT Professionals.

  3. Install the Windows Azure Active Directory Module for Windows PowerShell:

    • Windows Azure Active Directory Module for Windows PowerShell (64 bit version) (http://go.microsoft.com/fwlink/p/?linkid=236297)

      For more information about Windows Azure Active Directory Module for Windows PowerShell, see Manage Windows Azure Active Directory by using Windows PowerShell.

  4. Install the SharePoint Online Management Shell:

    • SharePoint Online Management Shell (64 bit version)

      For more information about the SharePoint Online Management Shell, see Introduction to the SharePoint Online Management Shell.

  5. From the Windows PowerShell command prompt, run the following commands to load the modules you will use for subsequent configuration steps:

    Copy code
    Add-PSSnapin Microsoft.SharePoint.PowerShell
Import-Module Microsoft.PowerShell.Utility
Import-Module MSOnline -force
Import-Module MSOnlineExtended -force
Import-Module Microsoft.Online.SharePoint.PowerShell -force

  6. Run the following commands to log in to your SharePoint Online tenancy:

    Copy code
    $cred=Get-Credential
Connect-MsolService -Credential $cred

    Type the credentials of your Office 365 global administrator account when you are prompted for credentials.

Leave the Windows PowerShell window open for the following steps. If you need to run any of the following configuration steps again later, you can use the commands in step 5 of this procedure to load the required modules and snap-ins in a new Windows PowerShell window.

Step 3. Set variables

In this step, you create several variables that contain strings that will be used in multiple configuration steps. You must supply the value for the first two commands in the Windows PowerShell code provided in this step, but do not modify any of the code outside the < > brackets.

Note:

If, in the future, you have to perform any of the configuration steps in this article again, you should begin by running the Windows PowerShell commands in this step to repopulate the variables.

These variables include:

  • $spcn The root domain name of your public domain, such as adventureworks.com. You must supply this value in the command that populates this variable. This value should not be in the form of a URL; it should be the domain name only, with no protocol.

  • $spsite The internal URL of your on-premises primary web application, such as https://sharepoint.adventureworks.com. You must supply this value in the command that populates this variable in the form of a full URL as shown (protocol://name). Ensure that you specify the correct protocol in the URL (either http:// or https://).

  • $site The converted URL of your on-premises primary web application. The command that populates this variable converts the value of the $spsite variable to a format that is used by certain commands.

  • $spoappid The SharePoint Online application principal ID (00000003-0000-0ff1-ce00-000000000000). This is a generic value that identifies the SharePoint Online application principal in the global Office 365 farm.

  • $spocontextID The context ID of your SharePoint Online tenant.

  • $metadataEndpoint The URL that is used by your Windows Azure AD proxy to connect to your Windows Azure AD tenancy.

Supply the required values (indicated in < > brackets) and run the following commands from the Windows PowerShell command prompt:

Copy code
$spcn="*.<public_root_domain_name>.com"
$spsite=Get-Spsite <principal_web_application_URL>
$site=Get-Spsite $spsite
$spoappid="00000003-0000-0ff1-ce00-000000000000"
$spocontextID = (Get-MsolCompanyInformation).ObjectID
$metadataEndpoint = "https://accounts.accesscontrol.windows.net/" + $spocontextID + "/metadata/json/1"

When you have run the commands to populate the variables, proceed to the next step.

Step 4. Upload the STS certificate to SharePoint Online

The following commands add the on-premises SharePoint Server STS certificate and private key to the SharePoint Online principal object of the Office 365 tenancy. This enables your SharePoint Server farm and SharePoint Online tenancy to trust connections from each other.

Note:

This procedure uses the STS certificate files in both .pfx and .cer formats that you created in Step 1, and also uses variables that were set in the Replace the STS certificate section in Step 1.

Supply the required values (indicated in < > brackets) and run the following commands from the Windows PowerShell command prompt:

Copy code
$cerPath = "<path to replacement certificate (.cer file)>"
$cer = New-Object System.Security.Cryptography.X509Certificates.X509Certificate2 -ArgumentList $pfxPath, $pfxPass
$cer.Import($cerPath)
$binCert = $cer.GetRawCertData()
$credValue = [System.Convert]::ToBase64String($binCert);
New-MsolServicePrincipalCredential -AppPrincipalId $spoappid -Type asymmetric -Usage Verify -Value $credValue -StartDate <start_date> -EndDate <end_date>
Important:

You must specify values for <start_date> and <end_date> in the final command in the format 00/00/0000 (month/date/year). The <start_date> value should be the current date, and the <end_date> value should be the STS certificate expiration date. However, if you are using a trial Office 365 subscription for testing, the <end_date> value must be set to a date prior to the trial subscription's expiration date, or the command will fail.

For example, if today's date is March 21, 2013, and your Office 365 trial subscription expires on April 19, 2013, the final command would be the following:

New-MsolServicePrincipalCredential -AppPrincipalId $spoappid -Type asymmetric -Usage Verify -Value $credValue -StartDate 3/21/2013 -EndDate 4/18/2013

To validate this step, run the following command:

Copy code
Get-MsolServicePrincipalCredential -AppPrincipalId $spoappid

The expected output is a description of the credential where the Value property matches the thumbprint of the certificate.

Step 5. Add a SPN for your public domain name

These commands add a service principal name (SPN) to the SharePoint Online principal object of the Office 365 tenant. This SPN is composed of two values that are passed to the Set-MsolServicePrincipal cmdlet as variables which you set in Step 2:

  • The SharePoint Online application principal ID (00000003-0000-0ff1-ce00-000000000000)

  • A wildcard value that represents your public root domain name (such as *.adventureworks.com).

This SPN is used by SharePoint Online to verify connections to and from your primary web application. The wildcard value for your public root domain name enables SharePoint Online to verify connections with any host in that domain, which is useful if you ever need to change the host name of your external endpoint or your SharePoint Server 2013 web application in the future.

Run the following commands from the Windows PowerShell command prompt:

Copy code
$msp = Get-MsolServicePrincipal -AppPrincipalId $spoappid
$spns = $msp.ServicePrincipalNames
$spns.Add("$spoappid/$spcn")
Set-MsolServicePrincipal -AppPrincipalId $spoappid -ServicePrincipalNames $spns

To validate this step, run the following commands:

Copy code
$msp = Get-MsolServicePrincipal -AppPrincipalId $spoappid
$spns = $msp.ServicePrincipalNames
$spns

The expected output is a current list of the SPNs for the SharePoint Online principal object of your Office 365 tenant. One SPN should appear that contains your public root domain name preceded by the SharePoint Online application principal ID and /*. as follows:

00000003-0000-0ff1-ce00-000000000000/*.<public domain name>.com

For example, if the external URL of your on-premises SharePoint Server 2013 farm is https://sharepoint.adventureworks.com, then the SPN should look like the following:

00000003-0000-0ff1-ce00-000000000000/*.adventureworks.com

The SPN described should be the only SPN in the output of the validation command that contains your public root domain name.

Step 6. Register the SharePoint Online application principal

This step registers the SharePoint Online application principal object ID with the on-premises SharePoint Application Management Service.

Run the following command from the Windows PowerShell command prompt:

Copy code
$spoappprincipalID = (Get-MsolServicePrincipal -ServicePrincipalName $spoappid).ObjectID
$sponameidentifier = "$spoappprincipalID@$spocontextID"
$appPrincipal = Register-SPAppPrincipal -site $site.rootweb -nameIdentifier $sponameidentifier -displayName "SharePoint Online"

To validate this step, run the following command:

Copy code
$appPrincipal |fl

The expected output is a description of the registered application principal with the name SharePoint Online.

Step 7. Set the SharePoint authentication realm

This step sets the SharePoint authentication realm to the context ID of the organization's Office 365 tenancy.

Run the following command from the Windows PowerShell command prompt:

Copy code
Set-SPAuthenticationRealm -realm $spocontextID

This sets the realm on the on-premises SharePoint Server 2013 farm to the context ID of the SharePoint Online tenancy.

To validate this step, run the following commands:

Copy code
$spocontextID
Get-SPAuthenticationRealm

The expected output of each of these commands is the GUID that represents the context ID of the SharePoint Online tenancy. These GUIDs should be identical.

Important:

If you have configured farm setup scripts that specify the farm authentication realm value, you must now update the setup scripts with this new value. For more information about the requirements for realm values in farm setup scripts, see Plan for server-to-server authentication in SharePoint 2013. Because you have now configured this SharePoint farm to participate in the hybrid configuration, the SharePoint farm authentication realm value must always match the tenant context identifier. If you change this value, the farm will no longer participate in hybrid functionality.

Step 8. Configure an on-premises proxy for Azure AD

This step creates a Windows Azure AD proxy in your SharePoint Server 2013 farm, and configures Windows Azure AD as a trusted token issuer that SharePoint Server 2013 will use both to sign user authentication tokens, and to authenticate tokens from SharePoint Online.

Run the following commands from the Windows PowerShell command prompt:

Copy code
New-SPAzureAccessControlServiceApplicationProxy -Name "ACS" -MetadataServiceEndpointUri $metadataEndpoint -DefaultProxyGroup
New-SPTrustedSecurityTokenIssuer -MetadataEndpoint $metadataEndpoint -IsTrustBroker:$true -Name "ACS"

To validate the New-SPAzureAccessControlServiceApplicationProxy command, perform the following:

  1. On the SharePoint 2013 Central Administration website, click Security.

  2. On the Security page, in the General Security section, click Manage trust.

  3. Verify that an entry exists having a name that begins with ACS and of the type Trusted Service Consumer.

To validate the New-SPTrustedSecurityTokenIssuer command, run the following command:

Copy code
Get-SPTrustedSecurityTokenIssuer

The expected output is a description of the farm's trusted token issuer where the value of the RegisteredIssuerName property is the following:

00000001-0000-0000-c000-000000000000@<context ID>

The second part of the value should match the context ID of your SharePoint Online tenancy.

Validation and next steps

After completing the configuration tasks in this topic, you should validate the following items:

  • Ensure that you have validated your SSO and Directory Synchronization configurations by following the validation procedures in the Validate your SSO configuration section earlier in this article.

  • Verify that the STS Service in your on-premises SharePoint Server 2013 farm is functioning normally.

    You can manually check the STS certificate on each farm server with the following procedure:

    1. Log on to the server using a farm administrator account.

    2. In the SharePoint Management Shell, run the following command:

      Get-ChildItem cert:\LocalMachine\Sharepoint |fl

    3. Verify that the results include a certificate that matches the subject and friendly name of your replacement STS certificate.

  • Verify that you have completed the validation procedures for steps 4 through 8, which are included at the end of the procedure for each step.

  • In order to maintain a record of the configuration steps and important command outputs and errors, you should capture the entire contents of the Windows PowerShell buffer to a file. This will provide you with a functional history of the configuration session for future reference, and also help you to maintain a running record of the configuration process in the event that the entire process spans multiple sessions.

After you have completed and validated the configuration tasks in this topic, your environment is ready for Phase 3 of the hybrid configuration process, in which you configure specific solutions for your hybrid deployment. To proceed to Phase 3, see Hybrid for SharePoint Server 2013.

See also

Configure the hybrid environment infrastructure
Configure Forefront TMG for a hybrid environment

Hybrid for SharePoint Server 2013


Configure Forefront TMG for a hybrid environment
See also

Updated: April 23, 2013

Summary: Learn about the general principles and requirements for reverse proxy devices in a SharePoint 2013 hybrid environment, and how to configure Forefront TMG as a reverse proxy device.

Applies to: SharePoint Server 2013 | SharePoint Online

If your planned authentication topology is one-way inbound or two-way, and therefore requires inbound requests from SharePoint Online, you must configure a reverse proxy device to provide a secure Internet endpoint for the connection.

A reverse proxy device is used to receive incoming requests from the Internet and relay them to servers in your intranet. A reverse proxy device also impersonates your SharePoint Server 2013 farm to resources outside of your business network. For example, in hybrid environments that use either a one-way inbound or two-way authentication topology, SharePoint Online communicates with your reverse proxy as if it were your SharePoint Server 2013 farm, and all requests and responses between the reverse proxy device and your intranet are transparent.

Reverse proxy devices also typically include a firewall, and might also possess other features or services to provide protection from malware and other web-based attacks from the Internet. Some security features might interfere with connections, authentication or other operations that support hybrid connectivity. Before you make any configuration changes to your reverse proxy device that could impact the hybrid environment, you should fully understand their implications, and be prepared to test the environment to ensure that hybrid functionality has not been interrupted or impaired.

For more information on SharePoint 2013 hybrid authentication topologies that require a reverse proxy device, see the Supported features and authentication topologies section in Configure the hybrid environment infrastructure.

Important:

Before you begin the configuration procedures in this article, you must have read the article Configure the hybrid environment infrastructure, and completed all of the procedures up to the Configure a reverse proxy device section. Some of the following configuration steps require that you have already configured URLs and DNS records in both your public Internet domain and your on-premises network, and configured specific services and features in SharePoint Server 2013.

For more information about specialized hybrid-related terms and concepts in this article, see the Glossary section in Configure the hybrid environment infrastructure.

In this article:

  • Reverse proxy requirements

  • Configure Forefront TMG 2010 as a reverse proxy device

    • Install TMG 2010

    • Install the Secure Channel certificate

    • Configure TMG 2010

Reverse proxy requirements

Requirements for a reverse proxy device include:

  • The device must have at least two network adapters installed.

  • The device must support client certificate authentication using a wildcard or SAN X.509 certificate as the client certificate.

  • The device must support or allow passthrough of OAuth 2.0 redirection-based authentication.

  • The device must support preservation of request headers. Requests from SharePoint Online must be received by SharePoint Server 2013 with the original request headers.

  • If the internal and external URLs of your on-premises SharePoint Server 2013 are different, the device must support path mapping and link translation.

  • The device must be able to accept unsolicited inbound traffic from the Internet.

Currently, Forefront Threat Management Gateway (TMG) 2010 is the only supported reverse proxy device for use in a SharePoint 2013 hybrid environment. Other devices and reverse proxy solutions might be compliant with the stated reverse proxy device requirements, but have not yet been tested, and are therefore not currently supported for use in a SharePoint 2013 hybrid environment. Support and guidance for additional reverse proxy devices and solutions will be added as they are tested for compatibility.

Note:

Microsoft Forefront Unified Access Gateway (UAG) is not supported for use as a reverse proxy device in SharePoint Server 2013 hybrid environments.

For complete information about Forefront Threat Management Gateway (TMG) 2010, see Forefront Threat Management Gateway (TMG) 2010.

Configure Forefront TMG 2010 as a reverse proxy device

This section provides guidance for installing and configuring Forefront Threat Management Gateway (TMG) 2010.

Before you begin, you should review the following considerations:

  • TMG should be deployed in an edge configuration, with at least one network adapter connected to the Internet and configured for the External Network in TMG, and at least one network adapter connected to the intranet network and configured for the Internal Network in TMG.

  • The TMG 2010 server must be a domain member in the Active Directory domain forest that contains your Active Directory Federation Services (AD FS) 2.0 server. Domain membership is required to configure TMG to use SSL client certificate authentication for authenticating inbound connections.

    Security

    As a general best practice for edge deployments, it is normally recommended that you install Forefront TMG in a separate forest (rather than in the internal forest of your corporate network), with a one-way trust to the corporate forest. However, you can configure client certificate authentication only for users defined in the Forefront TMG domain, and not for users in the corporate internal domain or forest, which makes this solution impracticable for use in a hybrid environment.

    For more information on TMG network topology considerations, see Workgroup and domain considerations.

  • Although there are no theoretical impediments to deploying TMG 2010 for use in a SharePoint 2013 hybrid environment in a back-to-back configuration, this deployment architecture has not been tested. If you plan to deploy TMG in a back-to-back configuration, or if your existing TMG deployment is configured in a back-to-back architecture, additional configuration might be necessary.

  • TMG 2010 includes both configurable diagnostic logging and a realtime logging interface. These features play an important role in troubleshooting issues with connectivity and authentication between SharePoint Server 2013 and SharePoint Online. When issues arise, identifying the component that is causing the failure can be challenging, and TMG logs can be useful as a first line of defense for establishing the nature of the issue. Troubleshooting can require comparing log events from TMG diagnostic and realtime logs, SharePoint Server 2013 ULS logs, Windows Server event logs, and Internet Information Services (IIS) logs on multiple servers.

    For more information on how to configure and use logging in TMG 2010, see Using diagnostic logging.

    For more information on general TMG 2010 troubleshooting, see Forefront TMG Troubleshooting.

    For more information on troubleshooting techniques and tools for SharePoint 2013 hybrid environments, see the Testing and troubleshooting section in Configure the hybrid environment infrastructure.

Install TMG 2010

If you have not already installed TMG 2010 and configured it for use in your network environment, use the guidance in this section to install TMG 2010 and perform the basic deployment steps to prepare the TMG system for hybrid configuration.

Deploy TMG 2010

  1. Install Forefront TMG 2010, if it is not already installed. For more information on installing TMG 2010, see Forefront TMG Deployment.

  2. Install all available service packs and updates for TMG 2010. For more information, see Installing Forefront TMG Service Packs.

  3. Join the TMG server computer to the on-premises Active Directory domain, if it is not already a domain member.

    For more information on deploying TMG 2010 in a domain environment, see Workgroup and domain considerations.

Install the Secure Channel certificate

In this section, you install the Secure Channel X.509 certificate you created in the Create and install certificates section of Configure the hybrid environment infrastructure to the certificate store on the TMG server. You will use this certificate in the TMG configuration procedure later in this article to configure client certificate authentication for the TMG web listener.

Install the certificate

  1. On the reverse proxy server, open MMC and add the Certificate Management snap-in for both the local computer account and the local fwsrv service account.

    Note:

    After TMG 2010 has been installed, the friendly name of the fwsrv service is the Microsoft Forefront TMG Firewall service.

  2. Import the Secure Channel certificate to the Personal certificate store of the computer account.

  3. Import the Secure Channel certificate to the Personal certificate store of the fwsrv service account.

Configure TMG 2010

In this section, you configure a Web Listener and a Publishing Rule that will receive inbound connections from SharePoint Online and relay them to the primary web application of your SharePoint Server 2013 farm. The web listener and publishing rule work together to define the connection rules and authenticate the session. You will configure the web listener to authenticate inbound connections using the Secure Channel certificate you installed in the previous procedure.

Security

In the following procedure, you can choose to either terminate SSL traffic on TMG or on the SharePoint Server 2013 primary web application. If you terminate SSL traffic on TMG, TMG will relay inbound traffic from SharePoint Online to the SharePoint Server 2013 farm in an unencrypted HTTP session. This is called HTTPS-to-HTTP bridging. If you choose to terminate SSL traffic at the SharePoint Server 2013 primary web application or a load balancer, TMG will create a new HTTPS session for relaying inbound traffic from SharePoint Online to the SharePoint Server 2013 farm (HTTPS-to-HTTPS bridging).

We recommended that you use HTTPS to secure the connection between TMG and the SharePoint Server 2013 farm. Using HTTPS-to-HTTPS bridging encrypts traffic between SharePoint Server 2013 and SharePoint Online, which provides increased security and helps to prevent token replay attacks.

For more information on configuring publishing rules in TMG, see Configuring Web publishing.

For more information on SSL bridging in TMG 2010, see About SSL bridging and publishing.

Use the following procedure to create the publishing rule and web listener.

Create the publishing rule and web listener

  1. In the Forefront TMG Management Console, in the left navigation pane, right-click Firewall Policy, and then click New.

  2. Select SharePoint Site Publishing Rule.

  3. In the New SharePoint Publishing Rule Wizard, in the Name text box, type the name of the publishing rule (for example, Hybrid Publishing Rule). Click Next.

  4. Select Publish a single Web site or load balancer, and then click Next.

  5. To use HTTP for the connection between TMG and your SharePoint Server 2013 farm, select Use non-secured connection to connect the published Web server or server farm, and then click Next.

    To use HTTPS for the connection between TMG and your SharePoint Server 2013 farm, select Use SSL to connect the published Web server or server farm, and then click Next.

    Note:

    If you use SSL, ensure that you have a valid certificate installed on the primary web application.

  6. In the Internal Publishing Details dialog box, in the Internal site name text box, type the internal host name of the primary web application (for example, sharepoint.adventureworks.com), and then click Next. This is the host name in the URL that you configured to accept inbound connections from SharePoint Online when you configured name mapping in the Create or configure the primary web application section of Configure the hybrid environment infrastructure.

    Note:

    Do not type the protocol (http:// or https://).

  7. In the Use a computer name or IP address to connect to the published server box, optionally type the IP address or the Fully Qualified Domain Name (FQDN) of the primary web application or network load balancer, and then click Next.

    Note:

    If TMG can resolve the primary web application using the host name you provided in the previous step, you do not have to perform this step.

  8. In the Public Name Details dialog box, accept the default setting in the Accept requests for menu. In the Public name text box, type the host name of your external URL (for example, sharepoint.adventureworks.com), and then click Next. This is the host name in the external URL that SharePoint Online will use to connect with your SharePoint Server 2013 farm.

    Note:

    Do not type the protocol (http:// or https://).

  9. In the Select a Web Listener dialog box, select New.

  10. In the New Web Listener Wizard dialog box, in the Web listener name text box, type a name for the web listener, and then click Next.

  11. In the Client Connection Security dialog box, select Require SSL secured connections with clients, and then click Next.

  12. In the Web Listener IP Addresses dialog box, select External <All IP addresses> and then click Next.

    If you want to restrict the listener to only listen on a specific external IP address, click the Select IP Addresses button, and in the External Network Listener IP Selection dialog box, select Specified IP addresses on the Forefront TMG computer in the selected network. Click Add to specify an IP address, and then click OK.

  13. In the Listener SSL Certificates dialog box, select Use a single certificate for this Web Listener and click the Select Certificate button. In the Select Certificate dialog box, select the Secure Channel certificate you imported to the TMG computer, click Select, and then click Next.

  14. In the Authentication Settings dialog box, select SSL Client Certificate Authentication, and then click Next. This setting enforces client certificate credentials for inbound connections using the Secure Channel certificate.

  15. Click Next to bypass Forefront TMG Single Sign On settings.

  16. Review the New Listener summary page and click Finish. This will return you to the Publishing Rule Wizard, in which your newly created web listener is automatically selected.

  17. In the Select Web Listener dialog box, in the Web Listener drop-down menu, make sure the correct web listener is selected, and click Next.

  18. In the Authentication Delegation dialog box, select No delegation, but client may authenticate directly from the drop-down menu, and then click Next.

  19. In the Alternate Access Mapping Configuration dialog box, select SharePoint AAM is already configured on the SharePoint server, and then click Next.

  20. In the User Sets dialog box, select the All Authenticated Users entry and click Remove. Then click Add, and in the Add Users dialog box, select All Users, and then click Add. Click Close to close the Add Users dialog box, and then click Next.

  21. In the Completing the New SharePoint Publishing Rule Wizard dialog box, confirm your settings, and then click Finish.

There are several settings that you must now verify or change in the publishing rule you just created.

Finalize the publishing rule configuration

  1. In the Forefront TMG Management Console, in the left navigation pane, select Firewall Policy, and in the Firewall Policy Rules list, right-click the publishing rule you just created and click Configure HTTP.

  2. In the Configure HTTP policy for rule dialog box, in the General tab, under URL Protection, ensure that both Verify normalization and Block high bit characters are unchecked, then click OK.

  3. Right-click the publishing rule you just created again, and click Properties.

  4. In the <rule name> Properties dialog box, in the To tab, uncheck the Forward the original host header instead of the actual one box. Under Proxy requests to published site, ensure that Requests appear to come from the original client is selected.

  5. In the Link Translation tab, ensure that the Apply link translation to this rule check box is set correctly:

    • If the internal URL of your primary web application and the external URL are identical, uncheck the Apply link translation to this rule check box.

    • If the internal URL of your primary web application and the external URL are different, check the Apply link translation to this rule check box.

  6. In the Bridging tab, under Web server, ensure that the correct Redirect requests to <HTTP port or SSL port> check box is checked, and that the port in the text box corresponds to the port your internal site is configured to use.

  7. Click OK to save your changes to the publishing rule.

  8. In the Forefront TMG Management Console, on the top bar, click Apply to apply your changes to TMG. It might take one to two minutes for TMG to process your changes.

  9. To validate your configuration, right-click the new publishing rule from the Firewall Policy Rules list, and click Properties.

  10. In the <rule name> Properties dialog box, click the Test Rule button. TMG will run a series of tests to check for connectivity to the SharePoint site, and will display the results of the tests in a list. Click on each configuration test for a description of the test and its results. Address any errors that appear.

See also

Hybrid for SharePoint Server 2013
Configuring Web publishing
Forefront Threat Management Gateway (TMG) 2010

Change History

Date | Description
April 23, 2013 | Minor revisions to the general reverse proxy requirements.
April 9, 2013 | Initial publication


Configure hybrid search for SharePoint Server 2013
See also

Published: April 9, 2013

Summary: Configure search in a hybrid SharePoint environment so that users can get search results in SharePoint Server 2013 or in SharePoint Online from the SharePoint Server 2013 and SharePoint Online search indexes.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Online

A hybrid SharePoint environment is composed of an on-premises deployment of SharePoint Server 2013 and an instance of Microsoft Office 365 - SharePoint Online. In such an environment, the SharePoint Server 2013 search index and the SharePoint Online search index typically contain different content. The SharePoint Server 2013 search index can contain crawled content from local SharePoint Server sites, file shares, and other sources. The SharePoint Online search index can contain crawled content only from SharePoint Online sites. Hybrid search enables end users to get and view search results from both indexes by performing a single search.

In this article:

  • Configure SharePoint Server 2013 to display hybrid search results

    Use this configuration to enable end users working in the SharePoint Server 2013 deployment to get and view search results from both indexes on a search results page in the SharePoint Server 2013 deployment.

  • Configure SharePoint Online to display hybrid search results

    Use this configuration to enable end users working in SharePoint Online to get and view search results from both indexes on a search results page in SharePoint Online.

You can perform either or both of these configurations. If you do both, you can do either one first, and then do the other one. The procedures for performing each of these configurations are covered in the following sections.

Configure SharePoint Server 2013 to display hybrid search results

To configure SharePoint Server 2013 to display hybrid search results, perform the procedures that are described in the following articles:

  • Phase 1: Configure the hybrid environment infrastructure

    Note:

    If you have already done this configuration, it is not necessary to do it again.

  • Phase 2: Configure the hybrid identity management infrastructure

    Note:

    If you have already done this configuration, it is not necessary to do it again.

  • Phase 3: Display hybrid search results in SharePoint Server 2013

Configure SharePoint Online to display hybrid search results

To configure SharePoint Online to display hybrid search results, perform the procedures that are described in the following articles:

  • Phase 1: Configure the hybrid environment infrastructure

    Note:

    If you have already done this configuration, it is not necessary to do it again. However, in Configure the hybrid environment infrastructure, make sure that you have followed the instructions in Configure a reverse proxy device. This is necessary so that SharePoint Online can send search queries to SharePoint Server 2013 through the reverse proxy device.

  • Phase 2: Configure the hybrid identity management infrastructure

    Note:

    If you have already done this configuration, it is not necessary to do it again.

  • Phase 3: Display hybrid search results in SharePoint Online

See also

Configure hybrid Duet Enterprise Online for SharePoint Server 2013
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013

Hybrid for SharePoint Server 2013


Display hybrid search results in SharePoint Server 2013
See also

Published: April 9, 2013

Summary: Configure search in a hybrid SharePoint environment so that users can get search results in SharePoint Server 2013 from the SharePoint Server 2013 and SharePoint Online search indexes.

Applies to: SharePoint Server 2013 Enterprise | SharePoint Online

A hybrid SharePoint environment is composed of an on-premises deployment of SharePoint Server 2013 and an instance of Microsoft Office 365 - SharePoint Online. In such an environment, the SharePoint Server 2013 search index and the SharePoint Online search index typically contain different content. The SharePoint Server 2013 search index can contain crawled content from local SharePoint Server sites, file shares, and other sources. The SharePoint Online search index can contain crawled content only from SharePoint Online sites.

This article describes how to configure the SharePoint Server 2013 deployment so that end users see search results from both indexes on a search results page in the SharePoint Server 2013 deployment. To do this, you perform the following procedures in the SharePoint Server 2013 deployment:

  • Before you begin

  • Step 1: Create a result source that defines how to get search results from SharePoint Online

  • Step 2: Create a query rule to turn on hybrid search results in SharePoint Server 2013

  • Step 3: Test your configuration for displaying hybrid search results in SharePoint Server 2013

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 2013 Products

  • Keyboard shortcuts

  • Touch

This article assumes the following:

  • There is crawled content in the SharePoint Server 2013 and SharePoint Online search indexes.

  • You have configured the hybrid SharePoint environment as described in the following two articles, and in the following order:

    1. Configure the hybrid environment infrastructure

    2. Configure the hybrid identity management infrastructure

Step 1: Create a result source that defines how to get search results from SharePoint Online

In this procedure, you create a result source in the SharePoint Server 2013 deployment. This result source is a definition that specifies the SharePoint Online URL to get search results from, and the protocol for getting those results.

Result sources can be created at the Search service application level, the site collection level, or the site level. In this procedure, you create the result source at the Search service application level. This will make the result source available to any query rule that is created at the same level, and also to any query rule that is created for a site collection or site that is in a web application that consumes the Search service application.

For more information about result sources, see the following resources:

  • Understanding result sources for search in SharePoint Server 2013

  • Configure result sources for search in SharePoint Server 2013

To create the result source

  1. Verify that the user account that you use to perform this procedure is an administrator for the Search service application that you want to configure.

  2. In the SharePoint Server 2013 deployment, in Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application to which you want to add a result source.

  4. On the Search Administration page for the Search service application, in the Quick Launch, click Result Sources.

  5. On the Manage Result Sources page, click New Result Source.

  6. On the Add Result Sources page, do the following:

    1. In the Name text box, type a name for the new result source — for example, Results from SharePoint Online.

    2. (Optional) In the Description text box, type a description of the new result source.

      This description will appear as a tool tip when the pointer rests on the result source on certain configuration pages.

    3. In the Protocol section, select Remote SharePoint.

    4. In the Remote Service URL section, type the address of the root site collection in SharePoint Online that you want to get search results from, such as https://adventure-works.sharepoint.com.

    5. In the Type section, select SharePoint Search Results.

    6. In the Query Transform section, do one of the following:

      • Keep the default query transform.

        The default transform is {searchTerms}, which is a query variable that stands for the query that the user typed, as it was changed by the most recent query transform.

      • Type a different query transform in the text box, or click Launch Query Builder if you want to use Query Builder to help you configure a query transform.

        Note:

        You can use the query transform to narrow the search results to a specified subset — for example, a subset that is from a particular SharePoint site collection or site. However, if you are not familiar with query transforms in SharePoint 2013, we recommend that you keep the default query transform here. For more information, see the following resources:

        • Plan to transform queries and order results in SharePoint 2013

        • Query variables in SharePoint Server 2013

    7. In the Credentials Information section, select Default Authentication.

    8. Click OK to save the new result source.

Step 2: Create a query rule to turn on hybrid search results in SharePoint Server 2013

In this procedure, you create a query rule in SharePoint Server 2013 that uses the result source that you created in the previous procedure in this article. When the query rule fires, it causes search results from content in the SharePoint Online search index to be displayed in a result block on a search results page in the SharePoint Server 2013 deployment.

Query rules can be created at the Search service application level, the site collection level, or the site level. In this procedure, you create the query rule at the Search service application level. Because you create the rule at this level, the rule can apply to queries that users submit in sites or site collections that consume the Search service application.

For more information about query rules, see the following resources:

  • Plan to transform queries and order results in SharePoint 2013

  • Manage query rules in SharePoint Server 2013

To create the query rule

  1. Verify that the user account that you use to perform this procedure is an administrator for the Search service application that you want to configure.

  2. In the SharePoint Server 2013 deployment, in Central Administration, in the Application Management section, click Manage service applications.

  3. Click the Search service application in which you created a result source in the previous procedure (Step 1: Create a result source that defines how to get search results from SharePoint Online).

  4. On the Search Administration page for the Search service application, in the Quick Launch, click Query rules.

  5. On the Manage Query Rules page, do the following:

    1. In the Select a Result Source drop-down list, select a result source for which you want this query rule to be applicable.

      For example, if you select the Local SharePoint Results result source, the rule will be applicable when a user performs a query in the Everything search vertical in the enterprise Search Center, because that vertical uses the Local SharePoint Results result source by default.

      Note:

      On the Add Query Rule page, in the Context section, you will be able to add or remove result sources for which you want the rule to be applicable.

    2. Click New Query Rule.

  6. On the Add Query Rule page, do the following:

    1. In the General Information section, in the Rule Name text box, type a name for the new query rule — for example, Show SharePoint Online results in result block.

    2. If the Context section is collapsed, click the arrow next to Context to expand it.

    3. In the Context section, do the following:

      1. Under Query is on these sources, do one of the following:

        • Select All sources if you want this query rule to be applicable for queries that users submit against any result source.

        • Select One of these sources, and then optionally click Add Source to add other result sources for which you want the query rule to be applicable.

          Note:

          When you select One of these sources, this rule will be applicable only when a user submits a query against one of the result sources in the list. Therefore, make sure that the result sources appear for which you want this query rule to be applicable.

      2. (Optional) Under Query is performed from these categories, specify the topic categories (based on terms for topic categories in the term store of a Managed Metadata service application) to perform the query from.

      3. (Optional) Under Query is performed by these user segments, define user segments (based on terms that describe users in the term store of a Managed Metadata service application) to which you want the query rule to apply.

    4. In the Query Conditions section, specify conditions to control when the rule will fire, or click Remove Condition if you want the rule to fire for any query text.

      For testing, we recommend that you click Remove Condition so that the rule will fire for any query text.

    5. In the Actions section, under Result Blocks, click Add Result Block.

    6. In the Add Result Block dialog box, do the following:

      1. (Optional) In the Block Title section, in the Title text box, change the title to the text that you would like to display above the result block on the search results page, such as Results for "{subjectTerms}" from SharePoint Online.

      2. In the Query section, in the Configure Query text box, do one of the following:

        • Keep the default query, which is {subjectTerms}.

          Note:

          If you are not familiar with transforming queries in SharePoint 2013, we recommend that you keep the default query here, namely {subjectTerms}. For more information, see the following resources:

          • Plan to transform queries and order results in SharePoint 2013

          • Query variables in SharePoint Server 2013

        • Type a different query in the text box, or click Launch Query Builder if you want to use Query Builder to help you configure a query.

      3. In the Query section, in the Search this Source drop-down list, select the name of the result source that you created in Step 1: Create a result source that defines how to get search results from SharePoint Online — for example, Results from SharePoint Online.

      4. In the Query section, in the Items drop-down list, select the number of search results from SharePoint Online that you want to show in this result block on the search results page. For example, select 3 to display three results from SharePoint Online in this result block.

      5. In the Settings section, do the following:

        1. If you want to display a Show More link at the bottom of the result block, select More link goes to the following URL, and type the URL for the link to a page that displays more results from the SharePoint Online search index.

          When end users click Show More, they will see more results for the result block.

        2. For the placement of the block of results from SharePoint Online relative to the results from SharePoint Server 2013, do one of the following:

          • Select This block is always shown above core results to display the result block at or near the top of the first page of search results.

            In this case, core results are the results from the SharePoint Server 2013 search index. This option is useful for testing, or when most of the relevant content is located in the remote search index in the hybrid environment. If you select this option for more than one result block, you can configure the order in which the result blocks are displayed by ranking the associated query rules.

          • Select This block is ranked within core results (may not show) to display the result block such that it is ranked by relevance compared to core results, in which case the result block might not appear on the first page of search results.

            This is the default setting and is typically the more appropriate choice in a production environment. As with individual results, the rank of the result block might be different when users perform the same query later. For example, if users click search results in the result block, the result block will be ranked higher in the search results over time. Otherwise, the result block will be ranked lower over time.

        3. (Optional) In the Group Display Template URL text box, specify a different URL for the group display template.

        4. (Optional) In the Item Display Template text box, specify an item display template.

      6. Skip the Routing section.

      7. Click OK to add the result block.

    7. On the Add Query Rule page, in the Publishing section, do the following:

      1. Select Is Active. When a query rule is active, it fires whenever the query conditions are met.

      2. (Optional) Specify a Start Date, an End Date, a Review Date, and a Contact.

        The start date and end date specify when the query rule will be active. If you do not specify a start date, the rule will be active until an end date that you specify. If you specify a start date without an end date, the rule will always be active after the start date. If you specify an end date without a start date, the rule will always be active until the end date. If you do not specify a start date or an end date, the rule will always be active.

    8. Click Save.

After a few moments, when federated end users submit queries in the SharePoint Server 2013 deployment against a result source that you specified in step 6 of this procedure, they will see results from both search indexes on a search results page in the SharePoint Server 2013 deployment. Also, the refinement panel on the search results page automatically merges item counts and values for all of the search results and thus provides filtering for the results from both search indexes.

Note:

A federated user is a user whose on-premises Active Directory Domain Services (AD DS) domain account is synchronized between SharePoint Server 2013 and SharePoint Online, and who accesses resources in both environments by authenticating with the federation identity provider, such as Active Directory Federation Services (AD FS) 2.0.

Step 3: Test your configuration for displaying hybrid search results in SharePoint Server 2013

To validate your configuration for displaying hybrid search results from SharePoint Server 2013 and SharePoint Online, you can log on to SharePoint Server 2013 as a federated end user and try some searches from the enterprise Search Center. Use the following procedure to validate your configuration in this way.

Important:

It is important to test single sign-on (SSO) authentication by using federated user accounts. Native Office 365 user accounts and AD accounts that are not federated are not recognized by both directory services. Therefore, they cannot authenticate using SSO, and cannot be granted permissions to resources in both environments. For more information, see Accounts for configuration and testing and Testing and troubleshooting in Configure the hybrid environment infrastructure.

To test your configuration

  1. Log on to the SharePoint Server 2013 deployment as a federated end user who has been activated in SharePoint Online, and who has permissions to view the root site collection in SharePoint Online.

  2. Go to the enterprise Search Center in the SharePoint Server 2013 deployment.

  3. In the enterprise Search Center, do the following:

    1. Click a search vertical that uses a result source that you specified in step 6 of the previous procedure.

    2. In the search box, type a test query, such as the name of your company.

      Make sure that the test query should yield search results from the SharePoint Server 2013 search index and the SharePoint Online search index.

    3. Click the search icon, or press Enter.

  4. On the search results page, you should see results from the SharePoint Server 2013 search index and a result block of results from the SharePoint Online search index.

  5. If you do not see results from both search indexes on the search results page, do the following:

    1. Verify each of the following:

      • The search system in SharePoint Server 2013 has crawled the local content. For information about how to view the crawl log, see Crawl log in View search diagnostics in SharePoint Server 2013.

      • You have configured the hybrid SharePoint environment as described in the following articles, and in the following order:

        1. Configure the hybrid environment infrastructure

        2. Configure the hybrid identity management infrastructure

      • You have configured Search features and functionality as described in this article.

    2. Correct any errors or omissions and try a search again.

  6. If you still do not see search results from both search indexes, check the SharePoint Unified Logging Service (ULS) logs, also called the SharePoint trace logs.

    For more information, see Overview of Unified Logging System (ULS) Logging (http://msdn.microsoft.com/en-us/library/ff512738(v=office.14).aspx).

See also

Configure the hybrid environment infrastructure
Configure the hybrid identity management infrastructure
Configure Forefront TMG for a hybrid environment
Configure hybrid search for SharePoint Server 2013
Display hybrid search results in SharePoint Online
Configure hybrid Duet Enterprise Online for SharePoint Server 2013
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013

Hybrid for SharePoint Server 2013


Display hybrid search results in SharePoint Online
See also

Published: April 9, 2013

Summary: Configure search in a hybrid SharePoint environment so that users can get search results in SharePoint Online from the SharePoint Server 2013 and SharePoint Online search indexes.

Applies to: SharePoint Online | SharePoint Server 2013 Enterprise

A hybrid SharePoint environment is composed of an on-premises deployment of SharePoint Server 2013 and an instance of Microsoft Office 365 - SharePoint Online. In such an environment, the SharePoint Server 2013 search index and the SharePoint Online search index typically contain different content. The SharePoint Server 2013 search index can contain crawled content from local SharePoint Server sites, file shares, and other sources. The SharePoint Online search index can contain crawled content only from SharePoint Online sites.

This article describes how to configure SharePoint Online so that end users see search results from both indexes on a search results page in SharePoint Online. To do this, you perform the following procedures in SharePoint Online:

  • Before you begin

  • Step 1: Create a result source that defines how to get search results from SharePoint Server 2013

  • Step 2: Create a query rule to turn on hybrid search results in SharePoint Online

  • Step 3: Test your configuration for displaying hybrid search results in SharePoint Online

  • Step 4: Try a hybrid search in SharePoint Online

Before you begin

Note:

Because SharePoint 2013 runs as websites in Internet Information Services (IIS), administrators and users depend on the accessibility features that browsers provide. SharePoint 2013 supports the accessibility features of supported browsers. For more information, see the following resources:

  • Plan browser support (http://go.microsoft.com/fwlink/p/?LinkId=246502)

  • Accessibility for SharePoint 2013

  • Accessibility features in SharePoint 15 Products (http://go.microsoft.com/fwlink/p/?LinkId=246501)

  • Keyboard shortcuts (http://go.microsoft.com/fwlink/p/?LinkID=246504)

  • Touch (http://go.microsoft.com/fwlink/p/?LinkId=246506)

This article assumes the following:

  • There is crawled content in the SharePoint Server 2013 and SharePoint Online search indexes.

  • You have configured the hybrid SharePoint environment as described in the following articles, and in the following order:

    1. Configure the hybrid environment infrastructure

      Note:

      In Configure the hybrid environment infrastructure, make sure that you have followed the instructions in Configure a reverse proxy device. This is necessary so that SharePoint Online can send search queries to SharePoint Server 2013 through the reverse proxy device.

    2. Configure the hybrid identity management infrastructure

Step 1: Create a result source that defines how to get search results from SharePoint Server 2013

In this procedure, you create a result source in SharePoint Online. This result source is a definition that specifies each of the following:

  • The protocol for getting search results from the SharePoint Server 2013 deployment.

  • The URL of the reverse proxy device. The reverse proxy device forwards search queries from SharePoint Online to the SharePoint Server 2013 deployment.

  • The ID of the target application that stores the reverse proxy certificate.

Result sources can be created at the SharePoint Admin Center level, the site collection level, or the site level. In this procedure, you create the result source at the SharePoint Admin Center level. This will make the result source available to any query rule that is created at the same level, and also to any query rule that is created for a site collection or site.

For more information about result sources, see the following resources:

  • Understanding result sources (http://go.microsoft.com/fwlink/p/?LinkId=294359)

  • Manage result sources (http://go.microsoft.com/fwlink/p/?LinkId=294360)

To create the result source

  1. Verify that the user account that you use to perform this procedure is a global administrator for the Office 365 subscription that you want to configure.

  2. In the SharePoint Online Admin Center, in the Quick Launch, click search.

  3. On the search administration page, click Manage Result Sources.

  4. Click New Result Source.

  5. On the page where you can create a new result source, do the following:

    1. In the Name box, type a name for the new result source — for example, Results from SharePoint Server 2013 (on-premises).

    2. (Optional) In the Description text box, type a description of the new result source.

      This description will appear as a tool tip when the pointer rests on the result source on certain configuration pages.

    3. In the Protocol section, select Remote SharePoint.

    4. In the Remote Service URL section, type the address of the reverse proxy device, such as https://hybrid.adventure-works.com.

      The reverse proxy device routes queries submitted in SharePoint Online to the SharePoint Server 2013 deployment. For more information, see Configure Forefront TMG for a hybrid environment.

    5. In the Type section, select SharePoint Search Results.

    6. In the Query Transform section, do one of the following:

      1. Keep the default query transform.

        The default transform is {searchTerms}, which is a query variable that stands for the query that the user typed, as it was changed by the most recent query transform.

      2. Type a different query transform in the text box, or click Launch Query Builder if you want to use Query Builder to help you configure a query transform.

        Note:

        You can use the query transform to narrow the search results to a specified subset — for example, a subset that is from a particular SharePoint site collection or site. However, if you are not familiar with query transforms in SharePoint 2013 or SharePoint Online, we recommend that you keep the default query transform here. For more information, see the following resources:

        • Plan to transform queries and order results in SharePoint 2013

        • Query variables in SharePoint Server 2013

    7. In the Credentials Information section, do each of the following if you are connecting to your organization's intranet through a reverse proxy:

      1. Select SSO Id.

      2. In the Reverse proxy certificate (Secure Store Id) text box, type the name of the target application — for example, TargetAppIDforSearchOrBCS — which stores the Windows certificate that will be used to authenticate to the reverse proxy device. For information about the name of the appropriate target application, see Create a target application to store the SSL certificate in Configure the hybrid environment infrastructure.

    8. Click OK to save the new result source.

Step 2: Create a query rule to turn on hybrid search results in SharePoint Online

In this procedure, you create a query rule in SharePoint Online that uses the result source that you created in the previous procedure in this article. When the query rule fires, it causes search results from content in the SharePoint Server 2013 search index to be displayed in a result block on a search results page in SharePoint Online.

Query rules can be created at the SharePoint Online Admin Center level, the site collection level, or the site level. In this procedure, you create a query rule at the SharePoint Online Admin Center level. Because you create the rule at this level, the rule can apply to any queries that users submit in this instance of SharePoint Online.

For more information about query rules, see the following resources:

  • Plan to transform queries and order results in SharePoint 2013

  • Manage query rules in SharePoint Server 2013

To create the query rule

  1. Verify that the user account that you use to perform this procedure is a global administrator for the Office 365 subscription that you want to configure.

  2. In the SharePoint Online Admin Center, in the Quick Launch, click search.

  3. On the search administration page, click Manage Query Rules.

  4. On the Manage Query Rules page, do the following:

    1. In the Select a Result Source drop-down list, select a result source for which you want this query rule to be applicable.

      For example, if you select the Local SharePoint Results result source, the rule will be applicable when a user performs a query in the Everything search vertical in the enterprise Search Center, because that vertical uses the Local SharePoint Results result source by default.

      Note:

      On the Add Query Rule page, in the Context section, you will be able to add or remove result sources for which you want the rule to be applicable.

    2. Click New Query Rule.

  5. On the Add Query Rule page, do the following:

    1. In the General Information section, in the Rule Name text box, type a name for the new query rule — for example, Show SharePoint Server 2013 results in result block.

    2. If the Context section is collapsed, click the arrow next to Context to expand it.

    3. In the Context section, do the following:

      1. Under Query is on these sources, do one of the following:

        • Select All sources if you want this query rule to be applicable for queries that users submit against any result source.

        • Select One of these sources, and then optionally click Add Source to add other result sources for which you want the query rule to be applicable.

          Note:

          When you select One of these sources, the rule will be applicable only when a query uses one of the result sources that are listed in the Context section. Therefore, make sure that the result source appears for which you want this query rule to be applicable — for example, Local SharePoint Results.

      2. (Optional) Under Query is performed from these categories, specify the topic categories (based on terms for topic categories in the term store of a Managed Metadata service application) to perform the query from.

      3. (Optional) Under Query is performed by these user segments, define user segments (based on terms that describe users in the term store of a Managed Metadata service application) to which you want the query rule to apply.

    4. In the Query Conditions section, specify conditions to control when the rule will fire, or click Remove Condition if you want the rule to fire for any query text.

      For testing, we recommend that you click Remove Condition so that the rule will fire for any query text.

    5. In the Actions section, under Result Blocks, click Add Result Block.

    6. In the add result block dialog box, do the following:

      1. (Optional) In the Block Title section, in the Title text box, change the title to the text that you would like to display above the result block, such as Results for "{subjectTerms}" from SharePoint Server 2013 (on premises).

      2. In the Query section, do the following:

        1. In the Configure Query text box, do one of the following:

          • Keep the default query, which is {subjectTerms}.

            Note:

            If you are not familiar with transforming queries in SharePoint 2013, we recommend that you keep the default query here, namely {subjectTerms}. For more information, see the following resources:

            • Plan to transform queries and order results in SharePoint 2013

            • Query variables in SharePoint Server 2013

          • Type a different query in the text box, or click Launch Query Builder if you want to use Query Builder to help you configure a query.

        2. In the Search this Source drop-down list, select the name of the result source that you created in Step 1: Create a result source that defines how to get search results from SharePoint Server 2013 — for example, Results from SharePoint Server 2013 (on-premises).

        3. In the Items drop-down list, select the number of search results from SharePoint Server 2013 that you want to show in this result block on the search results page. For example, select 3 to display three results from SharePoint Server 2013 in this result block.

      3. In the Settings section, do the following:

        1. If you want to display a Show More link at the bottom of the result block, select More link goes to the following URL, and type the URL for the link to a page that displays more results from the SharePoint Server 2013 search index.

          When end users click Show More, they will see more results for the result block.

        2. For the placement of the block of results from SharePoint Server 2013 relative to the results from SharePoint Online, do one of the following:

          • Select This block is always shown above core results to display the result block at or near the top of the first page of search results.

            In this case, core results are the results from the SharePoint Online search index. This option is useful for testing, or when most of the relevant content is located in the remote search index in the hybrid environment. If you select this option for more than one result block, you can configure the order in which the result blocks are displayed by ranking the associated query rules.

          • Select This block is ranked within core results (may not show) to display the result block such that it is ranked by relevance compared to core results, in which case the result block might not appear on the first page of search results.

            This is the default setting and is typically the more appropriate choice in a production environment. As with individual results, the rank of the result block might be different when users perform the same query later. For example, if users click search results in the result block, the result block will be ranked higher in the search results over time. Otherwise, the result block will be ranked lower over time.

        3. (Optional) In the Group Display Template URL text box, specify a different URL for the group display template.

        4. (Optional) In the Item Display Template text box, specify an item display template.

      4. Skip the Routing section.

      5. Click OK to add the result block.

    7. On the Add Query Rule page, in the Publishing section, do the following:

      1. Select Is Active. When a query rule is active, it fires whenever the query conditions are met.

      2. (Optional) Specify a Start Date, an End Date, a Review Date, and a Contact.

        The start date and end date specify when the query rule will be active. If you do not specify a start date, the rule will be active until an end date that you specify. If you specify a start date without an end date, the rule will always be active after the start date. If you specify an end date without a start date, the rule will always be active until the end date. If you do not specify a start date or an end date, the rule will always be active.

    8. Click Save.

After a few moments, when federated users submit queries from the enterprise Search Center in SharePoint Online, they will see results from both search indexes on a search results page in SharePoint Online. Also, the refinement panel on the search results page automatically merges item counts and values for all of the search results and thus provides filtering for the results from both search indexes.

Note:

A federated user is a user whose on-premises Active Directory Domain Services (AD DS) domain account is synchronized between SharePoint Server 2013 and SharePoint Online, and who accesses resources in both environments by authenticating with the federation identity provider, such as Active Directory Federation Services (AD FS) 2.0.

Step 3: Test your configuration for displaying hybrid search results in SharePoint Online

Use the following procedure to validate your configuration for viewing search results from SharePoint Server 2013 in SharePoint Online.

Important:

It is important to test single sign-on (SSO) authentication by using federated user accounts. Native Office 365 user accounts and AD accounts that are not federated are not recognized by both directory services. Therefore, they cannot authenticate using SSO, and cannot be granted permissions to resources in both environments. For more information, see Accounts for configuration and testing and Testing and troubleshooting in Configure the hybrid environment infrastructure.

To test your configuration

  1. Verify that the user account that you use to perform this procedure is a federated user who has been activated in SharePoint Online, and who has permissions to view the root site collection that is being queried in SharePoint Online.

  2. On the SharePoint Admin Center page, click search.

  3. Under search administration, click Manage Query Rules.

  4. On the page for managing query rules, do the following:

    1. In the Select a Result Source drop-down list, click the result source that you created according to Step 1 in this article (Step 1: Create a result source that defines how to get search results from SharePoint Server 2013) — for example, Results from SharePoint Server 2013 (on-premises).

    2. In the list of query rules, click the query rule that you created according to step 2 in this article (Step 2: Create a query rule to turn on hybrid search results in SharePoint Online) — for example, Show SharePoint Server 2013 results in result block.

  5. On the page for editing the query rule, in the Actions section, in the Result Blocks subsection, next to the name of the query rule that will get results from the SharePoint Server 2013 search index (for example, Results for "{subjectTerms}" from SharePoint Server 2013 On-Premises), click edit.

  6. In the edit result block dialog box, in the Query section, click Launch Query Builder.

  7. In the build your query dialog box, in the BASICS tab, do the following:

    1. In the Select a query section, select the result source that you created according to Step 1 in this article (see Step 1: Create a result source that defines how to get search results from SharePoint Server 2013) — for example, Results from SharePoint Server 2013 (on-premises).

    2. In the Query text section, delete the default text, which is {subjectTerms}, and then type a test query (such as the name of your company) that should yield search results from the SharePoint Server 2013 search index.

  8. Click Test query.

    In the Search Result Preview pane, if your search configuration is valid, the SharePoint Online search system will display search results from SharePoint Server 2013. If there are problems with your configuration, the search system will display troubleshooting information.

  9. Click OK.

Step 4: Try a hybrid search in SharePoint Online

To validate your configuration for displaying hybrid search results from SharePoint Server 2013 and SharePoint Online, you can log on to SharePoint Online as a federated end user and try some searches from the enterprise Search Center. Use the following procedure to validate your configuration in this way.

To try a hybrid search in SharePoint Online

  1. Log on to the enterprise Search Center in SharePoint Online as a federated end user who has been activated in SharePoint Online, and who has permissions to view the root site collection in SharePoint Online.

  2. Go to the enterprise Search Center in SharePoint Online.

    By default, the enterprise Search Center in SharePoint Online is at https://<domain>.sharepoint.com/search — for example, https://adventure-works.sharepoint.com/search.

  3. In the enterprise Search Center, do the following:

    1. Click a search vertical that uses a result source that you specified in step 5 of the previous procedure.

    2. In the search box, type a test query, such as the name of your company.

      Make sure that the test query should yield search results from the SharePoint Server 2013 search index and the SharePoint Online search index.

    3. Click the search icon, or press Enter.

  4. On the search results page, you should see results from the SharePoint Online search index and a result block of results from the SharePoint Server 2013 search index.

  5. If you do not see results from both search indexes on the search results page, do the following:

    1. Verify each of the following:

      • The search system in SharePoint Server 2013 has crawled the local content.

      • You have configured the hybrid SharePoint environment as described in the following two articles, and in the following order:

        1. Configure the hybrid environment infrastructure

        2. Configure the hybrid identity management infrastructure

        3. You have configured Search features and functionality as described in this article.

    2. Correct any errors or omissions and try a search again.

  6. If you still do not see search results from both search indexes, check the SharePoint Unified Logging Service (ULS) logs, also called the SharePoint trace logs.

    For more information, see Overview of Unified Logging System (ULS) Logging.

See also

Configure the hybrid environment infrastructure
Configure the hybrid identity management infrastructure
Configure Forefront TMG for a hybrid environment
Configure hybrid search for SharePoint Server 2013
Display hybrid search results in SharePoint Server 2013
Configure hybrid Duet Enterprise Online for SharePoint Server 2013
Deploy a Business Connectivity Services hybrid solution in SharePoint 2013

Hybrid for SharePoint Server 2013


Configure hybrid Duet Enterprise Online for SharePoint Server 2013
See also

Published: April 9, 2013

Summary: Roadmap to understanding and deploying Duet Enterprise Online.

Applies to: Duet Enterprise Online for Microsoft SharePoint and SAP | SharePoint Online

Warning:

To configure a hybrid SharePoint environment, you need a combination of expert skills and significant hands-on experience with SharePoint Server 2013, SharePoint Online, and related products and technologies. We recommend that you engage an SAP consultant and Microsoft Consulting Services to provide technical guidance and support during the design and deployment of your hybrid environment.

For more information about Microsoft Consulting Services, see Microsoft Services.

Duet Enterprise Online for Microsoft SharePoint and SAP is a jointly developed product from SAP and Microsoft that enables interoperability between SAP applications and SharePoint Online. Duet Enterprise Online empowers employees to consume and extend SAP processes and information from within SharePoint Online and Outlook 2013. Information that is stored in SAP applications is not moved into SharePoint. Instead, the information stays in the SAP applications and is surfaced in SharePoint Online. That is, based on an individual user's permissions, the user can view and change information stored in a SAP application from within SharePoint sites.

For an overview of Duet Enterprise Online and articles that help you plan for Duet Enterprise Online, see Plan for Duet Enterprise Online for Microsoft SharePoint and SAP.

Duet Enterprise Online is a SharePoint hybrid solution that requires a combination of SharePoint Online, an on-premises SharePoint Server 2013 farm, and SAP system. For information about how to plan to deploy this SharePoint hybrid solution, see Plan to deploy Duet Enterprise Online for Microsoft SharePoint and SAP. For guidance about how to deploy this SharePoint hybrid solution, see Install and configure Duet Enterprise Online for Microsoft SharePoint and SAP.

See also

Hybrid for SharePoint Server 2013


How to build a social media-sharing site in SharePoint 2013 (white paper)
See also

Published: February 19, 2013

Summary: Learn how to build a social media-sharing site in SharePoint 2013.

Applies to: SharePoint Server 2013

Social media for the enterprise is in high demand among many organizations. Sharing videos has revolutionized the way teams and organizations communicate with one another because it's the fastest way to convey information. This white paper addresses how to build a social media-sharing site on SharePoint 2013 by using the out-of-the-box video and web content management (WCM) feature sets. This white paper is organized into different projects, which are essentially the various steps required to build the site.

To download this white paper, click the following link: How to build a social media-sharing site in SharePoint 2013.

See also

Plan for social computing and collaboration in SharePoint Server 2013
Configure social computing features in SharePoint Server 2013
Solutions for the real world in SharePoint 2013


OBSOLETE Rename stand-alone servers in SharePoint 2013

Summary: This content is not supported and no longer available.


SharePoint products and technologies

Summary: Three versions of documentation for SharePoint products and technologies are available here on TechNet, plus documentation for other related products.

Explore these links to find out more about how to implement SharePoint 2013.

SharePoint 2013 is a collaboration environment that organizations of all sizes can use to increase the efficiency of business processes.

SharePoint 2013 sites provide secure environments that administrators can configure to provide personalized access to documents and other information. Search features enable users to find content efficiently regardless of the physical location of data.

Alert icon - exclamation point

Recently Published Content

See the following pages for new or updated content about SharePoint 2013:

  • Recently published content for SharePoint 2013

Building blocks

Documentation

The TechNet library contains articles that describe how to plan for, deploy, and use all the features of SharePoint 2013.

  • Accessibility for SharePoint 2013

  • Downloadable content for SharePoint 2013

  • Technical diagrams for SharePoint 2013

  • Video demos and training for SharePoint 2013

  • Explore SharePoint 2013

  • Plan for SharePoint 2013

  • Develop for SharePoint 2013

  • Install and configure SharePoint 2013

  • Operations for SharePoint 2013

  • Use SharePoint 2013

  • Troubleshooting SharePoint 2013

  • Technical reference for SharePoint 2013

  • Solutions for the real world in SharePoint 2013

Related content:

  • SharePoint Online administration

  • Project Server 2013

  • Office 2013 Resource Kit

  • Office Web Apps

  • Office 365 ProPlus

  • Duet Enterprise for Microsoft SharePoint and SAP

Legacy content:

  • SharePoint Server 2010

  • SharePoint Foundation 2010

  • Groove Server 2010

  • Project Server 2010

  • Office 2010 Resource Kit

  • Office Web Apps (Installed on SharePoint 2010 Products)

  • Search Server 2010

  • FAST Search Server 2010 for SharePoint

  • SharePoint Online Administration Guide in Office 365 for enterprises

  • Duet Enterprise for Microsoft SharePoint and SAP 1.0

  • Microsoft Office SharePoint Server 2007

  • Microsoft Office SharePoint Portal Server 2003

  • SharePoint 2007 products and technologies

  • PerformancePoint Server 2007

  • Forms Server 2007

  • Windows SharePoint Services 2.0

House icon

TechNet TechCenter

Visit the following site to access videos, community sites, documentation, and more.

  • Microsoft SharePoint 2013

Getting started

Getting Started

TechNet documentation includes several articles about the new features in SharePoint 2013:

  • Explore SharePoint 2013

Downloads

Downloads & Scripts

Access the following pages for both downloadable content and Windows PowerShell scripts:

  • Downloadable content for SharePoint 2013

  • Script Repository: Windows PowerShell for SharePoint 2013 Products

Chat icon

Blogs

Check out the latest posts from the SharePoint Products documentation teams.

  • To the SharePoint

  • Office 365 Technical Blog

People icon

Forums & Newsgroups

Got questions? Talk to your peers, MVPs, and the SharePoint product teams.

  • Forum: SharePoint 2013 for IT Professionals

Video (play button) icon

Videos

Watch subject matter experts and TechNet writers walk through tasks and dynamically explain SharePoint-related concepts.

  • Video demos and training for SharePoint 2013

Twitter

Stay Connected

Keep connected with the latest happenings with SharePoint 2013.

  • Follow us on Twitter

email

Provide Feedback

Provide feedback about the documentation for SharePoint 2013 depending on the TechNet view, as follows:

  • Lightweight View.Click Yes or No in the Did you find this helpful section at the bottom of the page. This delivers your feedback directly to the documentation team.

  • Classic View. Use the Click to Rate and Give Feedback link at the top of the article in the TechNet Library. This delivers your feedback directly to the documentation team.

  • Scriptfree View. Click the Feedback link at the top of the article in the TechNet Library. This enables you to provide feedback about the scriptfree view to a forum.

To suggest content or request more documentation (or report an error), please contact us at ITSPDOCS@microsoft.com.

Find training and other resources about SharePoint

Email us to suggest content Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support


social icons 2013

Test Link that uses a parameterized legacyLink element:Downloadable content for SharePoint Server 2010

Test Link that uses a parameterized Link element: Downloadable content for SharePoint Server 2010

Test Link that uses a legacyLink element without the trailing version parameter: Downloadable content for SharePoint Server 2010

Email us to suggest content Subscribe to Office 2013 news and highlights Read the Office IT Pro Blog Read Office IT pro forums Visit Office on Facebook Follow Office Resource Kit on Twitter

Email us to suggest content Subscribe to SharePoint 2013 news and highlights Read the To the SharePoint blog Read SharePoint 2010 forums Visit SharePoint on Facebook Follow @MSOffice_ITPro on Twitter

Broken link


Roadmap to SharePoint 2013 content

Content that is available for IT professionals can assist you when you plan, deploy, administer, and troubleshoot SharePoint 2013.

Applies to: SharePoint Foundation 2013 | SharePoint Server 2013

The following downloadable resources, articles on TechNet, video recordings, and related resources provide information about SharePoint 2013.

Downloadable resources about SharePoint 2013

Download the following content for general information about SharePoint 2013.

Content | Description
Technical diagrams for SharePoint 2013 | These poster-size models provide a visual representation of recommended solutions and correspond to various articles in the library. You can modify these models by using Visio 2013 to reflect your plans for SharePoint 2013 and how it will fit into your own environment.

TechNet articles about SharePoint 2013

The following articles are available to view online. Writers update articles on a continuing basis as new information becomes available and as users provide feedback.

 | Content | Description
SharePoint logo | SharePoint 2013 | The library contains current IT pro content. The SharePoint 2013 product team reviewed and approved the articles. Content evolves over the life cycle of SharePoint 2013.
 | Recently published content for SharePoint 2013 | This article contains a list of new or updated content in the TechNet library.

Videos about SharePoint 2013

The following video recordings are available to view online or to download.

 | Content | Description
Videos | Video demos and training for SharePoint 2013 | This article contains a list of SharePoint 2013 video demos intended for IT professionals.

Additional resources about SharePoint 2013

The following resources are available from other subject matter experts.

Content Description

TechNet logo

  • SharePoint Server 2013 TechCenter

    • SharePoint Server 2010 Resource Centers

    • SharePoint Server 2010 support

  • A TechCenter is the primary gateway to in-depth technical information about SharePoint 2013 Through the TechCenter, you can access the following.

    • Resource centers provide specific links to more information specific to a particular feature of SharePoint 2013. You can find resource centers for features such as installation and deployment, Business Connectivity Services, enterprise content management, and enterprise search, to name a few.

    • Locate support and troubleshooting resources for SharePoint 2013. You can search the Microsoft Knowledge Base, TechNet, or blogs for additional help.

Content on MSDN

  • SharePoint Developer Center

  • Use this developer center ti find resources for SharePoint developers.

Blogs

Microsoft SharePoint Team Blog (http://go.microsoft.com/fwlink/p/?LinkID=82560)

This is the official blog of the SharePoint product group. Members of the product team write articles, post product announcements, and add updates.

SharePoint IT Pro (http://go.microsoft.com/fwlink/p/?LinkId=188956)

This is the IT pro documentation team blog. This blog includes documentation highlights and announcements for SharePoint 2013.

Forums and newsgroups

 | Content | Description
Forums and newsgroups | SharePoint 2013 forums (http://go.microsoft.com/fwlink/p/?LinkId=188957) | The forum provides a place for users and SharePoint 2013 product team members to discuss the product.

Find training and other resources about SharePoint

Download

SharePoint Server 2013

Office ProPlus 365

SharePoint Online (Office 365)

SharePoint Server 2010

SharePoint Foundation 2010

SharePoint Designer 2010

SharePoint code samples

SharePoint scripts and sample files

SharePoint downloads

Office 365 downloads

How To

Build apps for SharePoint

Install SharePoint 2010

Maintain SharePoint 2010

Train SharePoint end users

SharePoint SDKs

SharePoint developer training

SharePoint developer videos

SharePoint IT pro training

SharePoint IT pro videos

Open specifications

SharePoint protocols

Open Specifications Interactive Pivot

Sites

SharePoint developers

SharePoint IT pros

Office developers

Office 365 developers

Office 365 IT pros

Visual Studio developers

SharePoint Online

Office 2010 Resource Kit

Office.com: SharePoint

Microsoft.com: SharePoint

Microsoft.com: Office 365

Upcoming conferences on TopSharePoint.com

Help

SharePoint updates

Apps for Office and SharePoint blog

SharePoint Developer Team blog

Forums: SharePoint 2010

Forums: Office 365

TechNet Wiki

StackExchange: SharePoint

StackOverflow: SharePoint

SharePoint MVPs

SharePoint IT pro support

SharePoint developer support


Groove Server

Groove is peer-to-peer collaborative software. Groove Server is a Windows-based software package that helps you deploy and administer Microsoft SharePoint Workspace when Groove peer workspaces are being used. Groove Enterprise Services 2007 provides access to Groove Server Manager and Relay services through a hosted environment at a Microsoft data center.

  • Groove Server 2010

  • Groove Server 2007

  • Groove Enterprise Services